(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(function () {
      return (root.cv = factory());
    });
  } else if (typeof module === 'object' && module.exports) {
    // Node. Does not work with strict CommonJS, but
    // only CommonJS-like environments that support module.exports,
    // like Node.
    module.exports = factory();
  } else {
    // Browser globals
    root.cv = factory();
  }
}(this, function () {
  var cv = function(cv) {
  cv = cv || {};
  var Module = cv;

var Module;if(!Module)Module=(typeof cv!=="undefined"?cv:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(Module["ENVIRONMENT"]){if(Module["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(Module["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(Module["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(Module["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=console.log;if(!Module["printErr"])Module["printErr"]=console.warn;var nodeFS;var nodePath;Module["read"]=function shell_read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function shell_read(){throw"no read() available"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof quit==="function"){Module["quit"]=(function(status,toThrow){quit(status)})}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function shell_read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(ENVIRONMENT_IS_WORKER){Module["readBinary"]=function readBinary(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.responseType="arraybuffer";xhr.send(null);return new Uint8Array(xhr.response)}}Module["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function shell_print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function shell_printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){eval.call(null,x)}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}if(!Module["quit"]){Module["quit"]=(function(status,toThrow){throw toThrow})}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value;return value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return Module["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=HEAP32[DYNAMICTOP_PTR>>2];var end=(ret+size+15|0)&-16;HEAP32[DYNAMICTOP_PTR>>2]=end;if(end>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){HEAP32[DYNAMICTOP_PTR>>2]=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var ABORT=0;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=Module["_"+ident];if(!func){try{func=eval("_"+ident)}catch(e){}}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){var len=(str.length<<2)+1;ret=Runtime.stackAlloc(len);stringToUTF8(str,ret,len)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};var sourceRegex=/^function\s*[a-zA-Z$_0-9]*\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSsource=null;function ensureJSsource(){if(!JSsource){JSsource={};for(var fun in JSfuncs){if(JSfuncs.hasOwnProperty(fun)){JSsource[fun]=parseJSFunc(JSfuncs[fun])}}}}cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident);var numericArgs=argTypes.every((function(type){return type==="number"}));var numericRet=returnType!=="string";if(numericRet&&numericArgs){return cfunc}var argNames=argTypes.map((function(x,i){return"$"+i}));var funcstr="(function("+argNames.join(",")+") {";var nargs=argTypes.length;if(!numericArgs){ensureJSsource();funcstr+="var stack = "+JSsource["stackSave"].body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if(type==="number")continue;var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";";funcstr+=convertCode.body+";";funcstr+=arg+"=("+convertCode.returnValue+");"}}var cfuncname=parseJSFunc((function(){return cfunc})).returnValue;funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");";if(!numericRet){var strgfy=parseJSFunc((function(){return Pointer_stringify})).returnValue;funcstr+="ret = "+strgfy+"(ret);"}if(!numericArgs){ensureJSsource();funcstr+=JSsource["stackRestore"].body.replace("()","(stack)")+";"}funcstr+="return ret})";return eval(funcstr)}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;var UTF8Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(u8Array,idx){var endPtr=idx;while(u8Array[endPtr])++endPtr;if(endPtr-idx>16&&u8Array.subarray&&UTF8Decoder){return UTF8Decoder.decode(u8Array.subarray(idx,endPtr))}else{var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;var UTF16Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf-16le"):undefined;function demangle(func){var __cxa_demangle_func=Module["___cxa_demangle"]||Module["__cxa_demangle"];if(__cxa_demangle_func){try{var s=func.substr(1);var len=lengthBytesUTF8(s)+1;var buf=_malloc(len);stringToUTF8(s,buf,len);var status=_malloc(4);var ret=__cxa_demangle_func(buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){var regex=/__Z[\w\d_]+/g;return text.replace(regex,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}Module["stackTrace"]=stackTrace;var WASM_PAGE_SIZE=65536;var ASMJS_PAGE_SIZE=16777216;var MIN_TOTAL_MEMORY=16777216;function alignUp(x,multiple){if(x%multiple>0){x+=multiple-x%multiple}return x}var HEAP,buffer,HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBuffer(buf){Module["buffer"]=buffer=buf}function updateGlobalBufferViews(){Module["HEAP8"]=HEAP8=new Int8Array(buffer);Module["HEAP16"]=HEAP16=new Int16Array(buffer);Module["HEAP32"]=HEAP32=new Int32Array(buffer);Module["HEAPU8"]=HEAPU8=new Uint8Array(buffer);Module["HEAPU16"]=HEAPU16=new Uint16Array(buffer);Module["HEAPU32"]=HEAPU32=new Uint32Array(buffer);Module["HEAPF32"]=HEAPF32=new Float32Array(buffer);Module["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE,STATICTOP,staticSealed;var STACK_BASE,STACKTOP,STACK_MAX;var DYNAMIC_BASE,DYNAMICTOP_PTR;STATIC_BASE=STATICTOP=STACK_BASE=STACKTOP=STACK_MAX=DYNAMIC_BASE=DYNAMICTOP_PTR=0;staticSealed=false;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or (4) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}if(!Module["reallocBuffer"])Module["reallocBuffer"]=(function(size){var ret;try{if(ArrayBuffer.transfer){ret=ArrayBuffer.transfer(buffer,size)}else{var oldHEAP8=HEAP8;ret=new ArrayBuffer(size);var temp=new Int8Array(ret);temp.set(oldHEAP8)}}catch(e){return false}var success=_emscripten_replace_memory(ret);if(!success)return false;return ret});function enlargeMemory(){var PAGE_MULTIPLE=Module["usingWasm"]?WASM_PAGE_SIZE:ASMJS_PAGE_SIZE;var LIMIT=2147483648-PAGE_MULTIPLE;if(HEAP32[DYNAMICTOP_PTR>>2]>LIMIT){return false}var OLD_TOTAL_MEMORY=TOTAL_MEMORY;TOTAL_MEMORY=Math.max(TOTAL_MEMORY,MIN_TOTAL_MEMORY);while(TOTAL_MEMORY<HEAP32[DYNAMICTOP_PTR>>2]){if(TOTAL_MEMORY<=536870912){TOTAL_MEMORY=alignUp(2*TOTAL_MEMORY,PAGE_MULTIPLE)}else{TOTAL_MEMORY=Math.min(alignUp((3*TOTAL_MEMORY+2147483648)/4,PAGE_MULTIPLE),LIMIT)}}var replacement=Module["reallocBuffer"](TOTAL_MEMORY);if(!replacement||replacement.byteLength!=TOTAL_MEMORY){TOTAL_MEMORY=OLD_TOTAL_MEMORY;return false}updateGlobalBuffer(replacement);updateGlobalBufferViews();return true}var byteLength;try{byteLength=Function.prototype.call.bind(Object.getOwnPropertyDescriptor(ArrayBuffer.prototype,"byteLength").get);byteLength(new ArrayBuffer(4))}catch(e){byteLength=(function(buffer){return buffer.byteLength})}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||134217728;if(TOTAL_MEMORY<TOTAL_STACK)Module.printErr("TOTAL_MEMORY should be larger than TOTAL_STACK, was "+TOTAL_MEMORY+"! (TOTAL_STACK="+TOTAL_STACK+")");if(Module["buffer"]){buffer=Module["buffer"]}else{{buffer=new ArrayBuffer(TOTAL_MEMORY)}}updateGlobalBufferViews();function getTotalMemory(){return TOTAL_MEMORY}HEAP32[0]=1668509029;HEAP16[1]=25459;if(HEAPU8[2]!==115||HEAPU8[3]!==99)throw"Runtime error: expected the system to be little-endian!";Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Module["dynCall_v"](func)}else{Module["dynCall_vi"](func,callback.arg)}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){Runtime.warnOnce("writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!");var lastChar,end;if(dontAddNull){end=buffer+lengthBytesUTF8(string);lastChar=HEAP8[end]}stringToUTF8(string,buffer,Infinity);if(dontAddNull)HEAP8[end]=lastChar}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_round=Math.round;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var ASM_CONSTS=[];STATIC_BASE=Runtime.GLOBAL_BASE;STATICTOP=STATIC_BASE+1154752;__ATINIT__.push({func:(function(){__GLOBAL__I_000101()})},{func:(function(){__GLOBAL__sub_I_opencv_caffe_pb_cc()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})},{func:(function(){__GLOBAL__sub_I_bind_cpp()})},{func:(function(){__GLOBAL__sub_I_message_cc()})},{func:(function(){__GLOBAL__sub_I_descriptor_pb_cc()})},{func:(function(){__GLOBAL__sub_I_status_cc()})},{func:(function(){__GLOBAL__sub_I_hog_cpp()})},{func:(function(){__GLOBAL__sub_I_haar_cpp()})},{func:(function(){__GLOBAL__sub_I_op_def_pb_cc()})},{func:(function(){__GLOBAL__sub_I_function_pb_cc()})},{func:(function(){__GLOBAL__sub_I_darknet_io_cpp()})},{func:(function(){__GLOBAL__sub_I_prior_box_layer_cpp()})},{func:(function(){__GLOBAL__sub_I_detection_output_layer_cpp()})},{func:(function(){__GLOBAL__sub_I_init_cpp()})},{func:(function(){__GLOBAL__sub_I_opencv_onnx_pb_cc()})},{func:(function(){__GLOBAL__sub_I_bindings_cpp()})},{func:(function(){__GLOBAL__sub_I_types_pb_cc()})},{func:(function(){__GLOBAL__sub_I_tensor_pb_cc()})},{func:(function(){__GLOBAL__sub_I_versions_pb_cc()})},{func:(function(){__GLOBAL__sub_I_tensor_shape_pb_cc()})},{func:(function(){__GLOBAL__sub_I_graph_pb_cc()})},{func:(function(){__GLOBAL__sub_I_attr_value_pb_cc()})},{func:(function(){__GLOBAL__sub_I_dnn_cpp()})},{func:(function(){__GLOBAL__sub_I_color_lab_cpp()})},{func:(function(){__GLOBAL__sub_I_imgwarp_cpp()})},{func:(function(){__GLOBAL__sub_I_histogram_cpp()})},{func:(function(){__GLOBAL__sub_I_system_cpp()})},{func:(function(){__GLOBAL__sub_I_persistence_types_cpp()})},{func:(function(){__GLOBAL__sub_I_kmeans_cpp()})},{func:(function(){__GLOBAL__sub_I_umatrix_cpp()})});allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,192,11,177,162,10,240,111,63,32,224,31,224,31,224,239,63,136,103,16,107,42,224,127,63,240,7,252,1,127,192,239,63,118,10,129,95,71,220,135,63,18,250,1,170,28,161,239,63,227,3,252,176,168,192,143,63,32,248,129,31,248,129,239,63,116,165,70,67,164,206,147,63,181,219,160,172,16,99,239,63,26,177,213,7,27,185,151,63,113,66,74,158,101,68,239,63,151,145,175,39,192,159,155,63,181,10,35,68,246,37,239,63,0,51,120,14,155,130,159,63,8,31,124,240,193,7,239,63,127,217,35,137,217,176,161,63,2,142,69,248,199,233,238,63,95,189,254,185,135,158,163,63,192,236,1,179,7,204,238,63,212,228,200,175,91,138,165,63,235,1,186,122,128,174,238,63,252,220,50,246,88,116,167,63,103,183,240,171,49,145,238,63,235,227,200,14,131,92,169,63,228,80,151,165,26,116,238,63,190,113,25,113,221,66,171,63,116,229,1,201,58,87,238,63,82,11,219,138,107,39,173,63,115,26,220,121,145,58,238,63,166,98,17,192,48,10,175,63,30,30,30,30,30,30,238,63,113,228,152,53,152,117,176,63,30,224,1,30,224,1,238,63,224,122,163,238,54,101,177,63,138,134,248,227,214,229,237,63,22,20,10,47,246,83,178,63,202,29,160,220,1,202,237,63,208,209,27,150,215,65,179,63,219,129,185,118,96,174,237,63,240,70,166,190,220,46,180,63,138,127,30,35,242,146,237,63,63,24,6,63,7,27,181,63,52,44,184,84,182,119,237,63,195,80,55,169,88,6,182,63,178,114,117,128,172,92,237,63,75,107,229,138,210,240,182,63,29,212,65,29,212,65,237,63,204,18,123,109,118,218,183,63,26,91,252,163,44,39,237,63,32,155,49,214,69,195,184,63,116,192,110,143,181,12,237,63,172,51,32,70,66,171,185,63,198,191,68,92,110,242,236,63,99,213,74,58,109,146,186,63,11,155,3,137,86,216,236,63,161,237,176,43,200,120,187,63,231,203,1,150,109,190,236,63,67,199,91,143,84,94,188,63,145,225,94,5,179,164,236,63,93,179,108,214,19,67,189,63,66,138,251,90,38,139,236,63,229,242,42,110,7,39,190,63,28,199,113,28,199,113,236,63,166,98,17,192,48,10,191,63,134,73,13,209,148,88,236,63,186,234,219,49,145,236,191,63,240,248,195,1,143,63,236,63,110,89,202,18,21,103,192,63,28,160,46,57,181,38,236,63,89,142,208,124,126,215,192,63,224,192,129,3,7,14,236,63,172,66,103,132,133,71,193,63,139,141,134,238,131,245,235,63,160,103,47,213,42,183,193,63,247,6,148,137,43,221,235,63,203,90,10,25,111,38,194,63,123,62,136,101,253,196,235,63,35,245,31,248,82,149,194,63,208,186,193,20,249,172,235,63,210,127,228,24,215,3,195,63,35,255,24,43,30,149,235,63,116,143,30,32,252,113,195,63,139,51,218,61,108,125,235,63,41,198,236,176,194,223,195,63,5,238,190,227,226,101,235,63,30,125,203,108,43,77,196,63,79,27,232,180,129,78,235,63,229,85,154,243,54,186,196,63,206,6,216,74,72,55,235,63,55,180,161,227,229,38,197,63,217,128,108,64,54,32,235,63,133,32,152,217,56,147,197,63,164,34,217,49,75,9,235,63,211,147,167,112,48,255,197,63,40,175,161,188,134,242,234,63,80,173,114,66,205,106,198,63,94,144,148,127,232,219,234,63,28,210,25,231,15,214,198,63,27,112,197,26,112,197,234,63,164,55,64,245,248,64,199,63,253,235,135,47,29,175,234,63,9,217,16,2,137,171,199,63,190,99,106,96,239,152,234,63,234,87,67,161,192,21,200,63,89,225,48,81,230,130,234,63,16,201,32,101,160,127,200,63,109,26,208,166,1,109,234,63,64,109,136,222,40,233,200,63,74,138,104,7,65,87,234,63,180,86,244,156,90,82,201,63,26,164,65,26,164,65,234,63,131,251,125,46,54,187,201,63,160,28,197,135,42,44,234,63,99,181,226,31,188,35,202,63,2,75,122,249,211,22,234,63,24,47,136,252,236,139,202,63,26,160,1,26,160,1,234,63,242,191,128,78,201,243,202,63,217,51,16,149,142,236,233,63,164,181,143,158,81,91,203,63,45,104,107,23,159,215,233,63,214,140,45,116,134,194,203,63,2,161,228,78,209,194,233,63,192,24,140,85,104,41,204,63,218,16,85,234,36,174,233,63,33,154,154,199,247,143,204,63,154,153,153,153,153,153,233,63,220,197,9,78,53,246,204,63,255,192,142,13,47,133,233,63,145,187,79,107,33,92,205,63,114,184,12,248,228,112,233,63,125,236,171,160,188,193,205,63,174,119,227,11,187,92,233,63,229,242,42,110,7,39,206,63,224,233,214,252,176,72,233,63,95,90,170,82,2,140,206,63,230,44,155,127,198,52,233,63,54,89,220,203,173,240,206,63,41,226,208,73,251,32,233,63,55,123,75,86,10,85,207,63,213,144,1,18,79,13,233,63,42,62,94,109,24,185,207,63,250,24,156,143,193,249,232,63,28,80,173,69,108,14,208,63,63,55,241,122,82,230,232,63,64,208,180,148,37,64,208,63,211,24,48,141,1,211,232,63,13,89,205,95,184,113,208,63,58,255,98,128,206,191,232,63,227,144,115,226,36,163,208,63,170,243,107,15,185,172,232,63,75,183,154,87,107,212,208,63,156,137,1,246,192,153,232,63,213,74,174,249,139,5,209,63,74,176,171,240,229,134,232,63,176,168,147,2,135,54,209,63,185,146,192,188,39,116,232,63,14,166,171,171,92,103,209,63,24,134,97,24,134,97,232,63,111,35,212,45,13,152,209,63,20,6,120,194,0,79,232,63,250,153,105,193,152,200,209,63,221,190,178,122,151,60,232,63,242,162,72,158,255,248,209,63,160,164,130,1,74,42,232,63,101,121,207,251,65,41,210,63,24,24,24,24,24,24,232,63,57,118,223,16,96,89,210,63,6,24,96,128,1,6,232,63,163,134,222,19,90,137,210,63,64,127,1,253,5,244,231,63,36,157,184,58,48,185,210,63,29,79,90,81,37,226,231,63,48,29,225,186,226,232,210,63,244,5,125,65,95,208,231,63,132,65,84,201,113,24,211,63,124,1,46,146,179,190,231,63,84,125,152,154,221,71,211,63,195,236,224,8,34,173,231,63,90,216,191,98,38,119,211,63,139,57,182,107,170,155,231,63,233,69,105,85,76,166,211,63,200,164,120,129,76,138,231,63,15,247,193,165,79,213,211,63,13,198,154,17,8,121,231,63,227,167,134,134,48,4,212,63,177,169,52,228,220,103,231,63,19,232,4,42,239,50,212,63,109,117,1,194,202,86,231,63,194,94,28,194,139,97,212,63,70,23,93,116,209,69,231,63,208,9,64,128,6,144,212,63,141,254,65,197,240,52,231,63,160,120,119,149,95,190,212,63,188,222,70,127,40,36,231,63,105,2,96,50,151,236,212,63,9,124,156,109,120,19,231,63,45,248,45,135,173,26,213,63,112,129,11,92,224,2,231,63,98,210,173,195,162,72,213,63,23,96,242,22,96,242,230,63,108,90,69,23,119,118,213,63,199,55,67,107,247,225,230,63,225,207,244,176,42,164,213,63,97,200,129,38,166,209,230,63,202,9,88,191,189,209,213,63,23,108,193,22,108,193,230,63,211,147,167,112,48,255,213,63,61,26,163,10,73,177,230,63,149,199,185,242,130,44,214,63,144,114,83,209,60,161,230,63,242,225,3,115,181,89,214,63,192,208,136,58,71,145,230,63,174,20,155,30,200,134,214,63,23,104,129,22,104,129,230,63,61,148,53,34,187,179,214,63,26,103,1,54,159,113,230,63,227,161,43,170,142,224,214,63,249,34,81,106,236,97,230,63,53,146,120,226,66,13,215,63,163,74,59,133,79,82,230,63,6,208,187,246,215,57,215,63,100,33,11,89,200,66,230,63,206,219,57,18,78,102,215,63,222,192,138,184,86,51,230,63,162,71,221,95,165,146,215,63,64,98,1,119,250,35,230,63,191,175,55,10,222,190,215,63,148,174,49,104,179,20,230,63,195,175,130,59,248,234,215,63,6,22,88,96,129,5,230,63,149,212,160,29,244,22,216,63,252,45,41,52,100,246,229,63,23,139,30,218,209,66,216,63,231,21,208,184,91,231,229,63,160,11,51,154,145,110,216,63,165,226,236,195,103,216,229,63,90,66,193,134,51,154,216,63,87,16,147,43,136,201,229,63,138,180,88,200,183,197,216,63,145,250,71,198,188,186,229,63,199,98,54,135,30,241,216,63,192,90,1,107,5,172,229,63,61,168,69,235,103,28,217,63,170,204,35,241,97,157,229,63,250,22,33,28,148,71,217,63,237,88,129,48,210,142,229,63,88,81,19,65,163,114,217,63,96,5,88,1,86,128,229,63,138,224,23,129,149,157,217,63,58,107,80,60,237,113,229,63,98,8,220,2,107,200,217,63,226,82,124,186,151,99,229,63,75,152,191,236,35,243,217,63,85,85,85,85,85,85,229,63,149,185,213,100,192,29,218,63,254,130,187,230,37,71,229,63,10,187,229,144,64,72,218,63,235,15,244,72,9,57,229,63,234,217,107,150,164,114,218,63,75,5,168,86,255,42,229,63,73,8,154,154,236,156,218,63,21,248,226,234,7,29,229,63,228,176,88,194,24,199,218,63,197,196,17,225,34,15,229,63,107,120,71,50,41,241,218,63,21,80,1,21,80,1,229,63,91,252,189,14,30,27,219,63,155,76,221,98,143,243,228,63,98,143,204,123,247,68,219,63,57,5,47,167,224,229,228,63,93,243,60,157,181,110,219,63,76,44,220,190,67,216,228,63,251,16,147,150,88,152,219,63,110,175,37,135,184,202,228,63,10,173,13,139,224,193,219,63,225,143,166,221,62,189,228,63,123,27,167,157,77,235,219,63,91,191,82,160,214,175,228,63,38,240,21,241,159,20,220,63,74,1,118,173,127,162,228,63,77,173,205,167,215,61,220,63,103,208,178,227,57,149,228,63,247,111,255,227,244,102,220,63,128,72,1,34,5,136,228,63,33,154,154,199,247,143,220,63,123,20,174,71,225,122,228,63,201,122,77,116,224,184,220,63,102,96,89,52,206,109,228,63,235,243,133,11,175,225,220,63,154,207,245,199,203,96,228,63,100,30,114,174,99,10,221,63,202,118,199,226,217,83,228,63,213,235,0,126,254,50,221,63,251,217,98,101,248,70,228,63,131,198,226,154,127,91,221,63,77,238,171,48,39,58,228,63,62,47,138,37,231,131,221,63,135,31,213,37,102,45,228,63,84,89,44,62,53,172,221,63,81,89,94,38,181,32,228,63,160,196,193,4,106,212,221,63,20,20,20,20,20,20,228,63,181,213,6,153,133,252,221,63,102,101,14,209,130,7,228,63,38,108,124,26,136,36,222,63,251,19,176,63,1,251,227,63,4,119,104,168,113,76,222,63,7,175,165,66,143,238,227,63,135,135,214,97,66,116,222,63,2,169,228,188,44,226,227,63,245,97,152,101,250,155,222,63,198,117,170,145,217,213,227,63,192,140,70,210,153,195,222,63,231,171,123,164,149,201,227,63,244,221,64,198,32,235,222,63,85,41,35,217,96,189,227,63,236,6,175,95,143,18,223,63,20,59,177,19,59,177,227,63,91,30,129,188,229,57,223,63,34,200,122,56,36,165,227,63,172,40,112,250,35,97,223,63,99,127,24,44,28,153,227,63,194,158,254,54,74,136,223,63,142,8,102,211,34,141,227,63,30,243,120,143,88,175,223,63,20,56,129,19,56,129,227,63,113,21,246,32,79,214,223,63,238,69,201,209,91,117,227,63,152,244,87,8,46,253,223,63,72,7,222,243,141,105,227,63,138,255,37,177,250,17,224,63,248,42,159,95,206,93,227,63,254,208,165,165,82,37,224,63,193,120,43,251,28,82,227,63,59,99,206,239,158,56,224,63,70,19,224,172,121,70,227,63,210,38,169,157,223,75,224,63,178,188,87,91,228,58,227,63,156,69,38,189,20,95,224,63,250,29,106,237,92,47,227,63,64,223,28,92,62,114,224,63,191,16,43,74,227,35,227,63,14,69,75,136,92,133,224,63,182,235,233,88,119,24,227,63,32,53,87,79,111,152,224,63,144,209,48,1,25,13,227,63,209,20,206,190,118,171,224,63,96,2,196,42,200,1,227,63,130,42,37,228,114,190,224,63,104,47,161,189,132,246,226,63,183,214,185,204,99,209,224,63,75,209,254,161,78,235,226,63,139,204,209,133,73,228,224,63,151,128,75,192,37,224,226,63,125,73,155,28,36,247,224,63,160,80,45,1,10,213,226,63,150,76,45,158,243,9,225,63,160,44,129,77,251,201,226,63,248,204,135,23,184,28,225,63,17,55,90,142,249,190,226,63,188,239,147,149,113,47,225,63,64,43,1,173,4,180,226,63,68,61,36,37,32,66,225,63,5,193,243,146,28,169,226,63,233,213,244,210,195,84,225,63,158,18,228,41,65,158,226,63,14,166,171,171,92,103,225,63,165,4,184,91,114,147,226,63,160,153,216,187,234,121,225,63,19,176,136,18,176,136,226,63,6,207,245,15,110,140,225,63,77,206,161,56,250,125,226,63,110,201,103,180,230,158,225,63,53,39,129,184,80,115,226,63,158,162,125,181,84,177,225,63,39,1,214,124,179,104,226,63,36,60,113,31,184,195,225,63,241,146,128,112,34,94,226,63,3,112,103,254,16,214,225,63,178,119,145,126,157,83,226,63,208,64,112,94,95,232,225,63,146,36,73,146,36,73,226,63,76,9,135,75,163,250,225,63,91,96,23,151,183,62,226,63,109,171,146,209,220,12,226,63,223,188,154,120,86,52,226,63,235,190,101,252,11,31,226,63,42,18,160,34,1,42,226,63,66,191,190,215,48,49,226,63,120,251,33,129,183,31,226,63,51,57,72,111,75,67,226,63,230,85,72,128,121,21,226,63,203,247,152,206,91,85,226,63,217,192,103,12,71,11,226,63,223,48,52,1,98,103,226,63,18,32,1,18,32,1,226,63,26,177,137,18,94,121,226,63,112,31,193,125,4,247,225,63,130,7,246,13,80,139,226,63,76,184,127,60,244,236,225,63,138,176,194,254,55,157,226,63,116,184,63,59,239,226,225,63,173,64,38,240,21,175,226,63,189,74,46,103,245,216,225,63,139,142,68,237,233,192,226,63,29,129,162,173,6,207,225,63,157,220,46,1,180,210,226,63,89,224,28,252,34,197,225,63,104,2,228,54,116,228,226,63,41,237,70,64,74,187,225,63,70,149,80,153,42,246,226,63,227,186,242,103,124,177,225,63,190,16,79,51,215,7,227,63,150,123,26,97,185,167,225,63,106,254,167,15,122,25,227,63,158,17,224,25,1,158,225,63,113,29,18,57,19,43,227,63,156,162,140,128,83,148,225,63,148,137,50,186,162,60,227,63,219,43,144,131,176,138,225,63,211,225,156,157,40,78,227,63,18,24,129,17,24,129,225,63,160,110,211,237,164,95,227,63,132,214,27,25,138,119,225,63,181,71,71,181,23,113,227,63,121,115,66,137,6,110,225,63,126,121,88,254,128,130,227,63,1,50,252,80,141,100,225,63,25,42,86,211,224,147,227,63,13,39,117,95,30,91,225,63,249,189,126,62,55,165,227,63,201,213,253,163,185,81,225,63,34,252,255,73,132,182,227,63,59,205,10,14,95,72,225,63,5,50,247,255,199,199,227,63,36,71,52,141,14,63,225,63,250,86,113,106,2,217,227,63,17,200,53,17,200,53,225,63,91,47,107,147,51,234,227,63,172,192,237,137,139,44,225,63,66,111,209,132,91,251,227,63,51,48,93,231,88,35,225,63,233,220,128,72,122,12,228,63,38,72,167,25,48,26,225,63,174,114,70,232,143,29,228,63,17,17,17,17,17,17,225,63,191,128,223,109,156,46,228,63,128,16,1,190,251,7,225,63,103,206,249,226,159,63,228,63,17,240,254,16,240,254,224,63,10,187,51,81,154,80,228,63,162,37,179,250,237,245,224,63,194,94,28,194,139,97,228,63,144,156,230,107,245,236,224,63,173,170,51,63,116,114,228,63,17,96,130,85,6,228,224,63,223,136,234,209,83,131,228,63,150,70,143,168,32,219,224,63,7,252,162,131,42,148,228,63,58,158,53,86,68,210,224,63,187,62,176,93,248,164,228,63,59,218,188,79,113,201,224,63,115,226,86,105,189,181,228,63,113,65,139,134,167,192,224,63,57,238,204,175,121,198,228,63,200,157,37,236,230,183,224,63,0,253,57,58,45,215,228,63,181,236,46,114,47,175,224,63,176,91,183,17,216,231,228,63,167,16,104,10,129,166,224,63,232,38,80,63,122,248,228,63,96,131,175,166,219,157,224,63,107,104,1,204,19,9,229,63,84,9,1,57,63,149,224,63,70,52,186,192,164,25,229,63,226,101,117,179,171,140,224,63,170,197,91,38,45,42,229,63,132,16,66,8,33,132,224,63,124,155,185,5,173,58,229,63,226,234,184,41,159,123,224,63,151,148,153,103,36,75,229,63,198,247,71,10,38,115,224,63,205,11,180,84,147,91,229,63,251,18,121,156,181,106,224,63,153,243,179,213,249,107,229,63,252,169,241,210,77,98,224,63,144,241,54,243,87,124,229,63,134,117,114,160,238,89,224,63,137,121,205,181,173,140,229,63,4,52,215,247,151,81,224,63,125,232,250,37,251,156,229,63,197,100,22,204,73,73,224,63,44,159,53,76,64,173,229,63,16,4,65,16,4,65,224,63,115,28,231,48,125,189,229,63,252,71,130,183,198,56,224,63,100,23,108,220,177,205,229,63,26,94,31,181,145,48,224,63,35,153,20,87,222,221,229,63,233,41,119,252,100,40,224,63,117,22,36,169,2,238,229,63,8,4,2,129,64,32,224,63,24,137,209,218,30,254,229,63,55,122,81,54,36,24,224,63,216,136,71,244,50,14,230,63,16,16,16,16,16,16,224,63,239,57,250,254,66,46,230,63,0,0,0,0,0,0,224,63,4,0,0,0,0,0,0,0,32,87,0,0,61,0,0,0,62,0,0,0,252,255,255,255,252,255,255,255,32,87,0,0,63,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,88,212,2,0,22,33,3,0,88,212,2,0,38,33,3,0,88,212,2,0,57,33,3,0,88,212,2,0,166,33,3,0,48,213,2,0,122,33,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,86,33,3,0,0,0,0,0,1,0,0,0,96,16,0,0,0,0,0,0,20,213,2,0,203,33,3,0,0,0,0,0,120,16,0,0,20,213,2,0,240,33,3,0,1,0,0,0,120,16,0,0,88,212,2,0,45,34,3,0,48,213,2,0,111,34,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,75,34,3,0,0,0,0,0,1,0,0,0,184,16,0,0,0,0,0,0,20,213,2,0,155,34,3,0,0,0,0,0,208,16,0,0,20,213,2,0,192,34,3,0,1,0,0,0,208,16,0,0,48,213,2,0,27,35,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,247,34,3,0,0,0,0,0,1,0,0,0,8,17,0,0,0,0,0,0,20,213,2,0,71,35,3,0,0,0,0,0,32,17,0,0,20,213,2,0,108,35,3,0,1,0,0,0,32,17,0,0,48,213,2,0,215,35,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,163,35,3,0,0,0,0,0,1,0,0,0,88,17,0,0,0,0,0,0,20,213,2,0,19,36,3,0,0,0,0,0,112,17,0,0,20,213,2,0,72,36,3,0,1,0,0,0,112,17,0,0,88,212,2,0,126,36,3,0,48,213,2,0,188,36,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,142,36,3,0,0,0,0,0,1,0,0,0,176,17,0,0,0,0,0,0,20,213,2,0,242,36,3,0,0,0,0,0,200,17,0,0,20,213,2,0,33,37,3,0,1,0,0,0,200,17,0,0,88,212,2,0,81,37,3,0,48,213,2,0,142,37,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,91,37,3,0,0,0,0,0,1,0,0,0,8,18,0,0,0,0,0,0,20,213,2,0,201,37,3,0,0,0,0,0,32,18,0,0,20,213,2,0,253,37,3,0,1,0,0,0,32,18,0,0,48,213,2,0,101,38,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,50,38,3,0,0,0,0,0,1,0,0,0,88,18,0,0,0,0,0,0,20,213,2,0,160,38,3,0,0,0,0,0,112,18,0,0,20,213,2,0,212,38,3,0,1,0,0,0,112,18,0,0,88,212,2,0,9,39,3,0,20,213,2,0,24,39,3,0,0,0,0,0,0,18,0,0,20,213,2,0,35,39,3,0,1,0,0,0,0,18,0,0,88,212,2,0,47,39,3,0,88,212,2,0,96,39,3,0,128,212,2,0,79,39,3,0,216,18,0,0,0,0,0,0,128,212,2,0,62,39,3,0,224,18,0,0,0,0,0,0,88,212,2,0,133,39,3,0,88,212,2,0,164,39,3,0,88,212,2,0,195,39,3,0,88,212,2,0,226,39,3,0,88,212,2,0,1,40,3,0,88,212,2,0,32,40,3,0,88,212,2,0,63,40,3,0,88,212,2,0,116,40,3,0,88,212,2,0,164,40,3,0,88,212,2,0,188,40,3,0,88,212,2,0,207,40,3,0,88,212,2,0,222,40,3,0,88,212,2,0,250,40,3,0,88,212,2,0,19,41,3,0,88,212,2,0,96,41,3,0,48,213,2,0,33,41,3,0,0,0,0,0,1,0,0,0,112,19,0,0,0,0,0,0,88,212,2,0,141,41,3,0,88,212,2,0,154,41,3,0,88,212,2,0,70,44,3,0,20,213,2,0,109,44,3,0,0,0,0,0,96,78,0,0,20,213,2,0,131,44,3,0,1,0,0,0,96,78,0,0,128,212,2,0,205,44,3,0,48,27,0,0,0,0,0,0,20,213,2,0,233,44,3,0,0,0,0,0,200,19,0,0,20,213,2,0,6,45,3,0,1,0,0,0,200,19,0,0,128,212,2,0,36,45,3,0,200,19,0,0,0,0,0,0,20,213,2,0,68,45,3,0,0,0,0,0,248,19,0,0,20,213,2,0,101,45,3,0,1,0,0,0,248,19,0,0,88,212,2,0,135,45,3,0,128,212,2,0,177,45,3,0,48,27,0,0,0,0,0,0,20,213,2,0,189,45,3,0,0,0,0,0,48,20,0,0,20,213,2,0,202,45,3,0,1,0,0,0,48,20,0,0,88,212,2,0,216,45,3,0,20,213,2,0,247,45,3,0,0,0,0,0,128,76,0,0,20,213,2,0,8,46,3,0,1,0,0,0,128,76,0,0,88,212,2,0,26,46,3,0,20,213,2,0,52,46,3,0,0,0,0,0,64,76,0,0,20,213,2,0,64,46,3,0,1,0,0,0,64,76,0,0,88,212,2,0,77,46,3,0,20,213,2,0,122,46,3,0,0,0,0,0,48,27,0,0,20,213,2,0,139,46,3,0,1,0,0,0,48,27,0,0,20,213,2,0,157,46,3,0,0,0,0,0,48,75,0,0,20,213,2,0,174,46,3,0,1,0,0,0,48,75,0,0,48,213,2,0,4,47,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,192,46,3,0,0,0,0,0,1,0,0,0,248,20,0,0,0,0,0,0,20,213,2,0,86,47,3,0,0,0,0,0,0,75,0,0,20,213,2,0,107,47,3,0,1,0,0,0,0,75,0,0,88,212,2,0,129,47,3,0,20,213,2,0,193,47,3,0,0,0,0,0,112,76,0,0,20,213,2,0,219,47,3,0,1,0,0,0,112,76,0,0,48,213,2,0,56,48,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,246,47,3,0,0,0,0,0,1,0,0,0,112,21,0,0,0,0,0,0,88,212,2,0,187,48,3,0,48,213,2,0,15,49,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,222,48,3,0,0,0,0,0,1,0,0,0,168,21,0,0,0,0,0,0,20,213,2,0,72,49,3,0,0,0,0,0,160,19,0,0,20,213,2,0,112,49,3,0,1,0,0,0,160,19,0,0,20,213,2,0,153,49,3,0,0,0,0,0,208,76,0,0,20,213,2,0,165,49,3,0,1,0,0,0,208,76,0,0,88,212,2,0,178,49,3,0,48,213,2,0,69,50,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,48,213,2,0,0,50,3,0,0,0,0,0,1,0,0,0,32,22,0,0,0,0,0,0,20,213,2,0,152,50,3,0,0,0,0,0,160,76,0,0,20,213,2,0,181,50,3,0,1,0,0,0,160,76,0,0,88,212,2,0,211,50,3,0,88,212,2,0,249,50,3,0,20,213,2,0,18,51,3,0,0,0,0,0,120,22,0,0,20,213,2,0,44,51,3,0,1,0,0,0,120,22,0,0,20,213,2,0,151,51,3,0,0,0,0,0,64,75,0,0,20,213,2,0,179,51,3,0,1,0,0,0,64,75,0,0,88,212,2,0,208,51,3,0,20,213,2,0,245,51,3,0,0,0,0,0,160,74,0,0,20,213,2,0,2,52,3,0,1,0,0,0,160,74,0,0,88,212,2,0,16,52,3,0,20,213,2,0,72,52,3,0,0,0,0,0,208,74,0,0,20,213,2,0,83,52,3,0,1,0,0,0,208,74,0,0,88,212,2,0,95,52,3,0,20,213,2,0,183,52,3,0,0,0,0,0,128,75,0,0,20,213,2,0,196,52,3,0,1,0,0,0,128,75,0,0,88,212,2,0,210,52,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,192,0,0,0,0,0,0,224,193,0,0,0,224,255,255,239,199,255,255,255,255,255,255,239,255,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,224,255,239,64,0,0,0,0,192,255,223,64,0,0,192,255,255,255,223,65,0,0,0,224,255,255,239,71,255,255,255,255,255,255,239,127,0,0,0,0,0,0,0,0,128,212,2,0,133,58,3,0,208,23,0,0,0,0,0,0,88,212,2,0,208,58,3,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,205,59,127,102,158,160,230,63,204,59,127,102,158,160,230,63,70,141,50,207,107,144,237,63,99,169,174,166,226,125,216,63,176,92,247,207,151,98,239,63,10,166,105,60,184,248,200,63,38,37,209,163,141,216,239,63,44,180,41,188,166,23,185,63,126,109,121,227,33,246,239,63,21,216,13,241,101,31,169,63,13,205,132,96,136,253,239,63,127,102,163,247,85,33,153,63,219,146,155,22,98,255,239,63,135,199,222,252,209,33,137,63,146,138,142,133,216,255,239,63,118,0,103,254,240,33,121,63,2,29,98,33,246,255,239,63,195,164,204,190,248,33,105,63,230,110,88,136,253,255,239,63,66,71,230,174,250,33,89,63,52,26,22,98,255,255,239,63,55,179,236,42,251,33,73,63,117,134,133,216,255,255,239,63,248,78,238,73,251,33,57,63,156,97,33,246,255,255,239,63,2,181,174,81,251,33,41,63,103,88,136,253,255,255,239,63,245,207,158,83,251,33,25,63,26,22,98,255,255,255,239,63,106,215,26,84,251,33,9,63,134,133,216,255,255,255,239,63,72,217,57,84,251,33,249,62,98,33,246,255,255,255,239,63,78,152,65,84,251,33,233,62,88,136,253,255,255,255,239,63,136,124,67,84,251,33,217,62,22,98,255,255,255,255,239,63,196,216,67,84,251,33,201,62,134,216,255,255,255,255,239,63,0,53,68,84,251,33,185,62,33,246,255,255,255,255,239,63,136,124,67,84,251,33,169,62,136,253,255,255,255,255,239,63,136,124,67,84,251,33,153,62,98,255,255,255,255,255,239,63,103,94,70,84,251,33,137,62,217,255,255,255,255,255,239,63,169,154,64,84,251,33,121,62,246,255,255,255,255,255,239,63,36,34,76,84,251,33,105,62,254,255,255,255,255,255,239,63,36,34,76,84,251,33,89,62,255,255,255,255,255,255,239,63,58,4,30,84,251,33,73,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,57,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,41,62,128,212,2,0,74,60,3,0,232,25,0,0,0,0,0,0,88,212,2,0,97,60,3,0,128,212,2,0,113,60,3,0,232,25,0,0,0,0,0,0,128,212,2,0,72,61,3,0,208,23,0,0,0,0,0,0,128,212,2,0,142,61,3,0,32,26,0,0,0,0,0,0,88,212,2,0,160,61,3,0,128,212,2,0,176,61,3,0,32,26,0,0,0,0,0,0,48,213,2,0,99,75,3,0,0,0,0,0,1,0,0,0,112,30,0,0,0,0,0,0,88,212,2,0,25,81,3,0,128,212,2,0,169,79,3,0,104,26,0,0,0,0,0,0,88,212,2,0,202,79,3,0,128,212,2,0,76,80,3,0,80,26,0,0,0,0,0,0,88,212,2,0,166,88,3,0,128,212,2,0,61,88,3,0,128,26,0,0,0,0,0,0,128,212,2,0,164,87,3,0,128,26,0,0,0,0,0,0,128,212,2,0,39,88,3,0,128,26,0,0,0,0,0,0,128,212,2,0,81,88,3,0,128,26,0,0,0,0,0,0,128,212,2,0,133,88,3,0,128,26,0,0,0,0,0,0,128,212,2,0,117,88,3,0,128,26,0,0,0,0,0,0,128,212,2,0,152,88,3,0,128,26,0,0,0,0,0,0,128,212,2,0,178,88,3,0,128,26,0,0,0,0,0,0,128,212,2,0,226,88,3,0,128,26,0,0,0,0,0,0,88,212,2,0,149,94,3,0,128,212,2,0,80,94,3,0,208,23,0,0,0,0,0,0,88,212,2,0,109,108,3,0,64,0,0,0,0,0,0,0,240,86,0,0,45,0,0,0,46,0,0,0,192,255,255,255,192,255,255,255,240,86,0,0,47,0,0,0,48,0,0,0,64,0,0,0,0,0,0,0,80,87,0,0,51,0,0,0,52,0,0,0,56,0,0,0,248,255,255,255,80,87,0,0,53,0,0,0,54,0,0,0,192,255,255,255,192,255,255,255,80,87,0,0,55,0,0,0,56,0,0,0,0,0,0,0,128,212,2,0,216,127,3,0,224,86,0,0,0,0,0,0,128,212,2,0,26,128,3,0,80,87,0,0,0,0,0,0,128,212,2,0,217,129,3,0,176,30,0,0,0,0,0,0,128,212,2,0,253,129,3,0,176,30,0,0,0,0,0,0,128,212,2,0,33,130,3,0,176,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,44,180,41,188,166,23,185,63,10,166,105,60,184,248,200,63,5,159,213,46,6,148,210,63,99,169,174,166,226,125,216,63,59,246,6,56,93,43,222,63,200,104,174,57,59,199,225,63,214,29,9,37,243,76,228,63,204,59,127,102,158,160,230,63,65,23,21,107,128,188,232,63,163,161,14,41,102,155,234,63,176,189,128,241,178,56,236,63,70,141,50,207,107,144,237,63,219,45,198,86,65,159,238,63,176,92,247,207,151,98,239,63,37,37,209,163,141,216,239,63,0,0,0,0,0,0,240,63,38,37,209,163,141,216,239,63,176,92,247,207,151,98,239,63,219,45,198,86,65,159,238,63,70,141,50,207,107,144,237,63,177,189,128,241,178,56,236,63,165,161,14,41,102,155,234,63,66,23,21,107,128,188,232,63,205,59,127,102,158,160,230,63,214,29,9,37,243,76,228,63,200,104,174,57,59,199,225,63,63,246,6,56,93,43,222,63,101,169,174,166,226,125,216,63,6,159,213,46,6,148,210,63,23,166,105,60,184,248,200,63,60,180,41,188,166,23,185,63,159,113,189,255,249,165,161,60,43,180,41,188,166,23,185,191,14,166,105,60,184,248,200,191,1,159,213,46,6,148,210,191,97,169,174,166,226,125,216,191,59,246,6,56,93,43,222,191,198,104,174,57,59,199,225,191,212,29,9,37,243,76,228,191,204,59,127,102,158,160,230,191,62,23,21,107,128,188,232,191,163,161,14,41,102,155,234,191,176,189,128,241,178,56,236,191,68,141,50,207,107,144,237,191,218,45,198,86,65,159,238,191,175,92,247,207,151,98,239,191,38,37,209,163,141,216,239,191,0,0,0,0,0,0,240,191,38,37,209,163,141,216,239,191,176,92,247,207,151,98,239,191,219,45,198,86,65,159,238,191,69,141,50,207,107,144,237,191,177,189,128,241,178,56,236,191,165,161,14,41,102,155,234,191,64,23,21,107,128,188,232,191,206,59,127,102,158,160,230,191,218,29,9,37,243,76,228,191,200,104,174,57,59,199,225,191,64,246,6,56,93,43,222,191,110,169,174,166,226,125,216,191,8,159,213,46,6,148,210,191,27,166,105,60,184,248,200,191,37,180,41,188,166,23,185,191,56,0,0,0,0,0,0,0,32,87,0,0,61,0,0,0,62,0,0,0,200,255,255,255,200,255,255,255,32,87,0,0,63,0,0,0,64,0,0,0,128,212,2,0,20,137,3,0,32,87,0,0,0,0,0,0,60,0,0,0,0,0,0,0,240,86,0,0,45,0,0,0,46,0,0,0,196,255,255,255,196,255,255,255,240,86,0,0,47,0,0,0,48,0,0,0,128,212,2,0,90,137,3,0,240,86,0,0,0,0,0,0,128,212,2,0,154,150,3,0,64,92,0,0,0,0,0,0,88,212,2,0,81,155,3,0,88,212,2,0,70,175,3,0,48,213,2,0,94,176,3,0,0,0,0,0,1,0,0,0,112,30,0,0,0,0,0,0,48,213,2,0,139,176,3,0,0,0,0,0,1,0,0,0,112,30,0,0,0,0,0,0,88,212,2,0,112,193,3,0,88,212,2,0,243,203,3,0,88,212,2,0,3,204,3,0,128,212,2,0,19,204,3,0,208,23,0,0,0,0,0,0,128,212,2,0,64,205,3,0,8,31,0,0,0,0,0,0,128,212,2,0,96,204,3,0,208,23,0,0,0,0,0,0,128,212,2,0,43,205,3,0,184,30,0,0,0,0,0,0,128,212,2,0,82,205,3,0,192,30,0,0,0,0,0,0,128,212,2,0,103,205,3,0,208,23,0,0,0,0,0,0,128,212,2,0,245,205,3,0,8,31,0,0,0,0,0,0,128,212,2,0,11,206,3,0,208,23,0,0,0,0,0,0,128,212,2,0,86,206,3,0,8,31,0,0,0,0,0,0,128,212,2,0,109,206,3,0,208,23,0,0,0,0,0,0,128,212,2,0,181,206,3,0,8,31,0,0,0,0,0,0,128,212,2,0,201,206,3,0,208,23,0,0,0,0,0,0,128,212,2,0,25,207,3,0,8,31,0,0,0,0,0,0,128,212,2,0,48,207,3,0,208,23,0,0,0,0,0,0,128,212,2,0,124,207,3,0,8,31,0,0,0,0,0,0,128,212,2,0,43,209,3,0,176,30,0,0,0,0,0,0,128,212,2,0,119,209,3,0,176,30,0,0,0,0,0,0,128,212,2,0,193,209,3,0,176,30,0,0,0,0,0,0,128,212,2,0,10,210,3,0,176,30,0,0,0,0,0,0,128,212,2,0,95,210,3,0,176,30,0,0,0,0,0,0,128,212,2,0,7,211,3,0,176,30,0,0,0,0,0,0,128,212,2,0,88,211,3,0,176,30,0,0,0,0,0,0,128,212,2,0,167,211,3,0,176,30,0,0,0,0,0,0,128,212,2,0,245,211,3,0,176,30,0,0,0,0,0,0,128,212,2,0,79,212,3,0,176,30,0,0,0,0,0,0,128,212,2,0,108,213,3,0,176,30,0,0,0,0,0,0,128,212,2,0,1,214,3,0,176,30,0,0,0,0,0,0,128,212,2,0,109,214,3,0,176,30,0,0,0,0,0,0,128,212,2,0,217,214,3,0,176,30,0,0,0,0,0,0,128,212,2,0,69,215,3,0,176,30,0,0,0,0,0,0,128,212,2,0,190,215,3,0,176,30,0,0,0,0,0,0,128,212,2,0,66,216,3,0,176,30,0,0,0,0,0,0,128,212,2,0,198,216,3,0,176,30,0,0,0,0,0,0,128,212,2,0,74,217,3,0,176,30,0,0,0,0,0,0,128,212,2,0,206,217,3,0,176,30,0,0,0,0,0,0,128,212,2,0,98,218,3,0,176,30,0,0,0,0,0,0,128,212,2,0,212,218,3,0,176,30,0,0,0,0,0,0,128,212,2,0,70,219,3,0,176,30,0,0,0,0,0,0,128,212,2,0,184,219,3,0,176,30,0,0,0,0,0,0,128,212,2,0,42,220,3,0,176,30,0,0,0,0,0,0,128,212,2,0,169,220,3,0,176,30,0,0,0,0,0,0,128,212,2,0,199,220,3,0,176,30,0,0,0,0,0,0,128,212,2,0,229,220,3,0,176,30,0,0,0,0,0,0,128,212,2,0,3,221,3,0,176,30,0,0,0,0,0,0,128,212,2,0,33,221,3,0,176,30,0,0,0,0,0,0,128,212,2,0,63,221,3,0,176,30,0,0,0,0,0,0,128,212,2,0,126,221,3,0,176,30,0,0,0,0,0,0,128,212,2,0,197,221,3,0,176,30,0,0,0,0,0,0,128,212,2,0,30,222,3,0,176,30,0,0,0,0,0,0,128,212,2,0,119,222,3,0,176,30,0,0,0,0,0,0,128,212,2,0,208,222,3,0,176,30,0,0,0,0,0,0,128,212,2,0,231,222,3,0,176,30,0,0,0,0,0,0,128,212,2,0,41,223,3,0,176,30,0,0,0,0,0,0,128,212,2,0,107,223,3,0,176,30,0,0,0,0,0,0,128,212,2,0,174,223,3,0,176,30,0,0,0,0,0,0,128,212,2,0,240,223,3,0,176,30,0,0,0,0,0,0,128,212,2,0,35,227,3,0,208,23,0,0,0,0,0,0,128,212,2,0,138,232,3,0,176,30,0,0,0,0,0,0,128,212,2,0,249,241,3,0,176,30,0,0,0,0,0,0,128,212,2,0,19,242,3,0,176,30,0,0,0,0,0,0,128,212,2,0,90,243,3,0,208,23,0,0,0,0,0,0,128,212,2,0,198,243,3,0,152,42,0,0,0,0,0,0,128,212,2,0,254,243,3,0,208,23,0,0,0,0,0,0,128,212,2,0,106,244,3,0,152,42,0,0,0,0,0,0,128,212,2,0,162,244,3,0,208,23,0,0,0,0,0,0,128,212,2,0,14,245,3,0,152,42,0,0,0,0,0,0,128,212,2,0,70,245,3,0,208,23,0,0,0,0,0,0,128,212,2,0,178,245,3,0,152,42,0,0,0,0,0,0,128,212,2,0,234,245,3,0,208,23,0,0,0,0,0,0,128,212,2,0,86,246,3,0,152,42,0,0,0,0,0,0,128,212,2,0,142,246,3,0,208,23,0,0,0,0,0,0,128,212,2,0,250,246,3,0,152,42,0,0,0,0,0,0,128,212,2,0,50,247,3,0,208,23,0,0,0,0,0,0,128,212,2,0,158,247,3,0,152,42,0,0,0,0,0,0,128,212,2,0,214,247,3,0,208,23,0,0,0,0,0,0,128,212,2,0,66,248,3,0,152,42,0,0,0,0,0,0,128,212,2,0,122,248,3,0,208,23,0,0,0,0,0,0,128,212,2,0,230,248,3,0,152,42,0,0,0,0,0,0,128,212,2,0,30,249,3,0,208,23,0,0,0,0,0,0,128,212,2,0,138,249,3,0,152,42,0,0,0,0,0,0,128,212,2,0,220,249,3,0,208,23,0,0,0,0,0,0,128,212,2,0,78,250,3,0,160,42,0,0,0,0,0,0,128,212,2,0,140,250,3,0,208,23,0,0,0,0,0,0,128,212,2,0,254,250,3,0,160,42,0,0,0,0,0,0,128,212,2,0,60,251,3,0,208,23,0,0,0,0,0,0,128,212,2,0,174,251,3,0,160,42,0,0,0,0,0,0,128,212,2,0,236,251,3,0,208,23,0,0,0,0,0,0,128,212,2,0,94,252,3,0,160,42,0,0,0,0,0,0,128,212,2,0,156,252,3,0,208,23,0,0,0,0,0,0,128,212,2,0,14,253,3,0,160,42,0,0,0,0,0,0,128,212,2,0,76,253,3,0,208,23,0,0,0,0,0,0,128,212,2,0,190,253,3,0,160,42,0,0,0,0,0,0,128,212,2,0,252,253,3,0,208,23,0,0,0,0,0,0,128,212,2,0,110,254,3,0,160,42,0,0,0,0,0,0,128,212,2,0,172,254,3,0,208,23,0,0,0,0,0,0,128,212,2,0,30,255,3,0,160,42,0,0,0,0,0,0,128,212,2,0,92,255,3,0,208,23,0,0,0,0,0,0,128,212,2,0,206,255,3,0,160,42,0,0,0,0,0,0,128,212,2,0,12,0,4,0,208,23,0,0,0,0,0,0,128,212,2,0,126,0,4,0,160,42,0,0,0,0,0,0,128,212,2,0,208,0,4,0,208,23,0,0,0,0,0,0,128,212,2,0,90,1,4,0,168,42,0,0,0,0,0,0,128,212,2,0,140,1,4,0,208,23,0,0,0,0,0,0,128,212,2,0,242,1,4,0,168,42,0,0,0,0,0,0,128,212,2,0,36,2,4,0,208,23,0,0,0,0,0,0,128,212,2,0,138,2,4,0,168,42,0,0,0,0,0,0,128,212,2,0,188,2,4,0,208,23,0,0,0,0,0,0,128,212,2,0,34,3,4,0,168,42,0,0,0,0,0,0,128,212,2,0,84,3,4,0,208,23,0,0,0,0,0,0,128,212,2,0,186,3,4,0,168,42,0,0,0,0,0,0,128,212,2,0,236,3,4,0,208,23,0,0,0,0,0,0,128,212,2,0,82,4,4,0,168,42,0,0,0,0,0,0,128,212,2,0,132,4,4,0,208,23,0,0,0,0,0,0,128,212,2,0,234,4,4,0,168,42,0,0,0,0,0,0,128,212,2,0,28,5,4,0,208,23,0,0,0,0,0,0,128,212,2,0,130,5,4,0,168,42,0,0,0,0,0,0,128,212,2,0,180,5,4,0,208,23,0,0,0,0,0,0,128,212,2,0,26,6,4,0,168,42,0,0,0,0,0,0,128,212,2,0,76,6,4,0,208,23,0,0,0,0,0,0,128,212,2,0,178,6,4,0,168,42,0,0,0,0,0,0,128,212,2,0,86,7,4,0,208,23,0,0,0,0,0,0,128,212,2,0,46,11,4,0,176,30,0,0,0,0,0,0,128,212,2,0,121,11,4,0,176,30,0,0,0,0,0,0,128,212,2,0,196,11,4,0,176,30,0,0,0,0,0,0,128,212,2,0,3,12,4,0,176,30,0,0,0,0,0,0,128,212,2,0,66,12,4,0,176,30,0,0,0,0,0,0,128,212,2,0,130,12,4,0,176,30,0,0,0,0,0,0,128,212,2,0,80,13,4,0,208,23,0,0,0,0,0,0,128,212,2,0,149,13,4,0,152,42,0,0,0,0,0,0,128,212,2,0,166,13,4,0,208,23,0,0,0,0,0,0,128,212,2,0,235,13,4,0,152,42,0,0,0,0,0,0,128,212,2,0,252,13,4,0,208,23,0,0,0,0,0,0,128,212,2,0,65,14,4,0,152,42,0,0,0,0,0,0,128,212,2,0,82,14,4,0,208,23,0,0,0,0,0,0,128,212,2,0,151,14,4,0,152,42,0,0,0,0,0,0,128,212,2,0,168,14,4,0,208,23,0,0,0,0,0,0,128,212,2,0,237,14,4,0,152,42,0,0,0,0,0,0,128,212,2,0,254,14,4,0,208,23,0,0,0,0,0,0,128,212,2,0,67,15,4,0,152,42,0,0,0,0,0,0,128,212,2,0,84,15,4,0,208,23,0,0,0,0,0,0,128,212,2,0,153,15,4,0,152,42,0,0,0,0,0,0,128,212,2,0,170,15,4,0,208,23,0,0,0,0,0,0,128,212,2,0,239,15,4,0,152,42,0,0,0,0,0,0,128,212,2,0,0,16,4,0,208,23,0,0,0,0,0,0,128,212,2,0,69,16,4,0,152,42,0,0,0,0,0,0,128,212,2,0,86,16,4,0,208,23,0,0,0,0,0,0,128,212,2,0,155,16,4,0,152,42,0,0,0,0,0,0,128,212,2,0,122,17,4,0,208,23],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([128,212,2,0,214,17,4,0,160,42,0,0,0,0,0,0,128,212,2,0,234,17,4,0,208,23,0,0,0,0,0,0,128,212,2,0,50,18,4,0,160,42,0,0,0,0,0,0,128,212,2,0,70,18,4,0,208,23,0,0,0,0,0,0,128,212,2,0,142,18,4,0,160,42,0,0,0,0,0,0,128,212,2,0,162,18,4,0,208,23,0,0,0,0,0,0,128,212,2,0,234,18,4,0,160,42,0,0,0,0,0,0,128,212,2,0,254,18,4,0,208,23,0,0,0,0,0,0,128,212,2,0,70,19,4,0,160,42,0,0,0,0,0,0,128,212,2,0,90,19,4,0,208,23,0,0,0,0,0,0,128,212,2,0,162,19,4,0,160,42,0,0,0,0,0,0,128,212,2,0,182,19,4,0,208,23,0,0,0,0,0,0,128,212,2,0,254,19,4,0,160,42,0,0,0,0,0,0,128,212,2,0,18,20,4,0,208,23,0,0,0,0,0,0,128,212,2,0,90,20,4,0,160,42,0,0,0,0,0,0,128,212,2,0,110,20,4,0,208,23,0,0,0,0,0,0,128,212,2,0,182,20,4,0,160,42,0,0,0,0,0,0,128,212,2,0,202,20,4,0,208,23,0,0,0,0,0,0,128,212,2,0,18,21,4,0,160,42,0,0,0,0,0,0,128,212,2,0,38,21,4,0,208,23,0,0,0,0,0,0,128,212,2,0,110,21,4,0,160,42,0,0,0,0,0,0,128,212,2,0,130,21,4,0,208,23,0,0,0,0,0,0,128,212,2,0,202,21,4,0,160,42,0,0,0,0,0,0,128,212,2,0,241,21,4,0,208,23,0,0,0,0,0,0,128,212,2,0,57,22,4,0,152,42,0,0,0,0,0,0,128,212,2,0,77,22,4,0,208,23,0,0,0,0,0,0,128,212,2,0,149,22,4,0,152,42,0,0,0,0,0,0,128,212,2,0,169,22,4,0,208,23,0,0,0,0,0,0,128,212,2,0,241,22,4,0,152,42,0,0,0,0,0,0,128,212,2,0,5,23,4,0,208,23,0,0,0,0,0,0,128,212,2,0,77,23,4,0,152,42,0,0,0,0,0,0,128,212,2,0,97,23,4,0,208,23,0,0,0,0,0,0,128,212,2,0,169,23,4,0,152,42,0,0,0,0,0,0,128,212,2,0,103,26,4,0,176,30,0,0,0,0,0,0,128,212,2,0,138,26,4,0,176,30,0,0,0,0,0,0,128,212,2,0,234,27,4,0,176,30,0,0,0,0,0,0,128,212,2,0,250,27,4,0,176,30,0,0,0,0,0,0,128,212,2,0,177,35,4,0,176,30,0,0,0,0,0,0,128,212,2,0,226,35,4,0,176,30,0,0,0,0,0,0,128,212,2,0,202,36,4,0,176,30,0,0,0,0,0,0,128,212,2,0,236,44,4,0,176,30,0,0,0,0,0,0,88,212,2,0,169,46,4,0,88,212,2,0,190,46,4,0,88,212,2,0,214,46,4,0,88,212,2,0,112,48,4,0,128,212,2,0,5,50,4,0,208,23,0,0,0,0,0,0,128,212,2,0,178,50,4,0,152,42,0,0,0,0,0,0,128,212,2,0,211,50,4,0,208,23,0,0,0,0,0,0,128,212,2,0,40,51,4,0,152,42,0,0,0,0,0,0,128,212,2,0,73,51,4,0,208,23,0,0,0,0,0,0,128,212,2,0,158,51,4,0,152,42,0,0,0,0,0,0,128,212,2,0,191,51,4,0,208,23,0,0,0,0,0,0,128,212,2,0,20,52,4,0,152,42,0,0,0,0,0,0,128,212,2,0,53,52,4,0,208,23,0,0,0,0,0,0,128,212,2,0,138,52,4,0,152,42,0,0,0,0,0,0,128,212,2,0,171,52,4,0,208,23,0,0,0,0,0,0,128,212,2,0,0,53,4,0,152,42,0,0,0,0,0,0,128,212,2,0,33,53,4,0,208,23,0,0,0,0,0,0,128,212,2,0,118,53,4,0,152,42,0,0,0,0,0,0,128,212,2,0,151,53,4,0,208,23,0,0,0,0,0,0,128,212,2,0,236,53,4,0,152,42,0,0,0,0,0,0,128,212,2,0,13,54,4,0,208,23,0,0,0,0,0,0,128,212,2,0,98,54,4,0,152,42,0,0,0,0,0,0,128,212,2,0,131,54,4,0,208,23,0,0,0,0,0,0,128,212,2,0,216,54,4,0,152,42,0,0,0,0,0,0,128,212,2,0,249,54,4,0,208,23,0,0,0,0,0,0,128,212,2,0,202,55,4,0,152,42,0,0,0,0,0,0,128,212,2,0,245,55,4,0,8,44,0,0,0,0,0,0,128,212,2,0,42,56,4,0,208,23,0,0,0,0,0,0,128,212,2,0,147,56,4,0,152,42,0,0,0,0,0,0,128,212,2,0,190,56,4,0,56,44,0,0,0,0,0,0,128,212,2,0,176,57,4,0,208,23,0,0,0,0,0,0,128,212,2,0,110,58,4,0,160,42,0,0,0,0,0,0,128,212,2,0,162,58,4,0,104,44,0,0,0,0,0,0,128,212,2,0,218,58,4,0,208,23,0,0,0,0,0,0,128,212,2,0,70,59,4,0,160,42,0,0,0,0,0,0,128,212,2,0,122,59,4,0,152,44,0,0,0,0,0,0,128,212,2,0,178,59,4,0,208,23,0,0,0,0,0,0,128,212,2,0,30,60,4,0,160,42,0,0,0,0,0,0,128,212,2,0,82,60,4,0,200,44,0,0,0,0,0,0,128,212,2,0,138,60,4,0,208,23,0,0,0,0,0,0,128,212,2,0,246,60,4,0,160,42,0,0,0,0,0,0,128,212,2,0,42,61,4,0,248,44,0,0,0,0,0,0,128,212,2,0,98,61,4,0,208,23,0,0,0,0,0,0,128,212,2,0,206,61,4,0,160,42,0,0,0,0,0,0,128,212,2,0,2,62,4,0,40,45,0,0,0,0,0,0,128,212,2,0,149,62,4,0,208,23,0,0,0,0,0,0,128,212,2,0,1,63,4,0,160,42,0,0,0,0,0,0,128,212,2,0,53,63,4,0,88,45,0,0,0,0,0,0,128,212,2,0,109,63,4,0,208,23,0,0,0,0,0,0,128,212,2,0,217,63,4,0,160,42,0,0,0,0,0,0,128,212,2,0,13,64,4,0,136,45,0,0,0,0,0,0,128,212,2,0,69,64,4,0,208,23,0,0,0,0,0,0,128,212,2,0,177,64,4,0,160,42,0,0,0,0,0,0,128,212,2,0,229,64,4,0,184,45,0,0,0,0,0,0,128,212,2,0,29,65,4,0,208,23,0,0,0,0,0,0,128,212,2,0,137,65,4,0,160,42,0,0,0,0,0,0,128,212,2,0,189,65,4,0,232,45,0,0,0,0,0,0,128,212,2,0,245,65,4,0,208,23,0,0,0,0,0,0,128,212,2,0,107,66,4,0,160,42,0,0,0,0,0,0,128,212,2,0,169,66,4,0,24,46,0,0,0,0,0,0,128,212,2,0,235,66,4,0,208,23,0,0,0,0,0,0,128,212,2,0,140,67,4,0,160,42,0,0,0,0,0,0,128,212,2,0,201,67,4,0,104,46,0,0,0,0,0,0,128,212,2,0,15,68,4,0,72,46,0,0,0,0,0,0,128,212,2,0,80,68,4,0,208,23,0,0,0,0,0,0,128,212,2,0,202,68,4,0,160,42,0,0,0,0,0,0,128,212,2,0,7,69,4,0,168,46,0,0,0,0,0,0,128,212,2,0,77,69,4,0,136,46,0,0,0,0,0,0,128,212,2,0,142,69,4,0,208,23,0,0,0,0,0,0,128,212,2,0,9,70,4,0,40,46,0,0,0,0,0,0,128,212,2,0,80,70,4,0,208,23,0,0,0,0,0,0,128,212,2,0,184,70,4,0,208,23,0,0,0,0,0,0,128,212,2,0,32,71,4,0,208,23,0,0,0,0,0,0,128,212,2,0,136,71,4,0,208,23,0,0,0,0,0,0,128,212,2,0,240,71,4,0,208,23,0,0,0,0,0,0,128,212,2,0,88,72,4,0,208,23,0,0,0,0,0,0,128,212,2,0,192,72,4,0,208,23,0,0,0,0,0,0,128,212,2,0,40,73,4,0,208,23,0,0,0,0,0,0,128,212,2,0,144,73,4,0,208,23,0,0,0,0,0,0,128,212,2,0,172,75,4,0,208,23,0,0,0,0,0,0,128,212,2,0,62,76,4,0,168,42,0,0,0,0,0,0,128,212,2,0,110,76,4,0,208,23,0,0,0,0,0,0,128,212,2,0,210,76,4,0,168,42,0,0,0,0,0,0,128,212,2,0,2,77,4,0,208,23,0,0,0,0,0,0,128,212,2,0,102,77,4,0,168,42,0,0,0,0,0,0,128,212,2,0,150,77,4,0,208,23,0,0,0,0,0,0,128,212,2,0,250,77,4,0,168,42,0,0,0,0,0,0,128,212,2,0,42,78,4,0,208,23,0,0,0,0,0,0,128,212,2,0,142,78,4,0,168,42,0,0,0,0,0,0,128,212,2,0,190,78,4,0,208,23,0,0,0,0,0,0,128,212,2,0,34,79,4,0,168,42,0,0,0,0,0,0,128,212,2,0,82,79,4,0,208,23,0,0,0,0,0,0,128,212,2,0,182,79,4,0,168,42,0,0,0,0,0,0,128,212,2,0,230,79,4,0,208,23,0,0,0,0,0,0,128,212,2,0,74,80,4,0,168,42,0,0,0,0,0,0,128,212,2,0,122,80,4,0,208,23,0,0,0,0,0,0,128,212,2,0,222,80,4,0,168,42,0,0,0,0,0,0,128,212,2,0,14,81,4,0,208,23,0,0,0,0,0,0,128,212,2,0,114,81,4,0,168,42,0,0,0,0,0,0,128,212,2,0,162,81,4,0,208,23,0,0,0,0,0,0,128,212,2,0,6,82,4,0,168,42,0,0,0,0,0,0,128,212,2,0,54,82,4,0,208,23,0,0,0,0,0,0,128,212,2,0,154,82,4,0,168,42,0,0,0,0,0,0,128,212,2,0,202,82,4,0,208,23,0,0,0,0,0,0,128,212,2,0,46,83,4,0,168,42,0,0,0,0,0,0,128,212,2,0,102,84,4,0,176,30,0,0,0,0,0,0,128,212,2,0,146,84,4,0,176,30,0,0,0,0,0,0,128,212,2,0,190,84,4,0,176,30,0,0,0,0,0,0,128,212,2,0,234,84,4,0,176,30,0,0,0,0,0,0,128,212,2,0,22,85,4,0,176,30,0,0,0,0,0,0,128,212,2,0,66,85,4,0,176,30,0,0,0,0,0,0,128,212,2,0,110,85,4,0,176,30,0,0,0,0,0,0,128,212,2,0,154,85,4,0,176,30,0,0,0,0,0,0,128,212,2,0,206,91,4,0,176,30,0,0,0,0,0,0,128,212,2,0,8,92,4,0,176,30,0,0,0,0,0,0,128,212,2,0,67,92,4,0,176,30,0,0,0,0,0,0,128,212,2,0,105,92,4,0,176,30,0,0,0,0,0,0,128,212,2,0,126,93,4,0,176,30,0,0,0,0,0,0,128,212,2,0,76,100,4,0,208,23,0,0,0,0,0,0,128,212,2,0,140,103,4,0,48,20,0,0,0,0,0,0,128,212,2,0,225,100,4,0,208,23,0,0,0,0,0,0,128,212,2,0,72,101,4,0,176,30,0,0,0,0,0,0,128,212,2,0,122,101,4,0,208,23,0,0,0,0,0,0,128,212,2,0,225,101,4,0,176,30,0,0,0,0,0,0,128,212,2,0,19,102,4,0,208,23,0,0,0,0,0,0,128,212,2,0,124,102,4,0,176,30,0,0,0,0,0,0,128,212,2,0,176,102,4,0,208,23,0,0,0,0,0,0,128,212,2,0,23,103,4,0,176,30,0,0,0,0,0,0,128,212,2,0,8,105,4,0,176,30,0,0,0,0,0,0,128,212,2,0,28,105,4,0,176,30,0,0,0,0,0,0,128,212,2,0,214,105,4,0,176,30,0,0,0,0,0,0,128,212,2,0,5,106,4,0,176,30,0,0,0,0,0,0,128,212,2,0,52,106,4,0,176,30,0,0,0,0,0,0,128,212,2,0,99,106,4,0,176,30,0,0,0,0,0,0,128,212,2,0,146,106,4,0,176,30,0,0,0,0,0,0,128,212,2,0,193,106,4,0,176,30,0,0,0,0,0,0,128,212,2,0,240,106,4,0,176,30,0,0,0,0,0,0,128,212,2,0,28,107,4,0,176,30,0,0,0,0,0,0,128,212,2,0,91,108,4,0,176,30,0,0,0,0,0,0,128,212,2,0,239,108,4,0,176,30,0,0,0,0,0,0,128,212,2,0,166,109,4,0,176,30,0,0,0,0,0,0,128,212,2,0,210,109,4,0,176,30,0,0,0,0,0,0,128,212,2,0,11,110,4,0,176,30,0,0,0,0,0,0,128,212,2,0,55,110,4,0,176,30,0,0,0,0,0,0,128,212,2,0,87,112,4,0,176,30,0,0,0,0,0,0,128,212,2,0,5,113,4,0,176,30,0,0,0,0,0,0,128,212,2,0,50,113,4,0,176,30,0,0,0,0,0,0,128,212,2,0,95,113,4,0,176,30,0,0,0,0,0,0,128,212,2,0,141,113,4,0,176,30,0,0,0,0,0,0,128,212,2,0,187,113,4,0,176,30,0,0,0,0,0,0,128,212,2,0,233,113,4,0,176,30,0,0,0,0,0,0,128,212,2,0,23,114,4,0,176,30,0,0,0,0,0,0,128,212,2,0,69,114,4,0,176,30,0,0,0,0,0,0,128,212,2,0,115,114,4,0,176,30,0,0,0,0,0,0,128,212,2,0,161,114,4,0,176,30,0,0,0,0,0,0,128,212,2,0,207,114,4,0,176,30,0,0,0,0,0,0,128,212,2,0,254,114,4,0,176,30,0,0,0,0,0,0,128,212,2,0,45,115,4,0,176,30,0,0,0,0,0,0,128,212,2,0,94,115,4,0,176,30,0,0,0,0,0,0,128,212,2,0,26,163,5,0,176,30,0,0,0,0,0,0,128,212,2,0,76,163,5,0,176,30,0,0,0,0,0,0,128,212,2,0,126,163,5,0,176,30,0,0,0,0,0,0,128,212,2,0,176,163,5,0,176,30,0,0,0,0,0,0,128,212,2,0,226,163,5,0,176,30,0,0,0,0,0,0,128,212,2,0,20,164,5,0,176,30,0,0,0,0,0,0,128,212,2,0,203,164,5,0,176,30,0,0,0,0,0,0,128,212,2,0,245,164,5,0,176,30,0,0,0,0,0,0,128,212,2,0,31,165,5,0,176,30,0,0,0,0,0,0,128,212,2,0,73,165,5,0,176,30,0,0,0,0,0,0,128,212,2,0,115,165,5,0,176,30,0,0,0,0,0,0,128,212,2,0,155,165,5,0,176,30,0,0,0,0,0,0,128,212,2,0,195,165,5,0,176,30,0,0,0,0,0,0,128,212,2,0,235,165,5,0,176,30,0,0,0,0,0,0,128,212,2,0,41,166,5,0,176,30,0,0,0,0,0,0,128,212,2,0,78,166,5,0,176,30,0,0,0,0,0,0,128,212,2,0,115,166,5,0,176,30,0,0,0,0,0,0,128,212,2,0,150,166,5,0,176,30,0,0,0,0,0,0,128,212,2,0,185,166,5,0,176,30,0,0,0,0,0,0,128,212,2,0,235,166,5,0,176,30,0,0,0,0,0,0,128,212,2,0,24,167,5,0,176,30,0,0,0,0,0,0,128,212,2,0,69,167,5,0,176,30,0,0,0,0,0,0,128,212,2,0,114,167,5,0,176,30,0,0,0,0,0,0,128,212,2,0,159,167,5,0,176,30,0,0,0,0,0,0,128,212,2,0,204,167,5,0,176,30,0,0,0,0,0,0,128,212,2,0,249,167,5,0,176,30,0,0,0,0,0,0,128,212,2,0,36,168,5,0,176,30,0,0,0,0,0,0,128,212,2,0,79,168,5,0,176,30,0,0,0,0,0,0,128,212,2,0,122,168,5,0,176,30,0,0,0,0,0,0,128,212,2,0,165,168,5,0,176,30,0,0,0,0,0,0,128,212,2,0,208,168,5,0,176,30,0,0,0,0,0,0,128,212,2,0,7,176,5,0,248,19,0,0,0,0,0,0,128,212,2,0,4,175,5,0,176,30,0,0,0,0,0,0,128,212,2,0,43,176,5,0,208,23,0,0,0,0,0,0,128,212,2,0,241,176,5,0,176,30,0,0,0,0,0,0,128,212,2,0,134,177,5,0,208,23,0,0,0,0,0,0,128,212,2,0,218,180,5,0,184,54,0,0,0,0,0,0,128,212,2,0,10,181,5,0,200,54,0,0,0,0,0,0,128,212,2,0,40,181,5,0,48,27,0,0,0,0,0,0,128,212,2,0,81,182,5,0,208,23,0,0,0,0,0,0,128,212,2,0,148,183,5,0,248,54,0,0,0,0,0,0,128,212,2,0,194,183,5,0,8,55,0,0,0,0,0,0,128,212,2,0,222,183,5,0,48,27,0,0,0,0,0,0,128,212,2,0,250,190,5,0,48,27,0,0,0,0,0,0,88,212,2,0,35,191,5,0,128,212,2,0,12,194,5,0,208,23,0,0,0,0,0,0,128,212,2,0,133,194,5,0,208,23,0,0,0,0,0,0,128,212,2,0,49,196,5,0,24,55,0,0,0,0,0,0,128,212,2,0,122,199,5,0,40,55,0,0,0,0,0,0,128,212,2,0,96,206,5,0,24,55,0,0,0,0,0,0,128,212,2,0,47,206,5,0,24,55,0,0,0,0,0,0,128,212,2,0,32,205,5,0,24,55,0,0,0,0,0,0,128,212,2,0,240,204,5,0,24,55,0,0,0,0,0,0,128,212,2,0,159,205,5,0,208,23,0,0,0,0,0,0,112,0,0,0,0,0,0,0,240,86,0,0,45,0,0,0,46,0,0,0,144,255,255,255,144,255,255,255,240,86,0,0,47,0,0,0,48,0,0,0,112,0,0,0,0,0,0,0,80,87,0,0,51,0,0,0,52,0,0,0,104,0,0,0,248,255,255,255,80,87,0,0,53,0,0,0,54,0,0,0,144,255,255,255,144,255,255,255,80,87,0,0,55,0,0,0,56,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,32,87,0,0,61,0,0,0,62,0,0,0,152,255,255,255,152,255,255,255,32,87,0,0,63,0,0,0,64,0,0,0,128,212,2,0,67,215,5,0,224,86,0,0,0,0,0,0,128,212,2,0,114,215,5,0,80,87,0,0,0,0,0,0,48,213,2,0,193,224,5,0,0,0,0,0,1,0,0,0,136,56,0,0,0,0,0,0,88,212,2,0,66,225,5,0,128,212,2,0,206,238,5,0,208,23,0,0,0,0,0,0,128,212,2,0,154,240,5,0,208,23,0,0,0,0,0,0,108,0,0,0,0,0,0,0,240,86,0,0,45,0,0,0,46,0,0,0,148,255,255,255,148,255,255,255,240,86,0,0,47,0,0,0,48,0,0,0,128,212,2,0,36,242,5,0,240,86,0,0,0,0,0,0,128,212,2,0,84,242,5,0,224,86,0,0,0,0,0,0,128,212,2,0,210,244,5,0,0,79,0,0,0,0,0,0,128,212,2,0,218,14,6,0,8,82,0,0,0,0,0,0,128,212,2,0,246,11,6,0,152,57,0,0,0,0,0,0,128,212,2,0,189,8,6,0,8,82,0,0,0,0,0,0,88,212,2,0,225,8,6,0,128,212,2,0,121,11,6,0,144,57,0,0,0,0,0,0,128,212,2,0,94,9,6,0,8,82,0,0,0,0,0,0,128,212,2,0,126,9,6,0,112,57,0,0,0,0,0,0,128,212,2,0,181,9,6,0,128,57,0,0,0,0,0,0,128,212,2,0,142,10,6,0,8,82,0,0,0,0,0,0,88,212,2,0,173,11,6,0,128,212,2,0,207,12,6,0,192,81,0,0,0,0,0,0,128,212,2,0,222,13,6,0,96,57,0,0,0,0,0,0,128,212,2,0,218,21,6,0,8,82,0,0,0,0,0,0,128,212,2,0,76,19,6,0,152,57,0,0,0,0,0,0,128,212,2,0,26,19,6,0,248,57,0,0,0,0,0,0,128,212,2,0,96,17,6,0,8,82,0,0,0,0,0,0,128,212,2,0,70,18,6,0,232,57,0,0,0,0,0,0,128,212,2,0,188,21,6,0,8,82,0,0,0,0,0,0,128,212,2,0,197,20,6,0,216,57,0,0,0,0,0,0,128,212,2,0,156,23,6,0,8,82,0,0,0,0,0,0,128,212,2,0,72,23,6,0,8,82,0,0,0,0,0,0,128,212,2,0,209,24,6,0,8,82,0,0,0,0,0,0,128,212,2,0,62,27,6,0,8,82,0,0,0,0,0,0,128,212,2,0,217,113,6,0,8,82,0,0,0,0,0,0,128,212,2,0,87,104,6,0,8,82,0,0,0,0,0,0,128,212,2,0,127,104,6,0,8,82,0,0,0,0,0,0,128,212,2,0,163,104,6,0,8,82,0,0,0,0,0,0,128,212,2,0,201,104,6,0,8,82,0,0,0,0,0,0,128,212,2,0,12,105,6,0,8,82,0,0,0,0,0,0,128,212,2,0,234,104,6,0,8,82,0,0,0,0,0,0,128,212,2,0,110,105,6,0,8,82,0,0,0,0,0,0,128,212,2,0,45,105,6,0,8,82,0,0,0,0,0,0,128,212,2,0,83,105,6,0,8,82,0,0,0,0,0,0,128,212,2,0,182,109,6,0,8,82,0,0,0,0,0,0,128,212,2,0,145,105,6,0,8,82,0,0,0,0,0,0,128,212,2,0,177,105,6,0,8,82,0,0,0,0,0,0,128,212,2,0,208,105,6,0,8,82,0,0,0,0,0,0,128,212,2,0,251,105,6,0,8,82,0,0,0,0,0,0,128,212,2,0,30,106,6,0,8,82,0,0,0,0,0,0,128,212,2,0,65,106,6,0,8,82,0,0,0,0,0,0,128,212,2,0,97,106,6,0,8,82,0,0,0,0,0,0,128,212,2,0,139,106,6,0,8,82,0,0,0,0,0,0,128,212,2,0,170,106,6,0,8,82,0,0,0,0,0,0,128,212,2,0,203,106,6,0,8,82,0,0,0,0,0,0,128,212,2,0,235,106,6,0,8,82,0,0,0,0,0,0,128,212,2,0,16,107,6,0,8,82,0,0,0,0,0,0,128,212,2,0,52,107,6,0,8,82,0,0,0,0,0,0,128,212,2,0,89,107,6,0,8,82,0,0,0,0,0,0,128,212,2,0,126,107,6,0,8,82,0,0,0,0,0,0,128,212,2,0,161,107,6,0,8,82,0,0,0,0,0,0,128,212,2,0,195,107,6,0,8,82,0,0,0,0,0,0,128,212,2,0,233,107,6,0,8,82,0,0,0,0,0,0,128,212,2,0,10,108,6,0,8,82,0,0,0,0,0,0,128,212,2,0,48,108,6,0,8,82,0,0,0,0,0,0,128,212,2,0,83,108,6,0,8,82,0,0,0,0,0,0,128,212,2,0,114,108,6,0,8,82,0,0,0,0,0,0,128,212,2,0,154,108,6,0,8,82,0,0,0,0,0,0,128,212,2,0,194,108,6,0,8,82,0,0,0,0,0,0,128,212,2,0,231,108,6,0,8,82,0,0,0,0,0,0,128,212,2,0,11,109,6,0,8,82,0,0,0,0,0,0,128,212,2,0,46,109,6,0,8,82,0,0,0,0,0,0,128,212,2,0,78,109,6,0,8,82,0,0,0,0,0,0,128,212,2,0,117,109,6,0,8,82,0,0,0,0,0,0,128,212,2,0,151,109,6,0,8,82,0,0,0,0,0,0,128,212,2,0,217,109,6,0,8,82,0,0,0,0,0,0,128,212,2,0,248,109,6,0,8,82,0,0,0,0,0,0,128,212,2,0,24,110,6,0,8,82,0,0,0,0,0,0,128,212,2,0,57,110,6,0,8,82,0,0,0,0,0,0,128,212,2,0,92,110,6,0,8,82,0,0,0,0,0,0,128,212,2,0,129,110,6,0,8,82,0,0,0,0,0,0,128,212,2,0,166,110,6,0,8,82,0,0,0,0,0,0,128,212,2,0,200,110,6,0,8,82,0,0,0,0,0,0,128,212,2,0,237,110,6,0,8,82,0,0,0,0,0,0,128,212,2,0,12,111,6,0,8,82,0,0,0,0,0,0,128,212,2,0,45,111,6,0,8,82,0,0,0,0,0,0,128,212,2,0,80,111,6,0,8,82,0,0,0,0,0,0,128,212,2,0,113,111,6,0,8,82,0,0,0,0,0,0,128,212,2,0,144,111,6,0,8,82,0,0,0,0,0,0,128,212,2,0,182,111,6,0,8,82,0,0,0,0,0,0,128,212,2,0,231,111,6,0,8,82,0,0,0,0,0,0,128,212,2,0,7,112,6,0,8,82,0,0,0,0,0,0,128,212,2,0,39,112,6,0,8,82,0,0,0,0,0,0,128,212,2,0,2,113,6,0,8,82,0,0,0,0,0,0,128,212,2,0,76,112,6,0,8,82,0,0,0,0,0,0,128,212,2,0,112,112,6,0,8,82,0,0,0,0,0,0,128,212,2,0,153,112,6,0,8,82,0,0,0,0,0,0,128,212,2,0,188,112,6,0,8,82,0,0,0,0,0,0,128,212,2,0,231,112,6,0,8,82,0,0,0,0,0,0,128,212,2,0,35,113,6,0,8,82,0,0,0,0,0,0,128,212,2,0,61,113,6,0,8,82,0,0,0,0,0,0,128,212,2,0,126,113,6,0,8,82,0,0,0,0,0,0,128,212,2,0,95,113,6,0,8,82,0,0,0,0,0,0,128,212,2,0,160,113,6,0,8,82,0,0,0,0,0,0,128,212,2,0,183,113,6,0,8,82,0,0,0,0,0,0,128,212,2,0,185,125,6,0,8,82,0,0,0,0,0,0,128,212,2,0,47,124,6,0,8,82,0,0,0,0,0,0,128,212,2,0,195,124,6,0,8,82,0,0,0,0,0,0,128,212,2,0,83,124,6,0,8,82,0,0,0,0,0,0,128,212,2,0,127,124,6,0,8,82,0,0,0,0,0,0,128,212,2,0,161,124,6,0,8,82,0,0,0,0,0,0,128,212,2,0,2,125,6,0,8,82,0,0,0,0,0,0,128,212,2,0,221,124,6,0,8,82,0,0,0,0,0,0,128,212,2,0,31,125,6,0,8,82,0,0,0,0,0,0,128,212,2,0,157,125,6,0,8,82,0,0,0,0,0,0,128,212,2,0,71,125,6,0,8,82,0,0,0,0,0,0,128,212,2,0,103,125,6,0,8,82,0,0,0,0,0,0,128,212,2,0,129,125,6,0,8,82,0,0,0,0,0,0,128,212,2,0,248,127,6,0,208,23,0,0,0,0,0,0,88,212,2,0,123,128,6,0,128,212,2,0,4,129,6,0,184,63,0,0,0,0,0,0,128,212,2,0,63,129,6,0,208,23,0,0,0,0,0,0,128,212,2,0,19,131,6,0,184,63,0,0,0,0,0,0,128,212,2,0,79,131,6,0,208,23,0,0,0,0,0,0,128,212,2,0,205,131,6,0,184,63,0,0,0,0,0,0,128,212,2,0,8,132,6,0,208,23,0,0,0,0,0,0,128,212,2,0,195,132,6,0,184,63,0,0,0,0,0,0,128,212,2,0,6,133,6,0,208,23,0,0,0,0,0,0,128,212,2,0,177,133,6,0,184,63,0,0,0,0,0,0,128,212,2,0,245,133,6,0,208,23,0,0,0,0,0,0,128,212,2,0,134,134,6,0,184,63,0,0,0,0,0,0,128,212,2,0,190,134,6,0,208,23,0,0,0,0,0,0,128,212,2,0,43,135,6,0,184,63,0,0,0,0,0,0,128,212,2,0,100,135,6,0,208,23,0,0,0,0,0,0,128,212,2,0,221,135,6,0,184,63,0,0,0,0,0,0,128,212,2,0,20,136,6,0,208,23,0,0,0,0,0,0,128,212,2,0,149,136,6,0,184,63,0,0,0,0,0,0,128,212,2,0,206,136,6,0,208,23,0,0,0,0,0,0,128,212,2,0,67,137,6,0,184,63,0,0,0,0,0,0,128,212,2,0,124,137,6,0,208,23,0,0,0,0,0,0,128,212,2,0,228,137,6,0,184,63,0,0,0,0,0,0,128,212,2,0,24,138,6,0,208,23,0,0,0,0,0,0,128,212,2,0,107,139,6,0,184,63,0,0,0,0,0,0,128,212,2,0,168,139,6,0,208,23,0,0,0,0,0,0,128,212,2,0,178,140,6,0,184,63,0,0,0,0,0,0,128,212,2,0,113,144,6,0,208,23,0,0,0,0,0,0,128,212,2,0,18,146,6,0,112,65,0,0,0,0,0,0,128,212,2,0,52,146,6,0,24,55,0,0,0,0,0,0,128,212,2,0,107,146,6,0,208,23,0,0,0,0,0,0,128,212,2,0,148,149,6,0,176,65,0,0,0,0,0,0,128,212,2,0,77,149,6,0,176,30,0,0,0,0,0,0,128,212,2,0,176,149,6,0,24,55,0,0,0,0,0,0,128,212,2,0,225,149,6,0,208,23,0,0,0,0,0,0,128,212,2,0,162,150,6,0,24,55,0,0,0,0,0,0,128,212,2,0,62,152,6,0,208,65,0,0,0,0,0,0,128,212,2,0,90,152,6,0,208,23,0,0,0,0,0,0,128,212,2,0,195,158,6,0,80,66,0,0,0,0,0,0,128,212,2,0,147,156,6,0,112,55,0,0,0,0,0,0,128,212,2,0,92,156,6,0,112,55,0,0,0,0,0,0,128,212,2,0,46,156,6,0,176,30,0,0,0,0,0,0,128,212,2,0,138,158,6,0,24,55,0,0,0,0,0,0,128,212,2,0,227,158,6,0,96,66,0,0,0,0,0,0,128,212,2,0,7,159,6,0,64,66,0,0,0,0,0,0,128,212,2,0,189,159,6,0,208,23,0,0,0,0,0,0,128,212,2,0,40,161,6,0,80,66,0,0,0,0,0,0,128,212,2,0,198,160,6,0,176,30,0,0,0,0,0,0,128,212,2,0,247,160,6,0,176,30,0,0,0,0,0,0,128,212,2,0,74,161,6,0,208,23,0,0,0,0,0,0,128,212,2,0,41,163,6,0,224,66,0,0,0,0,0,0,128,212,2,0,5,163,6,0,176,30,0,0,0,0,0,0,128,212,2,0,65,163,6,0,24,55,0,0,0,0,0,0,128,212,2,0,109,163,6,0,208,23,0,0,0,0,0,0,128,212,2,0,175,165,6,0,16,67,0,0,0,0,0,0,128,212,2,0,201,165,6,0,24,55,0,0,0,0,0,0,128,212,2,0,254,165,6,0,208,23,0,0,0,0,0,0,128,212,2,0,184,168,6,0,64,67,0,0,0,0,0,0,128,212,2,0,212,168,6,0,24,55,0,0,0,0,0,0,128,212,2,0,5,169,6,0,208,23,0,0,0,0,0,0,128,212,2,0,19,170,6,0,112,67,0,0,0,0,0,0,128,212,2,0,47,170,6,0,24,55,0,0,0,0,0,0,128,212,2,0,96,170,6,0,208,23,0,0,0,0,0,0,128,212,2,0,229,171,6,0,24,55,0,0,0,0,0,0,128,212,2,0,38,173,6,0,144,67,0,0,0,0,0,0,128,212,2,0,64,173,6,0,208,23,0,0,0,0,0,0,128,212,2,0,175,173,6,0,208,67,0,0,0,0,0,0,128,212,2,0,199,173,6,0,24,55,0,0,0,0,0,0,128,212,2,0,243,173,6,0,208,23,0,0,0,0,0,0,128,212,2,0,217,175,6,0,0,68,0,0,0,0,0,0,128,212,2,0,246,175,6,0,24,55,0,0,0,0,0,0,128,212,2,0,40,176,6,0,208,23,0,0,0,0,0,0,128,212,2,0,138,177,6,0,16,66,0,0,0,0,0,0,128,212,2,0,84,177,6,0,176,30,0,0,0,0,0,0,128,212,2,0,240,177,6,0,208,23,0,0,0,0,0,0,128,212,2,0,140,178,6,0,112,68,0,0,0,0,0,0,128,212,2,0,85,178,6,0,176,30,0,0,0,0,0,0,128,212,2,0,189,178,6,0,112,55,0,0,0,0,0,0,128,212,2,0,236,178,6,0,208,23,0,0,0,0,0,0,128,212,2,0,134,179,6,0,176,68,0,0,0,0,0,0,128,212,2,0,80,179,6,0,176,30,0,0,0,0,0,0,128,212,2,0,182,179,6,0,112,55,0,0,0,0,0,0,128,212,2,0,227,179,6,0,208,23,0,0,0,0,0,0,128,212,2,0,131,180,6,0,240,68,0,0,0,0,0,0,128,212,2,0,74,180,6,0,176,30,0,0,0,0,0,0,128,212,2,0,182,180,6,0,112,55,0,0,0,0,0,0,128,212,2,0,231,180,6,0,208,23,0,0,0,0,0,0,128,212,2,0,127,181,6,0,48,69,0,0,0,0,0,0,128,212,2,0,74,181,6,0,176,30,0,0,0,0,0,0,128,212,2,0,174,181,6,0,112,55,0,0,0,0,0,0,128,212,2,0,218,181,6,0,208,23,0,0,0,0,0,0,128,212,2,0,120,182,6,0,112,69,0,0,0,0,0,0,128,212,2,0,64,182,6,0,176,30,0,0,0,0,0,0,128,212,2,0,170,182,6,0,112,55,0,0,0,0,0,0,128,212,2,0,214,182,6,0,208,23,0,0,0,0,0,0,128,212,2,0,112,183,6,0,176,69,0,0,0,0,0,0,128,212,2,0,58,183,6,0,176,30,0,0,0,0,0,0,128,212,2,0,160,183,6,0,112,55,0,0,0,0,0,0,128,212,2,0,217,183,6,0,208,23,0,0,0,0,0,0,128,212,2,0,117,184,6,0,240,69,0,0,0,0,0,0,128,212,2,0,62,184,6,0,176,30,0,0,0,0,0,0,128,212,2,0,166,184,6,0,112,55,0,0,0,0,0,0,128,212,2,0,238,184,6,0,208,23,0,0,0,0,0,0,128,212,2,0,2,186,6,0,32,66,0,0,0,0,0,0,128,212,2,0,195,185,6,0,176,30,0,0,0,0,0,0,128,212,2,0,59,186,6,0,208,23,0,0,0,0,0,0,128,212,2,0,123,188,6,0,160,55,0,0,0,0,0,0,128,212,2,0,74,188,6,0,176,30,0,0,0,0,0,0,128,212,2,0,150,188,6,0,208,23,0,0,0,0,0,0,128,212,2,0,63,190,6,0,128,70,0,0,0,0,0,0,128,212,2,0,90,190,6,0,24,55,0,0,0,0,0,0,128,212,2,0,138,190,6,0,208,23,0,0,0,0,0,0,128,212,2,0,217,190,6,0,112,70,0,0,0,0,0,0,128,212,2,0,244,190,6,0,208,23,0,0,0,0,0,0,128,212,2,0,225,191,6,0,208,70,0,0,0,0,0,0,128,212,2,0,251,191,6,0,24,55,0,0,0,0,0,0,128,212,2,0,42,192,6,0,208,23,0,0,0,0,0,0,128,212,2,0,100,195,6,0,16,71,0,0,0,0,0,0,128,212,2,0,49,195,6,0,176,30,0,0,0,0,0,0,128,212,2,0,135,195,6,0,24,55,0,0,0,0,0,0,128,212,2,0,195,195,6,0,24,55,0,0,0,0,0,0,128,212,2,0,240,195,6,0,208,23,0,0,0,0,0,0,128,212,2,0,253,199,6,0,32,71,0,0,0,0,0,0,128,212,2,0,22,200,6,0,208,23,0,0,0,0,0,0,128,212,2,0,99,200,6,0,24,55,0,0,0,0,0,0,128,212,2,0,112,201,6,0,96,71,0,0,0,0,0,0,128,212,2,0,137,201,6,0,208,23,0,0,0,0,0,0,128,212,2,0,125,203,6,0,160,71,0,0,0,0,0,0,128,212,2,0,155,203,6,0,24,55,0,0,0,0,0,0,128,212,2,0,206,203,6,0,208,23,0,0,0,0,0,0,128,212,2,0,72,207,6,0,128,55,0,0,0,0,0,0,128,212,2,0,12,206,6,0,176,30,0,0,0,0,0,0,128,212,2,0,116,207,6,0,208,23,0,0,0,0,0,0,128,212,2,0,57,212,6,0,0,72,0,0,0,0,0,0,128,212,2,0,93,212,6,0,24,55,0,0,0,0,0,0,128,212,2,0,150,212,6,0,208,23,0,0,0,0,0,0,128,212,2,0,144,214,6,0,48,72,0,0,0,0,0,0,128,212,2,0,171,214,6,0,24,55,0,0,0,0,0,0,128,212,2,0,219,214,6,0,208,23,0,0,0,0,0,0,128,212,2,0,231,215,6,0,96,72,0,0,0,0,0,0,128,212,2,0,3,216,6,0,24,55,0,0,0,0,0,0,128,212,2,0,52,216,6,0,208,23,0,0,0,0,0,0,128,212,2,0,92,217,6,0,144,72,0,0,0,0,0,0,128,212,2,0,126,217,6,0,24,55,0,0,0,0,0,0,128,212,2,0,181,217,6,0,208,23,0,0,0,0,0,0,128,212,2,0,247,218,6,0,192,72,0,0,0,0,0,0,128,212,2,0,17,219,6,0,24,55,0,0,0,0,0,0,128,212,2,0,64,219,6,0,208,23,0,0,0,0,0,0,128,212,2,0,107,222,6,0,240,72,0,0,0,0,0,0,128,212,2,0,137,222,6,0,112,55,0,0,0,0,0,0,128,212,2,0,23,225,6,0,208,23,0,0,0,0,0,0,128,212,2,0,10,226,6,0,32,73,0,0,0,0,0,0,128,212,2,0,45,226,6,0,24,55,0,0,0,0,0,0,128,212,2,0,225,226,6,0,208,23,0,0,0,0,0,0,128,212,2,0,47,227,6,0,80,73,0,0,0,0,0,0,128,212,2,0,73,227,6,0,24,55,0,0,0,0,0,0,128,212,2,0,120,227,6,0,208,23,0,0,0,0,0,0,128,212,2,0,7,231,6,0,128,73,0,0,0,0,0,0,128,212,2,0,36,231,6,0,24,55,0,0,0,0,0,0,128,212,2,0,86,231,6,0,208,23,0,0,0,0,0,0,128,212,2,0,95,236,6,0,144,55,0,0,0,0,0,0,128,212,2,0,26,236,6,0,176,30,0,0,0,0,0,0,128,212,2,0,236,250,6,0,8,82,0,0,0,0,0,0,128,212,2,0,55,245,6,0,8,82,0,0,0,0,0,0,128,212,2,0,201,250,6,0,8,82,0,0,0,0,0,0,128,212,2,0,161,250,6,0,8,82,0,0,0,0,0,0,128,212,2,0,248,247,6,0,152,57,0,0,0,0,0,0,128,212,2,0,189,247,6,0,48,74,0,0,0,0,0,0,128,212,2,0,241,245,6,0,8,82,0,0,0,0,0,0,128,212,2,0,224,246,6,0,32,74,0,0,0,0,0,0,128,212,2,0,161,249,6,0,16,74,0,0,0,0,0,0,128,212,2,0,39,2,7,0,8,82,0,0,0,0,0,0,128,212,2,0,57,1,7,0,8,82,0,0,0,0,0,0,128,212,2,0,29,1,7,0,8,82,0,0,0,0,0,0,128,212,2,0,252,255,6,0,8,82,0,0,0,0,0,0,128,212,2,0,151,0,7,0,8,82,0,0,0,0,0,0,128,212,2,0,82,2,7,0,48,75,0,0,0,0,0,0,128,212,2,0,94,2,7,0,208,23,0,0,0,0,0,0,128,212,2,0,171,3,7,0,160,74,0,0,0,0,0,0,128,212,2,0,189,3,7,0,48,75,0,0,0,0,0,0,128,212,2,0,248,4,7,0,208,74,0,0,0,0,0,0,128,212,2,0,23,5,7,0,208,23,0,0,0,0,0,0,128,212,2,0,104,5,7,0,48,75,0,0,0,0,0,0,128,212,2,0,124,5,7,0,208,23,0,0,0,0,0,0,128,212,2,0,201,5,7,0,0,75,0,0,0,0,0,0,128,212,2,0,165,6,7,0,48,27,0,0,0,0,0,0,128,212,2,0,202,6,7,0,48,75,0,0,0,0,0,0,128,212,2,0,229,6,7,0,208,23,0,0,0,0,0,0,128,212,2,0,57,7,7,0,64,75,0,0,0,0,0,0,128,212,2,0,160,10,7,0,128,75,0,0,0,0,0,0,128,212,2,0,178,10,7,0,48,75,0,0,0,0,0,0,128,212,2,0,38,11,7,0,208,23,0,0,0,0,0,0,128,212,2,0,81,13,7,0,176,30,0,0,0,0,0,0,128,212,2,0,117,13,7,0,176,30,0,0,0,0,0,0,128,212,2,0,91,14,7,0,176,30,0,0,0,0,0,0,128,212,2,0,125,14,7,0,176,30,0,0,0,0,0,0,128,212,2,0,71,15,7,0,176,30,0,0,0,0,0,0,128,212,2,0,17,16,7,0,176,30,0,0,0,0,0,0,128,212,2,0,88,16,7,0,176,30,0,0,0,0,0,0,128,212,2,0,9,17,7,0,176,30,0,0,0,0,0,0,128,212,2,0,96,17,7,0,176,30,0,0,0,0,0,0,128,212,2,0,163,17,7,0,176,30,0,0,0,0,0,0,128,212,2,0,212,17,7,0,48,75,0,0,0,0,0,0,128,212,2,0,223,17,7,0,208,23,0,0,0,0,0,0,128,212,2,0,26,19,7,0,64,76,0,0,0,0,0,0,128,212,2,0,226,19,7,0,48,27,0,0,0,0,0,0,128,212,2,0,215,20,7,0,112,76,0,0,0,0,0,0,128,212,2,0,147,20,7,0,208,23,0,0,0,0,0,0,128,212,2,0,219,22,7,0,48,75,0,0,0,0,0,0,128,212,2,0,247,22,7,0,208,23,0,0,0,0,0,0,128,212,2,0,76,23,7,0,160,76,0,0,0,0,0,0,128,212,2,0,115,23,7,0,48,75,0,0,0,0,0,0,128,212,2,0,87,24,7,0,208,76,0,0,0,0,0,0,128,212,2,0,103,24,7,0,208,23,0,0,0,0,0,0,128,212,2,0,19,25,7,0,176,30,0,0,0,0,0,0,128,212,2,0,183,25,7,0,176,30,0,0,0,0,0,0,128,212,2,0,223,25,7,0,176,30,0,0,0,0,0,0,128,212,2,0,98,26,7,0,176,30,0,0,0,0,0,0,88,212,2,0,252,26,7,0,128,212,2,0,129,26,7,0,208,23,0,0,0,0,0,0,128,212,2,0,123,29,7,0,64,77,0,0,0,0,0,0,128,212,2,0,60,28,7,0,208,23,0,0,0,0,0,0,128,212,2,0,139,28,7,0,208,23,0,0,0,0,0,0,128,212,2,0,5,29,7,0,208,23,0,0,0,0,0,0,128,212,2,0,213,30,7,0,64,77,0,0,0,0,0,0,128,212,2,0,154,29,7,0,208,23,0,0,0,0,0,0,128,212,2,0,226,29,7,0,208,23,0,0,0,0,0,0,128,212,2,0,91,30,7,0,208,23,0,0,0,0,0,0,128,212,2,0,224,33,7,0,8,78,0,0,0,0,0,0,128,212,2,0,230,31,7,0,176,30,0,0,0,0,0,0,128,212,2,0,172,32,7,0,208,23,0,0,0,0,0,0,128,212,2,0,253,33,7,0,48,27,0,0,0,0,0,0,128,212,2,0,26,34,7,0,208,23,0,0,0,0,0,0,128,212,2,0,50,46,7,0,176,30,0,0,0,0,0,0,128,212,2,0,96,46,7,0,176,30,0,0,0,0,0,0,128,212,2,0,140,46,7,0,208,23,0,0,0,0,0,0,88,212,2,0,200,46,7,0,88,212,2,0,173,50,7,0,128,212,2,0,215,46,7,0,176,30,0,0,0,0,0,0,128,212,2,0,232,48,7,0,176,30,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,128,212,2,0,136,54,7,0,168,78,0,0,0,0,0,0,88,212,2,0,176,54,7,0,128,212,2,0,219,54,7,0,40,84,0,0,0,0,0,0,128,212,2,0,151,55,7,0,40,84,0,0,0,0,0,0,128,212,2,0,241,56,7,0,168,78,0,0,0,0,0,0,88,212,2,0,34,57,7,0,88,212,2,0,206,57,7,0,128,212,2,0,13,61,7,0,64,92,0,0,0,0,0,0,88,212,2,0,48,61,7,0,128,212,2,0,75,61,7,0,0,79,0,0,0,0,0,0,88,212,2,0,197,64,7,0,128,212,2,0,109,85,7,0,144,83,0,0,0,0,0,0,128,212,2,0,192,85,7,0,152,81,0,0,0,0,0,0,128,212,2,0,81,87,7,0,0,79,0,0,0,0,0,0,128,212,2,0,81,102,7,0,0,79,0,0,0,0,0,0,128,212,2,0,169,103,7,0,0,79,0,0,0,0,0,0,128,212,2,0,55,104,7,0,0,79,0,0,0,0,0,0,128,212,2,0,138,132,7,0,8,82,0,0,0,0,0,0,128,212,2,0,156,128,7,0,8,82,0,0,0,0,0,0,128,212,2,0,107,128,7,0,8,82,0,0,0,0,0,0,128,212,2,0,238,128,7,0,8,82,0,0,0,0,0,0,128,212,2,0,194,128,7,0,8,82,0,0,0,0,0,0,128,212,2,0,66,129,7,0,8,82,0,0,0,0,0,0,128,212,2,0,17,129,7,0,8,82,0,0,0,0,0,0,128,212,2,0,106,129,7,0,8,82,0,0,0,0,0,0,128,212,2,0,140,129,7],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([8,82,0,0,0,0,0,0,128,212,2,0,175,129,7,0,8,82,0,0,0,0,0,0,128,212,2,0,212,129,7,0,8,82,0,0,0,0,0,0,128,212,2,0,244,129,7,0,8,82,0,0,0,0,0,0,128,212,2,0,21,130,7,0,8,82,0,0,0,0,0,0,128,212,2,0,54,130,7,0,8,82,0,0,0,0,0,0,128,212,2,0,89,130,7,0,8,82,0,0,0,0,0,0,128,212,2,0,121,130,7,0,8,82,0,0,0,0,0,0,128,212,2,0,163,130,7,0,8,82,0,0,0,0,0,0,128,212,2,0,206,130,7,0,8,82,0,0,0,0,0,0,128,212,2,0,53,131,7,0,8,82,0,0,0,0,0,0,128,212,2,0,251,130,7,0,8,82,0,0,0,0,0,0,128,212,2,0,93,131,7,0,8,82,0,0,0,0,0,0,128,212,2,0,134,131,7,0,8,82,0,0,0,0,0,0,128,212,2,0,175,131,7,0,8,82,0,0,0,0,0,0,128,212,2,0,62,132,7,0,8,82,0,0,0,0,0,0,128,212,2,0,217,131,7,0,8,82,0,0,0,0,0,0,128,212,2,0,11,132,7,0,8,82,0,0,0,0,0,0,128,212,2,0,98,132,7,0,8,82,0,0,0,0,0,0,88,212,2,0,176,132,7,0,128,212,2,0,215,132,7,0,48,81,0,0,0,0,0,0,128,212,2,0,225,134,7,0,8,82,0,0,0,0,0,0,128,212,2,0,4,135,7,0,104,83,0,0,0,0,0,0,128,212,2,0,3,136,7,0,200,83,0,0,0,0,0,0,128,212,2,0,62,136,7,0,144,57,0,0,0,0,0,0,128,212,2,0,28,148,7,0,24,82,0,0,0,0,0,0,88,212,2,0,55,149,7,0,128,212,2,0,134,153,7,0,168,78,0,0,0,0,0,0,128,212,2,0,176,153,7,0,224,78,0,0,0,0,0,0,88,212,2,0,245,153,7,0,128,212,2,0,250,156,7,0,216,81,0,0,0,0,0,0,128,212,2,0,39,157,7,0,192,81,0,0,0,0,0,0,48,213,2,0,124,157,7,0,0,0,0,0,1,0,0,0,0,82,0,0,0,0,0,0,88,212,2,0,188,157,7,0,128,212,2,0,87,159,7,0,232,78,0,0,0,0,0,0,88,212,2,0,53,165,7,0,128,212,2,0,53,160,7,0,48,82,0,0,0,0,0,0,128,212,2,0,114,160,7,0,64,82,0,0,0,0,0,0,128,212,2,0,182,160,7,0,80,82,0,0,0,0,0,0,88,212,2,0,245,160,7,0,128,212,2,0,40,161,7,0,64,82,0,0,0,0,0,0,128,212,2,0,86,161,7,0,120,82,0,0,0,0,0,0,128,212,2,0,146,161,7,0,64,82,0,0,0,0,0,0,128,212,2,0,9,162,7,0,152,82,0,0,0,0,0,0,128,212,2,0,72,162,7,0,64,82,0,0,0,0,0,0,128,212,2,0,125,162,7,0,184,82,0,0,0,0,0,0,128,212,2,0,188,162,7,0,64,82,0,0,0,0,0,0,128,212,2,0,241,162,7,0,216,82,0,0,0,0,0,0,128,212,2,0,48,163,7,0,64,82,0,0,0,0,0,0,128,212,2,0,101,163,7,0,248,82,0,0,0,0,0,0,128,212,2,0,164,163,7,0,64,82,0,0,0,0,0,0,128,212,2,0,217,163,7,0,24,83,0,0,0,0,0,0,128,212,2,0,24,164,7,0,64,82,0,0,0,0,0,0,128,212,2,0,77,164,7,0,56,83,0,0,0,0,0,0,128,212,2,0,140,164,7,0,64,82,0,0,0,0,0,0,128,212,2,0,193,164,7,0,88,83,0,0,0,0,0,0,128,212,2,0,0,165,7,0,64,82,0,0,0,0,0,0,88,212,2,0,84,165,7,0,128,212,2,0,242,165,7,0,104,83,0,0,0,0,0,0,88,212,2,0,88,168,7,0,88,212,2,0,150,168,7,0,88,212,2,0,204,168,7,0,128,212,2,0,46,170,7,0,128,83,0,0,0,0,0,0,128,212,2,0,143,174,7,0,152,81,0,0,0,0,0,0,128,212,2,0,215,174,7,0,24,79,0,0,0,0,0,0,88,212,2,0,237,176,7,0,128,212,2,0,26,177,7,0,200,83,0,0,0,0,0,0,88,212,2,0,12,178,7,0,88,212,2,0,49,178,7,0,88,212,2,0,86,178,7,0,88,212,2,0,123,178,7,0,88,212,2,0,160,178,7,0,88,212,2,0,197,178,7,0,88,212,2,0,234,178,7,0,128,212,2,0,15,179,7,0,144,57,0,0,0,0,0,0,88,212,2,0,138,180,7,0,128,212,2,0,244,193,7,0,176,30,0,0,0,0,0,0,49,244,70,62,15,206,131,63,254,130,43,101,71,21,87,64,0,0,0,0,0,0,144,63,0,0,0,0,0,0,240,63,97,128,119,62,154,44,240,63,116,133,21,211,176,89,240,63,200,155,117,24,69,135,240,63,15,137,249,108,88,181,240,63,162,209,211,50,236,227,240,63,81,91,18,208,1,19,241,63,224,45,169,174,154,66,241,63,123,81,125,60,184,114,241,63,117,203,111,235,91,163,241,63,170,185,104,49,135,212,241,63,214,140,98,136,59,6,242,63,56,98,117,110,122,56,242,63,221,124,226,101,69,107,242,63,225,222,31,245,157,158,242,63,11,3,228,166,133,210,242,63,21,183,49,10,254,6,243,63,255,22,100,178,8,60,243,63,203,169,58,55,167,113,243,63,247,159,229,52,219,167,243,63,34,52,18,76,166,222,243,63,42,46,247,33,10,22,244,63,45,137,97,96,8,78,244,63,208,60,193,181,162,134,244,63,39,42,54,213,218,191,244,63,167,44,157,118,178,249,244,63,130,79,157,86,43,52,245,63,218,39,181,54,71,111,245,63,41,84,72,221,7,171,245,63,72,33,173,21,111,231,245,63,133,85,58,176,126,36,246,63,37,34,85,130,56,98,246,63,205,59,127,102,158,160,246,63,47,26,101,60,178,223,246,63,116,95,236,232,117,31,247,63,201,103,66,86,235,95,247,63,135,1,235,115,20,161,247,63,98,78,207,54,243,226,247,63,19,206,76,153,137,37,248,63,237,146,68,155,217,104,248,63,219,160,42,66,229,172,248,63,54,119,21,153,174,241,248,63,229,197,205,176,55,55,249,63,80,78,222,159,130,125,249,63,144,240,163,130,145,196,249,63,101,229,93,123,102,12,250,63,93,37,62,178,3,85,250,63,191,253,121,85,107,158,250,63,173,211,90,153,159,232,250,63,251,21,79,184,162,51,251,63,71,94,251,242,118,127,251,63,210,193,75,144,30,204,251,63,156,82,133,221,155,25,252,63,75,209,87,46,241,103,252,63,105,144,239,220,32,183,252,63,124,137,7,74,45,7,253,63,135,164,251,220,24,88,253,63,133,50,219,3,230,169,253,63,95,155,123,51,151,252,253,63,246,63,139,231,46,80,254,63,218,144,164,162,175,164,254,63,39,90,97,238,27,250,254,63,64,69,110,91,118,80,255,63,216,144,158,129,193,167,255,63,239,57,250,254,66,46,230,63,48,213,2,0,186,205,7,0,0,0,0,0,1,0,0,0,112,19,0,0,0,0,0,0,48,213,2,0,123,205,7,0,0,0,0,0,1,0,0,0,112,19,0,0,0,0,0,0,88,212,2,0,92,205,7,0,88,212,2,0,61,205,7,0,88,212,2,0,30,205,7,0,88,212,2,0,255,204,7,0,88,212,2,0,224,204,7,0,128,212,2,0,9,217,7,0,200,86,0,0,0,0,0,0,88,212,2,0,247,216,7,0,128,212,2,0,51,217,7,0,200,86,0,0,0,0,0,0,88,212,2,0,93,217,7,0,88,212,2,0,142,217,7,0,48,213,2,0,191,217,7,0,0,0,0,0,1,0,0,0,184,86,0,0,3,244,255,255,48,213,2,0,238,217,7,0,0,0,0,0,1,0,0,0,208,86,0,0,3,244,255,255,48,213,2,0,29,218,7,0,0,0,0,0,1,0,0,0,184,86,0,0,3,244,255,255,48,213,2,0,76,218,7,0,0,0,0,0,1,0,0,0,208,86,0,0,3,244,255,255,48,213,2,0,123,218,7,0,3,0,0,0,2,0,0,0,240,86,0,0,2,0,0,0,32,87,0,0,2,8,0,0,12,0,0,0,0,0,0,0,240,86,0,0,45,0,0,0,46,0,0,0,244,255,255,255,244,255,255,255,240,86,0,0,47,0,0,0,48,0,0,0,128,212,2,0,171,218,7,0,232,86,0,0,0,0,0,0,128,212,2,0,196,218,7,0,224,86,0,0,0,0,0,0,128,212,2,0,3,219,7,0,232,86,0,0,0,0,0,0,128,212,2,0,27,219,7,0,224,86,0,0,0,0,0,0,128,212,2,0,51,219,7,0,232,87,0,0,0,0,0,0,128,212,2,0,71,219,7,0,56,92,0,0,0,0,0,0,128,212,2,0,93,219,7,0,232,87,0,0,0,0,0,0,48,213,2,0,151,219,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,40,88,0,0,0,0,0,0,48,213,2,0,219,219,7,0,0,0,0,0,1,0,0,0,64,88,0,0,0,0,0,0,88,212,2,0,241,219,7,0,48,213,2,0,10,220,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,104,88,0,0,0,0,0,0,48,213,2,0,78,220,7,0,0,0,0,0,1,0,0,0,64,88,0,0,0,0,0,0,48,213,2,0,114,220,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,160,88,0,0,0,0,0,0,48,213,2,0,182,220,7,0,0,0,0,0,1,0,0,0,184,88,0,0,0,0,0,0,88,212,2,0,204,220,7,0,48,213,2,0,229,220,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,224,88,0,0,0,0,0,0,48,213,2,0,41,221,7,0,0,0,0,0,1,0,0,0,184,88,0,0,0,0,0,0,48,213,2,0,127,222,7,0,0,0,0,0,3,0,0,0,232,87,0,0,2,0,0,0,32,89,0,0,2,0,0,0,40,89,0,0,0,8,0,0,88,212,2,0,230,222,7,0,88,212,2,0,196,222,7,0,48,213,2,0,249,222,7,0,0,0,0,0,3,0,0,0,232,87,0,0,2,0,0,0,32,89,0,0,2,0,0,0,88,89,0,0,0,8,0,0,88,212,2,0,62,223,7,0,48,213,2,0,96,223,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,128,89,0,0,0,8,0,0,88,212,2,0,165,223,7,0,48,213,2,0,186,223,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,128,89,0,0,0,8,0,0,48,213,2,0,255,223,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,200,89,0,0,2,0,0,0,88,212,2,0,27,224,7,0,48,213,2,0,48,224,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,200,89,0,0,2,0,0,0,48,213,2,0,76,224,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,200,89,0,0,2,0,0,0,48,213,2,0,104,224,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,200,89,0,0,2,0,0,0,48,213,2,0,147,224,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,80,90,0,0,0,0,0,0,88,212,2,0,217,224,7,0,48,213,2,0,253,224,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,120,90,0,0,0,0,0,0,88,212,2,0,67,225,7,0,48,213,2,0,98,225,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,160,90,0,0,0,0,0,0,88,212,2,0,168,225,7,0,48,213,2,0,193,225,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,200,90,0,0,0,0,0,0,88,212,2,0,7,226,7,0,48,213,2,0,32,226,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,240,90,0,0,2,0,0,0,88,212,2,0,53,226,7,0,48,213,2,0,204,226,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,240,90,0,0,2,0,0,0,128,212,2,0,77,226,7,0,40,91,0,0,0,0,0,0,48,213,2,0,112,226,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,72,91,0,0,2,0,0,0,88,212,2,0,147,226,7,0,128,212,2,0,170,226,7,0,40,91,0,0,0,0,0,0,48,213,2,0,225,226,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,72,91,0,0,2,0,0,0,48,213,2,0,3,227,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,72,91,0,0,2,0,0,0,48,213,2,0,37,227,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,72,91,0,0,2,0,0,0,128,212,2,0,72,227,7,0,232,87,0,0,0,0,0,0,48,213,2,0,94,227,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,240,91,0,0,2,0,0,0,88,212,2,0,112,227,7,0,48,213,2,0,133,227,7,0,0,0,0,0,2,0,0,0,232,87,0,0,2,0,0,0,240,91,0,0,2,0,0,0,128,212,2,0,151,227,7,0,232,87,0,0,0,0,0,0,128,212,2,0,172,227,7,0,232,87,0,0,0,0,0,0,88,212,2,0,193,227,7,0,88,212,2,0,107,228,7,0,128,212,2,0,203,228,7,0,88,92,0,0,0,0,0,0,128,212,2,0,120,228,7,0,104,92,0,0,0,0,0,0,88,212,2,0,153,228,7,0,128,212,2,0,166,228,7,0,72,92,0,0,0,0,0,0,128,212,2,0,173,229,7,0,64,92,0,0,0,0,0,0,128,212,2,0,189,229,7,0,128,92,0,0,0,0,0,0,128,212,2,0,206,229,7,0,128,92,0,0,0,0,0,0,128,212,2,0,237,229,7,0,64,92,0,0,0,0,0,0,128,212,2,0,29,230,7,0,88,92,0,0,0,0,0,0,128,212,2,0,249,229,7,0,192,92,0,0,0,0,0,0,128,212,2,0,63,230,7,0,88,92,0,0,0,0,0,0,248,212,2,0,103,230,7,0,248,212,2,0,105,230,7,0,248,212,2,0,108,230,7,0,248,212,2,0,191,195,6,0,248,212,2,0,189,195,6,0,248,212,2,0,110,230,7,0,248,212,2,0,112,230,7,0,248,212,2,0,15,172,7,0,248,212,2,0,114,230,7,0,248,212,2,0,116,230,7,0,248,212,2,0,200,235,7,0,248,212,2,0,118,230,7,0,248,212,2,0,23,172,7,0,248,212,2,0,120,230,7,0,128,212,2,0,122,230,7,0,72,92,0,0,0,0,0,0,240,92,0,0,48,93,0,0,240,92,0,0,56,93,0,0,240,92,0,0,64,16,0,0,240,92,0,0,72,16,0,0,240,92,0,0,80,16,0,0,240,92,0,0,48,93,0,0,144,16,0,0,240,92,0,0,144,16,0,0,48,93,0,0,240,92,0,0,144,16,0,0,56,93,0,0,48,93,0,0,56,93,0,0,160,16,0,0,176,16,0,0,120,16,0,0,56,93,0,0,0,93,0,0,120,16,0,0,56,93,0,0,48,93,0,0,232,16,0,0,240,92,0,0,232,16,0,0,80,93,0,0,240,92,0,0,232,16,0,0,56,93,0,0,80,93,0,0,56,93,0,0,248,16,0,0,176,16,0,0,208,16,0,0,56,93,0,0,0,93,0,0,208,16,0,0,56,93,0,0,80,93,0,0,56,17,0,0,240,92,0,0,56,17,0,0,88,93,0,0,240,92,0,0,56,17,0,0,56,93,0,0,88,93,0,0,56,93,0,0,72,17,0,0,176,16,0,0,32,17,0,0,56,93,0,0,0,93,0,0,32,17,0,0,56,93,0,0,88,93,0,0,136,17,0,0,240,92,0,0,136,17,0,0,168,17,0,0,240,92,0,0,136,17,0,0,56,93,0,0,168,17,0,0,56,93,0,0,152,17,0,0,176,16,0,0,112,17,0,0,56,93,0,0,0,93,0,0,112,17,0,0,56,93,0,0,168,17,0,0,224,17,0,0,240,92,0,0,224,17,0,0,0,18,0,0,240,92,0,0,224,17,0,0,56,93,0,0,0,18,0,0,56,93,0,0,240,17,0,0,176,16,0,0,200,17,0,0,56,93,0,0,0,93,0,0,200,17,0,0,56,93,0,0,0,18,0,0,56,18,0,0,240,92,0,0,56,18,0,0,80,16,0,0,240,92,0,0,56,18,0,0,56,93,0,0,80,16,0,0,56,93,0,0,72,18,0,0,176,16,0,0,32,18,0,0,56,93,0,0,0,93,0,0,32,18,0,0,56,93,0,0,80,16,0,0,136,18,0,0,240,92,0,0,136,18,0,0,168,18,0,0,240,92,0,0,136,18,0,0,56,93,0,0,168,18,0,0,56,93,0,0,152,18,0,0,176,16,0,0,112,18,0,0,56,93,0,0,0,93,0,0,112,18,0,0,56,93,0,0,168,18,0,0,176,18,0,0,176,18,0,0,0,18,0,0,176,18,0,0,208,18,0,0,48,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,18,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,56,93,0,0,0,18,0,0,208,18,0,0,48,93,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,56,93,0,0,192,18,0,0,48,93,0,0,192,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,0,18,0,0,192,18,0,0,48,93,0,0,240,92,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,176,18,0,0,208,18,0,0,48,93,0,0,0,18,0,0,192,18,0,0,48,93,0,0,48,93,0,0,0,18,0,0,192,18,0,0,56,19,0,0,240,92,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,93,0,0,192,18,0,0,56,93,0,0,192,18,0,0,48,93,0,0,0,18,0,0,192,18,0,0,88,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,192,18,0,0,80,16,0,0,240,92,0,0,0,18,0,0,240,18,0,0,240,92,0,0,0,18,0,0,240,18,0,0,0,18,0,0,208,18,0,0,0,18,0,0,176,16,0,0,0,18,0,0,48,93,0,0,176,16,0,0,0,18,0,0,48,93,0,0,48,93,0,0,8,93,0,0,176,18,0,0,48,93,0,0,8,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,8,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,16,93,0,0,176,18,0,0,48,93,0,0,16,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,16,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,32,93,0,0,176,18,0,0,48,93,0,0,32,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,32,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,40,93,0,0,176,18,0,0,48,93,0,0,40,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,40,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,80,93,0,0,176,18,0,0,48,93,0,0,80,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,80,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,176,18,0,0,48,93,0,0,88,93,0,0,176,18,0,0,48,93,0,0,48,93,0,0,176,16,0,0,72,16,0,0,80,16,0,0,72,16,0,0,80,19,0,0,72,16,0,0,96,30,0,0,48,93,0,0,96,19,0,0,0,18,0,0,88,19,0,0,0,18,0,0,0,18,0,0,88,19,0,0,0,18,0,0,240,18,0,0,48,93,0,0,48,93,0,0,176,16,0,0,0,18,0,0,80,16,0,0,64,19,0,0,120,19,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,208,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,208,18,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,208,18,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,88,93,0,0,0,18,0,0,88,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,88,93,0,0,0,18,0,0,88,93,0,0,88,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,0,93,0,0,88,93,0,0,0,18,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,17,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,17,0,0,240,92,0,0,0,18,0,0,0,18,0,0,208,18,0,0,80,16,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,208,18,0,0,168,17,0,0,0,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,208,18,0,0,168,17,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,208,18,0,0,168,17,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,208,18,0,0,240,92,0,0,200,17,0,0,176,16,0,0,0,18,0,0,0,18,0,0,176,16,0,0,88,93,0,0,240,92,0,0,200,17,0,0,176,16,0,0,0,18,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,93,0,0,240,92,0,0,200,17,0,0,176,16,0,0,0,18,0,0,0,18,0,0,176,16,0,0,176,16,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,64,19,0,0,48,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,64,19,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,64,19,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,168,17,0,0,48,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,48,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,48,93,0,0,240,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,48,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,93,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,88,93,0,0,48,93,0,0,48,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,17,0,0,48,93,0,0,48,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,17,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,17,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,17,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,240,92,0,0,88,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,240,92,0,0,88,93,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,200,17,0,0,48,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,0,18,0,0,48,93,0,0,168,17,0,0,240,92,0,0,0,18,0,0,200,17,0,0,48,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,0,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,200,17,0,0,48,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,200,17,0,0,48,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,200,17,0,0,48,93,0,0,240,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,200,17,0,0,48,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,176,16,0,0,0,18,0,0,240,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,176,16,0,0,0,18,0,0,240,18,0,0,240,92,0,0,0,18,0,0,176,16,0,0,0,18,0,0,240,92,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,240,18,0,0,240,18,0,0,176,16,0,0,48,93,0,0,240,92,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,240,18,0,0,240,18,0,0,176,16,0,0,240,92,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,240,18,0,0,240,18,0,0,240,92,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,240,18,0,0,240,92,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,0,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,93,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,168,17,0,0,208,18,0,0,88,93,0,0,88,93,0,0,88,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,208,18,0,0,88,93,0,0,88,93,0,0,88,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,208,18,0,0,88,93,0,0,88,93,0,0,88,93,0,0,240,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,208,18,0,0,88,93,0,0,88,93,0,0,88,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,72,16,0,0,240,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,72,16,0,0,240,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,72,16,0,0,240,18,0,0,240,92,0,0,168,17,0,0,208,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,112,17,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,93,0,0,48,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,168,17,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,168,17,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,168,17,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,200,17,0,0,0,18,0,0,48,93,0,0,48,93,0,0,168,17,0,0,240,92,0,0,0,18,0,0,200,17,0,0,0,18,0,0,48,93,0,0,48,93,0,0,88,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,64,19,0,0,0,18,0,0,88,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,64,19,0,0,88,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,72,16,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,0,18,0,0,88,93,0,0,0,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,0,18,0,0,88,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,64,16,0,0,88,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,208,18,0,0,168,17,0,0,0,18,0,0,48,93,0,0,208,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,0,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,48,93,0,0,0,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,48,93,0,0,0,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,80,16,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,80,16,0,0,0,18,0,0,0,18,0,0,48,93,0,0,240,92,0,0,32,18,0,0,120,16,0,0,48,93,0,0,88,93,0,0,240,92,0,0,32,18,0,0,120,16,0,0,48,93,0,0,240,92,0,0,200,17,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,0,18,0,0,0,18,0,0,0,93,0,0,0,18,0,0,88,93,0,0,0,18,0,0,48,93,0,0,0,18,0,0,64,19,0,0,48,93,0,0,48,93,0,0,0,18,0,0,88,93,0,0,0,18,0,0,48,93,0,0,0,18,0,0,64,19,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,168,17,0,0,240,18,0,0,48,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,168,17,0,0,240,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,168,17,0,0,240,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,168,17,0,0,168,17,0,0,240,18,0,0,88,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,240,18,0,0,0,18,0,0,0,18,0,0,240,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,200,17,0,0,200,17,0,0,176,16,0,0,104,19,0,0,0,18,0,0,0,93,0,0,104,19,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,168,17,0,0,48,93,0,0,48,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,168,17,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,168,17,0,0,48,93,0,0,88,93,0,0,0,18,0,0,48,93,0,0,0,18,0,0,88,93,0,0,0,18,0,0,48,93,0,0,88,93,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,48,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,0,18,0,0,64,16,0,0,0,93,0,0,240,92,0,0,0,18,0,0,88,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,120,19,0,0,168,17,0,0,48,93,0,0,88,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,0,93,0,0,240,92,0,0,0,18,0,0,120,19,0,0,168,17,0,0,48,93,0,0,88,93,0,0,240,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,120,19,0,0,168,17,0,0,48,93,0,0,88,93,0,0,240,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,120,19,0,0,168,17,0,0,48,93,0,0,88,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,208,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,48,93,0,0,48,93,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,0,18,0,0,168,17,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,0,18,0,0,168,17,0,0,88,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,0,18,0,0,168,17,0,0,240,92,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,240,92,0,0,48,93,0,0,0,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,48,93,0,0,0,93,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,200,17,0,0,88,93,0,0,0,18,0,0,0,18,0,0,88,93,0,0,88,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,48,93,0,0,240,18,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,48,93,0,0,240,92,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,208,18,0,0,240,18,0,0,0,93,0,0,0,93,0,0,48,93,0,0,0,18,0,0,0,18,0,0,88,93,0,0,208,18,0,0,240,18,0,0,0,93,0,0,0,93,0,0,0,18,0,0,0,18,0,0,88,93,0,0,208,18,0,0,240,18,0,0,0,93,0,0,0,18,0,0,0,18,0,0,88,93,0,0,208,18,0,0,240,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,208,18,0,0,0,18,0,0,0,18,0,0,88,93,0,0,160,19,0,0,120,19,0,0,120,19,0,0,120,19,0,0,160,19,0,0,120,19,0,0,120,19,0,0,160,19,0,0,120,19,0,0,160,19,0,0,120,19,0,0,176,16,0,0,176,16,0,0,160,19,0,0,120,19,0,0,176,16,0,0,160,19,0,0,176,16,0,0,176,16,0,0,160,19,0,0,176,16,0,0,160,19,0,0,120,19,0,0,0,93,0,0,0,93,0,0,96,78,0,0,120,19,0,0,120,19,0,0,0,93,0,0,96,78,0,0,120,19,0,0,168,19,0,0,168,19,0,0,208,18,0,0,208,18,0,0,208,18,0,0,208,18,0,0,48,93,0,0,48,93,0,0,88,93,0,0,48,93,0,0,88,93,0,0,0,93,0,0,48,93,0,0,0,93,0,0,168,19,0,0,152,19,0,0,208,16,0,0,240,92,0,0,96,78,0,0,0,18,0,0,240,92,0,0,96,78,0,0,0,18,0,0,32,18,0,0,32,17,0,0,88,93,0,0,208,18,0,0,208,18,0,0,88,93],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20480);allocate([88,93,0,0,0,93,0,0,240,92,0,0,96,78,0,0,0,18,0,0,32,18,0,0,32,17,0,0,88,93,0,0,208,18,0,0,208,18,0,0,88,93,0,0,88,93,0,0,240,92,0,0,96,78,0,0,0,18,0,0,32,18,0,0,32,17,0,0,88,93,0,0,208,18,0,0,208,18,0,0,88,93,0,0,240,92,0,0,96,78,0,0,0,18,0,0,32,18,0,0,32,17,0,0,88,93,0,0,208,18,0,0,208,18,0,0,240,92,0,0,96,78,0,0,0,18,0,0,32,18,0,0,32,17,0,0,88,93,0,0,208,18,0,0,240,92,0,0,96,78,0,0,0,18,0,0,32,18,0,0,32,17,0,0,88,93,0,0,240,92,0,0,96,78,0,0,0,18,0,0,32,18,0,0,32,17,0,0,240,92,0,0,200,19,0,0,0,18,0,0,0,18,0,0,88,93,0,0,240,92,0,0,200,19,0,0,0,18,0,0,0,18,0,0,240,92,0,0,200,19,0,0,0,18,0,0,40,20,0,0,48,93,0,0,88,93,0,0,0,93,0,0,40,20,0,0,48,93,0,0,88,93,0,0,40,20,0,0,48,93,0,0,40,20,0,0,240,92,0,0,248,19,0,0,0,18,0,0,0,18,0,0,88,93,0,0,240,92,0,0,248,19,0,0,0,18,0,0,0,18,0,0,240,92,0,0,48,20,0,0,208,18,0,0,96,20,0,0,88,93,0,0,208,18,0,0,96,20,0,0,88,93,0,0,96,20,0,0,240,92,0,0,64,20,0,0,240,92,0,0,48,20,0,0,88,93,0,0,208,18,0,0,80,20,0,0,88,93,0,0,80,20,0,0,240,92,0,0,48,20,0,0,0,18,0,0,0,18,0,0,136,20,0,0,48,93,0,0,0,93,0,0,136,20,0,0,48,93,0,0,136,20,0,0,240,92,0,0,64,76,0,0,0,93,0,0,240,92,0,0,64,76,0,0,48,93,0,0,48,93,0,0,160,20,0,0,0,93,0,0,160,20,0,0,176,20,0,0,0,93,0,0,0,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,176,20,0,0,0,93,0,0,0,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,176,20,0,0,0,93,0,0,0,93,0,0,80,93,0,0,48,93,0,0,176,20,0,0,0,93,0,0,0,93,0,0,80,93,0,0,176,20,0,0,0,93,0,0,0,93,0,0,176,20,0,0,0,93,0,0,176,20,0,0,88,93,0,0,160,20,0,0,120,19,0,0,64,76,0,0,240,92,0,0,64,76,0,0,88,93,0,0,120,19,0,0,48,75,0,0,240,92,0,0,48,75,0,0,0,18,0,0,112,18,0,0,0,18,0,0,240,92,0,0,48,75,0,0,0,18,0,0,112,18,0,0,240,92,0,0,48,75,0,0,200,17,0,0,16,21,0,0,200,17,0,0,240,92,0,0,48,75,0,0,200,17,0,0,16,21,0,0,240,92,0,0,48,75,0,0,0,18,0,0,112,18,0,0,0,18,0,0,240,92,0,0,48,75,0,0,200,17,0,0,16,21,0,0,200,17,0,0,48,93,0,0,232,20,0,0,240,92,0,0,48,75,0,0,0,18,0,0,0,18,0,0,112,18,0,0,0,18,0,0,0,93,0,0,240,92,0,0,48,75,0,0,0,18,0,0,0,18,0,0,112,18,0,0,0,18,0,0,0,93,0,0,232,20,0,0,48,93,0,0,56,21,0,0,120,19,0,0,0,75,0,0,88,93,0,0,56,21,0,0,240,92,0,0,0,75,0,0,0,93,0,0,240,92,0,0,0,75,0,0,48,93,0,0,72,21,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,0,93,0,0,88,93,0,0,72,21,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,0,93,0,0,72,21,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,72,21,0,0,48,93,0,0,88,93,0,0,88,93,0,0,72,21,0,0,48,93,0,0,88,93,0,0,72,21,0,0,48,93,0,0,72,21,0,0,72,21,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,48,93,0,0,0,93,0,0,88,93,0,0,240,92,0,0,0,75,0,0,88,93,0,0,0,93,0,0,56,21,0,0,240,92,0,0,112,76,0,0,0,18,0,0,0,18,0,0,136,21,0,0,80,93,0,0,0,18,0,0,0,93,0,0,240,92,0,0,112,76,0,0,0,18,0,0,0,18,0,0,136,21,0,0,80,93,0,0,0,18,0,0,240,92,0,0,112,76,0,0,0,18,0,0,0,18,0,0,136,21,0,0,80,93,0,0,240,92,0,0,112,76,0,0,0,18,0,0,136,21,0,0,80,93,0,0,200,17,0,0,0,93,0,0,240,92,0,0,112,76,0,0,0,18,0,0,136,21,0,0,80,93,0,0,200,17,0,0,240,92,0,0,112,76,0,0,0,18,0,0,136,21,0,0,80,93,0,0,160,21,0,0,120,19,0,0,240,92,0,0,80,21,0,0,240,92,0,0,112,76,0,0,0,18,0,0,0,18,0,0,136,21,0,0,48,93,0,0,0,18,0,0,0,93,0,0,240,92,0,0,112,76,0,0,0,18,0,0,0,18,0,0,136,21,0,0,48,93,0,0,0,18,0,0,240,92,0,0,112,76,0,0,0,18,0,0,0,18,0,0,136,21,0,0,48,93,0,0,240,92,0,0,112,76,0,0,0,18,0,0,136,21,0,0,48,93,0,0,200,17,0,0,0,93,0,0,240,92,0,0,112,76,0,0,0,18,0,0,136,21,0,0,48,93,0,0,200,17,0,0,240,92,0,0,112,76,0,0,0,18,0,0,136,21,0,0,48,93,0,0,240,92,0,0,112,76,0,0,200,17,0,0,240,92,0,0,112,76,0,0,0,18,0,0,0,18,0,0,192,21,0,0,0,18,0,0,240,92,0,0,112,76,0,0,0,18,0,0,0,18,0,0,192,21,0,0,240,92,0,0,112,76,0,0,0,18,0,0,192,21,0,0,200,17,0,0,240,92,0,0,112,76,0,0,0,18,0,0,192,21,0,0,0,93,0,0,96,21,0,0,240,92,0,0,160,19,0,0,0,18,0,0,120,19,0,0,88,93,0,0,240,18,0,0,240,92,0,0,160,19,0,0,0,18,0,0,120,19,0,0,88,93,0,0,240,92,0,0,160,19,0,0,0,18,0,0,120,19,0,0,240,92,0,0,160,19,0,0,0,18,0,0,0,18,0,0,160,19,0,0,120,19,0,0,0,18,0,0,160,19,0,0,240,92,0,0,160,19,0,0,200,17,0,0,120,19,0,0,240,92,0,0,160,19,0,0,200,17,0,0,240,92,0,0,160,19,0,0,200,17,0,0,176,16,0,0,120,19,0,0,208,76,0,0,0,93,0,0,8,22,0,0,240,92,0,0,208,76,0,0,48,93,0,0,48,93,0,0,8,22,0,0,24,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,24,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,24,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,88,93,0,0,24,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,48,93,0,0,24,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,88,93,0,0,24,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,88,93,0,0,24,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,24,22,0,0,48,93,0,0,48,93,0,0,24,22,0,0,48,93,0,0,24,22,0,0,240,92,0,0,208,76,0,0,0,93,0,0,240,92,0,0,208,76,0,0,0,18,0,0,56,22,0,0,32,18,0,0,120,19,0,0,160,76,0,0,0,93,0,0,96,22,0,0,48,93,0,0,96,22,0,0,112,22,0,0,48,93,0,0,0,93,0,0,48,93,0,0,112,22,0,0,48,93,0,0,0,93,0,0,112,22,0,0,48,93,0,0,112,22,0,0,240,92,0,0,160,76,0,0,0,93,0,0,240,92,0,0,160,76,0,0,48,93,0,0,0,93,0,0,120,22,0,0,120,19,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,88,93,0,0,48,93,0,0,48,93,0,0,208,18,0,0,208,18,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,88,93,0,0,48,93,0,0,48,93,0,0,208,18,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,88,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,88,93,0,0,48,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,88,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,128,22,0,0,128,22,0,0,152,19,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,88,93,0,0,48,93,0,0,48,93,0,0,208,18,0,0,208,18,0,0,0,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,88,93,0,0,48,93,0,0,48,93,0,0,208,18,0,0,208,18,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,88,93,0,0,48,93,0,0,48,93,0,0,208,18,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,88,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,88,93,0,0,48,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,88,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,0,93,0,0,144,22,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,88,93,0,0,48,93,0,0,48,93,0,0,208,18,0,0,208,18,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,88,93,0,0,48,93,0,0,48,93,0,0,208,18,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,88,93,0,0,48,93,0,0,48,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,88,93,0,0,48,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,88,93,0,0,240,92,0,0,120,22,0,0,0,18,0,0,32,18,0,0,120,19,0,0,64,75,0,0,0,93,0,0,176,22,0,0,48,93,0,0,176,22,0,0,192,22,0,0,48,93,0,0,0,93,0,0,48,93,0,0,192,22,0,0,48,93,0,0,0,93,0,0,192,22,0,0,48,93,0,0,192,22,0,0,240,92,0,0,64,75,0,0,0,93,0,0,240,92,0,0,64,75,0,0,48,93,0,0,240,92,0,0,160,74,0,0,48,93,0,0,120,19,0,0,160,74,0,0,48,93,0,0,216,22,0,0,88,93,0,0,216,22,0,0,232,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,232,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,232,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,80,93,0,0,48,93,0,0,232,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,80,93,0,0,232,22,0,0,48,93,0,0,48,93,0,0,48,93,0,0,232,22,0,0,48,93,0,0,48,93,0,0,232,22,0,0,48,93,0,0,232,22,0,0,240,92,0,0,160,74,0,0,88,93,0,0,120,19,0,0,208,74,0,0,240,92,0,0,208,74,0,0,48,93,0,0,16,23,0,0,48,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,16,23,0,0,48,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,16,23,0,0,48,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,16,23,0,0,48,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,16,23,0,0,48,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,48,93,0,0,16,23,0,0,48,93,0,0,80,93,0,0,48,93,0,0,48,93,0,0,16,23,0,0,48,93,0,0,80,93,0,0,48,93,0,0,16,23,0,0,48,93,0,0,80,93,0,0,16,23,0,0,48,93,0,0,16,23,0,0,48,93,0,0,0,23,0,0,240,92,0,0,208,74,0,0,88,93,0,0,120,19,0,0,128,75,0,0,56,23,0,0,48,93,0,0,48,93,0,0,80,93,0,0,56,23,0,0,48,93,0,0,48,93,0,0,56,23,0,0,48,93,0,0,56,23,0,0,56,23,0,0,176,16,0,0,176,16,0,0,80,93,0,0,80,93,0,0,176,16,0,0,56,23,0,0,176,16,0,0,176,16,0,0,80,93,0,0,80,93,0,0,56,23,0,0,48,93,0,0,48,93,0,0,176,16,0,0,176,16,0,0,80,93,0,0,80,93,0,0,176,16,0,0,56,23,0,0,48,93,0,0,48,93,0,0,176,16,0,0,176,16,0,0,80,93,0,0,80,93,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,0,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,0,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,240,25,0,0,1,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,216,25,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,192,23,0,0,5,0,0,0,6,0,0,0,7,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,40,26,0,0,1,0,0,0,8,0,0,0,9,0,0,0,0,0,0,0,16,26,0,0,2,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,26,0,0,5,0,0,0,12,0,0,0,13,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,12,0,0,0,15,0,0,0,16,0,0,0,18,0,0,0,20,0,0,0,24,0,0,0,25,0,0,0,27,0,0,0,30,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,45,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,60,0,0,0,64,0,0,0,72,0,0,0,75,0,0,0,80,0,0,0,81,0,0,0,90,0,0,0,96,0,0,0,100,0,0,0,108,0,0,0,120,0,0,0,125,0,0,0,128,0,0,0,135,0,0,0,144,0,0,0,150,0,0,0,160,0,0,0,162,0,0,0,180,0,0,0,192,0,0,0,200,0,0,0,216,0,0,0,225,0,0,0,240,0,0,0,243,0,0,0,250,0,0,0,0,1,0,0,14,1,0,0,32,1,0,0,44,1,0,0,64,1,0,0,68,1,0,0,104,1,0,0,119,1,0,0,128,1,0,0,144,1,0,0,149,1,0,0,176,1,0,0,194,1,0,0,224,1,0,0,230,1,0,0,244,1,0,0,0,2,0,0,28,2,0,0,64,2,0,0,88,2,0,0,113,2,0,0,128,2,0,0,136,2,0,0,163,2,0,0,208,2,0,0,217,2,0,0,238,2,0,0,0,3,0,0,32,3,0,0,42,3,0,0,96,3,0,0,132,3,0,0,192,3,0,0,204,3,0,0,232,3,0,0,0,4,0,0,56,4,0,0,101,4,0,0,128,4,0,0,176,4,0,0,191,4,0,0,226,4,0,0,0,5,0,0,16,5,0,0,70,5,0,0,160,5,0,0,178,5,0,0,220,5,0,0,0,6,0,0,64,6,0,0,84,6,0,0,192,6,0,0,8,7,0,0,83,7,0,0,128,7,0,0,152,7,0,0,208,7,0,0,233,7,0,0,0,8,0,0,112,8,0,0,139,8,0,0,202,8,0,0,0,9,0,0,96,9,0,0,126,9,0,0,196,9,0,0,0,10,0,0,32,10,0,0,140,10,0,0,64,11,0,0,100,11,0,0,184,11,0,0,0,12,0,0,53,12,0,0,128,12,0,0,168,12,0,0,47,13,0,0,128,13,0,0,16,14,0,0,61,14,0,0,166,14,0,0,0,15,0,0,48,15,0,0,160,15,0,0,210,15,0,0,0,16,0,0,224,16,0,0,22,17,0,0,148,17,0,0,0,18,0,0,192,18,0,0,252,18,0,0,136,19,0,0,0,20,0,0,64,20,0,0,24,21,0,0,249,21,0,0,128,22,0,0,200,22,0,0,112,23,0,0,187,23,0,0,0,24,0,0,106,24,0,0,0,25,0,0,80,25,0,0,161,25,0,0,94,26,0,0,0,27,0,0,32,28,0,0,122,28,0,0,76,29,0,0,0,30,0,0,96,30,0,0,64,31,0,0,164,31,0,0,0,32,0,0,192,33,0,0,44,34,0,0,40,35,0,0,0,36,0,0,159,36,0,0,128,37,0,0,248,37,0,0,16,39,0,0,141,39,0,0,0,40,0,0,128,40,0,0,48,42,0,0,183,42,0,0,242,43,0,0,0,45,0,0,144,45,0,0,224,46,0,0,118,47,0,0,0,48,0,0,212,48,0,0,0,50,0,0,160,50,0,0,66,51,0,0,188,52,0,0,0,54,0,0,64,56,0,0,244,56,0,0,152,58,0,0,0,60,0,0,192,60,0,0,9,61,0,0,128,62,0,0,72,63,0,0,0,64,0,0,235,65,0,0,128,67,0,0,88,68,0,0,80,70,0,0,49,71,0,0,0,72,0,0,62,73,0,0,0,75,0,0,240,75,0,0,227,76,0,0,32,78,0,0,26,79,0,0,0,80,0,0,0,81,0,0,96,84,0,0,110,85,0,0,228,87,0,0,0,90,0,0,32,91,0,0,192,93,0,0,236,94,0,0,0,96,0,0,168,97,0,0,0,100,0,0,64,101,0,0,132,102,0,0,120,105,0,0,0,108,0,0,221,109,0,0,128,112,0,0,232,113,0,0,48,117,0,0,167,118,0,0,0,120,0,0,128,121,0,0,18,122,0,0,0,125,0,0,144,126,0,0,0,128,0,0,37,128,0,0,214,131,0,0,0,135,0,0,176,136,0,0,160,140,0,0,98,142,0,0,0,144,0,0,124,146,0,0,0,150,0,0,224,151,0,0,198,153,0,0,64,156,0,0,52,158,0,0,0,160,0,0,0,162,0,0,192,168,0,0,220,170,0,0,200,175,0,0,0,180,0,0,64,182,0,0,27,183,0,0,128,187,0,0,216,189,0,0,0,192,0,0,80,195,0,0,193,197,0,0,0,200,0,0,128,202,0,0,8,205,0,0,240,210,0,0,147,213,0,0,0,216,0,0,186,219,0,0,0,225,0,0,208,227,0,0,169,230,0,0,96,234,0,0,78,237,0,0,0,240,0,0,0,243,0,0,36,244,0,0,0,250,0,0,32,253,0,0,0,0,1,0,74,0,1,0,172,7,1,0,0,14,1,0,96,17,1,0,64,25,1,0,196,28,1,0,0,32,1,0,248,36,1,0,0,44,1,0,192,47,1,0,45,49,1,0,140,51,1,0,128,56,1,0,104,60,1,0,0,64,1,0,0,68,1,0,151,73,1,0,128,81,1,0,184,85,1,0,144,95,1,0,245,99,1,0,0,104,1,0,128,108,1,0,54,110,1,0,0,119,1,0,176,123,1,0,0,128,1,0,111,128,1,0,160,134,1,0,130,139,1,0,0,144,1,0,0,149,1,0,16,154,1,0,224,165,1,0,38,171,1,0,0,176,1,0,116,183,1,0,0,194,1,0,160,199,1,0,82,205,1,0,192,212,1,0,156,218,1,0,0,224,1,0,0,230,1,0,72,232,1,0,0,244,1,0,64,250,1,0,0,0,2,0,148,0,2,0,88,15,2,0,0,28,2,0,192,34,2,0,81,37,2,0,128,50,2,0,136,57,2,0,0,64,2,0,240,73,2,0,67,81,2,0,0,88,2,0,128,95,2,0,90,98,2,0,24,103,2,0,0,113,2,0,208,120,2,0,0,128,2,0,185,128,2,0,0,136,2,0,46,147,2,0,0,163,2,0,112,171,2,0,251,179,2,0,32,191,2,0,234,199,2,0,0,208,2,0,0,217,2,0,108,220,2,0,0,238,2,0,96,247,2,0,0,0,3,0,222,0,3,0,64,13,3,0,4,23,3,0,0,32,3,0,0,42,3,0,32,52,3,0,192,75,3,0,76,86,3,0,0,96,3,0,232,110,3,0,0,132,3,0,64,143,3,0,135,147,3,0,164,154,3,0,128,169,3,0,56,181,3,0,0,192,3,0,0,204,3,0,144,208,3,0,197,220,3,0,0,232,3,0,128,244,3,0,0,0,4,0,40,1,4,0,176,30,4,0,223,43,4,0,0,56,4,0,128,69,4,0,162,74,4,0,0,101,4,0,16,115,4,0,0,128,4,0,77,129,4,0,224,147,4,0,134,162,4,0,0,176,4,0,0,191,4,0,180,196,4,0,48,206,4,0,0,226,4,0,160,241,4,0,0,0,5,0,114,1,5,0,0,16,5,0,92,38,5,0,0,70,5,0,224,86,5,0,246,103,5,0,64,126,5,0,212,143,5,0,0,160,5,0,0,178,5,0,216,184,5,0,0,220,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,0,128,26,6,0,8,46,6,0,0,64,6,0,0,84,6,0,64,104,6,0,243,111,6,0,128,151,6,0,152,172,6,0,0,192,6,0,208,221,6,0,201,243,6,0,0,8,7,0,128,30,7,0,14,39,7,0,72,53,7,0,0,83,7,0,112,106,7,0,0,128,7,0,43,130,7,0,0,152,7,0,32,161,7,0,138,185,7,0,0,208,7,0,0,233,7,0,0,0,8,0,80,2,8,0,241,27,8,0,96,61,8,0,190,87,8,0,0,112,8,0,0,139,8,0,68,149,8,0,0,202,8,0,32,230,8,0,0,0,9,0,154,2,9,0,192,39,9,0,12,69,9,0,0,96,9,0,0,126,9,0,104,137,9,0,96,156,9,0,0,196,9,0,64,227,9,0,0,0,10,0,228,2,10,0,0,32,10,0,184,76,10,0,0,140,10,0,192,173,10,0,149,186,10,0,236,207,10,0,128,252,10,0,168,31,11,0,0,64,11,0,0,100,11,0,176,113,11,0,79,150,11,0,0,184,11,0,128,221,11,0,194,235,11,0,0,0,12,0,120,3,12,0,0,53,12,0,16,92,12,0,0,128,12,0,157,131,12,0,0,168,12,0,128,208,12,0,230,223,12,0,0,47,13,0,48,89,13,0,0,128,13,0,231,131,13,0,160,187,13,0,146,231,13,0,0,16,14,0,0,61,14,0,28,78,14,0,144,106,14,0,0,166,14,0,224,212,14,0,0,0,15,0,86,4,15,0,0,48,15,0,64,66,15,0,20,115,15,0,0,160,15,0,0,210,15,0,0,0,16,0,160,4,16,0,226,55,16,0,192,122,16,0,124,175,16,0,0,224,16,0,0,22,17,0,136,42,17,0,0,148,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,0,128,79,18,0,24,138,18,0,0,192,18,0,0,252,18,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,0,128,198,19,0,0,0,20,0,200,5,20,0,0,64,20,0,112,153,20,0,91,219,20,0,0,24,21,0,128,91,21,0,42,117,21,0,216,159,21,0,0,249,21,0,80,63,22,0,0,128,22,0,129,134,22,0,0,200,22,0,96,227,22,0,158,44,23,0,0,112,23,0,0,187,23,0,132,215,23,0,0,0,24,0,240,6,24,0,211,83,24,0,0,106,24,0,32,184,24,0,0,0,25,0,58,7,25,0,0,80,25,0,0,161,25,0,204,191,25,0,0,94,26,0,96,178,26,0,0,0,27,0,206,7,27,0,64,119,27,0,36,207,27,0,0,32,28,0,0,122,28,0,56,156,28,0,32,213,28,0,0,76,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,0,0,96,30,0,128,132,30,0,40,230,30,0,0,64,31,0,0,164,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,0,128,245,32,0,248,94,33,0,0,192,33,0,0,44,34,0,16,85,34,0,237,194,34,0,0,40,35,0,128,152,35,0,70,195,35,0,0,0,36,0,104,10,36,0,0,159,36,0,48,20,37,0,0,128,37,0,215,138,37,0,0,248,37,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,0,0,141,39,0,0,0,40,0,144,11,40,0,0,128,40,0,181,139,40,0,224,50,41,0,182,182,41,0,0,48,42,0,0,183,42,0,84,234,42,0,176,63,43,0,0,242,43,0,160,126,44,0,0,0,45,0,2,13,45,0,0,144,45,0,192,198,45,0,60,89,46,0,0,224,46,0,0,118,47,0,8,175,47,0,0,0,48,0,224,13,48,0,166,167,48,0,0,212,48,0,64,112,49,0,0,0,50,0,116,14,50,0,0,160,50,0,0,66,51,0,152,127,51,0,0,188,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,0,128,238,54,0,72,158,55,0,0,64,56,0,0,244,56,0,112,56,57,0,64,170,57,0,139,239,57,0,0,152,58,0,128,83,59,0,202,154,59,0,0,0,60,0,88,17,60,0,0,192,60,0,0,9,61,0,80,204,61,0,0,128,62,0,17,146,62,0,0,72,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,0,0,235,65,0,240,189,66,0,0,128,67,0,131,147,67,0,0,88,68,0,32,170,68,0,218,133,69,0,0,80,70,0,0,49,71,0,140,134,71,0,0,0,72,0,208,20,72,0,121,251,72,0,0,62,73,0,96,40,74,0,0,0,75,0,174,21,75,0,0,240,75,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,0,0,26,79,0,0,0,80,0,32,23,80,0,0,0,81,0,106,23,81,0,192,101,82,0,108,109,83,0,0,96,84,0,0,110,85,0,168,212,85,0,96,127,86,0,0,228,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,0,0,32,91,0,128,141,91,0,120,178,92,0,0,192,93,0,0,236,94,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,0,128,224,98,0,0,0,100,0,232,28,100,0,0,64,101,0,0,132,102,0,48,255,102,0,199,72,104,0,0,120,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,0,0,221,109,0,144,60,111,0,0,128,112,0,133,160,112,0,0,232,113,0,224,112,114,0,128,84,115,0,22,223,115,0,0,48,117,0,0,167,118,0,148,53,119,0,0,0,120,0,176,34,120,0,0,128,121,0,31,163,121,0,0,18,122,0,160,152,123,0,0,0,125,0,34,36,125,0,0,144,126,0,0,0,128,0,0,37,128,0,252,190,128,0,16,191,129,0,0,214,131,0,224,123,133,0,0,0,135,0,6,39,135,0,0,176,136,0,64,84,137,0,180,11,139,0,0,160,140,0,0,98,142,0,24,13,143,0,0,0,144,0,160,41,144,0,242,246,145,0,0,124,146,0,192,80,148,0,249,2,149,0,0,0,150,0,92,43,150,0,0,224,151,0,128,150,152,0,0,198,153,0,200,126,154,0,0,64,156,0,0,52,158,0,0,0,160,0,64,46,160,0,187,238,160,0,0,0,162,0,212,46,162,0,128,203,164,0,216,218,166,0,0,192,168,0,0,220,170,0,80,169,171,0,192,254,172,0,161,206,173,0,0,200,175,0,128,250,177,0,94,208,178,0,0,0,180,0,8,52,180,0,0,64,182,0,0,27,183,0,240,100,185,0,0,128,187,0,51,182,187,0,0,216,189,0,32,188,190,0,0,0,192,0,128,55,192,0,122,30,193,0,152,158,194,0,0,80,195,0,0,193,197,0,0,0,200,0,208,57,200,0,0,128,202,0,137,186,202,0,0,8,205,0,96,254,205,0,142,145,208,0,0,240,210,0,0,147,213,0,164,147,214,0,0,0,216,0,112,62,216,0,0,186,219,0,32,121,222,0,0,0,225,0,10,65,225,0,0,208,227,0,192,225,228,0,0,169,230,0,44,190,231,0,0,96,234,0,0,78,237,0,40,107,238,0,0,0,240,0,96,69,240,0,0,0,243,0,62,70,243,0,0,36,244,0,64,49,247,0,0,0,250,0,68,72,250,0,0,32,253,0,0,0,0,1,0,74,0,1,248,125,1,1,32,126,3,1,0,172,7,1,192,247,10,1,141,56,12,1,0,0,14,1,12,78,14,1,0,96,17,1,128,168,18,1,104,23,22,1,0,64,25,1,0,196,28,1,48,26,30,1,0,0,32,1,64,83,32,1,183,173,33,1,228,237,35,1,0,248,36,1,128,161,40,1,242,5,42,1,0,0,44,1,184,86,44,1,0,192,47,1,0,45,49,1,0,140,51,1,144,253,52,1,0,128,56,1,85,218,56,1,0,104,60,1,0,0,64,1,128,92,64,1,118,221,65,1,0,0,68,1,168,93,68,1,0,151,73,1,176,181,77,1,0,128,81,1,143,225,81,1,0,184,85,1,160,82,87,1,128,253,89,1,66,157,91,1,0,144,95,1,0,245,99,1,188,160,101,1,0,0,104,1,16,104,104,1,0,128,108,1,93,233,108,1,0,54,110,1,224,201,114,1,0,0,119,1,102,108,119,1,0,176,123,1,64,120,125,1,0,0,128,1,0,111,128,1,244,60,130,1,48,61,133,1,0,160,134,1,0,130,139,1,0,0,144,1,160,115,144,1,0,0,149,1,18,117,149,1,0,16,154,1,192,252,155,1,28,35,161,1,0,224,165,1,0,38,171,1,72,39,173,1,0,0,176,1,224,124,176,1,0,116,183,1,64,242,188,1,235,8,191,1,0,0,194,1,20,130,194,1,0,160,199,1,128,195,201,1,0,82,205,1,88,124,207,1,0,192,212,1,0,156,218,1,80,214,220,1,0,0,224,1,192,138,224,1,49,204,226,1,0,0,230,1,124,140,230,1,0,72,232,1,128,98,238,1,0,0,244,1,136,144,244,1,0,64,250,1,0,0,0,2,0,148,0,2,240,251,2,2,64,252,6,2,227,107,9,2,0,88,15,2,128,239,21,2,26,113,24,2,0,0,28,2,24,156,28,2,0,192,34,2,0,81,37,2,208,46,44,2,0,128,50,2,153,34,51,2,0,136,57,2,96,52,60,2,0,0,64,2,128,166,64,2,110,91,67,2,200,219,71,2,0,240,73,2,0,67,81,2,228,11,84,2,0,0,88,2,112,173,88,2,0,128,95,2,155,47,96,2,0,90,98,2,0,24,103,2,32,251,105,2,0,0,113,2,170,180,113,2,0,208,120,2,0,0,128,2,0,185,128,2,236,186,131,2,0,0,136,2,80,187,136,2,0,46,147,2,96,107,155,2,0,0,163,2,30,195,163,2,0,112,171,2,64,165,174,2,0,251,179,2,132,58,183,2,0,32,191,2,0,234,199,2,120,65,203,2,0,0,208,2,32,208,208,2,0,0,217,2,186,210,217,2,0,108,220,2,192,147,229,2,221,14,233,2,0,0,238,2,204,216,238,2,0,96,247,2,128,240,250,2,0,0,0,3,0,222,0,3,232,121,4,3,96,122,10,3,0,64,13,3,0,4,23,3,0,0,32,3,64,231,32,3,167,169,36,3,0,0,42,3,36,234,42,3,0,32,52,3,128,249,55,3,56,70,66,3,0,192,75,3,0,76,86,3,144,78,90,3,0,0,96,3,192,249,96,3,37,9,101,3,0,232,110,3,128,228,121,3,214,17,126,3,0,0,132,3,40,4,133,3,0,64,143,3,0,135,147,3,0,164,154,3,176,248,158,3,0,128,169,3,255,142,170,3,0,56,181,3,160,172,185,3,0,0,192,3,128,21,193,3,98,152,197,3,0,0,204,3,248,24,205,3,0,144,208,3,0,197,220,3,0,0,232,3,16,33,233,3,0,128,244,3,173,164,245,3,0,0,0,4,0,40,1,4,224,247,5,4,128,248,13,4,198,215,18,4,0,176,30,4,0,223,43,4,52,226,48,4,0,0,56,4,48,56,57,4,0,128,69,4,0,162,74,4,160,93,88,4,0,0,101,4,50,69,102,4,0,16,115,4,192,104,120,4,0,0,128,4,0,77,129,4,220,182,134,4,144,183,143,4,0,224,147,4,0,134,162,4,200,23,168,4,0,0,176,4,224,90,177,4,0,0,191,4,54,95,192,4,0,180,196,4,0,48,206,4,64,246,211,4,0,0,226,4,84,105,227,4,0,160,241,4,0,0,0,5,0,114,1,5,216,117,7,5,0,0,16,5,160,118,17,5,0,92,38,5,192,214,54,5,193,26,61,5,0,0,70,5,60,134,71,5,0,224,86,5,128,74,93,5,0,246,103,5,8,117,110,5,0,64,126,5,0,212,143,5,240,130,150,5,0,0,160,5,64,160,161,5,147,100,168,5,0,0,178,5,116,165,179,5,0,216,184,5,128,39,203,5,186,29,210,5,0,0,220,5,152,177,221,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,208,243,8,6,192,244,20,6,0,128,26,6,169,67,28,6,0,8,46,6,0,0,64,6,128,206,65,6,78,83,73,6,0,0,84,6,72,212,85,6,0,64,104,6,0,243,111,6,112,140,132,6,0,128,151,6,203,103,153,6,0,152,172,6,32,157,180,6,0,0,192,6,128,243,193,6,74,18,202,6,0,208,221,6,0,201,243,6,172,35,252,6,0,0,8,7,80,8,10,7,0,128,30,7,209,142,32,7,0,14,39,7,0,72,53,7,96,241,61,7,0,0,83,7,254,29,85,7,0,112,106,7,64,89,115,7,0,0,128,7,0,43,130,7,196,48,139,7,0,0,152,7,240,49,154,7,0,32,161,7,0,138,185,7,0,0,208,7,32,66,210,7,0,0,233,7,90,73,235,7,0,0,0,8,0,80,2,8,192,239,11,8,0,241,27,8,140,175,37,8,0,96,61,8,0,190,87,8,104,196,97,8,0,0,112,8,96,112,114,8,0,0,139,8,0,68,149,8,64,187,176,8,151,44,187,8,0,0,202,8,100,138,204,8,0,32,230,8,128,209,240,8,0,0,0,9,0,154,2,9,184,109,13,9,32,111,31,9,0,192,39,9,0,12,69,9,144,47,80,9,0,0,96,9,192,181,98,9,245,252,109,9,0,0,126,9,108,190,128,9,0,104,137,9,0,96,156,9,128,236,167,9,0,0,196,9,168,210,198,9,0,64,227,9,0,0,0,10,0,228,2,10,176,235,14,10,0,0,32,10,64,237,34,10,111,27,47,10,0,184,76,10,128,173,109,10,130,53,122,10,0,0,140,10,120,12,143,10,0,192,173,10,0,149,186,10,0,236,207,10,16,234,220,10,0,128,252,10,253,172,255,10,0,168,31,11,224,5,45,11,0,0,64,11,128,64,67,11,38,201,80,11,0,0,100,11,232,74,103,11,0,176,113,11,0,79,150,11,116,59,164,11,0,0,184,11,48,99,187,11,0,128,221,11,7,238,224,11,0,194,235,11,0,0,0,12,0,120,3,12,160,231,17,12,128,233,41,12,0,0,53,12,82,135,56,12,0,16,92,12,0,0,128,12,0,157,131,12,156,166,146,12,0,0,168,12,144,168,171,12,0,128,208,12,0,230,223,12,224,24,9,13,0,0,47,13,150,207,50,13,0,48,89,13,64,58,105,13,0,0,128,13,0,231,131,13,148,36,148,13,0,160,187,13,0,146,231,13,88,71,248,13,0,0,16,14,160,16,20,14,0,0,61,14,162,29,65,14,0,28,78,14,0,144,106,14,192,226,123,14,81,74,141,14,0,0,166,14,252,59,170,14,0,224,212,14,128,178,230,14,0,0,0,15,0,86,4,15,136,97,22,15,0,0,48,15,224,99,52,15,0,64,66,15,0,20,115,15,0,0,160,15,64,132,164,15,67,80,183,15,0,0,210,15,180,146,214,15,0,0,0,16,0,160,4,16,128,223,23,16,0,226,55,16,24,95,75,16,0,192,122,16,0,124,175,16,208,136,195,16,0,0,224,16,192,224,228,16,185,45,249,16,0,0,22,17,0,136,42,17,128,118,97,17,46,89,118,17,0,0,148,17,200,20,153,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,112,219,26,18,64,222,62,18,0,128,79,18,251,202,84,18,0,24,138,18,32,95,160,18,0,0,192,18,128,107,197,18,234,249,219,18,0,0,252,18,216,124,1,19,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,80,165,141,19,0,128,198,19,97,55,204,19,0,0,0,20,0,200,5,20,96,215,29,20,0,0,64,20,128,218,69,20,222,54,94,20,0,112,153,20,0,91,219,20,4,107,244,20,0,0,24,21,240,24,30,21,0,128,91,21,0,42,117,21,0,216,159,21,32,212,185,21,0,0,249,21,250,89,255,21,0,80,63,22,192,11,90,22,0,0,128,22,0,129,134,22,76,146,161,22,0,0,200,22,208,149,206,22,0,96,227,22,0,158,44,23,232,118,72,23,0,0,112,23,96,198,118,23,0,0,187,23,14,220,193,23,0,132,215,23,0,0,0,24,0,240,6,24,64,207,35,24,0,211,83,24,0,0,106,24,164,14,113,24,0,32,184,24,0,0,0,25,0,58,7,25,56,77,37,25,0,0,80,25,32,81,87,25,0,0,161,25,0,204,191,25,192,49,18,26,197,133,49,26,0,0,94,26,44,159,101,26,0,96,178,26,128,116,210,26,0,0,0,27,0,206,7,27,40,73,40,27,0,64,119,27,0,36,207,27,176,142,240,27,0,0,32,28,64,33,40,28,223,246,73,28,0,0,122,28,68,59,130,28,0,56,156,28,0,32,213,28,128,197,247,28,162,148,26,29,0,0,76,29,248,119,84,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,16,195,44,30,0,0,96,30,192,199,104,30,0,128,132,30,77,82,141,30,0,40,230,30,0,0,64,31,128,8,73,31,134,160,110,31,0,0,164,31,104,37,173,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,48,190,150,32,0,128,245,32,247,6,255,32,0,248,94,33,160,17,135,33,0,0,192,33,128,193,201,33,114,91,242,33,0,0,44,34,0,16,85,34,0,237,194,34,92,178,236,34,0,0,40,35,144,41,50,35,0,128,152,35,21,202,162,35,0,70,195,35,0,0,0,36,0,104,10,36,224,182,53,36,128,188,125,36,0,0,159,36,246,149,169,36,0,48,20,37,64,190,64,37,0,0,128,37,0,215,138,37,212,243,183,37,0,0,248,37,176,249,2,38,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,160,74,27,39,0,0,141,39,194,110,152,39,0,0,0,40,0,144,11,40,192,174,59,40,0,0,128,40,0,181,139,40,188,109,188,40,0,224,50,41,0,182,182,41,8,214,232,41,0,0,48,42,224,49,60,42,0,0,183,42,0,84,234,42,0,176,63,43,64,168,115,43,243,222,167,43,0,0,242,43,244,179,254,43,0,160,126,44,128,23,180,44,0,0,0,45,0,2,13,45,152,36,67,45,0,0,144,45,160,43,157,45,0,192,198,45,0,60,89,46,208,237,144,46,0,0,224,46,192,140,237,46,201,240,37,47,0,0,118,47,28,184,131,47,0,8,175,47,0,0,0,48,0,224,13,48,128,158,71,48,0,166,167,48,0,0,212,48,72,29,226,48,0,64,112,49,0,0,0,50,0,116,14,50,112,154,74,50,0,0,160,50,64,162,174,50,43,137,235,50,0,0,66,51,0,152,127,51,128,99,36,52,138,11,99,52,0,0,188,52,88,62,203,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,80,146,80,54,0,128,238,54,241,96,254,54,0,72,158,55,96,29,225,55,0,0,64,56,128,66,80,56,190,237,147,56,0,0,244,56,136,118,4,57,0,112,56,57,0,64,170,57,0,139,239,57,68,41,53,58,0,0,152,58,240,239,168,58,0,128,83,59,35,166,100,59,0,202,154,59,0,0,0,60,0,88,17,60,32,134,89,60,0,0,192,60,128,143,209,60,0,0,9,61,154,164,26,61,0,80,204,61,0,0,128,62,0,17,146,62,12,65,221,62,0,0,72,63,208,74,90,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,96,124,45,65,0,0,235,65,238,13,254,65,0,240,189,66,64,35,14,67,0,0,128,67,0,131,147,67,228,182,228,67,0,0,88,68,0,32,170,68,0,218,133,69,184,100,217,69,0,0,80,70,32,83,100,70,0,0,49,71,42,148,69,71,0,140,134,71,0,0,0,72,0,208,20,72,192,109,107,72,149,115,194,72,0,121,251,72,0,0,62,73,236,43,83,73,0,96,40,74,128,124,129,74,0,0,0,75,0,174,21,75,168,231,111,75,0,0,240,75],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+30720);allocate([96,243,5,76,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,64,149,54,78,79,145,148,78,0,0,26,79,132,221,48,79,0,0,0,80,0,32,23,80,128,93,119,80,0,0,0,81,0,106,23,81,120,219,120,81,0,192,101,82,0,108,109,83,16,172,209,83,0,0,96,84,192,99,120,84,157,228,221,84,0,0,110,85,0,168,212,85,0,96,127,86,128,80,231,86,230,189,79,87,0,0,228,87,232,103,253,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,48,73,134,90,0,0,32,91,64,87,58,91,0,128,141,91,231,246,167,91,0,120,178,92,160,219,33,93,0,0,192,93,128,25,219,93,146,225,75,94,0,0,236,94,56,112,7,95,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,144,58,196,97,0,128,224,98,229,20,253,98,0,0,0,100,0,232,28,100,224,52,149,100,0,0,64,101,128,68,93,101,86,18,215,101,0,0,132,102,0,48,255,102,0,199,72,104,20,23,198,104,0,0,120,105,176,124,150,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,160,36,161,108,0,0,221,109,226,193,252,109,0,144,60,111,192,58,194,111,0,0,128,112,0,133,160,112,124,219,39,113,0,0,232,113,16,237,8,114,0,224,112,114,0,128,84,115,0,22,223,115,136,82,106,116,0,0,48,117,224,223,81,117,0,0,167,118,70,76,201,118,0,148,53,119,0,0,0,120,0,176,34,120,64,12,179,120,0,0,128,121,0,31,163,121,0,0,18,122,52,73,53,122,0,160,152,123,0,0,0,125,0,34,36,125,24,130,186,125,0,0,144,126,160,149,180,126,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,184,73,3,0,216,70,3,0,67,4,0,0,0,0,0,0,241,73,3,0,22,74,3,0,29,74,3,0,0,0,0,0,56,26,0,0,14,0,0,0,15,0,0,0,1,0,0,0,1,0,0,0,15,0,0,0,15,0,0,0,16,0,0,0,16,0,0,0,17,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,88,26,0,0,2,0,0,0,3,0,0,0,2,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,112,26,0,0,19,0,0,0,20,0,0,0,1,0,0,0,1,0,0,0,3,0,0,0,26,0,0,0,4,0,0,0,57,0,0,0,58,0,0,0,1,0,0,0,1,0,0,0,204,84,3,0,200,80,3,0,191,3,0,0,3,0,0,0,180,158,17,0,249,84,3,0,1,85,3,0,90,85,3,0,200,80,3,0,197,3,0,0,3,0,0,0,180,158,17,0,249,84,3,0,1,85,3,0,90,85,3,0,200,80,3,0,198,3,0,0,3,0,0,0,180,158,17,0,166,85,3,0,1,85,3,0,90,85,3,0,200,80,3,0,203,3,0,0,1,0,0,0,180,158,17,0,146,85,3,0,155,85,3,0,16,86,3,0,200,80,3,0,223,3,0,0,3,0,0,0,180,158,17,0,249,84,3,0,1,85,3,0,16,86,3,0,200,80,3,0,224,3,0,0,3,0,0,0,180,158,17,0,166,85,3,0,1,85,3,0,16,86,3,0,200,80,3,0,225,3,0,0,3,0,0,0,180,158,17,0,94,86,3,0,1,85,3,0,16,86,3,0,200,80,3,0,230,3,0,0,1,0,0,0,180,158,17,0,146,85,3,0,155,85,3,0,16,86,3,0,200,80,3,0,231,3,0,0,1,0,0,0,180,158,17,0,146,85,3,0,83,86,3,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,0,0,0,0,180,165,0,0,0,0,0,0,136,26,0,0,21,0,0,0,22,0,0,0,2,0,0,0,1,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,34,0,0,0,35,0,0,0,7,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,164,166,0,0,48,166,0,0,0,0,0,0,152,26,0,0,21,0,0,0,23,0,0,0,4,0,0,0,9,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,34,0,0,0,35,0,0,0,10,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,0,0,0,0,168,26,0,0,21,0,0,0,24,0,0,0,5,0,0,0,11,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,34,0,0,0,35,0,0,0,10,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,132,168,0,0,152,167,0,0,36,167,0,0,0,0,0,0,184,26,0,0,21,0,0,0,25,0,0,0,6,0,0,0,12,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,34,0,0,0,37,0,0,0,10,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,0,0,0,0,200,26,0,0,21,0,0,0,26,0,0,0,7,0,0,0,15,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,3,0,0,0,16,0,0,0,5,0,0,0,17,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,38,0,0,0,39,0,0,0,10,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,16,168,0,0,0,0,0,0,216,26,0,0,21,0,0,0,27,0,0,0,8,0,0,0,18,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,3,0,0,0,34,0,0,0,35,0,0,0,10,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,0,0,0,0,232,26,0,0,21,0,0,0,28,0,0,0,9,0,0,0,19,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,1,0,0,0,34,0,0,0,40,0,0,0,10,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,0,0,0,0,248,26,0,0,21,0,0,0,29,0,0,0,10,0,0,0,20,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,34,0,0,0,35,0,0,0,10,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,0,0,0,0,8,27,0,0,21,0,0,0,30,0,0,0,11,0,0,0,21,0,0,0,13,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,6,0,0,0,2,0,0,0,1,0,0,0,34,0,0,0,35,0,0,0,10,0,0,0,8,0,0,0,36,0,0,0,3,0,0,0,248,168,0,0,22,0,0,0,22,0,0,0,23,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,0,0,0,0,73,0,0,0,66,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,0,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,0,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,81,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,0,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,0,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,96,0,0,0,104,0,0,0,0,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,27,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,121,0,0,0,36,91,3,0,76,91,3,0,36,1,0,0,5,0,0,0,180,158,17,0,139,91,3,0,142,194,7,0,0,0,0,0,24,27,0,0,31,0,0,0,32,0,0,0,2,0,0,0,4,0,0,0,33,0,0,0,5,0,0,0,0,0,0,0,32,27,0,0,5,0,0,0,34,0,0,0,35,0,0,0,0,0,0,195,0,0,254,194,0,0,252,194,0,0,250,194,0,0,248,194,0,0,246,194,0,0,244,194,0,0,242,194,0,0,240,194,0,0,238,194,0,0,236,194,0,0,234,194,0,0,232,194,0,0,230,194,0,0,228,194,0,0,226,194,0,0,224,194,0,0,222,194,0,0,220,194,0,0,218,194,0,0,216,194,0,0,214,194,0,0,212,194,0,0,210,194,0,0,208,194,0,0,206,194,0,0,204,194,0,0,202,194,0,0,200,194,0,0,198,194,0,0,196,194,0,0,194,194,0,0,192,194,0,0,190,194,0,0,188,194,0,0,186,194,0,0,184,194,0,0,182,194,0,0,180,194,0,0,178,194,0,0,176,194,0,0,174,194,0,0,172,194,0,0,170,194,0,0,168,194,0,0,166,194,0,0,164,194,0,0,162,194,0,0,160,194,0,0,158,194,0,0,156,194,0,0,154,194,0,0,152,194,0,0,150,194,0,0,148,194,0,0,146,194,0,0,144,194,0,0,142,194,0,0,140,194,0,0,138,194,0,0,136,194,0,0,134,194,0,0,132,194,0,0,130,194,0,0,128,194,0,0,124,194,0,0,120,194,0,0,116,194,0,0,112,194,0,0,108,194,0,0,104,194,0,0,100,194,0,0,96,194,0,0,92,194,0,0,88,194,0,0,84,194,0,0,80,194,0,0,76,194,0,0,72,194,0,0,68,194,0,0,64,194,0,0,60,194,0,0,56,194,0,0,52,194,0,0,48,194,0,0,44,194,0,0,40,194,0,0,36,194,0,0,32,194,0,0,28,194,0,0,24,194,0,0,20,194,0,0,16,194,0,0,12,194,0,0,8,194,0,0,4,194,0,0,0,194,0,0,248,193,0,0,240,193,0,0,232,193,0,0,224,193,0,0,216,193,0,0,208,193,0,0,200,193,0,0,192,193,0,0,184,193,0,0,176,193,0,0,168,193,0,0,160,193,0,0,152,193,0,0,144,193,0,0,136,193,0,0,128,193,0,0,112,193,0,0,96,193,0,0,80,193,0,0,64,193,0,0,48,193,0,0,32,193,0,0,16,193,0,0,0,193,0,0,224,192,0,0,192,192,0,0,160,192,0,0,128,192,0,0,64,192,0,0,0,192,0,0,128,191,0,0,0,0,0,0,128,63,0,0,0,64,0,0,64,64,0,0,128,64,0,0,160,64,0,0,192,64,0,0,224,64,0,0,0,65,0,0,16,65,0,0,32,65,0,0,48,65,0,0,64,65,0,0,80,65,0,0,96,65,0,0,112,65,0,0,128,65,0,0,136,65,0,0,144,65,0,0,152,65,0,0,160,65,0,0,168,65,0,0,176,65,0,0,184,65,0,0,192,65,0,0,200,65,0,0,208,65,0,0,216,65,0,0,224,65,0,0,232,65,0,0,240,65,0,0,248,65,0,0,0,66,0,0,4,66,0,0,8,66,0,0,12,66,0,0,16,66,0,0,20,66,0,0,24,66,0,0,28,66,0,0,32,66,0,0,36,66,0,0,40,66,0,0,44,66,0,0,48,66,0,0,52,66,0,0,56,66,0,0,60,66,0,0,64,66,0,0,68,66,0,0,72,66,0,0,76,66,0,0,80,66,0,0,84,66,0,0,88,66,0,0,92,66,0,0,96,66,0,0,100,66,0,0,104,66,0,0,108,66,0,0,112,66,0,0,116,66,0,0,120,66,0,0,124,66,0,0,128,66,0,0,130,66,0,0,132,66,0,0,134,66,0,0,136,66,0,0,138,66,0,0,140,66,0,0,142,66,0,0,144,66,0,0,146,66,0,0,148,66,0,0,150,66,0,0,152,66,0,0,154,66,0,0,156,66,0,0,158,66,0,0,160,66,0,0,162,66,0,0,164,66,0,0,166,66,0,0,168,66,0,0,170,66,0,0,172,66,0,0,174,66,0,0,176,66,0,0,178,66,0,0,180,66,0,0,182,66,0,0,184,66,0,0,186,66,0,0,188,66,0,0,190,66,0,0,192,66,0,0,194,66,0,0,196,66,0,0,198,66,0,0,200,66,0,0,202,66,0,0,204,66,0,0,206,66,0,0,208,66,0,0,210,66,0,0,212,66,0,0,214,66,0,0,216,66,0,0,218,66,0,0,220,66,0,0,222,66,0,0,224,66,0,0,226,66,0,0,228,66,0,0,230,66,0,0,232,66,0,0,234,66,0,0,236,66,0,0,238,66,0,0,240,66,0,0,242,66,0,0,244,66,0,0,246,66,0,0,248,66,0,0,250,66,0,0,252,66,0,0,254,66,0,0,0,67,0,0,1,67,0,0,2,67,0,0,3,67,0,0,4,67,0,0,5,67,0,0,6,67,0,0,7,67,0,0,8,67,0,0,9,67,0,0,10,67,0,0,11,67,0,0,12,67,0,0,13,67,0,0,14,67,0,0,15,67,0,0,16,67,0,0,17,67,0,0,18,67,0,0,19,67,0,0,20,67,0,0,21,67,0,0,22,67,0,0,23,67,0,0,24,67,0,0,25,67,0,0,26,67,0,0,27,67,0,0,28,67,0,0,29,67,0,0,30,67,0,0,31,67,0,0,32,67,0,0,33,67,0,0,34,67,0,0,35,67,0,0,36,67,0,0,37,67,0,0,38,67,0,0,39,67,0,0,40,67,0,0,41,67,0,0,42,67,0,0,43,67,0,0,44,67,0,0,45,67,0,0,46,67,0,0,47,67,0,0,48,67,0,0,49,67,0,0,50,67,0,0,51,67,0,0,52,67,0,0,53,67,0,0,54,67,0,0,55,67,0,0,56,67,0,0,57,67,0,0,58,67,0,0,59,67,0,0,60,67,0,0,61,67,0,0,62,67,0,0,63,67,0,0,64,67,0,0,65,67,0,0,66,67,0,0,67,67,0,0,68,67,0,0,69,67,0,0,70,67,0,0,71,67,0,0,72,67,0,0,73,67,0,0,74,67,0,0,75,67,0,0,76,67,0,0,77,67,0,0,78,67,0,0,79,67,0,0,80,67,0,0,81,67,0,0,82,67,0,0,83,67,0,0,84,67,0,0,85,67,0,0,86,67,0,0,87,67,0,0,88,67,0,0,89,67,0,0,90,67,0,0,91,67,0,0,92,67,0,0,93,67,0,0,94,67,0,0,95,67,0,0,96,67,0,0,97,67,0,0,98,67,0,0,99,67,0,0,100,67,0,0,101,67,0,0,102,67,0,0,103,67,0,0,104,67,0,0,105,67,0,0,106,67,0,0,107,67,0,0,108,67,0,0,109,67,0,0,110,67,0,0,111,67,0,0,112,67,0,0,113,67,0,0,114,67,0,0,115,67,0,0,116,67,0,0,117,67,0,0,118,67,0,0,119,67,0,0,120,67,0,0,121,67,0,0,122,67,0,0,123,67,0,0,124,67,0,0,125,67,0,0,126,67,0,0,127,67,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,27,0,0,36,0,0,0,37,0,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,27,117,3,0,27,117,3,0,180,158,17,0,180,158,17,0,32,117,3,0,36,117,3,0,32,117,3,0,40,117,3,0,236,126,3,0,242,126,3,0,248,126,3,0,255,126,3,0,6,127,3,0,13,127,3,0,20,127,3,0,27,127,3,0,64,0,0,0,0,0,0,0,176,27,0,0,39,0,0,0,40,0,0,0,56,0,0,0,248,255,255,255,176,27,0,0,41,0,0,0,42,0,0,0,192,255,255,255,192,255,255,255,176,27,0,0,43,0,0,0,44,0,0,0,0,0,0,0,160,27,0,0,49,0,0,0,50,0,0,0,10,0,0,0,1,0,0,0,19,0,0,0,30,0,0,0,6,0,0,0,7,0,0,0,2,0,0,0,8,0,0,0,9,0,0,0,12,0,0,0,3,0,0,0,13,0,0,0,116,178,0,0,108,27,0,0,68,27,0,0,88,27,0,0,252,29,0,0,16,30,0,0,148,27,0,0,128,27,0,0,156,178,0,0,136,178,0,0,74,127,3,0,62,231,7,0,96,231,7,0,71,231,7,0,249,230,7,0,65,231,7,0,251,230,7,0,109,127,3,0,124,127,3,0,133,127,3,0,146,127,3,0,168,127,3,0,178,127,3,0,203,127,3,0,0,0,0,0,224,27,0,0,57,0,0,0,58,0,0,0,11,0,0,0,0,0,0,0,208,27,0,0,57,0,0,0,59,0,0,0,12,0,0,0,0,0,0,0,192,27,0,0,57,0,0,0,60,0,0,0,13,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,14,0,0,0,14,0,0,0,15,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,0,0,0,0,56,0,0,0,0,0,0,0,24,30,0,0,65,0,0,0,66,0,0,0,200,255,255,255,200,255,255,255,24,30,0,0,67,0,0,0,68,0,0,0,0,180,0,0,252,29,0,0,16,30,0,0,20,180,0,0,60,0,0,0,0,0,0,0,80,30,0,0,69,0,0,0,70,0,0,0,196,255,255,255,196,255,255,255,80,30,0,0,71,0,0,0,72,0,0,0,56,180,0,0,52,30,0,0,72,30,0,0,76,180,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,0,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,96,30,0,0,73,0,0,0,74,0,0,0,10,0,0,0,0,0,0,0,112,30,0,0,75,0,0,0,76,0,0,0,1,0,0,0,1,0,0,0,136,138,17,0,0,0,0,0,128,30,0,0,77,0,0,0,78,0,0,0,11,0,0,0,14,0,0,0,0,0,0,0,152,30,0,0,79,0,0,0,80,0,0,0,12,0,0,0,15,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,168,31,0,0,81,0,0,0,82,0,0,0,41,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,152,31,0,0,5,0,0,0,83,0,0,0,84,0,0,0,0,0,0,0,136,31,0,0,81,0,0,0,85,0,0,0,42,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,120,31,0,0,5,0,0,0,86,0,0,0,87,0,0,0,0,0,0,0,104,31,0,0,81,0,0,0,88,0,0,0,43,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,88,31,0,0,5,0,0,0,89,0,0,0,90,0,0,0,0,0,0,0,72,31,0,0,81,0,0,0,91,0,0,0,44,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,56,31,0,0,5,0,0,0,92,0,0,0,93,0,0,0,0,0,0,0,40,31,0,0,81,0,0,0,94,0,0,0,45,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,24,31,0,0,5,0,0,0,95,0,0,0,96,0,0,0,0,0,0,0,216,30,0,0,81,0,0,0,97,0,0,0,46,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,200,30,0,0,5,0,0,0,98,0,0,0,99,0,0,0,0,0,0,0,232,30,0,0,5,0,0,0,100,0,0,0,101,0,0,0,0,0,0,0,248,30,0,0,13,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,205,205,3,0,211,205,3,0,216,205,3,0,223,205,3,0,33,66,7,0,229,205,3,0,237,205,3,0,26,66,7,0,0,0,0,0,200,31,0,0,57,0,0,0,105,0,0,0,19,0,0,0,0,0,0,0,184,31,0,0,57,0,0,0,106,0,0,0,20,0,0,0,0,0,0,0,248,31,0,0,57,0,0,0,107,0,0,0,21,0,0,0,0,0,0,0,232,31,0,0,57,0,0,0,108,0,0,0,22,0,0,0,0,0,0,0,216,31,0,0,57,0,0,0,109,0,0,0,23,0,0,0,0,0,0,0,24,32,0,0,57,0,0,0,110,0,0,0,24,0,0,0,0,0,0,0,8,32,0,0,57,0,0,0,111,0,0,0,25,0,0,0,0,0,0,0,72,32,0,0,57,0,0,0,112,0,0,0,26,0,0,0,0,0,0,0,56,32,0,0,57,0,0,0,113,0,0,0,27,0,0,0,0,0,0,0,40,32,0,0,57,0,0,0,114,0,0,0,28,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,23,0,0,0,24,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,9,0,0,0,10,0,0,0,0,0,0,0,11,0,0,0,12,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,81,0,0,0,82,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,84,0,0,0,85,0,0,0,0,0,0,0,86,0,0,0,87,0,0,0,0,0,0,0,88,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,0,0,0,0,91,0,0,0,92,0,0,0,0,0,0,0,0,0,0,0,88,32,0,0,115,0,0,0,116,0,0,0,29,0,0,0,0,0,0,0,104,32,0,0,117,0,0,0,118,0,0,0,30,0,0,0,0,0,0,0,120,32,0,0,119,0,0,0,120,0,0,0,31,0,0,0,0,0,0,0,136,32,0,0,121,0,0,0,122,0,0,0,32,0,0,0,0,0,0,0,152,32,0,0,123,0,0,0,124,0,0,0,33,0,0,0,0,0,0,0,168,32,0,0,125,0,0,0,126,0,0,0,34,0,0,0,0,0,0,0,184,32,0,0,127,0,0,0,128,0,0,0,35,0,0,0,0,0,0,0,200,32,0,0,129,0,0,0,130,0,0,0,36,0,0,0,0,0,0,0,216,32,0,0,131,0,0,0,132,0,0,0,37,0,0,0,0,0,0,0,232,32,0,0,133,0,0,0,134,0,0,0,38,0,0,0,0,0,0,0,248,32,0,0,135,0,0,0,136,0,0,0,39,0,0,0,0,0,0,0,8,33,0,0,137,0,0,0,138,0,0,0,40,0,0,0,0,0,0,0,24,33,0,0,139,0,0,0,140,0,0,0,41,0,0,0,0,0,0,0,40,33,0,0,141,0,0,0,142,0,0,0,42,0,0,0,0,0,0,0,56,33,0,0,143,0,0,0,144,0,0,0,43,0,0,0,0,0,0,0,72,33,0,0,57,0,0,0,145,0,0,0,44,0,0,0,0,0,0,0,88,33,0,0,57,0,0,0,146,0,0,0,45,0,0,0,0,0,0,0,104,33,0,0,57,0,0,0,147,0,0,0,46,0,0,0,0,0,0,0,120,33,0,0,57,0,0,0,148,0,0,0,47,0,0,0,0,0,0,0,136,33,0,0,57,0,0,0,149,0,0,0,48,0,0,0,0,0,0,0,152,33,0,0,150,0,0,0,151,0,0,0,49,0,0,0,0,0,0,0,168,33,0,0,152,0,0,0,153,0,0,0,50,0,0,0,0,0,0,0,184,33,0,0,154,0,0,0,155,0,0,0,51,0,0,0,0,0,0,0,200,33,0,0,156,0,0,0,157,0,0,0,52,0,0,0,0,0,0,0,216,33,0,0,158,0,0,0,159,0,0,0,53,0,0,0,0,0,0,0,232,33,0,0,160,0,0,0,161,0,0,0,54,0,0,0,0,0,0,0,248,33,0,0,57,0,0,0,162,0,0,0,55,0,0,0,0,0,0,0,8,34,0,0,57,0,0,0,163,0,0,0,56,0,0,0,0,0,0,0,24,34,0,0,57,0,0,0,164,0,0,0,57,0,0,0,0,0,0,0,40,34,0,0,57,0,0,0,165,0,0,0,58,0,0,0,0,0,0,0,56,34,0,0,57,0,0,0,166,0,0,0,59,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,72,34,0,0,5,0,0,0,167,0,0,0,168,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,62,0,0,0,63,0,0,128,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,61,0,0,128,62,0,0,192,62,0,0,128,62,0,0,128,61,0,0,0,0,0,0,0,0,0,0,0,61,0,0,224,61,0,0,96,62,0,0,144,62,0,0,96,62,0,0,224,61,0,0,0,61,0,0,0,0,88,34,0,0,57,0,0,0,169,0,0,0,60,0,0,0,0,0,0,0,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,5,246,127,63,19,216,127,63,47,166,127,63,92,96,127,63,158,6,127,63,253,152,126,63,130,23,126,63,54,130,125,63,36,217,124,63,93,28,124,63,236,75,123,63,226,103,122,63,82,112,121,63,77,101,120,63,234,70,119,63,63,21,118,63,100,208,116,63,112,120,115,63,130,13,114,63,178,143,112,63,32,255,110,63,237,91,109,63,54,166,107,63,30,222,105,63,202,3,104,63,93,23,102,63,1,25,100,63,219,8,98,63,20,231,95,63,215,179,93,63,81,111,91,63,174,25,89,63,30,179,86,63,207,59,84,63,242,179,81,63,189,27,79,63,96,115,76,63,19,187,73,63,10,243,70,63,124,27,68,63,166,52,65,63,189,62,62,63,255,57,59,63,167,38,56,63,244,4,53,63,34,213,49,63,114,151,46,63,37,76,43,63,124,243,39,63,186,141,36,63,36,27,33,63,254,155,29,63,140,16,26,63,25,121,22,63,231,213,18,63,68,39,15,63,118,109,11,63,203,168,7,63,137,217,3,63,0,0,0,63,247,56,248,62,149,94,240,62,113,113,232,62,45,114,224,62,109,97,216,62,200,63,208,62,232,13,200,62,112,204,191,62,255,123,183,62,66,29,175,62,224,176,166,62,122,55,158,62,190,177,149,62,88,32,141,62,237,131,132,62,96,186,119,62,149,89,102,62,206,230,84,62,111,99,67,62,213,208,49,62,94,48,32,62,101,131,14,62,157,150,249,61,10,19,214,61,176,126,178,61,127,220,142,61,70,94,86,61,199,242,14,61,86,248,142,60,0,0,0,0,86,248,142,188,199,242,14,189,70,94,86,189,127,220,142,189,176,126,178,189,10,19,214,189,157,150,249,189,101,131,14,190,94,48,32,190,213,208,49,190,111,99,67,190,206,230,84,190,149,89,102,190,96,186,119,190,237,131,132,190,88,32,141,190,190,177,149,190,122,55,158,190,224,176,166,190,66,29,175,190,255,123,183,190,112,204,191,190,232,13,200,190,200,63,208,190,109,97,216,190,45,114,224,190,113,113,232,190,149,94,240,190,247,56,248,190,0,0,0,191,137,217,3,191,203,168,7,191,118,109,11,191,68,39,15,191,231,213,18,191,25,121,22,191,140,16,26,191,254,155,29,191,36,27,33,191,186,141,36,191,124,243,39,191,37,76,43,191,114,151,46,191,34,213,49,191,244,4,53,191,167,38,56,191,255,57,59,191,189,62,62,191,166,52,65,191,124,27,68,191,10,243,70,191,19,187,73,191,96,115,76,191,189,27,79,191,242,179,81,191,207,59,84,191,30,179,86,191,174,25,89,191,81,111,91,191,215,179,93,191,20,231,95,191,219,8,98,191,1,25,100,191,93,23,102,191,202,3,104,191,30,222,105,191,54,166,107,191,237,91,109,191,32,255,110,191,178,143,112,191,130,13,114,191,112,120,115,191,100,208,116,191,63,21,118,191,234,70,119,191,77,101,120,191,82,112,121,191,226,103,122,191,236,75,123,191,93,28,124,191,36,217,124,191,54,130,125,191,130,23,126,191,253,152,126,191,158,6,127,191,92,96,127,191,47,166,127,191,19,216,127,191,5,246,127,191,0,0,128,191,5,246,127,191,19,216,127,191,47,166,127,191,92,96,127,191,158,6,127,191,253,152,126,191,130,23,126,191,54,130,125,191,36,217,124,191,93,28,124,191,236,75,123,191,226,103,122,191,82,112,121,191,77,101,120,191,234,70,119,191,63,21,118,191,100,208,116,191,112,120,115,191,130,13,114,191,178,143,112,191,32,255,110,191,237,91,109,191,54,166,107,191,30,222,105,191,202,3,104,191,93,23,102,191,1,25,100,191,219,8,98,191,20,231,95,191,215,179,93,191,81,111,91,191,174,25,89,191,30,179,86,191,207,59,84,191,242,179,81,191,189,27,79,191,96,115,76,191,19,187,73,191,10,243,70,191,124,27,68,191,166,52,65,191,189,62,62,191,255,57,59,191,167,38,56,191,244,4,53,191,34,213,49,191,114,151,46,191,37,76,43,191,124,243,39,191,186,141,36,191,36,27,33,191,254,155,29,191,140,16,26,191,25,121,22,191,231,213,18,191,68,39,15,191,118,109,11,191,203,168,7,191,137,217,3,191,0,0,0,191,247,56,248,190,149,94,240,190,113,113,232,190,45,114,224,190,109,97,216,190,200,63,208,190,232,13,200,190,112,204,191,190,255,123,183,190,66,29,175,190,224,176,166,190,122,55,158,190,190,177,149,190,88,32,141,190,237,131,132,190,96,186,119,190,149,89,102,190,206,230,84,190,111,99,67,190,213,208,49,190,94,48,32,190,101,131,14,190,157,150,249,189,10,19,214,189,176,126,178,189,127,220,142,189,70,94,86,189,199,242,14,189,86,248,142,188,0,0,0,128,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,168,0,0,0,177,0,0,0,185,0,0,0,194,0,0,0,202,0,0,0,210,0,0,0,218,0,0,0,224,0,0,0,231,0,0,0,236,0,0,0,241,0,0,0,246,0,0,0,249,0,0,0,252,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,252,0,0,0,249,0,0,0,246,0,0,0,241,0,0,0,236,0,0,0,231,0,0,0,224,0,0,0,218,0,0,0,210,0,0,0,202,0,0,0,194,0,0,0,185,0,0,0,177,0,0,0,168,0,0,0,158,0,0,0,149,0,0,0,140,0,0,0,131,0,0,0,122,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,89,0,0,0,82,0,0,0,75,0,0,0,68,0,0,0,62,0,0,0,56,0,0,0,50,0,0,0,45,0,0,0,40,0,0,0,36,0,0,0,32,0,0,0,28,0,0,0,25,0,0,0,22,0,0,0,19,0,0,0,16,0,0,0,14,0,0,0,12,0,0,0,11,0,0,0,9,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,5,0,0,0,69,17,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,151,0,0,0,152,0,0,0,153,0,0,0,154,0,0,0,155,0,0,0,156,0,0,0,157,0,0,0,158,0,0,0,159,0,0,0,160,0,0,0,161,0,0,0,162,0,0,0,163,0,0,0,164,0,0,0,165,0,0,0,166,0,0,0,167,0,0,0,168,0,0,0,169,0,0,0,170,0,0,0,171,0,0,0,172,0,0,0,173,0,0,0,174,0,0,0,175,0,0,0,176,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,69,16,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,201,55,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,205,10,0,0,225,8,0,0,3,8,0,0,4,8,0,0,5,8,0,0,6,8,0,0,7,8,0,0,8,8,0,0,9,8,0,0,10,8,0,0,11,8,0,0,12,8,0,0,13,8,0,0,14,8,0,0,15,8,0,0,16,8,0,0,17,8,0,0,18,8,0,0,19,8,0,0,20,8,0,0,21,8,0,0,22,8,0,0,23,8,0,0,24,8,0,0,25,8,0,0,26,8,0,0,27,8,0,0,28,8,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,103,8,0,0,104,8,0,0,105,8,0,0,106,8,0,0,107,8,0,0,108,8,0,0,109,8,0,0,110,8,0,0,111,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+40960);allocate([112,8,0,0,113,8,0,0,114,8,0,0,115,8,0,0,116,8,0,0,117,8,0,0,118,8,0,0,119,8,0,0,120,8,0,0,121,8,0,0,122,8,0,0,123,8,0,0,124,8,0,0,125,8,0,0,126,8,0,0,127,8,0,0,128,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,48,0,0,151,8,0,0,166,8,0,0,169,8,0,0,227,8,0,0,226,8,0,0,223,8,0,0,224,8,0,0,168,8,0,0,173,8,0,0,174,8,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,152,8,0,0,153,8,0,0,154,8,0,0,155,8,0,0,156,8,0,0,157,8,0,0,158,8,0,0,159,8,0,0,160,8,0,0,161,8,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,209,7,0,0,210,7,0,0,211,7,0,0,212,7,0,0,213,7,0,0,214,7,0,0,215,7,0,0,216,7,0,0,217,7,0,0,218,7,0,0,219,7,0,0,220,7,0,0,221,7,0,0,222,7,0,0,223,7,0,0,224,7,0,0,225,7,0,0,226,7,0,0,227,7,0,0,228,7,0,0,229,7,0,0,230,7,0,0,231,7,0,0,232,7,0,0,233,7,0,0,234,7,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,53,8,0,0,54,8,0,0,55,8,0,0,56,8,0,0,57,8,0,0,58,8,0,0,59,8,0,0,60,8,0,0,61,8,0,0,62,8,0,0,63,8,0,0,64,8,0,0,65,8,0,0,66,8,0,0,67,8,0,0,68,8,0,0,69,8,0,0,70,8,0,0,71,8,0,0,72,8,0,0,73,8,0,0,74,8,0,0,75,8,0,0,76,8,0,0,77,8,0,0,78,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,241,10,0,0,242,10,0,0,243,10,0,0,244,10,0,0,245,10,0,0,246,10,0,0,247,10,0,0,248,10,0,0,249,10,0,0,250,10,0,0,251,10,0,0,252,10,0,0,253,10,0,0,254,10,0,0,255,10,0,0,0,11,0,0,1,11,0,0,2,11,0,0,3,11,0,0,4,11,0,0,5,11,0,0,6,11,0,0,7,11,0,0,8,11,0,0,9,11,0,0,10,11,0,0,11,11,0,0,12,11,0,0,13,11,0,0,14,11,0,0,15,11,0,0,16,11,0,0,85,11,0,0,86,11,0,0,87,11,0,0,88,11,0,0,89,11,0,0,90,11,0,0,91,11,0,0,92,11,0,0,93,11,0,0,94,11,0,0,95,11,0,0,96,11,0,0,97,11,0,0,98,11,0,0,99,11,0,0,100,11,0,0,101,11,0,0,102,11,0,0,103,11,0,0,104,11,0,0,105,11,0,0,106,11,0,0,107,11,0,0,108,11,0,0,109,11,0,0,110,11,0,0,111,11,0,0,112,11,0,0,113,11,0,0,114,11,0,0,115,11,0,0,116,11,0,0,201,23,0,0,151,8,0,0,192,12,0,0,206,12,0,0,210,12,0,0,197,12,0,0,161,12,0,0,196,12,0,0,205,12,0,0,199,12,0,0,200,12,0,0,151,12,0,0,153,12,0,0,189,12,0,0,152,12,0,0,188,12,0,0,198,12,0,0,178,12,0,0,179,12,0,0,180,12,0,0,181,12,0,0,182,12,0,0,183,12,0,0,184,12,0,0,185,12,0,0,186,12,0,0,187,12,0,0,190,12,0,0,191,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,193,12,0,0,162,12,0,0,235,11,0,0,236,11,0,0,237,11,0,0,238,11,0,0,239,11,0,0,240,11,0,0,241,11,0,0,242,11,0,0,243,11,0,0,244,11,0,0,245,11,0,0,246,11,0,0,247,11,0,0,16,8,0,0,249,11,0,0,250,11,0,0,251,11,0,0,252,11,0,0,253,11,0,0,254,11,0,0,255,11,0,0,0,12,0,0,1,12,0,0,2,12,0,0,3,12,0,0,4,12,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,79,12,0,0,80,12,0,0,81,12,0,0,82,12,0,0,83,12,0,0,84,12,0,0,85,12,0,0,86,12,0,0,87,12,0,0,88,12,0,0,89,12,0,0,90,12,0,0,91,12,0,0,92,12,0,0,93,12,0,0,94,12,0,0,95,12,0,0,96,12,0,0,97,12,0,0,98,12,0,0,99,12,0,0,100,12,0,0,101,12,0,0,102,12,0,0,103,12,0,0,104,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,142,12,0,0,156,12,0,0,160,12,0,0,147,12,0,0,161,12,0,0,146,12,0,0,155,12,0,0,149,12,0,0,150,12,0,0,151,12,0,0,153,12,0,0,139,12,0,0,152,12,0,0,138,12,0,0,148,12,0,0,128,12,0,0,129,12,0,0,130,12,0,0,131,12,0,0,132,12,0,0,133,12,0,0,134,12,0,0,135,12,0,0,136,12,0,0,137,12,0,0,140,12,0,0,141,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,143,12,0,0,162,12,0,0,185,11,0,0,186,11,0,0,187,11,0,0,188,11,0,0,189,11,0,0,190,11,0,0,191,11,0,0,192,11,0,0,193,11,0,0,194,11,0,0,195,11,0,0,196,11,0,0,197,11,0,0,222,7,0,0,199,11,0,0,200,11,0,0,201,11,0,0,202,11,0,0,203,11,0,0,204,11,0,0,205,11,0,0,206,11,0,0,207,11,0,0,208,11,0,0,209,11,0,0,210,11,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,29,12,0,0,30,12,0,0,31,12,0,0,32,12,0,0,33,12,0,0,34,12,0,0,35,12,0,0,36,12,0,0,37,12,0,0,38,12,0,0,39,12,0,0,40,12,0,0,41,12,0,0,42,12,0,0,43,12,0,0,44,12,0,0,45,12,0,0,46,12,0,0,47,12,0,0,48,12,0,0,49,12,0,0,50,12,0,0,51,12,0,0,52,12,0,0,53,12,0,0,54,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,118,17,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,189,4,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,27,4,0,0,28,4,0,0,29,4,0,0,30,4,0,0,31,4,0,0,32,4,0,0,33,4,0,0,34,4,0,0,35,4,0,0,36,4,0,0,37,4,0,0,38,4,0,0,39,4,0,0,40,4,0,0,41,4,0,0,42,4,0,0,43,4,0,0,44,4,0,0,45,4,0,0,46,4,0,0,47,4,0,0,48,4,0,0,49,4,0,0,50,4,0,0,51,4,0,0,52,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,127,4,0,0,128,4,0,0,129,4,0,0,130,4,0,0,131,4,0,0,132,4,0,0,133,4,0,0,134,4,0,0,135,4,0,0,136,4,0,0,137,4,0,0,138,4,0,0,139,4,0,0,140,4,0,0,141,4,0,0,142,4,0,0,143,4,0,0,144,4,0,0,145,4,0,0,146,4,0,0,147,4,0,0,148,4,0,0,149,4,0,0,150,4,0,0,151,4,0,0,152,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,118,16,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,165,8,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,233,3,0,0,234,3,0,0,235,3,0,0,236,3,0,0,237,3,0,0,238,3,0,0,239,3,0,0,240,3,0,0,241,3,0,0,242,3,0,0,243,3,0,0,244,3,0,0,245,3,0,0,246,3,0,0,247,3,0,0,248,3,0,0,249,3,0,0,250,3,0,0,251,3,0,0,252,3,0,0,253,3,0,0,254,3,0,0,255,3,0,0,0,4,0,0,1,4,0,0,2,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,77,4,0,0,78,4,0,0,79,4,0,0,80,4,0,0,81,4,0,0,82,4,0,0,83,4,0,0,84,4,0,0,85,4,0,0,86,4,0,0,87,4,0,0,88,4,0,0,89,4,0,0,90,4,0,0,91,4,0,0,92,4,0,0,93,4,0,0,94,4,0,0,95,4,0,0,96,4,0,0,97,4,0,0,98,4,0,0,99,4,0,0,100,4,0,0,101,4,0,0,102,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,201,23,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,247,9,0,0,248,9,0,0,249,9,0,0,250,9,0,0,251,9,0,0,252,9,0,0,253,9,0,0,254,9,0,0,255,9,0,0,0,10,0,0,1,10,0,0,2,10,0,0,3,10,0,0,4,10,0,0,5,10,0,0,6,10,0,0,7,10,0,0,8,10,0,0,9,10,0,0,10,10,0,0,11,10,0,0,12,10,0,0,13,10,0,0,14,10,0,0,15,10,0,0,16,10,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,74,2,0,0,201,8,0,0,91,10,0,0,92,10,0,0,93,10,0,0,94,10,0,0,95,10,0,0,96,10,0,0,97,10,0,0,98,10,0,0,99,10,0,0,100,10,0,0,101,10,0,0,102,10,0,0,103,10,0,0,104,10,0,0,105,10,0,0,106,10,0,0,107,10,0,0,108,10,0,0,109,10,0,0,110,10,0,0,111,10,0,0,112,10,0,0,113,10,0,0,114,10,0,0,115,10,0,0,116,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,17,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,39,2,0,0,40,2,0,0,41,2,0,0,42,2,0,0,43,2,0,0,44,2,0,0,45,2,0,0,46,2,0,0,47,2,0,0,48,2,0,0,49,2,0,0,50,2,0,0,51,2,0,0,52,2,0,0,53,2,0,0,54,2,0,0,55,2,0,0,56,2,0,0,57,2,0,0,58,2,0,0,59,2,0,0,60,2,0,0,61,2,0,0,62,2,0,0,63,2,0,0,64,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,139,2,0,0,140,2,0,0,141,2,0,0,142,2,0,0,143,2,0,0,144,2,0,0,145,2,0,0,146,2,0,0,147,2,0,0,148,2,0,0,149,2,0,0,150,2,0,0,151,2,0,0,152,2,0,0,153,2,0,0,154,2,0,0,155,2,0,0,156,2,0,0,157,2,0,0,158,2,0,0,159,2,0,0,160,2,0,0,161,2,0,0,162,2,0,0,163,2,0,0,164,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,201,16,0,0,151,8,0,0,154,10,0,0,168,10,0,0,172,10,0,0,159,10,0,0,173,10,0,0,158,10,0,0,167,10,0,0,161,10,0,0,162,10,0,0,163,10,0,0,165,10,0,0,151,10,0,0,164,10,0,0,150,10,0,0,160,10,0,0,140,10,0,0,141,10,0,0,142,10,0,0,143,10,0,0,144,10,0,0,145,10,0,0,146,10,0,0,147,10,0,0,148,10,0,0,149,10,0,0,152,10,0,0,153,10,0,0,170,10,0,0,166,10,0,0,171,10,0,0,155,10,0,0,174,10,0,0,197,9,0,0,198,9,0,0,199,9,0,0,200,9,0,0,201,9,0,0,202,9,0,0,203,9,0,0,204,9,0,0,205,9,0,0,206,9,0,0,207,9,0,0,208,9,0,0,209,9,0,0,210,9,0,0,211,9,0,0,212,9,0,0,213,9,0,0,214,9,0,0,215,9,0,0,216,9,0,0,217,9,0,0,218,9,0,0,219,9,0,0,220,9,0,0,221,9,0,0,222,9,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,41,10,0,0,42,10,0,0,43,10,0,0,44,10,0,0,45,10,0,0,46,10,0,0,47,10,0,0,48,10,0,0,49,10,0,0,50,10,0,0,51,10,0,0,52,10,0,0,53,10,0,0,54,10,0,0,55,10,0,0,56,10,0,0,57,10,0,0,58,10,0,0,59,10,0,0,60,10,0,0,61,10,0,0,62,10,0,0,63,10,0,0,64,10,0,0,65,10,0,0,66,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,245,1,0,0,246,1,0,0,247,1,0,0,248,1,0,0,249,1,0,0,250,1,0,0,251,1,0,0,252,1,0,0,253,1,0,0,254,1,0,0,255,1,0,0,0,2,0,0,1,2,0,0,2,2,0,0,3,2,0,0,4,2,0,0,5,2,0,0,6,2,0,0,7,2,0,0,8,2,0,0,9,2,0,0,10,2,0,0,11,2,0,0,12,2,0,0,13,2,0,0,14,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,89,2,0,0,90,2,0,0,91,2,0,0,92,2,0,0,93,2,0,0,94,2,0,0,95,2,0,0,96,2,0,0,97,2,0,0,98,2,0,0,99,2,0,0,100,2,0,0,101,2,0,0,102,2,0,0,103,2,0,0,104,2,0,0,105,2,0,0,106,2,0,0,107,2,0,0,108,2,0,0,109,2,0,0,110,2,0,0,111,2,0,0,112,2,0,0,113,2,0,0,114,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,120,34,0,0,57,0,0,0,170,0,0,0,61,0,0,0,0,0,0,0,104,34,0,0,57,0,0,0,171,0,0,0,62,0,0,0,0,0,0,0,184,35,0,0,172,0,0,0,173,0,0,0,26,0,0,0,0,0,0,0,168,35,0,0,5,0,0,0,174,0,0,0,175,0,0,0,0,0,0,0,152,35,0,0,172,0,0,0,176,0,0,0,27,0,0,0,0,0,0,0,136,35,0,0,5,0,0,0,177,0,0,0,178,0,0,0,0,0,0,0,120,35,0,0,172,0,0,0,179,0,0,0,28,0,0,0,0,0,0,0,104,35,0,0,5,0,0,0,180,0,0,0,181,0,0,0,0,0,0,0,88,35,0,0,172,0,0,0,182,0,0,0,29,0,0,0,0,0,0,0,72,35,0,0,5,0,0,0,183,0,0,0,184,0,0,0,0,0,0,0,56,35,0,0,172,0,0,0,185,0,0,0,30,0,0,0,0,0,0,0,40,35,0,0,5,0,0,0,186,0,0,0,187,0,0,0,0,0,0,0,24,35,0,0,172,0,0,0,188,0,0,0,31,0,0,0,0,0,0,0,8,35,0,0,5,0,0,0,189,0,0,0,190,0,0,0,0,0,0,0,248,34,0,0,172,0,0,0,191,0,0,0,32,0,0,0,0,0,0,0,232,34,0,0,5,0,0,0,192,0,0,0,193,0,0,0,0,0,0,0,216,34,0,0,172,0,0,0,194,0,0,0,33,0,0,0,0,0,0,0,200,34,0,0,5,0,0,0,195,0,0,0,196,0,0,0,0,0,0,0,184,34,0,0,172,0,0,0,197,0,0,0,34,0,0,0,0,0,0,0,168,34,0,0,5,0,0,0,198,0,0,0,199,0,0,0,0,0,0,0,152,34,0,0,172,0,0,0,200,0,0,0,35,0,0,0,0,0,0,0,136,34,0,0,5,0,0,0,201,0,0,0,202,0,0,0,0,0,0,0,248,36,0,0,203,0,0,0,204,0,0,0,25,0,0,0,205,0,0,0,0,0,0,0,232,36,0,0,5,0,0,0,206,0,0,0,207,0,0,0,0,0,0,0,216,36,0,0,203,0,0,0,208,0,0,0,26,0,0,0,205,0,0,0,0,0,0,0,200,36,0,0,5,0,0,0,209,0,0,0,210,0,0,0,0,0,0,0,184,36,0,0,203,0,0,0,211,0,0,0,27,0,0,0,205,0,0,0,0,0,0,0,168,36,0,0,5,0,0,0,212,0,0,0,213,0,0,0,0,0,0,0,152,36,0,0,203,0,0,0,214,0,0,0,28,0,0,0,205,0,0,0,0,0,0,0,136,36,0,0,5,0,0,0,215,0,0,0,216,0,0,0,0,0,0,0,120,36,0,0,203,0,0,0,217,0,0,0,29,0,0,0,205,0,0,0,0,0,0,0,104,36,0,0,5,0,0,0,218,0,0,0,219,0,0,0,0,0,0,0,88,36,0,0,203,0,0,0,220,0,0,0,30,0,0,0,205,0,0,0,0,0,0,0,72,36,0,0,5,0,0,0,221,0,0,0,222,0,0,0,0,0,0,0,56,36,0,0,203,0,0,0,223,0,0,0,31,0,0,0,205,0,0,0,0,0,0,0,40,36,0,0,5,0,0,0,224,0,0,0,225,0,0,0,0,0,0,0,24,36,0,0,203,0,0,0,226,0,0,0,32,0,0,0,205,0,0,0,0,0,0,0,8,36,0,0,5,0,0,0,227,0,0,0,228,0,0,0,0,0,0,0,248,35,0,0,203,0,0,0,229,0,0,0,33,0,0,0,205,0,0,0,0,0,0,0,232,35,0,0,5,0,0,0,230,0,0,0,231,0,0,0,0,0,0,0,216,35,0,0,203,0,0,0,232,0,0,0,34,0,0,0,205,0,0,0,0,0,0,0,200,35,0,0,5,0,0,0,233,0,0,0,234,0,0,0,0,0,0,0,40,38,0,0,5,0,0,0,235,0,0,0,236,0,0,0,0,0,0,0,8,38,0,0,5,0,0,0,237,0,0,0,238,0,0,0,0,0,0,0,232,37,0,0,5,0,0,0,239,0,0,0,240,0,0,0,0,0,0,0,200,37,0,0,5,0,0,0,241,0,0,0,242,0,0,0,0,0,0,0,168,37,0,0,5,0,0,0,243,0,0,0,244,0,0,0,0,0,0,0,136,37,0,0,5,0,0,0,245,0,0,0,246,0,0,0,0,0,0,0,104,37,0,0,5,0,0,0,247,0,0,0,248,0,0,0,0,0,0,0,72,37,0,0,5,0,0,0,249,0,0,0,250,0,0,0,0,0,0,0,40,37,0,0,5,0,0,0,251,0,0,0,252,0,0,0,0,0,0,0,8,37,0,0,5,0,0,0,253,0,0,0,254,0,0,0,0,0,0,0,24,37,0,0,255,0,0,0,0,1,0,0,13,0,0,0,1,1,0,0,0,0,0,0,56,37,0,0,2,1,0,0,3,1,0,0,14,0,0,0,1,1,0,0,0,0,0,0,88,37,0,0,4,1,0,0,5,1,0,0,15,0,0,0,1,1,0,0,0,0,0,0,120,37,0,0,6,1,0,0,7,1,0,0,16,0,0,0,1,1,0,0,0,0,0,0,152,37,0,0,8,1,0,0,9,1,0,0,17,0,0,0,1,1,0,0,0,0,0,0,184,37,0,0,10,1,0,0,11,1,0,0,18,0,0,0,1,1,0,0,0,0,0,0,216,37,0,0,12,1,0,0,13,1,0,0,19,0,0,0,1,1,0,0,0,0,0,0,248,37,0,0,14,1,0,0,15,1,0,0,20,0,0,0,1,1,0,0,0,0,0,0,24,38,0,0,16,1,0,0,17,1,0,0,21,0,0,0,1,1,0,0,0,0,0,0,56,38,0,0,18,1,0,0,19,1,0,0,22,0,0,0,1,1,0,0,0,0,0,0,72,38,0,0,5,0,0,0,20,1,0,0,21,1,0,0,0,0,0,0,0,0,0,63,0,0,128,62,171,170,42,62,0,0,0,62,205,204,204,61,171,170,170,61,40,73,146,61,0,0,128,61,0,0,0,0,88,38,0,0,22,1,0,0,23,1,0,0,63,0,0,0,0,0,0,0,104,38,0,0,24,1,0,0,25,1,0,0,64,0,0,0,0,0,0,0,120,38,0,0,26,1,0,0,27,1,0,0,65,0,0,0,0,0,0,0,136,38,0,0,28,1,0,0,29,1,0,0,66,0,0,0,0,0,0,0,152,38,0,0,30,1,0,0,31,1,0,0,67,0,0,0,0,0,0,0,168,38,0,0,32,1,0,0,33,1,0,0,68,0,0,0,0,0,0,0,232,39,0,0,172,0,0,0,34,1,0,0,36,0,0,0,0,0,0,0,216,39,0,0,5,0,0,0,35,1,0,0,36,1,0,0,0,0,0,0,200,39,0,0,172,0,0,0,37,1,0,0,37,0,0,0,0,0,0,0,184,39,0,0,5,0,0,0,38,1,0,0,39,1,0,0,0,0,0,0,168,39,0,0,172,0,0,0,40,1,0,0,38,0,0,0,0,0,0,0,152,39,0,0,5,0,0,0,41,1,0,0,42,1,0,0,0,0,0,0,136,39,0,0,172,0,0,0,43,1,0,0,39,0,0,0,0,0,0,0,120,39,0,0,5,0,0,0,44,1,0,0,45,1,0,0,0,0,0,0,104,39,0,0,172,0,0,0,46,1,0,0,40,0,0,0,0,0,0,0,88,39,0,0,5,0,0,0,47,1,0,0,48,1,0,0,0,0,0,0,72,39,0,0,172,0,0,0,49,1,0,0,41,0,0,0,0,0,0,0,56,39,0,0,5,0,0,0,50,1,0,0,51,1,0,0,0,0,0,0,40,39,0,0,172,0,0,0,52,1,0,0,42,0,0,0,0,0,0,0,24,39,0,0,5,0,0,0,53,1,0,0,54,1,0,0,0,0,0,0,8,39,0,0,172,0,0,0,55,1,0,0,43,0,0,0,0,0,0,0,248,38,0,0,5,0,0,0,56,1,0,0,57,1,0,0,0,0,0,0,232,38,0,0,172,0,0,0,58,1,0,0,44,0,0,0,0,0,0,0,216,38,0,0,5,0,0,0,59,1,0,0,60,1,0,0,0,0,0,0,200,38,0,0,172,0,0,0,61,1,0,0,45,0,0,0,0,0,0,0,184,38,0,0,5,0,0,0,62,1,0,0,63,1,0,0,0,0,0,0,104,41,0,0,64,1,0,0,65,1,0,0,35,0,0,0,66,1,0,0,0,0,0,0,88,41,0,0,5,0,0,0,67,1,0,0,68,1,0,0,0,0,0,0,72,41,0,0,69,1,0,0,70,1,0,0,36,0,0,0,71,1,0,0,0,0,0,0,56,41,0,0,5,0,0,0,72,1,0,0,73,1,0,0,0,0,0,0,40,41,0,0,74,1,0,0,75,1,0,0,37,0,0,0,76,1,0,0,0,0,0,0,24,41,0,0,5,0,0,0,77,1,0,0,78,1,0,0,0,0,0,0,8,41,0,0,79,1,0,0,80,1,0,0,38,0,0,0,81,1,0,0,0,0,0,0,248,40,0,0,5,0,0,0,82,1,0,0,83,1,0,0,0,0,0,0,232,40,0,0,84,1,0,0,85,1,0,0,39,0,0,0,86,1,0,0,0,0,0,0,216,40,0,0,5,0,0,0,87,1,0,0,88,1,0,0,0,0,0,0,200,40,0,0,89,1,0,0,90,1,0,0,40,0,0,0,91,1,0,0,0,0,0,0,184,40,0,0,5,0,0,0,92,1,0,0,93,1,0,0,0,0,0,0,168,40,0,0,94,1,0,0,95,1,0,0,41,0,0,0,96,1,0,0,0,0,0,0,152,40,0,0,5,0,0,0,97,1,0,0,98,1,0,0,0,0,0,0,136,40,0,0,99,1,0,0,100,1,0,0,42,0,0,0,101,1,0,0,0,0,0,0,120,40,0,0,5,0,0,0,102,1,0,0,103,1,0,0,0,0,0,0,104,40,0,0,104,1,0,0,105,1,0,0,43,0,0,0,106,1,0,0,0,0,0,0,88,40,0,0,5,0,0,0,107,1,0,0,108,1,0,0,0,0,0,0,72,40,0,0,109,1,0,0,110,1,0,0,44,0,0,0,111,1,0,0,0,0,0,0,56,40,0,0,5,0,0,0,112,1,0,0,113,1,0,0,0,0,0,0,40,40,0,0,114,1,0,0,115,1,0,0,45,0,0,0,116,1,0,0,0,0,0,0,24,40,0,0,5,0,0,0,117,1,0,0,118,1,0,0,0,0,0,0,8,40,0,0,119,1,0,0,120,1,0,0,46,0,0,0,121,1,0,0,0,0,0,0,248,39,0,0,5,0,0,0,122,1,0,0,123,1,0,0,0,0,0,0,8,42,0,0,172,0,0,0,124,1,0,0,46,0,0,0,0,0,0,0,248,41,0,0,5,0,0,0,125,1,0,0,126,1,0,0,0,0,0,0,232,41,0,0,172,0,0,0,127,1,0,0,47,0,0,0,0,0,0,0,216,41,0,0,5,0,0,0,128,1,0,0,129,1,0,0,0,0,0,0,200,41,0,0,172,0,0,0,130,1,0,0,48,0,0,0,0,0,0,0,184,41,0,0,5,0,0,0,131,1,0,0,132,1,0,0,0,0,0,0,168,41,0,0,172,0,0,0,133,1,0,0,49,0,0,0,0,0,0,0,152,41,0,0,5,0,0,0,134,1,0,0,135,1,0,0,0,0,0,0,136,41,0,0,172,0,0,0,136,1,0,0,50,0,0,0,0,0,0,0,120,41,0,0,5,0,0,0,137,1,0,0,138,1,0,0,0,0,0,0,40,42,0,0,57,0,0,0,139,1,0,0,69,0,0,0,0,0,0,0,24,42,0,0,57,0,0,0,140,1,0,0,70,0,0,0,0,0,0,0,72,42,0,0,141,1,0,0,142,1,0,0,71,0,0,0,0,0,0,0,56,42,0,0,57,0,0,0,143,1,0,0,72,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,128,63,0,0,128,192,0,0,128,63,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,193,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,0,0,0,0,23,0,0,0,0,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,29,0,0,0,30,0,0,0,0,0,0,0,31,0,0,0,32,0,0,0,0,0,0,0,33,0,0,0,0,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,36,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,88,42,0,0,57,0,0,0,144,1,0,0,73,0,0,0,0,0,0,0,104,42,0,0,145,1,0,0,146,1,0,0,74,0,0,0,0,0,0,0,120,42,0,0,147,1,0,0,148,1,0,0,75,0,0,0,0,0,0,0,136,42,0,0,57,0,0,0,149,1,0,0,76,0,0,0,0,0,0,0,152,42,0,0,172,0,0,0,150,1,0,0,1,0,0,0,0,0,0,0,160,42,0,0,203,0,0,0,151,1,0,0,1,0,0,0,205,0,0,0,0,0,0,0,168,42,0,0,152,1,0,0,153,1,0,0,1,0,0,0,1,1,0,0,0,0,0,0,176,42,0,0,154,1,0,0,155,1,0,0,8,0,0,0,9,0,0,0,29,0,0,0,58,0,0,0,0,0,0,0,40,44,0,0,5,0,0,0,156,1,0,0,157,1,0,0,0,0,0,0,248,43,0,0,5,0,0,0,158,1,0,0,159,1,0,0,0,0,0,0,216,43,0,0,5,0,0,0,160,1,0,0,161,1,0,0,0,0,0,0,184,43,0,0,5,0,0,0,162,1,0,0,163,1,0,0,0,0,0,0,152,43,0,0,5,0,0,0,164,1,0,0,165,1,0,0,0,0,0,0,120,43,0,0,5,0,0,0,166,1,0,0,167,1,0,0,0,0,0,0,88,43,0,0,5,0,0,0,168,1,0,0,169,1,0,0,0,0,0,0,56,43,0,0,5,0,0,0,170,1,0,0,171,1,0,0,0,0,0,0,24,43,0,0,5,0,0,0,172,1,0,0,173,1,0,0,0,0,0,0,248,42,0,0,5,0,0,0,174,1,0,0,175,1,0,0,0,0,0,0,216,42,0,0,5,0,0,0,176,1,0,0,177,1,0,0,0,0,0,0,184,42,0,0,5,0,0,0,178,1,0,0,179,1,0,0,0,0,0,0,200,42,0,0,180,1,0,0,181,1,0,0,59,0,0,0,0,0,0,0,232,42,0,0,182,1,0,0,183,1,0,0,60,0,0,0,0,0,0,0,8,43,0,0,184,1,0,0,185,1,0,0,61,0,0,0,0,0,0,0,40,43,0,0,186,1,0,0,187,1,0,0,62,0,0,0,0,0,0,0,72,43,0,0,188,1,0,0,189,1,0,0,63,0,0,0,0,0,0,0,104,43,0,0,190,1,0,0,191,1,0,0,64,0,0,0,0,0,0,0,136,43,0,0,192,1,0,0,193,1,0,0,65,0,0,0,0,0,0,0,168,43,0,0,194,1,0,0,195,1,0,0,66,0,0,0,0,0,0,0,200,43,0,0,196,1,0,0,197,1,0,0,67,0,0,0,0,0,0,0,232,43,0,0,198,1,0,0,199,1,0,0,68,0,0,0,0,0,0,0,24,44,0,0,200,1,0,0,201,1,0,0,69,0,0,0,0,0,0,0,8,44,0,0,200,1,0,0,202,1,0,0,70,0,0,0,0,0,0,0,72,44,0,0,203,1,0,0,204,1,0,0,71,0,0,0,0,0,0,0,56,44,0,0,203,1,0,0,205,1,0,0,72,0,0,0,0,0,0,0,88,47,0,0,5,0,0,0,206,1,0,0,207,1,0,0,0,0,0,0,72,47,0,0,5,0,0,0,208,1,0,0,209,1,0,0,0,0,0,0,56,47,0,0,5,0,0,0,210,1,0,0,211,1,0,0,0,0,0,0,40,47,0,0,5,0,0,0,212,1,0,0,213,1,0,0,0,0,0,0,24,47,0,0,5,0,0,0,214,1,0,0,215,1,0,0,0,0,0,0,8,47,0,0,5,0,0,0,216,1,0,0,217,1,0,0,0,0,0,0,248,46,0,0,5,0,0,0,218,1,0,0,219,1,0,0,0,0,0,0,232,46,0,0,5,0,0,0,220,1,0,0,221,1,0,0,0,0,0,0,216,46,0,0,5,0,0,0,222,1,0,0,223,1,0,0,0,0,0,0,184,46,0,0,5,0,0,0,224,1,0,0,225,1,0,0,0,0,0,0,120,46,0,0,5,0,0,0,226,1,0,0,227,1,0,0,0,0,0,0,56,46,0,0,5,0,0,0,228,1,0,0,229,1,0,0,0,0,0,0,8,46,0,0,5,0,0,0,230,1,0,0,231,1,0,0,0,0,0,0,216,45,0,0,5,0,0,0,232,1,0,0,233,1,0,0,0,0,0,0,168,45,0,0,5,0,0,0,234,1,0,0,235,1,0,0,0,0,0,0,120,45,0,0,5,0,0,0,236,1,0,0,237,1,0,0,0,0,0,0,72,45,0,0,5,0,0,0,238,1,0,0,239,1,0,0,0,0,0,0,24,45,0,0,5,0,0,0,240,1,0,0,241,1,0,0,0,0,0,0,232,44,0,0,5,0,0,0,242,1,0,0,243,1,0,0,0,0,0,0,184,44,0,0,5,0,0,0,244,1,0,0,245,1,0,0,0,0,0,0,136,44,0,0,5,0,0,0,246,1,0,0,247,1,0,0,0,0,0,0,88,44,0,0,5,0,0,0,248,1,0,0,249,1,0,0,0,0,0,0,120,44,0,0,250,1,0,0,251,1,0,0,47,0,0,0,205,0,0,0,0,0,0,0,104,44,0,0,250,1,0,0,252,1,0,0,48,0,0,0,205,0,0,0,0,0,0,0,168,44,0,0,253,1,0,0,254,1,0,0,49,0,0,0,205,0,0,0,0,0,0,0,152,44,0,0,253,1,0,0,255,1,0,0,50,0,0,0,205,0,0,0,0,0,0,0,216,44,0,0,0,2,0,0,1,2,0,0,51,0,0,0,205,0,0,0,0,0,0,0,200,44,0,0,0,2,0,0,2,2,0,0,52,0,0,0,205,0,0,0,0,0,0,0,8,45,0,0,3,2,0,0,4,2,0,0,53,0,0,0,205,0,0,0,0,0,0,0,248,44,0,0,3,2,0,0,5,2,0,0,54,0,0,0,205,0,0,0,0,0,0,0,56,45,0,0,6,2,0,0,7,2,0,0,55,0,0,0,205,0,0,0,0,0,0,0,40,45,0,0,6,2,0,0,8,2,0,0,56,0,0,0,205,0,0,0,0,0,0,0,104,45,0,0,9,2,0,0,10,2,0,0,57,0,0,0,205,0,0,0,0,0,0,0,88,45,0,0,9,2,0,0,11,2,0,0,58,0,0,0,205,0,0,0,0,0,0,0,152,45,0,0,12,2,0,0,13,2,0,0,59,0,0,0,205,0,0,0,0,0,0,0,136,45,0,0,12,2,0,0,14,2,0,0,60,0,0,0,205,0,0,0,0,0,0,0,200,45,0,0,15,2,0,0,16,2,0,0,61,0,0,0,205,0,0,0,0,0,0,0,184,45,0,0,15,2,0,0,17,2,0,0,62,0,0,0,205,0,0,0,0,0,0,0,248,45,0,0,18,2,0,0,19,2,0,0,63,0,0,0,205,0,0,0,0,0,0,0,232,45,0,0,18,2,0,0,20,2,0,0,64,0,0,0,205,0,0,0,0,0,0,0,40,46,0,0,21,2,0,0,22,2,0,0,65,0,0,0,205,0,0,0,0,0,0,0,24,46,0,0,21,2,0,0,23,2,0,0,66,0,0,0,205,0,0,0,0,0,0,0,88,46,0,0,24,2,0,0,25,2,0,0,67,0,0,0,205,0,0,0,0,0,0,0,72,46,0,0,24,2,0,0,26,2,0,0,68,0,0,0,205,0,0,0,0,0,0,0,104,46,0,0,24,2,0,0,27,2,0,0,69,0,0,0,205,0,0,0,0,0,0,0,152,46,0,0,28,2,0,0,29,2,0,0,70,0,0,0,205,0,0,0,0,0,0,0,136,46,0,0,28,2,0,0,30,2,0,0,71,0,0,0,205,0,0,0,0,0,0,0,168,46,0,0,28,2,0,0,31,2,0,0,72,0,0,0,205,0,0,0,0,0,0,0,200,46,0,0,21,2,0,0,32,2,0,0,73,0,0,0,205,0,0,0,0,0,0,0,232,48,0,0,5,0,0,0,33,2,0,0,34,2,0,0,0,0,0,0,200,48,0,0,5,0,0,0,35,2,0,0,36,2,0,0,0,0,0,0,168,48,0,0,5,0,0,0,37,2,0,0,38,2,0,0,0,0,0,0,136,48,0,0,5,0,0,0,39,2,0,0,40,2,0,0,0,0,0,0,104,48,0,0,5,0,0,0,41,2,0,0,42,2,0,0,0,0,0,0,72,48,0,0,5,0,0,0,43,2,0,0,44,2,0,0,0,0,0,0,40,48,0,0,5,0,0,0,45,2,0,0,46,2,0,0,0,0,0,0,8,48,0,0,5,0,0,0,47,2,0,0,48,2,0,0,0,0,0,0,232,47,0,0,5,0,0,0,49,2,0,0,50,2,0,0,0,0,0,0,200,47,0,0,5,0,0,0,51,2,0,0,52,2,0,0,0,0,0,0,168,47,0,0,5,0,0,0,53,2,0,0,54,2,0,0,0,0,0,0,136,47,0,0,5,0,0,0,55,2,0,0,56,2,0,0,0,0,0,0,104,47,0,0,5,0,0,0,57,2,0,0,58,2,0,0,0,0,0,0,120,47,0,0,59,2,0,0,60,2,0,0,38,0,0,0,1,1,0,0,0,0,0,0,152,47,0,0,61,2,0,0,62,2,0,0,39,0,0,0,1,1,0,0,0,0,0,0,184,47,0,0,63,2,0,0,64,2,0,0,40,0,0,0,1,1,0,0,0,0,0,0,216,47,0,0,65,2,0,0,66,2,0,0,41,0,0,0,1,1,0,0,0,0,0,0,248,47,0,0,67,2,0,0,68,2,0,0,42,0,0,0,1,1,0,0,0,0,0,0,24,48,0,0,69,2,0,0,70,2,0,0,43,0,0,0,1,1,0,0,0,0,0,0,56,48,0,0,71,2,0,0,72,2,0,0,44,0,0,0,1,1,0,0,0,0,0,0,88,48,0,0,73,2,0,0,74,2,0,0,45,0,0,0,1,1,0,0,0,0,0,0,120,48,0,0,75,2,0,0,76,2,0,0,46,0,0,0,1,1,0,0,0,0,0,0,152,48,0,0,77,2,0,0,78,2,0,0,47,0,0,0,1,1,0,0,0,0,0,0,184,48,0,0,79,2,0,0,80,2,0,0,48,0,0,0,1,1,0,0,0,0,0,0,216,48,0,0,81,2,0,0,82,2,0,0,49,0,0,0,1,1,0,0,0,0,0,0,248,48,0,0,83,2,0,0,84,2,0,0,50,0,0,0,1,1,0,0,0,0,0,0,56,49,0,0,57,0,0,0,85,2,0,0,77,0,0,0,0,0,0,0,40,49,0,0,57,0,0,0,86,2,0,0,78,0,0,0,0,0,0,0,24,49,0,0,57,0,0,0,87,2,0,0,79,0,0,0,0,0,0,0,8,49,0,0,57,0,0,0,88,2,0,0,80,0,0,0,0,0,0,0,120,49,0,0,57,0,0,0,89,2,0,0,81,0,0,0,0,0,0,0,104,49,0,0,57,0,0,0,90,2,0,0,82,0,0,0,0,0,0,0,88,49,0,0,57,0,0,0,91,2,0,0,83,0,0,0,0,0,0,0,72,49,0,0,57,0,0,0,92,2,0,0,84,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,198,85,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,198,85,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,198,85,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,194,86,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,194,86,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,194,86,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,134,89,4,0,227,87,4,0,136,3,0,0,0,0,0,0,232,89,4,0,170,88,4,0,175,88,4,0,51,88,4,0,227,87,4,0,239,0,0,0,0,0,0,0,155,88,4,0,170,88,4,0,175,88,4,0,231,88,4,0,227,87,4,0,113,0,0,0,0,0,0,0,155,88,4,0,170,88,4,0,175,88,4,0,231,88,4,0,227,87,4,0,131,0,0,0,5,0,0,0,73,89,4,0,114,89,4,0,124,89,4,0,137,92,4,0,227,87,4,0,197,6,0,0,0,0,0,0,244,92,4,0,170,88,4,0,17,93,4,0,0,0,0,0,184,49,0,0,57,0,0,0,93,2,0,0,85,0,0,0,0,0,0,0,168,49,0,0,57,0,0,0,94,2,0,0,86,0,0,0,0,0,0,0,136,49,0,0,57,0,0,0,95,2,0,0,87,0,0,0,0,0,0,0,152,49,0,0,57,0,0,0,96,2,0,0,88,0,0,0,0,0,0,0,200,49,0,0,97,2,0,0,98,2,0,0,89,0,0,0,0,0,0,0,232,49,0,0,99,2,0,0,100,2,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,47,0,0,0,1,0,0,0,1,0,0,0,90,0,0,0,91,0,0,0,101,2,0,0,0,0,0,0,216,49,0,0,5,0,0,0,102,2,0,0,103,2,0,0,0,0,0,0,104,50,0,0,104,2,0,0,105,2,0,0,92,0,0,0,0,0,0,0,88,50,0,0,5,0,0,0,106,2,0,0,107,2,0,0,0,0,0,0,72,50,0,0,108,2,0,0,109,2,0,0,93,0,0,0,0,0,0,0,56,50,0,0,5,0,0,0,110,2,0,0,111,2,0,0,0,0,0,0,40,50,0,0,112,2,0,0,113,2,0,0,94,0,0,0,0,0,0,0,24,50,0,0,5,0,0,0,114,2,0,0,115,2,0,0,0,0,0,0,8,50,0,0,116,2,0,0,117,2,0,0,95,0,0,0,0,0,0,0,248,49,0,0,5,0,0,0,118,2,0,0,119,2,0,0,0,0,0,0,136,50,0,0,57,0,0,0,120,2,0,0,96,0,0,0,0,0,0,0,120,50,0,0,57,0,0,0,121,2,0,0,97,0,0,0,153,6,0,0,185,5,0,0,227,2,0,0,103,3,0,0,113,11,0,0,40,1,0,0,79,0,0,0,232,1,0,0,52,15,0,0,0,0,0,0,184,50,0,0,57,0,0,0,122,2,0,0,98,0,0,0,0,0,0,0,168,50,0,0,57,0,0,0,123,2,0,0,99,0,0,0,0,0,0,0,152,50,0,0,57,0,0,0,124,2,0,0,100,0,0,0,217,51,0,0,104,231,255,255,6,248,255,255,126,240,255,255,4,30,0,0,170],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+51200);allocate([228,0,0,0,188,252,255,255,235,16,0,0,0,0,0,0,232,50,0,0,57,0,0,0,125,2,0,0,101,0,0,0,0,0,0,0,216,50,0,0,57,0,0,0,126,2,0,0,102,0,0,0,0,0,0,0,200,50,0,0,57,0,0,0,127,2,0,0,103,0,0,0,0,0,0,0,40,51,0,0,57,0,0,0,128,2,0,0,104,0,0,0,0,0,0,0,24,51,0,0,57,0,0,0,129,2,0,0,105,0,0,0,0,0,0,0,8,51,0,0,57,0,0,0,130,2,0,0,106,0,0,0,0,0,0,0,248,50,0,0,57,0,0,0,131,2,0,0,107,0,0,0,3,0,0,0,0,0,0,0,104,51,0,0,57,0,0,0,132,2,0,0,108,0,0,0,0,0,0,0,88,51,0,0,57,0,0,0,133,2,0,0,109,0,0,0,0,0,0,0,72,51,0,0,57,0,0,0,134,2,0,0,110,0,0,0,0,0,0,0,56,51,0,0,57,0,0,0,135,2,0,0,111,0,0,0,99,110,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,99,110,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,99,110,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,93,111,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,93,111,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,93,111,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,0,0,0,0,152,51,0,0,57,0,0,0,136,2,0,0,112,0,0,0,0,0,0,0,136,51,0,0,57,0,0,0,137,2,0,0,113,0,0,0,0,0,0,0,120,51,0,0,57,0,0,0,138,2,0,0,114,0,0,0,0,0,0,0,168,51,0,0,57,0,0,0,139,2,0,0,115,0,0,0,0,0,0,0,184,51,0,0,57,0,0,0,140,2,0,0,116,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,0,0,0,0,232,51,0,0,57,0,0,0,141,2,0,0,117,0,0,0,0,0,0,0,216,51,0,0,57,0,0,0,142,2,0,0,118,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,0,0,0,0,200,51,0,0,57,0,0,0,143,2,0,0,119,0,0,0,0,0,0,0,24,52,0,0,57,0,0,0,144,2,0,0,120,0,0,0,0,0,0,0,8,52,0,0,57,0,0,0,145,2,0,0,121,0,0,0,0,0,0,0,248,51,0,0,57,0,0,0,146,2,0,0,122,0,0,0,0,0,0,0,40,52,0,0,57,0,0,0,147,2,0,0,123,0,0,0,0,0,0,0,56,52,0,0,57,0,0,0,148,2,0,0,124,0,0,0,0,0,0,0,72,52,0,0,57,0,0,0,149,2,0,0,125,0,0,0,0,0,0,0,88,52,0,0,57,0,0,0,150,2,0,0,126,0,0,0,143,115,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,143,115,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,143,115,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,135,116,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,135,116,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,135,116,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,133,117,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,133,117,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,133,117,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,131,118,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,131,118,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,131,118,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,125,119,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,125,119,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,125,119,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,119,120,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,119,120,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,119,120,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,119,121,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,119,121,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,119,121,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,119,122,4,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,119,122,4,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,119,122,4,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,180,158,17,0,119,123,4,0,136,123,4,0,167,123,4,0,190,123,4,0,214,123,4,0,236,123,4,0,253,123,4,0,27,124,4,0,44,124,4,0,51,124,4,0,66,124,4,0,83,124,4,0,95,124,4,0,117,124,4,0,134,124,4,0,163,124,4,0,183,124,4,0,217,124,4,0,242,124,4,0,13,125,4,0,25,125,4,0,44,125,4,0,56,125,4,0,78,125,4,0,90,125,4,0,104,125,4,0,119,123,4,0,136,123,4,0,121,125,4,0,133,125,4,0,214,123,4,0,104,125,4,0,27,124,4,0,150,125,4,0,44,124,4,0,66,124,4,0,189,125,4,0,95,124,4,0,117,124,4,0,201,125,4,0,134,124,4,0,223,125,4,0,163,124,4,0,240,125,4,0,13,125,4,0,3,126,4,0,33,126,4,0,78,125,4,0,59,126,4,0,83,126,4,0,110,126,4,0,127,126,4,0,160,126,4,0,189,126,4,0,213,126,4,0,235,126,4,0,252,126,4,0,27,127,4,0,44,127,4,0,51,127,4,0,68,127,4,0,85,127,4,0,97,127,4,0,119,127,4,0,136,127,4,0,169,127,4,0,191,127,4,0,243,127,4,0,20,128,4,0,47,128,4,0,59,128,4,0,78,128,4,0,90,128,4,0,112,128,4,0,124,128,4,0,138,128,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,149,128,4,0,166,128,4,0,173,128,4,0,185,128,4,0,192,128,4,0,199,128,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,214,128,4,0,240,128,4,0,10,129,4,0,31,129,4,0,57,129,4,0,78,129,4,0,96,129,4,0,128,129,4,0,148,129,4,0,166,129,4,0,190,129,4,0,44,124,4,0,207,129,4,0,244,129,4,0,8,130,4,0,29,130,4,0,55,130,4,0,81,130,4,0,97,130,4,0,124,130,4,0,142,130,4,0,162,130,4,0,174,130,4,0,196,130,4,0,208,130,4,0,226,130,4,0,237,130,4,0,6,131,4,0,43,131,4,0,69,131,4,0,100,131,4,0,130,131,4,0,162,131,4,0,194,131,4,0,233,131,4,0,248,131,4,0,17,132,4,0,35,132,4,0,68,132,4,0,86,132,4,0,8,130,4,0,129,132,4,0,152,132,4,0,175,132,4,0,198,132,4,0,212,132,4,0,235,132,4,0,10,133,4,0,34,133,4,0,62,133,4,0,92,133,4,0,124,133,4,0,147,133,4,0,166,133,4,0,198,133,4,0,223,133,4,0,247,133,4,0,25,134,4,0,53,134,4,0,83,134,4,0,115,134,4,0,140,134,4,0,153,134,4,0,202,134,4,0,8,130,4,0,236,134,4,0,12,135,4,0,38,135,4,0,62,135,4,0,89,135,4,0,107,135,4,0,141,135,4,0,166,135,4,0,206,135,4,0,242,135,4,0,22,136,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,47,136,4,0,76,136,4,0,102,136,4,0,136,136,4,0,166,136,4,0,180,158,17,0,180,158,17,0,191,136,4,0,249,136,4,0,2,137,4,0,11,137,4,0,22,137,4,0,33,137,4,0,58,137,4,0,83,137,4,0,131,137,4,0,134,137,4,0,137,137,4,0,162,137,4,0,171,137,4,0,190,137,4,0,220,137,4,0,234,137,4,0,6,138,4,0,35,138,4,0,47,138,4,0,85,138,4,0,114,138,4,0,127,138,4,0,142,138,4,0,166,138,4,0,192,138,4,0,215,138,4,0,249,138,4,0,0,139,4,0,12,139,4,0,33,139,4,0,65,139,4,0,72,139,4,0,87,139,4,0,102,139,4,0,109,139,4,0,116,139,4,0,128,139,4,0,140,139,4,0,152,139,4,0,169,139,4,0,182,139,4,0,197,139,4,0,212,139,4,0,226,139,4,0,248,139,4,0,35,140,4,0,73,140,4,0,180,158,17,0,110,140,4,0,134,140,4,0,196,140,4,0,180,158,17,0,203,140,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,216,140,4,0,180,158,17,0,46,141,4,0,180,158,17,0,100,141,4,0,180,158,17,0,116,141,4,0,180,158,17,0,129,141,4,0,180,158,17,0,183,141,4,0,190,141,4,0,180,158,17,0,202,141,4,0,36,142,4,0,134,142,4,0,227,142,4,0,91,143,4,0,238,143,4,0,159,144,4,0,67,145,4,0,209,145,4,0,90,146,4,0,136,146,4,0,239,146,4,0,61,147,4,0,173,147,4,0,8,148,4,0,30,148,4,0,180,158,17,0,65,148,4,0,108,148,4,0,151,148,4,0,183,148,4,0,215,148,4,0,180,158,17,0,247,148,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,8,149,4,0,25,149,4,0,72,149,4,0,111,149,4,0,143,149,4,0,165,149,4,0,182,149,4,0,228,149,4,0,245,149,4,0,252,149,4,0,19,150,4,0,36,150,4,0,48,150,4,0,70,150,4,0,87,150,4,0,132,150,4,0,160,150,4,0,210,150,4,0,243,150,4,0,30,151,4,0,42,151,4,0,65,151,4,0,77,151,4,0,99,151,4,0,111,151,4,0,125,151,4,0,8,149,4,0,25,149,4,0,142,151,4,0,154,151,4,0,143,149,4,0,125,151,4,0,228,149,4,0,171,151,4,0,245,149,4,0,19,150,4,0,221,151,4,0,48,150,4,0,70,150,4,0,233,151,4,0,87,150,4,0,250,151,4,0,132,150,4,0,11,152,4,0,30,151,4,0,30,152,4,0,68,152,4,0,110,152,4,0,122,152,4,0,158,152,4,0,193,152,4,0,234,152,4,0,60,153,4,0,109,153,4,0,180,153,4,0,237,153,4,0,36,154,4,0,95,154,4,0,171,154,4,0,222,154,4,0,17,155,4,0,94,155,4,0,153,155,4,0,242,155,4,0,50,156,4,0,109,156,4,0,172,156,4,0,237,156,4,0,58,157,4,0,115,157,4,0,165,157,4,0,231,157,4,0,40,158,4,0,88,158,4,0,160,158,4,0,236,158,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,61,159,4,0,78,159,4,0,85,159,4,0,97,159,4,0,104,159,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,117,159,4,0,153,159,4,0,189,159,4,0,220,159,4,0,0,160,4,0,37,160,4,0,55,160,4,0,101,160,4,0,123,160,4,0,141,160,4,0,165,160,4,0,245,149,4,0,182,160,4,0,219,160,4,0,241,160,4,0,22,161,4,0,58,161,4,0,94,161,4,0,112,161,4,0,149,161,4,0,167,161,4,0,189,161,4,0,201,161,4,0,223,161,4,0,235,161,4,0,255,161,4,0,16,162,4,0,64,162,4,0,125,162,4,0,159,162,4,0,208,162,4,0,246,162,4,0,36,163,4,0,74,163,4,0,129,163,4,0,148,163,4,0,185,163,4,0,203,163,4,0,244,163,4,0,16,164,4,0,73,164,4,0,110,164,4,0,135,164,4,0,174,164,4,0,211,164,4,0,227,164,4,0,4,165,4,0,47,165,4,0,75,165,4,0,115,165,4,0,161,165,4,0,206,165,4,0,253,165,4,0,26,166,4,0,74,166,4,0,109,166,4,0,158,166,4,0,214,166,4,0,16,167,4,0,48,167,4,0,88,167,4,0,153,167,4,0,190,167,4,0,255,167,4,0,45,168,4,0,92,168,4,0,139,168,4,0,193,168,4,0,224,168,4,0,0,169,4,0,31,169,4,0,69,169,4,0,103,169,4,0,152,169,4,0,192,169,4,0,238,169,4,0,29,170,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,74,170,4,0,127,170,4,0,159,170,4,0,205,170,4,0,247,170,4,0,180,158,17,0,180,158,17,0,24,171,4,0,112,171,4,0,121,171,4,0,130,171,4,0,147,171,4,0,164,171,4,0,197,171,4,0,230,171,4,0,134,137,4,0,37,172,4,0,40,172,4,0,77,172,4,0,88,172,4,0,119,172,4,0,152,172,4,0,166,172,4,0,203,172,4,0,252,172,4,0,8,173,4,0,69,173,4,0,118,173,4,0,131,173,4,0,150,173,4,0,174,173,4,0,204,173,4,0,222,173,4,0,8,174,4,0,15,174,4,0,27,174,4,0,56,174,4,0,109,174,4,0,116,174,4,0,139,174,4,0,162,174,4,0,169,174,4,0,176,174,4,0,188,174,4,0,200,174,4,0,212,174,4,0,229,174,4,0,242,174,4,0,3,175,4,0,20,175,4,0,38,175,4,0,60,175,4,0,131,175,4,0,185,175,4,0,238,175,4,0,250,175,4,0,6,176,4,0,15,176,4,0,50,176,4,0,113,176,4,0,165,176,4,0,203,176,4,0,39,177,4,0,143,177,4,0,180,158,17,0,180,158,17,0,180,158,17,0,248,177,4,0,28,178,4,0,60,178,4,0,77,178,4,0,127,178,4,0,175,178,4,0,201,178,4,0,221,178,4,0,244,178,4,0,15,179,4,0,38,179,4,0,53,179,4,0,66,179,4,0,81,179,4,0,96,179,4,0,139,179,4,0,182,179,4,0,245,179,4,0,29,180,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,89,180,4,0,96,180,4,0,103,180,4,0,110,180,4,0,117,180,4,0,124,180,4,0,131,180,4,0,180,158,17,0,138,180,4,0,145,180,4,0,152,180,4,0,159,180,4,0,180,158,17,0,166,180,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,173,180,4,0,192,180,4,0,211,180,4,0,230,180,4,0,249,180,4,0,4,181,4,0,15,181,4,0,26,181,4,0,37,181,4,0,84,181,4,0,131,181,4,0,178,181,4,0,225,181,4,0,12,182,4,0,51,182,4,0,180,158,17,0,102,182,4,0,119,182,4,0,130,182,4,0,142,182,4,0,159,182,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,176,182,4,0,213,182,4,0,226,182,4,0,237,182,4,0,250,182,4,0,19,183,4,0,31,183,4,0,43,183,4,0,180,158,17,0,180,158,17,0,60,183,4,0,124,183,4,0,172,183,4,0,203,183,4,0,234,183,4,0,9,184,4,0,40,184,4,0,180,158,17,0,180,158,17,0,180,158,17,0,80,184,4,0,105,184,4,0,126,184,4,0,152,184,4,0,184,184,4,0,221,184,4,0,242,184,4,0,15,185,4,0,79,185,4,0,99,185,4,0,165,185,4,0,23,186,4,0,195,186,4,0,17,187,4,0,79,187,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,106,187,4,0,119,187,4,0,140,187,4,0,169,187,4,0,176,182,4,0,206,187,4,0,251,187,4,0,64,188,4,0,133,188,4,0,234,188,4,0,46,189,4,0,111,189,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,172,189,4,0,204,189,4,0,14,190,4,0,62,190,4,0,112,190,4,0,152,190,4,0,188,190,4,0,0,191,4,0,47,191,4,0,69,191,4,0,106,191,4,0,153,191,4,0,179,191,4,0,231,191,4,0,12,192,4,0,75,192,4,0,122,192,4,0,213,192,4,0,26,193,4,0,90,193,4,0,120,193,4,0,158,193,4,0,185,193,4,0,227,193,4,0,8,194,4,0,44,194,4,0,172,189,4,0,204,189,4,0,74,194,4,0,100,194,4,0,112,190,4,0,44,194,4,0,0,191,4,0,127,194,4,0,47,191,4,0,106,191,4,0,210,194,4,0,179,191,4,0,231,191,4,0,237,194,4,0,12,192,4,0,43,195,4,0,75,192,4,0,80,195,4,0,90,193,4,0,117,195,4,0,180,195,4,0,227,193,4,0,255,195,4,0,60,196,4,0,127,196,4,0,159,196,4,0,223,196,4,0,17,197,4,0,67,197,4,0,107,197,4,0,143,197,4,0,207,197,4,0,254,197,4,0,20,198,4,0,57,198,4,0,104,198,4,0,130,198,4,0,182,198,4,0,219,198,4,0,26,199,4,0,71,199,4,0,160,199,4,0,225,199,4,0,25,200,4,0,55,200,4,0,93,200,4,0,120,200,4,0,162,200,4,0,199,200,4,0,235,200,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,9,201,4,0,16,201,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,28,201,4,0,90,201,4,0,145,201,4,0,193,201,4,0,253,201,4,0,48,202,4,0,86,202,4,0,166,202,4,0,217,202,4,0,250,202,4,0,38,203,4,0,85,203,4,0,107,203,4,0,187,203,4,0,238,203,4,0,37,204,4,0,97,204,4,0,152,204,4,0,193,204,4,0,245,204,4,0,16,205,4,0,67,205,4,0,94,205,4,0,136,205,4,0,173,205,4,0,216,205,4,0,246,205,4,0,52,206,4,0,128,206,4,0,165,206,4,0,241,206,4,0,37,207,4,0,93,207,4,0,143,207,4,0,212,207,4,0,238,207,4,0,31,208,4,0,59,208,4,0,108,208,4,0,144,208,4,0,213,208,4,0,12,209,4,0,48,209,4,0,104,209,4,0,159,209,4,0,185,209,4,0,233,209,4,0,45,210,4,0,78,210,4,0,132,210,4,0,202,210,4,0,8,211,4,0,69,211,4,0,113,211,4,0,180,211,4,0,226,211,4,0,15,212,4,0,81,212,4,0,136,212,4,0,187,212,4,0,238,212,4,0,42,213,4,0,73,213,4,0,161,213,4,0,213,208,4,0,225,213,4,0,36,214,4,0,89,214,4,0,132,214,4,0,180,214,4,0,211,214,4,0,185,209,4,0,19,215,4,0,91,215,4,0,165,215,4,0,233,215,4,0,28,216,4,0,101,216,4,0,154,216,4,0,203,216,4,0,35,217,4,0,119,217,4,0,180,158,17,0,141,217,4,0,182,217,4,0,250,217,4,0,59,218,4,0,180,158,17,0,180,158,17,0,180,158,17,0,103,218,4,0,190,218,4,0,7,219,4,0,79,219,4,0,198,219,4,0,60,220,4,0,180,158,17,0,100,220,4,0,103,220,4,0,106,220,4,0,161,220,4,0,180,220,4,0,248,220,4,0,68,221,4,0,92,221,4,0,155,221,4,0,226,221,4,0,11,222,4,0,109,222,4,0,180,222,4,0,193,222,4,0,210,222,4,0,234,222,4,0,6,223,4,0,35,223,4,0,92,223,4,0,104,223,4,0,126,223,4,0,147,223,4,0,164,223,4,0,171,223,4,0,203,223,4,0,235,223,4,0,1,224,4,0,23,224,4,0,72,224,4,0,121,224,4,0,130,224,4,0,139,224,4,0,146,224,4,0,158,224,4,0,165,224,4,0,177,224,4,0,194,224,4,0,211,224,4,0,223,224,4,0,236,224,4,0,9,225,4,0,21,225,4,0,38,225,4,0,55,225,4,0,64,225,4,0,73,225,4,0,92,225,4,0,111,225,4,0,154,225,4,0,186,225,4,0,202,225,4,0,216,225,4,0,230,225,4,0,2,226,4,0,19,226,4,0,36,226,4,0,53,226,4,0,180,158,17,0,70,226,4,0,93,226,4,0,116,226,4,0,139,226,4,0,162,226,4,0,190,226,4,0,215,226,4,0,240,226,4,0,9,227,4,0,34,227,4,0,107,227,4,0,134,227,4,0,153,227,4,0,205,227,4,0,28,228,4,0,81,228,4,0,132,228,4,0,213,228,4,0,15,229,4,0,81,229,4,0,103,229,4,0,181,229,4,0,236,229,4,0,62,230,4,0,180,158,17,0,84,230,4,0,132,230,4,0,194,230,4,0,238,230,4,0,29,231,4,0,77,231,4,0,124,231,4,0,175,231,4,0,227,231,4,0,21,232,4,0,72,232,4,0,112,232,4,0,156,232,4,0,178,232,4,0,246,232,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,58,233,4,0,95,233,4,0,132,233,4,0,172,233,4,0,212,233,4,0,234,233,4,0,0,234,4,0,51,234,4,0,102,234,4,0,150,234,4,0,198,234,4,0,222,234,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,30,235,4,0,62,235,4,0,148,235,4,0,212,235,4,0,14,236,4,0,54,236,4,0,90,236,4,0,167,236,4,0,214,236,4,0,236,236,4,0,19,237,4,0,66,237,4,0,92,237,4,0,144,237,4,0,181,237,4,0,12,238,4,0,67,238,4,0,192,238,4,0,21,239,4,0,89,239,4,0,119,239,4,0,163,239,4,0,190,239,4,0,232,239,4,0,13,240,4,0,49,240,4,0,30,235,4,0,62,235,4,0,79,240,4,0,105,240,4,0,14,236,4,0,49,240,4,0,167,236,4,0,132,240,4,0,214,236,4,0,19,237,4,0,239,240,4,0,92,237,4,0,144,237,4,0,10,241,4,0,181,237,4,0,72,241,4,0,12,238,4,0,109,241,4,0,89,239,4,0,146,241,4,0,209,241,4,0,232,239,4,0,44,242,4,0,121,242,4,0,204,242,4,0,236,242,4,0,58,243,4,0,126,243,4,0,184,243,4,0,224,243,4,0,4,244,4,0,86,244,4,0,133,244,4,0,155,244,4,0,196,244,4,0,243,244,4,0,13,245,4,0,65,245,4,0,102,245,4,0,185,245,4,0,236,245,4,0,99,246,4,0,178,246,4,0,248,246,4,0,22,247,4,0,70,247,4,0,97,247,4,0,139,247,4,0,176,247,4,0,212,247,4,0,242,247,4,0,71,248,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,130,248,4,0,137,248,4,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,149,248,4,0,225,248,4,0,32,249,4,0,88,249,4,0,156,249,4,0,217,249,4,0,3,250,4,0,119,250,4,0,170,250,4,0,203,250,4,0,251,250,4,0,42,251,4,0,64,251,4,0,144,251,4,0,195,251,4,0,10,252,4,0,78,252,4,0,141,252,4,0,184,252,4,0,248,252,4,0,23,253,4,0,74,253,4,0,101,253,4,0,143,253,4,0,180,253,4,0,221,253,4,0,251,253,4,0,73,254,4,0,183,254,4,0,237,254,4,0,68,255,4,0,130,255,4,0,192,255,4,0,254,255,4,0,85,0,5,0,115,0,5,0,170,0,5,0,214,0,5,0,11,1,5,0,56,1,5,0,143,1,5,0,206,1,5,0,246,1,5,0,51,2,5,0,119,2,5,0,149,2,5,0,210,2,5,0,27,3,5,0,72,3,5,0,138,3,5,0,224,3,5,0,44,4,5,0,113,4,5,0,163,4,5,0,244,4,5,0,40,5,5,0,109,5,5,0,193,5,5,0,252,5,5,0,47,6,5,0,110,6,5,0,174,6,5,0,209,6,5,0,53,7,5,0,143,1,5,0,125,7,5,0,206,7,5,0,13,8,5,0,64,8,5,0,120,8,5,0,155,8,5,0,227,8,5,0,23,9,5,0,103,9,5,0,185,9,5,0,9,10,5,0,68,10,5,0,149,10,5,0,210,10,5,0,18,11,5,0,118,11,5,0,221,11,5,0,180,158,17,0,243,11,5,0,36,12,5,0,120,12,5,0,201,12,5,0,180,158,17,0,180,158,17,0,255,12,5,0,88,13,5,0,223,13,5,0,68,14,5,0,172,14,5,0,83,15,5,0,253,15,5,0,180,158,17,0,134,137,4,0,37,172,4,0,37,16,5,0,116,16,5,0,137,16,5,0,225,16,5,0,61,17,5,0,85,17,5,0,160,17,5,0,255,17,5,0,58,18,5,0,180,18,5],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+61440);allocate([118,173,4,0,19,19,5,0,150,173,4,0,36,19,5,0,64,19,5,0,93,19,5,0,156,19,5,0,168,19,5,0,27,174,4,0,190,19,5,0,109,174,4,0,132,233,4,0,172,233,4,0,212,233,4,0,234,233,4,0,0,234,4,0,51,234,4,0,207,19,5,0,216,19,5,0,162,174,4,0,225,19,5,0,169,174,4,0,176,174,4,0,237,19,5,0,254,19,5,0,200,174,4,0,15,20,5,0,38,20,5,0,188,174,4,0,67,20,5,0,84,20,5,0,112,171,4,0,121,171,4,0,101,20,5,0,120,20,5,0,139,20,5,0,182,20,5,0,230,20,5,0,246,20,5,0,4,21,5,0,18,21,5,0,3,175,4,0,242,174,4,0,54,21,5,0,71,21,5,0,88,21,5,0,107,21,5,0,134,21,5,0,161,21,5,0,188,21,5,0,215,21,5,0,247,21,5,0,12,22,5,0,33,22,5,0,54,22,5,0,75,22,5,0,162,22,5,0,189,22,5,0,222,234,4,0,208,22,5,0,51,23,5,0,104,23,5,0,167,23,5,0,8,24,5,0,118,24,5,0,38,175,4,0,200,24,5,0,34,25,5,0,90,25,5,0,193,25,5,0,180,158,17,0,215,25,5,0,34,26,5,0,118,26,5,0,170,26,5,0,225,26,5,0,29,27,5,0,82,27,5,0,139,27,5,0,224,27,5,0,37,28,5,0,96,28,5,0,144,28,5,0,196,28,5,0,218,28,5,0,58,29,5,0,154,29,5,0,179,29,5,0,204,29,5,0,229,29,5,0,180,158,17,0,254,29,5,0,76,30,5,0,175,30,5,0,231,30,5,0,67,31,5,0,162,31,5,0,252,31,5,0,75,32,5,0,131,32,5,0,190,32,5,0,255,32,5,0,65,33,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,155,33,5,0,178,33,5,0,213,33,5,0,248,33,5,0,248,33,5,0,59,34,5,0,122,34,5,0,154,34,5,0,186,34,5,0,234,34,5,0,10,35,5,0,42,35,5,0,131,35,5,0,179,35,5,0,93,36,5,0,30,37,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,155,33,5,0,178,33,5,0,213,33,5,0,82,37,5,0,248,33,5,0,59,34,5,0,122,34,5,0,154,34,5,0,186,34,5,0,234,34,5,0,10,35,5,0,145,37,5,0,213,37,5,0,179,35,5,0,5,38,5,0,170,38,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,75,39,5,0,112,39,5,0,154,39,5,0,210,39,5,0,10,40,5,0,36,40,5,0,62,40,5,0,137,40,5,0,212,40,5,0,20,41,5,0,84,41,5,0,110,41,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,221,41,5,0,1,42,5,0,85,42,5,0,161,42,5,0,223,42,5,0,15,43,5,0,53,43,5,0,141,43,5,0,181,43,5,0,197,43,5,0,237,43,5,0,21,44,5,0,47,44,5,0,93,44,5,0,129,44,5,0,209,44,5,0,5,45,5,0,99,45,5,0,163,45,5,0,249,45,5,0,21,46,5,0,69,46,5,0,95,46,5,0,141,46,5,0,171,46,5,0,203,46,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,239,46,5,0,57,47,5,0,193,47,5,0,19,48,5,0,105,48,5,0,201,48,5,0,35,49,5,0,139,49,5,0,247,49,5,0,57,50,5,0,125,50,5,0,239,50,5,0,63,51,5,0,157,51,5,0,231,51,5,0,43,52,5,0,147,52,5,0,233,52,5,0,103,53,5,0,175,53,5,0,250,53,5,0,70,54,5,0,142,54,5,0,220,54,5,0,67,55,5,0,149,55,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,236,55,5,0,50,56,5,0,120,56,5,0,184,56,5,0,254,56,5,0,70,57,5,0,115,57,5,0,209,57,5,0,1,58,5,0,47,58,5,0,93,58,5,0,181,43,5,0,133,58,5,0,213,58,5,0,5,59,5,0,77,59,5,0,147,59,5,0,217,59,5,0,1,60,5,0,95,60,5,0,125,60,5,0,173,60,5,0,199,60,5,0,245,60,5,0,19,61,5,0,51,61,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,87,61,5,0,151,61,5,0,196,61,5,0,240,61,5,0,48,62,5,0,94,62,5,0,148,62,5,0,222,62,5,0,23,63,5,0,60,63,5,0,107,63,5,0,165,63,5,0,198,63,5,0,28,64,5,0,90,64,5,0,148,64,5,0,205,64,5,0,17,65,5,0,63,65,5,0,106,65,5,0,144,65,5,0,196,65,5,0,241,65,5,0,54,66,5,0,134,66,5,0,196,66,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,134,137,4,0,37,172,4,0,14,67,5,0,95,67,5,0,119,67,5,0,185,67,5,0,19,68,5,0,52,68,5,0,151,68,5,0,14,69,5,0,37,69,5,0,170,69,5,0,33,70,5,0,65,70,5,0,111,70,5,0,173,70,5,0,249,70,5,0,39,71,5,0,149,71,5,0,195,71,5,0,241,71,5,0,124,72,5,0,223,72,5,0,239,72,5,0,31,73,5,0,79,73,5,0,150,73,5,0,166,73,5,0,196,73,5,0,226,73,5,0,247,73,5,0,31,74,5,0,90,74,5,0,110,74,5,0,130,74,5,0,188,74,5,0,56,75,5,0,219,75,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,134,137,4,0,37,172,4,0,65,76,5,0,148,76,5,0,176,76,5,0,2,77,5,0,100,77,5,0,119,77,5,0,194,77,5,0,29,78,5,0,86,78,5,0,208,78,5,0,43,79,5,0,56,79,5,0,73,79,5,0,95,79,5,0,123,79,5,0,155,79,5,0,222,79,5,0,239,79,5,0,0,80,5,0,109,80,5,0,189,80,5,0,196,80,5,0,236,80,5,0,20,81,5,0,169,174,4,0,176,174,4,0,188,174,4,0,37,81,5,0,49,81,5,0,71,81,5,0,112,171,4,0,121,171,4,0,100,81,5,0,122,81,5,0,8,24,5,0,51,23,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,30,235,4,0,185,81,5,0,62,235,4,0,79,240,4,0,244,81,5,0,14,236,4,0,43,82,5,0,178,82,5,0,10,83,5,0,57,83,5,0,123,83,5,0,204,83,5,0,92,237,4,0,167,236,4,0,181,237,4,0,72,241,4,0,12,238,4,0,148,235,4,0,89,239,4,0,251,83,5,0,40,84,5,0,232,239,4,0,131,84,5,0,178,84,5,0,229,84,5,0,25,85,5,0,87,85,5,0,146,85,5,0,221,85,5,0,20,86,5,0,97,86,5,0,209,86,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,149,248,4,0,38,87,5,0,132,87,5,0,202,87,5,0,228,87,5,0,156,249,4,0,13,88,5,0,124,88,5,0,206,88,5,0,253,88,5,0,63,89,5,0,134,89,5,0,175,89,5,0,227,89,5,0,195,251,4,0,18,90,5,0,10,252,4,0,32,249,4,0,55,90,5,0,85,90,5,0,126,90,5,0,143,253,4,0,224,90,5,0,9,91,5,0,60,91,5,0,112,91,5,0,168,91,5,0,219,91,5,0,30,92,5,0,77,92,5,0,144,92,5,0,240,92,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,59,93,5,0,121,93,5,0,6,94,5,0,79,94,5,0,191,94,5,0,77,95,5,0,197,95,5,0,53,96,5,0,190,96,5,0,1,97,5,0,84,97,5,0,201,97,5,0,34,98,5,0,141,98,5,0,208,98,5,0,57,99,5,0,162,99,5,0,54,100,5,0,198,100,5,0,29,101,5,0,126,101,5,0,207,101,5,0,10,102,5,0,105,102,5,0,197,102,5,0,24,103,5,0,59,93,5,0,121,93,5,0,95,103,5,0,184,103,5,0,191,94,5,0,24,103,5,0,53,96,5,0,221,103,5,0,190,96,5,0,84,97,5,0,130,104,5,0,34,98,5,0,141,98,5,0,187,104,5,0,208,98,5,0,103,105,5,0,57,99,5,0,230,105,5,0,29,101,5,0,37,106,5,0,151,106,5,0,105,102,5,0,41,107,5,0,193,107,5,0,46,108,5,0,112,108,5,0,253,108,5,0,78,109,5,0,192,109,5,0,73,110,5,0,193,110,5,0,59,111,5,0,196,111,5,0,7,112,5,0,94,112,5,0,216,112,5,0,44,113,5,0,160,113,5,0,234,113,5,0,87,114,5,0,194,114,5,0,88,115,5,0,228,115,5,0,59,116,5,0,151,116,5,0,238,116,5,0,43,117,5,0,142,117,5,0,234,117,5,0,66,118,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,127,118,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,161,118,5,0,9,119,5,0,97,119,5,0,164,119,5,0,4,120,5,0,83,120,5,0,156,120,5,0,70,121,5,0,184,121,5,0,3,122,5,0,79,122,5,0,183,122,5,0,237,122,5,0,155,123,5,0,13,124,5,0,102,124,5,0,211,124,5,0,56,125,5,0,133,125,5,0,216,125,5,0,2,126,5,0,80,126,5,0,134,126,5,0,212,126,5,0,38,127,5,0,110,127,5,0,181,127,5,0,28,128,5,0,158,128,5,0,252,128,5,0,113,129,5,0,209,129,5,0,54,130,5,0,134,130,5,0,1,131,5,0,52,131,5,0,157,131,5,0,211,131,5,0,35,132,5,0,108,132,5,0,13,124,5,0,239,132,5,0,53,133,5,0,142,133,5,0,245,133,5,0,39,134,5,0,117,134,5,0,232,134,5,0,46,135,5,0,149,135,5,0,255,135,5,0,95,136,5,0,194,136,5,0,5,137,5,0,115,137,5,0,180,137,5,0,12,138,5,0,122,138,5,0,198,138,5,0,8,139,5,0,94,139,5,0,185,139,5,0,234,139,5,0,93,140,5,0,173,140,5,0,6,141,5,0,129,141,5,0,234,141,5,0,36,142,5,0,127,142,5,0,171,142,5,0,251,142,5,0,52,143,5,0,144,143,5,0,243,143,5,0,81,144,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,154,144,5,0,13,145,5,0,98,145,5,0,205,145,5,0,62,146,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,134,137,4,0,37,172,4,0,142,146,5,0,239,146,5,0,32,147,5,0,151,147,5,0,41,148,5,0,90,148,5,0,195,148,5,0,73,149,5,0,154,149,5,0,48,150,5,0,33,70,5,0,65,70,5,0,111,70,5,0,173,70,5,0,182,150,5,0,246,150,5,0,149,71,5,0,195,71,5,0,90,151,5,0,232,151,5,0,223,72,5,0,85,152,5,0,138,152,5,0,79,73,5,0,150,73,5,0,166,73,5,0,196,73,5,0,226,73,5,0,247,73,5,0,31,74,5,0,90,74,5,0,110,74,5,0,130,74,5,0,191,152,5,0,71,153,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,134,137,4,0,37,172,4,0,203,153,5,0,60,154,5,0,97,154,5,0,197,154,5,0,65,155,5,0,93,155,5,0,186,155,5,0,49,156,5,0,122,156,5,0,59,157,5,0,178,157,5,0,210,157,5,0,253,157,5,0,59,158,5,0,132,158,5,0,196,158,5,0,54,159,5,0,97,159,5,0,140,159,5,0,24,160,5,0,125,160,5,0,141,160,5,0,203,160,5,0,9,161,5,0,150,73,5,0,166,73,5,0,196,73,5,0,80,161,5,0,101,161,5,0,141,161,5,0,90,74,5,0,110,74,5,0,200,161,5,0,2,162,5,0,138,162,5,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,180,158,17,0,0,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,35,19,0,0,145,37,0,0,76,7,0,0,33,56,0,0,125,31,0,0,0,0,0,0,136,52,0,0,57,0,0,0,151,2,0,0,127,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,35,19,0,0,145,37,0,0,76,7,0,0,33,56,0,0,125,31,0,0,0,0,0,0,120,52,0,0,57,0,0,0,152,2,0,0,128,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,43,135,54,63,78,98,16,63,135,22,153,62,162,69,22,63,213,120,233,61,18,131,96,63,109,231,251,62,0,0,0,0,104,52,0,0,57,0,0,0,153,2,0,0,129,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,246,72,0,0,209,218,255,255,184,230,255,255,12,130,0,0,0,0,0,0,184,52,0,0,57,0,0,0,154,2,0,0,130,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,246,72,0,0,209,218,255,255,184,230,255,255,12,130,0,0,0,0,0,0,168,52,0,0,57,0,0,0,155,2,0,0,131,0,0,0,129,149,179,63,180,200,54,191,197,32,176,190,170,241,226,63,133,235,145,63,106,188,20,191,113,61,202,190,74,12,2,64,0,0,0,0,152,52,0,0,57,0,0,0,156,2,0,0,132,0,0,0,0,0,0,0,56,53,0,0,57,0,0,0,157,2,0,0,133,0,0,0,0,0,0,0,40,53,0,0,57,0,0,0,158,2,0,0,134,0,0,0,0,0,0,0,24,53,0,0,57,0,0,0,159,2,0,0,135,0,0,0,0,0,0,0,8,53,0,0,57,0,0,0,160,2,0,0,136,0,0,0,0,0,0,0,248,52,0,0,57,0,0,0,161,2,0,0,137,0,0,0,0,0,0,0,232,52,0,0,57,0,0,0,162,2,0,0,138,0,0,0,0,0,0,0,216,52,0,0,57,0,0,0,163,2,0,0,139,0,0,0,0,0,0,0,200,52,0,0,57,0,0,0,164,2,0,0,140,0,0,0,0,0,0,0,120,53,0,0,57,0,0,0,165,2,0,0,141,0,0,0,0,0,0,0,104,53,0,0,57,0,0,0,166,2,0,0,142,0,0,0,0,0,0,0,88,53,0,0,57,0,0,0,167,2,0,0,143,0,0,0,0,0,0,0,72,53,0,0,57,0,0,0,168,2,0,0,144,0,0,0,0,0,0,0,136,53,0,0,57,0,0,0,169,2,0,0,145,0,0,0,0,0,0,0,72,54,0,0,57,0,0,0,170,2,0,0,146,0,0,0,0,0,0,0,56,54,0,0,57,0,0,0,171,2,0,0,147,0,0,0,0,0,0,0,40,54,0,0,57,0,0,0,172,2,0,0,148,0,0,0,0,0,0,0,24,54,0,0,57,0,0,0,173,2,0,0,149,0,0,0,0,0,0,0,8,54,0,0,57,0,0,0,174,2,0,0,150,0,0,0,0,0,0,0,248,53,0,0,57,0,0,0,175,2,0,0,151,0,0,0,0,0,0,0,232,53,0,0,57,0,0,0,176,2,0,0,152,0,0,0,0,0,0,0,216,53,0,0,57,0,0,0,177,2,0,0,153,0,0,0,0,0,0,0,200,53,0,0,57,0,0,0,178,2,0,0,154,0,0,0,0,0,0,0,184,53,0,0,57,0,0,0,179,2,0,0,155,0,0,0,0,0,0,0,168,53,0,0,57,0,0,0,180,2,0,0,156,0,0,0,0,0,0,0,152,53,0,0,57,0,0,0,181,2,0,0,157,0,0,0,192,169,5,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,192,169,5,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,192,169,5,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,174,171,5,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,174,171,5,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,174,171,5,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,182,172,5,0,85,169,5,0,255,0,0,0,0,0,0,0,68,171,5,0,110,171,5,0,114,171,5,0,182,172,5,0,85,169,5,0,0,1,0,0,0,0,0,0,1,171,5,0,44,171,5,0,48,171,5,0,182,172,5,0,85,169,5,0,1,1,0,0,0,0,0,0,194,170,5,0,227,170,5,0,233,170,5,0,0,0,0,0,88,54,0,0,182,2,0,0,183,2,0,0,38,0,0,0,158,0,0,0,159,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,1,0,0,0,160,0,0,0,14,0,0,0,161,0,0,0,15,0,0,0,162,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,16,0,0,0,163,0,0,0,17,0,0,0,164,0,0,0,9,0,0,0,9,0,0,0,0,0,0,0,104,54,0,0,57,0,0,0,184,2,0,0,165,0,0,0,0,0,0,0,120,54,0,0,5,0,0,0,185,2,0,0,186,2,0,0,0,0,0,0,136,54,0,0,57,0,0,0,187,2,0,0,166,0,0,0,0,0,0,0,168,54,0,0,36,0,0,0,188,2,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,51,0,0,0,167,0,0,0,168,0,0,0,18,0,0,0,169,0,0,0,170,0,0,0,171,0,0,0,19,0,0,0,172,0,0,0,10,0,0,0,10,0,0,0,0,0,0,0,152,54,0,0,5,0,0,0,189,2,0,0,190,2,0,0,0,0,0,0,232,54,0,0,36,0,0,0,191,2,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,38,0,0,0,192,2,0,0,20,0,0,0,173,0,0,0,11,0,0,0,11,0,0,0,21,0,0,0,174,0,0,0,22,0,0,0,175,0,0,0,23,0,0,0,176,0,0,0,24,0,0,0,177,0,0,0,12,0,0,0,12,0,0,0,25,0,0,0,178,0,0,0,0,0,0,0,216,54,0,0,5,0,0,0,193,2,0,0,194,2,0,0,41,92,15,62,41,92,15,62,102,247,228,62,102,247,228,62,102,247,228,62,0,0,0,0,24,55,0,0,195,2,0,0,196,2,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,4,0,0,0,248,192,5,0,90,190,5,0,133,0,0,0,0,0,0,0,188,193,5,0,225,193,5,0,232,193,5,0,248,192,5,0,90,190,5,0,136,0,0,0,1,0,0,0,126,193,5,0,172,193,5,0,184,193,5,0,0,0,0,0,48,55,0,0,5,0,0,0,198,2,0,0,199,2,0,0,0,0,0,0,80,55,0,0,200,2,0,0,201,2,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,54,0,0,0,39,0,0,0,41,0,0,0,19,0,0,0,24,0,0,0,25,0,0,0,50,0,0,0,55,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,30,0,0,0,4,0,0,0,0,0,0,0,64,55,0,0,5,0,0,0,202,2,0,0,203,2,0,0,54,195,5,0,90,190,5,0,204,1,0,0,1,0,0,0,180,158,17,0,182,195,5,0,2,222,6,0,0,0,0,0,176,55,0,0,5,0,0,0,204,2,0,0,205,2,0,0,0,0,0,0,96,55,0,0,206,2,0,0,207,2,0,0,208,2,0,0,209,2,0,0,112,0,0,0,0,0,0,0,96,56,0,0,210,2,0,0,211,2,0,0,104,0,0,0,248,255,255,255,96,56,0,0,212,2,0,0,213,2,0,0,144,255,255,255,144,255,255,255,96,56,0,0,214,2,0,0,215,2,0,0,172,48,1,0,244,55,0,0,204,55,0,0,224,55,0,0,52,56,0,0,72,56,0,0,28,56,0,0,8,56,0,0,212,48,1,0,192,48,1,0,0,0,0,0,80,56,0,0,216,2,0,0,217,2,0,0,179,0,0,0,5,0,0,0,74,0,0,0,42,0,0,0,26,0,0,0,7,0,0,0,2,0,0,0,27,0,0,0,9,0,0,0,26,0,0,0,3,0,0,0,27,0,0,0,32,222,5,0,210,215,5,0,68,5,0,0,1,0,0,0,180,158,17,0,124,223,5,0,152,130,6,0,32,222,5,0,210,215,5,0,69,5,0,0,1,0,0,0,180,158,17,0,111,223,5,0,152,130,6,0,32,222,5,0,210,215,5,0,157,6,0,0,1,0,0,0,180,158,17,0,96,223,5,0,152,130,6,0,32,222,5,0,210,215,5,0,157,6,0,0,1,0,0,0,180,158,17,0,80,223,5,0,180,130,6,0,32,222,5,0,210,215,5,0,165,6,0,0,1,0,0,0,180,158,17,0,60,223,5,0,152,130,6,0,32,222,5,0,210,215,5,0,165,6,0,0,1,0,0,0,180,158,17,0,39,223,5,0,253,230,6,0,32,222,5,0,210,215,5,0,166,6,0,0,1,0,0,0,180,158,17,0,20,223,5,0,152,130,6,0,32,222,5,0,210,215,5,0,166,6,0,0,1,0,0,0,180,158,17,0,0,223,5,0,253,230,6,0,32,222,5,0,210,215,5,0,8,7,0,0,1,0,0,0,180,158,17,0,240,222,5,0,152,130,6,0,32,222,5,0,210,215,5,0,8,7,0,0,1,0,0,0,180,158,17,0,223,222,5,0,180,130,6,0,32,222,5,0,210,215,5,0,62,7,0,0,1,0,0,0,180,158,17,0,206,222,5,0,253,230,6,0,32,222,5,0,210,215,5,0,62,7,0,0,1,0,0,0,180,158,17,0,190,222,5,0,2,222,6,0,32,222,5,0,210,215,5,0,63,7,0,0,1,0,0,0,180,158,17,0,173,222,5,0,253,230,6,0,32,222,5,0,210,215,5,0,63,7,0,0,1,0,0,0,180,158,17,0,157,222,5,0,2,222,6,0,0,0,0,0,144,56,0,0,5,0,0,0,218,2,0,0,219,2,0,0,59,239,5,0,63,239,5,0,69,239,5,0,76,239,5,0,0,0,0,0,0,0,0,0,160,56,0,0,5,0,0,0,220,2,0,0,221,2,0,0,108,0,0,0,0,0,0,0,216,56,0,0,222,2,0,0,223,2,0,0,148,255,255,255,148,255,255,255,216,56,0,0,224,2,0,0,225,2,0,0,20,51,1,0,188,56,0,0,208,56,0,0,40,51,1,0,0,0,0,0,232,56,0,0,226,2,0,0,227,2,0,0,10,0,0,0,1,0,0,0,75,0,0,0,43,0,0,0,6,0,0,0,7,0,0,0,2,0,0,0,28,0,0,0,9,0,0,0,28,0,0,0,3,0,0,0,29,0,0,0,0,0,0,0,248,56,0,0,228,2,0,0,229,2,0,0,230,2,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,72,0,0,0,88,0,0,0,104,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,20,0,0,0,255,255,255,255,24,0,0,0,32,0,0,0,40,0,0,0,44,0,0,0,48,0,0,0,52,0,0,0,56,0,0,0,60,0,0,0,64,0,0,0,68,0,0,0,8,0,0,0,16,0,0,0,20,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,4,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,44,0,0,0,8,0,0,0,0,0,0,0,8,57,0,0,231,2,0,0,232,2,0,0,180,0,0,0,29,0,0,0,30,0,0,0,30,0,0,0,31,0,0,0,233,2,0,0,32,0,0,0,181,0,0,0,182,0,0,0,31,0,0,0,33,0,0,0,183,0,0,0,32,0,0,0,34,0,0,0,6,0,0,0,35,0,0,0,184,0,0,0,185,0,0,0,234,2,0,0,36,0,0,0,186,0,0,0,37,0,0,0,187,0,0,0,0,0,0,0,255,255,255,255,124,0,0,0,12,0,0,0,255,255,255,255,24,0,0,0,28,0,0,0,35,0,0,0,24,0,0,0,37,0,0,0,255,255,255,255,52,0,0,0,144,240,7,0,16,241,7,0,88,241,7,0,112,241,7,0,0,0,0,0,80,57,0,0,235,2,0,0,236,2,0,0,180,0,0,0,38,0,0,0,33,0,0,0,39,0,0,0,40,0,0,0,237,2,0,0,41,0,0,0,181,0,0,0,182,0,0,0,34,0,0,0,42,0,0,0,188,0,0,0,32,0,0,0,43,0,0,0,7,0,0,0,35,0,0,0,189,0,0,0,190,0,0,0,234,2,0,0,36,0,0,0,191,0,0,0,37,0,0,0,192,0,0,0,0,0,0,0,96,57,0,0,238,2,0,0,239,2,0,0,193,0,0,0,44,0,0,0,35,0,0,0,45,0,0,0,46,0,0,0,240,2,0,0,47,0,0,0,181,0,0,0,194,0,0,0,36,0,0,0,48,0,0,0,195,0,0,0,32,0,0,0,49,0,0,0,8,0,0,0,35,0,0,0,196,0,0,0,197,0,0,0,234,2,0,0,50,0,0,0,198,0,0,0,37,0,0,0,199,0,0,0,51,0,0,0,52,0,0,0,0,0,0,0,40,57,0,0,241,2,0,0,242,2,0,0,180,0,0,0,53,0,0,0,37,0,0,0,54,0,0,0,55,0,0,0,243,2,0,0,56,0,0,0,181,0,0,0,182,0,0,0,38,0,0,0,57,0,0,0,200,0,0,0,32,0,0,0,58,0,0,0,9,0,0,0,35,0,0,0,201,0,0,0,202,0,0,0,234,2,0,0,36,0,0,0,203,0,0,0,37,0,0,0,204,0,0,0,0,0,0,0,24,57,0,0,244,2,0,0,245,2,0,0,39,0,0,0,10,0,0,0,40,0,0,0,11,0,0,0,205,0,0,0,206,0,0,0,59,0,0,0,60,0,0,0,246,2,0,0,247,2,0,0,207,0,0,0,208,0,0,0,56,0,0,0,209,0,0,0,61,0,0,0,62,0,0,0,210,0,0,0,0,0,0,0,168,57,0,0,238,2,0,0,248,2,0,0,193,0,0,0,44,0,0,0,35,0,0,0,45,0,0,0,46,0,0,0,240,2,0,0,47,0,0,0,181,0,0,0,194,0,0,0,36,0,0,0,48,0,0,0,195,0,0,0,32,0,0,0,49,0,0,0,8,0,0,0,35,0,0,0,196,0,0,0,197,0,0,0,234,2,0,0,50,0,0,0,198,0,0,0,37,0,0,0,199,0,0,0,63,0,0,0,64,0,0,0,0,0,0,0,112,57,0,0,238,2,0,0,249,2,0,0,193,0,0,0,44,0,0,0,35,0,0,0,45,0,0,0,46,0,0,0,240,2,0,0,47,0,0,0,181,0,0,0,194,0,0,0,36,0,0,0,48,0,0,0,195,0,0,0,32,0,0,0,49,0,0,0,8,0,0,0,35,0,0,0,196,0,0,0,211,0,0,0,234,2,0,0,50,0,0,0,198,0,0,0,37,0,0,0,1,0,0,0,51,0,0,0,52,0,0,0,0,0,0,0,128,57,0,0,250,2,0,0,251,2,0,0,193,0,0,0,44,0,0,0,35,0,0,0,45,0,0,0,46,0,0,0,240,2,0,0,47,0,0,0,181,0,0,0,194,0,0,0,36,0,0,0,48,0,0,0,195,0,0,0,32,0,0,0,49,0,0,0,8,0,0,0,35,0,0,0,196,0,0,0,211,0,0,0,234,2,0,0,50,0,0,0,198,0,0,0,37,0,0,0,1,0,0,0,51,0,0,0,52,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,28,0,0,0,32,0,0,0,24,0,0,0,16,0,0,0,20,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,4,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,60,0,0,0,64,0,0,0,8,0,0,0,68,0,0,0,24,0,0,0,0,0,0,0,184,57,0,0,252,2,0,0,253,2,0,0,180,0,0,0,65,0,0,0,41,0,0,0,66,0,0,0,67,0,0,0,254,2,0,0,68,0,0,0,181,0,0,0,182,0,0,0,42,0,0,0,69,0,0,0,212,0,0,0,32,0,0,0,70,0,0,0,12,0,0,0,35,0,0,0,213,0,0,0,214,0,0,0,234,2,0,0,36,0,0,0,215,0,0,0,37,0,0,0,216,0,0,0,0,0,0,0,255,255,255,255,40,0,0,0,9,0,0,0,16,0,0,0,24,0,0,0,18,0,0,0,255,255,255,255,76,0,0,0,200,241,7,0,240,241,7,0,8,242,7,0,0,0,0,0,8,58,0,0,255,2,0,0,0,3,0,0,180,0,0,0,71,0,0,0,43,0,0,0,72,0,0,0,73,0,0,0,1,3,0,0,74,0,0,0,181,0,0,0,182,0,0,0,44,0,0,0,75,0,0,0,217,0,0,0,32,0,0,0,76,0,0,0,13,0,0,0,35,0,0,0,218,0,0,0,219,0,0,0,234,2,0,0,36,0,0,0,220,0,0,0,37,0,0,0,221,0,0,0,0,0,0,0,200,57,0,0,2,3,0,0,3,3,0,0,45,0,0,0,14,0,0,0,46,0,0,0,11,0,0,0,205,0,0,0,206,0,0,0,77,0,0,0,78,0,0,0,4,3,0,0,5,3,0,0,207,0,0,0,208,0,0,0,56,0,0,0,209,0,0,0,79,0,0,0,80,0,0,0,222,0,0,0,0,0,0,0,216,57,0,0,6,3,0,0,7,3,0,0,223,0,0,0,81,0,0,0,47,0,0,0,82,0,0,0,46,0,0,0,8,3,0,0,83,0,0,0,181,0,0,0,224,0,0,0,48,0,0,0,84,0,0,0,225,0,0,0,32,0,0,0,85,0,0,0,15,0,0,0,35,0,0,0,196,0,0,0,226,0,0,0,234,2,0,0,86,0,0,0,198,0,0,0,37,0,0,0,227,0,0,0,87,0,0,0,88,0,0,0,0,0,0,0,248,57,0,0,6,3,0,0,9,3,0,0,223,0,0,0,81,0,0,0,47,0,0,0,82,0,0,0,46,0,0,0,8,3,0,0,83,0,0,0,181,0,0,0,224,0,0,0,48,0,0,0,84,0,0,0,225,0,0,0,32,0,0,0,85,0,0,0,15,0,0,0,35,0,0,0,196,0,0,0,211,0,0,0,234,2,0,0,86,0,0,0,198,0,0,0,37,0,0,0,1,0,0,0,87,0,0,0,88,0,0,0,0,0,0,0,232,57,0,0,10,3,0,0,11,3,0,0,223,0,0,0,81,0,0,0,47,0,0,0,82,0,0,0,46,0,0,0,8,3,0,0,83,0,0,0,181,0,0,0,224,0,0,0,48,0,0,0,84,0,0,0,225,0,0,0,32,0,0,0,85,0,0,0,15,0,0,0,35,0,0,0,196,0,0,0,211,0,0,0,234,2,0,0,86,0,0,0,198,0,0,0,37,0,0,0,1,0,0,0,87,0,0,0,88,0,0,0,0,0,0,0,24,58,0,0,6,3,0,0,12,3,0,0,223,0,0,0,81,0,0,0,47,0,0,0,82,0,0,0,46,0,0,0,8,3,0,0,83,0,0,0,181,0,0,0,224,0,0,0,48,0,0,0,84,0,0,0,225,0,0,0,32,0,0,0,85,0,0,0,15,0,0,0,35,0,0,0,196,0,0,0,226,0,0,0,234,2,0,0,86,0,0,0,198,0,0,0,37,0,0,0,227,0,0,0,89,0,0,0,90,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,8,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,24,0,0,0,0,0,0,0,40,58,0,0,13,3,0,0,14,3,0,0,180,0,0,0,91,0,0,0,49,0,0,0,92,0,0,0,93,0,0,0,15,3,0,0,94,0,0,0,181,0,0,0,182,0,0,0,50,0,0,0,95,0,0,0,228,0,0,0,32,0,0,0,96,0,0,0,16,0,0,0,35,0,0,0,229,0,0,0,230,0,0,0,234,2,0,0,36,0,0,0,231,0,0,0,37,0,0,0,232,0,0,0,0,0,0,0,255,255,255,255,32,0,0,0,7,0,0,0,255,255,255,255,32,0,0,0,112,242,7,0,144,242,7,0,0,0,0,0,56,58,0,0,16,3,0,0,17,3,0,0,180,0,0,0,97,0,0,0,51,0,0,0,98,0,0,0,99,0,0,0,18,3,0,0,100,0,0,0,181,0,0,0,182,0,0,0,52,0,0,0,101,0,0,0,233,0,0,0,32,0,0,0,102,0,0,0,17,0,0,0,35,0,0,0,234,0,0,0,235,0,0,0,234,2,0,0,36,0,0,0,236,0,0,0,37,0,0,0,237,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,28,0,0,0,8,0,0,0,0,0,0,0,72,58,0,0,19,3,0,0,20,3,0,0,180,0,0,0,103,0,0,0,53,0,0,0,104,0,0,0,105,0,0,0,21,3,0,0,106,0,0,0,181,0,0,0,182,0,0,0,54,0,0,0,107,0,0,0,238,0,0,0,32,0,0,0,108,0,0,0,18,0,0,0,35,0,0,0,239,0,0,0,240,0,0,0,234,2,0,0,36,0,0,0,241,0,0,0,37,0,0,0,242,0,0,0,0,0,0,0,255,255,255,255,36,0,0,0,192,242,7,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,160,0,0,0,156,0,0,0,164,0,0,0,152,0,0,0,136,0,0,0,8,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,72,0,0,0,88,0,0,0,104,0,0,0,120,0,0,0,0,0,0,0,88,58,0,0,22,3,0,0,23,3,0,0,180,0,0,0,109,0,0,0,55,0,0,0,110,0,0,0,111,0,0,0,24,3,0,0,112,0,0,0,181,0,0,0,182,0,0,0,56,0,0,0,113,0,0,0,243,0,0,0,32,0,0,0,114,0,0,0,19,0,0,0,35,0,0,0,244,0,0,0,245,0,0,0,234,2,0,0,36,0,0,0,246,0,0,0,37,0,0,0,247,0,0,0,0,0,0,0,255,255,255,255,172,0,0,0,240,242,7,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,84,0,0,0,16,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,104,0,0,0,80,0,0,0,88,0,0,0,92,0,0,0,96,0,0,0,100,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,6,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,21,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,88,0,0,0,92,0,0,0,16,0,0,0,120,0,0,0,121,0,0,0,28,0,0,0,96,0,0,0,100,0,0,0,104,0,0,0,108,0,0,0,112,0,0,0,116,0,0,0,124,0,0,0,40,0,0,0,52,0,0,0,64,0,0,0,76,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,8,0,0,0,9,0,0,0,255,255,255,255,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,10,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,48,0,0,0,28,0,0,0,16,0,0,0,20,0,0,0,44,0,0,0,32,0,0,0,40,0,0,0,36,0,0,0,49,0,0,0,2,0,0,0,8,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,7,0,0,0,4,0,0,0,6,0,0,0,5],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+71680);allocate([9,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,32,0,0,0,36,0,0,0,40,0,0,0,28,0,0,0,44,0,0,0,16,0,0,0,48,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,4,0,0,0,255,255,255,255,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,40,0,0,0,28,0,0,0,44,0,0,0,36,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,6,0,0,0,3,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,92,0,0,0,32,0,0,0,60,0,0,0,48,0,0,0,100,0,0,0,96,0,0,0,101,0,0,0,76,0,0,0,16,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,2,0,0,0,1,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,100,0,0,0,116,0,0,0,88,0,0,0,16,0,0,0,112,0,0,0,44,0,0,0,120,0,0,0,60,0,0,0,32,0,0,0,124,0,0,0,168,0,0,0,196,0,0,0,128,0,0,0,132,0,0,0,204,0,0,0,136,0,0,0,212,0,0,0,92,0,0,0,140,0,0,0,144,0,0,0,148,0,0,0,152,0,0,0,104,0,0,0,156,0,0,0,76,0,0,0,208,0,0,0,160,0,0,0,96,0,0,0,169,0,0,0,216,0,0,0,192,0,0,0,164,0,0,0,184,0,0,0,108,0,0,0,200,0,0,0,176,0,0,0,220,0,0,0,170,0,0,0,197,0,0,0,172,0,0,0,3,0,0,0,7,0,0,0,0,0,0,0,255,255,255,255,6,0,0,0,255,255,255,255,8,0,0,0,255,255,255,255,255,255,255,255,9,0,0,0,20,0,0,0,27,0,0,0,10,0,0,0,11,0,0,0,30,0,0,0,12,0,0,0,32,0,0,0,1,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,4,0,0,0,17,0,0,0,255,255,255,255,31,0,0,0,18,0,0,0,2,0,0,0,21,0,0,0,33,0,0,0,26,0,0,0,19,0,0,0,25,0,0,0,5,0,0,0,29,0,0,0,24,0,0,0,34,0,0,0,22,0,0,0,28,0,0,0,23,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,36,0,0,0,32,0,0,0,16,0,0,0,40,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,36,0,0,0,32,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,48,0,0,0,52,0,0,0,56,0,0,0,16,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,136,0,0,0,140,0,0,0,16,0,0,0,32,0,0,0,104,1,0,0,48,0,0,0,60,0,0,0,76,0,0,0,124,0,0,0,92,0,0,0,108,0,0,0,144,0,0,0,148,0,0,0,152,0,0,0,156,0,0,0,44,1,0,0,52,1,0,0,160,0,0,0,164,0,0,0,168,0,0,0,64,1,0,0,172,0,0,0,76,1,0,0,176,0,0,0,180,0,0,0,184,0,0,0,48,1,0,0,36,1,0,0,188,0,0,0,28,1,0,0,192,0,0,0,196,0,0,0,200,0,0,0,204,0,0,0,208,0,0,0,212,0,0,0,60,1,0,0,24,1,0,0,216,0,0,0,220,0,0,0,224,0,0,0,84,1,0,0,80,1,0,0,68,1,0,0,228,0,0,0,232,0,0,0,12,1,0,0,88,1,0,0,92,1,0,0,96,1,0,0,8,1,0,0,72,1,0,0,32,1,0,0,236,0,0,0,20,1,0,0,100,1,0,0,56,1,0,0,240,0,0,0,244,0,0,0,16,1,0,0,248,0,0,0,252,0,0,0,0,1,0,0,40,1,0,0,4,1,0,0,0,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,56,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,41,0,0,0,43,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,46,0,0,0,9,0,0,0,49,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,42,0,0,0,39,0,0,0,13,0,0,0,37,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,45,0,0,0,36,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,51,0,0,0,50,0,0,0,47,0,0,0,23,0,0,0,24,0,0,0,33,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,32,0,0,0,48,0,0,0,38,0,0,0,25,0,0,0,35,0,0,0,55,0,0,0,44,0,0,0,26,0,0,0,27,0,0,0,34,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,40,0,0,0,31,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,40,0,0,0,36,0,0,0,32,0,0,0,28,0,0,0,16,0,0,0,37,0,0,0,38,0,0,0,5,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,3,0,0,0,4,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,20,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,20,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,17,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,72,0,0,0,112,0,0,0,16,0,0,0,28,0,0,0,40,0,0,0,52,0,0,0,76,0,0,0,80,0,0,0,84,0,0,0,88,0,0,0,92,0,0,0,96,0,0,0,116,0,0,0,64,0,0,0,68,0,0,0,100,0,0,0,108,0,0,0,104,0,0,0,2,0,0,0,12,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,13,0,0,0,0,0,0,0,1,0,0,0,9,0,0,0,11,0,0,0,10,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,28,0,0,0,16,0,0,0,0,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,32,0,0,0,40,0,0,0,44,0,0,0,20,0,0,0,28,0,0,0,36,0,0,0,37,0,0,0,48,0,0,0,0,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,3,0,0,0,5,0,0,0,6,0,0,0,9,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,36,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,80,0,0,0,32,0,0,0,44,0,0,0,56,0,0,0,68,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,28,0,0,0,16,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,28,0,0,0,32,0,0,0,16,0,0,0,20,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,56,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,44,0,0,0,48,0,0,0,52,0,0,0,20,0,0,0,28,0,0,0,37,0,0,0,24,0,0,0,0,0,0,0,11,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,29,0,0,0,16,0,0,0,20,0,0,0,32,0,0,0,28,0,0,0,2,0,0,0,4,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,28,0,0,0,32,0,0,0,16,0,0,0,36,0,0,0,20,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,5,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,17,0,0,0,16,0,0,0,20,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,44,0,0,0,48,0,0,0,20,0,0,0,28,0,0,0,32,0,0,0,60,0,0,0,36,0,0,0,40,0,0,0,52,0,0,0,56,0,0,0,64,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,6,0,0,0,9,0,0,0,10,0,0,0,12,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,16,0,0,0,20,0,0,0,28,0,0,0,29,0,0,0,2,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,28,0,0,0,32,0,0,0,16,0,0,0,24,0,0,0,20,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,32,0,0,0,16,0,0,0,28,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,48,0,0,0,20,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,52,0,0,0,56,0,0,0,60,0,0,0,44,0,0,0,24,0,0,0,41,0,0,0,28,0,0,0,0,0,0,0,9,0,0,0,1,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,8,0,0,0,2,0,0,0,7,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,160,0,0,0,88,0,0,0,104,0,0,0,32,1,0,0,48,0,0,0,132,0,0,0,148,0,0,0,64,0,0,0,76,0,0,0,120,0,0,0,240,0,0,0,224,0,0,0,168,0,0,0,20,1,0,0,172,0,0,0,176,0,0,0,180,0,0,0,236,0,0,0,228,0,0,0,24,1,0,0,184,0,0,0,188,0,0,0,244,0,0,0,192,0,0,0,196,0,0,0,200,0,0,0,204,0,0,0,220,0,0,0,0,1,0,0,208,0,0,0,216,0,0,0,248,0,0,0,12,1,0,0,16,1,0,0,252,0,0,0,8,1,0,0,232,0,0,0,212,0,0,0,4,1,0,0,28,1,0,0,164,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,32,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,2,0,0,0,29,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,19,0,0,0,17,0,0,0,30,0,0,0,6,0,0,0,7,0,0,0,21,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,15,0,0,0,24,0,0,0,12,0,0,0,14,0,0,0,22,0,0,0,27,0,0,0,28,0,0,0,23,0,0,0,26,0,0,0,18,0,0,0,13,0,0,0,25,0,0,0,31,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,56,0,0,0,60,0,0,0,88,0,0,0,144,0,0,0,76,0,0,0,80,0,0,0,92,0,0,0,96,0,0,0,148,0,0,0,152,0,0,0,100,0,0,0,156,0,0,0,160,0,0,0,164,0,0,0,168,0,0,0,176,0,0,0,64,0,0,0,172,0,0,0,68,0,0,0,104,0,0,0,108,0,0,0,116,0,0,0,16,0,0,0,32,0,0,0,44,0,0,0,120,0,0,0,180,0,0,0,184,0,0,0,188,0,0,0,124,0,0,0,72,0,0,0,128,0,0,0,132,0,0,0,136,0,0,0,112,0,0,0,117,0,0,0,140,0,0,0,84,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,23,0,0,0,5,0,0,0,6,0,0,0,9,0,0,0,10,0,0,0,24,0,0,0,25,0,0,0,11,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,31,0,0,0,2,0,0,0,30,0,0,0,3,0,0,0,12,0,0,0,13,0,0,0,15,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,17,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,18,0,0,0,4,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,14,0,0,0,16,0,0,0,22,0,0,0,7,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,44,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,40,0,0,0,44,0,0,0,48,0,0,0,16,0,0,0,28,0,0,0,52,0,0,0,56,0,0,0,60,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,255,255,255,255,3,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,104,58,0,0,25,3,0,0,26,3,0,0,180,0,0,0,115,0,0,0,57,0,0,0,116,0,0,0,46,0,0,0,27,3,0,0,117,0,0,0,181,0,0,0,182,0,0,0,58,0,0,0,118,0,0,0,248,0,0,0,32,0,0,0,119,0,0,0,20,0,0,0,35,0,0,0,249,0,0,0,250,0,0,0,234,2,0,0,36,0,0,0,251,0,0,0,37,0,0,0,252,0,0,0,0,0,0,0,6,0,0,0,32,0,0,0,7,0,0,0,23,0,0,0,108,0,0,0,34,0,0,0,40,0,0,0,32,0,0,0,41,0,0,0,47,0,0,0,28,0,0,0,48,0,0,0,57,0,0,0,28,0,0,0,61,0,0,0,83,0,0,0,128,0,0,0,100,0,0,0,115,0,0,0,52,0,0,0,125,0,0,0,137,0,0,0,52,0,0,0,144,0,0,0,157,0,0,0,48,0,0,0,165,0,0,0,179,0,0,0,104,0,0,0,188,0,0,0,233,0,0,0,232,0,0,0,17,1,0,0,26,1,0,0,44,0,0,0,30,1,0,0,38,1,0,0,40,0,0,0,41,1,0,0,51,1,0,0,60,0,0,0,56,1,0,0,65,1,0,0,32,0,0,0,69,1,0,0,139,1,0,0,112,1,0,0,204,1,0,0,216,1,0,0,44,0,0,0,223,1,0,0,231,1,0,0,28,0,0,0,234,1,0,0,242,1,0,0,28,0,0,0,245,1,0,0,253,1,0,0,28,0,0,0,0,2,0,0,7,2,0,0,24,0,0,0,9,2,0,0,18,2,0,0,28,0,0,0,22,2,0,0,30,2,0,0,28,0,0,0,33,2,0,0,40,2,0,0,24,0,0,0,42,2,0,0,65,2,0,0,120,0,0,0,83,2,0,0,90,2,0,0,32,0,0,0,92,2,0,0,107,2,0,0,52,0,0,0,117,2,0,0,125,2,0,0,28,0,0,0,128,2,0,0,139,2,0,0,40,0,0,0,145,2,0,0,152,2,0,0,24,0,0,0,154,2,0,0,165,2,0,0,96,0,0,0,171,2,0,0,179,2,0,0,36,0,0,0,182,2,0,0,188,2,0,0,20,0,0,0,189,2,0,0,199,2,0,0,36,0,0,0,204,2,0,0,212,2,0,0,28,0,0,0,215,2,0,0,222,2,0,0,24,0,0,0,224,2,0,0,232,2,0,0,28,0,0,0,235,2,0,0,241,2,0,0,20,0,0,0,242,2,0,0,248,2,0,0,20,0,0,0,249,2,0,0,10,3,0,0,60,0,0,0,22,3,0,0,28,3,0,0,20,0,0,0,29,3,0,0,40,3,0,0,36,0,0,0,46,3,0,0,52,3,0,0,32,0,0,0,53,3,0,0,61,3,0,0,28,0,0,0,64,3,0,0,75,3,0,0,40,0,0,0,81,3,0,0,90,3,0,0,32,0,0,0,94,3,0,0,102,3,0,0,24,0,0,0,105,3,0,0,111,3,0,0,20,0,0,0,112,3,0,0,130,3,0,0,68,0,0,0,143,3,0,0,151,3,0,0,28,0,0,0,154,3,0,0,163,3,0,0,32,0,0,0,167,3,0,0,177,3,0,0,32,0,0,0,182,3,0,0,190,3,0,0,28,0,0,0,193,3,0,0,200,3,0,0,24,0,0,0,202,3,0,0,210,3,0,0,28,0,0,0,213,3,0,0,223,3,0,0,36,0,0,0,228,3,0,0,234,3,0,0,20,0,0,0,235,3,0,0,243,3,0,0,36,0,0,0,246,3,0,0,253,3,0,0,24,0,0,0,255,3,0,0,5,4,0,0,20,0,0,0,6,4,0,0,13,4,0,0,24,0,0,0,15,4,0,0,21,4,0,0,20,0,0,0,22,4,0,0,40,4,0,0,64,0,0,0,53,4,0,0,61,4,0,0,28,0,0,0,64,4,0,0,112,4,0,0,40,1,0,0,155,4,0,0,198,4,0,0,196,0,0,0,236,4,0,0,243,4,0,0,24,0,0,0,245,4,0,0,2,5,0,0,48,0,0,0,10,5,0,0,18,5,0,0,28,0,0,0,21,5,0,0,34,5,0,0,64,0,0,0,42,5,0,0,50,5,0,0,28,0,0,0,168,243,7,0,200,243,7,0,56,244,7,0,88,244,7,0,120,244,7,0,152,244,7,0,24,245,7,0,80,245,7,0,136,245,7,0,184,245,7,0,32,246,7,0,8,247,7,0,56,247,7,0,96,247,7,0,160,247,7,0,192,247,7,0,48,249,7,0,96,249,7,0,128,249,7,0,160,249,7,0,192,249,7,0,216,249,7,0,248,249,7,0,24,250,7,0,48,250,7,0,168,250,7,0,200,250,7,0,0,251,7,0,32,251,7,0,72,251,7,0,96,251,7,0,192,251,7,0,232,251,7,0,0,252,7,0,40,252,7,0,72,252,7,0,96,252,7,0,128,252,7,0,152,252,7,0,176,252,7,0,240,252,7,0,8,253,7,0,48,253,7,0,80,253,7,0,112,253,7,0,152,253,7,0,184,253,7,0,208,253,7,0,232,253,7,0,48,254,7,0,80,254,7,0,112,254,7,0,144,254,7,0,176,254,7,0,200,254,7,0,232,254,7,0,16,255,7,0,40,255,7,0,80,255,7,0,104,255,7,0,128,255,7,0,152,255,7,0,176,255,7,0,240,255,7,0,16,0,8,0,56,1,8,0,0,2,8,0,24,2,8,0,72,2,8,0,104,2,8,0,168,2,8,0,0,0,0,0,120,58,0,0,28,3,0,0,29,3,0,0,180,0,0,0,120,0,0,0,59,0,0,0,116,0,0,0,46,0,0,0,30,3,0,0,121,0,0,0,181,0,0,0,182,0,0,0,60,0,0,0,122,0,0,0,253,0,0,0,32,0,0,0,123,0,0,0,21,0,0,0,35,0,0,0,254,0,0,0,255,0,0,0,234,2,0,0,36,0,0,0,0,1,0,0,37,0,0,0,1,1,0,0,0,0,0,0,136,58,0,0,31,3,0,0,32,3,0,0,180,0,0,0,124,0,0,0,61,0,0,0,116,0,0,0,46,0,0,0,33,3,0,0,125,0,0,0,181,0,0,0,182,0,0,0,62,0,0,0,126,0,0,0,2,1,0,0,32,0,0,0,127,0,0,0,22,0,0,0,35,0,0,0,3,1,0,0,4,1,0,0,234,2,0,0,36,0,0,0,5,1,0,0,37,0,0,0,6,1,0,0,0,0,0,0,152,58,0,0,34,3,0,0,35,3,0,0,180,0,0,0,128,0,0,0,63,0,0,0,116,0,0,0,46,0,0,0,36,3,0,0,129,0,0,0,181,0,0,0,182,0,0,0,64,0,0,0,130,0,0,0,7,1,0,0,32,0,0,0,131,0,0,0,23,0,0,0,35,0,0,0,8,1,0,0,9,1,0,0,234,2,0,0,36,0,0,0,10,1,0,0,37,0,0,0,11,1,0,0,0,0,0,0,168,58,0,0,37,3,0,0,38,3,0,0,180,0,0,0,132,0,0,0,65,0,0,0,116,0,0,0,46,0,0,0,39,3,0,0,133,0,0,0,181,0,0,0,182,0,0,0,66,0,0,0,134,0,0,0,12,1,0,0,32,0,0,0,135,0,0,0,24,0,0,0,35,0,0,0,13,1,0,0,14,1,0,0,234,2,0,0,36,0,0,0,15,1,0,0,37,0,0,0,16,1,0,0,0,0,0,0,184,58,0,0,40,3,0,0,41,3,0,0,180,0,0,0,136,0,0,0,67,0,0,0,116,0,0,0,46,0,0,0,42,3,0,0,137,0,0,0,181,0,0,0,182,0,0,0,68,0,0,0,138,0,0,0,17,1,0,0,32,0,0,0,139,0,0,0,25,0,0,0,35,0,0,0,18,1,0,0,19,1,0,0,234,2,0,0,36,0,0,0,20,1,0,0,37,0,0,0,21,1,0,0,0,0,0,0,200,58,0,0,43,3,0,0,44,3,0,0,180,0,0,0,140,0,0,0,69,0,0,0,116,0,0,0,46,0,0,0,45,3,0,0,141,0,0,0,181,0,0,0,182,0,0,0,70,0,0,0,142,0,0,0,22,1,0,0,32,0,0,0,143,0,0,0,26,0,0,0,35,0,0,0,23,1,0,0,24,1,0,0,234,2,0,0,36,0,0,0,25,1,0,0,37,0,0,0,26,1,0,0,0,0,0,0,216,58,0,0,46,3,0,0,47,3,0,0,180,0,0,0,144,0,0,0,71,0,0,0,116,0,0,0,46,0,0,0,48,3,0,0,145,0,0,0,181,0,0,0,182,0,0,0,72,0,0,0,146,0,0,0,27,1,0,0,32,0,0,0,147,0,0,0,27,0,0,0,35,0,0,0,28,1,0,0,29,1,0,0,234,2,0,0,36,0,0,0,30,1,0,0,37,0,0,0,31,1,0,0,0,0,0,0,232,58,0,0,49,3,0,0,50,3,0,0,180,0,0,0,148,0,0,0,73,0,0,0,116,0,0,0,46,0,0,0,51,3,0,0,149,0,0,0,181,0,0,0,182,0,0,0,74,0,0,0,150,0,0,0,32,1,0,0,32,0,0,0,151,0,0,0,28,0,0,0,35,0,0,0,33,1,0,0,34,1,0,0,234,2,0,0,36,0,0,0,35,1,0,0,37,0,0,0,36,1,0,0,0,0,0,0,248,58,0,0,52,3,0,0,53,3,0,0,180,0,0,0,152,0,0,0,75,0,0,0,116,0,0,0,46,0,0,0,54,3,0,0,153,0,0,0,181,0,0,0,182,0,0,0,76,0,0,0,154,0,0,0,37,1,0,0,32,0,0,0,155,0,0,0,29,0,0,0,35,0,0,0,38,1,0,0,39,1,0,0,234,2,0,0,36,0,0,0,40,1,0,0,37,0,0,0,41,1,0,0,0,0,0,0,8,59,0,0,55,3,0,0,56,3,0,0,180,0,0,0,156,0,0,0,77,0,0,0,116,0,0,0,46,0,0,0,57,3,0,0,157,0,0,0,181,0,0,0,182,0,0,0,78,0,0,0,158,0,0,0,42,1,0,0,32,0,0,0,159,0,0,0,30,0,0,0,35,0,0,0,43,1,0,0,44,1,0,0,234,2,0,0,36,0,0,0,45,1,0,0,37,0,0,0,46,1,0,0,0,0,0,0,24,59,0,0,58,3,0,0,59,3,0,0,180,0,0,0,160,0,0,0,79,0,0,0,116,0,0,0,46,0,0,0,60,3,0,0,161,0,0,0,181,0,0,0,182,0,0,0,80,0,0,0,162,0,0,0,47,1,0,0,32,0,0,0,163,0,0,0,31,0,0,0,35,0,0,0,48,1,0,0,49,1,0,0,234,2,0,0,36,0,0,0,50,1,0,0,37,0,0,0,51,1,0,0,0,0,0,0,40,59,0,0,61,3,0,0,62,3,0,0,180,0,0,0,164,0,0,0,81,0,0,0,116,0,0,0,46,0,0,0,63,3,0,0,165,0,0,0,181,0,0,0,182,0,0,0,82,0,0,0,166,0,0,0,52,1,0,0,32,0,0,0,167,0,0,0,32,0,0,0,35,0,0,0,53,1,0,0,54,1,0,0,234,2,0,0,36,0,0,0,55,1,0,0,37,0,0,0,56,1,0,0,0,0,0,0,56,59,0,0,64,3,0,0,65,3,0,0,180,0,0,0,168,0,0,0,83,0,0,0,116,0,0,0,46,0,0,0,66,3,0,0,169,0,0,0,181,0,0,0,182,0,0,0,84,0,0,0,170,0,0,0,57,1,0,0,32,0,0,0,171,0,0,0,33,0,0,0,35,0,0,0,58,1,0,0,59,1,0,0,234,2,0,0,36,0,0,0,60,1,0,0,37,0,0,0,61,1,0,0,0,0,0,0,72,59,0,0,67,3,0,0,68,3,0,0,180,0,0,0,172,0,0,0,85,0,0,0,116,0,0,0,46,0,0,0,69,3,0,0,173,0,0,0,181,0,0,0,182,0,0,0,86,0,0,0,174,0,0,0,62,1,0,0,32,0,0,0,175,0,0,0,34,0,0,0,35,0,0,0,63,1,0,0,64,1,0,0,234,2,0,0,36,0,0,0,65,1,0,0,37,0,0,0,66,1,0,0,0,0,0,0,88,59,0,0,70,3,0,0,71,3,0,0,180,0,0,0,176,0,0,0,87,0,0,0,116,0,0,0,46,0,0,0,72,3,0,0,177,0,0,0,181,0,0,0,182,0,0,0,88,0,0,0,178,0,0,0,67,1,0,0,32,0,0,0,179,0,0,0,35,0,0,0,35,0,0,0,68,1,0,0,69,1,0,0,234,2,0,0,36,0,0,0,70,1,0,0,37,0,0,0,71,1,0,0,0,0,0,0,104,59,0,0,73,3,0,0,74,3,0,0,180,0,0,0,180,0,0,0,89,0,0,0,116,0,0,0,46,0,0,0,75,3,0,0,181,0,0,0,181,0,0,0,182,0,0,0,90,0,0,0,182,0,0,0,72,1,0,0,32,0,0,0,183,0,0,0,36,0,0,0,35,0,0,0,73,1,0,0,74,1,0,0,234,2,0,0,36,0,0,0,75,1,0,0,37,0,0,0,76,1,0,0,0,0,0,0,120,59,0,0,76,3,0,0,77,3,0,0,180,0,0,0,184,0,0,0,91,0,0,0,116,0,0,0,46,0,0,0,78,3,0,0,185,0,0,0,181,0,0,0,182,0,0,0,92,0,0,0,186,0,0,0,77,1,0,0,32,0,0,0,187,0,0,0,37,0,0,0,35,0,0,0,78,1,0,0,79,1,0,0,234,2,0,0,36,0,0,0,80,1,0,0,37,0,0,0,81,1,0,0,0,0,0,0,136,59,0,0,79,3,0,0,80,3,0,0,180,0,0,0,188,0,0,0,93,0,0,0,116,0,0,0,46,0,0,0,81,3,0,0,189,0,0,0,181,0,0,0,182,0,0,0,94,0,0,0,190,0,0,0,82,1,0,0,32,0,0,0,191,0,0,0,38,0,0,0,35,0,0,0,83,1,0,0,84,1,0,0,234,2,0,0,36,0,0,0,85,1,0,0,37,0,0,0,86,1,0,0,0,0,0,0,152,59,0,0,82,3,0,0,83,3,0,0,180,0,0,0,192,0,0,0,95,0,0,0,116,0,0,0,46,0,0,0,84,3,0,0,193,0,0,0,181,0,0,0,182,0,0,0,96,0,0,0,194,0,0,0,87,1,0,0,32,0,0,0,195,0,0,0,39,0,0,0,35,0,0,0,88,1,0,0,89,1,0,0,234,2,0,0,36,0,0,0,90,1,0,0,37,0,0,0,91,1,0,0,0,0,0,0,168,59,0,0,85,3,0,0,86,3,0,0,180,0,0,0,196,0,0,0,97,0,0,0,116,0,0,0,46,0,0,0,87,3,0,0,197,0,0,0,181,0,0,0,182,0,0,0,98,0,0,0,198,0,0,0,92,1,0,0,32,0,0,0,199,0,0,0,40,0,0,0,35,0,0,0,93,1,0,0,94,1,0,0,234,2,0,0,36,0,0,0,95,1,0,0,37,0,0,0,96,1,0,0,0,0,0,0,184,59,0,0,88,3,0,0,89,3,0,0,180,0,0,0,200,0,0,0,99,0,0,0,116,0,0,0,46,0,0,0,90,3,0,0,201,0,0,0,181,0,0,0,182,0,0,0,100,0,0,0,202,0,0,0,97,1,0,0,32,0,0,0,203,0,0,0,41,0,0,0,35,0,0,0,98,1,0,0,99,1,0,0,234,2,0,0,36,0,0,0,100,1,0,0,37,0,0,0,101,1,0,0,0,0,0,0,200,59,0,0,91,3,0,0,92,3,0,0,180,0,0,0,204,0,0,0,101,0,0,0,116,0,0,0,46,0,0,0,93,3,0,0,205,0,0,0,181,0,0,0,182,0,0,0,102,0,0,0,206,0,0,0,102,1,0,0,32,0,0,0,207,0,0,0,42,0,0,0,35,0,0,0,103,1,0,0,104,1,0,0,234,2,0,0,36,0,0,0,105,1,0,0,37,0,0,0,106,1,0,0,0,0,0,0,216,59,0,0,94,3,0,0,95,3,0,0,180,0,0,0,208,0,0,0,103,0,0,0,116,0,0,0,46,0,0,0,96,3,0,0,209,0,0,0,181,0,0,0,182,0,0,0,104,0,0,0,210,0,0,0,107,1,0,0,32,0,0,0,211,0,0,0,43,0,0,0,35,0,0,0,108,1,0,0,109,1,0,0,234,2,0,0,36,0,0,0,110,1,0,0,37,0,0,0,111,1,0,0,0,0,0,0,232,59,0,0,97,3,0,0,98,3,0,0,180,0,0,0,212,0,0,0,105,0,0,0,116,0,0,0,46,0,0,0,99,3,0,0,213,0,0,0,181,0,0,0,182,0,0,0,106,0,0,0,214,0,0,0,112,1,0,0,32,0,0,0,215,0,0,0,44,0,0,0,35,0,0,0,113,1,0,0,114,1,0,0,234,2,0,0,36,0,0,0,115,1,0,0,37,0,0,0,116,1,0,0,0,0,0,0,248,59,0,0,100,3,0,0,101,3,0,0,180,0,0,0,216,0,0,0,107,0,0,0,116,0,0,0,46,0,0,0,102,3,0,0,217,0,0,0,181,0,0,0,182,0,0,0,108,0,0,0,218,0,0,0,117,1,0,0,32,0,0,0,219,0,0,0,45,0,0,0,35,0,0,0,118,1,0,0,119,1,0,0,234,2,0,0,36,0,0,0,120,1,0,0,37,0,0,0,121,1,0,0,0,0,0,0,8,60,0,0,103,3,0,0,104,3,0,0,180,0,0,0,220,0,0,0,109,0,0,0,116,0,0,0,46,0,0,0,105,3,0,0,221,0,0,0,181,0,0,0,182,0,0,0,110,0,0,0,222,0,0,0,122,1,0,0,32,0,0,0,223,0,0,0,46,0,0,0,35,0,0,0,123,1,0,0,124,1,0,0,234,2,0,0,36,0,0,0,125,1,0,0,37,0,0,0,126,1,0,0,0,0,0,0,24,60,0,0,106,3,0,0,107,3,0,0,180,0,0,0,224,0,0,0,111,0,0,0,116,0,0,0,46,0,0,0,108,3,0,0,225,0,0,0,181,0,0,0,182,0,0,0,112,0,0,0,226,0,0,0,127,1,0,0,32,0,0,0,227,0,0,0,47,0,0,0,35,0,0,0,128,1,0,0,129,1,0,0,234,2,0,0,36,0,0,0,130,1,0,0,37,0,0,0,131,1,0,0,0,0,0,0,40,60,0,0,109,3,0,0,110,3,0,0,180,0,0,0,228,0,0,0,113,0,0,0,116,0,0,0,46,0,0,0,111,3,0,0,229,0,0,0,181,0,0,0,182,0,0,0,114,0,0,0,230,0,0,0,132,1,0,0,32,0,0,0,231,0,0,0,48,0,0,0,35,0,0,0,133,1,0,0,134,1,0,0,234,2,0,0,36,0,0,0,135,1,0,0,37,0,0,0,136,1,0,0,0,0,0,0,56,60,0,0,112,3,0,0,113,3,0,0,180,0,0,0,232,0,0,0,115,0,0,0,116,0,0,0,46,0,0,0,114,3,0,0,233,0,0,0,181,0,0,0,182,0,0,0,116,0,0,0,234,0,0,0,137,1,0,0,32,0,0,0,235,0,0,0,49,0,0,0,35,0,0,0,138,1,0,0,139,1,0,0,234,2,0,0,36,0,0,0,140,1,0,0,37,0,0,0,141,1,0,0,0,0,0,0,72,60,0,0,115,3,0,0,116,3,0,0,180,0,0,0,236,0,0,0,117,0,0,0,116,0,0,0,46,0,0,0,117,3,0,0,237,0,0,0,181,0,0,0,182,0,0,0,118,0,0,0,238,0,0,0,142,1,0,0,32,0,0,0,239,0,0,0,50,0,0,0,35,0,0,0,143,1,0,0,144,1,0,0,234,2,0,0,36,0,0,0,145,1,0,0,37,0,0,0,146,1,0,0,0,0,0,0,88,60,0,0,118,3,0,0,119,3,0,0,180,0,0,0,240,0,0,0,119,0,0,0,116,0,0,0,46,0,0,0,120,3,0,0,241,0,0,0,181,0,0,0,182,0,0,0,120,0,0,0,242,0,0,0,147,1,0,0,32,0,0,0,243,0,0,0,51,0,0,0,35,0,0,0,148,1,0,0,149,1,0,0,234,2,0,0,36,0,0,0,150,1,0,0,37,0,0,0,151,1,0,0,0,0,0,0,104,60,0,0,121,3,0,0,122,3,0,0,180,0,0,0,244,0,0,0,121,0,0,0,116,0,0,0,46,0,0,0,123,3,0,0,245,0,0,0,181,0,0,0,182,0,0,0,122,0,0,0,246,0,0,0,152,1,0,0,32,0,0,0,247,0,0,0,52,0,0,0,35,0,0,0,153,1,0,0,154,1,0,0,234,2,0,0,36,0,0,0,155,1,0,0,37,0,0,0,156,1,0,0,0,0,0,0,120,60,0,0,124,3,0,0,125,3,0,0,180,0,0,0,248,0,0,0,123,0,0,0,116,0,0,0,46,0,0,0,126,3,0,0,249,0,0,0,181,0,0,0,182,0,0,0,124,0,0,0,250,0,0,0,157,1,0,0,32,0,0,0,251,0,0,0,53,0,0,0,35,0,0,0,158,1,0,0,159,1,0,0,234,2,0,0,36,0,0,0,160,1,0,0,37,0,0,0,161,1,0,0,0,0,0,0,136,60,0,0,127,3,0,0,128,3,0,0,180,0,0,0,252,0,0,0,125,0,0,0,116,0,0,0,46,0,0,0,129,3,0,0,253,0,0,0,181,0,0,0,182,0,0,0,126,0,0,0,254,0,0,0,162,1,0,0,32,0,0,0,255,0,0,0,54,0,0,0,35,0,0,0,163,1,0,0,164,1,0,0,234,2,0,0,36,0,0,0,165,1,0,0,37,0,0,0,166,1,0,0,0,0,0,0,152,60,0,0,130,3,0,0,131,3,0,0,180,0,0,0,0,1,0,0,127,0,0,0,116,0,0,0,46,0,0,0,132,3,0,0,1,1,0,0,181,0,0,0,182,0,0,0,128,0,0,0,2,1,0,0,167,1,0,0,32,0,0,0,3,1,0,0,55,0,0,0,35,0,0,0,168,1,0,0,169,1,0,0,234,2,0,0,36,0,0,0,170,1,0,0,37,0,0,0,171,1,0,0,0,0,0,0,168,60,0,0,133,3,0,0,134,3,0,0,180,0,0,0,4,1,0,0,129,0,0,0,116,0,0,0,46,0,0,0,135,3,0,0,5,1,0,0,181,0,0,0,182,0,0,0,130,0,0,0,6,1,0,0,172,1,0,0,32,0,0,0,7,1,0,0,56,0,0,0,35,0,0,0,173,1,0,0,174,1,0,0,234,2,0,0,36,0,0,0,175,1,0,0,37,0,0,0,176,1,0,0,0,0,0,0,184,60,0,0,136,3,0,0,137,3,0,0,180,0,0,0,8,1,0,0,131,0,0,0,116,0,0,0,46,0,0,0,138,3,0,0,9,1,0,0,181,0,0,0,182,0,0,0,132,0,0,0,10,1,0,0,177,1,0,0,32,0,0,0,11,1,0,0,57,0,0,0,35,0,0,0,178,1,0,0,179,1,0,0,234,2,0,0,36,0,0,0,180,1,0,0,37,0,0,0,181,1,0,0,0,0,0,0,200,60,0,0,139,3,0,0,140,3,0,0,180,0,0,0,12,1,0,0,133,0,0,0,116,0,0,0,46,0,0,0,141,3,0,0,13,1,0,0,181,0,0,0,182,0,0,0,134,0,0,0,14,1,0,0,182,1,0,0,32,0,0,0,15,1,0,0,58,0,0,0,35,0,0,0,183,1,0,0,184,1,0,0,234,2,0,0,36,0,0,0,185,1,0,0,37,0,0,0,186,1,0,0,0,0,0,0,216,60,0,0,142,3,0,0,143,3,0,0,180,0,0,0,16,1,0,0,135,0,0,0,116,0,0,0,46,0,0,0,144,3,0,0,17,1,0,0,181,0,0,0,182,0,0,0,136],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+81920);allocate([18,1,0,0,187,1,0,0,32,0,0,0,19,1,0,0,59,0,0,0,35,0,0,0,188,1,0,0,189,1,0,0,234,2,0,0,36,0,0,0,190,1,0,0,37,0,0,0,191,1,0,0,0,0,0,0,232,60,0,0,145,3,0,0,146,3,0,0,180,0,0,0,20,1,0,0,137,0,0,0,116,0,0,0,46,0,0,0,147,3,0,0,21,1,0,0,181,0,0,0,182,0,0,0,138,0,0,0,22,1,0,0,192,1,0,0,32,0,0,0,23,1,0,0,60,0,0,0,35,0,0,0,193,1,0,0,194,1,0,0,234,2,0,0,36,0,0,0,195,1,0,0,37,0,0,0,196,1,0,0,0,0,0,0,248,60,0,0,148,3,0,0,149,3,0,0,180,0,0,0,24,1,0,0,139,0,0,0,116,0,0,0,46,0,0,0,150,3,0,0,25,1,0,0,181,0,0,0,182,0,0,0,140,0,0,0,26,1,0,0,197,1,0,0,32,0,0,0,27,1,0,0,61,0,0,0,35,0,0,0,198,1,0,0,199,1,0,0,234,2,0,0,36,0,0,0,200,1,0,0,37,0,0,0,201,1,0,0,0,0,0,0,8,61,0,0,151,3,0,0,152,3,0,0,180,0,0,0,28,1,0,0,141,0,0,0,116,0,0,0,46,0,0,0,153,3,0,0,29,1,0,0,181,0,0,0,182,0,0,0,142,0,0,0,30,1,0,0,202,1,0,0,32,0,0,0,31,1,0,0,62,0,0,0,35,0,0,0,203,1,0,0,204,1,0,0,234,2,0,0,36,0,0,0,205,1,0,0,37,0,0,0,206,1,0,0,0,0,0,0,24,61,0,0,154,3,0,0,155,3,0,0,180,0,0,0,32,1,0,0,143,0,0,0,116,0,0,0,46,0,0,0,156,3,0,0,33,1,0,0,181,0,0,0,182,0,0,0,144,0,0,0,34,1,0,0,207,1,0,0,32,0,0,0,35,1,0,0,63,0,0,0,35,0,0,0,208,1,0,0,209,1,0,0,234,2,0,0,36,0,0,0,210,1,0,0,37,0,0,0,211,1,0,0,0,0,0,0,40,61,0,0,157,3,0,0,158,3,0,0,180,0,0,0,36,1,0,0,145,0,0,0,116,0,0,0,46,0,0,0,159,3,0,0,37,1,0,0,181,0,0,0,182,0,0,0,146,0,0,0,38,1,0,0,212,1,0,0,32,0,0,0,39,1,0,0,64,0,0,0,35,0,0,0,213,1,0,0,214,1,0,0,234,2,0,0,36,0,0,0,215,1,0,0,37,0,0,0,216,1,0,0,0,0,0,0,56,61,0,0,160,3,0,0,161,3,0,0,180,0,0,0,40,1,0,0,147,0,0,0,116,0,0,0,46,0,0,0,162,3,0,0,41,1,0,0,181,0,0,0,182,0,0,0,148,0,0,0,42,1,0,0,217,1,0,0,32,0,0,0,43,1,0,0,65,0,0,0,35,0,0,0,218,1,0,0,219,1,0,0,234,2,0,0,36,0,0,0,220,1,0,0,37,0,0,0,221,1,0,0,0,0,0,0,72,61,0,0,163,3,0,0,164,3,0,0,180,0,0,0,44,1,0,0,149,0,0,0,116,0,0,0,46,0,0,0,165,3,0,0,45,1,0,0,181,0,0,0,182,0,0,0,150,0,0,0,46,1,0,0,222,1,0,0,32,0,0,0,47,1,0,0,66,0,0,0,35,0,0,0,223,1,0,0,224,1,0,0,234,2,0,0,36,0,0,0,225,1,0,0,37,0,0,0,226,1,0,0,0,0,0,0,88,61,0,0,166,3,0,0,167,3,0,0,180,0,0,0,48,1,0,0,151,0,0,0,116,0,0,0,46,0,0,0,168,3,0,0,49,1,0,0,181,0,0,0,182,0,0,0,152,0,0,0,50,1,0,0,227,1,0,0,32,0,0,0,51,1,0,0,67,0,0,0,35,0,0,0,228,1,0,0,229,1,0,0,234,2,0,0,36,0,0,0,230,1,0,0,37,0,0,0,231,1,0,0,0,0,0,0,104,61,0,0,169,3,0,0,170,3,0,0,180,0,0,0,52,1,0,0,153,0,0,0,116,0,0,0,46,0,0,0,171,3,0,0,53,1,0,0,181,0,0,0,182,0,0,0,154,0,0,0,54,1,0,0,232,1,0,0,32,0,0,0,55,1,0,0,68,0,0,0,35,0,0,0,233,1,0,0,234,1,0,0,234,2,0,0,36,0,0,0,235,1,0,0,37,0,0,0,236,1,0,0,0,0,0,0,120,61,0,0,172,3,0,0,173,3,0,0,180,0,0,0,56,1,0,0,155,0,0,0,116,0,0,0,46,0,0,0,174,3,0,0,57,1,0,0,181,0,0,0,182,0,0,0,156,0,0,0,58,1,0,0,237,1,0,0,32,0,0,0,59,1,0,0,69,0,0,0,35,0,0,0,238,1,0,0,239,1,0,0,234,2,0,0,36,0,0,0,240,1,0,0,37,0,0,0,241,1,0,0,0,0,0,0,136,61,0,0,175,3,0,0,176,3,0,0,180,0,0,0,60,1,0,0,157,0,0,0,116,0,0,0,46,0,0,0,177,3,0,0,61,1,0,0,181,0,0,0,182,0,0,0,158,0,0,0,62,1,0,0,242,1,0,0,32,0,0,0,63,1,0,0,70,0,0,0,35,0,0,0,243,1,0,0,244,1,0,0,234,2,0,0,36,0,0,0,245,1,0,0,37,0,0,0,246,1,0,0,0,0,0,0,152,61,0,0,178,3,0,0,179,3,0,0,180,0,0,0,64,1,0,0,159,0,0,0,116,0,0,0,46,0,0,0,180,3,0,0,65,1,0,0,181,0,0,0,182,0,0,0,160,0,0,0,66,1,0,0,247,1,0,0,32,0,0,0,67,1,0,0,71,0,0,0,35,0,0,0,248,1,0,0,249,1,0,0,234,2,0,0,36,0,0,0,250,1,0,0,37,0,0,0,251,1,0,0,0,0,0,0,168,61,0,0,181,3,0,0,182,3,0,0,180,0,0,0,68,1,0,0,161,0,0,0,116,0,0,0,46,0,0,0,183,3,0,0,69,1,0,0,181,0,0,0,182,0,0,0,162,0,0,0,70,1,0,0,252,1,0,0,32,0,0,0,71,1,0,0,72,0,0,0,35,0,0,0,253,1,0,0,254,1,0,0,234,2,0,0,36,0,0,0,255,1,0,0,37,0,0,0,0,2,0,0,0,0,0,0,184,61,0,0,184,3,0,0,185,3,0,0,180,0,0,0,72,1,0,0,163,0,0,0,116,0,0,0,46,0,0,0,186,3,0,0,73,1,0,0,181,0,0,0,182,0,0,0,164,0,0,0,74,1,0,0,1,2,0,0,32,0,0,0,75,1,0,0,73,0,0,0,35,0,0,0,2,2,0,0,3,2,0,0,234,2,0,0,36,0,0,0,4,2,0,0,37,0,0,0,5,2,0,0,0,0,0,0,200,61,0,0,187,3,0,0,188,3,0,0,180,0,0,0,76,1,0,0,165,0,0,0,116,0,0,0,46,0,0,0,189,3,0,0,77,1,0,0,181,0,0,0,182,0,0,0,166,0,0,0,78,1,0,0,6,2,0,0,32,0,0,0,79,1,0,0,74,0,0,0,35,0,0,0,7,2,0,0,8,2,0,0,234,2,0,0,36,0,0,0,9,2,0,0,37,0,0,0,10,2,0,0,0,0,0,0,216,61,0,0,190,3,0,0,191,3,0,0,180,0,0,0,80,1,0,0,167,0,0,0,116,0,0,0,46,0,0,0,192,3,0,0,81,1,0,0,181,0,0,0,182,0,0,0,168,0,0,0,82,1,0,0,11,2,0,0,32,0,0,0,83,1,0,0,75,0,0,0,35,0,0,0,12,2,0,0,13,2,0,0,234,2,0,0,36,0,0,0,14,2,0,0,37,0,0,0,15,2,0,0,0,0,0,0,232,61,0,0,193,3,0,0,194,3,0,0,180,0,0,0,84,1,0,0,169,0,0,0,116,0,0,0,46,0,0,0,195,3,0,0,85,1,0,0,181,0,0,0,182,0,0,0,170,0,0,0,86,1,0,0,16,2,0,0,32,0,0,0,87,1,0,0,76,0,0,0,35,0,0,0,17,2,0,0,18,2,0,0,234,2,0,0,36,0,0,0,19,2,0,0,37,0,0,0,20,2,0,0,0,0,0,0,248,61,0,0,196,3,0,0,197,3,0,0,180,0,0,0,88,1,0,0,171,0,0,0,116,0,0,0,46,0,0,0,198,3,0,0,89,1,0,0,181,0,0,0,182,0,0,0,172,0,0,0,90,1,0,0,21,2,0,0,32,0,0,0,91,1,0,0,77,0,0,0,35,0,0,0,22,2,0,0,23,2,0,0,234,2,0,0,36,0,0,0,24,2,0,0,37,0,0,0,25,2,0,0,0,0,0,0,8,62,0,0,199,3,0,0,200,3,0,0,180,0,0,0,92,1,0,0,173,0,0,0,116,0,0,0,46,0,0,0,201,3,0,0,93,1,0,0,181,0,0,0,182,0,0,0,174,0,0,0,94,1,0,0,26,2,0,0,32,0,0,0,95,1,0,0,78,0,0,0,35,0,0,0,27,2,0,0,28,2,0,0,234,2,0,0,36,0,0,0,29,2,0,0,37,0,0,0,30,2,0,0,0,0,0,0,24,62,0,0,202,3,0,0,203,3,0,0,180,0,0,0,96,1,0,0,175,0,0,0,116,0,0,0,46,0,0,0,204,3,0,0,97,1,0,0,181,0,0,0,182,0,0,0,176,0,0,0,98,1,0,0,31,2,0,0,32,0,0,0,99,1,0,0,79,0,0,0,35,0,0,0,32,2,0,0,33,2,0,0,234,2,0,0,36,0,0,0,34,2,0,0,37,0,0,0,35,2,0,0,0,0,0,0,40,62,0,0,205,3,0,0,206,3,0,0,180,0,0,0,100,1,0,0,177,0,0,0,116,0,0,0,46,0,0,0,207,3,0,0,101,1,0,0,181,0,0,0,182,0,0,0,178,0,0,0,102,1,0,0,36,2,0,0,32,0,0,0,103,1,0,0,80,0,0,0,35,0,0,0,37,2,0,0,38,2,0,0,234,2,0,0,36,0,0,0,39,2,0,0,37,0,0,0,40,2,0,0,0,0,0,0,56,62,0,0,208,3,0,0,209,3,0,0,180,0,0,0,104,1,0,0,179,0,0,0,116,0,0,0,46,0,0,0,210,3,0,0,105,1,0,0,181,0,0,0,182,0,0,0,180,0,0,0,106,1,0,0,41,2,0,0,32,0,0,0,107,1,0,0,81,0,0,0,35,0,0,0,42,2,0,0,43,2,0,0,234,2,0,0,36,0,0,0,44,2,0,0,37,0,0,0,45,2,0,0,0,0,0,0,72,62,0,0,211,3,0,0,212,3,0,0,180,0,0,0,108,1,0,0,181,0,0,0,116,0,0,0,46,0,0,0,213,3,0,0,109,1,0,0,181,0,0,0,182,0,0,0,182,0,0,0,110,1,0,0,46,2,0,0,32,0,0,0,111,1,0,0,82,0,0,0,35,0,0,0,47,2,0,0,48,2,0,0,234,2,0,0,36,0,0,0,49,2,0,0,37,0,0,0,50,2,0,0,0,0,0,0,88,62,0,0,214,3,0,0,215,3,0,0,180,0,0,0,112,1,0,0,183,0,0,0,116,0,0,0,46,0,0,0,216,3,0,0,113,1,0,0,181,0,0,0,182,0,0,0,184,0,0,0,114,1,0,0,51,2,0,0,32,0,0,0,115,1,0,0,83,0,0,0,35,0,0,0,52,2,0,0,53,2,0,0,234,2,0,0,36,0,0,0,54,2,0,0,37,0,0,0,55,2,0,0,0,0,0,0,104,62,0,0,217,3,0,0,218,3,0,0,180,0,0,0,116,1,0,0,185,0,0,0,116,0,0,0,46,0,0,0,219,3,0,0,117,1,0,0,181,0,0,0,182,0,0,0,186,0,0,0,118,1,0,0,56,2,0,0,32,0,0,0,119,1,0,0,84,0,0,0,35,0,0,0,57,2,0,0,58,2,0,0,234,2,0,0,36,0,0,0,59,2,0,0,37,0,0,0,60,2,0,0,0,0,0,0,120,62,0,0,220,3,0,0,221,3,0,0,180,0,0,0,120,1,0,0,187,0,0,0,116,0,0,0,46,0,0,0,222,3,0,0,121,1,0,0,181,0,0,0,182,0,0,0,188,0,0,0,122,1,0,0,61,2,0,0,32,0,0,0,123,1,0,0,85,0,0,0,35,0,0,0,62,2,0,0,63,2,0,0,234,2,0,0,36,0,0,0,64,2,0,0,37,0,0,0,65,2,0,0,0,0,0,0,136,62,0,0,223,3,0,0,224,3,0,0,180,0,0,0,124,1,0,0,189,0,0,0,116,0,0,0,46,0,0,0,225,3,0,0,125,1,0,0,181,0,0,0,182,0,0,0,190,0,0,0,126,1,0,0,66,2,0,0,32,0,0,0,127,1,0,0,86,0,0,0,35,0,0,0,67,2,0,0,68,2,0,0,234,2,0,0,36,0,0,0,69,2,0,0,37,0,0,0,70,2,0,0,0,0,0,0,152,62,0,0,226,3,0,0,227,3,0,0,180,0,0,0,128,1,0,0,191,0,0,0,116,0,0,0,46,0,0,0,228,3,0,0,129,1,0,0,181,0,0,0,182,0,0,0,192,0,0,0,130,1,0,0,71,2,0,0,32,0,0,0,131,1,0,0,87,0,0,0,35,0,0,0,72,2,0,0,73,2,0,0,234,2,0,0,36,0,0,0,74,2,0,0,37,0,0,0,75,2,0,0,0,0,0,0,168,62,0,0,229,3,0,0,230,3,0,0,180,0,0,0,132,1,0,0,193,0,0,0,116,0,0,0,46,0,0,0,231,3,0,0,133,1,0,0,181,0,0,0,182,0,0,0,194,0,0,0,134,1,0,0,76,2,0,0,32,0,0,0,135,1,0,0,88,0,0,0,35,0,0,0,77,2,0,0,78,2,0,0,234,2,0,0,36,0,0,0,79,2,0,0,37,0,0,0,80,2,0,0,0,0,0,0,184,62,0,0,232,3,0,0,233,3,0,0,180,0,0,0,136,1,0,0,195,0,0,0,116,0,0,0,46,0,0,0,234,3,0,0,137,1,0,0,181,0,0,0,182,0,0,0,196,0,0,0,138,1,0,0,81,2,0,0,32,0,0,0,139,1,0,0,89,0,0,0,35,0,0,0,82,2,0,0,83,2,0,0,234,2,0,0,36,0,0,0,84,2,0,0,37,0,0,0,85,2,0,0,0,0,0,0,200,62,0,0,235,3,0,0,236,3,0,0,180,0,0,0,140,1,0,0,197,0,0,0,116,0,0,0,46,0,0,0,237,3,0,0,141,1,0,0,181,0,0,0,182,0,0,0,198,0,0,0,142,1,0,0,86,2,0,0,32,0,0,0,143,1,0,0,90,0,0,0,35,0,0,0,87,2,0,0,88,2,0,0,234,2,0,0,36,0,0,0,89,2,0,0,37,0,0,0,90,2,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,88,0,0,0,100,0,0,0,96,0,0,0,124,0,0,0,120,0,0,0,112,0,0,0,92,0,0,0,104,0,0,0,108,0,0,0,16,0,0,0,28,0,0,0,40,0,0,0,56,0,0,0,72,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,8,0,0,0,7,0,0,0,6,0,0,0,1,0,0,0,4,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,20,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,64,0,0,0,68,0,0,0,76,0,0,0,48,0,0,0,72,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,72,0,0,0,16,0,0,0,48,0,0,0,52,0,0,0,56,0,0,0,80,0,0,0,60,0,0,0,64,0,0,0,32,0,0,0,5,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,6,0,0,0,3,0,0,0,4,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,96,0,0,0,32,0,0,0,100,0,0,0,48,0,0,0,64,0,0,0,80,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,140,0,0,0,136,0,0,0,28,0,0,0,44,0,0,0,60,0,0,0,76,0,0,0,124,0,0,0,132,0,0,0,128,0,0,0,92,0,0,0,108,0,0,0,255,255,255,255,4,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,2,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,32,0,0,0,255,255,255,255,40,0,0,0,48,0,0,0,16,0,0,0,24,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,24,0,0,0,255,255,255,255,32,0,0,0,16,0,0,0,20,0,0,0,255,255,255,255,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,216,62,0,0,238,3,0,0,239,3,0,0,180,0,0,0,144,1,0,0,199,0,0,0,116,0,0,0,46,0,0,0,240,3,0,0,145,1,0,0,181,0,0,0,182,0,0,0,200,0,0,0,146,1,0,0,91,2,0,0,32,0,0,0,147,1,0,0,91,0,0,0,35,0,0,0,92,2,0,0,93,2,0,0,234,2,0,0,36,0,0,0,94,2,0,0,37,0,0,0,95,2,0,0,0,0,0,0,19,0,0,0,128,0,0,0,33,0,0,0,41,0,0,0,28,0,0,0,44,0,0,0,56,0,0,0,80,0,0,0,63,0,0,0,77,0,0,0,88,0,0,0,86,0,0,0,93,0,0,0,24,0,0,0,95,0,0,0,107,0,0,0,104,0,0,0,114,0,0,0,121,0,0,0,32,0,0,0,123,0,0,0,140,0,0,0,144,0,0,0,152,0,0,0,161,0,0,0,40,0,0,0,164,0,0,0,170,0,0,0,32,0,0,0,171,0,0,0,178,0,0,0,24,0,0,0,180,0,0,0,188,0,0,0,28,0,0,0,190,0,0,0,197,0,0,0,32,0,0,0,80,5,8,0,208,5,8,0,240,5,8,0,64,6,8,0,152,6,8,0,176,6,8,0,24,7,8,0,56,7,8,0,200,7,8,0,0,8,8,0,32,8,8,0,56,8,8,0,96,8,8,0,0,0,0,0,232,62,0,0,241,3,0,0,242,3,0,0,180,0,0,0,148,1,0,0,201,0,0,0,116,0,0,0,46,0,0,0,243,3,0,0,149,1,0,0,181,0,0,0,182,0,0,0,202,0,0,0,150,1,0,0,96,2,0,0,32,0,0,0,151,1,0,0,92,0,0,0,35,0,0,0,97,2,0,0,98,2,0,0,234,2,0,0,36,0,0,0,99,2,0,0,37,0,0,0,100,2,0,0,0,0,0,0,248,62,0,0,244,3,0,0,245,3,0,0,180,0,0,0,152,1,0,0,203,0,0,0,116,0,0,0,46,0,0,0,246,3,0,0,153,1,0,0,181,0,0,0,182,0,0,0,204,0,0,0,154,1,0,0,101,2,0,0,32,0,0,0,155,1,0,0,93,0,0,0,35,0,0,0,102,2,0,0,103,2,0,0,234,2,0,0,36,0,0,0,104,2,0,0,37,0,0,0,105,2,0,0,0,0,0,0,8,63,0,0,247,3,0,0,248,3,0,0,180,0,0,0,156,1,0,0,205,0,0,0,116,0,0,0,46,0,0,0,249,3,0,0,157,1,0,0,181,0,0,0,182,0,0,0,206,0,0,0,158,1,0,0,106,2,0,0,32,0,0,0,159,1,0,0,94,0,0,0,35,0,0,0,107,2,0,0,108,2,0,0,234,2,0,0,36,0,0,0,109,2,0,0,37,0,0,0,110,2,0,0,0,0,0,0,24,63,0,0,250,3,0,0,251,3,0,0,180,0,0,0,160,1,0,0,207,0,0,0,116,0,0,0,46,0,0,0,252,3,0,0,161,1,0,0,181,0,0,0,182,0,0,0,208,0,0,0,162,1,0,0,111,2,0,0,32,0,0,0,163,1,0,0,95,0,0,0,35,0,0,0,112,2,0,0,113,2,0,0,234,2,0,0,36,0,0,0,114,2,0,0,37,0,0,0,115,2,0,0,0,0,0,0,40,63,0,0,253,3,0,0,254,3,0,0,180,0,0,0,164,1,0,0,209,0,0,0,116,0,0,0,46,0,0,0,255,3,0,0,165,1,0,0,181,0,0,0,182,0,0,0,210,0,0,0,166,1,0,0,116,2,0,0,32,0,0,0,167,1,0,0,96,0,0,0,35,0,0,0,117,2,0,0,118,2,0,0,234,2,0,0,36,0,0,0,119,2,0,0,37,0,0,0,120,2,0,0,0,0,0,0,56,63,0,0,0,4,0,0,1,4,0,0,180,0,0,0,168,1,0,0,211,0,0,0,116,0,0,0,46,0,0,0,2,4,0,0,169,1,0,0,181,0,0,0,182,0,0,0,212,0,0,0,170,1,0,0,121,2,0,0,32,0,0,0,171,1,0,0,97,0,0,0,35,0,0,0,122,2,0,0,123,2,0,0,234,2,0,0,36,0,0,0,124,2,0,0,37,0,0,0,125,2,0,0,0,0,0,0,72,63,0,0,3,4,0,0,4,4,0,0,180,0,0,0,172,1,0,0,213,0,0,0,116,0,0,0,46,0,0,0,5,4,0,0,173,1,0,0,181,0,0,0,182,0,0,0,214,0,0,0,174,1,0,0,126,2,0,0,32,0,0,0,175,1,0,0,98,0,0,0,35,0,0,0,127,2,0,0,128,2,0,0,234,2,0,0,36,0,0,0,129,2,0,0,37,0,0,0,130,2,0,0,0,0,0,0,88,63,0,0,6,4,0,0,7,4,0,0,180,0,0,0,176,1,0,0,215,0,0,0,116,0,0,0,46,0,0,0,8,4,0,0,177,1,0,0,181,0,0,0,182,0,0,0,216,0,0,0,178,1,0,0,131,2,0,0,32,0,0,0,179,1,0,0,99,0,0,0,35,0,0,0,132,2,0,0,133,2,0,0,234,2,0,0,36,0,0,0,134,2,0,0,37,0,0,0,135,2,0,0,0,0,0,0,104,63,0,0,9,4,0,0,10,4,0,0,180,0,0,0,180,1,0,0,217,0,0,0,116,0,0,0,46,0,0,0,11,4,0,0,181,1,0,0,181,0,0,0,182,0,0,0,218,0,0,0,182,1,0,0,136,2,0,0,32,0,0,0,183,1,0,0,100,0,0,0,35,0,0,0,137,2,0,0,138,2,0,0,234,2,0,0,36,0,0,0,139,2,0,0,37,0,0,0,140,2,0,0,0,0,0,0,120,63,0,0,12,4,0,0,13,4,0,0,180,0,0,0,184,1,0,0,219,0,0,0,116,0,0,0,46,0,0,0,14,4,0,0,185,1,0,0,181,0,0,0,182,0,0,0,220,0,0,0,186,1,0,0,141,2,0,0,32,0,0,0,187,1,0,0,101,0,0,0,35,0,0,0,142,2,0,0,143,2,0,0,234,2,0,0,36,0,0,0,144,2,0,0,37,0,0,0,145,2,0,0,0,0,0,0,136,63,0,0,15,4,0,0,16,4,0,0,180,0,0,0,188,1,0,0,221,0,0,0,116,0,0,0,46,0,0,0,17,4,0,0,189,1,0,0,181,0,0,0,182,0,0,0,222,0,0,0,190,1,0,0,146,2,0,0,32,0,0,0,191,1,0,0,102,0,0,0,35,0,0,0,147,2,0,0,148,2,0,0,234,2,0,0,36,0,0,0,149,2,0,0,37,0,0,0,150,2,0,0,0,0,0,0,152,63,0,0,18,4,0,0,19,4,0,0,180,0,0,0,192,1,0,0,223,0,0,0,116,0,0,0,46,0,0,0,20,4,0,0,193,1,0,0,181,0,0,0,182,0,0,0,224,0,0,0,194,1,0,0,151,2,0,0,32,0,0,0,195,1,0,0,103,0,0,0,35,0,0,0,152,2,0,0,153,2,0,0,234,2,0,0,36,0,0,0,154,2,0,0,37,0,0,0,155,2,0,0,0,0,0,0,48,65,0,0,5,0,0,0,21,4,0,0,22,4,0,0,0,0,0,0,16,65,0,0,5,0,0,0,23,4,0,0,24,4,0,0,0,0,0,0,240,64,0,0,5,0,0,0,25,4,0,0,26,4,0,0,0,0,0,0,208,64,0,0,5,0,0,0,27,4,0,0,28,4,0,0,0,0,0,0,176,64,0,0,5,0,0,0,29,4,0,0,30,4,0,0,0,0,0,0,144,64,0,0,5,0,0,0,31,4,0,0,32,4,0,0,0,0,0,0,112,64,0,0,5,0,0,0,33,4,0,0,34,4,0,0,0,0,0,0,80,64,0,0,5,0,0,0,35,4,0,0,36,4,0,0,0,0,0,0,48,64,0,0,5,0,0,0,37,4,0,0,38,4,0,0,0,0,0,0,16,64,0,0,5,0,0,0,39,4,0,0,40,4,0,0,0,0,0,0,240,63,0,0,5,0,0,0,41,4,0,0,42,4,0,0,0,0,0,0,208,63,0,0,5,0,0,0,43,4,0,0,44,4,0,0,0,0,0,0,168,63,0,0,5,0,0,0,45,4,0,0,46,4,0,0,0,0,0,0,192,63,0,0,47,4,0,0,48,4,0,0,10,0,0,0,44,0,0,0,0,0,0,0,184,63,0,0,47,4,0,0,49,4,0,0,10,0,0,0,44,0,0,0,0,0,0,0,224,63,0,0,47,4,0,0,50,4,0,0,10,0,0,0,45,0,0,0,224,129,6,0,82,127,6,0,86,2,0,0,1,0,0,0,180,158,17,0,161,130,6,0,180,130,6,0,224,129,6,0,82,127,6,0,86,2,0,0,1,0,0,0,180,158,17,0,134,130,6,0,152,130,6,0,0,0,0,0,0,64,0,0,47,4,0,0,51,4,0,0,10,0,0,0,44,0,0,0,0,0,0,0,32,64,0,0,47,4,0,0,52,4,0,0,10,0,0,0,46,0,0,0,0,0,0,0,64,64,0,0,47,4,0,0,53,4,0,0,10,0,0,0,47,0,0,0,0,0,0,0,96,64,0,0,47,4,0,0,54,4,0,0,10,0,0,0,44,0,0,0,0,0,0,0,128,64,0,0,47,4,0,0,55,4,0,0,10,0,0,0,48,0,0,0,0,0,0,0,160,64,0,0,47,4,0,0,56,4,0,0,11,0,0,0,44,0,0,0,0,0,0,0,192,64,0,0,47,4,0,0,57,4,0,0,10,0,0,0,44,0,0,0,0,0,0,0,224,64,0,0,47,4,0,0,58,4,0,0,10,0,0,0,44,0,0,0,0,0,0,0,0,65,0,0,47,4,0,0,59,4,0,0,10,0,0,0,44,0,0,0,0,0,0,0,32,65,0,0,47,4,0,0,60,4,0,0,10,0,0,0,49,0,0,0,167,138,6,0,82,127,6,0,5,1,0,0,1,0,0,0,180,158,17,0,92,139,6,0,253,230,6,0,167,138,6,0,82,127,6,0,5,1,0,0,1,0,0,0,180,158,17,0,78,139,6,0,2,222,6,0,0,0,0,0,64,65,0,0,47,4,0,0,61,4,0,0,10,0,0,0,50,0,0,0,18,140,6,0,82,127,6,0,226,0,0,0,1,0,0,0,180,158,17,0,92,139,6,0,253,230,6,0,18,140,6,0,82,127,6,0,226,0,0,0,1,0,0,0,180,158,17,0,78,139,6,0,2,222,6,0,196,1,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,156,2,0,0,62,4,0,0,197,1,0,0,63,4,0,0,64,4,0,0,0,0,0,0,80,65,0,0,5,0,0,0,65,4,0,0,66,4,0,0,0,0,0,0,96,65,0,0,195,2,0,0,67,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,57,0,0,0,39,0,0,0,51,0,0,0,19,0,0,0,20,0,0,0,225,0,0,0,50,0,0,0,58,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,31,0,0,0,4,0,0,0,0,0,0,0,128,65,0,0,5,0,0,0,68,4,0,0,69,4,0,0,0,0,0,0,144,65,0,0,70,4,0,0,71,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,59,0,0,0,39,0,0,0,52,0,0,0,19,0,0,0,20,0,0,0,226,0,0,0,50,0,0,0,60,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,32,0,0,0,4,0,0,0,0,0,0,0,160,65,0,0,57,0,0,0,72,4,0,0,157,2,0,0,0,0,0,0,192,65,0,0,5,0,0,0,73,4,0,0,74,4,0,0,0,0,0,0,224,65,0,0,75,4,0,0,76,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,53,0,0,0,19,0,0,0,20,0,0,0,227,0,0,0,50,0,0,0,61,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,33,0,0,0,4,0,0,0,0,0,0,0,208,65,0,0,75,4,0,0,77,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,4,0,0,0,0,0,0,0,0,66,0,0,78,4,0,0,79,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,62,0,0,0,39,0,0,0,54,0,0,0,19,0,0,0,20,0,0,0,228,0,0,0,63,0,0,0,64,0,0,0,74,0,0,0,52,0,0,0,229,0,0,0,230,0,0,0,53,0,0,0,197,2,0,0,34,0,0,0,112,0,0,0,55,0,0,0,0,0,0,0,240,65,0,0,5,0,0,0,80,4,0,0,81,4,0,0,0,0,0,0,48,66,0,0,82,4,0,0,83,4,0,0,158,2,0,0,0,0,0,0,64,66,0,0,84,4,0,0,85,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,4,0,0,0,0,0,0,0,80,66,0,0,84,4,0,0,86,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,65,0,0,0,39,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,74,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,4,0,0,0,1,0,0,0,0,0,0,0,128,66,0,0,87,4,0,0,88,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,66,0,0,0,39,0,0,0,56,0,0,0,19,0,0,0,20,0,0,0,231,0,0,0,67,0,0,0,68,0,0,0,74,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,35,0,0,0,113,0,0,0,57,0,0,0,0,0,0,0,112,66,0,0,5,0,0,0,89,4,0,0,90,4,0,0,0,0,0,0,160,66,0,0,57,0,0,0,91,4,0,0,159,2,0,0,0,0,0,0,144,66,0,0,57,0,0,0,92,4,0,0,160,2,0,0,0,0,0,0,176,66,0,0,5,0,0,0,93,4,0,0,94,4,0,0,0,0,0,0,192,66,0,0,195,2,0,0,95,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,58,0,0,0,19,0,0,0,20,0,0,0,232,0,0,0,69,0,0,0,70,0,0,0,75,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,114,0,0,0,0,0,0,0,208,66,0,0,57,0,0,0,96,4,0,0,161,2,0,0,0,0,0,0,240,66,0,0,5,0,0,0,97,4,0,0,98,4,0,0,0,0,0,0,0,67,0,0,195,2,0,0,99,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,71,0,0,0,39,0,0,0,59,0,0,0,19,0,0,0,20,0,0,0,233,0,0,0,72,0,0,0,73,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,75,0,0,0,197,2,0,0,36,0,0,0,115,0,0,0,144,164,6,0,187,163,6,0,86,0,0,0,1,0,0,0,26,165,6,0,58,165,6,0,74,165,6,0,144,164,6,0,187,163,6,0,96,0,0,0,1,0,0,0,180,158,17,0,11,165,6,0,2,222,6,0,144,164,6,0,187,163,6,0,96,0,0,0,1,0,0,0,180,158,17,0,252,164,6,0,2,222,6,0,0,0,0,0,32,67,0,0,5,0,0,0,100,4,0,0,101,4,0,0,0,0,0,0,48,67,0,0,102,4,0,0,103,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,76,0,0,0,39,0,0,0,60,0,0,0,19,0,0,0,20,0,0,0,234,0,0,0,77,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,37,0,0,0,4,0,0,0,21,168,6,0,129,166,6,0,137,0,0,0,4,0,0,0,180,158,17,0,177,168,6,0,167,168,6,0,21,168,6,0,129,166,6,0,137,0,0,0,4,0,0,0,180,158,17,0,157,168,6,0,167,168,6,0,21,168,6,0,129,166,6,0,138,0,0,0,4,0,0,0,180,158,17,0,149,168,6,0,140,168,6,0,21,168,6,0,129,166,6,0,138,0,0,0,4,0,0,0,180,158,17,0,131,168,6,0,140,168,6,0,0,0,0,0,80,67,0,0,5,0,0,0,104,4,0,0,105,4,0,0,0,0,0,0,96,67,0,0,195,2,0,0,106,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,61,0,0,0,19,0,0,0,20,0,0,0,235,0,0,0,50,0,0,0,78,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,38,0,0,0,4,0,0,0,0,0,0,0,128,67,0,0,5,0,0,0,107,4,0,0,108,4,0,0,0,0,0,0,160,67,0,0,109,4,0,0,110,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,79,0,0,0,39,0,0,0,62,0,0,0,19,0,0,0,20,0,0,0,236,0,0,0,50,0,0,0,80,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,39,0,0,0,4,0,0,0,0,0,0,0,144,67,0,0,109,4,0,0,111,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,4,0,0,0,0,0,0,0,176,67,0,0,5,0,0,0,112,4,0,0,113,4,0,0,0,0,0,0,192,67,0,0,114,4,0,0,115,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,81,0,0,0,39,0,0,0,63,0,0,0,19,0,0,0,20,0,0,0,237,0,0,0,50,0,0,0,82,0,0,0,73,0,0,0,52,0,0,0,238,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,116,0,0,0,0,0,0,0,224,67,0,0,5,0,0,0,116,4,0,0,117,4,0,0,0,0,0,0,240,67,0,0,118,4,0,0,119,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,83,0,0,0,39,0,0,0,64,0,0,0,19,0,0,0,20,0,0,0,239,0,0,0,50,0,0,0,84,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,40,0,0,0,4,0,0,0,0,0,0,0,32,68,0,0,195,2,0,0,120,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,65,0,0,0,19,0,0,0,20,0,0,0,240,0,0,0,85,0,0,0,86,0,0,0,73,0,0,0,87,0,0,0,22,0,0,0,241,0,0,0,88,0,0,0,197,2,0,0,41,0,0,0,117,0,0,0,52,0,0,0,0,0,0,0,16,68,0,0,5,0,0,0,121,4,0,0,122,4,0,0,0,0,0,0,48,68,0,0,57,0,0,0,123,4,0,0,162,2,0,0,0,0,0,0,80,68,0,0,195,2,0,0,124,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,66,0,0,0,19,0,0,0,20,0,0,0,242,0,0,0,89,0,0,0,90,0,0,0,73,0,0,0,91,0,0,0,22,0,0,0,243,0,0,0,92,0,0,0,197,2,0,0,42,0,0,0,118,0,0,0,53,0,0,0,0,0,0,0,64,68,0,0,5,0,0,0,125,4,0,0,126,4,0,0,0,0,0,0,96,68,0,0,57,0,0,0,127,4,0,0,163,2,0,0,0,0,0,0,144,68,0,0,195,2,0,0,128,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,67,0,0,0,19,0,0,0,20,0,0,0,244,0,0,0,93,0,0,0,94,0,0,0,73,0,0,0,95,0,0,0,22,0,0,0,245,0,0,0,96,0,0,0,197,2,0,0,43,0,0,0,119,0,0,0,54,0,0,0,0,0,0,0,128,68,0,0,5,0,0,0,129,4,0,0,130,4,0,0,0,0,0,0,160,68,0,0,57,0,0,0,131,4,0,0,164,2,0,0,0,0,0,0,208,68,0,0,195,2,0,0,132,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,68,0,0,0,19,0,0,0,20,0,0,0,246,0,0,0,97,0,0,0,98,0,0,0,73,0,0,0,99,0,0,0,22,0,0,0,247,0,0,0,100,0,0,0,197,2,0,0,44,0,0,0,120,0,0,0,55,0,0,0,0,0,0,0,192,68,0,0,5,0,0,0,133,4,0,0,134,4,0,0,0,0,0,0,224,68,0,0,57,0,0,0,135,4,0,0,165,2,0,0,0,0,0,0,16,69,0,0,195,2,0,0,136,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,69,0,0,0,19,0,0,0,20,0,0,0,248,0,0,0,101,0,0,0,102,0,0,0,73,0,0,0,103,0,0,0,22,0,0,0,249,0,0,0,104,0,0,0,197,2,0,0,45,0,0,0,121,0,0,0,56,0,0,0,0,0,0,0,0,69,0,0,5,0,0,0,137,4,0,0,138,4,0,0,0,0,0,0,32,69,0,0,57,0,0,0,139,4,0,0,166,2,0,0,0,0,0,0,80,69,0,0,195,2,0,0,140,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,70,0,0,0,19,0,0,0,20,0,0,0,250,0,0,0,105,0,0,0,106,0,0,0,73,0,0,0,107,0,0,0,22,0,0,0,251,0,0,0,108,0,0,0,197,2,0,0,46,0,0,0,122,0,0,0,57,0,0,0,0,0,0,0,64,69,0,0,5,0,0,0,141,4,0,0,142,4,0,0,0,0,0,0,96,69,0,0,57,0,0,0,143,4,0,0,167,2,0,0,0,0,0,0,144,69,0,0,195,2,0,0,144,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,71,0,0,0,19,0,0,0,20,0,0,0,252,0,0,0,109,0,0,0,110,0,0,0,73,0,0,0,111,0,0,0,22,0,0,0,253,0,0,0,112,0,0,0,197,2,0,0,47,0,0,0,123,0,0,0,58,0,0,0,0,0,0,0,128,69,0,0,5,0,0,0,145,4,0,0,146,4,0,0,0,0,0,0,160,69,0,0,57,0,0,0,147,4,0,0,168,2,0,0,0,0,0,0,208,69,0,0,195,2,0,0,148,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,72,0,0,0,19,0,0,0,20,0,0,0,254,0,0,0,113,0,0,0,114,0,0,0,73,0,0,0,115,0,0,0,22,0,0,0,255,0,0,0,116,0,0,0,197,2,0,0,48,0,0,0,124,0,0,0,59,0,0,0,0,0,0,0,192,69,0,0,5,0,0,0,149,4,0,0,150,4,0,0,0,0,0,0,224,69,0,0,57,0,0,0,151,4,0,0,169,2,0,0,0,0,0,0,0,70,0,0,5,0,0,0,152,4,0,0,153,4,0,0,0,0,0,0,16,70,0,0,154,4,0,0,155,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,73,0,0,0,19,0,0,0,20,0,0,0,0,1,0,0,117,0,0,0,118,0,0,0,73,0,0,0,119,0,0,0,22,0,0,0,1,1,0,0,120,0,0,0,197,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+92160);allocate([49,0,0,0,125,0,0,0,60,0,0,0,0,0,0,0,32,70,0,0,57,0,0,0,156,4,0,0,170,2,0,0,0,0,0,0,48,70,0,0,5,0,0,0,157,4,0,0,158,4,0,0,0,0,0,0,64,70,0,0,195,2,0,0,159,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,74,0,0,0,19,0,0,0,20,0,0,0,2,1,0,0,121,0,0,0,122,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,50,0,0,0,4,0,0,0,0,0,0,0,80,70,0,0,160,4,0,0,161,4,0,0,171,2,0,0,0,0,0,0,96,70,0,0,5,0,0,0,162,4,0,0,163,4,0,0,0,0,0,0,112,70,0,0,164,4,0,0,165,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,123,0,0,0,39,0,0,0,75,0,0,0,19,0,0,0,20,0,0,0,3,1,0,0,50,0,0,0,124,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,51,0,0,0,4,0,0,0,0,0,0,0,160,70,0,0,164,4,0,0,166,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,125,0,0,0,39,0,0,0,75,0,0,0,19,0,0,0,20,0,0,0,4,1,0,0,50,0,0,0,126,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,52,0,0,0,4,0,0,0,0,0,0,0,144,70,0,0,5,0,0,0,167,4,0,0,168,4,0,0,0,0,0,0,176,70,0,0,5,0,0,0,169,4,0,0,170,4,0,0,0,0,0,0,192,70,0,0,195,2,0,0,171,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,76,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,53,0,0,0,4,0,0,0,0,0,0,0,224,70,0,0,5,0,0,0,172,4,0,0,173,4,0,0,0,0,0,0,240,70,0,0,174,4,0,0,175,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,77,0,0,0,19,0,0,0,20,0,0,0,5,1,0,0,127,0,0,0,128,0,0,0,73,0,0,0,52,0,0,0,6,1,0,0,23,0,0,0,53,0,0,0,197,2,0,0,54,0,0,0,126,0,0,0,0,0,0,0,0,71,0,0,57,0,0,0,176,4,0,0,172,2,0,0,0,0,0,0,48,71,0,0,5,0,0,0,177,4,0,0,178,4,0,0,0,0,0,0,64,71,0,0,179,4,0,0,180,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,129,0,0,0,39,0,0,0,78,0,0,0,7,1,0,0,8,1,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,55,0,0,0,4,0,0,0,79,0,0,0,173,2,0,0,174,2,0,0,175,2,0,0,0,0,0,0,80,71,0,0,5,0,0,0,181,4,0,0,182,4,0,0,0,0,0,0,112,71,0,0,183,4,0,0,184,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,130,0,0,0,39,0,0,0,80,0,0,0,19,0,0,0,20,0,0,0,9,1,0,0,50,0,0,0,131,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,56,0,0,0,4,0,0,0,0,0,0,0,96,71,0,0,185,4,0,0,186,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,4,0,0,0,0,0,0,0,128,71,0,0,5,0,0,0,187,4,0,0,188,4,0,0,0,0,0,0,144,71,0,0,195,2,0,0,189,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,81,0,0,0,19,0,0,0,20,0,0,0,10,1,0,0,132,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,57,0,0,0,4,0,0,0,0,0,0,0,176,71,0,0,5,0,0,0,190,4,0,0,191,4,0,0,0,0,0,0,192,71,0,0,192,4,0,0,193,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,82,0,0,0,19,0,0,0,20,0,0,0,11,1,0,0,133,0,0,0,134,0,0,0,73,0,0,0,52,0,0,0,12,1,0,0,23,0,0,0,53,0,0,0,197,2,0,0,58,0,0,0,127,0,0,0,56,206,6,0,87,204,6,0,142,0,0,0,0,0,0,0,180,158,17,0,33,207,6,0,42,207,6,0,56,206,6,0,87,204,6,0,142,0,0,0,1,0,0,0,180,158,17,0,22,207,6,0,2,222,6,0,0,0,0,0,208,71,0,0,57,0,0,0,194,4,0,0,176,2,0,0,0,0,0,0,224,71,0,0,5,0,0,0,195,4,0,0,196,4,0,0,0,0,0,0,240,71,0,0,197,4,0,0,198,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,83,0,0,0,19,0,0,0,20,0,0,0,13,1,0,0,50,0,0,0,135,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,59,0,0,0,4,0,0,0,0,0,0,0,16,72,0,0,5,0,0,0,199,4,0,0,200,4,0,0,0,0,0,0,32,72,0,0,195,2,0,0,201,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,84,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,60,0,0,0,128,0,0,0,0,0,0,0,64,72,0,0,5,0,0,0,202,4,0,0,203,4,0,0,0,0,0,0,80,72,0,0,195,2,0,0,204,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,85,0,0,0,19,0,0,0,20,0,0,0,14,1,0,0,136,0,0,0,137,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,61,0,0,0,129,0,0,0,0,0,0,0,112,72,0,0,5,0,0,0,205,4,0,0,206,4,0,0,0,0,0,0,128,72,0,0,195,2,0,0,207,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,86,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,62,0,0,0,4,0,0,0,0,0,0,0,160,72,0,0,5,0,0,0,208,4,0,0,209,4,0,0,0,0,0,0,176,72,0,0,210,4,0,0,211,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,138,0,0,0,39,0,0,0,87,0,0,0,19,0,0,0,20,0,0,0,15,1,0,0,50,0,0,0,139,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,63,0,0,0,130,0,0,0,0,0,0,0,208,72,0,0,5,0,0,0,212,4,0,0,213,4,0,0,0,0,0,0,224,72,0,0,214,4,0,0,215,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,88,0,0,0,19,0,0,0,20,0,0,0,16,1,0,0,140,0,0,0,141,0,0,0,73,0,0,0,142,0,0,0,22,0,0,0,17,1,0,0,143,0,0,0,197,2,0,0,64,0,0,0,131,0,0,0,61,0,0,0,139,221,6,0,183,219,6,0,52,0,0,0,1,0,0,0,180,158,17,0,242,221,6,0,2,222,6,0,0,0,0,0,0,73,0,0,5,0,0,0,216,4,0,0,217,4,0,0,0,0,0,0,16,73,0,0,218,4,0,0,219,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,144,0,0,0,39,0,0,0,89,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,65,0,0,0,4,0,0,0,0,0,0,0,64,73,0,0,195,2,0,0,220,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,90,0,0,0,19,0,0,0,20,0,0,0,18,1,0,0,50,0,0,0,145,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,66,0,0,0,4,0,0,0,0,0,0,0,48,73,0,0,5,0,0,0,221,4,0,0,222,4,0,0,0,0,0,0,96,73,0,0,5,0,0,0,223,4,0,0,224,4,0,0,0,0,0,0,112,73,0,0,225,4,0,0,226,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,146,0,0,0,39,0,0,0,91,0,0,0,19,0,0,0,20,0,0,0,19,1,0,0,50,0,0,0,147,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,67,0,0,0,132,0,0,0,116,230,6,0,255,227,6,0,49,1,0,0,6,0,0,0,180,158,17,0,239,230,6,0,253,230,6,0,116,230,6,0,255,227,6,0,50,1,0,0,1,0,0,0,180,158,17,0,224,230,6,0,222,230,6,0,116,230,6,0,255,227,6,0,50,1,0,0,1,0,0,0,180,158,17,0,207,230,6,0,222,230,6,0,0,0,0,0,144,73,0,0,5,0,0,0,227,4,0,0,228,4,0,0,0,0,0,0,160,73,0,0,229,4,0,0,230,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,148,0,0,0,39,0,0,0,92,0,0,0,19,0,0,0,20,0,0,0,20,1,0,0,149,0,0,0,150,0,0,0,76,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,68,0,0,0,133,0,0,0,151,0,0,0,152,0,0,0,0,0,0,0,144,55,0,0,229,4,0,0,231,4,0,0,38,0,0,0,6,0,0,0,7,0,0,0,5,0,0,0,8,0,0,0,9,0,0,0,48,0,0,0,49,0,0,0,39,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,50,0,0,0,51,0,0,0,73,0,0,0,52,0,0,0,22,0,0,0,23,0,0,0,53,0,0,0,197,2,0,0,29,0,0,0,4,0,0,0,0,0,0,0,176,73,0,0,232,4,0,0,233,4,0,0,177,2,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,24,0,0,0,16,0,0,0,20,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,4,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,92,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,8,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,12,0,0,0,0,0,0,0,192,73,0,0,234,4,0,0,235,4,0,0,180,0,0,0,198,1,0,0,21,1,0,0,199,1,0,0,200,1,0,0,236,4,0,0,201,1,0,0,181,0,0,0,182,0,0,0,22,1,0,0,202,1,0,0,178,2,0,0,32,0,0,0,203,1,0,0,134,0,0,0,35,0,0,0,179,2,0,0,180,2,0,0,234,2,0,0,36,0,0,0,181,2,0,0,37,0,0,0,182,2,0,0,0,0,0,0,255,255,255,255,44,0,0,0,7,0,0,0,14,0,0,0,24,0,0,0,16,0,0,0,255,255,255,255,100,0,0,0,26,0,0,0,255,255,255,255,32,0,0,0,33,0,0,0,255,255,255,255,20,0,0,0,0,9,8,0,48,9,8,0,72,9,8,0,176,9,8,0,208,9,8,0,0,0,0,0,208,73,0,0,237,4,0,0,238,4,0,0,180,0,0,0,204,1,0,0,23,1,0,0,205,1,0,0,206,1,0,0,239,4,0,0,207,1,0,0,181,0,0,0,182,0,0,0,24,1,0,0,208,1,0,0,183,2,0,0,32,0,0,0,209,1,0,0,135,0,0,0,35,0,0,0,184,2,0,0,185,2,0,0,234,2,0,0,36,0,0,0,186,2,0,0,37,0,0,0,187,2,0,0,0,0,0,0,224,73,0,0,240,4,0,0,241,4,0,0,180,0,0,0,210,1,0,0,25,1,0,0,211,1,0,0,212,1,0,0,242,4,0,0,213,1,0,0,181,0,0,0,182,0,0,0,26,1,0,0,214,1,0,0,188,2,0,0,32,0,0,0,215,1,0,0,136,0,0,0,35,0,0,0,189,2,0,0,190,2,0,0,234,2,0,0,36,0,0,0,191,2,0,0,37,0,0,0,192,2,0,0,0,0,0,0,240,73,0,0,243,4,0,0,244,4,0,0,180,0,0,0,216,1,0,0,27,1,0,0,217,1,0,0,218,1,0,0,245,4,0,0,219,1,0,0,181,0,0,0,182,0,0,0,28,1,0,0,220,1,0,0,193,2,0,0,32,0,0,0,221,1,0,0,137,0,0,0,35,0,0,0,194,2,0,0,195,2,0,0,234,2,0,0,36,0,0,0,196,2,0,0,37,0,0,0,197,2,0,0,0,0,0,0,0,74,0,0,246,4,0,0,247,4,0,0,29,1,0,0,138,0,0,0,30,1,0,0,11,0,0,0,205,0,0,0,206,0,0,0,222,1,0,0,223,1,0,0,248,4,0,0,249,4,0,0,207,0,0,0,208,0,0,0,56,0,0,0,209,0,0,0,224,1,0,0,225,1,0,0,198,2,0,0,0,0,0,0,16,74,0,0,250,4,0,0,251,4,0,0,199,2,0,0,226,1,0,0,31,1,0,0,227,1,0,0,46,0,0,0,252,4,0,0,228,1,0,0,181,0,0,0,200,2,0,0,32,1,0,0,229,1,0,0,201,2,0,0,32,0,0,0,230,1,0,0,139,0,0,0,35,0,0,0,196,0,0,0,202,2,0,0,234,2,0,0,231,1,0,0,198,0,0,0,37,0,0,0,203,2,0,0,232,1,0,0,233,1,0,0,0,0,0,0,48,74,0,0,250,4,0,0,253,4,0,0,199,2,0,0,226,1,0,0,31,1,0,0,227,1,0,0,46,0,0,0,252,4,0,0,228,1,0,0,181,0,0,0,200,2,0,0,32,1,0,0,229,1,0,0,201,2,0,0,32,0,0,0,230,1,0,0,139,0,0,0,35,0,0,0,196,0,0,0,211,0,0,0,234,2,0,0,231,1,0,0,198,0,0,0,37,0,0,0,1,0,0,0,232,1,0,0,233,1,0,0,0,0,0,0,32,74,0,0,254,4,0,0,255,4,0,0,199,2,0,0,226,1,0,0,31,1,0,0,227,1,0,0,46,0,0,0,252,4,0,0,228,1,0,0,181,0,0,0,200,2,0,0,32,1,0,0,229,1,0,0,201,2,0,0,32,0,0,0,230,1,0,0,139,0,0,0,35,0,0,0,196,0,0,0,211,0,0,0,234,2,0,0,231,1,0,0,198,0,0,0,37,0,0,0,1,0,0,0,232,1,0,0,233,1,0,0,0,0,0,0,64,74,0,0,250,4,0,0,0,5,0,0,199,2,0,0,226,1,0,0,31,1,0,0,227,1,0,0,46,0,0,0,252,4,0,0,228,1,0,0,181,0,0,0,200,2,0,0,32,1,0,0,229,1,0,0,201,2,0,0,32,0,0,0,230,1,0,0,139,0,0,0,35,0,0,0,196,0,0,0,202,2,0,0,234,2,0,0,231,1,0,0,198,0,0,0,37,0,0,0,203,2,0,0,234,1,0,0,235,1,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,12,0,0,0,28,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,32,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,12,0,0,0,20,0,0,0,16,0,0,0,40,0,0,0,32,0,0,0,24,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,56,0,0,0,8,0,0,0,24,0,0,0,40,0,0,0,68,0,0,0,60,0,0,0,64,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,12,0,0,0,8,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,0,0,0,0,80,74,0,0,1,5,0,0,2,5,0,0,180,0,0,0,236,1,0,0,33,1,0,0,237,1,0,0,238,1,0,0,3,5,0,0,239,1,0,0,181,0,0,0,182,0,0,0,34,1,0,0,240,1,0,0,204,2,0,0,32,0,0,0,241,1,0,0,140,0,0,0,35,0,0,0,205,2,0,0,206,2,0,0,234,2,0,0,36,0,0,0,207,2,0,0,37,0,0,0,208,2,0,0,0,0,0,0,255,255,255,255,40,0,0,0,12,0,0,0,255,255,255,255,48,0,0,0,24,0,0,0,255,255,255,255,80,0,0,0,40,0,0,0,255,255,255,255,20,0,0,0,47,0,0,0,255,255,255,255,28,0,0,0,16,10,8,0,56,10,8,0,104,10,8,0,184,10,8,0,208,10,8,0,0,0,0,0,96,74,0,0,4,5,0,0,5,5,0,0,180,0,0,0,242,1,0,0,35,1,0,0,243,1,0,0,244,1,0,0,6,5,0,0,245,1,0,0,181,0,0,0,182,0,0,0,36,1,0,0,246,1,0,0,209,2,0,0,32,0,0,0,247,1,0,0,141,0,0,0,35,0,0,0,210,2,0,0,211,2,0,0,234,2,0,0,36,0,0,0,212,2,0,0,37,0,0,0,213,2,0,0,0,0,0,0,112,74,0,0,7,5,0,0,8,5,0,0,180,0,0,0,248,1,0,0,37,1,0,0,249,1,0,0,250,1,0,0,9,5,0,0,251,1,0,0,181,0,0,0,182,0,0,0,38,1,0,0,252,1,0,0,214,2,0,0,32,0,0,0,253,1,0,0,142,0,0,0,35,0,0,0,215,2,0,0,216,2,0,0,234,2,0,0,36,0,0,0,217,2,0,0,37,0,0,0,218,2,0,0,0,0,0,0,128,74,0,0,10,5,0,0,11,5,0,0,180,0,0,0,254,1,0,0,39,1,0,0,255,1,0,0,0,2,0,0,12,5,0,0,1,2,0,0,181,0,0,0,182,0,0,0,40,1,0,0,2,2,0,0,219,2,0,0,32,0,0,0,3,2,0,0,143,0,0,0,35,0,0,0,220,2,0,0,221,2,0,0,234,2,0,0,36,0,0,0,222,2,0,0,37,0,0,0,223,2,0,0,0,0,0,0,144,74,0,0,13,5,0,0,14,5,0,0,180,0,0,0,4,2,0,0,41,1,0,0,5,2,0,0,6,2,0,0,15,5,0,0,7,2,0,0,181,0,0,0,182,0,0,0,42,1,0,0,8,2,0,0,224,2,0,0,32,0,0,0,9,2,0,0,144,0,0,0,35,0,0,0,225,2,0,0,226,2,0,0,234,2,0,0,36,0,0,0,227,2,0,0,37,0,0,0,228,2,0,0,0,0,0,0,192,74,0,0,16,5,0,0,17,5,0,0,38,0,0,0,229,2,0,0,230,2,0,0,10,2,0,0,8,0,0,0,231,2,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,76,0,0,0,11,2,0,0,12,2,0,0,13,2,0,0,232,2,0,0,14,2,0,0,233,2,0,0,15,2,0,0,234,2,0,0,16,2,0,0,13,0,0,0,13,0,0,0,235,2,0,0,17,2,0,0,236,2,0,0,18,2,0,0,237,2,0,0,19,2,0,0,0,0,0,0,176,74,0,0,5,0,0,0,18,5,0,0,19,5,0,0,0,0,0,0,224,74,0,0,16,5,0,0,20,5,0,0,38,0,0,0,238,2,0,0,239,2,0,0,10,2,0,0,8,0,0,0,240,2,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,77,0,0,0,20,2,0,0,21,2,0,0,22,2,0,0,241,2,0,0,23,2,0,0,14,0,0,0,14,0,0,0,242,2,0,0,24,2,0,0,243,2,0,0,25,2,0,0,244,2,0,0,26,2,0,0,245,2,0,0,27,2,0,0,246,2,0,0,28,2,0,0,247,2,0,0,29,2,0,0,248,2,0,0,30,2,0,0,8,0,0,0,253,255,255,255,9,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,7,0,0,0,244,255,255,255,245,255,255,255,9,0,0,0,248,255,255,255,2,0,0,0,7,0,0,0,244,255,255,255,12,0,0,0,243,255,255,255,2,0,0,0,243,255,255,255,2,0,0,0,12,0,0,0,1,0,0,0,249,255,255,255,1,0,0,0,6,0,0,0,254,255,255,255,246,255,255,255,254,255,255,255,252,255,255,255,243,255,255,255,243,255,255,255,245,255,255,255,248,255,255,255,243,255,255,255,253,255,255,255,244,255,255,255,247,255,255,255,10,0,0,0,4,0,0,0,11,0,0,0,9,0,0,0,243,255,255,255,248,255,255,255,248,255,255,255,247,255,255,255,245,255,255,255,7,0,0,0,247,255,255,255,12,0,0,0,7,0,0,0,7,0,0,0,12,0,0,0,6,0,0,0,252,255,255,255,251,255,255,255,253,255,255,255,0,0,0,0,243,255,255,255,2,0,0,0,244,255,255,255,253,255,255,255,247,255,255,255,0,0,0,0,249,255,255,255,5,0,0,0,12,0,0,0,250,255,255,255,12,0,0,0,255,255,255,255,253,255,255,255,6,0,0,0,254,255,255,255,12,0,0,0,250,255,255,255,243,255,255,255,252,255,255,255,248,255,255,255,11,0,0,0,243,255,255,255,12,0,0,0,248,255,255,255,4,0,0,0,7,0,0,0,5,0,0,0,1,0,0,0,5,0,0,0,253,255,255,255,10,0,0,0,253,255,255,255,3,0,0,0,249,255,255,255,6,0,0,0,12,0,0,0,248,255,255,255,249,255,255,255,250,255,255,255,254,255,255,255,254,255,255,255,11,0,0,0,255,255,255,255,246,255,255,255,243,255,255,255,12,0,0,0,248,255,255,255,10,0,0,0,249,255,255,255,3,0,0,0,251,255,255,255,253,255,255,255,252,255,255,255,2,0,0,0,253,255,255,255,7,0,0,0,246,255,255,255,244,255,255,255,250,255,255,255,11,0,0,0,5,0,0,0,244,255,255,255,6,0,0,0,249,255,255,255,5,0,0,0,250,255,255,255,7,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,4,0,0,0,251,255,255,255,9,0,0,0,11,0,0,0,11,0,0,0,243,255,255,255,4,0,0,0,7,0,0,0,4,0,0,0,12,0,0,0,2,0,0,0,255,255,255,255,4,0,0,0,4,0,0,0,252,255,255,255,244,255,255,255,254,255,255,255,7,0,0,0,248,255,255,255,251,255,255,255,249,255,255,255,246,255,255,255,4,0,0,0,11,0,0,0,9,0,0,0,12,0,0,0,0,0,0,0,248,255,255,255,1,0,0,0,243,255,255,255,243,255,255,255,254,255,255,255,248,255,255,255,2,0,0,0,253,255,255,255,254,255,255,255,254,255,255,255,3,0,0,0,250,255,255,255,9,0,0,0,252,255,255,255,247,255,255,255,8,0,0,0,12,0,0,0,10,0,0,0,7,0,0,0,0,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,7,0,0,0,251,255,255,255,11,0,0,0,246,255,255,255,243,255,255,255,250,255,255,255,245,255,255,255,0,0,0,0,10,0,0,0,7,0,0,0,12,0,0,0,1,0,0,0,250,255,255,255,253,255,255,255,250,255,255,255,12,0,0,0,10,0,0,0,247,255,255,255,12,0,0,0,252,255,255,255,243,255,255,255,8,0,0,0,248,255,255,255,244,255,255,255,243,255,255,255,0,0,0,0,248,255,255,255,252,255,255,255,3,0,0,0,3,0,0,0,7,0,0,0,8,0,0,0,5,0,0,0,7,0,0,0,10,0,0,0,249,255,255,255,255,255,255,255,7,0,0,0,1,0,0,0,244,255,255,255,3,0,0,0,246,255,255,255,5,0,0,0,6,0,0,0,2,0,0,0,252,255,255,255,3,0,0,0,246,255,255,255,243,255,255,255,0,0,0,0,243,255,255,255,5,0,0,0,243,255,255,255,249,255,255,255,244,255,255,255,12,0,0,0,243,255,255,255,3,0,0,0,245,255,255,255,8,0,0,0,249,255,255,255,12,0,0,0,252,255,255,255,7,0,0,0,6,0,0,0,246,255,255,255,12,0,0,0,8,0,0,0,247,255,255,255,255,255,255,255,249,255,255,255,250,255,255,255,254,255,255,255,251,255,255,255,0,0,0,0,12,0,0,0,244,255,255,255,5,0,0,0,249,255,255,255,5,0,0,0,3,0,0,0,246,255,255,255,8,0,0,0,243,255,255,255,249,255,255,255,249,255,255,255,252,255,255,255,5,0,0,0,253,255,255,255,254,255,255,255,255,255,255,255,249,255,255,255,2,0,0,0,9,0,0,0,5,0,0,0,245,255,255,255,245,255,255,255,243,255,255,255,251,255,255,255,243,255,255,255,255,255,255,255,6,0,0,0,0,0,0,0,255,255,255,255,5,0,0,0,253,255,255,255,5,0,0,0,2,0,0,0,252,255,255,255,243,255,255,255,252,255,255,255,12,0,0,0,247,255,255,255,250,255,255,255,247,255,255,255,6,0,0,0,244,255,255,255,246,255,255,255,248,255,255,255,252,255,255,255,10,0,0,0,2,0,0,0,12,0,0,0,253,255,255,255,7,0,0,0,12,0,0,0,12,0,0,0,12,0,0,0,249,255,255,255,243,255,255,255,250,255,255,255,5,0,0,0,252,255,255,255,9,0,0,0,253,255,255,255,4,0,0,0,7,0,0,0,255,255,255,255,12,0,0,0,2,0,0,0,249,255,255,255,6,0,0,0,251,255,255,255,1,0,0,0,243,255,255,255,11,0,0,0,244,255,255,255,5,0,0,0,253,255,255,255,7,0,0,0,254,255,255,255,250,255,255,255,7,0,0,0,248,255,255,255,12,0,0,0,249,255,255,255,243,255,255,255,249,255,255,255,245,255,255,255,244,255,255,255,1,0,0,0,253,255,255,255,12,0,0,0,12,0,0,0,2,0,0,0,250,255,255,255,3,0,0,0,0,0,0,0,252,255,255,255,3,0,0,0,254,255,255,255,243,255,255,255,255,255,255,255,243,255,255,255,1,0,0,0,9,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,250,255,255,255,1,0,0,0,255,255,255,255,3,0,0,0,12,0,0,0,9,0,0,0,1,0,0,0,12,0,0,0,6,0,0,0,255,255,255,255,247,255,255,255,255,255,255,255,3,0,0,0,243,255,255,255,243,255,255,255,246,255,255,255,5,0,0,0,7,0,0,0,7,0,0,0,10,0,0,0,12,0,0,0,12,0,0,0,251,255,255,255,12,0,0,0,9,0,0,0,6,0,0,0,3,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,243,255,255,255,6,0,0,0,10,0,0,0,2,0,0,0,244,255,255,255,2,0,0,0,3,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,250,255,255,255,2,0,0,0,6,0,0,0,12,0,0,0,243,255,255,255,9,0,0,0,244,255,255,255,10,0,0,0,3,0,0,0,248,255,255,255,4,0,0,0,249,255,255,255,9,0,0,0,245,255,255,255,12,0,0,0,252,255,255,255,250,255,255,255,1,0,0,0,12,0,0,0,2,0,0,0,248,255,255,255,6,0,0,0,247,255,255,255,7,0,0,0,252,255,255,255,2,0,0,0,3,0,0,0,3,0,0,0,254,255,255,255,6,0,0,0,3,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,253,255,255,255,8,0,0,0,248,255,255,255,7,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,245,255,255,255,251,255,255,255,250,255,255,255,252,255,255,255,246,255,255,255,11,0,0,0,251,255,255,255,10,0,0,0,251,255,255,255,248,255,255,255,253,255,255,255,12,0,0,0,246,255,255,255,5,0,0,0,247,255,255,255,0,0,0,0,8,0,0,0,255,255,255,255,12,0,0,0,250,255,255,255,4,0,0,0,250,255,255,255,6,0,0,0,245,255,255,255,246,255,255,255,12,0,0,0,248,255,255,255,7,0,0,0,4,0,0,0,254,255,255,255,6,0,0,0,7,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,12,0,0,0,251,255,255,255,248,255,255,255,251,255,255,255,2,0,0,0,7,0,0,0,250,255,255,255,10,0,0,0,12,0,0,0,247,255,255,255,243,255,255,255,248,255,255,255,248,255,255,255,251,255,255,255,243,255,255,255,251,255,255,255,254,255,255,255,8,0,0,0,248,255,255,255,9,0,0,0,243,255,255,255,247,255,255,255,245,255,255,255,247,255,255,255,0,0,0,0,1,0,0,0,248,255,255,255,1,0,0,0,254,255,255,255,7,0,0,0,252,255,255,255,9,0,0,0,1,0,0,0,254,255,255,255,1,0,0,0,255,255,255,255,252,255,255,255,11,0,0,0,250,255,255,255,12,0,0,0,245,255,255,255,244,255,255,255,247,255,255,255,250,255,255,255,4,0,0,0,3,0,0,0,7,0,0,0,7,0,0,0,12,0,0,0,5,0,0,0,5,0,0,0,10,0,0,0,8,0,0,0,0,0,0,0,252,255,255,255,2,0,0,0,8,0,0,0,247,255,255,255,12,0,0,0,251,255,255,255,243,255,255,255,0,0,0,0,7,0,0,0,2,0,0,0,12,0,0,0,255,255,255,255,2,0,0,0,1,0,0,0,7,0,0,0,5,0,0,0,11,0,0,0,7,0,0,0,247,255,255,255,3,0,0,0,5,0,0,0,6,0,0,0,248,255,255,255,243,255,255,255,252,255,255,255,248,255,255,255,9,0,0,0,251,255,255,255,9,0,0,0,253,255,255,255,253,255,255,255,252,255,255,255,249,255,255,255,253,255,255,255,244,255,255,255,6,0,0,0,5,0,0,0,8,0,0,0,0,0,0,0,249,255,255,255,6,0,0,0,250,255,255,255,12,0,0,0,243,255,255,255,6,0,0,0,251,255,255,255,254,255,255,255,1,0,0,0,246,255,255,255,3,0,0,0,10,0,0,0,4,0,0,0,1,0,0,0,8,0,0,0,252,255,255,255,254,255,255,255,254,255,255,255,2,0,0,0,243,255,255,255,2,0,0,0,244,255,255,255,12,0,0,0,12,0,0,0,254,255,255,255,243,255,255,255,0,0,0,0,250,255,255,255,4,0,0,0,1,0,0,0,9,0,0,0,3,0,0,0,250,255,255,255,246,255,255,255,253,255,255,255,251,255,255,255,253,255,255,255,243,255,255,255,255,255,255,255,1,0,0,0,7,0,0,0,5,0,0,0,12,0,0,0,245,255,255,255,4,0,0,0,254,255,255,255,5,0,0,0,249,255,255,255,243,255,255,255,9,0,0,0,247,255,255,255,251,255,255,255,7,0,0,0,1,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,248,255,255,255,7,0,0,0,6,0,0,0,249,255,255,255,252,255,255,255,249,255,255,255,1,0,0,0,248,255,255,255,11,0,0,0,249,255,255,255,248,255,255,255,243,255,255,255,6,0,0,0,244,255,255,255,248,255,255,255,2,0,0,0,4,0,0,0,3,0,0,0,9,0,0,0,10,0,0,0,251,255,255,255,12,0,0,0,3,0,0,0,250,255,255,255,251,255,255,255,250,255,255,255,7,0,0,0,8,0,0,0,253,255,255,255,9,0,0,0,248,255,255,255,2,0,0,0,244,255,255,255,2,0,0,0,8,0,0,0,245,255,255,255,254,255,255,255,246,255,255,255,3,0,0,0,244,255,255,255,243,255,255,255,249,255,255,255,247,255,255,255,245,255,255,255,0,0,0,0,246,255,255,255,251,255,255,255,5,0,0,0,253,255,255,255,11,0,0,0,8,0,0,0,254,255,255,255,243,255,255,255,255,255,255,255,12,0,0,0,255,255,255,255,248,255,255,255,0,0,0,0,9,0,0,0,243,255,255,255,245,255,255,255,244,255,255,255,251,255,255,255,246,255,255,255,254,255,255,255,246,255,255,255,11,0,0,0,253,255,255,255,9,0,0,0,254,255,255,255,243,255,255,255,2,0,0,0,253,255,255,255,3,0,0,0,2,0,0,0,247,255,255,255,243,255,255,255,252,255,255,255,0,0,0,0,252,255,255,255,6,0,0,0,253,255,255,255,246,255,255,255,252,255,255,255,12,0,0,0,254,255,255,255,249,255,255,255,250,255,255,255,245,255,255,255,252,255,255,255,9,0,0,0,6,0,0,0,253,255,255,255,6,0,0,0,11,0,0,0,243,255,255,255,11,0,0,0,251,255,255,255,5,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,6,0,0,0,7,0,0,0,251,255,255,255,12,0,0,0,254,255,255,255,255,255,255,255,12,0,0,0,0,0,0,0,7,0,0,0,252,255,255,255,248,255,255,255,253,255,255,255,254,255,255,255,249,255,255,255,1,0,0,0,250,255,255,255,7,0,0,0,243,255,255,255,244,255,255,255,248,255,255,255,243,255,255,255,249,255,255,255,254,255,255,255,250,255,255,255,248,255,255,255,248,255,255,255,5,0,0,0,250,255,255,255,247,255,255,255,251,255,255,255,255,255,255,255,252,255,255,255,5,0,0,0,243,255,255,255,7,0,0,0,248,255,255,255,10,0,0,0,1,0,0,0,5,0,0,0,5,0,0,0,243,255,255,255,1,0,0,0,0,0,0,0,10,0,0,0,243,255,255,255,9,0,0,0,12,0,0,0,10,0,0,0,255,255,255,255,5,0,0,0,248,255,255,255,10,0,0,0,247,255,255,255,255,255,255,255,11,0,0,0,1,0,0,0,243,255,255,255,247,255,255,255,253,255,255,255,250,255,255,255,2,0,0,0,255,255,255,255,246,255,255,255,1,0,0,0,12,0,0,0,243,255,255,255,1,0,0,0,248,255,255,255,246,255,255,255,8,0,0,0,245,255,255,255,10,0,0,0,250,255,255,255,2,0,0,0,243,255,255,255,3,0,0,0,250,255,255,255,7,0,0,0,243,255,255,255,12,0,0,0,247,255,255,255,246,255,255,255,246,255,255,255,251,255,255,255,249,255,255,255,246,255,255,255,248,255,255,255,248,255,255,255,243,255,255,255,4,0,0,0,250,255,255,255,8,0,0,0,5,0,0,0,3,0,0,0,12,0,0,0,8,0,0,0,243,255,255,255,252,255,255,255,2,0,0,0,253,255,255,255,253,255,255,255,5,0,0,0,243,255,255,255,10,0,0,0,244,255,255,255,4,0,0,0,243,255,255,255,5,0,0,0,255,255,255,255,247,255,255,255,9,0,0,0,252,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,3,0,0,0,247,255,255,255,244,255,255,255,1,0,0,0,250,255,255,255,1,0,0,0,3,0,0,0,2,0,0,0,4,0,0,0,248,255,255,255,246,255,255,255,246,255,255,255,246,255,255,255,9,0,0,0,8,0,0,0,243,255,255,255,12,0,0,0,12,0,0,0,248,255,255,255,244,255,255,255,250,255,255,255,251,255,255,255,2,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,10,0,0,0,6,0,0,0,11,0,0,0,248,255,255,255,6,0,0,0,8,0,0,0,8,0,0,0,244,255,255,255,249,255,255,255,10,0,0,0,250,255,255,255,5,0,0,0,253,255,255,255,247,255,255,255,253,255,255,255,9,0,0,0,255,255,255,255,243,255,255,255,255,255,255,255,5,0,0,0,253,255,255,255,249,255,255,255,253,255,255,255,4,0,0,0,248,255,255,255,254,255,255,255,248,255,255,255,3,0,0,0,4,0,0,0,2,0,0,0,12,0,0,0,12,0,0,0,2,0,0,0,251,255,255,255,3,0,0,0,11,0,0,0,6,0,0,0,247,255,255,255,11,0,0,0,243,255,255,255,3,0,0,0,255,255,255,255,7,0,0,0,12,0,0,0,11,0,0,0,255,255,255,255,12,0,0,0,4,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,6,0,0,0,4,0,0,0,245,255,255,255,4,0,0,0,12,0,0,0,2,0,0,0,252,255,255,255,2,0,0,0,1,0,0,0,246,255,255,255,250,255,255,255,248,255,255,255,1,0,0,0,243,255,255,255,7,0,0,0,245,255,255,255,1,0,0,0,243,255,255,255,12,0,0,0,245,255,255,255,243,255,255,255,6,0,0,0,0,0,0,0,11,0,0,0,243,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,4,0,0,0,243,255,255,255,3,0,0,0,247,255,255,255,254,255,255,255,247,255,255,255,8,0,0,0,250,255,255,255,253,255,255,255,243,255,255,255,250,255,255,255,248,255,255,255,254,255,255,255,5,0,0,0,247,255,255,255,8,0,0,0,10,0,0,0,2,0,0,0,7,0,0,0,3,0,0,0,247,255,255,255,255,255,255,255,250,255,255,255,255,255,255,255,255,255,255,255,9,0,0,0,5,0,0,0,11,0,0,0,254,255,255,255,11,0,0,0,253,255,255,255,12,0,0,0,248,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,255,255,255,255,4,0,0,0,0,0,0,0,10,0,0,0,3,0,0,0,250,255,255,255,4,0,0,0,5,0,0,0,243,255,255,255,0,0,0,0,246,255,255,255,5,0,0,0,5,0,0,0,8,0,0,0,12,0,0,0,11,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,250,255,255,255,7,0,0,0,252,255,255,255,8,0,0,0,244,255,255,255,246,255,255,255,4,0,0,0,246,255,255,255,9,0,0,0,7,0,0,0,3,0,0,0,12,0,0,0,4,0,0,0,9,0,0,0,249,255,255,255,10,0,0,0,254,255,255,255,7,0,0,0,0,0,0,0,12,0,0,0,254,255,255,255,255,255,255,255,250,255,255,255,0,0,0,0,245,255,255,255,0,0,0,0,240,74,0,0,5,0,0,0,21,5,0,0,22,5,0,0,0,0,0,0,32,75,0,0,16,5,0,0,23,5,0,0,38,0,0,0,238,2,0,0,239,2,0,0,10,2,0,0,8,0,0,0,249,2,0,0,97,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,78,0,0,0,31,2,0,0,32,2,0,0,33,2,0,0,250,2,0,0,34,2,0,0,15,0,0,0,15,0,0,0,16,0,0,0,16,0,0,0,251,2,0,0,35,2,0,0,252,2,0,0,36,2,0,0,17,0,0,0,17,0,0,0,0,0,0,0,16,75,0,0,5,0,0,0,24,5,0,0,25,5,0,0,0,0,0,0,96,75,0,0,16,5,0,0,26,5,0,0,38,0,0,0,238,2,0,0,239,2,0,0,10,2,0,0,8,0,0,0,253,2,0,0,98,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,78,0,0,0,31,2,0,0,32,2,0,0,33,2,0,0,254,2,0,0,37,2,0,0,255,2,0,0,38,2,0,0,0,3,0,0,39,2,0,0,0,0,0,0,80,75,0,0,5,0,0,0,27,5,0,0,28,5,0,0,0,0,0,0,112,75,0,0,29,5,0,0,30,5,0,0,38,0,0,0,238,2,0,0,239,2,0,0,10,2,0,0,8,0,0,0,1,3,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,79,0,0,0,40,2,0,0,41,2,0,0,42,2,0,0,0,0,0,0,144,75,0,0,5,0,0,0,31,5,0,0,32,5,0,0,0,0,0,0,176,75,0,0,57,0,0,0,33,5,0,0,2,3,0,0,0,0,0,0,160,75,0,0,57,0,0,0,34,5,0,0,3,3,0,0,0,0,0,0,192,75,0,0,57,0,0,0,35,5,0,0,4,3,0,0,148,155,208,60,182,145,192,60,246,122,151,60,156,20,75,60,197,0,232,59,39,219,97,59,184,92,187,58,182,145,192,60,135,195,177,60,124,213,139,60,144,119,59,60,111,42,214,59,177,125,80,59,22,245,172,58,246,122,151,60,124,213,139,60,153,254,91,60,129,119,19,60,4,120,168,59,82,1,36,59,128,13,136,58,156,20,75,60,144,119,59,60,129,119,19,60,40,179,197,59,39,219,97,59,57,223,219,58,173,101,54,58,197,0,232,59,111,42,214,59,4,120,168,59,39,219,97,59,202,2,1,59,183,47,123,58,126,95,208,57,39,219,97,59,177,125,80,59,82,1,36,59,57,223,219,58,183,47,123,58,38,135,244,57,134,219,74,57,184,92,187,58,22,245,172,58,128,13,136,58,173,101,54,58,126,95,208,57,134,219,74,57,134,70,168,56,0,0,0,0,208,75,0,0,57,0,0,0,36,5,0,0,5,3,0,0,0,0,0,0,48,76,0,0,57,0,0,0,37,5,0,0,6,3,0,0,0,0,0,0,32,76,0,0,57,0,0,0,38,5,0,0,7,3,0,0,0,0,0,0,16,76,0,0,57,0,0,0,39,5,0,0,8,3,0,0,0,0,0,0,240,75,0,0,57,0,0,0,40,5,0,0,9,3,0,0,0,0,0,0,224,75,0,0,41,5,0,0,42,5,0,0,10,3,0,0,0,0,0,0,0,76,0,0,43,5,0,0,44,5,0,0,11,3,0,0,0,0,0,0,96,76,0,0,16,5,0,0,45,5,0,0,38,0,0,0,12,3,0,0,13,3,0,0,10,2,0,0,8,0,0,0,14,3,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,80,0,0,0,43,2,0,0,44,2,0,0,45,2,0,0,15,3,0,0,46,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+102400);allocate([16,3,0,0,47,2,0,0,18,0,0,0,18,0,0,0,17,3,0,0,48,2,0,0,18,3,0,0,49,2,0,0,19,3,0,0,50,2,0,0,0,0,0,0,80,76,0,0,5,0,0,0,46,5,0,0,47,5,0,0,0,0,0,0,112,76,0,0,48,5,0,0,49,5,0,0,50,5,0,0,20,3,0,0,21,3,0,0,51,2,0,0,8,0,0,0,9,0,0,0,22,3,0,0,1,0,0,0,51,5,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,128,76,0,0,48,5,0,0,52,5,0,0,50,5,0,0,20,3,0,0,21,3,0,0,51,2,0,0,8,0,0,0,9,0,0,0,22,3,0,0,52,2,0,0,51,5,0,0,153,0,0,0,81,0,0,0,1,0,0,0,0,0,0,0,144,76,0,0,5,0,0,0,53,5,0,0,54,5,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,255,255,255,255,254,255,255,255,254,255,255,255,255,255,255,255,253,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,253,255,255,255,2,0,0,0,254,255,255,255,3,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,3,0,0,0,254,255,255,255,2,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,254,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,2,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,38,0,1,0,23,0,2,32,12,0,3,48,9,0,4,80,7,0,5,16,6,0,109,64,108,0,109,112,108,0,8,64,108,0,109,96,108,0,10,16,11,0,109,64,108,0,109,112,18,0,13,112,108,0,14,96,17,0,15,80,16,0,109,16,108,0,109,64,108,0,109,16,108,16,19,80,108,16,20,48,108,16,21,112,108,16,22,64,108,16,109,96,28,0,24,80,108,0,25,112,108,0,26,96,27,0,109,16,108,0,109,64,108,16,29,80,108,16,30,48,35,16,31,32,33,16,32,16,108,16,109,64,108,16,34,64,108,16,109,96,108,16,36,112,108,16,37,64,108,16,109,96,88,16,39,0,73,16,40,32,53,0,41,112,49,16,42,48,47,16,43,80,45,16,44,16,108,16,109,64,108,16,46,64,108,16,109,96,108,16,48,16,108,16,109,64,108,0,50,80,108,0,51,48,108,0,52,64,108,0,109,96,65,16,54,112,60,16,55,48,59,16,56,80,57,16,109,16,108,16,58,64,108,16,109,96,108,16,109,16,108,16,61,96,64,16,62,80,63,16,109,16,108,16,109,64,108,16,109,16,108,16,66,48,71,16,67,80,69,16,68,16,108,16,109,64,108,16,70,64,108,16,109,96,108,16,72,16,108,16,109,64,83,0,74,80,108,0,75,48,80,0,76,32,78,0,77,16,108,0,109,64,108,0,79,64,108,0,109,96,108,0,81,112,108,0,82,64,108,0,109,96,108,16,84,80,108,16,85,112,108,16,86,96,87,16,109,16,108,16,109,64,98,0,89,48,108,0,90,80,95,0,91,32,93,0,92,16,108,0,109,64,108,0,94,64,108,0,109,96,108,0,96,112,108,0,97,64,108,0,109,96,108,16,99,48,108,16,100,80,105,16,101,32,103,16,102,16,108,16,109,64,108,16,104,64,108,16,109,96,108,16,106,112,108,16,107,64,108,16,109,96,254,0,0,0,255,0,0,0,181,0,1,0,54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,135,65,134,1,9,160,134,1,135,177,134,1,11,128,134,1,12,160,13,0,135,177,134,1,14,64,134,1,135,113,134,1,16,176,19,0,17,48,18,0,135,65,134,1,135,161,134,1,20,128,134,1,135,161,134,1,22,96,134,1,23,112,134,1,24,128,27,0,25,64,26,0,135,49,134,1,135,161,134,1,28,160,134,1,135,177,134,1,30,48,134,1,31,64,34,0,32,16,33,0,135,97,134,1,135,177,134,1,35,96,134,1,36,112,134,1,135,129,134,1,38,144,134,1,39,112,134,1,40,128,48,0,41,16,45,0,42,160,43,0,135,177,134,1,44,96,134,1,135,65,134,1,46,96,134,1,47,48,134,1,135,65,134,1,49,96,52,0,50,64,51,0,135,49,134,1,135,161,134,1,53,160,134,1,135,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,134,1,62,160,63,0,135,33,134,1,135,113,134,17,65,96,134,17,66,32,134,17,67,112,134,17,135,129,72,0,69,96,134,1,70,112,134,1,71,128,134,1,135,161,134,17,73,96,134,17,74,32,134,17,75,112,76,16,135,17,134,17,135,129,134,17,78,32,134,17,79,112,81,16,80,16,134,17,135,97,134,17,82,96,134,17,135,129,134,1,84,176,134,1,85,128,134,1,86,160,89,0,87,16,88,0,135,33,134,1,135,113,134,1,90,96,134,1,135,113,134,1,92,176,134,1,93,160,101,0,94,48,98,0,95,16,96,0,135,33,134,1,97,112,134,1,135,129,134,1,99,96,134,1,100,112,134,1,135,129,134,1,102,128,105,0,103,16,104,0,135,33,134,1,135,113,134,1,106,96,134,1,135,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,134,1,113,48,134,1,135,177,134,17,115,96,134,17,116,112,134,17,117,128,134,17,118,176,134,17,135,161,134,17,120,96,134,17,121,112,134,17,122,128,125,16,123,160,124,16,135,65,134,17,135,177,134,17,126,48,134,17,135,65,134,17,128,96,134,17,129,112,134,17,130,128,133,16,131,64,132,16,135,49,134,17,135,161,134,17,134,160,134,17,135,177,134,17,136,96,134,17,137,112,143,16,138,128,141,16,139,64,140,16,135,49,134,17,135,161,134,17,142,160,134,17,135,177,134,17,144,32,134,17,145,16,134,17,146,48,134,17,135,65,153,0,148,32,134,1,149,16,134,1,150,48,134,1,151,64,134,1,152,160,134,1,135,177,134,17,154,32,134,17,155,48,134,17,156,64,134,17,157,112,159,16,158,16,134,17,135,97,134,17,160,96,134,17,135,129,174,0,162,32,134,1,163,160,134,1,164,176,171,0,165,144,168,0,166,16,167,0,135,49,134,1,135,129,134,1,169,96,134,1,170,112,134,1,135,129,134,1,172,16,134,1,173,48,134,1,135,65,134,1,175,144,134,1,176,112,134,1,177,128,134,1,178,160,134,1,179,176,180,0,135,17,134,1,135,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,134,1,186,96,193,0,187,64,190,0,188,48,189,0,135,17,134,1,135,129,134,1,191,144,134,1,192,128,134,1,135,161,134,1,194,144,134,1,195,128,134,1,196,160,134,1,135,177,134,17,198,144,134,17,199,128,134,17,200,160,134,17,201,176,134,17,202,112,203,16,135,17,134,17,135,97,134,17,205,144,134,17,206,112,134,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,135,177,134,17,212,96,134,17,135,65,134,17,214,96,134,17,215,48,134,17,135,65,134,17,217,96,220,16,218,64,219,16,135,49,134,17,135,161,134,17,221,160,134,17,135,177,134,17,223,160,134,17,224,176,225,16,135,17,134,17,135,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,134,17,233,48,134,17,135,177,134,1,235,96,134,1,236,112,134,1,237,128,134,1,238,176,134,1,135,161,134,1,240,96,134,1,241,112,134,1,242,128,245,0,243,160,244,0,135,65,134,1,135,177,134,1,246,48,134,1,135,65,134,1,248,96,134,1,249,112,134,1,250,128,253,0,251,64,252,0,135,49,134,1,135,161,134,1,254,160,134,1,135,177,134,17,0,49,134,17,1,65,8,17,2,81,5,17,3,17,4,17,135,97,134,17,135,177,134,17,6,97,134,17,7,113,134,17,135,129,134,17,9,17,134,17,10,161,134,17,135,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,135,65,134,17,18,161,134,17,135,177,134,17,20,129,134,17,21,161,22,17,135,177,134,17,23,65,134,17,135,113,134,17,25,177,28,17,26,49,27,17,135,65,134,17,135,161,134,17,29,129,134,17,135,161,134,17,31,97,134,17,32,113,134,17,33,129,36,17,34,65,35,17,135,49,134,17,135,161,134,17,37,161,134,17,135,177,134,17,39,161,134,17,40,177,43,17,41,17,42,17,135,49,134,17,135,129,134,17,44,97,134,17,45,113,134,17,135,129,134,17,47,49,134,17,48,65,55,17,49,81,52,17,50,17,51,17,135,97,134,17,135,177,134,17,53,97,134,17,54,113,134,17,135,129,134,17,56,17,134,17,57,161,134,17,135,177,80,17,59,145,134,17,60,113,134,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,135,177,134,17,66,97,134,17,135,65,134,17,68,97,134,17,69,49,134,17,135,65,134,17,71,97,74,17,72,65,73,17,135,49,134,17,135,161,134,17,75,161,134,17,135,177,134,17,77,161,134,17,78,177,79,17,135,17,134,17,135,97,134,1,81,81,134,1,82,145,134,1,83,97,134,1,84,113,134,1,85,129,88,1,86,65,87,1,135,49,134,1,135,161,134,1,89,161,134,1,135,177,112,1,91,81,104,1,92,145,134,1,93,97,134,1,94,113,101,1,95,65,99,1,96,49,97,1,135,129,134,1,98,17,134,1,135,33,134,1,100,129,134,1,135,161,134,1,102,177,134,1,103,129,134,1,135,161,134,1,105,33,134,1,106,49,134,1,107,65,134,1,108,113,110,1,109,17,134,1,135,97,134,1,111,97,134,1,135,129,134,17,113,81,126,17,114,145,134,17,115,97,134,17,116,113,123,17,117,65,121,17,118,49,119,17,135,129,134,17,120,17,134,17,135,33,134,17,122,129,134,17,135,161,134,17,124,177,134,17,125,129,134,17,135,161,134,17,127,33,134,17,128,49,134,17,129,65,134,17,130,113,132,17,131,17,134,17,135,97,134,17,133,97,134,17,135,129,254,0,0,0,255,0,0,0,43,3,1,0,4,1,2,80,38,16,3,32,72,7,4,112,5,16,72,151,72,7,6,144,15,16,7,16,8,16,72,103,72,7,9,96,72,7,10,128,13,0,11,64,12,0,73,55,72,7,73,167,72,7,14,160,72,7,73,183,30,0,16,16,20,16,17,96,72,7,18,128,72,7,19,160,72,7,73,183,27,0,21,96,72,7,22,128,25,0,23,64,24,0,73,55,72,7,73,167,72,7,26,160,72,7,73,183,72,7,28,128,72,7,29,160,72,7,73,183,31,16,72,103,72,7,32,96,72,7,33,128,36,0,34,64,35,0,73,55,72,7,73,167,72,7,37,160,72,7,73,183,225,0,39,32,89,16,40,112,53,16,41,144,42,16,72,23,72,7,43,16,46,0,44,96,72,7,45,48,72,7,73,71,50,16,47,96,72,7,48,48,72,7,49,64,72,7,73,183,72,7,51,48,72,7,52,64,72,7,73,183,77,0,54,144,55,16,72,23,72,7,56,16,63,16,57,96,72,7,58,176,61,0,59,48,60,0,73,71,72,7,73,167,72,7,62,128,72,7,73,167,71,0,64,96,68,0,65,48,66,0,73,71,72,7,67,160,72,7,73,183,72,7,69,128,72,7,70,160,72,7,73,183,72,7,72,176,75,0,73,48,74,0,73,71,72,7,73,167,72,7,76,128,72,7,73,167,78,16,72,23,72,7,79,16,82,0,80,96,72,7,81,48,72,7,73,71,86,16,83,96,72,7,84,48,72,7,85,64,72,7,73,183,72,7,87,48,72,7,88,64,72,7,73,183,125,16,90,144,113,0,91,112,97,16,92,16,93,16,72,103,72,7,94,96,72,7,95,48,72,7,96,64,72,7,73,135,108,0,98,16,101,0,99,96,72,7,100,48,72,7,73,71,105,16,102,96,72,7,103,48,72,7,104,64,72,7,73,183,72,7,106,48,72,7,107,64,72,7,73,183,109,16,72,103,72,7,110,96,72,7,111,48,72,7,112,64,72,7,73,135,114,16,72,23,72,7,115,16,118,0,116,96,72,7,117,48,72,7,73,71,122,16,119,96,72,7,120,48,72,7,121,64,72,7,73,183,72,7,123,48,72,7,124,64,72,7,73,183,189,0,126,112,167,0,127,144,136,16,128,16,129,16,72,103,72,7,130,96,72,7,131,128,134,0,132,64,133,0,73,55,72,7,73,167,72,7,135,160,72,7,73,183,159,0,137,16,144,16,138,96,72,7,139,176,142,0,140,48,141,0,73,71,72,7,73,167,72,7,143,128,72,7,73,167,153,0,145,96,149,0,146,48,147,0,73,71,72,7,148,160,72,7,73,183,72,7,150,128,72,7,151,160,152,0,73,71,72,7,73,183,72,7,154,176,157,0,155,48,156,0,73,71,72,7,73,167,72,7,158,128,72,7,73,167,160,16,72,103,72,7,161,96,72,7,162,128,165,0,163,64,164,0,73,55,72,7,73,167,72,7,166,160,72,7,73,183,173,16,168,16,169,16,72,103,72,7,170,96,72,7,171,48,72,7,172,64,72,7,73,135,184,0,174,16,177,0,175,96,72,7,176,48,72,7,73,71,181,16,178,96,72,7,179,48,72,7,180,64,72,7,73,183,72,7,182,48,72,7,183,64,72,7,73,183,185,16,72,103,72,7,186,96,72,7,187,48,72,7,188,64,72,7,73,135,213,0,190,144,191,16,72,23,72,7,192,16,199,16,193,96,72,7,194,176,197,0,195,48,196,0,73,71,72,7,73,167,72,7,198,128,72,7,73,167,207,0,200,96,204,0,201,48,202,0,73,71,72,7,203,160,72,7,73,183,72,7,205,128,72,7,206,160,72,7,73,183,72,7,208,176,211,0,209,48,210,0,73,71,72,7,73,167,72,7,212,128,72,7,73,167,214,16,72,23,72,7,215,16,218,0,216,96,72,7,217,48,72,7,73,71,222,16,219,96,72,7,220,48,72,7,221,64,72,7,73,183,72,7,223,48,72,7,224,64,72,7,73,183,72,7,226,112,227,16,72,151,72,7,228,144,237,16,229,16,230,16,72,103,72,7,231,96,72,7,232,128,235,0,233,64,234,0,73,55,72,7,73,167,72,7,236,160,72,7,73,183,252,0,238,16,242,16,239,96,72,7,240,128,72,7,241,160,72,7,73,183,249,0,243,96,72,7,244,128,247,0,245,64,246,0,73,55,72,7,73,167,72,7,248,160,72,7,73,183,72,7,250,128,72,7,251,160,72,7,73,183,253,16,72,103,72,7,254,96,72,7,255,128,2,1,0,65,1,1,73,55,72,7,73,167,72,7,3,161,72,7,73,183,83,18,5,81,140,17,6,145,25,1,7,113,8,17,72,39,72,7,9,33,10,17,72,23,72,7,11,17,16,1,12,97,72,7,13,49,72,7,14,65,72,7,15,161,72,7,73,183,21,17,17,97,72,7,18,49,72,7,19,65,72,7,20,161,72,7,73,183,72,7,22,49,72,7,23,65,72,7,24,161,72,7,73,183,122,17,26,113,54,17,27,33,36,1,28,17,29,1,72,103,72,23,30,97,72,23,31,129,34,17,32,65,33,17,73,55,72,23,73,167,72,23,35,161,72,23,73,183,46,17,37,17,38,1,72,103,72,23,39,97,43,17,40,65,41,17,73,55,72,23,42,129,72,23,73,167,72,23,44,129,72,23,45,161,72,23,73,183,47,1,72,103,72,23,48,97,72,23,49,129,52,17,50,65,51,17,73,55,72,23,73,167,72,23,53,161,72,23,73,183,96,1,55,33,64,17,56,17,57,1,72,103,72,23,58,97,72,23,59,129,62,17,60,65,61,17,73,55,72,23,73,167,72,23,63,161,72,23,73,183,88,1,65,17,70,1,66,97,72,7,67,49,72,7,68,65,72,7,69,161,72,7,73,183,84,17,71,97,78,1,72,65,75,1,73,161,72,7,74,49,72,7,73,183,72,23,76,129,72,23,77,177,72,23,73,167,72,23,79,129,82,17,80,161,81,17,73,71,72,23,73,183,72,23,83,49,72,23,73,71,72,7,85,49,72,7,86,65,72,7,87,161,72,7,73,183,89,1,72,103,72,23,90,97,72,23,91,129,94,17,92,65,93,17,73,55,72,23,73,167,72,23,95,161,72,23,73,183,105,1,97,17,98,1,72,103,72,23,99,97,72,23,100,129,103,17,101,65,102,17,73,55,72,23,73,167,72,23,104,161,72,23,73,183,114,17,106,17,107,1,72,103,72,23,108,97,72,23,109,129,112,17,110,65,111,17,73,55,72,23,73,167,72,23,113,161,72,23,73,183,115,1,72,103,72,23,116,97,72,23,117,129,120,17,118,65,119,17,73,55,72,23,73,167,72,23,121,161,72,23,73,183,123,17,72,39,72,7,124,33,125,17,72,23,72,7,126,17,131,1,127,97,72,7,128,49,72,7,129,65,72,7,130,161,72,7,73,183,136,17,132,97,72,7,133,49,72,7,134,65,72,7,135,161,72,7,73,183,72,7,137,49,72,7,138,65,72,7,139,161,72,7,73,183,13,2,141,145,176,17,142,113,159,1,143,33,144,17,72,23,72,7,145,17,150,1,146,97,72,7,147,161,72,7,148,177,149,1,73,55,72,7,73,135,155,17,151,97,72,7,152,161,72,7,153,177,154,1,73,55,72,7,73,135,72,7,156,161,72,7,157,177,158,1,73,55,72,7,73,135,72,23,160,33,165,17,161,17,162,1,72,103,72,23,163,97,72,23,164,49,72,23,73,71,171,1,166,17,167,1,72,103,72,23,168,97,72,23,169,49,72,23,170,65,72,23,73,135,172,1,72,103,72,23,173,97,72,23,174,49,72,23,175,65,72,23,73,135,251,1,177,113,201,17,178,33,184,17,179,17,180,17,72,103,72,7,181,97,72,7,182,129,72,7,183,161,72,7,73,183,196,1,185,17,189,1,186,97,72,7,187,129,72,7,188,161,72,7,73,183,193,17,190,97,72,7,191,129,72,7,192,161,72,7,73,183,72,7,194,129,72,7,195,161,72,7,73,183,197,17,72,103,72,7,198,97,72,7,199,129,72,7,200,161,72,7,73,183,228,1,202,33,208,17,203,17,204,17,72,103,72,7,205,97,72,7,206,129,72,7,207,161,72,7,73,183,223,1,209,17,214,1,210,97,72,7,211,161,72,7,212,177,213,1,73,55,72,7,73,135,219,17,215,97,72,7,216,161,72,7,217,177,218,1,73,55,72,7,73,135,72,7,220,161,72,7,221,177,222,1,73,55,72,7,73,135,224,17,72,103,72,7,225,97,72,7,226,129,72,7,227,161,72,7,73,183,234,17,229,17,230,17,72,103,72,7,231,97,72,7,232,129,72,7,233,161,72,7,73,183,246,1,235,17,239,1,236,97,72,7,237,129,72,7,238,161,72,7,73,183,243,17,240,97,72,7,241,129,72,7,242,161,72,7,73,183,72,7,244,129,72,7,245,161,72,7,73,183,247,17,72,103,72,7,248,97,72,7,249,129,72,7,250,161,72,7,73,183,252,17,72,39,72,7,253,33,254,17,72,23,72,7,255,17,4,2,0,98,72,7,1,162,72,7,2,178,3,2,73,55,72,7,73,135,9,18,5,98,72,7,6,162,72,7,7,178,8,2,73,55,72,7,73,135,72,7,10,162,72,7,11,178,12,2,73,55,72,7,73,135,32,18,14,34,15,2,72,119,72,23,16,114,21,18,17,18,18,2,72,103,72,23,19,98,72,23,20,50,72,23,73,71,27,2,22,18,23,2,72,103,72,23,24,98,72,23,25,50,72,23,26,66,72,23,73,135,28,2,72,103,72,23,29,98,72,23,30,50,72,23,31,66,72,23,73,135,72,7,33,34,50,2,34,114,35,18,72,23,72,7,36,18,41,2,37,98,72,7,38,50,72,7,39,66,72,7,40,162,72,7,73,183,46,18,42,98,72,7,43,50,72,7,44,66,72,7,45,162,72,7,73,183,72,7,47,50,72,7,48,66,72,7,49,162,72,7,73,183,67,18,51,114,52,18,72,23,72,7,53,18,58,2,54,98,72,7,55,50,72,7,56,66,72,7,57,162,72,7,73,183,63,18,59,98,72,7,60,50,72,7,61,66,72,7,62,162,72,7,73,183,72,7,64,50,72,7,65,66,72,7,66,162,72,7,73,183,68,18,72,23,72,7,69,18,74,2,70,98,72,7,71,50,72,7,72,66,72,7,73,162,72,7,73,183,79,18,75,98,72,7,76,50,72,7,77,66,72,7,78,162,72,7,73,183,72,7,80,50,72,7,81,66,72,7,82,162,72,7,73,183,110,18,84,34,72,7,85,114,86,18,72,151,72,7,87,146,93,18,88,18,89,18,72,103,72,7,90,98,72,7,91,130,72,7,92,162,72,7,73,183,105,2,94,18,98,2,95,98,72,7,96,130,72,7,97,162,72,7,73,183,102,18,99,98,72,7,100,130,72,7,101,162,72,7,73,183,72,7,103,130,72,7,104,162,72,7,73,183,106,18,72,103,72,7,107,98,72,7,108,130,72,7,109,162,72,7,73,183,17,3,111,34,162,18,112,114,129,18,113,146,114,18,72,23,72,7,115,18,120,2,116,98,72,7,117,50,72,7,118,66,72,7,119,162,72,7,73,183,125,18,121,98,72,7,122,50,72,7,123,66,72,7,124,162,72,7,73,183,72,7,126,50,72,7,127,66,72,7,128,162,72,7,73,183,146,2,130,146,131,18,72,23,72,7,132,18,137,2,133,98,72,7,134,162,72,7,135,178,136,2,73,55,72,7,73,135,142,18,138,98,72,7,139,162,72,7,140,178,141,2,73,55,72,7,73,135,72,7,143,162,72,7,144,178,145,2,73,55,72,7,73,135,147,18,72,23,72,7,148,18,153,2,149,98,72,7,150,50,72,7,151,66,72,7,152,162,72,7,73,183,158,18,154,98,72,7,155,50,72,7,156,66,72,7,157,162,72,7,73,183,72,7,159,50,72,7,160,66,72,7,161,162,72,7,73,183,196,18,163,146,180,2,164,114,165,18,72,23,72,7,166,18,171,2,167,98,72,7,168,50,72,7,169,66,72,7,170,162,72,7,73,183,176,18,172,98,72,7,173,50,72,7,174,66,72,7,175,162,72,7,73,183,72,7,177,50,72,7,178,66,72,7,179,162,72,7,73,183,181,18,72,23,72,7,182,18,187,2,183,98,72,7,184,50,72,7,185,66,72,7,186,162,72,7,73,183,192,18,188,98,72,7,189,50,72,7,190,66,72,7,191,162,72,7,73,183,72,7,193,50,72,7,194,66,72,7,195,162,72,7,73,183,240,2,197,114,224,2,198,146,204,18,199,18,200,18,72,103,72,7,201,98,72,7,202,130,72,7,203,162,72,7,73,183,219,2,205,18,210,2,206,98,72,7,207,162,72,7,208,178,209,2,73,55,72,7,73,135,215,18,211,98,72,7,212,162,72,7,213,178,214,2,73,55,72,7,73,135,72,7,216,162,72,7,217,178,218,2,73,55,72,7,73,135,220,18,72,103,72,7,221,98,72,7,222,130,72,7,223,162,72,7,73,183,225,18,72,23,72,7,226,18,231,2,227,98,72,7,228,50,72,7,229,66,72,7,230,162,72,7,73,183,236,18,232,98,72,7,233,50,72,7,234,66,72,7,235,162,72,7,73,183,72,7,237,50,72,7,238,66,72,7,239,162,72,7,73,183,1,3,241,146,242,18,72,23,72,7,243,18,248,2,244,98,72,7,245,162,72,7,246,178,247,2,73,55,72,7,73,135,253,18,249,98,72,7,250,162,72,7,251,178,252,2,73,55,72,7,73,135,72,7,254,162,72,7,255,178,0,3,73,55,72,7,73,135,2,19,72,23,72,7,3,19,8,3,4,99,72,7,5,51,72,7,6,67,72,7,7,163,72,7,73,183,13,19,9,99,72,7,10,51,72,7,11,67,72,7,12,163,72,7,73,183,72,7,14,51,72,7,15,67,72,7,16,163,72,7,73,183,72,7,18,115,19,19,72,151,72,7,20,147,26,19,21,19,22,19,72,103,72,7,23,99,72,7,24,131,72,7,25,163,72,7,73,183,38,3,27,19,31,3,28,99,72,7,29,131,72,7,30,163,72,7,73,183,35,19,32,99,72,7,33,131,72,7,34,163,72,7,73,183,72,7,36,131,72,7,37,163,72,7,73,183,39,19,72,103,72,7,40,99,72,7,41,131,72,7,42,163,72,7,73,183,85,22,44,3,49,20,45,83,96,3,46,147,47,3,72,39,72,23,48,35,61,3,49,115,50,3,72,23,72,23,51,19,54,19,52,99,72,23,53,51,72,23,73,71,58,3,55,99,72,23,56,51,72,23,57,67,72,23,73,183,72,23,59,51,72,23,60,67,72,23,73,183,84,19,62,115,68,3,63,19,64,3,72,103,72,23,65,99,72,23,66,51,72,23,67,67,72,23,73,135,79,19,69,19,72,19,70,99,72,23,71,51,72,23,73,71,76,3,73,99,72,23,74,51,72,23,75,67,72,23,73,183,72,23,77,51,72,23,78,67,72,23,73,183,80,3,72,103,72,23,81,99,72,23,82,51,72,23,83,67,72,23,73,135,85,3,72,23,72,23,86,19,89,19,87,99,72,23,88,51,72,23,73,71,93,3,90,99,72,23,91,51,72,23,92,67,72,23,73,183,72,23,94,51,72,23,95,67,72,23,73,183,255,19,97,147,123,3,98,115,99,3,72,39,72,23,100,35,101,3,72,23,72,23,102,19,109,3,103,99,72,23,104,179,107,19,105,51,106,19,73,71,72,23,73,167,72,23,108,131,72,23,73,167,117,19,110,99,114,19,111,51,112,19,73,71,72,23,113,163,72,23,73,183,72,23,115,131,72,23,116,163,72,23,73,183,72,23,118,179,121,19,119,51,120,19,73,71,72,23,73,167,72,23,122,131,72,23,73,167,230,19,124,115,157,3,125,35,134,3,126,19,127,3,72,103,72,23,128,99,72,23,129,131,132,19,130,67,131,19,73,55,72,23,73,167,72,23,133,163,72,23,73,183,149,19,135,19,139,3,136,99,72,23,137,131,72,23,138,163,72,23,73,183,146,19,140,99,72,23,141,131,144,19,142,67,143,19,73,55,72,23,73,167,72,23,145,163,72,23,73,183,72,23,147,131,72,23,148,163,72,23,73,183,150,3,72,103,72,23,151,99,72,23,152,131,155,19,153,67,154,19,73,55,72,23,73,167,72,23,156,163,72,23,73,183,198,19,158,35,167,3,159,19,160,3,72,103,72,23,161,99,72,23,162,131,165,19,163,67,164,19,73,55,72,23,73,167,72,23,166,163,72,23,73,183,190,19,168,19,175,3,169,99,72,23,170,179,173,19,171,51,172,19,73,71,72,23,73,167,72,23,174,131,72,23,73,167,184,19,176,99,180,19,177,51,178,19,73,71,72,23,179,163,72,23,73,183,72,23,181,131,72,23,182,163,183,19,73,71,72,23,73,183,72,23,185,179,188,19,186,51,187,19,73,71,72,23,73,167,72,23,189,131,72,23,73,167,191,3,72,103,72,23,192,99,72,23,193,131,196,19,194,67,195,19,73,55,72,23,73,167,72,23,197,163,72,23,73,183,207,3,199,19,200,3,72,103,72,23,201,99,72,23,202,131,205,19,203,67,204,19,73,55,72,23,73,167,72,23,206,163,72,23,73,183,222,19,208,19,212,3,209,99,72,23,210,131,72,23,211,163,72,23,73,183,219,19,213,99,72,23,214,131,217,19,215,67,216,19,73,55,72,23,73,167,72,23,218,163,72,23,73,183,72,23,220,131,72,23,221,163,72,23,73,183,223,3,72,103,72,23,224,99,72,23,225,131,228,19,226,67,227,19,73,55,72,23,73,167,72,23,229,163,72,23,73,183,231,3,72,39,72,23,232,35,233,3,72,23,72,23,234,19,241,3,235,99,72,23,236,179,239,19,237,51,238,19,73,71,72,23,73,167,72,23,240,131,72,23,73,167,249,19,242,99,246,19,243,51,244,19,73,71,72,23,245,163,72,23,73,183,72,23,247,131,72,23,248,163,72,23,73,183,72,23,250,179,253,19,251,51,252,19,73,71,72,23,73,167,72,23,254,131,72,23,73,167,0,4,72,39,72,23,1,36,14,4,2,116,3,4,72,23,72,23,4,20,7,20,5,100,72,23,6,52,72,23,73,71,11,4,8,100,72,23,9,52,72,23,10,68,72,23,73,183,72,23,12,52,72,23,13,68,72,23,73,183,37,20,15,116,21,4,16,20,17,4,72,103,72,23,18,100,72,23,19,52,72,23,20,68,72,23,73,135,32,20,22,20,25,20,23,100,72,23,24,52,72,23,73,71,29,4,26,100,72,23,27,52,72,23,28,68,72,23,73,183,72,23,30,52,72,23,31,68,72,23,73,183,33,4,72,103,72,23,34,100,72,23,35,52,72,23,36,68,72,23,73,135,38,4,72,23,72,23,39,20,42,20,40,100,72,23,41,52,72,23,73,71,46,4,43,100,72,23,44,52,72,23,45,68,72,23,73,183,72,23,47,52,72,23,48,68,72,23,73,183,125,5,50,84,139,4,51,36,77,20,52,116,53,4,72,151,72,23,54,148,60,4,55,20,56,4,72,103,72,23,57,100,72,23,58,132,72,23,59,164,72,23,73,183,72,20,61,20,65,4,62,100,72,23,63,132,72,23,64,164,72,23,73,183,69,20,66,100,72,23,67,132,72,23,68,164,72,23,73,183,72,23,70,132,72,23,71,164,72,23,73,183,73,4,72,103,72,23,74,100,72,23,75,132,72,23,76,164,72,23,73,183,72,7,78,116,95,20,79,148,84,4,80,20,81,20,72,103,72,7,82,100,72,7,83,52,72,7,73,71,90,20,85,20,86,20,72,103,72,7,87,100,72,7,88,52,72,7,89,68,72,7,73,135,91,20,72,103,72,7,92,100,72,7,93,52,72,7,94,68,72,7,73,135,123,4,96,148,105,20,97,20,98,20,72,103,72,7,99,100,72,7,100,132,103,4,101,68,102,4,73,55,72,7,73,167,72,7,104,164,72,7,73,183,115,4,106,20,107,20,72,103,72,7,108,100,112,4,109,68,110,4,73,55,72,7,111,132,72,7,73,167,72,7,113,132,72,7,114,164,72,7,73,183,116,20,72,103,72,7,117,100,72,7,118,132,121,4,119,68,120,4,73,55,72,7,73,167,72,7,122,164,72,7,73,183,128,4,124,20,125,20,72,103,72,7,126,100,72,7,127,52,72,7,73,71,134,20,129,20,130,20,72,103,72,7,131,100,72,7,132,52,72,7,133,68,72,7,73,135,135,20,72,103,72,7,136,100,72,7,137,52,72,7,138,68,72,7,73,135,71,21,140,36,201,20,141,116,158,4,142,148,143,4,72,23,72,23,144,20,149,4,145,100,72,23,146,52,72,23,147,68,72,23,148,164,72,23,73,183,154,20,150,100,72,23,151,52,72,23,152,68,72,23,153,164,72,23,73,183,72,23,155,52,72,23,156,68,72,23,157,164,72,23,73,183,185,20,159,148,165,4,160,20,161,4,72,103,72,23,162,100,72,23,163,132,72,23,164,164,72,23,73,183,180,20,166,20,171,4,167,100,72,23,168,164,72,23,169,180,170,20,73,55,72,23,73,135,176,20,172,100,72,23,173,164,72,23,174,180,175,20,73,55,72,23,73,135,72,23,177,164,72,23,178,180,179,20,73,55,72,23,73,135,181,4,72,103,72,23,182,100,72,23,183,132,72,23,184,164,72,23,73,183,186,4,72,23,72,23,187,20,192,4,188,100,72,23,189,52,72,23,190,68,72,23,191,164,72,23,73,183,197,20,193,100,72,23,194,52,72,23,195,68,72,23,196,164,72,23,73,183,72,23,198,52,72,23,199,68,72,23,200,164,72,23,73,183,21,5,202,116,219,20,203,148,204,4,72,23,72,23,205,20,210,4,206,100,72,23,207,164,72,23,208,180,209,20,73,55,72,23,73,135,215,20,211,100,72,23,212,164,72,23,213,180,214,20,73,55,72,23,73,135,72,23,216,164,72,23,217,180,218,20,73,55,72,23,73,135,5,5,220,148,229,4,221,20,222,20,72,103,72,7,223,100,72,7,224,132,227,4,225,68,226,4,73,55,72,7,73,167,72,7,228,164,72,7,73,183,253,20,230,20,235,20,231,100,72,23,232,52,72,23,233,68,72,23,234,164,72,23,73,183,249,4,236,100,243,20,237,68,240,4,238,164,72,7,239,132,72,7,73,183,72,23,241,52,72,23,242,180,72,23,73,167,72,7,244,132,247,4,245,164,246,4,73,71,72,7,73,183,72,7,248,52,72,7,73,71,72,23,250,52,72,23,251,68,72,23,252,164,72,23,73,183,254,20,72,103,72,7,255,100,72,7,0,133,3,5,1,69,2,5,73,55,72,7,73,167,72,7,4,165,72,7,73,183,6,5,72,23,72,23,7,21,12,5,8,101,72,23,9,53,72,23,10,69,72,23,11,165,72,23,73,183,17,21,13,101,72,23,14,53,72,23,15,69,72,23,16,165,72,23,73,183,72,23,18,53,72,23,19,69,72,23,20,165,72,23,73,183,38,5,22,149,23,5,72,23,72,23,24,21,29,5,25,101,72,23,26,53,72,23,27,69,72,23,28,165,72,23,73,183,34,21,30,101,72,23,31,53,72,23,32,69,72,23,33,165,72,23,73,183,72,23,35,53,72,23,36,69,72,23,37,165,72,23,73,183,55,21,39,149,40,5,72,23,72,23,41,21,46,5,42,101,72,23,43,165,72,23,44,181,45,21,73,55,72,23,73,135,51,21,47,101,72,23,48,165,72,23,49,181,50,21,73,55,72,23,73,135,72,23,52,165,72,23,53,181,54,21,73,55,72,23,73,135,56,5,72,23,72,23,57,21,62,5,58,101,72,23,59,53,72,23,60,69,72,23,61,165,72,23,73,183,67,21,63,101,72,23,64,53,72,23,65,69,72,23,66,165,72,23,73,183,72,23,68,53,72,23,69,69,72,23,70,165,72,23,73,183,100,5,72,117,73,21,72,151,72,7,74,149,83,5,75,21,76,21,72,103,72,7,77,101,72,7,78,133,81,5,79,69,80,5,73,55,72,7,73,167,72,7,82,165,72,7,73,183,92,21,84,21,85,21,72,103,72,7,86,101,72,7,87,133,90,5,88,69,89,5,73,55,72,7,73,167,72,7,91,165,72,7,73,183,93,21,72,103,72,7,94,101,72,7,95,133,98,5,96,69,97,5,73,55,72,7,73,167,72,7,99,165,72,7,73,183,72,23,101,149,72,23,102,117,108,5,103,21,104,5,72,103,72,23,105,101,72,23,106,133,72,23,107,165,72,23,73,183,120,21,109,21,113,5,110,101,72,23,111,133,72,23,112,165,72,23,73,183,117,21,114,101,72,23,115,133,72,23,116,165,72,23,73,183,72,23,118,133,72,23,119,165,72,23,73,183,121,5,72,103,72,23,122,101,72,23,123,133,72,23,124,165,72,23,73,183,152,5,126,37,72,23,127,117,128,5,72,151,72,23,129,149,135,5,130,21,131,5,72,103,72,23,132,101,72,23,133,133,72,23,134,165,72,23,73,183,147,21,136,21,140,5,137,101,72,23,138,133,72,23,139,165,72,23,73,183,144,21,141,101,72,23,142,133,72,23,143,165,72,23,73,183,72,23,145,133,72,23,146,165,72,23,73,183,148,5,72,103,72,23,149,101,72,23,150,133,72,23,151,165,72,23,73,183,59,22,153,37,204,5,154,117,171,5,155,149,156,5,72,23,72,23,157,21,162,5,158,101,72,23,159,53,72,23,160,69,72,23,161,165,72,23,73,183,167,21,163,101,72,23,164,53,72,23,165,69,72,23,166,165,72,23,73,183,72,23,168,53,72,23,169,69,72,23,170,165,72,23,73,183,188,21,172,149,173,5,72,23,72,23,174,21,179,5,175,101,72,23,176,165,72,23,177,181,178,21,73,55,72,23,73,135,184,21,180,101,72,23,181,165,72,23,182,181,183,21,73,55,72,23,73,135,72,23,185,165,72,23,186,181,187,21,73,55,72,23,73,135,189,5,72,23,72,23,190,21,195,5,191,101,72,23,192,53,72,23,193,69,72,23,194,165,72,23,73,183,200,21,196,101,72,23,197,53,72,23,198,69,72,23,199,165,72,23,73,183,72,23,201,53,72,23,202,69,72,23,203,165,72,23,73,183,238,5,205,149,222,21,206,117,207,5,72,23,72,23,208,21,213,5,209,101,72,23,210,53,72,23,211,69,72,23,212,165,72,23,73,183,218,21,214,101,72,23,215,53,72,23,216,69,72,23,217,165,72,23,73,183,72,23,219,53,72,23,220,69,72,23,221,165,72,23,73,183,223,5,72,23,72,23,224,21,229,5,225,101,72,23,226,53,72,23,227,69,72,23,228,165,72,23,73,183,234,21,230,101,72,23,231,53,72,23,232,69,72,23,233,165,72,23,73,183,72,23,235,53,72,23,236,69,72,23,237,165,72,23,73,183,26,22,239,117,10,22,240,149,246,5,241,21,242,5,72,103,72,23,243,101,72,23,244,133,72,23,245,165,72,23,73,183,5,22,247,21,252,5,248,101,72,23,249,165,72,23,250,181,251,21,73,55,72,23,73,135,1,22,253,101,72,23,254,165,72,23,255,181,0,22,73,55,72,23,73,135,72,23,2,166,72,23,3,182,4,22,73,55,72,23,73,135,6,6,72,103,72,23,7,102,72,23,8,134,72,23,9,166,72,23,73,183,11,6,72,23,72,23,12,22,17,6,13,102,72,23,14,54,72,23,15,70,72,23,16,166,72,23,73,183,22,22,18,102,72,23,19,54,72,23,20,70,72,23,21,166,72,23,73,183,72,23,23,54,72,23,24,70,72,23,25,166,72,23,73,183,43,22,27,150,28,6,72,23,72,23,29,22,34,6,30,102,72,23,31,166,72,23,32,182,33,22,73,55,72,23,73,135,39,22,35,102,72,23,36,166,72,23,37,182,38,22,73,55,72,23,73,135,72,23,40,166,72,23,41,182,42,22,73,55,72,23,73,135,44,6,72,23,72,23,45,22,50,6,46,102,72,23,47,54,72,23,48,70,72,23,49,166,72,23,73,183,55,22,51,102,72,23,52,54,72,23,53,70,72,23,54,166,72,23,73,183,72,23,56,54,72,23,57,70,72,23,58,166,72,23,73,183,72,23,60,118,61,6,72,151,72,23,62,150,68,6,63,22,64,6,72,103,72,23,65,102,72,23,66,134,72,23,67,166,72,23,73,183,80,22,69,22,73,6,70,102,72,23,71,134,72,23,72,166,72,23,73,183,77,22,74,102,72,23,75,134,72,23,76,166,72,23,73,183,72,23,78,134,72,23,79,166,72,23,73,183,81,6,72,103,72,23,82,102,72,23,83,134,72,23,84,166,72,23,73,183,207,22,86,86,87,6,72,119,72,23,88,118,117,6,89,38,90,6,72,151,72,23,91,150,100,6,92,22,93,6,72,103,72,23,94,102,72,23,95,134,98,22,96,70,97,22,73,55,72,23,73,167,72,23,99,166,72,23,73,183,109,22,101,22,102,6,72,103,72,23,103,102,72,23,104,134,107,22,105,70,106,22,73,55,72,23,73,167,72,23,108,166,72,23,73,183,110,6,72,103,72,23,111,102,72,23,112,134,115,22,113,70,114,22,73,55,72,23,73,167,72,23,116,166,72,23,73,183,179,22,118,38,135,6,119,150,124,22,120,22,121,6,72,103,72,23,122,102,72,23,123,54,72,23,73,71,130,6,125,22,126,6,72,103,72,23,127,102,72,23,128,54,72,23,129,70,72,23,73,135,131,6,72,103,72,23,132,102,72,23,133,54,72,23,134,70,72,23,73,135,163,22,136,150,145,6,137,22,138,6,72,103,72,23,139,102,72,23,140,134,143,22,141,70,142,22,73,55,72,23,73,167,72,23,144,166,72,23,73,183,155,22,146,22,147,6,72,103,72,23,148,102,152,22,149,70,150,22,73,55,72,23,151,134,72,23,73,167,72,23,153,134,72,23,154,166,72,23,73,183,156,6,72,103,72,23,157,102,72,23,158,134,161,22,159,70,160,22,73,55,72,23,73,167,72,23,162,166,72,23,73,183,168,22,164,22,165,6,72,103,72,23,166,102,72,23,167,54,72,23,73,71,174,6,169,22,170,6,72,103,72,23,171,102,72,23,172,54,72,23,173,70,72,23,73,135,175,6,72,103,72,23,176,102,72,23,177,54,72,23,178,70,72,23,73,135,180,6,72,151,72,23,181,150,190,6,182,22,183,6,72,103,72,23,184,102,72,23,185,134,188,22,186,70,187,22,73,55,72,23,73,167,72,23,189,166,72,23,73,183,199,22,191,22,192,6,72,103,72,23,193,102,72,23,194,134,197,22,195,70,196,22,73,55,72,23,73,167,72,23,198,166,72,23,73,183,200,6,72,103,72,23,201,102,72,23,202,134,205,22,203,70,204,22,73,55,72,23,73,167,72,23,206,166,72,23,73,183,72,7,208,86,72,7,209,118,238,22,210,38,211,22,72,151,72,7,212,150,221,6,213,22,214,22,72,103,72,7,215,102,72,7,216,134,219,6,217,70,218,6,73,55,72,7,73,167,72,7,220,166,72,7,73,183,230,22,222,22,223,22,72,103,72,7,224,102,72,7,225,134,228,6,226,70,227,6,73,55,72,7,73,167,72,7,229,166,72,7,73,183,231,22,72,103,72,7,232,102,72,7,233,134,236,6,234,70,235,6,73,55,72,7,73,167,72,7,237,166,72,7,73,183,44,7,239,38,0,23,240,150,245,6,241,22,242,22,72,103,72,7,243,102,72,7,244,54,72,7,73,71,251,22,246,22,247,22,72,103,72,7,248,102,72,7,249,54,72,7,250,70,72,7,73,135,252,22,72,103,72,7,253,102,72,7,254,54,72,7,255,70,72,7,73,135,28,7,1,151,10,23,2,23,3,23,72,103,72,7,4,103,72,7,5,135,8,7,6,71,7,7,73,55,72,7,73,167,72,7,9,167,72,7,73,183,20,7,11,23,12,23,72,103,72,7,13,103,17,7,14,71,15,7,73,55,72,7,16,135,72,7,73,167,72,7,18,135,72,7,19,167,72,7,73,183,21,23,72,103,72,7,22,103,72,7,23,135,26,7,24,71,25,7,73,55,72,7,73,167,72,7,27,167,72,7,73,183,33,7,29,23,30,23,72,103,72,7,31,103,72,7,32,55,72,7,73,71,39,23,34,23,35,23,72,103,72,7,36,103,72,7,37,55,72,7,38,71,72,7,73,135,40,23,72,103,72,7,41,103,72,7,42,55,72,7,43,71,72,7,73,135,45,23,72,151,72,7,46,151,55,7,47,23,48,23,72,103,72,7,49,103,72,7,50,135,53,7,51,71,52,7,73,55,72,7,73,167,72,7,54,167,72,7,73,183,64,23,56,23,57,23,72,103,72,7,58,103,72,7,59,135,62,7,60,71,61,7,73,55,72,7,73,167,72,7,63,167,72,7,73,183,65,23,72,103,72,7,66,103,72,7,67,135,70,7,68,71,69,7,73,55,72,7,73,167,72,7,71,167,72,7,73,183,254,0,0,0,255,0,0,0,56,1,1,0,211,0,2,32,138,0,3,64,81,0,4,80,39,0,5,112,22,0,6,48,13,0,7,16,10,0,8,96,9,0,173,130,172,2,173,242,172,2,11,208,172,2,12,224,172,2,173,242,172,2,14,128,172,2,15,144,172,2,16,160,17,0,173,98,172,2,18,176,172,2,19,192,172,2,20,208,172,2,21,224,172,2,173,242,172,2,23,160,172,2,24,176,172,2,25,192,35,0,26,128,31,0,27,144,28,0,173,98,172,2,29,208,172,2,30,224,172,2,173,242,172,2,32,16,172,2,33,208,172,2,34,224,172,2,173,242,172,2,36,16,172,2,37,208,172,2,38,224,172,2,173,242,65,16,40,112,56,0,41,224,172,2,42,240,50,0,43,16,46,0,44,48],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+112640);allocate([45,0,173,98,172,2,173,210,172,2,47,160,172,2,48,176,172,2,49,192,172,2,173,210,172,2,51,128,172,2,52,144,172,2,53,160,172,2,54,176,172,2,55,192,172,2,173,210,172,18,57,224,172,18,58,128,172,18,59,144,172,18,60,160,172,18,61,176,172,18,62,192,172,18,63,208,64,16,173,98,172,18,173,242,172,2,66,224,172,2,67,240,75,0,68,16,71,0,69,48,70,0,173,98,172,2,173,210,172,2,72,160,172,2,73,176,172,2,74,192,172,2,173,210,172,2,76,128,172,2,77,144,172,2,78,160,172,2,79,176,172,2,80,192,172,2,173,210,110,16,82,80,100,0,83,192,172,2,84,208,172,2,85,224,94,0,86,240,90,0,87,16,88,0,173,50,172,2,89,160,172,2,173,178,172,2,91,128,172,2,92,144,172,2,93,160,172,2,173,178,172,2,95,96,172,2,96,112,172,2,97,128,172,2,98,144,172,2,99,160,172,2,173,178,172,18,101,192,172,18,102,112,172,18,103,128,172,18,104,144,172,18,105,160,172,18,106,176,172,18,107,208,108,16,173,98,172,18,109,224,172,18,173,242,128,0,111,192,172,2,112,208,172,2,113,224,122,0,114,240,118,0,115,16,116,0,173,50,172,2,117,160,172,2,173,178,172,2,119,128,172,2,120,144,172,2,121,160,172,2,173,178,172,2,123,96,172,2,124,112,172,2,125,128,172,2,126,144,172,2,127,160,172,2,173,178,172,18,129,192,172,18,130,112,172,18,131,128,172,18,132,144,172,18,133,160,172,18,134,176,172,18,135,208,172,18,136,224,137,16,173,98,172,18,173,242,177,16,139,64,161,0,140,176,172,2,141,192,172,2,142,208,157,0,143,160,152,0,144,224,148,0,145,240,146,0,173,18,172,2,147,128,172,2,173,146,172,2,149,96,172,2,150,112,172,2,151,128,172,2,173,146,172,2,153,80,172,2,154,96,172,2,155,112,172,2,156,128,172,2,173,146,172,2,158,16,172,2,159,48,172,2,160,224,172,2,173,242,172,18,162,176,172,18,163,112,172,18,164,128,172,18,165,144,172,18,166,160,173,16,167,96,170,16,168,80,169,16,173,50,172,18,173,194,172,18,171,192,172,18,172,208,172,18,173,226,172,18,174,192,172,18,175,208,172,18,176,224,172,18,173,242,199,0,178,176,172,2,179,192,172,2,180,208,195,0,181,160,190,0,182,224,186,0,183,240,184,0,173,18,172,2,185,128,172,2,173,146,172,2,187,96,172,2,188,112,172,2,189,128,172,2,173,146,172,2,191,80,172,2,192,96,172,2,193,112,172,2,194,128,172,2,173,146,172,2,196,16,172,2,197,48,172,2,198,224,172,2,173,242,172,18,200,176,172,18,201,112,172,18,202,128,172,18,203,144,172,18,204,160,172,18,205,192,172,18,206,208,209,16,207,96,208,16,173,82,172,18,173,226,172,18,210,224,172,18,173,242,10,17,212,32,239,0,213,144,172,2,214,160,172,2,215,176,234,0,216,128,229,0,217,192,225,0,218,208,222,0,219,224,220,0,173,242,172,2,221,96,172,2,173,114,172,2,223,80,172,2,224,96,172,2,173,114,172,2,226,64,172,2,227,80,172,2,228,96,172,2,173,114,172,2,230,48,172,2,231,64,172,2,232,80,172,2,233,96,172,2,173,114,172,2,235,16,172,2,236,192,172,2,237,208,172,2,238,224,172,2,173,242,172,18,240,144,172,18,241,112,172,18,242,128,4,17,243,96,255,16,244,80,251,16,245,64,248,16,246,48,247,16,173,18,172,18,173,162,172,18,249,160,172,18,250,176,172,18,173,194,172,18,252,160,172,18,253,176,172,18,254,192,172,18,173,210,172,18,0,161,172,18,1,177,172,18,2,193,172,18,3,209,172,18,173,226,172,18,5,161,172,18,6,177,172,18,7,193,172,18,8,209,172,18,9,225,172,18,173,242,37,1,11,145,172,2,12,161,172,2,13,177,32,1,14,129,27,1,15,193,23,1,16,209,20,1,17,225,18,1,173,242,172,2,19,97,172,2,173,114,172,2,21,81,172,2,22,97,172,2,173,114,172,2,24,65,172,2,25,81,172,2,26,97,172,2,173,114,172,2,28,49,172,2,29,65,172,2,30,81,172,2,31,97,172,2,173,114,172,2,33,17,172,2,34,193,172,2,35,209,172,2,36,225,172,2,173,242,172,18,38,145,172,18,39,113,172,18,40,129,172,18,41,161,172,18,42,177,52,17,43,97,49,17,44,81,47,17,45,65,46,17,173,50,172,18,173,194,172,18,48,193,172,18,173,210,172,18,50,193,172,18,51,209,172,18,173,226,172,18,53,193,172,18,54,209,172,18,55,225,172,18,173,242,112,18,57,1,112,1,58,33,85,1,59,145,172,2,60,113,172,2,61,129,79,1,62,97,74,1,63,81,70,1,64,65,67,1,65,49,66,1,173,18,172,2,173,162,172,2,68,161,172,2,69,177,172,2,173,194,172,2,71,161,172,2,72,177,172,2,73,193,172,2,173,210,172,2,75,161,172,2,76,177,172,2,77,193,172,2,78,209,172,2,173,226,172,2,80,161,172,2,81,177,172,2,82,193,172,2,83,209,172,2,84,225,172,2,173,242,172,18,86,145,172,18,87,161,172,18,88,177,107,17,89,129,102,17,90,193,98,17,91,209,95,17,92,225,93,17,173,242,172,18,94,97,172,18,173,114,172,18,96,81,172,18,97,97,172,18,173,114,172,18,99,65,172,18,100,81,172,18,101,97,172,18,173,114,172,18,103,49,172,18,104,65,172,18,105,81,172,18,106,97,172,18,173,114,172,18,108,17,172,18,109,193,172,18,110,209,172,18,111,225,172,18,173,242,66,18,113,33,152,1,114,65,130,1,115,177,172,2,116,113,172,2,117,129,172,2,118,145,172,2,119,161,126,1,120,97,123,1,121,81,122,1,173,50,172,2,173,194,172,2,124,193,172,2,125,209,172,2,173,226,172,2,127,193,172,2,128,209,172,2,129,225,172,2,173,242,172,18,131,177,172,18,132,193,172,18,133,209,148,17,134,161,143,17,135,225,139,17,136,241,137,17,173,18,172,18,138,129,172,18,173,146,172,18,140,97,172,18,141,113,172,18,142,129,172,18,173,146,172,18,144,81,172,18,145,97,172,18,146,113,172,18,147,129,172,18,173,146,172,18,149,17,172,18,150,49,172,18,151,225,172,18,173,242,32,18,153,65,182,1,154,81,164,1,155,193,172,2,156,113,172,2,157,129,172,2,158,145,172,2,159,161,172,2,160,177,172,2,161,209,162,1,173,98,172,2,163,225,172,2,173,242,172,18,165,193,172,18,166,209,172,18,167,225,176,17,168,241,172,17,169,17,170,17,173,50,172,18,171,161,172,18,173,178,172,18,173,129,172,18,174,145,172,18,175,161,172,18,173,178,172,18,177,97,172,18,178,113,172,18,179,129,172,18,180,145,172,18,181,161,172,18,173,178,4,18,183,81,209,1,184,113,193,1,185,225,172,2,186,129,172,2,187,145,172,2,188,161,172,2,189,177,172,2,190,193,172,2,191,209,192,1,173,98,172,2,173,242,172,18,194,225,172,18,195,241,203,17,196,17,199,17,197,49,198,17,173,98,172,18,173,210,172,18,200,161,172,18,201,177,172,18,202,193,172,18,173,210,172,18,204,129,172,18,205,145,172,18,206,161,172,18,207,177,172,18,208,193,172,18,173,210,244,17,210,113,227,17,211,49,218,17,212,17,215,17,213,97,214,17,173,130,172,18,173,242,172,18,216,209,172,18,217,225,172,18,173,242,172,18,219,129,172,18,220,145,172,18,221,161,222,17,173,98,172,18,223,177,172,18,224,193,172,18,225,209,172,18,226,225,172,18,173,242,172,18,228,161,172,18,229,177,172,18,230,193,240,17,231,129,236,17,232,145,233,17,173,98,172,18,234,209,172,18,235,225,172,18,173,242,172,18,237,17,172,18,238,209,172,18,239,225,172,18,173,242,172,18,241,17,172,18,242,209,172,18,243,225,172,18,173,242,172,18,245,225,172,18,246,241,254,17,247,17,250,17,248,49,249,17,173,98,172,18,173,210,172,18,251,161,172,18,252,177,172,18,253,193,172,18,173,210,172,18,255,129,172,18,0,146,172,18,1,162,172,18,2,178,172,18,3,194,172,18,173,210,14,2,5,194,172,2,6,114,172,2,7,130,172,2,8,146,172,2,9,162,172,2,10,178,172,2,11,210,172,2,12,226,13,2,173,98,172,2,173,242,172,18,15,194,172,18,16,210,172,18,17,226,26,18,18,242,22,18,19,18,20,18,173,50,172,18,21,162,172,18,173,178,172,18,23,130,172,18,24,146,172,18,25,162,172,18,173,178,172,18,27,98,172,18,28,114,172,18,29,130,172,18,30,146,172,18,31,162,172,18,173,178,44,2,33,178,172,2,34,114,172,2,35,130,172,2,36,146,172,2,37,162,172,2,38,194,172,2,39,210,42,2,40,98,41,2,173,82,172,2,173,226,172,2,43,226,172,2,173,242,172,18,45,178,172,18,46,194,172,18,47,210,62,18,48,162,57,18,49,226,53,18,50,242,51,18,173,18,172,18,52,130,172,18,173,146,172,18,54,98,172,18,55,114,172,18,56,130,172,18,173,146,172,18,58,82,172,18,59,98,172,18,60,114,172,18,61,130,172,18,173,146,172,18,63,18,172,18,64,50,172,18,65,226,172,18,173,242,85,2,67,146,172,2,68,114,172,2,69,130,172,2,70,162,172,2,71,178,81,2,72,98,78,2,73,82,76,2,74,66,75,2,173,50,172,2,173,194,172,2,77,194,172,2,173,210,172,2,79,194,172,2,80,210,172,2,173,226,172,2,82,194,172,2,83,210,172,2,84,226,172,2,173,242,172,18,86,146,172,18,87,162,172,18,88,178,107,18,89,130,102,18,90,194,98,18,91,210,95,18,92,226,93,18,173,242,172,18,94,98,172,18,173,114,172,18,96,82,172,18,97,98,172,18,173,114,172,18,99,66,172,18,100,82,172,18,101,98,172,18,173,114,172,18,103,50,172,18,104,66,172,18,105,82,172,18,106,98,172,18,173,114,172,18,108,18,172,18,109,194,172,18,110,210,172,18,111,226,172,18,173,242,142,2,113,114,172,2,114,130,172,2,115,146,136,2,116,98,131,2,117,82,127,2,118,66,124,2,119,50,122,2,120,34,121,2,173,18,172,2,173,162,172,2,123,162,172,2,173,178,172,2,125,162,172,2,126,178,172,2,173,194,172,2,128,162,172,2,129,178,172,2,130,194,172,2,173,210,172,2,132,162,172,2,133,178,172,2,134,194,172,2,135,210,172,2,173,226,172,2,137,162,172,2,138,178,172,2,139,194,172,2,140,210,172,2,141,226,172,2,173,242,172,18,143,114,172,18,144,130,172,18,145,146,166,18,146,98,161,18,147,82,157,18,148,66,154,18,149,50,152,18,150,34,151,18,173,18,172,18,173,162,172,18,153,162,172,18,173,178,172,18,155,162,172,18,156,178,172,18,173,194,172,18,158,162,172,18,159,178,172,18,160,194,172,18,173,210,172,18,162,162,172,18,163,178,172,18,164,194,172,18,165,210,172,18,173,226,172,18,167,162,172,18,168,178,172,18,169,194,172,18,170,210,172,18,171,226,172,18,173,242,254,0,0,0,255,0,0,0,56,1,1,0,211,0,2,32,138,0,3,64,81,0,4,80,39,0,5,112,22,0,6,48,13,0,7,16,10,0,8,96,9,0,173,130,172,2,173,242,172,2,11,208,172,2,12,224,172,2,173,242,172,2,14,128,172,2,15,144,172,2,16,160,17,0,173,98,172,2,18,176,172,2,19,192,172,2,20,208,172,2,21,224,172,2,173,242,172,2,23,160,172,2,24,176,172,2,25,192,35,0,26,128,31,0,27,144,28,0,173,98,172,2,29,208,172,2,30,224,172,2,173,242,172,2,32,16,172,2,33,208,172,2,34,224,172,2,173,242,172,2,36,16,172,2,37,208,172,2,38,224,172,2,173,242,65,16,40,112,56,0,41,224,172,2,42,240,50,0,43,16,46,0,44,48,45,0,173,98,172,2,173,210,172,2,47,160,172,2,48,176,172,2,49,192,172,2,173,210,172,2,51,128,172,2,52,144,172,2,53,160,172,2,54,176,172,2,55,192,172,2,173,210,172,18,57,224,172,18,58,128,172,18,59,144,172,18,60,160,172,18,61,176,172,18,62,192,172,18,63,208,64,16,173,98,172,18,173,242,172,2,66,224,172,2,67,240,75,0,68,16,71,0,69,48,70,0,173,98,172,2,173,210,172,2,72,160,172,2,73,176,172,2,74,192,172,2,173,210,172,2,76,128,172,2,77,144,172,2,78,160,172,2,79,176,172,2,80,192,172,2,173,210,110,16,82,80,100,0,83,192,172,2,84,208,172,2,85,224,94,0,86,240,90,0,87,16,88,0,173,50,172,2,89,160,172,2,173,178,172,2,91,128,172,2,92,144,172,2,93,160,172,2,173,178,172,2,95,96,172,2,96,112,172,2,97,128,172,2,98,144,172,2,99,160,172,2,173,178,172,18,101,192,172,18,102,112,172,18,103,128,172,18,104,144,172,18,105,160,172,18,106,176,172,18,107,208,108,16,173,98,172,18,109,224,172,18,173,242,128,0,111,192,172,2,112,208,172,2,113,224,122,0,114,240,118,0,115,16,116,0,173,50,172,2,117,160,172,2,173,178,172,2,119,128,172,2,120,144,172,2,121,160,172,2,173,178,172,2,123,96,172,2,124,112,172,2,125,128,172,2,126,144,172,2,127,160,172,2,173,178,172,18,129,192,172,18,130,112,172,18,131,128,172,18,132,144,172,18,133,160,172,18,134,176,172,18,135,208,172,18,136,224,137,16,173,98,172,18,173,242,177,16,139,64,161,0,140,176,172,2,141,192,172,2,142,208,157,0,143,160,152,0,144,224,148,0,145,240,146,0,173,18,172,2,147,128,172,2,173,146,172,2,149,96,172,2,150,112,172,2,151,128,172,2,173,146,172,2,153,80,172,2,154,96,172,2,155,112,172,2,156,128,172,2,173,146,172,2,158,16,172,2,159,48,172,2,160,224,172,2,173,242,172,18,162,176,172,18,163,112,172,18,164,128,172,18,165,144,172,18,166,160,173,16,167,96,170,16,168,80,169,16,173,50,172,18,173,194,172,18,171,192,172,18,172,208,172,18,173,226,172,18,174,192,172,18,175,208,172,18,176,224,172,18,173,242,199,0,178,176,172,2,179,192,172,2,180,208,195,0,181,160,190,0,182,224,186,0,183,240,184,0,173,18,172,2,185,128,172,2,173,146,172,2,187,96,172,2,188,112,172,2,189,128,172,2,173,146,172,2,191,80,172,2,192,96,172,2,193,112,172,2,194,128,172,2,173,146,172,2,196,16,172,2,197,48,172,2,198,224,172,2,173,242,172,18,200,176,172,18,201,112,172,18,202,128,172,18,203,144,172,18,204,160,172,18,205,192,172,18,206,208,209,16,207,96,208,16,173,82,172,18,173,226,172,18,210,224,172,18,173,242,10,17,212,32,239,0,213,144,172,2,214,160,172,2,215,176,234,0,216,128,229,0,217,192,225,0,218,208,222,0,219,224,220,0,173,242,172,2,221,96,172,2,173,114,172,2,223,80,172,2,224,96,172,2,173,114,172,2,226,64,172,2,227,80,172,2,228,96,172,2,173,114,172,2,230,48,172,2,231,64,172,2,232,80,172,2,233,96,172,2,173,114,172,2,235,16,172,2,236,192,172,2,237,208,172,2,238,224,172,2,173,242,172,18,240,144,172,18,241,112,172,18,242,128,4,17,243,96,255,16,244,80,251,16,245,64,248,16,246,48,247,16,173,18,172,18,173,162,172,18,249,160,172,18,250,176,172,18,173,194,172,18,252,160,172,18,253,176,172,18,254,192,172,18,173,210,172,18,0,161,172,18,1,177,172,18,2,193,172,18,3,209,172,18,173,226,172,18,5,161,172,18,6,177,172,18,7,193,172,18,8,209,172,18,9,225,172,18,173,242,37,1,11,145,172,2,12,161,172,2,13,177,32,1,14,129,27,1,15,193,23,1,16,209,20,1,17,225,18,1,173,242,172,2,19,97,172,2,173,114,172,2,21,81,172,2,22,97,172,2,173,114,172,2,24,65,172,2,25,81,172,2,26,97,172,2,173,114,172,2,28,49,172,2,29,65,172,2,30,81,172,2,31,97,172,2,173,114,172,2,33,17,172,2,34,193,172,2,35,209,172,2,36,225,172,2,173,242,172,18,38,145,172,18,39,113,172,18,40,129,172,18,41,161,172,18,42,177,52,17,43,97,49,17,44,81,47,17,45,65,46,17,173,50,172,18,173,194,172,18,48,193,172,18,173,210,172,18,50,193,172,18,51,209,172,18,173,226,172,18,53,193,172,18,54,209,172,18,55,225,172,18,173,242,112,18,57,1,112,1,58,33,85,1,59,145,172,2,60,113,172,2,61,129,79,1,62,97,74,1,63,81,70,1,64,65,67,1,65,49,66,1,173,18,172,2,173,162,172,2,68,161,172,2,69,177,172,2,173,194,172,2,71,161,172,2,72,177,172,2,73,193,172,2,173,210,172,2,75,161,172,2,76,177,172,2,77,193,172,2,78,209,172,2,173,226,172,2,80,161,172,2,81,177,172,2,82,193,172,2,83,209,172,2,84,225,172,2,173,242,172,18,86,145,172,18,87,161,172,18,88,177,107,17,89,129,102,17,90,193,98,17,91,209,95,17,92,225,93,17,173,242,172,18,94,97,172,18,173,114,172,18,96,81,172,18,97,97,172,18,173,114,172,18,99,65,172,18,100,81,172,18,101,97,172,18,173,114,172,18,103,49,172,18,104,65,172,18,105,81,172,18,106,97,172,18,173,114,172,18,108,17,172,18,109,193,172,18,110,209,172,18,111,225,172,18,173,242,66,18,113,33,152,1,114,65,130,1,115,177,172,2,116,113,172,2,117,129,172,2,118,145,172,2,119,161,126,1,120,97,123,1,121,81,122,1,173,50,172,2,173,194,172,2,124,193,172,2,125,209,172,2,173,226,172,2,127,193,172,2,128,209,172,2,129,225,172,2,173,242,172,18,131,177,172,18,132,193,172,18,133,209,148,17,134,161,143,17,135,225,139,17,136,241,137,17,173,18,172,18,138,129,172,18,173,146,172,18,140,97,172,18,141,113,172,18,142,129,172,18,173,146,172,18,144,81,172,18,145,97,172,18,146,113,172,18,147,129,172,18,173,146,172,18,149,17,172,18,150,49,172,18,151,225,172,18,173,242,32,18,153,65,182,1,154,81,164,1,155,193,172,2,156,113,172,2,157,129,172,2,158,145,172,2,159,161,172,2,160,177,172,2,161,209,162,1,173,98,172,2,163,225,172,2,173,242,172,18,165,193,172,18,166,209,172,18,167,225,176,17,168,241,172,17,169,17,170,17,173,50,172,18,171,161,172,18,173,178,172,18,173,129,172,18,174,145,172,18,175,161,172,18,173,178,172,18,177,97,172,18,178,113,172,18,179,129,172,18,180,145,172,18,181,161,172,18,173,178,4,18,183,81,209,1,184,113,193,1,185,225,172,2,186,129,172,2,187,145,172,2,188,161,172,2,189,177,172,2,190,193,172,2,191,209,192,1,173,98,172,2,173,242,172,18,194,225,172,18,195,241,203,17,196,17,199,17,197,49,198,17,173,98,172,18,173,210,172,18,200,161,172,18,201,177,172,18,202,193,172,18,173,210,172,18,204,129,172,18,205,145,172,18,206,161,172,18,207,177,172,18,208,193,172,18,173,210,244,17,210,113,227,17,211,49,218,17,212,17,215,17,213,97,214,17,173,130,172,18,173,242,172,18,216,209,172,18,217,225,172,18,173,242,172,18,219,129,172,18,220,145,172,18,221,161,222,17,173,98,172,18,223,177,172,18,224,193,172,18,225,209,172,18,226,225,172,18,173,242,172,18,228,161,172,18,229,177,172,18,230,193,240,17,231,129,236,17,232,145,233,17,173,98,172,18,234,209,172,18,235,225,172,18,173,242,172,18,237,17,172,18,238,209,172,18,239,225,172,18,173,242,172,18,241,17,172,18,242,209,172,18,243,225,172,18,173,242,172,18,245,225,172,18,246,241,254,17,247,17,250,17,248,49,249,17,173,98,172,18,173,210,172,18,251,161,172,18,252,177,172,18,253,193,172,18,173,210,172,18,255,129,172,18,0,146,172,18,1,162,172,18,2,178,172,18,3,194,172,18,173,210,14,2,5,194,172,2,6,114,172,2,7,130,172,2,8,146,172,2,9,162,172,2,10,178,172,2,11,210,172,2,12,226,13,2,173,98,172,2,173,242,172,18,15,194,172,18,16,210,172,18,17,226,26,18,18,242,22,18,19,18,20,18,173,50,172,18,21,162,172,18,173,178,172,18,23,130,172,18,24,146,172,18,25,162,172,18,173,178,172,18,27,98,172,18,28,114,172,18,29,130,172,18,30,146,172,18,31,162,172,18,173,178,44,2,33,178,172,2,34,114,172,2,35,130,172,2,36,146,172,2,37,162,172,2,38,194,172,2,39,210,42,2,40,98,41,2,173,82,172,2,173,226,172,2,43,226,172,2,173,242,172,18,45,178,172,18,46,194,172,18,47,210,62,18,48,162,57,18,49,226,53,18,50,242,51,18,173,18,172,18,52,130,172,18,173,146,172,18,54,98,172,18,55,114,172,18,56,130,172,18,173,146,172,18,58,82,172,18,59,98,172,18,60,114,172,18,61,130,172,18,173,146,172,18,63,18,172,18,64,50,172,18,65,226,172,18,173,242,85,2,67,146,172,2,68,114,172,2,69,130,172,2,70,162,172,2,71,178,81,2,72,98,78,2,73,82,76,2,74,66,75,2,173,50,172,2,173,194,172,2,77,194,172,2,173,210,172,2,79,194,172,2,80,210,172,2,173,226,172,2,82,194,172,2,83,210,172,2,84,226,172,2,173,242,172,18,86,146,172,18,87,162,172,18,88,178,107,18,89,130,102,18,90,194,98,18,91,210,95,18,92,226,93,18,173,242,172,18,94,98,172,18,173,114,172,18,96,82,172,18,97,98,172,18,173,114,172,18,99,66,172,18,100,82,172,18,101,98,172,18,173,114,172,18,103,50,172,18,104,66,172,18,105,82,172,18,106,98,172,18,173,114,172,18,108,18,172,18,109,194,172,18,110,210,172,18,111,226,172,18,173,242,142,2,113,114,172,2,114,130,172,2,115,146,136,2,116,98,131,2,117,82,127,2,118,66,124,2,119,50,122,2,120,34,121,2,173,18,172,2,173,162,172,2,123,162,172,2,173,178,172,2,125,162,172,2,126,178,172,2,173,194,172,2,128,162,172,2,129,178,172,2,130,194,172,2,173,210,172,2,132,162,172,2,133,178,172,2,134,194,172,2,135,210,172,2,173,226,172,2,137,162,172,2,138,178,172,2,139,194,172,2,140,210,172,2,141,226,172,2,173,242,172,18,143,114,172,18,144,130,172,18,145,146,166,18,146,98,161,18,147,82,157,18,148,66,154,18,149,50,152,18,150,34,151,18,173,18,172,18,173,162,172,18,153,162,172,18,173,178,172,18,155,162,172,18,156,178,172,18,173,194,172,18,158,162,172,18,159,178,172,18,160,194,172,18,173,210,172,18,162,162,172,18,163,178,172,18,164,194,172,18,165,210,172,18,173,226,172,18,167,162,172,18,168,178,172,18,169,194,172,18,170,210,172,18,171,226,172,18,173,242,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,146,0,1,0,101,0,2,32,49,0,3,80,38,0,4,144,28,0,5,112,21,0,6,16,15,0,7,96,11,0,8,48,9,0,64,65,63,1,10,160,63,1,64,177,63,1,12,128,63,1,13,160,14,0,64,65,63,1,64,177,63,1,16,176,19,0,17,48,18,0,64,65,63,1,64,161,63,1,20,128,63,1,64,161,63,1,22,96,63,1,23,128,26,0,24,64,25,0,64,49,63,1,64,161,63,1,27,160,63,1,64,177,63,1,29,16,35,0,30,176,33,0,31,48,32,0,64,65,63,1,64,161,63,1,34,128,63,1,64,161,63,1,36,96,63,1,37,48,63,1,64,65,63,1,39,48,63,1,40,64,46,0,41,112,44,0,42,16,43,0,64,97,63,1,64,177,63,1,45,96,63,1,64,129,63,1,47,16,48,0,64,97,63,1,64,177,89,16,50,112,80,16,51,144,75,16,52,80,68,0,53,16,61,0,54,64,57,0,55,160,63,1,56,48,63,1,64,177,63,17,58,96,63,17,59,128,63,17,60,176,63,17,64,161,63,17,62,96,63,17,63,128,66,16,64,160,65,16,64,65,63,17,64,177,63,17,67,48,63,17,64,65,63,17,69,96,63,17,70,128,73,16,71,64,72,16,64,49,63,17,64,161,63,17,74,160,63,17,64,177,63,1,76,16,63,1,77,48,63,1,78,64,63,1,79,160,63,1,64,177,63,1,81,160,63,1,82,176,86,0,83,144,63,1,84,16,85,0,64,49,63,1,64,129,63,1,87,16,63,1,88,48,63,1,64,65,63,1,90,160,63,1,91,176,98,0,92,144,95,0,93,16,94,0,64,49,63,1,64,129,63,1,96,96,63,1,97,128,63,1,64,113,63,1,99,16,63,1,100,48,63,1,64,65,123,0,102,112,63,1,103,144,63,1,104,128,119,0,105,80,113,0,106,16,110,0,107,160,108,0,64,177,63,1,109,96,63,1,64,65,63,1,111,96,63,1,112,48,63,1,64,65,63,1,114,96,117,0,115,64,116,0,64,49,63,1,64,161,63,1,118,160,63,1,64,177,63,1,120,160,63,1,121,176,122,0,64,17,63,1,64,97,63,17,124,112,63,17,125,80,138,16,126,32,63,17,127,96,134,16,128,64,131,16,129,48,130,16,64,17,63,17,64,129,63,17,132,144,63,17,133,128,63,17,64,161,63,17,135,144,63,17,136,128,63,17,137,160,63,17,64,177,63,17,139,144,63,17,140,96,63,17,141,128,144,16,142,64,143,16,64,49,63,17,64,161,63,17,145,160,63,17,64,177,19,17,147,0,230,16,148,32,200,16,149,176,185,16,150,48,169,16,151,80,163,16,152,144,160,16,153,112,156,16,154,16,155,16,64,65,63,17,64,161,63,17,157,96,63,17,158,128,159,16,64,65,63,17,64,161,63,17,161,16,162,16,64,65,63,17,64,161,63,17,164,64,168,16,165,112,166,16,64,17,63,17,167,96,63,17,64,129,63,17,64,17,178,16,170,160,176,16,171,144,175,16,172,112,173,16,64,17,63,17,174,96,63,17,64,129,63,17,64,17,63,17,177,16,63,17,64,65,63,1,179,112,63,1,180,144,63,1,181,80,63,1,182,64,63,1,183,96,63,1,184,128,63,1,64,161,192,16,186,144,63,17,187,128,63,17,188,160,191,16,189,112,190,16,64,17,63,17,64,97,63,17,64,17,63,1,193,80,63,1,194,112,63,1,195,144,63,1,196,64,63,1,197,96,63,1,198,128,199,0,64,49,63,1,64,161,220,16,201,64,213,16,202,80,210,16,203,112,63,17,204,96,207,16,205,48,206,16,64,17,63,17,64,129,63,17,208,144,63,17,209,128,63,17,64,161,63,17,211,16,63,17,212,96,63,17,64,49,63,1,214,112,63,1,215,144,63,1,216,80,63,1,217,96,63,1,218,128,63,1,219,160,63,1,64,177,63,1,221,80,63,1,222,112,63,1,223,144,63,1,224,96,63,1,225,128,228,0,226,160,227,0,64,65,61,1,64,177,63,1,229,48,63,1,64,65,253,0,231,112,63,1,232,80,245,0,233,32,63,1,234,96,241,0,235,64,238,0,236,48,237,0,64,17,63,1,64,129,63,1,239,144,63,1,240,128,63,1,64,161,63,1,242,144,63,1,243,128,63,1,244,160,63,1,64,177,63,1,246,144,63,1,247,96,63,1,248,128,251,0,249,64,250,0,64,49,63,1,64,161,63,1,252,160,63,1,64,177,63,17,254,112,63,17,255,144,63,17,0,129,15,17,1,81,9,17,2,17,6,17,3,161,4,17,64,177,63,17,5,97,63,17,64,65,63,17,7,97,63,17,8,49,63,17,64,65,63,17,10,97,13,17,11,65,12,17,64,49,63,17,64,161,63,17,14,161,63,17,64,177,63,17,16,161,63,17,17,177,18,17,64,17,63,17,64,97,40,1,20,81,63,1,21,113,33,1,22,145,63,1,23,97,30,1,24,65,28,1,25,49,26,1,64,129,63,1,27,17,63,1,64,33,63,1,29,129,63,1,64,161,63,1,31,177,63,1,32,129,63,1,64,161,63,1,34,33,63,1,35,49,63,1,36,65,38,1,37,17,63,1,64,97,63,1,39,97,63,1,64,129,61,17,41,81,63,17,42,113,54,17,43,145,63,17,44,97,51,17,45,65,49,17,46,49,47,17,64,129,63,17,48,17,63,17,64,33,63,17,50,129,63,17,64,161,63,17,52,177,63,17,53,129,63,17,64,161,63,17,55,33,63,17,56,49,63,17,57,65,59,17,58,17,63,17,64,97,63,17,60,97,63,17,64,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,181,0,1,0,54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,137,65,136,1,9,160,136,1,137,177,136,1,11,128,136,1,12,160,13,0,137,177,136,1,14,64,136,1,137,113,136,1,16,176,19,0,17,48,18,0,137,65,136,1,137,161,136,1,20,128,136,1,137,161,136,1,22,96,136,1,23,112,136,1,24,128,27,0,25,64,26,0,137,49,136,1,137,161,136,1,28,160,136,1,137,177,136,1,30,48,136,1,31,64,34,0,32,16,33,0,137,97,136,1,137,177,136,1,35,96,136,1,36,112,136,1,137,129,136,1,38,144,136,1,39,112,136,1,40,128,48,0,41,16,45,0,42,160,43,0,137,177,136,1,44,96,136,1,137,65,136,1,46,96,136,1,47,48,136,1,137,65,136,1,49,96,52,0,50,64,51,0,137,49,136,1,137,161,136,1,53,160,136,1,137,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,136,1,62,160,63,0,137,33,136,1,137,113,136,17,65,96,136,17,66,32,136,17,67,112,136,17,137,129,72,0,69,96,136,1,70,112,136,1,71,128,136,1,137,161,136,17,73,96,136,17,74,32,136,17,75,112,76,16,137,17,136,17,137,129,136,17,78,32,136,17,79,112,81,16,80,16,136,17,137,97,136,17,82,96,136,17,137,129,136,1,84,176,136,1,85,128,136,1,86,160,89,0,87,16,88,0,137,33,136,1,137,113,136,1,90,96,136,1,137,113,136,1,92,176,136,1,93,160,101,0,94,48,98,0,95,16,96,0,137,33,136,1,97,112,136,1,137,129,136,1,99,96,136,1,100,112,136,1,137,129,136,1,102,128,105,0,103,16,104,0,137,33,136,1,137,113,136,1,106,96,136,1,137,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,136,1,113,48,136,1,137,177,136,17,115,96,136,17,116,112,136,17,117,128,136,17,118,176,136,17,137,161,136,17,120,96,136,17,121,112,136,17,122,128,125,16,123,160,124,16,137,65,136,17,137,177,136,17,126,48,136,17,137,65,136,17,128,96,136,17,129,112,136,17,130,128,133,16,131,64,132,16,137,49,136,17,137,161,136,17,134,160,136,17,137,177,136,17,136,96,136,17,137,112,143,16,138,128,141,16,139,64,140,16,137,49,136,17,137,161,136,17,142,160,136,17,137,177,136,17,144,32,136,17,145,16,136,17,146,48,136,17,137,65,153,0,148,32,136,1,149,16,136,1,150,48,136,1,151,64,136,1,152,160,136,1,137,177,134,17,154,32,136,17,155,48,136,17,156,64,136,17,157,112,159,16,158,16,136,17,137,97,136,17,160,96,136,17,137,129,174,0,162,32,136,1,163,160,136,1,164,176,171,0,165,144,168,0,166,16,167,0,137,49,136,1,137,129,136,1,169,96,136,1,170,112,136,1,137,129,136,1,172,16,136,1,173,48,136,1,137,65,136,1,175,144,136,1,176,112,136,1,177,128,136,1,178,160,136,1,179,176,180,0,137,17,136,1,137,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,136,1,186,96,193,0,187,64,190,0,188,48,189,0,137,17,136,1,137,129,136,1,191,144,136,1,192,128,136,1,137,161,136,1,194,144,136,1,195,128,136,1,196,160,136,1,137,177,136,17,198,144,136,17,199,128,136,17,200,160,136,17,201,176,136,17,202,112,203,16,137,17,136,17,137,97,136,17,205,144,136,17,206,112,136,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,137,177,136,17,212,96,136,17,137,65,136,17,214,96,136,17,215,48,136,17,137,65,136,17,217,96,220,16,218,64,219,16,137,49,136,17,137,161,136,17,221,160,136,17,137,177,136,17,223,160,136,17,224,176,225,16,137,17,136,17,137,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,136,17,233,48,136,17,137,177,136,1,235,96,136,1,236,112,136,1,237,128,136,1,238,176,136,1,137,161,136,1,240,96,136,1,241,112,136,1,242,128,245,0,243,160,244,0,137,65,136,1,137,177,136,1,246,48,136,1,137,65,136,1,248,96,136,1,249,112,136,1,250,128,253,0,251,64,252,0,137,49,136,1,137,161,136,1,254,160,136,1,137,177,136,17,0,49,136,17,1,65,8,17,2,81,5,17,3,17,4,17,137,97,136,17,137,177,136,17,6,97,136,17,7,113,136,17,137,129,136,17,9,17,136,17,10,161,136,17,137,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,137,65,136,17,18,161,136,17,137,177,136,17,20,129,136,17,21,161,22,17,137,177,136,17,23,65,136,17,137,113,136,17,25,177,28,17,26,49,27,17,137,65,136,17,137,161,136,17,29,129,136,17,137,161,136,17,31,97,136,17,32,113,136,17,33,129,36,17,34,65,35,17,137,49,136,17,137,161,136,17,37,161,136,17,137,177,136,17,39,161,136,17,40,177,43,17,41,17,42,17,137,49,136,17,137,129,136,17,44,97,136,17,45,113,136,17,137,129,136,17,47,49,136,17,48,65,55,17,49,81,52,17,50,17,51,17,137,97,136,17,137,177,136,17,53,97,136,17,54,113,136,17,137,129,136,17,56,17,136,17,57,161,136,17,137,177,80,17,59,145,136,17,60,113,136,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,137,177,136,17,66,97,136,17,137,65,136,17,68,97,136,17,69,49,136,17,137,65,136,17,71,97,74,17,72,65,73,17,137,49,136,17,137,161,136,17,75,161,136,17,137,177,136,17,77,161,136,17,78,177,79,17,137,17,136,17,137,97,136,1,81,81,134,1,82,145,136,1,83,97,136,1,84,113,136,1,85,129,88,1,86,65,87,1,137,49,136,1,137,161,136,1,89,161,136,1,137,177,112,1,91,81,104,1,92,145,136,1,93,97,136,1,94,113,101,1,95,65,99,1,96,49,97,1,137,129,136,1,98,17,136,1,137,33,136,1,100,129,136,1,137,161,136,1,102,177,136,1,103,129,136,1,137,161,136,1,105,33,136,1,106,49,136,1,107,65,136,1,108,113,110,1,109,17,136,1,137,97,136,1,111,97,136,1,137,129,134,17,113,81,126,17,114,145,136,17,115,97,136,17,116,113,123,17,117,65,121,17,118,49,119,17,137,129,136,17,120,17,136,17,137,33,136,17,122,129,136,17,137,161,136,17,124,177,136,17,125,129,136,17,137,161,136,17,127,33,136,17,128,49,136,17,129,65,136,17,130,113,132,17,131,17,136,17,137,97,136,17,133,97,136,17,137,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,42,0,1,0,27,0,2,32,16,0,3,48,12,0,4,80,8,0,5,112,6,0,115,16,114,0,7,64,114,0,115,96,10,0,9,16,114,0,115,64,114,0,11,64,114,0,115,96,14,0,13,112,114,0,115,16,114,0,15,16,114,0,115,64,22,0,17,112,114,0,18,96,21,0,19,80,20,0,115,16,114,0,115,64,114,0,115,16,114,16,23,80,112,16,24,48,112,16,25,112,114,16,26,64,114,16,115,96,32,0,28,80,114,0,29,112,114,0,30,96,31,0,115,16,114,0,115,64,112,16,33,80,114,16,34,48,39,16,35,32,37,16,36,16,114,16,115,64,114,16,38,64,114,16,115,96,112,16,40,112,112,16,41,64,112,16,113,96,92,16,43,0,77,16,44,32,57,0,45,112,53,16,46,48,51,16,47,80,49,16,48,16,114,16,115,64,114,16,50,64,114,16,115,96,114,16,52,16,114,16,115,64,114,0,54,80,112,0,55,48,114,0,56,64,114,0,115,96,69,16,58,112,64,16,59,48,63,16,60,80,61,16,115,16,114,16,62,64,114,16,115,96,114,16,115,16,114,16,65,96,68,16,66,80,67,16,115,16,114,16,115,64,114,16,115,16,112,16,70,48,75,16,71,80,73,16,72,16,112,16,113,64,112,16,74,64,112,16,113,96,112,16,76,16,112,16,113,64,87,0,78,80,114,0,79,48,84,0,80,32,82,0,81,16,114,0,115,64,114,0,83,64,114,0,115,96,112,0,85,112,112,0,86,64,112,0,113,96,112,16,88,80,114,16,89,112,114,16,90,96,91,16,115,16,114,16,115,64,102,0,93,48,112,0,94,80,99,0,95,32,97,0,96,16,112,0,113,64,112,0,98,64,112,0,113,96,112,0,100,112,112,0,101,64,112,0,113,96,112,16,103,48,112,16,104,80,109,16,105,32,107,16,106,16,112,16,113,64,112,16,108,64,112,16,113,96,112,16,110,112,112,16,111,64,112,16,113,96,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,145,0,1,0,100,0,2,32,49,0,3,80,38,0,4,144,28,0,5,112,21,0,6,16,15,0,7,96,11,0,8,48,9,0,89,65,86,1,10,160,88,1,89,177,86,1,12,128,86,1,13,160,14,0,89,65,88,1,89,177,86,1,16,176,19,0,17,48,18,0,89,65,86,1,89,161,86,1,20,128,86,1,89,161,86,1,22,96,86,1,23,128,26,0,24,64,25,0,89,49,86,1,89,161,86,1,27,160,86,1,89,177,86,1,29,16,35,0,30,176,33,0,31,48,32,0,87,65,86,1,87,161,86,1,34,128,86,1,87,161,86,1,36,96,86,1,37,48,86,1,87,65,86,1,39,48,86,1,40,64,46,0,41,112,44,0,42,16,43,0,87,97,86,1,87,177,86,1,45,96,86,1,87,129,86,1,47,16,48,0,87,97,86,1,87,177,85,16,50,144,80,16,51,112,75,16,52,80,68,0,53,16,61,0,54,64,57,0,55,160,86,1,56,48,88,1,89,177,86,17,58,96,86,17,59,128,88,17,60,176,88,17,89,161,86,17,62,96,86,17,63,128,66,16,64,160,65,16,89,65,88,17,89,177,86,17,67,48,88,17,89,65,86,17,69,96,86,17,70,128,73,16,71,64,72,16,89,49,86,17,89,161,86,17,74,160,86,17,89,177,86,1,76,16,86,1,77,48,86,1,78,64,86,1,79,160,86,1,89,177,86,1,81,16,86,1,82,48,86,1,83,64,86,1,84,160,86,1,87,177,86,1,86,160,86,1,87,176,97,0,88,144,94,0,89,112,92,0,90,16,91,0,87,49,86,1,87,129,86,1,93,96,86,1,87,129,86,1,95,16,96,0,87,49,86,1,87,129,86,1,98,16,86,1,99,48,86,1,87,65,122,0,101,112,86,1,102,144,86,1,103,128,118,0,104,80,112,0,105,16,109,0,106,160,107,0,87,177,86,1,108,96,86,1,89,65,86,1,110,96,86,1,111,48,86,1,89,65,86,1,113,96,116,0,114,64,115,0,87,49,86,1,87,161,86,1,117,160,86,1,87,177,86,1,119,160,86,1,120,176,121,0,87,17,86,1,87,97,86,17,123,112,86,17,124,80,137,16,125,32,86,17,126,96,133,16,127,64,130,16,128,48,129,16,87,17,86,17,87,129,86,17,131,144,86,17,132,128,86,17,89,161,86,17,134,144,86,17,135,128,86,17,136,160,86,17,89,177,86,17,138,144,86,17,139,96,86,17,140,128,143,16,141,64,142,16,87,49,86,17,87,161,86,17,144,160,86,17,87,177,44,17,146,0,255,16,147,32,194,16,148,144,183,16,149,80,173,16,150,112,166,16,151,16,160,16,152,96,156,16,153,48,154,16,89,65,86,17,155,160,88,17,89,177,86,17,157,128,86,17,158,160,159,16,89,65,88,17,89,177,86,17,161,176,164,16,162,48,163,16,89,65,86,17,89,161,86,17,165,128,86,17,89,161,86,17,167,96,86,17,168,128,171,16,169,64,170,16,89,49,86,17,89,161,86,17,172,160,86,17,89,177,86,17,174,16,180,16,175,176,178,16,176,48,177,16,87,65,86,17,87,161,86,17,179,128,86,17,87,161,86,17,181,96,86,17,182,48,86,17,87,65,86,17,184,160,86,17,185,176,191,16,186,112,189,16,187,16,188,16,87,49,86,17,87,129,86,17,190,96,86,17,87,129,86,17,192,16,193,16,87,49,86,17,87,129,240,0,195,144,225,0,196,80,220,0,197,112,213,16,198,16,206,16,199,64,202,16,200,160,86,17,201,48,88,17,89,177,86,1,203,96,86,1,204,128,88,1,205,176,88,1,89,161,86,1,207,96,86,1,208,128,211,0,209,160,210,0,89,65,88,1,89,177,86,1,212,48,88,1,89,65,86,1,214,96,86,1,215,128,218,0,216,64,217,0,89,49,86,1,89,161,86,1,219,160,86,1,89,177,86,17,221,16,86,17,222,48,86,17,223,64,86,17,224,160,86,17,89,177,86,17,226,48,86,17,227,64,237,16,228,80,234,16,229,112,232,16,230,16,231,16,89,97,86,17,89,177,86,17,233,96,86,17,89,129,86,17,235,16,236,16,87,97,86,17,87,177,86,17,238,16,86,17,239,160,86,17,87,177,86,17,241,48,86,17,242,64,252,16,243,80,249,16,244,112,247,16,245,16,246,16,87,97,86,17,87,177,86,17,248,96,86,17,87,129,86,17,250,16,251,16,87,97,86,17,87,177,86,17,253,16,86,17,254,160,86,17,87,177,22,1,0,113,86,1,1,81,14,1,2,33,86,1,3,97,10,1,4,65,7,1,5,49,6,1,87,17,86,1,87,129,86,1,8,145,86,1,9,129,86,1,89,161,86,1,11,145,86,1,12,129,86,1,13,161,86,1,89,177,86,1,15,145,86,1,16,97,86,1,17,129,20,1,18,65,19,1,87,49,86,1,87,161,86,1,21,161,86,1,87,177,86,17,23,113,86,17,24,145,86,17,25,129,40,17,26,81,34,17,27,17,31,17,28,161,29,17,87,177,86,17,30,97,86,17,89,65,86,17,32,97,86,17,33,49,86,17,89,65,86,17,35,97,38,17,36,65,37,17,87,49,86,17,87,161,86,17,39,161,86,17,87,177,86,17,41,161,86,17,42,177,43,17,87,17,86,17,87,97,65,1,45,81,86,1,46,113,58,1,47,145,86,1,48,97,55,1,49,65,53,1,50,49,51,1,87,129,86,1,52,17,86,1,87,33,86,1,54,129,86,1,87,161,86,1,56,177,86,1,57,129,86,1,87,161,86,1,59,33,86,1,60,49,86,1,61,65,63,1,62,17,86,1,87,97,86,1,64,97,86,1,87,129,86,17,66,81,86,17,67,113,79,17,68,145,86,17,69,97,76,17,70,65,74,17,71,49,72,17,87,129,86,17,73,17,86,17,87,33,86,17,75,129,86,17,87,161,86,17,77,177,86,17,78,129,86,17,87,161,86,17,80,33,86,17,81,49,86,17,82,65,84,17,83,17,86,17,87,97,86,17,85,97,86,17,87,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,181,0,1,0,54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,135,65,134,1,9,160,134,1,137,177,134,1,11,128,134,1,12,160,13,0,137,177,134,1,14,64,136,1,137,113,134,1,16,176,19,0,17,48,18,0,135,65,134,1,135,161,134,1,20,128,134,1,135,161,134,1,22,96,134,1,23,112,134,1,24,128,27,0,25,64,26,0,137,49,134,1,137,161,134,1,28,160,134,1,137,177,134,1,30,48,134,1,31,64,34,0,32,16,33,0,135,97,134,1,135,177,134,1,35,96,134,1,36,112,134,1,135,129,134,1,38,144,134,1,39,112,134,1,40,128,48,0,41,16,45,0,42,160,43,0,135,177,134,1,44,96,134,1,137,65,134,1,46,96,134,1,47,48,134,1,137,65,134,1,49,96,52,0,50,64,51,0,135,49,134,1,135,161,134,1,53,160],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+122880);allocate([134,1,135,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,134,1,62,160,63,0,137,33,136,1,137,113,134,17,65,96,134,17,66,32,136,17,67,112,136,17,137,129,72,0,69,96,134,1,70,112,134,1,71,128,136,1,137,161,134,17,73,96,134,17,74,32,134,17,75,112,76,16,137,17,136,17,137,129,134,17,78,32,134,17,79,112,81,16,80,16,134,17,137,97,134,17,82,96,134,17,137,129,134,1,84,176,134,1,85,128,134,1,86,160,89,0,87,16,88,0,137,33,134,1,137,113,134,1,90,96,134,1,137,113,134,1,92,176,134,1,93,160,101,0,94,48,98,0,95,16,96,0,135,33,134,1,97,112,134,1,137,129,134,1,99,96,134,1,100,112,134,1,137,129,134,1,102,128,105,0,103,16,104,0,135,33,134,1,135,113,134,1,106,96,134,1,135,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,134,1,113,48,134,1,137,177,134,17,115,96,134,17,116,112,134,17,117,128,136,17,118,176,136,17,137,161,134,17,120,96,134,17,121,112,134,17,122,128,125,16,123,160,124,16,137,65,136,17,137,177,134,17,126,48,136,17,137,65,134,17,128,96,134,17,129,112,134,17,130,128,133,16,131,64,132,16,137,49,134,17,137,161,134,17,134,160,134,17,137,177,134,17,136,96,134,17,137,112,143,16,138,128,141,16,139,64,140,16,135,49,134,17,135,161,134,17,142,160,134,17,135,177,134,17,144,32,134,17,145,16,134,17,146,48,134,17,137,65,153,0,148,32,134,1,149,16,134,1,150,48,134,1,151,64,134,1,152,160,134,1,135,177,134,17,154,32,134,17,155,48,134,17,156,64,134,17,157,112,159,16,158,16,134,17,135,97,134,17,160,96,134,17,135,129,174,0,162,32,134,1,163,160,134,1,164,176,171,0,165,144,168,0,166,16,167,0,135,49,134,1,135,129,134,1,169,96,134,1,170,112,134,1,135,129,134,1,172,16,134,1,173,48,134,1,135,65,134,1,175,144,134,1,176,112,134,1,177,128,134,1,178,160,134,1,179,176,180,0,135,17,134,1,135,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,134,1,186,96,193,0,187,64,190,0,188,48,189,0,135,17,134,1,135,129,134,1,191,144,134,1,192,128,134,1,137,161,134,1,194,144,134,1,195,128,134,1,196,160,134,1,137,177,134,17,198,144,134,17,199,128,134,17,200,160,134,17,201,176,134,17,202,112,203,16,137,17,134,17,137,97,134,17,205,144,134,17,206,112,134,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,137,177,134,17,212,96,136,17,137,65,134,17,214,96,134,17,215,48,136,17,137,65,134,17,217,96,220,16,218,64,219,16,137,49,134,17,137,161,134,17,221,160,134,17,137,177,134,17,223,160,134,17,224,176,225,16,135,17,134,17,135,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,134,17,233,48,134,17,137,177,134,1,235,96,134,1,236,112,134,1,237,128,136,1,238,176,136,1,137,161,134,1,240,96,134,1,241,112,134,1,242,128,245,0,243,160,244,0,137,65,136,1,137,177,134,1,246,48,136,1,137,65,134,1,248,96,134,1,249,112,134,1,250,128,253,0,251,64,252,0,137,49,134,1,137,161,134,1,254,160,134,1,137,177,134,17,0,49,134,17,1,65,8,17,2,81,5,17,3,17,4,17,135,97,134,17,135,177,134,17,6,97,134,17,7,113,134,17,137,129,134,17,9,17,134,17,10,161,134,17,135,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,135,65,134,17,18,161,134,17,137,177,134,17,20,129,134,17,21,161,22,17,137,177,134,17,23,65,136,17,137,113,134,17,25,177,28,17,26,49,27,17,135,65,134,17,135,161,134,17,29,129,134,17,135,161,134,17,31,97,134,17,32,113,134,17,33,129,36,17,34,65,35,17,137,49,134,17,137,161,134,17,37,161,134,17,137,177,134,17,39,161,134,17,40,177,43,17,41,17,42,17,135,49,134,17,135,129,134,17,44,97,134,17,45,113,134,17,135,129,134,17,47,49,134,17,48,65,55,17,49,81,52,17,50,17,51,17,135,97,134,17,135,177,134,17,53,97,134,17,54,113,134,17,135,129,134,17,56,17,134,17,57,161,134,17,135,177,80,17,59,145,134,17,60,113,134,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,135,177,134,17,66,97,134,17,137,65,134,17,68,97,134,17,69,49,134,17,137,65,134,17,71,97,74,17,72,65,73,17,135,49,134,17,135,161,134,17,75,161,134,17,135,177,134,17,77,161,134,17,78,177,79,17,135,17,134,17,135,97,134,1,81,81,134,1,82,145,134,1,83,97,134,1,84,113,134,1,85,129,88,1,86,65,87,1,135,49,134,1,135,161,134,1,89,161,134,1,135,177,112,1,91,81,104,1,92,145,134,1,93,97,134,1,94,113,101,1,95,65,99,1,96,49,97,1,135,129,134,1,98,17,134,1,135,33,134,1,100,129,134,1,135,161,134,1,102,177,134,1,103,129,134,1,135,161,134,1,105,33,134,1,106,49,134,1,107,65,134,1,108,113,110,1,109,17,134,1,135,97,134,1,111,97,134,1,135,129,134,17,113,81,126,17,114,145,134,17,115,97,134,17,116,113,123,17,117,65,121,17,118,49,119,17,135,129,134,17,120,17,134,17,135,33,134,17,122,129,134,17,135,161,134,17,124,177,134,17,125,129,134,17,135,161,134,17,127,33,134,17,128,49,134,17,129,65,134,17,130,113,132,17,131,17,134,17,135,97,134,17,133,97,134,17,135,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,38,0,1,0,23,0,2,32,12,0,3,48,9,0,4,80,7,0,5,16,6,0,111,64,108,0,111,112,108,0,8,64,108,0,111,96,108,0,10,16,11,0,109,64,108,0,109,112,18,0,13,112,108,0,14,96,17,0,15,80,16,0,111,16,108,0,111,64,108,0,109,16,108,16,19,80,108,16,20,48,108,16,21,112,108,16,22,64,110,16,111,96,28,0,24,80,108,0,25,112,108,0,26,96,27,0,109,16,108,0,109,64,108,16,29,80,108,16,30,48,35,16,31,32,33,16,32,16,108,16,111,64,108,16,34,64,108,16,111,96,108,16,36,112,108,16,37,64,108,16,111,96,88,16,39,0,73,16,40,32,53,0,41,112,49,16,42,48,47,16,43,80,45,16,44,16,110,16,111,64,108,16,46,64,110,16,111,96,108,16,48,16,108,16,111,64,108,0,50,80,108,0,51,48,108,0,52,64,110,0,111,96,65,16,54,112,60,16,55,48,59,16,56,80,57,16,111,16,108,16,58,64,110,16,111,96,108,16,109,16,108,16,61,96,64,16,62,80,63,16,111,16,108,16,111,64,108,16,109,16,108,16,66,48,71,16,67,80,69,16,68,16,108,16,111,64,108,16,70,64,108,16,111,96,108,16,72,16,108,16,109,64,83,0,74,80,108,0,75,48,80,0,76,32,78,0,77,16,108,0,111,64,108,0,79,64,108,0,111,96,108,0,81,112,108,0,82,64,108,0,111,96,108,16,84,80,108,16,85,112,108,16,86,96,87,16,109,16,108,16,109,64,98,0,89,48,108,0,90,80,95,0,91,32,93,0,92,16,108,0,109,64,108,0,94,64,108,0,109,96,108,0,96,112,108,0,97,64,108,0,109,96,108,16,99,48,108,16,100,80,105,16,101,32,103,16,102,16,108,16,109,64,108,16,104,64,108,16,109,96,108,16,106,112,108,16,107,64,108,16,109,96,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,0,0,0,0,192,76,0,0,16,5,0,0,55,5,0,0,38,0,0,0,238,2,0,0,239,2,0,0,10,2,0,0,8,0,0,0,23,3,0,0,99,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,78,0,0,0,31,2,0,0,32,2,0,0,33,2,0,0,24,3,0,0,53,2,0,0,25,3,0,0,54,2,0,0,26,3,0,0,55,2,0,0,0,0,0,0,176,76,0,0,5,0,0,0,56,5,0,0,57,5,0,0,0,0,0,0,224,76,0,0,58,5,0,0,59,5,0,0,38,0,0,0,238,2,0,0,239,2,0,0,10,2,0,0,8,0,0,0,27,3,0,0,100,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,78,0,0,0,31,2,0,0,32,2,0,0,33,2,0,0,101,0,0,0,28,3,0,0,56,2,0,0,29,3,0,0,57,2,0,0,30,3,0,0,58,2,0,0,31,3,0,0,59,2,0,0,0,0,0,0,120,218,117,60,45,46,196,60,242,29,1,61,60,13,29,61,238,237,54,61,1,78,79,61,100,132,102,61,98,203,124,61,25,38,137,61,199,146,147,61,94,183,157,61,78,157,167,61,224,75,177,61,82,201,186,61,186,26,196,61,86,68,205,61,212,73,214,61,207,46,223,61,98,245,231,61,44,160,240,61,68,49,249,61,99,213,0,62,33,7,5,62,165,46,9,62,119,76,13,62,162,97,17,62,105,110,21,62,17,115,25,62,164,112,29,62,35,103,33,62,88,87,37,62,255,64,41,62,36,37,45,62,201,3,49,62,47,221,52,62,154,177,56,62,145,129,60,62,18,77,64,62,31,20,68,62,128,215,71,62,53,151,75,62,63,83,79,62,225,11,83,62,93,193,86,62,180,115,90,62,108,35,94,62,66,208,97,62,120,122,101,62,83,34,105,62,210,199,108,62,244,106,112,62,65,12,116,62,117,171,119,62,212,72,123,62,92,228,126,62,41,63,129,62,124,11,131,62,228,214,132,62,165,161,134,62,223,107,136,62,114,53,138,62,93,254,139,62,227,198,141,62,193,142,143,62,92,86,145,62,113,29,147,62,33,228,148,62,143,170,150,62,151,112,152,62,126,54,154,62,1,252,155,62,64,193,157,62,127,134,159,62,90,75,161,62,52,16,163,62,237,212,164,62,133,153,166,62,28,94,168,62,180,34,170,62,75,231,171,62,193,171,173,62,88,112,175,62,17,53,177,62,202,249,178,62,165,190,180,62,161,131,182,62,191,72,184,62,31,14,186,62,162,211,187,62,70,153,189,62,78,95,191,62,120,37,193,62,230,235,194,62,183,178,196,62,204,121,198,62,70,65,200,62,3,9,202,62,36,209,203,62,170,153,205,62,149,98,207,62,6,44,209,62,220,245,210,62,22,192,212,62,215,138,214,62,252,85,216,62,201,33,218,62,28,238,219,62,212,186,221,62,51,136,223,62,59,86,225,62,200,36,227,62,220,243,228,62,185,195,230,62,29,148,232,62,40,101,234,62,219,54,236,62,87,9,238,62,123,220,239,62,104,176,241,62,253,132,243,62,92,90,245,62,131,48,247,62,83,7,249,62,13,223,250,62,145,183,252,62,0,145,254,62,156,53,0,63,28,35,1,63,18,17,2,63,126,255,2,63,95,238,3,63,181,221,4,63,129,205,5,63,211,189,6,63,155,174,7,63,216,159,8,63,155,145,9,63,228,131,10,63,180,118,11,63,249,105,12,63,213,93,13,63,55,82,14,63,48,71,15,63,159,60,16,63,181,50,17,63,82,41,18,63,134,32,19,63,97,24,20,63,195,16,21,63,187,9,22,63,92,3,23,63,147,253,23,63,114,248,24,63,249,243,25,63,40,240,26,63,238,236,27,63,108,234,28,63,146,232,29,63,96,231,30,63,230,230,31,63,20,231,32,63,12,232,33,63,171,233,34,63,3,236,35,63,36,239,36,63,254,242,37,63,144,247,38,63,235,252,39,63,16,3,41,63,255,9,42,63,165,17,43,63,38,26,44,63,129,35,45,63,165,45,46,63,147,56,47,63,91,68,48,63,13,81,49,63,137,94,50,63,240,108,51,63,49,124,52,63,76,140,53,63,98,157,54,63,83,175,55,63,64,194,56,63,6,214,57,63,200,234,58,63,134,0,60,63,64,23,61,63,228,46,62,63,132,71,63,63,49,97,64,63,217,123,65,63,141,151,66,63,78,180,67,63,28,210,68,63,246,240,69,63,220,16,71,63,223,49,72,63,0,84,73,63,62,119,74,63,153,155,75,63,18,193,76,63,201,231,77,63,140,15,79,63,143,56,80,63,191,98,81,63,46,142,82,63,203,186,83,63,184,232,84,63,211,23,86,63,61,72,87,63,230,121,88,63,239,172,89,63,55,225,90,63,223,22,92,63,215,77,93,63,47,134,94,63,232,191,95,63,18,251,96,63,155,55,98,63,151,117,99,63,3,181,100,63,241,245,101,63,97,56,103,63,66,124,104,63,181,193,105,63,171,8,107,63,51,81,108,63,95,155,109,63,29,231,110,63,127,52,112,63,132,131,113,63,44,212,114,63,137,38,116,63,171,122,117,63,129,208,118,63,11,40,120,63,107,129,121,63,160,220,122,63,155,57,124,63,124,152,125,63,51,249,126,63,224,45,128,63,34,224,128,63,96,147,129,63,153,71,130,63,34,253,130,63,83,179,131,63,127,106,132,63,251,34,133,63,114,220,133,63,230,150,134,63,168,82,135,63,19,15,136,63,33,205,136,63,42,140,137,63,48,76,138,63,132,13,139,63,213,207,139,63,201,147,140,63,184,88,141,63,247,30,142,63,50,230,142,63,16,175,143,63,62,121,144,63,103,68,145,63,52,17,146,63,80,223,146,63,188,174,147,63,204,127,148,63,215,81,149,63,217,37,150,63,43,251,150,63,204,209,151,63,17,170,152,63,249,131,153,63,49,95,154,63,96,60,155,63,51,27,156,63,85,251,156,63,110,221,157,63,43,193,158,63,139,166,159,63,227,141,160,63,222,118,161,63,208,97,162,63,186,78,163,63,71,61,164,63,31,46,165,63,155,32,166,63,98,21,167,63,32,12,168,63,213,4,169,63,214,255,169,63,34,253,170,63,101,252,171,63,244,253,172,63,205,1,174,63,70,8,175,63,182,16,176,63,25,28,177,63,116,41,178,63,193,57,179,63,173,76,180,63,229,97,181,63,99,122,182,63,45,149,183,63,234,178,184,63,153,211,185,63,144,247,186,63,38,30,188,63,2,72,189,63,37,117,190,63,60,165,191,63,237,216,192,63,228,15,194,63,119,74,195,63,81,136,196,63,25,202,197,63,208,15,199,63,33,89,200,63,97,166,201,63,144,247,202,63,85,77,204,63,9,167,205,63,83,5,207,63,224,103,208,63,87,207,209,63,100,59,211,63,176,172,212,63,146,34,214,63,6,158,215,63,184,30,217,63,169,164,218,63,127,48,220,63,59,194,221,63,50,90,223,63,14,248,224,63,203,156,226,63,195,71,228,63,240,249,229,63,83,179,231,63,235,115,233,63,12,60,235,63,95,12,237,63,143,228,238,63,151,197,240,63,121,175,242,63,135,162,244,63,107,159,246,63,34,166,248,63,2,183,250,63,7,211,252,63,47,250,254,63,188,150,0,64,112,182,1,64,135,220,2,64,171,9,4,64,176,61,5,64,62,121,6,64,169,188,7,64,112,8,9,64,230,92,10,64,136,186,11,64,255,33,13,64,201,147,14,64,140,16,16,64,242,152,17,64,161,45,19,64,192,207,20,64,246,127,22,64,62,63,24,64,19,15,26,64,111,240,27,64,205,228,29,64,208,237,31,64,69,13,34,64,78,69,36,64,95,152,38,64,238,8,41,64,107,154,43,64,156,80,46,64,194,47,49,64,29,61,52,64,57,127,55,64,160,253,58,64,253,193,62,64,111,216,66,64,177,80,71,64,20,63,76,64,114,191,81,64,161,248,87,64,79,35,95,64,120,151,103,64,146,232,113,64,179,41,127,64,25,226,136,64,133,177,152,64,63,85,5,67,0,0,0,0,240,76,0,0,5,0,0,0,60,5,0,0,61,5,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,255,255,255,255,253,255,255,255,254,255,255,255,254,255,255,255,253,255,255,255,255,255,255,255,253,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,1,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,254,255,255,255,254,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,254,255,255,255,1,0,0,0,255,255,255,255,2,0,0,0,0,0,0,0,0,77,0,0,57,0,0,0,62,5,0,0,32,3,0,0,0,0,0,0,16,77,0,0,57,0,0,0,63,5,0,0,33,3,0,0,0,0,0,0,32,77,0,0,57,0,0,0,64,5,0,0,34,3,0,0,0,0,0,0,48,77,0,0,57,0,0,0,65,5,0,0,35,3,0,0,0,0,0,0,64,77,0,0,66,5,0,0,67,5,0,0,145,0,0,0,36,3,0,0,60,2,0,0,146,0,0,0,147,0,0,0,37,3,0,0,68,5,0,0,1,0,0,0,43,1,0,0,154,0,0,0,69,5,0,0,0,0,0,0,72,77,0,0,5,0,0,0,70,5,0,0,71,5,0,0,0,0,0,0,88,77,0,0,72,5,0,0,73,5,0,0,148,0,0,0,38,3,0,0,61,2,0,0,146,0,0,0,149,0,0,0,37,3,0,0,68,5,0,0,2,0,0,0,43,1,0,0,155,0,0,0,74,5,0,0,0,0,0,0,104,77,0,0,5,0,0,0,75,5,0,0,76,5,0,0,0,0,0,0,136,77,0,0,5,0,0,0,77,5,0,0,78,5,0,0,0,0,0,0,120,77,0,0,5,0,0,0,79,5,0,0,80,5,0,0,0,0,0,0,152,77,0,0,81,5,0,0,82,5,0,0,150,0,0,0,39,3,0,0,62,2,0,0,146,0,0,0,151,0,0,0,37,3,0,0,68,5,0,0,1,0,0,0,44,1,0,0,156,0,0,0,83,5,0,0,0,0,0,0,168,77,0,0,5,0,0,0,84,5,0,0,85,5,0,0,0,0,0,0,200,77,0,0,5,0,0,0,86,5,0,0,87,5,0,0,0,0,0,0,184,77,0,0,5,0,0,0,88,5,0,0,89,5,0,0,0,0,0,0,216,77,0,0,90,5,0,0,91,5,0,0,38,0,0,0,6,0,0,0,40,3,0,0,63,2,0,0,8,0,0,0,9,0,0,0,45,1,0,0,1,0,0,0,1,0,0,0,1,0,0,0,64,2,0,0,41,3,0,0,65,2,0,0,66,2,0,0,42,3,0,0,43,3,0,0,0,0,0,0,232,77,0,0,92,5,0,0,93,5,0,0,44,3,0,0,0,0,0,0,248,77,0,0,5,0,0,0,94,5,0,0,95,5,0,0,0,0,0,0,24,78,0,0,5,0,0,0,96,5,0,0,97,5,0,0,0,0,0,0,72,78,0,0,5,0,0,0,98,5,0,0,99,5,0,0,0,0,0,0,40,78,0,0,57,0,0,0,100,5,0,0,45,3,0,0,0,0,0,0,56,78,0,0,101,5,0,0,102,5,0,0,46,3,0,0,0,0,0,0,88,78,0,0,103,5,0,0,104,5,0,0,62,0,0,0,47,3,0,0,0,0,0,0,96,78,0,0,105,5,0,0,106,5,0,0,48,3,0,0,46,1,0,0,157,0,0,0,152,0,0,0,158,0,0,0,49,3,0,0,82,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,83,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,104,78,0,0,107,5,0,0,108,5,0,0,50,3,0,0,0,0,0,0,120,78,0,0,109,5,0,0,110,5,0,0,51,3,0,0,64,11,8,0,60,133,91,61,105,191,22,190,2,153,98,189,108,247,79,61,246,123,236,61,167,217,46,189,62,226,61,61,57,250,95,189,212,151,168,61,35,124,213,61,136,247,187,188,168,158,53,60,147,226,97,60,59,62,229,61,79,209,79,60,24,169,174,61,149,54,129,189,240,173,5,62,38,231,165,61,19,100,85,189,154,195,48,189,193,79,191,61,81,255,225,61,15,146,155,189,76,255,97,189,6,230,54,189,19,114,241,60,66,152,58,61,65,71,105,187,217,33,160,61,168,84,158,61,18,154,161,61,195,227,126,61,40,89,184,61,26,104,18,189,208,217,11,61,93,138,104,61,160,134,67,189,86,118,25,61,50,58,16,189,138,114,142,61,23,168,29,189,94,104,44,60,232,56,142,60,25,146,222,61,48,45,179,61,33,25,88,59,61,96,223,61,226,18,162,61,158,217,212,61,161,93,171,60,17,114,237,61,236,252,6,62,68,84,202,61,23,168,91,61,71,37,138,189,4,202,229,187,53,239,171,59,152,142,4,61,71,172,102,60,194,224,180,60,128,219,207,60,177,72,58,61,179,120,147,61,81,51,0,61,72,128,128,189,73,155,172,60,190,51,119,61,192,222,176,61,41,126,148,59,40,174,179,60,10,56,189,60,116,18,100,61,159,175,216,188,243,55,54,61,22,115,232,60,125,210,183,61,99,190,54,61,182,208,183,61,13,229,153,61,235,252,188,60,210,50,213,61,174,108,130,61,189,113,115,61,27,55,150,59,51,211,85,61,176,184,136,61,249,46,171,61,189,118,137,61,18,84,134,61,23,254,32,189,43,17,22,188,31,148,113,189,77,185,230,60,254,31,78,61,63,222,138,61,58,89,10,61,73,193,31,186,241,14,147,188,138,157,252,188,195,101,85,188,236,125,243,188,194,56,1,60,97,108,16,189,197,25,36,187,177,214,86,61,86,124,241,61,186,143,177,188,134,15,89,61,120,255,135,61,224,151,84,61,44,140,7,188,73,121,248,60,160,75,111,61,138,106,131,187,176,213,204,187,146,37,112,61,119,248,201,188,55,50,99,61,112,131,168,189,36,39,148,189,151,19,62,61,38,88,86,188,162,78,205,188,91,3,254,60,230,26,63,189,56,17,60,189,116,168,241,60,104,54,119,61,163,225,183,60,11,39,139,188,123,102,42,60,181,84,57,60,104,252,93,61,38,131,174,188,138,4,49,189,99,32,22,189,106,144,56,60,4,134,213,188,109,139,182,188,10,201,184,188,45,97,12,189,146,1,254,187,175,193,125,189,2,158,6,60,249,75,195,61,243,245,23,189,179,46,142,189,24,75,21,62,111,40,95,189,111,107,168,188,104,105,107,61,83,226,227,60,227,242,144,189,143,26,84,189,14,150,213,189,104,26,230,189,217,49,154,61,131,208,154,189,209,243,179,189,185,111,244,60,80,135,218,60,161,117,98,60,57,64,147,188,220,169,0,189,94,224,171,188,8,235,184,61,33,245,74,61,218,122,12,62,186,15,233,61,101,244,235,58,184,127,59,189,210,161,145,186,226,244,193,189,219,124,237,189,42,226,55,61,158,41,146,60,0,25,73,59,8,208,220,61,17,135,92,59,89,14,222,189,116,78,152,189,28,194,215,189,189,237,152,188,204,110,36,62,200,60,166,187,61,243,47,189,202,125,193,187,233,129,16,60,28,142,116,188,208,255,77,189,89,217,3,190,106,97,102,58,215,135,84,188,1,128,155,189,113,161,218,188,73,223,53,186,30,40,197,60,193,68,145,188,107,238,29,189,202,193,112,189,97,132,5,61,31,88,3,62,75,223,128,61,220,150,134,187,126,53,225,61,178,101,90,60,243,27,171,60,76,96,37,61,199,110,85,189,253,236,158,61,2,15,131,61,92,153,107,189,249,226,205,189,239,179,153,61,123,74,175,188,138,36,147,60,241,157,25,59,108,95,44,189,172,161,150,61,165,159,80,61,8,127,245,188,80,201,181,188,47,111,9,61,222,253,52,61,239,149,100,189,200,86,78,189,29,75,58,189,3,5,98,60,215,46,176,60,241,191,179,188,98,28,12,190,99,216,95,61,236,187,131,60,30,118,89,61,202,141,64,61,14,59,175,58,76,38,155,61,83,32,197,61,91,64,18,60,75,241,230,188,124,141,222,61,240,223,12,189,115,64,145,189,175,244,117,189,3,49,222,188,170,210,231,187,204,26,134,188,9,5,91,60,0,57,211,189,62,249,72,61,11,205,106,189,225,186,223,188,129,194,42,60,31,209,170,189,196,255,22,61,150,50,122,61,19,184,88,60,108,240,159,189,218,156,26,61,128,206,11,189,179,182,121,189,82,135,44,189,151,121,163,189,154,29,165,186,201,124,249,188,70,150,74,188,33,71,129,189,72,46,68,61,41,128,60,189,237,165,175,61,225,134,206,60,245,200,244,60,31,62,211,61,235,150,144,61,87,41,57,61,213,80,53,189,215,158,6,62,92,193,171,61,190,82,177,60,183,30,11,187,54,254,22,189,187,250,169,188,8,224,28,189,217,197,122,188,68,87,220,60,92,11,243,61,96,138,119,189,42,38,228,188,72,150,67,189,89,213,71,61,77,17,130,61,130,37,15,61,56,107,112,60,98,133,154,58,149,99,51,61,37,124,5,59,6,37,34,189,204,191,47,188,243,237,210,59,41,121,245,60,165,5,12,189,158,150,160,188,6,191,71,188,65,50,143,187,232,217,208,188,80,201,216,60,71,188,133,188,198,217,211,59,117,21,158,188,68,221,156,59,59,66,75,61,108,5,28,61,82,205,148,61,81,218,107,61,10,65,25,189,209,13,135,60,217,125,10,188,194,181,35,61,121,163,167,189,56,45,216,60,30,238,36,189,252,215,224,188,243,196,38,189,122,192,137,58,108,51,66,189,54,229,137,189,176,156,14,60,246,156,179,188,44,104,177,58,100,109,250,188,51,193,243,188,35,145,236,188,252,92,70,188,196,198,69,189,68,173,185,189,146,45,204,189,8,32,22,189,47,208,104,186,104,207,139,189,1,224,152,188,144,150,20,189,225,187,102,188,164,137,153,60,106,13,170,188,14,75,187,61,11,76,17,189,87,13,93,61,130,253,43,61,177,78,85,60,134,159,10,189,127,229,249,189,178,229,139,61,117,49,24,189,46,155,28,60,251,179,165,59,0,206,103,61,179,11,128,59,78,18,230,60,113,5,98,189,43,7,24,189,28,74,232,188,237,15,53,189,255,18,41,188,37,75,154,60,174,47,11,188,255,231,192,189,243,249,79,188,8,196,174,188,56,181,208,189,104,167,160,189,188,172,31,59,151,56,134,187,165,6,69,60,150,36,132,189,30,246,216,189,120,233,201,188,8,51,180,188,110,151,151,189,7,55,149,61,11,168,104,58,251,116,35,60,132,188,10,60,96,203,24,61,232,252,237,188,39,93,18,61,43,247,51,189,111,14,246,189,149,28,2,61,197,227,52,187,231,175,221,61,50,132,80,61,228,98,88,187,43,223,81,189,107,104,165,59,165,0,104,189,167,106,196,187,228,205,90,189,239,28,72,188,205,145,83,60,117,125,34,60,184,12,248,187,157,171,125,189,24,41,19,187,50,210,162,60,37,98,165,188,235,219,142,189,254,50,135,189,252,45,9,189,174,122,182,189,15,24,10,189,115,177,151,189,246,40,184,188,197,79,124,189,250,6,54,59,138,109,106,189,171,76,68,189,216,250,153,61,188,183,53,59,95,133,44,61,61,254,253,60,138,52,88,61,209,251,33,61,34,82,246,188,111,196,29,189,239,192,228,188,27,140,235,188,138,226,122,60,187,39,179,60,189,1,163,188,9,73,36,59,72,25,210,189,39,6,68,189,79,133,236,188,238,90,124,59,143,58,54,60,246,219,7,60,159,140,69,189,163,119,56,189,173,22,24,189,74,29,143,189,182,83,225,189,208,109,48,187,112,252,242,58,179,134,114,189,31,16,122,189,139,56,173,189,89,115,57,189,253,100,105,58,21,164,112,189,22,8,48,187,199,89,130,188,205,194,20,61,5,0,97,61,193,130,149,61,246,80,181,59,145,20,131,61,235,93,151,60,233,213,188,187,124,132,3,189,14,81,139,59,101,31,63,60,93,224,189,186,112,160,184,60,101,234,9,189,14,4,143,61,17,99,138,187,47,184,17,188,66,174,162,189,26,251,84,61,62,110,120,61,206,78,41,61,103,201,188,58,61,78,196,189,56,101,34,189,239,88,45,61,233,101,143,60,16,211,55,189,19,243,248,187,80,193,164,60,123,110,63,61,128,140,184,61,53,41,161,189,98,203,63,189,30,21,80,189,188,222,130,187,88,252,90,189,134,226,49,60,190,109,19,189,123,93,145,189,177,120,17,61,202,147,219,60,159,49,14,61,67,171,146,60,117,26,96,61,59,159,29,60,249,66,2,189,4,53,112,61,133,236,190,60,131,201,133,60,43,15,102,189,142,211,209,189,97,7,170,189,135,83,149,61,54,152,161,188,176,153,214,188,22,153,203,188,210,139,61,189,234,26,195,58,108,220,97,61,187,55,80,188,101,167,159,188,242,135,130,61,213,228,76,61,10,144,246,188,45,143,15,60,136,176,202,188,247,122,97,189,76,28,228,58,8,140,8,189,151,218,121,60,180,223,238,61,156,119,173,186,83,87,135,189,66,242,104,61,66,193,52,186,2,82,52,189,81,138,193,61,13,246,44,189,251,149,91,189,120,199,145,60,51,212,209,60,12,211,226,189,57,209,15,188,138,36,52,188,125,150,212,189,54,60,254,60,151,128,172,188,7,249,150,189,42,207,82,61,46,181,216,61,249,126,176,189,225,235,236,188,37,242,50,60,255,1,21,62,205,2,19,187,127,78,110,189,198,92,151,189,14,134,105,61,159,121,4,62,211,64,76,189,46,137,208,61,56,249,77,61,246,40,0,62,164,231,187,61,143,44,131,61,199,151,121,60,151,192,193,61,171,32,122,61,20,24,18,190,105,193,239,188,237,70,226,60,137,73,177,60,15,67,123,186,12,81,45,189,236,16,202,189,3,10,49,61,189,132,112,61,253,50,70,189,22,107,129,61,41,50,200,60,214,188,19,189,126,205,25,60,209,183,47,61,190,84,40,188,146,13,167,61,92,57,179,61,88,20,7,190,209,179,5,60,12,236,109,188,32,226,241,60,238,27,20,61,2,14,9,187,145,12,184,60,189,21,197,61,162,194,192,61,159,152,239,188,21,14,160,189,234,121,180,188,26,193,4,187,110,92,51,60,202,79,108,188,240,136,232,60,216,89,243,61,9,208,238,59,167,226,211,189,142,218,154,61,130,232,167,188,78,140,145,59,116,214,131,60,123,108,72,189,107,94,179,189,234,119,251,187,98,128,181,61,111,199,121,61,40,120,134,61,250,46,240,59,154,192,17,61,134,177,30,189,61,252,203,188,239,171,138,189,39,142,203,61,131,170,46,188,4,151,98,60,198,71,149,189,93,214,244,59,227,134,217,61,219,209,235,188,36,66,195,60,39,33,6,189,78,16,175,60,231,44,29,61,7,201,200,60,103,255,47,189,141,43,237,188,134,53,90,61,117,153,117,60,129,191,76,61,234,125,4,62,115,88,192,61,249,208,47,61,180,151,9,189,89,117,139,189,79,115,56,60,228,13,49,62,216,133,12,189,112,27,128,189,194,135,148,188,129,42,240,61,136,252,122,189,60,185,177,189,209,124,12,189,35,229,63,61,88,37,167,61,188,242,16,61,86,59,150,60,33,223,231,61,236,154,5,61,106,175,69,189,163,142,143,60,136,41,147,188,96,80,214,189,215,75,88,187,13,124,112,57,66,195,110,60,224,187,174,188,64,59,213,188,132,196,33,188,204,14,47,61,188,77,172,188,236,183,163,189,165,55,214,60,217,252,172,188,52,164,142,189,132,195,9,190,1,136,140,189,64,171,199,187,87,253,168,61,59,223,31,62,27,145,33,59,59,143,17,60,90,27,42,189,100,85,168,60,89,47,88,61,156,243,252,188,234,208,230,60,116,188,14,62,22,125,156,61,109,150,20,189,48,255,246,188,158,138,37,189,122,239,94,188,250,16,127,189,179,80,224,188,228,8,11,62,166,3,28,62,227,228,92,189,48,226,228,189,70,182,176,60,230,214,59,60,222,166,87,189,181,17,135,189,97,54,225,188,59,234,241,61,239,55,50,62,122,95,123,189,234,89,225,189,24,115,93,188,131,6,143,188,126,170,175,189,101,22,55,189,66,27,122,189,139,67,216,61,208,15,85,62,39,231,187,189,236,5,58,58,117,156,18,61,251,195,147,61,79,1,182,60,135,186,149,60,238,143,1,188,108,12,116,60,52,175,20,62,220,153,131,189,54,249,244,60,210,42,236,186,88,160,101,188,131,217,42,189,163,212,114,187,77,44,186,189,245,251,194,61,251,39,181,61,75,59,217,188,106,33,247,188,110,234,209,60,82,249,17,61,98,97,28,189,134,216,106,60,93,228,184,60,185,72,235,60,40,40,36,60,72,175,129,189,124,179,49,61,162,101,143,61,18,191,64,189,39,228,149,189,174,124,215,60,141,121,254,60,118,40,136,61,126,128,223,61,171,152,133,188,149,105,238,60,214,42,237,60,22,170,164,61,66,187,142,61,180,55,139,61,108,112,199,59,1,130,136,59,193,209,182,61,166,227,255,188,42,50,221,60,66,124,63,60,2,169,133,188,207,16,151,59,155,124,11,60,226,43,17,189,18,79,18,61,100,211,140,59,130,99,161,188,52,37,16,188,135,197,196,61,93,1,125,60,13,183,32,189,10,174,149,61,240,68,120,61,106,20,10,57,220,199,2,188,38,140,196,60,113,55,121,189,224,189,224,188,5,71,96,189,240,55,41,189,191,206,17,61,42,75,250,60,47,61,244,60,243,43,24,62,53,188,144,60,132,70,241,60,192,161,72,61,59,64,40,60,190,84,230,60,94,79,169,61,108,209,223,60,155,200,74,188,22,217,240,61,133,187,27,61,73,145,7,189,163,4,172,59,162,144,201,188,210,123,220,60,250,46,93,61,194,136,207,189,20,198,130,61,84,238,148,188,54,25,185,60,9,91,18,61,55,220,42,60,148,31,42,189,59,154,37,189,68,164,134,60,197,135,170,61,200,229,241,57,105,107,89,189,101,210,174,189,139,10,211,186,127,64,177,188,154,23,146,188,58,23,30,61,162,14,174,61,103,84,141,188,135,164,176,61,236,45,225,61,73,245,187,61,208,11,174,61,161,153,156,61,206,147,100,61,32,167,220,60,157,188,204,61,163,194,185,61,84,139,136,61,244,142,112,61,170,36,184,188,89,45,159,61,241,31,254,61,212,82,1,62,134,185,92,186,182,30,114,60,48,184,187,61,128,143,67,187,206,110,132,189,150,136,144,189,199,177,91,57,113,15,181,60,130,217,176,188,232,45,176,189,124,44,187,188,213,175,131,59,62,189,28,60,121,230,169,188,242,218,61,189,11,217,248,187,13,172,97,188,88,192,58,189,38,9,8,190,36,151,177,189,28,175,21,189,102,63,59,60,9,172,6,61,196,239,51,189,152,157,123,61,9,92,53,62,168,176,212,61,12,196,89,60,100,47,206,61,52,254,254,61,178,93,55,189,147,83,185,61,109,250,59,61,255,183,228,61,110,223,175,61,187,71,67,61,8,35,219,58,163,80,193,60,181,2,28,189,86,13,0,61,244,52,157,188,125,109,105,189,254,191,193,188,129,130,133,189,134,89,101,189,86,90,145,189,2,62,7,189,95,75,65,189,38,59,210,188,176,239,88,60,78,11,189,189,219,6,98,189,246,9,65,189,86,123,10,189,108,157,137,189,179,248,65,60,248,2,191,189,96,149,134,60,163,59,27,61,85,200,216,187,132,171,159,61,235,104,148,61,160,197,64,61,79,184,206,188,27,1,139,188,25,64,165,189,114,6,119,61,29,152,215,61,165,104,135,189,121,231,243,60,195,199,214,60,115,200,156,60,76,168,173,189,174,123,129,189,142,246,10,190,37,143,156,189,187,174,24,60,229,201,165,189,98,218,208,189,40,40,85,189,217,135,103,60,158,192,159,189,224,109,154,188,201,202,153,189,138,151,207,189,129,127,85,189,138,167,203,189,240,30,175,186,148,229,129,189,70,39,43,189,242,105,253,189,200,14,232,188,128,29,120,189,183,204,110,61,87,188,155,61,145,90,132,189,22,121,3,60,53,41,237,61,79,144,252,61,91,19,162,60,121,129,50,187,149,165,111,61,124,119,63,189,88,221,82,61,97,15,44,187,253,119,230,61,145,159,202,61,18,102,200,61,218,215,62,189,57,159,52,188,67,104,143,189,51,11,253,60,118,43,210,188,125,28,157,189,62,10,80,59,171,216,220,189,194,149,189,188,53,29,227,189,227,229,39,188,178,67,255,60,247,91,75,189,87,237,186,60,210,57,180,59,61,154,172,189,37,97,22,190,192,25,158,189,1,161,8,190,108,93,57,189,3,11,203,189,79,20,212,60,7,26,14,61,203,9,63,61,199,95,239,61,129,147,197,61,57,94,222,61,249,91,109,188,59,30,48,61,100,130,138,189,212,169,174,58,94,193,18,62,91,31,155,61,80,185,187,61,233,113,104,61,132,242,231,61,185,73,53,188,167,238,168,60,163,53,235,189,96,112,153,189,148,164,234,188,35,0,81,188,54,65,142,189,192,225,206,189,39,125,40,189,94,111,181,188,0,185,80,188,206,50,153,189,14,48,216,189,210,25,156,189,242,143,204,189,190,147,234,189,6,70,247,189,40,198,192,189,180,92,146,189,231,18,38,189,31,247,122,189,172,229,44,61,219,115,157,61,209,231,39,61,56,173,1,62,181,92,22,62,47,215,94,62,101,66,0,62,214,189,60,62,95,27,218,186,103,212,27,59,158,211,108,60,229,190,15,61,8,121,217,60,160,162,140,60,151,30,92,61,206,47,241,60,254,233,231,61,138,96,115,188,10,0,132,188,166,53,243,186,223,246,139,188,0,166,94,189,143,44,89,189,16,119,87,61,231,193,18,189,243,194,179,185,194,91,178,58,153,179,53,189,83,50,45,189,212,102,6,61,187,126,96,189,178,217,208,189,168,149,147,189,21,250,219,189,117,230,193,188,208,128,210,61,2,21,52,187,214,207,4,189,76,38,189,60,124,80,232,60,131,241,211,61,188,128,72,62,38,246,209,61,98,168,164,61,162,83,98,61,89,176,7,190,141,104,19,190,38,131,77,59,3,188,10,189,40,149,18,60,170,111,93,61,155,246,162,187,14,211,66,188,205,84,148,57,202,206,31,189,165,166,72,189,70,81,177,60,72,147,98,188,9,150,151,188,12,35,153,60,123,181,200,188,249,187,187,60,18,221,167,61,252,138,7,61,174,179,217,189,242,169,202,60,8,232,90,61,203,0,197,188,16,220,4,189,75,241,181,187,115,11,164,189,63,82,230,60,249,126,45,61,36,74,152,60,124,202,72,61,169,164,107,188,219,40,122,188,224,117,167,60,155,39,77,189,192,214,45,61,214,227,155,61,113,197,74,61,8,154,118,189,167,153,139,187,183,124,6,62,12,185,107,188,41,119,160,188,2,166,37,189,5,119,254,189,146,90,58,59,87,141,78,189,217,206,186,189,99,161,240,59,153,72,192,61,161,171,241,61,252,194,154,59,39,157,145,59,246,135,163,189,199,4,20,189,168,242,55,61,42,8,184,188,150,188,63,61,132,170,86,61,228,183,176,60,121,142,60,189,201,68,68,188,19,46,225,188,195,122,11,62,18,121,180,61,52,201,159,189,26,103,159,59,5,250,130,188,140,216,39,60,156,221,13,189,101,195,188,188,153,6,178,189,10,76,136,61,139,252,108,61,254,112,1,190,50,7,189,60,30,69,150,61,243,30,154,61,29,127,74,61,228,149,183,188,180,90,204,189,104,91,20,62,116,144,134,189,89,225,160,189,15,218,231,60,23,213,10,186,102,71,63,189,112,33,242,189,174,206,250,189,40,88,29,190,27,59,243,188,10,113,165,61,119,94,10,62,237,162,235,61,143,45,66,61,140,114,97,60,236,188,111,189,98,244,123,188,216,246,98,189,107,17,204,60,191,44,235,188,232,45,226,60,27,21,116,62,114,214,100,62,145,19,211,61,219,179,141,189,17,129,207,189,190,212,78,190,26,118,78,189,48,19,139,62,156,95,189,62,225,216,176,62,108,248,148,62,118,105,103,61,125,253,40,61,114,184,153,61,149,72,224,188,19,48,10,188,144,230,150,61,75,124,135,60,145,146,192,189,55,21,196,189,45,142,113,60,49,254,145,189,117,192,13,189,255,68,234,61,158,211,12,62,41,198,130,189,88,60,129,189,89,70,6,60,55,7,238,61,163,133,165,59,84,180,155,189,139,32,137,61,222,180,131,62,160,24,185,61,42,151,147,62,65,208,6,62,204,154,89,189,74,20,175,188,107,254,12,189,198,29,128,189,249,186,31,61,250,82,60,62,139,52,133,62,204,55,10,61,199,104,152,60,191,90,67,62,198,246,57,62,73,52,97,59,239,197,248,188,231,141,73,62,231,34,181,62,97,173,127,62,237,255,3,189,174,86,148,62,17,161,220,62,207,149,157,62,20,78,191,60,5,74,202,189,137,138,224,187,210,50,183,61,18,237,166,189,211,194,228,60,166,5,126,62,205,139,49,62,43,65,127,61,187,167,213,189,175,135,42,190,128,37,7,190,7,186,174,189,39,87,69,190,197,156,10,190,89,189,99,62,230,205,200,62,41,46,136,62,26,203,73,188,163,125,38,60,138,2,9,62,175,34,246,61,231,198,70,189,208,26,162,189,247,24,144,61,37,25,126,59,53,244,122,189,94,193,25,190,253,154,233,189,222,60,175,189,26,39,152,189,203,5,37,190,223,79,7,62,49,138,131,62,61,97,105,61,46,136,140,61,59,143,197,187,94,46,2,188,38,151,68,61,242,29,137,61,206,216,157,188,219,53,126,61,242,188,9,62,106,177,130,189,53,138,67,187,153,169,14,189,104,17,247,59,113,144,31,61,191,201,234,61,213,205,136,60,59,161,7,60,29,124,245,187,143,223,239,189,238,31,218,189,38,12,212,189,255,142,76,189,207,179,72,186,253,180,247,60,144,240,66,189,27,143,149,189,174,151,110,189,148,184,6,190,235,230,217,189,97,151,70,190,211,66,204,189,226,45,162,189,166,214,242,57,153,96,45,186,247,87,34,62,87,85,175,61,243,224,156,189,19,39,164,189,253,122,124,189,128,56,154,60,83,87,63,186,250,25,140,61,201,112,29,61,129,157,79,62,55,147,97,62,146,100,172,187,138,247,109,60,241,171,129,189,191,180,234,60,122,101,104,61,13,70,249,61,235,43,29,61,198,161,17,61,91,37,218,188,116,137,210,189,135,168,133,189,141,163,226,189,58,21,184,189,95,236,206,189,243,203,4,60,62,12,195,59,151,113,214,60,1,188,139,188,173,48,223,189,53,241,163,189,181,217,230,189,54,93,125,189,15,2,122,189,97,212,130,60,131,161,114,189,79,187,192,61,93,18,106,62,5,171,5,61,249,181,138,61,91,100,184,189,144,196,38,60,111,62,158,60,113,181,176,61,237,74,106,188,118,91,224,61,140,28,42,62,23,112,199,188,148,148,7,189,65,136,45,189,104,163,70,60,213,137,201,187,1,108,142,61,17,3,247,60,45,120,146,60,201,223,227,60,234,200,99,189,53,215,18,188,215,161,75,189,133,207,153,61,93,110,145,60,12,64,113,61,170,117,163,189,79,104,21,61,211,254,116,187,48,41,182,189,194,172,131,189,1,61,165,189,23,34,18,61,226,15,146,189,52,142,236,187,228,236,195,189,80,39,55,62,49,178,24,62,184,147,169,60,81,128,77,189,112,127,76,189,73,160,128,60,180,228,202,189,12,57,132,61,98,249,28,62,131,185,64,62,138,104,239,61,107,22,65,188,13,73,182,188,106,21,156,188,203,90,210,61,158,59,238,187,45,226,238,61,49,133,23,62,26,43,159,61,236,155,196,60,132,158,91,189,118,158,161,188,12,121,97,60,57,9,138,61,221,163,133,189,84,139,106,61,27,4,197,188,213,140,15,190,162,251,169,188,222,80,61,189,209,11,64,189,199,230,150,188,85,41,158,61,43,198,70,189,19,131,122,60,194,27,73,190,158,136,221,61,122,122,27,61,167,59,193,189,35,133,163,189,241,149,10,189,25,242,226,61,247,72,183,60,211,20,2,62,134,83,93,62,118,27,239,60,136,218,152,59,190,106,210,189,65,211,70,189,117,244,98,187,206,50,177,61,88,114,184,60,170,88,197,61,81,238,47,62,5,230,189,189,85,189,240,57,137,22,240,189],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+133120);allocate([38,16,250,189,240,52,31,190,21,212,147,61,241,255,88,189,139,211,26,61,215,250,82,61,28,190,27,189,168,138,30,61,203,42,28,190,179,26,178,189,48,155,165,188,18,182,40,61,38,108,27,190,168,61,129,60,219,231,209,61,19,198,245,59,228,12,141,60,138,219,139,189,60,105,196,188,165,37,135,189,62,217,48,189,185,43,165,189,49,113,218,59,29,138,8,61,0,71,145,61,123,146,168,61,40,183,134,189,60,49,137,189,96,8,143,189,201,72,133,189,129,216,16,190,220,13,196,188,170,209,132,61,193,182,16,60,77,118,189,61,123,199,154,189,173,146,79,189,169,173,200,189,97,72,137,189,187,239,15,190,183,244,4,61,239,141,0,62,223,79,144,60,38,235,4,62,89,50,39,189,127,218,243,189,110,175,23,190,227,142,171,189,181,222,249,189,104,80,76,61,90,45,94,61,124,27,128,187,214,90,5,61,12,59,2,190,182,207,152,189,102,162,105,189,134,58,142,188,160,97,164,189,130,146,94,189,146,217,140,188,147,113,236,60,58,55,145,60,58,171,187,189,34,123,106,59,86,118,207,189,119,101,217,188,8,136,166,189,15,157,29,189,135,203,71,186,184,216,132,61,150,122,73,62,23,125,73,189,43,146,144,189,145,249,70,189,182,200,42,188,33,146,170,189,12,237,21,61,61,108,23,189,117,138,75,61,108,199,168,61,243,38,0,190,233,200,122,189,184,155,25,189,189,248,213,59,232,220,209,189,31,102,210,60,44,10,148,59,59,244,24,189,167,88,57,188,182,173,93,189,247,34,105,58,235,185,253,189,33,23,116,189,70,85,254,189,167,248,123,189,209,182,149,189,138,3,200,60,132,215,143,61,198,150,154,189,87,123,70,186,143,147,185,189,92,39,166,189,85,186,141,189,50,94,28,60,102,222,71,188,138,244,158,58,238,166,17,188,171,44,170,189,28,122,58,189,234,243,219,189,209,26,105,189,127,159,14,190,104,227,184,61,75,220,26,62,134,22,2,61,39,230,53,62,53,248,172,57,118,5,83,61,76,155,201,189,203,13,194,189,5,138,175,189,82,80,38,62,54,0,70,62,64,124,12,60,165,0,235,61,34,196,116,188,62,80,9,61,236,160,183,189,95,62,190,188,18,51,218,60,73,46,95,61,232,222,16,189,152,171,147,189,189,105,139,189,35,185,255,188,206,253,114,189,251,249,48,190,108,139,34,190,100,3,75,189,65,89,131,60,7,170,253,189,226,29,14,62,65,213,91,62,218,87,10,62,106,246,86,62,224,41,181,61,94,248,165,61,99,197,25,61,45,78,249,61,75,100,227,61,157,248,217,61,191,194,14,62,35,101,238,61,213,106,23,62,155,152,71,60,130,45,62,60,217,82,17,61,132,27,180,61,200,226,138,188,154,137,157,189,48,173,168,189,238,142,222,59,115,100,201,188,188,90,5,62,63,82,224,61,31,227,201,61,211,251,65,61,188,81,50,189,30,96,27,190,108,87,55,190,1,6,214,189,235,102,9,190,137,216,135,189,219,219,1,189,14,16,140,189,89,115,232,189,209,7,143,189,93,106,67,62,42,68,52,62,199,82,158,61,142,67,205,61,13,131,186,62,202,218,144,62,120,238,1,62,23,63,35,62,170,5,16,62,249,105,229,189,46,11,15,190,178,31,186,189,199,116,16,190,142,155,81,61,122,150,44,187,216,18,221,189,247,248,198,189,0,121,88,189,112,66,128,60,245,19,78,61,218,202,143,61,51,187,242,188,214,191,144,60,76,172,170,61,200,137,3,189,76,152,160,59,56,114,84,61,99,172,78,189,128,29,197,189,255,237,206,188,68,167,141,61,84,227,70,60,252,121,90,61,104,9,13,189,236,239,205,189,144,215,128,189,180,225,177,59,115,142,206,187,189,250,185,60,58,251,144,188,27,23,6,61,194,163,158,61,209,163,254,59,88,126,78,61,58,3,135,60,25,46,190,188,198,94,203,189,150,233,187,188,213,180,166,60,205,122,170,189,63,73,174,61,159,229,24,189,88,105,132,189,65,82,121,189,159,22,12,62,160,228,234,189,199,152,31,189,229,72,146,189,175,92,47,59,79,20,21,189,113,181,201,189,213,146,225,189,192,22,51,62,241,85,52,62,20,199,36,190,21,117,148,189,84,97,128,60,215,32,115,62,137,171,154,61,176,106,128,189,189,146,149,189,149,67,130,62,129,22,45,62,187,75,167,189,178,59,114,189,180,245,33,189,151,103,223,59,227,0,102,189,242,144,149,189,79,95,249,189,163,165,253,61,25,37,98,62,186,12,99,189,99,152,7,189,28,196,106,61,155,126,71,62,82,131,36,61,214,185,132,189,181,255,252,189,152,212,63,62,77,63,197,189,182,54,229,189,195,11,254,61,140,122,32,62,201,46,69,62,106,36,223,61,55,234,10,61,158,114,5,190,101,122,102,189,45,216,184,189,9,125,112,62,46,102,142,62,163,213,136,62,60,154,148,61,131,160,41,62,8,66,101,62,158,100,152,61,116,18,87,190,9,98,165,189,81,237,25,190,30,217,143,61,206,168,222,61,57,236,57,62,117,46,77,62,25,250,10,62,126,8,244,189,167,251,227,189,147,79,65,190,2,209,120,61,83,186,82,62,113,56,254,61,53,251,32,61,150,97,149,62,212,13,151,62,183,159,142,62,65,192,147,188,128,117,42,62,190,78,69,62,49,180,155,60,51,214,118,61,40,148,26,59,154,75,127,60,186,198,221,60,199,31,233,61,199,227,247,61,137,11,32,61,44,242,61,61,255,191,184,61,177,29,244,61,129,230,109,187,6,224,181,60,196,178,211,61,235,174,49,62,76,20,251,61,185,99,66,62,63,37,33,62,86,44,62,60,8,129,138,188,147,43,126,186,40,189,147,61,149,81,62,60,168,239,54,62,247,188,122,62,199,117,58,62,24,158,78,62,127,162,116,61,86,118,18,188,17,206,189,188,181,212,19,62,79,136,16,62,91,35,98,61,28,31,130,61,213,214,67,190,205,96,208,61,185,154,150,62,23,106,135,62,129,98,191,61,47,130,28,62,250,185,74,62,117,218,232,61,239,71,2,190,75,25,91,190,190,131,164,188,101,124,134,189,208,41,136,188,120,66,33,189,143,184,67,61,238,129,77,61,211,86,188,188,92,239,78,190,237,252,130,189,208,130,12,62,52,219,102,62,239,116,24,62,151,233,177,61,232,176,138,62,218,229,164,62,231,86,200,61,146,173,61,190,33,117,48,190,250,164,42,188,201,49,36,61,17,5,44,61,72,129,165,189,113,210,25,189,203,0,69,189,125,229,85,189,94,77,94,190,72,163,135,189,5,71,241,60,15,111,60,189,246,73,87,189,231,180,172,189,252,80,233,60,55,249,14,61,233,194,7,60,91,84,226,189,209,151,229,189,40,179,163,188,75,238,91,189,164,164,181,189,199,129,64,190,221,174,94,189,203,70,77,189,215,253,93,189,229,250,123,189,226,192,221,189,210,10,50,61,175,127,36,61,208,43,121,60,60,79,249,189,127,229,71,189,81,116,52,188,154,39,5,61,182,38,118,189,197,141,252,188,115,4,188,188,143,109,140,189,148,183,179,189,241,164,115,190,4,229,187,189,132,217,98,189,75,253,48,189,240,49,243,189,62,237,44,189,120,165,120,189,128,180,67,60,147,177,213,60,12,108,31,189,96,155,134,188,156,40,213,188,119,227,85,188,58,145,32,61,125,105,133,189,94,162,56,60,50,176,205,187,133,211,222,188,79,4,228,189,120,46,7,61,155,123,196,60,99,26,39,61,34,92,216,189,182,95,116,61,52,211,67,60,219,58,2,189,47,168,138,188,92,11,125,189,166,220,150,60,202,147,180,187,178,181,139,189,95,189,2,189,201,125,195,189,61,67,248,60,224,139,72,189,24,196,238,188,125,5,8,190,201,237,67,189,14,45,199,59,8,126,109,188,192,201,8,190,214,103,198,189,132,129,230,188,204,209,70,60,54,49,136,61,86,10,167,188,121,196,8,62,28,52,117,61,245,139,21,188,16,79,64,190,231,156,245,189,150,227,129,189,101,114,73,60,26,75,146,61,5,103,219,61,86,9,227,61,122,137,134,61,46,48,242,188,222,202,38,190,64,75,15,190,2,196,83,188,14,0,29,61,130,253,186,61,69,85,80,189,247,21,102,61,132,155,31,189,103,169,128,189,190,80,235,189,130,16,18,190,186,145,57,189,116,236,130,60,169,193,187,61,156,108,177,61,216,25,72,61,11,41,107,189,107,242,154,189,54,122,47,190,67,149,214,188,153,246,202,188,3,131,219,60,128,4,238,61,123,252,179,61,109,238,30,62,51,231,64,61,237,128,56,61,42,47,209,189,173,196,251,189,23,115,69,189,167,168,96,189,121,52,96,61,136,116,150,61,253,113,100,61,220,35,168,189,237,215,13,61,61,167,86,190,192,247,190,189,118,178,120,59,162,45,20,61,56,113,43,62,207,140,144,61,97,255,208,61,47,43,139,189,20,142,83,59,30,234,0,190,59,43,51,190,103,65,170,60,107,148,157,189,155,138,249,61,13,67,184,61,118,87,68,61,177,33,233,189,24,202,164,189,146,171,131,190,132,127,165,189,57,14,223,59,109,12,240,188,40,216,71,187,237,116,227,189,29,153,61,189,248,47,160,189,250,90,252,59,126,223,209,189,50,167,158,58,35,173,82,62,103,192,4,189,210,28,10,60,79,116,159,60,161,70,68,188,136,76,21,190,169,104,45,61,243,176,135,187,230,159,140,189,216,55,199,188,211,137,10,190,58,2,165,58,124,252,233,189,13,71,48,189,217,214,138,188,192,76,106,61,113,64,36,190,216,39,227,60,83,54,97,61,77,181,25,190,187,181,109,60,109,137,192,60,76,43,48,189,104,211,74,189,26,59,94,62,36,102,1,189,115,213,160,188,202,179,58,62,54,176,5,189,100,14,61,187,151,13,130,60,146,173,254,186,98,135,159,189,20,116,63,61,38,253,204,187,191,205,182,61,145,169,90,62,248,144,77,60,9,92,143,189,123,242,114,189,52,93,154,188,137,98,48,189,61,139,241,61,236,101,29,61,46,8,32,189,240,218,102,61,3,2,200,189,20,92,172,188,43,252,14,60,121,52,224,188,20,102,81,189,33,12,46,62,78,35,242,60,168,138,171,60,48,83,172,61,0,162,8,189,201,43,20,189,229,231,109,189,92,179,181,189,109,214,239,60,119,163,138,62,32,214,120,61,160,39,153,61,6,127,28,62,28,23,32,189,16,248,80,189,177,249,27,188,197,9,6,189,213,231,178,189,54,85,156,61,187,39,147,189,26,188,13,62,196,0,160,61,97,28,4,190,7,208,96,189,177,51,103,189,134,201,6,189,87,16,229,189,16,170,25,61,122,221,116,189,3,128,187,189,63,185,103,61,82,72,49,189,202,175,249,188,46,135,103,188,249,129,208,189,182,193,98,188,59,40,78,62,32,205,123,188,187,125,156,189,14,241,113,61,61,108,160,189,217,168,121,188,71,167,153,189,135,199,193,189,74,188,25,190,219,91,36,62,5,194,184,61,41,136,173,61,149,179,10,61,103,86,187,189,115,208,187,189,155,12,174,189,145,174,81,189,177,160,213,189,160,168,42,60,226,19,251,188,156,73,191,61,212,16,132,61,205,247,30,189,22,52,76,189,161,125,23,190,32,255,84,189,82,173,175,188,166,223,35,61,201,96,254,61,240,175,151,188,16,159,40,189,88,197,244,189,94,216,71,189,25,163,178,189,39,39,173,189,2,12,216,189,195,112,230,61,168,126,220,61,217,160,68,62,80,10,123,61,8,5,224,188,113,240,180,189,6,20,46,190,32,87,17,189,175,170,175,187,45,241,169,61,8,255,147,61,211,206,43,61,150,58,63,61,31,46,15,60,8,244,142,61,140,134,103,61,115,210,112,61,13,236,202,60,17,210,200,60,65,164,254,61,163,98,101,61,105,8,141,61,74,59,30,61,239,194,152,61,112,122,185,60,132,4,117,60,252,237,129,61,228,60,142,61,97,46,240,60,65,3,240,61,131,113,57,61,195,11,5,61,40,126,8,59,234,126,167,60,234,138,233,61,148,73,48,61,150,252,131,61,35,31,75,61,203,103,167,61,130,61,189,61,3,124,72,61,131,143,184,60,17,96,135,188,204,97,155,61,66,100,120,61,156,228,14,62,128,38,227,60,244,67,145,61,248,26,174,61,222,94,139,60,16,118,185,61,37,30,171,62,37,122,78,62,123,34,201,61,19,216,162,61,121,19,178,61,160,163,2,190,212,252,13,190,203,95,135,189,177,251,224,189,14,139,11,61,135,230,54,188,112,33,149,189,218,128,10,190,168,135,3,190,139,108,183,61,167,213,187,61,207,176,206,61,88,119,111,62,25,150,176,62,173,201,202,61,82,20,164,60,30,164,252,61,87,198,155,61,179,145,24,190,57,25,32,190,129,2,133,189,89,57,144,188,110,112,11,61,50,66,7,190,250,212,247,189,33,86,59,190,232,148,41,190,110,231,178,60,123,126,225,188,191,146,148,60,234,230,163,60,160,65,88,60,152,117,164,61,243,248,71,60,66,115,67,59,125,38,86,188,26,139,116,61,93,241,90,189,167,134,10,189,150,204,33,188,95,175,140,189,82,17,34,61,45,159,254,188,220,208,106,189,61,246,177,60,76,98,42,61,212,55,44,59,93,38,69,61,6,172,191,61,185,21,6,188,240,70,141,60,103,176,208,188,202,117,75,189,209,209,195,188,94,255,135,61,146,40,129,189,247,94,58,60,224,240,100,61,187,181,168,189,26,29,201,60,187,160,250,188,162,96,183,189,148,81,140,61,182,65,147,61,130,222,155,189,39,251,0,60,34,192,0,188,117,11,118,61,102,154,56,188,187,67,59,187,110,127,67,189,36,106,154,60,244,168,25,62,173,98,128,189,221,241,162,188,234,131,58,60,254,105,179,61,86,226,30,61,218,107,30,188,254,26,164,189,190,94,131,61,68,78,95,188,115,24,187,189,90,200,143,60,249,168,54,61,154,166,197,61,31,207,85,61,16,208,15,187,18,35,144,189,152,254,130,188,143,45,6,62,172,49,204,188,222,43,41,188,195,214,237,188,65,224,55,61,152,221,82,61,182,56,152,60,166,36,239,188,55,248,169,61,103,5,60,189,59,60,33,190,121,183,185,189,220,128,243,188,114,247,4,62,208,143,100,62,39,113,120,62,244,51,21,61,5,139,97,189,119,64,47,59,189,10,29,189,142,21,132,61,124,19,29,61,13,88,28,61,121,51,128,62,96,42,175,62,189,15,166,62,125,195,64,62,237,31,176,189,203,55,52,190,163,216,28,190,123,5,203,189,44,248,233,188,205,71,89,189,157,130,139,186,59,6,136,189,89,202,153,189,207,193,111,60,205,169,154,189,176,190,56,189,239,97,10,188,57,45,145,60,137,162,38,61,238,210,79,62,150,247,32,62,190,247,105,61,0,164,134,62,108,24,22,62,46,131,125,60,50,246,78,189,210,250,30,189,47,149,107,188,167,240,73,189,74,4,240,61,142,196,118,62,236,132,135,62,246,75,162,62,1,236,206,61,77,161,51,188,174,248,95,188,184,37,47,62,4,120,77,62,154,99,47,59,165,249,66,188,145,104,59,62,112,188,193,61,60,52,130,189,93,149,132,189,145,193,97,60,163,120,205,189,102,215,130,189,93,75,121,59,114,51,126,61,50,243,211,61,251,60,137,62,255,1,6,60,117,151,189,188,130,24,25,60,2,98,188,61,128,201,22,61,75,190,15,188,230,226,197,189,134,120,222,188,169,70,10,62,130,142,183,61,39,79,215,187,1,31,3,189,181,249,145,62,127,84,164,62,235,145,61,62,87,185,17,190,111,219,15,190,176,18,147,189,214,159,175,189,38,100,177,189,53,87,50,190,1,190,69,58,215,113,101,61,74,29,11,62,244,45,75,189,45,222,157,189,188,166,218,61,120,136,52,189,85,164,147,189,74,16,22,61,115,56,148,62,36,146,210,62,149,114,140,62,151,81,141,189,77,229,91,190,115,134,31,190,135,63,72,190,28,191,27,190,244,202,230,189,55,225,151,61,162,120,66,62,139,131,137,62,215,237,159,60,190,198,38,60,49,239,176,60,124,65,162,187,144,235,50,189,25,69,2,190,193,174,136,189,200,234,230,189,243,197,52,61,215,124,100,61,155,156,31,61,152,20,18,61,116,130,112,189,223,78,151,189,165,247,55,190,227,132,175,189,220,101,28,190,149,172,118,189,92,91,143,189,64,81,223,187,15,232,128,61,177,173,43,186,46,235,56,188,150,145,187,188,126,160,70,61,122,155,41,61,200,128,114,62,196,242,20,62,151,4,163,60,206,109,246,61,133,237,125,59,142,117,197,187,87,121,114,189,89,68,251,188,97,126,159,189,44,229,221,61,254,110,176,60,221,143,226,60,151,214,34,61,132,129,249,189,105,181,72,189,192,146,203,189,130,43,132,189,183,223,12,190,133,109,24,189,95,158,231,60,39,58,50,189,124,57,156,60,104,158,210,189,108,74,104,189,200,96,220,189,134,25,197,189,70,231,195,189,54,151,85,188,150,91,252,60,199,20,104,60,62,117,111,61,193,235,177,187,231,212,126,61,34,0,8,189,148,24,139,189,159,54,109,189,24,153,3,62,75,128,25,62,44,221,20,61,76,13,18,62,113,95,49,61,80,34,78,61,230,174,102,189,34,147,131,60,94,179,51,61,16,208,100,62,242,255,32,62,66,64,64,189,136,76,246,60,171,186,37,187,154,49,106,61,112,53,154,189,56,91,233,188,18,172,140,189,205,5,148,187,175,108,132,61,243,28,115,189,0,182,64,189,90,208,150,189,35,97,70,61,84,111,9,190,86,124,200,189,38,7,210,189,119,195,15,61,138,159,66,61,246,143,28,189,26,124,199,61,203,22,67,61,109,99,33,61,34,164,169,189,13,165,195,61,2,99,78,61,52,176,89,62,5,146,197,61,95,194,4,61,70,171,83,61,70,3,61,61,73,92,49,61,140,224,218,188,244,51,128,189,77,146,188,188,138,207,64,62,180,129,215,61,19,171,48,61,82,226,136,60,36,123,172,189,179,33,114,61,80,187,216,189,113,225,70,189,88,127,171,189,48,64,159,61,19,132,24,61,199,186,246,189,159,93,159,59,212,119,215,189,16,151,134,61,30,45,154,189,30,241,4,189,84,30,202,189,237,255,238,188,182,82,59,190,1,170,23,62,201,100,23,60,149,96,50,189,6,180,185,60,75,39,243,189,253,132,36,189,52,218,231,60,195,204,102,62,154,151,82,62,194,6,43,62,97,186,184,61,77,25,85,60,168,229,199,61,226,143,22,189,73,141,158,188,203,52,141,189,50,108,165,61,250,11,67,62,165,172,231,61,251,46,40,61,14,29,229,189,12,167,48,61,253,239,61,190,76,41,231,189,199,28,180,189,182,64,170,60,51,160,28,190,119,203,241,61,81,192,52,188,83,139,35,190,247,106,176,60,10,79,86,189,68,232,221,189,49,113,14,190,150,131,114,61,150,79,207,189,150,149,78,62,153,124,186,61,186,30,154,188,190,196,195,61,69,155,24,189,39,100,193,189,38,243,199,189,102,204,111,61,179,184,169,61,156,76,4,62,40,3,176,61,151,182,35,187,239,122,196,60,28,27,186,59,244,242,128,189,20,13,5,190,138,239,29,61,6,113,84,61,86,0,222,61,185,118,10,189,226,149,1,190,44,40,93,189,28,183,152,189,254,254,65,189,216,41,208,189,91,133,153,61,134,103,166,61,107,204,156,61,163,200,76,189,237,78,3,190,78,138,157,189,108,200,231,189,4,192,186,189,107,75,105,189,192,146,214,61,224,244,152,61,150,136,133,60,196,58,3,188,79,205,134,189,68,159,36,189,215,207,63,189,89,74,156,188,186,59,225,189,211,43,73,61,39,28,240,60,113,240,43,61,146,128,108,189,3,14,198,189,203,63,19,189,211,89,11,189,235,106,146,189,82,101,216,189,69,29,217,61,121,219,129,61,11,208,120,188,218,109,195,187,192,56,156,189,133,50,103,187,127,220,219,188,193,60,210,189,196,156,219,188,22,78,39,62,109,61,254,60,20,43,188,60,12,17,133,60,226,212,221,189,252,148,189,188,119,50,68,189,152,137,98,189,229,83,132,189,112,237,214,61,224,43,62,61,244,128,155,189,191,221,125,189,238,46,185,189,140,213,108,188,227,9,48,189,101,165,230,189,206,24,234,189,122,7,2,61,63,161,22,189,128,207,242,188,83,96,135,189,79,28,8,190,215,145,144,189,118,239,172,189,14,80,216,188,129,38,146,189,184,198,58,61,0,52,111,60,190,53,56,62,201,171,53,61,21,71,255,189,165,51,235,188,139,52,220,189,247,1,11,189,203,75,27,189,178,192,208,60,87,61,160,60,82,19,69,62,213,251,14,62,58,219,113,189,108,14,152,189,66,60,213,189,237,20,202,58,209,62,147,60,120,98,5,62,124,69,58,61,89,229,105,189,238,19,219,189,192,33,10,190,82,113,133,189,137,54,131,189,149,225,133,187,41,248,90,188,135,241,50,61,92,153,230,189,250,137,105,189,72,129,132,189,60,240,170,189,192,171,42,189,172,98,109,189,182,232,168,189,210,55,107,189,39,26,173,61,165,57,9,189,252,41,15,62,11,180,7,62,116,111,155,61,65,107,154,61,99,243,248,61,47,116,67,62,164,30,26,62,62,154,89,62,70,122,17,62,147,190,84,60,190,148,152,61,143,84,134,61,68,79,139,60,238,217,56,61,62,147,45,62,56,40,210,61,91,213,39,62,186,124,97,61,35,112,13,189,137,150,176,61,65,135,162,61,28,222,34,61,236,203,166,60,125,173,129,59,169,209,5,61,12,4,28,62,216,148,84,60,136,19,166,189,67,157,102,60,11,104,144,59,67,54,27,190,233,70,233,189,147,88,153,189,10,3,0,188,35,62,225,188,230,131,208,189,201,219,12,62,16,111,15,62,186,15,10,62,100,227,140,62,157,93,175,62,206,117,156,61,111,220,148,61,30,255,74,62,2,59,37,62,63,122,43,189,197,232,2,190,231,166,201,189,206,205,1,61,204,191,224,61,182,33,26,190,83,157,182,189,179,51,146,189,5,31,42,189,231,239,204,59,82,135,79,60,143,184,215,61,30,141,2,62,182,29,27,62,49,132,117,60,85,37,129,61,33,84,76,188,26,200,179,189,123,36,175,189,101,215,244,189,199,242,173,189,98,179,237,188,213,47,196,188,229,126,9,190,154,94,226,189,127,151,19,190,128,174,27,190,104,185,34,61,21,26,195,185,212,17,44,189,168,16,122,61,57,14,156,60,3,61,53,188,147,94,238,187,185,23,121,188,141,122,144,58,253,183,74,189,183,27,164,189,204,116,187,59,55,89,172,61,26,152,133,189,173,20,22,61,193,249,218,188,102,29,247,189,15,163,23,189,142,7,118,61,240,107,133,60,134,110,202,187,115,199,167,61,249,227,95,187,0,39,235,60,73,220,109,61,57,41,75,61,223,41,61,61,78,197,72,189,112,171,216,189,130,82,186,60,154,54,247,61,111,137,18,59,196,90,201,61,205,98,247,188,186,1,229,189,164,52,75,189,82,182,204,60,129,42,24,189,150,174,132,188,235,141,216,60,22,2,250,187,1,30,236,188,88,178,127,189,46,217,172,189,71,226,147,61,7,196,148,61,41,217,127,60,69,75,253,60,74,250,139,60,4,136,27,189,176,197,80,187,48,10,133,60,122,183,231,188,252,26,231,61,11,98,173,186,22,111,159,189,114,164,147,189,133,32,10,61,189,236,248,61,78,159,186,60,160,21,88,189,135,41,157,188,167,2,5,62,248,46,94,61,92,32,191,60,92,7,37,61,149,206,253,61,182,119,194,61,218,55,188,61,234,134,162,61,93,168,15,60,159,153,47,62,57,122,11,188,4,18,164,189,25,48,139,189,80,21,72,61,18,60,54,60,146,119,160,189,84,124,150,186,252,238,12,189,18,21,233,60,206,154,157,61,183,200,144,189,83,181,60,188,129,230,11,188,38,55,136,188,71,141,42,189,102,52,93,61,254,56,234,60,173,91,239,60,172,237,76,61,51,178,224,187,86,190,133,188,190,86,159,61,239,151,37,61,49,77,71,188,108,135,108,59,197,123,129,189,13,231,194,61,93,220,3,62,159,201,30,188,200,242,40,60,159,53,84,61,115,34,25,188,91,184,134,188,23,161,70,189,33,230,49,189,191,87,215,61,139,203,164,61,239,9,61,189,254,213,34,189,111,99,115,188,142,28,6,62,112,179,120,188,172,151,134,189,182,130,36,189,211,136,151,60,151,219,199,60,170,55,165,61,113,37,229,58,243,117,144,61,173,159,180,61,180,147,166,187,99,41,134,189,138,74,169,189,199,88,159,189,29,34,110,60,83,87,179,189,150,166,51,60,198,193,14,188,243,15,207,61,53,79,198,60,63,99,137,189,217,122,164,60,155,91,194,59,208,35,93,61,142,97,154,61,104,223,167,60,128,182,183,60,30,75,36,61,66,228,189,186,238,85,137,187,217,104,130,61,55,94,205,60,236,111,199,60,8,210,112,61,37,213,6,188,193,143,75,188,143,13,45,61,103,195,143,188,217,11,116,61,236,107,28,61,127,241,149,188,69,126,48,189,25,34,53,189,219,73,199,188,175,137,185,60,209,135,5,59,30,31,68,60,107,212,53,61,231,57,249,61,47,145,19,61,63,238,212,188,227,232,1,187,199,162,167,60,15,49,216,188,90,170,250,186,141,44,191,189,233,65,19,189,68,231,33,188,147,65,140,189,188,33,63,189,187,228,203,189,158,75,44,189,69,188,213,60,114,238,20,60,145,50,146,189,236,105,221,185,59,185,144,60,251,205,225,60,19,89,86,60,164,1,38,61,210,149,195,60,160,157,90,61,8,218,204,60,44,155,75,189,81,85,255,189,227,68,52,62,228,2,251,61,217,217,153,189,93,157,14,60,31,95,105,189,86,138,20,189,63,160,15,188,180,100,70,188,50,145,193,189,2,105,153,61,213,126,164,188,122,166,219,188,219,94,132,189,219,160,120,188,16,112,240,59,66,243,198,59,185,207,190,189,203,103,59,189,123,204,7,62,95,243,29,62,30,167,135,188,59,29,227,188,152,199,86,189,119,10,193,188,214,167,192,188,70,34,209,189,228,209,3,190,101,253,20,62,13,52,0,62,21,198,143,59,52,12,229,60,193,198,83,61,53,230,188,61,73,65,113,61,8,179,194,60,43,133,227,188,148,179,194,61,84,201,190,60,107,12,190,188,121,214,3,189,76,82,122,188,61,147,38,188,236,28,219,188,58,107,82,61,148,65,162,60,192,7,134,61,220,11,143,188,127,41,40,60,228,226,127,60,18,238,80,58,97,175,155,61,238,61,156,60,238,143,252,188,91,62,117,189,205,74,189,61,32,11,21,62,188,181,41,60,89,84,253,60,35,216,195,189,146,190,27,189,240,89,207,60,186,68,252,60,50,108,145,189,36,109,8,61,81,94,48,187,138,189,1,61,174,80,107,61,122,134,5,61,137,178,250,58,148,217,2,61,181,87,151,61,169,16,180,60,141,84,156,61,181,226,6,61,86,113,186,189,78,65,65,61,39,247,121,61,131,87,36,188,189,217,191,59,98,117,121,188,223,87,190,60,115,196,216,61,56,212,142,59,177,45,122,61,195,96,112,61,108,57,255,188,84,3,71,60,7,116,175,61,246,20,129,59,112,143,206,188,0,249,246,186,18,245,166,60,132,83,36,186,92,153,72,61,48,85,47,189,26,106,69,189,145,34,69,189,39,195,109,188,200,244,80,61,241,163,19,188,12,142,8,189,188,122,32,61,242,226,43,61,76,206,47,61,24,40,230,60,149,188,245,60,9,44,39,61,206,25,21,60,226,184,198,61,189,147,212,61,85,104,192,60,179,233,154,187,34,81,40,60,227,11,213,61,31,59,247,61,236,14,201,61,77,250,213,188,137,7,21,61,74,132,113,61,124,69,71,61,202,91,68,61,22,5,31,189,25,168,242,188,163,65,72,188,202,197,38,61,142,131,157,60,7,108,187,188,155,84,8,61,252,75,152,60,246,212,184,61,154,212,27,61,72,100,105,188,224,12,160,60,124,150,205,60,79,228,10,189,186,254,103,189,204,130,134,188,236,142,111,61,119,10,62,61,218,98,171,60,124,55,4,62,53,246,75,62,34,131,158,61,6,213,237,187,198,231,38,61,150,106,2,61,253,132,182,58,224,16,106,188,243,209,152,60,92,175,174,61,252,185,10,62,13,42,229,61,132,203,35,61,126,29,196,61,53,138,215,188,105,166,13,189,52,143,66,189,18,168,120,189,128,160,154,59,128,2,132,61,5,181,200,188,143,157,96,189,171,194,62,189,57,91,166,188,122,146,14,189,45,119,192,189,244,16,131,189,228,212,147,188,50,69,184,59,110,216,217,187,104,124,133,189,89,34,228,59,34,98,152,188,193,232,45,189,139,161,111,189,41,156,84,187,214,181,157,61,80,61,231,61,65,57,203,61,250,89,243,188,174,16,101,61,58,46,69,61,235,238,200,189,218,166,191,189,140,48,6,189,61,190,85,61,119,161,41,61,94,197,128,59,170,190,78,189,103,110,35,62,183,240,60,61,94,27,255,188,63,119,62,189,146,28,5,189,97,181,198,188,213,151,48,189,20,113,48,61,242,140,192,189,181,67,66,189,128,137,77,188,104,36,135,189,79,184,95,59,163,54,102,189,197,151,238,187,96,177,117,189,25,31,6,189,9,20,151,189,230,17,81,59,142,95,158,189,193,55,110,61,29,110,202,188,165,184,29,61,139,181,13,62,208,177,29,62,111,212,141,60,115,22,114,188,10,219,212,61,197,88,83,61,63,97,159,188,249,99,12,189,197,93,71,189,0,47,189,61,92,206,219,61,196,175,120,61,204,3,94,188,243,22,151,60,221,146,14,189,251,130,27,189,94,26,98,57,124,212,94,189,34,209,154,60,33,125,108,188,171,163,213,188,89,174,240,188,252,224,222,60,122,29,127,189,11,97,243,188,106,86,12,189,102,141,210,189,93,5,138,189,251,33,86,189,55,163,9,61,131,251,230,189,217,170,142,189,37,184,14,190,69,63,21,60,167,33,132,57,206,123,133,187,52,31,252,61,139,88,191,61,48,142,149,61,24,250,3,61,251,69,154,61,15,86,27,61,103,49,76,189,63,213,147,60,93,181,220,60,240,12,10,62,87,119,60,61,212,56,40,61,115,78,174,61,74,52,252,61,160,103,88,60,113,155,78,61,76,48,181,187,64,43,184,189,67,67,184,188,19,144,167,189,242,134,124,61,245,99,5,189,193,33,47,188,123,214,88,188,125,38,245,189,232,21,61,189,129,147,247,189,136,127,138,189,153,179,177,189,180,199,131,189,161,52,145,60,141,29,14,61,242,198,223,189,127,229,246,60,216,171,15,62,28,44,37,62,36,44,56,62,203,13,231,61,224,170,215,61,209,100,182,61,50,99,158,61,84,30,137,61,215,122,175,60,66,222,131,61,36,151,200,61,114,81,107,61,71,112,228,60,114,174,215,60,161,140,163,61,114,59,139,59,25,235,10,60,122,128,219,188,6,72,173,187,151,40,177,188,235,104,153,189,197,252,168,189,134,121,168,188,178,33,40,188,2,97,151,186,250,235,22,186,67,172,147,189,6,239,149,189,61,5,72,189,116,44,223,189,94,34,153,189,82,153,181,189,33,224,188,189,182,188,223,189,175,156,213,189,62,227,162,61,79,192,226,60,4,86,233,61,114,77,64,62,189,183,7,61,166,156,175,60,214,178,111,61,10,251,10,187,108,15,119,187,128,66,227,60,210,247,255,188,120,12,112,60,15,98,132,60,16,13,100,188,91,100,52,189,220,254,94,189,36,95,22,190,21,197,25,190,51,181,56,61,33,210,169,58,13,27,101,60,90,205,101,61,34,109,71,189,127,167,67,189,43,214,5,188,205,208,22,187,117,75,187,188,133,107,245,61,68,165,64,189,14,133,180,189,141,88,155,189,11,45,221,189,227,98,4,189,4,93,119,60,103,99,70,189,226,133,34,189,40,100,196,61,122,154,93,60,242,229,110,188,246,42,44,60,81,243,248,188,87,194,131,60,195,196,146,58,81,232,76,188,79,146,59,59,11,130,49,61,49,138,21,190,247,117,159,188,189,171,190,188,155,180,161,188,137,179,162,61,18,60,182,188,198,64,137,189,21,102,14,61,115,162,235,61,143,59,222,188,243,103,136,188,139,88,129,61,87,14,168,189,20,53,152,61,171,89,73,61,67,10,55,189,254,47,116,188,207,143,151,61,71,156,238,189,219,254,80,61,209,189,58,61,42,82,114,189,11,15,181,61,184,20,130,188,192,121,24,190,107,237,160,61,152,238,64,61,47,114,92,189,130,40,150,189,108,165,19,189,216,221,31,62,188,171,156,61,75,24,116,189,171,117,227,188,23,77,227,61,169,246,25,61,221,36,54,189,55,16,74,61,212,115,92,60,131,190,141,61,175,212,150,61,115,14,98,61,180,136,237,60,103,4,192,61,227,106,215,61,150,13,53,189,96,230,156,60,201,143,105,187,160,94,21,62,203,168,210,61,122,156,50,189,52,73,2,190,103,226,185,61,255,187,227,61,179,49,119,189,232,35,198,61,35,14,183,61,203,181,144,61,164,64,213,60,227,161,191,59,90,145,114,189,158,35,253,61,248,186,107,59,122,129,68,59,171,119,23,61,83,94,167,60,64,192,42,61,131,24,40,60,178,209,94,188,186,37,131,188,171,112,211,60,234,207,190,60,255,92,67,59,150,130,133,60,62,60,136,61,179,216,111,61,246,190,74,60,201,133,84,188,40,79,144,60,151,133,80,61,106,33,134,61,102,73,53,189,184,98,31,59,12,105,73,59,65,199,136,61,254,72,48,189,218,86,49,60,31,161,132,189,175,6,39,61,206,207,254,61,174,181,168,61,2,12,152,61,242,137,38,61,239,108,141,61,200,182,195,61,127,77,2,62,0,169,174,188,176,94,174,61,125,5,43,189,20,122,218,188,129,120,155,60,69,225,7,61,181,231,26,60,86,254,74,188,214,197,45,189,68,145,104,188,65,54,17,189,215,244,199,188,203,217,177,61,254,143,44,61,224,193,201,60,184,3,53,188,57,102,164,187,17,56,243,60,5,201,212,60,9,135,128,188,19,238,56,61,185,214,142,61,58,145,177,61,243,214,139,61,45,177,209,61,145,109,93,61,216,28,134,61,243,43,26,189,248,209,95,60,19,201,144,61,249,178,91,61,239,135,68,61,94,191,239,61,242,231,95,61,52,33,153,188,213,238,129,61,238,124,254,60,158,178,172,61,81,216,168,188,3,131,28,61,46,209,226,187,69,222,209,59,71,94,80,188,50,127,144,56,48,4,58,61,56,156,155,188,5,161,77,189,127,213,245,60,157,167,50,60,125,66,148,59,250,212,210,60,131,169,195,188,252,12,44,189,168,120,226,58,193,223,116,189,82,222,222,188,51,161,134,61,144,31,61,60,190,91,79,60,116,15,151,61,102,180,22,188,72,72,73,189,240,16,174,60,123,52,132,61,73,29,51,61,81,148,7,189,109,177,19,61,114,47,222,187,44,99,25,60,191,41,143,60,137,51,131,189,103,135,139,189,192,126,165,61,186,148,227,188,143,18,224,60,81,240,130,61,215,60,136,61,150,135,104,61,148,242,176,61,80,197,248,187,118,228,164,188,168,50,66,189,65,191,135,188,30,18,133,188,171,60,99,61,226,230,24,187,151,129,55,60,176,138,123,61,134,183,128,189,158,214,178,189,7,189,190,189,118,207,46,189,202,169,182,59,15,3,69,61,243,75,145,60,28,21,176,59,132,252,23,62,185,251,128,189,126,114,240,188,200,92,234,61,127,51,78,189,25,77,185,59,232,27,170,60,164,131,59,189,216,249,65,189,41,146,242,60,38,156,190,189,66,245,52,189,58,100,76,189,48,98,33,189,72,250,85,60,217,93,128,61,55,245,25,61,97,67,173,61,252,233,13,62,213,41,71,61,0,110,129,189,98,166,103,189,110,124,154,60,22,148,6,189,113,25,10,61,190,50,144,189,60,229,56,189,173,23,100,60,241,157,167,61,174,19,148,189,80,136,195,60,50,246,178,60,213,118,213,60,45,103,41,188,236,89,24,60,21,114,251,59,176,137,27,62,144,127,169,60,184,112,199,189,186,38,182,189,157,26,159,189,52,15,191,60,59,188,145,188,235,123,5,189,17,139,167,189,182,239,173,189,13,156,187,60,243,209,232,189,68,151,17,189,205,180,57,189,175,107,234,188,111,231,138,61,195,95,54,60,165,0,201,60,209,69,2,62,182,147,165,61,121,198,19,189,243,183,53,60,218,192,68,61,143,242,14,189,184,62,11,61,60,188,104,189,119,211,12,60,61,55,140,187,78,86,4,61,66,6,85,188,159,22,42,188,161,104,162,189,164,126,8,60,117,43,188,60,149,14,86,188,143,36,154,188,135,197,52,61,38,178,106,61,190,18,26,189,135,29,159,60,188,170,215,58,148,28,28,189,38,166,43,61,46,96,25,190,212,233,56,189,255,43,70,60,113,16,179,187,47,240,134,188,117,10,250,59,56,125,153,189,88,88,172,61,102,54,205,61,149,73,73,188,236,56,134,61,52,136,58,61,130,152,161,61,73,33,249,60,64,134,143,60,200,149,188,61,181,77,196,185,231,13,216,61,216,249,63,61,135,57,155,60,36,52,217,188,205,111,142,187,30,145,178,59,13,170,108,60,224,238,112,61,51,170,8,189,76,147,60,61,150,168,213,189,178,155,157,60,67,247,150,60,196,66,140,188,200,22,182,188,18,61,64,61,181,18,126,189,172,1,105,188,251,213,178,61,50,210,157,189,62,254,217,60,67,35,48,189,202,84,253,188,89,127,17,189,34,130,154,188,101,250,75,189,149,1,32,61,35,197,60,61,115,105,75,61,125,31,47,61,195,78,61,189,227,89,217,188,168,105,12,60,1,70,29,61,42,86,110,61,24,245,30,61,155,193,144,185,29,7,252,60,60,208,5,189,81,36,92,189,134,63,76,61,44,230,26,188,58,189,18,61,150,98,45,187,26,218,140,186,53,172,242,60,193,8,115,188,19,191,250,60,35,145,200,60,230,49,151,60,101,120,6,61,69,197,16,189,187,156,49,188,247,91,55,188,146,244,242,186,122,226,27,186,175,88,54,189,23,131,67,59,226,117,128,61,78,76,176,188,121,133,72,187,124,179,79,189,193,246,122,60,41,45,82,60,127,165,83,61,80,9,27,60,147,65,91,187,139,86,234,61,187,4,32,189,184,49,47,187,116,109,251,60,84,210,57,188,180,158,241,60,150,235,235,60,138,236,29,61,16,88,13,189,251,62,187,61,80,172,176,188,164,213,120,61,252,205,126,189,229,78,159,60,35,3,219,59,200,84,136,189,84,171,14,60,236,142,13,61,100,107,199,60,81,138,7,190,99,23,43,189,57,139,169,188,221,255,46,60,101,166,118,60,199,244,153,189,164,96,123,187,82,254,128,189,103,8,236,188,155,39,6,190,200,229,147,189,86,9,190,187,198,117,12,188,16,238,26,61,199,70,226,60,104,113,74,61,176,140,240,188,7,141,196,61,233,102,157,60,160,231,121,61,166,24,68,189,178,7,98,188,135,142,242,187,160,223,181,188,236,62,87,188,76,202,254,59,135,215,251,61,58,216,240,60,121,54,19,61,210,130,159,189,129,167,57,188,97,91,209,57,235,117,121,189,220,214,55,188,241,147,153,187,109,83,156,61,202,55,138,189,208,6,103,189,171,174,87,189,61,162,58,188,7,17,133,188,216,39,65,189,66,19,52,188,214,203,43,60,39,73,87,59,4,252,109,189,182,177,157,189,190,108,8,189,109,108,43,61,24,123,14,61,171,97,186,60,114,206,188,60,142,63,218,59,175,160,224,61,154,81,194,187,88,255,70,189,226,41,44,189,202,206,190,189,115,228,200,187,167,116,208,188,160,214,95,60,6,127,22,60,140,69,151,188,38,75,102,189,166,103,35,189,114,244,159,189,105,132,226,59,239,5,116,61,116,204,31,189,69,199,128,60,236,155,67,188,35,231,225,187,97,104,253,188,34,106,41,189,189,7,128,188,133,154,60,189,80,184,234,60,14,188,177,189,13,103,4,189,214,187,91,189,93,192,108,188,102,112,143,189,112,142,177,189,195,43,57,189,107,17,47,61,7,99,255,60,59,112,167,61,255,32,49,60,55,168,130,61,99,235,125,61,32,200,234,60,11,92,193,60,133,188,137,61,237,17,5,189,28,162,25,188,28,73,169,61,168,250,183,188,133,243,81,61,65,145,152,188,79,170,161,60,146,99,163,188,94,150,220,189,166,68,2,61,77,75,84,59,172,122,175,188,99,85,46,189,168,1,67,61,19,109,47,61,64,217,102,61,140,66,153,188,162,241,98,61,85,65,249,188,190,110,110,60,60,201,135,189,194,92,111,189,102,45,25,189,57,117,199,189,151,230,3,189,225,51,102,189,113,156,212,189,107,142,151,61,240,216,137,59,55,120,5,61,20,115,12,59,181,203,81,61,145,201,80,188,16,92,195,60,173,192,129,61,17,232,161,189,102,136,171,61,0,197,161,189,110,75,133,189,43,172,204,188,120,218,133,61,20,162,34,61,180,132,72,61,39,159,63,188,160,11,35,189,41,191,104,61,252,180,114,61,136,1,63,188,41,139,162,189,21,102,44,189,120,143,90,60,86,94,185,61,31,210,206,61,24,201,34,189,210,245,74,60,186,162,153,189,17,186,21,189,202,48,48,189,228,194,188,61,136,12,243,57,55,144,233,60,105,136,175,60,65,121,6,57,106,231,235,60,66,52,175,189,37,51,70,189,195,156,166,61,160,201,107,189,68,167,103,60,150,99,13,61,46,145,135,189,199,28,250,188,217,158,242,60,193,60,151,189,96,18,58,60,208,109,88,61,77,75,159,189,26,165,172,188,136,194,97,189,162,248,9,190,0,59,248,60,191,170,137,61,6,185,126,189,182,170,110,189,102,24,128,61,190,56,237,60,156,80,136,188,99,73,20,189,236,19,132,188,37,126,191,186,81,127,15,62,151,212,18,188,77,33,5,189,184,236,93,59,160,134,45,59,88,157,9,61,30,151,197,188,236,63,45,189,120,113,218,61,42,78,213,192,11,181,150,62,143,85,202,189,106,161,4,190,65,73,161,61,240,105,198,62,33,231,133,62,9,113,21,62,101,252,123,61,60,75,168,62,124,153,104,62,218,31,136,189,212,155,177,189,58,205,66,61,223,140,218,61,226,57,27,61,170,69,228,61,23,239,199,188,175,10,156,62,229,100,130,62,20,203,141,189,93,24,169,61,83,203,22,62,123,104,167,62,25,118,24,62,204,98,98,61,123,49,180,189,42,0,134,62,118,226,18,62,215,164,219,60,217,237,115,62,46,173,70,62,210,197,102,61,197,203,211,188,39,21,13,189,224,99,32,190,34,25,82,62,212,73,182,61,157,42,15,190,223,25,205,189,161,243,26,189,193,115,239,188,209,231,99,189,14,47,8,61,44,68,135,188,72,248,30,62,37,64,125,62,145,95,255,189,194,77,70,189,90,217,126,189,214,84,70,62,126,225,149,59,1,165,97,61,2,159,191,61,178,188,43,62,91,154,43,62,176,201,154,60,152,108,92,62,109,26,251,61,141,98,185,61,29,170,137,189,162,210,72,189,243,2,204,189,120,155,119,62,67,87,194,189,91,122,52,190,129,92,226,58,74,179,9,190,176,229,213,61,143,168,80,61,214,57,166,61,134,198,147,61,138,33,249,61,73,16,46,59,12,144,152,190,8,203,8,190,112,65,118,189,129,120,189,189,246,152,72,189,129,147,173,189,5,111,56,190,140,16,30,189,36,181,176,61,5,222,9,190,93,165,219,189,81,20,8,62,14,244,16,62,68,105,127,62,73,102,5,62,146,3,246,188,44,240,149,61,141,156,5,188,86,70,163,60,40,209,146,61,82,73,157,57,229,242,159,188,161,248,177,188,71,232,39,189,178,217,177,189,44,157,143,61,54,203,117,62,245,219,135,62,223,250,48,61,144,193,42,62,182,75,187,61,14,131,121,61,244,111,23,189,193,116,186,189,117,148,163,61,69,14,97,62,126,229,33,62,42,254,15,190,140,49,48,189,49,152,255,61,2,213,191,61,183,94,211,61,64,76,194,61,174,242,164,61,29,4,13,62,106,107,36,62,228,74,45,190,244,24,101,60,213,119,158,62,195,46,138,187,140,74,106,189,207,18,132,189,20,117,102,60,44,214,184,62,16,174,128,62,106,218,165,189,60,249,52,189,81,164,123,61,210,28,25,189,142,90,161,189,8,229,253,60,162,207,135,61,125,89,26,61,22,251,27,62,76,196,187,189,151,198,143,61,165,21,95,62,222,60,21,61,28,152,156,189,91,238,204,59,10,101,193,189,126,139,30,62,48,186,188,188,37,176,73,190,91,121,201,188,135,191,54,62,141,94,77,189,49,35,60,189,14,248,124,186,29,118,223,61,131,23,61,61,173,50,35,190,249,192,14,188,135,49,41,61,146,235,198,61,21,86,106,189,123,76,132,189,175,8,158,61,31,101,52,62,72,164,13,62,130,169,134,61,7,240,214,189,58,232,146,60,110,134,11,62,138,5,62,188],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+143360);allocate([105,138,64,61,102,247,164,61,30,136,140,61,191,98,173,61,28,97,17,189,214,2,187,189,149,158,41,189,186,188,121,61,61,183,208,189,226,146,163,189,182,20,176,189,254,215,185,188,228,103,163,61,199,213,200,189,101,167,95,189,165,104,37,61,172,1,154,62,129,176,3,62,146,61,194,61,216,45,66,61,160,137,208,61,141,67,125,61,69,13,38,190,87,118,81,190,45,9,16,189,5,197,207,61,181,82,136,188,181,84,222,188,14,158,9,190,205,62,15,188,234,146,209,61,13,56,235,61,222,1,30,60,88,169,128,61,255,8,115,62,9,223,43,62,188,91,89,61,173,78,78,188,113,198,48,61,124,15,23,59,63,31,133,61,4,116,31,189,160,193,166,188,206,255,27,62,141,12,50,61,91,125,245,188,62,234,47,189,204,10,5,61,112,67,140,61,21,0,227,189,124,127,227,189,197,85,229,61,100,202,7,187,112,65,182,187,27,213,169,61,106,106,217,59,82,127,221,189,41,151,198,60,10,20,177,189,244,112,66,190,98,75,143,188,11,13,68,62,173,193,251,187,5,220,3,190,183,183,27,189,159,142,7,190,179,67,188,61,168,55,163,61,54,148,218,189,47,223,250,187,206,227,48,62,67,169,61,60,78,236,33,60,44,131,170,61,21,56,217,188,221,6,21,62,65,158,29,62,190,106,5,190,142,30,223,189,157,244,254,61,54,204,80,187,20,203,205,189,57,39,118,60,110,219,119,189,239,89,215,60,150,150,177,189,123,17,45,190,242,180,156,61,232,244,92,62,210,255,50,61,41,205,6,190,81,49,78,188,182,15,57,189,238,9,242,189,79,87,119,190,219,78,43,190,111,183,164,188,250,40,163,188,173,138,208,189,38,85,219,189,198,20,44,188,233,16,56,61,121,59,66,62,113,84,94,62,172,196,60,189,5,78,54,61,90,130,76,62,238,120,19,189,82,128,24,190,238,206,90,60,190,80,160,189,96,116,249,60,225,155,102,61,208,152,201,188,88,113,170,61,245,215,203,61,115,131,33,189,143,54,14,190,89,162,179,59,78,151,197,188,216,214,15,190,195,242,135,189,31,187,139,188,65,183,23,60,154,149,109,189,121,91,233,188,196,90,124,189,244,51,245,59,193,27,34,190,177,77,26,190,63,169,54,189,174,73,215,189,252,113,59,189,207,219,216,187,91,10,200,188,131,19,241,189,41,118,244,189,225,41,52,190,157,132,146,189,110,196,243,61,195,17,228,61,167,116,48,61,197,231,14,61,91,120,190,61,187,123,0,60,181,250,106,61,92,228,222,189,67,198,163,189,132,128,108,62,245,132,165,60,171,236,59,60,6,128,202,61,158,123,207,61,115,133,247,188,124,154,147,188,204,236,115,189,215,104,217,189,83,32,179,60,158,98,21,189,199,241,163,61,162,156,40,61,146,36,168,189,84,26,241,61,236,161,253,60,43,79,96,189,171,61,172,189,151,60,62,190,244,26,123,189,54,3,28,189,93,197,226,189,82,44,135,190,200,7,157,61,95,236,157,189,140,242,12,190,1,104,20,61,92,85,142,62,40,153,156,60,190,165,220,61,134,117,19,62,108,118,164,61,102,50,92,62,250,99,106,62,142,234,148,61,115,71,159,61,164,26,246,61,120,67,154,61,150,120,128,61,191,213,250,61,157,188,72,189,177,222,40,62,75,89,38,62,145,241,40,61,220,13,34,60,134,89,200,189,228,131,30,189,30,163,188,188,12,205,245,189,167,62,80,62,248,111,126,62,203,103,25,62,37,150,20,189,99,154,169,189,192,5,185,189,255,90,222,188,214,2,155,189,172,255,163,190,111,18,3,186,38,198,18,190,23,71,133,189,39,108,63,190,24,122,4,62,96,115,238,61,77,15,58,62,198,134,46,62,8,116,214,62,5,139,235,62,55,221,170,62,32,12,108,62,0,225,67,61,175,33,56,189,172,112,139,189,21,139,15,62,58,150,55,189,215,52,175,61,186,103,189,61,1,190,219,189,91,206,5,190,141,150,83,190,238,179,234,61,186,191,162,190,126,1,157,189,235,110,30,61,236,219,89,62,42,142,131,188,8,144,1,190,72,135,39,190,156,50,87,62,142,145,204,61,23,102,1,190,125,151,242,61,232,45,158,60,141,9,177,188,69,161,197,189,30,252,228,189,253,76,77,190,82,72,18,62,8,85,106,62,196,233,180,190,92,115,55,190,170,70,239,61,34,57,129,62,56,245,1,189,118,166,64,190,95,208,34,190,88,230,197,62,73,128,250,61,143,251,86,62,98,189,201,62,200,210,183,62,179,124,133,62,76,108,46,62,169,46,96,60,176,4,18,190,92,31,214,188,241,155,66,188,167,33,26,190,204,41,65,61,82,67,219,189,34,226,22,190,140,49,64,190,221,125,62,190,137,10,85,190,36,124,111,61,168,142,149,189,188,59,114,190,228,103,163,189,166,185,21,190,194,223,111,189,91,150,207,189,151,2,146,189,53,153,145,189,59,115,239,61,99,237,111,62,102,18,157,62,159,203,164,62,143,194,117,62,221,9,150,61,67,113,71,188,125,234,216,60,52,130,77,61,50,29,42,62,46,115,106,62,25,144,125,61,13,55,32,62,11,239,82,62,226,34,247,61,80,252,24,61,201,233,43,62,219,135,148,62,52,128,215,62,109,116,78,188,40,101,66,62,148,221,156,62,201,114,242,61,226,200,195,189,123,49,148,189,8,173,7,190,39,164,101,190,166,11,1,190,182,18,186,60,143,109,145,62,77,104,82,61,235,1,115,186,29,148,112,189,128,181,170,189,227,164,16,190,114,20,64,190,118,136,79,190,119,77,72,61,237,131,124,62,222,59,226,62,166,94,175,62,73,44,137,61,239,115,92,62,36,181,64,62,145,242,147,189,45,35,85,190,154,93,247,188,152,106,54,62,204,69,12,62,239,168,49,189,193,113,57,190,129,9,188,61,53,238,237,61,6,187,1,190,182,243,197,190,31,128,188,62,230,205,137,62,93,79,180,189,54,30,236,188,86,98,190,61,68,107,197,60,240,223,60,61,134,255,52,62,0,28,11,62,104,232,255,61,128,40,72,62,231,113,24,189,239,58,43,62,247,120,65,62,45,64,91,61,34,81,136,189,40,238,8,62,98,132,144,189,238,91,237,61,236,23,28,62,7,154,239,189,15,126,226,189,22,77,55,190,217,118,218,60,234,236,164,61,164,197,153,61,102,46,144,189,56,192,76,60,173,252,178,60,75,30,15,190,73,99,180,188,117,57,197,189,154,6,133,189,52,129,2,190,144,50,98,188,65,212,221,189,45,9,32,62,188,118,25,62,145,123,58,188,90,41,132,61,187,241,238,60,73,103,224,60,67,199,142,61,181,108,29,62,47,135,29,61,74,64,108,62,81,247,129,62,87,205,115,61,127,137,56,189,98,188,102,60,115,158,145,61,58,203,140,61,103,96,196,61,93,26,191,59,66,93,20,62,163,234,215,60,132,243,137,189,174,215,52,189,204,123,252,189,101,28,163,188,158,66,174,59,114,168,223,61,222,199,81,187,128,11,178,188,0,111,17,62,138,6,137,189,67,231,245,189,149,42,65,190,92,87,76,60,216,125,71,189,195,154,74,188,141,67,61,190,30,163,44,62,251,201,136,62,131,107,110,61,64,163,52,189,76,55,9,61,233,215,54,62,79,30,214,61,74,182,250,61,215,51,164,61,102,103,49,62,215,217,152,62,34,109,131,61,208,182,90,61,114,134,50,62,18,135,108,62,206,170,239,61,88,59,42,62,108,63,105,62,49,9,247,61,232,50,53,62,181,169,58,188,0,30,177,189,229,126,7,188,97,195,83,61,195,12,29,190,17,255,112,189,223,22,108,189,37,59,118,189,220,217,215,60,86,154,36,190,189,54,27,189,148,246,70,189,36,38,40,61,58,36,181,188,74,65,119,61,99,155,84,61,142,143,38,62,237,215,13,62,201,142,77,189,142,147,194,187,66,6,146,61,30,192,2,62,83,90,127,61,152,221,19,62,79,175,148,61,207,50,75,62,213,32,124,62,117,31,160,189,242,37,20,189,73,131,155,61,1,219,65,61,187,214,94,188,137,152,178,61,83,5,163,60,56,48,185,60,123,189,123,188,201,115,189,189,199,41,154,61,4,86,238,189,23,217,78,61,167,205,56,61,138,144,42,62,2,155,147,61,149,71,119,61,176,232,6,62,145,240,45,190,144,47,33,189,174,128,66,189,46,2,35,189,42,55,81,190,43,217,177,60,181,140,4,62,0,115,173,188,247,147,49,62,114,252,144,189,24,11,131,189,27,185,142,61,86,70,131,189,206,80,252,189,185,79,142,188,187,213,83,190,46,227,134,61,8,227,231,61,86,102,202,60,59,27,146,189,108,36,137,189,250,69,201,189,223,223,128,189,0,82,155,61,97,27,113,60,157,190,158,60,63,226,7,62,115,241,151,189,169,105,183,189,76,168,160,189,75,58,74,190,61,213,49,190,70,97,87,61,225,179,53,61,97,140,232,61,44,182,201,61,226,120,158,61,182,157,54,188,25,55,69,190,166,97,40,190,131,165,58,61,194,162,82,62,79,120,73,61,241,130,168,189,105,28,10,62,115,243,61,62,155,58,15,61,102,220,244,189,75,35,230,189,213,180,235,189,37,91,93,189,67,58,60,190,229,242,159,189,141,69,67,62,178,161,187,61,78,126,139,59,44,125,40,189,36,182,123,189,126,253,16,190,3,124,71,190,14,17,247,189,93,55,165,60,183,155,224,61,246,7,138,61,206,168,121,188,109,226,116,190,245,130,135,190,199,158,61,190,186,187,78,61,21,86,170,60,24,35,18,61,219,24,187,60,160,55,85,189,11,10,3,190,60,134,231,189,226,229,105,190,104,61,132,190,193,224,90,189,48,132,156,61,255,178,123,61,111,45,115,62,248,27,109,59,179,210,100,189,184,92,221,189,74,13,237,188,86,183,58,61,57,99,88,61,146,206,192,186,151,253,186,60,110,250,115,61,101,223,213,189,163,61,158,189,152,247,88,190,250,42,89,190,114,251,229,60,38,85,155,61,45,62,133,60,156,195,37,62,87,180,9,62,27,100,18,60,164,198,68,189,31,248,152,61,15,123,161,59,245,19,206,188,195,128,69,62,69,100,152,61,31,18,158,62,167,232,136,62,32,240,192,61,149,16,172,187,47,51,44,61,159,173,3,189,208,100,127,60,12,120,129,62,94,130,51,62,1,136,187,60,44,68,167,61,50,115,129,61,110,135,38,62,156,23,71,62,220,128,111,62,35,75,134,62,148,106,63,62,156,49,172,61,115,161,146,190,150,37,90,190,195,40,72,189,47,167,84,190,150,33,46,190,28,64,63,60,196,96,190,189,177,105,69,190,233,12,140,190,25,114,108,62,25,145,136,62,17,27,164,62,179,36,152,62,206,84,12,63,189,30,156,62,26,223,7,62,221,68,125,62,116,150,89,62,97,254,138,190,249,131,17,190,191,41,44,187,254,38,244,189,213,118,3,62,56,246,204,61,162,122,107,189,193,167,249,189,170,98,106,190,162,37,79,62,238,177,204,190,113,30,190,190,170,69,196,189,89,78,130,189,125,63,37,190,252,82,159,190,162,239,150,190,212,238,119,62,117,34,65,60,199,187,195,61,188,33,165,62,242,7,3,63,135,80,165,62,124,99,160,62,175,125,49,62,175,151,38,59,83,35,244,188,187,71,166,62,193,255,166,190,45,92,174,190,95,155,13,190,228,46,66,187,74,152,233,189,10,47,193,190,137,152,226,190,114,139,89,62,54,63,254,187,67,169,61,188,184,200,45,62,124,12,158,62,112,123,162,62,119,21,10,63,169,106,170,62,233,211,106,61,245,161,139,189,59,226,208,61,146,179,136,62,133,153,86,62,62,34,182,62,34,171,187,61,223,82,46,62,92,56,0,62,234,93,140,62,20,209,143,61,213,4,209,60,45,148,76,61,224,45,16,186,128,14,51,61,75,63,17,190,9,193,170,60,231,252,4,62,129,95,131,62,27,18,215,61,46,230,23,62,67,199,46,62,51,221,235,60,182,160,151,61,13,226,35,62,30,110,207,62,114,24,124,62,81,78,180,62,126,1,45,62,233,152,99,62,140,100,135,62,44,14,135,61,192,235,179,60,164,197,153,189,214,173,190,61,0,202,223,60,53,121,202,61,83,202,107,61,228,106,164,189,7,121,61,62,135,251,160,62,68,222,170,62,49,209,0,62,160,255,150,62,14,162,197,62,132,215,94,62,225,235,59,190,139,167,142,190,61,124,25,187,222,232,227,188,7,125,9,190,83,231,169,190,242,235,7,188,105,27,255,61,29,1,92,61,170,239,188,190,60,162,194,189,249,103,86,62,18,247,216,62,84,87,190,62,172,230,217,61,12,35,189,62,157,161,248,62,244,191,108,62,113,3,14,190,100,203,178,190,173,135,143,189,137,126,237,60,161,45,167,189,119,191,202,190,97,80,22,190,127,21,224,188,195,213,129,61,6,131,139,190,239,202,110,61,120,41,173,62,207,217,226,61,35,159,87,189,218,117,111,190,161,218,224,188,109,114,248,60,68,78,31,62,217,39,192,189,12,92,158,60,14,17,247,61,31,45,206,59,11,66,217,189,1,246,113,190,190,80,16,190,121,92,180,189,53,238,205,188,128,101,85,190,146,233,208,188,17,167,19,62,204,13,70,189,7,98,217,189,210,56,156,190,231,197,233,189,207,74,186,61,213,203,167,62,153,215,17,61,52,15,192,189,102,188,45,59,220,47,47,190,106,165,64,190,202,196,93,190,147,30,86,190,162,212,94,189,37,235,32,62,0,254,105,189,49,93,136,61,104,66,19,60,229,183,40,61,188,33,13,61,40,68,160,189,195,101,85,61,144,46,182,188,86,45,137,61,83,174,240,189,181,194,148,189,75,6,128,61,0,227,25,61,66,179,107,189,133,237,159,190,237,185,12,61,134,57,1,189,86,42,40,59,29,90,84,190,11,179,144,189,25,229,153,188,239,143,55,189,208,241,81,188,169,77,156,189,105,30,160,61,179,153,195,60,151,198,239,61,182,157,182,60,171,90,82,190,115,133,119,189,87,176,141,188,208,43,158,187,213,94,164,190,195,187,188,189,140,19,31,61,164,228,149,61,65,68,138,189,145,66,217,60,90,18,48,62,200,211,178,61,161,74,13,61,232,160,11,189,168,29,30,62,18,159,123,189,77,161,243,59,64,133,227,189,17,143,196,189,60,132,113,60,241,127,7,190,163,205,241,188,151,197,68,190,237,17,202,61,18,21,170,60,152,76,53,62,210,29,132,189,85,249,94,189,88,88,112,189,34,136,243,186,220,159,43,62,176,230,128,60,134,145,94,61,198,250,134,60,169,218,62,62,164,196,46,188,184,4,96,61,168,200,1,62,40,73,87,60,254,10,185,61,137,208,8,190,99,152,147,188,40,72,28,190,101,25,226,60,95,7,14,190,28,236,77,189,197,229,56,61,61,41,243,189,238,36,194,61,165,160,43,190,162,153,199,61,49,154,21,188,212,183,76,62,93,253,88,189,156,253,33,62,136,218,54,62,100,93,220,189,29,115,30,60,241,45,172,189,147,229,36,189,241,155,82,190,132,184,210,61,17,224,100,62,38,229,46,61,75,201,242,61,208,70,174,188,101,82,227,61,10,216,30,190,185,226,226,60,54,145,25,190,49,40,83,61,252,81,4,190,71,176,49,62,162,126,151,61,3,149,65,190,253,103,13,189,240,109,218,189,36,9,66,188,63,30,74,190,205,173,96,62,255,151,59,62,203,243,96,189,21,111,20,62,218,146,21,61,125,236,174,189,83,145,106,190,183,40,19,190,213,177,74,189,170,100,32,62,51,25,14,188,84,170,132,189,249,163,168,61,78,43,21,62,65,215,62,59,246,41,87,190,27,185,238,189,73,157,160,61,181,53,98,62,185,110,138,189,72,27,71,61,88,230,173,61,234,148,135,189,68,110,230,189,80,254,94,190,41,63,169,189,206,167,142,188,151,202,107,62,131,221,144,189,72,81,135,61,18,108,92,62,195,186,145,61,102,160,178,189,177,22,79,190,183,67,67,188,41,231,203,61,192,232,50,62,43,193,130,189,175,235,247,189,145,99,107,60,222,228,7,62,91,206,165,187,255,121,122,190,113,1,56,190,45,236,9,190,183,95,190,60,51,192,69,190,18,165,157,189,32,96,173,188,125,4,254,186,237,186,39,190,21,57,228,189,35,105,87,190,120,94,42,190,54,90,14,61,9,110,36,60,72,139,179,188,237,74,139,61,245,244,177,189,218,228,128,190,163,202,136,190,235,30,25,61,56,245,129,59,191,129,9,61,100,36,27,190,65,97,208,60,219,247,168,188,175,237,157,190,112,176,175,190,98,244,188,189,79,33,215,188,198,51,232,188,124,154,19,61,95,13,16,61,201,147,4,62,157,70,250,61,127,75,128,60,6,157,144,189,169,49,193,189,216,71,135,189,166,70,40,189,43,247,34,62,126,225,149,61,192,94,225,61,135,168,50,62,164,226,159,61,112,207,115,188,249,248,4,60,144,106,88,60,234,90,155,61,173,76,72,62,51,112,128,61,254,43,139,61,174,154,103,61,15,154,29,190,166,38,17,190,24,149,148,189,106,79,9,61,65,14,202,188,246,182,9,62,153,242,161,61,122,196,8,62,196,148,104,62,251,229,147,60,15,123,161,59,206,56,45,62,105,110,133,61,159,200,147,61,71,202,6,62,130,58,197,61,24,93,94,61,191,156,217,61,47,196,234,61,50,202,243,61,38,228,3,63,7,94,125,62,201,233,75,62,65,11,89,62,144,158,2,62,210,224,150,190,63,145,71,190,56,192,76,189,193,225,229,189,35,18,5,188,11,96,202,187,3,178,23,61,148,21,227,189,30,253,127,190,169,23,28,62,125,64,112,62,41,5,29,62,57,213,178,62,77,220,46,63,57,242,32,62,54,174,255,61,209,7,203,61,209,231,131,61,146,92,126,190,254,12,31,190,85,18,217,188,55,26,192,188,180,233,72,61,224,218,233,189,9,196,235,59,157,17,53,190,114,252,192,190,49,121,187,62,171,65,56,190,123,18,24,190,92,4,198,59,16,33,46,62,248,109,200,61,92,62,210,189,21,87,133,190,65,215,126,62,60,161,23,61,46,228,241,189,189,26,160,61,195,212,70,62,94,102,88,62,182,186,188,62,233,240,184,62,33,34,5,62,220,215,193,61,127,218,104,62,214,84,54,190,211,18,235,189,129,152,4,188,60,160,108,62,36,9,66,188,181,136,200,189,175,205,166,190,187,72,17,62,50,57,245,61,14,245,107,190,95,121,240,189,12,201,233,189,45,64,27,61,54,90,238,61,8,6,96,62,143,168,208,189,159,146,115,61,247,59,244,61,221,40,50,60,171,208,0,189,77,102,60,61,98,158,245,61,69,42,140,62,36,151,159,62,221,9,134,62,3,124,71,62,17,254,173,62,30,50,117,62,213,91,131,61,45,235,158,61,106,190,202,61,148,250,18,62,79,8,61,62,241,160,25,61,230,231,102,62,25,230,196,61,41,232,22,190,45,210,84,190,145,239,50,190,196,237,176,189,166,129,31,189,39,104,35,62,75,59,181,189,85,161,129,186,216,127,221,61,68,23,212,188,142,234,148,189,169,247,212,60,179,235,222,187,158,237,177,189,177,249,56,188,149,212,137,190,152,221,211,189,208,208,255,189,170,67,238,189,161,218,16,62,171,207,85,62,54,33,45,61,137,178,135,62,164,55,4,63,45,208,94,62,163,92,154,188,135,108,160,190,90,103,44,190,87,10,65,61,148,77,185,61,22,250,224,189,171,176,153,188,157,185,87,62,126,2,144,62,122,140,50,189,186,221,11,189,129,122,115,190,73,20,10,190,235,112,148,189,89,165,212,189,34,26,29,61,79,3,158,62,87,147,23,62,9,223,59,189,127,217,253,189,175,235,87,190,144,16,133,189,179,183,20,189,1,105,63,189,246,8,181,188,53,38,196,61,228,159,209,62,104,92,120,61,123,133,133,189,153,73,84,61,105,56,229,60,17,111,29,188,64,252,12,190,33,149,194,189,67,4,156,188,93,136,53,62,54,228,31,60,227,168,188,189,129,235,138,188,153,18,9,190,182,134,242,189,84,59,3,189,207,158,203,187,213,35,173,189,58,3,131,61,158,209,150,189,248,166,41,62,241,47,226,61,181,194,52,61,22,190,62,61,182,72,90,61,81,48,99,189,11,38,126,60,214,111,190,62,38,172,109,62,26,162,138,188,241,242,212,61,158,235,187,189,130,143,193,59,79,30,86,62,30,54,33,62,226,0,250,60,249,47,128,62,90,69,127,61,182,103,22,61,126,229,193,61,80,197,141,60,198,54,41,188,11,209,161,189,79,120,137,60,82,68,230,189,193,28,125,61,146,65,46,61,153,215,1,190,47,110,35,188,44,125,104,189,24,39,62,61,149,98,71,190,157,190,14,190,210,139,26,189,222,199,33,62,202,53,133,188,78,156,252,61,181,24,108,62,49,153,170,61,132,72,134,188,135,252,115,61,213,91,131,188,144,164,132,189,253,130,109,62,90,99,32,62,212,186,13,61,130,31,21,62,235,57,41,61,146,116,13,61,213,145,163,60,51,168,182,189,84,25,70,188,111,159,157,62,141,122,88,62,164,139,205,188,150,206,23,190,61,125,4,190,42,31,130,61,187,127,140,189,167,36,139,189,54,201,15,189,88,228,87,62,209,174,130,61,105,138,128,61,185,23,184,189,98,76,250,188,243,85,114,60,29,146,90,189,12,231,26,189,255,91,73,190,210,109,9,60,128,70,169,189,70,125,18,62,77,134,131,61,174,240,142,61,253,159,67,62,60,80,199,61,57,240,234,188,226,57,155,61,185,85,160,62,153,158,176,61,94,160,84,62,46,228,145,60,178,161,251,61,223,249,101,62,177,107,43,62,97,168,195,188,39,74,66,61,178,44,176,62,58,64,64,62,252,113,11,62,196,35,17,62,13,169,130,61,61,70,57,61,124,101,158,189,176,3,103,187,130,0,41,190,165,216,209,188,158,7,151,189,178,98,40,62,52,128,55,60,195,101,21,190,201,255,228,188,21,230,125,189,235,82,35,189,156,51,18,190,193,170,26,62,115,159,28,189,233,181,89,61,231,0,161,61,192,64,176,61,180,3,206,61,126,30,3,62,152,107,145,189,246,181,238,189,155,114,85,62,142,63,81,61,221,95,157,61,13,251,189,60,169,161,173,189,216,42,65,188,184,90,23,62,143,224,70,189,46,85,233,189,149,15,145,62,52,132,67,62,41,8,190,61,226,61,7,61,165,216,17,190,71,230,17,190,146,204,202,189,150,4,40,189,28,37,47,189,145,44,80,62,154,8,91,189,202,196,45,61,232,47,100,62,29,4,157,188,74,95,8,190,47,108,141,190,86,16,3,189,189,53,240,61,72,24,54,62,64,166,117,189,129,152,132,189,171,178,239,189,172,54,31,190,233,214,203,189,86,15,40,62,54,148,218,188,117,31,192,189,149,186,116,62,73,48,213,187,102,73,0,60,29,204,134,61,202,135,80,190,196,177,206,189,51,194,91,189,146,232,5,190,221,66,215,60,136,245,6,62,122,28,6,61,12,61,2,62,68,253,238,61,42,253,36,190,104,62,143,190,165,73,129,190,76,226,44,187,163,91,47,61,127,50,198,61,58,122,252,189,69,212,132,61,115,75,43,188,196,8,97,190,48,19,117,190,69,188,213,189,122,168,109,189,229,122,91,189,41,206,209,60,44,17,168,59,244,167,205,189,130,60,59,189,131,21,71,190,23,102,1,190,13,26,250,188,137,149,81,61,91,36,93,62,38,138,48,62,27,13,96,189,121,117,62,190,52,133,142,190,117,87,70,190,13,27,37,189,231,198,116,59,124,155,254,187,238,10,253,61,73,190,66,62,84,87,158,189,252,112,240,61,120,13,90,62,189,58,71,60,106,250,236,56,67,229,223,60,218,170,36,61,62,94,8,61,91,180,96,62,28,152,60,62,100,201,132,62,101,86,159,62,103,14,169,61,147,24,68,189,24,153,160,189,254,15,48,60,173,52,169,61,108,181,159,62,103,126,157,62,99,42,125,59,138,89,175,60,166,43,216,188,117,85,160,188,149,155,168,60,34,28,115,189,34,110,206,60,155,203,133,62,113,198,176,61,140,15,19,62,195,187,220,61,36,151,127,59,37,235,64,190,60,244,29,189,31,46,217,189,95,40,0,190,241,45,44,188,32,69,93,61,237,240,119,62,3,237,142,62,23,184,92,62,84,169,177,62,225,183,225,62,158,38,115,62,17,198,111,62,88,113,154,62,185,251,44,62,205,91,85,190,113,228,1,190,143,25,40,60,73,216,247,61,9,249,128,189,37,119,88,189,93,50,78,61,36,71,122,189,84,112,136,190,85,132,219,61,24,150,15,62,174,100,143,62,48,102,147,62,207,19,191,62,251,59,27,62,45,181,94,60,21,200,236,61,242,119,111,60,75,60,144,190,161,76,115,190,155,61,240,189,57,155,14,184,79,5,12,190,80,252,72,190,83,5,195,189,68,81,0,190,95,67,128,190,191,124,114,62,128,14,147,189,195,70,25,189,210,140,69,61,59,168,164,62,126,81,130,61,112,237,196,60,84,168,238,188,207,134,108,62,126,114,36,62,61,15,30,190,170,102,86,188,209,177,163,189,225,237,193,61,138,61,36,62,147,144,56,62,1,193,92,61,188,90,206,61,113,199,147,62,43,110,28,61,120,13,58,62,194,49,107,62,112,93,225,62,98,216,129,61,189,141,205,59,20,237,170,60,110,105,173,62,106,50,131,62,204,236,51,189,155,200,236,61,180,1,88,59,226,35,50,62,22,163,174,60,130,172,39,189,159,146,243,189,211,193,58,62,137,149,113,62,217,10,90,189,220,160,118,188,249,246,206,189,36,66,195,61,197,89,81,61,7,183,37,62,66,150,5,61,235,82,35,62,88,57,148,61,114,135,205,60,42,139,194,60,20,206,238,60,162,39,37,62,156,21,241,189,4,61,20,189,212,16,53,190,231,228,37,190,160,250,103,62,244,106,160,189,155,115,48,61,115,16,244,189,238,178,95,61,116,152,207,189,18,46,132,189,129,36,236,189,1,106,10,62,192,5,153,62,174,211,200,61,7,38,183,61,101,169,245,187,173,20,226,61,79,32,236,188,41,174,170,60,203,191,22,189,190,107,0,62,44,183,68,62,223,107,72,189,125,62,74,59,92,255,46,188,68,251,152,61,252,57,133,188,174,188,196,61,136,218,118,61,231,115,238,187,116,122,14,62,246,35,165,189,62,7,22,61,45,63,176,61,129,37,7,62,39,135,175,61,11,68,207,60,47,133,103,62,231,110,71,62,145,210,44,61,98,162,33,190,89,22,140,189,69,216,16,190,195,185,230,189,204,69,156,189,112,124,141,189,229,38,234,189,255,231,208,189,154,93,7,62,81,77,137,189,165,103,218,61,56,189,75,62,27,188,47,62,45,64,43,62,120,40,10,189,77,45,219,188,125,65,171,61,200,11,25,62,109,111,55,187,61,185,166,185,168,143,64,60,208,240,134,61,61,10,183,189,219,51,75,189,10,248,101,62,194,190,93,62,177,251,14,189,67,60,146,188,215,132,180,189,56,190,246,59,209,8,118,62,149,14,150,61,14,77,89,60,223,135,51,62,149,243,69,60,103,127,192,61,91,97,122,60,251,201,216,61,220,41,221,61,143,84,159,61,174,242,196,189,255,8,163,189,114,22,54,62,53,207,17,62,97,140,8,61,229,242,159,189,74,38,167,189,187,123,64,189,87,206,14,62,119,17,166,60,214,59,252,189,183,121,51,62,3,124,215,61,196,208,106,61,158,179,165,61,144,162,78,188,103,210,198,189,19,15,168,61,10,19,198,189,3,233,130,189,174,186,78,62,243,61,3,62,163,145,15,189,117,0,4,189,118,140,139,189,216,100,237,189,78,185,194,61,112,36,176,189,252,83,138,189,243,29,252,60,5,253,5,61,154,36,182,61,109,143,94,61,114,23,33,189,94,132,233,189,201,202,47,62,141,8,230,189,152,222,94,190,61,128,133,61,100,172,118,61,67,201,68,62,219,167,99,61,234,64,6,190,87,205,19,190,183,93,104,61,237,40,14,189,74,38,167,189,143,139,10,190,216,244,32,186,37,144,178,61,143,111,111,60,4,171,138,61,13,140,220,61,223,50,103,62,118,197,172,61,34,252,11,188,231,141,83,61,147,30,70,189,54,148,26,189,13,171,120,189,187,238,45,59,69,187,138,60,167,59,175,61,165,192,130,188,162,209,157,188,27,241,228,61,250,125,127,61,18,222,78,62,181,110,67,61,223,25,45,61,67,199,142,61,47,190,120,62,62,117,172,60,117,30,149,189,126,169,31,190,79,144,216,188,83,231,17,61,10,104,162,189,183,210,235,188,161,244,69,189,161,128,173,61,1,19,120,189,31,133,171,189,71,3,40,190,21,225,38,189,150,147,176,189,55,51,122,60,81,134,170,187,32,98,131,188,143,169,59,61,213,146,78,189,3,8,159,189,216,214,239,61,117,119,29,60,123,49,20,188,159,117,13,188,205,206,98,189,254,15,176,189,117,177,233,60,219,50,96,189,134,31,44,190,36,15,52,62,237,211,145,61,20,91,193,188,95,68,27,61,113,116,149,187,240,106,185,188,27,155,253,61,247,120,193,61,21,87,149,189,115,217,8,190,121,230,101,188,27,46,18,190,2,45,221,188,223,49,76,190,7,98,89,60,206,111,104,62,57,69,71,61,122,23,47,190,166,96,77,189,30,27,1,60,226,117,125,61,119,73,156,60,216,126,50,189,164,55,28,189,174,12,10,62,209,148,93,61,154,66,167,189,5,21,53,62,195,71,68,61,112,94,28,189,134,118,78,61,182,129,219,189,74,153,20,189,239,172,221,60,193,26,167,61,192,207,56,187,188,91,185,61,109,141,8,189,185,0,116,189,115,156,91,60,102,131,204,189,137,67,150,61,35,132,175,62,34,84,201,61,39,136,26,190,230,146,170,188,228,78,105,189,57,125,61,61,212,209,49,189,160,253,24,190,26,52,4,190,184,145,50,188,192,32,105,188,141,68,56,190,157,131,231,189,245,158,74,189,174,43,134,189,244,222,184,61,233,71,67,188,155,232,179,61,177,48,196,61,81,162,21,62,35,19,208,61,17,225,159,61,165,190,172,189,217,205,204,189,15,240,164,188,2,126,77,189,163,115,126,61,156,220,111,60,200,209,156,60,29,174,21,61,36,68,57,62,152,251,100,188,169,189,136,189,85,222,142,186,214,55,144,189,121,144,158,187,222,33,197,186,12,62,13,61,175,33,56,189,31,45,78,189,215,135,181,189,13,250,50,190,102,188,237,189,109,112,82,190,158,96,127,60,242,119,47,189,127,104,198,189,42,142,19,190,210,229,77,189,228,132,73,190,105,138,224,61,98,246,138,62,205,230,49,62,206,83,221,61,5,49,32,62,104,121,254,61,208,38,199,61,240,107,116,62,66,233,171,61,113,114,223,61,135,80,101,62,222,204,136,62,130,86,224,60,94,130,211,60,90,18,0,62,181,249,191,61,48,73,37,61,56,74,30,61,125,145,80,188,64,133,19,62,45,206,88,61,141,183,21,188,97,109,172,61,88,30,36,62,101,111,41,189,33,206,67,60,174,184,248,189,88,140,218,189,145,212,66,189,223,138,68,61,184,172,130,190,181,226,155,189,92,27,202,61,29,119,26,190,27,161,47,190,33,89,32,190,125,236,110,61,42,254,63,62,24,119,211,62,80,228,13,63,129,150,190,62,84,167,115,62,21,31,255,61,81,250,226,61,155,29,41,60,25,170,50,190,6,128,138,189,28,178,1,187,201,87,18,62,10,73,38,61,1,20,163,60,91,176,212,60,47,134,50,189,87,66,247,189,197,171,204,61,36,125,186,61,12,62,125,62,159,32,81,62,197,29,47,189,172,115,140,189,82,183,243,189,25,232,218,60,5,194,14,61,238,149,121,189,12,62,205,188,106,132,190,189,59,226,16,189,87,206,110,190,112,67,76,189,205,92,32,189,115,130,182,188,243,229,133,189,67,5,17,193,100,0,0,0,0,0,0,0,152,78,0,0,111,5,0,0,112,5,0,0,153,0,0,0,52,3,0,0,47,1,0,0,67,2,0,0,0,0,0,0,176,78,0,0,113,5,0,0,114,5,0,0,154,0,0,0,53,3,0,0,68,2,0,0,155,0,0,0,69,2,0,0,0,0,0,0,192,78,0,0,113,5,0,0,115,5,0,0,156,0,0,0,54,3,0,0,70,2,0,0,155,0,0,0,69,2,0,0,0,0,0,0,208,78,0,0,116,5,0,0,117,5,0,0,157,0,0,0,55,3,0,0,48,1,0,0,71,2,0,0,0,0,0,0,240,78,0,0,118,5,0,0,119,5,0,0,72,2,0,0,0,0,0,0,8,79,0,0,228,2,0,0,120,5,0,0,121,5,0,0,102,0,0,0,212,194,7,0,116,194,7,0,164,194,7,0,152,194,7,0,4,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,4,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,7,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,9,0,0,0,3,0,0,0,8,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,1,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,4,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,7,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,9,0,0,0,3,0,0,0,8,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,164,194,7,0,28,237,7,0,172,236,7,0,20,66,7,0,26,66,7,0,33,66,7,0,39,66,7,0,47,66,7,0,121,236,7,0,55,66,7,0,62,66,7,0,68,66,7,0,76,66,7,0,82,66,7,0,89,66,7,0,94,66,7,0,103,66,7,0,112,66,7,0,119,66,7,0,164,194,7,0,33,66,7,0,20,66,7,0,82,66,7,0,26,66,7,0,28,237,7,0,172,236,7,0,121,236,7,0,89,66,7,0,55,66,7,0,68,66,7,0,164,194,7,0,126,66,7,0,135,66,7,0,144,66,7,0,0,0,0,0,80,79,0,0,228,2,0,0,122,5,0,0,123,5,0,0,24,75,7,0,36,75,7,0,51,75,7,0,64,75,7,0,76,75,7,0,93,75,7,0,108,75,7,0,122,75,7,0,0,0,0,0,48,79,0,0,124,5,0,0,125,5,0,0,103,0,0,0,104,0,0,0,0,0,0,0,32,79,0,0,126,5,0,0,127,5,0,0,158,0,0,0,0,0,0,0,64,79,0,0,228,2,0,0,128,5,0,0,129,5,0,0,0,0,0,0,96,79,0,0,228,2,0,0,130,5,0,0,131,5,0,0,0,0,0,0,112,79,0,0,228,2,0,0,132,5,0,0,133,5,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,120,0,0,0,124,0,0,0,16,0,0,0,96,0,0,0,108,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,80,0,0,0,132,0,0,0,136,0,0,0,128,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,4,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,144,0,0,0,16,0,0,0,80,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,0,148,0,0,0,112,0,0,0,128,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,255,255,255,255,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,32,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,40,0,0,0,48,0,0,0,52,0,0,0,24,0,0,0,20,0,0,0,28,0,0,0,44,0,0,0,32,0,0,0,36,0,0,0,0,0,0,0,6,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,7,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,64,0,0,0,16,0,0,0,68,0,0,0,32,0,0,0,48,0,0,0,0,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,20,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,32,0,0,0,16,0,0,0,36,0,0,0,0,0,0,0,255,255,255,255,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,52,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,92,0,0,0,56,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,80,0,0,0,60,0,0,0,64,0,0,0,68,0,0,0,72,0,0,0,76,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,2,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,8,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,52,0,0,0,56,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,32,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,49,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,52,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,36,0,0,0,40,0,0,0,255,255,255,255,0,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,64,0,0,0,68,0,0,0,48,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,1,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,0,0,0,0,128,79,0,0,134,5,0,0,135,5,0,0,180,0,0,0,73,2,0,0,49,1,0,0,74,2,0,0,75,2,0,0,136,5,0,0,76,2,0,0,181,0,0,0,182,0,0,0,50,1,0,0,77,2,0,0,56,3,0,0,32,0,0,0,78,2,0,0,159,0,0,0,35,0,0,0,57,3,0,0,58,3,0,0,234,2,0,0,36,0,0,0,59,3,0,0,37,0,0,0,60,3,0,0,0,0,0,0,6,0,0,0,32,0,0,0,7,0,0,0,24,0,0,0,140,0,0,0,36,0,0,0,44,0,0,0,28,0,0,0,47,0,0,0,54,0,0,0,24,0,0,0,56,0,0,0,71,0,0,0,152,0,0,0,81,0,0,0,87,0,0,0,48,0,0,0,88,0,0,0,103,0,0,0,56,0,0,0,113,0,0,0,120,0,0,0,24,0,0,0,122,0,0,0,129,0,0,0,24,0,0,0,131,0,0,0,141,0,0,0,72,0,0,0,146,0,0,0,154,0,0,0,28,0,0,0,157,0,0,0,165,0,0,0,40,0,0,0,168,0,0,0,179,0,0,0,36,0,0,0,185,0,0,0,209,0,0,0,96,0,0,0,228,0,0,0,238,0,0,0,52,0,0,0,243,0,0,0,255,0,0,0,60,0,0,0,6,1,0,0,12,1,0,0,48,0,0,0,13,1,0,0,21,1,0,0,52,0,0,0,24,1,0,0,31,1,0,0,52,0,0,0,33,1,0,0,40,1,0,0,52,0,0,0,42,1,0,0,50,1,0,0,56,0,0,0,53,1,0,0,60,1,0,0,24,0,0,0,62,1,0,0,74,1,0,0,72,0,0,0,81,1,0,0,91,1,0,0,72,0,0,0,96,1,0,0,102,1,0,0,32,0,0,0,103,1,0,0,112,1,0,0,44,0,0,0,116,1,0,0,122,1,0,0,32,0,0,0,232,11,8,0,8,12,8,0,152,12,8,0,184,12,8,0,208,12,8,0,104,13,8,0,152,13,8,0,208,13,8,0,232,13,8,0,0,14,8,0,72,14,8,0,104,14,8,0,144,14,8,0,184,14,8,0,24,15,8,0,80,15,8,0,144,15,8,0,192,15,8,0,248,15,8,0,48,16,8,0,104,16,8,0,160,16,8,0,184,16,8,0,0,17,8,0,72,17,8,0,104,17,8,0,152,17,8,0,0,0,0,0,144,79,0,0,137,5,0,0,138,5,0,0,180,0,0,0,79,2,0,0,51,1,0,0,80,2,0,0,81,2,0,0,139,5,0,0,82,2,0,0,181,0,0,0,182,0,0,0,52,1,0,0,83,2,0,0,61,3,0,0,32,0,0,0,84,2,0,0,160,0,0,0,35,0,0,0,62,3,0,0,63,3,0,0,234,2,0,0,36,0,0,0,64,3,0,0,37,0,0,0,65,3,0,0,0,0,0,0,160,79,0,0,140,5,0,0,141,5,0,0,180,0,0,0,85,2,0,0,53,1,0,0,86,2,0,0,87,2,0,0,142,5,0,0,88,2,0,0,181,0,0,0,182,0,0,0,54,1,0,0,89,2,0,0,66,3,0,0,32,0,0,0,90,2,0,0,161,0,0,0,35,0,0,0,67,3,0,0,68,3,0,0,234,2,0,0,36,0,0,0,69,3],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+153600);allocate([37,0,0,0,70,3,0,0,0,0,0,0,176,79,0,0,143,5,0,0,144,5,0,0,180,0,0,0,91,2,0,0,55,1,0,0,92,2,0,0,93,2,0,0,145,5,0,0,94,2,0,0,181,0,0,0,182,0,0,0,56,1,0,0,95,2,0,0,71,3,0,0,32,0,0,0,96,2,0,0,162,0,0,0,35,0,0,0,72,3,0,0,73,3,0,0,234,2,0,0,36,0,0,0,74,3,0,0,37,0,0,0,75,3,0,0,0,0,0,0,192,79,0,0,146,5,0,0,147,5,0,0,180,0,0,0,97,2,0,0,57,1,0,0,98,2,0,0,99,2,0,0,148,5,0,0,100,2,0,0,181,0,0,0,182,0,0,0,58,1,0,0,101,2,0,0,76,3,0,0,32,0,0,0,102,2,0,0,163,0,0,0,35,0,0,0,77,3,0,0,78,3,0,0,234,2,0,0,36,0,0,0,79,3,0,0,37,0,0,0,80,3,0,0,0,0,0,0,208,79,0,0,149,5,0,0,150,5,0,0,180,0,0,0,103,2,0,0,59,1,0,0,104,2,0,0,105,2,0,0,151,5,0,0,106,2,0,0,181,0,0,0,182,0,0,0,60,1,0,0,107,2,0,0,81,3,0,0,32,0,0,0,108,2,0,0,164,0,0,0,35,0,0,0,82,3,0,0,83,3,0,0,234,2,0,0,36,0,0,0,84,3,0,0,37,0,0,0,85,3,0,0,0,0,0,0,224,79,0,0,152,5,0,0,153,5,0,0,180,0,0,0,109,2,0,0,61,1,0,0,110,2,0,0,111,2,0,0,154,5,0,0,112,2,0,0,181,0,0,0,182,0,0,0,62,1,0,0,113,2,0,0,86,3,0,0,32,0,0,0,114,2,0,0,165,0,0,0,35,0,0,0,87,3,0,0,88,3,0,0,234,2,0,0,36,0,0,0,89,3,0,0,37,0,0,0,90,3,0,0,0,0,0,0,240,79,0,0,155,5,0,0,156,5,0,0,180,0,0,0,115,2,0,0,63,1,0,0,116,2,0,0,117,2,0,0,157,5,0,0,118,2,0,0,181,0,0,0,182,0,0,0,64,1,0,0,119,2,0,0,91,3,0,0,32,0,0,0,120,2,0,0,166,0,0,0,35,0,0,0,92,3,0,0,93,3,0,0,234,2,0,0,36,0,0,0,94,3,0,0,37,0,0,0,95,3,0,0,0,0,0,0,0,80,0,0,158,5,0,0,159,5,0,0,180,0,0,0,121,2,0,0,65,1,0,0,122,2,0,0,123,2,0,0,160,5,0,0,124,2,0,0,181,0,0,0,182,0,0,0,66,1,0,0,125,2,0,0,96,3,0,0,32,0,0,0,126,2,0,0,167,0,0,0,35,0,0,0,97,3,0,0,98,3,0,0,234,2,0,0,36,0,0,0,99,3,0,0,37,0,0,0,100,3,0,0,0,0,0,0,16,80,0,0,161,5,0,0,162,5,0,0,180,0,0,0,127,2,0,0,67,1,0,0,128,2,0,0,129,2,0,0,163,5,0,0,130,2,0,0,181,0,0,0,182,0,0,0,68,1,0,0,131,2,0,0,101,3,0,0,32,0,0,0,132,2,0,0,168,0,0,0,35,0,0,0,102,3,0,0,103,3,0,0,234,2,0,0,36,0,0,0,104,3,0,0,37,0,0,0,105,3,0,0,0,0,0,0,32,80,0,0,164,5,0,0,165,5,0,0,180,0,0,0,133,2,0,0,69,1,0,0,134,2,0,0,135,2,0,0,166,5,0,0,136,2,0,0,181,0,0,0,182,0,0,0,70,1,0,0,137,2,0,0,106,3,0,0,32,0,0,0,138,2,0,0,169,0,0,0,35,0,0,0,107,3,0,0,108,3,0,0,234,2,0,0,36,0,0,0,109,3,0,0,37,0,0,0,110,3,0,0,0,0,0,0,48,80,0,0,167,5,0,0,168,5,0,0,180,0,0,0,139,2,0,0,71,1,0,0,140,2,0,0,141,2,0,0,169,5,0,0,142,2,0,0,181,0,0,0,182,0,0,0,72,1,0,0,143,2,0,0,111,3,0,0,32,0,0,0,144,2,0,0,170,0,0,0,35,0,0,0,112,3,0,0,113,3,0,0,234,2,0,0,36,0,0,0,114,3,0,0,37,0,0,0,115,3,0,0,0,0,0,0,64,80,0,0,170,5,0,0,171,5,0,0,180,0,0,0,145,2,0,0,73,1,0,0,146,2,0,0,147,2,0,0,172,5,0,0,148,2,0,0,181,0,0,0,182,0,0,0,74,1,0,0,149,2,0,0,116,3,0,0,32,0,0,0,150,2,0,0,171,0,0,0,35,0,0,0,117,3,0,0,118,3,0,0,234,2,0,0,36,0,0,0,119,3,0,0,37,0,0,0,120,3,0,0,0,0,0,0,80,80,0,0,173,5,0,0,174,5,0,0,180,0,0,0,151,2,0,0,75,1,0,0,152,2,0,0,153,2,0,0,175,5,0,0,154,2,0,0,181,0,0,0,182,0,0,0,76,1,0,0,155,2,0,0,121,3,0,0,32,0,0,0,156,2,0,0,172,0,0,0,35,0,0,0,122,3,0,0,123,3,0,0,234,2,0,0,36,0,0,0,124,3,0,0,37,0,0,0,125,3,0,0,0,0,0,0,96,80,0,0,176,5,0,0,177,5,0,0,180,0,0,0,157,2,0,0,77,1,0,0,158,2,0,0,159,2,0,0,178,5,0,0,160,2,0,0,181,0,0,0,182,0,0,0,78,1,0,0,161,2,0,0,126,3,0,0,32,0,0,0,162,2,0,0,173,0,0,0,35,0,0,0,127,3,0,0,128,3,0,0,234,2,0,0,36,0,0,0,129,3,0,0,37,0,0,0,130,3,0,0,0,0,0,0,112,80,0,0,179,5,0,0,180,5,0,0,180,0,0,0,163,2,0,0,79,1,0,0,164,2,0,0,165,2,0,0,181,5,0,0,166,2,0,0,181,0,0,0,182,0,0,0,80,1,0,0,167,2,0,0,131,3,0,0,32,0,0,0,168,2,0,0,174,0,0,0,35,0,0,0,132,3,0,0,133,3,0,0,234,2,0,0,36,0,0,0,134,3,0,0,37,0,0,0,135,3,0,0,0,0,0,0,128,80,0,0,182,5,0,0,183,5,0,0,180,0,0,0,169,2,0,0,81,1,0,0,170,2,0,0,171,2,0,0,184,5,0,0,172,2,0,0,181,0,0,0,182,0,0,0,82,1,0,0,173,2,0,0,136,3,0,0,32,0,0,0,174,2,0,0,175,0,0,0,35,0,0,0,137,3,0,0,138,3,0,0,234,2,0,0,36,0,0,0,139,3,0,0,37,0,0,0,140,3,0,0,0,0,0,0,144,80,0,0,185,5,0,0,186,5,0,0,180,0,0,0,175,2,0,0,83,1,0,0,176,2,0,0,177,2,0,0,187,5,0,0,178,2,0,0,181,0,0,0,182,0,0,0,84,1,0,0,179,2,0,0,141,3,0,0,32,0,0,0,180,2,0,0,176,0,0,0,35,0,0,0,142,3,0,0,143,3,0,0,234,2,0,0,36,0,0,0,144,3,0,0,37,0,0,0,145,3,0,0,0,0,0,0,160,80,0,0,188,5,0,0,189,5,0,0,180,0,0,0,181,2,0,0,85,1,0,0,182,2,0,0,183,2,0,0,190,5,0,0,184,2,0,0,181,0,0,0,182,0,0,0,86,1,0,0,185,2,0,0,146,3,0,0,32,0,0,0,186,2,0,0,177,0,0,0,35,0,0,0,147,3,0,0,148,3,0,0,234,2,0,0,36,0,0,0,149,3,0,0,37,0,0,0,150,3,0,0,0,0,0,0,176,80,0,0,191,5,0,0,192,5,0,0,180,0,0,0,187,2,0,0,87,1,0,0,188,2,0,0,189,2,0,0,193,5,0,0,190,2,0,0,181,0,0,0,182,0,0,0,88,1,0,0,191,2,0,0,151,3,0,0,32,0,0,0,192,2,0,0,178,0,0,0,35,0,0,0,152,3,0,0,153,3,0,0,234,2,0,0,36,0,0,0,154,3,0,0,37,0,0,0,155,3,0,0,0,0,0,0,192,80,0,0,194,5,0,0,195,5,0,0,180,0,0,0,193,2,0,0,89,1,0,0,194,2,0,0,195,2,0,0,196,5,0,0,196,2,0,0,181,0,0,0,182,0,0,0,90,1,0,0,197,2,0,0,156,3,0,0,32,0,0,0,198,2,0,0,179,0,0,0,35,0,0,0,157,3,0,0,158,3,0,0,234,2,0,0,36,0,0,0,159,3,0,0,37,0,0,0,160,3,0,0,0,0,0,0,208,80,0,0,197,5,0,0,198,5,0,0,180,0,0,0,199,2,0,0,91,1,0,0,200,2,0,0,201,2,0,0,199,5,0,0,202,2,0,0,181,0,0,0,182,0,0,0,92,1,0,0,203,2,0,0,161,3,0,0,32,0,0,0,204,2,0,0,180,0,0,0,35,0,0,0,162,3,0,0,163,3,0,0,234,2,0,0,36,0,0,0,164,3,0,0,37,0,0,0,165,3,0,0,0,0,0,0,224,80,0,0,200,5,0,0,201,5,0,0,180,0,0,0,205,2,0,0,93,1,0,0,206,2,0,0,207,2,0,0,202,5,0,0,208,2,0,0,181,0,0,0,182,0,0,0,94,1,0,0,209,2,0,0,166,3,0,0,32,0,0,0,210,2,0,0,181,0,0,0,35,0,0,0,167,3,0,0,168,3,0,0,234,2,0,0,36,0,0,0,169,3,0,0,37,0,0,0,170,3,0,0,0,0,0,0,240,80,0,0,203,5,0,0,204,5,0,0,180,0,0,0,211,2,0,0,95,1,0,0,212,2,0,0,213,2,0,0,205,5,0,0,214,2,0,0,181,0,0,0,182,0,0,0,96,1,0,0,215,2,0,0,171,3,0,0,32,0,0,0,216,2,0,0,182,0,0,0,35,0,0,0,172,3,0,0,173,3,0,0,234,2,0,0,36,0,0,0,174,3,0,0,37,0,0,0,175,3,0,0,0,0,0,0,0,81,0,0,206,5,0,0,207,5,0,0,180,0,0,0,217,2,0,0,97,1,0,0,218,2,0,0,219,2,0,0,208,5,0,0,220,2,0,0,181,0,0,0,182,0,0,0,98,1,0,0,221,2,0,0,176,3,0,0,32,0,0,0,222,2,0,0,183,0,0,0,35,0,0,0,177,3,0,0,178,3,0,0,234,2,0,0,36,0,0,0,179,3,0,0,37,0,0,0,180,3,0,0,0,0,0,0,16,81,0,0,209,5,0,0,210,5,0,0,180,0,0,0,223,2,0,0,99,1,0,0,224,2,0,0,225,2,0,0,211,5,0,0,226,2,0,0,181,0,0,0,182,0,0,0,100,1,0,0,227,2,0,0,181,3,0,0,32,0,0,0,228,2,0,0,184,0,0,0,35,0,0,0,182,3,0,0,183,3,0,0,234,2,0,0,36,0,0,0,184,3,0,0,37,0,0,0,185,3,0,0,0,0,0,0,32,81,0,0,212,5,0,0,213,5,0,0,180,0,0,0,229,2,0,0,101,1,0,0,230,2,0,0,231,2,0,0,214,5,0,0,232,2,0,0,181,0,0,0,182,0,0,0,102,1,0,0,233,2,0,0,186,3,0,0,32,0,0,0,234,2,0,0,185,0,0,0,35,0,0,0,187,3,0,0,188,3,0,0,234,2,0,0,36,0,0,0,189,3,0,0,37,0,0,0,190,3,0,0,4,0,0,0,5,0,0,0,7,0,0,0,2,0,0,0,6,0,0,0,3,0,0,0,4,0,0,0,8,0,0,0,2,0,0,0,0,0,0,0,56,81,0,0,215,5,0,0,216,5,0,0,186,0,0,0,187,0,0,0,12,0,0,0,188,0,0,0,103,1,0,0,0,0,0,0,72,81,0,0,217,5,0,0,218,5,0,0,180,0,0,0,235,2,0,0,104,1,0,0,236,2,0,0,46,0,0,0,219,5,0,0,237,2,0,0,181,0,0,0,182,0,0,0,105,1,0,0,238,2,0,0,191,3,0,0,32,0,0,0,239,2,0,0,189,0,0,0,35,0,0,0,196,0,0,0,211,0,0,0,234,2,0,0,36,0,0,0,192,3,0,0,37,0,0,0,193,3,0,0,0,0,0,0,88,81,0,0,220,5,0,0,221,5,0,0,106,1,0,0,0,0,0,0,104,81,0,0,222,5,0,0,223,5,0,0,190,0,0,0,0,0,0,0,136,81,0,0,224,5,0,0,225,5,0,0,107,1,0,0,108,1,0,0,109,1,0,0,191,0,0,0,192,0,0,0,159,0,0,0,193,0,0,0,160,0,0,0,194,0,0,0,161,0,0,0,195,0,0,0,162,0,0,0,105,0,0,0,77,0,0,0,163,0,0,0,196,0,0,0,197,0,0,0,198,0,0,0,199,0,0,0,8,0,0,0,9,0,0,0,200,0,0,0,106,0,0,0,201,0,0,0,202,0,0,0,13,0,0,0,14,0,0,0,107,0,0,0,78,0,0,0,108,0,0,0,79,0,0,0,2,0,0,0,3,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,15,0,0,0,113,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,1,0,0,0,2,0,0,0,21,0,0,0,80,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,69,0,0,0,81,0,0,0,84,0,0,0,82,0,0,0,85,0,0,0,3,0,0,0,4,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,25,0,0,0,114,0,0,0,87,0,0,0,115,0,0,0,88,0,0,0,4,0,0,0,5,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,26,0,0,0,120,0,0,0,110,1,0,0,111,1,0,0,240,2,0,0,241,2,0,0,30,0,0,0,31,0,0,0,70,0,0,0,112,1,0,0,27,0,0,0,71,0,0,0,28,0,0,0,121,0,0,0,122,0,0,0,203,0,0,0,204,0,0,0,195,140,7,0,211,140,7,0,225,140,7,0,239,140,7,0,254,140,7,0,13,141,7,0,28,141,7,0,42,141,7,0,55,141,7,0,68,141,7,0,83,141,7,0,0,0,0,0,160,81,0,0,226,5,0,0,227,5,0,0,205,0,0,0,194,3,0,0,113,1,0,0,242,2,0,0,0,0,0,0,176,81,0,0,228,5,0,0,229,5,0,0,206,0,0,0,114,1,0,0,0,0,0,0,192,81,0,0,230,5,0,0,231,5,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,243,2,0,0,232,5,0,0,233,5,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,200,81,0,0,234,5,0,0,235,5,0,0,115,1,0,0,207,0,0,0,116,1,0,0,208,0,0,0,195,3,0,0,196,3,0,0,244,2,0,0,245,2,0,0,236,5,0,0,237,5,0,0,197,3,0,0,198,3,0,0,164,0,0,0,199,3,0,0,246,2,0,0,247,2,0,0,200,3,0,0,0,0,0,0,32,82,0,0,238,5,0,0,239,5,0,0,117,1,0,0,118,1,0,0,29,0,0,0,201,3,0,0,123,0,0,0,165,0,0,0,202,3,0,0,124,0,0,0,125,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,121,1,0,0,167,0,0,0,211,0,0,0,0,0,0,0,88,82,0,0,238,5,0,0,240,5,0,0,122,1,0,0,123,1,0,0,32,0,0,0,203,3,0,0,126,0,0,0,168,0,0,0,204,3,0,0,127,0,0,0,128,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,124,1,0,0,169,0,0,0,212,0,0,0,0,0,0,0,104,82,0,0,238,5,0,0,241,5,0,0,125,1,0,0,126,1,0,0,33,0,0,0,205,3,0,0,129,0,0,0,170,0,0,0,206,3,0,0,130,0,0,0,131,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,127,1,0,0,171,0,0,0,213,0,0,0,0,0,0,0,136,82,0,0,238,5,0,0,242,5,0,0,128,1,0,0,129,1,0,0,34,0,0,0,207,3,0,0,132,0,0,0,172,0,0,0,208,3,0,0,133,0,0,0,134,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,130,1,0,0,214,0,0,0,0,0,0,0,168,82,0,0,238,5,0,0,243,5,0,0,131,1,0,0,132,1,0,0,35,0,0,0,209,3,0,0,135,0,0,0,173,0,0,0,210,3,0,0,136,0,0,0,137,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,3,0,0,0,215,0,0,0,0,0,0,0,200,82,0,0,238,5,0,0,244,5,0,0,133,1,0,0,134,1,0,0,36,0,0,0,211,3,0,0,138,0,0,0,174,0,0,0,212,3,0,0,139,0,0,0,140,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,4,0,0,0,216,0,0,0,0,0,0,0,232,82,0,0,238,5,0,0,245,5,0,0,135,1,0,0,136,1,0,0,37,0,0,0,213,3,0,0,141,0,0,0,175,0,0,0,214,3,0,0,142,0,0,0,143,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,137,1,0,0,217,0,0,0,0,0,0,0,8,83,0,0,238,5,0,0,246,5,0,0,138,1,0,0,139,1,0,0,38,0,0,0,215,3,0,0,144,0,0,0,176,0,0,0,216,3,0,0,145,0,0,0,146,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,140,1,0,0,218,0,0,0,0,0,0,0,40,83,0,0,238,5,0,0,247,5,0,0,141,1,0,0,142,1,0,0,39,0,0,0,217,3,0,0,147,0,0,0,177,0,0,0,218,3,0,0,148,0,0,0,149,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,143,1,0,0,219,0,0,0,0,0,0,0,72,83,0,0,238,5,0,0,248,5,0,0,144,1,0,0,145,1,0,0,40,0,0,0,219,3,0,0,150,0,0,0,178,0,0,0,220,3,0,0,151,0,0,0,152,0,0,0,119,1,0,0,120,1,0,0,209,0,0,0,210,0,0,0,30,0,0,0,166,0,0,0,31,0,0,0,146,1,0,0,220,0,0,0,0,0,0,0,112,83,0,0,249,5,0,0,250,5,0,0,147,1,0,0,0,0,0,0,136,83,0,0,251,5,0,0,252,5,0,0,179,0,0,0,180,0,0,0,181,0,0,0,153,0,0,0,154,0,0,0,1,0,0,0,2,0,0,0,182,0,0,0,183,0,0,0,155,0,0,0,89,0,0,0,86,0,0,0,87,0,0,0,0,0,0,0,152,83,0,0,253,5,0,0,254,5,0,0,184,0,0,0,0,0,0,0,168,83,0,0,255,5,0,0,0,6,0,0,156,0,0,0,157,0,0,0,0,0,0,0,184,83,0,0,1,6,0,0,2,6,0,0,221,0,0,0,148,1,0,0,185,0,0,0,0,0,0,0,208,83,0,0,222,5,0,0,3,6,0,0,222,0,0,0,0,0,0,0,0,1,0,0,0,9,0,0,0,0,0,0,8,0,0,0,1,0,0,0,32,32,32,32,0,0,0,0,182,180,7,0,128,137,17,0,180,158,17,0,182,189,7,0,0,0,0,0,48,84,0,0,57,0,0,0,4,6,0,0,221,3,0,0,183,198,7,0,199,198,7,0,180,158,17,0,210,198,7,0,221,198,7,0,234,198,7,0,245,198,7,0,9,199,7,0,22,199,7,0,180,158,17,0,0,0,0,0,150,48,7,119,44,97,14,238,186,81,9,153,25,196,109,7,143,244,106,112,53,165,99,233,163,149,100,158,50,136,219,14,164,184,220,121,30,233,213,224,136,217,210,151,43,76,182,9,189,124,177,126,7,45,184,231,145,29,191,144,100,16,183,29,242,32,176,106,72,113,185,243,222,65,190,132,125,212,218,26,235,228,221,109,81,181,212,244,199,133,211,131,86,152,108,19,192,168,107,100,122,249,98,253,236,201,101,138,79,92,1,20,217,108,6,99,99,61,15,250,245,13,8,141,200,32,110,59,94,16,105,76,228,65,96,213,114,113,103,162,209,228,3,60,71,212,4,75,253,133,13,210,107,181,10,165,250,168,181,53,108,152,178,66,214,201,187,219,64,249,188,172,227,108,216,50,117,92,223,69,207,13,214,220,89,61,209,171,172,48,217,38,58,0,222,81,128,81,215,200,22,97,208,191,181,244,180,33,35,196,179,86,153,149,186,207,15,165,189,184,158,184,2,40,8,136,5,95,178,217,12,198,36,233,11,177,135,124,111,47,17,76,104,88,171,29,97,193,61,45,102,182,144,65,220,118,6,113,219,1,188,32,210,152,42,16,213,239,137,133,177,113,31,181,182,6,165,228,191,159,51,212,184,232,162,201,7,120,52,249,0,15,142,168,9,150,24,152,14,225,187,13,106,127,45,61,109,8,151,108,100,145,1,92,99,230,244,81,107,107,98,97,108,28,216,48,101,133,78,0,98,242,237,149,6,108,123,165,1,27,193,244,8,130,87,196,15,245,198,217,176,101,80,233,183,18,234,184,190,139,124,136,185,252,223,29,221,98,73,45,218,21,243,124,211,140,101,76,212,251,88,97,178,77,206,81,181,58,116,0,188,163,226,48,187,212,65,165,223,74,215,149,216,61,109,196,209,164,251,244,214,211,106,233,105,67,252,217,110,52,70,136,103,173,208,184,96,218,115,45,4,68,229,29,3,51,95,76,10,170,201,124,13,221,60,113,5,80,170,65,2,39,16,16,11,190,134,32,12,201,37,181,104,87,179,133,111,32,9,212,102,185,159,228,97,206,14,249,222,94,152,201,217,41,34,152,208,176,180,168,215,199,23,61,179,89,129,13,180,46,59,92,189,183,173,108,186,192,32,131,184,237,182,179,191,154,12,226,182,3,154,210,177,116,57,71,213,234,175,119,210,157,21,38,219,4,131,22,220,115,18,11,99,227,132,59,100,148,62,106,109,13,168,90,106,122,11,207,14,228,157,255,9,147,39,174,0,10,177,158,7,125,68,147,15,240,210,163,8,135,104,242,1,30,254,194,6,105,93,87,98,247,203,103,101,128,113,54,108,25,231,6,107,110,118,27,212,254,224,43,211,137,90,122,218,16,204,74,221,103,111,223,185,249,249,239,190,142,67,190,183,23,213,142,176,96,232,163,214,214,126,147,209,161,196,194,216,56,82,242,223,79,241,103,187,209,103,87,188,166,221,6,181,63,75,54,178,72,218,43,13,216,76,27,10,175,246,74,3,54,96,122,4,65,195,239,96,223,85,223,103,168,239,142,110,49,121,190,105,70,140,179,97,203,26,131,102,188,160,210,111,37,54,226,104,82,149,119,12,204,3,71,11,187,185,22,2,34,47,38,5,85,190,59,186,197,40,11,189,178,146,90,180,43,4,106,179,92,167,255,215,194,49,207,208,181,139,158,217,44,29,174,222,91,176,194,100,155,38,242,99,236,156,163,106,117,10,147,109,2,169,6,9,156,63,54,14,235,133,103,7,114,19,87,0,5,130,74,191,149,20,122,184,226,174,43,177,123,56,27,182,12,155,142,210,146,13,190,213,229,183,239,220,124,33,223,219,11,212,210,211,134,66,226,212,241,248,179,221,104,110,131,218,31,205,22,190,129,91,38,185,246,225,119,176,111,119,71,183,24,230,90,8,136,112,106,15,255,202,59,6,102,92,11,1,17,255,158,101,143,105,174,98,248,211,255,107,97,69,207,108,22,120,226,10,160,238,210,13,215,84,131,4,78,194,179,3,57,97,38,103,167,247,22,96,208,77,71,105,73,219,119,110,62,74,106,209,174,220,90,214,217,102,11,223,64,240,59,216,55,83,174,188,169,197,158,187,222,127,207,178,71,233,255,181,48,28,242,189,189,138,194,186,202,48,147,179,83,166,163,180,36,5,54,208,186,147,6,215,205,41,87,222,84,191,103,217,35,46,122,102,179,184,74,97,196,2,27,104,93,148,43,111,42,55,190,11,180,161,142,12,195,27,223,5,90,141,239,2,45,0,0,0,0,65,49,27,25,130,98,54,50,195,83,45,43,4,197,108,100,69,244,119,125,134,167,90,86,199,150,65,79,8,138,217,200,73,187,194,209,138,232,239,250,203,217,244,227,12,79,181,172,77,126,174,181,142,45,131,158,207,28,152,135,81,18,194,74,16,35,217,83,211,112,244,120,146,65,239,97,85,215,174,46,20,230,181,55,215,181,152,28,150,132,131,5,89,152,27,130,24,169,0,155,219,250,45,176,154,203,54,169,93,93,119,230,28,108,108,255,223,63,65,212,158,14,90,205,162,36,132,149,227,21,159,140,32,70,178,167,97,119,169,190,166,225,232,241,231,208,243,232,36,131,222,195,101,178,197,218,170,174,93,93,235,159,70,68,40,204,107,111,105,253,112,118,174,107,49,57,239,90,42,32,44,9,7,11,109,56,28,18,243,54,70,223,178,7,93,198,113,84,112,237,48,101,107,244,247,243,42,187,182,194,49,162,117,145,28,137,52,160,7,144,251,188,159,23,186,141,132,14,121,222,169,37,56,239,178,60,255,121,243,115,190,72,232,106,125,27,197,65,60,42,222,88,5,79,121,240,68,126,98,233,135,45,79,194,198,28,84,219,1,138,21,148,64,187,14,141,131,232,35,166,194,217,56,191,13,197,160,56,76,244,187,33,143,167,150,10,206,150,141,19,9,0,204,92,72,49,215,69,139,98,250,110,202,83,225,119,84,93,187,186,21,108,160,163,214,63,141,136,151,14,150,145,80,152,215,222,17,169,204,199,210,250,225,236,147,203,250,245,92,215,98,114,29,230,121,107,222,181,84,64,159,132,79,89,88,18,14,22,25,35,21,15,218,112,56,36,155,65,35,61,167,107,253,101,230,90,230,124,37,9,203,87,100,56,208,78,163,174,145,1,226,159,138,24,33,204,167,51,96,253,188,42,175,225,36,173,238,208,63,180,45,131,18,159,108,178,9,134,171,36,72,201,234,21,83,208,41,70,126,251,104,119,101,226,246,121,63,47,183,72,36,54,116,27,9,29,53,42,18,4,242,188,83,75,179,141,72,82,112,222,101,121,49,239,126,96,254,243,230,231,191,194,253,254,124,145,208,213,61,160,203,204,250,54,138,131,187,7,145,154,120,84,188,177,57,101,167,168,75,152,131,59,10,169,152,34,201,250,181,9,136,203,174,16,79,93,239,95,14,108,244,70,205,63,217,109,140,14,194,116,67,18,90,243,2,35,65,234,193,112,108,193,128,65,119,216,71,215,54,151,6,230,45,142,197,181,0,165,132,132,27,188,26,138,65,113,91,187,90,104,152,232,119,67,217,217,108,90,30,79,45,21,95,126,54,12,156,45,27,39,221,28,0,62,18,0,152,185,83,49,131,160,144,98,174,139,209,83,181,146,22,197,244,221,87,244,239,196,148,167,194,239,213,150,217,246,233,188,7,174,168,141,28,183,107,222,49,156,42,239,42,133,237,121,107,202,172,72,112,211,111,27,93,248,46,42,70,225,225,54,222,102,160,7,197,127,99,84,232,84,34,101,243,77,229,243,178,2,164,194,169,27,103,145,132,48,38,160,159,41,184,174,197,228,249,159,222,253,58,204,243,214,123,253,232,207,188,107,169,128,253,90,178,153,62,9,159,178,127,56,132,171,176,36,28,44,241,21,7,53,50,70,42,30,115,119,49,7,180,225,112,72,245,208,107,81,54,131,70,122,119,178,93,99,78,215,250,203,15,230,225,210,204,181,204,249,141,132,215,224,74,18,150,175,11,35,141,182,200,112,160,157,137,65,187,132,70,93,35,3,7,108,56,26,196,63,21,49,133,14,14,40,66,152,79,103,3,169,84,126,192,250,121,85,129,203,98,76,31,197,56,129,94,244,35,152,157,167,14,179,220,150,21,170,27,0,84,229,90,49,79,252,153,98,98,215,216,83,121,206,23,79,225,73,86,126,250,80,149,45,215,123,212,28,204,98,19,138,141,45,82,187,150,52,145,232,187,31,208,217,160,6,236,243,126,94,173,194,101,71,110,145,72,108,47,160,83,117,232,54,18,58,169,7,9,35,106,84,36,8,43,101,63,17,228,121,167,150,165,72,188,143,102,27,145,164,39,42,138,189,224,188,203,242,161,141,208,235,98,222,253,192,35,239,230,217,189,225,188,20,252,208,167,13,63,131,138,38,126,178,145,63,185,36,208,112,248,21,203,105,59,70,230,66,122,119,253,91,181,107,101,220,244,90,126,197,55,9,83,238,118,56,72,247,177,174,9,184,240,159,18,161,51,204,63,138,114,253,36,147,0,0,0,0,55,106,194,1,110,212,132,3,89,190,70,2,220,168,9,7,235,194,203,6,178,124,141,4,133,22,79,5,184,81,19,14,143,59,209,15,214,133,151,13,225,239,85,12,100,249,26,9,83,147,216,8,10,45,158,10,61,71,92,11,112,163,38,28,71,201,228,29,30,119,162,31,41,29,96,30,172,11,47,27,155,97,237,26,194,223,171,24,245,181,105,25,200,242,53,18,255,152,247,19,166,38,177,17,145,76,115,16,20,90,60,21,35,48,254,20,122,142,184,22,77,228,122,23,224,70,77,56,215,44,143,57,142,146,201,59,185,248,11,58,60,238,68,63,11,132,134,62,82,58,192,60,101,80,2,61,88,23,94,54,111,125,156,55,54,195,218,53,1,169,24,52,132,191,87,49,179,213,149,48,234,107,211,50,221,1,17,51,144,229,107,36,167,143,169,37,254,49,239,39,201,91,45,38,76,77,98,35,123,39,160,34,34,153,230,32,21,243,36,33,40,180,120,42,31,222,186,43,70,96,252,41,113,10,62,40,244,28,113,45,195,118,179,44,154,200,245,46,173,162,55,47,192,141,154,112,247,231,88,113,174,89,30,115,153,51,220,114,28,37,147,119,43,79,81,118,114,241,23,116,69,155,213,117,120,220,137,126,79,182,75,127,22,8,13,125,33,98,207,124,164,116,128,121,147,30,66,120,202,160,4,122,253,202,198,123,176,46,188,108,135,68,126,109,222,250,56,111,233,144,250,110,108,134,181,107,91,236,119,106,2,82,49,104,53,56,243,105,8,127,175,98,63,21,109,99,102,171,43,97,81,193,233,96,212,215,166,101,227,189,100,100,186,3,34,102,141,105,224,103,32,203,215,72,23,161,21,73,78,31,83,75,121,117,145,74,252,99,222,79,203,9,28,78,146,183,90,76,165,221,152,77,152,154,196,70,175,240,6,71,246,78,64,69,193,36,130,68,68,50,205,65,115,88,15,64,42,230,73,66,29,140,139,67,80,104,241,84,103,2,51,85,62,188,117,87,9,214,183,86,140,192,248,83,187,170,58,82,226,20,124,80,213,126,190,81,232,57,226,90,223,83,32,91,134,237,102,89,177,135,164,88,52,145,235,93,3,251,41,92,90,69,111,94,109,47,173,95,128,27,53,225,183,113,247,224,238,207,177,226,217,165,115,227,92,179,60,230,107,217,254,231,50,103,184,229,5,13,122,228,56,74,38,239,15,32,228,238,86,158,162,236,97,244,96,237,228,226,47,232,211,136,237,233,138,54,171,235,189,92,105,234,240,184,19,253,199,210,209,252,158,108,151,254,169,6,85,255,44,16,26,250,27,122,216,251,66,196,158,249,117,174,92,248,72,233,0,243,127,131,194,242,38,61,132,240,17,87,70,241,148,65,9,244,163,43,203,245,250,149,141,247,205,255,79,246,96,93,120,217,87,55,186,216,14,137,252,218,57,227,62,219,188,245,113,222,139,159,179,223,210,33,245,221,229,75,55,220,216,12,107,215,239,102,169,214,182,216,239,212,129,178,45,213,4,164,98,208,51,206,160,209,106,112,230,211,93,26,36,210,16,254,94,197,39,148,156,196,126,42,218,198,73,64,24,199,204,86,87,194,251,60,149,195,162,130,211,193,149,232,17,192,168,175,77,203,159,197,143,202,198,123,201,200,241,17,11,201,116,7,68,204,67,109,134,205,26,211,192,207,45,185,2,206,64,150,175,145,119,252,109,144,46,66,43,146,25,40,233,147,156,62,166,150,171,84,100,151,242,234,34,149,197,128,224,148,248,199,188,159,207,173,126,158,150,19,56,156,161,121,250,157,36,111,181,152,19,5,119,153,74,187,49,155,125,209,243,154,48,53,137,141,7,95,75,140,94,225,13,142,105,139,207,143,236,157,128,138,219,247,66,139,130,73,4,137,181,35,198,136,136,100,154,131,191,14,88,130,230,176,30,128,209,218,220,129,84,204,147,132,99,166,81,133,58,24,23,135,13,114,213,134,160,208,226,169,151,186,32,168,206,4,102,170,249,110,164,171,124,120,235,174,75,18,41,175,18,172,111,173,37,198,173,172,24,129,241,167,47,235,51,166,118,85,117,164,65,63,183,165,196,41,248,160,243,67,58,161,170,253,124,163,157,151,190,162,208,115,196,181,231,25,6,180,190,167,64,182,137,205,130,183,12,219,205,178,59,177,15,179,98,15,73,177,85,101,139,176,104,34,215,187,95,72,21,186,6,246,83,184,49,156,145,185,180,138,222,188,131,224,28,189,218,94,90,191,237,52,152,190,0,0,0,0,101,103,188,184,139,200,9,170,238,175,181,18,87,151,98,143,50,240,222,55,220,95,107,37,185,56,215,157,239,40,180,197,138,79,8,125,100,224,189,111,1,135,1,215,184,191,214,74,221,216,106,242,51,119,223,224,86,16,99,88,159,87,25,80,250,48,165,232,20,159,16,250,113,248,172,66,200,192,123,223,173,167,199,103,67,8,114,117,38,111,206,205,112,127,173,149,21,24,17,45,251,183,164,63,158,208,24,135,39,232,207,26,66,143,115,162,172,32,198,176,201,71,122,8,62,175,50,160,91,200,142,24,181,103,59,10,208,0,135,178,105,56,80,47,12,95,236,151,226,240,89,133,135,151,229,61,209,135,134,101,180,224,58,221,90,79,143,207,63,40,51,119,134,16,228,234,227,119,88,82,13,216,237,64,104,191,81,248,161,248,43,240,196,159,151,72,42,48,34,90,79,87,158,226,246,111,73,127,147,8,245,199,125,167,64,213,24,192,252,109,78,208,159,53,43,183,35,141,197,24,150,159,160,127,42,39,25,71,253,186,124,32,65,2,146,143,244,16,247,232,72,168,61,88,20,155,88,63,168,35,182,144,29,49,211,247,161,137,106,207,118,20,15,168,202,172,225,7,127,190,132,96,195,6,210,112,160,94,183,23,28,230,89,184,169,244,60,223,21,76,133,231,194,209,224,128,126,105,14,47,203,123,107,72,119,195,162,15,13,203,199,104,177,115,41,199,4,97,76,160,184,217,245,152,111,68,144,255,211,252,126,80,102,238,27,55,218,86,77,39,185,14,40,64,5,182,198,239,176,164,163,136,12,28,26,176,219,129,127,215,103,57,145,120,210,43,244,31,110,147,3,247,38,59,102,144,154,131,136,63,47,145,237,88,147,41,84,96,68,180,49,7,248,12,223,168,77,30,186,207,241,166,236,223,146,254,137,184,46,70,103,23,155,84,2,112,39,236,187,72,240,113,222,47,76,201,48,128,249,219,85,231,69,99,156,160,63,107,249,199,131,211,23,104,54,193,114,15,138,121,203,55,93,228,174,80,225,92,64,255,84,78,37,152,232,246,115,136,139,174,22,239,55,22,248,64,130,4,157,39,62,188,36,31,233,33,65,120,85,153,175,215,224,139,202,176,92,51,59,182,89,237,94,209,229,85,176,126,80,71,213,25,236,255,108,33,59,98,9,70,135,218,231,233,50,200,130,142,142,112,212,158,237,40,177,249,81,144,95,86,228,130,58,49,88,58,131,9,143,167,230,110,51,31,8,193,134,13,109,166,58,181,164,225,64,189,193,134,252,5,47,41,73,23,74,78,245,175,243,118,34,50,150,17,158,138,120,190,43,152,29,217,151,32,75,201,244,120,46,174,72,192,192,1,253,210,165,102,65,106,28,94,150,247,121,57,42,79,151,150,159,93,242,241,35,229,5,25,107,77,96,126,215,245,142,209,98,231,235,182,222,95,82,142,9,194,55,233,181,122,217,70,0,104,188,33,188,208,234,49,223,136,143,86,99,48,97,249,214,34,4,158,106,154,189,166,189,7,216,193,1,191,54,110,180,173,83,9,8,21,154,78,114,29,255,41,206,165,17,134,123,183,116,225,199,15,205,217,16,146,168,190,172,42,70,17,25,56,35,118,165,128,117,102,198,216,16,1,122,96,254,174,207,114,155,201,115,202,34,241,164,87,71,150,24,239,169,57,173,253,204,94,17,69,6,238,77,118,99,137,241,206,141,38,68,220,232,65,248,100,81,121,47,249,52,30,147,65,218,177,38,83,191,214,154,235,233,198,249,179,140,161,69,11,98,14,240,25,7,105,76,161,190,81,155,60,219,54,39,132,53,153,146,150,80,254,46,46,153,185,84,38,252,222,232,158,18,113,93,140,119,22,225,52,206,46,54,169,171,73,138,17,69,230,63,3,32,129,131,187,118,145,224,227,19,246,92,91,253,89,233,73,152,62,85,241,33,6,130,108,68,97,62,212,170,206,139,198,207,169,55,126,56,65,127,214,93,38,195,110,179,137,118,124,214,238,202,196,111,214,29,89,10,177,161,225,228,30,20,243,129,121,168,75,215,105,203,19,178,14,119,171,92,161,194,185,57,198,126,1,128,254,169,156,229,153,21,36,11,54,160,54,110,81,28,142,167,22,102,134,194,113,218,62,44,222,111,44,73,185,211,148,240,129,4,9,149,230,184,177,123,73,13,163,30,46,177,27,72,62,210,67,45,89,110,251,195,246,219,233,166,145,103,81,31,169,176,204,122,206,12,116,148,97,185,102,241,6,5,222,0,0,0,0,119,7,48,150,238,14,97,44,153,9,81,186,7,109,196,25,112,106,244,143,233,99,165,53,158,100,149,163,14,219,136,50,121,220,184,164,224,213,233,30,151,210,217,136,9,182,76,43,126,177,124,189,231,184,45,7,144,191,29,145,29,183,16,100,106,176,32,242,243,185,113,72,132,190,65,222,26,218,212,125,109,221,228,235,244,212,181,81,131,211,133,199,19,108,152,86,100,107,168,192,253,98,249,122,138,101,201,236,20,1,92,79,99,6,108,217,250,15,61,99,141,8,13,245,59,110,32,200,76,105,16,94,213,96,65,228,162,103,113,114,60,3,228,209,75,4,212,71,210,13,133,253,165,10,181,107,53,181,168,250,66,178,152,108,219,187,201,214,172,188,249,64,50,216,108,227,69,223,92,117,220,214,13,207,171,209,61,89,38,217,48,172,81,222,0,58,200,215,81,128,191,208,97,22,33,180,244,181,86,179,196,35,207,186,149,153,184,189,165,15,40,2,184,158,95,5,136,8,198,12,217,178,177,11,233,36,47,111,124,135,88,104,76,17,193,97,29,171,182,102,45,61,118,220,65,144,1,219,113,6,152,210,32,188,239,213,16,42,113,177,133,137,6,182,181,31,159,191,228,165,232,184,212,51,120,7,201,162,15,0,249,52,150,9,168,142,225,14,152,24,127,106,13,187,8,109,61,45,145,100,108,151,230,99,92,1,107,107,81,244,28,108,97,98,133,101,48,216,242,98,0,78,108,6,149,237,27,1,165,123,130,8,244,193,245,15,196,87,101,176,217,198,18,183,233,80,139,190,184,234,252,185,136,124,98,221,29,223,21,218,45,73,140,211,124,243,251,212,76,101,77,178,97,88,58,181,81,206,163,188,0,116,212,187,48,226,74,223,165,65,61,216,149,215,164,209,196,109,211,214,244,251,67,105,233,106,52,110,217,252,173,103,136,70,218,96,184,208,68,4,45,115,51,3,29,229,170,10,76,95,221,13,124,201,80,5,113,60,39,2,65,170,190,11,16,16,201,12,32,134,87,104,181,37,32,111,133,179,185,102,212,9,206,97,228,159,94,222,249,14,41,217,201,152,176,208,152,34,199,215,168,180,89,179,61,23,46,180,13,129,183,189,92,59,192,186,108,173,237,184,131,32,154,191,179,182,3,182,226,12,116,177,210,154,234,213,71,57,157,210,119,175,4,219,38,21,115,220,22,131,227,99,11,18,148,100,59,132,13,109,106,62,122,106,90,168,228,14,207,11,147,9,255,157,10,0,174,39,125,7,158,177,240,15,147,68,135,8,163,210,30,1,242,104,105,6,194,254,247,98,87,93,128,101,103,203,25,108,54,113,110,107,6,231,254,212,27,118,137,211,43,224,16,218,122,90,103,221,74,204,249,185,223,111,142,190,239,249,23,183,190,67,96,176,142,213,214,214,163,232,161,209,147,126,56,216,194,196,79,223,242,82,209,187,103,241,166,188,87,103,63,181,6,221,72,178,54,75,216,13,43,218,175,10,27,76,54,3,74,246,65,4,122,96,223,96,239,195,168,103,223,85,49,110,142,239,70,105,190,121,203,97,179,140,188,102,131,26,37,111,210,160,82,104,226,54,204,12,119,149,187,11,71,3,34,2,22,185,85,5,38,47,197,186,59,190,178,189,11,40,43,180,90,146,92,179,106,4,194,215,255,167,181,208,207,49,44,217,158,139,91,222,174,29,155,100,194,176,236,99,242,38,117,106,163,156,2,109,147,10,156,9,6,169,235,14,54,63,114,7,103,133,5,0,87,19,149,191,74,130,226,184,122,20,123,177,43,174,12,182,27,56,146,210,142,155,229,213,190,13,124,220,239,183,11,219,223,33,134,211,210,212,241,212,226,66,104,221,179,248,31,218,131,110,129,190,22,205,246,185,38,91,111,176,119,225,24,183,71,119,136,8,90,230,255,15,106,112,102,6,59,202,17,1,11,92,143,101,158,255,248,98,174,105,97,107,255,211,22,108,207,69,160,10,226,120,215,13,210,238,78,4,131,84,57,3,179,194,167,103,38,97,208,96,22,247,73,105,71,77,62,110,119,219,174,209,106,74,217,214,90,220,64,223,11,102,55,216,59,240,169,188,174,83,222,187,158,197,71,178,207,127,48,181,255,233,189,189,242,28,202,186,194,138,83,179,147,48,36,180,163,166,186,208,54,5,205,215,6,147,84,222,87,41,35,217,103,191,179,102,122,46,196,97,74,184,93,104,27,2,42,111,43,148,180,11,190,55,195,12,142,161,90,5,223,27,45,2,239,141,0,0,0,0,25,27,49,65,50,54,98,130,43,45,83,195,100,108,197,4,125,119,244,69,86,90,167,134,79,65,150,199,200,217,138,8,209,194,187,73,250,239,232,138,227,244,217,203,172,181,79,12,181,174,126,77,158,131,45,142,135,152,28,207,74,194,18,81,83,217,35,16,120,244,112,211,97,239,65,146,46,174,215,85,55,181,230,20,28,152,181,215,5,131,132,150,130,27,152,89,155,0,169,24,176,45,250,219,169,54,203,154,230,119,93,93,255,108,108,28,212,65,63,223,205,90,14,158,149,132,36,162,140,159,21,227,167,178,70,32,190,169,119,97,241,232,225,166,232,243,208,231,195,222,131,36,218,197,178,101,93,93,174,170,68,70,159,235,111,107,204,40,118,112,253,105,57,49,107,174,32,42,90,239,11,7,9,44,18,28,56,109,223,70,54,243,198,93,7,178,237,112,84,113,244,107,101,48,187,42,243,247,162,49,194,182,137,28,145,117,144,7,160,52,23,159,188,251,14,132,141,186,37,169,222,121,60,178,239,56,115,243,121,255,106,232,72,190,65,197,27,125,88,222,42,60,240,121,79,5,233,98,126,68,194,79,45,135,219,84,28,198,148,21,138,1,141,14,187,64,166,35,232,131,191,56,217,194,56,160,197,13,33,187,244,76,10,150,167,143,19,141,150,206,92,204,0,9,69,215,49,72,110,250,98,139,119,225,83,202,186,187,93,84,163,160,108,21,136,141,63,214,145,150,14,151,222,215,152,80,199,204,169,17,236,225,250,210,245,250,203,147,114,98,215,92,107,121,230,29,64,84,181,222,89,79,132,159,22,14,18,88,15,21,35,25,36,56,112,218,61,35,65,155,101,253,107,167,124,230,90,230,87,203,9,37,78,208,56,100,1,145,174,163,24,138,159,226,51,167,204,33,42,188,253,96,173,36,225,175,180,63,208,238,159,18,131,45,134,9,178,108,201,72,36,171,208,83,21,234,251,126,70,41,226,101,119,104,47,63,121,246,54,36,72,183,29,9,27,116,4,18,42,53,75,83,188,242,82,72,141,179,121,101,222,112,96,126,239,49,231,230,243,254,254,253,194,191],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+163840);allocate([213,208,145,124,204,203,160,61,131,138,54,250,154,145,7,187,177,188,84,120,168,167,101,57,59,131,152,75,34,152,169,10,9,181,250,201,16,174,203,136,95,239,93,79,70,244,108,14,109,217,63,205,116,194,14,140,243,90,18,67,234,65,35,2,193,108,112,193,216,119,65,128,151,54,215,71,142,45,230,6,165,0,181,197,188,27,132,132,113,65,138,26,104,90,187,91,67,119,232,152,90,108,217,217,21,45,79,30,12,54,126,95,39,27,45,156,62,0,28,221,185,152,0,18,160,131,49,83,139,174,98,144,146,181,83,209,221,244,197,22,196,239,244,87,239,194,167,148,246,217,150,213,174,7,188,233,183,28,141,168,156,49,222,107,133,42,239,42,202,107,121,237,211,112,72,172,248,93,27,111,225,70,42,46,102,222,54,225,127,197,7,160,84,232,84,99,77,243,101,34,2,178,243,229,27,169,194,164,48,132,145,103,41,159,160,38,228,197,174,184,253,222,159,249,214,243,204,58,207,232,253,123,128,169,107,188,153,178,90,253,178,159,9,62,171,132,56,127,44,28,36,176,53,7,21,241,30,42,70,50,7,49,119,115,72,112,225,180,81,107,208,245,122,70,131,54,99,93,178,119,203,250,215,78,210,225,230,15,249,204,181,204,224,215,132,141,175,150,18,74,182,141,35,11,157,160,112,200,132,187,65,137,3,35,93,70,26,56,108,7,49,21,63,196,40,14,14,133,103,79,152,66,126,84,169,3,85,121,250,192,76,98,203,129,129,56,197,31,152,35,244,94,179,14,167,157,170,21,150,220,229,84,0,27,252,79,49,90,215,98,98,153,206,121,83,216,73,225,79,23,80,250,126,86,123,215,45,149,98,204,28,212,45,141,138,19,52,150,187,82,31,187,232,145,6,160,217,208,94,126,243,236,71,101,194,173,108,72,145,110,117,83,160,47,58,18,54,232,35,9,7,169,8,36,84,106,17,63,101,43,150,167,121,228,143,188,72,165,164,145,27,102,189,138,42,39,242,203,188,224,235,208,141,161,192,253,222,98,217,230,239,35,20,188,225,189,13,167,208,252,38,138,131,63,63,145,178,126,112,208,36,185,105,203,21,248,66,230,70,59,91,253,119,122,220,101,107,181,197,126,90,244,238,83,9,55,247,72,56,118,184,9,174,177,161,18,159,240,138,63,204,51,147,36,253,114,0,0,0,0,1,194,106,55,3,132,212,110,2,70,190,89,7,9,168,220,6,203,194,235,4,141,124,178,5,79,22,133,14,19,81,184,15,209,59,143,13,151,133,214,12,85,239,225,9,26,249,100,8,216,147,83,10,158,45,10,11,92,71,61,28,38,163,112,29,228,201,71,31,162,119,30,30,96,29,41,27,47,11,172,26,237,97,155,24,171,223,194,25,105,181,245,18,53,242,200,19,247,152,255,17,177,38,166,16,115,76,145,21,60,90,20,20,254,48,35,22,184,142,122,23,122,228,77,56,77,70,224,57,143,44,215,59,201,146,142,58,11,248,185,63,68,238,60,62,134,132,11,60,192,58,82,61,2,80,101,54,94,23,88,55,156,125,111,53,218,195,54,52,24,169,1,49,87,191,132,48,149,213,179,50,211,107,234,51,17,1,221,36,107,229,144,37,169,143,167,39,239,49,254,38,45,91,201,35,98,77,76,34,160,39,123,32,230,153,34,33,36,243,21,42,120,180,40,43,186,222,31,41,252,96,70,40,62,10,113,45,113,28,244,44,179,118,195,46,245,200,154,47,55,162,173,112,154,141,192,113,88,231,247,115,30,89,174,114,220,51,153,119,147,37,28,118,81,79,43,116,23,241,114,117,213,155,69,126,137,220,120,127,75,182,79,125,13,8,22,124,207,98,33,121,128,116,164,120,66,30,147,122,4,160,202,123,198,202,253,108,188,46,176,109,126,68,135,111,56,250,222,110,250,144,233,107,181,134,108,106,119,236,91,104,49,82,2,105,243,56,53,98,175,127,8,99,109,21,63,97,43,171,102,96,233,193,81,101,166,215,212,100,100,189,227,102,34,3,186,103,224,105,141,72,215,203,32,73,21,161,23,75,83,31,78,74,145,117,121,79,222,99,252,78,28,9,203,76,90,183,146,77,152,221,165,70,196,154,152,71,6,240,175,69,64,78,246,68,130,36,193,65,205,50,68,64,15,88,115,66,73,230,42,67,139,140,29,84,241,104,80,85,51,2,103,87,117,188,62,86,183,214,9,83,248,192,140,82,58,170,187,80,124,20,226,81,190,126,213,90,226,57,232,91,32,83,223,89,102,237,134,88,164,135,177,93,235,145,52,92,41,251,3,94,111,69,90,95,173,47,109,225,53,27,128,224,247,113,183,226,177,207,238,227,115,165,217,230,60,179,92,231,254,217,107,229,184,103,50,228,122,13,5,239,38,74,56,238,228,32,15,236,162,158,86,237,96,244,97,232,47,226,228,233,237,136,211,235,171,54,138,234,105,92,189,253,19,184,240,252,209,210,199,254,151,108,158,255,85,6,169,250,26,16,44,251,216,122,27,249,158,196,66,248,92,174,117,243,0,233,72,242,194,131,127,240,132,61,38,241,70,87,17,244,9,65,148,245,203,43,163,247,141,149,250,246,79,255,205,217,120,93,96,216,186,55,87,218,252,137,14,219,62,227,57,222,113,245,188,223,179,159,139,221,245,33,210,220,55,75,229,215,107,12,216,214,169,102,239,212,239,216,182,213,45,178,129,208,98,164,4,209,160,206,51,211,230,112,106,210,36,26,93,197,94,254,16,196,156,148,39,198,218,42,126,199,24,64,73,194,87,86,204,195,149,60,251,193,211,130,162,192,17,232,149,203,77,175,168,202,143,197,159,200,201,123,198,201,11,17,241,204,68,7,116,205,134,109,67,207,192,211,26,206,2,185,45,145,175,150,64,144,109,252,119,146,43,66,46,147,233,40,25,150,166,62,156,151,100,84,171,149,34,234,242,148,224,128,197,159,188,199,248,158,126,173,207,156,56,19,150,157,250,121,161,152,181,111,36,153,119,5,19,155,49,187,74,154,243,209,125,141,137,53,48,140,75,95,7,142,13,225,94,143,207,139,105,138,128,157,236,139,66,247,219,137,4,73,130,136,198,35,181,131,154,100,136,130,88,14,191,128,30,176,230,129,220,218,209,132,147,204,84,133,81,166,99,135,23,24,58,134,213,114,13,169,226,208,160,168,32,186,151,170,102,4,206,171,164,110,249,174,235,120,124,175,41,18,75,173,111,172,18,172,173,198,37,167,241,129,24,166,51,235,47,164,117,85,118,165,183,63,65,160,248,41,196,161,58,67,243,163,124,253,170,162,190,151,157,181,196,115,208,180,6,25,231,182,64,167,190,183,130,205,137,178,205,219,12,179,15,177,59,177,73,15,98,176,139,101,85,187,215,34,104,186,21,72,95,184,83,246,6,185,145,156,49,188,222,138,180,189,28,224,131,191,90,94,218,190,152,52,237,0,0,0,0,184,188,103,101,170,9,200,139,18,181,175,238,143,98,151,87,55,222,240,50,37,107,95,220,157,215,56,185,197,180,40,239,125,8,79,138,111,189,224,100,215,1,135,1,74,214,191,184,242,106,216,221,224,223,119,51,88,99,16,86,80,25,87,159,232,165,48,250,250,16,159,20,66,172,248,113,223,123,192,200,103,199,167,173,117,114,8,67,205,206,111,38,149,173,127,112,45,17,24,21,63,164,183,251,135,24,208,158,26,207,232,39,162,115,143,66,176,198,32,172,8,122,71,201,160,50,175,62,24,142,200,91,10,59,103,181,178,135,0,208,47,80,56,105,151,236,95,12,133,89,240,226,61,229,151,135,101,134,135,209,221,58,224,180,207,143,79,90,119,51,40,63,234,228,16,134,82,88,119,227,64,237,216,13,248,81,191,104,240,43,248,161,72,151,159,196,90,34,48,42,226,158,87,79,127,73,111,246,199,245,8,147,213,64,167,125,109,252,192,24,53,159,208,78,141,35,183,43,159,150,24,197,39,42,127,160,186,253,71,25,2,65,32,124,16,244,143,146,168,72,232,247,155,20,88,61,35,168,63,88,49,29,144,182,137,161,247,211,20,118,207,106,172,202,168,15,190,127,7,225,6,195,96,132,94,160,112,210,230,28,23,183,244,169,184,89,76,21,223,60,209,194,231,133,105,126,128,224,123,203,47,14,195,119,72,107,203,13,15,162,115,177,104,199,97,4,199,41,217,184,160,76,68,111,152,245,252,211,255,144,238,102,80,126,86,218,55,27,14,185,39,77,182,5,64,40,164,176,239,198,28,12,136,163,129,219,176,26,57,103,215,127,43,210,120,145,147,110,31,244,59,38,247,3,131,154,144,102,145,47,63,136,41,147,88,237,180,68,96,84,12,248,7,49,30,77,168,223,166,241,207,186,254,146,223,236,70,46,184,137,84,155,23,103,236,39,112,2,113,240,72,187,201,76,47,222,219,249,128,48,99,69,231,85,107,63,160,156,211,131,199,249,193,54,104,23,121,138,15,114,228,93,55,203,92,225,80,174,78,84,255,64,246,232,152,37,174,139,136,115,22,55,239,22,4,130,64,248,188,62,39,157,33,233,31,36,153,85,120,65,139,224,215,175,51,92,176,202,237,89,182,59,85,229,209,94,71,80,126,176,255,236,25,213,98,59,33,108,218,135,70,9,200,50,233,231,112,142,142,130,40,237,158,212,144,81,249,177,130,228,86,95,58,88,49,58,167,143,9,131,31,51,110,230,13,134,193,8,181,58,166,109,189,64,225,164,5,252,134,193,23,73,41,47,175,245,78,74,50,34,118,243,138,158,17,150,152,43,190,120,32,151,217,29,120,244,201,75,192,72,174,46,210,253,1,192,106,65,102,165,247,150,94,28,79,42,57,121,93,159,150,151,229,35,241,242,77,107,25,5,245,215,126,96,231,98,209,142,95,222,182,235,194,9,142,82,122,181,233,55,104,0,70,217,208,188,33,188,136,223,49,234,48,99,86,143,34,214,249,97,154,106,158,4,7,189,166,189,191,1,193,216,173,180,110,54,21,8,9,83,29,114,78,154,165,206,41,255,183,123,134,17,15,199,225,116,146,16,217,205,42,172,190,168,56,25,17,70,128,165,118,35,216,198,102,117,96,122,1,16,114,207,174,254,202,115,201,155,87,164,241,34,239,24,150,71,253,173,57,169,69,17,94,204,118,77,238,6,206,241,137,99,220,68,38,141,100,248,65,232,249,47,121,81,65,147,30,52,83,38,177,218,235,154,214,191,179,249,198,233,11,69,161,140,25,240,14,98,161,76,105,7,60,155,81,190,132,39,54,219,150,146,153,53,46,46,254,80,38,84,185,153,158,232,222,252,140,93,113,18,52,225,22,119,169,54,46,206,17,138,73,171,3,63,230,69,187,131,129,32,227,224,145,118,91,92,246,19,73,233,89,253,241,85,62,152,108,130,6,33,212,62,97,68,198,139,206,170,126,55,169,207,214,127,65,56,110,195,38,93,124,118,137,179,196,202,238,214,89,29,214,111,225,161,177,10,243,20,30,228,75,168,121,129,19,203,105,215,171,119,14,178,185,194,161,92,1,126,198,57,156,169,254,128,36,21,153,229,54,160,54,11,142,28,81,110,134,102,22,167,62,218,113,194,44,111,222,44,148,211,185,73,9,4,129,240,177,184,230,149,163,13,73,123,27,177,46,30,67,210,62,72,251,110,89,45,233,219,246,195,81,103,145,166,204,176,169,31,116,12,206,122,102,185,97,148,222,5,6,241,0,0,0,0,0,0,0,0,149,1,0,0,4,0,4,0,8,0,4,0,150,1,0,0,4,0,5,0,16,0,8,0,150,1,0,0,4,0,6,0,32,0,32,0,150,1,0,0,4,0,4,0,16,0,16,0,151,1,0,0,8,0,16,0,32,0,32,0,151,1,0,0,8,0,16,0,128,0,128,0,151,1,0,0,8,0,32,0,128,0,0,1,151,1,0,0,32,0,128,0,2,1,0,4,151,1,0,0,32,0,2,1,2,1,0,16,151,1,0,0,106,223,2,0,152,179,2,0,1,1,0,0,30,1,0,0,15,0,0,0,242,222,2,0,32,179,2,0,0,0,0,0,30,0,0,0,15,0,0,0,0,0,0,0,212,178,2,0,0,0,0,0,19,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,12,0,0,0,13,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,10,0,0,0,12,0,0,0,14,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,40,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,80,0,0,0,96,0,0,0,112,0,0,0,128,0,0,0,160,0,0,0,192,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,0,128,0,0,0,192,0,0,0,0,1,0,0,128,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,252,180,2,0,5,0,0,0,0,0,0,0,0,0,0,0,248,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,0,0,0,224,0,0,0,162,150,17,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,125,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,182,2,0,9,0,0,0,0,0,0,0,0,0,0,0,248,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,0,0,0,0,0,0,0,224,0,0,0,170,150,17,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,182,2,0,5,0,0,0,0,0,0,0,0,0,0,0,248,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,226,0,0,0,224,0,0,0,178,154,17,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,182,2,0,140,183,2,0,20,0,0,0,67,46,85,84,70,45,56,0,0,0,0,0,0,0,0,0,0,0,0,0,222,18,4,149,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,112,183,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,95,112,137,0,255,9,47,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,234,228,2,0,48,187,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,52,193,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,5,0,0,0,7,0,0,0,11,0,0,0,13,0,0,0,17,0,0,0,19,0,0,0,23,0,0,0,29,0,0,0,31,0,0,0,37,0,0,0,41,0,0,0,43,0,0,0,47,0,0,0,53,0,0,0,59,0,0,0,61,0,0,0,67,0,0,0,71,0,0,0,73,0,0,0,79,0,0,0,83,0,0,0,89,0,0,0,97,0,0,0,101,0,0,0,103,0,0,0,107,0,0,0,109,0,0,0,113,0,0,0,127,0,0,0,131,0,0,0,137,0,0,0,139,0,0,0,149,0,0,0,151,0,0,0,157,0,0,0,163,0,0,0,167,0,0,0,173,0,0,0,179,0,0,0,181,0,0,0,191,0,0,0,193,0,0,0,197,0,0,0,199,0,0,0,211,0,0,0,1,0,0,0,11,0,0,0,13,0,0,0,17,0,0,0,19,0,0,0,23,0,0,0,29,0,0,0,31,0,0,0,37,0,0,0,41,0,0,0,43,0,0,0,47,0,0,0,53,0,0,0,59,0,0,0,61,0,0,0,67,0,0,0,71,0,0,0,73,0,0,0,79,0,0,0,83,0,0,0,89,0,0,0,97,0,0,0,101,0,0,0,103,0,0,0,107,0,0,0,109,0,0,0,113,0,0,0,121,0,0,0,127,0,0,0,131,0,0,0,137,0,0,0,139,0,0,0,143,0,0,0,149,0,0,0,151,0,0,0,157,0,0,0,163,0,0,0,167,0,0,0,169,0,0,0,173,0,0,0,179,0,0,0,181,0,0,0,187,0,0,0,191,0,0,0,193,0,0,0,197,0,0,0,199,0,0,0,209,0,0,0,0,0,0,0,200,86,0,0,5,6,0,0,6,6,0,0,0,0,0,0,224,86,0,0,7,6,0,0,8,6,0,0,10,0,0,0,1,0,0,0,75,0,0,0,43,0,0,0,6,0,0,0,7,0,0,0,2,0,0,0,28,0,0,0,9,0,0,0,28,0,0,0,3,0,0,0,29,0,0,0,0,0,0,0,232,86,0,0,9,6,0,0,10,6,0,0,222,3,0,0,228,0,0,0,88,0,0,0,158,0,0,0,249,2,0,0,250,2,0,0,229,0,0,0,251,2,0,0,252,2,0,0,152,1,0,0,230,0,0,0,153,1,0,0,8,0,0,0,0,0,0,0,240,86,0,0,45,0,0,0,46,0,0,0,248,255,255,255,248,255,255,255,240,86,0,0,47,0,0,0,48,0,0,0,80,199,2,0,100,199,2,0,8,0,0,0,0,0,0,0,8,87,0,0,11,6,0,0,12,6,0,0,248,255,255,255,248,255,255,255,8,87,0,0,13,6,0,0,14,6,0,0,128,199,2,0,148,199,2,0,28,16,0,0,48,16,0,0,4,0,0,0,0,0,0,0,56,87,0,0,15,6,0,0,16,6,0,0,252,255,255,255,252,255,255,255,56,87,0,0,17,6,0,0,18,6,0,0,184,199,2,0,204,199,2,0,12,0,0,0,0,0,0,0,80,87,0,0,51,0,0,0,52,0,0,0,4,0,0,0,248,255,255,255,80,87,0,0,53,0,0,0,54,0,0,0,244,255,255,255,244,255,255,255,80,87,0,0,55,0,0,0,56,0,0,0,232,199,2,0,124,87,0,0,144,87,0,0,28,16,0,0,48,16,0,0,16,200,2,0,252,199,2,0,0,0,0,0,152,87,0,0,19,6,0,0,20,6,0,0,223,3,0,0,228,0,0,0,88,0,0,0,158,0,0,0,253,2,0,0,250,2,0,0,229,0,0,0,251,2,0,0,252,2,0,0,152,1,0,0,231,0,0,0,154,1,0,0,0,0,0,0,168,87,0,0,21,6,0,0,22,6,0,0,224,3,0,0,1,0,0,0,75,0,0,0,43,0,0,0,254,2,0,0,7,0,0,0,2,0,0,0,28,0,0,0,9,0,0,0,28,0,0,0,232,0,0,0,155,1,0,0,0,0,0,0,184,87,0,0,23,6,0,0,24,6,0,0,225,3,0,0,228,0,0,0,88,0,0,0,158,0,0,0,249,2,0,0,250,2,0,0,229,0,0,0,255,2,0,0,0,3,0,0,156,1,0,0,230,0,0,0,153,1,0,0,0,0,0,0,200,87,0,0,25,6,0,0,26,6,0,0,226,3,0,0,1,0,0,0,75,0,0,0,43,0,0,0,6,0,0,0,7,0,0,0,2,0,0,0,1,3,0,0,2,3,0,0,157,1,0,0,3,0,0,0,29,0,0,0,0,0,0,0,216,87,0,0,27,6,0,0,28,6,0,0,29,6,0,0,72,0,0,0,159,0,0,0,233,0,0,0,0,0,0,0,248,87,0,0,30,6,0,0,31,6,0,0,29,6,0,0,73,0,0,0,160,0,0,0,234,0,0,0,0,0,0,0,8,88,0,0,32,6,0,0,33,6,0,0,29,6,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,72,88,0,0,34,6,0,0,35,6,0,0,29,6,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,0,0,0,0,128,88,0,0,36,6,0,0,37,6,0,0,29,6,0,0,74,0,0,0,75,0,0,0,54,0,0,0,76,0,0,0,55,0,0,0,1,0,0,0,2,0,0,0,77,0,0,0,0,0,0,0,192,88,0,0,38,6,0,0,39,6,0,0,29,6,0,0,78,0,0,0,79,0,0,0,56,0,0,0,80,0,0,0,57,0,0,0,3,0,0,0,4,0,0,0,81,0,0,0,0,0,0,0,248,88,0,0,40,6,0,0,41,6,0,0,29,6,0,0,3,3,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,2,0,0,0,248,255,255,255,248,88,0,0,4,3,0,0,5,3,0,0,6,3,0,0,7,3,0,0,8,3,0,0,9,3,0,0,10,3,0,0,0,0,0,0,48,89,0,0,42,6,0,0,43,6,0,0,29,6,0,0,11,3,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,3,0,0,0,248,255,255,255,48,89,0,0,12,3,0,0,13,3,0,0,14,3,0,0,15,3,0,0,16,3,0,0,17,3,0,0,18,3,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+174080);allocate([96,89,0,0,44,6,0,0,45,6,0,0,29,6,0,0,1,0,0,0,0,0,0,0,136,89,0,0,46,6,0,0,47,6,0,0,29,6,0,0,2,0,0,0,0,0,0,0,168,89,0,0,48,6,0,0,49,6,0,0,29,6,0,0,19,3,0,0,20,3,0,0,227,3,0,0,228,3,0,0,229,3,0,0,230,3,0,0,21,3,0,0,231,3,0,0,232,3,0,0,0,0,0,0,208,89,0,0,50,6,0,0,51,6,0,0,29,6,0,0,22,3,0,0,23,3,0,0,233,3,0,0,234,3,0,0,235,3,0,0,236,3,0,0,24,3,0,0,237,3,0,0,238,3,0,0,0,0,0,0,240,89,0,0,52,6,0,0,53,6,0,0,29,6,0,0,25,3,0,0,26,3,0,0,239,3,0,0,240,3,0,0,241,3,0,0,242,3,0,0,27,3,0,0,243,3,0,0,244,3,0,0,0,0,0,0,16,90,0,0,54,6,0,0,55,6,0,0,29,6,0,0,28,3,0,0,29,3,0,0,245,3,0,0,246,3,0,0,247,3,0,0,248,3,0,0,30,3,0,0,249,3,0,0,250,3,0,0,0,0,0,0,48,90,0,0,56,6,0,0,57,6,0,0,29,6,0,0,3,0,0,0,4,0,0,0,0,0,0,0,88,90,0,0,58,6,0,0,59,6,0,0,29,6,0,0,5,0,0,0,6,0,0,0,0,0,0,0,128,90,0,0,60,6,0,0,61,6,0,0,29,6,0,0,1,0,0,0,68,0,0,0,0,0,0,0,168,90,0,0,62,6,0,0,63,6,0,0,29,6,0,0,2,0,0,0,69,0,0,0,0,0,0,0,208,90,0,0,64,6,0,0,65,6,0,0,29,6,0,0,235,0,0,0,89,0,0,0,251,3,0,0,0,0,0,0,248,90,0,0,66,6,0,0,67,6,0,0,29,6,0,0,236,0,0,0,90,0,0,0,252,3,0,0,0,0,0,0,80,91,0,0,68,6,0,0,69,6,0,0,29,6,0,0,4,0,0,0,5,0,0,0,82,0,0,0,31,3,0,0,32,3,0,0,83,0,0,0,33,3,0,0,0,0,0,0,24,91,0,0,68,6,0,0,70,6,0,0,29,6,0,0,4,0,0,0,5,0,0,0,82,0,0,0,31,3,0,0,32,3,0,0,83,0,0,0,33,3,0,0,0,0,0,0,128,91,0,0,71,6,0,0,72,6,0,0,29,6,0,0,6,0,0,0,7,0,0,0,84,0,0,0,34,3,0,0,35,3,0,0,85,0,0,0,36,3,0,0,0,0,0,0,192,91,0,0,73,6,0,0,74,6,0,0,29,6,0,0,0,0,0,0,208,91,0,0,75,6,0,0,76,6,0,0,29,6,0,0,158,1,0,0,237,0,0,0,159,1,0,0,238,0,0,0,160,1,0,0,41,0,0,0,239,0,0,0,86,0,0,0,0,0,0,0,24,92,0,0,77,6,0,0,78,6,0,0,29,6,0,0,37,3,0,0,38,3,0,0,253,3,0,0,254,3,0,0,255,3,0,0,0,0,0,0,40,92,0,0,79,6,0,0,80,6,0,0,29,6,0,0,39,3,0,0,40,3,0,0,0,4,0,0,1,4,0,0,2,4,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,232,87,0,0,68,6,0,0,81,6,0,0,29,6,0,0,0,0,0,0,248,91,0,0,68,6,0,0,82,6,0,0,29,6,0,0,240,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,161,1,0,0,241,0,0,0,162,1,0,0,242,0,0,0,163,1,0,0,45,0,0,0,243,0,0,0,87,0,0,0,0,0,0,0,96,91,0,0,68,6,0,0,83,6,0,0,29,6,0,0,8,0,0,0,9,0,0,0,88,0,0,0,41,3,0,0,42,3,0,0,89,0,0,0,43,3,0,0,0,0,0,0,160,91,0,0,68,6,0,0,84,6,0,0,29,6,0,0,10,0,0,0,11,0,0,0,90,0,0,0,44,3,0,0,45,3,0,0,91,0,0,0,46,3,0,0,0,0,0,0,40,91,0,0,68,6,0,0,85,6,0,0,29,6,0,0,4,0,0,0,5,0,0,0,82,0,0,0,31,3,0,0,32,3,0,0,83,0,0,0,33,3,0,0,0,0,0,0,40,89,0,0,4,3,0,0,5,3,0,0,6,3,0,0,7,3,0,0,8,3,0,0,9,3,0,0,10,3,0,0,0,0,0,0,88,89,0,0,12,3,0,0,13,3,0,0,14,3,0,0,15,3,0,0,16,3,0,0,17,3,0,0,18,3,0,0,2,0,0,0,98,228,7,0,0,0,0,0,72,92,0,0,86,6,0,0,87,6,0,0,88,6,0,0,89,6,0,0,244,0,0,0,91,0,0,0,90,0,0,0,161,0,0,0,0,0,0,0,112,92,0,0,86,6,0,0,90,6,0,0,88,6,0,0,89,6,0,0,244,0,0,0,92,0,0,0,91,0,0,0,162,0,0,0,0,0,0,0,128,92,0,0,91,6,0,0,92,6,0,0,47,3,0,0,0,0,0,0,144,92,0,0,91,6,0,0,93,6,0,0,47,3,0,0,0,0,0,0,160,92,0,0,91,6,0,0,94,6,0,0,47,3,0,0,0,0,0,0,176,92,0,0,95,6,0,0,96,6,0,0,48,3,0,0,0,0,0,0,224,92,0,0,86,6,0,0,97,6,0,0,88,6,0,0,89,6,0,0,245,0,0,0,0,0,0,0,208,92,0,0,86,6,0,0,98,6,0,0,88,6,0,0,89,6,0,0,246,0,0,0,0,0,0,0,96,93,0,0,86,6,0,0,99,6,0,0,88,6,0,0,89,6,0,0,244,0,0,0,93,0,0,0,92,0,0,0,163,0,0,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,192,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,160,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,224,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,144,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,208,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,176,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,240,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,200,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,168,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,232,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,152,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,216,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,184,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,248,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,196,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,164,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,228,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,148,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,212,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,180,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,244,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,204,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,172,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,236,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,156,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,220,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,188,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,252,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,194,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,162,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,226,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,146,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,210,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,178,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,242,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,202,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,170,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,234,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,154,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,218,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,186,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,250,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,198,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,166,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,230,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,150,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,214,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,182,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,246,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,206,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,174,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,238,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,158,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,222,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,190,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,254,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,193,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,161,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,225,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,145,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,209,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,177,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,241,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,201,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,169,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,233,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,153,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,217,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,185,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,249,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,197,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,165,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,229,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,149,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,213,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,181,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,245,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,205,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,173,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,237,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,157,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,221,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,189,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,253,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,195,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,163,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,227,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,147,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,211,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,179,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,243,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,203,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,171,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,235,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,155,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,219,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,187,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,251,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,199,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,167,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,231,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,151,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,215,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,183,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,247,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,207,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,175,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,239,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,159,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,223,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,191,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,255,0,16,5,1,0,23,5,1,1,19,5,17,0,27,5,1,16,17,5,5,0,25,5,1,4,21,5,65,0,29,5,1,64,16,5,3,0,24,5,1,2,20,5,33,0,28,5,1,32,18,5,9,0,26,5,1,8,22,5,129,0,64,5,0,0,16,5,2,0,23,5,129,1,19,5,25,0,27,5,1,24,17,5,7,0,25,5,1,6,21,5,97,0,29,5,1,96,16,5,4,0,24,5,1,3,20,5,49,0,28,5,1,48,18,5,13,0,26,5,1,12,22,5,193,0,64,5,0,0,16,0,17,0,18,0,0,0,8,0,7,0,9,0,6,0,10,0,5,0,11,0,4,0,12,0,3,0,13,0,2,0,14,0,1,0,15,0,1,0,2,0,3,0,4,0,5,0,7,0,9,0,13,0,17,0,25,0,33,0,49,0,65,0,97,0,129,0,193,0,1,1,129,1,1,2,1,3,1,4,1,6,1,8,1,12,1,16,1,24,1,32,1,48,1,64,1,96,0,0,0,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,13,0,15,0,17,0,19,0,23,0,27,0,31,0,35,0,43,0,51,0,59,0,67,0,83,0,99,0,115,0,131,0,163,0,195,0,227,0,2,1,0,0,0,0,16,0,16,0,16,0,16,0,17,0,17,0,18,0,18,0,19,0,19,0,20,0,20,0,21,0,21,0,22,0,22,0,23,0,23,0,24,0,24,0,25,0,25,0,26,0,26,0,27,0,27,0,28,0,28,0,29,0,29,0,64,0,64,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,17,0,17,0,17,0,17,0,18,0,18,0,18,0,18,0,19,0,19,0,19,0,19,0,20,0,20,0,20,0,20,0,21,0,21,0,21,0,21,0,16,0,77,0,202,0,0,0,5,0,16,0,5,0,8,0,5,0,24,0,5,0,4,0,5,0,20,0,5,0,12,0,5,0,28,0,5,0,2,0,5,0,18,0,5,0,10,0,5,0,26,0,5,0,6,0,5,0,22,0,5,0,14,0,5,0,30,0,5,0,1,0,5,0,17,0,5,0,9,0,5,0,25,0,5,0,5,0,5,0,21,0,5,0,13,0,5,0,29,0,5,0,3,0,5,0,19,0,5,0,11,0,5,0,27,0,5,0,7,0,5,0,23,0,5,0,12,0,8,0,140,0,8,0,76,0,8,0,204,0,8,0,44,0,8,0,172,0,8,0,108,0,8,0,236,0,8,0,28,0,8,0,156,0,8,0,92,0,8,0,220,0,8,0,60,0,8,0,188,0,8,0,124,0,8,0,252,0,8,0,2,0,8,0,130,0,8,0,66,0,8,0,194,0,8,0,34,0,8,0,162,0,8,0,98,0,8,0,226,0,8,0,18,0,8,0,146,0,8,0,82,0,8,0,210,0,8,0,50,0,8,0,178,0,8,0,114,0,8,0,242,0,8,0,10,0,8,0,138,0,8,0,74,0,8,0,202,0,8,0,42,0,8,0,170,0,8,0,106,0,8,0,234,0,8,0,26,0,8,0,154,0,8,0,90,0,8,0,218,0,8,0,58,0,8,0,186,0,8,0,122,0,8,0,250,0,8,0,6,0,8,0,134,0,8,0,70,0,8,0,198,0,8,0,38,0,8,0,166,0,8,0,102,0,8,0,230,0,8,0,22,0,8,0,150,0,8,0,86,0,8,0,214,0,8,0,54,0,8,0,182,0,8,0,118,0,8,0,246,0,8,0,14,0,8,0,142,0,8,0,78,0,8,0,206,0,8,0,46,0,8,0,174,0,8,0,110,0,8,0,238,0,8,0,30,0,8,0,158,0,8,0,94,0,8,0,222,0,8,0,62,0,8,0,190,0,8,0,126,0,8,0,254,0,8,0,1,0,8,0,129,0,8,0,65,0,8,0,193,0,8,0,33,0,8,0,161,0,8,0,97,0,8,0,225,0,8,0,17,0,8,0,145,0,8,0,81,0,8,0,209,0,8,0,49,0,8,0,177,0,8,0,113,0,8,0,241,0,8,0,9,0,8,0,137,0,8,0,73,0,8,0,201,0,8,0,41,0,8,0,169,0,8,0,105,0,8,0,233,0,8,0,25,0,8,0,153,0,8,0,89,0,8,0,217,0,8,0,57,0,8,0,185,0,8,0,121,0,8,0,249,0,8,0,5,0,8,0,133,0,8,0,69,0,8,0,197,0,8,0,37,0,8,0,165,0,8,0,101,0,8,0,229,0,8,0,21,0,8,0,149,0,8,0,85,0,8,0,213,0,8,0,53,0,8,0,181,0,8,0,117,0,8,0,245,0,8,0,13,0,8,0,141,0,8,0,77,0,8,0,205,0,8,0,45,0,8,0,173,0,8,0,109,0,8,0,237,0,8,0,29,0,8,0,157,0,8,0,93,0,8,0,221,0,8,0,61,0,8,0,189,0,8,0,125,0,8,0,253,0,8,0,19,0,9,0,19,1,9,0,147,0,9,0,147,1,9,0,83,0,9,0,83,1,9,0,211,0,9,0,211,1,9,0,51,0,9,0,51,1,9,0,179,0,9,0,179,1,9,0,115,0,9,0,115,1,9,0,243,0,9,0,243,1,9,0,11,0,9,0,11,1,9,0,139,0,9,0,139,1,9,0,75,0,9,0,75,1,9,0,203,0,9,0,203,1,9,0,43,0,9,0,43,1,9,0,171,0,9,0,171,1,9,0,107,0,9,0,107,1,9,0,235,0,9,0,235,1,9,0,27,0,9,0,27,1,9,0,155,0,9,0,155,1,9,0,91,0,9,0,91,1,9,0,219,0,9,0,219,1,9,0,59,0,9,0,59,1,9,0,187,0,9,0,187,1,9,0,123,0,9,0,123,1,9,0,251,0,9,0,251,1,9,0,7,0,9,0,7,1,9,0,135,0,9,0,135,1,9,0,71,0,9,0,71,1,9,0,199,0,9,0,199,1,9,0,39,0,9,0,39,1,9,0,167,0,9,0,167,1,9,0,103,0,9,0,103,1,9,0,231,0,9,0,231,1,9,0,23,0,9,0,23,1,9,0,151,0,9,0,151,1,9,0,87,0,9,0,87,1,9,0,215,0,9,0,215,1,9,0,55,0,9,0,55,1,9,0,183,0,9,0,183,1,9,0,119,0,9,0,119,1,9,0,247,0,9,0,247,1,9,0,15,0,9,0,15,1,9,0,143,0,9,0,143,1,9,0,79,0,9,0,79,1,9,0,207,0,9,0,207,1,9,0,47,0,9,0,47,1,9,0,175,0,9,0,175,1,9,0,111,0,9,0,111,1,9,0,239,0,9,0,239,1,9,0,31,0,9,0,31,1,9,0,159,0,9,0,159,1,9,0,95,0,9,0,95,1,9,0,223,0,9,0,223,1,9,0,63,0,9,0,63,1,9,0,191,0,9,0,191,1,9,0,127,0,9,0,127,1,9,0,255,0,9,0,255,1,9,0,0,0,7,0,64,0,7,0,32,0,7,0,96,0,7,0,16,0,7,0,80,0,7,0,48,0,7,0,112,0,7,0,8,0,7,0,72,0,7,0,40,0,7,0,104,0,7,0,24,0,7,0,88,0,7,0,56,0,7,0,120,0,7,0,4,0,7,0,68,0,7,0,36,0,7,0,100,0,7,0,20,0,7,0,84,0,7,0,52,0,7,0,116,0,7,0,3,0,8,0,131,0,8,0,67,0,8,0,195,0,8,0,35,0,8,0,163,0,8,0,99,0,8,0,227,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,3,32,2,32,2,32,2,32,2,32,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,96,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,213,8,213,8,213,8,213,8,213,8,213,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,4,192,4,192,4,192,4,192,4,192,4,192,8,214,8,214,8,214,8,214,8,214,8,214,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,4,192,4,192,4,192,4,192,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,117,115,104,0,73,110,116,86,101,99,116,111,114,0,70,108,111,97,116,86,101,99,116,111,114,0,68,111,117,98,108,101,86,101,99,116,111,114,0,80,111,105,110,116,86,101,99,116,111,114,0,77,97,116,86,101,99,116,111,114,0,82,101,99,116,86,101,99,116,111,114,0,75,101,121,80,111,105,110,116,86,101,99,116,111,114,0,101,121,101,0,111,110,101,115,0,122,101,114,111,115,0,109,97,116,83,105,122,101,0,115,116,101,112,0,100,97,116,97,56,83,0,100,97,116,97,49,54,85,0,100,97,116,97,49,54,83,0,100,97,116,97,51,50,83,0,100,97,116,97,51,50,70,0,100,97,116,97,54,52,70,0,101,108,101,109,83,105,122,101,0,101,108,101,109,83,105,122,101,49,0,99,104,97,110,110,101,108,115,0,114,111,119,0,114,111,119,82,97,110,103,101,0,99,111,108,82,97,110,103,101,0,115,116,101,112,49,0,99,108,111,110,101,0,99,111,108,0,109,117,108,0,105,110,118,0,117,99,104,97,114,80,116,114,0,99,104,97,114,80,116,114,0,115,104,111,114,116,80,116,114,0,117,115,104,111,114,116,80,116,114,0,105,110,116,80,116,114,0,102,108,111,97,116,80,116,114,0,100,111,117,98,108,101,80,116,114,0,99,104,97,114,65,116,0,117,99,104,97,114,65,116,0,115,104,111,114,116,65,116,0,117,115,104,111,114,116,65,116,0,105,110,116,65,116,0,102,108,111,97,116,65,116,0,100,111,117,98,108,101,65,116,0,82,97,110,103,101,0,84,101,114,109,67,114,105,116,101,114,105,97,0,109,97,120,67,111,117,110,116,0,35,116,121,112,101,0,82,101,99,116,0,82,101,99,116,50,102,0,82,111,116,97,116,101,100,82,101,99,116,0,99,101,110,116,101,114,0,97,110,103,108,101,0,114,111,116,97,116,101,100,82,101,99,116,80,111,105,110,116,115,0,114,111,116,97,116,101,100,82,101,99,116,66,111,117,110,100,105,110,103,82,101,99,116,0,114,111,116,97,116,101,100,82,101,99,116,66,111,117,110,100,105,110,103,82,101,99,116,50,102,0,75,101,121,80,111,105,110,116,0,99,108,97,115,115,95,105,100,0,111,99,116,97,118,101,0,112,116,0,114,101,115,112,111,110,115,101,0,83,99,97,108,97,114,0,77,105,110,77,97,120,76,111,99,0,109,105,110,86,97,108,0,109,97,120,86,97,108,0,109,105,110,76,111,99,0,109,97,120,76,111,99,0,67,105,114,99,108,101,0,114,97,100,105,117,115,0,77,111,109,101,110,116,115,0,109,48,48,0,109,49,48,0,109,48,49,0,109,50,48,0,109,49,49,0,109,48,50,0,109,51,48,0,109,50,49,0,109,49,50,0,109,48,51,0,109,117,50,48,0,109,117,49,49,0,109,117,48,50,0,109,117,51,48,0,109,117,50,49,0,109,117,49,50,0,109,117,48,51,0,110,117,50,48,0,110,117,49,49,0,110,117,48,50,0,110,117,51,48,0,110,117,50,49,0,110,117,49,50,0,110,117,48,51,0,69,120,99,101,112,116,105,111,110,0,99,111,100,101,0,109,115,103,0,101,120,99,101,112,116,105,111,110,70,114,111,109,80,116,114,0,109,111,114,112,104,111,108,111,103,121,68,101,102,97,117,108,116,66,111,114,100,101,114,86,97,108,117,101,0,67,86,95,77,65,84,95,68,69,80,84,72,0,67,97,109,83,104,105,102,116,0,103,101,116,66,117,105,108,100,73,110,102,111,114,109,97,116,105,111,110,0,67,86,95,56,85,67,49,0,67,86,95,56,85,67,50,0,67,86,95,56,85,67,51,0,67,86,95,56,85,67,52,0,67,86,95,56,83,67,49,0,67,86,95,56,83,67,50,0,67,86,95,56,83,67,51,0,67,86,95,56,83,67,52,0,67,86,95,49,54,85,67,49,0,67,86,95,49,54,85,67,50,0,67,86,95,49,54,85,67,51,0,67,86,95,49,54,85,67,52,0,67,86,95,49,54,83,67,49,0,67,86,95,49,54,83,67,50,0,67,86,95,49,54,83,67,51,0,67,86,95,49,54,83,67,52,0,67,86,95,51,50,83,67,50,0,67,86,95,51,50,83,67,51,0,67,86,95,51,50,83,67,52,0,67,86,95,51,50,70,67,50,0,67,86,95,51,50,70,67,51,0,67,86,95,51,50,70,67,52,0,67,86,95,54,52,70,67,49,0,67,86,95,54,52,70,67,50,0,67,86,95,54,52,70,67,51,0,67,86,95,54,52,70,67,52,0,73,78,84,95,77,73,78,0,73,78,84,95,77,65,88,0,67,97,110,110,121,49,0,71,97,117,115,115,105,97,110,66,108,117,114,0,72,111,117,103,104,76,105,110,101,115,0,72,111,117,103,104,76,105,110,101,115,80,0,76,97,112,108,97,99,105,97,110,0,83,99,104,97,114,114,0,83,111,98,101,108,0,97,98,115,100,105,102,102,0,97,100,100,87,101,105,103,104,116,101,100,0,98,105,116,119,105,115,101,95,97,110,100,0,98,105,116,119,105,115,101,95,110,111,116,0,98,105,116,119,105,115,101,95,111,114,0,98,105,116,119,105,115,101,95,120,111,114,0,98,108,117,114,0,98,111,117,110,100,105,110,103,82,101,99,116,0,98,111,120,70,105,108,116,101,114,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,70,97,114,110,101,98,97,99,107,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,80,121,114,76,75,0,99,111,114,110,101,114,72,97,114,114,105,115,0,99,111,114,110,101,114,77,105,110,69,105,103,101,110,86,97,108,0,100,105,108,97,116,101,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,87,105,116,104,76,97,98,101,108,115,0,100,105,118,105,100,101,0,100,105,118,105,100,101,49,0,101,108,108,105,112,115,101,49,0,101,108,108,105,112,115,101,50,80,111,108,121,0,101,114,111,100,101,0,101,115,116,105,109,97,116,101,82,105,103,105,100,84,114,97,110,115,102,111,114,109,49,0,102,105,108,116,101,114,50,68,0,103,101,116,79,112,116,105,109,97,108,68,70,84,83,105,122,101,0,103,101,116,82,111,116,97,116,105,111,110,77,97,116,114,105,120,50,68,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,49,0,105,110,116,101,103,114,97,108,50,0,109,105,110,0,109,105,110,65,114,101,97,82,101,99,116,0,109,117,108,116,105,112,108,121,0,110,111,114,109,49,0,112,117,116,84,101,120,116,0,114,97,110,100,110,0,114,97,110,100,117,0,115,101,116,82,78,71,83,101,101,100,0,115,113,114,116,0,115,117,98,116,114,97,99,116,0,98,108,111,98,70,114,111,109,73,109,97,103,101,0,114,101,97,100,78,101,116,49,0,114,101,97,100,78,101,116,70,114,111,109,67,97,102,102,101,0,114,101,97,100,78,101,116,70,114,111,109,67,97,102,102,101,49,0,114,101,97,100,78,101,116,70,114,111,109,68,97,114,107,110,101,116,49,0,114,101,97,100,78,101,116,70,114,111,109,79,78,78,88,0,114,101,97,100,78,101,116,70,114,111,109,84,101,110,115,111,114,102,108,111,119,0,114,101,97,100,78,101,116,70,114,111,109,84,101,110,115,111,114,102,108,111,119,49,0,114,101,97,100,78,101,116,70,114,111,109,84,111,114,99,104,0,72,79,71,68,101,115,99,114,105,112,116,111,114,0,108,111,97,100,0,103,101,116,68,101,102,97,117,108,116,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,103,101,116,68,97,105,109,108,101,114,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,115,118,109,68,101,116,101,99,116,111,114,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,0,80,116,114,60,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,62,0,67,76,65,72,69,0,115,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,99,111,108,108,101,99,116,71,97,114,98,97,103,101,0,115,101,116,67,108,105,112,76,105,109,105,116,0,103,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,103,101,116,67,108,105,112,76,105,109,105,116,0,80,116,114,60,67,76,65,72,69,62,0,66,70,77,97,116,99,104,101,114,0,80,116,114,60,66,70,77,97,116,99,104,101,114,62,0,75,65,90,69,0,115,101,116,69,120,116,101,110,100,101,100,0,115,101,116,78,79,99,116,97,118,101,76,97,121,101,114,115,0,103,101,116,78,79,99,116,97,118,101,115,0,103,101,116,78,79,99,116,97,118,101,76,97,121,101,114,115,0,115,101,116,78,79,99,116,97,118,101,115,0,103,101,116,85,112,114,105,103,104,116,0,103,101,116,69,120,116,101,110,100,101,100,0,115,101,116,85,112,114,105,103,104,116,0,115,101,116,68,105,102,102,117,115,105,118,105,116,121,0,103,101,116,84,104,114,101,115,104,111,108,100,0,103,101,116,68,101,102,97,117,108,116,78,97,109,101,0,103,101,116,68,105,102,102,117,115,105,118,105,116,121,0,115,101,116,84,104,114,101,115,104,111,108,100,0,80,116,114,60,75,65,90,69,62,0,65,108,103,111,114,105,116,104,109,0,100,101,116,101,99,116,49,0,99,111,109,112,117,116,101,49,0,100,101,102,97,117,108,116,78,111,114,109,0,100,101,115,99,114,105,112,116,111,114,83,105,122,101,0,100,101,115,99,114,105,112,116,111,114,84,121,112,101,0,71,70,84,84,68,101,116,101,99,116,111,114,0,103,101,116,66,108,111,99,107,83,105,122,101,0,103,101,116,75,0,115,101,116,72,97,114,114,105,115,68,101,116,101,99,116,111,114,0,115,101,116,66,108,111,99,107,83,105,122,101,0,115,101,116,81,117,97,108,105,116,121,76,101,118,101,108,0,115,101,116,77,97,120,70,101,97,116,117,114,101,115,0,115,101,116,75,0,103,101,116,77,97,120,70,101,97,116,117,114,101,115,0,115,101,116,77,105,110,68,105,115,116,97,110,99,101,0,103,101,116,77,105,110,68,105,115,116,97,110,99,101,0,103,101,116,81,117,97,108,105,116,121,76,101,118,101,108,0,103,101,116,72,97,114,114,105,115,68,101,116,101,99,116,111,114,0,80,116,114,60,71,70,84,84,68,101,116,101,99,116,111,114,62,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,0,114,97,100,105,117,115,77,97,116,99,104,49,0,107,110,110,77,97,116,99,104,49,0,116,114,97,105,110,0,109,97,116,99,104,0,109,97,116,99,104,49,0,105,115,77,97,115,107,83,117,112,112,111,114,116,101,100,0,80,116,114,60,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,62,0,100,110,110,95,78,101,116,0,102,111,114,119,97,114,100,49,0,102,111,114,119,97,114,100,50,0,77,83,69,82,0,103,101,116,80,97,115,115,50,79,110,108,121,0,115,101,116,77,105,110,65,114,101,97,0,103,101,116,68,101,108,116,97,0,103,101,116,77,97,120,65,114,101,97,0,115,101,116,77,97,120,65,114,101,97,0,115,101,116,80,97,115,115,50,79,110,108,121,0,103,101,116,77,105,110,65,114,101,97,0,115,101,116,68,101,108,116,97,0,80,116,114,60,77,83,69,82,62,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,103,101,116,78,111,110,109,97,120,83,117,112,112,114,101,115,115,105,111,110,0,103,101,116,84,121,112,101,0,115,101,116,78,111,110,109,97,120,83,117,112,112,114,101,115,115,105,111,110,0,115,101,116,84,121,112,101,0,80,116,114,60,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,62,0,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,50,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,51,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,80,116,114,60,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,62,0,65,75,65,90,69,0,115,101,116,68,101,115,99,114,105,112,116,111,114,84,121,112,101,0,103,101,116,68,101,115,99,114,105,112,116,111,114,84,121,112,101,0,115,101,116,68,101,115,99,114,105,112,116,111,114,67,104,97,110,110,101,108,115,0,103,101,116,68,101,115,99,114,105,112,116,111,114,67,104,97,110,110,101,108,115,0,115,101,116,68,101,115,99,114,105,112,116,111,114,83,105,122,101,0,80,116,114,60,65,75,65,90,69,62,0,79,82,66,0,115,101,116,69,100,103,101,84,104,114,101,115,104,111,108,100,0,103,101,116,70,97,115,116,84,104,114,101,115,104,111,108,100,0,115,101,116,78,76,101,118,101,108,115,0,115,101,116,80,97,116,99,104,83,105,122,101,0,115,101,116,87,84,65,95,75,0,115,101,116,83,99,97,108,101,70,97,99,116,111,114,0,115,101,116,83,99,111,114,101,84,121,112,101,0,80,116,114,60,79,82,66,62,0,66,82,73,83,75,0,80,116,114,60,66,82,73,83,75,62,0,65,67,67,69,83,83,95,70,65,83,84,0,65,67,67,69,83,83,95,77,65,83,75,0,65,67,67,69,83,83,95,82,69,65,68,0,65,67,67,69,83,83,95,82,87,0,65,67,67,69,83,83,95,87,82,73,84,69,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,71,65,85,83,83,73,65,78,95,67,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,77,69,65,78,95,67,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,75,65,90,69,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,75,65,90,69,95,85,80,82,73,71,72,84,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,77,76,68,66,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,77,76,68,66,95,85,80,82,73,71,72,84,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,53,95,56,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,55,95,49,50,100,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,55,95,49,50,115,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,78,79,78,77,65,88,95,83,85,80,80,82,69,83,83,73,79,78,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,79,65,83,84,95,57,95,49,54,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,72,82,69,83,72,79,76,68,0,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,66,79,82,68,69,82,95,73,83,79,76,65,84,69,68,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,49,48,49,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,95,49,48,49,0,66,79,82,68,69,82,95,82,69,80,76,73,67,65,84,69,0,66,79,82,68,69,82,95,84,82,65,78,83,80,65,82,69,78,84,0,66,79,82,68,69,82,95,87,82,65,80,0,67,65,83,67,65,68,69,95,68,79,95,67,65,78,78,89,95,80,82,85,78,73,78,71,0,67,65,83,67,65,68,69,95,68,79,95,82,79,85,71,72,95,83,69,65,82,67,72,0,67,65,83,67,65,68,69,95,70,73,78,68,95,66,73,71,71,69,83,84,95,79,66,74,69,67,84,0,67,65,83,67,65,68,69,95,83,67,65,76,69,95,73,77,65,71,69,0,67,67,76,95,68,69,70,65,85,76,84,0,67,67,76,95,71,82,65,78,65,0,67,67,76,95,87,85,0,67,67,95,83,84,65,84,95,65,82,69,65,0,67,67,95,83,84,65,84,95,72,69,73,71,72,84,0,67,67,95,83,84,65,84,95,76,69,70,84,0,67,67,95,83,84,65,84,95,77,65,88,0,67,67,95,83,84,65,84,95,84,79,80,0,67,67,95,83,84,65,84,95,87,73,68,84,72,0,67,72,65,73,78,95,65,80,80,82,79,88,95,78,79,78,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,83,73,77,80,76,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,75,67,79,83,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,76,49,0,67,77,80,95,69,81,0,67,77,80,95,71,69,0,67,77,80,95,71,84,0,67,77,80,95,76,69,0,67,77,80,95,76,84,0,67,77,80,95,78,69,0,67,79,76,79,82,77,65,80,95,65,85,84,85,77,78,0,67,79,76,79,82,77,65,80,95,66,79,78,69,0,67,79,76,79,82,77,65,80,95,67,79,79,76,0,67,79,76,79,82,77,65,80,95,72,79,84,0,67,79,76,79,82,77,65,80,95,72,83,86,0,67,79,76,79,82,77,65,80,95,74,69,84,0,67,79,76,79,82,77,65,80,95,79,67,69,65,78,0,67,79,76,79,82,77,65,80,95,80,65,82,85,76,65,0,67,79,76,79,82,77,65,80,95,80,73,78,75,0,67,79,76,79,82,77,65,80,95,82,65,73,78,66,79,87,0,67,79,76,79,82,77,65,80,95,83,80,82,73,78,71,0,67,79,76,79,82,77,65,80,95,83,85,77,77,69,82,0,67,79,76,79,82,77,65,80,95,87,73,78,84,69,82,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,50,72,76,83,0,67,79,76,79,82,95,66,71,82,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,72,83,86,0,67,79,76,79,82,95,66,71,82,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,76,97,98,0,67,79,76,79,82,95,66,71,82,50,76,117,118,0,67,79,76,79,82,95,66,71,82,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,82,71,66,65,0,67,79,76,79,82,95,66,71],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+184320);allocate([82,50,88,89,90,0,67,79,76,79,82,95,66,71,82,50,89,67,114,67,98,0,67,79,76,79,82,95,66,71,82,50,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,53,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,65,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,67,79,76,79,82,67,86,84,95,77,65,88,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,53,53,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,54,53,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,65,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,65,0,67,79,76,79,82,95,72,76,83,50,66,71,82,0,67,79,76,79,82,95,72,76,83,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,76,83,50,82,71,66,0,67,79,76,79,82,95,72,76,83,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,66,71,82,0,67,79,76,79,82,95,72,83,86,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,82,71,66,0,67,79,76,79,82,95,72,83,86,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,76,66,71,82,50,76,97,98,0,67,79,76,79,82,95,76,66,71,82,50,76,117,118,0,67,79,76,79,82,95,76,82,71,66,50,76,97,98,0,67,79,76,79,82,95,76,82,71,66,50,76,117,118,0,67,79,76,79,82,95,76,97,98,50,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,82,71,66,0,67,79,76,79,82,95,76,97,98,50,82,71,66,0,67,79,76,79,82,95,76,117,118,50,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,82,71,66,0,67,79,76,79,82,95,76,117,118,50,82,71,66,0,67,79,76,79,82,95,82,71,66,50,66,71,82,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,50,72,76,83,0,67,79,76,79,82,95,82,71,66,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,72,83,86,0,67,79,76,79,82,95,82,71,66,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,76,97,98,0,67,79,76,79,82,95,82,71,66,50,76,117,118,0,67,79,76,79,82,95,82,71,66,50,82,71,66,65,0,67,79,76,79,82,95,82,71,66,50,88,89,90,0,67,79,76,79,82,95,82,71,66,50,89,67,114,67,98,0,67,79,76,79,82,95,82,71,66,50,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,65,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,65,50,82,71,66,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,109,82,71,66,65,0,67,79,76,79,82,95,88,89,90,50,66,71,82,0,67,79,76,79,82,95,88,89,90,50,82,71,66,0,67,79,76,79,82,95,89,67,114,67,98,50,66,71,82,0,67,79,76,79,82,95,89,67,114,67,98,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,66,71,82,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,65,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,65,0,67,79,76,79,82,95,109,82,71,66,65,50,82,71,66,65,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,49,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,50,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,51,0,67,79,86,65,82,95,67,79,76,83,0,67,79,86,65,82,95,78,79,82,77,65,76,0,67,79,86,65,82,95,82,79,87,83,0,67,79,86,65,82,95,83,67,65,76,69,0,67,79,86,65,82,95,83,67,82,65,77,66,76,69,68,0,67,79,86,65,82,95,85,83,69,95,65,86,71,0,68,67,84,95,73,78,86,69,82,83,69,0,68,67,84,95,82,79,87,83,0,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,68,69,67,79,77,80,95,69,73,71,0,68,69,67,79,77,80,95,76,85,0,68,69,67,79,77,80,95,78,79,82,77,65,76,0,68,69,67,79,77,80,95,81,82,0,68,69,67,79,77,80,95,83,86,68,0,68,70,84,95,67,79,77,80,76,69,88,95,73,78,80,85,84,0,68,70,84,95,67,79,77,80,76,69,88,95,79,85,84,80,85,84,0,68,70,84,95,73,78,86,69,82,83,69,0,68,70,84,95,82,69,65,76,95,79,85,84,80,85,84,0,68,70,84,95,82,79,87,83,0,68,70,84,95,83,67,65,76,69,0,68,73,83,84,95,67,0,68,73,83,84,95,70,65,73,82,0,68,73,83,84,95,72,85,66,69,82,0,68,73,83,84,95,76,49,0,68,73,83,84,95,76,49,50,0,68,73,83,84,95,76,50,0,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,0,68,73,83,84,95,77,65,83,75,95,51,0,68,73,83,84,95,77,65,83,75,95,53,0,68,73,83,84,95,77,65,83,75,95,80,82,69,67,73,83,69,0,68,73,83,84,95,85,83,69,82,0,68,73,83,84,95,87,69,76,83,67,72,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,72,65,77,77,73,78,71,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,72,65,77,77,73,78,71,76,85,84,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,76,49,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,83,76,50,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,70,76,65,78,78,66,65,83,69,68,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,69,70,65,85,76,84,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,82,65,87,95,79,86,69,82,95,79,85,84,73,77,71,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,82,65,87,95,82,73,67,72,95,75,69,89,80,79,73,78,84,83,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,78,79,84,95,68,82,65,87,95,83,73,78,71,76,69,95,80,79,73,78,84,83,0,70,73,76,76,69,68,0,70,76,79,79,68,70,73,76,76,95,70,73,88,69,68,95,82,65,78,71,69,0,70,76,79,79,68,70,73,76,76,95,77,65,83,75,95,79,78,76,89,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,95,83,77,65,76,76,0,70,79,78,84,95,72,69,82,83,72,69,89,95,68,85,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,80,76,65,73,78,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,84,82,73,80,76,69,88,0,70,79,78,84,95,73,84,65,76,73,67,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,70,65,83,84,95,78,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,78,79,78,77,65,88,95,83,85,80,80,82,69,83,83,73,79,78,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,72,82,69,83,72,79,76,68,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,53,95,56,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,55,95,49,50,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,57,95,49,54,0,70,105,108,101,78,111,100,101,95,69,77,80,84,89,0,70,105,108,101,78,111,100,101,95,70,76,79,65,84,0,70,105,108,101,78,111,100,101,95,70,76,79,87,0,70,105,108,101,78,111,100,101,95,73,78,84,0,70,105,108,101,78,111,100,101,95,77,65,80,0,70,105,108,101,78,111,100,101,95,78,65,77,69,68,0,70,105,108,101,78,111,100,101,95,78,79,78,69,0,70,105,108,101,78,111,100,101,95,82,69,65,76,0,70,105,108,101,78,111,100,101,95,82,69,70,0,70,105,108,101,78,111,100,101,95,83,69,81,0,70,105,108,101,78,111,100,101,95,83,84,82,0,70,105,108,101,78,111,100,101,95,83,84,82,73,78,71,0,70,105,108,101,78,111,100,101,95,84,89,80,69,95,77,65,83,75,0,70,105,108,101,78,111,100,101,95,85,83,69,82,0,70,105,108,101,83,116,111,114,97,103,101,95,65,80,80,69,78,68,0,70,105,108,101,83,116,111,114,97,103,101,95,66,65,83,69,54,52,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,65,85,84,79,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,74,83,79,78,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,77,65,83,75,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,88,77,76,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,89,65,77,76,0,70,105,108,101,83,116,111,114,97,103,101,95,73,78,83,73,68,69,95,77,65,80,0,70,105,108,101,83,116,111,114,97,103,101,95,77,69,77,79,82,89,0,70,105,108,101,83,116,111,114,97,103,101,95,78,65,77,69,95,69,88,80,69,67,84,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,82,69,65,68,0,70,105,108,101,83,116,111,114,97,103,101,95,85,78,68,69,70,73,78,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,86,65,76,85,69,95,69,88,80,69,67,84,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,87,82,73,84,69,0,70,105,108,101,83,116,111,114,97,103,101,95,87,82,73,84,69,95,66,65,83,69,54,52,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,67,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,67,83,86,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,68,69,70,65,85,76,84,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,77,65,84,76,65,66,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,78,85,77,80,89,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,80,89,84,72,79,78,0,71,67,95,66,71,68,0,71,67,95,69,86,65,76,0,71,67,95,69,86,65,76,95,70,82,69,69,90,69,95,77,79,68,69,76,0,71,67,95,70,71,68,0,71,67,95,73,78,73,84,95,87,73,84,72,95,77,65,83,75,0,71,67,95,73,78,73,84,95,87,73,84,72,95,82,69,67,84,0,71,67,95,80,82,95,66,71,68,0,71,67,95,80,82,95,70,71,68,0,71,69,77,77,95,49,95,84,0,71,69,77,77,95,50,95,84,0,71,69,77,77,95,51,95,84,0,72,73,83,84,67,77,80,95,66,72,65,84,84,65,67,72,65,82,89,89,65,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,95,65,76,84,0,72,73,83,84,67,77,80,95,67,79,82,82,69,76,0,72,73,83,84,67,77,80,95,72,69,76,76,73,78,71,69,82,0,72,73,83,84,67,77,80,95,73,78,84,69,82,83,69,67,84,0,72,73,83,84,67,77,80,95,75,76,95,68,73,86,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,68,69,70,65,85,76,84,95,78,76,69,86,69,76,83,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,76,50,72,121,115,0,72,79,85,71,72,95,71,82,65,68,73,69,78,84,0,72,79,85,71,72,95,77,85,76,84,73,95,83,67,65,76,69,0,72,79,85,71,72,95,80,82,79,66,65,66,73,76,73,83,84,73,67,0,72,79,85,71,72,95,83,84,65,78,68,65,82,68,0,72,97,109,109,105,110,103,95,110,111,114,109,84,121,112,101,0,73,78,84,69,82,83,69,67,84,95,70,85,76,76,0,73,78,84,69,82,83,69,67,84,95,78,79,78,69,0,73,78,84,69,82,83,69,67,84,95,80,65,82,84,73,65,76,0,73,78,84,69,82,95,65,82,69,65,0,73,78,84,69,82,95,66,73,84,83,0,73,78,84,69,82,95,66,73,84,83,50,0,73,78,84,69,82,95,67,85,66,73,67,0,73,78,84,69,82,95,76,65,78,67,90,79,83,52,0,73,78,84,69,82,95,76,73,78,69,65,82,0,73,78,84,69,82,95,76,73,78,69,65,82,95,69,88,65,67,84,0,73,78,84,69,82,95,77,65,88,0,73,78,84,69,82,95,78,69,65,82,69,83,84,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,50,0,75,65,90,69,95,68,73,70,70,95,67,72,65,82,66,79,78,78,73,69,82,0,75,65,90,69,95,68,73,70,70,95,80,77,95,71,49,0,75,65,90,69,95,68,73,70,70,95,80,77,95,71,50,0,75,65,90,69,95,68,73,70,70,95,87,69,73,67,75,69,82,84,0,75,77,69,65,78,83,95,80,80,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,82,65,78,68,79,77,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,85,83,69,95,73,78,73,84,73,65,76,95,76,65,66,69,76,83,0,76,73,78,69,95,52,0,76,73,78,69,95,56,0,76,73,78,69,95,65,65,0,76,83,68,95,82,69,70,73,78,69,95,65,68,86,0,76,83,68,95,82,69,70,73,78,69,95,78,79,78,69,0,76,83,68,95,82,69,70,73,78,69,95,83,84,68,0,77,65,82,75,69,82,95,67,82,79,83,83,0,77,65,82,75,69,82,95,68,73,65,77,79,78,68,0,77,65,82,75,69,82,95,83,81,85,65,82,69,0,77,65,82,75,69,82,95,83,84,65,82,0,77,65,82,75,69,82,95,84,73,76,84,69,68,95,67,82,79,83,83,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,68,79,87,78,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,85,80,0,77,79,82,80,72,95,66,76,65,67,75,72,65,84,0,77,79,82,80,72,95,67,76,79,83,69,0,77,79,82,80,72,95,67,82,79,83,83,0,77,79,82,80,72,95,68,73,76,65,84,69,0,77,79,82,80,72,95,69,76,76,73,80,83,69,0,77,79,82,80,72,95,69,82,79,68,69,0,77,79,82,80,72,95,71,82,65,68,73,69,78,84,0,77,79,82,80,72,95,72,73,84,77,73,83,83,0,77,79,82,80,72,95,79,80,69,78,0,77,79,82,80,72,95,82,69,67,84,0,77,79,82,80,72,95,84,79,80,72,65,84,0,77,79,84,73,79,78,95,65,70,70,73,78,69,0,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,0,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,77,97,116,95,65,85,84,79,95,83,84,69,80,0,77,97,116,95,67,79,78,84,73,78,85,79,85,83,95,70,76,65,71,0,77,97,116,95,68,69,80,84,72,95,77,65,83,75,0,77,97,116,95,77,65,71,73,67,95,77,65,83,75,0,77,97,116,95,77,65,71,73,67,95,86,65,76,0,77,97,116,95,83,85,66,77,65,84,82,73,88,95,70,76,65,71,0,77,97,116,95,84,89,80,69,95,77,65,83,75,0,78,79,82,77,95,72,65,77,77,73,78,71,0,78,79,82,77,95,72,65,77,77,73,78,71,50,0,78,79,82,77,95,73,78,70,0,78,79,82,77,95,76,49,0,78,79,82,77,95,76,50,0,78,79,82,77,95,76,50,83,81,82,0,78,79,82,77,95,77,73,78,77,65,88,0,78,79,82,77,95,82,69,76,65,84,73,86,69,0,78,79,82,77,95,84,89,80,69,95,77,65,83,75,0,79,80,84,70,76,79,87,95,70,65,82,78,69,66,65,67,75,95,71,65,85,83,83,73,65,78,0,79,80,84,70,76,79,87,95,76,75,95,71,69,84,95,77,73,78,95,69,73,71,69,78,86,65,76,83,0,79,80,84,70,76,79,87,95,85,83,69,95,73,78,73,84,73,65,76,95,70,76,79,87,0,79,82,66,95,70,65,83,84,95,83,67,79,82,69,0,79,82,66,95,72,65,82,82,73,83,95,83,67,79,82,69,0,79,82,66,95,107,66,121,116,101,115,0,80,67,65,95,68,65,84,65,95,65,83,95,67,79,76,0,80,67,65,95,68,65,84,65,95,65,83,95,82,79,87,0,80,67,65,95,85,83,69,95,65,86,71,0,80,82,79,74,95,83,80,72,69,82,73,67,65,76,95,69,81,82,69,67,84,0,80,82,79,74,95,83,80,72,69,82,73,67,65,76,95,79,82,84,72,79,0,80,97,114,97,109,95,65,76,71,79,82,73,84,72,77,0,80,97,114,97,109,95,66,79,79,76,69,65,78,0,80,97,114,97,109,95,70,76,79,65,84,0,80,97,114,97,109,95,73,78,84,0,80,97,114,97,109,95,77,65,84,0,80,97,114,97,109,95,77,65,84,95,86,69,67,84,79,82,0,80,97,114,97,109,95,82,69,65,76,0,80,97,114,97,109,95,83,67,65,76,65,82,0,80,97,114,97,109,95,83,84,82,73,78,71,0,80,97,114,97,109,95,85,67,72,65,82,0,80,97,114,97,109,95,85,73,78,84,54,52,0,80,97,114,97,109,95,85,78,83,73,71,78,69,68,95,73,78,84,0,82,69,68,85,67,69,95,65,86,71,0,82,69,68,85,67,69,95,77,65,88,0,82,69,68,85,67,69,95,77,73,78,0,82,69,68,85,67,69,95,83,85,77,0,82,69,84,82,95,67,67,79,77,80,0,82,69,84,82,95,69,88,84,69,82,78,65,76,0,82,69,84,82,95,70,76,79,79,68,70,73,76,76,0,82,69,84,82,95,76,73,83,84,0,82,69,84,82,95,84,82,69,69,0,82,78,71,95,78,79,82,77,65,76,0,82,78,71,95,85,78,73,70,79,82,77,0,82,79,84,65,84,69,95,49,56,48,0,82,79,84,65,84,69,95,57,48,95,67,76,79,67,75,87,73,83,69,0,82,79,84,65,84,69,95,57,48,95,67,79,85,78,84,69,82,67,76,79,67,75,87,73,83,69,0,83,79,76,86,69,76,80,95,77,85,76,84,73,0,83,79,76,86,69,76,80,95,83,73,78,71,76,69,0,83,79,76,86,69,76,80,95,85,78,66,79,85,78,68,69,68,0,83,79,76,86,69,76,80,95,85,78,70,69,65,83,73,66,76,69,0,83,79,82,84,95,65,83,67,69,78,68,73,78,71,0,83,79,82,84,95,68,69,83,67,69,78,68,73,78,71,0,83,79,82,84,95,69,86,69,82,89,95,67,79,76,85,77,78,0,83,79,82,84,95,69,86,69,82,89,95,82,79,87,0,83,86,68,95,70,85,76,76,95,85,86,0,83,86,68,95,77,79,68,73,70,89,95,65,0,83,86,68,95,78,79,95,85,86,0,83,112,97,114,115,101,77,97,116,95,72,65,83,72,95,66,73,84,0,83,112,97,114,115,101,77,97,116,95,72,65,83,72,95,83,67,65,76,69,0,83,112,97,114,115,101,77,97,116,95,77,65,71,73,67,95,86,65,76,0,83,112,97,114,115,101,77,97,116,95,77,65,88,95,68,73,77,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,68,83,84,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,76,69,70,84,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,79,82,71,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,82,73,71,72,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,68,83,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,76,69,70,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,79,82,71,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,82,73,71,72,84,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,69,82,82,79,82,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,73,78,83,73,68,69,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,79,78,95,69,68,71,69,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,79,85,84,83,73,68,69,95,82,69,67,84,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,86,69,82,84,69,88,0,84,72,82,69,83,72,95,66,73,78,65,82,89,0,84,72,82,69,83,72,95,66,73,78,65,82,89,95,73,78,86,0,84,72,82,69,83,72,95,77,65,83,75,0,84,72,82,69,83,72,95,79,84,83,85,0,84,72,82,69,83,72,95,84,79,90,69,82,79,0,84,72,82,69,83,72,95,84,79,90,69,82,79,95,73,78,86,0,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,0,84,72,82,69,83,72,95,84,82,85,78,67,0,84,77,95,67,67,79,69,70,70,0,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,84,77,95,67,67,79,82,82,0,84,77,95,67,67,79,82,82,95,78,79,82,77,69,68,0,84,77,95,83,81,68,73,70,70,0,84,77,95,83,81,68,73,70,70,95,78,79,82,77,69,68,0,84,101,114,109,67,114,105,116,101,114,105,97,95,67,79,85,78,84,0,84,101,114,109,67,114,105,116,101,114,105,97,95,69,80,83,0,84,101,114,109,67,114,105,116,101,114,105,97,95,77,65,88,95,73,84,69,82,0,85,77,97,116,68,97,116,97,95,65,83,89,78,67,95,67,76,69,65,78,85,80,0,85,77,97,116,68,97,116,97,95,67,79,80,89,95,79,78,95,77,65,80,0,85,77,97,116,68,97,116,97,95,68,69,86,73,67,69,95,67,79,80,89,95,79,66,83,79,76,69,84,69,0,85,77,97,116,68,97,116,97,95,68,69,86,73,67,69,95,77,69,77,95,77,65,80,80,69,68,0,85,77,97,116,68,97,116,97,95,72,79,83,84,95,67,79,80,89,95,79,66,83,79,76,69,84,69,0,85,77,97,116,68,97,116,97,95,84,69,77,80,95,67,79,80,73,69,68,95,85,77,65,84,0,85,77,97,116,68,97,116,97,95,84,69,77,80,95,85,77,65,84,0,85,77,97,116,68,97,116,97,95,85,83,69,82,95,65,76,76,79,67,65,84,69,68,0,85,77,97,116,95,65,85,84,79,95,83,84,69,80,0,85,77,97,116,95,67,79,78,84,73,78,85,79,85,83,95,70,76,65,71,0,85,77,97,116,95,68,69,80,84,72,95,77,65,83,75,0,85,77,97,116,95,77,65,71,73,67,95,77,65,83,75,0,85,77,97,116,95,77,65,71,73,67,95,86,65,76,0,85,77,97,116,95,83,85,66,77,65,84,82,73,88,95,70,76,65,71,0,85,77,97,116,95,84,89,80,69,95,77,65,83,75,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,68,69,86,73,67,69,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,72,79,83,84,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,83,72,65,82,69,68,95,77,69,77,79,82,89,0,85,83,65,71,69,95,68,69,70,65,85,76,84,0,87,65,82,80,95,70,73,76,76,95,79,85,84,76,73,69,82,83,0,87,65,82,80,95,73,78,86,69,82,83,69,95,77,65,80,0,87,65,82,80,95,80,79,76,65,82,95,76,73,78,69,65,82,0,87,65,82,80,95,80,79,76,65,82,95,76,79,71,0,95,73,110,112,117,116,65,114,114,97,121,95,67,85,68,65,95,71,80,85,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,67,85,68,65,95,72,79,83,84,95,77,69,77,0,95,73,110,112,117,116,65,114,114,97,121,95,69,88,80,82,0,95,73,110,112,117,116,65,114,114,97,121,95,70,73,88,69,68,95,83,73,90,69,0,95,73,110,112,117,116,65,114,114,97,121,95,70,73,88,69,68,95,84,89,80,69,0,95,73,110,112,117,116,65,114,114,97,121,95,75,73,78,68,95,77,65,83,75,0,95,73,110,112,117,116,65,114,114,97,121,95,75,73,78,68,95,83,72,73,70,84,0,95,73,110,112,117,116,65,114,114,97,121,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,77,65,84,88,0,95,73,110,112,117,116,65,114,114,97,121,95,78,79,78,69,0,95,73,110,112,117,116,65,114,114,97,121,95,79,80,69,78,71,76,95,66,85,70,70,69,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,65,82,82,65,89,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,65,82,82,65,89,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,66,79,79,76,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,67,85,68,65,95,71,80,85,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,85,77,65,84,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,49,54,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,49,54,85,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,51,50,70,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,51,50,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,54,52,70,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,56,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,56,85,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,65,76,76,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,65,76,76,95,66,85,84,95,56,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,70,76,84,0,95,95,85,77,65,84,95,85,83,65,71,69,95,70,76,65,71,83,95,51,50,66,73,84,0,66,97,100,65,108,105,103,110,0,66,97,100,65,108,112,104,97,67,104,97,110,110,101,108,0,66,97,100,67,79,73,0,66,97,100,67,97,108,108,66,97,99,107,0,66,97,100,68,97,116,97,80,116,114,0,66,97,100,68,101,112,116,104,0,66,97,100,73,109,97,103,101,83,105,122,101,0,66,97,100,77,111,100,101,108,79,114,67,104,83,101,113,0,66,97,100,78,117,109,67,104,97,110,110,101,108,49,85,0,66,97,100,78,117,109,67,104,97,110,110,101,108,115,0,66,97,100,79,102,102,115,101,116,0,66,97,100,79,114,100,101,114,0,66,97,100,79,114,105,103,105,110,0,66,97,100,82,79,73,83,105,122,101,0,66,97,100,83,116,101,112,0,66,97,100,84,105,108,101,83,105,122,101,0,71,112,117,65,112,105,67,97,108,108,69,114,114,111,114,0,71,112,117,78,111,116,83,117,112,112,111,114,116,101,100,0,72,101,97,100,101,114,73,115,78,117,108,108,0,77,97,115,107,73,115,84,105,108,101,100,0,79,112,101,110,67,76,65,112,105,67,97,108,108,69,114,114,111,114,0,79,112,101,110,67,76,68,111,117,98,108,101,78,111,116,83,117,112,112,111,114,116,101,100,0,79,112,101,110,67,76,73,110,105,116,69,114,114,111,114,0,79,112,101,110,67,76,78,111,65,77,68,66,108,97,115,70,102,116,0,79,112,101,110,71,108,65,112,105,67,97,108,108,69,114,114,111,114,0,79,112,101,110,71,108,78,111,116,83,117,112,112,111,114,116,101,100,0,83,116,115,65,115,115,101,114,116,0,83,116,115,65,117,116,111,84,114,97,99,101,0,83,116,115,66,97,99,107,84,114,97,99,101,0,83,116,115,66,97,100,65,114,103,0,83,116,115,66,97,100,70,108,97,103,0,83,116,115,66,97,100,70,117,110,99,0,83,116,115,66,97,100,77,97,115,107,0,83,116,115,66,97,100,77,101,109,66,108,111,99,107,0,83,116,115,66,97,100,80,111,105,110,116,0,83,116,115,66,97,100,83,105,122,101,0,83,116,115,68,105,118,66,121,90,101,114,111,0,83,116,115,69,114,114,111,114,0,83,116,115,70,105,108,116,101,114,79,102,102,115,101,116,69,114,114,0,83,116,115,70,105,108,116,101,114,83,116,114,117,99,116,67,111,110,116,101,110,116,69,114,114,0,83,116,115,73,110,112,108,97,99,101,78,111,116,83,117,112,112,111,114,116,101,100,0,83,116,115,73,110,116,101,114,110,97,108,0,83,116,115,75,101,114,110,101,108,83,116,114,117,99,116,67,111,110,116,101,110,116,69,114,114,0,83,116,115,78,111,67,111,110,118,0,83,116,115,78,111,77,101,109,0,83,116,115,78,111,116,73,109,112,108,101,109,101,110,116,101,100,0,83,116,115,78,117,108,108,80,116,114,0,83,116,115,79,98,106,101,99,116,78,111,116,70,111,117,110,100,0,83,116,115,79,107,0,83,116,115,79,117,116,79,102,82,97,110,103,101,0,83,116,115,80,97,114,115,101,69,114,114,111,114,0,83,116,115,85,110,109,97,116,99,104,101,100,70,111,114,109,97,116,115,0,83,116,115,85,110,109,97,116,99,104,101,100,83,105,122,101,115,0,83,116,115,85,110,115,117,112,112,111,114,116,101,100,70,111,114,109,97,116,0,83,116,115,86,101,99,76,101,110,103,116,104,69,114,114,0,84,69,83,84,95,67,85,83,84,79,77,0,84,69,83,84,95,69,81,0,84,69,83,84,95,71,69,0,84,69,83,84,95,71,84,0,84,69,83,84,95,76,69,0,84,69,83,84,95,76,84,0,84,69,83,84,95,78,69,0,68,78,78,95,66,65,67,75,69,78,68,95,68,69,70,65,85,76,84,0,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+194560);allocate([73,68,69,0,68,78,78,95,66,65,67,75,69,78,68,95,73,78,70,69,82,69,78,67,69,95,69,78,71,73,78,69,0,68,78,78,95,66,65,67,75,69,78,68,95,79,80,69,78,67,86,0,68,78,78,95,84,65,82,71,69,84,95,67,80,85,0,68,78,78,95,84,65,82,71,69,84,95,70,80,71,65,0,68,78,78,95,84,65,82,71,69,84,95,77,89,82,73,65,68,0,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,0,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,95,70,80,49,54,0,70,76,65,71,83,95,69,88,80,65,78,68,95,83,65,77,69,95,78,65,77,69,83,0,70,76,65,71,83,95,77,65,80,80,73,78,71,0,70,76,65,71,83,95,78,79,78,69,0,73,77,80,76,95,73,80,80,0,73,77,80,76,95,79,80,69,78,67,76,0,73,77,80,76,95,80,76,65,73,78,0,84,89,80,69,95,70,85,78,0,84,89,80,69,95,71,69,78,69,82,65,76,0,84,89,80,69,95,77,65,82,75,69,82,0,84,89,80,69,95,87,82,65,80,80,69,82,0,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,0,78,50,99,118,49,49,82,111,116,97,116,101,100,82,101,99,116,69,0,78,50,99,118,53,82,101,99,116,95,73,105,69,69,0,112,117,115,104,95,98,97,99,107,0,115,101,116,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,118,101,99,116,111,114,95,98,97,115,101,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,105,105,0,118,0,118,105,0,118,105,105,105,0,118,105,105,105,105,0,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,0,105,105,105,105,0,105,105,105,105,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,118,105,105,102,0,118,105,105,105,102,0,105,105,105,105,102,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,118,105,105,100,0,118,105,105,105,100,0,105,105,105,105,100,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,51,77,97,116,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,56,75,101,121,80,111,105,110,116,69,0,80,78,50,99,118,51,77,97,116,69,0,80,75,78,50,99,118,51,77,97,116,69,0,78,50,99,118,53,83,105,122,101,95,73,105,69,69,0,78,50,99,118,55,83,99,97,108,97,114,95,73,100,69,69,0,78,50,99,118,51,86,101,99,73,100,76,105,52,69,69,69,0,78,50,99,118,52,77,97,116,120,73,100,76,105,52,69,76,105,49,69,69,69,0,105,105,105,105,105,105,0,105,105,105,105,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,104,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,99,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,116,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,115,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,105,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,102,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,100,69,69,0,118,105,105,105,105,100,100,0,118,105,105,105,105,100,0,118,105,105,105,105,105,0,78,50,99,118,53,82,97,110,103,101,69,0,100,105,105,105,0,102,105,105,105,0,102,105,105,105,105,0,102,105,105,105,105,105,0,100,105,105,105,105,105,0,100,105,105,105,105,0,78,50,99,118,49,50,84,101,114,109,67,114,105,116,101,114,105,97,69,0,100,105,105,0,78,50,99,118,53,83,105,122,101,95,73,102,69,69,0,102,105,105,0,78,50,99,118,53,82,101,99,116,95,73,102,69,69,0,78,49,51,98,105,110,100,105,110,103,95,117,116,105,108,115,57,77,105,110,77,97,120,76,111,99,69,0,78,49,51,98,105,110,100,105,110,103,95,117,116,105,108,115,54,67,105,114,99,108,101,69,0,78,50,99,118,55,77,111,109,101,110,116,115,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,50,49,95,95,98,97,115,105,99,95,115,116,114,105,110,103,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,108,101,110,103,116,104,0,78,50,99,118,54,68,77,97,116,99,104,69,0,78,50,99,118,54,83,116,114,105,110,103,69,0,118,105,105,105,100,100,105,105,0,118,105,105,105,100,100,105,0,118,105,105,105,100,100,0,118,105,105,105,105,100,100,105,0,118,105,105,105,105,100,100,100,100,105,105,0,118,105,105,105,105,100,100,100,100,105,0,118,105,105,105,105,100,100,100,100,0,118,105,105,105,105,100,100,100,0,118,105,105,105,100,100,105,100,100,100,100,0,118,105,105,105,100,100,105,100,100,100,0,118,105,105,105,100,100,105,100,100,0,118,105,105,105,100,100,105,100,0,118,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,100,100,0,118,105,105,105,105,105,100,0,118,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,100,100,0,118,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,105,100,100,0,118,105,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,105,0,118,105,105,105,100,105,105,105,100,0,118,105,105,100,105,100,100,105,105,0,118,105,105,100,105,100,100,105,0,118,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,0,118,105,105,105,105,100,105,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,0,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,100,105,0,118,105,105,105,105,100,105,0,118,105,100,105,105,105,0,118,105,100,105,105,0,118,105,105,105,105,100,100,100,105,105,105,105,0,118,105,105,105,105,100,100,100,105,105,105,0,118,105,105,105,105,100,100,100,105,105,0,118,105,105,105,105,100,100,100,105,0,105,105,105,105,105,105,100,105,0,118,105,105,105,105,105,105,100,105,0,100,105,105,105,105,105,105,105,0,100,105,105,105,105,105,105,0,118,105,105,105,100,105,100,105,105,0,118,105,105,105,100,105,100,105,0,105,105,105,100,100,0,118,105,105,105,105,100,100,105,105,105,100,0,118,105,105,105,105,100,100,105,105,105,0,118,105,105,105,105,100,100,105,105,0,118,105,105,105,105,100,100,105,105,105,105,100,0,118,105,105,105,105,100,100,105,105,105,105,0,100,105,105,105,105,105,105,105,105,0,100,105,105,105,105,100,0,118,105,105,105,100,100,105,105,105,0,118,105,105,100,105,0,118,105,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,105,100,105,105,105,0,118,105,105,105,105,105,100,105,105,0,118,105,105,105,105,105,105,105,100,105,0,118,105,105,0,100,105,105,105,100,100,105,0,105,105,105,100,105,105,105,105,105,0,105,105,105,100,105,105,105,105,0,105,105,105,100,105,105,105,0,105,105,105,100,105,105,0,105,105,105,100,105,0,105,105,105,100,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,51,78,101,116,69,0,80,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,80,75,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,105,105,105,105,105,105,105,105,100,105,100,105,105,105,0,118,105,105,105,105,105,100,105,105,100,100,105,0,118,105,105,105,105,105,100,105,105,100,100,0,118,105,105,105,105,105,100,105,105,100,0,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,75,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,80,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,80,75,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,69,69,0,78,50,99,118,53,67,76,65,72,69,69,0,80,78,50,99,118,53,67,76,65,72,69,69,0,80,75,78,50,99,118,53,67,76,65,72,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,67,76,65,72,69,69,69,69,0,105,105,100,105,0,105,105,100,0,80,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,80,75,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,57,66,70,77,97,116,99,104,101,114,69,69,69,0,80,78,50,99,118,52,75,65,90,69,69,0,80,75,78,50,99,118,52,75,65,90,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,52,75,65,90,69,69,69,69,0,105,105,105,105,102,105,105,105,0,105,105,105,105,102,105,105,0,105,105,105,105,102,105,0,80,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,75,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,80,75,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,80,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,69,69,0,105,105,105,100,100,105,105,100,0,105,105,105,100,100,105,105,0,105,105,105,100,100,105,0,105,105,105,100,100,105,105,105,100,0,80,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,80,75,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,118,105,105,105,105,105,102,105,105,0,118,105,105,105,105,105,102,105,0,118,105,105,105,105,105,102,0,118,105,105,105,105,102,105,105,0,118,105,105,105,105,102,105,0,118,105,105,105,105,102,0,78,50,99,118,51,80,116,114,73,78,83,95,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,51,78,101,116,69,0,80,75,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,51,78,101,116,69,0,80,78,50,99,118,52,77,83,69,82,69,0,80,75,78,50,99,118,52,77,83,69,82,69,0,78,50,99,118,51,80,116,114,73,78,83,95,52,77,83,69,82,69,69,69,0,105,105,105,105,105,100,100,105,100,100,105,0,105,105,105,105,105,100,100,105,100,100,0,105,105,105,105,105,100,100,105,100,0,105,105,105,105,105,100,100,105,0,105,105,105,105,105,100,100,0,105,105,105,105,105,100,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,80,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,75,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,118,105,105,105,105,105,105,100,105,105,105,105,105,0,118,105,105,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,105,105,100,105,105,105,0,118,105,105,105,105,105,105,100,105,105,0,118,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,100,105,105,105,0,118,105,105,105,105,100,105,105,0,80,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,80,78,50,99,118,53,65,75,65,90,69,69,0,80,75,78,50,99,118,53,65,75,65,90,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,65,75,65,90,69,69,69,69,0,105,105,105,105,105,102,105,105,105,0,105,105,105,105,105,102,105,105,0,105,105,105,105,105,102,105,0,105,105,105,105,105,102,0,80,78,50,99,118,51,79,82,66,69,0,80,75,78,50,99,118,51,79,82,66,69,0,78,50,99,118,51,80,116,114,73,78,83,95,51,79,82,66,69,69,69,0,105,105,105,102,105,105,105,105,105,105,105,0,105,105,105,102,105,105,105,105,105,105,0,105,105,105,102,105,105,105,105,105,0,105,105,105,102,105,105,105,105,0,105,105,105,102,105,105,105,0,105,105,105,102,105,105,0,105,105,105,102,105,0,105,105,105,102,0,80,78,50,99,118,53,66,82,73,83,75,69,0,80,75,78,50,99,118,53,66,82,73,83,75,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,66,82,73,83,75,69,69,69,0,105,105,105,105,102,102,105,0,105,105,105,105,102,102,0,105,105,105,105,105,105,102,102,105,0,105,105,105,105,105,105,102,102,0,99,111,110,118,101,114,116,65,110,100,85,110,114,111,108,108,83,99,97,108,97,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,105,116,104,109,46,99,112,112,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,98,105,110,97,114,121,95,111,112,0,112,115,114,99,49,45,62,115,97,109,101,83,105,122,101,40,42,112,115,114,99,50,41,32,38,38,32,116,121,112,101,49,32,61,61,32,116,121,112,101,50,0,40,109,116,121,112,101,32,61,61,32,67,86,95,56,85,32,124,124,32,109,116,121,112,101,32,61,61,32,67,86,95,56,83,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,97,114,105,116,104,109,95,111,112,0,116,121,112,101,50,32,61,61,32,67,86,95,54,52,70,32,38,38,32,40,115,122,50,46,104,101,105,103,104,116,32,61,61,32,49,32,124,124,32,115,122,50,46,104,101,105,103,104,116,32,61,61,32,52,41,0,87,104,101,110,32,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,105,110,32,97,100,100,47,115,117,98,116,114,97,99,116,47,109,117,108,116,105,112,108,121,47,100,105,118,105,100,101,32,102,117,110,99,116,105,111,110,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,115,44,32,116,104,101,32,111,117,116,112,117,116,32,97,114,114,97,121,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,120,112,108,105,99,105,116,108,121,32,115,112,101,99,105,102,105,101,100,0,40,109,116,121,112,101,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,109,116,121,112,101,32,61,61,32,67,86,95,56,83,67,49,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,111,112,32,61,61,32,67,77,80,95,76,84,32,124,124,32,111,112,32,61,61,32,67,77,80,95,76,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,69,81,32,124,124,32,111,112,32,61,61,32,67,77,80,95,78,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,84,0,99,111,109,112,97,114,101,0,95,115,114,99,49,46,101,109,112,116,121,40,41,32,61,61,32,95,115,114,99,50,46,101,109,112,116,121,40,41,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,33,32,95,115,114,99,46,101,109,112,116,121,40,41,0,105,110,82,97,110,103,101,0,84,104,101,32,108,111,119,101,114,32,98,111,117,110,100,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,84,104,101,32,117,112,112,101,114,32,98,111,117,110,100,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,108,98,83,99,97,108,97,114,32,61,61,32,117,98,83,99,97,108,97,114,0,108,98,46,116,121,112,101,40,41,32,61,61,32,117,98,46,116,121,112,101,40,41,0,99,111,110,118,101,114,116,83,99,97,108,101,65,98,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,110,118,101,114,116,95,115,99,97,108,101,46,99,112,112,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,110,111,114,109,32,116,121,112,101,0,110,111,114,109,97,108,105,122,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,56,80,116,114,79,119,110,101,114,69,0,99,46,102,97,99,116,111,114,115,91,48,93,32,61,61,32,99,46,102,97,99,116,111,114,115,91,99,46,110,102,45,49,93,0,68,70,84,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,120,116,46,99,112,112,0,0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,240,8,136,72,200,40,168,104,232,24,152,88,216,56,184,120,248,4,132,68,196,36,164,100,228,20,148,84,212,52,180,116,244,12,140,76,204,44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,125,253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,243,11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,143,79,207,47,175,111,239,31,159,95,223,63,191,127,255,78,50,99,118,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,0,78,50,99,118,51,104,97,108,53,68,70,84,49,68,69,0,78,50,99,118,49,54,82,101,112,108,97,99,101,109,101,110,116,68,70,84,49,68,69,0,84,104,105,115,32,109,111,100,101,32,40,117,115,105,110,103,32,110,111,110,122,101,114,111,95,114,111,119,115,32,119,105,116,104,32,97,32,115,105,110,103,108,101,45,99,111,108,117,109,110,32,109,97,116,114,105,120,41,32,98,114,101,97,107,115,32,116,104,101,32,102,117,110,99,116,105,111,110,39,115,32,108,111,103,105,99,44,32,115,111,32,105,116,32,105,115,32,112,114,111,104,105,98,105,116,101,100,46,10,70,111,114,32,102,97,115,116,32,99,111,110,118,111,108,117,116,105,111,110,47,99,111,114,114,101,108,97,116,105,111,110,32,117,115,101,32,50,45,99,111,108,117,109,110,32,109,97,116,114,105,120,32,111,114,32,115,105,110,103,108,101,45,114,111,119,32,109,97,116,114,105,120,32,105,110,115,116,101,97,100,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,79,99,118,68,102,116,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,48,79,99,118,68,102,116,73,109,112,108,69,0,78,50,99,118,51,104,97,108,53,68,70,84,50,68,69,0,78,50,99,118,49,54,82,101,112,108,97,99,101,109,101,110,116,68,70,84,50,68,69,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,50,0,100,102,116,0,33,40,40,102,108,97,103,115,32,38,32,68,70,84,95,67,79,77,80,76,69,88,95,73,78,80,85,84,41,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,33,61,32,50,41,0,116,121,112,101,32,61,61,32,115,114,99,66,46,116,121,112,101,40,41,32,38,38,32,115,114,99,65,46,115,105,122,101,40,41,32,61,61,32,115,114,99,66,46,115,105,122,101,40,41,0,109,117,108,83,112,101,99,116,114,117,109,115,0,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,50,0,103,101,109,109,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,109,117,108,46,99,112,112,0,116,121,112,101,32,61,61,32,66,46,116,121,112,101,40,41,0,103,101,109,109,0,40,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,41,0,97,95,115,105,122,101,46,119,105,100,116,104,32,61,61,32,108,101,110,0,97,95,115,105,122,101,46,104,101,105,103,104,116,32,61,61,32,108,101,110,0,67,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,0,40,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,61,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,41,32,124,124,32,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,33,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,41,41,0,115,99,110,32,61,61,32,109,46,99,111,108,115,32,124,124,32,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,116,114,97,110,115,102,111,114,109,0,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,112,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,115,99,97,108,101,65,100,100,0,115,114,99,49,46,115,105,122,101,32,61,61,32,115,114,99,50,46,115,105,122,101,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,117,108,84,114,97,110,115,112,111,115,101,100,0,100,101,108,116,97,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,40,100,101,108,116,97,46,114,111,119,115,32,61,61,32,115,114,99,46,114,111,119,115,32,124,124,32,100,101,108,116,97,46,114,111,119,115,32,61,61,32,49,41,0,40,100,101,108,116,97,46,99,111,108,115,32,61,61,32,115,114,99,46,99,111,108,115,32,124,124,32,100,101,108,116,97,46,99,111,108,115,32,61,61,32,49,41,0,109,97,116,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,40,41,0,100,111,116,0,109,97,116,46,115,105,122,101,32,61,61,32,115,105,122,101,0,0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,1,1,1,1,2,2,2,1,2,2,2,1,2,2,2,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,0,110,111,114,109,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,110,111,114,109,46,99,112,112,0,95,115,114,99,49,46,115,97,109,101,83,105,122,101,40,95,115,114,99,50,41,32,38,38,32,95,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,0,100,101,116,101,114,109,105,110,97,110,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,108,97,112,97,99,107,46,99,112,112,0,109,97,116,46,114,111,119,115,32,61,61,32,109,97,116,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,105,110,118,101,114,116,0,109,32,61,61,32,110,0,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,76,85,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,101,105,103,101,110,0,119,46,116,121,112,101,40,41,32,61,61,32,117,46,116,121,112,101,40,41,32,38,38,32,117,46,116,121,112,101,40,41,32,61,61,32,118,116,46,116,121,112,101,40,41,32,38,38,32,117,46,100,97,116,97,32,38],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+204800);allocate([38,32,118,116,46,100,97,116,97,32,38,38,32,119,46,100,97,116,97,0,98,97,99,107,83,117,98,115,116,0,117,46,99,111,108,115,32,62,61,32,110,109,32,38,38,32,118,116,46,114,111,119,115,32,62,61,32,110,109,32,38,38,32,40,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,109,44,32,49,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,109,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,118,116,46,114,111,119,115,44,32,117,46,99,111,108,115,41,41,0,114,104,115,46,100,97,116,97,32,61,61,32,48,32,124,124,32,40,114,104,115,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,32,38,38,32,114,104,115,46,114,111,119,115,32,61,61,32,109,41,0,95,83,86,68,99,111,109,112,117,116,101,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,0,115,111,108,118,101,0,40,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,76,85,32,38,38,32,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,41,32,124,124,32,105,115,95,110,111,114,109,97,108,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,84,104,101,32,102,117,110,99,116,105,111,110,32,99,97,110,32,110,111,116,32,115,111,108,118,101,32,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,98,111,111,108,32,99,118,58,58,115,111,108,118,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,85,110,115,117,112,112,111,114,116,101,100,32,109,101,116,104,111,100,44,32,115,101,101,32,35,68,101,99,111,109,112,84,121,112,101,115,0,109,101,116,104,111,100,0,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,76,85,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,83,86,68,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,69,73,71,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,81,82,0,109,97,112,99,111,117,110,116,32,61,61,32,48,0,126,85,77,97,116,68,97,116,97,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,117,109,97,116,114,105,120,46,99,112,112,0,117,115,97,103,101,95,99,111,117,110,116,32,61,61,32,48,0,108,111,99,107,0,112,116,114,0,103,101,116,82,101,102,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,117,116,105,108,105,116,121,46,104,112,112,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,56,85,77,97,116,68,97,116,97,65,117,116,111,76,111,99,107,101,114,69,69,69,0,117,115,97,103,101,95,99,111,117,110,116,32,61,61,32,49,0,100,97,116,97,32,61,61,32,100,97,116,97,115,116,97,114,116,0,97,108,108,111,99,97,116,101,100,0,85,77,97,116,0,100,115,116,46,117,0,117,45,62,100,97,116,97,32,33,61,32,48,32,38,38,32,34,69,114,114,111,114,32,109,97,112,112,105,110,103,32,111,102,32,85,77,97,116,32,116,111,32,104,111,115,116,32,109,101,109,111,114,121,46,34,0,103,101,116,77,97,116,0,115,114,99,32,38,38,32,110,115,114,99,115,32,62,32,48,32,38,38,32,100,115,116,32,38,38,32,110,100,115,116,115,32,62,32,48,32,38,38,32,102,114,111,109,84,111,32,38,38,32,110,112,97,105,114,115,32,62,32,48,0,109,105,120,67,104,97,110,110,101,108,115,0,106,32,60,32,110,115,114,99,115,32,38,38,32,115,114,99,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,105,49,32,62,61,32,48,32,38,38,32,106,32,60,32,110,100,115,116,115,32,38,38,32,100,115,116,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,104,97,110,110,101,108,115,46,99,112,112,0,102,114,111,109,84,111,46,115,105,122,101,40,41,37,50,32,61,61,32,48,32,38,38,32,110,115,114,99,32,62,32,48,32,38,38,32,110,100,115,116,32,62,32,48,0,48,32,60,61,32,99,111,105,32,38,38,32,99,111,105,32,60,32,99,110,0,101,120,116,114,97,99,116,67,104,97,110,110,101,108,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,114,111,119,115,32,61,61,32,115,114,99,91,48,93,46,114,111,119,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,104,99,111,110,99,97,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,111,112,101,114,97,116,105,111,110,115,46,99,112,112,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,99,111,108,115,32,61,61,32,115,114,99,91,48,93,46,99,111,108,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,118,99,111,110,99,97,116,0,95,109,46,100,105,109,115,40,41,32,60,61,32,50,0,115,101,116,73,100,101,110,116,105,116,121,0,116,114,97,99,101,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,32,38,38,32,101,115,122,32,60,61,32,51,50,0,116,114,97,110,115,112,111,115,101,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,32,38,38,32,40,115,114,99,46,99,111,108,115,32,61,61,32,49,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,49,41,0,109,46,100,105,109,115,32,60,61,32,50,32,38,38,32,109,46,114,111,119,115,32,61,61,32,109,46,99,111,108,115,0,99,111,109,112,108,101,116,101,83,121,109,109,0,114,101,100,117,99,101,0,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,83,85,77,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,77,65,88,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,77,73,78,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,65,86,71,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,97,114,114,97,121,32,102,111,114,109,97,116,115,0,115,114,99,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,115,111,114,116,0,78,50,99,118,50,53,68,117,109,109,121,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,78,50,99,118,50,48,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,115,122,91,105,93,32,60,61,32,40,115,105,122,101,95,116,41,73,78,84,95,77,65,88,0,99,111,112,121,0,117,45,62,117,114,101,102,99,111,117,110,116,32,61,61,32,48,0,100,101,97,108,108,111,99,97,116,101,0,117,45,62,114,101,102,99,111,117,110,116,32,61,61,32,48,0,116,111,116,97,108,32,60,61,32,115,116,101,112,91,105,93,0,97,108,108,111,99,97,116,101,0,78,50,99,118,49,53,83,116,100,77,97,116,65,108,108,111,99,97,116,111,114,69,0,48,32,60,61,32,95,100,105,109,115,32,38,38,32,95,100,105,109,115,32,60,61,32,67,86,95,77,65,88,95,68,73,77,0,115,101,116,83,105,122,101,0,115,32,62,61,32,48,0,84,104,101,32,116,111,116,97,108,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,116,111,32,34,115,105,122,101,95,116,34,32,116,121,112,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,46,99,112,112,0,117,112,108,111,97,100,0,100,111,119,110,108,111,97,100,0,78,50,99,118,49,50,77,97,116,65,108,108,111,99,97,116,111,114,69,0,48,32,60,61,32,100,32,38,38,32,100,32,60,61,32,67,86,95,77,65,88,95,68,73,77,32,38,38,32,95,115,105,122,101,115,0,117,32,33,61,32,48,0,115,116,101,112,91,100,105,109,115,45,49,93,32,61,61,32,40,115,105,122,101,95,116,41,67,86,95,69,76,69,77,95,83,73,90,69,40,102,108,97,103,115,41,0,109,46,100,105,109,115,32,62,61,32,50,0,48,32,60,61,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,38,38,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,114,111,119,115,0,48,32,60,61,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,38,38,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,99,111,108,115,0,114,97,110,103,101,115,0,114,32,61,61,32,82,97,110,103,101,58,58,97,108,108,40,41,32,124,124,32,40,48,32,60,61,32,114,46,115,116,97,114,116,32,38,38,32,114,46,115,116,97,114,116,32,60,32,114,46,101,110,100,32,38,38,32,114,46,101,110,100,32,60,61,32,109,46,115,105,122,101,91,105,93,41,0,48,32,60,61,32,114,111,105,46,120,32,38,38,32,48,32,60,61,32,114,111,105,46,119,105,100,116,104,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,109,46,99,111,108,115,32,38,38,32,48,32,60,61,32,114,111,105,46,121,32,38,38,32,48,32,60,61,32,114,111,105,46,104,101,105,103,104,116,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,109,46,114,111,119,115,0,40,105,110,116,41,114,97,110,103,101,115,46,115,105,122,101,40,41,32,61,61,32,100,0,100,105,109,115,32,60,61,32,50,0,100,105,97,103,0,40,105,110,116,41,110,101,108,101,109,115,32,62,61,32,48,0,114,101,115,101,114,118,101,0,100,105,109,115,32,60,61,32,50,32,38,38,32,115,116,101,112,91,48,93,32,62,32,48,0,108,111,99,97,116,101,82,79,73,0,97,100,106,117,115,116,82,79,73,0,114,101,115,104,97,112,101,0,95,99,110,32,62,61,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,62,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,60,61,32,67,86,95,77,65,88,95,68,73,77,32,38,38,32,95,110,101,119,115,122,0,95,99,110,32,60,61,32,67,86,95,67,78,95,77,65,88,0,95,110,101,119,115,122,91,105,93,32,62,61,32,48,0,67,111,112,121,32,100,105,109,101,110,115,105,111,110,32,40,119,104,105,99,104,32,104,97,115,32,122,101,114,111,32,115,105,122,101,41,32,105,115,32,110,111,116,32,112,114,101,115,101,110,116,32,105,110,32,115,111,117,114,99,101,32,109,97,116,114,105,120,0,82,101,113,117,101,115,116,101,100,32,97,110,100,32,115,111,117,114,99,101,32,109,97,116,114,105,99,101,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,99,111,117,110,116,32,111,102,32,101,108,101,109,101,110,116,115,0,82,101,115,104,97,112,105,110,103,32,111,102,32,110,45,100,105,109,101,110,115,105,111,110,97,108,32,110,111,110,45,99,111,110,116,105,110,117,111,117,115,32,109,97,116,114,105,99,101,115,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,121,101,116,0,101,109,112,116,121,40,41,0,100,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,46,114,111,119,115,32,61,61,32,49,0,83,105,122,101,32,99,118,58,58,103,101,116,67,111,110,116,105,110,117,111,117,115,83,105,122,101,50,68,40,99,118,58,58,77,97,116,32,38,44,32,105,110,116,41,0,109,49,46,100,105,109,115,0,50,0,105,115,95,109,49,95,118,101,99,116,111,114,0,103,101,116,67,111,110,116,105,110,117,111,117,115,83,105,122,101,50,68,0,105,115,95,109,50,95,118,101,99,116,111,114,0,109,49,46,99,111,108,115,32,61,61,32,109,50,46,99,111,108,115,32,38,38,32,109,49,46,114,111,119,115,32,61,61,32,109,50,46,114,111,119,115,0,83,105,122,101,32,99,118,58,58,103,101,116,67,111,110,116,105,110,117,111,117,115,83,105,122,101,50,68,40,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,105,110,116,41,0,116,111,116,97,108,95,115,122,0,109,50,46,116,111,116,97,108,40,41,0,109,50,46,100,105,109,115,0,105,115,95,109,51,95,118,101,99,116,111,114,0,109,49,46,99,111,108,115,32,61,61,32,109,50,46,99,111,108,115,32,38,38,32,109,49,46,114,111,119,115,32,61,61,32,109,50,46,114,111,119,115,32,38,38,32,109,49,46,99,111,108,115,32,61,61,32,109,51,46,99,111,108,115,32,38,38,32,109,49,46,114,111,119,115,32,61,61,32,109,51,46,114,111,119,115,0,83,105,122,101,32,99,118,58,58,103,101,116,67,111,110,116,105,110,117,111,117,115,83,105,122,101,50,68,40,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,105,110,116,41,0,109,51,46,116,111,116,97,108,40,41,0,109,51,46,100,105,109,115,0,40,99,110,32,61,61,32,49,32,38,38,32,40,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,41,32,124,124,32,40,99,110,32,62,32,49,32,38,38,32,95,109,97,115,107,46,101,109,112,116,121,40,41,32,38,38,32,33,109,105,110,73,100,120,32,38,38,32,33,109,97,120,73,100,120,41,0,109,105,110,77,97,120,73,100,120,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,105,110,109,97,120,46,99,112,112,0,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,105,110,77,97,120,76,111,99,0,99,109,112,111,112,32,61,61,32,67,77,80,95,78,69,0,99,109,112,95,108,111,111,112,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,105,116,104,109,46,115,105,109,100,46,104,112,112,0,99,109,112,95,108,111,111,112,95,110,111,115,105,109,100,0,78,50,99,118,49,49,77,97,116,79,112,95,83,111,108,118,101,69,0,67,86,95,77,65,84,95,67,78,40,95,116,121,112,101,41,32,61,61,32,101,46,97,46,99,104,97,110,110,101,108,115,40,41,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,101,120,112,114,101,115,115,105,111,110,115,46,99,112,112,0,78,50,99,118,49,52,77,97,116,79,112,95,73,100,101,110,116,105,116,121,69,0,78,50,99,118,49,50,77,97,116,79,112,95,73,110,118,101,114,116,69,0,78,50,99,118,49,48,77,97,116,79,112,95,71,69,77,77,69,0,85,110,107,110,111,119,110,32,111,112,101,114,97,116,105,111,110,0,78,50,99,118,57,77,97,116,79,112,95,66,105,110,69,0,78,50,99,118,49,49,77,97,116,79,112,95,65,100,100,69,120,69,0,78,50,99,118,55,77,97,116,79,112,95,84,69,0,78,50,99,118,53,77,97,116,79,112,69,0,78,50,99,118,57,77,97,116,79,112,95,67,109,112,69,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,105,110,105,116,105,97,108,105,122,101,114,32,116,121,112,101,0,78,50,99,118,49,55,77,97,116,79,112,95,73,110,105,116,105,97,108,105,122,101,114,69,0,83,116,101,112,32,109,117,115,116,32,98,101,32,97,32,109,117,108,116,105,112,108,101,32,111,102,32,101,115,122,49,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,112,108,105,116,46,99,112,112,0,33,95,109,118,46,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,95,109,118,46,101,109,112,116,121,40,41,32,124,124,32,95,109,118,46,116,121,112,101,40,41,32,61,61,32,109,46,100,101,112,116,104,40,41,0,99,111,110,118,101,114,116,84,111,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,110,118,101,114,116,46,99,112,112,0,100,100,101,112,116,104,32,61,61,32,67,86,95,49,54,83,0,99,111,110,118,101,114,116,70,112,49,54,0,95,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,0,85,110,115,117,112,112,111,114,116,101,100,32,105,110,112,117,116,32,100,101,112,116,104,0,109,118,32,38,38,32,110,32,62,32,48,0,109,101,114,103,101,0,109,118,91,105,93,46,115,105,122,101,32,61,61,32,109,118,91,48,93,46,115,105,122,101,32,38,38,32,109,118,91,105,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,48,32,60,32,99,110,32,38,38,32,99,110,32,60,61,32,67,86,95,67,78,95,77,65,88,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,101,114,103,101,46,99,112,112,0,99,104,97,110,110,101,108,115,40,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,116,121,112,101,41,0,100,115,116,46,117,32,33,61,32,78,85,76,76,0,100,105,109,115,32,62,32,48,32,38,38,32,100,105,109,115,32,60,32,67,86,95,77,65,88,95,68,73,77,0,118,111,105,100,32,99,118,58,58,77,97,116,58,58,99,111,112,121,84,111,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,112,121,46,99,112,112,0,115,122,46,119,105,100,116,104,0,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,0,115,105,122,101,40,41,32,61,61,32,109,97,115,107,46,115,105,122,101,40,41,0,115,122,32,60,61,32,115,105,122,101,111,102,40,115,99,97,108,97,114,41,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,95,118,97,108,117,101,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,77,65,84,32,41,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,32,38,38,32,115,105,122,101,32,61,61,32,109,97,115,107,46,115,105,122,101,41,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,0,102,108,105,112,0,95,115,114,99,46,103,101,116,79,98,106,40,41,32,33,61,32,95,100,115,116,46,103,101,116,79,98,106,40,41,0,114,101,112,101,97,116,0,110,121,32,62,32,48,32,38,38,32,110,120,32,62,32,48,0,98,111,114,100,101,114,73,110,116,101,114,112,111,108,97,116,101,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,98,111,114,100,101,114,32,116,121,112,101,0,116,111,112,32,62,61,32,48,32,38,38,32,98,111,116,116,111,109,32,62,61,32,48,32,38,38,32,108,101,102,116,32,62,61,32,48,32,38,38,32,114,105,103,104,116,32,62,61,32,48,32,38,38,32,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,0,99,111,112,121,77,97,107,101,66,111,114,100,101,114,0,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,49,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,50,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,51,93,0,109,97,115,107,97,114,114,32,61,61,32,48,0,99,118,67,111,112,121,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,38,38,32,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,0,40,99,111,105,49,32,33,61,32,48,32,124,124,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,32,38,38,32,40,99,111,105,50,32,33,61,32,48,32,124,124,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,51,67,118,70,105,108,101,83,116,111,114,97,103,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,49,70,105,108,101,83,116,111,114,97,103,101,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,99,112,112,46,99,112,112,0,69,120,116,114,97,32,99,108,111,115,105,110,103,32,39,37,99,39,0,84,104,101,32,99,108,111,115,105,110,103,32,39,37,99,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,111,112,101,110,105,110,103,32,39,37,99,39,0,73,110,99,111,114,114,101,99,116,32,101,108,101,109,101,110,116,32,110,97,109,101,32,37,115,0,73,110,118,97,108,105,100,32,102,115,46,115,116,97,116,101,0,108,101,110,32,37,32,101,108,101,109,83,105,122,101,32,61,61,32,48,0,119,114,105,116,101,82,97,119,0,46,103,122,0,73,110,118,97,108,105,100,32,102,105,108,101,110,97,109,101,0,103,101,116,68,101,102,97,117,108,116,79,98,106,101,99,116,78,97,109,101,0,101,108,101,109,95,115,105,122,101,32,62,32,48,0,114,101,97,100,82,97,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,105,32,60,32,48,0,103,101,116,77,97,116,95,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,119,114,97,112,46,99,112,112,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,115,122,46,104,101,105,103,104,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,109,97,112,72,111,115,116,47,117,110,109,97,112,72,111,115,116,32,109,101,116,104,111,100,115,32,102,111,114,32,111,103,108,58,58,66,117,102,102,101,114,32,111,98,106,101,99,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,100,111,119,110,108,111,97,100,32,109,101,116,104,111,100,32,102,111,114,32,99,117,100,97,58,58,71,112,117,77,97,116,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,40,102,108,97,103,115,32,38,32,70,73,88,69,68,95,84,89,80,69,41,32,33,61,32,48,0,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,105,32,60,32,115,122,46,104,101,105,103,104,116,0,103,101,116,85,77,97,116,0,103,101,116,77,97,116,86,101,99,116,111,114,0,100,105,109,115,0,101,109,112,116,121,0,105,32,62,61,32,48,32,38,38,32,40,115,105,122,101,95,116,41,105,32,60,32,118,118,46,115,105,122,101,40,41,0,105,115,67,111,110,116,105,110,117,111,117,115,0,105,32,62,32,48,32,38,38,32,105,32,60,32,115,122,46,104,101,105,103,104,116,0,99,111,112,121,84,111,0,33,102,105,120,101,100,83,105,122,101,40,41,0,114,101,108,101,97,115,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,84,121,112,101,40,41,32,38,38,32,33,102,105,120,101,100,83,105,122,101,40,41,0,67,86,95,77,65,84,95,84,89,80,69,40,109,116,121,112,101,41,32,61,61,32,109,46,116,121,112,101,40,41,0,109,46,100,105,109,115,32,61,61,32,100,0,109,46,115,105,122,101,91,106,93,32,61,61,32,115,105,122,101,115,91,106,93,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,67,86,95,77,65,84,95,67,78,40,109,116,121,112,101,41,32,61,61,32,49,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,100,32,61,61,32,50,32,38,38,32,40,40,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,104,101,105,103,104,116,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,119,105,100,116,104,41,32,124,124,32,40,97,108,108,111,119,84,114,97,110,115,112,111,115,101,100,32,38,38,32,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,119,105,100,116,104,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,104,101,105,103,104,116,41,41,0,100,32,61,61,32,50,32,38,38,32,115,122,46,97,114,101,97,40,41,32,61,61,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,0,100,32,61,61,32,50,32,38,38,32,40,115,105,122,101,115,91,48,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,49,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,32,61,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,118,118,46,115,105,122,101,40,41,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,67,86,95,77,65,84,95,67,78,40,109,116,121,112,101,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,116,121,112,101,48,41,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,40,40,115,116,100,58,58,118,101,99,116,111,114,60,117,99,104,97,114,62,42,41,118,41,45,62,115,105,122,101,40,41,32,47,32,101,115,122,0,86,101,99,116,111,114,115,32,119,105,116,104,32,101,108,101,109,101,110,116,32,115,105,122,101,32,37,100,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,46,32,80,108,101,97,115,101,44,32,109,111,100,105,102,121,32,79,117,116,112,117,116,65,114,114,97,121,58,58,99,114,101,97,116,101,40,41,10,0,99,114,101,97,116,101,40,41,32,99,97,108,108,101,100,32,102,111,114,32,116,104,101,32,109,105,115,115,105,110,103,32,111,117,116,112,117,116,32,97,114,114,97,121,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,108,101,110,48,0,118,91,106,93,46,101,109,112,116,121,40,41,0,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,108,101,110,32,61,61,32,108,101,110,48,0,103,101,116,77,97,116,82,101,102,0,107,32,61,61,32,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,107,32,61,61,32,83,84,68,95,65,82,82,65,89,95,77,65,84,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,99,108,101,97,114,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,97,114,114,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,67,85,68,65,95,71,80,85,95,77,65,84,41,0,115,101,116,84,111,0,97,115,115,105,103,110,0,116,104,105,115,95,118,46,115,105,122,101,40,41,32,61,61,32,118,46,115,105,122,101,40,41,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,37,108,108,117,32,98,121,116,101,115,0,79,117,116,79,102,77,101,109,111,114,121,69,114,114,111,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,108,108,111,99,46,99,112,112,0,109,121,95,111,98,106,101,99,116,0,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,114,97,121,46,99,112,112,0,68,97,116,97,32,105,115,32,97,108,114,101,97,100,121,32,97,108,108,111,99,97,116,101,100,0,99,118,67,114,101,97,116,101,68,97,116,97,0,84,111,111,32,98,105,103,32,98,117,102,102,101,114,32,105,115,32,97,108,108,111,99,97,116,101,100,0,79,118,101,114,102,108,111,119,32,102,111,114,32,105,109,97,103,101,83,105,122,101,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,78,111,110,45,112,111,115,105,116,105,118,101,32,119,105,100,116,104,32,111,114,32,104,101,105,103,104,116,0,99,118,67,114,101,97,116,101,77,97,116,72,101,97,100,101,114,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,116,121,112,101,0,99,118,73,110,105,116,77,97,116,72,101,97,100,101,114,0,78,111,110,45,112,111,115,105,116,105,118,101,32,99,111,108,115,32,111,114,32,114,111,119,115,0,99,118,82,101,108,101,97,115,101,77,97,116,0,66,97,100,32,67,118,77,97,116,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,77,97,116,0,78,85,76,76,32,109,97,116,114,105,120,32,104,101,97,100,101,114,32,112,111,105,110,116,101,114,0,99,118,73,110,105,116,77,97,116,78,68,72,101,97,100,101,114,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,100,97,116,97,32,116,121,112,101,0,78,85,76,76,32,60,115,105,122,101,115,62,32,112,111,105,110,116,101,114,0,110,111,110,45,112,111,115,105,116,105,118,101,32,111,114,32,116,111,111,32,108,97,114,103,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,0,111,110,101,32,111,102,32,100,105,109,101,115,105,111,110,32,115,105,122,101,115,32,105,115,32,110,111,110,45,112,111,115,105,116,105,118,101,0,84,104,101,32,97,114,114,97,121,32,105,115,32,116,111,111,32,98,105,103,0,99,118,67,114,101,97,116,101,77,97,116,78,68,72,101,97,100,101,114,0,66,97,100,32,67,118,77,97,116,78,68,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,77,97,116,78,68,0,115,114,99,45,62,100,105,109,115,32,60,61,32,67,86,95,77,65,88,95,68,73,77,0,95,100,115,116,46,100,97,116,97,32,61,61,32,100,97,116,97,48,0,73,110,99,111,114,114,101,99,116,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,115,0,99,118,73,110,105,116,78,65,114,114,97,121,73,116,101,114,97,116,111,114,0,83,111,109,101,32,111,102,32,114,101,113,117,105,114,101,100,32,97,114,114,97,121,32,112,111,105,110,116,101,114,115,32,105,115,32,78,85,76,76,0,73,116,101,114,97,116,111,114,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,73,116,101,114,97,116,111,114,32,119,105,116,104,32,109,97,115,107,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,67,79,73,32,115,101,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,78,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,115,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,97,116,97,32,116,121,112,101,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,78,117,109,98,101,114,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+215040);allocate([111,102,32,99,104,97,110,110,101,108,115,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,101,112,116,104,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,105,109,101,110,115,105,111,110,32,115,105,122,101,115,32,97,114,101,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,78,85,76,76,32,97,114,114,97,121,32,112,111,105,110,116,101,114,32,105,115,32,112,97,115,115,101,100,0,99,118,71,101,116,77,97,116,78,68,0,84,104,101,32,109,97,116,114,105,120,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,73,110,112,117,116,32,97,114,114,97,121,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,99,118,71,101,116,77,97,116,0,84,104,101,32,105,109,97,103,101,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,67,79,73,32,115,101,108,101,99,116,101,100,0,84,104,101,32,105,109,97,103,101,32,105,115,32,105,110,116,101,114,108,101,97,118,101,100,32,97,110,100,32,104,97,115,32,111,118,101,114,32,67,86,95,67,78,95,77,65,88,32,99,104,97,110,110,101,108,115,0,80,105,120,101,108,32,111,114,100,101,114,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,99,111,105,32,61,61,32,48,0,79,110,108,121,32,99,111,110,116,105,110,117,111,117,115,32,110,68,32,97,114,114,97,121,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,104,101,114,101,0,99,118,67,114,101,97,116,101,83,112,97,114,115,101,77,97,116,0,98,97,100,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,0,99,118,82,101,108,101,97,115,101,83,112,97,114,115,101,77,97,116,0,73,110,118,97,108,105,100,32,115,112,97,114,115,101,32,97,114,114,97,121,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,83,112,97,114,115,101,77,97,116,0,73,110,118,97,108,105,100,32,115,112,97,114,115,101,32,109,97,116,114,105,120,32,104,101,97,100,101,114,0,99,118,73,110,105,116,83,112,97,114,115,101,77,97,116,73,116,101,114,97,116,111,114,0,99,118,82,101,108,101,97,115,101,68,97,116,97,0,105,110,100,101,120,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,99,118,80,116,114,50,68,0,67,79,73,32,109,117,115,116,32,98,101,32,110,111,110,45,110,117,108,108,32,105,110,32,99,97,115,101,32,111,102,32,112,108,97,110,97,114,32,105,109,97,103,101,115,0,40,40,67,118,83,112,97,114,115,101,77,97,116,42,41,97,114,114,41,45,62,100,105,109,115,32,61,61,32,50,0,79,110,101,32,111,102,32,105,110,100,105,99,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,105,99,118,71,101,116,78,111,100,101,80,116,114,0,99,118,71,101,116,69,108,101,109,84,121,112,101,0,99,118,71,101,116,68,105,109,115,0,65,114,114,97,121,32,115,104,111,117,108,100,32,98,101,32,67,118,77,97,116,32,111,114,32,73,112,108,73,109,97,103,101,0,99,118,71,101,116,83,105,122,101,0,78,85,76,76,32,112,111,105,110,116,101,114,32,116,111,32,105,110,100,105,99,101,115,0,99,118,80,116,114,78,68,0,84,104,101,32,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,99,118,82,101,115,104,97,112,101,0,84,104,101,32,109,97,116,114,105,120,32,105,115,32,110,111,116,32,99,111,110,116,105,110,117,111,117,115,44,32,116,104,117,115,32,105,116,115,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,32,99,97,110,32,110,111,116,32,98,101,32,99,104,97,110,103,101,100,0,66,97,100,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,84,104,101,32,116,111,116,97,108,32,119,105,100,116,104,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,110,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,104,101,97,100,101,114,0,99,118,73,110,105,116,73,109,97,103,101,72,101,97,100,101,114,0,66,97,100,32,105,110,112,117,116,32,114,111,105,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,0,66,97,100,32,105,110,112,117,116,32,111,114,105,103,105,110,0,66,97,100,32,105,110,112,117,116,32,97,108,105,103,110,0,71,82,65,89,0,82,71,66,0,66,71,82,0,66,71,82,65,0,99,118,82,101,108,101,97,115,101,73,109,97,103,101,0,99,118,83,101,116,73,109,97,103,101,82,79,73,0,114,101,99,116,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,101,99,116,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,101,99,116,46,120,32,60,32,105,109,97,103,101,45,62,119,105,100,116,104,32,38,38,32,114,101,99,116,46,121,32,60,32,105,109,97,103,101,45,62,104,101,105,103,104,116,32,38,38,32,114,101,99,116,46,120,32,43,32,114,101,99,116,46,119,105,100,116,104,32,62,61,32,40,105,110,116,41,40,114,101,99,116,46,119,105,100,116,104,32,62,32,48,41,32,38,38,32,114,101,99,116,46,121,32,43,32,114,101,99,116,46,104,101,105,103,104,116,32,62,61,32,40,105,110,116,41,40,114,101,99,116,46,104,101,105,103,104,116,32,62,32,48,41,0,99,118,83,101,116,73,109,97,103,101,67,79,73,0,99,118,71,101,116,73,109,97,103,101,67,79,73,0,66,97,100,32,105,109,97,103,101,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,73,109,97,103,101,0,99,110,32,60,61,32,52,0,115,99,97,108,97,114,84,111,82,97,119,68,97,116,97,0,98,97,115,101,54,52,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,102,105,108,101,110,97,109,101,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,98,117,102,102,101,114,0,99,118,79,112,101,110,70,105,108,101,83,116,111,114,97,103,101,0,67,86,95,83,84,79,82,65,71,69,95,65,80,80,69,78,68,32,97,110,100,32,67,86,95,83,84,79,82,65,71,69,95,77,69,77,79,82,89,32,97,114,101,32,110,111,116,32,99,117,114,114,101,110,116,108,121,32,99,111,109,112,97,116,105,98,108,101,0,65,112,112,101,110,100,105,110,103,32,100,97,116,97,32,116,111,32,99,111,109,112,114,101,115,115,101,100,32,102,105,108,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,97,43,116,0,119,116,0,114,116,0,85,84,70,45,49,54,0,117,116,102,45,49,54,0,85,116,102,45,49,54,0,85,84,70,45,49,54,32,88,77,76,32,101,110,99,111,100,105,110,103,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,33,32,85,115,101,32,56,45,98,105,116,32,101,110,99,111,100,105,110,103,10,0,115,116,114,108,101,110,40,101,110,99,111,100,105,110,103,41,32,60,32,49,48,48,48,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,32,101,110,99,111,100,105,110,103,61,34,37,115,34,63,62,10,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,114,43,116,0,32,60,33,45,45,32,114,101,115,117,109,101,100,32,45,45,62,0,37,89,65,77,76,58,49,46,48,10,45,45,45,10,0,46,46,46,10,45,45,45,10,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,39,125,39,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,73,110,112,117,116,32,102,105,108,101,32,105,115,32,101,109,112,116,121,0,85,110,115,117,112,112,111,114,116,101,100,32,102,105,108,101,32,115,116,111,114,97,103,101,32,102,111,114,109,97,116,0,99,118,82,101,108,101,97,115,101,70,105,108,101,83,116,111,114,97,103,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,99,46,99,112,112,0,110,111,100,101,32,33,61,32,78,85,76,76,0,99,118,76,111,97,100,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,116,104,101,47,97,110,32,111,98,106,101,99,116,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,78,85,76,76,32,109,101,109,111,114,121,32,115,116,111,114,97,103,101,32,105,115,32,112,97,115,115,101,100,32,45,32,116,104,101,32,108,111,97,100,101,100,32,100,121,110,97,109,105,99,32,115,116,114,117,99,116,117,114,101,32,99,97,110,32,110,111,116,32,98,101,32,115,116,111,114,101,100,0,99,118,82,101,108,101,97,115,101,0,85,110,107,110,111,119,110,32,111,98,106,101,99,116,32,116,121,112,101,0,114,101,108,101,97,115,101,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,82,101,97,100,0,84,104,101,32,110,111,100,101,32,100,111,101,115,32,110,111,116,32,114,101,112,114,101,115,101,110,116,32,97,32,117,115,101,114,32,111,98,106,101,99,116,32,40,117,110,107,110,111,119,110,32,116,121,112,101,63,41,0,99,118,71,101,116,70,105,108,101,78,111,100,101,66,121,78,97,109,101,0,78,117,108,108,32,101,108,101,109,101,110,116,32,110,97,109,101,0,84,104,101,32,110,111,100,101,32,105,115,32,110,101,105,116,104,101,114,32,97,32,109,97,112,32,110,111,114,32,97,110,32,101,109,112,116,121,32,99,111,108,108,101,99,116,105,111,110,0,99,118,71,101,116,70,105,108,101,78,111,100,101,0,78,117,108,108,32,107,101,121,32,101,108,101,109,101,110,116,0,109,97,112,95,110,111,100,101,32,33,61,32,78,85,76,76,0,68,117,112,108,105,99,97,116,101,100,32,107,101,121,0,99,118,71,101,116,82,111,111,116,70,105,108,101,78,111,100,101,0,99,118,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,109,117,115,116,32,115,101,116,32,39,115,116,114,117,99,116,95,102,108,97,103,115,32,124,61,32,67,86,95,78,79,68,69,95,83,69,81,39,32,105,102,32,117,115,105,110,103,32,66,97,115,101,54,52,46,0,102,117,110,99,116,105,111,110,32,39,99,118,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,39,32,99,97,108,108,115,32,99,97,110,110,111,116,32,98,101,32,110,101,115,116,101,100,32,105,102,32,117,115,105,110,103,32,66,97,115,101,54,52,46,0,65,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,111,117,116,112,117,116,32,66,97,115,101,54,52,44,32,96,99,118,69,110,100,87,114,105,116,101,83,116,114,117,99,116,96,32,105,115,32,110,101,101,100,101,100,46,0,99,118,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,99,118,87,114,105,116,101,73,110,116,0,99,118,87,114,105,116,101,82,101,97,108,0,99,118,87,114,105,116,101,83,116,114,105,110,103,0,99,118,87,114,105,116,101,67,111,109,109,101,110,116,0,99,118,87,114,105,116,101,82,97,119,68,97,116,97,0,78,101,103,97,116,105,118,101,32,110,117,109,98,101,114,32,111,102,32,101,108,101,109,101,110,116,115,0,78,117,108,108,32,100,97,116,97,32,112,111,105,110,116,101,114,0,99,118,83,116,97,114,116,82,101,97,100,82,97,119,68,97,116,97,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,115,111,117,114,99,101,32,102,105,108,101,32,110,111,100,101,32,111,114,32,114,101,97,100,101,114,0,84,104,101,32,102,105,108,101,32,110,111,100,101,32,115,104,111,117,108,100,32,98,101,32,97,32,110,117,109,101,114,105,99,97,108,32,115,99,97,108,97,114,32,111,114,32,97,32,115,101,113,117,101,110,99,101,0,99,118,82,101,97,100,82,97,119,68,97,116,97,83,108,105,99,101,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,114,101,97,100,101,114,32,111,114,32,100,101,115,116,105,110,97,116,105,111,110,32,97,114,114,97,121,0,84,104,101,32,114,101,97,100,32,115,101,113,117,101,110,99,101,32,105,115,32,97,32,115,99,97,108,97,114,44,32,116,104,117,115,32,108,101,110,32,109,117,115,116,32,98,101,32,49,0,84,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,97,32,110,117,109,101,114,105,99,97,108,32,115,99,97,108,97,114,0,84,104,101,32,115,101,113,117,101,110,99,101,32,115,108,105,99,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,97,110,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,32,111,102,32,114,101,99,111,114,100,115,0,78,117,108,108,32,112,111,105,110,116,101,114,115,32,116,111,32,115,111,117,114,99,101,32,102,105,108,101,32,110,111,100,101,32,111,114,32,100,101,115,116,105,110,97,116,105,111,110,32,97,114,114,97,121,0,99,118,82,101,97,100,82,97,119,68,97,116,97,0,73,110,118,97,108,105,100,32,116,121,112,101,32,105,110,102,111,0,99,118,82,101,103,105,115,116,101,114,84,121,112,101,0,83,111,109,101,32,111,102,32,114,101,113,117,105,114,101,100,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,115,32,40,105,115,95,105,110,115,116,97,110,99,101,44,32,114,101,108,101,97,115,101,44,32,114,101,97,100,32,111,114,32,119,114,105,116,101,41,32,97,114,101,32,78,85,76,76,0,84,121,112,101,32,110,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,84,121,112,101,32,110,97,109,101,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,111,110,108,121,32,108,101,116,116,101,114,115,44,32,100,105,103,105,116,115,44,32,45,32,97,110,100,32,95,0,99,118,87,114,105,116,101,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,116,104,101,32,119,114,105,116,116,101,110,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,32,111,98,106,101,99,116,0,84,104,101,32,111,98,106,101,99,116,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,119,114,105,116,101,32,102,117,110,99,116,105,111,110,0,60,105,110,118,97,108,105,100,32,100,101,112,116,104,62,0,67,86,95,56,85,0,67,86,95,56,83,0,67,86,95,49,54,85,0,67,86,95,49,54,83,0,67,86,95,51,50,83,0,67,86,95,51,50,70,0,67,86,95,54,52,70,0,67,86,95,85,83,82,84,89,80,69,49,0,37,115,67,37,100,0,60,105,110,118,97,108,105,100,32,116,121,112,101,62,0,32,40,101,120,112,101,99,116,101,100,58,32,39,0,63,63,63,0,39,41,44,32,119,104,101,114,101,0,32,32,32,32,39,0,39,32,105,115,32,0,109,117,115,116,32,98,101,32,0,123,99,117,115,116,111,109,32,99,104,101,99,107,125,0,101,113,117,97,108,32,116,111,0,110,111,116,32,101,113,117,97,108,32,116,111,0,108,101,115,115,32,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,0,108,101,115,115,32,116,104,97,110,0,103,114,101,97,116,101,114,32,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,0,103,114,101,97,116,101,114,32,116,104,97,110,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,56,98,97,115,105,99,95,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,39,0,119,104,101,114,101,0,79,80,69,78,67,86,95,75,77,69,65,78,83,95,80,65,82,65,76,76,69,76,95,71,82,65,78,85,76,65,82,73,84,89,0,100,97,116,97,48,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,38,38,32,75,32,62,32,48,0,107,109,101,97,110,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,107,109,101,97,110,115,46,99,112,112,0,78,32,62,61,32,75,0,40,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,32,61,61,32,49,32,124,124,32,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,42,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,78,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,40,117,110,115,105,103,110,101,100,41,95,108,97,98,101,108,115,46,97,116,60,105,110,116,62,40,105,41,32,60,32,40,117,110,115,105,103,110,101,100,41,75,0,99,111,117,110,116,101,114,115,91,107,93,32,33,61,32,48,0,78,50,99,118,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,73,76,98,48,69,69,69,0,78,50,99,118,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,73,76,98,49,69,69,69,0,78,50,99,118,50,52,75,77,101,97,110,115,80,80,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,95,97,114,114,97,121,115,32,38,38,32,40,95,112,116,114,115,32,124,124,32,95,112,108,97,110,101,115,41,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,105,116,101,114,97,116,111,114,46,99,112,112,0,110,97,114,114,97,121,115,32,60,61,32,49,48,48,48,0,97,114,114,97,121,115,91,105,93,32,33,61,32,48,0,65,46,115,105,122,101,32,61,61,32,97,114,114,97,121,115,91,105,48,93,45,62,115,105,122,101,0,65,46,115,116,101,112,91,100,45,49,93,32,61,61,32,65,46,101,108,101,109,83,105,122,101,40,41,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,109,101,97,110,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,101,97,110,46,99,112,112,0,109,101,97,110,83,116,100,68,101,118,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,100,115,116,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,115,116,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,100,99,110,32,62,61,32,99,110,0,99,111,117,110,116,78,111,110,90,101,114,111,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,117,110,116,95,110,111,110,95,122,101,114,111,46,99,112,112,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,32,38,38,32,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,0,109,97,103,110,105,116,117,100,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,46,99,112,112,0,88,46,115,105,122,101,32,61,61,32,89,46,115,105,122,101,32,38,38,32,116,121,112,101,32,61,61,32,89,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,0,99,97,114,116,84,111,80,111,108,97,114,0,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,40,115,114,99,49,46,101,109,112,116,121,40,41,32,124,124,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,41,0,112,111,108,97,114,84,111,67,97,114,116,0,77,97,103,46,101,109,112,116,121,40,41,32,124,124,32,65,110,103,108,101,46,115,105,122,101,32,61,61,32,77,97,103,46,115,105,122,101,0,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,0,101,120,112,0,108,111,103,0,112,116,32,61,61,32,78,85,76,76,0,99,104,101,99,107,82,97,110,103,101,0,116,104,101,32,118,97,108,117,101,32,97,116,32,40,37,100,44,32,37,100,41,61,37,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,102,44,32,37,102,41,0,99,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,99,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,115,111,108,118,101,67,117,98,105,99,0,40,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,43,49,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,43,49,41,41,0,67,86,95,77,65,84,95,68,69,80,84,72,40,99,116,121,112,101,41,32,62,61,32,67,86,95,51,50,70,32,38,38,32,67,86,95,77,65,84,95,67,78,40,99,116,121,112,101,41,32,60,61,32,50,0,115,111,108,118,101,80,111,108,121,0,99,111,101,102,102,115,48,46,114,111,119,115,32,61,61,32,49,32,124,124,32,99,111,101,102,102,115,48,46,99,111,108,115,32,61,61,32,49,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,111,103,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,112,101,110,103,108,46,99,112,112,0,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,48,49,50,51,52,53,54,55,56,57,43,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,63,52,53,54,55,56,57,58,59,60,61,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,0,0,0,0,0,0,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,0,0,0,0,98,117,102,102,101,114,46,115,105,122,101,40,41,32,60,32,72,69,65,68,69,82,95,83,73,90,69,0,109,97,107,101,95,98,97,115,101,54,52,95,104,101,97,100,101,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,98,97,115,101,54,52,46,99,112,112,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,105,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,102,108,117,115,104,0,100,115,116,95,99,117,114,32,43,32,108,101,110,32,60,32,100,115,116,95,101,110,100,0,102,108,117,115,104,40,41,0,73,110,118,97,108,105,100,32,112,111,105,110,116,101,114,32,116,111,32,102,105,108,101,32,115,116,111,114,97,103,101,0,66,97,115,101,54,52,87,114,105,116,101,114,0,84,104,101,32,102,105,108,101,32,115,116,111,114,97,103,101,32,105,115,32,111,112,101,110,101,100,32,102,111,114,32,114,101,97,100,105,110,103,0,66,97,115,101,54,52,67,111,110,116,101,120,116,69,109,105,116,116,101,114,0,34,36,98,97,115,101,54,52,36,0,115,114,99,0,82,97,119,68,97,116,97,84,111,66,105,110,97,114,121,67,111,110,118,101,114,116,111,114,0,33,100,116,46,101,109,112,116,121,40,41,0,108,101,110,32,62,32,48,0,109,97,107,101,95,116,111,95,98,105,110,97,114,121,95,102,117,110,99,115,0,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,105,115,115,46,101,111,102,40,41,0,73,110,118,97,108,105,100,32,39,100,116,39,46,0,99,104,101,99,107,95,100,116,0,39,100,116,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,46,0,66,105,110,97,114,121,84,111,67,118,83,101,113,67,111,110,118,101,114,116,111,114,0,109,97,107,101,95,102,117,110,99,115,0,98,105,110,97,114,121,95,116,111,95,102,117,110,99,115,46,115,105,122,101,40,41,0,99,118,87,114,105,116,101,82,97,119,68,97,116,97,66,97,115,101,54,52,0,66,97,115,101,54,52,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,117,115,101,100,32,97,116,32,112,114,101,115,101,110,116,46,0,33,95,109,97,116,46,101,109,112,116,121,40,41,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,114,97,110,100,46,99,112,112,0,95,112,97,114,97,109,49,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,49,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,99,110,32,60,61,32,52,41,41,0,95,112,97,114,97,109,50,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,40,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,99,110,32,60,61,32,52,41,41,41,32,124,124,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,99,110,32,38,38,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,99,110,32,38,38,32,100,105,115,116,116,121,112,101,32,61,61,32,78,79,82,77,65,76,41,41,0,115,99,97,108,101,70,117,110,99,32,33,61,32,48,0,85,110,107,110,111,119,110,32,100,105,115,116,114,105,98,117,116,105,111,110,32,116,121,112,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,99,46,99,112,112,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,99,118,97,114,114,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,73,80,76,95,68,65,84,65,95,79,82,68,69,82,95,80,73,88,69,76,0,105,112,108,73,109,97,103,101,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,73,80,76,95,68,65,84,65,95,79,82,68,69,82,95,80,73,88,69,76,32,124,124,32,105,109,103,45,62,114,111,105,45,62,99,111,105,32,33,61,32,48,0,116,111,116,97,108,32,62,32,48,32,38,38,32,67,86,95,69,76,69,77,95,83,73,90,69,40,115,101,113,45,62,102,108,97,103,115,41,32,61,61,32,101,115,122,0,85,110,107,110,111,119,110,32,97,114,114,97,121,32,116,121,112,101,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,45,116,114,101,101,0,111,112,101,110,99,118,45,103,114,97,112,104,0,111,112,101,110,99,118,45,115,112,97,114,115,101,45,109,97,116,114,105,120,0,111,112,101,110,99,118,45,105,109,97,103,101,0,111,112,101,110,99,118,45,109,97,116,114,105,120,0,111,112,101,110,99,118,45,110,100,45,109,97,116,114,105,120,0,115,105,122,101,115,0,105,0,100,116,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,109,97,116,114,105,120,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,77,97,116,78,68,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,116,104,101,32,109,97,116,114,105,120,32,100,105,109,101,110,115,105,111,110,97,108,105,116,121,0,84,104,101,32,109,97,116,114,105,120,32,100,97,116,97,32,105,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,84,104,101,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,111,114,101,100,32,101,108,101,109,101,110,116,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,116,121,112,101,115,46,99,112,112,0,114,111,119,115,0,99,111,108,115,0,105,99,118,82,101,97,100,77,97,116,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,105,99,118,87,114,105,116,101,73,109,97,103,101,0,116,111,112,45,108,101,102,116,0,98,111,116,116,111,109,45,108,101,102,116,0,111,114,105,103,105,110,0,112,108,97,110,97,114,0,105,110,116,101,114,108,101,97,118,101,100,0,108,97,121,111,117,116,0,114,111,105,0,121,0,99,111,105,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,105,109,97,103,101,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,73,109,97,103,101,0,79,110,108,121,32,105,110,116,101,114,108,101,97,118,101,100,32,105,109,97,103,101,115,32,99,97,110,32,98,101,32,114,101,97,100,0,84,104,101,32,105,109,97,103,101,32,100,97,116,97,32,105,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,105,99,118,82,101,97,100,83,112,97,114,115,101,77,97,116,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,112,97,114,115,101,32,109,97,116,114,105,120,32,100,105,109,101,110,115,105,111,110,97,108,105,116,121,0,83,112,97,114,115,101,32,109,97,116,114,105,120,32,100,97,116,97,32,105,115,32,99,111,114,114,117,112,116,101,100,0,111,114,105,101,110,116,101,100,0,102,108,97,103,115,0,118,101,114,116,101,120,95,99,111,117,110,116,0,118,101,114,116,101,120,95,100,116,0,101,100,103,101,95,99,111,117,110,116,0,101,100,103,101,95,100,116,0,50,105,102,37,115,0,118,101,114,116,105,99,101,115,0,101,100,103,101,115,0,104,101,97,100,101,114,95,100,116,0,84,104,101,32,115,105,122,101,32,111,102,32,104,101,97,100,101,114,32,99,97,108,99,117,108,97,116,101,100,32,102,114,111,109,32,34,104,101,97,100,101,114,95,100,116,34,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,104,101,97,100,101,114,95,115,105,122,101,0,105,99,118,87,114,105,116,101,72,101,97,100,101,114,68,97,116,97,0,99,111,108,111,114,0,37,117,105,0,37,117,117,0,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,0,84,104,101,32,115,105,122,101,32,111,102,32,101,108,101,109,101,110,116,32,99,97,108,99,117,108,97,116,101,100,32,102,114,111,109,32,34,100,116,34,32,97,110,100,32,116,104,101,32,101,108,101,109,95,115,105,122,101,32,100,111,32,110,111,116,32,109,97,116,99,104,0,105,99,118,71,101,116,70,111,114,109,97,116,0,83,105,122,101,32,111,102,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,40,101,108,101,109,95,115,105,122,101,41,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,115,101,113,45,62,102,108,97,103,115,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,103,114,97,112,104,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,71,114,97,112,104,0,84,104,101,32,115,101,113,117,101,110,99,101,32,102,108,97,103,115,32,97,114,101,32,105,110,118,97,108,105,100,0,79,110,101,32,111,102,32,34,104,101,97,100,101,114,95,100,116,34,32,97,110,100,32,34,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,34,32,105,115,32,116,104,101,114,101,44,32,119,104,105,108,101,32,116,104,101,32,111,116,104,101,114,32,105,115,32,110,111,116,0,71,114,97,112,104,32,101,100,103,101,115,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,50,32,105,110,116,101,103,101,114,115,32,97,110,100,32,97,32,102,108,111,97,116,0,37,100,102,37,115,0,78,111,32,101,100,103,101,115,32,100,97,116,97,0,78,111,32,118,101,114,116,105,99,101,115,32,100,97,116,97,0,83,111,109,101,32,111,102,32,115,116,111,114,101,100,32,118,101,114,116,101,120,32,105,110,100,105,99,101,115,32,97,114,101,32,111,117,116,32,111,102,32,114,97,110,103,101,0,68,117,112,108,105,99,97,116,101,100,32,101,100,103,101,32,104,97,115,32,111,99,99,117,114,114,101,100,0,78,85,76,76,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,0,105,99,118,82,101,108,101,97,115,101,71,114,97,112,104,0,115,101,113,117,101,110,99,101,115,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,45,116,114,101,101,32,105,110,115,116,97,110,99,101,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,97,32,102,105,101,108,100,32,34,115,101,113,117,101,110,99,101,115,34,32,116,104,97,116,32,115,104,111,117,108,100,32,98,101,32,97,32,115,101,113,117,101,110,99,101,0,105,99,118,82,101,97,100,83,101,113,84,114,101,101,0,108,101,118,101,108,0,65,108,108,32,116,104,101,32,115,101,113,117,101,110,99,101,32,116,114,101,101,32,110,111,100,101,115,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,34,108,101,118,101,108,34,32,102,105,101,108,100,0,114,101,99,117,114,115,105,118,101,0,32,104,111,108,101,0,32,99,117,114,118,101,0,32,117,110,116,121,112,101,100,0,99,111,117,110,116,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,115,101,113,117,101,110,99,101,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,83,101,113,0,99,117,114,118,101,0,99,108,111,115,101,100,0,104,111,108,101,0,117,110,116,121,112,101,100,0,79,110,108,121,32,111,110,101,32,111,102,32,34,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,34,44,32,34,114,101,99,116,34,32,97,110,100,32,34,111,114,105,103,105,110,34,32,116,97,103,115,32,109,97,121,32,111,99,99,117,114,0,84,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,111,114,101,100,32,101,108,101,109,101,110,116,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,111,32,34,99,111,117,110,116,34,0,105,99,118,82,101,108,101,97,115,101,83,101,113,0,78,50,99,118,57,69,120,99,101,112,116,105,111,110,69,0,107,101,121,95,32,61,61,32,45,49,0,126,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,121,115,116,101,109,46,99,112,112,0,115,116,97,116,117,115,0,85,110,107,110,111,119,110,32,37,115,32,99,111,100,101,32,37,100,0,79,112,101,110,71,76,32,65,80,73,32,99,97,108,108,0,78,111,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,71,112,117,32,65,80,73,32,99,97,108,108,0,78,111,32,67,85,68,65,32,115,117,112,112,111,114,116,0,65,115,115,101,114,116,105,111,110,32,102,97,105,108,101,100,0,77,101,109,111,114,121,32,98,108,111,99,107,32,104,97,115,32,98,101,101,110,32,99,111,114,114,117,112,116,101,100,0,84,104,101,32,102,117,110,99,116,105,111,110,47,102,101,97,116,117,114,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,80,97,114,115,105,110,103,32,101,114,114,111,114,0,66,97,100,32,116,121,112,101,32,111,102,32,109,97,115,107,32,97,114,103,117,109,101,110,116,0,66,97,100,32,112,97,114,97,109,101,116,101,114,32,111,102,32,116,121,112,101,32,67,118,80,111,105,110,116,0,66,97,100,32,102,108,97,103],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+225280);allocate([32,40,112,97,114,97,109,101,116,101,114,32,111,114,32,115,116,114,117,99,116,117,114,101,32,102,105,101,108,100,41,0,66,97,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,73,110,112,117,116,32,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,32,111,114,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,102,111,114,109,97,116,115,0,79,110,101,32,111,102,32,97,114,103,117,109,101,110,116,115,39,32,118,97,108,117,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,83,105,122,101,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,70,111,114,109,97,116,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,73,110,112,117,116,32,105,109,97,103,101,32,100,101,112,116,104,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,102,117,110,99,116,105,111,110,0,82,101,113,117,101,115,116,101,100,32,111,98,106,101,99,116,32,119,97,115,32,110,111,116,32,102,111,117,110,100,0,73,110,112,108,97,99,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,109,97,103,101,32,115,116,101,112,32,105,115,32,119,114,111,110,103,0,68,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,111,99,99,117,114,114,101,100,0,78,117,108,108,32,112,111,105,110,116,101,114,0,73,110,99,111,114,114,101,99,116,32,115,105,122,101,32,111,102,32,105,110,112,117,116,32,97,114,114,97,121,0,65,117,116,111,116,114,97,99,101,32,99,97,108,108,0,73,116,101,114,97,116,105,111,110,115,32,100,111,32,110,111,116,32,99,111,110,118,101,114,103,101,0,66,97,100,32,97,114,103,117,109,101,110,116,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,85,110,115,112,101,99,105,102,105,101,100,32,101,114,114,111,114,0,66,97,99,107,116,114,97,99,101,0,78,111,32,69,114,114,111,114,0,117,110,107,110,111,119,110,32,102,117,110,99,116,105,111,110,0,79,112,101,110,67,86,40,37,115,41,32,69,114,114,111,114,58,32,37,115,32,40,37,115,41,32,105,110,32,37,115,44,32,102,105,108,101,32,37,115,44,32,108,105,110,101,32,37,100,0,51,46,52,46,52,45,100,101,118,0,37,115,10,0,62,32,0,79,112,101,110,67,86,40,37,115,41,32,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,58,37,115,41,32,105,110,32,102,117,110,99,116,105,111,110,32,39,37,115,39,10,37,115,0,79,112,101,110,67,86,40,37,115,41,32,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,58,37,115,41,32,37,115,32,105,110,32,102,117,110,99,116,105,111,110,32,39,37,115,39,10,0,79,112,101,110,67,86,40,37,115,41,32,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,58,37,115,41,32,37,115,37,115,0,108,101,110,32,62,61,32,48,32,38,38,32,34,67,104,101,99,107,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,102,111,114,32,101,114,114,111,114,115,34,0,102,111,114,109,97,116,0,78,50,99,118,49,54,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,69,0,79,80,69,78,67,86,95,68,85,77,80,95,69,82,82,79,82,83,0,79,80,69,78,67,86,95,68,85,77,80,95,67,79,78,70,73,71,0,10,71,101,110,101,114,97,108,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,102,111,114,32,79,112,101,110,67,86,32,51,46,52,46,52,45,100,101,118,32,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,32,32,86,101,114,115,105,111,110,32,99,111,110,116,114,111,108,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,51,46,52,46,52,45,50,50,45,103,54,98,51,52,54,99,57,10,10,32,32,80,108,97,116,102,111,114,109,58,10,32,32,32,32,84,105,109,101,115,116,97,109,112,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,50,48,49,56,45,49,49,45,50,50,84,48,53,58,52,51,58,53,52,90,10,32,32,32,32,72,111,115,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,76,105,110,117,120,32,52,46,49,53,46,48,45,51,57,45,103,101,110,101,114,105,99,32,120,56,54,95,54,52,10,32,32,32,32,84,97,114,103,101,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,69,109,115,99,114,105,112,116,101,110,32,49,32,120,56,54,10,32,32,32,32,67,77,97,107,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,51,46,53,46,49,10,32,32,32,32,67,77,97,107,101,32,103,101,110,101,114,97,116,111,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,85,110,105,120,32,77,97,107,101,102,105,108,101,115,10,32,32,32,32,67,77,97,107,101,32,98,117,105,108,100,32,116,111,111,108,58,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,109,97,107,101,10,32,32,32,32,67,111,110,102,105,103,117,114,97,116,105,111,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,82,101,108,101,97,115,101,10,10,32,32,67,80,85,47,72,87,32,102,101,97,116,117,114,101,115,58,10,32,32,32,32,66,97,115,101,108,105,110,101,58,10,10,32,32,67,47,67,43,43,58,10,32,32,32,32,66,117,105,108,116,32,97,115,32,100,121,110,97,109,105,99,32,108,105,98,115,63,58,32,32,32,32,32,32,78,79,10,32,32,32,32,67,43,43,32,67,111,109,112,105,108,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,111,112,116,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,49,46,51,55,46,50,49,47,101,109,43,43,32,32,40,118,101,114,32,52,46,48,46,48,41,10,32,32,32,32,67,43,43,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,68,78,68,69,66,85,71,32,45,79,50,32,32,45,68,78,68,69,66,85,71,10,32,32,32,32,67,43,43,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,103,32,32,45,79,48,32,45,68,68,69,66,85,71,32,45,68,95,68,69,66,85,71,10,32,32,32,32,67,32,67,111,109,112,105,108,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,111,112,116,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,49,46,51,55,46,50,49,47,101,109,99,99,10,32,32,32,32,67,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,68,78,68,69,66,85,71,32,45,79,50,32,32,45,68,78,68,69,66,85,71,10,32,32,32,32,67,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,103,32,32,45,79,48,32,45,68,68,69,66,85,71,32,45,68,95,68,69,66,85,71,10,32,32,32,32,76,105,110,107,101,114,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,45,79,50,32,10,32,32,32,32,76,105,110,107,101,114,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,10,32,32,32,32,99,99,97,99,104,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,80,114,101,99,111,109,112,105,108,101,100,32,104,101,97,100,101,114,115,58,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,69,120,116,114,97,32,100,101,112,101,110,100,101,110,99,105,101,115,58,10,32,32,32,32,51,114,100,112,97,114,116,121,32,100,101,112,101,110,100,101,110,99,105,101,115,58,32,32,32,32,32,32,32,113,117,105,114,99,32,108,105,98,112,114,111,116,111,98,117,102,32,122,108,105,98,10,10,32,32,79,112,101,110,67,86,32,109,111,100,117,108,101,115,58,10,32,32,32,32,84,111,32,98,101,32,98,117,105,108,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,97,108,105,98,51,100,32,99,111,114,101,32,100,110,110,32,102,101,97,116,117,114,101,115,50,100,32,105,109,103,112,114,111,99,32,106,97,118,97,95,98,105,110,100,105,110,103,115,95,103,101,110,101,114,97,116,111,114,32,106,115,32,111,98,106,100,101,116,101,99,116,32,112,121,116,104,111,110,95,98,105,110,100,105,110,103,115,95,103,101,110,101,114,97,116,111,114,32,118,105,100,101,111,10,32,32,32,32,68,105,115,97,98,108,101,100,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,102,108,97,110,110,32,104,105,103,104,103,117,105,32,105,109,103,99,111,100,101,99,115,32,109,108,32,112,104,111,116,111,32,115,104,97,112,101,32,115,116,105,116,99,104,105,110,103,32,115,117,112,101,114,114,101,115,32,118,105,100,101,111,105,111,32,118,105,100,101,111,115,116,97,98,32,119,111,114,108,100,10,32,32,32,32,68,105,115,97,98,108,101,100,32,98,121,32,100,101,112,101,110,100,101,110,99,121,58,32,32,32,32,32,32,45,10,32,32,32,32,85,110,97,118,97,105,108,97,98,108,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,117,100,97,97,114,105,116,104,109,32,99,117,100,97,98,103,115,101,103,109,32,99,117,100,97,99,111,100,101,99,32,99,117,100,97,102,101,97,116,117,114,101,115,50,100,32,99,117,100,97,102,105,108,116,101,114,115,32,99,117,100,97,105,109,103,112,114,111,99,32,99,117,100,97,108,101,103,97,99,121,32,99,117,100,97,111,98,106,100,101,116,101,99,116,32,99,117,100,97,111,112,116,102,108,111,119,32,99,117,100,97,115,116,101,114,101,111,32,99,117,100,97,119,97,114,112,105,110,103,32,99,117,100,101,118,32,106,97,118,97,32,112,121,116,104,111,110,50,32,112,121,116,104,111,110,51,32,116,115,32,118,105,122,10,32,32,32,32,65,112,112,108,105,99,97,116,105,111,110,115,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,45,10,32,32,32,32,68,111,99,117,109,101,110,116,97,116,105,111,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,106,115,10,32,32,32,32,78,111,110,45,102,114,101,101,32,97,108,103,111,114,105,116,104,109,115,58,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,71,85,73,58,32,10,10,32,32,77,101,100,105,97,32,73,47,79,58,32,10,32,32,32,32,90,76,105,98,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,98,117,105,108,100,32,40,118,101,114,32,49,46,50,46,49,49,41,10,32,32,32,32,72,68,82,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,89,69,83,10,32,32,32,32,83,85,78,82,65,83,84,69,82,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,89,69,83,10,32,32,32,32,80,88,77,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,89,69,83,10,10,32,32,86,105,100,101,111,32,73,47,79,58,10,10,32,32,80,97,114,97,108,108,101,108,32,102,114,97,109,101,119,111,114,107,58,32,32,32,32,32,32,32,32,32,32,32,32,110,111,110,101,10,10,32,32,79,116,104,101,114,32,116,104,105,114,100,45,112,97,114,116,121,32,108,105,98,114,97,114,105,101,115,58,10,32,32,32,32,67,117,115,116,111,109,32,72,65,76,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,80,114,111,116,111,98,117,102,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,98,117,105,108,100,32,40,51,46,53,46,49,41,10,10,32,32,80,121,116,104,111,110,32,40,102,111,114,32,98,117,105,108,100,41,58,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,112,121,116,104,111,110,50,46,55,10,10,32,32,73,110,115,116,97,108,108,32,116,111,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,98,117,105,108,100,47,106,115,47,105,110,115,116,97,108,108,10,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,10,0,10,79,112,101,110,67,86,32,98,117,105,108,100,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,105,115,58,10,37,115,10,0,77,77,88,0,83,83,69,0,83,83,69,50,0,83,83,69,51,0,83,83,83,69,51,0,83,83,69,52,46,49,0,83,83,69,52,46,50,0,80,79,80,67,78,84,0,70,80,49,54,0,65,86,88,0,65,86,88,50,0,70,77,65,51,0,65,86,88,53,49,50,70,0,65,86,88,53,49,50,66,87,0,65,86,88,53,49,50,67,68,0,65,86,88,53,49,50,68,81,0,65,86,88,53,49,50,69,82,0,65,86,88,53,49,50,73,70,77,65,0,65,86,88,53,49,50,80,70,0,65,86,88,53,49,50,86,66,77,73,0,65,86,88,53,49,50,86,76,0,78,69,79,78,0,86,83,88,0,86,83,88,51,0,65,86,88,53,49,50,45,83,75,88,0,79,80,69,78,67,86,95,67,80,85,95,68,73,83,65,66,76,69,0,102,101,97,116,117,114,101,46,115,105,122,101,40,41,32,62,32,48,0,114,101,97,100,83,101,116,116,105,110,103,115,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,98,97,115,101,108,105,110,101,32,67,80,85,32,102,101,97,116,117,114,101,58,32,39,37,115,39,46,32,84,104,105,115,32,104,97,115,32,118,101,114,121,32,108,105,109,105,116,101,100,32,101,102,102,101,99,116,44,32,98,101,99,97,117,115,101,32,99,111,100,101,32,111,112,116,105,109,105,122,97,116,105,111,110,115,32,102,111,114,32,116,104,105,115,32,102,101,97,116,117,114,101,32,97,114,101,32,101,120,101,99,117,116,101,100,32,117,110,99,111,110,100,105,116,105,111,110,97,108,108,121,32,105,110,32,116,104,101,32,109,111,115,116,32,99,97,115,101,115,46,10,0,85,110,107,110,111,119,110,32,102,101,97,116,117,114,101,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,117,110,97,118,97,105,108,97,98,108,101,32,67,80,85,32,102,101,97,116,117,114,101,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,58,32,39,37,115,39,46,10,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,117,110,107,110,111,119,110,32,67,80,85,32,102,101,97,116,117,114,101,58,32,39,37,115,39,46,10,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,112,97,114,97,109,101,116,101,114,32,0,78,50,99,118,49,48,80,97,114,115,101,69,114,114,111,114,69,0,49,0,84,82,85,69,0,70,65,76,83,69,0,107,101,121,95,32,33,61,32,45,49,32,38,38,32,34,67,97,110,39,116,32,102,101,116,99,104,32,100,97,116,97,32,102,114,111,109,32,116,101,114,109,105,110,97,116,101,100,32,84,76,83,32,99,111,110,116,97,105,110,101,114,46,34,0,103,101,116,68,97,116,97,0,116,108,115,83,108,111,116,115,83,105,122,101,32,62,32,115,108,111,116,73,100,120,0,115,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,115,101,116,115,112,101,99,105,102,105,99,40,116,108,115,75,101,121,44,32,112,68,97,116,97,41,32,61,61,32,48,0,83,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,107,101,121,95,99,114,101,97,116,101,40,38,116,108,115,75,101,121,44,32,78,85,76,76,41,32,61,61,32,48,0,84,108,115,65,98,115,116,114,97,99,116,105,111,110,0,116,108,115,83,108,111,116,115,83,105,122,101,32,61,61,32,116,108,115,83,108,111,116,115,46,115,105,122,101,40,41,0,114,101,108,101,97,115,101,83,108,111,116,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,49,67,111,114,101,84,76,83,68,97,116,97,69,69,69,0,114,101,115,101,114,118,101,83,108,111,116,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,50,95,71,76,79,66,65,76,95,95,78,95,49,56,84,104,114,101,97,100,73,68,69,69,69,0,77,66,0,77,98,0,109,98,0,75,66,0,75,98,0,107,98,0,99,110,32,60,61,32,52,32,38,38,32,102,117,110,99,32,33,61,32,48,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,117,109,46,99,112,112,0,105,99,118,73,110,105,116,77,101,109,83,116,111,114,97,103,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,97,116,97,115,116,114,117,99,116,115,46,99,112,112,0,99,118,67,114,101,97,116,101,67,104,105,108,100,77,101,109,83,116,111,114,97,103,101,0,99,118,82,101,108,101,97,115,101,77,101,109,83,116,111,114,97,103,101,0,99,118,67,108,101,97,114,77,101,109,83,116,111,114,97,103,101,0,99,118,83,97,118,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,82,101,115,116,111,114,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,77,101,109,83,116,111,114,97,103,101,65,108,108,111,99,0,84,111,111,32,108,97,114,103,101,32,109,101,109,111,114,121,32,98,108,111,99,107,32,105,115,32,114,101,113,117,101,115,116,101,100,0,114,101,113,117,101,115,116,101,100,32,115,105,122,101,32,105,115,32,110,101,103,97,116,105,118,101,32,111,114,32,116,111,111,32,98,105,103,0,105,99,118,71,111,78,101,120,116,77,101,109,66,108,111,99,107,0,99,118,67,114,101,97,116,101,83,101,113,0,83,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,101,116,83,101,113,66,108,111,99,107,83,105,122,101,0,83,116,111,114,97,103,101,32,98,108,111,99,107,32,115,105,122,101,32,105,115,32,116,111,111,32,115,109,97,108,108,32,116,111,32,102,105,116,32,116,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,0,0,1,255,2,255,255,255,3,255,255,255,255,255,255,255,4,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,5,99,118,67,118,116,83,101,113,84,111,65,114,114,97,121,0,99,118,83,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,116,97,114,116,82,101,97,100,83,101,113,0,99,118,77,97,107,101,83,101,113,72,101,97,100,101,114,70,111,114,65,114,114,97,121,0,69,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,112,114,101,100,101,102,105,110,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,116,97,114,116,65,112,112,101,110,100,84,111,83,101,113,0,99,118,83,116,97,114,116,87,114,105,116,101,83,101,113,0,99,118,70,108,117,115,104,83,101,113,87,114,105,116,101,114,0,99,118,69,110,100,87,114,105,116,101,83,101,113,0,99,118,67,114,101,97,116,101,83,101,113,66,108,111,99,107,0,105,99,118,71,114,111,119,83,101,113,0,84,104,101,32,115,101,113,117,101,110,99,101,32,104,97,115,32,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,99,118,67,104,97,110,103,101,83,101,113,66,108,111,99,107,0,99,118,71,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,101,113,80,117,115,104,0,99,118,83,101,113,80,111,112,0,78,85,76,76,32,115,101,113,117,101,110,99,101,32,112,111,105,110,116,101,114,0,99,118,83,101,113,80,117,115,104,77,117,108,116,105,0,110,117,109,98,101,114,32,111,102,32,114,101,109,111,118,101,100,32,101,108,101,109,101,110,116,115,32,105,115,32,110,101,103,97,116,105,118,101,0,99,118,83,101,113,80,111,112,77,117,108,116,105,0,99,118,67,108,101,97,114,83,101,113,0,73,110,118,97,108,105,100,32,115,101,113,117,101,110,99,101,32,104,101,97,100,101,114,0,99,118,83,101,113,83,108,105,99,101,0,66,97,100,32,115,101,113,117,101,110,99,101,32,115,108,105,99,101,0,66,97,100,32,105,110,112,117,116,32,115,101,113,117,101,110,99,101,0,99,118,83,101,113,83,111,114,116,0,78,117,108,108,32,99,111,109,112,97,114,101,32,102,117,110,99,116,105,111,110,0,99,118,67,114,101,97,116,101,83,101,116,0,99,118,83,101,116,65,100,100,0,99,118,67,114,101,97,116,101,71,114,97,112,104,0,99,118,71,114,97,112,104,65,100,100,86,116,120,0,99,118,70,105,110,100,71,114,97,112,104,69,100,103,101,66,121,80,116,114,0,103,114,97,112,104,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,71,114,97,112,104,65,100,100,69,100,103,101,66,121,80,116,114,0,118,101,114,116,101,120,32,112,111,105,110,116,101,114,115,32,99,111,105,110,99,105,100,101,32,40,111,114,32,115,101,116,32,116,111,32,78,85,76,76,41,0,73,110,118,97,108,105,100,32,103,114,97,112,104,32,112,111,105,110,116,101,114,0,99,118,67,108,111,110,101,71,114,97,112,104,0,99,118,84,114,101,101,84,111,78,111,100,101,83,101,113,0,99,118,73,110,105,116,84,114,101,101,78,111,100,101,73,116,101,114,97,116,111,114,0,78,85,76,76,32,105,116,101,114,97,116,111,114,32,112,111,105,110,116,101,114,0,99,118,78,101,120,116,84,114,101,101,78,111,100,101,0,99,118,73,110,115,101,114,116,78,111,100,101,73,110,116,111,84,114,101,101,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,67,85,68,65,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,99,117,100,97,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,114,105,118,97,116,101,46,99,117,100,97,46,104,112,112,0,60,63,120,109,108,0,105,99,118,88,77,76,80,97,114,115,101,0,86,97,108,105,100,32,88,77,76,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,63,120,109,108,32,46,46,46,63,62,39,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,120,109,108,46,99,112,112,0,111,112,101,110,99,118,95,115,116,111,114,97,103,101,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,102,115,45,62,100,117,109,109,121,95,101,111,102,32,33,61,32,48,0,105,99,118,88,77,76,80,97,114,115,101,86,97,108,117,101,0,68,105,114,101,99,116,105,118,101,32,116,97,103,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,69,109,112,116,121,32,116,97,103,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,116,97,103,95,116,121,112,101,32,61,61,32,67,86,95,88,77,76,95,79,80,69,78,73,78,71,95,84,65,71,0,77,97,112,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,104,97,118,101,32,97,32,110,97,109,101,0,105,99,118,88,77,76,71,101,116,77,117,108,116,105,108,105,110,101,83,116,114,105,110,103,67,111,110,116,101,110,116,0,105,99,118,88,77,76,80,97,114,115,101,66,97,115,101,54,52,0,100,97,116,97,32,115,105,122,101,32,110,111,116,32,109,97,116,99,104,101,115,32,101,108,101,109,101,109,116,32,115,105,122,101,0,77,105,115,109,97,116,99,104,101,100,32,99,108,111,115,105,110,103,32,116,97,103,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,108,105,116,101,114,97,108,115,0,76,105,116,101,114,97,108,32,34,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,119,105,116,104,105,110,32,97,32,115,116,114,105,110,103,46,32,85,115,101,32,38,113,117,111,116,59,0,67,108,111,115,105,110,103,32,34,32,105,115,32,101,120,112,101,99,116,101,100,0,76,105,116,101,114,97,108,32,39,32,111,114,32,62,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,46,32,85,115,101,32,38,97,112,111,115,59,32,111,114,32,38,103,116,59,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,105,110,32,116,104,101,32,115,116,114,105,110,103,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,121,109,98,111,108,32,101,110,116,105,116,121,32,110,97,109,101,0,108,116,0,103,116,0,97,109,112,0,97,112,111,115,0,113,117,111,116,0,84,104,101,32,97,99,116,117,97,108,32,116,121,112,101,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,116,121,112,101,0,105,99,118,88,77,76,80,97,114,115,101,84,97,103,0,80,114,101,108,105,109,105,110,97,114,121,32,101,110,100,32,111,102,32,116,104,101,32,115,116,114,101,97,109,0,84,97,103,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,39,0,85,110,107,110,111,119,110,32,116,97,103,32,116,121,112,101,0,78,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,117,110,100,101,114,115,99,111,114,101,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,99,111,110,116,97,105,110,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,65,116,116,114,105,98,117,116,101,32,110,97,109,101,32,115,104,111,117,108,100,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,39,61,39,0,65,116,116,114,105,98,117,116,101,32,118,97,108,117,101,32,115,104,111,117,108,100,32,98,101,32,112,117,116,32,105,110,116,111,32,115,105,110,103,108,101,32,111,114,32,100,111,117,98,108,101,32,113,117,111,116,101,115,0,73,110,118,97,108,105,100,32,99,108,111,115,105,110,103,32,116,97,103,32,102,111,114,32,60,63,120,109,108,32,46,46,46,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,97,116,116,114,105,98,117,116,101,115,0,105,99,118,88,77,76,83,107,105,112,83,112,97,99,101,115,0,67,111,109,109,101,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,58,32,67,86,95,78,79,68,69,95,83,69,81,32,111,114,32,67,86,95,78,79,68,69,95,77,65,80,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,105,99,118,88,77,76,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,88,77,76,87,114,105,116,101,84,97,103,0,65,32,115,105,110,103,108,101,32,95,32,105,115,32,97,32,114,101,115,101,114,118,101,100,32,116,97,103,32,110,97,109,101,0,95,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,105,110,99,108,117,100,101,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,75,101,121,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,32,97,110,100,32,39,95,39,0,65,110,32,101,120,116,114,97,32,99,108,111,115,105,110,103,32,116,97,103,0,105,99,118,88,77,76,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,10,60,33,45,45,32,110,101,120,116,32,115,116,114,101,97,109,32,45,45,62,10,0,67,117,114,114,101,110,116,108,121,32,111,110,108,121,32,66,97,115,101,54,52,32,100,97,116,97,32,105,115,32,97,108,108,111,119,101,100,46,0,105,99,118,88,77,76,87,114,105,116,101,83,99,97,108,97,114,0,101,108,101,109,101,110,116,115,32,119,105,116,104,32,107,101,121,115,32,99,97,110,32,110,111,116,32,98,101,32,119,114,105,116,116,101,110,32,116,111,32,115,101,113,117,101,110,99,101,0,105,99,118,88,77,76,87,114,105,116,101,83,116,114,105,110,103,0,35,120,37,48,50,120,0,105,99,118,88,77,76,87,114,105,116,101,67,111,109,109,101,110,116,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,39,45,45,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,116,104,101,32,99,111,109,109,101,110,116,115,0,60,33,45,45,0,60,33,45,45,32,37,115,32,45,45,62,0,105,99,118,74,83,79,78,80,97,114,115,101,0,108,101,102,116,45,98,114,97,99,101,32,111,102,32,116,111,112,32,108,101,118,101,108,32,105,115,32,109,105,115,115,105,110,103,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,106,115,111,110,46,99,112,112,0,85,110,101,120,112,101,99,116,101,100,32,69,110,100,45,79,102,45,70,105,108,101,0,105,99,118,74,83,79,78,80,97,114,115,101,83,101,113,0,112,116,114,32,105,115,32,78,85,76,76,0,39,91,39,32,45,32,108,101,102,116,45,98,114,97,99,101,32,111,102,32,115,101,113,32,105,115,32,109,105,115,115,105,110,103,0,85,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,39,93,39,32,45,32,114,105,103,104,116,45,98,114,97,99,101,32,111,102,32,115,101,113,32,105,115,32,109,105,115,115,105,110,103,0,105,99,118,74,83,79,78,80,97,114,115,101,86,97,108,117,101,0,36,98,97,115,101,54,52,36,0,39,34,39,32,45,32,114,105,103,104,116,45,113,117,111,116,101,32,111,102,32,115,116,114,105,110,103,32,105,115,32,109,105,115,115,105,110,103,0,39,92,117,88,88,88,88,39,32,99,117,114,114,101,110,116,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,0,110,117,108,108,0,86,97,108,117,101,32,39,110,117,108,108,39,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,118,97,108,117,101,0,105,99,118,74,83,79,78,80,97,114,115,101,77,97,112,0,39,123,39,32,45,32,108,101,102,116,45,98,114,97,99,101,32,111],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+235520);allocate([102,32,109,97,112,32,105,115,32,109,105,115,115,105,110,103,0,105,99,118,74,83,79,78,80,97,114,115,101,75,101,121,0,75,101,121,32,109,117,115,116,32,101,110,100,32,119,105,116,104,32,39,34,39,0,77,105,115,115,105,110,103,32,39,58,39,32,98,101,116,119,101,101,110,32,107,101,121,32,97,110,100,32,118,97,108,117,101,0,75,101,121,32,105,115,32,101,109,112,116,121,0,116,121,112,101,95,105,100,0,34,116,121,112,101,95,105,100,34,32,115,104,111,117,108,100,32,98,101,32,111,102,32,116,121,112,101,32,115,116,114,105,110,103,0,39,125,39,32,45,32,114,105,103,104,116,45,98,114,97,99,101,32,111,102,32,109,97,112,32,105,115,32,109,105,115,115,105,110,103,0,105,99,118,74,83,79,78,83,107,105,112,83,112,97,99,101,115,0,78,111,116,32,115,117,112,112,111,114,116,101,100,32,101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,116,114,101,97,109,0,105,99,118,74,83,79,78,87,114,105,116,101,0,105,99,118,74,83,79,78,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,74,83,79,78,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,74,83,79,78,87,114,105,116,101,83,116,114,105,110,103,0,105,99,118,74,83,79,78,87,114,105,116,101,67,111,109,109,101,110,116,0,78,50,99,118,49,54,80,97,114,97,108,108,101,108,76,111,111,112,66,111,100,121,69,0,84,104,101,32,115,116,111,114,97,103,101,32,105,115,32,110,111,116,32,111,112,101,110,101,100,0,105,99,118,80,117,116,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,46,99,112,112,0,106,32,60,32,109,97,120,67,111,117,110,116,32,45,32,49,32,38,38,32,34,79,112,101,110,67,86,32,112,101,114,115,105,115,116,101,110,99,101,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,118,101,114,121,32,108,111,110,103,32,108,105,110,101,115,34,0,105,99,118,71,101,116,115,0,115,122,32,60,32,40,115,105,122,101,95,116,41,40,109,97,120,67,111,117,110,116,32,45,32,49,41,32,38,38,32,34,79,112,101,110,67,86,32,112,101,114,115,105,115,116,101,110,99,101,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,118,101,114,121,32,108,111,110,103,32,108,105,110,101,115,34,0,84,111,111,32,115,109,97,108,108,32,109,97,112,32,104,101,97,100,101,114,95,115,105,122,101,0,99,118,67,114,101,97,116,101,77,97,112,0,37,115,40,37,100,41,58,32,37,115,0,105,99,118,70,83,67,114,101,97,116,101,67,111,108,108,101,99,116,105,111,110,0,83,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,110,111,116,32,104,97,118,101,32,110,97,109,101,32,40,117,115,101,32,60,95,62,60,47,95,62,41,0,78,85,76,76,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,32,116,111,32,102,105,108,101,32,115,116,111,114,97,103,101,0,105,99,118,67,108,111,115,101,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,37,100,46,0,37,46,49,54,101,0,46,78,97,110,0,45,46,73,110,102,0,46,73,110,102,0,37,46,56,101,0,105,99,118,80,114,111,99,101,115,115,83,112,101,99,105,97,108,68,111,117,98,108,101,0,66,97,100,32,102,111,114,109,97,116,32,111,102,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,99,111,110,115,116,97,110,116,0,85,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,44,32,117,110,97,98,108,101,32,116,111,32,100,101,116,101,114,109,105,110,101,32,116,104,101,32,66,97,115,101,54,52,32,115,116,97,116,101,46,0,115,119,105,116,99,104,95,116,111,95,66,97,115,101,54,52,95,115,116,97,116,101,0,85,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,44,32,117,110,97,98,108,101,32,116,111,32,115,119,105,116,99,104,32,116,111,32,116,104,105,115,32,115,116,97,116,101,46,0,102,115,45,62,105,115,95,119,114,105,116,101,95,115,116,114,117,99,116,95,100,101,108,97,121,101,100,32,61,61,32,102,97,108,115,101,0,109,97,107,101,95,119,114,105,116,101,95,115,116,114,117,99,116,95,100,101,108,97,121,101,100,0,100,101,112,116,104,32,62,61,48,32,38,38,32,100,101,112,116,104,32,60,32,57,0,105,99,118,84,121,112,101,83,121,109,98,111,108,0,117,99,119,115,105,102,100,114,0,37,100,37,99,0,73,110,118,97,108,105,100,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,105,99,118,68,101,99,111,100,101,70,111,114,109,97,116,0,105,99,118,83,121,109,98,111,108,84,111,84,121,112,101,0,84,111,111,32,108,111,110,103,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,84,111,111,32,99,111,109,112,108,101,120,32,102,111,114,109,97,116,32,102,111,114,32,116,104,101,32,109,97,116,114,105,120,0,105,99,118,68,101,99,111,100,101,83,105,109,112,108,101,70,111,114,109,97,116,0,45,45,45,0,37,89,65,77,76,0,37,89,65,77,76,58,49,46,0,37,89,65,77,76,32,49,46,0,105,99,118,89,77,76,80,97,114,115,101,0,85,110,115,117,112,112,111,114,116,101,100,32,89,65,77,76,32,118,101,114,115,105,111,110,32,40,105,116,32,109,117,115,116,32,98,101,32,49,46,120,41,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,121,109,108,46,99,112,112,0,84,104,101,32,89,65,77,76,32,115,116,114,101,97,109,115,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,45,45,39,44,32,101,120,99,101,112,116,32,116,104,101,32,102,105,114,115,116,32,111,110,101,0,73,110,118,97,108,105,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,115,121,110,116,97,120,0,79,110,108,121,32,99,111,108,108,101,99,116,105,111,110,115,32,97,115,32,89,65,77,76,32,115,116,114,101,97,109,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,60,116,97,103,58,121,97,109,108,46,111,114,103,44,50,48,48,50,58,0,105,99,118,89,77,76,80,97,114,115,101,86,97,108,117,101,0,69,109,112,116,121,32,116,121,112,101,32,110,97,109,101,0,115,116,114,0,115,101,113,0,109,97,112,0,98,105,110,97,114,121,0,105,99,118,89,77,76,71,101,116,77,117,108,116,105,108,105,110,101,83,116,114,105,110,103,67,111,110,116,101,110,116,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,108,105,110,101,0,105,99,118,89,77,76,80,97,114,115,101,66,97,115,101,54,52,0,85,110,114,101,99,111,103,110,105,122,101,100,32,66,97,115,101,54,52,32,104,101,97,100,101,114,0,73,110,118,97,108,105,100,32,96,100,116,96,32,105,110,32,66,97,115,101,54,52,32,104,101,97,100,101,114,0,73,110,118,97,108,105,100,32,66,97,115,101,54,52,32,100,97,116,97,46,0,66,121,116,101,32,115,105,122,101,32,110,111,116,32,109,97,116,99,104,32,101,108,101,109,101,109,116,32,115,105,122,101,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,40,105,110,99,111,110,115,105,115,116,101,110,116,32,101,120,112,108,105,99,105,116,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,63,41,0,40,112,116,114,91,48,93,32,33,61,32,48,32,124,124,32,112,116,114,32,33,61,32,102,115,45,62,98,117,102,102,101,114,95,101,110,100,32,45,32,49,41,32,38,38,32,34,79,112,101,110,67,86,32,112,101,114,115,105,115,116,101,110,99,101,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,118,101,114,121,32,108,111,110,103,32,108,105,110,101,115,34,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,84,104,101,32,119,114,111,110,103,32,99,108,111,115,105,110,103,32,98,114,97,99,107,101,116,0,77,105,115,115,105,110,103,32,44,32,98,101,116,119,101,101,110,32,116,104,101,32,101,108,101,109,101,110,116,115,0,67,111,109,112,108,101,120,32,107,101,121,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,77,117,108,116,105,45,108,105,110,101,32,116,101,120,116,32,108,105,116,101,114,97,108,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,66,108,111,99,107,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,32,109,117,115,116,32,98,101,32,112,114,101,99,101,100,101,100,32,119,105,116,104,32,39,45,39,0,73,110,99,111,114,114,101,99,116,32,105,110,100,101,110,116,97,116,105,111,110,0,105,99,118,89,77,76,80,97,114,115,101,75,101,121,0,75,101,121,32,109,97,121,32,110,111,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,39,0,77,105,115,115,105,110,103,32,39,58,39,0,65,110,32,101,109,112,116,121,32,107,101,121,0,105,99,118,89,77,76,83,107,105,112,83,112,97,99,101,115,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,111,114,32,97,32,108,97,115,116,32,115,116,114,105,110,103,32,119,47,111,32,110,101,119,108,105,110,101,0,84,97,98,115,32,97,114,101,32,112,114,111,104,105,98,105,116,101,100,32,105,110,32,89,65,77,76,33,0,65,116,32,112,114,101,115,101,110,116,44,32,111,117,116,112,117,116,32,66,97,115,101,54,52,32,100,97,116,97,32,111,110,108,121,46,0,105,99,118,89,77,76,87,114,105,116,101,0,65,110,32,97,116,116,101,109,112,116,32,116,111,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,111,117,116,32,97,32,107,101,121,32,116,111,32,97,32,109,97,112,44,32,111,114,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,32,107,101,121,32,116,111,32,115,101,113,117,101,110,99,101,0,84,104,101,32,107,101,121,32,105,115,32,97,110,32,101,109,112,116,121,0,84,104,101,32,107,101,121,32,105,115,32,116,111,111,32,108,111,110,103,0,75,101,121,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,115,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,44,32,39,95,39,32,97,110,100,32,39,32,39,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,32,45,32,67,86,95,78,79,68,69,95,83,69,81,32,111,114,32,67,86,95,78,79,68,69,95,77,65,80,44,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,105,99,118,89,77,76,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,33,33,98,105,110,97,114,121,32,124,0,33,33,37,115,32,37,99,0,33,33,37,115,0,69,110,100,87,114,105,116,101,83,116,114,117,99,116,32,119,47,111,32,109,97,116,99,104,105,110,103,32,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,89,77,76,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,46,46,46,10,0,45,45,45,10,0,78,117,108,108,32,115,116,114,105,110,103,32,112,111,105,110,116,101,114,0,105,99,118,89,77,76,87,114,105,116,101,83,116,114,105,110,103,0,84,104,101,32,119,114,105,116,116,101,110,32,115,116,114,105,110,103,32,105,115,32,116,111,111,32,108,111,110,103,0,120,37,48,50,120,0,78,117,108,108,32,99,111,109,109,101,110,116,0,105,99,118,89,77,76,87,114,105,116,101,67,111,109,109,101,110,116,0,78,50,99,118,57,70,111,114,109,97,116,116,101,100,69,0,78,50,99,118,57,70,111,114,109,97,116,116,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,67,70,111,114,109,97,116,116,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,0,0,44,0,0,123,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,51,70,111,114,109,97,116,116,101,100,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,109,46,100,105,109,115,32,60,61,32,50,0,70,111,114,109,97,116,116,101,100,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,117,116,46,99,112,112,0,37,37,46,37,100,103,0,37,51,100,0,10,40,58,44,32,58,44,32,37,100,41,32,61,32,10,0,40,58,44,32,58,44,32,37,100,41,32,61,32,10,0,78,50,99,118,49,51,70,111,114,109,97,116,116,101,100,73,109,112,108,69,0,78,50,99,118,49,48,67,70,111,114,109,97,116,116,101,114,69,0,78,50,99,118,49,51,70,111,114,109,97,116,116,101,114,66,97,115,101,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,78,117,109,112,121,70,111,114,109,97,116,116,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,91,93,44,91,93,93,44,32,100,116,121,112,101,61,39,37,115,39,41,0,97,114,114,97,121,40,91,0,117,105,110,116,56,0,105,110,116,56,0,117,105,110,116,49,54,0,105,110,116,49,54,0,102,108,111,97,116,51,50,0,102,108,111,97,116,54,52,0,78,50,99,118,49,52,78,117,109,112,121,70,111,114,109,97,116,116,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,53,80,121,116,104,111,110,70,111,114,109,97,116,116,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,53,80,121,116,104,111,110,70,111,114,109,97,116,116,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,83,86,70,111,114,109,97,116,116,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,50,67,83,86,70,111,114,109,97,116,116,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,53,77,97,116,108,97,98,70,111,114,109,97,116,116,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,0,0,59,0,0,78,50,99,118,49,53,77,97,116,108,97,98,70,111,114,109,97,116,116,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,68,101,102,97,117,108,116,70,111,114,109,97,116,116,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,54,68,101,102,97,117,108,116,70,111,114,109,97,116,116,101,114,69,0,116,104,101,32,116,121,112,101,32,111,102,32,108,97,98,101,108,115,32,109,117,115,116,32,98,101,32,49,54,117,32,111,114,32,51,50,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,46,99,112,112,0,76,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,73,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,95,115,117,98,49,0,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,71,82,65,78,65,32,124,124,32,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,87,85,32,124,124,32,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,68,69,70,65,85,76,84,0,105,68,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,105,68,101,112,116,104,32,61,61,32,67,86,95,56,83,0,117,110,115,117,112,112,111,114,116,101,100,32,108,97,98,101,108,47,105,109,97,103,101,32,116,121,112,101,0,105,109,103,46,114,111,119,115,32,61,61,32,105,109,103,76,97,98,101,108,115,46,114,111,119,115,0,105,109,103,46,99,111,108,115,32,61,61,32,105,109,103,76,97,98,101,108,115,46,99,111,108,115,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,57,70,105,114,115,116,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,52,67,111,110,110,101,99,116,105,118,105,116,121,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,56,67,111,110,110,101,99,116,105,118,105,116,121,69,0,105,109,103,76,97,98,101,108,115,46,114,111,119,115,32,61,61,32,105,109,103,46,114,111,119,115,0,105,109,103,76,97,98,101,108,115,46,99,111,108,115,32,61,61,32,105,109,103,46,99,111,108,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,87,105,116,104,83,116,97,116,115,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,57,70,105,114,115,116,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,52,67,111,110,110,101,99,116,105,118,105,116,121,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,56,67,111,110,110,101,99,116,105,118,105,116,121,69,0,40,100,115,116,95,119,105,100,116,104,32,62,32,48,32,38,38,32,100,115,116,95,104,101,105,103,104,116,32,62,32,48,41,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,114,101,115,105,122,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,101,115,105,122,101,46,99,112,112,0,33,100,115,105,122,101,46,101,109,112,116,121,40,41,0,102,117,110,99,32,33,61,32,48,0,102,117,110,99,32,33,61,32,48,32,38,38,32,99,110,32,60,61,32,52,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,107,115,105,122,101,32,60,61,32,77,65,88,95,69,83,73,90,69,0,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,76,105,50,48,52,56,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,100,100,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,102,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,115,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,116,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,104,102,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,100,100,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,100,100,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,102,102,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,102,102,69,69,69,69,0,99,110,32,61,61,32,52,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,115,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,115,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,115,115,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,116,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,116,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,116,116,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,104,105,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,104,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,104,104,69,69,69,69,69,69,0,78,50,99,118,49,53,114,101,115,105,122,101,78,78,73,110,118,111,107,101,114,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,105,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,54,52,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,115,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,116,78,83,95,49,51,117,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,97,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,104,78,83,95,49,51,117,102,105,120,101,100,112,111,105,110,116,49,54,69,76,105,50,69,69,69,0,33,100,115,105,122,101,46,101,109,112,116,121,40,41,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,99,118,82,101,115,105,122,101,0,99,118,83,116,97,114,116,82,101,97,100,67,104,97,105,110,80,111,105,110,116,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,116,111,117,114,115,46,99,112,112,0,99,118,83,116,97,114,116,70,105,110,100,67,111,110,116,111,117,114,115,95,73,109,112,108,0,91,83,116,97,114,116,93,70,105,110,100,67,111,110,116,111,117,114,115,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,67,86,95,56,85,67,49,32,105,109,97,103,101,115,32,119,104,101,110,32,109,111,100,101,32,33,61,32,67,86,95,82,69,84,82,95,70,76,79,79,68,70,73,76,76,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,111,114,116,115,32,67,86,95,51,50,83,67,49,32,105,109,97,103,101,115,32,111,110,108,121,0,115,116,101,112,32,62,61,32,48,0,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,49,0,99,118,70,105,110,100,78,101,120,116,67,111,110,116,111,117,114,0,115,99,97,110,110,101,114,45,62,105,109,103,95,115,116,101,112,32,62,61,32,48,0,112,116,114,32,33,61,32,78,85,76,76,0,105,99,118,84,114,97,99,101,67,111,110,116,111,117,114,95,51,50,115,0,105,52,32,33,61,32,78,85,76,76,0,105,99,118,84,114,97,99,101,67,111,110,116,111,117,114,0,112,97,114,95,105,110,102,111,32,33,61,32,48,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,0,108,95,99,105,110,102,111,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,69,120,95,51,50,115,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,69,120,0,99,118,69,110,100,70,105,110,100,67,111,110,116,111,117,114,115,0,78,85,76,76,32,100,111,117,98,108,101,32,67,118,83,101,113,32,112,111,105,110,116,101,114,0,99,118,70,105,110,100,67,111,110,116,111,117,114,115,95,73,109,112,108,0,78,111,110,122,101,114,111,32,111,102,102,115,101,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,67,86,95,76,73,78,75,95,82,85,78,83,32,121,101,116,0,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,105,99,118,70,105,110,100,67,111,110,116,111,117,114,115,73,110,73,110,116,101,114,118,97,108,0,67,111,110,116,111,117,114,32,104,101,97,100,101,114,32,115,105,122,101,32,109,117,115,116,32,98,101,32,62,61,32,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,73,110,112,117,116,32,97,114,114,97,121,32,109,117,115,116,32,98,101,32,56,117,67,49,32,111,114,32,56,115,67,49,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,50,67,118,77,101,109,83,116,111,114,97,103,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,40,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,41,0,102,105,110,100,67,111,110,116,111,117,114,115,0,95,99,111,110,116,111,117,114,115,46,101,109,112,116,121,40,41,32,124,124,32,40,95,99,111,110,116,111,117,114,115,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,32,38,38,32,95,99,111,110,116,111,117,114,115,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,41,0,99,105,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,67,86,95,73,83,95,83,69,81,95,67,72,65,73,78,95,67,79,78,84,79,85,82,40,32,99,104,97,105,110,32,41,0,105,99,118,65,112,112,114,111,120,105,109,97,116,101,67,104,97,105,110,84,67,56,57,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,97,112,112,114,111,120,46,99,112,112,0,104,101,97,100,101,114,95,115,105,122,101,32,62,61,32,40,105,110,116,41,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,0,97,112,112,114,111,120,80,111,108,121,68,80,0,105,109,103,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,101,109,112,108,46,100,105,109,115,32,60,61,32,50,32,38,38,32,99,111,114,114,46,100,105,109,115,32,60,61,32,50,0,99,114,111,115,115,67,111,114,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,101,109,112,108,109,97,116,99,104,46,99,112,112,0,100,101,112,116,104,32,61,61,32,116,100,101,112,116,104,32,124,124,32,116,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,0,99,111,114,114,115,105,122,101,46,104,101,105,103,104,116,32,60,61,32,105,109,103,46,114,111,119,115,32,43,32,116,101,109,112,108,46,114,111,119,115,32,45,32,49,32,38,38,32,99,111,114,114,115,105,122,101,46,119,105,100,116,104,32,60,61,32,105,109,103,46,99,111,108,115,32,43,32,116,101,109,112,108,46,99,111,108,115,32,45,32,49,0,99,99,110,32,61,61,32,49,32,124,124,32,100,101,108,116,97,32,61,61,32,48,0,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,97,114,101,32,116,111,111,32,98,105,103,0,67,86,95,84,77,95,83,81,68,73,70,70,32,60,61,32,109,101,116,104,111,100,32,38,38,32,109,101,116,104,111,100,32,60,61,32,67,86,95,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,109,97,116,99,104,84,101,109,112,108,97,116,101,77,97,115,107,0,40,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,32,38,38,32,116,121,112,101,32,61,61,32,95,116,101,109,112,108,46,116,121,112,101,40,41,32,38,38,32,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,97,116,99,104,84,101,109,112,108,97,116,101,0,95,105,109,103,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,38,38,32,95,105,109,103,46,115,105,122,101,40,41,46,119,105,100,116,104,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,119,105,100,116,104,0,115,113,115,117,109,46,100,97,116,97,32,33,61,32,78,85,76,76,0,99,111,109,109,111,110,95,109,97,116,99,104,84,101,109,112,108,97,116,101,0,115,117,109,46,100,97,116,97,32,33,61,32,78,85,76,76,0,103,101,116,71,97,117,115,115,105,97,110,75,101,114,110,101,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+245760);allocate([105,109,103,112,114,111,99,47,115,114,99,47,115,109,111,111,116,104,46,99,112,112,0,107,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,107,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,61,61,32,49,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,49,0,99,114,101,97,116,101,71,97,117,115,115,105,97,110,75,101,114,110,101,108,115,0,78,50,99,118,49,56,102,105,120,101,100,83,109,111,111,116,104,73,110,118,111,107,101,114,73,104,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,51,117,102,105,120,101,100,112,111,105,110,116,49,54,69,69,69,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,32,124,124,32,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,52,0,76,105,110,101,73,116,101,114,97,116,111,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,114,97,119,105,110,103,46,99,112,112,0,48,32,60,32,116,104,105,99,107,110,101,115,115,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,108,105,110,101,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,32,38,38,32,116,104,105,99,107,110,101,115,115,32,62,61,32,48,0,80,111,108,121,76,105,110,101,0,181,181,181,182,182,183,184,185,187,188,190,192,194,196,198,201,203,206,209,211,214,218,221,224,227,231,235,238,242,246,250,254,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,114,101,99,116,97,110,103,108,101,0,114,97,100,105,117,115,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,99,105,114,99,108,101,0,97,120,101,115,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,97,120,101,115,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,101,108,108,105,112,115,101,0,98,111,120,46,115,105,122,101,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,98,111,120,46,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,85,110,107,110,111,119,110,32,102,111,110,116,32,116,121,112,101,0,103,101,116,70,111,110,116,68,97,116,97,0,48,32,60,61,32,99,111,110,116,111,117,114,73,100,120,32,38,38,32,99,111,110,116,111,117,114,73,100,120,32,60,32,40,105,110,116,41,108,97,115,116,0,100,114,97,119,67,111,110,116,111,117,114,115,0,110,112,111,105,110,116,115,32,62,32,48,0,104,105,101,114,97,114,99,104,121,46,116,111,116,97,108,40,41,32,61,61,32,110,99,111,110,116,111,117,114,115,32,38,38,32,104,105,101,114,97,114,99,104,121,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,52,0,99,118,68,114,97,119,67,111,110,116,111,117,114,115,0,114,101,97,100,101,114,46,112,116,114,32,33,61,32,78,85,76,76,0,101,108,101,109,95,116,121,112,101,32,61,61,32,67,86,95,51,50,83,67,50,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,46,99,112,112,0,99,118,116,67,111,108,111,114,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,0,99,118,67,118,116,67,111,108,111,114,0,100,115,116,46,100,97,116,97,32,61,61,32,100,115,116,48,46,100,97,116,97,0,111,112,101,110,99,118,45,104,105,115,116,0,68,101,115,116,105,110,97,116,105,111,110,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,67,111,112,121,72,105,115,116,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,104,101,97,100,101,114,91,115,93,0,78,85,76,76,32,114,97,110,103,101,115,32,112,111,105,110,116,101,114,0,99,118,83,101,116,72,105,115,116,66,105,110,82,97,110,103,101,115,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,104,101,97,100,101,114,0,79,110,101,32,111,102,32,60,114,97,110,103,101,115,62,32,101,108,101,109,101,110,116,115,32,105,115,32,78,85,76,76,0,66,105,110,32,114,97,110,103,101,115,32,115,104,111,117,108,100,32,103,111,32,105,110,32,97,115,99,101,110,116,105,110,103,32,111,114,100,101,114,0,78,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,99,118,67,114,101,97,116,101,72,105,115,116,0,78,117,108,108,32,60,115,105,122,101,115,62,32,112,111,105,110,116,101,114,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,116,121,112,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,105,115,116,111,103,114,97,109,46,99,112,112,0,105,115,95,117,110,105,102,111,114,109,0,104,97,118,101,95,114,97,110,103,101,115,0,109,97,116,0,98,105,110,115,0,69,120,112,101,99,116,101,100,32,67,118,77,97,116,78,68,0,105,99,118,82,101,97,100,72,105,115,116,0,85,110,107,110,111,119,110,32,72,105,115,116,111,103,114,97,109,32,116,121,112,101,0,39,116,104,114,101,115,104,39,32,110,111,100,101,32,105,115,32,109,105,115,115,105,110,103,0,99,118,82,101,108,101,97,115,101,72,105,115,116,0,100,105,109,115,32,62,32,48,32,38,38,32,104,105,115,116,83,105,122,101,0,99,97,108,99,72,105,115,116,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,69,105,116,104,101,114,32,114,97,110,103,101,115,44,32,101,105,116,104,101,114,32,117,110,105,102,111,114,109,32,114,97,110,103,101,115,32,115,104,111,117,108,100,32,98,101,32,112,114,111,118,105,100,101,100,0,99,97,108,99,72,105,115,116,95,0,99,97,108,99,72,105,115,116,76,111,111,107,117,112,84,97,98,108,101,115,95,56,117,0,99,104,97,110,110,101,108,115,32,33,61,32,48,32,124,124,32,110,105,109,97,103,101,115,32,61,61,32,100,105,109,115,0,104,105,115,116,80,114,101,112,97,114,101,73,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,32,62,61,32,48,0,106,32,60,32,110,105,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,105,109,97,103,101,115,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,109,97,115,107,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,109,97,115,107,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,114,97,110,103,101,115,91,105,93,32,38,38,32,114,97,110,103,101,115,91,105,93,91,48,93,32,60,32,114,97,110,103,101,115,91,105,93,91,49,93,0,114,97,110,103,101,115,91,105,93,91,107,93,32,60,32,114,97,110,103,101,115,91,105,93,91,107,43,49,93,0,110,105,109,97,103,101,115,32,62,32,48,32,38,38,32,100,105,109,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,67,86,95,56,85,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,0,100,105,109,115,32,62,32,48,32,38,38,32,33,104,105,115,116,46,101,109,112,116,121,40,41,0,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,0,99,97,108,99,66,97,99,107,80,114,111,106,95,0,72,48,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,105,109,97,103,101,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,50,32,38,38,32,95,49,100,41,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,67,86,95,56,85,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,32,124,124,32,40,99,115,122,32,61,61,32,49,32,38,38,32,95,49,100,41,0,72,49,46,116,121,112,101,40,41,32,61,61,32,72,50,46,116,121,112,101,40,41,32,38,38,32,72,49,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,99,111,109,112,97,114,101,72,105,115,116,0,105,116,46,112,108,97,110,101,115,91,48,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,116,46,112,108,97,110,101,115,91,49,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,101,113,117,97,108,105,122,101,72,105,115,116,0,50,51,69,113,117,97,108,105,122,101,72,105,115,116,76,117,116,95,73,110,118,111,107,101,114,0,50,56,69,113,117,97,108,105,122,101,72,105,115,116,67,97,108,99,72,105,115,116,95,73,110,118,111,107,101,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,101,111,109,101,116,114,121,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,0,112,111,105,110,116,80,111,108,121,103,111,110,84,101,115,116,0,111,112,32,61,61,32,77,79,82,80,72,95,69,82,79,68,69,32,124,124,32,111,112,32,61,61,32,77,79,82,80,72,95,68,73,76,65,84,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,82,111,119,70,105,108,116,101,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,114,112,104,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,100,97,116,97,32,116,121,112,101,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,77,111,114,112,104,70,105,108,116,101,114,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,0,99,114,101,97,116,101,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,82,69,67,84,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,67,82,79,83,83,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,69,76,76,73,80,83,69,0,103,101,116,83,116,114,117,99,116,117,114,105,110,103,69,108,101,109,101,110,116,0,109,111,114,112,104,111,108,111,103,121,69,120,0,117,110,107,110,111,119,110,32,109,111,114,112,104,111,108,111,103,105,99,97,108,32,111,112,101,114,97,116,105,111,110,0,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,32,124,124,32,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,99,111,110,116,111,117,114,77,111,109,101,110,116,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,109,101,110,116,115,46,99,112,112,0,73,110,118,97,108,105,100,32,105,109,97,103,101,32,116,121,112,101,32,40,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,41,0,109,111,109,101,110,116,115,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,119,97,116,101,114,115,104,101,100,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,101,103,109,101,110,116,97,116,105,111,110,46,99,112,112,0,85,110,107,110,111,119,110,32,99,111,109,112,97,114,105,115,111,110,32,109,101,116,104,111,100,0,109,97,116,99,104,83,104,97,112,101,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,97,116,99,104,99,111,110,116,111,117,114,115,46,99,112,112,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,85,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,49,0,66,97,121,101,114,45,62,71,114,97,121,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,0,66,97,121,101,114,45,62,82,71,66,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,51,0,66,97,121,101,114,45,62,82,71,66,32,69,100,103,101,45,65,119,97,114,101,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,85,110,107,110,111,119,110,32,47,32,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,100,101,109,111,115,97,105,99,105,110,103,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,109,111,115,97,105,99,105,110,103,46,99,112,112,0,67,86,95,77,65,84,95,67,78,40,115,117,109,84,121,112,101,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,115,114,99,84,121,112,101,41,0,103,101,116,82,111,119,83,117,109,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,102,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,115,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,105,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,105,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,115,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,116,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,116,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,100,69,69,0,78,50,99,118,54,100,101,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+256e3);allocate([97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,105,69,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,98,111,120,95,102,105,108,116,101,114,46,99,112,112,0,67,86,95,77,65,84,95,67,78,40,115,117,109,84,121,112,101,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,115,116,84,121,112,101,41,0,103,101,116,67,111,108,117,109,110,83,117,109,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,117,109,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,117,109,67,111,117,110,116,32,61,61,32,107,115,105,122,101,45,49,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,116,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,116,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,0,103,101,116,83,113,114,82,111,119,83,117,109,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,102,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,115,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,116,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,116,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,104,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,104,105,69,69,0,98,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,112,121,114,68,111,119,110,0,112,121,114,68,111,119,110,95,0,115,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,115,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,42,50,32,45,32,115,115,105,122,101,46,119,105,100,116,104,41,32,60,61,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,42,50,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,41,32,60,61,32,50,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,112,121,114,97,109,105,100,115,46,99,112,112,0,98,111,114,100,101,114,84,121,112,101,32,61,61,32,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,112,121,114,85,112,0,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,32,45,32,115,115,105,122,101,46,119,105,100,116,104,42,50,41,32,61,61,32,100,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,42,50,41,32,61,61,32,100,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,0,112,121,114,85,112,95,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,51,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,0,66,105,108,97,116,101,114,97,108,32,102,105,108,116,101,114,105,110,103,32,105,115,32,111,110,108,121,32,105,109,112,108,101,109,101,110,116,101,100,32,102,111,114,32,56,117,32,97,110,100,32,51,50,102,32,105,109,97,103,101,115,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,0,99,110,32,61,61,32,51,0,78,50,99,118,50,55,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,95,73,110,118,111,107,101,114,69,0,78,50,99,118,50,54,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,95,73,110,118,111,107,101,114,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,98,105,108,97,116,101,114,97,108,95,102,105,108,116,101,114,46,99,112,112,0,95,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,67,97,110,110,121,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,97,110,110,121,46,99,112,112,0,40,95,100,115,116,46,103,101,116,79,98,106,40,41,32,33,61,32,95,115,114,99,46,103,101,116,79,98,106,40,41,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,41,32,38,38,32,34,73,110,112,108,97,99,101,32,112,97,114,97,109,101,116,101,114,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,34,0,65,112,101,114,116,117,114,101,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,111,100,100,32,98,101,116,119,101,101,110,32,51,32,97,110,100,32,55,0,78,50,99,118,57,102,105,110,97,108,80,97,115,115,69,0,78,50,99,118,49,51,112,97,114,97,108,108,101,108,67,97,110,110,121,69,0,95,100,120,46,100,105,109,115,40,41,32,61,61,32,50,0,95,100,120,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,67,49,32,124,124,32,95,100,120,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,67,51,0,95,100,121,46,116,121,112,101,40,41,32,61,61,32,95,100,120,46,116,121,112,101,40,41,0,95,100,120,46,115,97,109,101,83,105,122,101,40,95,100,121,41,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,99,118,67,97,110,110,121,0,113,117,97,108,105,116,121,76,101,118,101,108,32,62,32,48,32,38,38,32,109,105,110,68,105,115,116,97,110,99,101,32,62,61,32,48,32,38,38,32,109,97,120,67,111,114,110,101,114,115,32,62,61,32,48,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,101,97,116,117,114,101,115,101,108,101,99,116,46,99,112,112,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,95,105,109,97,103,101,41,41,0,95,109,111,100,101,108,32,109,117,115,116,32,104,97,118,101,32,67,86,95,54,52,70,67,49,32,116,121,112,101,44,32,114,111,119,115,32,61,61,32,49,32,97,110,100,32,99,111,108,115,32,61,61,32,49,51,42,99,111,109,112,111,110,101,110,116,115,67,111,117,110,116,0,71,77,77,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,114,97,98,99,117,116,46,99,112,112,0,100,116,114,109,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,99,97,108,99,73,110,118,101,114,115,101,67,111,118,65,110,100,68,101,116,101,114,109,0,99,111,118,68,101,116,101,114,109,115,91,99,105,93,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,116,111,116,97,108,83,97,109,112,108,101,67,111,117,110,116,32,62,32,48,0,101,110,100,76,101,97,114,110,105,110,103,0,105,109,97,103,101,32,105,115,32,101,109,112,116,121,0,103,114,97,98,67,117,116,0,105,109,97,103,101,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,51,32,116,121,112,101,0,33,98,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,32,38,38,32,33,102,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,0,105,110,105,116,71,77,77,115,0,105,62,61,48,32,38,38,32,105,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,97,100,100,84,101,114,109,87,101,105,103,104,116,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,99,103,114,97,112,104,46,104,112,112,0,105,110,83,111,117,114,99,101,83,101,103,109,101,110,116,0,109,105,110,87,101,105,103,104,116,32,62,32,48,0,109,97,120,70,108,111,119,0,97,100,100,69,100,103,101,115,0,106,62,61,48,32,38,38,32,106,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,119,62,61,48,32,38,38,32,114,101,118,119,62,61,48,0,105,32,33,61,32,106,0,109,97,115,107,32,105,115,32,101,109,112,116,121,0,99,104,101,99,107,77,97,115,107,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,49,32,116,121,112,101,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,97,115,32,109,97,110,121,32,114,111,119,115,32,97,110,100,32,99,111,108,115,32,97,115,32,105,109,103,0,109,97,115,107,32,101,108,101,109,101,110,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,71,67,95,66,71,68,32,111,114,32,71,67,95,70,71,68,32,111,114,32,71,67,95,80,82,95,66,71,68,32,111,114,32,71,67,95,80,82,95,70,71,68,0,107,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,103,101,116,83,111,98,101,108,75,101,114,110,101,108,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,114,105,118,46,99,112,112,0,84,104,101,32,107,101,114,110,101,108,32,115,105,122,101,32,109,117,115,116,32,98,101,32,111,100,100,32,97,110,100,32,110,111,116,32,108,97,114,103,101,114,32,116,104,97,110,32,51,49,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,62,32,48,0,107,115,105,122,101,32,62,32,111,114,100,101,114,0,103,101,116,83,99,104,97,114,114,75,101,114,110,101,108,115,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,61,61,32,49,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,116,121,112,101,0,105,110,105,116,73,110,116,101,114,84,97,98,50,68,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,105,109,103,119,97,114,112,46,99,112,112,0,85,110,107,110,111,119,110,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,109,101,116,104,111,100,0,105,110,105,116,73,110,116,101,114,84,97,98,49,68,0,33,95,109,97,112,49,46,101,109,112,116,121,40,41,0,114,101,109,97,112,0,95,109,97,112,50,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,112,50,46,115,105,122,101,40,41,32,61,61,32,95,109,97,112,49,46,115,105,122,101,40,41,41,0,100,115,116,46,99,111,108,115,32,60,32,83,72,82,84,95,77,65,88,32,38,38,32,100,115,116,46,114,111,119,115,32,60,32,83,72,82,84,95,77,65,88,32,38,38,32,115,114,99,46,99,111,108,115,32,60,32,83,72,82,84,95,77,65,88,32,38,38,32,115,114,99,46,114,111,119,115,32,60,32,83,72,82,84,95,77,65,88,0,110,110,102,117,110,99,32,33,61,32,48,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,60,61,32,52,0,105,102,117,110,99,32,33,61,32,48,0,40,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,67,50,41,32,38,38,32,109,97,112,50,46,101,109,112,116,121,40,41,41,32,124,124,32,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,32,38,38,32,109,97,112,50,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,41,0,78,50,99,118,49,50,82,101,109,97,112,73,110,118,111,107,101,114,69,0,33,115,115,105,122,101,46,101,109,112,116,121,40,41,0,114,101,109,97,112,66,105,108,105,110,101,97,114,0,78,50,99,118,49,55,87,97,114,112,65,102,102,105,110,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,60,61,32,52,32,124,124,32,40,105,110,116,101,114,112,111,108,97,116,105,111,110,32,33,61,32,73,78,84,69,82,95,76,65,78,67,90,79,83,52,32,38,38,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,33,61,32,73,78,84,69,82,95,67,85,66,73,67,41,0,119,97,114,112,65,102,102,105,110,101,0,115,114,99,46,99,111,108,115,32,62,32,48,32,38,38,32,115,114,99,46,114,111,119,115,32,62,32,48,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,50,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,78,50,99,118,50,50,87,97,114,112,80,101,114,115,112,101,99,116,105,118,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,116,111,116,97,108,40,41,32,62,32,48,0,119,97,114,112,80,101,114,115,112,101,99,116,105,118,101,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,51,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,116,111,116,97,108,40,41,32,61,61,32,48,32,124,124,32,100,97,116,97,32,33,61,32,78,85,76,76,0,77,97,116,0,79,80,69,78,67,86,95,73,77,71,80,82,79,67,95,71,69,84,80,69,82,83,80,69,67,84,73,86,69,84,82,65,78,83,70,79,82,77,95,83,79,76,86,69,95,77,69,84,72,79,68,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,52,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,52,0,103,101,116,80,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,51,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,51,0,103,101,116,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,111,114,105,101,110,116,97,116,105,111,110,32,33,61,32,48,0,114,111,116,97,116,105,110,103,67,97,108,105,112,101,114,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,111,116,99,97,108,105,112,101,114,115,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,99,111,114,110,101,114,69,105,103,101,110,86,97,108,115,86,101,99,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,114,110,101,114,46,99,112,112,0,109,49,116,121,112,101,32,61,61,32,67,86,95,49,54,83,67,50,32,124,124,32,109,49,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,109,49,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,0,105,110,105,116,85,110,100,105,115,116,111,114,116,82,101,99,116,105,102,121,77,97,112,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,110,100,105,115,116,111,114,116,46,99,112,112,0,65,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,32,38,38,32,65,46,115,105,122,101,40,41,32,61,61,32,82,46,115,105,122,101,40,41,0,65,114,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,32,124,124,32,65,114,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,52,44,32,51,41,0,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,52,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,53,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,53,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,56,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,56,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,49,50,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,50,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,49,52,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,52,44,32,49,41,0,109,49,32,33,61,32,78,85,76,76,32,38,38,32,109,50,32,33,61,32,78,85,76,76,0,109,49,102,32,33,61,32,78,85,76,76,32,38,38,32,109,50,102,32,33,61,32,78,85,76,76,0,109,49,32,33,61,32,78,85,76,76,0,51,49,105,110,105,116,85,110,100,105,115,116,111,114,116,82,101,99,116,105,102,121,77,97,112,67,111,109,112,117,116,101,114,0,100,115,116,46,100,97,116,97,32,33,61,32,115,114,99,46,100,97,116,97,0,117,110,100,105,115,116,111,114,116,0,110,112,111,105,110,116,115,50,32,62,61,32,48,32,124,124,32,110,112,111,105,110,116,115,51,32,62,61,32,48,0,102,105,116,76,105,110,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,108,105,110,101,102,105,116,46,99,112,112,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,32,116,121,112,101,0,102,105,116,76,105,110,101,50,68,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,0,102,105,116,76,105,110,101,51,68,0,99,111,117,110,116,32,62,32,48,0,102,105,116,76,105,110,101,51,68,95,119,111,100,115,0,102,105,116,76,105,110,101,50,68,95,119,111,100,115,0,105,110,116,101,103,114,97,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,117,109,112,105,120,101,108,115,46,99,112,112,0,115,117,109,46,100,97,116,97,32,61,61,32,115,117,109,48,46,100,97,116,97,32,38,38,32,115,113,115,117,109,46,100,97,116,97,32,61,61,32,115,113,115,117,109,48,46,100,97,116,97,32,38,38,32,116,105,108,116,101,100,46,100,97,116,97,32,61,61,32,116,105,108,116,101,100,48,46,100,97,116,97,0,99,118,73,110,116,101,103,114,97,108,0,78,50,99,118,49,51,66,97,115,101,82,111,119,70,105,108,116,101,114,69,0,78,50,99,118,49,54,66,97,115,101,67,111,108,117,109,110,70,105,108,116,101,114,69,0,78,50,99,118,49,48,66,97,115,101,70,105,108,116,101,114,69,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,115,114,99,84,121,112,101,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,100,115,116,84,121,112,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,46,99,112,112,0,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,0,112,114,111,99,101,101,100,0,115,114,99,32,38,38,32,100,115,116,32,38,38,32,99,111,117,110,116,32,62,32,48,0,115,114,99,89,32,62,61,32,115,116,97,114,116,89,0,100,115,116,89,32,60,61,32,114,111,105,46,104,101,105,103,104,116,0,114,111,105,46,120,32,62,61,32,48,32,38,38,32,114,111,105,46,121,32,62,61,32,48,32,38,38,32,114,111,105,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,111,105,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,0,115,116,97,114,116,0,99,111,110,115,116,86,97,108,32,33,61,32,78,85,76,76,0,78,50,99,118,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,0,99,111,108,117,109,110,66,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,87,82,65,80,0,105,110,105,116,0,114,111,119,70,105,108,116,101,114,32,38,38,32,99,111,108,117,109,110,70,105,108,116,101,114,0,98,117,102,84,121,112,101,32,61,61,32,115,114,99,84,121,112,101,0,48,32,60,61,32,97,110,99,104,111,114,46,120,32,38,38,32,97,110,99,104,111,114,46,120,32,60,32,107,115,105,122,101,46,119,105,100,116,104,32,38,38,32,48,32,60,61,32,97,110,99,104,111,114,46,121,32,38,38,32,97,110,99,104,111,114,46,121,32,60,32,107,115,105,122,101,46,104,101,105,103,104,116,0,95,107,101,114,110,101,108,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,103,101,116,75,101,114,110,101,108,84,121,112,101,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,98,117,102,84,121,112,101,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,115,100,101,112,116,104,44,32,67,86,95,51,50,83,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,100,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,82,111,119,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,68,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,82,111,119,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,32,38,38,32,116,104,105,115,45,62,107,115,105,122,101,32,60,61,32,53,0,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+266240);allocate([105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,98,117,102,84,121,112,101,41,32,38,38,32,115,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,100,100,101,112,116,104,44,32,67,86,95,51,50,83,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,67,111,108,117,109,110,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,0,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,83,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,116,104,105,115,45,62,107,115,105,122,101,32,61,61,32,51,0,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,95,100,115,116,84,121,112,101,41,0,99,114,101,97,116,101,83,101,112,97,114,97,98,108,101,76,105,110,101,97,114,70,105,108,116,101,114,0,107,116,121,112,101,32,61,61,32,67,86,95,56,85,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,51,50,83,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,112,114,101,112,114,111,99,101,115,115,50,68,75,101,114,110,101,108,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,115,116,84,121,112,101,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,70,105,108,116,101,114,0,97,110,99,104,111,114,46,105,110,115,105,100,101,40,82,101,99,116,40,48,44,32,48,44,32,107,115,105,122,101,46,119,105,100,116,104,44,32,107,115,105,122,101,46,104,101,105,103,104,116,41,41,0,110,111,114,109,97,108,105,122,101,65,110,99,104,111,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,101,110,103,105,110,101,46,104,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,75,84,62,58,58,116,121,112,101,0,70,105,108,116,101,114,50,68,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,99,114,101,97,116,101,76,105,110,101,97,114,70,105,108,116,101,114,0,107,101,114,110,101,108,88,46,116,121,112,101,40,41,32,61,61,32,107,101,114,110,101,108,89,46,116,121,112,101,40,41,32,38,38,32,40,107,101,114,110,101,108,88,46,99,111,108,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,88,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,40,107,101,114,110,101,108,89,46,99,111,108,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,89,46,114,111,119,115,32,61,61,32,49,41,0,115,101,112,70,105,108,116,101,114,50,68,0,104,114,97,110,103,101,32,61,61,32,49,56,48,32,124,124,32,104,114,97,110,103,101,32,61,61,32,50,53,54,0,82,71,66,50,72,83,86,95,98,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,95,104,115,118,46,99,112,112,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,98,69,69,69,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,53,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,53,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,53,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,53,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,72,111,117,103,104,76,105,110,101,115,83,68,105,118,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,111,117,103,104,46,99,112,112,0,108,105,110,101,115,77,97,120,32,62,32,48,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,83,68,105,118,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,102,108,111,97,116,44,32,102,108,111,97,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,0,116,121,112,101,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,51,0,72,111,117,103,104,76,105,110,101,115,83,116,97,110,100,97,114,100,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,83,116,97,110,100,97,114,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,102,108,111,97,116,44,32,102,108,111,97,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,109,97,120,95,116,104,101,116,97,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,109,105,110,95,116,104,101,116,97,0,109,97,120,95,116,104,101,116,97,0,109,105,110,95,116,104,101,116,97,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,87,114,111,110,103,32,116,121,112,101,32,111,102,32,111,117,116,112,117,116,32,108,105,110,101,115,0,105,109,97,103,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,72,111,117,103,104,76,105,110,101,115,80,114,111,98,97,98,105,108,105,115,116,105,99,0,33,95,105,109,97,103,101,46,101,109,112,116,121,40,41,32,38,38,32,95,105,109,97,103,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,40,95,105,109,97,103,101,46,105,115,77,97,116,40,41,32,124,124,32,95,105,109,97,103,101,46,105,115,85,77,97,116,40,41,41,0,72,111,117,103,104,67,105,114,99,108,101,115,0,95,99,105,114,99,108,101,115,46,105,115,77,97,116,40,41,32,124,124,32,95,99,105,114,99,108,101,115,46,105,115,86,101,99,116,111,114,40,41,0,100,112,44,32,109,105,110,95,100,105,115,116,44,32,99,97,110,110,121,95,116,104,114,101,115,104,111,108,100,32,97,110,100,32,97,99,99,95,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,97,108,108,32,112,111,115,105,116,105,118,101,32,110,117,109,98,101,114,115,0,107,101,114,110,101,108,83,105,122,101,32,61,61,32,45,49,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,51,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,53,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,55,0,72,111,117,103,104,67,105,114,99,108,101,115,71,114,97,100,105,101,110,116,0,85,110,114,101,99,111,103,110,105,122,101,100,32,109,101,116,104,111,100,32,105,100,46,32,65,99,116,117,97,108,108,121,32,111,110,108,121,32,67,86,95,72,79,85,71,72,95,71,82,65,68,73,69,78,84,32,105,115,32,115,117,112,112,111,114,116,101,100,46,0,72,111,117,103,104,67,105,114,99,108,101,69,115,116,105,109,97,116,101,82,97,100,105,117,115,73,110,118,111,107,101,114,0,78,50,99,118,51,50,72,111,117,103,104,67,105,114,99,108,101,69,115,116,105,109,97,116,101,82,97,100,105,117,115,73,110,118,111,107,101,114,73,78,83,95,49,48,78,90,80,111,105,110,116,83,101,116,69,69,69,0,78,50,99,118,51,50,72,111,117,103,104,67,105,114,99,108,101,69,115,116,105,109,97,116,101,82,97,100,105,117,115,73,110,118,111,107,101,114,73,78,83,95,49,49,78,90,80,111,105,110,116,76,105,115,116,69,69,69,0,78,50,99,118,51,48,72,111,117,103,104,67,105,114,99,108,101,115,70,105,110,100,67,101,110,116,101,114,115,73,110,118,111,107,101,114,69,0,78,50,99,118,50,52,72,111,117,103,104,67,105,114,99,108,101,115,65,99,99,117,109,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,67,105,114,99,108,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,87,114,111,110,103,32,116,121,112,101,32,111,102,32,111,117,116,112,117,116,32,99,105,114,99,108,101,115,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,51,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,52,0,97,117,116,111,109,97,116,105,99,95,116,104,114,101,115,104,32,33,61,32,40,67,86,95,84,72,82,69,83,72,95,79,84,83,85,32,124,32,67,86,95,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,41,0,116,104,114,101,115,104,71,101,110,101,114,105,99,0,78,50,99,118,49,53,84,104,114,101,115,104,111,108,100,82,117,110,110,101,114,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,104,114,101,115,104,46,99,112,112,0,97,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,0,98,108,111,99,107,83,105,122,101,32,37,32,50,32,61,61,32,49,32,38,38,32,98,108,111,99,107,83,105,122,101,32,62,32,49,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,100,97,112,116,105,118,101,32,116,104,114,101,115,104,111,108,100,32,109,101,116,104,111,100,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,116,104,114,101,115,104,111,108,100,32,116,121,112,101,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,40,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,124,124,32,100,115,116,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,41,0,99,118,84,104,114,101,115,104,111,108,100,0,99,111,117,110,116,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,109,105,110,69,110,99,108,111,115,105,110,103,67,105,114,99,108,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,104,97,112,101,100,101,115,99,114,46,99,112,112,0,97,114,99,76,101,110,103,116,104,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,99,111,110,116,111,117,114,65,114,101,97,0,110,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,102,105,116,69,108,108,105,112,115,101,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,97,116,32,108,101,97,115,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+276480);allocate([32,53,32,112,111,105,110,116,115,32,116,111,32,102,105,116,32,116,104,101,32,101,108,108,105,112,115,101,0,112,111,105,110,116,83,101,116,66,111,117,110,100,105,110,103,82,101,99,116,0,105,109,103,46,100,101,112,116,104,40,41,32,60,61,32,67,86,95,56,83,32,38,38,32,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,97,115,107,66,111,117,110,100,105,110,103,82,101,99,116,0,85,110,115,117,112,112,111,114,116,101,100,32,115,101,113,117,101,110,99,101,32,116,121,112,101,0,99,118,66,111,117,110,100,105,110,103,82,101,99,116,0,84,104,101,32,105,109,97,103,101,47,109,97,116,114,105,120,32,102,111,114,109,97,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,40,107,115,105,122,101,32,37,32,50,32,61,61,32,49,41,32,38,38,32,40,95,115,114,99,48,46,100,105,109,115,40,41,32,60,61,32,50,32,41,0,109,101,100,105,97,110,66,108,117,114,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,40,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,41,0,99,110,32,62,32,48,32,38,38,32,99,110,32,60,61,32,52,0,109,101,100,105,97,110,66,108,117,114,95,56,117,95,79,109,0,109,101,100,105,97,110,66,108,117,114,95,56,117,95,79,49,0,107,32,60,32,49,54,0,98,32,60,32,49,54,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,101,100,105,97,110,95,98,108,117,114,46,99,112,112,0,95,112,111,105,110,116,115,46,103,101,116,79,98,106,40,41,32,33,61,32,95,104,117,108,108,46,103,101,116,79,98,106,40,41,0,99,111,110,118,101,120,72,117,108,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,118,104,117,108,108,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,112,111,105,110,116,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,112,111,105,110,116,115,32,62,61,32,48,0,99,111,110,118,101,120,105,116,121,68,101,102,101,99,116,115,0,104,112,111,105,110,116,115,32,62,32,48,0,48,32,60,61,32,104,99,117,114,114,32,38,38,32,104,99,117,114,114,32,60,32,110,112,111,105,110,116,115,0,48,32,60,61,32,104,110,101,120,116,32,38,38,32,104,110,101,120,116,32,60,32,110,112,111,105,110,116,115,0,105,115,67,111,110,116,111,117,114,67,111,110,118,101,120,0,97,114,114,32,33,61,32,48,32,38,38,32,99,111,110,116,111,117,114,95,104,101,97,100,101,114,32,33,61,32,48,32,38,38,32,98,108,111,99,107,32,33,61,32,48,0,99,118,80,111,105,110,116,83,101,113,70,114,111,109,77,97,116,0,73,110,112,117,116,32,97,114,114,97,121,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,116,114,105,120,0,84,104,101,32,109,97,116,114,105,120,32,99,97,110,32,110,111,116,32,98,101,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,98,101,99,97,117,115,101,32,111,102,32,105,110,97,112,112,114,111,112,114,105,97,116,101,32,101,108,101,109,101,110,116,32,116,121,112,101,0,84,104,101,32,109,97,116,114,105,120,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,109,117,115,116,32,98,101,32,49,45,100,105,109,101,110,115,105,111,110,97,108,32,97,110,100,32,99,111,110,116,105,110,117,111,117,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,116,105,108,115,46,99,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,85,67,49,0,85,110,115,117,112,112,111,114,116,101,100,32,116,121,112,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,54,53,53,51,54,69,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,54,53,53,51,54,69,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,108,97,104,101,46,99,112,112,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,0,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,32,124,124,32,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,77,97,115,107,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,51,32,111,114,32,53,32,111,114,32,48,32,40,112,114,101,99,105,115,101,41,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,0,116,114,117,101,68,105,115,116,84,114,97,110,115,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,67,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,49,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,50,0,85,110,107,110,111,119,110,32,109,101,116,114,105,99,32,116,121,112,101,0,103,101,116,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,77,97,115,107,0,78,50,99,118,49,50,68,84,82,111,119,73,110,118,111,107,101,114,69,0,78,50,99,118,49,53,68,84,67,111,108,117,109,110,73,110,118,111,107,101,114,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,105,115,116,114,97,110,115,102,111,114,109,46,99,112,112,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,95,76,49,95,56,85,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,100,105,115,116,97,110,99,101,65,84,83,95,76,49,95,56,117,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,93,41,32,43,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,43,49,93,41,32,43,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,43,50,93,41,32,60,32,115,111,102,116,102,108,111,97,116,40,49,46,53,102,41,0,82,71,66,50,76,117,118,102,108,111,97,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,95,108,97,98,46,99,112,112,0,119,104,105,116,101,80,116,91,49,93,32,61,61,32,115,111,102,116,100,111,117,98,108,101,58,58,111,110,101,40,41,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,102,69,69,69,0,99,91,48,93,32,62,61,32,48,32,38,38,32,99,91,49,93,32,62,61,32,48,32,38,38,32,99,91,50,93,32,62,61,32,48,32,38,38,32,99,91,48,93,32,43,32,99,91,49,93,32,43,32,99,91,50,93,32,60,32,115,111,102,116,102,108,111,97,116,40,40,105,110,116,41,76,65,66,95,67,66,82,84,95,84,65,66,95,83,73,90,69,41,0,82,71,66,50,76,97,98,95,102,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,60,32,50,42,40,49,32,60,60,32,108,97,98,95,115,104,105,102,116,41,0,82,71,66,50,76,97,98,95,98,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,98,69,69,69,0,76,117,118,50,82,71,66,102,108,111,97,116,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,98,69,69,69,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,102,69,69,69,69,0,115,114,99,99,110,32,61,61,32,51,32,124,124,32,115,114,99,99,110,32,61,61,32,52,0,82,71,66,50,82,71,66,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,95,114,103,98,46,99,112,112,0,100,115,116,99,110,32,61,61,32,51,32,124,124,32,100,115,116,99,110,32,61,61,32,52,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,50,82,71,66,53,120,53,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,53,120,53,50,82,71,66,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,53,120,53,50,71,114,97,121,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,71,114,97,121,50,82,71,66,53,120,53,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,65,50,109,82,71,66,65,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,109,82,71,66,65,50,82,71,66,65,73,104,69,69,69,69,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,52,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,52,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,52,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,52,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,77,87,82,77,78,86,32,82,77,86,86,32,80,83,84,83,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,80,83,81,32,79,81,83,81,85,82,85,85,83,86,79,86,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,0,77,87,79,77,79,86,32,79,77,82,77,84,78,85,80,85,83,84,85,82,86,79,86,0,77,87,79,77,79,86,32,79,77,85,77,32,79,81,83,81,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,32,79,81,83,81,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,86,82,32,83,82,86,82,0,77,87,79,77,79,86,32,85,77,85,86,32,79,81,85,81,0,80,84,82,77,82,86,0,78,85,83,77,83,84,82,86,80,86,79,84,79,83,0,77,87,79,77,79,86,32,85,77,79,83,32,81,81,85,86,0,77,86,79,77,79,86,32,79,86,85,86,0,76,88,78,77,78,86,32,78,77,82,86,32,86,77,82,86,32,86,77,86,86,0,77,87,79,77,79,86,32,79,77,85,86,32,85,77,85,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,83,84,86,87,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,32,82,82,85,86,0,77,87,85,78,83,77,81,77,79,78,79,79,80,80,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,82,77,82,86,32,78,77,86,77,0,77,88,79,77,79,83,80,85,82,86,83,86,85,85,86,83,86,77,0,77,87,78,77,82,86,32,86,77,82,86,0,76,88,78,77,80,86,32,82,77,80,86,32,82,77,84,86,32,86,77,84,86,0,77,87,79,77,85,86,32,85,77,79,86,0,77,87,78,77,82,81,82,86,32,86,77,82,81,0,77,87,85,77,79,86,32,79,77,85,77,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,0,77,87,82,77,78,86,32,82,77,86,86,32,78,86,86,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,81,81,84,82,32,84,81,81,82,0,77,87,82,77,78,86,32,82,77,86,86,0,77,87,79,77,85,77,32,80,81,84,82,32,84,81,80,82,32,79,86,85,86,0,77,87,79,77,79,86,32,85,77,85,86,32,79,77,85,77,0,77,87,79,77,82,81,79,86,32,79,77,85,77,32,79,86,85,86,0,77,87,78,79,78,78,79,77,80,77,81,78,82,80,82,86,32,86,79,86,78,85,77,84,77,83,78,82,80,0,76,88,82,77,82,86,32,80,79,78,80,78,83,80,84,84,84,86,83,86,80,84,79,80,79,0,76,88,82,77,82,86,32,78,79,79,80,79,83,81,84,83,84,85,83,85,80,86,79,0,77,88,79,86,81,86,79,82,79,80,80,78,82,77,83,77,85,78,86,80,86,82,84,86,86,86,0,77,87,83,77,77,86,32,83,77,85,86,32,79,83,84,83,0,77,87,81,77,78,86,32,81,77,84,77,86,78,86,80,83,81,80,81,32,83,81,85,82,85,84,84,85,82,86,78,86,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,0,77,88,81,77,78,86,32,81,77,85,77,86,79,86,81,85,84,84,85,82,86,78,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,32,78,86,83,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,83,82,83,0,77,88,81,77,78,86,32,87,77,84,86,32,80,81,85,81,0,80,85,84,77,81,86,0,79,86,85,77,83,83,82,85,81,86,80,86,79,85,79,84,0,77,86,81,77,78,86,32,86,77,79,83,32,82,81,84,86,0,78,86,82,77,79,86,32,79,86,84,86,0,76,89,80,77,77,86,32,80,77,81,86,32,88,77,81,86,32,88,77,85,86,0,77,88,81,77,78,86,32,81,77,84,86,32,87,77,84,86,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,32,81,86,80,85,80,84,81,83,82,83,83,84,84,86,85,87,86,87,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,32,81,82,82,85,83,86,84,86,85,85,0,77,87,86,78,84,77,82,77,80,78,80,80,81,81,84,82,85,83,85,85,83,86,80,86,78,85,0,77,86,83,77,80,86,32,80,77,86,77,0,76,88,80,77,78,83,78,85,79,86,82,86,84,85,85,83,87,77,0,77,87,79,77,81,86,32,87,77,81,86,0,75,88,78,77,78,86,32,83,77,78,86,32,83,77,83,86,32,88,77,83,86,0,78,87,81,77,84,86,32,87,77,78,86,0,78,87,81,77,83,81,81,86,32,87,77,83,81,0,77,87,81,77,87,77,78,86,84,86,0,76,88,78,77,82,86,32,86,77,82,86,32,78,77,86,77,0,77,87,78,76,86,88,0,76,88,82,79,78,85,32,82,79,86,85,0,77,87,78,86,86,86,0,80,86,82,77,85,81,0,77,87,77,77,79,75,81,75,84,77,86,77,87,75,0,78,87,81,80,84,80,85,81,85,86,32,85,82,81,83,80,84,80,85,81,86,83,86,85,85,0,77,87,79,77,79,86,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,0,77,87,85,77,85,86,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,83,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,86,0,78,86,85,78,84,77,83,77,82,78,82,86,32,80,80,84,80,0,77,87,85,80,85,86,84,88,82,89,80,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,77,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,80,84,82,76,81,77,82,78,83,77,82,76,32,82,80,82,86,0,80,85,83,76,82,77,83,78,84,77,83,76,32,83,80,83,88,82,89,81,89,80,88,0,78,87,80,77,80,86,32,85,80,80,84,32,82,83,85,86,0,75,89,77,80,77,86,32,77,83,78,81,79,80,80,80,81,81,82,83,82,86,32,82,83,83,81,84,80,85,80,86,81,87,83,87,86,0,77,87,79,80,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,77,87,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,87,79,80,79,89,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,80,85,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,78,86,80,80,80,86,32,80,83,81,81,83,80,84,80,0,78,87,85,81,84,80,81,80,80,81,80,82,81,83,84,83,85,84,85,85,84,86,81,86,80,85,0,78,86,82,77,82,85,83,86,84,86,85,85,32,80,80,84,80,0,77,87,85,80,85,86,32,79,80,79,83,80,85,82,86,84,85,85,83,0,78,86,79,80,82,86,32,85,80,82,86,0,76,88,78,80,80,86,32,82,80,80,86,32,82,80,84,86,32,86,80,84,86,0,77,87,79,80,85,86,32,85,80,79,86,0,77,87,79,80,82,86,32,85,80,82,86,81,88,80,89,79,89,0,77,87,79,80,85,80,79,86,85,86,0,77,88,86,80,85,83,84,85,82,86,80,85,79,83,80,81,82,80,84,81,85,85,86,86,0,77,87,79,84,81,86,83,86,84,85,84,83,83,82,80,81,82,81,84,80,85,79,85,78,84,77,82,77,81,78,80,80,79,84,78,89,0,77,88,78,81,79,80,81,80,82,81,82,83,81,87,32,86,80,85,82,83,84,81,87,80,89,0,77,87,84,78,83,77,82,77,81,78,81,79,82,80,84,81,85,83,84,85,82,86,80,85,79,83,80,81,82,80,0,78,87,85,81,83,80,81,80,80,81,80,82,81,83,32,83,83,81,83,80,84,80,85,81,86,83,86,85,85,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,80,83,80,85,81,86,83,87,83,88,82,89,81,89,0,76,88,78,81,79,80,80,80,81,81,81,83,80,86,32,81,83,82,81,84,80,85,80,86,81,86,83,85,86,84,89,0,76,88,78,81,79,80,80,80,81,81,81,85,82,86,83,86,84,85,85,83,86,80,86,78,85,77,84,77,83,78,83,80,84,82,85,83,87,84,0,79,86,82,80,81,83,81,85,82,86,83,86,84,85,0,77,87,81,80,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,77,87,79,77,80,77,81,78,82,80,85,86,32,82,80,79,86,0,76,89,80,80,77,89,32,85,80,84,83,83,85,81,86,80,86,79,85,79,83,32,84,83,84,85,85,86,86,86,87,85,0,77,87,78,80,79,80,79,86,32,85,80,84,83,82,85,79,86,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,81,82,82,83,84,83,32,83,83,81,84,80,85,80,86,81,87,83,88,83,89,82,90,81,90,0,77,88,79,81,81,80,86,80,32,81,80,81,82,80,86,32,84,80,84,82,85,86,0,77,87,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,78,89,0,77,88,86,80,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,88,79,81,81,80,86,80,32,83,80,82,86,0,75,88,77,81,78,80,79,80,80,81,80,85,81,86,83,86,84,85,85,83,86,80,0,77,88,80,80,79,81,79,83,80,85,82,86,83,86,85,85,86,83,86,81,85,80,84,80,83,81,82,83,81,89,0,77,87,79,80,80,80,81,81,83,88,84,89,85,89,32,85,80,84,82,80,87,79,89,0,75,89,84,77,82,89,32,77,81,78,80,79,80,80,81,80,85,81,86,84,86,85,85,86,83,87,80,0,76,88,79,80,78,82,78,84,79,86,81,86,82,84,82,82,32,85,80,86,82,86,84,85,86,83,86,82,84,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,81,77,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,86,77,84,83,84,85,85,86,86,86,0,77,87,79,83,84,83,85,82,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,79,86,86,77,85,77,84,78,83,80,81,86,80,88,79,89,78,89,32,81,80,85,80,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,84,86,83,88,82,89,80,89,79,88,0,77,86,81,77,78,86,32,79,83,80,81,81,80,83,80,84,81,84,82,83,84,83,85,84,86,85,86,0,80,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,84,82,85,83,86,84,86,0,79,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,86,81,88,80,89,79,89,78,88,0,78,86,82,77,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,79,84,83,77,81,83,81,85,82,86,83,86,0,74,89,75,80,76,80,77,81,77,83,76,86,32,77,83,78,81,79,80,81,80,82,81,82,83,81,86,32,82,83,83,81,84,80,86,80,87,81,87,82,86,84,86,85,87,86,88,86,0,77,87,78,80,79,80,80,81,80,83,79,86,32,80,83,81,81,82,80,84,80,85,81,85,82,84,84,84,85,85,86,86,86,0,77,88,78,80,79,80,80,81,80,83,78,89,32,80,83,81,85,83,86,85,85,86,83,85,81,83,80,81,81,80,83,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,83,89,0,77,86,79,80,80,80,81,81,81,83,80,86,32,85,81,84,80,83,80,82,81,81,83,0,78,86,84,81,83,80,81,80,80,81,80,82,81,83,82,83,83,84,83,85,82,86,80,86,79,85,0,78,85,83,77,81,83,81,85,82,86,83,86,32,80,80,84,80,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,84,85,85,82,85,80,0,75,89,76,80,77,80,78,81,78,82,77,84,77,85,78,86,80,86,81,85,82,83,83,80,32,82,83,82,85,83,86,85,86,86,85,87,82,87,80,0,77,87,79,81,80,80,81,80,82,81,82,85,83,86,84,86,85,85,32,86,81,85,80,84,80,83,81,81,85,80,86,79,86,78,85,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+286720);allocate([32,85,80,83,86,82,88,81,89,79,89,78,88,0,78,86,85,80,79,86,32,80,81,81,80,83,80,84,81,32,80,85,81,86,83,86,84,85,0,77,87,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,81,77,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,32,79,83,83,83,0,77,87,82,77,81,78,80,80,79,83,79,86,80,87,82,87,83,86,84,84,85,81,85,78,84,77,82,77,32,80,82,84,82,0,77,87,84,77,81,89,32,82,80,80,81,79,83,80,85,82,86,83,86,85,85,86,83,85,81,83,80,82,80,0,77,87,85,81,83,80,81,80,79,81,79,83,80,84,82,85,83,86,83,87,82,88,81,88,0,75,89,84,80,84,83,85,84,86,84,87,83,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,32,84,81,83,80,81,80,80,81,80,83,81,84,83,84,84,83,0,77,87,85,78,79,82,85,86,0,77,87,79,78,85,82,79,86,0,79,85,84,75,81,75,81,89,84,89,0,79,85,80,75,83,75,83,89,80,89,0,79,85,84,75,83,76,82,78,82,79,83,81,81,82,83,83,82,85,82,86,83,88,84,89,0,79,85,80,75,81,76,82,78,82,79,81,81,83,82,81,83,82,85,82,86,81,88,80,89,0,76,89,80,77,81,78,81,79,80,80,79,80,78,79,78,78,79,77,80,77,83,78,85,78,87,77,78,86,32,85,83,84,84,84,85,85,86,86,86,87,85,87,84,86,83,85,83,0,80,84,0,78,86,0,77,87,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,0,77,87,80,79,82,77,82,86,0,77,87,79,78,81,77,83,77,85,78,85,80,84,82,79,86,85,86,0,77,87,79,78,81,77,83,77,85,78,85,80,83,81,32,82,81,83,81,85,82,85,85,83,86,81,86,79,85,0,77,87,83,77,83,86,32,83,77,78,83,86,83,0,77,87,80,77,79,81,81,80,82,80,84,81,85,83,84,85,82,86,81,86,79,85,32,80,77,84,77,0,77,87,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,77,81,86,32,79,77,85,77,0,77,87,81,77,79,78,79,80,81,81,83,81,85,80,85,78,83,77,81,77,32,81,81,79,82,79,85,81,86,83,86,85,85,85,82,83,81,0,77,87,85,80,84,82,82,83,80,82,79,80,80,78,82,77,84,78,85,80,85,83,84,85,82,86,80,86,0,80,85,82,85,82,86,83,86,83,85,82,85,0,80,85,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,80,82,81,83,81,83,80,82,80,32,82,85,82,86,83,86,83,85,82,85,0,80,85,82,80,82,81,83,81,83,80,82,80,32,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,77,82,82,32,83,77,83,82,32,82,85,82,86,83,86,83,85,82,85,0,78,87,80,78,82,77,83,77,85,78,85,80,82,81,82,82,83,82,83,81,85,80,32,82,85,82,86,83,86,83,85,82,85,0,80,84,82,77,82,81,0,78,86,80,77,80,81,32,84,77,84,81,0,78,86,81,77,80,78,80,80,81,81,83,81,84,80,84,78,83,77,81,77,0,77,87,82,75,82,88,32,85,78,83,77,81,77,79,78,79,80,81,81,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,86,76,78,88,0,79,85,84,75,82,78,81,81,81,83,82,86,84,89,0,79,85,80,75,82,78,83,81,83,83,82,86,80,89,0,80,84,82,75,82,89,0,76,88,78,82,86,82,0,76,88,82,78,82,86,32,78,82,86,82,0,76,88,78,80,86,80,32,78,84,86,84,0,77,87,79,79,85,85,32,85,79,79,85,0,77,87,82,79,82,85,32,79,80,85,84,32,85,80,79,84,0,80,85,82,81,82,82,83,82,83,81,82,81,0,80,85,83,77,82,79,82,81,83,81,83,80,82,80,0,80,85,83,78,82,78,82,77,83,77,83,79,82,81,0,76,88,83,79,86,82,83,85,32,78,82,86,82,0,77,88,81,76,81,89,32,84,76,84,89,32,79,81,86,81,32,79,84,86,84,0,76,88,86,82,85,82,84,83,83,85,82,86,79,86,78,85,78,83,79,82,82,81,83,80,83,78,82,77,80,77,79,78,79,80,81,83,83,85,85,86,86,86,0,76,88,78,78,79,81,79,83,78,86,32,86,78,85,81,85,83,86,86,32,78,78,81,79,83,79,86,78,32,78,86,81,85,83,85,86,86,0,76,89,82,81,81,80,79,80,78,81,78,83,79,84,81,84,82,83,83,81,84,80,86,80,87,81,87,83,86,84,84,84,83,83,82,81,0,72,92,78,82,77,81,76,82,77,83,78,82,32,86,82,87,81,88,82,87,83,86,82,0,72,92,77,80,76,81,76,82,77,83,78,83,79,82,79,81,78,80,77,80,32,77,81,77,82,78,82,78,81,77,81,32,87,80,86,81,86,82,87,83,88,83,89,82,89,81,88,80,87,80,32,87,81,87,82,88,82,88,81,87,81,0,73,91,75,82,89,82,0,72,92,82,85,74,80,82,84,90,80,82,85,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,89,74,87,76,86,78,86,80,87,84,90,86,91,88,91,90,90,91,87,32,73,89,74,86,76,85,78,85,80,86,84,89,86,90,88,90,90,89,91,87,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,87,91,87,32,73,91,91,91,0,67,97,71,79,93,79,88,73,32,76,91,71,85,93,85,0,68,96,70,94,94,94,94,70,70,70,70,94,0,75,89,81,86,79,85,78,83,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,32,83,86,86,83,32,81,86,86,81,32,79,85,85,79,32,78,83,83,78,32,78,81,81,78,0,72,92,73,82,91,82,0,72,92,73,82,91,82,32,73,81,91,81,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,81,91,79,92,78,94,78,97,32,84,84,85,85,86,87,85,89,84,90,32,78,96,79,95,80,95,83,96,86,96,87,95,32,80,95,83,97,86,97,87,95,87,94,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,81,74,79,75,78,77,78,80,32,84,67,85,68,86,70,85,72,84,73,32,78,79,79,78,80,78,83,79,86,79,87,78,32,80,78,83,80,86,80,87,78,87,77,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,78,67,78,71,32,86,69,82,76,80,80,32,87,67,84,73,81,80,32,78,69,80,67,82,67,85,69,32,78,69,80,68,82,68,85,69,86,69,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,70,94,89,88,87,90,85,91,82,91,80,90,77,88,75,87,73,87,72,88,72,90,73,91,75,91,77,90,79,87,80,85,82,81,84,75,87,71,89,70,90,70,91,71,92,72,91,73,90,72,91,71,91,70,90,70,89,70,87,71,86,72,84,76,82,80,80,86,78,90,77,90,32,79,80,85,80,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,78,74,78,87,32,79,74,79,87,32,76,74,83,74,86,75,87,77,87,78,86,80,83,81,79,81,32,83,74,85,75,86,77,86,78,85,80,83,81,32,76,87,81,87,32,83,81,84,82,85,86,86,87,87,87,88,86,32,83,81,85,82,86,86,87,87,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,85,75,86,74,86,78,85,75,83,74,80,74,78,75,77,76,76,79,76,82,77,85,78,86,80,87,83,87,85,86,86,84,32,80,74,78,76,77,79,77,82,78,85,80,87,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,32,75,91,89,73,0,67,97,72,81,71,82,72,83,73,82,72,81,32,82,81,81,82,82,83,83,82,82,81,32,92,81,91,82,92,83,93,82,92,81,0,69,95,78,87,76,84,73,82,76,80,78,77,32,76,80,74,82,76,84,32,74,82,90,82,32,86,87,88,84,91,82,88,80,86,77,32,88,80,90,82,88,84,0,74,90,87,78,84,76,82,73,80,76,77,78,32,80,76,82,74,84,76,32,82,74,82,90,32,87,86,84,88,82,91,80,88,77,86,32,80,88,82,90,84,88,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,83,70,83,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,81,70,81,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,79,82,90,82,0,72,92,76,66,76,91,32,82,66,82,91,32,88,66,88,91,0,73,91,82,70,74,91,32,82,70,90,91,32,77,84,87,84,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,32,75,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,75,91,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,0,71,92,75,70,75,91,32,75,70,82,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,82,91,75,91,0,72,91,76,70,76,91,32,76,70,89,70,32,76,80,84,80,32,76,91,89,91,0,72,90,76,70,76,91,32,76,70,89,70,32,76,80,84,80,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,83,32,85,83,90,83,0,71,93,75,70,75,91,32,89,70,89,91,32,75,80,89,80,0,78,86,82,70,82,91,0,74,90,86,70,86,86,85,89,84,90,82,91,80,91,78,90,77,89,76,86,76,84,0,71,92,75,70,75,91,32,89,70,75,84,32,80,79,89,91,0,72,89,76,70,76,91,32,76,91,88,91,0,70,94,74,70,74,91,32,74,70,82,91,32,90,70,82,91,32,90,70,90,91,0,71,93,75,70,75,91,32,75,70,89,91,32,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,75,81,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,83,87,89,93,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,75,80,32,82,80,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,90,82,70,82,91,32,75,70,89,70,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,0,73,91,74,70,82,91,32,90,70,82,91,0,70,94,72,70,77,91,32,82,70,77,91,32,82,70,87,91,32,92,70,87,91,0,72,92,75,70,89,91,32,89,70,75,91,0,73,91,74,70,82,80,82,91,32,90,70,82,80,0,72,92,89,70,75,91,32,75,70,89,70,32,75,91,89,91,0,72,89,76,70,76,91,32,76,70,88,70,0,73,91,82,70,74,91,32,82,70,90,91,32,74,91,90,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,79,80,85,80,0,73,91,82,70,74,91,32,82,70,90,91,0,73,91,75,70,89,70,32,79,80,85,80,32,75,91,89,91,0,71,93,75,70,75,91,32,89,70,89,91,32,75,70,89,70,0,73,91,75,70,82,80,75,91,32,75,70,89,70,32,75,91,89,91,0,73,91,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,89,75,89,73,88,71,87,70,85,70,84,71,83,73,82,77,0,72,92,82,70,82,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,84,86,87,85,88,84,89,82,89,79,88,77,87,76,84,75,80,75,0,72,92,75,70,89,91,32,75,91,89,70,0,71,93,82,70,82,91,32,73,76,74,76,75,77,76,81,77,83,78,84,81,85,83,85,86,84,87,83,88,81,89,77,90,76,91,76,0,72,92,75,91,79,91,76,84,75,80,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,80,88,84,85,91,89,91,0,71,91,71,91,73,90,76,87,79,83,83,76,86,70,86,91,85,88,83,85,81,83,78,81,76,81,75,82,75,84,76,86,78,88,81,90,84,91,89,91,0,70,93,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,88,70,90,71,91,73,91,75,90,77,89,78,87,79,84,80,32,83,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,82,91,80,90,79,88,0,72,92,84,76,84,77,85,78,87,78,89,77,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,87,86,0,71,94,84,70,82,71,81,73,80,77,79,83,78,86,77,88,75,90,73,91,71,91,70,90,70,88,71,87,73,87,75,88,77,90,80,91,83,91,86,90,88,88,90,84,91,79,91,75,90,72,89,71,87,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,92,85,0,72,92,86,74,86,75,87,76,89,76,90,75,90,73,89,71,86,70,82,70,79,71,78,73,78,76,79,78,80,79,83,80,80,80,77,81,76,82,75,84,75,87,76,89,77,90,80,91,83,91,86,90,88,88,89,86,0,72,92,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,32,81,80,90,80,0,71,94,71,91,73,90,77,86,80,81,81,78,82,74,82,71,81,70,80,70,79,71,78,73,78,76,79,78,81,79,85,79,88,78,89,77,90,75,90,81,89,86,88,88,86,90,83,91,79,91,76,90,74,88,73,86,73,84,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,72,88,76,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,73,90,87,86,85,84,83,81,82,79,81,76,81,73,82,71,83,70,85,70,86,71,87,73,87,76,86,81,84,86,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,77,85,79,86,0,74,89,84,94,82,91,80,86,79,80,79,74,80,71,82,70,84,70,85,71,86,74,86,77,85,82,82,91,80,97,79,100,78,102,76,103,75,102,75,100,76,97,78,94,80,92,83,90,87,88,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,94,73,94,71,93,70,92,70,90,71,88,73,86,76,84,78,82,79,80,79,32,82,79,83,81,83,88,84,90,85,91,86,91,88,90,89,89,91,86,0,73,92,77,82,79,82,83,81,86,79,88,77,89,75,89,72,88,70,86,70,85,71,84,73,83,78,82,83,81,86,80,88,78,90,76,91,74,91,73,90,73,88,74,87,76,87,78,88,81,90,84,91,86,91,89,90,91,88,0,64,97,69,77,67,76,66,74,66,73,67,71,69,70,70,70,72,71,73,73,73,75,72,80,71,84,69,91,32,71,84,74,76,76,72,77,71,79,70,80,70,82,71,83,73,83,75,82,80,81,84,79,91,32,81,84,84,76,86,72,87,71,89,70,90,70,92,71,93,73,93,75,92,80,90,87,90,90,91,91,92,91,94,90,95,89,97,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,80,76,84,74,91,32,76,84,79,76,81,72,82,71,84,70,86,70,88,71,89,73,89,75,88,80,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,72,93,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,86,70,84,70,82,72,82,75,83,78,85,81,87,83,90,85,92,86,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,90,70,92,71,93,72,94,74,94,77,93,79,92,80,90,81,87,81,85,80,84,79,0,72,94,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,89,90,91,88,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,89,70,91,71,92,72,93,74,93,77,92,79,91,80,89,81,86,81,83,80,84,81,85,83,85,88,86,90,88,91,90,90,91,89,93,86,0,72,92,72,91,74,90,76,88,79,84,81,81,83,77,84,74,84,71,83,70,82,70,81,71,80,73,80,75,81,77,83,79,86,81,88,83,89,85,89,87,88,89,87,90,84,91,80,91,77,90,75,88,74,86,74,84,0,72,91,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,79,76,82,75,86,75,88,76,90,78,91,80,91,82,90,83,89,85,85,88,77,90,70,32,88,77,87,81,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,89,77,91,79,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,75,87,78,89,80,91,81,0,67,95,72,77,70,76,69,74,69,73,70,71,72,70,73,70,75,71,76,73,76,76,75,91,32,85,70,75,91,32,85,70,83,91,32,97,70,95,71,92,74,89,78,86,84,83,91,0,70,94,78,76,76,76,75,75,75,73,76,71,78,70,80,70,82,71,83,73,83,76,81,85,81,88,82,90,84,91,86,91,88,90,89,88,89,86,88,85,86,85,32,93,73,93,71,92,70,90,70,88,71,86,73,84,76,80,85,78,88,76,90,74,91,72,91,71,90,71,88,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,88,77,90,78,91,80,91,82,90,84,88,86,85,87,83,89,77,32,91,70,89,77,86,87,84,93,82,98,80,102,78,103,77,102,77,100,78,97,80,94,83,91,86,89,91,86,0,72,93,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,84,84,87,80,90,78,91,75,91,74,90,74,88,75,87,78,87,80,88,81,89,82,91,82,94,81,97,80,99,78,102,76,103,75,102,75,100,76,97,78,94,81,91,84,89,90,86,0,73,91,74,70,82,91,32,90,70,82,91,32,74,70,90,70,0,71,93,73,76,91,98,0,69,95,82,74,73,90,32,82,74,91,90,0,73,91,74,91,90,91,0,73,91,74,91,90,91,90,90,74,90,74,91,0,73,92,88,77,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,72,91,76,70,76,91,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,88,70,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,77,89,87,70,85,70,83,71,82,74,82,91,32,79,77,86,77,0,73,92,88,77,88,93,87,96,86,97,84,98,81,98,79,97,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,78,86,81,70,82,71,83,70,82,69,81,70,32,82,77,82,91,0,77,87,82,70,83,71,84,70,83,69,82,70,32,83,77,83,94,82,97,80,98,78,98,0,73,90,77,70,77,91,32,87,77,77,87,32,81,83,88,91,0,67,97,71,77,71,91,32,71,81,74,78,76,77,79,77,81,78,82,81,82,91,32,82,81,85,78,87,77,90,77,92,78,93,81,93,91,0,73,92,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,0,72,91,76,77,76,98,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,92,88,77,88,98,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,75,88,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,89,82,70,82,87,83,90,85,91,87,91,32,79,77,86,77,0,73,92,77,77,77,87,78,90,80,91,83,91,85,90,88,87,32,88,77,88,91,0,74,90,76,77,82,91,32,88,77,82,91,0,71,93,74,77,78,91,32,82,77,78,91,32,82,77,86,91,32,90,77,86,91,0,74,91,77,77,88,91,32,88,77,77,91,0,74,90,76,77,82,91,32,88,77,82,91,80,95,78,97,76,98,75,98,0,74,91,88,77,77,91,32,77,77,88,77,32,77,91,88,91,0,72,93,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,83,77,84,78,85,80,87,88,88,90,89,91,90,91,0,73,92,85,70,83,71,81,73,79,77,78,80,77,84,76,90,75,98,32,85,70,87,70,89,72,89,75,88,77,87,78,85,79,82,79,32,82,79,84,80,86,82,87,84,87,87,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,73,92,74,80,76,78,78,77,79,77,81,78,82,79,83,82,83,86,82,91,32,90,77,89,80,88,82,82,91,80,95,79,98,0,73,91,84,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,84,77,82,75,81,73,81,71,82,70,84,70,86,71,88,73,0,74,90,87,79,86,78,84,77,81,77,79,78,79,80,80,82,83,83,32,83,83,79,84,77,86,77,88,78,90,80,91,83,91,85,90,87,88,0,74,89,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,88,75,84,77,81,79,78,82,77,85,77,87,78,89,80,91,83,93,84,95,84,97,83,98,81,98,80,96,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,78,84,76,91,32,78,84,80,80,82,78,84,77,86,77,88,79,88,82,87,87,84,98,0,71,92,72,81,73,79,75,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,74,87,71,85,70,83,70,82,72,82,74,83,77,85,80,87,82,90,84,0,76,87,82,77,80,84,79,88,79,90,80,91,82,91,84,89,85,87,0,73,91,79,77,75,91,32,89,78,88,77,87,77,85,78,81,82,79,83,78,83,32,78,83,80,84,81,85,83,90,84,91,85,91,86,90,0,74,90,75,70,77,70,79,71,80,72,88,91,32,82,77,76,91,0,72,93,79,77,73,98,32,78,81,77,86,77,89,79,91,81,91,83,90,85,88,87,84,32,89,77,87,84,86,88,86,90,87,91,89,91,91,89,92,87,0,73,91,76,77,79,77,78,83,77,88,76,91,32,89,77,88,80,87,82,85,85,82,88,79,90,76,91,0,74,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,82,76,80,77,79,79,79,81,81,83,84,84,86,84,32,84,84,80,85,78,86,77,88,77,90,79,92,83,94,84,95,84,97,82,98,80,98,0,74,91,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,0,71,93,80,77,76,91,32,85,77,86,83,87,88,88,91,32,73,80,75,78,78,77,91,77,0,73,91,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,80,78,78,80,77,83,73,98,0,73,93,91,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,85,78,83,77,0,72,92,83,77,80,91,32,74,80,76,78,79,77,90,77,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,77,86,77,89,79,91,81,91,84,90,86,88,88,84,89,80,89,77,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,0,73,91,75,77,77,77,79,79,85,96,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,86,70,78,98,32,71,81,72,79,74,77,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,84,90,86,88,88,85,90,80,91,77,0,70,93,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,32,82,83,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,84,78,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,89,87,91,86,0,77,88,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,90,70,32,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,78,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,85,78,88,79,90,81,91,83,91,85,90,86,89,88,86,0,79,87,79,86,83,81,85,78,86,76,87,73,87,71,86,70,84,71,83,73,81,81,78,90,75,97,74,100,74,102,75,103,77,102,78,99,79,90,80,91,82,91,84,90,85,89,87,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,32,86,82,84,89,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,77,92,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,80,88,80,90,81,91,82,91,84,90,85,89,87,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,76,100,75,102,73,103,72,102,72,100,73,97,76,94,79,92,81,91,84,89,87,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,84,86,81,86,32,81,86,83,87,84,90,85,91,86,91,88,90,89,89,91,86,0,79,87,79,86,81,83,84,78,85,76,86,73,86,71,85,70,83,71,82,73,81,77,80,84,80,90,81,91,82,91,84,90,85,89,87,86,0,69,94,69,86,71,83,73,82,74,83,74,84,73,88,72,91,32,73,88,74,86,76,83,78,82,80,82,81,83,81,84,80,88,79,91,32,80,88,81,86,83,83,85,82,87,82,88,83,88,85,87,88,87,90,88,91,89,91,91,90,92,89,94,86,0,74,92,74,86,76,83,78,82,79,83,79,84,78,88,77,91,32,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,76,90,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,87,88,89,87,90,86,0,75,90,75,86,77,83,78,81,77,85,71,103,32,77,85,78,83,80,82,82,82,84,83,85,85,85,87,84,89,83,90,81,91,32,77,90,79,91,82,91,85,90,87,89,90,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,86,82,85,85,83,90,80,97,79,100,79,102,80,103,82,102,83,99,83,92,85,91,88,89,91,86,0,77,90,77,86,79,83,80,81,80,83,83,83,84,84,84,86,83,89,83,90,84,91,85,91,87,90,88,89,90,86,0,78,89,78,86,80,83,81,81,81,83,83,86,84,88,84,90,82,91,32,78,90,80,91,84,91,86,90,87,89,89,86,0,79,88,79,86,81,83,83,79,32,86,70,80,88,80,90,81,91,83,91,85,90,86,89,88,86,32,80,78,87,78,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,84,88,84,90,85,91,86,91,88,90,89,89,91,86,0,76,91,76,86,78,82,77,87,77,90,78,91,79,91,82,90,84,88,85,85,85,82,32,85,82,86,86,87,87,89,87,91,86,0,73,94,76,82,74,84,73,87,73,89,74,91,76,91,78,90,80,88,32,82,82,80,88,80,90,81,91,83,91,85,90,87,88,88,85,88,82,32,88,82,89,86,90,87,92,87,94,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,90,82,91,85,91,88,89,90,86,32,87,83,86,82,84,82,83,83,79,90,78,91,76,91,75,90,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,76,90,76,86,78,83,80,82,82,82,84,84,84,86,83,88,81,90,78,91,80,92,81,94,81,97,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,87,89,90,86,0,74,92,75,91,78,90,81,88,83,86,85,83,87,79,88,75,88,73,87,71,85,70,83,71,82,72,81,74,80,79,80,84,81,88,82,90,84,91,86,91,88,90,89,89,0,73,91,87,85,87,82,86,79,85,78,83,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,88,80,88,75,87,72,86,71,84,70,82,70,80,71,78,73,0,74,90,87,78,85,77,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,84,91,86,90,32,77,84,85,84,0,74,91,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,84,70,32,78,80,87,80,0,72,92,86,70,78,98,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,82,88,80,86,78,83,77,81,77,0,73,91,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,84,92,84,94,83,95,81,95,0,68,97,87,78,86,76,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,86,85,87,83,32,87,75,87,83,88,85,89,86,91,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,0,70,94,90,73,74,82,90,91,0,70,94,74,73,90,82,74,91,0,75,89,79,66,79,98,32,79,66,86,66,32,79,98,86,98,0,75,89,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,75,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,0,75,89,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,0,74,90,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,0,72,92,78,74,80,73,83,70,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,75,91,89,91,0,72,92,77,70,88,70,82,78,85,78,87,79,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,85,70,75,84,90,84,32,85,70,85,91,0,72,92,87,70,77,70,76,79,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,0,72,92,89,70,79,91,32,75,70,89,70,0,72,92,80,70,77,71,76,73,76,75,77,77,79,78,83,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,81,79,85,78,87,77,88,75,88,73,87,71,84,70,80,70,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,0,77,87,82,89,81,90,82,91,83,90,82,89,0,77,87,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,89,81,90,82,91,83,90,82,89,0,77,87,82,77,81,78,82,79,83,78,82,77,32,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,82,84,32,82,89,81,90,82,91,83,90,82,89,0,73,91,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,82,77,0,74,90,78,70,78,77,32,86,70,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,0,72,92,80,66,80,95,32,84,66,84,95,32,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,71,93,91,66,73,98,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,0,78,86,82,66,82,98,0,69,95,73,82,91,82,0,69,95,82,73,82,91,32,73,82,91,82,0,69,95,73,79,91,79,32,73,85,91,85,0,71,93,75,75,89,89,32,89,75,75,89,0,74,90,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,77,87,82,81,81,82,82,83,83,82,82,81,0,77,87,83,70,82,71,81,73,81,75,82,76,83,75,82,74,0,77,87,82,72,81,71,82,70,83,71,83,73,82,75,81,76,0,69,95,85,77,88,80,91,82,88,84,85,87,32,73,82,91,82,0,71,93,79,70,79,98,32,85,70,85,98,32,74,81,90,81,32,74,87,90,87,0,69,95,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,89,72,87,72,85,73,83,74,82,81,78,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,89,91,91,91,92,90,92,89,0,71,93,73,73,74,75,75,79,75,85,74,89,73,91,32,91,73,90,75,89,79,89,85,90,89,91,91,32,73,73,75,74,79,75,85,75,89,74,91,73,32,73,91,75,90,79,89,85,89,89,90,91,91,0,70,95,92,81,91,79,89,78,87,78,85,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,85,85,87,86,89,86,91,85,92,83,92,81,0,75,89,79,66,79,91,32,85,66,85,91,0,70,94,82,66,82,91,32,73,91,91,91,0,70,94],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+296960);allocate([91,66,73,91,91,91,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,89,72,90,73,91,74,90,73,89,32,91,89,90,90,91,91,92,90,91,89,0,70,94,82,72,78,76,75,80,74,83,74,85,75,87,77,88,79,88,81,87,82,85,32,82,72,86,76,89,80,90,83,90,85,89,87,87,88,85,88,83,87,82,85,32,82,85,81,89,80,92,32,82,85,83,89,84,92,32,80,92,84,92,0,70,94,82,78,81,75,80,73,78,72,77,72,75,73,74,75,74,79,75,82,76,84,78,87,82,92,32,82,78,83,75,84,73,86,72,87,72,89,73,90,75,90,79,89,82,88,84,86,87,82,92,0,70,94,82,71,80,74,76,79,73,82,32,82,71,84,74,88,79,91,82,32,73,82,76,85,80,90,82,93,32,91,82,88,85,84,90,82,93,0,70,94,82,84,84,87,86,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,83,81,32,83,81,85,79,86,77,86,75,85,73,83,72,81,72,79,73,78,75,78,77,79,79,81,81,32,81,81,78,80,76,80,74,81,73,83,73,85,74,87,76,88,78,88,80,87,82,84,32,82,84,81,89,80,92,32,82,84,83,89,84,92,32,80,92,84,92,0,70,94,82,82,82,91,81,92,32,82,86,81,92,32,82,73,81,72,79,72,78,73,78,75,79,78,82,82,32,82,73,83,72,85,72,86,73,86,75,85,78,82,82,32,82,82,78,79,76,78,74,78,73,79,73,81,74,82,32,82,82,86,79,88,78,90,78,91,79,91,81,90,82,32,82,82,78,85,76,86,74,86,73,85,73,83,74,82,32,82,82,86,85,88,86,90,86,91,85,91,83,90,82,0,70,94,73,83,74,83,76,84,77,86,77,88,76,90,32,73,83,73,82,74,81,76,81,77,82,78,84,78,87,77,89,76,90,32,82,71,80,73,79,76,79,79,81,85,81,88,80,90,82,92,32,82,71,84,73,85,76,85,79,83,85,83,88,84,90,82,92,32,91,83,91,82,90,81,88,81,87,82,86,84,86,87,87,89,88,90,32,91,83,90,83,88,84,87,86,87,88,88,90,32,75,86,89,86,0,80,83,83,82,82,83,81,83,80,82,80,81,81,80,82,80,83,81,83,83,82,85,81,86,32,81,81,81,82,82,82,82,81,81,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,78,86,80,79,84,85,32,84,79,80,85,32,78,82,86,82,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,32,82,77,79,81,32,82,77,85,81,32,82,79,80,81,32,82,79,84,81,32,81,81,83,81,32,77,82,87,82,0,77,87,77,82,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,82,32,80,78,84,78,32,79,79,85,79,32,78,80,86,80,32,78,81,86,81,32,77,82,87,82,0,76,82,76,70,76,82,82,82,76,70,32,76,73,80,81,32,76,76,79,82,32,76,79,77,81,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,0,77,87,87,82,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,82,0,71,93,93,82,93,80,92,77,90,74,87,72,84,71,80,71,77,72,74,74,72,77,71,80,71,82,0,77,87,77,82,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,82,0,76,88,76,80,78,82,81,83,83,83,86,82,88,80,0,82,85,82,85,84,84,85,82,84,80,82,79,0,82,86,82,82,85,80,86,78,86,76,85,75,84,75,0,78,82,82,82,79,80,78,78,78,76,79,75,80,75,0,77,87,87,72,86,71,84,70,81,70,79,71,78,72,77,74,77,76,78,78,79,79,85,83,86,84,87,86,87,88,86,90,85,91,83,92,80,92,78,91,77,90,0,71,93,73,87,72,86,71,84,71,81,72,79,73,78,75,77,77,77,79,78,80,79,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,80,92,78,91,77,0,71,93,82,82,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,81,92,79,91,78,89,77,87,77,85,78,84,79,80,85,79,86,77,87,75,87,73,86,72,85,71,83,71,81,72,79,73,78,75,77,77,77,79,78,80,79,82,82,0,72,92,75,70,75,91,32,72,70,91,70,81,80,91,90,32,90,86,91,89,92,91,32,90,86,90,89,32,87,89,90,89,32,87,89,90,90,92,91,0,75,89,85,65,82,66,80,67,78,69,76,72,75,76,75,82,76,85,78,87,81,88,83,88,86,87,88,85,89,82,32,75,80,76,77,78,75,81,74,83,74,86,75,88,77,89,80,89,86,88,90,86,93,84,95,82,96,79,97,0,62,102,62,82,102,82,0,68,96,68,96,96,68,0,82,82,82,62,82,102,0,68,96,68,68,96,96,0,68,96,68,82,96,82,0,70,94,70,89,94,75,0,75,89,75,94,89,70,0,75,89,75,70,89,94,0,70,94,70,75,94,89,0,75,89,75,82,89,82,0,77,87,77,87,87,77,0,77,87,77,77,87,87,0,68,96,68,79,71,81,75,83,80,84,84,84,89,83,93,81,96,79,0,80,85,85,68,83,71,81,75,80,80,80,84,81,89,83,93,85,96,0,79,84,79,68,81,71,83,75,84,80,84,84,83,89,81,93,79,96,0,68,96,68,85,71,83,75,81,80,80,84,80,89,81,93,83,96,85,0,75,89,82,74,89,78,75,86,82,90,0,74,90,74,82,78,75,86,89,90,82,0,75,89,75,86,75,78,89,86,89,78,0,74,90,76,88,74,80,90,84,88,76,0,74,90,74,93,76,93,79,92,81,91,84,88,85,86,86,83,86,79,85,76,84,74,83,73,81,73,80,74,79,76,78,79,78,83,79,86,80,88,83,91,85,92,88,93,90,93,0,73,93,93,90,93,88,92,85,91,83,88,80,86,79,83,78,79,78,76,79,74,80,73,81,73,83,74,84,76,85,79,86,83,86,86,85,88,84,91,81,92,79,93,76,93,74,0,74,90,90,71,88,71,85,72,83,73,80,76,79,78,78,81,78,85,79,88,80,90,81,91,83,91,84,90,85,88,86,85,86,81,85,78,84,76,81,73,79,72,76,71,74,71,0,71,91,71,74,71,76,72,79,73,81,76,84,78,85,81,86,85,86,88,85,90,84,91,83,91,81,90,80,88,79,85,78,81,78,78,79,76,80,73,83,72,85,71,88,71,90,0,69,91,69,80,70,82,72,84,74,85,77,86,81,86,85,85,88,83,90,80,91,78,90,76,87,76,83,77,81,78,78,80,76,83,75,86,75,89,76,92,77,94,0,69,89,69,84,72,86,75,87,80,87,83,86,86,84,88,81,89,78,89,76,88,75,86,75,83,76,80,78,78,81,77,84,77,89,78,92,80,95,0,79,85,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,68,96,68,82,74,82,32,79,82,85,82,32,90,82,96,82,0,68,96,68,85,68,79,96,79,96,85,0,74,90,82,68,74,82,32,82,68,90,82,0,68,96,68,82,96,82,32,74,89,90,89,32,80,96,84,96,0,68,96,68,82,96,82,32,68,82,82,98,32,96,82,82,98,0,75,89,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,76,88,76,76,76,88,88,88,88,76,76,76,0,75,89,82,74,75,86,89,86,82,74,0,76,88,82,72,76,82,82,92,88,82,82,72,0,74,90,82,73,80,79,74,79,79,83,77,89,82,85,87,89,85,83,90,79,84,79,82,73,0,75,89,82,75,82,89,32,75,82,89,82,0,77,87,77,77,87,87,32,87,77,77,87,0,77,87,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,32,79,81,79,83,32,80,80,80,84,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,80,84,84,32,85,81,85,83,0,78,86,78,78,78,86,86,86,86,78,78,78,32,79,79,79,85,32,80,79,80,85,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,79,84,85,32,85,79,85,85,0,77,87,82,76,77,85,87,85,82,76,32,82,79,79,84,32,82,79,85,84,32,82,82,81,84,32,82,82,83,84,0,76,85,76,82,85,87,85,77,76,82,32,79,82,84,85,32,79,82,84,79,32,82,82,84,83,32,82,82,84,81,0,77,87,82,88,87,79,77,79,82,88,32,82,85,85,80,32,82,85,79,80,32,82,82,83,80,32,82,82,81,80,0,79,88,88,82,79,77,79,87,88,82,32,85,82,80,79,32,85,82,80,85,32,82,82,80,81,32,82,82,80,83,0,76,88,82,76,78,87,88,80,76,80,86,87,82,76,32,82,82,82,76,32,82,82,76,80,32,82,82,78,87,32,82,82,86,87,32,82,82,88,80,0,77,87,82,76,82,88,32,79,79,85,79,32,77,85,79,87,81,88,83,88,85,87,87,85,0,76,88,82,76,82,88,32,76,81,77,79,87,79,88,81,32,80,87,84,87,0,75,89,77,78,87,88,32,87,78,77,88,32,79,76,76,79,75,81,32,85,76,88,79,89,81,0,73,91,78,73,73,91,32,86,73,91,91,32,77,77,91,91,32,87,77,73,91,32,78,73,86,73,32,77,77,87,77,0,73,91,82,71,82,86,32,77,74,87,80,32,87,74,77,80,32,73,86,76,92,32,91,86,88,92,32,73,86,91,86,32,76,92,88,92,0,71,91,77,74,83,86,32,75,80,83,76,32,71,92,91,92,91,82,71,92,0,76,88,80,76,80,80,76,80,76,84,80,84,80,88,84,88,84,84,88,84,88,80,84,80,84,76,80,76,0,75,89,89,80,88,78,86,76,83,75,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,84,32,89,80,87,78,85,77,83,77,81,78,80,79,79,81,79,83,80,85,81,86,83,87,85,87,87,86,89,84,0,75,89,82,74,75,86,89,86,82,74,32,82,90,89,78,75,78,82,90,0,71,93,80,73,80,71,81,70,83,70,84,71,84,73,32,71,90,72,88,74,86,75,84,76,80,76,75,77,74,79,73,85,73,87,74,88,75,88,80,89,84,90,86,92,88,93,90,32,71,90,93,90,32,81,90,80,91,81,92,83,92,84,91,83,90,0,74,90,82,77,82,83,32,82,83,81,92,32,82,83,83,92,32,81,92,83,92,32,82,77,81,74,80,72,78,71,32,81,74,78,71,32,82,77,83,74,84,72,86,71,32,83,74,86,71,32,82,77,78,75,76,75,74,77,32,80,76,76,76,74,77,32,82,77,86,75,88,75,90,77,32,84,76,88,76,90,77,32,82,77,80,78,79,79,79,82,32,82,77,80,79,79,82,32,82,77,84,78,85,79,85,82,32,82,77,84,79,85,82,0,74,90,82,73,82,75,32,82,78,82,80,32,82,83,82,85,32,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,71,81,73,80,74,32,82,71,83,73,84,74,32,80,74,82,73,84,74,32,82,75,80,78,78,79,77,78,32,82,75,84,78,86,79,87,78,32,78,79,80,79,82,78,84,79,86,79,32,82,80,80,83,78,84,76,84,75,82,75,83,76,84,32,82,80,84,83,86,84,88,84,89,82,89,83,88,84,32,78,84,80,84,82,83,84,84,86,84,32,82,85,80,88,79,89,77,90,76,90,75,89,74,87,74,89,76,90,32,82,85,84,88,85,89,87,90,88,90,89,89,90,87,90,89,88,90,32,77,90,79,90,82,89,85,90,87,90,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,85,90,88,90,90,88,90,85,89,84,87,84,89,82,90,79,89,77,87,76,85,77,86,74,85,72,83,71,81,71,79,72,78,74,79,77,77,76,75,77,74,79,75,82,77,84,75,84,74,85,74,88,76,90,79,90,82,89,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,86,88,86,86,88,85,88,82,90,81,90,76,89,73,88,72,86,72,84,71,80,71,78,72,76,72,75,73,74,76,74,81,76,82,76,85,78,86,78,88,82,89,0,73,91,73,80,75,82,32,76,75,78,80,32,82,71,82,79,32,88,75,86,80,32,91,80,89,82,0,81,83,82,81,81,82,82,83,83,82,82,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,77,87,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,0,71,93,80,71,77,72,74,74,72,77,71,80,71,84,72,87,74,90,77,92,80,93,84,93,87,92,90,90,92,87,93,84,93,80,92,77,90,74,87,72,84,71,80,71,0,65,99,80,65,76,66,74,67,71,69,69,71,67,74,66,76,65,80,65,84,66,88,67,90,69,93,71,95,74,97,76,98,80,99,84,99,88,98,90,97,93,95,95,93,97,90,98,88,99,84,99,80,98,76,97,74,95,71,93,69,90,67,88,66,84,65,80,65,0,60,104,80,60,75,61,71,63,68,65,65,68,63,71,61,75,60,80,60,84,61,89,63,93,65,96,68,99,71,101,75,103,80,104,84,104,89,103,93,101,96,99,99,96,101,93,103,89,104,84,104,80,103,75,101,71,99,68,96,65,93,63,89,61,84,60,80,60,0,41,123,79,41,73,42,69,43,64,45,59,48,55,51,51,55,48,59,45,64,43,69,42,73,41,79,41,85,42,91,43,95,45,100,48,105,51,109,55,113,59,116,64,119,69,121,73,122,79,123,85,123,91,122,95,121,100,119,105,116,109,113,113,109,116,105,119,100,121,95,122,91,123,85,123,79,122,73,121,69,119,64,116,59,113,55,109,51,105,48,100,45,95,43,91,42,85,41,79,41,0,62,102,82,65,80,67,77,68,74,68,71,67,69,65,62,72,64,74,65,77,65,90,66,93,68,95,71,96,77,96,80,97,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,102,72,100,74,99,77,99,90,98,93,96,95,93,96,87,96,84,97,82,99,0,65,99,82,65,80,67,77,68,74,68,71,67,69,65,66,71,65,75,65,80,66,84,68,88,71,92,76,96,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,98,71,99,75,99,80,98,84,96,88,93,92,88,96,82,99,32,66,72,98,72,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,76,98,88,70,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,79,84,84,84,32,75,88,80,88,32,84,88,89,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,86,80,83,81,32,83,75,85,76,86,78,85,80,83,81,32,79,81,83,81,86,82,87,84,87,85,86,87,83,88,76,88,32,83,81,85,82,86,84,86,85,85,87,83,88,0,75,89,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,85,32,81,75,79,77,78,80,78,83,79,86,81,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,77,88,80,88,83,87,86,86,87,83,88,76,88,32,83,75,85,76,86,77,87,80,87,83,86,86,85,87,83,88,0,74,89,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,86,88,86,84,85,88,0,74,88,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,81,88,0,75,91,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,85,87,86,85,32,86,83,86,88,32,87,83,87,88,32,84,83,89,83,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,81,75,32,84,75,89,75,32,79,81,86,81,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,85,75,32,80,88,85,88,0,76,88,83,75,83,85,82,87,81,88,32,84,75,84,85,83,87,81,88,80,88,78,87,77,85,78,84,79,85,78,86,32,81,75,86,75,0,74,90,78,75,78,88,32,79,75,79,88,32,87,75,79,83,32,81,81,86,88,32,82,81,87,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,82,75,32,77,88,87,88,87,84,86,88,0,73,92,77,75,77,88,32,78,78,82,88,32,78,75,82,85,32,87,75,82,88,32,87,75,87,88,32,88,75,88,88,32,75,75,78,75,32,87,75,90,75,32,75,88,79,88,32,85,88,90,88,0,74,90,78,75,78,88,32,79,77,86,88,32,79,75,86,86,32,86,75,86,88,32,76,75,79,75,32,84,75,88,75,32,76,88,80,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,80,87,80,85,81,84,83,84,84,85,85,90,86,91,87,91,88,90,32,84,85,85,88,86,90,87,91,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,32,83,82,84,83,85,87,86,88,87,88,88,87,32,83,82,85,83,86,87,87,88,0,75,90,86,77,87,75,87,79,86,77,85,76,83,75,81,75,79,76,78,77,78,79,79,80,81,81,84,82,86,83,87,84,32,78,78,79,79,81,80,84,81,86,82,87,83,87,86,86,87,84,88,82,88,80,87,79,86,78,84,78,88,79,86,0,75,90,82,75,82,88,32,83,75,83,88,32,78,75,77,79,77,75,88,75,88,79,87,75,32,80,88,85,88,0,74,91,78,75,78,85,79,87,81,88,84,88,86,87,87,85,87,75,32,79,75,79,85,80,87,81,88,32,76,75,81,75,32,85,75,89,75,0,75,89,77,75,82,88,32,78,75,82,85,32,87,75,82,88,32,75,75,80,75,32,84,75,89,75,0,73,91,76,75,79,88,32,77,75,79,84,32,82,75,79,88,32,82,75,85,88,32,83,75,85,84,32,88,75,85,88,32,74,75,79,75,32,86,75,90,75,0,75,90,78,75,86,88,32,79,75,87,88,32,87,75,78,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,76,89,78,75,82,82,82,88,32,79,75,83,82,32,87,75,83,82,83,88,32,76,75,81,75,32,84,75,89,75,32,80,88,85,88,0,76,89,86,75,78,88,32,87,75,79,88,32,79,75,78,79,78,75,87,75,32,78,88,87,88,87,84,86,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,87,75,87,79,86,75,32,77,88,82,88,0,75,89,82,75,76,88,32,82,77,87,88,32,82,75,88,88,32,77,87,86,87,32,76,88,88,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,81,79,81,84,32,84,79,84,84,32,81,81,84,81,32,81,82,84,82,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,75,88,80,88,32,84,88,89,88,0,74,90,77,74,76,77,32,88,74,87,77,32,80,80,79,83,32,85,80,84,83,32,77,86,76,89,32,88,86,87,89,32,77,75,87,75,32,77,76,87,76,32,80,81,84,81,32,80,82,84,82,32,77,87,87,87,32,77,88,87,88,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,91,77,75,82,81,32,78,75,83,81,77,88,32,77,75,87,75,88,79,86,75,32,78,87,87,87,32,77,88,87,88,88,84,86,88,0,75,90,77,79,78,76,79,75,80,75,81,76,82,79,82,88,32,88,79,87,76,86,75,85,75,84,76,83,79,83,88,32,77,79,78,77,79,76,80,76,81,77,82,79,32,88,79,87,77,86,76,85,76,84,77,83,79,32,80,88,85,88,0,75,90,82,75,82,88,32,83,75,83,88,32,81,78,78,79,77,81,77,82,78,84,81,85,84,85,87,84,88,82,88,81,87,79,84,78,81,78,32,81,78,79,79,78,81,78,82,79,84,81,85,32,84,85,86,84,87,82,87,81,86,79,84,78,32,80,75,85,75,32,80,88,85,88,0,74,91,82,75,82,88,32,83,75,83,88,32,76,80,77,79,78,79,79,83,81,85,32,84,85,86,83,87,79,88,79,89,80,32,77,79,78,82,79,84,81,85,84,85,86,84,87,82,88,79,32,80,75,85,75,32,80,88,85,88,0,75,90,77,86,78,88,81,88,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,84,88,87,88,88,86,32,79,85,78,82,78,79,79,77,81,75,32,84,75,86,77,87,79,87,82,86,85,32,78,87,80,87,32,85,87,87,87,0,75,89,84,75,75,88,32,83,77,84,88,32,84,75,85,88,32,78,84,84,84,32,73,88,78,88,32,82,88,87,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,87,78,86,80,83,81,32,85,75,86,76,86,78,85,80,83,81,32,79,81,82,81,84,82,85,83,85,85,84,87,81,88,74,88,32,82,81,84,83,84,85,83,87,81,88,0,75,88,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,82,75,80,77,79,79,78,82,78,86,80,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,84,75,86,76,87,78,87,81,86,84,85,86,84,87,81,88,74,88,32,84,75,85,76,86,78,86,81,85,84,84,86,83,87,81,88,0,74,89,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,84,88,85,85,83,88,0,74,88,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,79,88,0,75,89,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,83,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,83,32,83,83,88,83,0,74,91,80,75,76,88,32,81,75,77,88,32,88,75,84,88,32,89,75,85,88,32,78,75,83,75,32,86,75,91,75,32,79,81,86,81,32,74,88,79,88,32,82,88,87,88,0,78,87,84,75,80,88,32,85,75,81,88,32,82,75,87,75,32,78,88,83,88,0,76,88,85,75,82,85,81,87,80,88,32,86,75,83,85,82,87,80,88,79,88,77,87,76,85,77,84,78,85,77,86,32,83,75,88,75,0,74,90,80,75,76,88,32,81,75,77,88,32,89,75,79,82,32,82,80,84,88,32,83,80,85,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,75,88,81,75,77,88,32,82,75,78,88,32,79,75,84,75,32,75,88,85,88,86,85,84,88,0,73,92,79,75,75,88,32,79,77,80,88,32,80,75,81,86,32,89,75,80,88,32,89,75,85,88,32,90,75,86,88,32,77,75,80,75,32,89,75,92,75,32,73,88,77,88,32,83,88,88,88,0,74,90,80,75,76,88,32,80,75,84,88,32,81,75,84,85,32,88,75,84,88,32,78,75,81,75,32,86,75,90,75,32,74,88,78,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,74,88,79,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,32,79,87,79,86,80,85,81,85,82,86,82,90,83,91,84,91,85,90,32,82,86,83,90,84,91,0,74,90,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,83,82,84,87,85,88,86,88,87,87,32,83,82,84,83,85,87,86,88,32,74,88,79,88,0,75,90,87,76,88,76,89,75,88,78,87,76,85,75,82,75,80,76,79,77,79,79,80,80,85,83,86,84,32,79,78,80,79,85,82,86,83,86,86,85,87,83,88,80,88,78,87,77,85,76,88,77,87,78,87,0,75,90,84,75,80,88,32,85,75,81,88,32,80,75,78,78,79,75,90,75,89,78,89,75,32,78,88,83,88,0,74,91,80,75,77,85,77,87,79,88,83,88,85,87,86,85,89,75,32,81,75,78,85,78,87,79,88,32,78,75,83,75,32,87,75,91,75,0,75,89,79,75,80,88,32,80,75,81,86,32,89,75,80,88,32,77,75,82,75,32,86,75,91,75,0,73,91,78,75,77,88,32,79,75,78,86,32,84,75,77,88,32,84,75,83,88,32,85,75,84,86,32,90,75,83,88,32,76,75,81,75,32,88,75,92,75,0,75,90,80,75,84,88,32,81,75,85,88,32,89,75,76,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,76,89,80,75,82,81,80,88,32,81,75,83,81,32,89,75,83,81,81,88,32,78,75,83,75,32,86,75,91,75,32,78,88,83,88,0,76,89,88,75,76,88,32,89,75,77,88,32,81,75,79,78,80,75,89,75,32,76,88,85,88,86,85,84,88,0,75,90,77,72,88,92,0,74,90,82,77,76,87,32,82,77,88,87,0,76,90,81,79,80,80,80,81,79,81,79,80,81,79,84,79,86,81,86,87,87,88,88,88,32,84,79,85,81,85,87,87,88,32,85,82,82,83,80,84,79,85,79,87,80,88,83,88,84,87,85,85,32,82,83,80,85,80,87,81,88,0,74,89,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,75,79,75,0,76,88,86,81,85,81,85,82,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,91,86,75,86,88,32,87,75,87,88,32,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,85,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,75,87,75,32,86,88,89,88,0,76,88,79,83,86,83,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,85,83,85,81,83,79,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,87,84,75,85,76,85,77,86,77,86,76,84,75,82,75,80,77,80,88,32,82,75,81,77,81,88,32,78,79,83,79,32,78,88,83,88,0,76,89,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,79,80,81,80,83,81,85,32,83,85,84,83,84,81,83,79,32,84,80,85,79,86,79,32,80,84,79,85,79,88,80,89,84,89,86,90,32,79,87,80,88,84,88,86,89,86,91,84,92,80,92,78,91,78,89,80,88,0,74,91,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,75,79,75,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,76,83,76,83,75,82,75,32,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,78,87,83,75,83,76,84,76,84,75,83,75,32,83,79,83,90,82,92,32,84,79,84,90,82,92,80,92,79,91,79,90,80,90,80,91,79,91,32,81,79,84,79,0,74,90,78,75,78,88,32,79,75,79,88,32,87,79,79,85,32,82,83,86,88,32,83,83,87,88,32,76,75,79,75,32,84,79,89,79,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,83,75,32,80,88,85,88,0,70,95,74,79,74,88,32,75,79,75,88,32,75,82,76,80,78,79,80,79,82,80,83,82,83,88,32,80,79,81,80,82,82,82,88,32,83,82,84,80,86,79,88,79,90,80,91,82,91,88,32,88,79,89,80,90,82,90,88,32,72,79,75,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,74,91,78,79,78,88,32,79,79,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,79,79,79,32,76,88,81,88,32,84,88,89,88,0,76,89,81,79,79,80,78,82,78,85,79,87,81,88,84,88,86,87,87,85,87,82,86,80,84,79,81,79,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,88,85,87,86,85,86,82,85,80,84,79,0,74,89,78,79,78,92,32,79,79,79,92,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,79,79,79,32,76,92,81,92,0,75,89,85,79,85,92,32,86,79,86,92,32,85,82,84,80,82,79,80,79,78,80,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,80,79,79,80,78,82,78,85,79,87,80,88,32,83,92,88,92,0,75,88,79,79,79,88,32,80,79,80,88,32,80,82,81,80,83,79,85,79,86,80,86,81,85,81,85,80,86,80,32,77,79,80,79,32,77,88,82,88,0,76,89,84,79,85,80,85,81,86,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,79,86,80,86,80,87,81,88,0,76,87,80,75,80,86,82,88,84,88,85,87,85,86,32,81,75,81,86,82,88,32,78,79,84,79,0,74,91,78,79,78,85,79,87,81,88,83,88,85,87,86,85,32,79,79,79,85,80,87,81,88,32,86,79,86,88,32,87,79,87,88,32,76,79,79,79,32,84,79,87,79,32,86,88,89,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,32,76,79,81,79,32,84,79,88,79,0,73,91,76,79,79,88,32,77,79,79,85,32,82,79,79,88,32,82,79,85,88,32,83,79,85,85,32,88,79,85,88,32,74,79,79,79,32,86,79,90,79,0,75,89,78,79,85,88,32,79,79,86,88,32,86,79,78,88,32,76,79,81,79,32,84,79,88,79,32,76,88,80,88,32,83,88,88,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,80,91,78,92,77,92,76,91,76,90,77,90,77,91,76,91,32,76,79,81,79,32,84,79,88,79,0,76,88,85,79,78,88,32,86,79,79,88,32,79,79,78,81,78,79,86,79,32,78,88,86,88,86,86,85,88,0,75,91,81,79,79,80,78,81,77,83,77,85,78,87,80,88,81,88,83,87,85,85,87,82,88,79,32,81,79,79,81,78,83,78,85,79,87,80,88,32,81,79,83,79,85,80,87,87,88,88,32,83,79,84,80,86,87,88,88,89,88,0,75,88,82,75,80,77,79,79,77,85,75,92,32,81,76,80,78,78,84,76,92,32,82,75,84,75,86,76,86,78,85,80,82,81,32,84,75,85,76,85,78,84,80,82,81,32,82,81,84,82,85,84,85,86,84,87,82,88,81,88,79,87,78,84,32,82,81,83,82,84,84,84,86,82,88,0,75,89,76,81,78,79,80,79,82,80,83,83,83,88,82,92,32,76,81,78,80,80,80,82,81,83,83,32,87,79,86,82,83,88,81,92,0,75,89,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,82,78,81,76,81,75,82,74,84,74,85,75,86,77,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,32,81,76,82,75,84,75,86,77,0,76,88,86,80,84,79,81,79,79,80,79,81,80,82,82,83,32,81,79,80,80,80,81,82,83,32,82,83,79,84,78,85,78,87,80,88,83,88,85,87,32,82,83,80,84,79,85,79,87,80,88,0,76,87,82,75,81,76,81,77,83,78,86,78,86,77,83,78,80,79,79,80,78,82,78,84,79,86,80,87,82,88,83,89,83,91,82,92,80,92,79,91,32,83,78,81,79,80,80,79,82,79,84,80,86,82,88,0,73,89,74,82,75,80,76,79,78,79,79,80,79,81,77,88,32,77,79,78,80,78,81,76,88,32,79,81,80,80,82,79,84,79,86,80,86,82,83,92,32,84,79,85,80,85,82,82,92,0,73,89,74,83,75,81,76,80,78,80,79,81,79,86,80,88,32,77,80,78,81,78,85,79,87,80,88,81,88,83,87,84,86,85,84,86,81,86,78,85,76,84,75,82,75,81,76,81,78,82,80,85,82,87,83,32,81,88,83,86,84,84,85,81,85,78,84,75,0,78,87,82,79,80,86,80,87,81,88,83,88,85,87,86,85,32,83,79,81,86,81,87,82,88,0,75,89,79,79,76,88,32,80,79,77,88,32,85,79,86,80,87,80,86,79,84,79,82,81,79,82,32,79,82,80,83,82,87,84,88,86,87,87,85,32,79,82,81,83,83,87,84,88,0,76,88,76,75,78,75,80,76,87,88,32,78,75,79,76,86,88,32,82,80,77,88,32,82,80,78,88,0,75,90,79,79,75,92,32,80,79,76,92,32,78,85,78,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,74,89,78,79,77,88,32,79,79,78,85,77,88,32,86,82,86,79,87,79,86,82,84,85,81,87,78,88,77,88,32,76,79,79,79,0,77,88,82,75,81,76,81,77,83,78,86,78,32,84,78,81,79,80,80,80,82,82,83,85,83,32,84,78,82,79,81,80,81,82,82,83,32,83,83,80,84,79,85,79,87,81,88,83,89,84,90,84,91,83,92,81,92,32,83,83,81,84,80,85,80,87,81,88,0,75,88,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,83,79,81,79,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,73,90,80,80,77,88,32,80,80,78,88,32,84,80,83,88,32,84,80,84,88,32,75,81,77,79,88,79,32,75,81,77,80,88,80,0,74,88,83,79,81,79,79,80,78,81,77,83,74,92,32,81,79,79,81,78,83,75,92,32,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,32,83,79,85,81,85,84,84,86,82,88,0,75,91,89,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,89,80,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,75,90,83,80,81,88,32,83,80,82,88,32,77,81,79,79,88,79,32,77,81,79,80,88,80,0,74,88,75,82,76,80,77,79,79,79,80,80,80,82,79,85,79,87,80,88,32,78,79,79,80,79,82,78,85,78,87,80,88,81,88,83,87,85,85,86,82,86,79,85,79,86,80,0,75,90,79,80,78,81,77,83,77,85,78,87,80,88,82,88,85,87,87,85,88,82,88,80,87,79,85,79,84,80,83,82,82,85,79,92,32,77,85,78,86,80,87,82,87,85,86,87,84,88,82,32,88,81,87,80,85,80,83,82,32,82,85,81,88,80,92,0,75,88,77,79,78,79,80,80,83,91,84,92,32,78,79,79,80,82,91,84,92,85,92,32,86,79,84,82,78,89,76,92,0,73,91,84,75,81,92,32,85,75,80,92,32,74,82,75,80,76,79,78,79,79,80,79,86,80,87,83,87,85,86,87,84,32,77,79,78,80,78,84,79,87,80,88,83,88,85,87,87,84,88,82,89,79,0,74,90,78,80,80,80,80,79,78,80,77,81,76,83,76,85,77,87,78,88,80,88,81,87,82,85,83,82,32,76,85,78,87,80,87,82,85,32,82,82,82,87,83,88,85,88,87,86,88,84,88,82,87,80,86,79,86,80,87,80,32,82,85,83,87,85,87,87,86,0,75,90,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,74,88,79,75,77,82,32,80,75,78,82,78,86,80,88,32,78,82,79,80,81,79,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,77,82,32,83,79,85,81,85,84,84,86,82,88,32,77,75,80,75,0,75,88,85,80,85,81,86,81,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,85,75,88,75,0,75,87,78,85,82,84,84,83,85,82,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,77,88,87,75,88,76,88,75,86,75,84,76,83,78,80,89,79,91,78,92,32,86,75,85,76,84,78,81,89,80,91,78,92,76,92,76,91,77,92,32,80,79,86,79,0,75,89,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,80,75,76,88,32,81,75,77,88,32,79,81,80,80,82,79,84,79,86,80,86,82,85,85,85,87,86,88,32,84,79,85,80,85,82,84,85,84,87,85,88,87,88,88,87,89,85,32,78,75,81,75,0,77,87,83,75,83,76,84,76,84,75,83,75,32,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,77,87,84,75,84,76,85,76,85,75,84,75,32,79,82,80,80,81,79,83,79,84,80,84,82,82,89,81,91,79,92,77,92,77,91,78,92,32,82,79,83,80,83,82,81,89,80,91,79,92,0,75,88,80,75,76,88,32,81,75,77,88,32,86,80,85,81,86,81,86,80,85,79,84,79,82,81,80,82,79,82,32,79,82,80,83,81,87,82,88,84,88,85,87,86,85,32,79,82,81,83,82,87,83,88,32,78,75,81,75,0,78,86,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,81,75,84,75,0,70,94,71,82,72,80,73,79,75,79,76,80,76,81,74,88,32,74,79,75,80,75,81,73,88,32,76,81,77,80,79,79,81,79,83,80,83,81,81,88,32,81,79,82,80,82,81,80,88,32,83,81,84,80,86,79,88,79,90,80,90,82,89,85,89,87,90,88,32,88,79,89,80,89,82,88,85,88,87,89,88,91,88,92,87,93,85,0,74,91,75,82,76,80,77,79,79,79,80,80,80,81,78,88,32,78,79,79,80,79,81,77,88,32,80,81,81,80,83,79,85,79,87,80,87,82,86,85,86,87,87,88,32,85,79,86,80,86,82,85,85,85,87,86,88,88,88,89,87,90,85,0,74,89,75,82,76,80,77,79,79,79,80,80,80,81,77,92,32,78,79,79,80,79,81,76,92,32,80,81,82,79,84,79,86,80,87,82,87,84,86,86,85,87,83,88,81,88,79,86,79,84,32,84,79,86,81,86,84,85,86,83,88,32,74,92,79,92,0,75,89,86,79,82,92,32,87,79,83,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,80,92,85,92,0,76,88,77,82,78,80,79,79,81,79,82,80,82,81,80,88,32,80,79,81,80,81,81,79,88,32,82,81,83,80,85,79,86,79,87,80,87,81,86,81,87,80,0,76,89,86,80,86,81,87,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,78,86,79,86,79,87,0,78,87,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,80,79,85,79,0,73,90,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,72,92,73,82,74,80,75,79,77,79,78,80,78,82,77,85,77,87,78,88,32,76,79,77,80,77,82,76,85,76,87,78,88,79,88,81,87,82,86,32,84,79,82,86,82,87,84,88,32,85,79,83,86,83,87,84,88,85,88,87,87,89,85,90,82,90,79,89,79,90,80,0,74,90,77,82,78,80,80,79,82,79,83,80,83,82,32,81,79,82,80,82,82,81,85,80,87,78,88,77,88,76,87,76,86,77,86,76,87,32,88,80,87,81,88,81,88,80,87,79,86,79,84,80,83,82,82,85,82,87,83,88,32,81,85,81,87,82,88,84,88,86,87,87,85,0,73,89,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,0,75,89,87,79,87,80,86,81,78,86,77,87,77,88,32,78,81,79,79,82,79,85,81,32,79,80,82,80,85,81,86],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+307200);allocate([81,32,78,86,79,86,82,87,85,87,32,79,86,82,88,85,88,86,86,0,72,91,82,75,83,76,83,77,84,77,84,76,82,75,79,75,77,76,76,78,76,88,32,79,75,78,76,77,78,77,88,32,88,75,89,76,89,77,90,77,90,76,88,75,86,75,84,77,84,88,32,86,75,85,77,85,88,32,74,79,87,79,32,74,88,79,88,32,82,88,87,88,0,74,91,85,75,86,76,87,76,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,86,79,86,88,32,87,79,87,88,32,76,79,87,79,32,76,88,81,88,32,84,88,89,88,0,74,91,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,85,75,86,76,86,88,32,87,75,87,88,32,76,79,86,79,32,76,88,81,88,32,84,88,89,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,89,75,90,76,91,76,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,90,79,90,88,32,91,79,91,88,32,72,79,91,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,89,75,90,76,90,88,32,91,75,91,88,32,72,79,90,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,78,87,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,76,88,86,80,84,79,82,79,80,80,79,81,78,83,78,85,79,87,81,88,83,88,85,87,32,82,79,80,81,79,83,79,86,81,88,32,79,83,83,83,0,76,89,83,75,81,76,80,77,79,79,78,82,78,85,79,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,85,75,83,75,32,83,75,81,77,80,79,79,83,79,86,80,88,32,82,88,84,86,85,84,86,80,86,77,85,75,32,79,81,86,81,0,75,90,84,75,81,92,32,85,75,80,92,32,81,79,78,80,77,82,77,85,78,87,81,88,84,88,87,87,88,85,88,82,87,80,84,79,81,79,32,81,79,79,80,78,82,78,85,79,87,81,88,32,84,88,86,87,87,85,87,82,86,80,84,79,0,76,88,85,80,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,84,79,86,82,88,32,81,79,79,81,79,84,80,86,82,88,83,89,83,91,82,92,80,92,0,73,91,86,75,87,76,88,76,86,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,90,75,91,76,91,75,89,75,87,76,86,78,83,89,82,91,81,92,32,89,75,88,76,87,78,84,89,83,91,81,92,79,92,79,91,80,92,32,76,79,89,79,0,73,90,86,75,87,76,88,76,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,76,79,87,79,0,73,90,86,75,87,76,32,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,76,79,86,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,92,76,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,90,79,88,86,88,87,89,88,91,88,92,87,93,85,32,91,79,89,86,89,87,90,88,32,73,79,91,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,32,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,91,75,88,86,88,87,89,88,91,88,92,87,93,85,32,92,75,89,86,89,87,90,88,32,73,79,90,79,0,77,87,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,79,85,0,76,88,0,76,89,81,75,79,76,78,79,78,84,79,87,81,88,84,88,86,87,87,84,87,79,86,76,84,75,81,75,32,81,75,80,76,79,79,79,84,80,87,81,88,32,84,88,85,87,86,84,86,79,85,76,84,75,0,76,89,80,78,83,75,83,88,32,82,76,82,88,32,79,88,86,88,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,81,82,79,83,78,85,78,88,32,84,75,85,76,86,78,85,80,84,81,32,78,87,79,86,80,86,83,87,86,87,87,86,32,80,86,83,88,86,88,87,86,87,85,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,32,84,75,85,76,86,78,85,80,84,81,32,82,81,84,81,86,82,87,84,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,81,85,82,86,84,86,85,85,87,84,88,0,76,89,83,77,83,88,32,84,75,84,88,32,84,75,77,84,88,84,32,81,88,86,88,0,76,89,79,75,78,81,32,79,75,86,75,32,79,76,83,76,86,75,32,78,81,79,80,81,79,84,79,86,80,87,82,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,79,85,80,86,82,86,85,85,87,84,88,0,76,89,86,77,86,78,87,78,87,77,86,76,84,75,82,75,80,76,79,77,78,80,78,85,79,87,81,88,84,88,86,87,87,85,87,83,86,81,84,80,81,80,78,82,32,82,75,80,77,79,80,79,85,80,87,81,88,32,84,88,85,87,86,85,86,83,85,81,84,80,0,76,89,78,75,78,79,32,86,77,82,84,80,88,32,87,75,84,81,81,88,32,78,77,80,75,82,75,85,77,32,78,77,80,76,82,76,85,77,86,77,0,76,89,81,75,79,76,78,78,79,80,81,81,84,81,86,80,87,78,86,76,84,75,81,75,32,81,75,80,76,79,78,80,80,81,81,32,84,81,85,80,86,78,85,76,84,75,32,81,81,79,82,78,84,78,85,79,87,81,88,84,88,86,87,87,85,87,84,86,82,84,81,32,81,81,80,82,79,84,79,85,80,87,81,88,32,84,88,85,87,86,85,86,84,85,82,84,81,0,76,89,79,86,79,85,78,85,78,86,79,87,81,88,83,88,85,87,86,86,87,83,87,78,86,76,84,75,81,75,79,76,78,78,78,80,79,82,81,83,84,83,87,81,32,83,88,85,86,86,83,86,78,85,76,84,75,32,81,75,80,76,79,78,79,80,80,82,81,83,0,78,86,82,86,81,87,82,88,83,87,82,86,0,78,86,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,79,81,80,82,81,83,80,82,79,32,82,86,81,87,82,88,83,87,82,86,0,78,86,82,79,81,80,82,81,83,80,82,79,32,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,75,81,76,82,83,83,76,82,75,32,82,76,82,79,32,82,86,81,87,82,88,83,87,82,86,0,76,89,78,78,79,78,79,79,78,79,78,78,79,76,81,75,84,75,86,76,87,78,87,79,86,81,83,82,82,83,82,84,83,84,32,84,75,86,77,86,80,85,81,83,82,32,82,87,82,88,83,88,83,87,82,87,0,79,86,82,75,82,80,32,83,75,82,80,0,76,88,79,75,79,80,32,80,75,79,80,32,85,75,85,80,32,86,75,85,80,0,77,87,81,75,80,76,80,78,81,79,83,79,84,78,84,76,83,75,81,75,0,77,87,82,74,82,80,32,79,75,85,79,32,85,75,79,79,0,75,90,88,72,77,92,0,77,87,85,72,83,74,81,77,80,80,80,84,81,87,83,90,85,92,32,83,74,82,76,81,80,81,84,82,88,83,90,0,77,87,79,72,81,74,83,77,84,80,84,84,83,87,81,90,79,92,32,81,74,82,76,83,80,83,84,82,88,81,90,0,77,87,80,72,80,92,32,81,72,81,92,32,80,72,85,72,32,80,92,85,92,0,77,87,83,72,83,92,32,84,72,84,92,32,79,72,84,72,32,79,92,84,92,0,76,87,83,72,82,73,81,75,81,77,82,79,82,80,80,82,82,84,82,85,81,87,81,89,82,91,83,92,32,82,73,81,77,32,81,75,82,79,32,82,85,81,89,32,81,87,82,91,0,77,88,81,72,82,73,83,75,83,77,82,79,82,80,84,82,82,84,82,85,83,87,83,89,82,91,81,92,32,82,73,83,77,32,83,75,82,79,32,82,85,83,89,32,83,87,82,91,0,77,87,84,72,80,82,84,92,0,77,87,80,72,84,82,80,92,0,79,85,82,72,82,92,0,77,87,80,72,80,92,32,84,72,84,92,0,73,91,76,82,88,82,0,73,91,82,76,82,88,32,76,82,88,82,0,74,90,82,77,82,88,32,77,82,87,82,32,77,88,87,88,0,74,90,82,77,82,88,32,77,77,87,77,32,77,82,87,82,0,74,90,77,77,87,87,32,87,77,77,87,0,78,86,82,81,81,82,82,83,83,82,82,81,0,73,91,82,76,81,77,82,78,83,77,82,76,32,76,82,88,82,32,82,86,81,87,82,88,83,87,82,86,0,73,91,76,80,88,80,32,76,84,88,84,0,73,91,87,76,77,88,32,76,80,88,80,32,76,84,88,84,0,73,91,76,78,88,78,32,76,82,88,82,32,76,86,88,86,0,74,90,87,76,77,82,87,88,0,74,90,77,76,87,82,77,88,0,74,90,87,75,77,79,87,83,32,77,84,87,84,32,77,88,87,88,0,74,90,77,75,87,79,77,83,32,77,84,87,84,32,77,88,87,88,0,72,91,89,85,87,85,85,84,84,83,82,80,81,79,79,78,78,78,76,79,75,81,75,82,76,84,78,85,79,85,81,84,82,83,84,80,85,79,87,78,89,78,0,74,90,76,84,76,82,77,80,79,80,85,83,87,83,88,82,32,76,82,77,81,79,81,85,84,87,84,88,82,88,80,0,74,90,77,83,82,80,87,83,32,77,83,82,81,87,83,0,78,86,83,75,80,79,32,83,75,84,76,80,79,0,78,86,81,75,84,79,32,81,75,80,76,84,79,0,76,88,78,75,79,77,81,78,83,78,85,77,86,75,32,78,75,79,78,81,79,83,79,85,78,86,75,0,78,86,83,76,82,77,81,76,82,75,83,76,83,78,81,80,0,78,86,83,75,81,77,81,79,82,80,83,79,82,78,81,79,0,78,86,81,76,82,77,83,76,82,75,81,76,81,78,83,80,0,78,86,81,75,83,77,83,79,82,80,81,79,82,78,83,79,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,0,74,90,77,77,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,77,0,74,90,77,77,83,77,85,78,86,79,87,81,87,83,86,85,85,86,83,87,77,87,0,74,90,77,87,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,87,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,32,77,82,85,82,0,73,91,84,79,85,80,88,82,85,84,84,85,32,85,80,87,82,85,84,32,76,82,87,82,0,77,87,82,77,82,88,32,79,80,80,79,82,76,84,79,85,80,32,80,79,82,77,84,79,0,73,91,80,79,79,80,76,82,79,84,80,85,32,79,80,77,82,79,84,32,77,82,88,82,0,77,87,82,76,82,87,32,79,84,80,85,82,88,84,85,85,84,32,80,85,82,87,84,85,0,75,89,86,83,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,81,75,80,76,81,76,82,75,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,86,81,86,78,85,76,84,75,0,74,90,76,75,82,88,32,77,75,82,86,32,88,75,82,88,32,76,75,88,75,32,78,76,87,76,0,71,91,73,79,76,79,82,87,32,75,79,82,88,32,91,70,82,88,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,32,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,72,92,90,82,89,84,87,85,86,85,84,84,83,83,81,80,80,79,78,78,77,78,75,79,74,81,74,82,75,84,77,85,78,85,80,84,81,83,83,80,84,79,86,78,87,78,89,79,90,81,90,82,0,74,90,88,75,76,88,32,79,75,80,76,80,78,79,79,77,79,76,78,76,76,77,75,79,75,83,76,86,76,88,75,32,85,84,84,85,84,87,85,88,87,88,88,87,88,85,87,84,85,84,0,74,91,89,80,88,80,88,81,89,81,89,80,88,79,87,79,86,80,85,84,84,86,83,87,81,88,79,88,77,87,76,86,76,84,77,83,79,82,82,80,83,78,83,76,82,75,80,75,79,76,79,78,80,81,85,87,87,88,88,88,89,87,32,79,88,77,86,77,84,79,82,32,79,78,80,80,86,87,87,88,0,74,91,85,80,83,79,81,79,80,81,80,82,81,84,83,84,85,83,32,85,79,85,83,86,84,88,84,89,82,89,81,88,78,86,76,83,75,82,75,79,76,77,78,76,81,76,82,77,85,79,87,82,88,83,88,86,87,0,75,90,81,72,81,92,32,84,72,84,92,32,87,76,86,76,86,77,87,77,87,76,85,75,80,75,78,76,78,78,79,80,86,83,87,84,32,78,78,79,79,86,82,87,84,87,86,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,78,86,0,75,89,80,75,80,91,32,84,75,84,91,32,77,81,87,81,32,77,85,87,85,0,76,88,84,76,83,76,83,77,84,77,84,76,83,75,81,75,80,76,80,78,81,80,84,82,85,83,32,80,78,81,79,84,81,85,83,85,85,83,87,32,81,80,79,82,79,84,80,86,83,88,84,89,32,79,84,80,85,83,87,84,89,84,91,83,92,81,92,80,91,80,90,81,90,81,91,80,91,0,76,88,82,75,81,76,82,77,83,76,82,75,32,82,77,82,81,32,82,81,81,83,82,86,83,83,82,81,32,82,86,82,92,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,0,76,88,82,77,83,76,82,75,81,76,82,77,82,81,81,82,83,85,82,86,32,82,81,83,82,81,85,82,86,82,90,81,91,82,92,83,91,82,90,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,32,80,88,79,87,78,88,79,89,80,88,84,88,85,87,86,88,85,89,84,88,0,76,89,86,75,86,88,32,78,75,86,75,32,81,81,86,81,32,78,88,86,88,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,81,81,82,82,83,83,82,82,81,0,76,89,81,75,80,76,80,77,81,78,32,84,75,85,76,85,77,84,78,32,82,78,80,79,79,81,79,82,80,84,82,85,83,85,85,84,86,82,86,81,85,79,83,78,82,78,32,82,85,82,89,32,83,85,83,89,32,79,87,86,87,0,76,89,82,75,80,76,79,78,79,79,80,81,82,82,83,82,85,81,86,79,86,78,85,76,83,75,82,75,32,82,82,82,88,32,83,82,83,88,32,79,85,86,85,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,75,82,89,32,75,82,89,82,0,74,89,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,87,77,82,82,32,82,77,87,77,87,82,32,82,77,86,78,87,82,0,74,90,76,76,77,75,79,75,81,76,82,78,82,80,81,82,80,83,78,84,32,79,75,80,76,81,78,81,81,80,83,32,86,75,85,88,32,87,75,84,88,32,78,84,88,84,0,74,89,78,75,78,85,32,79,75,78,82,32,78,82,79,80,81,79,83,79,85,80,86,81,86,84,84,86,84,88,85,89,86,89,87,88,32,83,79,85,81,85,84,84,86,32,76,75,79,75,0,76,89,79,78,82,75,82,81,32,86,78,83,75,83,81,32,82,81,80,82,79,84,79,85,80,87,82,88,83,88,85,87,86,85,86,84,85,82,83,81,32,82,84,82,85,83,85,83,84,82,84,0,74,90,82,75,82,89,32,77,75,77,80,78,82,80,83,84,83,86,82,87,80,87,75,32,76,77,77,75,78,77,32,81,77,82,75,83,77,32,86,77,87,75,88,77,32,79,86,85,86,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,86,88,86,85,85,88,0,76,89,87,75,84,75,81,76,79,78,78,81,78,83,79,86,81,88,84,89,87,89,32,87,75,84,76,82,78,81,81,81,83,82,86,84,88,87,89,0,74,90,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,83,76,81,81,32,87,77,82,82,32,88,81,83,83,0,75,89,80,77,84,87,32,84,77,80,87,32,77,80,87,84,32,87,80,77,84,0,74,91,79,85,77,85,76,86,76,88,77,89,79,89,80,88,80,86,78,84,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,87,84,85,86,85,88,86,89,88,89,89,88,89,86,88,85,86,85,32,78,77,80,76,85,76,87,77,0,74,91,79,79,77,79,76,78,76,76,77,75,79,75,80,76,80,78,78,80,77,82,77,85,78,87,79,88,81,89,84,89,86,88,87,87,88,85,88,82,87,80,85,78,85,76,86,75,88,75,89,76,89,78,88,79,86,79,32,78,87,80,88,85,88,87,87,0,70,94,75,72,75,92,32,76,72,76,92,32,88,72,88,92,32,89,72,89,92,32,72,72,92,72,32,72,92,79,92,32,85,92,92,92,0,72,93,75,72,82,81,74,92,32,74,72,81,81,32,74,72,89,72,90,77,88,72,32,75,91,88,91,32,74,92,89,92,90,87,88,92,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,32,84,68,82,72,81,75,80,80,80,84,81,89,82,92,84,96,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,32,80,68,82,72,83,75,84,80,84,84,83,89,82,92,80,96,0,75,89,79,66,79,98,32,80,66,80,98,32,79,66,86,66,32,79,98,86,98,0,75,89,84,66,84,98,32,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,74,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,32,82,68,81,71,81,75,82,78,32,82,86,81,89,81,93,82,96,0,75,90,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,32,82,68,83,71,83,75,82,78,32,82,86,83,89,83,93,82,96,0,75,89,85,64,82,67,80,70,79,73,79,76,80,79,83,86,84,89,84,92,83,95,82,97,32,82,67,81,69,80,72,80,75,81,78,84,85,85,88,85,91,84,94,82,97,79,100,0,75,89,79,64,82,67,84,70,85,73,85,76,84,79,81,86,80,89,80,92,81,95,82,97,32,82,67,83,69,84,72,84,75,83,78,80,85,79,88,79,91,80,94,82,97,85,100,0,65,88,67,82,71,82,82,96,32,71,83,82,97,32,70,83,82,98,32,88,58,82,98,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,71,92,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,0,71,92,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,89,91,89,85,88,91,0,71,91,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,80,91,0,71,94,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,32,88,83,88,91,32,89,83,89,91,32,85,83,92,83,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,76,80,88,80,32,72,91,79,91,32,85,91,92,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,79,91,86,91,0,75,90,85,70,85,87,84,90,82,91,80,91,78,90,77,88,77,86,78,85,79,86,78,87,32,84,70,84,87,83,90,82,91,32,81,70,88,70,0,70,92,75,70,75,91,32,76,70,76,91,32,89,70,76,83,32,81,79,89,91,32,80,79,88,91,32,72,70,79,70,32,85,70,91,70,32,72,91,79,91,32,85,91,91,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,82,70,32,75,91,90,91,90,85,89,91,0,70,95,75,70,75,91,32,76,70,82,88,32,75,70,82,91,32,89,70,82,91,32,89,70,89,91,32,90,70,90,91,32,72,70,76,70,32,89,70,93,70,32,72,91,78,91,32,86,91,93,91,0,71,94,76,70,76,91,32,77,70,89,89,32,77,72,89,91,32,89,70,89,91,32,73,70,77,70,32,86,70,92,70,32,73,91,79,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,78,89,78,88,79,86,81,85,82,85,84,86,85,88,86,95,87,96,89,96,90,94,90,93,32,85,88,86,92,87,94,88,95,89,95,90,94,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,77,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,73,91,80,91,32,82,80,84,81,85,82,88,89,89,90,90,90,91,89,32,84,81,85,83,87,90,88,91,90,91,91,89,91,88,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,73,92,82,70,82,91,32,83,70,83,91,32,76,70,75,76,75,70,90,70,90,76,89,70,32,79,91,86,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,76,70,76,85,77,88,79,90,81,91,32,72,70,79,70,32,86,70,92,70,0,72,92,75,70,82,91,32,76,70,82,88,32,89,70,82,91,32,73,70,79,70,32,85,70,91,70,0,70,94,74,70,78,91,32,75,70,78,86,32,82,70,78,91,32,82,70,86,91,32,83,70,86,86,32,90,70,86,91,32,71,70,78,70,32,87,70,93,70,0,72,92,75,70,88,91,32,76,70,89,91,32,89,70,75,91,32,73,70,79,70,32,85,70,91,70,32,73,91,79,91,32,85,91,91,91,0,72,93,75,70,82,81,82,91,32,76,70,83,81,83,91,32,90,70,83,81,32,73,70,79,70,32,86,70,92,70,32,79,91,86,91,0,72,92,88,70,75,91,32,89,70,76,91,32,76,70,75,76,75,70,89,70,32,75,91,89,91,89,85,88,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,90,70,90,76,89,70,32,75,91,82,91,0,72,92,82,70,74,91,32,82,70,90,91,32,82,73,89,91,32,75,90,89,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,73,91,79,91,32,85,91,91,91,0,71,93,75,69,74,74,32,90,69,89,74,32,79,78,78,83,32,86,78,85,83,32,75,87,74,92,32,90,87,89,92,32,75,71,89,71,32,75,72,89,72,32,79,80,85,80,32,79,81,85,81,32,75,89,89,89,32,75,90,89,90,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,92,70,32,72,91,79,91,32,85,91,92,91,0,72,93,75,70,82,80,74,91,32,74,70,81,80,32,74,70,89,70,90,76,88,70,32,75,90,88,90,32,74,91,89,91,90,85,88,91,0,73,92,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,75,73,77,71,79,71,81,73,32,90,75,90,73,89,71,88,70,86,70,85,71,84,73,83,77,83,91,32,90,73,88,71,86,71,84,73,32,79,91,86,91,0,72,93,82,70,82,91,32,83,70,83,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,80,75,32,80,75,78,76,77,77,76,79,76,82,77,84,78,85,80,86,32,85,86,87,85,88,84,89,82,89,79,88,77,87,76,85,75,32,79,70,86,70,32,79,91,86,91,0,71,94,82,70,82,91,32,83,70,83,91,32,73,77,74,76,76,77,77,81,78,83,79,84,81,85,32,74,76,75,77,76,81,77,83,78,84,81,85,84,85,87,84,88,83,89,81,90,77,91,76,32,84,85,86,84,87,83,88,81,89,77,91,76,92,77,32,79,70,86,70,32,79,91,86,91,0,71,93,74,88,75,91,79,91,77,87,75,83,74,80,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,80,89,83,87,87,85,91,89,91,90,88,32,77,87,76,84,75,80,75,76,76,73,78,71,80,70,32,84,70,86,71,88,73,89,76,89,80,88,84,87,87,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,72,91,32,85,70,86,91,32,84,72,85,91,32,76,85,85,85,32,70,91,76,91,32,82,91,88,91,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,77,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,86,80,87,81,88,83,88,85,87,88,85,90,82,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,85,70,87,71,88,72,89,75,89,79,88,83,86,87,84,89,82,90,79,91,0,70,93,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,85,91,87,86,84,91,0,70,92,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,32,82,91,84,90,86,88,88,84,32,85,84,92,84,0,69,95,78,70,72,91,32,79,70,73,91,32,91,70,85,91,32,92,70,86,91,32,75,70,82,70,32,88,70,95,70,32,76,80,88,80,32,69,91,76,91,32,82,91,89,91,0,76,89,85,70,79,91,32,86,70,80,91,32,82,70,89,70,32,76,91,83,91,0,73,91,88,70,83,87,82,89,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,86,75,87,32,87,70,82,87,81,89,79,91,32,84,70,91,70,0,70,93,79,70,73,91,32,80,70,74,91,32,93,70,76,83,32,83,79,87,91,32,82,79,86,91,32,76,70,83,70,32,89,70,95,70,32,70,91,77,91,32,83,91,89,91,0,72,92,81,70,75,91,32,82,70,76,91,32,78,70,85,70,32,72,91,87,91,89,85,86,91,0,69,96,78,70,72,91,32,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,92,70,86,91,32,93,70,87,91,32,75,70,79,70,32,92,70,96,70,32,69,91,75,91,32,83,91,90,91,0,70,95,79,70,73,91,32,79,70,86,88,32,79,73,86,91,32,92,70,86,91,32,76,70,79,70,32,89,70,95,70,32,70,91,76,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,88,70,90,71,91,73,91,75,90,78,88,80,85,81,32,70,91,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,32,76,89,76,88,77,86,79,85,80,85,82,86,83,88,83,95,84,96,86,96,87,94,87,93,32,83,88,84,94,85,95,86,95,87,94,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,77,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,82,80,84,81,85,82,86,90,87,91,89,91,90,89,90,88,32,85,82,87,89,88,90,89,90,90,89,32,70,91,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,72,93,85,70,79,91,32,86,70,80,91,32,79,70,76,76,78,70,93,70,92,76,92,70,32,76,91,83,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,70,32,79,70,76,81,75,85,75,88,76,90,78,91,32,75,70,82,70,32,89,70,95,70,0,72,92,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,76,70,82,70,32,88,70,94,70,0,69,95,77,70,75,91,32,78,70,76,89,32,85,70,75,91,32,85,70,83,91,32,86,70,84,89,32,93,70,83,91,32,74,70,81,70,32,90,70,96,70,0,71,93,78,70,85,91,32,79,70,86,91,32,92,70,72,91,32,76,70,82,70,32,88,70,94,70,32,70,91,76,91,32,82,91,88,91,0,72,93,78,70,82,80,79,91,32,79,70,83,80,80,91,32,93,70,83,80,32,76,70,82,70,32,89,70,95,70,32,76,91,83,91,0,71,93,91,70,72,91,32,92,70,73,91,32,79,70,76,76,78,70,92,70,32,72,91,86,91,88,85,85,91,0,72,92,75,73,76,75,88,87,89,89,89,91,32,76,76,88,88,32,75,73,75,75,76,77,88,89,89,91,32,80,80,76,84,75,86,75,88,76,90,75,91,32,75,86,77,90,32,76,84,76,86,77,88,77,90,75,91,32,83,83,88,78,32,86,73,86,76,87,78,89,78,89,76,87,75,86,73,32,86,73,87,76,89,78,0,72,92,81,73,75,91,32,83,73,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,32,81,66,79,67,78,69,78,71,79,73,81,74,83,74,85,73,86,71,86,69,85,67,83,66,81,66,0,71,93,73,66,91,98,0,70,94,82,74,73,90,32,82,74,91,90,0,73,93,78,79,78,80,77,80,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,87,79,87,88,88,90,90,91,91,91,32,87,81,86,82,80,83,77,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,80,83,78,84,77,86,77,88,78,90,80,91,0,71,92,76,70,76,91,32,77,70,77,91,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,70,77,70,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,72,93,87,70,87,91,32,88,70,88,91,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,70,88,70,32,87,91,91,91,0,72,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,83,87,80,86,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,75,88,85,71,84,72,85,73,86,72,86,71,85,70,83,70,81,71,80,73,80,91,32,83,70,82,71,81,73,81,91,32,77,77,85,77,32,77,91,84,91,0,73,92,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,78,78,80,78,84,79,86,32,85,86,86,84,86,80,85,78,32,86,79,87,78,89,77,89,78,87,78,32,78,85,77,86,76,88,76,89,77,91,80,92,85,92,88,93,89,94,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,0,71,93,76,70,76,91,32,77,70,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,70,77,70,32,73,91,80,91,32,84,91,91,91,0,77,88,82,70,81,71,82,72,83,71,82,70,32,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,77,88,83,70,82,71,83,72,84,71,83,70,32,84,77,84,95,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,83,77,83,95,82,97,81,98,32,80,77,84,77,0,71,92,76,70,76,91,32,77,70,77,91,32,87,77,77,87,32,82,83,88,91,32,81,83,87,91,32,73,70,77,70,32,84,77,90,77,32,73,91,80,91,32,84,91,90,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,83,70,32,79,91,86,91,0,66,99,71,77,71,91,32,72,77,72,91,32,72,80,74,78,77,77,79,77,82,78,83,80,83,91,32,79,77,81,78,82,80,82,91,32,83,80,85,78,88,77,90,77,93,78,94,80,94,91,32,90,77,92,78,93,80,93,91,32,68,77,72,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,71,93,76,77,76,91,32,77,77,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,77,77,77,32,73,91,80,91,32,84,91,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,71,92,76,77,76,98,32,77,77,77,98,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,77,77,77,32,73,98,80,98,0,72,92,87,77,87,98,32,88,77,88,98,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,98,91,98,0,73,90,78,77,78,91,32,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,88,78,88,79,87,80,86,79,87,78,32,75,77,79,77,32,75,91,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,82,80,83,85,85,87,86,88,87,32,77,80,78,81,80,82,85,84,87,85,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,70,80,87,81,90,83,91,85,91,87,90,88,88,32,81,70,81,87,82,90,83,91,32,77,77,85,77,0,71,93,76,77,76,88,77,90,80,91,82,91,85,90,87,88,32,77,77,77,88,78,90,80,91,32,87,77,87,91,32,88,77,88,91,32,73,77,77,77,32,84,77,88,77,32,87,91,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,74,77,80,77,32,84,77,90,77,0,70,94,74,77,78,91,32,75,77,78,88,32,82,77,78,91,32,82,77,86,91,32,83,77,86,88,32,90,77,86,91,32,71,77,78,77,32,87,77,93,77,0,72,92,76,77,87,91,32,77,77,88,91,32,88,77,76,91,32,74,77,80,77,32,84,77,90,77,32,74,91,80,91,32,84,91,90,91,0,72,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,73,91,87,77,76,91,32,88,77,77,91,32,77,77,76,81,76,77,88,77,32,76,91,88,91,88,87,87,91,0,71,94,81,77,78,78,76,80,75,82,74,85,74,88,75,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,32,81,77,83,77,85,78,86,80,88,88,89,90,90,91,32,83,77,84,78,85,80,87,88,88,90,90,91,91,91,0,71,92,84,70,81,71,79,73,77,77,76,80,75,84,74,90,73,98,32,84,70,82,71,80,73,78,77,77,80,76,84,75,90,74,98,32,84,70,86,70,88,71,89,72,89,75,88,77,87,78,84,79,80,79,32,86,70,88,72,88,75,87,77,86,78,84,79,32,80,79,84,80,86,82,87,84,87,87,86,89,85,90,82,91,80,91,78,90,77,89,76,86,32,80,79,83,80,85,82,86,84,86,87,85,89,84,90,82,91,0,72,92,73,80,75,78,77,77,79,77,81,78,82,79,83,82,83,86,82,90,79,98,32,74,79,76,78,80,78,82,79,32,90,77,89,80,88,82,83,89,80,94,78,98,32,89,77,88,80,87,82,83,89,0,73,92,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,83,74,82,72,82,70,83,69,85,69,87,70,89,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,84,75,83,73,83,71,84,70,86,70,89,72,0,73,91,88,80,86,78,84,77,80,77,78,78,78,80,80,82,83,83,32,80,77,79,78,79,80,81,82,83,83,32,83,83,78,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,83,83,79,84,77,86,77,88,78,90,80,91,0,73,91,84,70,82,71,81,72,81,73,82,74,85,75,90,75,90,74,87,75,83,77,80,79,77,82,76,85,76,87,77,89,80,91,83,93,84,95,84,97,83,98,81,98,80,97,32,85,76,81,79,78,82,77,85,77,87,78,89,80,91,0,71,93,72,81,73,79,75,77,78,77,79,78,79,80,78,84,76,91,32,77,77,78,78,78,80,77,84,75,91,32,78,84,80,80,82,78,84,77,86,77,88,78,89,79,89,82,88,87,85,98,32,86,77,88,79,88,82,87,87,84,98,0,70,93,71,81,72,79,74,77,77,77],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+317440);allocate([78,78,78,80,77,85,77,88,78,90,79,91,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,85,88,82,89,77,89,73,88,71,86,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,32,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,0,76,88,82,77,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,83,77,81,84,80,88,80,90,81,91,0,72,92,78,77,74,91,32,79,77,75,91,32,88,77,89,78,90,78,89,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,0,72,92,75,70,77,70,79,71,80,72,81,74,87,88,88,90,89,91,32,77,70,79,72,80,74,86,88,87,90,89,91,90,91,32,82,77,74,91,32,82,77,75,91,0,70,93,77,77,71,98,32,78,77,72,98,32,77,80,76,86,76,89,78,91,80,91,82,90,84,88,86,85,32,88,77,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,86,88,86,90,87,91,0,72,92,78,77,76,91,32,79,77,78,83,77,88,76,91,32,89,77,88,81,86,85,32,90,77,89,80,88,82,86,85,84,87,81,89,79,90,76,91,32,75,77,79,77,0,73,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,81,76,79,77,78,79,78,81,80,83,83,84,86,84,32,85,75,82,76,80,77,79,79,79,81,81,83,83,84,32,83,84,79,85,77,86,76,88,76,90,78,92,83,94,84,95,84,97,82,98,80,98,32,83,84,80,85,78,86,77,88,77,90,79,92,83,94,0,73,91,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,0,71,93,80,78,76,91,32,80,78,77,91,32,86,78,86,91,32,86,78,87,91,32,73,80,75,78,78,77,91,77,32,73,80,75,79,78,78,91,78,0,72,91,76,86,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,79,78,77,81,76,84,72,98,32,82,91,84,90,86,87,87,84,87,80,86,78,32,82,77,80,78,78,81,77,84,73,98,0,72,93,91,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,84,90,86,87,87,84,87,81,86,79,85,78,83,77,32,81,77,79,78,77,81,76,84,76,88,77,90,32,81,91,83,90,85,87,86,84,86,80,85,78,32,85,78,91,78,0,72,92,83,78,80,91,32,83,78,81,91,32,74,80,76,78,79,77,90,77,32,74,80,76,79,79,78,90,78,0,72,92,73,81,74,79,76,77,79,77,80,78,80,80,78,86,78,89,80,91,32,78,77,79,78,79,80,77,86,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,82,89,79,88,77,87,78,88,79,89,82,32,88,85,89,79,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,32,74,87,76,89,78,90,81,90,84,89,87,87,89,85,32,90,79,88,78,86,78,84,80,82,83,80,89,78,98,0,73,91,75,77,77,77,79,78,80,80,85,95,86,97,87,98,32,77,77,78,78,79,80,84,95,85,97,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,85,70,79,98,32,86,70,78,98,32,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,79,90,82,90,84,89,87,86,89,83,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,82,91,84,90,86,88,88,85,89,83,91,77,0,70,93,74,81,76,79,79,78,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,82,84,32,73,87,74,89,75,90,77,90,79,89,81,87,32,81,84,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,87,78,89,79,90,81,32,81,87,82,89,83,90,85,90,87,89,89,87,0,72,93,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,91,80,70,76,83,76,86,77,89,78,90,32,81,70,77,83,32,77,83,78,80,80,78,82,77,84,77,86,78,87,79,88,81,88,84,87,87,85,90,82,91,80,91,78,90,77,87,77,83,32,86,78,87,80,87,84,86,87,84,90,82,91,32,77,70,81,70,0,73,91,87,80,87,81,88,81,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,32,82,77,80,78,78,81,77,84,77,88,78,90,0,72,93,90,70,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,91,70,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,87,70,91,70,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,32,82,77,80,78,78,81,77,84,77,88,78,90,0,75,90,90,71,89,72,90,73,91,72,91,71,90,70,88,70,86,71,85,72,84,74,83,77,80,91,79,95,78,97,32,88,70,86,72,85,74,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,79,77,89,77,0,72,92,89,77,85,91,84,94,82,97,79,98,76,98,74,97,73,96,73,95,74,94,75,95,74,96,32,88,77,84,91,83,94,81,97,79,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,93,80,70,74,91,32,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,32,77,70,81,70,0,76,89,85,70,84,71,85,72,86,71,85,70,32,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,76,89,86,70,85,71,86,72,87,71,86,70,32,78,81,79,79,81,77,84,77,85,78,85,81,82,91,81,94,80,96,79,97,77,98,75,98,74,97,74,96,75,95,76,96,75,97,32,83,77,84,78,84,81,81,91,80,94,79,96,77,98,0,72,92,80,70,74,91,32,81,70,75,91,32,88,78,87,79,88,80,89,79,89,78,88,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,81,70,0,77,89,85,70,81,84,80,88,80,90,81,91,84,91,86,89,87,87,32,86,70,82,84,81,88,81,90,82,91,32,82,70,86,70,0,65,98,66,81,67,79,69,77,72,77,73,78,73,80,72,84,70,91,32,71,77,72,78,72,80,71,84,69,91,32,72,84,74,80,76,78,78,77,80,77,82,78,83,79,83,81,80,91,32,80,77,82,79,82,81,79,91,32,82,84,84,80,86,78,88,77,90,77,92,78,93,79,93,81,91,87,91,90,92,91,32,90,77,92,79,92,81,90,87,90,90,91,91,94,91,96,89,97,87,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,84,75,91,32,76,77,77,78,77,80,76,84,74,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,0,71,92,72,81,73,79,75,77,78,77,79,78,79,80,78,84,74,98,32,77,77,78,78,78,80,77,84,73,98,32,78,84,79,81,81,78,83,77,85,77,87,78,88,79,89,81,89,84,88,87,86,90,83,91,81,91,79,90,78,87,78,84,32,87,78,88,80,88,84,87,87,85,90,83,91,32,70,98,77,98,0,72,92,88,77,82,98,32,89,77,83,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,79,98,86,98,0,73,90,74,81,75,79,77,77,80,77,81,78,81,80,80,84,78,91,32,79,77,80,78,80,80,79,84,77,91,32,80,84,82,80,84,78,86,77,88,77,89,78,89,79,88,80,87,79,88,78,0,74,91,88,79,88,80,89,80,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,82,86,86,87,87,32,78,80,79,81,86,85,87,86,87,89,86,90,83,91,80,91,77,90,76,89,76,88,77,88,77,89,0,75,89,84,70,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,85,70,81,84,80,88,80,90,81,91,32,78,77,87,77,0,70,93,71,81,72,79,74,77,77,77,78,78,78,81,76,87,76,89,78,91,32,76,77,77,78,77,81,75,87,75,89,76,90,78,91,80,91,82,90,84,88,86,84,32,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,0,72,92,73,81,74,79,76,77,79,77,80,78,80,81,78,87,78,89,80,91,32,78,77,79,78,79,81,77,87,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,81,89,77,88,77,89,79,0,67,96,68,81,69,79,71,77,74,77,75,78,75,81,73,87,73,89,75,91,32,73,77,74,78,74,81,72,87,72,89,73,90,75,91,77,91,79,90,81,88,82,86,32,84,77,82,86,82,89,83,90,85,91,87,91,89,90,91,88,92,86,93,82,93,77,92,77,93,79,32,85,77,83,86,83,89,85,91,0,72,92,75,81,77,78,79,77,82,77,83,79,83,82,32,81,77,82,79,82,82,81,86,80,88,78,90,76,91,75,91,74,90,74,89,75,88,76,89,75,90,32,81,86,81,89,82,91,85,91,87,90,89,87,32,89,78,88,79,89,80,90,79,90,78,89,77,88,77,86,78,84,80,83,82,82,86,82,89,83,91,0,71,92,72,81,73,79,75,77,78,77,79,78,79,81,77,87,77,89,79,91,32,77,77,78,78,78,81,76,87,76,89,77,90,79,91,81,91,83,90,85,88,87,84,32,90,77,86,91,85,94,83,97,80,98,77,98,75,97,74,96,74,95,75,94,76,95,75,96,32,89,77,85,91,84,94,82,97,80,98,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,76,81,77,79,79,77,82,77,86,79,32,77,79,79,78,82,78,86,79,88,79,32,76,89,78,89,82,90,85,90,87,89,32,78,89,82,91,85,91,87,89,88,87,0,71,94,86,71,85,72,86,73,87,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,92,71,91,72,92,73,93,72,93,71,92,70,90,70,88,71,87,73,87,91,32,90,70,89,71,88,73,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,71,93,87,71,86,72,87,73,88,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,88,77,32,73,91,80,91,32,84,91,91,91,0,71,93,86,71,85,72,86,73,87,72,87,71,85,70,32,88,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,72,87,91,32,88,70,88,91,32,73,77,87,77,32,73,91,80,91,32,84,91,91,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,93,71,92,72,93,73,94,72,93,71,91,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,77,93,91,32,94,77,94,91,32,68,77,94,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,92,71,91,72,92,73,93,72,93,71,91,70,32,94,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,72,93,91,32,94,70,94,91,32,68,77,93,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,77,88,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,73,90,87,78,85,77,82,77,79,78,77,80,76,83,76,86,77,89,78,90,81,91,84,91,86,90,32,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,32,77,84,85,84,0,73,92,84,70,81,71,79,74,78,76,77,79,76,84,76,88,77,90,79,91,81,91,84,90,86,87,87,85,88,82,89,77,89,73,88,71,86,70,84,70,32,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,32,78,80,87,80,0,71,93,85,70,79,98,32,86,70,78,98,32,81,77,77,78,75,80,74,83,74,86,75,88,77,90,80,91,83,91,87,90,89,88,90,85,90,82,89,80,87,78,84,77,81,77,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,80,91,32,83,91,86,90,88,88,89,85,89,82,88,80,86,78,84,77,0,73,91,84,77,86,78,88,80,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,32,81,77,79,78,78,79,77,81,77,83,78,85,83,90,84,92,84,94,83,95,81,95,0,71,93,76,77,75,78,74,80,74,82,75,85,79,89,80,91,32,74,82,75,84,79,88,80,91,80,93,79,96,77,98,76,98,75,97,74,95,74,92,75,88,77,84,79,81,82,78,84,77,86,77,89,78,90,80,90,84,89,88,87,90,85,91,84,91,83,90,83,88,84,87,85,88,84,89,32,86,77,88,78,89,80,89,84,88,88,87,90,0,69,95,89,71,88,72,89,73,90,72,89,71,87,70,84,70,81,71,79,73,78,75,77,78,76,82,74,91,73,95,72,97,32,84,70,82,71,80,73,79,75,78,78,76,87,75,91,74,94,73,96,72,97,70,98,68,98,67,97,67,96,68,95,69,96,68,97,32,95,71,94,72,95,73,96,72,96,71,95,70,93,70,91,71,90,72,89,74,88,77,85,91,84,95,83,97,32,93,70,91,72,90,74,89,78,87,87,86,91,85,94,84,96,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,73,77,94,77,0,70,94,91,71,90,72,91,73,92,72,91,71,88,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,89,77,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,90,77,88,84,87,88,87,90,88,91,32,74,77,90,77,0,70,94,89,71,88,72,89,73,90,72,90,71,88,70,32,92,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,91,70,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,92,70,88,84,87,88,87,90,88,91,32,74,77,89,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,96,71,95,72,96,73,97,72,96,71,93,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,94,77,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,95,77,93,84,92,88,92,90,93,91,32,68,77,95,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,94,71,93,72,94,73,95,72,95,71,93,70,32,97,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,96,70,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,97,70,93,84,92,88,92,90,93,91,32,68,77,94,77,0,76,89,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,81,70,79,71,78,72,77,74,76,79,76,82,77,87,78,89,79,90,81,91,32,83,91,85,90,86,89,87,87,88,82,88,79,87,74,86,72,85,71,83,70,0,72,92,78,74,80,73,83,70,83,91,32,82,71,82,91,32,78,91,87,91,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,84,70,86,71,87,72,88,74,88,76,87,78,84,80,80,82,32,75,89,76,88,78,88,83,90,86,90,88,89,89,88,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,72,92,84,72,84,91,32,85,70,85,91,32,85,70,74,85,90,85,32,81,91,88,91,0,72,92,77,70,75,80,32,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,77,70,87,70,32,77,71,82,71,87,70,0,72,92,87,73,86,74,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,32,82,70,80,71,78,73,77,75,76,79,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,84,87,81,85,79,83,78,0,72,92,75,70,75,76,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,76,72,78,71,80,71,85,73,32,89,70,89,73,88,76,84,81,83,83,82,86,82,91,32,88,76,83,81,82,83,81,86,81,91,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,80,70,78,71,77,73,77,76,78,78,80,79,32,84,79,86,78,87,76,87,73,86,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,80,79,78,80,77,81,76,83,76,87,77,89,78,90,80,91,32,84,91,86,90,87,89,88,87,88,83,87,81,86,80,84,79,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,87,77,88,32,81,83,79,82,77,80,76,77,76,76,77,73,79,71,81,70,32,83,70,85,71,87,73,88,76,88,82,87,86,86,88,84,90,82,91,0,77,87,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,81,72,82,84,83,72,82,70,32,82,72,82,78,32,82,89,81,90,82,91,83,90,82,89,0,73,91,77,74,78,75,77,76,76,75,76,74,77,72,78,71,80,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,83,70,85,71,86,72,87,74,87,76,86,78,84,80,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,81,77,32,83,70,81,77,0,74,90,78,70,77,77,32,79,70,77,77,32,86,70,85,77,32,87,70,85,77,0,74,90,82,70,82,82,32,77,73,87,79,32,87,73,77,79,0,75,89,85,66,78,82,85,98,0,75,89,79,66,86,82,79,98,0,75,89,79,66,79,98,32,85,66,85,98,0,70,94,82,74,82,91,32,74,82,90,82,32,74,91,90,91,0,70,94,82,74,82,91,32,74,74,90,74,32,74,82,90,82,0,77,87,81,81,81,83,83,83,83,81,81,81,32,82,81,82,83,32,81,82,83,82,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,82,91,82,32,82,89,81,90,82,91,83,90,82,89,0,69,95,89,73,75,91,32,73,79,91,79,32,73,85,91,85,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,0,70,94,90,70,74,77,90,84,32,74,86,90,86,32,74,91,90,91,0,70,94,74,70,90,77,74,84,32,74,86,90,86,32,74,91,90,91,0,70,95,91,87,89,87,87,86,85,84,82,80,81,79,79,78,77,78,75,79,74,81,74,83,75,85,77,86,79,86,81,85,82,84,85,80,87,78,89,77,91,77,0,70,94,73,85,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,91,79,0,71,93,74,84,82,79,90,84,32,74,84,82,80,90,84,0,76,88,84,70,79,76,32,84,70,85,71,79,76,0,76,88,80,70,85,76,32,80,70,79,71,85,76,0,72,92,75,70,76,72,78,74,81,75,83,75,86,74,88,72,89,70,32,75,70,76,73,78,75,81,76,83,76,86,75,88,73,89,70,0,77,87,82,72,83,71,82,70,81,71,81,73,82,75,83,76,0,77,87,81,70,82,71,83,73,83,75,82,76,81,75,82,74,0,69,91,72,77,76,77,82,89,32,75,77,82,91,32,91,66,82,91,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,0,70,94,74,74,74,81,75,85,76,87,78,89,81,90,83,90,86,89,88,87,89,85,90,81,90,74,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,0,70,94,74,90,74,83,75,79,76,77,78,75,81,74,83,74,86,75,88,77,89,79,90,83,90,90,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,74,82,86,82,0,69,95,88,80,91,82,88,84,32,85,77,90,82,85,87,32,73,82,90,82,0,74,90,80,76,82,73,84,76,32,77,79,82,74,87,79,32,82,74,82,91,0,69,95,76,80,73,82,76,84,32,79,77,74,82,79,87,32,74,82,91,82,0,74,90,80,88,82,91,84,88,32,77,85,82,90,87,85,32,82,73,82,90,0,73,92,88,82,87,79,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,88,85,89,80,89,75,88,72,87,71,85,70,82,70,80,71,79,72,79,73,80,73,80,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,88,87,85,88,80,88,75,87,72,85,70,0,72,92,74,70,82,91,32,75,70,82,89,32,90,70,82,91,32,74,70,90,70,32,75,71,89,71,0,65,98,68,77,73,77,82,89,32,72,78,82,91,32,98,58,82,91,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,32,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,70,95,92,83,91,85,89,86,87,86,85,85,84,84,81,80,80,79,78,78,76,78,74,79,73,81,73,83,74,85,76,86,78,86,80,85,81,84,84,80,85,79,87,78,89,78,91,79,92,81,92,83,0,70,94,91,70,73,91,32,78,70,80,72,80,74,79,76,77,77,75,77,73,75,73,73,74,71,76,70,78,70,80,71,83,72,86,72,89,71,91,70,32,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,87,84,0,70,95,91,78,90,79,91,80,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,77,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,90,91,91,91,92,90,92,89,32,77,91,75,90,74,88,74,85,75,83,77,81,32,77,75,78,77,86,88,88,90,90,91,0,69,96,87,78,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,85,80,86,83,86,85,85,86,83,32,81,75,79,77,78,80,78,83,79,85,80,86,32,87,75,86,83,86,85,88,86,90,86,92,84,93,81,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,90,88,32,88,75,87,83,87,85,88,86,0,72,92,80,66,80,95,32,84,66,84,95,32,88,73,87,74,88,75,89,74,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,80,91,77,90,75,88,75,87,76,86,77,87,76,88,0,74,90,85,73,84,74,85,75,86,74,86,73,85,71,83,70,81,70,79,71,78,73,78,75,79,77,81,79,86,82,32,79,77,84,80,86,82,87,84,87,86,86,88,84,90,32,80,78,78,80,77,82,77,84,78,86,80,88,85,91,32,78,86,83,89,85,91,86,93,86,95,85,97,83,98,81,98,79,97,78,95,78,94,79,93,80,94,79,95,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,98,32,82,81,81,84,82,98,83,84,82,81,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,84,32,82,80,81,82,83,86,82,88,81,86,83,82,82,80,32,82,84,82,98,32,82,94,81,96,82,98,83,96,82,94,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,32,76,91,78,92,80,91,78,90,76,91,32,76,91,88,91,32,84,91,86,92,88,91,86,90,84,91,0,73,92,88,70,88,91,32,75,70,88,70,32,80,80,88,80,32,75,91,88,91,0,69,96,81,70,78,71,75,73,73,76,72,79,72,82,73,85,75,88,78,90,81,91,84,91,87,90,90,88,92,85,93,82,93,79,92,76,90,73,87,71,84,70,81,70,32,82,79,81,80,81,81,82,82,83,82,84,81,84,80,83,79,82,79,32,82,80,82,81,83,81,83,80,82,80,0,74,91,80,70,78,71,79,73,81,74,32,80,70,79,71,79,73,32,85,70,87,71,86,73,84,74,32,85,70,86,71,86,73,32,81,74,79,75,78,76,77,78,77,81,78,83,79,84,81,85,84,85,86,84,87,83,88,81,88,78,87,76,86,75,84,74,81,74,32,82,85,82,91,32,83,85,83,91,32,78,88,87,88,0,73,92,82,70,79,71,77,73,76,76,76,77,77,80,79,82,82,83,83,83,86,82,88,80,89,77,89,76,88,73,86,71,83,70,82,70,32,82,83,82,91,32,83,83,83,91,32,78,87,87,87,0,68,96,80,70,77,71,74,73,72,76,71,79,71,83,72,86,74,89,77,91,80,92,84,92,87,91,90,89,92,86,93,83,93,79,92,76,90,73,87,71,84,70,80,70,32,82,70,82,92,32,71,81,93,81,0,71,96,80,77,77,78,75,80,74,83,74,84,75,87,77,89,80,90,81,90,84,89,86,87,87,84,87,83,86,80,84,78,81,77,80,77,32,93,71,87,71,91,72,85,78,32,93,71,93,77,92,73,86,79,32,92,72,86,78,0,70,92,73,73,74,71,76,70,79,70,81,71,82,73,82,76,81,79,80,81,78,83,75,85,32,79,70,80,71,81,73,81,77,80,80,78,83,32,86,70,84,91,32,87,70,83,91,32,75,85,89,85,0,73,92,77,70,77,85,32,78,70,77,81,32,77,81,78,79,79,78,81,77,84,77,87,78,88,80,88,82,87,84,85,86,32,84,77,86,78,87,80,87,82,84,88,84,90,85,91,87,91,89,89,32,75,70,78,70,0,73,92,82,78,79,79,77,81,76,84,76,85,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,32,82,72,78,74,82,70,82,78,32,83,72,87,74,83,70,83,78,32,82,83,81,84,81,85,82,86,83,86,84,85,84,84,83,83,82,83,32,82,84,82,85,83,85,83,84,82,84,0,71,94,81,72,82,70,82,91,32,84,72,83,70,83,91,32,74,72,75,70,75,77,76,80,78,82,81,83,82,83,32,77,72,76,70,76,78,77,81,32,91,72,90,70,90,77,89,80,87,82,84,83,83,83,32,88,72,89,70,89,78,88,81,32,78,87,87,87,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,89,91,89,86,88,91,0,72,91,89,71,85,71,81,72,78,74,76,77,75,80,75,83,76,86,78,89,81,91,85,92,89,92,32,89,71,86,72,83,74,81,77,80,80,80,83,81,86,83,89,86,91,89,92,0,70,95,79,81,77,81,75,82,74,83,73,85,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,85,82,83,81,82,79,81,32,83,72,80,81,32,90,74,82,82,32,92,81,83,84,0,72,92,79,75,85,89,32,85,75,79,89,32,75,79,89,85,32,89,79,75,85,0,70,94,78,86,76,85,75,85,73,86,72,88,72,89,73,91,75,92,76,92,78,91,79,89,79,88,78,86,75,82,74,79,74,77,75,74,77,72,80,71,84,71,87,72,89,74,90,77,90,79,89,82,86,86,85,88,85,89,86,91,88,92,89,92,91,91,92,89,92,88,91,86,89,85,88,85,86,86,32,74,77,75,75,77,73,80,72,84,72,87,73,89,75,90,77,0,70,94,78,77,76,78,75,78,73,77,72,75,72,74,73,72,75,71,76,71,78,72,79,74,79,75,78,77,75,81,74,84,74,86,75,89,77,91,80,92,84,92,87,91,89,89,90,86,90,84,89,81,86,77,85,75,85,74,86,72,88,71,89,71,91,72,92,74,92,75,91,77,89,78,88,78,86,77,32,74,86,75,88,77,90,80,91,84,91,87,90,89,88,90,86,0,73,91,75,89,89,75,32,81,76,85,76,89,75,88,79,88,83,32,85,76,88,76,88,79,0,73,91,89,75,75,89,32,76,81,76,85,75,89,79,88,83,88,32,76,85,76,88,79,88,0,73,91,89,89,75,75,32,83,76,79,76,75,75,76,79,76,83,32,79,76,76,76,76,79,0,73,91,75,75,89,89,32,81,88,85,88,89,89,88,85,88,81,32,85,88,88,88,88,85,0,70,95,74,77,73,76,73,74,74,72,76,71,78,71,80,72,81,73,82,75,83,80,32,73,74,75,72,77,72,79,73,80,74,81,76,82,80,82,91,32,91,77,92,76,92,74,91,72,89,71,87,71,85,72,84,73,83,75,82,80,32,92,74,90,72,88,72,86,73,85,74,84,76,83,80,83,91,0,70,94,73,71,74,75,75,77,77,79,80,80,84,80,87,79,89,77,90,75,91,71,32,73,71,74,74,75,76,77,78,80,79,84,79,87,78,89,76,90,74,91,71,32,80,79,78,80,77,81,76,83,76,86,77,88,79,90,81,91,83,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,32,80,80,78,81,77,83,77,86,78,89,32,86,89,87,86,87,83,86,81,84,80,0,70,94,77,74,77,86,32,78,75,78,85,32,86,75,86,85,32,87,74,87,86,32,73,71,75,73,77,74,80,75,84,75,87,74,89,73,91,71,32,73,89,75,87,77,86,80,85,84,85,87,86,89,87,91,89,0,70,94,91,73,76,73,74,74,73,76,73,78,74,80,76,81,78,81,80,80,81,78,81,76,80,74,91,74,32,73,77,74,79,75,80,77,81,32,81,77,80,75,79,74,77,73,32,73,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,84,81,83,83,83,85,84,87,73,87,32,91,84,90,82,89,81,87,80,32,83,84,84,86,85,87,87,88,0,70,93,79,85,77,84,76,84,74,85,73,87,73,88,74,90,76,91,77,91,79,90,80,88,80,87,79,85,74,80,73,78,73,75,74,73,76,72,79,71,83,71,87,72,89,74,90,76,90,79,89,82,86,85,85,87,85,89,86,91,88,91,89,90,90,88,32,77,83,75,80,74,78,74,75,75,73,76,72,32,83,71,86,72,88,74,89,76,89,79,88,82,86,85,0,71,95,72,75,75,72,77,75,77,86,32,74,73,76,76,76,86,32,77,75,80,72,82,75,82,85,32,79,73,81,76,81,85,32,82,75,85,72,87,75,87,91,32,84,73,86,76,86,91,32,87,75,90,72,91,74,92,77,92,80,91,83,90,85,88,87,85,89,80,91,32,89,73,90,74,91,77,91,80,90,83,89,85,87,87,84,89,80,91,0,70,94,73,83,77,83,76,82,75,79,75,77,76,74,78,72,81,71,83,71,86,72,88,74,89,77,89,79,88,82,87,83,91,83,32,73,84,79,84,77,82,76,79,76,77,77,74,79,72,81,71,32,83,71,85,72,87,74,88,77,88,79,87,82,85,84,91,84,32,75,88,89,88,32,75,89,89,89,0,70,95,71,76,74,73,77,76,77,88,32,73,74,76,77,76,88,32,77,76,80,73,83,76,83,88,32,79,74,82,77,82,88,32,83,76,86,73,89,76,89,87,91,89,32,85,74,88,77,88,88,90,90,93,87,0,71,93,90,73,74,89,32,90,73,87,74,81,74,32,88,75,85,75,81,74,32,90,73,89,76,89,82,32,88,75,88,78,89,82,32,81,82,74,82,32,80,83,77,83,74,82,32,81,82,81,89,32,80,83,80,86,81,89,0,70,94,72,79,74,75,79,85,32,74,77,79,87,82,80,87,80,90,79,91,77,91,75,90,73,88,72,87,72,85,73,84,75,84,77,85,80,86,82,87,85,87,88,85,90,32,87,72,86,73,85,75,85,77,87,81,88,84,88,87,87,89,85,90,0,70,94,73,79,76,76,80,78,32,75,77,79,79,82,76,85,78,32,81,77,84,79,87,76,89,78,32,86,77,88,79,91,76,32,73,85,76,82,80,84,32,75,83,79,85,82,82,85,84,32,81,83,84,85,87,82,89,84,32,86,83,88,85,91,82,0,70,94,74,72,78,74,80,76,81,79,81,82,80,85,78,87,74,89,32,74,72,77,73,79,74,81,76,82,79,32,82,82,81,85,79,87,77,88,74,89,32,90,72,87,73,85,74,83,76,82,79,32,82,82,83,85,85,87,87,88,90,89,32,90,72,86,74,84,76,83,79,83,82,84,85,86,87,90,89,32,73,80,91,80,32,73,81,91,81,0,78,86,81,81,81,83,83,83,83,81,81,81,32,81,81,83,83,32,83,81,81,83,0,74,90,77,80,81,82,84,84,86,86,87,89,87,91,86,93,85,94,32,77,81,83,84,32,77,82,80,83,84,85,86,87,87,89,0,74,90,87,75,86,77,84,79,80,81,77,82,32,83,80,77,83,32,85,70,86,71,87,73,87,75,86,78,84,80,81,82,77,84,0,72,92,83,77,79,78,76,80,75,82,75,84,76,86,78,87,81,87,85,86,88,84,89,82,89,80,88,78,86,77,83,77,32,88,78,83,77,32,86,77,81,78,76,80,32,79,78,75,82,32,76,86,81,87,32,78,87,83,86,88,84,32,85,86,89,82,0,74,91,83,77,80,78,78,80,77,82,77,84,78,86,80,87,82,87,85,86,87,84,88,82,88,80,87,78,85,77,83,77,32,79,80,85,77,32,78,82,86,78,32,77,84,87,79,32,78,85,88,80,32,79,86,87,82,32,80,87,86,84,0,74,90,79,71,79,94,32,85,70,85,93,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,0,74,90,78,70,78,88,32,86,76,86,94,32,78,78,86,76,32,78,79,86,77,32,78,87,86,85,32,78,88,86,86,0,74,90,78,66,78,87,32,78,78,81,76,84,76,86,77,87,79,87,81,86,83,83,85,81,86,78,87,32,78,78,81,77,84,77,86,78,32,85,77,86,79,86,81,85,83,83,85,0,69,95,72,73,72,76,32,92,73,92,76,32,72,73,92,73,32,72,74,92,74,32,72,75,92,75,32,72,76,92,76,0,74,90,77,78,77,81,32,87,78,87,81,32,77,78,87,78,32,77,79,87,79,32,77,80,87,80,32,77,81,87,81,0,74,90,77,76,87,88,32,77,76,79,78,81,79,84,79,86,78,87,77,87,75,85,75,85,77,84,79,32,79,78,84,79,32,81,79,87,77,32,86,75,86,78,32,85,76,87,76,32,87,88,85,86,83,85,80,85,78,86,77,87,77,89,79,89,79,87,80,85,32,85,86,80,85,32,83,85,77,87,32,78,86,78,89,32,77,88,79,88,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,87,89,0,65,94,71,102,72,102,73,101,73,100,72,99,71,99,70,100,70,102,71,104,73,105,75,105,78,104,80,102,81,100,82,96,82,85,81,59,81,52,82,47,83,45,85,44,86,44,88,45,89,47,89,51,88,54,87,56,85,59,80,63,74,67,72,69,70,72,69,74,68,78,68,82,69,86,71,89,74,91,78,92,82,92,86,91,88,90,90,87,91,84,91,80,90,77,89,75,87,73,84,72,80,72,77,73,75,75,74,78,74,82,75,85,77,87,32,71,100,71,101,72,101,72,100,71,100,32,85,59,81,63,76,67,73,70,71,73,70,75,69,78,69,82,70,86,71,88,74,91,32,82,92,85,91,87,90,89,87,90,84,90,80,89,77,88,75,86,73,84,72,0,69,102,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,79,79,78,80,77,83,77,86,78,89,80,91,83,92,86,92,89,91,91,89,92,87,93,84,93,80,92,77,90,74,88,73,85,72,82,72,79,73,77,74,75,76,73,79,72,83,72,88,73,93,75,97,77,99,80,101,84,102,89,102,93,101,96,99,98,97,32,75,76,74,78,73,82,73,88,74,92,76,96,78,98,81,100,85,101,89,101,93,100,95,99,98,97,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,97,76,97,78,99,78,99,76,97,76,32,98,76,98,78,32,97,77,99,77,32,97,86,97,88,99,88,99,86,97,86,32,98,86,98,88,32,97,87,99,87,0,68,96,72,64,72,100,32,77,64,77,100,32,87,64,87,100,32,92,64,92,100,32,77,77,87,75,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,32,77,89,87,87,0,72,92,80,77,77,78,76,79,75,81,75,83,76,85,77,86,80,87,84,87,87,86,88,85,89,83,89,81,88,79,87,78,84,77,80,77,32,77,78,76,80,76,83,77,85,78,86,80,87,32,87,86,88,84,88,81,87,79,86,78,84,77,0,74,90,81,67,86,77,82,84,82,85,32,85,76,81,83,32,84,73,84,75,80,82,82,85,85,89,32,87,92,85,89,83,88,81,88,79,89,78,91,78,93,79,95,82,97,32,87,92,85,90,83,89,79,89,79,93,80,95,82,97,32,83,88,80,90,78,93,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,83,89,0,73,106,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,79,85,78,84,77,81,77,78,78,75,80,73,83,72,87,72,91,73,94,75,96,78,97,82,97,87,96,91,95,93,93,96,90,99,86,102,81,105,77,107,32,87,72,90,73,93,75,95,78,96,82,96,87,95,91,94,93,92,96,89,99,84,103,81,105,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,101,76,101,78,103,78,103,76,101,76,32,102,76,102,78,32,101,77,103,77,32,101,86,101,88,103,88,103,86,101,86,32,102,86,102,88,32,101,87,103,87,0,68,96,72,62,72,102,32,73,62,73,102,32,77,62,77,102,32,81,66,83,66,83,68,81,68,81,65,82,63,84,62,87,62,89,63,91,65,92,68,92,73,91,76,89,78,87,79,85,79,83,78,82,76,81,78,79,81,78,82,79,83,81,86,82,88,83,86,85,85,87,85,89,86,91,88,92,91,92,96,91,99,89,101,87,102,84,102,82,101,81,99,81,96,83,96,83,98,81,98,32,82,66,82,68,32,81,67,83,67,32,89,63,90,65,91,68,91,73,90,76,89,78,32,82,76,82,78,80,81,78,82,80,83,82,86,82,88,32,89,86,90,88,91,91,91,96,90,99,89,101,32,82,96,82,98,32,81,97,83,97,0,65,99,72,66,72,98,32,73,66,73,98,32,91,66,91,98,32,92,66,92,98,32,68,66,96,66,32,68,98,77,98,32,87,98,96,98,0,66,97,71,66,81,80,70,98,32,70,66,80,80,32,69,66,80,81,32,69,66,92,66,94,73,91,66,32,71,97,92,97,32,70,98,92,98,94,91,91,98,0,73,91,88,43,85,49,82,56,80,61,79,65,78,70,77,78,77,86,78,94,79,99,80,103,82,108,85,115,88,121,32,85,49,83,54,81,60,80,64,79,70,78,78,78,86,79,94,80,100,81,104,83,110,85,115,0,73,91,76,43,79,49,82,56,84,61,85,65,86,70,87,78,87,86,86,94,85,99,84,103,82,108,79,115,76,121,32,79,49,81,54,83,60,84,64,85,70,86,78,86,86,85,94,84,100,83,104,81,110,79],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+327680);allocate([115,0,73,91,77,43,77,82,77,121,32,78,43,78,82,78,121,32,77,43,88,43,32,77,121,88,121,0,73,91,86,43,86,82,86,121,32,87,43,87,82,87,121,32,76,43,87,43,32,76,121,87,121,0,72,91,86,43,82,49,80,53,79,58,79,62,80,66,84,74,84,76,83,78,82,79,77,82,82,85,83,86,84,88,84,90,80,98,79,102,79,106,80,111,82,115,86,121,32,84,46,82,50,81,53,80,58,80,62,81,67,82,70,32,82,94,81,97,80,102,80,106,81,111,82,114,84,118,0,73,92,78,43,82,49,84,53,85,58,85,62,84,66,80,74,80,76,81,78,82,79,87,82,82,85,81,86,80,88,80,90,84,98,85,102,85,106,84,111,82,115,78,121,32,80,46,82,50,83,53,84,58,84,62,83,67,82,70,32,82,94,83,97,84,102,84,106,83,111,82,114,80,118,0,73,91,86,46,83,49,81,52,79,56,78,61,78,67,79,73,80,77,83,88,84,92,85,98,85,103,84,108,83,111,81,115,32,83,49,81,53,80,56,79,61,79,66,80,72,81,76,84,87,85,91,86,97,86,103,85,108,83,112,81,115,78,118,0,73,91,78,46,81,49,83,52,85,56,86,61,86,67,85,73,84,77,81,88,80,92,79,98,79,103,80,108,81,111,83,115,32,81,49,83,53,84,56,85,61,85,66,84,72,83,76,80,87,79,91,78,97,78,103,79,108,81,112,83,115,86,118,0,55,90,58,82,65,82,82,111,32,64,82,81,111,32,63,82,82,114,32,90,34,86,74,82,114,0,67,97,93,46,92,46,91,47,91,48,92,49,93,49,94,48,94,46,93,44,91,43,89,43,87,44,85,46,84,48,83,51,82,58,81,74,81,106,80,115,79,118,32,92,47,92,48,93,48,93,47,92,47,32,82,58,82,106,32,85,46,84,49,83,58,83,90,82,106,81,113,80,116,79,118,77,120,75,121,73,121,71,120,70,118,70,116,71,115,72,115,73,116,73,117,72,118,71,118,32,71,116,71,117,72,117,72,116,71,116,0,72,92,82,70,74,91,32,82,73,75,91,74,91,32,82,73,89,91,90,91,32,82,70,90,91,32,77,85,87,85,32,76,86,88,86,0,72,92,76,70,76,91,32,77,71,77,90,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,32,77,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,76,91,32,77,81,84,81,87,82,88,84,88,87,87,89,84,90,77,90,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,77,75,76,78,76,83,77,86,79,89,81,90,85,90,87,89,88,88,89,86,90,86,0,72,93,76,70,76,91,32,77,71,77,90,32,76,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,76,91,32,77,71,83,71,86,72,87,73,88,75,89,78,89,83,88,86,87,88,86,89,83,90,77,90,0,73,92,77,70,77,91,32,78,71,78,90,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,32,78,90,89,90,89,91,32,77,91,89,91,0,73,91,77,70,77,91,32,78,71,78,91,77,91,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,82,85,82,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,78,73,77,75,76,78,76,83,77,86,78,88,79,89,81,90,85,90,87,89,88,88,89,86,89,83,85,83,85,82,0,71,93,75,70,75,91,32,75,70,76,70,76,91,75,91,32,89,70,88,70,88,91,89,91,32,89,70,89,91,32,76,80,88,80,32,76,81,88,81,0,78,87,82,70,82,91,83,91,32,82,70,83,70,83,91,0,74,91,86,70,86,86,85,89,83,90,81,90,79,89,78,86,77,86,32,86,70,87,70,87,86,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,72,93,76,70,76,91,77,91,32,76,70,77,70,77,91,32,90,70,89,70,77,82,32,90,70,77,83,32,80,79,89,91,90,91,32,81,79,90,91,0,73,90,77,70,77,91,32,77,70,78,70,78,90,32,78,90,89,90,89,91,32,77,91,89,91,0,70,94,74,70,74,91,32,75,75,75,91,74,91,32,75,75,82,91,32,74,70,82,88,32,90,70,82,88,32,89,75,82,91,32,89,75,89,91,90,91,32,90,70,90,91,0,71,93,75,70,75,91,32,76,73,76,91,75,91,32,76,73,89,91,32,75,70,88,88,32,88,70,88,88,32,88,70,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,77,81,32,77,71,85,71,87,72,88,74,88,77,87,79,85,80,77,80,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,32,83,88,88,93,89,93,32,83,88,84,88,89,93,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,77,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,77,80,32,82,81,88,91,89,91,32,83,81,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,84,81,86,82,87,83,88,85,88,88,87,89,84,90,80,90,78,89,77,88,75,88,32,89,73,87,73,86,72,84,71,80,71,77,72,76,73,76,75,77,77,79,78,84,80,86,81,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,91,82,71,82,91,32,83,71,83,91,82,91,32,76,70,89,70,89,71,32,76,70,76,71,89,71,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,75,70,76,70,76,85,77,88,78,89,81,90,83,90,86,89,87,88,88,85,88,70,89,70,0,72,92,74,70,82,91,32,74,70,75,70,82,88,32,90,70,89,70,82,88,32,90,70,82,91,0,69,95,71,70,77,91,32,71,70,72,70,77,88,32,82,70,77,88,32,82,73,77,91,32,82,73,87,91,32,82,70,87,88,32,93,70,92,70,87,88,32,93,70,87,91,0,72,92,75,70,88,91,89,91,32,75,70,76,70,89,91,32,89,70,88,70,75,91,32,89,70,76,91,75,91,0,73,92,75,70,82,80,82,91,83,91,32,75,70,76,70,83,80,32,90,70,89,70,82,80,32,90,70,83,80,83,91,0,72,92,88,70,75,91,32,89,70,76,91,32,75,70,89,70,32,75,70,75,71,88,71,32,76,90,89,90,89,91,32,75,91,89,91,0,69,92,88,70,86,72,84,75,81,80,79,83,76,87,73,90,71,91,69,91,68,90,68,88,69,87,70,88,69,89,32,88,70,87,74,85,84,84,91,32,88,70,85,91,32,84,91,84,89,83,86,82,84,80,82,78,81,76,81,75,82,75,84,76,87,79,90,82,91,86,91,88,90,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,88,70,90,71,91,73,91,75,90,77,88,78,84,79,82,79,32,88,70,89,71,90,73,90,75,89,77,88,78,32,84,79,87,80,88,81,89,83,89,86,88,89,87,90,85,91,83,91,82,90,82,88,83,85,32,84,79,86,80,87,81,88,83,88,86,87,89,85,91,0,72,93,75,72,74,74,74,76,75,78,78,79,81,79,85,78,87,77,89,75,90,73,90,71,89,70,87,70,84,71,81,74,79,77,77,81,76,85,76,88,77,90,80,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,87,70,85,71,82,74,80,77,78,81,77,85,77,88,78,90,80,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,74,87,76,88,78,90,80,91,83,91,85,90,87,88,89,84,90,79,90,76,89,73,87,71,85,70,80,70,77,71,75,73,74,75,74,77,75,78,77,78,78,77,79,75,0,73,92,87,73,86,74,86,76,87,77,89,77,90,75,90,73,89,71,87,70,84,70,82,71,81,72,80,74,80,76,81,78,83,79,32,84,70,82,72,81,74,81,77,83,79,32,83,79,81,79,78,80,76,82,75,84,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,81,79,79,80,77,82,76,84,76,88,77,90,0,71,92,87,72,86,74,84,79,82,85,81,87,79,90,77,91,32,81,76,80,78,78,79,76,79,75,77,75,75,76,73,78,71,81,70,91,70,88,71,87,72,86,75,84,83,83,86,82,88,80,90,77,91,75,91,73,90,72,89,72,88,73,87,74,88,73,89,32,83,70,87,71,88,71,32,79,83,80,82,82,81,86,81,88,80,90,77,88,84,0,71,93,74,73,73,75,73,77,74,79,76,80,79,80,82,79,84,78,87,75,88,72,88,71,87,70,86,70,84,71,82,73,81,75,80,78,80,81,81,83,83,84,85,84,87,83,89,81,90,79,32,87,70,85,71,83,73,82,75,81,78,81,82,83,84,32,90,79,89,83,87,87,85,89,83,90,79,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,32,89,83,87,86,85,88,82,90,79,91,0,70,94,76,76,75,75,75,73,76,71,79,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,74,84,75,83,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,71,88,74,87,76,85,82,84,86,84,89,86,91,87,91,89,90,91,88,32,92,70,90,72,88,76,86,82,85,86,85,89,86,91,0,73,89,87,72,85,75,83,80,81,85,80,87,78,90,76,91,32,89,76,87,78,84,79,81,79,79,78,78,76,78,74,79,72,81,71,85,70,89,70,87,72,86,74,84,80,82,86,81,88,79,90,76,91,74,91,73,90,73,88,74,87,75,88,74,89,0,73,90,89,70,87,72,85,75,83,80,80,89,78,93,32,89,77,87,79,84,80,81,80,79,79,78,77,78,75,79,73,81,71,85,70,89,70,87,73,86,75,83,84,81,88,80,90,78,93,77,94,75,95,74,94,74,92,75,90,77,88,79,87,82,86,86,85,0,70,94,76,76,75,75,75,73,77,71,80,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,90,71,87,75,85,77,83,78,80,79,32,93,71,92,72,93,73,94,72,94,71,93,70,92,70,90,71,87,76,86,77,84,78,80,79,32,80,79,83,80,84,82,85,89,86,91,32,80,79,82,80,83,82,84,89,86,91,87,91,89,90,91,88,0,73,91,77,73,76,75,76,77,77,79,79,80,82,80,85,79,87,78,90,75,91,72,91,71,90,70,89,70,87,71,86,72,84,75,80,85,79,87,77,90,75,91,32,86,72,84,76,82,83,81,86,80,88,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,82,91,85,91,87,90,89,88,0,68,96,82,70,78,79,75,85,73,88,71,90,69,91,67,91,66,90,66,88,67,87,68,88,67,89,32,82,70,80,77,79,81,78,86,78,90,80,91,32,82,70,81,74,80,79,79,86,79,90,80,91,32,91,70,87,79,82,88,80,91,32,91,70,89,77,88,81,87,86,87,90,89,91,90,91,92,90,94,88,32,91,70,90,74,89,79,88,86,88,90,89,91,0,71,94,82,70,81,74,79,80,77,85,76,87,74,90,72,91,70,91,69,90,69,88,70,87,71,88,70,89,32,82,70,82,75,83,86,84,91,32,82,70,83,75,84,86,84,91,32,96,71,95,72,96,73,97,72,97,71,96,70,94,70,92,71,90,74,89,76,87,81,85,87,84,91,0,72,93,83,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,87,71,85,72,83,74,81,78,80,83,80,86,32,81,71,79,74,77,78,76,82,76,86,77,89,79,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,86,70,89,71,90,72,91,74,91,77,90,79,89,80,86,81,84,81,82,80,32,86,70,88,71,89,72,90,74,90,77,89,79,88,80,86,81,0,72,93,85,74,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,88,90,90,88,32,87,70,88,71,89,73,89,77,88,80,86,83,83,86,79,89,75,91,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,87,70,90,71,91,73,91,75,90,77,89,78,86,79,82,79,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,82,79,85,80,86,82,87,89,88,91,32,82,79,84,80,85,82,86,89,88,91,89,91,91,90,93,88,0,72,92,78,73,77,75,77,77,78,79,80,80,83,80,86,79,88,78,91,75,92,72,92,71,91,70,90,70,88,71,87,72,86,74,85,77,83,84,82,87,80,90,78,91,32,86,74,85,78,84,85,83,88,81,90,78,91,75,91,73,90,72,88,72,87,73,86,74,87,73,88,0,73,91,89,72,88,74,86,79,84,85,83,87,81,90,79,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,92,70,90,71,89,72,88,75,86,83,85,86,84,88,82,90,79,91,77,91,75,90,74,89,74,88,75,87,76,88,75,89,32,85,70,89,71,90,71,0,71,93,72,74,74,71,76,70,77,70,79,72,79,75,78,78,75,86,75,89,76,91,32,77,70,78,72,78,75,75,83,74,86,74,89,76,91,78,91,80,90,83,87,85,84,86,82,32,90,70,86,82,85,86,85,89,87,91,88,91,90,90,92,88,32,91,70,87,82,86,86,86,89,87,91,0,71,92,72,74,74,71,76,70,77,70,79,72,79,75,78,79,76,86,76,89,77,91,32,77,70,78,72,78,75,76,82,75,86,75,89,77,91,78,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,76,87,78,89,80,91,81,93,81,0,70,93,73,76,72,76,71,75,71,73,72,71,74,70,78,70,77,72,76,76,75,85,74,91,32,76,76,76,85,75,91,32,86,70,84,72,82,76,79,85,77,89,75,91,32,86,70,85,72,84,76,83,85,82,91,32,84,76,84,85,83,91,32,96,70,94,71,92,73,90,76,87,85,85,89,83,91,0,72,92,80,75,79,76,77,76,76,75,76,73,77,71,79,70,81,70,83,71,84,73,84,76,83,80,81,85,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,81,70,82,71,83,73,83,76,82,80,80,85,78,88,76,90,74,91,32,93,71,92,72,93,73,94,72,94,71,93,70,91,70,89,71,87,73,85,76,83,80,82,85,82,88,83,90,84,91,85,91,87,90,89,88,0,71,93,74,74,76,71,78,70,79,70,81,71,81,73,79,79,79,82,80,84,32,79,70,80,71,80,73,78,79,78,82,80,84,82,84,85,83,87,81,89,78,90,76,32,92,70,90,76,87,84,85,88,32,93,70,91,76,89,81,87,85,85,88,83,90,80,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,0,71,92,90,72,89,74,87,79,86,82,85,84,83,87,81,89,79,90,76,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,93,70,91,71,90,72,89,75,88,79,86,85,84,88,81,90,76,91,72,91,71,90,71,88,72,87,74,87,76,88,79,90,81,91,84,91,87,90,89,88,32,86,70,90,71,91,71,0,72,92,87,77,87,91,88,91,32,87,77,88,77,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,88,80,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,72,92,87,70,87,91,88,91,32,87,70,88,70,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,73,91,77,84,88,84,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,77,83,87,83,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,76,90,87,70,85,70,83,71,82,74,82,91,83,91,32,87,70,87,71,85,71,83,72,32,84,71,83,74,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,88,77,87,77,87,92,86,95,85,96,83,97,81,97,79,96,78,95,76,95,32,88,77,88,92,87,95,85,97,83,98,80,98,78,97,76,95,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,91,83,91,32,82,77,83,77,83,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,98,83,98,32,82,77,83,77,83,98,0,72,91,76,70,76,91,77,91,32,76,70,77,70,77,91,32,88,77,87,77,77,87,32,88,77,77,88,32,80,84,86,91,88,91,32,81,83,88,91,0,67,98,71,77,71,91,72,91,32,71,77,72,77,72,91,32,72,81,75,78,77,77,80,77,82,78,83,81,83,91,32,72,81,75,79,77,78,79,78,81,79,82,81,82,91,83,91,32,83,81,86,78,88,77,91,77,93,78,94,81,94,91,32,83,81,86,79,88,78,90,78,92,79,93,81,93,91,94,91,0,72,92,76,77,76,91,77,91,32,76,77,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,32,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,88,88,85,88,83,87,80,86,79,84,78,81,78,0,72,92,76,77,76,98,77,98,32,76,77,77,77,77,98,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,72,92,87,77,87,98,88,98,32,87,77,88,77,88,98,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,75,89,79,77,79,91,80,91,32,79,77,80,77,80,91,32,80,83,81,80,83,78,85,77,88,77,32,80,83,81,81,83,79,85,78,88,78,88,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,85,87,86,32,86,85,87,87,87,88,86,90,32,87,89,84,90,81,90,78,89,32,79,90,78,88,77,88,32,88,80,87,80,86,78,32,87,79,84,78,81,78,78,79,32,79,78,78,80,79,82,32,78,81,80,82,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,88,82,70,82,91,83,91,32,82,70,83,70,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,76,77,76,87,77,90,79,91,82,91,84,90,87,87,32,76,77,77,77,77,87,78,89,80,90,82,90,84,89,87,87,32,87,77,87,91,88,91,32,87,77,88,77,88,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,32,88,77,82,91,0,70,94,73,77,78,91,32,73,77,74,77,78,88,32,82,77,78,88,32,82,80,78,91,32,82,80,86,91,32,82,77,86,88,32,91,77,90,77,86,88,32,91,77,86,91,0,73,91,76,77,87,91,88,91,32,76,77,77,77,88,91,32,88,77,87,77,76,91,32,88,77,77,91,76,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,78,98,32,88,77,82,91,79,98,78,98,0,73,91,86,78,76,91,32,88,77,78,90,32,76,77,88,77,32,76,77,76,78,86,78,32,78,90,88,90,88,91,32,76,91,88,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,76,90,76,86,78,83,80,79,32,83,70,77,88,77,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,88,87,90,86,32,84,70,78,88,78,90,79,91,0,76,88,84,83,83,84,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,90,70,84,88,84,90,86,91,88,90,89,89,91,86,32,91,70,85,88,85,90,86,91,0,76,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,79,88,82,82,85,79,87,76,88,73,88,71,87,70,85,71,84,73,75,100,75,102,76,103,78,102,79,99,80,90,81,91,83,91,85,90,86,89,88,86,32,84,73,83,78,82,82,79,91,77,96,75,100,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,91,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,79,88,79,90,81,91,83,90,84,89,86,86,32,82,82,80,88,80,90,81,91,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,75,100,32,82,82,79,91,77,96,75,100,74,102,72,103,71,102,71,100,72,97,74,95,77,93,81,91,84,89,86,86,0,76,90,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,85,82,85,83,86,83,85,82,84,82,82,84,79,85,32,79,85,82,86,83,90,84,91,32,79,85,81,86,82,90,84,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,0,69,94,69,86,71,83,73,82,75,83,75,85,73,91,32,73,82,74,83,74,85,72,91,32,75,85,77,83,79,82,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,89,83,89,85,88,88,88,90,89,91,32,87,82,88,83,88,85,87,88,87,90,89,91,91,90,92,89,94,86,0,73,91,73,86,75,83,77,82,79,83,79,85,77,91,32,77,82,78,83,78,85,76,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,89,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,86,88,88,87,89,86,32,80,82,78,84,77,86,77,89,79,91,0,76,91,76,86,78,83,80,79,32,81,76,72,103,32,82,76,73,103,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,80,102,81,103,83,102,84,99,84,91,86,91,89,89,91,86,32,87,82,84,91,82,96,80,100,0,76,90,76,86,78,83,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,86,85,32,86,82,86,85,87,87,88,87,90,86,0,78,90,78,86,80,83,81,81,81,83,84,85,85,87,85,89,84,90,82,91,32,81,83,83,85,84,87,84,89,82,91,32,78,90,80,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,32,80,78,86,78,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,75,90,78,82,77,84,76,87,76,90,78,91,79,91,82,90,84,88,85,85,85,82,32,79,82,78,84,77,87,77,90,78,91,32,85,82,86,86,87,87,88,87,90,86,0,72,93,76,82,74,84,73,87,73,90,75,91,76,91,78,90,80,88,32,77,82,75,84,74,87,74,90,75,91,32,82,82,80,88,80,90,82,91,83,91,85,90,87,88,88,85,88,82,32,83,82,81,88,81,90,82,91,32,88,82,89,86,90,87,91,87,93,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,85,80,88,79,90,77,91,76,91,75,90,75,89,76,89,75,90,32,87,83,86,84,87,84,87,83,86,82,85,82,83,83,82,85,81,88,81,90,82,91,85,91,88,89,90,86,32,81,83,82,85,32,83,83,81,85,32,80,88,81,90,32,81,88,79,90,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,89,76,86,78,83,80,82,82,82,84,83,84,86,83,88,80,90,78,91,32,82,82,83,83,83,86,82,88,80,90,32,78,91,80,92,81,94,81,97,80,100,78,102,76,103,75,102,75,100,76,97,79,94,82,92,86,89,89,86,32,78,91,79,92,80,94,80,97,79,100,78,102,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,79,71,77,74,76,79,76,82,77,87,79,90,32,78,89,81,90,83,90,86,89,32,85,90,87,87,88,82,88,79,87,74,85,71,32,86,72,83,71,81,71,78,72,0,72,92,78,74,80,73,83,70,83,91,32,78,74,78,75,80,74,82,72,82,91,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,76,91,32,76,75,77,75,77,74,78,72,80,71,84,71,86,72,87,74,87,76,86,78,84,81,75,91,32,76,90,89,90,89,91,32,75,91,89,91,0,72,92,77,70,88,70,81,79,32,77,70,77,71,87,71,32,87,70,80,79,32,81,78,83,78,86,79,88,81,89,84,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,80,79,83,79,86,80,88,83,32,84,79,87,81,88,84,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,85,73,85,91,86,91,32,86,70,86,91,32,86,70,75,86,90,86,32,85,73,76,86,32,76,85,90,85,90,86,0,72,92,77,70,76,79,32,78,71,77,78,32,77,70,87,70,87,71,32,78,71,87,71,32,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,76,79,77,79,79,78,83,78,86,79,88,82,32,84,78,87,80,88,83,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,86,71,87,73,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,32,87,72,84,71,82,71,79,72,32,80,71,78,74,77,79,77,84,78,88,81,90,32,77,86,79,89,82,90,83,90,86,89,88,86,32,84,90,87,88,88,85,88,84,87,81,84,79,32,88,83,86,80,83,79,82,79,79,80,77,83,32,81,79,78,81,77,84,0,72,92,75,70,89,70,79,91,32,75,70,75,71,88,71,32,88,70,78,91,79,91,0,72,92,80,70,77,71,76,73,76,75,77,77,78,78,80,79,84,80,86,81,87,82,88,84,88,87,87,89,84,90,80,90,77,89,76,87,76,84,77,82,78,81,80,80,84,79,86,78,87,77,88,75,88,73,87,71,84,70,80,70,32,78,71,77,73,77,75,78,77,80,78,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,80,79,84,78,86,77,87,75,87,73,86,71,32,87,72,84,71,80,71,77,72,32,76,88,79,90,32,85,90,88,88,0,72,92,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,77,88,78,90,32,87,77,86,80,83,82,32,87,78,85,81,82,82,81,82,78,81,76,78,32,80,82,77,80,76,77,76,76,77,73,80,71,32,76,75,78,72,81,71,82,71,85,72,87,75,32,83,71,86,73,87,77,87,82,86,87,84,90,32,85,89,82,90,80,90,77,89,0,77,88,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,70,82,84,83,84,32,82,70,83,70,83,84,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,76,75,76,74,77,72,78,71,81,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,82,81,32,76,75,77,75,77,74,78,72,81,71,84,71,87,72,88,74,88,76,87,78,85,79,82,80,32,77,73,80,71,32,85,71,88,73,32,88,77,84,80,32,82,80,82,84,83,84,83,80,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,70,82,71,81,73,81,76,82,77,83,77,84,76,84,75,83,74,82,74,81,75,32,82,75,82,76,83,76,83,75,82,75,32,82,71,81,75,32,81,73,82,74,0,77,88,84,72,83,73,82,73,81,72,81,71,82,70,83,70,84,71,84,74,83,76,81,77,32,82,71,82,72,83,72,83,71,82,71,32,83,73,84,74,32,84,72,83,76,0,70,95,92,77,90,77,88,78,87,80,85,86,84,88,83,89,81,90,77,90,75,89,74,87,74,85,75,83,76,82,81,79,83,77,84,75,84,73,83,71,81,70,80,70,78,71,77,73,77,75,78,78,80,81,85,87,88,90,90,91,92,91,32,92,77,92,78,90,78,87,80,32,90,77,88,80,86,86,85,88,83,90,81,91,77,91,75,90,74,89,73,87,73,85,74,83,76,81,81,78,82,77,83,75,83,73,82,71,32,83,72,81,71,80,71,78,72,32,79,71,78,73,78,75,79,78,81,81,86,87,88,89,90,90,92,90,92,91,0,73,92,82,66,82,95,83,95,32,82,66,83,66,83,95,32,87,73,89,73,87,71,84,70,81,70,78,71,76,73,76,75,77,77,78,78,86,82,87,83,88,85,88,87,87,89,84,90,81,90,79,89,78,88,32,87,73,86,72,84,71,81,71,78,72,77,73,77,75,78,77,86,81,88,83,89,85,89,87,88,89,87,90,84,91,81,91,78,90,76,88,78,88,32,88,88,85,90,0,71,94,91,66,73,98,74,98,32,91,66,92,66,74,98,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,86,98,32,85,66,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,79,98,32,78,66,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,0,74,90,82,70,81,71,83,81,82,82,32,82,70,82,82,32,82,70,83,71,81,81,82,82,32,77,73,78,73,86,79,87,79,32,77,73,87,79,32,77,73,77,74,87,78,87,79,32,87,73,86,73,78,79,77,79,32,87,73,77,79,32,87,73,87,74,77,78,77,79,0,70,95,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,82,73,82,90,83,90,32,82,73,83,73,83,90,32,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,74,77,91,77,91,78,32,74,77,74,78,91,78,32,74,85,91,85,91,86,32,74,85,74,86,91,86,0,78,87,83,70,82,71,82,77,32,83,71,82,77,32,83,70,84,71,82,77,0,73,91,78,70,77,71,77,77,32,78,71,77,77,32,78,70,79,71,77,77,32,87,70,86,71,86,77,32,87,71,86,77,32,87,70,88,71,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,32,81,70,78,73,79,77,83,78,86,75,85,71,81,70,32,83,70,79,71,78,75,81,78,85,77,86,73,83,70,0,70,94,90,73,74,82,90,91,32,90,73,90,74,76,82,90,90,90,91,0,70,94,74,73,90,82,74,91,32,74,73,74,74,88,82,74,90,74,91,0,71,94,79,70,79,98,80,98,32,79,70,80,70,80,98,32,85,70,85,98,86,98,32,85,70,86,70,86,98,32,74,80,91,80,91,81,32,74,80,74,81,91,81,32,74,87,91,87,91,88,32,74,87,74,88,91,88,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,73,91,32,91,70,92,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,78,70,74,71,73,75,77,77,80,74,78,70,32,76,70,73,73,75,77,79,76,80,72,76,70,32,89,84,85,85,84,89,88,91,91,88,89,84,32,87,84,84,87,86,91,90,90,91,86,87,84,0,69,96,87,77,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,87,84,32,87,77,84,76,81,76,79,77,78,79,78,82,79,84,81,85,84,85,87,84,32,86,75,86,83,87,85,89,86,90,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,85,91,89,90,32,86,75,87,75,87,83,88,85,90,86,32,89,86,91,85,92,83,92,79,91,76,90,74,89,73,87,72,84,71,81,71,78,72,76,73,75,74,74,76,73,79,73,82,74,85,75,87,76,88,78,89,81,90,85,90,89,89,89,90,0,69,95,74,80,76,79,78,79,80,80,83,84,84,85,86,86,88,86,90,85,91,83,91,81,90,79,88,78,86,78,84,79,83,80,80,84,78,85,76,85,74,84,32,90,80,88,79,86,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,86,85,88,85,90,84,32,75,79,74,81,74,83,75,85,32,89,85,90,83,90,81,89,79,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,79,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,72,93,84,74,79,91,32,86,70,80,91,32,86,70,83,73,80,75,78,76,32,85,73,81,75,78,76,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,84,81,80,83,77,85,75,87,73,91,32,86,70,88,71,89,73,89,75,88,77,86,79,80,83,32,74,89,75,88,77,88,82,90,85,90,87,89,88,87,32,77,88,82,91,85,91,87,90,88,87,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,86,79,83,80,32,86,70,88,71,89,73,89,75,88,77,86,79,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,80,85,81,86,82,87,84,87,87,86,89,85,90,83,91,0,72,93,88,71,82,91,32,89,70,83,91,32,89,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,86,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,82,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,78,85,79,86,80,87,82,87,85,86,88,84,90,82,91,0,72,93,89,73,88,74,89,75,90,74,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,77,82,76,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,88,77,90,32,82,91,84,90,86,88,87,86,87,82,86,80,0,72,93,78,70,76,76,32,91,70,90,73,88,76,83,82,81,85,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,32,77,73,80,70,82,70,87,73,32,78,72,80,71,82,71,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,88,79,89,78,90,76,90,73,89,71,86,70,83,70,32,83,70,81,71,80,72,79,74,79,77,80,79,81,80,32,84,80,87,79,88,78,89,76,89,73,88,71,86,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,81,80,78,81,76,83,75,85,75,88,76,90,78,91,32,82,91,85,90,86,89,87,87,87,83,86,81,0,72,93,89,77,88,79,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,74,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,87,76,86,77,87,76,88,32,79,81,78,79,78,75,79,73,81,71,83,70,32,88,71,89,73,89,78,88,82,87,85,85,88,83,90,81,91,0,77,88,80,89,79,90,80,91,81,90,80,89,0,77,88,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,89,79,90,80,91,81,90,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,85,70,84,71,82,83,32,85,71,82,83,32,85,70,86,71,82,83,32,80,89,79,90,80,91,81,90,80,89,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,83,80,81,81,81,83,82,84,84,84,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,80,89,79,90,80,91,81,90,80,89,0,77,88,86,70,84,72,83,74,83,75,84,76,85,75,84,74,0,77,88,85,72,84,71,85,70,86,71,86,72,85,74,83,76,0,69,95,92,78,91,79,92,80],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+337920);allocate([93,79,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,83,88,85,90,87,91,89,91,90,89,90,88,32,75,91,73,90,72,88,72,86,73,84,74,83,80,80,32,79,76,80,81,81,84,83,87,85,89,87,90,89,90,90,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,74,89,75,90,76,91,75,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,0,71,93,95,66,69,98,0,75,90,90,66,86,69,83,72,81,75,79,79,78,84,78,88,79,93,80,96,81,98,32,86,69,83,73,81,77,80,80,79,85,79,90,80,95,81,98,0,74,89,83,66,84,68,85,71,86,76,86,80,85,85,83,89,81,92,78,95,74,98,32,83,66,84,69,85,74,85,79,84,84,83,87,81,91,78,95,0,74,91,84,70,84,82,32,79,73,89,79,32,89,73,79,79,0,78,87,85,70,83,77,32,86,70,83,77,0,73,91,80,70,78,77,32,81,70,78,77,32,89,70,87,77,32,90,70,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,0,72,93,83,70,76,98,32,89,70,82,98,32,76,81,90,81,32,75,87,89,87,0,69,95,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,70,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,89,70,89,76,88,70,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,70,94,78,70,78,76,77,84,76,88,75,90,74,91,32,88,70,88,91,32,89,70,89,91,32,75,70,92,70,32,71,91,92,91,32,71,91,71,98,32,72,91,71,98,32,91,91,92,98,32,92,91,92,98,0,67,98,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,71,71,72,72,71,73,70,72,70,71,71,70,72,70,73,71,74,73,75,77,76,79,78,80,87,80,89,79,90,77,91,73,92,71,93,70,94,70,95,71,95,72,94,73,93,72,94,71,32,78,80,76,81,75,83,74,88,73,90,72,91,32,78,80,77,81,76,83,75,88,74,90,73,91,71,91,70,90,69,88,32,87,80,89,81,90,83,91,88,92,90,93,91,32,87,80,88,81,89,83,90,88,91,90,92,91,94,91,95,90,96,88,32,79,91,86,91,0,72,92,76,73,75,70,75,76,76,73,78,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,79,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,32,78,64,78,63,77,63,77,64,78,66,80,67,84,67,86,66,87,64,0,70,94,75,70,75,91,32,76,70,76,91,32,72,70,79,70,32,76,80,83,80,85,79,86,77,87,73,88,71,89,70,90,70,91,71,91,72,90,73,89,72,90,71,32,83,80,85,81,86,83,87,88,88,90,89,91,32,83,80,84,81,85,83,86,88,87,90,88,91,90,91,91,90,92,88,32,72,91,79,91,0,69,94,77,70,77,76,76,84,75,88,74,90,73,91,72,91,71,90,71,89,72,88,73,89,72,90,32,88,70,88,91,32,89,70,89,91,32,74,70,92,70,32,85,91,92,91,0,72,93,75,70,82,86,32,76,70,83,86,32,90,70,83,86,81,89,80,90,78,91,77,91,76,90,76,89,77,88,78,89,77,90,32,73,70,79,70,32,86,70,92,70,0,70,95,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,80,73,76,74,74,76,73,79,73,82,74,85,76,87,80,88,85,88,89,87,91,85,92,82,92,79,91,76,89,74,85,73,80,73,32,80,73,77,74,75,76,74,79,74,82,75,85,77,87,80,88,32,85,88,88,87,90,85,91,82,91,79,90,76,88,74,85,73,32,79,91,86,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,72,91,92,91,32,91,91,92,98,32,92,91,92,98,0,70,93,75,70,75,81,76,83,79,84,82,84,85,83,87,81,32,76,70,76,81,77,83,79,84,32,87,70,87,91,32,88,70,88,91,32,72,70,79,70,32,84,70,91,70,32,84,91,91,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,32,96,91,97,98,32,97,91,97,98,0,70,96,80,70,80,91,32,81,70,81,91,32,73,70,72,76,72,70,84,70,32,81,80,88,80,91,81,92,82,93,84,93,87,92,89,91,90,88,91,77,91,32,88,80,90,81,91,82,92,84,92,87,91,89,90,90,88,91,0,67,97,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,73,80,80,80,83,81,84,82,85,84,85,87,84,89,83,90,80,91,69,91,32,80,80,82,81,83,82,84,84,84,87,83,89,82,90,80,91,32,91,70,91,91,32,92,70,92,91,32,88,70,95,70,32,88,91,95,91,0,72,93,77,70,77,91,32,78,70,78,91,32,74,70,81,70,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,74,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,72,93,76,73,75,70,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,32,80,80,89,80,0,67,98,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,69,91,76,91,32,86,70,83,71,81,73,80,75,79,79,79,82,80,86,81,88,83,90,86,91,88,91,91,90,93,88,94,86,95,82,95,79,94,75,93,73,91,71,88,70,86,70,32,86,70,84,71,82,73,81,75,80,79,80,82,81,86,82,88,84,90,86,91,32,88,91,90,90,92,88,93,86,94,82,94,79,93,75,92,73,90,71,88,70,32,73,80,79,80,0,71,93,87,70,87,91,32,88,70,88,91,32,91,70,79,70,76,71,75,72,74,74,74,76,75,78,76,79,79,80,87,80,32,79,70,77,71,76,72,75,74,75,76,76,78,77,79,79,80,32,82,80,80,81,79,82,76,89,75,90,74,90,73,89,32,80,81,79,83,77,90,76,91,74,91,73,89,73,88,32,84,91,91,91,0,72,92,88,70,87,71,81,73,78,75,76,78,75,81,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,78,78,76,80,75,83,32,88,70,87,72,85,73,81,74,78,76,76,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,85,77,88,78,89,80,89,81,88,83,85,84,32,85,77,87,78,88,80,88,81,87,83,85,84,32,78,84,85,84,88,85,89,87,89,88,88,90,85,91,74,91,32,85,84,87,85,88,87,88,88,87,90,85,91,0,72,90,77,77,77,91,32,78,77,78,91,32,74,77,88,77,88,82,87,77,32,74,91,81,91,0,70,93,78,77,78,81,77,87,76,90,75,91,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,73,91,72,96,72,91,91,91,91,96,90,91,0,69,96,82,77,82,91,32,83,77,83,91,32,79,77,86,77,32,74,78,73,79,72,78,73,77,74,77,75,78,77,82,78,83,80,84,85,84,87,83,88,82,90,78,91,77,92,77,93,78,92,79,91,78,32,80,84,78,85,77,86,75,90,74,91,32,80,84,78,86,76,90,75,91,73,91,72,90,71,88,32,85,84,87,85,88,86,90,90,91,91,32,85,84,87,86,89,90,90,91,92,91,93,90,94,88,32,79,91,86,91,0,73,91,77,79,76,77,76,81,77,79,78,78,80,77,84,77,87,78,88,80,88,81,87,83,84,84,32,84,77,86,78,87,80,87,81,86,83,84,84,32,81,84,84,84,87,85,88,87,88,88,87,90,84,91,80,91,77,90,76,88,76,87,77,86,78,87,77,88,32,84,84,86,85,87,87,87,88,86,90,84,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,32,79,71,79,70,78,70,78,71,79,73,81,74,83,74,85,73,86,71,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,81,77,32,78,84,80,84,83,83,84,82,86,78,87,77,88,77,89,78,88,79,87,78,32,80,84,83,85,84,86,86,90,87,91,32,80,84,82,85,83,86,85,90,86,91,88,91,89,90,90,88,32,74,91,81,91,0,71,93,78,77,78,81,77,87,76,90,75,91,74,91,73,90,74,89,75,90,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,84,91,91,91,0,71,94,76,77,76,91,32,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,88,77,88,91,32,89,77,89,91,32,73,77,77,77,32,88,77,92,77,32,73,91,79,91,32,85,91,92,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,77,84,87,84,32,73,91,80,91,32,84,91,91,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,73,92,82,77,82,91,32,83,77,83,91,32,77,77,76,82,76,77,89,77,89,82,88,77,32,79,91,86,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,72,93,82,70,82,98,32,83,70,83,98,32,79,70,83,70,32,82,80,81,78,80,77,78,77,76,78,75,81,75,87,76,90,78,91,80,91,81,90,82,88,32,78,77,77,78,76,81,76,87,77,90,78,91,32,87,77,88,78,89,81,89,87,88,90,87,91,32,83,80,84,78,85,77,87,77,89,78,90,81,90,87,89,90,87,91,85,91,84,90,83,88,32,79,98,86,98,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,91,91,91,96,90,91,0,71,93,76,77,76,84,77,86,80,87,82,87,85,86,87,84,32,77,77,77,84,78,86,80,87,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,84,91,91,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,96,96,95,91,0,72,93,81,77,81,91,32,82,77,82,91,32,76,77,75,82,75,77,85,77,32,82,84,86,84,89,85,90,87,90,88,89,90,86,91,78,91,32,86,84,88,85,89,87,89,88,88,90,86,91,0,69,95,74,77,74,91,32,75,77,75,91,32,71,77,78,77,32,75,84,79,84,82,85,83,87,83,88,82,90,79,91,71,91,32,79,84,81,85,82,87,82,88,81,90,79,91,32,89,77,89,91,32,90,77,90,91,32,86,77,93,77,32,86,91,93,91,0,74,91,79,77,79,91,32,80,77,80,91,32,76,77,83,77,32,80,84,84,84,87,85,88,87,88,88,87,90,84,91,76,91,32,84,84,86,85,87,87,87,88,86,90,84,91,0,73,92,77,79,76,77,76,81,77,79,78,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,78,90,76,88,76,87,77,86,78,87,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,82,84,88,84,0,68,97,73,77,73,91,32,74,77,74,91,32,70,77,77,77,32,70,91,77,91,32,86,77,83,78,81,80,80,83,80,85,81,88,83,90,86,91,88,91,91,90,93,88,94,85,94,83,93,80,91,78,88,77,86,77,32,86,77,84,78,82,80,81,83,81,85,82,88,84,90,86,91,32,88,91,90,90,92,88,93,85,93,83,92,80,90,78,88,77,32,74,84,80,84,0,71,92,86,77,86,91,32,87,77,87,91,32,90,77,79,77,76,78,75,80,75,81,76,83,79,84,86,84,32,79,77,77,78,76,80,76,81,77,83,79,84,32,84,84,81,85,80,86,78,90,77,91,32,84,84,82,85,81,86,79,90,78,91,76,91,75,90,74,88,32,83,91,90,91,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,77,85,86,85,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,88,82,89,84,89,87,88,89,32,85,80,87,81,88,83,88,88,87,90,85,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,88,89,86,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,87,73,88,75,89,78,89,83,88,86,87,88,32,83,70,85,71,87,74,88,78,88,83,87,87,85,90,83,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,89,91,89,85,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,71,91,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,94,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,90,89,91,89,83,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,88,84,88,89,32,87,83,87,89,86,90,32,84,83,92,83,32,85,83,87,84,32,86,83,87,85,32,90,83,89,85,32,91,83,89,84,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,80,70,32,84,70,92,70,32,77,80,87,80,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,74,90,83,70,83,87,82,90,81,91,32,84,71,84,87,83,90,32,85,70,85,87,84,90,81,91,79,91,77,90,76,88,76,86,77,85,78,85,79,86,79,87,78,88,77,88,32,77,86,77,87,78,87,78,86,77,86,32,80,70,88,70,32,81,70,83,71,32,82,70,83,72,32,86,70,85,72,32,87,70,85,71,0,70,92,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,88,71,77,82,32,80,80,87,91,32,81,80,88,91,32,81,78,89,91,32,72,70,80,70,32,85,70,91,70,32,72,91,80,91,32,84,91,91,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,88,71,32,90,70,88,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,89,85,91,32,87,89,90,91,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,83,70,32,75,91,90,91,90,85,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,32,85,91,90,90,32,87,91,90,89,32,88,91,90,88,32,89,91,90,85,0,69,95,74,70,74,90,32,74,70,81,91,32,75,70,81,88,32,76,70,82,88,32,88,70,81,91,32,88,70,88,91,32,89,71,89,90,32,90,70,90,91,32,71,70,76,70,32,88,70,93,70,32,71,91,77,91,32,85,91,93,91,32,72,70,74,71,32,91,70,90,72,32,92,70,90,71,32,74,90,72,91,32,74,90,76,91,32,88,90,86,91,32,88,89,87,91,32,90,89,91,91,32,90,90,92,91,0,70,94,75,70,75,90,32,75,70,89,91,32,76,70,88,88,32,77,70,89,88,32,89,71,89,91,32,72,70,77,70,32,86,70,92,70,32,72,91,78,91,32,73,70,75,71,32,87,70,89,71,32,91,70,89,71,32,75,90,73,91,32,75,90,77,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,78,81,32,88,72,89,74,89,77,88,79,32,85,70,87,71,88,73,88,78,87,80,85,81,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,78,88,79,86,81,85,82,85,84,86,85,88,86,94,87,96,89,96,90,94,90,92,32,86,92,87,94,88,95,89,95,32,85,88,87,93,88,94,89,94,90,93,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,78,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,82,80,84,81,85,83,87,89,88,91,90,91,91,89,91,87,32,87,87,88,89,89,90,90,90,32,84,81,85,82,88,88,89,89,90,89,91,88,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,72,92,74,70,74,76,32,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,90,70,90,76,32,74,70,90,70,32,78,91,86,91,32,75,70,74,76,32,76,70,74,73,32,77,70,74,72,32,79,70,74,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,71,32,76,71,76,86,77,88,32,77,70,77,86,78,89,79,90,81,91,32,72,70,80,70,32,86,70,92,70,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,91,70,89,71,0,72,92,75,70,82,91,32,76,70,82,88,82,91,32,77,70,83,88,32,89,71,82,91,32,73,70,80,70,32,85,70,91,70,32,74,70,76,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,90,70,89,71,0,70,94,74,70,78,91,32,75,70,78,86,78,91,32,76,70,79,86,32,82,70,79,86,78,91,32,82,70,86,91,32,83,70,86,86,86,91,32,84,70,87,86,32,90,71,87,86,86,91,32,71,70,79,70,32,82,70,84,70,32,87,70,93,70,32,72,70,75,71,32,73,70,75,72,32,77,70,76,72,32,78,70,76,71,32,88,70,90,71,32,92,70,90,71,0,72,92,75,70,87,91,32,76,70,88,91,32,77,70,89,91,32,88,71,76,90,32,73,70,80,70,32,85,70,91,70,32,73,91,79,91,32,84,91,91,91,32,74,70,77,72,32,78,70,77,72,32,79,70,77,71,32,86,70,88,71,32,90,70,88,71,32,76,90,74,91,32,76,90,78,91,32,87,90,85,91,32,87,89,86,91,32,87,89,90,91,0,71,93,74,70,81,81,81,91,32,75,70,82,81,82,90,32,76,70,83,81,83,91,32,89,71,83,81,32,72,70,79,70,32,86,70,92,70,32,78,91,86,91,32,73,70,75,71,32,78,70,76,71,32,87,70,89,71,32,91,70,89,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,89,70,75,70,75,76,32,87,70,75,91,32,88,70,76,91,32,89,70,77,91,32,75,91,89,91,89,85,32,76,70,75,76,32,77,70,75,73,32,78,70,75,72,32,80,70,75,71,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,90,70,90,76,32,75,91,83,91,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,78,89,77,91,32,78,90,76,91,32,80,89,81,91,32,80,90,82,91,0,72,92,82,70,74,91,32,81,73,88,91,32,82,73,89,91,32,82,70,90,91,32,75,89,88,89,32,75,90,88,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,74,69,74,76,32,90,69,90,76,32,79,77,79,84,32,85,77,85,84,32,74,85,74,92,32,90,85,90,92,32,74,71,90,71,32,74,72,90,72,32,74,73,90,73,32,79,80,85,80,32,79,81,85,81,32,74,88,90,88,32,74,89,90,89,32,74,90,90,90,32,74,70,77,72,32,90,70,87,72,32,75,73,74,75,32,76,73,74,74,32,88,73,90,74,32,89,73,90,75,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,32,74,86,75,88,32,74,87,76,88,32,90,87,88,88,32,90,86,89,88,32,77,89,74,91,32,87,89,90,91,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,92,70,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,71,93,73,70,80,80,81,81,32,74,70,81,80,32,75,70,82,80,73,91,32,73,70,89,70,90,76,89,73,87,70,32,86,70,89,72,32,84,70,89,71,32,75,89,89,89,32,74,90,89,90,32,73,91,89,91,90,85,89,88,87,89,0,72,92,74,77,75,73,76,71,77,70,79,70,80,71,81,73,82,77,32,76,72,77,71,79,71,80,72,32,74,77,75,74,77,72,79,72,80,73,81,77,81,91,32,82,77,82,91,32,90,77,89,74,87,72,85,72,84,73,83,77,83,91,32,88,72,87,71,85,71,84,72,32,90,77,89,73,88,71,87,70,85,70,84,71,83,73,82,77,32,78,91,86,91,32,81,89,80,91,32,81,90,79,91,32,83,90,85,91,32,83,89,84,91,0,71,93,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,79,75,76,76,75,77,74,79,74,82,75,84,76,85,79,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,79,75,32,76,77,75,79,75,82,76,84,32,88,84,89,82,89,79,88,77,32,79,75,77,76,76,79,76,82,77,85,79,86,32,85,86,87,85,88,82,88,79,87,76,85,75,0,70,94,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,72,77,73,77,74,78,75,81,76,83,77,84,80,85,84,85,87,84,88,83,89,81,90,78,91,77,92,77,32,76,82,75,78,74,76,73,76,75,78,32,72,77,73,75,74,75,75,76,76,80,77,83,78,84,80,85,32,89,78,91,76,90,76,89,78,88,82,32,84,85,86,84,87,83,88,80,89,76,90,75,91,75,92,77,0,71,93,78,89,75,89,74,87,75,91,79,91,77,86,75,82,74,79,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,79,89,82,87,86,85,91,89,91,90,87,89,89,86,89,32,76,83,75,79,75,76,76,73,32,88,73,89,76,89,79,88,83,32,79,91,77,85,76,80,76,75,77,72,78,71,80,70,32,84,70,86,71,87,72,88,75,88,80,87,85,85,91,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,73,90,32,83,74,84,91,32,84,72,85,90,32,85,70,85,72,86,89,86,91,32,76,85,84,85,32,70,91,76,91,32,81,91,88,91,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,86,89,87,91,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,78,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,87,81,88,83,88,85,87,88,85,90,32,86,80,87,82,87,85,86,88,84,90,82,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,87,71,88,72,89,75,89,79,88,83,86,87,84,89,32,85,70,87,72,88,75,88,79,87,83,85,87,82,90,79,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,85,91,87,86,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,80,91,85,90,32,82,91,85,89,32,85,89,87,86,0,70,92,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,86,88,87,87,88,84,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,32,82,91,84,90,86,87,87,84,32,84,84,92,84,32,85,84,87,85,32,86,84,87,87,32,90,84,88,86,32,91,84,88,85,0,69,95,78,70,72,91,32,79,70,73,91,32,80,70,74,91,32,90,70,84,91,32,91,70,85,91,32,92,70,86,91,32,75,70,83,70,32,87,70,95,70,32,76,80,88,80,32,69,91,77,91,32,81,91,89,91,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,88,70,91,71,32,89,70,90,72,32,93,70,91,72,32,94,70,91,71,32,73,90,70,91,32,73,89,71,91,32,74,89,75,91,32,73,90,76,91,32,85,90,82,91,32,85,89,83,91,32,86,89,87,91,32,85,90,88,91,0,75,89,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,81,70,89,70,32,75,91,83,91,32,82,70,85,71,32,83,70,84,72,32,87,70,85,72,32,88,70,85,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,73,92,87,70,82,87,81,89,79,91,32,88,70,84,83,83,86,82,88,32,89,70,85,83,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,85,77,86,77,87,76,88,75,88,32,75,86,75,87,76,87,76,86,75,86,32,84,70,92,70,32,85,70,88,71,32,86,70,87,72,32,90,70,88,72,32,91,70,88,71,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,92,71,77,82,32,81,79,85,91,32,82,79,86,91,32,83,78,87,90,32,76,70,84,70,32,89,70,95,70,32,70,91,78,91,32,82,91,89,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,90,70,92,71,32,94,70,92,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,85,90,83,91,32,85,89,84,91,32,86,89,88,91,0,72,92,81,70,75,91,32,82,70,76,91,32,83,70,77,91,32,78,70,86,70,32,72,91,87,91,89,85,32,79,70,82,71,32,80,70,81,72,32,84,70,82,72,32,85,70,82,71,32,76,90,73,91,32,76,89,74,91,32,77,89,78,91,32,76,90,79,91,32,82,91,87,90,32,84,91,88,88,32,86,91,89,85,0,68,96,77,70,71,90,32,77,71,78,89,78,91,32,78,70,79,89,32,79,70,80,88,32,91,70,80,88,78,91,32,91,70,85,91,32,92,70,86,91,32,93,70,87,91,32,74,70,79,70,32,91,70,96,70,32,68,91,74,91,32,82,91,90,91,32,75,70,77,71,32,76,70,77,72,32,94,70,92,72,32,95,70,92,71,32,71,90,69,91,32,71,90,73,91,32,86,90,83,91,32,86,89,84,91,32,87,89,88,91,32,86,90,89,91,0,70,95,79,70,73,90,32,79,70,86,91,32,80,70,86,88,32,81,70,87,88,32,92,71,87,88,86,91,32,76,70,81,70,32,89,70,95,70,32,70,91,76,91,32,77,70,80,71,32,78,70,80,72,32,90,70,92,71,32,94,70,92,71,32,73,90,71,91,32,73,90,75,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,90,71,91,73,91,75,90,78,88,80,32,88,70,89,71,90,73,90,75,89,78,87,80,85,81,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,32,76,88,77,86,79,85,80,85,82,86,83,88,84,93,85,94,86,94,87,93,32,84,94,85,95,86,95,32,83,88,83,95,84,96,86,96,87,93,87,92,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,78,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,82,80,84,81,85,82,87,88,88,89,89,89,90,88,32,87,89,88,90,89,90,32,85,82,86,90,87,91,89,91,90,88,90,87,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,71,93,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,77,70,75,76,32,93,70,92,76,32,77,70,93,70,32,75,91,83,91,32,78,70,75,76,32,80,70,76,73,32,82,70,77,71,32,89,70,92,71,32,90,70,92,72,32,91,70,92,73,32,92,70,92,76,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,71,32,79,70,76,81,75,85,75,89,76,90,32,80,70,77,81,76,85,76,89,78,91,32,75,70,83,70,32,89,70,95,70,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,90,70,92,71,32,94,70,92,71,0,72,92,78,70,78,72,79,89,79,91,32,79,71,80,88,32,80,70,81,87,32,91,71,79,91,32,76,70,83,70,32,88,70,94,70,32,77,70,78,72,32,81,70,80,72,32,82,70,79,71,32,89,70,91,71,32,93,70,91,71,0,69,95,77,70,77,72,75,89,75,91,32,78,71,76,88,32,79,70,77,87,32,85,70,77,87,75,91,32,85,70,85,72,83,89,83,91,32,86,71,84,88,32,87,70,85,87,32,93,71,85,87,83,91,32,74,70,82,70,32,85,70,87,70,32,90,70,96,70,32,75,70,78,71,32,76,70,77,72,32,80,70,78,73,32,81,70,78,71,32,91,70,93,71,32,95,70,93,71,0,71,93,78,70,84,91,32,79,70,85,91,32,80,70,86,91,32,91,71,73,90,32,76,70,83,70,32,88,70,94,70,32,70,91,76,91,32,81,91,88,91,32,77,70,79,72,32,81,70,80,72,32,82,70,80,71,32,89,70,91,71,32,93,70,91,71,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,85,89,87,91,0,71,93,77,70,81,80,78,91,32,78,70,82,80,79,91,32,79,70,83,80,80,91,32,92,71,83,80,32,75,70,82,70,32,89,70,95,70,32,75,91,83,91,32,76,70,78,71,32,80,70,79,72,32,81,70,78,71,32,90,70,92,71,32,94,70,92,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,71,93,90,70,72,91,32,91,70,73,91,32,92,70,74,91,32,92,70,78,70,76,76,32,72,91,86,91,88,85,32,79,70,76,76,32,80,70,77,73,32,82,70,78,71,32,82,91,86,90,32,84,91,87,88,32,85,91,88,85,0,72,92,74,70,82,91,32,75,70,82,88,32,76,70,83,88,32,74,70,90,70,82,91,32,76,71,89,71,32,76,72,89,72,0,73,93,78,80,78,79,79,79,79,81,77,81,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,86,79,87,81,87,88,88,90,32,84,77,85,78,86,80,86,88,87,90,90,91,91,91,32,86,82,85,83,80,84,77,85,76,87,76,88,77,90,80,91,83,91,85,90,86,88,32,78,85,77,87,77,88,78,90,32,85,83,81,84,79,85,78,87,78,88,79,90,80,91,0,71,92,76,70,76,91,77,90,79,90,32,77,71,77,89,32,73,70,78,70,78,90,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,74,70,76,71,32,75,70,76,72,0,72,91,87,81,87,80,86,80,86,82,88,82,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,72,93,86,70,86,91,91,91,32,87,71,87,90,32,83,70,88,70,88,91,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,84,70,86,71,32,85,70,86,72,32,88,89,89,91,32,88,90,90,91,0,72,91,77,83],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+348160);allocate([88,83,88,81,87,79,86,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,82,87,81,86,79,32,77,80,76,82,76,86,77,88,32,86,83,86,80,85,78,83,77,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,75,89,87,72,87,71,86,71,86,73,88,73,88,71,87,70,84,70,82,71,81,72,80,75,80,91,32,82,72,81,75,81,90,32,84,70,83,71,82,73,82,91,32,77,77,86,77,32,77,91,85,91,32,80,90,78,91,32,80,89,79,91,32,82,89,83,91,32,82,90,84,91,0,73,92,88,78,89,79,90,78,89,77,88,77,86,78,85,79,32,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,79,78,81,78,83,79,85,32,85,85,86,83,86,81,85,79,32,81,77,80,78,79,80,79,84,80,86,81,87,32,83,87,84,86,85,84,85,80,84,78,83,77,32,78,85,77,86,76,88,76,89,77,91,78,92,81,93,85,93,88,94,89,95,32,78,91,81,92,85,92,88,93,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,32,79,98,77,97,76,95,76,94,77,92,79,91,0,71,94,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,70,76,71,32,75,70,76,72,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,72,83,72,83,70,81,70,32,82,70,82,72,32,81,71,83,71,32,81,77,81,91,32,82,78,82,90,32,78,77,83,77,83,91,32,78,91,86,91,32,79,77,81,78,32,80,77,81,79,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,75,88,82,70,82,72,84,72,84,70,82,70,32,83,70,83,72,32,82,71,84,71,32,82,77,82,94,81,97,80,98,32,83,78,83,93,82,96,32,79,77,84,77,84,93,83,96,82,97,80,98,77,98,76,97,76,95,78,95,78,97,77,97,77,96,32,80,77,82,78,32,81,77,82,79,0,71,93,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,87,78,78,87,32,82,83,89,91,32,82,84,88,91,32,81,84,87,91,32,84,77,91,77,32,73,91,81,91,32,84,91,91,91,32,74,70,76,71,32,75,70,76,72,32,85,77,87,78,32,90,77,87,78,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,89,85,91,32,86,89,90,91,0,76,88,81,70,81,91,32,82,71,82,90,32,78,70,83,70,83,91,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,65,99,70,77,70,91,32,71,78,71,90,32,67,77,72,77,72,91,32,72,81,73,79,74,78,76,77,79,77,81,78,82,79,83,82,83,91,32,81,79,82,82,82,90,32,79,77,80,78,81,81,81,91,32,83,81,84,79,85,78,87,77,90,77,92,78,93,79,94,82,94,91,32,92,79,93,82,93,90,32,90,77,91,78,92,81,92,91,32,67,91,75,91,32,78,91,86,91,32,89,91,97,91,32,68,77,70,78,32,69,77,70,79,32,70,90,68,91,32,70,89,69,91,32,72,89,73,91,32,72,90,74,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,92,90,90,91,32,92,89,91,91,32,94,89,95,91,32,94,90,96,91,0,71,94,76,77,76,91,32,77,78,77,90,32,73,77,78,77,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,77,76,78,32,75,77,76,79,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,77,80,76,82,76,86,77,88,32,87,88,88,86,88,82,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,0,71,92,76,77,76,98,32,77,78,77,97,32,73,77,78,77,78,98,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,73,98,81,98,32,74,77,76,78,32,75,77,76,79,32,76,97,74,98,32,76,96,75,98,32,78,96,79,98,32,78,97,80,98,0,72,92,86,78,86,98,32,87,79,87,97,32,85,78,87,78,88,77,88,98,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,98,91,98,32,86,97,84,98,32,86,96,85,98,32,88,96,89,98,32,88,97,90,98,0,73,90,78,77,78,91,32,79,78,79,90,32,75,77,80,77,80,91,32,87,79,87,78,86,78,86,80,88,80,88,78,87,77,85,77,83,78,81,80,80,83,32,75,91,83,91,32,76,77,78,78,32,77,77,78,79,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,83,80,84,85,85,87,86,88,89,32,78,78,77,81,32,78,82,80,83,85,84,87,85,32,88,86,87,90,32,77,79,78,81,80,82,85,83,87,84,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,72,80,86,81,89,82,90,84,91,86,91,88,90,89,88,32,81,72,81,87,82,89,32,80,72,82,70,82,87,83,90,84,91,32,77,77,86,77,0,71,94,76,77,76,86,77,89,78,90,80,91,83,91,85,90,86,89,87,87,32,77,78,77,87,78,89,32,73,77,78,77,78,87,79,90,80,91,32,87,77,87,91,92,91,32,88,78,88,90,32,84,77,89,77,89,91,32,74,77,76,78,32,75,77,76,79,32,89,89,90,91,32,89,90,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,82,91,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,70,94,74,77,78,91,32,75,77,78,88,32,76,77,79,88,32,82,77,79,88,78,91,32,82,77,86,91,32,83,77,86,88,32,82,77,84,77,87,88,32,90,78,87,88,86,91,32,71,77,79,77,32,87,77,93,77,32,72,77,75,78,32,78,77,76,78,32,88,77,90,78,32,92,77,90,78,0,72,92,76,77,86,91,32,77,77,87,91,32,78,77,88,91,32,87,78,77,90,32,74,77,81,77,32,84,77,90,77,32,74,91,80,91,32,83,91,90,91,32,75,77,77,78,32,80,77,78,78,32,85,77,87,78,32,89,77,87,78,32,77,90,75,91,32,77,90,79,91,32,86,90,84,91,32,87,90,89,91,0,72,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,73,91,86,77,76,91,32,87,77,77,91,32,88,77,78,91,32,88,77,76,77,76,81,32,76,91,88,91,88,87,32,77,77,76,81,32,78,77,76,80,32,79,77,76,79,32,81,77,76,78,32,83,91,88,90,32,85,91,88,89,32,86,91,88,88,32,87,91,88,87,0,71,94,91,77,90,81,89,84,87,88,85,90,82,91,80,91,77,90,75,88,74,85,74,83,75,80,77,78,80,77,82,77,85,78,86,79,87,81,89,88,90,90,91,91,92,91,32,90,77,89,81,88,84,87,86,85,89,84,90,82,91,32,76,88,75,86,75,82,76,80,32,80,91,78,90,77,89,76,86,76,82,77,79,78,78,80,77,32,82,77,84,78,85,79,86,81,88,88,89,90,91,91,0,71,92,81,70,78,71,77,72,76,74,75,78,75,98,32,78,72,77,74,76,78,76,97,32,81,70,79,71,78,73,77,78,77,98,32,81,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,83,80,32,80,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,81,91,79,90,78,89,77,87,32,86,72,87,74,87,76,86,78,32,87,82,88,84,88,87,87,89,32,83,70,85,71,86,73,86,77,85,79,83,80,32,84,80,86,81,87,83,87,88,86,90,84,91,32,75,98,77,98,0,70,92,72,82,73,78,75,77,77,77,79,78,80,79,81,82,82,89,83,98,32,73,79,75,78,77,78,79,79,80,80,32,72,82,73,80,75,79,77,79,79,80,80,81,81,84,82,89,82,97,32,88,77,87,80,86,82,84,85,83,87,82,91,81,98,32,89,77,87,81,32,90,77,89,79,87,82,84,86,83,88,82,91,32,88,77,90,77,32,81,98,83,98,0,72,92,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,80,76,78,75,77,74,77,72,78,71,80,70,83,70,87,72,32,77,80,76,83,76,85,77,88,32,87,88,88,85,88,83,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,79,75,78,74,78,73,79,72,81,71,84,71,87,72,0,73,91,83,77,85,78,86,79,87,79,86,78,83,77,81,77,77,78,76,79,76,81,77,82,81,83,32,83,83,81,83,77,84,75,86,75,88,77,90,80,91,83,91,86,90,88,88,87,88,86,90,32,78,78,77,79,77,81,78,82,32,77,85,76,86,76,88,77,89,32,81,77,79,78,78,79,78,81,79,82,81,83,32,81,83,78,84,77,86,77,88,78,90,80,91,0,73,91,81,72,82,71,82,70,81,70,80,71,80,73,81,74,84,75,88,75,89,75,89,74,88,74,85,75,83,76,80,78,78,80,77,82,76,85,76,87,77,89,78,90,80,91,83,92,85,93,86,95,86,97,85,98,83,98,82,97,82,96,83,96,83,97,32,80,79,79,80,78,82,77,85,77,87,78,89,79,90,32,85,75,82,77,81,78,79,81,78,84,78,87,79,89,81,91,83,92,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,85,77,86,78,87,81,87,98,32,87,79,88,82,88,97,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,98,32,76,91,78,91,32,87,98,89,98,0,70,93,73,77,74,78,75,80,75,84,76,87,77,89,78,90,81,91,83,91,86,90,87,89,88,87,89,82,89,79,88,74,86,71,84,70,82,70,80,71,79,73,79,75,80,77,83,79,86,80,91,81,32,74,77,75,78,76,80,76,84,77,87,78,89,32,86,89,87,87,88,82,88,79,87,74,86,72,84,71,32,71,80,72,78,73,77,75,77,76,78,77,80,77,84,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,74,85,72,83,71,81,71,79,73,0,75,90,78,77,79,78,80,80,80,88,81,90,83,91,85,91,87,90,88,88,32,79,77,80,78,81,80,81,88,82,90,32,76,80,77,78,78,77,80,77,81,78,82,80,82,88,83,90,84,91,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,83,79,85,78,87,78,88,79,88,80,90,80,90,78,88,77,86,77,84,78,81,81,79,84,78,87,32,88,78,89,79,89,80,32,80,83,81,83,87,89,89,89,90,88,32,84,87,87,90,89,90,32,82,84,85,90,86,91,88,91,89,90,90,88,32,76,91,78,91,0,72,92,74,71,75,70,77,70,79,71,81,73,88,88,89,90,90,91,32,79,72,80,73,87,88,88,89,32,77,70,78,71,79,73,86,88,88,90,90,91,91,91,32,82,77,74,90,74,91,75,91,82,77,0,71,93,75,77,75,98,32,76,78,76,97,32,77,77,77,98,32,86,77,86,88,87,90,88,91,90,91,91,90,92,88,32,87,78,87,88,88,90,89,91,32,88,77,88,88,89,90,90,91,32,77,88,78,90,80,91,82,91,84,90,85,89,86,87,32,75,77,77,77,32,86,77,88,77,32,75,98,77,98,0,71,93,74,77,75,78,76,80,77,84,78,91,32,75,77,76,78,77,80,78,84,79,90,32,72,80,73,78,74,77,76,77,77,78,78,80,79,84,80,90,32,86,86,87,84,88,81,88,77,89,77,90,78,89,81,88,83,86,86,84,88,81,90,78,91,32,88,82,89,79,89,77,0,74,90,80,71,83,70,82,70,80,71,79,72,79,73,80,74,83,75,86,76,87,75,86,74,83,75,80,76,78,77,77,79,77,81,78,82,80,83,83,84,86,85,87,84,86,83,83,84,79,85,77,86,76,88,76,90,77,91,79,92,83,93,85,94,86,95,86,97,84,98,82,98,79,97,80,97,82,98,32,79,77,78,79,78,81,79,82,32,78,86,77,88,77,90,78,91,32,86,75,83,75,81,76,80,77,79,79,79,81,81,83,83,84,32,86,84,83,84,80,85,79,86,78,88,78,90,80,92,83,93,0,71,93,73,81,74,79,75,78,77,77,91,77,32,75,79,77,78,90,78,32,73,81,74,80,76,79,91,79,32,79,79,78,90,77,91,76,90,77,87,79,79,32,85,79,86,90,87,91,88,90,87,87,85,79,32,91,77,91,79,32,79,79,77,90,32,85,79,87,90,0,71,92,81,77,78,78,76,80,75,84,75,98,32,77,80,76,84,76,97,32,81,77,79,78,78,79,77,83,77,98,32,77,87,78,89,79,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,87,88,88,86,88,82,87,80,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,32,75,98,77,98,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,82,91,85,90,87,88,88,85,88,83,87,80,85,78,82,77,32,76,80,75,82,75,86,76,88,32,86,88,87,86,87,82,86,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,32,82,91,84,90,85,89,86,86,86,82,85,79,84,78,82,77,32,82,77,90,79,91,78,91,77,80,77,32,82,77,90,78,0,72,92,74,81,75,79,76,78,78,77,90,77,32,76,79,78,78,89,78,32,74,81,75,80,77,79,90,79,32,82,79,81,90,82,91,83,90,82,79,32,90,77,90,79,32,82,79,82,90,0,71,92,74,77,75,78,76,80,76,85,77,88,79,90,81,91,83,91,85,90,87,88,88,86,89,82,89,78,88,77,87,77,88,80,88,83,87,87,85,90,32,75,77,76,78,77,80,77,85,78,88,32,87,77,88,78,88,79,32,72,80,73,78,74,77,76,77,77,78,78,80,78,86,79,89,81,91,0,71,93,82,81,81,78,80,77,78,77,76,78,75,79,74,82,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,82,89,79,88,78,86,77,84,77,83,78,82,81,32,76,79,75,82,75,85,76,88,32,88,88,89,85,89,82,88,79,32,78,77,77,78,76,81,76,86,77,89,78,90,80,91,32,84,91,86,90,87,89,88,86,88,81,87,78,86,77,32,82,81,81,98,32,82,81,82,97,32,82,81,83,98,32,81,98,83,98,0,72,92,76,77,77,78,78,80,84,95,86,97,88,98,90,98,91,97,32,78,79,79,80,85,95,86,96,32,73,78,74,77,76,77,78,78,80,80,86,95,87,97,88,98,32,86,83,88,80,89,77,90,77,89,79,86,83,78,92,75,96,74,98,75,98,76,95,78,92,0,70,93,72,78,73,78,74,80,74,85,75,88,77,90,80,91,84,91,86,90,88,88,89,86,90,82,90,78,89,77,88,77,89,80,89,83,88,87,86,90,32,74,78,75,80,75,85,76,88,32,88,77,89,78,89,79,32,71,80,72,78,73,77,74,77,75,78,76,80,76,86,77,89,78,90,80,91,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,70,94,78,77,76,78,74,80,73,83,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,84,82,83,81,84,81,87,82,89,83,90,85,91,87,91,89,90,90,89,91,87,91,83,90,80,88,78,86,77,32,75,80,74,83,74,87,75,89,32,82,84,82,88,32,89,89,90,87,90,83,89,80,32,78,77,76,79,75,82,75,87,76,90,77,91,32,87,91,88,90,89,87,89,82,88,79,86,77,0,71,93,87,77,85,84,85,88,86,90,87,91,89,91,91,89,92,87,32,88,77,86,84,86,90,32,87,77,89,77,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,78,78,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,0,73,92,80,70,78,77,77,83,77,87,78,89,79,90,81,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,85,77,83,77,81,78,80,79,79,81,78,84,32,81,70,79,77,78,81,78,87,79,90,32,86,89,87,87,88,84,88,81,87,79,32,77,70,82,70,80,77,78,84,32,83,91,85,89,86,87,87,84,87,81,86,78,85,77,32,78,70,81,71,32,79,70,80,72,0,73,91,87,81,87,80,86,80,86,82,88,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,87,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,71,93,89,70,86,81,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,90,70,87,81,86,85,86,90,32,86,70,91,70,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,87,70,90,71,32,88,70,89,72,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,88,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,74,90,90,72,90,71,89,71,89,73,91,73,91,71,90,70,88,70,86,71,84,73,83,75,82,78,81,82,79,91,78,94,77,96,75,98,32,84,74,83,77,82,82,80,91,79,94,32,88,70,86,72,85,74,84,77,83,82,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,95,74,95,74,97,73,97,73,96,32,78,77,89,77,0,72,93,88,77,84,91,83,94,81,97,79,98,32,89,77,85,91,83,95,32,88,77,90,77,86,91,84,95,82,97,79,98,76,98,74,97,73,96,73,94,75,94,75,96,74,96,74,95,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,86,76,89,77,90,79,91,81,91,83,90,84,89,85,87,86,84,32,78,79,77,81,76,84,76,87,77,89,32,81,77,79,79,78,81,77,84,77,87,78,90,79,91,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,80,88,83,86,88,32,87,78,87,82,86,86,86,90,32,87,80,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,77,70,80,71,32,78,70,79,72,0,75,88,84,70,84,72,86,72,86,70,84,70,32,85,70,85,72,32,84,71,86,71,32,76,81,77,79,79,77,81,77,82,78,83,80,83,83,81,88,32,82,78,82,82,81,86,81,90,32,82,80,80,85,80,88,81,90,82,91,84,91,86,89,87,87,0,75,88,85,70,85,72,87,72,87,70,85,70,32,86,70,86,72,32,85,71,87,71,32,77,81,78,79,80,77,82,77,83,78,84,80,84,83,82,90,81,93,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,83,78,83,83,81,90,80,93,79,95,32,83,80,82,84,80,91,79,94,78,96,76,98,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,81,82,79,83,32,77,83,79,83,81,84,82,85,84,89,85,90,87,90,32,81,85,83,89,84,90,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,80,71,32,78,70,79,72,0,76,88,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,81,70,86,70,82,84,81,88,32,82,70,85,71,32,83,70,84,72,0,64,99,65,81,66,79,68,77,70,77,71,78,72,80,72,83,70,91,32,71,78,71,83,69,91,32,71,80,70,84,68,91,70,91,32,72,83,74,80,76,78,78,77,80,77,82,78,83,80,83,83,81,91,32,82,78,82,83,80,91,32,82,80,81,84,79,91,81,91,32,83,83,85,80,87,78,89,77,91,77,93,78,94,80,94,83,92,88,32,93,78,93,82,92,86,92,90,32,93,80,91,85,91,88,92,90,93,91,95,91,97,89,98,87,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,91,32,77,78,77,83,75,91,32,77,80,76,84,74,91,76,91,32,78,83,80,80,82,78,84,77,86,77,88,78,89,80,89,83,87,88,32,88,78,88,82,87,86,87,90,32,88,80,86,85,86,88,87,90,88,91,90,91,92,89,93,87,0,72,92,81,77,78,78,76,81,75,84,75,86,76,89,77,90,80,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,84,77,81,77,32,78,79,77,81,76,84,76,87,77,89,32,86,89,87,87,88,84,88,81,87,79,32,81,77,79,79,78,81,77,84,77,87,78,90,80,91,32,83,91,85,89,86,87,87,84,87,81,86,78,84,77,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,78,87,75,98,32,78,78,78,83,77,87,74,98,32,78,80,77,84,73,98,32,79,84,80,81,81,79,82,78,84,77,86,77,88,78,89,79,90,82,90,84,89,87,87,90,84,91,82,91,80,90,79,87,79,84,32,88,79,89,81,89,84,88,87,87,89,32,86,77,87,78,88,81,88,84,87,87,86,89,84,91,32,70,98,78,98,32,74,97,71,98,32,74,96,72,98,32,75,96,76,98,32,74,97,77,98,0,71,92,87,77,81,98,32,88,77,82,98,32,87,77,89,77,83,98,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,78,98,86,98,32,82,97,79,98,32,82,96,80,98,32,83,96,84,98,32,82,97,85,98,0,73,91,74,81,75,79,77,77,79,77,80,78,81,80,81,84,79,91,32,80,78,80,84,78,91,32,80,80,79,84,77,91,79,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,83,80,81,84,0,74,91,88,80,88,79,87,79,87,81,89,81,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,83,81,84,84,85,86,86,87,88,32,79,78,78,81,32,79,82,81,83,84,84,86,85,32,87,86,86,90,32,78,79,79,81,81,82,84,83,86,84,87,86,87,88,86,90,83,91,80,91,77,90,76,89,76,87,78,87,78,89,77,89,77,88,0,75,89,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,84,70,86,70,82,84,81,88,32,78,77,88,77,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,88,32,77,78,77,82,76,86,76,90,32,77,80,75,85,75,88,76,90,78,91,80,91,82,90,84,88,86,85,32,88,77,86,85,86,88,87,90,88,91,90,91,92,89,93,87,32,89,77,87,85,87,90,32,88,77,90,77,88,84,87,88,0,72,92,73,81,74,79,76,77,78,77,79,78,80,80,80,83,78,88,32,79,78,79,82,78,86,78,90,32,79,80,77,85,77,88,78,90,80,91,82,91,84,90,86,88,88,85,89,81,89,77,88,77,88,78,89,80,0,67,97,68,81,69,79,71,77,73,77,74,78,75,80,75,83,73,88,32,74,78,74,82,73,86,73,90,32,74,80,72,85,72,88,73,90,75,91,77,91,79,90,81,88,82,85,32,84,77,82,85,82,88,83,90,85,91,87,91,89,90,91,88,93,85,94,81,94,77,93,77,93,78,94,80,32,85,77,83,85,83,90,32,84,77,86,77,84,84,83,88,0,71,93,74,81,76,78,78,77,80,77,82,78,83,80,83,82,32,80,77,81,78,81,82,80,86,79,88,77,90,75,91,73,91,72,90,72,88,74,88,74,90,73,90,73,89,32,82,79,82,82,81,86,81,89,32,90,79,90,78,89,78,89,80,91,80,91,78,90,77,88,77,86,78,84,80,83,82,82,86,82,90,83,91,32,80,86,80,88,81,90,83,91,85,91,87,90,89,87,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,77,88,32,78,78,78,82,77,86,77,90,32,78,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,84,32,89,77,85,91,84,94,82,97,80,98,32,90,77,86,91,84,95,32,89,77,91,77,87,91,85,95,83,97,80,98,77,98,75,97,74,96,74,94,76,94,76,96,75,96,75,95,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,88,79,79,79,77,80,76,82,32,86,79,82,78,79,78,78,79,32,86,79,82,77,79,77,77,79,76,82,32,76,89,85,89,87,88,88,86,32,78,89,82,90,85,90,86,89,32,78,89,82,91,85,91,87,89,88,86,0,72,92,87,81,86,79,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,87,89,88,87,89,83,89,78,88,74,87,72,86,71,83,70,81,70,78,71,77,72,78,72,79,71,81,70,32,77,80,76,82,76,86,77,88,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,88,87,84,87,77,86,73,85,71,83,70,0,73,91,85,77,87,78,88,79,89,79,88,78,85,77,82,77,79,78,77,80,76,83,76,85,77,88,79,90,82,91,85,91,88,90,89,89,88,89,87,90,85,91,32,78,80,77,83,77,85,78,88,32,82,77,80,78,79,79,78,82,78,86,79,89,80,90,82,91,32,78,84,84,85,85,84,84,83,78,84,32,78,84,84,84,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,32,76,80,88,81,32,76,81,88,80,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,83,89,80,87,78,84,77,80,77,32,76,80,75,83,75,85,76,88,32,88,88,89,85,89,83,88,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,84,91,86,90,87,89,88,86,88,82,87,79,86,78,84,77,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,72,92,84,77,86,78,88,80,89,80,89,79,87,78,84,77,80,77,77,78,76,79,75,81,75,83,76,85,78,87,80,88,82,89,83,90,84,92,84,94,83,95,81,95,79,94,80,94,81,95,32,77,79,76,81,76,83,77,85,79,87,32,80,77,78,78,77,80,77,83,78,85,82,89,32,89,80,88,79,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,0,72,92,81,72,81,91,32,82,72,82,90,32,83,70,83,91,32,83,70,80,73,78,74,32,77,91,87,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,87,72,88,74,88,76,87,78,32,84,70,86,71,87,74,87,76,86,78,84,80,80,82,32,75,89,76,88,78,88,83,89,87,89,89,88,32,78,88,83,90,87,90,88,89,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,32,86,71,87,73,87,76,86,78,32,83,70,85,71,86,73,86,76,85,78,83,79,32,81,79,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,82,88,84,88,87,87,89,32,83,79,85,80,86,81,87,84,87,87,86,90,84,91,32,76,86,76,87,77,87,77,86,76,86,0,72,92,83,73,83,91,32,84,72,84,90,32,85,70,85,91,32,85,70,74,85,90,85,32,80,91,88,91,32,83,90,81,91,32,83,89,82,91,32,85,89,86,91,32,85,90,87,91,0,72,92,77,70,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,76,86,76,87,77,87,77,86,76,86,32,77,70,87,70,32,77,71,85,71,32,77,72,81,72,85,71,87,70,0,72,92,86,73,86,74,87,74,87,73,86,73,32,87,72,86,72,85,73,85,74,86,75,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,81,78,79,79,78,80,77,82,32,78,73,77,75,76,79,76,85,77,88,78,89,32,87,88,88,86,88,83,87,81,32,82,70,80,71,79,72,78,74,77,78,77,85,78,88,79,90,81,91,32,83,91,85,90,86,89,87,86,87,83,86,80,85,79,83,78,0,72,92,75,70,75,76,32,89,70,89,73,88,76,84,81,83,83,82,87,82,91,32,83,82,82,84,81,87,81,91,32,88,76,83,81,81,84,80,87,80,91,82,91,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,77,72,78,71,80,71,82,72,32,75,74,76,73,78,72,80,72,85,73,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,78,71,77,73,77,76,78,78,32,86,78,87,76,87,73,86,71,32,80,70,79,71,78,73,78,76,79,78,80,79,32,84,79,85,78,86,76,86,73,85,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,77,81,76,83,76,87,77,89,32,87,89,88,87,88,83,87,81,32,80,79,78,80,77,83,77,87,78,90,80,91,32,84,91,86,90,87,87,87,83,86,80,84,79,0,72,92,77,87,77,88,78,88,78,87,77,87,32,87,79,86,81,85,82,83,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,86,79,87,79,88,78,89,77,89,32,77,80,76,78,76,75,77,73,32,86,72,87,73,88,76,88,82,87,86,86,88,32,81,83,79,82,78,81,77,78,77,75,78,72,79,71,81,70,32,83,70,85,71,86,73,87,76,87,83,86,87,85,89,84,90,82,91,0,77,88,82,70,81,71,81,73,82,81,32,82,70,82,84,83,84,32,82,70,83,70,83,84,32,83,70,84,71,84,73,83,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,77,75,77,74,78,74,78,76,76,76,76,74,77,72,78,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,83,81,32,87,72,88,73,88,77,87,78,32,84,70,86,71,87,73,87,77,86,79,85,80,32,82,81,82,84,83,84,83,81,82,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,69,95,91,79,91,78,90,78,90,80,92,80,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,76,78,79,80,82,84,87,87,90,89,91,91,91,92,89,92,88,32,75,90,74,88,74,85,75,83,76,82,32,82,77,83,73,32,83,75,82,71,32,78,71,77,75,32,78,78,80,81,84,86,87,89,89,90,32,78,91,76,90,75,88,75,85,76,83,80,79,32,77,73,78,77,81,81,85,86,88,89,90,90,91,90,92,89,0,72,92,80,66,80,95,32,84,66,84,95,32,88,75,88,74,87,74,87,76,89,76,89,74,88,72,87,71,84,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,85,77,85,77,87,76,87,76,86,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,32,81,72,80,75,79,79,79,85,80,89,81,92,32,83,68,82,70,81,73,80,79,80,85,81,91,82,94,83,96,0,75,89,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,32,83,72,84,75,85,79,85,85,84,89,83,92,32,81,68,82,70,83,73,84,79,84,85,83,91,82,94,81,96,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,32,91,70,73,91,32,91,70,74,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,79,71,76,70,73,73,74,76,77,77,80,74,79,71,32,78,70,74,71,73,75,32,75,77,79,76,80,72,32,90,85,87,84,84,87,85,90,88,91,91,88,90,85,32,89,84,85,85,84,89,32,86,91,90,90,91,86,32,72,91,74,91,0,69,96,86,78,85,76,83,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,83,86,85,85,86,83,32,79,77,78,79,78,82,79,84,32,81,75,80,76,79,79,79,82,80,85,81,86,32,86,75,86,83,87,85,89,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,76,87,83,88,85,32,86,75,88,75,88,83,89,85,90,86,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,89,86,87,87,85,88,82,89,78,89,74,88,72,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,72,93,84,74,79,91,81,91,32,87,70,85,74,80,91,32,87,70,81,91,32,87,70,84,73,81,75,79,76,32,84,74,82,75,79,76,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,77,85,75,87,73,91,32,88,71,89,73,89,75,88,77,86,79,83,81,32,86,70,87,71,88,73,88,75,87,77,85,79,77,85,32,74,89,75,88,77,88,82,89,87,89,88,88,32,77,88,82,90,87,90,32,77,88,82,91,85,91,87,90,88,88,88,87,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,88,78,86,79,83,80,32,88,71,89,73,89,75,88,77,87,78,32,86,70,87,71,88,73,88,75,87,77,85,79,83,80,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,85,90,82,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,82,87,84,87,87,86,89,32,83,80,85,81,86,83,86,87,85,89,84,90,82,91,0,72,93,87,74,82,91,84,91,32,90,70,88,74,83,91,32,90,70,84,91,32,90,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,89,71,32,80,72,85,72,89,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,81,91,78,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,80,87,82,87,85,86,88,84,90,32,83,78,85,79,86,81,86,85,85,88,83,90,81,91,0,72,93,89,74,89,73,88,73,88,75,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,78,81,77,83,32,80,73,78,76,77,79,76,83,76,87,77,89,32,86,88,87,86,87,83,86,81,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,82,91,84,90,85,89,86,86,86,82,85,80,84,79,0,72,93,78,70,76,76,32,91,70,90,73,88,76,84,81,82,84,81,87,80,91,32,82,83,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,80,91,32,77,73,80,70,82,70,87,73,32,79,71,82,71,87,73,32,77,73,79,72,82,72,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,87,79,89,78,90,76,90,73,89,71,87,70,83,70,32,85,70,80,71,32,80,72,79,74,79,78,80,79,32,79,79,82,80,32,83,80,87,79,32,88,78,89,76,89,73,88,71,32,89,71,85,70,32,83,70,81,72,80,74,80,78,81,80,32,84,80,86,79,87,78,88,76,88,72,87,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,82,80,77,81,32,78,81,76,83,75,85,75,88,76,90,32,75,90,80,91,86,90,32,86,89,87,87,87,84,86,82,32,86,81,83,80,32,81,80,79,81,77,83,76,85,76,88,77,90,78,91,32,82,91,84,90,85,89,86,87,86,83,85,81,84,80,0,72,93,88,78,87,80,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,75,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,86,77,86,77,88,76,88,76,87,32,79,80,78,78,78,75,79,73,32,88,72,89,74,89,78,88,82,87,85,85,88,32,81,82,80,81,79,79,79,75,80,72,81,71,83,70,32,86,70,87,71,88,73,88,78,87,82,86,85,85,87,83,90,81,91,0,77,88,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,86,70,85,70,84,71,82,84,32,86,71,85,71,82,84,32,86,71,86,72,82,84,32,86,70,87,71,87,72,82,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,87,79,83,80,81,81,81,83,83,84,84,84,32,85,70,90,71,32,89,71,90,73,90,75,89,77,88,78,86,79,32,87,70,88,71,89,73,89,75,88,77,87,78,83,80,82,81,82,83,83,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,87,70,85,71,84,72,83,74,83,76,84,77,85,77,86,76,86,75,85,74,84,74,32,85,71,84,73,84,74,32,84,75,84,76,85,76,85,75,84,75,0,77,88,86,73,85,73,84,72,84,71,85,70,86,70,87,71,87,73,86,75,85,76,83,77,32,85,71,85,72,86,72,86,71,85,71,32,86,73,86,74,85,76,0,69,95,92,79,92,78,91,78,91,80,93,80,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,82,87,84,90,86,91,88,91,89,89,89,88,32,76,91,72,90,32,73,90,72,88,72,86,73,84,74,83,76,82,32,80,80,81,83,84,89,86,90,32,75,91,74,90,73,88,73,86,74,84,75,83,77,82,82,79,32,79],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+358400);allocate([76,80,79,81,82,83,86,85,89,87,90,88,90,89,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,75,90,74,89,74,89,76,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,0,71,94,95,66,69,98,70,98,32,95,66,96,66,70,98,0,74,90,90,66,88,67,85,69,82,72,80,75,78,79,77,83,77,88,78,92,79,95,81,98,32,83,72,81,75,79,79,78,84,78,92,32,90,66,87,68,84,71,82,74,81,76,80,79,79,83,78,92,32,78,84,79,93,80,96,81,98,0,74,90,83,66,85,69,86,72,87,76,87,81,86,85,84,89,82,92,79,95,76,97,74,98,32,86,72,86,80,85,85,83,89,81,92,32,83,66,84,68,85,71,86,80,32,86,72,85,81,84,85,83,88,82,90,80,93,77,96,74,98,0,74,91,84,70,83,71,85,81,84,82,32,84,70,84,82,32,84,70,85,71,83,81,84,82,32,79,73,80,73,88,79,89,79,32,79,73,89,79,32,79,73,79,74,89,78,89,79,32,89,73,88,73,80,79,79,79,32,89,73,79,79,32,89,73,89,74,79,78,79,79,0,77,87,85,70,84,71,82,77,32,85,71,82,77,32,85,70,86,71,82,77,0,72,92,80,70,79,71,77,77,32,80,71,77,77,32,80,70,81,71,77,77,32,90,70,89,71,87,77,32,90,71,87,77,32,90,70,91,71,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,32,83,70,80,73,81,77,85,78,88,75,87,71,83,70,32,85,70,81,71,80,75,83,78,87,77,88,73,85,70,0,71,94,83,70,75,98,76,98,32,83,70,84,70,76,98,32,89,70,81,98,82,98,32,89,70,90,70,82,98,32,75,80,92,80,92,81,32,75,80,75,81,92,81,32,73,87,90,87,90,88,32,73,87,73,88,90,88,0,69,94,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,69,91,32,94,70,70,91,32,94,70,71,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,32,80,71,77,70,74,73,75,76,78,77,81,74,80,71,32,79,70,75,71,74,75,32,76,77,80,76,81,72,32,89,85,86,84,83,87,84,90,87,91,90,88,89,85,32,88,84,84,85,83,89,32,85,91,89,90,90,86,32,69,91,71,91,0,69,96,85,81,85,78,84,76,82,75,80,75,78,76,77,77,76,80,76,83,77,85,79,86,81,86,83,85,84,84,85,81,32,79,76,78,77,77,80,77,83,78,85,32,82,75,80,76,79,77,78,80,78,83,79,85,80,86,32,86,75,85,81,85,83,86,85,88,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,75,86,81,86,83,87,85,32,86,75,88,75,87,81,87,83,88,85,90,86,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,104,69,69,69,69,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,99,118,116,84,119,111,80,108,97,110,101,89,85,86,116,111,66,71,82,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,95,121,117,118,46,99,112,112,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,99,118,116,84,104,114,101,101,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,69,0,99,118,116,79,110,101,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,32,38,38,32,95,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,99,118,116,67,111,108,111,114,89,85,86,50,71,114,97,121,95,99,104,0,33,95,115,114,99,46,101,109,112,116,121,40,41,0,67,118,116,72,101,108,112,101,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,46,104,112,112,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,48,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,84,79,95,89,85,86,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,84,79,95,89,85,86,93,0,85,110,115,117,112,112,111,114,116,101,100,32,100,101,112,116,104,32,111,102,32,105,110,112,117,116,32,105,109,97,103,101,0,100,101,112,116,104,0,86,68,101,112,116,104,58,58,99,111,110,116,97,105,110,115,40,100,101,112,116,104,41,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,32,105,110,32,111,117,116,112,117,116,32,105,109,97,103,101,0,100,99,110,0,86,68,99,110,58,58,99,111,110,116,97,105,110,115,40,100,99,110,41,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,32,105,110,32,105,110,112,117,116,32,105,109,97,103,101,0,115,99,110,0,86,83,99,110,58,58,99,111,110,116,97,105,110,115,40,115,99,110,41,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,51,32,61,61,32,48,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,70,82,79,77,95,89,85,86,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,70,82,79,77,95,89,85,86,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,70,82,79,77,95,89,85,86,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,70,82,79,77,95,89,85,86,93,0,99,110,32,61,61,32,49,0,73,110,112,117,116,32,119,105,110,100,111,119,32,104,97,115,32,110,111,110,45,112,111,115,105,116,105,118,101,32,115,105,122,101,115,0,109,101,97,110,83,104,105,102,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,99,97,109,115,104,105,102,116,46,99,112,112,0,102,114,97,109,101,84,121,112,101,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,67,86,95,56,85,67,51,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,67,86,95,51,50,70,67,51,0,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,98,103,102,103,95,103,97,117,115,115,109,105,120,50,46,99,112,112,0,108,101,97,114,110,105,110,103,82,97,116,101,32,62,61,32,48,0,78,50,99,118,49,49,77,79,71,50,73,110,118,111,107,101,114,69,0,110,99,104,97,110,110,101,108,115,32,60,61,32,67,86,95,67,78,95,77,65,88,0,105,110,105,116,105,97,108,105,122,101,0,110,109,105,120,116,117,114,101,115,32,60,61,32,50,53,53,0,110,97,109,101,0,40,83,116,114,105,110,103,41,102,110,91,34,110,97,109,101,34,93,32,61,61,32,110,97,109,101,95,0,104,105,115,116,111,114,121,0,110,109,105,120,116,117,114,101,115,0,98,97,99,107,103,114,111,117,110,100,82,97,116,105,111,0,118,97,114,84,104,114,101,115,104,111,108,100,0,118,97,114,84,104,114,101,115,104,111,108,100,71,101,110,0,118,97,114,73,110,105,116,0,118,97,114,77,105,110,0,118,97,114,77,97,120,0,99,111,109,112,108,101,120,105,116,121,82,101,100,117,99,116,105,111,110,84,104,114,101,115,104,111,108,100,0,100,101,116,101,99,116,83,104,97,100,111,119,115,0,115,104,97,100,111,119,86,97,108,117,101,0,115,104,97,100,111,119,84,104,114,101,115,104,111,108,100,0,78,50,99,118,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,46,77,79,71,50,0,115,116,97,116,117,115,32,33,61,32,78,85,76,76,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,108,107,112,121,114,97,109,105,100,46,99,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,54,76,75,84,114,97,99,107,101,114,73,110,118,111,107,101,114,69,0,105,109,103,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,98,117,105,108,100,79,112,116,105,99,97,108,70,108,111,119,80,121,114,97,109,105,100,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,99,97,108,99,83,104,97,114,114,68,101,114,105,118,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,54,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,109,97,120,76,101,118,101,108,32,62,61,32,48,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,40,110,112,111,105,110,116,115,32,61,32,112,114,101,118,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,44,32,116,114,117,101,41,41,32,62,61,32,48,0,110,101,120,116,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,44,32,116,114,117,101,41,32,61,61,32,110,112,111,105,110,116,115,0,115,116,97,116,117,115,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,101,114,114,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,108,101,118,101,108,115,49,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,108,101,118,101,108,115,50,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,115,105,122,101,40,41,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,116,121,112,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,116,121,112,101,40,41,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,54,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,0,78,50,99,118,50,50,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,55,83,112,97,114,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,114,97,110,115,97,99,83,105,122,101,48,32,115,104,111,117,108,100,32,104,97,118,101,32,118,97,108,117,101,32,98,105,103,103,101,114,32,116,104,97,110,32,50,46,0,101,115,116,105,109,97,116,101,82,105,103,105,100,84,114,97,110,115,102,111,114,109,0,114,97,110,115,97,99,71,111,111,100,82,97,116,105,111,32,115,104,111,117,108,100,32,104,97,118,101,32,118,97,108,117,101,32,98,101,116,119,101,101,110,32,48,32,97,110,100,32,49,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,101,105,116,104,101,114,32,56,117,67,49,32,111,114,32,56,117,67,51,32,116,121,112,101,0,77,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,103,101,116,82,84,77,97,116,114,105,120,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,112,114,101,118,48,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,48,46,115,105,122,101,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,110,101,120,116,48,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,112,121,114,83,99,97,108,101,95,32,60,32,49,0,99,97,108,99,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,70,97,114,110,101,98,97,99,107,80,111,108,121,69,120,112,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,111,112,116,102,108,111,119,103,102,46,99,112,112,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,0,78,50,99,118,50,48,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,54,68,101,110,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,33,115,114,99,46,101,109,112,116,121,40,41,0,102,105,110,100,84,114,97,110,115,102,111,114,109,69,67,67,0,33,100,115,116,46,101,109,112,116,121,40,41,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,100,97,116,97,32,116,121,112,101,0,73,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,56,117,67,49,32,111,114,32,51,50,102,67,49,32,116,121,112,101,0,119,97,114,112,77,97,116,114,105,120,32,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,109,97,116,114,105,120,0,109,97,112,46,99,111,108,115,32,61,61,32,51,0,109,97,112,46,114,111,119,115,32,61,61,32,50,32,124,124,32,109,97,112,46,114,111,119,115,32,61,61,51,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,109,97,112,46,114,111,119,115,32,61,61,51,0,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,67,79,85,78,84,32,124,124,32,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,69,80,83,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,97,102,102,105,110,101,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,52,46,115,105,122,101,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,100,115,116,46,114,111,119,115,0,100,115,116,46,99,111,108,115,32,61,61,32,40,54,42,115,114,99,49,46,99,111,108,115,41,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,104,111,109,111,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,56,41,0,115,114,99,53,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,116,114,97,110,115,108,97,116,105,111,110,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,50,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,101,117,99,108,105,100,101,97,110,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,52,46,115,105,122,101,40,41,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,51,41,0,78,97,78,32,101,110,99,111,117,110,116,101,114,101,100,46,0,84,104,101,32,97,108,103,111,114,105,116,104,109,32,115,116,111,112,112,101,100,32,98,101,102,111,114,101,32,105,116,115,32,99,111,110,118,101,114,103,101,110,99,101,46,32,84,104,101,32,99,111,114,114,101,108,97,116,105,111,110,32,105,115,32,103,111,105,110,103,32,116,111,32,98,101,32,109,105,110,105,109,105,122,101,100,46,32,73,109,97,103,101,115,32,109,97,121,32,98,101,32,117,110,99,111,114,114,101,108,97,116,101,100,32,111,114,32,110,111,110,45,111,118,101,114,108,97,112,112,101,100,0,109,97,112,95,109,97,116,114,105,120,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,117,112,100,97,116,101,95,119,97,114,112,105,110,103,95,109,97,116,114,105,120,95,69,67,67,0,117,112,100,97,116,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,51,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,56,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,54,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,51,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,50,0,117,112,100,97,116,101,46,99,111,108,115,32,61,61,32,49,0,109,97,112,95,109,97,116,114,105,120,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,117,112,100,97,116,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,115,114,99,50,46,114,111,119,115,0,112,114,111,106,101,99,116,95,111,110,116,111,95,106,97,99,111,98,105,97,110,95,69,67,67,0,40,115,114,99,49,46,99,111,108,115,32,37,32,115,114,99,50,46,99,111,108,115,41,32,61,61,32,48,0,100,115,116,46,99,111,108,115,32,61,61,32,100,115,116,46,114,111,119,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,101,99,99,46,99,112,112,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,110,110,46,99,112,112,0,73,110,102,101,114,101,110,99,101,32,69,110,103,105,110,101,32,112,105,112,101,108,105,110,101,32,111,102,32,0,32,108,97,121,101,114,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,0,105,110,105,116,73,110,102,69,110,103,105,110,101,0,72,97,108,105,100,101,32,112,105,112,101,108,105,110,101,32,111,102,32,0,105,110,105,116,72,97,108,105,100,101,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,53,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,52,66,97,99,107,101,110,100,87,114,97,112,112,101,114,69,0,79,80,69,78,67,86,95,68,78,78,95,68,73,83,65,66,76,69,95,77,69,77,79,82,89,95,79,80,84,73,77,73,90,65,84,73,79,78,83,0,79,80,69,78,67,86,95,68,78,78,95,66,65,67,75,69,78,68,95,68,69,70,65,85,76,84,0,79,80,69,78,67,86,95,68,78,78,95,67,72,69,67,75,95,78,65,78,95,73,78,70,0,79,80,69,78,67,86,95,68,78,78,95,67,72,69,67,75,95,78,65,78,95,73,78,70,95,68,85,77,80,0,79,80,69,78,67,86,95,68,78,78,95,67,72,69,67,75,95,78,65,78,95,73,78,70,95,82,65,73,83,69,95,69,82,82,79,82,0,109,101,97,110,95,32,61,61,32,83,99,97,108,97,114,40,41,32,38,38,32,34,77,101,97,110,32,115,117,98,116,114,97,99,116,105,111,110,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,102,111,114,32,67,86,95,56,85,32,98,108,111,98,32,100,101,112,116,104,34,0,98,108,111,98,70,114,111,109,73,109,97,103,101,115,0,33,105,109,97,103,101,115,46,101,109,112,116,121,40,41,0,105,109,97,103,101,48,46,100,105,109,115,32,61,61,32,50,0,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,98,108,111,98,95,46,100,101,112,116,104,40,41,0,105,109,97,103,101,46,100,105,109,115,32,61,61,32,50,32,38,38,32,40,110,99,104,32,61,61,32,51,32,124,124,32,110,99,104,32,61,61,32,52,41,0,105,109,97,103,101,46,115,105,122,101,40,41,32,61,61,32,105,109,97,103,101,48,46,115,105,122,101,40,41,0,105,109,97,103,101,46,100,105,109,115,32,61,61,32,50,32,38,38,32,40,110,99,104,32,61,61,32,49,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,98,108,111,98,70,114,111,109,73,109,97,103,101,115,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,98,111,111,108,44,32,98,111,111,108,44,32,105,110,116,41,0,83,99,97,108,105,110,103,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,102,111,114,32,67,86,95,56,85,32,98,108,111,98,32,100,101,112,116,104,0,115,99,97,108,101,102,97,99,116,111,114,0,49,46,48,0,66,108,111,98,32,100,101,112,116,104,32,115,104,111,117,108,100,32,98,101,32,67,86,95,51,50,70,32,111,114,32,67,86,95,56,85,0,100,100,101,112,116,104,0,100,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,51,78,101,116,52,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,95,105,110,112,117,116,0,95,95,78,101,116,73,110,112,117,116,76,97,121,101,114,95,95,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,57,68,97,116,97,76,97,121,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,0,109,101,97,110,32,61,61,32,83,99,97,108,97,114,40,41,32,124,124,32,105,110,112,117,116,115,68,97,116,97,91,105,93,46,115,105,122,101,91,49,93,32,60,61,32,52,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,68,97,116,97,76,97,121,101,114,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,111,117,116,112,117,116,115,91,105,93,46,116,121,112,101,40,41,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,115,99,97,108,101,70,97,99,116,111,114,115,46,115,105,122,101,40,41,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,109,101,97,110,115,46,115,105,122,101,40,41,0,105,110,112,117,116,115,68,97,116,97,46,115,105,122,101,40,41,32,61,61,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,57,68,97,116,97,76,97,121,101,114,69,0,66,117,105,108,100,32,79,112,101,110,67,86,32,119,105,116,104,32,73,110,102,101,114,101,110,99,101,32,69,110,103,105,110,101,32,116,111,32,101,110,97,98,108,101,32,108,111,97,100,105,110,103,32,109,111,100,101,108,115,32,102,114,111,109,32,77,111,100,101,108,32,79,112,116,105,109,105,122,101,114,46,0,114,101,97,100,70,114,111,109,77,111,100,101,108,79,112,116,105,109,105,122,101,114,0,76,97,121,101,114,32,34,0,34,32,97,108,114,101,97,100,121,32,105,110,116,111,32,110,101,116,0,97,100,100,76,97,121,101,114,0,111,117,116,76,97,121,101,114,73,100,32,60,32,105,110,76,97,121,101,114,73,100,0,76,97,121,101,114,32,119,105,116,104,32,114,101,113,117,101,115,116,101,100,32,105,100,61,37,100,32,110,111,116,32,102,111,117,110,100,0,103,101,116,76,97,121,101,114,68,97,116,97,0,73,110,112,117,116,32,35,37,100,32,111,102,32,108,97,121,101,114,32,34,37,115,34,32,97,108,114,101,97,100,121,32,119,97,115,32,99,111,110,110,101,99,116,101,100,0,97,100,100,76,97,121,101,114,73,110,112,117,116,0,67,97,110,39,116,32,99,114,101,97,116,101,32,108,97,121,101,114,32,34,0,34,32,111,102,32,116,121,112,101,32,34,0,103,101,116,76,97,121,101,114,73,110,115,116,97,110,99,101,0,33,105,116,45,62,115,101,99,111,110,100,46,101,109,112,116,121,40,41,0,99,114,101,97,116,101,76,97,121,101,114,73,110,115,116,97,110,99,101,0,82,101,113,117,101,115,116,101,100,32,98,108,111,98,32,110,111,116,32,102,111,117,110,100,0,76,97,121,101,114,32,34,37,115,34,32,112,114,111,100,117,99,101,32,111,110,108,121,32,37,100,32,111,117,116,112,117,116,115,44,32,116,104,101,32,35,37,100,32,119,97,115,32,114,101,113,117,101,115,116,101,100,0,33,108,100,46,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,46,101,109,112,116,121,40,41,32,38,38,32,33,108,100,46,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,91,112,105,110,46,111,105,100,93,46,101,109,112,116,121,40,41,0,87,65,82,78,73,78,71,58,32,78,97,78,32,100,101,116,101,99,116,101,100,32,105,110,32,108,97,121,101,114,32,111,117,116,112,117,116,58,32,105,100,61,0,32,110,97,109,101,61,0,111,117,116,112,117,116,32,105,100,61,0,32,111,117,116,112,117,116,32,115,104,97,112,101,61,0,87,65,82,78,73,78,71,58,32,73,110,102,32,100,101,116,101,99,116,101,100,32,105,110,32,108,97,121,101,114,32,111,117,116,112,117,116,58,32,105,100,61,0,73,78,80,85,84,32,0,79,85,84,80,85,84,32,0,73,78,84,69,82,78,65,76,32,0,33,102,97,105,108,0,102,111,114,119,97,114,100,76,97,121,101,114,0,32,105,115,32,78,85,76,76,0,33,110,111,100,101,46,101,109,112,116,121,40,41,0,85,110,107,110,111,119,110,32,98,97,99,107,101,110,100,32,105,100,101,110,116,105,102,105,101,114,0,119,114,97,112,112,101,114,115,46,115,105,122,101,40,41,32,61,61,32,117,109,97,116,115,46,115,105,122,101,40,41,0,117,112,100,97,116,101,0,33,117,109,97,116,87,114,97,112,112,101,114,46,101,109,112,116,121,40,41,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,79,112,101,110,67,76,66,97,99,107,101,110,100,87,114,97,112,112,101,114,69,0,32,93,0,103,101,116,85,77,97,116,86,101,99,116,111,114,0,82,101,113,117,101,115,116,101,100,32,108,97,121,101,114,32,34,0,34,32,110,111,116,32,102,111,117,110,100,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,79,80,69,78,67],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+368640);allocate([86,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,95,70,80,49,54,0,115,101,116,85,112,78,101,116,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,73,78,70,69,82,69,78,67,69,95,69,78,71,73,78,69,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,95,70,80,49,54,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,77,89,82,73,65,68,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,70,80,71,65,0,68,78,78,58,32,79,112,101,110,67,76,32,116,97,114,103,101,116,32,105,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,105,110,32,116,104,105,115,32,79,112,101,110,67,86,32,98,117,105,108,100,44,32,115,119,105,116,99,104,105,110,103,32,116,111,32,67,80,85,46,0,105,116,32,33,61,32,108,97,121,101,114,115,46,101,110,100,40,41,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,0,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,73,83,95,68,78,78,95,79,80,69,78,67,76,95,84,65,82,71,69,84,40,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,41,0,105,110,105,116,66,97,99,107,101,110,100,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,61,61,32,68,78,78,95,66,65,67,75,69,78,68,95,73,78,70,69,82,69,78,67,69,95,69,78,71,73,78,69,0,105,110,105,116,73,110,102,69,110,103,105,110,101,66,97,99,107,101,110,100,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,61,61,32,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,0,105,110,105,116,72,97,108,105,100,101,66,97,99,107,101,110,100,0,104,97,118,101,72,97,108,105,100,101,40,41,0,33,108,100,66,111,116,46,98,97,99,107,101,110,100,78,111,100,101,115,91,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,93,46,101,109,112,116,121,40,41,0,33,108,97,121,101,114,115,91,48,93,46,111,117,116,112,117,116,66,108,111,98,115,46,101,109,112,116,121,40,41,0,97,108,108,111,99,97,116,101,76,97,121,101,114,115,0,105,110,112,46,116,111,116,97,108,40,41,0,98,105,97,115,76,97,121,101,114,68,97,116,97,0,102,117,115,101,76,97,121,101,114,115,0,98,105,97,115,76,97,121,101,114,68,97,116,97,45,62,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,100,46,105,110,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,100,46,111,117,116,112,117,116,66,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,100,46,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,111,117,116,112,117,116,95,115,108,105,99,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,111,117,116,112,117,116,95,115,108,105,99,101,46,115,105,122,101,32,61,61,32,99,117,114,114,95,111,117,116,112,117,116,46,115,105,122,101,0,99,117,114,114,95,111,117,116,112,117,116,46,100,97,116,97,32,61,61,32,111,117,116,112,117,116,95,115,108,105,99,101,46,100,97,116,97,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,49,67,111,110,99,97,116,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,80,111,111,108,105,110,103,76,97,121,101,114,69,0,73,83,95,68,78,78,95,79,80,69,78,67,76,95,84,65,82,71,69,84,40,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,41,0,119,114,97,112,0,85,110,107,110,111,119,110,32,116,97,114,103,101,116,32,105,100,101,110,116,105,102,105,101,114,0,119,114,97,112,77,97,116,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,79,112,101,110,67,76,66,97,99,107,101,110,100,87,114,97,112,112,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,33,98,97,115,101,46,101,109,112,116,121,40,41,0,79,112,101,110,67,76,66,97,99,107,101,110,100,87,114,97,112,112,101,114,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,69,108,116,119,105,115,101,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,53,65,99,116,105,118,97,116,105,111,110,76,97,121,101,114,69,0,102,114,111,109,46,118,97,108,105,100,40,41,0,97,108,108,111,99,97,116,101,76,97,121,101,114,0,108,97,121,101,114,83,104,97,112,101,115,73,116,32,33,61,32,108,97,121,101,114,115,83,104,97,112,101,115,46,101,110,100,40,41,0,108,100,46,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,46,115,105,122,101,40,41,32,60,61,32,111,117,116,83,104,97,112,101,115,46,115,105,122,101,40,41,0,97,108,108,111,99,97,116,101,66,108,111,98,115,70,111,114,76,97,121,101,114,0,108,100,46,105,110,112,117,116,66,108,111,98,115,91,48,93,45,62,116,111,116,97,108,40,41,32,61,61,32,116,111,116,97,108,40,115,104,97,112,101,115,91,105,110,100,101,120,93,41,0,109,97,112,73,116,32,33,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,114,101,108,101,97,115,101,82,101,102,101,114,101,110,99,101,0,114,101,102,73,116,32,33,61,32,114,101,102,67,111,117,110,116,101,114,46,101,110,100,40,41,0,114,101,102,73,116,45,62,115,101,99,111,110,100,32,62,32,48,0,109,101,109,72,111,115,116,115,46,102,105,110,100,40,108,112,41,32,61,61,32,109,101,109,72,111,115,116,115,46,101,110,100,40,41,0,97,100,100,72,111,115,116,0,114,101,117,115,101,77,97,112,46,102,105,110,100,40,117,115,101,114,41,32,61,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,114,101,117,115,101,0,114,101,117,115,101,77,97,112,46,102,105,110,100,40,104,111,115,116,41,32,33,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,110,117,109,82,101,102,101,114,101,110,99,101,115,0,33,108,100,46,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,91,105,93,46,101,109,112,116,121,40,41,0,82,101,113,117,101,115,116,101,100,32,98,108,111,98,32,34,0,115,101,116,73,110,112,117,116,0,105,115,83,116,114,105,110,103,40,41,0,40,105,100,120,32,61,61,32,45,49,32,38,38,32,112,115,45,62,115,105,122,101,40,41,32,61,61,32,49,41,32,124,124,32,40,105,100,120,32,62,61,32,48,32,38,38,32,105,100,120,32,60,32,40,105,110,116,41,112,115,45,62,115,105,122,101,40,41,41,0,102,114,97,99,112,97,114,116,32,61,61,32,48,46,48,0,105,115,73,110,116,40,41,32,124,124,32,105,115,82,101,97,108,40,41,32,124,124,32,105,115,83,116,114,105,110,103,40,41,0,34,32,97,108,114,101,97,100,121,32,119,97,115,32,114,101,103,105,115,116,101,114,101,100,0,114,101,103,105,115,116,101,114,76,97,121,101,114,0,99,97,102,102,101,0,99,97,102,102,101,109,111,100,101,108,0,112,114,111,116,111,116,120,116,0,116,101,110,115,111,114,102,108,111,119,0,112,98,0,112,98,116,120,116,0,116,111,114,99,104,0,116,55,0,110,101,116,0,100,97,114,107,110,101,116,0,119,101,105,103,104,116,115,0,99,102,103,0,100,108,100,116,0,98,105,110,0,120,109,108,0,111,110,110,120,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,97,110,32,111,114,105,103,105,110,32,102,114,97,109,101,119,111,114,107,32,111,102,32,102,105,108,101,115,58,32,0,114,101,97,100,78,101,116,0,82,101,97,100,105,110,103,32,84,111,114,99,104,32,109,111,100,101,108,115,32,102,114,111,109,32,98,117,102,102,101,114,115,0,82,101,97,100,105,110,103,32,73,110,116,101,108,39,115,32,77,111,100,101,108,32,79,112,116,105,109,105,122,101,114,32,109,111,100,101,108,115,32,102,114,111,109,32,98,117,102,102,101,114,115,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,97,110,32,111,114,105,103,105,110,32,102,114,97,109,101,119,111,114,107,32,119,105,116,104,32,97,32,110,97,109,101,32,0,33,116,101,110,115,111,114,95,112,114,111,116,111,46,114,97,119,95,100,97,116,97,40,41,46,101,109,112,116,121,40,41,32,124,124,32,33,116,101,110,115,111,114,95,112,114,111,116,111,46,102,108,111,97,116,95,100,97,116,97,40,41,46,101,109,112,116,121,40,41,32,124,124,32,33,116,101,110,115,111,114,95,112,114,111,116,111,46,100,111,117,98,108,101,95,100,97,116,97,40,41,46,101,109,112,116,121,40,41,32,124,124,32,33,116,101,110,115,111,114,95,112,114,111,116,111,46,105,110,116,54,52,95,100,97,116,97,40,41,46,101,109,112,116,121,40,41,0,103,101,116,77,97,116,70,114,111,109,84,101,110,115,111,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,111,110,110,120,47,111,110,110,120,95,105,109,112,111,114,116,101,114,46,99,112,112,0,73,110,112,117,116,32,105,115,32,111,117,116,32,111,102,32,79,112,101,110,67,86,32,51,50,83,32,114,97,110,103,101,0,99,111,110,118,101,114,116,73,110,116,54,52,84,111,73,110,116,51,50,0,85,110,115,117,112,112,111,114,116,101,100,32,100,97,116,97,32,116,121,112,101,58,32,0,107,101,114,110,101,108,95,115,104,97,112,101,0,97,116,116,114,105,98,117,116,101,95,112,114,111,116,111,46,105,110,116,115,95,115,105,122,101,40,41,32,61,61,32,50,0,103,101,116,76,97,121,101,114,80,97,114,97,109,115,0,112,97,100,115,0,97,116,116,114,105,98,117,116,101,95,112,114,111,116,111,46,105,110,116,115,95,115,105,122,101,40,41,32,37,32,50,32,61,61,32,48,0,97,116,116,114,105,98,117,116,101,95,112,114,111,116,111,46,105,110,116,115,95,115,105,122,101,40,41,32,61,61,32,52,0,97,117,116,111,95,112,97,100,0,83,65,77,69,95,85,80,80,69,82,0,83,65,77,69,95,76,79,87,69,82,0,100,105,108,97,116,105,111,110,115,0,85,110,101,120,112,101,99,116,101,100,32,97,116,116,114,105,98,117,116,101,32,116,121,112,101,0,85,110,115,117,112,112,111,114,116,101,100,32,97,116,116,114,105,98,117,116,101,32,116,121,112,101,0,105,110,100,101,120,32,60,32,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,0,103,101,116,66,108,111,98,0,66,108,111,98,32,0,32,110,111,116,32,102,111,117,110,100,32,105,110,32,99,111,110,115,116,32,98,108,111,98,115,0,82,101,113,117,105,114,101,100,32,97,114,103,117,109,101,110,116,32,34,0,34,32,110,111,116,32,102,111,117,110,100,32,105,110,116,111,32,100,105,99,116,105,111,110,97,114,121,0,103,101,116,0,109,111,100,101,108,95,112,114,111,116,111,46,104,97,115,95,103,114,97,112,104,40,41,0,110,111,100,101,95,112,114,111,116,111,46,111,117,116,112,117,116,95,115,105,122,101,40,41,32,62,61,32,49,0,65,118,101,114,97,103,101,80,111,111,108,0,112,121,116,111,114,99,104,0,71,108,111,98,97,108,65,118,101,114,97,103,101,80,111,111,108,0,67,111,110,115,116,97,110,116,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,48,0,108,97,121,101,114,80,97,114,97,109,115,46,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,73,109,97,103,101,83,99,97,108,101,114,0,76,101,97,107,121,82,101,108,117,0,69,120,112,101,99,116,101,100,32,105,110,112,117,116,44,32,115,99,97,108,101,44,32,98,105,97,115,44,32,109,101,97,110,32,97,110,100,32,118,97,114,0,115,112,97,116,105,97,108,0,71,101,109,109,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,62,61,32,50,0,116,114,97,110,115,66,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,67,111,110,118,0,67,111,110,118,84,114,97,110,115,112,111,115,101,0,85,110,115,113,117,101,101,122,101,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,49,0,97,120,101,115,46,103,101,116,73,110,116,86,97,108,117,101,40,97,120,101,115,46,115,105,122,101,40,41,45,49,41,32,60,61,32,100,105,109,115,46,115,105,122,101,40,41,0,115,104,97,112,101,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,32,124,124,32,108,97,121,101,114,80,97,114,97,109,115,46,104,97,115,40,34,115,104,97,112,101,34,41,0,98,108,111,98,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,40,105,100,120,32,61,61,32,45,49,32,38,38,32,115,105,122,101,40,41,32,61,61,32,49,41,32,124,124,32,40,105,100,120,32,62,61,32,48,32,38,38,32,105,100,120,32,60,32,115,105,122,101,40,41,41,0,105,115,82,101,97,108,40,41,32,124,124,32,105,115,73,110,116,40,41,32,124,124,32,105,115,83,116,114,105,110,103,40,41,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,111,110,110,120,32,109,111,100,101,108,0,79,78,78,88,73,109,112,111,114,116,101,114,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,105,116,32,33,61,32,100,97,116,97,95,108,97,121,111,117,116,115,46,101,110,100,40,41,0,112,114,101,100,105,99,116,79,117,116,112,117,116,68,97,116,97,76,97,121,111,117,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,101,110,115,111,114,102,108,111,119,47,116,102,95,105,109,112,111,114,116,101,114,46,99,112,112,0,67,111,110,118,50,68,0,83,112,97,99,101,84,111,66,97,116,99,104,78,68,0,68,101,112,116,104,119,105,115,101,67,111,110,118,50,100,78,97,116,105,118,101,0,80,97,100,0,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,51,0,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,73,78,84,51,50,0,112,97,114,115,101,68,105,109,115,0,100,105,109,115,32,61,61,32,49,0,118,97,108,117,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,100,105,108,97,116,105,111,110,46,115,105,122,101,40,41,32,61,61,32,50,0,115,105,122,101,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,112,97,114,115,101,84,101,110,115,111,114,0,100,115,116,95,105,32,60,32,116,111,116,97,108,0,115,114,99,95,105,32,60,32,116,111,116,97,108,0,110,101,120,116,95,108,97,121,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,112,97,100,100,105,110,103,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,66,105,97,115,65,100,100,0,110,117,109,87,101,105,103,104,116,115,32,37,32,52,32,61,61,32,48,0,33,108,111,99,80,114,101,100,84,114,97,110,115,112,111,115,101,100,0,66,97,116,99,104,84,111,83,112,97,99,101,78,68,0,33,104,97,118,101,67,111,110,115,116,32,124,124,32,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,118,97,108,117,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,73,110,112,117,116,32,108,97,121,101,114,32,110,111,116,32,102,111,117,110,100,58,32,0,104,97,118,101,67,111,110,115,116,0,77,97,116,77,117,108,0,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,47,110,99,104,119,0,108,97,121,101,114,95,105,100,46,102,105,110,100,40,112,101,114,109,78,97,109,101,41,32,61,61,32,108,97,121,101,114,95,105,100,46,101,110,100,40,41,0,83,113,117,101,101,122,101,0,115,113,117,101,101,122,101,95,100,105,109,115,0,104,97,115,76,97,121,101,114,65,116,116,114,40,108,97,121,101,114,44,32,34,115,113,117,101,101,122,101,95,100,105,109,115,34,41,0,85,110,115,117,112,112,111,114,116,101,100,32,115,113,117,101,101,122,101,32,99,111,110,102,105,103,117,114,97,116,105,111,110,0,84,114,97,110,115,112,111,115,101,0,112,101,114,109,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,79,110,108,121,32,78,72,87,67,32,60,45,62,32,78,67,72,87,32,112,101,114,109,117,116,97,116,105,111,110,115,32,97,114,101,32,97,108,108,111,119,101,100,46,0,100,101,112,116,104,95,114,97,100,105,117,115,0,67,111,110,99,97,116,86,50,0,45,52,32,60,61,32,105,100,120,32,38,38,32,105,100,120,32,60,32,52,0,116,111,78,67,72,87,0,77,97,120,80,111,111,108,0,65,118,103,80,111,111,108,0,80,108,97,99,101,104,111,108,100,101,114,0,100,116,121,112,101,0,33,98,101,103,105,110,115,46,101,109,112,116,121,40,41,0,33,115,105,122,101,115,46,101,109,112,116,121,40,41,0,115,99,97,108,101,77,97,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,110,101,116,46,110,111,100,101,40,109,97,120,105,109,117,109,76,97,121,101,114,73,100,120,41,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,69,120,112,101,99,116,101,100,32,103,97,109,109,97,44,32,98,101,116,97,44,32,109,101,97,110,32,97,110,100,32,115,116,100,0,105,115,95,116,114,97,105,110,105,110,103,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,110,117,109,98,101,114,32,111,102,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,98,97,116,99,104,32,110,111,114,109,97,108,105,122,97,116,105,111,110,32,108,97,121,101,114,46,0,108,97,121,101,114,95,105,100,46,102,105,110,100,40,109,118,110,78,97,109,101,41,32,61,61,32,108,97,121,101,114,95,105,100,46,101,110,100,40,41,0,69,120,112,101,99,116,101,100,32,111,117,116,112,117,116,32,115,104,97,112,101,44,32,119,101,105,103,104,116,115,32,97,110,100,32,105,110,112,117,116,32,110,111,100,101,115,0,66,108,111,99,107,76,83,84,77,0,85,110,101,120,112,101,99,116,101,100,32,110,117,109,98,101,114,32,111,102,32,105,110,112,117,116,32,110,111,100,101,115,0,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,32,124,124,32,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,51,0,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,97,116,60,105,110,116,62,40,105,41,32,61,61,32,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,97,116,60,105,110,116,62,40,105,32,45,32,49,41,32,43,32,49,0,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,97,116,60,105,110,116,62,40,105,41,32,42,32,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,97,116,60,105,110,116,62,40,105,32,45,32,49,41,32,62,61,32,48,0,80,114,105,111,114,66,111,120,0,115,99,97,108,101,115,0,77,101,97,110,0,105,110,100,105,99,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,85,110,115,117,112,112,111,114,116,101,100,32,109,111,100,101,32,111,102,32,114,101,100,117,99,101,95,109,101,97,110,32,111,112,101,114,97,116,105,111,110,46,0,107,101,101,112,95,100,105,109,115,0,108,97,121,101,114,95,105,100,46,102,105,110,100,40,102,108,97,116,116,101,110,78,97,109,101,41,32,61,61,32,108,97,121,101,114,95,105,100,46,101,110,100,40,41,0,67,108,105,112,66,121,86,97,108,117,101,0,65,98,115,0,82,101,108,117,0,69,108,117,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,84,70,73,109,112,111,114,116,101,114,58,58,112,111,112,117,108,97,116,101,78,101,116,40,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,78,101,116,41,0,109,97,120,86,97,108,117,101,46,116,121,112,101,40,41,0,109,97,120,86,97,108,117,101,46,116,111,116,97,108,40,41,0,109,105,110,86,97,108,117,101,46,116,121,112,101,40,41,0,109,105,110,86,97,108,117,101,46,116,111,116,97,108,40,41,0,99,114,111,112,83,105,122,101,46,116,111,116,97,108,40,41,0,99,114,111,112,83,105,122,101,46,116,121,112,101,40,41,0,102,97,99,116,111,114,87,105,100,116,104,46,116,111,116,97,108,40,41,0,102,97,99,116,111,114,87,105,100,116,104,46,116,121,112,101,40,41,0,102,97,99,116,111,114,72,101,105,103,104,116,46,116,111,116,97,108,40,41,0,102,97,99,116,111,114,72,101,105,103,104,116,46,116,121,112,101,40,41,0,111,117,116,83,105,122,101,46,116,111,116,97,108,40,41,0,111,117,116,83,105,122,101,46,116,121,112,101,40,41,0,115,105,122,101,115,46,116,121,112,101,40,41,0,98,101,103,105,110,115,46,116,121,112,101,40,41,0,107,115,105,122,101,0,85,110,115,117,112,112,111,114,116,101,100,32,107,115,105,122,101,0,115,101,116,75,83,105,122,101,0,85,110,115,117,112,112,111,114,116,101,100,32,115,116,114,105,100,101,115,0,115,101,116,83,116,114,105,100,101,115,0,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,70,76,79,65,84,32,124,124,32,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,72,65,76,70,0,107,101,114,110,101,108,70,114,111,109,84,101,110,115,111,114,0,100,105,109,115,32,61,61,32,52,0,98,108,111,98,70,114,111,109,84,101,110,115,111,114,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,116,32,33,61,32,101,110,100,40,41,58,32,0,107,101,121,32,110,111,116,32,102,111,117,110,100,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,77,97,112,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,56,73,110,110,101,114,77,97,112,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,52,104,97,115,104,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,99,111,110,110,101,99,116,0,85,110,107,110,111,119,110,32,115,104,97,112,101,32,111,102,32,105,110,112,117,116,32,116,101,110,115,111,114,0,98,108,111,98,83,104,97,112,101,70,114,111,109,84,101,110,115,111,114,0,77,111,114,101,32,116,104,97,110,32,111,110,101,32,105,110,112,117,116,32,105,115,32,67,111,110,115,116,32,111,112,0,103,101,116,67,111,110,115,116,66,108,111,98,0,67,111,110,115,116,32,105,110,112,117,116,32,98,108,111,98,32,102,111,114,32,119,101,105,103,104,116,115,32,110,111,116,32,102,111,117,110,100,0,73,110,112,117,116,32,91,0,93,32,102,111,114,32,110,111,100,101,32,91,0,93,32,110,111,116,32,102,111,117,110,100,0,85,110,115,117,112,112,111,114,116,101,100,32,107,101,114,110,101,108,32,105,110,112,117,116,0,110,111,100,101,73,100,120,32,60,32,110,101,116,84,120,116,46,110,111,100,101,95,115,105,122,101,40,41,0,110,101,116,84,120,116,46,110,111,100,101,40,110,111,100,101,73,100,120,41,46,110,97,109,101,40,41,32,61,61,32,107,101,114,110,101,108,95,105,110,112,46,110,97,109,101,0,109,97,112,58,58,97,116,58,32,32,107,101,121,32,110,111,116,32,102,111,117,110,100,0,68,101,113,117,97,110,116,105,122,101,0,97,100,100,67,111,110,115,116,78,111,100,101,115,0,99,111,110,115,116,95,108,97,121,101,114,115,46,102,105,110,100,40,108,97,121,101,114,46,105,110,112,117,116,40,105,41,41,32,33,61,32,99,111,110,115,116,95,108,97,121,101,114,115,46,101,110,100,40,41,0,77,73,78,95,70,73,82,83,84,0,104,97,115,76,97,121,101,114,65,116,116,114,40,108,97,121,101,114,44,32,34,109,111,100,101,34,41,32,38,38,32,103,101,116,76,97,121,101,114,65,116,116,114,40,108,97,121,101,114,44,32,34,109,111,100,101,34,41,46,115,40,41,32,61,61,32,34,77,73,78,95,70,73,82,83,84,34,0,116,101,110,115,111,114,45,62,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,81,85,73,78,84,56,0,113,77,105,110,46,116,111,116,97,108,40,41,32,61,61,32,49,0,113,77,105,110,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,113,77,97,120,46,116,111,116,97,108,40,41,32,61,61,32,49,0,113,77,97,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,114,97,110,103,101,83,99,97,108,101,32,62,61,32,48,0,99,111,110,115,116,95,108,97,121,101,114,115,46,105,110,115,101,114,116,40,115,116,100,58,58,109,97,107,101,95,112,97,105,114,40,110,97,109,101,44,32,116,101,110,115,111,114,73,100,41,41,46,115,101,99,111,110,100,0,99,111,110,115,116,95,108,97,121,101,114,115,46,105,110,115,101,114,116,40,115,116,100,58,58,109,97,107,101,95,112,97,105,114,40,110,97,109,101,44,32,108,105,41,41,46,115,101,99,111,110,100,0,100,97,116,97,95,102,111,114,109,97,116,0,78,72,87,67,0,99,104,97,110,110,101,108,115,95,108,97,115,116,0,78,67,72,87,0,99,104,97,110,110,101,108,115,95,102,105,114,115,116,0,85,110,107,110,111,119,110,32,100,97,116,97,95,102,111,114,109,97,116,32,118,97,108,117,101,58,32,0,103,101,116,68,97,116,97,76,97,121,111,117,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,101,110,115,111,114,102,108,111,119,47,116,102,95,105,111,46,99,112,112,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,70,105,108,101,79,114,68,105,101,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,71,114,97,112,104,68,101,102,32,102,105,108,101,58,32,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,66,117,102,102,101,114,79,114,68,105,101,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,71,114,97,112,104,68,101,102,32,98,117,102,102,101,114,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,70,105,108,101,79,114,68,105,101,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,66,117,102,102,101,114,79,114,68,105,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,111,114,99,104,47,116,111,114,99,104,95,105,109,112,111,114,116,101,114,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,76,117,97,32,116,121,112,101,0,114,101,97,100,79,98,106,101,99,116,0,84,101,110,115,111,114,0,116,111,114,99,104,46,0,83,116,111,114,97,103,101,0,116,111,114,99,104,95,105,110,100,101,120,0,83,101,113,117,101,110,116,105,97,108,0,80,97,114,97,108,108,101,108,0,67,111,110,99,97,116,84,97,98,108,101,0,74,111,105,110,84,97,98,108,101,0,68,101,112,116,104,67,111,110,99,97,116,0,73,110,99,101,112,116,105,111,110,0,105,110,112,117,116,68,105,109,101,110,115,105,111,110,0,111,117,116,112,117,116,68,105,109,101,110,115,105,111,110,0,100,105,109,101,110,115,105,111,110,0,83,112,97,116,105,97,108,67,111,110,118,111,108,117,116,105,111,110,0,83,112,97,116,105,97,108,67,111,110,118,111,108,117,116,105,111,110,77,77,0,119,101,105,103,104,116,0,116,101,110,115,111,114,80,97,114,97,109,115,46,99,111,117,110,116,40,34,119,101,105,103,104,116,34,41,0,114,101,97,100,84,111,114,99,104,79,98,106,101,99,116,0,110,79,117,116,112,117,116,80,108,97,110,101,0,108,97,121,101,114,80,97,114,97,109,115,46,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,50,0,83,112,97,116,105,97,108,76,80,80,111,111,108,105,110,103,0,83,112,97,116,105,97,108,77,97,120,80,111,111,108,105,110,103,0,83,112,97,116,105,97,108,65,118,101,114,97,103,101,80,111,111,108,105,110,103,0,77,65,88,0,105,110,100,105,99,101,115,95,98,108,111,98,95,105,100,0,105,110,100,105,99,101,115,0,65,86,69,0,99,111,117,110,116,95,105,110,99,108,117,100,101,95,112,97,100,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,99,101,105,108,95,109,111,100,101,34,41,0,76,105,110,101,97,114,0,86,105,101,119,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,0,98,97,116,99,104,77,111,100,101,0,84,97,110,104,0,83,112,97,116,105,97,108,66,97,116,99,104,78,111,114,109,97,108,105,122,97,116,105,111,110,0,73,110,115,116,97,110,99,101,78,111,114,109,97,108,105,122,97,116,105,111,110,0,66,97,116,99,104,78,111,114,109,97,108,105,122,97,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,101,112,115,34,41,0,114,117,110,110,105,110,103,95,109,101,97,110,0,110,79,117,116,112,117,116,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,34,41,0,114,117,110,110,105,110,103,95,118,97,114,0,114,117,110,110,105,110,103,95,115,116,100,0,116,101,110,115,111,114,80,97,114,97,109,115,91,34,119,101,105,103,104,116,34,93,46,115,101,99,111,110,100,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,67,104,97,110,110,101,108,115,0,116,101,110,115,111,114,80,97,114,97,109,115,91,34,119,101,105,103,104,116,34,93,46,115,101,99,111,110,100,46,116,111,116,97,108,40,41,32,61,61,32,49,0,83,112,97,116,105,97,108,68,114,111,112,111,117,116,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,34,41,0,84,111,116,97,108,86,97,114,105,97,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,109,34,41,0,105,110,100,101,120,0,80,97,100,100,105,110,103,32,119,105,116,104,32,111,102,102,115,101,116,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,110,73,110,112,117,116,68,105,109,0,67,65,100,100,84,97,98,108,101,0,83,112,97,116,105,97,108,68,105,108,97,116,101,100,67,111,110,118,111,108,117,116,105,111,110,0,100,105,108,97,116,105,111,110,87,0,100,105,108,97,116,105,111,110,72,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,87,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,108,97,116,105,111,110,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,108,97,116,105,111,110,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,80,108,97,110,101,34,41,0,112,97,100,95,119,0,112,97,100,95,104,0,100,105,108,97,116,105,111,110,95,119,0,100,105,108,97,116,105,111,110,95,104,0,83,112,97,116,105,97,108,70,117,108,108,67,111,110,118,111,108,117,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,87,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,100,106,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,100,106,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,80,108,97,110,101,34,41,0,83,112,97,116,105,97,108,77,97,120,85,110,112,111,111,108,105,110,103,0,116,101,110,115,111,114,80,97,114,97,109,115,46,99,111,117,110,116,40,34,105,110,100,105,99,101,115,34,41,0,83,111,102,116,77,97,120,0,76,111,103,83,111,102,116,77,97,120,0,83,112,97,116,105,97,108,67,114,111,115,115,77,97,112,76,82,78,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,108,112,104,97,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,98,101,116,97,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,34,41,0,83,113,114,116,0,112,111,119,0,77,117,108,67,111,110,115,116,97,110,116,0,99,111,110,115,116,97,110,116,95,115,99,97,108,97,114,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,99,111,110,115,116,97,110,116,95,115,99,97,108,97,114,34,41,0,83,112,97,116,105,97,108,90,101,114,111,80,97,100,100,105,110,103,0,83,112,97,116,105,97,108,82,101,102,108,101,99,116,105,111,110,80,97,100,100,105,110,103,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,108,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,114,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,116,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,98,34,41,0,83,112,97,116,105,97,108,90,101,114,111,80,97,100,100,105,110,103,32,105,110,32,99,114,111,112,112,105,110,103,32,109,111,100,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,83,104,97,118,101,73,109,97,103,101,0,83,112,97,116,105,97,108,85,112,83,97,109,112,108,105,110,103,78,101,97,114,101,115,116,0,115,99,97,108,101,95,102,97,99,116,111,114,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,115,99,97,108,101,95,102,97,99,116,111,114,34,41,0,85,110,115,117,112,112,111,114,116,101,100,32,84,111,114,99,104,32,99,108,97,115,115,32,34,0,108,117,97,84,121,112,101,32,61,61,32,84,89,80,69,95,84,65,66,76,69,32,38,38,32,114,101,97,100,101,100,73,110,100,101,120,101,115,46,99,111,117,110,116,40,105,110,100,101,120,41,32,61,61,32,48,0,114,101,97,100,84,111,114,99,104,84,97,98,108,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,51,84,111,114,99,104,73,109,112,111,114,116,101,114,54,77,111,100,117,108,101,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,110,110,46,0,99,117,110,110,46,0,99,117,100,110,110,46,0,102,98,99,117,110,110,46,0,114,101,97,100,84,111,114,99,104,83,116,111,114,97,103,101,0,116,121,112,101,105,100,120,32,61,61,32,84,89,80,69,95,84,79,82,67,72,32,124,124,32,40,116,121,112,101,105,100,120,32,61,61,32,84,89,80,69,95,78,73,76,32,38,38,32,110,100,105,109,115,32,61,61,32,48,41,0,114,101,97,100,84,111,114,99,104,84,101,110,115,111,114,0,116,121,112,101,83,116,111,114,97,103,101,32,62,61,32,48,32,38,38,32,116,121,112,101,84,101,110,115,111,114,32,61,61,32,116,121,112,101,83,116,111,114,97,103,101,0,83,116,111,114,97,103,101,32,104,97,115,32,105,110,115,117,102,102,105,99,105,101,110,116,32,110,117,109,98,101,114,32,111,102,32,101,108,101,109,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+378880);allocate([110,116,115,32,102,111,114,32,114,101,113,117,101,115,116,101,100,32,84,101,110,115,111,114,0,68,111,117,98,108,101,0,70,108,111,97,116,0,67,117,100,97,0,66,121,116,101,0,67,104,97,114,0,83,104,111,114,116,0,73,110,116,0,76,111,110,103,0,34,32,111,102,32,116,111,114,99,104,32,99,108,97,115,115,32,34,0,112,97,114,115,101,84,111,114,99,104,84,121,112,101,0,102,105,108,101,32,38,38,32,84,72,70,105,108,101,95,105,115,79,112,101,110,101,100,40,102,105,108,101,41,0,84,111,114,99,104,73,109,112,111,114,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,50,84,72,56,84,72,70,105,108,101,95,95,69,80,70,118,80,83,51,95,69,69,69,0,114,111,111,116,77,111,100,117,108,101,32,61,61,32,78,85,76,76,0,116,111,114,99,104,77,101,114,103,101,0,116,111,114,99,104,83,112,108,105,116,0,116,111,114,99,104,82,101,115,104,97,112,101,0,33,110,117,109,85,110,99,111,110,110,101,99,116,101,100,76,97,121,101,114,115,46,101,109,112,116,121,40,41,0,102,105,108,108,0,110,117,109,73,110,112,117,116,115,32,60,61,32,105,100,115,46,115,105,122,101,40,41,0,116,111,114,99,104,67,65,100,100,84,97,98,108,101,0,109,111,100,117,108,101,45,62,112,97,114,97,109,115,46,104,97,115,40,34,105,110,100,105,99,101,115,95,98,108,111,98,95,105,100,34,41,0,116,111,114,99,104,77,97,120,85,110,112,111,111,108,105,110,103,0,112,111,111,108,105,110,103,76,97,121,101,114,46,102,105,114,115,116,32,33,61,32,45,49,0,85,110,101,120,112,101,99,116,101,100,32,116,111,114,99,104,32,99,111,110,116,97,105,110,101,114,58,32,0,114,101,97,100,78,101,116,70,114,111,109,68,97,114,107,110,101,116,0,95,37,100,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,97,114,107,110,101,116,47,100,97,114,107,110,101,116,95,105,109,112,111,114,116,101,114,46,99,112,112,0,78,83,116,51,95,95,50,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,66,117,102,102,101,114,83,116,114,101,97,109,69,0,112,98,66,108,111,98,46,100,97,116,97,95,115,105,122,101,40,41,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,98,108,111,98,70,114,111,109,80,114,111,116,111,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,99,97,102,102,101,47,99,97,102,102,101,95,105,109,112,111,114,116,101,114,46,99,112,112,0,112,98,66,108,111,98,46,114,97,119,95,100,97,116,97,95,116,121,112,101,40,41,32,61,61,32,99,97,102,102,101,58,58,70,76,79,65,84,49,54,0,114,97,119,95,100,97,116,97,46,115,105,122,101,40,41,32,47,32,50,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,110,117,109,66,108,111,98,115,32,61,61,32,98,105,110,76,97,121,101,114,45,62,98,108,111,98,115,40,41,46,67,108,101,97,114,101,100,67,111,117,110,116,40,41,0,101,120,116,114,97,99,116,66,105,110,97,114,121,76,97,121,101,114,80,97,114,97,109,115,0,73,110,112,117,116,0,108,97,121,101,114,46,98,111,116,116,111,109,95,115,105,122,101,40,41,32,61,61,32,49,0,112,111,112,117,108,97,116,101,78,101,116,0,108,97,121,101,114,46,116,111,112,95,115,105,122,101,40,41,32,61,61,32,49,0,67,111,110,118,111,108,117,116,105,111,110,68,101,112,116,104,119,105,115,101,0,67,97,110,39,116,32,102,105,110,100,32,111,117,116,112,117,116,32,98,108,111,98,32,34,0,97,100,100,73,110,112,117,116,0,68,117,112,108,105,99,97,116,101,32,98,108,111,98,115,32,112,114,111,100,117,99,101,100,32,98,121,32,109,117,108,116,105,112,108,101,32,115,111,117,114,99,101,115,0,97,100,100,79,117,116,112,117,116,0,95,112,97,114,97,109,0,102,105,101,108,100,46,116,121,112,101,40,41,32,61,61,32,103,111,111,103,108,101,58,58,112,114,111,116,111,98,117,102,58,58,85,110,107,110,111,119,110,70,105,101,108,100,58,58,84,89,80,69,95,71,82,79,85,80,0,101,120,116,114,97,99,116,67,117,115,116,111,109,80,97,114,97,109,115,0,85,110,107,110,111,119,110,32,116,121,112,101,32,34,0,34,32,105,110,32,112,114,111,116,111,116,120,116,0,97,100,100,80,97,114,97,109,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,75,78,83,48,95,49,53,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,69,69,69,0,118,48,95,108,97,121,101,114,95,99,111,110,110,101,99,116,105,111,110,95,32,33,61,32,78,85,76,76,0,85,112,103,114,97,100,101,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,99,111,110,118,0,105,110,110,101,114,112,114,111,100,117,99,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,99,97,102,102,101,47,99,97,102,102,101,95,105,111,46,99,112,112,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,117,109,95,111,117,116,112,117,116,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,105,97,115,116,101,114,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,119,101,105,103,104,116,95,102,105,108,108,101,114,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,105,97,115,95,102,105,108,108,101,114,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,112,111,111,108,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,112,97,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,107,101,114,110,101,108,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,103,114,111,117,112,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,116,114,105,100,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,111,111,108,32,109,101,116,104,111,100,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,112,111,111,108,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,100,114,111,112,111,117,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,114,111,112,111,117,116,95,114,97,116,105,111,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,108,114,110,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,108,111,99,97,108,95,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,97,108,112,104,97,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,101,116,97,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,107,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,100,97,116,97,0,104,100,102,53,95,100,97,116,97,0,105,109,97,103,101,115,0,119,105,110,100,111,119,95,100,97,116,97,0,105,110,102,111,103,97,105,110,95,108,111,115,115,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,111,117,114,99,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,97,116,99,104,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,114,97,110,100,95,115,107,105,112,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,104,117,102,102,108,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,101,119,95,104,101,105,103,104,116,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,101,119,95,119,105,100,116,104,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,99,111,110,99,97,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,99,111,110,99,97,116,95,100,105,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,102,103,95,116,104,114,101,115,104,111,108,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,98,103,95,116,104,114,101,115,104,111,108,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,102,103,95,102,114,97,99,116,105,111,110,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,99,111,110,116,101,120,116,95,112,97,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,99,114,111,112,95,109,111,100,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,104,100,102,53,95,111,117,116,112,117,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,97,99,99,117,114,97,99,121,0,98,110,108,108,0,101,117,99,108,105,100,101,97,110,95,108,111,115,115,0,102,108,97,116,116,101,110,0,105,109,50,99,111,108,0,109,117,108,116,105,110,111,109,105,97,108,95,108,111,103,105,115,116,105,99,95,108,111,115,115,0,114,101,108,117,0,115,105,103,109,111,105,100,0,115,111,102,116,109,97,120,95,108,111,115,115,0,115,112,108,105,116,0,85,112,103,114,97,100,101,86,48,76,97,121,101,114,84,121,112,101,0,85,110,107,110,111,119,110,32,108,97,121,101,114,32,110,97,109,101,58,32,0,85,112,103,114,97,100,101,86,48,80,97,100,100,105,110,103,76,97,121,101,114,115,0,85,110,107,110,111,119,110,32,98,108,111,98,32,105,110,112,117,116,32,0,32,116,111,32,108,97,121,101,114,32,0,67,72,69,67,75,0,40,108,97,121,101,114,95,112,97,114,97,109,46,116,121,112,101,40,41,32,61,61,32,34,99,111,110,118,34,41,32,124,124,32,40,108,97,121,101,114,95,112,97,114,97,109,46,116,121,112,101,40,41,32,61,61,32,34,112,111,111,108,34,41,0,80,97,100,100,105,110,103,32,108,97,121,101,114,32,105,110,112,117,116,32,116,111,32,110,111,110,45,99,111,110,118,111,108,117,116,105,111,110,97,108,32,47,32,110,111,110,45,112,111,111,108,105,110,103,32,108,97,121,101,114,32,116,121,112,101,32,0,108,97,121,101,114,95,99,111,110,110,101,99,116,105,111,110,46,98,111,116,116,111,109,95,115,105,122,101,40,41,61,49,0,67,111,110,118,32,76,97,121,101,114,32,116,97,107,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,105,110,112,117,116,46,0,115,111,117,114,99,101,95,108,97,121,101,114,46,98,111,116,116,111,109,95,115,105,122,101,40,41,61,49,0,80,97,100,100,105,110,103,32,76,97,121,101,114,32,116,97,107,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,105,110,112,117,116,46,0,115,111,117,114,99,101,95,108,97,121,101,114,46,116,111,112,95,115,105,122,101,40,41,61,49,0,80,97,100,100,105,110,103,32,76,97,121,101,114,32,112,114,111,100,117,99,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,111,117,116,112,117,116,46,0,85,112,103,114,97,100,101,78,101,116,65,115,78,101,101,100,101,100,0,65,116,116,101,109,112,116,105,110,103,32,116,111,32,117,112,103,114,97,100,101,32,105,110,112,117,116,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,58,32,0,87,97,114,110,105,110,103,58,32,104,97,100,32,111,110,101,32,111,114,32,109,111,114,101,32,112,114,111,98,108,101,109,115,32,117,112,103,114,97,100,105,110,103,32,0,86,48,78,101,116,80,97,114,97,109,101,116,101,114,32,116,111,32,78,101,116,80,97,114,97,109,101,116,101,114,32,40,115,101,101,32,97,98,111,118,101,41,59,32,99,111,110,116,105,110,117,105,110,103,32,97,110,121,119,97,121,46,0,83,117,99,99,101,115,115,102,117,108,108,121,32,117,112,103,114,97,100,101,100,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,78,111,116,101,32,116,104,97,116,32,102,117,116,117,114,101,32,67,97,102,102,101,32,114,101,108,101,97,115,101,115,32,119,105,108,108,32,110,111,116,32,115,117,112,112,111,114,116,32,0,86,48,78,101,116,80,97,114,97,109,101,116,101,114,59,32,117,115,101,32,46,47,98,117,105,108,100,47,116,111,111,108,115,47,117,112,103,114,97,100,101,95,110,101,116,95,112,114,111,116,111,95,116,101,120,116,32,102,111,114,32,0,112,114,111,116,111,116,120,116,32,97,110,100,32,46,47,98,117,105,108,100,47,116,111,111,108,115,47,117,112,103,114,97,100,101,95,110,101,116,95,112,114,111,116,111,95,98,105,110,97,114,121,32,102,111,114,32,109,111,100,101,108,32,0,119,101,105,103,104,116,115,32,117,112,103,114,97,100,101,32,116,104,105,115,32,97,110,100,32,97,110,121,32,111,116,104,101,114,32,110,101,116,32,112,114,111,116,111,115,32,116,111,32,116,104,101,32,110,101,119,32,102,111,114,109,97,116,46,0,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,112,97,114,97,109,101,116,101,114,115,58,32,0,100,97,116,97,32,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,112,97,114,97,109,101,116,101,114,115,46,0,78,111,116,101,32,116,104,97,116,32,102,117,116,117,114,101,32,67,97,102,102,101,32,114,101,108,101,97,115,101,115,32,119,105,108,108,32,111,110,108,121,32,115,117,112,112,111,114,116,32,0,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,32,109,101,115,115,97,103,101,115,32,102,111,114,32,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,102,105,101,108,100,115,46,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,58,32,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,32,40,115,101,101,32,97,98,111,118,101,41,59,32,99,111,110,116,105,110,117,105,110,103,32,97,110,121,119,97,121,46,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,65,116,116,101,109,112,116,105,110,103,32,116,111,32,117,112,103,114,97,100,101,32,98,97,116,99,104,32,110,111,114,109,32,108,97,121,101,114,115,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,112,97,114,97,109,115,58,32,0,83,117,99,99,101,115,115,102,117,108,108,121,32,117,112,103,114,97,100,101,100,32,98,97,116,99,104,32,110,111,114,109,32,108,97,121,101,114,115,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,112,97,114,97,109,115,46,0,110,101,116,95,112,97,114,97,109,32,33,61,32,78,85,76,76,0,85,112,103,114,97,100,101,86,49,78,101,116,0,73,110,112,117,116,32,78,101,116,80,97,114,97,109,101,116,101,114,32,116,111,32,98,101,32,117,112,103,114,97,100,101,100,32,97,108,114,101,97,100,121,32,115,112,101,99,105,102,105,101,115,32,39,108,97,121,101,114,39,32,0,102,105,101,108,100,115,59,32,116,104,101,115,101,32,119,105,108,108,32,98,101,32,105,103,110,111,114,101,100,32,102,111,114,32,116,104,101,32,117,112,103,114,97,100,101,46,0,85,112,103,114,97,100,101,32,111,102,32,105,110,112,117,116,32,108,97,121,101,114,32,0,32,102,97,105,108,101,100,46,0,118,49,95,108,97,121,101,114,95,112,97,114,97,109,95,32,33,61,32,78,85,76,76,0,85,112,103,114,97,100,101,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,85,110,107,110,111,119,110,32,98,108,111,98,95,115,104,97,114,101,95,109,111,100,101,58,32,37,100,0,85,110,107,110,111,119,110,32,98,108,111,98,95,115,104,97,114,101,95,109,111,100,101,58,32,0,73,110,112,117,116,32,78,101,116,80,97,114,97,109,101,116,101,114,32,104,97,115,32,86,48,32,108,97,121,101,114,32,45,45,32,105,103,110,111,114,105,110,103,46,0,85,112,103,114,97,100,101,86,49,76,97,121,101,114,84,121,112,101,0,85,110,107,110,111,119,110,32,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,32,108,97,121,101,114,32,116,121,112,101,58,32,0,84,104,114,101,115,104,111,108,100,0,87,105,110,100,111,119,68,97,116,97,0,84,97,110,72,0,83,111,102,116,109,97,120,87,105,116,104,76,111,115,115,0,83,105,103,109,111,105,100,67,114,111,115,115,69,110,116,114,111,112,121,76,111,115,115,0,82,101,76,85,0,77,117,108,116,105,110,111,109,105,97,108,76,111,103,105,115,116,105,99,76,111,115,115,0,77,101,109,111,114,121,68,97,116,97,0,73,110,102,111,103,97,105,110,76,111,115,115,0,73,109,97,103,101,68,97,116,97,0,73,109,50,99,111,108,0,72,105,110,103,101,76,111,115,115,0,72,68,70,53,79,117,116,112,117,116,0,72,68,70,53,68,97,116,97,0,69,117,99,108,105,100,101,97,110,76,111,115,115,0,68,117,109,109,121,68,97,116,97,0,68,97,116,97,0,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,0,66,78,76,76,0,65,114,103,77,97,120,0,65,99,99,117,114,97,99,121,0,114,0,82,101,97,100,80,114,111,116,111,70,114,111,109,84,101,120,116,70,105,108,101,0,102,115,46,105,115,95,111,112,101,110,40,41,0,67,97,110,39,116,32,111,112,101,110,32,34,0,82,101,97,100,80,114,111,116,111,70,114,111,109,66,105,110,97,114,121,70,105,108,101,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,70,105,108,101,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,84,101,120,116,70,105,108,101,40,112,97,114,97,109,95,102,105,108,101,44,32,112,97,114,97,109,41,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,78,101,116,80,97,114,97,109,101,116,101,114,32,102,105,108,101,58,32,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,66,117,102,102,101,114,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,84,101,120,116,66,117,102,102,101,114,40,100,97,116,97,44,32,108,101,110,44,32,112,97,114,97,109,41,0,109,101,109,111,114,121,32,98,117,102,102,101,114,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,78,101,116,80,97,114,97,109,101,116,101,114,32,98,117,102,102,101,114,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,70,105,108,101,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,66,105,110,97,114,121,70,105,108,101,40,112,97,114,97,109,95,102,105,108,101,44,32,112,97,114,97,109,41,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,66,117,102,102,101,114,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,66,105,110,97,114,121,66,117,102,102,101,114,40,100,97,116,97,44,32,108,101,110,44,32,112,97,114,97,109,41,0,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,0,10,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,12,116,101,110,115,111,114,46,112,114,111,116,111,26,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,182,4,10,9,65,116,116,114,86,97,108,117,101,18,11,10,1,115,24,2,32,1,40,12,72,0,18,11,10,1,105,24,3,32,1,40,3,72,0,18,11,10,1,102,24,4,32,1,40,2,72,0,18,11,10,1,98,24,5,32,1,40,8,72,0,18,43,10,4,116,121,112,101,24,6,32,1,40,14,50,27,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,72,0,18,52,10,5,115,104,97,112,101,24,7,32,1,40,11,50,35,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,72,0,18,48,10,6,116,101,110,115,111,114,24,8,32,1,40,11,50,30,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,80,114,111,116,111,72,0,18,54,10,4,108,105,115,116,24,1,32,1,40,11,50,38,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,46,76,105,115,116,86,97,108,117,101,72,0,18,47,10,4,102,117,110,99,24,10,32,1,40,11,50,31,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,72,0,18,21,10,11,112,108,97,99,101,104,111,108,100,101,114,24,9,32,1,40,9,72,0,26,214,1,10,9,76,105,115,116,86,97,108,117,101,18,9,10,1,115,24,2,32,3,40,12,18,13,10,1,105,24,3,32,3,40,3,66,2,16,1,18,13,10,1,102,24,4,32,3,40,2,66,2,16,1,18,13,10,1,98,24,5,32,3,40,8,66,2,16,1,18,45,10,4,116,121,112,101,24,6,32,3,40,14,50,27,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,66,2,16,1,18,50,10,5,115,104,97,112,101,24,7,32,3,40,11,50,35,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,46,10,6,116,101,110,115,111,114,24,8,32,3,40,11,50,30,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,80,114,111,116,111,66,7,10,5,118,97,108,117,101,34,160,1,10,12,78,97,109,101,65,116,116,114,76,105,115,116,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,55,10,4,97,116,116,114,24,2,32,3,40,11,50,41,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,65,116,116,114,69,110,116,114,121,26,73,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,43,10,5,118,97,108,117,101,24,2,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,66,48,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,15,65,116,116,114,86,97,108,117,101,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,97,116,116,114,95,118,97,108,117,101,46,112,98,46,99,99,0,77,97,112,75,101,121,58,58,116,121,112,101,32,77,97,112,75,101,121,32,105,115,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,100,46,32,0,67,97,108,108,32,115,101,116,32,109,101,116,104,111,100,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,32,77,97,112,75,101,121,46,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,50,78,97,109,101,65,116,116,114,76,105,115,116,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,57,73,110,116,101,114,110,97,108,77,101,116,97,100,97,116,97,87,105,116,104,65,114,101,110,97,66,97,115,101,73,78,83,48,95,49,53,85,110,107,110,111,119,110,70,105,101,108,100,83,101,116,69,78,83,49,95,50,53,73,110,116,101,114,110,97,108,77,101,116,97,100,97,116,97,87,105,116,104,65,114,101,110,97,69,69,57,67,111,110,116,97,105,110,101,114,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,69,110,116,114,121,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,48,95,55,77,101,115,115,97,103,101,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,66,97,115,101,69,0,77,97,112,75,101,121,58,58,71,101,116,83,116,114,105,110,103,86,97,108,117,101,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,70,105,101,108,100,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,84,121,112,101,68,101,102,105,110,101,100,77,97,112,70,105,101,108,100,66,97,115,101,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,46,112,108,97,99,101,104,111,108,100,101,114,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,49,53,77,97,112,69,110,116,114,121,87,114,97,112,112,101,114,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,57,65,116,116,114,86,97,108,117,101,95,76,105,115,116,86,97,108,117,101,69,0,103,114,97,112,104,46,112,114,111,116,111,0,10,11,103,114,97,112,104,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,14,102,117,110,99,116,105,111,110,46,112,114,111,116,111,26,14,118,101,114,115,105,111,110,115,46,112,114,111,116,111,34,178,1,10,8,71,114,97,112,104,68,101,102,18,40,10,4,110,111,100,101,24,1,32,3,40,11,50,26,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,18,47,10,8,118,101,114,115,105,111,110,115,24,4,32,1,40,11,50,29,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,86,101,114,115,105,111,110,68,101,102,18,19,10,7,118,101,114,115,105,111,110,24,3,32,1,40,5,66,2,24,1,18,54,10,7,108,105,98,114,97,114,121,24,2,32,1,40,11,50,37,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,34,193,1,10,7,78,111,100,101,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,10,10,2,111,112,24,2,32,1,40,9,18,13,10,5,105,110,112,117,116,24,3,32,3,40,9,18,14,10,6,100,101,118,105,99,101,24,4,32,1,40,9,18,50,10,4,97,116,116,114,24,5,32,3,40,11,50,36,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,65,116,116,114,69,110,116,114,121,26,73,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,43,10,5,118,97,108,117,101,24,2,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,71,114,97,112,104,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,103,114,97,112,104,46,112,98,46,99,99,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,69,110,116,114,121,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,70,105,101,108,100,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,111,112,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,105,110,112,117,116,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,100,101,118,105,99,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,49,53,77,97,112,69,110,116,114,121,87,114,97,112,112,101,114,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,55,78,111,100,101,68,101,102,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,56,71,114,97,112,104,68,101,102,69,0,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,0,10,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,34,129,1,10,16,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,52,10,3,100,105,109,24,2,32,3,40,11,50,39,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,46,68,105,109,18,20,10,12,117,110,107,110,111,119,110,95,114,97,110,107,24,3,32,1,40,8,26,33,10,3,68,105,109,18,12,10,4,115,105,122,101,24,1,32,1,40,3,18,12,10,4,110,97,109,101,24,2,32,1,40,9,66,50,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,17,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,116,101,110,115,111,114,95,115,104,97,112,101,46,112,98,46,99,99,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,54,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,46,68,105,109,46,110,97,109,101,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,48,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,95,68,105,109,69,0,118,101,114,115,105,111,110,115,46,112,114,111,116,111,0,10,14,118,101,114,115,105,111,110,115,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,34,75,10,10,86,101,114,115,105,111,110,68,101,102],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+389120);allocate([18,16,10,8,112,114,111,100,117,99,101,114,24,1,32,1,40,5,18,20,10,12,109,105,110,95,99,111,110,115,117,109,101,114,24,2,32,1,40,5,18,21,10,13,98,97,100,95,99,111,110,115,117,109,101,114,115,24,3,32,3,40,5,66,47,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,14,86,101,114,115,105,111,110,115,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,118,101,114,115,105,111,110,115,46,112,98,46,99,99,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,48,86,101,114,115,105,111,110,68,101,102,69,0,116,101,110,115,111,114,46,112,114,111,116,111,0,10,12,116,101,110,115,111,114,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,243,2,10,11,84,101,110,115,111,114,80,114,111,116,111,18,42,10,5,100,116,121,112,101,24,1,32,1,40,14,50,27,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,18,57,10,12,116,101,110,115,111,114,95,115,104,97,112,101,24,2,32,1,40,11,50,35,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,22,10,14,118,101,114,115,105,111,110,95,110,117,109,98,101,114,24,3,32,1,40,5,18,22,10,14,116,101,110,115,111,114,95,99,111,110,116,101,110,116,24,4,32,1,40,12,18,20,10,8,104,97,108,102,95,118,97,108,24,13,32,3,40,5,66,2,16,1,18,21,10,9,102,108,111,97,116,95,118,97,108,24,5,32,3,40,2,66,2,16,1,18,22,10,10,100,111,117,98,108,101,95,118,97,108,24,6,32,3,40,1,66,2,16,1,18,19,10,7,105,110,116,95,118,97,108,24,7,32,3,40,5,66,2,16,1,18,18,10,10,115,116,114,105,110,103,95,118,97,108,24,8,32,3,40,12,18,24,10,12,115,99,111,109,112,108,101,120,95,118,97,108,24,9,32,3,40,2,66,2,16,1,18,21,10,9,105,110,116,54,52,95,118,97,108,24,10,32,3,40,3,66,2,16,1,18,20,10,8,98,111,111,108,95,118,97,108,24,11,32,3,40,8,66,2,16,1,18,24,10,12,100,99,111,109,112,108,101,120,95,118,97,108,24,12,32,3,40,1,66,2,16,1,66,45,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,12,84,101,110,115,111,114,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,116,101,110,115,111,114,46,112,98,46,99,99,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,49,84,101,110,115,111,114,80,114,111,116,111,69,0,10,11,116,121,112,101,115,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,42,156,5,10,8,68,97,116,97,84,121,112,101,18,14,10,10,68,84,95,73,78,86,65,76,73,68,16,0,18,12,10,8,68,84,95,70,76,79,65,84,16,1,18,13,10,9,68,84,95,68,79,85,66,76,69,16,2,18,12,10,8,68,84,95,73,78,84,51,50,16,3,18,12,10,8,68,84,95,85,73,78,84,56,16,4,18,12,10,8,68,84,95,73,78,84,49,54,16,5,18,11,10,7,68,84,95,73,78,84,56,16,6,18,13,10,9,68,84,95,83,84,82,73,78,71,16,7,18,16,10,12,68,84,95,67,79,77,80,76,69,88,54,52,16,8,18,12,10,8,68,84,95,73,78,84,54,52,16,9,18,11,10,7,68,84,95,66,79,79,76,16,10,18,12,10,8,68,84,95,81,73,78,84,56,16,11,18,13,10,9,68,84,95,81,85,73,78,84,56,16,12,18,13,10,9,68,84,95,81,73,78,84,51,50,16,13,18,15,10,11,68,84,95,66,70,76,79,65,84,49,54,16,14,18,13,10,9,68,84,95,81,73,78,84,49,54,16,15,18,14,10,10,68,84,95,81,85,73,78,84,49,54,16,16,18,13,10,9,68,84,95,85,73,78,84,49,54,16,17,18,17,10,13,68,84,95,67,79,77,80,76,69,88,49,50,56,16,18,18,11,10,7,68,84,95,72,65,76,70,16,19,18,16,10,12,68,84,95,70,76,79,65,84,95,82,69,70,16,101,18,17,10,13,68,84,95,68,79,85,66,76,69,95,82,69,70,16,102,18,16,10,12,68,84,95,73,78,84,51,50,95,82,69,70,16,103,18,16,10,12,68,84,95,85,73,78,84,56,95,82,69,70,16,104,18,16,10,12,68,84,95,73,78,84,49,54,95,82,69,70,16,105,18,15,10,11,68,84,95,73,78,84,56,95,82,69,70,16,106,18,17,10,13,68,84,95,83,84,82,73,78,71,95,82,69,70,16,107,18,20,10,16,68,84,95,67,79,77,80,76,69,88,54,52,95,82,69,70,16,108,18,16,10,12,68,84,95,73,78,84,54,52,95,82,69,70,16,109,18,15,10,11,68,84,95,66,79,79,76,95,82,69,70,16,110,18,16,10,12,68,84,95,81,73,78,84,56,95,82,69,70,16,111,18,17,10,13,68,84,95,81,85,73,78,84,56,95,82,69,70,16,112,18,17,10,13,68,84,95,81,73,78,84,51,50,95,82,69,70,16,113,18,19,10,15,68,84,95,66,70,76,79,65,84,49,54,95,82,69,70,16,114,18,17,10,13,68,84,95,81,73,78,84,49,54,95,82,69,70,16,115,18,18,10,14,68,84,95,81,85,73,78,84,49,54,95,82,69,70,16,116,18,17,10,13,68,84,95,85,73,78,84,49,54,95,82,69,70,16,117,18,21,10,17,68,84,95,67,79,77,80,76,69,88,49,50,56,95,82,69,70,16,118,18,15,10,11,68,84,95,72,65,76,70,95,82,69,70,16,119,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,84,121,112,101,115,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,116,121,112,101,115,46,112,114,111,116,111,0,111,112,101,110,99,118,45,99,97,102,102,101,46,112,114,111,116,111,0,10,18,111,112,101,110,99,118,45,99,97,102,102,101,46,112,114,111,116,111,18,12,111,112,101,110,99,118,95,99,97,102,102,101,34,28,10,9,66,108,111,98,83,104,97,112,101,18,15,10,3,100,105,109,24,1,32,3,40,3,66,2,16,1,34,148,2,10,9,66,108,111,98,80,114,111,116,111,18,38,10,5,115,104,97,112,101,24,7,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,16,10,4,100,97,116,97,24,5,32,3,40,2,66,2,16,1,18,16,10,4,100,105,102,102,24,6,32,3,40,2,66,2,16,1,18,23,10,11,100,111,117,98,108,101,95,100,97,116,97,24,8,32,3,40,1,66,2,16,1,18,23,10,11,100,111,117,98,108,101,95,100,105,102,102,24,9,32,3,40,1,66,2,16,1,18,41,10,13,114,97,119,95,100,97,116,97,95,116,121,112,101,24,10,32,1,40,14,50,18,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,121,112,101,18,20,10,8,114,97,119,95,100,97,116,97,24,12,32,1,40,12,66,2,16,0,18,14,10,3,110,117,109,24,1,32,1,40,5,58,1,48,18,19,10,8,99,104,97,110,110,101,108,115,24,2,32,1,40,5,58,1,48,18,17,10,6,104,101,105,103,104,116,24,3,32,1,40,5,58,1,48,18,16,10,5,119,105,100,116,104,24,4,32,1,40,5,58,1,48,34,57,10,15,66,108,111,98,80,114,111,116,111,86,101,99,116,111,114,18,38,10,5,98,108,111,98,115,24,1,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,34,33,10,16,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,18,13,10,5,111,114,100,101,114,24,1,32,3,40,13,34,157,1,10,22,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,18,28,10,14,97,99,114,111,115,115,95,115,112,97,116,105,97,108,24,1,32,1,40,8,58,4,116,114,117,101,18,51,10,12,115,99,97,108,101,95,102,105,108,108,101,114,24,2,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,28,10,14,99,104,97,110,110,101,108,95,115,104,97,114,101,100,24,3,32,1,40,8,58,4,116,114,117,101,18,18,10,3,101,112,115,24,4,32,1,40,2,58,5,49,101,45,49,48,34,230,2,10,17,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,18,16,10,8,109,105,110,95,115,105,122,101,24,1,32,1,40,2,18,16,10,8,109,97,120,95,115,105,122,101,24,2,32,1,40,2,18,20,10,12,97,115,112,101,99,116,95,114,97,116,105,111,24,3,32,3,40,2,18,18,10,4,102,108,105,112,24,4,32,1,40,8,58,4,116,114,117,101,18,18,10,4,99,108,105,112,24,5,32,1,40,8,58,4,116,114,117,101,18,16,10,8,118,97,114,105,97,110,99,101,24,6,32,3,40,2,18,16,10,8,105,109,103,95,115,105,122,101,24,7,32,1,40,13,18,13,10,5,105,109,103,95,104,24,8,32,1,40,13,18,13,10,5,105,109,103,95,119,24,9,32,1,40,13,18,12,10,4,115,116,101,112,24,10,32,1,40,2,18,14,10,6,115,116,101,112,95,104,24,11,32,1,40,2,18,14,10,6,115,116,101,112,95,119,24,12,32,1,40,2,18,19,10,6,111,102,102,115,101,116,24,13,32,1,40,2,58,3,48,46,53,18,16,10,8,111,102,102,115,101,116,95,104,24,14,32,3,40,2,18,16,10,8,111,102,102,115,101,116,95,119,24,15,32,3,40,2,18,13,10,5,119,105,100,116,104,24,16,32,3,40,2,18,14,10,6,104,101,105,103,104,116,24,17,32,3,40,2,34,39,10,8,67,111,100,101,84,121,112,101,18,10,10,6,67,79,82,78,69,82,16,1,18,15,10,11,67,69,78,84,69,82,95,83,73,90,69,16,2,34,177,3,10,24,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,19,10,11,110,117,109,95,99,108,97,115,115,101,115,24,1,32,1,40,13,18,28,10,14,115,104,97,114,101,95,108,111,99,97,116,105,111,110,24,2,32,1,40,8,58,4,116,114,117,101,18,30,10,19,98,97,99,107,103,114,111,117,110,100,95,108,97,98,101,108,95,105,100,24,3,32,1,40,5,58,1,48,18,63,10,9,110,109,115,95,112,97,114,97,109,24,4,32,1,40,11,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,18,60,10,17,115,97,118,101,95,111,117,116,112,117,116,95,112,97,114,97,109,24,5,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,67,10,9,99,111,100,101,95,116,121,112,101,24,6,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,46,67,111,100,101,84,121,112,101,58,6,67,79,82,78,69,82,18,41,10,26,118,97,114,105,97,110,99,101,95,101,110,99,111,100,101,100,95,105,110,95,116,97,114,103,101,116,24,8,32,1,40,8,58,5,102,97,108,115,101,18,22,10,10,107,101,101,112,95,116,111,112,95,107,24,7,32,1,40,5,58,2,45,49,18,28,10,20,99,111,110,102,105,100,101,110,99,101,95,116,104,114,101,115,104,111,108,100,24,9,32,1,40,2,18,29,10,15,110,111,114,109,97,108,105,122,101,100,95,98,98,111,120,24,10,32,1,40,8,58,4,116,114,117,101,34,129,1,10,5,68,97,116,117,109,18,16,10,8,99,104,97,110,110,101,108,115,24,1,32,1,40,5,18,14,10,6,104,101,105,103,104,116,24,2,32,1,40,5,18,13,10,5,119,105,100,116,104,24,3,32,1,40,5,18,12,10,4,100,97,116,97,24,4,32,1,40,12,18,13,10,5,108,97,98,101,108,24,5,32,1,40,5,18,18,10,10,102,108,111,97,116,95,100,97,116,97,24,6,32,3,40,2,18,22,10,7,101,110,99,111,100,101,100,24,7,32,1,40,8,58,5,102,97,108,115,101,34,145,2,10,15,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,22,10,4,116,121,112,101,24,1,32,1,40,9,58,8,99,111,110,115,116,97,110,116,18,16,10,5,118,97,108,117,101,24,2,32,1,40,2,58,1,48,18,14,10,3,109,105,110,24,3,32,1,40,2,58,1,48,18,14,10,3,109,97,120,24,4,32,1,40,2,58,1,49,18,15,10,4,109,101,97,110,24,5,32,1,40,2,58,1,48,18,14,10,3,115,116,100,24,6,32,1,40,2,58,1,49,18,18,10,6,115,112,97,114,115,101,24,7,32,1,40,5,58,2,45,49,18,73,10,13,118,97,114,105,97,110,99,101,95,110,111,114,109,24,8,32,1,40,14,50,42,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,46,86,97,114,105,97,110,99,101,78,111,114,109,58,6,70,65,78,95,73,78,34,52,10,12,86,97,114,105,97,110,99,101,78,111,114,109,18,10,10,6,70,65,78,95,73,78,16,0,18,11,10,7,70,65,78,95,79,85,84,16,1,18,11,10,7,65,86,69,82,65,71,69,16,2,34,170,2,10,12,78,101,116,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,13,10,5,105,110,112,117,116,24,3,32,3,40,9,18,44,10,11,105,110,112,117,116,95,115,104,97,112,101,24,8,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,17,10,9,105,110,112,117,116,95,100,105,109,24,4,32,3,40,5,18,29,10,14,102,111,114,99,101,95,98,97,99,107,119,97,114,100,24,5,32,1,40,8,58,5,102,97,108,115,101,18,37,10,5,115,116,97,116,101,24,6,32,1,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,7,32,1,40,8,58,5,102,97,108,115,101,18,43,10,5,108,97,121,101,114,24,100,32,3,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,46,10,6,108,97,121,101,114,115,24,2,32,3,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,34,218,10,10,15,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,18,11,10,3,110,101,116,24,24,32,1,40,9,18,45,10,9,110,101,116,95,112,97,114,97,109,24,25,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,17,10,9,116,114,97,105,110,95,110,101,116,24,1,32,1,40,9,18,16,10,8,116,101,115,116,95,110,101,116,24,2,32,3,40,9,18,51,10,15,116,114,97,105,110,95,110,101,116,95,112,97,114,97,109,24,21,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,50,10,14,116,101,115,116,95,110,101,116,95,112,97,114,97,109,24,22,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,43,10,11,116,114,97,105,110,95,115,116,97,116,101,24,26,32,1,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,42,10,10,116,101,115,116,95,115,116,97,116,101,24,27,32,3,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,17,10,9,116,101,115,116,95,105,116,101,114,24,3,32,3,40,5,18,24,10,13,116,101,115,116,95,105,110,116,101,114,118,97,108,24,4,32,1,40,5,58,1,48,18,32,10,17,116,101,115,116,95,99,111,109,112,117,116,101,95,108,111,115,115,24,19,32,1,40,8,58,5,102,97,108,115,101,18,33,10,19,116,101,115,116,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,24,32,32,1,40,8,58,4,116,114,117,101,18,15,10,7,98,97,115,101,95,108,114,24,5,32,1,40,2,18,15,10,7,100,105,115,112,108,97,121,24,6,32,1,40,5,18,23,10,12,97,118,101,114,97,103,101,95,108,111,115,115,24,33,32,1,40,5,58,1,49,18,16,10,8,109,97,120,95,105,116,101,114,24,7,32,1,40,5,18,20,10,9,105,116,101,114,95,115,105,122,101,24,36,32,1,40,5,58,1,49,18,17,10,9,108,114,95,112,111,108,105,99,121,24,8,32,1,40,9,18,13,10,5,103,97,109,109,97,24,9,32,1,40,2,18,13,10,5,112,111,119,101,114,24,10,32,1,40,2,18,16,10,8,109,111,109,101,110,116,117,109,24,11,32,1,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,12,32,1,40,2,18,31,10,19,114,101,103,117,108,97,114,105,122,97,116,105,111,110,95,116,121,112,101,24,29,32,1,40,9,58,2,76,50,18,16,10,8,115,116,101,112,115,105,122,101,24,13,32,1,40,5,18,17,10,9,115,116,101,112,118,97,108,117,101,24,34,32,3,40,5,18,26,10,14,99,108,105,112,95,103,114,97,100,105,101,110,116,115,24,35,32,1,40,2,58,2,45,49,18,19,10,8,115,110,97,112,115,104,111,116,24,14,32,1,40,5,58,1,48,18,23,10,15,115,110,97,112,115,104,111,116,95,112,114,101,102,105,120,24,15,32,1,40,9,18,28,10,13,115,110,97,112,115,104,111,116,95,100,105,102,102,24,16,32,1,40,8,58,5,102,97,108,115,101,18,82,10,15,115,110,97,112,115,104,111,116,95,102,111,114,109,97,116,24,37,32,1,40,14,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,110,97,112,115,104,111,116,70,111,114,109,97,116,58,11,66,73,78,65,82,89,80,82,79,84,79,18,66,10,11,115,111,108,118,101,114,95,109,111,100,101,24,17,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,111,108,118,101,114,77,111,100,101,58,3,71,80,85,18,20,10,9,100,101,118,105,99,101,95,105,100,24,18,32,1,40,5,58,1,48,18,23,10,11,114,97,110,100,111,109,95,115,101,101,100,24,20,32,1,40,3,58,2,45,49,18,17,10,4,116,121,112,101,24,40,32,1,40,9,58,3,83,71,68,18,20,10,5,100,101,108,116,97,24,31,32,1,40,2,58,5,49,101,45,48,56,18,24,10,9,109,111,109,101,110,116,117,109,50,24,39,32,1,40,2,58,5,48,46,57,57,57,18,23,10,9,114,109,115,95,100,101,99,97,121,24,38,32,1,40,2,58,4,48,46,57,57,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,23,32,1,40,8,58,5,102,97,108,115,101,18,34,10,20,115,110,97,112,115,104,111,116,95,97,102,116,101,114,95,116,114,97,105,110,24,28,32,1,40,8,58,4,116,114,117,101,18,66,10,11,115,111,108,118,101,114,95,116,121,112,101,24,30,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,111,108,118,101,114,84,121,112,101,58,3,83,71,68,34,43,10,14,83,110,97,112,115,104,111,116,70,111,114,109,97,116,18,8,10,4,72,68,70,53,16,0,18,15,10,11,66,73,78,65,82,89,80,82,79,84,79,16,1,34,30,10,10,83,111,108,118,101,114,77,111,100,101,18,7,10,3,67,80,85,16,0,18,7,10,3,71,80,85,16,1,34,85,10,10,83,111,108,118,101,114,84,121,112,101,18,7,10,3,83,71,68,16,0,18,12,10,8,78,69,83,84,69,82,79,86,16,1,18,11,10,7,65,68,65,71,82,65,68,16,2,18,11,10,7,82,77,83,80,82,79,80,16,3,18,12,10,8,65,68,65,68,69,76,84,65,16,4,18,8,10,4,65,68,65,77,16,5,34,115,10,11,83,111,108,118,101,114,83,116,97,116,101,18,12,10,4,105,116,101,114,24,1,32,1,40,5,18,19,10,11,108,101,97,114,110,101,100,95,110,101,116,24,2,32,1,40,9,18,40,10,7,104,105,115,116,111,114,121,24,3,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,23,10,12,99,117,114,114,101,110,116,95,115,116,101,112,24,4,32,1,40,5,58,1,48,34,85,10,8,78,101,116,83,116,97,116,101,18,40,10,5,112,104,97,115,101,24,1,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,58,4,84,69,83,84,18,16,10,5,108,101,118,101,108,24,2,32,1,40,5,58,1,48,18,13,10,5,115,116,97,103,101,24,3,32,3,40,9,34,122,10,12,78,101,116,83,116,97,116,101,82,117,108,101,18,34,10,5,112,104,97,115,101,24,1,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,18,17,10,9,109,105,110,95,108,101,118,101,108,24,2,32,1,40,5,18,17,10,9,109,97,120,95,108,101,118,101,108,24,3,32,1,40,5,18,13,10,5,115,116,97,103,101,24,4,32,3,40,9,18,17,10,9,110,111,116,95,115,116,97,103,101,24,5,32,3,40,9,34,170,1,10,9,80,97,114,97,109,83,112,101,99,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,56,10,10,115,104,97,114,101,95,109,111,100,101,24,2,32,1,40,14,50,36,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,83,112,101,99,46,68,105,109,67,104,101,99,107,77,111,100,101,18,18,10,7,108,114,95,109,117,108,116,24,3,32,1,40,2,58,1,49,18,21,10,10,100,101,99,97,121,95,109,117,108,116,24,4,32,1,40,2,58,1,49,34,42,10,12,68,105,109,67,104,101,99,107,77,111,100,101,18,10,10,6,83,84,82,73,67,84,16,0,18,14,10,10,80,69,82,77,73,83,83,73,86,69,16,1,34,163,26,10,14,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,14,10,6,98,111,116,116,111,109,24,3,32,3,40,9,18,11,10,3,116,111,112,24,4,32,3,40,9,18,34,10,5,112,104,97,115,101,24,10,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,18,19,10,11,108,111,115,115,95,119,101,105,103,104,116,24,5,32,3,40,2,18,38,10,5,112,97,114,97,109,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,83,112,101,99,18,38,10,5,98,108,111,98,115,24,7,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,22,10,14,112,114,111,112,97,103,97,116,101,95,100,111,119,110,24,11,32,3,40,8,18,43,10,7,105,110,99,108,117,100,101,24,8,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,43,10,7,101,120,99,108,117,100,101,24,9,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,62,10,15,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,24,100,32,1,40,11,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,108,111,115,115,95,112,97,114,97,109,24,101,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,18,55,10,14,97,99,99,117,114,97,99,121,95,112,97,114,97,109,24,102,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,51,10,12,97,114,103,109,97,120,95,112,97,114,97,109,24,103,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,59,10,16,98,97,116,99,104,95,110,111,114,109,95,112,97,114,97,109,24,139,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,18,48,10,10,98,105,97,115,95,112,97,114,97,109,24,141,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,105,97,115,80,97,114,97,109,101,116,101,114,18,51,10,12,99,111,110,99,97,116,95,112,97,114,97,109,24,104,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,70,10,22,99,111,110,116,114,97,115,116,105,118,101,95,108,111,115,115,95,112,97,114,97,109,24,105,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,61,10,17,99,111,110,118,111,108,117,116,105,111,110,95,112,97,114,97,109,24,106,32,1,40,11,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,48,10,10,99,114,111,112,95,112,97,114,97,109,24,144,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,114,111,112,80,97,114,97,109,101,116,101,114,18,47,10,10,100,97,116,97,95,112,97,114,97,109,24,107,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,18,71,10,22,100,101,116,101,99,116,105,111,110,95,111,117,116,112,117,116,95,112,97,114,97,109,24,147,1,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,53,10,13,100,114,111,112,111,117,116,95,112,97,114,97,109,24,108,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,100,117,109,109,121,95,100,97,116,97,95,112,97,114,97,109,24,109,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,101,108,116,119,105,115,101,95,112,97,114,97,109,24,110,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,46,10,9,101,108,117,95,112,97,114,97,109,24,140,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,76,85,80,97,114,97,109,101,116,101,114,18,50,10,11,101,109,98,101,100,95,112,97,114,97,109,24,137,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,109,98,101,100,80,97,114,97,109,101,116,101,114,18,45,10,9,101,120,112,95,112,97,114,97,109,24,111,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,120,112,80,97,114,97,109,101,116,101,114,18,54,10,13,102,108,97,116,116,101,110,95,112,97,114,97,109,24,135,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,18,56,10,15,104,100,102,53,95,100,97,116,97,95,112,97,114,97,109,24,112,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,60,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,113,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,104,105,110,103,101,95,108,111,115,115,95,112,97,114,97,109,24,114,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,58,10,16,105,109,97,103,101,95,100,97,116,97,95,112,97,114,97,109,24,115,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,102,111,103,97,105,110,95,108,111,115,115,95,112,97,114,97,109,24,116,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,110,101,114,95,112,114,111,100,117,99,116,95,112,97,114,97,109,24,117,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,50,10,11,105,110,112,117,116,95,112,97,114,97,109,24,143,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,112,117,116,80,97,114,97,109,101,116,101,114,18,46,10,9,108,111,103,95,112,97,114,97,109,24,134,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,103,80,97,114,97,109,101,116,101,114,18,45,10,9,108,114,110,95,112,97,114,97,109,24,118,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,18,60,10,17,109,101,109,111,114,121,95,100,97,116,97,95,112,97,114,97,109,24,119,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,45,10,9,109,118,110,95,112,97,114,97,109,24,120,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,86,78,80,97,114,97,109,101,116,101,114,18,57,10,10,110,111,114,109,95,112,97,114,97,109,24,149,1,32,1,40,11,50,36,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,18,54,10,13,112,101,114,109,117,116,101,95,112,97,114,97,109,24,148,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,18,58,10,15,112,97,114,97,109,101,116,101,114,95,112,97,114,97,109,24,145,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,18,53,10,13,112,111,111,108,105,110,103,95,112,97,114,97,109,24,121,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,49,10,11,112,111,119,101,114,95,112,97,114,97,109,24,122,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,112,114,101,108,117,95,112,97,114,97,109,24,131,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,82,101,76,85,80,97,114,97,109,101,116,101,114,18,57,10,15,112,114,105,111,114,95,98,111,120,95,112,97,114,97,109,24,150,1,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,18,56,10,14,112,114,111,112,111,115,97,108,95,112,97,114,97,109,24,201,1,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,18,65,10,19,112,115,114,111,105,95,112,111,111,108,105,110,103,95,112,97,114,97,109,24,146,78,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,52,10,12,112,121,116,104,111,110,95,112,97,114,97,109,24,130,1,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,18,58,10,15,114,101,99,117,114,114,101,110,116,95,112,97,114,97,109,24,146,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,18,58,10,15,114,101,100,117,99,116,105,111,110,95,112,97,114,97,109,24,136,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,114,101,108,117,95,112,97,114,97,109,24,123,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,18,54,10,13,114,101,115,104,97,112,101,95,112,97,114,97,109,24,133,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,18,63,10,17,114,111,105,95,112,111,111,108,105,110,103,95,112,97,114,97,109,24,215,199,248,3,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,50,10,11,115,99,97,108,101,95,112,97,114,97,109,24,142,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,99,97,108,101,80,97,114,97,109,101,116,101,114,18,53,10,13,115,105,103,109,111,105,100,95,112,97,114,97,109,24,124,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,53,10,13,115,111,102,116,109,97,120,95,112,97,114,97,109,24,125,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,46,10,9,115,112,112,95,112,97,114,97,109,24,132,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,18,49,10,11,115,108,105,99,101,95,112,97,114,97,109,24,126,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,47,10,10,116,97,110,104,95,112,97,114,97,109,24,127,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,18,58,10,15,116,104,114,101,115,104,111,108,100,95,112,97,114,97,109,24,128,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,48,10,10,116,105,108,101,95,112,97,114,97,109,24,138,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,105,108,101,80,97,114,97,109,101,116,101,114,18,61,10,17,119,105,110,100,111,119,95,100,97,116,97,95,112,97,114,97,109,24,129,1,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,34,182,1,10,23,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,16,10,5,115,99,97,108,101,24,1,32,1,40,2,58,1,49,18,21,10,6,109,105,114,114,111,114,24,2,32,1,40,8,58,5,102,97,108,115,101,18,20,10,9,99,114,111,112,95,115,105,122,101,24,3,32,1,40,13,58,1,48,18,17,10,9,109,101,97,110,95,102,105,108,101,24,4,32,1,40,9,18,18,10,10,109,101,97,110,95,118,97,108,117,101,24,5,32,3,40,2,18,26,10,11,102,111,114,99,101,95,99,111,108,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,102,111,114,99,101,95,103,114,97,121,24,7,32,1,40,8,58,5,102,97,108,115,101,34,201,1,10,13,76,111,115,115,80,97,114,97,109,101,116,101,114,18,20,10,12,105,103,110,111,114,101,95,108,97,98,101,108,24,1,32,1,40,5,18,75,10,13,110,111,114,109,97,108,105,122,97,116,105,111,110,24,3,32,1,40,14,50,45,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,46,78,111,114,109,97,108,105,122,97,116,105,111,110,77,111,100,101,58,5,86,65,76,73,68,18,17,10,9,110,111,114,109,97,108,105,122,101,24,2,32,1,40,8,34,66,10,17,78,111,114,109,97,108,105,122,97,116,105,111,110,77,111,100,101,18,8,10,4,70,85,76,76,16,0,18,9,10,5,86,65,76,73,68,16,1,18,14,10,10,66,65,84,67,72,95,83,73,90,69,16,2,18,8,10,4,78,79,78,69,16,3,34,76,10,17,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,16,10,5,116,111,112,95,107,24,1,32,1,40,13,58,1,49,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,18,20,10,12,105,103,110,111,114,101,95,108,97,98,101,108,24,3,32,1,40,5,34,77,10,15,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,26,10,11,111,117,116,95,109,97,120,95,118,97,108,24,1,32,1,40,8,58,5,102,97,108,115,101,18,16,10,5,116,111,112,95,107,24,2,32,1,40,13,58,1,49,18,12,10,4,97,120,105,115,24,3,32,1,40,5,34,57,10,15,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,18,21,10,10,99,111,110,99,97,116,95,100,105,109,24,1,32,1,40,13,58,1,49,34,133,1,10,18,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,18,24,10,16,117,115,101,95,103,108,111,98,97,108,95,115,116,97,116,115,24,1,32,1,40,8,18,38,10,23,109,111,118,105,110,103,95,97,118,101,114,97,103,101,95,102,114,97,99,116,105,111,110,24,2,32,1,40,2,58,5,48,46,57,57,57,18,18,10,3,101,112,115,24,3,32,1,40,2,58,5,49,101,45,48,53,18,25,10,10,115,99,97,108,101,95,98,105,97,115,24,7,32,1,40,8,58,5,102,97,108,115,101,34,100,10,13,66,105,97,115,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,19,10,8,110,117,109,95,97,120,101,115,24,2,32,1,40,5,58,1,49,18,45,10,6,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,76,10,24,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,17,10,6,109,97,114,103,105,110,24,1,32,1,40,2,58,1,49,18,29,10,14,108,101,103,97,99,121,95,118,101,114,115,105,111,110,24,2,32,1,40,8,58,5,102,97,108,115,101,34,145,4,10,20,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,2,32,1,40,8,58,4,116,114,117,101,18,11,10,3,112,97,100,24,3,32,3,40,13,18,19,10,11,107,101,114,110,101,108,95,115,105,122,101,24,4,32,3,40,13,18,14,10,6,115,116,114,105,100,101,24,6,32,3,40,13,18,16,10,8,100,105,108,97,116,105,111,110,24,18,32,3,40,13,18,16,10,5,112,97,100,95,104,24,9,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,119,24,10,32,1,40,13,58,1,48,18,16,10,8,107,101,114,110,101,108,95,104,24,11,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,119,24,12,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,104,24,13,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,119,24,14,32,1,40,13,18,16,10,5,103,114,111,117,112,24,5,32,1,40,13,58,1,49,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,7,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+399360);allocate([108,101,114,24,8,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,66,10,6,101,110,103,105,110,101,24,15,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,15,10,4,97,120,105,115,24,16,32,1,40,5,58,1,49,18,30,10,15,102,111,114,99,101,95,110,100,95,105,109,50,99,111,108,24,17,32,1,40,8,58,5,102,97,108,115,101,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,48,10,13,67,114,111,112,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,50,18,14,10,6,111,102,102,115,101,116,24,2,32,3,40,13,34,171,2,10,13,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,18,20,10,9,114,97,110,100,95,115,107,105,112,24,7,32,1,40,13,58,1,48,18,56,10,7,98,97,99,107,101,110,100,24,8,32,1,40,14,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,46,68,66,58,7,76,69,86,69,76,68,66,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,34,10,19,102,111,114,99,101,95,101,110,99,111,100,101,100,95,99,111,108,111,114,24,9,32,1,40,8,58,5,102,97,108,115,101,18,19,10,8,112,114,101,102,101,116,99,104,24,10,32,1,40,13,58,1,52,34,27,10,2,68,66,18,11,10,7,76,69,86,69,76,68,66,16,0,18,8,10,4,76,77,68,66,16,1,34,91,10,30,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,18,26,10,13,110,109,115,95,116,104,114,101,115,104,111,108,100,24,1,32,1,40,2,58,3,48,46,51,18,13,10,5,116,111,112,95,107,24,2,32,1,40,5,18,14,10,3,101,116,97,24,3,32,1,40,2,58,1,49,34,170,1,10,19,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,24,10,16,111,117,116,112,117,116,95,100,105,114,101,99,116,111,114,121,24,1,32,1,40,9,18,26,10,18,111,117,116,112,117,116,95,110,97,109,101,95,112,114,101,102,105,120,24,2,32,1,40,9,18,21,10,13,111,117,116,112,117,116,95,102,111,114,109,97,116,24,3,32,1,40,9,18,22,10,14,108,97,98,101,108,95,109,97,112,95,102,105,108,101,24,4,32,1,40,9,18,22,10,14,110,97,109,101,95,115,105,122,101,95,102,105,108,101,24,5,32,1,40,9,18,22,10,14,110,117,109,95,116,101,115,116,95,105,109,97,103,101,24,6,32,1,40,13,34,73,10,16,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,26,10,13,100,114,111,112,111,117,116,95,114,97,116,105,111,24,1,32,1,40,2,58,3,48,46,53,18,25,10,11,115,99,97,108,101,95,116,114,97,105,110,24,2,32,1,40,8,58,4,116,114,117,101,34,174,1,10,18,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,50,10,11,100,97,116,97,95,102,105,108,108,101,114,24,1,32,3,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,11,10,3,110,117,109,24,2,32,3,40,13,18,16,10,8,99,104,97,110,110,101,108,115,24,3,32,3,40,13,18,14,10,6,104,101,105,103,104,116,24,4,32,3,40,13,18,13,10,5,119,105,100,116,104,24,5,32,3,40,13,34,172,1,10,16,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,64,10,9,111,112,101,114,97,116,105,111,110,24,1,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,46,69,108,116,119,105,115,101,79,112,58,3,83,85,77,18,13,10,5,99,111,101,102,102,24,2,32,3,40,2,18,30,10,16,115,116,97,98,108,101,95,112,114,111,100,95,103,114,97,100,24,3,32,1,40,8,58,4,116,114,117,101,34,39,10,9,69,108,116,119,105,115,101,79,112,18,8,10,4,80,82,79,68,16,0,18,7,10,3,83,85,77,16,1,18,7,10,3,77,65,88,16,2,34,32,10,12,69,76,85,80,97,114,97,109,101,116,101,114,18,16,10,5,97,108,112,104,97,24,1,32,1,40,2,58,1,49,34,186,1,10,14,69,109,98,101,100,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,17,10,9,105,110,112,117,116,95,100,105,109,24,2,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,3,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,4,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,68,10,12,69,120,112,80,97,114,97,109,101,116,101,114,18,16,10,4,98,97,115,101,24,1,32,1,40,2,58,2,45,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,57,10,16,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,20,10,8,101,110,100,95,97,120,105,115,24,2,32,1,40,5,58,2,45,49,34,79,10,17,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,2,32,1,40,13,18,22,10,7,115,104,117,102,102,108,101,24,3,32,1,40,8,58,5,102,97,108,115,101,34,40,10,19,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,17,10,9,102,105,108,101,95,110,97,109,101,24,1,32,1,40,9,34,101,10,18,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,55,10,4,110,111,114,109,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,46,78,111,114,109,58,2,76,49,34,22,10,4,78,111,114,109,18,6,10,2,76,49,16,1,18,6,10,2,76,50,16,2,34,151,2,10,18,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,21,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,58,1,49,18,20,10,9,114,97,110,100,95,115,107,105,112,24,7,32,1,40,13,58,1,48,18,22,10,7,115,104,117,102,102,108,101,24,8,32,1,40,8,58,5,102,97,108,115,101,18,21,10,10,110,101,119,95,104,101,105,103,104,116,24,9,32,1,40,13,58,1,48,18,20,10,9,110,101,119,95,119,105,100,116,104,24,10,32,1,40,13,58,1,48,18,22,10,8,105,115,95,99,111,108,111,114,24,11,32,1,40,8,58,4,116,114,117,101,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,21,10,11,114,111,111,116,95,102,111,108,100,101,114,24,12,32,1,40,9,58,0,34,39,10,21,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,34,217,1,10,21,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,2,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,4,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,5,32,1,40,5,58,1,49,18,24,10,9,116,114,97,110,115,112,111,115,101,24,6,32,1,40,8,58,5,102,97,108,115,101,34,56,10,14,73,110,112,117,116,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,34,68,10,12,76,111,103,80,97,114,97,109,101,116,101,114,18,16,10,4,98,97,115,101,24,1,32,1,40,2,58,2,45,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,198,2,10,12,76,82,78,80,97,114,97,109,101,116,101,114,18,21,10,10,108,111,99,97,108,95,115,105,122,101,24,1,32,1,40,13,58,1,53,18,16,10,5,97,108,112,104,97,24,2,32,1,40,2,58,1,49,18,18,10,4,98,101,116,97,24,3,32,1,40,2,58,4,48,46,55,53,18,75,10,11,110,111,114,109,95,114,101,103,105,111,110,24,4,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,46,78,111,114,109,82,101,103,105,111,110,58,15,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,18,12,10,1,107,24,5,32,1,40,2,58,1,49,18,58,10,6,101,110,103,105,110,101,24,6,32,1,40,14,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,53,10,10,78,111,114,109,82,101,103,105,111,110,18,19,10,15,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,16,0,18,18,10,14,87,73,84,72,73,78,95,67,72,65,78,78,69,76,16,1,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,90,10,19,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,1,32,1,40,13,18,16,10,8,99,104,97,110,110,101,108,115,24,2,32,1,40,13,18,14,10,6,104,101,105,103,104,116,24,3,32,1,40,13,18,13,10,5,119,105,100,116,104,24,4,32,1,40,13,34,100,10,12,77,86,78,80,97,114,97,109,101,116,101,114,18,32,10,18,110,111,114,109,97,108,105,122,101,95,118,97,114,105,97,110,99,101,24,1,32,1,40,8,58,4,116,114,117,101,18,30,10,15,97,99,114,111,115,115,95,99,104,97,110,110,101,108,115,24,2,32,1,40,8,58,5,102,97,108,115,101,18,18,10,3,101,112,115,24,3,32,1,40,2,58,5,49,101,45,48,57,34,60,10,18,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,34,201,3,10,16,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,60,10,4,112,111,111,108,24,1,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,14,10,3,112,97,100,24,4,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,104,24,9,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,119,24,10,32,1,40,13,58,1,48,18,19,10,11,107,101,114,110,101,108,95,115,105,122,101,24,2,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,104,24,5,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,119,24,6,32,1,40,13,18,17,10,6,115,116,114,105,100,101,24,3,32,1,40,13,58,1,49,18,16,10,8,115,116,114,105,100,101,95,104,24,7,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,119,24,8,32,1,40,13,18,62,10,6,101,110,103,105,110,101,24,11,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,29,10,14,103,108,111,98,97,108,95,112,111,111,108,105,110,103,24,12,32,1,40,8,58,5,102,97,108,115,101,18,23,10,9,99,101,105,108,95,109,111,100,101,24,13,32,1,40,8,58,4,116,114,117,101,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,70,10,14,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,16,10,5,112,111,119,101,114,24,1,32,1,40,2,58,1,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,103,10,15,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,18,14,10,6,109,111,100,117,108,101,24,1,32,1,40,9,18,13,10,5,108,97,121,101,114,24,2,32,1,40,9,18,19,10,9,112,97,114,97,109,95,115,116,114,24,3,32,1,40,9,58,0,18,32,10,17,115,104,97,114,101,95,105,110,95,112,97,114,97,108,108,101,108,24,4,32,1,40,8,58,5,102,97,108,115,101,34,206,1,10,18,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,18,21,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,58,1,48,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,2,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,4,32,1,40,8,58,5,102,97,108,115,101,18,28,10,13,101,120,112,111,115,101,95,104,105,100,100,101,110,24,5,32,1,40,8,58,5,102,97,108,115,101,34,180,1,10,18,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,18,68,10,9,111,112,101,114,97,116,105,111,110,24,1,32,1,40,14,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,46,82,101,100,117,99,116,105,111,110,79,112,58,3,83,85,77,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,48,18,16,10,5,99,111,101,102,102,24,3,32,1,40,2,58,1,49,34,53,10,11,82,101,100,117,99,116,105,111,110,79,112,18,7,10,3,83,85,77,16,1,18,8,10,4,65,83,85,77,16,2,18,9,10,5,83,85,77,83,81,16,3,18,8,10,4,77,69,65,78,16,4,34,148,1,10,13,82,101,76,85,80,97,114,97,109,101,116,101,114,18,25,10,14,110,101,103,97,116,105,118,101,95,115,108,111,112,101,24,1,32,1,40,2,58,1,48,18,59,10,6,101,110,103,105,110,101,24,2,32,1,40,14,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,97,10,16,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,48,18,20,10,8,110,117,109,95,97,120,101,115,24,3,32,1,40,5,58,2,45,49,34,179,1,10,14,83,99,97,108,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,19,10,8,110,117,109,95,97,120,101,115,24,2,32,1,40,5,58,1,49,18,45,10,6,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,24,10,9,98,105,97,115,95,116,101,114,109,24,4,32,1,40,8,58,5,102,97,108,115,101,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,127,10,16,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,62,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,76,10,14,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,3,32,1,40,5,58,1,49,18,19,10,11,115,108,105,99,101,95,112,111,105,110,116,24,2,32,3,40,13,18,20,10,9,115,108,105,99,101,95,100,105,109,24,1,32,1,40,13,58,1,49,34,144,1,10,16,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,62,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,121,10,13,84,97,110,72,80,97,114,97,109,101,116,101,114,18,59,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,47,10,13,84,105,108,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,13,10,5,116,105,108,101,115,24,2,32,1,40,5,34,42,10,18,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,20,10,9,116,104,114,101,115,104,111,108,100,24,1,32,1,40,2,58,1,48,34,193,2,10,19,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,25,10,12,102,103,95,116,104,114,101,115,104,111,108,100,24,7,32,1,40,2,58,3,48,46,53,18,25,10,12,98,103,95,116,104,114,101,115,104,111,108,100,24,8,32,1,40,2,58,3,48,46,53,18,25,10,11,102,103,95,102,114,97,99,116,105,111,110,24,9,32,1,40,2,58,4,48,46,50,53,18,22,10,11,99,111,110,116,101,120,116,95,112,97,100,24,10,32,1,40,13,58,1,48,18,23,10,9,99,114,111,112,95,109,111,100,101,24,11,32,1,40,9,58,4,119,97,114,112,18,27,10,12,99,97,99,104,101,95,105,109,97,103,101,115,24,12,32,1,40,8,58,5,102,97,108,115,101,18,21,10,11,114,111,111,116,95,102,111,108,100,101,114,24,13,32,1,40,9,58,0,34,249,1,10,12,83,80,80,80,97,114,97,109,101,116,101,114,18,22,10,14,112,121,114,97,109,105,100,95,104,101,105,103,104,116,24,1,32,1,40,13,18,56,10,4,112,111,111,108,24,2,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,58,10,6,101,110,103,105,110,101,24,6,32,1,40,14,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,220,21,10,16,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,14,10,6,98,111,116,116,111,109,24,2,32,3,40,9,18,11,10,3,116,111,112,24,3,32,3,40,9,18,12,10,4,110,97,109,101,24,4,32,1,40,9,18,43,10,7,105,110,99,108,117,100,101,24,32,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,43,10,7,101,120,99,108,117,100,101,24,33,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,54,10,4,116,121,112,101,24,5,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,76,97,121,101,114,84,121,112,101,18,38,10,5,98,108,111,98,115,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,14,10,5,112,97,114,97,109,24,233,7,32,3,40,9,18,69,10,15,98,108,111,98,95,115,104,97,114,101,95,109,111,100,101,24,234,7,32,3,40,14,50,43,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,68,105,109,67,104,101,99,107,77,111,100,101,18,16,10,8,98,108,111,98,115,95,108,114,24,7,32,3,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,8,32,3,40,2,18,19,10,11,108,111,115,115,95,119,101,105,103,104,116,24,35,32,3,40,2,18,55,10,14,97,99,99,117,114,97,99,121,95,112,97,114,97,109,24,27,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,51,10,12,97,114,103,109,97,120,95,112,97,114,97,109,24,23,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,51,10,12,99,111,110,99,97,116,95,112,97,114,97,109,24,9,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,70,10,22,99,111,110,116,114,97,115,116,105,118,101,95,108,111,115,115,95,112,97,114,97,109,24,40,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,61,10,17,99,111,110,118,111,108,117,116,105,111,110,95,112,97,114,97,109,24,10,32,1,40,11,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,100,97,116,97,95,112,97,114,97,109,24,11,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,100,114,111,112,111,117,116,95,112,97,114,97,109,24,12,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,100,117,109,109,121,95,100,97,116,97,95,112,97,114,97,109,24,26,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,101,108,116,119,105,115,101,95,112,97,114,97,109,24,24,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,45,10,9,101,120,112,95,112,97,114,97,109,24,41,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,120,112,80,97,114,97,109,101,116,101,114,18,56,10,15,104,100,102,53,95,100,97,116,97,95,112,97,114,97,109,24,13,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,60,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,14,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,104,105,110,103,101,95,108,111,115,115,95,112,97,114,97,109,24,29,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,58,10,16,105,109,97,103,101,95,100,97,116,97,95,112,97,114,97,109,24,15,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,102,111,103,97,105,110,95,108,111,115,115,95,112,97,114,97,109,24,16,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,110,101,114,95,112,114,111,100,117,99,116,95,112,97,114,97,109,24,17,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,45,10,9,108,114,110,95,112,97,114,97,109,24,18,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,18,60,10,17,109,101,109,111,114,121,95,100,97,116,97,95,112,97,114,97,109,24,22,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,45,10,9,109,118,110,95,112,97,114,97,109,24,34,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,86,78,80,97,114,97,109,101,116,101,114,18,53,10,13,112,111,111,108,105,110,103,95,112,97,114,97,109,24,19,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,49,10,11,112,111,119,101,114,95,112,97,114,97,109,24,21,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,47,10,10,114,101,108,117,95,112,97,114,97,109,24,30,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,18,53,10,13,115,105,103,109,111,105,100,95,112,97,114,97,109,24,38,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,53,10,13,115,111,102,116,109,97,120,95,112,97,114,97,109,24,39,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,49,10,11,115,108,105,99,101,95,112,97,114,97,109,24,31,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,47,10,10,116,97,110,104,95,112,97,114,97,109,24,37,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,18,57,10,15,116,104,114,101,115,104,111,108,100,95,112,97,114,97,109,24,25,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,60,10,17,119,105,110,100,111,119,95,100,97,116,97,95,112,97,114,97,109,24,20,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,18,62,10,15,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,24,36,32,1,40,11,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,108,111,115,115,95,112,97,114,97,109,24,42,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,18,45,10,5,108,97,121,101,114,24,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,34,216,4,10,9,76,97,121,101,114,84,121,112,101,18,8,10,4,78,79,78,69,16,0,18,10,10,6,65,66,83,86,65,76,16,35,18,12,10,8,65,67,67,85,82,65,67,89,16,1,18,10,10,6,65,82,71,77,65,88,16,30,18,8,10,4,66,78,76,76,16,2,18,10,10,6,67,79,78,67,65,84,16,3,18,20,10,16,67,79,78,84,82,65,83,84,73,86,69,95,76,79,83,83,16,37,18,15,10,11,67,79,78,86,79,76,85,84,73,79,78,16,4,18,8,10,4,68,65,84,65,16,5,18,17,10,13,68,69,67,79,78,86,79,76,85,84,73,79,78,16,39,18,11,10,7,68,82,79,80,79,85,84,16,6,18,14,10,10,68,85,77,77,89,95,68,65,84,65,16,32,18,18,10,14,69,85,67,76,73,68,69,65,78,95,76,79,83,83,16,7,18,11,10,7,69,76,84,87,73,83,69,16,25,18,7,10,3,69,88,80,16,38,18,11,10,7,70,76,65,84,84,69,78,16,8,18,13,10,9,72,68,70,53,95,68,65,84,65,16,9,18,15,10,11,72,68,70,53,95,79,85,84,80,85,84,16,10,18,14,10,10,72,73,78,71,69,95,76,79,83,83,16,28,18,10,10,6,73,77,50,67,79,76,16,11,18,14,10,10,73,77,65,71,69,95,68,65,84,65,16,12,18,17,10,13,73,78,70,79,71,65,73,78,95,76,79,83,83,16,13,18,17,10,13,73,78,78,69,82,95,80,82,79,68,85,67,84,16,14,18,7,10,3,76,82,78,16,15,18,15,10,11,77,69,77,79,82,89,95,68,65,84,65,16,29,18,29,10,25,77,85,76,84,73,78,79,77,73,65,76,95,76,79,71,73,83,84,73,67,95,76,79,83,83,16,16,18,7,10,3,77,86,78,16,34,18,11,10,7,80,79,79,76,73,78,71,16,17,18,9,10,5,80,79,87,69,82,16,26,18,8,10,4,82,69,76,85,16,18,18,11,10,7,83,73,71,77,79,73,68,16,19,18,30,10,26,83,73,71,77,79,73,68,95,67,82,79,83,83,95,69,78,84,82,79,80,89,95,76,79,83,83,16,27,18,11,10,7,83,73,76,69,78,67,69,16,36,18,11,10,7,83,79,70,84,77,65,88,16,20,18,16,10,12,83,79,70,84,77,65,88,95,76,79,83,83,16,21,18,9,10,5,83,80,76,73,84,16,22,18,9,10,5,83,76,73,67,69,16,33,18,8,10,4,84,65,78,72,16,23,18,15,10,11,87,73,78,68,79,87,95,68,65,84,65,16,24,18,13,10,9,84,72,82,69,83,72,79,76,68,16,31,34,42,10,12,68,105,109,67,104,101,99,107,77,111,100,101,18,10,10,6,83,84,82,73,67,84,16,0,18,14,10,10,80,69,82,77,73,83,83,73,86,69,16,1,34,160,8,10,16,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,3,32,1,40,13,18,22,10,8,98,105,97,115,116,101,114,109,24,4,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,6,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,14,10,3,112,97,100,24,7,32,1,40,13,58,1,48,18,18,10,10,107,101,114,110,101,108,115,105,122,101,24,8,32,1,40,13,18,16,10,5,103,114,111,117,112,24,9,32,1,40,13,58,1,49,18,17,10,6,115,116,114,105,100,101,24,10,32,1,40,13,58,1,49,18,60,10,4,112,111,111,108,24,11,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,26,10,13,100,114,111,112,111,117,116,95,114,97,116,105,111,24,12,32,1,40,2,58,3,48,46,53,18,21,10,10,108,111,99,97,108,95,115,105,122,101,24,13,32,1,40,13,58,1,53,18,16,10,5,97,108,112,104,97,24,14,32,1,40,2,58,1,49,18,18,10,4,98,101,116,97,24,15,32,1,40,2,58,4,48,46,55,53,18,12,10,1,107,24,22,32,1,40,2,58,1,49,18,14,10,6,115,111,117,114,99,101,24,16,32,1,40,9,18,16,10,5,115,99,97,108,101,24,17,32,1,40,2,58,1,49,18,16,10,8,109,101,97,110,102,105,108,101,24,18,32,1,40,9,18,17,10,9,98,97,116,99,104,115,105,122,101,24,19,32,1,40,13,18,19,10,8,99,114,111,112,115,105,122,101,24,20,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,21,32,1,40,8,58,5,102,97,108,115,101,18,38,10,5,98,108,111,98,115,24,50,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,16,10,8,98,108,111,98,115,95,108,114,24,51,32,3,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,52,32,3,40,2,18,20,10,9,114,97,110,100,95,115,107,105,112,24,53,32,1,40,13,58,1,48,18,29,10,16,100,101,116,95,102,103,95,116,104,114,101,115,104,111,108,100,24,54,32,1,40,2,58,3,48,46,53,18,29,10,16,100,101,116,95,98,103,95,116,104,114,101,115,104,111,108,100,24,55,32,1,40,2,58,3,48,46,53,18,29,10,15,100,101,116,95,102,103,95,102,114,97,99,116,105,111,110,24,56,32,1,40,2,58,4,48,46,50,53,18,26,10,15,100,101,116,95,99,111,110,116,101,120,116,95,112,97,100,24,58,32,1,40,13,58,1,48,18,27,10,13,100,101,116,95,99,114,111,112,95,109,111,100,101,24,59,32,1,40,9,58,4,119,97,114,112,18,18,10,7,110,101,119,95,110,117,109,24,60,32,1,40,5,58,1,48,18,23,10,12,110,101,119,95,99,104,97,110,110,101,108,115,24,61,32,1,40,5,58,1,48,18,21,10,10,110,101,119,95,104,101,105,103,104,116,24,62,32,1,40,5,58,1,48,18,20,10,9,110,101,119,95,119,105,100,116,104,24,63,32,1,40,5,58,1,48,18,29,10,14,115,104,117,102,102,108,101,95,105,109,97,103,101,115,24,64,32,1,40,8,58,5,102,97,108,115,101,18,21,10,10,99,111,110,99,97,116,95,100,105,109,24,65,32,1,40,13,58,1,49,18,61,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,233,7,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,94,10,14,80,82,101,76,85,80,97,114,97,109,101,116,101,114,18,45,10,6,102,105,108,108,101,114,24,1,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,29,10,14,99,104,97,110,110,101,108,95,115,104,97,114,101,100,24,2,32,1,40,8,58,5,102,97,108,115,101,34,135,1,10,14,78,111,114,109,97,108,105,122,101,100,66,66,111,120,18,12,10,4,120,109,105,110,24,1,32,1,40,2,18,12,10,4,121,109,105,110,24,2,32,1,40,2,18,12,10,4,120,109,97,120,24,3,32,1,40,2,18,12,10,4,121,109,97,120,24,4,32,1,40,2,18,13,10,5,108,97,98,101,108,24,5,32,1,40,5,18,17,10,9,100,105,102,102,105,99,117,108,116,24,6,32,1,40,8,18,13,10,5,115,99,111,114,101,24,7,32,1,40,2,18,12,10,4,115,105,122,101,24,8,32,1,40,2,34,89,10,19,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,19,10,8,112,111,111,108,101,100,95,104,24,1,32,1,40,13,58,1,48,18,19,10,8,112,111,111,108,101,100,95,119,24,2,32,1,40,13,58,1,48,18,24,10,13,115,112,97,116,105,97,108,95,115,99,97,108,101,24,3,32,1,40,2,58,1,49,34,200,1,10,17,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,18,23,10,11,102,101,97,116,95,115,116,114,105,100,101,24,1,32,1,40,13,58,2,49,54,18,21,10,9,98,97,115,101,95,115,105,122,101,24,2,32,1,40,13,58,2,49,54,18,20,10,8,109,105,110,95,115,105,122,101,24,3,32,1,40,13,58,2,49,54,18,13,10,5,114,97,116,105,111,24,4,32,3,40,2,18,13,10,5,115,99,97,108,101,24,5,32,3,40,2,18,26,10,12,112,114,101,95,110,109,115,95,116,111,112,110,24,6,32,1,40,13,58,4,54,48,48,48,18,26,10,13,112,111,115,116,95,110,109,115,95,116,111,112,110,24,7,32,1,40,13,58,3,51,48,48,18,23,10,10,110,109,115,95,116,104,114,101,115,104,24,8,32,1,40,2,58,3,48,46,55,34,86,10,21,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,21,10,13,115,112,97,116,105,97,108,95,115,99,97,108,101,24,1,32,2,40,2,18,18,10,10,111,117,116,112,117,116,95,100,105,109,24,2,32,2,40,5,18,18,10,10,103,114,111,117,112,95,115,105,122,101,24,3,32,2,40,5,42,61,10,4,84,121,112,101,18,10,10,6,68,79,85,66,76,69,16,0,18,9,10,5,70,76,79,65,84,16,1,18,11,10,7,70,76,79,65,84,49,54,16,2,18,7,10,3,73,78,84,16,3,18,8,10,4,85,73,78,84,16,4,42,28,10,5,80,104,97,115,101,18,9,10,5,84,82,65,73,78,16,0,18,8,10,4,84,69,83,84,16,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+409600);allocate([47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,99,97,102,102,101,47,111,112,101,110,99,118,45,99,97,102,102,101,46,112,98,46,99,99,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,78,111,114,109,97,108,105,122,101,100,66,66,111,120,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,80,82,101,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,66,108,111,98,80,114,111,116,111,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,69,120,112,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,52,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,84,97,110,72,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,51,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,77,86,78,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,83,108,105,99,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,82,101,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,80,111,119,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,76,82,78,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,48,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,78,101,116,83,116,97,116,101,82,117,108,101,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,83,80,80,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,84,105,108,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,83,99,97,108,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,76,111,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,73,110,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,69,109,98,101,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,69,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,51,48,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,67,114,111,112,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,66,105,97,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,80,97,114,97,109,83,112,101,99,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,56,78,101,116,83,116,97,116,101,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,49,83,111,108,118,101,114,83,116,97,116,101,69,0,83,71,68,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,78,101,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,53,68,97,116,117,109,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,66,108,111,98,80,114,111,116,111,86,101,99,116,111,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,66,108,111,98,83,104,97,112,101,69,0,111,112,101,110,99,118,45,111,110,110,120,46,112,114,111,116,111,0,10,17,111,112,101,110,99,118,45,111,110,110,120,46,112,114,111,116,111,18,11,111,112,101,110,99,118,95,111,110,110,120,34,131,4,10,14,65,116,116,114,105,98,117,116,101,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,21,10,13,114,101,102,95,97,116,116,114,95,110,97,109,101,24,21,32,1,40,9,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,13,32,1,40,9,18,55,10,4,116,121,112,101,24,20,32,1,40,14,50,41,46,111,112,101,110,99,118,95,111,110,110,120,46,65,116,116,114,105,98,117,116,101,80,114,111,116,111,46,65,116,116,114,105,98,117,116,101,84,121,112,101,18,9,10,1,102,24,2,32,1,40,2,18,9,10,1,105,24,3,32,1,40,3,18,9,10,1,115,24,4,32,1,40,12,18,35,10,1,116,24,5,32,1,40,11,50,24,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,18,34,10,1,103,24,6,32,1,40,11,50,23,46,111,112,101,110,99,118,95,111,110,110,120,46,71,114,97,112,104,80,114,111,116,111,18,14,10,6,102,108,111,97,116,115,24,7,32,3,40,2,18,12,10,4,105,110,116,115,24,8,32,3,40,3,18,15,10,7,115,116,114,105,110,103,115,24,9,32,3,40,12,18,41,10,7,116,101,110,115,111,114,115,24,10,32,3,40,11,50,24,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,18,39,10,6,103,114,97,112,104,115,24,11,32,3,40,11,50,23,46,111,112,101,110,99,118,95,111,110,110,120,46,71,114,97,112,104,80,114,111,116,111,34,145,1,10,13,65,116,116,114,105,98,117,116,101,84,121,112,101,18,13,10,9,85,78,68,69,70,73,78,69,68,16,0,18,9,10,5,70,76,79,65,84,16,1,18,7,10,3,73,78,84,16,2,18,10,10,6,83,84,82,73,78,71,16,3,18,10,10,6,84,69,78,83,79,82,16,4,18,9,10,5,71,82,65,80,72,16,5,18,10,10,6,70,76,79,65,84,83,16,6,18,8,10,4,73,78,84,83,16,7,18,11,10,7,83,84,82,73,78,71,83,16,8,18,11,10,7,84,69,78,83,79,82,83,16,9,18,10,10,6,71,82,65,80,72,83,16,10,34,88,10,14,86,97,108,117,101,73,110,102,111,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,36,10,4,116,121,112,101,24,2,32,1,40,11,50,22,46,111,112,101,110,99,118,95,111,110,110,120,46,84,121,112,101,80,114,111,116,111,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,3,32,1,40,9,34,157,1,10,9,78,111,100,101,80,114,111,116,111,18,13,10,5,105,110,112,117,116,24,1,32,3,40,9,18,14,10,6,111,117,116,112,117,116,24,2,32,3,40,9,18,12,10,4,110,97,109,101,24,3,32,1,40,9,18,15,10,7,111,112,95,116,121,112,101,24,4,32,1,40,9,18,14,10,6,100,111,109,97,105,110,24,7,32,1,40,9,18,46,10,9,97,116,116,114,105,98,117,116,101,24,5,32,3,40,11,50,27,46,111,112,101,110,99,118,95,111,110,110,120,46,65,116,116,114,105,98,117,116,101,80,114,111,116,111,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,6,32,1,40,9,34,168,2,10,10,77,111,100,101,108,80,114,111,116,111,18,18,10,10,105,114,95,118,101,114,115,105,111,110,24,1,32,1,40,3,18,53,10,12,111,112,115,101,116,95,105,109,112,111,114,116,24,8,32,3,40,11,50,31,46,111,112,101,110,99,118,95,111,110,110,120,46,79,112,101,114,97,116,111,114,83,101,116,73,100,80,114,111,116,111,18,21,10,13,112,114,111,100,117,99,101,114,95,110,97,109,101,24,2,32,1,40,9,18,24,10,16,112,114,111,100,117,99,101,114,95,118,101,114,115,105,111,110,24,3,32,1,40,9,18,14,10,6,100,111,109,97,105,110,24,4,32,1,40,9,18,21,10,13,109,111,100,101,108,95,118,101,114,115,105,111,110,24,5,32,1,40,3,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,6,32,1,40,9,18,38,10,5,103,114,97,112,104,24,7,32,1,40,11,50,23,46,111,112,101,110,99,118,95,111,110,110,120,46,71,114,97,112,104,80,114,111,116,111,18,59,10,14,109,101,116,97,100,97,116,97,95,112,114,111,112,115,24,14,32,3,40,11,50,35,46,111,112,101,110,99,118,95,111,110,110,120,46,83,116,114,105,110,103,83,116,114,105,110,103,69,110,116,114,121,80,114,111,116,111,34,52,10,22,83,116,114,105,110,103,83,116,114,105,110,103,69,110,116,114,121,80,114,111,116,111,18,11,10,3,107,101,121,24,1,32,1,40,9,18,13,10,5,118,97,108,117,101,24,2,32,1,40,9,34,141,2,10,10,71,114,97,112,104,80,114,111,116,111,18,36,10,4,110,111,100,101,24,1,32,3,40,11,50,22,46,111,112,101,110,99,118,95,111,110,110,120,46,78,111,100,101,80,114,111,116,111,18,12,10,4,110,97,109,101,24,2,32,1,40,9,18,45,10,11,105,110,105,116,105,97,108,105,122,101,114,24,5,32,3,40,11,50,24,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,10,32,1,40,9,18,42,10,5,105,110,112,117,116,24,11,32,3,40,11,50,27,46,111,112,101,110,99,118,95,111,110,110,120,46,86,97,108,117,101,73,110,102,111,80,114,111,116,111,18,43,10,6,111,117,116,112,117,116,24,12,32,3,40,11,50,27,46,111,112,101,110,99,118,95,111,110,110,120,46,86,97,108,117,101,73,110,102,111,80,114,111,116,111,18,47,10,10,118,97,108,117,101,95,105,110,102,111,24,13,32,3,40,11,50,27,46,111,112,101,110,99,118,95,111,110,110,120,46,86,97,108,117,101,73,110,102,111,80,114,111,116,111,34,189,4,10,11,84,101,110,115,111,114,80,114,111,116,111,18,12,10,4,100,105,109,115,24,1,32,3,40,3,18,52,10,9,100,97,116,97,95,116,121,112,101,24,2,32,1,40,14,50,33,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,46,68,97,116,97,84,121,112,101,18,49,10,7,115,101,103,109,101,110,116,24,3,32,1,40,11,50,32,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,46,83,101,103,109,101,110,116,18,22,10,10,102,108,111,97,116,95,100,97,116,97,24,4,32,3,40,2,66,2,16,1,18,22,10,10,105,110,116,51,50,95,100,97,116,97,24,5,32,3,40,5,66,2,16,1,18,19,10,11,115,116,114,105,110,103,95,100,97,116,97,24,6,32,3,40,12,18,22,10,10,105,110,116,54,52,95,100,97,116,97,24,7,32,3,40,3,66,2,16,1,18,12,10,4,110,97,109,101,24,8,32,1,40,9,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,12,32,1,40,9,18,16,10,8,114,97,119,95,100,97,116,97,24,9,32,1,40,12,18,23,10,11,100,111,117,98,108,101,95,100,97,116,97,24,10,32,3,40,1,66,2,16,1,18,23,10,11,117,105,110,116,54,52,95,100,97,116,97,24,11,32,3,40,4,66,2,16,1,26,37,10,7,83,101,103,109,101,110,116,18,13,10,5,98,101,103,105,110,24,1,32,1,40,3,18,11,10,3,101,110,100,24,2,32,1,40,3,34,204,1,10,8,68,97,116,97,84,121,112,101,18,13,10,9,85,78,68,69,70,73,78,69,68,16,0,18,9,10,5,70,76,79,65,84,16,1,18,9,10,5,85,73,78,84,56,16,2,18,8,10,4,73,78,84,56,16,3,18,10,10,6,85,73,78,84,49,54,16,4,18,9,10,5,73,78,84,49,54,16,5,18,9,10,5,73,78,84,51,50,16,6,18,9,10,5,73,78,84,54,52,16,7,18,10,10,6,83,84,82,73,78,71,16,8,18,8,10,4,66,79,79,76,16,9,18,11,10,7,70,76,79,65,84,49,54,16,10,18,10,10,6,68,79,85,66,76,69,16,11,18,10,10,6,85,73,78,84,51,50,16,12,18,10,10,6,85,73,78,84,54,52,16,13,18,13,10,9,67,79,77,80,76,69,88,54,52,16,14,18,14,10,10,67,79,77,80,76,69,88,49,50,56,16,15,34,156,1,10,16,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,52,10,3,100,105,109,24,1,32,3,40,11,50,39,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,46,68,105,109,101,110,115,105,111,110,26,82,10,9,68,105,109,101,110,115,105,111,110,18,19,10,9,100,105,109,95,118,97,108,117,101,24,1,32,1,40,3,72,0,18,19,10,9,100,105,109,95,112,97,114,97,109,24,2,32,1,40,9,72,0,18,18,10,10,100,101,110,111,116,97,116,105,111,110,24,3,32,1,40,9,66,7,10,5,118,97,108,117,101,34,204,1,10,9,84,121,112,101,80,114,111,116,111,18,52,10,11,116,101,110,115,111,114,95,116,121,112,101,24,1,32,1,40,11,50,29,46,111,112,101,110,99,118,95,111,110,110,120,46,84,121,112,101,80,114,111,116,111,46,84,101,110,115,111,114,72,0,18,18,10,10,100,101,110,111,116,97,116,105,111,110,24,6,32,1,40,9,26,108,10,6,84,101,110,115,111,114,18,52,10,9,101,108,101,109,95,116,121,112,101,24,1,32,1,40,14,50,33,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,46,68,97,116,97,84,121,112,101,18,44,10,5,115,104,97,112,101,24,2,32,1,40,11,50,29,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,66,7,10,5,118,97,108,117,101,34,53,10,18,79,112,101,114,97,116,111,114,83,101,116,73,100,80,114,111,116,111,18,14,10,6,100,111,109,97,105,110,24,1,32,1,40,9,18,15,10,7,118,101,114,115,105,111,110,24,2,32,1,40,3,42,99,10,7,86,101,114,115,105,111,110,18,18,10,14,95,83,84,65,82,84,95,86,69,82,83,73,79,78,16,0,18,25,10,21,73,82,95,86,69,82,83,73,79,78,95,50,48,49,55,95,49,48,95,49,48,16,1,18,25,10,21,73,82,95,86,69,82,83,73,79,78,95,50,48,49,55,95,49,48,95,51,48,16,2,18,14,10,10,73,82,95,86,69,82,83,73,79,78,16,3,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,111,110,110,120,47,111,112,101,110,99,118,45,111,110,110,120,46,112,98,46,99,99,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,56,79,112,101,114,97,116,111,114,83,101,116,73,100,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,50,54,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,95,68,105,109,101,110,115,105,111,110,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,54,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,54,84,121,112,101,80,114,111,116,111,95,84,101,110,115,111,114,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,57,84,121,112,101,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,57,84,101,110,115,111,114,80,114,111,116,111,95,83,101,103,109,101,110,116,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,49,84,101,110,115,111,114,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,50,50,83,116,114,105,110,103,83,116,114,105,110,103,69,110,116,114,121,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,52,86,97,108,117,101,73,110,102,111,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,57,78,111,100,101,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,48,71,114,97,112,104,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,48,77,111,100,101,108,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,52,65,116,116,114,105,98,117,116,101,80,114,111,116,111,69,0,104,97,118,101,73,110,102,69,110,103,105,110,101,40,41,0,102,111,114,119,97,114,100,73,110,102,69,110,103,105,110,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,111,112,95,105,110,102,95,101,110,103,105,110,101,46,99,112,112,0,83,108,105,99,101,0,83,112,108,105,116,0,73,110,116,101,114,112,0,67,114,111,112,65,110,100,82,101,115,105,122,101,0,68,101,99,111,110,118,111,108,117,116,105,111,110,0,82,79,73,80,111,111,108,105,110,103,0,80,83,82,79,73,80,111,111,108,105,110,103,0,76,82,78,0,73,110,110,101,114,80,114,111,100,117,99,116,0,77,86,78,0,82,101,76,85,54,0,67,104,97,110,110,101,108,115,80,82,101,76,85,0,80,82,101,76,85,0,83,105,103,109,111,105,100,0,69,76,85,0,65,98,115,86,97,108,0,77,97,120,85,110,112,111,111,108,0,83,105,108,101,110,99,101,0,83,104,117,102,102,108,101,67,104,97,110,110,101,108,0,80,114,105,111,114,66,111,120,67,108,117,115,116,101,114,101,100,0,78,111,114,109,97,108,105,122,101,66,66,111,120,0,78,111,114,109,97,108,105,122,101,0,83,104,105,102,116,0,80,97,100,100,105,110,103,0,110,111,100,101,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,105,110,112,73,110,100,105,99,101,115,46,115,105,122,101,40,41,0,114,101,112,108,97,99,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,101,110,115,111,114,102,108,111,119,47,116,102,95,103,114,97,112,104,95,115,105,109,112,108,105,102,105,101,114,46,99,112,112,0,33,105,110,112,78,97,109,101,46,101,109,112,116,121,40,41,0,105,110,112,73,100,32,60,32,110,111,100,101,46,105,110,112,117,116,95,115,105,122,101,40,41,0,103,101,116,73,110,112,117,116,78,111,100,101,0,73,110,112,117,116,32,110,111,100,101,32,119,105,116,104,32,110,97,109,101,32,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,50,82,101,115,104,97,112,101,65,115,83,104,97,112,101,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,83,104,97,112,101,0,82,101,115,104,97,112,101,0,67,111,110,115,116,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,56,83,117,98,103,114,97,112,104,69,0,110,111,100,101,73,110,112,117,116,115,91,105,93,32,60,32,40,105,110,116,41,110,111,100,101,115,46,115,105,122,101,40,41,0,115,101,116,70,117,115,101,100,78,111,100,101,0,105,110,112,117,116,115,95,91,105,93,32,60,32,40,105,110,116,41,110,111,100,101,115,46,115,105,122,101,40,41,0,97,100,100,78,111,100,101,84,111,77,97,116,99,104,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,50,82,101,115,104,97,112,101,65,115,83,104,97,112,101,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,51,85,112,115,97,109,112,108,105,110,103,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,83,116,114,105,100,101,100,83,108,105,99,101,0,77,117,108,0,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,0,47,102,97,99,116,111,114,95,121,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,85,112,115,97,109,112,108,105,110,103,75,101,114,97,115,83,117,98,103,114,97,112,104,58,58,102,105,110,97,108,105,122,101,40,116,101,110,115,111,114,102,108,111,119,58,58,71,114,97,112,104,68,101,102,32,38,44,32,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,62,32,38,41,0,102,97,99,116,111,114,115,77,97,116,46,116,121,112,101,40,41,0,67,86,95,51,50,83,67,49,0,102,97,99,116,111,114,115,77,97,116,46,116,111,116,97,108,40,41,0,40,115,105,122,101,95,116,41,50,0,33,102,105,101,108,100,46,101,109,112,116,121,40,41,0,103,101,116,84,101,110,115,111,114,67,111,110,116,101,110,116,0,33,99,111,110,116,101,110,116,46,101,109,112,116,121,40,41,0,84,101,110,115,111,114,39,115,32,100,97,116,97,32,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,51,85,112,115,97,109,112,108,105,110,103,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,50,82,101,115,105,122,101,66,105,108,105,110,101,97,114,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,82,101,115,105,122,101,66,105,108,105,110,101,97,114,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,50,82,101,115,105,122,101,66,105,108,105,110,101,97,114,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,51,48,68,101,99,111,110,118,111,108,117,116,105,111,110,83,97,109,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,67,111,110,118,50,68,66,97,99,107,112,114,111,112,73,110,112,117,116,0,112,97,100,77,111,100,101,32,61,61,32,34,83,65,77,69,34,0,115,116,114,105,100,101,115,0,115,116,114,105,100,101,115,46,105,95,115,105,122,101,40,41,32,61,61,32,52,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,51,48,68,101,99,111,110,118,111,108,117,116,105,111,110,83,97,109,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,51,49,68,101,99,111,110,118,111,108,117,116,105,111,110,86,97,108,105,100,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,65,100,100,0,112,97,100,77,111,100,101,32,61,61,32,34,86,65,76,73,68,34,0,107,101,114,110,101,108,83,104,97,112,101,46,100,105,109,95,115,105,122,101,40,41,32,61,61,32,52,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,51,49,68,101,99,111,110,118,111,108,117,116,105,111,110,86,97,108,105,100,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,57,76,50,78,111,114,109,97,108,105,122,101,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,83,113,117,97,114,101,0,83,117,109,0,77,97,120,105,109,117,109,0,82,115,113,114,116,0,76,50,78,111,114,109,97,108,105,122,101,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,57,76,50,78,111,114,109,97,108,105,122,101,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,82,101,115,104,97,112,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,82,101,115,104,97,112,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,56,82,101,76,85,54,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,77,105,110,105,109,117,109,0,82,101,108,117,54,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,56,82,101,76,85,54,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,83,111,102,116,77,97,120,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,77,97,120,0,83,117,98,0,69,120,112,0,82,101,97,108,68,105,118,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,83,111,102,116,77,97,120,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,70,108,97,116,116,101,110,83,104,97,112,101,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,70,108,97,116,116,101,110,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,70,108,97,116,116,101,110,83,104,97,112,101,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,53,70,108,97,116,116,101,110,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,53,70,108,97,116,116,101,110,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,52,66,97,116,99,104,78,111,114,109,78,111,71,97,109,109,97,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,70,117,115,101,100,66,97,116,99,104,78,111,114,109,0,101,112,115,105,108,111,110,0,47,103,97,109,109,97,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,66,97,116,99,104,78,111,114,109,78,111,71,97,109,109,97,83,117,98,103,114,97,112,104,58,58,102,105,110,97,108,105,122,101,40,116,101,110,115,111,114,102,108,111,119,58,58,71,114,97,112,104,68,101,102,32,38,44,32,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,62,32,38,41,0,101,112,115,77,97,116,46,116,121,112,101,40,41,0,101,112,115,77,97,116,46,116,111,116,97,108,40,41,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,52,66,97,116,99,104,78,111,114,109,78,111,71,97,109,109,97,83,117,98,103,114,97,112,104,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,55,66,97,116,99,104,78,111,114,109,83,117,98,103,114,97,112,104,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,66,97,116,99,104,78,111,114,109,83,117,98,103,114,97,112,104,58,58,102,105,110,97,108,105,122,101,40,116,101,110,115,111,114,102,108,111,119,58,58,71,114,97,112,104,68,101,102,32,38,44,32,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,62,32,38,41,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,55,66,97,116,99,104,78,111,114,109,83,117,98,103,114,97,112,104,69,0,73,100,101,110,116,105,116,121,0,68,114,111,112,111,117,116,0,100,102,115,101,108,102,45,62,104,97,110,100,108,101,32,33,61,32,48,76,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,111,114,99,104,47,84,72,68,105,115,107,70,105,108,101,46,99,112,112,0,84,72,68,105,115,107,70,105,108,101,95,109,111,100,101,40,109,111,100,101,44,32,38,105,115,82,101,97,100,97,98,108,101,44,32,38,105,115,87,114,105,116,97,98,108,101,41,0,84,72,68,105,115,107,70,105,108,101,95,110,101,119,0,105,115,82,101,97,100,97,98,108,101,32,38,38,32,33,105,115,87,114,105,116,97,98,108,101,0,114,98,0,99,97,110,110,111,116,32,111,112,101,110,32,60,37,115,62,32,105,110,32,109,111,100,101,32,37,99,37,99,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,115,101,108,102,0,84,72,68,105,115,107,70,105,108,101,95,99,108,111,115,101,0,84,72,68,105,115,107,70,105,108,101,95,112,111,115,105,116,105,111,110,0,117,110,97,98,108,101,32,116,111,32,111,98,116,97,105,110,32,100,105,115,107,32,102,105,108,101,32,111,102,102,115,101,116,32,40,109,97,121,98,101,32,97,32,108,111,110,103,32,111,118,101,114,102,108,111,119,32,111,99,99,117,114,114,101,100,41,0,84,72,68,105,115,107,70,105,108,101,95,115,101,101,107,69,110,100,0,117,110,97,98,108,101,32,116,111,32,115,101,101,107,32,97,116,32,101,110,100,32,111,102,32,102,105,108,101,0,84,72,68,105,115,107,70,105,108,101,95,115,101,101,107,0,117,110,97,98,108,101,32,116,111,32,115,101,101,107,32,97,116,32,112,111,115,105,116,105,111,110,32,37,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,83,116,114,105,110,103,0,100,102,115,101,108,102,45,62,102,105,108,101,46,105,115,82,101,97,100,97,98,108,101,0,40,115,116,114,108,101,110,40,102,111,114,109,97,116,41,32,62,61,32,50,32,63,32,40,102,111,114,109,97,116,91,48,93,32,61,61,32,39,42,39,41,32,38,38,32,40,102,111,114,109,97,116,91,49,93,32,61,61,32,39,97,39,32,124,124,32,102,111,114,109,97,116,91,49,93,32,61,61,32,39,108,39,41,32,58,32,48,41,0,114,101,97,100,32,101,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,0,114,101,97,100,32,101,114,114,111,114,58,32,114,101,97,100,32,48,32,98,108,111,99,107,115,32,105,110,115,116,101,97,100,32,111,102,32,49,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,68,111,117,98,108,101,0,37,108,103,0,114,101,97,100,32,101,114,114,111,114,58,32,114,101,97,100,32,37,100,32,98,108,111,99,107,115,32,105,110,115,116,101,97,100,32,111,102,32,37,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,70,108,111,97,116,0,37,103,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,76,111,110,103,0,37,108,100,0,99,97,110,32,110,111,116,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+419840);allocate([97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,73,110,116,0,37,100,10,13,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,83,104,111,114,116,0,37,104,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,67,104,97,114,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,66,121,116,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,97,99,114,111,115,115,95,115,112,97,116,105,97,108,0,115,116,97,114,116,95,97,120,105,115,0,33,112,97,114,97,109,115,46,104,97,115,40,34,97,99,114,111,115,115,95,115,112,97,116,105,97,108,34,41,32,124,124,32,33,112,97,114,97,109,115,46,104,97,115,40,34,101,110,100,95,97,120,105,115,34,41,0,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,110,111,114,109,97,108,105,122,101,95,98,98,111,120,95,108,97,121,101,114,46,99,112,112,0,112,110,111,114,109,32,62,32,48,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,32,38,38,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,105,110,112,117,116,115,91,48,93,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,116,111,116,97,108,40,41,0,110,117,109,32,42,32,110,117,109,80,108,97,110,101,115,32,33,61,32,48,0,115,99,97,108,101,46,116,111,116,97,108,40,41,32,61,61,32,110,117,109,80,108,97,110,101,115,0,78,50,99,118,51,100,110,110,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,56,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,79,114,100,101,114,115,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,110,32,80,101,114,109,117,116,101,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,109,117,115,116,32,98,101,32,105,110,32,91,48,46,46,46,37,100,93,0,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,101,114,109,117,116,101,95,108,97,121,101,114,46,99,112,112,0,80,101,114,109,117,116,101,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,32,99,111,110,116,97,105,110,115,32,100,117,112,108,105,99,97,116,101,100,32,111,114,100,101,114,115,46,0,40,105,110,116,41,95,110,117,109,65,120,101,115,32,61,61,32,105,110,112,117,116,115,91,48,93,46,115,105,122,101,40,41,0,116,111,116,97,108,40,105,110,112,117,116,115,91,105,93,41,32,61,61,32,116,111,116,97,108,40,115,104,97,112,101,65,102,116,101,114,41,0,111,117,116,112,117,116,115,91,107,93,46,116,111,116,97,108,40,41,32,61,61,32,105,110,112,117,116,115,91,107,93,46,116,111,116,97,108,40,41,0,105,110,112,46,100,105,109,115,32,61,61,32,110,117,109,65,120,101,115,32,38,38,32,105,110,112,46,115,105,122,101,32,61,61,32,105,110,112,117,116,115,91,48,93,46,115,105,122,101,0,111,117,116,46,100,105,109,115,32,61,61,32,110,117,109,65,120,101,115,32,38,38,32,111,117,116,46,115,105,122,101,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,0,105,110,112,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,111,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,105,110,112,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,111,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,111,117,116,46,115,105,122,101,91,48,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,48,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,49,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,49,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,50,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,50,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,51,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,51,93,93,0,78,50,99,118,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,49,52,80,101,114,109,117,116,101,73,110,118,111,107,101,114,69,0,40,105,110,116,41,95,110,117,109,65,120,101,115,32,61,61,32,105,110,112,48,46,100,105,109,115,0,78,50,99,118,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,80,101,114,109,117,116,101,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,117,109,65,120,101,115,32,62,61,32,45,49,0,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,115,104,97,112,101,95,108,97,121,101,114,46,99,112,112,0,100,105,109,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,82,101,115,104,97,112,101,76,97,121,101,114,69,0,116,111,116,97,108,40,115,114,99,83,104,97,112,101,44,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,44,32,115,114,99,82,97,110,103,101,46,101,110,100,41,32,61,61,32,109,97,115,107,84,111,116,97,108,0,99,111,109,112,117,116,101,83,104,97,112,101,66,121,82,101,115,104,97,112,101,77,97,115,107,0,48,32,60,61,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,115,114,99,82,97,110,103,101,46,101,110,100,32,38,38,32,115,114,99,82,97,110,103,101,46,101,110,100,32,60,61,32,115,114,99,83,104,97,112,101,83,105,122,101,0,67,111,112,121,32,100,105,109,91,37,100,93,32,40,119,104,105,99,104,32,104,97,115,32,122,101,114,111,32,115,105,122,101,41,32,105,115,32,111,117,116,32,111,102,32,116,104,101,32,115,111,117,114,99,101,32,115,104,97,112,101,32,98,111,117,110,100,115,0,68,117,112,108,105,99,97,116,101,32,111,102,32,105,110,102,101,114,114,101,100,32,100,105,109,32,40,119,104,105,99,104,32,105,115,32,100,101,110,111,116,101,100,32,98,121,32,45,49,41,0,109,97,115,107,83,104,97,112,101,91,105,93,32,62,61,32,45,49,0,67,97,110,39,116,32,105,110,102,101,114,32,97,32,100,105,109,32,100,101,110,111,116,101,100,32,98,121,32,45,49,0,115,114,99,84,111,116,97,108,32,61,61,32,100,115,116,84,111,116,97,108,0,78,50,99,118,51,100,110,110,49,54,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,111,110,118,111,108,117,116,105,111,110,95,108,97,121,101,114,46,99,112,112,0,98,108,111,98,115,46,115,105,122,101,40,41,32,33,61,32,48,0,33,104,97,115,66,105,97,115,40,41,32,124,124,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,98,108,111,98,115,91,48,93,46,115,105,122,101,91,48,93,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,49,0,110,103,114,111,117,112,115,32,62,32,48,32,38,38,32,105,110,112,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,32,38,38,32,111,117,116,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,33,119,101,105,103,104,116,115,77,97,116,46,101,109,112,116,121,40,41,0,102,117,115,101,87,101,105,103,104,116,115,0,98,105,97,115,118,101,99,46,115,105,122,101,40,41,32,61,61,32,111,117,116,67,110,32,43,32,50,0,119,46,101,109,112,116,121,40,41,32,124,124,32,111,117,116,67,110,32,61,61,32,119,46,116,111,116,97,108,40,41,0,98,46,101,109,112,116,121,40,41,32,124,124,32,111,117,116,67,110,32,61,61,32,98,46,116,111,116,97,108,40,41,0,105,110,112,117,116,115,91,48,93,46,115,105,122,101,91,49,93,32,37,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,49,93,32,61,61,32,48,0,105,110,112,117,116,115,91,48,93,46,100,97,116,97,32,33,61,32,111,117,116,112,117,116,115,91,48,93,46,100,97,116,97,0,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,91,49,93,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,109,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,109,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,40,105,110,116,41,109,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,67,110,0,105,110,112,117,116,46,100,105,109,115,32,61,61,32,52,32,38,38,32,111,117,116,112,117,116,46,100,105,109,115,32,61,61,32,52,0,105,110,112,117,116,46,115,105,122,101,91,48,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,48,93,0,119,101,105,103,104,116,115,46,114,111,119,115,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,49,93,0,119,101,105,103,104,116,115,46,99,111,108,115,32,61,61,32,40,105,110,112,117,116,46,115,105,122,101,91,49,93,47,110,103,114,111,117,112,115,41,42,107,101,114,110,101,108,46,119,105,100,116,104,42,107,101,114,110,101,108,46,104,101,105,103,104,116,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,111,117,116,112,117,116,46,116,121,112,101,40,41,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,111,117,116,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,98,105,97,115,118,101,99,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,111,117,116,112,117,116,46,115,105,122,101,91,49,93,43,50,0,78,50,99,118,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,50,80,97,114,97,108,108,101,108,67,111,110,118,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,56,67,104,97,110,110,101,108,115,80,82,101,76,85,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,57,82,101,76,85,76,97,121,101,114,69,0,33,98,108,111,98,115,46,101,109,112,116,121,40,41,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,49,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,60,61,32,50,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,52,32,38,38,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,51,93,32,61,61,32,107,101,114,110,101,108,46,119,105,100,116,104,32,38,38,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,50,93,32,61,61,32,107,101,114,110,101,108,46,104,101,105,103,104,116,0,105,110,112,117,116,46,100,105,109,115,32,61,61,32,52,32,38,38,32,40,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,124,124,32,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,41,0,105,110,112,117,116,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,105,110,112,117,116,46,116,121,112,101,40,41,0,105,110,112,117,116,115,91,105,93,46,100,105,109,115,32,61,61,32,52,32,38,38,32,105,110,112,117,116,115,91,105,93,46,115,105,122,101,91,49,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,49,93,0,105,110,112,117,116,115,91,105,93,46,115,105,122,101,91,50,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,50,93,32,38,38,32,105,110,112,117,116,115,91,105,93,46,115,105,122,101,91,51,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,51,93,0,85,110,115,117,112,112,111,114,116,101,100,32,97,115,121,109,109,101,116,114,105,99,32,112,97,100,100,105,110,103,32,105,110,32,99,111,110,118,111,108,117,116,105,111,110,32,108,97,121,101,114,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,66,97,115,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,52,66,97,115,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,54,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,69,0,66,97,115,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,0,97,100,106,95,104,0,97,100,106,95,119,0,110,117,109,79,117,116,112,117,116,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,97,100,106,117,115,116,80,97,100,46,119,105,100,116,104,32,60,32,115,116,114,105,100,101,46,119,105,100,116,104,32,38,38,32,97,100,106,117,115,116,80,97,100,46,104,101,105,103,104,116,32,60,32,115,116,114,105,100,101,46,104,101,105,103,104,116,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,33,104,97,115,66,105,97,115,40,41,32,124,124,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,0,85,110,115,117,112,112,111,114,116,101,100,32,112,97,100,100,105,110,103,32,109,111,100,101,32,0,111,117,116,67,110,32,37,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,49,93,32,61,61,32,48,0,105,110,112,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,32,38,38,32,111,117,116,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,98,108,111,98,115,91,48,93,46,115,105,122,101,91,48,93,32,61,61,32,105,110,112,67,110,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,51,67,111,108,50,73,109,73,110,118,111,107,101,114,69,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,51,77,97,116,77,117,108,73,110,118,111,107,101,114,69,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,111,114,109,95,114,101,103,105,111,110,0,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,0,87,73,84,72,73,78,95,67,72,65,78,78,69,76,0,85,110,107,110,111,119,110,32,114,101,103,105,111,110,32,116,121,112,101,32,34,0,76,82,78,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,108,114,110,95,108,97,121,101,114,46,99,112,112,0,108,111,99,97,108,95,115,105,122,101,0,76,82,78,32,108,97,121,101,114,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,112,111,115,105,116,105,118,101,32,111,100,100,32,118,97,108,117,101,115,32,102,111,114,32,108,111,99,97,108,95,115,105,122,101,0,97,108,112,104,97,0,110,111,114,109,95,98,121,95,115,105,122,101,0,105,110,112,117,116,115,95,97,114,114,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,95,97,114,114,46,116,111,116,97,108,40,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,0,105,110,112,117,116,115,91,105,93,46,100,105,109,115,32,61,61,32,52,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,109,111,100,101,32,111,102,32,76,82,78,32,108,97,121,101,114,0,78,50,99,118,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,49,48,67,104,97,110,110,101,108,76,82,78,69,0,78,50,99,118,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,56,76,82,78,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,83,99,97,108,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,99,97,108,101,95,108,97,121,101,114,46,99,112,112,0,33,98,108,111,98,115,46,101,109,112,116,121,40,41,32,124,124,32,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,0,110,117,109,87,101,105,103,104,116,115,32,33,61,32,48,0,116,111,116,97,108,40,105,110,112,83,104,97,112,101,44,32,97,120,105,115,44,32,101,110,100,65,120,105,115,41,32,61,61,32,110,117,109,87,101,105,103,104,116,115,0,33,104,97,115,66,105,97,115,32,124,124,32,110,117,109,87,101,105,103,104,116,115,32,61,61,32,98,105,97,115,46,116,111,116,97,108,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,99,97,108,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,111,117,116,66,108,111,98,46,116,121,112,101,40,41,0,105,110,112,66,108,111,98,46,116,121,112,101,40,41,0,73,110,99,111,109,112,97,116,105,98,108,101,32,119,101,105,103,104,116,115,47,98,105,97,115,32,98,108,111,98,115,0,119,101,105,103,104,116,115,46,116,111,116,97,108,40,41,0,98,105,97,115,46,116,111,116,97,108,40,41,0,40,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,32,38,38,32,98,108,111,98,115,46,101,109,112,116,121,40,41,41,32,124,124,32,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,40,105,110,116,41,104,97,115,87,101,105,103,104,116,115,32,43,32,40,105,110,116,41,104,97,115,66,105,97,115,0,78,50,99,118,51,100,110,110,49,52,83,99,97,108,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,48,83,99,97,108,101,76,97,121,101,114,69,0,83,99,97,108,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,105,110,112,117,116,95,100,105,109,115,0,112,97,114,97,109,115,46,104,97,115,40,34,112,97,100,100,105,110,103,115,34,41,0,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,97,100,100,105,110,103,95,108,97,121,101,114,46,99,112,112,0,40,112,97,100,100,105,110,103,115,80,97,114,97,109,46,115,105,122,101,40,41,32,38,32,49,41,32,61,61,32,48,0,112,97,100,100,105,110,103,115,91,105,93,46,102,105,114,115,116,32,62,61,32,48,0,112,97,100,100,105,110,103,115,91,105,93,46,115,101,99,111,110,100,32,62,61,32,48,0,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,62,61,32,112,97,100,100,105,110,103,115,46,115,105,122,101,40,41,0,105,110,112,117,116,68,105,109,115,32,61,61,32,45,49,32,124,124,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,61,61,32,105,110,112,117,116,68,105,109,115,32,124,124,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,62,32,112,97,100,100,105,110,103,115,46,115,105,122,101,40,41,0,99,111,110,115,116,97,110,116,0,114,101,102,108,101,99,116,0,105,110,112,117,116,115,91,48,93,46,100,105,109,115,32,61,61,32,52,0,111,117,116,112,117,116,115,91,48,93,46,100,105,109,115,32,61,61,32,52,0,79,110,108,121,32,115,112,97,116,105,97,108,32,114,101,102,108,101,99,116,105,111,110,32,112,97,100,100,105,110,103,32,105,115,32,115,117,112,112,111,114,116,101,100,46,0,85,110,107,110,111,119,110,32,112,97,100,100,105,110,103,32,116,121,112,101,58,32,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,112,97,100,82,105,103,104,116,0,105,110,112,87,105,100,116,104,0,112,97,100,76,101,102,116,0,112,97,100,66,111,116,116,111,109,0,105,110,112,72,101,105,103,104,116,0,112,97,100,84,111,112,0,78,50,99,118,51,100,110,110,49,54,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,80,97,100,100,105,110,103,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,102,108,97,116,116,101,110,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,115,91,105,93,32,61,61,32,105,110,112,117,116,115,91,48,93,0,115,116,97,114,116,65,120,105,115,32,62,61,32,48,0,101,110,100,65,120,105,115,32,62,61,32,115,116,97,114,116,65,120,105,115,32,38,38,32,101,110,100,65,120,105,115,32,60,32,40,105,110,116,41,110,117,109,65,120,101,115,0,111,117,116,112,117,116,83,104,97,112,101,86,101,99,46,115,105,122,101,40,41,32,60,61,32,52,0,78,50,99,118,51,100,110,110,49,54,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,70,108,97,116,116,101,110,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,83,108,105,99,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,108,105,99,101,95,112,111,105,110,116,0,98,101,103,105,110,0,101,110,100,0,33,112,97,114,97,109,115,46,104,97,115,40,34,98,101,103,105,110,34,41,32,38,38,32,33,112,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,32,38,38,32,33,112,97,114,97,109,115,46,104,97,115,40,34,101,110,100,34,41,0,83,108,105,99,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,108,105,99,101,95,108,97,121,101,114,46,99,112,112,0,112,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,32,94,32,112,97,114,97,109,115,46,104,97,115,40,34,101,110,100,34,41,0,98,101,103,105,110,115,46,115,105,122,101,40,41,32,61,61,32,115,105,122,101,115,79,114,69,110,100,115,46,115,105,122,101,40,41,0,115,116,97,114,116,32,62,61,32,48,0,115,105,122,101,32,61,61,32,45,49,32,124,124,32,115,105,122,101,32,62,32,48,0,101,110,100,32,60,32,48,32,124,124,32,101,110,100,32,62,32,115,116,97,114,116,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,48,83,108,105,99,101,76,97,121,101,114,69,0,115,108,105,99,101,82,97,110,103,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,0,48,32,60,61,32,97,120,105,115,32,38,38,32,97,120,105,115,32,60,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,0,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,32,62,32,48,32,38,38,32,105,110,112,83,104,97,112,101,91,97,120,105,115,93,32,37,32,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,32,61,61,32,48,0,99,108,97,109,112,101,100,46,115,116,97,114,116,32,60,32,99,108,97,109,112,101,100,46,101,110,100,0,99,108,97,109,112,0,99,108,97,109,112,101,100,46,101,110,100,32,60,61,32,97,120,105,115,83,105,122,101,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,115,108,105,99,101,82,97,110,103,101,115,46,115,105,122,101,40,41,0,115,108,105,99,101,82,97,110,103,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,105,110,112,83,104,97,112,101,46,100,105,109,115,40,41,0,78,50,99,118,51,100,110,110,49,52,83,108,105,99,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,50,77,86,78,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,111,114,109,97,108,105,122,101,95,118,97,114,105,97,110,99,101,0,97,99,114,111,115,115,95,99,104,97,110,110,101,108,115,0,78,50,99,118,51,100,110,110,49,50,77,86,78,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,56,77,86,78,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,55,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,102,101,97,116,95,115,116,114,105,100,101,0,98,97,115,101,95,115,105,122,101,0,112,114,101,95,110,109,115,95,116,111,112,110,0,112,111,115,116,95,110,109,115,95,116,111,112,110,0,110,109,115,95,116,104,114,101,115,104,0,114,97,116,105,111,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,51,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,114,111,112,111,115,97,108,95,108,97,121,101,114,46,99,112,112,0,108,97,121,101,114,79,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,97,121,101,114,73,110,116,101,114,110,97,108,115,46,101,109,112,116,121,40,41,0,115,99,111,114,101,115,46,115,105,122,101,40,41,32,61,61,32,52,0,40,115,99,111,114,101,115,91,49,93,32,38,32,49,41,32,61,61,32,48,0,105,110,116,101,114,110,97,108,115,46,115,105,122,101,40,41,32,61,61,32,51,0,105,109,73,110,102,111,46,116,111,116,97,108,40,41,32,62,61,32,50,0,110,117,109,68,101,116,115,32,60,61,32,107,101,101,112,84,111,112,65,102,116,101,114,78,77,83,0,109,46,100,105,109,115,32,61,61,32,52,0,103,101,116,79,98,106,101,99,116,83,99,111,114,101,115,0,109,46,115,105,122,101,91,48,93,32,61,61,32,49,0,40,99,104,97,110,110,101,108,115,32,38,32,49,41,32,61,61,32,48,0,98,98,111,120,68,101,108,116,97,115,46,100,105,109,115,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,55,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,51,80,114,111,112,111,115,97,108,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,101,108,101,109,101,110,116,119,105,115,101,95,108,97,121,101,114,115,46,99,112,112,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,69,0,109,105,110,95,118,97,108,117,101,0,109,97,120,95,118,97,108,117,101,0,109,105,110,86,97,108,117,101,32,60,61,32,109,97,120,86,97,108,117,101,0,82,101,76,85,54,70,117,110,99,116,111,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,48,82,101,76,85,54,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,57,84,97,110,72,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,83,105,103,109,111,105,100,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,56,69,76,85,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,56,65,98,115,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,57,66,78,76,76,76,97,121,101,114,69,0,112,111,119,101,114,0,115,104,105,102,116,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+430080);allocate([97,121,101,114,73,78,83,50,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,48,80,111,119,101,114,76,97,121,101,114,69,0,112,97,114,97,109,115,46,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,115,99,97,108,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,99,97,108,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,97,112,112,108,121,0,48,32,60,61,32,99,110,48,32,38,38,32,99,110,48,32,60,32,99,110,49,32,38,38,32,99,110,49,32,60,61,32,40,105,110,116,41,115,99,97,108,101,46,116,111,116,97,108,40,41,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,112,97,100,100,105,110,103,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,111,110,99,97,116,95,108,97,121,101,114,46,99,112,112,0,99,117,114,83,104,97,112,101,46,115,105,122,101,40,41,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,40,41,0,73,110,99,111,110,115,105,115,116,101,110,116,32,115,104,97,112,101,32,102,111,114,32,67,111,110,99,97,116,76,97,121,101,114,0,105,110,112,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,105,110,112,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,105,110,112,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,41,32,38,38,32,105,110,112,46,100,105,109,115,32,61,61,32,52,32,38,38,32,105,110,112,46,115,105,122,101,91,48,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,48,93,32,38,38,32,105,110,112,46,115,105,122,101,91,50,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,50,93,32,38,38,32,105,110,112,46,115,105,122,101,91,51,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,51,93,0,110,99,104,97,110,110,101,108,115,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,49,93,0,111,117,116,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,111,117,116,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,111,117,116,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,41,0,78,50,99,118,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,50,48,67,104,97,110,110,101,108,67,111,110,99,97,116,73,110,118,111,107,101,114,69,0,78,50,99,118,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,53,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,122,111,111,109,95,102,97,99,116,111,114,95,120,0,122,111,111,109,95,102,97,99,116,111,114,95,121,0,33,112,97,114,97,109,115,46,104,97,115,40,34,122,111,111,109,95,102,97,99,116,111,114,95,120,34,41,32,38,38,32,33,112,97,114,97,109,115,46,104,97,115,40,34,122,111,111,109,95,102,97,99,116,111,114,95,121,34,41,0,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,115,105,122,101,95,108,97,121,101,114,46,99,112,112,0,112,97,114,97,109,115,46,104,97,115,40,34,122,111,111,109,95,102,97,99,116,111,114,95,120,34,41,32,38,38,32,112,97,114,97,109,115,46,104,97,115,40,34,122,111,111,109,95,102,97,99,116,111,114,95,121,34,41,0,98,105,108,105,110,101,97,114,0,105,110,116,101,114,112,111,108,97,116,105,111,110,32,61,61,32,34,110,101,97,114,101,115,116,34,32,124,124,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,61,61,32,34,98,105,108,105,110,101,97,114,34,0,97,108,105,103,110,95,99,111,114,110,101,114,115,0,85,110,107,110,111,119,110,32,105,110,116,101,114,112,111,108,97,116,105,111,110,58,32,0,78,50,99,118,51,100,110,110,49,53,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,49,82,101,115,105,122,101,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,53,73,110,116,101,114,112,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,53,73,110,116,101,114,112,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,83,112,108,105,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,116,111,112,95,99,111,117,110,116,0,111,117,116,112,117,116,115,67,111,117,110,116,32,62,61,32,48,0,83,112,108,105,116,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,112,108,105,116,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,115,91,48,93,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,91,105,93,46,116,111,116,97,108,40,41,0,78,50,99,118,51,100,110,110,49,52,83,112,108,105,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,48,83,112,108,105,116,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,49,32,60,61,32,98,108,111,98,115,46,115,105,122,101,40,41,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,60,61,32,50,0,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,102,117,108,108,121,95,99,111,110,110,101,99,116,101,100,95,108,97,121,101,114,46,99,112,112,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,115,105,122,101,95,116,41,40,105,110,110,101,114,83,105,122,101,32,42,32,110,117,109,79,117,116,112,117,116,41,32,61,61,32,98,108,111,98,115,91,48,93,46,116,111,116,97,108,40,41,0,33,98,105,97,115,32,124,124,32,40,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,50,32,38,38,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,32,61,61,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,41,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,50,0,33,98,105,97,115,32,124,124,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,32,61,61,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,0,115,114,99,77,97,116,46,100,105,109,115,32,61,61,32,50,32,38,38,32,115,114,99,77,97,116,46,99,111,108,115,32,61,61,32,119,101,105,103,104,116,115,46,99,111,108,115,32,38,38,32,100,115,116,77,97,116,46,114,111,119,115,32,61,61,32,115,114,99,77,97,116,46,114,111,119,115,32,38,38,32,100,115,116,77,97,116,46,99,111,108,115,32,61,61,32,119,101,105,103,104,116,115,46,114,111,119,115,32,38,38,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,32,38,38,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,32,61,61,32,100,115,116,77,97,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,40,98,105,97,115,77,97,116,46,101,109,112,116,121,40,41,32,124,124,32,40,98,105,97,115,77,97,116,46,116,121,112,101,40,41,32,61,61,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,38,38,32,98,105,97,115,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,105,110,116,41,98,105,97,115,77,97,116,46,116,111,116,97,108,40,41,32,61,61,32,100,115,116,77,97,116,46,99,111,108,115,41,41,0,78,50,99,118,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,49,52,70,117,108,108,121,67,111,110,110,101,99,116,101,100,69,0,78,50,99,118,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,55,73,110,110,101,114,80,114,111,100,117,99,116,76,97,121,101,114,69,0,104,0,99,0,120,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,57,76,83,84,77,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,51,76,83,84,77,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,51,0,76,83,84,77,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,99,117,114,114,101,110,116,95,108,97,121,101,114,115,46,99,112,112,0,87,104,46,100,105,109,115,32,61,61,32,50,32,38,38,32,87,120,46,100,105,109,115,32,61,61,32,50,0,87,104,46,114,111,119,115,32,61,61,32,87,120,46,114,111,119,115,0,87,104,46,114,111,119,115,32,61,61,32,52,42,87,104,46,99,111,108,115,0,87,104,46,114,111,119,115,32,61,61,32,40,105,110,116,41,98,105,97,115,46,116,111,116,97,108,40,41,0,87,104,46,116,121,112,101,40,41,32,61,61,32,87,120,46,116,121,112,101,40,41,32,38,38,32,87,120,46,116,121,112,101,40,41,32,61,61,32,98,105,97,115,46,116,121,112,101,40,41,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,54,0,98,108,111,98,115,91,105,93,46,114,111,119,115,32,61,61,32,78,32,38,38,32,98,108,111,98,115,91,105,93,46,99,111,108,115,32,61,61,32,78,0,98,108,111,98,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,98,105,97,115,46,116,121,112,101,40,41,0,117,115,101,95,116,105,109,101,115,116,97,109,112,95,100,105,109,0,112,114,111,100,117,99,101,95,99,101,108,108,95,111,117,116,112,117,116,0,102,111,114,103,101,116,95,98,105,97,115,0,99,101,108,108,95,99,108,105,112,0,117,115,101,95,99,101,108,108,95,99,108,105,112,0,117,115,101,95,112,101,101,112,104,111,108,101,0,33,97,108,108,111,99,97,116,101,100,0,115,101,116,80,114,111,100,117,99,101,67,101,108,108,79,117,116,112,117,116,0,115,101,116,85,115,101,84,105,109,115,116,97,109,112,115,68,105,109,0,33,97,108,108,111,99,97,116,101,100,32,124,124,32,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,41,32,61,61,32,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,95,41,0,115,101,116,79,117,116,83,104,97,112,101,0,115,101,116,87,101,105,103,104,116,115,0,40,33,117,115,101,80,101,101,112,104,111,108,101,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,51,41,32,124,124,32,40,117,115,101,80,101,101,112,104,111,108,101,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,54,41,0,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,95,41,32,61,61,32,95,110,117,109,79,117,116,0,105,110,112,48,46,115,105,122,101,40,41,32,62,61,32,50,32,38,38,32,116,111,116,97,108,40,105,110,112,48,44,32,50,41,32,61,61,32,95,110,117,109,73,110,112,0,105,110,112,48,46,115,105,122,101,40,41,32,62,61,32,50,32,38,38,32,116,111,116,97,108,40,105,110,112,48,44,32,49,41,32,61,61,32,95,110,117,109,73,110,112,0,70,117,110,99,116,105,111,110,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,102,108,111,97,116,105,110,103,32,112,111,105,110,116,32,116,121,112,101,115,0,116,97,110,104,0,105,110,112,117,116,46,115,105,122,101,40,41,32,61,61,32,49,0,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,41,32,61,61,32,110,117,109,79,117,116,0,105,110,112,48,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,105,110,116,41,105,110,112,48,46,116,111,116,97,108,40,50,41,32,61,61,32,110,117,109,73,110,112,0,105,110,112,48,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,105,110,116,41,105,110,112,48,46,116,111,116,97,108,40,49,41,32,61,61,32,110,117,109,73,110,112,0,78,50,99,118,51,100,110,110,49,51,76,83,84,77,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,51,67,114,111,112,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,57,67,114,111,112,76,97,121,101,114,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,114,111,112,95,108,97,121,101,114,46,99,112,112,0,50,32,61,61,32,105,110,112,117,116,115,46,115,105,122,101,40,41,0,110,117,109,98,101,114,32,111,102,32,111,102,102,115,101,116,32,118,97,108,117,101,115,32,115,112,101,99,105,102,105,101,100,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,102,111,108,108,111,119,105,110,103,32,97,120,105,115,46,0,105,110,118,97,108,105,100,32,99,114,111,112,32,112,97,114,97,109,101,116,101,114,115,32,111,114,32,98,108,111,98,32,115,105,122,101,115,0,78,50,99,118,51,100,110,110,49,51,67,114,111,112,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,56,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,112,111,111,108,95,112,97,100,95,119,0,112,111,111,108,95,112,97,100,95,104,0,112,111,111,108,95,115,116,114,105,100,101,95,119,0,112,111,111,108,95,115,116,114,105,100,101,95,104,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,109,97,120,95,117,110,112,111,111,108,105,110,103,95,108,97,121,101,114,46,99,112,112,0,116,111,116,97,108,40,105,110,112,117,116,115,91,48,93,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,49,93,41,0,105,110,112,117,116,46,116,111,116,97,108,40,41,32,61,61,32,105,110,100,105,99,101,115,46,116,111,116,97,108,40,41,0,105,110,112,117,116,46,115,105,122,101,91,48,93,32,61,61,32,49,0,105,110,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,105,110,112,117,116,46,115,105,122,101,91,49,93,32,61,61,32,111,117,116,66,108,111,98,46,115,105,122,101,91,49,93,0,109,46,100,105,109,115,32,62,32,50,0,103,101,116,80,108,97,110,101,0,105,95,110,61,0,105,95,99,61,0,105,95,119,104,61,0,105,110,100,101,120,61,0,109,97,120,118,97,108,61,0,111,117,116,80,108,97,110,101,84,111,116,97,108,61,0,105,110,112,117,116,46,115,105,122,101,61,0,32,120,32,0,105,110,100,105,99,101,115,46,115,105,122,101,61,0,111,117,116,66,108,111,98,61,0,48,32,60,61,32,105,110,100,101,120,32,38,38,32,105,110,100,101,120,32,60,32,111,117,116,80,108,97,110,101,84,111,116,97,108,0,78,50,99,118,51,100,110,110,49,56,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,52,77,97,120,85,110,112,111,111,108,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,111,112,101,114,97,116,105,111,110,0,112,114,111,100,0,85,110,107,110,111,119,110,32,111,112,101,114,97,116,105,111,110,32,116,121,112,101,32,34,0,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,101,108,116,119,105,115,101,95,108,97,121,101,114,46,99,112,112,0,99,111,101,102,102,0,103,101,116,70,76,79,80,83,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,50,0,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,48,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,105,110,112,117,116,115,46,115,105,122,101,40,41,0,111,112,32,61,61,32,83,85,77,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,48,0,105,110,112,117,116,115,91,48,93,32,61,61,32,105,110,112,117,116,115,91,105,93,0,99,111,101,102,102,115,46,101,109,112,116,121,40,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,115,114,99,115,0,115,114,99,115,91,105,93,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,115,91,105,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,100,115,116,46,116,111,116,97,108,40,41,32,61,61,32,100,115,116,46,115,105,122,101,91,48,93,32,42,32,112,46,99,104,97,110,110,101,108,115,32,42,32,112,46,112,108,97,110,101,83,105,122,101,0,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,115,114,99,115,0,78,50,99,118,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,49,52,69,108,116,119,105,115,101,73,110,118,111,107,101,114,69,0,115,116,97,116,105,99,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,58,58,69,108,116,119,105,115,101,73,110,118,111,107,101,114,58,58,114,117,110,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,105,110,116,44,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,44,32,99,118,58,58,100,110,110,58,58,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,58,58,69,108,116,119,105,115,101,79,112,44,32,99,111,110,115,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,65,99,116,105,118,97,116,105,111,110,76,97,121,101,114,32,42,44,32,105,110,116,41,0,100,115,116,46,116,121,112,101,40,41,0,100,115,116,46,100,105,109,115,0,49,32,60,32,100,115,116,46,100,105,109,115,32,38,38,32,100,115,116,46,100,105,109,115,32,60,61,32,52,0,78,50,99,118,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,69,0,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,117,109,95,99,108,97,115,115,101,115,0,115,104,97,114,101,95,108,111,99,97,116,105,111,110,0,98,97,99,107,103,114,111,117,110,100,95,108,97,98,101,108,95,105,100,0,118,97,114,105,97,110,99,101,95,101,110,99,111,100,101,100,95,105,110,95,116,97,114,103,101,116,0,107,101,101,112,95,116,111,112,95,107,0,99,111,110,102,105,100,101,110,99,101,95,116,104,114,101,115,104,111,108,100,0,116,111,112,95,107,0,108,111,99,95,112,114,101,100,95,116,114,97,110,115,112,111,115,101,100,0,103,114,111,117,112,95,98,121,95,99,108,97,115,115,101,115,0,95,110,109,115,84,104,114,101,115,104,111,108,100,32,62,32,48,46,0,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,100,101,116,101,99,116,105,111,110,95,111,117,116,112,117,116,95,108,97,121,101,114,46,99,112,112,0,99,111,100,101,95,116,121,112,101,0,99,101,110,116,101,114,95,115,105,122,101,0,67,69,78,84,69,82,95,83,73,90,69,0,67,79,82,78,69,82,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,51,0,105,110,112,117,116,115,91,48,93,91,48,93,32,61,61,32,105,110,112,117,116,115,91,49,93,91,48,93,0,40,110,117,109,80,114,105,111,114,115,32,42,32,95,110,117,109,76,111,99,67,108,97,115,115,101,115,32,42,32,52,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,48,93,44,32,49,41,0,105,110,116,40,110,117,109,80,114,105,111,114,115,32,42,32,95,110,117,109,67,108,97,115,115,101,115,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,49,93,44,32,49,41,0,105,110,112,117,116,115,91,50,93,91,49,93,32,61,61,32,49,32,43,32,40,105,110,116,41,40,33,95,118,97,114,105,97,110,99,101,69,110,99,111,100,101,100,73,110,84,97,114,103,101,116,41,0,95,98,98,111,120,101,115,78,111,114,109,97,108,105,122,101,100,32,124,124,32,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,52,0,105,110,112,117,116,115,91,51,93,46,100,105,109,115,32,61,61,32,52,0,99,111,117,110,116,32,61,61,32,110,117,109,75,101,112,116,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,99,111,110,102,105,100,101,110,99,101,32,112,114,101,100,105,99,116,105,111,110,115,32,102,111,114,32,108,97,98,101,108,32,37,100,0,111,117,116,112,117,116,68,101,116,101,99,116,105,111,110,115,95,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,108,111,99,97,116,105,111,110,32,112,114,101,100,105,99,116,105,111,110,115,32,102,111,114,32,108,97,98,101,108,32,37,100,0,112,114,111,99,101,115,115,68,101,116,101,99,116,105,111,110,115,95,0,78,77,83,70,97,115,116,95,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,46,46,47,110,109,115,46,105,110,108,46,104,112,112,0,105,100,120,32,60,32,115,99,111,114,101,115,46,115,105,122,101,40,41,0,97,108,108,95,108,111,99,95,112,114,101,100,115,46,115,105,122,101,40,41,32,61,61,32,110,117,109,0,68,101,99,111,100,101,66,66,111,120,101,115,65,108,108,0,112,114,105,111,114,95,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,112,114,105,111,114,95,118,97,114,105,97,110,99,101,115,46,115,105,122,101,40,41,0,68,101,99,111,100,101,66,66,111,120,101,115,0,112,114,105,111,114,95,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,98,98,111,120,101,115,46,115,105,122,101,40,41,0,110,117,109,95,98,98,111,120,101,115,32,61,61,32,48,32,124,124,32,112,114,105,111,114,95,118,97,114,105,97,110,99,101,115,91,48,93,46,115,105,122,101,40,41,32,61,61,32,52,0,112,114,105,111,114,95,119,105,100,116,104,32,62,32,48,0,68,101,99,111,100,101,66,66,111,120,0,112,114,105,111,114,95,104,101,105,103,104,116,32,62,32,48,0,85,110,107,110,111,119,110,32,116,121,112,101,46,0,110,117,109,76,111,99,67,108,97,115,115,101,115,32,61,61,32,49,0,71,101,116,76,111,99,80,114,101,100,105,99,116,105,111,110,115,0,78,50,99,118,51,100,110,110,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,50,48,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,53,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,103,105,111,110,95,108,97,121,101,114,46,99,112,112,0,110,109,115,95,116,104,114,101,115,104,111,108,100,0,110,109,115,84,104,114,101,115,104,111,108,100,32,62,61,32,48,46,0,99,111,111,114,100,115,32,61,61,32,52,0,99,108,97,115,115,101,115,32,62,61,32,49,0,97,110,99,104,111,114,115,32,62,61,32,49,0,117,115,101,76,111,103,105,115,116,105,99,32,124,124,32,117,115,101,83,111,102,116,109,97,120,0,89,111,108,111,57,48,48,48,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,105,110,112,117,116,115,91,48,93,91,51,93,32,61,61,32,40,49,32,43,32,99,111,111,114,100,115,32,43,32,99,108,97,115,115,101,115,41,42,97,110,99,104,111,114,115,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,49,0,115,97,109,112,108,101,95,115,105,122,101,42,98,97,116,99,104,95,115,105,122,101,32,61,61,32,105,110,112,66,108,111,98,46,116,111,116,97,108,40,41,0,115,97,109,112,108,101,95,115,105,122,101,42,98,97,116,99,104,95,115,105,122,101,32,61,61,32,111,117,116,66,108,111,98,46,116,111,116,97,108,40,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,60,32,50,32,124,124,32,105,110,112,117,116,115,91,49,93,46,100,105,109,115,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,53,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,49,82,101,103,105,111,110,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,108,111,103,95,115,111,102,116,109,97,120,0,48,32,60,61,32,115,116,97,114,116,68,105,109,32,38,38,32,115,116,97,114,116,68,105,109,32,60,61,32,101,110,100,68,105,109,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,111,102,116,109,97,120,95,108,97,121,101,114,46,99,112,112,0,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,78,50,99,118,51,100,110,110,49,54,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,50,83,111,102,116,109,97,120,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,50,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,112,97,114,97,109,115,46,104,97,115,40,34,119,105,100,116,104,34,41,0,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,114,111,112,95,97,110,100,95,114,101,115,105,122,101,95,108,97,121,101,114,46,99,112,112,0,112,97,114,97,109,115,46,104,97,115,40,34,104,101,105,103,104,116,34,41,0,105,110,112,117,116,115,91,48,93,46,115,105,122,101,40,41,32,61,61,32,52,0,105,110,112,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,111,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,78,50,99,118,51,100,110,110,50,50,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,56,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,82,101,111,114,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,114,101,111,114,103,83,116,114,105,100,101,32,62,32,48,0,82,101,111,114,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,111,114,103,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,32,48,0,111,117,116,112,117,116,115,91,48,93,91,48,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,49,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,50,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,51,93,32,62,32,48,0,116,111,116,97,108,40,111,117,116,112,117,116,115,91,48,93,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,48,93,41,0,78,50,99,118,51,100,110,110,49,52,82,101,111,114,103,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,48,82,101,111,114,103,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,56,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,50,0,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,98,97,116,99,104,95,110,111,114,109,95,108,97,121,101,114,46,99,112,112,0,117,115,101,95,103,108,111,98,97,108,95,115,116,97,116,115,0,115,99,97,108,101,95,98,105,97,115,0,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,110,32,38,38,32,98,108,111,98,115,91,48,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,108,111,98,115,91,49,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,108,111,98,115,91,48,93,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,98,108,111,98,115,91,49,93,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,51,0,40,115,105,122,101,95,116,41,119,101,105,103,104,116,115,66,108,111,98,73,110,100,101,120,32,60,32,98,108,111,98,115,46,115,105,122,101,40,41,0,119,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,119,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,119,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,0,40,115,105,122,101,95,116,41,98,105,97,115,66,108,111,98,73,110,100,101,120,32,60,32,98,108,111,98,115,46,115,105,122,101,40,41,0,98,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,98,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,0,99,118,58,58,100,110,110,58,58,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,58,58,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,40,99,111,110,115,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,58,58,76,97,121,101,114,80,97,114,97,109,115,32,38,41,0,98,108,111,98,115,91,50,93,46,116,121,112,101,40,41,0,67,86,95,51,50,70,67,49,0,66,97,116,99,104,32,110,111,114,109,97,108,105,122,97,116,105,111,110,32,105,110,32,116,114,97,105,110,105,110,103,32,109,111,100,101,32,119,105,116,104,32,98,97,116,99,104,32,115,105,122,101,32,62,32,49,0,105,110,112,66,108,111,98,46,100,105,109,115,32,61,61,32,50,32,124,124,32,105,110,112,66,108,111,98,46,100,105,109,115,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,56,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,52,66,97,116,99,104,78,111,114,109,76,97,121,101,114,69,0,107,101,114,110,101,108,0,107,101,114,110,101,108,95,115,105,122,101,32,40,111,114,32,107,101,114,110,101,108,95,104,32,97,110,100,32,107,101,114,110,101,108,95,119,41,32,110,111,116,32,115,112,101,99,105,102,105,101,100,0,103,101,116,75,101,114,110,101,108,83,105,122,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,108,97,121,101,114,115,95,99,111,109,109,111,110,46,99,112,112,0,107,101,114,110,101,108,72,32,62,32,48,32,38,38,32,107,101,114,110,101,108,87,32,62,32,48,0,112,97,100,95,108,0,112,97,100,95,116,0,112,97,100,95,114,0,112,97,100,95,98,0,112,97,100,84,32,62,61,32,48,32,38,38,32,112,97,100,76,32,62,61,32,48,32,38,38,32,112,97,100,66,32,62,61,32,48,32,38,38,32,112,97,100,82,32,62,61,32,48,32,38,38,32,115,116,114,105,100,101,72,32,62,32,48,32,38,38,32,115,116,114,105,100,101,87,32,62,32,48,0,103,101,116,83,116,114,105,100,101,65,110,100,80,97,100,100,105,110,103,0,73,110,32,103,108,111,98,97,108,95,112,111,111,108,105,110,103,32,109,111,100,101,44,32,107,101,114,110,101,108],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+440320);allocate([95,115,105,122,101,32,40,111,114,32,107,101,114,110,101,108,95,104,32,97,110,100,32,107,101,114,110,101,108,95,119,41,32,99,97,110,110,111,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,103,101,116,80,111,111,108,105,110,103,75,101,114,110,101,108,80,97,114,97,109,115,0,73,110,32,103,108,111,98,97,108,95,112,111,111,108,105,110,103,32,109,111,100,101,44,32,112,97,100,115,32,109,117,115,116,32,98,101,32,61,32,48,44,32,97,110,100,32,115,116,114,105,100,101,95,104,32,97,110,100,32,115,116,114,105,100,101,95,119,32,109,117,115,116,32,98,101,32,61,32,49,0,100,105,108,97,116,105,111,110,72,32,62,32,48,32,38,38,32,100,105,108,97,116,105,111,110,87,32,62,32,48,0,103,101,116,67,111,110,118,111,108,117,116,105,111,110,75,101,114,110,101,108,80,97,114,97,109,115,0,86,65,76,73,68,0,83,65,77,69,0,85,110,115,117,112,112,111,114,116,101,100,32,112,97,100,100,105,110,103,32,109,111,100,101,0,103,101,116,67,111,110,118,80,111,111,108,79,117,116,80,97,114,97,109,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,83,104,117,102,102,108,101,67,104,97,110,110,101,108,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,32,38,38,32,105,110,112,117,116,115,91,48,93,46,115,105,122,101,40,41,32,61,61,32,52,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,104,117,102,102,108,101,95,99,104,97,110,110,101,108,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,115,91,48,93,91,49,93,32,37,32,103,114,111,117,112,32,61,61,32,48,0,78,50,99,118,51,100,110,110,50,51,83,104,117,102,102,108,101,67,104,97,110,110,101,108,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,57,83,104,117,102,102,108,101,67,104,97,110,110,101,108,76,97,121,101,114,69,0,115,99,97,108,101,95,116,114,97,105,110,0,100,114,111,112,111,117,116,95,114,97,116,105,111,0,115,99,97,108,101,32,62,32,48,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,98,108,97,110,107,95,108,97,121,101,114,46,99,112,112,0,80,111,119,101,114,0,115,99,97,108,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,66,108,97,110,107,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,52,66,108,97,110,107,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,48,66,108,97,110,107,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,55,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,111,114,109,97,108,105,122,101,100,95,98,98,111,120,0,95,109,97,120,83,105,122,101,32,62,32,95,109,105,110,83,105,122,101,0,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,114,105,111,114,95,98,111,120,95,108,97,121,101,114,46,99,112,112,0,119,105,100,116,104,115,46,115,105,122,101,40,41,32,61,61,32,104,101,105,103,104,116,115,46,115,105,122,101,40,41,0,95,97,115,112,101,99,116,82,97,116,105,111,115,46,101,109,112,116,121,40,41,0,33,112,97,114,97,109,115,46,104,97,115,40,34,109,105,110,95,115,105,122,101,34,41,0,33,112,97,114,97,109,115,46,104,97,115,40,34,109,97,120,95,115,105,122,101,34,41,0,95,109,105,110,83,105,122,101,32,62,32,48,0,95,98,111,120,87,105,100,116,104,115,46,115,105,122,101,40,41,32,61,61,32,95,98,111,120,72,101,105,103,104,116,115,46,115,105,122,101,40,41,0,115,116,101,112,95,104,0,115,116,101,112,95,119,0,33,112,97,114,97,109,115,46,104,97,115,40,34,115,116,101,112,34,41,0,95,115,116,101,112,89,32,62,32,48,46,0,95,115,116,101,112,88,32,62,32,48,46,0,111,102,102,115,101,116,0,33,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,34,41,0,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,95,104,34,41,0,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,95,119,34,41,0,95,111,102,102,115,101,116,115,88,46,115,105,122,101,40,41,32,61,61,32,95,111,102,102,115,101,116,115,89,46,115,105,122,101,40,41,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,100,110,110,47,100,110,110,46,105,110,108,46,104,112,112,0,118,97,114,105,97,110,99,101,80,97,114,97,109,101,116,101,114,82,101,116,114,105,101,118,101,100,0,103,101,116,86,97,114,105,97,110,99,101,0,118,97,114,105,97,110,99,101,83,105,122,101,32,61,61,32,52,0,118,97,114,105,97,110,99,101,32,62,32,48,0,97,115,112,101,99,116,95,114,97,116,105,111,0,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,0,32,112,97,114,97,109,101,116,101,114,46,0,103,101,116,80,97,114,97,109,101,116,101,114,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,58,58,102,105,110,97,108,105,122,101,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,115,91,49,93,46,100,105,109,115,0,52,0,105,110,112,117,116,115,91,48,93,46,100,105,109,115,0,105,110,112,117,116,115,46,115,105,122,101,40,41,0,40,115,105,122,101,95,116,41,49,0,78,50,99,118,51,100,110,110,49,55,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,51,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,51,52,95,118,49,48,49,51,80,114,105,111,114,66,111,120,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,116,111,99,104,97,115,116,105,99,0,85,110,107,110,111,119,110,32,112,111,111,108,105,110,103,32,116,121,112,101,32,34,0,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,111,111,108,105,110,103,95,108,97,121,101,114,46,99,112,112,0,111,117,116,112,117,116,95,100,105,109,0,103,114,111,117,112,95,115,105,122,101,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,112,111,111,108,105,110,103,32,116,121,112,101,0,99,101,105,108,95,109,111,100,101,0,115,112,97,116,105,97,108,95,115,99,97,108,101,0,97,118,101,95,112,111,111,108,95,112,97,100,100,101,100,95,97,114,101,97,0,115,116,97,114,116,32,60,61,32,40,105,110,116,41,115,104,97,112,101,46,115,105,122,101,40,41,32,38,38,32,101,110,100,32,60,61,32,40,105,110,116,41,115,104,97,112,101,46,115,105,122,101,40,41,32,38,38,32,115,116,97,114,116,32,60,61,32,101,110,100,0,116,111,116,97,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,100,110,110,47,115,104,97,112,101,95,117,116,105,108,115,46,104,112,112,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,33,61,32,48,0,103,101,116,77,101,109,111,114,121,83,104,97,112,101,115,0,40,111,117,116,46,104,101,105,103,104,116,32,45,32,49,41,32,42,32,115,116,114,105,100,101,46,104,101,105,103,104,116,32,60,32,105,110,46,104,101,105,103,104,116,32,43,32,112,97,100,95,98,0,40,111,117,116,46,119,105,100,116,104,32,45,32,49,41,32,42,32,115,116,114,105,100,101,46,119,105,100,116,104,32,60,32,105,110,46,119,105,100,116,104,32,43,32,112,97,100,95,114,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,0,112,115,82,111,105,79,117,116,67,104,97,110,110,101,108,115,32,42,32,112,111,111,108,101,100,83,105,122,101,46,119,105,100,116,104,32,42,32,112,111,111,108,101,100,83,105,122,101,46,104,101,105,103,104,116,32,61,61,32,105,110,112,117,116,115,91,48,93,91,49,93,0,110,117,109,79,117,116,112,117,116,115,32,61,61,32,49,32,124,124,32,40,110,117,109,79,117,116,112,117,116,115,32,61,61,32,50,32,38,38,32,116,121,112,101,32,61,61,32,77,65,88,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,102,111,114,119,97,114,100,0,33,99,111,109,112,117,116,101,77,97,120,73,100,120,32,124,124,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,78,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,114,117,110,0,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,53,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,0,115,114,99,46,100,105,109,115,32,61,61,32,52,0,100,115,116,46,100,105,109,115,32,61,61,32,52,0,40,40,40,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,82,79,73,32,124,124,32,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,80,83,82,79,73,41,32,38,38,32,100,115,116,46,115,105,122,101,91,48,93,32,61,61,32,114,111,105,115,46,115,105,122,101,91,48,93,41,32,124,124,32,115,114,99,46,115,105,122,101,91,48,93,32,61,61,32,100,115,116,46,115,105,122,101,91,48,93,41,0,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,80,83,82,79,73,32,124,124,32,115,114,99,46,115,105,122,101,91,49,93,32,61,61,32,100,115,116,46,115,105,122,101,91,49,93,0,40,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,115,114,99,46,116,121,112,101,40,41,32,38,38,32,109,97,115,107,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,41,41,0,114,111,105,115,68,97,116,97,91,48,93,32,60,32,115,114,99,45,62,115,105,122,101,91,48,93,0,78,50,99,118,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,49,52,80,111,111,108,105,110,103,73,110,118,111,107,101,114,69,0,33,105,110,112,117,116,115,46,101,109,112,116,121,40,41,0,102,105,110,97,108,105,122,101,0,78,50,99,118,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,69,0,97,110,99,104,111,114,115,0,91,110,101,116,93,0,108,97,121,101,114,95,116,121,112,101,95,115,105,122,101,32,60,32,108,105,110,101,46,115,105,122,101,40,41,0,82,101,97,100,68,97,114,107,110,101,116,70,114,111,109,67,102,103,83,116,114,101,97,109,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,97,114,107,110,101,116,47,100,97,114,107,110,101,116,95,105,111,46,99,112,112,0,115,101,112,97,114,97,116,111,114,95,105,110,100,101,120,32,60,32,108,105,110,101,46,115,105,122,101,40,41,0,110,101,116,45,62,119,105,100,116,104,32,62,32,48,32,38,38,32,110,101,116,45,62,104,101,105,103,104,116,32,62,32,48,32,38,38,32,110,101,116,45,62,99,104,97,110,110,101,108,115,32,62,32,48,0,99,111,110,118,111,108,117,116,105,111,110,97,108,0,112,97,100,0,115,116,114,105,100,101,0,102,105,108,116,101,114,115,0,97,99,116,105,118,97,116,105,111,110,0,108,105,110,101,97,114,0,98,97,116,99,104,95,110,111,114,109,97,108,105,122,101,0,108,101,97,107,121,0,85,110,115,117,112,112,111,114,116,101,100,32,97,99,116,105,118,97,116,105,111,110,58,32,0,102,108,105,112,112,101,100,0,84,114,97,110,115,112,111,115,101,32,116,104,101,32,99,111,110,118,111,108,117,116,105,111,110,97,108,32,119,101,105,103,104,116,115,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,107,101,114,110,101,108,95,115,105,122,101,32,62,32,48,32,38,38,32,102,105,108,116,101,114,115,32,62,32,48,0,99,117,114,114,101,110,116,95,99,104,97,110,110,101,108,115,32,62,32,48,0,109,97,120,112,111,111,108,0,97,118,103,112,111,111,108,0,115,111,102,116,109,97,120,0,103,114,111,117,112,115,0,83,111,102,116,109,97,120,32,102,114,111,109,32,68,97,114,107,110,101,116,32,119,105,116,104,32,103,114,111,117,112,115,32,33,61,32,49,0,114,111,117,116,101,0,108,97,121,101,114,115,0,33,98,111,116,116,111,109,95,108,97,121,101,114,115,46,101,109,112,116,121,40,41,0,114,101,111,114,103,0,114,101,103,105,111,110,0,116,104,114,101,115,104,0,99,111,111,114,100,115,0,99,108,97,115,115,101,115,0,110,117,109,0,33,97,110,99,104,111,114,115,95,118,97,108,117,101,115,46,101,109,112,116,121,40,41,0,99,108,97,115,115,101,115,32,62,32,48,32,38,38,32,110,117,109,95,111,102,95,97,110,99,104,111,114,115,32,62,32,48,32,38,38,32,40,110,117,109,95,111,102,95,97,110,99,104,111,114,115,32,42,32,50,41,32,61,61,32,97,110,99,104,111,114,115,95,118,101,99,46,115,105,122,101,40,41,0,115,104,111,114,116,99,117,116,0,33,98,111,116,116,111,109,95,108,97,121,101,114,46,101,109,112,116,121,40,41,0,117,112,115,97,109,112,108,101,0,121,111,108,111,0,33,109,97,115,107,95,118,97,108,117,101,115,46,101,109,112,116,121,40,41,0,85,110,107,110,111,119,110,32,108,97,121,101,114,32,116,121,112,101,58,32,0,82,101,103,105,111,110,45,110,97,109,101,0,82,101,103,105,111,110,0,121,111,108,111,95,37,100,0,85,112,115,97,109,112,108,101,45,110,97,109,101,0,82,101,115,105,122,101,0,122,111,111,109,95,102,97,99,116,111,114,0,105,110,116,101,114,112,111,108,97,116,105,111,110,0,110,101,97,114,101,115,116,0,117,112,115,97,109,112,108,101,95,37,100,0,83,104,111,114,116,99,117,116,45,110,97,109,101,0,69,108,116,119,105,115,101,0,115,117,109,0,115,104,111,114,116,99,117,116,95,37,100,0,115,111,102,116,109,97,120,95,116,114,101,101,0,100,101,116,101,99,116,105,111,110,95,111,117,116,0,80,101,114,109,117,116,101,45,110,97,109,101,0,80,101,114,109,117,116,101,0,111,114,100,101,114,0,112,101,114,109,117,116,101,95,37,100,0,82,101,111,114,103,45,110,97,109,101,0,82,101,111,114,103,0,114,101,111,114,103,95,115,116,114,105,100,101,0,114,101,111,114,103,95,37,100,0,67,111,110,99,97,116,45,110,97,109,101,0,67,111,110,99,97,116,0,99,111,110,99,97,116,95,37,100,0,73,100,101,110,116,105,116,121,45,110,97,109,101,0,105,100,101,110,116,105,116,121,95,37,100,0,83,111,102,116,109,97,120,45,110,97,109,101,0,83,111,102,116,109,97,120,0,115,111,102,116,109,97,120,95,37,100,0,97,118,101,0,103,108,111,98,97,108,95,112,111,111,108,105,110,103,0,80,111,111,108,105,110,103,45,110,97,109,101,0,80,111,111,108,105,110,103,0,97,118,103,112,111,111,108,95,37,100,0,109,97,120,0,107,101,114,110,101,108,95,115,105,122,101,0,112,111,111,108,95,37,100,0,99,111,110,118,95,37,100,0,98,105,97,115,95,116,101,114,109,0,66,97,116,99,104,78,111,114,109,45,110,97,109,101,0,66,97,116,99,104,78,111,114,109,0,104,97,115,95,119,101,105,103,104,116,0,101,112,115,0,98,110,95,37,100,0,110,101,103,97,116,105,118,101,95,115,108,111,112,101,0,82,101,76,85,45,110,97,109,101,0,114,101,108,117,95,37,100,0,67,111,110,118,111,108,117,116,105,111,110,45,110,97,109,101,0,67,111,110,118,111,108,117,116,105,111,110,0,110,117,109,95,111,117,116,112,117,116,0,84,114,97,110,115,112,111,115,101,32,116,104,101,32,119,101,105,103,104,116,115,32,40,101,120,99,101,112,116,32,102,111,114,32,99,111,110,118,111,108,117,116,105,111,110,97,108,41,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,82,101,97,100,68,97,114,107,110,101,116,70,114,111,109,87,101,105,103,104,116,115,83,116,114,101,97,109,0,119,101,105,103,104,116,115,66,108,111,98,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,102,117,110,99,116,105,111,110,46,112,114,111,116,111,0,10,14,102,117,110,99,116,105,111,110,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,12,111,112,95,100,101,102,46,112,114,111,116,111,34,120,10,18,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,18,48,10,8,102,117,110,99,116,105,111,110,24,1,32,3,40,11,50,30,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,18,48,10,8,103,114,97,100,105,101,110,116,24,2,32,3,40,11,50,30,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,34,177,2,10,11,70,117,110,99,116,105,111,110,68,101,102,18,43,10,9,115,105,103,110,97,116,117,114,101,24,1,32,1,40,11,50,24,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,18,49,10,4,110,111,100,101,24,2,32,3,40,11,50,35,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,26,193,1,10,4,78,111,100,101,18,11,10,3,114,101,116,24,1,32,3,40,9,18,10,10,2,111,112,24,2,32,1,40,9,18,11,10,3,97,114,103,24,3,32,3,40,9,18,11,10,3,100,101,112,24,4,32,3,40,9,18,59,10,4,97,116,116,114,24,5,32,3,40,11,50,45,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,65,116,116,114,69,110,116,114,121,26,73,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,43,10,5,118,97,108,117,101,24,2,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,34,59,10,11,71,114,97,100,105,101,110,116,68,101,102,18,21,10,13,102,117,110,99,116,105,111,110,95,110,97,109,101,24,1,32,1,40,9,18,21,10,13,103,114,97,100,105,101,110,116,95,102,117,110,99,24,2,32,1,40,9,66,47,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,14,70,117,110,99,116,105,111,110,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,102,117,110,99,116,105,111,110,46,112,98,46,99,99,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,46,102,117,110,99,116,105,111,110,95,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,46,103,114,97,100,105,101,110,116,95,102,117,110,99,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,49,71,114,97,100,105,101,110,116,68,101,102,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,102,105,101,108,100,95,105,110,108,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,116,104,105,115,45,62,77,97,112,70,105,101,108,100,66,97,115,101,58,58,114,101,112,101,97,116,101,100,95,102,105,101,108,100,95,32,33,61,32,78,85,76,76,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,69,110,116,114,121,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,70,105,101,108,100,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,114,101,116,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,111,112,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,97,114,103,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,100,101,112,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,49,53,77,97,112,69,110,116,114,121,87,114,97,112,112,101,114,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,54,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,49,70,117,110,99,116,105,111,110,68,101,102,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,56,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,69,0,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,115,99,111,114,101,115,46,115,105,122,101,40,41,0,78,77,83,66,111,120,101,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,110,109,115,46,99,112,112,0,115,99,111,114,101,95,116,104,114,101,115,104,111,108,100,32,62,61,32,48,0,110,109,115,95,116,104,114,101,115,104,111,108,100,32,62,61,32,48,0,101,116,97,32,62,32,48,0,111,112,95,100,101,102,46,112,114,111,116,111,0,10,12,111,112,95,100,101,102,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,233,5,10,5,79,112,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,50,10,9,105,110,112,117,116,95,97,114,103,24,2,32,3,40,11,50,31,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,18,51,10,10,111,117,116,112,117,116,95,97,114,103,24,3,32,3,40,11,50,31,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,18,46,10,4,97,116,116,114,24,4,32,3,40,11,50,32,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,18,53,10,11,100,101,112,114,101,99,97,116,105,111,110,24,8,32,1,40,11,50,32,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,112,114,101,99,97,116,105,111,110,18,15,10,7,115,117,109,109,97,114,121,24,5,32,1,40,9,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,6,32,1,40,9,18,22,10,14,105,115,95,99,111,109,109,117,116,97,116,105,118,101,24,18,32,1,40,8,18,20,10,12,105,115,95,97,103,103,114,101,103,97,116,101,24,16,32,1,40,8,18,19,10,11,105,115,95,115,116,97,116,101,102,117,108,24,17,32,1,40,8,18,34,10,26,97,108,108,111,119,115,95,117,110,105,110,105,116,105,97,108,105,122,101,100,95,105,110,112,117,116,24,19,32,1,40,8,26,166,1,10,6,65,114,103,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,2,32,1,40,9,18,41,10,4,116,121,112,101,24,3,32,1,40,14,50,27,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,18,17,10,9,116,121,112,101,95,97,116,116,114,24,4,32,1,40,9,18,19,10,11,110,117,109,98,101,114,95,97,116,116,114,24,5,32,1,40,9,18,22,10,14,116,121,112,101,95,108,105,115,116,95,97,116,116,114,24,6,32,1,40,9,18,14,10,6,105,115,95,114,101,102,24,16,32,1,40,8,26,203,1,10,7,65,116,116,114,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,51,10,13,100,101,102,97,117,108,116,95,118,97,108,117,101,24,3,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,4,32,1,40,9,18,19,10,11,104,97,115,95,109,105,110,105,109,117,109,24,5,32,1,40,8,18,15,10,7,109,105,110,105,109,117,109,24,6,32,1,40,3,18,52,10,14,97,108,108,111,119,101,100,95,118,97,108,117,101,115,24,7,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,34,53,10,13,79,112,68,101,112,114,101,99,97,116,105,111,110,18,15,10,7,118,101,114,115,105,111,110,24,1,32,1,40,5,18,19,10,11,101,120,112,108,97,110,97,116,105,111,110,24,2,32,1,40,9,34,46,10,6,79,112,76,105,115,116,18,36,10,2,111,112,24,1,32,3,40,11,50,24,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,79,112,68,101,102,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,111,112,95,100,101,102,46,112,98,46,99,99,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,112,114,101,99,97,116,105,111,110,46,101,120,112,108,97,110,97,116,105,111,110,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,51,79,112,68,101,112,114,101,99,97,116,105,111,110,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,116,121,112,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,51,79,112,68,101,102,95,65,116,116,114,68,101,102,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,115,117,109,109,97,114,121,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,53,79,112,68,101,102,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,54,79,112,76,105,115,116,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,116,121,112,101,95,97,116,116,114,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,110,117,109,98,101,114,95,97,116,116,114,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,116,121,112,101,95,108,105,115,116,95,97,116,116,114,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,50,79,112,68,101,102,95,65,114,103,68,101,102,69,0,46,65,75,65,90,69,0,78,50,99,118,53,65,75,65,90,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,65,75,65,90,69,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,33,32,105,109,97,103,101,46,101,109,112,116,121,40,41,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,97,107,97,122,101,46,99,112,112,0,40,100,101,115,99,114,105,112,116,111,114,115,46,101,109,112,116,121,40,41,32,124,124,32,100,101,115,99,114,105,112,116,111,114,115,46,99,111,108,115,40,41,32,61,61,32,100,101,115,99,114,105,112,116,111,114,83,105,122,101,40,41,41,0,40,100,101,115,99,114,105,112,116,111,114,115,46,101,109,112,116,121,40,41,32,124,124,32,40,100,101,115,99,114,105,112,116,111,114,115,46,116,121,112,101,40,41,32,61,61,32,100,101,115,99,114,105,112,116,111,114,84,121,112,101,40,41,41,41,0,100,101,115,99,114,105,112,116,111,114,0,100,101,115,99,114,105,112,116,111,114,95,99,104,97,110,110,101,108,115,0,100,101,115,99,114,105,112,116,111,114,95,115,105,122,101,0,78,50,99,118,49,48,65,75,65,90,69,95,73,109,112,108,69,0,78,50,99,118,51,79,82,66,69,0,102,105,114,115,116,76,101,118,101,108,95,32,62,61,32,48,0,115,101,116,70,105,114,115,116,76,101,118,101,108,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,111,114,98,46,99,112,112,0,112,97,116,99,104,83,105,122,101,32,62,61,32,50,0,108,101,118,101,108,32,62,61,32,48,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,98,108,111,99,107,83,105,122,101,42,98,108,111,99,107,83,105,122,101,32,60,61,32,50,48,52,56,0,72,97,114,114,105,115,82,101,115,112,111,110,115,101,115,0,48,32,60,61,32,108,101,118,101,108,0,119,116,97,95,107,32,61,61,32,50,32,124,124,32,119,116,97,95,107,32,61,61,32,51,32,124,124,32,119,116,97,95,107,32,61,61,32,52,0,87,114,111,110,103,32,119,116,97,95,107,46,32,73,116,32,99,97,110,32,98,101,32,111,110,108,121,32,50,44,32,51,32,111,114,32,52,46,0,99,111,109,112,117,116,101,79,114,98,68,101,115,99,114,105,112,116,111,114,115,0,78,50,99,118,56,79,82,66,95,73,109,112,108,69,0,102,105,114,115,116,76,101,118,101,108,32,62,61,32,48,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,79,82,66,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,46,71,70,84,84,68,101,116,101,99,116,111,114,0,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,71,70,84,84,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,55,71,70,84,84,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,101,97,116,117,114,101,50,100,46,99,112,112,0,107,101,121,112,111,105,110,116,115,46,115,105,122,101,40,41,32,61,61,32,110,105,109,97,103,101,115,0,99,111,109,112,117,116,101,0,95,100,101,115,99,114,105,112,116,111,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,77,65,84,0,109,97,115,107,115,46,115,105,122,101,40,41,32,61,61,32,110,105,109,97,103,101,115,0,70,101,97,116,117,114,101,50,68,0,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,46,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,52,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,50,52,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,73,110,99,111,114,114,101,99,116,32,116,121,112,101,32,111,102,32,105,110,112,117,116,32,105,109,97,103,101,46,10,0,100,114,97,119,75,101,121,112,111,105,110,116,115,0,33,111,117,116,73,109,97,103,101,46,101,109,112,116,121,40,41,0,33,105,109,103,46,101,109,112,116,121,40,41,0,95,100,114,97,119,75,101,121,112,111,105,110,116,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,100,114,97,119,46,99,112,112,0,109,97,116,99,104,101,115,77,97,115,107,32,109,117,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+450560);allocate([116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,115,32,109,97,116,99,104,101,115,49,116,111,50,0,100,114,97,119,77,97,116,99,104,101,115,0,105,49,32,62,61,32,48,32,38,38,32,105,49,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,107,101,121,112,111,105,110,116,115,49,46,115,105,122,101,40,41,41,0,105,50,32,62,61,32,48,32,38,38,32,105,50,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,107,101,121,112,111,105,110,116,115,50,46,115,105,122,101,40,41,41,0,111,117,116,73,109,103,32,104,97,115,32,115,105,122,101,32,108,101,115,115,32,116,104,97,110,32,110,101,101,100,32,116,111,32,100,114,97,119,32,105,109,103,49,32,97,110,100,32,105,109,103,50,32,116,111,103,101,116,104,101,114,0,95,112,114,101,112,97,114,101,73,109,103,65,110,100,68,114,97,119,75,101,121,112,111,105,110,116,115,0,105,116,101,114,45,62,105,32,60,32,112,111,105,110,116,115,95,32,38,38,32,105,116,101,114,45,62,106,32,60,32,112,111,105,110,116,115,95,0,99,111,109,112,117,116,101,68,101,115,99,114,105,112,116,111,114,115,65,110,100,79,114,79,114,105,101,110,116,97,116,105,111,110,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,98,114,105,115,107,46,99,112,112,0,115,99,97,108,105,110,103,50,32,33,61,32,48,0,115,109,111,111,116,104,101,100,73,110,116,101,110,115,105,116,121,0,108,97,121,101,114,32,43,32,49,32,60,32,108,97,121,101,114,115,95,0,103,101,116,83,99,111,114,101,77,97,120,65,98,111,118,101,0,108,97,121,101,114,32,62,32,48,0,103,101,116,83,99,111,114,101,77,97,120,66,101,108,111,119,0,33,109,97,116,46,101,109,112,116,121,40,41,0,40,115,114,99,105,109,103,46,99,111,108,115,32,47,32,51,41,32,42,32,50,32,61,61,32,100,115,116,105,109,103,46,99,111,108,115,0,116,119,111,116,104,105,114,100,115,97,109,112,108,101,0,40,115,114,99,105,109,103,46,114,111,119,115,32,47,32,51,41,32,42,32,50,32,61,61,32,100,115,116,105,109,103,46,114,111,119,115,0,115,114,99,105,109,103,46,99,111,108,115,32,47,32,50,32,61,61,32,100,115,116,105,109,103,46,99,111,108,115,0,104,97,108,102,115,97,109,112,108,101,0,115,114,99,105,109,103,46,114,111,119,115,32,47,32,50,32,61,61,32,100,115,116,105,109,103,46,114,111,119,115,0,46,66,82,73,83,75,0,78,50,99,118,49,48,66,82,73,83,75,95,73,109,112,108,69,0,78,50,99,118,53,66,82,73,83,75,69,0,114,97,100,105,117,115,76,105,115,116,46,115,105,122,101,40,41,32,33,61,32,48,32,38,38,32,114,97,100,105,117,115,76,105,115,116,46,115,105,122,101,40,41,32,61,61,32,110,117,109,98,101,114,76,105,115,116,46,115,105,122,101,40,41,0,103,101,110,101,114,97,116,101,75,101,114,110,101,108,0,110,111,83,104,111,114,116,80,97,105,114,115,95,32,60,32,105,110,100,83,105,122,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,66,82,73,83,75,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,110,98,105,116,115,32,60,61,32,115,115,122,32,38,38,32,34,68,101,115,99,114,105,112,116,111,114,32,115,105,122,101,32,99,97,110,39,116,32,98,101,32,98,105,103,103,101,114,32,116,104,97,110,32,102,117,108,108,32,100,101,115,99,114,105,112,116,111,114,32,40,52,56,54,32,61,32,49,54,50,42,51,32,45,32,51,32,99,104,97,110,110,101,108,115,41,34,0,103,101,110,101,114,97,116,101,68,101,115,99,114,105,112,116,111,114,83,117,98,115,97,109,112,108,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,47,65,75,65,90,69,70,101,97,116,117,114,101,115,46,99,112,112,0,68,97,116,97,84,121,112,101,60,95,84,112,62,58,58,99,104,97,110,110,101,108,115,32,61,61,32,109,46,99,104,97,110,110,101,108,115,40,41,32,124,124,32,109,46,101,109,112,116,121,40,41,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,109,97,116,46,105,110,108,46,104,112,112,0,101,118,111,108,117,116,105,111,110,46,115,105,122,101,40,41,32,62,32,48,0,99,114,101,97,116,101,95,110,111,110,108,105,110,101,97,114,95,115,99,97,108,101,95,115,112,97,99,101,0,110,98,105,110,115,32,62,32,50,0,99,111,109,112,117,116,101,95,107,99,111,110,116,114,97,115,116,0,33,76,120,95,46,101,109,112,116,121,40,41,0,68,105,102,102,117,115,105,118,105,116,121,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,99,111,109,112,117,116,101,95,100,105,102,102,117,115,105,118,105,116,121,0,78,50,99,118,50,56,78,111,110,76,105,110,101,97,114,83,99,97,108,97,114,68,105,102,102,117,115,105,111,110,83,116,101,112,69,0,78,50,99,118,50,54,68,101,116,101,114,109,105,110,97,110,116,72,101,115,115,105,97,110,82,101,115,112,111,110,115,101,73,78,83,95,51,77,97,116,69,69,69,0,107,32,60,32,49,48,57,0,103,116,97,98,108,101,0,120,48,32,45,32,54,32,42,32,115,99,97,108,101,32,62,61,32,48,32,38,38,32,120,48,32,43,32,54,32,42,32,115,99,97,108,101,32,60,32,76,120,46,99,111,108,115,0,83,97,109,112,108,101,95,68,101,114,105,118,97,116,105,118,101,95,82,101,115,112,111,110,115,101,95,82,97,100,105,117,115,54,0,121,48,32,45,32,54,32,42,32,115,99,97,108,101,32,62,61,32,48,32,38,38,32,121,48,32,43,32,54,32,42,32,115,99,97,108,101,32,60,32,76,120,46,114,111,119,115,0,99,117,109,91,110,107,101,121,115,93,32,61,61,32,110,0,113,117,97,110,116,105,122,101,100,95,99,111,117,110,116,105,110,103,95,115,111,114,116,0,78,50,99,118,50,54,67,111,109,112,117,116,101,75,101,121,112,111,105,110,116,79,114,105,101,110,116,97,116,105,111,110,69,0,78,50,99,118,50,50,70,105,110,100,75,101,121,112,111,105,110,116,115,83,97,109,101,83,99,97,108,101,69,0,67,111,109,112,117,116,101,95,68,101,115,99,114,105,112,116,111,114,115,0,99,104,97,110,110,101,108,115,32,60,61,32,109,97,120,95,99,104,97,110,110,101,108,115,0,71,101,116,95,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,0,40,112,97,116,116,101,114,110,95,115,105,122,101,32,38,32,49,41,32,61,61,32,48,0,99,111,111,114,100,115,91,48,93,32,62,61,32,48,32,38,38,32,99,111,111,114,100,115,91,48,93,32,60,32,51,0,100,105,118,85,112,40,100,101,115,99,114,105,112,116,111,114,66,105,116,115,95,46,114,111,119,115,44,32,56,41,32,61,61,32,100,101,115,99,95,115,105,122,101,0,78,50,99,118,51,48,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,95,73,110,118,111,107,101,114,69,0,111,112,116,105,111,110,115,95,45,62,100,101,115,99,114,105,112,116,111,114,95,99,104,97,110,110,101,108,115,32,60,61,32,109,97,120,95,99,104,97,110,110,101,108,115,0,71,101,116,95,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,0,100,112,111,115,32,61,61,32,52,56,54,0,100,105,118,85,112,40,100,112,111,115,44,32,56,41,32,61,61,32,100,101,115,99,95,115,105,122,101,0,115,105,122,101,32,61,61,32,76,120,46,115,105,122,101,40,41,0,77,76,68,66,95,70,105,108,108,95,86,97,108,117,101,115,0,115,105,122,101,32,61,61,32,76,121,46,115,105,122,101,40,41,0,78,50,99,118,50,56,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,71,101,116,95,85,112,114,105,103,104,116,95,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,0,78,50,99,118,51,56,85,112,114,105,103,104,116,95,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,95,73,110,118,111,107,101,114,69,0,111,112,116,105,111,110,115,46,100,101,115,99,114,105,112,116,111,114,95,99,104,97,110,110,101,108,115,32,60,61,32,109,97,120,95,99,104,97,110,110,101,108,115,0,71,101,116,95,85,112,114,105,103,104,116,95,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,0,100,99,111,117,110,116,49,32,60,61,32,100,101,115,99,95,115,105,122,101,42,56,0,100,105,118,85,112,40,100,99,111,117,110,116,49,44,32,56,41,32,61,61,32,100,101,115,99,95,115,105,122,101,0,78,50,99,118,51,54,85,112,114,105,103,104,116,95,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,100,101,115,99,95,115,105,122,101,32,61,61,32,100,115,105,122,101,0,71,101,116,95,77,83,85,82,70,95,68,101,115,99,114,105,112,116,111,114,95,54,52,0,78,50,99,118,50,55,77,83,85,82,70,95,68,101,115,99,114,105,112,116,111,114,95,54,52,95,73,110,118,111,107,101,114,69,0,71,101,116,95,77,83,85,82,70,95,85,112,114,105,103,104,116,95,68,101,115,99,114,105,112,116,111,114,95,54,52,0,78,50,99,118,51,53,77,83,85,82,70,95,85,112,114,105,103,104,116,95,68,101,115,99,114,105,112,116,111,114,95,54,52,95,73,110,118,111,107,101,114,69,0,46,75,65,90,69,0,78,50,99,118,52,75,65,90,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,75,65,90,69,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,33,32,105,109,103,49,95,51,50,46,101,109,112,116,121,40,41,0,100,101,116,101,99,116,65,110,100,67,111,109,112,117,116,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,46,99,112,112,0,40,33,100,101,115,99,46,114,111,119,115,32,124,124,32,100,101,115,99,46,99,111,108,115,32,61,61,32,100,101,115,99,114,105,112,116,111,114,83,105,122,101,40,41,41,0,40,33,100,101,115,99,46,114,111,119,115,32,124,124,32,40,100,101,115,99,46,116,121,112,101,40,41,32,61,61,32,100,101,115,99,114,105,112,116,111,114,84,121,112,101,40,41,41,41,0,101,120,116,101,110,100,101,100,0,117,112,114,105,103,104,116,0,111,99,116,97,118,101,115,0,115,117,98,108,101,118,101,108,115,0,100,105,102,102,117,115,105,118,105,116,121,0,78,50,99,118,57,75,65,90,69,95,73,109,112,108,69,0,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,85,77,97,116,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,85,77,97,116,86,101,99,116,111,114,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,77,97,116,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,77,97,116,86,101,99,116,111,114,40,41,0,97,100,100,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,109,97,116,99,104,101,114,115,46,99,112,112,0,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,95,113,117,101,114,121,68,101,115,99,114,105,112,116,111,114,115,46,116,121,112,101,40,41,32,61,61,32,116,114,97,105,110,68,101,115,99,84,121,112,101,0,114,97,100,105,117,115,77,97,116,99,104,73,109,112,108,0,107,110,110,77,97,116,99,104,73,109,112,108,0,40,105,110,116,54,52,41,105,109,103,67,111,117,110,116,42,73,77,71,73,68,88,95,79,78,69,32,60,32,73,78,84,95,77,65,88,0,116,114,97,105,110,68,101,115,99,67,111,108,108,101,99,116,105,111,110,91,105,73,100,120,93,46,114,111,119,115,32,60,32,73,77,71,73,68,88,95,79,78,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,66,70,77,97,116,99,104,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,107,110,110,77,97,116,99,104,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,49,0,99,111,110,118,101,114,116,77,97,116,99,104,101,115,0,109,97,115,107,115,46,115,105,122,101,40,41,32,61,61,32,105,109,97,103,101,67,111,117,110,116,0,99,104,101,99,107,77,97,115,107,115,0,109,97,115,107,115,91,105,93,46,114,111,119,115,32,61,61,32,113,117,101,114,121,68,101,115,99,114,105,112,116,111,114,115,67,111,117,110,116,32,38,38,32,109,97,115,107,115,91,105,93,46,99,111,108,115,32,61,61,32,114,111,119,115,32,38,38,32,109,97,115,107,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,107,110,110,32,62,32,48,0,107,110,110,77,97,116,99,104,0,109,97,120,68,105,115,116,97,110,99,101,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,102,108,111,97,116,62,58,58,101,112,115,105,108,111,110,40,41,0,114,97,100,105,117,115,77,97,116,99,104,0,66,114,117,116,101,70,111,114,99,101,0,66,114,117,116,101,70,111,114,99,101,45,83,76,50,0,66,114,117,116,101,70,111,114,99,101,45,76,49,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,76,85,84,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,40,50,41,0,85,110,107,110,111,119,110,32,109,97,116,99,104,101,114,32,110,97,109,101,0,99,114,101,97,116,101,0,109,97,107,101,65,103,97,115,116,79,102,102,115,101,116,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,97,103,97,115,116,95,115,99,111,114,101,46,99,112,112,0,46,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,53,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,50,53,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,46,77,83,69,82,0,78,50,99,118,52,77,83,69,82,69,0,73,110,112,117,116,32,105,109,97,103,101,32,105,115,32,116,111,111,32,115,109,97,108,108,46,32,69,120,112,101,99,116,101,100,32,97,116,32,108,101,97,115,116,32,51,120,51,0,100,101,116,101,99,116,82,101,103,105,111,110,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,109,115,101,114,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,52,0,112,116,114,111,102,115,32,33,61,32,48,0,112,97,115,115,0,104,32,33,61,32,78,85,76,76,0,103,114,111,119,72,105,115,116,111,114,121,0,78,50,99,118,57,77,83,69,82,95,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,77,83,69,82,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,112,105,120,101,108,32,38,38,32,111,102,102,115,101,116,115,0,109,97,107,101,79,102,102,115,101,116,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,97,115,116,95,115,99,111,114,101,46,99,112,112,0,78,50,99,118,50,51,78,108,100,95,83,116,101,112,95,83,99,97,108,97,114,95,73,110,118,111,107,101,114,69,0,101,118,111,108,117,116,105,111,110,95,46,115,105,122,101,40,41,32,62,32,48,0,67,114,101,97,116,101,95,78,111,110,108,105,110,101,97,114,95,83,99,97,108,101,95,83,112,97,99,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,47,75,65,90,69,70,101,97,116,117,114,101,115,46,99,112,112,0,78,50,99,118,51,50,77,117,108,116,105,115,99,97,108,101,68,101,114,105,118,97,116,105,118,101,115,75,65,90,69,73,110,118,111,107,101,114,69,0,78,50,99,118,50,51,70,105,110,100,69,120,116,114,101,109,117,109,75,65,90,69,73,110,118,111,107,101,114,69,0,48,32,60,61,32,107,112,116,115,91,105,93,46,99,108,97,115,115,95,105,100,32,38,38,32,107,112,116,115,91,105,93,46,99,108,97,115,115,95,105,100,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,101,118,111,108,117,116,105,111,110,95,46,115,105,122,101,40,41,41,0,70,101,97,116,117,114,101,95,68,101,115,99,114,105,112,116,105,111,110,0,78,50,99,118,50,51,75,65,90,69,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,57,83,99,97,108,101,68,97,116,97,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,69,0,115,113,115,117,109,46,117,32,61,61,32,117,32,38,38,32,115,113,115,117,109,46,115,105,122,101,40,41,32,61,61,32,115,46,115,122,105,32,38,38,32,115,113,115,117,109,46,116,121,112,101,40,41,61,61,67,86,95,51,50,83,0,99,111,109,112,117,116,101,67,104,97,110,110,101,108,115,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,99,112,112,0,48,32,60,61,32,115,99,97,108,101,73,100,120,32,38,38,32,115,99,97,108,101,73,100,120,32,60,32,40,105,110,116,41,115,99,97,108,101,68,97,116,97,45,62,115,105,122,101,40,41,0,103,101,116,83,99,97,108,101,68,97,116,97,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,104,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,110,32,62,32,48,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,0,115,101,116,87,105,110,100,111,119,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,114,101,99,116,0,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,95,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,0,110,111,100,101,115,91,114,111,111,116,93,91,80,65,82,69,78,84,93,32,60,32,48,0,112,97,114,116,105,116,105,111,110,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,111,112,101,114,97,116,105,111,110,115,46,104,112,112,0,33,99,97,115,99,97,100,101,46,100,97,116,97,46,115,116,117,109,112,115,46,101,109,112,116,121,40,41,0,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,83,116,117,109,112,0,112,114,101,100,105,99,116,79,114,100,101,114,101,100,83,116,117,109,112,0,78,50,99,118,50,52,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,110,118,111,107,101,114,69,0,33,95,115,101,113,32,124,124,32,95,115,101,113,45,62,101,108,101,109,95,115,105,122,101,32,61,61,32,115,105,122,101,111,102,40,95,84,112,41,0,83,101,113,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,99,111,114,101,95,99,46,104,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,50,51,67,118,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,102,101,97,116,117,114,101,115,0,115,116,97,103,101,84,121,112,101,0,66,79,79,83,84,0,102,101,97,116,117,114,101,84,121,112,101,0,72,65,65,82,0,76,66,80,0,72,79,71,0,72,79,71,32,99,97,115,99,97,100,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,51,46,48,0,119,105,100,116,104,0,104,101,105,103,104,116,0,111,114,105,103,87,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,111,114,105,103,87,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,48,0,102,101,97,116,117,114,101,80,97,114,97,109,115,0,109,97,120,67,97,116,67,111,117,110,116,0,115,116,97,103,101,84,104,114,101,115,104,111,108,100,0,119,101,97,107,67,108,97,115,115,105,102,105,101,114,115,0,105,110,116,101,114,110,97,108,78,111,100,101,115,0,108,101,97,102,86,97,108,117,101,115,0,78,50,99,118,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,0,78,50,99,118,50,49,66,97,115,101,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,97,45,62,115,105,122,101,40,41,32,61,61,32,110,0,99,108,105,112,79,98,106,101,99,116,115,0,98,45,62,115,105,122,101,40,41,32,61,61,32,110,0,111,112,101,110,99,118,45,104,97,97,114,45,99,108,97,115,115,105,102,105,101,114,0,78,117,109,98,101,114,32,111,102,32,115,116,97,103,101,115,32,115,104,111,117,108,100,32,98,101,32,112,111,115,105,116,105,118,101,0,105,99,118,67,114,101,97,116,101,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,97,97,114,46,99,112,112,0,115,105,122,101,0,115,116,97,103,101,115,0,115,116,97,103,101,32,37,100,0,116,114,101,101,115,0,116,114,101,101,32,37,100,0,110,111,100,101,32,37,100,0,114,111,111,116,32,110,111,100,101,0,102,101,97,116,117,114,101,0,114,101,99,116,115,0,116,105,108,116,101,100,0,116,104,114,101,115,104,111,108,100,0,108,101,102,116,95,110,111,100,101,0,108,101,102,116,95,118,97,108,0,114,105,103,104,116,95,110,111,100,101,0,114,105,103,104,116,95,118,97,108,0,115,116,97,103,101,95,116,104,114,101,115,104,111,108,100,0,112,97,114,101,110,116,0,110,101,120,116,0,73,110,118,97,108,105,100,32,115,116,97,103,101,115,32,110,111,100,101,0,105,99,118,82,101,97,100,72,97,97,114,67,108,97,115,115,105,102,105,101,114,0,115,105,122,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,0,73,110,118,97,108,105,100,32,115,105,122,101,32,110,111,100,101,58,32,119,105,100,116,104,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,0,73,110,118,97,108,105,100,32,115,105,122,101,32,110,111,100,101,58,32,104,101,105,103,104,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,0,73,110,118,97,108,105,100,32,115,116,97,103,101,32,37,100,0,84,114,101,101,115,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,41,0,84,114,101,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,84,114,101,101,32,110,111,100,101,32,37,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,112,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,70,101,97,116,117,114,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,112,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,82,101,99,116,115,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,82,101,99,116,32,37,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,120,32,99,111,111,114,100,105,110,97,116,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,121,32,99,111,111,114,100,105,110,97,116,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,119,105,100,116,104,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,32,97,110,100,32,40,120,32,43,32,119,105,100,116,104,41,32,109,117,115,116,32,110,111,116,32,101,120,99,101,101,100,32,119,105,110,100,111,119,32,119,105,100,116,104,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,104,101,105,103,104,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,32,97,110,100,32,40,121,32,43,32,104,101,105,103,104,116,41,32,109,117,115,116,32,110,111,116,32,101,120,99,101,101,100,32,119,105,110,100,111,119,32,104,101,105,103,104,116,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,119,101,105,103,104,116,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,116,105,108,116,101,100,32,109,117,115,116,32,98,101,32,48,32,111,114,32,49,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,110,111,100,101,32,109,117,115,116,32,98,101,32,118,97,108,105,100,32,110,111,100,101,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,110,111,100,101,32,111,114,32,108,101,102,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,84,114,101,101,32,115,116,114,117,99,116,117,114,101,32,105,115,32,98,114,111,107,101,110,58,32,116,111,111,32,109,97,110,121,32,118,97,108,117,101,115,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,110,111,100,101,32,109,117,115,116,32,98,101,32,118,97,108,105,100,32,110,111,100,101,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,110,111,100,101,32,111,114,32,114,105,103,104,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,84,114,101,101,32,115,116,114,117,99,116,117,114,101,32,105,115,32,98,114,111,107,101,110,58,32,116,111,111,32,102,101,119,32,118,97,108,117,101,115,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,115,116,97,103,101,32,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,112,97,114,101,110,116,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,110,101,120,116,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,73,110,118,97,108,105,100,32,99,108,97,115,115,105,102,105,101,114,32,112,111,105,110,116,101,114,0,99,118,83,101,116,73,109,97,103,101,115,70,111,114,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,83,99,97,108,101,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,108,108,32,105,110,116,101,103,114,97,108,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,79,110,108,121,32,40,51,50,115,44,32,54,52,102,44,32,51,50,115,41,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,40,115,117,109,44,115,113,115,117,109,44,116,105,108,116,101,100,95,115,117,109,41,32,102,111,114,109,97,116,115,32,105,115,32,97,108,108,111,119,101,100,0,83,117,109,32,97,110,100,32,116,105,108,116,101,100,95,115,117,109,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,116,114,105,100,101,32,40,115,116,101,112,44,32,119,105,100,116,104,83,116,101,112,41,0,97,114,101,97,48,32,62,32,48,0,105,99,118,67,114,101,97,116,101,72,105,100,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,104,105,100,95,99,97,115,99,97,100,101,32,104,97,115,32,98,101,101,110,32,97,108,114,101,97,100,121,32,99,114,101,97,116,101,100,0,78,101,103,97,116,105,118,101,32,110,117,109,98,101,114,32,111,102,32,99,97,115,99,97,100,101,32,115,116,97,103,101,115,0,104,101,97,100,101,114,32,111,102,32,116,104,101,32,115,116,97,103,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,105,115,32,105,110,118,97,108,105,100,32,40,104,97,115,32,110,117,108,108,32,112,111,105,110,116,101,114,115,32,111,114,32,110,111,110,45,112,111,115,105,116,105,118,101,32,99,108,97,115,115,102,105,101,114,32,99,111,117,110,116,41,0,114,101,99,116,97,110,103,108,101,32,35,37,100,32,111,102,32,116,104,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,111,102,32,116,104,101,32,115,116,97,103,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,105,115,32,110,111,116,32,105,110,115,105,100,101,32,116,104,101,32,114,101,102,101,114,101,110,99,101,32,40,111,114,105,103,105,110,97,108,41,32,99,97,115,99,97,100,101,32,119,105,110,100,111,119,0,73,110,118,97,108,105,100,32,99,97,115,99,97,100,101,32,112,111,105,110,116,101,114,0,99,118,82,117,110,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,83,117,109,0,72,105,100,100,101,110,32,99,97,115,99,97,100,101,32,104,97,115,32,110,111,116,32,98,101,101,110,32,99,114,101,97,116,101,100,46,10,85,115,101,32,99,118,83,101,116,73,109,97,103,101,115,70,111,114,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,73,110,118,97,108,105,100,32,99,108,97,115,115,105,102,105,101,114,32,99,97,115,99,97,100,101,0,99,118,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,70,111,114,82,79,67,0,78,117,108,108,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,79,110,108,121,32,56,45,98,105,116,32,105,109,97,103,101,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,115,99,97,108,101,32,102,97,99,116,111,114,32,109,117,115,116,32,98,101,32,62,32,49,0,78,50,99,118,51,56,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,67,97,115,99,97,100,101,95,73,110,118,111,107,101,114,69,0,78,50,99,118,51,54,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,73,109,97,103,101,95,73,110,118,111,107,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,53,67,118,77,97,116,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,56,72,79,71,67,97,99,104,101,69,0,78,50,99,118,49,52,72,79,71,67,111,110,102,73,110,118,111,107,101,114,69,0,112,116,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,66,108,111,99,107,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,111,103,46,99,112,112,0,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,32,37,32,99,101,108,108,83,105,122,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,32,37,32,99,101,108,108,83,105,122,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,68,101,115,99,114,105,112,116,111,114,83,105,122,101,0,40,119,105,110,83,105,122,101,46,119,105,100,116,104,32,45,32,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,41,32,37,32,98,108,111,99,107,83,116,114],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+460800);allocate([105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,40,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,45,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,32,124,124,32,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,0,99,111,109,112,117,116,101,71,114,97,100,105,101,110,116,0,40,117,110,115,105,103,110,101,100,41,104,105,100,120,32,60,32,40,117,110,115,105,103,110,101,100,41,110,98,105,110,115,0,114,101,99,116,76,105,115,116,46,115,105,122,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,115,105,122,101,40,41,0,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,0,78,50,99,118,49,48,72,79,71,73,110,118,111,107,101,114,69,0,112,116,48,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,48,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,100,101,116,101,99,116,0,123,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,119,105,110,83,105,122,101,0,98,108,111,99,107,83,105,122,101,0,98,108,111,99,107,83,116,114,105,100,101,0,110,98,105,110,115,0,78,111,32,101,108,101,109,101,110,116,32,110,97,109,101,32,104,97,115,32,98,101,101,110,32,103,105,118,101,110,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,101,114,115,105,115,116,101,110,99,101,46,104,112,112,0,100,101,114,105,118,65,112,101,114,116,117,114,101,0,104,105,115,116,111,103,114,97,109,78,111,114,109,84,121,112,101,0,76,50,72,121,115,84,104,114,101,115,104,111,108,100,0,103,97,109,109,97,67,111,114,114,101,99,116,105,111,110,0,110,108,101,118,101,108,115,0,115,105,103,110,101,100,71,114,97,100,105,101,110,116,0,83,86,77,68,101,116,101,99,116,111,114,0,33,111,98,106,91,34,119,105,110,83,105,122,101,34,93,46,101,109,112,116,121,40,41,0,114,101,97,100,0,99,101,108,108,83,105,122,101,0,119,105,110,83,105,103,109,97,0,99,104,101,99,107,68,101,116,101,99,116,111,114,83,105,122,101,40,41,0,115,101,116,83,86,77,68,101,116,101,99,116,111,114,0,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,97,114,101,110,97,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,105,110,95,98,121,116,101,115,41,32,60,61,32,40,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,115,105,122,101,95,116,62,58,58,109,97,120,40,41,32,45,32,107,72,101,97,100,101,114,83,105,122,101,41,58,32,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,103,101,110,101,114,97,116,101,100,95,109,101,115,115,97,103,101,95,117,116,105,108,46,99,99,0,78,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,102,105,101,108,100,32,110,117,109,98,101,114,32,0,32,119,105,116,104,32,116,121,112,101,32,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,99,111,100,101,100,95,115,116,114,101,97,109,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,117,102,102,101,114,95,115,105,122,101,41,32,62,61,32,40,48,41,58,32,0,65,32,112,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,119,97,115,32,114,101,106,101,99,116,101,100,32,98,101,99,97,117,115,101,32,105,116,32,119,97,115,32,116,111,111,32,98,105,103,32,40,109,111,114,101,32,116,104,97,110,32,0,32,98,121,116,101,115,41,46,32,32,84,111,32,105,110,99,114,101,97,115,101,32,116,104,101,32,108,105,109,105,116,32,40,111,114,32,116,111,32,100,105,115,97,98,108,101,32,116,104,101,115,101,32,119,97,114,110,105,110,103,115,41,44,32,115,101,101,32,67,111,100,101,100,73,110,112,117,116,83,116,114,101,97,109,58,58,83,101,116,84,111,116,97,108,66,121,116,101,115,76,105,109,105,116,40,41,32,105,110,32,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,99,111,100,101,100,95,115,116,114,101,97,109,46,104,46,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,122,101,114,111,95,99,111,112,121,95,115,116,114,101,97,109,95,105,109,112,108,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,62,61,32,40,48,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,108,97,115,116,95,114,101,116,117,114,110,101,100,95,115,105,122,101,95,41,32,62,32,40,48,41,58,32,0,66,97,99,107,85,112,40,41,32,99,97,110,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,97,102,116,101,114,32,97,32,115,117,99,99,101,115,115,102,117,108,32,78,101,120,116,40,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,108,97,115,116,95,114,101,116,117,114,110,101,100,95,115,105,122,101,95,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,54,65,114,114,97,121,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,57,90,101,114,111,67,111,112,121,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,55,65,114,114,97,121,79,117,116,112,117,116,83,116,114,101,97,109,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,116,97,114,103,101,116,95,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,116,97,114,103,101,116,95,45,62,115,105,122,101,40,41,41,58,32,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,32,108,97,114,103,101,114,32,116,104,97,110,32,107,105,110,116,51,50,109,97,120,32,102,111,114,32,0,83,116,114,105,110,103,79,117,116,112,117,116,83,116,114,101,97,109,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,83,116,114,105,110,103,79,117,116,112,117,116,83,116,114,101,97,109,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,98,97,99,107,117,112,95,98,121,116,101,115,95,32,61,61,32,48,32,38,38,32,98,117,102,102,101,114,95,46,103,101,116,40,41,32,33,61,32,78,85,76,76,58,32,0,32,66,97,99,107,85,112,40,41,32,99,97,110,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,97,102,116,101,114,32,78,101,120,116,40,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,98,117,102,102,101,114,95,117,115,101,100,95,41,58,32,0,32,67,97,110,39,116,32,98,97,99,107,32,117,112,32,111,118,101,114,32,109,111,114,101,32,98,121,116,101,115,32,116,104,97,110,32,119,101,114,101,32,114,101,116,117,114,110,101,100,32,98,121,32,116,104,101,32,108,97,115,116,32,99,97,108,108,32,116,111,32,78,101,120,116,40,41,46,0,32,80,97,114,97,109,101,116,101,114,32,116,111,32,66,97,99,107,85,112,40,41,32,99,97,110,39,116,32,98,101,32,110,101,103,97,116,105,118,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,97,99,107,117,112,95,98,121,116,101,115,95,41,32,61,61,32,40,48,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,50,53,67,111,112,121,105,110,103,73,110,112,117,116,83,116,114,101,97,109,65,100,97,112,116,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,67,111,112,121,105,110,103,73,110,112,117,116,83,116,114,101,97,109,69,0,1,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,101,115,115,97,103,101,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,99,111,100,101,100,95,111,117,116,46,72,97,100,69,114,114,111,114,40,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,77,101,115,115,97,103,101,76,105,116,101,69,0,67,97,110,39,116,32,0,112,97,114,115,101,0,32,109,101,115,115,97,103,101,32,111,102,32,116,121,112,101,32,34,0,34,32,98,101,99,97,117,115,101,32,105,116,32,105,115,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,69,120,99,101,101,100,101,100,32,109,97,120,105,109,117,109,32,112,114,111,116,111,98,117,102,32,115,105,122,101,32,111,102,32,50,71,66,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,121,116,101,95,115,105,122,101,95,98,101,102,111,114,101,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,32,61,61,32,40,98,121,116,101,95,115,105,122,101,95,97,102,116,101,114,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,58,32,0,32,119,97,115,32,109,111,100,105,102,105,101,100,32,99,111,110,99,117,114,114,101,110,116,108,121,32,100,117,114,105,110,103,32,115,101,114,105,97,108,105,122,97,116,105,111,110,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,121,116,101,115,95,112,114,111,100,117,99,101,100,95,98,121,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,32,61,61,32,40,98,121,116,101,95,115,105,122,101,95,98,101,102,111,114,101,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,58,32,0,66,121,116,101,32,115,105,122,101,32,99,97,108,99,117,108,97,116,105,111,110,32,97,110,100,32,115,101,114,105,97,108,105,122,97,116,105,111,110,32,119,101,114,101,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,32,84,104,105,115,32,109,97,121,32,105,110,100,105,99,97,116,101,32,97,32,98,117,103,32,105,110,32,112,114,111,116,111,99,111,108,32,98,117,102,102,101,114,115,32,111,114,32,105,116,32,109,97,121,32,98,101,32,99,97,117,115,101,100,32,98,121,32,99,111,110,99,117,114,114,101,110,116,32,109,111,100,105,102,105,99,97,116,105,111,110,32,111,102,32,0,84,104,105,115,32,115,104,111,117,108,100,110,39,116,32,98,101,32,99,97,108,108,101,100,32,105,102,32,97,108,108,32,116,104,101,32,115,105,122,101,115,32,97,114,101,32,101,113,117,97,108,46,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,112,101,97,116,101,100,95,102,105,101,108,100,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,110,101,119,95,115,105,122,101,41,32,60,61,32,40,40,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,115,105,122,101,95,116,62,58,58,109,97,120,40,41,32,45,32,107,82,101,112,72,101,97,100,101,114,83,105,122,101,41,32,47,32,115,105,122,101,111,102,40,111,108,100,95,114,101,112,45,62,101,108,101,109,101,110,116,115,91,48,93,41,41,58,32,0,82,101,113,117,101,115,116,101,100,32,115,105,122,101,32,105,115,32,116,111,111,32,108,97,114,103,101,32,116,111,32,102,105,116,32,105,110,116,111,32,115,105,122,101,95,116,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,70,97,116,97,108,69,120,99,101,112,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,55,67,108,111,115,117,114,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,48,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,99,111,109,109,111,110,46,99,99,0,84,104,105,115,32,112,114,111,103,114,97,109,32,114,101,113,117,105,114,101,115,32,118,101,114,115,105,111,110,32,0,37,100,46,37,100,46,37,100,0,32,111,102,32,116,104,101,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,117,110,116,105,109,101,32,108,105,98,114,97,114,121,44,32,98,117,116,32,116,104,101,32,105,110,115,116,97,108,108,101,100,32,118,101,114,115,105,111,110,32,105,115,32,0,46,32,32,80,108,101,97,115,101,32,117,112,100,97,116,101,32,121,111,117,114,32,108,105,98,114,97,114,121,46,32,32,73,102,32,121,111,117,32,99,111,109,112,105,108,101,100,32,116,104,101,32,112,114,111,103,114,97,109,32,121,111,117,114,115,101,108,102,44,32,109,97,107,101,32,115,117,114,101,32,116,104,97,116,32,121,111,117,114,32,104,101,97,100,101,114,115,32,97,114,101,32,102,114,111,109,32,116,104,101,32,115,97,109,101,32,118,101,114,115,105,111,110,32,111,102,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,115,32,97,115,32,121,111,117,114,32,108,105,110,107,45,116,105,109,101,32,108,105,98,114,97,114,121,46,32,32,40,86,101,114,115,105,111,110,32,118,101,114,105,102,105,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,34,0,34,46,41,0,84,104,105,115,32,112,114,111,103,114,97,109,32,119,97,115,32,99,111,109,112,105,108,101,100,32,97,103,97,105,110,115,116,32,118,101,114,115,105,111,110,32,0,32,111,102,32,116,104,101,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,117,110,116,105,109,101,32,108,105,98,114,97,114,121,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,99,111,109,112,97,116,105,98,108,101,32,119,105,116,104,32,116,104,101,32,105,110,115,116,97,108,108,101,100,32,118,101,114,115,105,111,110,32,40,0,41,46,32,32,67,111,110,116,97,99,116,32,116,104,101,32,112,114,111,103,114,97,109,32,97,117,116,104,111,114,32,102,111,114,32,97,110,32,117,112,100,97,116,101,46,32,32,73,102,32,121,111,117,32,99,111,109,112,105,108,101,100,32,116,104,101,32,112,114,111,103,114,97,109,32,121,111,117,114,115,101,108,102,44,32,109,97,107,101,32,115,117,114,101,32,116,104,97,116,32,121,111,117,114,32,104,101,97,100,101,114,115,32,97,114,101,32,102,114,111,109,32,116,104,101,32,115,97,109,101,32,118,101,114,115,105,111,110,32,111,102,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,115,32,97,115,32,121,111,117,114,32,108,105,110,107,45,116,105,109,101,32,108,105,98,114,97,114,121,46,32,32,40,86,101,114,115,105,111,110,32,118,101,114,105,102,105,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,34,0,91,108,105,98,112,114,111,116,111,98,117,102,32,37,115,32,37,115,58,37,100,93,32,37,115,10,0,112,116,104,114,101,97,100,95,109,117,116,101,120,95,117,110,108,111,99,107,58,32,0,112,116,104,114,101,97,100,95,109,117,116,101,120,95,108,111,99,107,58,32,0,37,117,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,70,105,101,108,100,83,107,105,112,112,101,114,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,119,105,114,101,95,102,111,114,109,97,116,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,118,97,108,117,101,46,115,105,122,101,40,41,41,32,60,61,32,40,107,105,110,116,51,50,109,97,120,41,58,32,0,115,101,114,105,97,108,105,122,105,110,103,0,112,97,114,115,105,110,103,0,32,39,37,115,39,0,83,116,114,105,110,103,32,102,105,101,108,100,0,32,99,111,110,116,97,105,110,115,32,105,110,118,97,108,105,100,32,0,85,84,70,45,56,32,100,97,116,97,32,119,104,101,110,32,0,32,97,32,112,114,111,116,111,99,111,108,32,0,98,117,102,102,101,114,46,32,85,115,101,32,116,104,101,32,39,98,121,116,101,115,39,32,116,121,112,101,32,105,102,32,121,111,117,32,105,110,116,101,110,100,32,116,111,32,115,101,110,100,32,114,97,119,32,0,98,121,116,101,115,46,32,0,105,110,116,54,52,0,117,105,110,116,54,52,0,105,110,116,51,50,0,102,105,120,101,100,54,52,0,102,105,120,101,100,51,50,0,115,116,114,105,110,103,0,103,114,111,117,112,0,109,101,115,115,97,103,101,0,98,121,116,101,115,0,117,105,110,116,51,50,0,101,110,117,109,0,115,102,105,120,101,100,51,50,0,115,102,105,120,101,100,54,52,0,115,105,110,116,51,50,0,115,105,110,116,54,52,0,111,112,116,105,111,110,97,108,0,114,101,113,117,105,114,101,100,0,114,101,112,101,97,116,101,100,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,99,99,0,117,110,107,110,111,119,110,0,112,114,111,116,111,51,0,112,114,111,116,111,50,0,77,105,115,115,105,110,103,32,102,105,101,108,100,58,32,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,110,97,109,101,46,0,85,110,114,101,99,111,103,110,105,122,101,100,32,115,121,110,116,97,120,58,32,0,65,32,102,105,108,101,32,119,105,116,104,32,116,104,105,115,32,110,97,109,101,32,105,115,32,97,108,114,101,97,100,121,32,105,110,32,116,104,101,32,112,111,111,108,46,0,73,110,118,97,108,105,100,32,112,117,98,108,105,99,32,100,101,112,101,110,100,101,110,99,121,32,105,110,100,101,120,46,0,73,110,118,97,108,105,100,32,119,101,97,107,32,100,101,112,101,110,100,101,110,99,121,32,105,110,100,101,120,46,0,46,100,117,109,109,121,0,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,115,95,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,78,111,32,102,105,101,108,100,32,110,97,109,101,100,32,34,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,34,32,105,110,32,116,104,101,32,79,112,116,105,111,110,115,32,112,114,111,116,111,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,114,105,103,105,110,97,108,95,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,115,95,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,45,62,65,112,112,101,110,100,80,97,114,116,105,97,108,84,111,83,116,114,105,110,103,40,38,98,117,102,41,58,32,0,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,115,101,114,105,97,108,105,122,101,100,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,45,62,80,97,114,115,101,80,97,114,116,105,97,108,70,114,111,109,83,116,114,105,110,103,40,98,117,102,41,58,32,0,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,115,101,114,105,97,108,105,122,101,100,32,105,116,115,101,108,102,32,105,110,32,105,110,118,97,108,105,100,32,102,97,115,104,105,111,110,46,0,79,112,116,105,111,110,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,102,117,108,108,121,32,112,97,114,115,101,100,32,117,115,105,110,103,32,116,104,101,32,112,114,111,116,111,32,100,101,115,99,114,105,112,116,111,114,115,32,99,111,109,112,105,108,101,100,32,105,110,116,111,32,116,104,105,115,32,98,105,110,97,114,121,46,32,77,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,115,115,97,103,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,116,114,101,97,109,79,112,116,105,111,110,115,0,73,109,112,111,114,116,32,0,32,98,117,116,32,110,111,116,32,117,115,101,100,46,0,69,120,112,97,110,100,101,100,32,109,97,112,32,101,110,116,114,121,32,116,121,112,101,32,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,110,101,115,116,101,100,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,102,105,101,108,100,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,101,110,117,109,32,116,121,112,101,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,111,110,101,111,102,32,116,121,112,101,46,0,70,105,108,101,115,32,119,105,116,104,32,111,112,116,105,109,105,122,101,95,102,111,114,32,61,32,76,73,84,69,95,82,85,78,84,73,77,69,32,99,97,110,110,111,116,32,100,101,102,105,110,101,32,115,101,114,118,105,99,101,115,32,117,110,108,101,115,115,32,121,111,117,32,115,101,116,32,98,111,116,104,32,111,112,116,105,111,110,115,32,99,99,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,32,97,110,100,32,106,97,118,97,95,103,101,110,101,114,105,99,95,115,101,118,105,99,101,115,32,116,111,32,102,97,108,115,101,46,0,70,105,108,101,115,32,116,104,97,116,32,100,111,32,110,111,116,32,117,115,101,32,111,112,116,105,109,105,122,101,95,102,111,114,32,61,32,76,73,84,69,95,82,85,78,84,73,77,69,32,99,97,110,110,111,116,32,105,109,112,111,114,116,32,102,105,108,101,115,32,119,104,105,99,104,32,100,111,32,117,115,101,32,116,104,105,115,32,111,112,116,105,111,110,46,32,32,84,104,105,115,32,102,105,108,101,32,105,115,32,110,111,116,32,108,105,116,101,44,32,98,117,116,32,105,116,32,105,109,112,111,114,116,115,32,34,0,34,32,119,104,105,99,104,32,105,115,46,0,84,104,101,32,102,105,114,115,116,32,101,110,117,109,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,122,101,114,111,32,105,110,32,112,114,111,116,111,51,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,77,101,115,115,97,103,101,83,101,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,112,114,111,116,111,51,46,0,84,104,101,32,74,83,79,78,32,99,97,109,101,108,45,99,97,115,101,32,110,97,109,101,32,111,102,32,102,105,101,108,100,32,34,0,34,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,102,105,101,108,100,32,34,0,34,46,32,84,104,105,115,32,105,115,32,110,111,116,32,0,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,120,116,101,110,115,105,111,110,115,32,105,110,32,112,114,111,116,111,51,32,97,114,101,32,111,110,108,121,32,97,108,108,111,119,101,100,32,102,111,114,32,100,101,102,105,110,105,110,103,32,111,112,116,105,111,110,115,46,0,82,101,113,117,105,114,101,100,32,102,105,101,108,100,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,120,112,108,105,99,105,116,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,110,117,109,32,116,121,112,101,32,34,0,34,32,105,115,32,110,111,116,32,97,32,112,114,111,116,111,51,32,101,110,117,109,44,32,98,117,116,32,105,115,32,117,115,101,100,32,105,110,32,34,0,34,32,119,104,105,99,104,32,105,115,32,97,32,112,114,111,116,111,51,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,71,114,111,117,112,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,112,114,111,116,111,51,32,115,121,110,116,97,120,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,40,41,45,62,102,105,110,105,115,104,101,100,95,98,117,105,108,100,105,110,103,95,32,61,61,32,116,114,117,101,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,101,110,117,109,95,116,121,112,101,95,45,62,118,97,108,117,101,95,99,111,117,110,116,40,41,58,32,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,0,112,114,111,116,111,0,50,46,0,70,105,108,101,79,112,116,105,111,110,115,0,77,101,115,115,97,103,101,79,112,116,105,111,110,115,0,70,105,101,108,100,79,112,116,105,111,110,115,0,69,110,117,109,79,112,116,105,111,110,115,0,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,0,83,101,114,118,105,99,101,79,112,116,105,111,110,115,0,77,101,116,104,111,100,79,112,116,105,111,110,115,0,79,110,101,111,102,79,112,116,105,111,110,115,0,91,108,97,122,121,32,61,32,116,114,117,101,93,32,99,97,110,32,111,110,108,121,32,98,101,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,115,117,98,109,101,115,115,97,103,101,32,102,105,101,108,100,115,46,0,91,112,97,99,107,101,100,32,61,32,116,114,117,101,93,32,99,97,110,32,111,110,108,121,32,98,101,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,114,101,112,101,97,116,101,100,32,112,114,105,109,105,116,105,118,101,32,102,105,101,108,100,115,46,0,77,101,115,115,97,103,101,83,101,116,115,32,99,97,110,110,111,116,32,104,97,118,101,32,102,105,101,108,100,115,44,32,111,110,108,121,32,101,120,116,101,110,115,105,111,110,115,46,0,69,120,116,101,110,115,105,111,110,115,32,116,111,32,110,111,110,45,108,105,116,101,32,116,121,112,101,115,32,99,97,110,32,111,110,108,121,32,98,101,32,100,101,99,108,97,114,101,100,32,105,110,32,110,111,110,45,108,105,116,101,32,102,105,108,101,115,46,32,32,78,111,116,101,32,116,104,97,116,32,121,111,117,32,99,97,110,110,111,116,32,101,120,116,101,110,100,32,97,32,110,111,110,45,108,105,116,101,32,116,121,112,101,32,116,111,32,99,111,110,116,97,105,110,32,97,32,108,105,116,101,32,116,121,112,101,44,32,98,117,116,32,116,104,101,32,114,101,118,101,114,115,101,32,105,115,32,97,108,108,111,119,101,100,46,0,109,97,112,95,101,110,116,114,121,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,115,101,116,32,101,120,112,108,105,99,105,116,108,121,46,32,85,115,101,32,109,97,112,60,75,101,121,84,121,112,101,44,32,86,97,108,117,101,84,121,112,101,62,32,105,110,115,116,101,97,100,46,0,73,108,108,101,103,97,108,32,106,115,116,121,112,101,32,102,111,114,32,105,110,116,54,52,44,32,117,105,110,116,54,52,44,32,115,105,110,116,54,52,44,32,102,105,120,101,100,54,52,32,111,114,32,115,102,105,120,101,100,54,52,32,102,105,101,108,100,58,32,0,106,115,116,121,112,101,32,105,115,32,111,110,108,121,32,97,108,108,111,119,101,100,32,111,110,32,105,110,116,54,52,44,32,117,105,110,116,54,52,44,32,115,105,110,116,54,52,44,32,102,105,120,101,100,54,52,32,111,114,32,115,102,105,120,101,100,54,52,32,102,105,101,108,100,115,46,0,69,110,116,114,121,0,75,101,121,32,105,110,32,109,97,112,32,102,105,101,108,100,115,32,99,97,110,110,111,116,32,98,101,32,101,110,117,109,32,116,121,112,101,115,46,0,75,101,121,32,105,110,32,109,97,112,32,102,105,101,108,100,115,32,99,97,110,110,111,116,32,98,101,32,102,108,111,97,116,47,100,111,117,98,108,101,44,32,98,121,116,101,115,32,111,114,32,109,101,115,115,97,103,101,32,116,121,112,101,115,46,0,69,110,117,109,32,118,97,108,117,101,32,105,110,32,109,97,112,32,109,117,115,116,32,100,101,102,105,110,101,32,48,32,97,115,32,116,104,101,32,102,105,114,115,116,32,118,97,108,117,101,46,0,34,32,117,115,101,115,32,116,104,101,32,115,97,109,101,32,101,110,117,109,32,118,97,108,117,101,32,97,115,32,34,0,34,46,32,73,102,32,116,104,105,115,32,105,115,32,105,110,116,101,110,100,101,100,44,32,115,101,116,32,39,111,112,116,105,111,110,32,97,108,108,111,119,95,97,108,105,97,115,32,61,32,116,114,117,101,59,39,32,116,111,32,116,104,101,32,101,110,117,109,32,100,101,102,105,110,105,116,105,111,110,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,115,32,99,97,110,110,111,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,36,48,46,0,79,112,116,105,111,110,32,109,117,115,116,32,104,97,118,101,32,97,32,110,97,109,101,46,0,79,112,116,105,111,110,32,109,117,115,116,32,110,111,116,32,117,115,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,32,34,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,34,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,95,100,101,115,99,114,105,112,116,111,114,58,32,0,79,112,116,105,111,110,32,34,0,34,32,105,115,32,114,101,115,111,108,118,101,100,32,116,111,32,34,40,0,41,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,32,84,104,101,32,105,110,110,101,114,109,111,115,116,32,115,99,111,112,101,32,105,115,32,115,101,97,114,99,104,101,100,32,102,105,114,115,116,32,105,110,32,110,97,109,101,32,114,101,115,111,108,117,116,105,111,110,46,32,67,111,110,115,105,100,101,114,32,117,115,105,110,103,32,97,32,108,101,97,100,105,110,103,32,39,46,39,40,105,46,101,46,44,32,34,40,46,0,34,41,32,116,111,32,115,116,97,114,116,32,102,114,111,109,32,116,104,101,32,111,117,116,101,114,109,111,115,116,32,115,99,111,112,101,46,0,34,32,117,110,107,110,111,119,110,46,0,79,112,116,105,111,110,32,102,105,101,108,100,32,34,0,34,32,105,115,32,110,111,116,32,97,32,102,105,101,108,100,32,111,114,32,101,120,116,101,110,115,105,111,110,32,111,102,32,109,101,115,115,97,103,101,32,34,0,34,32,105,115,32,97,110,32,97,116,111,109,105,99,32,116,121,112,101,44,32,110,111,116,32,97,32,109,101,115,115,97,103,101,46,0,34,32,105,115,32,97,32,114,101,112,101,97,116,101,100,32,109,101,115,115,97,103,101,46,32,82,101,112,101,97,116,101,100,32,109,101,115,115,97,103,101,32,111,112,116,105,111,110,115,32,109,117,115,116,32,98,101,32,105,110,105,116,105,97,108,105,122,101,100,32,117,115,105,110,103,32,97,110,32,97,103,103,114,101,103,97,116,101,32,118,97,108,117,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,111,117,116,46,72,97,100,69,114,114,111,114,40,41,58,32,0,85,110,101,120,112,101,99,116,101,100,32,102,97,105,108,117,114,101,32,119,104,105,108,101,32,115,101,114,105,97,108,105,122,105,110,103,32,111,112,116,105,111,110,32,115,117,98,109,101,115,115,97,103,101,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,58,32,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,102,111,114,32,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,102,111,114,32,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,117,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,32,102,111,114,32,117,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,32,102,111,114,32,117,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,117,109,98,101,114,32,102,111,114,32,102,108,111,97,116,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,117,109,98,101,114,32,102,111,114,32,100,111,117,98,108,101,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,100,101,110,116,105,102,105,101,114,32,102,111,114,32,98,111,111,108,101,97,110,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,34,116,114,117,101,34,32,111,114,32,34,102,97,108,115,101,34,32,102,111,114,32,98,111,111,108,101,97,110,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,100,101,110,116,105,102,105,101,114,32,102,111,114,32,101,110,117,109,45,118,97,108,117,101,100,32,111,112,116,105,111,110,32,34,0,34,32,104,97,115,32,110,111,32,118,97,108,117,101,32,110,97,109,101,100,32,34,0,34,32,102,111,114,32,111,112,116,105,111,110,32,34,0,34,46,32,84,104,105,115,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,97,32,118,97,108,117,101,32,102,114,111,109,32,97,32,115,105,98,108,105,110,103,32,116,121,112,101,46,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,113,117,111,116,101,100,32,115,116,114,105,110,103,32,102,111,114,32,115,116,114,105,110,103,32,111,112,116,105,111,110,32,34,0,34,32,105,115,32,97,32,109,101,115,115,97,103,101,46,32,84,111,32,115,101,116,32,116,104,101,32,101,110,116,105,114,101,32,109,101,115,115,97,103,101,44,32,117,115,101,32,115,121,110,116,97,120,32,108,105,107,101,32,34,0,32,61,32,123,32,60,112,114,111,116,111,32,116,101,120,116,32,102,111,114,109,97,116,62,32,125,34,46,32,84,111,32,115,101,116,32,102,105,101,108,100,115,32,119,105,116,104,105,110,32,105,116,44,32,117,115,101,32,115,121,110,116,97,120,32,108,105,107,101,32,34,0,46,102,111,111,32,61,32,118,97,108,117,101,34,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,100,121,110,97,109,105,99,46,103,101,116,40,41,32,33,61,32,78,85,76,76,58,32,0,67,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,97,110,32,105,110,115,116,97,110,99,101,32,111,102,32,0,69,114,114,111,114,32,119,104,105,108,101,32,112,97,114,115,105,110,103,32,111,112,116,105,111,110,32,118,97,108,117,101,32,102,111,114,32,34,0,34,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,111,112,116,105,111,110,95,102,105,101,108,100,45,62,116,121,112,101,40,41,41,32,61,61,32,40,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,84,89,80,69,95,71,82,79,85,80,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,68,101,115,99,114,105,112,116,111,114,66,117,105,108,100,101,114,49,55,79,112,116,105,111,110,73,110,116,101,114,112,114,101,116,101,114,50,49,65,103,103,114,101,103,97,116,101,79,112,116,105,111,110,70,105,110,100,101,114,69,0,59,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,51,65,103,103,114,101,103,97,116,101,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,101,120,116,101,110,100,32,46,36,48,32,123,10,0,109,97,112,60,36,48,44,32,36,49,62,0,36,48,36,49,36,50,32,36,51,32,61,32,36,52,0,32,91,100,101,102,97,117,108,116,32,61,32,36,48,0,106,115,111,110,95,110,97,109,101,32,61,32,34,0,32,123,32,46,46,46,32,125,59,10,0,59,10,0,36,48,47,47,32,36,49,10,0,36,48,109,101,115,115,97,103,101,32,36,49,0,36,48,32,32,101,120,116,101,110,115,105,111,110,115,32,36,49,32,116,111,32,36,50,59,10,0,36,48,32,32,125,10,0,36,48,32,32,101,120,116,101,110,100,32,46,36,49,32,123,10,0,36,48,32,32,114,101,115,101,114,118,101,100,32,0,36,48,44,32,0,36,48,32,116,111,32,36,49,44,32,0,34,36,48,34,44,32,0,36,48,125,10,0,36,48,111,110,101,111,102,32,36,49,32,123,0,32,46,46,46,32,125,10,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,108,111,103,103,105,110,103,46,104,0,39,111,117,116,95,108,111,99,97,116,105,111,110,39,32,109,117,115,116,32,110,111,116,32,98,101,32,78,85,76,76,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,78,83,116,51,95,95,50,52,112,97,105,114,73,80,75,78,83,48,95,50,48,70,105,108,101,68,101,115,99,114,105,112,116,111,114,84,97,98,108,101,115,69,80,75,78,83,48,95,49,52,83,111,117,114,99,101,67,111,100,101,73,110,102,111,69,69,69,69,69,0,36,48,101,110,117,109,32,36,49,32,123,10,0,36,48,36,49,32,61,32,36,50,0,32,91,36,48,93,0,36,48,111,112,116,105,111,110,32,36,49,59,10,0,70,111,117,110,100,32,105,110,118,97,108,105,100,32,112,114,111,116,111,32,111,112,116,105],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+471040);allocate([111,110,32,100,97,116,97,32,102,111,114,58,32,0,123,10,0,40,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,104,97,115,95,100,101,102,97,117,108,116,95,118,97,108,117,101,40,41,58,32,0,78,111,32,100,101,102,97,117,108,116,32,118,97,108,117,101,0,77,101,115,115,97,103,101,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,33,0,67,97,110,39,116,32,103,101,116,32,104,101,114,101,58,32,102,97,105,108,101,100,32,116,111,32,103,101,116,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,97,115,32,115,116,114,105,110,103,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,85,73,78,84,54,52,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,85,73,78,84,51,50,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,73,78,84,54,52,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,73,78,84,51,50,58,32,0,34,32,119,97,115,32,97,108,114,101,97,100,121,32,115,101,116,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,46,112,108,97,99,101,104,111,108,100,101,114,46,112,114,111,116,111,0,80,76,65,67,69,72,79,76,68,69,82,95,86,65,76,85,69,0,46,80,76,65,67,69,72,79,76,68,69,82,95,86,65,76,85,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,98,117,105,108,100,101,114,95,58,32,0,34,32,105,115,32,110,111,116,32,97,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,110,97,109,101,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,111,110,99,101,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,102,105,108,101,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,100,101,115,99,114,105,112,116,111,114,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,32,38,38,32,102,105,108,101,45,62,112,111,111,108,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,45,62,112,111,111,108,95,45,62,108,97,122,105,108,121,95,98,117,105,108,100,95,100,101,112,101,110,100,101,110,99,105,101,115,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,102,105,108,101,45,62,102,105,110,105,115,104,101,100,95,98,117,105,108,100,105,110,103,95,58,32,0,34,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,0,34,32,115,101,101,109,115,32,116,111,32,98,101,32,100,101,102,105,110,101,100,32,105,110,32,34,0,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,105,109,112,111,114,116,101,100,32,98,121,32,34,0,34,46,32,32,84,111,32,117,115,101,32,105,116,32,104,101,114,101,44,32,112,108,101,97,115,101,32,97,100,100,32,116,104,101,32,110,101,99,101,115,115,97,114,121,32,105,109,112,111,114,116,46,0,34,32,105,115,32,114,101,115,111,108,118,101,100,32,116,111,32,34,0,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,32,84,104,101,32,105,110,110,101,114,109,111,115,116,32,115,99,111,112,101,32,105,115,32,115,101,97,114,99,104,101,100,32,102,105,114,115,116,32,105,110,32,110,97,109,101,32,114,101,115,111,108,117,116,105,111,110,46,32,67,111,110,115,105,100,101,114,32,117,115,105,110,103,32,97,32,108,101,97,100,105,110,103,32,39,46,39,40,105,46,101,46,44,32,34,46,0,34,36,48,34,32,100,111,101,115,32,110,111,116,32,100,101,99,108,97,114,101,32,36,49,32,97,115,32,97,110,32,101,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,46,0,70,105,101,108,100,115,32,111,102,32,111,110,101,111,102,115,32,109,117,115,116,32,116,104,101,109,115,101,108,118,101,115,32,104,97,118,101,32,108,97,98,101,108,32,76,65,66,69,76,95,79,80,84,73,79,78,65,76,46,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,109,112,116,121,0,34,32,105,115,32,110,111,116,32,97,32,116,121,112,101,46,0,77,101,115,115,97,103,101,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,46,0,34,32,105,115,32,110,111,116,32,97,110,32,101,110,117,109,32,116,121,112,101,46,0,68,101,102,97,117,108,116,32,118,97,108,117,101,32,102,111,114,32,97,110,32,101,110,117,109,32,102,105,101,108,100,32,109,117,115,116,32,98,101,32,97,110,32,105,100,101,110,116,105,102,105,101,114,46,0,70,105,101,108,100,32,119,105,116,104,32,112,114,105,109,105,116,105,118,101,32,116,121,112,101,32,104,97,115,32,116,121,112,101,95,110,97,109,101,46,0,70,105,101,108,100,32,119,105,116,104,32,109,101,115,115,97,103,101,32,111,114,32,101,110,117,109,32,116,121,112,101,32,109,105,115,115,105,110,103,32,116,121,112,101,95,110,97,109,101,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,101,120,116,101,110,115,105,111,110,32,34,36,50,34,46,0,70,105,101,108,100,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,102,105,101,108,100,32,34,36,50,34,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,101,120,116,101,110,115,105,111,110,32,34,36,50,34,32,100,101,102,105,110,101,100,32,105,110,32,36,51,46,0,70,105,101,108,100,115,32,105,110,32,116,104,101,32,115,97,109,101,32,111,110,101,111,102,32,109,117,115,116,32,98,101,32,100,101,102,105,110,101,100,32,99,111,110,115,101,99,117,116,105,118,101,108,121,46,32,34,36,48,34,32,99,97,110,110,111,116,32,98,101,32,100,101,102,105,110,101,100,32,98,101,102,111,114,101,32,116,104,101,32,99,111,109,112,108,101,116,105,111,110,32,111,102,32,116,104,101,32,34,36,49,34,32,111,110,101,111,102,32,100,101,102,105,110,105,116,105,111,110,46,0,79,110,101,111,102,32,109,117,115,116,32,104,97,118,101,32,97,116,32,108,101,97,115,116,32,111,110,101,32,102,105,101,108,100,46,0,77,101,115,115,97,103,101,32,101,120,116,101,110,115,105,111,110,115,32,99,97,110,110,111,116,32,104,97,118,101,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,46,0,82,101,112,101,97,116,101,100,32,102,105,101,108,100,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,46,0,66,111,111,108,101,97,110,32,100,101,102,97,117,108,116,32,109,117,115,116,32,98,101,32,116,114,117,101,32,111,114,32,102,97,108,115,101,46,0,67,111,117,108,100,110,39,116,32,112,97,114,115,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,34,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,99,97,110,110,111,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,36,48,46,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,36,48,32,116,104,114,111,117,103,104,32,36,49,32,97,114,101,32,114,101,115,101,114,118,101,100,32,102,111,114,32,116,104,101,32,112,114,111,116,111,99,111,108,32,98,117,102,102,101,114,32,108,105,98,114,97,114,121,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,101,120,116,101,110,100,101,101,32,110,111,116,32,115,101,116,32,102,111,114,32,101,120,116,101,110,115,105,111,110,32,102,105,101,108,100,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,111,110,101,111,102,95,105,110,100,101,120,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,115,101,116,32,102,111,114,32,101,120,116,101,110,115,105,111,110,115,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,101,120,116,101,110,100,101,101,32,115,101,116,32,102,111,114,32,110,111,110,45,101,120,116,101,110,115,105,111,110,32,102,105,101,108,100,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,111,110,101,111,102,95,105,110,100,101,120,32,36,48,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,116,121,112,101,32,34,36,49,34,46,0,34,32,110,111,116,32,112,114,101,118,105,111,117,115,108,121,32,100,101,102,105,110,101,100,32,105,110,32,115,121,109,98,111,108,115,95,98,121,95,110,97,109,101,95,44,32,98,117,116,32,119,97,115,32,100,101,102,105,110,101,100,32,105,110,32,115,121,109,98,111,108,115,95,98,121,95,112,97,114,101,110,116,95,59,32,116,104,105,115,32,115,104,111,117,108,100,110,39,116,32,98,101,32,112,111,115,115,105,98,108,101,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,34,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,102,105,108,101,32,34,0,77,105,115,115,105,110,103,32,110,97,109,101,46,0,34,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,105,100,101,110,116,105,102,105,101,114,46,0,69,110,117,109,115,32,109,117,115,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,111,110,101,32,118,97,108,117,101,46,0,82,101,115,101,114,118,101,100,32,114,97,110,103,101,32,101,110,100,32,110,117,109,98,101,114,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,115,116,97,114,116,32,110,117,109,98,101,114,46,0,82,101,115,101,114,118,101,100,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,97,108,114,101,97,100,121,45,100,101,102,105,110,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,69,110,117,109,32,118,97,108,117,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,69,110,117,109,32,118,97,108,117,101,32,34,36,48,34,32,117,115,101,115,32,114,101,115,101,114,118,101,100,32,110,117,109,98,101,114,32,36,49,46,0,69,110,117,109,32,118,97,108,117,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,46,0,87,104,101,110,32,101,110,117,109,32,110,97,109,101,32,105,115,32,115,116,114,105,112,112,101,100,32,97,110,100,32,108,97,98,101,108,32,105,115,32,80,97,115,99,97,108,67,97,115,101,100,32,40,0,41,44,32,116,104,105,115,32,118,97,108,117,101,32,108,97,98,101,108,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,0,46,32,84,104,105,115,32,119,105,108,108,32,109,97,107,101,32,116,104,101,32,112,114,111,116,111,32,102,97,105,108,32,116,111,32,99,111,109,112,105,108,101,32,102,111,114,32,115,111,109,101,32,108,97,110,103,117,97,103,101,115,44,32,115,117,99,104,32,97,115,32,67,35,46,0,116,104,101,32,103,108,111,98,97,108,32,115,99,111,112,101,0,78,111,116,101,32,116,104,97,116,32,101,110,117,109,32,118,97,108,117,101,115,32,117,115,101,32,67,43,43,32,115,99,111,112,105,110,103,32,114,117,108,101,115,44,32,109,101,97,110,105,110,103,32,116,104,97,116,32,101,110,117,109,32,118,97,108,117,101,115,32,97,114,101,32,115,105,98,108,105,110,103,115,32,111,102,32,116,104,101,105,114,32,116,121,112,101,44,32,110,111,116,32,99,104,105,108,100,114,101,110,32,111,102,32,105,116,46,32,32,84,104,101,114,101,102,111,114,101,44,32,34,0,34,32,109,117,115,116,32,98,101,32,117,110,105,113,117,101,32,119,105,116,104,105,110,32,0,44,32,110,111,116,32,106,117,115,116,32,119,105,116,104,105,110,32,34,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,101,110,100,32,110,117,109,98,101,114,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,115,116,97,114,116,32,110,117,109,98,101,114,46,0,82,101,115,101,114,118,101,100,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,70,105,101,108,100,32,110,97,109,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,105,110,99,108,117,100,101,115,32,102,105,101,108,100,32,34,36,50,34,32,40,36,51,41,46,0,70,105,101,108,100,32,34,36,48,34,32,117,115,101,115,32,114,101,115,101,114,118,101,100,32,110,117,109,98,101,114,32,36,49,46,0,70,105,101,108,100,32,110,97,109,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,114,101,115,101,114,118,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,97,108,114,101,97,100,121,45,100,101,102,105,110,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,110,105,115,104,101,100,95,98,117,105,108,100,105,110,103,95,32,61,61,32,116,114,117,101,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,75,78,83,48,95,49,52,70,105,108,101,68,101,115,99,114,105,112,116,111,114,69,69,69,0,73,109,112,111,114,116,32,34,0,34,32,104,97,115,32,110,111,116,32,98,101,101,110,32,108,111,97,100,101,100,46,0,34,32,119,97,115,32,110,111,116,32,102,111,117,110,100,32,111,114,32,104,97,100,32,101,114,114,111,114,115,46,0,34,32,119,97,115,32,108,105,115,116,101,100,32,116,119,105,99,101,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,40,97,115,32,115,111,109,101,116,104,105,110,103,32,111,116,104,101,114,32,116,104,97,110,32,97,32,112,97,99,107,97,103,101,41,32,105,110,32,102,105,108,101,32,34,0,73,110,118,97,108,105,100,32,112,114,111,116,111,32,100,101,115,99,114,105,112,116,111,114,32,102,111,114,32,102,105,108,101,32,34,0,34,58,0,32,32,0,70,105,108,101,32,114,101,99,117,114,115,105,118,101,108,121,32,105,109,112,111,114,116,115,32,105,116,115,101,108,102,58,32,0,32,45,62,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,95,45,62,102,105,110,105,115,104,101,100,95,98,117,105,108,100,105,110,103,95,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,78,83,49,95,49,52,76,97,122,121,68,101,115,99,114,105,112,116,111,114,69,69,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,103,101,110,101,114,97,116,101,100,95,100,97,116,97,98,97,115,101,95,45,62,65,100,100,40,101,110,99,111,100,101,100,95,102,105,108,101,95,100,101,115,99,114,105,112,116,111,114,44,32,115,105,122,101,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,75,78,83,48,95,50,48,70,105,108,101,68,101,115,99,114,105,112,116,111,114,84,97,98,108,101,115,69,69,69,0,85,78,75,78,79,87,78,95,69,78,85,77,95,86,65,76,85,69,95,37,115,95,37,100,0,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,114,111,116,111,0,10,32,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,114,111,116,111,18,15,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,34,71,10,17,70,105,108,101,68,101,115,99,114,105,112,116,111,114,83,101,116,18,50,10,4,102,105,108,101,24,1,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,34,219,3,10,19,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,15,10,7,112,97,99,107,97,103,101,24,2,32,1,40,9,18,18,10,10,100,101,112,101,110,100,101,110,99,121,24,3,32,3,40,9,18,25,10,17,112,117,98,108,105,99,95,100,101,112,101,110,100,101,110,99,121,24,10,32,3,40,5,18,23,10,15,119,101,97,107,95,100,101,112,101,110,100,101,110,99,121,24,11,32,3,40,5,18,54,10,12,109,101,115,115,97,103,101,95,116,121,112,101,24,4,32,3,40,11,50,32,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,55,10,9,101,110,117,109,95,116,121,112,101,24,5,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,7,115,101,114,118,105,99,101,24,6,32,3,40,11,50,39,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,9,101,120,116,101,110,115,105,111,110,24,7,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,45,10,7,111,112,116,105,111,110,115,24,8,32,1,40,11,50,28,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,18,57,10,16,115,111,117,114,99,101,95,99,111,100,101,95,105,110,102,111,24,9,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,111,117,114,99,101,67,111,100,101,73,110,102,111,18,14,10,6,115,121,110,116,97,120,24,12,32,1,40,9,34,169,5,10,15,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,52,10,5,102,105,101,108,100,24,2,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,9,101,120,116,101,110,115,105,111,110,24,6,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,53,10,11,110,101,115,116,101,100,95,116,121,112,101,24,3,32,3,40,11,50,32,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,55,10,9,101,110,117,109,95,116,121,112,101,24,4,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,72,10,15,101,120,116,101,110,115,105,111,110,95,114,97,110,103,101,24,5,32,3,40,11,50,47,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,69,120,116,101,110,115,105,111,110,82,97,110,103,101,18,57,10,10,111,110,101,111,102,95,100,101,99,108,24,8,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,48,10,7,111,112,116,105,111,110,115,24,7,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,115,115,97,103,101,79,112,116,105,111,110,115,18,70,10,14,114,101,115,101,114,118,101,100,95,114,97,110,103,101,24,9,32,3,40,11,50,46,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,82,101,115,101,114,118,101,100,82,97,110,103,101,18,21,10,13,114,101,115,101,114,118,101,100,95,110,97,109,101,24,10,32,3,40,9,26,101,10,14,69,120,116,101,110,115,105,111,110,82,97,110,103,101,18,13,10,5,115,116,97,114,116,24,1,32,1,40,5,18,11,10,3,101,110,100,24,2,32,1,40,5,18,55,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,38,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,120,116,101,110,115,105,111,110,82,97,110,103,101,79,112,116,105,111,110,115,26,43,10,13,82,101,115,101,114,118,101,100,82,97,110,103,101,18,13,10,5,115,116,97,114,116,24,1,32,1,40,5,18,11,10,3,101,110,100,24,2,32,1,40,5,34,103,10,21,69,120,116,101,110,115,105,111,110,82,97,110,103,101,79,112,116,105,111,110,115,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,188,5,10,20,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,14,10,6,110,117,109,98,101,114,24,3,32,1,40,5,18,58,10,5,108,97,98,101,108,24,4,32,1,40,14,50,43,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,76,97,98,101,108,18,56,10,4,116,121,112,101,24,5,32,1,40,14,50,42,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,84,121,112,101,18,17,10,9,116,121,112,101,95,110,97,109,101,24,6,32,1,40,9,18,16,10,8,101,120,116,101,110,100,101,101,24,2,32,1,40,9,18,21,10,13,100,101,102,97,117,108,116,95,118,97,108,117,101,24,7,32,1,40,9,18,19,10,11,111,110,101,111,102,95,105,110,100,101,120,24,9,32,1,40,5,18,17,10,9,106,115,111,110,95,110,97,109,101,24,10,32,1,40,9,18,46,10,7,111,112,116,105,111,110,115,24,8,32,1,40,11,50,29,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,34,182,2,10,4,84,121,112,101,18,15,10,11,84,89,80,69,95,68,79,85,66,76,69,16,1,18,14,10,10,84,89,80,69,95,70,76,79,65,84,16,2,18,14,10,10,84,89,80,69,95,73,78,84,54,52,16,3,18,15,10,11,84,89,80,69,95,85,73,78,84,54,52,16,4,18,14,10,10,84,89,80,69,95,73,78,84,51,50,16,5,18,16,10,12,84,89,80,69,95,70,73,88,69,68,54,52,16,6,18,16,10,12,84,89,80,69,95,70,73,88,69,68,51,50,16,7,18,13,10,9,84,89,80,69,95,66,79,79,76,16,8,18,15,10,11,84,89,80,69,95,83,84,82,73,78,71,16,9,18,14,10,10,84,89,80,69,95,71,82,79,85,80,16,10,18,16,10,12,84,89,80,69,95,77,69,83,83,65,71,69,16,11,18,14,10,10,84,89,80,69,95,66,89,84,69,83,16,12,18,15,10,11,84,89,80,69,95,85,73,78,84,51,50,16,13,18,13,10,9,84,89,80,69,95,69,78,85,77,16,14,18,17,10,13,84,89,80,69,95,83,70,73,88,69,68,51,50,16,15,18,17,10,13,84,89,80,69,95,83,70,73,88,69,68,54,52,16,16,18,15,10,11,84,89,80,69,95,83,73,78,84,51,50,16,17,18,15,10,11,84,89,80,69,95,83,73,78,84,54,52,16,18,34,67,10,5,76,97,98,101,108,18,18,10,14,76,65,66,69,76,95,79,80,84,73,79,78,65,76,16,1,18,18,10,14,76,65,66,69,76,95,82,69,81,85,73,82,69,68,16,2,18,18,10,14,76,65,66,69,76,95,82,69,80,69,65,84,69,68,16,3,34,84,10,20,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,46,10,7,111,112,116,105,111,110,115,24,2,32,1,40,11,50,29,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,79,110,101,111,102,79,112,116,105,111,110,115,34,164,2,10,19,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,56,10,5,118,97,108,117,101,24,2,32,3,40,11,50,41,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,45,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,28,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,79,112,116,105,111,110,115,18,78,10,14,114,101,115,101,114,118,101,100,95,114,97,110,103,101,24,4,32,3,40,11,50,54,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,69,110,117,109,82,101,115,101,114,118,101,100,82,97,110,103,101,18,21,10,13,114,101,115,101,114,118,101,100,95,110,97,109,101,24,5,32,3,40,9,26,47,10,17,69,110,117,109,82,101,115,101,114,118,101,100,82,97,110,103,101,18,13,10,5,115,116,97,114,116,24,1,32,1,40,5,18,11,10,3,101,110,100,24,2,32,1,40,5,34,108,10,24,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,14,10,6,110,117,109,98,101,114,24,2,32,1,40,5,18,50,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,33,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,34,144,1,10,22,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,54,10,6,109,101,116,104,111,100,24,2,32,3,40,11,50,38,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,48,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,79,112,116,105,111,110,115,34,193,1,10,21,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,18,10,10,105,110,112,117,116,95,116,121,112,101,24,2,32,1,40,9,18,19,10,11,111,117,116,112,117,116,95,116,121,112,101,24,3,32,1,40,9,18,47,10,7,111,112,116,105,111,110,115,24,4,32,1,40,11,50,30,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,79,112,116,105,111,110,115,18,31,10,16,99,108,105,101,110,116,95,115,116,114,101,97,109,105,110,103,24,5,32,1,40,8,58,5,102,97,108,115,101,18,31,10,16,115,101,114,118,101,114,95,115,116,114,101,97,109,105,110,103,24,6,32,1,40,8,58,5,102,97,108,115,101,34,240,5,10,11,70,105,108,101,79,112,116,105,111,110,115,18,20,10,12,106,97,118,97,95,112,97,99,107,97,103,101,24,1,32,1,40,9,18,28,10,20,106,97,118,97,95,111,117,116,101,114,95,99,108,97,115,115,110,97,109,101,24,8,32,1,40,9,18,34,10,19,106,97,118,97,95,109,117,108,116,105,112,108,101,95,102,105,108,101,115,24,10,32,1,40,8,58,5,102,97,108,115,101,18,41,10,29,106,97,118,97,95,103,101,110,101,114,97,116,101,95,101,113,117,97,108,115,95,97,110,100,95,104,97,115,104,24,20,32,1,40,8,66,2,24,1,18,37,10,22,106,97,118,97,95,115,116,114,105,110,103,95,99,104,101,99,107,95,117,116,102,56,24,27,32,1,40,8,58,5,102,97,108,115,101,18,70,10,12,111,112,116,105,109,105,122,101,95,102,111,114,24,9,32,1,40,14,50,41,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,46,79,112,116,105,109,105,122,101,77,111,100,101,58,5,83,80,69,69,68,18,18,10,10,103,111,95,112,97,99,107,97,103,101,24,11,32,1,40,9,18,34,10,19,99,99,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,16,32,1,40,8,58,5,102,97,108,115,101,18,36,10,21,106,97,118,97,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,17,32,1,40,8,58,5,102,97,108,115,101,18,34,10,19,112,121,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,18,32,1,40,8,58,5,102,97,108,115,101,18,35,10,20,112,104,112,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,42,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,23,32,1,40,8,58,5,102,97,108,115,101,18,31,10,16,99,99,95,101,110,97,98,108,101,95,97,114,101,110,97,115,24,31,32,1,40,8,58,5,102,97,108,115,101,18,25,10,17,111,98,106,99,95,99,108,97,115,115,95,112,114,101,102,105,120,24,36,32,1,40,9,18,24,10,16,99,115,104,97,114,112,95,110,97,109,101,115,112,97,99,101,24,37,32,1,40,9,18,20,10,12,115,119,105,102,116,95,112,114,101,102,105,120,24,39,32,1,40,9,18,24,10,16,112,104,112,95,99,108,97,115,115,95,112,114,101,102,105,120,24,40,32,1,40,9,18,21,10,13,112,104,112,95,110,97,109,101,115,112,97,99,101,24,41,32,1,40,9,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,34,58,10,12,79,112,116,105,109,105,122,101,77,111,100,101,18,9,10,5,83,80,69,69,68,16,1,18,13,10,9,67,79,68,69,95,83,73,90,69,16,2,18,16,10,12,76,73,84,69,95,82,85,78,84,73,77,69,16,3,42,9,8,232,7,16,128,128,128,128,2,74,4,8,38,16,39,34,242,1,10,14,77,101,115,115,97,103,101,79,112,116,105,111,110,115,18,38,10,23,109,101,115,115,97,103,101,95,115,101,116,95,119,105,114,101,95,102,111,114,109,97,116,24,1,32,1,40,8,58,5,102,97,108,115,101,18,46,10,31,110,111,95,115,116,97,110,100,97,114,100,95,100,101,115,99,114,105,112,116,111,114,95,97,99,99,101,115,115,111,114,24,2,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,17,10,9,109,97,112,95,101,110,116,114,121,24,7,32,1,40,8,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,74,4,8,8,16,9,74,4,8,9,16,10,34,158,3,10,12,70,105,101,108,100,79,112,116,105,111,110,115,18,58,10,5,99,116,121,112,101,24,1,32,1,40,14,50,35,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,46,67,84,121,112,101,58,6,83,84,82,73,78,71,18,14,10,6,112,97,99,107,101,100,24,2,32,1,40,8,18,63,10,6,106,115,116,121,112,101,24,6,32,1,40,14,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,46,74,83,84,121,112,101,58,9,74,83,95,78,79,82,77,65,76,18,19,10,4,108,97,122,121,24,5,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,19,10,4,119,101,97,107,24,10,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,34,47,10,5,67,84,121,112,101,18,10,10,6,83,84,82,73,78,71,16,0,18,8,10,4,67,79,82,68,16,1,18,16,10,12,83,84,82,73,78,71,95,80,73,69,67,69,16,2,34,53,10,6,74,83,84,121,112,101,18,13,10,9,74,83,95,78,79,82,77,65,76,16,0,18,13,10,9,74,83,95,83,84,82,73,78,71,16,1,18,13,10,9,74,83,95,78,85,77,66,69,82,16,2,42,9,8,232,7,16,128,128,128,128,2,74,4,8,4,16,5,34,94,10,12,79,110,101,111,102,79,112,116,105,111,110,115,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,147,1,10,11,69,110,117,109,79,112,116,105,111,110,115,18,19,10,11,97,108,108,111,119,95,97,108,105,97,115,24,2,32,1,40,8,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,74,4,8,5,16,6,34,125,10,16,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,1,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,123,10,14,83,101,114,118,105,99,101,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,33,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,173,2,10,13,77,101,116,104,111,100,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,33,32,1,40,8,58,5,102,97,108,115,101,18,95,10,17,105,100,101,109,112,111,116,101,110,99,121,95,108,101,118,101,108,24,34,32,1,40,14,50,47,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,79,112,116,105,111,110,115,46,73,100,101,109,112,111,116,101,110,99,121,76,101,118,101,108,58,19,73,68,69,77,80,79,84,69,78,67,89,95,85,78,75,78,79,87,78,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,34,80,10,16,73,100,101,109,112,111,116,101,110,99,121,76,101,118,101,108,18,23,10,19,73,68,69,77,80,79,84,69,78,67,89,95,85,78,75,78,79,87,78,16,0,18,19,10,15,78,79,95,83,73,68,69,95,69,70,70,69,67,84,83,16,1,18,14,10,10,73,68,69,77,80,79,84,69,78,84,16,2,42,9,8,232,7,16,128,128,128,128,2,34,158,2,10,19,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,18,59,10,4,110,97,109,101,24,2,32,3,40,11,50,45,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,46,78,97,109,101,80,97,114,116,18,24,10,16,105,100,101,110,116,105,102,105,101,114,95,118,97,108,117,101,24,3,32,1,40,9,18,26,10,18,112,111,115,105,116,105,118,101,95,105,110,116,95,118,97,108,117,101,24,4,32,1,40,4,18,26,10,18,110,101,103,97,116,105,118,101,95,105,110,116,95,118,97,108,117,101,24,5,32,1,40,3,18,20,10,12,100,111,117,98,108,101,95,118,97,108,117,101,24,6,32,1,40,1,18,20,10,12,115,116,114,105,110,103,95,118,97,108,117,101,24,7,32,1,40,12,18,23,10,15,97,103,103,114,101,103,97,116,101,95,118,97,108,117,101,24,8,32,1,40,9,26,51,10,8,78,97,109,101,80,97,114,116,18,17,10,9,110,97,109,101,95,112,97,114,116,24,1,32,2,40,9,18,20,10,12,105,115,95,101,120,116,101,110,115,105,111,110,24,2,32,2,40,8,34,213,1,10,14,83,111,117,114,99,101,67,111,100,101,73,110,102,111,18,58,10,8,108,111,99,97,116,105,111,110,24,1,32,3,40,11,50,40,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,111,117,114,99,101,67,111,100,101,73,110,102,111,46,76,111,99,97,116,105,111,110,26,134,1,10,8,76,111,99,97,116,105,111,110,18,16,10,4,112,97,116,104,24,1,32,3,40,5,66,2,16,1,18,16,10,4,115,112,97,110,24,2,32,3,40,5,66,2,16,1,18,24,10,16,108,101,97,100,105,110,103,95,99,111,109,109,101,110,116,115,24,3,32,1,40,9,18,25,10,17,116,114,97,105,108,105,110,103,95,99,111,109,109,101,110,116,115,24,4,32,1,40,9,18,33,10,25,108,101,97,100,105,110,103,95,100,101,116,97,99,104,101,100,95,99,111,109,109,101,110,116,115,24,6,32,3,40,9,34,167,1,10,17,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,18,65,10,10,97,110,110,111,116,97,116,105,111,110,24,1,32,3,40,11,50,45,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,46,65,110,110,111,116,97,116,105,111,110,26,79,10,10,65,110,110,111,116,97,116,105,111,110,18,16,10,4,112,97,116,104,24,1,32,3,40,5,66,2,16,1,18,19,10,11,115,111,117,114,99,101,95,102,105,108,101,24,2,32,1,40,9,18,13,10,5,98,101,103,105,110,24,3,32,1,40,5,18,11,10,3,101,110,100,24,4,32,1,40,5,66,143,1,10,19,99,111,109,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,66,16,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,115,72,1,90,62,103,105,116,104,117,98,46,99,111,109,47,103,111,108,97,110,103,47,112,114,111,116,111,98,117,102,47,112,114,111,116,111,99,45,103,101,110,45,103,111,47,100,101,115,99,114,105,112,116,111,114,59,100,101,115,99,114,105,112,116,111,114,248,1,1,162,2,3,71,80,66,170,2,26,71,111,111,103,108,101,46,80,114,111,116,111,98,117,102,46,82,101,102,108],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+481280);allocate([101,99,116,105,111,110,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,98,46,99,99,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,56,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,95,65,110,110,111,116,97,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,51,83,111,117,114,99,101,67,111,100,101,73,110,102,111,95,76,111,99,97,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,83,111,117,114,99,101,67,111,100,101,73,110,102,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,56,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,95,78,97,109,101,80,97,114,116,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,77,101,116,104,111,100,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,83,101,114,118,105,99,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,69,110,117,109,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,79,110,101,111,102,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,70,105,101,108,100,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,77,101,115,115,97,103,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,70,105,108,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,49,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,50,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,52,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,55,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,95,69,110,117,109,82,101,115,101,114,118,101,100,82,97,110,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,48,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,48,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,49,69,120,116,101,110,115,105,111,110,82,97,110,103,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,57,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,95,82,101,115,101,114,118,101,100,82,97,110,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,48,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,95,69,120,116,101,110,115,105,111,110,82,97,110,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,53,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,70,105,108,101,68,101,115,99,114,105,112,116,111,114,83,101,116,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,56,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,53,69,110,99,111,100,101,100,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,95,100,97,116,97,98,97,115,101,46,99,99,0,70,105,108,101,32,97,108,114,101,97,100,121,32,101,120,105,115,116,115,32,105,110,32,100,97,116,97,98,97,115,101,58,32,0,69,120,116,101,110,115,105,111,110,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,101,120,116,101,110,115,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,100,97,116,97,98,97,115,101,58,32,101,120,116,101,110,100,32,0,32,61,32,0,32,125,0,73,110,118,97,108,105,100,32,115,121,109,98,111,108,32,110,97,109,101,58,32,0,83,121,109,98,111,108,32,110,97,109,101,32,34,0,34,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,116,104,101,32,101,120,105,115,116,105,110,103,32,115,121,109,98,111,108,32,34,0,73,110,118,97,108,105,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,100,97,116,97,32,112,97,115,115,101,100,32,116,111,32,69,110,99,111,100,101,100,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,58,58,65,100,100,40,41,46,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,121,110,97,109,105,99,95,109,101,115,115,97,103,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,115,95,112,114,111,116,111,116,121,112,101,40,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,68,121,110,97,109,105,99,77,101,115,115,97,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,49,68,121,110,97,109,105,99,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,101,120,116,101,110,115,105,111,110,95,115,101,116,95,104,101,97,118,121,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,117,116,112,117,116,45,62,109,101,115,115,97,103,101,95,112,114,111,116,111,116,121,112,101,32,33,61,32,78,85,76,76,58,32,0,69,120,116,101,110,115,105,111,110,32,102,97,99,116,111,114,121,39,115,32,71,101,116,80,114,111,116,111,116,121,112,101,40,41,32,114,101,116,117,114,110,101,100,32,78,85,76,76,32,102,111,114,32,101,120,116,101,110,115,105,111,110,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,57,68,101,115,99,114,105,112,116,111,114,80,111,111,108,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,48,95,49,49,77,101,115,115,97,103,101,76,105,116,101,69,69,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,112,114,111,116,111,116,121,112,101,32,33,61,32,78,85,76,76,58,32,0,34,71,101,116,77,97,112,68,97,116,97,34,0,70,105,101,108,100,32,105,115,32,110,111,116,32,97,32,109,97,112,32,102,105,101,108,100,46,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,103,101,110,101,114,97,116,101,100,95,109,101,115,115,97,103,101,95,114,101,102,108,101,99,116,105,111,110,46,99,99,0,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,101,102,108,101,99,116,105,111,110,32,117,115,97,103,101,32,101,114,114,111,114,58,10,32,32,77,101,116,104,111,100,32,32,32,32,32,32,58,32,103,111,111,103,108,101,58,58,112,114,111,116,111,98,117,102,58,58,82,101,102,108,101,99,116,105,111,110,58,58,0,10,32,32,77,101,115,115,97,103,101,32,116,121,112,101,58,32,0,10,32,32,70,105,101,108,100,32,32,32,32,32,32,32,58,32,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,0,34,77,97,112,83,105,122,101,34,0,34,77,97,112,69,110,100,34,0,34,77,97,112,66,101,103,105,110,34,0,34,68,101,108,101,116,101,77,97,112,86,97,108,117,101,34,0,34,73,110,115,101,114,116,79,114,76,111,111,107,117,112,77,97,112,86,97,108,117,101,34,0,34,76,111,111,107,117,112,77,97,112,86,97,108,117,101,34,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,45,62,99,112,112,95,116,121,112,101,40,41,32,61,61,32,99,112,112,95,116,121,112,101,32,124,124,32,40,102,105,101,108,100,45,62,99,112,112,95,116,121,112,101,40,41,32,61,61,32,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,67,80,80,84,89,80,69,95,69,78,85,77,32,38,38,32,99,112,112,95,116,121,112,101,32,61,61,32,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,67,80,80,84,89,80,69,95,73,78,84,51,50,41,58,32,0,84,104,101,32,116,121,112,101,32,112,97,114,97,109,101,116,101,114,32,84,32,105,110,32,82,101,112,101,97,116,101,100,70,105,101,108,100,82,101,102,60,84,62,32,65,80,73,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,0,116,104,101,32,97,99,116,117,97,108,32,102,105,101,108,100,32,116,121,112,101,32,40,102,111,114,32,101,110,117,109,115,32,84,32,115,104,111,117,108,100,32,98,101,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,101,110,117,109,32,0,116,121,112,101,32,111,114,32,105,110,116,51,50,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,95,116,121,112,101,41,32,61,61,32,40,102,105,101,108,100,45,62,109,101,115,115,97,103,101,95,116,121,112,101,40,41,41,58,32,0,34,71,101,116,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,34,0,70,105,101,108,100,32,105,115,32,115,105,110,103,117,108,97,114,59,32,116,104,101,32,109,101,116,104,111,100,32,114,101,113,117,105,114,101,115,32,97,32,114,101,112,101,97,116,101,100,32,102,105,101,108,100,46,0,71,101,116,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,105,101,108,100,45,62,111,112,116,105,111,110,115,40,41,46,99,116,121,112,101,40,41,41,32,61,61,32,40,99,116,121,112,101,41,58,32,0,115,117,98,116,121,112,101,32,109,105,115,109,97,116,99,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,105,101,108,100,45,62,109,101,115,115,97,103,101,95,116,121,112,101,40,41,41,32,61,61,32,40,100,101,115,99,41,58,32,0,119,114,111,110,103,32,115,117,98,109,101,115,115,97,103,101,32,116,121,112,101,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,70,105,101,108,100,32,105,115,32,110,111,116,32,116,104,101,32,114,105,103,104,116,32,116,121,112,101,32,102,111,114,32,116,104,105,115,32,109,101,115,115,97,103,101,58,10,32,32,32,32,69,120,112,101,99,116,101,100,32,32,58,32,0,10,32,32,32,32,70,105,101,108,100,32,116,121,112,101,58,32,0,73,78,86,65,76,73,68,95,67,80,80,84,89,80,69,0,67,80,80,84,89,80,69,95,73,78,84,51,50,0,67,80,80,84,89,80,69,95,73,78,84,54,52,0,67,80,80,84,89,80,69,95,85,73,78,84,51,50,0,67,80,80,84,89,80,69,95,85,73,78,84,54,52,0,67,80,80,84,89,80,69,95,68,79,85,66,76,69,0,67,80,80,84,89,80,69,95,70,76,79,65,84,0,67,80,80,84,89,80,69,95,66,79,79,76,0,67,80,80,84,89,80,69,95,69,78,85,77,0,67,80,80,84,89,80,69,95,83,84,82,73,78,71,0,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,0,34,77,117,116,97,98,108,101,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,34,0,77,117,116,97,98,108,101,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,0,65,100,100,65,108,108,111,99,97,116,101,100,77,101,115,115,97,103,101,0,70,105,101,108,100,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,65,100,100,77,101,115,115,97,103,101,0,65,100,100,69,110,117,109,0,65,100,100,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,118,97,108,117,101,32,0,32,117,110,101,120,112,101,99,116,101,100,32,102,111,114,32,102,105,101,108,100,32,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,69,110,117,109,32,118,97,108,117,101,32,100,105,100,32,110,111,116,32,109,97,116,99,104,32,102,105,101,108,100,32,116,121,112,101,58,10,32,32,32,32,69,120,112,101,99,116,101,100,32,32,58,32,0,10,32,32,32,32,65,99,116,117,97,108,32,32,32,32,58,32,0,65,100,100,83,116,114,105,110,103,0,65,100,100,66,111,111,108,0,65,100,100,68,111,117,98,108,101,0,65,100,100,70,108,111,97,116,0,65,100,100,85,73,110,116,54,52,0,65,100,100,85,73,110,116,51,50,0,65,100,100,73,110,116,54,52,0,65,100,100,73,110,116,51,50,0,77,117,116,97,98,108,101,82,101,112,101,97,116,101,100,77,101,115,115,97,103,101,0,83,101,116,82,101,112,101,97,116,101,100,69,110,117,109,0,83,101,116,82,101,112,101,97,116,101,100,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,0,118,97,108,117,101,32,0,83,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,0,83,101,116,82,101,112,101,97,116,101,100,66,111,111,108,0,83,101,116,82,101,112,101,97,116,101,100,68,111,117,98,108,101,0,83,101,116,82,101,112,101,97,116,101,100,70,108,111,97,116,0,83,101,116,82,101,112,101,97,116,101,100,85,73,110,116,54,52,0,83,101,116,82,101,112,101,97,116,101,100,85,73,110,116,51,50,0,83,101,116,82,101,112,101,97,116,101,100,73,110,116,54,52,0,83,101,116,82,101,112,101,97,116,101,100,73,110,116,51,50,0,71,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,82,101,102,101,114,101,110,99,101,0,71,101,116,82,101,112,101,97,116,101,100,77,101,115,115,97,103,101,0,71,101,116,82,101,112,101,97,116,101,100,69,110,117,109,86,97,108,117,101,0,71,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,0,71,101,116,82,101,112,101,97,116,101,100,66,111,111,108,0,71,101,116,82,101,112,101,97,116,101,100,68,111,117,98,108,101,0,71,101,116,82,101,112,101,97,116,101,100,70,108,111,97,116,0,71,101,116,82,101,112,101,97,116,101,100,85,73,110,116,54,52,0,71,101,116,82,101,112,101,97,116,101,100,85,73,110,116,51,50,0,71,101,116,82,101,112,101,97,116,101,100,73,110,116,54,52,0,71,101,116,82,101,112,101,97,116,101,100,73,110,116,51,50,0,82,101,108,101,97,115,101,77,101,115,115,97,103,101,0,70,105,101,108,100,32,105,115,32,114,101,112,101,97,116,101,100,59,32,116,104,101,32,109,101,116,104,111,100,32,114,101,113,117,105,114,101,115,32,97,32,115,105,110,103,117,108,97,114,32,102,105,101,108,100,46,0,83,101,116,65,108,108,111,99,97,116,101,100,77,101,115,115,97,103,101,0,77,117,116,97,98,108,101,77,101,115,115,97,103,101,0,83,101,116,69,110,117,109,86,97,108,117,101,0,83,101,116,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,118,97,108,117,101,32,0,83,101,116,69,110,117,109,0,83,101,116,83,116,114,105,110,103,0,83,101,116,66,111,111,108,0,83,101,116,68,111,117,98,108,101,0,83,101,116,70,108,111,97,116,0,83,101,116,85,73,110,116,54,52,0,83,101,116,85,73,110,116,51,50,0,83,101,116,73,110,116,54,52,0,83,101,116,73,110,116,51,50,0,71,101,116,83,116,114,105,110,103,82,101,102,101,114,101,110,99,101,0,71,101,116,77,101,115,115,97,103,101,0,71,101,116,69,110,117,109,86,97,108,117,101,0,71,101,116,83,116,114,105,110,103,0,71,101,116,66,111,111,108,0,71,101,116,68,111,117,98,108,101,0,71,101,116,70,108,111,97,116,0,71,101,116,85,73,110,116,54,52,0,71,101,116,85,73,110,116,51,50,0,71,101,116,73,110,116,54,52,0,71,101,116,73,110,116,51,50,0,82,101,97,99,104,101,100,32,105,109,112,111,115,115,105,98,108,101,32,99,97,115,101,32,105,110,32,72,97,115,66,105,116,40,41,46,0,83,119,97,112,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,49,45,62,71,101,116,82,101,102,108,101,99,116,105,111,110,40,41,41,32,61,61,32,40,116,104,105,115,41,58,32,0,70,105,114,115,116,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,70,105,101,108,100,115,40,41,32,40,111,102,32,116,121,112,101,32,34,0,34,41,32,105,115,32,110,111,116,32,99,111,109,112,97,116,105,98,108,101,32,119,105,116,104,32,116,104,105,115,32,114,101,102,108,101,99,116,105,111,110,32,111,98,106,101,99,116,32,40,119,104,105,99,104,32,105,115,32,102,111,114,32,116,121,112,101,32,34,0,34,41,46,32,32,78,111,116,101,32,116,104,97,116,32,116,104,101,32,101,120,97,99,116,32,115,97,109,101,32,99,108,97,115,115,32,105,115,32,114,101,113,117,105,114,101,100,59,32,110,111,116,32,106,117,115,116,32,116,104,101,32,115,97,109,101,32,100,101,115,99,114,105,112,116,111,114,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,50,45,62,71,101,116,82,101,102,108,101,99,116,105,111,110,40,41,41,32,61,61,32,40,116,104,105,115,41,58,32,0,83,101,99,111,110,100,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,70,105,101,108,100,115,40,41,32,40,111,102,32,116,121,112,101,32,34,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,116,121,112,101,58,32,0,70,105,114,115,116,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,40,41,32,40,111,102,32,116,121,112,101,32,34,0,83,101,99,111,110,100,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,40,41,32,40,111,102,32,116,121,112,101,32,34,0,82,101,108,101,97,115,101,76,97,115,116,0,82,101,109,111,118,101,76,97,115,116,0,67,108,101,97,114,70,105,101,108,100,0,70,105,101,108,100,83,105,122,101,0,72,97,115,70,105,101,108,100,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,54,71,101,110,101,114,97,116,101,100,77,101,115,115,97,103,101,82,101,102,108,101,99,116,105,111,110,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,32,33,61,32,78,85,76,76,58,32,0,37,46,49,102,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,115,116,114,116,111,100,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,101,109,112,91,48,93,41,32,61,61,32,40,39,49,39,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,101,109,112,91,115,105,122,101,45,49,93,41,32,61,61,32,40,39,53,39,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,115,105,122,101,41,32,60,61,32,40,54,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,52,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,115,116,114,105,110,103,46,0,83,116,114,105,110,103,32,108,105,116,101,114,97,108,115,32,99,97,110,110,111,116,32,99,114,111,115,115,32,108,105,110,101,32,98,111,117,110,100,97,114,105,101,115,46,0,69,120,112,101,99,116,101,100,32,104,101,120,32,100,105,103,105,116,115,32,102,111,114,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,46,0,69,120,112,101,99,116,101,100,32,102,111,117,114,32,104,101,120,32,100,105,103,105,116,115,32,102,111,114,32,92,117,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,46,0,69,120,112,101,99,116,101,100,32,101,105,103,104,116,32,104,101,120,32,100,105,103,105,116,115,32,117,112,32,116,111,32,49,48,102,102,102,102,32,102,111,114,32,92,85,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,32,105,110,32,115,116,114,105,110,103,32,108,105,116,101,114,97,108,46,0,34,48,120,34,32,109,117,115,116,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,104,101,120,32,100,105,103,105,116,115,46,0,78,117,109,98,101,114,115,32,115,116,97,114,116,105,110,103,32,119,105,116,104,32,108,101,97,100,105,110,103,32,122,101,114,111,32,109,117,115,116,32,98,101,32,105,110,32,111,99,116,97,108,46,0,34,101,34,32,109,117,115,116,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,101,120,112,111,110,101,110,116,46,0,78,101,101,100,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,110,117,109,98,101,114,32,97,110,100,32,105,100,101,110,116,105,102,105,101,114,46,0,65,108,114,101,97,100,121,32,115,97,119,32,100,101,99,105,109,97,108,32,112,111,105,110,116,32,111,114,32,101,120,112,111,110,101,110,116,59,32,99,97,110,39,116,32,104,97,118,101,32,97,110,111,116,104,101,114,32,111,110,101,46,0,72,101,120,32,97,110,100,32,111,99,116,97,108,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,115,46,0,34,47,42,34,32,105,110,115,105,100,101,32,98,108,111,99,107,32,99,111,109,109,101,110,116,46,32,32,66,108,111,99,107,32,99,111,109,109,101,110,116,115,32,99,97,110,110,111,116,32,98,101,32,110,101,115,116,101,100,46,0,69,110,100,45,111,102,45,102,105,108,101,32,105,110,115,105,100,101,32,98,108,111,99,107,32,99,111,109,109,101,110,116,46,0,32,32,67,111,109,109,101,110,116,32,115,116,97,114,116,101,100,32,104,101,114,101,46,0,73,110,118,97,108,105,100,32,99,111,110,116,114,111,108,32,99,104,97,114,97,99,116,101,114,115,32,101,110,99,111,117,110,116,101,114,101,100,32,105,110,32,116,101,120,116,46,0,78,101,101,100,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,105,100,101,110,116,105,102,105,101,114,32,97,110,100,32,100,101,99,105,109,97,108,32,112,111,105,110,116,46,0,73,110,116,101,114,112,114,101,116,105,110,103,32,110,111,110,32,97,115,99,105,105,32,99,111,100,101,112,111,105,110,116,32,37,100,46,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,116,111,107,101,110,105,122,101,114,46,99,99,0,32,84,111,107,101,110,105,122,101,114,58,58,80,97,114,115,101,70,108,111,97,116,40,41,32,112,97,115,115,101,100,32,116,101,120,116,32,116,104,97,116,32,99,111,117,108,100,32,110,111,116,32,104,97,118,101,32,98,101,101,110,32,116,111,107,101,110,105,122,101,100,32,97,115,32,97,32,102,108,111,97,116,58,32,0,32,84,111,107,101,110,105,122,101,114,58,58,80,97,114,115,101,83,116,114,105,110,103,65,112,112,101,110,100,40,41,32,112,97,115,115,101,100,32,116,101,120,116,32,116,104,97,116,32,99,111,117,108,100,32,110,111,116,32,104,97,118,101,32,98,101,101,110,32,116,111,107,101,110,105,122,101,100,32,97,115,32,97,32,115,116,114,105,110,103,58,32,0,92,85,37,48,56,120,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,50,53,67,111,112,121,105,110,103,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,70,105,101,108,100,66,97,115,101,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,102,105,101,108,100,46,104,0,85,110,115,117,112,112,111,114,116,101,100,58,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,109,97,112,32,117,115,97,103,101,32,101,114,114,111,114,58,10,0,77,97,112,75,101,121,58,58,71,101,116,66,111,111,108,86,97,108,117,101,0,32,116,121,112,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,10,0,32,32,69,120,112,101,99,116,101,100,32,58,32,0,32,32,65,99,116,117,97,108,32,32,32,58,32,0,77,97,112,75,101,121,58,58,71,101,116,85,73,110,116,51,50,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,85,73,110,116,54,52,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,73,110,116,51,50,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,73,110,116,54,52,86,97,108,117,101,0,107,101,121,0,118,97,108,117,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,102,105,101,108,100,46,99,99,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,77,101,115,115,97,103,101,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,116,121,112,101,32,77,97,112,86,97,108,117,101,82,101,102,32,105,115,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,100,46,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,69,110,117,109,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,70,108,111,97,116,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,68,111,117,98,108,101,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,66,111,111,108,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,85,73,110,116,51,50,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,85,73,110,116,54,52,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,73,110,116,51,50,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,73,110,116,54,52,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,83,116,114,105,110,103,86,97,108,117,101,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,53,68,121,110,97,109,105,99,77,97,112,70,105,101,108,100,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,84,121,112,101,68,101,102,105,110,101,100,77,97,112,70,105,101,108,100,66,97,115,101,73,78,83,48,95,54,77,97,112,75,101,121,69,78,83,48,95,49,49,77,97,112,86,97,108,117,101,82,101,102,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,77,97,112,73,78,83,48,95,54,77,97,112,75,101,121,69,78,83,48,95,49,49,77,97,112,86,97,108,117,101,82,101,102,69,69,56,73,110,110,101,114,77,97,112,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,52,104,97,115,104,73,78,83,48,95,54,77,97,112,75,101,121,69,69,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,101,115,115,97,103,101,46,99,99,0,77,101,115,115,97,103,101,32,99,108,97,115,115,32,34,0,34,32,105,109,112,108,101,109,101,110,116,115,32,110,101,105,116,104,101,114,32,83,101,116,67,97,99,104,101,100,83,105,122,101,40,41,32,110,111,114,32,66,121,116,101,83,105,122,101,40,41,46,32,32,77,117,115,116,32,105,109,112,108,101,109,101,110,116,32,111,110,101,32,111,114,32,116,104,101,32,111,116,104,101,114,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,114,111,109,46,71,101,116,68,101,115,99,114,105,112,116,111,114,40,41,41,32,61,61,32,40,100,101,115,99,114,105,112,116,111,114,41,58,32,0,58,32,84,114,105,101,100,32,116,111,32,109,101,114,103,101,32,102,114,111,109,32,97,32,109,101,115,115,97,103,101,32,119,105,116,104,32,97,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,46,32,32,116,111,58,32,0,44,32,102,114,111,109,58,32,0,58,32,84,114,105,101,100,32,116,111,32,99,111,112,121,32,102,114,111,109,32,97,32,109,101,115,115,97,103,101,32,119,105,116,104,32,97,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,46,32,116,111,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,55,77,101,115,115,97,103,101,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,45,62,105,115,95,114,101,112,101,97,116,101,100,40,41,58,32,0,83,104,111,117,108,100,32,110,111,116,32,114,101,97,99,104,32,104,101,114,101,46,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,102,108,101,99,116,105,111,110,95,105,110,116,101,114,110,97,108,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,116,104,105,115,32,61,61,32,111,116,104,101,114,95,109,117,116,97,116,111,114,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,49,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,77,101,115,115,97,103,101,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,87,114,97,112,112,101,114,73,78,83,48,95,55,77,101,115,115,97,103,101,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,51,82,97,110,100,111,109,65,99,99,101,115,115,82,101,112,101,97,116,101,100,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,49,82,101,112,101,97,116,101,100,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,77,97,112,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,83,116,114,105,110,103,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,87,114,97,112,112,101,114,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,82,101,102,108,101,99,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,70,105,108,101,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,105,110,32,103,101,110,101,114,97,116,101,100,32,112,111,111,108,32,98,117,116,32,119,97,115,110,39,116,32,114,101,103,105,115,116,101,114,101,100,58,32,0,84,121,112,101,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,105,110,32,103,101,110,101,114,97,116,101,100,32,112,111,111,108,32,98,117,116,32,119,97,115,110,39,116,32,0,114,101,103,105,115,116,101,114,101,100,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,51,71,101,110,101,114,97,116,101,100,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,70,105,108,101,32,105,115,32,97,108,114,101,97,100,121,32,114,101,103,105,115,116,101,114,101,100,58,32,0,84,121,112,101,32,105,115,32,97,108,114,101,97,100,121,32,114,101,103,105,115,116,101,114,101,100,58,32,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,102,108,101,99,116,105,111,110,95,111,112,115,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,38,102,114,111,109,41,32,33,61,32,40,116,111,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,111,45,62,71,101,116,68,101,115,99,114,105,112,116,111,114,40,41,41,32,61,61,32,40,100,101,115,99,114,105,112,116,111,114,41,58,32,0,84,114,105,101,100,32,116,111,32,109,101,114,103,101,32,109,101,115,115,97,103,101,115,32,111,102,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,115,32,0,40,109,101,114,103,101,32,0,32,116,111,32,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,115,117,98,115,116,105,116,117,116,101,46,99,99,0,115,116,114,105,110,103,115,58,58,83,117,98,115,116,105,116,117,116,101,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,105,110,118,97,108,105,100,58,32,97,115,107,101,100,32,102,111,114,32,34,36,0,34,44,32,98,117,116,32,111,110,108,121,32,0,32,97,114,103,115,32,119,101,114,101,32,103,105,118,101,110,46,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+491520);allocate([32,70,117,108,108,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,119,97,115,58,32,34,0,73,110,118,97,108,105,100,32,115,116,114,105,110,103,115,58,58,83,117,98,115,116,105,116,117,116,101,40,41,32,102,111,114,109,97,116,32,115,116,114,105,110,103,58,32,34,0,125,32,0,125,10,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,49,55,66,97,115,101,84,101,120,116,71,101,110,101,114,97,116,111,114,69,0,32,123,32,0,32,123,10,0,91,0,34,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,50,49,70,97,115,116,70,105,101,108,100,86,97,108,117,101,80,114,105,110,116,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,54,70,105,110,100,101,114,69,0,10,0,58,32,48,120,0,58,32,34,0,34,32,0,34,10,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,116,101,120,116,95,102,111,114,109,97,116,46,99,99,0,32,79,117,116,100,101,110,116,40,41,32,119,105,116,104,111,117,116,32,109,97,116,99,104,105,110,103,32,73,110,100,101,110,116,40,41,46,0,46,46,46,60,116,114,117,110,99,97,116,101,100,62,46,46,46,0,37,100,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,121,110,97,109,105,99,95,109,101,115,115,97,103,101,46,104,0,58,32,91,0,93,10,0,80,114,111,116,111,32,116,121,112,101,32,0,32,110,111,116,32,102,111,117,110,100,0,58,32,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,99,111,110,116,101,110,116,115,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,55,80,114,105,110,116,101,114,49,51,84,101,120,116,71,101,110,101,114,97,116,111,114,69,0,77,101,115,115,97,103,101,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,69,114,114,111,114,32,112,97,114,115,105,110,103,32,116,101,120,116,45,102,111,114,109,97,116,32,0,58,0,78,111,110,45,114,101,112,101,97,116,101,100,32,65,110,121,32,115,112,101,99,105,102,105,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,69,120,116,101,110,115,105,111,110,32,34,0,34,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,32,111,114,32,105,115,32,110,111,116,32,97,110,32,101,120,116,101,110,115,105,111,110,32,111,102,32,34,0,34,46,0,77,101,115,115,97,103,101,32,116,121,112,101,32,34,0,34,32,104,97,115,32,110,111,32,102,105,101,108,100,32,110,97,109,101,100,32,34,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,97,108,108,111,119,95,117,110,107,110,111,119,110,95,102,105,101,108,100,95,32,124,124,32,114,101,115,101,114,118,101,100,95,102,105,101,108,100,58,32,0,78,111,110,45,114,101,112,101,97,116,101,100,32,102,105,101,108,100,32,34,0,34,32,105,115,32,115,112,101,99,105,102,105,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,70,105,101,108,100,32,34,0,34,32,105,115,32,115,112,101,99,105,102,105,101,100,32,97,108,111,110,103,32,119,105,116,104,32,102,105,101,108,100,32,34,0,34,44,32,97,110,111,116,104,101,114,32,109,101,109,98,101,114,32,111,102,32,111,110,101,111,102,32,34,0,116,101,120,116,32,102,111,114,109,97,116,32,99,111,110,116,97,105,110,115,32,100,101,112,114,101,99,97,116,101,100,32,102,105,101,108,100,32,34,0,84,114,117,101,0,116,0,70,97,108,115,101,0,102,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,98,111,111,108,101,97,110,32,102,105,101,108,100,32,34,0,34,46,32,86,97,108,117,101,58,32,34,0,69,120,112,101,99,116,101,100,32,105,110,116,101,103,101,114,32,111,114,32,105,100,101,110,116,105,102,105,101,114,44,32,103,111,116,58,32,0,85,110,107,110,111,119,110,32,101,110,117,109,101,114,97,116,105,111,110,32,118,97,108,117,101,32,111,102,32,34,0,34,32,102,111,114,32,102,105,101,108,100,32,34,0,82,101,97,99,104,101,100,32,97,110,32,117,110,105,110,116,101,110,100,101,100,32,115,116,97,116,101,58,32,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,0,69,120,112,101,99,116,101,100,32,100,111,117,98,108,101,44,32,103,111,116,58,32,0,69,120,112,101,99,116,101,100,32,105,110,116,101,103,101,114,44,32,103,111,116,58,32,0,69,120,112,101,99,116,32,97,32,100,101,99,105,109,97,108,32,110,117,109,98,101,114,44,32,103,111,116,58,32,0,73,110,116,101,103,101,114,32,111,117,116,32,111,102,32,114,97,110,103,101,32,40,0,125,0,69,120,112,101,99,116,101,100,32,115,116,114,105,110,103,44,32,103,111,116,58,32,0,73,110,118,97,108,105,100,32,102,108,111,97,116,32,110,117,109,98,101,114,58,32,0,69,120,112,101,99,116,101,100,32,105,100,101,110,116,105,102,105,101,114,44,32,103,111,116,58,32,0,87,97,114,110,105,110,103,32,112,97,114,115,105,110,103,32,116,101,120,116,45,102,111,114,109,97,116,32,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,116,121,112,101,32,34,0,34,32,115,116,111,114,101,100,32,105,110,32,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,46,0,86,97,108,117,101,32,111,102,32,116,121,112,101,32,34,0,34,32,115,116,111,114,101,100,32,105,110,32,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,32,104,97,115,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,0,69,120,112,101,99,116,101,100,32,34,0,34,44,32,102,111,117,110,100,32,34,0,84,101,120,116,70,111,114,109,97,116,58,58,80,97,114,115,101,114,32,102,111,114,32,65,110,121,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,116,121,112,101,46,103,111,111,103,108,101,97,112,105,115,46,99,111,109,32,97,110,100,32,116,121,112,101,46,103,111,111,103,108,101,112,114,111,100,46,99,111,109,44,32,98,117,116,32,102,111,117,110,100,32,34,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,54,80,97,114,115,101,114,49,48,80,97,114,115,101,114,73,109,112,108,50,48,80,97,114,115,101,114,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,55,85,110,107,110,111,119,110,70,105,101,108,100,83,101,116,70,105,101,108,100,83,107,105,112,112,101,114,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,119,105,114,101,95,102,111,114,109,97,116,46,99,99,0,69,120,116,101,110,115,105,111,110,115,32,111,102,32,77,101,115,115,97,103,101,83,101,116,115,32,109,117,115,116,32,98,101,32,111,112,116,105,111,110,97,108,32,109,101,115,115,97,103,101,115,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,111,117,116,112,117,116,45,62,66,121,116,101,67,111,117,110,116,40,41,41,32,61,61,32,40,101,120,112,101,99,116,101,100,95,101,110,100,112,111,105,110,116,41,58,32,0,58,32,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,115,101,114,105,97,108,105,122,101,100,32,116,111,32,97,32,115,105,122,101,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,119,104,97,116,32,119,97,115,32,111,114,105,103,105,110,97,108,108,121,32,101,120,112,101,99,116,101,100,46,32,32,80,101,114,104,97,112,115,32,105,116,32,119,97,115,32,109,111,100,105,102,105,101,100,32,98,121,32,97,110,111,116,104,101,114,32,116,104,114,101,97,100,32,100,117,114,105,110,103,32,115,101,114,105,97,108,105,122,97,116,105,111,110,63,0,85,110,115,117,112,112,111,114,116,101,100,0,67,97,110,110,111,116,32,103,101,116,32,104,101,114,101,0,73,110,118,97,108,105,100,32,107,101,121,32,102,111,114,32,109,97,112,32,102,105,101,108,100,46,0,97,108,108,111,99,97,116,111,114,60,84,62,58,58,97,108,108,111,99,97,116,101,40,115,105,122,101,95,116,32,110,41,32,39,110,39,32,101,120,99,101,101,100,115,32,109,97,120,105,109,117,109,32,115,117,112,112,111,114,116,101,100,32,115,105,122,101,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,53,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,52,71,101,110,101,114,97,116,101,100,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,101,120,116,101,110,115,105,111,110,95,115,101,116,46,99,99,0,67,97,110,39,116,32,103,101,116,32,104,101,114,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,116,101,114,32,33,61,32,101,120,116,101,110,115,105,111,110,115,95,46,101,110,100,40,41,58,32,0,73,110,100,101,120,32,111,117,116,45,111,102,45,98,111,117,110,100,115,32,40,102,105,101,108,100,32,105,115,32,101,109,112,116,121,41,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,99,97,110,39,116,32,114,101,97,99,104,32,104,101,114,101,46,0,78,111,110,45,112,114,105,109,105,116,105,118,101,32,116,121,112,101,115,32,99,97,110,39,116,32,98,101,32,112,97,99,107,101,100,46,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,122,101,114,111,95,99,111,112,121,95,115,116,114,101,97,109,46,99,99,0,84,104,105,115,32,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,97,108,105,97,115,105,110,103,46,32,82,101,97,99,104,105,110,103,32,104,101,114,101,32,117,115,117,97,108,108,121,32,109,101,97,110,115,32,97,32,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,32,98,117,103,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,50,48,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,3,3,3,3,3,3,3,3,3,3,3,3,7,3,3,4,5,5,5,6,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,4,4,4,4,4,4,4,4,2,2,4,4,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0,48,48,48,49,48,50,48,51,48,52,48,53,48,54,48,55,48,56,48,57,49,48,49,49,49,50,49,51,49,52,49,53,49,54,49,55,49,56,49,57,50,48,50,49,50,50,50,51,50,52,50,53,50,54,50,55,50,56,50,57,51,48,51,49,51,50,51,51,51,52,51,53,51,54,51,55,51,56,51,57,52,48,52,49,52,50,52,51,52,52,52,53,52,54,52,55,52,56,52,57,53,48,53,49,53,50,53,51,53,52,53,53,53,54,53,55,53,56,53,57,54,48,54,49,54,50,54,51,54,52,54,53,54,54,54,55,54,56,54,57,55,48,55,49,55,50,55,51,55,52,55,53,55,54,55,55,55,56,55,57,56,48,56,49,56,50,56,51,56,52,56,53,56,54,56,55,56,56,56,57,57,48,57,49,57,50,57,51,57,52,57,53,57,54,57,55,57,56,57,57,45,105,110,102,0,37,46,42,103,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,0,116,121,112,101,46,103,111,111,103,108,101,97,112,105,115,46,99,111,109,47,0,116,121,112,101,46,103,111,111,103,108,101,112,114,111,100,46,99,111,109,47,0,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,115,114,99,49,46,99,111,108,115,32,61,61,32,115,114,99,50,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,56,85,41,0,95,110,105,100,120,46,110,101,101,100,101,100,40,41,32,61,61,32,40,75,32,62,32,48,41,0,40,116,121,112,101,32,61,61,32,67,86,95,56,85,32,38,38,32,100,116,121,112,101,32,61,61,32,67,86,95,51,50,83,41,32,124,124,32,100,116,121,112,101,32,61,61,32,67,86,95,51,50,70,0,75,32,61,61,32,49,32,38,38,32,117,112,100,97,116,101,32,61,61,32,48,32,38,38,32,109,97,115,107,46,101,109,112,116,121,40,41,0,33,110,105,100,120,46,101,109,112,116,121,40,41,0,84,104,101,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,116,121,112,101,61,37,100,44,32,100,116,121,112,101,61,37,100,32,97,110,100,32,110,111,114,109,84,121,112,101,61,37,100,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,49,54,66,97,116,99,104,68,105,115,116,73,110,118,111,107,101,114,69,0,98,97,116,99,104,68,105,115,116,97,110,99,101,0,47,98,117,105,108,100,47,51,95,52,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,98,97,116,99,104,95,100,105,115,116,97,110,99,101,46,99,112,112,0,79,80,69,78,67,86,95,76,79,71,95,76,69,86,69,76,0,87,65,82,78,73,78,71,0,68,73,83,65,66,76,69,68,0,100,105,115,97,98,108,101,100,0,48,0,79,70,70,0,111,102,102,0,70,65,84,65,76,0,102,97,116,97,108,0,69,82,82,79,82,0,101,114,114,111,114,0,119,97,114,110,105,110,103,0,87,65,82,78,73,78,71,83,0,119,97,114,110,105,110,103,115,0,87,65,82,78,0,119,97,114,110,0,73,78,70,79,0,105,110,102,111,0,68,69,66,85,71,0,100,101,98,117,103,0,86,69,82,66,79,83,69,0,118,101,114,98,111,115,101,0,69,82,82,79,82,58,32,85,110,101,120,112,101,99,116,101,100,32,108,111,103,103,105,110,103,32,108,101,118,101,108,32,118,97,108,117,101,58,32,0,91,70,65,84,65,76,58,0,93,32,0,91,69,82,82,79,82,58,0,91,32,87,65,82,78,58,0,91,32,73,78,70,79,58,0,91,68,69,66,85,71,58,0,8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,115,0,37,115,37,115,37,115,0,58,32,0,117,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,102,105,108,101,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,105,110,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,32,101,114,114,111,114,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,100,101,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,49,46,50,46,49,49,0,105,110,99,111,114,114,101,99,116,32,104,101,97,100,101,114,32,99,104,101,99,107,0,117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,0,105,110,118,97,108,105,100,32,119,105,110,100,111,119,32,115,105,122,101,0,117,110,107,110,111,119,110,32,104,101,97,100,101,114,32,102,108,97,103,115,32,115,101,116,0,104,101,97,100,101,114,32,99,114,99,32,109,105,115,109,97,116,99,104,0,105,110,118,97,108,105,100,32,98,108,111,99,107,32,116,121,112,101,0,105,110,118,97,108,105,100,32,115,116,111,114,101,100,32,98,108,111,99,107,32,108,101,110,103,116,104,115,0,116,111,111,32,109,97,110,121,32,108,101,110,103,116,104,32,111,114,32,100,105,115,116,97,110,99,101,32,115,121,109,98,111,108,115,0,105,110,118,97,108,105,100,32,99,111,100,101,32,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,98,105,116,32,108,101,110,103,116,104,32,114,101,112,101,97,116,0,105,110,118,97,108,105,100,32,99,111,100,101,32,45,45,32,109,105,115,115,105,110,103,32,101,110,100,45,111,102,45,98,108,111,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,115,32,115,101,116,0,105,110,99,111,114,114,101,99,116,32,100,97,116,97,32,99,104,101,99,107,0,105,110,99,111,114,114,101,99,116,32,108,101,110,103,116,104,32,99,104,101,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,110,101,101,100,32,100,105,99,116,105,111,110,97,114,121,0,115,116,114,101,97,109,32,101,110,100,0,102,105,108,101,32,101,114,114,111,114,0,115,116,114,101,97,109,32,101,114,114,111,114,0,100,97,116,97,32,101,114,114,111,114,0,105,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,98,117,102,102,101,114,32,101,114,114,111,114,0,105,110,99,111,109,112,97,116,105,98,108,101,32,118,101,114,115,105,111,110,0,0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0,0,16,17,18,18,19,19,20,20,20,20,21,21,21,21,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,0,1,2,3,4,5,6,7,8,8,9,9,10,10,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,16,16,16,16,17,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,115,116,100,58,58,119,115,116,114,105,110,103,0,101,109,115,99,114,105,112,116,101,110,58,58,118,97,108,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,102,108,111,97,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,100,111,117,98,108,101,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,32,100,111,117,98,108,101,62,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,101,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,109,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,108,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,106,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,97,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,104,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,104,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,45,43,32,32,32,48,88,48,120,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,78,65,78,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+501760);allocate([70,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,105,110,102,105,110,105,116,121,0,110,97,110,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,114,119,97,0,76,67,95,65,76,76,0,76,67,95,67,84,89,80,69,0,0,0,0,76,67,95,78,85,77,69,82,73,67,0,0,76,67,95,84,73,77,69,0,0,0,0,0,76,67,95,67,79,76,76,65,84,69,0,0,76,67,95,77,79,78,69,84,65,82,89,0,76,67,95,77,69,83,83,65,71,69,83,0,76,65,78,71,0,67,46,85,84,70,45,56,0,80,79,83,73,88,0,77,85,83,76,95,76,79,67,80,65,84,72,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,52,98,97,115,105,99,95,105,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,99,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,119,69,69,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,37,112,0,67,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,37,112,0,0,0,0,76,0,37,0,0,0,0,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,37,72,58,37,77,58,37,83,0,37,109,47,37,100,47,37,121,0,37,73,58,37,77,58,37,83,32,37,112,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,65,77,0,80,77,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,77,97,114,99,104,0,65,112,114,105,108,0,77,97,121,0,74,117,110,101,0,74,117,108,121,0,65,117,103,117,115,116,0,83,101,112,116,101,109,98,101,114,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,68,101,99,101,109,98,101,114,0,74,97,110,0,70,101,98,0,77,97,114,0,65,112,114,0,74,117,110,0,74,117,108,0,65,117,103,0,83,101,112,0,79,99,116,0,78,111,118,0,68,101,99,0,83,117,110,100,97,121,0,77,111,110,100,97,121,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,84,104,117,114,115,100,97,121,0,70,114,105,100,97,121,0,83,97,116,117,114,100,97,121,0,83,117,110,0,77,111,110,0,84,117,101,0,87,101,100,0,84,104,117,0,70,114,105,0,83,97,116,0,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,37,72,58,37,77,37,72,58,37,77,58,37,83,37,72,58,37,77,58,37,83,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,78,83,116,51,95,95,50,57,116,105,109,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,95,95,116,105,109,101,95,112,117,116,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,48,49,50,51,52,53,54,55,56,57,0,37,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,48,49,50,51,52,53,54,55,56,57,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,37,46,48,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,99,69,69,0,78,83,116,51,95,95,50,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,119,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,99,69,69,0,78,83,116,51,95,95,50,49,48,99,116,121,112,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,119,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,99,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,119,69,69,0,78,83,116,51,95,95,50,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,58,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,102,111,114,101,105,103,110,32,101,120,99,101,112,116,105,111,110,0,116,101,114,109,105,110,97,116,105,110,103,0,117,110,99,97,117,103,104,116,0,83,116,57,101,120,99,101,112,116,105,111,110,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,116,121,112,101,95,105,110,102,111,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,112,116,104,114,101,97,100,95,111,110,99,101,32,102,97,105,108,117,114,101,32,105,110,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,95,102,97,115,116,40,41,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,112,116,104,114,101,97,100,32,107,101,121,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,99,97,110,110,111,116,32,122,101,114,111,32,111,117,116,32,116,104,114,101,97,100,32,118,97,108,117,101,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,114,101,116,117,114,110,101,100,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,83,116,56,98,97,100,95,99,97,115,116,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,57,95,95,112,111,105,110,116,101,114,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,112,98,97,115,101,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,51,95,95,102,117,110,100,97,109,101,110,116,97,108,95,116,121,112,101,95,105,110,102,111,69,0,118,0,68,110,0,98,0,97,0,115,0,105,0,106,0,109,0,100,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,32,99,111,110,115,116,0,32,118,111,108,97,116,105,108,101,0,32,114,101,115,116,114,105,99,116,0,32,99,111,109,112,108,101,120,0,32,105,109,97,103,105,110,97,114,121,0,32,91,0,32,40,0,41,0,40,0,38,38,0,111,98,106,99,95,111,98,106,101,99,116,60,0,42,0,38,0,111,98,106,99,112,114,111,116,111,0,32,0,60,0,62,0,32,118,101,99,116,111,114,91,0,93,0,112,105,120,101,108,32,118,101,99,116,111,114,91,0,38,61,0,61,0,44,0,126,0,58,58,0,100,101,108,101,116,101,91,93,32,0,100,101,108,101,116,101,32,0,47,0,47,61,0,94,0,94,61,0,61,61,0,62,61,0,41,91,0,60,61,0,60,60,0,60,60,61,0,45,0,45,61,0,42,61,0,45,45,0,41,45,45,0,33,61,0,33,0,124,124,0,124,0,124,61,0,45,62,42,0,43,0,43,61,0,43,43,0,41,43,43,0,41,32,63,32,40,0,41,32,58,32,40,0,37,0,37,61,0,62,62,0,62,62,61,0,116,104,114,111,119,0,116,104,114,111,119,32,0,116,121,112,101,105,100,40,0,115,105,122,101,111,102,46,46,46,40,0,44,32,0,115,105,122,101,111,102,32,40,0,115,116,97,116,105,99,95,99,97,115,116,60,0,62,40,0,114,101,105,110,116,101,114,112,114,101,116,95,99,97,115,116,60,0,45,62,0,110,111,101,120,99,101,112,116,32,40,0,91,93,32,0,41,32,0,46,0,46,42,0,115,116,100,58,58,0,111,112,101,114,97,116,111,114,38,38,0,111,112,101,114,97,116,111,114,38,0,111,112,101,114,97,116,111,114,38,61,0,111,112,101,114,97,116,111,114,61,0,111,112,101,114,97,116,111,114,40,41,0,111,112,101,114,97,116,111,114,44,0,111,112,101,114,97,116,111,114,126,0,111,112,101,114,97,116,111,114,32,0,111,112,101,114,97,116,111,114,32,100,101,108,101,116,101,91,93,0,111,112,101,114,97,116,111,114,42,0,111,112,101,114,97,116,111,114,47,0,111,112,101,114,97,116,111,114,47,61,0,111,112,101,114,97,116,111,114,94,0,111,112,101,114,97,116,111,114,94,61,0,111,112,101,114,97,116,111,114,61,61,0,111,112,101,114,97,116,111,114,62,61,0,111,112,101,114,97,116,111,114,62,0,111,112,101,114,97,116,111,114,91,93,0,111,112,101,114,97,116,111,114,60,61,0,111,112,101,114,97,116,111,114,34,34,32,0,111,112,101,114,97,116,111,114,60,60,0,111,112,101,114,97,116,111,114,60,60,61,0,111,112,101,114,97,116,111,114,60,0,111,112,101,114,97,116,111,114,45,0,111,112,101,114,97,116,111,114,45,61,0,111,112,101,114,97,116,111,114,42,61,0,111,112,101,114,97,116,111,114,45,45,0,111,112,101,114,97,116,111,114,32,110,101,119,91,93,0,111,112,101,114,97,116,111,114,33,61,0,111,112,101,114,97,116,111,114,33,0,111,112,101,114,97,116,111,114,32,110,101,119,0,111,112,101,114,97,116,111,114,124,124,0,111,112,101,114,97,116,111,114,124,0,111,112,101,114,97,116,111,114,124,61,0,111,112,101,114,97,116,111,114,45,62,42,0,111,112,101,114,97,116,111,114,43,0,111,112,101,114,97,116,111,114,43,61,0,111,112,101,114,97,116,111,114,43,43,0,111,112,101,114,97,116,111,114,45,62,0,111,112,101,114,97,116,111,114,63,0,111,112,101,114,97,116,111,114,37,0,111,112,101,114,97,116,111,114,37,61,0,111,112,101,114,97,116,111,114,62,62,0,111,112,101,114,97,116,111,114,62,62,61,0,111,112,101,114,97,116,111,114,32,100,101,108,101,116,101,0,39,117,110,110,97,109,101,100,0,39,108,97,109,98,100,97,39,40,0,115,116,100,58,58,115,116,114,105,110,103,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,44,32,115,116,100,58,58,97,108,108,111,99,97,116,111,114,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,115,116,114,105,110,103,0,115,116,100,58,58,105,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,105,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,105,115,116,114,101,97,109,0,115,116,100,58,58,111,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,111,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,111,115,116,114,101,97,109,0,115,116,100,58,58,105,111,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,105,111,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,105,111,115,116,114,101,97,109,0,100,121,110,97,109,105,99,95,99,97,115,116,60,0,41,40,0,99,111,110,115,116,95,99,97,115,116,60,0,97,108,105,103,110,111,102,32,40,0,102,112,0,119,99,104,97,114,95,116,0,102,97,108,115,101,0,116,114,117,101,0,99,104,97,114,0,115,105,103,110,101,100,32,99,104,97,114,0,117,110,115,105,103,110,101,100,32,99,104,97,114,0,115,104,111,114,116,0,117,110,115,105,103,110,101,100,32,115,104,111,114,116,0,117,0,108,0,117,108,0,108,108,0,117,108,108,0,95,95,105,110,116,49,50,56,0,117,110,115,105,103,110,101,100,32,95,95,105,110,116,49,50,56,0,37,76,97,76,0,37,97,0,37,97,102,0,100,101,99,108,116,121,112,101,40,0,115,116,100,58,58,97,108,108,111,99,97,116,111,114,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,0,58,58,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,115,116,100,0,95,71,76,79,66,65,76,95,95,78,0,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,0,32,62,0,84,95,0,105,100,0,58,58,42,0,32,38,0,32,38,38,0,32,91,93,0,118,111,105,100,0,98,111,111,108,0,105,110,116,0,117,110,115,105,103,110,101,100,32,105,110,116,0,108,111,110,103,0,117,110,115,105,103,110,101,100,32,108,111,110,103,0,108,111,110,103,32,108,111,110,103,0,102,108,111,97,116,0,108,111,110,103,32,100,111,117,98,108,101,0,95,95,102,108,111,97,116,49,50,56,0,46,46,46,0,100,101,99,105,109,97,108,54,52,0,100,101,99,105,109,97,108,49,50,56,0,100,101,99,105,109,97,108,51,50,0,100,101,99,105,109,97,108,49,54,0,99,104,97,114,51,50,95,116,0,99,104,97,114,49,54,95,116,0,97,117,116,111,0,115,116,100,58,58,110,117,108,108,112,116,114,95,116,0,100,111,117,98,108,101,0,117,110,115,105,103,110,101,100,32,108,111,110,103,32,108,111,110,103,0,95,98,108,111,99,107,95,105,110,118,111,107,101,0,105,110,118,111,99,97,116,105,111,110,32,102,117,110,99,116,105,111,110,32,102,111,114,32,98,108,111,99,107,32,105,110,32,0,118,116,97,98,108,101,32,102,111,114,32,0,86,84,84,32,102,111,114,32,0,116,121,112,101,105,110,102,111,32,102,111,114,32,0,116,121,112,101,105,110,102,111,32,110,97,109,101,32,102,111,114,32,0,99,111,118,97,114,105,97,110,116,32,114,101,116,117,114,110,32,116,104,117,110,107,32,116,111,32,0,99,111,110,115,116,114,117,99,116,105,111,110,32,118,116,97,98,108,101,32,102,111,114,32,0,45,105,110,45,0,118,105,114,116,117,97,108,32,116,104,117,110,107,32,116,111,32,0,110,111,110,45,118,105,114,116,117,97,108,32,116,104,117,110,107,32,116,111,32,0,103,117,97,114,100,32,118,97,114,105,97,98,108,101,32,102,111,114,32,0,114,101,102,101,114,101,110,99,101,32,116,101,109,112,111,114,97,114,121,32,102,111,114,32,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+512e3);var tempDoublePtr=STATICTOP;STATICTOP+=16;function _atexit(func,arg){__ATEXIT__.unshift({func:func,arg:arg})}function ___cxa_atexit(){return _atexit.apply(null,arguments)}var emval_symbols={};function embind_init_charCodes(){var codes=new Array(256);for(var i=0;i<256;++i){codes[i]=String.fromCharCode(i)}embind_charCodes=codes}var embind_charCodes=undefined;function readLatin1String(ptr){var ret="";var c=ptr;while(HEAPU8[c]){ret+=embind_charCodes[HEAPU8[c++]]}return ret}function getStringOrSymbol(address){var symbol=emval_symbols[address];if(symbol===undefined){return readLatin1String(address)}else{return symbol}}var emval_free_list=[];var emval_handle_array=[{},{value:undefined},{value:null},{value:true},{value:false}];function count_emval_handles(){var count=0;for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){++count}}return count}function get_first_emval(){for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){return emval_handle_array[i]}}return null}function init_emval(){Module["count_emval_handles"]=count_emval_handles;Module["get_first_emval"]=get_first_emval}function __emval_register(value){switch(value){case undefined:{return 1};case null:{return 2};case true:{return 3};case false:{return 4};default:{var handle=emval_free_list.length?emval_free_list.pop():emval_handle_array.length;emval_handle_array[handle]={refcount:1,value:value};return handle}}}function __emval_new_cstring(v){return __emval_register(getStringOrSymbol(v))}var emval_methodCallers=[];function __emval_addMethodCaller(caller){var id=emval_methodCallers.length;emval_methodCallers.push(caller);return id}var registeredTypes={};function getTypeName(type){var ptr=___getTypeName(type);var rv=readLatin1String(ptr);_free(ptr);return rv}var char_0=48;var char_9=57;function makeLegalFunctionName(name){if(undefined===name){return"_unknown"}name=name.replace(/[^a-zA-Z0-9_]/g,"$");var f=name.charCodeAt(0);if(f>=char_0&&f<=char_9){return"_"+name}else{return name}}function createNamedFunction(name,body){name=makeLegalFunctionName(name);return(new Function("body","return function "+name+"() {\n"+'    "use strict";'+"    return body.apply(this, arguments);\n"+"};\n"))(body)}function extendError(baseErrorType,errorName){var errorClass=createNamedFunction(errorName,(function(message){this.name=errorName;this.message=message;var stack=(new Error(message)).stack;if(stack!==undefined){this.stack=this.toString()+"\n"+stack.replace(/^Error(:[^\n]*)?\n/,"")}}));errorClass.prototype=Object.create(baseErrorType.prototype);errorClass.prototype.constructor=errorClass;errorClass.prototype.toString=(function(){if(this.message===undefined){return this.name}else{return this.name+": "+this.message}});return errorClass}var BindingError=undefined;function throwBindingError(message){throw new BindingError(message)}function requireRegisteredType(rawType,humanName){var impl=registeredTypes[rawType];if(undefined===impl){throwBindingError(humanName+" has unknown type "+getTypeName(rawType))}return impl}function __emval_lookupTypes(argCount,argTypes,argWireTypes){var a=new Array(argCount);for(var i=0;i<argCount;++i){a[i]=requireRegisteredType(HEAP32[(argTypes>>2)+i],"parameter "+i)}return a}function new_(constructor,argumentList){if(!(constructor instanceof Function)){throw new TypeError("new_ called with constructor type "+typeof constructor+" which is not a function")}var dummy=createNamedFunction(constructor.name||"unknownFunctionName",(function(){}));dummy.prototype=constructor.prototype;var obj=new dummy;var r=constructor.apply(obj,argumentList);return r instanceof Object?r:obj}function __emval_get_method_caller(argCount,argTypes){var types=__emval_lookupTypes(argCount,argTypes);var retType=types[0];var signatureName=retType.name+"_$"+types.slice(1).map((function(t){return t.name})).join("_")+"$";var params=["retType"];var args=[retType];var argsList="";for(var i=0;i<argCount-1;++i){argsList+=(i!==0?", ":"")+"arg"+i;params.push("argType"+i);args.push(types[1+i])}var functionName=makeLegalFunctionName("methodCaller_"+signatureName);var functionBody="return function "+functionName+"(handle, name, destructors, args) {\n";var offset=0;for(var i=0;i<argCount-1;++i){functionBody+="    var arg"+i+" = argType"+i+".readValueFromPointer(args"+(offset?"+"+offset:"")+");\n";offset+=types[i+1]["argPackAdvance"]}functionBody+="    var rv = handle[name]("+argsList+");\n";for(var i=0;i<argCount-1;++i){if(types[i+1]["deleteObject"]){functionBody+="    argType"+i+".deleteObject(arg"+i+");\n"}}if(!retType.isVoid){functionBody+="    return retType.toWireType(destructors, rv);\n"}functionBody+="};\n";params.push(functionBody);var invokerFunction=new_(Function,params).apply(null,args);return __emval_addMethodCaller(invokerFunction)}function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0&&!info.rethrown){if(info.destructor){Module["dynCall_vi"](info.destructor,ptr)}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(Runtime.setTempRet0(0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(Runtime.setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=Module["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&Module["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(Runtime.setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(Runtime.setTempRet0(throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0,caught:false,rethrown:false};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}var awaitingDependencies={};var typeDependencies={};var InternalError=undefined;function throwInternalError(message){throw new InternalError(message)}function whenDependentTypesAreResolved(myTypes,dependentTypes,getTypeConverters){myTypes.forEach((function(type){typeDependencies[type]=dependentTypes}));function onComplete(typeConverters){var myTypeConverters=getTypeConverters(typeConverters);if(myTypeConverters.length!==myTypes.length){throwInternalError("Mismatched type converter count")}for(var i=0;i<myTypes.length;++i){registerType(myTypes[i],myTypeConverters[i])}}var typeConverters=new Array(dependentTypes.length);var unregisteredTypes=[];var registered=0;dependentTypes.forEach((function(dt,i){if(registeredTypes.hasOwnProperty(dt)){typeConverters[i]=registeredTypes[dt]}else{unregisteredTypes.push(dt);if(!awaitingDependencies.hasOwnProperty(dt)){awaitingDependencies[dt]=[]}awaitingDependencies[dt].push((function(){typeConverters[i]=registeredTypes[dt];++registered;if(registered===unregisteredTypes.length){onComplete(typeConverters)}}))}}));if(0===unregisteredTypes.length){onComplete(typeConverters)}}function registerType(rawType,registeredInstance,options){options=options||{};if(!("argPackAdvance"in registeredInstance)){throw new TypeError("registerType registeredInstance requires argPackAdvance")}var name=registeredInstance.name;if(!rawType){throwBindingError('type "'+name+'" must have a positive integer typeid pointer')}if(registeredTypes.hasOwnProperty(rawType)){if(options.ignoreDuplicateRegistrations){return}else{throwBindingError("Cannot register type '"+name+"' twice")}}registeredTypes[rawType]=registeredInstance;delete typeDependencies[rawType];if(awaitingDependencies.hasOwnProperty(rawType)){var callbacks=awaitingDependencies[rawType];delete awaitingDependencies[rawType];callbacks.forEach((function(cb){cb()}))}}function simpleReadValueFromPointer(pointer){return this["fromWireType"](HEAPU32[pointer>>2])}function __embind_register_std_string(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){var length=HEAPU32[value>>2];var a=new Array(length);for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAPU8[value+4+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){if(value instanceof ArrayBuffer){value=new Uint8Array(value)}function getTAElement(ta,index){return ta[index]}function getStringElement(string,index){return string.charCodeAt(index)}var getElement;if(value instanceof Uint8Array){getElement=getTAElement}else if(value instanceof Uint8ClampedArray){getElement=getTAElement}else if(value instanceof Int8Array){getElement=getTAElement}else if(typeof value==="string"){getElement=getStringElement}else{throwBindingError("Cannot pass non-string to std::string")}var length=value.length;var ptr=_malloc(4+length);HEAPU32[ptr>>2]=length;for(var i=0;i<length;++i){var charCode=getElement(value,i);if(charCode>255){_free(ptr);throwBindingError("String has UTF-16 code units that do not fit in 8 bits")}HEAPU8[ptr+4+i]=charCode}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function __embind_register_std_wstring(rawType,charSize,name){name=readLatin1String(name);var getHeap,shift;if(charSize===2){getHeap=(function(){return HEAPU16});shift=1}else if(charSize===4){getHeap=(function(){return HEAPU32});shift=2}registerType(rawType,{name:name,"fromWireType":(function(value){var HEAP=getHeap();var length=HEAPU32[value>>2];var a=new Array(length);var start=value+4>>shift;for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAP[start+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){var HEAP=getHeap();var length=value.length;var ptr=_malloc(4+length*charSize);HEAPU32[ptr>>2]=length;var start=ptr+4>>shift;for(var i=0;i<length;++i){HEAP[start+i]=value.charCodeAt(i)}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function _pthread_mutex_init(){}var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);function __emval_decref(handle){if(handle>4&&0===--emval_handle_array[handle].refcount){emval_handle_array[handle]=undefined;emval_free_list.push(handle)}}var structRegistrations={};function runDestructors(destructors){while(destructors.length){var ptr=destructors.pop();var del=destructors.pop();del(ptr)}}function __embind_finalize_value_object(structType){var reg=structRegistrations[structType];delete structRegistrations[structType];var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;var fieldRecords=reg.fields;var fieldTypes=fieldRecords.map((function(field){return field.getterReturnType})).concat(fieldRecords.map((function(field){return field.setterArgumentType})));whenDependentTypesAreResolved([structType],fieldTypes,(function(fieldTypes){var fields={};fieldRecords.forEach((function(field,i){var fieldName=field.fieldName;var getterReturnType=fieldTypes[i];var getter=field.getter;var getterContext=field.getterContext;var setterArgumentType=fieldTypes[i+fieldRecords.length];var setter=field.setter;var setterContext=field.setterContext;fields[fieldName]={read:(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))}),write:(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}}));return[{name:reg.name,"fromWireType":(function(ptr){var rv={};for(var i in fields){rv[i]=fields[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){for(var fieldName in fields){if(!(fieldName in o)){throw new TypeError("Missing field")}}var ptr=rawConstructor();for(fieldName in fields){fields[fieldName].write(ptr,o[fieldName])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}var PTHREAD_SPECIFIC={};var PTHREAD_SPECIFIC_NEXT_KEY=1;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}function __emval_take_value(type,argv){type=requireRegisteredType(type,"_emval_take_value");var v=type["readValueFromPointer"](argv);return __emval_register(v)}var _llvm_pow_f32=Math_pow;var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up;up--){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var isPosixPlatform=process.platform!="win32";var fd=process.stdin.fd;if(isPosixPlatform){var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}}try{bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null)}catch(e){if(e.toString().indexOf("EOF")!=-1)bytesRead=0;else throw e}if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.length:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}if(!req){return callback("Unable to connect to IndexedDB")}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){flags&=~2097152;flags&=~2048;flags&=~32768;flags&=~524288;if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount:(function(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);var createdParents={};function ensureParent(path){var parts=path.split("/");var parent=root;for(var i=0;i<parts.length-1;i++){var curr=parts.slice(0,i+1).join("/");if(!createdParents[curr]){createdParents[curr]=WORKERFS.createNode(parent,parts[i],WORKERFS.DIR_MODE,0)}parent=createdParents[curr]}return parent}function base(path){var parts=path.split("/");return parts[parts.length-1]}Array.prototype.forEach.call(mount.opts["files"]||[],(function(file){WORKERFS.createNode(ensureParent(file.name),base(file.name),WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)}));(mount.opts["blobs"]||[]).forEach((function(obj){WORKERFS.createNode(ensureParent(obj["name"]),base(obj["name"]),WORKERFS.FILE_MODE,0,obj["data"])}));(mount.opts["packages"]||[]).forEach((function(pack){pack["metadata"].files.forEach((function(file){var name=file.filename.substr(1);WORKERFS.createNode(ensureParent(name),base(name),WORKERFS.FILE_MODE,0,pack["blob"].slice(file.start,file.end))}))}));return root}),createNode:(function(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();assert(WORKERFS.FILE_MODE!==WORKERFS.DIR_MODE);if(mode===WORKERFS.FILE_MODE){node.size=contents.size;node.contents=contents}else{node.size=4096;node.contents={}}if(parent){parent.contents[name]=node}return node}),node_ops:{getattr:(function(node){return{dev:1,ino:undefined,mode:node.mode,nlink:1,uid:0,gid:0,rdev:undefined,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}}),lookup:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}),mknod:(function(parent,name,mode,dev){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rename:(function(oldNode,newDir,newName){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),unlink:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rmdir:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newName,oldPath){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readlink:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)})},stream_ops:{read:(function(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size}),write:(function(stream,buffer,offset,length,position){throw new FS.ErrnoError(ERRNO_CODES.EIO)}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};STATICTOP+=16;STATICTOP+=16;STATICTOP+=16;var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,syncFSRequests:0,handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}FS.syncFSRequests++;if(FS.syncFSRequests>1){console.log("warning: "+FS.syncFSRequests+" FS.syncfs operations in flight at once, probably just doing extra work")}var mounts=FS.getMounts(FS.root.mount);var completed=0;function doCallback(err){assert(FS.syncFSRequests>0);FS.syncFSRequests--;return callback(err)}function done(err){if(err){if(!done.errored){done.errored=true;return doCallback(err)}return}if(++completed>=mounts.length){doCallback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdirTree:(function(path,mode){var dirs=path.split("/");var d="";for(var i=0;i<dirs.length;++i){if(!dirs[i])continue;d+="/"+dirs[i];try{FS.mkdir(d,mode)}catch(e){if(e.errno!=ERRNO_CODES.EEXIST)throw e}}}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;Module["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)}),munmap:(function(stream){return 0}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(lookup.node===null){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(stream,buffer,offset,length,pos){return length})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createSpecialDirectories:(function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:(function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:(function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:(function(){return stream.path})}};ret.parent=ret;return ret})};return node})},{},"/proc/self/fd")}),createStandardStreams:(function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={"MEMFS":MEMFS,"IDBFS":IDBFS,"NODEFS":NODEFS,"WORKERFS":WORKERFS}}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;var fflush=Module["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(Module["read"]){try{obj.contents=intArrayFromString(Module["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;console.log("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperties(lazyArray,{length:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})},chunkSize:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})}});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:(function(){return this.contents.length})}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;Module["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency(dep)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:(function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);dir=dirstream.path}path=PATH.join2(dir,path)}return path}),doStat:(function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-ERRNO_CODES.ENOTDIR}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;HEAP32[buf+36>>2]=stat.size;HEAP32[buf+40>>2]=4096;HEAP32[buf+44>>2]=stat.blocks;HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+52>>2]=0;HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ino;return 0}),doMsync:(function(addr,stream,len,flags){var buffer=new Uint8Array(HEAPU8.subarray(addr,addr+len));FS.msync(stream,buffer,0,len,flags)}),doMkdir:(function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}),doMknod:(function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-ERRNO_CODES.EINVAL}FS.mknod(path,mode,dev);return 0}),doReadlink:(function(path,buf,bufsize){if(bufsize<=0)return-ERRNO_CODES.EINVAL;var ret=FS.readlink(path);var len=Math.min(bufsize,lengthBytesUTF8(ret));var endChar=HEAP8[buf+len];stringToUTF8(ret,buf,bufsize+1);HEAP8[buf+len]=endChar;return len}),doAccess:(function(path,amode){if(amode&~7){return-ERRNO_CODES.EINVAL}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-ERRNO_CODES.EACCES}return 0}),doDup:(function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd}),doReadv:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret}),doWritev:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret}),varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),getStreamFromFD:(function(){var stream=FS.getStream(SYSCALLS.get());if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return stream}),getSocketFromFD:(function(){var socket=SOCKFS.getSocket(SYSCALLS.get());if(!socket)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return socket}),getSocketAddress:(function(allowNull){var addrp=SYSCALLS.get(),addrlen=SYSCALLS.get();if(allowNull&&addrp===0)return null;var info=__read_sockaddr(addrp,addrlen);if(info.errno)throw new FS.ErrnoError(info.errno);info.addr=DNS.lookup_addr(info.addr)||info.addr;return info}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall91(which,varargs){SYSCALLS.varargs=varargs;try{var addr=SYSCALLS.get(),len=SYSCALLS.get();var info=SYSCALLS.mappings[addr];if(!info)return 0;if(len===info.len){var stream=FS.getStream(info.fd);SYSCALLS.doMsync(addr,stream,len,info.flags);FS.munmap(stream);SYSCALLS.mappings[addr]=null;if(info.allocated){_free(info.malloc)}}return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _pthread_mutexattr_destroy(){}function _emscripten_set_main_loop_timing(mode,value){Browser.mainLoop.timingMode=mode;Browser.mainLoop.timingValue=value;if(!Browser.mainLoop.func){return 1}if(mode==0){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setTimeout(){var timeUntilNextTick=Math.max(0,Browser.mainLoop.tickStartTime+value-_emscripten_get_now())|0;setTimeout(Browser.mainLoop.runner,timeUntilNextTick)};Browser.mainLoop.method="timeout"}else if(mode==1){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_rAF(){Browser.requestAnimationFrame(Browser.mainLoop.runner)};Browser.mainLoop.method="rAF"}else if(mode==2){if(!window["setImmediate"]){var setImmediates=[];var emscriptenMainLoopMessageId="setimmediate";function Browser_setImmediate_messageHandler(event){if(event.source===window&&event.data===emscriptenMainLoopMessageId){event.stopPropagation();setImmediates.shift()()}}window.addEventListener("message",Browser_setImmediate_messageHandler,true);window["setImmediate"]=function Browser_emulated_setImmediate(func){setImmediates.push(func);if(ENVIRONMENT_IS_WORKER){if(Module["setImmediates"]===undefined)Module["setImmediates"]=[];Module["setImmediates"].push(func);window.postMessage({target:emscriptenMainLoopMessageId})}else window.postMessage(emscriptenMainLoopMessageId,"*")}}Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setImmediate(){window["setImmediate"](Browser.mainLoop.runner)};Browser.mainLoop.method="immediate"}return 0}function _emscripten_get_now(){abort()}function _emscripten_set_main_loop(func,fps,simulateInfiniteLoop,arg,noSetTiming){Module["noExitRuntime"]=true;assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");Browser.mainLoop.func=func;Browser.mainLoop.arg=arg;var browserIterationFunc;if(typeof arg!=="undefined"){browserIterationFunc=(function(){Module["dynCall_vi"](func,arg)})}else{browserIterationFunc=(function(){Module["dynCall_v"](func)})}var thisMainLoopId=Browser.mainLoop.currentlyRunningMainloop;Browser.mainLoop.runner=function Browser_mainLoop_runner(){if(ABORT)return;if(Browser.mainLoop.queue.length>0){var start=Date.now();var blocker=Browser.mainLoop.queue.shift();blocker.func(blocker.arg);if(Browser.mainLoop.remainingBlockers){var remaining=Browser.mainLoop.remainingBlockers;var next=remaining%1==0?remaining-1:Math.floor(remaining);if(blocker.counted){Browser.mainLoop.remainingBlockers=next}else{next=next+.5;Browser.mainLoop.remainingBlockers=(8*remaining+next)/9}}console.log('main loop blocker "'+blocker.name+'" took '+(Date.now()-start)+" ms");Browser.mainLoop.updateStatus();if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;setTimeout(Browser.mainLoop.runner,0);return}if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0;if(Browser.mainLoop.timingMode==1&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0){Browser.mainLoop.scheduler();return}else if(Browser.mainLoop.timingMode==0){Browser.mainLoop.tickStartTime=_emscripten_get_now()}if(Browser.mainLoop.method==="timeout"&&Module.ctx){Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");Browser.mainLoop.method=""}Browser.mainLoop.runIter(browserIterationFunc);if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;if(typeof SDL==="object"&&SDL.audio&&SDL.audio.queueNewAudioData)SDL.audio.queueNewAudioData();Browser.mainLoop.scheduler()};if(!noSetTiming){if(fps&&fps>0)_emscripten_set_main_loop_timing(0,1e3/fps);else _emscripten_set_main_loop_timing(1,1);Browser.mainLoop.scheduler()}if(simulateInfiniteLoop){throw"SimulateInfiniteLoop"}}var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:(function(){Browser.mainLoop.scheduler=null;Browser.mainLoop.currentlyRunningMainloop++}),resume:(function(){Browser.mainLoop.currentlyRunningMainloop++;var timingMode=Browser.mainLoop.timingMode;var timingValue=Browser.mainLoop.timingValue;var func=Browser.mainLoop.func;Browser.mainLoop.func=null;_emscripten_set_main_loop(func,0,false,Browser.mainLoop.arg,true);_emscripten_set_main_loop_timing(timingMode,timingValue);Browser.mainLoop.scheduler()}),updateStatus:(function(){if(Module["setStatus"]){var message=Module["statusMessage"]||"Please wait...";var remaining=Browser.mainLoop.remainingBlockers;var expected=Browser.mainLoop.expectedBlockers;if(remaining){if(remaining<expected){Module["setStatus"](message+" ("+(expected-remaining)+"/"+expected+")")}else{Module["setStatus"](message)}}else{Module["setStatus"]("")}}}),runIter:(function(func){if(ABORT)return;if(Module["preMainLoop"]){var preRet=Module["preMainLoop"]();if(preRet===false){return}}try{func()}catch(e){if(e instanceof ExitStatus){return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}if(Module["postMainLoop"])Module["postMainLoop"]()})},isFullscreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:(function(){if(!Module["preloadPlugins"])Module["preloadPlugins"]=[];if(Browser.initted)return;Browser.initted=true;try{new Blob;Browser.hasBlobConstructor=true}catch(e){Browser.hasBlobConstructor=false;console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder=typeof MozBlobBuilder!="undefined"?MozBlobBuilder:typeof WebKitBlobBuilder!="undefined"?WebKitBlobBuilder:!Browser.hasBlobConstructor?console.log("warning: no BlobBuilder"):null;Browser.URLObject=typeof window!="undefined"?window.URL?window.URL:window.webkitURL:undefined;if(!Module.noImageDecoding&&typeof Browser.URLObject==="undefined"){console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");Module.noImageDecoding=true}var imagePlugin={};imagePlugin["canHandle"]=function imagePlugin_canHandle(name){return!Module.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(name)};imagePlugin["handle"]=function imagePlugin_handle(byteArray,name,onload,onerror){var b=null;if(Browser.hasBlobConstructor){try{b=new Blob([byteArray],{type:Browser.getMimetype(name)});if(b.size!==byteArray.length){b=new Blob([(new Uint8Array(byteArray)).buffer],{type:Browser.getMimetype(name)})}}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}}if(!b){var bb=new Browser.BlobBuilder;bb.append((new Uint8Array(byteArray)).buffer);b=bb.getBlob()}var url=Browser.URLObject.createObjectURL(b);var img=new Image;img.onload=function img_onload(){assert(img.complete,"Image "+name+" could not be decoded");var canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;var ctx=canvas.getContext("2d");ctx.drawImage(img,0,0);Module["preloadedImages"][name]=canvas;Browser.URLObject.revokeObjectURL(url);if(onload)onload(byteArray)};img.onerror=function img_onerror(event){console.log("Image "+url+" could not be decoded");if(onerror)onerror()};img.src=url};Module["preloadPlugins"].push(imagePlugin);var audioPlugin={};audioPlugin["canHandle"]=function audioPlugin_canHandle(name){return!Module.noAudioDecoding&&name.substr(-4)in{".ogg":1,".wav":1,".mp3":1}};audioPlugin["handle"]=function audioPlugin_handle(byteArray,name,onload,onerror){var done=false;function finish(audio){if(done)return;done=true;Module["preloadedAudios"][name]=audio;if(onload)onload(byteArray)}function fail(){if(done)return;done=true;Module["preloadedAudios"][name]=new Audio;if(onerror)onerror()}if(Browser.hasBlobConstructor){try{var b=new Blob([byteArray],{type:Browser.getMimetype(name)})}catch(e){return fail()}var url=Browser.URLObject.createObjectURL(b);var audio=new Audio;audio.addEventListener("canplaythrough",(function(){finish(audio)}),false);audio.onerror=function audio_onerror(event){if(done)return;console.log("warning: browser could not fully decode audio "+name+", trying slower base64 approach");function encode64(data){var BASE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var PAD="=";var ret="";var leftchar=0;var leftbits=0;for(var i=0;i<data.length;i++){leftchar=leftchar<<8|data[i];leftbits+=8;while(leftbits>=6){var curr=leftchar>>leftbits-6&63;leftbits-=6;ret+=BASE[curr]}}if(leftbits==2){ret+=BASE[(leftchar&3)<<4];ret+=PAD+PAD}else if(leftbits==4){ret+=BASE[(leftchar&15)<<2];ret+=PAD}return ret}audio.src="data:audio/x-"+name.substr(-3)+";base64,"+encode64(byteArray);finish(audio)};audio.src=url;Browser.safeSetTimeout((function(){finish(audio)}),1e4)}else{return fail()}};Module["preloadPlugins"].push(audioPlugin);function pointerLockChange(){Browser.pointerLock=document["pointerLockElement"]===Module["canvas"]||document["mozPointerLockElement"]===Module["canvas"]||document["webkitPointerLockElement"]===Module["canvas"]||document["msPointerLockElement"]===Module["canvas"]}var canvas=Module["canvas"];if(canvas){canvas.requestPointerLock=canvas["requestPointerLock"]||canvas["mozRequestPointerLock"]||canvas["webkitRequestPointerLock"]||canvas["msRequestPointerLock"]||(function(){});canvas.exitPointerLock=document["exitPointerLock"]||document["mozExitPointerLock"]||document["webkitExitPointerLock"]||document["msExitPointerLock"]||(function(){});canvas.exitPointerLock=canvas.exitPointerLock.bind(document);document.addEventListener("pointerlockchange",pointerLockChange,false);document.addEventListener("mozpointerlockchange",pointerLockChange,false);document.addEventListener("webkitpointerlockchange",pointerLockChange,false);document.addEventListener("mspointerlockchange",pointerLockChange,false);if(Module["elementPointerLock"]){canvas.addEventListener("click",(function(ev){if(!Browser.pointerLock&&Module["canvas"].requestPointerLock){Module["canvas"].requestPointerLock();ev.preventDefault()}}),false)}}}),createContext:(function(canvas,useWebGL,setInModule,webGLContextAttributes){if(useWebGL&&Module.ctx&&canvas==Module.canvas)return Module.ctx;var ctx;var contextHandle;if(useWebGL){var contextAttributes={antialias:false,alpha:false};if(webGLContextAttributes){for(var attribute in webGLContextAttributes){contextAttributes[attribute]=webGLContextAttributes[attribute]}}contextHandle=GL.createContext(canvas,contextAttributes);if(contextHandle){ctx=GL.getContext(contextHandle).GLctx}}else{ctx=canvas.getContext("2d")}if(!ctx)return null;if(setInModule){if(!useWebGL)assert(typeof GLctx==="undefined","cannot set in module if GLctx is used, but we are a non-GL context that would replace it");Module.ctx=ctx;if(useWebGL)GL.makeContextCurrent(contextHandle);Module.useWebGL=useWebGL;Browser.moduleContextCreatedCallbacks.forEach((function(callback){callback()}));Browser.init()}return ctx}),destroyContext:(function(canvas,useWebGL,setInModule){}),fullscreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullscreen:(function(lockPointer,resizeCanvas,vrDevice){Browser.lockPointer=lockPointer;Browser.resizeCanvas=resizeCanvas;Browser.vrDevice=vrDevice;if(typeof Browser.lockPointer==="undefined")Browser.lockPointer=true;if(typeof Browser.resizeCanvas==="undefined")Browser.resizeCanvas=false;if(typeof Browser.vrDevice==="undefined")Browser.vrDevice=null;var canvas=Module["canvas"];function fullscreenChange(){Browser.isFullscreen=false;var canvasContainer=canvas.parentNode;if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvasContainer){canvas.exitFullscreen=document["exitFullscreen"]||document["cancelFullScreen"]||document["mozCancelFullScreen"]||document["msExitFullscreen"]||document["webkitCancelFullScreen"]||(function(){});canvas.exitFullscreen=canvas.exitFullscreen.bind(document);if(Browser.lockPointer)canvas.requestPointerLock();Browser.isFullscreen=true;if(Browser.resizeCanvas)Browser.setFullscreenCanvasSize()}else{canvasContainer.parentNode.insertBefore(canvas,canvasContainer);canvasContainer.parentNode.removeChild(canvasContainer);if(Browser.resizeCanvas)Browser.setWindowedCanvasSize()}if(Module["onFullScreen"])Module["onFullScreen"](Browser.isFullscreen);if(Module["onFullscreen"])Module["onFullscreen"](Browser.isFullscreen);Browser.updateCanvasDimensions(canvas)}if(!Browser.fullscreenHandlersInstalled){Browser.fullscreenHandlersInstalled=true;document.addEventListener("fullscreenchange",fullscreenChange,false);document.addEventListener("mozfullscreenchange",fullscreenChange,false);document.addEventListener("webkitfullscreenchange",fullscreenChange,false);document.addEventListener("MSFullscreenChange",fullscreenChange,false)}var canvasContainer=document.createElement("div");canvas.parentNode.insertBefore(canvasContainer,canvas);canvasContainer.appendChild(canvas);canvasContainer.requestFullscreen=canvasContainer["requestFullscreen"]||canvasContainer["mozRequestFullScreen"]||canvasContainer["msRequestFullscreen"]||(canvasContainer["webkitRequestFullscreen"]?(function(){canvasContainer["webkitRequestFullscreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null)||(canvasContainer["webkitRequestFullScreen"]?(function(){canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null);if(vrDevice){canvasContainer.requestFullscreen({vrDisplay:vrDevice})}else{canvasContainer.requestFullscreen()}}),requestFullScreen:(function(lockPointer,resizeCanvas,vrDevice){Module.printErr("Browser.requestFullScreen() is deprecated. Please call Browser.requestFullscreen instead.");Browser.requestFullScreen=(function(lockPointer,resizeCanvas,vrDevice){return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)});return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)}),nextRAF:0,fakeRequestAnimationFrame:(function(func){var now=Date.now();if(Browser.nextRAF===0){Browser.nextRAF=now+1e3/60}else{while(now+2>=Browser.nextRAF){Browser.nextRAF+=1e3/60}}var delay=Math.max(Browser.nextRAF-now,0);setTimeout(func,delay)}),requestAnimationFrame:function requestAnimationFrame(func){if(typeof window==="undefined"){Browser.fakeRequestAnimationFrame(func)}else{if(!window.requestAnimationFrame){window.requestAnimationFrame=window["requestAnimationFrame"]||window["mozRequestAnimationFrame"]||window["webkitRequestAnimationFrame"]||window["msRequestAnimationFrame"]||window["oRequestAnimationFrame"]||Browser.fakeRequestAnimationFrame}window.requestAnimationFrame(func)}},safeCallback:(function(func){return(function(){if(!ABORT)return func.apply(null,arguments)})}),allowAsyncCallbacks:true,queuedAsyncCallbacks:[],pauseAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=false}),resumeAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=true;if(Browser.queuedAsyncCallbacks.length>0){var callbacks=Browser.queuedAsyncCallbacks;Browser.queuedAsyncCallbacks=[];callbacks.forEach((function(func){func()}))}}),safeRequestAnimationFrame:(function(func){return Browser.requestAnimationFrame((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}))}),safeSetTimeout:(function(func,timeout){Module["noExitRuntime"]=true;return setTimeout((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}),timeout)}),safeSetInterval:(function(func,timeout){Module["noExitRuntime"]=true;return setInterval((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}}),timeout)}),getMimetype:(function(name){return{"jpg":"image/jpeg","jpeg":"image/jpeg","png":"image/png","bmp":"image/bmp","ogg":"audio/ogg","wav":"audio/wav","mp3":"audio/mpeg"}[name.substr(name.lastIndexOf(".")+1)]}),getUserMedia:(function(func){if(!window.getUserMedia){window.getUserMedia=navigator["getUserMedia"]||navigator["mozGetUserMedia"]}window.getUserMedia(func)}),getMovementX:(function(event){return event["movementX"]||event["mozMovementX"]||event["webkitMovementX"]||0}),getMovementY:(function(event){return event["movementY"]||event["mozMovementY"]||event["webkitMovementY"]||0}),getMouseWheelDelta:(function(event){var delta=0;switch(event.type){case"DOMMouseScroll":delta=event.detail;break;case"mousewheel":delta=event.wheelDelta;break;case"wheel":delta=event["deltaY"];break;default:throw"unrecognized mouse wheel event: "+event.type}return delta}),mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:(function(event){if(Browser.pointerLock){if(event.type!="mousemove"&&"mozMovementX"in event){Browser.mouseMovementX=Browser.mouseMovementY=0}else{Browser.mouseMovementX=Browser.getMovementX(event);Browser.mouseMovementY=Browser.getMovementY(event)}if(typeof SDL!="undefined"){Browser.mouseX=SDL.mouseX+Browser.mouseMovementX;Browser.mouseY=SDL.mouseY+Browser.mouseMovementY}else{Browser.mouseX+=Browser.mouseMovementX;Browser.mouseY+=Browser.mouseMovementY}}else{var rect=Module["canvas"].getBoundingClientRect();var cw=Module["canvas"].width;var ch=Module["canvas"].height;var scrollX=typeof window.scrollX!=="undefined"?window.scrollX:window.pageXOffset;var scrollY=typeof window.scrollY!=="undefined"?window.scrollY:window.pageYOffset;if(event.type==="touchstart"||event.type==="touchend"||event.type==="touchmove"){var touch=event.touch;if(touch===undefined){return}var adjustedX=touch.pageX-(scrollX+rect.left);var adjustedY=touch.pageY-(scrollY+rect.top);adjustedX=adjustedX*(cw/rect.width);adjustedY=adjustedY*(ch/rect.height);var coords={x:adjustedX,y:adjustedY};if(event.type==="touchstart"){Browser.lastTouches[touch.identifier]=coords;Browser.touches[touch.identifier]=coords}else if(event.type==="touchend"||event.type==="touchmove"){var last=Browser.touches[touch.identifier];if(!last)last=coords;Browser.lastTouches[touch.identifier]=last;Browser.touches[touch.identifier]=coords}return}var x=event.pageX-(scrollX+rect.left);var y=event.pageY-(scrollY+rect.top);x=x*(cw/rect.width);y=y*(ch/rect.height);Browser.mouseMovementX=x-Browser.mouseX;Browser.mouseMovementY=y-Browser.mouseY;Browser.mouseX=x;Browser.mouseY=y}}),asyncLoad:(function(url,onload,onerror,noRunDep){var dep=!noRunDep?getUniqueRunDependency("al "+url):"";Module["readAsync"](url,(function(arrayBuffer){assert(arrayBuffer,'Loading data file "'+url+'" failed (no arrayBuffer).');onload(new Uint8Array(arrayBuffer));if(dep)removeRunDependency(dep)}),(function(event){if(onerror){onerror()}else{throw'Loading data file "'+url+'" failed.'}}));if(dep)addRunDependency(dep)}),resizeListeners:[],updateResizeListeners:(function(){var canvas=Module["canvas"];Browser.resizeListeners.forEach((function(listener){listener(canvas.width,canvas.height)}))}),setCanvasSize:(function(width,height,noUpdates){var canvas=Module["canvas"];Browser.updateCanvasDimensions(canvas,width,height);if(!noUpdates)Browser.updateResizeListeners()}),windowedWidth:0,windowedHeight:0,setFullscreenCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags|8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),setWindowedCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags&~8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),updateCanvasDimensions:(function(canvas,wNative,hNative){if(wNative&&hNative){canvas.widthNative=wNative;canvas.heightNative=hNative}else{wNative=canvas.widthNative;hNative=canvas.heightNative}var w=wNative;var h=hNative;if(Module["forcedAspectRatio"]&&Module["forcedAspectRatio"]>0){if(w/h<Module["forcedAspectRatio"]){w=Math.round(h*Module["forcedAspectRatio"])}else{h=Math.round(w/Module["forcedAspectRatio"])}}if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvas.parentNode&&typeof screen!="undefined"){var factor=Math.min(screen.width/w,screen.height/h);w=Math.round(w*factor);h=Math.round(h*factor)}if(Browser.resizeCanvas){if(canvas.width!=w)canvas.width=w;if(canvas.height!=h)canvas.height=h;if(typeof canvas.style!="undefined"){canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}else{if(canvas.width!=wNative)canvas.width=wNative;if(canvas.height!=hNative)canvas.height=hNative;if(typeof canvas.style!="undefined"){if(w!=wNative||h!=hNative){canvas.style.setProperty("width",w+"px","important");canvas.style.setProperty("height",h+"px","important")}else{canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}}}),wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:(function(){var handle=Browser.nextWgetRequestHandle;Browser.nextWgetRequestHandle++;return handle})};function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),op=SYSCALLS.get();switch(op){case 21505:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21506:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21519:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0};case 21520:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return-ERRNO_CODES.EINVAL};case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)};case 21523:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var tupleRegistrations={};function requireFunction(signature,rawFunction){signature=readLatin1String(signature);function makeDynCaller(dynCall){var args=[];for(var i=1;i<signature.length;++i){args.push("a"+i)}var name="dynCall_"+signature+"_"+rawFunction;var body="return function "+name+"("+args.join(", ")+") {\n";body+="    return dynCall(rawFunction"+(args.length?", ":"")+args.join(", ")+");\n";body+="};\n";return(new Function("dynCall","rawFunction",body))(dynCall,rawFunction)}var fp;if(Module["FUNCTION_TABLE_"+signature]!==undefined){fp=Module["FUNCTION_TABLE_"+signature][rawFunction]}else if(typeof FUNCTION_TABLE!=="undefined"){fp=FUNCTION_TABLE[rawFunction]}else{var dc=Module["asm"]["dynCall_"+signature];if(dc===undefined){dc=Module["asm"]["dynCall_"+signature.replace(/f/g,"d")];if(dc===undefined){throwBindingError("No dynCall invoker for signature: "+signature)}}fp=makeDynCaller(dc)}if(typeof fp!=="function"){throwBindingError("unknown function pointer with signature "+signature+": "+rawFunction)}return fp}function __embind_register_value_array(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){tupleRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),elements:[]}}function upcastPointer(ptr,ptrClass,desiredClass){while(ptrClass!==desiredClass){if(!ptrClass.upcast){throwBindingError("Expected null or instance of "+desiredClass.name+", got an instance of "+ptrClass.name)}ptr=ptrClass.upcast(ptr);ptrClass=ptrClass.baseClass}return ptr}function constNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function genericPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}if(this.isSmartPointer){var ptr=this.rawConstructor();if(destructors!==null){destructors.push(this.rawDestructor,ptr)}return ptr}else{return 0}}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(!this.isConst&&handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);if(this.isSmartPointer){if(undefined===handle.$$.smartPtr){throwBindingError("Passing raw pointer to smart pointer is illegal")}switch(this.sharingPolicy){case 0:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}break;case 1:ptr=handle.$$.smartPtr;break;case 2:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{var clonedHandle=handle["clone"]();ptr=this.rawShare(ptr,__emval_register((function(){clonedHandle["delete"]()})));if(destructors!==null){destructors.push(this.rawDestructor,ptr)}}break;default:throwBindingError("Unsupporting sharing policy")}}return ptr}function nonConstNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+handle.$$.ptrType.name+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function RegisteredPointer_getPointee(ptr){if(this.rawGetPointee){ptr=this.rawGetPointee(ptr)}return ptr}function RegisteredPointer_destructor(ptr){if(this.rawDestructor){this.rawDestructor(ptr)}}function RegisteredPointer_deleteObject(handle){if(handle!==null){handle["delete"]()}}function downcastPointer(ptr,ptrClass,desiredClass){if(ptrClass===desiredClass){return ptr}if(undefined===desiredClass.baseClass){return null}var rv=downcastPointer(ptr,ptrClass,desiredClass.baseClass);if(rv===null){return null}return desiredClass.downcast(rv)}var registeredPointers={};function getInheritedInstanceCount(){return Object.keys(registeredInstances).length}function getLiveInheritedInstances(){var rv=[];for(var k in registeredInstances){if(registeredInstances.hasOwnProperty(k)){rv.push(registeredInstances[k])}}return rv}var deletionQueue=[];function flushPendingDeletes(){while(deletionQueue.length){var obj=deletionQueue.pop();obj.$$.deleteScheduled=false;obj["delete"]()}}var delayFunction=undefined;function setDelayFunction(fn){delayFunction=fn;if(deletionQueue.length&&delayFunction){delayFunction(flushPendingDeletes)}}function init_embind(){Module["getInheritedInstanceCount"]=getInheritedInstanceCount;Module["getLiveInheritedInstances"]=getLiveInheritedInstances;Module["flushPendingDeletes"]=flushPendingDeletes;Module["setDelayFunction"]=setDelayFunction}var registeredInstances={};function getBasestPointer(class_,ptr){if(ptr===undefined){throwBindingError("ptr should not be undefined")}while(class_.baseClass){ptr=class_.upcast(ptr);class_=class_.baseClass}return ptr}function getInheritedInstance(class_,ptr){ptr=getBasestPointer(class_,ptr);return registeredInstances[ptr]}function makeClassHandle(prototype,record){if(!record.ptrType||!record.ptr){throwInternalError("makeClassHandle requires ptr and ptrType")}var hasSmartPtrType=!!record.smartPtrType;var hasSmartPtr=!!record.smartPtr;if(hasSmartPtrType!==hasSmartPtr){throwInternalError("Both smartPtrType and smartPtr must be specified")}record.count={value:1};return Object.create(prototype,{$$:{value:record}})}function RegisteredPointer_fromWireType(ptr){var rawPointer=this.getPointee(ptr);if(!rawPointer){this.destructor(ptr);return null}var registeredInstance=getInheritedInstance(this.registeredClass,rawPointer);if(undefined!==registeredInstance){if(0===registeredInstance.$$.count.value){registeredInstance.$$.ptr=rawPointer;registeredInstance.$$.smartPtr=ptr;return registeredInstance["clone"]()}else{var rv=registeredInstance["clone"]();this.destructor(ptr);return rv}}function makeDefaultHandle(){if(this.isSmartPointer){return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this.pointeeType,ptr:rawPointer,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this,ptr:ptr})}}var actualType=this.registeredClass.getActualType(rawPointer);var registeredPointerRecord=registeredPointers[actualType];if(!registeredPointerRecord){return makeDefaultHandle.call(this)}var toType;if(this.isConst){toType=registeredPointerRecord.constPointerType}else{toType=registeredPointerRecord.pointerType}var dp=downcastPointer(rawPointer,this.registeredClass,toType.registeredClass);if(dp===null){return makeDefaultHandle.call(this)}if(this.isSmartPointer){return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp})}}function init_RegisteredPointer(){RegisteredPointer.prototype.getPointee=RegisteredPointer_getPointee;RegisteredPointer.prototype.destructor=RegisteredPointer_destructor;RegisteredPointer.prototype["argPackAdvance"]=8;RegisteredPointer.prototype["readValueFromPointer"]=simpleReadValueFromPointer;RegisteredPointer.prototype["deleteObject"]=RegisteredPointer_deleteObject;RegisteredPointer.prototype["fromWireType"]=RegisteredPointer_fromWireType}function RegisteredPointer(name,registeredClass,isReference,isConst,isSmartPointer,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor){this.name=name;this.registeredClass=registeredClass;this.isReference=isReference;this.isConst=isConst;this.isSmartPointer=isSmartPointer;this.pointeeType=pointeeType;this.sharingPolicy=sharingPolicy;this.rawGetPointee=rawGetPointee;this.rawConstructor=rawConstructor;this.rawShare=rawShare;this.rawDestructor=rawDestructor;if(!isSmartPointer&&registeredClass.baseClass===undefined){if(isConst){this["toWireType"]=constNoSmartPtrRawPointerToWireType;this.destructorFunction=null}else{this["toWireType"]=nonConstNoSmartPtrRawPointerToWireType;this.destructorFunction=null}}else{this["toWireType"]=genericPointerToWireType}}function __embind_register_smart_ptr(rawType,rawPointeeType,name,sharingPolicy,getPointeeSignature,rawGetPointee,constructorSignature,rawConstructor,shareSignature,rawShare,destructorSignature,rawDestructor){name=readLatin1String(name);rawGetPointee=requireFunction(getPointeeSignature,rawGetPointee);rawConstructor=requireFunction(constructorSignature,rawConstructor);rawShare=requireFunction(shareSignature,rawShare);rawDestructor=requireFunction(destructorSignature,rawDestructor);whenDependentTypesAreResolved([rawType],[rawPointeeType],(function(pointeeType){pointeeType=pointeeType[0];var registeredPointer=new RegisteredPointer(name,pointeeType.registeredClass,false,false,true,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor);return[registeredPointer]}))}function _llvm_exp2_f32(x){return Math.pow(2,x)}function _llvm_exp2_f64(){return _llvm_exp2_f32.apply(null,arguments)}function _sched_yield(){return 0}function craftInvokerFunction(humanName,argTypes,classType,cppInvokerFunc,cppTargetFunc){var argCount=argTypes.length;if(argCount<2){throwBindingError("argTypes array size mismatch! Must at least get return value and 'this' types!")}var isClassMethodFunc=argTypes[1]!==null&&classType!==null;var argsList="";var argsListWired="";for(var i=0;i<argCount-2;++i){argsList+=(i!==0?", ":"")+"arg"+i;argsListWired+=(i!==0?", ":"")+"arg"+i+"Wired"}var invokerFnBody="return function "+makeLegalFunctionName(humanName)+"("+argsList+") {\n"+"if (arguments.length !== "+(argCount-2)+") {\n"+"throwBindingError('function "+humanName+" called with ' + arguments.length + ' arguments, expected "+(argCount-2)+" args!');\n"+"}\n";var needsDestructorStack=false;for(var i=1;i<argTypes.length;++i){if(argTypes[i]!==null&&argTypes[i].destructorFunction===undefined){needsDestructorStack=true;break}}if(needsDestructorStack){invokerFnBody+="var destructors = [];\n"}var dtorStack=needsDestructorStack?"destructors":"null";var args1=["throwBindingError","invoker","fn","runDestructors","retType","classParam"];var args2=[throwBindingError,cppInvokerFunc,cppTargetFunc,runDestructors,argTypes[0],argTypes[1]];if(isClassMethodFunc){invokerFnBody+="var thisWired = classParam.toWireType("+dtorStack+", this);\n"}for(var i=0;i<argCount-2;++i){invokerFnBody+="var arg"+i+"Wired = argType"+i+".toWireType("+dtorStack+", arg"+i+"); // "+argTypes[i+2].name+"\n";args1.push("argType"+i);args2.push(argTypes[i+2])}if(isClassMethodFunc){argsListWired="thisWired"+(argsListWired.length>0?", ":"")+argsListWired}var returns=argTypes[0].name!=="void";invokerFnBody+=(returns?"var rv = ":"")+"invoker(fn"+(argsListWired.length>0?", ":"")+argsListWired+");\n";if(needsDestructorStack){invokerFnBody+="runDestructors(destructors);\n"}else{for(var i=isClassMethodFunc?1:2;i<argTypes.length;++i){var paramName=i===1?"thisWired":"arg"+(i-2)+"Wired";if(argTypes[i].destructorFunction!==null){invokerFnBody+=paramName+"_dtor("+paramName+"); // "+argTypes[i].name+"\n";args1.push(paramName+"_dtor");args2.push(argTypes[i].destructorFunction)}}}if(returns){invokerFnBody+="var ret = retType.fromWireType(rv);\n"+"return ret;\n"}else{}invokerFnBody+="}\n";args1.push(invokerFnBody);var invokerFunction=new_(Function,args1).apply(null,args2);return invokerFunction}function ensureOverloadTable(proto,methodName,humanName){if(undefined===proto[methodName].overloadTable){var prevFunc=proto[methodName];proto[methodName]=(function(){if(!proto[methodName].overloadTable.hasOwnProperty(arguments.length)){throwBindingError("Function '"+humanName+"' called with an invalid number of arguments ("+arguments.length+") - expects one of ("+proto[methodName].overloadTable+")!")}return proto[methodName].overloadTable[arguments.length].apply(this,arguments)});proto[methodName].overloadTable=[];proto[methodName].overloadTable[prevFunc.argCount]=prevFunc}}function heap32VectorToArray(count,firstElement){var array=[];for(var i=0;i<count;i++){array.push(HEAP32[(firstElement>>2)+i])}return array}var UnboundTypeError=undefined;function throwUnboundTypeError(message,types){var unboundTypes=[];var seen={};function visit(type){if(seen[type]){return}if(registeredTypes[type]){return}if(typeDependencies[type]){typeDependencies[type].forEach(visit);return}unboundTypes.push(type);seen[type]=true}types.forEach(visit);throw new UnboundTypeError(message+": "+unboundTypes.map(getTypeName).join([", "]))}function __embind_register_class_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,fn){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.constructor;if(undefined===proto[methodName]){unboundTypesHandler.argCount=argCount-1;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-1]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));var func=craftInvokerFunction(humanName,invokerArgsArray,null,rawInvoker,fn);if(undefined===proto[methodName].overloadTable){proto[methodName]=func}else{proto[methodName].overloadTable[argCount-1]=func}return[]}));return[]}))}var _environ=STATICTOP;STATICTOP+=16;function ___buildEnvironment(env){var MAX_ENV_VALUES=64;var TOTAL_ENV_SIZE=1024;var poolPtr;var envPtr;if(!___buildEnvironment.called){___buildEnvironment.called=true;ENV["USER"]=ENV["LOGNAME"]="web_user";ENV["PATH"]="/";ENV["PWD"]="/";ENV["HOME"]="/home/web_user";ENV["LANG"]="C";ENV["_"]=Module["thisProgram"];poolPtr=allocate(TOTAL_ENV_SIZE,"i8",ALLOC_STATIC);envPtr=allocate(MAX_ENV_VALUES*4,"i8*",ALLOC_STATIC);HEAP32[envPtr>>2]=poolPtr;HEAP32[_environ>>2]=envPtr}else{envPtr=HEAP32[_environ>>2];poolPtr=HEAP32[envPtr>>2]}var strings=[];var totalSize=0;for(var key in env){if(typeof env[key]==="string"){var line=key+"="+env[key];strings.push(line);totalSize+=line.length}}if(totalSize>TOTAL_ENV_SIZE){throw new Error("Environment size exceeded TOTAL_ENV_SIZE!")}var ptrSize=4;for(var i=0;i<strings.length;i++){var line=strings[i];writeAsciiToMemory(line,poolPtr);HEAP32[envPtr+i*ptrSize>>2]=poolPtr;poolPtr+=line.length+1}HEAP32[envPtr+strings.length*ptrSize>>2]=0}var ENV={};function _getenv(name){if(name===0)return 0;name=Pointer_stringify(name);if(!ENV.hasOwnProperty(name))return 0;if(_getenv.ret)_free(_getenv.ret);_getenv.ret=allocate(intArrayFromString(ENV[name]),"i8",ALLOC_NORMAL);return _getenv.ret}function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function __emval_allocateDestructors(destructorsRef){var destructors=[];HEAP32[destructorsRef>>2]=__emval_register(destructors);return destructors}function requireHandle(handle){if(!handle){throwBindingError("Cannot use deleted val. handle = "+handle)}return emval_handle_array[handle].value}function __emval_call_void_method(caller,handle,methodName,args){caller=emval_methodCallers[caller];handle=requireHandle(handle);methodName=getStringOrSymbol(methodName);caller(handle,methodName,null,args)}function _gettimeofday(ptr){var now=Date.now();HEAP32[ptr>>2]=now/1e3|0;HEAP32[ptr+4>>2]=now%1e3*1e3|0;return 0}function ___map_file(pathname,size){___setErrNo(ERRNO_CODES.EPERM);return-1}function __emval_run_destructors(handle){var destructors=emval_handle_array[handle].value;runDestructors(destructors);__emval_decref(handle)}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}var _llvm_pow_f64=Math_pow;function __embind_finalize_value_array(rawTupleType){var reg=tupleRegistrations[rawTupleType];delete tupleRegistrations[rawTupleType];var elements=reg.elements;var elementsLength=elements.length;var elementTypes=elements.map((function(elt){return elt.getterReturnType})).concat(elements.map((function(elt){return elt.setterArgumentType})));var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;whenDependentTypesAreResolved([rawTupleType],elementTypes,(function(elementTypes){elements.forEach((function(elt,i){var getterReturnType=elementTypes[i];var getter=elt.getter;var getterContext=elt.getterContext;var setterArgumentType=elementTypes[i+elementsLength];var setter=elt.setter;var setterContext=elt.setterContext;elt.read=(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))});elt.write=(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}));return[{name:reg.name,"fromWireType":(function(ptr){var rv=new Array(elementsLength);for(var i=0;i<elementsLength;++i){rv[i]=elements[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){if(elementsLength!==o.length){throw new TypeError("Incorrect number of tuple elements for "+reg.name+": expected="+elementsLength+", actual="+o.length)}var ptr=rawConstructor();for(var i=0;i<elementsLength;++i){elements[i].write(ptr,o[i])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}function ___gxx_personality_v0(){}function _pthread_cond_wait(){return 0}function __embind_register_memory_view(rawType,dataTypeIndex,name){var typeMapping=[Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];var TA=typeMapping[dataTypeIndex];function decodeMemoryView(handle){handle=handle>>2;var heap=HEAPU32;var size=heap[handle];var data=heap[handle+1];return new TA(heap["buffer"],data,size)}name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":decodeMemoryView,"argPackAdvance":8,"readValueFromPointer":decodeMemoryView},{ignoreDuplicateRegistrations:true})}function validateThis(this_,classType,humanName){if(!(this_ instanceof Object)){throwBindingError(humanName+' with invalid "this": '+this_)}if(!(this_ instanceof classType.registeredClass.constructor)){throwBindingError(humanName+' incompatible with "this" of type '+this_.constructor.name)}if(!this_.$$.ptr){throwBindingError("cannot call emscripten binding method "+humanName+" on deleted object")}return upcastPointer(this_.$$.ptr,this_.$$.ptrType.registeredClass,classType.registeredClass)}function __embind_register_class_property(classType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){fieldName=readLatin1String(fieldName);getter=requireFunction(getterSignature,getter);whenDependentTypesAreResolved([],[classType],(function(classType){classType=classType[0];var humanName=classType.name+"."+fieldName;var desc={get:(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])}),enumerable:true,configurable:true};if(setter){desc.set=(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])})}else{desc.set=(function(v){throwBindingError(humanName+" is a read-only property")})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);whenDependentTypesAreResolved([],setter?[getterReturnType,setterArgumentType]:[getterReturnType],(function(types){var getterReturnType=types[0];var desc={get:(function(){var ptr=validateThis(this,classType,humanName+" getter");return getterReturnType["fromWireType"](getter(getterContext,ptr))}),enumerable:true};if(setter){setter=requireFunction(setterSignature,setter);var setterArgumentType=types[1];desc.set=(function(v){var ptr=validateThis(this,classType,humanName+" setter");var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,v));runDestructors(destructors)})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);return[]}));return[]}))}function __emval_incref(handle){if(handle>4){emval_handle_array[handle].refcount+=1}}function _pthread_mutexattr_settype(){}function __embind_register_value_object(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){structRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),fields:[]}}function getShiftFromSize(size){switch(size){case 1:return 0;case 2:return 1;case 4:return 2;case 8:return 3;default:throw new TypeError("Unknown type size: "+size)}}function __embind_register_bool(rawType,name,size,trueValue,falseValue){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(wt){return!!wt}),"toWireType":(function(destructors,o){return o?trueValue:falseValue}),"argPackAdvance":8,"readValueFromPointer":(function(pointer){var heap;if(size===1){heap=HEAP8}else if(size===2){heap=HEAP16}else if(size===4){heap=HEAP32}else{throw new TypeError("Unknown boolean type size: "+name)}return this["fromWireType"](heap[pointer>>shift])}),destructorFunction:null})}function __embind_register_void(rawType,name){name=readLatin1String(name);registerType(rawType,{isVoid:true,name:name,"argPackAdvance":0,"fromWireType":(function(){return undefined}),"toWireType":(function(destructors,o){return undefined})})}function __emval_new_array(){return __emval_register([])}function _abort(){Module["abort"]()}function __emval_as(handle,returnType,destructorsRef){handle=requireHandle(handle);returnType=requireRegisteredType(returnType,"emval::as");var destructors=[];var rd=__emval_register(destructors);HEAP32[destructorsRef>>2]=rd;return returnType["toWireType"](destructors,handle)}function _pthread_mutex_destroy(){}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;Module["dynCall_v"](func);_pthread_once.seen[ptr]=1}function __embind_register_value_object_field(structType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){structRegistrations[structType].fields.push({fieldName:readLatin1String(fieldName),getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ClassHandle_isAliasOf(other){if(!(this instanceof ClassHandle)){return false}if(!(other instanceof ClassHandle)){return false}var leftClass=this.$$.ptrType.registeredClass;var left=this.$$.ptr;var rightClass=other.$$.ptrType.registeredClass;var right=other.$$.ptr;while(leftClass.baseClass){left=leftClass.upcast(left);leftClass=leftClass.baseClass}while(rightClass.baseClass){right=rightClass.upcast(right);rightClass=rightClass.baseClass}return leftClass===rightClass&&left===right}function shallowCopyInternalPointer(o){return{count:o.count,deleteScheduled:o.deleteScheduled,preservePointerOnDelete:o.preservePointerOnDelete,ptr:o.ptr,ptrType:o.ptrType,smartPtr:o.smartPtr,smartPtrType:o.smartPtrType}}function throwInstanceAlreadyDeleted(obj){function getInstanceTypeName(handle){return handle.$$.ptrType.registeredClass.name}throwBindingError(getInstanceTypeName(obj)+" instance already deleted")}function ClassHandle_clone(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.preservePointerOnDelete){this.$$.count.value+=1;return this}else{var clone=Object.create(Object.getPrototypeOf(this),{$$:{value:shallowCopyInternalPointer(this.$$)}});clone.$$.count.value+=1;clone.$$.deleteScheduled=false;return clone}}function runDestructor(handle){var $$=handle.$$;if($$.smartPtr){$$.smartPtrType.rawDestructor($$.smartPtr)}else{$$.ptrType.registeredClass.rawDestructor($$.ptr)}}function ClassHandle_delete(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}this.$$.count.value-=1;var toDelete=0===this.$$.count.value;if(toDelete){runDestructor(this)}if(!this.$$.preservePointerOnDelete){this.$$.smartPtr=undefined;this.$$.ptr=undefined}}function ClassHandle_isDeleted(){return!this.$$.ptr}function ClassHandle_deleteLater(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}deletionQueue.push(this);if(deletionQueue.length===1&&delayFunction){delayFunction(flushPendingDeletes)}this.$$.deleteScheduled=true;return this}function init_ClassHandle(){ClassHandle.prototype["isAliasOf"]=ClassHandle_isAliasOf;ClassHandle.prototype["clone"]=ClassHandle_clone;ClassHandle.prototype["delete"]=ClassHandle_delete;ClassHandle.prototype["isDeleted"]=ClassHandle_isDeleted;ClassHandle.prototype["deleteLater"]=ClassHandle_deleteLater}function ClassHandle(){}function exposePublicSymbol(name,value,numArguments){if(Module.hasOwnProperty(name)){if(undefined===numArguments||undefined!==Module[name].overloadTable&&undefined!==Module[name].overloadTable[numArguments]){throwBindingError("Cannot register public name '"+name+"' twice")}ensureOverloadTable(Module,name,name);if(Module.hasOwnProperty(numArguments)){throwBindingError("Cannot register multiple overloads of a function with the same number of arguments ("+numArguments+")!")}Module[name].overloadTable[numArguments]=value}else{Module[name]=value;if(undefined!==numArguments){Module[name].numArguments=numArguments}}}function RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast){this.name=name;this.constructor=constructor;this.instancePrototype=instancePrototype;this.rawDestructor=rawDestructor;this.baseClass=baseClass;this.getActualType=getActualType;this.upcast=upcast;this.downcast=downcast;this.pureVirtualFunctions=[]}function replacePublicSymbol(name,value,numArguments){if(!Module.hasOwnProperty(name)){throwInternalError("Replacing nonexistant public symbol")}if(undefined!==Module[name].overloadTable&&undefined!==numArguments){Module[name].overloadTable[numArguments]=value}else{Module[name]=value;Module[name].argCount=numArguments}}function __embind_register_class(rawType,rawPointerType,rawConstPointerType,baseClassRawType,getActualTypeSignature,getActualType,upcastSignature,upcast,downcastSignature,downcast,name,destructorSignature,rawDestructor){name=readLatin1String(name);getActualType=requireFunction(getActualTypeSignature,getActualType);if(upcast){upcast=requireFunction(upcastSignature,upcast)}if(downcast){downcast=requireFunction(downcastSignature,downcast)}rawDestructor=requireFunction(destructorSignature,rawDestructor);var legalFunctionName=makeLegalFunctionName(name);exposePublicSymbol(legalFunctionName,(function(){throwUnboundTypeError("Cannot construct "+name+" due to unbound types",[baseClassRawType])}));whenDependentTypesAreResolved([rawType,rawPointerType,rawConstPointerType],baseClassRawType?[baseClassRawType]:[],(function(base){base=base[0];var baseClass;var basePrototype;if(baseClassRawType){baseClass=base.registeredClass;basePrototype=baseClass.instancePrototype}else{basePrototype=ClassHandle.prototype}var constructor=createNamedFunction(legalFunctionName,(function(){if(Object.getPrototypeOf(this)!==instancePrototype){throw new BindingError("Use 'new' to construct "+name)}if(undefined===registeredClass.constructor_body){throw new BindingError(name+" has no accessible constructor")}var body=registeredClass.constructor_body[arguments.length];if(undefined===body){throw new BindingError("Tried to invoke ctor of "+name+" with invalid number of parameters ("+arguments.length+") - expected ("+Object.keys(registeredClass.constructor_body).toString()+") parameters instead!")}return body.apply(this,arguments)}));var instancePrototype=Object.create(basePrototype,{constructor:{value:constructor}});constructor.prototype=instancePrototype;var registeredClass=new RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast);var referenceConverter=new RegisteredPointer(name,registeredClass,true,false,false);var pointerConverter=new RegisteredPointer(name+"*",registeredClass,false,false,false);var constPointerConverter=new RegisteredPointer(name+" const*",registeredClass,false,true,false);registeredPointers[rawType]={pointerType:pointerConverter,constPointerType:constPointerConverter};replacePublicSymbol(legalFunctionName,constructor);return[referenceConverter,pointerConverter,constPointerConverter]}))}function ___lock(){}function ___unlock(){}function _pthread_mutexattr_init(){}function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}function _embind_repr(v){if(v===null){return"null"}var t=typeof v;if(t==="object"||t==="array"||t==="function"){return v.toString()}else{return""+v}}function integerReadValueFromPointer(name,shift,signed){switch(shift){case 0:return signed?function readS8FromPointer(pointer){return HEAP8[pointer]}:function readU8FromPointer(pointer){return HEAPU8[pointer]};case 1:return signed?function readS16FromPointer(pointer){return HEAP16[pointer>>1]}:function readU16FromPointer(pointer){return HEAPU16[pointer>>1]};case 2:return signed?function readS32FromPointer(pointer){return HEAP32[pointer>>2]}:function readU32FromPointer(pointer){return HEAPU32[pointer>>2]};default:throw new TypeError("Unknown integer type: "+name)}}function __embind_register_integer(primitiveType,name,size,minRange,maxRange){name=readLatin1String(name);if(maxRange===-1){maxRange=4294967295}var shift=getShiftFromSize(size);var fromWireType=(function(value){return value});if(minRange===0){var bitshift=32-8*size;fromWireType=(function(value){return value<<bitshift>>>bitshift})}var isUnsignedType=name.indexOf("unsigned")!=-1;registerType(primitiveType,{name:name,"fromWireType":fromWireType,"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}if(value<minRange||value>maxRange){throw new TypeError('Passing a number "'+_embind_repr(value)+'" from JS side to C/C++ side to an argument of type "'+name+'", which is outside the valid range ['+minRange+", "+maxRange+"]!")}return isUnsignedType?value>>>0:value|0}),"argPackAdvance":8,"readValueFromPointer":integerReadValueFromPointer(name,shift,minRange!==0),destructorFunction:null})}function __emval_get_property(handle,key){handle=requireHandle(handle);key=requireHandle(key);return __emval_register(handle[key])}function __embind_register_emval(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(handle){var rv=emval_handle_array[handle].value;__emval_decref(handle);return rv}),"toWireType":(function(destructors,value){return __emval_register(value)}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:null})}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function __embind_register_value_array_element(rawTupleType,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){tupleRegistrations[rawTupleType].elements.push({getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ___cxa_allocate_exception(size){return _malloc(size)}function ___cxa_pure_virtual(){ABORT=true;throw"Pure virtual function called!"}function floatReadValueFromPointer(name,shift){switch(shift){case 2:return(function(pointer){return this["fromWireType"](HEAPF32[pointer>>2])});case 3:return(function(pointer){return this["fromWireType"](HEAPF64[pointer>>3])});default:throw new TypeError("Unknown float type: "+name)}}function __embind_register_float(rawType,name,size){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){return value}),"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}return value}),"argPackAdvance":8,"readValueFromPointer":floatReadValueFromPointer(name,shift),destructorFunction:null})}function __embind_register_function(name,argCount,rawArgTypesAddr,signature,rawInvoker,fn){var argTypes=heap32VectorToArray(argCount,rawArgTypesAddr);name=readLatin1String(name);rawInvoker=requireFunction(signature,rawInvoker);exposePublicSymbol(name,(function(){throwUnboundTypeError("Cannot call "+name+" due to unbound types",argTypes)}),argCount-1);whenDependentTypesAreResolved([],argTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));replacePublicSymbol(name,craftInvokerFunction(name,invokerArgsArray,null,rawInvoker,fn),argCount-1);return[]}))}function __embind_register_constant(name,type,value){name=readLatin1String(name);whenDependentTypesAreResolved([],[type],(function(type){type=type[0];Module[name]=type["fromWireType"](value);return[]}))}function ___cxa_begin_catch(ptr){var info=EXCEPTIONS.infos[ptr];if(info&&!info.caught){info.caught=true;__ZSt18uncaught_exceptionv.uncaught_exception--}if(info)info.rethrown=false;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}function ___syscall3(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.read(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall5(which,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(),flags=SYSCALLS.get(),mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall4(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.write(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __embind_register_class_constructor(rawClassType,argCount,rawArgTypesAddr,invokerSignature,invoker,rawConstructor){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);invoker=requireFunction(invokerSignature,invoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName="constructor "+classType.name;if(undefined===classType.registeredClass.constructor_body){classType.registeredClass.constructor_body=[]}if(undefined!==classType.registeredClass.constructor_body[argCount-1]){throw new BindingError("Cannot register multiple constructors with identical number of parameters ("+(argCount-1)+") for class '"+classType.name+"'! Overload resolution is currently only performed using the parameter count, not actual type info!")}classType.registeredClass.constructor_body[argCount-1]=function unboundTypeHandler(){throwUnboundTypeError("Cannot construct "+classType.name+" due to unbound types",rawArgTypes)};whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){classType.registeredClass.constructor_body[argCount-1]=function constructor_body(){if(arguments.length!==argCount-1){throwBindingError(humanName+" called with "+arguments.length+" arguments, expected "+(argCount-1))}var destructors=[];var args=new Array(argCount);args[0]=rawConstructor;for(var i=1;i<argCount;++i){args[i]=argTypes[i]["toWireType"](destructors,arguments[i-1])}var ptr=invoker.apply(null,args);runDestructors(destructors);return argTypes[0]["fromWireType"](ptr)};return[]}));return[]}))}function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __embind_register_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,context,isPureVirtual){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;if(isPureVirtual){classType.registeredClass.pureVirtualFunctions.push(methodName)}function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.instancePrototype;var method=proto[methodName];if(undefined===method||undefined===method.overloadTable&&method.className!==classType.name&&method.argCount===argCount-2){unboundTypesHandler.argCount=argCount-2;unboundTypesHandler.className=classType.name;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-2]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var memberFunction=craftInvokerFunction(humanName,argTypes,classType,rawInvoker,context);if(undefined===proto[methodName].overloadTable){memberFunction.argCount=argCount-2;proto[methodName]=memberFunction}else{proto[methodName].overloadTable[argCount-2]=memberFunction}return[]}));return[]}))}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doWritev(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall221(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),cmd=SYSCALLS.get();switch(cmd){case 0:{var arg=SYSCALLS.get();if(arg<0){return-ERRNO_CODES.EINVAL}var newStream;newStream=FS.open(stream.path,stream.flags,0,arg);return newStream.fd};case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=SYSCALLS.get();stream.flags|=arg;return 0};case 12:case 12:{var arg=SYSCALLS.get();var offset=0;HEAP16[arg+offset>>1]=2;return 0};case 13:case 14:case 13:case 14:return 0;case 16:case 8:return-ERRNO_CODES.EINVAL;case 9:___setErrNo(ERRNO_CODES.EINVAL);return-1;default:{return-ERRNO_CODES.EINVAL}}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var ___dso_handle=STATICTOP;STATICTOP+=16;embind_init_charCodes();init_emval();BindingError=Module["BindingError"]=extendError(Error,"BindingError");InternalError=Module["InternalError"]=extendError(Error,"InternalError");FS.staticInit();__ATINIT__.unshift((function(){if(!Module["noFSInit"]&&!FS.init.initialized)FS.init()}));__ATMAIN__.push((function(){FS.ignorePermissions=false}));__ATEXIT__.push((function(){FS.quit()}));Module["FS_createFolder"]=FS.createFolder;Module["FS_createPath"]=FS.createPath;Module["FS_createDataFile"]=FS.createDataFile;Module["FS_createPreloadedFile"]=FS.createPreloadedFile;Module["FS_createLazyFile"]=FS.createLazyFile;Module["FS_createLink"]=FS.createLink;Module["FS_createDevice"]=FS.createDevice;Module["FS_unlink"]=FS.unlink;__ATINIT__.unshift((function(){TTY.init()}));__ATEXIT__.push((function(){TTY.shutdown()}));if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}Module["requestFullScreen"]=function Module_requestFullScreen(lockPointer,resizeCanvas,vrDevice){Module.printErr("Module.requestFullScreen is deprecated. Please call Module.requestFullscreen instead.");Module["requestFullScreen"]=Module["requestFullscreen"];Browser.requestFullScreen(lockPointer,resizeCanvas,vrDevice)};Module["requestFullscreen"]=function Module_requestFullscreen(lockPointer,resizeCanvas,vrDevice){Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)};Module["requestAnimationFrame"]=function Module_requestAnimationFrame(func){Browser.requestAnimationFrame(func)};Module["setCanvasSize"]=function Module_setCanvasSize(width,height,noUpdates){Browser.setCanvasSize(width,height,noUpdates)};Module["pauseMainLoop"]=function Module_pauseMainLoop(){Browser.mainLoop.pause()};Module["resumeMainLoop"]=function Module_resumeMainLoop(){Browser.mainLoop.resume()};Module["getUserMedia"]=function Module_getUserMedia(){Browser.getUserMedia()};Module["createContext"]=function Module_createContext(canvas,useWebGL,setInModule,webGLContextAttributes){return Browser.createContext(canvas,useWebGL,setInModule,webGLContextAttributes)};if(ENVIRONMENT_IS_NODE){_emscripten_get_now=function _emscripten_get_now_actual(){var t=process["hrtime"]();return t[0]*1e3+t[1]/1e6}}else if(typeof dateNow!=="undefined"){_emscripten_get_now=dateNow}else if(typeof self==="object"&&self["performance"]&&typeof self["performance"]["now"]==="function"){_emscripten_get_now=(function(){return self["performance"]["now"]()})}else if(typeof performance==="object"&&typeof performance["now"]==="function"){_emscripten_get_now=(function(){return performance["now"]()})}else{_emscripten_get_now=Date.now}init_RegisteredPointer();init_embind();UnboundTypeError=Module["UnboundTypeError"]=extendError(Error,"UnboundTypeError");___buildEnvironment(ENV);init_ClassHandle();DYNAMICTOP_PTR=allocate(1,"i32",ALLOC_STATIC);STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=Runtime.alignMemory(STACK_MAX);HEAP32[DYNAMICTOP_PTR>>2]=DYNAMIC_BASE;staticSealed=true;function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viidiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iidi(index,a1,a2,a3){try{return Module["dynCall_iidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddidd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidi(index,a1,a2,a3){try{Module["dynCall_vidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiddii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddid(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiddid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiidi(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiidi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiidi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiddii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiidd(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiidd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_di(index,a1){try{return Module["dynCall_di"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiddi(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiddiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vdii(index,a1,a2,a3){try{Module["dynCall_vdii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_diiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return Module["dynCall_iiiiiddiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_dii(index,a1,a2){try{return Module["dynCall_dii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiddid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiddid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiidiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiid(index,a1,a2,a3,a4){try{return Module["dynCall_iiiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiddi(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiididiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{return Module["dynCall_iiiiiiiididiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiidddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viidiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viidiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{Module["dynCall_viiiiiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiddi(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_diiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiididii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiididii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_diiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return Module["dynCall_iiidiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidd(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiidd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidi(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiidi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiidiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiddiddd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{return Module["dynCall_iiiiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiddi(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiddi(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diii(index,a1,a2,a3){try{return Module["dynCall_diii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiddii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiddii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiddiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiid(index,a1,a2,a3,a4){try{Module["dynCall_viiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiidii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiidii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viidiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vid(index,a1,a2){try{Module["dynCall_vid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidi(index,a1,a2,a3,a4){try{return Module["dynCall_iiidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidd(index,a1,a2,a3,a4){try{return Module["dynCall_iiidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiid(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidd(index,a1,a2,a3,a4){try{Module["dynCall_viidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidi(index,a1,a2,a3,a4){try{Module["dynCall_viidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiidii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiidii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiid(index,a1,a2,a3,a4){try{return Module["dynCall_diiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiii(index,a1,a2,a3,a4){try{return Module["dynCall_diiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{Module["dynCall_viiiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iid(index,a1,a2){try{return Module["dynCall_iid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiddid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididdi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viididdi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddi(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiididi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiididi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vdiii(index,a1,a2,a3,a4){try{Module["dynCall_vdiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiidddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viid(index,a1,a2,a3){try{Module["dynCall_viid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiddiid(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiddiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vididdi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_vididdi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidii(index,a1,a2,a3,a4){try{Module["dynCall_vidii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiidiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiidiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiidi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viidiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viididii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiddid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiid(index,a1,a2,a3){try{return Module["dynCall_iiid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiidii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{return Module["dynCall_iiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiidd(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiidd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiidii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){try{return Module["dynCall_iiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiidiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{return Module["dynCall_iiidiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_i(index){try{return Module["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_diiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vididdii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_vididdii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{Module["dynCall_viiiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiidi(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiidd(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viididi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididdii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viididdii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiidiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiidd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_vidiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity,"byteLength":byteLength};Module.asmLibraryArg={"abort":abort,"assert":assert,"enlargeMemory":enlargeMemory,"getTotalMemory":getTotalMemory,"abortOnCannotGrowMemory":abortOnCannotGrowMemory,"invoke_iiiiiid":invoke_iiiiiid,"invoke_viiiiddd":invoke_viiiiddd,"invoke_viiiidiii":invoke_viiiidiii,"invoke_viiiiiddi":invoke_viiiiiddi,"invoke_viiidiii":invoke_viiidiii,"invoke_viiiidiid":invoke_viiiidiid,"invoke_iiiiiii":invoke_iiiiiii,"invoke_viiiidddiiii":invoke_viiiidddiiii,"invoke_viiiiddi":invoke_viiiiddi,"invoke_viiiddddi":invoke_viiiddddi,"invoke_viidiii":invoke_viidiii,"invoke_viiiiiiiiiii":invoke_viiiiiiiiiii,"invoke_viiiiiiiiiid":invoke_viiiiiiiiiid,"invoke_viiidddd":invoke_viiidddd,"invoke_iidi":invoke_iidi,"invoke_viiddidd":invoke_viiddidd,"invoke_vidi":invoke_vidi,"invoke_viiddii":invoke_viiddii,"invoke_viiddid":invoke_viiddid,"invoke_iiiidi":invoke_iiiidi,"invoke_viiiiidi":invoke_viiiiidi,"invoke_viiddidddd":invoke_viiddidddd,"invoke_viiiiddiiii":invoke_viiiiddiiii,"invoke_viiiiiiidd":invoke_viiiiiiidd,"invoke_viiiiddiiid":invoke_viiiiddiiid,"invoke_viiiiiiidi":invoke_viiiiiiidi,"invoke_viiiddii":invoke_viiiddii,"invoke_iiiidd":invoke_iiiidd,"invoke_viiiiidd":invoke_viiiiidd,"invoke_viiiiddiddi":invoke_viiiiddiddi,"invoke_di":invoke_di,"invoke_viiiiiidiiii":invoke_viiiiiidiiii,"invoke_iiiiddi":invoke_iiiiddi,"invoke_viiiidiiddi":invoke_viiiidiiddi,"invoke_viiiiddiiiid":invoke_viiiiddiiiid,"invoke_viiiiddiii":invoke_viiiiddiii,"invoke_vdii":invoke_vdii,"invoke_diiiiiii":invoke_diiiiiii,"invoke_iiiiiddiddi":invoke_iiiiiddiddi,"invoke_dii":invoke_dii,"invoke_viiiddiiii":invoke_viiiddiiii,"invoke_viiiddiiid":invoke_viiiddiiid,"invoke_viiiidiidd":invoke_viiiidiidd,"invoke_iiiiiddid":invoke_iiiiiddid,"invoke_iiiii":invoke_iiiii,"invoke_viiiiidiiiii":invoke_viiiiidiiiii,"invoke_viiidddi":invoke_viiidddi,"invoke_viiiiidiidd":invoke_viiiiidiidd,"invoke_iiiid":invoke_iiiid,"invoke_iiiddiiid":invoke_iiiddiiid,"invoke_iiiiiiii":invoke_iiiiiiii,"invoke_iiiddi":invoke_iiiddi,"invoke_viiddiii":invoke_viiddiii,"invoke_viiddiid":invoke_viiddiid,"invoke_iiiiiiiididiii":invoke_iiiiiiiididiii,"invoke_viiidddiii":invoke_viiidddiii,"invoke_viidiiid":invoke_viidiiid,"invoke_viiiidiiii":invoke_viiiidiiii,"invoke_viidiiii":invoke_viidiiii,"invoke_viiiiiiiiiiddi":invoke_viiiiiiiiiiddi,"invoke_diiiddi":invoke_diiiddi,"invoke_viiididii":invoke_viiididii,"invoke_diiiiiiii":invoke_diiiiiiii,"invoke_viiidiiid":invoke_viiidiiid,"invoke_viiiddddii":invoke_viiiddddii,"invoke_iiidiiiiiii":invoke_iiidiiiiiii,"invoke_viiiiid":invoke_viiiiid,"invoke_viiiiddddii":invoke_viiiiddddii,"invoke_viiiiii":invoke_viiiiii,"invoke_viiidiiii":invoke_viiidiiii,"invoke_viiiiiidi":invoke_viiiiiidi,"invoke_viiiiiidiii":invoke_viiiiiidiii,"invoke_viiiidddii":invoke_viiiidddii,"invoke_viiidd":invoke_viiidd,"invoke_viiidi":invoke_viiidi,"invoke_iiidiiii":invoke_iiidiiii,"invoke_viiddiddd":invoke_viiddiddd,"invoke_viiiiiiiiii":invoke_viiiiiiiiii,"invoke_iiiiiddidd":invoke_iiiiiddidd,"invoke_diiddi":invoke_diiddi,"invoke_iiiiiddi":invoke_iiiiiddi,"invoke_diii":invoke_diii,"invoke_viiiddd":invoke_viiiddd,"invoke_viidiiiii":invoke_viidiiiii,"invoke_iiiddii":invoke_iiiddii,"invoke_viiiddidd":invoke_viiiddidd,"invoke_viiidiiiidi":invoke_viiidiiiidi,"invoke_viiiddiiiid":invoke_viiiddiiiid,"invoke_viiiddi":invoke_viiiddi,"invoke_iiiiii":invoke_iiiiii,"invoke_viiid":invoke_viiid,"invoke_iiiiidii":invoke_iiiiidii,"invoke_viidii":invoke_viidii,"invoke_iiiiid":invoke_iiiiid,"invoke_viiiidddi":invoke_viiiidddi,"invoke_viiii":invoke_viiii,"invoke_viiddiiid":invoke_viiddiiid,"invoke_viiiii":invoke_viiiii,"invoke_iiiiiiddi":invoke_iiiiiiddi,"invoke_viidiiiiiii":invoke_viidiiiiiii,"invoke_vid":invoke_vid,"invoke_iiidi":invoke_iiidi,"invoke_iiidd":invoke_iiidd,"invoke_vii":invoke_vii,"invoke_viiiid":invoke_viiiid,"invoke_viiiiddddi":invoke_viiiiddddi,"invoke_iiiiidiii":invoke_iiiiidiii,"invoke_viidd":invoke_viidd,"invoke_viidi":invoke_viidi,"invoke_viiidiiddi":invoke_viiidiiddi,"invoke_iiiidii":invoke_iiiidii,"invoke_diiid":invoke_diiid,"invoke_viiidddii":invoke_viiidddii,"invoke_viiiiiiii":invoke_viiiiiiii,"invoke_viiidddiiii":invoke_viiidddiiii,"invoke_viiiiiiid":invoke_viiiiiiid,"invoke_viiiiiiddi":invoke_viiiiiiddi,"invoke_diiii":invoke_diiii,"invoke_viiiiidiiddi":invoke_viiiiidiiddi,"invoke_viiiddidddd":invoke_viiiddidddd,"invoke_viiiiiiiiiiid":invoke_viiiiiiiiiiid,"invoke_viiiiidii":invoke_viiiiidii,"invoke_viiiddiddd":invoke_viiiddiddd,"invoke_iid":invoke_iid,"invoke_viiiddid":invoke_viiiddid,"invoke_viiiiiii":invoke_viiiiiii,"invoke_viididdi":invoke_viididdi,"invoke_viiiiiid":invoke_viiiiiid,"invoke_viiiiiiiii":invoke_viiiiiiiii,"invoke_iii":invoke_iii,"invoke_viiddi":invoke_viiddi,"invoke_viiididi":invoke_viiididi,"invoke_vdiii":invoke_vdiii,"invoke_viiiiiidii":invoke_viiiiiidii,"invoke_viiiiddidd":invoke_viiiiddidd,"invoke_viiiidddiii":invoke_viiiidddiii,"invoke_viii":invoke_viii,"invoke_v":invoke_v,"invoke_viid":invoke_viid,"invoke_iiiddiid":invoke_iiiddiid,"invoke_viiiiidiiii":invoke_viiiiidiiii,"invoke_vi":invoke_vi,"invoke_viiiidiiiidi":invoke_viiiidiiiidi,"invoke_ii":invoke_ii,"invoke_viiiiiiiddi":invoke_viiiiiiiddi,"invoke_vididdi":invoke_vididdi,"invoke_viiiiiidd":invoke_viiiiiidd,"invoke_vidii":invoke_vidii,"invoke_iiiidiii":invoke_iiiidiii,"invoke_viiiidi":invoke_viiiidi,"invoke_viiiddiii":invoke_viiiddiii,"invoke_viidiiiiii":invoke_viidiiiiii,"invoke_iiii":invoke_iiii,"invoke_viididii":invoke_viididii,"invoke_viiiidddd":invoke_viiiidddd,"invoke_viiiiddii":invoke_viiiiddii,"invoke_viiiiddid":invoke_viiiiddid,"invoke_iiid":invoke_iiid,"invoke_viiiiiiiiidd":invoke_viiiiiiiiidd,"invoke_viiiidii":invoke_viiiidii,"invoke_diiiii":invoke_diiiii,"invoke_diiiid":invoke_diiiid,"invoke_iiiiiiiiiiiii":invoke_iiiiiiiiiiiii,"invoke_iiiiidd":invoke_iiiiidd,"invoke_viiidii":invoke_viiidii,"invoke_iiiiiiiiiiiiiii":invoke_iiiiiiiiiiiiiii,"invoke_iiiiidi":invoke_iiiiidi,"invoke_iiidiii":invoke_iiidiii,"invoke_iiidiiiiii":invoke_iiidiiiiii,"invoke_i":invoke_i,"invoke_iiidii":invoke_iiidii,"invoke_diiiiii":invoke_diiiiii,"invoke_iiidiiiii":invoke_iiidiiiii,"invoke_vididdii":invoke_vididdii,"invoke_viiiiiidiiiii":invoke_viiiiiidiiiii,"invoke_iiiiiidi":invoke_iiiiiidi,"invoke_iiiiiidd":invoke_iiiiiidd,"invoke_viiiiidiii":invoke_viiiiidiii,"invoke_viididi":invoke_viididi,"invoke_iiiiiiiii":invoke_iiiiiiiii,"invoke_viididdii":invoke_viididdii,"invoke_viiiiidiid":invoke_viiiiidiid,"invoke_viiiidd":invoke_viiiidd,"invoke_vidiii":invoke_vidiii,"___syscall221":___syscall221,"floatReadValueFromPointer":floatReadValueFromPointer,"simpleReadValueFromPointer":simpleReadValueFromPointer,"__emval_call_void_method":__emval_call_void_method,"throwInternalError":throwInternalError,"get_first_emval":get_first_emval,"whenDependentTypesAreResolved":whenDependentTypesAreResolved,"constNoSmartPtrRawPointerToWireType":constNoSmartPtrRawPointerToWireType,"getLiveInheritedInstances":getLiveInheritedInstances,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"ClassHandle":ClassHandle,"getShiftFromSize":getShiftFromSize,"__emval_get_property":__emval_get_property,"_llvm_exp2_f64":_llvm_exp2_f64,"__addDays":__addDays,"_emscripten_set_main_loop_timing":_emscripten_set_main_loop_timing,"___cxa_begin_catch":___cxa_begin_catch,"_emscripten_memcpy_big":_emscripten_memcpy_big,"runDestructor":runDestructor,"throwInstanceAlreadyDeleted":throwInstanceAlreadyDeleted,"__embind_register_std_string":__embind_register_std_string,"init_RegisteredPointer":init_RegisteredPointer,"getStringOrSymbol":getStringOrSymbol,"flushPendingDeletes":flushPendingDeletes,"_pthread_mutexattr_settype":_pthread_mutexattr_settype,"makeClassHandle":makeClassHandle,"__isLeapYear":__isLeapYear,"__embind_register_class_constructor":__embind_register_class_constructor,"___cxa_atexit":___cxa_atexit,"__embind_finalize_value_array":__embind_finalize_value_array,"__emval_allocateDestructors":__emval_allocateDestructors,"init_ClassHandle":init_ClassHandle,"__embind_register_constant":__embind_register_constant,"___syscall140":___syscall140,"ClassHandle_clone":ClassHandle_clone,"___syscall145":___syscall145,"___syscall146":___syscall146,"throwBindingError":throwBindingError,"RegisteredClass":RegisteredClass,"___cxa_find_matching_catch":___cxa_find_matching_catch,"__embind_register_value_object_field":__embind_register_value_object_field,"embind_init_charCodes":embind_init_charCodes,"__emval_as":__emval_as,"___setErrNo":___setErrNo,"readLatin1String":readLatin1String,"_llvm_pow_f32":_llvm_pow_f32,"__embind_register_bool":__embind_register_bool,"___resumeException":___resumeException,"createNamedFunction":createNamedFunction,"__embind_register_class_property":__embind_register_class_property,"__embind_register_emval":__embind_register_emval,"___buildEnvironment":___buildEnvironment,"__embind_finalize_value_object":__embind_finalize_value_object,"__emval_decref":__emval_decref,"_pthread_once":_pthread_once,"__embind_register_class":__embind_register_class,"___syscall91":___syscall91,"__emval_addMethodCaller":__emval_addMethodCaller,"heap32VectorToArray":heap32VectorToArray,"__emval_lookupTypes":__emval_lookupTypes,"_emscripten_get_now":_emscripten_get_now,"__emval_run_destructors":__emval_run_destructors,"ClassHandle_delete":ClassHandle_delete,"___syscall3":___syscall3,"RegisteredPointer_destructor":RegisteredPointer_destructor,"_llvm_exp2_f32":_llvm_exp2_f32,"___syscall6":___syscall6,"___syscall5":___syscall5,"ensureOverloadTable":ensureOverloadTable,"_gettimeofday":_gettimeofday,"new_":new_,"downcastPointer":downcastPointer,"replacePublicSymbol":replacePublicSymbol,"init_embind":init_embind,"_llvm_pow_f64":_llvm_pow_f64,"ClassHandle_deleteLater":ClassHandle_deleteLater,"___syscall54":___syscall54,"_sched_yield":_sched_yield,"RegisteredPointer_deleteObject":RegisteredPointer_deleteObject,"ClassHandle_isDeleted":ClassHandle_isDeleted,"__embind_register_integer":__embind_register_integer,"___cxa_allocate_exception":___cxa_allocate_exception,"__emval_take_value":__emval_take_value,"__embind_register_value_object":__embind_register_value_object,"getTypeName":getTypeName,"_strftime":_strftime,"__embind_register_class_function":__embind_register_class_function,"throwUnboundTypeError":throwUnboundTypeError,"craftInvokerFunction":craftInvokerFunction,"_getenv":_getenv,"runDestructors":runDestructors,"requireRegisteredType":requireRegisteredType,"makeLegalFunctionName":makeLegalFunctionName,"_pthread_key_create":_pthread_key_create,"upcastPointer":upcastPointer,"init_emval":init_emval,"shallowCopyInternalPointer":shallowCopyInternalPointer,"nonConstNoSmartPtrRawPointerToWireType":nonConstNoSmartPtrRawPointerToWireType,"__embind_register_value_array":__embind_register_value_array,"_abort":_abort,"requireHandle":requireHandle,"_embind_repr":_embind_repr,"validateThis":validateThis,"exposePublicSymbol":exposePublicSymbol,"RegisteredPointer_fromWireType":RegisteredPointer_fromWireType,"___cxa_pure_virtual":___cxa_pure_virtual,"__emval_get_method_caller":__emval_get_method_caller,"_pthread_getspecific":_pthread_getspecific,"_pthread_cond_wait":_pthread_cond_wait,"___lock":___lock,"__embind_register_value_array_element":__embind_register_value_array_element,"__embind_register_memory_view":__embind_register_memory_view,"getInheritedInstance":getInheritedInstance,"setDelayFunction":setDelayFunction,"___gxx_personality_v0":___gxx_personality_v0,"extendError":extendError,"___syscall4":___syscall4,"__emval_new_array":__emval_new_array,"__embind_register_void":__embind_register_void,"__embind_register_smart_ptr":__embind_register_smart_ptr,"__embind_register_function":__embind_register_function,"_pthread_mutexattr_destroy":_pthread_mutexattr_destroy,"_strftime_l":_strftime_l,"RegisteredPointer_getPointee":RegisteredPointer_getPointee,"__emval_register":__emval_register,"__embind_register_std_wstring":__embind_register_std_wstring,"ClassHandle_isAliasOf":ClassHandle_isAliasOf,"__emval_incref":__emval_incref,"RegisteredPointer":RegisteredPointer,"__arraySum":__arraySum,"__embind_register_class_class_function":__embind_register_class_class_function,"_pthread_mutex_destroy":_pthread_mutex_destroy,"getBasestPointer":getBasestPointer,"getInheritedInstanceCount":getInheritedInstanceCount,"__embind_register_float":__embind_register_float,"integerReadValueFromPointer":integerReadValueFromPointer,"___unlock":___unlock,"_emscripten_set_main_loop":_emscripten_set_main_loop,"_pthread_mutexattr_init":_pthread_mutexattr_init,"_pthread_setspecific":_pthread_setspecific,"genericPointerToWireType":genericPointerToWireType,"registerType":registerType,"___cxa_throw":___cxa_throw,"__emval_new_cstring":__emval_new_cstring,"count_emval_handles":count_emval_handles,"requireFunction":requireFunction,"_atexit":_atexit,"_pthread_mutex_init":_pthread_mutex_init,"___map_file":___map_file,"DYNAMICTOP_PTR":DYNAMICTOP_PTR,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"cttz_i8":cttz_i8,"___dso_handle":___dso_handle};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"almost asm";var a=global.Int8Array;var b=new a(buffer);var c=global.Int16Array;var d=new c(buffer);var e=global.Int32Array;var f=new e(buffer);var g=global.Uint8Array;var h=new g(buffer);var i=global.Uint16Array;var j=new i(buffer);var k=global.Uint32Array;var l=new k(buffer);var m=global.Float32Array;var n=new m(buffer);var o=global.Float64Array;var p=new o(buffer);var q=global.byteLength;var r=env.DYNAMICTOP_PTR|0;var s=env.tempDoublePtr|0;var t=env.ABORT|0;var u=env.STACKTOP|0;var v=env.STACK_MAX|0;var w=env.cttz_i8|0;var x=env.___dso_handle|0;var y=0;var z=0;var A=0;var B=0;var C=global.NaN,D=global.Infinity;var E=0,F=0,G=0,H=0,I=0.0;var J=0;var K=global.Math.floor;var L=global.Math.abs;var M=global.Math.sqrt;var N=global.Math.pow;var O=global.Math.cos;var P=global.Math.sin;var Q=global.Math.tan;var R=global.Math.acos;var S=global.Math.asin;var T=global.Math.atan;var U=global.Math.atan2;var V=global.Math.exp;var W=global.Math.log;var X=global.Math.ceil;var Y=global.Math.imul;var Z=global.Math.min;var _=global.Math.max;var $=global.Math.clz32;var aa=env.abort;var ba=env.assert;var ca=env.enlargeMemory;var da=env.getTotalMemory;var ea=env.abortOnCannotGrowMemory;var fa=env.invoke_iiiiiid;var ga=env.invoke_viiiiddd;var ha=env.invoke_viiiidiii;var ia=env.invoke_viiiiiddi;var ja=env.invoke_viiidiii;var ka=env.invoke_viiiidiid;var la=env.invoke_iiiiiii;var ma=env.invoke_viiiidddiiii;var na=env.invoke_viiiiddi;var oa=env.invoke_viiiddddi;var pa=env.invoke_viidiii;var qa=env.invoke_viiiiiiiiiii;var ra=env.invoke_viiiiiiiiiid;var sa=env.invoke_viiidddd;var ta=env.invoke_iidi;var ua=env.invoke_viiddidd;var va=env.invoke_vidi;var wa=env.invoke_viiddii;var xa=env.invoke_viiddid;var ya=env.invoke_iiiidi;var za=env.invoke_viiiiidi;var Aa=env.invoke_viiddidddd;var Ba=env.invoke_viiiiddiiii;var Ca=env.invoke_viiiiiiidd;var Da=env.invoke_viiiiddiiid;var Ea=env.invoke_viiiiiiidi;var Fa=env.invoke_viiiddii;var Ga=env.invoke_iiiidd;var Ha=env.invoke_viiiiidd;var Ia=env.invoke_viiiiddiddi;var Ja=env.invoke_di;var Ka=env.invoke_viiiiiidiiii;var La=env.invoke_iiiiddi;var Ma=env.invoke_viiiidiiddi;var Na=env.invoke_viiiiddiiiid;var Oa=env.invoke_viiiiddiii;var Pa=env.invoke_vdii;var Qa=env.invoke_diiiiiii;var Ra=env.invoke_iiiiiddiddi;var Sa=env.invoke_dii;var Ta=env.invoke_viiiddiiii;var Ua=env.invoke_viiiddiiid;var Va=env.invoke_viiiidiidd;var Wa=env.invoke_iiiiiddid;var Xa=env.invoke_iiiii;var Ya=env.invoke_viiiiidiiiii;var Za=env.invoke_viiidddi;var _a=env.invoke_viiiiidiidd;var $a=env.invoke_iiiid;var ab=env.invoke_iiiddiiid;var bb=env.invoke_iiiiiiii;var cb=env.invoke_iiiddi;var db=env.invoke_viiddiii;var eb=env.invoke_viiddiid;var fb=env.invoke_iiiiiiiididiii;var gb=env.invoke_viiidddiii;var hb=env.invoke_viidiiid;var ib=env.invoke_viiiidiiii;var jb=env.invoke_viidiiii;var kb=env.invoke_viiiiiiiiiiddi;var lb=env.invoke_diiiddi;var mb=env.invoke_viiididii;var nb=env.invoke_diiiiiiii;var ob=env.invoke_viiidiiid;var pb=env.invoke_viiiddddii;var qb=env.invoke_iiidiiiiiii;var rb=env.invoke_viiiiid;var sb=env.invoke_viiiiddddii;var tb=env.invoke_viiiiii;var ub=env.invoke_viiidiiii;var vb=env.invoke_viiiiiidi;var wb=env.invoke_viiiiiidiii;var xb=env.invoke_viiiidddii;var yb=env.invoke_viiidd;var zb=env.invoke_viiidi;var Ab=env.invoke_iiidiiii;var Bb=env.invoke_viiddiddd;var Cb=env.invoke_viiiiiiiiii;var Db=env.invoke_iiiiiddidd;var Eb=env.invoke_diiddi;var Fb=env.invoke_iiiiiddi;var Gb=env.invoke_diii;var Hb=env.invoke_viiiddd;var Ib=env.invoke_viidiiiii;var Jb=env.invoke_iiiddii;var Kb=env.invoke_viiiddidd;var Lb=env.invoke_viiidiiiidi;var Mb=env.invoke_viiiddiiiid;var Nb=env.invoke_viiiddi;var Ob=env.invoke_iiiiii;var Pb=env.invoke_viiid;var Qb=env.invoke_iiiiidii;var Rb=env.invoke_viidii;var Sb=env.invoke_iiiiid;var Tb=env.invoke_viiiidddi;var Ub=env.invoke_viiii;var Vb=env.invoke_viiddiiid;var Wb=env.invoke_viiiii;var Xb=env.invoke_iiiiiiddi;var Yb=env.invoke_viidiiiiiii;var Zb=env.invoke_vid;var _b=env.invoke_iiidi;var $b=env.invoke_iiidd;var ac=env.invoke_vii;var bc=env.invoke_viiiid;var cc=env.invoke_viiiiddddi;var dc=env.invoke_iiiiidiii;var ec=env.invoke_viidd;var fc=env.invoke_viidi;var gc=env.invoke_viiidiiddi;var hc=env.invoke_iiiidii;var ic=env.invoke_diiid;var jc=env.invoke_viiidddii;var kc=env.invoke_viiiiiiii;var lc=env.invoke_viiidddiiii;var mc=env.invoke_viiiiiiid;var nc=env.invoke_viiiiiiddi;var oc=env.invoke_diiii;var pc=env.invoke_viiiiidiiddi;var qc=env.invoke_viiiddidddd;var rc=env.invoke_viiiiiiiiiiid;var sc=env.invoke_viiiiidii;var tc=env.invoke_viiiddiddd;var uc=env.invoke_iid;var vc=env.invoke_viiiddid;var wc=env.invoke_viiiiiii;var xc=env.invoke_viididdi;var yc=env.invoke_viiiiiid;var zc=env.invoke_viiiiiiiii;var Ac=env.invoke_iii;var Bc=env.invoke_viiddi;var Cc=env.invoke_viiididi;var Dc=env.invoke_vdiii;var Ec=env.invoke_viiiiiidii;var Fc=env.invoke_viiiiddidd;var Gc=env.invoke_viiiidddiii;var Hc=env.invoke_viii;var Ic=env.invoke_v;var Jc=env.invoke_viid;var Kc=env.invoke_iiiddiid;var Lc=env.invoke_viiiiidiiii;var Mc=env.invoke_vi;var Nc=env.invoke_viiiidiiiidi;var Oc=env.invoke_ii;var Pc=env.invoke_viiiiiiiddi;var Qc=env.invoke_vididdi;var Rc=env.invoke_viiiiiidd;var Sc=env.invoke_vidii;var Tc=env.invoke_iiiidiii;var Uc=env.invoke_viiiidi;var Vc=env.invoke_viiiddiii;var Wc=env.invoke_viidiiiiii;var Xc=env.invoke_iiii;var Yc=env.invoke_viididii;var Zc=env.invoke_viiiidddd;var _c=env.invoke_viiiiddii;var $c=env.invoke_viiiiddid;var ad=env.invoke_iiid;var bd=env.invoke_viiiiiiiiidd;var cd=env.invoke_viiiidii;var dd=env.invoke_diiiii;var ed=env.invoke_diiiid;var fd=env.invoke_iiiiiiiiiiiii;var gd=env.invoke_iiiiidd;var hd=env.invoke_viiidii;var id=env.invoke_iiiiiiiiiiiiiii;var jd=env.invoke_iiiiidi;var kd=env.invoke_iiidiii;var ld=env.invoke_iiidiiiiii;var md=env.invoke_i;var nd=env.invoke_iiidii;var od=env.invoke_diiiiii;var pd=env.invoke_iiidiiiii;var qd=env.invoke_vididdii;var rd=env.invoke_viiiiiidiiiii;var sd=env.invoke_iiiiiidi;var td=env.invoke_iiiiiidd;var ud=env.invoke_viiiiidiii;var vd=env.invoke_viididi;var wd=env.invoke_iiiiiiiii;var xd=env.invoke_viididdii;var yd=env.invoke_viiiiidiid;var zd=env.invoke_viiiidd;var Ad=env.invoke_vidiii;var Bd=env.___syscall221;var Cd=env.floatReadValueFromPointer;var Dd=env.simpleReadValueFromPointer;var Ed=env.__emval_call_void_method;var Fd=env.throwInternalError;var Gd=env.get_first_emval;var Hd=env.whenDependentTypesAreResolved;var Id=env.constNoSmartPtrRawPointerToWireType;var Jd=env.getLiveInheritedInstances;var Kd=env.__ZSt18uncaught_exceptionv;var Ld=env.ClassHandle;var Md=env.getShiftFromSize;var Nd=env.__emval_get_property;var Od=env._llvm_exp2_f64;var Pd=env.__addDays;var Qd=env._emscripten_set_main_loop_timing;var Rd=env.___cxa_begin_catch;var Sd=env._emscripten_memcpy_big;var Td=env.runDestructor;var Ud=env.throwInstanceAlreadyDeleted;var Vd=env.__embind_register_std_string;var Wd=env.init_RegisteredPointer;var Xd=env.getStringOrSymbol;var Yd=env.flushPendingDeletes;var Zd=env._pthread_mutexattr_settype;var _d=env.makeClassHandle;var $d=env.__isLeapYear;var ae=env.__embind_register_class_constructor;var be=env.___cxa_atexit;var ce=env.__embind_finalize_value_array;var de=env.__emval_allocateDestructors;var ee=env.init_ClassHandle;var fe=env.__embind_register_constant;var ge=env.___syscall140;var he=env.ClassHandle_clone;var ie=env.___syscall145;var je=env.___syscall146;var ke=env.throwBindingError;var le=env.RegisteredClass;var me=env.___cxa_find_matching_catch;var ne=env.__embind_register_value_object_field;var oe=env.embind_init_charCodes;var pe=env.__emval_as;var qe=env.___setErrNo;var re=env.readLatin1String;var se=env._llvm_pow_f32;var te=env.__embind_register_bool;var ue=env.___resumeException;var ve=env.createNamedFunction;var we=env.__embind_register_class_property;var xe=env.__embind_register_emval;var ye=env.___buildEnvironment;var ze=env.__embind_finalize_value_object;var Ae=env.__emval_decref;var Be=env._pthread_once;var Ce=env.__embind_register_class;var De=env.___syscall91;var Ee=env.__emval_addMethodCaller;var Fe=env.heap32VectorToArray;var Ge=env.__emval_lookupTypes;var He=env._emscripten_get_now;var Ie=env.__emval_run_destructors;var Je=env.ClassHandle_delete;var Ke=env.___syscall3;var Le=env.RegisteredPointer_destructor;var Me=env._llvm_exp2_f32;var Ne=env.___syscall6;var Oe=env.___syscall5;var Pe=env.ensureOverloadTable;var Qe=env._gettimeofday;var Re=env.new_;var Se=env.downcastPointer;var Te=env.replacePublicSymbol;var Ue=env.init_embind;var Ve=env._llvm_pow_f64;var We=env.ClassHandle_deleteLater;var Xe=env.___syscall54;var Ye=env._sched_yield;var Ze=env.RegisteredPointer_deleteObject;var _e=env.ClassHandle_isDeleted;var $e=env.__embind_register_integer;var af=env.___cxa_allocate_exception;var bf=env.__emval_take_value;var cf=env.__embind_register_value_object;var df=env.getTypeName;var ef=env._strftime;var ff=env.__embind_register_class_function;var gf=env.throwUnboundTypeError;var hf=env.craftInvokerFunction;var jf=env._getenv;var kf=env.runDestructors;var lf=env.requireRegisteredType;var mf=env.makeLegalFunctionName;var nf=env._pthread_key_create;var of=env.upcastPointer;var pf=env.init_emval;var qf=env.shallowCopyInternalPointer;var rf=env.nonConstNoSmartPtrRawPointerToWireType;var sf=env.__embind_register_value_array;var tf=env._abort;var uf=env.requireHandle;var vf=env._embind_repr;var wf=env.validateThis;var xf=env.exposePublicSymbol;var yf=env.RegisteredPointer_fromWireType;var zf=env.___cxa_pure_virtual;var Af=env.__emval_get_method_caller;var Bf=env._pthread_getspecific;var Cf=env._pthread_cond_wait;var Df=env.___lock;var Ef=env.__embind_register_value_array_element;var Ff=env.__embind_register_memory_view;var Gf=env.getInheritedInstance;var Hf=env.setDelayFunction;var If=env.___gxx_personality_v0;var Jf=env.extendError;var Kf=env.___syscall4;var Lf=env.__emval_new_array;var Mf=env.__embind_register_void;var Nf=env.__embind_register_smart_ptr;var Of=env.__embind_register_function;var Pf=env._pthread_mutexattr_destroy;var Qf=env._strftime_l;var Rf=env.RegisteredPointer_getPointee;var Sf=env.__emval_register;var Tf=env.__embind_register_std_wstring;var Uf=env.ClassHandle_isAliasOf;var Vf=env.__emval_incref;var Wf=env.RegisteredPointer;var Xf=env.__arraySum;var Yf=env.__embind_register_class_class_function;var Zf=env._pthread_mutex_destroy;var _f=env.getBasestPointer;var $f=env.getInheritedInstanceCount;var ag=env.__embind_register_float;var bg=env.integerReadValueFromPointer;var cg=env.___unlock;var dg=env._emscripten_set_main_loop;var eg=env._pthread_mutexattr_init;var fg=env._pthread_setspecific;var gg=env.genericPointerToWireType;var hg=env.registerType;var ig=env.___cxa_throw;var jg=env.__emval_new_cstring;var kg=env.count_emval_handles;var lg=env.requireFunction;var mg=env._atexit;var ng=env._pthread_mutex_init;var og=env.___map_file;var pg=0.0;function qg(newBuffer){if(q(newBuffer)&16777215||q(newBuffer)<=16777215||q(newBuffer)>2147483648)return false;b=new a(newBuffer);d=new c(newBuffer);f=new e(newBuffer);h=new g(newBuffer);j=new i(newBuffer);l=new k(newBuffer);n=new m(newBuffer);p=new o(newBuffer);buffer=newBuffer;return true}
// EMSCRIPTEN_START_FUNCS
function ynb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=a+4|0;i=h+60|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[a>>2]=98420;j=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;k=d+4|0;f[k>>2]=0;f[d+8>>2]=0;l=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){n=f[k>>2]|0;if((n|0)!=(m|0))f[k>>2]=n+(~((n+-4-m|0)>>>2)<<2);YDc(m)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[426087]|0;b[d+1>>0]=b[426088]|0;b[d+2>>0]=b[426089]|0;b[d+3>>0]=b[426090]|0;b[d+4>>0]=b[426091]|0;b[d+5>>0]=0;m=Jnb(a,d,l,-1,-1,-1)|0;if((b[j>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;o=f[d>>2]|0;if(o|0){p=f[n>>2]|0;if((p|0)!=(o|0))f[n>>2]=p+(~((p+-4-o|0)>>>2)<<2);YDc(o)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[o>>2]|0;if((q|0)!=(n|0))f[o>>2]=q+(~((q+-4-n|0)>>>2)<<2);YDc(n)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;q=Inb(a,e,d)|0;o=f[d>>2]|0;if(o|0){r=f[n>>2]|0;if((r|0)!=(o|0))f[n>>2]=r+(~((r+-4-o|0)>>>2)<<2);YDc(o)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;r=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){s=f[o>>2]|0;if((s|0)!=(n|0))f[o>>2]=s+(~((s+-4-n|0)>>>2)<<2);YDc(n)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=VDc(16)|0;f[d>>2]=j;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=j;n=426415;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[j+12>>0]=0;j=Jnb(a,d,m,p,q,r)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;s=f[d>>2]|0;if(s|0){o=f[q>>2]|0;if((o|0)!=(s|0))f[q>>2]=o+(~((o+-4-s|0)>>>2)<<2);YDc(s)}if((b[r>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;q=f[d>>2]|0;if(q|0){t=f[s>>2]|0;if((t|0)!=(q|0))f[s>>2]=t+(~((t+-4-q|0)>>>2)<<2);YDc(q)}if((b[r>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;t=Inb(a,e,d)|0;s=f[d>>2]|0;if(s|0){v=f[q>>2]|0;if((v|0)!=(s|0))f[q>>2]=v+(~((v+-4-s|0)>>>2)<<2);YDc(s)}if((b[r>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;r=VDc(16)|0;f[d>>2]=r;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=r;n=426415;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[r+12>>0]=0;r=Jnb(a,d,m,p,o,t)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;s=f[d>>2]|0;if(s|0){v=f[o>>2]|0;if((v|0)!=(s|0))f[o>>2]=v+(~((v+-4-s|0)>>>2)<<2);YDc(s)}if((b[t>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;v=Inb(a,e,d)|0;o=f[d>>2]|0;if(o|0){q=f[s>>2]|0;if((q|0)!=(o|0))f[s>>2]=q+(~((q+-4-o|0)>>>2)<<2);YDc(o)}if((b[t>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;q=Inb(a,e,d)|0;s=f[d>>2]|0;if(s|0){w=f[o>>2]|0;if((w|0)!=(s|0))f[o>>2]=w+(~((w+-4-s|0)>>>2)<<2);YDc(s)}if((b[t>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;t=VDc(16)|0;f[d>>2]=t;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=t;n=426415;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[t+12>>0]=0;t=Jnb(a,d,m,p,v,q)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[426428]|0;b[e+1>>0]=b[426429]|0;b[e+2>>0]=b[426430]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;s=Inb(a,g,d)|0;w=f[d>>2]|0;if(w|0){o=f[m>>2]|0;if((o|0)!=(w|0))f[m>>2]=o+(~((o+-4-w|0)>>>2)<<2);YDc(w)}w=Jnb(a,e,r,s,-1,-1)|0;if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[427390]|0;b[e+1>>0]=b[427391]|0;b[e+2>>0]=b[427392]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;r=Inb(a,g,d)|0;o=f[d>>2]|0;if(o|0){m=f[s>>2]|0;if((m|0)!=(o|0))f[s>>2]=m+(~((m+-4-o|0)>>>2)<<2);YDc(o)}o=Jnb(a,e,w,r,-1,-1)|0;if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[426428]|0;b[e+1>>0]=b[426429]|0;b[e+2>>0]=b[426430]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[d>>2]=0;r=d+4|0;f[r>>2]=0;f[d+8>>2]=0;w=Inb(a,g,d)|0;m=f[d>>2]|0;if(m|0){s=f[r>>2]|0;if((s|0)!=(m|0))f[r>>2]=s+(~((s+-4-m|0)>>>2)<<2);YDc(m)}m=Jnb(a,e,t,w,-1,-1)|0;if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[427390]|0;b[e+1>>0]=b[427391]|0;b[e+2>>0]=b[427392]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[d>>2]=0;w=d+4|0;f[w>>2]=0;f[d+8>>2]=0;t=Inb(a,g,d)|0;s=f[d>>2]|0;if(s|0){r=f[w>>2]|0;if((r|0)!=(s|0))f[w>>2]=r+(~((r+-4-s|0)>>>2)<<2);YDc(s)}s=Jnb(a,e,m,t,-1,-1)|0;if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=4;f[e>>2]=1801675088;b[e+4>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[d>>2]=0;t=d+4|0;f[t>>2]=0;f[d+8>>2]=0;m=Inb(a,g,d)|0;r=f[d>>2]|0;if(r|0){w=f[t>>2]|0;if((w|0)!=(r|0))f[t>>2]=w+(~((w+-4-r|0)>>>2)<<2);YDc(r)}r=Jnb(a,e,j,o,s,m)|0;if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=VDc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=19;h=e;n=427135;i=h+19|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[e+19>>0]=0;Jnb(a,d,r,k,l,-1)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;r=VDc(32)|0;f[d>>2]=r;f[d+8>>2]=-2147483616;f[d+4>>2]=19;h=r;n=427135;i=h+19|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[r+19>>0]=0;Knb(a,d,p,k,l,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function znb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=a+4|0;i=h+60|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[a>>2]=98396;j=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;k=d+4|0;f[k>>2]=0;f[d+8>>2]=0;l=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){n=f[k>>2]|0;if((n|0)!=(m|0))f[k>>2]=n+(~((n+-4-m|0)>>>2)<<2);YDc(m)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[426087]|0;b[d+1>>0]=b[426088]|0;b[d+2>>0]=b[426089]|0;b[d+3>>0]=b[426090]|0;b[d+4>>0]=b[426091]|0;b[d+5>>0]=0;m=Jnb(a,d,l,-1,-1,-1)|0;if((b[j>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;o=f[d>>2]|0;if(o|0){p=f[n>>2]|0;if((p|0)!=(o|0))f[n>>2]=p+(~((p+-4-o|0)>>>2)<<2);YDc(o)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[o>>2]|0;if((q|0)!=(n|0))f[o>>2]=q+(~((q+-4-n|0)>>>2)<<2);YDc(n)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;q=Inb(a,e,d)|0;o=f[d>>2]|0;if(o|0){r=f[n>>2]|0;if((r|0)!=(o|0))f[n>>2]=r+(~((r+-4-o|0)>>>2)<<2);YDc(o)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;r=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){s=f[o>>2]|0;if((s|0)!=(n|0))f[o>>2]=s+(~((s+-4-n|0)>>>2)<<2);YDc(n)}if((b[j>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=VDc(16)|0;f[d>>2]=j;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=j;n=426415;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[j+12>>0]=0;j=Jnb(a,d,m,p,q,r)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;s=f[d>>2]|0;if(s|0){o=f[q>>2]|0;if((o|0)!=(s|0))f[q>>2]=o+(~((o+-4-s|0)>>>2)<<2);YDc(s)}if((b[r>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;q=f[d>>2]|0;if(q|0){t=f[s>>2]|0;if((t|0)!=(q|0))f[s>>2]=t+(~((t+-4-q|0)>>>2)<<2);YDc(q)}if((b[r>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;t=Inb(a,e,d)|0;s=f[d>>2]|0;if(s|0){v=f[q>>2]|0;if((v|0)!=(s|0))f[q>>2]=v+(~((v+-4-s|0)>>>2)<<2);YDc(s)}if((b[r>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;r=VDc(16)|0;f[d>>2]=r;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=r;n=426415;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[r+12>>0]=0;r=Jnb(a,d,m,p,o,t)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;s=f[d>>2]|0;if(s|0){v=f[o>>2]|0;if((v|0)!=(s|0))f[o>>2]=v+(~((v+-4-s|0)>>>2)<<2);YDc(s)}if((b[t>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;v=Inb(a,e,d)|0;o=f[d>>2]|0;if(o|0){q=f[s>>2]|0;if((q|0)!=(o|0))f[s>>2]=q+(~((q+-4-o|0)>>>2)<<2);YDc(o)}if((b[t>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;q=Inb(a,e,d)|0;s=f[d>>2]|0;if(s|0){w=f[o>>2]|0;if((w|0)!=(s|0))f[o>>2]=w+(~((w+-4-s|0)>>>2)<<2);YDc(s)}if((b[t>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;t=VDc(16)|0;f[d>>2]=t;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=t;n=426415;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[t+12>>0]=0;t=Jnb(a,d,m,p,v,q)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[426428]|0;b[e+1>>0]=b[426429]|0;b[e+2>>0]=b[426430]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;s=Inb(a,g,d)|0;w=f[d>>2]|0;if(w|0){o=f[m>>2]|0;if((o|0)!=(w|0))f[m>>2]=o+(~((o+-4-w|0)>>>2)<<2);YDc(w)}w=Jnb(a,e,r,s,-1,-1)|0;if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[426428]|0;b[e+1>>0]=b[426429]|0;b[e+2>>0]=b[426430]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;r=Inb(a,g,d)|0;o=f[d>>2]|0;if(o|0){m=f[s>>2]|0;if((m|0)!=(o|0))f[s>>2]=m+(~((m+-4-o|0)>>>2)<<2);YDc(o)}o=Jnb(a,e,t,r,-1,-1)|0;if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=4;f[e>>2]=1801675088;b[e+4>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[d>>2]=0;r=d+4|0;f[r>>2]=0;f[d+8>>2]=0;t=Inb(a,g,d)|0;m=f[d>>2]|0;if(m|0){s=f[r>>2]|0;if((s|0)!=(m|0))f[r>>2]=s+(~((s+-4-m|0)>>>2)<<2);YDc(m)}m=Jnb(a,e,j,w,o,t)|0;if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=VDc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=19;h=e;n=427135;i=h+19|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[e+19>>0]=0;Jnb(a,d,m,k,l,-1)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;m=VDc(32)|0;f[d>>2]=m;f[d+8>>2]=-2147483616;f[d+4>>2]=19;h=m;n=427135;i=h+19|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[m+19>>0]=0;Knb(a,d,p,k,l,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function Anb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98372;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=5;b[d>>0]=b[426087]|0;b[d+1>>0]=b[426088]|0;b[d+2>>0]=b[426089]|0;b[d+3>>0]=b[426090]|0;b[d+4>>0]=b[426091]|0;b[d+5>>0]=0;l=Jnb(a,d,k,-1,-1,-1)|0;if((b[i>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;j=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){o=f[m>>2]|0;if((o|0)!=(n|0))f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);YDc(n)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){p=f[n>>2]|0;if((p|0)!=(m|0))f[n>>2]=p+(~((p+-4-m|0)>>>2)<<2);YDc(m)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[m>>2]|0;if((q|0)!=(n|0))f[m>>2]=q+(~((q+-4-n|0)>>>2)<<2);YDc(n)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=VDc(16)|0;f[d>>2]=i;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=i;n=426415;h=g+12|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[i+12>>0]=0;i=Jnb(a,d,l,j,o,p)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;j=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[o>>2]|0;if((q|0)!=(l|0))f[o>>2]=q+(~((q+-4-l|0)>>>2)<<2);YDc(l)}if((b[p>>0]|0)<0)YDc(f[e>>2]|0);p=d+4|0;f[p>>2]=0;f[p+4>>2]=0;p=d+11|0;b[p>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;l=Jnb(a,d,i,j,-1,-1)|0;if((b[p>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;p=d+11|0;b[p>>0]=5;b[d>>0]=b[426087]|0;b[d+1>>0]=b[426088]|0;b[d+2>>0]=b[426089]|0;b[d+3>>0]=b[426090]|0;b[d+4>>0]=b[426091]|0;b[d+5>>0]=0;i=Jnb(a,d,k,-1,-1,-1)|0;if((b[p>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){r=f[q>>2]|0;if((r|0)!=(m|0))f[q>>2]=r+(~((r+-4-m|0)>>>2)<<2);YDc(m)}if((b[p>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;r=Inb(a,e,d)|0;q=f[d>>2]|0;if(q|0){s=f[m>>2]|0;if((s|0)!=(q|0))f[m>>2]=s+(~((s+-4-q|0)>>>2)<<2);YDc(q)}if((b[p>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;s=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){t=f[q>>2]|0;if((t|0)!=(m|0))f[q>>2]=t+(~((t+-4-m|0)>>>2)<<2);YDc(m)}if((b[p>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;p=VDc(16)|0;f[d>>2]=p;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=p;n=426415;h=g+12|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[p+12>>0]=0;p=Jnb(a,d,i,o,r,s)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;s=e+11|0;b[s>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;r=d+4|0;f[r>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;i=f[d>>2]|0;if(i|0){m=f[r>>2]|0;if((m|0)!=(i|0))f[r>>2]=m+(~((m+-4-i|0)>>>2)<<2);YDc(i)}if((b[s>>0]|0)<0)YDc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;s=Jnb(a,d,p,o,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=4;f[d>>2]=1801675088;b[d+4>>0]=0;p=Jnb(a,d,l,s,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=VDc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=14;g=e;n=426942;h=g+14|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[e+14>>0]=0;Jnb(a,d,k,p,-1,-1)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;p=VDc(16)|0;f[d>>2]=p;f[d+8>>2]=-2147483632;f[d+4>>2]=14;g=p;n=426942;h=g+14|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[p+14>>0]=0;Knb(a,d,k,j,o,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function Bnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98292;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=5;b[d>>0]=b[426087]|0;b[d+1>>0]=b[426088]|0;b[d+2>>0]=b[426089]|0;b[d+3>>0]=b[426090]|0;b[d+4>>0]=b[426091]|0;b[d+5>>0]=0;l=Jnb(a,d,k,-1,-1,-1)|0;if((b[i>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;j=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){o=f[m>>2]|0;if((o|0)!=(n|0))f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);YDc(n)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){p=f[n>>2]|0;if((p|0)!=(m|0))f[n>>2]=p+(~((p+-4-m|0)>>>2)<<2);YDc(m)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[m>>2]|0;if((q|0)!=(n|0))f[m>>2]=q+(~((q+-4-n|0)>>>2)<<2);YDc(n)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=VDc(16)|0;f[d>>2]=i;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=i;n=426415;h=g+12|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[i+12>>0]=0;i=Jnb(a,d,l,j,o,p)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;j=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[o>>2]|0;if((q|0)!=(l|0))f[o>>2]=q+(~((q+-4-l|0)>>>2)<<2);YDc(l)}if((b[p>>0]|0)<0)YDc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;p=Jnb(a,d,i,j,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=VDc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=21;g=e;n=426432;h=g+21|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[e+21>>0]=0;Jnb(a,d,k,p,-1,-1)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;p=VDc(32)|0;f[d>>2]=p;f[d+8>>2]=-2147483616;f[d+4>>2]=21;g=p;n=426432;h=g+21|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[p+21>>0]=0;Knb(a,d,k,j,-1,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function Cnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98244;g=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;f[d+8>>2]=0;i=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){k=f[h>>2]|0;if((k|0)!=(j|0))f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2);YDc(j)}if((b[g>>0]|0)<0)YDc(f[e>>2]|0);g=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;h=f[d>>2]|0;if(h|0){l=f[j>>2]|0;if((l|0)!=(h|0))f[j>>2]=l+(~((l+-4-h|0)>>>2)<<2);YDc(h)}if((b[g>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[426087]|0;b[d+1>>0]=b[426088]|0;b[d+2>>0]=b[426089]|0;b[d+3>>0]=b[426090]|0;b[d+4>>0]=b[426091]|0;b[d+5>>0]=0;g=Jnb(a,d,k,-1,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[426093]|0;b[d+1>>0]=b[426094]|0;b[d+2>>0]=b[426095]|0;b[d+3>>0]=b[426096]|0;b[d+4>>0]=b[426097]|0;b[d+5>>0]=b[426098]|0;b[d+6>>0]=b[426099]|0;b[d+7>>0]=0;Jnb(a,d,i,g,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[426093]|0;b[d+1>>0]=b[426094]|0;b[d+2>>0]=b[426095]|0;b[d+3>>0]=b[426096]|0;b[d+4>>0]=b[426097]|0;b[d+5>>0]=b[426098]|0;b[d+6>>0]=b[426099]|0;b[d+7>>0]=0;Knb(a,d,i,k,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function Dnb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+32|0;g=e+20|0;h=e+8|0;i=e;j=a+52|0;k=a+56|0;Enb(g,(f[k>>2]|0)-(f[j>>2]|0)>>2);a:do if((f[k>>2]|0)!=(f[j>>2]|0)){l=d+4|0;m=h+11|0;n=h+4|0;o=c+20|0;p=a+40|0;q=a+16|0;r=0;b:while(1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=f[l>>2]|0;t=f[d>>2]|0;c:do if((s|0)==(t|0)){v=0;w=0}else{x=0;y=s;z=0;A=0;B=t;while(1){if((z<<24>>24<0?A:z&255)|0){v=z;w=A;break c}C=f[(f[o>>2]|0)+4+(f[B+(x<<2)>>2]<<2)>>2]|0;D=f[(f[p>>2]|0)+(x<<2)>>2]|0;E=f[q>>2]|0;F=f[C+12>>2]|0;G=f[E+(D*12|0)+4>>2]|0;H=f[E+(D*12|0)>>2]|0;D=H;if((F|0)!=(G-H>>2|0)){I=10;break b}d:do if((G|0)==(H|0)){J=B;K=y}else{E=f[(f[j>>2]|0)+(r<<2)>>2]|0;L=0;while(1){if((f[D+(L<<2)>>2]|0)==(E|0))break;M=L+1|0;if(M>>>0<F>>>0)L=M;else{J=B;K=y;break d}}iEc(h,f[(f[C+20>>2]|0)+4+(L<<2)>>2]|0)|0;J=f[d>>2]|0;K=f[l>>2]|0}while(0);x=x+1|0;C=b[m>>0]|0;F=f[n>>2]|0;if(x>>>0>=K-J>>2>>>0){v=C;w=F;break}else{y=K;z=C;A=F;B=J}}}while(0);if(!((v<<24>>24<0?w:v&255)|0)){I=15;break}iEc((f[g>>2]|0)+(r*12|0)|0,h)|0;if((b[m>>0]|0)<0)YDc(f[h>>2]|0);r=r+1|0;if(r>>>0>=(f[k>>2]|0)-(f[j>>2]|0)>>2>>>0){N=o;O=d;P=l;break a}}if((I|0)==10){f[i>>2]=0;f[i+4>>2]=0;Q=tT(i,38)|0;R=425763;S=Q+38|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));z5(-215,i,425802,425810,153)}else if((I|0)==15){f[i>>2]=0;f[i+4>>2]=0;Q=tT(i,16)|0;R=425898;S=Q+16|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));z5(-215,i,425802,425810,163)}}else{N=c+20|0;O=d;P=d+4|0}while(0);i=f[P>>2]|0;P=f[N>>2]|0;R=f[P+4+(f[i+-4>>2]<<2)>>2]|0;Q=f[O>>2]|0;O=(i-Q>>2)+-2|0;e:do if((O|0)>-1){i=c+8|0;S=O;I=Q;j=P;while(1){k=f[I+(S<<2)>>2]|0;v=f[j+4+(k<<2)>>2]|0;if(!((v|0)==0|(f[i>>2]|0)!=0))Yi[f[(f[v>>2]|0)+4>>2]&2047](v);VSb(i,k,1);if((S|0)<=0)break e;S=S+-1|0;I=f[d>>2]|0;j=f[N>>2]|0}}while(0);N=a+28|0;d=R+64|0;P=f[R+4>>2]|0;Q=P&-2;if(!(P&1))T=Q;else T=f[Q+4>>2]|0;Q=f[d>>2]|0;if((Q|0)==527320)WJa(d,T,N);else iEc(Q,N)|0;N=R+12|0;Q=f[N>>2]|0;if((Q|0)>0){T=f[R+20>>2]|0;d=0;do{P=f[T+4+(d<<2)>>2]|0;d=d+1|0;O=P+11|0;if((b[O>>0]|0)<0){b[f[P>>2]>>0]=0;f[P+4>>2]=0}else{b[P>>0]=0;b[O>>0]=0}}while((d|0)!=(Q|0));f[N>>2]=0}N=g+4|0;Q=f[N>>2]|0;d=f[g>>2]|0;if((Q|0)==(d|0)){U=Q;V=Q}else{Q=R+8|0;T=0;O=d;while(1){iEc(JLa(Q)|0,O+(T*12|0)|0)|0;T=T+1|0;d=f[N>>2]|0;P=f[g>>2]|0;if(T>>>0>=((d-P|0)/12|0)>>>0){U=P;V=d;break}else O=P}}O=V-U|0;T=(O|0)/12|0;f[h>>2]=0;Q=h+4|0;f[Q>>2]=0;f[h+8>>2]=0;if(!O)W=V;else{if(T>>>0>1073741823)mCc(h);V=VDc(T<<2)|0;f[Q>>2]=V;f[h>>2]=V;f[h+8>>2]=V+(T<<2);O=T;T=V;do{f[T>>2]=0;T=(f[Q>>2]|0)+4|0;f[Q>>2]=T;O=O+-1|0}while((O|0)!=0);W=f[N>>2]|0}if((W|0)!=(U|0)){U=0;do{W=Fnb(c,R,U)|0;f[(f[h>>2]|0)+(U<<2)>>2]=W;U=U+1|0}while(U>>>0<(((f[N>>2]|0)-(f[g>>2]|0)|0)/12|0)>>>0)}ei[f[(f[a>>2]|0)+12>>2]&511](a,c,R,h);R=f[h>>2]|0;if(R|0){h=f[Q>>2]|0;if((h|0)!=(R|0))f[Q>>2]=h+(~((h+-4-R|0)>>>2)<<2);YDc(R)}R=f[g>>2]|0;if(!R){u=e;return}h=f[N>>2]|0;if((h|0)==(R|0))X=R;else{Q=h;while(1){h=Q+-12|0;f[N>>2]=h;if((b[h+11>>0]|0)<0){YDc(f[h>>2]|0);Y=f[N>>2]|0}else Y=h;if((Y|0)==(R|0))break;else Q=Y}X=f[g>>2]|0}YDc(X);u=e;return}function Enb(a,b){a=a|0;b=b|0;var c=0,d=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)mCc(a);d=VDc(b*12|0)|0;f[c>>2]=d;f[a>>2]=d;f[a+8>>2]=d+(b*12|0);a=b;b=d;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=(f[c>>2]|0)+12|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function Fnb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if((f[c+12>>2]|0)<=(d|0)){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,25)|0;l=425915;m=k+25|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,g,425941,425810,85)}fEc(g,f[(f[c+20>>2]|0)+4+(d<<2)>>2]|0);gEc(h,g,0,DEc(g,58,-1)|0,g);iEc(g,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);d=f[a+12>>2]|0;a:do if((d|0)>0){c=f[a+20>>2]|0;l=b[g+11>>0]|0;k=l<<24>>24<0;m=k?f[g+4>>2]|0:l&255;l=f[g>>2]|0;n=k?l:g;o=(m|0)==0;p=0;b:while(1){q=f[c+4+(p<<2)>>2]|0;r=f[q+60>>2]|0;s=b[r+11>>0]|0;t=s<<24>>24<0;v=s&255;do if(((t?f[r+4>>2]|0:v)|0)==(m|0)){s=f[r>>2]|0;w=t?s:r;if(t){if(o)break b;if(!(Arc(w,n,m)|0))break b;else break}if(o)break b;if((s&255)<<24>>24==(b[n>>0]|0)){s=r;w=v;x=n;do{w=w+-1|0;s=s+1|0;if(!w)break b;x=x+1|0}while((b[s>>0]|0)==(b[x>>0]|0))}}while(0);p=p+1|0;if((p|0)>=(d|0))break a}if(!k){u=e;return q|0}YDc(l);u=e;return q|0}while(0);VHa(j,425954,g);jIa(i,j,502280);f[h>>2]=0;f[h+4>>2]=0;j=i+11|0;g=b[j>>0]|0;q=g<<24>>24<0?f[i+4>>2]|0:g&255;if(!q)z5(-212,h,425941,425810,96);g=tT(h,q)|0;dJc(g|0,((b[j>>0]|0)<0?f[i>>2]|0:i)|0,q|0)|0;z5(-212,h,425941,425810,96);return 0}function Gnb(a){a=a|0;YDc(a);return}function Hnb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Inb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;h=f[d+4>>2]|0;i=f[d>>2]|0;j=i;a:do if((h|0)==(i|0)){k=a+8|0;l=k;m=a+4|0;n=f[k>>2]|0}else{k=a+4|0;o=a+8|0;p=f[o>>2]|0;q=(p-(f[k>>2]|0)|0)/12|0;r=h-i>>2;s=p;p=0;while(1){if((f[j+(p<<2)>>2]|0)>=(q|0))break;p=p+1|0;if(p>>>0>=r>>>0){l=o;m=k;n=s;break a}}f[g>>2]=0;f[g+4>>2]=0;s=tT(g,30)|0;k=426198;o=s+30|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(o|0));z5(-215,g,426229,425810,44)}while(0);if((n|0)==(f[a+12>>2]|0))e1(m,c);else{fEc(n,c);f[l>>2]=(f[l>>2]|0)+12}c=a+20|0;n=f[c>>2]|0;if((n|0)==(f[a+24>>2]|0)){OGa(a+16|0,d);t=f[l>>2]|0;v=f[m>>2]|0;w=t-v|0;x=(w|0)/12|0;y=x+-1|0;u=e;return y|0}else{jFa(n,d);f[c>>2]=(f[c>>2]|0)+12;t=f[l>>2]|0;v=f[m>>2]|0;w=t-v|0;x=(w|0)/12|0;y=x+-1|0;u=e;return y|0}return 0}function Jnb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i>>2]=c;f[i+4>>2]=d;f[i+8>>2]=e;f[i+12>>2]=g;k=((g|0)!=-1&1)+(((e|0)!=-1&1)+(((d|0)!=-1&1)+((c|0)!=-1&1)))|0;f[j>>2]=0;c=j+4|0;f[c>>2]=0;f[j+8>>2]=0;d=k<<2;if(k|0){e=VDc(d)|0;f[j>>2]=e;f[j+8>>2]=e+(k<<2);dJc(e|0,i|0,d|0)|0;f[c>>2]=e+(k<<2)}k=Inb(a,b,j)|0;b=f[j>>2]|0;if(!b){u=h;return k|0}j=f[c>>2]|0;if((j|0)!=(b|0))f[c>>2]=j+(~((j+-4-b|0)>>>2)<<2);YDc(b);u=h;return k|0}function Knb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+48|0;l=k+16|0;m=k;f[l>>2]=d;f[l+4>>2]=e;f[l+8>>2]=g;f[l+12>>2]=h;f[l+16>>2]=i;f[l+20>>2]=j;n=((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)/12|0;if(!((n|0)>(d|0)&(n|0)>(e|0)&(n|0)>(g|0)&(n|0)>(h|0)&(n|0)>(i|0)&(n|0)>(j|0))){f[m>>2]=0;f[m+4>>2]=0;n=tT(m,33)|0;o=426151;p=n+33|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,m,426185,425810,62)}o=((j|0)!=-1&1)+(((i|0)!=-1&1)+(((h|0)!=-1&1)+(((g|0)!=-1&1)+(((e|0)!=-1&1)+((d|0)!=-1&1)))))|0;f[m>>2]=0;d=m+4|0;f[d>>2]=0;f[m+8>>2]=0;e=o<<2;if(o|0){g=VDc(e)|0;f[m>>2]=g;f[m+8>>2]=g+(o<<2);dJc(g|0,l|0,e|0)|0;f[d>>2]=g+(o<<2)}Pnb(a,c,m);c=f[m>>2]|0;if(!c){u=k;return}m=f[d>>2]|0;if((m|0)!=(c|0))f[d>>2]=m+(~((m+-4-c|0)>>>2)<<2);YDc(c);u=k;return}function Lnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=98268;c=f[a+52>>2]|0;if(c|0){d=a+56|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);YDc(c)}c=f[a+40>>2]|0;if(c|0){e=a+44|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-4-c|0)>>>2)<<2);YDc(c)}c=a+28|0;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);c=a+16|0;d=f[c>>2]|0;if(d|0){e=a+20|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;while(1){g=i+-12|0;f[e>>2]=g;j=f[g>>2]|0;if(!j)k=g;else{g=i+-8|0;l=f[g>>2]|0;if((l|0)!=(j|0))f[g>>2]=l+(~((l+-4-j|0)>>>2)<<2);YDc(j);k=f[e>>2]|0}if((k|0)==(d|0))break;else i=k}h=f[c>>2]|0}YDc(h)}h=a+4|0;c=f[h>>2]|0;if(!c)return;k=a+8|0;a=f[k>>2]|0;if((a|0)==(c|0))m=c;else{i=a;while(1){a=i+-12|0;f[k>>2]=a;if((b[a+11>>0]|0)<0){YDc(f[a>>2]|0);n=f[k>>2]|0}else n=a;if((n|0)==(c|0))break;else i=n}m=f[h>>2]|0}YDc(m);return}function Mnb(a){a=a|0;Lnb(a);YDc(a);return}function Nnb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;g=u;u=u+16|0;h=g;f[h>>2]=d;i=f[e>>2]|0;j=e+4|0;k=f[j>>2]|0;if((k|0)!=(i|0))f[j>>2]=k+(~((k+-4-i|0)>>>2)<<2);i=a+40|0;k=a+44|0;aIa(e,(f[k>>2]|0)-(f[i>>2]|0)>>2);l=f[c+12>>2]|0;if((f[k>>2]|0)==(f[i>>2]|0)){m=1;u=g;return m|0}n=c+20|0;o=a+4|0;p=a+16|0;a=e+8|0;q=0;r=d;a:while(1){b:do if((r|0)<(l|0)){d=r;while(1){s=f[(f[(f[n>>2]|0)+4+(d<<2)>>2]|0)+64>>2]|0;t=b[s+11>>0]|0;if(((t<<24>>24<0?f[s+4>>2]|0:t&255)|0)!=5){v=d;break b}t=(EEc(s,0,-1,426101,5)|0)==0;s=f[h>>2]|0;if(!t){v=s;break b}t=s+1|0;f[h>>2]=t;if((t|0)<(l|0))d=t;else{v=t;break}}}else v=r;while(0);if((v|0)>=(l|0)){m=0;w=38;break}d=f[(f[n>>2]|0)+4+(v<<2)>>2]|0;t=f[d+64>>2]|0;s=f[(f[i>>2]|0)+(q<<2)>>2]|0;x=f[o>>2]|0;y=x+(s*12|0)|0;z=b[t+11>>0]|0;A=z<<24>>24<0;B=z&255;z=A?f[t+4>>2]|0:B;C=b[y+11>>0]|0;D=C<<24>>24<0;if((z|0)!=((D?f[x+(s*12|0)+4>>2]|0:C&255)|0)){m=0;w=38;break}C=f[t>>2]|0;E=A?C:t;F=D?f[y>>2]|0:y;y=(z|0)==0;c:do if(A){if(!y?Arc(E,F,z)|0:0){m=0;w=38;break a}}else if(!y){if((C&255)<<24>>24==(b[F>>0]|0)){G=t;H=B;I=F}else{m=0;w=38;break a}while(1){H=H+-1|0;G=G+1|0;if(!H)break c;I=I+1|0;if((b[G>>0]|0)!=(b[I>>0]|0)){m=0;w=38;break a}}}while(0);F=f[p>>2]|0;B=F+(s*12|0)|0;t=F+(s*12|0)+4|0;F=f[t>>2]|0;C=f[B>>2]|0;if((F-C>>2|0)!=(f[d+12>>2]|0)){m=0;w=38;break}if((F|0)!=(C|0)){F=0;y=C;C=x;while(1){z=f[y+(F<<2)>>2]|0;E=b[C+(z*12|0)+11>>0]|0;if(E<<24>>24<0)J=f[C+(z*12|0)+4>>2]|0;else J=E&255;d:do if(J){E=(Fnb(c,d,F)|0)+64|0;z=f[E>>2]|0;E=f[B>>2]|0;A=f[E+(F<<2)>>2]|0;D=f[o>>2]|0;K=D+(A*12|0)|0;L=b[z+11>>0]|0;M=L<<24>>24<0;N=L&255;L=M?f[z+4>>2]|0:N;O=b[K+11>>0]|0;P=O<<24>>24<0;Q=E;if((L|0)!=((P?f[D+(A*12|0)+4>>2]|0:O&255)|0)){m=0;w=38;break a}O=f[z>>2]|0;A=M?O:z;E=P?f[K>>2]|0:K;K=(L|0)==0;if(M){if(K){R=Q;S=D;break}if(!(Arc(A,E,L)|0)){R=Q;S=D;break}else{m=0;w=38;break a}}if(K){R=Q;S=D}else{if((O&255)<<24>>24==(b[E>>0]|0)){T=z;U=N;V=E}else{m=0;w=38;break a}while(1){U=U+-1|0;T=T+1|0;if(!U){R=Q;S=D;break d}V=V+1|0;if((b[T>>0]|0)!=(b[V>>0]|0)){m=0;w=38;break a}}}}else{R=y;S=C}while(0);F=F+1|0;if(F>>>0>=(f[t>>2]|0)-R>>2>>>0)break;else{y=R;C=S}}}C=f[j>>2]|0;if((C|0)==(f[a>>2]|0))g6(e,h);else{f[C>>2]=f[h>>2];f[j>>2]=C+4}r=(f[h>>2]|0)+1|0;f[h>>2]=r;q=q+1|0;if(q>>>0>=(f[k>>2]|0)-(f[i>>2]|0)>>2>>>0){m=1;w=38;break}}if((w|0)==38){u=g;return m|0}return 0}function Onb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Pnb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e;h=a+52|0;if((h|0)!=(d|0))xxa(h,f[d>>2]|0,f[d+4>>2]|0);iEc(a+28|0,c)|0;c=a+40|0;d=f[c>>2]|0;i=a+44|0;j=f[i>>2]|0;if((j|0)!=(d|0))f[i>>2]=j+(~((j+-4-d|0)>>>2)<<2);f[g>>2]=0;d=a+4|0;j=a+8|0;k=f[d>>2]|0;if((f[j>>2]|0)==(k|0)){u=e;return}l=a+56|0;m=a+48|0;a=k;k=0;do{n=a;o=f[h>>2]|0;p=f[l>>2]|0;a:do if((o|0)==(p|0)){q=o;r=11}else{s=o;while(1){if((f[s>>2]|0)==(k|0)){q=s;r=11;break a}s=s+4|0;if((s|0)==(p|0)){r=12;break}}}while(0);if((r|0)==11?(r=0,(q|0)==(p|0)):0)r=12;do if((r|0)==12){r=0;o=n+(k*12|0)|0;s=b[o+11>>0]|0;if(((s<<24>>24<0?f[n+(k*12|0)+4>>2]|0:s&255)|0)==5?(EEc(o,0,-1,426101,5)|0)==0:0)break;o=f[i>>2]|0;if((o|0)==(f[m>>2]|0)){g6(c,g);break}else{f[o>>2]=f[g>>2];f[i>>2]=o+4;break}}while(0);k=(f[g>>2]|0)+1|0;f[g>>2]=k;a=f[d>>2]|0}while(k>>>0<(((f[j>>2]|0)-a|0)/12|0)>>>0);u=e;return}function Qnb(a){a=a|0;Lnb(a);YDc(a);return}function Rnb(a){a=a|0;YDc(a);return}function Snb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tnb(a){a=a|0;Lnb(a);YDc(a);return}function Unb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;a=u;u=u+160|0;g=a+136|0;h=a+80|0;i=a+40|0;j=a;k=a+64|0;l=f[(f[e>>2]|0)+4>>2]|0;Wdc(l+24|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=g+11|0;b[m>>0]=5;b[g>>0]=b[498520]|0;b[g+1>>0]=b[498521]|0;b[g+2>>0]=b[498522]|0;b[g+3>>0]=b[498523]|0;b[g+4>>0]=b[498524]|0;b[g+5>>0]=0;n=dJa(l+48|0,g)|0;Vnb(h,(f[n+20>>2]|0)==8?f[n+8>>2]|0:520944);if((b[m>>0]|0)<0)YDc(f[g>>2]|0);m=h+4|0;n=f[m>>2]|0;l=(n|0)<3;if(l)o=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{p=f[h+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((o|0)!=2){if(l){t=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;$1(t,2,98308)}l=f[h+40>>2]|0;o=0;r=1;while(1){q=Y(f[l+(o<<2)>>2]|0,r)|0;o=o+1|0;if((o|0)==(n|0)){t=q;break}else r=q}$1(t,2,98308)}t=f[h>>2]&4095;if((t|0)!=4)Y1(t,4,98336);t=f[(f[e>>2]|0)+4>>2]|0;e=t+24|0;Wdc(e);Vdc(e);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=g+11|0;b[e>>0]=5;b[g>>0]=b[498520]|0;b[g+1>>0]=b[498521]|0;b[g+2>>0]=b[498522]|0;b[g+3>>0]=b[498523]|0;b[g+4>>0]=b[498524]|0;b[g+5>>0]=0;r=UJa(TJa(t+48|0,g)|0)|0;if((b[e>>0]|0)<0)YDc(f[g>>2]|0);f[r+40>>2]=0;e=f[r+152>>2]|0;do if((e|0)!=527320){t=e+11|0;if((b[t>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[t>>0]=0;break}}while(0);e=h+16|0;t=h+44|0;n=f[f[e>>2]>>2]|0;o=r+40|0;l=f[o>>2]|0;if((l|0)==(f[r+44>>2]|0)){KLa(o,l+1|0);v=f[o>>2]|0}else v=l;l=f[r+48>>2]|0;f[o>>2]=v+1;f[l+4+(v<<2)>>2]=n;n=Wnb(c)|0;Xnb(n,426101);jIa(g,f[d+60>>2]|0,426454);c=n+60|0;v=f[n+4>>2]|0;l=v&-2;if(!(v&1))w=l;else w=f[l+4>>2]|0;l=f[c>>2]|0;if((l|0)==527320)WJa(c,w,g);else iEc(l,g)|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);JNa(i);l=(UJa(i)|0)+160|0;f[l>>2]=3;l=UJa(i)|0;w=f[(f[e>>2]|0)+4>>2]|0;c=l+40|0;v=f[c>>2]|0;if((v|0)==(f[l+44>>2]|0)){KLa(c,v+1|0);x=f[c>>2]|0}else x=v;v=f[l+48>>2]|0;f[c>>2]=x+1;f[v+4+(x<<2)>>2]=w;w=n+24|0;Wdc(w);Vdc(w);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=k+11|0;b[w>>0]=5;b[k>>0]=b[498520]|0;b[k+1>>0]=b[498521]|0;b[k+2>>0]=b[498522]|0;b[k+3>>0]=b[498523]|0;b[k+4>>0]=b[498524]|0;b[k+5>>0]=0;fEc(j,k);x=j+16|0;kPa(x,i);Ynb(g,f[n+56>>2]|0,j);if(b[g+12>>0]|0){v=Znb(n+48|0,j)|0;f[(f[g>>2]|0)+12>>2]=v}ROa(x);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[w>>0]|0)<0)YDc(f[k>>2]|0);k=f[n+60>>2]|0;iEc(JLa(d+8|0)|0,k)|0;ROa(i);i=h+36|0;k=f[i>>2]|0;if(k|0?(d=k+12|0,k=f[d>>2]|0,f[d>>2]=k+-1,(k|0)==1):0)_S(h);f[i>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[h+40>>2]|0;i=0;do{f[e+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[t>>2]|0;if((m|0)==(h+48|0)){u=a;return}g0(m);u=a;return}function Vnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=u;u=u+592|0;e=d+528|0;g=d+472|0;h=d+416|0;i=d+360|0;j=d+304|0;k=d+248|0;l=d+192|0;m=d+72|0;n=d+16|0;o=d+184|0;p=d;q=d+128|0;r=f[c+152>>2]|0;switch(f[c+160>>2]|0){case 1:{s=b[r+11>>0]|0;t=s<<24>>24<0;if(t)v=f[r+4>>2]|0;else v=s&255;if(!v){v=f[c+8>>2]|0;if(!v){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,14)|0;x=426686;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,e,426701,425810,720)}z=f[c+16>>2]|0;Vj(h,1,v,5,(z|0)==0?0:z+4|0,0);f[a>>2]=1124007936;z=a+8|0;v=a+40|0;w=a+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[v>>2]=z;z=a+48|0;f[a+44>>2]=z;f[z>>2]=0;f[a+52>>2]=0;z=e+8|0;f[z>>2]=0;f[z+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;h_(h,e);z=h+36|0;v=f[z>>2]|0;if(v|0?(A=v+12|0,v=f[A>>2]|0,f[A>>2]=v+-1,(v|0)==1):0)_S(h);f[z>>2]=0;z=h+16|0;v=h+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[v>>2]|0)>0){z=f[h+40>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[v>>2]|0))}v=f[h+44>>2]|0;if((v|0)==(h+48|0)){u=d;return}g0(v);u=d;return}if(t){B=f[r+4>>2]|0;C=f[r>>2]|0}else{B=s&255;C=r}Vj(g,1,B>>>2,5,C,0);f[a>>2]=1124007936;C=a+8|0;B=a+40|0;w=a+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[B>>2]=C;C=a+48|0;f[a+44>>2]=C;f[C>>2]=0;f[a+52>>2]=0;C=e+8|0;f[C>>2]=0;f[C+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;h_(g,e);C=g+36|0;B=f[C>>2]|0;if(B|0?(s=B+12|0,B=f[s>>2]|0,f[s>>2]=B+-1,(B|0)==1):0)_S(g);f[C>>2]=0;C=g+16|0;B=g+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){C=f[g+40>>2]|0;s=0;do{f[C+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[B>>2]|0))}B=f[g+44>>2]|0;if((B|0)==(g+48|0)){u=d;return}g0(B);u=d;return}case 2:{B=b[r+11>>0]|0;g=B<<24>>24<0;if(g)D=f[r+4>>2]|0;else D=B&255;if(!D){D=f[c+24>>2]|0;if(!D){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,14)|0;x=426686;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,e,426701,425810,731)}s=f[c+32>>2]|0;Vj(j,1,D,6,(s|0)==0?0:s+8|0,0);f[a>>2]=1124007936;s=a+8|0;D=a+40|0;w=a+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[D>>2]=s;s=a+48|0;f[a+44>>2]=s;f[s>>2]=0;f[a+52>>2]=0;s=e+8|0;f[s>>2]=0;f[s+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;h_(j,e);s=j+36|0;D=f[s>>2]|0;if(D|0?(C=D+12|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)_S(j);f[s>>2]=0;s=j+16|0;D=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[D>>2]|0)>0){s=f[j+40>>2]|0;C=0;do{f[s+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[D>>2]|0))}D=f[j+44>>2]|0;if((D|0)==(j+48|0)){u=d;return}g0(D);u=d;return}if(g){E=f[r+4>>2]|0;F=f[r>>2]|0}else{E=B&255;F=r}Vj(i,1,E>>>3,6,F,0);f[a>>2]=1124007936;F=a+8|0;E=a+40|0;w=a+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[E>>2]=F;F=a+48|0;f[a+44>>2]=F;f[F>>2]=0;f[a+52>>2]=0;F=e+8|0;f[F>>2]=0;f[F+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;h_(i,e);F=i+36|0;E=f[F>>2]|0;if(E|0?(B=E+12|0,E=f[B>>2]|0,f[B>>2]=E+-1,(E|0)==1):0)_S(i);f[F>>2]=0;F=i+16|0;E=i+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[E>>2]|0)>0){F=f[i+40>>2]|0;B=0;do{f[F+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[E>>2]|0))}E=f[i+44>>2]|0;if((E|0)==(i+48|0)){u=d;return}g0(E);u=d;return}case 3:{E=b[r+11>>0]|0;i=E<<24>>24<0;if(i)G=f[r+4>>2]|0;else G=E&255;if(!G){G=f[c+40>>2]|0;if(!G){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,14)|0;x=426686;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,e,426701,425810,742)}B=f[c+48>>2]|0;Vj(l,1,G,4,(B|0)==0?0:B+4|0,0);f[a>>2]=1124007936;B=a+8|0;G=a+40|0;w=a+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[G>>2]=B;B=a+48|0;f[a+44>>2]=B;f[B>>2]=0;f[a+52>>2]=0;B=e+8|0;f[B>>2]=0;f[B+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;h_(l,e);B=l+36|0;G=f[B>>2]|0;if(G|0?(F=G+12|0,G=f[F>>2]|0,f[F>>2]=G+-1,(G|0)==1):0)_S(l);f[B>>2]=0;B=l+16|0;G=l+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[G>>2]|0)>0){B=f[l+40>>2]|0;F=0;do{f[B+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[G>>2]|0))}G=f[l+44>>2]|0;if((G|0)==(l+48|0)){u=d;return}g0(G);u=d;return}if(i){H=f[r+4>>2]|0;I=f[r>>2]|0}else{H=E&255;I=r}Vj(k,1,H>>>2,4,I,0);f[a>>2]=1124007936;I=a+8|0;H=a+40|0;w=a+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[H>>2]=I;I=a+48|0;f[a+44>>2]=I;f[I>>2]=0;f[a+52>>2]=0;I=e+8|0;f[I>>2]=0;f[I+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;h_(k,e);I=k+36|0;H=f[I>>2]|0;if(H|0?(E=H+12|0,H=f[E>>2]|0,f[E>>2]=H+-1,(H|0)==1):0)_S(k);f[I>>2]=0;I=k+16|0;H=k+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[H>>2]|0)>0){I=f[k+40>>2]|0;E=0;do{f[I+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[H>>2]|0))}H=f[k+44>>2]|0;if((H|0)==(k+48|0)){u=d;return}g0(H);u=d;return}case 19:{f[m>>2]=1124007936;H=m+4|0;k=m+8|0;E=m+40|0;w=H;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[E>>2]=k;I=m+48|0;i=m+44|0;f[i>>2]=I;f[I>>2]=0;f[m+52>>2]=0;G=b[r+11>>0]|0;l=G<<24>>24<0;if(l)J=f[r+4>>2]|0;else J=G&255;if(!J){J=f[c+136>>2]|0;if(!J){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,14)|0;x=426686;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,e,426701,425810,757)}F=f[c+144>>2]|0;Vj(e,1,J,4,(F|0)==0?0:F+4|0,0);F=n+8|0;f[F>>2]=0;f[F+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=m;LZ(e,n,2,1.0,0.0);F=e+36|0;J=f[F>>2]|0;if(J|0?(c=J+12|0,J=f[c>>2]|0,f[c>>2]=J+-1,(J|0)==1):0)_S(e);f[F>>2]=0;F=e+16|0;J=e+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[J>>2]|0)>0){F=f[e+40>>2]|0;c=0;do{f[F+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[J>>2]|0))}J=f[e+44>>2]|0;if((J|0)!=(e+48|0))g0(J);K=m+16|0}else{if(l){L=f[r+4>>2]|0;M=f[r>>2]|0}else{L=G&255;M=r}Vj(e,1,L>>>1,2,M,0);M=e+36|0;L=f[M>>2]|0;if(L|0){G=L+12|0;f[G>>2]=(f[G>>2]|0)+1}G=m+36|0;L=f[G>>2]|0;if(L|0?(l=L+12|0,L=f[l>>2]|0,f[l>>2]=L+-1,(L|0)==1):0)_S(m);f[G>>2]=0;L=m+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[H>>2]|0)>0){l=f[E>>2]|0;J=0;do{f[l+(J<<2)>>2]=0;J=J+1|0;N=f[H>>2]|0}while((J|0)<(N|0));f[m>>2]=f[e>>2];if((N|0)<3)O=94;else O=96}else{f[m>>2]=f[e>>2];O=94}if((O|0)==94){N=f[e+4>>2]|0;if((N|0)<3){f[H>>2]=N;f[k>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];k=f[e+44>>2]|0;N=f[i>>2]|0;f[N>>2]=f[k>>2];f[N+4>>2]=f[k+4>>2]}else O=96}if((O|0)==96)ZS(m,e);O=e+16|0;f[L>>2]=f[O>>2];f[m+20>>2]=f[e+20>>2];f[m+24>>2]=f[e+24>>2];f[m+28>>2]=f[e+28>>2];f[m+32>>2]=f[e+32>>2];k=f[M>>2]|0;f[G>>2]=k;if(k|0?(G=k+12|0,k=f[G>>2]|0,f[G>>2]=k+-1,(k|0)==1):0)_S(e);f[M>>2]=0;M=e+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[M>>2]|0)>0){O=f[e+40>>2]|0;k=0;do{f[O+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[M>>2]|0))}M=f[e+44>>2]|0;if((M|0)!=(e+48|0))g0(M);K=L}L=f[E>>2]|0;M=f[L>>2]|0;f[o>>2]=f[L+4>>2];f[o+4>>2]=M;CY(n,o,3,f[K>>2]|0,0);o=f[E>>2]|0;M=f[o+4>>2]|0;L=f[o>>2]|0;f[a>>2]=1124007936;o=a+8|0;k=a+40|0;w=a+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[k>>2]=o;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;f[e>>2]=L;f[e+4>>2]=M;XS(a,2,e,5);f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=n;M=p+8|0;f[M>>2]=0;f[M+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=a;NZ(e,p);p=n+36|0;M=f[p>>2]|0;if(M|0?(L=M+12|0,M=f[L>>2]|0,f[L>>2]=M+-1,(M|0)==1):0)_S(n);f[p>>2]=0;p=n+16|0;M=n+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[M>>2]|0)>0){p=f[n+40>>2]|0;L=0;do{f[p+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[M>>2]|0))}M=f[n+44>>2]|0;if((M|0)!=(n+48|0))g0(M);M=m+36|0;n=f[M>>2]|0;if(n|0?(L=n+12|0,n=f[L>>2]|0,f[L>>2]=n+-1,(n|0)==1):0)_S(m);f[M>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[H>>2]|0)>0){K=f[E>>2]|0;E=0;do{f[K+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[H>>2]|0))}H=f[i>>2]|0;if((H|0)!=(I|0))g0(H);u=d;return}case 12:{H=b[r+11>>0]|0;I=H<<24>>24<0;if(I)P=f[r+4>>2]|0;else P=H&255;if(!P){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,16)|0;x=426718;y=w+16|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,e,426701,425810,769)}if(I){Q=f[r+4>>2]|0;R=f[r>>2]|0}else{Q=H&255;R=r}Vj(q,1,Q,0,R,0);f[a>>2]=1124007936;R=a+8|0;Q=a+40|0;w=a+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[Q>>2]=R;R=a+48|0;f[a+44>>2]=R;f[R>>2]=0;f[a+52>>2]=0;R=e+8|0;f[R>>2]=0;f[R+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;h_(q,e);a=q+36|0;R=f[a>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)_S(q);f[a>>2]=0;a=q+16|0;R=q+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[R>>2]|0)>0){a=f[q+40>>2]|0;Q=0;do{f[a+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[R>>2]|0))}R=f[q+44>>2]|0;if((R|0)==(q+48|0)){u=d;return}g0(R);u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;w=tT(e,35)|0;x=426735;y=w+35|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-2,e,426701,425810,773)}}}function Wnb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+8|0;c=a+20|0;d=f[c>>2]|0;do if(!d){e=a+12|0;g=f[a+16>>2]|0;h=6}else{i=a+12|0;j=f[i>>2]|0;k=f[d>>2]|0;if((j|0)>=(k|0))if((k|0)==(f[a+16>>2]|0)){e=i;g=k;h=6;break}else{l=i;m=k;n=d;break}f[i>>2]=j+1;o=f[d+4+(j<<2)>>2]|0;return o|0}while(0);if((h|0)==6){USb(b,g+1|0);g=f[c>>2]|0;l=e;m=f[g>>2]|0;n=g}f[n>>2]=m+1;m=f[b>>2]|0;if(!m){b=VDc(76)|0;KPa(b);p=b}else{if(f[m+64>>2]|0)OQb(m,14856,80);b=MQb(m,80)|0;UQa(b,m);p=b}b=f[c>>2]|0;c=f[l>>2]|0;f[l>>2]=c+1;f[b+4+(c<<2)>>2]=p;o=p;return o|0}function Xnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=Mpc(c)|0;if(g>>>0>4294967279)dEc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=VDc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){dJc(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+64|0;a=f[h>>2]|0;if((a|0)==527320)WJa(h,m,e);else iEc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function Ynb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;bJa(g,c,d,0);i=f[g>>2]|0;if(i|0){j=f[g+4>>2]|0;k=f[g+8>>2]|0;f[a>>2]=i;f[a+4>>2]=j;f[a+8>>2]=k;b[a+12>>0]=0;u=e;return}k=(f[c>>2]|0)+1|0;j=f[c+4>>2]|0;i=j*12|0;l=i>>>4;if(l>>>0>k>>>0){if(j>>>0>8&i>>>6>>>0>=k>>>0){i=((k*5|0)>>>2)+1|0;k=1;while(1)if(i<<k>>>0<l>>>0)k=k+1|0;else break;l=j>>>k;k=l>>>0>8?l:8;if((k|0)!=(j|0)){GJa(c,k);m=11}}}else if(j>>>0<=134217728){GJa(c,j<<1);m=11}if((m|0)==11){bJa(h,c,d,0);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2]}m=f[g+12>>2]|0;g=f[c+20>>2]|0;if(!g)n=VDc(20)|0;else{if(f[g+64>>2]|0)OQb(g,23824,24);n=MQb(g,24)|0}fEc(n,d);HJa(h,c,m,n);f[c>>2]=(f[c>>2]|0)+1;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];b[a+12>>0]=1;u=e;return}function Znb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=VDc(40)|0;fEc(d,b);kPa(d+16|0,b+16|0);e=d;return e|0}if(f[c+64>>2]|0)OQb(c,23824,40);d=MQb(c,40)|0;c=f[a>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;EJa(c,d);c=d+16|0;KNa(c,f[a>>2]|0);iEc(d,b)|0;lPa(c,b+16|0);e=d;return e|0}function _nb(a){a=a|0;YDc(a);return}function $nb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function aob(a){a=a|0;Lnb(a);YDc(a);return}function bob(a){a=a|0;YDc(a);return}function cob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dob(a){a=a|0;Lnb(a);YDc(a);return}function eob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+32|0;a=c+12|0;g=c;h=d+24|0;Wdc(h);i=d+48|0;f[g+8>>2]=0;d=g+11|0;b[d>>0]=7;b[g>>0]=b[440970]|0;b[g+1>>0]=b[440971]|0;b[g+2>>0]=b[440972]|0;b[g+3>>0]=b[440973]|0;b[g+4>>0]=b[440974]|0;b[g+5>>0]=b[440975]|0;b[g+6>>0]=b[440976]|0;b[g+7>>0]=0;j=dJa(i,g)|0;fEc(a,(f[j+20>>2]|0)==2?f[j+8>>2]|0:527320);if((b[d>>0]|0)<0)YDc(f[g>>2]|0);d=a+11|0;j=b[d>>0]|0;if(((j<<24>>24<0?f[a+4>>2]|0:j&255)|0)!=4){f[g>>2]=0;k=g+4|0;f[k>>2]=0;l=tT(g,17)|0;m=l;n=427155;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,453718,425810,528)}if(EEc(a,0,-1,450788,4)|0){f[g>>2]=0;k=g+4|0;f[k>>2]=0;l=tT(g,17)|0;m=l;n=427155;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,453718,425810,528)}Wdc(h);f[g+8>>2]=0;h=g+11|0;b[h>>0]=7;b[g>>0]=b[427173]|0;b[g+1>>0]=b[427174]|0;b[g+2>>0]=b[427175]|0;b[g+3>>0]=b[427176]|0;b[g+4>>0]=b[427177]|0;b[g+5>>0]=b[427178]|0;b[g+6>>0]=b[427179]|0;b[g+7>>0]=0;l=dJa(i,g)|0;i=(f[l+20>>2]|0)==1?f[l+8>>2]|0:520336;if((b[h>>0]|0)<0)YDc(f[g>>2]|0);if((f[i+24>>2]|0)!=4){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,21)|0;n=427181;o=m+21|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,453718,425810,531)}n=f[i+32>>2]|0;i=f[n+16>>2]|0;m=f[n+24>>2]|0;n=f[f[e>>2]>>2]|0;e=n+24|0;Wdc(e);Vdc(e);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=g+11|0;b[e>>0]=5;b[g>>0]=b[498520]|0;b[g+1>>0]=b[498521]|0;b[g+2>>0]=b[498522]|0;b[g+3>>0]=b[498523]|0;b[g+4>>0]=b[498524]|0;b[g+5>>0]=0;o=UJa(TJa(n+48|0,g)|0)|0;if((b[e>>0]|0)<0)YDc(f[g>>2]|0);f[o+40>>2]=0;g=o+40|0;e=o+44|0;if(!(f[e>>2]|0)){KLa(g,1);p=f[g>>2]|0}else p=0;n=o+48|0;o=f[n>>2]|0;f[g>>2]=p+1;f[o+4+(p<<2)>>2]=-1;p=f[g>>2]|0;if((p|0)==(f[e>>2]|0)){KLa(g,p+1|0);q=f[g>>2]|0;r=f[n>>2]|0}else{q=p;r=o}f[g>>2]=q+1;f[r+4+(q<<2)>>2]=i;i=f[g>>2]|0;if((i|0)==(f[e>>2]|0)){KLa(g,i+1|0);s=f[g>>2]|0;t=f[n>>2]|0}else{s=i;t=r}f[g>>2]=s+1;f[t+4+(s<<2)>>2]=m;m=f[g>>2]|0;if((m|0)==(f[e>>2]|0)){KLa(g,m+1|0);v=f[g>>2]|0;w=f[n>>2]|0}else{v=m;w=t}f[g>>2]=v+1;f[w+4+(v<<2)>>2]=-1;if((b[d>>0]|0)>=0){u=c;return}YDc(f[a>>2]|0);u=c;return}function fob(a){a=a|0;YDc(a);return}function gob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hob(a){a=a|0;Lnb(a);YDc(a);return}function iob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+32|0;a=c+12|0;g=c;Wdc(d+24|0);f[g+8>>2]=0;h=g+11|0;b[h>>0]=7;b[g>>0]=b[440970]|0;b[g+1>>0]=b[440971]|0;b[g+2>>0]=b[440972]|0;b[g+3>>0]=b[440973]|0;b[g+4>>0]=b[440974]|0;b[g+5>>0]=b[440975]|0;b[g+6>>0]=b[440976]|0;b[g+7>>0]=0;i=dJa(d+48|0,g)|0;fEc(a,(f[i+20>>2]|0)==2?f[i+8>>2]|0:527320);if((b[h>>0]|0)<0)YDc(f[g>>2]|0);h=a+11|0;i=b[h>>0]|0;if(((i<<24>>24<0?f[a+4>>2]|0:i&255)|0)!=5){f[g>>2]=0;j=g+4|0;f[j>>2]=0;k=tT(g,18)|0;l=k;m=427394;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,453718,425810,469)}if(EEc(a,0,-1,450782,5)|0){f[g>>2]=0;j=g+4|0;f[j>>2]=0;k=tT(g,18)|0;l=k;m=427394;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,453718,425810,469)}k=f[(f[e>>2]|0)+4>>2]|0;j=k+24|0;Wdc(j);Vdc(j);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=5;b[g>>0]=b[498520]|0;b[g+1>>0]=b[498521]|0;b[g+2>>0]=b[498522]|0;b[g+3>>0]=b[498523]|0;b[g+4>>0]=b[498524]|0;b[g+5>>0]=0;i=TJa(k+48|0,g)|0;k=f[((f[i+20>>2]|0)==8?f[i+8>>2]|0:520944)+156>>2]|0;i=k|0?k:520848;if((b[j>>0]|0)<0)YDc(f[g>>2]|0);if((f[i+12>>2]|0)!=4){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,27)|0;m=427413;n=l+27|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,453718,425810,474)}m=f[i+20>>2]|0;i=f[(f[m+4>>2]|0)+16>>2]|0;l=f[(f[m+8>>2]|0)+16>>2]|0;m=f[f[e>>2]>>2]|0;e=m+24|0;Wdc(e);Vdc(e);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=g+11|0;b[e>>0]=5;b[g>>0]=b[498520]|0;b[g+1>>0]=b[498521]|0;b[g+2>>0]=b[498522]|0;b[g+3>>0]=b[498523]|0;b[g+4>>0]=b[498524]|0;b[g+5>>0]=0;n=UJa(TJa(m+48|0,g)|0)|0;if((b[e>>0]|0)<0)YDc(f[g>>2]|0);f[n+40>>2]=0;g=n+40|0;e=n+44|0;if(!(f[e>>2]|0)){KLa(g,1);o=f[g>>2]|0}else o=0;m=n+48|0;n=f[m>>2]|0;f[g>>2]=o+1;f[n+4+(o<<2)>>2]=-1;o=f[g>>2]|0;if((o|0)==(f[e>>2]|0)){KLa(g,o+1|0);p=f[g>>2]|0;q=f[m>>2]|0}else{p=o;q=n}f[g>>2]=p+1;f[q+4+(p<<2)>>2]=i;i=f[g>>2]|0;if((i|0)==(f[e>>2]|0)){KLa(g,i+1|0);r=f[g>>2]|0;s=f[m>>2]|0}else{r=i;s=q}f[g>>2]=r+1;f[s+4+(r<<2)>>2]=l;l=f[g>>2]|0;if((l|0)==(f[e>>2]|0)){KLa(g,l+1|0);t=f[g>>2]|0;v=f[m>>2]|0}else{t=l;v=s}f[g>>2]=t+1;f[v+4+(t<<2)>>2]=-1;if((b[h>>0]|0)>=0){u=c;return}YDc(f[a>>2]|0);u=c;return}function job(a){a=a|0;YDc(a);return}function kob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function lob(a){a=a|0;Lnb(a);YDc(a);return}function mob(a){a=a|0;YDc(a);return}function nob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function oob(a){a=a|0;Lnb(a);YDc(a);return}function pob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+32|0;g=c+12|0;h=c;i=a+64|0;a=(f[i>>2]|0)+1|0;f[g>>2]=0;j=g+4|0;f[j>>2]=0;f[g+8>>2]=0;if(a>>>0>1073741823)mCc(g);k=a<<2;l=VDc(k)|0;f[g>>2]=l;m=l+(a<<2)|0;f[g+8>>2]=m;XIc(l|0,0,k|0)|0;f[j>>2]=m;f[l>>2]=-1;if((f[i>>2]|0)>0){l=h+11|0;m=h+5|0;k=0;do{k=k+1|0;a=f[(f[e>>2]|0)+(k<<2)>>2]|0;Wdc(a+24|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[l>>0]=5;b[h>>0]=b[498520]|0;b[h+1>>0]=b[498521]|0;b[h+2>>0]=b[498522]|0;b[h+3>>0]=b[498523]|0;b[h+4>>0]=b[498524]|0;b[m>>0]=0;n=dJa(a+48|0,h)|0;f[(f[g>>2]|0)+(k<<2)>>2]=f[(f[((f[n+20>>2]|0)==8?f[n+8>>2]|0:520944)+48>>2]|0)+4>>2];if((b[l>>0]|0)<0)YDc(f[h>>2]|0)}while((k|0)<(f[i>>2]|0))}k=f[(f[e>>2]|0)+4>>2]|0;e=k+24|0;Wdc(e);Vdc(e);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=h+11|0;b[e>>0]=5;b[h>>0]=b[498520]|0;b[h+1>>0]=b[498521]|0;b[h+2>>0]=b[498522]|0;b[h+3>>0]=b[498523]|0;b[h+4>>0]=b[498524]|0;b[h+5>>0]=0;l=UJa(TJa(k+48|0,h)|0)|0;if((b[e>>0]|0)<0)YDc(f[h>>2]|0);h=d+8|0;e=f[i>>2]|0;i=e+-1|0;if((e|0)>1){e=d+20|0;d=0;do{k=f[(f[e>>2]|0)+4+(d+2<<2)>>2]|0;if(!((k|0)==0|(f[h>>2]|0)!=0)){if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);YDc(k)}d=d+1|0}while((d|0)!=(i|0));VSb(h,2,i)}f[l+40>>2]=0;i=f[j>>2]|0;h=f[g>>2]|0;d=h;e=i;a:do if((i|0)==(h|0)){o=d;p=e}else{k=l+40|0;m=l+44|0;n=l+48|0;a=0;q=e;r=d;s=h;t=i;v=d;w=0;while(1){x=f[v+(a<<2)>>2]|0;if((w|0)==(f[m>>2]|0)){KLa(k,w+1|0);y=f[j>>2]|0;z=f[g>>2]|0;A=f[k>>2]|0;B=z;C=y;D=y;E=z}else{A=w;B=s;C=t;D=q;E=r}z=f[n>>2]|0;f[k>>2]=A+1;f[z+4+(A<<2)>>2]=x;x=a+1|0;if(x>>>0>=C-B>>2>>>0){o=E;p=D;break a}a=x;q=D;r=E;s=B;t=C;v=B;w=f[k>>2]|0}}while(0);if(!o){u=c;return}if((p|0)!=(o|0))f[j>>2]=p+(~((p+-4-o|0)>>>2)<<2);YDc(o);u=c;return}function qob(a){a=a|0;YDc(a);return}function rob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function sob(a){a=a|0;Lnb(a);YDc(a);return}function tob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+16|0;i=g;if(!(Nnb(a,c,d,e)|0)){j=0;u=g;return j|0}e=f[(f[c+20>>2]|0)+4+(d+1<<2)>>2]|0;Wdc(e+24|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=i+11|0;b[d>>0]=5;b[i>>0]=b[498520]|0;b[i+1>>0]=b[498521]|0;b[i+2>>0]=b[498522]|0;b[i+3>>0]=b[498523]|0;b[i+4>>0]=b[498524]|0;b[i+5>>0]=0;c=dJa(e+48|0,i)|0;Vnb(h,(f[c+20>>2]|0)==8?f[c+8>>2]|0:520944);if((b[d>>0]|0)<0)YDc(f[i>>2]|0);if((f[h>>2]&4095|0)==5){i=f[h+4>>2]|0;if((i|0)<3)k=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{d=f[h+40>>2]|0;c=0;e=1;while(1){a=Y(f[d+(c<<2)>>2]|0,e)|0;c=c+1|0;if((c|0)==(i|0)){k=a;break}else e=a}}if((k|0)==1)l=+n[f[h+16>>2]>>2]==6.0;else l=0}else l=0;k=h+36|0;e=f[k>>2]|0;if(e|0?(i=e+12|0,e=f[i>>2]|0,f[i>>2]=e+-1,(e|0)==1):0)_S(h);f[k>>2]=0;k=h+16|0;e=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[e>>2]|0)>0){k=f[h+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)!=(h+48|0))g0(e);j=l;u=g;return j|0}function uob(a){a=a|0;YDc(a);return}function vob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function wob(a){a=a|0;Lnb(a);YDc(a);return}function xob(a){a=a|0;YDc(a);return}function yob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zob(a){a=a|0;Lnb(a);YDc(a);return}function Aob(a){a=a|0;YDc(a);return}function Bob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Cob(a){a=a|0;Lnb(a);YDc(a);return}function Dob(a){a=a|0;YDc(a);return}function Eob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fob(a){a=a|0;Lnb(a);YDc(a);return}function Gob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=u;u=u+160|0;g=a+136|0;h=a+80|0;i=a+40|0;j=a;k=a+64|0;l=f[(f[e+4>>2]|0)+-4>>2]|0;Wdc(l+24|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=g+11|0;b[e>>0]=5;b[g>>0]=b[498520]|0;b[g+1>>0]=b[498521]|0;b[g+2>>0]=b[498522]|0;b[g+3>>0]=b[498523]|0;b[g+4>>0]=b[498524]|0;b[g+5>>0]=0;m=dJa(l+48|0,g)|0;Vnb(h,(f[m+20>>2]|0)==8?f[m+8>>2]|0:520944);if((b[e>>0]|0)<0)YDc(f[g>>2]|0);e=h+4|0;m=f[e>>2]|0;l=(m|0)<3;if(l)n=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{o=f[h+40>>2]|0;p=0;q=1;while(1){r=Y(f[o+(p<<2)>>2]|0,q)|0;p=p+1|0;if((p|0)==(m|0)){n=r;break}else q=r}}if((n|0)!=1){if(l){s=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;$1(s,1,98604)}l=f[h+40>>2]|0;n=0;q=1;while(1){p=Y(f[l+(n<<2)>>2]|0,q)|0;n=n+1|0;if((n|0)==(m|0)){s=p;break}else q=p}$1(s,1,98604)}s=f[h>>2]&4095;if((s|0)!=5)Y1(s,5,98632);s=d+20|0;q=f[s>>2]|0;m=d+12|0;n=(f[m>>2]|0)+-1|0;f[m>>2]=n;m=f[q+4+(n<<2)>>2]|0;n=m+11|0;if((b[n>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0}else{b[m>>0]=0;b[n>>0]=0}dRa(d);JNa(i);n=h+16|0;m=f[f[n>>2]>>2]|0;q=i+20|0;if((f[q>>2]|0)!=4){nNa(i);f[q>>2]=4}f[i+8>>2]=m;m=d+24|0;Wdc(m);Vdc(m);f[k+8>>2]=0;m=k+11|0;b[m>>0]=7;b[k>>0]=b[428696]|0;b[k+1>>0]=b[428697]|0;b[k+2>>0]=b[428698]|0;b[k+3>>0]=b[428699]|0;b[k+4>>0]=b[428700]|0;b[k+5>>0]=b[428701]|0;b[k+6>>0]=b[428702]|0;b[k+7>>0]=0;fEc(j,k);q=j+16|0;kPa(q,i);Ynb(g,f[d+56>>2]|0,j);if(b[g+12>>0]|0){l=Znb(d+48|0,j)|0;f[(f[g>>2]|0)+12>>2]=l}ROa(q);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[m>>0]|0)<0)YDc(f[k>>2]|0);m=Wnb(c)|0;Xnb(m,426101);jIa(g,f[d+60>>2]|0,428704);d=m+60|0;c=f[m+4>>2]|0;q=c&-2;if(!(c&1))t=q;else t=f[q+4>>2]|0;q=f[d>>2]|0;if((q|0)==527320)WJa(d,t,g);else iEc(q,g)|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);q=m+24|0;Wdc(q);Vdc(q);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=k+11|0;b[q>>0]=5;b[k>>0]=b[498520]|0;b[k+1>>0]=b[498521]|0;b[k+2>>0]=b[498522]|0;b[k+3>>0]=b[498523]|0;b[k+4>>0]=b[498524]|0;b[k+5>>0]=0;fEc(j,k);t=j+16|0;kPa(t,i);Ynb(g,f[m+56>>2]|0,j);if(b[g+12>>0]|0){d=Znb(m+48|0,j)|0;f[(f[g>>2]|0)+12>>2]=d}ROa(t);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[q>>0]|0)<0)YDc(f[k>>2]|0);iEc(f[(f[s>>2]|0)+8>>2]|0,f[m+60>>2]|0)|0;ROa(i);i=h+36|0;m=f[i>>2]|0;if(m|0?(s=m+12|0,m=f[s>>2]|0,f[s>>2]=m+-1,(m|0)==1):0)_S(h);f[i>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[e>>2]|0)>0){n=f[h+40>>2]|0;i=0;do{f[n+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=a;return}g0(e);u=a;return}function Hob(a){a=a|0;YDc(a);return}function Iob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Job(a){a=a|0;Lnb(a);YDc(a);return}function Kob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+160|0;a=c+136|0;g=c+80|0;h=c+40|0;i=c;j=c+64|0;k=f[(f[e+4>>2]|0)+-4>>2]|0;Wdc(k+24|0);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=a+11|0;b[e>>0]=5;b[a>>0]=b[498520]|0;b[a+1>>0]=b[498521]|0;b[a+2>>0]=b[498522]|0;b[a+3>>0]=b[498523]|0;b[a+4>>0]=b[498524]|0;b[a+5>>0]=0;l=dJa(k+48|0,a)|0;Vnb(g,(f[l+20>>2]|0)==8?f[l+8>>2]|0:520944);if((b[e>>0]|0)<0)YDc(f[a>>2]|0);e=g+4|0;l=f[e>>2]|0;k=(l|0)<3;if(k)m=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{n=f[g+40>>2]|0;o=0;p=1;while(1){q=Y(f[n+(o<<2)>>2]|0,p)|0;o=o+1|0;if((o|0)==(l|0)){m=q;break}else p=q}}if((m|0)!=1){if(k){r=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;$1(r,1,98684)}k=f[g+40>>2]|0;m=0;p=1;while(1){o=Y(f[k+(m<<2)>>2]|0,p)|0;m=m+1|0;if((m|0)==(l|0)){r=o;break}else p=o}$1(r,1,98684)}r=f[g>>2]&4095;if((r|0)!=5)Y1(r,5,98712);r=f[d+20>>2]|0;p=d+12|0;l=(f[p>>2]|0)+-1|0;f[p>>2]=l;p=f[r+4+(l<<2)>>2]|0;l=p+11|0;if((b[l>>0]|0)<0){b[f[p>>2]>>0]=0;f[p+4>>2]=0}else{b[p>>0]=0;b[l>>0]=0}dRa(d);JNa(h);l=g+16|0;p=f[f[l>>2]>>2]|0;r=h+20|0;if((f[r>>2]|0)!=4){nNa(h);f[r>>2]=4}f[h+8>>2]=p;p=d+24|0;Wdc(p);Vdc(p);f[j+8>>2]=0;p=j+11|0;b[p>>0]=7;b[j>>0]=b[428696]|0;b[j+1>>0]=b[428697]|0;b[j+2>>0]=b[428698]|0;b[j+3>>0]=b[428699]|0;b[j+4>>0]=b[428700]|0;b[j+5>>0]=b[428701]|0;b[j+6>>0]=b[428702]|0;b[j+7>>0]=0;fEc(i,j);r=i+16|0;kPa(r,h);Ynb(a,f[d+56>>2]|0,i);if(b[a+12>>0]|0){m=Znb(d+48|0,i)|0;f[(f[a>>2]|0)+12>>2]=m}ROa(r);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[p>>0]|0)<0)YDc(f[j>>2]|0);ROa(h);h=g+36|0;j=f[h>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)_S(g);f[h>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[e>>2]|0)>0){l=f[g+40>>2]|0;h=0;do{f[l+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[e>>2]|0))}e=f[g+44>>2]|0;if((e|0)==(g+48|0)){u=c;return}g0(e);u=c;return}function Lob(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;c=u;u=u+64|0;d=c;e=c+40|0;g=c+28|0;h=c+16|0;i=c+8|0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+4|0;f[e>>2]=j;f[g>>2]=0;k=g+4|0;f[k>>2]=0;f[g+8>>2]=0;l=f[a+12>>2]|0;f[d>>2]=0;m=(l|0)>0;a:do if(m){n=a+20|0;o=h+4|0;p=g+8|0;q=i+4|0;r=0;do{s=f[(f[n>>2]|0)+4+(r<<2)>>2]|0;t=f[s+64>>2]|0;f[h>>2]=0;f[o>>2]=0;v=t+11|0;w=b[v>>0]|0;x=w<<24>>24<0?f[t+4>>2]|0:w&255;if(x){w=tT(h,x)|0;dJc(w|0,((b[v>>0]|0)<0?f[t>>2]|0:t)|0,x|0)|0;x=f[h>>2]|0;if((x|0)==429288)y=10;else{z=x;y=8}}else{z=0;y=8}if((y|0)==8){y=0;x=(z|0)==0?1154740:z;if(!(!((Ioc(x,429288)|0)==0|(z|0)==429297)?(Ioc(x,429297)|0)!=0:0))y=10}if((y|0)==10){y=0;x=f[k>>2]|0;if((x|0)==(f[p>>2]|0))g6(g,d);else{f[x>>2]=f[d>>2];f[k>>2]=x+4}x=f[(f[s+20>>2]|0)+4>>2]|0;t=f[s+60>>2]|0;f[i>>2]=0;f[q>>2]=0;s=t+11|0;v=b[s>>0]|0;w=v<<24>>24<0?f[t+4>>2]|0:v&255;if(w|0){v=tT(i,w)|0;dJc(v|0,((b[s>>0]|0)<0?f[t>>2]|0:t)|0,w|0)|0}w=Mob(e,i)|0;uT(w);t=x+11|0;s=b[t>>0]|0;v=s<<24>>24<0?f[x+4>>2]|0:s&255;if(v|0){s=tT(w,v)|0;dJc(s|0,((b[t>>0]|0)<0?f[x>>2]|0:x)|0,v|0)|0}uT(i)}uT(h);r=(f[d>>2]|0)+1|0;f[d>>2]=r}while((r|0)<(l|0));if(m){r=a+20|0;q=d+4|0;p=h+11|0;o=h+8|0;n=h+4|0;v=0;b:while(1){x=f[(f[r>>2]|0)+4+(v<<2)>>2]|0;t=x+12|0;if((f[t>>2]|0)>0){s=x+20|0;x=0;do{w=f[(f[s>>2]|0)+4+(x<<2)>>2]|0;f[d>>2]=0;f[q>>2]=0;A=w+11|0;B=b[A>>0]|0;C=B<<24>>24<0?f[w+4>>2]|0:B&255;if(C|0){B=tT(d,C)|0;dJc(B|0,((b[A>>0]|0)<0?f[w>>2]|0:w)|0,C|0)|0}C=f[j>>2]|0;do if(C|0){w=f[d>>2]|0;A=(w|0)==0?1154740:w;B=j;D=C;c:while(1){E=D;while(1){F=f[E+16>>2]|0;if((F|0)==(w|0))break;if((Ioc((F|0)==0?1154740:F,A)|0)>=0)break;F=f[E+4>>2]|0;if(!F){G=B;break c}else E=F}D=f[E>>2]|0;if(!D){G=E;break}else B=E}if((G|0)!=(j|0)){B=f[G+16>>2]|0;if((w|0)!=(B|0)?(Ioc(A,(B|0)==0?1154740:B)|0)<=-1:0)break;B=f[G+24>>2]|0;D=f[G+28>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(D>>>0>4294967279)break b;if(D>>>0<11){b[p>>0]=D;if(!D)H=h;else{I=h;y=41}}else{F=D+16&-16;J=VDc(F)|0;f[h>>2]=J;f[o>>2]=F|-2147483648;f[n>>2]=D;I=J;y=41}if((y|0)==41){y=0;dJc(I|0,B|0,D|0)|0;H=I}b[H+D>>0]=0;iEc(f[(f[s>>2]|0)+4+(x<<2)>>2]|0,h)|0;if((b[p>>0]|0)<0)YDc(f[h>>2]|0)}}while(0);uT(d);x=x+1|0}while((x|0)<(f[t>>2]|0))}v=v+1|0;if((v|0)>=(l|0))break a}dEc(h)}}while(0);rsc(f[g>>2]|0,f[k>>2]|0,d);d=f[k>>2]|0;h=f[g>>2]|0;l=h;if((d|0)==(h|0)){K=d;L=l}else{d=a+8|0;h=a+20|0;a=0;H=l;while(1){l=(f[H+(a<<2)>>2]|0)-a|0;I=f[(f[h>>2]|0)+4+(l<<2)>>2]|0;if(!((I|0)==0|(f[d>>2]|0)!=0))Yi[f[(f[I>>2]|0)+4>>2]&2047](I);VSb(d,l,1);a=a+1|0;l=f[k>>2]|0;I=f[g>>2]|0;y=I;if(a>>>0>=l-I>>2>>>0){K=l;L=y;break}else H=y}}H=K;if(!L){M=f[j>>2]|0;Nob(e,M);u=c;return}if((H|0)!=(L|0))f[k>>2]=H+(~((H+-4-L|0)>>>2)<<2);YDc(L);M=f[j>>2]|0;Nob(e,M);u=c;return}function Mob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=a+4|0;d=f[c>>2]|0;a:do if(!d){e=c;g=c;h=d;i=12}else{j=a+4|0;k=f[b>>2]|0;l=(k|0)==0?1154740:k;m=f[d+16>>2]|0;b:do if((k|0)!=(m|0)){n=j;o=d;p=m;q=d;while(1){r=(p|0)==0?1154740:p;if((Ioc(l,r)|0)<0){s=f[o>>2]|0;if(!s){i=6;break}else{t=o;u=s}}else{if((Ioc(r,l)|0)>=0){v=n;w=o;x=q;break b}y=o+4|0;r=f[y>>2]|0;if(!r){i=9;break}else{t=y;u=r}}p=f[u+16>>2]|0;if((k|0)==(p|0)){v=t;w=u;x=u;break b}else{n=t;o=u;q=u}}if((i|0)==6){z=o;A=o;break a}else if((i|0)==9){z=y;A=o;break a}}else{v=j;w=d;x=d}while(0);e=v;g=w;h=x;i=12}while(0);if((i|0)==12)if(!h){z=e;A=g}else{B=h;C=B+24|0;return C|0}h=VDc(32)|0;g=f[b>>2]|0;f[h+16>>2]=g;f[h+20>>2]=f[b+4>>2];if(g|0){b=g+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[h+24>>2]=0;f[h+28>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=A;f[z>>2]=h;A=f[f[a>>2]>>2]|0;if(!A)D=h;else{f[a>>2]=A;D=f[z>>2]|0}laa(f[a+4>>2]|0,D);D=a+8|0;f[D>>2]=(f[D>>2]|0)+1;B=h;C=B+24|0;return C|0}function Nob(a,b){a=a|0;b=b|0;if(!b)return;Nob(a,f[b>>2]|0);Nob(a,f[b+4>>2]|0);uT(b+24|0);uT(b+16|0);YDc(b);return}function Oob(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+152|0;d=a+4|0;e=f[d>>2]|0;g=e&-2;if(!(e&1))h=g;else h=f[g+4>>2]|0;g=f[c>>2]|0;if((g|0)==527320){WJa(c,h,527320);i=f[c>>2]|0}else i=g;g=b[i+11>>0]|0;if(g<<24>>24<0)j=f[i+4>>2]|0;else j=g&255;if(!j)return;j=f[d>>2]|0;d=j&-2;if(!(j&1))k=d;else k=f[d+4>>2]|0;d=a+152|0;if((i|0)==527320)return;if(!k){f[d>>2]=527320;if(!i)return;else{l=i;m=g}}else{g=VDc(12)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[d>>2]=527320;l=g;m=b[g+11>>0]|0}if(m<<24>>24<0)YDc(f[l>>2]|0);YDc(l);return}function Pob(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,429326,d);return}function Qob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+32|0;g=e+16|0;h=e;i=e+24|0;a:do switch(Mpc(c)|0){case 1:{switch(b[c>>0]|0){case 114:break;case 119:{f[i>>2]=0;j=i+4|0;f[j>>2]=0;k=tT(i,25)|0;l=k;m=429463;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Pob(-215,i,429448,482);break}default:break a}o=a+11|0;p=yqc((b[o>>0]|0)<0?f[a>>2]|0:a,429489)|0;if(!p)if(!d){f[h>>2]=(b[o>>0]|0)<0?f[a>>2]|0:a;f[h+4>>2]=114;f[h+8>>2]=32;F5(i,429492,h);Pob(-2,i,429448,496)}else{q=0;u=e;return q|0}o=ooc(40)|0;if(!o){F5(i,429522,g);Pob(-2,i,429448,501)}f[o+28>>2]=p;f[o+32>>2]=1;f[o+36>>2]=0;f[o>>2]=98740;f[o+4>>2]=d;f[o+8>>2]=1;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=1;f[o+24>>2]=0;q=o;u=e;return q|0}case 2:{if((b[c>>0]|0)==114?(b[c+1>>0]|0)==119:0){f[i>>2]=0;j=i+4|0;f[j>>2]=0;k=tT(i,25)|0;l=k;m=429463;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Pob(-215,i,429448,482)}break}default:{}}while(0);f[i>>2]=0;f[i+4>>2]=0;l=tT(i,47)|0;m=429400;n=l+47|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Pob(-215,i,429448,480);return 0}function Rob(a){a=a|0;return (f[a+28>>2]|0)!=0|0}function Sob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=e+8|0;i=a+28|0;j=f[i>>2]|0;if(!j){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,20)|0;l=429305;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));Pob(-215,h,430173,266)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,23)|0;l=429775;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));Pob(-215,h,430173,266)}a:do if(!(f[a+16>>2]|0))if((d|0)>0){l=Qpc(c,1,d,j)|0;if(!(f[a+20>>2]|0))n=l;else{k=Noc(f[i>>2]|0)|0;switch(k|0){case 10:case -1:{n=l;break a;break}default:{}}nqc(k,f[i>>2]|0)|0;n=l}}else n=0;else n=Qpc(c,1,d,j)|0;while(0);if((n|0)==(d|0)){u=e;return n|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=n;f[g+4>>2]=d;F5(h,429991,g);Pob(-2,h,430173,266)}else{u=e;return n|0}return 0}function Tob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=e+8|0;i=a+28|0;j=f[i>>2]|0;if(!j){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,20)|0;l=429305;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));Pob(-215,h,430153,270)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,23)|0;l=429775;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));Pob(-215,h,430153,270)}a:do if(!(f[a+16>>2]|0))if((d|0)>0){l=Qpc(c,1,d,j)|0;if(!(f[a+20>>2]|0))n=l;else{k=Noc(f[i>>2]|0)|0;switch(k|0){case 10:case -1:{n=l;break a;break}default:{}}nqc(k,f[i>>2]|0)|0;n=l}}else n=0;else n=Qpc(c,1,d,j)|0;while(0);if((n|0)==(d|0)){u=e;return n|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=n;f[g+4>>2]=d;F5(h,429991,g);Pob(-2,h,430153,270)}else{u=e;return n|0}return 0}function Uob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;l=f[k>>2]|0;if(!l){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,20)|0;n=429305;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,j,430128,274)}if(!(f[a+8>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,23)|0;n=429775;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,j,430128,274)}a:do if(!(f[a+16>>2]|0)){n=(d|0)>0;if(n){f[i>>2]=c;m=(opc(l,430149,i)|0)>0;o=m&1;if(m&(d|0)!=1){m=o;p=1;while(1){q=f[k>>2]|0;f[h>>2]=c+(p<<1);r=(opc(q,430149,h)|0)>0;q=(r&1)+m|0;p=p+1|0;if(!(r&(p|0)<(d|0))){s=q;break}else m=q}}else s=o;if(n&(f[a+20>>2]|0)!=0){m=Noc(f[k>>2]|0)|0;switch(m|0){case 10:case -1:{t=s;break a;break}default:{}}nqc(m,f[k>>2]|0)|0;t=s}else t=s}else t=0}else{m=Qpc(c,2,d,l)|0;if((m|0)>0&(f[a+32>>2]|0)==0){p=0;q=c;while(1){r=b[q>>0]|0;v=q+1|0;b[q>>0]=b[v>>0]|0;b[v>>0]=r;p=p+1|0;if((p|0)==(m|0)){t=m;break}else q=q+2|0}}else t=m}while(0);if((t|0)==(d|0)){u=e;return t|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=t;f[g+4>>2]=d;F5(j,429991,g);Pob(-2,j,430128,274)}else{u=e;return t|0}return 0}function Vob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;l=f[k>>2]|0;if(!l){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,20)|0;n=429305;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,j,430104,278)}if(!(f[a+8>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,23)|0;n=429775;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,j,430104,278)}a:do if(!(f[a+16>>2]|0)){n=(d|0)>0;if(n){f[i>>2]=c;m=(opc(l,430123,i)|0)>0;o=m&1;if(m&(d|0)!=1){m=o;p=1;while(1){q=f[k>>2]|0;f[h>>2]=c+(p<<2);r=(opc(q,430123,h)|0)>0;q=(r&1)+m|0;p=p+1|0;if(!(r&(p|0)<(d|0))){s=q;break}else m=q}}else s=o;if(n&(f[a+20>>2]|0)!=0){m=Noc(f[k>>2]|0)|0;switch(m|0){case 10:case -1:{t=s;break a;break}default:{}}nqc(m,f[k>>2]|0)|0;t=s}else t=s}else t=0}else{m=Qpc(c,4,d,l)|0;if((m|0)>0&(f[a+32>>2]|0)==0){p=0;q=c;while(1){r=b[q>>0]|0;v=q+3|0;b[q>>0]=b[v>>0]|0;b[v>>0]=r;r=q+1|0;v=b[r>>0]|0;w=q+2|0;b[r>>0]=b[w>>0]|0;b[w>>0]=v;p=p+1|0;if((p|0)==(m|0)){t=m;break}else q=q+4|0}}else t=m}while(0);if((t|0)==(d|0)){u=e;return t|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=t;f[g+4>>2]=d;F5(j,429991,g);Pob(-2,j,430104,278)}else{u=e;return t|0}return 0}function Wob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+24|0;h=e+16|0;i=e+8|0;j=e;k=e+32|0;l=a+28|0;m=f[l>>2]|0;if(!m){f[k>>2]=0;f[k+4>>2]=0;n=tT(k,20)|0;o=429305;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Pob(-215,k,430056,299)}if(!(f[a+8>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;n=tT(k,23)|0;o=429775;p=n+23|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Pob(-215,k,430056,300)}a:do if(!(f[a+16>>2]|0)){o=(d|0)>0;if(o){f[j>>2]=k;b:do if((opc(m,430076,j)|0)<1){q=0;r=23}else{n=0;while(1){p=n+1|0;s=f[k>>2]|0;t=c+(n<<3)|0;f[t>>2]=s;f[t+4>>2]=((s|0)<0)<<31>>31;if((p|0)>=(d|0)){v=p;break b}s=f[l>>2]|0;f[h>>2]=k;if((opc(s,430076,h)|0)<1){q=p;r=23;break}else n=p}}while(0);if((r|0)==23)v=q;if(o&(f[a+20>>2]|0)!=0){n=Noc(f[l>>2]|0)|0;switch(n|0){case 10:case -1:{w=v;break a;break}default:{}}nqc(n,f[l>>2]|0)|0;w=v}else w=v}else w=0}else switch(f[a+36>>2]|0){case 8:case 0:{n=Qpc(c,8,d,m)|0;if((n|0)>0&(f[a+32>>2]|0)==0){x=0;y=c}else{w=n;break a}while(1){p=b[y>>0]|0;s=y+7|0;b[y>>0]=b[s>>0]|0;b[s>>0]=p;p=y+1|0;s=b[p>>0]|0;t=y+6|0;b[p>>0]=b[t>>0]|0;b[t>>0]=s;s=y+2|0;t=b[s>>0]|0;p=y+5|0;b[s>>0]=b[p>>0]|0;b[p>>0]=t;t=y+3|0;p=b[t>>0]|0;s=y+4|0;b[t>>0]=b[s>>0]|0;b[s>>0]=p;x=x+1|0;if((x|0)==(n|0)){w=n;break}else y=y+8|0}break}case 4:{n=Qpc(c,4,d,m)|0;o=(n|0)>0;if(o&(f[a+32>>2]|0)==0){p=0;s=c;while(1){t=b[s>>0]|0;z=s+3|0;b[s>>0]=b[z>>0]|0;b[z>>0]=t;t=s+1|0;z=b[t>>0]|0;A=s+2|0;b[t>>0]=b[A>>0]|0;b[A>>0]=z;p=p+1|0;if((p|0)==(n|0))break;else s=s+4|0}}if(!o){w=n;break a}s=n;do{p=s;s=s+-1|0;z=f[c+(s<<2)>>2]|0;A=c+(s<<3)|0;f[A>>2]=z;f[A+4>>2]=((z|0)<0)<<31>>31}while((p|0)>1);w=n;break}default:{n=ooc(d<<3)|0;if(!n){F5(k,430080,i);Pob(-2,k,430056,323)}s=Qpc(n,8,d,m)|0;o=(s|0)>0;if(o){p=s;do{z=p;p=p+-1|0;A=f[n+(p<<1<<2)>>2]|0;t=c+(p<<3)|0;f[t>>2]=A;f[t+4>>2]=((A|0)<0)<<31>>31}while((z|0)>1)}poc(n);if(!(o&(f[a+32>>2]|0)==0)){w=s;break a}p=0;z=c;while(1){A=b[z>>0]|0;t=z+3|0;b[z>>0]=b[t>>0]|0;b[t>>0]=A;A=z+1|0;t=b[A>>0]|0;B=z+2|0;b[A>>0]=b[B>>0]|0;b[B>>0]=t;p=p+1|0;if((p|0)==(s|0)){w=s;break}else z=z+4|0}}}while(0);if((w|0)==(d|0)){u=e;return w|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=w;f[g+4>>2]=d;F5(k,429991,g);Pob(-2,k,430056,354)}else{u=e;return w|0}return 0}function Xob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;l=f[k>>2]|0;if(!l){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,20)|0;n=429305;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,j,430032,286)}if(!(f[a+8>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,23)|0;n=429775;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,j,430032,286)}a:do if(!(f[a+16>>2]|0)){n=(d|0)>0;if(n){f[i>>2]=c;m=(opc(l,430053,i)|0)>0;o=m&1;if(m&(d|0)!=1){m=o;p=1;while(1){q=f[k>>2]|0;f[h>>2]=c+(p<<2);r=(opc(q,430053,h)|0)>0;q=(r&1)+m|0;p=p+1|0;if(!(r&(p|0)<(d|0))){s=q;break}else m=q}}else s=o;if(n&(f[a+20>>2]|0)!=0){m=Noc(f[k>>2]|0)|0;switch(m|0){case 10:case -1:{t=s;break a;break}default:{}}nqc(m,f[k>>2]|0)|0;t=s}else t=s}else t=0}else{m=Qpc(c,4,d,l)|0;if((m|0)>0&(f[a+32>>2]|0)==0){p=0;q=c;while(1){r=b[q>>0]|0;v=q+3|0;b[q>>0]=b[v>>0]|0;b[v>>0]=r;r=q+1|0;v=b[r>>0]|0;w=q+2|0;b[r>>0]=b[w>>0]|0;b[w>>0]=v;p=p+1|0;if((p|0)==(m|0)){t=m;break}else q=q+4|0}}else t=m}while(0);if((t|0)==(d|0)){u=e;return t|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=t;f[g+4>>2]=d;F5(j,429991,g);Pob(-2,j,430032,286)}else{u=e;return t|0}return 0}function Yob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;l=f[k>>2]|0;if(!l){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,20)|0;n=429305;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,j,429965,290)}if(!(f[a+8>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,23)|0;n=429775;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,j,429965,290)}a:do if(!(f[a+16>>2]|0)){n=(d|0)>0;if(n){f[i>>2]=c;m=(opc(l,429987,i)|0)>0;o=m&1;if(m&(d|0)!=1){m=o;p=1;while(1){q=f[k>>2]|0;f[h>>2]=c+(p<<3);r=(opc(q,429987,h)|0)>0;q=(r&1)+m|0;p=p+1|0;if(!(r&(p|0)<(d|0))){s=q;break}else m=q}}else s=o;if(n&(f[a+20>>2]|0)!=0){m=Noc(f[k>>2]|0)|0;switch(m|0){case 10:case -1:{t=s;break a;break}default:{}}nqc(m,f[k>>2]|0)|0;t=s}else t=s}else t=0}else{m=Qpc(c,8,d,l)|0;if((m|0)>0&(f[a+32>>2]|0)==0){p=0;q=c;while(1){r=b[q>>0]|0;v=q+7|0;b[q>>0]=b[v>>0]|0;b[v>>0]=r;r=q+1|0;v=b[r>>0]|0;w=q+6|0;b[r>>0]=b[w>>0]|0;b[w>>0]=v;v=q+2|0;w=b[v>>0]|0;r=q+5|0;b[v>>0]=b[r>>0]|0;b[r>>0]=w;w=q+3|0;r=b[w>>0]|0;v=q+4|0;b[w>>0]=b[v>>0]|0;b[v>>0]=r;p=p+1|0;if((p|0)==(m|0)){t=m;break}else q=q+8|0}}else t=m}while(0);if((t|0)==(d|0)){u=e;return t|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=t;f[g+4>>2]=d;F5(j,429991,g);Pob(-2,j,429965,290)}else{u=e;return t|0}return 0}function Zob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+48|0;g=e+24|0;h=e+16|0;i=e+8|0;j=e;k=e+32|0;l=a+28|0;if(!(f[l>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;m=tT(k,20)|0;n=429305;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,k,429753,364)}if(!(f[a+8>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;m=tT(k,23)|0;n=429775;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,k,429753,365)}if(((Mpc(c)|0)>>>0>1?(b[c>>0]|0)==42:0)?(p=b[c+1>>0]|0,c=p<<24>>24==97,!(c^p<<24>>24!=108)):0){p=ooc(1024)|0;if(c){c=0;q=1024;r=p;while(1){s=q+1024|0;if((q|0)==(c|0)){t=s;v=qoc(r,s)|0}else{t=q;v=r}if(!v){w=13;break}c=(Qpc(v+c|0,1,t-c|0,f[l>>2]|0)|0)+c|0;if((c|0)<(t|0))break;else{q=t;r=v}}if((w|0)==13){F5(k,429888,j);Pob(-2,k,429753,386)}if(c|0){x=v;y=c;f[d>>2]=x;u=e;return y|0}poc(v);f[a+24>>2]=1;if(!(f[a+4>>2]|0)){F5(k,429926,i);Pob(-2,k,429753,395)}else{x=0;y=0;f[d>>2]=x;u=e;return y|0}}else{z=0;A=1024;B=p}while(1){p=A+1024|0;if((A-z|0)<2){C=p;D=qoc(B,p)|0}else{C=A;D=B}if(!D){w=21;break}p=D+z|0;if(!(mqc(p,C-z|0,f[l>>2]|0)|0)){w=23;break}i=Mpc(p)|0;if(i|0?(E=i+-1|0,(b[p+E>>0]|0)==10):0){w=29;break}z=i+z|0;A=C;B=D}if((w|0)==21){F5(k,429888,h);Pob(-2,k,429753,420)}else if((w|0)==23){if(z|0){x=D;y=z;f[d>>2]=x;u=e;return y|0}poc(D);f[a+24>>2]=1;if(!(f[a+4>>2]|0)){F5(k,429926,g);Pob(-2,k,429753,428)}else{x=0;y=0;f[d>>2]=x;u=e;return y|0}}else if((w|0)==29){x=D;y=E+z|0;f[d>>2]=x;u=e;return y|0}}f[k>>2]=0;f[k+4>>2]=0;m=tT(k,88)|0;n=429799;o=m+88|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Pob(-215,k,429753,366);return 0}function _ob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=d+8|0;h=f[a+28>>2]|0;if(!h){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,20)|0;j=429305;k=i+20|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));Pob(-215,g,429707,111)}if((uqc(h,c,0)|0)>=0){u=d;return}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[e>>2]=c;F5(g,429723,e);Pob(-2,g,429707,123)}else{u=d;return}}function $ob(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[a+28>>2]|0;if(!g){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,20)|0;i=429305;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));Pob(-215,e,429658,131)}if((uqc(g,0,2)|0)>=0){u=c;return}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){F5(e,429677,d);Pob(-2,e,429658,143)}else{u=c;return}}function apb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[a+28>>2]|0;if(!g){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,20)|0;i=429305;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));Pob(-215,e,429571,150)}i=Spc(g)|0;if((i|0)>-1){k=i;u=c;return k|0}if(!(f[a+4>>2]|0)){F5(e,429591,d);Pob(-2,e,429571,162)}else{k=0;u=c;return k|0}return 0}function bpb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=a+28|0;a=f[e>>2]|0;if(!a){f[d>>2]=0;f[d+4>>2]=0;g=tT(d,20)|0;h=429305;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));Pob(-215,d,429554,170)}else{_pc(a)|0;f[e>>2]=0;u=c;return}}function cpb(a){a=a|0;var b=0;b=f[a+28>>2]|0;if(!b){poc(a);return}_pc(b)|0;poc(a);return}function dpb(a,b){a=a|0;b=b|0;var c=0;c=VDc(56)|0;epb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=98804;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function epb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;d=u;u=u+16|0;e=d+8|0;g=d;JHa(a);f[a>>2]=98824;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;h=tT(e,1)|0;b[h>>0]=112;h=c+4|0;c=f[h>>2]|0;do if(c){i=f[e>>2]|0;j=(i|0)==0?1154740:i;k=h;l=c;a:while(1){m=l;while(1){o=f[m+16>>2]|0;if((o|0)==(i|0))break;if((Ioc((o|0)==0?1154740:o,j)|0)>=0)break;o=f[m+4>>2]|0;if(!o){p=k;break a}else m=o}l=f[m>>2]|0;if(!l){p=m;break}else k=m}if((p|0)!=(h|0)){k=f[p+16>>2]|0;if((i|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<=-1:0){q=2.0;break}q=+tIa(p+24|0,-1)}else q=2.0}else q=2.0;while(0);p=a+36|0;n[p>>2]=q;uT(e);f[e>>2]=0;f[e+4>>2]=0;c=tT(e,3)|0;b[c>>0]=b[454985]|0;b[c+1>>0]=b[454986]|0;b[c+2>>0]=b[454987]|0;c=f[h>>2]|0;do if(c){k=f[e>>2]|0;l=(k|0)==0?1154740:k;o=h;r=c;b:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)==(k|0))break;if((Ioc((t|0)==0?1154740:t,l)|0)>=0)break;t=f[s+4>>2]|0;if(!t){v=o;break b}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else o=s}if((v|0)!=(h|0)){o=f[v+16>>2]|0;if((k|0)!=(o|0)?(Ioc(l,(o|0)==0?1154740:o)|0)<=-1:0){w=1.000000013351432e-10;break}w=+tIa(v+24|0,-1)}else w=1.000000013351432e-10}else w=1.000000013351432e-10;while(0);n[a+40>>2]=w;uT(e);f[e>>2]=0;f[e+4>>2]=0;v=tT(e,14)|0;c=430279;o=v+14|0;do{b[v>>0]=b[c>>0]|0;v=v+1|0;c=c+1|0}while((v|0)<(o|0));r=f[h>>2]|0;do if(r){j=f[e>>2]|0;i=(j|0)==0?1154740:j;m=h;t=r;c:while(1){x=t;while(1){y=f[x+16>>2]|0;if((y|0)==(j|0))break;if((Ioc((y|0)==0?1154740:y,i)|0)>=0)break;y=f[x+4>>2]|0;if(!y){z=m;break c}else x=y}t=f[x>>2]|0;if(!t){z=x;break}else m=x}if((z|0)!=(h|0)){m=f[z+16>>2]|0;if((j|0)!=(m|0)?(Ioc(i,(m|0)==0?1154740:m)|0)<=-1:0){A=1;break}m=DHa(z+24|0,-1)|0;A=(m|0)!=0|(J|0)!=0}else A=1}else A=1;while(0);z=a+44|0;b[z>>0]=A&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;v=tT(e,10)|0;c=430294;o=v+10|0;do{b[v>>0]=b[c>>0]|0;v=v+1|0;c=c+1|0}while((v|0)<(o|0));A=f[h>>2]|0;do if(A){r=f[e>>2]|0;m=(r|0)==0?1154740:r;t=h;l=A;d:while(1){k=l;while(1){s=f[k+16>>2]|0;if((s|0)==(r|0))break;if((Ioc((s|0)==0?1154740:s,m)|0)>=0)break;s=f[k+4>>2]|0;if(!s){B=t;break d}else k=s}l=f[k>>2]|0;if(!l){B=k;break}else t=k}if((B|0)!=(h|0)){t=f[B+16>>2]|0;if((r|0)!=(t|0)?(Ioc(m,(t|0)==0?1154740:t)|0)<=-1:0){C=1;break}t=DHa(B+24|0,-1)|0;C=t}else C=1}else C=1;while(0);B=a+48|0;f[B>>2]=C;uT(e);f[e>>2]=0;f[e+4>>2]=0;v=tT(e,14)|0;c=430279;o=v+14|0;do{b[v>>0]=b[c>>0]|0;v=v+1|0;c=c+1|0}while((v|0)<(o|0));C=f[h>>2]|0;do if(C){A=f[e>>2]|0;t=(A|0)==0?1154740:A;l=C;while(1){i=f[l+16>>2]|0;if((A|0)==(i|0))break;j=(i|0)==0?1154740:i;if((Ioc(t,j)|0)<0)D=l;else{if((Ioc(j,t)|0)>=0)break;D=l+4|0}l=f[D>>2]|0;if(!l){E=65;break}}if((E|0)==65){uT(e);break}f[g>>2]=0;f[g+4>>2]=0;l=tT(g,8)|0;t=l;b[t>>0]=101;b[t+1>>0]=110;b[t+2>>0]=100;b[t+3>>0]=95;t=l+4|0;b[t>>0]=97;b[t+1>>0]=120;b[t+2>>0]=105;b[t+3>>0]=115;t=f[h>>2]|0;if(!t){uT(g);uT(e);break}l=f[g>>2]|0;A=(l|0)==0?1154740:l;m=t;while(1){t=f[m+16>>2]|0;if((l|0)==(t|0)){E=61;break}r=(t|0)==0?1154740:t;if((Ioc(A,r)|0)<0)F=m;else{if((Ioc(r,A)|0)>=0){E=62;break}F=m+4|0}m=f[F>>2]|0;if(!m){E=67;break}}if((E|0)==61){uT(g);uT(e);f[e>>2]=0;G=e+4|0;f[G>>2]=0;H=tT(e,56)|0;v=H;c=430305;o=v+56|0;do{b[v>>0]=b[c>>0]|0;v=v+1|0;c=c+1|0}while((v|0)<(o|0));z5(-215,e,430362,430385,59)}else if((E|0)==62){uT(g);uT(e);f[e>>2]=0;G=e+4|0;f[G>>2]=0;H=tT(e,56)|0;v=H;c=430305;o=v+56|0;do{b[v>>0]=b[c>>0]|0;v=v+1|0;c=c+1|0}while((v|0)<(o|0));z5(-215,e,430362,430385,59)}else if((E|0)==67){uT(g);uT(e);break}}else uT(e);while(0);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,8)|0;E=g;b[E>>0]=101;b[E+1>>0]=110;b[E+2>>0]=100;b[E+3>>0]=95;E=g+4|0;b[E>>0]=97;b[E+1>>0]=120;b[E+2>>0]=105;b[E+3>>0]=115;if(!(b[z>>0]|0))I=f[B>>2]|0;else I=-1;B=f[h>>2]|0;do if(B){z=f[e>>2]|0;E=(z|0)==0?1154740:z;g=h;H=B;e:while(1){G=H;while(1){F=f[G+16>>2]|0;if((F|0)==(z|0))break;if((Ioc((F|0)==0?1154740:F,E)|0)>=0)break;F=f[G+4>>2]|0;if(!F){K=g;break e}else G=F}H=f[G>>2]|0;if(!H){K=G;break}else g=G}if((K|0)!=(h|0)){g=f[K+16>>2]|0;if((z|0)!=(g|0)?(Ioc(E,(g|0)==0?1154740:g)|0)<=-1:0){L=I;break}g=DHa(K+24|0,-1)|0;L=g}else L=I}else L=I;while(0);f[a+52>>2]=L;uT(e);if(+n[p>>2]>0.0){u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;v=tT(e,9)|0;c=430470;o=v+9|0;do{b[v>>0]=b[c>>0]|0;v=v+1|0;c=c+1|0}while((v|0)<(o|0));z5(-215,e,430362,430385,61)}}function fpb(a){a=a|0;YDc(a);return}function gpb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hpb(a){a=a|0;REa(a);YDc(a);return}function ipb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+8|0;g=d;f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;f$(c,e);c=f[e>>2]|0;i=c;if(((f[h>>2]|0)-c|0)!=56){f[g>>2]=0;f[g+4>>2]=0;c=tT(g,18)|0;h=453187;j=c+18|0;do{b[c>>0]=b[h>>0]|0;c=c+1|0;h=h+1|0}while((c|0)<(j|0));z5(-215,g,453718,430385,96)}g=a+52|0;h=f[g>>2]|0;if((h|0)==-1)k=(f[i+4>>2]|0)+-1|0;else k=h;f[g>>2]=k;g=a+48|0;h=f[g>>2]|0;if((h|0)==-1)l=(f[i+4>>2]|0)+-1|0;else l=h;f[g>>2]=l;if((l|0)!=1){m=0;n=a+44|0;b[n>>0]=m;mx(e);u=d;return}m=(k|0)==((f[i+4>>2]|0)+-1|0)&1;n=a+44|0;b[n>>0]=m;mx(e);u=d;return}function jpb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0;g=u;u=u+528|0;h=g+512|0;i=g+80|0;j=g+64|0;k=g+496|0;l=g+484|0;m=g+472|0;o=g+416|0;q=g+360|0;r=g+32|0;s=g+304|0;t=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;f[l>>2]=0;w=l+4|0;f[w>>2]=0;f[l+8>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f$(c,k);f$(d,l);f$(e,m);e=f[k>>2]|0;d=e;if(((f[v>>2]|0)-e|0)!=56){f[h>>2]=0;x=h+4|0;f[x>>2]=0;y=tT(h,41)|0;z=y;A=430480;B=z+41|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,453206,430385,201)}e=f[l>>2]|0;v=e;if(((f[w>>2]|0)-e|0)!=56){f[h>>2]=0;x=h+4|0;f[x>>2]=0;y=tT(h,41)|0;z=y;A=430480;B=z+41|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,453206,430385,201)}y=d+4|0;x=f[y>>2]|0;if((x|0)<3)C=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{e=f[d+40>>2]|0;w=0;c=1;while(1){D=Y(f[e+(w<<2)>>2]|0,c)|0;w=w+1|0;if((w|0)==(x|0)){C=D;break}else c=D}}c=f[v+4>>2]|0;if((c|0)<3)E=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{w=f[v+40>>2]|0;e=0;D=1;while(1){F=Y(f[w+(e<<2)>>2]|0,D)|0;e=e+1|0;if((e|0)==(c|0)){E=F;break}else D=F}}if((C|0)!=(E|0)){f[h>>2]=0;f[h+4>>2]=0;z=tT(h,39)|0;A=430522;B=z+39|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,453206,430385,202)}E=f[m>>2]|0;C=a+48|0;D=f[C>>2]|0;f[C>>2]=((D|0)<0?x:0)+D;D=a+52|0;c=f[D>>2]|0;f[D>>2]=((c|0)<0?x:0)+c;c=f[d+16>>2]|0;x=f[v+16>>2]|0;v=d+40|0;e=f[v>>2]|0;w=f[e+-4>>2]|0;f[i>>2]=0;F=i+4|0;f[F>>2]=0;f[i+8>>2]=0;lFa(i,e,e+(w<<2)|0);w=f[C>>2]|0;if((w|0)==-1){e=f[F>>2]|0;G=f[i>>2]|0;H=e-G>>2;I=G;J=e;K=G;L=e}else{e=f[i>>2]|0;G=f[F>>2]|0;H=w;I=e;J=G;K=e;L=G}if((K|0)!=(L|0)){G=J-I|0;if((G|0)<0|H>>>0>G>>>2>>>0){f[h>>2]=0;f[h+4>>2]=0;z=tT(h,70)|0;A=452744;B=z+70|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,452815,452821,161)}if((H|0)>0){G=1;I=0;while(1){J=Y(f[K+(I<<2)>>2]|0,G)|0;I=I+1|0;if((I|0)==(H|0)){M=J;break}else G=J}}else M=1}else M=0;if(K|0){if((L|0)!=(K|0))f[F>>2]=L+(~((L+-4-K|0)>>>2)<<2);YDc(K)}K=f[v>>2]|0;L=f[K+-4>>2]|0;f[i>>2]=0;F=i+4|0;f[F>>2]=0;f[i+8>>2]=0;lFa(i,K,K+(L<<2)|0);L=f[C>>2]|0;C=(f[D>>2]|0)+1|0;D=(L|0)==-1?0:L;if((C|0)==-1){L=f[F>>2]|0;K=f[i>>2]|0;O=L-K>>2;P=K;Q=L;R=K;S=L}else{L=f[i>>2]|0;K=f[F>>2]|0;O=C;P=L;Q=K;R=L;S=K}if((P|0)!=(Q|0)){K=S-R>>2;if((D|0)>(K|0)){f[h>>2]=0;T=h+4|0;f[T>>2]=0;U=tT(h,70)|0;z=U;A=452744;B=z+70|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,452815,452821,161)}if((D|0)>(O|0)|(O|0)>(K|0)){f[h>>2]=0;T=h+4|0;f[T>>2]=0;U=tT(h,70)|0;z=U;A=452744;B=z+70|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,452815,452821,161)}if((D|0)<(O|0)){U=1;T=D;while(1){D=Y(f[P+(T<<2)>>2]|0,U)|0;T=T+1|0;if((T|0)==(O|0)){V=D;break}else U=D}}else V=1}else V=0;if(P|0){if((Q|0)!=(P|0))f[F>>2]=Q+(~((Q+-4-P|0)>>>2)<<2);YDc(P)}P=Y(V,M)|0;if(!P){f[h>>2]=0;f[h+4>>2]=0;z=tT(h,20)|0;A=430562;B=z+20|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,453206,430385,214)}Q=f[y>>2]|0;if((Q|0)<3)W=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{d=f[v>>2]|0;v=0;y=1;while(1){F=Y(f[d+(v<<2)>>2]|0,y)|0;v=v+1|0;if((v|0)==(Q|0)){W=F;break}else y=F}}y=(W>>>0)/(P>>>0)|0;a:do if(M|0){P=h+8|0;W=h+12|0;Q=h+4|0;v=a+36|0;d=j+8|0;F=j+4|0;U=(y|0)==1;O=h+8|0;T=h+12|0;D=h+4|0;K=a+40|0;R=h+8|0;S=h+12|0;L=h+4|0;C=i+8|0;G=i+12|0;H=i+4|0;I=s+8|0;J=s+4|0;e=a+4|0;w=a+8|0;X=Y(y,V)|0;Z=q+36|0;_=q+16|0;$=q+4|0;aa=q+40|0;ba=q+44|0;ca=q+48|0;da=o+36|0;ea=o+16|0;fa=o+4|0;ga=o+40|0;ha=o+44|0;ia=o+48|0;ja=i+4|0;ka=i+8|0;la=i+12|0;ma=i+16|0;na=i+20|0;oa=i+24|0;pa=i+28|0;qa=i+32|0;ra=i+36|0;sa=i+40|0;ta=i+48|0;ua=i+44|0;va=i+52|0;wa=h+8|0;xa=h+4|0;ya=h+8|0;za=h+12|0;Aa=h+4|0;Ba=q+12|0;Ca=j+8|0;Da=j+4|0;Ea=h+8|0;Fa=h+12|0;Ga=h+4|0;Ha=j+8|0;Ia=j+12|0;Ja=j+4|0;Ka=s+8|0;La=s+4|0;Ma=s+4|0;Na=s+8|0;Oa=s+40|0;Pa=s+48|0;Qa=s+44|0;Ra=s+52|0;Sa=h+8|0;Ta=h+12|0;Ua=h+4|0;Va=i+8|0;Wa=i+4|0;Xa=t+8|0;Ya=h+8|0;Za=h+12|0;_a=h+4|0;$a=i+8|0;ab=i+12|0;bb=i+4|0;cb=j+8|0;db=j+4|0;eb=h+8|0;fb=h+12|0;gb=h+4|0;hb=i+8|0;ib=i+4|0;jb=h+8|0;kb=h+12|0;lb=h+4|0;mb=i+8|0;nb=i+4|0;ob=h+8|0;pb=h+12|0;qb=h+4|0;rb=i+8|0;sb=i+12|0;tb=i+4|0;ub=j+8|0;vb=j+4|0;wb=s+36|0;xb=s+16|0;yb=0;zb=c;Ab=x;while(1){Vj(o,V,y,5,zb,0);Vj(q,V,y,5,Ab,0);uY(i,o);f[P>>2]=0;f[W>>2]=0;f[h>>2]=-1056571392;f[Q>>2]=i;Bb=+n[v>>2];Cb=d;f[Cb>>2]=0;f[Cb+4>>2]=0;f[j>>2]=33619968;f[F>>2]=E;d3(h,Bb,j);$j(i);if(!U){f[s>>2]=1124007936;z=Ma;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[Oa>>2]=Na;f[Qa>>2]=Pa;f[Pa>>2]=0;f[Ra>>2]=0;f[Sa>>2]=0;f[Ta>>2]=0;f[h>>2]=16842752;f[Ua>>2]=E;Cb=Va;f[Cb>>2]=0;f[Cb+4>>2]=0;f[i>>2]=33619968;f[Wa>>2]=s;FR(h,i,0,0,-1);p[t>>3]=+n[K>>2];f[Xa>>2]=0;f[Xa+4>>2]=0;f[Xa+8>>2]=0;f[Xa+12>>2]=0;f[Xa+16>>2]=0;f[Xa+20>>2]=0;f[Ya>>2]=0;f[Za>>2]=0;f[h>>2]=16842752;f[_a>>2]=s;f[i>>2]=-1056833530;f[bb>>2]=t;f[$a>>2]=1;f[ab>>2]=4;Cb=cb;f[Cb>>2]=0;f[Cb+4>>2]=0;f[j>>2]=33619968;f[db>>2]=s;mL(h,i,j,e0()|0,-1);f[eb>>2]=0;f[fb>>2]=0;f[h>>2]=16842752;f[gb>>2]=s;Bb=+n[v>>2];Cb=hb;f[Cb>>2]=0;f[Cb+4>>2]=0;f[i>>2]=33619968;f[ib>>2]=s;d3(h,-1.0/Bb,i);f[jb>>2]=0;f[kb>>2]=0;f[h>>2]=16842752;f[lb>>2]=s;Cb=mb;f[Cb>>2]=0;f[Cb+4>>2]=0;f[i>>2]=33619968;f[nb>>2]=E;o_(h,V,1,i);f[ob>>2]=0;f[pb>>2]=0;f[h>>2]=16842752;f[qb>>2]=o;f[rb>>2]=0;f[sb>>2]=0;f[i>>2]=16842752;f[tb>>2]=E;Cb=ub;f[Cb>>2]=0;f[Cb+4>>2]=0;f[j>>2]=33619968;f[vb>>2]=q;qL(h,i,j,1.0,-1);Cb=f[wb>>2]|0;do if(Cb|0){Db=Cb+12|0;Eb=f[Db>>2]|0;f[Db>>2]=Eb+-1;if((Eb|0)!=1)break;_S(s)}while(0);f[wb>>2]=0;f[xb>>2]=0;f[xb+4>>2]=0;f[xb+8>>2]=0;f[xb+12>>2]=0;if((f[Ma>>2]|0)>0){Cb=f[Oa>>2]|0;Eb=0;do{f[Cb+(Eb<<2)>>2]=0;Eb=Eb+1|0}while((Eb|0)<(f[Ma>>2]|0))}Eb=f[Qa>>2]|0;if((Eb|0)!=(Pa|0))g0(Eb)}else{f[O>>2]=0;f[T>>2]=0;f[h>>2]=16842752;f[D>>2]=E;L6(r,h);Bb=+N(+(+p[r>>3]+ +n[K>>2]),+(1.0/+n[v>>2]));f[R>>2]=0;f[S>>2]=0;f[h>>2]=16842752;f[L>>2]=o;p[j>>3]=1.0/Bb;f[i>>2]=-1056833530;f[H>>2]=j;f[C>>2]=1;f[G>>2]=1;Eb=I;f[Eb>>2]=0;f[Eb+4>>2]=0;f[s>>2]=33619968;f[J>>2]=q;qL(h,i,s,1.0,-1)}Eb=f[e>>2]|0;if((Eb|0)!=(f[w>>2]|0)){f[i>>2]=f[Eb>>2];Cb=Eb+4|0;f[ja>>2]=f[Cb>>2];f[ka>>2]=f[Eb+8>>2];f[la>>2]=f[Eb+12>>2];f[ma>>2]=f[Eb+16>>2];f[na>>2]=f[Eb+20>>2];f[oa>>2]=f[Eb+24>>2];f[pa>>2]=f[Eb+28>>2];f[qa>>2]=f[Eb+32>>2];Db=f[Eb+36>>2]|0;f[ra>>2]=Db;f[sa>>2]=ka;f[ua>>2]=ta;f[ta>>2]=0;f[va>>2]=0;if(Db|0){Fb=Db+12|0;f[Fb>>2]=(f[Fb>>2]|0)+1}if((f[Cb>>2]|0)<3){Cb=f[Eb+44>>2]|0;Fb=f[ua>>2]|0;f[Fb>>2]=f[Cb>>2];f[Fb+4>>2]=f[Cb+4>>2]}else{f[ja>>2]=0;ZS(i,Eb)}Eb=f[ja>>2]|0;Cb=(Eb|0)<3;if(Cb)Gb=Y(f[la>>2]|0,f[ka>>2]|0)|0;else{Fb=f[sa>>2]|0;Db=0;Hb=1;while(1){Ib=Y(f[Fb+(Db<<2)>>2]|0,Hb)|0;Db=Db+1|0;if((Db|0)==(Eb|0)){Gb=Ib;break}else Hb=Ib}}if((Gb|0)==1){Bb=+n[f[ma>>2]>>2];Hb=wa;f[Hb>>2]=0;f[Hb+4>>2]=0;f[h>>2]=33619968;f[xa>>2]=q;LZ(q,h,-1,Bb,0.0)}else{if(Cb)Jb=Y(f[la>>2]|0,f[ka>>2]|0)|0;else{Hb=f[sa>>2]|0;Db=0;Fb=1;while(1){Ib=Y(f[Hb+(Db<<2)>>2]|0,Fb)|0;Db=Db+1|0;if((Db|0)==(Eb|0)){Jb=Ib;break}else Fb=Ib}}if((Jb|0)!=(V|0))break;f[ya>>2]=0;f[za>>2]=0;f[h>>2]=16842752;f[Aa>>2]=i;Fb=f[Ba>>2]|0;Eb=Ca;f[Eb>>2]=0;f[Eb+4>>2]=0;f[j>>2]=33619968;f[Da>>2]=E;o_(h,1,Fb,j);f[Ea>>2]=0;f[Fa>>2]=0;f[h>>2]=16842752;f[Ga>>2]=q;f[Ha>>2]=0;f[Ia>>2]=0;f[j>>2]=16842752;f[Ja>>2]=E;Fb=Ka;f[Fb>>2]=0;f[Fb+4>>2]=0;f[s>>2]=33619968;f[La>>2]=q;qL(h,j,s,1.0,-1)}Fb=f[ra>>2]|0;do if(Fb|0){Eb=Fb+12|0;Db=f[Eb>>2]|0;f[Eb>>2]=Db+-1;if((Db|0)!=1)break;_S(i)}while(0);f[ra>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ja>>2]|0)>0){Fb=f[sa>>2]|0;Db=0;do{f[Fb+(Db<<2)>>2]=0;Db=Db+1|0}while((Db|0)<(f[ja>>2]|0))}Db=f[ua>>2]|0;if((Db|0)!=(ta|0))g0(Db)}zb=zb+(X<<2)|0;Ab=Ab+(X<<2)|0;Db=f[Z>>2]|0;do if(Db|0){Fb=Db+12|0;Eb=f[Fb>>2]|0;f[Fb>>2]=Eb+-1;if((Eb|0)!=1)break;_S(q)}while(0);f[Z>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[$>>2]|0)>0){Db=f[aa>>2]|0;Eb=0;do{f[Db+(Eb<<2)>>2]=0;Eb=Eb+1|0}while((Eb|0)<(f[$>>2]|0))}Eb=f[ba>>2]|0;if((Eb|0)!=(ca|0))g0(Eb);Eb=f[da>>2]|0;do if(Eb|0){Db=Eb+12|0;Fb=f[Db>>2]|0;f[Db>>2]=Fb+-1;if((Fb|0)!=1)break;_S(o)}while(0);f[da>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[fa>>2]|0)>0){Eb=f[ga>>2]|0;Fb=0;do{f[Eb+(Fb<<2)>>2]=0;Fb=Fb+1|0}while((Fb|0)<(f[fa>>2]|0))}Fb=f[ha>>2]|0;if((Fb|0)!=(ia|0))g0(Fb);yb=yb+1|0;if(yb>>>0>=M>>>0)break a}f[h>>2]=0;f[h+4>>2]=0;z=tT(h,26)|0;A=430583;B=z+26|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,453206,430385,254)}while(0);mx(m);mx(l);mx(k);u=g;return}function kpb(a,c){a=a|0;c=c|0;var d=0;if((c|0)!=2){d=(c|0)==3;return d|0}if(+n[a+36>>2]!=2.0){d=0;return d|0}if((f[a+4>>2]|0)!=(f[a+8>>2]|0)){d=1;return d|0}if((f[a+32>>2]|0)==3){d=(b[a+44>>0]|0)==0;return d|0}if((f[a+48>>2]|0)!=1){d=0;return d|0}if(!(b[a+44>>0]|0)){d=1;return d|0}d=(f[a+52>>2]|0)>1;return d|0}function lpb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function mpb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+16|0;i=h;if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=12){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,18)|0;k=453187;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,i,452925,430385,85)}gFa(a,c,d,e,g)|0;e=g+4|0;d=f[e>>2]|0;a=f[g>>2]|0;i=d-a|0;k=(i|0)/12|0;j=d;if(!i){npb(g,1-k|0,f[c>>2]|0);m=f[g>>2]|0;n=f[m>>2]|0;f[n>>2]=1;u=h;return 1}if(k>>>0<=1){m=f[g>>2]|0;n=f[m>>2]|0;f[n>>2]=1;u=h;return 1}k=a+12|0;if((j|0)==(k|0)){m=f[g>>2]|0;n=f[m>>2]|0;f[n>>2]=1;u=h;return 1}else o=j;while(1){j=o+-12|0;f[e>>2]=j;a=f[j>>2]|0;if(!a)p=j;else{j=o+-8|0;c=f[j>>2]|0;if((c|0)!=(a|0))f[j>>2]=c+(~((c+-4-a|0)>>>2)<<2);YDc(a);p=f[e>>2]|0}if((p|0)==(k|0))break;else o=p}m=f[g>>2]|0;n=f[m>>2]|0;f[n>>2]=1;u=h;return 1}function npb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=b;j=h;do{jFa(j,c);j=(f[g>>2]|0)+12|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/12|0;h=j+b|0;if(h>>>0>357913941)mCc(a);k=(e-i|0)/12|0;i=k<<1;e=k>>>0<178956970?(i>>>0<h>>>0?h:i):357913941;do if(e)if(e>>>0>357913941){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{l=VDc(e*12|0)|0;break}else l=0;while(0);i=l+(j*12|0)|0;j=i;h=l+(e*12|0)|0;e=b;b=j;l=i;do{jFa(l,c);l=b+12|0;b=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(e|0)){m=j;n=e;o=e}else{c=l;l=j;j=i;do{c=c+-12|0;jFa(j+-12|0,c);j=l+-12|0;l=j}while((c|0)!=(e|0));m=l;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=b;f[d>>2]=h;h=n;if((o|0)!=(h|0)){d=o;do{o=d;d=d+-12|0;b=f[d>>2]|0;if(b|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(b|0))f[g>>2]=o+(~((o+-4-b|0)>>>2)<<2);YDc(b)}}while((d|0)!=(h|0))}if(!n)return;YDc(n);return}function opb(a,b){a=a|0;b=b|0;var c=0;c=VDc(108)|0;ppb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=98932;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function ppb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+32|0;e=d;g=d+16|0;h=d+8|0;JHa(a);f[a>>2]=98952;i=a+36|0;j=a+40|0;k=a+44|0;l=a+100|0;m=a+104|0;f[m>>2]=0;n=i;o=n+64|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));b[i+64>>0]=0;f[g>>2]=0;f[g+4>>2]=0;i=tT(g,5)|0;b[i>>0]=b[454713]|0;b[i+1>>0]=b[454714]|0;b[i+2>>0]=b[454715]|0;b[i+3>>0]=b[454716]|0;b[i+4>>0]=b[454717]|0;i=f[c+4>>2]|0;if(!i){uT(g);u=d;return}p=f[g>>2]|0;q=(p|0)==0?1154740:p;r=i;while(1){i=f[r+16>>2]|0;if((p|0)==(i|0)){s=9;break}t=(i|0)==0?1154740:i;if((Ioc(q,t)|0)<0)v=r;else{if((Ioc(t,q)|0)>=0){s=10;break}v=r+4|0}r=f[v>>2]|0;if(!r){s=36;break}}if((s|0)==9)uT(g);else if((s|0)==10)uT(g);else if((s|0)==36){uT(g);u=d;return}f[g>>2]=0;f[g+4>>2]=0;r=tT(g,5)|0;b[r>>0]=b[454713]|0;b[r+1>>0]=b[454714]|0;b[r+2>>0]=b[454715]|0;b[r+3>>0]=b[454716]|0;b[r+4>>0]=b[454717]|0;TFa(h,lIa(c,g)|0);uT(g);switch(f[h>>2]|0){case 0:{w=(f[h+4>>2]|0)+4|0;break}case 3:{w=(f[h+4>>2]|0)+4|0;break}case 2:{w=(f[h+4>>2]|0)+4|0;break}default:{f[g>>2]=0;f[g+4>>2]=0;z5(-3,g,467763,451988,278)}}r=f[w>>2]|0;f[m>>2]=r;a:do if(r|0){w=a+48|0;v=0;while(1){q=DHa(h,v)|0;x=f[m>>2]|0;if((q|0)<0|q>>>0>x>>>0){s=20;break}p=f[j>>2]|0;t=f[k>>2]|0;b:do if((p|0)==(t|0)){y=p;s=24}else{i=p;do{if((f[i>>2]|0)==(q|0)){y=i;s=24;break b}i=i+4|0}while((i|0)!=(t|0))}while(0);if((s|0)==24?(s=0,(y|0)!=(t|0)):0){s=25;break}f[g>>2]=q;if((t|0)==(f[w>>2]|0))paa(j,g);else{f[t>>2]=q;f[k>>2]=t+4}v=v+1|0;if(v>>>0>=(f[m>>2]|0)>>>0)break a}if((s|0)==20){f[e>>2]=x+-1;F5(g,430779,e);z5(-5,g,430846,430863,91)}else if((s|0)==25){f[g>>2]=0;f[g+4>>2]=0;n=tT(g,51)|0;v=430941;o=n+51|0;do{b[n>>0]=b[v>>0]|0;n=n+1|0;v=v+1|0}while((n|0)<(o|0));z5(-5,g,430846,430863,96)}}while(0);KHa(a,c);b[l>>0]=0;c=f[m>>2]|0;c:do if(c|0){m=f[a+40>>2]|0;g=0;while(1){if((f[m+(g<<2)>>2]|0)!=(g|0))break;g=g+1|0;if(g>>>0>=c>>>0)break c}b[l>>0]=1}while(0);JFa(h);u=d;return}function qpb(a){a=a|0;YDc(a);return}function rpb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function spb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=98952;b=f[a+88>>2]|0;if(b|0){c=a+92|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+76>>2]|0;if(b|0){d=a+80|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+64>>2]|0;if(b|0){c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+52>>2]|0;if(b|0){d=a+56|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+40>>2]|0;if(!b){REa(a);return}c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);REa(a);return}function tpb(a){a=a|0;spb(a);YDc(a);return}function upb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(!(b[a+100>>0]|0)){u=e;return}f[g>>2]=0;k=g+4|0;f[k>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=f[g>>2]|0;c=d;if((f[k>>2]|0)==(d|0)){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,17)|0;m=449134;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,453718,430863,169)}d=f[a+104>>2]|0;if((d|0)!=(f[c+4>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,26)|0;m=431481;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,453718,430863,171)}m=f[c+40>>2]|0;f[i>>2]=0;c=i+4|0;f[c>>2]=0;f[i+8>>2]=0;lFa(i,m,m+(d<<2)|0);d=f[h>>2]|0;m=f[d+4>>2]|0;l=f[d+40>>2]|0;f[j>>2]=0;d=j+4|0;f[d>>2]=0;f[j+8>>2]=0;lFa(j,l,l+(m<<2)|0);Cpb(a,i,j);a=f[j>>2]|0;if(a|0){j=f[d>>2]|0;if((j|0)!=(a|0))f[d>>2]=j+(~((j+-4-a|0)>>>2)<<2);YDc(a)}a=f[i>>2]|0;if(a|0){i=f[c>>2]|0;if((i|0)!=(a|0))f[c>>2]=i+(~((i+-4-a|0)>>>2)<<2);YDc(a)}mx(h);mx(g);u=e;return}function vpb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+48|0;h=g+28|0;i=g+16|0;j=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;c=(f[e>>2]|0)-d|0;e=(c|0)/56|0;k=d;a:do if(!(b[a+100>>0]|0)){if(c|0){d=j+8|0;l=j+4|0;m=0;while(1){n=f[i>>2]|0;o=f[n+(m*56|0)+4>>2]|0;if((o|0)<3)p=Y(f[n+(m*56|0)+12>>2]|0,f[n+(m*56|0)+8>>2]|0)|0;else{q=f[n+(m*56|0)+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}s=f[h>>2]|0;o=f[s+(m*56|0)+4>>2]|0;if((o|0)<3)v=Y(f[s+(m*56|0)+12>>2]|0,f[s+(m*56|0)+8>>2]|0)|0;else{r=f[s+(m*56|0)+40>>2]|0;q=0;t=1;while(1){w=Y(f[r+(q<<2)>>2]|0,t)|0;q=q+1|0;if((q|0)==(o|0)){v=w;break}else t=w}}if((p|0)!=(v|0))break;if((f[n+(m*56|0)+16>>2]|0)!=(f[s+(m*56|0)+16>>2]|0)){t=d;f[t>>2]=0;f[t+4>>2]=0;f[j>>2]=33619968;f[l>>2]=n+(m*56|0);h_(s+(m*56|0)|0,j)}m=m+1|0;if(m>>>0>=e>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;x=tT(j,39)|0;y=431065;z=x+39|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,j,453206,430863,323)}}else{m=f[a+36>>2]|0;l=f[a+104>>2]|0;d=f[a+88>>2]|0;t=f[a+76>>2]|0;o=a+40|0;q=f[o>>2]|0;if(c|0){r=(l|0)==4;w=(m|0)==0;A=(l|0)==0;B=f[i>>2]|0;b:do if((f[k+4>>2]|0)==(l|0)){C=0;D=B;E=k;F=B;G=k;c:while(1){H=f[G+(C*56|0)+40>>2]|0;I=f[H+-4>>2]|0;J=f[G+40>>2]|0;if((I|0)!=(f[J+-4>>2]|0))break b;if((I|0)==2){if((f[H>>2]|0)!=(f[J>>2]|0))break b;if((f[H+4>>2]|0)!=(f[J+4>>2]|0))break b}else if((I|0)>0){K=0;do{if((f[H+(K<<2)>>2]|0)!=(f[J+(K<<2)>>2]|0))break b;K=K+1|0}while((K|0)<(I|0))}if((f[D+(C*56|0)+4>>2]|0)!=(l|0)){L=37;break}I=f[D+(C*56|0)+40>>2]|0;K=f[I+-4>>2]|0;J=f[D+40>>2]|0;if((K|0)!=(f[J+-4>>2]|0)){L=37;break}if((K|0)==2){if((f[I>>2]|0)!=(f[J>>2]|0)){L=37;break}if((f[I+4>>2]|0)!=(f[J+4>>2]|0)){L=37;break}}else if((K|0)>0){H=0;do{if((f[I+(H<<2)>>2]|0)!=(f[J+(H<<2)>>2]|0)){L=37;break c}H=H+1|0}while((H|0)<(K|0))}K=f[E>>2]|0;if(!(K&16384)){L=40;break}H=f[F>>2]|0;if(!(H&16384)){L=40;break}if(!((K&4095|0)==5&(H&4095|0)==5)){L=42;break}d:do if(!r){H=f[G+(C*56|0)+16>>2]|0;K=f[D+(C*56|0)+16>>2]|0;if(!w){if(A){J=0;while(1){f[K+(J<<2)>>2]=f[H>>2];J=J+1|0;if((J|0)==(m|0))break d}}else M=0;do{J=0;I=0;N=M;while(1){O=f[d+(I<<2)>>2]|0;J=(Y(f[t+(f[q+(I<<2)>>2]<<2)>>2]|0,(N>>>0)/(O>>>0)|0)|0)+J|0;I=I+1|0;if((I|0)==(l|0))break;else N=(N>>>0)%(O>>>0)|0}f[K+(M<<2)>>2]=f[H+(J<<2)>>2];M=M+1|0}while((M|0)!=(m|0))}}else zpb(E,F,o,z8()|0);while(0);H=C+1|0;if(H>>>0>=e>>>0)break a;K=f[h>>2]|0;N=f[i>>2]|0;if((f[K+(H*56|0)+4>>2]|0)==(l|0)){C=H;D=N;E=K+(H*56|0)|0;F=N+(H*56|0)|0;G=K}else break b}if((L|0)==37){f[j>>2]=0;f[j+4>>2]=0;x=tT(j,50)|0;y=431155;z=x+50|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,j,453206,430863,341)}else if((L|0)==40){f[j>>2]=0;f[j+4>>2]=0;x=tT(j,40)|0;y=431206;z=x+40|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,j,453206,430863,343)}else if((L|0)==42){f[j>>2]=0;f[j+4>>2]=0;x=tT(j,44)|0;y=431247;z=x+44|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,j,453206,430863,344)}}while(0);f[j>>2]=0;f[j+4>>2]=0;x=tT(j,49)|0;y=431105;z=x+49|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,j,453206,430863,340)}}while(0);mx(i);mx(h);u=g;return}function wpb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=vmb()|0;break}default:c=0}return c|0}function xpb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ypb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+32|0;i=h+24|0;j=h+12|0;k=h;if(!(b[a+100>>0]|0)){gFa(a,c,d,e,g)|0;l=1;u=h;return l|0}g=c+4|0;d=f[c>>2]|0;m=d;if((f[g>>2]|0)==(d|0)){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,17)|0;o=449134;p=n+17|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,i,452925,430863,122)}q=a+104|0;if((f[q>>2]|0)!=((f[m+4>>2]|0)-(f[d>>2]|0)>>2|0)){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,33)|0;o=430993;p=n+33|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,i,452925,430863,123)}jFa(j,m);f[k>>2]=0;m=k+4|0;f[m>>2]=0;f[k+8>>2]=0;a:do if(f[q>>2]|0){d=a+40|0;r=k+8|0;s=0;t=0;v=0;while(1){w=(f[j>>2]|0)+(f[(f[d>>2]|0)+(s<<2)>>2]<<2)|0;if((t|0)==(v|0))g6(k,w);else{f[t>>2]=f[w>>2];f[m>>2]=t+4}w=s+1|0;if(w>>>0>=(f[q>>2]|0)>>>0)break a;s=w;t=f[m>>2]|0;v=f[r>>2]|0}}while(0);q=f[e>>2]|0;a=e+4|0;r=f[a>>2]|0;if((r|0)!=(q|0)){v=r;while(1){r=v+-12|0;f[a>>2]=r;t=f[r>>2]|0;if(!t)x=r;else{r=v+-8|0;s=f[r>>2]|0;if((s|0)!=(t|0))f[r>>2]=s+(~((s+-4-t|0)>>>2)<<2);YDc(t);x=f[a>>2]|0}if((x|0)==(q|0))break;else v=x}}x=f[c>>2]|0;b:do if((f[g>>2]|0)!=(x|0)){v=e+8|0;q=0;t=x;while(1){s=t;r=f[s+(q*12|0)+4>>2]|0;d=f[s+(q*12|0)>>2]|0;s=r-d|0;w=s>>2;y=d;if((y|0)!=(r|0)){if((s|0)<=-4){z=29;break}if((s|0)>0){s=0;r=1;while(1){d=Y(f[y+(s<<2)>>2]|0,r)|0;s=s+1|0;if((s|0)>=(w|0)){A=d;break}else r=d}}else A=1}else A=0;r=f[m>>2]|0;w=f[k>>2]|0;s=r-w|0;y=s>>2;d=w;if((d|0)!=(r|0)){if((s|0)<=-4){z=34;break}if((s|0)>0){s=0;r=1;while(1){w=Y(f[d+(s<<2)>>2]|0,r)|0;s=s+1|0;if((s|0)>=(y|0)){B=w;break}else r=w}}else B=1}else B=0;if((A|0)!=(B|0)){z=37;break}C=f[a>>2]|0;if((C|0)==(f[v>>2]|0))OGa(e,k);else{f[C>>2]=0;r=C+4|0;f[r>>2]=0;f[C+8>>2]=0;y=(f[m>>2]|0)-(f[k>>2]|0)|0;s=y>>2;if(s|0){if(s>>>0>1073741823){z=41;break}d=VDc(y)|0;f[r>>2]=d;f[C>>2]=d;f[C+8>>2]=d+(s<<2);s=f[k>>2]|0;y=(f[m>>2]|0)-s|0;if((y|0)>0){dJc(d|0,s|0,y|0)|0;f[r>>2]=d+(y>>>2<<2)}}f[a>>2]=(f[a>>2]|0)+12}q=q+1|0;t=f[c>>2]|0;if(q>>>0>=(((f[g>>2]|0)-t|0)/12|0)>>>0)break b}if((z|0)==29){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,70)|0;o=452744;p=n+70|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,i,452815,452821,161)}else if((z|0)==34){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,70)|0;o=452744;p=n+70|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,i,452815,452821,161)}else if((z|0)==37){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,37)|0;o=431027;p=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,i,452925,430863,135)}else if((z|0)==41)mCc(C)}while(0);C=f[k>>2]|0;if(C|0){k=f[m>>2]|0;if((k|0)!=(C|0))f[m>>2]=k+(~((k+-4-C|0)>>>2)<<2);YDc(C)}C=f[j>>2]|0;if(C|0){k=j+4|0;j=f[k>>2]|0;if((j|0)!=(C|0))f[k>>2]=j+(~((j+-4-C|0)>>>2)<<2);YDc(C)}l=0;u=h;return l|0}function zpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+8|0;h=e;f[g>>2]=99060;f[g+4>>2]=a;f[g+8>>2]=b;f[g+12>>2]=c;f[g+16>>2]=d;i=f[b+40>>2]|0;b=f[c>>2]|0;c=f[a+40>>2]|0;if((((f[i>>2]|0)==(f[c+(f[b>>2]<<2)>>2]|0)?(f[i+4>>2]|0)==(f[c+(f[b+4>>2]<<2)>>2]|0):0)?(f[i+8>>2]|0)==(f[c+(f[b+8>>2]<<2)>>2]|0):0)?(f[i+12>>2]|0)==(f[c+(f[b+12>>2]<<2)>>2]|0):0){f[h>>2]=0;f[h+4>>2]=d;y8(h,g,+(d|0));u=e;return}f[h>>2]=0;f[h+4>>2]=0;dJc(tT(h,144)|0,431292,144)|0;z5(-215,h,453307,430863,213)}function Apb(a){a=a|0;YDc(a);return}function Bpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a+8>>2]|0;d=f[c+40>>2]|0;e=f[d>>2]|0;g=f[d+4>>2]|0;h=f[d+8>>2]|0;i=f[d+12>>2]|0;d=Y(Y(g,e)|0,h)|0;j=f[a+16>>2]|0;k=((d+-1+j|0)>>>0)/(j>>>0)|0;j=Y(f[b>>2]|0,k)|0;l=Y(f[b+4>>2]|0,k)|0;k=d>>>0<l>>>0?d:l;l=f[c+44>>2]|0;d=(f[l>>2]|0)>>>2;b=(f[l+4>>2]|0)>>>2;m=(f[l+8>>2]|0)>>>2;l=f[a+12>>2]|0;n=f[l>>2]|0;if((f[l+4>>2]|0)==(n|0))nCc(l);l=n;n=f[a+4>>2]|0;a=f[n+44>>2]|0;o=(f[a+(f[l>>2]<<2)>>2]|0)>>>2;p=(f[a+(f[l+4>>2]<<2)>>2]|0)>>>2;q=(f[a+(f[l+8>>2]<<2)>>2]|0)>>>2;r=(f[a+(f[l+12>>2]<<2)>>2]|0)>>>2;l=(j>>>0)/(h>>>0)|0;a=f[n+16>>2]|0;n=f[c+16>>2]|0;if(!(j>>>0<k>>>0&(i|0)>0))return;c=(j>>>0)%(h>>>0)|0;s=(l>>>0)%(g>>>0)|0;t=j;j=(l>>>0)/(g>>>0)|0;while(1){l=a+((Y(j,o)|0)<<2)+((Y(s,p)|0)<<2)+((Y(c,q)|0)<<2)|0;u=n+((Y(j,d)|0)<<2)+((Y(s,b)|0)<<2)+((Y(c,m)|0)<<2)|0;v=0;do{w=l+((Y(v,r)|0)<<2)|0;f[u+(v<<2)>>2]=f[w>>2];v=v+1|0}while((v|0)!=(i|0));v=c+1|0;if((v|0)>=(h|0)){u=s+1|0;if((u|0)>=(g|0)){l=j+1|0;if((l|0)<(e|0)){x=0;y=0;z=l}else{A=11;break}}else{x=0;y=u;z=j}}else{x=v;y=s;z=j}t=t+1|0;if(t>>>0>=k>>>0){A=11;break}else{c=x;s=y;j=z}}if((A|0)==11)return}function Cpb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=a+76|0;e=a+104|0;g=f[e>>2]|0;h=a+80|0;i=f[h>>2]|0;j=f[d>>2]|0;k=i-j>>2;l=j;j=i;if(g>>>0<=k>>>0)if(g>>>0<k>>>0?(i=l+(g<<2)|0,(j|0)!=(i|0)):0){f[h>>2]=j+(~((j+-4-i|0)>>>2)<<2);m=g}else m=g;else{A6(d,g-k|0);m=f[e>>2]|0}k=a+88|0;g=a+92|0;i=f[g>>2]|0;j=f[k>>2]|0;h=i-j>>2;l=j;j=i;if(m>>>0<=h>>>0)if(m>>>0<h>>>0?(i=l+(m<<2)|0,(j|0)!=(i|0)):0){f[g>>2]=j+(~((j+-4-i|0)>>>2)<<2);n=m;o=l}else{n=m;o=l}else{A6(k,m-h|0);n=f[e>>2]|0;o=f[k>>2]|0}h=f[d>>2]|0;f[h+(n+-1<<2)>>2]=1;f[o+((f[e>>2]|0)+-1<<2)>>2]=1;o=(f[e>>2]|0)+-2|0;if((o|0)<=-1){p=f[b>>2]|0;q=f[h>>2]|0;r=f[p>>2]|0;s=Y(r,q)|0;t=a+36|0;f[t>>2]=s;return}e=f[b>>2]|0;b=f[k>>2]|0;k=f[c>>2]|0;c=o;while(1){o=c+1|0;n=Y(f[e+(o<<2)>>2]|0,f[h+(o<<2)>>2]|0)|0;f[h+(c<<2)>>2]=n;n=Y(f[k+(o<<2)>>2]|0,f[b+(o<<2)>>2]|0)|0;f[b+(c<<2)>>2]=n;if((c|0)>0)c=c+-1|0;else{p=e;break}}q=f[h>>2]|0;r=f[p>>2]|0;s=Y(r,q)|0;t=a+36|0;f[t>>2]=s;return}function Dpb(a,b){a=a|0;b=b|0;var c=0;c=VDc(56)|0;Epb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=99080;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Epb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;JHa(a);g=a+36|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[a>>2]=99100;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,4)|0;b[g>>0]=97;b[g+1>>0]=120;b[g+2>>0]=105;b[g+3>>0]=115;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1154740:i;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((Ioc((n|0)==0?1154740:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<=-1:0){p=0;break}k=DHa(o+24|0,-1)|0;p=k}else p=0}else p=0;while(0);uT(e);f[e>>2]=0;f[e+4>>2]=0;o=tT(e,8)|0;h=o;b[h>>0]=110;b[h+1>>0]=117;b[h+2>>0]=109;b[h+3>>0]=95;h=o+4|0;b[h>>0]=97;b[h+1>>0]=120;b[h+2>>0]=101;b[h+3>>0]=115;h=f[g>>2]|0;do if(h){o=f[e>>2]|0;k=(o|0)==0?1154740:o;l=g;n=h;b:while(1){q=n;while(1){r=f[q+16>>2]|0;if((r|0)==(o|0))break;if((Ioc((r|0)==0?1154740:r,k)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=l;break b}else q=r}n=f[q>>2]|0;if(!n){s=q;break}else l=q}if((s|0)!=(g|0)){l=f[s+16>>2]|0;if((o|0)!=(l|0)?(Ioc(k,(l|0)==0?1154740:l)|0)<=-1:0){t=-1;break}l=DHa(s+24|0,-1)|0;t=l}else t=-1}else t=-1;while(0);uT(e);if((t|0)<=-2){f[e>>2]=0;f[e+4>>2]=0;s=tT(e,13)|0;h=431665;l=s+13|0;do{b[s>>0]=b[h>>0]|0;s=s+1|0;h=h+1|0}while((s|0)<(l|0));z5(-215,e,431679,431696,164)}h=(t|0)==-1;s=t+p|0;t=a+48|0;l=t;f[l>>2]=p;f[l+4>>2]=h?2147483647:s;s=a+36|0;h=f[s>>2]|0;l=a+40|0;a=f[l>>2]|0;if((a|0)!=(h|0))f[l>>2]=a+(~((a+-4-h|0)>>>2)<<2);f[e>>2]=0;f[e+4>>2]=0;h=tT(e,3)|0;b[h>>0]=b[431774]|0;b[h+1>>0]=b[431775]|0;b[h+2>>0]=b[431776]|0;h=f[g>>2]|0;if(!h){uT(e);u=d;return}g=f[e>>2]|0;a=(g|0)==0?1154740:g;p=h;while(1){h=f[p+16>>2]|0;if((g|0)==(h|0)){v=35;break}t=(h|0)==0?1154740:h;if((Ioc(a,t)|0)<0)w=p;else{if((Ioc(t,a)|0)>=0){v=36;break}w=p+4|0}p=f[w>>2]|0;if(!p){v=50;break}}if((v|0)==35)uT(e);else if((v|0)==36)uT(e);else if((v|0)==50){uT(e);u=d;return}f[e>>2]=0;f[e+4>>2]=0;v=tT(e,3)|0;b[v>>0]=b[431774]|0;b[v+1>>0]=b[431775]|0;b[v+2>>0]=b[431776]|0;v=lIa(c,e)|0;uT(e);switch(f[v>>2]|0){case 0:{x=(f[v+4>>2]|0)+4|0;break}case 3:{x=(f[v+4>>2]|0)+4|0;break}case 2:{x=(f[v+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}e=f[x>>2]|0;x=f[l>>2]|0;c=f[s>>2]|0;p=x-c>>2;w=c;c=x;if(e>>>0<=p>>>0){if(e>>>0<p>>>0?(x=w+(e<<2)|0,(c|0)!=(x|0)):0)f[l>>2]=c+(~((c+-4-x|0)>>>2)<<2)}else lN(s,e-p|0);if((e|0)>0)y=0;else{u=d;return}do{p=DHa(v,y)|0;f[(f[s>>2]|0)+(y<<2)>>2]=p;y=y+1|0}while((y|0)<(e|0));u=d;return}function Fpb(a){a=a|0;YDc(a);return}function Gpb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Hpb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=99208;b=f[a+36>>2]|0;if(!b){REa(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);REa(a);return}function Ipb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=99208;b=f[a+36>>2]|0;if(!b){REa(a);YDc(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);REa(a);YDc(a);return}function Jpb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=99208;b=f[a+36>>2]|0;if(!b){REa(a);YDc(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);REa(a);YDc(a);return}function Kpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+176|0;a=d+156|0;e=d+144|0;g=d+88|0;h=d+16|0;i=d+72|0;j=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[e>>2]=0;k=e+4|0;f[k>>2]=0;f[e+8>>2]=0;f$(b,a);f$(c,e);if((f[k>>2]|0)==(f[e>>2]|0)){mx(e);mx(a);u=d;return}c=g+4|0;b=g+8|0;l=g+12|0;m=g+16|0;n=g+20|0;o=g+24|0;p=g+28|0;q=g+32|0;r=g+36|0;s=g+40|0;t=g+48|0;v=g+44|0;w=g+52|0;x=i+4|0;y=i+8|0;z=j+8|0;A=j+4|0;B=h+36|0;C=h+16|0;D=h+4|0;E=h+40|0;F=h+44|0;G=h+48|0;H=0;do{I=f[a>>2]|0;J=I+(H*56|0)|0;f[g>>2]=f[J>>2];K=I+(H*56|0)+4|0;f[c>>2]=f[K>>2];f[b>>2]=f[I+(H*56|0)+8>>2];f[l>>2]=f[I+(H*56|0)+12>>2];f[m>>2]=f[I+(H*56|0)+16>>2];f[n>>2]=f[I+(H*56|0)+20>>2];f[o>>2]=f[I+(H*56|0)+24>>2];f[p>>2]=f[I+(H*56|0)+28>>2];f[q>>2]=f[I+(H*56|0)+32>>2];L=f[I+(H*56|0)+36>>2]|0;f[r>>2]=L;f[s>>2]=b;f[v>>2]=t;f[t>>2]=0;f[w>>2]=0;if(L|0){M=L+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[K>>2]|0)<3){K=f[I+(H*56|0)+44>>2]|0;I=f[v>>2]|0;f[I>>2]=f[K>>2];f[I+4>>2]=f[K+4>>2]}else{f[c>>2]=0;ZS(g,J)}J=f[e>>2]|0;if((f[J+(H*56|0)+16>>2]|0)!=(f[m>>2]|0)){K=f[J+(H*56|0)+4>>2]|0;I=f[J+(H*56|0)+40>>2]|0;f[i>>2]=0;f[x>>2]=0;f[y>>2]=0;lFa(i,I,I+(K<<2)|0);nT(h,g,1,i);K=(f[e>>2]|0)+(H*56|0)|0;I=z;f[I>>2]=0;f[I+4>>2]=0;f[j>>2]=33619968;f[A>>2]=K;h_(h,j);K=f[B>>2]|0;if(K|0?(I=K+12|0,K=f[I>>2]|0,f[I>>2]=K+-1,(K|0)==1):0)_S(h);f[B>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[D>>2]|0)>0){K=f[E>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[D>>2]|0))}I=f[F>>2]|0;if((I|0)!=(G|0))g0(I);I=f[i>>2]|0;if(I|0){K=f[x>>2]|0;if((K|0)!=(I|0))f[x>>2]=K+(~((K+-4-I|0)>>>2)<<2);YDc(I)}}I=f[r>>2]|0;if(I|0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0)_S(g);f[r>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[c>>2]|0)>0){I=f[s>>2]|0;K=0;do{f[I+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[c>>2]|0))}K=f[v>>2]|0;if((K|0)!=(t|0))g0(K);H=H+1|0}while(H>>>0<(((f[k>>2]|0)-(f[e>>2]|0)|0)/56|0)>>>0);mx(e);mx(a);u=d;return}function Lpb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=vmb()|0;break}default:c=0}return c|0}function Mpb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Npb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;g=u;u=u+16|0;h=g;i=g+4|0;j=c+4|0;k=f[j>>2]|0;l=f[c>>2]|0;m=k-l|0;n=l;if(!((m|0)==12?1:((m|0)/12|0|0)==(d|0))){if((m|0)!=24){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,18)|0;p=453044;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452925,431696,200)}m=f[n+4>>2]|0;d=f[l>>2]|0;r=m-d|0;s=r>>2;t=d;if((t|0)!=(m|0)){if((r|0)<0){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,70)|0;p=452744;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452815,452821,161)}if(!r)v=1;else{r=1;m=0;while(1){d=Y(f[t+(m<<2)>>2]|0,r)|0;m=m+1|0;if((m|0)==(s|0)){v=d;break}else r=d}}}else v=0;r=n+12|0;s=f[n+16>>2]|0;n=f[r>>2]|0;m=s-n|0;t=m>>2;d=n;if((d|0)!=(s|0)){if((m|0)<0){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,70)|0;p=452744;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452815,452821,161)}if(!m)w=1;else{m=1;s=0;while(1){n=Y(f[d+(s<<2)>>2]|0,m)|0;s=s+1|0;if((s|0)==(t|0)){w=n;break}else m=n}}}else w=0;if((v|0)!=(w|0)){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,36)|0;p=445025;q=o+36|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452925,431696,200)}iFa(e,1,r);u=g;return 1}r=f[e>>2]|0;w=e+4|0;v=f[w>>2]|0;if((v|0)==(r|0)){x=k;y=l}else{l=v;while(1){v=l+-12|0;f[w>>2]=v;k=f[v>>2]|0;if(!k)z=v;else{v=l+-8|0;m=f[v>>2]|0;if((m|0)!=(k|0))f[v>>2]=m+(~((m+-4-k|0)>>>2)<<2);YDc(k);z=f[w>>2]|0}if((z|0)==(r|0))break;else l=z}x=f[j>>2]|0;y=f[c>>2]|0}if((x|0)==(y|0)){u=g;return 1}y=i+4|0;x=i+8|0;z=e+8|0;l=a+36|0;k=a+48|0;m=a+40|0;a=0;v=r;a:while(1){f[i>>2]=0;f[y>>2]=0;f[x>>2]=0;if((v|0)==(f[z>>2]|0)){OGa(e,i);A=f[i>>2]|0}else{f[v>>2]=0;r=v+4|0;f[r>>2]=0;f[v+8>>2]=0;t=f[i>>2]|0;s=(f[y>>2]|0)-t|0;d=s>>2;if(d){if(d>>>0>1073741823){B=14;break}n=VDc(s)|0;f[r>>2]=n;f[v>>2]=n;f[v+8>>2]=n+(d<<2);d=f[i>>2]|0;s=(f[y>>2]|0)-d|0;if((s|0)>0){dJc(n|0,d|0,s|0)|0;f[r>>2]=n+(s>>>2<<2);C=d}else C=d}else C=t;f[w>>2]=(f[w>>2]|0)+12;A=C}if(A|0){t=f[y>>2]|0;if((t|0)!=(A|0))f[y>>2]=t+(~((t+-4-A|0)>>>2)<<2);YDc(A)}t=f[c>>2]|0;d=t+(a*12|0)|0;s=k;n=f[s>>2]|0;r=f[s+4>>2]|0;s=f[w>>2]|0;D=s+-12|0;E=t+(a*12|0)+4|0;t=f[E>>2]|0;F=f[d>>2]|0;G=t-F>>2;H=f[m>>2]|0;I=f[l>>2]|0;J=H-I|0;K=J>>2;L=(r|0)==2147483647;M=I;I=H;H=t;t=F;N=(n|0)<0?G:0;O=(n|0)==-2147483648&L?0:N+n|0;n=L?G:N+r|0;r=(M|0)!=(I|0);N=(J|0)>0;if(N&r){L=0;do{P=(f[M+(L<<2)>>2]|0)>0;L=L+1|0}while((L|0)<(K|0)&P);Q=P}else Q=r;if(Q){if((M|0)!=(I|0)){if((J|0)<0){B=29;break}if(!J)R=1;else{L=1;P=0;while(1){S=Y(f[M+(P<<2)>>2]|0,L)|0;P=P+1|0;if((P|0)==(K|0)){R=S;break}else L=S}}}else R=0;L=n+-1|0;b:do if((n|0)>(O|0)){P=(t|0)==(H|0);if((n|0)==-1){if(P){M=(R|0)==0;J=0;I=-1;r=L;while(1){if(J){if(!M){T=I;B=61;break b}if(!r){T=0;B=61;break b}else U=1}else U=M;if((r|0)>(O|0)){S=r;J=U;r=r+-1|0;I=S}else{V=O;break b}}}else{W=0;X=-1;Z=L}while(1){I=(X|0)==0?0:Z;if((I|0)>(G|0)){B=55;break a}if((I|0)<(G|0)){r=1;J=I;while(1){I=Y(f[t+(J<<2)>>2]|0,r)|0;J=J+1|0;if((J|0)==(G|0)){_=I;break}else r=I}}else _=1;r=(_|0)==(R|0);if(W){if(!r){T=X;B=61;break b}if(!Z){T=0;B=61;break b}else $=1}else $=r;if((Z|0)>(O|0)){r=Z;W=$;Z=Z+-1|0;X=r}else{V=O;break b}}}if(P){r=(R|0)==0;J=0;I=n;M=L;while(1){if(J){if(!r){T=I;B=61;break b}if(!M){T=0;B=61;break b}else aa=1}else aa=r;if((M|0)>(O|0)){S=M;J=aa;M=M+-1|0;I=S}else{V=O;break b}}}if((n|0)>(G|0)){B=55;break a}else{ba=0;ca=n;da=L}while(1){I=(ca|0)==0?0:da;if((I|0)>(G|0)|(I|0)>(n|0)){B=55;break a}if((I|0)<(n|0)){M=1;J=I;while(1){I=Y(f[t+(J<<2)>>2]|0,M)|0;J=J+1|0;if((J|0)==(n|0)){ea=I;break}else M=I}}else ea=1;M=(ea|0)==(R|0);if(ba){if(!M){T=ca;B=61;break b}if(!da){T=0;B=61;break b}else fa=1}else fa=M;if((da|0)>(O|0)){M=da;ba=fa;da=da+-1|0;ca=M}else{V=O;break}}}else V=O;while(0);while(1){if((B|0)==61){B=0;V=T}ga=(V|0)==-1?0:V;ha=(n|0)==-1?G:n;ia=(t|0)==(H|0);if(!ia){if((ga|0)>(G|0)){B=66;break a}if((ha|0)>(G|0)|(ga|0)>(ha|0)){B=66;break a}if((ga|0)<(ha|0)){L=1;M=ga;while(1){J=Y(f[t+(M<<2)>>2]|0,L)|0;M=M+1|0;if((M|0)==(ha|0)){ja=J;break}else L=J}}else ja=1}else ja=0;if(!((V|0)>0&(ja|0)!=(R|0)))break;T=V+-1|0;B=61}if(!ia){if((ga|0)>(G|0)){B=74;break}if((ha|0)>(G|0)|(ga|0)>(ha|0)){B=74;break}if((ga|0)<(ha|0)){H=1;L=ga;while(1){M=Y(f[t+(L<<2)>>2]|0,H)|0;L=L+1|0;if((L|0)==(ha|0)){ka=M;break}else H=M}}else ka=1}else ka=0;if((ka|0)==(R|0))la=V;else{B=77;break}}else la=O;if((la|0)<=-1){B=80;break}if((n|0)>(G|0)|(la|0)>(n|0)){B=80;break}H=K+G-n+la|0;L=s+-8|0;M=f[L>>2]|0;J=f[D>>2]|0;I=M-J>>2;r=J;J=M;if(H>>>0<=I>>>0)if(H>>>0<I>>>0?(M=r+(H<<2)|0,(J|0)!=(M|0)):0){f[L>>2]=J+(~((J+-4-M|0)>>>2)<<2);ma=t;na=F}else{ma=t;na=F}else{lN(D,H-I|0);I=f[d>>2]|0;ma=I;na=I}I=ma+(la<<2)|0;if(la|0){H=f[D>>2]|0;M=ma;while(1){f[H>>2]=f[M>>2];M=M+4|0;if((M|0)==(I|0))break;else H=H+4|0}}H=ma+(G<<2)|0;if((n|0)!=(G|0)){I=(f[D>>2]|0)+(la<<2)+(K<<2)|0;M=ma+(n<<2)|0;while(1){f[I>>2]=f[M>>2];M=M+4|0;if((M|0)==(H|0))break;else I=I+4|0}}if(N){I=f[l>>2]|0;H=f[D>>2]|0;M=f[d>>2]|0;n=M;F=0;t=-1;while(1){s=f[I+(F<<2)>>2]|0;c:do if((s|0)>0){oa=t;pa=s;qa=F+la|0}else switch(s|0){case 0:{ra=F+la|0;if((ra|0)>=(G|0)){B=109;break a}oa=t;pa=f[M+(ra<<2)>>2]|0;qa=ra;break c;break}case -1:{if((t|0)!=-1){B=112;break a}O=F+la|0;oa=O;pa=1;qa=O;break c;break}default:{B=114;break a}}while(0);f[H+(qa<<2)>>2]=pa;F=F+1|0;if((F|0)>=(K|0)){sa=oa;ta=n;break}else t=oa}}else{sa=-1;ta=na}t=f[E>>2]|0;n=t-ta|0;K=n>>2;F=ta;if((F|0)!=(t|0)){if((n|0)<0){B=97;break}if(!n)ua=1;else{n=1;t=0;while(1){H=Y(f[F+(t<<2)>>2]|0,n)|0;t=t+1|0;if((t|0)==(K|0)){ua=H;break}else n=H}}}else ua=0;n=f[L>>2]|0;K=f[D>>2]|0;t=n-K|0;F=t>>2;E=K;if((E|0)!=(n|0)){if((t|0)<0){B=102;break}if(!t)va=1;else{t=1;n=0;while(1){K=Y(f[E+(n<<2)>>2]|0,t)|0;n=n+1|0;if((n|0)==(F|0)){va=K;break}else t=K}}}else va=0;if((sa|0)==-1){if((ua|0)!=(va|0)){B=120;break}}else{if((ua>>>0)%(va>>>0)|0|0){B=117;break}f[E+(sa<<2)>>2]=(ua>>>0)/(va>>>0)|0}t=a+1|0;if(t>>>0>=(((f[j>>2]|0)-(f[c>>2]|0)|0)/12|0)>>>0){B=138;break}a=t;v=f[w>>2]|0}switch(B|0){case 14:{mCc(v);break}case 29:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,70)|0;p=452744;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452815,452821,161);break}case 55:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,70)|0;p=452744;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452815,452821,161);break}case 66:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,70)|0;p=452744;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452815,452821,161);break}case 74:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,70)|0;p=452744;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452815,452821,161);break}case 77:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,58)|0;p=431827;q=o+58|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,431886,431696,105);break}case 80:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,85)|0;p=431912;q=o+85|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,431886,431696,108);break}case 97:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,70)|0;p=452744;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452815,452821,161);break}case 102:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,70)|0;p=452744;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452815,452821,161);break}case 109:{f[h>>2]=ra;F5(i,431998,h);z5(-5,i,431886,431696,125);break}case 112:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,50)|0;p=432067;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,431886,431696,131);break}case 114:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,18)|0;p=432118;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-5,i,431886,431696,136);break}case 117:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,31)|0;p=432137;q=o+31|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-1,i,431886,431696,145);break}case 120:{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,20)|0;p=432169;q=o+20|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,431886,431696,151);break}case 138:{u=g;return 1}}return 0}function Opb(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0;c=VDc(192)|0;Ppb(c,b);f[c>>2]=99316;f[c+88>>2]=1124007936;b=c+96|0;e=c+128|0;g=c+92|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=b;b=c+136|0;f[c+132>>2]=b;g=b;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));d[b+52>>1]=0;b=VDc(16)|0;g=b+4|0;f[g>>2]=1;f[b>>2]=99428;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;f[g>>2]=(f[g>>2]|0)+1;c=f[g>>2]|0;f[g>>2]=c+-1;if((c|0)!=1)return;Yi[f[(f[b>>2]|0)+8>>2]&2047](b);return}function Ppb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+32|0;e=d+20|0;g=d+16|0;h=d+12|0;i=d+8|0;j=d;JHa(a);k=a+36|0;l=k;m=l+48|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[a>>2]=99576;KHa(a,c);f[e>>2]=0;f[g>>2]=0;f[h>>2]=0;f[i>>2]=0;n=a+48|0;o=a+44|0;Gzb(c,a+40|0,k,e,g,i,h,n,o,a+64|0,a+60|0,a+76|0);k=f[e>>2]|0;if((k|0)!=(f[i>>2]|0)){f[j>>2]=0;p=j+4|0;f[p>>2]=0;q=tT(j,51)|0;l=q;r=433750;m=l+51|0;do{b[l>>0]=b[r>>0]|0;l=l+1|0;r=r+1|0}while((l|0)<(m|0));z5(-213,j,433980,432302,73)}i=f[g>>2]|0;if((i|0)!=(f[h>>2]|0)){f[j>>2]=0;p=j+4|0;f[p>>2]=0;q=tT(j,51)|0;l=q;r=433750;m=l+51|0;do{b[l>>0]=b[r>>0]|0;l=l+1|0;r=r+1|0}while((l|0)<(m|0));z5(-213,j,433980,432302,73)}f[a+52>>2]=i;f[a+56>>2]=k;f[j>>2]=0;f[j+4>>2]=0;l=tT(j,10)|0;r=455057;m=l+10|0;do{b[l>>0]=b[r>>0]|0;l=l+1|0;r=r+1|0}while((l|0)<(m|0));k=DHa(lIa(c,j)|0,-1)|0;i=a+84|0;f[i>>2]=k;uT(j);f[j>>2]=0;f[j+4>>2]=0;k=tT(j,5)|0;b[k>>0]=b[475710]|0;b[k+1>>0]=b[475711]|0;b[k+2>>0]=b[475712]|0;b[k+3>>0]=b[475713]|0;b[k+4>>0]=b[475714]|0;k=c+4|0;c=f[k>>2]|0;do if(c){q=f[j>>2]|0;p=(q|0)==0?1154740:q;h=k;g=c;a:while(1){e=g;while(1){s=f[e+16>>2]|0;if((s|0)==(q|0))break;if((Ioc((s|0)==0?1154740:s,p)|0)>=0)break;s=f[e+4>>2]|0;if(!s){t=h;break a}else e=s}g=f[e>>2]|0;if(!g){t=e;break}else h=e}if((t|0)!=(k|0)){h=f[t+16>>2]|0;if((q|0)!=(h|0)?(Ioc(p,(h|0)==0?1154740:h)|0)<=-1:0){v=1;break}h=DHa(t+24|0,-1)|0;v=h}else v=1}else v=1;while(0);uT(j);f[j>>2]=0;f[j+4>>2]=0;t=tT(j,5)|0;b[t>>0]=b[434005]|0;b[t+1>>0]=b[434006]|0;b[t+2>>0]=b[434007]|0;b[t+3>>0]=b[434008]|0;b[t+4>>0]=b[434009]|0;t=f[k>>2]|0;do if(t){c=f[j>>2]|0;h=(c|0)==0?1154740:c;g=k;s=t;b:while(1){w=s;while(1){x=f[w+16>>2]|0;if((x|0)==(c|0))break;if((Ioc((x|0)==0?1154740:x,h)|0)>=0)break;x=f[w+4>>2]|0;if(!x){y=g;break b}else w=x}s=f[w>>2]|0;if(!s){y=w;break}else g=w}if((y|0)!=(k|0)){g=f[y+16>>2]|0;if((c|0)!=(g|0)?(Ioc(h,(g|0)==0?1154740:g)|0)<=-1:0){z=0;break}g=DHa(y+24|0,-1)|0;z=g}else z=0}else z=0;while(0);y=a+72|0;f[y>>2]=z;uT(j);f[j>>2]=0;f[j+4>>2]=0;z=tT(j,5)|0;b[z>>0]=b[434011]|0;b[z+1>>0]=b[434012]|0;b[z+2>>0]=b[434013]|0;b[z+3>>0]=b[434014]|0;b[z+4>>0]=b[434015]|0;z=f[k>>2]|0;do if(z){t=f[j>>2]|0;g=(t|0)==0?1154740:t;s=k;p=z;c:while(1){q=p;while(1){e=f[q+16>>2]|0;if((e|0)==(t|0))break;if((Ioc((e|0)==0?1154740:e,g)|0)>=0)break;e=f[q+4>>2]|0;if(!e){A=s;break c}else q=e}p=f[q>>2]|0;if(!p){A=q;break}else s=q}if((A|0)!=(k|0)){s=f[A+16>>2]|0;if((t|0)!=(s|0)?(Ioc(g,(s|0)==0?1154740:s)|0)<=-1:0){B=0;break}s=DHa(A+24|0,-1)|0;B=s}else B=0}else B=0;while(0);A=a+68|0;f[A>>2]=B;uT(j);if((f[i>>2]|0)%(v|0)|0|0){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,24)|0;r=434017;m=l+24|0;do{b[l>>0]=b[r>>0]|0;l=l+1|0;r=r+1|0}while((l|0)<(m|0));z5(-215,j,433980,432302,84)}if((f[A>>2]|0)>=(f[o>>2]|0)){f[j>>2]=0;C=j+4|0;f[C>>2]=0;D=tT(j,66)|0;l=D;r=434042;m=l+66|0;do{b[l>>0]=b[r>>0]|0;l=l+1|0;r=r+1|0}while((l|0)<(m|0));z5(-215,j,433980,432302,86)}if((f[y>>2]|0)<(f[n>>2]|0)){u=d;return}else{f[j>>2]=0;C=j+4|0;f[C>>2]=0;D=tT(j,66)|0;l=D;r=434042;m=l+66|0;do{b[l>>0]=b[r>>0]|0;l=l+1|0;r=r+1|0}while((l|0)<(m|0));z5(-215,j,433980,432302,86)}}function Qpb(a){a=a|0;YDc(a);return}function Rpb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Spb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=99316;b=a+180|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+184>>2]=0;b=f[a+168>>2]|0;if(b|0){c=a+172|0;e=f[c>>2]|0;if((e|0)!=(b|0))f[c>>2]=e+(~((e+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+156>>2]|0;if(b|0){e=a+160|0;c=f[e>>2]|0;if((c|0)!=(b|0))f[e>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+144>>2]|0;if(b|0){c=a+148|0;e=f[c>>2]|0;if((e|0)!=(b|0))f[c>>2]=e+(~((e+-8-b|0)>>>3)<<3);YDc(b)}b=a+88|0;e=a+124|0;c=f[e>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)_S(b);f[e>>2]=0;e=a+104|0;b=a+92|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[a+128>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+132>>2]|0;if((b|0)==(a+136|0)){f[a>>2]=99468;g=a+76|0;uT(g);REa(a);return}g0(b);f[a>>2]=99468;g=a+76|0;uT(g);REa(a);return}function Tpb(a){a=a|0;Spb(a);YDc(a);return}function Upb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+368|0;g=e+32|0;h=e;i=e+256|0;j=e+312|0;k=e+200|0;l=e+144|0;m=e+88|0;kqb(a,c,d);d=f[a+4>>2]|0;c=a+8|0;if((d|0)==(f[c>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;n=tT(g,14)|0;o=433344;q=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));z5(-215,g,453718,432302,274)}o=f[f[d+40>>2]>>2]|0;lT(j,d,1,o);f[i>>2]=1124007936;d=i+4|0;r=i+8|0;s=i+40|0;n=d;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[s>>2]=r;t=i+48|0;v=i+44|0;f[v>>2]=t;f[t>>2]=0;f[i+52>>2]=0;w=g+8|0;f[w>>2]=0;f[w+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=i;h_(j,g);w=j+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)_S(j);f[w>>2]=0;w=j+16|0;x=j+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[j+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))g0(x);x=f[i>>2]|0;j=((f[f[v>>2]>>2]|0)>>>0)/((1212424721>>>(x<<2&28)&15)>>>0)|0;if(j&7|0){y=j+7&-8;j=x&4095;f[k>>2]=1124007936;x=k+4|0;w=k+8|0;z=k+40|0;n=x;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[z>>2]=w;w=k+48|0;A=k+44|0;f[A>>2]=w;f[w>>2]=0;f[k+52>>2]=0;f[g>>2]=o;f[g+4>>2]=y;XS(k,2,g,j);j=i+12|0;B=f[j>>2]|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=B;f[h+4>>2]=y;$S(l,k,g,h);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=-1056833530;f[g+4>>2]=h;f[g+8>>2]=1;f[g+12>>2]=4;l_(l,g,e0()|0)|0;y=f[j>>2]|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=y;$S(m,k,g,h);h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=m;h_(i,g);h=m+36|0;y=f[h>>2]|0;if(y|0){B=y+12|0;f[B>>2]=(f[B>>2]|0)+1}B=i+36|0;y=f[B>>2]|0;if(y|0?(C=y+12|0,y=f[C>>2]|0,f[C>>2]=y+-1,(y|0)==1):0)_S(i);f[B>>2]=0;y=i+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[d>>2]|0)>0){C=f[s>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0;E=f[d>>2]|0}while((D|0)<(E|0));f[i>>2]=f[m>>2];if((E|0)<3)F=22;else F=24}else{f[i>>2]=f[m>>2];F=22}if((F|0)==22){E=f[m+4>>2]|0;if((E|0)<3){f[d>>2]=E;f[r>>2]=f[m+8>>2];f[j>>2]=f[m+12>>2];j=f[m+44>>2]|0;E=f[v>>2]|0;f[E>>2]=f[j>>2];f[E+4>>2]=f[j+4>>2]}else F=24}if((F|0)==24)ZS(i,m);j=m+16|0;f[y>>2]=f[j>>2];f[i+20>>2]=f[m+20>>2];f[i+24>>2]=f[m+24>>2];f[i+28>>2]=f[m+28>>2];f[i+32>>2]=f[m+32>>2];y=f[h>>2]|0;f[B>>2]=y;if(y|0?(B=y+12|0,y=f[B>>2]|0,f[B>>2]=y+-1,(y|0)==1):0)_S(m);f[h>>2]=0;h=m+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[m+40>>2]|0;y=0;do{f[j+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[h>>2]|0))}h=f[m+44>>2]|0;if((h|0)!=(m+48|0))g0(h);h=l+36|0;m=f[h>>2]|0;if(m|0?(y=m+12|0,m=f[y>>2]|0,f[y>>2]=m+-1,(m|0)==1):0)_S(l);f[h>>2]=0;h=l+16|0;m=l+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[m>>2]|0)>0){h=f[l+40>>2]|0;y=0;do{f[h+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))g0(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(y=l+12|0,l=f[y>>2]|0,f[y>>2]=l+-1,(l|0)==1):0)_S(k);f[m>>2]=0;m=k+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[x>>2]|0)>0){m=f[z>>2]|0;z=0;do{f[m+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}x=f[A>>2]|0;if((x|0)!=(w|0))g0(x)}x=a+88|0;if((x|0)!=(i|0)){w=i+36|0;A=f[w>>2]|0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+124|0;A=f[z>>2]|0;if(A|0?(m=A+12|0,A=f[m>>2]|0,f[m>>2]=A+-1,(A|0)==1):0)_S(x);f[z>>2]=0;A=a+104|0;m=a+92|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[m>>2]|0)>0){k=f[a+128>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;G=f[m>>2]|0}while((l|0)<(G|0));f[x>>2]=f[i>>2];if((G|0)<3)F=61;else F=63}else{f[x>>2]=f[i>>2];F=61}if((F|0)==61){G=f[d>>2]|0;if((G|0)<3){f[m>>2]=G;f[a+96>>2]=f[r>>2];f[a+100>>2]=f[i+12>>2];r=f[v>>2]|0;G=f[a+132>>2]|0;f[G>>2]=f[r>>2];f[G+4>>2]=f[r+4>>2]}else F=63}if((F|0)==63)ZS(x,i);f[A>>2]=f[i+16>>2];f[a+108>>2]=f[i+20>>2];f[a+112>>2]=f[i+24>>2];f[a+116>>2]=f[i+28>>2];f[a+120>>2]=f[i+32>>2];f[z>>2]=f[w>>2]}p[g>>3]=1.0;lqb(a+144|0,o,g);w=f[a+4>>2]|0;if((((f[c>>2]|0)-w|0)/56|0)>>>0>1)lT(g,w+56|0,1,o);else{f[g>>2]=1124007936;w=g+8|0;c=g+40|0;n=g+4|0;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[c>>2]=w;w=g+48|0;f[g+44>>2]=w;f[w>>2]=0;f[g+52>>2]=0}w=a+156|0;c=o+2|0;n=a+160|0;a=f[n>>2]|0;q=f[w>>2]|0;z=a-q>>2;A=q;q=a;if(c>>>0<=z>>>0){if(c>>>0<z>>>0?(a=A+(c<<2)|0,(q|0)!=(a|0)):0)f[n>>2]=q+(~((q+-4-a|0)>>>2)<<2)}else fqb(w,c-z|0);z=g+16|0;c=f[z>>2]|0;a:do if(c){a=f[g+4>>2]|0;if((a|0)<3)H=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{q=f[g+40>>2]|0;n=0;A=1;while(1){x=Y(f[q+(n<<2)>>2]|0,A)|0;n=n+1|0;if((n|0)==(a|0)){H=x;break}else A=x}}if(!((a|0)==0|(H|0)==0)){if((o|0)>0){A=f[g+40>>2]|0;n=A+4|0;q=f[g+44>>2]|0;x=f[g+12>>2]|0;r=f[w>>2]|0;if(f[g>>2]&16384|0){G=0;while(1){f[r+(G<<2)>>2]=f[c+(G<<2)>>2];G=G+1|0;if((G|0)==(o|0))break a}}G=(f[A>>2]|0)==1;a=0;do{do if(!G){m=f[q>>2]|0;if((f[n>>2]|0)==1){I=c+(Y(m,a)|0)|0;break}else{l=(a|0)/(x|0)|0;I=c+(Y(l,m)|0)+(a-(Y(l,x)|0)<<2)|0;break}}else I=c+(a<<2)|0;while(0);f[r+(a<<2)>>2]=f[I>>2];a=a+1|0}while((a|0)!=(o|0))}}else F=88}else F=88;while(0);if((F|0)==88?(o|0)>0:0)XIc(f[w>>2]|0,0,o<<2|0)|0;o=g+36|0;w=f[o>>2]|0;if(w|0?(F=w+12|0,w=f[F>>2]|0,f[F>>2]=w+-1,(w|0)==1):0)_S(g);f[o>>2]=0;o=g+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[o>>2]|0)>0){z=f[g+40>>2]|0;w=0;do{f[z+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[o>>2]|0))}o=f[g+44>>2]|0;if((o|0)!=(g+48|0))g0(o);o=i+36|0;g=f[o>>2]|0;if(g|0?(w=g+12|0,g=f[w>>2]|0,f[w>>2]=g+-1,(g|0)==1):0)_S(i);f[o>>2]=0;o=i+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[d>>2]|0)>0){o=f[s>>2]|0;s=0;do{f[o+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[d>>2]|0))}d=f[v>>2]|0;if((d|0)==(t|0)){u=e;return}g0(d);u=e;return}function Vpb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=u;u=u+64|0;h=g+52|0;i=g+40|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;c=d;if(((f[e>>2]|0)-d|0)!=56){f[j>>2]=0;f[j+4>>2]=0;p=tT(j,26)|0;q=432461;r=p+26|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,j,453206,432302,1049)}d=f[(f[c+40>>2]|0)+4>>2]|0;e=f[(f[a+4>>2]|0)+40>>2]|0;s=f[e+4>>2]|0;if((d|0)%(s|0)|0|0){f[j>>2]=0;f[j+4>>2]=0;p=tT(j,41)|0;q=432672;r=p+41|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,j,453206,432302,1049)}t=f[i>>2]|0;v=t;if(((f[o>>2]|0)-t|0)!=56){f[j>>2]=0;f[j+4>>2]=0;p=tT(j,19)|0;q=453252;r=p+19|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,j,453206,432302,1049)}if((f[c+16>>2]|0)==(f[v+16>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;p=tT(j,33)|0;q=432714;r=p+33|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,j,453206,432302,1049)}c=(d|0)/(s|0)|0;if((f[(f[v+40>>2]|0)+4>>2]|0)%(c|0)|0|0){f[j>>2]=0;f[j+4>>2]=0;p=tT(j,33)|0;q=432748;r=p+33|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,j,453206,432302,1052)}v=f[e>>2]|0;e=a+168|0;s=f[e>>2]|0;d=a+172|0;t=f[d>>2]|0;if((t|0)!=(s|0))f[d>>2]=t+(~((t+-4-s|0)>>>2)<<2);s=a+184|0;t=f[s>>2]|0;if(t|0){o=a+180|0;w=bFc(t,14192,16912,0)|0;t=f[o>>2]|0;x=(t|0)==0;if(!x){y=t+4|0;f[y>>2]=(f[y>>2]|0)+1}if(w|0)eqb(e,v+2|0,w+36|0);w=f[s>>2]|0;if(!w)z=0;else z=bFc(w,14192,16928,0)|0;w=f[o>>2]|0;o=(w|0)==0;if(!o){y=w+4|0;f[y>>2]=(f[y>>2]|0)+1}if(z|0){y=f[z+4>>2]|0;if((f[y>>2]&20479|0)!=16389){f[j>>2]=0;A=j+4|0;f[A>>2]=0;B=tT(j,65)|0;p=B;q=432782;r=p+65|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,j,453206,432302,1068)}z=f[y+4>>2]|0;if((z|0)<3)C=Y(f[y+12>>2]|0,f[y+8>>2]|0)|0;else{D=f[y+40>>2]|0;E=0;F=1;while(1){G=Y(f[D+(E<<2)>>2]|0,F)|0;E=E+1|0;if((E|0)==(z|0)){C=G;break}else F=G}}if((C|0)!=(v|0)){f[j>>2]=0;A=j+4|0;f[A>>2]=0;B=tT(j,65)|0;p=B;q=432782;r=p+65|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,j,453206,432302,1068)}j=f[y+16>>2]|0;y=v+2|0;q=f[d>>2]|0;p=f[e>>2]|0;r=q-p>>2;B=p;p=q;do if(y>>>0>r>>>0)fqb(e,y-r|0);else{if(y>>>0>=r>>>0)break;q=B+(y<<2)|0;if((p|0)==(q|0))break;f[d>>2]=p+(~((p+-4-q|0)>>>2)<<2)}while(0);p=j+(v<<2)-j|0;if(p|0)fJc(f[e>>2]|0,j|0,p|0)|0;p=f[e>>2]|0;j=f[p+(v+-1<<2)>>2]|0;f[p+(v+1<<2)>>2]=j;f[p+(v<<2)>>2]=j}j=w;if(!o?(o=j+4|0,v=f[o>>2]|0,f[o>>2]=v+-1,(v|0)==1):0)Yi[f[(f[w>>2]|0)+8>>2]&2047](j);j=t;if(!x?(x=j+4|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)Yi[f[(f[t>>2]|0)+8>>2]&2047](j)}j=z8()|0;t=f[h>>2]|0;w=f[i>>2]|0;f[k>>2]=f[a+36>>2];f[k+4>>2]=f[a+40>>2];f[l>>2]=f[a+52>>2];f[l+4>>2]=f[a+56>>2];f[m>>2]=f[a+44>>2];f[m+4>>2]=f[a+48>>2];f[n>>2]=f[a+60>>2];f[n+4>>2]=f[a+64>>2];gqb(t,w,a+88|0,a+156|0,e,k,l,m,n,f[s>>2]|0,c,(j|0)>1?j:1);mx(i);mx(h);u=g;return}function Wpb(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function Xpb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Ypb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Zpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function _pb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+180|0;d=a+184|0;e=b+4|0;do if(f[d>>2]|0){g=f[e>>2]|0;if(!g){h=g;break}else{i=0;return i|0}}else h=f[e>>2]|0;while(0);e=f[b>>2]|0;if(e|0){b=e+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=e;f[d>>2]=h;if(!b)j=h;else{h=b+4|0;e=f[h>>2]|0;f[h>>2]=e+-1;if((e|0)==1)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);j=f[d>>2]|0}if((j|0)==0?(d=f[a+168>>2]|0,b=a+172|0,a=f[b>>2]|0,(a|0)!=(d|0)):0)f[b>>2]=a+(~((a+-4-d|0)>>>2)<<2);i=(j|0)!=0;return i|0}function $pb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+112|0;d=c+56|0;e=c;f[d>>2]=1124007936;g=d+4|0;h=d+8|0;i=d+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;l=d+48|0;m=d+44|0;f[m>>2]=l;f[l>>2]=0;f[d+52>>2]=0;f[e>>2]=1124007936;n=e+4|0;o=e+8|0;p=e+40|0;j=n;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[p>>2]=o;j=e+48|0;k=e+44|0;f[k>>2]=j;f[j>>2]=0;f[e+52>>2]=0;q=f[b+4>>2]|0;Ti[f[(f[q>>2]|0)+84>>2]&511](q,d,e);q=d+16|0;if(f[q>>2]|0){b=f[g>>2]|0;if((b|0)<3)r=Y(f[d+12>>2]|0,f[h>>2]|0)|0;else{h=f[i>>2]|0;s=0;t=1;while(1){v=Y(f[h+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(b|0)){r=v;break}else t=v}}if(!((b|0)==0|(r|0)==0))w=13;else w=7}else w=7;if((w|0)==7)if(f[e+16>>2]|0){r=f[n>>2]|0;if((r|0)<3)x=Y(f[e+12>>2]|0,f[o>>2]|0)|0;else{o=f[p>>2]|0;b=0;t=1;while(1){s=Y(f[o+(b<<2)>>2]|0,t)|0;b=b+1|0;if((b|0)==(r|0)){x=s;break}else t=s}}if(!((r|0)==0|(x|0)==0))w=13;else y=0}else y=0;if((w|0)==13){dqb(a,d,e);y=1}a=e+36|0;w=f[a>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)_S(e);f[a>>2]=0;a=e+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[n>>2]|0)>0){a=f[p>>2]|0;p=0;do{f[a+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[n>>2]|0))}n=f[k>>2]|0;if((n|0)!=(j|0))g0(n);n=d+36|0;j=f[n>>2]|0;if(j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)_S(d);f[n>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[g>>2]|0)>0){q=f[i>>2]|0;i=0;do{f[q+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[m>>2]|0;if((g|0)==(l|0)){u=c;return y|0}g0(g);u=c;return y|0}function aqb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+48|0;h=d+32|0;i=d+16|0;j=d;k=a+4|0;l=f[a+8>>2]|0;m=f[k>>2]|0;n=m;if((l|0)==(m|0)){f[h>>2]=0;f[h+4>>2]=0;o=tT(h,17)|0;p=432384;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,h,452925,432302,238)}if(((l-m|0)/56|0)>>>0>1){m=f[n+60>>2]|0;if((m|0)<3)r=Y(f[n+68>>2]|0,f[n+64>>2]|0)|0;else{l=f[n+96>>2]|0;s=0;t=1;while(1){v=Y(f[l+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(m|0)){r=v;break}else t=v}}if((r|0)!=(f[f[n+40>>2]>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;o=tT(h,58)|0;p=432402;q=o+58|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,h,452925,432302,239)}}r=c+4|0;t=f[c>>2]|0;m=t;if(((f[r>>2]|0)-t|0)!=12){f[h>>2]=0;f[h+4>>2]=0;o=tT(h,26)|0;p=432461;q=o+26|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,h,452925,432302,240)}t=f[g>>2]|0;s=g+4|0;g=f[s>>2]|0;if((g|0)==(t|0)){w=k;x=c;y=m;z=n}else{n=g;while(1){g=n+-12|0;f[s>>2]=g;m=f[g>>2]|0;if(!m)A=g;else{g=n+-8|0;l=f[g>>2]|0;if((l|0)!=(m|0))f[g>>2]=l+(~((l+-4-m|0)>>>2)<<2);YDc(m);A=f[s>>2]|0}if((A|0)==(t|0))break;else n=A}w=k;x=c;y=f[c>>2]|0;z=f[k>>2]|0}k=f[y>>2]|0;y=f[k+4>>2]|0;c=f[k+8>>2]|0;A=f[k+12>>2]|0;k=f[f[z+40>>2]>>2]|0;f[h>>2]=0;z=h+4|0;f[z>>2]=0;if(!(f[a+80>>2]|0)){n=c+-1+(f[a+56>>2]<<1)-(Y((f[a+40>>2]|0)+-1|0,f[a+64>>2]|0)|0)|0;f[z>>2]=((n|0)/(f[a+48>>2]|0)|0)+1;n=A+-1+(f[a+52>>2]<<1)-(Y((f[a+36>>2]|0)+-1|0,f[a+60>>2]|0)|0)|0;f[h>>2]=((n|0)/(f[a+44>>2]|0)|0)+1}else{f[i>>2]=A;f[i+4>>2]=c;Hzb(i,a+36|0,a+44|0,a+76|0,a+60|0,h)}a=(y|0)/(f[(f[(f[w>>2]|0)+40>>2]|0)+4>>2]|0)|0;if((a|0)<=0){f[i>>2]=0;B=i+4|0;f[B>>2]=0;C=tT(i,59)|0;o=C;p=432488;q=o+59|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452925,432302,262)}if((y|0)%(a|0)|0|0){f[i>>2]=0;B=i+4|0;f[B>>2]=0;C=tT(i,59)|0;o=C;p=432488;q=o+59|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452925,432302,262)}if((k|0)%(a|0)|0|0){f[i>>2]=0;B=i+4|0;f[B>>2]=0;C=tT(i,59)|0;o=C;p=432488;q=o+59|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,452925,432302,262)}p=f[x>>2]|0;f[i>>2]=f[f[p>>2]>>2];f[i+4>>2]=k;f[i+8>>2]=f[z>>2];f[i+12>>2]=f[h>>2];h=((f[r>>2]|0)-p|0)/12|0;f[j>>2]=0;p=j+4|0;f[p>>2]=0;f[j+8>>2]=0;lFa(j,i,i+16|0);i=e+4|0;r=f[i>>2]|0;z=f[e>>2]|0;k=(r-z|0)/12|0;x=z;z=r;if(h>>>0<=k>>>0){if(h>>>0<k>>>0?(r=x+(h*12|0)|0,(z|0)!=(r|0)):0){x=z;while(1){z=x+-12|0;f[i>>2]=z;o=f[z>>2]|0;if(!o)D=z;else{z=x+-8|0;q=f[z>>2]|0;if((q|0)!=(o|0))f[z>>2]=q+(~((q+-4-o|0)>>>2)<<2);YDc(o);D=f[i>>2]|0}if((D|0)==(r|0))break;else x=D}}}else npb(e,h-k|0,j);k=f[j>>2]|0;if(!k){u=d;return 0}j=f[p>>2]|0;if((j|0)!=(k|0))f[p>>2]=j+(~((j+-4-k|0)>>>2)<<2);YDc(k);u=d;return 0}function bqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;h=f[c+4>>2]|0;i=f[c>>2]|0;c=h-i|0;j=f[d>>2]|0;k=j;l=i;if((c|0)!=((f[d+4>>2]|0)-j|0)){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,31)|0;n=434865;o=m+31|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,445611,432302,1085)}if((h|0)==(i|0)){p=0;q=0;J=p;u=e;return q|0}i=a+36|0;h=a+40|0;a=(c|0)/12|0;c=0;j=0;d=0;while(1){r=f[k+(c*12|0)+4>>2]|0;s=f[k+(c*12|0)>>2]|0;t=r-s|0;v=t>>2;w=s;if((w|0)!=(r|0)){if((t|0)<=-4){x=9;break}if((t|0)>0){t=0;r=1;while(1){s=Y(f[w+(t<<2)>>2]|0,r)|0;t=t+1|0;if((t|0)>=(v|0)){y=s;break}else r=s}}else y=1}else y=0;r=Y(f[h>>2]|0,f[i>>2]|0)|0;v=jJc(r|0,((r|0)<0)<<31>>31|0,1)|0;r=f[(f[l+(c*12|0)>>2]|0)+4>>2]|0;t=mJc(v|0,J|0,r|0,((r|0)<0)<<31>>31|0)|0;r=mJc(t|1|0,J|0,y|0,((y|0)<0)<<31>>31|0)|0;t=UIc(r|0,J|0,j|0,d|0)|0;r=J;c=c+1|0;if(c>>>0>=a>>>0){p=r;q=t;x=5;break}else{j=t;d=r}}if((x|0)==5){J=p;u=e;return q|0}else if((x|0)==9){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,70)|0;n=452744;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,452815,452821,161)}return 0}function cqb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;e=c;g=f[d>>2]|0;d=Y(f[b+40>>2]|0,f[(f[(f[b+4>>2]|0)+40>>2]|0)+4>>2]|0)|0;h=Y(d,f[b+36>>2]|0)|0;b=Y(f[g+8>>2]|0,f[g+12>>2]|0)|0;f[e>>2]=b;f[e+4>>2]=h;f[e+8>>2]=-1;f[e+12>>2]=-1;f[a>>2]=0;h=a+4|0;f[h>>2]=0;f[a+8>>2]=0;lFa(a,e,e+16|0);e=f[a>>2]|0;a=f[h>>2]|0;a:do if((e|0)==(a|0))i=e;else{b=e;do{if((f[b>>2]|0)<0){i=b;break a}b=b+4|0}while((b|0)!=(a|0));u=c;return}while(0);if((i|0)==(a|0)){u=c;return}e=i+4|0;if((e|0)==(a|0)){j=a;k=i}else{b=e;e=i;while(1){i=f[b>>2]|0;if((i|0)<0)l=e;else{f[e>>2]=i;l=e+4|0}b=b+4|0;if((b|0)==(a|0))break;else e=l}j=f[h>>2]|0;k=l}if((k|0)==(j|0)){u=c;return}f[h>>2]=j+(~((j+-4-k|0)>>>2)<<2);u=c;return}function dqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=u;u=u+368|0;g=e+360|0;h=e;i=e+304|0;j=e+248|0;k=e+192|0;l=e+176|0;m=e+120|0;o=e+104|0;q=e+88|0;r=e+32|0;s=a+88|0;t=a+128|0;v=f[f[t>>2]>>2]|0;w=c+4|0;x=f[w>>2]|0;if((x|0)<3)y=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{z=f[c+40>>2]|0;A=0;B=1;while(1){C=Y(f[z+(A<<2)>>2]|0,B)|0;A=A+1|0;if((A|0)==(x|0)){y=C;break}else B=C}}do if((y|0)!=1){f[i>>2]=f[c>>2];B=i+4|0;f[B>>2]=x;A=i+8|0;f[A>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];z=f[c+36>>2]|0;f[i+36>>2]=z;f[i+40>>2]=A;A=i+48|0;C=i+44|0;f[C>>2]=A;f[A>>2]=0;f[i+52>>2]=0;if(!z)D=x;else{A=z+12|0;f[A>>2]=(f[A>>2]|0)+1;D=f[w>>2]|0}if((D|0)<3){A=f[c+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];break}else{f[B>>2]=0;ZS(i,c);break}}else{p[h>>3]=+n[f[c+16>>2]>>2];B=h+8|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;f[i>>2]=1124007936;B=i+8|0;A=i+40|0;E=i+4|0;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[A>>2]=B;z=i+48|0;f[i+44>>2]=z;f[z>>2]=0;f[i+52>>2]=0;f[g>>2]=1;f[g+4>>2]=v;XS(i,2,g,5);k_(i,h)|0}while(0);c=d+4|0;D=f[c>>2]|0;if((D|0)<3)G=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{w=f[d+40>>2]|0;x=0;y=1;while(1){z=Y(f[w+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(D|0)){G=z;break}else y=z}}do if((G|0)!=1){f[j>>2]=f[d>>2];y=j+4|0;f[y>>2]=D;x=j+8|0;f[x>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];w=f[d+36>>2]|0;f[j+36>>2]=w;f[j+40>>2]=x;x=j+48|0;z=j+44|0;f[z>>2]=x;f[x>>2]=0;f[j+52>>2]=0;if(!w)H=D;else{x=w+12|0;f[x>>2]=(f[x>>2]|0)+1;H=f[c>>2]|0}if((H|0)<3){x=f[d+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2];break}else{f[y>>2]=0;ZS(j,d);break}}else{p[h>>3]=+n[f[d+16>>2]>>2];y=h+8|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[j>>2]=1124007936;y=j+8|0;x=j+40|0;E=j+4|0;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[x>>2]=y;B=j+48|0;f[j+44>>2]=B;f[B>>2]=0;f[j+52>>2]=0;f[g>>2]=1;f[g+4>>2]=v;XS(j,2,g,5);k_(j,h)|0}while(0);if(!(f[a+104>>2]|0)){f[g>>2]=0;I=g+4|0;f[I>>2]=0;J=tT(g,19)|0;E=J;K=432548;F=E+19|0;do{b[E>>0]=b[K>>0]|0;E=E+1|0;K=K+1|0}while((E|0)<(F|0));z5(-215,g,432568,432302,367)}d=f[a+92>>2]|0;if((d|0)<3)L=Y(f[a+100>>2]|0,f[a+96>>2]|0)|0;else{H=f[t>>2]|0;t=0;c=1;while(1){D=Y(f[H+(t<<2)>>2]|0,c)|0;t=t+1|0;if((t|0)==(d|0)){L=D;break}else c=D}}if((d|0)==0|(L|0)==0){f[g>>2]=0;I=g+4|0;f[I>>2]=0;J=tT(g,19)|0;E=J;K=432548;F=E+19|0;do{b[E>>0]=b[K>>0]|0;E=E+1|0;K=K+1|0}while((E|0)<(F|0));z5(-215,g,432568,432302,367)}J=a+156|0;if(((f[a+160>>2]|0)-(f[J>>2]|0)>>2|0)!=(v+2|0)){f[g>>2]=0;f[g+4>>2]=0;E=tT(g,27)|0;K=432580;F=E+27|0;do{b[E>>0]=b[K>>0]|0;E=E+1|0;K=K+1|0}while((E|0)<(F|0));z5(-215,g,432568,432302,367)}I=i+16|0;L=(f[I>>2]|0)==0;if(!L){d=f[i+4>>2]|0;c=(d|0)<3;if(c)M=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{t=f[i+40>>2]|0;H=0;D=1;while(1){G=Y(f[t+(H<<2)>>2]|0,D)|0;H=H+1|0;if((H|0)==(d|0)){M=G;break}else D=G}}if(!((d|0)==0|(M|0)==0)){if(c)N=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{c=f[i+40>>2]|0;M=0;D=1;while(1){H=Y(f[c+(M<<2)>>2]|0,D)|0;M=M+1|0;if((M|0)==(d|0)){N=H;break}else D=H}}if((v|0)!=(N|0)){f[g>>2]=0;f[g+4>>2]=0;E=tT(g,31)|0;K=432608;F=E+31|0;do{b[E>>0]=b[K>>0]|0;E=E+1|0;K=K+1|0}while((E|0)<(F|0));z5(-215,g,432568,432302,367)}}}N=j+16|0;D=f[N>>2]|0;if(D|0){d=f[j+4>>2]|0;M=(d|0)<3;if(M)O=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{c=f[j+40>>2]|0;H=0;t=1;while(1){G=Y(f[c+(H<<2)>>2]|0,t)|0;H=H+1|0;if((H|0)==(d|0)){O=G;break}else t=G}}if(!((d|0)==0|(O|0)==0)){if(M)P=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{M=f[j+40>>2]|0;O=0;t=1;while(1){H=Y(f[M+(O<<2)>>2]|0,t)|0;O=O+1|0;if((O|0)==(d|0)){P=H;break}else t=H}}if((v|0)!=(P|0)){f[g>>2]=0;f[g+4>>2]=0;E=tT(g,31)|0;K=432640;F=E+31|0;do{b[E>>0]=b[K>>0]|0;E=E+1|0;K=K+1|0}while((E|0)<(F|0));z5(-215,g,432568,432302,367)}}}if(!L){L=f[i+4>>2]|0;if((L|0)<3)Q=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{K=f[i+40>>2]|0;E=0;F=1;while(1){P=Y(f[K+(E<<2)>>2]|0,F)|0;E=E+1|0;if((E|0)==(L|0)){Q=P;break}else F=P}}if(!((L|0)==0|(Q|0)==0)){lT(k,f[a+4>>2]|0,1,v);if((v|0)>0){Q=i+40|0;L=i+44|0;F=i+12|0;E=a+144|0;K=g+4|0;P=h+4|0;t=l+8|0;d=l+12|0;O=l+4|0;M=o+8|0;H=o+12|0;c=o+4|0;G=g+4|0;B=h+4|0;A=q+8|0;w=q+4|0;z=r+36|0;C=r+16|0;R=r+4|0;S=r+40|0;T=r+44|0;U=r+48|0;V=m+36|0;W=m+16|0;X=m+4|0;Z=m+40|0;_=m+44|0;$=m+48|0;aa=0;do{ba=f[I>>2]|0;do if((f[i>>2]&16384|0)==0?(ca=f[Q>>2]|0,(f[ca>>2]|0)!=1):0){da=f[f[L>>2]>>2]|0;if((f[ca+4>>2]|0)==1){ea=ba+(Y(da,aa)|0)|0;break}else{ca=f[F>>2]|0;fa=(aa|0)/(ca|0)|0;ea=ba+(Y(fa,da)|0)+(aa-(Y(fa,ca)|0)<<2)|0;break}}else ga=74;while(0);if((ga|0)==74){ga=0;ea=ba+(aa<<2)|0}ha=+n[ea>>2];y=(f[E>>2]|0)+(aa<<3)|0;p[y>>3]=ha*+p[y>>3];y=aa;aa=aa+1|0;f[g>>2]=y;f[K>>2]=aa;f[h>>2]=-2147483648;f[P>>2]=2147483647;$S(m,k,g,h);f[t>>2]=0;f[d>>2]=0;f[l>>2]=16842752;f[O>>2]=m;x=(f[E>>2]|0)+(y<<3)|0;f[o>>2]=-1056833530;f[c>>2]=x;f[M>>2]=1;f[H>>2]=1;f[g>>2]=y;f[G>>2]=aa;f[h>>2]=-2147483648;f[B>>2]=2147483647;$S(r,s,g,h);x=A;f[x>>2]=0;f[x+4>>2]=0;f[q>>2]=-1040121856;f[w>>2]=r;qL(l,o,q,1.0,-1);x=f[z>>2]|0;do if(x|0){ca=x+12|0;fa=f[ca>>2]|0;f[ca>>2]=fa+-1;if((fa|0)!=1)break;_S(r)}while(0);f[z>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[R>>2]|0)>0){x=f[S>>2]|0;ba=0;do{f[x+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[R>>2]|0))}ba=f[T>>2]|0;if((ba|0)!=(U|0))g0(ba);ba=f[V>>2]|0;do if(ba|0){x=ba+12|0;fa=f[x>>2]|0;f[x>>2]=fa+-1;if((fa|0)!=1)break;_S(m)}while(0);f[V>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[X>>2]|0)>0){ba=f[Z>>2]|0;fa=0;do{f[ba+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[X>>2]|0))}fa=f[_>>2]|0;if((fa|0)!=($|0))g0(fa);fa=(f[J>>2]|0)+(y<<2)|0;n[fa>>2]=ha*+n[fa>>2]}while((aa|0)<(v|0))}aa=k+36|0;$=f[aa>>2]|0;if($|0?(_=$+12|0,$=f[_>>2]|0,f[_>>2]=$+-1,($|0)==1):0)_S(k);f[aa>>2]=0;aa=k+16|0;$=k+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[k+40>>2]|0;_=0;do{f[aa+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[$>>2]|0))}$=f[k+44>>2]|0;if(($|0)!=(k+48|0))g0($);ia=f[N>>2]|0}else ia=D}else ia=D;D=(ia|0)==0;a:do if(!D){$=f[j+4>>2]|0;if(($|0)<3)ja=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{k=f[j+40>>2]|0;_=0;aa=1;while(1){X=Y(f[k+(_<<2)>>2]|0,aa)|0;_=_+1|0;if((_|0)==($|0)){ja=X;break}else aa=X}}if((ja|0)!=0&($|0)!=0&(v|0)>0){aa=f[j+40>>2]|0;_=aa+4|0;k=f[j+44>>2]|0;y=f[j+12>>2]|0;X=f[J>>2]|0;if(f[j>>2]&16384|0){Z=0;while(1){W=X+(Z<<2)|0;n[W>>2]=+n[ia+(Z<<2)>>2]+ +n[W>>2];Z=Z+1|0;if((Z|0)==(v|0))break a}}Z=(f[aa>>2]|0)==1;$=0;do{do if(!Z){W=f[k>>2]|0;if((f[_>>2]|0)==1){ka=ia+(Y(W,$)|0)|0;break}else{V=($|0)/(y|0)|0;ka=ia+(Y(V,W)|0)+($-(Y(V,y)|0)<<2)|0;break}}else ka=ia+($<<2)|0;while(0);V=X+($<<2)|0;n[V>>2]=+n[ka>>2]+ +n[V>>2];$=$+1|0}while(($|0)!=(v|0))}}while(0);if(f[I>>2]|0){ka=f[i+4>>2]|0;if((ka|0)<3)la=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{ia=f[i+40>>2]|0;ja=0;$=1;while(1){X=Y(f[ia+(ja<<2)>>2]|0,$)|0;ja=ja+1|0;if((ja|0)==(ka|0)){la=X;break}else $=X}}if(!((ka|0)==0|(la|0)==0))ma=1;else ga=117}else ga=117;if((ga|0)==117){if(D)na=1;else{ga=f[j+4>>2]|0;if((ga|0)<3)oa=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{la=f[j+40>>2]|0;ka=0;$=1;while(1){ja=Y(f[la+(ka<<2)>>2]|0,$)|0;ka=ka+1|0;if((ka|0)==(ga|0)){oa=ja;break}else $=ja}}na=(ga|0)==0|(oa|0)==0}ma=(na^1)&1}b[a+188>>0]=ma;ma=(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)/56|0)>>>0>1;if(ma|D)pa=ma;else{ma=f[j+4>>2]|0;if((ma|0)<3)qa=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{D=f[j+40>>2]|0;na=0;oa=1;while(1){ga=Y(f[D+(na<<2)>>2]|0,oa)|0;na=na+1|0;if((na|0)==(ma|0)){qa=ga;break}else oa=ga}}pa=(ma|0)!=0&(qa|0)!=0}b[a+189>>0]=pa&1;pa=f[J>>2]|0;J=f[pa+(v+-1<<2)>>2]|0;f[pa+(v+1<<2)>>2]=J;f[pa+(v<<2)>>2]=J;J=j+36|0;v=f[J>>2]|0;if(v|0?(pa=v+12|0,v=f[pa>>2]|0,f[pa>>2]=v+-1,(v|0)==1):0)_S(j);f[J>>2]=0;J=j+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[J>>2]|0)>0){N=f[j+40>>2]|0;v=0;do{f[N+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[J>>2]|0))}J=f[j+44>>2]|0;if((J|0)!=(j+48|0))g0(J);J=i+36|0;j=f[J>>2]|0;if(j|0?(v=j+12|0,j=f[v>>2]|0,f[v>>2]=j+-1,(j|0)==1):0)_S(i);f[J>>2]=0;J=i+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[J>>2]|0)>0){I=f[i+40>>2]|0;j=0;do{f[I+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[J>>2]|0))}J=f[i+44>>2]|0;if((J|0)==(i+48|0)){u=e;return}g0(J);u=e;return}function eqb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;if(e-g>>2>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>2;l=k>>>0<b>>>0;m=l?k:b;n=j;o=j;if(m|0){p=m;m=h;while(1){f[m>>2]=f[c>>2];p=p+-1|0;if(!p)break;else m=m+4|0}}if(l){l=b-k|0;k=o+(l<<2)|0;o=l;l=j;while(1){f[l>>2]=f[c>>2];o=o+-1|0;if(!o)break;else l=l+4|0}f[i>>2]=k;return}else{k=h+(b<<2)|0;if((n|0)==(k|0))return;f[i>>2]=n+(~((n+-4-k|0)>>>2)<<2);return}}else{k=g;if(!g)q=e;else{e=a+4|0;n=f[e>>2]|0;if((n|0)!=(h|0))f[e>>2]=n+(~((n+-4-g|0)>>>2)<<2);YDc(k);f[d>>2]=0;f[e>>2]=0;f[a>>2]=0;q=0}if(b>>>0>1073741823)mCc(a);e=q>>1;k=q>>2>>>0<536870911?(e>>>0<b>>>0?b:e):1073741823;if(k>>>0>1073741823)mCc(a);e=VDc(k<<2)|0;q=a+4|0;f[q>>2]=e;f[a>>2]=e;f[d>>2]=e+(k<<2);k=e+(b<<2)|0;d=b;b=e;while(1){f[b>>2]=f[c>>2];d=d+-1|0;if(!d)break;else b=b+4|0}f[q>>2]=k;return}}function fqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){XIc(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)mCc(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;XIc(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;YDc(h);return}function gqb(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;o=u;u=u+112|0;p=o+8|0;q=o;if((f[a+4>>2]|0)!=4){f[p>>2]=0;r=p+4|0;f[r>>2]=0;s=tT(p,35)|0;t=s;v=432848;w=t+35|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}if((f[c+4>>2]|0)!=4){f[p>>2]=0;r=p+4|0;f[r>>2]=0;s=tT(p,35)|0;t=s;v=432848;w=t+35|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}s=f[a+40>>2]|0;r=f[c+40>>2]|0;if((f[s>>2]|0)!=(f[r>>2]|0)){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,31)|0;v=432884;w=t+31|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}x=f[d+8>>2]|0;y=r+4|0;if((x|0)!=(f[y>>2]|0)){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,30)|0;v=432916;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}z=s+4|0;A=f[h>>2]|0;B=Y(A,(f[z>>2]|0)/(m|0)|0)|0;C=h+4|0;D=f[C>>2]|0;if((f[d+12>>2]|0)!=(Y(B,D)|0)){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,66)|0;v=432947;w=t+66|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}B=f[a>>2]|0;E=B&4095;F=f[c>>2]|0;if((E|0)!=(F&4095|0)){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,29)|0;v=433014;w=t+29|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}if((E|0)!=(f[d>>2]&4095|0)){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,30)|0;v=433044;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}if((E|0)!=5){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,57)|0;v=433075;w=t+57|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}if(!(B&16384)){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,20)|0;v=445114;w=t+20|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}if(!(F&16384)){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,21)|0;v=433133;w=t+21|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}if(((f[e+4>>2]|0)-(f[e>>2]|0)>>2|0)!=(x+2|0)){f[p>>2]=0;f[p+4>>2]=0;t=tT(p,42)|0;v=433155;w=t+42|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,p,453307,432302,558)}f[p>>2]=99448;v=p+4|0;x=p+8|0;F=p+12|0;B=p+32|0;t=B;w=t+68|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[v>>2]=a;f[x>>2]=d;f[F>>2]=c;f[p+16>>2]=f[r>>2];c=f[y>>2]|0;y=p+20|0;f[y>>2]=c;f[p+24>>2]=f[r+8>>2];f[p+28>>2]=f[r+12>>2];f[y>>2]=(c|0)/(m|0)|0;f[B>>2]=A;f[p+36>>2]=D;B=f[i>>2]|0;f[p+40>>2]=B;c=f[i+4>>2]|0;f[p+44>>2]=c;f[p+48>>2]=f[j>>2];f[p+52>>2]=f[j+4>>2];f[p+56>>2]=f[k>>2];j=k+4|0;f[p+60>>2]=f[j>>2];f[p+64>>2]=m;f[p+68>>2]=n;i=f[s+12>>2]|0;y=f[s+8>>2]|0;s=(f[z>>2]|0)/(m|0)|0;b[p+96>>0]=(D|A|(c|B)|0)==0&1;B=(R5(10)|0)&1;b[p+97>>0]=B;B=(R5(11)|0)&1;b[p+98>>0]=B;b[p+99>>0]=0;B=(s|0)<64?s:64;c=p+72|0;A=Y(Y(f[h>>2]|0,B)|0,f[C>>2]|0)|0;D=p+76|0;m=f[D>>2]|0;z=f[c>>2]|0;r=m-z>>2;F=z;z=m;if(A>>>0<=r>>>0)if(A>>>0<r>>>0?(m=F+(A<<2)|0,(z|0)!=(m|0)):0){f[D>>2]=z+(~((z+-4-m|0)>>>2)<<2);G=F}else G=F;else{lN(c,A-r|0);G=f[c>>2]|0}if((s|0)>0){s=0;c=f[C>>2]|0;while(1){if((c|0)>0){r=Y(s,y)|0;A=0;F=f[h>>2]|0;m=c;while(1){if((F|0)>0){z=0;d=m;x=F;while(1){a=Y((Y(f[j>>2]|0,A)|0)+r|0,i)|0;v=a+(Y(f[k>>2]|0,z)|0)|0;a=G+((Y((Y(d,s)|0)+A|0,x)|0)+z<<2)|0;f[a>>2]=v;z=z+1|0;v=f[h>>2]|0;a=f[C>>2]|0;if((z|0)>=(v|0)){H=a;I=v;break}else{d=a;x=v}}}else{H=m;I=F}A=A+1|0;if((A|0)>=(H|0)){J=H;break}else{F=I;m=H}}}else J=c;s=s+1|0;if((s|0)>=(B|0))break;else c=J}}f[p+84>>2]=e;f[p+88>>2]=g;f[p+92>>2]=(f[g>>2]|0)==(f[g+4>>2]|0)?l:0;f[q>>2]=0;f[q+4>>2]=n;y8(q,p,+(n|0));f[p>>2]=99448;n=f[p+72>>2]|0;if(!n){u=o;return}p=f[D>>2]|0;if((p|0)!=(n|0))f[D>>2]=p+(~((p+-4-n|0)>>>2)<<2);YDc(n);u=o;return}function hqb(a){a=a|0;var b=0,c=0;f[a>>2]=99448;b=f[a+72>>2]|0;if(!b)return;c=a+76|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function iqb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=99448;b=f[a+72>>2]|0;if(!b){YDc(a);return}c=a+76|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function jqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0;d=u;u=u+1072|0;e=d+1068|0;g=d+1064|0;h=d;i=f[a+64>>2]|0;j=f[a+4>>2]|0;k=f[j+40>>2]|0;l=Y(f[k>>2]|0,i)|0;m=f[a+12>>2]|0;o=f[m+40>>2]|0;p=f[o+12>>2]|0;q=(f[o+4>>2]|0)/(i|0)|0;r=f[k+12>>2]|0;s=f[k+8>>2]|0;t=(f[k+4>>2]|0)/(i|0)|0;k=f[a+68>>2]|0;v=f[a+32>>2]|0;w=f[a+36>>2]|0;x=f[a+40>>2]|0;y=f[a+44>>2]|0;z=f[a+48>>2]|0;A=f[a+52>>2]|0;B=f[a+56>>2]|0;C=f[a+60>>2]|0;D=Y(w,v)|0;E=Y(s,r)|0;F=Y(f[o+8>>2]|0,p)|0;f[e>>2]=F;o=(b[a+96>>0]|0)==0;G=f[c>>2]|0;H=f[c+4>>2]|0;if((k|0)<(l<<1|0)){c=(l+-1+k|0)/(k|0)|0;I=(c|0)>1?c:1;J=1;K=Y(I,G)|0;L=Y(I,H)|0;M=F}else{I=(k|0)/(l|0)|0;k=(((I+-1+F|0)>>>0)/(I>>>0)|0)+7&-8;f[g>>2]=k;J=I;K=G;L=H;M=F>>>0<k>>>0?f[e>>2]|0:k}f[g>>2]=M;M=f[j+16>>2]|0;j=f[a+72>>2]|0;k=f[a+8>>2]|0;F=f[k+16>>2]|0;H=((f[f[k+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[k>>2]<<2&28)&15)>>>0)|0;k=f[a+84>>2]|0;G=f[k>>2]|0;if((f[k+4>>2]|0)==(G|0))nCc(k);k=G;G=f[a+88>>2]|0;I=f[G>>2]|0;c=(I|0)==(f[G+4>>2]|0)?0:I;I=f[m+16>>2]|0;m=D<<11|8;G=h+8|0;f[h>>2]=G;N=h+4|0;f[N>>2]=m;if(m>>>0>264){O=XDc(m>>>0>1073741823?-1:m<<2)|0;f[h>>2]=O;P=O}else P=G;O=P+31&-32;P=O;XIc(O|0,0,D<<13|0)|0;a:do if((K|0)<(L|0)){O=Y(t,E)|0;m=(t|0)>0;Q=a+92|0;R=(c|0)!=0;S=s-(Y(C,w+-1|0)|0)|0;T=C+-1|0;U=s+-1+C|0;V=z<<1;W=r-(Y(B,v+-1|0)|0)|0;X=B+-1|0;Z=r+-1+B|0;_=Y(C,r)|0;$=(q|0)>0;aa=~t;ba=~p;ca=K;da=K;do{ca=ca+1|0;ea=(da|0)/(J|0)|0;if((ea|0)>=(l|0))break a;fa=Y(ea,J)|0;ga=f[g>>2]|0;ha=Y(ga,da-fa|0)|0;ia=ha+ga|0;ja=f[e>>2]|0;ka=ja>>>0<ia>>>0?ja:ia;ia=M+((Y(O,ea)|0)<<2)|0;la=I+((Y(Y(ea,q)|0,ja)|0)<<2)|0;ma=Y((ea|0)%(i|0)|0,q)|0;ea=F+((Y(ma,H)|0)<<2)|0;na=k+(ma<<2)|0;if(m){oa=c+(ma<<2)|0;pa=(ka|0)>(ha|0);qa=Y(ga,ca-fa|0)|0;fa=~(ja>>>0>qa>>>0?qa:ja);ja=-33-ha|0;qa=0;ga=-1;ra=-65;while(1){sa=((Y(D,ga-((ra|0)>(aa|0)?ra:aa)|0)|0)+7|0)>>>3;ta=qa;qa=qa+64|0;ua=((t|0)<(qa|0)?t:qa)-ta|0;va=Y(ua,D)|0;wa=va+7&-8;xa=ea+((Y(ta,D)|0)<<2)|0;ya=R&(t|0)<=(qa|0)?oa:0;if(pa){za=Y(ta,s)|0;Aa=(va|0)>0;Ba=va<<2;Ca=(ua|0)>0;Da=(ya|0)!=0;Ea=(ta|0)==0;ta=ha;Fa=ja;while(1){Ga=(Fa|0)<(fa|0)?fa:Fa;Ha=ta;ta=ta+32|0;Ia=(ka|0)<(ta|0)?ka:ta;Ja=(Ha|0)/(p|0)|0;if((Ia|0)>(Ha|0)){Ka=Ha;La=Ja;Ma=Ha-(Y(Ja,p)|0)|0;Ja=P;while(1){Na=Ia-Ka|0;Oa=p-Ma|0;Pa=(Oa|0)<(Na|0)?Oa:Na;Na=Pa+Ma|0;Oa=(Y(La,A)|0)-y|0;Qa=(Y(Ma,z)|0)-x|0;Ra=ia+((Y(Oa+za|0,r)|0)<<2)+(Qa<<2)|0;do if(o){Sa=(Oa|0)>-1&(Oa|0)<(S|0);Ta=(T-Oa|0)/(C|0)|0;Ua=(Ta|0)>0?Ta:0;Ta=(U-Oa|0)/(C|0)|0;Va=(Ta|0)<(w|0)?Ta:w;if((Pa|0)>0){Ta=(Ua|0)<(Va|0);Wa=Ra;Xa=Ma;Ya=Ja;Za=Qa;while(1){do if(Sa){if((Xa+2|0)>(Na|0)|(Za|0)<0|(Za+V|0)>(W|0)){_a=34;break}if(Aa){$a=0;do{ab=f[j+($a<<2)>>2]|0;bb=f[Wa+(ab+z<<2)>>2]|0;f[Ya+($a<<2)>>2]=f[Wa+(ab<<2)>>2];f[Ya+($a+wa<<2)>>2]=bb;$a=$a+1|0}while(($a|0)<(va|0))}cb=Za+z|0;db=Wa+(z<<2)|0;eb=Xa+1|0;fb=Ya+(wa<<2)|0}else _a=34;while(0);do if((_a|0)==34){_a=0;$a=(X-Za|0)/(B|0)|0;bb=($a|0)>0?$a:0;$a=(Z-Za|0)/(B|0)|0;ab=($a|0)<(v|0)?$a:v;XIc(Ya|0,0,Ba|0)|0;if(!Ca){cb=Za;db=Wa;eb=Xa;fb=Ya;break}$a=(bb|0)<(ab|0);if(Ta)gb=0;else{cb=Za;db=Wa;eb=Xa;fb=Ya;break}do{hb=Y(gb,E)|0;ib=Y(gb,w)|0;if($a){jb=Ua;do{kb=(Y(_,jb)|0)+hb|0;lb=Y(jb+ib|0,v)|0;mb=bb;do{nb=Wa+(kb+(Y(mb,B)|0)<<2)|0;f[Ya+(mb+lb<<2)>>2]=f[nb>>2];mb=mb+1|0}while((mb|0)<(ab|0));jb=jb+1|0}while((jb|0)<(Va|0))}gb=gb+1|0}while((gb|0)<(ua|0));cb=Za;db=Wa;eb=Xa;fb=Ya}while(0);Xa=eb+1|0;ab=fb+(wa<<2)|0;if((Xa|0)>=(Na|0)){ob=ab;break}else{Wa=db+(z<<2)|0;Ya=ab;Za=cb+z|0}}}else ob=Ja}else if((Pa|0)>0){if(Aa){pb=Ra;qb=Ma;rb=Ja}else{Za=Ma+ba|0;Ya=Ga+Ka|0;Wa=Ma+-1-((Za|0)>(Ya|0)?Za:Ya)|0;Ya=Ma+1|0;ob=Ja+(Y(sa,((Wa|0)>(Ya|0)?Wa:Ya)-Ma<<5)|0)|0;break}while(1){Ya=0;do{Wa=pb+((Y(Ya,E)|0)<<2)|0;f[rb+(Ya<<2)>>2]=f[Wa>>2];Ya=Ya+1|0}while((Ya|0)<(va|0));qb=qb+1|0;Ya=rb+(wa<<2)|0;if((qb|0)>=(Na|0)){ob=Ya;break}else{pb=pb+(z<<2)|0;rb=Ya}}}else ob=Ja;while(0);Ka=Pa+Ka|0;if((Ia|0)<=(Ka|0))break;else{La=La+1|0;Ma=0;Ja=ob}}}Ja=Ia-Ha|0;if($){Ma=la+(Ha<<2)|0;La=(Ja|0)>0;Ka=0;do{Ga=xa+((Y(Ka,H)|0)<<2)|0;Na=f[e>>2]|0;Ra=Ma+((Y(Na,Ka)|0)<<2)|0;sb=+n[na+(Ka<<2)>>2];Qa=Ka|1;Oa=(Qa|0)>=(q|0);Ya=Oa?Ga:Ga+(H<<2)|0;Wa=Oa?Ra:Ra+(Na<<2)|0;tb=Oa?sb:+n[na+(Qa<<2)>>2];if(Da){ub=+n[ya+(Ka<<2)>>2];vb=Oa?ub:+n[ya+(Qa<<2)>>2];wb=ub}else{vb=1.0;wb=1.0}if(La)if(Ea){Qa=0;do{Oa=P+((Y(Qa,wa)|0)<<2)|0;if(Aa){ub=sb;xb=tb;Na=0;while(1){yb=+n[Oa+(Na<<2)>>2];zb=ub+yb*+n[Ga+(Na<<2)>>2];Ab=xb+yb*+n[Ya+(Na<<2)>>2];Na=Na+1|0;if((Na|0)>=(va|0)){Bb=Ab;Cb=zb;break}else{ub=zb;xb=Ab}}}else{Bb=tb;Cb=sb}n[Ra+(Qa<<2)>>2]=Da?(Cb>0.0?Cb:wb*Cb):Cb;n[Wa+(Qa<<2)>>2]=Da?(Bb>0.0?Bb:vb*Bb):Bb;Qa=Qa+1|0}while((Qa|0)<(Ja|0))}else{Qa=0;do{Pa=P+((Y(Qa,wa)|0)<<2)|0;Na=Wa+(Qa<<2)|0;Oa=Ra+(Qa<<2)|0;sb=+n[Oa>>2];tb=+n[Na>>2];if(Aa){xb=sb;ub=tb;Za=0;while(1){Ab=+n[Pa+(Za<<2)>>2];zb=xb+Ab*+n[Ga+(Za<<2)>>2];yb=ub+Ab*+n[Ya+(Za<<2)>>2];Za=Za+1|0;if((Za|0)>=(va|0)){Db=yb;Eb=zb;break}else{xb=zb;ub=yb}}}else{Db=tb;Eb=sb}n[Oa>>2]=Da?(Eb>0.0?Eb:wb*Eb):Eb;n[Na>>2]=Da?(Db>0.0?Db:vb*Db):Db;Qa=Qa+1|0}while((Qa|0)<(Ja|0))}Ka=Ka+2|0}while((Ka|0)<(q|0))}if((ta|0)>=(ka|0))break;else Fa=Fa+-32|0}}if((qa|0)>=(t|0))break;else{ga=ga+-64|0;ra=ra+-64|0}}}ra=f[Q>>2]|0;if(ra|0){ga=la+(ha<<2)|0;Ii[f[(f[ra>>2]|0)+100>>2]&127](ra,ga,ga,ka-ha|0,f[e>>2]|0,ma,ma+q|0)}da=da+1|0}while((da|0)<(L|0))}while(0);L=f[h>>2]|0;if((L|0)==(G|0)){u=d;return}if(L|0)ZDc(L);f[h>>2]=G;f[N>>2]=264;u=d;return}function kqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+64|0;g=e+44|0;h=e+32|0;i=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e;f[g>>2]=0;o=g+4|0;f[o>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=f[o>>2]|0;o=f[g>>2]|0;c=o;if((d|0)==(o|0)){f[i>>2]=0;f[i+4>>2]=0;p=tT(i,17)|0;q=449134;r=p+17|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,95)}s=f[a+4>>2]|0;t=(f[a+8>>2]|0)-s|0;v=s;if(!((t|0)!=0&((t|0)/56|0)>>>0<3)){f[i>>2]=0;f[i+4>>2]=0;p=tT(i,38)|0;q=433359;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,97)}if((f[v+4>>2]|0)!=4){f[i>>2]=0;w=i+4|0;f[w>>2]=0;x=tT(i,91)|0;p=x;q=433398;r=p+91|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,98)}t=f[v+40>>2]|0;v=a+36|0;if((f[t+12>>2]|0)!=(f[v>>2]|0)){f[i>>2]=0;w=i+4|0;f[w>>2]=0;x=tT(i,91)|0;p=x;q=433398;r=p+91|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,98)}if((f[t+8>>2]|0)!=(f[a+40>>2]|0)){f[i>>2]=0;w=i+4|0;f[w>>2]=0;x=tT(i,91)|0;p=x;q=433398;r=p+91|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,98)}if((f[c+4>>2]|0)!=4){f[i>>2]=0;y=i+4|0;f[y>>2]=0;z=tT(i,95)|0;p=z;q=433490;r=p+95|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,101)}x=f[c>>2]|0;switch(x&4095){case 3:case 6:case 5:break;default:{f[i>>2]=0;y=i+4|0;f[y>>2]=0;z=tT(i,95)|0;p=z;q=433490;r=p+95|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,101)}}z=c+40|0;y=(d-o|0)/56|0;o=0;while(1){if((f[c+(o*56|0)+4>>2]|0)!=4){A=19;break}d=f[c+(o*56|0)+40>>2]|0;w=f[z>>2]|0;if((f[d+4>>2]|0)!=(f[w+4>>2]|0)){A=19;break}B=f[d+8>>2]|0;if((B|0)!=(f[w+8>>2]|0)){A=22;break}C=f[d+12>>2]|0;o=o+1|0;if((C|0)!=(f[w+12>>2]|0)){A=22;break}if(o>>>0>=y>>>0){A=15;break}if((x^f[c+(o*56|0)>>2])&4095|0){A=16;break}}if((A|0)==15){o=f[(f[h>>2]|0)+40>>2]|0;c=f[o+8>>2]|0;f[i>>2]=f[o+12>>2];f[i+4>>2]=c;c=a+56|0;o=f[c>>2]|0;f[j>>2]=o;x=a+52|0;y=f[x>>2]|0;f[k>>2]=y;f[l>>2]=o;f[m>>2]=y;f[n>>2]=C;f[n+4>>2]=B;Izb(n,i,v,a+44|0,a+76|0,a+60|0,j,k,l,m);a=f[j>>2]|0;if((a|0)!=(f[l>>2]|0)){f[n>>2]=0;D=n+4|0;f[D>>2]=0;E=tT(n,51)|0;p=E;q=433750;r=p+51|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-213,n,453718,432302,118)}l=f[k>>2]|0;if((l|0)==(f[m>>2]|0)){f[x>>2]=l;f[c>>2]=a;mx(h);mx(g);u=e;return}else{f[n>>2]=0;D=n+4|0;f[D>>2]=0;E=tT(n,51)|0;p=E;q=433750;r=p+51|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-213,n,453718,432302,118)}}else if((A|0)==16){f[i>>2]=0;f[i+4>>2]=0;p=tT(i,32)|0;q=433586;r=p+32|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,104)}else if((A|0)==19){f[i>>2]=0;f[i+4>>2]=0;p=tT(i,57)|0;q=433619;r=p+57|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,105)}else if((A|0)==22){f[i>>2]=0;f[i+4>>2]=0;p=tT(i,72)|0;q=433677;r=p+72|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,i,453718,432302,106)}}function lqb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>3>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>3;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=m;m=h;while(1){p[m>>3]=+p[c>>3];j=j+-1|0;if(!j)break;else m=m+8|0}}if(!l){m=h+(b<<3)|0;if((n|0)==(m|0))return;else{o=i;q=n+(~((n+-8-m|0)>>>3)<<3)|0;break}}else{m=b-k|0;j=m;r=n;while(1){p[r>>3]=+p[c>>3];j=j+-1|0;if(!j)break;else r=r+8|0}o=i;q=n+(m<<3)|0;break}}else{r=g;if(!g)s=e;else{j=a+4|0;k=f[j>>2]|0;if((k|0)!=(h|0))f[j>>2]=k+(~((k+-8-g|0)>>>3)<<3);YDc(r);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;s=0}if(b>>>0>536870911)mCc(a);j=s>>2;r=s>>3>>>0<268435455?(j>>>0<b>>>0?b:j):536870911;if(r>>>0>536870911)mCc(a);j=VDc(r<<3)|0;k=a+4|0;f[k>>2]=j;f[a>>2]=j;f[d>>2]=j+(r<<3);r=b;l=j;while(1){p[l>>3]=+p[c>>3];r=r+-1|0;if(!r)break;else l=l+8|0}o=k;q=j+(b<<3)|0}while(0);f[o>>2]=q;return}function mqb(a){a=a|0;f[a>>2]=99468;uT(a+76|0);REa(a);return}function nqb(a){a=a|0;f[a>>2]=99468;uT(a+76|0);REa(a);YDc(a);return}function oqb(a){a=a|0;f[a>>2]=99468;uT(a+76|0);REa(a);YDc(a);return}function pqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=VDc(296)|0;Ppb(c,b);f[c>>2]=99688;f[c+88>>2]=1124007936;b=c+96|0;d=c+128|0;e=c+92|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=b;b=c+136|0;f[c+132>>2]=b;f[b>>2]=0;f[c+140>>2]=0;f[c+144>>2]=1124007936;b=c+152|0;d=c+184|0;e=c+148|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=b;b=c+192|0;f[c+188>>2]=b;f[b>>2]=0;f[c+196>>2]=0;f[c+200>>2]=1124007936;b=c+204|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[c+232>>2]=c+208;b=c+240|0;f[c+236>>2]=b;f[c+244>>2]=0;f[b>>2]=0;f[c+248>>2]=1124007936;b=c+252|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[c+280>>2]=c+256;b=c+288|0;f[c+284>>2]=b;f[c+292>>2]=0;f[b>>2]=0;b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=99800;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function qqb(a){a=a|0;YDc(a);return}function rqb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function sqb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=99688;GQ(a+248|0);GQ(a+200|0);b=a+144|0;c=a+180|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+160|0;b=a+148|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+184>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+188>>2]|0;if((b|0)!=(a+192|0))g0(b);b=a+88|0;d=a+124|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+104|0;b=a+92|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+128>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+132>>2]|0;if((b|0)==(a+136|0)){f[a>>2]=99468;g=a+76|0;uT(g);REa(a);return}g0(b);f[a>>2]=99468;g=a+76|0;uT(g);REa(a);return}function tqb(a){a=a|0;sqb(a);YDc(a);return}function uqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+64|0;g=e+44|0;h=e+32|0;i=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+8|0;n=e;kqb(a,c,d);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=a+56|0;c=f[d>>2]|0;f[i>>2]=c;o=a+52|0;p=f[o>>2]|0;f[j>>2]=p;f[k>>2]=c;f[l>>2]=p;p=f[(f[h>>2]|0)+40>>2]|0;c=f[p+8>>2]|0;f[m>>2]=f[p+12>>2];f[m+4>>2]=c;c=f[(f[g>>2]|0)+40>>2]|0;p=f[c+8>>2]|0;f[n>>2]=f[c+12>>2];f[n+4>>2]=p;Izb(m,n,a+36|0,a+44|0,a+76|0,a+60|0,i,j,k,l);a=f[i>>2]|0;if((a|0)!=(f[k>>2]|0)){f[m>>2]=0;q=m+4|0;f[q>>2]=0;r=tT(m,51)|0;s=r;t=433750;v=s+51|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-213,m,453718,432302,1207)}k=f[j>>2]|0;if((k|0)==(f[l>>2]|0)){f[o>>2]=k;f[d>>2]=a;mx(h);mx(g);u=e;return}else{f[m>>2]=0;q=m+4|0;f[q>>2]=0;r=tT(m,51)|0;s=r;t=433750;v=s+51|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-213,m,453718,432302,1207)}}function vqb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0;g=u;u=u+752|0;h=g+680|0;i=g+624|0;j=g+608|0;k=g+596|0;l=g+584|0;m=g+528|0;n=g;o=g+472|0;p=g+416|0;q=g+360|0;r=g+304|0;s=g+248|0;t=g+224|0;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f$(c,j);f$(d,k);f$(e,l);e=f[a+84>>2]|0;d=f[(f[(f[j>>2]|0)+40>>2]|0)+4>>2]|0;c=a+40|0;if(((((f[c>>2]|0)==1?(f[a+36>>2]|0)==1:0)?(f[a+48>>2]|0)==1:0)?(f[a+44>>2]|0)==1:0)?(f[a+64>>2]|0)==1:0)w=(f[a+60>>2]|0)==1;else w=0;x=z8()|0;y=a+88|0;if(f[a+104>>2]|0){z=f[a+92>>2]|0;if((z|0)<3)A=Y(f[a+100>>2]|0,f[a+96>>2]|0)|0;else{B=f[a+128>>2]|0;C=0;D=1;while(1){E=Y(f[B+(C<<2)>>2]|0,D)|0;C=C+1|0;if((C|0)==(z|0)){A=E;break}else D=E}}if((z|0)==0|(A|0)==0)F=17}else F=17;if((F|0)==17){lT(i,f[a+4>>2]|0,1,d);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=i;A=m+8|0;f[A>>2]=0;f[A+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=y;jR(h,m);A=i+36|0;z=f[A>>2]|0;if(z|0?(D=z+12|0,z=f[D>>2]|0,f[D>>2]=z+-1,(z|0)==1):0)_S(i);f[A>>2]=0;A=i+16|0;z=i+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[z>>2]|0)>0){A=f[i+40>>2]|0;D=0;do{f[A+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[z>>2]|0))}z=f[i+44>>2]|0;if((z|0)!=(i+48|0))g0(z);z=f[a+4>>2]|0;if((((f[a+8>>2]|0)-z|0)/56|0)>>>0>1){lT(h,z+56|0,1,e);G=0}else{AY(n,e,1,5);f[h>>2]=1124007936;z=h+8|0;D=h+40|0;A=h+4|0;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[D>>2]=z;z=h+48|0;f[h+44>>2]=z;f[z>>2]=0;f[h+52>>2]=0;z=f[n>>2]|0;ei[f[(f[z>>2]|0)+12>>2]&511](z,n,h,-1);G=1}z=a+144|0;D=h+36|0;A=f[D>>2]|0;if((z|0)==(h|0))H=A;else{if(A|0){C=A+12|0;f[C>>2]=(f[C>>2]|0)+1}C=a+180|0;A=f[C>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)_S(z);f[C>>2]=0;A=a+160|0;B=a+148|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){E=f[a+184>>2]|0;I=0;do{f[E+(I<<2)>>2]=0;I=I+1|0;J=f[B>>2]|0}while((I|0)<(J|0));f[z>>2]=f[h>>2];if((J|0)<3)F=39;else F=41}else{f[z>>2]=f[h>>2];F=39}if((F|0)==39){J=f[h+4>>2]|0;if((J|0)<3){f[B>>2]=J;f[a+152>>2]=f[h+8>>2];f[a+156>>2]=f[h+12>>2];J=f[h+44>>2]|0;B=f[a+188>>2]|0;f[B>>2]=f[J>>2];f[B+4>>2]=f[J+4>>2]}else F=41}if((F|0)==41)ZS(z,h);f[A>>2]=f[h+16>>2];f[a+164>>2]=f[h+20>>2];f[a+168>>2]=f[h+24>>2];f[a+172>>2]=f[h+28>>2];f[a+176>>2]=f[h+32>>2];A=f[D>>2]|0;f[C>>2]=A;H=A}if(H|0?(A=H+12|0,H=f[A>>2]|0,f[A>>2]=H+-1,(H|0)==1):0)_S(h);f[D>>2]=0;D=h+16|0;H=h+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[H>>2]|0)>0){D=f[h+40>>2]|0;A=0;do{f[D+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[H>>2]|0))}H=f[h+44>>2]|0;if((H|0)!=(h+48|0))g0(H);if(G)$j(n)}if((f[v>>2]|0)!=(f[k>>2]|0)){n=a+4|0;G=o+36|0;H=o+16|0;A=o+4|0;D=o+40|0;C=o+44|0;z=o+48|0;F=m+36|0;J=m+16|0;B=m+4|0;I=m+40|0;E=m+44|0;K=m+48|0;L=i+4|0;M=h+4|0;N=i+4|0;O=h+4|0;P=i+4|0;Q=h+4|0;R=a+144|0;S=i+4|0;T=h+4|0;U=t+4|0;V=t+8|0;W=t+12|0;X=t+16|0;Z=t+20|0;_=t+21|0;$=t+22|0;aa=h+4|0;ba=+(x|0);ca=a+36|0;da=a+56|0;ea=a+52|0;fa=a+48|0;ga=a+44|0;a=p+16|0;ha=p+44|0;ia=s+16|0;ja=s+44|0;ka=w&1;la=h+4|0;ma=h+48|0;na=h+12|0;oa=h+16|0;pa=h+20|0;qa=h+24|0;ra=h+28|0;sa=h+32|0;ta=h+36|0;ua=h+40|0;va=h+44|0;wa=h+52|0;xa=h+56|0;ya=h+60|0;za=h+64|0;Aa=h+8|0;Ba=i+4|0;Ca=s+36|0;Da=s+4|0;Ea=s+40|0;Fa=s+48|0;Ga=r+36|0;Ha=r+16|0;Ia=r+4|0;Ja=r+40|0;Ka=r+44|0;La=r+48|0;Ma=q+36|0;Na=q+16|0;Oa=q+4|0;Pa=q+40|0;Qa=q+44|0;Ra=q+48|0;Sa=p+36|0;Ta=p+4|0;Ua=p+40|0;Va=p+48|0;Wa=0;Xa=f[k>>2]|0;do{Ya=f[(f[(f[n>>2]|0)+40>>2]|0)+4>>2]|0;Za=(e|0)/(Ya|0)|0;_a=(d|0)/(Za|0)|0;$a=f[j>>2]|0;ab=f[$a+(Wa*56|0)+40>>2]|0;bb=f[ab>>2]|0;cb=f[ab+8>>2]|0;db=f[ab+12>>2]|0;ab=f[Xa+(Wa*56|0)+40>>2]|0;eb=f[ab+8>>2]|0;fb=f[ab+12>>2]|0;lT(m,$a+(Wa*56|0)|0,1,Y(bb,d)|0);lT(o,Xa+(Wa*56|0)|0,1,Y(bb,e)|0);if((bb|0)>0){$a=(Za|0)>0;ab=0;do{if($a){gb=Y(ab,Za)|0;hb=0;do{ib=hb+gb|0;jb=Y(ib,Ya)|0;f[i>>2]=jb;f[L>>2]=jb+Ya;f[h>>2]=-2147483648;f[M>>2]=2147483647;$S(p,o,i,h);jb=w?p:f[l>>2]|0;kb=Y(ib,_a)|0;f[i>>2]=kb;f[N>>2]=kb+_a;f[h>>2]=-2147483648;f[O>>2]=2147483647;$S(q,m,i,h);kb=Y(hb,_a)|0;f[i>>2]=kb;f[P>>2]=kb+_a;f[h>>2]=-2147483648;f[Q>>2]=2147483647;$S(r,y,h,i);kb=Y(hb,Ya)|0;f[i>>2]=kb;f[S>>2]=kb+Ya;f[h>>2]=-2147483648;f[T>>2]=2147483647;$S(s,R,i,h);f[t>>2]=99820;f[U>>2]=r;f[V>>2]=q;f[W>>2]=jb;f[X>>2]=x;kb=(R5(10)|0)&1;b[Z>>0]=kb;kb=(R5(11)|0)&1;b[_>>0]=kb;b[$>>0]=0;f[h>>2]=0;f[aa>>2]=x;y8(h,t,ba);kb=f[jb+16>>2]|0;jb=f[c>>2]|0;ib=f[ca>>2]|0;lb=f[da>>2]|0;mb=f[ea>>2]|0;nb=f[fa>>2]|0;ob=f[ga>>2]|0;pb=f[a>>2]|0;qb=f[ia>>2]|0;rb=z8()|0;f[h>>2]=99840;f[la>>2]=kb;f[ma>>2]=pb;f[na>>2]=Ya;f[oa>>2]=eb;f[pa>>2]=fb;f[qa>>2]=jb;f[ra>>2]=ib;f[sa>>2]=lb;f[ta>>2]=mb;f[ua>>2]=nb;f[va>>2]=ob;f[wa>>2]=cb;f[xa>>2]=db;f[ya>>2]=rb;b[za>>0]=ka;f[Aa>>2]=qb;f[i>>2]=0;f[Ba>>2]=rb;y8(i,h,+(rb|0));rb=f[Ca>>2]|0;if(rb|0?(qb=rb+12|0,rb=f[qb>>2]|0,f[qb>>2]=rb+-1,(rb|0)==1):0)_S(s);f[Ca>>2]=0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[Da>>2]|0)>0){rb=f[Ea>>2]|0;qb=0;do{f[rb+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[Da>>2]|0))}qb=f[ja>>2]|0;if((qb|0)!=(Fa|0))g0(qb);qb=f[Ga>>2]|0;if(qb|0?(rb=qb+12|0,qb=f[rb>>2]|0,f[rb>>2]=qb+-1,(qb|0)==1):0)_S(r);f[Ga>>2]=0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;if((f[Ia>>2]|0)>0){qb=f[Ja>>2]|0;rb=0;do{f[qb+(rb<<2)>>2]=0;rb=rb+1|0}while((rb|0)<(f[Ia>>2]|0))}rb=f[Ka>>2]|0;if((rb|0)!=(La|0))g0(rb);rb=f[Ma>>2]|0;do if(rb|0){qb=rb+12|0;ob=f[qb>>2]|0;f[qb>>2]=ob+-1;if((ob|0)!=1)break;_S(q)}while(0);f[Ma>>2]=0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;if((f[Oa>>2]|0)>0){rb=f[Pa>>2]|0;ob=0;do{f[rb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[Oa>>2]|0))}ob=f[Qa>>2]|0;if((ob|0)!=(Ra|0))g0(ob);ob=f[Sa>>2]|0;do if(ob|0){rb=ob+12|0;qb=f[rb>>2]|0;f[rb>>2]=qb+-1;if((qb|0)!=1)break;_S(p)}while(0);f[Sa>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[Ta>>2]|0)>0){ob=f[Ua>>2]|0;qb=0;do{f[ob+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[Ta>>2]|0))}qb=f[ha>>2]|0;if((qb|0)!=(Va|0))g0(qb);hb=hb+1|0}while((hb|0)<(Za|0))}ab=ab+1|0}while((ab|0)<(bb|0))}bb=f[G>>2]|0;if(bb|0?(ab=bb+12|0,bb=f[ab>>2]|0,f[ab>>2]=bb+-1,(bb|0)==1):0)_S(o);f[G>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[A>>2]|0)>0){bb=f[D>>2]|0;ab=0;do{f[bb+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[A>>2]|0))}ab=f[C>>2]|0;if((ab|0)!=(z|0))g0(ab);ab=f[F>>2]|0;if(ab|0?(bb=ab+12|0,ab=f[bb>>2]|0,f[bb>>2]=ab+-1,(ab|0)==1):0)_S(m);f[F>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[B>>2]|0)>0){ab=f[I>>2]|0;bb=0;do{f[ab+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[B>>2]|0))}bb=f[E>>2]|0;if((bb|0)!=(K|0))g0(bb);Wa=Wa+1|0;Xa=f[k>>2]|0}while(Wa>>>0<(((f[v>>2]|0)-Xa|0)/56|0)>>>0)}mx(l);mx(k);mx(j);u=g;return}function wqb(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function xqb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function yqb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function zqb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+48|0;h=d+32|0;i=d+16|0;j=d;k=a+4|0;l=a+8|0;m=f[k>>2]|0;n=m;if((((f[l>>2]|0)-m|0)/56|0)>>>0>1){m=f[n+60>>2]|0;if((m|0)<3)o=Y(f[n+68>>2]|0,f[n+64>>2]|0)|0;else{p=f[n+96>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(m|0)){o=s;break}else r=s}}if((o|0)!=(f[a+84>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,51)|0;v=434195;w=t+51|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452925,432302,1146)}}o=f[c+4>>2]|0;r=f[c>>2]|0;if((o|0)==(r|0)){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,18)|0;v=452906;w=t+18|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452925,432302,1147)}m=f[r>>2]|0;q=f[m+4>>2]|0;p=f[m+8>>2]|0;s=f[m+12>>2]|0;x=a+80|0;y=f[x>>2]|0;do if(!y){z=Y(f[a+48>>2]|0,p+-1|0)|0;A=Y(f[a+44>>2]|0,s+-1|0)|0;B=z+(f[a+40>>2]|0)-(f[a+56>>2]<<1)+(f[a+72>>2]|0)|0;C=A+(f[a+36>>2]|0)-(f[a+52>>2]<<1)|0}else{A=a+76|0;z=f[A>>2]|0;if((z|0)!=450782?(D=(z|0)==0?1154740:z,Ioc(D,450782)|0):0){if((z|0)!=450788?Ioc(D,450788)|0:0){f[h>>2]=0;f[h+4>>2]=0;tT(h,y+25|0)|0;D=f[h>>2]|0;t=D;v=434247;w=t+25|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z=f[x>>2]|0;if(!z)z5(-2,h,452925,432302,1170);dJc(D+25|0,f[A>>2]|0,z|0)|0;z5(-2,h,452925,432302,1170)}z=(Y(f[a+48>>2]|0,p+-1|0)|0)+1|0;B=z+(f[a+72>>2]|0)|0;C=(Y(f[a+44>>2]|0,s+-1|0)|0)+1|0;break}z=Y(f[a+48>>2]|0,p+-1|0)|0;E=Y(f[a+44>>2]|0,s+-1|0)|0;B=z+(f[a+40>>2]|0)+(f[a+72>>2]|0)|0;C=E+(f[a+36>>2]|0)|0}while(0);s=(f[a+68>>2]|0)+C|0;C=f[a+84>>2]|0;p=f[n+40>>2]|0;n=f[p+4>>2]|0;if((C|0)%(n|0)|0|0){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,29)|0;v=434273;w=t+29|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452925,432302,1174)}x=(C|0)/(n|0)|0;if((q|0)%(x|0)|0|0){f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,44)|0;t=G;v=434303;w=t+44|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452925,432302,1177)}if((C|0)%(x|0)|0|0){f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,44)|0;t=G;v=434303;w=t+44|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452925,432302,1177)}if((f[p>>2]|0)!=(q|0)){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,25)|0;v=434348;w=t+25|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452925,432302,1178)}f[i>>2]=f[m>>2];f[i+4>>2]=C;f[i+8>>2]=B;f[i+12>>2]=s;C=(o-r|0)/12|0;f[h>>2]=0;r=h+4|0;f[r>>2]=0;f[h+8>>2]=0;lFa(h,i,i+16|0);i=e+4|0;o=f[i>>2]|0;m=f[e>>2]|0;v=(o-m|0)/12|0;t=m;m=o;if(C>>>0<=v>>>0){if(C>>>0<v>>>0?(o=t+(C*12|0)|0,(m|0)!=(o|0)):0){t=m;while(1){m=t+-12|0;f[i>>2]=m;w=f[m>>2]|0;if(!w)H=m;else{m=t+-8|0;q=f[m>>2]|0;if((q|0)!=(w|0))f[m>>2]=q+(~((q+-4-w|0)>>>2)<<2);YDc(w);H=f[i>>2]|0}if((H|0)==(o|0))break;else t=H}}}else npb(e,C-v|0,h);v=f[h>>2]|0;if(v|0){C=f[r>>2]|0;if((C|0)!=(v|0))f[r>>2]=C+(~((C+-4-v|0)>>>2)<<2);YDc(v)}f[h>>2]=0;v=h+4|0;f[v>>2]=0;f[h+8>>2]=0;C=g+4|0;r=f[C>>2]|0;H=g+8|0;if((r|0)==(f[H>>2]|0)){OGa(g,h);I=f[h>>2]|0}else{f[r>>2]=0;t=r+4|0;f[t>>2]=0;f[r+8>>2]=0;o=f[h>>2]|0;i=(f[v>>2]|0)-o|0;w=i>>2;if(w){if(w>>>0>1073741823)mCc(r);q=VDc(i)|0;f[t>>2]=q;f[r>>2]=q;f[r+8>>2]=q+(w<<2);w=f[h>>2]|0;r=(f[v>>2]|0)-w|0;if((r|0)>0){dJc(q|0,w|0,r|0)|0;f[t>>2]=q+(r>>>2<<2);J=w}else J=w}else J=o;f[C>>2]=(f[C>>2]|0)+12;I=J}if(I|0){J=f[v>>2]|0;if((J|0)!=(I|0))f[v>>2]=J+(~((J+-4-I|0)>>>2)<<2);YDc(I)}if(!((((((f[a+40>>2]|0)==1?(f[a+36>>2]|0)==1:0)?(f[a+48>>2]|0)==1:0)?(f[a+44>>2]|0)==1:0)?(f[a+64>>2]|0)==1:0)?(f[a+60>>2]|0)==1:0)){ei[f[(f[a>>2]|0)+100>>2]&511](h,a,f[c>>2]|0,f[e>>2]|0);e=f[g>>2]|0;if((e|0)!=(h|0))xxa(e,f[h>>2]|0,f[h+4>>2]|0);e=f[h>>2]|0;if(e|0){c=h+4|0;a=f[c>>2]|0;if((a|0)!=(e|0))f[c>>2]=a+(~((a+-4-e|0)>>>2)<<2);YDc(e)}}if((((f[l>>2]|0)-(f[k>>2]|0)|0)/56|0)>>>0<=1){u=d;return 0}k=Y(s,B)|0;f[h>>2]=1;f[h+4>>2]=k;f[h+8>>2]=-1;f[h+12>>2]=-1;f[j>>2]=0;k=j+4|0;f[k>>2]=0;f[j+8>>2]=0;lFa(j,h,h+16|0);h=f[j>>2]|0;B=f[k>>2]|0;a:do if((h|0)==(B|0)){K=h;L=70}else{s=h;do{if((f[s>>2]|0)<0){K=s;L=70;break a}s=s+4|0}while((s|0)!=(B|0))}while(0);if((L|0)==70?(K|0)!=(B|0):0){L=K+4|0;if((L|0)==(B|0)){M=B;N=K}else{h=L;L=K;while(1){K=f[h>>2]|0;if((K|0)<0)O=L;else{f[L>>2]=K;O=L+4|0}h=h+4|0;if((h|0)==(B|0))break;else L=O}M=f[k>>2]|0;N=O}if((N|0)!=(M|0))f[k>>2]=M+(~((M+-4-N|0)>>>2)<<2)}N=f[C>>2]|0;if((N|0)==(f[H>>2]|0)){OGa(g,j);P=f[j>>2]|0}else{f[N>>2]=0;g=N+4|0;f[g>>2]=0;f[N+8>>2]=0;H=f[j>>2]|0;M=(f[k>>2]|0)-H|0;O=M>>2;if(O){if(O>>>0>1073741823)mCc(N);L=VDc(M)|0;f[g>>2]=L;f[N>>2]=L;f[N+8>>2]=L+(O<<2);O=f[j>>2]|0;j=(f[k>>2]|0)-O|0;if((j|0)>0){dJc(L|0,O|0,j|0)|0;f[g>>2]=L+(j>>>2<<2);Q=O}else Q=O}else Q=H;f[C>>2]=(f[C>>2]|0)+12;P=Q}if(P|0){Q=f[k>>2]|0;if((Q|0)!=(P|0))f[k>>2]=Q+(~((Q+-4-P|0)>>>2)<<2);YDc(P)}u=d;return 0}function Aqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e;h=f[c+4>>2]|0;i=f[c>>2]|0;c=h-i|0;j=i;if((c|0)!=((f[d+4>>2]|0)-(f[d>>2]|0)|0)){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,31)|0;l=434865;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,g,445611,432302,1723)}if((h|0)==(i|0)){n=0;o=0;J=n;u=e;return o|0}i=f[f[(f[a+4>>2]|0)+40>>2]>>2]|0;h=jJc(i|0,((i|0)<0)<<31>>31|0,1)|0;i=Y(f[a+40>>2]|0,f[a+36>>2]|0)|0;a=mJc(h|0,J|0,i|0,((i|0)<0)<<31>>31|0)|0;i=J;h=(c|0)/12|0;p=0.0;c=0;do{d=f[j+(c*12|0)+4>>2]|0;q=f[j+(c*12|0)>>2]|0;r=d-q|0;s=r>>2;t=q;if((t|0)!=(d|0)){if((r|0)<=-4){v=10;break}if((r|0)>0){r=0;d=1;while(1){q=Y(f[t+(r<<2)>>2]|0,d)|0;r=r+1|0;if((r|0)>=(s|0)){w=q;break}else d=q}}else w=1}else w=0;d=mJc(a|0,i|0,w|0,((w|0)<0)<<31>>31|0)|0;p=p+(+(d>>>0)+4294967296.0*+(J|0));c=c+1|0}while(c>>>0<h>>>0);if((v|0)==10){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,70)|0;l=452744;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,g,452815,452821,161)}n=+L(p)>=1.0?(p>0.0?~~+Z(+K(p/4294967296.0),4294967295.0)>>>0:~~+X((p-+(~~p>>>0))/4294967296.0)>>>0):0;o=~~p>>>0;J=n;u=e;return o|0}function Bqb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;c=Y(f[b+40>>2]|0,(f[(f[d>>2]|0)+4>>2]|0)/((f[h+4>>2]|0)/(f[f[(f[b+4>>2]|0)+40>>2]>>2]|0)|0|0)|0)|0;d=Y(c,f[b+36>>2]|0)|0;b=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;f[g>>2]=d;f[g+4>>2]=b;f[g+8>>2]=-1;f[g+12>>2]=-1;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;lFa(a,g,g+16|0);g=f[a>>2]|0;a=f[b>>2]|0;a:do if((g|0)==(a|0))i=g;else{d=g;do{if((f[d>>2]|0)<0){i=d;break a}d=d+4|0}while((d|0)!=(a|0));u=e;return}while(0);if((i|0)==(a|0)){u=e;return}g=i+4|0;if((g|0)==(a|0)){j=a;k=i}else{d=g;g=i;while(1){i=f[d>>2]|0;if((i|0)<0)l=g;else{f[g>>2]=i;l=g+4|0}d=d+4|0;if((d|0)==(a|0))break;else g=l}j=f[b>>2]|0;k=l}if((k|0)==(j|0)){u=e;return}f[b>>2]=j+(~((j+-4-k|0)>>>2)<<2);u=e;return}function Cqb(a){a=a|0;YDc(a);return}function Dqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=f[a+4>>2]|0;e=f[a+48>>2]|0;g=f[a+40>>2]|0;h=f[a+28>>2]|0;i=Y(h,g)|0;j=f[a+52>>2]|0;k=1-(Y(i,j)|0)|0;i=f[a+56>>2]|0;l=Y(k,i)|0;k=f[a+44>>2]|0;m=Y(i,j)|0;o=1-(Y(m,k)|0)|0;p=f[a+16>>2]|0;q=Y(p,f[a+12>>2]|0)|0;r=f[a+20>>2]|0;s=Y(q,r)|0;q=f[a+60>>2]|0;t=((q+-1+s|0)>>>0)/(q>>>0)|0;q=Y(f[c>>2]|0,t)|0;u=Y(f[c+4>>2]|0,t)|0;t=s>>>0<u>>>0?s:u;u=f[a+36>>2]|0;s=u+((q>>>0)%(r>>>0)|0)|0;c=f[a+32>>2]|0;v=c+((((q>>>0)/(r>>>0)|0)>>>0)%(p>>>0)|0)|0;w=Y(r,p)|0;x=(q>>>0)/(w>>>0)|0;y=f[a+24>>2]|0;if((v|0)<(y|0))z=0;else z=((v-y|0)/(g|0)|0)+1|0;A=((v|0)/(g|0)|0)+1|0;B=(b[a+64>>0]|0)==0;C=f[a+8>>2]|0;if(q>>>0>=t>>>0)return;a=Y((Y((Y(y,x)|0)+v|0,h)|0)+s|0,m)|0;v=u+r|0;D=s;s=q;q=x;x=z;z=a;a=(j|0)<(A|0)?j:A;while(1){if((D|0)<(h|0))E=0;else E=((D-h|0)/(k|0)|0)+1|0;A=((D|0)/(k|0)|0)+1|0;F=(i|0)<(A|0)?i:A;if(B)if((x|0)<(a|0)&(E|0)<(F|0)){A=x;G=0.0;while(1){H=(Y(l,A)|0)+z|0;I=E;J=G;do{K=d+(H+(Y(I,o)|0)<<2)|0;J=J+ +n[K>>2];I=I+1|0}while((I|0)<(F|0));A=A+1|0;if((A|0)==(a|0)){L=J;break}else G=J}}else L=0.0;else L=+n[e+(s<<2)>>2];n[e+(s<<2)>>2]=L+ +n[C+(q<<2)>>2];A=D+1|0;if((A|0)<(v|0)){M=A;N=q;O=x;P=z+m|0;Q=a;R=s+1|0}else{A=s+1|0;F=((A>>>0)%(r>>>0)|0)+u|0;I=c+((((A>>>0)/(r>>>0)|0)>>>0)%(p>>>0)|0)|0;H=(A>>>0)/(w>>>0)|0;if((I|0)<(y|0))S=0;else S=((I-y|0)/(g|0)|0)+1|0;K=((I|0)/(g|0)|0)+1|0;M=F;N=H;O=S;P=Y((Y((Y(y,H)|0)+I|0,h)|0)+F|0,m)|0;Q=(j|0)<(K|0)?j:K;R=A}if(R>>>0<t>>>0){D=M;s=R;q=N;x=O;z=P;a=Q}else break}return}function Eqb(a){a=a|0;YDc(a);return}function Fqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;c=f[a+8>>2]|0;d=f[c+12>>2]|0;e=f[a+16>>2]|0;g=((d+-1+e|0)/(e|0)|0)+15&-16;e=Y(g,f[b>>2]|0)|0;h=Y(f[b+4>>2]|0,g)|0;g=f[a+4>>2]|0;b=f[g+8>>2]|0;i=((d|0)<(h|0)?d:h)-e|0;h=f[g+12>>2]|0;d=f[g+16>>2]|0;j=(f[c+16>>2]|0)+(e<<2)|0;k=f[a+12>>2]|0;a=(f[k+16>>2]|0)+(e<<2)|0;e=((f[f[g+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[g>>2]<<2&28)&15)>>>0)|0;g=((f[f[c+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[c>>2]<<2&28)&15)>>>0)|0;c=((f[f[k+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[k>>2]<<2&28)&15)>>>0)|0;if((b|0)<=0)return;k=b+-1|0;b=(i|0)>0;l=k>>>1;m=(h|0)<1|b^1;o=0;p=0;while(1){q=a+((Y(o,c)|0)<<2)|0;r=o|1;s=(k|0)<(r|0)?k:r;r=a+((Y(s,c)|0)<<2)|0;t=d+((Y(o,e)|0)<<2)|0;u=d+((Y(s,e)|0)<<2)|0;if(b){s=0;do{n[q+(s<<2)>>2]=0.0;n[r+(s<<2)>>2]=0.0;s=s+1|0}while((s|0)<(i|0))}if(!m){s=0;do{v=+n[t+(s<<2)>>2];w=+n[u+(s<<2)>>2];x=j+((Y(s,g)|0)<<2)|0;y=s|1;if((y|0)<(h|0)){z=+n[t+(y<<2)>>2];A=+n[u+(y<<2)>>2];y=x+(g<<2)|0;B=s|2;if((B|0)<(h|0)){C=+n[t+(B<<2)>>2];D=+n[u+(B<<2)>>2];B=y+(g<<2)|0;E=s|3;if((E|0)<(h|0)){F=z;G=A;H=C;I=B+(g<<2)|0;J=B;K=y;L=D;M=+n[u+(E<<2)>>2];N=+n[t+(E<<2)>>2]}else{F=z;G=A;H=C;I=x;J=B;K=y;L=D;M=0.0;N=0.0}}else{F=z;G=A;H=0.0;I=x;J=x;K=y;L=0.0;M=0.0;N=0.0}}else{F=0.0;G=0.0;H=0.0;I=x;J=x;K=x;L=0.0;M=0.0;N=0.0}y=0;do{A=+n[x+(y<<2)>>2];z=+n[K+(y<<2)>>2];D=+n[J+(y<<2)>>2];C=+n[I+(y<<2)>>2];B=q+(y<<2)|0;E=r+(y<<2)|0;O=M*C+(L*D+(G*z+(w*A+ +n[E>>2])));n[B>>2]=N*C+(H*D+(F*z+(v*A+ +n[B>>2])));n[E>>2]=O;y=y+1|0}while((y|0)<(i|0));s=s+4|0}while((s|0)<(h|0))}if((p|0)==(l|0))break;else{o=o+2|0;p=p+1|0}}return}function Gqb(a,b){a=a|0;b=b|0;var c=0;c=VDc(60)|0;Hqb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=99860;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Hqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0.0,I=0,K=0.0,L=0,M=0,N=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;JHa(a);f[a>>2]=99880;KHa(a,c);i=a+36|0;f[i>>2]=-1;f[g>>2]=0;f[g+4>>2]=0;j=tT(g,11)|0;k=434582;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));f[h>>2]=0;m=h+4|0;f[m>>2]=0;j=tT(h,15)|0;k=434594;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));o=c+4|0;c=f[o>>2]|0;do if(c){p=f[g>>2]|0;q=(p|0)==0?1154740:p;r=o;s=c;a:while(1){t=s;while(1){v=f[t+16>>2]|0;if((v|0)==(p|0))break;if((Ioc((v|0)==0?1154740:v,q)|0)>=0)break;v=f[t+4>>2]|0;if(!v){w=r;break a}else t=v}s=f[t>>2]|0;if(!s){w=t;break}else r=t}if((w|0)!=(o|0)){r=f[w+16>>2]|0;if((p|0)!=(r|0)?(Ioc(q,(r|0)==0?1154740:r)|0)<=-1:0){x=12;break}EHa(e,w+24|0,-1)}else x=12}else x=12;while(0);if((x|0)==12?(x=f[h>>2]|0,f[e>>2]=x,f[e+4>>2]=f[m>>2],x|0):0){m=x+-4|0;f[m>>2]=(f[m>>2]|0)+1}uT(h);uT(g);m=f[e>>2]|0;if((m|0)!=434594?(x=(m|0)==0?1154740:m,(Ioc(x,434594)|0)!=0):0)if((m|0)!=434610?(Ioc(x,434610)|0)!=0:0){f[h>>2]=0;x=h+4|0;f[x>>2]=0;m=e+4|0;tT(h,(f[m>>2]|0)+21|0)|0;w=f[h>>2]|0;j=w;k=434625;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));c=f[m>>2]|0;if(c|0)dJc(w+21|0,f[e>>2]|0,c|0)|0;f[g>>2]=0;f[g+4>>2]=0;tT(g,(f[x>>2]|0)+1|0)|0;c=f[x>>2]|0;if(!c){y=0;z=f[g>>2]|0;A=z+y|0;b[A>>0]=34;z5(-5,g,434647,434660,75)}dJc(f[g>>2]|0,f[h>>2]|0,c|0)|0;y=f[x>>2]|0;z=f[g>>2]|0;A=z+y|0;b[A>>0]=34;z5(-5,g,434647,434660,75)}else B=1;else B=0;f[i>>2]=B;f[g>>2]=0;f[g+4>>2]=0;j=tT(g,10)|0;k=434734;l=j+10|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));B=f[o>>2]|0;do if(B){i=f[g>>2]|0;A=(i|0)==0?1154740:i;y=o;z=B;b:while(1){x=z;while(1){c=f[x+16>>2]|0;if((c|0)==(i|0))break;if((Ioc((c|0)==0?1154740:c,A)|0)>=0)break;c=f[x+4>>2]|0;if(!c){C=y;break b}else x=c}z=f[x>>2]|0;if(!z){C=x;break}else y=x}if((C|0)!=(o|0)){y=f[C+16>>2]|0;if((i|0)!=(y|0)?(Ioc(A,(y|0)==0?1154740:y)|0)<=-1:0){D=5;break}y=DHa(C+24|0,-1)|0;D=y}else D=5}else D=5;while(0);C=a+40|0;f[C>>2]=D;uT(g);D=f[C>>2]|0;if((D|0)<1|((D|0)%2|0|0)!=1){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,58)|0;k=434745;l=j+58|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-5,g,434647,434660,79)}f[g>>2]=0;f[g+4>>2]=0;D=tT(g,5)|0;b[D>>0]=b[434804]|0;b[D+1>>0]=b[434805]|0;b[D+2>>0]=b[434806]|0;b[D+3>>0]=b[434807]|0;b[D+4>>0]=b[434808]|0;D=f[o>>2]|0;do if(D){C=f[g>>2]|0;B=(C|0)==0?1154740:C;y=o;z=D;c:while(1){q=z;while(1){p=f[q+16>>2]|0;if((p|0)==(C|0))break;if((Ioc((p|0)==0?1154740:p,B)|0)>=0)break;p=f[q+4>>2]|0;if(!p){E=y;break c}else q=p}z=f[q>>2]|0;if(!z){E=q;break}else y=q}if((E|0)!=(o|0)){y=f[E+16>>2]|0;if((C|0)!=(y|0)?(Ioc(B,(y|0)==0?1154740:y)|0)<=-1:0){F=1.0;break}F=+tIa(E+24|0,-1)}else F=1.0}else F=1.0;while(0);n[a+44>>2]=F;uT(g);f[g>>2]=0;f[g+4>>2]=0;E=tT(g,4)|0;b[E>>0]=98;b[E+1>>0]=101;b[E+2>>0]=116;b[E+3>>0]=97;E=f[o>>2]|0;do if(E){D=f[g>>2]|0;y=(D|0)==0?1154740:D;z=o;A=E;d:while(1){i=A;while(1){x=f[i+16>>2]|0;if((x|0)==(D|0))break;if((Ioc((x|0)==0?1154740:x,y)|0)>=0)break;x=f[i+4>>2]|0;if(!x){G=z;break d}else i=x}A=f[i>>2]|0;if(!A){G=i;break}else z=i}if((G|0)!=(o|0)){z=f[G+16>>2]|0;if((D|0)!=(z|0)?(Ioc(y,(z|0)==0?1154740:z)|0)<=-1:0){H=.75;break}H=+tIa(G+24|0,-1)}else H=.75}else H=.75;while(0);n[a+48>>2]=H;uT(g);f[g>>2]=0;f[g+4>>2]=0;G=tT(g,4)|0;b[G>>0]=98;b[G+1>>0]=105;b[G+2>>0]=97;b[G+3>>0]=115;G=f[o>>2]|0;do if(G){E=f[g>>2]|0;z=(E|0)==0?1154740:E;A=o;B=G;e:while(1){C=B;while(1){q=f[C+16>>2]|0;if((q|0)==(E|0))break;if((Ioc((q|0)==0?1154740:q,z)|0)>=0)break;q=f[C+4>>2]|0;if(!q){I=A;break e}else C=q}B=f[C>>2]|0;if(!B){I=C;break}else A=C}if((I|0)!=(o|0)){A=f[I+16>>2]|0;if((E|0)!=(A|0)?(Ioc(z,(A|0)==0?1154740:A)|0)<=-1:0){K=1.0;break}K=+tIa(I+24|0,-1)}else K=1.0}else K=1.0;while(0);n[a+52>>2]=K;uT(g);f[g>>2]=0;f[g+4>>2]=0;j=tT(g,12)|0;k=434810;l=j+12|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));k=f[o>>2]|0;if(!k){L=1;M=a+56|0;b[M>>0]=L;uT(g);uT(e);u=d;return}j=f[g>>2]|0;l=(j|0)==0?1154740:j;I=o;G=k;f:while(1){k=G;while(1){A=f[k+16>>2]|0;if((A|0)==(j|0))break;if((Ioc((A|0)==0?1154740:A,l)|0)>=0)break;A=f[k+4>>2]|0;if(!A){N=I;break f}else k=A}G=f[k>>2]|0;if(!G){N=k;break}else I=k}if((N|0)==(o|0)){L=1;M=a+56|0;b[M>>0]=L;uT(g);uT(e);u=d;return}o=f[N+16>>2]|0;if((j|0)!=(o|0)?(Ioc(l,(o|0)==0?1154740:o)|0)<=-1:0){L=1;M=a+56|0;b[M>>0]=L;uT(g);uT(e);u=d;return}o=DHa(N+24|0,-1)|0;L=((o|0)!=0|(J|0)!=0)&1;M=a+56|0;b[M>>0]=L;uT(g);uT(e);u=d;return}function Iqb(a){a=a|0;YDc(a);return}function Jqb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Kqb(a){a=a|0;REa(a);YDc(a);return}function Lqb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+32|0;h=g+20|0;i=g+8|0;j=g;k=o$(c,-1)|0;if((k|0)!=(o$(d,-1)|0)){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,41)|0;m=434823;n=l+41|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,h,453206,434660,149)}if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[e>>2]|0;c=f[h>>2]|0;if((d-c|0)!=((f[k>>2]|0)-(f[i>>2]|0)|0)){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,31)|0;m=434865;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,453206,434660,164)}a:do if((d|0)!=(c|0)){k=a+36|0;o=0;p=c;b:while(1){q=p;r=q+(o*56|0)|0;if((f[q+(o*56|0)+4>>2]|0)!=4){s=11;break}q=(f[i>>2]|0)+(o*56|0)|0;switch(f[k>>2]|0){case 0:{Rqb(a,r,q);break}case 1:{Sqb(a,r,q);break}default:{s=15;break b}}o=o+1|0;p=f[h>>2]|0;if(o>>>0>=(((f[e>>2]|0)-p|0)/56|0)>>>0)break a}if((s|0)==11){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,19)|0;m=434897;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,453206,434660,168)}else if((s|0)==15){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,31)|0;m=434917;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,j,453206,434660,182)}}while(0);mx(i);mx(h);u=g;return}function Mqb(a,b){a=a|0;b=b|0;var c=0;if((b|2|0)!=3)if((b|0)==2)if((f[a+32>>2]|0)==3)c=(f[a+36>>2]|0)==0;else c=1;else c=0;else c=1;return c|0}function Nqb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Oqb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Pqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function Qqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0;d=u;u=u+16|0;e=d;g=f[c+4>>2]|0;h=f[c>>2]|0;c=h;if((g|0)==(h|0)){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,17)|0;j=449134;k=i+17|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,445611,434660,405)}l=(f[a+36>>2]|0)==0;m=a+40|0;a=(g-h|0)/12|0;h=0;g=0;a:while(1){n=c+(g*12|0)|0;if(l){o=f[n>>2]|0;p=f[o+4>>2]|0;q=f[m>>2]|0;r=(q+-1|0)/2|0;s=f[o>>2]|0;t=((p|0)<(r|0)?p:r)<<1;v=f[c+(g*12|0)+4>>2]|0;w=v-o|0;x=w>>2;y=(o|0)==(v|0);do if(!y){if((w|0)<8){z=11;break a}if((w|0)==8){A=1;B=p<<2;C=t;break}else{D=2;E=1}do{E=Y(f[o+(D<<2)>>2]|0,E)|0;D=D+1|0}while((D|0)!=(x|0));v=Y(t,E)|0;F=p<<2;if(!y){if((w|0)<8){z=16;break a}if((w|0)==8){A=1;B=F;C=v}else{G=2;H=1;while(1){I=Y(f[o+(G<<2)>>2]|0,H)|0;G=G+1|0;if((G|0)==(x|0)){A=I;B=F;C=v;break}else H=I}}}else{A=0;B=F;C=v}}else{A=0;B=p<<2;C=0}while(0);t=(Y((Y(B,A)|0)+C|0,s)|0)+h|0;if((r|0)<(p|0)){H=(p-q<<1)+q|0;if(!y){if((w|0)<8){z=22;break}if((w|0)==8)K=1;else{G=2;I=1;while(1){L=Y(f[o+(G<<2)>>2]|0,I)|0;G=G+1|0;if((G|0)==(x|0)){K=L;break}else I=L}}}else K=0;M=(Y(K,H)|0)+t|0}else M=t}else{I=f[c+(g*12|0)+4>>2]|0;x=f[n>>2]|0;G=I-x|0;o=G>>2;w=x;if((w|0)!=(I|0)){if((G|0)<0){z=28;break}if(!G)N=1;else{G=0;I=1;while(1){x=Y(f[w+(G<<2)>>2]|0,I)|0;G=G+1|0;if((G|0)==(o|0)){N=x;break}else I=x}}}else N=0;I=f[m>>2]|0;M=(Y((Y(I<<1,I)|0)+2|0,N)|0)+h|0}g=g+1|0;if(g>>>0>=a>>>0){z=4;break}else h=M}if((z|0)==4){J=((M|0)<0)<<31>>31;u=d;return M|0}else if((z|0)==11){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,70)|0;j=452744;k=i+70|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,452815,452821,161)}else if((z|0)==16){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,70)|0;j=452744;k=i+70|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,452815,452821,161)}else if((z|0)==22){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,70)|0;j=452744;k=i+70|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,452815,452821,161)}else if((z|0)==28){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,70)|0;j=452744;k=i+70|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,452815,452821,161)}return 0}function Rqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0.0;e=u;u=u+64|0;g=e+8|0;h=e;i=f[c+40>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;l=f[a+40>>2]|0;m=(b[a+56>>0]|0)==0?1.0:+(l|0);o=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;i=z8()|0;p=(i|0)>1?i:1;i=f[c+16>>2]|0;c=f[d+16>>2]|0;q=+n[a+44>>2]/m;d=f[a+52>>2]|0;m=-+n[a+48>>2];f[g>>2]=99988;f[g+4>>2]=i;f[g+8>>2]=c;f[g+28>>2]=k;f[g+32>>2]=(l+-1|0)/2|0;n[g+12>>2]=q;f[g+16>>2]=d;n[g+20>>2]=m;f[g+24>>2]=o;f[g+36>>2]=j;f[g+40>>2]=p;f[h>>2]=0;f[h+4>>2]=p;y8(h,g,+(p|0));u=e;return}function Sqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0;e=u;u=u+384|0;g=e+256|0;h=e+200|0;i=e+144|0;j=e+88|0;k=e+32|0;l=e+16|0;m=e;o=f[c+40>>2]|0;p=f[o>>2]|0;q=f[o+4>>2]|0;if(!(b[a+56>>0]|0))r=1;else{o=f[a+40>>2]|0;r=Y(o,o)|0}f[h>>2]=f[c>>2];o=h+4|0;s=c+4|0;t=f[s>>2]|0;f[o>>2]=t;v=h+8|0;f[v>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];w=h+16|0;f[w>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];x=h+36|0;y=f[c+36>>2]|0;f[x>>2]=y;z=h+40|0;f[z>>2]=v;v=h+48|0;A=h+44|0;f[A>>2]=v;f[v>>2]=0;f[h+52>>2]=0;if(!y)B=t;else{t=y+12|0;f[t>>2]=(f[t>>2]|0)+1;B=f[s>>2]|0}if((B|0)<3){B=f[c+44>>2]|0;s=f[A>>2]|0;f[s>>2]=f[B>>2];f[s+4>>2]=f[B+4>>2]}else{f[o>>2]=0;ZS(h,c)}f[i>>2]=f[d>>2];c=i+4|0;B=d+4|0;s=f[B>>2]|0;f[c>>2]=s;t=i+8|0;f[t>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];y=i+16|0;f[y>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[i+32>>2]=f[d+32>>2];C=i+36|0;D=f[d+36>>2]|0;f[C>>2]=D;E=i+40|0;f[E>>2]=t;t=i+48|0;F=i+44|0;f[F>>2]=t;f[t>>2]=0;f[i+52>>2]=0;if(!D)G=s;else{s=D+12|0;f[s>>2]=(f[s>>2]|0)+1;G=f[B>>2]|0}if((G|0)<3){G=f[d+44>>2]|0;B=f[F>>2]|0;f[B>>2]=f[G>>2];f[B+4>>2]=f[G+4>>2]}else{f[c>>2]=0;ZS(i,d)}a:do if((p|0)>0){d=(q|0)>0;G=g+8|0;B=g+4|0;s=a+44|0;H=+(r|0);D=a+52|0;I=g+8|0;J=g+12|0;K=g+4|0;L=a+48|0;M=l+8|0;N=l+4|0;O=g+8|0;P=g+12|0;Q=g+4|0;R=l+8|0;S=l+12|0;T=l+4|0;U=m+8|0;V=m+4|0;W=k+36|0;X=k+16|0;Z=k+4|0;_=k+40|0;$=k+44|0;aa=k+48|0;ba=j+36|0;ca=j+16|0;da=j+4|0;ea=j+40|0;fa=j+44|0;ga=j+48|0;ha=0;b:while(1){if(d){ia=0;do{ja=f[o>>2]|0;if((ja|0)<=2){ka=26;break b}la=f[z>>2]|0;ma=2;do{f[g+(ma+-2<<2)>>2]=f[la+(ma<<2)>>2];ma=ma+1|0}while((ma|0)!=(ja|0));ma=f[A>>2]|0;la=(f[w>>2]|0)+(Y(f[ma>>2]|0,ha)|0)|0;dT(j,ja+-2|0,g,f[h>>2]&4095,la+(Y(f[ma+4>>2]|0,ia)|0)|0,0);ma=f[c>>2]|0;if((ma|0)<=2){ka=30;break b}la=f[E>>2]|0;na=2;do{f[g+(na+-2<<2)>>2]=f[la+(na<<2)>>2];na=na+1|0}while((na|0)!=(ma|0));na=f[F>>2]|0;la=(f[y>>2]|0)+(Y(f[na>>2]|0,ha)|0)|0;dT(k,ma+-2|0,g,f[i>>2]&4095,la+(Y(f[na+4>>2]|0,ia)|0)|0,0);Tqb(a,j,k);na=G;f[na>>2]=0;f[na+4>>2]=0;f[g>>2]=33619968;f[B>>2]=k;LZ(k,g,f[k>>2]&4095,+n[s>>2]/H,+n[D>>2]);f[I>>2]=0;f[J>>2]=0;f[g>>2]=16842752;f[K>>2]=k;oa=+n[L>>2];na=M;f[na>>2]=0;f[na+4>>2]=0;f[l>>2]=33619968;f[N>>2]=k;d3(g,oa,l);f[O>>2]=0;f[P>>2]=0;f[g>>2]=16842752;f[Q>>2]=j;f[R>>2]=0;f[S>>2]=0;f[l>>2]=16842752;f[T>>2]=k;na=U;f[na>>2]=0;f[na+4>>2]=0;f[m>>2]=33619968;f[V>>2]=k;rL(g,l,m,1.0,-1);na=f[W>>2]|0;if(na|0?(la=na+12|0,na=f[la>>2]|0,f[la>>2]=na+-1,(na|0)==1):0)_S(k);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){na=f[_>>2]|0;la=0;do{f[na+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Z>>2]|0))}la=f[$>>2]|0;if((la|0)!=(aa|0))g0(la);la=f[ba>>2]|0;if(la|0?(na=la+12|0,la=f[na>>2]|0,f[na>>2]=la+-1,(la|0)==1):0)_S(j);f[ba>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[da>>2]|0)>0){la=f[ea>>2]|0;na=0;do{f[la+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[da>>2]|0))}na=f[fa>>2]|0;if((na|0)!=(ga|0))g0(na);ia=ia+1|0}while((ia|0)<(q|0))}ha=ha+1|0;if((ha|0)>=(p|0))break a}if((ka|0)==26){f[g>>2]=0;f[g+4>>2]=0;pa=tT(g,10)|0;qa=445168;ra=pa+10|0;do{b[pa>>0]=b[qa>>0]|0;pa=pa+1|0;qa=qa+1|0}while((pa|0)<(ra|0));z5(-215,g,445179,452821,110)}else if((ka|0)==30){f[g>>2]=0;f[g+4>>2]=0;pa=tT(g,10)|0;qa=445168;ra=pa+10|0;do{b[pa>>0]=b[qa>>0]|0;pa=pa+1|0;qa=qa+1|0}while((pa|0)<(ra|0));z5(-215,g,445179,452821,110)}}while(0);g=f[C>>2]|0;if(g|0?(qa=g+12|0,g=f[qa>>2]|0,f[qa>>2]=g+-1,(g|0)==1):0)_S(i);f[C>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[E>>2]|0;E=0;do{f[y+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[c>>2]|0))}c=f[F>>2]|0;if((c|0)!=(t|0))g0(c);c=f[x>>2]|0;if(c|0?(t=c+12|0,c=f[t>>2]|0,f[t>>2]=c+-1,(c|0)==1):0)_S(h);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[o>>2]|0)>0){w=f[z>>2]|0;z=0;do{f[w+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[o>>2]|0))}o=f[A>>2]|0;if((o|0)==(v|0)){u=e;return}g0(o);u=e;return}function Tqb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+112|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d+8|0;j=d;Vj(e,f[b+8>>2]|0,f[b+12>>2]|0,f[b>>2]&4095,f[b+16>>2]|0,f[f[b+44>>2]>>2]|0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=e;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;b=f[c>>2]&7;c=f[a+40>>2]|0;f[i>>2]=c;f[i+4>>2]=c;f[j>>2]=-1;f[j+4>>2]=-1;_ma(g,h,b,i,j,0,0);j=e+36|0;i=f[j>>2]|0;if(i|0?(b=i+12|0,i=f[b>>2]|0,f[b>>2]=i+-1,(i|0)==1):0)_S(e);f[j>>2]=0;j=e+16|0;i=e+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[e+40>>2]|0;b=0;do{f[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)==(e+48|0)){u=d;return}g0(i);u=d;return}function Uqb(a){a=a|0;YDc(a);return}function Vqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0;c=u;u=u+1072|0;d=c;e=f[a+36>>2]|0;g=f[a+40>>2]|0;h=f[a+24>>2]|0;i=Y(h,e)|0;j=((g+-1+i|0)>>>0)/(g>>>0)|0;k=Y(f[b>>2]|0,j)|0;l=f[b+4>>2]|0;b=Y(l,j)|0;j=(l|0)==(g|0)?i:b;b=i>>>0<k>>>0?i:k;k=i>>>0<j>>>0?i:j;m=+n[a+12>>2];o=+n[a+16>>2];p=+n[a+20>>2];j=f[a+28>>2]|0;i=f[a+32>>2]|0;g=(i+j<<1)+2|0;l=d+8|0;f[d>>2]=l;q=d+4|0;f[q>>2]=g;if(g>>>0>264){r=XDc(g>>>0>1073741823?-1:g<<2)|0;f[d>>2]=r;s=r}else s=l;r=s+(j<<2)+(i<<2)+4|0;if((i|0)>=0){g=0;while(1){n[r+(g+j<<2)>>2]=0.0;n[r+(~g<<2)>>2]=0.0;if((g|0)==(i|0))break;else g=g+1|0}}if(k>>>0>b>>>0){g=a+4|0;t=a+8|0;a=(j|0)>0;v=(i|0)>0;w=~i;x=b;while(1){b=(x>>>0)/(h>>>0)|0;if((b|0)>=(e|0))break;y=Y(b,h)|0;b=x-y|0;z=h-b|0;A=k-x|0;B=(A>>>0<z>>>0?A:z)+x|0;z=Y(y,j)|0;y=(f[t>>2]|0)+(z<<2)+(b<<2)|0;a:do if(x>>>0<B>>>0){if(!a){A=x;while(1){if(v){C=0;do C=C+1|0;while((C|0)!=(i|0))}Y6(s,s,j);W6(s,s,j);C=A+1|0;if(C>>>0<B>>>0)A=C;else{D=C;break a}}}A=y;C=(f[g>>2]|0)+(z<<2)+(b<<2)|0;E=x;while(1){F=0;do{G=C+((Y(F,h)|0)<<2)|0;f[r+(F<<2)>>2]=f[G>>2];F=F+1|0}while((F|0)!=(j|0));if(v){H=0.0;F=0;while(1){I=+n[r+(F<<2)>>2];J=H+I*I;F=F+1|0;if((F|0)==(i|0)){K=J;L=0;break}else H=J}}else{K=0.0;L=0}do{H=+n[r+(L+i<<2)>>2];J=+n[r+(L+w<<2)>>2];I=K+(H+J)*(H-J);K=I<0.0?0.0:I;n[s+(L<<2)>>2]=o+m*K;L=L+1|0}while((L|0)!=(j|0));Y6(s,s,j);F=0;do{G=s+(F<<2)|0;n[G>>2]=p*+n[G>>2];F=F+1|0}while((F|0)!=(j|0));W6(s,s,j);F=0;do{G=A+((Y(F,h)|0)<<2)|0;n[G>>2]=+n[r+(F<<2)>>2]*+n[s+(F<<2)>>2];F=F+1|0}while((F|0)!=(j|0));F=E+1|0;if(F>>>0<B>>>0){A=A+4|0;C=C+4|0;E=F}else{D=F;break}}}else D=x;while(0);if(k>>>0>D>>>0)x=D;else break}M=f[d>>2]|0}else M=s;if((M|0)==(l|0)){u=c;return}if(M|0)ZDc(M);f[d>>2]=l;f[q>>2]=264;u=c;return}function Wqb(a,b){a=a|0;b=b|0;var c=0;c=VDc(48)|0;Xqb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=100008;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Xqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=100028;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,9)|0;h=454939;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));h=c+4|0;c=f[h>>2]|0;do if(c){g=f[e>>2]|0;i=(g|0)==0?1154740:g;j=h;k=c;a:while(1){l=k;while(1){m=f[l+16>>2]|0;if((m|0)==(g|0))break;if((Ioc((m|0)==0?1154740:m,i)|0)>=0)break;m=f[l+4>>2]|0;if(!m){n=j;break a}else l=m}k=f[l>>2]|0;if(!k){n=l;break}else j=l}if((n|0)!=(h|0)){j=f[n+16>>2]|0;if((g|0)!=(j|0)?(Ioc(i,(j|0)==0?1154740:j)|0)<=-1:0){o=0;break}j=DHa(n+24|0,-1)|0;o=((j|0)!=0|(J|0)!=0)&1}else o=0}else o=0;while(0);b[a+36>>0]=o;uT(e);f[e>>2]=0;f[e+4>>2]=0;o=tT(e,4)|0;b[o>>0]=97;b[o+1>>0]=120;b[o+2>>0]=105;b[o+3>>0]=115;o=f[h>>2]|0;if(!o){p=1;q=a+40|0;f[q>>2]=p;uT(e);r=a+44|0;b[r>>0]=0;u=d;return}n=f[e>>2]|0;c=(n|0)==0?1154740:n;j=h;k=o;b:while(1){o=k;while(1){m=f[o+16>>2]|0;if((m|0)==(n|0))break;if((Ioc((m|0)==0?1154740:m,c)|0)>=0)break;m=f[o+4>>2]|0;if(!m){s=j;break b}else o=m}k=f[o>>2]|0;if(!k){s=o;break}else j=o}if((s|0)==(h|0)){p=1;q=a+40|0;f[q>>2]=p;uT(e);r=a+44|0;b[r>>0]=0;u=d;return}h=f[s+16>>2]|0;if((n|0)!=(h|0)?(Ioc(c,(h|0)==0?1154740:h)|0)<=-1:0){p=1;q=a+40|0;f[q>>2]=p;uT(e);r=a+44|0;b[r>>0]=0;u=d;return}h=DHa(s+24|0,-1)|0;p=h;q=a+40|0;f[q>>2]=p;uT(e);r=a+44|0;b[r>>0]=0;u=d;return}function Yqb(a){a=a|0;YDc(a);return}function Zqb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _qb(a){a=a|0;REa(a);YDc(a);return}function $qb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d+8|0;g=d;f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;f$(c,e);c=f[a+8>>2]|0;i=f[a+4>>2]|0;j=(c-i|0)/56|0;k=i;i=c;switch(j|0){case 2:{l=1;break}case 1:{l=b[a+36>>0]^1;break}default:l=0}b[a+44>>0]=l;if((k|0)==(i|0)?((f[h>>2]|0)-(f[e>>2]|0)|0)==112:0){mx(e);u=d;return}if((j|0)==((b[a+36>>0]|0)+l&255|0)){mx(e);u=d;return}else{f[g>>2]=0;f[g+4>>2]=0;d=tT(g,87)|0;e=435543;l=d+87|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(l|0));z5(-215,g,453718,435131,48)}}function arb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0.0,Na=0.0;g=u;u=u+320|0;h=g+256|0;i=g+244|0;j=g+232|0;k=g+176|0;l=g+120|0;m=g+104|0;o=g+48|0;p=g+32|0;q=g+16|0;r=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[i>>2]=0;e=i+4|0;f[e>>2]=0;f[i+8>>2]=0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;f$(c,i);f$(d,j);d=f[j>>2]|0;c=d;if(((f[s>>2]|0)-d|0)!=56){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,19)|0;v=453252;w=t+19|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,453206,435131,72)}d=f[a+4>>2]|0;s=a+8|0;do if((d|0)==(f[s>>2]|0)){x=f[i>>2]|0;y=x;if(((f[e>>2]|0)-x|0)!=112){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,36)|0;v=435207;w=t+36|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,453206,435131,72)}x=y+56|0;f[k>>2]=f[x>>2];z=k+4|0;A=y+60|0;B=f[A>>2]|0;f[z>>2]=B;C=k+8|0;f[C>>2]=f[y+64>>2];f[k+12>>2]=f[y+68>>2];f[k+16>>2]=f[y+72>>2];f[k+20>>2]=f[y+76>>2];f[k+24>>2]=f[y+80>>2];f[k+28>>2]=f[y+84>>2];f[k+32>>2]=f[y+88>>2];D=f[y+92>>2]|0;f[k+36>>2]=D;f[k+40>>2]=C;C=k+48|0;E=k+44|0;f[E>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(!D)F=B;else{B=D+12|0;f[B>>2]=(f[B>>2]|0)+1;F=f[A>>2]|0}if((F|0)<3){A=f[y+100>>2]|0;B=f[E>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];G=y;H=k;break}else{f[z>>2]=0;ZS(k,x);G=y;H=k;break}}else{x=f[i>>2]|0;if(!(b[a+44>>0]|0)){f[k>>2]=1124007936;z=k+8|0;A=k+40|0;t=k+4|0;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[A>>2]=z;y=k+48|0;f[k+44>>2]=y;f[y>>2]=0;f[k+52>>2]=0;G=x;H=k;break}f[k>>2]=f[d>>2];y=k+4|0;B=d+4|0;f[y>>2]=f[B>>2];E=k+8|0;f[E>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];f[k+16>>2]=f[d+16>>2];f[k+20>>2]=f[d+20>>2];f[k+24>>2]=f[d+24>>2];f[k+28>>2]=f[d+28>>2];f[k+32>>2]=f[d+32>>2];D=f[d+36>>2]|0;f[k+36>>2]=D;f[k+40>>2]=E;E=k+48|0;C=k+44|0;f[C>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(D|0){E=D+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[B>>2]|0)<3){B=f[d+44>>2]|0;E=f[C>>2]|0;f[E>>2]=f[B>>2];f[E+4>>2]=f[B+4>>2];G=x;H=k;break}else{f[y>>2]=0;ZS(k,d);G=x;H=k;break}}while(0);H=a+36|0;if(!(b[H>>0]|0)){f[l>>2]=1124007936;d=l+8|0;F=l+40|0;t=l+4|0;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[F>>2]=d;d=l+48|0;f[l+44>>2]=d;f[d>>2]=0;f[l+52>>2]=0}else lT(l,(f[s>>2]|0)+-56|0,1,1);s=k+16|0;if(f[s>>2]|0){d=k+4|0;F=f[d>>2]|0;if((F|0)<3)I=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{e=f[k+40>>2]|0;y=0;B=1;while(1){E=Y(f[e+(y<<2)>>2]|0,B)|0;y=y+1|0;if((y|0)==(F|0)){I=E;break}else B=E}}if(!((F|0)==0|(I|0)==0)){lT(h,k,1,1);I=h+36|0;F=f[I>>2]|0;if(F|0){B=F+12|0;f[B>>2]=(f[B>>2]|0)+1}B=k+36|0;F=f[B>>2]|0;if(F|0?(y=F+12|0,F=f[y>>2]|0,f[y>>2]=F+-1,(F|0)==1):0)_S(k);f[B>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[d>>2]|0)>0){F=f[k+40>>2]|0;y=0;do{f[F+(y<<2)>>2]=0;y=y+1|0;J=f[d>>2]|0}while((y|0)<(J|0));f[k>>2]=f[h>>2];if((J|0)<3)K=39;else K=41}else{f[k>>2]=f[h>>2];K=39}if((K|0)==39){J=f[h+4>>2]|0;if((J|0)<3){f[d>>2]=J;f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];J=f[h+44>>2]|0;d=f[k+44>>2]|0;f[d>>2]=f[J>>2];f[d+4>>2]=f[J+4>>2]}else K=41}if((K|0)==41)ZS(k,h);J=h+16|0;f[s>>2]=f[J>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];d=f[I>>2]|0;f[B>>2]=d;if(d|0?(B=d+12|0,d=f[B>>2]|0,f[B>>2]=d+-1,(d|0)==1):0)_S(h);f[I>>2]=0;I=h+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[I>>2]|0)>0){J=f[h+40>>2]|0;d=0;do{f[J+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[I>>2]|0))}I=f[h+44>>2]|0;if((I|0)!=(h+48|0))g0(I)}}I=G+4|0;d=f[I>>2]|0;J=f[G+40>>2]|0;f[m>>2]=0;B=m+4|0;f[B>>2]=0;f[m+8>>2]=0;lFa(m,J,J+(d<<2)|0);d=f[s>>2]|0;J=(d|0)==0;do if(!J){y=f[k+4>>2]|0;F=(y|0)<3;if(F)L=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{e=f[k+40>>2]|0;E=0;C=1;while(1){D=Y(f[e+(E<<2)>>2]|0,C)|0;E=E+1|0;if((E|0)==(y|0)){L=D;break}else C=D}}if(!((y|0)==0|(L|0)==0)){if(F){M=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;break}C=f[k+40>>2]|0;E=0;e=1;while(1){x=Y(f[C+(E<<2)>>2]|0,e)|0;E=E+1|0;if((E|0)==(y|0)){M=x;break}else e=x}}else K=61}else K=61;while(0);do if((K|0)==61){L=f[l+4>>2]|0;if((L|0)<3){M=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;break}e=f[l+40>>2]|0;y=0;E=1;while(1){C=Y(f[e+(y<<2)>>2]|0,E)|0;y=y+1|0;if((y|0)==(L|0)){M=C;break}else E=C}}while(0);if(!M){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,15)|0;v=435244;w=t+15|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,453206,435131,84)}if(b[a+44>>0]|0?b[H>>0]|0:0){E=f[k+4>>2]|0;L=(E|0)<3;if(L)N=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{y=f[k+40>>2]|0;e=0;C=1;while(1){F=Y(f[y+(e<<2)>>2]|0,C)|0;e=e+1|0;if((e|0)==(E|0)){N=F;break}else C=F}}C=f[l+4>>2]|0;e=(C|0)<3;if(e)O=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{y=f[l+40>>2]|0;F=0;x=1;while(1){z=Y(f[y+(F<<2)>>2]|0,x)|0;F=F+1|0;if((F|0)==(C|0)){O=z;break}else x=z}}if((N|0)!=(O|0)){if(L)P=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{L=f[k+40>>2]|0;O=0;N=1;while(1){x=Y(f[L+(O<<2)>>2]|0,N)|0;O=O+1|0;if((O|0)==(E|0)){P=x;break}else N=x}}if(e){Q=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;$1(P,Q,100128)}e=f[l+40>>2]|0;N=0;E=1;while(1){O=Y(f[e+(N<<2)>>2]|0,E)|0;N=N+1|0;if((N|0)==(C|0)){Q=O;break}else E=O}$1(P,Q,100128)}}Q=f[a+40>>2]|0;a=f[I>>2]|0;I=f[B>>2]|0;P=f[m>>2]|0;E=I-P|0;C=E>>2;N=P;P=I;I=(Q|0)==-1?0:Q;e=(N|0)==(P|0);O=(I|0)>(C|0);L=Q;while(1){x=L;L=L+1|0;if((x|0)>=(a|0)){K=96;break}x=(L|0)==-1?C:L;if(!e){if(O){K=93;break}if((I|0)>(x|0)|(x|0)>(C|0)){K=93;break}if((I|0)<(x|0)){F=1;y=I;while(1){z=Y(f[N+(y<<2)>>2]|0,F)|0;y=y+1|0;if((y|0)==(x|0)){R=z;break}else F=z}}else R=1}else R=0;if((R|0)==(M|0)){K=96;break}}if((K|0)==93){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,70)|0;v=452744;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452815,452821,161)}else if((K|0)==96){R=(Q|0)==-1;I=R?0:Q;O=(L|0)==-1;e=O?C:L;F=(N|0)==(P|0);if(!F){if((I|0)>(C|0)){f[h>>2]=0;S=h+4|0;f[S>>2]=0;T=tT(h,70)|0;t=T;v=452744;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452815,452821,161)}if((I|0)>(e|0)|(e|0)>(C|0)){f[h>>2]=0;S=h+4|0;f[S>>2]=0;T=tT(h,70)|0;t=T;v=452744;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452815,452821,161)}if((I|0)<(e|0)){T=1;S=I;while(1){I=Y(f[N+(S<<2)>>2]|0,T)|0;S=S+1|0;if((S|0)==(e|0)){U=I;break}else T=I}}else U=1}else U=0;if((U|0)!=(M|0)){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,44)|0;v=435260;w=t+44|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,453206,435131,94)}U=b[H>>0]|0;if(U<<24>>24){T=f[l+4>>2]|0;if((T|0)<3)V=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{e=f[l+40>>2]|0;S=0;I=1;while(1){P=Y(f[e+(S<<2)>>2]|0,I)|0;S=S+1|0;if((S|0)==(T|0)){V=P;break}else I=P}}if((M|0)!=(V|0)){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,38)|0;v=435305;w=t+38|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,453206,435131,95)}}V=f[G>>2]&4095;if((V|0)!=5)Y1(V,5,100156);V=f[c>>2]&4095;if((V|0)!=5)Y1(V,5,100184);V=R?C:Q;if(!F){if((E|0)<0){f[h>>2]=0;W=h+4|0;f[W>>2]=0;X=tT(h,70)|0;t=X;v=452744;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452815,452821,161)}if((V|0)<0|(V|0)>(C|0)){f[h>>2]=0;W=h+4|0;f[W>>2]=0;X=tT(h,70)|0;t=X;v=452744;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452815,452821,161)}if((V|0)>0){X=1;W=0;while(1){E=Y(f[N+(W<<2)>>2]|0,X)|0;W=W+1|0;if((W|0)==(V|0)){Z=E;break}else X=E}}else Z=1}else Z=0;X=f[G+16>>2]|0;G=f[c+16>>2]|0;if((L|0)==(a|0)){if((Z|0)>0){a=p+8|0;c=p+12|0;V=p+4|0;W=q+8|0;E=q+12|0;Q=q+4|0;R=r+8|0;I=r+4|0;T=o+36|0;S=o+16|0;e=o+4|0;P=o+40|0;x=o+44|0;y=o+48|0;z=h+36|0;A=h+16|0;D=h+4|0;_=h+40|0;$=h+44|0;aa=h+48|0;ba=k+4|0;ca=k+8|0;da=k+12|0;ea=p+8|0;fa=p+12|0;ga=p+4|0;ha=q+8|0;ia=q+12|0;ja=q+4|0;ka=r+8|0;la=r+4|0;ma=p+8|0;na=p+12|0;oa=p+4|0;pa=q+8|0;qa=q+12|0;ra=q+4|0;sa=r+8|0;ta=r+4|0;ua=k+40|0;va=0;wa=X;xa=G;do{Vj(h,1,M,5,wa,0);Vj(o,1,M,5,xa,0);do if(!(f[s>>2]|0))K=187;else{ya=f[ba>>2]|0;if((ya|0)<3)za=Y(f[da>>2]|0,f[ca>>2]|0)|0;else{Aa=f[ua>>2]|0;Ba=0;Ca=1;while(1){Da=Y(f[Aa+(Ba<<2)>>2]|0,Ca)|0;Ba=Ba+1|0;if((Ba|0)==(ya|0)){za=Da;break}else Ca=Da}}if((ya|0)==0|(za|0)==0){K=187;break}f[ea>>2]=0;f[fa>>2]=0;f[p>>2]=16842752;f[ga>>2]=h;f[ha>>2]=0;f[ia>>2]=0;f[q>>2]=16842752;f[ja>>2]=k;Ca=ka;f[Ca>>2]=0;f[Ca+4>>2]=0;f[r>>2]=33619968;f[la>>2]=o;qL(p,q,r,1.0,-1);if(!(b[H>>0]|0))break;f[ma>>2]=0;f[na>>2]=0;f[p>>2]=16842752;f[oa>>2]=o;f[pa>>2]=0;f[qa>>2]=0;f[q>>2]=16842752;f[ra>>2]=l;Ca=sa;f[Ca>>2]=0;f[Ca+4>>2]=0;f[r>>2]=33619968;f[ta>>2]=o;mL(p,q,r,e0()|0,-1)}while(0);do if((K|0)==187){K=0;if(!(b[H>>0]|0))break;f[a>>2]=0;f[c>>2]=0;f[p>>2]=16842752;f[V>>2]=h;f[W>>2]=0;f[E>>2]=0;f[q>>2]=16842752;f[Q>>2]=l;Ca=R;f[Ca>>2]=0;f[Ca+4>>2]=0;f[r>>2]=33619968;f[I>>2]=o;mL(p,q,r,e0()|0,-1)}while(0);wa=wa+(M<<2)|0;xa=xa+(M<<2)|0;Ca=f[T>>2]|0;do if(Ca|0){Ba=Ca+12|0;Aa=f[Ba>>2]|0;f[Ba>>2]=Aa+-1;if((Aa|0)!=1)break;_S(o)}while(0);f[T>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[e>>2]|0)>0){Ca=f[P>>2]|0;Aa=0;do{f[Ca+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[e>>2]|0))}Aa=f[x>>2]|0;if((Aa|0)!=(y|0))g0(Aa);Aa=f[z>>2]|0;do if(Aa|0){Ca=Aa+12|0;Ba=f[Ca>>2]|0;f[Ca>>2]=Ba+-1;if((Ba|0)!=1)break;_S(h)}while(0);f[z>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[D>>2]|0)>0){Aa=f[_>>2]|0;Ba=0;do{f[Aa+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[D>>2]|0))}Ba=f[$>>2]|0;if((Ba|0)!=(aa|0))g0(Ba);va=va+1|0}while((va|0)<(Z|0))}}else{if(!J){J=f[k+4>>2]|0;if((J|0)<3)Ea=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{va=f[k+40>>2]|0;aa=0;$=1;while(1){D=Y(f[va+(aa<<2)>>2]|0,$)|0;aa=aa+1|0;if((aa|0)==(J|0)){Ea=D;break}else $=D}}if(!((J|0)==0|(Ea|0)==0))Fa=d;else K=130}else K=130;if((K|0)==130)Fa=0;K=U<<24>>24?f[l+16>>2]|0:0;U=O?0:L;do if(F)Ga=0;else{if((U|0)>(C|0)){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,70)|0;v=452744;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,452815,452821,161)}if((U|0)<(C|0)){Ha=1;Ia=U}else{Ga=1;break}while(1){L=Y(f[N+(Ia<<2)>>2]|0,Ha)|0;Ia=Ia+1|0;if((Ia|0)==(C|0)){Ga=L;break}else Ha=L}}while(0);if((Z|0)>0){Ha=(M|0)>0;C=(Fa|0)==0;Ia=(K|0)==0;N=p+8|0;U=p+4|0;v=o+36|0;t=o+16|0;w=o+4|0;F=o+40|0;L=o+44|0;O=o+48|0;d=h+36|0;Ea=h+16|0;J=h+4|0;$=h+40|0;aa=h+44|0;va=h+48|0;D=0;_=X;X=G;while(1){if(Ha)if(C){G=0;A=_;z=X;while(1){if(Ia)Ja=0.0;else Ja=+n[K+(G<<2)>>2];Vj(h,1,Ga,5,A,0);Vj(o,1,Ga,5,z,0);y=N;f[y>>2]=0;f[y+4>>2]=0;f[p>>2]=33619968;f[U>>2]=o;LZ(h,p,5,1.0,Ja);y=A+(Ga<<2)|0;x=z+(Ga<<2)|0;e=f[v>>2]|0;do if(e|0){P=e+12|0;S=f[P>>2]|0;f[P>>2]=S+-1;if((S|0)!=1)break;_S(o)}while(0);f[v>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){e=f[F>>2]|0;ya=0;do{f[e+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[w>>2]|0))}ya=f[L>>2]|0;if((ya|0)!=(O|0))g0(ya);ya=f[d>>2]|0;do if(ya|0){e=ya+12|0;S=f[e>>2]|0;f[e>>2]=S+-1;if((S|0)!=1)break;_S(h)}while(0);f[d>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[J>>2]|0)>0){ya=f[$>>2]|0;S=0;do{f[ya+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[J>>2]|0))}S=f[aa>>2]|0;if((S|0)!=(va|0))g0(S);G=G+1|0;if((G|0)>=(M|0)){Ka=y;La=x;break}else{A=y;z=x}}}else{z=0;A=_;G=X;while(1){Ma=+n[Fa+(z<<2)>>2];if(Ia)Na=0.0;else Na=+n[K+(z<<2)>>2];Vj(h,1,Ga,5,A,0);Vj(o,1,Ga,5,G,0);S=N;f[S>>2]=0;f[S+4>>2]=0;f[p>>2]=33619968;f[U>>2]=o;LZ(h,p,5,Ma,Na);S=A+(Ga<<2)|0;ya=G+(Ga<<2)|0;e=f[v>>2]|0;do if(e|0){P=e+12|0;T=f[P>>2]|0;f[P>>2]=T+-1;if((T|0)!=1)break;_S(o)}while(0);f[v>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){e=f[F>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[w>>2]|0))}x=f[L>>2]|0;if((x|0)!=(O|0))g0(x);x=f[d>>2]|0;do if(x|0){e=x+12|0;y=f[e>>2]|0;f[e>>2]=y+-1;if((y|0)!=1)break;_S(h)}while(0);f[d>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[J>>2]|0)>0){x=f[$>>2]|0;y=0;do{f[x+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[J>>2]|0))}y=f[aa>>2]|0;if((y|0)!=(va|0))g0(y);z=z+1|0;if((z|0)>=(M|0)){Ka=S;La=ya;break}else{A=S;G=ya}}}else{Ka=_;La=X}D=D+1|0;if((D|0)>=(Z|0))break;else{_=Ka;X=La}}}}La=f[m>>2]|0;if(La|0){m=f[B>>2]|0;if((m|0)!=(La|0))f[B>>2]=m+(~((m+-4-La|0)>>>2)<<2);YDc(La)}La=l+36|0;m=f[La>>2]|0;if(m|0?(B=m+12|0,m=f[B>>2]|0,f[B>>2]=m+-1,(m|0)==1):0)_S(l);f[La>>2]=0;La=l+16|0;m=l+4|0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;if((f[m>>2]|0)>0){La=f[l+40>>2]|0;B=0;do{f[La+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))g0(m);m=k+36|0;l=f[m>>2]|0;do if(l|0){B=l+12|0;La=f[B>>2]|0;f[B>>2]=La+-1;if((La|0)!=1)break;_S(k)}while(0);f[m>>2]=0;m=k+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[m>>2]|0)>0){s=f[k+40>>2]|0;l=0;do{f[s+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))g0(m);mx(j);mx(i);u=g;return}}function brb(a,b){a=a|0;b=b|0;var c=0;if((b|2|0)!=3)if((b|0)==2)c=(f[a+40>>2]|0)==1;else c=0;else c=1;return c|0}function crb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function drb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function erb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function frb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+64|0;g=e;do if(b[a+44>>0]|0){h=f[a+4>>2]|0;f[g>>2]=f[h>>2];i=g+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=g+8|0;f[k>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[g+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=k;k=g+48|0;m=g+44|0;f[m>>2]=k;f[k>>2]=0;f[g+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;ZS(g,h);break}}else{f[g>>2]=1124007936;h=g+8|0;i=g+40|0;n=g+4|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[i>>2]=h;j=g+48|0;f[g+44>>2]=j;f[j>>2]=0;f[g+52>>2]=0}while(0);if((g|0)==(c|0)){p=g+36|0;q=f[c+36>>2]|0}else{j=g+36|0;k=f[j>>2]|0;if(k|0){m=k+12|0;f[m>>2]=(f[m>>2]|0)+1}m=c+36|0;k=f[m>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(c);f[m>>2]=0;k=c+16|0;l=c+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){r=f[c+40>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0;t=f[l>>2]|0}while((s|0)<(t|0));f[c>>2]=f[g>>2];if((t|0)<3)v=20;else v=22}else{f[c>>2]=f[g>>2];v=20}if((v|0)==20){t=f[g+4>>2]|0;if((t|0)<3){f[l>>2]=t;f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];t=f[g+44>>2]|0;l=f[c+44>>2]|0;f[l>>2]=f[t>>2];f[l+4>>2]=f[t+4>>2]}else v=22}if((v|0)==22)ZS(c,g);f[k>>2]=f[g+16>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];c=f[j>>2]|0;f[m>>2]=c;p=j;q=c}if(q|0?(c=q+12|0,q=f[c>>2]|0,f[c>>2]=q+-1,(q|0)==1):0)_S(g);f[p>>2]=0;p=g+16|0;q=g+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[g+40>>2]|0;c=0;do{f[p+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[q>>2]|0))}q=f[g+44>>2]|0;if((q|0)!=(g+48|0))g0(q);do if(b[a+36>>0]|0){q=f[a+8>>2]|0;c=q+-56|0;f[g>>2]=f[c>>2];p=g+4|0;j=q+-52|0;f[p>>2]=f[j>>2];m=g+8|0;f[m>>2]=f[q+-48>>2];f[g+12>>2]=f[q+-44>>2];f[g+16>>2]=f[q+-40>>2];f[g+20>>2]=f[q+-36>>2];f[g+24>>2]=f[q+-32>>2];f[g+28>>2]=f[q+-28>>2];f[g+32>>2]=f[q+-24>>2];k=f[q+-20>>2]|0;f[g+36>>2]=k;f[g+40>>2]=m;m=g+48|0;t=g+44|0;f[t>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(k|0){m=k+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[j>>2]|0)<3){j=f[q+-12>>2]|0;q=f[t>>2]|0;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];break}else{f[p>>2]=0;ZS(g,c);break}}else{f[g>>2]=1124007936;c=g+8|0;p=g+40|0;n=g+4|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[p>>2]=c;h=g+48|0;f[g+44>>2]=h;f[h>>2]=0;f[g+52>>2]=0}while(0);if((g|0)==(d|0)){w=g+36|0;x=f[d+36>>2]|0}else{n=g+36|0;o=f[n>>2]|0;if(o|0){a=o+12|0;f[a>>2]=(f[a>>2]|0)+1}a=d+36|0;o=f[a>>2]|0;if(o|0?(h=o+12|0,o=f[h>>2]|0,f[h>>2]=o+-1,(o|0)==1):0)_S(d);f[a>>2]=0;o=d+16|0;h=d+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[h>>2]|0)>0){i=f[d+40>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0;y=f[h>>2]|0}while((j|0)<(y|0));f[d>>2]=f[g>>2];if((y|0)<3)v=51;else v=53}else{f[d>>2]=f[g>>2];v=51}if((v|0)==51){y=f[g+4>>2]|0;if((y|0)<3){f[h>>2]=y;f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];y=f[g+44>>2]|0;h=f[d+44>>2]|0;f[h>>2]=f[y>>2];f[h+4>>2]=f[y+4>>2]}else v=53}if((v|0)==53)ZS(d,g);f[o>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];d=f[n>>2]|0;f[a>>2]=d;w=n;x=d}if(x|0?(d=x+12|0,x=f[d>>2]|0,f[d>>2]=x+-1,(x|0)==1):0)_S(g);f[w>>2]=0;w=g+16|0;x=g+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[g+40>>2]|0;d=0;do{f[w+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[x>>2]|0))}x=f[g+44>>2]|0;if((x|0)==(g+48|0)){u=e;return}g0(x);u=e;return}function grb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;iFa(d,1,f[b>>2]|0);return 1}function hrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;do{k=f[c+(e*12|0)+4>>2]|0;l=f[c+(e*12|0)>>2]|0;m=k-l|0;n=m>>2;o=l;if((o|0)!=(k|0)){if((m|0)<0){p=8;break}if(!m)q=1;else{m=1;k=0;while(1){l=Y(f[o+(k<<2)>>2]|0,m)|0;k=k+1|0;if((k|0)==(n|0)){q=l;break}else m=l}}}else q=0;g=(q<<1)+g|0;e=e+1|0}while(e>>>0<j>>>0);if((p|0)==8){f[a>>2]=0;f[a+4>>2]=0;p=tT(a,70)|0;j=452744;e=p+70|0;do{b[p>>0]=b[j>>0]|0;p=p+1|0;j=j+1|0}while((p|0)<(e|0));z5(-215,a,452815,452821,161)}h=((g|0)<0)<<31>>31;i=g;J=h;u=d;return i|0}function irb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+64|0;e=d+16|0;g=d+8|0;h=d;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=e+4;i=e+12|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;i=c+24|0;j=e+24|0;k=(e|0)==(c|0);if(!k){uT(j);l=f[i>>2]|0;if(!l)m=0;else{n=l+-4|0;f[n>>2]=(f[n>>2]|0)+1;m=f[i>>2]|0}f[j>>2]=m;f[e+28>>2]=f[c+28>>2];m=e+32|0;uT(m);j=tT(m,5)|0;b[j>>0]=b[435704]|0;b[j+1>>0]=b[435705]|0;b[j+2>>0]=b[435706]|0;b[j+3>>0]=b[435707]|0;b[j+4>>0]=b[435708]|0;if(!k)XGa(e+12|0,f[c+12>>2]|0,f[c+16>>2]|0)}else{c=e+32|0;uT(c);k=tT(c,5)|0;b[k>>0]=b[435704]|0;b[k+1>>0]=b[435705]|0;b[k+2>>0]=b[435706]|0;b[k+3>>0]=b[435707]|0;b[k+4>>0]=b[435708]|0}f[g>>2]=0;f[g+4>>2]=0;k=tT(g,9)|0;c=454939;j=k+9|0;do{b[k>>0]=b[c>>0]|0;k=k+1|0;c=c+1|0}while((k|0)<(j|0));b[h>>0]=1;rIa(e,g,h)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;c=tT(g,4)|0;b[c>>0]=97;b[c+1>>0]=120;b[c+2>>0]=105;b[c+3>>0]=115;f[h>>2]=0;$Ha(e,g,h)|0;uT(g);g=VDc(48)|0;Xqb(g,e);h=VDc(16)|0;c=h+4|0;f[c>>2]=1;f[h>>2]=100008;f[h+8>>2]=g;f[a>>2]=h;f[a+4>>2]=g;f[c>>2]=(f[c>>2]|0)+1;g=f[c>>2]|0;f[c>>2]=g+-1;if((g|0)!=1){HFa(e);u=d;return}Yi[f[(f[h>>2]|0)+8>>2]&2047](h);HFa(e);u=d;return}function jrb(a,b){a=a|0;b=b|0;var c=0;c=VDc(80)|0;krb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=100220;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function krb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+48|0;e=d+24|0;g=d+16|0;h=d+8|0;i=d;JHa(a);f[a>>2]=100240;j=a+36|0;k=a+40|0;l=a+68|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;m=tT(e,5)|0;b[m>>0]=b[498520]|0;b[m+1>>0]=b[498521]|0;b[m+2>>0]=b[498522]|0;b[m+3>>0]=b[498523]|0;b[m+4>>0]=b[498524]|0;m=c+4|0;o=f[m>>2]|0;do if(o){p=f[e>>2]|0;q=(p|0)==0?1154740:p;r=m;s=o;a:while(1){t=s;while(1){v=f[t+16>>2]|0;if((v|0)==(p|0))break;if((Ioc((v|0)==0?1154740:v,q)|0)>=0)break;v=f[t+4>>2]|0;if(!v){w=r;break a}else t=v}s=f[t>>2]|0;if(!s){w=t;break}else r=t}if((w|0)!=(m|0)){r=f[w+16>>2]|0;if((p|0)!=(r|0)?(Ioc(q,(r|0)==0?1154740:r)|0)<=-1:0){x=0.0;break}x=+tIa(w+24|0,-1)}else x=0.0}else x=0.0;while(0);n[a+64>>2]=x;uT(e);f[e>>2]=0;f[e+4>>2]=0;w=tT(e,10)|0;o=435790;r=w+10|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));s=f[m>>2]|0;do if(s){v=f[e>>2]|0;y=(v|0)==0?1154740:v;z=m;A=s;b:while(1){B=A;while(1){C=f[B+16>>2]|0;if((C|0)==(v|0))break;if((Ioc((C|0)==0?1154740:C,y)|0)>=0)break;C=f[B+4>>2]|0;if(!C){D=z;break b}else B=C}A=f[B>>2]|0;if(!A){D=B;break}else z=B}if((D|0)!=(m|0)){z=f[D+16>>2]|0;if((v|0)!=(z|0)?(Ioc(y,(z|0)==0?1154740:z)|0)<=-1:0){E=-1;break}z=DHa(D+24|0,-1)|0;E=z}else E=-1}else E=-1;while(0);f[a+60>>2]=E;uT(e);f[h>>2]=0;f[h+4>>2]=0;E=tT(h,4)|0;b[E>>0]=116;b[E+1>>0]=121;b[E+2>>0]=112;b[E+3>>0]=101;f[i>>2]=0;E=i+4|0;f[E>>2]=0;a=tT(i,8)|0;D=a;b[D>>0]=99;b[D+1>>0]=111;b[D+2>>0]=110;b[D+3>>0]=115;D=a+4|0;b[D>>0]=116;b[D+1>>0]=97;b[D+2>>0]=110;b[D+3>>0]=116;D=f[m>>2]|0;do if(D){a=f[h>>2]|0;s=(a|0)==0?1154740:a;z=m;A=D;c:while(1){q=A;while(1){p=f[q+16>>2]|0;if((p|0)==(a|0))break;if((Ioc((p|0)==0?1154740:p,s)|0)>=0)break;p=f[q+4>>2]|0;if(!p){F=z;break c}else q=p}A=f[q>>2]|0;if(!A){F=q;break}else z=q}if((F|0)!=(m|0)){z=f[F+16>>2]|0;if((a|0)!=(z|0)?(Ioc(s,(z|0)==0?1154740:z)|0)<=-1:0){G=34;break}EHa(g,F+24|0,-1);H=g+4|0}else G=34}else G=34;while(0);if((G|0)==34){F=f[i>>2]|0;f[g>>2]=F;D=g+4|0;f[D>>2]=f[E>>2];if(!F)H=D;else{E=F+-4|0;f[E>>2]=(f[E>>2]|0)+1;H=D}}D=f[g>>2]|0;E=f[H>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(E>>>0>4294967279)dEc(e);if(E>>>0<11){b[e+11>>0]=E;if(!E)I=e;else{J=e;G=41}}else{H=E+16&-16;F=VDc(H)|0;f[e>>2]=F;f[e+8>>2]=H|-2147483648;f[e+4>>2]=E;J=F;G=41}if((G|0)==41){dJc(J|0,D|0,E|0)|0;I=J}b[I+E>>0]=0;iEc(l,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);uT(g);uT(i);uT(h);f[e>>2]=0;f[e+4>>2]=0;h=tT(e,8)|0;i=h;b[i>>0]=112;b[i+1>>0]=97;b[i+2>>0]=100;b[i+3>>0]=100;i=h+4|0;b[i>>0]=105;b[i+1>>0]=110;b[i+2>>0]=103;b[i+3>>0]=115;i=f[m>>2]|0;if(!i){uT(e);f[e>>2]=0;K=e+4|0;f[K>>2]=0;L=tT(e,22)|0;w=L;o=435801;r=w+22|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));z5(-215,e,435824,435841,32)}m=f[e>>2]|0;h=(m|0)==0?1154740:m;g=i;while(1){i=f[g+16>>2]|0;if((m|0)==(i|0)){G=52;break}l=(i|0)==0?1154740:i;if((Ioc(h,l)|0)<0)M=g;else{if((Ioc(l,h)|0)>=0){G=56;break}M=g+4|0}g=f[M>>2]|0;if(!g){G=54;break}}if((G|0)==52)uT(e);else if((G|0)==54){uT(e);f[e>>2]=0;K=e+4|0;f[K>>2]=0;L=tT(e,22)|0;w=L;o=435801;r=w+22|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));z5(-215,e,435824,435841,32)}else if((G|0)==56)uT(e);f[e>>2]=0;f[e+4>>2]=0;L=tT(e,8)|0;K=L;b[K>>0]=112;b[K+1>>0]=97;b[K+2>>0]=100;b[K+3>>0]=100;K=L+4|0;b[K>>0]=105;b[K+1>>0]=110;b[K+2>>0]=103;b[K+3>>0]=115;K=lIa(c,e)|0;uT(e);c=f[K>>2]|0;switch(c|0){case 0:{L=f[K+4>>2]|0;N=L+4|0;O=L;P=L;Q=L;break}case 3:{L=f[K+4>>2]|0;N=L+4|0;O=L;P=L;Q=L;break}case 2:{L=f[K+4>>2]|0;N=L+4|0;O=L;P=L;Q=L;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}if(f[N>>2]&1|0){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,31)|0;o=435919;r=w+31|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));z5(-215,e,435824,435841,34)}switch(c|0){case 0:{R=O+4|0;break}case 3:{R=P+4|0;break}case 2:{R=Q+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}Q=(f[R>>2]|0)/2|0;R=f[k>>2]|0;P=f[j>>2]|0;O=R-P>>3;c=P;N=R;if(Q>>>0<=O>>>0)if(Q>>>0<O>>>0?(L=c+(Q<<3)|0,(N|0)!=(L|0)):0){c=N+(~((N+-8-L|0)>>>3)<<3)|0;f[k>>2]=c;S=c;T=P}else{S=R;T=P}else{nrb(j,Q-O|0);S=f[k>>2]|0;T=f[j>>2]|0}if((S|0)==(T|0)){u=d;return}else U=0;while(1){T=U<<1;S=DHa(K,T)|0;f[(f[j>>2]|0)+(U<<3)>>2]=S;S=DHa(K,T|1)|0;T=f[j>>2]|0;f[T+(U<<3)+4>>2]=S;if((f[T+(U<<3)>>2]|0)<=-1){G=78;break}U=U+1|0;if((S|0)<=-1){G=80;break}if(U>>>0>=(f[k>>2]|0)-T>>3>>>0){G=76;break}}if((G|0)==76){u=d;return}else if((G|0)==78){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,22)|0;o=435951;r=w+22|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));z5(-215,e,435824,435841,41)}else if((G|0)==80){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,23)|0;o=435974;r=w+23|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));z5(-215,e,435824,435841,41)}}function lrb(a){a=a|0;YDc(a);return}function mrb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nrb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){XIc(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)mCc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;XIc(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;YDc(h);return}function orb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=100240;c=a+68|0;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);c=f[a+48>>2]|0;if(c|0){d=a+52|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);YDc(c)}c=f[a+36>>2]|0;if(!c){REa(a);return}e=a+40|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);YDc(c);REa(a);return}function prb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=100240;c=a+68|0;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);c=f[a+48>>2]|0;if(c|0){d=a+52|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);YDc(c)}c=f[a+36>>2]|0;if(!c){REa(a);YDc(a);return}e=a+40|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);YDc(c);REa(a);YDc(a);return}function qrb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+48|0;d=c;e=c+24|0;g=c+8|0;h=c+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f$(b,e);b=f[e>>2]|0;i=a+48|0;j=a+36|0;k=a+40|0;l=(f[k>>2]|0)-(f[j>>2]|0)>>3;m=a+52|0;n=f[m>>2]|0;o=f[i>>2]|0;p=n-o>>3;q=o;o=n;if(l>>>0<=p>>>0){if(l>>>0<p>>>0?(n=q+(l<<3)|0,(o|0)!=(n|0)):0)f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3)}else wrb(i,l-p|0);p=f[a+60>>2]|0;if((p|0)!=-1?(f[(f[e>>2]|0)+4>>2]|0)!=(p|0):0){f[g>>2]=f[i>>2];f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[d>>2]=f[g>>2];xrb(i,d,h)|0;r=1}else r=0;h=f[k>>2]|0;k=f[j>>2]|0;j=k;if((h|0)==(k|0))s=f[i>>2]|0;else{g=f[i>>2]|0;p=f[b+40>>2]|0;b=h-k>>3;k=g;h=0;do{l=f[j+(h<<3)>>2]|0;n=h+r|0;f[g+(n<<3)>>2]=l;f[g+(n<<3)+4>>2]=(f[p+(n<<2)>>2]|0)+l;h=h+1|0}while(h>>>0<b>>>0);s=k}k=f[m>>2]|0;b=k-s>>3;if((b|0)>=(f[(f[e>>2]|0)+4>>2]|0)){mx(e);u=c;return}s=d+4|0;h=a+56|0;a=b;b=k;while(1){f[d>>2]=-2147483648;f[s>>2]=2147483647;if((b|0)==(f[h>>2]|0))yrb(i,d);else{k=d;p=f[k+4>>2]|0;g=b;f[g>>2]=f[k>>2];f[g+4>>2]=p;f[m>>2]=(f[m>>2]|0)+8}p=a+1|0;if((p|0)>=(f[(f[e>>2]|0)+4>>2]|0))break;a=p;b=f[m>>2]|0}mx(e);u=c;return}function rrb(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+208|0;h=g+188|0;i=g+176|0;j=g+160|0;k=g+88|0;l=g+144|0;m=g+32|0;o=g;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;f$(c,h);f$(e,i);e=a+68|0;s=e+11|0;t=b[s>>0]|0;v=a+72|0;w=f[v>>2]|0;do if(((t<<24>>24<0?w:t&255)|0)==8){if(EEc(e,0,-1,436118,8)|0){x=b[s>>0]|0;y=f[v>>2]|0;break}if((p$(c,-1)|0)==3){f[j>>2]=0;z=j+4|0;f[z>>2]=0;f[j+8>>2]=0;A=VDc(4)|0;f[j>>2]=A;B=A+4|0;f[j+8>>2]=B;f[A>>2]=f[a+64>>2];f[z>>2]=B;f[k>>2]=0;B=k+4|0;f[B>>2]=0;f[k+8>>2]=0;A=VDc(2)|0;f[k>>2]=A;C=A+2|0;f[k+8>>2]=C;d[A>>1]=0;f[B>>2]=C;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=-2130509819;f[l+4>>2]=j;C=m+8|0;f[C>>2]=0;f[C+4>>2]=0;f[m>>2]=-2113732605;f[m+4>>2]=k;NZ(l,m);C=f[i>>2]|0;p[m>>3]=+(d[f[k>>2]>>1]|0);f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;l_(C,l,e0()|0)|0;C=f[k>>2]|0;if(C|0){A=f[B>>2]|0;if((A|0)!=(C|0))f[B>>2]=A+(~((A+-2-C|0)>>>1)<<1);YDc(C)}C=f[j>>2]|0;if(C|0){A=f[z>>2]|0;if((A|0)!=(C|0))f[z>>2]=A+(~((A+-4-C|0)>>>2)<<2);YDc(C)}}else{C=f[i>>2]|0;p[k>>3]=+n[a+64>>2];f[j>>2]=-1056833530;f[j+4>>2]=k;f[j+8>>2]=1;f[j+12>>2]=1;l_(C,j,e0()|0)|0}C=f[h>>2]|0;fT(k,f[i>>2]|0,a+48|0);A=j+8|0;f[A>>2]=0;f[A+4>>2]=0;f[j>>2]=-1040121856;f[j+4>>2]=k;h_(C,j);C=k+36|0;A=f[C>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)_S(k);f[C>>2]=0;C=k+16|0;A=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[A>>2]|0)>0){C=f[k+40>>2]|0;z=0;do{f[C+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[A>>2]|0))}A=f[k+44>>2]|0;if((A|0)!=(k+48|0))g0(A);mx(i);mx(h);u=g;return}else{x=t;y=w}while(0);if(((x<<24>>24<0?y:x&255)|0)==7?(EEc(e,0,-1,436127,7)|0)==0:0){x=f[h>>2]|0;y=x;if(((f[q>>2]|0)-x|0)!=56){f[j>>2]=0;f[j+4>>2]=0;D=tT(j,18)|0;E=453187;F=D+18|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,j,453206,435841,121)}x=f[i>>2]|0;q=x;if(((f[r>>2]|0)-x|0)!=56){f[j>>2]=0;f[j+4>>2]=0;D=tT(j,19)|0;E=453252;F=D+19|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,j,453206,435841,122)}if((f[y+4>>2]|0)!=4){f[j>>2]=0;f[j+4>>2]=0;D=tT(j,19)|0;E=436135;F=D+19|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,j,453206,435841,123)}if((f[q+4>>2]|0)!=4){f[j>>2]=0;f[j+4>>2]=0;D=tT(j,20)|0;E=436155;F=D+20|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,j,453206,435841,124)}x=f[y+40>>2]|0;r=f[x>>2]|0;w=f[q+40>>2]|0;if((r|0)!=(f[w>>2]|0)){f[j>>2]=0;G=j+4|0;f[G>>2]=0;H=tT(j,45)|0;D=H;E=436176;F=D+45|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-213,j,453206,435841,127)}q=f[x+4>>2]|0;if((q|0)!=(f[w+4>>2]|0)){f[j>>2]=0;G=j+4|0;f[G>>2]=0;H=tT(j,45)|0;D=H;E=436176;F=D+45|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-213,j,453206,435841,127)}E=f[x+8>>2]|0;D=f[x+12>>2]|0;x=f[a+48>>2]|0;a=f[x+16>>2]|0;F=(f[w+8>>2]|0)-(f[x+20>>2]|0)|0;H=f[x+24>>2]|0;G=(f[w+12>>2]|0)-(f[x+28>>2]|0)|0;if((a|0)>=(E|0))_1(a,E,100340);if((F|0)>=(E|0))_1(F,E,100368);if((H|0)>=(D|0))_1(H,D,100396);if((G|0)>=(D|0))_1(G,D,100424);if(!r){mx(i);mx(h);u=g;return}D=j+8|0;E=j+12|0;x=j+4|0;w=l+8|0;t=l+4|0;c=m+36|0;v=m+16|0;s=m+4|0;A=m+40|0;z=m+44|0;C=m+48|0;B=k+36|0;I=k+16|0;J=k+4|0;K=k+40|0;L=k+44|0;M=k+48|0;N=0;O=q;q=r;r=y;while(1){if(!O){P=0;Q=q;R=r}else{y=0;S=r;do{vrb(k,S,N,y);f[D>>2]=0;f[E>>2]=0;f[j>>2]=16842752;f[x>>2]=k;vrb(m,f[i>>2]|0,N,y);T=w;f[T>>2]=0;f[T+4>>2]=0;f[l>>2]=-1040121856;f[t>>2]=m;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;q_(j,l,a,F,H,G,4,o);T=f[c>>2]|0;do if(T|0){U=T+12|0;V=f[U>>2]|0;f[U>>2]=V+-1;if((V|0)!=1)break;_S(m)}while(0);f[c>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[s>>2]|0)>0){T=f[A>>2]|0;V=0;do{f[T+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[s>>2]|0))}V=f[z>>2]|0;if((V|0)!=(C|0))g0(V);V=f[B>>2]|0;do if(V|0){T=V+12|0;U=f[T>>2]|0;f[T>>2]=U+-1;if((U|0)!=1)break;_S(k)}while(0);f[B>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[J>>2]|0)>0){V=f[K>>2]|0;U=0;do{f[V+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[J>>2]|0))}U=f[L>>2]|0;if((U|0)!=(M|0))g0(U);y=y+1|0;S=f[h>>2]|0;W=f[S+40>>2]|0;X=f[W+4>>2]|0}while(y>>>0<X>>>0);P=X;Q=f[W>>2]|0;R=S}N=N+1|0;if(N>>>0>=Q>>>0)break;else{O=P;q=Q;r=R}}mx(i);mx(h);u=g;return}VHa(k,436222,e);f[j>>2]=0;f[j+4>>2]=0;e=k+11|0;g=b[e>>0]|0;h=g<<24>>24<0?f[k+4>>2]|0:g&255;if(!h)z5(-213,j,453206,435841,152);g=tT(j,h)|0;dJc(g|0,((b[e>>0]|0)<0?f[k>>2]|0:k)|0,h|0)|0;z5(-213,j,453206,435841,152)}function srb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 1:{if(sMa()|0)c=((f[a+52>>2]|0)-(f[a+48>>2]|0)|0)==32;else c=0;break}default:c=0}return c|0}function trb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function urb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=h;if(((f[c+4>>2]|0)-h|0)!=12){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,18)|0;k=453187;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,435841,50)}c=i+4|0;m=h;h=(f[c>>2]|0)-(f[m>>2]|0)>>2;n=a+36|0;o=a+40|0;p=(f[o>>2]|0)-(f[n>>2]|0)>>3;if(h>>>0<p>>>0){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,34)|0;k=435998;l=j+34|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,435841,52)}q=a+60|0;a=f[q>>2]|0;if(!(h>>>0>p>>>0|((a|0)==-1|(h|0)==(a|0)))){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,84)|0;k=436033;l=j+84|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,435841,53)}d=e+4|0;k=f[d>>2]|0;j=f[e>>2]|0;l=k-j|0;a=(l|0)/12|0;h=j;j=k;if(l){if(a>>>0>1?(l=h+12|0,(j|0)!=(l|0)):0){h=j;while(1){j=h+-12|0;f[d>>2]=j;k=f[j>>2]|0;if(!k)r=j;else{j=h+-8|0;p=f[j>>2]|0;if((p|0)!=(k|0))f[j>>2]=p+(~((p+-4-k|0)>>>2)<<2);YDc(k);r=f[d>>2]|0}if((r|0)==(l|0))break;else h=r}}}else npb(e,1-a|0,i);a=f[q>>2]|0;if((a|0)==-1)s=0;else s=(f[c>>2]|0)-(f[m>>2]|0)>>2>>>0>a>>>0&1;a=f[o>>2]|0;o=f[n>>2]|0;n=o;if((a|0)==(o|0)){u=g;return 0}m=f[i>>2]|0;i=f[f[e>>2]>>2]|0;e=a-o>>3;o=0;do{a=o+s|0;f[i+(a<<2)>>2]=(f[n+(o<<3)>>2]|0)+(f[m+(a<<2)>>2]|0)+(f[n+(o<<3)+4>>2]|0);o=o+1|0}while(o>>>0<e>>>0);u=g;return 0}function vrb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+128|0;h=g;i=f[c+4>>2]|0;if((i|0)<=2){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,10)|0;k=445168;l=j+10|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,h,445179,452821,110)}k=f[c+40>>2]|0;j=2;do{f[h+(j+-2<<2)>>2]=f[k+(j<<2)>>2];j=j+1|0}while((j|0)!=(i|0));j=f[c+44>>2]|0;k=(f[c+16>>2]|0)+(Y(f[j>>2]|0,d)|0)|0;dT(a,i+-2|0,h,f[c>>2]&4095,k+(Y(f[j+4>>2]|0,e)|0)|0,0);u=g;return}function wrb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){XIc(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)mCc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;XIc(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;YDc(h);return}function xrb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=f[a>>2]|0;e=d;g=(f[b>>2]|0)-e|0;b=d+(g>>3<<3)|0;h=a+4|0;i=f[h>>2]|0;j=a+8|0;k=f[j>>2]|0;l=i;m=k;if(i>>>0<k>>>0){if((b|0)==(i|0)){k=c;n=f[k+4>>2]|0;o=b;f[o>>2]=f[k>>2];f[o+4>>2]=n;f[h>>2]=(f[h>>2]|0)+8;p=b;return p|0}n=l-(b+8)|0;o=n>>3;k=b+(o<<3)|0;if(k>>>0<i>>>0){q=k;k=i;do{r=q;s=f[r+4>>2]|0;t=k;f[t>>2]=f[r>>2];f[t+4>>2]=s;q=q+8|0;k=(f[h>>2]|0)+8|0;f[h>>2]=k}while(q>>>0<i>>>0)}if(o|0)fJc(i+(0-o<<3)|0,b|0,n|0)|0;if(b>>>0>c>>>0)u=c;else u=(f[h>>2]|0)>>>0>c>>>0?c+8|0:c;n=u;u=f[n+4>>2]|0;o=b;f[o>>2]=f[n>>2];f[o+4>>2]=u;p=b;return p|0}u=(l-e>>3)+1|0;if(u>>>0>536870911)mCc(a);l=m-e|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<u>>>0?u:e):536870911;e=b;u=g>>3;do if(m)if(m>>>0>536870911){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{l=VDc(m<<3)|0;v=l;w=l;break}else{v=0;w=0}while(0);l=w+(u<<3)|0;o=l;n=w+(m<<3)|0;do if((u|0)==(m|0)){if((g|0)>0){i=l+(((m+1|0)/-2|0)<<3)|0;x=i;y=n;z=i;A=d;break}i=m<<3>>2;q=(i|0)==0?1:i;if(q>>>0>536870911){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}i=VDc(q<<3)|0;k=i+(q>>>2<<3)|0;s=k;t=i+(q<<3)|0;if(!w){x=s;y=t;z=k;A=d}else{YDc(v);x=s;y=t;z=k;A=f[a>>2]|0}}else{x=o;y=n;z=l;A=d}while(0);d=c;c=f[d+4>>2]|0;l=z;f[l>>2]=f[d>>2];f[l+4>>2]=c;c=x+8|0;l=x;x=e-A|0;d=l+(0-(x>>3)<<3)|0;if((x|0)>0)dJc(d|0,A|0,x|0)|0;x=(f[h>>2]|0)-e|0;if((x|0)>0){dJc(c|0,b|0,x|0)|0;B=c+(x>>>3<<3)|0}else B=c;c=f[a>>2]|0;f[a>>2]=d;f[h>>2]=B;f[j>>2]=y;if(!c){p=l;return p|0}YDc(c);p=l;return p|0}function yrb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function zrb(a,b){a=a|0;b=b|0;var c=0;c=VDc(44)|0;Arb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=100460;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Arb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=100480;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,4)|0;b[g>>0]=97;b[g+1>>0]=120;b[g+2>>0]=105;b[g+3>>0]=115;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1154740:i;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((Ioc((n|0)==0?1154740:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<=-1:0){p=1;break}k=DHa(o+24|0,-1)|0;p=k}else p=1}else p=1;while(0);f[a+36>>2]=p;uT(e);f[e>>2]=0;f[e+4>>2]=0;p=tT(e,8)|0;o=p;b[o>>0]=101;b[o+1>>0]=110;b[o+2>>0]=100;b[o+3>>0]=95;o=p+4|0;b[o>>0]=97;b[o+1>>0]=120;b[o+2>>0]=105;b[o+3>>0]=115;o=f[g>>2]|0;if(!o){q=-1;r=a+40|0;f[r>>2]=q;uT(e);KHa(a,c);u=d;return}p=f[e>>2]|0;h=(p|0)==0?1154740:p;k=g;l=o;b:while(1){o=l;while(1){n=f[o+16>>2]|0;if((n|0)==(p|0))break;if((Ioc((n|0)==0?1154740:n,h)|0)>=0)break;n=f[o+4>>2]|0;if(!n){s=k;break b}else o=n}l=f[o>>2]|0;if(!l){s=o;break}else k=o}if((s|0)==(g|0)){q=-1;r=a+40|0;f[r>>2]=q;uT(e);KHa(a,c);u=d;return}g=f[s+16>>2]|0;if((p|0)!=(g|0)?(Ioc(h,(g|0)==0?1154740:g)|0)<=-1:0){q=-1;r=a+40|0;f[r>>2]=q;uT(e);KHa(a,c);u=d;return}g=DHa(s+24|0,-1)|0;q=g;r=a+40|0;f[r>>2]=q;uT(e);KHa(a,c);u=d;return}function Brb(a){a=a|0;YDc(a);return}function Crb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Drb(a){a=a|0;REa(a);YDc(a);return}function Erb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+112|0;a=d+96|0;e=d+84|0;g=d+72|0;h=d;i=d+56|0;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f$(b,a);f$(c,e);if((f[j>>2]|0)==(f[a>>2]|0)){mx(e);mx(a);u=d;return}c=g+4|0;b=g+8|0;k=i+8|0;l=i+4|0;m=h+36|0;n=h+16|0;o=h+4|0;p=h+40|0;q=h+44|0;r=h+48|0;s=0;do{t=f[e>>2]|0;v=f[t+(s*56|0)+4>>2]|0;w=f[t+(s*56|0)+40>>2]|0;f[g>>2]=0;f[c>>2]=0;f[b>>2]=0;lFa(g,w,w+(v<<2)|0);v=f[a>>2]|0;if((f[v+(s*56|0)+16>>2]|0)!=(f[(f[e>>2]|0)+(s*56|0)+16>>2]|0)){w=f[g>>2]|0;mT(h,v+(s*56|0)|0,1,(f[c>>2]|0)-w>>2,w);w=(f[e>>2]|0)+(s*56|0)|0;v=k;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[l>>2]=w;h_(h,i);w=f[m>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)_S(h);f[m>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[o>>2]|0)>0){w=f[p>>2]|0;v=0;do{f[w+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[o>>2]|0))}v=f[q>>2]|0;if((v|0)!=(r|0))g0(v)}v=f[g>>2]|0;if(v|0){w=f[c>>2]|0;if((w|0)!=(v|0))f[c>>2]=w+(~((w+-4-v|0)>>>2)<<2);YDc(v)}s=s+1|0}while(s>>>0<(((f[j>>2]|0)-(f[a>>2]|0)|0)/56|0)>>>0);mx(e);mx(a);u=d;return}function Frb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=vmb()|0;break}default:c=0}return c|0}function Grb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Hrb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+32|0;d=g+8|0;h=g;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;l=k;if((j|0)==(k|0)){f[d>>2]=0;f[d+4>>2]=0;m=tT(d,17)|0;n=449134;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,452925,436565,76)}p=(j-k|0)/12|0;j=f[l+4>>2]|0;q=k;a:do if(p>>>0>1){k=f[q>>2]|0;r=j-k|0;s=k;k=1;b:while(1){t=f[l+(k*12|0)+4>>2]|0;v=f[l+(k*12|0)>>2]|0;w=v;x=t;if((t-v|0)!=(r|0)){y=10;break}if((w|0)!=(x|0)){v=w;w=s;while(1){if((f[v>>2]|0)!=(f[w>>2]|0)){y=10;break b}v=v+4|0;if((v|0)==(x|0))break;else w=w+4|0}}k=k+1|0;if(k>>>0>=p>>>0)break a}if((y|0)==10){f[d>>2]=0;f[d+4>>2]=0;m=tT(d,22)|0;n=436643;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,452925,436565,79)}}while(0);p=f[q>>2]|0;q=j-p>>2;k=f[a+36>>2]|0;s=((k|0)<0?q:0)+k|0;k=f[a+40>>2]|0;a=((k|0)<0?q:0)+k|0;if((s|0)<=-1){f[d>>2]=0;f[d+4>>2]=0;m=tT(d,14)|0;n=436666;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,452925,436565,86)}if(!((a|0)>=(s|0)&(a|0)<(q|0))){f[d>>2]=0;f[d+4>>2]=0;m=tT(d,46)|0;n=436681;o=m+46|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,452925,436565,87)}k=a+1|0;if((k|0)==-1){z=q;A=p;B=p}else{p=f[l>>2]|0;z=k;A=p;B=p}if((A|0)!=(j|0)){p=j-B>>2;if((s|0)>(p|0)){f[d>>2]=0;C=d+4|0;f[C>>2]=0;D=tT(d,70)|0;m=D;n=452744;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,452815,452821,161)}if((s|0)>(z|0)|(z|0)>(p|0)){f[d>>2]=0;C=d+4|0;f[C>>2]=0;D=tT(d,70)|0;m=D;n=452744;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,452815,452821,161)}if((s|0)<(z|0)){D=1;C=s;while(1){p=Y(f[A+(C<<2)>>2]|0,D)|0;C=C+1|0;if((C|0)==(z|0)){E=p;break}else D=p}}else E=1}else E=0;f[d>>2]=0;D=d+4|0;f[D>>2]=0;f[d+8>>2]=0;z=d+8|0;if((s|0)>0){C=0;A=l;l=0;p=0;while(1){B=(f[A>>2]|0)+(C<<2)|0;if((l|0)==(p|0))g6(d,B);else{f[l>>2]=f[B>>2];f[D>>2]=l+4}B=C+1|0;if((B|0)>=(s|0))break;C=B;A=f[c>>2]|0;l=f[D>>2]|0;p=f[z>>2]|0}p=f[D>>2]|0;l=f[z>>2]|0;f[h>>2]=E;if((p|0)==(l|0)){F=h;y=28}else{f[p>>2]=E;f[D>>2]=p+4;G=h}}else{f[h>>2]=E;F=h;y=28}if((y|0)==28){g6(d,h);G=F}if(k>>>0<q>>>0){F=k;do{k=(f[f[c>>2]>>2]|0)+(F<<2)|0;G=f[D>>2]|0;if((G|0)==(f[z>>2]|0))g6(d,k);else{f[G>>2]=f[k>>2];f[D>>2]=G+4}F=F+1|0}while(F>>>0<q>>>0)}if((f[D>>2]|0)-(f[d>>2]|0)>>2>>>0>=5){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,26)|0;n=436728;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,452925,436565,101)}h=((f[i>>2]|0)-(f[c>>2]|0)|0)/12|0;c=e+4|0;i=f[c>>2]|0;n=f[e>>2]|0;m=(i-n|0)/12|0;o=n;n=i;if(h>>>0<=m>>>0){if(h>>>0<m>>>0?(i=o+(h*12|0)|0,(n|0)!=(i|0)):0){o=n;while(1){n=o+-12|0;f[c>>2]=n;q=f[n>>2]|0;if(!q)H=n;else{n=o+-8|0;F=f[n>>2]|0;if((F|0)!=(q|0))f[n>>2]=F+(~((F+-4-q|0)>>>2)<<2);YDc(q);H=f[c>>2]|0}if((H|0)==(i|0))break;else o=H}}}else npb(e,h-m|0,d);m=f[d>>2]|0;if(!m){u=g;return 1}d=f[D>>2]|0;if((d|0)!=(m|0))f[D>>2]=d+(~((d+-4-m|0)>>>2)<<2);YDc(m);u=g;return 1}function Irb(a,b){a=a|0;b=b|0;var c=0;c=VDc(52)|0;Jrb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=100588;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Jrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;JHa(a);f[a+36>>2]=0;i=a+40|0;f[i>>2]=0;f[a+44>>2]=0;f[a>>2]=100608;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;j=tT(e,4)|0;b[j>>0]=97;b[j+1>>0]=120;b[j+2>>0]=105;b[j+3>>0]=115;j=c+4|0;k=f[j>>2]|0;do if(k){l=f[e>>2]|0;m=(l|0)==0?1154740:l;n=j;o=k;a:while(1){p=o;while(1){q=f[p+16>>2]|0;if((q|0)==(l|0))break;if((Ioc((q|0)==0?1154740:q,m)|0)>=0)break;q=f[p+4>>2]|0;if(!q){r=n;break a}else p=q}o=f[p>>2]|0;if(!o){r=p;break}else n=p}if((r|0)!=(j|0)){n=f[r+16>>2]|0;if((l|0)!=(n|0)?(Ioc(m,(n|0)==0?1154740:n)|0)<=-1:0){s=1;break}n=DHa(r+24|0,-1)|0;s=n}else s=1}else s=1;while(0);r=a+48|0;f[r>>2]=s;uT(e);f[e>>2]=0;f[e+4>>2]=0;s=tT(e,11)|0;k=436910;n=s+11|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));o=f[j>>2]|0;do if(!o)uT(e);else{q=f[e>>2]|0;t=(q|0)==0?1154740:q;v=o;while(1){w=f[v+16>>2]|0;if((q|0)==(w|0)){x=20;break}y=(w|0)==0?1154740:w;if((Ioc(t,y)|0)<0)z=v;else{if((Ioc(y,t)|0)>=0){x=21;break}z=v+4|0}v=f[z>>2]|0;if(!v){x=89;break}}if((x|0)==20)uT(e);else if((x|0)==21)uT(e);else if((x|0)==89){uT(e);break}f[e>>2]=0;f[e+4>>2]=0;v=tT(e,5)|0;b[v>>0]=b[436922]|0;b[v+1>>0]=b[436923]|0;b[v+2>>0]=b[436924]|0;b[v+3>>0]=b[436925]|0;b[v+4>>0]=b[436926]|0;v=f[j>>2]|0;b:do if(v|0){t=f[e>>2]|0;q=(t|0)==0?1154740:t;m=v;while(1){l=f[m+16>>2]|0;if((t|0)==(l|0)){x=47;break}y=(l|0)==0?1154740:l;if((Ioc(q,y)|0)<0)A=m;else{if((Ioc(y,q)|0)>=0){x=48;break}A=m+4|0}m=f[A>>2]|0;if(!m)break b}if((x|0)==47){uT(e);f[e>>2]=0;B=e+4|0;f[B>>2]=0;C=tT(e,65)|0;s=C;k=436932;n=s+65|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,66)}else if((x|0)==48){uT(e);f[e>>2]=0;B=e+4|0;f[B>>2]=0;C=tT(e,65)|0;s=C;k=436932;n=s+65|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,66)}}while(0);f[g>>2]=0;f[g+4>>2]=0;v=tT(g,4)|0;b[v>>0]=115;b[v+1>>0]=105;b[v+2>>0]=122;b[v+3>>0]=101;v=f[j>>2]|0;c:do if(v|0){m=f[g>>2]|0;q=(m|0)==0?1154740:m;t=v;while(1){p=f[t+16>>2]|0;if((m|0)==(p|0)){x=50;break}y=(p|0)==0?1154740:p;if((Ioc(q,y)|0)<0)D=t;else{if((Ioc(y,q)|0)>=0){x=49;break}D=t+4|0}t=f[D>>2]|0;if(!t)break c}if((x|0)==49){uT(g);uT(e);f[e>>2]=0;B=e+4|0;f[B>>2]=0;C=tT(e,65)|0;s=C;k=436932;n=s+65|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,66)}else if((x|0)==50){uT(g);uT(e);f[e>>2]=0;B=e+4|0;f[B>>2]=0;C=tT(e,65)|0;s=C;k=436932;n=s+65|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,66)}}while(0);f[h>>2]=0;f[h+4>>2]=0;v=tT(h,3)|0;b[v>>0]=b[436928]|0;b[v+1>>0]=b[436929]|0;b[v+2>>0]=b[436930]|0;v=f[j>>2]|0;do if(v){t=f[h>>2]|0;q=(t|0)==0?1154740:t;m=v;while(1){y=f[m+16>>2]|0;if((t|0)==(y|0)){x=46;break}p=(y|0)==0?1154740:y;if((Ioc(q,p)|0)<0)E=m;else{if((Ioc(p,q)|0)>=0){x=51;break}E=m+4|0}m=f[E>>2]|0;if(!m){x=54;break}}if((x|0)==46){uT(h);uT(g);uT(e);f[e>>2]=0;B=e+4|0;f[B>>2]=0;C=tT(e,65)|0;s=C;k=436932;n=s+65|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,66)}else if((x|0)==51){uT(h);uT(g);uT(e);f[e>>2]=0;B=e+4|0;f[B>>2]=0;C=tT(e,65)|0;s=C;k=436932;n=s+65|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,66)}else if((x|0)==54){uT(h);uT(g);uT(e);break}}else{uT(h);uT(g);uT(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;s=tT(e,11)|0;k=436910;n=s+11|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));v=lIa(c,e)|0;uT(e);m=a+36|0;switch(f[v>>2]|0){case 0:{F=(f[v+4>>2]|0)+4|0;break}case 3:{F=(f[v+4>>2]|0)+4|0;break}case 2:{F=(f[v+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}q=(f[F>>2]|0)+1|0;t=(f[r>>2]|0)+1|0;f[e>>2]=0;p=e+4|0;f[p>>2]=0;f[e+8>>2]=0;if(t|0){if(t>>>0>536870911)mCc(e);y=VDc(t<<3)|0;f[p>>2]=y;f[e>>2]=y;f[e+8>>2]=y+(t<<3);l=t;w=y;G=y;while(1){H=w;f[H>>2]=-2147483648;f[H+4>>2]=2147483647;H=G+8|0;I=l+-1|0;if(!I)break;else{l=I;w=H;G=H}}f[p>>2]=y+(t<<3)}G=f[i>>2]|0;w=f[m>>2]|0;l=(G-w|0)/12|0;H=w;w=G;if(q>>>0<=l>>>0){if(q>>>0<l>>>0?(G=H+(q*12|0)|0,(w|0)!=(G|0)):0){H=w;while(1){w=H+-12|0;f[i>>2]=w;I=f[w>>2]|0;if(!I)J=w;else{w=H+-8|0;K=f[w>>2]|0;if((K|0)!=(I|0))f[w>>2]=K+(~((K+-8-I|0)>>>3)<<3);YDc(I);J=f[i>>2]|0}if((J|0)==(G|0))break;else H=J}}}else Mrb(m,q-l|0,e);H=f[e>>2]|0;if(H|0){G=f[p>>2]|0;if((G|0)!=(H|0))f[p>>2]=G+(~((G+-8-H|0)>>>3)<<3);YDc(H)}H=v+4|0;G=v+4|0;t=0;y=0;d:while(1){switch(f[v>>2]|0){case 0:{L=(f[H>>2]|0)+4|0;break}case 3:{L=(f[G>>2]|0)+4|0;break}case 2:{L=(f[G>>2]|0)+4|0;break}default:{x=84;break d}}if((t|0)>=(f[L>>2]|0))break;f[(f[(f[m>>2]|0)+(t*12|0)>>2]|0)+(f[r>>2]<<3)>>2]=y;I=DHa(v,t)|0;f[(f[(f[m>>2]|0)+(t*12|0)>>2]|0)+(f[r>>2]<<3)+4>>2]=I;t=t+1|0;y=I}if((x|0)==84){f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}f[(f[(f[i>>2]|0)+-12>>2]|0)+(f[r>>2]<<3)>>2]=y;u=d;return}while(0);f[e>>2]=0;f[e+4>>2]=0;r=tT(e,5)|0;b[r>>0]=b[436922]|0;b[r+1>>0]=b[436923]|0;b[r+2>>0]=b[436924]|0;b[r+3>>0]=b[436925]|0;b[r+4>>0]=b[436926]|0;r=f[j>>2]|0;if(!r){uT(e);u=d;return}L=f[e>>2]|0;J=(L|0)==0?1154740:L;F=r;while(1){r=f[F+16>>2]|0;if((L|0)==(r|0)){x=98;break}h=(r|0)==0?1154740:r;if((Ioc(J,h)|0)<0)M=F;else{if((Ioc(h,J)|0)>=0){x=99;break}M=F+4|0}F=f[M>>2]|0;if(!F){x=187;break}}if((x|0)==98)uT(e);else if((x|0)==99)uT(e);else if((x|0)==187){uT(e);u=d;return}f[e>>2]=0;f[e+4>>2]=0;F=tT(e,4)|0;b[F>>0]=115;b[F+1>>0]=105;b[F+2>>0]=122;b[F+3>>0]=101;F=f[j>>2]|0;e:do if(!F)N=0;else{M=f[e>>2]|0;J=(M|0)==0?1154740:M;L=F;while(1){h=f[L+16>>2]|0;if((M|0)==(h|0)){N=1;break e}r=(h|0)==0?1154740:h;if((Ioc(J,r)|0)<0)O=L;else{if((Ioc(r,J)|0)>=0){N=1;break e}O=L+4|0}L=f[O>>2]|0;if(!L){N=0;break}}}while(0);f[g>>2]=0;f[g+4>>2]=0;O=tT(g,3)|0;b[O>>0]=b[436928]|0;b[O+1>>0]=b[436929]|0;b[O+2>>0]=b[436930]|0;O=f[j>>2]|0;f:do if(!O)P=0;else{F=f[g>>2]|0;L=(F|0)==0?1154740:F;J=O;while(1){M=f[J+16>>2]|0;if((F|0)==(M|0)){P=1;break f}y=(M|0)==0?1154740:M;if((Ioc(L,y)|0)<0)Q=J;else{if((Ioc(y,L)|0)>=0){P=1;break f}Q=J+4|0}J=f[Q>>2]|0;if(!J){P=0;break}}}while(0);uT(g);uT(e);if(!(N^P)){f[e>>2]=0;f[e+4>>2]=0;s=tT(e,38)|0;k=437089;n=s+38|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,81)}f[e>>2]=0;f[e+4>>2]=0;P=tT(e,5)|0;b[P>>0]=b[436922]|0;b[P+1>>0]=b[436923]|0;b[P+2>>0]=b[436924]|0;b[P+3>>0]=b[436925]|0;b[P+4>>0]=b[436926]|0;P=lIa(c,e)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;N=tT(e,4)|0;b[N>>0]=115;b[N+1>>0]=105;b[N+2>>0]=122;b[N+3>>0]=101;N=f[j>>2]|0;g:do if(!N)x=127;else{Q=f[e>>2]|0;O=(Q|0)==0?1154740:Q;J=N;while(1){L=f[J+16>>2]|0;if((Q|0)==(L|0))break;F=(L|0)==0?1154740:L;if((Ioc(O,F)|0)<0)R=J;else{if((Ioc(F,O)|0)>=0)break;R=J+4|0}J=f[R>>2]|0;if(!J){x=127;break g}}f[g>>2]=0;f[g+4>>2]=0;J=tT(g,4)|0;b[J>>0]=115;b[J+1>>0]=105;b[J+2>>0]=122;b[J+3>>0]=101;J=lIa(c,g)|0;uT(g);S=J}while(0);if((x|0)==127){f[g>>2]=0;f[g+4>>2]=0;R=tT(g,3)|0;b[R>>0]=b[436928]|0;b[R+1>>0]=b[436929]|0;b[R+2>>0]=b[436930]|0;R=lIa(c,g)|0;uT(g);S=R}uT(e);switch(f[P>>2]|0){case 0:{T=(f[P+4>>2]|0)+4|0;break}case 3:{T=(f[P+4>>2]|0)+4|0;break}case 2:{T=(f[P+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}R=f[T>>2]|0;switch(f[S>>2]|0){case 0:{U=(f[S+4>>2]|0)+4|0;break}case 3:{U=(f[S+4>>2]|0)+4|0;break}case 2:{U=(f[S+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}if((R|0)!=(f[U>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;s=tT(e,35)|0;k=437128;n=s+35|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,84)}U=a+36|0;a=f[i>>2]|0;R=f[U>>2]|0;T=a-R|0;g=(T|0)/12|0;c=R;R=a;if(T){if(g>>>0>1?(T=c+12|0,(R|0)!=(T|0)):0){c=R;while(1){R=c+-12|0;f[i>>2]=R;a=f[R>>2]|0;if(!a)V=R;else{R=c+-8|0;N=f[R>>2]|0;if((N|0)!=(a|0))f[R>>2]=N+(~((N+-8-a|0)>>>3)<<3);YDc(a);V=f[i>>2]|0}if((V|0)==(T|0))break;else c=V}}}else Nrb(U,1-g|0);g=f[U>>2]|0;switch(f[P>>2]|0){case 0:{W=(f[P+4>>2]|0)+4|0;break}case 3:{W=(f[P+4>>2]|0)+4|0;break}case 2:{W=(f[P+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}V=f[W>>2]|0;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;W=g+4|0;c=f[W>>2]|0;T=f[g>>2]|0;i=c-T>>3;a=T;T=c;if(V>>>0<=i>>>0){if(V>>>0<i>>>0?(c=a+(V<<3)|0,(T|0)!=(c|0)):0)f[W>>2]=T+(~((T+-8-c|0)>>>3)<<3)}else Orb(g,V-i|0,e);i=P+4|0;V=e+4|0;g=P+4|0;c=0;h:while(1){switch(f[P>>2]|0){case 0:{X=(f[i>>2]|0)+4|0;break}case 3:{X=(f[g>>2]|0)+4|0;break}case 2:{X=(f[g>>2]|0)+4|0;break}default:{x=164;break h}}if((c|0)>=(f[X>>2]|0)){x=188;break}T=DHa(P,c)|0;W=DHa(S,c)|0;if((T|0)<=-1){x=167;break}f[(f[f[U>>2]>>2]|0)+(c<<3)>>2]=T;f[e>>2]=0;f[V>>2]=0;a=tT(e,4)|0;b[a>>0]=115;b[a+1>>0]=105;b[a+2>>0]=122;b[a+3>>0]=101;a=f[j>>2]|0;do if(!a){uT(e);x=183}else{N=f[e>>2]|0;R=(N|0)==0?1154740:N;J=a;while(1){O=f[J+16>>2]|0;if((N|0)==(O|0)){x=176;break}Q=(O|0)==0?1154740:O;if((Ioc(R,Q)|0)<0)Y=J;else{if((Ioc(Q,R)|0)>=0){x=177;break}Y=J+4|0}J=f[Y>>2]|0;if(!J){x=182;break}}if((x|0)==176){x=0;uT(e)}else if((x|0)==177){x=0;uT(e)}else if((x|0)==182){x=0;uT(e);x=183;break}J=(W|0)>0;if(!((W|0)==-1|J)){x=179;break h}Z=J?W+T|0:-1}while(0);if((x|0)==183){x=0;if((W|0)<0|(W|0)>(T|0))Z=W;else{x=184;break}}f[(f[f[U>>2]>>2]|0)+(c<<3)+4>>2]=Z;c=c+1|0}if((x|0)==164){f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}else if((x|0)==167){f[e>>2]=0;f[e+4>>2]=0;s=tT(e,10)|0;k=437164;n=s+10|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,92)}else if((x|0)==179){f[e>>2]=0;f[e+4>>2]=0;s=tT(e,22)|0;k=437175;n=s+22|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,98)}else if((x|0)==184){f[e>>2]=0;f[e+4>>2]=0;s=tT(e,22)|0;k=437198;n=s+22|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));z5(-215,e,436998,437013,104)}else if((x|0)==188){u=d;return}}function Krb(a){a=a|0;YDc(a);return}function Lrb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Mrb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=b;j=h;do{Rrb(j,c);j=(f[g>>2]|0)+12|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/12|0;h=j+b|0;if(h>>>0>357913941)mCc(a);k=(e-i|0)/12|0;i=k<<1;e=k>>>0<178956970?(i>>>0<h>>>0?h:i):357913941;do if(e)if(e>>>0>357913941){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{l=VDc(e*12|0)|0;break}else l=0;while(0);i=l+(j*12|0)|0;j=i;h=l+(e*12|0)|0;e=b;b=j;l=i;do{Rrb(l,c);l=b+12|0;b=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(e|0)){m=j;n=e;o=e}else{c=l;l=j;j=i;do{c=c+-12|0;Rrb(j+-12|0,c);j=l+-12|0;l=j}while((c|0)!=(e|0));m=l;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=b;f[d>>2]=h;h=n;if((o|0)!=(h|0)){d=o;do{o=d;d=d+-12|0;b=f[d>>2]|0;if(b|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(b|0))f[g>>2]=o+(~((o+-8-b|0)>>>3)<<3);YDc(b)}}while((d|0)!=(h|0))}if(!n)return;YDc(n);return}function Nrb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){XIc(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)mCc(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{n=VDc(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;XIc(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{g=g+-12|0;Rrb(j+-12|0,g);j=h+-12|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~((q+-8-d|0)>>>3)<<3);YDc(d)}}while((c|0)!=(k|0))}if(!p)return;YDc(p);return}function Orb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>3>>>0>=b>>>0){i=b;j=h;do{k=c;l=f[k+4>>2]|0;m=j;f[m>>2]=f[k>>2];f[m+4>>2]=l;j=(f[g>>2]|0)+8|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>3;h=j+b|0;if(h>>>0>536870911)mCc(a);l=e-i|0;i=l>>2;e=l>>3>>>0<268435455?(i>>>0<h>>>0?h:i):536870911;do if(e)if(e>>>0>536870911){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{n=VDc(e<<3)|0;break}else n=0;while(0);i=n+(j<<3)|0;j=n+(e<<3)|0;e=b;b=i;n=i;do{h=c;l=f[h+4>>2]|0;m=b;f[m>>2]=f[h>>2];f[m+4>>2]=l;b=n+8|0;n=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>3)<<3)|0;if((b|0)>0)dJc(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=n;f[d>>2]=j;if(!e)return;YDc(e);return}function Prb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=100716;b=a+36|0;c=f[b>>2]|0;if(!c){REa(a);return}d=a+40|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);YDc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}YDc(g);REa(a);return}function Qrb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=100716;b=a+36|0;c=f[b>>2]|0;if(!c){REa(a);YDc(a);return}d=a+40|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);YDc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}YDc(g);REa(a);YDc(a);return}function Rrb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;dJc(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>3<<3);return}function Srb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=100716;b=a+36|0;c=f[b>>2]|0;if(!c){REa(a);YDc(a);return}d=a+40|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);YDc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}YDc(g);REa(a);YDc(a);return}function Trb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;f[g>>2]=0;j=g+4|0;f[j>>2]=0;f[g+8>>2]=0;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=f[g>>2]|0;if(((f[j>>2]|0)-d|0)!=56){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,18)|0;m=453187;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,453718,437013,153)}j=d+40|0;d=a+36|0;c=f[d>>2]|0;o=a+40|0;p=f[o>>2]|0;q=p;r=c;if((c|0)!=(p|0)){p=f[k>>2]|0;c=f[h>>2]|0;if(((p-c|0)/56|0|0)==((q-r|0)/12|0|0)){s=h;t=k;v=p;w=c}else{f[i>>2]=0;f[i+4>>2]=0;l=tT(i,36)|0;m=437464;n=l+36|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,453718,437013,171)}}else{c=a+48|0;a=f[c>>2]|0;p=((f[k>>2]|0)-(f[h>>2]|0)|0)/56|0;x=((f[(f[j>>2]|0)+(a<<2)>>2]|0)>>>0)/(p>>>0)|0;y=a+1|0;f[i>>2]=0;a=i+4|0;f[a>>2]=0;f[i+8>>2]=0;if(!y){z=r;A=q}else{if(y>>>0>536870911)mCc(i);q=VDc(y<<3)|0;f[a>>2]=q;f[i>>2]=q;f[i+8>>2]=q+(y<<3);r=y;B=q;C=q;while(1){D=B;f[D>>2]=-2147483648;f[D+4>>2]=2147483647;D=C+8|0;E=r+-1|0;if(!E)break;else{r=E;B=D;C=D}}f[a>>2]=q+(y<<3);z=f[d>>2]|0;A=f[o>>2]|0}y=(A-z|0)/12|0;q=z;z=A;if(p>>>0<=y>>>0){if(p>>>0<y>>>0?(A=q+(p*12|0)|0,(z|0)!=(A|0)):0){q=z;while(1){z=q+-12|0;f[o>>2]=z;C=f[z>>2]|0;if(!C)F=z;else{z=q+-8|0;B=f[z>>2]|0;if((B|0)!=(C|0))f[z>>2]=B+(~((B+-8-C|0)>>>3)<<3);YDc(C);F=f[o>>2]|0}if((F|0)==(A|0))break;else q=F}}}else Mrb(d,p-y|0,i);y=f[i>>2]|0;if(y|0){p=f[a>>2]|0;if((p|0)!=(y|0))f[a>>2]=p+(~((p+-8-y|0)>>>3)<<3);YDc(y)}y=f[k>>2]|0;p=f[h>>2]|0;if((y|0)==(p|0)){mx(h);mx(g);u=e;return}a=f[d>>2]|0;F=f[c>>2]|0;c=(y-p|0)/56|0;q=0;A=0;do{o=f[a+(q*12|0)>>2]|0;f[o+(F<<3)>>2]=A;A=A+x|0;f[o+(F<<3)+4>>2]=A;q=q+1|0}while(q>>>0<c>>>0);s=h;t=k;v=y;w=p}if((v|0)==(w|0)){mx(h);mx(g);u=e;return}w=i+4|0;v=0;p=f[j>>2]|0;while(1){y=f[d>>2]|0;k=(f[y+(v*12|0)+4>>2]|0)-(f[y+(v*12|0)>>2]|0)>>3;c=f[p+-4>>2]|0;if(k>>>0>c>>>0){G=33;break}if(!k){H=0;I=c;J=y;K=p}else{c=0;k=y;y=p;do{Yrb(i,(f[k+(v*12|0)>>2]|0)+(c<<3)|0,f[y+(c<<2)>>2]|0);q=i;A=f[q+4>>2]|0;F=(f[(f[d>>2]|0)+(v*12|0)>>2]|0)+(c<<3)|0;f[F>>2]=f[q>>2];f[F+4>>2]=A;c=c+1|0;k=f[d>>2]|0;L=(f[k+(v*12|0)+4>>2]|0)-(f[k+(v*12|0)>>2]|0)>>3;y=f[j>>2]|0}while(c>>>0<L>>>0);H=L;I=f[y+-4>>2]|0;J=k;K=y}a:do if((H|0)<(I|0)){c=H;A=J;while(1){f[i>>2]=-2147483648;f[w>>2]=2147483647;F=A+(v*12|0)+4|0;q=f[F>>2]|0;if((q|0)==(f[A+(v*12|0)+8>>2]|0))yrb(A+(v*12|0)|0,i);else{x=i;a=f[x+4>>2]|0;o=q;f[o>>2]=f[x>>2];f[o+4>>2]=a;f[F>>2]=(f[F>>2]|0)+8}F=c+1|0;a=f[j>>2]|0;if((F|0)>=(f[a+-4>>2]|0)){M=a;break a}c=F;A=f[d>>2]|0}}else M=K;while(0);v=v+1|0;if(v>>>0>=(((f[t>>2]|0)-(f[s>>2]|0)|0)/56|0)>>>0){G=30;break}else p=M}if((G|0)==30){mx(h);mx(g);u=e;return}else if((G|0)==33){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,40)|0;m=437501;n=l+40|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,453718,437013,175)}}function Urb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+96|0;g=e+84|0;h=e+72|0;i=e+56|0;j=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=f[g>>2]|0;c=f[k>>2]|0;l=f[h>>2]|0;m=a+36|0;n=f[m>>2]|0;o=n;if(((c-l|0)/56|0|0)!=(((f[a+40>>2]|0)-n|0)/12|0|0)){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,36)|0;a=437464;p=n+36|0;do{b[n>>0]=b[a>>0]|0;n=n+1|0;a=a+1|0}while((n|0)<(p|0));z5(-215,i,453206,437013,250)}if((c|0)==(l|0)){mx(h);mx(g);u=e;return}l=i+8|0;c=i+4|0;a=j+36|0;n=j+16|0;p=j+4|0;q=j+40|0;r=j+44|0;s=j+48|0;t=0;v=o;while(1){fT(j,d,v+(t*12|0)|0);o=(f[h>>2]|0)+(t*56|0)|0;w=l;f[w>>2]=0;f[w+4>>2]=0;f[i>>2]=33619968;f[c>>2]=o;h_(j,i);o=f[a>>2]|0;if(o|0?(w=o+12|0,o=f[w>>2]|0,f[w>>2]=o+-1,(o|0)==1):0)_S(j);f[a>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[p>>2]|0)>0){o=f[q>>2]|0;w=0;do{f[o+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[p>>2]|0))}w=f[r>>2]|0;if((w|0)!=(s|0))g0(w);w=t+1|0;if(w>>>0>=(((f[k>>2]|0)-(f[h>>2]|0)|0)/56|0)>>>0)break;t=w;v=f[m>>2]|0}mx(h);mx(g);u=e;return}function Vrb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 2:{b=f[a+36>>2]|0;if(((f[a+40>>2]|0)-b|0)!=12){c=0;return c|0}c=((f[b+4>>2]|0)-(f[b>>2]|0)|0)==32;return c|0}case 3:{c=1;return c|0}default:{c=0;return c|0}}return 0}function Wrb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Xrb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=u;u=u+32|0;h=g+16|0;i=g;j=g+8|0;k=f[c>>2]|0;if(((f[c+4>>2]|0)-k|0)!=12){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,18)|0;m=453187;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,h,452925,437013,122)}jFa(h,k);k=a+36|0;c=f[k>>2]|0;o=f[a+40>>2]|0;a:do if((c|0)==(o|0)){p=f[a+48>>2]|0;if((p|0)<=-1){f[i>>2]=0;q=i+4|0;f[q>>2]=0;r=tT(i,35)|0;l=r;m=437309;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,452925,437013,139)}s=f[h>>2]|0;t=s;if(p>>>0>=(f[h+4>>2]|0)-s>>2>>>0){f[i>>2]=0;q=i+4|0;f[q>>2]=0;r=tT(i,35)|0;l=r;m=437309;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,452925,437013,139)}if((d|0)<=0){f[i>>2]=0;v=i+4|0;f[v>>2]=0;w=tT(i,60)|0;l=w;m=437345;n=l+60|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,452925,437013,140)}s=t+(p<<2)|0;x=f[s>>2]|0;if((x|0)%(d|0)|0|0){f[i>>2]=0;v=i+4|0;f[v>>2]=0;w=tT(i,60)|0;l=w;m=437345;n=l+60|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,452925,437013,140)}f[s>>2]=(x|0)/(d|0)|0;p=e+4|0;t=f[p>>2]|0;y=f[e>>2]|0;z=(t-y|0)/12|0;A=t;if(z>>>0<d>>>0){npb(e,d-z|0,h);B=h;break}if(z>>>0>d>>>0?(z=y+(d*12|0)|0,(A|0)!=(z|0)):0){y=A;while(1){A=y+-12|0;f[p>>2]=A;t=f[A>>2]|0;if(!t)C=A;else{A=y+-8|0;D=f[A>>2]|0;if((D|0)!=(t|0))f[A>>2]=D+(~((D+-4-t|0)>>>2)<<2);YDc(t);C=f[p>>2]|0}if((C|0)==(z|0)){B=h;break}else y=C}}else B=h}else{y=(o-c|0)/12|0;z=e+4|0;p=f[z>>2]|0;x=f[e>>2]|0;s=(p-x|0)/12|0;t=x;x=p;if(y>>>0<=s>>>0)if(y>>>0<s>>>0?(D=t+(y*12|0)|0,(x|0)!=(D|0)):0){t=x;while(1){x=t+-12|0;f[z>>2]=x;A=f[x>>2]|0;if(!A)E=x;else{x=t+-8|0;F=f[x>>2]|0;if((F|0)!=(A|0))f[x>>2]=F+(~((F+-4-A|0)>>>2)<<2);YDc(A);E=f[z>>2]|0}if((E|0)==(D|0))break;else t=E}G=E}else G=p;else{npb(e,y-s|0,h);G=f[z>>2]|0}t=f[e>>2]|0;if((G|0)==(t|0)){B=h;break}D=h+4|0;A=j+4|0;F=0;x=t;t=G;H=f[k>>2]|0;while(1){I=f[H+(F*12|0)+4>>2]|0;J=f[H+(F*12|0)>>2]|0;K=f[h>>2]|0;if(I-J>>3>>>0>(f[D>>2]|0)-K>>2>>>0)break;if((I|0)==(J|0)){L=H;M=x;N=t}else{J=0;I=H;O=K;while(1){Yrb(j,(f[I+(F*12|0)>>2]|0)+(J<<3)|0,f[O+(J<<2)>>2]|0);P=f[e>>2]|0;f[(f[P+(F*12|0)>>2]|0)+(J<<2)>>2]=(f[A>>2]|0)-(f[j>>2]|0);K=J+1|0;Q=f[k>>2]|0;if(K>>>0>=(f[Q+(F*12|0)+4>>2]|0)-(f[Q+(F*12|0)>>2]|0)>>3>>>0)break;J=K;I=Q;O=f[h>>2]|0}L=Q;M=P;N=f[z>>2]|0}F=F+1|0;if(F>>>0>=((N-M|0)/12|0)>>>0){B=h;break a}else{x=M;t=N;H=L}}f[i>>2]=0;f[i+4>>2]=0;l=tT(i,40)|0;m=437268;n=l+40|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,452925,437013,130)}while(0);i=f[B>>2]|0;if(!i){u=g;return 0}B=h+4|0;h=f[B>>2]|0;if((h|0)!=(i|0))f[B>>2]=h+(~((h+-4-i|0)>>>2)<<2);YDc(i);u=g;return 0}function Yrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;i=(h|0)>0?h:0;h=f[c+4>>2]|0;c=(h|0)>0?((h|0)>(d|0)?d:h):d+1+h|0;f[a>>2]=i;f[a+4>>2]=c;if((i|0)>=(c|0)){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,27)|0;k=437406;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,g,437434,452821,212)}if((c|0)>(d|0)){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,23)|0;k=437440;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,g,437434,452821,212)}else{u=e;return}}function Zrb(a,b){a=a|0;b=b|0;var c=0;c=VDc(176)|0;_rb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=100824;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function _rb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=100844;f[a+44>>2]=1124007936;g=a+52|0;h=a+84|0;i=a+48|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+92|0;f[a+88>>2]=g;f[g>>2]=0;f[a+96>>2]=0;f[a+100>>2]=1124007936;g=a+108|0;h=a+140|0;i=a+104|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+148|0;f[a+144>>2]=g;f[g>>2]=0;f[a+152>>2]=0;f[a+160>>2]=0;f[a+164>>2]=0;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;i=tT(e,18)|0;g=437644;j=i+18|0;do{b[i>>0]=b[g>>0]|0;i=i+1|0;g=g+1|0}while((i|0)<(j|0));h=c+4|0;c=f[h>>2]|0;do if(c){k=f[e>>2]|0;l=(k|0)==0?1154740:k;m=h;o=c;a:while(1){p=o;while(1){q=f[p+16>>2]|0;if((q|0)==(k|0))break;if((Ioc((q|0)==0?1154740:q,l)|0)>=0)break;q=f[p+4>>2]|0;if(!q){r=m;break a}else p=q}o=f[p>>2]|0;if(!o){r=p;break}else m=p}if((r|0)!=(h|0)){m=f[r+16>>2]|0;if((k|0)!=(m|0)?(Ioc(l,(m|0)==0?1154740:m)|0)<=-1:0){s=1;break}m=DHa(r+24|0,-1)|0;s=(m|0)!=0|(J|0)!=0}else s=1}else s=1;while(0);b[a+40>>0]=s&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;i=tT(e,15)|0;g=437663;j=i+15|0;do{b[i>>0]=b[g>>0]|0;i=i+1|0;g=g+1|0}while((i|0)<(j|0));g=f[h>>2]|0;do if(g){i=f[e>>2]|0;j=(i|0)==0?1154740:i;s=h;r=g;b:while(1){c=r;while(1){m=f[c+16>>2]|0;if((m|0)==(i|0))break;if((Ioc((m|0)==0?1154740:m,j)|0)>=0)break;m=f[c+4>>2]|0;if(!m){t=s;break b}else c=m}r=f[c>>2]|0;if(!r){t=c;break}else s=c}if((t|0)!=(h|0)){s=f[t+16>>2]|0;if((i|0)!=(s|0)?(Ioc(j,(s|0)==0?1154740:s)|0)<=-1:0){v=0;break}s=DHa(t+24|0,-1)|0;v=(s|0)!=0|(J|0)!=0}else v=0}else v=0;while(0);b[a+41>>0]=v&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;v=tT(e,3)|0;b[v>>0]=b[454985]|0;b[v+1>>0]=b[454986]|0;b[v+2>>0]=b[454987]|0;v=f[h>>2]|0;if(!v){w=1.0e-09;x=w;y=a+36|0;n[y>>2]=x;uT(e);z=a+156|0;b[z>>0]=0;A=a+172|0;b[A>>0]=0;B=a+168|0;n[B>>2]=0.0;C=a+173|0;b[C>>0]=0;u=d;return}t=f[e>>2]|0;g=(t|0)==0?1154740:t;s=h;r=v;c:while(1){v=r;while(1){l=f[v+16>>2]|0;if((l|0)==(t|0))break;if((Ioc((l|0)==0?1154740:l,g)|0)>=0)break;l=f[v+4>>2]|0;if(!l){D=s;break c}else v=l}r=f[v>>2]|0;if(!r){D=v;break}else s=v}if((D|0)==(h|0)){w=1.0e-09;x=w;y=a+36|0;n[y>>2]=x;uT(e);z=a+156|0;b[z>>0]=0;A=a+172|0;b[A>>0]=0;B=a+168|0;n[B>>2]=0.0;C=a+173|0;b[C>>0]=0;u=d;return}h=f[D+16>>2]|0;if((t|0)!=(h|0)?(Ioc(g,(h|0)==0?1154740:h)|0)<=-1:0){w=1.0e-09;x=w;y=a+36|0;n[y>>2]=x;uT(e);z=a+156|0;b[z>>0]=0;A=a+172|0;b[A>>0]=0;B=a+168|0;n[B>>2]=0.0;C=a+173|0;b[C>>0]=0;u=d;return}w=+tIa(D+24|0,-1);x=w;y=a+36|0;n[y>>2]=x;uT(e);z=a+156|0;b[z>>0]=0;A=a+172|0;b[A>>0]=0;B=a+168|0;n[B>>2]=0.0;C=a+173|0;b[C>>0]=0;u=d;return}function $rb(a){a=a|0;YDc(a);return}function asb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bsb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=100844;b=a+160|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+164>>2]=0;b=a+100|0;c=a+136|0;e=f[c>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))g0(b);b=a+44|0;e=a+80|0;c=f[e>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)_S(b);f[e>>2]=0;e=a+60|0;b=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[a+84>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0)){REa(a);return}g0(b);REa(a);return}function csb(a){a=a|0;bsb(a);YDc(a);return}function dsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f$(c,e);c=b[a+41>>0]|0?1:2;g=f[e>>2]|0;h=f[g+40>>2]|0;i=0;j=1;do{j=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0}while((i|0)<(c|0));c=f[g+4>>2]|0;if((c|0)<3){k=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;l=(k|0)==(j|0);m=a+173|0;n=l&1;b[m>>0]=n;mx(e);u=d;return}else{g=0;i=1;while(1){o=Y(f[h+(g<<2)>>2]|0,i)|0;g=g+1|0;if((g|0)==(c|0)){k=o;break}else i=o}l=(k|0)==(j|0);m=a+173|0;n=l&1;b[m>>0]=n;mx(e);u=d;return}}function esb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0,Za=0.0,_a=0.0,$a=0.0,ab=0.0;g=u;u=u+432|0;h=g+416|0;i=g+80|0;j=g+400|0;k=g+332|0;l=g+320|0;m=g+264|0;o=g+208|0;q=g+344|0;r=g+48|0;s=g+16|0;t=g+152|0;v=g+96|0;w=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[j>>2]=0;x=j+4|0;f[x>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f$(c,j);f$(d,k);f$(e,l);a:do if((f[x>>2]|0)!=(f[j>>2]|0)){e=a+41|0;d=a+116|0;c=h+8|0;y=h+12|0;z=h+4|0;A=a+104|0;B=a+108|0;C=a+112|0;D=h+4|0;E=i+4|0;F=h+8|0;G=h+12|0;H=h+4|0;I=q+36|0;J=q+16|0;K=q+4|0;L=q+40|0;M=q+44|0;N=q+48|0;O=a+140|0;P=o+36|0;Q=o+16|0;R=o+4|0;S=o+40|0;T=o+44|0;U=o+48|0;V=m+36|0;W=m+16|0;X=m+4|0;Z=m+40|0;_=m+44|0;$=m+48|0;aa=h+4|0;ba=i+4|0;ca=h+4|0;da=i+4|0;ea=a+156|0;fa=h+8|0;ga=h+12|0;ha=h+4|0;ia=i+4|0;ja=i+8|0;ka=i+12|0;la=a+40|0;ma=w+8|0;na=w+12|0;oa=h+8|0;pa=h+4|0;qa=v+36|0;ra=v+16|0;sa=v+4|0;ta=v+40|0;ua=v+44|0;va=v+48|0;wa=t+36|0;xa=t+16|0;ya=t+4|0;za=t+40|0;Aa=t+44|0;Ba=t+48|0;Ca=a+36|0;Da=w+4|0;Ea=a+56|0;Fa=a+60|0;Ga=0;Ha=f[j>>2]|0;do{Ia=f[k>>2]|0;Ja=b[e>>0]|0?1:2;Ka=Ha+(Ga*56|0)+40|0;La=f[Ka>>2]|0;Ma=1;Na=0;do{Ma=Y(f[La+(Na<<2)>>2]|0,Ma)|0;Na=Na+1|0}while((Na|0)<(Ja|0));Ja=Ia+(Ga*56|0)|0;lT(m,Ha+(Ga*56|0)|0,1,Ma);lT(o,Ja,1,Ma);Na=f[Ha+(Ga*56|0)+4>>2]|0;if((Na|0)<3)Oa=Y(f[Ha+(Ga*56|0)+12>>2]|0,f[Ha+(Ga*56|0)+8>>2]|0)|0;else{La=f[Ka>>2]|0;Pa=0;Qa=1;while(1){Ra=Y(f[La+(Pa<<2)>>2]|0,Qa)|0;Pa=Pa+1|0;if((Pa|0)==(Na|0)){Oa=Ra;break}else Qa=Ra}}b:do if((Oa|0)==(Ma|0)){if(f[d>>2]|0){Qa=f[A>>2]|0;if((Qa|0)<3)Sa=Y(f[C>>2]|0,f[B>>2]|0)|0;else{Na=f[O>>2]|0;Pa=0;La=1;while(1){Ka=Y(f[Na+(Pa<<2)>>2]|0,La)|0;Pa=Pa+1|0;if((Pa|0)==(Qa|0)){Sa=Ka;break}else La=Ka}}if(!((Qa|0)==0|(Sa|0)==0)){if((Ma|0)>0)Ta=0;else{Ua=1;break}while(1){La=Ta;Ta=Ta+1|0;f[h>>2]=La;f[D>>2]=Ta;f[i>>2]=-2147483648;f[E>>2]=2147483647;$S(q,o,h,i);p[i>>3]=+n[(f[d>>2]|0)+(La<<2)>>2];f[h>>2]=-1056833530;f[H>>2]=i;f[F>>2]=1;f[G>>2]=1;l_(q,h,e0()|0)|0;La=f[I>>2]|0;if(La|0?(Pa=La+12|0,La=f[Pa>>2]|0,f[Pa>>2]=La+-1,(La|0)==1):0)_S(q);f[I>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[K>>2]|0)>0){La=f[L>>2]|0;Pa=0;do{f[La+(Pa<<2)>>2]=0;Pa=Pa+1|0}while((Pa|0)<(f[K>>2]|0))}Pa=f[M>>2]|0;if((Pa|0)!=(N|0))g0(Pa);if((Ta|0)>=(Ma|0)){Ua=1;break b}}}}p[i>>3]=0.0;f[h>>2]=-1056833530;f[z>>2]=i;f[c>>2]=1;f[y>>2]=1;l_(Ja,h,e0()|0)|0;Ua=1}else{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[s+28>>2]=0;if((Ma|0)>0){Qa=0;do{Pa=Qa;Qa=Qa+1|0;f[h>>2]=Pa;f[aa>>2]=Qa;f[i>>2]=-2147483648;f[ba>>2]=2147483647;$S(t,m,h,i);f[h>>2]=Pa;f[ca>>2]=Qa;f[i>>2]=-2147483648;f[da>>2]=2147483647;$S(v,o,h,i);if(b[ea>>0]|0){if((Pa|0)<(f[Ea>>2]|0))Va=+n[(f[Fa>>2]|0)+(Pa<<2)>>2];else Va=1.0;if((Pa|0)<(f[C>>2]|0)){Wa=+n[(f[d>>2]|0)+(Pa<<2)>>2];Xa=Va}else{Wa=0.0;Xa=Va}}else{Wa=0.0;Xa=1.0}f[fa>>2]=0;f[ga>>2]=0;f[h>>2]=16842752;f[ha>>2]=t;f[i>>2]=-1040056314;f[ia>>2]=r;f[ja>>2]=1;f[ka>>2]=4;if(!(b[la>>0]|0)){Pa=e0()|0;La=Pa;Na=f[La+4>>2]|0;Ka=w;f[Ka>>2]=f[La>>2];f[Ka+4>>2]=Na;f[ma>>2]=f[Pa+8>>2];Ya=f[Pa+12>>2]|0}else{f[w>>2]=-1023279098;f[Da>>2]=s;f[ma>>2]=1;Ya=4}f[na>>2]=Ya;F2(h,i,w,e0()|0);if(!(b[la>>0]|0))Za=1.0;else Za=1.0/(+n[Ca>>2]+ +p[s>>3]);if(!(b[ea>>0]|0)){_a=-(Za*+p[r>>3]);$a=Za}else{ab=Xa*Za;_a=Wa-ab*+p[r>>3];$a=ab}Pa=oa;f[Pa>>2]=0;f[Pa+4>>2]=0;f[h>>2]=33619968;f[pa>>2]=v;LZ(t,h,f[v>>2]&4095,$a,_a);Pa=f[qa>>2]|0;if(Pa|0?(Na=Pa+12|0,Pa=f[Na>>2]|0,f[Na>>2]=Pa+-1,(Pa|0)==1):0)_S(v);f[qa>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[sa>>2]|0)>0){Pa=f[ta>>2]|0;Na=0;do{f[Pa+(Na<<2)>>2]=0;Na=Na+1|0}while((Na|0)<(f[sa>>2]|0))}Na=f[ua>>2]|0;if((Na|0)!=(va|0))g0(Na);Na=f[wa>>2]|0;if(Na|0?(Pa=Na+12|0,Na=f[Pa>>2]|0,f[Pa>>2]=Na+-1,(Na|0)==1):0)_S(t);f[wa>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((f[ya>>2]|0)>0){Na=f[za>>2]|0;Pa=0;do{f[Na+(Pa<<2)>>2]=0;Pa=Pa+1|0}while((Pa|0)<(f[ya>>2]|0))}Pa=f[Aa>>2]|0;if((Pa|0)!=(Ba|0))g0(Pa)}while((Qa|0)<(Ma|0))}Ua=0}while(0);Ma=f[P>>2]|0;if(Ma|0?(Ja=Ma+12|0,Ma=f[Ja>>2]|0,f[Ja>>2]=Ma+-1,(Ma|0)==1):0)_S(o);f[P>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[R>>2]|0)>0){Ma=f[S>>2]|0;Ja=0;do{f[Ma+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[R>>2]|0))}Ja=f[T>>2]|0;if((Ja|0)!=(U|0))g0(Ja);Ja=f[V>>2]|0;if(Ja|0?(Ma=Ja+12|0,Ja=f[Ma>>2]|0,f[Ma>>2]=Ja+-1,(Ja|0)==1):0)_S(m);f[V>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[X>>2]|0)>0){Ja=f[Z>>2]|0;Ma=0;do{f[Ja+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[X>>2]|0))}Ma=f[_>>2]|0;if((Ma|0)!=($|0))g0(Ma);Ga=Ga+1|0;if(Ua|0)break a;Ha=f[j>>2]|0}while(Ga>>>0<(((f[x>>2]|0)-Ha|0)/56|0)>>>0)}while(0);mx(l);mx(k);mx(j);u=g;return}function fsb(a,c){a=a|0;c=c|0;var d=0;if((c|0)!=2){d=(c|0)==3;return d|0}if(b[a+173>>0]|0){d=0;return d|0}if(!(f[a+32>>2]|0)){d=1;return d|0}d=+n[a+36>>2]<=1.0000000116860974e-07;return d|0}function gsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function hsb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[c+4>>2]|0;e=a+172|0;if(d|0){if((b[e>>0]|0)==0?(g=a+156|0,(b[g>>0]|0)==0):0){Ti[f[(f[d>>2]|0)+84>>2]&511](d,a+44|0,a+100|0);if(f[a+60>>2]|0){h=f[a+48>>2]|0;if((h|0)<3)i=Y(f[a+56>>2]|0,f[a+52>>2]|0)|0;else{j=f[a+84>>2]|0;k=0;l=1;while(1){m=Y(f[j+(k<<2)>>2]|0,l)|0;k=k+1|0;if((k|0)==(h|0)){i=m;break}else l=m}}if(!((h|0)==0|(i|0)==0)){n=g;o=1;p=o&1;b[n>>0]=p;return o|0}}if(!(f[a+116>>2]|0)){n=g;o=0;p=o&1;b[n>>0]=p;return o|0}i=f[a+104>>2]|0;if((i|0)<3)q=Y(f[a+112>>2]|0,f[a+108>>2]|0)|0;else{h=f[a+140>>2]|0;l=0;k=1;while(1){j=Y(f[h+(l<<2)>>2]|0,k)|0;l=l+1|0;if((l|0)==(i|0)){q=j;break}else k=j}}n=g;o=(i|0)!=0&(q|0)!=0;p=o&1;b[n>>0]=p;return o|0}if((f[a+32>>2]|0)==1){q=bFc(d,14192,16912,0)|0;d=f[c>>2]|0;c=(d|0)==0;if(!c){i=d+4|0;f[i>>2]=(f[i>>2]|0)+1;f[i>>2]=(f[i>>2]|0)+1}i=a+160|0;g=f[i>>2]|0;f[i>>2]=d;i=a+164|0;f[i>>2]=q;if(g|0?(q=g+4|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=d;if(!c?(c=g+4|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)Yi[f[(f[d>>2]|0)+8>>2]&2047](g);g=f[i>>2]|0;if(g|0)f[a+168>>2]=f[g+36>>2]}}n=e;o=(f[a+164>>2]|0)!=0;p=o&1;b[n>>0]=p;return o|0}function isb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=f[c+4>>2]|0;h=f[c>>2]|0;c=h;if((g|0)==(h|0)){i=0;j=0;J=i;u=d;return j|0}k=a+40|0;a=(g-h|0)/12|0;h=0;g=0;a:while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;m=(p|0)==(l|0);do if(m){q=0;r=0}else{if((n|0)<0){s=9;break a}if(n){l=1;t=0;do{l=Y(f[p+(t<<2)>>2]|0,l)|0;t=t+1|0}while((t|0)!=(o|0));t=l*6|0;if(m){q=0;r=t;break}else{v=b[k>>0]|0?2:1;w=t}}else{v=b[k>>0]|0?2:1;w=6}if((n|0)<0|(v|0)>(o|0)){s=13;break a}else{x=1;y=0}while(1){t=Y(f[p+(y<<2)>>2]|0,x)|0;y=y+1|0;if((y|0)==(v|0)){q=t;r=w;break}else x=t}}while(0);h=r+h+(q*3|0)|0;g=g+1|0;if(g>>>0>=a>>>0){s=3;break}}if((s|0)==3){i=((h|0)<0)<<31>>31;j=h;J=i;u=d;return j|0}else if((s|0)==9){f[e>>2]=0;f[e+4>>2]=0;z=tT(e,70)|0;A=452744;B=z+70|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,e,452815,452821,161)}else if((s|0)==13){f[e>>2]=0;f[e+4>>2]=0;z=tT(e,70)|0;A=452744;B=z+70|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,e,452815,452821,161)}return 0}function jsb(a,b){a=a|0;b=b|0;var c=0;c=VDc(160)|0;ksb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=100952;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function ksb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0;d=u;u=u+128|0;e=d+80|0;g=d+40|0;h=d;i=d+24|0;j=d+16|0;JHa(a);f[a>>2]=100972;k=a+36|0;l=a+40|0;m=a+44|0;o=a+48|0;q=a+52|0;r=a+56|0;s=a+60|0;t=a+64|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[a+84>>2]=1124007936;v=a+92|0;w=a+124|0;x=a+88|0;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[w>>2]=v;v=a+132|0;f[a+128>>2]=v;f[v>>2]=0;f[a+136>>2]=0;v=a+144|0;f[v>>2]=0;w=a+148|0;z=VDc(16)|0;A=z+8|0;f[z>>2]=A;f[z+4>>2]=1;f[w>>2]=z;z=A;f[z>>2]=0;f[z+4>>2]=0;z=a+152|0;f[z>>2]=0;A=a+156|0;B=VDc(16)|0;C=B+8|0;f[B>>2]=C;f[B+4>>2]=1;f[A>>2]=B;B=C;f[B>>2]=0;f[B+4>>2]=0;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;x=tT(e,11)|0;B=437828;y=x+11|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));C=c+4|0;D=f[C>>2]|0;do if(D){E=f[e>>2]|0;F=(E|0)==0?1154740:E;G=C;H=D;a:while(1){I=H;while(1){J=f[I+16>>2]|0;if((J|0)==(E|0))break;if((Ioc((J|0)==0?1154740:J,F)|0)>=0)break;J=f[I+4>>2]|0;if(!J){L=G;break a}else I=J}H=f[I>>2]|0;if(!H){L=I;break}else G=I}if((L|0)!=(C|0)){G=f[L+16>>2]|0;if((E|0)!=(G|0)?(Ioc(F,(G|0)==0?1154740:G)|0)<=-1:0){N=16;break}G=DHa(L+24|0,-1)|0;N=G}else N=16}else N=16;while(0);L=a+76|0;f[L>>2]=N;uT(e);f[e>>2]=0;f[e+4>>2]=0;x=tT(e,9)|0;B=437840;y=x+9|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));N=f[C>>2]|0;do if(N){D=f[e>>2]|0;G=(D|0)==0?1154740:D;H=C;J=N;b:while(1){O=J;while(1){P=f[O+16>>2]|0;if((P|0)==(D|0))break;if((Ioc((P|0)==0?1154740:P,G)|0)>=0)break;P=f[O+4>>2]|0;if(!P){Q=H;break b}else O=P}J=f[O>>2]|0;if(!J){Q=O;break}else H=O}if((Q|0)!=(C|0)){H=f[Q+16>>2]|0;if((D|0)!=(H|0)?(Ioc(G,(H|0)==0?1154740:H)|0)<=-1:0){R=16;break}H=DHa(Q+24|0,-1)|0;R=H}else R=16}else R=16;while(0);Q=a+80|0;f[Q>>2]=R;uT(e);f[e>>2]=0;f[e+4>>2]=0;x=tT(e,12)|0;B=437850;y=x+12|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));R=f[C>>2]|0;do if(R){N=f[e>>2]|0;H=(N|0)==0?1154740:N;J=C;F=R;c:while(1){E=F;while(1){I=f[E+16>>2]|0;if((I|0)==(N|0))break;if((Ioc((I|0)==0?1154740:I,H)|0)>=0)break;I=f[E+4>>2]|0;if(!I){S=J;break c}else E=I}F=f[E>>2]|0;if(!F){S=E;break}else J=E}if((S|0)!=(C|0)){J=f[S+16>>2]|0;if((N|0)!=(J|0)?(Ioc(H,(J|0)==0?1154740:J)|0)<=-1:0){T=6e3;break}J=DHa(S+24|0,-1)|0;T=J}else T=6e3}else T=6e3;while(0);S=a+68|0;f[S>>2]=T;uT(e);f[e>>2]=0;f[e+4>>2]=0;x=tT(e,13)|0;B=437863;y=x+13|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));T=f[C>>2]|0;do if(T){R=f[e>>2]|0;J=(R|0)==0?1154740:R;F=C;G=T;d:while(1){D=G;while(1){O=f[D+16>>2]|0;if((O|0)==(R|0))break;if((Ioc((O|0)==0?1154740:O,J)|0)>=0)break;O=f[D+4>>2]|0;if(!O){U=F;break d}else D=O}G=f[D>>2]|0;if(!G){U=D;break}else F=D}if((U|0)!=(C|0)){F=f[U+16>>2]|0;if((R|0)!=(F|0)?(Ioc(J,(F|0)==0?1154740:F)|0)<=-1:0){V=300;break}F=DHa(U+24|0,-1)|0;V=F}else V=300}else V=300;while(0);U=a+72|0;f[U>>2]=V;uT(e);f[e>>2]=0;f[e+4>>2]=0;x=tT(e,10)|0;B=437877;y=x+10|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));V=f[C>>2]|0;do if(V){T=f[e>>2]|0;F=(T|0)==0?1154740:T;G=C;H=V;e:while(1){N=H;while(1){E=f[N+16>>2]|0;if((E|0)==(T|0))break;if((Ioc((E|0)==0?1154740:E,F)|0)>=0)break;E=f[N+4>>2]|0;if(!E){W=G;break e}else N=E}H=f[N>>2]|0;if(!H){W=N;break}else G=N}if((W|0)!=(C|0)){G=f[W+16>>2]|0;if((T|0)!=(G|0)?(Ioc(F,(G|0)==0?1154740:G)|0)<=-1:0){X=.699999988079071;break}X=+tIa(W+24|0,-1)}else X=.699999988079071}else X=.699999988079071;while(0);W=a+140|0;n[W>>2]=X;uT(e);f[e>>2]=0;f[e+4>>2]=0;C=tT(e,5)|0;b[C>>0]=b[437888]|0;b[C+1>>0]=b[437889]|0;b[C+2>>0]=b[437890]|0;b[C+3>>0]=b[437891]|0;b[C+4>>0]=b[437892]|0;gIa(v,lIa(c,e)|0)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;C=tT(e,5)|0;b[C>>0]=b[451291]|0;b[C+1>>0]=b[451292]|0;b[C+2>>0]=b[451293]|0;b[C+3>>0]=b[451294]|0;b[C+4>>0]=b[451295]|0;gIa(z,lIa(c,e)|0)|0;uT(e);f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=g+4;c=g+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[e>>2]=0;f[e+4>>2]=0;c=tT(e,4)|0;b[c>>0]=115;b[c+1>>0]=116;b[c+2>>0]=101;b[c+3>>0]=112;wLa(g,e,L)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;c=tT(e,4)|0;b[c>>0]=102;b[c+1>>0]=108;b[c+2>>0]=105;b[c+3>>0]=112;b[h>>0]=0;rIa(g,e,h)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;c=tT(e,4)|0;b[c>>0]=99;b[c+1>>0]=108;b[c+2>>0]=105;b[c+3>>0]=112;b[h>>0]=0;rIa(g,e,h)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;x=tT(e,15)|0;B=451529;y=x+15|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));b[h>>0]=0;rIa(g,e,h)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;c=tT(e,6)|0;b[c>>0]=b[451876]|0;b[c+1>>0]=b[451877]|0;b[c+2>>0]=b[451878]|0;b[c+3>>0]=b[451879]|0;b[c+4>>0]=b[451880]|0;b[c+5>>0]=b[451881]|0;p[h>>3]=+((f[Q>>2]|0)>>>0)*.5/+((f[L>>2]|0)>>>0);xKa(g,e,h)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;L=tT(e,8)|0;c=L;b[c>>0]=118;b[c+1>>0]=97;b[c+2>>0]=114;b[c+3>>0]=105;c=L+4|0;b[c>>0]=97;b[c+1>>0]=110;b[c+2>>0]=99;b[c+3>>0]=101;c=VDc(16)|0;f[c>>2]=c+8;f[c+4>>2]=4;L=XDc(32)|0;f[c>>2]=L;f[h>>2]=2;f[h+4>>2]=c;p[L>>3]=.10000000149011612;p[L+8>>3]=.10000000149011612;p[L+16>>3]=.20000000298023224;p[L+24>>3]=.20000000298023224;bIa(g,e,h)|0;JFa(h);uT(e);f[h>>2]=0;L=h+4|0;f[L>>2]=0;f[h+8>>2]=0;f[i>>2]=0;c=i+4|0;f[c>>2]=0;f[i+8>>2]=0;switch(f[v>>2]|0){case 0:{Z=(f[w>>2]|0)+4|0;break}case 3:{Z=(f[a+148>>2]|0)+4|0;break}case 2:{Z=(f[a+148>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}C=f[Z>>2]|0;switch(f[z>>2]|0){case 0:{_=(f[A>>2]|0)+4|0;break}case 3:{_=(f[a+156>>2]|0)+4|0;break}case 2:{_=(f[a+156>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}nsb(h,Y(f[_>>2]|0,C)|0);switch(f[v>>2]|0){case 0:{$=(f[w>>2]|0)+4|0;break}case 3:{$=(f[a+148>>2]|0)+4|0;break}case 2:{$=(f[a+148>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}C=f[$>>2]|0;switch(f[z>>2]|0){case 0:{aa=(f[A>>2]|0)+4|0;break}case 3:{aa=(f[a+156>>2]|0)+4|0;break}case 2:{aa=(f[a+156>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}nsb(i,Y(f[aa>>2]|0,C)|0);C=h+8|0;aa=i+8|0;$=a+156|0;_=a+148|0;a=0;f:while(1){switch(f[v>>2]|0){case 0:{ba=(f[w>>2]|0)+4|0;break}case 3:{ba=(f[_>>2]|0)+4|0;break}case 2:{ba=(f[_>>2]|0)+4|0;break}default:{ca=81;break f}}if((a|0)>=(f[ba>>2]|0)){ca=83;break}X=+tIa(v,a);Z=0;while(1){switch(f[z>>2]|0){case 0:{da=(f[A>>2]|0)+4|0;break}case 3:{da=(f[$>>2]|0)+4|0;break}case 2:{da=(f[$>>2]|0)+4|0;break}default:{ca=89;break f}}if((Z|0)>=(f[da>>2]|0))break;ea=+tIa(z,Z);fa=+K(+(+((f[Q>>2]|0)>>>0)/+M(+X)+.5));ga=+K(+(X*fa+.5));ha=ea*fa;n[e>>2]=ha;V=f[L>>2]|0;if((V|0)==(f[C>>2]|0))osb(h,e);else{n[V>>2]=ha;f[L>>2]=V+4}ha=ea*ga;n[e>>2]=ha;V=f[c>>2]|0;if((V|0)==(f[aa>>2]|0))osb(i,e);else{n[V>>2]=ha;f[c>>2]=V+4}Z=Z+1|0}a=a+1|0}if((ca|0)==81){f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}else if((ca|0)==83){f[e>>2]=0;f[e+4>>2]=0;a=tT(e,5)|0;b[a>>0]=b[467281]|0;b[a+1>>0]=b[467282]|0;b[a+2>>0]=b[467283]|0;b[a+3>>0]=b[467284]|0;b[a+4>>0]=b[467285]|0;a=f[h>>2]|0;aa=(f[L>>2]|0)-a|0;C=aa>>2;Q=VDc(16)|0;z=Q+8|0;f[Q>>2]=z;f[Q+4>>2]=C;if(C>>>0>1){da=XDc(C>>>0>536870911?-1:C<<3)|0;f[Q>>2]=da;ia=da}else ia=z;f[j>>2]=2;f[j+4>>2]=Q;if((aa|0)>0){aa=a;a=0;while(1){p[ia+(a<<3)>>3]=+n[aa>>2];a=a+1|0;if((a|0)==(C|0))break;else aa=aa+4|0}}bIa(g,e,j)|0;JFa(j);uT(e);f[e>>2]=0;f[e+4>>2]=0;aa=tT(e,6)|0;b[aa>>0]=b[467287]|0;b[aa+1>>0]=b[467288]|0;b[aa+2>>0]=b[467289]|0;b[aa+3>>0]=b[467290]|0;b[aa+4>>0]=b[467291]|0;b[aa+5>>0]=b[467292]|0;aa=f[i>>2]|0;C=(f[c>>2]|0)-aa|0;a=C>>2;ia=VDc(16)|0;Q=ia+8|0;f[ia>>2]=Q;f[ia+4>>2]=a;if(a>>>0>1){z=XDc(a>>>0>536870911?-1:a<<3)|0;f[ia>>2]=z;ja=z}else ja=Q;f[j>>2]=2;f[j+4>>2]=ia;if((C|0)>0){C=aa;aa=0;while(1){p[ja+(aa<<3)>>3]=+n[C>>2];aa=aa+1|0;if((aa|0)==(a|0))break;else C=C+4|0}}bIa(g,e,j)|0;JFa(j);uT(e);$zb(e,g);j=f[e>>2]|0;C=f[e+4>>2]|0;if(j|0){a=j+4|0;f[a>>2]=(f[a>>2]|0)+1}a=f[k>>2]|0;f[k>>2]=j;f[l>>2]=C;if(a|0?(C=a+4|0,l=f[C>>2]|0,f[C>>2]=l+-1,(l|0)==1):0)Yi[f[(f[a>>2]|0)+8>>2]&2047](a);a=f[e>>2]|0;if(a|0?(l=a+4|0,C=f[l>>2]|0,f[l>>2]=C+-1,(C|0)==1):0)Yi[f[(f[a>>2]|0)+8>>2]&2047](a);a=f[i>>2]|0;if(a|0){i=f[c>>2]|0;if((i|0)!=(a|0))f[c>>2]=i+(~((i+-4-a|0)>>>2)<<2);YDc(a)}a=f[h>>2]|0;if(a|0){i=f[L>>2]|0;if((i|0)!=(a|0))f[L>>2]=i+(~((i+-4-a|0)>>>2)<<2);YDc(a)}HFa(g);f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=e+4;a=e+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[g>>2]=0;f[g+4>>2]=0;a=tT(g,5)|0;b[a>>0]=b[454713]|0;b[a+1>>0]=b[454714]|0;b[a+2>>0]=b[454715]|0;b[a+3>>0]=b[454716]|0;b[a+4>>0]=b[454717]|0;a=VDc(16)|0;f[a>>2]=a+8;f[a+4>>2]=4;i=XDc(32)|0;f[a>>2]=i;f[h>>2]=0;f[h+4>>2]=a;a=i;f[a>>2]=0;f[a+4>>2]=0;a=i+8|0;f[a>>2]=2;f[a+4>>2]=0;a=i+16|0;f[a>>2]=3;f[a+4>>2]=0;a=i+24|0;f[a>>2]=1;f[a+4>>2]=0;bIa(e,g,h)|0;JFa(h);uT(g);opb(g,e);a=f[g>>2]|0;i=f[g+4>>2]|0;if(a|0){L=a+4|0;f[L>>2]=(f[L>>2]|0)+1}L=f[q>>2]|0;f[q>>2]=a;f[r>>2]=i;if(L|0?(i=L+4|0,r=f[i>>2]|0,f[i>>2]=r+-1,(r|0)==1):0)Yi[f[(f[L>>2]|0)+8>>2]&2047](L);L=f[g>>2]|0;if(L|0?(r=L+4|0,i=f[r>>2]|0,f[r>>2]=i+-1,(i|0)==1):0)Yi[f[(f[L>>2]|0)+8>>2]&2047](L);opb(g,e);L=f[g>>2]|0;i=f[g+4>>2]|0;if(L|0){r=L+4|0;f[r>>2]=(f[r>>2]|0)+1}r=f[s>>2]|0;f[s>>2]=L;f[t>>2]=i;do if(r|0){i=r+4|0;t=f[i>>2]|0;f[i>>2]=t+-1;if((t|0)!=1)break;Yi[f[(f[r>>2]|0)+8>>2]&2047](r)}while(0);r=f[g>>2]|0;do if(r|0){t=r+4|0;i=f[t>>2]|0;f[t>>2]=i+-1;if((i|0)!=1)break;Yi[f[(f[r>>2]|0)+8>>2]&2047](r)}while(0);HFa(e);f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=e+4;r=e+12|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[g>>2]=0;f[g+4>>2]=0;x=tT(g,9)|0;B=446692;y=x+9|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));psb(e,g,446714)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;x=tT(g,11)|0;B=446412;y=x+11|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));f[h>>2]=1;$Ha(e,g,h)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;x=tT(g,14)|0;B=446424;y=x+14|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));b[h>>0]=1;rIa(e,g,h)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;x=tT(g,19)|0;B=446439;y=x+19|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));f[h>>2]=1;$Ha(e,g,h)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;x=tT(g,26)|0;B=446459;y=x+26|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));b[h>>0]=1;rIa(e,g,h)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;x=tT(g,10)|0;B=446486;y=x+10|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));wLa(e,g,U)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;U=tT(g,5)|0;b[U>>0]=b[446518]|0;b[U+1>>0]=b[446519]|0;b[U+2>>0]=b[446520]|0;b[U+3>>0]=b[446521]|0;b[U+4>>0]=b[446522]|0;wLa(e,g,S)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;x=tT(g,13)|0;B=447828;y=x+13|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));eIa(e,g,W)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;x=tT(g,15)|0;B=451529;y=x+15|0;do{b[x>>0]=b[B>>0]|0;x=x+1|0;B=B+1|0}while((x|0)<(y|0));b[h>>0]=0;rIa(e,g,h)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;B=tT(g,4)|0;b[B>>0]=99;b[B+1>>0]=108;b[B+2>>0]=105;b[B+3>>0]=112;b[h>>0]=1;rIa(e,g,h)|0;uT(g);vxb(g,e);h=f[g>>2]|0;B=f[g+4>>2]|0;if(h|0){x=h+4|0;f[x>>2]=(f[x>>2]|0)+1}x=f[m>>2]|0;f[m>>2]=h;f[o>>2]=B;do if(x|0){B=x+4|0;o=f[B>>2]|0;f[B>>2]=o+-1;if((o|0)!=1)break;Yi[f[(f[x>>2]|0)+8>>2]&2047](x)}while(0);x=f[g>>2]|0;if(!x){HFa(e);u=d;return}g=x+4|0;o=f[g>>2]|0;f[g>>2]=o+-1;if((o|0)!=1){HFa(e);u=d;return}Yi[f[(f[x>>2]|0)+8>>2]&2047](x);HFa(e);u=d;return}else if((ca|0)==89){f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}function lsb(a){a=a|0;YDc(a);return}function msb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>2;i=VDc(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;YDc(d);return}function osb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function psb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=VDc(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;uT(p);o=Mpc(c)|0;if(o|0)dJc(tT(p,o)|0,c|0,o|0)|0;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=VDc(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;uT(t);b=Mpc(c)|0;if(b|0)dJc(tT(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function qsb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=100972;JFa(a+152|0);JFa(a+144|0);b=a+84|0;c=a+120|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+100|0;b=a+88|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+124>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+128>>2]|0;if((b|0)!=(a+132|0))g0(b);b=a+60|0;d=f[b>>2]|0;if(d|0?(c=d+4|0,e=f[c>>2]|0,f[c>>2]=e+-1,(e|0)==1):0)Yi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;f[a+64>>2]=0;b=a+52|0;d=f[b>>2]|0;if(d|0?(e=d+4|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)Yi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;f[a+56>>2]=0;b=a+44|0;d=f[b>>2]|0;if(d|0?(c=d+4|0,e=f[c>>2]|0,f[c>>2]=e+-1,(e|0)==1):0)Yi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;f[a+48>>2]=0;b=a+36|0;d=f[b>>2]|0;if(!d){f[b>>2]=0;g=a+40|0;f[g>>2]=0;REa(a);return}e=d+4|0;c=f[e>>2]|0;f[e>>2]=c+-1;if((c|0)!=1){f[b>>2]=0;g=a+40|0;f[g>>2]=0;REa(a);return}Yi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;g=a+40|0;f[g>>2]=0;REa(a);return}function rsb(a){a=a|0;qsb(a);YDc(a);return}function ssb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+192|0;e=d+168|0;g=d+152|0;h=d+140|0;i=d+128|0;j=d+72|0;k=d+16|0;l=d;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f$(c,g);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ysb(j,f[g>>2]|0);zsb(h,1,j);c=j+40|0;m=f[c>>2]|0;n=f[m+8>>2]|0;o=f[m+12>>2]|0;p=f[m+4>>2]|0;f[e>>2]=f[m>>2];m=e+4|0;f[m>>2]=n;n=e+8|0;f[n>>2]=o;o=e+12|0;f[o>>2]=p;f[l>>2]=0;p=l+4|0;f[p>>2]=0;f[l+8>>2]=0;q=e+16|0;lFa(l,e,q);r=f[l>>2]|0;s=f[p>>2]|0;a:do if((r|0)==(s|0)){t=r;v=4}else{w=r;do{if((f[w>>2]|0)<0){t=w;v=4;break a}w=w+4|0}while((w|0)!=(s|0))}while(0);if((v|0)==4?(t|0)!=(s|0):0){r=t+4|0;if((r|0)==(s|0)){x=s;y=t}else{w=r;r=t;while(1){t=f[w>>2]|0;if((t|0)<0)z=r;else{f[r>>2]=t;z=r+4|0}w=w+4|0;if((w|0)==(s|0))break;else r=z}x=f[p>>2]|0;y=z}if((y|0)!=(x|0))f[p>>2]=x+(~((x+-4-y|0)>>>2)<<2)}f[k>>2]=1124007936;y=k+4|0;x=k+8|0;z=k+40|0;r=y;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[z>>2]=x;x=k+48|0;w=k+44|0;f[w>>2]=x;f[x>>2]=0;f[k+52>>2]=0;YS(k,l,5);zsb(i,1,k);t=k+36|0;A=f[t>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)_S(k);f[t>>2]=0;t=k+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[y>>2]|0)>0){t=f[z>>2]|0;z=0;do{f[t+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[w>>2]|0;if((y|0)!=(x|0))g0(y);y=f[l>>2]|0;if(y|0){x=f[p>>2]|0;if((x|0)!=(y|0))f[p>>2]=x+(~((x+-4-y|0)>>>2)<<2);YDc(y)}LHa(f[a+64>>2]|0,h,i);y=f[g>>2]|0;if((f[y+60>>2]|0)!=4){f[e>>2]=0;f[e+4>>2]=0;r=tT(e,20)|0;x=438212;s=r+20|0;do{b[r>>0]=b[x>>0]|0;r=r+1|0;x=x+1|0}while((r|0)<(s|0));z5(-215,e,453718,437913,157)}zsb(h,1,y+56|0);x=f[y+96>>2]|0;y=f[x+8>>2]|0;p=f[x+12>>2]|0;w=f[x+4>>2]|0;f[e>>2]=f[x>>2];f[m>>2]=y;f[n>>2]=p;f[o>>2]=w;f[l>>2]=0;w=l+4|0;f[w>>2]=0;f[l+8>>2]=0;lFa(l,e,q);q=f[l>>2]|0;e=f[w>>2]|0;b:do if((q|0)==(e|0)){C=q;v=29}else{o=q;do{if((f[o>>2]|0)<0){C=o;v=29;break b}o=o+4|0}while((o|0)!=(e|0))}while(0);if((v|0)==29?(C|0)!=(e|0):0){v=C+4|0;if((v|0)==(e|0)){D=e;E=C}else{q=v;v=C;while(1){C=f[q>>2]|0;if((C|0)<0)F=v;else{f[v>>2]=C;F=v+4|0}q=q+4|0;if((q|0)==(e|0))break;else v=F}D=f[w>>2]|0;E=F}if((E|0)!=(D|0))f[w>>2]=D+(~((D+-4-E|0)>>>2)<<2)}f[k>>2]=1124007936;E=k+4|0;D=k+8|0;F=k+40|0;r=E;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[F>>2]=D;D=k+48|0;r=k+44|0;f[r>>2]=D;f[D>>2]=0;f[k+52>>2]=0;YS(k,l,5);zsb(i,1,k);s=k+36|0;v=f[s>>2]|0;if(v|0?(e=v+12|0,v=f[e>>2]|0,f[e>>2]=v+-1,(v|0)==1):0)_S(k);f[s>>2]=0;s=k+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[E>>2]|0)>0){s=f[F>>2]|0;F=0;do{f[s+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[E>>2]|0))}E=f[r>>2]|0;if((E|0)!=(D|0))g0(E);E=f[l>>2]|0;if(E|0){l=f[w>>2]|0;if((l|0)!=(E|0))f[w>>2]=l+(~((l+-4-E|0)>>>2)<<2);YDc(E)}LHa(f[a+56>>2]|0,h,i);a=j+36|0;E=f[a>>2]|0;if(E|0?(l=E+12|0,E=f[l>>2]|0,f[l>>2]=E+-1,(E|0)==1):0)_S(j);f[a>>2]=0;a=j+16|0;E=j+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[E>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[E>>2]|0))}E=f[j+44>>2]|0;if((E|0)==(j+48|0)){mx(i);mx(h);mx(g);u=d;return}g0(E);mx(i);mx(h);mx(g);u=d;return}function tsb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;g=u;u=u+528|0;h=g+472|0;i=g;j=g+232|0;k=g+220|0;l=g+208|0;m=g+196|0;o=g+184|0;q=g+128|0;r=g+416|0;s=g+72|0;t=g+16|0;v=g+360|0;w=g+304|0;x=g+248|0;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[j>>2]=0;y=j+4|0;f[y>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[l>>2]=0;z=l+4|0;f[z>>2]=0;f[l+8>>2]=0;f$(c,j);f$(d,k);f$(e,l);e=f[j>>2]|0;d=e;if(((f[y>>2]|0)-e|0)!=168){f[h>>2]=0;f[h+4>>2]=0;A=tT(h,18)|0;B=437894;C=A+18|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,h,453206,437913,268)}e=f[l>>2]|0;y=e;if(((f[z>>2]|0)-e|0)!=168){f[h>>2]=0;f[h+4>>2]=0;A=tT(h,21)|0;B=438080;C=A+21|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,h,453206,437913,269)}e=d+56|0;z=y+56|0;c=y+112|0;D=f[d+116>>2]|0;if((D|0)<3)E=Y(f[d+124>>2]|0,f[d+120>>2]|0)|0;else{F=f[d+152>>2]|0;G=0;H=1;while(1){I=Y(f[F+(G<<2)>>2]|0,H)|0;G=G+1|0;if((G|0)==(D|0)){E=I;break}else H=I}}if(E>>>0<=1){f[h>>2]=0;f[h+4>>2]=0;A=tT(h,19)|0;B=438102;C=A+19|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,h,453206,437913,277)}E=a+84|0;H=f[d+128>>2]|0;J=+n[H>>2];do if((f[d+112>>2]&16384|0)==0?(D=f[d+152>>2]|0,(f[D>>2]|0)!=1):0){G=f[f[d+156>>2]>>2]|0;if((f[D+4>>2]|0)==1){K=H+G|0;break}else{D=f[d+124>>2]|0;F=(D+1|0)>>>0<3?D:0;K=H+(Y(F,G)|0)+(1-(Y(F,D)|0)<<2)|0;break}}else L=15;while(0);if((L|0)==15)K=H+4|0;H=~~+n[K>>2];f[h>>2]=1;f[h+4>>2]=1;f[h+8>>2]=~~J;f[h+12>>2]=H;f[i>>2]=0;H=i+4|0;f[H>>2]=0;f[i+8>>2]=0;lFa(i,h,h+16|0);K=f[i>>2]|0;D=f[H>>2]|0;a:do if((K|0)==(D|0)){M=K;L=22}else{F=K;do{if((f[F>>2]|0)<0){M=F;L=22;break a}F=F+4|0}while((F|0)!=(D|0))}while(0);if((L|0)==22?(M|0)!=(D|0):0){K=M+4|0;if((K|0)==(D|0)){N=D;O=M}else{F=K;K=M;while(1){M=f[F>>2]|0;if((M|0)<0)P=K;else{f[K>>2]=M;P=K+4|0}F=F+4|0;if((F|0)==(D|0))break;else K=P}N=f[H>>2]|0;O=P}if((O|0)!=(N|0))f[H>>2]=N+(~((N+-4-O|0)>>>2)<<2)}YS(E,i,0);O=f[i>>2]|0;if(O|0){N=f[H>>2]|0;if((N|0)!=(O|0))f[H>>2]=N+(~((N+-4-O|0)>>>2)<<2);YDc(O)}f[m>>2]=0;O=m+4|0;f[O>>2]=0;f[m+8>>2]=0;N=VDc(112)|0;f[m>>2]=N;f[m+8>>2]=N+112;f[N>>2]=1124007936;H=N+8|0;P=N+40|0;A=N+4|0;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[P>>2]=H;H=N+48|0;f[N+44>>2]=H;f[H>>2]=0;f[N+52>>2]=0;f[N+56>>2]=1124007936;H=N+64|0;P=N+96|0;A=N+60|0;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[P>>2]=H;H=N+104|0;f[N+100>>2]=H;f[H>>2]=0;f[N+108>>2]=0;f[O>>2]=N+112;qFa(o,1,y);N=f[m>>2]|0;if((N|0)==(d|0))Q=d;else{O=d+36|0;H=f[O>>2]|0;if(H|0){P=H+12|0;f[P>>2]=(f[P>>2]|0)+1}P=N+36|0;H=f[P>>2]|0;if(H|0?(K=H+12|0,H=f[K>>2]|0,f[K>>2]=H+-1,(H|0)==1):0)_S(N);f[P>>2]=0;H=N+16|0;K=N+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[K>>2]|0)>0){D=f[N+40>>2]|0;F=0;do{f[D+(F<<2)>>2]=0;F=F+1|0;R=f[K>>2]|0}while((F|0)<(R|0));f[N>>2]=f[d>>2];if((R|0)<3)L=45;else L=47}else{f[N>>2]=f[d>>2];L=45}if((L|0)==45){R=f[d+4>>2]|0;if((R|0)<3){f[K>>2]=R;f[N+8>>2]=f[d+8>>2];f[N+12>>2]=f[d+12>>2];R=f[d+44>>2]|0;K=f[N+44>>2]|0;f[K>>2]=f[R>>2];f[K+4>>2]=f[R+4>>2]}else L=47}if((L|0)==47)ZS(N,d);f[H>>2]=f[d+16>>2];f[N+20>>2]=f[d+20>>2];f[N+24>>2]=f[d+24>>2];f[N+28>>2]=f[d+28>>2];f[N+32>>2]=f[d+32>>2];f[P>>2]=f[O>>2];Q=f[m>>2]|0}O=Q+56|0;if((O|0)!=(E|0)){P=a+120|0;N=f[P>>2]|0;if(N|0){H=N+12|0;f[H>>2]=(f[H>>2]|0)+1}H=Q+92|0;N=f[H>>2]|0;if(N|0?(R=N+12|0,N=f[R>>2]|0,f[R>>2]=N+-1,(N|0)==1):0)_S(O);f[H>>2]=0;N=Q+72|0;R=Q+60|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[R>>2]|0)>0){K=f[Q+96>>2]|0;F=0;do{f[K+(F<<2)>>2]=0;F=F+1|0;S=f[R>>2]|0}while((F|0)<(S|0));f[O>>2]=f[E>>2];if((S|0)<3)L=60;else L=62}else{f[O>>2]=f[E>>2];L=60}if((L|0)==60){S=f[a+88>>2]|0;if((S|0)<3){f[R>>2]=S;f[Q+64>>2]=f[a+92>>2];f[Q+68>>2]=f[a+96>>2];S=f[a+128>>2]|0;R=f[Q+100>>2]|0;f[R>>2]=f[S>>2];f[R+4>>2]=f[S+4>>2]}else L=62}if((L|0)==62)ZS(O,E);f[N>>2]=f[a+100>>2];f[Q+76>>2]=f[a+104>>2];f[Q+80>>2]=f[a+108>>2];f[Q+84>>2]=f[a+112>>2];f[Q+88>>2]=f[a+116>>2];f[H>>2]=f[P>>2]}P=f[a+40>>2]|0;H=f[(f[P>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=m;Q=i+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=o;Q=q+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[q>>2]=33882112;f[q+4>>2]=l;ei[H&511](P,h,i,q);ysb(h,d);zsb(m,1,h);d=h+36|0;P=f[d>>2]|0;if(P|0?(H=P+12|0,P=f[H>>2]|0,f[H>>2]=P+-1,(P|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;P=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[P>>2]|0)>0){d=f[h+40>>2]|0;H=0;do{f[d+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[P>>2]|0))}P=f[h+44>>2]|0;if((P|0)!=(h+48|0))g0(P);zsb(o,1,z);P=f[a+64>>2]|0;H=f[(f[P>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=m;d=i+8|0;f[d>>2]=0;f[d+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=o;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33882112;f[q+4>>2]=l;ei[H&511](P,h,i,q);zsb(m,1,e);zsb(o,1,c);e=f[a+56>>2]|0;P=f[(f[e>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=m;H=i+8|0;f[H>>2]=0;f[H+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=o;H=q+8|0;f[H>>2]=0;f[H+4>>2]=0;f[q>>2]=33882112;f[q+4>>2]=l;ei[P&511](e,h,i,q);g$(m,4);e=f[m>>2]|0;if((e|0)!=(c|0)){P=y+148|0;H=f[P>>2]|0;if(H|0){d=H+12|0;f[d>>2]=(f[d>>2]|0)+1}d=e+36|0;H=f[d>>2]|0;if(H|0?(Q=H+12|0,H=f[Q>>2]|0,f[Q>>2]=H+-1,(H|0)==1):0)_S(e);f[d>>2]=0;H=e+16|0;Q=e+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[Q>>2]|0)>0){N=f[e+40>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0;T=f[Q>>2]|0}while((O|0)<(T|0));f[e>>2]=f[c>>2];if((T|0)<3)L=83;else L=85}else{f[e>>2]=f[c>>2];L=83}if((L|0)==83){T=f[y+116>>2]|0;if((T|0)<3){f[Q>>2]=T;f[e+8>>2]=f[y+120>>2];f[e+12>>2]=f[y+124>>2];T=f[y+156>>2]|0;Q=f[e+44>>2]|0;f[Q>>2]=f[T>>2];f[Q+4>>2]=f[T+4>>2]}else L=85}if((L|0)==85)ZS(e,c);f[H>>2]=f[y+128>>2];f[e+20>>2]=f[y+132>>2];f[e+24>>2]=f[y+136>>2];f[e+28>>2]=f[y+140>>2];f[e+32>>2]=f[y+144>>2];f[d>>2]=f[P>>2];P=f[m>>2]|0;if((P|0)==(y|0))U=y;else{V=P;L=87}}else{V=c;L=87}if((L|0)==87){c=V+56|0;P=y+92|0;d=f[P>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=V+92|0;d=f[e>>2]|0;if(d|0?(H=d+12|0,d=f[H>>2]|0,f[H>>2]=d+-1,(d|0)==1):0)_S(c);f[e>>2]=0;d=V+72|0;H=V+60|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[H>>2]|0)>0){T=f[V+96>>2]|0;Q=0;do{f[T+(Q<<2)>>2]=0;Q=Q+1|0;W=f[H>>2]|0}while((Q|0)<(W|0));f[c>>2]=f[z>>2];if((W|0)<3)L=97;else L=99}else{f[c>>2]=f[z>>2];L=97}if((L|0)==97){W=f[y+60>>2]|0;if((W|0)<3){f[H>>2]=W;f[V+64>>2]=f[y+64>>2];f[V+68>>2]=f[y+68>>2];W=f[y+100>>2]|0;H=f[V+100>>2]|0;f[H>>2]=f[W>>2];f[H+4>>2]=f[W+4>>2]}else L=99}if((L|0)==99)ZS(c,z);f[d>>2]=f[y+72>>2];f[V+76>>2]=f[y+76>>2];f[V+80>>2]=f[y+80>>2];f[V+84>>2]=f[y+84>>2];f[V+88>>2]=f[y+88>>2];f[e>>2]=f[P>>2];U=f[m>>2]|0}P=U+112|0;if((P|0)==(y|0))X=U;else{e=y+36|0;V=f[e>>2]|0;if(V|0){d=V+12|0;f[d>>2]=(f[d>>2]|0)+1}d=U+148|0;V=f[d>>2]|0;if(V|0?(z=V+12|0,V=f[z>>2]|0,f[z>>2]=V+-1,(V|0)==1):0)_S(P);f[d>>2]=0;V=U+128|0;z=U+116|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[z>>2]|0)>0){c=f[U+152>>2]|0;W=0;do{f[c+(W<<2)>>2]=0;W=W+1|0;Z=f[z>>2]|0}while((W|0)<(Z|0));f[P>>2]=f[y>>2];if((Z|0)<3)L=112;else L=114}else{f[P>>2]=f[y>>2];L=112}do if((L|0)==112){Z=f[y+4>>2]|0;if((Z|0)>=3){L=114;break}f[z>>2]=Z;f[U+120>>2]=f[y+8>>2];f[U+124>>2]=f[y+12>>2];Z=f[y+44>>2]|0;W=f[U+156>>2]|0;f[W>>2]=f[Z>>2];f[W+4>>2]=f[Z+4>>2]}while(0);if((L|0)==114)ZS(P,y);f[V>>2]=f[y+16>>2];f[U+132>>2]=f[y+20>>2];f[U+136>>2]=f[y+24>>2];f[U+140>>2]=f[y+28>>2];f[U+144>>2]=f[y+32>>2];f[d>>2]=f[e>>2];X=f[m>>2]|0}e=X+168|0;if((e|0)!=(E|0)){d=a+120|0;y=f[d>>2]|0;if(y|0){U=y+12|0;f[U>>2]=(f[U>>2]|0)+1}U=X+204|0;y=f[U>>2]|0;do if(y|0){V=y+12|0;P=f[V>>2]|0;f[V>>2]=P+-1;if((P|0)!=1)break;_S(e)}while(0);f[U>>2]=0;y=X+184|0;P=X+172|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[P>>2]|0)>0){V=f[X+208>>2]|0;z=0;do{f[V+(z<<2)>>2]=0;z=z+1|0;_=f[P>>2]|0}while((z|0)<(_|0));f[e>>2]=f[E>>2];if((_|0)<3)L=127;else L=129}else{f[e>>2]=f[E>>2];L=127}do if((L|0)==127){_=f[a+88>>2]|0;if((_|0)>=3){L=129;break}f[P>>2]=_;f[X+176>>2]=f[a+92>>2];f[X+180>>2]=f[a+96>>2];_=f[a+128>>2]|0;z=f[X+212>>2]|0;f[z>>2]=f[_>>2];f[z+4>>2]=f[_+4>>2]}while(0);if((L|0)==129)ZS(e,E);f[y>>2]=f[a+100>>2];f[X+188>>2]=f[a+104>>2];f[X+192>>2]=f[a+108>>2];f[X+196>>2]=f[a+112>>2];f[X+200>>2]=f[a+116>>2];f[U>>2]=f[d>>2]}f[h>>2]=1124007936;d=h+4|0;U=h+8|0;X=h+40|0;A=d;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[X>>2]=U;y=h+48|0;E=h+44|0;f[E>>2]=y;f[y>>2]=0;f[h+52>>2]=0;e=f[o>>2]|0;P=h+36|0;do if((e|0)!=(h|0)){_=e+36|0;z=f[_>>2]|0;do if(z|0){V=z+12|0;Z=f[V>>2]|0;f[V>>2]=Z+-1;if((Z|0)!=1)break;_S(e)}while(0);f[_>>2]=0;z=e+16|0;Z=e+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[Z>>2]|0)>0){V=f[e+40>>2]|0;W=0;do{f[V+(W<<2)>>2]=0;W=W+1|0;$=f[Z>>2]|0}while((W|0)<($|0));f[e>>2]=f[h>>2];if(($|0)<3)L=140;else L=142}else{f[e>>2]=f[h>>2];L=140}do if((L|0)==140){W=f[d>>2]|0;if((W|0)>=3){L=142;break}f[Z>>2]=W;f[e+8>>2]=f[U>>2];f[e+12>>2]=f[h+12>>2];W=f[E>>2]|0;V=f[e+44>>2]|0;f[V>>2]=f[W>>2];f[V+4>>2]=f[W+4>>2]}while(0);if((L|0)==142)ZS(e,h);f[z>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];f[_>>2]=f[P>>2];Z=f[P>>2]|0;if(!Z)break;W=Z+12|0;Z=f[W>>2]|0;f[W>>2]=Z+-1;if((Z|0)!=1)break;_S(h)}while(0);f[P>>2]=0;P=h+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[d>>2]|0)>0){P=f[X>>2]|0;X=0;do{f[P+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[d>>2]|0))}d=f[E>>2]|0;if((d|0)!=(y|0))g0(d);d=f[a+48>>2]|0;y=f[(f[d>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=m;E=i+8|0;f[E>>2]=0;f[E+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=o;E=q+8|0;f[E>>2]=0;f[E+4>>2]=0;f[q>>2]=33882112;f[q+4>>2]=l;ei[y&511](d,h,i,q);d=f[o>>2]|0;y=f[d+4>>2]|0;if((y|0)<3)aa=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{E=f[d+40>>2]|0;X=0;P=1;while(1){e=Y(f[E+(X<<2)>>2]|0,P)|0;X=X+1|0;if((X|0)==(y|0)){aa=e;break}else P=e}}P=(aa>>>0)/7|0;aa=a+72|0;if(P>>>0>(f[aa>>2]|0)>>>0){f[h>>2]=0;f[h+4>>2]=0;A=tT(h,26)|0;B=438122;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,h,453206,437913,311)}lT(h,d,1,P);d=f[o>>2]|0;B=h+36|0;if((d|0)!=(h|0)){A=f[B>>2]|0;if(A|0){C=A+12|0;f[C>>2]=(f[C>>2]|0)+1}C=d+36|0;A=f[C>>2]|0;do if(A|0){a=A+12|0;y=f[a>>2]|0;f[a>>2]=y+-1;if((y|0)!=1)break;_S(d)}while(0);f[C>>2]=0;A=d+16|0;y=d+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[y>>2]|0)>0){a=f[d+40>>2]|0;X=0;do{f[a+(X<<2)>>2]=0;X=X+1|0;ba=f[y>>2]|0}while((X|0)<(ba|0));f[d>>2]=f[h>>2];if((ba|0)<3)L=168;else L=170}else{f[d>>2]=f[h>>2];L=168}do if((L|0)==168){ba=f[h+4>>2]|0;if((ba|0)>=3){L=170;break}f[y>>2]=ba;f[d+8>>2]=f[h+8>>2];f[d+12>>2]=f[h+12>>2];ba=f[h+44>>2]|0;X=f[d+44>>2]|0;f[X>>2]=f[ba>>2];f[X+4>>2]=f[ba+4>>2]}while(0);if((L|0)==170)ZS(d,h);f[A>>2]=f[h+16>>2];f[d+20>>2]=f[h+20>>2];f[d+24>>2]=f[h+24>>2];f[d+28>>2]=f[h+28>>2];f[d+32>>2]=f[h+32>>2];f[C>>2]=f[B>>2]}C=f[B>>2]|0;do if(C|0){d=C+12|0;A=f[d>>2]|0;f[d>>2]=A+-1;if((A|0)!=1)break;_S(h)}while(0);f[B>>2]=0;B=h+16|0;C=h+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){B=f[h+40>>2]|0;A=0;do{f[B+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[C>>2]|0))}C=f[h+44>>2]|0;if((C|0)!=(h+48|0))g0(C);C=f[k>>2]|0;f[h>>2]=0;f[h+4>>2]=P;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;$S(q,C,h,i);C=f[o>>2]|0;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=3;f[i+4>>2]=7;$S(r,C,h,i);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=1;f[i+4>>2]=5;$S(t,q,h,i);C=s+8|0;f[C>>2]=0;f[C+4>>2]=0;f[s>>2]=-1040121856;f[s+4>>2]=t;h_(r,s);C=t+36|0;A=f[C>>2]|0;do if(A|0){B=A+12|0;d=f[B>>2]|0;f[B>>2]=d+-1;if((d|0)!=1)break;_S(t)}while(0);f[C>>2]=0;C=t+16|0;A=t+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[A>>2]|0)>0){C=f[t+40>>2]|0;d=0;do{f[C+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[A>>2]|0))}A=f[t+44>>2]|0;if((A|0)!=(t+48|0))g0(A);A=r+36|0;t=f[A>>2]|0;do if(t|0){d=t+12|0;C=f[d>>2]|0;f[d>>2]=C+-1;if((C|0)!=1)break;_S(r)}while(0);f[A>>2]=0;A=r+16|0;t=r+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[t>>2]|0)>0){A=f[r+40>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[t>>2]|0))}t=f[r+44>>2]|0;if((t|0)!=(r+48|0))g0(t);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=0;f[i+4>>2]=1;$S(v,q,h,i);p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;l_(v,h,e0()|0)|0;t=v+36|0;r=f[t>>2]|0;do if(r|0){C=r+12|0;A=f[C>>2]|0;f[C>>2]=A+-1;if((A|0)!=1)break;_S(v)}while(0);f[t>>2]=0;t=v+16|0;r=v+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[r>>2]|0)>0){t=f[v+40>>2]|0;A=0;do{f[t+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[r>>2]|0))}r=f[v+44>>2]|0;if((r|0)!=(v+48|0))g0(r);r=(f[k>>2]|0)+56|0;f[h>>2]=0;f[h+4>>2]=P;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;$S(s,r,h,i);r=s+36|0;v=f[r>>2]|0;if(v|0){A=v+12|0;f[A>>2]=(f[A>>2]|0)+1}A=q+36|0;v=f[A>>2]|0;do if(v|0){t=v+12|0;C=f[t>>2]|0;f[t>>2]=C+-1;if((C|0)!=1)break;_S(q)}while(0);f[A>>2]=0;v=q+16|0;C=q+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[C>>2]|0)>0){t=f[q+40>>2]|0;d=0;do{f[t+(d<<2)>>2]=0;d=d+1|0;ca=f[C>>2]|0}while((d|0)<(ca|0));f[q>>2]=f[s>>2];if((ca|0)<3)L=214;else L=216}else{f[q>>2]=f[s>>2];L=214}do if((L|0)==214){ca=f[s+4>>2]|0;if((ca|0)>=3){L=216;break}f[C>>2]=ca;f[q+8>>2]=f[s+8>>2];f[q+12>>2]=f[s+12>>2];ca=f[s+44>>2]|0;d=f[q+44>>2]|0;f[d>>2]=f[ca>>2];f[d+4>>2]=f[ca+4>>2]}while(0);if((L|0)==216)ZS(q,s);L=s+16|0;f[v>>2]=f[L>>2];f[q+20>>2]=f[s+20>>2];f[q+24>>2]=f[s+24>>2];f[q+28>>2]=f[s+28>>2];f[q+32>>2]=f[s+32>>2];ca=f[r>>2]|0;f[A>>2]=ca;do if(ca|0){d=ca+12|0;t=f[d>>2]|0;f[d>>2]=t+-1;if((t|0)!=1)break;_S(s)}while(0);f[r>>2]=0;r=s+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[r>>2]|0)>0){L=f[s+40>>2]|0;ca=0;do{f[L+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[r>>2]|0))}r=f[s+44>>2]|0;if((r|0)!=(s+48|0))g0(r);r=f[o>>2]|0;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=2;f[i+4>>2]=3;$S(w,r,h,i);r=h+8|0;f[r>>2]=0;f[r+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;h_(w,h);r=w+36|0;s=f[r>>2]|0;do if(s|0){ca=s+12|0;L=f[ca>>2]|0;f[ca>>2]=L+-1;if((L|0)!=1)break;_S(w)}while(0);f[r>>2]=0;r=w+16|0;s=w+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){r=f[w+40>>2]|0;L=0;do{f[r+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[s>>2]|0))}s=f[w+44>>2]|0;if((s|0)!=(w+48|0))g0(s);s=f[aa>>2]|0;do if(P>>>0<s>>>0){w=h+4|0;L=i+4|0;r=h+8|0;ca=h+12|0;t=h+4|0;d=x+36|0;B=x+16|0;y=x+4|0;ba=x+40|0;X=x+44|0;a=x+48|0;E=f[k>>2]|0;f[h>>2]=P;f[w>>2]=s;f[i>>2]=-2147483648;f[L>>2]=2147483647;$S(x,E,h,i);p[i>>3]=0.0;f[h>>2]=-1056833530;f[t>>2]=i;f[r>>2]=1;f[ca>>2]=1;l_(x,h,e0()|0)|0;E=f[d>>2]|0;do if(E|0){e=E+12|0;U=f[e>>2]|0;f[e>>2]=U+-1;if((U|0)!=1)break;_S(x)}while(0);f[d>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[y>>2]|0)>0){E=f[ba>>2]|0;_=0;do{f[E+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[y>>2]|0))}_=f[X>>2]|0;if((_|0)!=(a|0))g0(_);_=(f[k>>2]|0)+56|0;E=f[aa>>2]|0;f[h>>2]=P;f[w>>2]=E;f[i>>2]=-2147483648;f[L>>2]=2147483647;$S(x,_,h,i);p[i>>3]=0.0;f[h>>2]=-1056833530;f[t>>2]=i;f[r>>2]=1;f[ca>>2]=1;l_(x,h,e0()|0)|0;_=f[d>>2]|0;do if(_|0){E=_+12|0;z=f[E>>2]|0;f[E>>2]=z+-1;if((z|0)!=1)break;_S(x)}while(0);f[d>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[y>>2]|0)>0){_=f[ba>>2]|0;ca=0;do{f[_+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[y>>2]|0))}y=f[X>>2]|0;if((y|0)==(a|0))break;g0(y)}while(0);x=f[A>>2]|0;do if(x|0){h=x+12|0;i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)!=1)break;_S(q)}while(0);f[A>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[C>>2]|0)>0){v=f[q+40>>2]|0;A=0;do{f[v+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[C>>2]|0))}C=f[q+44>>2]|0;if((C|0)!=(q+48|0))g0(C);mx(o);mx(m);mx(l);mx(k);mx(j);u=g;return}function usb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=(f[a+32>>2]|0)!=3;break}default:c=0}return c|0}function vsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function wsb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=u;u=u+80|0;h=d+64|0;i=d+48|0;j=d+36|0;k=d+24|0;l=d+12|0;m=d;n=f[c>>2]|0;o=n;if(((f[c+4>>2]|0)-n|0)!=36){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,18)|0;q=437894;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,102)}c=o+12|0;f[i>>2]=0;s=i+4|0;f[s>>2]=0;f[i+8>>2]=0;f[j>>2]=0;t=j+4|0;f[t>>2]=0;f[j+8>>2]=0;f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;iFa(i,1,o);w=f[a+40>>2]|0;_h[f[(f[w>>2]|0)+92>>2]&127](w,i,1,j,k)|0;w=f[j>>2]|0;x=w;if(((f[t>>2]|0)-w|0)!=12){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,24)|0;q=437992;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,112)}if((f[k>>2]|0)!=(f[v>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,22)|0;q=438017;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,113)}w=g+4|0;y=f[w>>2]|0;z=g+8|0;if((y|0)==(f[z>>2]|0))OGa(g,x);else{jFa(y,x);f[w>>2]=(f[w>>2]|0)+12}if(((f[o+4>>2]|0)-(f[n>>2]|0)|0)!=16){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,18)|0;q=438040;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,117)}jFa(l,o);if(f[(f[o>>2]|0)+4>>2]&1|0){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,20)|0;q=438059;r=p+20|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,119)}o=(f[l>>2]|0)+4|0;f[o>>2]=(f[o>>2]|0)/2|0;iFa(i,1,l);o=f[a+64>>2]|0;_h[f[(f[o>>2]|0)+92>>2]&127](o,i,1,j,k)|0;o=f[j>>2]|0;n=o;if(((f[t>>2]|0)-o|0)!=12){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,24)|0;q=437992;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,123)}if((f[k>>2]|0)!=(f[v>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,22)|0;q=438017;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,124)}o=f[w>>2]|0;if((o|0)==(f[z>>2]|0))OGa(g,n);else{jFa(o,n);f[w>>2]=(f[w>>2]|0)+12}iFa(i,1,c);c=f[a+56>>2]|0;_h[f[(f[c>>2]|0)+92>>2]&127](c,i,1,j,k)|0;c=f[j>>2]|0;n=c;if(((f[t>>2]|0)-c|0)!=12){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,24)|0;q=437992;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,130)}if((f[k>>2]|0)!=(f[v>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,22)|0;q=438017;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452925,437913,131)}q=f[w>>2]|0;if((q|0)==(f[z>>2]|0))OGa(g,n);else{jFa(q,n);f[w>>2]=(f[w>>2]|0)+12}w=e+4|0;n=f[w>>2]|0;q=f[e>>2]|0;g=n-q|0;z=(g|0)/12|0;p=q;q=n;if(z>>>0>=2){if((g|0)!=24?(g=p+24|0,(q|0)!=(g|0)):0){p=q;while(1){q=p+-12|0;f[w>>2]=q;n=f[q>>2]|0;if(!n)A=q;else{q=p+-8|0;r=f[q>>2]|0;if((r|0)!=(n|0))f[q>>2]=r+(~((r+-4-n|0)>>>2)<<2);YDc(n);A=f[w>>2]|0}if((A|0)==(g|0))break;else p=A}}}else xsb(e,2-z|0);z=a+72|0;f[h>>2]=f[z>>2];a=h+4|0;f[a>>2]=5;A=h+8|0;f[A>>2]=-1;p=h+12|0;f[p>>2]=-1;f[m>>2]=0;g=m+4|0;f[g>>2]=0;f[m+8>>2]=0;w=h+16|0;lFa(m,h,w);n=f[m>>2]|0;r=f[g>>2]|0;a:do if((n|0)==(r|0)){B=n;C=40}else{q=n;while(1){if((f[q>>2]|0)<0){B=q;C=40;break a}q=q+4|0;if((q|0)==(r|0)){D=r;break}}}while(0);if((C|0)==40)if((B|0)!=(r|0)){q=B+4|0;if((q|0)==(r|0)){E=r;F=B}else{c=q;q=B;while(1){B=f[c>>2]|0;if((B|0)<0)G=q;else{f[q>>2]=B;G=q+4|0}c=c+4|0;if((c|0)==(r|0))break;else q=G}E=f[g>>2]|0;F=G}if((F|0)==(E|0))D=E;else{G=E+(~((E+-4-F|0)>>>2)<<2)|0;f[g>>2]=G;D=G}}else D=r;r=f[e>>2]|0;if((r|0)==(m|0))H=n;else{xxa(r,f[m>>2]|0,D);H=f[m>>2]|0}if(H|0){D=f[g>>2]|0;if((D|0)!=(H|0))f[g>>2]=D+(~((D+-4-H|0)>>>2)<<2);YDc(H)}f[h>>2]=f[z>>2];f[a>>2]=1;f[A>>2]=-1;f[p>>2]=-1;f[m>>2]=0;p=m+4|0;f[p>>2]=0;f[m+8>>2]=0;lFa(m,h,w);w=f[m>>2]|0;h=f[p>>2]|0;b:do if((w|0)==(h|0)){I=w;C=57}else{A=w;while(1){if((f[A>>2]|0)<0){I=A;C=57;break b}A=A+4|0;if((A|0)==(h|0)){J=h;break}}}while(0);do if((C|0)==57)if((I|0)==(h|0))J=h;else{A=I+4|0;if((A|0)==(h|0)){K=h;L=I}else{a=A;A=I;while(1){z=f[a>>2]|0;if((z|0)<0)M=A;else{f[A>>2]=z;M=A+4|0}a=a+4|0;if((a|0)==(h|0))break;else A=M}K=f[p>>2]|0;L=M}if((L|0)==(K|0)){J=K;break}A=K+(~((K+-4-L|0)>>>2)<<2)|0;f[p>>2]=A;J=A}while(0);L=(f[e>>2]|0)+12|0;if((L|0)==(m|0))N=w;else{xxa(L,f[m>>2]|0,J);N=f[m>>2]|0}if(N|0){m=f[p>>2]|0;if((m|0)!=(N|0))f[p>>2]=m+(~((m+-4-N|0)>>>2)<<2);YDc(N)}N=f[l>>2]|0;if(N|0){m=l+4|0;l=f[m>>2]|0;if((l|0)!=(N|0))f[m>>2]=l+(~((l+-4-N|0)>>>2)<<2);YDc(N)}N=f[k>>2]|0;if(N|0){l=f[v>>2]|0;if((l|0)==(N|0))O=N;else{m=l;while(1){l=m+-12|0;f[v>>2]=l;p=f[l>>2]|0;if(!p)P=l;else{l=m+-8|0;J=f[l>>2]|0;if((J|0)!=(p|0))f[l>>2]=J+(~((J+-4-p|0)>>>2)<<2);YDc(p);P=f[v>>2]|0}if((P|0)==(N|0))break;else m=P}O=f[k>>2]|0}YDc(O)}O=f[j>>2]|0;if(O|0){k=f[t>>2]|0;if((k|0)==(O|0))Q=O;else{P=k;while(1){k=P+-12|0;f[t>>2]=k;m=f[k>>2]|0;if(!m)R=k;else{k=P+-8|0;N=f[k>>2]|0;if((N|0)!=(m|0))f[k>>2]=N+(~((N+-4-m|0)>>>2)<<2);YDc(m);R=f[t>>2]|0}if((R|0)==(O|0))break;else P=R}Q=f[j>>2]|0}YDc(Q)}Q=f[i>>2]|0;if(!Q){u=d;return 0}j=f[s>>2]|0;if((j|0)==(Q|0))S=Q;else{R=j;while(1){j=R+-12|0;f[s>>2]=j;P=f[j>>2]|0;if(!P)T=j;else{j=R+-8|0;O=f[j>>2]|0;if((O|0)!=(P|0))f[j>>2]=O+(~((O+-4-P|0)>>>2)<<2);YDc(P);T=f[s>>2]|0}if((T|0)==(Q|0))break;else R=T}S=f[i>>2]|0}YDc(S);u=d;return 0}function xsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){XIc(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)mCc(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{n=VDc(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;XIc(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{g=g+-12|0;jFa(j+-12|0,g);j=h+-12|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~((q+-4-d|0)>>>2)<<2);YDc(d)}}while((c|0)!=(k|0))}if(!p)return;YDc(p);return}function ysb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+256|0;e=d;if((f[c+4>>2]|0)!=4){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,11)|0;h=438149;i=g+11|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,438161,437913,364)}j=f[c+40>>2]|0;if((f[j>>2]|0)!=1){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,14)|0;h=438177;i=g+14|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,438161,437913,365)}k=f[j+4>>2]|0;if(!(k&1)){XIc(e|0,0,256)|0;j=e+16|0;f[j>>2]=-2147483648;f[j+4>>2]=2147483647;j=e+24|0;f[j>>2]=-2147483648;f[j+4>>2]=2147483647;j=e;f[j>>2]=-2147483648;f[j+4>>2]=2147483647;j=e+8|0;f[j>>2]=(k|0)/2|0;f[j+4>>2]=k;aT(a,c,e);u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;g=tT(e,19)|0;h=438192;i=g+19|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,438161,437913,367)}}function zsb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=a+8|0;e=f[a>>2]|0;g=e;if((((f[d>>2]|0)-e|0)/56|0)>>>0<b>>>0){hHa(a);if(b>>>0>76695844)mCc(a);h=((f[d>>2]|0)-(f[a>>2]|0)|0)/56|0;i=h<<1;j=h>>>0<38347922?(i>>>0<b>>>0?b:i):76695844;if(j>>>0>76695844)mCc(a);i=VDc(j*56|0)|0;h=a+4|0;f[h>>2]=i;f[a>>2]=i;f[d>>2]=i+(j*56|0);j=c+4|0;d=c+8|0;k=c+12|0;l=c+16|0;m=c+20|0;n=c+24|0;o=c+28|0;p=c+32|0;q=c+36|0;r=c+44|0;s=b;t=i;do{f[t>>2]=f[c>>2];i=t+4|0;f[i>>2]=f[j>>2];u=t+8|0;f[u>>2]=f[d>>2];f[t+12>>2]=f[k>>2];f[t+16>>2]=f[l>>2];f[t+20>>2]=f[m>>2];f[t+24>>2]=f[n>>2];f[t+28>>2]=f[o>>2];f[t+32>>2]=f[p>>2];v=f[q>>2]|0;f[t+36>>2]=v;f[t+40>>2]=u;u=t+48|0;w=t+44|0;f[w>>2]=u;f[u>>2]=0;f[t+52>>2]=0;if(v|0){u=v+12|0;f[u>>2]=(f[u>>2]|0)+1}if((f[j>>2]|0)<3){u=f[r>>2]|0;v=f[w>>2]|0;f[v>>2]=f[u>>2];f[v+4>>2]=f[u+4>>2]}else{f[i>>2]=0;ZS(t,c)}t=(f[h>>2]|0)+56|0;f[h>>2]=t;s=s+-1|0}while((s|0)!=0);return}s=a+4|0;t=((f[s>>2]|0)-e|0)/56|0;e=t>>>0<b>>>0;h=e?t:b;if(h|0){r=c+36|0;j=c+4|0;q=c+8|0;p=c+12|0;o=c+44|0;n=c+16|0;m=c+20|0;l=c+24|0;k=c+28|0;d=c+32|0;i=h;h=g;while(1){if((h|0)!=(c|0)){g=f[r>>2]|0;if(g|0){u=g+12|0;f[u>>2]=(f[u>>2]|0)+1}u=h+36|0;g=f[u>>2]|0;if(g|0?(v=g+12|0,g=f[v>>2]|0,f[v>>2]=g+-1,(g|0)==1):0)_S(h);f[u>>2]=0;g=h+16|0;v=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[v>>2]|0)>0){w=f[h+40>>2]|0;x=0;do{f[w+(x<<2)>>2]=0;x=x+1|0;y=f[v>>2]|0}while((x|0)<(y|0));f[h>>2]=f[c>>2];if((y|0)<3)z=15;else z=17}else{f[h>>2]=f[c>>2];z=15}if((z|0)==15){z=0;x=f[j>>2]|0;if((x|0)<3){f[v>>2]=x;f[h+8>>2]=f[q>>2];f[h+12>>2]=f[p>>2];x=f[o>>2]|0;w=f[h+44>>2]|0;f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2]}else z=17}if((z|0)==17){z=0;ZS(h,c)}f[g>>2]=f[n>>2];f[h+20>>2]=f[m>>2];f[h+24>>2]=f[l>>2];f[h+28>>2]=f[k>>2];f[h+32>>2]=f[d>>2];f[u>>2]=f[r>>2]}i=i+-1|0;if(!i)break;else h=h+56|0}}if(e){e=c+4|0;h=c+8|0;i=c+12|0;r=c+16|0;d=c+20|0;k=c+24|0;l=c+28|0;m=c+32|0;n=c+36|0;z=c+44|0;o=b-t|0;t=f[s>>2]|0;do{f[t>>2]=f[c>>2];p=t+4|0;f[p>>2]=f[e>>2];q=t+8|0;f[q>>2]=f[h>>2];f[t+12>>2]=f[i>>2];f[t+16>>2]=f[r>>2];f[t+20>>2]=f[d>>2];f[t+24>>2]=f[k>>2];f[t+28>>2]=f[l>>2];f[t+32>>2]=f[m>>2];j=f[n>>2]|0;f[t+36>>2]=j;f[t+40>>2]=q;q=t+48|0;y=t+44|0;f[y>>2]=q;f[q>>2]=0;f[t+52>>2]=0;if(j|0){q=j+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[e>>2]|0)<3){q=f[z>>2]|0;j=f[y>>2]|0;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2]}else{f[p>>2]=0;ZS(t,c)}t=(f[s>>2]|0)+56|0;f[s>>2]=t;o=o+-1|0}while((o|0)!=0);return}o=(f[a>>2]|0)+(b*56|0)|0;b=f[s>>2]|0;if((b|0)==(o|0))return;else A=b;do{b=A+-56|0;f[s>>2]=b;a=A+-20|0;t=f[a>>2]|0;if(t|0?(c=t+12|0,t=f[c>>2]|0,f[c>>2]=t+-1,(t|0)==1):0)_S(b);f[a>>2]=0;a=A+-40|0;b=A+-52|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[b>>2]|0)>0){a=f[A+-16>>2]|0;t=0;do{f[a+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[b>>2]|0))}b=f[A+-12>>2]|0;if((b|0)!=(A+-8|0))g0(b);A=f[s>>2]|0}while((A|0)!=(o|0));return}function Asb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,14)|0;h=454995;i=g+14|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));h=c+4|0;g=f[h>>2]|0;do if(g){i=f[e>>2]|0;j=(i|0)==0?1154740:i;k=h;l=g;a:while(1){m=l;while(1){o=f[m+16>>2]|0;if((o|0)==(i|0))break;if((Ioc((o|0)==0?1154740:o,j)|0)>=0)break;o=f[m+4>>2]|0;if(!o){p=k;break a}else m=o}l=f[m>>2]|0;if(!l){p=m;break}else k=m}if((p|0)!=(h|0)){k=f[p+16>>2]|0;if((i|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<=-1:0){q=0.0;break}q=+tIa(p+24|0,-1)}else q=0.0}else q=0.0;while(0);uT(e);e=VDc(48)|0;JHa(e);f[e>>2]=101080;b[e+44>>0]=0;n[e+40>>2]=q;p=VDc(16)|0;f[p+4>>2]=1;f[p>>2]=101192;f[p+8>>2]=e;f[a>>2]=p;f[a+4>>2]=e;KHa(e,c);n[e+36>>2]=q;u=d;return}function Bsb(a){a=a|0;YDc(a);return}function Csb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Dsb(a){a=a|0;REa(a);YDc(a);return}function Esb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+40|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=101212;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function Fsb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function Gsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Hsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Isb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Jsb(a,b){a=a|0;b=b|0;return 0}function Ksb(a,b,c){a=a|0;b=b|0;c=c|0;return}function Lsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function Msb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=UIc(r|0,0,e|0,k|0)|0;g=g+1|0;o=$Ic(0,l|0,32)|0;l=J;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;c=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(c|0));z5(-215,a,452815,452821,161)}return 0}function Nsb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,k=0,l=0.0;h=+n[a+40>>2];if((d|0)>0&(f|0)<(g|0)){i=f;j=c;k=b}else return;while(1){b=0;do{l=+n[k+(b<<2)>>2];n[j+(b<<2)>>2]=!(l>=0.0)?h*l:l;b=b+1|0}while((b|0)!=(d|0));i=i+1|0;if((i|0)==(g|0))break;else{j=j+(e<<2)|0;k=k+(e<<2)|0}}return}function Osb(a){a=a|0;YDc(a);return}function Psb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;i=f[d+16>>2]|0;e=f[f[d+44>>2]>>2]|0;d=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(a|0)>0)q=0;else return;do{o=h+(Y(b,q)|0)+(c<<2)|0;m=i+(Y(e,q)|0)+(c<<2)|0;r=+n[d>>2];g=0;p=m;m=o;while(1){o=0;do{s=+n[m+(o<<2)>>2];n[p+(o<<2)>>2]=!(s>=0.0)?r*s:s;o=o+1|0}while((o|0)!=(a|0));g=g+1|0;if((g|0)==(j|0))break;else{p=p+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function Qsb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,9)|0;h=438714;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=c+4|0;k=f[j>>2]|0;do if(k){l=f[e>>2]|0;m=(l|0)==0?1154740:l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)!=(j|0)){o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=0.0;break}t=+tIa(s+24|0,-1)}else t=0.0}else t=0.0;while(0);uT(e);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,9)|0;h=438724;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));s=f[j>>2]|0;do if(s){k=f[e>>2]|0;o=(k|0)==0?1154740:k;p=j;r=s;b:while(1){v=r;while(1){w=f[v+16>>2]|0;if((w|0)==(k|0))break;if((Ioc((w|0)==0?1154740:w,o)|0)>=0)break;w=f[v+4>>2]|0;if(!w){x=p;break b}else v=w}r=f[v>>2]|0;if(!r){x=v;break}else p=v}if((x|0)!=(j|0)){p=f[x+16>>2]|0;if((k|0)!=(p|0)?(Ioc(o,(p|0)==0?1154740:p)|0)<=-1:0){y=6.0;break}y=+tIa(x+24|0,-1)}else y=6.0}else y=6.0;while(0);uT(e);x=VDc(56)|0;if(!(t<=y)){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,20)|0;h=438734;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,438755,438529,373)}else{JHa(x);f[x>>2]=101232;b[x+52>>0]=0;n[x+44>>2]=t;n[x+48>>2]=y;e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=101344;f[e+8>>2]=x;f[a>>2]=e;f[a+4>>2]=x;KHa(x,c);n[x+36>>2]=t;n[x+40>>2]=y;u=d;return}}function Rsb(a){a=a|0;YDc(a);return}function Ssb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tsb(a){a=a|0;REa(a);YDc(a);return}function Usb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+44|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=101364;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function Vsb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function Wsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Xsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Ysb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Zsb(a,b){a=a|0;b=b|0;return 0}function _sb(a,b,c){a=a|0;b=b|0;c=c|0;return}function $sb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function atb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=jJc(r|0,((r|0)<0)<<31>>31|0,1)|0;o=UIc(l|0,J|0,e|0,k|0)|0;g=g+1|0;l=$Ic(0,o|0,32)|0;o=J;if(g>>>0>=j>>>0){h=o;i=l;q=3;break}else{e=l;k=o}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;c=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(c|0));z5(-215,a,452815,452821,161)}return 0}function btb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0;if((f|0)>=(g|0))return;h=a+44|0;i=a+48|0;if((d|0)>0){j=f;k=c;l=b}else return;while(1){b=0;do{m=+n[l+(b<<2)>>2];o=+n[h>>2];if(!(m>=o))p=o;else{o=+n[i>>2];p=m<=o?m:o}n[k+(b<<2)>>2]=p;b=b+1|0}while((b|0)!=(d|0));j=j+1|0;if((j|0)==(g|0))break;else{k=k+(e<<2)|0;l=l+(e<<2)|0}}return}function ctb(a){a=a|0;YDc(a);return}function dtb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[a+12>>2]|0;b=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;o=(a|0)>0;i=b+4|0;if((j|0)<=0)return;e=f[h+16>>2]|0;m=f[f[h+44>>2]>>2]|0;h=f[d+16>>2]|0;g=f[f[d+44>>2]>>2]|0;d=0;do{if(o){p=0;q=e+(Y(m,d)|0)+(c<<2)|0;r=h+(Y(g,d)|0)+(c<<2)|0;while(1){s=0;do{t=+n[r+(s<<2)>>2];u=+n[b>>2];if(!(t>=u))v=u;else{u=+n[i>>2];v=t<=u?t:u}n[q+(s<<2)>>2]=v;s=s+1|0}while((s|0)!=(a|0));p=p+1|0;if((p|0)==(j|0))break;else{q=q+(k<<2)|0;r=r+(k<<2)|0}}}d=d+1|0}while((d|0)!=(l|0));return}function etb(a,c){a=a|0;c=c|0;var d=0,e=0;d=VDc(40)|0;JHa(d);f[d>>2]=101384;b[d+37>>0]=0;e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=101496;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;KHa(d,c);return}function ftb(a){a=a|0;YDc(a);return}function gtb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function htb(a){a=a|0;REa(a);YDc(a);return}function itb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+36|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=101516;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function jtb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function ktb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ltb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function mtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ntb(a,b){a=a|0;b=b|0;return 0}function otb(a,b,c){a=a|0;b=b|0;c=c|0;return}function ptb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function qtb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=UIc(r|0,0,e|0,k|0)|0;g=g+1|0;o=$Ic(0,l|0,32)|0;l=J;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;c=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(c|0));z5(-215,a,452815,452821,161)}return 0}function rtb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+hrc(+n[j+(b<<2)>>2]);n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function stb(a){a=a|0;YDc(a);return}function ttb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+hrc(+n[m+(g<<2)>>2]);n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function utb(a,c){a=a|0;c=c|0;var d=0,e=0;d=VDc(40)|0;JHa(d);f[d>>2]=101536;b[d+37>>0]=0;e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=101648;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;KHa(d,c);return}function vtb(a){a=a|0;YDc(a);return}function wtb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xtb(a){a=a|0;REa(a);YDc(a);return}function ytb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+36|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=101668;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function ztb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function Atb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Btb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Ctb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Dtb(a,b){a=a|0;b=b|0;return 0}function Etb(a,b,c){a=a|0;b=b|0;c=c|0;return}function Ftb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function Gtb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=mJc(r|0,((r|0)<0)<<31>>31|0,3,0)|0;o=UIc(l|0,J|0,e|0,k|0)|0;g=g+1|0;l=$Ic(0,o|0,32)|0;o=J;if(g>>>0>=j>>>0){h=o;i=l;q=3;break}else{e=l;k=o}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;c=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(c|0));z5(-215,a,452815,452821,161)}return 0}function Htb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=1.0/(+V(+-+n[j+(b<<2)>>2])+1.0);n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Itb(a){a=a|0;YDc(a);return}function Jtb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=1.0/(+V(+-+n[m+(g<<2)>>2])+1.0);n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function Ktb(a,c){a=a|0;c=c|0;var d=0,e=0;d=VDc(40)|0;JHa(d);f[d>>2]=101688;b[d+37>>0]=0;e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=101800;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;KHa(d,c);return}function Ltb(a){a=a|0;YDc(a);return}function Mtb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ntb(a){a=a|0;REa(a);YDc(a);return}function Otb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+36|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=101820;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function Ptb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function Qtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Rtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Stb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Ttb(a,b){a=a|0;b=b|0;return 0}function Utb(a,b,c){a=a|0;b=b|0;c=c|0;return}function Vtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function Wtb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=jJc(r|0,((r|0)<0)<<31>>31|0,1)|0;o=UIc(l|0,J|0,e|0,k|0)|0;g=g+1|0;l=$Ic(0,o|0,32)|0;o=J;if(g>>>0>=j>>>0){h=o;i=l;q=3;break}else{e=l;k=o}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;c=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(c|0));z5(-215,a,452815,452821,161)}return 0}function Xtb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+n[j+(b<<2)>>2];if(!(k>=0.0))l=+V(+k)+-1.0;else l=k;n[i+(b<<2)>>2]=l;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Ytb(a){a=a|0;YDc(a);return}function Ztb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+n[m+(g<<2)>>2];if(!(r>=0.0))s=+V(+r)+-1.0;else s=r;n[e+(g<<2)>>2]=s;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function _tb(a,c){a=a|0;c=c|0;var d=0,e=0;d=VDc(40)|0;JHa(d);f[d>>2]=101840;b[d+37>>0]=0;e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=101952;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;KHa(d,c);return}function $tb(a){a=a|0;YDc(a);return}function aub(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bub(a){a=a|0;REa(a);YDc(a);return}function cub(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+36|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=101972;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function dub(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function eub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function fub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function gub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function hub(a,b){a=a|0;b=b|0;return 0}function iub(a,b,c){a=a|0;b=b|0;c=c|0;return}function jub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function kub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=UIc(r|0,0,e|0,k|0)|0;g=g+1|0;o=$Ic(0,l|0,32)|0;l=J;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;c=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(c|0));z5(-215,a,452815,452821,161)}return 0}function lub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+L(+(+n[j+(b<<2)>>2]));n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function mub(a){a=a|0;YDc(a);return}function nub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+L(+(+n[m+(g<<2)>>2]));n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function oub(a,c){a=a|0;c=c|0;var d=0,e=0;d=VDc(40)|0;JHa(d);f[d>>2]=101992;b[d+37>>0]=0;e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=102104;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;KHa(d,c);return}function pub(a){a=a|0;YDc(a);return}function qub(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rub(a){a=a|0;REa(a);YDc(a);return}function sub(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+36|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=102124;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function tub(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function uub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function vub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function wub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function xub(a,b){a=a|0;b=b|0;return 0}function yub(a,b,c){a=a|0;b=b|0;c=c|0;return}function zub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function Aub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=mJc(r|0,((r|0)<0)<<31>>31|0,5,0)|0;o=UIc(l|0,J|0,e|0,k|0)|0;g=g+1|0;l=$Ic(0,o|0,32)|0;o=J;if(g>>>0>=j>>>0){h=o;i=l;q=3;break}else{e=l;k=o}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;c=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(c|0));z5(-215,a,452815,452821,161)}return 0}function Bub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+W(+(+V(+-+L(+(+n[j+(b<<2)>>2])))+1.0));n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Cub(a){a=a|0;YDc(a);return}function Dub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+W(+(+V(+-+L(+(+n[m+(g<<2)>>2])))+1.0));n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function Eub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0.0,w=0,x=0.0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[440269]|0;b[g+1>>0]=b[440270]|0;b[g+2>>0]=b[440271]|0;b[g+3>>0]=b[440272]|0;b[g+4>>0]=b[440273]|0;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1154740:i;k=g;l=h;a:while(1){m=l;while(1){o=f[m+16>>2]|0;if((o|0)==(i|0))break;if((Ioc((o|0)==0?1154740:o,j)|0)>=0)break;o=f[m+4>>2]|0;if(!o){p=k;break a}else m=o}l=f[m>>2]|0;if(!l){p=m;break}else k=m}if((p|0)!=(g|0)){k=f[p+16>>2]|0;if((i|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<=-1:0){q=1.0;break}q=+tIa(p+24|0,-1)}else q=1.0}else q=1.0;while(0);uT(e);f[e>>2]=0;f[e+4>>2]=0;p=tT(e,5)|0;b[p>>0]=b[451291]|0;b[p+1>>0]=b[451292]|0;b[p+2>>0]=b[451293]|0;b[p+3>>0]=b[451294]|0;b[p+4>>0]=b[451295]|0;p=f[g>>2]|0;do if(p){h=f[e>>2]|0;k=(h|0)==0?1154740:h;l=g;o=p;b:while(1){r=o;while(1){s=f[r+16>>2]|0;if((s|0)==(h|0))break;if((Ioc((s|0)==0?1154740:s,k)|0)>=0)break;s=f[r+4>>2]|0;if(!s){t=l;break b}else r=s}o=f[r>>2]|0;if(!o){t=r;break}else l=r}if((t|0)!=(g|0)){l=f[t+16>>2]|0;if((h|0)!=(l|0)?(Ioc(k,(l|0)==0?1154740:l)|0)<=-1:0){v=1.0;break}v=+tIa(t+24|0,-1)}else v=1.0}else v=1.0;while(0);uT(e);f[e>>2]=0;f[e+4>>2]=0;t=tT(e,5)|0;b[t>>0]=b[440275]|0;b[t+1>>0]=b[440276]|0;b[t+2>>0]=b[440277]|0;b[t+3>>0]=b[440278]|0;b[t+4>>0]=b[440279]|0;t=f[g>>2]|0;do if(t){p=f[e>>2]|0;l=(p|0)==0?1154740:p;o=g;j=t;c:while(1){i=j;while(1){m=f[i+16>>2]|0;if((m|0)==(p|0))break;if((Ioc((m|0)==0?1154740:m,l)|0)>=0)break;m=f[i+4>>2]|0;if(!m){w=o;break c}else i=m}j=f[i>>2]|0;if(!j){w=i;break}else o=i}if((w|0)!=(g|0)){o=f[w+16>>2]|0;if((p|0)!=(o|0)?(Ioc(l,(o|0)==0?1154740:o)|0)<=-1:0){x=0.0;break}x=+tIa(w+24|0,-1)}else x=0.0}else x=0.0;while(0);uT(e);e=VDc(64)|0;JHa(e);f[e>>2]=102144;b[e+60>>0]=0;n[e+48>>2]=q;n[e+52>>2]=v;n[e+56>>2]=x;w=VDc(16)|0;f[w+4>>2]=1;f[w>>2]=102256;f[w+8>>2]=e;f[a>>2]=w;f[a+4>>2]=e;KHa(e,c);n[e+36>>2]=q;n[e+40>>2]=v;n[e+44>>2]=x;u=d;return}function Fub(a){a=a|0;YDc(a);return}function Gub(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Hub(a){a=a|0;REa(a);YDc(a);return}function Iub(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+48|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=102276;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function Jub(a,b){a=a|0;b=b|0;var c=0;if((b|0)!=2){c=(b|2|0)==3;return c|0}if(((f[a+32>>2]|0)+-1|0)>>>0>1){c=1;return c|0}c=+n[a+48>>2]==1.0;return c|0}function Kub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Lub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Mub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Nub(a,b){a=a|0;b=b|0;return Tub(a+48|0,b)|0}function Oub(a,b,c){a=a|0;b=b|0;c=c|0;Sub(a+48|0,b,c);return}function Pub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function Qub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+16|0;e=c;g=f[d+4>>2]|0;h=f[d>>2]|0;d=h;if((g|0)==(h|0)){i=0;j=0;J=i;u=c;return j|0}k=a+48|0;a=(g-h|0)/12|0;h=0;g=0;l=0;while(1){m=f[d+(h*12|0)+4>>2]|0;o=f[d+(h*12|0)>>2]|0;p=m-o|0;q=p>>2;r=o;if((r|0)!=(m|0)){if((p|0)<=-4){s=7;break}if((p|0)>0){p=0;m=1;while(1){o=Y(f[r+(p<<2)>>2]|0,m)|0;p=p+1|0;if((p|0)>=(q|0)){t=o;break}else m=o}}else t=1}else t=0;m=+n[k>>2]==1.0;q=mJc((m?2:10)|0,(m?0:0)|0,t|0,((t|0)<0)<<31>>31|0)|0;m=UIc(q|0,J|0,g|0,l|0)|0;h=h+1|0;q=$Ic(0,m|0,32)|0;m=J;if(h>>>0>=a>>>0){i=m;j=q;s=3;break}else{g=q;l=m}}if((s|0)==3){J=i;u=c;return j|0}else if((s|0)==7){f[e>>2]=0;f[e+4>>2]=0;s=tT(e,70)|0;j=452744;c=s+70|0;do{b[s>>0]=b[j>>0]|0;s=s+1|0;j=j+1|0}while((s|0)<(c|0));z5(-215,e,452815,452821,161)}return 0}function Rub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0;h=+n[a+52>>2];i=+n[a+56>>2];j=+n[a+48>>2];a=(d|0)>0&(f|0)<(g|0);if(j==1.0){if(a){k=c;l=f;m=b}else return;while(1){o=0;do{n[k+(o<<2)>>2]=i+h*+n[m+(o<<2)>>2];o=o+1|0}while((o|0)!=(d|0));l=l+1|0;if((l|0)==(g|0))break;else{k=k+(e<<2)|0;m=m+(e<<2)|0}}return}else{if(a){p=f;q=c;r=b}else return;while(1){b=0;do{s=+N(+(i+h*+n[r+(b<<2)>>2]),+j);n[q+(b<<2)>>2]=s;b=b+1|0}while((b|0)!=(d|0));p=p+1|0;if((p|0)==(g|0))break;else{q=q+(e<<2)|0;r=r+(e<<2)|0}}return}}function Sub(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;if(!(+n[a>>2]==1.0)){u=d;return}p[h>>3]=+n[a+4>>2];i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;o=g+48|0;q=g+44|0;f[q>>2]=o;f[o>>2]=0;f[g+52>>2]=0;f[e>>2]=1;r=e+4|0;f[r>>2]=1;XS(g,2,e,5);k_(g,h)|0;if((g|0)==(b|0)){s=g+36|0;t=f[b+36>>2]|0}else{v=g+36|0;w=f[v>>2]|0;if(w|0){x=w+12|0;f[x>>2]=(f[x>>2]|0)+1}x=b+36|0;w=f[x>>2]|0;if(w|0?(y=w+12|0,w=f[y>>2]|0,f[y>>2]=w+-1,(w|0)==1):0)_S(b);f[x>>2]=0;w=b+16|0;y=b+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[y>>2]|0)>0){z=f[b+40>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0;B=f[y>>2]|0}while((A|0)<(B|0));f[b>>2]=f[g>>2];if((B|0)<3)C=14;else C=16}else{f[b>>2]=f[g>>2];C=14}if((C|0)==14){B=f[i>>2]|0;if((B|0)<3){f[y>>2]=B;f[b+8>>2]=f[j>>2];f[b+12>>2]=f[g+12>>2];j=f[q>>2]|0;B=f[b+44>>2]|0;f[B>>2]=f[j>>2];f[B+4>>2]=f[j+4>>2]}else C=16}if((C|0)==16)ZS(b,g);f[w>>2]=f[g+16>>2];f[b+20>>2]=f[g+20>>2];f[b+24>>2]=f[g+24>>2];f[b+28>>2]=f[g+28>>2];f[b+32>>2]=f[g+32>>2];b=f[v>>2]|0;f[x>>2]=b;s=v;t=b}if(t|0?(b=t+12|0,t=f[b>>2]|0,f[b>>2]=t+-1,(t|0)==1):0)_S(g);f[s>>2]=0;s=g+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[i>>2]|0)>0){s=f[k>>2]|0;k=0;do{f[s+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[q>>2]|0;if((i|0)!=(o|0))g0(i);p[h>>3]=+n[a+8>>2];a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[g>>2]=1124007936;a=g+4|0;i=g+8|0;o=g+40|0;l=a;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[o>>2]=i;l=g+48|0;m=g+44|0;f[m>>2]=l;f[l>>2]=0;f[g+52>>2]=0;f[e>>2]=1;f[r>>2]=1;XS(g,2,e,5);k_(g,h)|0;if((g|0)==(c|0)){D=g+36|0;E=f[c+36>>2]|0}else{h=g+36|0;e=f[h>>2]|0;if(e|0){r=e+12|0;f[r>>2]=(f[r>>2]|0)+1}r=c+36|0;e=f[r>>2]|0;if(e|0?(q=e+12|0,e=f[q>>2]|0,f[q>>2]=e+-1,(e|0)==1):0)_S(c);f[r>>2]=0;e=c+16|0;q=c+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){k=f[c+40>>2]|0;s=0;do{f[k+(s<<2)>>2]=0;s=s+1|0;F=f[q>>2]|0}while((s|0)<(F|0));f[c>>2]=f[g>>2];if((F|0)<3)C=38;else C=40}else{f[c>>2]=f[g>>2];C=38}if((C|0)==38){F=f[a>>2]|0;if((F|0)<3){f[q>>2]=F;f[c+8>>2]=f[i>>2];f[c+12>>2]=f[g+12>>2];i=f[m>>2]|0;F=f[c+44>>2]|0;f[F>>2]=f[i>>2];f[F+4>>2]=f[i+4>>2]}else C=40}if((C|0)==40)ZS(c,g);f[e>>2]=f[g+16>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];c=f[h>>2]|0;f[r>>2]=c;D=h;E=c}if(E|0?(c=E+12|0,E=f[c>>2]|0,f[c>>2]=E+-1,(E|0)==1):0)_S(g);f[D>>2]=0;D=g+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[a>>2]|0)>0){D=f[o>>2]|0;o=0;do{f[D+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[m>>2]|0;if((a|0)!=(l|0))g0(a);u=d;return}function Tub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0,L=0.0;c=u;u=u+112|0;d=c+56|0;e=c;if(+n[a>>2]!=1.0?+n[a+8>>2]!=0.0:0){g=0;u=c;return g|0}f[d>>2]=1124007936;h=d+4|0;i=d+8|0;j=d+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;m=d+48|0;o=d+44|0;f[o>>2]=m;f[m>>2]=0;f[d+52>>2]=0;f[e>>2]=1124007936;p=e+4|0;q=e+8|0;r=e+40|0;k=p;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[r>>2]=q;k=e+48|0;l=e+44|0;f[l>>2]=k;f[k>>2]=0;f[e+52>>2]=0;s=f[b+4>>2]|0;Ti[f[(f[s>>2]|0)+84>>2]&511](s,d,e);s=d+16|0;b=f[s>>2]|0;t=(b|0)==0;if(!t){v=f[h>>2]|0;if((v|0)<3)w=Y(f[d+12>>2]|0,f[i>>2]|0)|0;else{x=f[j>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if(!((v|0)==0|(w|0)==0)){B=v;C=16}else C=9}else C=9;if((C|0)==9)if(f[e+16>>2]|0){v=f[p>>2]|0;if((v|0)<3)D=Y(f[e+12>>2]|0,f[q>>2]|0)|0;else{w=f[r>>2]|0;z=0;y=1;while(1){x=Y(f[w+(z<<2)>>2]|0,y)|0;z=z+1|0;if((z|0)==(v|0)){D=x;break}else y=x}}if(!((v|0)==0|(D|0)==0)){B=f[h>>2]|0;C=16}else E=0}else E=0;if((C|0)==16){C=(B|0)<3;if(C)F=Y(f[d+12>>2]|0,f[i>>2]|0)|0;else{D=f[j>>2]|0;v=0;y=1;while(1){z=Y(f[D+(v<<2)>>2]|0,y)|0;v=v+1|0;if((v|0)==(B|0)){F=z;break}else y=z}}if(F>>>0<=1){F=f[p>>2]|0;y=(F|0)<3;if(y)G=Y(f[e+12>>2]|0,f[q>>2]|0)|0;else{v=f[r>>2]|0;D=0;z=1;while(1){w=Y(f[v+(D<<2)>>2]|0,z)|0;D=D+1|0;if((D|0)==(F|0)){G=w;break}else z=w}}if(G>>>0<=1){if(!t){if(C)H=Y(f[d+12>>2]|0,f[i>>2]|0)|0;else{i=f[j>>2]|0;C=0;t=1;while(1){G=Y(f[i+(C<<2)>>2]|0,t)|0;C=C+1|0;if((C|0)==(B|0)){H=G;break}else t=G}}if(!((B|0)==0|(H|0)==0))I=+n[b>>2];else I=1.0}else I=1.0;b=f[e+16>>2]|0;if(b){if(y)J=Y(f[e+12>>2]|0,f[q>>2]|0)|0;else{q=f[r>>2]|0;y=0;H=1;while(1){B=Y(f[q+(y<<2)>>2]|0,H)|0;y=y+1|0;if((y|0)==(F|0)){J=B;break}else H=B}}if(!((F|0)==0|(J|0)==0))K=+n[b>>2];else K=0.0}else K=0.0;b=a+4|0;L=I*+N(+(+n[b>>2]),+(+n[a>>2]));n[b>>2]=L;b=a+8|0;n[b>>2]=K+I*+n[b>>2];E=1}else E=0}else E=0}b=e+36|0;a=f[b>>2]|0;if(a|0?(J=a+12|0,a=f[J>>2]|0,f[J>>2]=a+-1,(a|0)==1):0)_S(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[p>>2]|0)>0){b=f[r>>2]|0;r=0;do{f[b+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[l>>2]|0;if((p|0)!=(k|0))g0(p);p=d+36|0;k=f[p>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(d);f[p>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[h>>2]|0)>0){s=f[j>>2]|0;j=0;do{f[s+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[o>>2]|0;if((h|0)!=(m|0))g0(h);g=E;u=c;return g|0}function Uub(a){a=a|0;YDc(a);return}function Vub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;i=f[d+16>>2]|0;e=f[f[d+44>>2]>>2]|0;d=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;o=d+4|0;m=d+8|0;if((j|0)>0&(a|0)>0)q=0;else return;do{g=h+(Y(b,q)|0)+(c<<2)|0;p=i+(Y(e,q)|0)+(c<<2)|0;r=+n[o>>2];s=+n[m>>2];t=+n[d>>2];if(t==1.0){u=p;v=0;w=g;while(1){x=0;do{n[u+(x<<2)>>2]=s+r*+n[w+(x<<2)>>2];x=x+1|0}while((x|0)!=(a|0));v=v+1|0;if((v|0)==(j|0))break;else{u=u+(k<<2)|0;w=w+(k<<2)|0}}}else{w=0;u=p;v=g;while(1){x=0;do{y=+N(+(s+r*+n[v+(x<<2)>>2]),+t);n[u+(x<<2)>>2]=y;x=x+1|0}while((x|0)!=(a|0));w=w+1|0;if((w|0)==(j|0))break;else{u=u+(k<<2)|0;v=v+(k<<2)|0}}}q=q+1|0}while((q|0)!=(l|0));return}function Wub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+64|0;e=d+8|0;g=d;h=c+12|0;i=f[h>>2]|0;j=i;if(((f[c+16>>2]|0)-i|0)!=56){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,24)|0;l=440533;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,464481,438529,1162)}i=j+4|0;n=f[i>>2]|0;if((n|0)<3)o=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{p=f[j+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((o|0)==1){LFa(e,c);MFa(e+12|0,h);o=f[c+24>>2]|0;f[e+24>>2]=o;f[e+28>>2]=f[c+28>>2];if(o|0){r=o+-4|0;f[r>>2]=(f[r>>2]|0)+1}r=f[c+32>>2]|0;f[e+32>>2]=r;f[e+36>>2]=f[c+36>>2];if(r|0){o=r+-4|0;f[o>>2]=(f[o>>2]|0)+1}f[g>>2]=0;f[g+4>>2]=0;k=tT(g,14)|0;l=454995;m=k+14|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));eIa(e,g,f[(f[h>>2]|0)+16>>2]|0)|0;uT(g);Asb(g,e);h=f[g>>2]|0;f[a>>2]=h;f[a+4>>2]=f[g+4>>2];l=h;if(!h){t=g;v=l}else{h=l+4|0;f[h>>2]=(f[h>>2]|0)+1;t=g;v=f[g>>2]|0}if(v|0?(g=v+4|0,h=f[g>>2]|0,f[g>>2]=h+-1,(h|0)==1):0)Yi[f[(f[v>>2]|0)+8>>2]&2047](v);f[t>>2]=0;HFa(e);u=d;return}t=VDc(96)|0;f[e>>2]=f[j>>2];v=e+4|0;f[v>>2]=f[i>>2];h=e+8|0;f[h>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];g=e+16|0;f[g>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];l=e+36|0;k=f[j+36>>2]|0;f[l>>2]=k;m=e+40|0;f[m>>2]=h;h=e+48|0;o=e+44|0;f[o>>2]=h;f[h>>2]=0;f[e+52>>2]=0;if(k|0){r=k+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[i>>2]|0)<3){i=f[j+44>>2]|0;r=f[o>>2]|0;f[r>>2]=f[i>>2];f[r+4>>2]=f[i+4>>2]}else{f[v>>2]=0;ZS(e,j)}Xub(t,e);j=VDc(16)|0;i=j+4|0;f[i>>2]=1;f[j>>2]=102296;f[j+8>>2]=t;r=j;k=t;n=f[l>>2]|0;if(n|0?(q=n+12|0,n=f[q>>2]|0,f[q>>2]=n+-1,(n|0)==1):0)_S(e);f[l>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[v>>2]|0)>0){g=f[m>>2]|0;m=0;do{f[g+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[v>>2]|0))}v=f[o>>2]|0;if((v|0)!=(h|0))g0(v);KHa(t,c);f[a>>2]=r;f[a+4>>2]=k;f[i>>2]=(f[i>>2]|0)+1;k=f[i>>2]|0;f[i>>2]=k+-1;if((k|0)!=1){u=d;return}Yi[f[(f[j>>2]|0)+8>>2]&2047](j);u=d;return}function Xub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;JHa(a);f[a>>2]=102316;d=a+36|0;f[d>>2]=1124007936;e=a+40|0;g=a+44|0;h=a+48|0;i=a+52|0;j=a+56|0;k=a+60|0;l=a+64|0;m=a+68|0;n=a+72|0;o=a+76|0;p=e;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=g;p=a+84|0;q=a+80|0;f[q>>2]=p;f[p>>2]=0;f[a+88>>2]=0;b[a+92>>0]=0;if((d|0)==(c|0))return;a=c+36|0;p=f[a>>2]|0;if((p|0?(r=p+12|0,f[r>>2]=(f[r>>2]|0)+1,r=f[n>>2]|0,r|0):0)?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)_S(d);f[n>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[e>>2]|0)>0){r=f[o>>2]|0;o=0;do{f[r+(o<<2)>>2]=0;o=o+1|0;s=f[e>>2]|0}while((o|0)<(s|0));f[d>>2]=f[c>>2];if((s|0)<3)t=11;else t=13}else{f[d>>2]=f[c>>2];t=11}if((t|0)==11){s=f[c+4>>2]|0;if((s|0)<3){f[e>>2]=s;f[g>>2]=f[c+8>>2];f[h>>2]=f[c+12>>2];h=f[c+44>>2]|0;g=f[q>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else t=13}if((t|0)==13)ZS(d,c);f[i>>2]=f[c+16>>2];f[j>>2]=f[c+20>>2];f[k>>2]=f[c+24>>2];f[l>>2]=f[c+28>>2];f[m>>2]=f[c+32>>2];f[n>>2]=f[a>>2];return}function Yub(a){a=a|0;YDc(a);return}function Zub(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _ub(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=102316;b=a+36|0;c=a+72|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+52|0;b=a+40|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+76>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+80>>2]|0;if((b|0)==(a+84|0)){REa(a);return}g0(b);REa(a);return}function $ub(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=102316;b=a+36|0;c=a+72|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+52|0;b=a+40|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+76>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+80>>2]|0;if((b|0)==(a+84|0)){REa(a);YDc(a);return}g0(b);REa(a);YDc(a);return}function avb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+36|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=z8()|0;f[j>>2]=102428;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;y8(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;r=tT(j,116)|0;q=438412;p=r+116|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,j,453206,438529,204)}while(0);mx(i);mx(h);u=g;return}function bvb(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function cvb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function dvb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function evb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function fvb(a,b){a=a|0;b=b|0;return 0}function gvb(a,b,c){a=a|0;b=b|0;c=c|0;return}function hvb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function ivb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=UIc(r|0,0,e|0,k|0)|0;g=g+1|0;o=$Ic(0,l|0,32)|0;l=J;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;c=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(c|0));z5(-215,a,452815,452821,161)}return 0}function jvb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;kvb(a+36|0,b,c,d,e,f,g);return}function kvb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0;j=u;u=u+16|0;k=j;if((f[a>>2]&20479|0)!=16389){f[k>>2]=0;f[k+4>>2]=0;l=tT(k,46)|0;m=440667;o=l+46|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,k,440714,438529,986)}p=f[a+16>>2]|0;if(!((h|0)>-1&(h|0)<(i|0))){f[k>>2]=0;q=k+4|0;f[q>>2]=0;r=tT(k,50)|0;l=r;m=440720;o=l+50|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,k,440714,438529,989)}s=f[a+4>>2]|0;if((s|0)<3)t=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{v=f[a+40>>2]|0;a=0;w=1;while(1){x=Y(f[v+(a<<2)>>2]|0,w)|0;a=a+1|0;if((a|0)==(s|0)){t=x;break}else w=x}}if((t|0)<(i|0)){f[k>>2]=0;q=k+4|0;f[q>>2]=0;r=tT(k,50)|0;l=r;m=440720;o=l+50|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,k,440714,438529,989)}if((e|0)>0){y=d;z=h;A=c}else{u=j;return}while(1){B=+n[p+(z<<2)>>2];c=0;do{C=+n[A+(c<<2)>>2];n[y+(c<<2)>>2]=!(C>=0.0)?B*C:C;c=c+1|0}while((c|0)!=(e|0));z=z+1|0;if((z|0)==(i|0))break;else{y=y+(g<<2)|0;A=A+(g<<2)|0}}u=j;return}function lvb(a){a=a|0;YDc(a);return}function mvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+16>>2]|0;d=a+8|0;e=f[d>>2]|0;g=f[e+4>>2]|0;h=f[e+40>>2]|0;i=f[h>>2]|0;if((g|0)>1){j=f[h+4>>2]|0;if((g|0)==2){k=j;l=1;m=i}else{n=2;o=1;while(1){p=Y(f[h+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)>=(g|0)){k=j;l=p;m=i;break}else o=p}}}else{k=i;l=1;m=1}i=((c+-1+l|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,i)|0;o=Y(f[b+4>>2]|0,i)|0;if((m|0)<=0)return;i=a+12|0;b=a+4|0;a=(l>>>0<o>>>0?l:o)-c|0;o=0;j=e;while(1){e=(f[j+16>>2]|0)+(Y(f[f[j+44>>2]>>2]|0,o)|0)+(c<<2)|0;g=f[i>>2]|0;n=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,o)|0)+(c<<2)|0;kvb(f[b>>2]|0,e,n,a,l,0,k);n=o+1|0;if((n|0)==(m|0))break;o=n;j=f[d>>2]|0}return}function nvb(a,b){a=a|0;b=b|0;var c=0;c=VDc(44)|0;ovb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=102448;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function ovb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=102468;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,4)|0;b[g>>0]=97;b[g+1>>0]=120;b[g+2>>0]=105;b[g+3>>0]=115;g=c+4|0;c=f[g>>2]|0;do if(c){h=f[e>>2]|0;i=(h|0)==0?1154740:h;j=g;k=c;a:while(1){l=k;while(1){m=f[l+16>>2]|0;if((m|0)==(h|0))break;if((Ioc((m|0)==0?1154740:m,i)|0)>=0)break;m=f[l+4>>2]|0;if(!m){n=j;break a}else l=m}k=f[l>>2]|0;if(!k){n=l;break}else j=l}if((n|0)!=(g|0)){j=f[n+16>>2]|0;if((h|0)!=(j|0)?(Ioc(i,(j|0)==0?1154740:j)|0)<=-1:0){o=1;break}j=DHa(n+24|0,-1)|0;o=j}else o=1}else o=1;while(0);f[a+36>>2]=o;uT(e);f[e>>2]=0;f[e+4>>2]=0;o=tT(e,7)|0;b[o>>0]=b[440970]|0;b[o+1>>0]=b[440971]|0;b[o+2>>0]=b[440972]|0;b[o+3>>0]=b[440973]|0;b[o+4>>0]=b[440974]|0;b[o+5>>0]=b[440975]|0;b[o+6>>0]=b[440976]|0;o=f[g>>2]|0;if(!o){p=0;q=a+40|0;b[q>>0]=p;uT(e);u=d;return}n=f[e>>2]|0;c=(n|0)==0?1154740:n;j=g;k=o;b:while(1){o=k;while(1){m=f[o+16>>2]|0;if((m|0)==(n|0))break;if((Ioc((m|0)==0?1154740:m,c)|0)>=0)break;m=f[o+4>>2]|0;if(!m){r=j;break b}else o=m}k=f[o>>2]|0;if(!k){r=o;break}else j=o}if((r|0)==(g|0)){p=0;q=a+40|0;b[q>>0]=p;uT(e);u=d;return}g=f[r+16>>2]|0;if((n|0)!=(g|0)?(Ioc(c,(g|0)==0?1154740:g)|0)<=-1:0){p=0;q=a+40|0;b[q>>0]=p;uT(e);u=d;return}g=DHa(r+24|0,-1)|0;p=((g|0)!=0|(J|0)!=0)&1;q=a+40|0;b[q>>0]=p;uT(e);u=d;return}function pvb(a){a=a|0;YDc(a);return}function qvb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rvb(a){a=a|0;REa(a);YDc(a);return}function svb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+112|0;g=e+100|0;h=e+88|0;i=e+72|0;j=e;k=e+16|0;f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=f[a+36>>2]|0;c=((d|0)<0?f[(f[g>>2]|0)+4>>2]|0:0)+d|0;d=f[h>>2]|0;m=a+40|0;if(b[m>>0]|0){p[j>>3]=0.0;f[i>>2]=-1056833530;f[i+4>>2]=j;f[i+8>>2]=1;f[i+12>>2]=1;l_(d,i,e0()|0)|0}if(((c|0)==1?(f[d+4>>2]|0)==4:0)?(b[m>>0]|0)==0:0){xvb(g,d,z8()|0);mx(h);mx(g);u=e;return}m=f[(f[h>>2]|0)+4>>2]|0;f[i>>2]=0;a=i+4|0;f[a>>2]=0;f[i+8>>2]=0;if(m>>>0>536870911)mCc(i);n=VDc(m<<3)|0;f[a>>2]=n;f[i>>2]=n;f[i+8>>2]=n+(m<<3);o=m;q=n;r=n;while(1){s=q;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;s=r+8|0;t=o+-1|0;if(!t)break;else{o=t;q=s;r=s}}f[a>>2]=n+(m<<3);f[n+(c<<3)>>2]=0;m=f[g>>2]|0;if((f[l>>2]|0)==(m|0))v=n;else{r=d+4|0;q=j+8|0;o=j+4|0;s=k+36|0;t=k+16|0;w=k+4|0;x=k+40|0;y=k+44|0;z=k+48|0;A=d+40|0;B=0;C=m;m=f[n+(c<<3)>>2]|0;D=n;while(1){n=C;f[D+(c<<3)+4>>2]=(f[(f[n+(B*56|0)+40>>2]|0)+(c<<2)>>2]|0)+m;E=f[r>>2]|0;if((E|0)>0){F=n+(B*56|0)+40|0;G=f[i>>2]|0;H=0;do{if((H|0)!=(c|0)){I=(f[F>>2]|0)+(H<<2)|0;J=((f[(f[A>>2]|0)+(H<<2)>>2]|0)-(f[I>>2]|0)|0)/2|0;f[G+(H<<3)>>2]=J;f[G+(H<<3)+4>>2]=(f[I>>2]|0)+J}H=H+1|0}while((H|0)<(E|0))}aT(k,d,f[i>>2]|0);E=q;f[E>>2]=0;f[E+4>>2]=0;f[j>>2]=-1040121856;f[o>>2]=k;h_(n+(B*56|0)|0,j);E=f[s>>2]|0;if(E|0?(H=E+12|0,E=f[H>>2]|0,f[H>>2]=E+-1,(E|0)==1):0)_S(k);f[s>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){E=f[x>>2]|0;H=0;do{f[E+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[w>>2]|0))}H=f[y>>2]|0;if((H|0)!=(z|0))g0(H);H=f[i>>2]|0;m=f[H+(c<<3)+4>>2]|0;f[H+(c<<3)>>2]=m;B=B+1|0;C=f[g>>2]|0;if(B>>>0>=(((f[l>>2]|0)-C|0)/56|0)>>>0){v=H;break}else D=H}}if(v|0){D=f[a>>2]|0;if((D|0)!=(v|0))f[a>>2]=D+(~((D+-8-v|0)>>>3)<<3);YDc(v)}mx(h);mx(g);u=e;return}function tvb(a,c){a=a|0;c=c|0;var d=0,e=0;switch(c|0){case 3:{d=1;break}case 1:{if((sMa()|0?(f[a+36>>2]|0)==1:0)?(b[a+40>>0]|0)==0:0)d=1;else e=7;break}case 2:{if(vmb()|0)d=(b[a+40>>0]|0)==0;else d=0;break}default:e=7}if((e|0)==7)d=0;return d|0}function uvb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function vvb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function wvb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+32|0;d=g+8|0;h=g;i=c+4|0;j=f[c>>2]|0;k=j;if((f[i>>2]|0)==(j|0)){f[d>>2]=0;f[d+4>>2]=0;l=tT(d,17)|0;m=449134;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452925,440978,72)}j=e+4|0;o=f[j>>2]|0;p=f[e>>2]|0;q=o-p|0;r=(q|0)/12|0;s=p;p=o;if(q){if(r>>>0>1?(q=s+12|0,(p|0)!=(q|0)):0){s=p;while(1){p=s+-12|0;f[j>>2]=p;o=f[p>>2]|0;if(!o)t=p;else{p=s+-8|0;v=f[p>>2]|0;if((v|0)!=(o|0))f[p>>2]=v+(~((v+-4-o|0)>>>2)<<2);YDc(o);t=f[j>>2]|0}if((t|0)==(q|0))break;else s=t}}}else npb(e,1-r|0,k);k=f[a+36>>2]|0;r=f[c>>2]|0;t=((k|0)<0?(f[r+4>>2]|0)-(f[r>>2]|0)>>2:0)+k|0;if((f[i>>2]|0)==(r|0)){w=0;x=e;y=f[x>>2]|0;z=f[y>>2]|0;A=z+(t<<2)|0;f[A>>2]=w;u=g;return 0}k=a+40|0;a=d+4|0;s=0;q=0;j=r;a:while(1){jFa(d,j+(s*12|0)|0);if(!(b[k>>0]|0)){r=f[d>>2]|0;o=(f[a>>2]|0)-r|0;v=f[e>>2]|0;p=f[v+4>>2]|0;B=f[v>>2]|0;v=r;r=B;if((o|0)!=(p-B|0)){C=24;break}if((p|0)==(B|0)){D=v;C=29}else{B=o>>2;o=0;while(1){if((o|0)!=(t|0)?(f[r+(o<<2)>>2]|0)!=(f[v+(o<<2)>>2]|0):0){C=27;break a}o=o+1|0;if(o>>>0>=B>>>0){D=v;C=29;break}}}}else{v=f[e>>2]|0;B=f[v+4>>2]|0;o=f[v>>2]|0;v=o;r=f[d>>2]|0;if((B|0)==(o|0)){D=r;C=29}else{p=B-o>>2;o=0;do{B=v+(o<<2)|0;E=f[B>>2]|0;F=f[r+(o<<2)>>2]|0;f[B>>2]=(E|0)<(F|0)?F:E;o=o+1|0}while(o>>>0<p>>>0);G=r;H=(f[r+(t<<2)>>2]|0)+q|0;C=30}}if((C|0)==29){C=0;p=(f[D+(t<<2)>>2]|0)+q|0;if(!D)I=p;else{G=D;H=p;C=30}}if((C|0)==30){C=0;p=f[a>>2]|0;if((p|0)!=(G|0))f[a>>2]=p+(~((p+-4-G|0)>>>2)<<2);YDc(G);I=H}s=s+1|0;j=f[c>>2]|0;if(s>>>0>=(((f[i>>2]|0)-j|0)/12|0)>>>0){w=I;x=e;C=15;break}else q=I}if((C|0)==15){y=f[x>>2]|0;z=f[y>>2]|0;A=z+(t<<2)|0;f[A>>2]=w;u=g;return 0}else if((C|0)==24){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,36)|0;m=441055;n=l+36|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,h,452925,440978,90)}else if((C|0)==27){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,34)|0;m=441092;n=l+34|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-201,h,452925,440978,94)}return 0}function xvb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+48|0;g=e+8|0;h=e;f[g>>2]=102576;i=g+4|0;j=i+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[i>>2]=a;f[g+8>>2]=c;f[g+12>>2]=d;i=f[a>>2]|0;j=(f[a+4>>2]|0)-i|0;k=(j|0)/56|0;l=f[c+40>>2]|0;m=f[l>>2]|0;n=(j|0)==0;j=i;a:do if(n)o=0;else{i=l+8|0;p=l+12|0;q=0;r=0;b:while(1){s=f[j+(q*56|0)>>2]|0;if(!(s&16384))break;switch(s&4095){case 3:case 5:break;default:break b}if((f[j+(q*56|0)+4>>2]|0)!=4)break;s=f[j+(q*56|0)+40>>2]|0;if((f[s>>2]|0)!=(m|0))break;if((f[s+8>>2]|0)!=(f[i>>2]|0))break;if((f[s+12>>2]|0)!=(f[p>>2]|0))break;t=(f[s+4>>2]|0)+r|0;q=q+1|0;if(q>>>0>=k>>>0){o=t;break a}else r=t}f[h>>2]=0;f[h+4>>2]=0;dJc(tT(h,184)|0,441127,184)|0;z5(-215,h,453307,440978,134)}while(0);if((o|0)!=(f[l+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;v=tT(h,27)|0;w=441312;x=v+27|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,453307,440978,137)}l=f[c>>2]|0;if(!(l&16384)){f[h>>2]=0;y=h+4|0;f[y>>2]=0;z=tT(h,77)|0;v=z;w=441340;x=v+77|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,453307,440978,138)}switch(l&4095){case 3:case 5:break;default:{f[h>>2]=0;y=h+4|0;f[y>>2]=0;z=tT(h,77)|0;v=z;w=441340;x=v+77|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,453307,440978,138)}}w=g+16|0;v=Y(o,m)|0;x=g+20|0;if(v|0)yvb(w,v);if(!n?(m|0)>0:0){n=0;v=0;while(1){z=f[a>>2]|0;y=z+(v*56|0)+40|0;l=z+(v*56|0)+16|0;c=z+(v*56|0)+44|0;z=0;j=f[(f[y>>2]|0)+4>>2]|0;while(1){if((j|0)>0){r=(Y(z,o)|0)+n|0;q=0;do{p=f[c>>2]|0;i=(f[l>>2]|0)+(Y(f[p>>2]|0,z)|0)|0;t=i+(Y(f[p+4>>2]|0,q)|0)|0;f[(f[w>>2]|0)+(r+q<<2)>>2]=t;q=q+1|0;t=f[(f[y>>2]|0)+4>>2]|0}while((q|0)<(t|0));A=t}else A=j;z=z+1|0;if((z|0)==(m|0))break;else j=A}v=v+1|0;if(v>>>0>=k>>>0)break;else n=A+n|0}}f[h>>2]=0;f[h+4>>2]=d;y8(h,g,+(d|0));f[g>>2]=102576;d=f[g+16>>2]|0;if(!d){u=e;return}g=f[x>>2]|0;if((g|0)!=(d|0))f[x>>2]=g+(~((g+-4-d|0)>>>2)<<2);YDc(d);u=e;return}function yvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function zvb(a){a=a|0;var b=0,c=0;f[a>>2]=102576;b=f[a+16>>2]|0;if(!b)return;c=a+20|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function Avb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=102576;b=f[a+16>>2]|0;if(!b){YDc(a);return}c=a+20|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function Bvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;d=f[c+40>>2]|0;e=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;d=f[a+16>>2]|0;g=Y((f[a+20>>2]|0)-d>>2,e)|0;h=f[a+12>>2]|0;a=((h+-1+g|0)>>>0)/(h>>>0)|0;h=Y(f[b>>2]|0,a)|0;i=Y(f[b+4>>2]|0,a)|0;a=i>>>0<g>>>0?i:g;g=d;d=f[c+16>>2]|0;if(h>>>0<a>>>0)j=h;else return;do{h=(j>>>0)/(e>>>0)|0;c=j-(Y(h,e)|0)|0;i=e-c|0;b=i>>>0<65536?i:65536;dJc(d+(j<<2)|0,(f[g+(h<<2)>>2]|0)+(c<<2)|0,b<<2|0)|0;j=b+j|0}while(j>>>0<a>>>0);return}function Cvb(a,b){a=a|0;b=b|0;var c=0;c=VDc(72)|0;Dvb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=102596;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Dvb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=u;u=u+16|0;e=d+8|0;g=d;JHa(a);f[a>>2]=102616;h=a+44|0;i=a+48|0;j=a+52|0;k=a+56|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;l=tT(e,5)|0;b[l>>0]=b[467281]|0;b[l+1>>0]=b[467282]|0;b[l+2>>0]=b[467283]|0;b[l+3>>0]=b[467284]|0;b[l+4>>0]=b[467285]|0;l=c+4|0;m=f[l>>2]|0;do if(m){n=f[e>>2]|0;o=(n|0)==0?1154740:n;p=l;q=m;a:while(1){r=q;while(1){s=f[r+16>>2]|0;if((s|0)==(n|0))break;if((Ioc((s|0)==0?1154740:s,o)|0)>=0)break;s=f[r+4>>2]|0;if(!s){t=p;break a}else r=s}q=f[r>>2]|0;if(!q){t=r;break}else p=r}if((t|0)!=(l|0)){p=f[t+16>>2]|0;if((n|0)!=(p|0)?(Ioc(o,(p|0)==0?1154740:p)|0)<=-1:0){v=0.0;break}v=+tIa(t+24|0,-1)}else v=0.0}else v=0.0;while(0);f[a+36>>2]=~~v;uT(e);f[e>>2]=0;f[e+4>>2]=0;t=tT(e,6)|0;b[t>>0]=b[467287]|0;b[t+1>>0]=b[467288]|0;b[t+2>>0]=b[467289]|0;b[t+3>>0]=b[467290]|0;b[t+4>>0]=b[467291]|0;b[t+5>>0]=b[467292]|0;t=f[l>>2]|0;do if(t){m=f[e>>2]|0;p=(m|0)==0?1154740:m;q=l;s=t;b:while(1){w=s;while(1){x=f[w+16>>2]|0;if((x|0)==(m|0))break;if((Ioc((x|0)==0?1154740:x,p)|0)>=0)break;x=f[w+4>>2]|0;if(!x){y=q;break b}else w=x}s=f[w>>2]|0;if(!s){y=w;break}else q=w}if((y|0)!=(l|0)){q=f[y+16>>2]|0;if((m|0)!=(q|0)?(Ioc(p,(q|0)==0?1154740:q)|0)<=-1:0){z=0.0;break}z=+tIa(y+24|0,-1)}else z=0.0}else z=0.0;while(0);f[a+40>>2]=~~z;uT(e);f[e>>2]=0;f[e+4>>2]=0;y=tT(e,11)|0;t=454581;q=y+11|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));s=f[l>>2]|0;do if(!s){uT(e);A=59}else{o=f[e>>2]|0;n=(o|0)==0?1154740:o;r=s;while(1){x=f[r+16>>2]|0;if((o|0)==(x|0)){A=31;break}B=(x|0)==0?1154740:x;if((Ioc(n,B)|0)<0)C=r;else{if((Ioc(B,n)|0)>=0){A=32;break}C=r+4|0}r=f[C>>2]|0;if(!r){A=58;break}}if((A|0)==31)uT(e);else if((A|0)==32)uT(e);else if((A|0)==58){uT(e);A=59;break}f[e>>2]=0;f[e+4>>2]=0;y=tT(e,13)|0;t=441573;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));r=f[l>>2]|0;c:do if(r|0){n=f[e>>2]|0;o=(n|0)==0?1154740:n;p=r;while(1){m=f[p+16>>2]|0;if((n|0)==(m|0)){A=50;break}B=(m|0)==0?1154740:m;if((Ioc(o,B)|0)<0)D=p;else{if((Ioc(B,o)|0)>=0){A=51;break}D=p+4|0}p=f[D>>2]|0;if(!p)break c}if((A|0)==50){uT(e);f[e>>2]=0;E=e+4|0;f[E>>2]=0;F=tT(e,60)|0;y=F;t=441601;q=y+60|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,24)}else if((A|0)==51){uT(e);f[e>>2]=0;E=e+4|0;f[E>>2]=0;F=tT(e,60)|0;y=F;t=441601;q=y+60|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,24)}}while(0);f[g>>2]=0;f[g+4>>2]=0;y=tT(g,13)|0;t=441587;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));r=f[l>>2]|0;do if(r){p=f[g>>2]|0;o=(p|0)==0?1154740:p;n=r;while(1){w=f[n+16>>2]|0;if((p|0)==(w|0)){A=49;break}B=(w|0)==0?1154740:w;if((Ioc(o,B)|0)<0)G=n;else{if((Ioc(B,o)|0)>=0){A=52;break}G=n+4|0}n=f[G>>2]|0;if(!n){A=55;break}}if((A|0)==49){uT(g);uT(e);f[e>>2]=0;E=e+4|0;f[E>>2]=0;F=tT(e,60)|0;y=F;t=441601;q=y+60|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,24)}else if((A|0)==52){uT(g);uT(e);f[e>>2]=0;E=e+4|0;f[E>>2]=0;F=tT(e,60)|0;y=F;t=441601;q=y+60|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,24)}else if((A|0)==55){uT(g);uT(e);break}}else{uT(g);uT(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;y=tT(e,11)|0;t=454581;q=y+11|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));r=DHa(lIa(c,e)|0,-1)|0;f[i>>2]=r;f[h>>2]=r;uT(e)}while(0);d:do if((A|0)==59){f[e>>2]=0;f[e+4>>2]=0;y=tT(e,13)|0;t=441573;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));F=f[l>>2]|0;e:do if(F){E=f[e>>2]|0;G=(E|0)==0?1154740:E;D=F;while(1){C=f[D+16>>2]|0;if((E|0)==(C|0)){A=76;break}s=(C|0)==0?1154740:C;if((Ioc(G,s)|0)<0)H=D;else{if((Ioc(s,G)|0)>=0){A=77;break}H=D+4|0}D=f[H>>2]|0;if(!D){A=67;break e}}if((A|0)==76){uT(e);break}else if((A|0)==77){uT(e);break}}else A=67;while(0);do if((A|0)==67){f[g>>2]=0;f[g+4>>2]=0;y=tT(g,13)|0;t=441587;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));F=f[l>>2]|0;if(!F){uT(g);uT(e);break d}D=f[g>>2]|0;G=(D|0)==0?1154740:D;E=F;while(1){F=f[E+16>>2]|0;if((D|0)==(F|0)){A=78;break}s=(F|0)==0?1154740:F;if((Ioc(G,s)|0)<0)I=E;else{if((Ioc(s,G)|0)>=0){A=75;break}I=E+4|0}E=f[I>>2]|0;if(!E){A=104;break}}if((A|0)==75){uT(g);uT(e);break}else if((A|0)==78){uT(g);uT(e);break}else if((A|0)==104){uT(g);uT(e);break d}}while(0);f[e>>2]=0;f[e+4>>2]=0;y=tT(e,13)|0;t=441573;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));E=f[l>>2]|0;if(!E){uT(e);f[e>>2]=0;K=e+4|0;f[K>>2]=0;L=tT(e,58)|0;y=L;t=441755;q=y+58|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,29)}G=f[e>>2]|0;D=(G|0)==0?1154740:G;s=E;while(1){F=f[s+16>>2]|0;if((G|0)==(F|0))break;C=(F|0)==0?1154740:F;if((Ioc(D,C)|0)<0)M=s;else{if((Ioc(C,D)|0)>=0)break;M=s+4|0}s=f[M>>2]|0;if(!s){A=97;break}}if((A|0)==97){uT(e);f[e>>2]=0;K=e+4|0;f[K>>2]=0;L=tT(e,58)|0;y=L;t=441755;q=y+58|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,29)}f[g>>2]=0;f[g+4>>2]=0;y=tT(g,13)|0;t=441587;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));s=f[l>>2]|0;if(!s){uT(g);uT(e);f[e>>2]=0;K=e+4|0;f[K>>2]=0;L=tT(e,58)|0;y=L;t=441755;q=y+58|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,29)}D=f[g>>2]|0;G=(D|0)==0?1154740:D;E=s;while(1){C=f[E+16>>2]|0;if((D|0)==(C|0)){A=101;break}F=(C|0)==0?1154740:C;if((Ioc(G,F)|0)<0)N=E;else{if((Ioc(F,G)|0)>=0){A=95;break}N=E+4|0}E=f[N>>2]|0;if(!E){A=99;break}}if((A|0)==95){uT(g);uT(e)}else if((A|0)==99){uT(g);uT(e);f[e>>2]=0;K=e+4|0;f[K>>2]=0;L=tT(e,58)|0;y=L;t=441755;q=y+58|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,29)}else if((A|0)==101){uT(g);uT(e)}f[e>>2]=0;f[e+4>>2]=0;y=tT(e,13)|0;t=441573;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));E=DHa(lIa(c,e)|0,-1)|0;f[h>>2]=E;uT(e);f[e>>2]=0;f[e+4>>2]=0;y=tT(e,13)|0;t=441587;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));E=DHa(lIa(c,e)|0,-1)|0;f[i>>2]=E;uT(e)}while(0);f[g>>2]=0;f[g+4>>2]=0;y=tT(g,13)|0;t=454593;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));EHa(e,lIa(c,g)|0,-1);if((e|0)!=(j|0)){uT(j);c=f[e>>2]|0;if(!c)O=0;else{i=c+-4|0;f[i>>2]=(f[i>>2]|0)+1;O=f[e>>2]|0}f[j>>2]=O;f[k>>2]=f[e+4>>2]}uT(e);uT(g);g=f[j>>2]|0;if(((g|0)!=454607?(j=(g|0)==0?1154740:g,!((Ioc(j,454607)|0)==0|(g|0)==441814)):0)?Ioc(j,441814)|0:0){f[e>>2]=0;f[e+4>>2]=0;y=tT(e,57)|0;t=441823;q=y+57|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));z5(-215,e,441662,441678,34)}f[e>>2]=0;f[e+4>>2]=0;y=tT(e,13)|0;t=441881;q=y+13|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(q|0));t=f[l>>2]|0;if(!t){P=0;Q=a+68|0;b[Q>>0]=P;uT(e);u=d;return}y=f[e>>2]|0;q=(y|0)==0?1154740:y;j=l;g=t;f:while(1){t=g;while(1){k=f[t+16>>2]|0;if((k|0)==(y|0))break;if((Ioc((k|0)==0?1154740:k,q)|0)>=0)break;k=f[t+4>>2]|0;if(!k){R=j;break f}else t=k}g=f[t>>2]|0;if(!g){R=t;break}else j=t}if((R|0)==(l|0)){P=0;Q=a+68|0;b[Q>>0]=P;uT(e);u=d;return}l=f[R+16>>2]|0;if((y|0)!=(l|0)?(Ioc(q,(l|0)==0?1154740:l)|0)<=-1:0){P=0;Q=a+68|0;b[Q>>0]=P;uT(e);u=d;return}l=DHa(R+24|0,-1)|0;P=((l|0)!=0|(J|0)!=0)&1;Q=a+68|0;b[Q>>0]=P;uT(e);u=d;return}function Evb(a){a=a|0;YDc(a);return}function Fvb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Gvb(a){a=a|0;f[a>>2]=102616;uT(a+52|0);REa(a);return}function Hvb(a){a=a|0;f[a>>2]=102616;uT(a+52|0);REa(a);YDc(a);return}function Ivb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0;e=u;u=u+32|0;g=e+12|0;h=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=a+36|0;c=f[d>>2]|0;if(!c){i=a+40|0;if(!(f[i>>2]|0)){j=f[(f[h>>2]|0)+40>>2]|0;f[i>>2]=f[j+8>>2];i=f[j+12>>2]|0;f[d>>2]=i;k=i}else k=0}else k=c;c=(b[a+68>>0]|0)==0;i=f[a+40>>2]|0;d=f[(f[g>>2]|0)+40>>2]|0;j=f[d+8>>2]|0;if((i|0)>1&(c^1)){n[a+64>>2]=+(j+-1|0)/+(i+-1|0);if((k|0)>1)l=7;else l=8}else{n[a+64>>2]=+(j|0)/+(i|0);if((k|0)>1&(c^1))l=7;else l=8}if((l|0)==7){m=(f[d+12>>2]|0)+-1|0;o=k+-1|0;p=+(m|0);q=+(o|0);r=p/q;s=a+60|0;n[s>>2]=r;mx(h);mx(g);u=e;return}else if((l|0)==8){m=f[d+12>>2]|0;o=k;p=+(m|0);q=+(o|0);r=p/q;s=a+60|0;n[s>>2]=r;mx(h);mx(g);u=e;return}}function Jvb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0;g=u;u=u+240|0;h=g+216|0;i=g+204|0;j=g+192|0;k=g+136|0;l=g+80|0;m=g+64|0;o=g+8|0;p=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f$(c,h);f$(d,i);f$(e,j);e=a+40|0;d=f[e>>2]|0;c=f[h>>2]|0;q=f[c+40>>2]|0;r=f[q+8>>2]|0;if(!((d|0)==(r|0)?(f[a+36>>2]|0)==(f[q+12>>2]|0):0))s=5;do if((s|0)==5){t=f[i>>2]|0;v=a+52|0;w=f[v>>2]|0;if((w|0)!=454607?(x=(w|0)==0?1154740:w,Ioc(x,454607)|0):0){if((w|0)!=441814?Ioc(x,441814)|0:0){f[k>>2]=0;f[k+4>>2]=0;x=a+56|0;tT(k,(f[x>>2]|0)+23|0)|0;w=f[k>>2]|0;y=w;z=441895;A=y+23|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));B=f[x>>2]|0;if(!B)z5(-213,k,453206,441678,160);dJc(w+23|0,f[v>>2]|0,B|0)|0;z5(-213,k,453206,441678,160)}B=f[q+12>>2]|0;C=Y(B,r)|0;D=a+36|0;E=Y(f[D>>2]|0,d)|0;F=Y(f[q+4>>2]|0,f[q>>2]|0)|0;if(!(f[c>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;y=tT(k,18)|0;z=448822;A=y+18|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,k,453206,441678,126)}if(!(f[t>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;y=tT(k,18)|0;z=448841;A=y+18|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,k,453206,441678,126)}lT(k,c,1,Y(F,r)|0);lT(l,t,1,Y(f[e>>2]|0,F)|0);v=f[e>>2]|0;if((v|0)>0){w=a+64|0;x=f[k+16>>2]|0;G=f[f[k+44>>2]>>2]|0;H=r+-1|0;I=f[D>>2]|0;J=(I|0)>0;K=a+60|0;L=B+-1|0;M=f[l+16>>2]|0;N=f[l+44>>2]|0;O=N+4|0;P=(F|0)>0;Q=0;do{R=+(Q|0)*+n[w>>2];S=~~R;T=x+(Y(G,S)|0)|0;U=S+1|0;V=x+(Y((H|0)<(U|0)?H:U,G)|0)|0;if(J?(U=M+(Y(f[N>>2]|0,Q)|0)|0,W=f[O>>2]|0,X=R-+(S|0),P):0){S=0;do{R=+(S|0)*+n[K>>2];Z=~~R;_=Z+1|0;$=(L|0)<(_|0)?L:_;aa=R-+(Z|0);_=V;ba=T;ca=U+(Y(W,S)|0)|0;da=0;while(1){R=+n[ba+(Z<<2)>>2];ea=+n[_+(Z<<2)>>2];fa=+n[ba+($<<2)>>2];n[ca>>2]=R+X*(ea-R)+aa*(fa-R+X*(R+(+n[_+($<<2)>>2]-fa-ea)));da=da+1|0;if((da|0)==(F|0))break;else{_=_+(C<<2)|0;ba=ba+(C<<2)|0;ca=ca+(E<<2)|0}}S=S+1|0}while((S|0)<(I|0))}Q=Q+1|0}while((Q|0)<(v|0))}v=l+36|0;Q=f[v>>2]|0;if(Q|0?(I=Q+12|0,Q=f[I>>2]|0,f[I>>2]=Q+-1,(Q|0)==1):0)_S(l);f[v>>2]=0;v=l+16|0;Q=l+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[Q>>2]|0)>0){v=f[l+40>>2]|0;I=0;do{f[v+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[Q>>2]|0))}Q=f[l+44>>2]|0;if((Q|0)!=(l+48|0))g0(Q);Q=k+36|0;I=f[Q>>2]|0;if(I|0?(v=I+12|0,I=f[v>>2]|0,f[v>>2]=I+-1,(I|0)==1):0)_S(k);f[Q>>2]=0;Q=k+16|0;I=k+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[I>>2]|0)>0){Q=f[k+40>>2]|0;v=0;do{f[Q+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[I>>2]|0))}I=f[k+44>>2]|0;if((I|0)!=(k+48|0))g0(I);break}I=f[q>>2]|0;if(I|0){v=k+8|0;Q=k+12|0;E=k+4|0;C=m+8|0;F=m+4|0;L=a+36|0;K=p+4|0;P=o+36|0;O=o+16|0;N=o+4|0;M=o+40|0;J=o+44|0;G=o+48|0;H=l+36|0;x=l+16|0;w=l+4|0;B=l+40|0;D=l+44|0;S=l+48|0;W=0;U=I;I=q;while(1){if(!(f[I+4>>2]|0)){ga=I;ha=U}else{T=0;do{Nvb(l,c,W,T);f[v>>2]=0;f[Q>>2]=0;f[k>>2]=16842752;f[E>>2]=l;Nvb(o,t,W,T);V=C;f[V>>2]=0;f[V+4>>2]=0;f[m>>2]=-1040121856;f[F>>2]=o;V=f[e>>2]|0;f[p>>2]=f[L>>2];f[K>>2]=V;nfa(k,m,p,0.0,0.0,0);V=f[P>>2]|0;if(V|0?(ca=V+12|0,V=f[ca>>2]|0,f[ca>>2]=V+-1,(V|0)==1):0)_S(o);f[P>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[N>>2]|0)>0){V=f[M>>2]|0;ca=0;do{f[V+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[N>>2]|0))}ca=f[J>>2]|0;if((ca|0)!=(G|0))g0(ca);ca=f[H>>2]|0;if(ca|0?(V=ca+12|0,ca=f[V>>2]|0,f[V>>2]=ca+-1,(ca|0)==1):0)_S(l);f[H>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[w>>2]|0)>0){ca=f[B>>2]|0;V=0;do{f[ca+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[w>>2]|0))}V=f[D>>2]|0;if((V|0)!=(S|0))g0(V);T=T+1|0;ia=f[(f[h>>2]|0)+40>>2]|0}while(T>>>0<(f[ia+4>>2]|0)>>>0);ga=ia;ha=f[ia>>2]|0}W=W+1|0;if(W>>>0>=ha>>>0)break;else{U=ha;I=ga}}}}while(0);mx(j);mx(i);mx(h);u=g;return}function Kvb(a,b){a=a|0;b=b|0;return (b|0)==3|0}function Lvb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Mvb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=h;if(((f[c+4>>2]|0)-h|0)!=12){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,18)|0;k=453187;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,441678,44)}if(((f[i+4>>2]|0)-(f[h>>2]|0)|0)!=16){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,21)|0;k=448800;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,441678,44)}d=e+4|0;k=f[d>>2]|0;j=f[e>>2]|0;l=k-j|0;h=(l|0)/12|0;m=j;j=k;if(l){if(h>>>0>1?(l=m+12|0,(j|0)!=(l|0)):0){m=j;while(1){j=m+-12|0;f[d>>2]=j;k=f[j>>2]|0;if(!k)n=j;else{j=m+-8|0;o=f[j>>2]|0;if((o|0)!=(k|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);YDc(k);n=f[d>>2]|0}if((n|0)==(l|0))break;else m=n}}}else npb(e,1-h|0,i);i=f[a+40>>2]|0;h=f[f[e>>2]>>2]|0;if((i|0)>0)p=i;else p=Y(f[a+48>>2]|0,f[h+8>>2]|0)|0;f[h+8>>2]=p;i=f[a+36>>2]|0;e=h+12|0;if((i|0)>0)q=i;else q=Y(f[a+44>>2]|0,f[e>>2]|0)|0;f[e>>2]=q;e=f[f[c>>2]>>2]|0;if((p|0)!=(f[e+8>>2]|0)){r=0;u=g;return r|0}r=(q|0)==(f[e+12>>2]|0);u=g;return r|0}function Nvb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+128|0;h=g;i=f[c+4>>2]|0;if((i|0)<=2){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,10)|0;k=445168;l=j+10|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,h,445179,452821,110)}k=f[c+40>>2]|0;j=2;do{f[h+(j+-2<<2)>>2]=f[k+(j<<2)>>2];j=j+1|0}while((j|0)!=(i|0));j=f[c+44>>2]|0;k=(f[c+16>>2]|0)+(Y(f[j>>2]|0,d)|0)|0;dT(a,i+-2|0,h,f[c>>2]&4095,k+(Y(f[j+4>>2]|0,e)|0)|0,0);u=g;return}function Ovb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+8|0;g=d;LFa(e,c);MFa(e+12|0,c+12|0);h=f[c+24>>2]|0;f[e+24>>2]=h;f[e+28>>2]=f[c+28>>2];if(h|0){i=h+-4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[c+32>>2]|0;f[e+32>>2]=i;f[e+36>>2]=f[c+36>>2];if(i|0){c=i+-4|0;f[c>>2]=(f[c>>2]|0)+1}f[g>>2]=0;f[g+4>>2]=0;c=tT(g,13)|0;i=454593;h=c+13|0;do{b[c>>0]=b[i>>0]|0;c=c+1|0;i=i+1|0}while((c|0)<(h|0));oJa(e,g,441814)|0;uT(g);g=VDc(72)|0;Dvb(g,e);f[g>>2]=102724;i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=102832;f[i+8>>2]=g;f[a>>2]=i;f[a+4>>2]=g;HFa(e);u=d;return}function Pvb(a){a=a|0;YDc(a);return}function Qvb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Rvb(a){a=a|0;f[a>>2]=102616;uT(a+52|0);REa(a);YDc(a);return}function Svb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0;d=u;u=u+32|0;e=d+12|0;g=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f$(b,e);f$(c,g);c=a+36|0;b=f[c>>2]|0;h=a+40|0;i=f[h>>2]|0;if(!b)if(!i){j=f[(f[g>>2]|0)+40>>2]|0;k=f[j+8>>2]|0;f[h>>2]=k;h=f[j+12>>2]|0;f[c>>2]=h;l=k;m=h}else{l=i;m=0}else{l=i;m=b}b=f[(f[e>>2]|0)+40>>2]|0;i=f[b+12>>2]|0;if((l|0)>1)o=+((f[b+8>>2]|0)+-1|0)/+(l+-1|0);else o=0.0;n[a+64>>2]=o;if((m|0)<=1){p=0.0;q=a+60|0;n[q>>2]=p;mx(g);mx(e);u=d;return}p=+(i+-1|0)/+(m+-1|0);q=a+60|0;n[q>>2]=p;mx(g);mx(e);u=d;return}function Tvb(a,b){a=a|0;b=b|0;return (b|1|0)==3|0}function Uvb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Vvb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=h;if(((f[c+4>>2]|0)-h|0)!=12){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,18)|0;k=453187;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,441678,217)}if(((f[i+4>>2]|0)-(f[h>>2]|0)|0)!=16){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,21)|0;k=448800;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,441678,217)}d=e+4|0;k=f[d>>2]|0;j=f[e>>2]|0;l=k-j|0;h=(l|0)/12|0;m=j;j=k;if(l){if(h>>>0>1?(l=m+12|0,(j|0)!=(l|0)):0){m=j;while(1){j=m+-12|0;f[d>>2]=j;k=f[j>>2]|0;if(!k)n=j;else{j=m+-8|0;o=f[j>>2]|0;if((o|0)!=(k|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);YDc(k);n=f[d>>2]|0}if((n|0)==(l|0))break;else m=n}}}else npb(e,1-h|0,i);i=f[a+40>>2]|0;if((i|0)>0){p=f[f[e>>2]>>2]|0;q=i}else{i=f[f[e>>2]>>2]|0;p=i;q=(Y((f[i+8>>2]|0)+-1|0,f[a+48>>2]|0)|0)+1|0}f[p+8>>2]=q;i=f[a+36>>2]|0;if((i|0)>0){r=p+12|0;s=i}else{i=p+12|0;r=i;s=(Y((f[i>>2]|0)+-1|0,f[a+44>>2]|0)|0)+1|0}f[r>>2]=s;r=f[f[c>>2]>>2]|0;if((q|0)!=(f[r+8>>2]|0)){t=0;u=g;return t|0}t=(s|0)==(f[r+12>>2]|0);u=g;return t|0}function Wvb(a,b){a=a|0;b=b|0;var c=0;c=VDc(40)|0;Xvb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=102852;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Xvb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=102872;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,9)|0;h=442178;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=f[c+4>>2]|0;do if(j){k=f[e>>2]|0;l=(k|0)==0?1154740:k;m=j;while(1){n=f[m+16>>2]|0;if((k|0)==(n|0)){o=9;break}p=(n|0)==0?1154740:n;if((Ioc(l,p)|0)<0)q=m;else{if((Ioc(p,l)|0)>=0){o=10;break}q=m+4|0}m=f[q>>2]|0;if(!m){o=14;break}}if((o|0)==9)uT(e);else if((o|0)==10)uT(e);else if((o|0)==14){uT(e);break}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,9)|0;h=442178;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));m=DHa(lIa(c,e)|0,-1)|0;l=a+36|0;f[l>>2]=m;uT(e);if((f[l>>2]|0)>-1){u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;g=tT(e,17)|0;h=442188;i=g+17|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,442206,442221,61)}}else uT(e);while(0);f[a+36>>2]=-1;u=d;return}function Yvb(a){a=a|0;YDc(a);return}function Zvb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _vb(a){a=a|0;REa(a);YDc(a);return}function $vb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+48|0;a=e+28|0;g=e+16|0;h=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[g>>2]=0;i=g+4|0;f[i>>2]=0;f[g+8>>2]=0;f$(c,a);f$(d,g);d=f[g>>2]|0;if((f[i>>2]|0)==(d|0)){mx(g);mx(a);u=e;return}c=h+8|0;j=h+4|0;k=0;l=d;while(1){d=l;m=f[a>>2]|0;n=f[m+4>>2]|0;if((n|0)<3)o=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{p=f[m+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}r=f[d+(k*56|0)+4>>2]|0;if((r|0)<3)t=Y(f[d+(k*56|0)+12>>2]|0,f[d+(k*56|0)+8>>2]|0)|0;else{n=f[d+(k*56|0)+40>>2]|0;q=0;p=1;while(1){s=Y(f[n+(q<<2)>>2]|0,p)|0;q=q+1|0;if((q|0)==(r|0)){t=s;break}else p=s}}if((o|0)!=(t|0)){v=13;break}p=c;f[p>>2]=0;f[p+4>>2]=0;f[h>>2]=33619968;f[j>>2]=d+(k*56|0);h_(m,h);k=k+1|0;l=f[g>>2]|0;if(k>>>0>=(((f[i>>2]|0)-l|0)/56|0)>>>0){v=3;break}}if((v|0)==3){mx(g);mx(a);u=e;return}else if((v|0)==13){f[h>>2]=0;f[h+4>>2]=0;v=tT(h,39)|0;e=442297;a=v+39|0;do{b[v>>0]=b[e>>0]|0;v=v+1|0;e=e+1|0}while((v|0)<(a|0));z5(-215,h,453206,442221,91)}}function awb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h;if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)==12){j=f[a+36>>2]|0;k=(j|0)>-1?j:d;gFa(a,c,(k|0)>1?k:1,e,g)|0;u=h;return 0}else{f[i>>2]=0;f[i+4>>2]=0;h=tT(i,18)|0;g=453187;e=h+18|0;do{b[h>>0]=b[g>>0]|0;h=h+1|0;g=g+1|0}while((h|0)<(e|0));z5(-215,i,452925,442221,74)}return 0}function bwb(a,b){a=a|0;b=b|0;var c=0;c=VDc(164)|0;cwb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=102980;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function cwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+432|0;e=d+32|0;g=d;h=d+368|0;i=d+312|0;j=d+256|0;JHa(a);f[a>>2]=103e3;k=a+44|0;f[k>>2]=1124007936;l=a+48|0;m=a+52|0;n=a+84|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+92|0;r=a+88|0;f[r>>2]=q;f[q>>2]=0;f[a+96>>2]=0;q=a+100|0;f[q>>2]=1124007936;s=a+104|0;t=a+108|0;v=a+140|0;o=s;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[v>>2]=t;w=a+148|0;x=a+144|0;f[x>>2]=w;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;KHa(a,c);w=a+4|0;y=a+8|0;z=(f[y>>2]|0)-(f[w>>2]|0)|0;if(!((z|0)!=0&((z|0)/56|0)>>>0<3)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,38)|0;A=442497;p=o+38|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));z5(-215,e,442536,442560,73)}f[e>>2]=0;f[e+4>>2]=0;o=tT(e,10)|0;A=455057;p=o+10|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));z=DHa(lIa(c,e)|0,-1)|0;uT(e);B=f[w>>2]|0;C=f[B+4>>2]|0;if((C|0)<3)D=Y(f[B+12>>2]|0,f[B+8>>2]|0)|0;else{E=f[B+40>>2]|0;B=0;F=1;while(1){G=Y(f[E+(B<<2)>>2]|0,F)|0;B=B+1|0;if((B|0)==(C|0)){D=G;break}else F=G}}f[e>>2]=0;f[e+4>>2]=0;o=tT(e,9)|0;A=454939;p=o+9|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));F=c+4|0;c=f[F>>2]|0;do if(c){C=f[e>>2]|0;B=(C|0)==0?1154740:C;E=F;G=c;a:while(1){H=G;while(1){I=f[H+16>>2]|0;if((I|0)==(C|0))break;if((Ioc((I|0)==0?1154740:I,B)|0)>=0)break;I=f[H+4>>2]|0;if(!I){K=E;break a}else H=I}G=f[H>>2]|0;if(!G){K=H;break}else E=H}if((K|0)!=(F|0)){E=f[K+16>>2]|0;if((C|0)!=(E|0)?(Ioc(B,(E|0)==0?1154740:E)|0)<=-1:0){L=1;break}E=DHa(K+24|0,-1)|0;L=(E|0)!=0|(J|0)!=0}else L=1}else L=1;while(0);K=a+40|0;b[K>>0]=L&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;L=tT(e,4)|0;b[L>>0]=97;b[L+1>>0]=120;b[L+2>>0]=105;b[L+3>>0]=115;L=f[F>>2]|0;do if(L){c=f[e>>2]|0;E=(c|0)==0?1154740:c;G=F;I=L;b:while(1){M=I;while(1){N=f[M+16>>2]|0;if((N|0)==(c|0))break;if((Ioc((N|0)==0?1154740:N,E)|0)>=0)break;N=f[M+4>>2]|0;if(!N){O=G;break b}else M=N}I=f[M>>2]|0;if(!I){O=M;break}else G=M}if((O|0)!=(F|0)){G=f[O+16>>2]|0;if((c|0)!=(G|0)?(Ioc(E,(G|0)==0?1154740:G)|0)<=-1:0){P=1;break}G=DHa(O+24|0,-1)|0;P=G}else P=1}else P=1;while(0);f[a+36>>2]=P;uT(e);P=f[w>>2]|0;O=f[P+4>>2]|0;F=P;if((O|0)<=1){f[e>>2]=0;Q=e+4|0;f[Q>>2]=0;R=tT(e,73)|0;o=R;A=442646;p=o+73|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));z5(-215,e,442536,442560,80)}if((O|0)==2)S=Y(f[P+12>>2]|0,f[P+8>>2]|0)|0;else{L=f[P+40>>2]|0;G=0;I=1;while(1){B=Y(f[L+(G<<2)>>2]|0,I)|0;G=G+1|0;if((G|0)==(O|0)){S=B;break}else I=B}}if((D-((D|0)%(z|0)|0)|0)!=(S|0)){f[e>>2]=0;Q=e+4|0;f[Q>>2]=0;R=tT(e,73)|0;o=R;A=442646;p=o+73|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));z5(-215,e,442536,442560,80)}if(b[K>>0]|0){if(((f[y>>2]|0)-F|0)!=112){f[e>>2]=0;T=e+4|0;f[T>>2]=0;U=tT(e,69)|0;o=U;A=442720;p=o+69|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));z5(-215,e,442536,442560,81)}F=f[P+60>>2]|0;if((F|0)<3)V=Y(f[P+68>>2]|0,f[P+64>>2]|0)|0;else{y=f[P+96>>2]|0;R=0;Q=1;while(1){S=Y(f[y+(R<<2)>>2]|0,Q)|0;R=R+1|0;if((R|0)==(F|0)){V=S;break}else Q=S}}if((z|0)!=(V|0)){f[e>>2]=0;T=e+4|0;f[T>>2]=0;U=tT(e,69)|0;o=U;A=442720;p=o+69|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));z5(-215,e,442536,442560,81)}}lT(e,P,1,z);P=f[w>>2]|0;if((P|0)!=(e|0)){A=e+36|0;U=f[A>>2]|0;if(U|0){T=U+12|0;f[T>>2]=(f[T>>2]|0)+1}T=P+36|0;U=f[T>>2]|0;if(U|0?(V=U+12|0,U=f[V>>2]|0,f[V>>2]=U+-1,(U|0)==1):0)_S(P);f[T>>2]=0;U=P+16|0;V=P+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[V>>2]|0)>0){Q=f[P+40>>2]|0;F=0;do{f[Q+(F<<2)>>2]=0;F=F+1|0;W=f[V>>2]|0}while((F|0)<(W|0));f[P>>2]=f[e>>2];if((W|0)<3)X=55;else X=57}else{f[P>>2]=f[e>>2];X=55}if((X|0)==55){W=f[e+4>>2]|0;if((W|0)<3){f[V>>2]=W;f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];W=f[e+44>>2]|0;V=f[P+44>>2]|0;f[V>>2]=f[W>>2];f[V+4>>2]=f[W+4>>2]}else X=57}if((X|0)==57)ZS(P,e);f[U>>2]=f[e+16>>2];f[P+20>>2]=f[e+20>>2];f[P+24>>2]=f[e+24>>2];f[P+28>>2]=f[e+28>>2];f[P+32>>2]=f[e+32>>2];f[T>>2]=f[A>>2]}if((k|0)!=(P|0)){A=P+36|0;T=f[A>>2]|0;if(T|0){U=T+12|0;f[U>>2]=(f[U>>2]|0)+1}U=a+80|0;T=f[U>>2]|0;if(T|0?(W=T+12|0,T=f[W>>2]|0,f[W>>2]=T+-1,(T|0)==1):0)_S(k);f[U>>2]=0;T=a+60|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[l>>2]|0)>0){W=f[n>>2]|0;V=0;do{f[W+(V<<2)>>2]=0;V=V+1|0;Z=f[l>>2]|0}while((V|0)<(Z|0));f[k>>2]=f[P>>2];if((Z|0)<3)X=70;else X=72}else{f[k>>2]=f[P>>2];X=70}if((X|0)==70){Z=f[P+4>>2]|0;if((Z|0)<3){f[l>>2]=Z;f[m>>2]=f[P+8>>2];f[a+56>>2]=f[P+12>>2];Z=f[P+44>>2]|0;V=f[r>>2]|0;f[V>>2]=f[Z>>2];f[V+4>>2]=f[Z+4>>2]}else X=72}if((X|0)==72)ZS(k,P);f[T>>2]=f[P+16>>2];f[a+64>>2]=f[P+20>>2];f[a+68>>2]=f[P+24>>2];f[a+72>>2]=f[P+28>>2];f[a+76>>2]=f[P+32>>2];f[U>>2]=f[A>>2]}A=e+36|0;U=f[A>>2]|0;if(U|0?(P=U+12|0,U=f[P>>2]|0,f[P>>2]=U+-1,(U|0)==1):0)_S(e);f[A>>2]=0;A=e+16|0;U=e+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[U>>2]|0)>0){A=f[e+40>>2]|0;P=0;do{f[A+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[U>>2]|0))}U=f[e+44>>2]|0;if((U|0)!=(e+48|0))g0(U);U=a+56|0;P=f[U>>2]|0;if(P&7|0){A=P+7&-8;T=f[m>>2]|0;Z=f[k>>2]&4095;f[h>>2]=1124007936;V=h+4|0;W=h+8|0;F=h+40|0;o=V;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[F>>2]=W;W=h+48|0;o=h+44|0;f[o>>2]=W;f[W>>2]=0;f[h+52>>2]=0;f[e>>2]=T;f[e+4>>2]=A;XS(h,2,e,Z);f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=P;f[g+4>>2]=A;$S(i,h,e,g);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=-1056833530;f[e+4>>2]=g;f[e+8>>2]=1;f[e+12>>2]=4;l_(i,e,e0()|0)|0;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=0;f[g+4>>2]=P;$S(j,h,e,g);g=j+36|0;P=f[g>>2]|0;if((k|0)==(j|0))_=P;else{if(P|0){A=P+12|0;f[A>>2]=(f[A>>2]|0)+1}A=a+80|0;P=f[A>>2]|0;do if(P|0){Z=P+12|0;T=f[Z>>2]|0;f[Z>>2]=T+-1;if((T|0)!=1)break;_S(k)}while(0);f[A>>2]=0;P=a+60|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[l>>2]|0)>0){T=f[n>>2]|0;n=0;do{f[T+(n<<2)>>2]=0;n=n+1|0;$=f[l>>2]|0}while((n|0)<($|0));f[k>>2]=f[j>>2];if(($|0)<3)X=94;else X=96}else{f[k>>2]=f[j>>2];X=94}do if((X|0)==94){$=f[j+4>>2]|0;if(($|0)>=3){X=96;break}f[l>>2]=$;f[m>>2]=f[j+8>>2];f[U>>2]=f[j+12>>2];$=f[j+44>>2]|0;n=f[r>>2]|0;f[n>>2]=f[$>>2];f[n+4>>2]=f[$+4>>2]}while(0);if((X|0)==96)ZS(k,j);f[P>>2]=f[j+16>>2];f[a+64>>2]=f[j+20>>2];f[a+68>>2]=f[j+24>>2];f[a+72>>2]=f[j+28>>2];f[a+76>>2]=f[j+32>>2];P=f[g>>2]|0;f[A>>2]=P;_=P}if(_|0?(P=_+12|0,_=f[P>>2]|0,f[P>>2]=_+-1,(_|0)==1):0)_S(j);f[g>>2]=0;g=j+16|0;_=j+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[_>>2]|0)>0){g=f[j+40>>2]|0;P=0;do{f[g+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[_>>2]|0))}_=f[j+44>>2]|0;if((_|0)!=(j+48|0))g0(_);_=f[w>>2]|0;j=e+8|0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=k;h_(_,e);_=i+36|0;j=f[_>>2]|0;do if(j|0){P=j+12|0;g=f[P>>2]|0;f[P>>2]=g+-1;if((g|0)!=1)break;_S(i)}while(0);f[_>>2]=0;_=i+16|0;j=i+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[j>>2]|0)>0){_=f[i+40>>2]|0;g=0;do{f[_+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=h+36|0;i=f[j>>2]|0;do if(i|0){g=i+12|0;_=f[g>>2]|0;f[g>>2]=_+-1;if((_|0)!=1)break;_S(h)}while(0);f[j>>2]=0;j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[V>>2]|0)>0){j=f[F>>2]|0;F=0;do{f[j+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[V>>2]|0))}V=f[o>>2]|0;if((V|0)!=(W|0))g0(V)}if(!(b[K>>0]|0)){AY(e,1,z,f[k>>2]&4095);k=f[e>>2]|0;ei[f[(f[k>>2]|0)+12>>2]&511](k,e,q,-1);$j(e);u=d;return}lT(e,(f[w>>2]|0)+56|0,1,1);k=f[w>>2]|0;w=k+56|0;if((w|0)!=(e|0)){z=e+36|0;K=f[z>>2]|0;if(K|0){V=K+12|0;f[V>>2]=(f[V>>2]|0)+1}V=k+92|0;K=f[V>>2]|0;do if(K|0){W=K+12|0;o=f[W>>2]|0;f[W>>2]=o+-1;if((o|0)!=1)break;_S(w)}while(0);f[V>>2]=0;K=k+72|0;o=k+60|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[o>>2]|0)>0){W=f[k+96>>2]|0;F=0;do{f[W+(F<<2)>>2]=0;F=F+1|0;aa=f[o>>2]|0}while((F|0)<(aa|0));f[w>>2]=f[e>>2];if((aa|0)<3)X=135;else X=137}else{f[w>>2]=f[e>>2];X=135}do if((X|0)==135){aa=f[e+4>>2]|0;if((aa|0)>=3){X=137;break}f[o>>2]=aa;f[k+64>>2]=f[e+8>>2];f[k+68>>2]=f[e+12>>2];aa=f[e+44>>2]|0;F=f[k+100>>2]|0;f[F>>2]=f[aa>>2];f[F+4>>2]=f[aa+4>>2]}while(0);if((X|0)==137)ZS(w,e);f[K>>2]=f[e+16>>2];f[k+76>>2]=f[e+20>>2];f[k+80>>2]=f[e+24>>2];f[k+84>>2]=f[e+28>>2];f[k+88>>2]=f[e+32>>2];f[V>>2]=f[z>>2]}if((q|0)!=(w|0)){z=k+92|0;V=f[z>>2]|0;if(V|0){K=V+12|0;f[K>>2]=(f[K>>2]|0)+1}K=a+136|0;V=f[K>>2]|0;do if(V|0){o=V+12|0;aa=f[o>>2]|0;f[o>>2]=aa+-1;if((aa|0)!=1)break;_S(q)}while(0);f[K>>2]=0;V=a+116|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[s>>2]|0)>0){aa=f[v>>2]|0;v=0;do{f[aa+(v<<2)>>2]=0;v=v+1|0;ba=f[s>>2]|0}while((v|0)<(ba|0));f[q>>2]=f[w>>2];if((ba|0)<3)X=150;else X=152}else{f[q>>2]=f[w>>2];X=150}do if((X|0)==150){ba=f[k+60>>2]|0;if((ba|0)>=3){X=152;break}f[s>>2]=ba;f[t>>2]=f[k+64>>2];f[a+112>>2]=f[k+68>>2];ba=f[k+100>>2]|0;v=f[x>>2]|0;f[v>>2]=f[ba>>2];f[v+4>>2]=f[ba+4>>2]}while(0);if((X|0)==152)ZS(q,w);f[V>>2]=f[k+72>>2];f[a+120>>2]=f[k+76>>2];f[a+124>>2]=f[k+80>>2];f[a+128>>2]=f[k+84>>2];f[a+132>>2]=f[k+88>>2];f[K>>2]=f[z>>2]}z=e+36|0;K=f[z>>2]|0;if(K|0?(k=K+12|0,K=f[k>>2]|0,f[k>>2]=K+-1,(K|0)==1):0)_S(e);f[z>>2]=0;z=e+16|0;K=e+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[K>>2]|0)>0){z=f[e+40>>2]|0;k=0;do{f[z+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[K>>2]|0))}K=f[e+44>>2]|0;if((K|0)!=(e+48|0))g0(K);u=d;return}function dwb(a){a=a|0;YDc(a);return}function ewb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fwb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=103e3;b=a+156|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+160>>2]=0;b=a+100|0;c=a+136|0;e=f[c>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))g0(b);b=a+44|0;e=a+80|0;c=f[e>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)_S(b);f[e>>2]=0;e=a+60|0;b=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[a+84>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0)){REa(a);return}g0(b);REa(a);return}function gwb(a){a=a|0;fwb(a);YDc(a);return}function hwb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+144|0;h=g+80|0;i=g+68|0;j=g+56|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[i>>2]=0;e=i+4|0;f[e>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f$(c,i);f$(d,j);d=f[a+36>>2]|0;c=f[i>>2]|0;l=f[c+4>>2]|0;m=((d|0)<0?l:0)+d|0;d=c;if((m|0)<0){f[h>>2]=0;f[h+4>>2]=0;n=tT(h,35)|0;o=448311;p=n+35|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,h,452815,461938,997)}o=(l|0)<(m|0)?l:m;if((o|0)>0){m=f[c+40>>2]|0;l=1;n=0;while(1){p=Y(f[m+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){q=p;break}else l=p}}else q=1;if((f[e>>2]|0)!=(d|0)){d=a+44|0;l=a+100|0;o=a+160|0;a=k+36|0;n=k+16|0;m=k+4|0;p=k+40|0;r=k+44|0;s=k+48|0;t=h+36|0;v=h+16|0;w=h+4|0;x=h+40|0;y=h+44|0;z=h+48|0;A=0;B=c;do{lT(h,B+(A*56|0)|0,1,q);lT(k,(f[j>>2]|0)+(A*56|0)|0,1,q);c=z8()|0;owb(h,d,l,k,f[o>>2]|0,c);c=f[a>>2]|0;if(c|0?(C=c+12|0,c=f[C>>2]|0,f[C>>2]=c+-1,(c|0)==1):0)_S(k);f[a>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[m>>2]|0)>0){c=f[p>>2]|0;C=0;do{f[c+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[m>>2]|0))}C=f[r>>2]|0;if((C|0)!=(s|0))g0(C);C=f[t>>2]|0;if(C|0?(c=C+12|0,C=f[c>>2]|0,f[c>>2]=C+-1,(C|0)==1):0)_S(h);f[t>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){C=f[x>>2]|0;c=0;do{f[C+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[w>>2]|0))}c=f[y>>2]|0;if((c|0)!=(z|0))g0(c);A=A+1|0;B=f[i>>2]|0}while(A>>>0<(((f[e>>2]|0)-B|0)/56|0)>>>0)}mx(j);mx(i);u=g;return}function iwb(a,b){a=a|0;b=b|0;var c=0,d=0;switch(b|0){case 3:{c=1;break}case 1:{if(sMa()|0?(f[a+36>>2]|0)==1:0)c=1;else d=6;break}case 2:{if(vmb()|0)c=(f[a+36>>2]|0)==1;else c=0;break}default:d=6}if((d|0)==6)c=0;return c|0}function jwb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function kwb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function lwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+156|0;d=a+160|0;a=b+4|0;do if(f[d>>2]|0){e=f[a>>2]|0;if(!e){g=e;break}else{h=0;return h|0}}else g=f[a>>2]|0;while(0);a=f[b>>2]|0;if(a|0){b=a+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=a;f[d>>2]=g;if(b|0?(g=b+4|0,a=f[g>>2]|0,f[g>>2]=a+-1,(a|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);h=(f[d>>2]|0)!=0;return h|0}function mwb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+32|0;d=g+8|0;h=g;i=f[c>>2]|0;j=i;if(((f[c+4>>2]|0)-i|0)!=12){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,18)|0;l=453187;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,442560,106)}c=a+4|0;n=f[c>>2]|0;o=(f[a+8>>2]|0)-n|0;p=n;if(!((o|0)!=0&((o|0)/56|0)>>>0<3)){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,38)|0;l=442497;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,442560,107)}if((f[p+4>>2]|0)!=2){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,18)|0;l=442790;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,442560,108)}o=f[a+36>>2]|0;n=((o|0)<0?(f[j+4>>2]|0)-(f[i>>2]|0)>>2:0)+o|0;o=f[f[p+40>>2]>>2]|0;p=n+1|0;f[d>>2]=0;i=d+4|0;f[i>>2]=0;f[d+8>>2]=0;if(p>>>0>1073741823)mCc(d);q=p<<2;r=VDc(q)|0;f[d>>2]=r;s=r+(p<<2)|0;f[d+8>>2]=s;XIc(r|0,0,q|0)|0;f[i>>2]=s;if((n|0)>0){q=f[j>>2]|0;j=0;do{f[r+(j<<2)>>2]=f[q+(j<<2)>>2];j=j+1|0}while((j|0)!=(n|0))}f[s+-4>>2]=o;s=e+4|0;n=f[s>>2]|0;j=f[e>>2]|0;q=n-j|0;r=(q|0)/12|0;p=j;j=n;if(q){if(r>>>0>1?(q=p+12|0,(j|0)!=(q|0)):0){p=j;while(1){j=p+-12|0;f[s>>2]=j;n=f[j>>2]|0;if(!n)t=j;else{j=p+-8|0;v=f[j>>2]|0;if((v|0)!=(n|0))f[j>>2]=v+(~((v+-4-n|0)>>>2)<<2);YDc(n);t=f[s>>2]|0}if((t|0)==(q|0))break;else p=t}}}else npb(e,1-r|0,d);if(b[a+40>>0]|0){a=f[c>>2]|0;c=f[a+60>>2]|0;if((c|0)<3)w=Y(f[a+68>>2]|0,f[a+64>>2]|0)|0;else{r=f[a+96>>2]|0;a=0;e=1;while(1){t=Y(f[r+(a<<2)>>2]|0,e)|0;a=a+1|0;if((a|0)==(c|0)){w=t;break}else e=t}}if((o|0)!=(w|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,46)|0;l=442809;m=k+46|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,h,452925,442560,119)}}h=f[d>>2]|0;if(!h){u=g;return 0}d=f[i>>2]|0;if((d|0)!=(h|0))f[i>>2]=d+(~((d+-4-h|0)>>>2)<<2);YDc(h);u=g;return 0}function nwb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+16|0;e=c;g=f[d+4>>2]|0;h=f[d>>2]|0;d=h;if((g|0)==(h|0)){i=0;j=0;J=i;u=c;return j|0}k=f[(f[(f[a+4>>2]|0)+40>>2]|0)+4>>2]|0;a=mJc(k|0,((k|0)<0)<<31>>31|0,3,0)|0;k=J;l=(g-h|0)/12|0;h=0;g=0;m=0;while(1){n=f[d+(h*12|0)+4>>2]|0;o=f[d+(h*12|0)>>2]|0;p=n-o|0;q=p>>2;r=o;if((r|0)!=(n|0)){if((p|0)<=-4){s=7;break}if((p|0)>0){p=0;n=1;while(1){o=Y(f[r+(p<<2)>>2]|0,n)|0;p=p+1|0;if((p|0)>=(q|0)){t=o;break}else n=o}}else t=1}else t=0;n=mJc(a|0,k|0,t|0,((t|0)<0)<<31>>31|0)|0;q=UIc(n|0,J|0,g|0,m|0)|0;h=h+1|0;n=$Ic(0,q|0,32)|0;q=J;if(h>>>0>=l>>>0){i=q;j=n;s=3;break}else{g=n;m=q}}if((s|0)==3){J=i;u=c;return j|0}else if((s|0)==7){f[e>>2]=0;f[e+4>>2]=0;s=tT(e,70)|0;j=452744;c=s+70|0;do{b[s>>0]=b[j>>0]|0;s=s+1|0;j=j+1|0}while((s|0)<(c|0));z5(-215,e,452815,452821,161)}return 0}function owb(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;j=u;u=u+48|0;k=j+8|0;l=j;do if((((((f[a+4>>2]|0)==2?(f[a+12>>2]|0)==(f[c+12>>2]|0):0)?(f[g+8>>2]|0)==(f[a+8>>2]|0):0)?(m=f[g+12>>2]|0,(m|0)==(f[c+8>>2]|0)):0)?(n=f[a>>2]|0,o=n&4095,(o|0)==(f[c>>2]&4095|0)):0)?((o|0)==5?(o|0)==(f[g>>2]&4095|0):0):0){if(f[e+16>>2]|0){o=f[e+4>>2]|0;p=(o|0)<3;if(p)q=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{r=f[e+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(o|0)){q=v;break}else t=v}}if(!((o|0)==0|(q|0)==0)){t=f[e>>2]|0;if(!((t&16384|0)!=0&((n^t)&4095|0)==0))break;if(p)w=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{t=f[e+40>>2]|0;s=0;r=1;while(1){v=Y(f[t+(s<<2)>>2]|0,r)|0;s=s+1|0;if((s|0)==(o|0)){w=v;break}else r=v}}if((w|0)!=(m|0))break}}f[k>>2]=103108;r=k+4|0;o=r+24|0;d[o>>1]=0;b[o+2>>0]=0;f[r>>2]=a;f[k+8>>2]=c;f[k+12>>2]=e;f[k+20>>2]=g;f[k+24>>2]=i;f[k+16>>2]=h;r=(R5(10)|0)&1;b[k+28>>0]=r;r=(R5(11)|0)&1;b[k+29>>0]=r;b[k+30>>0]=0;f[l>>2]=0;f[l+4>>2]=i;y8(l,k,+(i|0));u=j;return}while(0);f[k>>2]=0;f[k+4>>2]=0;dJc(tT(k,328)|0,442856,328)|0;z5(-215,k,453307,442560,154)}function pwb(a){a=a|0;YDc(a);return}function qwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;c=u;u=u+1072|0;d=c;e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;j=f[i+8>>2]|0;k=f[g+12>>2]|0;l=k+7|0;m=l&-8;o=Y(j,f[g+8>>2]|0)|0;g=f[a+24>>2]|0;p=((o+-1+g|0)>>>0)/(g>>>0)|0;q=Y(f[b>>2]|0,p)|0;r=f[b+4>>2]|0;b=Y(r,p)|0;p=(r|0)==(g|0)|o>>>0<b>>>0?o:b;b=((f[f[i+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[i>>2]<<2&28)&15)>>>0)|0;i=m+8|0;o=d+8|0;f[d>>2]=o;g=d+4|0;f[g>>2]=i;if(i>>>0>264){r=XDc(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=r;s=r}else s=o;r=s+31&-32;s=r;if((k|0)<(m|0))XIc(s+(k<<2)|0,0,(l>>>3<<5)-(k<<2)|0)|0;a:do if(p>>>0>q>>>0){l=a+20|0;m=a+12|0;i=r;t=k<<2;v=a+16|0;if((k|0)>0)w=q;else{x=q;while(1){y=(x>>>0)/(j>>>0)|0;z=x-(Y(y,j)|0)|0;A=f[e>>2]|0;B=(f[A+16>>2]|0)+(Y(f[f[A+44>>2]>>2]|0,y)|0)|0;A=f[l>>2]|0;C=(f[A+16>>2]|0)+(Y(f[f[A+44>>2]>>2]|0,y)|0)+(z<<2)|0;y=(f[(f[m>>2]|0)+16>>2]|0)+(z<<2)|0;A=j-z|0;D=p-x|0;E=(D|0)<(A|0)?D:A;dJc(i|0,B|0,t|0)|0;if((E|0)>0){B=0;do{f[C+(B<<2)>>2]=f[y+(B<<2)>>2];B=B+1|0}while((B|0)<(E|0))}B=f[v>>2]|0;if(B|0)Ii[f[(f[B>>2]|0)+100>>2]&127](B,C,C,1,1,z,E+z|0);x=E+x|0;if(p>>>0<=x>>>0)break a}}do{x=(w>>>0)/(j>>>0)|0;B=w-(Y(x,j)|0)|0;y=f[e>>2]|0;A=(f[y+16>>2]|0)+(Y(f[f[y+44>>2]>>2]|0,x)|0)|0;y=f[h>>2]|0;D=f[y+16>>2]|0;F=f[f[y+44>>2]>>2]|0;y=f[l>>2]|0;G=(f[y+16>>2]|0)+(Y(f[f[y+44>>2]>>2]|0,x)|0)+(B<<2)|0;x=(f[(f[m>>2]|0)+16>>2]|0)+(B<<2)|0;y=j-B|0;H=p-w|0;I=(H|0)<(y|0)?H:y;dJc(i|0,A|0,t|0)|0;if((I|0)>0){A=0;y=D+(Y(F,B)|0)|0;while(1){J=+n[x+(A<<2)>>2];F=0;do{J=J+ +n[s+(F<<2)>>2]*+n[y+(F<<2)>>2];F=F+1|0}while((F|0)!=(k|0));n[G+(A<<2)>>2]=J;A=A+1|0;if((A|0)>=(I|0))break;else y=y+(b<<2)|0}}y=f[v>>2]|0;if(y|0)Ii[f[(f[y>>2]|0)+100>>2]&127](y,G,G,1,1,B,I+B|0);w=I+w|0}while(p>>>0>w>>>0)}while(0);w=f[d>>2]|0;if((w|0)==(o|0)){u=c;return}if(w|0)ZDc(w);f[d>>2]=o;f[g>>2]=264;u=c;return}function rwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+16|0;d=a+8|0;e=a;g=f[c>>2]|0;if(g){h=c+4|0;i=f[h>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;if(i|0?(dJc(tT(d,i)|0,g|0,i|0)|0,f[h>>2]|0):0){i=0;do{g=(Jqc(b[(f[c>>2]|0)+i>>0]|0)|0)&255;b[(f[d>>2]|0)+i>>0]=g;i=i+1|0}while(i>>>0<(f[h>>2]|0)>>>0)}h=f[d>>2]|0;f[e>>2]=h;f[e+4>>2]=f[j>>2];if(h|0){j=h+-4|0;f[j>>2]=(f[j>>2]|0)+1}uT(d);d=f[e>>2]|0;if((d|0)==443329)uT(e);else{k=d;l=10}}else{f[e>>2]=0;f[e+4>>2]=0;k=0;l=10}if((l|0)==10?(l=(Ioc((k|0)==0?1154740:k,443329)|0)==0,uT(e),!l):0){m=-1;u=a;return m|0}m=0;u=a;return m|0}function swb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+16|0;d=a+8|0;e=a;g=f[c>>2]|0;if(g){h=c+4|0;i=f[h>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;if(i|0?(dJc(tT(d,i)|0,g|0,i|0)|0,f[h>>2]|0):0){i=0;do{g=(Jqc(b[(f[c>>2]|0)+i>>0]|0)|0)&255;b[(f[d>>2]|0)+i>>0]=g;i=i+1|0}while(i>>>0<(f[h>>2]|0)>>>0)}h=f[d>>2]|0;f[e>>2]=h;f[e+4>>2]=f[j>>2];if(h|0){j=h+-4|0;f[j>>2]=(f[j>>2]|0)+1}uT(d);j=f[e>>2]|0;if((j|0)==443325){uT(e);k=0;u=a;return k|0}else l=j}else{f[e>>2]=0;f[e+4>>2]=0;l=0}j=(Ioc((l|0)==0?1154740:l,443325)|0)==0;uT(e);if(j){k=0;u=a;return k|0}j=f[c>>2]|0;if(j){l=c+4|0;h=f[l>>2]|0;f[d>>2]=0;i=d+4|0;f[i>>2]=0;if(h|0?(dJc(tT(d,h)|0,j|0,h|0)|0,f[l>>2]|0):0){h=0;do{j=(Jqc(b[(f[c>>2]|0)+h>>0]|0)|0)&255;b[(f[d>>2]|0)+h>>0]=j;h=h+1|0}while(h>>>0<(f[l>>2]|0)>>>0)}l=f[d>>2]|0;f[e>>2]=l;f[e+4>>2]=f[i>>2];if(l|0){i=l+-4|0;f[i>>2]=(f[i>>2]|0)+1}uT(d);d=f[e>>2]|0;if((d|0)==443327)uT(e);else{m=d;n=20}}else{f[e>>2]=0;f[e+4>>2]=0;m=0;n=20}if((n|0)==20?(n=(Ioc((m|0)==0?1154740:m,443327)|0)==0,uT(e),!n):0){k=-1;u=a;return k|0}k=1;u=a;return k|0}function twb(a,b){a=a|0;b=b|0;var c=0;c=VDc(88)|0;uwb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=103128;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function uwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0.0,V=0,W=0,X=0,Z=0;d=u;u=u+64|0;e=d;JHa(a);f[a>>2]=103148;f[a+36>>2]=0;f[a+40>>2]=0;g=a+48|0;h=a+52|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;KHa(a,c);i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;do if((j|0)!=(l|0)){if(((l-j|0)/56|0)>>>0<=2){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,17)|0;o=443453;p=m+17|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,105)}lT(e,j+112|0,1,1);q=f[i>>2]|0;r=q+112|0;s=e+36|0;t=f[s>>2]|0;if((r|0)==(e|0))v=t;else{if(t|0){w=t+12|0;f[w>>2]=(f[w>>2]|0)+1}w=q+148|0;t=f[w>>2]|0;if(t|0?(x=t+12|0,t=f[x>>2]|0,f[x>>2]=t+-1,(t|0)==1):0)_S(r);f[w>>2]=0;t=q+128|0;x=q+116|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[x>>2]|0)>0){y=f[q+152>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0;A=f[x>>2]|0}while((z|0)<(A|0));f[r>>2]=f[e>>2];if((A|0)<3)B=15;else B=17}else{f[r>>2]=f[e>>2];B=15}if((B|0)==15){z=f[e+4>>2]|0;if((z|0)<3){f[x>>2]=z;f[q+120>>2]=f[e+8>>2];f[q+124>>2]=f[e+12>>2];z=f[e+44>>2]|0;y=f[q+156>>2]|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2]}else B=17}if((B|0)==17)ZS(r,e);f[t>>2]=f[e+16>>2];f[q+132>>2]=f[e+20>>2];f[q+136>>2]=f[e+24>>2];f[q+140>>2]=f[e+28>>2];f[q+144>>2]=f[e+32>>2];z=f[s>>2]|0;f[w>>2]=z;v=z}if(v|0?(z=v+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)_S(e);f[s>>2]=0;y=e+16|0;z=e+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[z>>2]|0)>0){y=f[e+40>>2]|0;C=0;do{f[y+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[z>>2]|0))}z=f[e+44>>2]|0;if((z|0)!=(e+48|0))g0(z);z=f[i>>2]|0;C=z;if((f[z+4>>2]|0)!=2){f[e>>2]=0;D=e+4|0;f[D>>2]=0;E=tT(e,28)|0;m=E;o=443566;p=m+28|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,112)}if((f[z+60>>2]|0)!=2){f[e>>2]=0;D=e+4|0;f[D>>2]=0;E=tT(e,28)|0;m=E;o=443566;p=m+28|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,112)}y=f[z+8>>2]|0;if((y|0)!=(f[z+64>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,18)|0;o=443595;p=m+18|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,113)}s=f[z+12>>2]|0;if((y|0)!=(s<<2|0)){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,20)|0;o=443614;p=m+20|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,114)}w=f[z+116>>2]|0;if((w|0)<3)F=Y(f[z+124>>2]|0,f[z+120>>2]|0)|0;else{q=f[z+152>>2]|0;t=0;r=1;while(1){x=Y(f[q+(t<<2)>>2]|0,r)|0;t=t+1|0;if((t|0)==(w|0)){F=x;break}else r=x}}if((y|0)!=(F|0)){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,28)|0;o=443635;p=m+28|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,115)}y=f[z>>2]&4095;if((y|0)!=(f[z+56>>2]&4095|0)){f[e>>2]=0;G=e+4|0;f[G>>2]=0;H=tT(e,50)|0;m=H;o=443664;p=m+50|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,116)}r=f[z+112>>2]|0;if((y|0)!=(r&4095|0)){f[e>>2]=0;G=e+4|0;f[G>>2]=0;H=tT(e,50)|0;m=H;o=443664;p=m+50|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,116)}y=(f[k>>2]|0)-C|0;if(((y|0)/56|0)>>>0>3){if((y|0)!=336){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,17)|0;o=443715;p=m+17|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,121)}if((f[z+176>>2]|0)!=(s|0)){f[e>>2]=0;I=e+4|0;f[I>>2]=0;K=tT(e,40)|0;m=K;o=443733;p=m+40|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,125)}if((f[z+180>>2]|0)!=(s|0)){f[e>>2]=0;I=e+4|0;f[I>>2]=0;K=tT(e,40)|0;m=K;o=443733;p=m+40|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,125)}if((r^f[z+168>>2])&4095|0){f[e>>2]=0;L=e+4|0;f[L>>2]=0;M=tT(e,30)|0;m=M;o=443774;p=m+30|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,126)}if((f[z+232>>2]|0)!=(s|0)){f[e>>2]=0;I=e+4|0;f[I>>2]=0;K=tT(e,40)|0;m=K;o=443733;p=m+40|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,125)}if((f[z+236>>2]|0)!=(s|0)){f[e>>2]=0;I=e+4|0;f[I>>2]=0;K=tT(e,40)|0;m=K;o=443733;p=m+40|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,125)}if((r^f[z+224>>2])&4095|0){f[e>>2]=0;L=e+4|0;f[L>>2]=0;M=tT(e,30)|0;m=M;o=443774;p=m+30|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,126)}if((f[z+288>>2]|0)!=(s|0)){f[e>>2]=0;I=e+4|0;f[I>>2]=0;K=tT(e,40)|0;m=K;o=443733;p=m+40|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,125)}if((f[z+292>>2]|0)!=(s|0)){f[e>>2]=0;I=e+4|0;f[I>>2]=0;K=tT(e,40)|0;m=K;o=443733;p=m+40|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,125)}if(!((r^f[z+280>>2])&4095))break;f[e>>2]=0;L=e+4|0;f[L>>2]=0;M=tT(e,30)|0;m=M;o=443774;p=m+30|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,e,443471,443485,126)}}while(0);f[e>>2]=0;f[e+4>>2]=0;m=tT(e,17)|0;o=443805;p=m+17|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));M=c+4|0;c=f[M>>2]|0;do if(c){L=f[e>>2]|0;K=(L|0)==0?1154740:L;I=M;k=c;a:while(1){H=k;while(1){G=f[H+16>>2]|0;if((G|0)==(L|0))break;if((Ioc((G|0)==0?1154740:G,K)|0)>=0)break;G=f[H+4>>2]|0;if(!G){N=I;break a}else H=G}k=f[H>>2]|0;if(!k){N=H;break}else I=H}if((N|0)!=(M|0)){I=f[N+16>>2]|0;if((L|0)!=(I|0)?(Ioc(K,(I|0)==0?1154740:I)|0)<=-1:0){O=1;break}I=DHa(N+24|0,-1)|0;O=(I|0)!=0|(J|0)!=0}else O=1}else O=1;while(0);b[a+72>>0]=O&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;m=tT(e,19)|0;o=443823;p=m+19|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));O=f[M>>2]|0;do if(O){N=f[e>>2]|0;c=(N|0)==0?1154740:N;I=M;k=O;b:while(1){G=k;while(1){F=f[G+16>>2]|0;if((F|0)==(N|0))break;if((Ioc((F|0)==0?1154740:F,c)|0)>=0)break;F=f[G+4>>2]|0;if(!F){P=I;break b}else G=F}k=f[G>>2]|0;if(!k){P=G;break}else I=G}if((P|0)!=(M|0)){I=f[P+16>>2]|0;if((N|0)!=(I|0)?(Ioc(c,(I|0)==0?1154740:I)|0)<=-1:0){Q=0;break}I=DHa(P+24|0,-1)|0;Q=(I|0)!=0|(J|0)!=0}else Q=0}else Q=0;while(0);b[a+73>>0]=Q&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;m=tT(e,11)|0;o=443843;p=m+11|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));Q=f[M>>2]|0;do if(Q){P=f[e>>2]|0;O=(P|0)==0?1154740:P;I=M;k=Q;c:while(1){K=k;while(1){L=f[K+16>>2]|0;if((L|0)==(P|0))break;if((Ioc((L|0)==0?1154740:L,O)|0)>=0)break;L=f[K+4>>2]|0;if(!L){R=I;break c}else K=L}k=f[K>>2]|0;if(!k){R=K;break}else I=K}if((R|0)!=(M|0)){I=f[R+16>>2]|0;if((P|0)!=(I|0)?(Ioc(O,(I|0)==0?1154740:I)|0)<=-1:0){S=0.0;break}S=+tIa(R+24|0,-1)}else S=0.0}else S=0.0;while(0);n[a+76>>2]=S;uT(e);f[e>>2]=0;f[e+4>>2]=0;m=tT(e,9)|0;o=443855;p=m+9|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));R=f[M>>2]|0;do if(R){Q=f[e>>2]|0;I=(Q|0)==0?1154740:Q;k=M;c=R;d:while(1){N=c;while(1){G=f[N+16>>2]|0;if((G|0)==(Q|0))break;if((Ioc((G|0)==0?1154740:G,I)|0)>=0)break;G=f[N+4>>2]|0;if(!G){T=k;break d}else N=G}c=f[N>>2]|0;if(!c){T=N;break}else k=N}if((T|0)!=(M|0)){k=f[T+16>>2]|0;if((Q|0)!=(k|0)?(Ioc(I,(k|0)==0?1154740:k)|0)<=-1:0){U=0.0;break}U=+tIa(T+24|0,-1)}else U=0.0}else U=0.0;while(0);n[a+80>>2]=U;uT(e);f[e>>2]=0;f[e+4>>2]=0;m=tT(e,13)|0;o=443865;p=m+13|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));T=f[M>>2]|0;do if(T){R=f[e>>2]|0;k=(R|0)==0?1154740:R;c=M;O=T;e:while(1){P=O;while(1){K=f[P+16>>2]|0;if((K|0)==(R|0))break;if((Ioc((K|0)==0?1154740:K,k)|0)>=0)break;K=f[P+4>>2]|0;if(!K){V=c;break e}else P=K}O=f[P>>2]|0;if(!O){V=P;break}else c=P}if((V|0)!=(M|0)){c=f[V+16>>2]|0;if((R|0)!=(c|0)?(Ioc(k,(c|0)==0?1154740:c)|0)<=-1:0){W=0;break}c=DHa(V+24|0,-1)|0;W=(c|0)!=0|(J|0)!=0}else W=0}else W=0;while(0);b[a+84>>0]=W&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;m=tT(e,12)|0;o=443879;p=m+12|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));o=f[M>>2]|0;do if(o){m=f[e>>2]|0;p=(m|0)==0?1154740:m;W=M;V=o;f:while(1){T=V;while(1){c=f[T+16>>2]|0;if((c|0)==(m|0))break;if((Ioc((c|0)==0?1154740:c,p)|0)>=0)break;c=f[T+4>>2]|0;if(!c){X=W;break f}else T=c}V=f[T>>2]|0;if(!V){X=T;break}else W=T}if((X|0)!=(M|0)){W=f[X+16>>2]|0;if((m|0)!=(W|0)?(Ioc(p,(W|0)==0?1154740:W)|0)<=-1:0){Z=0;break}W=DHa(X+24|0,-1)|0;Z=((W|0)!=0|(J|0)!=0)&1}else Z=0}else Z=0;while(0);b[a+85>>0]=Z;uT(e);b[a+44>>0]=0;a=f[g>>2]|0;g=f[h>>2]|0;if((g|0)==(a|0)){u=d;return}f[h>>2]=g+(~((g+-4-a|0)>>>2)<<2);u=d;return}function vwb(a){a=a|0;YDc(a);return}function wwb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xwb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=103148;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+48>>2]|0;if(!b){REa(a);return}d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b);REa(a);return}function ywb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=103148;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+48>>2]|0;if(!b){REa(a);YDc(a);return}d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b);REa(a);YDc(a);return}function zwb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=u;u=u+48|0;e=d+40|0;g=d+32|0;h=d+28|0;i=d+16|0;j=d;k=d+12|0;l=d+8|0;m=d+4|0;f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;f$(c,i);if(!(b[a+85>>0]|0)){c=f[a+4>>2]|0;if(((f[a+8>>2]|0)-c|0)==168)o=c;else{f[e>>2]=0;p=e+4|0;f[p>>2]=0;q=tT(e,73)|0;r=q;s=444024;t=r+73|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,453718,443485,224)}}else{c=f[a+4>>2]|0;if(((f[a+8>>2]|0)-c|0)==336)o=c;else{f[e>>2]=0;p=e+4|0;f[p>>2]=0;q=tT(e,73)|0;r=q;s=444024;t=r+73|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,453718,443485,224)}}q=o;o=f[i>>2]|0;p=o;if(((f[n>>2]|0)-o|0)!=56){f[e>>2]=0;f[e+4>>2]=0;r=tT(e,17)|0;s=444271;t=r+17|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,453718,443485,225)}o=f[(f[q+40>>2]|0)+4>>2]|0;f[j>>2]=o;n=f[(f[q+96>>2]|0)+4>>2]|0;q=a+48|0;c=f[q>>2]|0;v=a+52|0;w=f[v>>2]|0;if((c|0)!=(w|0)){x=w-c|0;w=x>>2;if((x|0)<0){f[e>>2]=0;f[e+4>>2]=0;r=tT(e,70)|0;s=452744;t=r+70|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,452815,452821,161)}if(!x)y=1;else{x=0;z=1;while(1){A=Y(f[c+(x<<2)>>2]|0,z)|0;x=x+1|0;if((x|0)==(w|0)){y=A;break}else z=A}}if((y|0)!=(o|0)){f[e>>2]=0;f[e+4>>2]=0;r=tT(e,29)|0;s=444289;t=r+29|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,453718,443485,233)}}else RHa(q,1,j);j=f[p+4>>2]|0;o=(j|0)>1;do if(!(b[a+72>>0]|0)){if(!o){f[e>>2]=0;B=e+4|0;f[B>>2]=0;C=tT(e,46)|0;r=C;s=444366;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,453718,443485,245)}y=f[p+40>>2]|0;z=1;w=1;do{z=Y(f[y+(w<<2)>>2]|0,z)|0;w=w+1|0}while((w|0)!=(j|0));if((z|0)==(n|0)){D=1;E=0;F=y}else{f[e>>2]=0;B=e+4|0;f[B>>2]=0;C=tT(e,46)|0;r=C;s=444366;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,453718,443485,245)}}else{if(!o){f[e>>2]=0;G=e+4|0;f[G>>2]=0;H=tT(e,46)|0;r=H;s=444319;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,453718,443485,239)}if((j|0)==2)I=1;else{y=f[p+40>>2]|0;z=1;w=2;while(1){x=Y(f[y+(w<<2)>>2]|0,z)|0;w=w+1|0;if((w|0)>=(j|0)){I=x;break}else z=x}}if((I|0)==(n|0)){z=f[p+40>>2]|0;D=f[z>>2]|0;E=1;F=z;break}else{f[e>>2]=0;G=e+4|0;f[G>>2]=0;H=tT(e,46)|0;r=H;s=444319;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,e,453718,443485,239)}}while(0);f[a+36>>2]=D;D=f[F+(E<<2)>>2]|0;E=a+40|0;f[E>>2]=D;F=a+60|0;s=f[F>>2]|0;r=a+64|0;t=f[r>>2]|0;if((t|0)==(s|0))J=s;else{H=t+(~((t+-4-s|0)>>>2)<<2)|0;f[r>>2]=H;J=H}if((J|0)==(f[a+68>>2]|0)){g6(F,E);K=f[r>>2]|0;f[k>>2]=K;L=f[q>>2]|0;f[l>>2]=L;M=f[v>>2]|0;f[m>>2]=M;f[h>>2]=f[k>>2];f[g>>2]=f[l>>2];f[e>>2]=f[m>>2];yxa(F,h,g,e)|0;N=a+44|0;b[N>>0]=1;mx(i);u=d;return}else{f[J>>2]=D;D=J+4|0;f[r>>2]=D;K=D;f[k>>2]=K;L=f[q>>2]|0;f[l>>2]=L;M=f[v>>2]|0;f[m>>2]=M;f[h>>2]=f[k>>2];f[g>>2]=f[l>>2];f[e>>2]=f[m>>2];yxa(F,h,g,e)|0;N=a+44|0;b[N>>0]=1;mx(i);u=d;return}}function Awb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0.0;g=u;u=u+848|0;h=g+824|0;i=g+56|0;j=g+808|0;k=g+796|0;l=g+784|0;m=g+728|0;o=g+672|0;q=g+616|0;r=g+560|0;s=g+504|0;t=g+448|0;v=g+392|0;w=g+384|0;x=g+328|0;y=g+272|0;z=g+216|0;A=g+160|0;B=g+104|0;C=g;D=g+88|0;E=g+72|0;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f$(c,j);f$(d,k);f$(e,l);e=a+4|0;d=f[e>>2]|0;c=d+56|0;F=d+112|0;G=f[(f[d+40>>2]|0)+4>>2]|0;H=f[l>>2]|0;f[m>>2]=f[H>>2];I=m+4|0;J=H+4|0;f[I>>2]=f[J>>2];K=m+8|0;f[K>>2]=f[H+8>>2];f[m+12>>2]=f[H+12>>2];L=m+16|0;f[L>>2]=f[H+16>>2];f[m+20>>2]=f[H+20>>2];f[m+24>>2]=f[H+24>>2];f[m+28>>2]=f[H+28>>2];f[m+32>>2]=f[H+32>>2];M=m+36|0;N=f[H+36>>2]|0;f[M>>2]=N;O=m+40|0;f[O>>2]=K;K=m+48|0;P=m+44|0;f[P>>2]=K;f[K>>2]=0;f[m+52>>2]=0;if(N|0){Q=N+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[J>>2]|0)<3){J=f[H+44>>2]|0;Q=f[P>>2]|0;f[Q>>2]=f[J>>2];f[Q+4>>2]=f[J+4>>2]}else{f[I>>2]=0;ZS(m,H)}H=f[l>>2]|0;J=H+56|0;f[o>>2]=f[J>>2];Q=o+4|0;N=H+60|0;R=f[N>>2]|0;f[Q>>2]=R;S=o+8|0;f[S>>2]=f[H+64>>2];f[o+12>>2]=f[H+68>>2];T=o+16|0;f[T>>2]=f[H+72>>2];f[o+20>>2]=f[H+76>>2];f[o+24>>2]=f[H+80>>2];f[o+28>>2]=f[H+84>>2];f[o+32>>2]=f[H+88>>2];U=o+36|0;V=f[H+92>>2]|0;f[U>>2]=V;W=o+40|0;f[W>>2]=S;S=o+48|0;X=o+44|0;f[X>>2]=S;f[S>>2]=0;f[o+52>>2]=0;if(!V)Z=R;else{R=V+12|0;f[R>>2]=(f[R>>2]|0)+1;Z=f[N>>2]|0}if((Z|0)<3){Z=f[H+100>>2]|0;H=f[X>>2]|0;f[H>>2]=f[Z>>2];f[H+4>>2]=f[Z+4>>2]}else{f[Q>>2]=0;ZS(o,J)}J=f[l>>2]|0;Z=J+112|0;f[q>>2]=f[Z>>2];H=q+4|0;N=J+116|0;R=f[N>>2]|0;f[H>>2]=R;V=q+8|0;f[V>>2]=f[J+120>>2];f[q+12>>2]=f[J+124>>2];_=q+16|0;f[_>>2]=f[J+128>>2];f[q+20>>2]=f[J+132>>2];f[q+24>>2]=f[J+136>>2];f[q+28>>2]=f[J+140>>2];f[q+32>>2]=f[J+144>>2];$=q+36|0;aa=f[J+148>>2]|0;f[$>>2]=aa;ba=q+40|0;f[ba>>2]=V;V=q+48|0;ca=q+44|0;f[ca>>2]=V;f[V>>2]=0;f[q+52>>2]=0;if(!aa)da=R;else{R=aa+12|0;f[R>>2]=(f[R>>2]|0)+1;da=f[N>>2]|0}if((da|0)<3){da=f[J+156>>2]|0;J=f[ca>>2]|0;f[J>>2]=f[da>>2];f[J+4>>2]=f[da+4>>2]}else{f[H>>2]=0;ZS(q,Z)}Z=f[l>>2]|0;da=Z+168|0;f[r>>2]=f[da>>2];J=r+4|0;N=Z+172|0;R=f[N>>2]|0;f[J>>2]=R;aa=r+8|0;f[aa>>2]=f[Z+176>>2];f[r+12>>2]=f[Z+180>>2];ea=r+16|0;f[ea>>2]=f[Z+184>>2];f[r+20>>2]=f[Z+188>>2];f[r+24>>2]=f[Z+192>>2];f[r+28>>2]=f[Z+196>>2];f[r+32>>2]=f[Z+200>>2];fa=r+36|0;ga=f[Z+204>>2]|0;f[fa>>2]=ga;ha=r+40|0;f[ha>>2]=aa;aa=r+48|0;ia=r+44|0;f[ia>>2]=aa;f[aa>>2]=0;f[r+52>>2]=0;if(!ga)ja=R;else{R=ga+12|0;f[R>>2]=(f[R>>2]|0)+1;ja=f[N>>2]|0}if((ja|0)<3){ja=f[Z+212>>2]|0;Z=f[ia>>2]|0;f[Z>>2]=f[ja>>2];f[Z+4>>2]=f[ja+4>>2]}else{f[J>>2]=0;ZS(r,da)}p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;l_(m,h,e0()|0)|0;p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;l_(o,h,e0()|0)|0;p[i>>3]=1.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;l_(q,h,e0()|0)|0;da=a+36|0;ja=a+40|0;Z=Y(f[ja>>2]|0,f[da>>2]|0)|0;lT(s,f[j>>2]|0,1,Z);lT(t,f[k>>2]|0,1,Z);N=a+73|0;if(!(b[N>>0]|0)){f[v>>2]=1124007936;R=v+8|0;ga=v+40|0;ka=v+4|0;la=ka+36|0;do{f[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));f[ga>>2]=R;R=v+48|0;f[v+44>>2]=R;f[R>>2]=0;f[v+52>>2]=0}else lT(v,(f[k>>2]|0)+56|0,1,Z);if((f[da>>2]|0)>0){Z=w+4|0;R=h+4|0;ga=h+8|0;ka=h+12|0;la=h+4|0;ma=i+8|0;na=i+12|0;oa=i+4|0;pa=y+8|0;qa=y+12|0;ra=y+4|0;sa=z+8|0;ta=z+4|0;ua=h+8|0;va=h+12|0;wa=h+4|0;xa=i+8|0;ya=i+12|0;za=i+4|0;Aa=y+8|0;Ba=y+12|0;Ca=y+4|0;Da=z+8|0;Ea=z+4|0;Fa=h+8|0;Ga=h+12|0;Ha=h+4|0;Ia=i+8|0;Ja=i+12|0;Ka=i+4|0;La=y+8|0;Ma=y+12|0;Na=y+4|0;Oa=z+8|0;Pa=z+4|0;Qa=h+4|0;Ra=i+4|0;Sa=G<<1;Ta=h+4|0;Ua=i+4|0;Va=G*3|0;Wa=h+4|0;Xa=i+4|0;Ya=G<<2;Za=h+4|0;_a=i+4|0;$a=a+76|0;ab=h+8|0;bb=h+12|0;cb=h+4|0;db=i+8|0;eb=i+12|0;fb=i+4|0;gb=D+8|0;hb=D+4|0;ib=a+85|0;jb=h+4|0;kb=i+4|0;lb=C+36|0;mb=C+16|0;nb=C+4|0;ob=C+40|0;pb=C+44|0;qb=C+48|0;rb=h+8|0;sb=h+12|0;tb=h+4|0;ub=i+8|0;vb=i+12|0;wb=i+4|0;xb=C+8|0;yb=C+4|0;zb=h+8|0;Ab=h+12|0;Bb=h+4|0;Cb=i+8|0;Db=i+12|0;Eb=i+4|0;Fb=C+8|0;Gb=C+4|0;Hb=h+8|0;Ib=h+12|0;Jb=h+4|0;Kb=i+8|0;Lb=i+12|0;Mb=i+4|0;Nb=C+8|0;Ob=C+4|0;Pb=a+84|0;Qb=h+8|0;Rb=h+12|0;Sb=h+4|0;Tb=i+8|0;Ub=i+12|0;Vb=i+4|0;Wb=C+8|0;Xb=C+4|0;Yb=h+4|0;Zb=i+8|0;_b=i+4|0;$b=C+36|0;ac=C+16|0;bc=C+4|0;cc=C+40|0;dc=C+44|0;ec=C+48|0;fc=B+36|0;gc=B+16|0;hc=B+4|0;ic=B+40|0;jc=B+44|0;kc=B+48|0;lc=A+36|0;mc=A+16|0;nc=A+4|0;oc=A+40|0;pc=A+44|0;qc=A+48|0;rc=z+36|0;sc=z+16|0;tc=z+4|0;uc=z+40|0;vc=z+44|0;wc=z+48|0;xc=y+36|0;yc=y+16|0;zc=y+4|0;Ac=y+40|0;Bc=y+44|0;Cc=y+48|0;Dc=x+36|0;Ec=x+16|0;Fc=x+4|0;Gc=x+40|0;Hc=x+44|0;Ic=x+48|0;Jc=h+4|0;Kc=i+8|0;Lc=i+4|0;Mc=C+36|0;Nc=C+16|0;Oc=C+4|0;Pc=C+40|0;Qc=C+44|0;Rc=C+48|0;Sc=h+8|0;Tc=h+12|0;Uc=h+4|0;Vc=i+8|0;Wc=i+12|0;Xc=i+4|0;Yc=C+8|0;Zc=C+12|0;_c=C+4|0;$c=D+8|0;ad=D+4|0;bd=h+8|0;cd=h+12|0;dd=h+4|0;ed=a+80|0;a=i+8|0;fd=i+12|0;gd=i+4|0;hd=D+8|0;id=D+4|0;jd=h+8|0;kd=h+12|0;ld=h+4|0;md=i+8|0;nd=i+12|0;od=i+4|0;pd=D+8|0;qd=D+4|0;rd=h+4|0;sd=i+4|0;td=h+8|0;ud=h+12|0;vd=h+4|0;wd=i+8|0;xd=i+12|0;yd=i+4|0;zd=D+8|0;Ad=D+12|0;Bd=D+4|0;Cd=E+8|0;Dd=E+4|0;Ed=h+8|0;Fd=h+12|0;Gd=h+4|0;Hd=i+8|0;Id=i+12|0;Jd=i+4|0;Kd=D+8|0;Ld=D+12|0;Md=D+4|0;Nd=E+8|0;Od=E+4|0;Pd=C+36|0;Qd=C+16|0;Rd=C+4|0;Sd=C+40|0;Td=C+44|0;Ud=C+48|0;Vd=0;do{Wd=f[ja>>2]|0;Xd=Y(Wd,Vd)|0;Vd=Vd+1|0;Yd=Y(Wd,Vd)|0;f[w>>2]=Xd;f[Z>>2]=Yd;f[h>>2]=-2147483648;f[R>>2]=2147483647;$S(x,s,w,h);f[ga>>2]=0;f[ka>>2]=0;f[h>>2]=16842752;f[la>>2]=x;f[ma>>2]=0;f[na>>2]=0;f[i>>2]=16842752;f[oa>>2]=c;f[pa>>2]=0;f[qa>>2]=0;f[y>>2]=16842752;f[ra>>2]=r;Yd=sa;f[Yd>>2]=0;f[Yd+4>>2]=0;f[z>>2]=33619968;f[ta>>2]=r;MN(h,i,1.0,y,0.0,z,2);f[ua>>2]=0;f[va>>2]=0;f[h>>2]=16842752;f[wa>>2]=m;f[xa>>2]=0;f[ya>>2]=0;f[i>>2]=16842752;f[za>>2]=d;f[Aa>>2]=0;f[Ba>>2]=0;f[y>>2]=16842752;f[Ca>>2]=r;Yd=Da;f[Yd>>2]=0;f[Yd+4>>2]=0;f[z>>2]=33619968;f[Ea>>2]=r;MN(h,i,1.0,y,1.0,z,2);f[Fa>>2]=0;f[Ga>>2]=0;f[h>>2]=16842752;f[Ha>>2]=q;f[Ia>>2]=0;f[Ja>>2]=0;f[i>>2]=16842752;f[Ka>>2]=F;f[La>>2]=0;f[Ma>>2]=0;f[y>>2]=16842752;f[Na>>2]=r;Yd=Oa;f[Yd>>2]=0;f[Yd+4>>2]=0;f[z>>2]=33619968;f[Pa>>2]=r;MN(h,i,1.0,y,1.0,z,0);f[h>>2]=-2147483648;f[Qa>>2]=2147483647;f[i>>2]=0;f[Ra>>2]=G;$S(y,r,h,i);f[h>>2]=-2147483648;f[Ta>>2]=2147483647;f[i>>2]=G;f[Ua>>2]=Sa;$S(z,r,h,i);f[h>>2]=-2147483648;f[Wa>>2]=2147483647;f[i>>2]=Sa;f[Xa>>2]=Va;$S(A,r,h,i);f[h>>2]=-2147483648;f[Za>>2]=2147483647;f[i>>2]=Va;f[_a>>2]=Ya;$S(B,r,h,i);Zd=+n[$a>>2];if(Zd!=0.0){f[ab>>2]=0;f[bb>>2]=0;f[h>>2]=16842752;f[cb>>2]=z;p[C>>3]=Zd;f[i>>2]=-1056833530;f[fb>>2]=C;f[db>>2]=1;f[eb>>2]=1;Yd=gb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[D>>2]=33619968;f[hb>>2]=z;mL(h,i,D,e0()|0,-1)}if(!(b[ib>>0]|0)){f[h>>2]=-2147483648;f[jb>>2]=2147483647;f[i>>2]=0;f[kb>>2]=Va;$S(C,r,h,i);Gwb(C,C);Yd=f[lb>>2]|0;if(Yd|0?(Xd=Yd+12|0,Yd=f[Xd>>2]|0,f[Xd>>2]=Yd+-1,(Yd|0)==1):0)_S(C);f[lb>>2]=0;f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;f[mb+12>>2]=0;if((f[nb>>2]|0)>0){Yd=f[ob>>2]|0;Xd=0;do{f[Yd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[nb>>2]|0))}Xd=f[pb>>2]|0;if((Xd|0)!=(qb|0))g0(Xd)}else{f[h>>2]=-2147483648;f[rd>>2]=2147483647;f[i>>2]=0;f[sd>>2]=Sa;$S(C,r,h,i);f[td>>2]=0;f[ud>>2]=0;f[h>>2]=16842752;f[vd>>2]=o;Xd=(f[e>>2]|0)+168|0;f[wd>>2]=0;f[xd>>2]=0;f[i>>2]=16842752;f[yd>>2]=Xd;f[zd>>2]=0;f[Ad>>2]=0;f[D>>2]=16842752;f[Bd>>2]=y;Xd=Cd;f[Xd>>2]=0;f[Xd+4>>2]=0;f[E>>2]=33619968;f[Dd>>2]=y;MN(h,i,1.0,D,1.0,E,0);f[Ed>>2]=0;f[Fd>>2]=0;f[h>>2]=16842752;f[Gd>>2]=o;Xd=(f[e>>2]|0)+224|0;f[Hd>>2]=0;f[Id>>2]=0;f[i>>2]=16842752;f[Jd>>2]=Xd;f[Kd>>2]=0;f[Ld>>2]=0;f[D>>2]=16842752;f[Md>>2]=z;Xd=Nd;f[Xd>>2]=0;f[Xd+4>>2]=0;f[E>>2]=33619968;f[Od>>2]=z;MN(h,i,1.0,D,1.0,E,0);Gwb(C,C);Xd=f[Pd>>2]|0;if(Xd|0?(Yd=Xd+12|0,Xd=f[Yd>>2]|0,f[Yd>>2]=Xd+-1,(Xd|0)==1):0)_S(C);f[Pd>>2]=0;f[Qd>>2]=0;f[Qd+4>>2]=0;f[Qd+8>>2]=0;f[Qd+12>>2]=0;if((f[Rd>>2]|0)>0){Xd=f[Sd>>2]|0;Yd=0;do{f[Xd+(Yd<<2)>>2]=0;Yd=Yd+1|0}while((Yd|0)<(f[Rd>>2]|0))}Yd=f[Td>>2]|0;if((Yd|0)!=(Ud|0))g0(Yd)}Hwb(B,B);f[rb>>2]=0;f[sb>>2]=0;f[h>>2]=16842752;f[tb>>2]=z;f[ub>>2]=0;f[vb>>2]=0;f[i>>2]=16842752;f[wb>>2]=o;Yd=xb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[C>>2]=33619968;f[yb>>2]=z;qL(h,i,C,1.0,-1);f[zb>>2]=0;f[Ab>>2]=0;f[h>>2]=16842752;f[Bb>>2]=y;f[Cb>>2]=0;f[Db>>2]=0;f[i>>2]=16842752;f[Eb>>2]=B;Yd=Fb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[C>>2]=33619968;f[Gb>>2]=y;qL(h,i,C,1.0,-1);f[Hb>>2]=0;f[Ib>>2]=0;f[h>>2]=16842752;f[Jb>>2]=z;f[Kb>>2]=0;f[Lb>>2]=0;f[i>>2]=16842752;f[Mb>>2]=y;Yd=Nb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[C>>2]=33619968;f[Ob>>2]=o;mL(h,i,C,e0()|0,-1);if(b[Pb>>0]|0){f[bd>>2]=0;f[cd>>2]=0;f[h>>2]=16842752;f[dd>>2]=o;p[C>>3]=+n[ed>>2];f[i>>2]=-1056833530;f[gd>>2]=C;f[a>>2]=1;f[fd>>2]=1;Yd=hd;f[Yd>>2]=0;f[Yd+4>>2]=0;f[D>>2]=33619968;f[id>>2]=o;jL(h,i,D);f[jd>>2]=0;f[kd>>2]=0;f[h>>2]=16842752;f[ld>>2]=o;p[C>>3]=-+n[ed>>2];f[i>>2]=-1056833530;f[od>>2]=C;f[md>>2]=1;f[nd>>2]=1;Yd=pd;f[Yd>>2]=0;f[Yd+4>>2]=0;f[D>>2]=33619968;f[qd>>2]=o;iL(h,i,D)}if(b[ib>>0]|0){f[Sc>>2]=0;f[Tc>>2]=0;f[h>>2]=16842752;f[Uc>>2]=o;Yd=(f[e>>2]|0)+280|0;f[Vc>>2]=0;f[Wc>>2]=0;f[i>>2]=16842752;f[Xc>>2]=Yd;f[Yc>>2]=0;f[Zc>>2]=0;f[C>>2]=16842752;f[_c>>2]=A;Yd=$c;f[Yd>>2]=0;f[Yd+4>>2]=0;f[D>>2]=33619968;f[ad>>2]=A;MN(h,i,1.0,C,1.0,D,0);Gwb(A,A)}Hwb(o,m);f[Qb>>2]=0;f[Rb>>2]=0;f[h>>2]=16842752;f[Sb>>2]=A;f[Tb>>2]=0;f[Ub>>2]=0;f[i>>2]=16842752;f[Vb>>2]=m;Yd=Wb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[C>>2]=33619968;f[Xb>>2]=m;qL(h,i,C,1.0,-1);f[h>>2]=-2147483648;f[Yb>>2]=2147483647;$S(C,t,w,h);Yd=Zb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[i>>2]=-1040121856;f[_b>>2]=C;h_(m,i);Yd=f[$b>>2]|0;if(Yd|0?(Xd=Yd+12|0,Yd=f[Xd>>2]|0,f[Xd>>2]=Yd+-1,(Yd|0)==1):0)_S(C);f[$b>>2]=0;f[ac>>2]=0;f[ac+4>>2]=0;f[ac+8>>2]=0;f[ac+12>>2]=0;if((f[bc>>2]|0)>0){Yd=f[cc>>2]|0;Xd=0;do{f[Yd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[bc>>2]|0))}Xd=f[dc>>2]|0;if((Xd|0)!=(ec|0))g0(Xd);if(b[N>>0]|0){f[h>>2]=-2147483648;f[Jc>>2]=2147483647;$S(C,v,w,h);Xd=Kc;f[Xd>>2]=0;f[Xd+4>>2]=0;f[i>>2]=-1040121856;f[Lc>>2]=C;h_(o,i);Xd=f[Mc>>2]|0;do if(Xd|0){Yd=Xd+12|0;Wd=f[Yd>>2]|0;f[Yd>>2]=Wd+-1;if((Wd|0)!=1)break;_S(C)}while(0);f[Mc>>2]=0;f[Nc>>2]=0;f[Nc+4>>2]=0;f[Nc+8>>2]=0;f[Nc+12>>2]=0;if((f[Oc>>2]|0)>0){Xd=f[Pc>>2]|0;Wd=0;do{f[Xd+(Wd<<2)>>2]=0;Wd=Wd+1|0}while((Wd|0)<(f[Oc>>2]|0))}Wd=f[Qc>>2]|0;if((Wd|0)!=(Rc|0))g0(Wd)}Wd=f[fc>>2]|0;do if(Wd|0){Xd=Wd+12|0;Yd=f[Xd>>2]|0;f[Xd>>2]=Yd+-1;if((Yd|0)!=1)break;_S(B)}while(0);f[fc>>2]=0;f[gc>>2]=0;f[gc+4>>2]=0;f[gc+8>>2]=0;f[gc+12>>2]=0;if((f[hc>>2]|0)>0){Wd=f[ic>>2]|0;Yd=0;do{f[Wd+(Yd<<2)>>2]=0;Yd=Yd+1|0}while((Yd|0)<(f[hc>>2]|0))}Yd=f[jc>>2]|0;if((Yd|0)!=(kc|0))g0(Yd);Yd=f[lc>>2]|0;do if(Yd|0){Wd=Yd+12|0;Xd=f[Wd>>2]|0;f[Wd>>2]=Xd+-1;if((Xd|0)!=1)break;_S(A)}while(0);f[lc>>2]=0;f[mc>>2]=0;f[mc+4>>2]=0;f[mc+8>>2]=0;f[mc+12>>2]=0;if((f[nc>>2]|0)>0){Yd=f[oc>>2]|0;Xd=0;do{f[Yd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[nc>>2]|0))}Xd=f[pc>>2]|0;if((Xd|0)!=(qc|0))g0(Xd);Xd=f[rc>>2]|0;do if(Xd|0){Yd=Xd+12|0;Wd=f[Yd>>2]|0;f[Yd>>2]=Wd+-1;if((Wd|0)!=1)break;_S(z)}while(0);f[rc>>2]=0;f[sc>>2]=0;f[sc+4>>2]=0;f[sc+8>>2]=0;f[sc+12>>2]=0;if((f[tc>>2]|0)>0){Xd=f[uc>>2]|0;Wd=0;do{f[Xd+(Wd<<2)>>2]=0;Wd=Wd+1|0}while((Wd|0)<(f[tc>>2]|0))}Wd=f[vc>>2]|0;if((Wd|0)!=(wc|0))g0(Wd);Wd=f[xc>>2]|0;do if(Wd|0){Xd=Wd+12|0;Yd=f[Xd>>2]|0;f[Xd>>2]=Yd+-1;if((Yd|0)!=1)break;_S(y)}while(0);f[xc>>2]=0;f[yc>>2]=0;f[yc+4>>2]=0;f[yc+8>>2]=0;f[yc+12>>2]=0;if((f[zc>>2]|0)>0){Wd=f[Ac>>2]|0;Yd=0;do{f[Wd+(Yd<<2)>>2]=0;Yd=Yd+1|0}while((Yd|0)<(f[zc>>2]|0))}Yd=f[Bc>>2]|0;if((Yd|0)!=(Cc|0))g0(Yd);Yd=f[Dc>>2]|0;do if(Yd|0){Wd=Yd+12|0;Xd=f[Wd>>2]|0;f[Wd>>2]=Xd+-1;if((Xd|0)!=1)break;_S(x)}while(0);f[Dc>>2]=0;f[Ec>>2]=0;f[Ec+4>>2]=0;f[Ec+8>>2]=0;f[Ec+12>>2]=0;if((f[Fc>>2]|0)>0){Yd=f[Gc>>2]|0;Xd=0;do{f[Yd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[Fc>>2]|0))}Xd=f[Hc>>2]|0;if((Xd|0)!=(Ic|0))g0(Xd)}while((Vd|0)<(f[da>>2]|0))}da=v+36|0;Vd=f[da>>2]|0;if(Vd|0?(Ic=Vd+12|0,Vd=f[Ic>>2]|0,f[Ic>>2]=Vd+-1,(Vd|0)==1):0)_S(v);f[da>>2]=0;da=v+16|0;Vd=v+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[Vd>>2]|0)>0){da=f[v+40>>2]|0;Ic=0;do{f[da+(Ic<<2)>>2]=0;Ic=Ic+1|0}while((Ic|0)<(f[Vd>>2]|0))}Vd=f[v+44>>2]|0;if((Vd|0)!=(v+48|0))g0(Vd);Vd=t+36|0;v=f[Vd>>2]|0;if(v|0?(Ic=v+12|0,v=f[Ic>>2]|0,f[Ic>>2]=v+-1,(v|0)==1):0)_S(t);f[Vd>>2]=0;Vd=t+16|0;v=t+4|0;f[Vd>>2]=0;f[Vd+4>>2]=0;f[Vd+8>>2]=0;f[Vd+12>>2]=0;if((f[v>>2]|0)>0){Vd=f[t+40>>2]|0;Ic=0;do{f[Vd+(Ic<<2)>>2]=0;Ic=Ic+1|0}while((Ic|0)<(f[v>>2]|0))}v=f[t+44>>2]|0;if((v|0)!=(t+48|0))g0(v);v=s+36|0;t=f[v>>2]|0;if(t|0?(Ic=t+12|0,t=f[Ic>>2]|0,f[Ic>>2]=t+-1,(t|0)==1):0)_S(s);f[v>>2]=0;v=s+16|0;t=s+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[s+40>>2]|0;Ic=0;do{f[v+(Ic<<2)>>2]=0;Ic=Ic+1|0}while((Ic|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))g0(t);t=f[fa>>2]|0;do if(t|0){s=t+12|0;Ic=f[s>>2]|0;f[s>>2]=Ic+-1;if((Ic|0)!=1)break;_S(r)}while(0);f[fa>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[J>>2]|0)>0){ea=f[ha>>2]|0;ha=0;do{f[ea+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[J>>2]|0))}J=f[ia>>2]|0;if((J|0)!=(aa|0))g0(J);J=f[$>>2]|0;do if(J|0){aa=J+12|0;ia=f[aa>>2]|0;f[aa>>2]=ia+-1;if((ia|0)!=1)break;_S(q)}while(0);f[$>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[H>>2]|0)>0){_=f[ba>>2]|0;ba=0;do{f[_+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[H>>2]|0))}H=f[ca>>2]|0;if((H|0)!=(V|0))g0(H);H=f[U>>2]|0;do if(H|0){V=H+12|0;ca=f[V>>2]|0;f[V>>2]=ca+-1;if((ca|0)!=1)break;_S(o)}while(0);f[U>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[Q>>2]|0)>0){T=f[W>>2]|0;W=0;do{f[T+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[Q>>2]|0))}Q=f[X>>2]|0;if((Q|0)!=(S|0))g0(Q);Q=f[M>>2]|0;do if(Q|0){S=Q+12|0;X=f[S>>2]|0;f[S>>2]=X+-1;if((X|0)!=1)break;_S(m)}while(0);f[M>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[I>>2]|0)>0){L=f[O>>2]|0;O=0;do{f[L+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[I>>2]|0))}I=f[P>>2]|0;if((I|0)!=(K|0))g0(I);mx(l);mx(k);mx(j);u=g;return}function Bwb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;d=u;u=u+80|0;h=d+64|0;i=d+48|0;j=d+44|0;k=d+28|0;l=d+16|0;m=d+4|0;n=d;o=d+40|0;p=d+36|0;q=d+32|0;if(!(b[a+85>>0]|0)){r=f[a+4>>2]|0;if(((f[a+8>>2]|0)-r|0)==168)s=r;else{f[h>>2]=0;t=h+4|0;f[t>>2]=0;v=tT(h,73)|0;w=v;x=444024;y=w+73|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452925,443485,178)}}else{r=f[a+4>>2]|0;if(((f[a+8>>2]|0)-r|0)==336)s=r;else{f[h>>2]=0;t=h+4|0;f[t>>2]=0;v=tT(h,73)|0;w=v;x=444024;y=w+73|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452925,443485,178)}}v=s;s=f[c>>2]|0;t=s;if(((f[c+4>>2]|0)-s|0)!=12){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,18)|0;x=453187;y=w+18|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452925,443485,179)}f[k>>2]=f[(f[v+40>>2]|0)+4>>2];c=f[(f[v+96>>2]|0)+4>>2]|0;jFa(l,a+48|0);f[m>>2]=0;v=m+4|0;f[v>>2]=0;f[m+8>>2]=0;r=f[l>>2]|0;z=l+4|0;A=f[z>>2]|0;if((r|0)!=(A|0)){B=A-r|0;A=B>>2;if((B|0)<0){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,70)|0;x=452744;y=w+70|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452815,452821,161)}if(!B)C=1;else{B=0;D=1;while(1){E=Y(f[r+(B<<2)>>2]|0,D)|0;B=B+1|0;if((B|0)==(A|0)){C=E;break}else D=E}}if((C|0)!=(f[k>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,31)|0;x=444098;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452925,443485,188)}}else RHa(l,1,k);C=f[t+4>>2]|0;t=f[s>>2]|0;s=C-t|0;D=s>>2;A=D>>>0>1;B=t;do if(!(b[a+72>>0]|0)){if(!A){f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,45)|0;w=G;x=444176;y=w+45|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452925,443485,201)}if((B|0)!=(C|0)){if((s|0)<4){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,70)|0;x=452744;y=w+70|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452815,452821,161)}if((s|0)==4)H=1;else{t=1;r=1;while(1){E=Y(f[B+(t<<2)>>2]|0,r)|0;t=t+1|0;if((t|0)==(D|0)){H=E;break}else r=E}}}else H=0;if((H|0)==(c|0)){f[n>>2]=f[B>>2];I=m+8|0;break}else{f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,45)|0;w=G;x=444176;y=w+45|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452925,443485,201)}}else{if(!A){f[h>>2]=0;J=h+4|0;f[J>>2]=0;K=tT(h,45)|0;w=K;x=444130;y=w+45|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452925,443485,195)}if((B|0)!=(C|0)){if((s|0)<8){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,70)|0;x=452744;y=w+70|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452815,452821,161)}if((s|0)==8)L=1;else{r=2;t=1;while(1){E=Y(f[B+(r<<2)>>2]|0,t)|0;r=r+1|0;if((r|0)==(D|0)){L=E;break}else t=E}}}else L=0;if((L|0)!=(c|0)){f[h>>2]=0;J=h+4|0;f[J>>2]=0;K=tT(h,45)|0;w=K;x=444130;y=w+45|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,452925,443485,195)}f[n>>2]=f[B+4>>2];t=f[v>>2]|0;r=m+8|0;if((t|0)==(f[r>>2]|0)){g6(m,B);I=r;break}else{f[t>>2]=f[B>>2];f[v>>2]=t+4;I=r;break}}while(0);B=f[v>>2]|0;if((B|0)==(f[I>>2]|0)){g6(m,n);M=f[v>>2]|0}else{f[B>>2]=f[n>>2];I=B+4|0;f[v>>2]=I;M=I}f[o>>2]=M;f[p>>2]=f[l>>2];f[q>>2]=f[z>>2];f[j>>2]=f[o>>2];f[i>>2]=f[p>>2];f[h>>2]=f[q>>2];yxa(m,j,i,h)|0;iFa(e,b[a+73>>0]|0?2:1,m);a=f[k>>2]|0;f[h>>2]=f[n>>2];e=h+4|0;f[e>>2]=a;a=h+8|0;f[a>>2]=-1;j=h+12|0;f[j>>2]=-1;f[i>>2]=0;q=i+4|0;f[q>>2]=0;f[i+8>>2]=0;p=h+16|0;lFa(i,h,p);o=f[i>>2]|0;M=f[q>>2]|0;a:do if((o|0)==(M|0)){N=o;O=42}else{I=o;do{if((f[I>>2]|0)<0){N=I;O=42;break a}I=I+4|0}while((I|0)!=(M|0))}while(0);if((O|0)==42?(N|0)!=(M|0):0){o=N+4|0;if((o|0)==(M|0)){P=M;Q=N}else{I=o;o=N;while(1){N=f[I>>2]|0;if((N|0)<0)R=o;else{f[o>>2]=N;R=o+4|0}I=I+4|0;if((I|0)==(M|0))break;else o=R}P=f[q>>2]|0;Q=R}if((Q|0)!=(P|0))f[q>>2]=P+(~((P+-4-Q|0)>>>2)<<2)}iFa(g,1,i);Q=f[i>>2]|0;if(Q|0){P=f[q>>2]|0;if((P|0)!=(Q|0))f[q>>2]=P+(~((P+-4-Q|0)>>>2)<<2);YDc(Q)}Q=f[k>>2]|0;f[h>>2]=f[n>>2];f[e>>2]=Q;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;Q=i+4|0;f[Q>>2]=0;f[i+8>>2]=0;lFa(i,h,p);P=f[i>>2]|0;q=f[Q>>2]|0;b:do if((P|0)==(q|0)){S=P;O=57}else{R=P;do{if((f[R>>2]|0)<0){S=R;O=57;break b}R=R+4|0}while((R|0)!=(q|0))}while(0);if((O|0)==57?(S|0)!=(q|0):0){P=S+4|0;if((P|0)==(q|0)){T=q;U=S}else{R=P;P=S;while(1){S=f[R>>2]|0;if((S|0)<0)V=P;else{f[P>>2]=S;V=P+4|0}R=R+4|0;if((R|0)==(q|0))break;else P=V}T=f[Q>>2]|0;U=V}if((U|0)!=(T|0))f[Q>>2]=T+(~((T+-4-U|0)>>>2)<<2)}U=g+4|0;T=f[U>>2]|0;V=g+8|0;if((T|0)==(f[V>>2]|0)){OGa(g,i);W=f[i>>2]|0}else{f[T>>2]=0;P=T+4|0;f[P>>2]=0;f[T+8>>2]=0;q=f[i>>2]|0;R=(f[Q>>2]|0)-q|0;S=R>>2;if(S){if(S>>>0>1073741823)mCc(T);o=VDc(R)|0;f[P>>2]=o;f[T>>2]=o;f[T+8>>2]=o+(S<<2);S=f[i>>2]|0;T=(f[Q>>2]|0)-S|0;if((T|0)>0){dJc(o|0,S|0,T|0)|0;f[P>>2]=o+(T>>>2<<2);X=S}else X=S}else X=q;f[U>>2]=(f[U>>2]|0)+12;W=X}if(W|0){X=f[Q>>2]|0;if((X|0)!=(W|0))f[Q>>2]=X+(~((X+-4-W|0)>>>2)<<2);YDc(W)}f[h>>2]=f[n>>2];f[e>>2]=1;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;W=i+4|0;f[W>>2]=0;f[i+8>>2]=0;lFa(i,h,p);X=f[i>>2]|0;Q=f[W>>2]|0;c:do if((X|0)==(Q|0)){Z=X;O=80}else{q=X;do{if((f[q>>2]|0)<0){Z=q;O=80;break c}q=q+4|0}while((q|0)!=(Q|0))}while(0);if((O|0)==80?(Z|0)!=(Q|0):0){X=Z+4|0;if((X|0)==(Q|0)){_=Q;$=Z}else{q=X;X=Z;while(1){Z=f[q>>2]|0;if((Z|0)<0)aa=X;else{f[X>>2]=Z;aa=X+4|0}q=q+4|0;if((q|0)==(Q|0))break;else X=aa}_=f[W>>2]|0;$=aa}if(($|0)!=(_|0))f[W>>2]=_+(~((_+-4-$|0)>>>2)<<2)}$=f[U>>2]|0;if(($|0)==(f[V>>2]|0)){OGa(g,i);ba=f[i>>2]|0}else{f[$>>2]=0;_=$+4|0;f[_>>2]=0;f[$+8>>2]=0;aa=f[i>>2]|0;X=(f[W>>2]|0)-aa|0;Q=X>>2;if(Q){if(Q>>>0>1073741823)mCc($);q=VDc(X)|0;f[_>>2]=q;f[$>>2]=q;f[$+8>>2]=q+(Q<<2);Q=f[i>>2]|0;$=(f[W>>2]|0)-Q|0;if(($|0)>0){dJc(q|0,Q|0,$|0)|0;f[_>>2]=q+($>>>2<<2);ca=Q}else ca=Q}else ca=aa;f[U>>2]=(f[U>>2]|0)+12;ba=ca}if(ba|0){ca=f[W>>2]|0;if((ca|0)!=(ba|0))f[W>>2]=ca+(~((ca+-4-ba|0)>>>2)<<2);YDc(ba)}ba=f[k>>2]<<2;f[h>>2]=f[n>>2];f[e>>2]=ba;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;j=i+4|0;f[j>>2]=0;f[i+8>>2]=0;lFa(i,h,p);p=f[i>>2]|0;h=f[j>>2]|0;d:do if((p|0)==(h|0)){da=p;O=103}else{a=p;do{if((f[a>>2]|0)<0){da=a;O=103;break d}a=a+4|0}while((a|0)!=(h|0))}while(0);if((O|0)==103?(da|0)!=(h|0):0){O=da+4|0;if((O|0)==(h|0)){ea=h;fa=da}else{p=O;O=da;while(1){da=f[p>>2]|0;if((da|0)<0)ga=O;else{f[O>>2]=da;ga=O+4|0}p=p+4|0;if((p|0)==(h|0))break;else O=ga}ea=f[j>>2]|0;fa=ga}if((fa|0)!=(ea|0))f[j>>2]=ea+(~((ea+-4-fa|0)>>>2)<<2)}fa=f[U>>2]|0;if((fa|0)==(f[V>>2]|0)){OGa(g,i);ha=f[i>>2]|0}else{f[fa>>2]=0;g=fa+4|0;f[g>>2]=0;f[fa+8>>2]=0;V=f[i>>2]|0;ea=(f[j>>2]|0)-V|0;ga=ea>>2;if(ga){if(ga>>>0>1073741823)mCc(fa);O=VDc(ea)|0;f[g>>2]=O;f[fa>>2]=O;f[fa+8>>2]=O+(ga<<2);ga=f[i>>2]|0;i=(f[j>>2]|0)-ga|0;if((i|0)>0){dJc(O|0,ga|0,i|0)|0;f[g>>2]=O+(i>>>2<<2);ia=ga}else ia=ga}else ia=V;f[U>>2]=(f[U>>2]|0)+12;ha=ia}if(ha|0){ia=f[j>>2]|0;if((ia|0)!=(ha|0))f[j>>2]=ia+(~((ia+-4-ha|0)>>>2)<<2);YDc(ha)}ha=f[m>>2]|0;if(ha|0){m=f[v>>2]|0;if((m|0)!=(ha|0))f[v>>2]=m+(~((m+-4-ha|0)>>>2)<<2);YDc(ha)}ha=f[l>>2]|0;if(!ha){u=d;return 0}l=f[z>>2]|0;if((l|0)!=(ha|0))f[z>>2]=l+(~((l+-4-ha|0)>>>2)<<2);YDc(ha);u=d;return 0}function Cwb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+128|0;h=g+112|0;i=g;j=g+56|0;if((f[c+4>>2]|0)!=2){f[h>>2]=0;k=h+4|0;f[k>>2]=0;l=tT(h,28)|0;m=l;n=443566;o=m+28|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,444013,443485,161)}if((f[d+4>>2]|0)!=2){f[h>>2]=0;k=h+4|0;f[k>>2]=0;l=tT(h,28)|0;m=l;n=443566;o=m+28|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,444013,443485,161)}l=f[c+8>>2]|0;if((l|0)!=(f[d+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,18)|0;n=443595;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,444013,443485,162)}if((l|0)!=(f[c+12>>2]<<2|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,20)|0;n=443614;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,444013,443485,163)}k=f[e+4>>2]|0;if((k|0)<3)p=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{q=f[e+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(k|0)){p=t;break}else s=t}}if((l|0)!=(p|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,28)|0;n=443635;o=m+28|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,444013,443485,164)}p=f[c>>2]&4095;if((p|0)!=(f[d>>2]&4095|0)){f[h>>2]=0;v=h+4|0;f[v>>2]=0;w=tT(h,50)|0;m=w;n=443664;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,444013,443485,165)}if((p|0)!=(f[e>>2]&4095|0)){f[h>>2]=0;v=h+4|0;f[v>>2]=0;w=tT(h,50)|0;m=w;n=443664;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,444013,443485,165)}n=a+4|0;g$(n,3);f[i>>2]=1124007936;a=i+4|0;w=i+8|0;v=i+40|0;m=a;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[v>>2]=w;p=i+48|0;l=i+44|0;f[l>>2]=p;f[p>>2]=0;f[i+52>>2]=0;s=h+8|0;f[s>>2]=0;f[s+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=i;h_(c,h);c=f[n>>2]|0;s=i+36|0;if((c|0)!=(i|0)){k=f[s>>2]|0;if(k|0){r=k+12|0;f[r>>2]=(f[r>>2]|0)+1}r=c+36|0;k=f[r>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)_S(c);f[r>>2]=0;k=c+16|0;q=c+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[q>>2]|0)>0){t=f[c+40>>2]|0;x=0;do{f[t+(x<<2)>>2]=0;x=x+1|0;y=f[q>>2]|0}while((x|0)<(y|0));f[c>>2]=f[i>>2];if((y|0)<3)z=28;else z=30}else{f[c>>2]=f[i>>2];z=28}if((z|0)==28){y=f[a>>2]|0;if((y|0)<3){f[q>>2]=y;f[c+8>>2]=f[w>>2];f[c+12>>2]=f[i+12>>2];w=f[l>>2]|0;y=f[c+44>>2]|0;f[y>>2]=f[w>>2];f[y+4>>2]=f[w+4>>2]}else z=30}if((z|0)==30)ZS(c,i);f[k>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[c+28>>2]=f[i+28>>2];f[c+32>>2]=f[i+32>>2];f[r>>2]=f[s>>2]}r=f[s>>2]|0;if(r|0?(c=r+12|0,r=f[c>>2]|0,f[c>>2]=r+-1,(r|0)==1):0)_S(i);f[s>>2]=0;s=i+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[v>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[l>>2]|0;if((a|0)!=(p|0))g0(a);f[i>>2]=1124007936;a=i+4|0;p=i+8|0;l=i+40|0;m=a;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[l>>2]=p;v=i+48|0;s=i+44|0;f[s>>2]=v;f[v>>2]=0;f[i+52>>2]=0;r=h+8|0;f[r>>2]=0;f[r+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=i;h_(d,h);d=f[n>>2]|0;r=d+56|0;c=i+36|0;k=f[c>>2]|0;if((r|0)==(i|0))A=k;else{if(k|0){w=k+12|0;f[w>>2]=(f[w>>2]|0)+1}w=d+92|0;k=f[w>>2]|0;if(k|0?(y=k+12|0,k=f[y>>2]|0,f[y>>2]=k+-1,(k|0)==1):0)_S(r);f[w>>2]=0;k=d+72|0;y=d+60|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[y>>2]|0)>0){q=f[d+96>>2]|0;x=0;do{f[q+(x<<2)>>2]=0;x=x+1|0;B=f[y>>2]|0}while((x|0)<(B|0));f[r>>2]=f[i>>2];if((B|0)<3)z=51;else z=53}else{f[r>>2]=f[i>>2];z=51}if((z|0)==51){B=f[a>>2]|0;if((B|0)<3){f[y>>2]=B;f[d+64>>2]=f[p>>2];f[d+68>>2]=f[i+12>>2];p=f[s>>2]|0;B=f[d+100>>2]|0;f[B>>2]=f[p>>2];f[B+4>>2]=f[p+4>>2]}else z=53}if((z|0)==53)ZS(r,i);f[k>>2]=f[i+16>>2];f[d+76>>2]=f[i+20>>2];f[d+80>>2]=f[i+24>>2];f[d+84>>2]=f[i+28>>2];f[d+88>>2]=f[i+32>>2];d=f[c>>2]|0;f[w>>2]=d;A=d}if(A|0?(d=A+12|0,A=f[d>>2]|0,f[d>>2]=A+-1,(A|0)==1):0)_S(i);f[c>>2]=0;c=i+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[l>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[a>>2]|0))}a=f[s>>2]|0;if((a|0)!=(v|0))g0(a);f[j>>2]=1124007936;a=j+4|0;v=j+8|0;s=j+40|0;m=a;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[s>>2]=v;v=j+48|0;m=j+44|0;f[m>>2]=v;f[v>>2]=0;f[j+52>>2]=0;o=h+8|0;f[o>>2]=0;f[o+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=j;h_(e,h);lT(i,j,1,1);h=f[n>>2]|0;n=h+112|0;e=i+36|0;o=f[e>>2]|0;if((n|0)==(i|0))C=o;else{if(o|0){l=o+12|0;f[l>>2]=(f[l>>2]|0)+1}l=h+148|0;o=f[l>>2]|0;do if(o|0){c=o+12|0;A=f[c>>2]|0;f[c>>2]=A+-1;if((A|0)!=1)break;_S(n)}while(0);f[l>>2]=0;o=h+128|0;A=h+116|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[A>>2]|0)>0){c=f[h+152>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0;D=f[A>>2]|0}while((d|0)<(D|0));f[n>>2]=f[i>>2];if((D|0)<3)z=74;else z=76}else{f[n>>2]=f[i>>2];z=74}do if((z|0)==74){D=f[i+4>>2]|0;if((D|0)>=3){z=76;break}f[A>>2]=D;f[h+120>>2]=f[i+8>>2];f[h+124>>2]=f[i+12>>2];D=f[i+44>>2]|0;d=f[h+156>>2]|0;f[d>>2]=f[D>>2];f[d+4>>2]=f[D+4>>2]}while(0);if((z|0)==76)ZS(n,i);f[o>>2]=f[i+16>>2];f[h+132>>2]=f[i+20>>2];f[h+136>>2]=f[i+24>>2];f[h+140>>2]=f[i+28>>2];f[h+144>>2]=f[i+32>>2];h=f[e>>2]|0;f[l>>2]=h;C=h}if(C|0?(h=C+12|0,C=f[h>>2]|0,f[h>>2]=C+-1,(C|0)==1):0)_S(i);f[e>>2]=0;e=i+16|0;C=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[C>>2]|0)>0){e=f[i+40>>2]|0;h=0;do{f[e+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[C>>2]|0))}C=f[i+44>>2]|0;if((C|0)!=(i+48|0))g0(C);C=j+36|0;i=f[C>>2]|0;do if(i|0){h=i+12|0;e=f[h>>2]|0;f[h>>2]=e+-1;if((e|0)!=1)break;_S(j)}while(0);f[C>>2]=0;C=j+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[a>>2]|0)>0){C=f[s>>2]|0;s=0;do{f[C+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[a>>2]|0))}a=f[m>>2]|0;if((a|0)==(v|0)){u=g;return}g0(a);u=g;return}function Dwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=a+48|0;if(b[a+44>>0]|0){h=f[a+52>>2]|0;a=f[g>>2]|0;i=h-a|0;j=i>>2;k=a;if((k|0)!=(h|0)){if((i|0)<0){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,70)|0;m=452744;n=l+70|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,452815,452821,161)}if(!i)o=1;else{i=0;h=1;while(1){a=Y(f[k+(i<<2)>>2]|0,h)|0;i=i+1|0;if((i|0)==(j|0)){o=a;break}else h=a}}}else o=0;h=f[c+4>>2]|0;j=f[c>>2]|0;i=h-j|0;k=i>>2;a=j;if((a|0)!=(h|0)){if((i|0)<0){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,70)|0;m=452744;n=l+70|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,452815,452821,161)}if(!i)p=1;else{i=0;h=1;while(1){j=Y(f[a+(i<<2)>>2]|0,h)|0;i=i+1|0;if((i|0)==(k|0)){p=j;break}else h=j}}}else p=0;if((o|0)!=(p|0)){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,57)|0;m=443943;n=l+57|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,444001,443485,155)}}if((g|0)==(c|0)){u=d;return}xxa(g,f[c>>2]|0,f[c+4>>2]|0);u=d;return}function Ewb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!(b[a+44>>0]|0)){b[a+72>>0]=c&1;u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;d=tT(e,10)|0;c=443892;a=d+10|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(a|0));z5(-215,e,443924,443485,143)}}function Fwb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!(b[a+44>>0]|0)){b[a+73>>0]=c&1;u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;d=tT(e,10)|0;c=443892;a=d+10|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(a|0));z5(-215,e,443903,443485,149)}}function Gwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+288|0;d=c+272|0;e=c+32|0;g=c;h=c+256|0;kY(e,a);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=-1056571392;f[d+4>>2]=e;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b3(d,g);$j(e);p[g>>3]=1.0;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;cY(e,g,b);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=-1056571392;f[d+4>>2]=e;g=h+8|0;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;d3(d,-1.0,h);$j(e);u=c;return}function Hwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;d=u;u=u+64|0;e=d+40|0;g=d+20|0;h=d;i=a+4|0;j=a+40|0;XS(c,f[i>>2]|0,f[j>>2]|0,f[a>>2]&4095);k=f[a>>2]|0;switch(k&4095){case 5:{f[e>>2]=a;l=e+4|0;m=f[i>>2]|0;if((m|0)>0)o=f[(f[a+44>>2]|0)+(m+-1<<2)>>2]|0;else o=0;f[l>>2]=o;q=e+8|0;f[q>>2]=0;r=e+12|0;f[r>>2]=0;s=e+16|0;f[s>>2]=0;if(k&16384|0){t=f[a+16>>2]|0;f[r>>2]=t;if((m|0)<3)v=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{r=f[j>>2]|0;w=0;x=1;while(1){y=Y(f[r+(w<<2)>>2]|0,x)|0;w=w+1|0;if((w|0)==(m|0)){v=y;break}else x=y}}x=t+(Y(v,o)|0)|0;f[s>>2]=x}C2(e,0,0);f[g>>2]=c;x=g+4|0;o=f[c+4>>2]|0;if((o|0)>0)z=f[(f[c+44>>2]|0)+(o+-1<<2)>>2]|0;else z=0;f[x>>2]=z;v=g+8|0;f[v>>2]=0;t=g+12|0;f[t>>2]=0;m=g+16|0;f[m>>2]=0;if(f[c>>2]&16384|0){w=f[c+16>>2]|0;f[t>>2]=w;if((o|0)<3)A=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{t=f[c+40>>2]|0;r=0;y=1;while(1){B=Y(f[t+(r<<2)>>2]|0,y)|0;r=r+1|0;if((r|0)==(o|0)){A=B;break}else y=B}}y=w+(Y(A,z)|0)|0;f[m>>2]=y}C2(g,0,0);Iwb(h,a);y=f[e>>2]|0;z=f[q>>2]|0;A=h+8|0;if((y|0)!=(f[h>>2]|0)?1:(z|0)!=(f[A>>2]|0)){w=y;y=z;do{C=+hrc(+n[y>>2]);n[f[v>>2]>>2]=C;z=f[l>>2]|0;if(w|0?(o=f[s>>2]|0,r=y+z|0,f[q>>2]=r,r>>>0>=o>>>0):0){f[q>>2]=r+(0-z);B2(e,1,1)}z=f[x>>2]|0;if(f[g>>2]|0?(r=f[m>>2]|0,o=(f[v>>2]|0)+z|0,f[v>>2]=o,o>>>0>=r>>>0):0){f[v>>2]=o+(0-z);B2(g,1,1)}Iwb(h,a);w=f[e>>2]|0;y=f[q>>2]|0}while((w|0)!=(f[h>>2]|0)?1:(y|0)!=(f[A>>2]|0))}u=d;return}case 6:{f[e>>2]=a;A=e+4|0;y=f[i>>2]|0;if((y|0)>0)D=f[(f[a+44>>2]|0)+(y+-1<<2)>>2]|0;else D=0;f[A>>2]=D;i=e+8|0;f[i>>2]=0;w=e+12|0;f[w>>2]=0;q=e+16|0;f[q>>2]=0;if(k&16384|0){k=f[a+16>>2]|0;f[w>>2]=k;if((y|0)<3)E=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{w=f[j>>2]|0;j=0;v=1;while(1){m=Y(f[w+(j<<2)>>2]|0,v)|0;j=j+1|0;if((j|0)==(y|0)){E=m;break}else v=m}}v=k+(Y(E,D)|0)|0;f[q>>2]=v}C2(e,0,0);f[g>>2]=c;v=g+4|0;D=f[c+4>>2]|0;if((D|0)>0)F=f[(f[c+44>>2]|0)+(D+-1<<2)>>2]|0;else F=0;f[v>>2]=F;E=g+8|0;f[E>>2]=0;k=g+12|0;f[k>>2]=0;y=g+16|0;f[y>>2]=0;if(f[c>>2]&16384|0){j=f[c+16>>2]|0;f[k>>2]=j;if((D|0)<3)G=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{k=f[c+40>>2]|0;c=0;w=1;while(1){m=Y(f[k+(c<<2)>>2]|0,w)|0;c=c+1|0;if((c|0)==(D|0)){G=m;break}else w=m}}w=j+(Y(G,F)|0)|0;f[y>>2]=w}C2(g,0,0);Jwb(h,a);w=f[e>>2]|0;F=f[i>>2]|0;G=h+8|0;if((w|0)!=(f[h>>2]|0)?1:(F|0)!=(f[G>>2]|0)){j=w;w=F;do{C=+lrc(+p[w>>3]);p[f[E>>2]>>3]=C;F=f[A>>2]|0;if(j|0?(D=f[q>>2]|0,c=w+F|0,f[i>>2]=c,c>>>0>=D>>>0):0){f[i>>2]=c+(0-F);B2(e,1,1)}F=f[v>>2]|0;if(f[g>>2]|0?(c=f[y>>2]|0,D=(f[E>>2]|0)+F|0,f[E>>2]=D,D>>>0>=c>>>0):0){f[E>>2]=D+(0-F);B2(g,1,1)}Jwb(h,a);j=f[e>>2]|0;w=f[i>>2]|0}while((j|0)!=(f[h>>2]|0)?1:(w|0)!=(f[G>>2]|0))}u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;d=tT(e,43)|0;G=444222;w=d+43|0;do{b[d>>0]=b[G>>0]|0;d=d+1|0;G=G+1|0}while((d|0)<(w|0));z5(-210,e,444266,443485,74)}}}function Iwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=b;c=a+4|0;d=b+4|0;e=f[d>>2]|0;if((e|0)>0)g=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else g=0;f[c>>2]=g;h=a+8|0;f[h>>2]=0;i=a+12|0;f[i>>2]=0;j=a+16|0;f[j>>2]=0;if(f[b>>2]&16384|0){k=f[b+16>>2]|0;f[i>>2]=k;if((e|0)<3)l=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{m=f[b+40>>2]|0;n=0;o=1;while(1){p=Y(f[m+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)==(e|0)){l=p;break}else o=p}}o=k+(Y(l,g)|0)|0;f[j>>2]=o}C2(a,0,0);o=f[d>>2]|0;if((o|0)<3)q=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{d=f[b+40>>2]|0;b=0;g=1;while(1){l=Y(f[d+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(o|0)){q=l;break}else g=l}}if((q|0)==0|(f[a>>2]|0)==0)return;g=Y(f[c>>2]|0,q)|0;c=(f[h>>2]|0)+g|0;f[h>>2]=c;if(c>>>0>=(f[i>>2]|0)>>>0?(f[j>>2]|0)>>>0>c>>>0:0)return;f[h>>2]=c+(0-g);B2(a,q,1);return}function Jwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=b;c=a+4|0;d=b+4|0;e=f[d>>2]|0;if((e|0)>0)g=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else g=0;f[c>>2]=g;h=a+8|0;f[h>>2]=0;i=a+12|0;f[i>>2]=0;j=a+16|0;f[j>>2]=0;if(f[b>>2]&16384|0){k=f[b+16>>2]|0;f[i>>2]=k;if((e|0)<3)l=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{m=f[b+40>>2]|0;n=0;o=1;while(1){p=Y(f[m+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)==(e|0)){l=p;break}else o=p}}o=k+(Y(l,g)|0)|0;f[j>>2]=o}C2(a,0,0);o=f[d>>2]|0;if((o|0)<3)q=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{d=f[b+40>>2]|0;b=0;g=1;while(1){l=Y(f[d+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(o|0)){q=l;break}else g=l}}if((q|0)==0|(f[a>>2]|0)==0)return;g=Y(f[c>>2]|0,q)|0;c=(f[h>>2]|0)+g|0;f[h>>2]=c;if(c>>>0>=(f[i>>2]|0)>>>0?(f[j>>2]|0)>>>0>c>>>0:0)return;f[h>>2]=c+(0-g);B2(a,q,1);return}function Kwb(a,b){a=a|0;b=b|0;var c=0;c=VDc(64)|0;Lwb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=103272;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Lwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;JHa(a);f[a+40>>2]=0;g=a+44|0;f[g>>2]=0;f[a+48>>2]=0;f[a>>2]=103292;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;h=tT(e,4)|0;b[h>>0]=97;b[h+1>>0]=120;b[h+2>>0]=105;b[h+3>>0]=115;h=c+4|0;c=f[h>>2]|0;do if(c){i=f[e>>2]|0;j=(i|0)==0?1154740:i;k=h;l=c;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((Ioc((n|0)==0?1154740:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(h|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<=-1:0){p=2;break}k=DHa(o+24|0,-1)|0;p=k}else p=2}else p=2;while(0);f[a+36>>2]=p;uT(e);f[e>>2]=0;f[e+4>>2]=0;p=tT(e,6)|0;b[p>>0]=b[451876]|0;b[p+1>>0]=b[451877]|0;b[p+2>>0]=b[451878]|0;b[p+3>>0]=b[451879]|0;b[p+4>>0]=b[451880]|0;b[p+5>>0]=b[451881]|0;p=f[h>>2]|0;do if(p){o=f[e>>2]|0;c=(o|0)==0?1154740:o;k=h;l=p;b:while(1){n=l;while(1){q=f[n+16>>2]|0;if((q|0)==(o|0))break;if((Ioc((q|0)==0?1154740:q,c)|0)>=0)break;q=f[n+4>>2]|0;if(!q){r=k;break b}else n=q}l=f[n>>2]|0;if(!l){r=n;break}else k=n}if((r|0)!=(h|0)){k=f[r+16>>2]|0;if((o|0)!=(k|0)?(Ioc(c,(k|0)==0?1154740:k)|0)<0:0){s=0;break}s=r+24|0}else s=0}else s=0;while(0);uT(e);if(!s){u=d;return}r=s+4|0;h=a+48|0;p=a+40|0;a=s+4|0;k=0;c:while(1){switch(f[s>>2]|0){case 0:{t=(f[r>>2]|0)+4|0;break}case 3:{t=(f[a>>2]|0)+4|0;break}case 2:{t=(f[a>>2]|0)+4|0;break}default:{v=29;break c}}if((k|0)>=(f[t>>2]|0)){v=35;break}l=DHa(s,k)|0;f[e>>2]=l;j=f[g>>2]|0;if((j|0)==(f[h>>2]|0))g6(p,e);else{f[j>>2]=l;f[g>>2]=j+4}k=k+1|0}if((v|0)==29){f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}else if((v|0)==35){u=d;return}}function Mwb(a){a=a|0;YDc(a);return}function Nwb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Owb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=103400;b=f[a+40>>2]|0;if(!b){REa(a);return}c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);REa(a);return}function Pwb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=103400;b=f[a+40>>2]|0;if(!b){REa(a);YDc(a);return}c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);REa(a);YDc(a);return}function Qwb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=103292;b=f[a+52>>2]|0;if(b|0){c=a+56|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b)}f[a>>2]=103400;b=f[a+40>>2]|0;if(!b){REa(a);return}d=a+44|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b);REa(a);return}function Rwb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=103292;b=f[a+52>>2]|0;if(b|0){c=a+56|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b)}f[a>>2]=103400;b=f[a+40>>2]|0;if(!b){REa(a);YDc(a);return}d=a+44|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b);REa(a);YDc(a);return}function Swb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+20|0;g=d+8|0;h=d;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;f$(c,e);c=f[e>>2]|0;j=c;if(((f[i>>2]|0)-c|0)!=112){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,18)|0;l=444635;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,g,453718,444560,97)}c=f[j+4>>2]|0;i=f[a+36>>2]|0;n=((i|0)<0?c:0)+i|0;f[g>>2]=0;i=g+4|0;f[i>>2]=0;f[g+8>>2]=0;do if(c)if(c>>>0>1073741823)mCc(g);else{o=c<<2;p=VDc(o)|0;f[g>>2]=p;q=p+(c<<2)|0;f[g+8>>2]=q;XIc(p|0,0,o|0)|0;f[i>>2]=q;r=p;break}else r=0;while(0);p=f[a+40>>2]|0;q=(f[a+44>>2]|0)-p>>2;o=p;switch(q|0){case 1:{if((c|0)>(n|0)){p=n;do{f[r+(p<<2)>>2]=f[o>>2];p=p+1|0}while((p|0)!=(c|0))}break}case 0:break;default:{if((q|0)!=(c-n|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,91)|0;l=444654;m=k+91|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-5,h,453718,444560,115)}if((c|0)>(n|0)){q=n;do{f[r+(q<<2)>>2]=f[o+(q-n<<2)>>2];q=q+1|0}while((q|0)!=(c|0))}}}q=a+52|0;o=a+56|0;a=f[o>>2]|0;r=f[q>>2]|0;p=a-r>>3;s=r;r=a;if(c>>>0<=p>>>0){if(c>>>0<p>>>0?(a=s+(c<<3)|0,(r|0)!=(a|0)):0)f[o>>2]=r+(~((r+-8-a|0)>>>3)<<3)}else wrb(q,c-p|0);if((n|0)>0){p=j+40|0;a=0;do{r=f[(f[p>>2]|0)+(a<<2)>>2]|0;o=(f[q>>2]|0)+(a<<3)|0;f[o>>2]=0;f[o+4>>2]=r;a=a+1|0}while((a|0)!=(n|0))}a:do if((c|0)>(n|0)){a=j+96|0;p=j+40|0;r=n;while(1){o=f[(f[g>>2]|0)+(r<<2)>>2]|0;if((o|0)<0){t=30;break}s=(f[(f[a>>2]|0)+(r<<2)>>2]|0)+o|0;if((s|0)>(f[(f[p>>2]|0)+(r<<2)>>2]|0)){t=30;break}v=(f[q>>2]|0)+(r<<3)|0;f[v>>2]=o;f[v+4>>2]=s;r=r+1|0;if((r|0)>=(c|0))break a}if((t|0)==30){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,37)|0;l=444746;m=k+37|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-5,h,453718,444560,129)}}while(0);h=f[g>>2]|0;if(!h){mx(e);u=d;return}g=f[i>>2]|0;if((g|0)!=(h|0))f[i>>2]=g+(~((g+-4-h|0)>>>2)<<2);YDc(h);mx(e);u=d;return}function Twb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;d=u;u=u+96|0;e=d+84|0;g=d+72|0;h=d;i=d+56|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f$(b,e);f$(c,g);aT(h,f[e>>2]|0,f[a+52>>2]|0);a=f[g>>2]|0;c=i+8|0;f[c>>2]=0;f[c+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;h_(h,i);i=h+36|0;a=f[i>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)_S(h);f[i>>2]=0;i=h+16|0;a=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[h+40>>2]|0;c=0;do{f[i+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)==(h+48|0)){mx(g);mx(e);u=d;return}g0(a);mx(g);mx(e);u=d;return}function Uwb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=((f[a+56>>2]|0)-(f[a+52>>2]|0)|0)==32;break}default:c=0}return c|0}function Vwb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Wwb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)!=24){f[d>>2]=0;f[d+4>>2]=0;i=tT(d,18)|0;j=453044;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,d,452925,444560,79)}jFa(d,h);h=f[a+36>>2]|0;a=d+4|0;j=f[d>>2]|0;i=(f[a>>2]|0)-j>>2;k=((h|0)<0?i:0)+h|0;h=j;if(k>>>0<i>>>0){j=f[(f[c>>2]|0)+12>>2]|0;c=k;do{f[h+(c<<2)>>2]=f[j+(c<<2)>>2];c=c+1|0}while(c>>>0<i>>>0)}i=e+4|0;c=f[i>>2]|0;j=f[e>>2]|0;h=c-j|0;k=(h|0)/12|0;l=j;j=c;if(h){if(k>>>0>1?(h=l+12|0,(j|0)!=(h|0)):0){l=j;while(1){j=l+-12|0;f[i>>2]=j;c=f[j>>2]|0;if(!c)m=j;else{j=l+-8|0;n=f[j>>2]|0;if((n|0)!=(c|0))f[j>>2]=n+(~((n+-4-c|0)>>>2)<<2);YDc(c);m=f[i>>2]|0}if((m|0)==(h|0))break;else l=m}}}else npb(e,1-k|0,d);k=f[d>>2]|0;if(!k){u=g;return 0}d=f[a>>2]|0;if((d|0)!=(k|0))f[a>>2]=d+(~((d+-4-k|0)>>>2)<<2);YDc(k);u=g;return 0}function Xwb(a,b){a=a|0;b=b|0;var c=0;c=VDc(60)|0;Ywb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=103508;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Ywb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d+8|0;g=d;JHa(a);h=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a>>2]=103528;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;i=tT(e,8)|0;j=i;b[j>>0]=112;b[j+1>>0]=111;b[j+2>>0]=111;b[j+3>>0]=108;j=i+4|0;b[j>>0]=95;b[j+1>>0]=107;b[j+2>>0]=95;b[j+3>>0]=119;j=DHa(lIa(c,e)|0,-1)|0;f[g>>2]=0;f[g+4>>2]=0;i=tT(g,8)|0;k=i;b[k>>0]=112;b[k+1>>0]=111;b[k+2>>0]=111;b[k+3>>0]=108;k=i+4|0;b[k>>0]=95;b[k+1>>0]=107;b[k+2>>0]=95;b[k+3>>0]=104;k=DHa(lIa(c,g)|0,-1)|0;f[h>>2]=j;f[a+40>>2]=k;uT(g);uT(e);f[e>>2]=0;f[e+4>>2]=0;k=tT(e,10)|0;j=444891;h=k+10|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));i=DHa(lIa(c,e)|0,-1)|0;f[g>>2]=0;f[g+4>>2]=0;k=tT(g,10)|0;j=444902;h=k+10|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));l=DHa(lIa(c,g)|0,-1)|0;f[a+44>>2]=i;f[a+48>>2]=l;uT(g);uT(e);f[e>>2]=0;f[e+4>>2]=0;k=tT(e,13)|0;j=444913;h=k+13|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));l=DHa(lIa(c,e)|0,-1)|0;f[g>>2]=0;f[g+4>>2]=0;k=tT(g,13)|0;j=444927;h=k+13|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));j=DHa(lIa(c,g)|0,-1)|0;f[a+52>>2]=l;f[a+56>>2]=j;uT(g);uT(e);u=d;return}function Zwb(a){a=a|0;YDc(a);return}function _wb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $wb(a){a=a|0;REa(a);YDc(a);return}function axb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;g=u;u=u+208|0;h=g+80|0;i=g+68|0;j=g+56|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[i>>2]=0;e=i+4|0;f[e>>2]=0;f[i+8>>2]=0;f[j>>2]=0;a=j+4|0;f[a>>2]=0;f[j+8>>2]=0;f$(c,i);f$(d,j);d=f[i>>2]|0;c=d;if(((f[e>>2]|0)-d|0)!=112){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,18)|0;m=453044;o=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,453206,444941,74)}d=f[c+4>>2]|0;if((d|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{e=f[c+40>>2]|0;r=0;s=1;while(1){t=Y(f[e+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(d|0)){q=t;break}else s=t}}s=f[c+60>>2]|0;if((s|0)<3)v=Y(f[c+68>>2]|0,f[c+64>>2]|0)|0;else{d=f[c+96>>2]|0;r=0;e=1;while(1){t=Y(f[d+(r<<2)>>2]|0,e)|0;r=r+1|0;if((r|0)==(s|0)){v=t;break}else e=t}}if((q|0)!=(v|0)){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,32)|0;m=445062;o=l+32|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,453206,444941,78)}v=c+40|0;if((f[f[v>>2]>>2]|0)!=1){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,18)|0;m=445095;o=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,453206,444941,79)}if(!(f[c>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,20)|0;m=445114;o=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,453206,444941,80)}q=f[j>>2]|0;a:do if((f[a>>2]|0)!=(q|0)){e=h+8|0;s=h+12|0;r=h+4|0;d=c+16|0;t=c+44|0;w=c+72|0;x=c+100|0;y=k+16|0;z=k+44|0;A=k+36|0;B=k+4|0;C=k+40|0;D=k+48|0;E=0;F=q;b:while(1){G=F;H=G+(E*56|0)|0;p[k>>3]=0.0;f[h>>2]=-1056833530;f[r>>2]=k;f[e>>2]=1;f[s>>2]=1;l_(H,h,e0()|0)|0;I=f[(f[v>>2]|0)+4>>2]|0;J=G+(E*56|0)+40|0;K=f[J>>2]|0;if((I|0)!=(f[K+4>>2]|0)){L=23;break}M=Y(f[K+12>>2]|0,f[K+8>>2]|0)|0;if((I|0)>0){I=G+(E*56|0)+4|0;K=G+(E*56|0)+16|0;N=G+(E*56|0)+44|0;O=0;while(1){G=f[I>>2]|0;if((G|0)<=2){L=28;break b}P=f[J>>2]|0;Q=2;do{f[h+(Q+-2<<2)>>2]=f[P+(Q<<2)>>2];Q=Q+1|0}while((Q|0)!=(G|0));dT(k,G+-2|0,h,f[H>>2]&4095,(f[K>>2]|0)+(Y(f[(f[N>>2]|0)+4>>2]|0,O)|0)|0,0);Q=f[v>>2]|0;P=Y(f[Q+12>>2]|0,f[Q+8>>2]|0)|0;R=(f[d>>2]|0)+(Y(f[(f[t>>2]|0)+4>>2]|0,O)|0)|0;Q=(f[w>>2]|0)+(Y(f[(f[x>>2]|0)+4>>2]|0,O)|0)|0;S=f[y>>2]|0;if((P|0)>0){T=0;while(1){U=~~+n[Q+(T<<2)>>2];if(!((U|0)>-1&(U|0)<(M|0))){L=41;break b}f[S+(U<<2)>>2]=f[R+(T<<2)>>2];V=T+1|0;if((V|0)<(P|0))T=V;else break}}P=f[A>>2]|0;if(P|0?(S=P+12|0,P=f[S>>2]|0,f[S>>2]=P+-1,(P|0)==1):0)_S(k);f[A>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[B>>2]|0)>0){P=f[C>>2]|0;S=0;do{f[P+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[B>>2]|0))}S=f[z>>2]|0;if((S|0)!=(D|0))g0(S);S=O+1|0;if((S|0)<(f[(f[v>>2]|0)+4>>2]|0))O=S;else break}}N=E+1|0;F=f[j>>2]|0;if(N>>>0>=(((f[a>>2]|0)-F|0)/56|0)>>>0)break a;else E=N}if((L|0)==23){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,32)|0;m=445135;o=l+32|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,453206,444941,86)}else if((L|0)==28){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,10)|0;m=445168;o=l+10|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,445179,452821,110)}else if((L|0)==41){F=suc(H1(884536,445188,4)|0,E)|0;cuc(h,F+(f[(f[F>>2]|0)+-12>>2]|0)|0);D=Hvc(h,885240)|0;z=Mi[f[(f[D>>2]|0)+28>>2]&1023](D,10)|0;Ivc(h);wuc(F,z)|0;iuc(F)|0;z=suc(H1(F,445193,4)|0,O)|0;cuc(h,z+(f[(f[z>>2]|0)+-12>>2]|0)|0);F=Hvc(h,885240)|0;D=Mi[f[(f[F>>2]|0)+28>>2]&1023](F,10)|0;Ivc(h);wuc(z,D)|0;iuc(z)|0;D=suc(H1(z,445198,5)|0,T)|0;cuc(h,D+(f[(f[D>>2]|0)+-12>>2]|0)|0);z=Hvc(h,885240)|0;F=Mi[f[(f[z>>2]|0)+28>>2]&1023](z,10)|0;Ivc(h);wuc(D,F)|0;iuc(D)|0;F=suc(H1(D,445204,6)|0,U)|0;cuc(h,F+(f[(f[F>>2]|0)+-12>>2]|0)|0);D=Hvc(h,885240)|0;z=Mi[f[(f[D>>2]|0)+28>>2]&1023](D,10)|0;Ivc(h);wuc(F,z)|0;iuc(F)|0;z=H1(F,445211,7)|0;F=uuc(z,+n[R+(T<<2)>>2])|0;cuc(h,F+(f[(f[F>>2]|0)+-12>>2]|0)|0);z=Hvc(h,885240)|0;D=Mi[f[(f[z>>2]|0)+28>>2]&1023](z,10)|0;Ivc(h);wuc(F,D)|0;iuc(F)|0;D=suc(H1(F,445219,14)|0,M)|0;cuc(h,D+(f[(f[D>>2]|0)+-12>>2]|0)|0);F=Hvc(h,885240)|0;z=Mi[f[(f[F>>2]|0)+28>>2]&1023](F,10)|0;Ivc(h);wuc(D,z)|0;iuc(D)|0;z=H1(D,445234,11)|0;D=f[v>>2]|0;F=f[D+-4>>2]|0;c:do if((F|0)>0){B=F+-1|0;C=0;y=D;while(1){suc(z,f[y+(C<<2)>>2]|0)|0;if((C|0)<(B|0))H1(z,445246,3)|0;A=C+1|0;if((A|0)==(F|0))break c;C=A;y=f[v>>2]|0}}while(0);cuc(h,z+(f[(f[z>>2]|0)+-12>>2]|0)|0);F=Hvc(h,885240)|0;D=Mi[f[(f[F>>2]|0)+28>>2]&1023](F,10)|0;Ivc(h);wuc(z,D)|0;iuc(z)|0;D=H1(z,445250,13)|0;F=c+96|0;E=f[F>>2]|0;y=f[E+-4>>2]|0;d:do if((y|0)>0){C=y+-1|0;B=0;A=E;while(1){suc(D,f[A+(B<<2)>>2]|0)|0;if((B|0)<(C|0))H1(D,445246,3)|0;x=B+1|0;if((x|0)==(y|0))break d;B=x;A=f[F>>2]|0}}while(0);cuc(h,D+(f[(f[D>>2]|0)+-12>>2]|0)|0);F=Hvc(h,885240)|0;y=Mi[f[(f[F>>2]|0)+28>>2]&1023](F,10)|0;Ivc(h);wuc(D,y)|0;iuc(D)|0;y=H1(D,445264,8)|0;F=f[J>>2]|0;E=f[F+-4>>2]|0;if((E|0)<=0){W=f[y>>2]|0;X=W+-12|0;Z=f[X>>2]|0;_=y+Z|0;cuc(h,_);$=Hvc(h,885240)|0;aa=f[$>>2]|0;ba=aa+28|0;ca=f[ba>>2]|0;da=Mi[ca&1023]($,10)|0;Ivc(h);wuc(y,da)|0;iuc(y)|0;f[h>>2]=0;ea=h+4|0;f[ea>>2]=0;fa=tT(h,35)|0;l=fa;m=445273;o=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,453206,444941,113)}D=E+-1|0;z=0;A=F;while(1){suc(y,f[A+(z<<2)>>2]|0)|0;if((z|0)<(D|0))H1(y,445246,3)|0;B=z+1|0;if((B|0)==(E|0))break;z=B;A=f[J>>2]|0}W=f[y>>2]|0;X=W+-12|0;Z=f[X>>2]|0;_=y+Z|0;cuc(h,_);$=Hvc(h,885240)|0;aa=f[$>>2]|0;ba=aa+28|0;ca=f[ba>>2]|0;da=Mi[ca&1023]($,10)|0;Ivc(h);wuc(y,da)|0;iuc(y)|0;f[h>>2]=0;ea=h+4|0;f[ea>>2]=0;fa=tT(h,35)|0;l=fa;m=445273;o=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,453206,444941,113)}}while(0);mx(j);mx(i);u=g;return}function bxb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 1:{if(sMa()|0?(f[a+44>>2]|0)==0:0)c=(f[a+48>>2]|0)==0;else c=0;break}default:c=0}return c|0}function cxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function dxb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=h;if(((f[c+4>>2]|0)-h|0)!=24){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,18)|0;k=453044;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,444941,46)}c=f[i+4>>2]|0;m=f[h>>2]|0;h=c-m|0;n=h>>2;o=m;if((o|0)!=(c|0)){if((h|0)<=-4){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,70)|0;k=452744;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452815,452821,161)}if((h|0)>0){h=0;c=1;while(1){m=Y(f[o+(h<<2)>>2]|0,c)|0;h=h+1|0;if((h|0)>=(n|0)){p=m;break}else c=m}}else p=1}else p=0;c=f[i+16>>2]|0;n=f[i+12>>2]|0;h=c-n|0;o=h>>2;m=n;if((m|0)!=(c|0)){if((h|0)<=-4){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,70)|0;k=452744;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452815,452821,161)}if((h|0)>0){h=0;c=1;while(1){n=Y(f[m+(h<<2)>>2]|0,c)|0;h=h+1|0;if((h|0)>=(o|0)){q=n;break}else c=n}}else q=1}else q=0;if((p|0)!=(q|0)){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,36)|0;k=445025;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,444941,47)}jFa(d,i);i=f[d>>2]|0;k=i+8|0;j=Y((f[k>>2]|0)+-1|0,f[a+56>>2]|0)|0;f[k>>2]=j+(f[a+40>>2]|0)-(f[a+48>>2]<<1);j=i+12|0;i=Y((f[j>>2]|0)+-1|0,f[a+52>>2]|0)|0;f[j>>2]=i+(f[a+36>>2]|0)-(f[a+44>>2]<<1);a=f[e>>2]|0;i=e+4|0;j=f[i>>2]|0;if((j|0)!=(a|0)){k=j;while(1){j=k+-12|0;f[i>>2]=j;l=f[j>>2]|0;if(!l)r=j;else{j=k+-8|0;q=f[j>>2]|0;if((q|0)!=(l|0))f[j>>2]=q+(~((q+-4-l|0)>>>2)<<2);YDc(l);r=f[i>>2]|0}if((r|0)==(a|0))break;else k=r}}if((a|0)==(f[e+8>>2]|0)){OGa(e,d);s=f[d>>2]|0}else{f[a>>2]=0;e=a+4|0;f[e>>2]=0;f[a+8>>2]=0;r=d+4|0;k=f[d>>2]|0;l=(f[r>>2]|0)-k|0;q=l>>2;if(q){if(q>>>0>1073741823)mCc(a);j=VDc(l)|0;f[e>>2]=j;f[a>>2]=j;f[a+8>>2]=j+(q<<2);q=f[d>>2]|0;a=(f[r>>2]|0)-q|0;if((a|0)>0){dJc(j|0,q|0,a|0)|0;f[e>>2]=j+(a>>>2<<2);t=q}else t=q}else t=k;f[i>>2]=(f[i>>2]|0)+12;s=t}if(!s){u=g;return 0}t=d+4|0;d=f[t>>2]|0;if((d|0)!=(s|0))f[t>>2]=d+(~((d+-4-s|0)>>>2)<<2);YDc(s);u=g;return 0}function exb(a,b){a=a|0;b=b|0;var c=0;c=VDc(60)|0;fxb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=103636;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function fxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=u;u=u+32|0;e=d+24|0;g=d+8|0;h=d+16|0;i=d;JHa(a);f[a>>2]=103656;j=a+40|0;k=a+44|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;KHa(a,c);l=a+36|0;f[l>>2]=1;f[e>>2]=0;f[e+4>>2]=0;a=tT(e,9)|0;m=445470;o=a+9|0;do{b[a>>0]=b[m>>0]|0;a=a+1|0;m=m+1|0}while((a|0)<(o|0));p=c+4|0;q=f[p>>2]|0;do if(!q)uT(e);else{r=f[e>>2]|0;s=(r|0)==0?1154740:r;t=q;while(1){v=f[t+16>>2]|0;if((r|0)==(v|0)){w=9;break}x=(v|0)==0?1154740:v;if((Ioc(s,x)|0)<0)y=t;else{if((Ioc(x,s)|0)>=0){w=10;break}y=t+4|0}t=f[y>>2]|0;if(!t){w=32;break}}if((w|0)==9)uT(e);else if((w|0)==10)uT(e);else if((w|0)==32){uT(e);break}f[i>>2]=0;f[i+4>>2]=0;a=tT(i,9)|0;m=445470;o=a+9|0;do{b[a>>0]=b[m>>0]|0;a=a+1|0;m=m+1|0}while((a|0)<(o|0));EHa(h,lIa(c,i)|0,-1);t=f[h>>2]|0;if(!t){f[g>>2]=0;f[g+4>>2]=0}else{s=h+4|0;r=f[s>>2]|0;f[e>>2]=0;x=e+4|0;f[x>>2]=0;if(r|0?(dJc(tT(e,r)|0,t|0,r|0)|0,f[s>>2]|0):0){r=0;do{t=(Jqc(b[(f[h>>2]|0)+r>>0]|0)|0)&255;b[(f[e>>2]|0)+r>>0]=t;r=r+1|0}while(r>>>0<(f[s>>2]|0)>>>0)}s=f[e>>2]|0;f[g>>2]=s;f[g+4>>2]=f[x>>2];if(s|0){r=s+-4|0;f[r>>2]=(f[r>>2]|0)+1}uT(e)}uT(h);uT(i);r=f[g>>2]|0;if((r|0)!=445480?(s=(r|0)==0?1154740:r,(Ioc(s,445480)|0)!=0):0)if((r|0)!=454649?(Ioc(s,454649)|0)!=0:0)if((r|0)!=454907?(Ioc(s,454907)|0)!=0:0){f[i>>2]=0;s=i+4|0;f[s>>2]=0;r=g+4|0;tT(i,(f[r>>2]|0)+24|0)|0;t=f[i>>2]|0;a=t;m=445485;o=a+24|0;do{b[a>>0]=b[m>>0]|0;a=a+1|0;m=m+1|0}while((a|0)<(o|0));x=f[r>>2]|0;if(x|0)dJc(t+24|0,f[g>>2]|0,x|0)|0;f[e>>2]=0;f[e+4>>2]=0;tT(e,(f[s>>2]|0)+1|0)|0;x=f[s>>2]|0;if(!x){z=0;A=f[e>>2]|0;B=A+z|0;b[B>>0]=34;z5(-5,e,445510,445527,82)}dJc(f[e>>2]|0,f[i>>2]|0,x|0)|0;z=f[s>>2]|0;A=f[e>>2]|0;B=A+z|0;b[B>>0]=34;z5(-5,e,445510,445527,82)}else C=2;else C=1;else C=0;f[l>>2]=C;uT(g)}while(0);f[e>>2]=0;f[e+4>>2]=0;C=tT(e,5)|0;b[C>>0]=b[445605]|0;b[C+1>>0]=b[445606]|0;b[C+2>>0]=b[445607]|0;b[C+3>>0]=b[445608]|0;b[C+4>>0]=b[445609]|0;C=f[p>>2]|0;if(!C){uT(e);u=d;return}p=f[e>>2]|0;l=(p|0)==0?1154740:p;B=C;while(1){C=f[B+16>>2]|0;if((p|0)==(C|0)){w=41;break}z=(C|0)==0?1154740:C;if((Ioc(l,z)|0)<0)D=B;else{if((Ioc(z,l)|0)>=0){w=42;break}D=B+4|0}B=f[D>>2]|0;if(!B){w=57;break}}if((w|0)==41)uT(e);else if((w|0)==42)uT(e);else if((w|0)==57){uT(e);u=d;return}f[e>>2]=0;f[e+4>>2]=0;w=tT(e,5)|0;b[w>>0]=b[445605]|0;b[w+1>>0]=b[445606]|0;b[w+2>>0]=b[445607]|0;b[w+3>>0]=b[445608]|0;b[w+4>>0]=b[445609]|0;TFa(g,lIa(c,e)|0);uT(e);switch(f[g>>2]|0){case 0:{E=(f[g+4>>2]|0)+4|0;break}case 3:{E=(f[g+4>>2]|0)+4|0;break}case 2:{E=(f[g+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}e=f[E>>2]|0;E=f[k>>2]|0;c=f[j>>2]|0;w=E-c>>2;B=c;c=E;if(e>>>0<=w>>>0){if(e>>>0<w>>>0?(E=B+(e<<2)|0,(c|0)!=(E|0)):0)f[k>>2]=c+(~((c+-4-E|0)>>>2)<<2)}else fqb(j,e-w|0);if((e|0)>0){w=0;do{F=+tIa(g,w);n[(f[j>>2]|0)+(w<<2)>>2]=F;w=w+1|0}while((w|0)<(e|0))}JFa(g);u=d;return}function gxb(a){a=a|0;YDc(a);return}function hxb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ixb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=103656;b=a+52|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+56>>2]=0;b=f[a+40>>2]|0;if(!b){REa(a);return}c=a+44|0;e=f[c>>2]|0;if((e|0)!=(b|0))f[c>>2]=e+(~((e+-4-b|0)>>>2)<<2);YDc(b);REa(a);return}function jxb(a){a=a|0;ixb(a);YDc(a);return}function kxb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+20|0;i=g+8|0;j=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);if(((f[k>>2]|0)-(f[i>>2]|0)|0)!=56){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,19)|0;d=453252;c=k+19|0;do{b[k>>0]=b[d>>0]|0;k=k+1|0;d=d+1|0}while((k|0)<(c|0));z5(-215,j,453206,445527,370)}j=z8()|0;d=f[h>>2]|0;rxb(d,((f[e>>2]|0)-d|0)/56|0,f[i>>2]|0,a+40|0,f[a+36>>2]|0,f[a+56>>2]|0,j);mx(i);mx(h);u=g;return}function lxb(a,b){a=a|0;b=b|0;var c=0;if((b|2|0)==3){c=1;return c|0}if((b|0)!=2){c=0;return c|0}if((f[a+36>>2]|0)!=1){c=1;return c|0}c=(f[a+40>>2]|0)==(f[a+44>>2]|0);return c|0}function mxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function nxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function oxb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+52|0;d=a+56|0;a=b+4|0;do if(f[d>>2]|0){e=f[a>>2]|0;if(!e){g=e;break}else{h=0;return h|0}}else g=f[a>>2]|0;while(0);a=f[b>>2]|0;if(a|0){b=a+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=a;f[d>>2]=g;if(b|0?(g=b+4|0,a=f[g>>2]|0,f[g>>2]=a+-1,(a|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);h=(f[d>>2]|0)!=0;return h|0}function pxb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=((f[c+4>>2]|0)-h|0)/12|0;if(i>>>0<=1){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,18)|0;k=445620;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,445527,109)}c=f[a+44>>2]|0;m=f[a+40>>2]|0;n=c-m>>2;if(!((n|0)==0|(n|0)==(i|0))){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,52)|0;k=445639;l=j+52|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,445527,110)}if(!((c|0)==(m|0)?1:(f[a+36>>2]|0)==1)){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,31)|0;k=445692;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,445527,111)}a=h;m=f[a+4>>2]|0;c=f[h>>2]|0;h=m-c|0;n=c;c=m;m=(n|0)==(c|0);o=1;a:while(1){p=f[a+(o*12|0)>>2]|0;if((h|0)!=((f[a+(o*12|0)+4>>2]|0)-p|0)){q=14;break}if(!m){r=n;s=p;while(1){if((f[r>>2]|0)!=(f[s>>2]|0)){q=14;break a}r=r+4|0;if((r|0)==(c|0))break;else s=s+4|0}}o=o+1|0;if(o>>>0>=i>>>0){q=8;break}}if((q|0)==8){iFa(e,1,a);u=g;return 0}else if((q|0)==14){f[d>>2]=0;f[d+4>>2]=0;j=tT(d,22)|0;k=445724;l=j+22|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,452925,445527,115)}return 0}function qxb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;a=d;e=f[c>>2]|0;g=(f[c+4>>2]|0)-e|0;c=(g|0)/12|0;if(!g){f[a>>2]=0;f[a+4>>2]=0;h=tT(a,13)|0;i=452335;j=h+13|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-215,a,445611,445527,447)}g=f[e+4>>2]|0;k=f[e>>2]|0;e=g-k|0;l=e>>2;m=k;if((m|0)==(g|0)){n=0;o=Y(n,c)|0;p=(o|0)<0;q=p<<31>>31;J=q;u=d;return o|0}if((e|0)<=-4){f[a>>2]=0;f[a+4>>2]=0;h=tT(a,70)|0;i=452744;j=h+70|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-215,a,452815,452821,161)}if((e|0)>0){r=0;s=1}else{n=1;o=Y(n,c)|0;p=(o|0)<0;q=p<<31>>31;J=q;u=d;return o|0}while(1){e=Y(f[m+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)>=(l|0)){n=e;break}else s=e}o=Y(n,c)|0;p=(o|0)<0;q=p<<31>>31;J=q;u=d;return o|0}function rxb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0;j=u;u=u+48|0;k=j+8|0;l=j;m=f[d+4>>2]|0;o=m+-2|0;if(o>>>0>=3)e2(m,103756);p=f[d>>2]|0;q=p&4095;if((q|0)!=5)Y1(q,5,103784);if(!(p&16384)){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,18)|0;s=453311;t=r+18|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,k,453307,445527,142)}q=f[e>>2]|0;v=f[e+4>>2]|0;w=(q|0)==(v|0);x=v;v=q;if(!w?(x-v>>2|0)!=(c|0):0){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,48)|0;s=445747;t=r+48|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,k,453307,445527,143)}if((c|0)<0){y=f[d+40>>2]|0;z=f[y+-4>>2]|0;A=y+4|0;B=(z|0)==2;C=(z|0)>0;D=0;a:while(1){E=f[a+(D*56|0)+40>>2]|0;if((f[E+-4>>2]|0)!=(z|0))break;if(B){if((f[E>>2]|0)!=(f[y>>2]|0))break;if((f[E+4>>2]|0)!=(f[A>>2]|0))break}else if(C){F=0;do{if((f[E+(F<<2)>>2]|0)!=(f[y+(F<<2)>>2]|0))break a;F=F+1|0}while((F|0)<(z|0))}F=f[a+(D*56|0)>>2]|0;if(!((F&16384|0)!=0&((p^F)&4095|0)==0))break;D=D+1|0}f[k>>2]=0;f[k+4>>2]=0;r=tT(k,82)|0;s=445796;t=r+82|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,k,453307,445527,149)}f[k>>2]=103820;D=k+4|0;p=D+12|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[D>>2]=a;f[k+8>>2]=c;f[k+12>>2]=d;f[k+20>>2]=g;f[k+24>>2]=i;a=f[d+40>>2]|0;if((m|0)!=4){f[k+32>>2]=1;D=f[a+(m+-1<<2)>>2]|0;if((m|0)>2){G=1;H=D;I=25}else{f[k+36>>2]=D;J=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;K=1;L=D}}else{D=f[a+4>>2]|0;f[k+32>>2]=D;G=D;H=f[a+(m+-1<<2)>>2]|0;I=25}if((I|0)==25){D=Y(f[a+(o<<2)>>2]|0,H)|0;f[k+36>>2]=D;H=0;o=1;while(1){d=Y(f[a+(H<<2)>>2]|0,o)|0;H=H+1|0;if((H|0)==(m|0)){J=d;K=G;L=D;break}else o=d}}if((J|0)!=(Y(Y(K,f[a>>2]|0)|0,L)|0)){f[l>>2]=0;f[l+4>>2]=0;r=tT(l,53)|0;s=445879;t=r+53|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,l,453307,445527,161)}if((g|0)!=1|w){M=0;N=k+16|0;f[N>>2]=M;O=k+28|0;f[O>>2]=h;f[l>>2]=0;P=l+4|0;f[P>>2]=i;Q=+(i|0);y8(l,k,Q);u=j;return}if((x-v>>2|0)==(c|0))R=0;else{f[l>>2]=0;f[l+4>>2]=0;r=tT(l,30)|0;s=445933;t=r+30|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,l,453307,445527,166)}while(1){if(+n[q+(R<<2)>>2]!=1.0){M=e;I=35;break}R=R+1|0;if(R>>>0>=c>>>0){M=0;I=35;break}}if((I|0)==35){N=k+16|0;f[N>>2]=M;O=k+28|0;f[O>>2]=h;f[l>>2]=0;P=l+4|0;f[P>>2]=i;Q=+(i|0);y8(l,k,Q);u=j;return}}function sxb(a){a=a|0;YDc(a);return}function txb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0;c=f[a+12>>2]|0;d=a+36|0;e=f[d>>2]|0;g=Y(e,f[f[c+40>>2]>>2]|0)|0;h=f[a+24>>2]|0;i=((h+-1+g|0)>>>0)/(h>>>0)|0;h=Y(f[b>>2]|0,i)|0;j=Y(f[b+4>>2]|0,i)|0;i=g>>>0<j>>>0?g:j;j=f[a+8>>2]|0;g=f[a+16>>2]|0;if(!g)k=0;else{b=f[g>>2]|0;k=(b|0)==(f[g+4>>2]|0)?0:b}b=f[c+16>>2]|0;if(i>>>0<=h>>>0)return;c=a+32|0;g=a+28|0;l=a+4|0;m=a+20|0;a=(k|0)==0;o=(j|0)>1;p=(h>>>0)/(e>>>0)|0;q=h-(Y(p,e)|0)|0;r=i-h|0;s=e-q|0;t=(s|0)<(r|0)?s:r;r=(t|0)<4096?t:4096;if((r|0)<1)return;else{u=h;v=r;w=t;x=p;y=e;z=q}while(1){q=f[c>>2]|0;a:do if((q|0)>0){e=f[l>>2]|0;p=f[e+16>>2]|0;t=f[m>>2]|0;r=(w|0)>0;h=Y(q,x)|0;s=o&r;A=o&r;B=o&r;r=0;while(1){C=(Y(y,h+r|0)|0)+z|0;D=b+(C<<2)|0;b:do switch(t|0){case 0:{if(A){E=1;F=p;while(1){G=(f[e+(E*56|0)+16>>2]|0)+(C<<2)|0;H=F+(C<<2)|0;I=0;do{n[D+(I<<2)>>2]=+n[H+(I<<2)>>2]*+n[G+(I<<2)>>2];I=I+1|0}while((I|0)<(v|0));I=E+1|0;if((I|0)==(j|0))break;else{E=I;F=b}}}break}case 2:{if(B){F=1;E=p;while(1){I=(f[e+(F*56|0)+16>>2]|0)+(C<<2)|0;G=E+(C<<2)|0;H=0;do{J=G+(H<<2)|0;K=I+(H<<2)|0;f[D+(H<<2)>>2]=f[(+n[J>>2]<+n[K>>2]?K:J)>>2];H=H+1|0}while((H|0)<(v|0));H=F+1|0;if((H|0)==(j|0))break;else{F=H;E=b}}}break}default:{if(a){if(s){L=1;M=p}else break b;while(1){E=(f[e+(L*56|0)+16>>2]|0)+(C<<2)|0;F=M+(C<<2)|0;H=0;do{n[D+(H<<2)>>2]=+n[F+(H<<2)>>2]+ +n[E+(H<<2)>>2];H=H+1|0}while((H|0)<(v|0));H=L+1|0;if((H|0)==(j|0))break b;else{L=H;M=b}}}if(s){N=+n[k>>2];H=1;E=p;while(1){F=(f[e+(H*56|0)+16>>2]|0)+(C<<2)|0;O=+n[k+(H<<2)>>2];I=E+(C<<2)|0;G=0;do{n[D+(G<<2)>>2]=N*+n[I+(G<<2)>>2]+O*+n[F+(G<<2)>>2];G=G+1|0}while((G|0)<(v|0));G=H+1|0;if((G|0)==(j|0))break;else{N=1.0;H=G;E=b}}}}}while(0);r=r+1|0;if((r|0)>=(q|0))break a}}while(0);r=f[g>>2]|0;if(r|0){e=b+(z<<2)+((Y(Y(q,x)|0,y)|0)<<2)|0;Ii[f[(f[r>>2]|0)+100>>2]&127](r,e,e,v,y,0,q)}u=v+u|0;if(i>>>0<=u>>>0){P=31;break}y=f[d>>2]|0;x=(u>>>0)/(y>>>0)|0;z=u-(Y(x,y)|0)|0;e=i-u|0;r=y-z|0;w=(r|0)<(e|0)?r:e;v=(w|0)<4096?w:4096;if((v|0)<1){P=31;break}}if((P|0)==31)return}function uxb(){var a=0,c=0,d=0,e=0;f[220452]=0;f[220453]=0;f[220454]=0;a=VDc(16)|0;f[220452]=a;f[220454]=-2147483632;f[220453]=15;c=a;d=446308;e=c+15|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b[a+15>>0]=0;be(1736,881808,x|0)|0;return}function vxb(a,b){a=a|0;b=b|0;var c=0;c=VDc(84)|0;wxb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=103840;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function wxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;d=u;u=u+32|0;e=d+8|0;g=d+4|0;h=d;JHa(a);f[a>>2]=103860;f[a+52>>2]=0;f[a+56>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=VDc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=11;j=i;k=446412;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+11>>0]=0;f[g>>2]=0;f[h>>2]=0;i=zxb(a,c,e,g,1,h)|0;m=a+36|0;f[m>>2]=i;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=VDc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=14;j=i;k=446424;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+14>>0]=0;f[g>>2]=0;b[h>>0]=0;i=a+40|0;o=(Axb(a,c,e,g,1,h)|0)&1;b[i>>0]=o;if((b[e+11>>0]|0)<0){YDc(f[e>>2]|0);p=b[i>>0]|0}else p=o;if(!(p<<24>>24))q=f[m>>2]|0;else q=1;f[a+44>>2]=q;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=VDc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=19;j=q;k=446439;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+19>>0]=0;f[g>>2]=0;f[h>>2]=0;q=Bxb(a,c,e,g,1,h)|0;f[a+48>>2]=q;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=VDc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=26;j=q;k=446459;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+26>>0]=0;f[g>>2]=0;b[h>>0]=0;q=(Axb(a,c,e,g,0,h)|0)&1;b[a+60>>0]=q;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);q=e+11|0;b[q>>0]=10;j=e;k=446486;l=j+10|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[e+10>>0]=0;f[g>>2]=0;f[h>>2]=0;m=Bxb(a,c,e,g,1,h)|0;f[a+64>>2]=m;if((b[q>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=VDc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=20;j=q;k=446497;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+20>>0]=0;f[g>>2]=0;n[h>>2]=-3402823466385288598117041.0e14;r=+Cxb(a,c,e,g,0,h);n[a+68>>2]=r;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=5;b[e>>0]=b[446518]|0;b[e+1>>0]=b[446519]|0;b[e+2>>0]=b[446520]|0;b[e+3>>0]=b[446521]|0;b[e+4>>0]=b[446522]|0;b[e+5>>0]=0;f[g>>2]=0;f[h>>2]=-1;m=Bxb(a,c,e,g,0,h)|0;f[a+76>>2]=m;if((b[q>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=VDc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=19;j=q;k=446524;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+19>>0]=0;f[g>>2]=0;b[h>>0]=0;q=(Axb(a,c,e,g,0,h)|0)&1;b[a+80>>0]=q;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=VDc(16)|0;f[e>>2]=q;f[e+8>>2]=-2147483632;f[e+4>>2]=15;j=q;k=451529;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+15>>0]=0;f[g>>2]=0;b[h>>0]=1;q=(Axb(a,c,e,g,0,h)|0)&1;b[a+81>>0]=q;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=4;f[e>>2]=1885957219;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=0;m=(Axb(a,c,e,g,0,h)|0)&1;b[a+82>>0]=m;if((b[q>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=VDc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=16;j=q;k=446544;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+16>>0]=0;f[g>>2]=0;b[h>>0]=1;q=(Axb(a,c,e,g,0,h)|0)&1;b[a+83>>0]=q;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);Dxb(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=VDc(16)|0;f[e>>2]=q;f[e+8>>2]=-2147483632;f[e+4>>2]=13;j=q;k=447828;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+13>>0]=0;f[g>>2]=0;n[h>>2]=0.0;r=+Cxb(a,c,e,g,1,h);h=a+72|0;n[h>>2]=r;if((b[e+11>>0]|0)<0){YDc(f[e>>2]|0);s=+n[h>>2]}else s=r;if(s>0.0){KHa(a,c);u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;j=tT(e,18)|0;k=446561;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,e,446580,446605,193)}}function xxb(a){a=a|0;YDc(a);return}function yxb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zxb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+32|0;j=i+24|0;k=i+8|0;l=i;f[j>>2]=0;m=VDc(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[j+4>>2]=m;m=n;f[m>>2]=0;f[m+4>>2]=0;if(Exb(a,c,d,j)|0){c=DHa(j,f[e>>2]|0)|0;o=c;JFa(j);u=i;return o|0}if(!g){o=f[h>>2]|0;JFa(j);u=i;return o|0}fEc(k,881808);uEc(k,452152)|0;o=b[d+11>>0]|0;i=o<<24>>24<0;tEc(k,i?f[d>>2]|0:d,i?f[d+4>>2]|0:o&255)|0;uEc(k,452187)|0;f[l>>2]=0;f[l+4>>2]=0;o=k+11|0;d=b[o>>0]|0;i=d<<24>>24<0?f[k+4>>2]|0:d&255;if(!i)z5(-5,l,452199,446605,155);d=tT(l,i)|0;dJc(d|0,((b[o>>0]|0)<0?f[k>>2]|0:k)|0,i|0)|0;z5(-5,l,452199,446605,155);return 0}function Axb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+32|0;j=i+24|0;k=i+8|0;l=i;f[j>>2]=0;m=VDc(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[j+4>>2]=m;m=n;f[m>>2]=0;f[m+4>>2]=0;if(Exb(a,c,d,j)|0){c=DHa(j,f[e>>2]|0)|0;o=(c|0)!=0|(J|0)!=0;JFa(j);u=i;return o|0}if(!g){o=(b[h>>0]|0)!=0;JFa(j);u=i;return o|0}fEc(k,881808);uEc(k,452152)|0;o=b[d+11>>0]|0;i=o<<24>>24<0;tEc(k,i?f[d>>2]|0:d,i?f[d+4>>2]|0:o&255)|0;uEc(k,452187)|0;f[l>>2]=0;f[l+4>>2]=0;o=k+11|0;d=b[o>>0]|0;i=d<<24>>24<0?f[k+4>>2]|0:d&255;if(!i)z5(-5,l,452199,446605,155);d=tT(l,i)|0;dJc(d|0,((b[o>>0]|0)<0?f[k>>2]|0:k)|0,i|0)|0;z5(-5,l,452199,446605,155);return 0}function Bxb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+32|0;j=i+24|0;k=i+8|0;l=i;f[j>>2]=0;m=VDc(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[j+4>>2]=m;m=n;f[m>>2]=0;f[m+4>>2]=0;if(Exb(a,c,d,j)|0){c=DHa(j,f[e>>2]|0)|0;o=c;JFa(j);u=i;return o|0}if(!g){o=f[h>>2]|0;JFa(j);u=i;return o|0}fEc(k,881808);uEc(k,452152)|0;o=b[d+11>>0]|0;i=o<<24>>24<0;tEc(k,i?f[d>>2]|0:d,i?f[d+4>>2]|0:o&255)|0;uEc(k,452187)|0;f[l>>2]=0;f[l+4>>2]=0;o=k+11|0;d=b[o>>0]|0;i=d<<24>>24<0?f[k+4>>2]|0:d&255;if(!i)z5(-5,l,452199,446605,155);d=tT(l,i)|0;dJc(d|0,((b[o>>0]|0)<0?f[k>>2]|0:k)|0,i|0)|0;z5(-5,l,452199,446605,155);return 0}function Cxb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0;i=u;u=u+32|0;j=i+24|0;k=i+8|0;l=i;f[j>>2]=0;m=VDc(16)|0;o=m+8|0;f[m>>2]=o;f[m+4>>2]=1;f[j+4>>2]=m;m=o;f[m>>2]=0;f[m+4>>2]=0;if(Exb(a,c,d,j)|0){p=+tIa(j,f[e>>2]|0);JFa(j);u=i;return +p}if(!g){p=+n[h>>2];JFa(j);u=i;return +p}fEc(k,881808);uEc(k,452152)|0;i=b[d+11>>0]|0;j=i<<24>>24<0;tEc(k,j?f[d>>2]|0:d,j?f[d+4>>2]|0:i&255)|0;uEc(k,452187)|0;f[l>>2]=0;f[l+4>>2]=0;i=k+11|0;d=b[i>>0]|0;j=d<<24>>24<0?f[k+4>>2]|0:d&255;if(!j)z5(-5,l,452199,446605,155);d=tT(l,j)|0;dJc(d|0,((b[i>>0]|0)<0?f[k>>2]|0:k)|0,j|0)|0;z5(-5,l,452199,446605,155);return +(0.0)}function Dxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+32|0;e=d+24|0;g=d+16|0;h=d;i=d+8|0;f[i>>2]=0;f[i+4>>2]=0;j=tT(i,9)|0;k=446692;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));EHa(h,lIa(c,i)|0,-1);c=f[h>>2]|0;if(!c){f[g>>2]=0;f[g+4>>2]=0}else{m=h+4|0;n=f[m>>2]|0;f[e>>2]=0;o=e+4|0;f[o>>2]=0;if(n|0?(dJc(tT(e,n)|0,c|0,n|0)|0,f[m>>2]|0):0){n=0;do{c=(Jqc(b[(f[h>>2]|0)+n>>0]|0)|0)&255;b[(f[e>>2]|0)+n>>0]=c;n=n+1|0}while(n>>>0<(f[m>>2]|0)>>>0)}m=f[e>>2]|0;f[g>>2]=m;f[g+4>>2]=f[o>>2];if(m|0){o=m+-4|0;f[o>>2]=(f[o>>2]|0)+1}uT(e)}uT(h);uT(i);i=f[g>>2]|0;if((i|0)!=446702){h=a+52|0;if(!(Ioc((i|0)==0?1154740:i,446702)|0))p=h;else{uT(h);i=tT(h,6)|0;b[i>>0]=b[446726]|0;b[i+1>>0]=b[446727]|0;b[i+2>>0]=b[446728]|0;b[i+3>>0]=b[446729]|0;b[i+4>>0]=b[446730]|0;b[i+5>>0]=b[446731]|0;uT(g);u=d;return}}else p=a+52|0;uT(p);j=tT(p,11)|0;k=446714;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));uT(g);u=d;return}function Exb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=u;u=u+16|0;g=a;f[g>>2]=0;f[g+4>>2]=0;h=d+11|0;i=b[h>>0]|0;j=d+4|0;k=i<<24>>24<0?f[j>>2]|0:i&255;if(k|0){i=tT(g,k)|0;dJc(i|0,((b[h>>0]|0)<0?f[d>>2]|0:d)|0,k|0)|0}k=f[c+4>>2]|0;a:do if(k|0){i=f[g>>2]|0;l=(i|0)==0?1154740:i;m=k;while(1){n=f[m+16>>2]|0;if((i|0)==(n|0))break;o=(n|0)==0?1154740:n;if((Ioc(l,o)|0)<0)p=m;else{if((Ioc(o,l)|0)>=0)break;p=m+4|0}m=f[p>>2]|0;if(!m)break a}uT(g);f[g>>2]=0;f[g+4>>2]=0;m=b[h>>0]|0;l=m<<24>>24<0?f[j>>2]|0:m&255;if(l|0){m=tT(g,l)|0;dJc(m|0,((b[h>>0]|0)<0?f[d>>2]|0:d)|0,l|0)|0}gIa(e,lIa(c,g)|0)|0;uT(g);q=1;u=a;return q|0}while(0);uT(g);q=0;u=a;return q|0}function Fxb(a){a=a|0;f[a>>2]=103860;uT(a+52|0);REa(a);return}function Gxb(a){a=a|0;f[a>>2]=103860;uT(a+52|0);REa(a);YDc(a);return}function Hxb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;g=u;u=u+224|0;h=g+200|0;i=g+188|0;j=g+176|0;k=g+164|0;l=g+152|0;m=g+120|0;o=g+104|0;q=g;r=g+80|0;s=g+72|0;t=g+16|0;v=a+81|0;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);f[j>>2]=0;c=j+4|0;f[c>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=f[h>>2]|0;x=f[f[w+40>>2]>>2]|0;y=(f[(f[w+152>>2]|0)+8>>2]|0)/4|0;f[l>>2]=y;z=f[w+16>>2]|0;A=f[w+72>>2]|0;B=f[w+128>>2]|0;f[m>>2]=0;w=m+4|0;f[w>>2]=0;f[m+8>>2]=0;C=a+44|0;D=a+40|0;Lxb(z,x,y,f[C>>2]|0,(b[D>>0]|0)!=0,(b[a+80>>0]|0)!=0,m);Mxb(A,x,f[l>>2]|0,f[a+36>>2]|0,k);f[o>>2]=0;A=o+4|0;f[A>>2]=0;f[o+8>>2]=0;f[q>>2]=0;y=q+4|0;f[y>>2]=0;f[q+8>>2]=0;Nxb(B,l,(b[v>>0]|0)!=0,o,q);n[r+20>>2]=0.0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;b[r+16>>0]=0;B=b[a+82>>0]|0;z=b[v>>0]|0;do if(B<<24>>24){if(z<<24>>24){n[r+4>>2]=0.0;n[r>>2]=0.0;n[r+12>>2]=1.0;n[r+8>>2]=1.0;E=1;break}if((((f[e>>2]|0)-(f[h>>2]|0)|0)/56|0)>>>0<=3){f[s>>2]=0;f[s+4>>2]=0;F=tT(s,39)|0;G=446942;H=F+39|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,s,453206,446605,461)}n[r+4>>2]=0.0;n[r>>2]=0.0;v=f[h>>2]|0;if((f[v+172>>2]|0)==4){I=f[v+208>>2]|0;n[r+8>>2]=+((f[I+12>>2]|0)+-1|0);n[r+12>>2]=+((f[I+8>>2]|0)+-1|0);E=0;break}else{f[s>>2]=0;f[s+4>>2]=0;F=tT(s,19)|0;G=446982;H=F+19|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,s,453206,446605,468)}}else E=z;while(0);Oxb(m,o,q,x,(b[D>>0]|0)!=0,f[C>>2]|0,f[a+48>>2]|0,a+52|0,(b[a+60>>0]|0)!=0,B<<24>>24!=0,r,E<<24>>24!=0,j);E=f[q>>2]|0;if(E|0){r=f[y>>2]|0;if((r|0)==(E|0))J=E;else{B=r;while(1){r=B+-12|0;f[y>>2]=r;C=f[r>>2]|0;if(!C)K=r;else{r=B+-8|0;D=f[r>>2]|0;if((D|0)!=(C|0))f[r>>2]=D+(~((D+-4-C|0)>>>2)<<2);YDc(C);K=f[y>>2]|0}if((K|0)==(E|0))break;else B=K}J=f[q>>2]|0}YDc(J)}J=f[o>>2]|0;if(J|0){K=f[A>>2]|0;if((K|0)!=(J|0))f[A>>2]=K+(~(((K+-24-J|0)>>>0)/24|0)*24|0);YDc(J)}J=f[m>>2]|0;if(J|0){K=f[w>>2]|0;if((K|0)==(J|0))L=J;else{A=K;do{K=A+-12|0;f[w>>2]=K;Pxb(K,f[A+-8>>2]|0);A=f[w>>2]|0}while((A|0)!=(J|0));L=f[m>>2]|0}YDc(L)}f[l>>2]=0;L=l+4|0;f[L>>2]=0;f[l+8>>2]=0;J=(x|0)>0;do if(J){A=0;w=0;do{w=(Qxb(a,(f[j>>2]|0)+(A*12|0)|0,(f[k>>2]|0)+(A*56|0)|0,l)|0)+w|0;A=A+1|0}while((A|0)<(x|0));if(w){f[m>>2]=1;f[m+4>>2]=1;f[m+8>>2]=w;f[m+12>>2]=7;XS(f[i>>2]|0,4,m,5);A=f[(f[i>>2]|0)+16>>2]|0;if(J){K=a+83|0;B=0;E=0;while(1){y=(Rxb(a,B,A+(E*7<<2)|0,(f[j>>2]|0)+(B*12|0)|0,(f[k>>2]|0)+(B*56|0)|0,(f[l>>2]|0)+(B*12|0)|0,(b[K>>0]|0)!=0)|0)+E|0;B=B+1|0;if((B|0)>=(x|0)){M=y;break}else E=y}}else M=0;if((M|0)==(w|0)){d0(d,i);break}else{f[o>>2]=0;f[o+4>>2]=0;F=tT(o,16)|0;G=447002;H=F+16|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,o,453206,446605,504)}}else N=32}else N=32;while(0);if((N|0)==32){f[m>>2]=-2147483648;f[m+4>>2]=2147483647;f[m+8>>2]=-2147483648;f[m+12>>2]=2147483647;f[m+16>>2]=-2147483648;f[m+20>>2]=2147483647;f[m+24>>2]=2;f[m+28>>2]=3;aT(t,f[i>>2]|0,m);p[q>>3]=0.0;f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;l_(t,o,e0()|0)|0;o=t+36|0;q=f[o>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)_S(t);f[o>>2]=0;o=t+16|0;q=t+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[q>>2]|0)>0){o=f[t+40>>2]|0;m=0;do{f[o+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[q>>2]|0))}q=f[t+44>>2]|0;if((q|0)!=(t+48|0))g0(q)}q=f[l>>2]|0;if(q|0){t=f[L>>2]|0;if((t|0)==(q|0))O=q;else{m=t;do{t=m+-12|0;f[L>>2]=t;pHa(t,f[m+-8>>2]|0);m=f[L>>2]|0}while((m|0)!=(q|0));O=f[l>>2]|0}YDc(O)}mx(k);k=f[j>>2]|0;if(k|0){O=f[c>>2]|0;if((O|0)==(k|0))P=k;else{l=O;do{O=l+-12|0;f[c>>2]=O;Pxb(O,f[l+-8>>2]|0);l=f[c>>2]|0}while((l|0)!=(k|0));P=f[j>>2]|0}YDc(P)}mx(i);mx(h);u=g;return}function Ixb(a,c){a=a|0;c=c|0;var d=0;switch(c|0){case 3:{d=1;break}case 2:{if((b[a+80>>0]|0)==0?(b[a+81>>0]|0)!=0:0)d=(b[a+82>>0]|0)==0;else d=0;break}default:d=0}return d|0}function Jxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Kxb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+32|0;d=g+16|0;h=g;i=f[c>>2]|0;j=i;if((((f[c+4>>2]|0)-i|0)/12|0)>>>0<=2){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,18)|0;l=446733;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,446605,209)}i=f[j>>2]|0;if((f[i>>2]|0)!=(f[f[j+12>>2]>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,28)|0;l=446752;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,446605,210)}c=f[j+24>>2]|0;n=(f[c+8>>2]|0)/4|0;o=Y(f[a+44>>2]<<2,n)|0;p=f[j+4>>2]|0;q=p-i|0;r=q>>2;if((i|0)!=(p|0)){if((q|0)<=0){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,70)|0;l=452744;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452815,452821,161)}if((q|0)>4){q=1;p=1;while(1){s=Y(f[i+(q<<2)>>2]|0,p)|0;q=q+1|0;if((q|0)>=(r|0)){t=s;break}else p=s}}else t=1}else t=0;if((o|0)!=(t|0)){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,55)|0;l=446781;m=k+55|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,446605,213)}t=Y(f[a+36>>2]|0,n)|0;n=f[j+16>>2]|0;o=f[j+12>>2]|0;j=n-o|0;p=j>>2;r=o;if((r|0)!=(n|0)){if((j|0)<=0){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,70)|0;l=452744;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452815,452821,161)}if((j|0)>4){j=1;n=1;while(1){o=Y(f[r+(j<<2)>>2]|0,n)|0;j=j+1|0;if((j|0)>=(p|0)){v=o;break}else n=o}}else v=1}else v=0;if((t|0)!=(v|0)){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,51)|0;l=446837;m=k+51|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,446605,214)}if((f[c+4>>2]|0)!=(2-(b[a+60>>0]|0)&255|0)){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,52)|0;l=446889;m=k+52|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,446605,215)}l=f[a+64>>2]|0;f[d>>2]=1;f[d+4>>2]=1;f[d+8>>2]=l;f[d+12>>2]=7;f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;lFa(h,d,d+16|0);d=f[h>>2]|0;a=f[l>>2]|0;a:do if((d|0)==(a|0)){w=d;x=24}else{k=d;do{if((f[k>>2]|0)<0){w=k;x=24;break a}k=k+4|0}while((k|0)!=(a|0))}while(0);if((x|0)==24?(w|0)!=(a|0):0){x=w+4|0;if((x|0)==(a|0)){y=a;z=w}else{d=x;x=w;while(1){w=f[d>>2]|0;if((w|0)<0)A=x;else{f[x>>2]=w;A=x+4|0}d=d+4|0;if((d|0)==(a|0))break;else x=A}y=f[l>>2]|0;z=A}if((z|0)!=(y|0))f[l>>2]=y+(~((y+-4-z|0)>>>2)<<2)}z=e+4|0;y=f[z>>2]|0;A=f[e>>2]|0;x=y-A|0;a=(x|0)/12|0;d=A;A=y;if(x){if(a>>>0>1?(x=d+12|0,(A|0)!=(x|0)):0){d=A;while(1){A=d+-12|0;f[z>>2]=A;y=f[A>>2]|0;if(!y)B=A;else{A=d+-8|0;w=f[A>>2]|0;if((w|0)!=(y|0))f[A>>2]=w+(~((w+-4-y|0)>>>2)<<2);YDc(y);B=f[z>>2]|0}if((B|0)==(x|0))break;else d=B}}}else npb(e,1-a|0,h);a=f[h>>2]|0;if(!a){u=g;return 0}h=f[l>>2]|0;if((h|0)!=(a|0))f[l>>2]=h+(~((h+-4-a|0)>>>2)<<2);YDc(a);u=g;return 0}function Lxb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;j=u;u=u+16|0;k=j;l=f[i>>2]|0;m=i+4|0;n=f[m>>2]|0;if((n|0)==(l|0))o=n;else{p=n;while(1){n=p+-12|0;f[m>>2]=n;Pxb(n,f[p+-8>>2]|0);n=f[m>>2]|0;if((n|0)==(l|0)){o=n;break}else p=n}}if(!((e|0)==1|g^1)){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,18)|0;l=447508;n=p+18|0;do{b[p>>0]=b[l>>0]|0;p=p+1|0;l=l+1|0}while((p|0)<(n|0));z5(-215,k,447527,446605,851)}k=f[i>>2]|0;l=(o-k|0)/12|0;p=k;if(l>>>0>=c>>>0){if(l>>>0>c>>>0?(k=p+(c*12|0)|0,(o|0)!=(k|0)):0){p=o;do{o=p+-12|0;f[m>>2]=o;Pxb(o,f[p+-8>>2]|0);p=f[m>>2]|0}while((p|0)!=(k|0))}}else ryb(i,c-l|0);if((c|0)<=0){u=j;return}l=(d|0)>0;k=Y(d<<2,e)|0;p=(e|0)>0;m=a;a=0;while(1){o=f[i>>2]|0;n=o+(a*12|0)|0;if(l){q=o+(a*12|0)+4|0;r=o+(a*12|0)+4|0;s=o+(a*12|0)+8|0;o=0;do{t=Y(o,e)|0;if(p){v=0;do{w=g?-1:v;x=f[q>>2]|0;do if(x){y=q;z=x;a:while(1){A=z;while(1){if((f[A+16>>2]|0)>=(w|0))break;B=f[A+4>>2]|0;if(!B){C=y;break a}else A=B}z=f[A>>2]|0;if(!z){C=A;break}else y=A}if((C|0)!=(q|0)?(w|0)>=(f[C+16>>2]|0):0)break;y=r;z=x;B=x;while(1){D=f[z+16>>2]|0;if((w|0)<(D|0)){E=f[z>>2]|0;if(!E){F=29;break}else{G=z;H=E}}else{if((D|0)>=(w|0)){F=33;break}I=z+4|0;D=f[I>>2]|0;if(!D){F=32;break}else{G=I;H=D}}y=G;z=H;B=H}if((F|0)==29){F=0;J=z;K=z;F=34;break}else if((F|0)==32){F=0;J=I;K=z;F=34;break}else if((F|0)==33){F=0;if(!B){J=y;K=z;F=34;break}else{L=B;F=37;break}}}else{J=q;K=q;F=34}while(0);if((F|0)==34){F=0;x=VDc(32)|0;f[x+16>>2]=w;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=K;f[J>>2]=x;D=f[f[n>>2]>>2]|0;if(!D)M=x;else{f[n>>2]=D;M=f[J>>2]|0}laa(f[r>>2]|0,M);f[s>>2]=(f[s>>2]|0)+1;L=x;F=37}do if((F|0)==37){F=0;x=L+20|0;D=L+24|0;E=f[D>>2]|0;N=f[x>>2]|0;O=(E-N|0)/24|0;P=E;if(O>>>0<d>>>0){tyb(x,d-O|0);break}if(O>>>0>d>>>0?(O=N+(d*24|0)|0,(P|0)!=(O|0)):0)f[D>>2]=P+(~(((P+-24-O|0)>>>0)/24|0)*24|0)}while(0);O=f[q>>2]|0;do if(O){P=r;D=O;N=O;while(1){x=f[D+16>>2]|0;if((w|0)<(x|0)){E=f[D>>2]|0;if(!E){F=46;break}else{Q=D;R=E}}else{if((x|0)>=(w|0)){F=50;break}S=D+4|0;x=f[S>>2]|0;if(!x){F=49;break}else{Q=S;R=x}}P=Q;D=R;N=R}if((F|0)==46){F=0;T=D;U=D;F=52;break}else if((F|0)==49){F=0;T=S;U=D;F=52;break}else if((F|0)==50){F=0;V=P;W=D;X=N;F=51;break}}else{V=q;W=q;X=O;F=51}while(0);if((F|0)==51){F=0;if(!X){T=V;U=W;F=52}else Z=X}if((F|0)==52){F=0;O=VDc(32)|0;f[O+16>>2]=w;f[O+20>>2]=0;f[O+24>>2]=0;f[O+28>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=U;f[T>>2]=O;B=f[f[n>>2]>>2]|0;if(!B)_=O;else{f[n>>2]=B;_=f[T>>2]|0}laa(f[r>>2]|0,_);f[s>>2]=(f[s>>2]|0)+1;Z=O}O=f[Z+20>>2]|0;B=O+(o*24|0)|0;z=v+t<<2;y=f[m+(z<<2)>>2]|0;x=z|1;E=z|2;if(h){f[O+(o*24|0)+4>>2]=y;f[B>>2]=f[m+(x<<2)>>2];f[O+(o*24|0)+12>>2]=f[m+(E<<2)>>2];$=O+(o*24|0)+8|0}else{f[B>>2]=y;f[O+(o*24|0)+4>>2]=f[m+(x<<2)>>2];f[O+(o*24|0)+8>>2]=f[m+(E<<2)>>2];$=O+(o*24|0)+12|0}f[$>>2]=f[m+((z|3)<<2)>>2];v=v+1|0}while((v|0)!=(e|0))}o=o+1|0}while((o|0)!=(d|0))}a=a+1|0;if((a|0)==(c|0))break;else m=m+(k<<2)|0}u=j;return}function Mxb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+64|0;h=g+56|0;i=g;f[h>>2]=d;f[h+4>>2]=c;j=(b|0)>0;if(!j){u=g;return}k=i+4|0;l=i+8|0;m=i+40|0;n=i+48|0;o=i+44|0;p=i+52|0;q=e+4|0;r=e+8|0;s=i+36|0;t=i+16|0;v=i+12|0;w=i+20|0;x=i+24|0;y=i+28|0;z=i+32|0;A=0;do{f[i>>2]=1124007936;B=k;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[m>>2]=l;f[o>>2]=n;f[n>>2]=0;f[p>>2]=0;XS(i,2,h,5);B=f[q>>2]|0;if((B|0)==(f[r>>2]|0))Bxa(e,i);else{f[B>>2]=f[i>>2];C=B+4|0;f[C>>2]=f[k>>2];D=B+8|0;f[D>>2]=f[l>>2];f[B+12>>2]=f[v>>2];f[B+16>>2]=f[t>>2];f[B+20>>2]=f[w>>2];f[B+24>>2]=f[x>>2];f[B+28>>2]=f[y>>2];f[B+32>>2]=f[z>>2];E=f[s>>2]|0;f[B+36>>2]=E;f[B+40>>2]=D;D=B+48|0;F=B+44|0;f[F>>2]=D;f[D>>2]=0;f[B+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[k>>2]|0)<3){D=f[o>>2]|0;E=f[F>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[C>>2]=0;ZS(B,i)}f[q>>2]=(f[q>>2]|0)+56}B=f[s>>2]|0;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)_S(i);f[s>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[k>>2]|0)>0){B=f[m>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[k>>2]|0))}C=f[o>>2]|0;if((C|0)!=(n|0))g0(C);A=A+1|0}while((A|0)<(b|0));if(!j){u=g;return}j=i+4|0;A=i+8|0;n=i+12|0;o=i+16|0;k=i+20|0;m=i+24|0;t=i+28|0;s=i+32|0;q=i+36|0;z=i+40|0;y=i+48|0;x=i+44|0;w=i+52|0;v=(d|0)>0;l=(c|0)>0;r=Y(d,c)|0;h=0;p=a;while(1){a=f[e>>2]|0;C=a+(h*56|0)|0;f[i>>2]=f[C>>2];B=a+(h*56|0)+4|0;f[j>>2]=f[B>>2];f[A>>2]=f[a+(h*56|0)+8>>2];f[n>>2]=f[a+(h*56|0)+12>>2];f[o>>2]=f[a+(h*56|0)+16>>2];f[k>>2]=f[a+(h*56|0)+20>>2];f[m>>2]=f[a+(h*56|0)+24>>2];f[t>>2]=f[a+(h*56|0)+28>>2];f[s>>2]=f[a+(h*56|0)+32>>2];D=f[a+(h*56|0)+36>>2]|0;f[q>>2]=D;f[z>>2]=A;f[x>>2]=y;f[y>>2]=0;f[w>>2]=0;if(D|0){E=D+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[B>>2]|0)<3){B=f[a+(h*56|0)+44>>2]|0;a=f[x>>2]|0;f[a>>2]=f[B>>2];f[a+4>>2]=f[B+4>>2]}else{f[j>>2]=0;ZS(i,C)}if(v?(C=f[o>>2]|0,l):0){B=f[f[x>>2]>>2]|0;a=0;do{E=C+(Y(B,a)|0)|0;D=0;do{F=p+((Y(D,d)|0)+a<<2)|0;f[E+(D<<2)>>2]=f[F>>2];D=D+1|0}while((D|0)!=(c|0));a=a+1|0}while((a|0)!=(d|0))}a=f[q>>2]|0;if(a|0?(B=a+12|0,a=f[B>>2]|0,f[B>>2]=a+-1,(a|0)==1):0)_S(i);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[j>>2]|0)>0){a=f[z>>2]|0;B=0;do{f[a+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[j>>2]|0))}B=f[x>>2]|0;if((B|0)!=(y|0))g0(B);h=h+1|0;if((h|0)==(b|0))break;else p=p+(r<<2)|0}u=g;return}function Nxb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[e>>2]|0;i=e+4|0;j=f[i>>2]|0;k=h;if((j|0)==(h|0))l=j;else{m=j+(~(((j+-24-k|0)>>>0)/24|0)*24|0)|0;f[i>>2]=m;l=m}m=f[c>>2]|0;j=(l-k|0)/24|0;if(m>>>0<=j>>>0){if(m>>>0<j>>>0?(k=h+(m*24|0)|0,(l|0)!=(k|0)):0)f[i>>2]=l+(~(((l+-24-k|0)>>>0)/24|0)*24|0)}else tyb(e,m-j|0);j=f[g>>2]|0;m=g+4|0;k=f[m>>2]|0;if((k|0)==(j|0)){o=k;p=j}else{l=k;while(1){k=l+-12|0;f[m>>2]=k;i=f[k>>2]|0;if(!i)q=k;else{k=l+-8|0;h=f[k>>2]|0;if((h|0)!=(i|0))f[k>>2]=h+(~((h+-4-i|0)>>>2)<<2);YDc(i);q=f[m>>2]|0}if((q|0)==(j|0))break;else l=q}o=q;p=f[g>>2]|0}q=f[c>>2]|0;l=(o-p|0)/12|0;j=p;if(q>>>0<=l>>>0){if(q>>>0<l>>>0?(p=j+(q*12|0)|0,(o|0)!=(p|0)):0){j=o;while(1){o=j+-12|0;f[m>>2]=o;i=f[o>>2]|0;if(!i)r=o;else{o=j+-8|0;h=f[o>>2]|0;if((h|0)!=(i|0))f[o>>2]=h+(~((h+-4-i|0)>>>2)<<2);YDc(i);r=f[m>>2]|0}if((r|0)==(p|0))break;else j=r}}}else zyb(g,q-l|0);l=f[c>>2]|0;q=(l|0)>0;if(!q)return;r=f[e>>2]|0;if(d){d=0;do{e=d<<2;j=f[a+(e<<2)>>2]|0;f[r+(d*24|0)>>2]=j;p=f[a+((e|1)<<2)>>2]|0;f[r+(d*24|0)+4>>2]=p;m=f[a+((e|2)<<2)>>2]|0;f[r+(d*24|0)+8>>2]=m;i=f[a+((e|3)<<2)>>2]|0;f[r+(d*24|0)+12>>2]=i;t=(f[s>>2]=m,+n[s>>2]);u=(f[s>>2]=j,+n[s>>2]);v=(f[s>>2]=i,+n[s>>2]);w=(f[s>>2]=p,+n[s>>2]);do if(!(t<u|v<w))if(!(b[r+(d*24|0)+16>>0]|0)){x=(t-u)*(v-w);break}else{x=+n[r+(d*24|0)+20>>2];break}else x=0.0;while(0);n[r+(d*24|0)+20>>2]=x;b[r+(d*24|0)+16>>0]=1;d=d+1|0}while((d|0)<(l|0))}else{d=0;do{p=d<<2;i=f[a+(p<<2)>>2]|0;f[r+(d*24|0)>>2]=i;j=f[a+((p|1)<<2)>>2]|0;f[r+(d*24|0)+4>>2]=j;m=f[a+((p|2)<<2)>>2]|0;f[r+(d*24|0)+8>>2]=m;e=f[a+((p|3)<<2)>>2]|0;f[r+(d*24|0)+12>>2]=e;x=(f[s>>2]=m,+n[s>>2]);w=(f[s>>2]=i,+n[s>>2]);v=(f[s>>2]=e,+n[s>>2]);u=(f[s>>2]=j,+n[s>>2]);do if(!(x<w|v<u))if(!(b[r+(d*24|0)+16>>0]|0)){y=(x-w+1.0)*(v-u+1.0);break}else{y=+n[r+(d*24|0)+20>>2];break}else y=0.0;while(0);n[r+(d*24|0)+20>>2]=y;b[r+(d*24|0)+16>>0]=1;d=d+1|0}while((d|0)<(l|0))}if(q){z=0;A=l}else return;do{l=A+z<<2;q=f[g>>2]|0;d=a+(l<<2)|0;r=q+(z*12|0)+4|0;j=f[r>>2]|0;e=f[q+(z*12|0)+8>>2]|0;if((j|0)==(e|0)){osb(q+(z*12|0)|0,d);i=f[g>>2]|0;B=f[i+(z*12|0)+4>>2]|0;C=f[i+(z*12|0)+8>>2]|0;D=i}else{f[j>>2]=f[d>>2];d=j+4|0;f[r>>2]=d;B=d;C=e;D=q}q=a+((l|1)<<2)|0;if((B|0)==(C|0)){osb(D+(z*12|0)|0,q);e=f[g>>2]|0;E=f[e+(z*12|0)+4>>2]|0;F=f[e+(z*12|0)+8>>2]|0;G=e}else{f[B>>2]=f[q>>2];q=B+4|0;f[D+(z*12|0)+4>>2]=q;E=q;F=C;G=D}q=a+((l|2)<<2)|0;if((E|0)==(F|0)){osb(G+(z*12|0)|0,q);e=f[g>>2]|0;H=f[e+(z*12|0)+4>>2]|0;I=f[e+(z*12|0)+8>>2]|0;J=e}else{f[E>>2]=f[q>>2];q=E+4|0;f[G+(z*12|0)+4>>2]=q;H=q;I=F;J=G}q=a+((l|3)<<2)|0;if((H|0)==(I|0))osb(J+(z*12|0)|0,q);else{f[H>>2]=f[q>>2];f[J+(z*12|0)+4>>2]=H+4}z=z+1|0;A=f[c>>2]|0}while((z|0)<(A|0));return}function Oxb(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;p=u;u=u+16|0;q=p;r=p+8|0;if((((f[a+4>>2]|0)-(f[a>>2]|0)|0)/12|0|0)!=(e|0)){f[r>>2]=0;f[r+4>>2]=0;s=tT(r,27)|0;t=447260;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,r,447288,446605,776)}t=f[o>>2]|0;s=o+4|0;v=f[s>>2]|0;if((v|0)==(t|0)){w=v;x=t}else{y=v;do{v=y+-12|0;f[s>>2]=v;Pxb(v,f[y+-8>>2]|0);y=f[s>>2]|0}while((y|0)!=(t|0));w=y;x=f[o>>2]|0}y=(w-x|0)/12|0;t=x;if(y>>>0>=e>>>0){if(y>>>0>e>>>0?(x=t+(e*12|0)|0,(w|0)!=(x|0)):0){t=w;do{w=t+-12|0;f[s>>2]=w;Pxb(w,f[t+-8>>2]|0);t=f[s>>2]|0}while((t|0)!=(x|0))}}else ryb(o,e-y|0);if((e|0)<=0){u=p;return}y=(h|0)>0;x=(i|0)==-1;t=0;a:while(1){s=f[o>>2]|0;w=s+(t*12|0)|0;if(y){v=(f[a>>2]|0)+(t*12|0)+4|0;z=s+(t*12|0)+4|0;A=s+(t*12|0)+4|0;B=s+(t*12|0)+8|0;if(g){s=0;do{if(!x){C=f[v>>2]|0;if(!C){D=-1;E=49;break a}else{F=v;G=C}b:while(1){C=G;while(1){if((f[C+16>>2]|0)>=-1)break;H=f[C+4>>2]|0;if(!H){I=F;break b}else C=H}G=f[C>>2]|0;if(!G){I=C;break}else F=C}if((I|0)==(v|0)){D=-1;E=49;break a}if((f[I+16>>2]|0)>-1){D=-1;E=49;break a}H=I+20|0;J=f[z>>2]|0;do if(J){K=A;L=J;M=J;while(1){N=f[L+16>>2]|0;if((N|0)>-1){O=f[L>>2]|0;if(!O){E=33;break}else{P=L;Q=O}}else{if((N|0)==-1){E=28;break}R=L+4|0;N=f[R>>2]|0;if(!N){E=30;break}else{P=R;Q=N}}K=P;L=Q;M=Q}if((E|0)==28){E=0;S=K;T=L;U=M;E=34;break}else if((E|0)==30){E=0;V=R;W=L;E=35;break}else if((E|0)==33){E=0;V=L;W=L;E=35;break}}else{S=z;T=z;U=J;E=34}while(0);if((E|0)==34){E=0;if(!U){V=S;W=T;E=35}else X=U}if((E|0)==35){E=0;J=VDc(32)|0;f[J+16>>2]=-1;f[J+20>>2]=0;f[J+24>>2]=0;f[J+28>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=W;f[V>>2]=J;C=f[f[w>>2]>>2]|0;if(!C)Y=J;else{f[w>>2]=C;Y=f[V>>2]|0}laa(f[A>>2]|0,Y);f[B>>2]=(f[B>>2]|0)+1;X=J}syb(c,d,j,k,l,m,n,H,X+20|0)}s=s+1|0}while((s|0)<(h|0))}else{s=0;do{if((s|0)!=(i|0)){J=f[v>>2]|0;if(!J){D=s;E=49;break a}else{Z=v;_=J}c:while(1){J=_;while(1){if((f[J+16>>2]|0)>=(s|0))break;C=f[J+4>>2]|0;if(!C){$=Z;break c}else J=C}_=f[J>>2]|0;if(!_){$=J;break}else Z=J}if(($|0)==(v|0)){D=s;E=49;break a}if((s|0)<(f[$+16>>2]|0)){D=s;E=49;break a}H=$+20|0;L=f[z>>2]|0;do if(L){M=A;K=L;C=L;while(1){N=f[K+16>>2]|0;if((s|0)<(N|0)){O=f[K>>2]|0;if(!O){E=54;break}else{aa=K;ba=O}}else{if((N|0)>=(s|0)){E=58;break}ca=K+4|0;N=f[ca>>2]|0;if(!N){E=57;break}else{aa=ca;ba=N}}M=aa;K=ba;C=ba}if((E|0)==54){E=0;da=K;ea=K;E=60;break}else if((E|0)==57){E=0;da=ca;ea=K;E=60;break}else if((E|0)==58){E=0;fa=M;ga=K;ha=C;E=59;break}}else{fa=z;ga=z;ha=L;E=59}while(0);if((E|0)==59){E=0;if(!ha){da=fa;ea=ga;E=60}else ia=ha}if((E|0)==60){E=0;L=VDc(32)|0;f[L+16>>2]=s;f[L+20>>2]=0;f[L+24>>2]=0;f[L+28>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=ea;f[da>>2]=L;J=f[f[w>>2]>>2]|0;if(!J)ja=L;else{f[w>>2]=J;ja=f[da>>2]|0}laa(f[A>>2]|0,ja);f[B>>2]=(f[B>>2]|0)+1;ia=L}syb(c,d,j,k,l,m,n,H,ia+20|0)}s=s+1|0}while((s|0)<(h|0))}}t=t+1|0;if((t|0)>=(e|0)){E=14;break}}if((E|0)==14){u=p;return}else if((E|0)==49){f[q>>2]=D;F5(r,447088,q);z5(-2,r,447288,446605,791)}}function Pxb(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;Pxb(a,f[b>>2]|0);Pxb(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0){c=b+24|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~(((d+-24-a|0)>>>0)/24|0)*24|0);YDc(a)}YDc(b);return}function Qxb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0;g=u;u=u+208|0;h=g+192|0;i=g+16|0;j=g+8|0;k=g;l=g+184|0;m=g+172|0;o=g+168|0;p=g+44|0;q=g+112|0;r=g+32|0;s=g+56|0;t=g+20|0;v=p+4|0;f[v>>2]=0;w=p+8|0;f[w>>2]=0;x=p+4|0;f[p>>2]=x;y=a+36|0;z=f[y>>2]|0;do if((z|0)>0){A=a+48|0;B=d+8|0;C=h+4|0;D=l+4|0;E=m+4|0;F=m+8|0;G=h+8|0;H=h+4|0;I=q+36|0;J=q+16|0;K=q+4|0;L=q+40|0;M=q+44|0;N=q+48|0;O=a+40|0;P=c+4|0;Q=a+81|0;R=a+68|0;S=a+72|0;T=a+76|0;U=h+4|0;V=h+8|0;W=h+4|0;X=h+8|0;Y=0;Z=z;_=0;while(1){if((_|0)==(f[A>>2]|0)){$=Y;aa=_+1|0;ba=Z}else{if((_|0)>=(f[B>>2]|0)){ca=7;break}da=_+1|0;f[h>>2]=_;f[C>>2]=da;f[l>>2]=-2147483648;f[D>>2]=2147483647;$S(q,d,h,l);f[m>>2]=0;f[E>>2]=0;f[F>>2]=0;ea=G;f[ea>>2]=0;f[ea+4>>2]=0;f[h>>2]=-2113732603;f[H>>2]=m;h_(q,h);ea=f[I>>2]|0;if(ea|0?(fa=ea+12|0,ea=f[fa>>2]|0,f[fa>>2]=ea+-1,(ea|0)==1):0)_S(q);f[I>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[K>>2]|0)>0){ea=f[L>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[K>>2]|0))}fa=f[M>>2]|0;if((fa|0)!=(N|0))g0(fa);ga=b[O>>0]|0?-1:_;fa=f[P>>2]|0;if(!fa){ca=23;break}else{ha=P;ia=fa}a:while(1){fa=ia;while(1){if((f[fa+16>>2]|0)>=(ga|0))break;ea=f[fa+4>>2]|0;if(!ea){ja=ha;break a}else fa=ea}ia=f[fa>>2]|0;if(!ia){ja=fa;break}else ha=fa}if((ja|0)==(P|0)){ca=23;break}if((ga|0)<(f[ja+16>>2]|0)){ca=23;break}ea=ja+20|0;ka=+n[R>>2];la=+n[S>>2];ma=f[T>>2]|0;na=f[x>>2]|0;oa=(na|0)==0;if(!(b[Q>>0]|0)){do if(!oa){pa=v;qa=na;ra=na;while(1){sa=f[qa+16>>2]|0;if((_|0)<(sa|0)){ta=f[qa>>2]|0;if(!ta){ca=62;break}else{ua=qa;va=ta}}else{if((sa|0)>=(_|0)){ca=66;break}wa=qa+4|0;sa=f[wa>>2]|0;if(!sa){ca=65;break}else{ua=wa;va=sa}}pa=ua;qa=va;ra=va}if((ca|0)==62){ca=0;xa=qa;ya=qa;ca=68;break}else if((ca|0)==65){ca=0;xa=wa;ya=qa;ca=68;break}else if((ca|0)==66){ca=0;za=pa;Aa=qa;Ba=ra;ca=67;break}}else{za=x;Aa=x;Ba=na;ca=67}while(0);if((ca|0)==67){ca=0;if(!Ba){xa=za;ya=Aa;ca=68}else Ca=Ba}if((ca|0)==68){ca=0;fa=VDc(32)|0;f[fa+16>>2]=_;f[fa+20>>2]=0;f[fa+24>>2]=0;f[fa+28>>2]=0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=ya;f[xa>>2]=fa;sa=f[f[p>>2]>>2]|0;if(!sa)Da=fa;else{f[p>>2]=sa;Da=f[xa>>2]|0}laa(f[v>>2]|0,Da);f[w>>2]=(f[w>>2]|0)+1;Ca=fa}fa=Ca+20|0;if((((f[ja+24>>2]|0)-(f[ea>>2]|0)|0)/24|0|0)!=((f[E>>2]|0)-(f[m>>2]|0)>>2|0)){ca=72;break}f[h>>2]=0;f[U>>2]=0;f[V>>2]=0;Zxb(m,ka,ma,h);sa=f[fa>>2]|0;ta=Ca+24|0;Ea=f[ta>>2]|0;Fa=sa;Ga=Ea+(~((Ea+-4-Fa|0)>>>2)<<2)|0;if((Ea|0)==(sa|0))Ha=sa;else{f[ta>>2]=Ga;Ha=Ga}Ga=f[U>>2]|0;Ea=f[h>>2]|0;Ia=Ea;b:do if((Ga|0)==(Ea|0)){Ja=Ga;Ka=Ia}else{La=Ca+28|0;Ma=0;Na=Ia;Oa=Fa;Pa=Ha;Qa=Ha;Ra=sa;while(1){Sa=f[Na+(Ma<<3)+4>>2]|0;f[l>>2]=Sa;if((Pa-Oa|0)>0){Ta=0;Ua=Ra;Va=Sa;while(1){Sa=f[ea>>2]|0;Wa=+$xb(Sa+(Va*24|0)|0,Sa+((f[Ua+(Ta<<2)>>2]|0)*24|0)|0)<=la;Sa=Ta+1|0;Xa=f[ta>>2]|0;Ya=f[fa>>2]|0;if(!(Wa&(Sa|0)<(Xa-Ya>>2|0)))break;Ta=Sa;Ua=Ya;Va=f[l>>2]|0}if(Wa){Za=Xa;ca=85}}else{Za=Qa;ca=85}do if((ca|0)==85){ca=0;if((Za|0)==(f[La>>2]|0)){g6(fa,l);break}else{f[Za>>2]=f[l>>2];f[ta>>2]=Za+4;break}}while(0);Va=Ma+1|0;Ua=f[U>>2]|0;Ta=f[h>>2]|0;Ya=Ta;if(Va>>>0>=Ua-Ta>>3>>>0){Ja=Ua;Ka=Ya;break b}Ua=f[ta>>2]|0;Ta=f[fa>>2]|0;Ma=Va;Na=Ya;Oa=Ta;Pa=Ua;Qa=Ua;Ra=Ta}}while(0);fa=Ja;if(Ka|0){if((fa|0)!=(Ka|0))f[U>>2]=fa+(~((fa+-8-Ka|0)>>>3)<<3);YDc(Ka)}}else{do if(!oa){fa=v;ta=na;sa=na;while(1){Fa=f[ta+16>>2]|0;if((_|0)<(Fa|0)){Ia=f[ta>>2]|0;if(!Ia){ca=29;break}else{_a=ta;$a=Ia}}else{if((Fa|0)>=(_|0)){ca=33;break}ab=ta+4|0;Fa=f[ab>>2]|0;if(!Fa){ca=32;break}else{_a=ab;$a=Fa}}fa=_a;ta=$a;sa=$a}if((ca|0)==29){ca=0;bb=ta;cb=ta;ca=35;break}else if((ca|0)==32){ca=0;bb=ab;cb=ta;ca=35;break}else if((ca|0)==33){ca=0;db=fa;eb=ta;fb=sa;ca=34;break}}else{db=x;eb=x;fb=na;ca=34}while(0);if((ca|0)==34){ca=0;if(!fb){bb=db;cb=eb;ca=35}else gb=fb}if((ca|0)==35){ca=0;na=VDc(32)|0;f[na+16>>2]=_;f[na+20>>2]=0;f[na+24>>2]=0;f[na+28>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=cb;f[bb>>2]=na;oa=f[f[p>>2]>>2]|0;if(!oa)hb=na;else{f[p>>2]=oa;hb=f[bb>>2]|0}laa(f[v>>2]|0,hb);f[w>>2]=(f[w>>2]|0)+1;gb=na}na=gb+20|0;if((((f[ja+24>>2]|0)-(f[ea>>2]|0)|0)/24|0|0)!=((f[E>>2]|0)-(f[m>>2]|0)>>2|0)){ca=39;break}f[h>>2]=0;f[W>>2]=0;f[X>>2]=0;Zxb(m,ka,ma,h);oa=f[na>>2]|0;Fa=gb+24|0;Ia=f[Fa>>2]|0;Ga=oa;Ea=Ia+(~((Ia+-4-Ga|0)>>>2)<<2)|0;if((Ia|0)==(oa|0))ib=oa;else{f[Fa>>2]=Ea;ib=Ea}Ea=f[W>>2]|0;Ia=f[h>>2]|0;Ra=Ia;c:do if((Ea|0)==(Ia|0)){jb=Ea;kb=Ra}else{Qa=gb+28|0;Pa=0;Oa=Ra;Na=Ga;Ma=ib;La=ib;ra=oa;while(1){qa=f[Oa+(Pa<<3)+4>>2]|0;f[l>>2]=qa;if((Ma-Na|0)>0){pa=0;Ta=ra;Ua=qa;while(1){qa=f[ea>>2]|0;lb=+_xb(qa+(Ua*24|0)|0,qa+((f[Ta+(pa<<2)>>2]|0)*24|0)|0)<=la;qa=pa+1|0;mb=f[Fa>>2]|0;Ya=f[na>>2]|0;if(!(lb&(qa|0)<(mb-Ya>>2|0)))break;pa=qa;Ta=Ya;Ua=f[l>>2]|0}if(lb){nb=mb;ca=52}}else{nb=La;ca=52}do if((ca|0)==52){ca=0;if((nb|0)==(f[Qa>>2]|0)){g6(na,l);break}else{f[nb>>2]=f[l>>2];f[Fa>>2]=nb+4;break}}while(0);Ua=Pa+1|0;Ta=f[W>>2]|0;pa=f[h>>2]|0;Ya=pa;if(Ua>>>0>=Ta-pa>>3>>>0){jb=Ta;kb=Ya;break c}Ta=f[Fa>>2]|0;pa=f[na>>2]|0;Pa=Ua;Oa=Ya;Na=pa;Ma=Ta;La=Ta;ra=pa}}while(0);na=jb;if(kb|0){if((na|0)!=(kb|0))f[W>>2]=na+(~((na+-8-kb|0)>>>3)<<3);YDc(kb)}}na=f[x>>2]|0;do if(na){Fa=v;ea=na;oa=na;while(1){Ga=f[ea+16>>2]|0;if((_|0)<(Ga|0)){Ra=f[ea>>2]|0;if(!Ra){ca=95;break}else{ob=ea;pb=Ra}}else{if((Ga|0)>=(_|0)){ca=99;break}qb=ea+4|0;Ga=f[qb>>2]|0;if(!Ga){ca=98;break}else{ob=qb;pb=Ga}}Fa=ob;ea=pb;oa=pb}if((ca|0)==95){ca=0;rb=ea;sb=ea;ca=101;break}else if((ca|0)==98){ca=0;rb=qb;sb=ea;ca=101;break}else if((ca|0)==99){ca=0;tb=Fa;ub=ea;vb=oa;ca=100;break}}else{tb=x;ub=x;vb=na;ca=100}while(0);if((ca|0)==100){ca=0;if(!vb){rb=tb;sb=ub;ca=101}else wb=vb}if((ca|0)==101){ca=0;na=VDc(32)|0;f[na+16>>2]=_;f[na+20>>2]=0;f[na+24>>2]=0;f[na+28>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=sb;f[rb>>2]=na;Ga=f[f[p>>2]>>2]|0;if(!Ga)xb=na;else{f[p>>2]=Ga;xb=f[rb>>2]|0}laa(f[v>>2]|0,xb);f[w>>2]=(f[w>>2]|0)+1;wb=na}na=(f[wb+24>>2]|0)-(f[wb+20>>2]|0)>>2;Ga=f[m>>2]|0;if(Ga|0){Ra=f[E>>2]|0;if((Ra|0)!=(Ga|0))f[E>>2]=Ra+(~((Ra+-4-Ga|0)>>>2)<<2);YDc(Ga)}$=na+Y|0;aa=da;ba=f[y>>2]|0}if((aa|0)<(ba|0)){Y=$;Z=ba;_=aa}else{ca=3;break}}if((ca|0)==3){Z=a+64|0;Y=f[Z>>2]|0;if(!((Y|0)>-1&$>>>0>Y>>>0)){yb=$;break}f[r>>2]=0;Y=r+4|0;f[Y>>2]=0;f[r+8>>2]=0;E=f[p>>2]|0;do if((E|0)!=(x|0)){W=d+8|0;X=h+4|0;U=l+4|0;V=m+4|0;Q=m+8|0;T=h+8|0;S=h+4|0;R=s+36|0;P=s+16|0;O=s+4|0;N=s+40|0;M=s+44|0;K=s+48|0;L=h+4|0;J=h+8|0;I=r+8|0;H=E;d:while(1){zb=f[H+16>>2]|0;G=H+20|0;if((zb|0)>=(f[W>>2]|0)){ca=115;break}f[h>>2]=zb;f[X>>2]=zb+1;f[l>>2]=-2147483648;f[U>>2]=2147483647;$S(s,d,h,l);f[m>>2]=0;f[V>>2]=0;f[Q>>2]=0;F=T;f[F>>2]=0;f[F+4>>2]=0;f[h>>2]=-2113732603;f[S>>2]=m;h_(s,h);F=f[R>>2]|0;if(F|0?(D=F+12|0,F=f[D>>2]|0,f[D>>2]=F+-1,(F|0)==1):0)_S(s);f[R>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[O>>2]|0)>0){F=f[N>>2]|0;D=0;do{f[F+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[O>>2]|0))}D=f[M>>2]|0;if((D|0)!=(K|0))g0(D);D=H+24|0;F=f[G>>2]|0;if((f[D>>2]|0)!=(F|0)){oa=0;ea=F;do{F=f[ea+(oa<<2)>>2]|0;Fa=f[m>>2]|0;if(F>>>0>=(f[V>>2]|0)-Fa>>2>>>0){ca=130;break d}f[h>>2]=f[Fa+(F<<2)>>2];f[L>>2]=zb;f[J>>2]=F;F=f[Y>>2]|0;if((F|0)==(f[I>>2]|0))cyb(r,h);else{f[F>>2]=f[h>>2];f[F+4>>2]=f[h+4>>2];f[F+8>>2]=f[h+8>>2];f[Y>>2]=(f[Y>>2]|0)+12}oa=oa+1|0;ea=f[G>>2]|0}while(oa>>>0<(f[D>>2]|0)-ea>>2>>>0)}ea=f[m>>2]|0;if(ea|0){D=f[V>>2]|0;if((D|0)!=(ea|0))f[V>>2]=D+(~((D+-4-ea|0)>>>2)<<2);YDc(ea)}ea=f[H+4>>2]|0;if(!ea){D=H+8|0;oa=f[D>>2]|0;if((f[oa>>2]|0)==(H|0))Ab=oa;else{oa=D;do{D=f[oa>>2]|0;oa=D+8|0;G=f[oa>>2]|0}while((f[G>>2]|0)!=(D|0));Ab=G}}else{oa=ea;while(1){G=f[oa>>2]|0;if(!G)break;else oa=G}Ab=oa}if((Ab|0)==(x|0)){ca=112;break}else H=Ab}if((ca|0)==112){Bb=f[r>>2]|0;Cb=f[Y>>2]|0;break}else if((ca|0)==115){f[i>>2]=zb;F5(h,447088,i);z5(-2,h,447137,446605,609)}else if((ca|0)==130){f[h>>2]=0;f[h+4>>2]=0;Db=tT(h,19)|0;Eb=447240;Fb=Db+19|0;do{b[Db>>0]=b[Eb>>0]|0;Db=Db+1|0;Eb=Eb+1|0}while((Db|0)<(Fb|0));z5(-215,h,447137,446605,614)}}else{Bb=0;Cb=0}while(0);f[h>>2]=541;byb(Bb,Cb,h);E=f[Z>>2]|0;H=f[Y>>2]|0;V=f[r>>2]|0;I=(H-V|0)/12|0;J=V;L=H;if(E>>>0<=I>>>0)if(E>>>0<I>>>0?(K=J+(E*12|0)|0,(L|0)!=(K|0)):0){M=L+(~(((L+-12-K|0)>>>0)/12|0)*12|0)|0;f[Y>>2]=M;Gb=M;Hb=V;Ib=J}else{Gb=H;Hb=V;Ib=J}else{dyb(r,E-I|0);I=f[r>>2]|0;Gb=f[Y>>2]|0;Hb=I;Ib=I}I=t+4|0;f[I>>2]=0;E=t+8|0;f[E>>2]=0;J=t+4|0;f[t>>2]=J;e:do if((Gb|0)!=(Hb|0)){V=0;H=Ib;M=0;K=0;while(1){L=f[H+(V*12|0)+4>>2]|0;f[h>>2]=f[H+(V*12|0)+8>>2];do if(M){O=I;N=M;P=K;while(1){R=f[N+16>>2]|0;if((L|0)<(R|0)){S=f[N>>2]|0;if(!S){ca=166;break}else{Jb=N;Kb=S}}else{if((R|0)>=(L|0)){ca=170;break}Lb=N+4|0;R=f[Lb>>2]|0;if(!R){ca=169;break}else{Jb=Lb;Kb=R}}O=Jb;N=Kb;P=Kb}if((ca|0)==166){ca=0;Mb=N;Nb=N;ca=172;break}else if((ca|0)==169){ca=0;Mb=Lb;Nb=N;ca=172;break}else if((ca|0)==170){ca=0;Ob=O;Pb=N;Qb=P;ca=171;break}}else{Ob=J;Pb=J;Qb=K;ca=171}while(0);if((ca|0)==171){ca=0;if(!Qb){Mb=Ob;Nb=Pb;ca=172}else Rb=Qb}if((ca|0)==172){ca=0;oa=VDc(32)|0;f[oa+16>>2]=L;f[oa+20>>2]=0;f[oa+24>>2]=0;f[oa+28>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=Nb;f[Mb>>2]=oa;R=f[f[t>>2]>>2]|0;if(!R)Sb=oa;else{f[t>>2]=R;Sb=f[Mb>>2]|0}laa(f[I>>2]|0,Sb);f[E>>2]=(f[E>>2]|0)+1;Rb=oa}oa=Rb+24|0;R=f[oa>>2]|0;if((R|0)==(f[Rb+28>>2]|0))g6(Rb+20|0,h);else{f[R>>2]=f[h>>2];f[oa>>2]=R+4}R=V+1|0;oa=f[r>>2]|0;if(R>>>0>=(((f[Y>>2]|0)-oa|0)/12|0)>>>0)break e;S=f[J>>2]|0;V=R;H=oa;M=S;K=S}}while(0);E=e+4|0;I=f[E>>2]|0;if((I|0)==(f[e+8>>2]|0))fyb(e,t);else{K=I+4|0;f[K>>2]=0;M=I+8|0;f[M>>2]=0;H=I+4|0;f[I>>2]=H;V=f[t>>2]|0;if((V|0)!=(J|0)){S=H;H=V;while(1){V=H+16|0;f[o>>2]=S;f[h>>2]=f[o>>2];oa=eyb(I,h,l,m,V)|0;if(!(f[oa>>2]|0)){R=VDc(32)|0;f[R+16>>2]=f[V>>2];jFa(R+20|0,H+20|0);V=f[l>>2]|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=V;f[oa>>2]=R;V=f[f[I>>2]>>2]|0;if(!V)Tb=R;else{f[I>>2]=V;Tb=f[oa>>2]|0}laa(f[K>>2]|0,Tb);f[M>>2]=(f[M>>2]|0)+1}oa=f[H+4>>2]|0;if(!oa){V=H+8|0;R=f[V>>2]|0;if((f[R>>2]|0)==(H|0))Ub=R;else{R=V;do{V=f[R>>2]|0;R=V+8|0;T=f[R>>2]|0}while((f[T>>2]|0)!=(V|0));Ub=T}}else{R=oa;while(1){T=f[R>>2]|0;if(!T)break;else R=T}Ub=R}if((Ub|0)==(J|0))break;else H=Ub}}f[E>>2]=(f[E>>2]|0)+12}H=f[Z>>2]|0;pHa(t,f[J>>2]|0);M=f[r>>2]|0;if(M|0){K=f[Y>>2]|0;if((K|0)!=(M|0))f[Y>>2]=K+(~(((K+-12-M|0)>>>0)/12|0)*12|0);YDc(M)}Vb=H;Wb=f[x>>2]|0;pHa(p,Wb);u=g;return Vb|0}else if((ca|0)==7){f[k>>2]=_;F5(h,447019,k);z5(-2,h,447137,446605,584)}else if((ca|0)==23){f[j>>2]=ga;F5(h,447088,j);z5(-2,h,447137,446605,591)}else if((ca|0)==39){f[h>>2]=0;f[h+4>>2]=0;Db=tT(h,30)|0;Eb=457494;Fb=Db+30|0;do{b[Db>>0]=b[Eb>>0]|0;Db=Db+1|0;Eb=Eb+1|0}while((Db|0)<(Fb|0));z5(-215,h,447156,447165,72)}else if((ca|0)==72){f[h>>2]=0;f[h+4>>2]=0;Db=tT(h,30)|0;Eb=457494;Fb=Db+30|0;do{b[Db>>0]=b[Eb>>0]|0;Db=Db+1|0;Eb=Eb+1|0}while((Db|0)<(Fb|0));z5(-215,h,447156,447165,72)}}else yb=0;while(0);Eb=e+4|0;Db=f[Eb>>2]|0;if((Db|0)==(f[e+8>>2]|0)){fyb(e,p);Vb=yb;Wb=f[x>>2]|0;pHa(p,Wb);u=g;return Vb|0}e=Db+4|0;f[e>>2]=0;Fb=Db+8|0;f[Fb>>2]=0;ca=Db+4|0;f[Db>>2]=ca;j=f[p>>2]|0;if((j|0)!=(x|0)){ga=ca;ca=j;while(1){j=ca+16|0;f[o>>2]=ga;f[h>>2]=f[o>>2];k=eyb(Db,h,l,m,j)|0;if(!(f[k>>2]|0)){r=VDc(32)|0;f[r+16>>2]=f[j>>2];jFa(r+20|0,ca+20|0);j=f[l>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=j;f[k>>2]=r;j=f[f[Db>>2]>>2]|0;if(!j)Xb=r;else{f[Db>>2]=j;Xb=f[k>>2]|0}laa(f[e>>2]|0,Xb);f[Fb>>2]=(f[Fb>>2]|0)+1}k=f[ca+4>>2]|0;if(!k){j=ca+8|0;r=f[j>>2]|0;if((f[r>>2]|0)==(ca|0))Yb=r;else{r=j;do{j=f[r>>2]|0;r=j+8|0;t=f[r>>2]|0}while((f[t>>2]|0)!=(j|0));Yb=t}}else{r=k;while(1){t=f[r>>2]|0;if(!t)break;else r=t}Yb=r}if((Yb|0)==(x|0))break;else ca=Yb}}f[Eb>>2]=(f[Eb>>2]|0)+12;Vb=yb;Wb=f[x>>2]|0;pHa(p,Wb);u=g;return Vb|0}function Rxb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0;j=u;u=u+192|0;k=j+32|0;l=j+24|0;m=j+16|0;o=j;p=j+184|0;q=j+60|0;r=j+48|0;s=j+36|0;t=j+128|0;v=j+72|0;f[q>>2]=0;w=q+4|0;f[w>>2]=0;f[q+8>>2]=0;f[r>>2]=0;x=r+4|0;f[x>>2]=0;f[r+8>>2]=0;y=f[h>>2]|0;z=h+4|0;a:do if((y|0)!=(z|0)){A=g+8|0;B=o+4|0;C=p+4|0;D=s+4|0;E=s+8|0;F=o+8|0;G=o+4|0;H=t+36|0;I=t+16|0;J=t+4|0;K=t+40|0;L=t+44|0;M=t+48|0;N=o+4|0;O=r+8|0;P=y;while(1){Q=f[P+16>>2]|0;if((f[A>>2]|0)<=(Q|0))break;f[o>>2]=Q;f[B>>2]=Q+1;f[p>>2]=-2147483648;f[C>>2]=2147483647;$S(t,g,o,p);f[s>>2]=0;f[D>>2]=0;f[E>>2]=0;R=F;f[R>>2]=0;f[R+4>>2]=0;f[o>>2]=-2113732603;f[G>>2]=s;h_(t,o);R=f[H>>2]|0;if(R|0?(S=R+12|0,R=f[S>>2]|0,f[S>>2]=R+-1,(R|0)==1):0)_S(t);f[H>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[J>>2]|0)>0){R=f[K>>2]|0;S=0;do{f[R+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[J>>2]|0))}S=f[L>>2]|0;if((S|0)!=(M|0))g0(S);S=P+20|0;R=(f[x>>2]|0)-(f[r>>2]|0)>>3;T=P+24|0;Sxb(r,((f[T>>2]|0)-(f[S>>2]|0)>>2)+R|0);U=f[S>>2]|0;if((f[T>>2]|0)!=(U|0)){V=0;W=U;do{f[o>>2]=f[(f[s>>2]|0)+(f[W+(V<<2)>>2]<<2)>>2];f[N>>2]=V+R;U=f[x>>2]|0;if((U|0)==(f[O>>2]|0))Txb(r,o);else{X=o;Y=f[X+4>>2]|0;Z=U;f[Z>>2]=f[X>>2];f[Z+4>>2]=Y;f[x>>2]=(f[x>>2]|0)+8}V=V+1|0;W=f[S>>2]|0}while(V>>>0<(f[T>>2]|0)-W>>2>>>0)}W=f[s>>2]|0;if(W|0){T=f[D>>2]|0;if((T|0)!=(W|0))f[D>>2]=T+(~((T+-4-W|0)>>>2)<<2);YDc(W)}W=f[P+4>>2]|0;if(!W){T=P+8|0;V=f[T>>2]|0;if((f[V>>2]|0)==(P|0))_=V;else{V=T;do{T=f[V>>2]|0;V=T+8|0;S=f[V>>2]|0}while((f[S>>2]|0)!=(T|0));_=S}}else{V=W;while(1){S=f[V>>2]|0;if(!S)break;else V=S}_=V}if((_|0)==(z|0))break a;else P=_}f[m>>2]=Q;F5(o,447019,m);z5(-2,o,447070,446605,522)}while(0);if(!i){i=f[r>>2]|0;m=f[x>>2]|0;f[o>>2]=542;Vxb(i,m,o)}m=(f[x>>2]|0)-(f[r>>2]|0)>>3;i=f[w>>2]|0;Q=f[q>>2]|0;_=i-Q>>2;t=Q;y=i;if(m>>>0<=_>>>0)if(m>>>0<_>>>0?(P=t+(m<<2)|0,(y|0)!=(P|0)):0){D=y+(~((y+-4-P|0)>>>2)<<2)|0;f[w>>2]=D;$=D;aa=Q;ba=t}else{$=i;aa=Q;ba=t}else{lN(q,m-_|0);_=f[q>>2]|0;$=f[w>>2]|0;aa=_;ba=_}if(($|0)!=(aa|0)){aa=f[r>>2]|0;_=$-ba>>2;$=0;do{f[ba+(f[aa+($<<3)+4>>2]<<2)>>2]=$;$=$+1|0}while($>>>0<_>>>0)}_=f[h>>2]|0;b:do if((_|0)!=(z|0)){h=g+8|0;$=o+4|0;aa=p+4|0;ba=s+4|0;m=s+8|0;t=o+8|0;Q=o+4|0;i=v+36|0;D=v+16|0;P=v+4|0;y=v+40|0;O=v+44|0;N=v+48|0;M=a+40|0;L=e+4|0;ca=+(c|0);J=0;K=_;while(1){da=f[K+16>>2]|0;if((f[h>>2]|0)<=(da|0)){ea=45;break}f[o>>2]=da;f[$>>2]=da+1;f[p>>2]=-2147483648;f[aa>>2]=2147483647;$S(v,g,o,p);f[s>>2]=0;f[ba>>2]=0;f[m>>2]=0;I=t;f[I>>2]=0;f[I+4>>2]=0;f[o>>2]=-2113732603;f[Q>>2]=s;h_(v,o);I=f[i>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)_S(v);f[i>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[P>>2]|0)>0){I=f[y>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[P>>2]|0))}H=f[O>>2]|0;if((H|0)!=(N|0))g0(H);fa=b[M>>0]|0?-1:da;H=f[L>>2]|0;if(!H){ea=61;break}else{ga=L;ha=H}c:while(1){H=ha;while(1){if((f[H+16>>2]|0)>=(fa|0))break;I=f[H+4>>2]|0;if(!I){ia=ga;break c}else H=I}ha=f[H>>2]|0;if(!ha){ia=H;break}else ga=H}if((ia|0)==(L|0)){ea=61;break}if((fa|0)<(f[ia+16>>2]|0)){ea=61;break}I=f[K+24>>2]|0;V=f[K+20>>2]|0;G=V;if((I|0)==(V|0)){F=f[s>>2]|0;if(!F)ja=J;else{ka=J;la=F;ea=65}}else{F=f[q>>2]|0;E=f[ia+20>>2]|0;ma=+(da|0);C=f[s>>2]|0;B=I-V>>2;V=0;I=J;while(1){A=f[G+(V<<2)>>2]|0;W=(f[F+(I<<2)>>2]|0)*7|0;n[d+(W<<2)>>2]=ca;n[d+(W+1<<2)>>2]=ma;f[d+(W+2<<2)>>2]=f[C+(A<<2)>>2];f[d+(W+3<<2)>>2]=f[E+(A*24|0)>>2];f[d+(W+4<<2)>>2]=f[E+(A*24|0)+4>>2];f[d+(W+5<<2)>>2]=f[E+(A*24|0)+8>>2];f[d+(W+6<<2)>>2]=f[E+(A*24|0)+12>>2];V=V+1|0;A=I+1|0;if(V>>>0>=B>>>0){ka=A;la=C;ea=65;break}else I=A}}if((ea|0)==65){ea=0;I=f[ba>>2]|0;if((I|0)!=(la|0))f[ba>>2]=I+(~((I+-4-la|0)>>>2)<<2);YDc(la);ja=ka}I=f[K+4>>2]|0;if(!I){C=K+8|0;B=f[C>>2]|0;if((f[B>>2]|0)==(K|0))na=B;else{B=C;do{C=f[B>>2]|0;B=C+8|0;V=f[B>>2]|0}while((f[V>>2]|0)!=(C|0));na=V}}else{B=I;while(1){V=f[B>>2]|0;if(!V)break;else B=V}na=B}if((na|0)==(z|0)){oa=ja;break b}else{J=ja;K=na}}if((ea|0)==45){f[l>>2]=da;F5(o,447019,l);z5(-2,o,447070,446605,547)}else if((ea|0)==61){f[k>>2]=fa;F5(o,447088,k);z5(-2,o,447070,446605,552)}}else oa=0;while(0);o=f[r>>2]|0;if(o|0){r=f[x>>2]|0;if((r|0)!=(o|0))f[x>>2]=r+(~((r+-8-o|0)>>>3)<<3);YDc(o)}o=f[q>>2]|0;if(!o){u=j;return oa|0}q=f[w>>2]|0;if((q|0)!=(o|0))f[w>>2]=q+(~((q+-4-o|0)>>>2)<<2);YDc(o);u=j;return oa|0}function Sxb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>3;i=VDc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;YDc(d);return}function Txb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function Uxb(a,b){a=a|0;b=b|0;return +n[a>>2]>+n[b>>2]|0}function Vxb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-8|0;i=a+-4|0;j=g;while(1){k=j;b:while(1){l=k;m=b-l|0;n=m>>3;switch(n|0){case 2:{o=5;break a;break}case 3:{o=7;break a;break}case 4:{o=8;break a;break}case 5:{o=12;break a;break}case 1:case 0:{o=56;break a;break}default:{}}if((m|0)<56){o=14;break a}p=k+(((n|0)/2|0)<<3)|0;if((m|0)>7992){m=(n|0)/4|0;q=Xxb(k,k+(m<<3)|0,p,p+(m<<3)|0,h,c)|0}else q=Wxb(k,p,h,c)|0;if(Mi[f[c>>2]&1023](k,p)|0){r=h;s=q;break}else t=h;while(1){v=t+-8|0;if((k|0)==(v|0))break;if(Mi[f[c>>2]&1023](v,p)|0){o=39;break b}else t=v}m=k+8|0;if(Mi[f[c>>2]&1023](k,h)|0)w=m;else{if((m|0)==(h|0)){o=56;break a}else x=m;while(1){if(Mi[f[c>>2]&1023](k,x)|0)break;m=x+8|0;if((m|0)==(h|0)){o=56;break a}else x=m}m=f[x>>2]|0;f[x>>2]=f[h>>2];f[h>>2]=m;m=x+4|0;n=f[m>>2]|0;f[m>>2]=f[i>>2];f[i>>2]=n;w=x+8|0}if((w|0)==(h|0)){o=56;break a}else{y=h;z=w}while(1){n=z;while(1){A=n+8|0;if(Mi[f[c>>2]&1023](k,n)|0){B=y;break}else n=A}while(1){C=B+-8|0;if(Mi[f[c>>2]&1023](k,C)|0)B=C;else break}if(n>>>0>=C>>>0){k=n;continue b}m=f[n>>2]|0;f[n>>2]=f[C>>2];f[C>>2]=m;m=n+4|0;D=B+-4|0;E=f[m>>2]|0;f[m>>2]=f[D>>2];f[D>>2]=E;y=C;z=A}}if((o|0)==39){o=0;E=f[k>>2]|0;f[k>>2]=f[v>>2];f[v>>2]=E;E=k+4|0;D=t+-4|0;m=f[E>>2]|0;f[E>>2]=f[D>>2];f[D>>2]=m;r=v;s=q+1|0}m=k+8|0;c:do if(m>>>0<r>>>0){D=p;E=r;F=m;G=s;while(1){H=F;while(1){I=H+8|0;if(Mi[f[c>>2]&1023](H,D)|0)H=I;else{J=E;break}}while(1){K=J+-8|0;if(Mi[f[c>>2]&1023](K,D)|0)break;else J=K}if(H>>>0>K>>>0){L=D;M=G;N=H;break c}n=f[H>>2]|0;f[H>>2]=f[K>>2];f[K>>2]=n;n=H+4|0;O=J+-4|0;P=f[n>>2]|0;f[n>>2]=f[O>>2];f[O>>2]=P;D=(D|0)==(H|0)?K:D;E=K;F=I;G=G+1|0}}else{L=p;M=s;N=m}while(0);if((N|0)!=(L|0)?Mi[f[c>>2]&1023](L,N)|0:0){m=f[N>>2]|0;f[N>>2]=f[L>>2];f[L>>2]=m;m=N+4|0;G=L+4|0;F=f[m>>2]|0;f[m>>2]=f[G>>2];f[G>>2]=F;Q=M+1|0}else Q=M;if(!Q){R=Yxb(k,N,c)|0;F=N+8|0;if(Yxb(F,a,c)|0){o=55;break}if(R){j=F;continue}}F=N;if((F-l|0)>=(b-F|0)){o=54;break}Vxb(k,N,c);j=N+8|0}if((o|0)==54){o=0;Vxb(N+8|0,a,c);g=k;a=N;continue}else if((o|0)==55){o=0;if(R){o=56;break}else{g=k;a=N;continue}}}if((o|0)==5){if(!(Mi[f[c>>2]&1023](h,k)|0)){u=d;return}N=f[k>>2]|0;f[k>>2]=f[h>>2];f[h>>2]=N;N=k+4|0;g=f[N>>2]|0;f[N>>2]=f[i>>2];f[i>>2]=g;u=d;return}else if((o|0)==7){Wxb(k,k+8|0,h,c)|0;u=d;return}else if((o|0)==8){g=k+8|0;N=k+16|0;Wxb(k,g,N,c)|0;if(!(Mi[f[c>>2]&1023](h,N)|0)){u=d;return}R=f[N>>2]|0;f[N>>2]=f[h>>2];f[h>>2]=R;R=k+20|0;l=f[R>>2]|0;f[R>>2]=f[i>>2];f[i>>2]=l;if(!(Mi[f[c>>2]&1023](N,g)|0)){u=d;return}l=f[g>>2]|0;f[g>>2]=f[N>>2];f[N>>2]=l;l=k+12|0;N=f[l>>2]|0;f[l>>2]=f[R>>2];f[R>>2]=N;if(!(Mi[f[c>>2]&1023](g,k)|0)){u=d;return}N=f[k>>2]|0;f[k>>2]=f[g>>2];f[g>>2]=N;N=k+4|0;g=f[N>>2]|0;f[N>>2]=f[l>>2];f[l>>2]=g;u=d;return}else if((o|0)==12){Xxb(k,k+8|0,k+16|0,k+24|0,h,c)|0;u=d;return}else if((o|0)==14){h=k+16|0;Wxb(k,k+8|0,h,c)|0;g=k+24|0;if((g|0)==(a|0)){u=d;return}l=e+4|0;N=g;g=h;while(1){if(Mi[f[c>>2]&1023](N,g)|0){h=N;R=f[h+4>>2]|0;i=e;f[i>>2]=f[h>>2];f[i+4>>2]=R;R=g;i=N;while(1){f[i>>2]=f[R>>2];S=R+4|0;f[i+4>>2]=f[S>>2];if((R|0)==(k|0))break;h=R+-8|0;if(Mi[f[c>>2]&1023](e,h)|0){Q=R;R=h;i=Q}else break}f[R>>2]=f[e>>2];f[S>>2]=f[l>>2]}i=N+8|0;if((i|0)==(a|0))break;else{Q=N;N=i;g=Q}}u=d;return}else if((o|0)==56){u=d;return}}function Wxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=Mi[f[d>>2]&1023](b,a)|0;g=Mi[f[d>>2]&1023](c,b)|0;if(!e){if(!g){h=0;return h|0}e=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=e;e=b+4|0;i=c+4|0;j=f[e>>2]|0;f[e>>2]=f[i>>2];f[i>>2]=j;if(!(Mi[f[d>>2]&1023](b,a)|0)){h=1;return h|0}j=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=j;j=a+4|0;i=f[j>>2]|0;f[j>>2]=f[e>>2];f[e>>2]=i;h=2;return h|0}i=f[a>>2]|0;if(g){f[a>>2]=f[c>>2];f[c>>2]=i;g=a+4|0;e=c+4|0;j=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=j;h=1;return h|0}f[a>>2]=f[b>>2];f[b>>2]=i;i=a+4|0;a=b+4|0;j=f[i>>2]|0;f[i>>2]=f[a>>2];f[a>>2]=j;if(!(Mi[f[d>>2]&1023](c,b)|0)){h=1;return h|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=c+4|0;c=f[a>>2]|0;f[a>>2]=f[d>>2];f[d>>2]=c;h=2;return h|0}function Xxb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=Wxb(a,b,c,g)|0;if(Mi[f[g>>2]&1023](d,c)|0){i=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=i;i=c+4|0;j=d+4|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;k=h+1|0;if(Mi[f[g>>2]&1023](c,b)|0){j=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=j;j=b+4|0;l=f[j>>2]|0;f[j>>2]=f[i>>2];f[i>>2]=l;if(Mi[f[g>>2]&1023](b,a)|0){l=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=l;l=a+4|0;i=f[l>>2]|0;f[l>>2]=f[j>>2];f[j>>2]=i;m=h+3|0}else m=h+2|0}else m=k}else m=h;if(!(Mi[f[g>>2]&1023](e,d)|0)){n=m;return n|0}h=f[d>>2]|0;f[d>>2]=f[e>>2];f[e>>2]=h;h=d+4|0;k=e+4|0;e=f[h>>2]|0;f[h>>2]=f[k>>2];f[k>>2]=e;if(!(Mi[f[g>>2]&1023](d,c)|0)){n=m+1|0;return n|0}e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=c+4|0;d=f[e>>2]|0;f[e>>2]=f[h>>2];f[h>>2]=d;if(!(Mi[f[g>>2]&1023](c,b)|0)){n=m+2|0;return n|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=b+4|0;c=f[d>>2]|0;f[d>>2]=f[e>>2];f[e>>2]=c;if(!(Mi[f[g>>2]&1023](b,a)|0)){n=m+3|0;return n|0}g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;a=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=a;n=m+4|0;return n|0}function Yxb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;switch(b-a>>3|0){case 2:{g=b+-8|0;if(!(Mi[f[c>>2]&1023](g,a)|0)){h=1;u=d;return h|0}i=f[a>>2]|0;f[a>>2]=f[g>>2];f[g>>2]=i;i=a+4|0;g=b+-4|0;j=f[i>>2]|0;f[i>>2]=f[g>>2];f[g>>2]=j;h=1;u=d;return h|0}case 3:{Wxb(a,a+8|0,b+-8|0,c)|0;h=1;u=d;return h|0}case 4:{j=a+8|0;g=a+16|0;i=b+-8|0;Wxb(a,j,g,c)|0;if(!(Mi[f[c>>2]&1023](i,g)|0)){h=1;u=d;return h|0}k=f[g>>2]|0;f[g>>2]=f[i>>2];f[i>>2]=k;k=a+20|0;i=b+-4|0;l=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=l;if(!(Mi[f[c>>2]&1023](g,j)|0)){h=1;u=d;return h|0}l=f[j>>2]|0;f[j>>2]=f[g>>2];f[g>>2]=l;l=a+12|0;g=f[l>>2]|0;f[l>>2]=f[k>>2];f[k>>2]=g;if(!(Mi[f[c>>2]&1023](j,a)|0)){h=1;u=d;return h|0}g=f[a>>2]|0;f[a>>2]=f[j>>2];f[j>>2]=g;g=a+4|0;j=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=j;h=1;u=d;return h|0}case 5:{Xxb(a,a+8|0,a+16|0,a+24|0,b+-8|0,c)|0;h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{j=a+16|0;Wxb(a,a+8|0,j,c)|0;l=a+24|0;a:do if((l|0)==(b|0)){m=1;n=0}else{g=e+4|0;k=l;i=0;o=j;while(1){if(Mi[f[c>>2]&1023](k,o)|0){p=k;q=f[p+4>>2]|0;r=e;f[r>>2]=f[p>>2];f[r+4>>2]=q;q=o;r=k;while(1){f[r>>2]=f[q>>2];s=q+4|0;f[r+4>>2]=f[s>>2];if((q|0)==(a|0))break;p=q+-8|0;if(Mi[f[c>>2]&1023](e,p)|0){t=q;q=p;r=t}else break}f[q>>2]=f[e>>2];f[s>>2]=f[g>>2];r=i+1|0;if((r|0)==8){m=0;n=(k+8|0)==(b|0);break a}else v=r}else v=i;r=k+8|0;if((r|0)==(b|0)){m=1;n=0;break}else{t=k;k=r;i=v;o=t}}}while(0);h=n|m;u=d;return h|0}}return 0}function Zxb(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+32|0;g=e;h=e+20|0;i=e+16|0;j=e+12|0;k=e+8|0;l=a+4|0;m=f[l>>2]|0;o=f[a>>2]|0;if((m|0)==(o|0))p=d+4|0;else{q=g+4|0;r=d+4|0;s=d+8|0;t=0;v=o;o=m;while(1){m=v;if(+n[m+(t<<2)>>2]>b){f[g>>2]=f[m+(t<<2)>>2];f[q>>2]=t;m=f[r>>2]|0;if((m|0)==(f[s>>2]|0))Txb(d,g);else{w=g;x=f[w+4>>2]|0;y=m;f[y>>2]=f[w>>2];f[y+4>>2]=x;f[r>>2]=(f[r>>2]|0)+8}z=f[a>>2]|0;A=f[l>>2]|0}else{z=v;A=o}t=t+1|0;if(t>>>0>=A-z>>2>>>0){p=r;break}else{v=z;o=A}}}A=f[d>>2]|0;o=f[p>>2]|0;f[i>>2]=543;z=o-A|0;v=z>>3;if((z|0)>0){z=(v|0)<268435455?v:268435455;while(1){r=WDc(z<<3,1154739)|0;if(r|0){B=r;C=z;break}z=z>>>1;if(!z){B=0;C=0;break}}D=B;E=C;F=B}else{D=0;E=0;F=0}f[j>>2]=A;f[k>>2]=o;f[h>>2]=f[j>>2];f[g>>2]=f[k>>2];myb(h,g,i,v,D,E);if(D|0)YDc(F);if((c|0)<=0){u=e;return}F=f[p>>2]|0;D=f[d>>2]|0;E=F-D>>3;if((E|0)<=(c|0)){u=e;return}v=F;if(E>>>0<c>>>0){nyb(d,c-E|0);u=e;return}if(E>>>0<=c>>>0){u=e;return}E=D+(c<<3)|0;if((v|0)==(E|0)){u=e;return}f[p>>2]=v+(~((v+-8-E|0)>>>3)<<3);u=e;return}function _xb(a,c){a=a|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;d=+n[a>>2];e=+n[c>>2];f=d<e?e:d;g=+n[c+8>>2];h=+n[a+8>>2];i=g<h?g:h;if(i<f){j=0.0;return +j}k=+n[c+12>>2];l=+n[a+12>>2];m=k<l?k:l;o=+n[a+4>>2];p=+n[c+4>>2];q=o<p?p:o;if(m<q){j=0.0;return +j}r=(i-f)*(m-q);if(!(r>0.0)){j=0.0;return +j}do if(!(h<d|l<o))if(!(b[a+16>>0]|0)){s=(h-d)*(l-o);break}else{s=+n[a+20>>2];break}else s=0.0;while(0);do if(!(g<e|k<p))if(!(b[c+16>>0]|0)){t=(g-e)*(k-p);break}else{t=+n[c+20>>2];break}else t=0.0;while(0);j=r/(s+t-r);return +j}function $xb(a,c){a=a|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;d=+n[a>>2];e=+n[c>>2];f=d<e?e:d;g=+n[c+8>>2];h=+n[a+8>>2];i=g<h?g:h;if(i<f){j=0.0;return +j}k=+n[c+12>>2];l=+n[a+12>>2];m=k<l?k:l;o=+n[a+4>>2];p=+n[c+4>>2];q=o<p?p:o;if(m<q){j=0.0;return +j}r=(i-f+1.0)*(m-q+1.0);if(!(r>0.0)){j=0.0;return +j}do if(!(h<d|l<o))if(!(b[a+16>>0]|0)){s=(h-d+1.0)*(l-o+1.0);break}else{s=+n[a+20>>2];break}else s=0.0;while(0);do if(!(g<e|k<p))if(!(b[c+16>>0]|0)){t=(g-e+1.0)*(k-p+1.0);break}else{t=+n[c+20>>2];break}else t=0.0;while(0);j=r/(s+t-r);return +j}function ayb(a,b){a=a|0;b=b|0;return +n[a>>2]>+n[b>>2]|0}function byb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-12|0;i=a+-8|0;j=a+-4|0;k=g;while(1){l=k;b:while(1){m=l;n=b-m|0;switch((n|0)/12|0|0){case 2:{o=5;break a;break}case 3:{o=7;break a;break}case 4:{o=8;break a;break}case 5:{o=9;break a;break}case 1:case 0:{o=53;break a;break}default:{}}if((n|0)<84){o=11;break a}p=l+(((n>>>0)/24|0)*12|0)|0;if((n|0)>11988){q=(n>>>0)/48|0;r=jyb(l,l+(q*12|0)|0,p,p+(q*12|0)|0,h,c)|0}else r=hyb(l,p,h,c)|0;if(Mi[f[c>>2]&1023](l,p)|0){s=h;t=r;break}else v=h;while(1){w=v+-12|0;if((l|0)==(w|0))break;if(Mi[f[c>>2]&1023](w,p)|0){o=36;break b}else v=w}q=l+12|0;if(Mi[f[c>>2]&1023](l,h)|0)x=q;else{if((q|0)==(h|0)){o=53;break a}else y=q;while(1){if(Mi[f[c>>2]&1023](l,y)|0)break;q=y+12|0;if((q|0)==(h|0)){o=53;break a}else y=q}q=f[y>>2]|0;f[y>>2]=f[h>>2];f[h>>2]=q;q=y+4|0;n=f[q>>2]|0;f[q>>2]=f[i>>2];f[i>>2]=n;n=y+8|0;q=f[n>>2]|0;f[n>>2]=f[j>>2];f[j>>2]=q;x=y+12|0}if((x|0)==(h|0)){o=53;break a}else{z=h;A=x}while(1){q=A;while(1){B=q+12|0;if(Mi[f[c>>2]&1023](l,q)|0){C=z;break}else q=B}while(1){D=C+-12|0;if(Mi[f[c>>2]&1023](l,D)|0)C=D;else break}if(q>>>0>=D>>>0){l=q;continue b}n=f[q>>2]|0;f[q>>2]=f[D>>2];f[D>>2]=n;n=q+4|0;E=C+-8|0;F=f[n>>2]|0;f[n>>2]=f[E>>2];f[E>>2]=F;F=q+8|0;E=C+-4|0;n=f[F>>2]|0;f[F>>2]=f[E>>2];f[E>>2]=n;z=D;A=B}}if((o|0)==36){o=0;n=f[l>>2]|0;f[l>>2]=f[w>>2];f[w>>2]=n;n=l+4|0;E=v+-8|0;F=f[n>>2]|0;f[n>>2]=f[E>>2];f[E>>2]=F;F=l+8|0;E=v+-4|0;n=f[F>>2]|0;f[F>>2]=f[E>>2];f[E>>2]=n;s=w;t=r+1|0}n=l+12|0;c:do if(n>>>0<s>>>0){E=p;F=s;G=n;H=t;while(1){I=G;while(1){J=I+12|0;if(Mi[f[c>>2]&1023](I,E)|0)I=J;else{K=F;break}}while(1){L=K+-12|0;if(Mi[f[c>>2]&1023](L,E)|0)break;else K=L}if(I>>>0>L>>>0){M=E;N=H;O=I;break c}q=f[I>>2]|0;f[I>>2]=f[L>>2];f[L>>2]=q;q=I+4|0;P=K+-8|0;Q=f[q>>2]|0;f[q>>2]=f[P>>2];f[P>>2]=Q;Q=I+8|0;P=K+-4|0;q=f[Q>>2]|0;f[Q>>2]=f[P>>2];f[P>>2]=q;E=(E|0)==(I|0)?L:E;F=L;G=J;H=H+1|0}}else{M=p;N=t;O=n}while(0);if((O|0)!=(M|0)?Mi[f[c>>2]&1023](M,O)|0:0){n=f[O>>2]|0;f[O>>2]=f[M>>2];f[M>>2]=n;n=O+4|0;H=M+4|0;G=f[n>>2]|0;f[n>>2]=f[H>>2];f[H>>2]=G;G=O+8|0;H=M+8|0;n=f[G>>2]|0;f[G>>2]=f[H>>2];f[H>>2]=n;R=N+1|0}else R=N;if(!R){S=kyb(l,O,c)|0;n=O+12|0;if(kyb(n,a,c)|0){o=52;break}if(S){k=n;continue}}n=O;if((n-m|0)>=(b-n|0)){o=51;break}byb(l,O,c);k=O+12|0}if((o|0)==51){o=0;byb(O+12|0,a,c);g=l;a=O;continue}else if((o|0)==52){o=0;if(S){o=53;break}else{g=l;a=O;continue}}}if((o|0)==5){if(!(Mi[f[c>>2]&1023](h,l)|0)){u=d;return}O=f[l>>2]|0;f[l>>2]=f[h>>2];f[h>>2]=O;O=l+4|0;g=f[O>>2]|0;f[O>>2]=f[i>>2];f[i>>2]=g;g=l+8|0;i=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=i;u=d;return}else if((o|0)==7){hyb(l,l+12|0,h,c)|0;u=d;return}else if((o|0)==8){iyb(l,l+12|0,l+24|0,h,c)|0;u=d;return}else if((o|0)==9){jyb(l,l+12|0,l+24|0,l+36|0,h,c)|0;u=d;return}else if((o|0)==11){h=l+24|0;hyb(l,l+12|0,h,c)|0;i=l+36|0;if((i|0)==(a|0)){u=d;return}j=e+4|0;g=e+8|0;O=i;i=h;while(1){if(Mi[f[c>>2]&1023](O,i)|0){f[e>>2]=f[O>>2];f[e+4>>2]=f[O+4>>2];f[e+8>>2]=f[O+8>>2];h=i;S=O;while(1){f[S>>2]=f[h>>2];T=h+4|0;f[S+4>>2]=f[T>>2];U=h+8|0;f[S+8>>2]=f[U>>2];if((h|0)==(l|0))break;m=h+-12|0;if(Mi[f[c>>2]&1023](e,m)|0){R=h;h=m;S=R}else break}f[h>>2]=f[e>>2];f[T>>2]=f[j>>2];f[U>>2]=f[g>>2]}S=O+12|0;if((S|0)==(a|0))break;else{R=O;O=S;i=R}}u=d;return}else if((o|0)==53){u=d;return}}function cyb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)mCc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;YDc(d);return}function dyb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){XIc(g|0,0,b*12|0)|0;f[e>>2]=g+(b*12|0);return}h=f[a>>2]|0;i=g-h|0;g=(i|0)/12|0;j=g+b|0;if(j>>>0>357913941)mCc(a);k=(d-h|0)/12|0;d=k<<1;l=k>>>0<178956970?(d>>>0<j>>>0?j:d):357913941;do if(l)if(l>>>0>357913941){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l*12|0)|0;break}else m=0;while(0);d=m+(g*12|0)|0;XIc(d|0,0,b*12|0)|0;g=d+(((i|0)/-12|0)*12|0)|0;if((i|0)>0)dJc(g|0,h|0,i|0)|0;f[a>>2]=g;f[e>>2]=d+(b*12|0);f[c>>2]=m+(l*12|0);if(!h)return;YDc(h);return}function eyb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function fyb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+48|0;d=c+32|0;e=c+28|0;g=c+24|0;h=c+20|0;i=c;j=f[a>>2]|0;k=((f[a+4>>2]|0)-j|0)/12|0;l=k+1|0;if(l>>>0>357913941)mCc(a);m=((f[a+8>>2]|0)-j|0)/12|0;j=m<<1;n=m>>>0<178956970?(j>>>0<l>>>0?l:j):357913941;f[i+12>>2]=0;f[i+16>>2]=a+8;do if(n)if(n>>>0>357913941){j=af(8)|0;bEc(j,503977);f[j>>2]=185532;ig(j|0,23696,1627)}else{o=VDc(n*12|0)|0;break}else o=0;while(0);f[i>>2]=o;j=o+(k*12|0)|0;l=i+8|0;f[l>>2]=j;m=i+4|0;f[m>>2]=j;f[i+12>>2]=o+(n*12|0);n=o+(k*12|0)+4|0;f[n>>2]=0;p=o+(k*12|0)+8|0;f[p>>2]=0;q=o+(k*12|0)+4|0;f[j>>2]=q;k=f[b>>2]|0;o=b+4|0;if((k|0)==(o|0))r=j;else{b=q;q=k;while(1){k=q+16|0;f[h>>2]=b;f[d>>2]=f[h>>2];s=eyb(j,d,e,g,k)|0;if(!(f[s>>2]|0)){t=VDc(32)|0;f[t+16>>2]=f[k>>2];jFa(t+20|0,q+20|0);k=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=k;f[s>>2]=t;k=f[f[j>>2]>>2]|0;if(!k)v=t;else{f[j>>2]=k;v=f[s>>2]|0}laa(f[n>>2]|0,v);f[p>>2]=(f[p>>2]|0)+1}s=f[q+4>>2]|0;if(!s){k=q+8|0;t=f[k>>2]|0;if((f[t>>2]|0)==(q|0))w=t;else{t=k;do{k=f[t>>2]|0;t=k+8|0;x=f[t>>2]|0}while((f[x>>2]|0)!=(k|0));w=x}}else{t=s;while(1){x=f[t>>2]|0;if(!x)break;else t=x}w=t}if((w|0)==(o|0))break;else q=w}r=f[l>>2]|0}f[l>>2]=r+12;gyb(a,i);a=f[m>>2]|0;m=f[l>>2]|0;if((m|0)!=(a|0)){r=m;do{m=r+-12|0;f[l>>2]=m;pHa(m,f[r+-8>>2]|0);r=f[l>>2]|0}while((r|0)!=(a|0))}a=f[i>>2]|0;if(!a){u=c;return}YDc(a);u=c;return}function gyb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;i=f[a>>2]|0;j=a+4|0;k=f[j>>2]|0;l=b+4|0;if((k|0)==(i|0)){m=l;n=a;o=f[l>>2]|0;p=i;f[n>>2]=o;f[m>>2]=p;q=b+8|0;r=f[j>>2]|0;s=f[q>>2]|0;f[j>>2]=s;f[q>>2]=r;t=a+8|0;v=b+12|0;w=f[t>>2]|0;x=f[v>>2]|0;f[t>>2]=x;f[v>>2]=w;y=f[m>>2]|0;f[b>>2]=y;u=c;return}z=k;k=f[l>>2]|0;do{A=k+-12|0;B=z;z=z+-12|0;C=k+-8|0;f[C>>2]=0;D=k+-4|0;f[D>>2]=0;E=k+-8|0;f[A>>2]=E;F=f[z>>2]|0;G=B+-8|0;if((F|0)!=(G|0)){B=E;E=F;while(1){F=E+16|0;f[h>>2]=B;f[d>>2]=f[h>>2];H=eyb(A,d,e,g,F)|0;if(!(f[H>>2]|0)){I=VDc(32)|0;f[I+16>>2]=f[F>>2];jFa(I+20|0,E+20|0);F=f[e>>2]|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=F;f[H>>2]=I;F=f[f[A>>2]>>2]|0;if(!F)J=I;else{f[A>>2]=F;J=f[H>>2]|0}laa(f[C>>2]|0,J);f[D>>2]=(f[D>>2]|0)+1}H=f[E+4>>2]|0;if(!H){F=E+8|0;I=f[F>>2]|0;if((f[I>>2]|0)==(E|0))K=I;else{I=F;do{F=f[I>>2]|0;I=F+8|0;L=f[I>>2]|0}while((f[L>>2]|0)!=(F|0));K=L}}else{I=H;while(1){L=f[I>>2]|0;if(!L)break;else I=L}K=I}if((K|0)==(G|0))break;else E=K}}k=(f[l>>2]|0)+-12|0;f[l>>2]=k}while((z|0)!=(i|0));m=l;n=a;o=k;p=f[a>>2]|0;f[n>>2]=o;f[m>>2]=p;q=b+8|0;r=f[j>>2]|0;s=f[q>>2]|0;f[j>>2]=s;f[q>>2]=r;t=a+8|0;v=b+12|0;w=f[t>>2]|0;x=f[v>>2]|0;f[t>>2]=x;f[v>>2]=w;y=f[m>>2]|0;f[b>>2]=y;u=c;return}function hyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=Mi[f[d>>2]&1023](b,a)|0;g=Mi[f[d>>2]&1023](c,b)|0;if(!e){if(!g){h=0;return h|0}e=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=e;e=b+4|0;i=c+4|0;j=f[e>>2]|0;f[e>>2]=f[i>>2];f[i>>2]=j;j=b+8|0;i=c+8|0;k=f[j>>2]|0;f[j>>2]=f[i>>2];f[i>>2]=k;if(!(Mi[f[d>>2]&1023](b,a)|0)){h=1;return h|0}k=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=k;k=a+4|0;i=f[k>>2]|0;f[k>>2]=f[e>>2];f[e>>2]=i;i=a+8|0;e=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=e;h=2;return h|0}e=f[a>>2]|0;if(g){f[a>>2]=f[c>>2];f[c>>2]=e;g=a+4|0;j=c+4|0;i=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=i;i=a+8|0;j=c+8|0;g=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=g;h=1;return h|0}f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;g=b+4|0;j=f[e>>2]|0;f[e>>2]=f[g>>2];f[g>>2]=j;j=a+8|0;a=b+8|0;e=f[j>>2]|0;f[j>>2]=f[a>>2];f[a>>2]=e;if(!(Mi[f[d>>2]&1023](c,b)|0)){h=1;return h|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=c+4|0;b=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=b;b=c+8|0;c=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=c;h=2;return h|0}function iyb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=hyb(a,b,c,e)|0;if(!(Mi[f[e>>2]&1023](d,c)|0)){h=g;return h|0}i=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=i;i=c+4|0;j=d+4|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;k=c+8|0;j=d+8|0;d=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=d;if(!(Mi[f[e>>2]&1023](c,b)|0)){h=g+1|0;return h|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=b+4|0;c=f[d>>2]|0;f[d>>2]=f[i>>2];f[i>>2]=c;c=b+8|0;i=f[c>>2]|0;f[c>>2]=f[k>>2];f[k>>2]=i;if(!(Mi[f[e>>2]&1023](b,a)|0)){h=g+2|0;return h|0}e=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;b=f[e>>2]|0;f[e>>2]=f[d>>2];f[d>>2]=b;b=a+8|0;a=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=a;h=g+3|0;return h|0}function jyb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=iyb(a,b,c,d,g)|0;if(!(Mi[f[g>>2]&1023](e,d)|0)){i=h;return i|0}j=f[d>>2]|0;f[d>>2]=f[e>>2];f[e>>2]=j;j=d+4|0;k=e+4|0;l=f[j>>2]|0;f[j>>2]=f[k>>2];f[k>>2]=l;l=d+8|0;k=e+8|0;e=f[l>>2]|0;f[l>>2]=f[k>>2];f[k>>2]=e;if(!(Mi[f[g>>2]&1023](d,c)|0)){i=h+1|0;return i|0}e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=c+4|0;d=f[e>>2]|0;f[e>>2]=f[j>>2];f[j>>2]=d;d=c+8|0;j=f[d>>2]|0;f[d>>2]=f[l>>2];f[l>>2]=j;if(!(Mi[f[g>>2]&1023](c,b)|0)){i=h+2|0;return i|0}j=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=j;j=b+4|0;c=f[j>>2]|0;f[j>>2]=f[e>>2];f[e>>2]=c;c=b+8|0;e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;if(!(Mi[f[g>>2]&1023](b,a)|0)){i=h+3|0;return i|0}g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;b=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=b;b=a+8|0;a=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=a;i=h+4|0;return i|0}function kyb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;switch((b-a|0)/12|0|0){case 2:{g=b+-12|0;if(!(Mi[f[c>>2]&1023](g,a)|0)){h=1;u=d;return h|0}i=f[a>>2]|0;f[a>>2]=f[g>>2];f[g>>2]=i;i=a+4|0;g=b+-8|0;j=f[i>>2]|0;f[i>>2]=f[g>>2];f[g>>2]=j;j=a+8|0;g=b+-4|0;i=f[j>>2]|0;f[j>>2]=f[g>>2];f[g>>2]=i;h=1;u=d;return h|0}case 3:{hyb(a,a+12|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 4:{iyb(a,a+12|0,a+24|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 5:{jyb(a,a+12|0,a+24|0,a+36|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{i=a+24|0;hyb(a,a+12|0,i,c)|0;g=a+36|0;a:do if((g|0)==(b|0)){k=1;l=0}else{j=e+4|0;m=e+8|0;n=g;o=0;p=i;while(1){if(Mi[f[c>>2]&1023](n,p)|0){f[e>>2]=f[n>>2];f[e+4>>2]=f[n+4>>2];f[e+8>>2]=f[n+8>>2];q=p;r=n;while(1){f[r>>2]=f[q>>2];s=q+4|0;f[r+4>>2]=f[s>>2];t=q+8|0;f[r+8>>2]=f[t>>2];if((q|0)==(a|0))break;v=q+-12|0;if(Mi[f[c>>2]&1023](e,v)|0){w=q;q=v;r=w}else break}f[q>>2]=f[e>>2];f[s>>2]=f[j>>2];f[t>>2]=f[m>>2];r=o+1|0;if((r|0)==8){k=0;l=(n+12|0)==(b|0);break a}else x=r}else x=o;r=n+12|0;if((r|0)==(b|0)){k=1;l=0;break}else{w=n;n=r;o=x;p=w}}}while(0);h=l|k;u=d;return h|0}}return 0}function lyb(a,b){a=a|0;b=b|0;return +n[a>>2]>+n[b>>2]|0}function myb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;h=u;u=u+64|0;i=h;j=h+56|0;k=h+52|0;l=h+48|0;m=h+44|0;n=h+40|0;o=h+36|0;p=h+32|0;q=h+28|0;r=h+24|0;s=h+20|0;t=h+16|0;v=h+12|0;w=h+8|0;switch(d|0){case 2:{x=f[c>>2]|0;y=f[b>>2]|0;z=y+-8|0;f[b>>2]=z;A=f[a>>2]|0;if(!(Mi[x&1023](z,A)|0)){u=h;return}x=f[A>>2]|0;f[A>>2]=f[z>>2];f[z>>2]=x;x=A+4|0;A=y+-4|0;y=f[x>>2]|0;f[x>>2]=f[A>>2];f[A>>2]=y;u=h;return}case 1:case 0:{u=h;return}default:{if((d|0)<1){y=f[a>>2]|0;A=f[b>>2]|0;if((y|0)==(A|0)){u=h;return}x=y+8|0;if((x|0)==(A|0)){u=h;return}z=i+4|0;B=x;do{x=B;C=B;D=f[C>>2]|0;E=f[C+4>>2]|0;C=i;f[C>>2]=D;f[C+4>>2]=E;if((B|0)==(y|0)){F=x;G=D;H=E}else{E=x;x=B;while(1){D=x;x=x+-8|0;if(!(Mi[f[c>>2]&1023](i,x)|0)){I=E;break}C=E;f[E>>2]=f[x>>2];f[C+4>>2]=f[D+-4>>2];D=C+-8|0;if((x|0)==(y|0)){I=D;break}else E=D}F=I;G=f[i>>2]|0;H=f[z>>2]|0}f[F>>2]=G;f[F+4>>2]=H;B=B+8|0}while((B|0)!=(A|0));u=h;return}A=d>>>1;B=f[a>>2]|0;a=B+(A<<3)|0;H=B;if((d|0)>(g|0)){f[p>>2]=H;f[q>>2]=a;f[j>>2]=f[p>>2];f[i>>2]=f[q>>2];myb(j,i,c,A,e,g);f[r>>2]=a;q=f[b>>2]|0;f[s>>2]=q;p=d-A|0;f[j>>2]=f[r>>2];f[i>>2]=f[s>>2];myb(j,i,c,p,e,g);f[t>>2]=H;f[v>>2]=a;f[w>>2]=q;f[k>>2]=f[t>>2];f[j>>2]=f[v>>2];f[i>>2]=f[w>>2];pyb(k,j,i,c,A,p,e,g);u=h;return}f[l>>2]=H;f[m>>2]=a;f[j>>2]=f[l>>2];f[i>>2]=f[m>>2];oyb(j,i,c,A,e);f[n>>2]=a;f[o>>2]=f[b>>2];b=e+(A<<3)|0;f[j>>2]=f[n>>2];f[i>>2]=f[o>>2];oyb(j,i,c,d-A|0,b);A=e+(d<<3)|0;d=b;i=e;e=H;while(1){if((d|0)==(A|0))break;H=e;if(Mi[f[c>>2]&1023](d,i)|0){f[e>>2]=f[d>>2];J=d;K=d+8|0;L=i}else{f[e>>2]=f[i>>2];J=i;K=d;L=i+8|0}f[H+4>>2]=f[J+4>>2];M=H+8|0;if((L|0)==(b|0)){N=15;break}else{d=K;i=L;e=M}}if((N|0)==15){if((K|0)==(A|0)){u=h;return}else{O=K;P=M}while(1){f[P>>2]=f[O>>2];f[P+4>>2]=f[O+4>>2];O=O+8|0;if((O|0)==(A|0))break;else P=P+8|0}u=h;return}if((i|0)==(b|0)){u=h;return}P=i;i=e;while(1){f[i>>2]=f[P>>2];f[i+4>>2]=f[P+4>>2];P=P+8|0;if((P|0)==(b|0))break;else i=i+8|0}u=h;return}}}function nyb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){XIc(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)mCc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;XIc(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;YDc(h);return}function oyb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+32|0;h=g+8|0;i=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;switch(d|0){case 1:{n=f[a>>2]|0;o=f[n+4>>2]|0;p=e;f[p>>2]=f[n>>2];f[p+4>>2]=o;u=g;return}case 2:{o=f[c>>2]|0;p=(f[b>>2]|0)+-8|0;f[b>>2]=p;n=Mi[o&1023](p,f[a>>2]|0)|0;p=f[(n?b:a)>>2]|0;o=f[p+4>>2]|0;q=e;f[q>>2]=f[p>>2];f[q+4>>2]=o;o=f[(n?a:b)>>2]|0;n=f[o+4>>2]|0;q=e+8|0;f[q>>2]=f[o>>2];f[q+4>>2]=n;u=g;return}case 0:{u=g;return}default:{if((d|0)<9){n=f[a>>2]|0;q=f[b>>2]|0;if((n|0)==(q|0)){u=g;return}o=n;p=f[o+4>>2]|0;r=e;f[r>>2]=f[o>>2];f[r+4>>2]=p;p=n+8|0;if((p|0)==(q|0)){u=g;return}else{s=p;t=e}do{p=t;t=t+8|0;if(Mi[f[c>>2]&1023](s,p)|0){n=p;r=f[n+4>>2]|0;o=t;f[o>>2]=f[n>>2];f[o+4>>2]=r;a:do if((p|0)==(e|0))v=e;else{r=p;while(1){o=r;r=r+-8|0;if(!(Mi[f[c>>2]&1023](s,r)|0)){v=o;break a}f[o>>2]=f[r>>2];f[o+4>>2]=f[o+-4>>2];if((r|0)==(e|0)){v=e;break}}}while(0);f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2]}else{p=s;r=f[p+4>>2]|0;o=t;f[o>>2]=f[p>>2];f[o+4>>2]=r}s=s+8|0}while((s|0)!=(q|0));u=g;return}q=d>>>1;s=f[a>>2]|0;a=s+(q<<3)|0;t=s;f[j>>2]=t;f[k>>2]=a;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];myb(i,h,c,q,e,q);f[l>>2]=a;k=f[b>>2]|0;f[m>>2]=k;b=d-q|0;f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];myb(i,h,c,b,e+(q<<3)|0,b);b=k;f[h>>2]=a;f[i>>2]=t;b:do if(q){if((a|0)==(b|0)){w=e;x=s}else{t=e;k=s;m=a;while(1){l=Mi[f[c>>2]&1023](m,k)|0;d=l?h:i;l=f[d>>2]|0;j=l;v=f[j+4>>2]|0;r=t;f[r>>2]=f[j>>2];f[r+4>>2]=v;f[d>>2]=l+8;l=t+8|0;d=f[i>>2]|0;m=f[h>>2]|0;if((d|0)==(a|0)){y=l;z=m;A=16;break b}if((m|0)==(b|0)){w=l;x=d;break}else{t=l;k=d}}}if((x|0)!=(a|0)){k=(a+-8-x|0)>>>3;t=w;m=x;while(1){d=m;l=f[d+4>>2]|0;v=t;f[v>>2]=f[d>>2];f[v+4>>2]=l;m=m+8|0;if((m|0)==(a|0))break;else t=t+8|0}f[i>>2]=x+(k+1<<3)}}else{y=e;z=s;A=16}while(0);if((A|0)==16?(z|0)!=(b|0):0){A=(b+-8-z|0)>>>3;s=y;y=z;while(1){e=y;x=f[e+4>>2]|0;i=s;f[i>>2]=f[e>>2];f[i+4>>2]=x;y=y+8|0;if((y|0)==(b|0))break;else s=s+8|0}f[h>>2]=z+(A+1<<3)}u=g;return}}}function pyb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;j=u;u=u+64|0;k=j+52|0;l=j;m=j+48|0;n=j+44|0;o=j+40|0;p=j+36|0;q=j+16|0;r=j+8|0;s=j+32|0;t=j+28|0;v=j+24|0;w=j+20|0;x=j+12|0;y=j+4|0;if(!g){u=j;return}z=e;e=g;a:while(1){if(!((e|0)>(i|0)&(z|0)>(i|0))){A=6;break}if(!z){A=37;break}B=f[b>>2]|0;g=B;C=z;D=f[a>>2]|0;while(1){if(Mi[f[d>>2]&1023](B,D)|0)break;E=D+8|0;f[a>>2]=E;F=C+-1|0;if(!F){A=37;break a}else{C=F;D=E}}E=D;if((C|0)<(e|0)){F=(e|0)/2|0;G=B+(F<<3)|0;f[r>>2]=G;H=g-E>>3;if(!H)I=D;else{J=H;H=D;K=D;while(1){L=(J|0)/2|0;M=K+(L<<3)|0;N=Mi[f[d>>2]&1023](G,M)|0;O=M+8|0;M=N?H:O;J=N?L:J+-1-L|0;if(!J){I=M;break}else{H=M;K=N?K:O}}}K=I;f[q>>2]=K;P=K-E>>3;Q=F;R=G;S=I}else{if((C|0)==1){A=14;break}K=(C|0)/2|0;H=D+(K<<3)|0;f[q>>2]=H;J=(f[c>>2]|0)-g>>3;if(!J)T=B;else{O=J;J=B;N=B;while(1){M=(O|0)/2|0;L=N+(M<<3)|0;U=Mi[f[d>>2]&1023](L,H)|0;V=L+8|0;L=U?V:J;O=U?O+-1-M|0:M;if(!O){T=L;break}else{J=L;N=U?V:N}}}N=T;f[r>>2]=N;P=K;Q=N-g>>3;R=T;S=H}N=C-P|0;J=e-Q|0;if((S|0)!=(B|0))if((B|0)==(R|0))W=S;else{f[l>>2]=g;O=S;G=l;F=k;b:while(1){f[F>>2]=f[G>>2];E=f[l>>2]|0;V=f[k>>2]|0;X=O;do{U=f[X>>2]|0;f[X>>2]=f[V>>2];f[V>>2]=U;U=X+4|0;L=V+4|0;M=f[U>>2]|0;f[U>>2]=f[L>>2];f[L>>2]=M;X=X+8|0;V=V+8|0;Y=(X|0)==(E|0);if((V|0)==(R|0))break b}while(!Y);f[k>>2]=V;O=E;G=k;F=l}f[k>>2]=R;if(!Y){F=k;G=l;O=X;while(1){f[F>>2]=f[G>>2];g=f[l>>2]|0;C=g;H=f[k>>2]|0;K=O;while(1){M=f[K>>2]|0;f[K>>2]=f[H>>2];f[H>>2]=M;M=K+4|0;L=H+4|0;U=f[M>>2]|0;f[M>>2]=f[L>>2];f[L>>2]=U;K=K+8|0;H=H+8|0;Z=(K|0)==(C|0);if((H|0)==(R|0)){A=30;break}if(Z){A=27;break}}if((A|0)==27){A=0;f[k>>2]=H;F=l;G=k;O=g;continue}else if((A|0)==30){A=0;f[k>>2]=R;if(Z)break;else{F=k;G=l;O=K;continue}}}}W=X}else W=R;f[b>>2]=W;O=W;if((P+Q|0)<(N+J|0)){f[s>>2]=f[a>>2];f[t>>2]=f[q>>2];f[v>>2]=O;f[m>>2]=f[s>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];pyb(m,l,k,d,P,Q,h,i);_=J;$=N;aa=r;ba=a}else{f[w>>2]=O;f[x>>2]=f[r>>2];f[y>>2]=f[c>>2];f[m>>2]=f[w>>2];f[l>>2]=f[x>>2];f[k>>2]=f[y>>2];pyb(m,l,k,d,N,J,h,i);_=Q;$=P;aa=q;ba=c}f[ba>>2]=O;f[b>>2]=f[aa>>2];if(!_){A=37;break}else{z=$;e=_}}if((A|0)==6){f[n>>2]=f[a>>2];f[o>>2]=f[b>>2];f[p>>2]=f[c>>2];f[m>>2]=f[n>>2];f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];qyb(m,l,k,d,z,e,h);u=j;return}else if((A|0)==14){h=f[D>>2]|0;f[D>>2]=f[B>>2];f[B>>2]=h;h=D+4|0;D=B+4|0;B=f[h>>2]|0;f[h>>2]=f[D>>2];f[D>>2]=B;u=j;return}else if((A|0)==37){u=j;return}}function qyb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+16|0;j=i+4|0;k=i;if((e|0)>(g|0)){g=f[b>>2]|0;e=g;l=f[c>>2]|0;if((e|0)==(l|0))m=h;else{n=((l+-8+(0-g)|0)>>>3)+1|0;o=h;p=g;q=e;while(1){r=p;s=f[r+4>>2]|0;t=o;f[t>>2]=f[r>>2];f[t+4>>2]=s;s=q+8|0;if((s|0)==(l|0))break;else{o=o+8|0;p=s;q=s}}m=h+(n<<3)|0}n=f[a>>2]|0;f[j>>2]=g;f[k>>2]=m;a:do if((m|0)!=(h|0)){if((e|0)==(n|0)){v=m;w=l}else{g=e;q=m;p=l;while(1){o=Mi[f[d>>2]&1023](g+-8|0,q+-8|0)|0;s=o?k:j;o=f[s>>2]|0;t=o+-8|0;r=p+-8|0;f[r>>2]=f[t>>2];f[p+-4>>2]=f[o+-4>>2];f[s>>2]=t;t=f[k>>2]|0;if((t|0)==(h|0))break a;g=f[j>>2]|0;if((g|0)==(n|0)){v=t;w=r;break}else{q=t;p=r}}}if((v|0)!=(h|0)){p=v;q=w;do{g=p;p=p+-8|0;r=q;q=q+-8|0;f[q>>2]=f[p>>2];f[r+-4>>2]=f[g+-4>>2]}while((p|0)!=(h|0))}}while(0);u=i;return}w=f[a>>2]|0;a=w;v=f[b>>2]|0;if((a|0)==(v|0)){u=i;return}b=((v+-8+(0-w)|0)>>>3)+1|0;n=h;j=w;k=a;while(1){a=j;l=f[a+4>>2]|0;m=n;f[m>>2]=f[a>>2];f[m+4>>2]=l;l=k+8|0;if((l|0)==(v|0))break;else{n=n+8|0;j=l;k=l}}k=h+(b<<3)|0;b=f[d>>2]|0;if((k|0)==(h|0)){u=i;return}d=f[c>>2]|0;c=h;h=w;w=v;while(1){if((w|0)==(d|0))break;v=h;if(Mi[b&1023](w,c)|0){f[h>>2]=f[w>>2];x=w;y=c;z=w+8|0}else{f[h>>2]=f[c>>2];x=c;y=c+8|0;z=w}f[v+4>>2]=f[x+4>>2];if((y|0)==(k|0)){A=25;break}else{c=y;h=v+8|0;w=z}}if((A|0)==25){u=i;return}A=c;c=h;while(1){f[c>>2]=f[A>>2];f[c+4>>2]=f[A+4>>2];A=A+8|0;if((A|0)==(k|0))break;else c=c+8|0}u=i;return}function ryb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=b;j=h;do{f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;j=(f[g>>2]|0)+12|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);u=c;return}i=f[a>>2]|0;j=(h-i|0)/12|0;h=j+b|0;if(h>>>0>357913941)mCc(a);g=(e-i|0)/12|0;i=g<<1;e=g>>>0<178956970?(i>>>0<h>>>0?h:i):357913941;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>357913941){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{k=VDc(e*12|0)|0;break}else k=0;while(0);f[d>>2]=k;i=k+(j*12|0)|0;j=d+8|0;f[j>>2]=i;g=d+4|0;f[g>>2]=i;f[d+12>>2]=k+(e*12|0);e=b;b=i;while(1){f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=b+4;e=e+-1|0;if(!e)break;else b=b+12|0}f[j>>2]=k+(h*12|0);wyb(a,d);a=f[g>>2]|0;g=f[j>>2]|0;if((g|0)!=(a|0)){h=g;do{g=h+-12|0;f[j>>2]=g;Pxb(g,f[h+-8>>2]|0);h=f[j>>2]|0}while((h|0)!=(a|0))}a=f[d>>2]|0;if(a|0)YDc(a);u=c;return}function syb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;l=u;u=u+16|0;m=l;n=(f[a+4>>2]|0)-(f[a>>2]|0)|0;o=(n|0)/24|0;p=f[c>>2]|0;q=p;if((o|0)!=(((f[c+4>>2]|0)-p|0)/12|0|0)){f[m>>2]=0;f[m+4>>2]=0;r=tT(m,45)|0;s=447304;t=r+45|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,m,447350,446605,745)}if((o|0)!=(((f[j+4>>2]|0)-(f[j>>2]|0)|0)/24|0|0)){f[m>>2]=0;f[m+4>>2]=0;r=tT(m,36)|0;s=447363;t=r+36|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,m,447350,446605,746)}if(n|0?((f[q+4>>2]|0)-(f[p>>2]|0)|0)!=16:0){f[m>>2]=0;f[m+4>>2]=0;r=tT(m,49)|0;s=447400;t=r+49|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,m,447350,446605,748)}m=f[k>>2]|0;s=k+4|0;r=f[s>>2]|0;t=m;if((r|0)==(m|0))v=r;else{p=r+(~(((r+-24-t|0)>>>0)/24|0)*24|0)|0;f[s>>2]=p;v=p}p=(v-t|0)/24|0;if(o>>>0<=p>>>0){if(o>>>0<p>>>0?(t=m+(o*24|0)|0,(v|0)!=(t|0)):0)f[s>>2]=v+(~(((v+-24-t|0)>>>0)/24|0)*24|0)}else tyb(k,o-p|0);p=(n|0)!=0;if(e){if(!p){u=l;return}e=0;do{uyb((f[a>>2]|0)+(e*24|0)|0,(f[c>>2]|0)+(e*12|0)|0,d,g,h,i,(f[j>>2]|0)+(e*24|0)|0,(f[k>>2]|0)+(e*24|0)|0);e=e+1|0}while(e>>>0<o>>>0);u=l;return}else{if(!p){u=l;return}p=0;do{vyb((f[a>>2]|0)+(p*24|0)|0,(f[c>>2]|0)+(p*12|0)|0,d,g,h,i,(f[j>>2]|0)+(p*24|0)|0,(f[k>>2]|0)+(p*24|0)|0);p=p+1|0}while(p>>>0<o>>>0);u=l;return}}function tyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/24|0)>>>0>=c>>>0){i=c;j=h;do{n[j+20>>2]=0.0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;b[j+16>>0]=0;j=(f[g>>2]|0)+24|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/24|0;h=j+c|0;if(h>>>0>178956970)mCc(a);k=(e-i|0)/24|0;i=k<<1;e=k>>>0<89478485?(i>>>0<h>>>0?h:i):178956970;do if(e)if(e>>>0>178956970){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{l=VDc(e*24|0)|0;break}else l=0;while(0);i=l+(j*24|0)|0;j=l+(e*24|0)|0;e=c;c=i;l=i;do{n[l+20>>2]=0.0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;b[l+16>>0]=0;l=c+24|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(((l|0)/-24|0)*24|0)|0;if((l|0)>0)dJc(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;YDc(e);return}function uyb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;c=u;u=u+16|0;k=c;l=+n[i>>2];m=+n[i+4>>2];o=+n[i+8>>2];p=+n[i+12>>2];i=f[d>>2]|0;do if((i|0)!=446726?(d=(i|0)==0?1154740:i,(Ioc(d,446726)|0)!=0):0){if((i|0)!=446714?Ioc(d,446714)|0:0){f[k>>2]=0;f[k+4>>2]=0;q=tT(k,13)|0;r=447494;t=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));z5(-5,k,447466,446605,722)}v=+n[a>>2];w=+n[a+8>>2]-v;x=+n[a+4>>2];y=+n[a+12>>2]-x;z=h?y:y+1.0;y=h?w:w+1.0;if(!(y>0.0)){f[k>>2]=0;f[k+4>>2]=0;q=tT(k,15)|0;r=447450;t=q+15|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));z5(-215,k,447466,446605,705)}if(z>0.0){w=z*+V(+p);A=l*y+(v+y*.5);B=y*+V(+o)*.5;C=A-B;n[j>>2]=C;D=m*z+(x+z*.5);E=w*.5;w=D-E;n[j+4>>2]=w;F=A+B;n[j+8>>2]=F;G=w;H=F;I=D+E;J=C;break}else{f[k>>2]=0;f[k+4>>2]=0;q=tT(k,16)|0;r=447477;t=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));z5(-215,k,447466,446605,706)}}else K=3;while(0);if((K|0)==3){z=l+ +n[a>>2];n[j>>2]=z;l=m+ +n[a+4>>2];n[j+4>>2]=l;m=o+ +n[a+8>>2];n[j+8>>2]=m;G=l;H=m;I=p+ +n[a+12>>2];J=z}a=j+12|0;n[a>>2]=I;if(e){e=g+8|0;K=+n[e>>2]<J?e:j;k=f[(+n[K>>2]<+n[g>>2]?g:K)>>2]|0;f[j>>2]=k;K=j+4|0;r=g+12|0;q=+n[r>>2]<G?r:K;t=g+4|0;i=f[(+n[q>>2]<+n[t>>2]?t:q)>>2]|0;f[K>>2]=i;K=j+8|0;q=+n[e>>2]<H?e:K;e=f[(+n[q>>2]<+n[g>>2]?g:q)>>2]|0;f[K>>2]=e;K=+n[r>>2]<I?r:a;r=f[(+n[K>>2]<+n[t>>2]?t:K)>>2]|0;f[a>>2]=r;z=(f[s>>2]=e,+n[s>>2]);p=(f[s>>2]=k,+n[s>>2]);m=(f[s>>2]=r,+n[s>>2]);L=p;M=z;N=(f[s>>2]=i,+n[s>>2]);O=m}else{L=J;M=H;N=G;O=I}i=j+20|0;n[i>>2]=0.0;r=j+16|0;b[r>>0]=0;if(M<L|O<N){P=0.0;n[i>>2]=P;b[r>>0]=1;u=c;return}I=M-L;L=O-N;if(h){P=I*L;n[i>>2]=P;b[r>>0]=1;u=c;return}else{P=(I+1.0)*(L+1.0);n[i>>2]=P;b[r>>0]=1;u=c;return}}function vyb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0;k=u;u=u+16|0;l=k;m=f[c>>2]|0;o=+n[m>>2]*+n[i>>2];p=+n[m+4>>2]*+n[i+4>>2];q=+n[m+8>>2]*+n[i+8>>2];r=+n[m+12>>2]*+n[i+12>>2];i=f[d>>2]|0;do if((i|0)!=446726?(d=(i|0)==0?1154740:i,(Ioc(d,446726)|0)!=0):0){if((i|0)!=446714?Ioc(d,446714)|0:0){f[l>>2]=0;f[l+4>>2]=0;t=tT(l,13)|0;v=447494;w=t+13|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-5,l,447466,446605,722)}x=+n[a>>2];y=+n[a+8>>2]-x;z=+n[a+4>>2];A=+n[a+12>>2]-z;B=h?A:A+1.0;A=h?y:y+1.0;if(!(A>0.0)){f[l>>2]=0;f[l+4>>2]=0;t=tT(l,15)|0;v=447450;w=t+15|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,l,447466,446605,705)}if(B>0.0){y=B*+V(+r);C=o*A+(x+A*.5);D=A*+V(+q)*.5;E=C-D;n[j>>2]=E;F=p*B+(z+B*.5);G=y*.5;y=F-G;n[j+4>>2]=y;H=C+D;n[j+8>>2]=H;I=F+G;J=E;K=y;L=H;break}else{f[l>>2]=0;f[l+4>>2]=0;t=tT(l,16)|0;v=447477;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,l,447466,446605,706)}}else M=3;while(0);if((M|0)==3){B=o+ +n[a>>2];n[j>>2]=B;o=p+ +n[a+4>>2];n[j+4>>2]=o;p=q+ +n[a+8>>2];n[j+8>>2]=p;I=r+ +n[a+12>>2];J=B;K=o;L=p}a=j+12|0;n[a>>2]=I;if(e){e=g+8|0;M=+n[e>>2]<J?e:j;l=f[(+n[M>>2]<+n[g>>2]?g:M)>>2]|0;f[j>>2]=l;M=j+4|0;v=g+12|0;t=+n[v>>2]<K?v:M;w=g+4|0;i=f[(+n[t>>2]<+n[w>>2]?w:t)>>2]|0;f[M>>2]=i;M=j+8|0;t=+n[e>>2]<L?e:M;e=f[(+n[t>>2]<+n[g>>2]?g:t)>>2]|0;f[M>>2]=e;M=+n[v>>2]<I?v:a;v=f[(+n[M>>2]<+n[w>>2]?w:M)>>2]|0;f[a>>2]=v;p=(f[s>>2]=e,+n[s>>2]);o=(f[s>>2]=l,+n[s>>2]);B=(f[s>>2]=v,+n[s>>2]);N=o;O=p;P=(f[s>>2]=i,+n[s>>2]);Q=B}else{N=J;O=L;P=K;Q=I}i=j+20|0;n[i>>2]=0.0;v=j+16|0;b[v>>0]=0;if(O<N|Q<P){R=0.0;n[i>>2]=R;b[v>>0]=1;u=k;return}I=O-N;N=Q-P;if(h){R=I*N;n[i>>2]=R;b[v>>0]=1;u=k;return}else{R=(I+1.0)*(N+1.0);n[i>>2]=R;b[v>>0]=1;u=k;return}}function wyb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;i=f[a>>2]|0;j=a+4|0;k=f[j>>2]|0;l=b+4|0;if((k|0)==(i|0)){m=l;n=a;o=f[l>>2]|0;p=i;f[n>>2]=o;f[m>>2]=p;q=b+8|0;r=f[j>>2]|0;s=f[q>>2]|0;f[j>>2]=s;f[q>>2]=r;t=a+8|0;v=b+12|0;w=f[t>>2]|0;x=f[v>>2]|0;f[t>>2]=x;f[v>>2]=w;y=f[m>>2]|0;f[b>>2]=y;u=c;return}z=k;k=f[l>>2]|0;do{A=k+-12|0;B=z;z=z+-12|0;C=k+-8|0;f[C>>2]=0;D=k+-4|0;f[D>>2]=0;E=k+-8|0;f[A>>2]=E;F=f[z>>2]|0;G=B+-8|0;if((F|0)!=(G|0)){B=E;E=F;while(1){F=E+16|0;f[h>>2]=B;f[d>>2]=f[h>>2];H=xyb(A,d,e,g,F)|0;if(!(f[H>>2]|0)){I=VDc(32)|0;f[I+16>>2]=f[F>>2];yyb(I+20|0,E+20|0);F=f[e>>2]|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=F;f[H>>2]=I;F=f[f[A>>2]>>2]|0;if(!F)J=I;else{f[A>>2]=F;J=f[H>>2]|0}laa(f[C>>2]|0,J);f[D>>2]=(f[D>>2]|0)+1}H=f[E+4>>2]|0;if(!H){F=E+8|0;I=f[F>>2]|0;if((f[I>>2]|0)==(E|0))K=I;else{I=F;do{F=f[I>>2]|0;I=F+8|0;L=f[I>>2]|0}while((f[L>>2]|0)!=(F|0));K=L}}else{I=H;while(1){L=f[I>>2]|0;if(!L)break;else I=L}K=I}if((K|0)==(G|0))break;else E=K}}k=(f[l>>2]|0)+-12|0;f[l>>2]=k}while((z|0)!=(i|0));m=l;n=a;o=k;p=f[a>>2]|0;f[n>>2]=o;f[m>>2]=p;q=b+8|0;r=f[j>>2]|0;s=f[q>>2]|0;f[j>>2]=s;f[q>>2]=r;t=a+8|0;v=b+12|0;w=f[t>>2]|0;x=f[v>>2]|0;f[t>>2]=x;f[v>>2]=w;y=f[m>>2]|0;f[b>>2]=y;u=c;return}function xyb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function yyb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/24|0;if(!e)return;if(g>>>0>178956970)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*24|0);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;dJc(h|0,g|0,b|0)|0;f[c>>2]=h+(((b>>>0)/24|0)*24|0);return}function zyb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){XIc(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)mCc(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{n=VDc(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;XIc(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{g=g+-12|0;CF(j+-12|0,g);j=h+-12|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~((q+-4-d|0)>>>2)<<2);YDc(d)}}while((c|0)!=(k|0))}if(!p)return;YDc(p);return}function Ayb(a,b){a=a|0;b=b|0;var c=0;c=VDc(64)|0;Byb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=103968;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Byb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0.0,L=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=103988;KHa(a,c);if(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)!=56){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,17)|0;h=447717;i=g+17|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,447735,447751,70)}f[e>>2]=0;f[e+4>>2]=0;j=tT(e,6)|0;b[j>>0]=b[454316]|0;b[j+1>>0]=b[454317]|0;b[j+2>>0]=b[454318]|0;b[j+3>>0]=b[454319]|0;b[j+4>>0]=b[454320]|0;b[j+5>>0]=b[454321]|0;j=c+4|0;c=f[j>>2]|0;do if(c){k=f[e>>2]|0;l=(k|0)==0?1154740:k;m=j;o=c;a:while(1){p=o;while(1){q=f[p+16>>2]|0;if((q|0)==(k|0))break;if((Ioc((q|0)==0?1154740:q,l)|0)>=0)break;q=f[p+4>>2]|0;if(!q){r=m;break a}else p=q}o=f[p>>2]|0;if(!o){r=p;break}else m=p}if((r|0)!=(j|0)){m=f[r+16>>2]|0;if((k|0)!=(m|0)?(Ioc(l,(m|0)==0?1154740:m)|0)<=-1:0){s=.20000000298023224;break}s=+tIa(r+24|0,-1)}else s=.20000000298023224}else s=.20000000298023224;while(0);n[a+52>>2]=s;uT(e);f[e>>2]=0;f[e+4>>2]=0;r=tT(e,6)|0;b[r>>0]=b[454323]|0;b[r+1>>0]=b[454324]|0;b[r+2>>0]=b[454325]|0;b[r+3>>0]=b[454326]|0;b[r+4>>0]=b[454327]|0;b[r+5>>0]=b[454328]|0;r=f[j>>2]|0;do if(r){c=f[e>>2]|0;m=(c|0)==0?1154740:c;o=j;q=r;b:while(1){t=q;while(1){v=f[t+16>>2]|0;if((v|0)==(c|0))break;if((Ioc((v|0)==0?1154740:v,m)|0)>=0)break;v=f[t+4>>2]|0;if(!v){w=o;break b}else t=v}q=f[t>>2]|0;if(!q){w=t;break}else o=t}if((w|0)!=(j|0)){o=f[w+16>>2]|0;if((c|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){x=4;break}o=DHa(w+24|0,-1)|0;x=o}else x=4}else x=4;while(0);w=a+36|0;f[w>>2]=x;uT(e);f[e>>2]=0;f[e+4>>2]=0;x=tT(e,7)|0;b[x>>0]=b[454330]|0;b[x+1>>0]=b[454331]|0;b[x+2>>0]=b[454332]|0;b[x+3>>0]=b[454333]|0;b[x+4>>0]=b[454334]|0;b[x+5>>0]=b[454335]|0;b[x+6>>0]=b[454336]|0;x=f[j>>2]|0;do if(x){r=f[e>>2]|0;o=(r|0)==0?1154740:r;q=j;l=x;c:while(1){k=l;while(1){p=f[k+16>>2]|0;if((p|0)==(r|0))break;if((Ioc((p|0)==0?1154740:p,o)|0)>=0)break;p=f[k+4>>2]|0;if(!p){y=q;break c}else k=p}l=f[k>>2]|0;if(!l){y=k;break}else q=k}if((y|0)!=(j|0)){q=f[y+16>>2]|0;if((r|0)!=(q|0)?(Ioc(o,(q|0)==0?1154740:q)|0)<=-1:0){z=0;break}q=DHa(y+24|0,-1)|0;z=q}else z=0}else z=0;while(0);y=a+40|0;f[y>>2]=z;uT(e);f[e>>2]=0;f[e+4>>2]=0;z=tT(e,7)|0;b[z>>0]=b[453755]|0;b[z+1>>0]=b[453756]|0;b[z+2>>0]=b[453757]|0;b[z+3>>0]=b[453758]|0;b[z+4>>0]=b[453759]|0;b[z+5>>0]=b[453760]|0;b[z+6>>0]=b[453761]|0;z=f[j>>2]|0;do if(z){x=f[e>>2]|0;q=(x|0)==0?1154740:x;l=j;m=z;d:while(1){c=m;while(1){t=f[c+16>>2]|0;if((t|0)==(x|0))break;if((Ioc((t|0)==0?1154740:t,q)|0)>=0)break;t=f[c+4>>2]|0;if(!t){A=l;break d}else c=t}m=f[c>>2]|0;if(!m){A=c;break}else l=c}if((A|0)!=(j|0)){l=f[A+16>>2]|0;if((x|0)!=(l|0)?(Ioc(q,(l|0)==0?1154740:l)|0)<=-1:0){B=5;break}l=DHa(A+24|0,-1)|0;B=l}else B=5}else B=5;while(0);A=a+44|0;f[A>>2]=B;uT(e);f[e>>2]=0;f[e+4>>2]=0;B=tT(e,8)|0;z=B;b[z>>0]=99;b[z+1>>0]=108;b[z+2>>0]=97;b[z+3>>0]=115;z=B+4|0;b[z>>0]=115;b[z+1>>0]=102;b[z+2>>0]=105;b[z+3>>0]=120;z=f[j>>2]|0;do if(z){B=f[e>>2]|0;l=(B|0)==0?1154740:B;m=j;o=z;e:while(1){r=o;while(1){k=f[r+16>>2]|0;if((k|0)==(B|0))break;if((Ioc((k|0)==0?1154740:k,l)|0)>=0)break;k=f[r+4>>2]|0;if(!k){C=m;break e}else r=k}o=f[r>>2]|0;if(!o){C=r;break}else m=r}if((C|0)!=(j|0)){m=f[C+16>>2]|0;if((B|0)!=(m|0)?(Ioc(l,(m|0)==0?1154740:m)|0)<=-1:0){D=0;break}m=DHa(C+24|0,-1)|0;D=m}else D=0}else D=0;while(0);f[a+48>>2]=D;uT(e);f[e>>2]=0;f[e+4>>2]=0;D=tT(e,7)|0;b[D>>0]=b[454214]|0;b[D+1>>0]=b[454215]|0;b[D+2>>0]=b[454216]|0;b[D+3>>0]=b[454217]|0;b[D+4>>0]=b[454218]|0;b[D+5>>0]=b[454219]|0;b[D+6>>0]=b[454220]|0;D=f[j>>2]|0;do if(D){C=f[e>>2]|0;z=(C|0)==0?1154740:C;m=j;o=D;f:while(1){q=o;while(1){x=f[q+16>>2]|0;if((x|0)==(C|0))break;if((Ioc((x|0)==0?1154740:x,z)|0)>=0)break;x=f[q+4>>2]|0;if(!x){E=m;break f}else q=x}o=f[q>>2]|0;if(!o){E=q;break}else m=q}if((E|0)!=(j|0)){m=f[E+16>>2]|0;if((C|0)!=(m|0)?(Ioc(z,(m|0)==0?1154740:m)|0)<=-1:0){F=0;break}m=DHa(E+24|0,-1)|0;F=(m|0)!=0|(J|0)!=0}else F=0}else F=0;while(0);E=a+60|0;b[E>>0]=F&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;F=tT(e,8)|0;D=F;b[D>>0]=108;b[D+1>>0]=111;b[D+2>>0]=103;b[D+3>>0]=105;D=F+4|0;b[D>>0]=115;b[D+1>>0]=116;b[D+2>>0]=105;b[D+3>>0]=99;D=f[j>>2]|0;do if(D){F=f[e>>2]|0;m=(F|0)==0?1154740:F;o=j;l=D;g:while(1){B=l;while(1){r=f[B+16>>2]|0;if((r|0)==(F|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[B+4>>2]|0;if(!r){G=o;break g}else B=r}l=f[B>>2]|0;if(!l){G=B;break}else o=B}if((G|0)!=(j|0)){o=f[G+16>>2]|0;if((F|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){H=0;break}o=DHa(G+24|0,-1)|0;H=(o|0)!=0|(J|0)!=0}else H=0}else H=0;while(0);G=a+61|0;b[G>>0]=H&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,13)|0;h=447828;i=g+13|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));H=f[j>>2]|0;do if(H){D=f[e>>2]|0;o=(D|0)==0?1154740:D;l=j;z=H;h:while(1){C=z;while(1){q=f[C+16>>2]|0;if((q|0)==(D|0))break;if((Ioc((q|0)==0?1154740:q,o)|0)>=0)break;q=f[C+4>>2]|0;if(!q){I=l;break h}else C=q}z=f[C>>2]|0;if(!z){I=C;break}else l=C}if((I|0)!=(j|0)){l=f[I+16>>2]|0;if((D|0)!=(l|0)?(Ioc(o,(l|0)==0?1154740:l)|0)<=-1:0){K=.4000000059604645;break}K=+tIa(I+24|0,-1)}else K=.4000000059604645}else K=.4000000059604645;while(0);I=a+56|0;n[I>>2]=K;uT(e);if(!(+n[I>>2]>=0.0)){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,18)|0;h=447842;i=g+18|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,447735,447751,81)}if((f[w>>2]|0)!=4){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,11)|0;h=447861;i=g+11|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,447735,447751,82)}if((f[y>>2]|0)<=0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,12)|0;h=447873;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,447735,447751,83)}if((f[A>>2]|0)<=0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,12)|0;h=447886;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,447735,447751,84)}if((b[G>>0]|0)==0?(b[E>>0]|0)==0:0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,25)|0;h=447899;i=g+25|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,447735,447751,85)}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,12)|0;h=454665;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));E=f[j>>2]|0;if(!E){uT(e);u=d;return}G=f[e>>2]|0;A=(G|0)==0?1154740:G;y=j;w=E;i:while(1){E=w;while(1){I=f[E+16>>2]|0;if((I|0)==(G|0))break;if((Ioc((I|0)==0?1154740:I,A)|0)>=0)break;I=f[E+4>>2]|0;if(!I){L=y;break i}else E=I}w=f[E>>2]|0;if(!w){L=E;break}else y=E}if((L|0)==(j|0)){uT(e);u=d;return}j=f[L+16>>2]|0;if((G|0)!=(j|0)?(Ioc(A,(j|0)==0?1154740:j)|0)<=-1:0){uT(e);u=d;return}j=DHa(L+24|0,-1)|0;L=(j|0)!=0|(J|0)!=0;uT(e);if(L){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,27)|0;h=447925;i=g+27|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-213,e,447735,447751,87)}else{u=d;return}}function Cyb(a){a=a|0;YDc(a);return}function Dyb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Eyb(a){a=a|0;REa(a);YDc(a);return}function Fyb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0;g=u;u=u+48|0;h=g+32|0;i=g+20|0;j=g+8|0;k=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;f[i>>2]=0;m=i+4|0;f[m>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f$(c,h);f$(d,i);f$(e,j);e=f[h>>2]|0;d=e;if((f[l>>2]|0)==(e|0)){f[k>>2]=0;f[k+4>>2]=0;o=tT(k,18)|0;p=448e3;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,453206,447751,218)}c=f[m>>2]|0;r=f[i>>2]|0;if((c-r|0)!=56){f[k>>2]=0;f[k+4>>2]=0;o=tT(k,19)|0;p=453252;q=o+19|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,453206,447751,219)}s=a+40|0;t=(f[s>>2]|0)+1+(f[a+36>>2]|0)|0;v=f[(f[a+4>>2]|0)+16>>2]|0;a:do if((c|0)!=(r|0)){w=a+44|0;x=a+60|0;y=a+61|0;z=a+56|0;A=a+52|0;B=a+48|0;C=0;D=c;E=r;F=d;G=e;while(1){H=E;I=f[F+(C*56|0)+40>>2]|0;J=f[I>>2]|0;K=f[I+4>>2]|0;L=f[I+8>>2]|0;M=Y(Y(K,t)|0,L)|0;N=f[w>>2]|0;O=Y(M,N)|0;M=Y(O,J)|0;P=f[F+(C*56|0)+4>>2]|0;if((P|0)<3)Q=Y(f[F+(C*56|0)+12>>2]|0,f[F+(C*56|0)+8>>2]|0)|0;else{R=1;S=J;while(1){T=Y(f[I+(R<<2)>>2]|0,S)|0;R=R+1|0;if((R|0)==(P|0)){Q=T;break}else S=T}}if((M|0)!=(Q|0)){U=14;break}S=f[H+(C*56|0)+4>>2]|0;if((S|0)<3)W=Y(f[H+(C*56|0)+12>>2]|0,f[H+(C*56|0)+8>>2]|0)|0;else{P=f[H+(C*56|0)+40>>2]|0;R=0;I=1;while(1){T=Y(f[P+(R<<2)>>2]|0,I)|0;R=R+1|0;if((R|0)==(S|0)){W=T;break}else I=T}}if((M|0)!=(W|0)){U=20;break}I=f[l>>2]|0;if(((I-G|0)/56|0)>>>0>=2?(f[F+60>>2]|0)!=4:0){U=23;break}if(((I-G|0)/56|0)>>>0>1)X=f[(f[F+96>>2]|0)+8>>2]|0;else X=K;if(((I-G|0)/56|0)>>>0>1)Z=f[(f[F+96>>2]|0)+12>>2]|0;else Z=L;I=f[F+(C*56|0)+16>>2]|0;S=f[H+(C*56|0)+16>>2]|0;R=Y(N,Y(Y(K,J)|0,L)|0)|0;P=(R|0)>0;if(P){T=0;do{_=(Y(T,t)|0)+4|0;$=1.0/(+V(+-+n[I+(_<<2)>>2])+1.0);n[S+(_<<2)>>2]=$;T=T+1|0}while((T|0)<(R|0))}if(!(b[x>>0]|0)){if(!((b[y>>0]|0)==0|P^1)?(T=f[s>>2]|0,(T|0)>0):0){H=0;do{M=Y(H,t)|0;_=I+(M<<2)+20|0;aa=S+(M<<2)+20|0;M=0;do{$=1.0/(+V(+-+n[_+(M<<2)>>2])+1.0);n[aa+(M<<2)>>2]=$;M=M+1|0}while((M|0)<(T|0));H=H+1|0}while((H|0)<(R|0))}}else if(P?(H=f[s>>2]|0,(H|0)>0):0){T=0;do{M=Y(T,t)|0;aa=I+(M<<2)+20|0;_=S+(M<<2)|0;$=-3402823466385288598117041.0e14;M=0;do{ba=+n[aa+(M<<2)>>2];$=ba>$?ba:$;M=M+1|0}while((M|0)!=(H|0));M=_+20|0;ba=0.0;ca=0;do{da=+V(+(+n[aa+(ca<<2)>>2]-$));ba=ba+da;n[M+(ca<<2)>>2]=da;ca=ca+1|0}while((ca|0)!=(H|0));ea=0;do{ca=M+(ea<<2)|0;n[ca>>2]=+n[ca>>2]/ba;ea=ea+1|0}while((ea|0)!=(H|0));T=T+1|0}while((T|0)<(R|0))}R=(J|0)>0;if(R){T=(L|0)>0;H=(K|0)>0;ba=+(L|0);$=+(K|0);da=+(X|0);fa=+(Z|0);P=(N|0)>0;M=0;do{if(T){ca=Y(M,O)|0;aa=0;do{if(H){ga=+(aa|0);_=0;do{if(P){ha=(Y(_,L)|0)+aa|0;ia=(f[B>>2]|0)==-1;ja=+(_|0);ka=f[s>>2]|0;la=(ka|0)>0;ma=Y(N,ha)|0;ha=0;do{na=(Y(ma+ha|0,t)|0)+ca|0;oa=+n[S+(na+4<<2)>>2];pa=oa<.5&ia?0.0:oa;oa=(ga+1.0/(+V(+-+n[I+(na<<2)>>2])+1.0))/ba;n[S+(na<<2)>>2]=oa;qa=na+1|0;oa=(ja+1.0/(+V(+-+n[I+(qa<<2)>>2])+1.0))/$;n[S+(qa<<2)>>2]=oa;qa=na+2|0;oa=+V(+(+n[I+(qa<<2)>>2]));ra=ha<<1;n[S+(qa<<2)>>2]=oa*+n[v+(ra<<2)>>2]/da;qa=na+3|0;oa=+V(+(+n[I+(qa<<2)>>2]));n[S+(qa<<2)>>2]=oa*+n[v+((ra|1)<<2)>>2]/fa;ra=na+5|0;if(la){na=0;do{qa=S+(ra+na<<2)|0;oa=pa*+n[qa>>2];n[qa>>2]=oa>+n[A>>2]?oa:0.0;na=na+1|0}while((na|0)<(ka|0))}ha=ha+1|0}while((ha|0)<(N|0))}_=_+1|0}while((_|0)!=(K|0))}aa=aa+1|0}while((aa|0)!=(L|0))}M=M+1|0}while((M|0)!=(J|0));fa=+n[z>>2];if(fa>0.0&R){M=Y(L,K)|0;I=0;P=N;da=fa;while(1){H=S+((Y(I,O)|0)<<2)|0;T=Y(M,P)|0;Iyb(a,H,T,+n[A>>2],da);T=I+1|0;if((T|0)>=(J|0))break;I=T;P=f[w>>2]|0;da=+n[z>>2]}sa=f[i>>2]|0;ta=f[m>>2]|0}else{sa=E;ta=D}}else{sa=E;ta=D}P=C+1|0;if(P>>>0>=((ta-sa|0)/56|0)>>>0)break a;I=f[h>>2]|0;C=P;D=ta;E=sa;F=I;G=I}if((U|0)==14){f[k>>2]=0;f[k+4>>2]=0;o=tT(k,41)|0;p=448019;q=o+41|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,453206,447751,237)}else if((U|0)==20){f[k>>2]=0;f[k+4>>2]=0;o=tT(k,41)|0;p=448061;q=o+41|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,453206,447751,238)}else if((U|0)==23){f[k>>2]=0;f[k+4>>2]=0;o=tT(k,40)|0;p=448103;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,453206,447751,240)}}while(0);mx(j);mx(i);mx(h);u=g;return}function Gyb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+48|0;d=g+24|0;h=g+12|0;i=g;j=f[c>>2]|0;if((f[c+4>>2]|0)==(j|0)){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,17)|0;l=449134;m=k+17|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,447751,95)}c=f[j>>2]|0;j=f[c+12>>2]|0;n=f[a+44>>2]|0;if((j|0)!=(Y((f[a+36>>2]|0)+1+(f[a+40>>2]|0)|0,n)|0)){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,46)|0;l=447953;m=k+46|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,d,452925,447751,97)}l=f[c>>2]|0;if((l|0)>1){k=Y(Y(f[c+8>>2]|0,f[c+4>>2]|0)|0,n)|0;f[d>>2]=l;f[d+4>>2]=k;f[d+8>>2]=(j|0)/(n|0)|0;f[d+12>>2]=-1;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;lFa(i,d,d+16|0);l=f[i>>2]|0;m=f[k>>2]|0;a=m;o=l;a:do if((l|0)==(m|0)){p=l;q=9}else{r=l;while(1){if((f[r>>2]|0)<0){p=r;q=9;break a}r=r+4|0;if((r|0)==(m|0)){s=a;break}}}while(0);if((q|0)==9)if((p|0)!=(m|0)){l=p+4|0;if((l|0)==(m|0)){t=m;v=p;w=a}else{r=l;l=p;while(1){p=f[r>>2]|0;if((p|0)<0)x=l;else{f[l>>2]=p;x=l+4|0}r=r+4|0;if((r|0)==(m|0))break;else l=x}l=f[k>>2]|0;t=l;v=x;w=l}if((v|0)==(t|0))s=w;else{w=t+(~((t+-4-v|0)>>>2)<<2)|0;f[k>>2]=w;s=w}}else s=a;f[h>>2]=0;a=h+4|0;f[a>>2]=0;f[h+8>>2]=0;w=VDc(12)|0;f[a>>2]=w;f[h>>2]=w;f[h+8>>2]=w+12;f[w>>2]=0;v=w+4|0;f[v>>2]=0;f[w+8>>2]=0;t=s-o|0;o=t>>2;if(o|0){if(o>>>0>1073741823)mCc(w);l=VDc(t)|0;f[v>>2]=l;f[w>>2]=l;f[w+8>>2]=l+(o<<2);o=f[i>>2]|0;t=s-o|0;if((t|0)>0){dJc(l|0,o|0,t|0)|0;f[v>>2]=l+(t>>>2<<2)}}t=w+12|0;f[a>>2]=t;if((h|0)!=(e|0)){vHa(e,w,t);t=f[h>>2]|0;if(t|0){y=t;z=t;q=24}}else{y=w;z=w;q=24}if((q|0)==24){w=f[a>>2]|0;if((w|0)==(z|0))A=y;else{y=w;while(1){w=y+-12|0;f[a>>2]=w;t=f[w>>2]|0;if(!t)B=w;else{w=y+-8|0;l=f[w>>2]|0;if((l|0)!=(t|0))f[w>>2]=l+(~((l+-4-t|0)>>>2)<<2);YDc(t);B=f[a>>2]|0}if((B|0)==(z|0))break;else y=B}A=f[h>>2]|0}YDc(A)}A=f[i>>2]|0;if(A|0){B=f[k>>2]|0;if((B|0)!=(A|0))f[k>>2]=B+(~((B+-4-A|0)>>>2)<<2);YDc(A)}u=g;return 0}else{A=Y(Y(f[c+8>>2]|0,f[c+4>>2]|0)|0,n)|0;f[d>>2]=A;f[d+4>>2]=(j|0)/(n|0)|0;f[d+8>>2]=-1;f[d+12>>2]=-1;f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;lFa(i,d,d+16|0);d=f[i>>2]|0;j=f[n>>2]|0;A=j;c=d;b:do if((d|0)==(j|0)){C=d;q=40}else{B=d;while(1){if((f[B>>2]|0)<0){C=B;q=40;break b}B=B+4|0;if((B|0)==(j|0)){D=A;break}}}while(0);if((q|0)==40)if((C|0)!=(j|0)){d=C+4|0;if((d|0)==(j|0)){E=j;F=C;G=A}else{B=d;d=C;while(1){C=f[B>>2]|0;if((C|0)<0)H=d;else{f[d>>2]=C;H=d+4|0}B=B+4|0;if((B|0)==(j|0))break;else d=H}d=f[n>>2]|0;E=d;F=H;G=d}if((F|0)==(E|0))D=G;else{G=E+(~((E+-4-F|0)>>>2)<<2)|0;f[n>>2]=G;D=G}}else D=A;f[h>>2]=0;A=h+4|0;f[A>>2]=0;f[h+8>>2]=0;G=VDc(12)|0;f[A>>2]=G;f[h>>2]=G;f[h+8>>2]=G+12;f[G>>2]=0;F=G+4|0;f[F>>2]=0;f[G+8>>2]=0;E=D-c|0;c=E>>2;if(c|0){if(c>>>0>1073741823)mCc(G);d=VDc(E)|0;f[F>>2]=d;f[G>>2]=d;f[G+8>>2]=d+(c<<2);c=f[i>>2]|0;E=D-c|0;if((E|0)>0){dJc(d|0,c|0,E|0)|0;f[F>>2]=d+(E>>>2<<2)}}E=G+12|0;f[A>>2]=E;if((h|0)!=(e|0)){vHa(e,G,E);E=f[h>>2]|0;if(E|0){I=E;J=E;q=55}}else{I=G;J=G;q=55}if((q|0)==55){q=f[A>>2]|0;if((q|0)==(I|0))K=J;else{J=q;while(1){q=J+-12|0;f[A>>2]=q;G=f[q>>2]|0;if(!G)L=q;else{q=J+-8|0;E=f[q>>2]|0;if((E|0)!=(G|0))f[q>>2]=E+(~((E+-4-G|0)>>>2)<<2);YDc(G);L=f[A>>2]|0}if((L|0)==(I|0))break;else J=L}K=f[h>>2]|0}YDc(K)}K=f[i>>2]|0;if(K|0){i=f[n>>2]|0;if((i|0)!=(K|0))f[n>>2]=i+(~((i+-4-K|0)>>>2)<<2);YDc(K)}u=g;return 0}return 0}function Hyb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=r*60|0;o=UIc(l|0,((l|0)<0)<<31>>31|0,e|0,k|0)|0;l=J;g=g+1|0;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=d;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;d=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(d|0));z5(-215,a,452815,452821,161)}return 0}function Iyb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+48|0;h=g+24|0;i=g+12|0;j=g;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;l=(c|0)==0;do if(!l)if(c>>>0>134217727)mCc(h);else{m=c<<5;o=VDc(m)|0;f[h>>2]=o;f[h+8>>2]=o+(c<<5);XIc(o|0,0,m|0)|0;f[k>>2]=o+m;q=o;break}else q=0;while(0);f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;if(l){l=a+40|0;r=l;s=0;t=0;v=f[l>>2]|0}else{l=c<<2;m=VDc(l)|0;f[i>>2]=m;w=m+(c<<2)|0;f[i+8>>2]=w;XIc(m|0,0,l|0)|0;f[o>>2]=w;w=a+40|0;l=f[w>>2]|0;x=l+1+(f[a+36>>2]|0)|0;y=0;do{z=Y(x,y)|0;A=+n[b+(z+2<<2)>>2];p[q+(y<<5)+16>>3]=A;B=+n[b+(z+3<<2)>>2];p[q+(y<<5)+24>>3]=B;p[q+(y<<5)>>3]=+n[b+(z<<2)>>2]-A*.5;p[q+(y<<5)+8>>3]=+n[b+(z+1<<2)>>2]-B*.5;y=y+1|0}while((y|0)!=(c|0));r=w;s=1;t=m;v=l}f[j>>2]=0;l=j+4|0;f[l>>2]=0;f[j+8>>2]=0;if((v|0)>0){m=a+36|0;a:do if(s){a=0;w=v;y=t;while(1){q=w+1+(f[m>>2]|0)|0;x=a+5|0;z=0;do{C=b+(x+(Y(q,z)|0)<<2)|0;f[y+(z<<2)>>2]=f[C>>2];n[C>>2]=0.0;z=z+1|0}while((z|0)!=(c|0));aEb(h,i,d,e,j,1.0,0);z=f[l>>2]|0;q=f[j>>2]|0;C=z-q|0;D=C>>2;E=q;q=f[r>>2]|0;if((C|0)>0){C=q+1+(f[m>>2]|0)|0;F=f[i>>2]|0;G=0;do{H=f[E+(G<<2)>>2]|0;I=Y(C,H)|0;f[b+(x+I<<2)>>2]=f[F+(H<<2)>>2];G=G+1|0}while((G|0)<(D|0))}D=a+1|0;if((D|0)>=(q|0)){J=z;K=E;break a}a=D;w=q;y=f[i>>2]|0}}else{y=0;do{aEb(h,i,d,e,j,1.0,0);w=f[l>>2]|0;a=f[j>>2]|0;D=w-a|0;G=D>>2;F=a;a=f[r>>2]|0;if((D|0)>0){D=a+1+(f[m>>2]|0)|0;x=f[i>>2]|0;C=y+5|0;H=0;do{I=f[F+(H<<2)>>2]|0;L=Y(D,I)|0;f[b+(C+L<<2)>>2]=f[x+(I<<2)>>2];H=H+1|0}while((H|0)<(G|0))}y=y+1|0}while((y|0)<(a|0));J=w;K=F}while(0);b=J;if(K|0){if((b|0)!=(K|0))f[l>>2]=b+(~((b+-4-K|0)>>>2)<<2);YDc(K)}}K=f[i>>2]|0;if(K|0){i=f[o>>2]|0;if((i|0)!=(K|0))f[o>>2]=i+(~((i+-4-K|0)>>>2)<<2);YDc(K)}K=f[h>>2]|0;if(!K){u=g;return}h=f[k>>2]|0;if((h|0)!=(K|0))f[k>>2]=h+(~((h+-32-K|0)>>>5)<<5);YDc(K);u=g;return}function Jyb(a,b){a=a|0;b=b|0;var c=0;c=VDc(44)|0;Kyb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=104096;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Kyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=104116;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,4)|0;b[g>>0]=97;b[g+1>>0]=120;b[g+2>>0]=105;b[g+3>>0]=115;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1154740:i;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((Ioc((n|0)==0?1154740:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<=-1:0){p=1;break}k=DHa(o+24|0,-1)|0;p=k}else p=1}else p=1;while(0);f[a+40>>2]=p;uT(e);f[e>>2]=0;f[e+4>>2]=0;p=tT(e,11)|0;o=448299;h=p+11|0;do{b[p>>0]=b[o>>0]|0;p=p+1|0;o=o+1|0}while((p|0)<(h|0));o=f[g>>2]|0;if(!o){q=0;r=a+36|0;b[r>>0]=q;uT(e);KHa(a,c);u=d;return}p=f[e>>2]|0;h=(p|0)==0?1154740:p;k=g;l=o;b:while(1){o=l;while(1){n=f[o+16>>2]|0;if((n|0)==(p|0))break;if((Ioc((n|0)==0?1154740:n,h)|0)>=0)break;n=f[o+4>>2]|0;if(!n){s=k;break b}else o=n}l=f[o>>2]|0;if(!l){s=o;break}else k=o}if((s|0)==(g|0)){q=0;r=a+36|0;b[r>>0]=q;uT(e);KHa(a,c);u=d;return}g=f[s+16>>2]|0;if((p|0)!=(g|0)?(Ioc(h,(g|0)==0?1154740:g)|0)<=-1:0){q=0;r=a+36|0;b[r>>0]=q;uT(e);KHa(a,c);u=d;return}g=DHa(s+24|0,-1)|0;q=((g|0)!=0|(J|0)!=0)&1;r=a+36|0;b[r>>0]=q;uT(e);KHa(a,c);u=d;return}function Lyb(a){a=a|0;YDc(a);return}function Myb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Nyb(a){a=a|0;REa(a);YDc(a);return}function Oyb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;g=u;u=u+80|0;h=g+56|0;i=g+40|0;j=g+28|0;k=g+16|0;l=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f$(c,i);f$(d,j);f$(e,k);e=f[i>>2]|0;d=f[j>>2]|0;c=f[a+40>>2]|0;m=f[e+4>>2]|0;o=((c|0)<0?m:0)+c|0;if((o|0)<0){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,35)|0;q=448311;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452815,461938,997)}c=(m|0)<(o|0)?m:o;s=f[e+40>>2]|0;if((c|0)>0){t=1;v=0;do{t=Y(f[s+(v<<2)>>2]|0,t)|0;v=v+1|0}while((v|0)<(c|0));if((o|0)<-1){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,35)|0;q=448311;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,452815,461938,997)}else w=t}else w=1;t=f[s+(o<<2)>>2]|0;c=o+1|0;v=(m|0)>(c|0);if(v){x=1;y=c;while(1){z=Y(f[s+(y<<2)>>2]|0,x)|0;y=y+1|0;if((y|0)==(m|0)){A=z;break}else x=z}}else A=1;x=f[e>>2]|0;if((x&4095|0)!=5){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,20)|0;q=448347;r=p+20|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,453206,448368,211)}if(!(x&16384)){f[h>>2]=0;B=h+4|0;f[B>>2]=0;C=tT(h,40)|0;p=C;q=448446;r=p+40|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,453206,448368,212)}if(!(f[d>>2]&16384)){f[h>>2]=0;B=h+4|0;f[B>>2]=0;C=tT(h,40)|0;p=C;q=448446;r=p+40|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,h,453206,448368,212)}q=f[e+16>>2]|0;e=f[d+16>>2]|0;p=f[(f[k>>2]|0)+16>>2]|0;if((m|0)>(o|0)){r=o+1|0;if((r|0)==(m|0))D=t;else{o=r;r=t;while(1){C=Y(f[s+(o<<2)>>2]|0,r)|0;o=o+1|0;if((o|0)==(m|0)){D=C;break}else r=C}}}else D=1;if(v){v=1;r=c;while(1){c=Y(f[s+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(m|0)){E=c;break}else v=c}}else E=1;v=(w|0)==0;if(!v){m=A<<2;r=(A|0)==0;if(t>>>0>1){s=0;do{c=Y(s,D)|0;o=Y(s,E)|0;dJc(p+(o<<2)|0,q+(c<<2)|0,m|0)|0;if(!r){C=1;do{B=(Y(C,E)|0)+c|0;x=0;do{y=p+(x+o<<2)|0;z=q+(B+x<<2)|0;f[y>>2]=f[(+n[y>>2]<+n[z>>2]?z:y)>>2];x=x+1|0}while((x|0)!=(A|0));C=C+1|0}while((C|0)!=(t|0))}s=s+1|0}while((s|0)!=(w|0))}else{s=0;do{dJc(p+((Y(s,E)|0)<<2)|0,q+((Y(s,D)|0)<<2)|0,m|0)|0;s=s+1|0}while((s|0)!=(w|0))}if(!v?(s=(A|0)==0,t|0):0){m=0;do{r=Y(m,D)|0;C=Y(m,E)|0;if(!s){o=0;do{c=(Y(o,E)|0)+r|0;x=0;do{B=c+x|0;n[e+(B<<2)>>2]=+n[q+(B<<2)>>2]-+n[p+(x+C<<2)>>2];x=x+1|0}while((x|0)!=(A|0));o=o+1|0}while((o|0)!=(t|0))}m=m+1|0}while((m|0)!=(w|0))}}f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=d;b3(h,l);if(!v){v=(A|0)==0;l=(t|0)==0;h=A<<2;d=(b[a+36>>0]|0)==0|l|v;a=0;do{m=Y(E,a)|0;q=Y(a,D)|0;if(!v)XIc(p+(m<<2)|0,0,h|0)|0;do if(!l){if(!v){s=0;do{o=(Y(s,E)|0)+q|0;C=0;do{r=p+(C+m<<2)|0;n[r>>2]=+n[e+(o+C<<2)>>2]+ +n[r>>2];C=C+1|0}while((C|0)!=(A|0));s=s+1|0}while((s|0)!=(t|0));if(l)break;if(!v){s=0;do{C=(Y(s,E)|0)+q|0;o=0;do{r=e+(C+o<<2)|0;n[r>>2]=+n[r>>2]/+n[p+(o+m<<2)>>2];o=o+1|0}while((o|0)!=(A|0));s=s+1|0}while((s|0)!=(t|0))}}if(!d){s=0;do{o=(Y(s,E)|0)+q|0;C=0;do{r=e+(o+C<<2)|0;F=+W(+(+n[r>>2]));n[r>>2]=F;C=C+1|0}while((C|0)!=(A|0));s=s+1|0}while((s|0)!=(t|0))}}while(0);a=a+1|0}while((a|0)!=(w|0))}mx(k);mx(j);mx(i);u=g;return}function Pyb(a,c){a=a|0;c=c|0;var d=0,e=0;switch(c|0){case 3:{d=1;break}case 1:{if(sMa()|0?(f[a+40>>2]|0)==1:0)d=1;else e=6;break}case 2:{if(vmb()|0)d=(b[a+36>>0]|0)==0;else d=0;break}default:e=6}if((e|0)==6)d=0;return d|0}function Qyb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Ryb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Syb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=gFa(a,b,c,d,e)|0;jFa(h,f[b>>2]|0);b=f[a+40>>2]|0;a=h+4|0;d=f[h>>2]|0;f[d+(((b|0)<0?(f[a>>2]|0)-d>>2:0)+b<<2)>>2]=1;iFa(e,1,h);e=f[h>>2]|0;if(!e){u=g;return i|0}h=f[a>>2]|0;if((h|0)!=(e|0))f[a>>2]=h+(~((h+-4-e|0)>>>2)<<2);YDc(e);u=g;return i|0}function Tyb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=r<<2;o=UIc(l|0,((l|0)<0)<<31>>31|0,e|0,k|0)|0;l=J;g=g+1|0;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=d;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;d=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(d|0));z5(-215,a,452815,452821,161)}return 0}function Uyb(a,b){a=a|0;b=b|0;var c=0,d=0;c=VDc(44)|0;Vyb(c,b);b=VDc(16)|0;d=b+4|0;f[d>>2]=1;f[b>>2]=104224;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;Yi[f[(f[b>>2]|0)+8>>2]&2047](b);return}function Vyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=104244;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[467281]|0;b[g+1>>0]=b[467282]|0;b[g+2>>0]=b[467283]|0;b[g+3>>0]=b[467284]|0;b[g+4>>0]=b[467285]|0;g=c+4|0;h=f[g>>2]|0;if(!h){uT(e);f[e>>2]=0;i=e+4|0;f[i>>2]=0;j=tT(e,19)|0;k=j;l=448650;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,448670,448693,17)}n=f[e>>2]|0;o=(n|0)==0?1154740:n;p=h;while(1){h=f[p+16>>2]|0;if((n|0)==(h|0)){q=9;break}r=(h|0)==0?1154740:h;if((Ioc(o,r)|0)<0)s=p;else{if((Ioc(r,o)|0)>=0){q=13;break}s=p+4|0}p=f[s>>2]|0;if(!p){q=11;break}}if((q|0)==9)uT(e);else if((q|0)==11){uT(e);f[e>>2]=0;i=e+4|0;f[i>>2]=0;j=tT(e,19)|0;k=j;l=448650;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,448670,448693,17)}else if((q|0)==13)uT(e);f[e>>2]=0;f[e+4>>2]=0;j=tT(e,6)|0;b[j>>0]=b[467287]|0;b[j+1>>0]=b[467288]|0;b[j+2>>0]=b[467289]|0;b[j+3>>0]=b[467290]|0;b[j+4>>0]=b[467291]|0;b[j+5>>0]=b[467292]|0;j=f[g>>2]|0;if(!j){uT(e);f[e>>2]=0;t=e+4|0;f[t>>2]=0;v=tT(e,20)|0;k=v;l=448779;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,448670,448693,17)}g=f[e>>2]|0;i=(g|0)==0?1154740:g;p=j;while(1){j=f[p+16>>2]|0;if((g|0)==(j|0)){q=22;break}s=(j|0)==0?1154740:j;if((Ioc(i,s)|0)<0)w=p;else{if((Ioc(s,i)|0)>=0){q=26;break}w=p+4|0}p=f[w>>2]|0;if(!p){q=24;break}}if((q|0)==22)uT(e);else if((q|0)==24){uT(e);f[e>>2]=0;t=e+4|0;f[t>>2]=0;v=tT(e,20)|0;k=v;l=448779;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,448670,448693,17)}else if((q|0)==26)uT(e);f[e>>2]=0;f[e+4>>2]=0;q=tT(e,5)|0;b[q>>0]=b[467281]|0;b[q+1>>0]=b[467282]|0;b[q+2>>0]=b[467283]|0;b[q+3>>0]=b[467284]|0;b[q+4>>0]=b[467285]|0;q=~~+tIa(lIa(c,e)|0,-1);f[a+36>>2]=q;uT(e);f[e>>2]=0;f[e+4>>2]=0;q=tT(e,6)|0;b[q>>0]=b[467287]|0;b[q+1>>0]=b[467288]|0;b[q+2>>0]=b[467289]|0;b[q+3>>0]=b[467290]|0;b[q+4>>0]=b[467291]|0;b[q+5>>0]=b[467292]|0;q=~~+tIa(lIa(c,e)|0,-1);f[a+40>>2]=q;uT(e);u=d;return}function Wyb(a){a=a|0;YDc(a);return}function Xyb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Yyb(a){a=a|0;REa(a);YDc(a);return}function Zyb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0;g=u;u=u+176|0;h=g+164|0;i=g+152|0;j=g+96|0;k=g+80|0;l=g+24|0;m=g+8|0;o=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;c=f[i>>2]|0;e=d+56|0;q=f[d+60>>2]|0;if((q|0)<3)r=Y(f[d+68>>2]|0,f[d+64>>2]|0)|0;else{s=f[d+96>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}lT(j,e,1,(r>>>0)/7|0);r=f[d+40>>2]|0;e=f[r+4>>2]|0;v=f[r+8>>2]|0;q=f[r+12>>2]|0;r=Y(q,v)|0;t=f[a+40>>2]|0;s=f[a+36>>2]|0;a=Y(s,t)|0;if(!(f[d>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;x=tT(k,18)|0;y=448822;z=x+18|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,k,453206,448693,61)}if(!(f[c>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;x=tT(k,18)|0;y=448841;z=x+18|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,k,453206,448693,61)}y=j+8|0;x=f[y>>2]|0;if((x|0)>0){z=f[c+16>>2]|0;w=f[f[c+44>>2]>>2]|0;A=f[j+16>>2]|0;B=f[f[j+44>>2]>>2]|0;C=+(v+-1|0);D=+(t+-1|0);E=q+-1|0;F=+(E|0);G=+(s+-1|0);H=(t|0)>0;I=d+16|0;J=d+44|0;K=(e|0)>0;L=(s|0)>0;M=0;do{N=z+(Y(w,M)|0)|0;O=A+(Y(B,M)|0)|0;P=+n[O+12>>2];Q=+n[O+16>>2];R=C*(+n[O+24>>2]-Q)/D;S=F*(+n[O+20>>2]-P)/G;if(H){T=C*Q;O=f[I>>2]|0;U=f[(f[J>>2]|0)+8>>2]|0;Q=F*P;V=0;do{P=T+R*+(V|0);W=~~P;X=O+(Y(U,W)|0)|0;Z=(W+1|0)<(v|0)?X+(q<<2)|0:X;if(L?(_=P-+(W|0),K):0){W=N+((Y(s,V)|0)<<2)|0;$=0;do{P=Q+S*+($|0);aa=~~P;ba=aa+1|0;ca=(E|0)<(ba|0)?E:ba;da=P-+(aa|0);ba=Z;ea=X;fa=W+($<<2)|0;ga=0;while(1){P=+n[ea+(aa<<2)>>2];ha=+n[ba+(aa<<2)>>2];ia=+n[ea+(ca<<2)>>2];n[fa>>2]=P+_*(ha-P)+da*(ia-P+_*(P+(+n[ba+(ca<<2)>>2]-ia-ha)));ga=ga+1|0;if((ga|0)==(e|0))break;else{ba=ba+(r<<2)|0;ea=ea+(r<<2)|0;fa=fa+(a<<2)|0}}$=$+1|0}while(($|0)<(s|0))}V=V+1|0}while((V|0)<(t|0))}M=M+1|0}while((M|0)<(x|0))}M=c+40|0;if((x|0)<(f[f[M>>2]>>2]|0)){f[k>>2]=0;x=k+4|0;f[x>>2]=0;f[k+8>>2]=0;t=VDc(32)|0;f[k>>2]=t;f[k+8>>2]=t+32;s=t;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;s=t+8|0;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;s=t+16|0;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;s=t+24|0;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;f[x>>2]=t+32;s=f[f[M>>2]>>2]|0;M=t;f[M>>2]=f[y>>2];f[M+4>>2]=s;fT(l,c,k);p[o>>3]=+n[f[d+16>>2]>>2];f[m>>2]=-1056833530;f[m+4>>2]=o;f[m+8>>2]=1;f[m+12>>2]=1;l_(l,m,e0()|0)|0;m=l+36|0;o=f[m>>2]|0;if(o|0?(d=o+12|0,o=f[d>>2]|0,f[d>>2]=o+-1,(o|0)==1):0)_S(l);f[m>>2]=0;m=l+16|0;o=l+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){m=f[l+40>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))g0(o);o=f[k>>2]|0;if(o|0){k=f[x>>2]|0;if((k|0)!=(o|0))f[x>>2]=k+(~((k+-8-o|0)>>>3)<<3);YDc(o)}}o=j+36|0;k=f[o>>2]|0;if(k|0?(x=k+12|0,k=f[x>>2]|0,f[x>>2]=k+-1,(k|0)==1):0)_S(j);f[o>>2]=0;o=j+16|0;k=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[k>>2]|0)>0){o=f[j+40>>2]|0;x=0;do{f[o+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))g0(k);mx(i);mx(h);u=g;return}function _yb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)!=24){f[d>>2]=0;f[d+4>>2]=0;i=tT(d,18)|0;j=453044;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,d,452925,448693,27)}l=f[h>>2]|0;if(((f[h+4>>2]|0)-l|0)!=16){f[d>>2]=0;f[d+4>>2]=0;i=tT(d,21)|0;j=448800;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,d,452925,448693,27)}if((f[l>>2]|0)!=1){f[d>>2]=0;f[d+4>>2]=0;z5(-213,d,452925,448693,29)}f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;j=VDc(16)|0;f[d>>2]=j;i=j+16|0;f[d+8>>2]=i;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[l>>2]=i;i=e+4|0;k=f[i>>2]|0;h=f[e>>2]|0;m=k-h|0;n=(m|0)/12|0;o=h;h=k;if(!m){npb(e,1-n|0,d);m=f[d>>2]|0;if(!m){p=f[c>>2]|0;q=p+12|0;r=f[q>>2]|0;s=r+8|0;t=f[s>>2]|0;v=f[e>>2]|0;w=f[v>>2]|0;f[w>>2]=t;x=f[p>>2]|0;y=x+4|0;z=f[y>>2]|0;A=w+4|0;f[A>>2]=z;B=a+40|0;C=f[B>>2]|0;D=w+8|0;f[D>>2]=C;E=a+36|0;F=f[E>>2]|0;G=w+12|0;f[G>>2]=F;u=g;return 0}else{H=m;I=m}}else if(n>>>0>1?(n=o+12|0,(h|0)!=(n|0)):0){o=h;while(1){h=o+-12|0;f[i>>2]=h;m=f[h>>2]|0;if(!m)J=h;else{h=o+-8|0;d=f[h>>2]|0;if((d|0)!=(m|0))f[h>>2]=d+(~((d+-4-m|0)>>>2)<<2);YDc(m);J=f[i>>2]|0}if((J|0)==(n|0)){H=j;I=j;break}else o=J}}else{H=j;I=j}j=f[l>>2]|0;if((j|0)!=(H|0))f[l>>2]=j+(~((j+-4-H|0)>>>2)<<2);YDc(I);p=f[c>>2]|0;q=p+12|0;r=f[q>>2]|0;s=r+8|0;t=f[s>>2]|0;v=f[e>>2]|0;w=f[v>>2]|0;f[w>>2]=t;x=f[p>>2]|0;y=x+4|0;z=f[y>>2]|0;A=w+4|0;f[A>>2]=z;B=a+40|0;C=f[B>>2]|0;D=w+8|0;f[D>>2]=C;E=a+36|0;F=f[E>>2]|0;G=w+12|0;f[G>>2]=F;u=g;return 0}function $yb(a,b){a=a|0;b=b|0;var c=0;c=VDc(72)|0;azb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=104352;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function azb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=104372;g=a+40|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,12)|0;h=454747;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=c+4|0;c=f[j>>2]|0;do if(c){k=f[e>>2]|0;l=(k|0)==0?1154740:k;m=j;n=c;a:while(1){o=n;while(1){p=f[o+16>>2]|0;if((p|0)==(k|0))break;if((Ioc((p|0)==0?1154740:p,l)|0)>=0)break;p=f[o+4>>2]|0;if(!p){q=m;break a}else o=p}n=f[o>>2]|0;if(!n){q=o;break}else m=o}if((q|0)!=(j|0)){m=f[q+16>>2]|0;if((k|0)!=(m|0)?(Ioc(l,(m|0)==0?1154740:m)|0)<=-1:0){r=2;break}m=DHa(q+24|0,-1)|0;r=m}else r=2}else r=2;while(0);q=a+36|0;f[q>>2]=r;uT(e);if((f[q>>2]|0)>0){u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;g=tT(e,15)|0;h=449027;i=g+15|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,449043,449058,67)}}function bzb(a){a=a|0;YDc(a);return}function czb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dzb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=104372;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=a+40|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+44>>2]=0;REa(a);return}function ezb(a){a=a|0;dzb(a);YDc(a);return}function fzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+304|0;g=e+292|0;h=e+280|0;i=e+224|0;j=e+168|0;k=e+128|0;l=e+112|0;m=e+56|0;n=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=f[g>>2]|0;f[i>>2]=f[d>>2];c=i+4|0;o=d+4|0;f[c>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];q=i+16|0;f[q>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[i+32>>2]=f[d+32>>2];r=i+36|0;s=f[d+36>>2]|0;f[r>>2]=s;t=i+40|0;f[t>>2]=p;p=i+48|0;v=i+44|0;f[v>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(s|0){w=s+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[o>>2]|0)<3){o=f[d+44>>2]|0;w=f[v>>2]|0;f[w>>2]=f[o>>2];f[w+4>>2]=f[o+4>>2]}else{f[c>>2]=0;ZS(i,d)}d=f[h>>2]|0;f[j>>2]=f[d>>2];o=j+4|0;w=d+4|0;f[o>>2]=f[w>>2];s=j+8|0;f[s>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];x=j+16|0;f[x>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];y=j+36|0;z=f[d+36>>2]|0;f[y>>2]=z;A=j+40|0;f[A>>2]=s;s=j+48|0;B=j+44|0;f[B>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(z|0){C=z+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[w>>2]|0)<3){w=f[d+44>>2]|0;C=f[B>>2]|0;f[C>>2]=f[w>>2];f[C+4>>2]=f[w+4>>2]}else{f[o>>2]=0;ZS(j,d)}d=f[f[t>>2]>>2]|0;f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=k+4;w=k+12|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;f[w+24>>2]=0;if((d|0)==1){f[l>>2]=0;f[l+4>>2]=0;w=tT(l,5)|0;b[w>>0]=b[454713]|0;b[w+1>>0]=b[454714]|0;b[w+2>>0]=b[454715]|0;b[w+3>>0]=b[454716]|0;b[w+4>>0]=b[454717]|0;w=VDc(16)|0;f[w>>2]=w+8;f[w+4>>2]=4;C=XDc(32)|0;f[w>>2]=C;f[m>>2]=0;f[m+4>>2]=w;w=C;f[w>>2]=1;f[w+4>>2]=0;w=C+8|0;f[w>>2]=3;f[w+4>>2]=0;w=C+16|0;f[w>>2]=0;f[w+4>>2]=0;w=C+24|0;f[w>>2]=2;f[w+4>>2]=0;bIa(k,l,m)|0;JFa(m);uT(l);w=a+48|0;C=a+52|0;z=f[C>>2]|0;D=f[w>>2]|0;E=z-D>>2;F=D;D=z;if(E>>>0>=4)if((E|0)!=4?(z=F+16|0,(D|0)!=(z|0)):0){f[C>>2]=D+(~((D+-4-z|0)>>>2)<<2);G=F}else G=F;else{lN(w,4-E|0);G=f[w>>2]|0}E=f[t>>2]|0;F=Y(f[E+8>>2]|0,f[E+4>>2]|0)|0;z=a+36|0;D=f[z>>2]|0;C=(F|0)/(Y(D,D)|0)|0;f[G>>2]=C;f[G+4>>2]=f[z>>2];f[G+8>>2]=f[E+12>>2];f[G+12>>2]=f[z>>2];z=a+60|0;E=a+64|0;C=f[E>>2]|0;D=f[z>>2]|0;F=C-D>>2;H=D;D=C;if(F>>>0>=4)if((F|0)!=4?(C=H+16|0,(D|0)!=(C|0)):0){f[E>>2]=D+(~((D+-4-C|0)>>>2)<<2);I=G;J=H}else{I=G;J=H}else{lN(z,4-F|0);I=f[w>>2]|0;J=f[z>>2]|0}f[J>>2]=f[I+4>>2];f[J+4>>2]=f[I+12>>2];f[J+8>>2]=f[I>>2];K=I+8|0;L=J+12|0}else{f[l>>2]=0;f[l+4>>2]=0;J=tT(l,5)|0;b[J>>0]=b[454713]|0;b[J+1>>0]=b[454714]|0;b[J+2>>0]=b[454715]|0;b[J+3>>0]=b[454716]|0;b[J+4>>0]=b[454717]|0;J=VDc(16)|0;f[J>>2]=J+8;f[J+4>>2]=5;I=XDc(40)|0;f[J>>2]=I;f[m>>2]=0;f[m+4>>2]=J;J=I;f[J>>2]=0;f[J+4>>2]=0;J=I+8|0;f[J>>2]=2;f[J+4>>2]=0;J=I+16|0;f[J>>2]=4;f[J+4>>2]=0;J=I+24|0;f[J>>2]=1;f[J+4>>2]=0;J=I+32|0;f[J>>2]=3;f[J+4>>2]=0;bIa(k,l,m)|0;JFa(m);uT(l);J=a+48|0;I=a+52|0;z=f[I>>2]|0;w=f[J>>2]|0;F=z-w>>2;H=w;w=z;if(F>>>0>=5)if((F|0)!=5?(z=H+20|0,(w|0)!=(z|0)):0){f[I>>2]=w+(~((w+-4-z|0)>>>2)<<2);M=H}else M=H;else{lN(J,5-F|0);M=f[J>>2]|0}f[M>>2]=d;d=f[t>>2]|0;F=Y(f[d+8>>2]|0,f[d+4>>2]|0)|0;H=a+36|0;z=f[H>>2]|0;w=(F|0)/(Y(z,z)|0)|0;f[M+4>>2]=w;f[M+8>>2]=f[H>>2];f[M+12>>2]=f[d+12>>2];f[M+16>>2]=f[H>>2];H=a+60|0;d=a+64|0;w=f[d>>2]|0;z=f[H>>2]|0;F=w-z>>2;I=z;z=w;if(F>>>0>=5)if((F|0)!=5?(w=I+20|0,(z|0)!=(w|0)):0){f[d>>2]=z+(~((z+-4-w|0)>>>2)<<2);N=M;O=I}else{N=M;O=I}else{lN(H,5-F|0);N=f[J>>2]|0;O=f[H>>2]|0}f[O>>2]=f[N>>2];f[O+4>>2]=f[N+8>>2];f[O+8>>2]=f[N+16>>2];f[O+12>>2]=f[N+4>>2];K=N+12|0;L=O+16|0}f[L>>2]=f[K>>2];opb(l,k);K=a+40|0;L=f[l>>2]|0;O=f[l+4>>2]|0;if(L|0){N=L+4|0;f[N>>2]=(f[N>>2]|0)+1}N=f[K>>2]|0;f[K>>2]=L;L=a+44|0;f[L>>2]=O;if(N|0?(O=N+4|0,K=f[O>>2]|0,f[O>>2]=K+-1,(K|0)==1):0)Yi[f[(f[N>>2]|0)+8>>2]&2047](N);N=f[l>>2]|0;if(N|0?(K=N+4|0,O=f[K>>2]|0,f[K>>2]=O+-1,(O|0)==1):0)Yi[f[(f[N>>2]|0)+8>>2]&2047](N);nT(m,i,1,a+48|0);qFa(l,1,m);N=m+36|0;O=f[N>>2]|0;if(O|0?(K=O+12|0,O=f[K>>2]|0,f[K>>2]=O+-1,(O|0)==1):0)_S(m);f[N>>2]=0;N=m+16|0;O=m+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[O>>2]|0)>0){N=f[m+40>>2]|0;K=0;do{f[N+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[O>>2]|0))}O=f[m+44>>2]|0;if((O|0)!=(m+48|0))g0(O);nT(n,j,1,a+60|0);qFa(m,1,n);a=n+36|0;O=f[a>>2]|0;if(O|0?(K=O+12|0,O=f[K>>2]|0,f[K>>2]=O+-1,(O|0)==1):0)_S(n);f[a>>2]=0;a=n+16|0;O=n+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[O>>2]|0)>0){a=f[n+40>>2]|0;K=0;do{f[a+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[O>>2]|0))}O=f[n+44>>2]|0;if((O|0)!=(n+48|0))g0(O);LHa(f[L>>2]|0,l,m);mx(m);mx(l);HFa(k);k=f[y>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(j);f[y>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[o>>2]|0)>0){x=f[A>>2]|0;A=0;do{f[x+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[o>>2]|0))}o=f[B>>2]|0;if((o|0)!=(s|0))g0(o);o=f[r>>2]|0;if(o|0?(s=o+12|0,o=f[s>>2]|0,f[s>>2]=o+-1,(o|0)==1):0)_S(i);f[r>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[c>>2]|0)>0){q=f[t>>2]|0;t=0;do{f[q+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[c>>2]|0))}c=f[v>>2]|0;if((c|0)==(p|0)){mx(h);mx(g);u=e;return}g0(c);mx(h);mx(g);u=e;return}function gzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+96|0;g=e+84|0;h=e+72|0;i=e+16|0;j=e;if((p$(b,-1)|0)==3){kFa(a,b,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(b,g);f$(c,h);nT(i,f[g>>2]|0,1,a+48|0);c=f[g>>2]|0;b=i+36|0;if((c|0)!=(i|0)){k=f[b>>2]|0;if(k|0){l=k+12|0;f[l>>2]=(f[l>>2]|0)+1}l=c+36|0;k=f[l>>2]|0;if(k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)_S(c);f[l>>2]=0;k=c+16|0;m=c+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[m>>2]|0)>0){n=f[c+40>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0;p=f[m>>2]|0}while((o|0)<(p|0));f[c>>2]=f[i>>2];if((p|0)<3)q=14;else q=16}else{f[c>>2]=f[i>>2];q=14}if((q|0)==14){p=f[i+4>>2]|0;if((p|0)<3){f[m>>2]=p;f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];p=f[i+44>>2]|0;m=f[c+44>>2]|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2]}else q=16}if((q|0)==16)ZS(c,i);f[k>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[c+28>>2]=f[i+28>>2];f[c+32>>2]=f[i+32>>2];f[l>>2]=f[b>>2]}l=f[b>>2]|0;if(l|0?(c=l+12|0,l=f[c>>2]|0,f[c>>2]=l+-1,(l|0)==1):0)_S(i);f[b>>2]=0;b=i+16|0;l=i+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[l>>2]|0)>0){b=f[i+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[l>>2]|0))}l=f[i+44>>2]|0;if((l|0)!=(i+48|0))g0(l);nT(i,f[h>>2]|0,1,a+60|0);l=f[h>>2]|0;c=i+36|0;if((l|0)!=(i|0)){b=f[c>>2]|0;if(b|0){k=b+12|0;f[k>>2]=(f[k>>2]|0)+1}k=l+36|0;b=f[k>>2]|0;if(b|0?(p=b+12|0,b=f[p>>2]|0,f[p>>2]=b+-1,(b|0)==1):0)_S(l);f[k>>2]=0;b=l+16|0;p=l+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[p>>2]|0)>0){m=f[l+40>>2]|0;o=0;do{f[m+(o<<2)>>2]=0;o=o+1|0;r=f[p>>2]|0}while((o|0)<(r|0));f[l>>2]=f[i>>2];if((r|0)<3)q=37;else q=39}else{f[l>>2]=f[i>>2];q=37}if((q|0)==37){r=f[i+4>>2]|0;if((r|0)<3){f[p>>2]=r;f[l+8>>2]=f[i+8>>2];f[l+12>>2]=f[i+12>>2];r=f[i+44>>2]|0;p=f[l+44>>2]|0;f[p>>2]=f[r>>2];f[p+4>>2]=f[r+4>>2]}else q=39}if((q|0)==39)ZS(l,i);f[b>>2]=f[i+16>>2];f[l+20>>2]=f[i+20>>2];f[l+24>>2]=f[i+24>>2];f[l+28>>2]=f[i+28>>2];f[l+32>>2]=f[i+32>>2];f[k>>2]=f[c>>2]}k=f[c>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(i);f[c>>2]=0;c=i+16|0;k=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[k>>2]|0)>0){c=f[i+40>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))g0(k);k=f[a+44>>2]|0;a=f[(f[k>>2]|0)+44>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=g;l=j+8|0;f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=33882112;f[j+4>>2]=h;ei[a&511](k,i,j,d);mx(h);mx(g);u=e;return}function hzb(a,b){a=a|0;b=b|0;return (b|1|0)==3|0}function izb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function jzb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+48|0;d=g+24|0;h=g+12|0;i=g;j=f[c+4>>2]|0;k=f[c>>2]|0;if((j|0)==(k|0)){f[d>>2]=0;f[d+4>>2]=0;l=tT(d,17)|0;m=449134;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452925,449058,75)}o=(j-k|0)/12|0;j=f[k>>2]|0;k=f[a+36>>2]|0;a=Y(Y(k,f[j+4>>2]|0)|0,k)|0;p=(f[j+8>>2]|0)/(k|0)|0;q=(f[j+12>>2]|0)/(k|0)|0;f[d>>2]=f[j>>2];f[d+4>>2]=a;f[d+8>>2]=p;f[d+12>>2]=q;f[i>>2]=0;q=i+4|0;f[q>>2]=0;f[i+8>>2]=0;lFa(i,d,d+16|0);p=f[i>>2]|0;a=f[q>>2]|0;a:do if((p|0)==(a|0)){r=p;s=6}else{j=p;do{if((f[j>>2]|0)<0){r=j;s=6;break a}j=j+4|0}while((j|0)!=(a|0))}while(0);if((s|0)==6?(r|0)!=(a|0):0){s=r+4|0;if((s|0)==(a|0)){t=a;v=r}else{p=s;s=r;while(1){r=f[p>>2]|0;if((r|0)<0)w=s;else{f[s>>2]=r;w=s+4|0}p=p+4|0;if((p|0)==(a|0))break;else s=w}t=f[q>>2]|0;v=w}if((v|0)!=(t|0))f[q>>2]=t+(~((t+-4-v|0)>>>2)<<2)}lzb(h,o,i);if((h|0)!=(e|0))vHa(e,f[h>>2]|0,f[h+4>>2]|0);o=f[h>>2]|0;if(o|0){v=h+4|0;t=f[v>>2]|0;if((t|0)==(o|0))x=o;else{w=t;while(1){t=w+-12|0;f[v>>2]=t;s=f[t>>2]|0;if(!s)y=t;else{t=w+-8|0;a=f[t>>2]|0;if((a|0)!=(s|0))f[t>>2]=a+(~((a+-4-s|0)>>>2)<<2);YDc(s);y=f[v>>2]|0}if((y|0)==(o|0))break;else w=y}x=f[h>>2]|0}YDc(x)}x=f[i>>2]|0;if(x|0){i=f[q>>2]|0;if((i|0)!=(x|0))f[q>>2]=i+(~((i+-4-x|0)>>>2)<<2);YDc(x)}x=f[e>>2]|0;e=f[x>>2]|0;i=f[e>>2]|0;q=e;if((i|0)<=0){f[d>>2]=0;z=d+4|0;f[z>>2]=0;A=tT(d,80)|0;l=A;m=449152;n=l+80|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452925,449058,82)}if((f[e+4>>2]|0)<=0){f[d>>2]=0;z=d+4|0;f[z>>2]=0;A=tT(d,80)|0;l=A;m=449152;n=l+80|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452925,449058,82)}if((f[e+8>>2]|0)<=0){f[d>>2]=0;z=d+4|0;f[z>>2]=0;A=tT(d,80)|0;l=A;m=449152;n=l+80|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452925,449058,82)}if((f[e+12>>2]|0)<=0){f[d>>2]=0;z=d+4|0;f[z>>2]=0;A=tT(d,80)|0;l=A;m=449152;n=l+80|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452925,449058,82)}A=f[x+4>>2]|0;x=A-q|0;q=x>>2;if((e|0)!=(A|0)){if((x|0)<=-4){f[d>>2]=0;f[d+4>>2]=0;l=tT(d,70)|0;m=452744;n=l+70|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452815,452821,161)}if((x|0)>0)if((x|0)>4){x=1;A=i;while(1){z=Y(f[e+(x<<2)>>2]|0,A)|0;x=x+1|0;if((x|0)>=(q|0)){B=z;break}else A=z}}else B=i;else B=1}else B=0;i=f[c>>2]|0;c=f[i+4>>2]|0;A=f[i>>2]|0;i=c-A|0;q=i>>2;x=A;if((x|0)!=(c|0)){if((i|0)<=-4){f[d>>2]=0;f[d+4>>2]=0;l=tT(d,70)|0;m=452744;n=l+70|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452815,452821,161)}if((i|0)>0){i=0;c=1;while(1){A=Y(f[x+(i<<2)>>2]|0,c)|0;i=i+1|0;if((i|0)>=(q|0)){C=A;break}else c=A}}else C=1}else C=0;if((B|0)==(C|0)){u=g;return 0}else{f[d>>2]=0;f[d+4>>2]=0;l=tT(d,37)|0;m=449233;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,d,452925,449058,83)}return 0}function kzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=r*21|0;o=UIc(l|0,((l|0)<0)<<31>>31|0,e|0,k|0)|0;l=J;g=g+1|0;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=d;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;d=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(d|0));z5(-215,a,452815,452821,161)}return 0}function lzb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)mCc(a);e=VDc(b*12|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*12|0);a=b;b=e;do{jFa(b,c);b=(f[d>>2]|0)+12|0;f[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function mzb(a,b){a=a|0;b=b|0;var c=0;c=VDc(256)|0;nzb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=104480;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function nzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0.0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=104500;g=a+44|0;f[g>>2]=1124007936;h=a+48|0;i=a+52|0;j=a+84|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;j=a+92|0;f[a+88>>2]=j;f[j>>2]=0;f[a+96>>2]=0;j=a+100|0;f[j>>2]=1124007936;m=a+104|0;o=a+108|0;p=a+140|0;k=m;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[p>>2]=o;p=a+148|0;f[a+144>>2]=p;f[p>>2]=0;f[a+152>>2]=0;f[a+156>>2]=1124007936;p=a+160|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[a+188>>2]=a+164;p=a+196|0;f[a+192>>2]=p;f[a+200>>2]=0;f[p>>2]=0;f[a+204>>2]=1124007936;p=a+208|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[a+236>>2]=a+212;p=a+244|0;f[a+240>>2]=p;f[a+248>>2]=0;f[p>>2]=0;KHa(a,c);p=a+4|0;q=a+8|0;if((((f[q>>2]|0)-(f[p>>2]|0)|0)/56|0)>>>0<=1){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,17)|0;r=449426;l=k+17|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));z5(-215,e,449444,449463,36)}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,10)|0;r=454974;l=k+10|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));s=c+4|0;c=f[s>>2]|0;do if(c){t=f[e>>2]|0;v=(t|0)==0?1154740:t;w=s;x=c;a:while(1){y=x;while(1){z=f[y+16>>2]|0;if((z|0)==(t|0))break;if((Ioc((z|0)==0?1154740:z,v)|0)>=0)break;z=f[y+4>>2]|0;if(!z){A=w;break a}else y=z}x=f[y>>2]|0;if(!x){A=y;break}else w=y}if((A|0)!=(s|0)){w=f[A+16>>2]|0;if((t|0)!=(w|0)?(Ioc(v,(w|0)==0?1154740:w)|0)<=-1:0){B=0;break}w=DHa(A+24|0,-1)|0;B=(w|0)!=0|(J|0)!=0}else B=0}else B=0;while(0);A=a+36|0;b[A>>0]=B&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;B=tT(e,8)|0;c=B;b[c>>0]=104;b[c+1>>0]=97;b[c+2>>0]=115;b[c+3>>0]=95;c=B+4|0;b[c>>0]=98;b[c+1>>0]=105;b[c+2>>0]=97;b[c+3>>0]=115;c=f[s>>2]|0;do if(c){B=f[e>>2]|0;w=(B|0)==0?1154740:B;x=s;z=c;b:while(1){C=z;while(1){D=f[C+16>>2]|0;if((D|0)==(B|0))break;if((Ioc((D|0)==0?1154740:D,w)|0)>=0)break;D=f[C+4>>2]|0;if(!D){E=x;break b}else C=D}z=f[C>>2]|0;if(!z){E=C;break}else x=C}if((E|0)!=(s|0)){x=f[E+16>>2]|0;if((B|0)!=(x|0)?(Ioc(w,(x|0)==0?1154740:x)|0)<=-1:0){F=0;break}x=DHa(E+24|0,-1)|0;F=(x|0)!=0|(J|0)!=0}else F=0}else F=0;while(0);E=a+37|0;b[E>>0]=F&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;k=tT(e,16)|0;r=449544;l=k+16|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));F=f[s>>2]|0;do if(F){c=f[e>>2]|0;x=(c|0)==0?1154740:c;z=s;v=F;c:while(1){t=v;while(1){y=f[t+16>>2]|0;if((y|0)==(c|0))break;if((Ioc((y|0)==0?1154740:y,x)|0)>=0)break;y=f[t+4>>2]|0;if(!y){G=z;break c}else t=y}v=f[t>>2]|0;if(!v){G=t;break}else z=t}if((G|0)!=(s|0)){z=f[G+16>>2]|0;if((c|0)!=(z|0)?(Ioc(x,(z|0)==0?1154740:z)|0)<=-1:0){H=1;break}z=DHa(G+24|0,-1)|0;H=(z|0)!=0|(J|0)!=0}else H=1}else H=1;while(0);G=a+252|0;b[G>>0]=H&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;k=tT(e,10)|0;r=449561;l=k+10|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));H=f[s>>2]|0;do if(H){F=f[e>>2]|0;z=(F|0)==0?1154740:F;v=s;w=H;d:while(1){B=w;while(1){C=f[B+16>>2]|0;if((C|0)==(F|0))break;if((Ioc((C|0)==0?1154740:C,z)|0)>=0)break;C=f[B+4>>2]|0;if(!C){I=v;break d}else B=C}w=f[B>>2]|0;if(!w){I=B;break}else v=B}if((I|0)==(s|0)){uT(e);break}v=f[I+16>>2]|0;if((F|0)!=(v|0)?(Ioc(z,(v|0)==0?1154740:v)|0)<=-1:0){uT(e);break}v=DHa(I+24|0,-1)|0;w=(v|0)!=0|(J|0)!=0;uT(e);if(w){b[E>>0]=1;b[A>>0]=1}}else uT(e);while(0);f[e>>2]=0;f[e+4>>2]=0;I=tT(e,3)|0;b[I>>0]=b[454985]|0;b[I+1>>0]=b[454986]|0;b[I+2>>0]=b[454987]|0;I=f[s>>2]|0;do if(I){H=f[e>>2]|0;w=(H|0)==0?1154740:H;v=s;x=I;e:while(1){c=x;while(1){t=f[c+16>>2]|0;if((t|0)==(H|0))break;if((Ioc((t|0)==0?1154740:t,w)|0)>=0)break;t=f[c+4>>2]|0;if(!t){K=v;break e}else c=t}x=f[c>>2]|0;if(!x){K=c;break}else v=c}if((K|0)!=(s|0)){v=f[K+16>>2]|0;if((H|0)!=(v|0)?(Ioc(w,(v|0)==0?1154740:v)|0)<=-1:0){L=9.999999747378752e-06;break}L=+tIa(K+24|0,-1)}else L=9.999999747378752e-06}else L=9.999999747378752e-06;while(0);K=a+40|0;n[K>>2]=L;uT(e);s=f[p>>2]|0;p=f[s+4>>2]|0;I=s;if((p|0)<3)N=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{v=f[s+40>>2]|0;x=0;z=1;while(1){F=Y(f[v+(x<<2)>>2]|0,z)|0;x=x+1|0;if((x|0)==(p|0)){N=F;break}else z=F}}z=f[s+60>>2]|0;if((z|0)<3)O=Y(f[s+68>>2]|0,f[s+64>>2]|0)|0;else{p=f[s+96>>2]|0;x=0;v=1;while(1){F=Y(f[p+(x<<2)>>2]|0,v)|0;x=x+1|0;if((x|0)==(z|0)){O=F;break}else v=F}}if((O|0)!=(N|0)){f[e>>2]=0;P=e+4|0;f[P>>2]=0;Q=tT(e,133)|0;dJc(Q|0,449572,133)|0;z5(-215,e,449444,449463,48)}O=f[s>>2]|0;if(!(O&16384)){f[e>>2]=0;P=e+4|0;f[P>>2]=0;Q=tT(e,133)|0;dJc(Q|0,449572,133)|0;z5(-215,e,449444,449463,48)}if(!((O&4095|0)==5?(f[s+56>>2]&20479|0)==16389:0)){f[e>>2]=0;P=e+4|0;f[P>>2]=0;Q=tT(e,133)|0;dJc(Q|0,449572,133)|0;z5(-215,e,449444,449463,48)}Q=(b[A>>0]|0)==0;do if(Q){P=b[E>>0]|0;O=(f[q>>2]|0)-I|0;v=(O|0)/56|0;if(P<<24>>24){z=v+-1|0;R=1.0;S=O;T=z-(P&255)|0;U=z;V=96;break}if(v>>>0>2?(b[G>>0]|0)!=0:0){if((O|0)!=168){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,17)|0;r=449706;l=k+17|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));z5(-215,e,449444,449463,52)}w=f[s+112>>2]&4095;if((w|0)!=5)Y1(w,5,104604);L=+n[f[s+128>>2]>>2];if(L!=0.0){W=1.0/L;V=85}else{W=L;V=85}}else{W=1.0;V=85}}else{W=1.0;V=85}while(0);if((V|0)==85){G=b[E>>0]|0;w=(f[q>>2]|0)-I|0;I=(w|0)/56|0;q=I+-1|0;H=q-(G&255)|0;if(!Q){if(H>>>0>=I>>>0){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,39)|0;r=449724;l=k+39|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));z5(-215,e,449444,449463,63)}if((f[s+(H*56|0)>>2]&20479|0)!=16389){f[e>>2]=0;X=e+4|0;f[X>>2]=0;Z=tT(e,64)|0;k=Z;r=449764;l=k+64|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));z5(-215,e,449444,449463,65)}I=f[s+(H*56|0)+4>>2]|0;if((I|0)<3)_=Y(f[s+(H*56|0)+12>>2]|0,f[s+(H*56|0)+8>>2]|0)|0;else{O=f[s+(H*56|0)+40>>2]|0;v=0;z=1;while(1){P=Y(f[O+(v<<2)>>2]|0,z)|0;v=v+1|0;if((v|0)==(I|0)){_=P;break}else z=P}}if((_|0)!=(N|0)){f[e>>2]=0;X=e+4|0;f[X>>2]=0;Z=tT(e,64)|0;k=Z;r=449764;l=k+64|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));z5(-215,e,449444,449463,65)}}if(!(G<<24>>24)){$=W;aa=H;ba=q;ca=1}else{R=W;S=w;T=H;U=q;V=96}}if((V|0)==96){if(!S){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,36)|0;r=449829;l=k+36|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));z5(-215,e,449444,449463,70)}if((f[s+(T*56|0)>>2]&20479|0)!=16389){f[e>>2]=0;da=e+4|0;f[da>>2]=0;ea=tT(e,64)|0;k=ea;r=449866;l=k+64|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));z5(-215,e,449444,449463,72)}S=f[s+(T*56|0)+4>>2]|0;if((S|0)<3)fa=Y(f[s+(T*56|0)+12>>2]|0,f[s+(T*56|0)+8>>2]|0)|0;else{q=f[s+(T*56|0)+40>>2]|0;H=0;w=1;while(1){G=Y(f[q+(H<<2)>>2]|0,w)|0;H=H+1|0;if((H|0)==(S|0)){fa=G;break}else w=G}}if((fa|0)==(N|0)){$=R;aa=T;ba=U;ca=0}else{f[e>>2]=0;da=e+4|0;f[da>>2]=0;ea=tT(e,64)|0;k=ea;r=449866;l=k+64|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));z5(-215,e,449444,449463,72)}}r=f[s+16>>2]|0;k=f[s+72>>2]|0;if(Q)ga=0;else ga=f[s+(aa*56|0)+16>>2]|0;if(ca)ha=0;else ha=f[s+(ba*56|0)+16>>2]|0;if(!(((((f[h>>2]|0)<3?(f[i>>2]|0)==1:0)?(f[a+56>>2]|0)==(N|0):0)?(f[g>>2]&4095|0)==5:0)?(f[a+60>>2]|0)!=0:0)){f[e>>2]=1;f[e+4>>2]=N;XS(g,2,e,5)}do if((((f[m>>2]|0)<3?(f[o>>2]|0)==1:0)?(f[a+112>>2]|0)==(N|0):0)?(f[j>>2]&4095|0)==5:0){g=f[a+116>>2]|0;if(!g){V=121;break}ia=g}else V=121;while(0);if((V|0)==121){f[e>>2]=1;f[e+4>>2]=N;XS(j,2,e,5);ia=f[a+116>>2]|0}e=f[a+60>>2]|0;if(!N){u=d;return}a=(b[E>>0]|0)==0;if(b[A>>0]|0){A=0;do{R=+n[ga+(A<<2)>>2]/+M(+($*+n[k+(A<<2)>>2]+ +n[K>>2]));n[e+(A<<2)>>2]=R;if(a)ja=0.0;else ja=+n[ha+(A<<2)>>2];n[ia+(A<<2)>>2]=ja-$*(R*+n[r+(A<<2)>>2]);A=A+1|0}while((A|0)!=(N|0));u=d;return}if(a){a=0;do{ja=1.0/+M(+($*+n[k+(a<<2)>>2]+ +n[K>>2]));n[e+(a<<2)>>2]=ja;n[ia+(a<<2)>>2]=0.0-$*(ja*+n[r+(a<<2)>>2]);a=a+1|0}while((a|0)!=(N|0));u=d;return}else{a=0;do{ja=1.0/+M(+($*+n[k+(a<<2)>>2]+ +n[K>>2]));n[e+(a<<2)>>2]=ja;n[ia+(a<<2)>>2]=+n[ha+(a<<2)>>2]-$*(ja*+n[r+(a<<2)>>2]);a=a+1|0}while((a|0)!=(N|0));u=d;return}}function ozb(a){a=a|0;YDc(a);return}function pzb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function qzb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=104500;GQ(a+204|0);GQ(a+156|0);b=a+100|0;c=a+136|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))g0(b);b=a+44|0;d=a+80|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+60|0;b=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+84>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0)){REa(a);return}g0(b);REa(a);return}function rzb(a){a=a|0;qzb(a);YDc(a);return}function szb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;g=u;u=u+160|0;h=g+140|0;i=g+128|0;j=g+72|0;k=g+16|0;l=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;m=i+4|0;f[m>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);if((((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)/56|0)>>>0<=1){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,17)|0;p=449426;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,453206,449463,247)}d=f[h>>2]|0;c=d;if(((f[e>>2]|0)-d|0)!=56){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,18)|0;p=453187;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,453206,449463,248)}d=f[c+4>>2]|0;switch(d|0){case 4:case 2:break;default:{f[j>>2]=0;f[j+4>>2]=0;o=tT(j,38)|0;p=450116;q=o+38|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,453206,449463,251)}}if((d|0)>2){d=f[c+40>>2]|0;r=f[d+8>>2]|0;s=f[d+12>>2]|0}else{r=1;s=1}d=f[i>>2]|0;if((f[m>>2]|0)!=(d|0)){p=a+44|0;o=a+60|0;q=a+84|0;e=a+88|0;t=a+56|0;v=a+100|0;w=a+116|0;x=a+140|0;y=a+144|0;z=a+112|0;a=c+16|0;A=c+44|0;c=l+8|0;B=l+4|0;C=k+36|0;D=k+16|0;E=k+4|0;F=k+40|0;G=k+44|0;H=k+48|0;I=j+36|0;J=j+16|0;K=j+4|0;L=j+40|0;M=j+44|0;N=j+48|0;O=0;P=d;do{d=P;Q=d+(O*56|0)+40|0;R=f[Q>>2]|0;S=f[R>>2]|0;if((S|0)>0){T=d+(O*56|0)+16|0;U=d+(O*56|0)+44|0;d=0;V=S;S=R;while(1){if((f[S+4>>2]|0)>0){R=0;do{W=f[o>>2]|0;do if((f[p>>2]&16384|0)==0?(X=f[q>>2]|0,(f[X>>2]|0)!=1):0){Z=f[f[e>>2]>>2]|0;if((f[X+4>>2]|0)==1){_=W+(Y(Z,R)|0)|0;break}else{X=f[t>>2]|0;$=(R|0)/(X|0)|0;_=W+(Y($,Z)|0)+(R-(Y($,X)|0)<<2)|0;break}}else aa=22;while(0);if((aa|0)==22){aa=0;_=W+(R<<2)|0}ba=+n[_>>2];X=f[w>>2]|0;do if((f[v>>2]&16384|0)==0?($=f[x>>2]|0,(f[$>>2]|0)!=1):0){Z=f[f[y>>2]>>2]|0;if((f[$+4>>2]|0)==1){ca=X+(Y(Z,R)|0)|0;break}else{$=f[z>>2]|0;da=(R|0)/($|0)|0;ca=X+(Y(da,Z)|0)+(R-(Y(da,$)|0)<<2)|0;break}}else aa=28;while(0);if((aa|0)==28){aa=0;ca=X+(R<<2)|0}ea=+n[ca>>2];W=f[A>>2]|0;$=(f[a>>2]|0)+(Y(f[W>>2]|0,d)|0)|0;Vj(j,r,s,5,$+(Y(f[W+4>>2]|0,R)|0)|0,0);W=f[U>>2]|0;$=(f[T>>2]|0)+(Y(f[W>>2]|0,d)|0)|0;Vj(k,r,s,5,$+(Y(f[W+4>>2]|0,R)|0)|0,0);W=c;f[W>>2]=0;f[W+4>>2]=0;f[l>>2]=33619968;f[B>>2]=k;LZ(j,l,5,ba,ea);W=f[C>>2]|0;if(W|0?($=W+12|0,W=f[$>>2]|0,f[$>>2]=W+-1,(W|0)==1):0)_S(k);f[C>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[E>>2]|0)>0){W=f[F>>2]|0;$=0;do{f[W+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[E>>2]|0))}$=f[G>>2]|0;if(($|0)!=(H|0))g0($);$=f[I>>2]|0;do if($|0){W=$+12|0;X=f[W>>2]|0;f[W>>2]=X+-1;if((X|0)!=1)break;_S(j)}while(0);f[I>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[K>>2]|0)>0){$=f[L>>2]|0;X=0;do{f[$+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[K>>2]|0))}X=f[M>>2]|0;if((X|0)!=(N|0))g0(X);R=R+1|0;fa=f[Q>>2]|0}while((R|0)<(f[fa+4>>2]|0));ga=fa;ha=f[fa>>2]|0}else{ga=S;ha=V}d=d+1|0;if((d|0)>=(ha|0))break;else{V=ha;S=ga}}}O=O+1|0;P=f[i>>2]|0}while(O>>>0<(((f[m>>2]|0)-P|0)/56|0)>>>0)}mx(i);mx(h);u=g;return}function tzb(a,b){a=a|0;b=b|0;var c=0,d=0;switch(b|0){case 3:{c=1;break}case 1:{if(sMa()|0)c=1;else d=4;break}case 2:{c=vmb()|0;break}default:d=4}if((d|0)==4)c=0;return c|0}function uzb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function vzb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function wzb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function xzb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;c=u;u=u+256|0;d=c+200|0;e=c+144|0;g=c+88|0;h=c+72|0;i=c;j=c+56|0;f[d>>2]=1124007936;k=d+4|0;l=d+8|0;m=d+40|0;o=k;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[m>>2]=l;r=d+48|0;s=d+44|0;f[s>>2]=r;f[r>>2]=0;f[d+52>>2]=0;f[e>>2]=1124007936;t=e+4|0;v=e+8|0;w=e+40|0;o=t;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[w>>2]=v;o=e+48|0;q=e+44|0;f[q>>2]=o;f[o>>2]=0;f[e+52>>2]=0;x=f[b+4>>2]|0;Ti[f[(f[x>>2]|0)+84>>2]&511](x,d,e);x=d+16|0;b=(f[x>>2]|0)==0;if(!b){y=f[k>>2]|0;if((y|0)<3)z=Y(f[d+12>>2]|0,f[l>>2]|0)|0;else{A=f[m>>2]|0;B=0;C=1;while(1){D=Y(f[A+(B<<2)>>2]|0,C)|0;B=B+1|0;if((B|0)==(y|0)){z=D;break}else C=D}}if(!((y|0)==0|(z|0)==0))E=13;else E=7}else E=7;if((E|0)==7)if(f[e+16>>2]|0){z=f[t>>2]|0;if((z|0)<3)F=Y(f[e+12>>2]|0,f[v>>2]|0)|0;else{y=f[w>>2]|0;C=0;B=1;while(1){A=Y(f[y+(C<<2)>>2]|0,B)|0;C=C+1|0;if((C|0)==(z|0)){F=A;break}else B=A}}if(!((z|0)==0|(F|0)==0))E=13;else G=0}else G=0;do if((E|0)==13){F=a+44|0;z=f[a+48>>2]|0;if((z|0)<3)H=Y(f[a+56>>2]|0,f[a+52>>2]|0)|0;else{B=f[a+84>>2]|0;C=0;y=1;while(1){A=Y(f[B+(C<<2)>>2]|0,y)|0;C=C+1|0;if((C|0)==(z|0)){H=A;break}else y=A}}y=f[k>>2]|0;z=(y|0)<3;if(z)I=Y(f[d+12>>2]|0,f[l>>2]|0)|0;else{C=f[m>>2]|0;B=0;A=1;while(1){D=Y(f[C+(B<<2)>>2]|0,A)|0;B=B+1|0;if((B|0)==(y|0)){I=D;break}else A=D}}A=f[t>>2]|0;B=(A|0)<3;if(B)J=Y(f[e+12>>2]|0,f[v>>2]|0)|0;else{C=f[w>>2]|0;D=0;K=1;while(1){L=Y(f[C+(D<<2)>>2]|0,K)|0;D=D+1|0;if((D|0)==(A|0)){J=L;break}else K=L}}K=(I|0)==1;if(!(K|(I|0)==(H|0)|b)){if(z)M=Y(f[d+12>>2]|0,f[l>>2]|0)|0;else{D=f[m>>2]|0;C=0;L=1;while(1){N=Y(f[D+(C<<2)>>2]|0,L)|0;C=C+1|0;if((C|0)==(y|0)){M=N;break}else L=N}}if(!((y|0)==0|(M|0)==0)){G=0;break}}if((J|0)!=(H|0)&(J|0)!=1?f[e+16>>2]|0:0){if(B)O=Y(f[e+12>>2]|0,f[v>>2]|0)|0;else{L=f[w>>2]|0;C=0;D=1;while(1){N=Y(f[L+(C<<2)>>2]|0,D)|0;C=C+1|0;if((C|0)==(A|0)){O=N;break}else D=N}}if(!((A|0)==0|(O|0)==0)){G=0;break}}do if(!b){if(z)P=Y(f[d+12>>2]|0,f[l>>2]|0)|0;else{D=f[m>>2]|0;C=0;L=1;while(1){B=Y(f[D+(C<<2)>>2]|0,L)|0;C=C+1|0;if((C|0)==(y|0)){P=B;break}else L=B}}if(!((y|0)==0|(P|0)==0)){lT(g,d,1,1);L=g+36|0;C=f[L>>2]|0;if(C|0){D=C+12|0;f[D>>2]=(f[D>>2]|0)+1}D=d+36|0;C=f[D>>2]|0;if(C|0?(B=C+12|0,C=f[B>>2]|0,f[B>>2]=C+-1,(C|0)==1):0)_S(d);f[D>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){C=f[m>>2]|0;B=0;do{f[C+(B<<2)>>2]=0;B=B+1|0;Q=f[k>>2]|0}while((B|0)<(Q|0));f[d>>2]=f[g>>2];if((Q|0)<3)E=54;else E=56}else{f[d>>2]=f[g>>2];E=54}if((E|0)==54){B=f[g+4>>2]|0;if((B|0)<3){f[k>>2]=B;f[l>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];B=f[g+44>>2]|0;C=f[s>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2]}else E=56}if((E|0)==56)ZS(d,g);B=g+16|0;f[x>>2]=f[B>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];C=f[L>>2]|0;f[D>>2]=C;if(C|0?(N=C+12|0,C=f[N>>2]|0,f[N>>2]=C+-1,(C|0)==1):0)_S(g);f[L>>2]=0;C=g+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){B=f[g+40>>2]|0;N=0;do{f[B+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[C>>2]|0))}C=f[g+44>>2]|0;if((C|0)!=(g+48|0))g0(C);if(K){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=F;p[i>>3]=+n[f[x>>2]>>2];f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;C=j+8|0;f[C>>2]=0;f[C+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=F;qL(g,h,j,1.0,-1);C=a+100|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=C;p[i>>3]=+n[f[x>>2]>>2];f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;N=j+8|0;f[N>>2]=0;f[N+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=C;qL(g,h,j,1.0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=F;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;C=i+8|0;f[C>>2]=0;f[C+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=F;qL(g,h,i,1.0,-1);C=a+100|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=C;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;N=i+8|0;f[N>>2]=0;f[N+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=C;qL(g,h,i,1.0,-1);break}}}while(0);F=e+16|0;if(f[F>>2]|0){K=f[t>>2]|0;if((K|0)<3)R=Y(f[e+12>>2]|0,f[v>>2]|0)|0;else{y=f[w>>2]|0;z=0;A=1;while(1){C=Y(f[y+(z<<2)>>2]|0,A)|0;z=z+1|0;if((z|0)==(K|0)){R=C;break}else A=C}}if(!((K|0)==0|(R|0)==0)){lT(g,e,1,1);A=g+36|0;z=f[A>>2]|0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}y=e+36|0;z=f[y>>2]|0;if(z|0?(C=z+12|0,z=f[C>>2]|0,f[C>>2]=z+-1,(z|0)==1):0)_S(e);f[y>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[t>>2]|0)>0){z=f[w>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0;S=f[t>>2]|0}while((C|0)<(S|0));f[e>>2]=f[g>>2];if((S|0)<3)E=84;else E=86}else{f[e>>2]=f[g>>2];E=84}if((E|0)==84){C=f[g+4>>2]|0;if((C|0)<3){f[t>>2]=C;f[v>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];C=f[g+44>>2]|0;z=f[q>>2]|0;f[z>>2]=f[C>>2];f[z+4>>2]=f[C+4>>2]}else E=86}if((E|0)==86)ZS(e,g);C=g+16|0;f[F>>2]=f[C>>2];f[e+20>>2]=f[g+20>>2];f[e+24>>2]=f[g+24>>2];f[e+28>>2]=f[g+28>>2];f[e+32>>2]=f[g+32>>2];z=f[A>>2]|0;f[y>>2]=z;if(z|0?(K=z+12|0,z=f[K>>2]|0,f[K>>2]=z+-1,(z|0)==1):0)_S(g);f[A>>2]=0;z=g+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[z>>2]|0)>0){C=f[g+40>>2]|0;K=0;do{f[C+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[z>>2]|0))}z=f[g+44>>2]|0;if((z|0)!=(g+48|0))g0(z);if((J|0)==1){z=a+100|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=z;p[i>>3]=+n[f[F>>2]>>2];f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;K=j+8|0;f[K>>2]=0;f[K+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=z;mL(g,h,j,e0()|0,-1);G=1;break}z=a+100|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=z;lT(i,e,1,1);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=i;K=j+8|0;f[K>>2]=0;f[K+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=z;mL(g,h,j,e0()|0,-1);z=i+36|0;K=f[z>>2]|0;do if(K|0){C=K+12|0;A=f[C>>2]|0;f[C>>2]=A+-1;if((A|0)!=1)break;_S(i)}while(0);f[z>>2]=0;K=i+16|0;F=i+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[F>>2]|0)>0){K=f[i+40>>2]|0;A=0;do{f[K+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[F>>2]|0))}F=f[i+44>>2]|0;if((F|0)!=(i+48|0))g0(F);G=1}else G=1}else G=1}while(0);i=e+36|0;j=f[i>>2]|0;if(j|0?(h=j+12|0,j=f[h>>2]|0,f[h>>2]=j+-1,(j|0)==1):0)_S(e);f[i>>2]=0;i=e+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[t>>2]|0)>0){i=f[w>>2]|0;w=0;do{f[i+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[q>>2]|0;if((t|0)!=(o|0))g0(t);t=d+36|0;o=f[t>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)_S(d);f[t>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){x=f[m>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[s>>2]|0;if((k|0)==(r|0)){u=c;return G|0}g0(k);u=c;return G|0}function yzb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+44|0;if((d|0)!=(b|0)){e=a+80|0;g=f[e>>2]|0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}h=b+36|0;g=f[h>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)_S(b);f[h>>2]=0;g=b+16|0;i=b+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){j=f[b+40>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0;l=f[i>>2]|0}while((k|0)<(l|0));f[b>>2]=f[d>>2];if((l|0)<3)m=12;else m=14}else{f[b>>2]=f[d>>2];m=12}if((m|0)==12){l=f[a+48>>2]|0;if((l|0)<3){f[i>>2]=l;f[b+8>>2]=f[a+52>>2];f[b+12>>2]=f[a+56>>2];l=f[a+88>>2]|0;i=f[b+44>>2]|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2]}else m=14}if((m|0)==14)ZS(b,d);f[g>>2]=f[a+60>>2];f[b+20>>2]=f[a+64>>2];f[b+24>>2]=f[a+68>>2];f[b+28>>2]=f[a+72>>2];f[b+32>>2]=f[a+76>>2];f[h>>2]=f[e>>2]}e=a+100|0;if((e|0)==(c|0))return;h=a+136|0;b=f[h>>2]|0;if(b|0){g=b+12|0;f[g>>2]=(f[g>>2]|0)+1}g=c+36|0;b=f[g>>2]|0;if(b|0?(d=b+12|0,b=f[d>>2]|0,f[d>>2]=b+-1,(b|0)==1):0)_S(c);f[g>>2]=0;b=c+16|0;d=c+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){l=f[c+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0;n=f[d>>2]|0}while((i|0)<(n|0));f[c>>2]=f[e>>2];if((n|0)<3)m=27;else m=29}else{f[c>>2]=f[e>>2];m=27}if((m|0)==27){n=f[a+104>>2]|0;if((n|0)<3){f[d>>2]=n;f[c+8>>2]=f[a+108>>2];f[c+12>>2]=f[a+112>>2];n=f[a+144>>2]|0;d=f[c+44>>2]|0;f[d>>2]=f[n>>2];f[d+4>>2]=f[n+4>>2]}else m=29}if((m|0)==29)ZS(c,e);f[b>>2]=f[a+116>>2];f[c+20>>2]=f[a+120>>2];f[c+24>>2]=f[a+124>>2];f[c+28>>2]=f[a+128>>2];f[c+32>>2]=f[a+132>>2];f[g>>2]=f[h>>2];return}function zzb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;if((b[a+252>>0]|0)==0?(f[f[f[c>>2]>>2]>>2]|0)!=1:0){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,56)|0;k=450059;l=j+56|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-213,i,452925,449463,146)}gFa(a,c,d,e,g)|0;u=h;return 1}function Azb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=r*3|0;o=UIc(l|0,((l|0)<0)<<31>>31|0,e|0,k|0)|0;l=J;g=g+1|0;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=d;return i|0}else if((q|0)==7){f[a>>2]=0;f[a+4>>2]=0;q=tT(a,70)|0;i=452744;d=q+70|0;do{b[q>>0]=b[i>>0]|0;q=q+1|0;i=i+1|0}while((q|0)<(d|0));z5(-215,a,452815,452821,161)}return 0}function Bzb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0;if((g|0)>=(h|0))return;i=f[a+60>>2]|0;j=a+88|0;k=a+56|0;l=(f[a+100>>2]&16384|0)==0;m=f[a+116>>2]|0;o=a+140|0;p=a+144|0;q=a+112|0;r=(d|0)>0;if(f[a+44>>2]&16384|0){s=c;t=g;u=b;while(1){v=+n[i+(t<<2)>>2];do if(l?(w=f[o>>2]|0,(f[w>>2]|0)!=1):0){x=f[f[p>>2]>>2]|0;if((f[w+4>>2]|0)==1){y=m+(Y(x,t)|0)|0;break}else{w=f[q>>2]|0;z=(t|0)/(w|0)|0;y=m+(Y(z,x)|0)+(t-(Y(z,w)|0)<<2)|0;break}}else A=21;while(0);if((A|0)==21){A=0;y=m+(t<<2)|0}B=+n[y>>2];if(r){w=0;do{n[s+(w<<2)>>2]=B+v*+n[u+(w<<2)>>2];w=w+1|0}while((w|0)!=(d|0))}t=t+1|0;if((t|0)==(h|0))break;else{s=s+(e<<2)|0;u=u+(e<<2)|0}}return}u=f[a+84>>2]|0;a=(f[u>>2]|0)==1;s=u+4|0;u=c;c=g;g=b;while(1){do if(!a){b=f[f[j>>2]>>2]|0;if((f[s>>2]|0)==1){C=i+(Y(b,c)|0)|0;break}else{t=f[k>>2]|0;y=(c|0)/(t|0)|0;C=i+(Y(y,b)|0)+(c-(Y(y,t)|0)<<2)|0;break}}else C=i+(c<<2)|0;while(0);v=+n[C>>2];do if(l?(t=f[o>>2]|0,(f[t>>2]|0)!=1):0){y=f[f[p>>2]>>2]|0;if((f[t+4>>2]|0)==1){D=m+(Y(y,c)|0)|0;break}else{t=f[q>>2]|0;b=(c|0)/(t|0)|0;D=m+(Y(b,y)|0)+(c-(Y(b,t)|0)<<2)|0;break}}else A=14;while(0);if((A|0)==14){A=0;D=m+(c<<2)|0}B=+n[D>>2];if(r){t=0;do{n[u+(t<<2)>>2]=B+v*+n[g+(t<<2)>>2];t=t+1|0}while((t|0)!=(d|0))}c=c+1|0;if((c|0)==(h|0))break;else{u=u+(e<<2)|0;g=g+(e<<2)|0}}return}function Czb(a,c,e,g,h,i,j){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;k=u;u=u+64|0;l=k+44|0;m=k+32|0;n=k+20|0;o=k+8|0;p=k;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=l+11|0;b[q>>0]=2;d[l>>1]=26719;b[l+2>>0]=0;QJa(m,c,l);if((b[q>>0]|0)<0)YDc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=l+11|0;b[q>>0]=2;d[l>>1]=30559;b[l+2>>0]=0;QJa(n,c,l);if((b[q>>0]|0)<0)YDc(f[l>>2]|0);fEc(o,e);e=o+11|0;q=b[e>>0]|0;r=o+4|0;if(((q<<24>>24<0?f[r>>2]|0:q&255)|0)==0?(EEc(o,0,-1,1154740,0)|0)==0:0)iEc(o,c)|0;f[l>>2]=0;f[l+4>>2]=0;c=m+11|0;q=b[c>>0]|0;s=m+4|0;t=q<<24>>24<0?f[s>>2]|0:q&255;if(t|0){q=tT(l,t)|0;dJc(q|0,((b[c>>0]|0)<0?f[m>>2]|0:m)|0,t|0)|0}t=a+4|0;q=f[t>>2]|0;do if(!q){uT(l);v=39}else{w=f[l>>2]|0;x=(w|0)==0?1154740:w;y=q;while(1){z=f[y+16>>2]|0;if((w|0)==(z|0))break;A=(z|0)==0?1154740:z;if((Ioc(x,A)|0)<0)B=y;else{if((Ioc(A,x)|0)>=0)break;B=y+4|0}y=f[B>>2]|0;if(!y){v=36;break}}if((v|0)==36){uT(l);v=39;break}f[p>>2]=0;f[p+4>>2]=0;y=n+11|0;x=b[y>>0]|0;w=x<<24>>24<0?f[n+4>>2]|0:x&255;if(!w)C=q;else{x=tT(p,w)|0;dJc(x|0,((b[y>>0]|0)<0?f[n>>2]|0:n)|0,w|0)|0;C=f[t>>2]|0}if(!C){uT(p);uT(l);v=39;break}w=f[p>>2]|0;y=(w|0)==0?1154740:w;x=C;while(1){A=f[x+16>>2]|0;if((w|0)==(A|0)){v=29;break}z=(A|0)==0?1154740:A;if((Ioc(y,z)|0)<0)D=x;else{if((Ioc(z,y)|0)>=0){v=28;break}D=x+4|0}x=f[D>>2]|0;if(!x){v=38;break}}if((v|0)==28){uT(p);uT(l)}else if((v|0)==29){uT(p);uT(l)}else if((v|0)==38){uT(p);uT(l);v=39;break}f[l>>2]=0;f[l+4>>2]=0;x=b[c>>0]|0;y=x<<24>>24<0?f[s>>2]|0:x&255;if(y|0){x=tT(l,y)|0;dJc(x|0,((b[c>>0]|0)<0?f[m>>2]|0:m)|0,y|0)|0}y=DHa(lIa(a,l)|0,-1)|0;f[g>>2]=y;uT(l);f[l>>2]=0;f[l+4>>2]=0;y=n+11|0;x=b[y>>0]|0;w=x<<24>>24<0?f[n+4>>2]|0:x&255;if(w|0){x=tT(l,w)|0;dJc(x|0,((b[y>>0]|0)<0?f[n>>2]|0:n)|0,w|0)|0}w=DHa(lIa(a,l)|0,-1)|0;f[h>>2]=w;uT(l);E=1}while(0);a:do if((v|0)==39){f[l>>2]=0;f[l+4>>2]=0;s=b[e>>0]|0;D=s<<24>>24<0?f[r>>2]|0:s&255;if(D|0){s=tT(l,D)|0;dJc(s|0,((b[e>>0]|0)<0?f[o>>2]|0:o)|0,D|0)|0}D=f[t>>2]|0;do if(!D)uT(l);else{s=f[l>>2]|0;C=(s|0)==0?1154740:s;q=D;while(1){B=f[q+16>>2]|0;if((s|0)==(B|0)){v=49;break}w=(B|0)==0?1154740:B;if((Ioc(C,w)|0)<0)F=q;else{if((Ioc(w,C)|0)>=0){v=50;break}F=q+4|0}q=f[F>>2]|0;if(!q){v=69;break}}if((v|0)==49)uT(l);else if((v|0)==50)uT(l);else if((v|0)==69){uT(l);break}f[l>>2]=0;f[l+4>>2]=0;q=b[e>>0]|0;C=q<<24>>24<0?f[r>>2]|0:q&255;if(C|0){q=tT(l,C)|0;dJc(q|0,((b[e>>0]|0)<0?f[o>>2]|0:o)|0,C|0)|0}TFa(p,lIa(a,l)|0);uT(l);C=DHa(p,0)|0;f[g>>2]=C;q=f[p>>2]|0;switch(q|0){case 0:{s=f[p+4>>2]|0;G=s+4|0;H=s;I=s;J=s;break}case 3:{s=f[p+4>>2]|0;G=s+4|0;H=s;I=s;J=s;break}case 2:{s=f[p+4>>2]|0;G=s+4|0;H=s;I=s;J=s;break}default:{f[l>>2]=0;f[l+4>>2]=0;z5(-3,l,467763,451988,278)}}if((f[G>>2]|0)!=1){switch(q|0){case 0:{K=H+4|0;break}case 3:{K=I+4|0;break}case 2:{K=J+4|0;break}default:{f[l>>2]=0;f[l+4>>2]=0;z5(-3,l,467763,451988,278)}}if((f[K>>2]|0)==2){q=DHa(p,1)|0;L=q;v=66}else M=0}else{L=C;v=66}if((v|0)==66){f[h>>2]=L;M=1}JFa(p);E=M;break a}while(0);if(i){D=f[j>>2]|0;f[h>>2]=D;f[g>>2]=D;E=1}else E=0}while(0);if((b[e>>0]|0)<0)YDc(f[o>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if((b[c>>0]|0)>=0){u=k;return E|0}YDc(f[m>>2]|0);u=k;return E|0}function Dzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e+4|0;i=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=6;b[g>>0]=b[450236]|0;b[g+1>>0]=b[450237]|0;b[g+2>>0]=b[450238]|0;b[g+3>>0]=b[450239]|0;b[g+4>>0]=b[450240]|0;b[g+5>>0]=b[450241]|0;b[g+6>>0]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=VDc(16)|0;f[h>>2]=k;f[h+8>>2]=-2147483632;f[h+4>>2]=11;l=k;m=454911;n=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+11>>0]=0;f[i>>2]=0;k=Czb(a,g,h,c,d,0,i)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[j>>0]|0)<0)YDc(f[g>>2]|0);if(!k){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,52)|0;m=450243;n=l+52|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-5,g,450296,450310,115)}if((f[c>>2]|0)>0&(f[d>>2]|0)>0){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;l=tT(g,26)|0;m=450388;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,450296,450310,118)}}function Ezb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=u;u=u+48|0;l=k+28|0;m=k+16|0;n=k+8|0;o=k;f[l>>2]=0;f[l+4>>2]=0;p=tT(l,5)|0;b[p>>0]=b[450415]|0;b[p+1>>0]=b[450416]|0;b[p+2>>0]=b[450417]|0;b[p+3>>0]=b[450418]|0;b[p+4>>0]=b[450419]|0;p=a+4|0;q=f[p>>2]|0;a:do if(!q)r=34;else{s=f[l>>2]|0;t=(s|0)==0?1154740:s;v=q;while(1){w=f[v+16>>2]|0;if((s|0)==(w|0))break;x=(w|0)==0?1154740:w;if((Ioc(t,x)|0)<0)y=v;else{if((Ioc(x,t)|0)>=0)break;y=v+4|0}v=f[y>>2]|0;if(!v){r=34;break a}}f[m>>2]=0;f[m+4>>2]=0;v=tT(m,5)|0;b[v>>0]=b[450421]|0;b[v+1>>0]=b[450422]|0;b[v+2>>0]=b[450423]|0;b[v+3>>0]=b[450424]|0;b[v+4>>0]=b[450425]|0;v=f[p>>2]|0;if(!v){uT(m);uT(l);r=43;break}t=f[m>>2]|0;s=(t|0)==0?1154740:t;x=v;while(1){v=f[x+16>>2]|0;if((t|0)==(v|0))break;w=(v|0)==0?1154740:v;if((Ioc(s,w)|0)<0)z=x;else{if((Ioc(w,s)|0)>=0)break;z=x+4|0}x=f[z>>2]|0;if(!x){r=38;break}}if((r|0)==38){uT(m);uT(l);r=43;break}f[n>>2]=0;f[n+4>>2]=0;x=tT(n,5)|0;b[x>>0]=b[450427]|0;b[x+1>>0]=b[450428]|0;b[x+2>>0]=b[450429]|0;b[x+3>>0]=b[450430]|0;b[x+4>>0]=b[450431]|0;x=f[p>>2]|0;if(!x){uT(n);uT(m);uT(l);r=43;break}s=f[n>>2]|0;t=(s|0)==0?1154740:s;w=x;while(1){x=f[w+16>>2]|0;if((s|0)==(x|0))break;v=(x|0)==0?1154740:x;if((Ioc(t,v)|0)<0)A=w;else{if((Ioc(v,t)|0)>=0)break;A=w+4|0}w=f[A>>2]|0;if(!w){r=40;break}}if((r|0)==40){uT(n);uT(m);uT(l);r=43;break}f[o>>2]=0;f[o+4>>2]=0;w=tT(o,5)|0;b[w>>0]=b[450433]|0;b[w+1>>0]=b[450434]|0;b[w+2>>0]=b[450435]|0;b[w+3>>0]=b[450436]|0;b[w+4>>0]=b[450437]|0;w=f[p>>2]|0;if(!w){uT(o);uT(n);uT(m);uT(l);r=43;break}t=f[o>>2]|0;s=(t|0)==0?1154740:t;v=w;while(1){w=f[v+16>>2]|0;if((t|0)==(w|0)){r=33;break}x=(w|0)==0?1154740:w;if((Ioc(s,x)|0)<0)B=v;else{if((Ioc(x,s)|0)>=0){r=35;break}B=v+4|0}v=f[B>>2]|0;if(!v){r=42;break}}if((r|0)==33){uT(o);uT(n);uT(m);uT(l)}else if((r|0)==35){uT(o);uT(n);uT(m);uT(l)}else if((r|0)==42){uT(o);uT(n);uT(m);uT(l);r=43;break}f[l>>2]=0;f[l+4>>2]=0;v=tT(l,5)|0;b[v>>0]=b[450421]|0;b[v+1>>0]=b[450422]|0;b[v+2>>0]=b[450423]|0;b[v+3>>0]=b[450424]|0;b[v+4>>0]=b[450425]|0;v=DHa(lIa(a,l)|0,-1)|0;f[c>>2]=v;uT(l);f[l>>2]=0;f[l+4>>2]=0;v=tT(l,5)|0;b[v>>0]=b[450415]|0;b[v+1>>0]=b[450416]|0;b[v+2>>0]=b[450417]|0;b[v+3>>0]=b[450418]|0;b[v+4>>0]=b[450419]|0;v=DHa(lIa(a,l)|0,-1)|0;f[d>>2]=v;uT(l);f[l>>2]=0;f[l+4>>2]=0;v=tT(l,5)|0;b[v>>0]=b[450433]|0;b[v+1>>0]=b[450434]|0;b[v+2>>0]=b[450435]|0;b[v+3>>0]=b[450436]|0;b[v+4>>0]=b[450437]|0;v=DHa(lIa(a,l)|0,-1)|0;f[e>>2]=v;uT(l);f[l>>2]=0;f[l+4>>2]=0;v=tT(l,5)|0;b[v>>0]=b[450427]|0;b[v+1>>0]=b[450428]|0;b[v+2>>0]=b[450429]|0;b[v+3>>0]=b[450430]|0;b[v+4>>0]=b[450431]|0;v=DHa(lIa(a,l)|0,-1)|0;f[g>>2]=v;uT(l)}while(0);if((r|0)==34){uT(l);r=43}if((r|0)==43){o=l+4|0;f[o>>2]=0;f[o+4>>2]=0;o=l+11|0;b[o>>0]=3;b[l>>0]=b[453999]|0;b[l+1>>0]=b[454e3]|0;b[l+2>>0]=b[454001]|0;b[l+3>>0]=0;B=m+4|0;f[B>>2]=0;f[B+4>>2]=0;B=m+11|0;b[B>>0]=3;b[m>>0]=b[453999]|0;b[m+1>>0]=b[454e3]|0;b[m+2>>0]=b[454001]|0;b[m+3>>0]=0;f[n>>2]=0;Czb(a,l,m,c,d,1,n)|0;if((b[B>>0]|0)<0)YDc(f[m>>2]|0);if((b[o>>0]|0)<0)YDc(f[l>>2]|0);f[e>>2]=f[c>>2];f[g>>2]=f[d>>2]};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;o=l+11|0;b[o>>0]=6;b[l>>0]=b[454003]|0;b[l+1>>0]=b[454004]|0;b[l+2>>0]=b[454005]|0;b[l+3>>0]=b[454006]|0;b[l+4>>0]=b[454007]|0;b[l+5>>0]=b[454008]|0;b[l+6>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;B=m+11|0;b[B>>0]=6;b[m>>0]=b[454003]|0;b[m+1>>0]=b[454004]|0;b[m+2>>0]=b[454005]|0;b[m+3>>0]=b[454006]|0;b[m+4>>0]=b[454007]|0;b[m+5>>0]=b[454008]|0;b[m+6>>0]=0;f[n>>2]=1;Czb(a,l,m,h,i,1,n)|0;if((b[B>>0]|0)<0)YDc(f[m>>2]|0);if((b[o>>0]|0)<0)YDc(f[l>>2]|0);uT(j);f[l>>2]=0;f[l+4>>2]=0;o=tT(l,8)|0;B=o;b[B>>0]=112;b[B+1>>0]=97;b[B+2>>0]=100;b[B+3>>0]=95;B=o+4|0;b[B>>0]=109;b[B+1>>0]=111;b[B+2>>0]=100;b[B+3>>0]=101;B=f[p>>2]|0;b:do if(!B)r=60;else{p=f[l>>2]|0;o=(p|0)==0?1154740:p;n=B;while(1){A=f[n+16>>2]|0;if((p|0)==(A|0))break;z=(A|0)==0?1154740:A;if((Ioc(o,z)|0)<0)C=n;else{if((Ioc(z,o)|0)>=0)break;C=n+4|0}n=f[C>>2]|0;if(!n){r=60;break b}}uT(l);f[m>>2]=0;f[m+4>>2]=0;n=tT(m,8)|0;o=n;b[o>>0]=112;b[o+1>>0]=97;b[o+2>>0]=100;b[o+3>>0]=95;o=n+4|0;b[o>>0]=109;b[o+1>>0]=111;b[o+2>>0]=100;b[o+3>>0]=101;EHa(l,lIa(a,m)|0,-1);if((l|0)!=(j|0)){uT(j);o=f[l>>2]|0;if(!o)D=0;else{n=o+-4|0;f[n>>2]=(f[n>>2]|0)+1;D=f[l>>2]|0}f[j>>2]=D;f[j+4>>2]=f[l+4>>2]}uT(l);uT(m)}while(0);if((r|0)==60)uT(l);if(((f[h>>2]|0)>0?(f[d>>2]|f[c>>2]|f[e>>2]|f[g>>2]|0)>-1:0)&(f[i>>2]|0)>0){u=k;return}else{f[l>>2]=0;f[l+4>>2]=0;k=tT(l,78)|0;i=450439;g=k+78|0;do{b[k>>0]=b[i>>0]|0;k=k+1|0;i=i+1|0}while((k|0)<(g|0));z5(-215,l,450518,450310,142)}}function Fzb(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;n=u;u=u+32|0;o=n+16|0;p=n+8|0;q=n;Ezb(a,g,h,i,j,k,l,m);f[o>>2]=0;f[o+4>>2]=0;m=tT(o,14)|0;r=454860;s=m+14|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));t=a+4|0;v=f[t>>2]|0;a:do if(!v)w=10;else{x=f[o>>2]|0;y=(x|0)==0?1154740:x;z=v;while(1){A=f[z+16>>2]|0;if((x|0)==(A|0))break;B=(A|0)==0?1154740:A;if((Ioc(y,B)|0)<0)C=z;else{if((Ioc(B,y)|0)>=0)break;C=z+4|0}z=f[C>>2]|0;if(!z){w=10;break a}}f[p>>2]=0;f[p+4>>2]=0;m=tT(p,14)|0;r=454860;s=m+14|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));z=DHa(lIa(a,p)|0,-1)|0;b[e>>0]=((z|0)!=0|(J|0)!=0)&1;uT(p)}while(0);if((w|0)==10)b[e>>0]=0;uT(o);if(!(b[e>>0]|0)){Dzb(a,c,d);u=n;return}f[o>>2]=0;f[o+4>>2]=0;d=tT(o,8)|0;c=d;b[c>>0]=107;b[c+1>>0]=101;b[c+2>>0]=114;b[c+3>>0]=110;c=d+4|0;b[c>>0]=101;b[c+1>>0]=108;b[c+2>>0]=95;b[c+3>>0]=104;c=f[t>>2]|0;b:do if(c|0){d=f[o>>2]|0;a=(d|0)==0?1154740:d;e=c;while(1){C=f[e+16>>2]|0;if((d|0)==(C|0))break;v=(C|0)==0?1154740:C;if((Ioc(a,v)|0)<0)D=e;else{if((Ioc(v,a)|0)>=0)break;D=e+4|0}e=f[D>>2]|0;if(!e)break b}uT(o);f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,82)|0;m=F;r=450538;s=m+82|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));z5(-5,o,450621,450310,159)}while(0);f[p>>2]=0;f[p+4>>2]=0;D=tT(p,8)|0;c=D;b[c>>0]=107;b[c+1>>0]=101;b[c+2>>0]=114;b[c+3>>0]=110;c=D+4|0;b[c>>0]=101;b[c+1>>0]=108;b[c+2>>0]=95;b[c+3>>0]=119;c=f[t>>2]|0;c:do if(c|0){D=f[p>>2]|0;e=(D|0)==0?1154740:D;a=c;while(1){d=f[a+16>>2]|0;if((D|0)==(d|0)){w=38;break}v=(d|0)==0?1154740:d;if((Ioc(e,v)|0)<0)G=a;else{if((Ioc(v,e)|0)>=0){w=39;break}G=a+4|0}a=f[G>>2]|0;if(!a)break c}if((w|0)==38){uT(p);uT(o);f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,82)|0;m=F;r=450538;s=m+82|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));z5(-5,o,450621,450310,159)}else if((w|0)==39){uT(p);uT(o);f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,82)|0;m=F;r=450538;s=m+82|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));z5(-5,o,450621,450310,159)}}while(0);f[q>>2]=0;f[q+4>>2]=0;m=tT(q,11)|0;r=454911;s=m+11|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));G=f[t>>2]|0;do if(G){t=f[q>>2]|0;c=(t|0)==0?1154740:t;a=G;while(1){e=f[a+16>>2]|0;if((t|0)==(e|0)){w=40;break}D=(e|0)==0?1154740:e;if((Ioc(c,D)|0)<0)H=a;else{if((Ioc(D,c)|0)>=0){w=36;break}H=a+4|0}a=f[H>>2]|0;if(!a){w=43;break}}if((w|0)==36){uT(q);uT(p);uT(o);f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,82)|0;m=F;r=450538;s=m+82|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));z5(-5,o,450621,450310,159)}else if((w|0)==40){uT(q);uT(p);uT(o);f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,82)|0;m=F;r=450538;s=m+82|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));z5(-5,o,450621,450310,159)}else if((w|0)==43){uT(q);uT(p);uT(o);break}}else{uT(q);uT(p);uT(o)}while(0);if(((f[k>>2]|0)==1?(f[h>>2]|f[g>>2]|f[i>>2]|f[j>>2]|0)==0:0)&(f[l>>2]|0)==1){u=n;return}else{f[o>>2]=0;f[o+4>>2]=0;m=tT(o,79)|0;r=450644;s=m+79|0;do{b[m>>0]=b[r>>0]|0;m=m+1|0;r=r+1|0}while((m|0)<(s|0));z5(-5,o,450621,450310,163)}}function Gzb(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0;o=u;u=u+32|0;p=o+16|0;q=o;r=o+28|0;Dzb(a,c,d);Ezb(a,e,g,h,i,j,k,n);f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;n=p+11|0;b[n>>0]=8;k=p;f[k>>2]=1634494820;f[k+4>>2]=1852795252;b[p+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;k=q+11|0;b[k>>0]=8;j=q;f[j>>2]=1634494820;f[j+4>>2]=1852795252;b[q+8>>0]=0;f[r>>2]=1;Czb(a,p,q,l,m,1,r)|0;if((b[k>>0]|0)<0)YDc(f[q>>2]|0);if((b[n>>0]|0)<0)YDc(f[p>>2]|0);if((f[l>>2]|0)>0&(f[m>>2]|0)>0){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,30)|0;m=450724;l=o+30|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(l|0));z5(-215,p,450755,450310,179)}}function Hzb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i;k=f[e>>2]|0;if((k|0)!=450782?(e=(k|0)==0?1154740:k,Ioc(e,450782)|0):0){if((k|0)!=450788?Ioc(e,450788)|0:0){f[j>>2]=0;f[j+4>>2]=0;e=tT(j,24)|0;k=450793;l=e+24|0;do{b[e>>0]=b[k>>0]|0;e=e+1|0;k=k+1|0}while((e|0)<(l|0));z5(-2,j,450818,450310,207)}j=f[d+4>>2]|0;f[h+4>>2]=((f[a+4>>2]|0)+-1+j|0)/(j|0)|0;j=f[d>>2]|0;m=(f[a>>2]|0)+-1+j|0;n=j;o=(m|0)/(n|0)|0;f[h>>2]=o;u=i;return}j=Y((f[c+4>>2]|0)+-1|0,f[g+4>>2]|0)|0;k=f[d+4>>2]|0;f[h+4>>2]=((f[a+4>>2]|0)+-1+k-j|0)/(k|0)|0;k=Y((f[c>>2]|0)+-1|0,f[g>>2]|0)|0;g=f[d>>2]|0;m=(f[a>>2]|0)+-1+g-k|0;n=g;o=(m|0)/(n|0)|0;f[h>>2]=o;u=i;return}function Izb(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;l=f[e>>2]|0;if((l|0)!=450782?(e=(l|0)==0?1154740:l,Ioc(e,450782)|0):0){if((l|0)!=450788?Ioc(e,450788)|0:0)return;e=Y((f[b+4>>2]|0)+-1|0,f[d+4>>2]|0)|0;l=Y((f[c+4>>2]|0)+-1|0,f[g+4>>2]|0)|0;m=e+1-(f[a+4>>2]|0)+l|0;l=Y((f[b>>2]|0)+-1|0,f[d>>2]|0)|0;d=Y((f[c>>2]|0)+-1|0,f[g>>2]|0)|0;g=l+1-(f[a>>2]|0)+d|0;d=((m|0)>0?m:0)>>>1;f[j>>2]=d;f[h>>2]=d;d=((g|0)>0?g:0)>>>1;f[k>>2]=d;f[i>>2]=d;return}f[k>>2]=0;f[j>>2]=0;f[i>>2]=0;f[h>>2]=0;return}function Jzb(a,b){a=a|0;b=b|0;var c=0;c=VDc(72)|0;Kzb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=104640;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Kzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;JHa(a);f[a>>2]=104660;g=a+40|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[475710]|0;b[g+1>>0]=b[475711]|0;b[g+2>>0]=b[475712]|0;b[g+3>>0]=b[475713]|0;b[g+4>>0]=b[475714]|0;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1154740:i;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((Ioc((n|0)==0?1154740:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<=-1:0){p=1;break}k=DHa(o+24|0,-1)|0;p=k}else p=1}else p=1;while(0);f[a+36>>2]=p;uT(e);KHa(a,c);u=d;return}function Lzb(a){a=a|0;YDc(a);return}function Mzb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Nzb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=104660;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=a+40|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+44>>2]=0;REa(a);return}function Ozb(a){a=a|0;Nzb(a);YDc(a);return}function Pzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+192|0;g=e+180|0;h=e+168|0;i=e+128|0;j=e+112|0;k=e+56|0;l=e;m=a+36|0;if((f[m>>2]|0)==1){u=e;return}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=i+4;d=i+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[j>>2]=0;f[j+4>>2]=0;d=tT(j,5)|0;b[d>>0]=b[454713]|0;b[d+1>>0]=b[454714]|0;b[d+2>>0]=b[454715]|0;b[d+3>>0]=b[454716]|0;b[d+4>>0]=b[454717]|0;d=VDc(16)|0;f[d>>2]=d+8;f[d+4>>2]=4;c=XDc(32)|0;f[d>>2]=c;f[k>>2]=0;f[k+4>>2]=d;d=c;f[d>>2]=0;f[d+4>>2]=0;d=c+8|0;f[d>>2]=2;f[d+4>>2]=0;d=c+16|0;f[d>>2]=1;f[d+4>>2]=0;d=c+24|0;f[d>>2]=3;f[d+4>>2]=0;bIa(i,j,k)|0;JFa(k);uT(j);opb(j,i);d=a+40|0;c=f[j>>2]|0;n=f[j+4>>2]|0;if(c|0){o=c+4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[d>>2]|0;f[d>>2]=c;c=a+44|0;f[c>>2]=n;if(o|0?(n=o+4|0,d=f[n>>2]|0,f[n>>2]=d+-1,(d|0)==1):0)Yi[f[(f[o>>2]|0)+8>>2]&2047](o);o=f[j>>2]|0;if(o|0?(d=o+4|0,n=f[d>>2]|0,f[d>>2]=n+-1,(n|0)==1):0)Yi[f[(f[o>>2]|0)+8>>2]&2047](o);o=f[g>>2]|0;n=f[h>>2]|0;d=a+48|0;p=a+52|0;q=f[p>>2]|0;r=f[d>>2]|0;s=q-r>>2;t=r;r=q;if(s>>>0>=4)if((s|0)!=4?(q=t+16|0,(r|0)!=(q|0)):0){f[p>>2]=r+(~((r+-4-q|0)>>>2)<<2);v=t}else v=t;else{lN(d,4-s|0);v=f[d>>2]|0}s=f[o+40>>2]|0;f[v>>2]=f[s>>2];f[v+4>>2]=f[m>>2];f[v+8>>2]=(f[s+4>>2]|0)/(f[m>>2]|0)|0;m=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;f[v+12>>2]=m;m=a+60|0;s=a+64|0;a=f[s>>2]|0;t=f[m>>2]|0;q=a-t>>2;r=t;t=a;if(q>>>0>=4)if((q|0)!=4?(a=r+16|0,(t|0)!=(a|0)):0){f[s>>2]=t+(~((t+-4-a|0)>>>2)<<2);w=v;x=r}else{w=v;x=r}else{lN(m,4-q|0);w=f[d>>2]|0;x=f[m>>2]|0}f[x>>2]=f[w>>2];f[x+4>>2]=f[w+8>>2];f[x+8>>2]=f[w+4>>2];f[x+12>>2]=f[w+12>>2];nT(k,o,1,d);qFa(j,1,k);d=k+36|0;o=f[d>>2]|0;if(o|0?(w=o+12|0,o=f[w>>2]|0,f[w>>2]=o+-1,(o|0)==1):0)_S(k);f[d>>2]=0;d=k+16|0;o=k+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[o>>2]|0)>0){d=f[k+40>>2]|0;w=0;do{f[d+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[o>>2]|0))}o=f[k+44>>2]|0;if((o|0)!=(k+48|0))g0(o);nT(l,n,1,m);qFa(k,1,l);m=l+36|0;n=f[m>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)_S(l);f[m>>2]=0;m=l+16|0;n=l+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){m=f[l+40>>2]|0;o=0;do{f[m+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)!=(l+48|0))g0(n);LHa(f[c>>2]|0,j,k);mx(k);mx(j);HFa(i);mx(h);mx(g);u=e;return}function Qzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=u;u=u+272|0;g=e+256|0;h=e+244|0;i=e+232|0;j=e+176|0;k=e+120|0;l=e+64|0;m=e+48|0;n=e+32|0;o=e+16|0;p=e;if((p$(b,-1)|0)==3){kFa(a,b,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(b,g);f$(c,h);f$(d,i);d=f[g>>2]|0;f[j>>2]=f[d>>2];c=j+4|0;b=d+4|0;f[c>>2]=f[b>>2];q=j+8|0;f[q>>2]=f[d+8>>2];r=j+12|0;f[r>>2]=f[d+12>>2];s=j+16|0;f[s>>2]=f[d+16>>2];t=j+20|0;f[t>>2]=f[d+20>>2];v=j+24|0;f[v>>2]=f[d+24>>2];w=j+28|0;f[w>>2]=f[d+28>>2];x=j+32|0;f[x>>2]=f[d+32>>2];y=j+36|0;z=f[d+36>>2]|0;f[y>>2]=z;A=j+40|0;f[A>>2]=q;B=j+48|0;C=j+44|0;f[C>>2]=B;f[B>>2]=0;f[j+52>>2]=0;if(z|0){D=z+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[b>>2]|0)<3){b=f[d+44>>2]|0;D=f[C>>2]|0;f[D>>2]=f[b>>2];f[D+4>>2]=f[b+4>>2]}else{f[c>>2]=0;ZS(j,d)}d=f[h>>2]|0;f[k>>2]=f[d>>2];b=k+4|0;D=d+4|0;f[b>>2]=f[D>>2];z=k+8|0;f[z>>2]=f[d+8>>2];E=k+12|0;f[E>>2]=f[d+12>>2];F=k+16|0;f[F>>2]=f[d+16>>2];G=k+20|0;f[G>>2]=f[d+20>>2];H=k+24|0;f[H>>2]=f[d+24>>2];I=k+28|0;f[I>>2]=f[d+28>>2];J=k+32|0;f[J>>2]=f[d+32>>2];K=k+36|0;L=f[d+36>>2]|0;f[K>>2]=L;M=k+40|0;f[M>>2]=z;N=k+48|0;O=k+44|0;f[O>>2]=N;f[N>>2]=0;f[k+52>>2]=0;if(L|0){P=L+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[D>>2]|0)<3){D=f[d+44>>2]|0;P=f[O>>2]|0;f[P>>2]=f[D>>2];f[P+4>>2]=f[D+4>>2]}else{f[b>>2]=0;ZS(k,d)}do if((f[s>>2]|0)!=(f[F>>2]|0)){d=a+44|0;if(!(f[d>>2]|0)){D=l+8|0;f[D>>2]=0;f[D+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;h_(j,l);break}nT(l,j,1,a+48|0);D=l+36|0;P=f[D>>2]|0;if(P|0){L=P+12|0;f[L>>2]=(f[L>>2]|0)+1}L=f[y>>2]|0;if(L|0?(P=L+12|0,L=f[P>>2]|0,f[P>>2]=L+-1,(L|0)==1):0)_S(j);f[y>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[c>>2]|0)>0){L=f[A>>2]|0;P=0;do{f[L+(P<<2)>>2]=0;P=P+1|0;Q=f[c>>2]|0}while((P|0)<(Q|0));f[j>>2]=f[l>>2];if((Q|0)<3)R=25;else R=27}else{f[j>>2]=f[l>>2];R=25}if((R|0)==25){P=f[l+4>>2]|0;if((P|0)<3){f[c>>2]=P;f[q>>2]=f[l+8>>2];f[r>>2]=f[l+12>>2];P=f[l+44>>2]|0;L=f[C>>2]|0;f[L>>2]=f[P>>2];f[L+4>>2]=f[P+4>>2]}else R=27}if((R|0)==27)ZS(j,l);P=l+16|0;f[s>>2]=f[P>>2];f[t>>2]=f[l+20>>2];f[v>>2]=f[l+24>>2];f[w>>2]=f[l+28>>2];f[x>>2]=f[l+32>>2];L=f[D>>2]|0;f[y>>2]=L;if(L|0?(S=L+12|0,L=f[S>>2]|0,f[S>>2]=L+-1,(L|0)==1):0)_S(l);f[D>>2]=0;L=l+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[L>>2]|0)>0){P=f[l+40>>2]|0;S=0;do{f[P+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[L>>2]|0))}L=f[l+44>>2]|0;if((L|0)!=(l+48|0))g0(L);nT(l,k,1,a+60|0);L=l+36|0;S=f[L>>2]|0;if(S|0){P=S+12|0;f[P>>2]=(f[P>>2]|0)+1}P=f[K>>2]|0;if(P|0?(S=P+12|0,P=f[S>>2]|0,f[S>>2]=P+-1,(P|0)==1):0)_S(k);f[K>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[b>>2]|0)>0){P=f[M>>2]|0;S=0;do{f[P+(S<<2)>>2]=0;S=S+1|0;T=f[b>>2]|0}while((S|0)<(T|0));f[k>>2]=f[l>>2];if((T|0)<3)R=46;else R=48}else{f[k>>2]=f[l>>2];R=46}if((R|0)==46){S=f[l+4>>2]|0;if((S|0)<3){f[b>>2]=S;f[z>>2]=f[l+8>>2];f[E>>2]=f[l+12>>2];S=f[l+44>>2]|0;P=f[O>>2]|0;f[P>>2]=f[S>>2];f[P+4>>2]=f[S+4>>2]}else R=48}if((R|0)==48)ZS(k,l);S=l+16|0;f[F>>2]=f[S>>2];f[G>>2]=f[l+20>>2];f[H>>2]=f[l+24>>2];f[I>>2]=f[l+28>>2];f[J>>2]=f[l+32>>2];P=f[L>>2]|0;f[K>>2]=P;if(P|0?(D=P+12|0,P=f[D>>2]|0,f[D>>2]=P+-1,(P|0)==1):0)_S(l);f[L>>2]=0;P=l+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[P>>2]|0)>0){S=f[l+40>>2]|0;D=0;do{f[S+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[P>>2]|0))}P=f[l+44>>2]|0;if((P|0)!=(l+48|0))g0(P);qFa(l,1,j);qFa(m,1,k);P=f[d>>2]|0;D=f[(f[P>>2]|0)+44>>2]|0;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=17104896;f[n+4>>2]=l;S=o+8|0;f[S>>2]=0;f[S+4>>2]=0;f[o>>2]=33882112;f[o+4>>2]=m;S=p+8|0;f[S>>2]=0;f[S+4>>2]=0;f[p>>2]=33882112;f[p+4>>2]=i;ei[D&511](P,n,o,p);mx(m);mx(l)}while(0);l=f[K>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)_S(k);f[K>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[b>>2]|0)>0){F=f[M>>2]|0;M=0;do{f[F+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[b>>2]|0))}b=f[O>>2]|0;if((b|0)!=(N|0))g0(b);b=f[y>>2]|0;if(b|0?(N=b+12|0,b=f[N>>2]|0,f[N>>2]=b+-1,(b|0)==1):0)_S(j);f[y>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[c>>2]|0)>0){s=f[A>>2]|0;A=0;do{f[s+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[c>>2]|0))}c=f[C>>2]|0;if((c|0)!=(B|0))g0(c);mx(i);mx(h);mx(g);u=e;return}function Rzb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h;j=f[c>>2]|0;if(((f[c+4>>2]|0)-j|0)==12?(k=f[j>>2]|0,((f[j+4>>2]|0)-k|0)==16):0){j=a+36|0;if(!((f[k+4>>2]|0)%(f[j>>2]|0)|0)){gFa(a,c,d,e,g)|0;u=h;return (f[j>>2]|0)==1|0}else{f[i>>2]=0;f[i+4>>2]=0;l=tT(i,25)|0;m=451056;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,452925,450970,26)}}f[i>>2]=0;f[i+4>>2]=0;l=tT(i,43)|0;m=450926;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,452925,450970,25);return 0}function Szb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0;d=u;u=u+64|0;e=d+48|0;g=d+8|0;h=d;f[e>>2]=0;f[e+4>>2]=0;i=tT(e,11)|0;j=451173;k=i+11|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));l=c+4|0;m=f[l>>2]|0;do if(m){o=f[e>>2]|0;p=(o|0)==0?1154740:o;q=l;r=m;a:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)==(o|0))break;if((Ioc((t|0)==0?1154740:t,p)|0)>=0)break;t=f[s+4>>2]|0;if(!t){v=q;break a}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)!=(l|0)){q=f[v+16>>2]|0;if((o|0)!=(q|0)?(Ioc(p,(q|0)==0?1154740:q)|0)<=-1:0){w=12;break}q=DHa(v+24|0,-1)|0;r=(q|0)==0&(J|0)==0;uT(e);if(r){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,13)|0;j=451185;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));p=f[l>>2]|0;do if(p){o=f[g>>2]|0;r=(o|0)==0?1154740:o;q=l;t=p;b:while(1){x=t;while(1){y=f[x+16>>2]|0;if((y|0)==(o|0))break;if((Ioc((y|0)==0?1154740:y,r)|0)>=0)break;y=f[x+4>>2]|0;if(!y){z=q;break b}else x=y}t=f[x>>2]|0;if(!t){z=x;break}else q=x}if((z|0)!=(l|0)){q=f[z+16>>2]|0;if((o|0)!=(q|0)?(Ioc(r,(q|0)==0?1154740:q)|0)<=-1:0){A=.5;break}A=+tIa(z+24|0,-1)}else A=.5}else A=.5;while(0);B=1.0-A;uT(g);n[e>>2]=B;if(!(B>0.0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,9)|0;j=451199;k=i+9|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,g,464481,451209,139)}f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=g+4;p=g+12|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;p=c+24|0;q=g+24|0;if((g|0)!=(c|0)){uT(q);t=f[p>>2]|0;if(!t)C=0;else{s=t+-4|0;f[s>>2]=(f[s>>2]|0)+1;C=f[p>>2]|0}f[q>>2]=C;f[g+28>>2]=f[c+28>>2]}q=g+32|0;uT(q);p=tT(q,5)|0;b[p>>0]=b[451285]|0;b[p+1>>0]=b[451286]|0;b[p+2>>0]=b[451287]|0;b[p+3>>0]=b[451288]|0;b[p+4>>0]=b[451289]|0;f[h>>2]=0;f[h+4>>2]=0;p=tT(h,5)|0;b[p>>0]=b[451291]|0;b[p+1>>0]=b[451292]|0;b[p+2>>0]=b[451293]|0;b[p+3>>0]=b[451294]|0;b[p+4>>0]=b[451295]|0;eIa(g,h,e)|0;uT(h);Eub(h,g);p=f[h>>2]|0;f[a>>2]=p;f[a+4>>2]=f[h+4>>2];q=p;if(!p){D=h;E=q}else{p=q+4|0;f[p>>2]=(f[p>>2]|0)+1;D=h;E=f[h>>2]|0}if(E|0?(p=E+4|0,q=f[p>>2]|0,f[p>>2]=q+-1,(q|0)==1):0)Yi[f[(f[E>>2]|0)+8>>2]&2047](E);f[D>>2]=0;HFa(g);u=d;return}}else w=12}else w=12;while(0);if((w|0)==12)uT(e);e=VDc(36)|0;JHa(e);f[e>>2]=104768;KHa(e,c);c=VDc(16)|0;w=c+4|0;f[w>>2]=1;f[c>>2]=104876;f[c+8>>2]=e;f[a>>2]=c;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1){u=d;return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);u=d;return}function Tzb(a){a=a|0;YDc(a);return}function Uzb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Vzb(a){a=a|0;REa(a);YDc(a);return}function Wzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;a=d+28|0;e=d+16|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;f$(b,a);f$(c,e);c=f[e>>2]|0;b=(f[h>>2]|0)-c|0;h=(b|0)/56|0;if((b|0)<=0){mx(e);mx(a);u=d;return}b=g+8|0;i=g+4|0;j=0;k=c;while(1){c=f[a>>2]|0;if((f[k+(j*56|0)+16>>2]|0)!=(f[c+(j*56|0)+16>>2]|0)){l=b;f[l>>2]=0;f[l+4>>2]=0;f[g>>2]=33619968;f[i>>2]=k+(j*56|0);h_(c+(j*56|0)|0,g)}c=j+1|0;if((c|0)>=(h|0))break;j=c;k=f[e>>2]|0}mx(e);mx(a);u=d;return}function Xzb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=vmb()|0;break}default:c=0}return c|0}function Yzb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Zzb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gFa(a,b,c,d,e)|0;return 1}function _zb(){var a=0;f[131644]=0;f[131645]=0;f[131646]=0;b[526587]=8;a=526576;f[a>>2]=1869181520;f[a+4>>2]=2020557426;b[526584]=0;be(1736,526576,x|0)|0;return}function $zb(a,b){a=a|0;b=b|0;var c=0;c=VDc(132)|0;aAb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=104896;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function aAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;d=u;u=u+64|0;e=d+16|0;g=d+48|0;h=d;i=d+36|0;j=d+32|0;k=d+28|0;JHa(a);f[a>>2]=104916;l=a+52|0;m=a+56|0;o=a+76|0;p=a+80|0;q=a+88|0;r=a+92|0;s=a+100|0;t=a+104|0;v=a+112|0;w=a+116|0;x=l;y=x+72|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=8;A=e;f[A>>2]=1601071469;f[A+4>>2]=1702521203;b[e+8>>0]=0;f[g>>2]=0;n[h>>2]=0.0;B=+dAb(a,c,e,g,0,h);A=a+36|0;n[A>>2]=B;if((b[z>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=4;f[e>>2]=1885957222;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=1;C=(eAb(a,c,e,g,0,h)|0)&1;b[a+124>>0]=C;if((b[z>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=4;f[e>>2]=1885957219;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=1;C=(eAb(a,c,e,g,0,h)|0)&1;b[a+125>>0]=C;if((b[z>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=VDc(16)|0;f[e>>2]=z;f[e+8>>2]=-2147483632;f[e+4>>2]=15;x=z;C=451529;y=x+15|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[z+15>>0]=0;f[g>>2]=0;b[h>>0]=1;z=(eAb(a,c,e,g,0,h)|0)&1;b[a+127>>0]=z;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);z=f[l>>2]|0;D=f[m>>2]|0;if((D|0)!=(z|0))f[m>>2]=D+(~((D+-4-z|0)>>>2)<<2);fAb(a,c);gAb(a,c);z=a+40|0;n[z>>2]=-1.0;f[e>>2]=0;f[e+4>>2]=0;D=tT(e,8)|0;E=D;b[E>>0]=109;b[E+1>>0]=97;b[E+2>>0]=120;b[E+3>>0]=95;E=D+4|0;b[E>>0]=115;b[E+1>>0]=105;b[E+2>>0]=122;b[E+3>>0]=101;E=c+4|0;D=f[E>>2]|0;do if(D){F=f[e>>2]|0;G=(F|0)==0?1154740:F;H=D;while(1){I=f[H+16>>2]|0;if((F|0)==(I|0)){J=19;break}K=(I|0)==0?1154740:I;if((Ioc(G,K)|0)<0)L=H;else{if((Ioc(K,G)|0)>=0){J=20;break}L=H+4|0}H=f[L>>2]|0;if(!H){J=24;break}}if((J|0)==19)uT(e);else if((J|0)==20)uT(e);else if((J|0)==24){uT(e);break}f[e>>2]=0;f[e+4>>2]=0;H=tT(e,8)|0;G=H;b[G>>0]=109;b[G+1>>0]=97;b[G+2>>0]=120;b[G+3>>0]=95;G=H+4|0;b[G>>0]=115;b[G+1>>0]=105;b[G+2>>0]=122;b[G+3>>0]=101;B=+tIa(lIa(c,e)|0,0);n[z>>2]=B;uT(e);if(!(+n[z>>2]>+n[A>>2])){f[e>>2]=0;f[e+4>>2]=0;x=tT(e,19)|0;C=451545;y=x+19|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,e,451565,451583,197)}}else uT(e);while(0);f[e>>2]=0;L=e+4|0;f[L>>2]=0;f[e+8>>2]=0;f[g>>2]=0;D=g+4|0;f[D>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=h+11|0;b[G>>0]=5;b[h>>0]=b[467281]|0;b[h+1>>0]=b[467282]|0;b[h+2>>0]=b[467283]|0;b[h+3>>0]=b[467284]|0;b[h+4>>0]=b[467285]|0;b[h+5>>0]=0;hAb(h,c,e);if((b[G>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=h+11|0;b[G>>0]=6;b[h>>0]=b[467287]|0;b[h+1>>0]=b[467288]|0;b[h+2>>0]=b[467289]|0;b[h+3>>0]=b[467290]|0;b[h+4>>0]=b[467291]|0;b[h+5>>0]=b[467292]|0;b[h+6>>0]=0;hAb(h,c,g);if((b[G>>0]|0)<0)YDc(f[h>>2]|0);G=f[e>>2]|0;H=f[L>>2]|0;F=(G|0)!=(H|0);b[a+126>>0]=F&1;if((H-G|0)!=((f[D>>2]|0)-(f[g>>2]|0)|0)){f[h>>2]=0;f[h+4>>2]=0;x=tT(h,31)|0;C=451663;y=x+31|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,204)}if(F){if((f[l>>2]|0)!=(f[m>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;x=tT(h,21)|0;C=451695;y=x+21|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,208)}f[h>>2]=0;f[h+4>>2]=0;F=tT(h,8)|0;G=F;b[G>>0]=109;b[G+1>>0]=105;b[G+2>>0]=110;b[G+3>>0]=95;G=F+4|0;b[G>>0]=115;b[G+1>>0]=105;b[G+2>>0]=122;b[G+3>>0]=101;G=f[E>>2]|0;do if(G){F=f[h>>2]|0;H=(F|0)==0?1154740:F;K=G;while(1){I=f[K+16>>2]|0;if((F|0)==(I|0)){J=42;break}N=(I|0)==0?1154740:I;if((Ioc(H,N)|0)<0)O=K;else{if((Ioc(N,H)|0)>=0){J=43;break}O=K+4|0}K=f[O>>2]|0;if(!K){J=46;break}}if((J|0)==42){uT(h);f[h>>2]=0;P=h+4|0;f[P>>2]=0;Q=tT(h,23)|0;x=Q;C=451717;y=x+23|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,209)}else if((J|0)==43){uT(h);f[h>>2]=0;P=h+4|0;f[P>>2]=0;Q=tT(h,23)|0;x=Q;C=451717;y=x+23|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,209)}else if((J|0)==46){uT(h);break}}else uT(h);while(0);f[h>>2]=0;f[h+4>>2]=0;Q=tT(h,8)|0;P=Q;b[P>>0]=109;b[P+1>>0]=97;b[P+2>>0]=120;b[P+3>>0]=95;P=Q+4|0;b[P>>0]=115;b[P+1>>0]=105;b[P+2>>0]=122;b[P+3>>0]=101;P=f[E>>2]|0;do if(P){Q=f[h>>2]|0;O=(Q|0)==0?1154740:Q;G=P;while(1){K=f[G+16>>2]|0;if((Q|0)==(K|0)){J=55;break}H=(K|0)==0?1154740:K;if((Ioc(O,H)|0)<0)R=G;else{if((Ioc(H,O)|0)>=0){J=56;break}R=G+4|0}G=f[R>>2]|0;if(!G){J=59;break}}if((J|0)==55){uT(h);f[h>>2]=0;S=h+4|0;f[S>>2]=0;T=tT(h,23)|0;x=T;C=451741;y=x+23|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,210)}else if((J|0)==56){uT(h);f[h>>2]=0;S=h+4|0;f[S>>2]=0;T=tT(h,23)|0;x=T;C=451741;y=x+23|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,210)}else if((J|0)==59){uT(h);break}}else uT(h);while(0);if((s|0)!=(e|0))DF(s,f[e>>2]|0,f[L>>2]|0);if((v|0)!=(g|0))DF(v,f[g>>2]|0,f[D>>2]|0)}else{if(!(+n[A>>2]>0.0)){f[h>>2]=0;f[h+4>>2]=0;x=tT(h,12)|0;C=451765;y=x+12|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,216)}T=((f[m>>2]|0)-(f[l>>2]|0)>>2)+(+n[z>>2]>0.0?2:1)|0;S=f[t>>2]|0;R=f[s>>2]|0;P=S-R>>2;G=R;O=S;Q=R;if(T>>>0<=P>>>0)if(T>>>0<P>>>0?(H=G+(T<<2)|0,(O|0)!=(H|0)):0){K=O+(~((O+-4-H|0)>>>2)<<2)|0;f[t>>2]=K;U=R;V=K;W=G;X=Q}else{U=R;V=S;W=G;X=Q}else{fqb(s,T-P|0);P=f[s>>2]|0;U=P;V=f[t>>2]|0;W=P;X=P}P=V-U>>2;U=f[w>>2]|0;V=f[v>>2]|0;T=U-V>>2;Q=V;G=U;U=V;if(P>>>0<=T>>>0)if(P>>>0<T>>>0?(V=Q+(P<<2)|0,(G|0)!=(V|0)):0){f[w>>2]=G+(~((G+-4-V|0)>>>2)<<2);Z=U;_=X;$=Q;aa=W}else{Z=U;_=X;$=Q;aa=W}else{fqb(v,P-T|0);T=f[v>>2]|0;P=f[s>>2]|0;Z=T;_=P;$=T;aa=P}P=f[A>>2]|0;f[Z>>2]=P;f[_>>2]=P;B=+n[z>>2];if(B>0.0){ba=+M(+(B*+n[A>>2]));n[$+4>>2]=ba;n[aa+4>>2]=ba;ca=2}else ca=1;z=f[m>>2]|0;m=f[l>>2]|0;l=m;if((z|0)!=(m|0)){P=z-m>>2;m=0;do{ba=+M(+(+n[l+(m<<2)>>2]));z=m+ca|0;n[aa+(z<<2)>>2]=ba*+n[A>>2];n[$+(z<<2)>>2]=+n[A>>2]/ba;m=m+1|0}while(m>>>0<P>>>0)}}P=(f[t>>2]|0)-(f[s>>2]|0)>>2;if((P|0)!=((f[w>>2]|0)-(f[v>>2]|0)>>2|0)){f[h>>2]=0;f[h+4>>2]=0;x=tT(h,39)|0;C=451778;y=x+39|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,237)}v=a+128|0;f[v>>2]=P;f[h>>2]=0;f[h+4>>2]=0;P=tT(h,6)|0;b[P>>0]=b[451818]|0;b[P+1>>0]=b[451819]|0;b[P+2>>0]=b[451820]|0;b[P+3>>0]=b[451821]|0;b[P+4>>0]=b[451822]|0;b[P+5>>0]=b[451823]|0;P=f[E>>2]|0;a:do if(P){w=f[h>>2]|0;s=(w|0)==0?1154740:w;t=P;while(1){m=f[t+16>>2]|0;if((w|0)==(m|0)){J=100;break}A=(m|0)==0?1154740:m;if((Ioc(s,A)|0)<0)da=t;else{if((Ioc(A,s)|0)>=0){J=101;break}da=t+4|0}t=f[da>>2]|0;if(!t){J=91;break a}}if((J|0)==100){uT(h);J=103;break}else if((J|0)==101){uT(h);J=103;break}}else J=91;while(0);b:do if((J|0)==91){f[i>>2]=0;f[i+4>>2]=0;da=tT(i,6)|0;b[da>>0]=b[451825]|0;b[da+1>>0]=b[451826]|0;b[da+2>>0]=b[451827]|0;b[da+3>>0]=b[451828]|0;b[da+4>>0]=b[451829]|0;b[da+5>>0]=b[451830]|0;da=f[E>>2]|0;do if(da){P=f[i>>2]|0;t=(P|0)==0?1154740:P;s=da;while(1){w=f[s+16>>2]|0;if((P|0)==(w|0)){J=102;break}A=(w|0)==0?1154740:w;if((Ioc(t,A)|0)<0)ea=s;else{if((Ioc(A,t)|0)>=0){J=99;break}ea=s+4|0}s=f[ea>>2]|0;if(!s){J=125;break}}if((J|0)==99){uT(i);uT(h);J=103;break b}else if((J|0)==102){uT(i);uT(h);J=103;break b}else if((J|0)==125){uT(i);uT(h);break}}else{uT(i);uT(h)}while(0);f[h>>2]=0;f[h+4>>2]=0;da=tT(h,4)|0;b[da>>0]=115;b[da+1>>0]=116;b[da+2>>0]=101;b[da+3>>0]=112;da=f[E>>2]|0;do if(da){s=f[h>>2]|0;t=(s|0)==0?1154740:s;P=da;while(1){A=f[P+16>>2]|0;if((s|0)==(A|0)){J=134;break}w=(A|0)==0?1154740:A;if((Ioc(t,w)|0)<0)fa=P;else{if((Ioc(w,t)|0)>=0){J=135;break}fa=P+4|0}P=f[fa>>2]|0;if(!P){J=141;break}}if((J|0)==134)uT(h);else if((J|0)==135)uT(h);else if((J|0)==141){uT(h);ga=0.0;break};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;P=h+11|0;b[P>>0]=4;f[h>>2]=1885697139;b[h+4>>0]=0;f[i>>2]=0;n[j>>2]=0.0;ba=+dAb(a,c,h,i,1,j);if((b[P>>0]|0)<0)YDc(f[h>>2]|0);if(ba>0.0)ga=ba;else{f[h>>2]=0;f[h+4>>2]=0;P=tT(h,8)|0;t=P;b[t>>0]=115;b[t+1>>0]=116;b[t+2>>0]=101;b[t+3>>0]=112;t=P+4|0;b[t>>0]=32;b[t+1>>0]=62;b[t+2>>0]=32;b[t+3>>0]=48;z5(-215,h,451565,451583,248)}}else{uT(h);ga=0.0}while(0);n[a+48>>2]=ga;n[a+44>>2]=ga}while(0);if((J|0)==103){f[h>>2]=0;f[h+4>>2]=0;fa=tT(h,4)|0;b[fa>>0]=115;b[fa+1>>0]=116;b[fa+2>>0]=101;b[fa+3>>0]=112;fa=f[E>>2]|0;do if(fa){ea=f[h>>2]|0;da=(ea|0)==0?1154740:ea;t=fa;while(1){P=f[t+16>>2]|0;if((ea|0)==(P|0)){J=111;break}s=(P|0)==0?1154740:P;if((Ioc(da,s)|0)<0)ha=t;else{if((Ioc(s,da)|0)>=0){J=112;break}ha=t+4|0}t=f[ha>>2]|0;if(!t){J=115;break}}if((J|0)==111){uT(h);f[h>>2]=0;ia=h+4|0;f[ia>>2]=0;ja=tT(h,19)|0;x=ja;C=451832;y=x+19|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,241)}else if((J|0)==112){uT(h);f[h>>2]=0;ia=h+4|0;f[ia>>2]=0;ja=tT(h,19)|0;x=ja;C=451832;y=x+19|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,241)}else if((J|0)==115){uT(h);break}}else uT(h);while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;ja=h+11|0;b[ja>>0]=6;b[h>>0]=b[451818]|0;b[h+1>>0]=b[451819]|0;b[h+2>>0]=b[451820]|0;b[h+3>>0]=b[451821]|0;b[h+4>>0]=b[451822]|0;b[h+5>>0]=b[451823]|0;b[h+6>>0]=0;f[i>>2]=0;n[j>>2]=0.0;ga=+dAb(a,c,h,i,1,j);ia=a+48|0;n[ia>>2]=ga;if((b[ja>>0]|0)<0){YDc(f[h>>2]|0);ka=+n[ia>>2]}else ka=ga;if(!(ka>0.0)){f[h>>2]=0;f[h+4>>2]=0;x=tT(h,11)|0;C=451852;y=x+11|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,243)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;ia=h+11|0;b[ia>>0]=6;b[h>>0]=b[451825]|0;b[h+1>>0]=b[451826]|0;b[h+2>>0]=b[451827]|0;b[h+3>>0]=b[451828]|0;b[h+4>>0]=b[451829]|0;b[h+5>>0]=b[451830]|0;b[h+6>>0]=0;f[i>>2]=0;n[j>>2]=0.0;ka=+dAb(a,c,h,i,1,j);ja=a+44|0;n[ja>>2]=ka;if((b[ia>>0]|0)<0){YDc(f[h>>2]|0);la=+n[ja>>2]}else la=ka;if(!(la>0.0)){f[h>>2]=0;f[h+4>>2]=0;x=tT(h,11)|0;C=451864;y=x+11|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,245)}}f[h>>2]=0;f[h+4>>2]=0;ja=tT(h,8)|0;ia=ja;b[ia>>0]=111;b[ia+1>>0]=102;b[ia+2>>0]=102;b[ia+3>>0]=115;ia=ja+4|0;b[ia>>0]=101;b[ia+1>>0]=116;b[ia+2>>0]=95;b[ia+3>>0]=104;ia=f[E>>2]|0;c:do if(ia){ja=f[h>>2]|0;ha=(ja|0)==0?1154740:ja;fa=ia;while(1){t=f[fa+16>>2]|0;if((ja|0)==(t|0)){J=160;break}da=(t|0)==0?1154740:t;if((Ioc(ha,da)|0)<0)ma=fa;else{if((Ioc(da,ha)|0)>=0){J=161;break}ma=fa+4|0}fa=f[ma>>2]|0;if(!fa){J=151;break c}}if((J|0)==160){uT(h);J=163;break}else if((J|0)==161){uT(h);J=163;break}}else J=151;while(0);d:do if((J|0)==151){f[i>>2]=0;f[i+4>>2]=0;ma=tT(i,8)|0;ia=ma;b[ia>>0]=111;b[ia+1>>0]=102;b[ia+2>>0]=102;b[ia+3>>0]=115;ia=ma+4|0;b[ia>>0]=101;b[ia+1>>0]=116;b[ia+2>>0]=95;b[ia+3>>0]=119;ia=f[E>>2]|0;do if(ia){ma=f[i>>2]|0;fa=(ma|0)==0?1154740:ma;ha=ia;while(1){ja=f[ha+16>>2]|0;if((ma|0)==(ja|0)){J=162;break}da=(ja|0)==0?1154740:ja;if((Ioc(fa,da)|0)<0)na=ha;else{if((Ioc(da,fa)|0)>=0){J=159;break}na=ha+4|0}ha=f[na>>2]|0;if(!ha){J=210;break}}if((J|0)==159){uT(i);uT(h);J=163;break d}else if((J|0)==162){uT(i);uT(h);J=163;break d}else if((J|0)==210){uT(i);uT(h);break}}else{uT(i);uT(h)}while(0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ia=i+11|0;b[ia>>0]=6;b[i>>0]=b[451876]|0;b[i+1>>0]=b[451877]|0;b[i+2>>0]=b[451878]|0;b[i+3>>0]=b[451879]|0;b[i+4>>0]=b[451880]|0;b[i+5>>0]=b[451881]|0;b[i+6>>0]=0;f[j>>2]=0;n[k>>2]=.5;la=+dAb(a,c,i,j,0,k);if((b[ia>>0]|0)<0)YDc(f[i>>2]|0);n[h>>2]=la;eqb(o,1,h);eqb(q,1,h)}while(0);do if((J|0)==163){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,6)|0;b[i>>0]=b[451876]|0;b[i+1>>0]=b[451877]|0;b[i+2>>0]=b[451878]|0;b[i+3>>0]=b[451879]|0;b[i+4>>0]=b[451880]|0;b[i+5>>0]=b[451881]|0;i=f[E>>2]|0;do if(i){k=f[h>>2]|0;j=(k|0)==0?1154740:k;a=i;while(1){na=f[a+16>>2]|0;if((k|0)==(na|0)){J=171;break}ia=(na|0)==0?1154740:na;if((Ioc(j,ia)|0)<0)oa=a;else{if((Ioc(ia,j)|0)>=0){J=172;break}oa=a+4|0}a=f[oa>>2]|0;if(!a){J=175;break}}if((J|0)==171){uT(h);f[h>>2]=0;pa=h+4|0;f[pa>>2]=0;qa=tT(h,21)|0;x=qa;C=451883;y=x+21|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,257)}else if((J|0)==172){uT(h);f[h>>2]=0;pa=h+4|0;f[pa>>2]=0;qa=tT(h,21)|0;x=qa;C=451883;y=x+21|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,257)}else if((J|0)==175){uT(h);break}}else uT(h);while(0);f[h>>2]=0;f[h+4>>2]=0;i=tT(h,8)|0;a=i;b[a>>0]=111;b[a+1>>0]=102;b[a+2>>0]=102;b[a+3>>0]=115;a=i+4|0;b[a>>0]=101;b[a+1>>0]=116;b[a+2>>0]=95;b[a+3>>0]=104;a=f[E>>2]|0;if(!a){uT(h);f[h>>2]=0;ra=h+4|0;f[ra>>2]=0;sa=tT(h,22)|0;x=sa;C=451905;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,257)}i=f[h>>2]|0;j=(i|0)==0?1154740:i;k=a;while(1){ia=f[k+16>>2]|0;if((i|0)==(ia|0)){J=184;break}na=(ia|0)==0?1154740:ia;if((Ioc(j,na)|0)<0)ta=k;else{if((Ioc(na,j)|0)>=0){J=188;break}ta=k+4|0}k=f[ta>>2]|0;if(!k){J=186;break}}if((J|0)==184)uT(h);else if((J|0)==186){uT(h);f[h>>2]=0;ra=h+4|0;f[ra>>2]=0;sa=tT(h,22)|0;x=sa;C=451905;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,257)}else if((J|0)==188)uT(h);f[h>>2]=0;f[h+4>>2]=0;k=tT(h,8)|0;j=k;b[j>>0]=111;b[j+1>>0]=102;b[j+2>>0]=102;b[j+3>>0]=115;j=k+4|0;b[j>>0]=101;b[j+1>>0]=116;b[j+2>>0]=95;b[j+3>>0]=119;j=f[E>>2]|0;if(!j){uT(h);f[h>>2]=0;ua=h+4|0;f[ua>>2]=0;va=tT(h,22)|0;x=va;C=451928;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,257)}k=f[h>>2]|0;i=(k|0)==0?1154740:k;a=j;while(1){na=f[a+16>>2]|0;if((k|0)==(na|0)){J=197;break}ia=(na|0)==0?1154740:na;if((Ioc(i,ia)|0)<0)wa=a;else{if((Ioc(ia,i)|0)>=0){J=201;break}wa=a+4|0}a=f[wa>>2]|0;if(!a){J=199;break}}if((J|0)==197)uT(h);else if((J|0)==199){uT(h);f[h>>2]=0;ua=h+4|0;f[ua>>2]=0;va=tT(h,22)|0;x=va;C=451928;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,257)}else if((J|0)==201)uT(h);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=h+11|0;b[a>>0]=8;i=h;f[i>>2]=1936090735;f[i+4>>2]=1751086181;b[h+8>>0]=0;hAb(h,c,q);if((b[a>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=h+11|0;b[a>>0]=8;i=h;f[i>>2]=1936090735;f[i+4>>2]=2002744421;b[h+8>>0]=0;hAb(h,c,o);if((b[a>>0]|0)<0)YDc(f[h>>2]|0);a=(f[p>>2]|0)-(f[o>>2]|0)|0;if((a|0)==((f[r>>2]|0)-(f[q>>2]|0)|0)){i=(a>>1)+-2|0;a=Y(f[v>>2]|0,i>>>0>1?i:1)|0;f[v>>2]=a;break}else{f[h>>2]=0;f[h+4>>2]=0;x=tT(h,36)|0;C=451951;y=x+36|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));z5(-215,h,451565,451583,260)}}while(0);h=f[g>>2]|0;if(h|0){g=f[D>>2]|0;if((g|0)!=(h|0))f[D>>2]=g+(~((g+-4-h|0)>>>2)<<2);YDc(h)}h=f[e>>2]|0;if(!h){u=d;return}e=f[L>>2]|0;if((e|0)!=(h|0))f[L>>2]=e+(~((e+-4-h|0)>>>2)<<2);YDc(h);u=d;return}function bAb(a){a=a|0;YDc(a);return}function cAb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dAb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0.0;a=u;u=u+32|0;i=a+24|0;j=a+8|0;k=a;f[i>>2]=0;l=VDc(16)|0;m=l+8|0;f[l>>2]=m;f[l+4>>2]=1;f[i+4>>2]=l;l=m;f[l>>2]=0;f[l+4>>2]=0;if(iAb(c,d,i)|0){o=+tIa(i,f[e>>2]|0);JFa(i);u=a;return +o}if(!g){o=+n[h>>2];JFa(i);u=a;return +o}fEc(j,526576);uEc(j,452152)|0;a=b[d+11>>0]|0;i=a<<24>>24<0;tEc(j,i?f[d>>2]|0:d,i?f[d+4>>2]|0:a&255)|0;uEc(j,452187)|0;f[k>>2]=0;f[k+4>>2]=0;a=j+11|0;d=b[a>>0]|0;i=d<<24>>24<0?f[j+4>>2]|0:d&255;if(!i)z5(-5,k,452199,451583,92);d=tT(k,i)|0;dJc(d|0,((b[a>>0]|0)<0?f[j>>2]|0:j)|0,i|0)|0;z5(-5,k,452199,451583,92);return +(0.0)}function eAb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+32|0;i=a+24|0;j=a+8|0;k=a;f[i>>2]=0;l=VDc(16)|0;m=l+8|0;f[l>>2]=m;f[l+4>>2]=1;f[i+4>>2]=l;l=m;f[l>>2]=0;f[l+4>>2]=0;if(iAb(c,d,i)|0){c=DHa(i,f[e>>2]|0)|0;n=(c|0)!=0|(J|0)!=0;JFa(i);u=a;return n|0}if(!g){n=(b[h>>0]|0)!=0;JFa(i);u=a;return n|0}fEc(j,526576);uEc(j,452152)|0;n=b[d+11>>0]|0;a=n<<24>>24<0;tEc(j,a?f[d>>2]|0:d,a?f[d+4>>2]|0:n&255)|0;uEc(j,452187)|0;f[k>>2]=0;f[k+4>>2]=0;n=j+11|0;d=b[n>>0]|0;a=d<<24>>24<0?f[j+4>>2]|0:d&255;if(!a)z5(-5,k,452199,451583,92);d=tT(k,a)|0;dJc(d|0,((b[n>>0]|0)<0?f[j>>2]|0:j)|0,a|0)|0;z5(-5,k,452199,451583,92);return 0}function fAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[g>>2]=0;i=g+4|0;j=VDc(16)|0;k=j+8|0;f[j>>2]=k;f[j+4>>2]=1;f[i>>2]=j;j=k;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=VDc(16)|0;f[e>>2]=j;f[e+8>>2]=-2147483632;f[e+4>>2]=12;k=j;l=452139;m=k+12|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+12>>0]=0;j=iAb(c,e,g)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if(!j){JFa(g);u=d;return}j=a+52|0;c=a+56|0;l=a+60|0;k=a+124|0;a=g+4|0;m=0;a:while(1){switch(f[g>>2]|0){case 0:{o=(f[i>>2]|0)+4|0;break}case 3:{o=(f[a>>2]|0)+4|0;break}case 2:{o=(f[a>>2]|0)+4|0;break}default:{p=9;break a}}if((m|0)>=(f[o>>2]|0)){p=24;break}q=+tIa(g,m);n[e>>2]=q;r=+L(+(q+-1.0))<9.999999974752427e-07;s=f[c>>2]|0;t=f[j>>2]|0;v=t;w=s;if(r|(s|0)==(t|0))x=r;else{r=s-t>>2;t=0;do{y=+L(+(q-+n[v+(t<<2)>>2]))<1.0e-06;t=t+1|0}while(!(y|t>>>0>=r>>>0));x=y}if(!x){if((w|0)==(f[l>>2]|0))osb(j,e);else{n[s>>2]=q;f[c>>2]=w+4}if(b[k>>0]|0){z=1.0/+n[e>>2];n[h>>2]=z;r=f[c>>2]|0;if((r|0)==(f[l>>2]|0))osb(j,h);else{n[r>>2]=z;f[c>>2]=r+4}}}m=m+1|0}if((p|0)==9){f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}else if((p|0)==24){JFa(g);u=d;return}}function gAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0;d=u;u=u+32|0;e=d;g=d+24|0;h=d+16|0;f[g>>2]=0;i=g+4|0;j=VDc(16)|0;k=j+8|0;f[j>>2]=k;f[j+4>>2]=1;f[i>>2]=j;j=k;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=8;k=e;f[k>>2]=1769103734;f[k+4>>2]=1701015137;b[e+8>>0]=0;k=iAb(c,e,g)|0;if((b[j>>0]|0)<0)YDc(f[e>>2]|0);if(!k){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,26)|0;m=452069;o=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,e,452096,451583,149)}switch(f[g>>2]|0){case 0:{p=(f[i>>2]|0)+4|0;break}case 3:{p=(f[g+4>>2]|0)+4|0;break}case 2:{p=(f[g+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}i=f[p>>2]|0;if((i|0)<=1){if((i|0)!=1){n[e>>2]=.10000000149011612;p=a+68|0;k=f[p>>2]|0;if((k|0)==(f[a+72>>2]|0))osb(a+64|0,e);else{f[k>>2]=1036831949;f[p>>2]=k+4}JFa(g);u=d;return}q=+tIa(g,0);n[e>>2]=q;if(!(q>0.0)){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,12)|0;m=452126;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,452096,451583,169)}k=a+68|0;p=f[k>>2]|0;if((p|0)==(f[a+72>>2]|0))osb(a+64|0,e);else{n[p>>2]=q;f[k>>2]=p+4}JFa(g);u=d;return}if((i|0)!=4){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,17)|0;m=452108;o=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,e,452096,451583,155)}i=a+68|0;p=a+72|0;k=a+64|0;q=+tIa(g,0);n[e>>2]=q;if(!(q>0.0)){f[h>>2]=0;r=h+4|0;f[r>>2]=0;s=tT(h,12)|0;l=s;m=452126;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,452096,451583,160)}a=f[i>>2]|0;if((a|0)==(f[p>>2]|0))osb(k,e);else{n[a>>2]=q;f[i>>2]=a+4}q=+tIa(g,1);n[e>>2]=q;if(!(q>0.0)){f[h>>2]=0;r=h+4|0;f[r>>2]=0;s=tT(h,12)|0;l=s;m=452126;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,452096,451583,160)}a=f[i>>2]|0;if((a|0)==(f[p>>2]|0))osb(k,e);else{n[a>>2]=q;f[i>>2]=a+4}q=+tIa(g,2);n[e>>2]=q;if(!(q>0.0)){f[h>>2]=0;r=h+4|0;f[r>>2]=0;s=tT(h,12)|0;l=s;m=452126;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,452096,451583,160)}a=f[i>>2]|0;if((a|0)==(f[p>>2]|0))osb(k,e);else{n[a>>2]=q;f[i>>2]=a+4}q=+tIa(g,3);n[e>>2]=q;if(!(q>0.0)){f[h>>2]=0;r=h+4|0;f[r>>2]=0;s=tT(h,12)|0;l=s;m=452126;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));z5(-215,h,452096,451583,160)}h=f[i>>2]|0;if((h|0)==(f[p>>2]|0))osb(k,e);else{n[h>>2]=q;f[i>>2]=h+4}JFa(g);u=d;return}function hAb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0;d=u;u=u+16|0;e=d+8|0;g=d;f[g>>2]=0;h=g+4|0;i=VDc(16)|0;j=i+8|0;f[i>>2]=j;f[i+4>>2]=1;f[h>>2]=i;i=j;f[i>>2]=0;f[i+4>>2]=0;if(!(iAb(b,a,g)|0)){a=f[c>>2]|0;b=c+4|0;i=f[b>>2]|0;if((i|0)==(a|0)){JFa(g);u=d;return}f[b>>2]=i+(~((i+-4-a|0)>>>2)<<2);JFa(g);u=d;return}switch(f[g>>2]|0){case 0:{k=(f[h>>2]|0)+4|0;break}case 3:{k=(f[g+4>>2]|0)+4|0;break}case 2:{k=(f[g+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}a=f[k>>2]|0;k=c+4|0;i=f[k>>2]|0;b=f[c>>2]|0;j=i-b>>2;l=b;b=i;if(a>>>0<=j>>>0){if(a>>>0<j>>>0?(i=l+(a<<2)|0,(b|0)!=(i|0)):0)f[k>>2]=b+(~((b+-4-i|0)>>>2)<<2)}else fqb(c,a-j|0);j=g+4|0;a=0;a:while(1){switch(f[g>>2]|0){case 0:{m=(f[h>>2]|0)+4|0;break}case 3:{m=(f[j>>2]|0)+4|0;break}case 2:{m=(f[j>>2]|0)+4|0;break}default:{o=17;break a}}if((a|0)>=(f[m>>2]|0)){o=22;break}p=+tIa(g,a);n[(f[c>>2]|0)+(a<<2)>>2]=p;a=a+1|0}if((o|0)==17){f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}else if((o|0)==22){JFa(g);u=d;return}}function iAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=c+4|0;k=i<<24>>24<0?f[j>>2]|0:i&255;if(k|0){i=tT(g,k)|0;dJc(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}k=f[a+4>>2]|0;a:do if(k|0){i=f[g>>2]|0;l=(i|0)==0?1154740:i;m=k;while(1){n=f[m+16>>2]|0;if((i|0)==(n|0))break;o=(n|0)==0?1154740:n;if((Ioc(l,o)|0)<0)p=m;else{if((Ioc(o,l)|0)>=0)break;p=m+4|0}m=f[p>>2]|0;if(!m)break a}uT(g);f[g>>2]=0;f[g+4>>2]=0;m=b[h>>0]|0;l=m<<24>>24<0?f[j>>2]|0:m&255;if(l|0){m=tT(g,l)|0;dJc(m|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,l|0)|0}gIa(d,lIa(a,g)|0)|0;uT(g);q=1;u=e;return q|0}while(0);uT(g);q=0;u=e;return q|0}function jAb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=104916;b=f[a+112>>2]|0;if(b|0){c=a+116|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+100>>2]|0;if(b|0){d=a+104|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+88>>2]|0;if(b|0){c=a+92|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+76>>2]|0;if(b|0){d=a+80|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+64>>2]|0;if(b|0){c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+52>>2]|0;if(!b){REa(a);return}d=a+56|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b);REa(a);return}function kAb(a){a=a|0;jAb(a);YDc(a);return}function lAb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;f$(b,d);b=f[d>>2]|0;g=((f[e>>2]|0)-b|0)/56|0;e=b;if(g>>>0<=1)$1(g,1,105016);g=f[e+4>>2]|0;if((g|0)!=4)_1(g,4,105044);g=f[e+60>>2]|0;if((g|0)!=4)_1(g,4,105072);g=f[e+40>>2]|0;b=f[g+12>>2]|0;h=f[e+96>>2]|0;e=f[h+12>>2]|0;i=a+48|0;j=+n[i>>2];if(!(j==0.0)){k=j;n[i>>2]=k;l=a+44|0;m=+n[l>>2];o=m==0.0;p=+(e|0);q=+(b|0);r=p/q;s=o?r:m;n[l>>2]=s;mx(d);u=c;return}k=+(f[h+8>>2]|0)/+(f[g+8>>2]|0);n[i>>2]=k;l=a+44|0;m=+n[l>>2];o=m==0.0;p=+(e|0);q=+(b|0);r=p/q;s=o?r:m;n[l>>2]=s;mx(d);u=c;return}function mAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;g=u;u=u+128|0;h=g+116|0;i=g+104|0;j=g+48|0;k=g+32|0;l=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);d=f[h>>2]|0;c=d;if(((f[e>>2]|0)-d|0)!=112){f[j>>2]=0;f[j+4>>2]=0;d=tT(j,18)|0;e=453044;m=d+18|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(m|0));z5(-215,j,453206,451583,418)}e=f[c+40>>2]|0;d=f[e+12>>2]|0;m=f[e+8>>2]|0;e=f[c+96>>2]|0;c=(m|0)==0;if(!c?(o=a+100|0,q=a+104|0,r=a+112|0,s=a+76|0,t=a+80|0,v=a+44|0,w=a+88|0,x=a+48|0,y=+(f[e+12>>2]|0),z=+(f[e+8>>2]|0),e=a+127|0,d|0):0){A=f[(f[i>>2]|0)+16>>2]|0;B=0;C=f[q>>2]|0;D=f[o>>2]|0;while(1){E=+(B>>>0);F=0;G=A;H=C;I=D;J=D;K=D;while(1){if((H|0)==(I|0)){L=G;M=J;N=K;O=I;P=I}else{Q=+(F>>>0);R=f[s>>2]|0;S=0;T=G;U=K;V=J;W=H;X=R;Z=f[t>>2]|0;_=R;while(1){if((Z|0)==(_|0)){$=T;aa=X;ba=_;ca=_;da=V;ea=W}else{fa=+n[U+(S<<2)>>2]*.5;ga=+n[(f[r>>2]|0)+(S<<2)>>2]*.5;R=0;ha=T;ia=X;do{ja=(Q+ +n[ia+(R<<2)>>2])*+n[v>>2];ka=(E+ +n[(f[w>>2]|0)+(R<<2)>>2])*+n[x>>2];la=ja-fa;ma=fa+ja;ja=ga+ka;na=ka-ga;if(!(b[e>>0]|0)){n[ha>>2]=la;oa=ja+-1.0;pa=ma+-1.0;qa=na}else{n[ha>>2]=la/y;oa=ja/z;pa=ma/y;qa=na/z}n[ha+4>>2]=qa;n[ha+8>>2]=pa;n[ha+12>>2]=oa;ha=ha+16|0;R=R+1|0;ra=f[t>>2]|0;sa=f[s>>2]|0;ia=sa}while(R>>>0<ra-sa>>2>>>0);$=ha;aa=ia;ba=sa;ca=ra;da=f[o>>2]|0;ea=f[q>>2]|0}S=S+1|0;R=da;if(S>>>0>=ea-da>>2>>>0){L=$;M=da;N=R;O=da;P=ea;break}else{T=$;U=R;V=da;W=ea;X=aa;Z=ca;_=ba}}}F=F+1|0;if((F|0)==(d|0))break;else{G=L;H=P;I=O;J=M;K=N}}B=B+1|0;if((B|0)==(m|0))break;else{A=L;C=P;D=M}}}if(b[a+125>>0]|0){M=Y(Y(d<<2,m)|0,f[a+128>>2]|0)|0;D=f[i>>2]|0;P=f[D+16>>2]|0;if(!M){ta=D;ua=P}else{C=0;do{L=P+(C<<2)|0;n[j>>2]=0.0;A=+n[L>>2]<0.0?j:L;n[k>>2]=1.0;f[L>>2]=f[(+n[A>>2]>1.0?k:A)>>2];C=C+1|0}while((C|0)!=(M|0));ta=D;ua=P}}else{P=f[i>>2]|0;ta=P;ua=f[P+16>>2]|0}P=ua+(f[(f[ta+44>>2]|0)+4>>2]|0)|0;ua=a+64|0;D=f[ua>>2]|0;M=D;if(((f[a+68>>2]|0)-D|0)==4){Vj(j,1,f[(f[ta+40>>2]|0)+8>>2]|0,5,P,0);oa=+n[f[ua>>2]>>2];p[l>>3]=oa;p[l+8>>3]=oa;p[l+16>>3]=oa;p[l+24>>3]=oa;f[k>>2]=-1056833530;f[k+4>>2]=l;f[k+8>>2]=1;f[k+12>>2]=4;l_(j,k,e0()|0)|0;k=j+36|0;l=f[k>>2]|0;if(l|0?(ua=l+12|0,l=f[ua>>2]|0,f[ua>>2]=l+-1,(l|0)==1):0)_S(j);f[k>>2]=0;k=j+16|0;l=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[j+40>>2]|0;ua=0;do{f[k+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))g0(l)}else if(!(c|(d|0)==0)){c=f[a+128>>2]|0;a=D;D=M+4|0;l=M+8|0;j=M+12|0;M=0;ua=0;k=c;while(1){if(!k){va=0;wa=ua}else{ta=0;C=ua;while(1){A=0;L=C;do{f[P+(L<<2)>>2]=f[a>>2];f[P+(L+1<<2)>>2]=f[D>>2];f[P+(L+2<<2)>>2]=f[l>>2];f[P+(L+3<<2)>>2]=f[j>>2];L=L+4|0;A=A+1|0}while(A>>>0<c>>>0);ta=ta+1|0;if((ta|0)==(d|0)){va=c;wa=L;break}else C=L}}M=M+1|0;if((M|0)==(m|0))break;else{ua=wa;k=va}}}mx(i);mx(h);u=g;return}function nAb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=vmb()|0;break}default:c=0}return c|0}function oAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function pAb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+32|0;d=g+16|0;h=g;i=f[c>>2]|0;if((i|0)==(f[c+4>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;c=tT(d,15)|0;j=453702;k=c+15|0;do{b[c>>0]=b[j>>0]|0;c=c+1|0;j=j+1|0}while((c|0)<(k|0));z5(-215,d,452925,451583,282)}j=f[i>>2]|0;i=Y(Y(f[j+8>>2]<<2,f[j+12>>2]|0)|0,f[a+128>>2]|0)|0;f[d>>2]=1;f[d+4>>2]=2;f[d+8>>2]=i;f[d+12>>2]=-1;f[h>>2]=0;i=h+4|0;f[i>>2]=0;f[h+8>>2]=0;lFa(h,d,d+16|0);d=f[h>>2]|0;a=f[i>>2]|0;a:do if((d|0)==(a|0)){l=d;m=6}else{j=d;do{if((f[j>>2]|0)<0){l=j;m=6;break a}j=j+4|0}while((j|0)!=(a|0))}while(0);if((m|0)==6?(l|0)!=(a|0):0){m=l+4|0;if((m|0)==(a|0)){n=a;o=l}else{d=m;m=l;while(1){l=f[d>>2]|0;if((l|0)<0)p=m;else{f[m>>2]=l;p=m+4|0}d=d+4|0;if((d|0)==(a|0))break;else m=p}n=f[i>>2]|0;o=p}if((o|0)!=(n|0))f[i>>2]=n+(~((n+-4-o|0)>>>2)<<2)}o=e+4|0;n=f[o>>2]|0;p=f[e>>2]|0;m=n-p|0;a=(m|0)/12|0;d=p;p=n;if(m){if(a>>>0>1?(m=d+12|0,(p|0)!=(m|0)):0){d=p;while(1){p=d+-12|0;f[o>>2]=p;n=f[p>>2]|0;if(!n)q=p;else{p=d+-8|0;l=f[p>>2]|0;if((l|0)!=(n|0))f[p>>2]=l+(~((l+-4-n|0)>>>2)<<2);YDc(n);q=f[o>>2]|0}if((q|0)==(m|0))break;else d=q}}}else npb(e,1-a|0,h);a=f[h>>2]|0;if(!a){u=g;return 0}h=f[i>>2]|0;if((h|0)!=(a|0))f[i>>2]=h+(~((h+-4-a|0)>>>2)<<2);YDc(a);u=g;return 0}function qAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=f[c+4>>2]|0;h=f[c>>2]|0;c=h;if((g|0)==(h|0)){i=0;j=0;J=i;u=d;return j|0}k=a+128|0;a=(g-h|0)/12|0;h=0;g=0;do{l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=4){q=8;break}if((n|0)>8){n=2;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;h=(Y(r<<2,f[k>>2]|0)|0)+h|0;g=g+1|0}while(g>>>0<a>>>0);if((q|0)==8){f[e>>2]=0;f[e+4>>2]=0;q=tT(e,70)|0;a=452744;g=q+70|0;do{b[q>>0]=b[a>>0]|0;q=q+1|0;a=a+1|0}while((q|0)<(g|0));z5(-215,e,452815,452821,161)}i=((h|0)<0)<<31>>31;j=h;J=i;u=d;return j|0}function rAb(a,b){a=a|0;b=b|0;var c=0;c=VDc(112)|0;sAb(c,b);b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=105108;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function sAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0;d=u;u=u+48|0;e=d+32|0;g=d+24|0;h=d+16|0;i=d;j=d+8|0;JHa(a);k=a+40|0;l=a+72|0;f[l>>2]=0;m=a+76|0;f[m>>2]=0;f[a+84>>2]=0;f[a+88>>2]=0;o=a+96|0;f[o>>2]=0;p=a+100|0;f[p>>2]=0;q=k;f[q>>2]=0;f[q+4>>2]=0;f[a>>2]=105128;b[a+81>>0]=1;q=a+80|0;b[q>>0]=0;r=a+48|0;f[r>>2]=1;s=a+52|0;f[s>>2]=1;f[e>>2]=0;f[e+4>>2]=0;t=tT(e,4)|0;b[t>>0]=112;b[t+1>>0]=111;b[t+2>>0]=111;b[t+3>>0]=108;t=c+4|0;v=f[t>>2]|0;a:do if(v){w=f[e>>2]|0;x=(w|0)==0?1154740:w;y=v;while(1){z=f[y+16>>2]|0;if((w|0)==(z|0)){A=34;break}B=(z|0)==0?1154740:z;if((Ioc(x,B)|0)<0)C=y;else{if((Ioc(B,x)|0)>=0){A=35;break}C=y+4|0}y=f[C>>2]|0;if(!y){A=9;break a}}if((A|0)==34){uT(e);A=41;break}else if((A|0)==35){uT(e);A=41;break}}else A=9;while(0);b:do if((A|0)==9){f[g>>2]=0;f[g+4>>2]=0;D=tT(g,11)|0;E=454911;F=D+11|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));C=f[t>>2]|0;c:do if(C|0){v=f[g>>2]|0;y=(v|0)==0?1154740:v;x=C;while(1){w=f[x+16>>2]|0;if((v|0)==(w|0)){A=36;break}B=(w|0)==0?1154740:w;if((Ioc(y,B)|0)<0)G=x;else{if((Ioc(B,y)|0)>=0){A=37;break}G=x+4|0}x=f[G>>2]|0;if(!x)break c}if((A|0)==36){uT(g);uT(e);A=41;break b}else if((A|0)==37){uT(g);uT(e);A=41;break b}}while(0);f[h>>2]=0;f[h+4>>2]=0;C=tT(h,8)|0;x=C;b[x>>0]=107;b[x+1>>0]=101;b[x+2>>0]=114;b[x+3>>0]=110;x=C+4|0;b[x>>0]=101;b[x+1>>0]=108;b[x+2>>0]=95;b[x+3>>0]=119;x=f[t>>2]|0;d:do if(x|0){C=f[h>>2]|0;y=(C|0)==0?1154740:C;v=x;while(1){B=f[v+16>>2]|0;if((C|0)==(B|0)){A=38;break}w=(B|0)==0?1154740:B;if((Ioc(y,w)|0)<0)H=v;else{if((Ioc(w,y)|0)>=0){A=39;break}H=v+4|0}v=f[H>>2]|0;if(!v)break d}if((A|0)==38){uT(h);uT(g);uT(e);A=41;break b}else if((A|0)==39){uT(h);uT(g);uT(e);A=41;break b}}while(0);f[i>>2]=0;f[i+4>>2]=0;x=tT(i,8)|0;v=x;b[v>>0]=107;b[v+1>>0]=101;b[v+2>>0]=114;b[v+3>>0]=110;v=x+4|0;b[v>>0]=101;b[v+1>>0]=108;b[v+2>>0]=95;b[v+3>>0]=104;v=f[t>>2]|0;do if(v){x=f[i>>2]|0;y=(x|0)==0?1154740:x;C=v;while(1){w=f[C+16>>2]|0;if((x|0)==(w|0)){A=40;break}B=(w|0)==0?1154740:w;if((Ioc(y,B)|0)<0)I=C;else{if((Ioc(B,y)|0)>=0){A=33;break}I=C+4|0}C=f[I>>2]|0;if(!C){A=75;break}}if((A|0)==33){uT(i);uT(h);uT(g);uT(e);A=41;break b}else if((A|0)==40){uT(i);uT(h);uT(g);uT(e);A=41;break b}else if((A|0)==75){uT(i);uT(h);uT(g);uT(e);break}}else{uT(i);uT(h);uT(g);uT(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;v=tT(e,8)|0;C=v;b[C>>0]=112;b[C+1>>0]=111;b[C+2>>0]=111;b[C+3>>0]=108;C=v+4|0;b[C>>0]=101;b[C+1>>0]=100;b[C+2>>0]=95;b[C+3>>0]=119;C=f[t>>2]|0;e:do if(C){v=f[e>>2]|0;y=(v|0)==0?1154740:v;x=C;while(1){B=f[x+16>>2]|0;if((v|0)==(B|0)){A=93;break}w=(B|0)==0?1154740:B;if((Ioc(y,w)|0)<0)K=x;else{if((Ioc(w,y)|0)>=0){A=94;break}K=x+4|0}x=f[K>>2]|0;if(!x){A=84;break e}}if((A|0)==93){uT(e);break}else if((A|0)==94){uT(e);break}}else A=84;while(0);f:do if((A|0)==84){f[g>>2]=0;f[g+4>>2]=0;C=tT(g,8)|0;x=C;b[x>>0]=112;b[x+1>>0]=111;b[x+2>>0]=111;b[x+3>>0]=108;x=C+4|0;b[x>>0]=101;b[x+1>>0]=100;b[x+2>>0]=95;b[x+3>>0]=104;x=f[t>>2]|0;do if(x){C=f[g>>2]|0;y=(C|0)==0?1154740:C;v=x;while(1){w=f[v+16>>2]|0;if((C|0)==(w|0)){A=95;break}B=(w|0)==0?1154740:w;if((Ioc(y,B)|0)<0)L=v;else{if((Ioc(B,y)|0)>=0){A=92;break}L=v+4|0}v=f[L>>2]|0;if(!v){A=120;break}}if((A|0)==92){uT(g);uT(e);break f}else if((A|0)==95){uT(g);uT(e);break f}else if((A|0)==120){uT(g);uT(e);break}}else{uT(g);uT(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;D=tT(e,10)|0;E=452647;F=D+10|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));x=f[t>>2]|0;if(!x){uT(e);f[e>>2]=0;M=e+4|0;f[M>>2]=0;N=tT(e,29)|0;D=N;E=452669;F=D+29|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-5,e,452552,452569,109)}v=f[e>>2]|0;y=(v|0)==0?1154740:v;C=x;while(1){B=f[C+16>>2]|0;if((v|0)==(B|0))break;w=(B|0)==0?1154740:B;if((Ioc(y,w)|0)<0)O=C;else{if((Ioc(w,y)|0)>=0)break;O=C+4|0}C=f[O>>2]|0;if(!C){A=141;break}}if((A|0)==141){uT(e);f[e>>2]=0;M=e+4|0;f[M>>2]=0;N=tT(e,29)|0;D=N;E=452669;F=D+29|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-5,e,452552,452569,109)}f[g>>2]=0;f[g+4>>2]=0;D=tT(g,10)|0;E=452658;F=D+10|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));C=f[t>>2]|0;if(!C){uT(g);uT(e);f[e>>2]=0;M=e+4|0;f[M>>2]=0;N=tT(e,29)|0;D=N;E=452669;F=D+29|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-5,e,452552,452569,109)}y=f[g>>2]|0;v=(y|0)==0?1154740:y;x=C;while(1){w=f[x+16>>2]|0;if((y|0)==(w|0)){A=138;break}B=(w|0)==0?1154740:w;if((Ioc(v,B)|0)<0)P=x;else{if((Ioc(B,v)|0)>=0){A=137;break}P=x+4|0}x=f[P>>2]|0;if(!x){A=143;break}}if((A|0)==137){uT(g);uT(e)}else if((A|0)==138){uT(g);uT(e)}else if((A|0)==143){uT(g);uT(e);f[e>>2]=0;M=e+4|0;f[M>>2]=0;N=tT(e,29)|0;D=N;E=452669;F=D+29|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-5,e,452552,452569,109)}f[a+36>>2]=4;f[e>>2]=0;f[e+4>>2]=0;D=tT(e,10)|0;E=452658;F=D+10|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));x=DHa(lIa(c,e)|0,-1)|0;f[o>>2]=x;uT(e);f[p>>2]=f[o>>2];f[e>>2]=0;f[e+4>>2]=0;D=tT(e,10)|0;E=452647;F=D+10|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));x=DHa(lIa(c,e)|0,-1)|0;f[a+108>>2]=x;uT(e);break b}while(0);f[a+36>>2]=3;f[e>>2]=0;f[e+4>>2]=0;x=tT(e,8)|0;v=x;b[v>>0]=112;b[v+1>>0]=111;b[v+2>>0]=111;b[v+3>>0]=108;v=x+4|0;b[v>>0]=101;b[v+1>>0]=100;b[v+2>>0]=95;b[v+3>>0]=119;v=f[t>>2]|0;do if(v){x=f[e>>2]|0;y=(x|0)==0?1154740:x;C=t;B=v;g:while(1){w=B;while(1){z=f[w+16>>2]|0;if((z|0)==(x|0))break;if((Ioc((z|0)==0?1154740:z,y)|0)>=0)break;z=f[w+4>>2]|0;if(!z){Q=C;break g}else w=z}B=f[w>>2]|0;if(!B){Q=w;break}else C=w}if((Q|0)!=(t|0)){C=f[Q+16>>2]|0;if((x|0)!=(C|0)?(Ioc(y,(C|0)==0?1154740:C)|0)<=-1:0){R=1;break}C=DHa(Q+24|0,-1)|0;R=C}else R=1}else R=1;while(0);f[o>>2]=R;uT(e);f[e>>2]=0;f[e+4>>2]=0;v=tT(e,8)|0;C=v;b[C>>0]=112;b[C+1>>0]=111;b[C+2>>0]=111;b[C+3>>0]=108;C=v+4|0;b[C>>0]=101;b[C+1>>0]=100;b[C+2>>0]=95;b[C+3>>0]=104;C=f[t>>2]|0;do if(C){v=f[e>>2]|0;B=(v|0)==0?1154740:v;z=t;S=C;h:while(1){T=S;while(1){U=f[T+16>>2]|0;if((U|0)==(v|0))break;if((Ioc((U|0)==0?1154740:U,B)|0)>=0)break;U=f[T+4>>2]|0;if(!U){V=z;break h}else T=U}S=f[T>>2]|0;if(!S){V=T;break}else z=T}if((V|0)!=(t|0)){z=f[V+16>>2]|0;if((v|0)!=(z|0)?(Ioc(B,(z|0)==0?1154740:z)|0)<=-1:0){W=1;break}z=DHa(V+24|0,-1)|0;W=z}else W=1}else W=1;while(0);f[p>>2]=W;uT(e)}while(0);if((A|0)==41){f[h>>2]=0;f[h+4>>2]=0;W=tT(h,4)|0;b[W>>0]=112;b[W+1>>0]=111;b[W+2>>0]=111;b[W+3>>0]=108;f[i>>2]=0;W=i+4|0;f[W>>2]=0;p=tT(i,3)|0;b[p>>0]=b[454907]|0;b[p+1>>0]=b[454908]|0;b[p+2>>0]=b[454909]|0;p=f[t>>2]|0;do if(p){V=f[h>>2]|0;R=(V|0)==0?1154740:V;o=t;Q=p;i:while(1){N=Q;while(1){M=f[N+16>>2]|0;if((M|0)==(V|0))break;if((Ioc((M|0)==0?1154740:M,R)|0)>=0)break;M=f[N+4>>2]|0;if(!M){X=o;break i}else N=M}Q=f[N>>2]|0;if(!Q){X=N;break}else o=N}if((X|0)!=(t|0)){o=f[X+16>>2]|0;if((V|0)!=(o|0)?(Ioc(R,(o|0)==0?1154740:o)|0)<=-1:0){A=52;break}EHa(j,X+24|0,-1)}else A=52}else A=52;while(0);if((A|0)==52?(A=f[i>>2]|0,f[j>>2]=A,f[j+4>>2]=f[W>>2],A|0):0){W=A+-4|0;f[W>>2]=(f[W>>2]|0)+1}W=f[j>>2]|0;if(!W){f[g>>2]=0;f[g+4>>2]=0}else{A=j+4|0;X=f[A>>2]|0;f[e>>2]=0;p=e+4|0;f[p>>2]=0;if(X|0?(dJc(tT(e,X)|0,W|0,X|0)|0,f[A>>2]|0):0){X=0;do{W=(Jqc(b[(f[j>>2]|0)+X>>0]|0)|0)&255;b[(f[e>>2]|0)+X>>0]=W;X=X+1|0}while(X>>>0<(f[A>>2]|0)>>>0)}A=f[e>>2]|0;f[g>>2]=A;f[g+4>>2]=f[p>>2];if(A|0){p=A+-4|0;f[p>>2]=(f[p>>2]|0)+1}uT(e)}uT(j);uT(i);uT(h);i=f[g>>2]|0;if((i|0)!=454907?(j=(i|0)==0?1154740:i,(Ioc(j,454907)|0)!=0):0)if((i|0)!=454856?(Ioc(j,454856)|0)!=0:0)if((i|0)!=452518?(Ioc(j,452518)|0)!=0:0){f[h>>2]=0;j=h+4|0;f[j>>2]=0;i=g+4|0;tT(h,(f[i>>2]|0)+22|0)|0;p=f[h>>2]|0;D=p;E=452529;F=D+22|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));A=f[i>>2]|0;if(A|0)dJc(p+22|0,f[g>>2]|0,A|0)|0;f[e>>2]=0;f[e+4>>2]=0;tT(e,(f[j>>2]|0)+1|0)|0;A=f[j>>2]|0;if(!A){Y=0;Z=f[e>>2]|0;_=Z+Y|0;b[_>>0]=34;z5(-5,e,452552,452569,87)}dJc(f[e>>2]|0,f[h>>2]|0,A|0)|0;Y=f[j>>2]|0;Z=f[e>>2]|0;_=Z+Y|0;b[_>>0]=34;z5(-5,e,452552,452569,87)}else $=2;else $=1;else $=0;f[a+36>>2]=$;$=a+60|0;_=a+56|0;Fzb(c,a+44|0,k,q,$,_,a+68|0,a+64|0,s,r,a+84|0);f[l>>2]=f[_>>2];f[m>>2]=f[$>>2];uT(g)}KHa(a,c);f[e>>2]=0;f[e+4>>2]=0;D=tT(e,9)|0;E=452699;F=D+9|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));c=f[t>>2]|0;do if(c){g=f[e>>2]|0;$=(g|0)==0?1154740:g;m=t;_=c;j:while(1){l=_;while(1){r=f[l+16>>2]|0;if((r|0)==(g|0))break;if((Ioc((r|0)==0?1154740:r,$)|0)>=0)break;r=f[l+4>>2]|0;if(!r){aa=m;break j}else l=r}_=f[l>>2]|0;if(!_){aa=l;break}else m=l}if((aa|0)!=(t|0)){m=f[aa+16>>2]|0;if((g|0)!=(m|0)?(Ioc($,(m|0)==0?1154740:m)|0)<=-1:0){ba=1;break}m=DHa(aa+24|0,-1)|0;ba=(m|0)!=0|(J|0)!=0}else ba=1}else ba=1;while(0);b[a+92>>0]=ba&1;uT(e);f[e>>2]=0;f[e+4>>2]=0;D=tT(e,13)|0;E=452709;F=D+13|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));ba=f[t>>2]|0;do if(ba){aa=f[e>>2]|0;c=(aa|0)==0?1154740:aa;m=t;_=ba;k:while(1){R=_;while(1){V=f[R+16>>2]|0;if((V|0)==(aa|0))break;if((Ioc((V|0)==0?1154740:V,c)|0)>=0)break;V=f[R+4>>2]|0;if(!V){ca=m;break k}else R=V}_=f[R>>2]|0;if(!_){ca=R;break}else m=R}if((ca|0)!=(t|0)){m=f[ca+16>>2]|0;if((aa|0)!=(m|0)?(Ioc(c,(m|0)==0?1154740:m)|0)<=-1:0){da=1.0;break}da=+tIa(ca+24|0,-1)}else da=1.0}else da=1.0;while(0);n[a+104>>2]=da;uT(e);f[e>>2]=0;f[e+4>>2]=0;D=tT(e,20)|0;E=452723;F=D+20|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));E=f[t>>2]|0;if(!E){ea=1;fa=a+93|0;b[fa>>0]=ea;uT(e);u=d;return}D=f[e>>2]|0;F=(D|0)==0?1154740:D;ca=t;ba=E;l:while(1){E=ba;while(1){m=f[E+16>>2]|0;if((m|0)==(D|0))break;if((Ioc((m|0)==0?1154740:m,F)|0)>=0)break;m=f[E+4>>2]|0;if(!m){ga=ca;break l}else E=m}ba=f[E>>2]|0;if(!ba){ga=E;break}else ca=E}if((ga|0)==(t|0)){ea=1;fa=a+93|0;b[fa>>0]=ea;uT(e);u=d;return}t=f[ga+16>>2]|0;if((D|0)!=(t|0)?(Ioc(F,(t|0)==0?1154740:t)|0)<=-1:0){ea=1;fa=a+93|0;b[fa>>0]=ea;uT(e);u=d;return}t=DHa(ga+24|0,-1)|0;ea=((t|0)!=0|(J|0)!=0)&1;fa=a+93|0;b[fa>>0]=ea;uT(e);u=d;return}function tAb(a){a=a|0;YDc(a);return}function uAb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function vAb(a){a=a|0;f[a>>2]=105244;uT(a+84|0);REa(a);return}function wAb(a){a=a|0;f[a>>2]=105244;uT(a+84|0);REa(a);YDc(a);return}function xAb(a){a=a|0;f[a>>2]=105244;uT(a+84|0);REa(a);YDc(a);return}function yAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f$(c,g);f$(d,h);d=f[g>>2]|0;if((d|0)==(f[l>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,15)|0;c=453702;m=l+15|0;do{b[l>>0]=b[c>>0]|0;l=l+1|0;c=c+1|0}while((l|0)<(m|0));z5(-215,i,453718,452569,126)}c=f[d+40>>2]|0;d=f[c+12>>2]|0;l=f[c+8>>2]|0;f[i>>2]=d;f[i+4>>2]=l;c=f[(f[h>>2]|0)+40>>2]|0;m=f[c+8>>2]|0;f[j>>2]=f[c+12>>2];f[j+4>>2]=m;if(b[a+80>>0]|0){f[a+40>>2]=d;f[a+44>>2]=l}f[k>>2]=1;f[k+4>>2]=1;l=a+60|0;d=a+56|0;Izb(i,j,a+40|0,a+48|0,a+84|0,k,l,d,a+68|0,a+64|0);f[a+72>>2]=f[d>>2];f[a+76>>2]=f[l>>2];b[a+81>>0]=(f[a+36>>2]|0)==0&1;mx(h);mx(g);u=e;return}function zAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+80|0;h=g+68|0;i=g+56|0;j=g;if((p$(c,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;f$(c,h);f$(d,i);a:do switch(f[a+36>>2]|0){case 0:{if(((f[e>>2]|0)-(f[h>>2]|0)|0)!=56){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,18)|0;m=453187;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,453206,452569,228)}do if(b[a+81>>0]|0){if(((f[k>>2]|0)-(f[i>>2]|0)|0)!=112){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,37)|0;m=453214;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,453206,452569,228)}d=f[i>>2]|0;c=d+56|0;f[j>>2]=f[c>>2];o=j+4|0;p=d+60|0;q=f[p>>2]|0;f[o>>2]=q;r=j+8|0;f[r>>2]=f[d+64>>2];f[j+12>>2]=f[d+68>>2];f[j+16>>2]=f[d+72>>2];f[j+20>>2]=f[d+76>>2];f[j+24>>2]=f[d+80>>2];f[j+28>>2]=f[d+84>>2];f[j+32>>2]=f[d+88>>2];s=f[d+92>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;t=j+44|0;f[t>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(!s)v=q;else{q=s+12|0;f[q>>2]=(f[q>>2]|0)+1;v=f[p>>2]|0}if((v|0)<3){p=f[d+100>>2]|0;d=f[t>>2]|0;f[d>>2]=f[p>>2];f[d+4>>2]=f[p+4>>2];w=j;break}else{f[o>>2]=0;ZS(j,c);w=j;break}}else{f[j>>2]=1124007936;c=j+8|0;o=j+40|0;l=j+4|0;n=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));f[o>>2]=c;p=j+48|0;f[j+44>>2]=p;f[p>>2]=0;f[j+52>>2]=0;w=j}while(0);IAb(a,f[h>>2]|0,f[i>>2]|0,j);p=j+36|0;d=f[p>>2]|0;if(d|0?(t=d+12|0,d=f[t>>2]|0,f[t>>2]=d+-1,(d|0)==1):0)_S(j);f[p>>2]=0;p=j+16|0;d=j+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[d>>2]|0)>0){p=f[j+40>>2]|0;t=0;do{f[p+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[d>>2]|0))}d=f[j+44>>2]|0;if((d|0)!=(j+48|0))g0(d);break}case 1:{d=f[h>>2]|0;t=d;if(((f[e>>2]|0)-d|0)!=56){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,18)|0;m=453187;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,453206,452569,234)}d=f[i>>2]|0;if(((f[k>>2]|0)-d|0)==56){JAb(a,t,d);break a}else{f[j>>2]=0;f[j+4>>2]=0;l=tT(j,19)|0;m=453252;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,453206,452569,234)}break}case 4:case 3:{t=f[h>>2]|0;d=t;if(((f[e>>2]|0)-t|0)!=112){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,18)|0;m=453044;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,453206,452569,238)}t=f[i>>2]|0;if(((f[k>>2]|0)-t|0)==56){KAb(a,d,d+56|0,t);break a}else{f[j>>2]=0;f[j+4>>2]=0;l=tT(j,19)|0;m=453252;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,453206,452569,238)}break}default:{f[j>>2]=0;f[j+4>>2]=0;l=tT(j,15)|0;m=453272;n=l+15|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,j,453206,452569,242)}}while(0);mx(i);mx(h);u=g;return}function AAb(a,b){a=a|0;b=b|0;var c=0,d=0;a:do switch(b|0){case 2:{c=f[a+36>>2]|0;if((f[a+32>>2]|0)==3){d=(c|1|0)==1;break a}else{d=(c|0)!=2;break a}break}case 3:{d=1;break}case 1:{if(sMa()|0){switch(f[a+36>>2]|0){case 0:{d=1;break a;break}case 1:break;default:{d=0;break a}}if(((f[a+60>>2]|0)==0?(f[a+56>>2]|0)==0:0)?(f[a+68>>2]|0)==0:0)d=(f[a+64>>2]|0)==0;else d=0}else d=0;break}default:d=0}while(0);return d|0}function BAb(a,b,c){a=a|0;b=b|0;c=c|0;switch(f[b+36>>2]|0){case 0:{Ti[f[(f[b>>2]|0)+100>>2]&511](a,b,c);return}case 1:{Ti[f[(f[b>>2]|0)+104>>2]&511](a,b,c);return}default:{f[a>>2]=0;f[a+4>>2]=0;return}}}function CAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function DAb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function EAb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;g=u;u=u+48|0;h=g+40|0;i=g+32|0;j=g+16|0;k=g;l=c+4|0;m=f[c>>2]|0;n=m;if((f[l>>2]|0)==(m|0)){f[h>>2]=0;f[h+4>>2]=0;o=tT(h,18)|0;p=452906;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,h,452925,452569,867)}r=f[n>>2]|0;s=f[r+12>>2]|0;t=f[r+8>>2]|0;f[h>>2]=s;f[h+4>>2]=t;f[i>>2]=0;v=i+4|0;f[v>>2]=0;do if(!(b[a+80>>0]|0)){w=a+36|0;if(((f[w>>2]|0)+-3|0)>>>0<2){x=f[a+100>>2]|0;f[v>>2]=x;y=f[a+96>>2]|0;f[i>>2]=y;z=w;A=r;B=x;C=y;D=m;E=n;break}if(f[a+88>>2]|0){f[j>>2]=1;f[j+4>>2]=1;Hzb(h,a+40|0,a+48|0,a+84|0,j,i);y=f[c>>2]|0;z=w;A=f[y>>2]|0;B=f[v>>2]|0;C=f[i>>2]|0;D=y;E=y;break}y=f[a+68>>2]|0;x=f[a+52>>2]|0;F=+((f[a+60>>2]|0)+t+y-(f[a+44>>2]|0)|0)/+(x|0);G=f[a+64>>2]|0;H=f[a+48>>2]|0;I=+((f[a+56>>2]|0)+s+G-(f[a+40>>2]|0)|0)/+(H|0);if(!(b[a+92>>0]|0)){J=~~(+K(+F)+1.0);f[v>>2]=J;L=+K(+I);M=J}else{J=~~(+X(+F)+1.0);f[v>>2]=J;L=+X(+I);M=J}J=~~(L+1.0);f[i>>2]=J;if(y|G){N=M+-1|0;O=t+y|0;if((Y(N,x)|0)<(O|0))P=M;else{f[v>>2]=N;P=N}N=J+-1|0;y=s+G|0;if((Y(N,H)|0)<(y|0))Q=J;else{f[i>>2]=N;Q=N}if((Y(P+-1|0,x)|0)>=(O|0)){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,52)|0;p=452941;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,452925,452569,895)}if((Y(Q+-1|0,H)|0)<(y|0)){z=w;A=r;B=P;C=Q;D=m;E=n}else{f[j>>2]=0;f[j+4>>2]=0;o=tT(j,49)|0;p=452994;q=o+49|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,452925,452569,896)}}else{z=w;A=r;B=M;C=J;D=m;E=n}}else{f[v>>2]=1;f[i>>2]=1;z=a+36|0;A=r;B=1;C=1;D=m;E=n}while(0);f[j>>2]=f[A>>2];n=A+4|0;f[j+4>>2]=f[n>>2];f[j+8>>2]=B;f[j+12>>2]=C;C=f[z>>2]|0;a:do switch(C|0){case 3:{if(((f[l>>2]|0)-D|0)==24){R=0;S=f[f[E+12>>2]>>2]|0;T=30;break a}else{f[k>>2]=0;f[k+4>>2]=0;o=tT(k,18)|0;p=453044;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,452925,452569,907)}break}case 4:{if(((f[l>>2]|0)-D|0)!=24){f[k>>2]=0;f[k+4>>2]=0;o=tT(k,18)|0;p=453044;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,452925,452569,912)}J=f[a+108>>2]|0;if((Y(Y(f[a+96>>2]|0,J)|0,f[a+100>>2]|0)|0)==(f[n>>2]|0)){f[j>>2]=f[f[E+12>>2]>>2];R=1;S=J;T=30;break a}else{f[k>>2]=0;f[k+4>>2]=0;o=tT(k,71)|0;p=453063;q=o+71|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,452925,452569,913)}break}default:{}}while(0);if((T|0)==30)f[j+(R<<2)>>2]=S;S=(d|0)==0?((C|0)==0?2:1):d;switch(S|0){case 1:break;case 2:{T=32;break}default:{f[k>>2]=0;U=k+4|0;f[U>>2]=0;V=tT(k,51)|0;o=V;p=453135;q=o+51|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,452925,452569,919)}}if((T|0)==32?C|0:0){f[k>>2]=0;U=k+4|0;f[U>>2]=0;V=tT(k,51)|0;o=V;p=453135;q=o+51|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,452925,452569,919)}f[k>>2]=0;p=k+4|0;f[p>>2]=0;f[k+8>>2]=0;lFa(k,j,j+16|0);iFa(e,S,k);S=f[k>>2]|0;if(!S){u=g;return 0}k=f[p>>2]|0;if((k|0)!=(S|0))f[p>>2]=k+(~((k+-4-S|0)>>>2)<<2);YDc(S);u=g;return 0}function FAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=u;u=u+16|0;e=c;g=f[d+4>>2]|0;h=f[d>>2]|0;d=h;if((g|0)==(h|0)){i=0;j=(i|0)<0;k=j<<31>>31;J=k;u=c;return i|0}l=a+40|0;m=a+44|0;n=(g-h|0)/12|0;if(f[a+36>>2]|0){a=0;h=0;while(1){g=f[d+(h*12|0)+4>>2]|0;o=f[d+(h*12|0)>>2]|0;p=g-o|0;q=p>>2;r=o;if((r|0)!=(g|0)){if((p|0)<=-4){s=15;break}if((p|0)>0){p=0;g=1;while(1){o=Y(f[r+(p<<2)>>2]|0,g)|0;p=p+1|0;if((p|0)>=(q|0)){t=o;break}else g=o}}else t=1}else t=0;g=(Y((Y(f[m>>2]|0,f[l>>2]|0)|0)+1|0,t)|0)+a|0;h=h+1|0;if(h>>>0>=n>>>0){i=g;s=10;break}else a=g}if((s|0)==10){j=(i|0)<0;k=j<<31>>31;J=k;u=c;return i|0}else if((s|0)==15){f[e>>2]=0;f[e+4>>2]=0;v=tT(e,70)|0;w=452744;x=v+70|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,e,452815,452821,161)}}else{y=0;z=0}while(1){if(!(z&1)){a=f[d+(z*12|0)+4>>2]|0;h=f[d+(z*12|0)>>2]|0;t=a-h|0;g=t>>2;q=h;if((q|0)!=(a|0)){if((t|0)<=-4){s=12;break}if((t|0)>0){t=0;a=1;while(1){h=Y(f[q+(t<<2)>>2]|0,a)|0;t=t+1|0;if((t|0)>=(g|0)){A=h;break}else a=h}}else A=1}else A=0;B=(Y(Y(f[l>>2]|0,A)|0,f[m>>2]|0)|0)+y|0}else B=y;z=z+1|0;if(z>>>0>=n>>>0){i=B;s=10;break}else y=B}if((s|0)==10){j=(i|0)<0;k=j<<31>>31;J=k;u=c;return i|0}else if((s|0)==12){f[e>>2]=0;f[e+4>>2]=0;v=tT(e,70)|0;w=452744;x=v+70|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,e,452815,452821,161)}return 0}function GAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function HAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function IAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;g=u;u=u+80|0;h=g+16|0;i=g+8|0;j=g;k=z8()|0;f[h>>2]=1124007936;l=h+4|0;m=h+8|0;o=h+40|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;m=h+48|0;p=h+44|0;f[p>>2]=m;f[m>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+40>>2];f[i+4>>2]=f[a+44>>2];f[j>>2]=f[a+48>>2];f[j+4>>2]=f[a+52>>2];LAb(c,h,d,e,i,j,f[a+56>>2]|0,f[a+60>>2]|0,f[a+64>>2]|0,f[a+68>>2]|0,(b[a+93>>0]|0)!=0,f[a+36>>2]|0,+n[a+104>>2],(b[a+81>>0]|0)!=0,k);k=h+36|0;a=f[k>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)_S(h);f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[o>>2]|0;o=0;do{f[k+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[p>>2]|0;if((l|0)==(m|0)){u=g;return}g0(l);u=g;return}function JAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e+8|0;j=e;k=z8()|0;f[g>>2]=1124007936;l=g+4|0;m=g+8|0;o=g+40|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;m=g+48|0;r=g+44|0;f[r>>2]=m;f[m>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;s=h+4|0;t=h+8|0;v=h+40|0;p=s;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[v>>2]=t;t=h+48|0;p=h+44|0;f[p>>2]=t;f[t>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+40>>2];f[i+4>>2]=f[a+44>>2];f[j>>2]=f[a+48>>2];f[j+4>>2]=f[a+52>>2];LAb(c,g,d,h,i,j,f[a+56>>2]|0,f[a+60>>2]|0,f[a+64>>2]|0,f[a+68>>2]|0,(b[a+93>>0]|0)!=0,f[a+36>>2]|0,+n[a+104>>2],(b[a+81>>0]|0)!=0,k);k=h+36|0;a=f[k>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)_S(h);f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[s>>2]|0)>0){k=f[v>>2]|0;v=0;do{f[k+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[p>>2]|0;if((s|0)!=(t|0))g0(s);s=g+36|0;t=f[s>>2]|0;if(t|0?(p=t+12|0,t=f[p>>2]|0,f[p>>2]=t+-1,(t|0)==1):0)_S(g);f[s>>2]=0;s=g+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[l>>2]|0)>0){s=f[o>>2]|0;o=0;do{f[s+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)==(m|0)){u=e;return}g0(l);u=e;return}function KAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;g=u;u=u+80|0;h=g+16|0;i=g+8|0;j=g;k=z8()|0;f[h>>2]=1124007936;l=h+4|0;m=h+8|0;o=h+40|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;m=h+48|0;p=h+44|0;f[p>>2]=m;f[m>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+40>>2];f[i+4>>2]=f[a+44>>2];f[j>>2]=f[a+48>>2];f[j+4>>2]=f[a+52>>2];LAb(c,d,e,h,i,j,f[a+56>>2]|0,f[a+60>>2]|0,f[a+64>>2]|0,f[a+68>>2]|0,(b[a+93>>0]|0)!=0,f[a+36>>2]|0,+n[a+104>>2],(b[a+81>>0]|0)!=0,k);k=h+36|0;a=f[k>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)_S(h);f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[o>>2]|0;o=0;do{f[k+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[p>>2]|0;if((l|0)==(m|0)){u=g;return}g0(l);u=g;return}function LAb(a,c,d,e,g,h,i,j,k,l,m,o,p,q,r){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;p=+p;q=q|0;r=r|0;var s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;s=u;u=u+96|0;t=s+8|0;v=s;w=m&1;m=q&1;x=f[a>>2]|0;if(!(x&16384)){f[t>>2]=0;f[t+4>>2]=0;y=tT(t,18)|0;z=453288;A=y+18|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}B=f[d>>2]|0;if(!(B&16384)){f[t>>2]=0;f[t+4>>2]=0;y=tT(t,18)|0;z=453311;A=y+18|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}if((x&4095|0)!=5){f[t>>2]=0;f[t+4>>2]=0;y=tT(t,15)|0;z=453330;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}if((B&4095|0)!=5){f[t>>2]=0;f[t+4>>2]=0;y=tT(t,24)|0;z=453346;A=y+24|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}if((f[a+4>>2]|0)!=4){f[t>>2]=0;f[t+4>>2]=0;y=tT(t,13)|0;z=453371;A=y+13|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}if((f[d+4>>2]|0)!=4){f[t>>2]=0;f[t+4>>2]=0;y=tT(t,13)|0;z=453385;A=y+13|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}B=(o|0)==4;C=f[d+40>>2]|0;D=f[C>>2]|0;if(!((o+-3|0)>>>0<2?(D|0)==(f[f[c+40>>2]>>2]|0):0))E=15;if((E|0)==15?(f[f[a+40>>2]>>2]|0)!=(D|0):0){f[t>>2]=0;f[t+4>>2]=0;y=tT(t,109)|0;z=453399;A=y+109|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}if(!B?(f[(f[a+40>>2]|0)+4>>2]|0)!=(f[C+4>>2]|0):0){f[t>>2]=0;f[t+4>>2]=0;y=tT(t,50)|0;z=453509;A=y+50|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}a:do if(f[e+16>>2]|0){B=f[e+4>>2]|0;if((B|0)<3)F=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{E=f[e+40>>2]|0;G=0;H=1;while(1){I=Y(f[E+(G<<2)>>2]|0,H)|0;G=G+1|0;if((G|0)==(B|0)){F=I;break}else H=I}}if(!((B|0)==0|(F|0)==0)){do if(((x^f[e>>2])&4095|0)==0?(H=f[e+40>>2]|0,G=f[H+-4>>2]|0,(G|0)==(f[C+-4>>2]|0)):0){if((G|0)==2){if((f[H>>2]|0)!=(D|0))break;if((f[H+4>>2]|0)==(f[C+4>>2]|0))break a;else break}if((G|0)<=0)break a;if((f[H>>2]|0)==(D|0)){E=1;while(1){if((E|0)>=(G|0))break a;if((f[H+(E<<2)>>2]|0)==(f[C+(E<<2)>>2]|0))E=E+1|0;else break}}}while(0);f[t>>2]=0;f[t+4>>2]=0;y=tT(t,70)|0;z=453560;A=y+70|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,t,453307,452569,350)}}while(0);f[t>>2]=105352;z=t+64|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[t+4>>2]=a;f[t+8>>2]=c;f[t+12>>2]=d;f[t+16>>2]=e;e=f[g>>2]|0;f[t+20>>2]=e;d=g+4|0;c=f[d>>2]|0;f[t+24>>2]=c;f[t+28>>2]=f[h>>2];f[t+32>>2]=f[h+4>>2];f[t+36>>2]=i;f[t+40>>2]=j;f[t+44>>2]=k;f[t+48>>2]=l;b[t+52>>0]=w;f[t+56>>2]=r;b[t+60>>0]=m;f[t+76>>2]=o;n[t+80>>2]=p;if(!q){q=t+64|0;o=Y(c,e)|0;if(!o)J=c;else{lN(q,o);J=f[d>>2]|0}if((J|0)>0){o=(f[a+40>>2]|0)+12|0;a=f[q>>2]|0;q=0;c=f[g>>2]|0;e=J;while(1){if((c|0)>0){J=0;m=c;do{w=(Y(f[o>>2]|0,q)|0)+J|0;l=a+((Y(m,q)|0)+J<<2)|0;f[l>>2]=w;J=J+1|0;m=f[g>>2]|0}while((J|0)<(m|0));K=f[d>>2]|0;L=m}else{K=e;L=c}q=q+1|0;if((q|0)>=(K|0))break;else{c=L;e=K}}}}f[v>>2]=0;f[v+4>>2]=r;y8(v,t,+(r|0));f[t>>2]=105352;r=f[z>>2]|0;if(!r){u=s;return}z=t+68|0;t=f[z>>2]|0;if((t|0)!=(r|0))f[z>>2]=t+(~((t+-4-r|0)>>>2)<<2);YDc(r);u=s;return}function MAb(a){a=a|0;var b=0,c=0;f[a>>2]=105352;b=f[a+64>>2]|0;if(!b)return;c=a+68|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function NAb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=105352;b=f[a+64>>2]|0;if(!b){YDc(a);return}c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function OAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0,J=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0.0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;d=u;u=u+16|0;e=d;g=a+12|0;h=f[g>>2]|0;i=f[h+40>>2]|0;j=f[i+4>>2]|0;k=f[i+12>>2]|0;l=f[i+8>>2]|0;m=a+4|0;o=f[(f[m>>2]|0)+40>>2]|0;p=f[o+12>>2]|0;q=f[o+8>>2]|0;o=f[h+4>>2]|0;if((o|0)<3)r=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{h=0;t=1;while(1){v=Y(f[i+(h<<2)>>2]|0,t)|0;h=h+1|0;if((h|0)==(o|0)){r=v;break}else t=v}}t=f[a+56>>2]|0;o=((r+-1+t|0)>>>0)/(t>>>0)|0;t=Y(f[c>>2]|0,o)|0;h=Y(f[c+4>>2]|0,o)|0;o=r>>>0<h>>>0?r:h;h=f[a+20>>2]|0;r=f[a+24>>2]|0;c=f[a+28>>2]|0;i=f[a+32>>2]|0;v=(b[a+60>>0]|0)!=0;if(o>>>0<=t>>>0){u=d;return}w=a+76|0;x=f[w>>2]|0;y=a+40|0;z=a+48|0;A=a+16|0;B=a+8|0;C=a+80|0;D=+(k|0);E=a+36|0;F=a+44|0;G=a+52|0;H=+(l|0);a=t;a:while(1){t=(a>>>0)%(k>>>0)|0;I=(a>>>0)/(k>>>0)|0;J=(I>>>0)%(l>>>0)|0;L=(I>>>0)/(l>>>0)|0;I=(L>>>0)%(j>>>0)|0;M=(L>>>0)/(j>>>0)|0;switch(x|0){case 3:{L=f[B>>2]|0;N=(f[L+16>>2]|0)+(Y(f[f[L+44>>2]>>2]|0,M)|0)|0;O=+n[C>>2];P=+n[N+8>>2]*O;L=~~(P+(P>=0.0?.5:-.5));P=O*+n[N+16>>2];Q=~~(P+(P>=0.0?.5:-.5))-L+1|0;P=+(((Q|0)>1?Q:1)|0)/H;O=+(L|0);R=+n[N>>2];N=f[m>>2]|0;if(!(R<+(f[f[N+40>>2]>>2]|0))){S=10;break a}L=~~(O+ +X(+(+(J+1|0)*P)));Q=f[N+44>>2]|0;T=(f[N+16>>2]|0)+(Y(f[Q>>2]|0,~~R)|0)+(Y(f[Q+4>>2]|0,I)|0)|0;U=~~(O+ +(J|0)*P);V=L;break}case 4:{L=f[B>>2]|0;Q=(f[L+16>>2]|0)+(Y(f[f[L+44>>2]>>2]|0,M)|0)|0;P=+n[Q+8>>2];O=+n[C>>2];R=O*+(~~(P+(P>=0.0?.5:-.5))|0);P=+n[Q+16>>2]+1.0;W=O*+(~~(P+(P>=0.0?.5:-.5))|0)-R;P=(W<.10000000149011612?.10000000149011612:W)/H;T=0;U=~~+K(+(R+ +(J|0)*P));V=~~+X(+(R+ +(J+1|0)*P));break}default:{Q=(Y(J,i)|0)-(f[y>>2]|0)|0;L=Q+r|0;N=(f[z>>2]|0)+q|0;Z=f[m>>2]|0;_=f[Z+44>>2]|0;T=(f[Z+16>>2]|0)+(Y(f[_>>2]|0,M)|0)+(Y(f[_+4>>2]|0,I)|0)|0;U=Q;V=(N|0)<(L|0)?N:L}}L=V-U|0;N=(U|0)>0?U:0;Q=(q|0)<(V|0)?q:V;_=f[g>>2]|0;Z=f[_+16>>2]|0;$=f[_+44>>2]|0;_=Y(f[$>>2]|0,M)|0;aa=Y(f[$+4>>2]|0,I)|0;ba=Y(f[$+8>>2]|0,J)|0;$=Z+_+aa+ba|0;ca=f[A>>2]|0;da=f[ca+16>>2]|0;if(!da)ea=0;else{fa=f[ca+44>>2]|0;ca=da+(Y(f[fa>>2]|0,M)|0)|0;da=ca+(Y(f[fa+4>>2]|0,I)|0)|0;ea=da+(Y(f[fa+8>>2]|0,J)|0)|0}fa=o-a|0;da=k-t|0;ca=(da|0)<(fa|0)?da:fa;a=ca+a|0;fa=ca+t|0;da=f[w>>2]|0;b:do switch(da|0){case 0:{if((ca|0)>0){ga=f[E>>2]|0;ha=(Q|0)>(N|0);ia=(ea|0)==0;ja=v&(ea|0)!=0;ka=t;do{la=(Y(ka,c)|0)-ga|0;ma=la+h|0;na=(p|0)<(ma|0)?p:ma;ma=(la|0)>0?la:0;do if(ha&(ma|0)<(na|0)){if(v){oa=-1;pa=N;qa=-3402823466385288598117041.0e14}else{la=N;P=-3402823466385288598117041.0e14;ra=-8388609;while(1){sa=Y(la,p)|0;ta=ma;R=P;ua=ra;do{va=f[T+(ta+sa<<2)>>2]|0;ua=R<(f[s>>2]=va,+n[s>>2])?va:ua;ta=ta+1|0;R=(f[s>>2]=ua,+n[s>>2])}while((ta|0)<(na|0));la=la+1|0;if((la|0)>=(Q|0))break;else{P=R;ra=ua}}f[$+(ka<<2)>>2]=ua;break}while(1){ra=Y(pa,p)|0;la=ma;wa=oa;xa=qa;do{ta=la+ra|0;P=+n[T+(ta<<2)>>2];sa=P>xa;xa=sa?P:xa;wa=sa?ta:wa;la=la+1|0}while((la|0)<(na|0));pa=pa+1|0;if((pa|0)>=(Q|0))break;else{oa=wa;qa=xa}}n[$+(ka<<2)>>2]=xa;if(!ia)n[ea+(ka<<2)>>2]=+(wa|0)}else{n[$+(ka<<2)>>2]=0.0;if(ja)n[ea+(ka<<2)>>2]=-1.0}while(0);ka=ka+1|0}while((ka|0)<(fa|0))}break}case 1:{if((ca|0)>0){ka=f[E>>2]|0;ja=(f[F>>2]|0)+p|0;ia=(b[G>>0]|0)==0;ha=Q-N|0;if((Q|0)>(N|0))ya=t;else{ga=t;while(1){na=(Y(ga,c)|0)-ka|0;ma=na+h|0;la=(ja|0)<(ma|0)?ja:ma;R=1.0/+(Y(ia?((p|0)<(la|0)?p:la)-((na|0)>0?na:0)|0:L,ia?ha:la-na|0)|0)*0.0;n[$+(ga<<2)>>2]=R;ga=ga+1|0;if((ga|0)>=(fa|0))break b}}do{ga=(Y(ya,c)|0)-ka|0;na=ga+h|0;la=(ja|0)<(na|0)?ja:na;na=(ga|0)>0?ga:0;ma=(p|0)<(la|0)?p:la;R=1.0/+(Y(ia?ma-na|0:L,ia?ha:la-ga|0)|0);if((ma|0)>(na|0)){P=0.0;ga=N;while(1){la=Y(ga,p)|0;ra=na;W=P;do{W=W+ +n[T+(ra+la<<2)>>2];ra=ra+1|0}while((ra|0)<(ma|0));ga=ga+1|0;if((ga|0)>=(Q|0)){za=W;break}else P=W}}else za=0.0;n[$+(ya<<2)>>2]=R*za;ya=ya+1|0}while((ya|0)<(fa|0))}break}default:{ha=f[B>>2]|0;ia=(f[ha+16>>2]|0)+(Y(f[f[ha+44>>2]>>2]|0,M)|0)|0;if((da|0)!=3){ha=f[m>>2]|0;if(!(+n[ia>>2]<+(f[f[ha+40>>2]>>2]|0))){S=56;break a}P=+n[ia+4>>2];O=+n[C>>2];Aa=O*+(~~(P+(P>=0.0?.5:-.5))|0);P=+n[ia+12>>2]+1.0;Ba=O*+(~~(P+(P>=0.0?.5:-.5))|0)-Aa;P=(Ba<.10000000149011612?.10000000149011612:Ba)/D;if((ca|0)<=0)break b;ja=Y((Y(I,l)|0)+J|0,k)|0;ka=Q-N|0;if((Q|0)<=(N|0)){ga=t<<2;ma=t+1|0;XIc(Z+(ba+aa+_+ga)|0,0,(((fa|0)>(ma|0)?fa:ma)<<2)-ga|0)|0;break b}ga=ha+16|0;ma=ha+44|0;ha=t;while(1){na=~~+K(+(Aa+P*+(ha|0)));ra=ha;ha=ha+1|0;la=~~+X(+(Aa+P*+(ha|0)));ta=(na|0)>0?na:0;na=(p|0)<(la|0)?p:la;if((na|0)>(ta|0)){la=f[ma>>2]|0;sa=(f[ga>>2]|0)+(Y(f[la>>2]|0,~~+n[ia>>2])|0)|0;va=sa+(Y(f[la+4>>2]|0,ra+ja|0)|0)|0;la=N;Ba=0.0;while(1){sa=Y(la,p)|0;Ca=ta;Da=Ba;do{Da=Da+ +n[va+(Ca+sa<<2)>>2];Ca=Ca+1|0}while((Ca|0)<(na|0));la=la+1|0;if((la|0)>=(Q|0))break;else Ba=Da}Ea=Da/+(Y(na-ta|0,ka)|0)}else Ea=0.0;n[$+(ra<<2)>>2]=Ea;if((ha|0)>=(fa|0))break b}}P=+n[C>>2];Aa=+n[ia+4>>2]*P;ha=~~(Aa+(Aa>=0.0?.5:-.5));Aa=P*+n[ia+12>>2];ka=~~(Aa+(Aa>=0.0?.5:-.5))-ha+1|0;Aa=+(((ka|0)>1?ka:1)|0)/D;if((ca|0)>0){P=+(ha|0);ha=v&(ea|0)!=0;if((Q|0)>(N|0))Fa=t;else{ka=t;while(1){n[$+(ka<<2)>>2]=0.0;if(ha)n[ea+(ka<<2)>>2]=-1.0;ka=ka+1|0;if((ka|0)>=(fa|0))break b}}do{ka=~~(P+Aa*+(Fa|0));ia=Fa;Fa=Fa+1|0;ja=~~(P+ +X(+(Aa*+(Fa|0))));ga=(ka|0)>0?ka:0;ka=(p|0)<(ja|0)?p:ja;if((ga|0)>=(ka|0)){n[$+(ia<<2)>>2]=0.0;if(ha)n[ea+(ia<<2)>>2]=-1.0}else{ja=N;Ba=-3402823466385288598117041.0e14;ma=-8388609;while(1){la=Y(ja,p)|0;va=ga;R=Ba;Ga=ma;do{Ca=f[T+(va+la<<2)>>2]|0;Ga=R<(f[s>>2]=Ca,+n[s>>2])?Ca:Ga;va=va+1|0;R=(f[s>>2]=Ga,+n[s>>2])}while((va|0)<(ka|0));ja=ja+1|0;if((ja|0)>=(Q|0))break;else{Ba=R;ma=Ga}}f[$+(ia<<2)>>2]=Ga}}while((Fa|0)<(fa|0))}}}while(0);if(o>>>0<=a>>>0){S=7;break}}if((S|0)==7){u=d;return}else if((S|0)==10){f[e>>2]=0;f[e+4>>2]=0;Ha=tT(e,26)|0;Ia=453631;Ja=Ha+26|0;do{b[Ha>>0]=b[Ia>>0]|0;Ha=Ha+1|0;Ia=Ia+1|0}while((Ha|0)<(Ja|0));z5(-215,e,518189,452569,425)}else if((S|0)==56){f[e>>2]=0;f[e+4>>2]=0;Ha=tT(e,26)|0;Ia=453631;Ja=Ha+26|0;do{b[Ha>>0]=b[Ia>>0]|0;Ha=Ha+1|0;Ia=Ia+1|0}while((Ha|0)<(Ja|0));z5(-215,e,518189,452569,688)}}function PAb(){f[220455]=0;f[220456]=0;f[220457]=0;b[881831]=4;f[220455]=1635017060;b[881824]=0;be(1736,881820,x|0)|0;return}function QAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0.0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0;d=u;u=u+592|0;e=d+572|0;g=d+560|0;h=d+504|0;i=d+468|0;j=d+548|0;k=d+536|0;l=d+16|0;m=d+384|0;n=d+492|0;o=d+480|0;p=d+456|0;q=d+444|0;r=d+432|0;s=d+420|0;t=d+408|0;v=d+348|0;w=d+324|0;x=d+396|0;y=d+372|0;z=d+360|0;A=d+336|0;B=d+312|0;C=d+300|0;D=d+288|0;E=d+276|0;F=d+264|0;G=d+252|0;H=d+240|0;I=d+228|0;J=d;K=d+216|0;L=d+204|0;M=d+192|0;N=d+180|0;O=d+168|0;P=d+156|0;Q=d+144|0;R=d+132|0;S=d+108|0;T=d+96|0;U=d+76|0;V=d+64|0;W=d+52|0;X=d+40|0;Z=d+28|0;_=d+120|0;$=d+88|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;aa=g+11|0;ba=g+4|0;ca=e+11|0;da=e+11|0;ea=e+4|0;fa=i+11|0;ga=h+11|0;ha=h+4|0;ia=i+11|0;ja=c+48|0;ka=c+36|0;la=c+40|0;ma=c+40|0;na=c+44|0;oa=h+11|0;pa=h+4|0;qa=e+11|0;ra=-1;sa=0;a:while(1){cuc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);ta=Hvc(e,885240)|0;ua=Mi[f[(f[ta>>2]|0)+28>>2]&1023](ta,10)|0;Ivc(e);ta=RAb(a,g,ua)|0;ua=(f[ta+(f[(f[ta>>2]|0)+-12>>2]|0)+16>>2]&5|0)!=0;if(!((ua?0:0)&1|(ua?0:1768))){va=3;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ua=b[aa>>0]|0;ta=f[ba>>2]|0;if((ua<<24>>24<0?ta:ua&255)|0){wa=0;xa=ta;ta=ua;while(1){ua=b[(ta<<24>>24<0?f[g>>2]|0:g)+wa>>0]|0;if((ua+-33&255)<90){vEc(e,ua);ya=b[aa>>0]|0;za=f[ba>>2]|0}else{ya=ta;za=xa}wa=wa+1|0;if(wa>>>0>=(ya<<24>>24<0?za:ya&255)>>>0)break;else{xa=za;ta=ya}}}iEc(g,e)|0;if((b[ca>>0]|0)<0)YDc(f[e>>2]|0);ta=b[aa>>0]|0;xa=ta<<24>>24<0;wa=f[ba>>2]|0;ua=xa?wa:ta&255;if(!ua){Aa=sa;Ba=ra;sa=Aa;ra=Ba;continue}Ca=f[g>>2]|0;switch(b[(xa?Ca:g)>>0]|0){case 59:case 35:case 0:{Aa=sa;Ba=ra;sa=Aa;ra=Ba;continue a;break}case 91:{if((ua|0)==5){if(!(EEc(g,0,-1,453763,5)|0)){Ba=ra;sa=1;ra=Ba;continue a}Da=b[aa>>0]|0;Ea=f[g>>2]|0;Fa=f[ba>>2]|0}else{Da=ta;Ea=Ca;Fa=wa}wa=ra+1|0;Ca=Da<<24>>24<0;ta=Ca?Ea:g;ua=Ca?Fa:Da&255;Ca=ta+ua|0;xa=Ca;Ga=ta;b:do if((ua|0)<1)Ha=Ca;else{Ia=ta;Ja=ua;while(1){Ka=Zoc(Ia,93,Ja)|0;if(!Ka){Ha=Ca;break b}if((b[Ka>>0]|0)==93){Ha=Ka;break b}Ia=Ka+1|0;Ja=xa-Ia|0;if((Ja|0)<1){Ha=Ca;break}}}while(0);xa=(Ha|0)==(Ca|0)?-2:Ha-Ga+-1|0;if(xa>>>0>=ua>>>0){va=35;break a}gEc(e,g,1,xa,g);xa=f[la>>2]|0;do if(xa){ta=ma;Ja=xa;Ia=xa;while(1){Ka=f[Ja+16>>2]|0;if((wa|0)<(Ka|0)){La=f[Ja>>2]|0;if(!La){va=40;break}else{Ma=Ja;Na=La}}else{if((Ka|0)>(ra|0)){va=44;break}Oa=Ja+4|0;Ka=f[Oa>>2]|0;if(!Ka){va=43;break}else{Ma=Oa;Na=Ka}}ta=Ma;Ja=Na;Ia=Na}if((va|0)==40){va=0;Pa=Ja;Qa=Ja;va=46;break}else if((va|0)==43){va=0;Pa=Oa;Qa=Ja;va=46;break}else if((va|0)==44){va=0;Ra=ta;Sa=Ja;Ta=Ia;va=45;break}}else{Ra=la;Sa=la;Ta=xa;va=45}while(0);if((va|0)==45){va=0;if(!Ta){Pa=Ra;Qa=Sa;va=46}else Ua=Ta}if((va|0)==46){va=0;xa=VDc(32)|0;f[xa+16>>2]=wa;ua=xa+24|0;f[ua>>2]=0;f[xa+28>>2]=0;f[xa+20>>2]=ua;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=Qa;f[Pa>>2]=xa;ua=f[f[ka>>2]>>2]|0;if(!ua)Va=xa;else{f[ka>>2]=ua;Va=f[Pa>>2]|0}laa(f[ma>>2]|0,Va);f[na>>2]=(f[na>>2]|0)+1;Ua=xa}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[oa>>0]=4;f[h>>2]=1701869940;b[pa>>0]=0;iEc(TAb(Ua+20|0,h)|0,e)|0;if((b[oa>>0]|0)<0)YDc(f[h>>2]|0);if((b[qa>>0]|0)<0)YDc(f[e>>2]|0);ra=wa;sa=0;continue a;break}default:{}}xa=CEc(g,61,0)|0;ua=b[aa>>0]|0;if(xa>>>0>=(ua<<24>>24<0?f[ba>>2]|0:ua&255)>>>0){va=55;break}gEc(e,g,0,xa,g);ua=xa+1|0;xa=b[aa>>0]|0;gEc(h,g,ua,(xa<<24>>24<0?f[ba>>2]|0:xa&255)-ua|0,g);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ua=b[da>>0]|0;xa=f[ea>>2]|0;if((ua<<24>>24<0?xa:ua&255)|0){Ga=0;Ca=xa;xa=ua;while(1){ua=b[(xa<<24>>24<0?f[e>>2]|0:e)+Ga>>0]|0;if((ua+-33&255)<90){vEc(i,ua);Wa=b[da>>0]|0;Xa=f[ea>>2]|0}else{Wa=xa;Xa=Ca}Ga=Ga+1|0;if(Ga>>>0>=(Wa<<24>>24<0?Xa:Wa&255)>>>0)break;else{Ca=Xa;xa=Wa}}}iEc(e,i)|0;if((b[fa>>0]|0)<0)YDc(f[i>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;xa=b[ga>>0]|0;Ca=f[ha>>2]|0;if((xa<<24>>24<0?Ca:xa&255)|0){Ga=0;wa=Ca;Ca=xa;while(1){xa=b[(Ca<<24>>24<0?f[h>>2]|0:h)+Ga>>0]|0;if((xa+-33&255)<90){vEc(i,xa);Ya=b[ga>>0]|0;Za=f[ha>>2]|0}else{Ya=Ca;Za=wa}Ga=Ga+1|0;if(Ga>>>0>=(Ya<<24>>24<0?Za:Ya&255)>>>0)break;else{wa=Za;Ca=Ya}}}iEc(h,i)|0;if((b[ia>>0]|0)<0)YDc(f[i>>2]|0);Ca=b[da>>0]|0;wa=b[ga>>0]|0;Ga=wa<<24>>24<0;if(!((Ca<<24>>24<0?f[ea>>2]|0:Ca&255)|0)){if(Ga){YDc(f[h>>2]|0);_a=b[da>>0]|0}else _a=Ca;if(_a<<24>>24<0)YDc(f[e>>2]|0);Aa=sa;Ba=ra;sa=Aa;ra=Ba;continue}if(!((Ga?f[ha>>2]|0:wa&255)|0)){if(Ga){YDc(f[h>>2]|0);$a=b[da>>0]|0}else $a=Ca;if($a<<24>>24<0)YDc(f[e>>2]|0);Aa=sa;Ba=ra;sa=Aa;ra=Ba;continue}if(sa)iEc(TAb(ja,e)|0,h)|0;else{Ca=f[la>>2]|0;do if(Ca){Ga=ma;wa=Ca;xa=Ca;while(1){ua=f[wa+16>>2]|0;if((ra|0)<(ua|0)){Ka=f[wa>>2]|0;if(!Ka){va=76;break}else{ab=wa;bb=Ka}}else{if((ua|0)>=(ra|0)){va=80;break}cb=wa+4|0;ua=f[cb>>2]|0;if(!ua){va=79;break}else{ab=cb;bb=ua}}Ga=ab;wa=bb;xa=bb}if((va|0)==76){va=0;db=wa;eb=wa;va=82;break}else if((va|0)==79){va=0;db=cb;eb=wa;va=82;break}else if((va|0)==80){va=0;fb=Ga;gb=wa;hb=xa;va=81;break}}else{fb=la;gb=la;hb=Ca;va=81}while(0);if((va|0)==81){va=0;if(!hb){db=fb;eb=gb;va=82}else ib=hb}if((va|0)==82){va=0;Ca=VDc(32)|0;f[Ca+16>>2]=ra;Ia=Ca+24|0;f[Ia>>2]=0;f[Ca+28>>2]=0;f[Ca+20>>2]=Ia;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=eb;f[db>>2]=Ca;Ia=f[f[ka>>2]>>2]|0;if(!Ia)jb=Ca;else{f[ka>>2]=Ia;jb=f[db>>2]|0}laa(f[ma>>2]|0,jb);f[na>>2]=(f[na>>2]|0)+1;ib=Ca}iEc(TAb(ib+20|0,e)|0,h)|0}if((b[ga>>0]|0)<0)YDc(f[h>>2]|0);if((b[da>>0]|0)<0)YDc(f[e>>2]|0);Aa=sa;Ba=ra;sa=Aa;ra=Ba}if((va|0)==3){if((b[aa>>0]|0)<0)YDc(f[g>>2]|0);aa=(f[na>>2]|0)+-1|0;Ba=f[la>>2]|0;do if(Ba){ra=ma;Aa=Ba;sa=Ba;while(1){da=f[Aa+16>>2]|0;if((aa|0)<(da|0)){ga=f[Aa>>2]|0;if(!ga){va=9;break}else{kb=Aa;lb=ga}}else{if((da|0)>=(aa|0)){va=13;break}mb=Aa+4|0;da=f[mb>>2]|0;if(!da){va=12;break}else{kb=mb;lb=da}}ra=kb;Aa=lb;sa=lb}if((va|0)==9){nb=Aa;ob=Aa;va=15;break}else if((va|0)==12){nb=mb;ob=Aa;va=15;break}else if((va|0)==13){pb=ra;qb=Aa;rb=sa;va=14;break}}else{pb=la;qb=la;rb=Ba;va=14}while(0);if((va|0)==14)if(!rb){nb=pb;ob=qb;va=15}else sb=rb;if((va|0)==15){rb=VDc(32)|0;f[rb+16>>2]=aa;aa=rb+24|0;f[aa>>2]=0;f[rb+28>>2]=0;f[rb+20>>2]=aa;f[rb>>2]=0;f[rb+4>>2]=0;f[rb+8>>2]=ob;f[nb>>2]=rb;ob=f[f[ka>>2]>>2]|0;if(!ob)tb=rb;else{f[ka>>2]=ob;tb=f[nb>>2]|0}laa(f[ma>>2]|0,tb);f[na>>2]=(f[na>>2]|0)+1;sb=rb}f[g+8>>2]=0;rb=g+11|0;b[rb>>0]=7;b[g>>0]=b[453755]|0;b[g+1>>0]=b[453756]|0;b[g+2>>0]=b[453757]|0;b[g+3>>0]=b[453758]|0;b[g+4>>0]=b[453759]|0;b[g+5>>0]=b[453760]|0;b[g+6>>0]=b[453761]|0;b[g+7>>0]=0;fEc(e,TAb(sb+20|0,g)|0);if((b[rb>>0]|0)<0)YDc(f[g>>2]|0);UAb(g,e);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;rb=j+11|0;b[rb>>0]=5;b[j>>0]=b[467281]|0;b[j+1>>0]=b[467282]|0;b[j+2>>0]=b[467283]|0;b[j+3>>0]=b[467284]|0;b[j+4>>0]=b[467285]|0;b[j+5>>0]=0;sb=VAb(ja,j,416)|0;f[c>>2]=sb;if((b[rb>>0]|0)<0)YDc(f[j>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=k+11|0;b[j>>0]=6;b[k>>0]=b[467287]|0;b[k+1>>0]=b[467288]|0;b[k+2>>0]=b[467289]|0;b[k+3>>0]=b[467290]|0;b[k+4>>0]=b[467291]|0;b[k+5>>0]=b[467292]|0;b[k+6>>0]=0;rb=VAb(ja,k,416)|0;sb=c+4|0;f[sb>>2]=rb;if((b[j>>0]|0)<0)YDc(f[k>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;k=l+11|0;b[k>>0]=8;j=l;f[j>>2]=1851877475;f[j+4>>2]=1936483694;b[l+8>>0]=0;j=VAb(ja,l,3)|0;ja=c+8|0;f[ja>>2]=j;if((b[k>>0]|0)<0)YDc(f[l>>2]|0);if((f[c>>2]|0)<=0){f[h>>2]=0;ub=h+4|0;f[ub>>2]=0;vb=tT(h,54)|0;wb=vb;xb=453930;yb=wb+54|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,h,453799,453824,528)}if((f[sb>>2]|0)<=0){f[h>>2]=0;ub=h+4|0;f[ub>>2]=0;vb=tT(h,54)|0;wb=vb;xb=453930;yb=wb+54|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,h,453799,453824,528)}sb=f[ja>>2]|0;if((sb|0)<=0){f[h>>2]=0;ub=h+4|0;f[ub>>2]=0;vb=tT(h,54)|0;wb=vb;xb=453930;yb=wb+54|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,h,453799,453824,528)}vb=c+24|0;ub=f[na>>2]|0;na=c+28|0;ja=f[na>>2]|0;l=f[vb>>2]|0;k=ja-l>>2;j=l;l=ja;if(ub>>>0<=k>>>0){if(ub>>>0<k>>>0?(ja=j+(ub<<2)|0,(l|0)!=(ja|0)):0)f[na>>2]=l+(~((l+-4-ja|0)>>>2)<<2)}else lN(vb,ub-k|0);f[h>>2]=c;f[h+4>>2]=0;c=h+8|0;fEc(c,881820);f[h+20>>2]=0;k=h+24|0;f[k>>2]=0;f[h+28>>2]=0;ub=f[ka>>2]|0;c:do if((ub|0)!=(la|0)){ka=m+11|0;ja=m+4|0;l=i+11|0;na=i+4|0;j=n+11|0;rb=n+4|0;tb=o+11|0;ma=o+3|0;nb=p+11|0;ob=p+6|0;aa=q+11|0;qb=q+7|0;pb=r+11|0;Ba=r+10|0;mb=s+11|0;lb=s+6|0;kb=t+8|0;da=t+4|0;ga=t+11|0;ib=m+11|0;jb=m+4|0;db=x+11|0;eb=x+7|0;hb=y+11|0;gb=y+4|0;fb=z+11|0;cb=z+6|0;bb=A+11|0;ab=A+3|0;$a=B+11|0;ha=B+6|0;_a=C+11|0;ea=C+6|0;ia=D+11|0;Ya=m+11|0;Za=m+4|0;fa=v+4|0;Wa=E+11|0;Xa=E+6|0;ba=F+11|0;qa=F+6|0;oa=G+11|0;Ua=G+6|0;pa=H+11|0;Va=H+7|0;Pa=I+11|0;Qa=I+3|0;Ta=J+11|0;Sa=J+8|0;Ra=K+11|0;Oa=K+7|0;Na=M+11|0;Ma=M+4|0;Ha=N+11|0;Da=L+11|0;Fa=L+4|0;Ea=O+11|0;ca=O+7|0;ya=P+11|0;za=m+11|0;a=m+4|0;Ca=v+4|0;Ia=Q+11|0;Ja=Q+4|0;ta=R+11|0;ua=m+11|0;Ka=m+4|0;La=S+11|0;zb=S+6|0;Ab=T+11|0;Bb=T+7|0;Cb=U+11|0;Db=U+3|0;Eb=V+11|0;Fb=V+7|0;Gb=W+11|0;Hb=m+11|0;Ib=m+4|0;Jb=X+11|0;Kb=X+4|0;Lb=Z+11|0;Mb=w+11|0;Nb=w+4|0;Ob=v+4|0;Pb=_+4|0;Qb=o+4|0;Rb=q+8|0;Sb=x+8|0;Tb=A+4|0;Ub=H+8|0;Vb=I+4|0;Wb=K+8|0;Xb=O+8|0;Yb=T+8|0;Zb=U+4|0;_b=V+8|0;$b=sb;ac=-1;bc=ub;d:while(1){ac=ac+1|0;cc=bc+20|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[ka>>0]=4;f[m>>2]=1701869940;b[ja>>0]=0;fEc(i,TAb(cc,m)|0);if((b[ka>>0]|0)<0)YDc(f[m>>2]|0);dc=b[l>>0]|0;ec=f[na>>2]|0;do if(((dc<<24>>24<0?ec:dc&255)|0)==13){if(EEc(i,0,-1,453985,13)|0){fc=b[l>>0]|0;gc=f[na>>2]|0;va=168;break};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;b[j>>0]=4;f[n>>2]=1702521203;b[rb>>0]=0;hc=VAb(cc,n,-1)|0;if((b[j>>0]|0)<0)YDc(f[n>>2]|0);ic=Qb;f[ic>>2]=0;f[ic+4>>2]=0;b[tb>>0]=3;b[o>>0]=b[453999]|0;b[o+1>>0]=b[454e3]|0;b[o+2>>0]=b[454001]|0;b[ma>>0]=0;ic=VAb(cc,o,0)|0;if((b[tb>>0]|0)<0)YDc(f[o>>2]|0);f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;b[nb>>0]=6;b[p>>0]=b[454003]|0;b[p+1>>0]=b[454004]|0;b[p+2>>0]=b[454005]|0;b[p+3>>0]=b[454006]|0;b[p+4>>0]=b[454007]|0;b[p+5>>0]=b[454008]|0;b[ob>>0]=0;jc=VAb(cc,p,1)|0;if((b[nb>>0]|0)<0)YDc(f[p>>2]|0);f[Rb>>2]=0;b[aa>>0]=7;b[q>>0]=b[454010]|0;b[q+1>>0]=b[454011]|0;b[q+2>>0]=b[454012]|0;b[q+3>>0]=b[454013]|0;b[q+4>>0]=b[454014]|0;b[q+5>>0]=b[454015]|0;b[q+6>>0]=b[454016]|0;b[qb>>0]=0;kc=VAb(cc,q,-1)|0;if((b[aa>>0]|0)<0)YDc(f[q>>2]|0);b[pb>>0]=10;wb=r;xb=454018;yb=wb+10|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));b[Ba>>0]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;b[mb>>0]=6;b[s>>0]=b[454029]|0;b[s+1>>0]=b[454030]|0;b[s+2>>0]=b[454031]|0;b[s+3>>0]=b[454032]|0;b[s+4>>0]=b[454033]|0;b[s+5>>0]=b[454034]|0;b[lb>>0]=0;WAb(m,cc,r,s);if((b[mb>>0]|0)<0)YDc(f[s>>2]|0);if((b[pb>>0]|0)<0)YDc(f[r>>2]|0);f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;lc=VDc(16)|0;f[t>>2]=lc;f[kb>>2]=-2147483632;f[da>>2]=15;wb=lc;xb=454036;yb=wb+15|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));b[lc+15>>0]=0;mc=(VAb(cc,t,0)|0)==1;if((b[ga>>0]|0)<0)YDc(f[t>>2]|0);nc=b[ib>>0]|0;oc=f[jb>>2]|0;do if(((nc<<24>>24<0?oc:nc&255)|0)==6){if(!(EEc(m,0,-1,454029,6)|0))break;pc=b[ib>>0]|0;qc=f[jb>>2]|0;va=150}else{pc=nc;qc=oc;va=150}while(0);if((va|0)==150){va=0;if(((pc<<24>>24<0?qc:pc&255)|0)!=5){va=152;break d}if(EEc(m,0,-1,454052,5)|0){va=152;break d}}f[Sb>>2]=0;b[db>>0]=7;b[x>>0]=b[454083]|0;b[x+1>>0]=b[454084]|0;b[x+2>>0]=b[454085]|0;b[x+3>>0]=b[454086]|0;b[x+4>>0]=b[454087]|0;b[x+5>>0]=b[454088]|0;b[x+6>>0]=b[454089]|0;b[eb>>0]=0;oc=VAb(cc,x,0)|0;if((b[db>>0]|0)<0)YDc(f[x>>2]|0);if((oc|0)==1){va=158;break d}if(!((hc|0)>0&(kc|0)>0)){va=160;break d}if(($b|0)<=0){va=162;break d}oc=b[ib>>0]|0;if(((oc<<24>>24<0?f[jb>>2]|0:oc&255)|0)==5)rc=(EEc(m,0,-1,454052,5)|0)==0;else rc=0;XAb(h,hc,(hc|0)<3?0:ic,jc,kc,$b,mc&1,rc&1);if((b[ib>>0]|0)<0)YDc(f[m>>2]|0);sc=kc}else{fc=dc;gc=ec;va=168}while(0);e:do if((va|0)==168){va=0;do if(((fc<<24>>24<0?gc:fc&255)|0)==7){if(EEc(i,0,-1,454198,7)|0){tc=b[l>>0]|0;uc=f[na>>2]|0;break};f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;b[hb>>0]=4;f[y>>2]=1702521203;b[gb>>0]=0;ec=VAb(cc,y,2)|0;if((b[hb>>0]|0)<0)YDc(f[y>>2]|0);f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;b[fb>>0]=6;b[z>>0]=b[454003]|0;b[z+1>>0]=b[454004]|0;b[z+2>>0]=b[454005]|0;b[z+3>>0]=b[454006]|0;b[z+4>>0]=b[454007]|0;b[z+5>>0]=b[454008]|0;b[cb>>0]=0;dc=VAb(cc,z,2)|0;if((b[fb>>0]|0)<0)YDc(f[z>>2]|0);xa=Tb;f[xa>>2]=0;f[xa+4>>2]=0;b[bb>>0]=3;b[A>>0]=b[453999]|0;b[A+1>>0]=b[454e3]|0;b[A+2>>0]=b[454001]|0;b[ab>>0]=0;xa=VAb(cc,A,0)|0;if((b[bb>>0]|0)<0)YDc(f[A>>2]|0);YAb(h,ec,xa,dc);sc=$b;break e}else{tc=fc;uc=gc}while(0);do if(((tc<<24>>24<0?uc:tc&255)|0)==7)if(!(EEc(i,0,-1,454206,7)|0)){ZAb(h);sc=$b;break e}else{vc=b[l>>0]|0;wc=f[na>>2]|0;break}else{vc=tc;wc=uc}while(0);do if(((vc<<24>>24<0?wc:vc&255)|0)==7){if(EEc(i,0,-1,454214,7)|0){xc=b[l>>0]|0;yc=f[na>>2]|0;break};f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;b[$a>>0]=6;b[B>>0]=b[454222]|0;b[B+1>>0]=b[454223]|0;b[B+2>>0]=b[454224]|0;b[B+3>>0]=b[454225]|0;b[B+4>>0]=b[454226]|0;b[B+5>>0]=b[454227]|0;b[ha>>0]=0;kc=VAb(cc,B,1)|0;if((b[$a>>0]|0)<0)YDc(f[B>>2]|0);if((kc|0)!=1){va=188;break d}_Ab(h);sc=$b;break e}else{xc=vc;yc=wc}while(0);do if(((xc<<24>>24<0?yc:xc&255)|0)==5){if(EEc(i,0,-1,454267,5)|0){zc=b[l>>0]|0;Ac=f[na>>2]|0;break};f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;b[_a>>0]=6;b[C>>0]=b[454273]|0;b[C+1>>0]=b[454274]|0;b[C+2>>0]=b[454275]|0;b[C+3>>0]=b[454276]|0;b[C+4>>0]=b[454277]|0;b[C+5>>0]=b[454278]|0;b[ea>>0]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;WAb(m,cc,C,D);if((b[ia>>0]|0)<0)YDc(f[D>>2]|0);if((b[_a>>0]|0)<0)YDc(f[C>>2]|0);kc=b[Ya>>0]|0;if(!((kc<<24>>24<0?f[Za>>2]|0:kc&255)|0)){va=198;break d}$Ab(v,m);kc=f[v>>2]|0;mc=(f[fa>>2]|0)-kc>>2;jc=kc;do if(!mc){Bc=0;Cc=0;va=204}else{kc=f[vb>>2]|0;ic=0;hc=0;do{dc=jc+(ic<<2)|0;xa=f[dc>>2]|0;ec=((xa|0)>0?0:ac)+xa|0;f[dc>>2]=ec;hc=(f[kc+(ec<<2)>>2]|0)+hc|0;ic=ic+1|0}while(ic>>>0<mc>>>0);if((mc|0)!=1){Bc=hc;Cc=mc;va=204;break}aBb(h,f[jc>>2]|0);Dc=hc}while(0);if((va|0)==204){va=0;bBb(h,Cc,jc);Dc=Bc}mc=f[v>>2]|0;if(mc|0){ic=f[fa>>2]|0;if((ic|0)!=(mc|0))f[fa>>2]=ic+(~((ic+-4-mc|0)>>>2)<<2);YDc(mc)}if((b[Ya>>0]|0)<0)YDc(f[m>>2]|0);sc=Dc;break e}else{zc=xc;Ac=yc}while(0);do if(((zc<<24>>24<0?Ac:zc&255)|0)==5){if(EEc(i,0,-1,454303,5)|0){Ec=b[l>>0]|0;Fc=f[na>>2]|0;break};f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;b[Wa>>0]=6;b[E>>0]=b[454003]|0;b[E+1>>0]=b[454004]|0;b[E+2>>0]=b[454005]|0;b[E+3>>0]=b[454006]|0;b[E+4>>0]=b[454007]|0;b[E+5>>0]=b[454008]|0;b[Xa>>0]=0;mc=VAb(cc,E,2)|0;if((b[Wa>>0]|0)<0)YDc(f[E>>2]|0);cBb(h,mc);sc=Y(Y(mc,$b)|0,mc)|0;break e}else{Ec=zc;Fc=Ac}while(0);do if(((Ec<<24>>24<0?Fc:Ec&255)|0)==6){if(EEc(i,0,-1,454309,6)|0){Gc=b[l>>0]|0;Hc=f[na>>2]|0;break};f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;b[ba>>0]=6;b[F>>0]=b[454316]|0;b[F+1>>0]=b[454317]|0;b[F+2>>0]=b[454318]|0;b[F+3>>0]=b[454319]|0;b[F+4>>0]=b[454320]|0;b[F+5>>0]=b[454321]|0;b[qa>>0]=0;Ic=+dBb(cc,F,1.0000000474974513e-03);if((b[ba>>0]|0)<0)YDc(f[F>>2]|0);f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;b[oa>>0]=6;b[G>>0]=b[454323]|0;b[G+1>>0]=b[454324]|0;b[G+2>>0]=b[454325]|0;b[G+3>>0]=b[454326]|0;b[G+4>>0]=b[454327]|0;b[G+5>>0]=b[454328]|0;b[Ua>>0]=0;mc=VAb(cc,G,4)|0;if((b[oa>>0]|0)<0)YDc(f[G>>2]|0);f[Ub>>2]=0;b[pa>>0]=7;b[H>>0]=b[454330]|0;b[H+1>>0]=b[454331]|0;b[H+2>>0]=b[454332]|0;b[H+3>>0]=b[454333]|0;b[H+4>>0]=b[454334]|0;b[H+5>>0]=b[454335]|0;b[H+6>>0]=b[454336]|0;b[Va>>0]=0;ic=VAb(cc,H,-1)|0;if((b[pa>>0]|0)<0)YDc(f[H>>2]|0);kc=Vb;f[kc>>2]=0;f[kc+4>>2]=0;b[Pa>>0]=3;b[I>>0]=b[454338]|0;b[I+1>>0]=b[454339]|0;b[I+2>>0]=b[454340]|0;b[Qa>>0]=0;kc=VAb(cc,I,-1)|0;if((b[Pa>>0]|0)<0)YDc(f[I>>2]|0);f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;b[Ta>>0]=8;ec=J;f[ec>>2]=1935764579;f[ec+4>>2]=2020173427;b[Sa>>0]=0;ec=VAb(cc,J,0)|0;if((b[Ta>>0]|0)<0)YDc(f[J>>2]|0);f[Wb>>2]=0;b[Ra>>0]=7;b[K>>0]=b[454214]|0;b[K+1>>0]=b[454215]|0;b[K+2>>0]=b[454216]|0;b[K+3>>0]=b[454217]|0;b[K+4>>0]=b[454218]|0;b[K+5>>0]=b[454219]|0;b[K+6>>0]=b[454220]|0;b[Oa>>0]=0;dc=(VAb(cc,K,0)|0)==1;if((b[Ra>>0]|0)<0)YDc(f[K>>2]|0);f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;b[Na>>0]=4;f[M>>2]=1701147252;b[Ma>>0]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;WAb(L,cc,M,N);xa=b[Da>>0]|0;wa=xa<<24>>24<0;Ga=((wa?f[Fa>>2]|0:xa&255)|0)!=0;if(wa)YDc(f[L>>2]|0);if((b[Ha>>0]|0)<0)YDc(f[N>>2]|0);if((b[Na>>0]|0)<0)YDc(f[M>>2]|0);f[Xb>>2]=0;b[Ea>>0]=7;b[O>>0]=b[453755]|0;b[O+1>>0]=b[453756]|0;b[O+2>>0]=b[453757]|0;b[O+3>>0]=b[453758]|0;b[O+4>>0]=b[453759]|0;b[O+5>>0]=b[453760]|0;b[O+6>>0]=b[453761]|0;b[ca>>0]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;WAb(m,cc,O,P);if((b[ya>>0]|0)<0)YDc(f[P>>2]|0);if((b[Ea>>0]|0)<0)YDc(f[O>>2]|0);wa=b[za>>0]|0;if(!((wa<<24>>24<0?f[a>>2]|0:wa&255)|0)){va=244;break d}UAb(v,m);if(!((ic|0)>0&(kc|0)>0)){va=247;break d}if((kc<<1|0)!=((f[Ca>>2]|0)-(f[v>>2]|0)>>2|0)){va=247;break d}eBb(h,0);fBb(h,Ic,mc,ic,kc,ec,dc&1,Ga&1,f[v>>2]|0);Ga=f[v>>2]|0;if(Ga|0){dc=f[Ca>>2]|0;if((dc|0)!=(Ga|0))f[Ca>>2]=dc+(~((dc+-4-Ga|0)>>>2)<<2);YDc(Ga)}if((b[za>>0]|0)<0)YDc(f[m>>2]|0);sc=$b;break e}else{Gc=Ec;Hc=Fc}while(0);do if(((Gc<<24>>24<0?Hc:Gc&255)|0)==8){if(EEc(i,0,-1,454446,8)|0){Jc=b[l>>0]|0;Kc=f[na>>2]|0;break};f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;b[Ia>>0]=4;f[Q>>2]=1836020326;b[Ja>>0]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;WAb(m,cc,Q,R);if((b[ta>>0]|0)<0)YDc(f[R>>2]|0);if((b[Ia>>0]|0)<0)YDc(f[Q>>2]|0);Ga=b[ua>>0]|0;dc=Ga<<24>>24<0;if(!((dc?f[Ka>>2]|0:Ga&255)|0)){va=263;break d}Ga=(vrc(dc?f[m>>2]|0:m)|0)+ac|0;dc=f[(f[vb>>2]|0)+(Ga<<2)>>2]|0;gBb(h,Ga);if((b[ua>>0]|0)<0)YDc(f[m>>2]|0);sc=dc;break e}else{Jc=Gc;Kc=Hc}while(0);do if(((Jc<<24>>24<0?Kc:Jc&255)|0)==8){if(EEc(i,0,-1,454477,8)|0){Lc=b[l>>0]|0;Mc=f[na>>2]|0;break};f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;b[La>>0]=6;b[S>>0]=b[454003]|0;b[S+1>>0]=b[454004]|0;b[S+2>>0]=b[454005]|0;b[S+3>>0]=b[454006]|0;b[S+4>>0]=b[454007]|0;b[S+5>>0]=b[454008]|0;b[zb>>0]=0;dc=VAb(cc,S,1)|0;if((b[La>>0]|0)<0)YDc(f[S>>2]|0);hBb(h,dc);sc=$b;break e}else{Lc=Jc;Mc=Kc}while(0);if(((Lc<<24>>24<0?Mc:Lc&255)|0)!=4){va=307;break d}if(EEc(i,0,-1,454486,4)|0){va=307;break d}f[Yb>>2]=0;b[Ab>>0]=7;b[T>>0]=b[454330]|0;b[T+1>>0]=b[454331]|0;b[T+2>>0]=b[454332]|0;b[T+3>>0]=b[454333]|0;b[T+4>>0]=b[454334]|0;b[T+5>>0]=b[454335]|0;b[T+6>>0]=b[454336]|0;b[Bb>>0]=0;dc=VAb(cc,T,-1)|0;if((b[Ab>>0]|0)<0)YDc(f[T>>2]|0);Ga=Zb;f[Ga>>2]=0;f[Ga+4>>2]=0;b[Cb>>0]=3;b[U>>0]=b[454338]|0;b[U+1>>0]=b[454339]|0;b[U+2>>0]=b[454340]|0;b[Db>>0]=0;Ga=VAb(cc,U,-1)|0;if((b[Cb>>0]|0)<0)YDc(f[U>>2]|0);f[_b>>2]=0;b[Eb>>0]=7;b[V>>0]=b[453755]|0;b[V+1>>0]=b[453756]|0;b[V+2>>0]=b[453757]|0;b[V+3>>0]=b[453758]|0;b[V+4>>0]=b[453759]|0;b[V+5>>0]=b[453760]|0;b[V+6>>0]=b[453761]|0;b[Fb>>0]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;WAb(m,cc,V,W);if((b[Gb>>0]|0)<0)YDc(f[W>>2]|0);if((b[Eb>>0]|0)<0)YDc(f[V>>2]|0);ec=b[Hb>>0]|0;if(!((ec<<24>>24<0?f[Ib>>2]|0:ec&255)|0)){va=284;break d}UAb(v,m);f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;b[Jb>>0]=4;f[X>>2]=1802723693;b[Kb>>0]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;WAb(w,cc,X,Z);if((b[Lb>>0]|0)<0)YDc(f[Z>>2]|0);if((b[Jb>>0]|0)<0)YDc(f[X>>2]|0);ec=b[Mb>>0]|0;if(!((ec<<24>>24<0?f[Nb>>2]|0:ec&255)|0)){va=290;break d}$Ab(_,w);if(!((dc|0)>0&(Ga|0)>0)){va=293;break d}if((Ga<<1|0)!=((f[Ob>>2]|0)-(f[v>>2]|0)>>2|0)){va=293;break d}eBb(h,0);iBb(h,dc,_,v);dc=f[_>>2]|0;if(dc|0){Ga=f[Pb>>2]|0;if((Ga|0)!=(dc|0))f[Pb>>2]=Ga+(~((Ga+-4-dc|0)>>>2)<<2);YDc(dc)}if((b[Mb>>0]|0)<0)YDc(f[w>>2]|0);dc=f[v>>2]|0;if(dc|0){Ga=f[Ob>>2]|0;if((Ga|0)!=(dc|0))f[Ob>>2]=Ga+(~((Ga+-4-dc|0)>>>2)<<2);YDc(dc)}if((b[Hb>>0]|0)<0)YDc(f[m>>2]|0);sc=$b}while(0);f[(f[vb>>2]|0)+(ac<<2)>>2]=sc;if((b[l>>0]|0)<0)YDc(f[i>>2]|0);cc=f[bc+4>>2]|0;if(!cc){dc=bc+8|0;Ga=f[dc>>2]|0;if((f[Ga>>2]|0)==(bc|0))Nc=Ga;else{Ga=dc;do{dc=f[Ga>>2]|0;Ga=dc+8|0;ec=f[Ga>>2]|0}while((f[ec>>2]|0)!=(dc|0));Nc=ec}}else{Ga=cc;while(1){ec=f[Ga>>2]|0;if(!ec)break;else Ga=ec}Nc=Ga}if((Nc|0)==(la|0)){va=119;break}else{$b=sc;bc=Nc}}switch(va|0){case 119:{bc=h+20|0;$b=f[bc>>2]|0;if(!$b)break c;l=f[k>>2]|0;if((l|0)==($b|0))Oc=$b;else{ac=l;while(1){l=ac+-12|0;f[k>>2]=l;if((b[l+11>>0]|0)<0){YDc(f[l>>2]|0);Pc=f[k>>2]|0}else Pc=l;if((Pc|0)==($b|0))break;else ac=Pc}Oc=f[bc>>2]|0}YDc(Oc);break c;break}case 152:{VHa(w,454058,m);f[v>>2]=0;f[v+4>>2]=0;ac=w+11|0;$b=b[ac>>0]|0;l=$b<<24>>24<0?f[w+4>>2]|0:$b&255;if(!l)z5(-212,v,453799,453824,552);$b=tT(v,l)|0;dJc($b|0,((b[ac>>0]|0)<0?f[w>>2]|0:w)|0,l|0)|0;z5(-212,v,453799,453824,552);break}case 158:{f[v>>2]=0;f[v+4>>2]=0;wb=tT(v,54)|0;xb=454091;yb=wb+54|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-213,v,453799,453824,555);break}case 160:{f[v>>2]=0;f[v+4>>2]=0;wb=tT(v,30)|0;xb=454146;yb=wb+30|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,v,453799,453824,560);break}case 162:{f[v>>2]=0;f[v+4>>2]=0;wb=tT(v,20)|0;xb=454177;yb=wb+20|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,v,453799,453824,561);break}case 188:{f[m>>2]=0;f[m+4>>2]=0;wb=tT(m,37)|0;xb=454229;yb=wb+37|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-213,m,453799,453824,583);break}case 198:{f[v>>2]=0;f[v+4>>2]=0;wb=tT(v,22)|0;xb=454280;yb=wb+22|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,v,453799,453824,589);break}case 244:{f[v>>2]=0;f[v+4>>2]=0;wb=tT(v,23)|0;xb=454342;yb=wb+23|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,v,453799,453824,621);break}case 247:{f[w>>2]=0;f[w+4>>2]=0;wb=tT(w,79)|0;xb=454366;yb=wb+79|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,w,453799,453824,624);break}case 263:{f[v>>2]=0;f[v+4>>2]=0;wb=tT(v,21)|0;xb=454455;yb=wb+21|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,v,453799,453824,632);break}case 284:{f[v>>2]=0;f[v+4>>2]=0;wb=tT(v,23)|0;xb=454342;yb=wb+23|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,v,453799,453824,651);break}case 290:{f[_>>2]=0;f[_+4>>2]=0;wb=tT(_,20)|0;xb=454491;yb=wb+20|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,_,453799,453824,655);break}case 293:{f[$>>2]=0;f[$+4>>2]=0;wb=tT($,79)|0;xb=454366;yb=wb+79|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,$,453799,453824,658);break}case 307:{VHa(v,454512,i);f[m>>2]=0;f[m+4>>2]=0;bc=v+11|0;l=b[bc>>0]|0;ac=l<<24>>24<0?f[v+4>>2]|0:l&255;if(!ac)z5(-212,m,453799,453824,664);l=tT(m,ac)|0;dJc(l|0,((b[bc>>0]|0)<0?f[v>>2]|0:v)|0,ac|0)|0;z5(-212,m,453799,453824,664);break}}}while(0);if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);c=f[g>>2]|0;if(c|0){m=g+4|0;g=f[m>>2]|0;if((g|0)!=(c|0))f[m>>2]=g+(~((g+-4-c|0)>>>2)<<2);YDc(c)}if((b[e+11>>0]|0)>=0){u=d;return 1}YDc(f[e>>2]|0);u=d;return 1}else if((va|0)==35){f[e>>2]=0;f[e+4>>2]=0;wb=tT(e,29)|0;xb=453769;yb=wb+29|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,e,453799,453824,499)}else if((va|0)==55){f[e>>2]=0;f[e+4>>2]=0;wb=tT(e,29)|0;xb=453900;yb=wb+29|0;do{b[wb>>0]=b[xb>>0]|0;wb=wb+1|0;xb=xb+1|0}while((wb|0)<(yb|0));z5(-215,e,453799,453824,507)}return 0}function RAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;huc(g,a,1);if(!(b[g>>0]|0)){u=e;return a|0}g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;i=c+4|0;f[i>>2]=0;j=i}else{b[c>>0]=0;b[g>>0]=0;j=c+4|0}i=0;while(1){k=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;l=k+12|0;m=f[l>>2]|0;if((m|0)==(f[k+16>>2]|0)){n=_i[f[(f[k>>2]|0)+40>>2]&1023](k)|0;if((n|0)==-1){o=i;p=2;break}else q=n}else{f[l>>2]=m+1;q=h[m>>0]|0}m=i+1|0;l=q&255;if(l<<24>>24==d<<24>>24){o=m;p=0;break}vEc(c,l);if((b[g>>0]|0)<0&(f[j>>2]|0)==-17){o=m;p=4;break}else i=m}i=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(i,f[i+16>>2]|((o|0)==0?p|4:p));u=e;return a|0}function SAb(a){a=a|0;return}function TAb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=mBb(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=VDc(40)|0;fEc(g+16|0,b);b=g+28|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}laa(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function UAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+320|0;e=d+168|0;g=d+152|0;h=d+8|0;i=d;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;k=e+64|0;l=e+8|0;f[l>>2]=45704;m=e+12|0;f[e>>2]=6980;f[k>>2]=7e3;f[e+4>>2]=0;auc(e+64|0,m);f[e+136>>2]=0;f[e+140>>2]=-1;f[e>>2]=45684;f[k>>2]=45724;f[l>>2]=45704;fuc(m);f[m>>2]=45740;l=e+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[e+60>>2]=24;G1(m,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=h+64|0;m=h+8|0;l=h+12|0;k=h+4|0;n=h+64|0;o=h+136|0;p=h+140|0;q=h+44|0;r=h+60|0;s=a+8|0;while(1){t=RAb(e,g,44)|0;v=(f[t+(f[(f[t>>2]|0)+-12>>2]|0)+16>>2]&5|0)!=0;if(!((v?0:0)&1|(v?0:1768)))break;f[m>>2]=45704;f[h>>2]=6980;f[c>>2]=7e3;f[k>>2]=0;auc(n,l);f[o>>2]=0;f[p>>2]=-1;f[h>>2]=45684;f[c>>2]=45724;f[m>>2]=45704;fuc(l);f[l>>2]=45740;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[r>>2]=24;G1(l,g);nuc(h,i)|0;v=f[j>>2]|0;if((v|0)==(f[s>>2]|0))osb(a,i);else{f[v>>2]=f[i>>2];f[j>>2]=v+4}K1(h)}if((b[g+11>>0]|0)>=0){K1(e);u=d;return}YDc(f[g>>2]|0);K1(e);u=d;return}function VAb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+160|0;e=d;g=d+8|0;f[e>>2]=c;h=kBb(a,b)|0;if((h|0)==(a+4|0)){i=c;u=d;return i|0}c=g+64|0;a=g+8|0;f[a>>2]=45704;b=g+12|0;f[g>>2]=6980;f[c>>2]=7e3;f[g+4>>2]=0;auc(g+64|0,b);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=45684;f[c>>2]=45724;f[a>>2]=45704;fuc(b);f[b>>2]=45740;a=g+44|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[g+60>>2]=24;G1(b,h+28|0);luc(g,e)|0;K1(g);i=f[e>>2]|0;u=d;return i|0}function WAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+144|0;g=e;h=kBb(b,c)|0;if((h|0)==(b+4|0)){fEc(a,d);u=e;return}b=g+64|0;c=g+8|0;f[c>>2]=45704;i=g+12|0;f[g>>2]=6980;f[b>>2]=7e3;f[g+4>>2]=0;auc(g+64|0,i);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=45684;f[b>>2]=45724;f[c>>2]=45704;fuc(i);f[i>>2]=45740;c=g+44|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[g+60>>2]=24;G1(i,h+28|0);I3(g,d)|0;K1(g);fEc(a,d);u=e;return}function XAb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;h=u;u=u+320|0;k=h+56|0;l=h+40|0;m=h;o=h+272|0;p=h+196|0;q=h+184|0;r=h+176|0;s=h+96|0;t=h+68|0;v=h+88|0;w=h+80|0;lBb(o,a,c,d,e,g);f[p+40>>2]=0;f[p+44>>2]=0;g=p+40|0;e=p+36|0;d=p;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[e>>2]=g;g=p+48|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;g=a+4|0;f[m>>2]=f[g>>2];F5(r,454931,m);e=f[r>>2]|0;x=f[r+4>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;if(x>>>0>4294967279)dEc(q);if(x>>>0<11){b[q+11>>0]=x;if(!x)y=q;else{z=q;A=6}}else{B=x+16&-16;C=VDc(B)|0;f[q>>2]=C;f[q+8>>2]=B|-2147483648;f[q+4>>2]=x;z=C;A=6}if((A|0)==6){dJc(z|0,e|0,x|0)|0;y=z}b[y+x>>0]=0;uT(r);r=(i|0)!=0;if(!r){f[m>>2]=0;f[m+4>>2]=0;d=tT(m,9)|0;D=454939;c=d+9|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));b[s>>0]=1;rIa(o,m,s)|0;uT(m)}iEc(p,q)|0;i=o+32|0;x=f[i>>2]|0;y=o+36|0;z=f[y>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if(z>>>0>4294967279)dEc(m);if(z>>>0<11){b[m+11>>0]=z;if(!z)E=m;else{F=m;A=14}}else{e=z+16&-16;C=VDc(e)|0;f[m>>2]=C;f[m+8>>2]=e|-2147483648;f[m+4>>2]=z;F=C;A=14}if((A|0)==14){dJc(F|0,x|0,z|0)|0;E=F}b[E+z>>0]=0;iEc(p+12|0,m)|0;if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);pIa(p+36|0,o)|0;XGa(p+48|0,f[o+12>>2]|0,f[o+16>>2]|0);z=p+60|0;E=o+24|0;uT(z);F=f[E>>2]|0;if(!F)G=0;else{x=F+-4|0;f[x>>2]=(f[x>>2]|0)+1;G=f[E>>2]|0}f[z>>2]=G;f[p+64>>2]=f[o+28>>2];G=p+68|0;uT(G);z=f[i>>2]|0;if(!z)H=0;else{E=z+-4|0;f[E>>2]=(f[E>>2]|0)+1;H=f[i>>2]|0}f[G>>2]=H;f[p+72>>2]=f[y>>2];y=a+8|0;H=p+28|0;G=f[H>>2]|0;if((G|0)==(f[p+32>>2]|0))e1(p+24|0,y);else{fEc(G,y);f[H>>2]=(f[H>>2]|0)+12}iEc(y,q)|0;H=f[a>>2]|0;G=H+16|0;i=f[G>>2]|0;if((i|0)==(f[H+20>>2]|0))jBb(H+12|0,p);else{hLa(i,p);f[G>>2]=(f[G>>2]|0)+76}if(r){f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=m+4;r=m+12|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;G=m+24|0;uT(G);d=tT(G,14)|0;D=454949;c=d+14|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));i=m+32|0;uT(i);d=tT(i,9)|0;D=454964;c=d+9|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));f[s>>2]=0;f[s+4>>2]=0;d=tT(s,10)|0;D=454974;c=d+10|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));b[t>>0]=1;rIa(m,s,t)|0;uT(s);f[s>>2]=0;f[s+4>>2]=0;H=tT(s,8)|0;E=H;b[E>>0]=104;b[E+1>>0]=97;b[E+2>>0]=115;b[E+3>>0]=95;E=H+4|0;b[E>>0]=98;b[E+1>>0]=105;b[E+2>>0]=97;b[E+3>>0]=115;b[t>>0]=1;rIa(m,s,t)|0;uT(s);f[s>>2]=0;f[s+4>>2]=0;E=tT(s,3)|0;b[E>>0]=b[454985]|0;b[E+1>>0]=b[454986]|0;b[E+2>>0]=b[454987]|0;n[t>>2]=9.999999974752427e-07;eIa(m,s,t)|0;uT(s);f[s+40>>2]=0;f[s+44>>2]=0;E=s+40|0;H=s+36|0;d=s;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[H>>2]=E;E=s+48|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[l>>2]=f[g>>2];F5(v,454989,l);E=f[v>>2]|0;H=f[v+4>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;if(H>>>0>4294967279)dEc(t);if(H>>>0<11){b[t+11>>0]=H;if(!H)I=t;else{J=t;A=33}}else{z=H+16&-16;x=VDc(z)|0;f[t>>2]=x;f[t+8>>2]=z|-2147483648;f[t+4>>2]=H;J=x;A=33}if((A|0)==33){dJc(J|0,E|0,H|0)|0;I=J}b[I+H>>0]=0;uT(v);iEc(s,t)|0;v=f[i>>2]|0;H=m+36|0;I=f[H>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if(I>>>0>4294967279)dEc(l);if(I>>>0<11){b[l+11>>0]=I;if(!I)K=l;else{L=l;A=39}}else{J=I+16&-16;E=VDc(J)|0;f[l>>2]=E;f[l+8>>2]=J|-2147483648;f[l+4>>2]=I;L=E;A=39}if((A|0)==39){dJc(L|0,v|0,I|0)|0;K=L}b[K+I>>0]=0;iEc(s+12|0,l)|0;if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);pIa(s+36|0,m)|0;XGa(s+48|0,f[r>>2]|0,f[m+16>>2]|0);r=s+60|0;uT(r);l=f[G>>2]|0;if(!l)M=0;else{I=l+-4|0;f[I>>2]=(f[I>>2]|0)+1;M=f[G>>2]|0}f[r>>2]=M;f[s+64>>2]=f[m+28>>2];M=s+68|0;uT(M);r=f[i>>2]|0;if(!r)N=0;else{G=r+-4|0;f[G>>2]=(f[G>>2]|0)+1;N=f[i>>2]|0}f[M>>2]=N;f[s+72>>2]=f[H>>2];H=s+28|0;N=f[H>>2]|0;if((N|0)==(f[s+32>>2]|0))e1(s+24|0,y);else{fEc(N,y);f[H>>2]=(f[H>>2]|0)+12}iEc(y,t)|0;H=f[a>>2]|0;N=H+16|0;M=f[N>>2]|0;if((M|0)==(f[H+20>>2]|0))jBb(H+12|0,s);else{hLa(M,s);f[N>>2]=(f[N>>2]|0)+76}if((b[t+11>>0]|0)<0)YDc(f[t>>2]|0);fLa(s);HFa(m)}if(j|0){f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=m+4;j=m+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[s>>2]=0;f[s+4>>2]=0;d=tT(s,14)|0;D=454995;c=d+14|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));n[t>>2]=.10000000149011612;eIa(m,s,t)|0;uT(s);N=m+24|0;uT(N);d=tT(N,9)|0;D=455010;c=d+9|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));D=m+32|0;uT(D);M=tT(D,4)|0;b[M>>0]=82;b[M+1>>0]=101;b[M+2>>0]=76;b[M+3>>0]=85;f[s+40>>2]=0;f[s+44>>2]=0;M=s+40|0;H=s+36|0;d=s;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[H>>2]=M;M=s+48|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[M+16>>2]=0;f[M+20>>2]=0;f[M+24>>2]=0;f[k>>2]=f[g>>2];F5(w,455020,k);M=f[w>>2]|0;H=f[w+4>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;if(H>>>0>4294967279)dEc(t);if(H>>>0<11){b[t+11>>0]=H;if(!H)O=t;else{P=t;A=61}}else{d=H+16&-16;c=VDc(d)|0;f[t>>2]=c;f[t+8>>2]=d|-2147483648;f[t+4>>2]=H;P=c;A=61}if((A|0)==61){dJc(P|0,M|0,H|0)|0;O=P}b[O+H>>0]=0;uT(w);iEc(s,t)|0;w=f[D>>2]|0;H=m+36|0;O=f[H>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(O>>>0>4294967279)dEc(k);if(O>>>0<11){b[k+11>>0]=O;if(!O)Q=k;else{R=k;A=67}}else{P=O+16&-16;M=VDc(P)|0;f[k>>2]=M;f[k+8>>2]=P|-2147483648;f[k+4>>2]=O;R=M;A=67}if((A|0)==67){dJc(R|0,w|0,O|0)|0;Q=R}b[Q+O>>0]=0;iEc(s+12|0,k)|0;if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);pIa(s+36|0,m)|0;XGa(s+48|0,f[j>>2]|0,f[m+16>>2]|0);j=s+60|0;uT(j);k=f[N>>2]|0;if(!k)S=0;else{O=k+-4|0;f[O>>2]=(f[O>>2]|0)+1;S=f[N>>2]|0}f[j>>2]=S;f[s+64>>2]=f[m+28>>2];S=s+68|0;uT(S);j=f[D>>2]|0;if(!j)T=0;else{N=j+-4|0;f[N>>2]=(f[N>>2]|0)+1;T=f[D>>2]|0}f[S>>2]=T;f[s+72>>2]=f[H>>2];H=s+28|0;T=f[H>>2]|0;if((T|0)==(f[s+32>>2]|0))e1(s+24|0,y);else{fEc(T,y);f[H>>2]=(f[H>>2]|0)+12}iEc(y,t)|0;H=f[a>>2]|0;T=H+16|0;S=f[T>>2]|0;if((S|0)==(f[H+20>>2]|0))jBb(H+12|0,s);else{hLa(S,s);f[T>>2]=(f[T>>2]|0)+76}if((b[t+11>>0]|0)<0)YDc(f[t>>2]|0);fLa(s);HFa(m)}f[g>>2]=(f[g>>2]|0)+1;g=a+24|0;m=f[g>>2]|0;if((m|0)==(f[a+28>>2]|0))e1(a+20|0,y);else{fEc(m,y);f[g>>2]=(f[g>>2]|0)+12}if((b[q+11>>0]|0)>=0){fLa(p);HFa(o);u=h;return}YDc(f[q>>2]|0);fLa(p);HFa(o);u=h;return}function YAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+160|0;h=g;i=g+112|0;j=g+36|0;k=g+24|0;l=g+16|0;f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=i+4;m=i+12|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[j>>2]=0;f[j+4>>2]=0;n=tT(j,4)|0;b[n>>0]=112;b[n+1>>0]=111;b[n+2>>0]=111;b[n+3>>0]=108;f[k>>2]=0;f[k+4>>2]=0;n=tT(k,3)|0;b[n>>0]=b[454907]|0;b[n+1>>0]=b[454908]|0;b[n+2>>0]=b[454909]|0;yKa(i,j,k)|0;uT(k);uT(j);f[j>>2]=0;f[j+4>>2]=0;n=tT(j,11)|0;o=454911;p=n+11|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));f[k>>2]=c;$Ha(i,j,k)|0;uT(j);f[j>>2]=0;f[j+4>>2]=0;c=tT(j,3)|0;b[c>>0]=b[453999]|0;b[c+1>>0]=b[454e3]|0;b[c+2>>0]=b[454001]|0;f[k>>2]=d;$Ha(i,j,k)|0;uT(j);f[j>>2]=0;f[j+4>>2]=0;d=tT(j,6)|0;b[d>>0]=b[454003]|0;b[d+1>>0]=b[454004]|0;b[d+2>>0]=b[454005]|0;b[d+3>>0]=b[454006]|0;b[d+4>>0]=b[454007]|0;b[d+5>>0]=b[454008]|0;f[k>>2]=e;$Ha(i,j,k)|0;uT(j);f[j>>2]=0;f[j+4>>2]=0;e=tT(j,8)|0;d=e;b[d>>0]=112;b[d+1>>0]=97;b[d+2>>0]=100;b[d+3>>0]=95;d=e+4|0;b[d>>0]=109;b[d+1>>0]=111;b[d+2>>0]=100;b[d+3>>0]=101;f[k>>2]=0;f[k+4>>2]=0;d=tT(k,4)|0;b[d>>0]=83;b[d+1>>0]=65;b[d+2>>0]=77;b[d+3>>0]=69;yKa(i,j,k)|0;uT(k);uT(j);d=i+24|0;uT(d);n=tT(d,12)|0;o=454875;p=n+12|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));o=i+32|0;uT(o);e=tT(o,7)|0;b[e>>0]=b[454888]|0;b[e+1>>0]=b[454889]|0;b[e+2>>0]=b[454890]|0;b[e+3>>0]=b[454891]|0;b[e+4>>0]=b[454892]|0;b[e+5>>0]=b[454893]|0;b[e+6>>0]=b[454894]|0;f[j+40>>2]=0;f[j+44>>2]=0;e=j+40|0;c=j+36|0;n=j;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[c>>2]=e;e=j+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;e=a+4|0;f[h>>2]=f[e>>2];F5(l,454923,h);c=f[l>>2]|0;n=f[l+4>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(n>>>0>4294967279)dEc(k);if(n>>>0<11){b[k+11>>0]=n;if(!n)q=k;else{r=k;s=6}}else{p=n+16&-16;t=VDc(p)|0;f[k>>2]=t;f[k+8>>2]=p|-2147483648;f[k+4>>2]=n;r=t;s=6}if((s|0)==6){dJc(r|0,c|0,n|0)|0;q=r}b[q+n>>0]=0;uT(l);iEc(j,k)|0;l=f[o>>2]|0;n=i+36|0;q=f[n>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(q>>>0>4294967279)dEc(h);if(q>>>0<11){b[h+11>>0]=q;if(!q)v=h;else{w=h;s=12}}else{r=q+16&-16;c=VDc(r)|0;f[h>>2]=c;f[h+8>>2]=r|-2147483648;f[h+4>>2]=q;w=c;s=12}if((s|0)==12){dJc(w|0,l|0,q|0)|0;v=w}b[v+q>>0]=0;iEc(j+12|0,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);pIa(j+36|0,i)|0;XGa(j+48|0,f[m>>2]|0,f[i+16>>2]|0);m=j+60|0;uT(m);h=f[d>>2]|0;if(!h)x=0;else{q=h+-4|0;f[q>>2]=(f[q>>2]|0)+1;x=f[d>>2]|0}f[m>>2]=x;f[j+64>>2]=f[i+28>>2];x=j+68|0;uT(x);m=f[o>>2]|0;if(!m)y=0;else{d=m+-4|0;f[d>>2]=(f[d>>2]|0)+1;y=f[o>>2]|0}f[x>>2]=y;f[j+72>>2]=f[n>>2];n=a+8|0;y=j+28|0;x=f[y>>2]|0;if((x|0)==(f[j+32>>2]|0))e1(j+24|0,n);else{fEc(x,n);f[y>>2]=(f[y>>2]|0)+12}iEc(n,k)|0;y=f[a>>2]|0;x=y+16|0;o=f[x>>2]|0;if((o|0)==(f[y+20>>2]|0))jBb(y+12|0,j);else{hLa(o,j);f[x>>2]=(f[x>>2]|0)+76}f[e>>2]=(f[e>>2]|0)+1;e=a+24|0;x=f[e>>2]|0;if((x|0)==(f[a+28>>2]|0))e1(a+20|0,n);else{fEc(x,n);f[e>>2]=(f[e>>2]|0)+12}if((b[k+11>>0]|0)>=0){fLa(j);HFa(i);u=g;return}YDc(f[k>>2]|0);fLa(j);HFa(i);u=g;return}function ZAb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+160|0;d=c;e=c+112|0;g=c+36|0;h=c+24|0;i=c+16|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=e+4;j=e+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[g>>2]=0;f[g+4>>2]=0;k=tT(g,4)|0;b[k>>0]=112;b[k+1>>0]=111;b[k+2>>0]=111;b[k+3>>0]=108;f[h>>2]=0;f[h+4>>2]=0;k=tT(h,3)|0;b[k>>0]=b[454856]|0;b[k+1>>0]=b[454857]|0;b[k+2>>0]=b[454858]|0;yKa(e,g,h)|0;uT(h);uT(g);f[g>>2]=0;f[g+4>>2]=0;k=tT(g,14)|0;l=454860;m=k+14|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[h>>0]=1;rIa(e,g,h)|0;uT(g);n=e+24|0;uT(n);k=tT(n,12)|0;l=454875;m=k+12|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));l=e+32|0;uT(l);o=tT(l,7)|0;b[o>>0]=b[454888]|0;b[o+1>>0]=b[454889]|0;b[o+2>>0]=b[454890]|0;b[o+3>>0]=b[454891]|0;b[o+4>>0]=b[454892]|0;b[o+5>>0]=b[454893]|0;b[o+6>>0]=b[454894]|0;f[g+40>>2]=0;f[g+44>>2]=0;o=g+40|0;p=g+36|0;k=g;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[p>>2]=o;o=g+48|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;o=a+4|0;f[d>>2]=f[o>>2];F5(i,454896,d);p=f[i>>2]|0;k=f[i+4>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)dEc(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)q=h;else{r=h;s=6}}else{m=k+16&-16;t=VDc(m)|0;f[h>>2]=t;f[h+8>>2]=m|-2147483648;f[h+4>>2]=k;r=t;s=6}if((s|0)==6){dJc(r|0,p|0,k|0)|0;q=r}b[q+k>>0]=0;uT(i);iEc(g,h)|0;i=f[l>>2]|0;k=e+36|0;q=f[k>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;if(q>>>0>4294967279)dEc(d);if(q>>>0<11){b[d+11>>0]=q;if(!q)v=d;else{w=d;s=12}}else{r=q+16&-16;p=VDc(r)|0;f[d>>2]=p;f[d+8>>2]=r|-2147483648;f[d+4>>2]=q;w=p;s=12}if((s|0)==12){dJc(w|0,i|0,q|0)|0;v=w}b[v+q>>0]=0;iEc(g+12|0,d)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);pIa(g+36|0,e)|0;XGa(g+48|0,f[j>>2]|0,f[e+16>>2]|0);j=g+60|0;uT(j);d=f[n>>2]|0;if(!d)x=0;else{q=d+-4|0;f[q>>2]=(f[q>>2]|0)+1;x=f[n>>2]|0}f[j>>2]=x;f[g+64>>2]=f[e+28>>2];x=g+68|0;uT(x);j=f[l>>2]|0;if(!j)y=0;else{n=j+-4|0;f[n>>2]=(f[n>>2]|0)+1;y=f[l>>2]|0}f[x>>2]=y;f[g+72>>2]=f[k>>2];k=a+8|0;y=g+28|0;x=f[y>>2]|0;if((x|0)==(f[g+32>>2]|0))e1(g+24|0,k);else{fEc(x,k);f[y>>2]=(f[y>>2]|0)+12}iEc(k,h)|0;y=f[a>>2]|0;x=y+16|0;l=f[x>>2]|0;if((l|0)==(f[y+20>>2]|0))jBb(y+12|0,g);else{hLa(l,g);f[x>>2]=(f[x>>2]|0)+76}f[o>>2]=(f[o>>2]|0)+1;o=a+24|0;x=f[o>>2]|0;if((x|0)==(f[a+28>>2]|0))e1(a+20|0,k);else{fEc(x,k);f[o>>2]=(f[o>>2]|0)+12}if((b[h+11>>0]|0)>=0){fLa(g);HFa(e);u=c;return}YDc(f[h>>2]|0);fLa(g);HFa(e);u=c;return}function _Ab(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+160|0;d=c;e=c+112|0;g=c+36|0;h=c+24|0;i=c+16|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=e+4;j=e+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;k=e+24|0;uT(k);l=tT(k,12)|0;m=454824;n=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));m=e+32|0;uT(m);o=tT(m,7)|0;b[o>>0]=b[454837]|0;b[o+1>>0]=b[454838]|0;b[o+2>>0]=b[454839]|0;b[o+3>>0]=b[454840]|0;b[o+4>>0]=b[454841]|0;b[o+5>>0]=b[454842]|0;b[o+6>>0]=b[454843]|0;f[g+40>>2]=0;f[g+44>>2]=0;o=g+40|0;p=g+36|0;l=g;n=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));f[p>>2]=o;o=g+48|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;o=a+4|0;f[d>>2]=f[o>>2];F5(i,454845,d);p=f[i>>2]|0;l=f[i+4>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(l>>>0>4294967279)dEc(h);if(l>>>0<11){b[h+11>>0]=l;if(!l)q=h;else{r=h;s=6}}else{n=l+16&-16;t=VDc(n)|0;f[h>>2]=t;f[h+8>>2]=n|-2147483648;f[h+4>>2]=l;r=t;s=6}if((s|0)==6){dJc(r|0,p|0,l|0)|0;q=r}b[q+l>>0]=0;uT(i);iEc(g,h)|0;i=f[m>>2]|0;l=e+36|0;q=f[l>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;if(q>>>0>4294967279)dEc(d);if(q>>>0<11){b[d+11>>0]=q;if(!q)v=d;else{w=d;s=12}}else{r=q+16&-16;p=VDc(r)|0;f[d>>2]=p;f[d+8>>2]=r|-2147483648;f[d+4>>2]=q;w=p;s=12}if((s|0)==12){dJc(w|0,i|0,q|0)|0;v=w}b[v+q>>0]=0;iEc(g+12|0,d)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);pIa(g+36|0,e)|0;XGa(g+48|0,f[j>>2]|0,f[e+16>>2]|0);j=g+60|0;uT(j);d=f[k>>2]|0;if(!d)x=0;else{q=d+-4|0;f[q>>2]=(f[q>>2]|0)+1;x=f[k>>2]|0}f[j>>2]=x;f[g+64>>2]=f[e+28>>2];x=g+68|0;uT(x);j=f[m>>2]|0;if(!j)y=0;else{k=j+-4|0;f[k>>2]=(f[k>>2]|0)+1;y=f[m>>2]|0}f[x>>2]=y;f[g+72>>2]=f[l>>2];l=a+8|0;y=g+28|0;x=f[y>>2]|0;if((x|0)==(f[g+32>>2]|0))e1(g+24|0,l);else{fEc(x,l);f[y>>2]=(f[y>>2]|0)+12}iEc(l,h)|0;y=f[a>>2]|0;x=y+16|0;m=f[x>>2]|0;if((m|0)==(f[y+20>>2]|0))jBb(y+12|0,g);else{hLa(m,g);f[x>>2]=(f[x>>2]|0)+76}f[o>>2]=(f[o>>2]|0)+1;o=a+24|0;x=f[o>>2]|0;if((x|0)==(f[a+28>>2]|0))e1(a+20|0,l);else{fEc(x,l);f[o>>2]=(f[o>>2]|0)+12}if((b[h+11>>0]|0)>=0){fLa(g);HFa(e);u=c;return}YDc(f[h>>2]|0);fLa(g);HFa(e);u=c;return}function $Ab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+320|0;e=d+168|0;g=d+152|0;h=d+8|0;i=d;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;k=e+64|0;l=e+8|0;f[l>>2]=45704;m=e+12|0;f[e>>2]=6980;f[k>>2]=7e3;f[e+4>>2]=0;auc(e+64|0,m);f[e+136>>2]=0;f[e+140>>2]=-1;f[e>>2]=45684;f[k>>2]=45724;f[l>>2]=45704;fuc(m);f[m>>2]=45740;l=e+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[e+60>>2]=24;G1(m,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=h+64|0;m=h+8|0;l=h+12|0;k=h+4|0;n=h+64|0;o=h+136|0;p=h+140|0;q=h+44|0;r=h+60|0;s=a+8|0;while(1){t=RAb(e,g,44)|0;v=(f[t+(f[(f[t>>2]|0)+-12>>2]|0)+16>>2]&5|0)!=0;if(!((v?0:0)&1|(v?0:1768)))break;f[m>>2]=45704;f[h>>2]=6980;f[c>>2]=7e3;f[k>>2]=0;auc(n,l);f[o>>2]=0;f[p>>2]=-1;f[h>>2]=45684;f[c>>2]=45724;f[m>>2]=45704;fuc(l);f[l>>2]=45740;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[r>>2]=24;G1(l,g);luc(h,i)|0;v=f[j>>2]|0;if((v|0)==(f[s>>2]|0))g6(a,i);else{f[v>>2]=f[i>>2];f[j>>2]=v+4}K1(h)}if((b[g+11>>0]|0)>=0){K1(e);u=d;return}YDc(f[g>>2]|0);K1(e);u=d;return}function aBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+160|0;e=d;g=d+112|0;h=d+36|0;i=d+24|0;j=d+16|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=g+4;k=g+12|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;l=g+24|0;uT(l);m=tT(l,13)|0;n=454798;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));n=g+32|0;uT(n);p=tT(n,8)|0;q=p;b[q>>0]=73;b[q+1>>0]=100;b[q+2>>0]=101;b[q+3>>0]=110;q=p+4|0;b[q>>0]=116;b[q+1>>0]=105;b[q+2>>0]=116;b[q+3>>0]=121;f[h+40>>2]=0;f[h+44>>2]=0;q=h+40|0;p=h+36|0;m=h;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[p>>2]=q;q=h+48|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;q=a+4|0;f[e>>2]=f[q>>2];F5(j,454812,e);p=f[j>>2]|0;m=f[j+4>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(m>>>0>4294967279)dEc(i);if(m>>>0<11){b[i+11>>0]=m;if(!m)r=i;else{s=i;t=6}}else{o=m+16&-16;v=VDc(o)|0;f[i>>2]=v;f[i+8>>2]=o|-2147483648;f[i+4>>2]=m;s=v;t=6}if((t|0)==6){dJc(s|0,p|0,m|0)|0;r=s}b[r+m>>0]=0;uT(j);iEc(h,i)|0;j=f[n>>2]|0;m=g+36|0;r=f[m>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(r>>>0>4294967279)dEc(e);if(r>>>0<11){b[e+11>>0]=r;if(!r)w=e;else{x=e;t=12}}else{s=r+16&-16;p=VDc(s)|0;f[e>>2]=p;f[e+8>>2]=s|-2147483648;f[e+4>>2]=r;x=p;t=12}if((t|0)==12){dJc(x|0,j|0,r|0)|0;w=x}b[w+r>>0]=0;iEc(h+12|0,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);pIa(h+36|0,g)|0;XGa(h+48|0,f[k>>2]|0,f[g+16>>2]|0);k=h+60|0;uT(k);e=f[l>>2]|0;if(!e)y=0;else{r=e+-4|0;f[r>>2]=(f[r>>2]|0)+1;y=f[l>>2]|0}f[k>>2]=y;f[h+64>>2]=f[g+28>>2];y=h+68|0;uT(y);k=f[n>>2]|0;if(!k)z=0;else{l=k+-4|0;f[l>>2]=(f[l>>2]|0)+1;z=f[n>>2]|0}f[y>>2]=z;f[h+72>>2]=f[m>>2];m=a+20|0;z=a+24|0;y=f[m>>2]|0;if((((f[z>>2]|0)-y|0)/12|0)>>>0<=c>>>0)nCc(m);n=y+(c*12|0)|0;c=h+28|0;y=f[c>>2]|0;if((y|0)==(f[h+32>>2]|0))e1(h+24|0,n);else{fEc(y,n);f[c>>2]=(f[c>>2]|0)+12}c=a+8|0;iEc(c,i)|0;n=f[a>>2]|0;y=n+16|0;l=f[y>>2]|0;if((l|0)==(f[n+20>>2]|0))jBb(n+12|0,h);else{hLa(l,h);f[y>>2]=(f[y>>2]|0)+76}f[q>>2]=(f[q>>2]|0)+1;q=f[z>>2]|0;if((q|0)==(f[a+28>>2]|0))e1(m,c);else{fEc(q,c);f[z>>2]=(f[z>>2]|0)+12}if((b[i+11>>0]|0)>=0){fLa(h);HFa(g);u=d;return}YDc(f[i>>2]|0);fLa(h);HFa(g);u=d;return}function bBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+160|0;g=e;h=e+112|0;i=e+36|0;j=e+24|0;k=e+16|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=h+4;l=h+12|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;m=h+24|0;uT(m);n=tT(m,11)|0;o=454769;p=n+11|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));o=h+32|0;uT(o);q=tT(o,6)|0;b[q>>0]=b[454781]|0;b[q+1>>0]=b[454782]|0;b[q+2>>0]=b[454783]|0;b[q+3>>0]=b[454784]|0;b[q+4>>0]=b[454785]|0;b[q+5>>0]=b[454786]|0;f[i>>2]=0;f[i+4>>2]=0;q=tT(i,4)|0;b[q>>0]=97;b[q+1>>0]=120;b[q+2>>0]=105;b[q+3>>0]=115;f[j>>2]=1;$Ha(h,i,j)|0;uT(i);f[i+40>>2]=0;f[i+44>>2]=0;q=i+40|0;r=i+36|0;n=i;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[r>>2]=q;q=i+48|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;q=a+4|0;f[g>>2]=f[q>>2];F5(k,454788,g);r=f[k>>2]|0;n=f[k+4>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)dEc(j);if(n>>>0<11){b[j+11>>0]=n;if(!n)s=j;else{t=j;v=6}}else{p=n+16&-16;w=VDc(p)|0;f[j>>2]=w;f[j+8>>2]=p|-2147483648;f[j+4>>2]=n;t=w;v=6}if((v|0)==6){dJc(t|0,r|0,n|0)|0;s=t}b[s+n>>0]=0;uT(k);iEc(i,j)|0;k=f[o>>2]|0;n=h+36|0;s=f[n>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(s>>>0>4294967279)dEc(g);if(s>>>0<11){b[g+11>>0]=s;if(!s)x=g;else{y=g;v=12}}else{t=s+16&-16;r=VDc(t)|0;f[g>>2]=r;f[g+8>>2]=t|-2147483648;f[g+4>>2]=s;y=r;v=12}if((v|0)==12){dJc(y|0,k|0,s|0)|0;x=y}b[x+s>>0]=0;iEc(i+12|0,g)|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);pIa(i+36|0,h)|0;XGa(i+48|0,f[l>>2]|0,f[h+16>>2]|0);l=i+60|0;uT(l);g=f[m>>2]|0;if(!g)z=0;else{s=g+-4|0;f[s>>2]=(f[s>>2]|0)+1;z=f[m>>2]|0}f[l>>2]=z;f[i+64>>2]=f[h+28>>2];z=i+68|0;uT(z);l=f[o>>2]|0;if(!l)A=0;else{m=l+-4|0;f[m>>2]=(f[m>>2]|0)+1;A=f[o>>2]|0}f[z>>2]=A;f[i+72>>2]=f[n>>2];a:do if((c|0)>0){n=a+20|0;A=a+24|0;z=i+28|0;o=i+32|0;m=i+24|0;l=0;while(1){s=f[d+(l<<2)>>2]|0;g=f[n>>2]|0;if((((f[A>>2]|0)-g|0)/12|0)>>>0<=s>>>0)break;x=g+(s*12|0)|0;s=f[z>>2]|0;if((s|0)==(f[o>>2]|0))e1(m,x);else{fEc(s,x);f[z>>2]=(f[z>>2]|0)+12}l=l+1|0;if((l|0)>=(c|0))break a}nCc(n)}while(0);c=a+8|0;iEc(c,j)|0;d=f[a>>2]|0;l=d+16|0;z=f[l>>2]|0;if((z|0)==(f[d+20>>2]|0))jBb(d+12|0,i);else{hLa(z,i);f[l>>2]=(f[l>>2]|0)+76}f[q>>2]=(f[q>>2]|0)+1;q=a+24|0;l=f[q>>2]|0;if((l|0)==(f[a+28>>2]|0))e1(a+20|0,c);else{fEc(l,c);f[q>>2]=(f[q>>2]|0)+12}if((b[j+11>>0]|0)>=0){fLa(i);HFa(h);u=e;return}YDc(f[j>>2]|0);fLa(i);HFa(h);u=e;return}function cBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+160|0;e=d;g=d+112|0;h=d+120|0;i=d+36|0;j=d+24|0;k=d+16|0;f[g>>2]=c;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=h+4;c=h+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;l=h+24|0;uT(l);m=tT(l,10)|0;n=454730;o=m+10|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=h+32|0;uT(p);q=tT(p,5)|0;b[q>>0]=b[454741]|0;b[q+1>>0]=b[454742]|0;b[q+2>>0]=b[454743]|0;b[q+3>>0]=b[454744]|0;b[q+4>>0]=b[454745]|0;f[i>>2]=0;f[i+4>>2]=0;m=tT(i,12)|0;n=454747;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));$Ha(h,i,g)|0;uT(i);f[i+40>>2]=0;f[i+44>>2]=0;g=i+40|0;n=i+36|0;m=i;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[n>>2]=g;g=i+48|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;g=a+4|0;f[e>>2]=f[g>>2];F5(k,454760,e);n=f[k>>2]|0;m=f[k+4>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(m>>>0>4294967279)dEc(j);if(m>>>0<11){b[j+11>>0]=m;if(!m)r=j;else{s=j;t=6}}else{o=m+16&-16;q=VDc(o)|0;f[j>>2]=q;f[j+8>>2]=o|-2147483648;f[j+4>>2]=m;s=q;t=6}if((t|0)==6){dJc(s|0,n|0,m|0)|0;r=s}b[r+m>>0]=0;uT(k);iEc(i,j)|0;k=f[p>>2]|0;m=h+36|0;r=f[m>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(r>>>0>4294967279)dEc(e);if(r>>>0<11){b[e+11>>0]=r;if(!r)v=e;else{w=e;t=12}}else{s=r+16&-16;n=VDc(s)|0;f[e>>2]=n;f[e+8>>2]=s|-2147483648;f[e+4>>2]=r;w=n;t=12}if((t|0)==12){dJc(w|0,k|0,r|0)|0;v=w}b[v+r>>0]=0;iEc(i+12|0,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);pIa(i+36|0,h)|0;XGa(i+48|0,f[c>>2]|0,f[h+16>>2]|0);c=i+60|0;uT(c);e=f[l>>2]|0;if(!e)x=0;else{r=e+-4|0;f[r>>2]=(f[r>>2]|0)+1;x=f[l>>2]|0}f[c>>2]=x;f[i+64>>2]=f[h+28>>2];x=i+68|0;uT(x);c=f[p>>2]|0;if(!c)y=0;else{l=c+-4|0;f[l>>2]=(f[l>>2]|0)+1;y=f[p>>2]|0}f[x>>2]=y;f[i+72>>2]=f[m>>2];m=a+8|0;y=i+28|0;x=f[y>>2]|0;if((x|0)==(f[i+32>>2]|0))e1(i+24|0,m);else{fEc(x,m);f[y>>2]=(f[y>>2]|0)+12}iEc(m,j)|0;y=f[a>>2]|0;x=y+16|0;p=f[x>>2]|0;if((p|0)==(f[y+20>>2]|0))jBb(y+12|0,i);else{hLa(p,i);f[x>>2]=(f[x>>2]|0)+76}f[g>>2]=(f[g>>2]|0)+1;g=a+24|0;x=f[g>>2]|0;if((x|0)==(f[a+28>>2]|0))e1(a+20|0,m);else{fEc(x,m);f[g>>2]=(f[g>>2]|0)+12}if((b[j+11>>0]|0)>=0){fLa(i);HFa(h);u=d;return}YDc(f[j>>2]|0);fLa(i);HFa(h);u=d;return}function dBb(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0.0,j=0;d=u;u=u+160|0;e=d;g=d+8|0;n[e>>2]=c;h=kBb(a,b)|0;if((h|0)==(a+4|0)){i=c;u=d;return +i}a=g+64|0;b=g+8|0;f[b>>2]=45704;j=g+12|0;f[g>>2]=6980;f[a>>2]=7e3;f[g+4>>2]=0;auc(g+64|0,j);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=45684;f[a>>2]=45724;f[b>>2]=45704;fuc(j);f[j>>2]=45740;b=g+44|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[g+60>>2]=24;G1(j,h+28|0);nuc(g,e)|0;K1(g);i=+n[e>>2];u=d;return +i}function eBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+160|0;e=d;g=d+120|0;h=d+112|0;i=d+32|0;j=d+12|0;k=d+24|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=g+4;l=g+12|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;m=g+24|0;uT(m);n=tT(m,12)|0;o=454692;p=n+12|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));o=g+32|0;uT(o);q=tT(o,7)|0;b[q>>0]=b[454705]|0;b[q+1>>0]=b[454706]|0;b[q+2>>0]=b[454707]|0;b[q+3>>0]=b[454708]|0;b[q+4>>0]=b[454709]|0;b[q+5>>0]=b[454710]|0;b[q+6>>0]=b[454711]|0;q=VDc(16)|0;f[q>>2]=q+8;f[q+4>>2]=4;r=XDc(32)|0;f[q>>2]=r;f[h>>2]=0;f[h+4>>2]=q;q=r;f[q>>2]=0;f[q+4>>2]=0;q=r+8|0;f[q>>2]=2;f[q+4>>2]=0;q=r+16|0;f[q>>2]=3;f[q+4>>2]=0;q=r+24|0;f[q>>2]=1;f[q+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;q=tT(i,5)|0;b[q>>0]=b[454713]|0;b[q+1>>0]=b[454714]|0;b[q+2>>0]=b[454715]|0;b[q+3>>0]=b[454716]|0;b[q+4>>0]=b[454717]|0;bIa(g,i,h)|0;uT(i);f[i+40>>2]=0;f[i+44>>2]=0;q=i+40|0;r=i+36|0;n=i;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[r>>2]=q;q=i+48|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;q=a+4|0;f[e>>2]=f[q>>2];F5(k,454719,e);r=f[k>>2]|0;n=f[k+4>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)dEc(j);if(n>>>0<11){b[j+11>>0]=n;if(!n)s=j;else{t=j;v=6}}else{p=n+16&-16;w=VDc(p)|0;f[j>>2]=w;f[j+8>>2]=p|-2147483648;f[j+4>>2]=n;t=w;v=6}if((v|0)==6){dJc(t|0,r|0,n|0)|0;s=t}b[s+n>>0]=0;uT(k);iEc(i,j)|0;k=f[o>>2]|0;n=g+36|0;s=f[n>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(s>>>0>4294967279)dEc(e);if(s>>>0<11){b[e+11>>0]=s;if(!s)x=e;else{y=e;v=12}}else{t=s+16&-16;r=VDc(t)|0;f[e>>2]=r;f[e+8>>2]=t|-2147483648;f[e+4>>2]=s;y=r;v=12}if((v|0)==12){dJc(y|0,k|0,s|0)|0;x=y}b[x+s>>0]=0;iEc(i+12|0,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);pIa(i+36|0,g)|0;XGa(i+48|0,f[l>>2]|0,f[g+16>>2]|0);l=i+60|0;uT(l);e=f[m>>2]|0;if(!e)z=0;else{s=e+-4|0;f[s>>2]=(f[s>>2]|0)+1;z=f[m>>2]|0}f[l>>2]=z;f[i+64>>2]=f[g+28>>2];z=i+68|0;uT(z);l=f[o>>2]|0;if(!l)A=0;else{m=l+-4|0;f[m>>2]=(f[m>>2]|0)+1;A=f[o>>2]|0}f[z>>2]=A;f[i+72>>2]=f[n>>2];n=a+8|0;A=i+28|0;z=f[A>>2]|0;if((z|0)==(f[i+32>>2]|0))e1(i+24|0,n);else{fEc(z,n);f[A>>2]=(f[A>>2]|0)+12}iEc(n,j)|0;A=f[a>>2]|0;z=A+16|0;o=f[z>>2]|0;if((o|0)==(f[A+20>>2]|0))jBb(A+12|0,i);else{hLa(o,i);f[z>>2]=(f[z>>2]|0)+76}do if(c){f[q>>2]=(f[q>>2]|0)+1;z=a+24|0;o=f[z>>2]|0;if((o|0)==(f[a+28>>2]|0)){e1(a+20|0,n);break}else{fEc(o,n);f[z>>2]=(f[z>>2]|0)+12;break}}while(0);if((b[j+11>>0]|0)>=0){fLa(i);JFa(h);HFa(g);u=d;return}YDc(f[j>>2]|0);fLa(i);JFa(h);HFa(g);u=d;return}function fBb(a,c,d,e,g,h,i,j,k){a=a|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;l=u;u=u+288|0;m=l+200|0;o=l+152|0;p=l+148|0;q=l+144|0;r=l+140|0;s=l+136|0;t=l+160|0;v=l+24|0;w=l+80|0;x=l+12|0;y=l;n[o>>2]=c;f[p>>2]=d;f[q>>2]=e;f[r>>2]=g;f[s>>2]=h;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=t+4;h=t+12|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;g=t+24|0;uT(g);e=tT(g,11)|0;d=454533;z=e+11|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(z|0));A=t+32|0;uT(A);B=tT(A,6)|0;b[B>>0]=b[454545]|0;b[B+1>>0]=b[454546]|0;b[B+2>>0]=b[454547]|0;b[B+3>>0]=b[454548]|0;b[B+4>>0]=b[454549]|0;b[B+5>>0]=b[454550]|0;f[m>>2]=0;f[m+4>>2]=0;B=tT(m,6)|0;b[B>>0]=b[454316]|0;b[B+1>>0]=b[454317]|0;b[B+2>>0]=b[454318]|0;b[B+3>>0]=b[454319]|0;b[B+4>>0]=b[454320]|0;b[B+5>>0]=b[454321]|0;eIa(t,m,o)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;o=tT(m,6)|0;b[o>>0]=b[454323]|0;b[o+1>>0]=b[454324]|0;b[o+2>>0]=b[454325]|0;b[o+3>>0]=b[454326]|0;b[o+4>>0]=b[454327]|0;b[o+5>>0]=b[454328]|0;$Ha(t,m,p)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;p=tT(m,7)|0;b[p>>0]=b[454330]|0;b[p+1>>0]=b[454331]|0;b[p+2>>0]=b[454332]|0;b[p+3>>0]=b[454333]|0;b[p+4>>0]=b[454334]|0;b[p+5>>0]=b[454335]|0;b[p+6>>0]=b[454336]|0;$Ha(t,m,q)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;q=tT(m,7)|0;b[q>>0]=b[453755]|0;b[q+1>>0]=b[453756]|0;b[q+2>>0]=b[453757]|0;b[q+3>>0]=b[453758]|0;b[q+4>>0]=b[453759]|0;b[q+5>>0]=b[453760]|0;b[q+6>>0]=b[453761]|0;$Ha(t,m,r)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;q=tT(m,8)|0;p=q;b[p>>0]=99;b[p+1>>0]=108;b[p+2>>0]=97;b[p+3>>0]=115;p=q+4|0;b[p>>0]=115;b[p+1>>0]=102;b[p+2>>0]=105;b[p+3>>0]=120;$Ha(t,m,s)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;e=tT(m,12)|0;d=454665;z=e+12|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(z|0));b[v>>0]=(j|0)!=0&1;rIa(t,m,v)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;j=tT(m,7)|0;b[j>>0]=b[454214]|0;b[j+1>>0]=b[454215]|0;b[j+2>>0]=b[454216]|0;b[j+3>>0]=b[454217]|0;b[j+4>>0]=b[454218]|0;b[j+5>>0]=b[454219]|0;b[j+6>>0]=b[454220]|0;b[v>>0]=(i|0)!=0&1;rIa(t,m,v)|0;uT(m);Vj(w,1,f[r>>2]<<1,5,k,0);f[v>>2]=1124007936;k=v+4|0;r=v+8|0;i=v+40|0;e=k;z=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(z|0));f[i>>2]=r;j=v+48|0;s=v+44|0;f[s>>2]=j;f[j>>2]=0;f[v+52>>2]=0;p=m+8|0;f[p>>2]=0;f[p+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=v;h_(w,m);p=w+36|0;q=f[p>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)_S(w);f[p>>2]=0;p=w+16|0;q=w+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[w+40>>2]|0;o=0;do{f[p+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[q>>2]|0))}q=f[w+44>>2]|0;if((q|0)!=(w+48|0))g0(q);q=t+16|0;w=f[q>>2]|0;if((w|0)==(f[t+20>>2]|0))Bxa(t+12|0,v);else{f[w>>2]=f[v>>2];o=w+4|0;f[o>>2]=f[k>>2];p=w+8|0;f[p>>2]=f[r>>2];f[w+12>>2]=f[v+12>>2];f[w+16>>2]=f[v+16>>2];f[w+20>>2]=f[v+20>>2];f[w+24>>2]=f[v+24>>2];f[w+28>>2]=f[v+28>>2];f[w+32>>2]=f[v+32>>2];r=f[v+36>>2]|0;f[w+36>>2]=r;f[w+40>>2]=p;p=w+48|0;B=w+44|0;f[B>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(r|0){p=r+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[k>>2]|0)<3){p=f[s>>2]|0;r=f[B>>2]|0;f[r>>2]=f[p>>2];f[r+4>>2]=f[p+4>>2]}else{f[o>>2]=0;ZS(w,v)}f[q>>2]=(f[q>>2]|0)+56}f[m+40>>2]=0;f[m+44>>2]=0;w=m+40|0;o=m+36|0;e=m;z=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(z|0));f[o>>2]=w;w=m+48|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;f[w+24>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;w=VDc(16)|0;f[x>>2]=w;f[x+8>>2]=-2147483632;f[x+4>>2]=13;e=w;d=454678;z=e+13|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(z|0));b[w+13>>0]=0;iEc(m,x)|0;w=f[A>>2]|0;d=t+36|0;e=f[d>>2]|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;if(e>>>0>4294967279)dEc(y);if(e>>>0<11){b[y+11>>0]=e;if(!e)C=y;else{D=y;E=22}}else{z=e+16&-16;o=VDc(z)|0;f[y>>2]=o;f[y+8>>2]=z|-2147483648;f[y+4>>2]=e;D=o;E=22}if((E|0)==22){dJc(D|0,w|0,e|0)|0;C=D}b[C+e>>0]=0;iEc(m+12|0,y)|0;if((b[y+11>>0]|0)<0)YDc(f[y>>2]|0);pIa(m+36|0,t)|0;XGa(m+48|0,f[h>>2]|0,f[q>>2]|0);q=m+60|0;uT(q);h=f[g>>2]|0;if(!h)F=0;else{y=h+-4|0;f[y>>2]=(f[y>>2]|0)+1;F=f[g>>2]|0}f[q>>2]=F;f[m+64>>2]=f[t+28>>2];F=m+68|0;uT(F);q=f[A>>2]|0;if(!q)G=0;else{g=q+-4|0;f[g>>2]=(f[g>>2]|0)+1;G=f[A>>2]|0}f[F>>2]=G;f[m+72>>2]=f[d>>2];d=a+8|0;G=m+28|0;F=f[G>>2]|0;if((F|0)==(f[m+32>>2]|0))e1(m+24|0,d);else{fEc(F,d);f[G>>2]=(f[G>>2]|0)+12}iEc(d,x)|0;G=f[a>>2]|0;F=G+16|0;A=f[F>>2]|0;if((A|0)==(f[G+20>>2]|0))jBb(G+12|0,m);else{hLa(A,m);f[F>>2]=(f[F>>2]|0)+76}F=a+4|0;f[F>>2]=(f[F>>2]|0)+1;F=a+24|0;A=f[F>>2]|0;if((A|0)==(f[a+28>>2]|0))e1(a+20|0,d);else{fEc(A,d);f[F>>2]=(f[F>>2]|0)+12}if((b[x+11>>0]|0)<0)YDc(f[x>>2]|0);fLa(m);m=v+36|0;x=f[m>>2]|0;if(x|0?(F=x+12|0,x=f[F>>2]|0,f[F>>2]=x+-1,(x|0)==1):0)_S(v);f[m>>2]=0;m=v+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[i>>2]|0;i=0;do{f[m+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[k>>2]|0))}k=f[s>>2]|0;if((k|0)==(j|0)){HFa(t);u=l;return}g0(k);HFa(t);u=l;return}function gBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+160|0;e=d;g=d+112|0;h=d+36|0;i=d+24|0;j=d+16|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=g+4;k=g+12|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;l=g+24|0;uT(l);m=tT(l,13)|0;n=454627;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));n=g+32|0;uT(n);p=tT(n,7)|0;b[p>>0]=b[454641]|0;b[p+1>>0]=b[454642]|0;b[p+2>>0]=b[454643]|0;b[p+3>>0]=b[454644]|0;b[p+4>>0]=b[454645]|0;b[p+5>>0]=b[454646]|0;b[p+6>>0]=b[454647]|0;f[h>>2]=0;f[h+4>>2]=0;p=tT(h,2)|0;b[p>>0]=111;b[p+1>>0]=112;p=i+4|0;f[p>>2]=0;f[p+4>>2]=0;p=i+11|0;b[p>>0]=3;b[i>>0]=b[454649]|0;b[i+1>>0]=b[454650]|0;b[i+2>>0]=b[454651]|0;b[i+3>>0]=0;fIa(g,h,i)|0;if((b[p>>0]|0)<0)YDc(f[i>>2]|0);uT(h);f[h+40>>2]=0;f[h+44>>2]=0;p=h+40|0;q=h+36|0;m=h;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[q>>2]=p;p=h+48|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;p=a+4|0;f[e>>2]=f[p>>2];F5(j,454653,e);q=f[j>>2]|0;m=f[j+4>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(m>>>0>4294967279)dEc(i);if(m>>>0<11){b[i+11>>0]=m;if(!m)r=i;else{s=i;t=8}}else{o=m+16&-16;v=VDc(o)|0;f[i>>2]=v;f[i+8>>2]=o|-2147483648;f[i+4>>2]=m;s=v;t=8}if((t|0)==8){dJc(s|0,q|0,m|0)|0;r=s}b[r+m>>0]=0;uT(j);iEc(h,i)|0;j=f[n>>2]|0;m=g+36|0;r=f[m>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(r>>>0>4294967279)dEc(e);if(r>>>0<11){b[e+11>>0]=r;if(!r)w=e;else{x=e;t=14}}else{s=r+16&-16;q=VDc(s)|0;f[e>>2]=q;f[e+8>>2]=s|-2147483648;f[e+4>>2]=r;x=q;t=14}if((t|0)==14){dJc(x|0,j|0,r|0)|0;w=x}b[w+r>>0]=0;iEc(h+12|0,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);pIa(h+36|0,g)|0;XGa(h+48|0,f[k>>2]|0,f[g+16>>2]|0);k=h+60|0;uT(k);e=f[l>>2]|0;if(!e)y=0;else{r=e+-4|0;f[r>>2]=(f[r>>2]|0)+1;y=f[l>>2]|0}f[k>>2]=y;f[h+64>>2]=f[g+28>>2];y=h+68|0;uT(y);k=f[n>>2]|0;if(!k)z=0;else{l=k+-4|0;f[l>>2]=(f[l>>2]|0)+1;z=f[n>>2]|0}f[y>>2]=z;f[h+72>>2]=f[m>>2];m=h+24|0;z=a+20|0;y=a+24|0;n=f[z>>2]|0;if((((f[y>>2]|0)-n|0)/12|0)>>>0<=c>>>0)nCc(z);l=n+(c*12|0)|0;c=h+28|0;n=f[c>>2]|0;k=h+32|0;if((n|0)==(f[k>>2]|0)){e1(m,l);A=f[c>>2]|0}else{fEc(n,l);l=(f[c>>2]|0)+12|0;f[c>>2]=l;A=l}l=a+8|0;if((A|0)==(f[k>>2]|0))e1(m,l);else{fEc(A,l);f[c>>2]=(f[c>>2]|0)+12}iEc(l,i)|0;c=f[a>>2]|0;A=c+16|0;m=f[A>>2]|0;if((m|0)==(f[c+20>>2]|0))jBb(c+12|0,h);else{hLa(m,h);f[A>>2]=(f[A>>2]|0)+76}f[p>>2]=(f[p>>2]|0)+1;p=f[y>>2]|0;if((p|0)==(f[a+28>>2]|0))e1(z,l);else{fEc(p,l);f[y>>2]=(f[y>>2]|0)+12}if((b[i+11>>0]|0)>=0){fLa(h);HFa(g);u=d;return}YDc(f[i>>2]|0);fLa(h);HFa(g);u=d;return}function hBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+160|0;e=d;g=d+112|0;h=d+120|0;i=d+36|0;j=d+24|0;k=d+16|0;f[g>>2]=c;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=h+4;c=h+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;l=h+24|0;uT(l);m=tT(l,13)|0;n=454560;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=h+32|0;uT(p);q=tT(p,6)|0;b[q>>0]=b[454574]|0;b[q+1>>0]=b[454575]|0;b[q+2>>0]=b[454576]|0;b[q+3>>0]=b[454577]|0;b[q+4>>0]=b[454578]|0;b[q+5>>0]=b[454579]|0;f[i>>2]=0;f[i+4>>2]=0;m=tT(i,11)|0;n=454581;o=m+11|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));$Ha(h,i,g)|0;uT(i);f[i>>2]=0;f[i+4>>2]=0;m=tT(i,13)|0;n=454593;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));f[j>>2]=0;f[j+4>>2]=0;n=tT(j,7)|0;b[n>>0]=b[454607]|0;b[n+1>>0]=b[454608]|0;b[n+2>>0]=b[454609]|0;b[n+3>>0]=b[454610]|0;b[n+4>>0]=b[454611]|0;b[n+5>>0]=b[454612]|0;b[n+6>>0]=b[454613]|0;yKa(h,i,j)|0;uT(j);uT(i);f[i+40>>2]=0;f[i+44>>2]=0;n=i+40|0;g=i+36|0;m=i;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[g>>2]=n;n=i+48|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;n=a+4|0;f[e>>2]=f[n>>2];F5(k,454615,e);g=f[k>>2]|0;m=f[k+4>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(m>>>0>4294967279)dEc(j);if(m>>>0<11){b[j+11>>0]=m;if(!m)r=j;else{s=j;t=6}}else{o=m+16&-16;q=VDc(o)|0;f[j>>2]=q;f[j+8>>2]=o|-2147483648;f[j+4>>2]=m;s=q;t=6}if((t|0)==6){dJc(s|0,g|0,m|0)|0;r=s}b[r+m>>0]=0;uT(k);iEc(i,j)|0;k=f[p>>2]|0;m=h+36|0;r=f[m>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(r>>>0>4294967279)dEc(e);if(r>>>0<11){b[e+11>>0]=r;if(!r)v=e;else{w=e;t=12}}else{s=r+16&-16;g=VDc(s)|0;f[e>>2]=g;f[e+8>>2]=s|-2147483648;f[e+4>>2]=r;w=g;t=12}if((t|0)==12){dJc(w|0,k|0,r|0)|0;v=w}b[v+r>>0]=0;iEc(i+12|0,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);pIa(i+36|0,h)|0;XGa(i+48|0,f[c>>2]|0,f[h+16>>2]|0);c=i+60|0;uT(c);e=f[l>>2]|0;if(!e)x=0;else{r=e+-4|0;f[r>>2]=(f[r>>2]|0)+1;x=f[l>>2]|0}f[c>>2]=x;f[i+64>>2]=f[h+28>>2];x=i+68|0;uT(x);c=f[p>>2]|0;if(!c)y=0;else{l=c+-4|0;f[l>>2]=(f[l>>2]|0)+1;y=f[p>>2]|0}f[x>>2]=y;f[i+72>>2]=f[m>>2];m=a+8|0;y=i+28|0;x=f[y>>2]|0;if((x|0)==(f[i+32>>2]|0))e1(i+24|0,m);else{fEc(x,m);f[y>>2]=(f[y>>2]|0)+12}iEc(m,j)|0;y=f[a>>2]|0;x=y+16|0;p=f[x>>2]|0;if((p|0)==(f[y+20>>2]|0))jBb(y+12|0,i);else{hLa(p,i);f[x>>2]=(f[x>>2]|0)+76}f[n>>2]=(f[n>>2]|0)+1;n=a+24|0;x=f[n>>2]|0;if((x|0)==(f[a+28>>2]|0))e1(a+20|0,m);else{fEc(x,m);f[n>>2]=(f[n>>2]|0)+12}if((b[j+11>>0]|0)>=0){fLa(i);HFa(h);u=d;return}YDc(f[j>>2]|0);fLa(i);HFa(h);u=d;return}function iBb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+288|0;h=g;i=g+208|0;j=g+164|0;k=g+168|0;l=g+160|0;m=g+88|0;n=g+24|0;o=g+104|0;p=g+12|0;q=g+80|0;f[j>>2]=c;f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=k+4;c=k+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;r=k+24|0;uT(r);s=tT(r,11)|0;t=454533;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));t=k+32|0;uT(t);w=tT(t,6)|0;b[w>>0]=b[454545]|0;b[w+1>>0]=b[454546]|0;b[w+2>>0]=b[454547]|0;b[w+3>>0]=b[454548]|0;b[w+4>>0]=b[454549]|0;b[w+5>>0]=b[454550]|0;f[l>>2]=(f[d+4>>2]|0)-(f[d>>2]|0)>>2;f[i>>2]=0;f[i+4>>2]=0;w=tT(i,7)|0;b[w>>0]=b[454330]|0;b[w+1>>0]=b[454331]|0;b[w+2>>0]=b[454332]|0;b[w+3>>0]=b[454333]|0;b[w+4>>0]=b[454334]|0;b[w+5>>0]=b[454335]|0;b[w+6>>0]=b[454336]|0;$Ha(k,i,j)|0;uT(i);f[i>>2]=0;f[i+4>>2]=0;j=tT(i,7)|0;b[j>>0]=b[453755]|0;b[j+1>>0]=b[453756]|0;b[j+2>>0]=b[453757]|0;b[j+3>>0]=b[453758]|0;b[j+4>>0]=b[453759]|0;b[j+5>>0]=b[453760]|0;b[j+6>>0]=b[453761]|0;$Ha(k,i,l)|0;uT(i);f[i>>2]=0;f[i+4>>2]=0;j=tT(i,8)|0;w=j;b[w>>0]=108;b[w+1>>0]=111;b[w+2>>0]=103;b[w+3>>0]=105;w=j+4|0;b[w>>0]=115;b[w+1>>0]=116;b[w+2>>0]=105;b[w+3>>0]=99;b[m>>0]=1;rIa(k,i,m)|0;uT(i);w=f[l>>2]|0;l=w<<1;f[m>>2]=0;j=m+4|0;f[j>>2]=0;f[m+8>>2]=0;if(w){if(l>>>0>1073741823)mCc(m);x=w<<3;y=VDc(x)|0;f[m>>2]=y;z=y+(l<<2)|0;f[m+8>>2]=z;XIc(y|0,0,x|0)|0;f[j>>2]=z;if((w|0)>0){z=f[d>>2]|0;d=f[e>>2]|0;e=0;do{x=f[z+(e<<2)>>2]<<1;A=e<<1;f[y+(A<<2)>>2]=f[d+(x<<2)>>2];f[y+((A|1)<<2)>>2]=f[d+((x|1)<<2)>>2];e=e+1|0}while((e|0)<(w|0));B=y}else B=y}else B=0;Vj(o,1,l,5,B,0);f[n>>2]=1124007936;B=n+4|0;l=n+8|0;y=n+40|0;s=B;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[y>>2]=l;w=n+48|0;e=n+44|0;f[e>>2]=w;f[w>>2]=0;f[n+52>>2]=0;d=i+8|0;f[d>>2]=0;f[d+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;h_(o,i);d=o+36|0;z=f[d>>2]|0;if(z|0?(x=z+12|0,z=f[x>>2]|0,f[x>>2]=z+-1,(z|0)==1):0)_S(o);f[d>>2]=0;d=o+16|0;z=o+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[z>>2]|0)>0){d=f[o+40>>2]|0;x=0;do{f[d+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[z>>2]|0))}z=f[o+44>>2]|0;if((z|0)!=(o+48|0))g0(z);z=k+16|0;o=f[z>>2]|0;if((o|0)==(f[k+20>>2]|0))Bxa(k+12|0,n);else{f[o>>2]=f[n>>2];x=o+4|0;f[x>>2]=f[B>>2];d=o+8|0;f[d>>2]=f[l>>2];f[o+12>>2]=f[n+12>>2];f[o+16>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];l=f[n+36>>2]|0;f[o+36>>2]=l;f[o+40>>2]=d;d=o+48|0;A=o+44|0;f[A>>2]=d;f[d>>2]=0;f[o+52>>2]=0;if(l|0){d=l+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[B>>2]|0)<3){d=f[e>>2]|0;l=f[A>>2]|0;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2]}else{f[x>>2]=0;ZS(o,n)}f[z>>2]=(f[z>>2]|0)+56}f[i+40>>2]=0;f[i+44>>2]=0;o=i+40|0;x=i+36|0;s=i;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[x>>2]=o;o=i+48|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;o=a+4|0;f[h>>2]=f[o>>2];F5(q,454552,h);x=f[q>>2]|0;s=f[q+4>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;if(s>>>0>4294967279)dEc(p);if(s>>>0<11){b[p+11>>0]=s;if(!s)C=p;else{D=p;E=28}}else{v=s+16&-16;d=VDc(v)|0;f[p>>2]=d;f[p+8>>2]=v|-2147483648;f[p+4>>2]=s;D=d;E=28}if((E|0)==28){dJc(D|0,x|0,s|0)|0;C=D}b[C+s>>0]=0;uT(q);iEc(i,p)|0;q=f[t>>2]|0;s=k+36|0;C=f[s>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(C>>>0>4294967279)dEc(h);if(C>>>0<11){b[h+11>>0]=C;if(!C)F=h;else{G=h;E=34}}else{D=C+16&-16;x=VDc(D)|0;f[h>>2]=x;f[h+8>>2]=D|-2147483648;f[h+4>>2]=C;G=x;E=34}if((E|0)==34){dJc(G|0,q|0,C|0)|0;F=G}b[F+C>>0]=0;iEc(i+12|0,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);pIa(i+36|0,k)|0;XGa(i+48|0,f[c>>2]|0,f[z>>2]|0);z=i+60|0;uT(z);c=f[r>>2]|0;if(!c)H=0;else{h=c+-4|0;f[h>>2]=(f[h>>2]|0)+1;H=f[r>>2]|0}f[z>>2]=H;f[i+64>>2]=f[k+28>>2];H=i+68|0;uT(H);z=f[t>>2]|0;if(!z)I=0;else{r=z+-4|0;f[r>>2]=(f[r>>2]|0)+1;I=f[t>>2]|0}f[H>>2]=I;f[i+72>>2]=f[s>>2];s=i+24|0;I=a+8|0;H=i+28|0;t=f[H>>2]|0;r=i+32|0;if((t|0)==(f[r>>2]|0)){e1(s,I);J=f[H>>2]|0}else{fEc(t,I);t=(f[H>>2]|0)+12|0;f[H>>2]=t;J=t}if((J|0)==(f[r>>2]|0))e1(s,881820);else{fEc(J,881820);f[H>>2]=(f[H>>2]|0)+12}iEc(I,p)|0;H=f[a>>2]|0;J=H+16|0;s=f[J>>2]|0;if((s|0)==(f[H+20>>2]|0))jBb(H+12|0,i);else{hLa(s,i);f[J>>2]=(f[J>>2]|0)+76}f[o>>2]=(f[o>>2]|0)+1;o=a+24|0;J=f[o>>2]|0;if((J|0)==(f[a+28>>2]|0))e1(a+20|0,I);else{fEc(J,I);f[o>>2]=(f[o>>2]|0)+12}if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);fLa(i);i=n+36|0;p=f[i>>2]|0;if(p|0?(o=p+12|0,p=f[o>>2]|0,f[o>>2]=p+-1,(p|0)==1):0)_S(n);f[i>>2]=0;i=n+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[B>>2]|0)>0){i=f[y>>2]|0;y=0;do{f[i+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[B>>2]|0))}B=f[e>>2]|0;if((B|0)!=(w|0))g0(B);B=f[m>>2]|0;if(!B){HFa(k);u=g;return}m=f[j>>2]|0;if((m|0)!=(B|0))f[j>>2]=m+(~((m+-4-B|0)>>>2)<<2);YDc(B);HFa(k);u=g;return}function jBb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/76|0;g=e+1|0;if(g>>>0>56512727)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/76|0;d=i<<1;j=i>>>0<28256363?(d>>>0<g>>>0?g:d):56512727;do if(j)if(j>>>0>56512727){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*76|0)|0;break}else k=0;while(0);d=k+(e*76|0)|0;e=d;g=k+(j*76|0)|0;hLa(d,b);b=d+76|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=k}else{i=k;k=e;e=d;do{i=i+-76|0;hLa(e+-76|0,i);e=k+-76|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;h=n;while(1){n=h;if((n|0)==(g|0))break;b=n+-76|0;fLa(b);h=b}if(!m)return;YDc(m);return}function kBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function lBb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;i=c+12|0;j=c+8|0;k=c+4|0;l=c;m=c+16|0;n=c+24|0;f[i>>2]=d;f[j>>2]=e;f[k>>2]=g;f[l>>2]=h;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;h=a+12|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;h=a+24|0;uT(h);g=tT(h,16)|0;h=455028;e=g+16|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));d=a+32|0;uT(d);g=tT(d,11)|0;h=455045;e=g+11|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));f[m>>2]=0;f[m+4>>2]=0;g=tT(m,11)|0;h=454911;e=g+11|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));$Ha(a,m,i)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;i=tT(m,3)|0;b[i>>0]=b[453999]|0;b[i+1>>0]=b[454e3]|0;b[i+2>>0]=b[454001]|0;$Ha(a,m,j)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;j=tT(m,6)|0;b[j>>0]=b[454003]|0;b[j+1>>0]=b[454004]|0;b[j+2>>0]=b[454005]|0;b[j+3>>0]=b[454006]|0;b[j+4>>0]=b[454007]|0;b[j+5>>0]=b[454008]|0;$Ha(a,m,k)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;g=tT(m,9)|0;h=454939;e=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));b[n>>0]=0;rIa(a,m,n)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;g=tT(m,10)|0;h=455057;e=g+10|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));$Ha(a,m,l)|0;uT(m);u=c;return}function mBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function nBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0;d=u;u=u+496|0;e=d+472|0;g=d+468|0;h=d+464|0;i=d;j=d+416|0;k=d+392|0;l=d+448|0;m=d+404|0;n=d+368|0;o=d+380|0;p=d+356|0;q=d+344|0;r=d+328|0;s=d+272|0;t=d+216|0;v=d+160|0;w=d+104|0;x=d+32|0;y=d+88|0;z=d+8|0;A=d+20|0;ouc(a,g,4)|0;ouc(a,h,4)|0;ouc(a,d+460|0,4)|0;if((((f[g>>2]|0)*10|0)+(f[h>>2]|0)|0)>1)ouc(a,i,8)|0;else{f[e>>2]=0;ouc(a,e,4)|0;B=f[e>>2]|0;C=i;f[C>>2]=B;f[C+4>>2]=((B|0)<0)<<31>>31}if((f[g>>2]|0)>1e3|(f[h>>2]|0)>1e3){f[e>>2]=0;f[e+4>>2]=0;D=tT(e,67)|0;E=455068;F=D+67|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-213,e,455136,453824,690)}h=f[c+8>>2]|0;f[j>>2]=c;f[j+4>>2]=0;g=j+8|0;fEc(g,881820);f[j+20>>2]=0;B=j+24|0;f[B>>2]=0;f[j+28>>2]=0;C=f[c+36>>2]|0;i=c+40|0;do if((C|0)!=(i|0)){G=e+11|0;H=e+4|0;I=k+11|0;J=k+4|0;K=l+11|0;L=l+4|0;M=m+11|0;N=m+7|0;O=o+11|0;P=o+10|0;Q=p+11|0;R=p+6|0;S=q+8|0;T=q+4|0;U=q+11|0;V=r+4|0;W=r+8|0;X=r+12|0;Z=s+4|0;_=s+8|0;$=s+40|0;aa=s+48|0;ba=s+44|0;ca=s+52|0;da=t+4|0;ea=t+8|0;fa=t+40|0;ga=t+48|0;ha=t+44|0;ia=t+52|0;ja=e+4|0;ka=v+4|0;la=v+8|0;ma=v+40|0;na=v+48|0;oa=v+44|0;pa=v+52|0;qa=w+4|0;ra=w+8|0;sa=w+40|0;ta=w+48|0;ua=w+44|0;va=w+52|0;wa=x+4|0;xa=x+8|0;ya=x+40|0;za=x+48|0;Aa=x+44|0;Ba=x+52|0;Ca=x+16|0;Da=w+16|0;Ea=t+16|0;Fa=v+16|0;Ga=s+16|0;Ha=e+4|0;Ia=e+8|0;Ja=e+8|0;Ka=z+4|0;La=z+8|0;Ma=z+8|0;Na=A+4|0;Oa=x+12|0;Pa=x+20|0;Qa=x+24|0;Ra=x+28|0;Sa=x+32|0;Ta=x+36|0;Ua=w+12|0;Va=w+20|0;Wa=w+24|0;Xa=w+28|0;Ya=w+32|0;Za=w+36|0;_a=v+12|0;$a=v+20|0;ab=v+24|0;bb=v+28|0;cb=v+32|0;db=v+36|0;eb=n+11|0;fb=n+4|0;gb=t+36|0;hb=s+36|0;ib=y+4|0;jb=c+24|0;kb=m+8|0;lb=h;mb=-1;nb=-1;ob=C;while(1){nb=nb+1|0;pb=mb+1|0;qb=ob+20|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[G>>0]=4;f[e>>2]=1701869940;b[H>>0]=0;fEc(k,TAb(qb,e)|0);if((b[G>>0]|0)<0)YDc(f[e>>2]|0);rb=b[I>>0]|0;if(((rb<<24>>24<0?f[J>>2]|0:rb&255)|0)==13?(EEc(k,0,-1,453985,13)|0)==0:0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[K>>0]=4;f[l>>2]=1702521203;b[L>>0]=0;rb=VAb(qb,l,-1)|0;if((b[K>>0]|0)<0)YDc(f[l>>2]|0);f[kb>>2]=0;b[M>>0]=7;b[m>>0]=b[454010]|0;b[m+1>>0]=b[454011]|0;b[m+2>>0]=b[454012]|0;b[m+3>>0]=b[454013]|0;b[m+4>>0]=b[454014]|0;b[m+5>>0]=b[454015]|0;b[m+6>>0]=b[454016]|0;b[N>>0]=0;sb=VAb(qb,m,-1)|0;if((b[M>>0]|0)<0)YDc(f[m>>2]|0);b[O>>0]=10;D=o;E=454018;F=D+10|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[P>>0]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;b[Q>>0]=6;b[p>>0]=b[454029]|0;b[p+1>>0]=b[454030]|0;b[p+2>>0]=b[454031]|0;b[p+3>>0]=b[454032]|0;b[p+4>>0]=b[454033]|0;b[p+5>>0]=b[454034]|0;b[R>>0]=0;WAb(n,qb,o,p);if((b[Q>>0]|0)<0)YDc(f[p>>2]|0);if((b[O>>0]|0)<0)YDc(f[o>>2]|0);f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;tb=VDc(16)|0;f[q>>2]=tb;f[S>>2]=-2147483632;f[T>>2]=15;D=tb;E=454036;F=D+15|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[tb+15>>0]=0;ub=(VAb(qb,q,0)|0)==1;if((b[U>>0]|0)<0)YDc(f[q>>2]|0);if(!((rb|0)>0&(sb|0)>0)){vb=33;break}if((lb|0)<=0){vb=35;break}f[r>>2]=sb;f[V>>2]=lb;f[W>>2]=rb;f[X>>2]=rb;f[s>>2]=1124007936;D=Z;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[$>>2]=_;f[ba>>2]=aa;f[aa>>2]=0;f[ca>>2]=0;XS(s,4,r,5);if(!(f[s>>2]&16384)){vb=37;break}f[t>>2]=1124007936;D=da;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[fa>>2]=ea;f[ha>>2]=ga;f[ga>>2]=0;f[ia>>2]=0;f[e>>2]=1;f[ja>>2]=sb;XS(t,2,e,5);f[v>>2]=1124007936;D=ka;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[ma>>2]=la;f[oa>>2]=na;f[na>>2]=0;f[pa>>2]=0;f[e>>2]=1;f[ja>>2]=sb;XS(v,2,e,5);f[w>>2]=1124007936;D=qa;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[sa>>2]=ra;f[ua>>2]=ta;f[ta>>2]=0;f[va>>2]=0;f[e>>2]=1;f[ja>>2]=sb;XS(w,2,e,5);f[x>>2]=1124007936;D=wa;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[ya>>2]=xa;f[Aa>>2]=za;f[za>>2]=0;f[Ba>>2]=0;f[e>>2]=1;f[ja>>2]=sb;XS(x,2,e,5);qb=sb<<2;ouc(a,f[Ca>>2]|0,qb)|0;if(ub){ouc(a,f[Da>>2]|0,qb)|0;ouc(a,f[Ea>>2]|0,qb)|0;ouc(a,f[Fa>>2]|0,qb)|0;wb=ub}else wb=0;ouc(a,f[Ga>>2]|0,Y(Y(Y(lb<<2,rb)|0,rb)|0,sb)|0)|0;f[e>>2]=0;f[Ha>>2]=0;f[Ia>>2]=0;Bxa(e,s);do if(!wb){qb=f[Ha>>2]|0;if((qb|0)==(f[Ja>>2]|0)){Bxa(e,x);break}f[qb>>2]=f[x>>2];tb=qb+4|0;f[tb>>2]=f[wa>>2];xb=qb+8|0;f[xb>>2]=f[xa>>2];f[qb+12>>2]=f[Oa>>2];f[qb+16>>2]=f[Ca>>2];f[qb+20>>2]=f[Pa>>2];f[qb+24>>2]=f[Qa>>2];f[qb+28>>2]=f[Ra>>2];f[qb+32>>2]=f[Sa>>2];yb=f[Ta>>2]|0;f[qb+36>>2]=yb;f[qb+40>>2]=xb;xb=qb+48|0;zb=qb+44|0;f[zb>>2]=xb;f[xb>>2]=0;f[qb+52>>2]=0;if(yb|0){xb=yb+12|0;f[xb>>2]=(f[xb>>2]|0)+1}if((f[wa>>2]|0)<3){xb=f[Aa>>2]|0;yb=f[zb>>2]|0;f[yb>>2]=f[xb>>2];f[yb+4>>2]=f[xb+4>>2]}else{f[tb>>2]=0;ZS(qb,x)}f[Ha>>2]=(f[Ha>>2]|0)+56}while(0);MFa(y,e);sb=(f[(f[j>>2]|0)+12>>2]|0)+(pb*76|0)+48|0;if((sb|0)!=(y|0))XGa(sb,f[y>>2]|0,f[ib>>2]|0);mx(y);if(ub){sb=mb+2|0;f[z>>2]=0;f[Ka>>2]=0;f[La>>2]=0;Bxa(z,t);rb=f[Ka>>2]|0;if((rb|0)==(f[Ma>>2]|0)){Bxa(z,v);Ab=f[Ka>>2]|0}else{f[rb>>2]=f[v>>2];qb=rb+4|0;f[qb>>2]=f[ka>>2];tb=rb+8|0;f[tb>>2]=f[la>>2];f[rb+12>>2]=f[_a>>2];f[rb+16>>2]=f[Fa>>2];f[rb+20>>2]=f[$a>>2];f[rb+24>>2]=f[ab>>2];f[rb+28>>2]=f[bb>>2];f[rb+32>>2]=f[cb>>2];xb=f[db>>2]|0;f[rb+36>>2]=xb;f[rb+40>>2]=tb;tb=rb+48|0;yb=rb+44|0;f[yb>>2]=tb;f[tb>>2]=0;f[rb+52>>2]=0;if(xb|0){tb=xb+12|0;f[tb>>2]=(f[tb>>2]|0)+1}if((f[ka>>2]|0)<3){tb=f[oa>>2]|0;xb=f[yb>>2]|0;f[xb>>2]=f[tb>>2];f[xb+4>>2]=f[tb+4>>2]}else{f[qb>>2]=0;ZS(rb,v)}rb=(f[Ka>>2]|0)+56|0;f[Ka>>2]=rb;Ab=rb}if((Ab|0)==(f[Ma>>2]|0)){Bxa(z,w);Bb=f[Ka>>2]|0}else{f[Ab>>2]=f[w>>2];rb=Ab+4|0;f[rb>>2]=f[qa>>2];qb=Ab+8|0;f[qb>>2]=f[ra>>2];f[Ab+12>>2]=f[Ua>>2];f[Ab+16>>2]=f[Da>>2];f[Ab+20>>2]=f[Va>>2];f[Ab+24>>2]=f[Wa>>2];f[Ab+28>>2]=f[Xa>>2];f[Ab+32>>2]=f[Ya>>2];tb=f[Za>>2]|0;f[Ab+36>>2]=tb;f[Ab+40>>2]=qb;qb=Ab+48|0;xb=Ab+44|0;f[xb>>2]=qb;f[qb>>2]=0;f[Ab+52>>2]=0;if(tb|0){qb=tb+12|0;f[qb>>2]=(f[qb>>2]|0)+1}if((f[qa>>2]|0)<3){qb=f[ua>>2]|0;tb=f[xb>>2]|0;f[tb>>2]=f[qb>>2];f[tb+4>>2]=f[qb+4>>2]}else{f[rb>>2]=0;ZS(Ab,w)}rb=(f[Ka>>2]|0)+56|0;f[Ka>>2]=rb;Bb=rb}if((Bb|0)==(f[Ma>>2]|0))Bxa(z,x);else{f[Bb>>2]=f[x>>2];rb=Bb+4|0;f[rb>>2]=f[wa>>2];qb=Bb+8|0;f[qb>>2]=f[xa>>2];f[Bb+12>>2]=f[Oa>>2];f[Bb+16>>2]=f[Ca>>2];f[Bb+20>>2]=f[Pa>>2];f[Bb+24>>2]=f[Qa>>2];f[Bb+28>>2]=f[Ra>>2];f[Bb+32>>2]=f[Sa>>2];tb=f[Ta>>2]|0;f[Bb+36>>2]=tb;f[Bb+40>>2]=qb;qb=Bb+48|0;xb=Bb+44|0;f[xb>>2]=qb;f[qb>>2]=0;f[Bb+52>>2]=0;if(tb|0){qb=tb+12|0;f[qb>>2]=(f[qb>>2]|0)+1}if((f[wa>>2]|0)<3){qb=f[Aa>>2]|0;tb=f[xb>>2]|0;f[tb>>2]=f[qb>>2];f[tb+4>>2]=f[qb+4>>2]}else{f[rb>>2]=0;ZS(Bb,x)}f[Ka>>2]=(f[Ka>>2]|0)+56}MFa(A,z);rb=(f[(f[j>>2]|0)+12>>2]|0)+(sb*76|0)+48|0;if((rb|0)!=(A|0))XGa(rb,f[A>>2]|0,f[Na>>2]|0);mx(A);mx(z);Cb=sb}else Cb=pb;sb=b[eb>>0]|0;if(((sb<<24>>24<0?f[fb>>2]|0:sb&255)|0)==5)Db=((EEc(n,0,-1,454052,5)|0)==0&1)+Cb|0;else Db=Cb;mx(e);sb=f[Ta>>2]|0;do if(sb|0){rb=sb+12|0;qb=f[rb>>2]|0;f[rb>>2]=qb+-1;if((qb|0)!=1)break;_S(x)}while(0);f[Ta>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[wa>>2]|0)>0){sb=f[ya>>2]|0;ub=0;do{f[sb+(ub<<2)>>2]=0;ub=ub+1|0}while((ub|0)<(f[wa>>2]|0))}ub=f[Aa>>2]|0;if((ub|0)!=(za|0))g0(ub);ub=f[Za>>2]|0;do if(ub|0){sb=ub+12|0;qb=f[sb>>2]|0;f[sb>>2]=qb+-1;if((qb|0)!=1)break;_S(w)}while(0);f[Za>>2]=0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[qa>>2]|0)>0){ub=f[sa>>2]|0;qb=0;do{f[ub+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[qa>>2]|0))}qb=f[ua>>2]|0;if((qb|0)!=(ta|0))g0(qb);qb=f[db>>2]|0;do if(qb|0){ub=qb+12|0;sb=f[ub>>2]|0;f[ub>>2]=sb+-1;if((sb|0)!=1)break;_S(v)}while(0);f[db>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;if((f[ka>>2]|0)>0){qb=f[ma>>2]|0;sb=0;do{f[qb+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[ka>>2]|0))}sb=f[oa>>2]|0;if((sb|0)!=(na|0))g0(sb);sb=f[gb>>2]|0;do if(sb|0){qb=sb+12|0;ub=f[qb>>2]|0;f[qb>>2]=ub+-1;if((ub|0)!=1)break;_S(t)}while(0);f[gb>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[da>>2]|0)>0){sb=f[fa>>2]|0;ub=0;do{f[sb+(ub<<2)>>2]=0;ub=ub+1|0}while((ub|0)<(f[da>>2]|0))}ub=f[ha>>2]|0;if((ub|0)!=(ga|0))g0(ub);ub=f[hb>>2]|0;do if(ub|0){sb=ub+12|0;qb=f[sb>>2]|0;f[sb>>2]=qb+-1;if((qb|0)!=1)break;_S(s)}while(0);f[hb>>2]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[Z>>2]|0)>0){ub=f[$>>2]|0;qb=0;do{f[ub+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[Z>>2]|0))}qb=f[ba>>2]|0;if((qb|0)!=(aa|0))g0(qb);if((b[eb>>0]|0)<0)YDc(f[n>>2]|0);Eb=Db}else Eb=pb;qb=b[I>>0]|0;ub=f[J>>2]|0;if(((qb<<24>>24<0?ub:qb&255)|0)==6)if(!(EEc(k,0,-1,454309,6)|0))vb=129;else{Fb=b[I>>0]|0;Gb=f[J>>2]|0;vb=127}else{Fb=qb;Gb=ub;vb=127}if((vb|0)==127){vb=0;if(((Fb<<24>>24<0?Gb:Fb&255)|0)==4?(EEc(k,0,-1,454486,4)|0)==0:0)vb=129;else Hb=Eb}if((vb|0)==129){vb=0;Hb=Eb+1|0}lb=f[(f[jb>>2]|0)+(nb<<2)>>2]|0;if((b[I>>0]|0)<0)YDc(f[k>>2]|0);ub=f[ob+4>>2]|0;if(!ub){qb=ob+8|0;sb=f[qb>>2]|0;if((f[sb>>2]|0)==(ob|0))Ib=sb;else{sb=qb;do{qb=f[sb>>2]|0;sb=qb+8|0;rb=f[sb>>2]|0}while((f[rb>>2]|0)!=(qb|0));Ib=rb}}else{sb=ub;while(1){pb=f[sb>>2]|0;if(!pb)break;else sb=pb}Ib=sb}if((Ib|0)==(i|0)){vb=8;break}else{mb=Hb;ob=Ib}}if((vb|0)==8){ob=j+20|0;mb=f[ob>>2]|0;if(!mb)break;I=f[B>>2]|0;if((I|0)==(mb|0))Jb=mb;else{nb=I;while(1){I=nb+-12|0;f[B>>2]=I;if((b[I+11>>0]|0)<0){YDc(f[I>>2]|0);Kb=f[B>>2]|0}else Kb=I;if((Kb|0)==(mb|0))break;else nb=Kb}Jb=f[ob>>2]|0}YDc(Jb);break}else if((vb|0)==33){f[e>>2]=0;f[e+4>>2]=0;D=tT(e,30)|0;E=454146;F=D+30|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,e,455136,453824,712)}else if((vb|0)==35){f[e>>2]=0;f[e+4>>2]=0;D=tT(e,20)|0;E=454177;F=D+20|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,e,455136,453824,713)}else if((vb|0)==37){f[e>>2]=0;f[e+4>>2]=0;D=tT(e,26)|0;E=455165;F=D+26|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,e,455136,453824,719)}}while(0);if((b[g+11>>0]|0)>=0){u=d;return 1}YDc(f[g>>2]|0);u=d;return 1}function oBb(a,b){a=a|0;b=b|0;QAb(a,b)|0;return}function pBb(a,b){a=a|0;b=b|0;nBb(a,b)|0;return}function qBb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=105532;b=a+36|0;c=f[b>>2]|0;if(c|0?(f[a+24>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h|0?(f[a+8>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;YDc(i)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[b>>2]=0;return}function rBb(a){a=a|0;qBb(a);YDc(a);return}function sBb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function tBb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(44)|0;VDb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,18880,48);a=MQb(b,48)|0;WDb(a,b);c=a;return c|0}function uBb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function vBb(a){a=a|0;return f[a+4>>2]|0}function wBb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+20>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}b=a+28|0;c=f[b>>2]|0;if((c|0)>0){e=f[a+36>>2]|0;d=0;do{g=f[e+4+(d<<2)>>2]|0;d=d+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((d|0)!=(c|0));f[b>>2]=0}b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function xBb(a){a=a|0;return 1}function yBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=e+4|0;m=a+24|0;n=a+36|0;o=a+32|0;p=a+28|0;q=e+4|0;r=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=a+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=WRb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=10){y=v;break b}t=f[i>>2]|0;do if(t){a=f[k>>2]|0;s=f[t>>2]|0;if((a|0)>=(s|0))if((s|0)==(f[j>>2]|0)){z=s;w=13;break}else{A=s;B=t;w=14;break}else{f[k>>2]=a+1;C=f[t+4+(a<<2)>>2]|0;break}}else{z=f[j>>2]|0;w=13}while(0);if((w|0)==13){w=0;USb(h,z+1|0);t=f[i>>2]|0;A=f[t>>2]|0;B=t;w=14}if((w|0)==14){w=0;f[B>>2]=A+1;t=f[h>>2]|0;if(!t){a=VDc(32)|0;PDb(a);D=a}else{if(f[t+64>>2]|0)OQb(t,18912,32);a=MQb(t,32)|0;QDb(a,t);D=a}a=f[i>>2]|0;t=f[k>>2]|0;f[k>>2]=t+1;f[a+4+(t<<2)>>2]=D;C=D}t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(a=b[t>>0]|0,a<<24>>24>-1):0){f[c>>2]=t+1;E=a&255}else{a=VRb(c)|0;if((a|0)>-1)E=a;else{F=0;w=54;break a}}GRb(e,c,E);if((f[l>>2]|0)<0){w=26;break a}if(!(Mi[f[(f[C>>2]|0)+44>>2]&1023](C,c)|0)){w=26;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{F=0;w=54;break a}break}case 2:{if((v&255|0)!=18){y=v;break b}a=f[n>>2]|0;do if(a){t=f[p>>2]|0;s=f[a>>2]|0;if((t|0)>=(s|0))if((s|0)==(f[o>>2]|0)){G=s;w=34;break}else{H=s;I=a;w=35;break}else{f[p>>2]=t+1;J=f[a+4+(t<<2)>>2]|0;break}}else{G=f[o>>2]|0;w=34}while(0);if((w|0)==34){w=0;USb(m,G+1|0);a=f[n>>2]|0;H=f[a>>2]|0;I=a;w=35}if((w|0)==35){w=0;f[I>>2]=H+1;a=f[m>>2]|0;if(!a){t=VDc(20)|0;gCb(t);K=t}else{if(f[a+64>>2]|0)OQb(a,18896,24);t=MQb(a,24)|0;hCb(t,a);K=t}t=f[n>>2]|0;a=f[p>>2]|0;f[p>>2]=a+1;f[t+4+(a<<2)>>2]=K;J=K}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(t=b[a>>0]|0,t<<24>>24>-1):0){f[c>>2]=a+1;L=t&255}else{t=VRb(c)|0;if((t|0)>-1)L=t;else{F=0;w=54;break a}}GRb(e,c,L);if((f[q>>2]|0)<0){w=47;break a}if(!(Mi[f[(f[J>>2]|0)+44>>2]&1023](J,c)|0)){w=47;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{F=0;w=54;break a}break}default:{y=v;break b}}}while(0);if(!y){F=1;w=54;break}t=f[r>>2]|0;if(!(t&1))M=mNa(r)|0;else M=t&-2;if(!(Djc(c,y,M)|0)){F=0;w=54;break}}if((w|0)==26){F=0;u=d;return F|0}else if((w|0)==47){F=0;u=d;return F|0}else if((w|0)==54){u=d;return F|0}return 0}function zBb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+20|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+28>>2]|0;c=i+g|0;if(!i){k=c;l=a+40|0;f[l>>2]=k;return k|0}g=a+36|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}l=a+40|0;f[l>>2]=k;return k|0}function ABb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{eUb(1,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+28>>2]|0;if(d|0){g=a+36|0;e=0;do{eUb(2,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)!=(d|0))}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function BBb(a){a=a|0;return f[a+40>>2]|0}function CBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[a+12>>2]|0;if(!e)g=d;else{h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+28>>2]|0;if(!j)s=g;else{e=a+36|0;i=0;q=g;while(1){g=f[(f[e>>2]|0)+4+(i<<2)>>2]|0;b[q>>0]=18;r=q+1|0;h=_i[f[(f[g>>2]|0)+60>>2]&1023](g)|0;if(h>>>0>127){n=h;m=r;while(1){b[m>>0]=n|128;o=n>>>7;p=m+1|0;if(n>>>0>16383){n=o;m=p}else{t=p;u=o;break}}}else{t=r;u=h}b[t>>0]=u;m=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,t+1|0)|0;i=i+1|0;if((i|0)==(j|0)){s=m;break}else q=m}}q=f[a+4>>2]|0;if(!((q&1|0)!=0&(b[473420]|0)!=0)){v=s;return v|0}v=Hjc(q&-2,s)|0;return v|0}function DBb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function EBb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,18880,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}RDb(a+8|0,c+8|0);SDb(a+24|0,c+24|0);return}function FBb(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function GBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220458]|0)!=2){f[d>>2]=161028;f[d+4>>2]=110;b[d+8>>0]=0;DTb(881832,d);ZSb(d)}d=526824;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function HBb(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220459]|0)!=2){f[c>>2]=161028;f[c+4>>2]=111;b[c+8>>0]=0;DTb(881836,c);ZSb(c)}d=VDc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=14;e=d;g=455192;h=e+14|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+14>>0]=0;Xbc(c,105632,105692,105364,0,526824,0,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function IBb(){JBb();lYb(455207,615);rhc(455192,1769);jPa();rGb();return}function JBb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220460]|0)!=2){f[c>>2]=161028;f[c+4>>2]=112;b[c+8>>0]=0;DTb(881840,c);ZSb(c)}if((f[220461]|0)!=2){f[c>>2]=161028;f[c+4>>2]=113;b[c+8>>0]=0;DTb(881844,c);ZSb(c)}if((f[220462]|0)!=2){f[c>>2]=161028;f[c+4>>2]=114;b[c+8>>0]=0;DTb(881848,c);ZSb(c)}if((f[220463]|0)!=2){f[c>>2]=161028;f[c+4>>2]=115;b[c+8>>0]=0;DTb(881852,c);ZSb(c)}if((f[220464]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=116;b[c+8>>0]=0;DTb(881856,c);ZSb(c);u=a;return}function KBb(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220458]|0)!=2){f[c>>2]=161028;f[c+4>>2]=110;b[c+8>>0]=0;DTb(881832,c);ZSb(c)}acc(526824,5);u=a;return}function LBb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,455823);SQb();if((f[220463]|0)!=2){f[c>>2]=161028;f[c+4>>2]=115;b[c+8>>0]=0;DTb(881852,c);ZSb(c)}if((f[220464]|0)!=2){f[c>>2]=161028;f[c+4>>2]=116;b[c+8>>0]=0;DTb(881856,c);ZSb(c)}f[131648]=105532;c=526596;d=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131658]=0;zTb(526592);u=a;return}function MBb(){aTb(3005001,3005e3,455823);SQb();iPa();f[131663]=0;f[131661]=527320;f[131664]=0;f[131665]=0;f[131660]=106128;f[131662]=520464;return}function NBb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,455823);SQb();if((f[220461]|0)!=2){f[c>>2]=161028;f[c+4>>2]=113;b[c+8>>0]=0;DTb(881844,c);ZSb(c)}CCb(526664);zTb(526664);u=a;return}function OBb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,455823);SQb();qGb();if((f[220462]|0)!=2){f[c>>2]=161028;f[c+4>>2]=114;b[c+8>>0]=0;DTb(881848,c);ZSb(c)}f[131692]=105828;f[131693]=0;f[131694]=0;f[131695]=0;f[131696]=0;f[131697]=0;f[131698]=0;f[131699]=0;zTb(526768);f[131698]=526952;u=a;return}function PBb(){aTb(3005001,3005e3,455823);SQb();f[131700]=105720;f[131701]=0;f[131702]=527320;f[131703]=527320;f[131704]=0;zTb(526800);return}function QBb(a){a=a|0;var c=0,d=0;f[a>>2]=105720;c=f[a+8>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+12>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function RBb(a){a=a|0;QBb(a);YDc(a);return}function SBb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function TBb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(20)|0;gCb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,18896,24);a=MQb(b,24)|0;hCb(a,b);c=a;return c|0}function UBb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function VBb(a){a=a|0;return f[a+4>>2]|0}function WBb(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+12>>2]|0;do if((d|0)!=527320){a=d+11|0;if((b[a>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[a>>0]=0;break}}while(0);d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;ljc(c);return}function XBb(a){a=a|0;return 1}function YBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=c+4|0;e=a+8|0;g=a+4|0;h=a+8|0;i=a+12|0;j=a+12|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=6}else{o=l;n=5}}else{o=0;n=5}if((n|0)==5){n=0;l=WRb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=6}else p=l}b:do if((n|0)==6){n=0;switch(m>>>3&536870911|0){case 1:{if((m&255|0)!=10){p=m;break b}l=f[g>>2]|0;a=l&-2;if(!(l&1))q=a;else q=f[a+4>>2]|0;a=f[e>>2]|0;if((a|0)==527320){WJa(e,q,527320);r=f[e>>2]|0}else r=a;if(!(fUb(c,r)|0)){s=0;n=34;break a}a=f[h>>2]|0;l=b[a+11>>0]|0;if(l<<24>>24<0){t=f[a>>2]|0;u=f[a+4>>2]|0}else{t=a;u=l&255}if(gUb(t,u,0,455903)|0)continue a;else{s=0;n=34;break a}break}case 2:{if((m&255|0)!=18){p=m;break b}l=f[g>>2]|0;a=l&-2;if(!(l&1))v=a;else v=f[a+4>>2]|0;a=f[i>>2]|0;if((a|0)==527320){WJa(i,v,527320);w=f[i>>2]|0}else w=a;if(!(fUb(c,w)|0)){s=0;n=34;break a}a=f[j>>2]|0;l=b[a+11>>0]|0;if(l<<24>>24<0){x=f[a>>2]|0;y=f[a+4>>2]|0}else{x=a;y=l&255}if(gUb(x,y,0,455947)|0)continue a;else{s=0;n=34;break a}break}default:{p=m;break b}}}while(0);if(!p){s=1;n=34;break}l=f[g>>2]|0;if(!(l&1))z=mNa(g)|0;else z=l&-2;if(!(Djc(c,p,z)|0)){s=0;n=34;break}}if((n|0)==34)return s|0;return 0}function ZBb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=f[a+12>>2]|0;d=b[h+11>>0]|0;e=d<<24>>24<0;if(e)j=f[h+4>>2]|0;else j=d&255;if(!j){k=i;l=a+16|0;f[l>>2]=k;return k|0}j=e?f[h+4>>2]|0:d&255;k=i+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=a+16|0;f[l>>2]=k;return k|0}function _Bb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gUb(j,k,1,455903)|0;$Tb(1,f[d>>2]|0,c)}d=a+12|0;k=f[d>>2]|0;j=b[k+11>>0]|0;g=j<<24>>24<0;if(g)l=f[k+4>>2]|0;else l=j&255;if(l|0){if(g){m=f[k>>2]|0;n=f[k+4>>2]|0}else{m=k;n=j&255}gUb(m,n,1,455947)|0;$Tb(2,f[d>>2]|0,c)}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function $Bb(a){a=a|0;return f[a+16>>2]|0}function aCb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;e=f[c>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=d;else{if(h){k=f[e>>2]|0;l=f[e+4>>2]|0}else{k=e;l=g&255}gUb(k,l,1,455903)|0;l=f[c>>2]|0;b[d>>0]=10;j=dSb(l,d+1|0)|0}d=a+12|0;l=f[d>>2]|0;c=b[l+11>>0]|0;k=c<<24>>24<0;if(k)m=f[l+4>>2]|0;else m=c&255;if(!m)n=j;else{if(k){o=f[l>>2]|0;p=f[l+4>>2]|0}else{o=l;p=c&255}gUb(o,p,1,455947)|0;p=f[d>>2]|0;b[j>>0]=18;n=dSb(p,j+1|0)|0}j=f[a+4>>2]|0;if(!((j&1|0)!=0&(b[473420]|0)!=0)){q=n;return q|0}q=Hjc(j&-2,n)|0;return q|0}function bCb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function cCb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,18896,0)|0;if(!c){Ehc(b,a);return}else{fCb(a,c);return}}function dCb(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function eCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220458]|0)!=2){f[d>>2]=161028;f[d+4>>2]=110;b[d+8>>0]=0;DTb(881832,d);ZSb(d)}d=526856;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function fCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+12>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)l=f[e+4>>2]|0;else l=c&255;if(!l)return;l=a+12|0;a=f[d>>2]|0;d=a&-2;if(!(a&1))m=d;else m=f[d+4>>2]|0;d=f[l>>2]|0;if((d|0)==527320){WJa(l,m,e);return}else{iEc(d,e)|0;return}}function gCb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=105720;f[a+4>>2]=0;if((a|0)!=526800?(f[220464]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=116;b[d+8>>0]=0;DTb(881856,d);ZSb(d)}f[a+8>>2]=527320;f[a+12>>2]=527320;f[a+16>>2]=0;u=c;return}function hCb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=105720;f[a+4>>2]=c;if((f[220464]|0)!=2){f[e>>2]=161028;f[e+4>>2]=116;b[e+8>>0]=0;DTb(881856,e);ZSb(e)}f[a+8>>2]=527320;f[a+12>>2]=527320;f[a+16>>2]=0;u=d;return}function iCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=105828;if((a|0)!=526768?(b=f[a+24>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function jCb(a){a=a|0;iCb(a);YDc(a);return}function kCb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function lCb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(32)|0;PDb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,18912,32);a=MQb(b,32)|0;QDb(a,b);c=a;return c|0}function mCb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function nCb(a){a=a|0;return f[a+4>>2]|0}function oCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+12|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+20>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}b=a+4|0;c=f[b>>2]|0;e=c&-2;if(!(c&1))h=e;else h=f[e+4>>2]|0;e=a+24|0;if((h|0)==0?(h=f[e>>2]|0,(h|0)!=0):0){Yi[f[(f[h>>2]|0)+4>>2]&2047](h);i=f[b>>2]|0}else i=c;f[e>>2]=0;if(!(i&1))return;e=i&-2;if(!(f[e>>2]|0))return;ljc(e);return}function pCb(a){a=a|0;return 1}function qCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+24|0;i=e+4|0;j=a+8|0;k=a+20|0;l=a+16|0;m=a+12|0;n=e+4|0;o=a+4|0;a:while(1){p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){q=b[p>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=p+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=WRb(c,v)|0;if((r+-1|0)>>>0<127){s=r;t=6}else w=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{if((s&255|0)!=10){w=s;break b}r=f[h>>2]|0;if(!r){BCb(a);x=f[h>>2]|0}else x=r;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(p=b[r>>0]|0,p<<24>>24>-1):0){f[c>>2]=r+1;y=p&255}else{p=VRb(c)|0;if((p|0)>-1)y=p;else{z=0;t=44;break a}}GRb(e,c,y);if((f[i>>2]|0)<0){t=16;break a}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){t=16;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{z=0;t=44;break a}break}case 2:break;default:{w=s;break b}}if((s&255|0)==18){p=f[k>>2]|0;do if(p){r=f[m>>2]|0;q=f[p>>2]|0;if((r|0)>=(q|0))if((q|0)==(f[l>>2]|0)){A=q;t=24;break}else{B=q;C=p;t=25;break}else{f[m>>2]=r+1;D=f[p+4+(r<<2)>>2]|0;break}}else{A=f[l>>2]|0;t=24}while(0);if((t|0)==24){t=0;USb(j,A+1|0);p=f[k>>2]|0;B=f[p>>2]|0;C=p;t=25}if((t|0)==25){t=0;f[C>>2]=B+1;p=f[j>>2]|0;if(!p){r=VDc(100)|0;CCb(r);E=r}else{if(f[p+64>>2]|0)OQb(p,18928,104);r=MQb(p,104)|0;ECb(r,p);E=r}r=f[k>>2]|0;p=f[m>>2]|0;f[m>>2]=p+1;f[r+4+(p<<2)>>2]=E;D=E}p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(r=b[p>>0]|0,r<<24>>24>-1):0){f[c>>2]=p+1;F=r&255}else{r=VRb(c)|0;if((r|0)>-1)F=r;else{z=0;t=44;break a}}GRb(e,c,F);if((f[n>>2]|0)<0){t=37;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){t=37;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{z=0;t=44;break a}}else w=s}while(0);if(!w){z=1;t=44;break}r=f[o>>2]|0;if(!(r&1))G=mNa(o)|0;else G=r&-2;if(!(Djc(c,w,G)|0)){z=0;t=44;break}}if((t|0)==16){z=0;u=d;return z|0}else if((t|0)==37){z=0;u=d;return z|0}else if((t|0)==44){u=d;return z|0}return 0}function rCb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+20|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}if((a|0)==526768){k=g;l=a+28|0;f[l>>2]=k;return k|0}i=f[a+24>>2]|0;if(!i){k=g;l=a+28|0;f[l>>2]=k;return k|0}c=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;k=g+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=a+28|0;f[l>>2]=k;return k|0}function sCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)!=526768?(d=f[a+24>>2]|0,d|0):0)eUb(1,d,c);d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{eUb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function tCb(a){a=a|0;return f[a+28>>2]|0}function uCb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((a|0)!=526768?(e=f[a+24>>2]|0,(e|0)!=0):0){b[d>>0]=10;g=d+1|0;h=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(h>>>0>127){i=h;j=g;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=g;n=h}b[m>>0]=n;o=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,m+1|0)|0}else o=d;d=f[a+12>>2]|0;if(!d)p=o;else{m=a+20|0;e=0;n=o;while(1){o=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;b[n>>0]=18;h=n+1|0;g=_i[f[(f[o>>2]|0)+60>>2]&1023](o)|0;if(g>>>0>127){j=g;i=h;while(1){b[i>>0]=j|128;k=j>>>7;l=i+1|0;if(j>>>0>16383){j=k;i=l}else{q=l;r=k;break}}}else{q=h;r=g}b[q>>0]=r;i=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,q+1|0)|0;e=e+1|0;if((e|0)==(d|0)){p=i;break}else n=i}}n=f[a+4>>2]|0;if(!((n&1|0)!=0&(b[473420]|0)!=0)){s=p;return s|0}s=Hjc(n&-2,p)|0;return s|0}function vCb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function wCb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,18912,0)|0;if(!c){Ehc(b,a);return}else{zCb(a,c);return}}function xCb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function yCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220458]|0)!=2){f[d>>2]=161028;f[d+4>>2]=110;b[d+8>>0]=0;DTb(881832,d);ZSb(d)}d=526848;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function zCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}ACb(a+8|0,b+8|0);if((b|0)==526768)return;d=b+24|0;b=f[d>>2]|0;if(!b)return;g=a+24|0;e=f[g>>2]|0;if(!e){BCb(a);h=f[d>>2]|0;i=f[g>>2]|0}else{h=b;i=e}mFb(i,h|0?h:526952);return}function ACb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{DCb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(100)|0;CCb(l);DCb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,18928,104);l=MQb(i,104)|0;ECb(l,i);DCb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function BCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(80)|0;UEb(c);e=c;g=a+24|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,19056,80);c=MQb(d,80)|0;WEb(c,d);e=c;g=a+24|0;f[g>>2]=e;return}function CCb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=105936;e=a+56|0;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=167152;f[a+60>>2]=0;f[a+64>>2]=0;tTb(a+68|0);f[a+72>>2]=0;f[e>>2]=106044;f[a+76>>2]=0;e=a+80|0;f[e>>2]=0;g=a+84|0;f[g>>2]=0;AJa(e);f[g>>2]=0;if((a|0)!=526664?(f[220462]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=114;b[d+8>>0]=0;DTb(881848,d);ZSb(d)}f[a+92>>2]=527320;f[a+96>>2]=0;u=c;return}function DCb(a,b){a=a|0;b=b|0;HDb(b,a);return}function ECb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=105936;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=c;f[a+28>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=c;f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;FCb(a+56|0,c);if((f[220462]|0)==2){g=a+92|0;f[g>>2]=527320;h=a+96|0;f[h>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=114;b[e+8>>0]=0;DTb(881848,e);ZSb(e);g=a+92|0;f[g>>2]=527320;h=a+96|0;f[h>>2]=0;u=d;return}function FCb(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=167152;f[a+4>>2]=b;f[a+8>>2]=0;c=a+12|0;tTb(c);f[a+16>>2]=0;wNa(b,c);f[a>>2]=106044;f[a+20>>2]=b;c=a+24|0;f[c>>2]=b;b=a+28|0;f[b>>2]=0;AJa(c);f[b>>2]=0;return}function GCb(a){a=a|0;f[a>>2]=106044;cJa(a+24|0);Bcc(a);return}function HCb(a){a=a|0;f[a>>2]=106044;cJa(a+24|0);Bcc(a);YDc(a);return}function ICb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;fEc(g,PNa(c)|0);bJa(e,f[a+32>>2]|0,g,0);a=(f[e>>2]|0)!=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}YDc(f[g>>2]|0);u=d;return a|0}function JCb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e+16|0;h=e;i=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;fEc(h,PNa(c)|0);bJa(g,f[i+8>>2]|0,h,0);c=f[g>>2]|0;if(!c){j=1;k=BJa(i,h)|0}else{j=0;k=(f[c+12>>2]|0)+16|0}f[d>>2]=k;if((b[h+11>>0]|0)>=0){u=e;return j|0}YDc(f[h>>2]|0);u=e;return j|0}function KCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d+40|0;g=d+24|0;h=d;fEc(h,PNa(c)|0);c=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;bJa(e,f[c+8>>2]|0,h,0);a=f[e>>2]|0;i=f[e+4>>2]|0;j=f[e+8>>2]|0;if(!a)k=0;else{f[g>>2]=a;f[g+4>>2]=i;f[g+8>>2]=j;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];sJa(d+12|0,c,e);k=1}if((b[h+11>>0]|0)>=0){u=d;return k|0}YDc(f[h>>2]|0);u=d;return k|0}function LCb(a){a=a|0;Wdc(a);return f[f[a+32>>2]>>2]|0}function MCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=u;u=u+16|0;c=b;d=f[a+8>>2]|0;if(!d)e=12;else{g=f[d+8>>2]<<2;h=d+12|0;d=f[h>>2]|0;if(!d)i=g;else{if((f[d>>2]|0)>0){j=0;k=g;l=d;while(1){d=f[l+4+(j<<2)>>2]|0;m=(_i[f[(f[d>>2]|0)+84>>2]&1023](d)|0)+k|0;j=j+1|0;l=f[h>>2]|0;if((j|0)>=(f[l>>2]|0)){n=m;break}else k=m}}else n=g;i=n+4|0}e=i+12|0}i=f[a+32>>2]|0;a=f[i+12>>2]|0;n=f[i+4>>2]|0;a:do if(n>>>0>a>>>0){g=f[i+16>>2]|0;k=a;while(1){o=f[g+(k<<2)>>2]|0;if(o|0)break;l=k+1|0;if(l>>>0<n>>>0)k=l;else{p=0;q=l;break a}}if((o|0)==(f[g+((k^1)<<2)>>2]|0)){p=f[(f[o>>2]|0)+16>>2]|0;q=k;break}else{p=o;q=k;break}}else{p=0;q=a}while(0);f[c>>2]=p;f[c+4>>2]=i;f[c+8>>2]=q;if(!p){r=e;u=b;return r|0}q=e;e=p;while(1){p=(f[e+12>>2]|0)+16|0;i=q+12+(_i[f[(f[p>>2]|0)+84>>2]&1023](p)|0)|0;vJa(c)|0;e=f[c>>2]|0;if(!e){r=i;break}else q=i}u=b;return r|0}function NCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;b=u;u=u+16|0;c=b;d=a+8|0;e=f[d>>2]|0;if(!e){g=f[a+4>>2]|0;if(!g){h=VDc(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}else{if(f[g+64>>2]|0)OQb(g,14656,16);h=NQb(g,16,1744)|0;f[h>>2]=g;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}f[d>>2]=i;j=i}else j=e;e=j+4|0;i=f[e>>2]|0;if((i|0)>0){d=f[j+12>>2]|0;h=0;do{g=f[d+4+(h<<2)>>2]|0;h=h+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((h|0)!=(i|0));f[e>>2]=0}i=f[a+32>>2]|0;h=f[i+12>>2]|0;d=f[i+4>>2]|0;a:do if(d>>>0>h>>>0){g=f[i+16>>2]|0;k=h;while(1){l=f[g+(k<<2)>>2]|0;if(l|0)break;m=k+1|0;if(m>>>0<d>>>0)k=m;else{n=0;o=m;break a}}if((l|0)==(f[g+((k^1)<<2)>>2]|0)){n=f[(f[l>>2]|0)+16>>2]|0;o=k;break}else{n=l;o=k;break}}else{n=0;o=h}while(0);f[c>>2]=n;f[c+4>>2]=i;f[c+8>>2]=o;if(!n){u=b;return}n=a+4|0;a=j+12|0;o=j+8|0;do{i=Mi[f[(f[131660]|0)+16>>2]&1023](526640,f[n>>2]|0)|0;h=i+12|0;l=f[h>>2]|0;d=f[j>>2]|0;if(((d|0)==(l|0)?(m=f[a>>2]|0,(m|0)!=0):0)?(p=f[m>>2]|0,(p|0)<(f[o>>2]|0)):0){q=f[e>>2]|0;if((q|0)<(p|0)){r=m+4+(q<<2)|0;f[m+4+(p<<2)>>2]=f[r>>2];s=r}else s=m+4+(q<<2)|0;f[s>>2]=i;f[e>>2]=q+1;q=f[a>>2]|0;f[q>>2]=(f[q>>2]|0)+1}else SCb(j,i,l,d);d=f[(f[c>>2]|0)+12>>2]|0;l=i+16|0;f[l>>2]=f[l>>2]|1;q=i+4|0;m=f[q>>2]|0;if((m|0)==527320){WJa(q,f[h>>2]|0,527320);t=f[q>>2]|0}else t=m;iEc(t,d)|0;d=(f[(f[c>>2]|0)+12>>2]|0)+16|0;f[l>>2]=f[l>>2]|2;l=i+8|0;i=f[h>>2]|0;h=f[l>>2]|0;if(!h){if(!i){m=VDc(24)|0;JNa(m);v=m}else{if(f[i+64>>2]|0)OQb(i,14672,24);m=MQb(i,24)|0;KNa(m,i);v=m}f[l>>2]=v;w=v}else w=h;lPa(w,d);pJa(c)|0}while((f[c>>2]|0)!=0);u=b;return}function OCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+80|0;c=b+52|0;d=b+40|0;e=b;g=b+16|0;h=a+24|0;i=f[a+8>>2]|0;if(!i){rTb(g,3,456026,306);oTb(b+64|0,mTb(g,456117)|0);sTb(g)}g=f[a+32>>2]|0;a=f[g+12>>2]|0;j=f[g+4>>2]|0;a:do if(j>>>0>a>>>0){k=f[g+16>>2]|0;l=a;while(1){m=f[k+(l<<2)>>2]|0;if(m|0)break;n=l+1|0;if(n>>>0<j>>>0)l=n;else{o=0;p=n;break a}}if((m|0)==(f[k+((l^1)<<2)>>2]|0)){o=f[(f[m>>2]|0)+16>>2]|0;p=l;break}else{o=m;p=l;break}}else{o=0;p=a}while(0);f[e>>2]=o;f[e+4>>2]=g;f[e+8>>2]=p;if(o|0)do{f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];sJa(d,h,c);f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2];f[e+8>>2]=f[d+8>>2]}while((f[e>>2]|0)!=0);e=i+12|0;d=f[e>>2]|0;c=i+4|0;if(!(f[c>>2]|0)){u=b;return}i=(d|0)==0?0:d+4|0;do{d=f[i>>2]|0;o=_i[f[(f[d>>2]|0)+104>>2]&1023](d)|0;d=f[i>>2]|0;lPa(BJa(h,_i[f[(f[d>>2]|0)+100>>2]&1023](d)|0)|0,o);i=i+4|0;o=f[e>>2]|0}while((i|0)!=(((o|0)==0?0:o+4|0)+(f[c>>2]<<2)|0));u=b;return}function PCb(a){a=a|0;Wdc(a);return a+24|0}function QCb(a){a=a|0;Wdc(a);Vdc(a);return a+24|0}function RCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;a=f[f[b>>2]>>2]|0;if(!a)return;c=b+8|0;d=a+12|0;a=f[d>>2]|0;e=b+16|0;if((f[e>>2]|0)==9)g=f[c>>2]|0;else{f[e>>2]=9;e=VDc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[c>>2]=e;g=e}iEc(g,a)|0;f[b+24>>2]=(f[d>>2]|0)+16;return}function SCb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){if(!d){e=VDc(24)|0;f[e+12>>2]=0;f[e+4>>2]=527320;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)OQb(d,18960,24);e=MQb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=527320;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=106128;UCb(b,g);if((b|0)==0|(c|0)!=0)i=g;else{Yi[f[(f[b>>2]|0)+4>>2]&2047](b);i=g}}else i=b;else{TCb(d,b);i=b}b=a+12|0;d=f[b>>2]|0;g=f[a+8>>2]|0;c=a+4|0;if(d|0?(e=f[c>>2]|0,(e|0)!=(g|0)):0){h=f[d>>2]|0;if((h|0)==(g|0)){j=f[d+4+(e<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}Yi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}else{if((e|0)<(h|0)){f[d+4+(h<<2)>>2]=f[d+4+(e<<2)>>2];e=f[b>>2]|0;o=e;p=f[e>>2]|0}else{o=d;p=h}f[o>>2]=p+1;k=o;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}}USb(a,g+1|0);g=f[b>>2]|0;f[g>>2]=(f[g>>2]|0)+1;k=g;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}function TCb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function UCb(a,b){a=a|0;b=b|0;VCb(b,a);return}function VCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=b+16|0;d=f[c>>2]|0;if(!d)return;if(!(d&1))e=d;else{d=a+4|0;g=a+12|0;if((f[d>>2]|0)==527320)WJa(d,f[g>>2]|0,527320);h=_i[f[(f[b>>2]|0)+100>>2]&1023](b)|0;i=f[d>>2]|0;if((i|0)==527320)WJa(d,f[g>>2]|0,h);else iEc(i,h)|0;h=a+16|0;f[h>>2]=f[h>>2]|1;e=f[c>>2]|0}if(!(e&2))return;e=a+8|0;c=f[a+12>>2]|0;if(!(f[e>>2]|0)){if(!c){h=VDc(24)|0;JNa(h);j=h}else{if(f[c+64>>2]|0)OQb(c,14672,24);h=MQb(c,24)|0;KNa(h,c);j=h}f[e>>2]=j}j=_i[f[(f[b>>2]|0)+104>>2]&1023](b)|0;lNa(f[e>>2]|0,j);j=a+16|0;f[j>>2]=f[j>>2]|2;return}function WCb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=106244;c=a+20|0;d=f[c>>2]|0;if(d&1|0?(e=d&-2,d=e,!((e|0)==0|(f[d+4>>2]|0)!=0)):0){if(f[d>>2]|0)ljc(d);YDc(e)}f[c>>2]=0;f[a>>2]=106360;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function XCb(a){a=a|0;WCb(a);YDc(a);return}function YCb(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function ZCb(a){a=a|0;a=VDc(24)|0;f[a+12>>2]=0;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a>>2]=106128;return a|0}function _Cb(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=VDc(24)|0;f[a+12>>2]=0;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;c=a;f[c>>2]=106128;return c|0}if(f[b+64>>2]|0)OQb(b,18960,24);a=MQb(b,24)|0;d=b;f[a+12>>2]=d;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=d;c=a;f[c>>2]=106128;return c|0}function $Cb(a){a=a|0;return f[a+12>>2]|0}function aDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+4>>2]|0;do if((c|0)!=527320){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+8>>2]|0;if(!c){e=a+16|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}Yi[f[(f[c>>2]|0)+28>>2]&2047](c);e=a+16|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}function bDb(a){a=a|0;var b=0;b=f[a+8>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&1023](b)|0}function cDb(a,b){a=a|0;b=b|0;VCb(a,b);return}function dDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+4|0;j=a+12|0;k=a+8|0;a=e+4|0;l=c+32|0;m=c+12|0;n=c+28|0;a:while(1){o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){p=b[o>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=o+1;r=q}else{s=q;t=5}}else{s=0;t=5}if((t|0)==5){t=0;r=WRb(c,s)|0}switch(r|0){case 0:{v=1;t=35;break a;break}case 10:{f[h>>2]=f[h>>2]|1;q=f[i>>2]|0;if((q|0)==527320){WJa(i,f[j>>2]|0,527320);w=f[i>>2]|0}else w=q;if(!(fUb(c,w)|0)){v=0;t=35;break a}q=f[h>>2]|1;f[h>>2]=q;o=f[c>>2]|0;if(o>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[o>>0]|0)!=18)continue a;f[c>>2]=o+1;x=q;break}case 18:{x=f[h>>2]|0;break}default:{if((r&7|0)==4){v=1;t=35;break a}if(ITb(c,r)|0)continue a;else{v=0;t=35;break a}}}f[h>>2]=x|2;q=f[j>>2]|0;o=f[k>>2]|0;if(!o){if(!q){p=VDc(24)|0;JNa(p);y=p}else{if(f[q+64>>2]|0)OQb(q,14672,24);p=MQb(q,24)|0;KNa(p,q);y=p}f[k>>2]=y;z=y}else z=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(p=b[o>>0]|0,p<<24>>24>-1):0){f[c>>2]=o+1;A=p&255}else{p=VRb(c)|0;if((p|0)>-1)A=p;else{v=0;t=35;break}}GRb(e,c,A);if((f[a>>2]|0)<0){t=27;break}if(!(BOa(z,c)|0)){t=27;break}if(!(LRb(c,f[e>>2]|0)|0)){v=0;t=35;break}f[h>>2]=f[h>>2]|2;if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[l>>2]|0){t=32;break}if((f[m>>2]|0)==(f[n>>2]|0)){t=32;break}}if((t|0)==27){v=0;u=d;return v|0}else if((t|0)==32){f[c+20>>2]=0;b[c+24>>0]=1;v=1;u=d;return v|0}else if((t|0)==35){u=d;return v|0}return 0}function eDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=AOa(_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0)|0;j=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function fDb(a,b){a=a|0;b=b|0;_Tb(1,_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0,b);eUb(2,_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0,b);return}function gDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0;a=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;j=a+1+((((($(a|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function hDb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;b[d>>0]=10;g=dSb(e,d+1|0)|0;d=_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0;b[g>>0]=18;a=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(g>>>0>127){e=g;h=a;while(1){b[h>>0]=e|128;i=e>>>7;j=h+1|0;if(e>>>0>16383){e=i;h=j}else{k=j;l=i;break}}}else{k=a;l=g}b[k>>0]=l;return hj[f[(f[d>>2]|0)+64>>2]&511](d,c,k+1|0)|0}function iDb(a,b){a=a|0;b=b|0;hec(a,b);return}function jDb(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (_i[f[(f[b>>2]|0)+84>>2]&1023](b)|0)+28|0}function kDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220458]|0)!=2){f[d>>2]=161028;f[d+4>>2]=110;b[d+8>>0]=0;DTb(881832,d);ZSb(d)}d=526832;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function lDb(a){a=a|0;return f[a+4>>2]|0}function mDb(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (b|0?b:f[131662]|0)|0}function nDb(a){a=a|0;var c=0;f[a>>2]=106360;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function oDb(a){a=a|0;var c=0;f[a>>2]=106360;if(f[a+12>>2]|0){YDc(a);return}c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c){YDc(a);return}Yi[f[(f[c>>2]|0)+4>>2]&2047](c);YDc(a);return}function pDb(a){a=a|0;WCb(a);YDc(a);return}function qDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=105936;c=f[a+92>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+56|0;f[c>>2]=106044;cJa(a+80|0);Bcc(c);c=a+52|0;d=f[c>>2]|0;if(d|0?(f[a+40>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+36|0;i=f[c>>2]|0;if(i|0?(f[a+24>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);YDc(g)}e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+20|0;j=f[c>>2]|0;if(j|0?(f[a+8>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(k);f[c>>2]=0;return}function rDb(a){a=a|0;qDb(a);YDc(a);return}function sDb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function tDb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(100)|0;CCb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,18928,104);a=MQb(b,104)|0;ECb(a,b);c=a;return c|0}function uDb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function vDb(a){a=a|0;return f[a+4>>2]|0}function wDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=a+12|0;i=f[h>>2]|0;if((i|0)>0){j=f[a+20>>2]|0;k=0;do{l=f[j+4+(k<<2)>>2]|0;k=k+1|0;m=l+11|0;if((b[m>>0]|0)<0){b[f[l>>2]>>0]=0;f[l+4>>2]=0}else{b[l>>0]=0;b[m>>0]=0}}while((k|0)!=(i|0));f[h>>2]=0}h=a+28|0;i=f[h>>2]|0;if((i|0)>0){k=f[a+36>>2]|0;j=0;do{m=f[k+4+(j<<2)>>2]|0;j=j+1|0;l=m+11|0;if((b[l>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0}else{b[m>>0]=0;b[l>>0]=0}}while((j|0)!=(i|0));f[h>>2]=0}h=a+44|0;i=f[h>>2]|0;if((i|0)>0){j=f[a+52>>2]|0;k=0;do{l=f[j+4+(k<<2)>>2]|0;k=k+1|0;m=l+11|0;if((b[m>>0]|0)<0){b[f[l>>2]>>0]=0;f[l+4>>2]=0}else{b[l>>0]=0;b[m>>0]=0}}while((k|0)!=(i|0));f[h>>2]=0}h=a+56|0;Wdc(h);i=a+80|0;k=f[a+88>>2]|0;j=f[k+12>>2]|0;m=f[k+4>>2]|0;a:do if(m>>>0>j>>>0){l=f[k+16>>2]|0;n=j;while(1){o=f[l+(n<<2)>>2]|0;if(o|0)break;p=n+1|0;if(p>>>0<m>>>0)n=p;else{q=0;r=p;break a}}if((o|0)==(f[l+((n^1)<<2)>>2]|0)){q=f[(f[o>>2]|0)+16>>2]|0;r=n;break}else{q=o;r=n;break}}else{q=0;r=j}while(0);f[g>>2]=q;f[g+4>>2]=k;f[g+8>>2]=r;if(q|0)do{f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];sJa(e,i,d);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2]}while((f[g>>2]|0)!=0);Vdc(h);h=a+4|0;g=f[a+92>>2]|0;do if((g|0)!=527320){a=g+11|0;if((b[a>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[a>>0]=0;break}}while(0);g=f[h>>2]|0;if(!(g&1)){u=c;return}h=g&-2;if(!(f[h>>2]|0)){u=c;return}ljc(h);u=c;return}function xDb(a){a=a|0;return 1}function yDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=a+8|0;j=a+12|0;k=a+20|0;l=a+92|0;m=a+4|0;n=a+92|0;o=a+24|0;p=a+28|0;q=a+36|0;r=a+40|0;s=a+44|0;t=a+52|0;v=a+56|0;a=g+4|0;w=g+8|0;x=g+24|0;y=e+4|0;z=w+11|0;A=g+12|0;a:while(1){B=f[c>>2]|0;if(B>>>0<(f[h>>2]|0)>>>0){C=b[B>>0]|0;D=C&255;if(C<<24>>24>0){f[c>>2]=B+1;E=D;F=6}else{G=D;F=5}}else{G=0;F=5}if((F|0)==5){F=0;D=WRb(c,G)|0;if((D+-1|0)>>>0<127){E=D;F=6}else H=D}b:do if((F|0)==6){F=0;switch(E>>>3&536870911|0){case 1:{if((E&255|0)!=10){H=E;break b}if(!(fUb(c,JLa(i)|0)|0)){I=0;F=57;break a}D=f[(f[k>>2]|0)+4+((f[j>>2]|0)+-1<<2)>>2]|0;B=b[D+11>>0]|0;if(B<<24>>24<0){J=f[D>>2]|0;K=f[D+4>>2]|0}else{J=D;K=B&255}if(gUb(J,K,0,456917)|0)continue a;else{I=0;F=57;break a}break}case 2:{if((E&255|0)!=18){H=E;break b}B=f[m>>2]|0;D=B&-2;if(!(B&1))L=D;else L=f[D+4>>2]|0;D=f[l>>2]|0;if((D|0)==527320){WJa(l,L,527320);M=f[l>>2]|0}else M=D;if(!(fUb(c,M)|0)){I=0;F=57;break a}D=f[n>>2]|0;B=b[D+11>>0]|0;if(B<<24>>24<0){N=f[D>>2]|0;O=f[D+4>>2]|0}else{N=D;O=B&255}if(gUb(N,O,0,456956)|0)continue a;else{I=0;F=57;break a}break}case 3:{if((E&255|0)!=26){H=E;break b}if(!(fUb(c,JLa(o)|0)|0)){I=0;F=57;break a}B=f[(f[q>>2]|0)+4+((f[p>>2]|0)+-1<<2)>>2]|0;D=b[B+11>>0]|0;if(D<<24>>24<0){P=f[B>>2]|0;Q=f[B+4>>2]|0}else{P=B;Q=D&255}if(gUb(P,Q,0,456994)|0)continue a;else{I=0;F=57;break a}break}case 4:{if((E&255|0)!=34){H=E;break b}if(!(fUb(c,JLa(r)|0)|0)){I=0;F=57;break a}D=f[(f[t>>2]|0)+4+((f[s>>2]|0)+-1<<2)>>2]|0;B=b[D+11>>0]|0;if(B<<24>>24<0){R=f[D>>2]|0;S=f[D+4>>2]|0}else{R=D;S=B&255}if(gUb(R,S,0,457033)|0)continue a;else{I=0;F=57;break a}break}case 5:{if((E&255|0)!=42){H=E;break b}f[g>>2]=v;B=_i[f[(f[v>>2]|0)+68>>2]&1023](v)|0;f[a>>2]=B;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[x>>2]=0;B=f[c>>2]|0;if(B>>>0<(f[h>>2]|0)>>>0?(D=b[B>>0]|0,D<<24>>24>-1):0){f[c>>2]=B+1;T=D&255;F=41}else{D=VRb(c)|0;if((D|0)>-1){T=D;F=41}else U=6}do if((F|0)==41){F=0;GRb(e,c,T);if((f[y>>2]|0)>=0?MDb(g,c)|0:0){if(!(LRb(c,f[e>>2]|0)|0)){U=6;break}D=b[z>>0]|0;B=D<<24>>24<0;C=gUb(B?f[w>>2]|0:w,B?f[A>>2]|0:D&255,0,457072)|0;U=C?0:6;break}U=6}while(0);C=f[x>>2]|0;if(C|0)Yi[f[(f[C>>2]|0)+4>>2]&2047](C);if((b[z>>0]|0)<0)YDc(f[w>>2]|0);switch(U&7){case 0:{continue a;break}case 6:{I=0;F=57;break a;break}default:{F=56;break a}}break}default:{H=E;break b}}}while(0);if(!H){F=56;break}C=f[m>>2]|0;if(!(C&1))V=mNa(m)|0;else V=C&-2;if(!(Djc(c,H,V)|0)){I=0;F=57;break}}if((F|0)==56){I=1;u=d;return I|0}else if((F|0)==57){u=d;return I|0}return 0}function zDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;if((e&1|0)!=0&(b[473420]|0)!=0)g=Jjc(e&-2)|0;else g=0;e=f[a+12>>2]|0;h=e+g|0;if((e|0)>0){g=f[a+20>>2]|0;i=0;j=h;while(1){k=f[g+4+(i<<2)>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0?f[k+4>>2]|0:l&255;l=m+j+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(e|0)){n=l;break}else j=l}}else n=h;h=f[a+28>>2]|0;j=h+n|0;if((h|0)>0){n=f[a+36>>2]|0;e=0;i=j;while(1){g=f[n+4+(e<<2)>>2]|0;l=b[g+11>>0]|0;m=l<<24>>24<0?f[g+4>>2]|0:l&255;l=m+i+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(h|0)){o=l;break}else i=l}}else o=j;j=f[a+44>>2]|0;i=j+o|0;if((j|0)>0){o=f[a+52>>2]|0;h=0;e=i;while(1){n=f[o+4+(h<<2)>>2]|0;l=b[n+11>>0]|0;m=l<<24>>24<0?f[n+4>>2]|0:l&255;l=m+e+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(j|0)){p=l;break}else e=l}}else p=i;i=a+56|0;Wdc(i);e=a+88|0;j=f[f[e>>2]>>2]|0;Wdc(i);h=j+p|0;p=f[e>>2]|0;e=f[p+12>>2]|0;j=f[p+4>>2]|0;a:do if(j>>>0>e>>>0){o=f[p+16>>2]|0;l=e;while(1){q=f[o+(l<<2)>>2]|0;if(q|0)break;m=l+1|0;if(m>>>0<j>>>0)l=m;else{r=0;s=m;break a}}if((q|0)==(f[o+((l^1)<<2)>>2]|0)){r=f[(f[q>>2]|0)+16>>2]|0;s=l;break}else{r=q;s=l;break}}else{r=0;s=e}while(0);f[d>>2]=r;f[d+4>>2]=p;f[d+8>>2]=s;s=a+76|0;p=h;h=0;while(1){Wdc(i);r=f[d>>2]|0;if(!r)break;if(!h){t=0;v=r}else{r=(_i[f[(f[h>>2]|0)+20>>2]&1023](h)|0)==0;t=r?h:0;v=f[d>>2]|0}r=f[v+12>>2]|0;e=r+16|0;q=f[s>>2]|0;if(!q){j=VDc(32)|0;f[j+12>>2]=0;f[j+4>>2]=527320;f[j+8>>2]=0;f[j+20>>2]=0;w=j}else{if(f[q+64>>2]|0)OQb(q,19008,32);j=MQb(q,32)|0;m=q;f[j+12>>2]=m;f[j+4>>2]=527320;f[j+8>>2]=0;f[j+20>>2]=m;w=j}f[w>>2]=106476;f[w+24>>2]=r;f[w+28>>2]=e;f[w+16>>2]=3;if((t|0)!=(w|0))if(!t)x=w;else{Yi[f[(f[t>>2]|0)+4>>2]&2047](t);x=w}else x=t;e=x+16|0;r=f[e>>2]|0;if(!(r&1)){y=r;z=0}else{r=_i[f[(f[x>>2]|0)+100>>2]&1023](x)|0;j=b[r+11>>0]|0;m=j<<24>>24<0?f[r+4>>2]|0:j&255;j=m+1+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;y=f[e>>2]|0;z=j}if(!(y&2))A=0;else{j=AOa(_i[f[(f[x>>2]|0)+104>>2]&1023](x)|0)|0;A=j+1+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}j=A+z|0;e=j+p+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;pJa(d)|0;p=e;h=x}if(h|0?(_i[f[(f[h>>2]|0)+20>>2]&1023](h)|0)==0:0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);h=f[a+92>>2]|0;x=b[h+11>>0]|0;d=x<<24>>24<0;if(d)B=f[h+4>>2]|0;else B=x&255;if(!B){C=p;D=a+96|0;f[D>>2]=C;u=c;return C|0}B=d?f[h+4>>2]|0:x&255;C=p+1+B+((((($(B|1|0)|0)^31)*9|0)+73|0)>>>6)|0;D=a+96|0;f[D>>2]=C;u=c;return C|0}function ADb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+16|0;e=d;g=f[a+12>>2]|0;if((g|0)>0){h=a+20|0;i=0;do{j=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;k=b[j+11>>0]|0;if(k<<24>>24<0){l=f[j>>2]|0;m=f[j+4>>2]|0}else{l=j;m=k&255}gUb(l,m,1,456917)|0;_Tb(1,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}g=a+92|0;i=f[g>>2]|0;h=b[i+11>>0]|0;m=h<<24>>24<0;if(m)n=f[i+4>>2]|0;else n=h&255;if(n|0){if(m){o=f[i>>2]|0;p=f[i+4>>2]|0}else{o=i;p=h&255}gUb(o,p,1,456956)|0;$Tb(2,f[g>>2]|0,c)}g=f[a+28>>2]|0;if((g|0)>0){p=a+36|0;o=0;do{h=f[(f[p>>2]|0)+4+(o<<2)>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){q=f[h>>2]|0;r=f[h+4>>2]|0}else{q=h;r=i&255}gUb(q,r,1,456994)|0;_Tb(3,f[(f[p>>2]|0)+4+(o<<2)>>2]|0,c);o=o+1|0}while((o|0)!=(g|0))}g=f[a+44>>2]|0;if((g|0)>0){o=a+52|0;p=0;do{r=f[(f[o>>2]|0)+4+(p<<2)>>2]|0;q=b[r+11>>0]|0;if(q<<24>>24<0){s=f[r>>2]|0;t=f[r+4>>2]|0}else{s=r;t=q&255}gUb(s,t,1,457033)|0;_Tb(4,f[(f[o>>2]|0)+4+(p<<2)>>2]|0,c);p=p+1|0}while((p|0)!=(g|0))}g=a+56|0;Wdc(g);p=a+88|0;do if(f[f[p>>2]>>2]|0){if(!(b[c+18>>0]|0)){if(f[220805]|0)v=31}else if(b[c+19>>0]|0)v=31;if((v|0)==31?(Wdc(g),(f[f[p>>2]>>2]|0)>>>0>1):0){Wdc(g);o=f[f[p>>2]>>2]|0;t=XDc(o>>>0>1073741823?-1:o<<2)|0;Wdc(g);o=f[p>>2]|0;s=f[o+12>>2]|0;q=f[o+4>>2]|0;a:do if(q>>>0>s>>>0){r=f[o+16>>2]|0;i=s;while(1){w=f[r+(i<<2)>>2]|0;if(w|0)break;h=i+1|0;if(h>>>0<q>>>0)i=h;else{x=0;y=h;break a}}if((w|0)==(f[r+((i^1)<<2)>>2]|0)){x=f[(f[w>>2]|0)+16>>2]|0;y=i;break}else{x=w;y=i;break}}else{x=0;y=s}while(0);f[e>>2]=x;f[e+4>>2]=o;f[e+8>>2]=y;s=0;while(1){Wdc(g);q=f[e>>2]|0;if(!q)break;f[t+(s<<2)>>2]=f[q+12>>2];pJa(e)|0;s=s+1|0}fOa(t,t+(s<<2)|0,e);if(s|0){o=a+76|0;q=0;h=0;do{m=t+(q<<2)|0;n=f[m>>2]|0;l=n+16|0;k=f[o>>2]|0;if(!k){j=VDc(32)|0;f[j+12>>2]=0;f[j+4>>2]=527320;f[j+8>>2]=0;f[j+20>>2]=0;z=j}else{if(f[k+64>>2]|0)OQb(k,19008,32);j=MQb(k,32)|0;A=k;f[j+12>>2]=A;f[j+4>>2]=527320;f[j+8>>2]=0;f[j+20>>2]=A;z=j}f[z>>2]=106476;f[z+24>>2]=n;f[z+28>>2]=l;f[z+16>>2]=3;if((h|0)!=(z|0))if(!h)B=z;else{Yi[f[(f[h>>2]|0)+4>>2]&2047](h);B=z}else B=h;eUb(5,B,c);l=(_i[f[(f[B>>2]|0)+20>>2]&1023](B)|0)==0;h=l?B:0;l=f[m>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){C=f[l>>2]|0;D=f[l+4>>2]|0}else{C=l;D=m&255}gUb(C,D,1,457072)|0;q=q+1|0}while(q>>>0<s>>>0);if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h)}ZDc(t);break}Wdc(g);s=f[p>>2]|0;q=f[s+12>>2]|0;o=f[s+4>>2]|0;b:do if(o>>>0>q>>>0){m=f[s+16>>2]|0;l=q;while(1){E=f[m+(l<<2)>>2]|0;if(E|0)break;n=l+1|0;if(n>>>0<o>>>0)l=n;else{F=0;G=n;break b}}if((E|0)==(f[m+((l^1)<<2)>>2]|0)){F=f[(f[E>>2]|0)+16>>2]|0;G=l;break}else{F=E;G=l;break}}else{F=0;G=q}while(0);f[e>>2]=F;f[e+4>>2]=s;f[e+8>>2]=G;q=a+76|0;o=0;while(1){Wdc(g);t=f[e>>2]|0;if(!t)break;h=f[t+12>>2]|0;t=h+16|0;i=f[q>>2]|0;if(!i){r=VDc(32)|0;f[r+12>>2]=0;f[r+4>>2]=527320;f[r+8>>2]=0;f[r+20>>2]=0;H=r}else{if(f[i+64>>2]|0)OQb(i,19008,32);r=MQb(i,32)|0;n=i;f[r+12>>2]=n;f[r+4>>2]=527320;f[r+8>>2]=0;f[r+20>>2]=n;H=r}f[H>>2]=106476;f[H+24>>2]=h;f[H+28>>2]=t;f[H+16>>2]=3;if((o|0)!=(H|0))if(!o)I=H;else{Yi[f[(f[o>>2]|0)+4>>2]&2047](o);I=H}else I=o;eUb(5,I,c);t=(_i[f[(f[I>>2]|0)+20>>2]&1023](I)|0)==0;h=f[(f[e>>2]|0)+12>>2]|0;r=b[h+11>>0]|0;if(r<<24>>24<0){J=f[h>>2]|0;K=f[h+4>>2]|0}else{J=h;K=r&255}gUb(J,K,1,457072)|0;pJa(e)|0;o=t?I:0}if(o|0)Yi[f[(f[o>>2]|0)+4>>2]&2047](o)}while(0);I=f[a+4>>2]|0;if(!((I&1|0)!=0&(b[473420]|0)!=0)){u=d;return}Gjc(I&-2,c);u=d;return}function BDb(a){a=a|0;return f[a+96>>2]|0}function CDb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+16|0;g=e;h=f[a+12>>2]|0;if((h|0)>0){i=a+20|0;j=d;k=0;while(1){l=f[(f[i>>2]|0)+4+(k<<2)>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){n=f[l>>2]|0;o=f[l+4>>2]|0}else{n=l;o=m&255}gUb(n,o,1,456917)|0;m=f[(f[i>>2]|0)+4+(k<<2)>>2]|0;b[j>>0]=10;l=dSb(m,j+1|0)|0;k=k+1|0;if((k|0)==(h|0)){p=l;break}else j=l}}else p=d;d=a+92|0;j=f[d>>2]|0;h=b[j+11>>0]|0;k=h<<24>>24<0;if(k)q=f[j+4>>2]|0;else q=h&255;if(!q)r=p;else{if(k){s=f[j>>2]|0;t=f[j+4>>2]|0}else{s=j;t=h&255}gUb(s,t,1,456956)|0;t=f[d>>2]|0;b[p>>0]=18;r=dSb(t,p+1|0)|0}p=f[a+28>>2]|0;if((p|0)>0){t=a+36|0;d=0;s=r;while(1){h=f[(f[t>>2]|0)+4+(d<<2)>>2]|0;j=b[h+11>>0]|0;if(j<<24>>24<0){v=f[h>>2]|0;w=f[h+4>>2]|0}else{v=h;w=j&255}gUb(v,w,1,456994)|0;j=f[(f[t>>2]|0)+4+(d<<2)>>2]|0;b[s>>0]=26;h=dSb(j,s+1|0)|0;d=d+1|0;if((d|0)==(p|0)){x=h;break}else s=h}}else x=r;r=f[a+44>>2]|0;if((r|0)>0){s=a+52|0;p=0;d=x;while(1){t=f[(f[s>>2]|0)+4+(p<<2)>>2]|0;w=b[t+11>>0]|0;if(w<<24>>24<0){y=f[t>>2]|0;z=f[t+4>>2]|0}else{y=t;z=w&255}gUb(y,z,1,457033)|0;w=f[(f[s>>2]|0)+4+(p<<2)>>2]|0;b[d>>0]=34;t=dSb(w,d+1|0)|0;p=p+1|0;if((p|0)==(r|0)){A=t;break}else d=t}}else A=x;x=a+56|0;Wdc(x);d=a+88|0;do if(f[f[d>>2]>>2]|0){if(c?(Wdc(x),(f[f[d>>2]>>2]|0)>>>0>1):0){Wdc(x);r=f[f[d>>2]>>2]|0;p=XDc(r>>>0>1073741823?-1:r<<2)|0;Wdc(x);r=f[d>>2]|0;s=f[r+12>>2]|0;z=f[r+4>>2]|0;a:do if(z>>>0>s>>>0){y=f[r+16>>2]|0;t=s;while(1){B=f[y+(t<<2)>>2]|0;if(B|0)break;w=t+1|0;if(w>>>0<z>>>0)t=w;else{C=0;D=w;break a}}if((B|0)==(f[y+((t^1)<<2)>>2]|0)){C=f[(f[B>>2]|0)+16>>2]|0;D=t;break}else{C=B;D=t;break}}else{C=0;D=s}while(0);f[g>>2]=C;f[g+4>>2]=r;f[g+8>>2]=D;s=0;while(1){Wdc(x);z=f[g>>2]|0;if(!z)break;f[p+(s<<2)>>2]=f[z+12>>2];pJa(g)|0;s=s+1|0}fOa(p,p+(s<<2)|0,g);if(s){r=a+76|0;z=0;w=A;v=0;do{h=p+(z<<2)|0;j=f[h>>2]|0;k=j+16|0;q=f[r>>2]|0;if(!q){i=VDc(32)|0;f[i+12>>2]=0;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+20>>2]=0;E=i}else{if(f[q+64>>2]|0)OQb(q,19008,32);i=MQb(q,32)|0;o=q;f[i+12>>2]=o;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+20>>2]=o;E=i}f[E>>2]=106476;f[E+24>>2]=j;f[E+28>>2]=k;f[E+16>>2]=3;if((v|0)!=(E|0))if(!v)F=E;else{Yi[f[(f[v>>2]|0)+4>>2]&2047](v);F=E}else F=v;b[w>>0]=42;k=w+1|0;j=F+16|0;i=f[j>>2]|0;if(!(i&1)){G=i;H=0}else{i=_i[f[(f[F>>2]|0)+100>>2]&1023](F)|0;o=b[i+11>>0]|0;q=o<<24>>24<0?f[i+4>>2]|0:o&255;o=q+1+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;G=f[j>>2]|0;H=o}if(!(G&2))I=0;else{o=_i[f[(f[F>>2]|0)+104>>2]&1023](F)|0;j=_i[f[(f[o>>2]|0)+60>>2]&1023](o)|0;I=j+1+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}j=I+H|0;if(j>>>0>127){o=j;q=k;while(1){b[q>>0]=o|128;i=o>>>7;n=q+1|0;if(o>>>0>16383){o=i;q=n}else{J=n;K=i;break}}}else{J=k;K=j}b[J>>0]=K;q=_i[f[(f[F>>2]|0)+100>>2]&1023](F)|0;b[J+1>>0]=10;o=dSb(q,J+2|0)|0;q=_i[f[(f[F>>2]|0)+104>>2]&1023](F)|0;b[o>>0]=18;t=o+1|0;o=_i[f[(f[q>>2]|0)+60>>2]&1023](q)|0;if(o>>>0>127){y=o;i=t;while(1){b[i>>0]=y|128;n=y>>>7;l=i+1|0;if(y>>>0>16383){y=n;i=l}else{L=l;M=n;break}}}else{L=t;M=o}b[L>>0]=M;w=hj[f[(f[q>>2]|0)+64>>2]&511](q,1,L+1|0)|0;i=(_i[f[(f[F>>2]|0)+20>>2]&1023](F)|0)==0;v=i?F:0;i=f[h>>2]|0;y=b[i+11>>0]|0;if(y<<24>>24<0){N=f[i>>2]|0;O=f[i+4>>2]|0}else{N=i;O=y&255}gUb(N,O,1,457072)|0;z=z+1|0}while(z>>>0<s>>>0);if(!v)P=w;else{Yi[f[(f[v>>2]|0)+4>>2]&2047](v);P=w}}else P=A;ZDc(p);Q=P;break}Wdc(x);s=f[d>>2]|0;z=f[s+12>>2]|0;r=f[s+4>>2]|0;b:do if(r>>>0>z>>>0){y=f[s+16>>2]|0;i=z;while(1){R=f[y+(i<<2)>>2]|0;if(R|0)break;j=i+1|0;if(j>>>0<r>>>0)i=j;else{S=0;T=j;break b}}if((R|0)==(f[y+((i^1)<<2)>>2]|0)){S=f[(f[R>>2]|0)+16>>2]|0;T=i;break}else{S=R;T=i;break}}else{S=0;T=z}while(0);f[g>>2]=S;f[g+4>>2]=s;f[g+8>>2]=T;z=a+76|0;r=A;p=0;while(1){Wdc(x);w=f[g>>2]|0;if(!w)break;v=f[w+12>>2]|0;w=v+16|0;h=f[z>>2]|0;if(!h){q=VDc(32)|0;f[q+12>>2]=0;f[q+4>>2]=527320;f[q+8>>2]=0;f[q+20>>2]=0;U=q}else{if(f[h+64>>2]|0)OQb(h,19008,32);q=MQb(h,32)|0;o=h;f[q+12>>2]=o;f[q+4>>2]=527320;f[q+8>>2]=0;f[q+20>>2]=o;U=q}f[U>>2]=106476;f[U+24>>2]=v;f[U+28>>2]=w;f[U+16>>2]=3;if((p|0)!=(U|0))if(!p)V=U;else{Yi[f[(f[p>>2]|0)+4>>2]&2047](p);V=U}else V=p;b[r>>0]=42;w=r+1|0;v=V+16|0;q=f[v>>2]|0;if(!(q&1)){W=q;X=0}else{q=_i[f[(f[V>>2]|0)+100>>2]&1023](V)|0;o=b[q+11>>0]|0;h=o<<24>>24<0?f[q+4>>2]|0:o&255;o=h+1+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;W=f[v>>2]|0;X=o}if(!(W&2))Y=0;else{o=_i[f[(f[V>>2]|0)+104>>2]&1023](V)|0;v=_i[f[(f[o>>2]|0)+60>>2]&1023](o)|0;Y=v+1+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0}v=Y+X|0;if(v>>>0>127){o=v;h=w;while(1){b[h>>0]=o|128;q=o>>>7;t=h+1|0;if(o>>>0>16383){o=q;h=t}else{Z=t;_=q;break}}}else{Z=w;_=v}b[Z>>0]=_;h=_i[f[(f[V>>2]|0)+100>>2]&1023](V)|0;b[Z+1>>0]=10;o=dSb(h,Z+2|0)|0;h=_i[f[(f[V>>2]|0)+104>>2]&1023](V)|0;b[o>>0]=18;i=o+1|0;o=_i[f[(f[h>>2]|0)+60>>2]&1023](h)|0;if(o>>>0>127){y=o;q=i;while(1){b[q>>0]=y|128;t=y>>>7;j=q+1|0;if(y>>>0>16383){y=t;q=j}else{aa=j;ba=t;break}}}else{aa=i;ba=o}b[aa>>0]=ba;q=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,aa+1|0)|0;y=(_i[f[(f[V>>2]|0)+20>>2]&1023](V)|0)==0;v=f[(f[g>>2]|0)+12>>2]|0;w=b[v+11>>0]|0;if(w<<24>>24<0){ca=f[v>>2]|0;da=f[v+4>>2]|0}else{ca=v;da=w&255}gUb(ca,da,1,457072)|0;pJa(g)|0;r=q;p=y?V:0}if(!p)Q=r;else{Yi[f[(f[p>>2]|0)+4>>2]&2047](p);Q=r}}else Q=A;while(0);A=f[a+4>>2]|0;if(!((A&1|0)!=0&(b[473420]|0)!=0)){ea=Q;u=e;return ea|0}ea=Hjc(A&-2,Q)|0;u=e;return ea|0}function DDb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function EDb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,18928,0)|0;if(!c){Ehc(b,a);return}else{HDb(a,c);return}}function FDb(a,b){a=a|0;b=b|0;f[a+96>>2]=b;return}function GDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220458]|0)!=2){f[d>>2]=161028;f[d+4>>2]=110;b[d+8>>0]=0;DTb(881832,d);ZSb(d)}d=526840;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function HDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}yNa(a+8|0,c+8|0);yNa(a+24|0,c+24|0);yNa(a+40|0,c+40|0);IDb(a+56|0,c+56|0);e=f[c+92>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)i=f[e+4>>2]|0;else i=c&255;if(!i)return;i=a+92|0;a=f[d>>2]|0;d=a&-2;if(!(a&1))j=d;else j=f[d+4>>2]|0;d=f[i>>2]|0;if((d|0)==527320){WJa(i,j,e);return}else{iEc(d,e)|0;return}}function IDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;Wdc(a);Wdc(b);e=f[b+32>>2]|0;b=f[e+12>>2]|0;g=f[e+4>>2]|0;a:do if(g>>>0>b>>>0){h=f[e+16>>2]|0;i=b;while(1){j=f[h+(i<<2)>>2]|0;if(j|0)break;k=i+1|0;if(k>>>0<g>>>0)i=k;else{l=0;m=k;break a}}if((j|0)==(f[h+((i^1)<<2)>>2]|0)){l=f[(f[j>>2]|0)+16>>2]|0;m=i;break}else{l=j;m=i;break}}else{l=0;m=b}while(0);f[d>>2]=l;f[d+4>>2]=e;f[d+8>>2]=m;if(!l){Vdc(a);u=c;return}m=a+24|0;e=l;do{l=f[e+12>>2]|0;lPa(BJa(m,l)|0,l+16|0);pJa(d)|0;e=f[d>>2]|0}while((e|0)!=0);Vdc(a);u=c;return}function JDb(a){a=a|0;WCb(a);YDc(a);return}function KDb(a){a=a|0;return f[a+24>>2]|0}function LDb(a){a=a|0;return f[a+28>>2]|0}function MDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=f[c>>2]|0;j=c+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(b[i>>0]|0)==10:0){f[c>>2]=i+1;i=a+8|0;if(!(fUb(c,i)|0)){k=0;u=d;return k|0}l=f[c>>2]|0;if((((f[j>>2]|0)-l|0)>0?(b[l>>0]|0)==18:0)?(l=a+4|0,m=f[l>>2]|0,n=f[f[m+8>>2]>>2]|0,o=BJa(m,i)|0,m=a+20|0,f[m>>2]=o,(n|0)!=(f[f[(f[l>>2]|0)+8>>2]>>2]|0)):0){n=f[j>>2]|0;p=f[c>>2]|0;q=n-p|0;if((q|0)<1){PRb(c,1,q)|0;r=f[c>>2]|0;s=f[j>>2]|0;t=f[m>>2]|0}else{m=p+1|0;f[c>>2]=m;r=m;s=n;t=o}if(r>>>0<s>>>0?(s=b[r>>0]|0,s<<24>>24>-1):0){f[c>>2]=r+1;v=s&255;w=14}else w=13;if((w|0)==13?(s=VRb(c)|0,(s|0)>-1):0){v=s;w=14}do if(((w|0)==14?(GRb(e,c,v),(f[e+4>>2]|0)>=0):0)?BOa(t,c)|0:0){if(!(LRb(c,f[e>>2]|0)|0))break;do if((f[c>>2]|0)==(f[j>>2]|0)){if((f[c+32>>2]|0)==0?(f[c+12>>2]|0)!=(f[c+28>>2]|0):0)break;f[c+20>>2]=0;b[c+24>>0]=1;k=1;u=d;return k|0}while(0);k=NDb(a,c)|0;u=d;return k|0}while(0);j=f[l>>2]|0;bJa(e,f[j+8>>2]|0,i,0);i=f[e>>2]|0;l=f[e+4>>2]|0;t=f[e+8>>2]|0;if(i|0){f[g>>2]=i;f[g+4>>2]=l;f[g+8>>2]=t;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];sJa(h,j,e)}k=0;u=d;return k|0}}else w=26;if((w|0)==26?(f[e>>2]=0,f[e+4>>2]=0,f[e+8>>2]=0,iEc(a+8|0,e)|0,(b[e+11>>0]|0)<0):0)YDc(f[e>>2]|0);e=f[(f[a>>2]|0)+20>>2]|0;if(!e){w=VDc(24)|0;f[w+12>>2]=0;f[w+4>>2]=527320;f[w+8>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;x=w}else{if(f[e+64>>2]|0)OQb(e,18960,24);w=MQb(e,24)|0;j=e;f[w+12>>2]=j;f[w+4>>2]=527320;f[w+8>>2]=0;f[w+16>>2]=0;f[w+20>>2]=j;x=w}f[x>>2]=106128;w=a+24|0;j=f[w>>2]|0;if((j|0)==(x|0))y=x;else{if(j|0)Yi[f[(f[j>>2]|0)+4>>2]&2047](j);f[w>>2]=x;y=x}x=y+16|0;f[x>>2]=f[x>>2]|1;x=y+4|0;j=f[x>>2]|0;if((j|0)==527320){WJa(x,f[y+12>>2]|0,527320);z=f[x>>2]|0}else z=j;iEc(z,a+8|0)|0;z=f[w>>2]|0;j=Mi[f[(f[z>>2]|0)+44>>2]&1023](z,c)|0;if(j)ODb(a);a=f[w>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){k=j;u=d;return k|0}f[w>>2]=0;k=j;u=d;return k|0}function NDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+48|0;d=c;e=c+28|0;g=c+16|0;h=f[(f[a>>2]|0)+20>>2]|0;if(!h){i=VDc(24)|0;f[i+12>>2]=0;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=i}else{if(f[h+64>>2]|0)OQb(h,18960,24);i=MQb(h,24)|0;k=h;f[i+12>>2]=k;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+16>>2]=0;f[i+20>>2]=k;j=i}f[j>>2]=106128;i=a+24|0;k=f[i>>2]|0;if((k|0)==(j|0))l=j;else{if(k|0)Yi[f[(f[k>>2]|0)+4>>2]&2047](k);f[i>>2]=j;l=j}j=f[a+20>>2]|0;k=l+16|0;f[k>>2]=f[k>>2]|2;k=l+8|0;h=f[l+12>>2]|0;l=f[k>>2]|0;if(!l){if(!h){m=VDc(24)|0;JNa(m);n=m}else{if(f[h+64>>2]|0)OQb(h,14672,24);m=MQb(h,24)|0;KNa(m,h);n=m}f[k>>2]=n;o=n}else o=l;POa(o,j);j=f[a+4>>2]|0;o=a+8|0;bJa(d,f[j+8>>2]|0,o,0);l=f[d>>2]|0;n=f[d+4>>2]|0;k=f[d+8>>2]|0;if(l|0){f[e>>2]=l;f[e+4>>2]=n;f[e+8>>2]=k;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];sJa(g,j,d)}j=f[i>>2]|0;g=j+16|0;f[g>>2]=f[g>>2]|1;g=j+4|0;e=f[g>>2]|0;if((e|0)==527320){WJa(g,f[j+12>>2]|0,527320);p=f[g>>2]|0}else p=e;f[d>>2]=f[p>>2];f[d+4>>2]=f[p+4>>2];f[d+8>>2]=f[p+8>>2];f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];f[p+8>>2]=f[o+8>>2];f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];f[o+8>>2]=f[d+8>>2];d=f[i>>2]|0;o=Mi[f[(f[d>>2]|0)+44>>2]&1023](d,b)|0;if(o)ODb(a);a=f[i>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){u=c;return o|0}f[i>>2]=0;u=c;return o|0}function ODb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+24|0;c=f[b>>2]|0;d=a+8|0;iEc(d,_i[f[(f[c>>2]|0)+100>>2]&1023](c)|0)|0;c=BJa(f[a+4>>2]|0,d)|0;d=a+20|0;f[d>>2]=c;a=f[b>>2]|0;b=a+16|0;f[b>>2]=f[b>>2]|2;b=a+8|0;e=f[a+12>>2]|0;a=f[b>>2]|0;if(a|0){g=c;h=a;POa(g,h);return}if(!e){a=VDc(24)|0;JNa(a);i=a}else{if(f[e+64>>2]|0)OQb(e,14672,24);a=MQb(e,24)|0;KNa(a,e);i=a}f[b>>2]=i;g=f[d>>2]|0;h=i;POa(g,h);return}function PDb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=105828;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=526768?(f[220463]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=115;b[d+8>>0]=0;DTb(881852,d);ZSb(d)}f[a+24>>2]=0;f[a+28>>2]=0;u=c;return}function QDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=105828;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;if((f[220463]|0)==2){g=a+24|0;f[g>>2]=0;h=a+28|0;f[h>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=115;b[e+8>>0]=0;DTb(881852,e);ZSb(e);g=a+24|0;f[g>>2]=0;h=a+28|0;f[h>>2]=0;u=d;return}function RDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{UDb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(32)|0;PDb(l);UDb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,18912,32);l=MQb(i,32)|0;QDb(l,i);UDb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function SDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{TDb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(20)|0;gCb(l);TDb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,18896,24);l=MQb(i,24)|0;hCb(l,i);TDb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function TDb(a,b){a=a|0;b=b|0;fCb(b,a);return}function UDb(a,b){a=a|0;b=b|0;zCb(b,a);return}function VDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=105532;e=(a|0)==526592;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220460]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=112;b[d+8>>0]=0;DTb(881840,d);ZSb(d)}f[a+40>>2]=0;u=c;return}function WDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=105532;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=c;f[a+28>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;if((f[220460]|0)==2){g=a+40|0;f[g>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=112;b[e+8>>0]=0;DTb(881840,e);ZSb(e);g=a+40|0;f[g>>2]=0;u=d;return}function XDb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220459]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=111;b[c+8>>0]=0;DTb(881836,c);ZSb(c);u=a;return}function YDb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220460]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=112;b[c+8>>0]=0;DTb(881840,c);ZSb(c);u=a;return}function ZDb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220459]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=111;b[c+8>>0]=0;DTb(881836,c);ZSb(c);u=a;return}function _Db(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}RDb(a+8|0,b+8|0);SDb(a+24|0,b+24|0);return}function $Db(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(-215,a,b,c,d);return}function aEb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0;j=u;u=u+48|0;k=j;l=j+36|0;m=j+32|0;if(((f[a+4>>2]|0)-(f[a>>2]|0)>>5|0)!=((f[c+4>>2]|0)-(f[c>>2]|0)>>2|0)){f[k>>2]=0;f[k+4>>2]=0;n=tT(k,30)|0;o=457494;q=n+30|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));$Db(k,457525,457534,39)}if(!(d>=0.0)){f[k>>2]=0;f[k+4>>2]=0;n=tT(k,20)|0;o=457595;q=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));$Db(k,457525,457534,39)}if(!(e>=0.0)){f[k>>2]=0;f[k+4>>2]=0;n=tT(k,18)|0;o=457616;q=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));$Db(k,457525,457534,39)}if(!(h>0.0)){f[k>>2]=0;f[k+4>>2]=0;o=tT(k,7)|0;b[o>>0]=b[457635]|0;b[o+1>>0]=b[457636]|0;b[o+2>>0]=b[457637]|0;b[o+3>>0]=b[457638]|0;b[o+4>>0]=b[457639]|0;b[o+5>>0]=b[457640]|0;b[o+6>>0]=b[457641]|0;$Db(k,457525,457534,39)}f[l>>2]=0;o=l+4|0;f[o>>2]=0;f[l+8>>2]=0;Zxb(c,d,i,l);i=f[g>>2]|0;c=g+4|0;n=f[c>>2]|0;q=i;r=n+(~((n+-4-q|0)>>>2)<<2)|0;if((n|0)==(i|0)){s=n;t=i}else{f[c>>2]=r;s=r;t=r}r=s;s=t;n=f[o>>2]|0;v=f[l>>2]|0;w=v;a:do if((n|0)!=(v|0)){x=g+8|0;if(h<1.0){y=k+8|0;z=k+16|0;A=k+24|0;B=0;d=e;C=r;D=t;E=i;F=w;G=q;H=s;while(1){I=f[F+(B<<3)+4>>2]|0;f[m>>2]=I;if((H-G|0)>0){J=0;K=G;L=C;M=E;N=I;while(1){I=f[M+(J<<2)>>2]|0;O=f[a>>2]|0;P=+p[O+(N<<5)+16>>3];Q=+p[O+(N<<5)+24>>3];R=P*Q+ +p[O+(I<<5)+16>>3]*+p[O+(I<<5)+24>>3];if(!(R<=2.220446049250313e-16)){p[k>>3]=+p[O+(N<<5)>>3];p[y>>3]=+p[O+(N<<5)+8>>3];p[z>>3]=P;p[A>>3]=Q;bEb(k,O+(I<<5)|0)|0;Q=+p[k+16>>3]*+p[k+24>>3];S=1.0-Q/(R-Q);T=f[g>>2]|0;U=f[c>>2]|0}else{S=0.0;T=K;U=L}V=1.0-S<=d;I=J+1|0;if(!(V&(I|0)<(U-T>>2|0)))break;J=I;K=T;L=U;M=T;N=f[m>>2]|0}if(V){W=U;X=17}else Y=0}else{W=D;X=17}do if((X|0)==17){X=0;if((W|0)==(f[x>>2]|0)){g6(g,m);Y=1;break}else{f[W>>2]=f[m>>2];f[c>>2]=W+4;Y=1;break}}while(0);N=B+1|0;M=f[o>>2]|0;L=f[l>>2]|0;K=L;if(N>>>0>=M-L>>3>>>0){Z=M;_=K;break a}M=f[c>>2]|0;L=f[g>>2]|0;B=N;d=d>.5&Y?d*h:d;C=M;D=M;E=L;F=K;G=L;H=M}}else{H=k+8|0;G=k+16|0;F=k+24|0;E=0;D=w;C=q;B=s;A=r;z=t;y=i;while(1){M=f[D+(E<<3)+4>>2]|0;f[m>>2]=M;if((B-C|0)>0){L=0;K=y;N=M;M=C;J=A;while(1){I=f[K+(L<<2)>>2]|0;O=f[a>>2]|0;d=+p[O+(N<<5)+16>>3];Q=+p[O+(N<<5)+24>>3];R=d*Q+ +p[O+(I<<5)+16>>3]*+p[O+(I<<5)+24>>3];if(!(R<=2.220446049250313e-16)){p[k>>3]=+p[O+(N<<5)>>3];p[H>>3]=+p[O+(N<<5)+8>>3];p[G>>3]=d;p[F>>3]=Q;bEb(k,O+(I<<5)|0)|0;Q=+p[k+16>>3]*+p[k+24>>3];$=1.0-Q/(R-Q);aa=f[c>>2]|0;ba=f[g>>2]|0}else{$=0.0;aa=J;ba=M}ca=1.0-$<=e;I=L+1|0;if(!(ca&(I|0)<(aa-ba>>2|0)))break;L=I;K=ba;N=f[m>>2]|0;M=ba;J=aa}if(ca){da=aa;X=36}}else{da=z;X=36}do if((X|0)==36){X=0;if((da|0)==(f[x>>2]|0)){g6(g,m);break}else{f[da>>2]=f[m>>2];f[c>>2]=da+4;break}}while(0);J=E+1|0;M=f[o>>2]|0;N=f[l>>2]|0;K=N;if(J>>>0>=M-N>>3>>>0){Z=M;_=K;break a}M=f[c>>2]|0;N=f[g>>2]|0;E=J;D=K;C=N;B=M;A=M;z=M;y=N}}}else{Z=n;_=w}while(0);w=Z;if(!_){u=j;return}if((w|0)!=(_|0))f[o>>2]=w+(~((w+-8-_|0)>>>3)<<3);YDc(_);u=j;return}function bEb(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,g=0,h=0.0,i=0.0,j=0.0,k=0,l=0.0;c=+p[a>>3];d=+p[b>>3];e=c<d?d:c;g=a+8|0;h=+p[g>>3];i=+p[b+8>>3];j=h<i?i:h;k=a+16|0;l=c+ +p[k>>3];c=d+ +p[b+16>>3];d=(c<l?c:l)-e;p[k>>3]=d;k=a+24|0;l=h+ +p[k>>3];h=i+ +p[b+24>>3];i=(h<l?h:l)-j;p[k>>3]=i;p[a>>3]=e;p[g>>3]=j;if(!(d<=0.0)&!(i<=0.0))return a|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function cEb(a){a=a|0;var b=0,c=0;f[a>>2]=106804;oGb(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function dEb(a){a=a|0;cEb(a);YDc(a);return}function eEb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function fEb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(40)|0;gGb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,19024,40);a=MQb(b,40)|0;iGb(a,b);c=a;return c|0}function gEb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function hEb(a){a=a|0;return f[a+4>>2]|0}function iEb(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+12>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+16>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+20>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+24>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=a+28|0;f[d>>2]=0;b[d+4>>0]=0;d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;ljc(c);return}function jEb(a){a=a|0;return 1}function kEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+4|0;k=a+8|0;l=a+12|0;m=a+12|0;n=a+28|0;o=a+16|0;p=a+16|0;q=a+20|0;r=a+20|0;s=a+24|0;t=a+24|0;v=a+32|0;a=e+8|0;a:while(1){w=f[c>>2]|0;x=f[g>>2]|0;do if(w>>>0<x>>>0){y=b[w>>0]|0;z=y&255;A=w+1|0;if(y<<24>>24>0){B=A;C=z}else{if(A>>>0>=x>>>0){D=z;E=7;break}y=h[A>>0]|0;if(((y^128)&z)>>>0<=127){D=z;E=7;break}B=w+2|0;C=z+-128+(y<<7)|0}f[c>>2]=B;F=C;E=9}else{D=0;E=7}while(0);if((E|0)==7){E=0;w=WRb(c,D)|0;if((w+-1|0)>>>0<16383){F=w;E=9}else G=w}b:do if((E|0)==9){E=0;switch(F>>>3&536870911|0){case 1:{if((F&255|0)!=10){G=F;break b}w=f[j>>2]|0;x=w&-2;if(!(w&1))H=x;else H=f[x+4>>2]|0;x=f[i>>2]|0;if((x|0)==527320){WJa(i,H,527320);I=f[i>>2]|0}else I=x;if(!(fUb(c,I)|0)){K=0;E=82;break a}x=f[k>>2]|0;w=b[x+11>>0]|0;if(w<<24>>24<0){L=f[x>>2]|0;M=f[x+4>>2]|0}else{L=x;M=w&255}if(gUb(L,M,0,459094)|0)continue a;else{K=0;E=82;break a}break}case 2:{if((F&255|0)!=18){G=F;break b}w=f[j>>2]|0;x=w&-2;if(!(w&1))N=x;else N=f[x+4>>2]|0;x=f[l>>2]|0;if((x|0)==527320){WJa(l,N,527320);O=f[l>>2]|0}else O=x;if(!(fUb(c,O)|0)){K=0;E=82;break a}x=f[m>>2]|0;w=b[x+11>>0]|0;if(w<<24>>24<0){P=f[x>>2]|0;Q=f[x+4>>2]|0}else{P=x;Q=w&255}if(gUb(P,Q,0,459130)|0)continue a;else{K=0;E=82;break a}break}case 3:{if((F&255|0)!=24){G=F;break b}w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){x=b[w>>0]|0;y=x&255;if(x<<24>>24>-1){f[c>>2]=w+1;R=y}else{S=y;E=36}}else{S=0;E=36}if((E|0)==36){E=0;y=HRb(c,S)|0;w=J;if((w|0)>-1|(w|0)==-1&y>>>0>4294967295)R=y;else{K=0;E=82;break a}}f[n>>2]=R;continue a;break}case 4:{if((F&255|0)!=34){G=F;break b}y=f[j>>2]|0;w=y&-2;if(!(y&1))T=w;else T=f[w+4>>2]|0;w=f[o>>2]|0;if((w|0)==527320){WJa(o,T,527320);U=f[o>>2]|0}else U=w;if(!(fUb(c,U)|0)){K=0;E=82;break a}w=f[p>>2]|0;y=b[w+11>>0]|0;if(y<<24>>24<0){V=f[w>>2]|0;W=f[w+4>>2]|0}else{V=w;W=y&255}if(gUb(V,W,0,459173)|0)continue a;else{K=0;E=82;break a}break}case 5:{if((F&255|0)!=42){G=F;break b}y=f[j>>2]|0;w=y&-2;if(!(y&1))X=w;else X=f[w+4>>2]|0;w=f[q>>2]|0;if((w|0)==527320){WJa(q,X,527320);Y=f[q>>2]|0}else Y=w;if(!(fUb(c,Y)|0)){K=0;E=82;break a}w=f[r>>2]|0;y=b[w+11>>0]|0;if(y<<24>>24<0){Z=f[w>>2]|0;_=f[w+4>>2]|0}else{Z=w;_=y&255}if(gUb(Z,_,0,459214)|0)continue a;else{K=0;E=82;break a}break}case 6:{if((F&255|0)!=50){G=F;break b}y=f[j>>2]|0;w=y&-2;if(!(y&1))$=w;else $=f[w+4>>2]|0;w=f[s>>2]|0;if((w|0)==527320){WJa(s,$,527320);aa=f[s>>2]|0}else aa=w;if(!(fUb(c,aa)|0)){K=0;E=82;break a}w=f[t>>2]|0;y=b[w+11>>0]|0;if(y<<24>>24<0){ba=f[w>>2]|0;ca=f[w+4>>2]|0}else{ba=w;ca=y&255}if(gUb(ba,ca,0,459257)|0)continue a;else{K=0;E=82;break a}break}case 16:{if((F&255|0)!=128){G=F;break b}y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[c>>2]=y+1;da=w<<24>>24!=0}else{IRb(e,c);w=e;if(!(b[a>>0]|0)){K=0;E=82;break a}else da=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0}b[v>>0]=da&1;continue a;break}default:{G=F;break b}}}while(0);if(!G){K=1;E=82;break}w=f[j>>2]|0;if(!(w&1))ea=mNa(j)|0;else ea=w&-2;if(!(Djc(c,G,ea)|0)){K=0;E=82;break}}if((E|0)==82){u=d;return K|0}return 0}function lEb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=f[a+12>>2]|0;d=b[h+11>>0]|0;e=d<<24>>24<0;if(e)j=f[h+4>>2]|0;else j=d&255;if(!j)k=i;else{j=e?f[h+4>>2]|0:d&255;k=i+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}j=f[a+16>>2]|0;i=b[j+11>>0]|0;d=i<<24>>24<0;if(d)l=f[j+4>>2]|0;else l=i&255;if(!l)m=k;else{l=d?f[j+4>>2]|0:i&255;m=k+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}l=f[a+20>>2]|0;k=b[l+11>>0]|0;i=k<<24>>24<0;if(i)n=f[l+4>>2]|0;else n=k&255;if(!n)o=m;else{n=i?f[l+4>>2]|0:k&255;o=m+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}n=f[a+24>>2]|0;m=b[n+11>>0]|0;k=m<<24>>24<0;if(k)p=f[n+4>>2]|0;else p=m&255;if(!p)q=o;else{p=k?f[n+4>>2]|0:m&255;q=o+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0}p=f[a+28>>2]|0;if(!p){r=q;s=a+32|0;t=b[s>>0]|0;u=t<<24>>24!=0;v=r+3|0;w=u?v:r;x=a+36|0;f[x>>2]=w;return w|0}if((p|0)<0)y=11;else y=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=y+q|0;s=a+32|0;t=b[s>>0]|0;u=t<<24>>24!=0;v=r+3|0;w=u?v:r;x=a+36|0;f[x>>2]=w;return w|0}function mEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gUb(j,k,1,459094)|0;$Tb(1,f[d>>2]|0,c)}d=a+12|0;k=f[d>>2]|0;j=b[k+11>>0]|0;g=j<<24>>24<0;if(g)l=f[k+4>>2]|0;else l=j&255;if(l|0){if(g){m=f[k>>2]|0;n=f[k+4>>2]|0}else{m=k;n=j&255}gUb(m,n,1,459130)|0;$Tb(2,f[d>>2]|0,c)}d=f[a+28>>2]|0;if(d|0)ZTb(3,d,c);d=a+16|0;n=f[d>>2]|0;m=b[n+11>>0]|0;j=m<<24>>24<0;if(j)o=f[n+4>>2]|0;else o=m&255;if(o|0){if(j){p=f[n>>2]|0;q=f[n+4>>2]|0}else{p=n;q=m&255}gUb(p,q,1,459173)|0;$Tb(4,f[d>>2]|0,c)}d=a+20|0;q=f[d>>2]|0;p=b[q+11>>0]|0;m=p<<24>>24<0;if(m)r=f[q+4>>2]|0;else r=p&255;if(r|0){if(m){s=f[q>>2]|0;t=f[q+4>>2]|0}else{s=q;t=p&255}gUb(s,t,1,459214)|0;$Tb(5,f[d>>2]|0,c)}d=a+24|0;t=f[d>>2]|0;s=b[t+11>>0]|0;p=s<<24>>24<0;if(p)u=f[t+4>>2]|0;else u=s&255;if(u|0){if(p){v=f[t>>2]|0;w=f[t+4>>2]|0}else{v=t;w=s&255}gUb(v,w,1,459257)|0;$Tb(6,f[d>>2]|0,c)}if(b[a+32>>0]|0)YTb(16,1,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function nEb(a){a=a|0;return f[a+36>>2]|0}function oEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=a+8|0;e=f[c>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=d;else{if(h){k=f[e>>2]|0;l=f[e+4>>2]|0}else{k=e;l=g&255}gUb(k,l,1,459094)|0;l=f[c>>2]|0;b[d>>0]=10;j=dSb(l,d+1|0)|0}d=a+12|0;l=f[d>>2]|0;c=b[l+11>>0]|0;k=c<<24>>24<0;if(k)m=f[l+4>>2]|0;else m=c&255;if(!m)n=j;else{if(k){o=f[l>>2]|0;p=f[l+4>>2]|0}else{o=l;p=c&255}gUb(o,p,1,459130)|0;p=f[d>>2]|0;b[j>>0]=18;n=dSb(p,j+1|0)|0}j=f[a+28>>2]|0;if(!j)q=n;else{b[n>>0]=24;p=n+1|0;n=j&255;if(j>>>0>127){d=p;o=n;c=j;l=((j|0)<0)<<31>>31;while(1){b[d>>0]=o|-128;j=c;c=aJc(c|0,l|0,7)|0;k=d+1|0;m=c&255;if(!(l>>>0>0|(l|0)==0&j>>>0>16383)){r=k;s=m;break}else{d=k;o=m;l=J}}}else{r=p;s=n}b[r>>0]=s;q=r+1|0}r=a+16|0;s=f[r>>2]|0;n=b[s+11>>0]|0;p=n<<24>>24<0;if(p)t=f[s+4>>2]|0;else t=n&255;if(!t)u=q;else{if(p){v=f[s>>2]|0;w=f[s+4>>2]|0}else{v=s;w=n&255}gUb(v,w,1,459173)|0;w=f[r>>2]|0;b[q>>0]=34;u=dSb(w,q+1|0)|0}q=a+20|0;w=f[q>>2]|0;r=b[w+11>>0]|0;v=r<<24>>24<0;if(v)x=f[w+4>>2]|0;else x=r&255;if(!x)y=u;else{if(v){z=f[w>>2]|0;A=f[w+4>>2]|0}else{z=w;A=r&255}gUb(z,A,1,459214)|0;A=f[q>>2]|0;b[u>>0]=42;y=dSb(A,u+1|0)|0}u=a+24|0;A=f[u>>2]|0;q=b[A+11>>0]|0;z=q<<24>>24<0;if(z)B=f[A+4>>2]|0;else B=q&255;if(!B)C=y;else{if(z){D=f[A>>2]|0;E=f[A+4>>2]|0}else{D=A;E=q&255}gUb(D,E,1,459257)|0;E=f[u>>2]|0;b[y>>0]=50;C=dSb(E,y+1|0)|0}if(!(b[a+32>>0]|0))F=C;else{b[C>>0]=-128;b[C+1>>0]=1;b[C+2>>0]=1;F=C+3|0}C=f[a+4>>2]|0;if(!((C&1|0)!=0&(b[473420]|0)!=0)){G=F;return G|0}G=Hjc(C&-2,F)|0;return G|0}function pEb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function qEb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,19024,0)|0;if(!c){Ehc(b,a);return}else{jGb(a,c);return}}function rEb(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function sEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220465]|0)!=2){f[d>>2]=161028;f[d+4>>2]=117;b[d+8>>0]=0;DTb(881860,d);ZSb(d)}d=527088;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function tEb(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220466]|0)!=2){f[c>>2]=161028;f[c+4>>2]=118;b[c+8>>0]=0;DTb(881864,c);ZSb(c)}d=VDc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=12;e=d;g=457643;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+12>>0]=0;Xbc(c,106904,106964,106584,0,527088,0,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function uEb(){vEb();lYb(457656,969);rhc(457643,1770);jPa();kTa();return}function vEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220467]|0)!=2){f[c>>2]=161028;f[c+4>>2]=119;b[c+8>>0]=0;DTb(881868,c);ZSb(c)}if((f[220468]|0)!=2){f[c>>2]=161028;f[c+4>>2]=120;b[c+8>>0]=0;DTb(881872,c);ZSb(c)}if((f[220469]|0)!=2){f[c>>2]=161028;f[c+4>>2]=121;b[c+8>>0]=0;DTb(881876,c);ZSb(c)}if((f[220470]|0)!=2){f[c>>2]=161028;f[c+4>>2]=122;b[c+8>>0]=0;DTb(881880,c);ZSb(c)}if((f[220471]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=123;b[c+8>>0]=0;DTb(881884,c);ZSb(c);u=a;return}function wEb(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220465]|0)!=2){f[c>>2]=161028;f[c+4>>2]=117;b[c+8>>0]=0;DTb(881860,c);ZSb(c)}acc(527088,5);u=a;return}function xEb(){aTb(3005001,3005e3,458626);SQb();f[131716]=106804;f[131717]=0;f[131718]=527320;f[131719]=527320;f[131720]=527320;f[131721]=527320;f[131722]=527320;f[131723]=0;b[526896]=0;f[131725]=0;zTb(526864);return}function yEb(){aTb(3005001,3005e3,458626);SQb();iPa();f[131726]=107316;f[131727]=0;f[131728]=527320;f[131729]=527320;f[131730]=527320;f[131731]=0;f[131732]=0;f[131733]=0;f[131734]=0;f[131735]=0;b[526944]=0;f[131737]=0;zTb(526904);f[131731]=520464;f[131732]=520464;return}function zEb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,458626);SQb();if((f[220467]|0)!=2){f[c>>2]=161028;f[c+4>>2]=119;b[c+8>>0]=0;DTb(881868,c);ZSb(c)}if((f[220468]|0)!=2){f[c>>2]=161028;f[c+4>>2]=120;b[c+8>>0]=0;DTb(881872,c);ZSb(c)}if((f[220470]|0)!=2){f[c>>2]=161028;f[c+4>>2]=122;b[c+8>>0]=0;DTb(881880,c);ZSb(c)}f[131738]=107100;c=526956;d=c+52|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131752]=527320;f[131753]=527320;f[131754]=527320;c=527020;f[c>>2]=0;f[c+4>>2]=0;f[131757]=0;zTb(526952);f[131755]=527032;u=a;return}function AEb(){aTb(3005001,3005e3,458626);SQb();f[131758]=107208;f[131759]=0;f[131760]=527320;f[131761]=0;f[131762]=0;zTb(527032);return}function BEb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,458626);SQb();if((f[220469]|0)!=2){f[c>>2]=161028;f[c+4>>2]=121;b[c+8>>0]=0;DTb(881876,c);ZSb(c)}f[131764]=106992;f[131765]=0;f[131766]=0;f[131767]=0;f[131768]=0;f[131769]=0;f[131770]=0;zTb(527056);u=a;return}function CEb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=106992;b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function DEb(a){a=a|0;CEb(a);YDc(a);return}function EEb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function FEb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(28)|0;mGb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,19040,32);a=MQb(b,32)|0;nGb(a,b);c=a;return c|0}function GEb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function HEb(a){a=a|0;return f[a+4>>2]|0}function IEb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+20>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function JEb(a){a=a|0;return 1}function KEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;USb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=VDc(80)|0;UEb(a);y=a}else{if(f[o+64>>2]|0)OQb(o,19056,80);a=MQb(o,80)|0;WEb(a,o);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=VRb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}GRb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(LRb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=mNa(m)|0;else B=a&-2;if(!(Djc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function LEb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c){g=e;h=a+24|0;f[h>>2]=g;return g|0}d=a+20|0;i=0;j=e;while(1){e=f[(f[d>>2]|0)+4+(i<<2)>>2]|0;k=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=k+j+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(c|0)){g=e;break}else j=e}h=a+24|0;f[h>>2]=g;return g|0}function MEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{eUb(1,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function NEb(a){a=a|0;return f[a+24>>2]|0}function OEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+12>>2]|0;if(!e)g=d;else{h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!((j&1|0)!=0&(b[473420]|0)!=0)){s=g;return s|0}s=Hjc(j&-2,g)|0;return s|0}function PEb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function QEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,19040,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}TEb(a+8|0,c+8|0);return}function REb(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function SEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220465]|0)!=2){f[d>>2]=161028;f[d+4>>2]=117;b[d+8>>0]=0;DTb(881860,d);ZSb(d)}d=527120;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function TEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{VEb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(80)|0;UEb(l);VEb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,19056,80);l=MQb(i,80)|0;WEb(l,i);VEb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function UEb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=107100;e=(a|0)==526952;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220469]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=121;b[d+8>>0]=0;DTb(881876,d);ZSb(d)}f[a+56>>2]=527320;f[a+60>>2]=527320;f[a+64>>2]=527320;d=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[a+76>>2]=0;u=c;return}function VEb(a,b){a=a|0;b=b|0;mFb(b,a);return}function WEb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=107100;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=c;f[a+28>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=c;f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;if((f[220469]|0)!=2){f[e>>2]=161028;f[e+4>>2]=121;b[e+8>>0]=0;DTb(881876,e);ZSb(e)}f[a+56>>2]=527320;f[a+60>>2]=527320;f[a+64>>2]=527320;e=a+68|0;f[e>>2]=0;f[e+4>>2]=0;f[a+76>>2]=0;u=d;return}function XEb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=107100;lGb(a);b=a+52|0;c=f[b>>2]|0;if(c|0?(f[a+40>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+36|0;h=f[b>>2]|0;if(h|0?(f[a+24>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;YDc(i)}f[b>>2]=0;b=a+20|0;i=f[b>>2]|0;if(i|0?(f[a+8>>2]|0)==0:0){h=f[i>>2]|0;if((h|0)>0){c=0;do{d=f[i+4+(c<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);c=c+1|0}while((c|0)!=(h|0));j=f[b>>2]|0}else j=i;YDc(j)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}j=a&-2;a=j;if((j|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(j);f[b>>2]=0;return}function YEb(a){a=a|0;XEb(a);YDc(a);return}function ZEb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function _Eb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(80)|0;UEb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,19056,80);a=MQb(b,80)|0;WEb(a,b);c=a;return c|0}function $Eb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function aFb(a){a=a|0;return f[a+4>>2]|0}function bFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+28|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+36>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+44|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+52>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+4|0;d=f[a+56>>2]|0;do if((d|0)!=527320){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[a+60>>2]|0;do if((d|0)!=527320){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[a+64>>2]|0;do if((d|0)!=527320){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[c>>2]|0;g=d&-2;if(!(d&1))i=g;else i=f[g+4>>2]|0;g=a+68|0;if((i|0)==0?(i=f[g>>2]|0,(i|0)!=0):0){Yi[f[(f[i>>2]|0)+4>>2]&2047](i);j=f[c>>2]|0}else j=d;f[g>>2]=0;f[a+72>>2]=0;if(!(j&1))return;a=j&-2;if(!(f[a>>2]|0))return;ljc(a);return}function cFb(a){a=a|0;return 1}function dFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+56|0;j=a+4|0;k=a+56|0;l=a+8|0;m=e+4|0;n=a+24|0;o=e+4|0;p=a+40|0;q=a+52|0;r=a+48|0;s=a+44|0;t=e+4|0;v=a+60|0;w=a+60|0;x=a+64|0;y=a+64|0;z=a+68|0;A=e+4|0;B=a+73|0;C=e+8|0;D=a+74|0;E=e+8|0;F=a+72|0;G=e+8|0;H=a+75|0;I=e+8|0;a:while(1){J=f[c>>2]|0;K=f[g>>2]|0;do if(J>>>0<K>>>0){L=b[J>>0]|0;M=L&255;N=J+1|0;if(L<<24>>24>0){O=N;P=M}else{if(N>>>0>=K>>>0){Q=M;R=7;break}L=h[N>>0]|0;if(((L^128)&M)>>>0<=127){Q=M;R=7;break}O=J+2|0;P=M+-128+(L<<7)|0}f[c>>2]=O;S=P;R=9}else{Q=0;R=7}while(0);if((R|0)==7){R=0;J=WRb(c,Q)|0;if((J+-1|0)>>>0<16383){S=J;R=9}else T=J}b:do if((R|0)==9){R=0;do switch(S>>>3&536870911|0){case 1:{if((S&255|0)!=10){T=S;break b}J=f[j>>2]|0;K=J&-2;if(!(J&1))U=K;else U=f[K+4>>2]|0;K=f[i>>2]|0;if((K|0)==527320){WJa(i,U,527320);V=f[i>>2]|0}else V=K;if(!(fUb(c,V)|0)){W=0;R=122;break a}K=f[k>>2]|0;J=b[K+11>>0]|0;if(J<<24>>24<0){X=f[K>>2]|0;Y=f[K+4>>2]|0}else{X=K;Y=J&255}if(gUb(X,Y,0,458940)|0)continue a;else{W=0;R=122;break a}break}case 2:{if((S&255|0)!=18){T=S;break b}J=kGb(l)|0;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(L=b[K>>0]|0,L<<24>>24>-1):0){f[c>>2]=K+1;Z=L&255}else{L=VRb(c)|0;if((L|0)>-1)Z=L;else{W=0;R=122;break a}}GRb(e,c,Z);if((f[m>>2]|0)<0){R=28;break a}if(!(Mi[f[(f[J>>2]|0)+44>>2]&1023](J,c)|0)){R=28;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{W=0;R=122;break a}break}case 3:{if((S&255|0)!=26){T=S;break b}J=kGb(n)|0;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;_=K&255}else{K=VRb(c)|0;if((K|0)>-1)_=K;else{W=0;R=122;break a}}GRb(e,c,_);if((f[o>>2]|0)<0){R=37;break a}if(!(Mi[f[(f[J>>2]|0)+44>>2]&1023](J,c)|0)){R=37;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{W=0;R=122;break a}break}case 4:{if((S&255|0)!=34){T=S;break b}J=f[q>>2]|0;do if(J){K=f[s>>2]|0;L=f[J>>2]|0;if((K|0)>=(L|0))if((L|0)==(f[r>>2]|0)){$=L;R=45;break}else{aa=L;ba=J;R=46;break}else{f[s>>2]=K+1;ca=f[J+4+(K<<2)>>2]|0;break}}else{$=f[r>>2]|0;R=45}while(0);if((R|0)==45){R=0;USb(p,$+1|0);J=f[q>>2]|0;aa=f[J>>2]|0;ba=J;R=46}if((R|0)==46){R=0;f[ba>>2]=aa+1;J=f[p>>2]|0;if(!J){K=VDc(48)|0;KFb(K);da=K}else{if(f[J+64>>2]|0)OQb(J,19088,48);K=MQb(J,48)|0;MFb(K,J);da=K}K=f[q>>2]|0;J=f[s>>2]|0;f[s>>2]=J+1;f[K+4+(J<<2)>>2]=da;ca=da}J=f[c>>2]|0;if(J>>>0<(f[g>>2]|0)>>>0?(K=b[J>>0]|0,K<<24>>24>-1):0){f[c>>2]=J+1;ea=K&255}else{K=VRb(c)|0;if((K|0)>-1)ea=K;else{W=0;R=122;break a}}GRb(e,c,ea);if((f[t>>2]|0)<0){R=58;break a}if(!(Mi[f[(f[ca>>2]|0)+44>>2]&1023](ca,c)|0)){R=58;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{W=0;R=122;break a}break}case 5:{if((S&255|0)!=42){T=S;break b}K=f[j>>2]|0;J=K&-2;if(!(K&1))fa=J;else fa=f[J+4>>2]|0;J=f[v>>2]|0;if((J|0)==527320){WJa(v,fa,527320);ga=f[v>>2]|0}else ga=J;if(!(fUb(c,ga)|0)){W=0;R=122;break a}J=f[w>>2]|0;K=b[J+11>>0]|0;if(K<<24>>24<0){ha=f[J>>2]|0;ia=f[J+4>>2]|0}else{ha=J;ia=K&255}if(gUb(ha,ia,0,458969)|0)continue a;else{W=0;R=122;break a}break}case 6:{if((S&255|0)!=50){T=S;break b}K=f[j>>2]|0;J=K&-2;if(!(K&1))ja=J;else ja=f[J+4>>2]|0;J=f[x>>2]|0;if((J|0)==527320){WJa(x,ja,527320);ka=f[x>>2]|0}else ka=J;if(!(fUb(c,ka)|0)){W=0;R=122;break a}J=f[y>>2]|0;K=b[J+11>>0]|0;if(K<<24>>24<0){la=f[J>>2]|0;ma=f[J+4>>2]|0}else{la=J;ma=K&255}if(gUb(la,ma,0,459001)|0)continue a;else{W=0;R=122;break a}break}case 8:{if((S&255|0)!=66){T=S;break b}K=f[z>>2]|0;if(!K){pFb(a);na=f[z>>2]|0}else na=K;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(J=b[K>>0]|0,J<<24>>24>-1):0){f[c>>2]=K+1;oa=J&255}else{J=VRb(c)|0;if((J|0)>-1)oa=J;else{W=0;R=122;break a}}GRb(e,c,oa);if((f[A>>2]|0)<0){R=91;break a}if(!(Mi[f[(f[na>>2]|0)+44>>2]&1023](na,c)|0)){R=91;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{W=0;R=122;break a}break}case 16:{if((S&255|0)!=128){T=S;break b}J=f[c>>2]|0;if(J>>>0<(f[g>>2]|0)>>>0?(K=b[J>>0]|0,K<<24>>24>-1):0){f[c>>2]=J+1;pa=K<<24>>24!=0}else{IRb(e,c);K=e;if(!(b[C>>0]|0)){W=0;R=122;break a}else pa=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0}b[B>>0]=pa&1;continue a;break}case 17:{if((S&255|0)!=136){T=S;break b}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(J=b[K>>0]|0,J<<24>>24>-1):0){f[c>>2]=K+1;qa=J<<24>>24!=0}else{IRb(e,c);J=e;if(!(b[E>>0]|0)){W=0;R=122;break a}else qa=(f[J>>2]|0)!=0|(f[J+4>>2]|0)!=0}b[D>>0]=qa&1;continue a;break}case 18:{if((S&255|0)!=144){T=S;break b}J=f[c>>2]|0;if(J>>>0<(f[g>>2]|0)>>>0?(K=b[J>>0]|0,K<<24>>24>-1):0){f[c>>2]=J+1;ra=K<<24>>24!=0}else{IRb(e,c);K=e;if(!(b[G>>0]|0)){W=0;R=122;break a}else ra=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0}b[F>>0]=ra&1;continue a;break}case 19:{if((S&255|0)!=152){T=S;break b}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(J=b[K>>0]|0,J<<24>>24>-1):0){f[c>>2]=K+1;sa=J<<24>>24!=0}else{IRb(e,c);J=e;if(!(b[I>>0]|0)){W=0;R=122;break a}else sa=(f[J>>2]|0)!=0|(f[J+4>>2]|0)!=0}b[H>>0]=sa&1;continue a;break}default:{T=S;break b}}while(0)}while(0);if(!T){W=1;R=122;break}J=f[j>>2]|0;if(!(J&1))ta=mNa(j)|0;else ta=J&-2;if(!(Djc(c,T,ta)|0)){W=0;R=122;break}}if((R|0)==28){W=0;u=d;return W|0}else if((R|0)==37){W=0;u=d;return W|0}else if((R|0)==58){W=0;u=d;return W|0}else if((R|0)==91){W=0;u=d;return W|0}else if((R|0)==122){u=d;return W|0}return 0}function eFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+20|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+28>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+36|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=f[a+44>>2]|0;i=d+k|0;if(!d)l=i;else{k=a+52|0;h=0;g=i;while(1){i=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;c=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=c+g+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=i;break}else g=i}}g=f[a+56>>2]|0;d=b[g+11>>0]|0;h=d<<24>>24<0;if(h)m=f[g+4>>2]|0;else m=d&255;if(!m)n=l;else{m=h?f[g+4>>2]|0:d&255;n=l+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}m=f[a+60>>2]|0;l=b[m+11>>0]|0;d=l<<24>>24<0;if(d)o=f[m+4>>2]|0;else o=l&255;if(!o)p=n;else{o=d?f[m+4>>2]|0:l&255;p=n+1+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0}o=f[a+64>>2]|0;n=b[o+11>>0]|0;l=n<<24>>24<0;if(l)q=f[o+4>>2]|0;else q=n&255;if(!q)r=p;else{q=l?f[o+4>>2]|0:n&255;r=p+1+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if((a|0)!=526952?(q=f[a+68>>2]|0,(q|0)!=0):0){p=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;s=r+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else s=r;r=b[a+72>>0]|0?s+3|0:s;s=b[a+73>>0]|0?r+3|0:r;r=b[a+74>>0]|0?s+3|0:s;s=b[a+75>>0]|0?r+3|0:r;f[a+76>>2]=s;return s|0}function fFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+56|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gUb(j,k,1,458940)|0;$Tb(1,f[d>>2]|0,c)}d=f[a+12>>2]|0;if(d|0){k=a+20|0;j=0;do{eUb(2,f[(f[k>>2]|0)+4+(j<<2)>>2]|0,c);j=j+1|0}while((j|0)!=(d|0))}d=f[a+28>>2]|0;if(d|0){j=a+36|0;k=0;do{eUb(3,f[(f[j>>2]|0)+4+(k<<2)>>2]|0,c);k=k+1|0}while((k|0)!=(d|0))}d=f[a+44>>2]|0;if(d|0){k=a+52|0;j=0;do{eUb(4,f[(f[k>>2]|0)+4+(j<<2)>>2]|0,c);j=j+1|0}while((j|0)!=(d|0))}d=a+60|0;j=f[d>>2]|0;k=b[j+11>>0]|0;g=k<<24>>24<0;if(g)l=f[j+4>>2]|0;else l=k&255;if(l|0){if(g){m=f[j>>2]|0;n=f[j+4>>2]|0}else{m=j;n=k&255}gUb(m,n,1,458969)|0;$Tb(5,f[d>>2]|0,c)}d=a+64|0;n=f[d>>2]|0;m=b[n+11>>0]|0;k=m<<24>>24<0;if(k)o=f[n+4>>2]|0;else o=m&255;if(o|0){if(k){p=f[n>>2]|0;q=f[n+4>>2]|0}else{p=n;q=m&255}gUb(p,q,1,459001)|0;$Tb(6,f[d>>2]|0,c)}if((a|0)!=526952?(d=f[a+68>>2]|0,d|0):0)eUb(8,d,c);if(b[a+73>>0]|0)YTb(16,1,c);if(b[a+74>>0]|0)YTb(17,1,c);if(b[a+72>>0]|0)YTb(18,1,c);if(b[a+75>>0]|0)YTb(19,1,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function gFb(a){a=a|0;return f[a+76>>2]|0}function hFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=a+56|0;g=f[e>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0;if(i)j=f[g+4>>2]|0;else j=h&255;if(!j)k=d;else{if(i){l=f[g>>2]|0;m=f[g+4>>2]|0}else{l=g;m=h&255}gUb(l,m,1,458940)|0;m=f[e>>2]|0;b[d>>0]=10;k=dSb(m,d+1|0)|0}d=f[a+12>>2]|0;if(!d)n=k;else{m=a+20|0;e=0;l=k;while(1){k=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;b[l>>0]=18;h=l+1|0;g=_i[f[(f[k>>2]|0)+60>>2]&1023](k)|0;if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;o=i>>>7;p=j+1|0;if(i>>>0>16383){i=o;j=p}else{q=p;r=o;break}}}else{q=h;r=g}b[q>>0]=r;j=hj[f[(f[k>>2]|0)+64>>2]&511](k,c,q+1|0)|0;e=e+1|0;if((e|0)==(d|0)){n=j;break}else l=j}}l=f[a+28>>2]|0;if(!l)s=n;else{d=a+36|0;e=0;q=n;while(1){n=f[(f[d>>2]|0)+4+(e<<2)>>2]|0;b[q>>0]=26;r=q+1|0;m=_i[f[(f[n>>2]|0)+60>>2]&1023](n)|0;if(m>>>0>127){j=m;i=r;while(1){b[i>>0]=j|128;o=j>>>7;p=i+1|0;if(j>>>0>16383){j=o;i=p}else{t=p;u=o;break}}}else{t=r;u=m}b[t>>0]=u;i=hj[f[(f[n>>2]|0)+64>>2]&511](n,c,t+1|0)|0;e=e+1|0;if((e|0)==(l|0)){s=i;break}else q=i}}q=f[a+44>>2]|0;if(!q)v=s;else{l=a+52|0;e=0;t=s;while(1){s=f[(f[l>>2]|0)+4+(e<<2)>>2]|0;b[t>>0]=34;u=t+1|0;d=_i[f[(f[s>>2]|0)+60>>2]&1023](s)|0;if(d>>>0>127){i=d;j=u;while(1){b[j>>0]=i|128;k=i>>>7;g=j+1|0;if(i>>>0>16383){i=k;j=g}else{w=g;x=k;break}}}else{w=u;x=d}b[w>>0]=x;j=hj[f[(f[s>>2]|0)+64>>2]&511](s,c,w+1|0)|0;e=e+1|0;if((e|0)==(q|0)){v=j;break}else t=j}}t=a+60|0;q=f[t>>2]|0;e=b[q+11>>0]|0;w=e<<24>>24<0;if(w)y=f[q+4>>2]|0;else y=e&255;if(!y)z=v;else{if(w){A=f[q>>2]|0;B=f[q+4>>2]|0}else{A=q;B=e&255}gUb(A,B,1,458969)|0;B=f[t>>2]|0;b[v>>0]=42;z=dSb(B,v+1|0)|0}v=a+64|0;B=f[v>>2]|0;t=b[B+11>>0]|0;A=t<<24>>24<0;if(A)C=f[B+4>>2]|0;else C=t&255;if(!C)D=z;else{if(A){E=f[B>>2]|0;F=f[B+4>>2]|0}else{E=B;F=t&255}gUb(E,F,1,459001)|0;F=f[v>>2]|0;b[z>>0]=50;D=dSb(F,z+1|0)|0}if((a|0)!=526952?(z=f[a+68>>2]|0,(z|0)!=0):0){b[D>>0]=66;F=D+1|0;v=_i[f[(f[z>>2]|0)+60>>2]&1023](z)|0;if(v>>>0>127){E=v;t=F;while(1){b[t>>0]=E|128;B=E>>>7;A=t+1|0;if(E>>>0>16383){E=B;t=A}else{G=A;H=B;break}}}else{G=F;H=v}b[G>>0]=H;I=hj[f[(f[z>>2]|0)+64>>2]&511](z,c,G+1|0)|0}else I=D;if(!(b[a+73>>0]|0))J=I;else{b[I>>0]=-128;b[I+1>>0]=1;b[I+2>>0]=1;J=I+3|0}if(!(b[a+74>>0]|0))K=J;else{b[J>>0]=-120;b[J+1>>0]=1;b[J+2>>0]=1;K=J+3|0}if(!(b[a+72>>0]|0))L=K;else{b[K>>0]=-112;b[K+1>>0]=1;b[K+2>>0]=1;L=K+3|0}if(!(b[a+75>>0]|0))M=L;else{b[L>>0]=-104;b[L+1>>0]=1;b[L+2>>0]=1;M=L+3|0}L=f[a+4>>2]|0;if(!((L&1|0)!=0&(b[473420]|0)!=0)){N=M;return N|0}N=Hjc(L&-2,M)|0;return N|0}function iFb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function jFb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,19056,0)|0;if(!c){Ehc(b,a);return}else{mFb(a,c);return}}function kFb(a,b){a=a|0;b=b|0;f[a+76>>2]=b;return}function lFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220465]|0)!=2){f[d>>2]=161028;f[d+4>>2]=117;b[d+8>>0]=0;DTb(881860,d);ZSb(d)}d=527104;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function mFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}nFb(a+8|0,c+8|0);nFb(a+24|0,c+24|0);oFb(a+40|0,c+40|0);e=f[c+56>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+56|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+60>>2]|0;k=b[e+11>>0]|0;if(k<<24>>24<0)l=f[e+4>>2]|0;else l=k&255;do if(l|0){k=a+60|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==527320){WJa(k,m,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+64>>2]|0;m=b[e+11>>0]|0;if(m<<24>>24<0)n=f[e+4>>2]|0;else n=m&255;do if(n|0){m=a+64|0;l=f[d>>2]|0;j=l&-2;if(!(l&1))o=j;else o=f[j+4>>2]|0;j=f[m>>2]|0;if((j|0)==527320){WJa(m,o,e);break}else{iEc(j,e)|0;break}}while(0);if((c|0)!=526952?(e=c+68|0,o=f[e>>2]|0,o|0):0){d=a+68|0;n=f[d>>2]|0;if(!n){pFb(a);p=f[e>>2]|0;q=f[d>>2]|0}else{p=o;q=n}qFb(q,p|0?p:527032)}if(b[c+72>>0]|0)b[a+72>>0]=1;if(b[c+73>>0]|0)b[a+73>>0]=1;if(b[c+74>>0]|0)b[a+74>>0]=1;if(!(b[c+75>>0]|0))return;b[a+75>>0]=1;return}function nFb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{hGb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(40)|0;gGb(l);hGb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,19024,40);l=MQb(i,40)|0;iGb(l,i);hGb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function oFb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{LFb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(48)|0;KFb(l);LFb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,19088,48);l=MQb(i,48)|0;MFb(l,i);LFb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function pFb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(20)|0;rFb(c);e=c;g=a+68|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,19072,24);c=MQb(d,24)|0;sFb(c,d);e=c;g=a+68|0;f[g>>2]=e;return}function qFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+12>>2]|0;if(!e)return;f[a+12>>2]=e;return}function rFb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=107208;f[a+4>>2]=0;if((a|0)!=527032?(f[220470]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=122;b[d+8>>0]=0;DTb(881880,d);ZSb(d)}f[a+8>>2]=527320;f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function sFb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=107208;f[a+4>>2]=c;if((f[220470]|0)!=2){f[e>>2]=161028;f[e+4>>2]=122;b[e+8>>0]=0;DTb(881880,e);ZSb(e)}f[a+8>>2]=527320;f[a+12>>2]=0;f[a+16>>2]=0;u=d;return}function tFb(a){a=a|0;var c=0,d=0;f[a>>2]=107208;c=f[a+8>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function uFb(a){a=a|0;tFb(a);YDc(a);return}function vFb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function wFb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(20)|0;rFb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,19072,24);a=MQb(b,24)|0;sFb(a,b);c=a;return c|0}function xFb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function yFb(a){a=a|0;return f[a+4>>2]|0}function zFb(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[a+12>>2]=0;a=f[c>>2]|0;if(!(a&1))return;c=a&-2;if(!(f[c>>2]|0))return;ljc(c);return}function AFb(a){a=a|0;return 1}function BFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=a+12|0;g=a+8|0;h=a+4|0;i=a+8|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=HRb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=29;break a}}f[e>>2]=p;continue a;break}case 2:break;default:{o=l;break b}}if((l&255|0)==18){j=f[h>>2]|0;k=j&-2;if(!(j&1))s=k;else s=f[k+4>>2]|0;k=f[g>>2]|0;if((k|0)==527320){WJa(g,s,527320);t=f[g>>2]|0}else t=k;if(!(fUb(c,t)|0)){r=0;m=29;break a}k=f[i>>2]|0;j=b[k+11>>0]|0;if(j<<24>>24<0){u=f[k>>2]|0;v=f[k+4>>2]|0}else{u=k;v=j&255}if(gUb(u,v,0,458704)|0)continue a;else{r=0;m=29;break a}}else o=l}while(0);if(!o){r=1;m=29;break}j=f[h>>2]|0;if(!(j&1))w=mNa(h)|0;else w=j&-2;if(!(Djc(c,o,w)|0)){r=0;m=29;break}}if((m|0)==29)return r|0;return 0}function CFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=f[a+12>>2]|0;if(!h){j=i;k=a+16|0;f[k>>2]=j;return j|0}if((h|0)<0)l=11;else l=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=l+i|0;k=a+16|0;f[k>>2]=j;return j|0}function DFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=f[a+12>>2]|0;if(d|0)MTb(1,d,c);d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gUb(j,k,1,458704)|0;$Tb(2,f[d>>2]|0,c)}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function EFb(a){a=a|0;return f[a+16>>2]|0}function FFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+12>>2]|0;if(!c)e=d;else{b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=aJc(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=a+8|0;o=f[n>>2]|0;d=b[o+11>>0]|0;g=d<<24>>24<0;if(g)p=f[o+4>>2]|0;else p=d&255;if(!p)q=e;else{if(g){r=f[o>>2]|0;s=f[o+4>>2]|0}else{r=o;s=d&255}gUb(r,s,1,458704)|0;s=f[n>>2]|0;b[e>>0]=18;q=dSb(s,e+1|0)|0}e=f[a+4>>2]|0;if(!((e&1|0)!=0&(b[473420]|0)!=0)){t=q;return t|0}t=Hjc(e&-2,q)|0;return t|0}function GFb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function HFb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,19072,0)|0;if(!c){Ehc(b,a);return}else{qFb(a,c);return}}function IFb(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function JFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220465]|0)!=2){f[d>>2]=161028;f[d+4>>2]=117;b[d+8>>0]=0;DTb(881860,d);ZSb(d)}d=527112;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function KFb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=107316;f[a+4>>2]=0;if((a|0)!=526904?(f[220468]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=120;b[d+8>>0]=0;DTb(881872,d);ZSb(d)}f[a+8>>2]=527320;f[a+12>>2]=527320;f[a+16>>2]=527320;d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;b[d+20>>0]=0;f[a+44>>2]=0;u=c;return}function LFb(a,b){a=a|0;b=b|0;cGb(b,a);return}function MFb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=107316;f[a+4>>2]=c;if((f[220468]|0)!=2){f[e>>2]=161028;f[e+4>>2]=120;b[e+8>>0]=0;DTb(881872,e);ZSb(e)}f[a+8>>2]=527320;f[a+12>>2]=527320;f[a+16>>2]=527320;e=a+20|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;b[e+20>>0]=0;f[a+44>>2]=0;u=d;return}function NFb(a){a=a|0;var b=0,c=0;f[a>>2]=107316;fGb(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function OFb(a){a=a|0;NFb(a);YDc(a);return}function PFb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function QFb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(48)|0;KFb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,19088,48);a=MQb(b,48)|0;MFb(a,b);c=a;return c|0}function RFb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function SFb(a){a=a|0;return f[a+4>>2]|0}function TFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+12>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+16>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;e=a+20|0;if((g|0)==0?(g=f[e>>2]|0,(g|0)!=0):0){Yi[f[(f[g>>2]|0)+4>>2]&2047](g);h=f[c>>2]|0}else h=d;f[e>>2]=0;e=h&-2;if(!(h&1))i=e;else i=f[e+4>>2]|0;e=a+24|0;if((i|0)==0?(i=f[e>>2]|0,(i|0)!=0):0){Yi[f[(f[i>>2]|0)+4>>2]&2047](i);j=f[c>>2]|0}else j=h;f[e>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;b[e+8>>0]=0;if(!(j&1))return;e=j&-2;if(!(f[e>>2]|0))return;ljc(e);return}function UFb(a){a=a|0;return 1}function VFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+4|0;j=a+8|0;k=a+12|0;l=a+12|0;m=a+20|0;n=e+4|0;o=a+16|0;p=a+16|0;q=a+40|0;r=e+8|0;s=a+32|0;t=e+8|0;v=a+24|0;w=e+4|0;a:while(1){x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;z=y&255;if(y<<24>>24>0){f[c>>2]=x+1;A=z;B=6}else{C=z;B=5}}else{C=0;B=5}if((B|0)==5){B=0;z=WRb(c,C)|0;if((z+-1|0)>>>0<127){A=z;B=6}else D=z}b:do if((B|0)==6){B=0;switch(A>>>3&536870911|0){case 1:{if((A&255|0)!=10){D=A;break b}z=f[i>>2]|0;x=z&-2;if(!(z&1))E=x;else E=f[x+4>>2]|0;x=f[h>>2]|0;if((x|0)==527320){WJa(h,E,527320);F=f[h>>2]|0}else F=x;if(!(fUb(c,F)|0)){G=0;B=79;break a}x=f[j>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0){H=f[x>>2]|0;I=f[x+4>>2]|0}else{H=x;I=z&255}if(gUb(H,I,0,458785)|0)continue a;else{G=0;B=79;break a}break}case 2:{if((A&255|0)!=18){D=A;break b}z=f[i>>2]|0;x=z&-2;if(!(z&1))J=x;else J=f[x+4>>2]|0;x=f[k>>2]|0;if((x|0)==527320){WJa(k,J,527320);K=f[k>>2]|0}else K=x;if(!(fUb(c,K)|0)){G=0;B=79;break a}x=f[l>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0){L=f[x>>2]|0;M=f[x+4>>2]|0}else{L=x;M=z&255}if(gUb(L,M,0,458822)|0)continue a;else{G=0;B=79;break a}break}case 3:{if((A&255|0)!=26){D=A;break b}z=f[m>>2]|0;if(!z){dGb(a);N=f[m>>2]|0}else N=z;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(x=b[z>>0]|0,x<<24>>24>-1):0){f[c>>2]=z+1;O=x&255}else{x=VRb(c)|0;if((x|0)>-1)O=x;else{G=0;B=79;break a}}GRb(e,c,O);if((f[n>>2]|0)<0){B=38;break a}if(!(Mi[f[(f[N>>2]|0)+44>>2]&1023](N,c)|0)){B=38;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{G=0;B=79;break a}break}case 4:{if((A&255|0)!=34){D=A;break b}x=f[i>>2]|0;z=x&-2;if(!(x&1))P=z;else P=f[z+4>>2]|0;z=f[o>>2]|0;if((z|0)==527320){WJa(o,P,527320);Q=f[o>>2]|0}else Q=z;if(!(fUb(c,Q)|0)){G=0;B=79;break a}z=f[p>>2]|0;x=b[z+11>>0]|0;if(x<<24>>24<0){R=f[z>>2]|0;S=f[z+4>>2]|0}else{R=z;S=x&255}if(gUb(R,S,0,458859)|0)continue a;else{G=0;B=79;break a}break}case 5:{if((A&255|0)!=40){D=A;break b}x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(z=b[x>>0]|0,z<<24>>24>-1):0){f[c>>2]=x+1;T=z<<24>>24!=0}else{IRb(e,c);z=e;if(!(b[r>>0]|0)){G=0;B=79;break a}else T=(f[z>>2]|0)!=0|(f[z+4>>2]|0)!=0}b[q>>0]=T&1;continue a;break}case 6:{if((A&255|0)!=48){D=A;break b}z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(x=b[z>>0]|0,x<<24>>24>-1):0){f[c>>2]=z+1;U=x&255;V=0}else{IRb(e,c);x=e;if(!(b[t>>0]|0)){G=0;B=79;break a}else{U=f[x>>2]|0;V=f[x+4>>2]|0}}x=s;f[x>>2]=U;f[x+4>>2]=V;continue a;break}case 7:{if((A&255|0)!=58){D=A;break b}x=f[v>>2]|0;if(!x){eGb(a);W=f[v>>2]|0}else W=x;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(z=b[x>>0]|0,z<<24>>24>-1):0){f[c>>2]=x+1;X=z&255}else{z=VRb(c)|0;if((z|0)>-1)X=z;else{G=0;B=79;break a}}GRb(e,c,X);if((f[w>>2]|0)<0){B=72;break a}if(!(Mi[f[(f[W>>2]|0)+44>>2]&1023](W,c)|0)){B=72;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{G=0;B=79;break a}break}default:{D=A;break b}}}while(0);if(!D){G=1;B=79;break}z=f[i>>2]|0;if(!(z&1))Y=mNa(i)|0;else Y=z&-2;if(!(Djc(c,D,Y)|0)){G=0;B=79;break}}if((B|0)==38){G=0;u=d;return G|0}else if((B|0)==72){G=0;u=d;return G|0}else if((B|0)==79){u=d;return G|0}return 0}function WFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=f[a+12>>2]|0;d=b[h+11>>0]|0;e=d<<24>>24<0;if(e)j=f[h+4>>2]|0;else j=d&255;if(!j)k=i;else{j=e?f[h+4>>2]|0:d&255;k=i+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}j=f[a+16>>2]|0;i=b[j+11>>0]|0;d=i<<24>>24<0;if(d)l=f[j+4>>2]|0;else l=i&255;if(!l)m=k;else{l=d?f[j+4>>2]|0:i&255;m=k+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if((a|0)!=526904){l=f[a+20>>2]|0;if(!l)n=m;else{k=_i[f[(f[l>>2]|0)+48>>2]&1023](l)|0;n=m+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}k=f[a+24>>2]|0;if(!k)o=n;else{l=_i[f[(f[k>>2]|0)+48>>2]&1023](k)|0;o=n+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}}else o=m;m=a+32|0;l=f[m>>2]|0;n=f[m+4>>2]|0;if((l|0)==0&(n|0)==0){p=o;q=a+40|0;r=b[q>>0]|0;s=r<<24>>24!=0;t=p+2|0;u=s?t:p;v=a+44|0;f[v>>2]=u;return u|0}m=iJc(l|1|0,n|0,1)|0;p=o+1+((((m^63)*9|0)+73|0)>>>6)|0;q=a+40|0;r=b[q>>0]|0;s=r<<24>>24!=0;t=p+2|0;u=s?t:p;v=a+44|0;f[v>>2]=u;return u|0}function XFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gUb(j,k,1,458785)|0;$Tb(1,f[d>>2]|0,c)}d=a+12|0;k=f[d>>2]|0;j=b[k+11>>0]|0;g=j<<24>>24<0;if(g)l=f[k+4>>2]|0;else l=j&255;if(l|0){if(g){m=f[k>>2]|0;n=f[k+4>>2]|0}else{m=k;n=j&255}gUb(m,n,1,458822)|0;$Tb(2,f[d>>2]|0,c)}d=(a|0)==526904;if(!d?(n=f[a+20>>2]|0,n|0):0)eUb(3,n,c);n=a+16|0;m=f[n>>2]|0;j=b[m+11>>0]|0;k=j<<24>>24<0;if(k)o=f[m+4>>2]|0;else o=j&255;if(o|0){if(k){p=f[m>>2]|0;q=f[m+4>>2]|0}else{p=m;q=j&255}gUb(p,q,1,458859)|0;$Tb(4,f[n>>2]|0,c)}if(b[a+40>>0]|0)YTb(5,1,c);n=a+32|0;q=f[n>>2]|0;p=f[n+4>>2]|0;if(!((q|0)==0&(p|0)==0))NTb(6,q,p,c);if(!d?(d=f[a+24>>2]|0,d|0):0)eUb(7,d,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function YFb(a){a=a|0;return f[a+44>>2]|0}function ZFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=a+8|0;g=f[e>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0;if(i)j=f[g+4>>2]|0;else j=h&255;if(!j)k=d;else{if(i){l=f[g>>2]|0;m=f[g+4>>2]|0}else{l=g;m=h&255}gUb(l,m,1,458785)|0;m=f[e>>2]|0;b[d>>0]=10;k=dSb(m,d+1|0)|0}d=a+12|0;m=f[d>>2]|0;e=b[m+11>>0]|0;l=e<<24>>24<0;if(l)n=f[m+4>>2]|0;else n=e&255;if(!n)o=k;else{if(l){p=f[m>>2]|0;q=f[m+4>>2]|0}else{p=m;q=e&255}gUb(p,q,1,458822)|0;q=f[d>>2]|0;b[k>>0]=18;o=dSb(q,k+1|0)|0}k=(a|0)==526904;if(!k?(q=f[a+20>>2]|0,(q|0)!=0):0){b[o>>0]=26;d=o+1|0;p=_i[f[(f[q>>2]|0)+60>>2]&1023](q)|0;if(p>>>0>127){e=p;m=d;while(1){b[m>>0]=e|128;l=e>>>7;n=m+1|0;if(e>>>0>16383){e=l;m=n}else{r=n;s=l;break}}}else{r=d;s=p}b[r>>0]=s;t=hj[f[(f[q>>2]|0)+64>>2]&511](q,c,r+1|0)|0}else t=o;o=a+16|0;r=f[o>>2]|0;q=b[r+11>>0]|0;s=q<<24>>24<0;if(s)u=f[r+4>>2]|0;else u=q&255;if(!u)v=t;else{if(s){w=f[r>>2]|0;x=f[r+4>>2]|0}else{w=r;x=q&255}gUb(w,x,1,458859)|0;x=f[o>>2]|0;b[t>>0]=34;v=dSb(x,t+1|0)|0}if(!(b[a+40>>0]|0))y=v;else{b[v>>0]=40;b[v+1>>0]=1;y=v+2|0}v=a+32|0;t=f[v>>2]|0;x=f[v+4>>2]|0;if((t|0)==0&(x|0)==0)z=y;else{b[y>>0]=48;v=y+1|0;y=t&255;if(x>>>0>0|(x|0)==0&t>>>0>127){o=v;w=y;q=t;t=x;while(1){b[o>>0]=w|-128;x=q;q=aJc(q|0,t|0,7)|0;r=o+1|0;s=q&255;if(!(t>>>0>0|(t|0)==0&x>>>0>16383)){A=r;B=s;break}else{o=r;w=s;t=J}}}else{A=v;B=y}b[A>>0]=B;z=A+1|0}if(!k?(k=f[a+24>>2]|0,(k|0)!=0):0){b[z>>0]=58;A=z+1|0;B=_i[f[(f[k>>2]|0)+60>>2]&1023](k)|0;if(B>>>0>127){y=B;v=A;while(1){b[v>>0]=y|128;t=y>>>7;w=v+1|0;if(y>>>0>16383){y=t;v=w}else{C=w;D=t;break}}}else{C=A;D=B}b[C>>0]=D;E=hj[f[(f[k>>2]|0)+64>>2]&511](k,c,C+1|0)|0}else E=z;z=f[a+4>>2]|0;if(!((z&1|0)!=0&(b[473420]|0)!=0)){F=E;return F|0}F=Hjc(z&-2,E)|0;return F|0}function _Fb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function $Fb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,19088,0)|0;if(!c){Ehc(b,a);return}else{cGb(a,c);return}}function aGb(a,b){a=a|0;b=b|0;f[a+44>>2]=b;return}function bGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220465]|0)!=2){f[d>>2]=161028;f[d+4>>2]=117;b[d+8>>0]=0;DTb(881860,d);ZSb(d)}d=527096;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function cGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+12>>2]|0;k=b[e+11>>0]|0;if(k<<24>>24<0)l=f[e+4>>2]|0;else l=k&255;do if(l|0){k=a+12|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==527320){WJa(k,m,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+16>>2]|0;m=b[e+11>>0]|0;if(m<<24>>24<0)n=f[e+4>>2]|0;else n=m&255;do if(n|0){m=a+16|0;l=f[d>>2]|0;j=l&-2;if(!(l&1))o=j;else o=f[j+4>>2]|0;j=f[m>>2]|0;if((j|0)==527320){WJa(m,o,e);break}else{iEc(j,e)|0;break}}while(0);if((c|0)!=526904){e=c+20|0;o=f[e>>2]|0;if(o|0){d=a+20|0;n=f[d>>2]|0;if(!n){dGb(a);p=f[e>>2]|0;q=f[d>>2]|0}else{p=o;q=n}lNa(q,p|0?p:520464)}p=c+24|0;q=f[p>>2]|0;if(q|0){n=a+24|0;o=f[n>>2]|0;if(!o){eGb(a);r=f[p>>2]|0;s=f[n>>2]|0}else{r=q;s=o}lNa(s,r|0?r:520464)}}r=c+32|0;s=f[r>>2]|0;o=f[r+4>>2]|0;if(!((s|0)==0&(o|0)==0)){r=a+32|0;f[r>>2]=s;f[r+4>>2]=o}if(!(b[c+40>>0]|0))return;b[a+40>>0]=1;return}function dGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(24)|0;JNa(c);e=c;g=a+20|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,14672,24);c=MQb(d,24)|0;KNa(c,d);e=c;g=a+20|0;f[g>>2]=e;return}function eGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(24)|0;JNa(c);e=c;g=a+24|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,14672,24);c=MQb(d,24)|0;KNa(c,d);e=c;g=a+24|0;f[g>>2]=e;return}function fGb(a){a=a|0;var c=0;c=f[a+8>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+12>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==526904)return;c=f[a+20>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+24>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function gGb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=106804;f[a+4>>2]=0;if((a|0)!=526864?(f[220467]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=119;b[d+8>>0]=0;DTb(881868,d);ZSb(d)}f[a+8>>2]=527320;f[a+12>>2]=527320;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;d=a+28|0;f[d>>2]=0;b[d+4>>0]=0;f[a+36>>2]=0;u=c;return}function hGb(a,b){a=a|0;b=b|0;jGb(b,a);return}function iGb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=106804;f[a+4>>2]=c;if((f[220467]|0)!=2){f[e>>2]=161028;f[e+4>>2]=119;b[e+8>>0]=0;DTb(881868,e);ZSb(e)}f[a+8>>2]=527320;f[a+12>>2]=527320;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;e=a+28|0;f[e>>2]=0;b[e+4>>0]=0;f[a+36>>2]=0;u=d;return}function jGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+12>>2]|0;k=b[e+11>>0]|0;if(k<<24>>24<0)l=f[e+4>>2]|0;else l=k&255;do if(l|0){k=a+12|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==527320){WJa(k,m,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+16>>2]|0;m=b[e+11>>0]|0;if(m<<24>>24<0)n=f[e+4>>2]|0;else n=m&255;do if(n|0){m=a+16|0;l=f[d>>2]|0;j=l&-2;if(!(l&1))o=j;else o=f[j+4>>2]|0;j=f[m>>2]|0;if((j|0)==527320){WJa(m,o,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+20>>2]|0;o=b[e+11>>0]|0;if(o<<24>>24<0)p=f[e+4>>2]|0;else p=o&255;do if(p|0){o=a+20|0;n=f[d>>2]|0;j=n&-2;if(!(n&1))q=j;else q=f[j+4>>2]|0;j=f[o>>2]|0;if((j|0)==527320){WJa(o,q,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+24>>2]|0;q=b[e+11>>0]|0;if(q<<24>>24<0)r=f[e+4>>2]|0;else r=q&255;do if(r|0){q=a+24|0;p=f[d>>2]|0;j=p&-2;if(!(p&1))s=j;else s=f[j+4>>2]|0;j=f[q>>2]|0;if((j|0)==527320){WJa(q,s,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+28>>2]|0;if(e|0)f[a+28>>2]=e;if(!(b[c+32>>0]|0))return;b[a+32>>0]=1;return}function kGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(40)|0;gGb(a);o=a}else{if(f[l+64>>2]|0)OQb(l,19024,40);a=MQb(l,40)|0;iGb(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function lGb(a){a=a|0;var c=0;c=f[a+56>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+60>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+64>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==526952)return;c=f[a+68>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function mGb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=106992;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=527056?(f[220471]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=123;b[d+8>>0]=0;DTb(881884,d);ZSb(d)}f[a+24>>2]=0;u=c;return}function nGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=106992;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;if((f[220471]|0)==2){g=a+24|0;f[g>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=123;b[e+8>>0]=0;DTb(881884,e);ZSb(e);g=a+24|0;f[g>>2]=0;u=d;return}function oGb(a){a=a|0;var c=0;c=f[a+8>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+12>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function pGb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220466]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=118;b[c+8>>0]=0;DTb(881864,c);ZSb(c);u=a;return}function qGb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220469]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=121;b[c+8>>0]=0;DTb(881876,c);ZSb(c);u=a;return}function rGb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220466]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=118;b[c+8>>0]=0;DTb(881864,c);ZSb(c);u=a;return}function sGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;XHb(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;tT(a,(f[c>>2]|0)+6|0)|0;g=f[c>>2]|0;if(!g)h=0;else{dJc(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;b[c>>0]=b[459339]|0;b[c+1>>0]=b[459340]|0;b[c+2>>0]=b[459341]|0;b[c+3>>0]=b[459342]|0;b[c+4>>0]=b[459343]|0;b[c+5>>0]=b[459344]|0;uT(e);u=d;return}function tGb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0;j=VDc(32)|0;r0(j);f[j>>2]=107424;f[j+4>>2]=b;f[j+8>>2]=d;f[j+12>>2]=c;n[j+16>>2]=e;f[j+20>>2]=g;f[j+24>>2]=h;f[j+28>>2]=i;i=VDc(16)|0;h=i+4|0;f[h>>2]=1;f[i>>2]=107552;f[i+8>>2]=j;f[a>>2]=i;f[a+4>>2]=j;f[h>>2]=(f[h>>2]|0)+1;j=f[h>>2]|0;f[h>>2]=j+-1;if((j|0)!=1)return;Yi[f[(f[i>>2]|0)+8>>2]&2047](i);return}function uGb(a){a=a|0;YDc(a);return}function vGb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function wGb(a){a=a|0;THb(a);YDc(a);return}function xGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;s0(a,c);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,10)|0;h=459644;i=g+10|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=E_(c,e)|0;uT(e);k=a+4|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,30)|0;h=471427;i=g+30|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,f[k>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,19)|0;h=459655;i=g+19|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));l=E_(c,e)|0;uT(e);k=a+8|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](l)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,30)|0;h=471427;i=g+30|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-2,e,518366,471458,1188)}P_(l,c+12|0,f[k>>2]|0);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,15)|0;h=459675;i=g+15|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=E_(c,e)|0;uT(e);k=a+12|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,30)|0;h=471427;i=g+30|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,f[k>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,9)|0;h=467837;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));l=E_(c,e)|0;uT(e);k=a+16|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](l)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,30)|0;h=471427;i=g+30|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-2,e,518366,471458,1188)}Q_(l,c+12|0,+n[k>>2]);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;j=tT(e,7)|0;b[j>>0]=b[463612]|0;b[j+1>>0]=b[463613]|0;b[j+2>>0]=b[463614]|0;b[j+3>>0]=b[463615]|0;b[j+4>>0]=b[463616]|0;b[j+5>>0]=b[463617]|0;b[j+6>>0]=b[463618]|0;j=E_(c,e)|0;uT(e);k=a+20|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,30)|0;h=471427;i=g+30|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,f[k>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,9)|0;h=463620;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));l=E_(c,e)|0;uT(e);k=a+24|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](l)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,30)|0;h=471427;i=g+30|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-2,e,518366,471458,1188)}P_(l,c+12|0,f[k>>2]|0);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,11)|0;h=463630;i=g+11|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=E_(c,e)|0;uT(e);k=a+28|0;if(!(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0)){u=d;return}a=c+32|0;if((f[a>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,30)|0;h=471427;i=g+30|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,f[k>>2]|0);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function yGb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+64|0;d=c+56|0;e=c+48|0;g=c+40|0;h=c+32|0;i=c+24|0;j=c+16|0;k=c+8|0;l=c;I_(e,b,459644);Y_(e,d,0);f[a+4>>2]=f[d>>2];I_(g,b,459655);Y_(g,d,0);f[a+8>>2]=f[d>>2];I_(h,b,459675);Y_(h,d,0);f[a+12>>2]=f[d>>2];I_(i,b,467837);Z_(i,d,0.0);f[a+16>>2]=f[d>>2];I_(j,b,463612);Y_(j,d,0);f[a+20>>2]=f[d>>2];I_(k,b,463620);Y_(k,d,0);f[a+24>>2]=f[d>>2];I_(l,b,463630);Y_(l,d,0);f[a+28>>2]=f[d>>2];u=c;return}function zGb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+416|0;j=i+336|0;k=i+56|0;l=i;if(r$(c)|0){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,15)|0;o=459428;p=m+15|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,j,463413,459444,172)}n[j+16>>2]=1.600000023841858;n[j+20>>2]=1.5;n[j+24>>2]=1.0;n[j+36>>2]=9.999999747378752e-06;f[j+52>>2]=10;n[j+56>>2]=1.0000000474974513e-03;n[j+60>>2]=.699999988079071;f[j+64>>2]=300;f[j+40>>2]=f[a+4>>2];f[j+48>>2]=f[a+8>>2];f[j+44>>2]=f[a+12>>2];q=l$(c,-1)|0;f[j+8>>2]=q;q=k$(c,-1)|0;f[j+12>>2]=q;f[j+32>>2]=f[a+16>>2];f[j>>2]=f[a+20>>2];f[j+4>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];mJb(k,j);vJb(k,c);if(!h)AJb(k,e);if(!(r$(d)|0)){do if((d$(d)|0)==65536){h=f[d+4>>2]|0;f[l>>2]=f[h>>2];c=l+4|0;j=h+4|0;f[c>>2]=f[j>>2];q=l+8|0;f[q>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];r=f[h+36>>2]|0;f[l+36>>2]=r;f[l+40>>2]=q;q=l+48|0;s=l+44|0;f[s>>2]=q;f[q>>2]=0;f[l+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];break}else{f[c>>2]=0;ZS(l,h);break}}else a$(l,d,-1);while(0);SHb(e,l);d=l+36|0;h=f[d>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)_S(l);f[d>>2]=0;d=l+16|0;h=l+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[h>>2]|0)>0){d=f[l+40>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[h>>2]|0))}h=f[l+44>>2]|0;if((h|0)!=(l+48|0))g0(h)}if(!($$(g)|0)){RGb(k);u=i;return}HJb(k,e,g);if(!(r$(g)|0)?(e=l$(g,-1)|0,(e|0)!=(_i[f[(f[a>>2]|0)+52>>2]&1023](a)|0)):0){f[l>>2]=0;f[l+4>>2]=0;m=tT(l,63)|0;o=459514;p=m+63|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,l,463413,459444,202)}if(r$(g)|0){RGb(k);u=i;return}e=c$(g,-1)|0;if((e|0)==(_i[f[(f[a>>2]|0)+56>>2]&1023](a)|0)){RGb(k);u=i;return}else{f[l>>2]=0;f[l+4>>2]=0;m=tT(l,65)|0;o=459578;p=m+65|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-215,l,463413,459444,203)}}function AGb(a){a=a|0;var b=0,c=0;switch(f[a+4>>2]|0){case 4:case 5:{b=f[a+12>>2]|0;if(!b){c=(((f[a+8>>2]|0)*162|0)+7|0)>>>3;return c|0}else{c=(b+7|0)>>>3;return c|0}break}case 2:case 3:{c=64;return c|0}default:{c=-1;return c|0}}return 0}function BGb(a){a=a|0;var b=0;switch(f[a+4>>2]|0){case 2:case 3:{b=5;break}case 4:case 5:{b=0;break}default:b=-1}return b|0}function CGb(a){a=a|0;var b=0;switch(f[a+4>>2]|0){case 2:case 3:{b=4;break}case 4:case 5:{b=6;break}default:b=-1}return b|0}function DGb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function EGb(a){a=a|0;return f[a+4>>2]|0}function FGb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function GGb(a){a=a|0;return f[a+12>>2]|0}function HGb(a,b){a=a|0;b=b|0;f[a+8>>2]=b;return}function IGb(a){a=a|0;return f[a+8>>2]|0}function JGb(a,b){a=a|0;b=+b;n[a+16>>2]=b;return}function KGb(a){a=a|0;return +(+n[a+16>>2])}function LGb(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function MGb(a){a=a|0;return f[a+20>>2]|0}function NGb(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function OGb(a){a=a|0;return f[a+24>>2]|0}function PGb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function QGb(a){a=a|0;return f[a+28>>2]|0}function RGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+224|0;c=a+260|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+240|0;b=a+228|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+264>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+268>>2]|0;if((b|0)!=(a+272|0))g0(b);b=a+168|0;d=a+204|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+184|0;b=a+172|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+208>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+212>>2]|0;if((b|0)!=(a+216|0))g0(b);b=a+112|0;c=a+148|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+128|0;b=a+116|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+152>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+156>>2]|0;if((b|0)!=(a+160|0))g0(b);b=f[a+100>>2]|0;if(b|0){d=a+104|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=a+88|0;c=f[b>>2]|0;if(c|0){d=a+92|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-4-i|0)>>>2)<<2);YDc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}YDc(g)}g=a+68|0;b=f[g>>2]|0;if(!b)return;j=a+72|0;while(1){a=f[j>>2]|0;if((a|0)==(b|0))break;h=a+-316|0;f[j>>2]=h;SGb(h)}YDc(f[g>>2]|0);return}function SGb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+224|0;c=a+260|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+240|0;b=a+228|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+264>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+268>>2]|0;if((b|0)!=(a+272|0))g0(b);b=a+168|0;d=a+204|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+184|0;b=a+172|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+208>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+212>>2]|0;if((b|0)!=(a+216|0))g0(b);b=a+112|0;c=a+148|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+128|0;b=a+116|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+152>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+156>>2]|0;if((b|0)!=(a+160|0))g0(b);b=a+56|0;d=a+92|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+72|0;b=a+60|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+96>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;c=f[b>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;c=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[a+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+44>>2]|0;if((c|0)==(a+48|0))return;g0(c);return}function TGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;XHb(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;tT(a,(f[c>>2]|0)+4|0)|0;g=f[c>>2]|0;if(!g)h=0;else{dJc(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;b[c>>0]=46;b[c+1>>0]=79;b[c+2>>0]=82;b[c+3>>0]=66;uT(e);u=d;return}function UGb(a){a=a|0;THb(a);YDc(a);return}function VGb(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0.0,Gd=0.0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0;j=u;u=u+6016|0;k=j+4944|0;l=j+4888|0;m=j+792|0;o=j+736|0;q=j+680|0;r=j+624|0;s=j+576|0;t=j;v=j+560|0;w=j+552|0;x=j+496|0;y=j+440|0;z=j+400|0;A=j+380|0;B=j+368|0;C=j+312|0;D=j+256|0;E=j+208|0;F=j+160|0;G=j+104|0;H=j+48|0;I=j+432|0;K=j+424|0;L=j+416|0;Q=j+392|0;R=a+36|0;if((f[R>>2]|0)<=1){f[k>>2]=0;f[k+4>>2]=0;S=tT(k,14)|0;T=459818;U=S+14|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));z5(-215,k,463413,459750,971)}V=$$(g)|0;if(!(V|i^1)){u=j;return}if(r$(c)|0){u=j;return}W=+((f[R>>2]|0)/2|0|0)*1.4142135623730951;X=~~W;Z=(+(X|0)<W&1)+X|0;X=a+20|0;_=f[X>>2]|0;$=(Z|0)>4?Z:4;Z=((_|0)<($|0)?$:_)+1|0;do if((d$(c)|0)==65536){_=f[c+4>>2]|0;f[x>>2]=f[_>>2];$=x+4|0;aa=_+4|0;f[$>>2]=f[aa>>2];ba=x+8|0;f[ba>>2]=f[_+8>>2];f[x+12>>2]=f[_+12>>2];f[x+16>>2]=f[_+16>>2];f[x+20>>2]=f[_+20>>2];f[x+24>>2]=f[_+24>>2];f[x+28>>2]=f[_+28>>2];f[x+32>>2]=f[_+32>>2];ca=f[_+36>>2]|0;f[x+36>>2]=ca;f[x+40>>2]=ba;ba=x+48|0;da=x+44|0;f[da>>2]=ba;f[ba>>2]=0;f[x+52>>2]=0;if(ca|0){ba=ca+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[_+44>>2]|0;ba=f[da>>2]|0;f[ba>>2]=f[aa>>2];f[ba+4>>2]=f[aa+4>>2];break}else{f[$>>2]=0;ZS(x,_);break}}else a$(x,c,-1);while(0);do if((d$(d)|0)==65536){_=f[d+4>>2]|0;f[y>>2]=f[_>>2];$=y+4|0;aa=_+4|0;f[$>>2]=f[aa>>2];ba=y+8|0;f[ba>>2]=f[_+8>>2];f[y+12>>2]=f[_+12>>2];f[y+16>>2]=f[_+16>>2];f[y+20>>2]=f[_+20>>2];f[y+24>>2]=f[_+24>>2];f[y+28>>2]=f[_+28>>2];f[y+32>>2]=f[_+32>>2];da=f[_+36>>2]|0;f[y+36>>2]=da;f[y+40>>2]=ba;ba=y+48|0;ca=y+44|0;f[ca>>2]=ba;f[ba>>2]=0;f[y+52>>2]=0;if(da|0){ba=da+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[_+44>>2]|0;ba=f[ca>>2]|0;f[ba>>2]=f[aa>>2];f[ba+4>>2]=f[aa+4>>2];break}else{f[$>>2]=0;ZS(y,_);break}}else a$(y,d,-1);while(0);if(f[x>>2]&4095|0){d=k+8|0;f[d>>2]=0;f[d+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=x;Oga(c,k,6,0)}c=f[a+16>>2]|0;d=e+4|0;_=f[e>>2]|0;$=(f[d>>2]|0)-_|0;aa=($|0)/28|0;ba=_;if(i){a:do if(($|0)>0){_=0;ca=1;da=0;while(1){ea=f[ba+(_*28|0)+20>>2]|0;if((ea|0)<=-1)break;if((_|0)>0)fa=ca&(ea|0)>=(f[ba+((_+-1|0)*28|0)+20>>2]|0);else fa=ca;ga=(da|0)<(ea|0)?ea:da;_=_+1|0;if((_|0)>=(aa|0)){ha=fa;ia=ga;break a}else{ca=fa;da=ga}}f[k>>2]=0;f[k+4>>2]=0;S=tT(k,10)|0;T=459833;U=S+10|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));z5(-215,k,463413,459750,1010)}else{ha=1;ia=0}while(0);ja=ia+1|0;ka=ha}else{ja=c;ka=1}f[z>>2]=0;c=z+4|0;f[c>>2]=0;f[z+8>>2]=0;ha=(ja|0)==0;do if(!ha)if(ja>>>0>268435455)mCc(z);else{ia=ja<<4;fa=VDc(ia)|0;f[z>>2]=fa;f[z+8>>2]=fa+(ja<<4);XIc(fa|0,0,ia|0)|0;f[c>>2]=fa+ia;la=fa;break}else la=0;while(0);f[A>>2]=0;fa=A+4|0;f[fa>>2]=0;f[A+8>>2]=0;if(ha)ma=0;else{ia=ja<<2;aa=VDc(ia)|0;f[A>>2]=aa;ba=aa+(ja<<2)|0;f[A+8>>2]=ba;XIc(aa|0,0,ia|0)|0;f[fa>>2]=ba;ma=aa}f[B>>2]=0;aa=B+4|0;f[aa>>2]=0;f[B+8>>2]=0;if(ha)na=0;else{ha=ja<<2;ba=VDc(ha)|0;f[B>>2]=ba;ia=ba+(ja<<2)|0;f[B+8>>2]=ia;XIc(ba|0,0,ha|0)|0;f[aa>>2]=ia;na=ba}f[C>>2]=1124007936;ba=C+4|0;ia=C+8|0;ha=C+40|0;S=ba;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[ha>>2]=ia;ia=C+48|0;$=C+44|0;f[$>>2]=ia;f[ia>>2]=0;f[C+52>>2]=0;f[D>>2]=1124007936;da=D+4|0;ca=D+8|0;_=D+40|0;S=da;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[_>>2]=ca;ga=D+48|0;ea=D+44|0;f[ea>>2]=ga;f[ga>>2]=0;f[D+52>>2]=0;f[E>>2]=1124007936;oa=E+4|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;f[oa+16>>2]=0;f[oa+20>>2]=0;f[oa+24>>2]=0;f[E+32>>2]=E+8;oa=E+40|0;f[E+36>>2]=oa;f[E+44>>2]=0;f[oa>>2]=0;f[F>>2]=1124007936;oa=F+4|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;f[oa+16>>2]=0;f[oa+20>>2]=0;f[oa+24>>2]=0;f[F+32>>2]=F+8;oa=F+40|0;f[F+36>>2]=oa;f[F+44>>2]=0;f[oa>>2]=0;oa=x+8|0;pa=f[oa>>2]|0;qa=Z<<1;ra=pa+qa|0;sa=x+12|0;ta=f[sa>>2]|0;ua=a+24|0;va=f[ua>>2]|0;wa=a+8|0;W=+p[wa>>3];xa=qa+15+(mrc(+(ta|0)/+N(+W,+(+(0-va|0))))|0)&-16;ya=(ja|0)>0;b:do if(ya){za=f[sa>>2]|0;Aa=f[oa>>2]|0;Ba=ra;Ca=0;Da=0;Ea=va;Fa=ta;Ga=pa;Ha=0;while(1){Ia=+N(+W,+(+(Ha-Ea|0)));n[na+(Ha<<2)>>2]=Ia;Ja=mrc(+(Fa|0)/Ia)|0;Ka=mrc(+(Ga|0)/Ia)|0;La=Ja+qa|0;Ma=(La+Ca|0)>(xa|0);Na=Ma?0:Ca;Oa=(Ma?Ba:0)+Da|0;Pa=Ma?Ka+qa|0:Ba;Ma=Na+Z|0;Qa=Oa+Z|0;f[la+(Ha<<4)>>2]=Ma;f[la+(Ha<<4)+4>>2]=Qa;f[la+(Ha<<4)+8>>2]=Ja;f[la+(Ha<<4)+12>>2]=Ka;Ka=(Y(Qa,xa)|0)+Ma|0;f[ma+(Ha<<2)>>2]=Ka;Ka=Ha+1|0;if((Ka|0)==(ja|0)){Ra=Pa;Sa=Oa;break b}Ba=Pa;Ca=Na+La|0;Da=Oa;Ea=f[ua>>2]|0;Fa=za;Ga=Aa;Ha=Ka}}else{Ra=ra;Sa=0}while(0);ra=Ra+Sa|0;f[k>>2]=ra;f[k+4>>2]=xa;XS(C,2,k,0);Sa=y+16|0;do if(f[Sa>>2]|0){Ra=f[y+4>>2]|0;if((Ra|0)<3)Ta=Y(f[y+12>>2]|0,f[y+8>>2]|0)|0;else{ma=f[y+40>>2]|0;la=0;na=1;while(1){pa=Y(f[ma+(la<<2)>>2]|0,na)|0;la=la+1|0;if((la|0)==(Ra|0)){Ta=pa;break}else na=pa}}if(!((Ra|0)==0|(Ta|0)==0)){if(((((f[da>>2]|0)<3?(f[ca>>2]|0)==(ra|0):0)?(f[D+12>>2]|0)==(xa|0):0)?(f[D>>2]&4095|0)==0:0)?f[D+16>>2]|0:0)break;f[k>>2]=ra;f[k+4>>2]=xa;XS(D,2,k,0)}}while(0);f[G>>2]=f[x>>2];xa=G+4|0;ra=x+4|0;Ta=f[ra>>2]|0;f[xa>>2]=Ta;na=G+8|0;f[na>>2]=f[oa>>2];oa=G+12|0;f[oa>>2]=f[sa>>2];sa=G+16|0;la=x+16|0;f[sa>>2]=f[la>>2];ma=G+20|0;f[ma>>2]=f[x+20>>2];pa=G+24|0;f[pa>>2]=f[x+24>>2];ta=G+28|0;f[ta>>2]=f[x+28>>2];va=G+32|0;f[va>>2]=f[x+32>>2];Ha=G+36|0;Aa=x+36|0;Ga=f[Aa>>2]|0;f[Ha>>2]=Ga;za=G+40|0;f[za>>2]=na;Fa=G+48|0;Ea=G+44|0;f[Ea>>2]=Fa;f[Fa>>2]=0;f[G+52>>2]=0;if(!Ga)Ua=Ta;else{Ta=Ga+12|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ua=f[ra>>2]|0}if((Ua|0)<3){Ua=f[x+44>>2]|0;Ta=f[Ea>>2]|0;f[Ta>>2]=f[Ua>>2];f[Ta+4>>2]=f[Ua+4>>2]}else{f[xa>>2]=0;ZS(G,x)}f[H>>2]=f[y>>2];Ua=H+4|0;Ta=y+4|0;Ga=f[Ta>>2]|0;f[Ua>>2]=Ga;Da=H+8|0;Ca=y+8|0;f[Da>>2]=f[Ca>>2];Ba=H+12|0;Ka=y+12|0;f[Ba>>2]=f[Ka>>2];Oa=H+16|0;f[Oa>>2]=f[Sa>>2];La=H+20|0;f[La>>2]=f[y+20>>2];Na=H+24|0;f[Na>>2]=f[y+24>>2];Pa=H+28|0;f[Pa>>2]=f[y+28>>2];Ma=H+32|0;f[Ma>>2]=f[y+32>>2];Qa=H+36|0;Ja=y+36|0;Va=f[Ja>>2]|0;f[Qa>>2]=Va;Wa=H+40|0;f[Wa>>2]=Da;Xa=H+48|0;Ya=H+44|0;f[Ya>>2]=Xa;f[Xa>>2]=0;f[H+52>>2]=0;if(!Va)Za=Ga;else{Ga=Va+12|0;f[Ga>>2]=(f[Ga>>2]|0)+1;Za=f[Ta>>2]|0}if((Za|0)<3){Za=f[y+44>>2]|0;Ga=f[Ya>>2]|0;f[Ga>>2]=f[Za>>2];f[Ga+4>>2]=f[Za+4>>2]}else{f[Ua>>2]=0;ZS(H,y)}if(ya){Za=k+4|0;Ga=k+8|0;Va=k+12|0;_a=m+4|0;$a=m+8|0;ab=m+40|0;bb=m+48|0;cb=m+44|0;db=m+52|0;eb=q+4|0;fb=q+8|0;gb=q+12|0;hb=q+4|0;ib=q+8|0;jb=q+40|0;kb=q+48|0;lb=q+44|0;mb=q+52|0;nb=r+8|0;ob=r+12|0;pb=r+4|0;qb=s+8|0;rb=s+4|0;sb=r+8|0;tb=r+12|0;ub=r+4|0;vb=s+8|0;wb=s+4|0;xb=y+40|0;yb=o+36|0;zb=o+4|0;Ab=o+8|0;Bb=o+12|0;Cb=o+44|0;Db=o+16|0;Eb=o+20|0;Fb=o+24|0;Gb=o+28|0;Hb=o+32|0;Ib=q+36|0;Jb=q+12|0;Kb=q+16|0;Lb=q+20|0;Mb=q+24|0;Nb=q+28|0;Ob=q+32|0;Pb=o+40|0;Qb=o+48|0;Rb=m+36|0;Sb=m+16|0;Tb=l+36|0;Ub=l+16|0;Vb=l+4|0;Wb=l+40|0;Xb=l+44|0;Yb=l+48|0;Zb=r+8|0;_b=r+12|0;$b=r+4|0;ac=s+8|0;bc=s+4|0;cc=I+4|0;dc=r+8|0;ec=r+12|0;fc=r+4|0;gc=s+8|0;hc=s+4|0;ic=r+8|0;jc=r+12|0;kc=r+4|0;lc=s+8|0;mc=s+4|0;nc=r+8|0;oc=r+12|0;pc=r+4|0;qc=s+8|0;rc=s+4|0;sc=K+4|0;tc=r+8|0;uc=r+12|0;vc=r+4|0;wc=s+8|0;xc=s+4|0;yc=r+36|0;zc=r+4|0;Ac=r+8|0;Bc=r+12|0;Cc=m+12|0;Dc=r+44|0;Ec=r+16|0;Fc=r+20|0;Gc=m+20|0;Hc=r+24|0;Ic=m+24|0;Jc=r+28|0;Kc=m+28|0;Lc=r+32|0;Mc=m+32|0;Nc=r+40|0;Oc=r+48|0;Pc=s+4|0;Qc=s+8|0;Rc=s+12|0;Sc=r+36|0;Tc=r+4|0;Uc=r+8|0;Vc=r+12|0;Wc=r+44|0;Xc=r+16|0;Yc=r+20|0;Zc=r+24|0;_c=r+28|0;$c=r+32|0;ad=r+40|0;bd=r+48|0;cd=0;do{dd=f[z>>2]|0;ed=f[dd+(cd<<4)+8>>2]|0;fd=f[dd+(cd<<4)+12>>2]|0;gd=(f[dd+(cd<<4)+4>>2]|0)-Z|0;f[k>>2]=(f[dd+(cd<<4)>>2]|0)-Z;f[Za>>2]=gd;f[Ga>>2]=ed+qa;f[Va>>2]=fd+qa;cT(l,C,k);f[m>>2]=1124007936;S=_a;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[ab>>2]=$a;f[cb>>2]=bb;f[bb>>2]=0;f[db>>2]=0;f[q>>2]=Z;f[eb>>2]=Z;f[fb>>2]=ed;f[gb>>2]=fd;cT(o,l,q);f[q>>2]=1124007936;S=hb;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[jb>>2]=ib;f[lb>>2]=kb;f[kb>>2]=0;f[mb>>2]=0;do if(f[Sa>>2]|0){Ra=f[Ta>>2]|0;if((Ra|0)<3)hd=Y(f[Ka>>2]|0,f[Ca>>2]|0)|0;else{gd=f[xb>>2]|0;dd=0;id=1;while(1){jd=Y(f[gd+(dd<<2)>>2]|0,id)|0;dd=dd+1|0;if((dd|0)==(Ra|0)){hd=jd;break}else id=jd}}if((Ra|0)==0|(hd|0)==0)break;cT(r,D,k);id=f[yc>>2]|0;if(id|0){dd=id+12|0;f[dd>>2]=(f[dd>>2]|0)+1}dd=f[Rb>>2]|0;do if(dd|0){id=dd+12|0;gd=f[id>>2]|0;f[id>>2]=gd+-1;if((gd|0)!=1)break;_S(m)}while(0);f[Rb>>2]=0;f[Sb>>2]=0;f[Sb+4>>2]=0;f[Sb+8>>2]=0;f[Sb+12>>2]=0;if((f[_a>>2]|0)>0){dd=f[ab>>2]|0;Ra=0;do{f[dd+(Ra<<2)>>2]=0;Ra=Ra+1|0;kd=f[_a>>2]|0}while((Ra|0)<(kd|0));f[m>>2]=f[r>>2];if((kd|0)<3)ld=80;else ld=82}else{f[m>>2]=f[r>>2];ld=80}do if((ld|0)==80){ld=0;Ra=f[zc>>2]|0;if((Ra|0)>=3){ld=82;break}f[_a>>2]=Ra;f[$a>>2]=f[Ac>>2];f[Cc>>2]=f[Bc>>2];Ra=f[Dc>>2]|0;dd=f[cb>>2]|0;f[dd>>2]=f[Ra>>2];f[dd+4>>2]=f[Ra+4>>2]}while(0);if((ld|0)==82){ld=0;ZS(m,r)}f[Sb>>2]=f[Ec>>2];f[Gc>>2]=f[Fc>>2];f[Ic>>2]=f[Hc>>2];f[Kc>>2]=f[Jc>>2];f[Mc>>2]=f[Lc>>2];Ra=f[yc>>2]|0;f[Rb>>2]=Ra;do if(Ra|0){dd=Ra+12|0;gd=f[dd>>2]|0;f[dd>>2]=gd+-1;if((gd|0)!=1)break;_S(r)}while(0);f[yc>>2]=0;f[Ec>>2]=0;f[Ec+4>>2]=0;f[Ec+8>>2]=0;f[Ec+12>>2]=0;if((f[zc>>2]|0)>0){Ra=f[Nc>>2]|0;gd=0;do{f[Ra+(gd<<2)>>2]=0;gd=gd+1|0}while((gd|0)<(f[zc>>2]|0))}gd=f[Dc>>2]|0;if((gd|0)!=(Oc|0))g0(gd);f[s>>2]=Z;f[Pc>>2]=Z;f[Qc>>2]=ed;f[Rc>>2]=fd;cT(r,m,s);gd=f[Sc>>2]|0;if(gd|0){Ra=gd+12|0;f[Ra>>2]=(f[Ra>>2]|0)+1}Ra=f[Ib>>2]|0;do if(Ra|0){gd=Ra+12|0;dd=f[gd>>2]|0;f[gd>>2]=dd+-1;if((dd|0)!=1)break;_S(q)}while(0);f[Ib>>2]=0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[Kb+8>>2]=0;f[Kb+12>>2]=0;if((f[hb>>2]|0)>0){Ra=f[jb>>2]|0;dd=0;do{f[Ra+(dd<<2)>>2]=0;dd=dd+1|0;md=f[hb>>2]|0}while((dd|0)<(md|0));f[q>>2]=f[r>>2];if((md|0)<3)ld=101;else ld=103}else{f[q>>2]=f[r>>2];ld=101}do if((ld|0)==101){ld=0;dd=f[Tc>>2]|0;if((dd|0)>=3){ld=103;break}f[hb>>2]=dd;f[ib>>2]=f[Uc>>2];f[Jb>>2]=f[Vc>>2];dd=f[Wc>>2]|0;Ra=f[lb>>2]|0;f[Ra>>2]=f[dd>>2];f[Ra+4>>2]=f[dd+4>>2]}while(0);if((ld|0)==103){ld=0;ZS(q,r)}f[Kb>>2]=f[Xc>>2];f[Lb>>2]=f[Yc>>2];f[Mb>>2]=f[Zc>>2];f[Nb>>2]=f[_c>>2];f[Ob>>2]=f[$c>>2];dd=f[Sc>>2]|0;f[Ib>>2]=dd;do if(dd|0){Ra=dd+12|0;gd=f[Ra>>2]|0;f[Ra>>2]=gd+-1;if((gd|0)!=1)break;_S(r)}while(0);f[Sc>>2]=0;f[Xc>>2]=0;f[Xc+4>>2]=0;f[Xc+8>>2]=0;f[Xc+12>>2]=0;if((f[Tc>>2]|0)>0){dd=f[ad>>2]|0;gd=0;do{f[dd+(gd<<2)>>2]=0;gd=gd+1|0}while((gd|0)<(f[Tc>>2]|0))}gd=f[Wc>>2]|0;if((gd|0)!=(bd|0))g0(gd)}while(0);do if((cd|0)==(f[ua>>2]|0)){f[nb>>2]=0;f[ob>>2]=0;f[r>>2]=16842752;f[pb>>2]=x;gd=qb;f[gd>>2]=0;f[gd+4>>2]=0;f[s>>2]=33619968;f[rb>>2]=l;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;q_(r,s,Z,Z,Z,Z,4,t);if(!(f[Sa>>2]|0))break;gd=f[Ta>>2]|0;if((gd|0)<3)nd=Y(f[Ka>>2]|0,f[Ca>>2]|0)|0;else{dd=f[xb>>2]|0;Ra=0;id=1;while(1){jd=Y(f[dd+(Ra<<2)>>2]|0,id)|0;Ra=Ra+1|0;if((Ra|0)==(gd|0)){nd=jd;break}else id=jd}}if((gd|0)==0|(nd|0)==0)break;f[sb>>2]=0;f[tb>>2]=0;f[r>>2]=16842752;f[ub>>2]=y;id=vb;f[id>>2]=0;f[id+4>>2]=0;f[s>>2]=33619968;f[wb>>2]=m;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;q_(r,s,Z,Z,Z,Z,16,t)}else{f[Zb>>2]=0;f[_b>>2]=0;f[r>>2]=16842752;f[$b>>2]=G;id=ac;f[id>>2]=0;f[id+4>>2]=0;f[s>>2]=33619968;f[bc>>2]=o;f[I>>2]=ed;f[cc>>2]=fd;nfa(r,s,I,0.0,0.0,5);do if(f[Sa>>2]|0){id=f[Ta>>2]|0;if((id|0)<3)od=Y(f[Ka>>2]|0,f[Ca>>2]|0)|0;else{Ra=f[xb>>2]|0;dd=0;jd=1;while(1){pd=Y(f[Ra+(dd<<2)>>2]|0,jd)|0;dd=dd+1|0;if((dd|0)==(id|0)){od=pd;break}else jd=pd}}if((id|0)==0|(od|0)==0)break;f[nc>>2]=0;f[oc>>2]=0;f[r>>2]=16842752;f[pc>>2]=H;jd=qc;f[jd>>2]=0;f[jd+4>>2]=0;f[s>>2]=33619968;f[rc>>2]=q;f[K>>2]=ed;f[sc>>2]=fd;nfa(r,s,K,0.0,0.0,5);if((cd|0)<=(f[ua>>2]|0))break;f[tc>>2]=0;f[uc>>2]=0;f[r>>2]=16842752;f[vc>>2]=q;jd=wc;f[jd>>2]=0;f[jd+4>>2]=0;f[s>>2]=33619968;f[xc>>2]=q;+Cxa(r,s,254.0,0.0,3)}while(0);f[dc>>2]=0;f[ec>>2]=0;f[r>>2]=16842752;f[fc>>2]=o;gd=gc;f[gd>>2]=0;f[gd+4>>2]=0;f[s>>2]=33619968;f[hc>>2]=l;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;q_(r,s,Z,Z,Z,Z,20,t);if(!(f[Sa>>2]|0))break;gd=f[Ta>>2]|0;if((gd|0)<3)qd=Y(f[Ka>>2]|0,f[Ca>>2]|0)|0;else{jd=f[xb>>2]|0;dd=0;Ra=1;while(1){pd=Y(f[jd+(dd<<2)>>2]|0,Ra)|0;dd=dd+1|0;if((dd|0)==(gd|0)){qd=pd;break}else Ra=pd}}if((gd|0)==0|(qd|0)==0)break;f[ic>>2]=0;f[jc>>2]=0;f[r>>2]=16842752;f[kc>>2]=q;Ra=lc;f[Ra>>2]=0;f[Ra+4>>2]=0;f[s>>2]=33619968;f[mc>>2]=m;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;q_(r,s,Z,Z,Z,Z,16,t)}while(0);if((cd|0)>(f[ua>>2]|0)){fd=f[yb>>2]|0;if(fd|0){ed=fd+12|0;f[ed>>2]=(f[ed>>2]|0)+1}ed=f[Ha>>2]|0;do if(ed|0){fd=ed+12|0;Ra=f[fd>>2]|0;f[fd>>2]=Ra+-1;if((Ra|0)!=1)break;_S(G)}while(0);f[Ha>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[xa>>2]|0)>0){ed=f[za>>2]|0;Ra=0;do{f[ed+(Ra<<2)>>2]=0;Ra=Ra+1|0;rd=f[xa>>2]|0}while((Ra|0)<(rd|0));f[G>>2]=f[o>>2];if((rd|0)<3)ld=148;else ld=150}else{f[G>>2]=f[o>>2];ld=148}do if((ld|0)==148){ld=0;Ra=f[zb>>2]|0;if((Ra|0)>=3){ld=150;break}f[xa>>2]=Ra;f[na>>2]=f[Ab>>2];f[oa>>2]=f[Bb>>2];Ra=f[Cb>>2]|0;ed=f[Ea>>2]|0;f[ed>>2]=f[Ra>>2];f[ed+4>>2]=f[Ra+4>>2]}while(0);if((ld|0)==150){ld=0;ZS(G,o)}f[sa>>2]=f[Db>>2];f[ma>>2]=f[Eb>>2];f[pa>>2]=f[Fb>>2];f[ta>>2]=f[Gb>>2];f[va>>2]=f[Hb>>2];f[Ha>>2]=f[yb>>2];Ra=f[Ib>>2]|0;if(Ra|0){ed=Ra+12|0;f[ed>>2]=(f[ed>>2]|0)+1}ed=f[Qa>>2]|0;do if(ed|0){Ra=ed+12|0;fd=f[Ra>>2]|0;f[Ra>>2]=fd+-1;if((fd|0)!=1)break;_S(H)}while(0);f[Qa>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[Ua>>2]|0)>0){ed=f[Wa>>2]|0;fd=0;do{f[ed+(fd<<2)>>2]=0;fd=fd+1|0;sd=f[Ua>>2]|0}while((fd|0)<(sd|0));f[H>>2]=f[q>>2];if((sd|0)<3)ld=161;else ld=163}else{f[H>>2]=f[q>>2];ld=161}do if((ld|0)==161){ld=0;fd=f[hb>>2]|0;if((fd|0)>=3){ld=163;break}f[Ua>>2]=fd;f[Da>>2]=f[ib>>2];f[Ba>>2]=f[Jb>>2];fd=f[lb>>2]|0;ed=f[Ya>>2]|0;f[ed>>2]=f[fd>>2];f[ed+4>>2]=f[fd+4>>2]}while(0);if((ld|0)==163){ld=0;ZS(H,q)}f[Oa>>2]=f[Kb>>2];f[La>>2]=f[Lb>>2];f[Na>>2]=f[Mb>>2];f[Pa>>2]=f[Nb>>2];f[Ma>>2]=f[Ob>>2];fd=f[Ib>>2]|0;f[Qa>>2]=fd;td=fd}else td=f[Ib>>2]|0;do if(td|0){fd=td+12|0;ed=f[fd>>2]|0;f[fd>>2]=ed+-1;if((ed|0)!=1)break;_S(q)}while(0);f[Ib>>2]=0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[Kb+8>>2]=0;f[Kb+12>>2]=0;if((f[hb>>2]|0)>0){ed=f[jb>>2]|0;fd=0;do{f[ed+(fd<<2)>>2]=0;fd=fd+1|0}while((fd|0)<(f[hb>>2]|0))}fd=f[lb>>2]|0;if((fd|0)!=(kb|0))g0(fd);fd=f[yb>>2]|0;do if(fd|0){ed=fd+12|0;Ra=f[ed>>2]|0;f[ed>>2]=Ra+-1;if((Ra|0)!=1)break;_S(o)}while(0);f[yb>>2]=0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;if((f[zb>>2]|0)>0){fd=f[Pb>>2]|0;Ra=0;do{f[fd+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[zb>>2]|0))}Ra=f[Cb>>2]|0;if((Ra|0)!=(Qb|0))g0(Ra);Ra=f[Rb>>2]|0;do if(Ra|0){fd=Ra+12|0;ed=f[fd>>2]|0;f[fd>>2]=ed+-1;if((ed|0)!=1)break;_S(m)}while(0);f[Rb>>2]=0;f[Sb>>2]=0;f[Sb+4>>2]=0;f[Sb+8>>2]=0;f[Sb+12>>2]=0;if((f[_a>>2]|0)>0){Ra=f[ab>>2]|0;ed=0;do{f[Ra+(ed<<2)>>2]=0;ed=ed+1|0}while((ed|0)<(f[_a>>2]|0))}ed=f[cb>>2]|0;if((ed|0)!=(bb|0))g0(ed);ed=f[Tb>>2]|0;do if(ed|0){Ra=ed+12|0;fd=f[Ra>>2]|0;f[Ra>>2]=fd+-1;if((fd|0)!=1)break;_S(l)}while(0);f[Tb>>2]=0;f[Ub>>2]=0;f[Ub+4>>2]=0;f[Ub+8>>2]=0;f[Ub+12>>2]=0;if((f[Vb>>2]|0)>0){ed=f[Wb>>2]|0;fd=0;do{f[ed+(fd<<2)>>2]=0;fd=fd+1|0}while((fd|0)<(f[Vb>>2]|0))}fd=f[Xb>>2]|0;if((fd|0)!=(Yb|0))g0(fd);cd=cd+1|0}while((cd|0)<(ja|0))}if(i){i=f[x+40>>2]|0;cd=f[i>>2]|0;f[L>>2]=f[i+4>>2];f[L+4>>2]=cd;QHb(e,L,f[X>>2]|0);if(!ka){qHb(k,ja);ka=f[d>>2]|0;L=f[e>>2]|0;cd=ka-L|0;i=(cd|0)/28|0;Yb=L;L=ka;do if((cd|0)>0){ka=0;Xb=Yb;while(1){Vb=Xb+(ka*28|0)|0;Wb=f[Xb+(ka*28|0)+20>>2]|0;if((Wb|0)<=-1){ld=354;break}Ub=f[k>>2]|0;Tb=Ub+(Wb*12|0)+4|0;bb=f[Tb>>2]|0;if((bb|0)==(f[Ub+(Wb*12|0)+8>>2]|0))V_(Ub+(Wb*12|0)|0,Vb);else{f[bb>>2]=f[Vb>>2];f[bb+4>>2]=f[Xb+(ka*28|0)+4>>2];Vb=bb+8|0;bb=Xb+(ka*28|0)+8|0;f[Vb>>2]=f[bb>>2];f[Vb+4>>2]=f[bb+4>>2];f[Vb+8>>2]=f[bb+8>>2];f[Vb+12>>2]=f[bb+12>>2];f[Vb+16>>2]=f[bb+16>>2];f[Tb>>2]=(f[Tb>>2]|0)+28}ka=ka+1|0;Xb=f[e>>2]|0;if((ka|0)>=(i|0)){ld=359;break}}if((ld|0)==354){f[l>>2]=0;f[l+4>>2]=0;S=tT(l,10)|0;T=459913;U=S+10|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));z5(-215,l,463413,459750,1125)}else if((ld|0)==359){ud=Xb;vd=f[d>>2]|0;break}}else{ud=Yb;vd=L}while(0);if((vd|0)!=(ud|0))f[d>>2]=vd+(~(((vd+-28-ud|0)>>>0)/28|0)*28|0);ud=f[k>>2]|0;if(ya){vd=e+8|0;L=ud;Yb=0;while(1){i=f[L+(Yb*12|0)>>2]|0;cd=f[L+(Yb*12|0)+4>>2]|0;if((i|0)==(cd|0))wd=L;else{ka=i;do{i=f[d>>2]|0;if((i|0)==(f[vd>>2]|0))V_(e,ka);else{f[i>>2]=f[ka>>2];f[i+4>>2]=f[ka+4>>2];Tb=i+8|0;i=ka+8|0;f[Tb>>2]=f[i>>2];f[Tb+4>>2]=f[i+4>>2];f[Tb+8>>2]=f[i+8>>2];f[Tb+12>>2]=f[i+12>>2];f[Tb+16>>2]=f[i+16>>2];f[d>>2]=(f[d>>2]|0)+28}ka=ka+28|0}while((ka|0)!=(cd|0));wd=f[k>>2]|0}Yb=Yb+1|0;if((Yb|0)>=(ja|0)){xd=wd;break}else L=wd}}else xd=ud;if(xd|0){ud=k+4|0;wd=f[ud>>2]|0;if((wd|0)==(xd|0))yd=xd;else{L=wd;while(1){wd=L+-12|0;f[ud>>2]=wd;Yb=f[wd>>2]|0;if(!Yb)zd=wd;else{wd=L+-8|0;vd=f[wd>>2]|0;if((vd|0)!=(Yb|0))f[wd>>2]=vd+(~(((vd+-28-Yb|0)>>>0)/28|0)*28|0);YDc(Yb);zd=f[ud>>2]|0}if((zd|0)==(xd|0))break;else L=zd}yd=f[k>>2]|0}YDc(yd)}}}else{yd=f[a+4>>2]|0;W=+p[wa>>3];wa=f[X>>2]|0;X=f[R>>2]|0;zd=f[a+32>>2]|0;L=f[a+40>>2]|0;xd=(f[c>>2]|0)-(f[z>>2]|0)|0;ud=xd>>4;f[l>>2]=0;Yb=l+4|0;f[Yb>>2]=0;f[l+8>>2]=0;vd=(ud|0)==0;do if(!vd)if(ud>>>0>1073741823)mCc(l);else{wd=xd>>2;cd=VDc(wd)|0;f[l>>2]=cd;ka=cd+(ud<<2)|0;f[l+8>>2]=ka;XIc(cd|0,0,wd|0)|0;f[Yb>>2]=ka;Ad=cd;break}else Ad=0;while(0);Ia=1.0/W;cd=ud+-1|0;if((xd|0)>16){ka=0;W=+(yd|0)*(1.0-Ia)/(1.0-+N(+Ia,+(+(ud|0))));wd=0;while(1){Xb=mrc(W)|0;f[Ad+(ka<<2)>>2]=Xb;i=Xb+wd|0;ka=ka+1|0;if((ka|0)>=(cd|0)){Bd=i;break}else{W=Ia*W;wd=i}}}else Bd=0;wd=yd-Bd|0;f[Ad+(cd<<2)>>2]=(wd|0)>0?wd:0;wd=(X|0)/2|0;cd=wd+2|0;f[m>>2]=0;Bd=m+4|0;f[Bd>>2]=0;f[m+8>>2]=0;do if(cd)if(cd>>>0>1073741823)mCc(m);else{yd=cd<<2;ka=VDc(yd)|0;f[m>>2]=ka;i=ka+(cd<<2)|0;f[m+8>>2]=i;XIc(ka|0,0,yd|0)|0;f[Bd>>2]=i;Cd=ka;break}else Cd=0;while(0);W=+(wd|0)*1.4142135381698608*.5;Ia=W+1.0;cd=~~Ia;ka=+(cd|0)>Ia;i=~~W;yd=(+(i|0)<W&1)+i|0;if((cd|0)>=(ka&1|0)){W=+(wd|0);Ia=W*W;i=cd+1+(ka<<31>>31)|0;ka=0;do{cd=nrc(+M(+(Ia-+(Y(ka,ka)|0))))|0;f[Cd+(ka<<2)>>2]=cd;ka=ka+1|0}while((ka|0)!=(i|0))}if((wd|0)>=(yd|0)){i=0;ka=wd;while(1){cd=f[Cd+(i<<2)>>2]|0;Xb=i;while(1){Dd=Xb+1|0;if((cd|0)==(f[Cd+(Dd<<2)>>2]|0))Xb=Dd;else break}f[Cd+(ka<<2)>>2]=Xb;if((ka|0)>(yd|0)){i=Dd;ka=ka+-1|0}else break}}ka=f[e>>2]|0;Dd=f[d>>2]|0;if((Dd|0)!=(ka|0))f[d>>2]=Dd+(~(((Dd+-28-ka|0)>>>0)/28|0)*28|0);f[o>>2]=0;ka=o+4|0;f[ka>>2]=0;f[o+8>>2]=0;f[q>>2]=0;Dd=q+4|0;f[Dd>>2]=0;f[q+8>>2]=0;do if(!vd)if(ud>>>0>1073741823)mCc(q);else{i=xd>>2;yd=VDc(i)|0;f[q>>2]=yd;Cd=yd+(ud<<2)|0;f[q+8>>2]=Cd;XIc(yd|0,0,i|0)|0;f[Dd>>2]=Cd;break}while(0);pHb(o,f[Ad>>2]<<1);Ad=(xd|0)>0;if(Ad){xd=D+16|0;vd=r+4|0;Cd=r+8|0;i=r+40|0;yd=r+48|0;cd=r+44|0;Tb=r+52|0;bb=s+4|0;Vb=t+8|0;Wb=t+12|0;Ub=t+4|0;cb=v+8|0;_a=v+12|0;ab=v+4|0;Sb=k+40|0;Rb=w+4|0;Qb=(zd|0)==0&1;Cb=r+36|0;zb=r+16|0;Pb=k+36|0;Db=k+16|0;yb=k+4|0;kb=k+44|0;lb=k+48|0;hb=e+8|0;Ia=+(X|0);jb=D+12|0;Kb=0;do{Ib=f[(f[l>>2]|0)+(Kb<<2)>>2]|0;cT(k,C,(f[z>>2]|0)+(Kb<<4)|0);do if(!(f[xd>>2]|0))ld=231;else{td=f[da>>2]|0;if((td|0)<3)Ed=Y(f[jb>>2]|0,f[ca>>2]|0)|0;else{Ob=f[_>>2]|0;Ma=0;Nb=1;while(1){Pa=Y(f[Ob+(Ma<<2)>>2]|0,Nb)|0;Ma=Ma+1|0;if((Ma|0)==(td|0)){Ed=Pa;break}else Nb=Pa}}if((td|0)==0|(Ed|0)==0){ld=231;break}cT(r,D,(f[z>>2]|0)+(Kb<<4)|0)}while(0);if((ld|0)==231){ld=0;f[r>>2]=1124007936;S=vd;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[i>>2]=Cd;f[cd>>2]=yd;f[yd>>2]=0;f[Tb>>2]=0}mIb(s,L,1,2);Xb=f[bb>>2]|0;Nb=f[(f[Xb>>2]|0)+32>>2]|0;f[Vb>>2]=0;f[Wb>>2]=0;f[t>>2]=16842752;f[Ub>>2]=k;f[cb>>2]=0;f[_a>>2]=0;f[v>>2]=16842752;f[ab>>2]=r;ei[Nb&511](Xb,t,o,v);Xb=f[s>>2]|0;do if(Xb|0){Nb=Xb+4|0;Ma=f[Nb>>2]|0;f[Nb>>2]=Ma+-1;if((Ma|0)!=1)break;Yi[f[(f[Xb>>2]|0)+8>>2]&2047](Xb)}while(0);Xb=f[Sb>>2]|0;Ma=f[Xb>>2]|0;f[w>>2]=f[Xb+4>>2];f[Rb>>2]=Ma;QHb(o,w,wa);NHb(o,Ib<<Qb);Ma=f[ka>>2]|0;Xb=f[o>>2]|0;Nb=Ma-Xb|0;Ob=(Nb|0)/28|0;f[(f[q>>2]|0)+(Kb<<2)>>2]=Ob;gd=Xb;Xb=Ma;if((Nb|0)>0){W=Ia*+n[(f[B>>2]|0)+(Kb<<2)>>2];Nb=0;do{f[gd+(Nb*28|0)+20>>2]=Kb;n[gd+(Nb*28|0)+8>>2]=W;Nb=Nb+1|0}while((Nb|0)<(Ob|0))}if((gd|0)!=(Xb|0)){Ob=gd;do{Nb=f[d>>2]|0;if((Nb|0)==(f[hb>>2]|0))V_(e,Ob);else{f[Nb>>2]=f[Ob>>2];f[Nb+4>>2]=f[Ob+4>>2];Ib=Nb+8|0;Nb=Ob+8|0;f[Ib>>2]=f[Nb>>2];f[Ib+4>>2]=f[Nb+4>>2];f[Ib+8>>2]=f[Nb+8>>2];f[Ib+12>>2]=f[Nb+12>>2];f[Ib+16>>2]=f[Nb+16>>2];f[d>>2]=(f[d>>2]|0)+28}Ob=Ob+28|0}while((Ob|0)!=(Xb|0))}Xb=f[Cb>>2]|0;do if(Xb|0){Ob=Xb+12|0;gd=f[Ob>>2]|0;f[Ob>>2]=gd+-1;if((gd|0)!=1)break;_S(r)}while(0);f[Cb>>2]=0;f[zb>>2]=0;f[zb+4>>2]=0;f[zb+8>>2]=0;f[zb+12>>2]=0;if((f[vd>>2]|0)>0){Xb=f[i>>2]|0;gd=0;do{f[Xb+(gd<<2)>>2]=0;gd=gd+1|0}while((gd|0)<(f[vd>>2]|0))}gd=f[cd>>2]|0;if((gd|0)!=(yd|0))g0(gd);gd=f[Pb>>2]|0;do if(gd|0){Xb=gd+12|0;Ob=f[Xb>>2]|0;f[Xb>>2]=Ob+-1;if((Ob|0)!=1)break;_S(k)}while(0);f[Pb>>2]=0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;if((f[yb>>2]|0)>0){gd=f[Sb>>2]|0;Ob=0;do{f[gd+(Ob<<2)>>2]=0;Ob=Ob+1|0}while((Ob|0)<(f[yb>>2]|0))}Ob=f[kb>>2]|0;if((Ob|0)!=(lb|0))g0(Ob);Kb=Kb+1|0}while((Kb|0)<(ud|0))}Kb=(f[d>>2]|0)-(f[e>>2]|0)|0;if(Kb|0){lb=(Kb|0)/28|0;f[r>>2]=1124007936;Kb=r+4|0;kb=r+8|0;yb=r+40|0;S=Kb;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[yb>>2]=kb;kb=r+48|0;Sb=r+44|0;f[Sb>>2]=kb;f[kb>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;Db=s+4|0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;f[Db+16>>2]=0;f[Db+20>>2]=0;f[Db+24>>2]=0;f[s+32>>2]=s+8;Db=s+40|0;f[s+36>>2]=Db;f[s+44>>2]=0;f[Db>>2]=0;f[t>>2]=1124007936;Db=t+4|0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;f[Db+16>>2]=0;f[Db+20>>2]=0;f[Db+24>>2]=0;f[t+32>>2]=t+8;Db=t+40|0;f[t+36>>2]=Db;f[t+44>>2]=0;f[Db>>2]=0;f[k>>2]=1;f[k+4>>2]=lb;DQ(t,2,k,5,0);if(!zd){zd=f[z>>2]|0;lb=f[C>>2]|0;if(lb&4095|0){f[k>>2]=0;f[k+4>>2]=0;S=tT(k,52)|0;T=459844;U=S+52|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));z5(-215,k,459897,459750,134)}Db=(f[d>>2]|0)-(f[e>>2]|0)|0;Pb=f[C+16>>2]|0;yd=((f[ia>>2]|0)>>>0)/((1212424721>>>(lb<<2&28)&15)>>>0)|0;lb=k+8|0;f[k>>2]=lb;cd=k+4|0;f[cd>>2]=49;f[lb>>2]=0;f[k+12>>2]=1;f[k+16>>2]=2;f[k+20>>2]=3;f[k+24>>2]=4;f[k+28>>2]=5;f[k+32>>2]=6;f[k+36>>2]=yd;vd=yd+1|0;f[k+40>>2]=vd;f[k+44>>2]=yd+2;f[k+48>>2]=yd+3;f[k+52>>2]=yd+4;f[k+56>>2]=yd+5;f[k+60>>2]=yd+6;i=yd<<1;f[k+64>>2]=i;f[k+68>>2]=i|1;f[k+72>>2]=i+2;f[k+76>>2]=i+3;f[k+80>>2]=i+4;f[k+84>>2]=i+5;f[k+88>>2]=i+6;i=yd*3|0;f[k+92>>2]=i;f[k+96>>2]=i+1;f[k+100>>2]=i+2;f[k+104>>2]=i+3;f[k+108>>2]=i+4;f[k+112>>2]=i+5;f[k+116>>2]=i+6;i=yd<<2;f[k+120>>2]=i;f[k+124>>2]=i|1;f[k+128>>2]=i|2;f[k+132>>2]=i|3;f[k+136>>2]=i+4;f[k+140>>2]=i+5;f[k+144>>2]=i+6;i=yd*5|0;f[k+148>>2]=i;f[k+152>>2]=i+1;f[k+156>>2]=i+2;f[k+160>>2]=i+3;f[k+164>>2]=i+4;f[k+168>>2]=i+5;f[k+172>>2]=i+6;i=yd*6|0;f[k+176>>2]=i;f[k+180>>2]=i|1;f[k+184>>2]=i+2;f[k+188>>2]=i+3;f[k+192>>2]=i+4;f[k+196>>2]=i+5;f[k+200>>2]=i+6;i=(Db|0)/28|0;if(Db|0){Db=0-yd|0;zb=1-yd|0;Cb=~yd;hb=yd+-1|0;Qb=f[e>>2]|0;wa=0;do{w=mrc(+n[Qb+(wa*28|0)>>2])|0;Rb=mrc(+n[Qb+(wa*28|0)+4>>2])|0;v=f[Qb+(wa*28|0)+20>>2]|0;ab=Pb+(Y(Rb+-3+(f[zd+(v<<4)+4>>2]|0)|0,yd)|0)+w+-3|0;w=ab+(f[zd+(v<<4)>>2]|0)|0;v=0;ab=0;Rb=0;_a=0;do{cb=w+(f[k+8+(v<<2)>>2]|0)|0;Ub=h[cb+zb>>0]|0;Wb=h[cb+Cb>>0]|0;Vb=h[cb+vd>>0]|0;bb=h[cb+hb>>0]|0;L=Ub-Wb+((h[cb+1>>0]|0)-(h[cb+-1>>0]|0)<<1)+(Vb-bb)|0;Tb=Vb-(Wb+Ub)+bb+((h[cb+yd>>0]|0)-(h[cb+Db>>0]|0)<<1)|0;_a=(Y(L,L)|0)+_a|0;Rb=(Y(Tb,Tb)|0)+Rb|0;ab=(Y(Tb,L)|0)+ab|0;v=v+1|0}while((v|0)!=49);Ia=+(_a|0);W=+(Rb|0);Fd=+(ab|0);Gd=Ia+W;n[Qb+(wa*28|0)+16>>2]=(Ia*W-Fd*Fd-Gd*(Gd*.03999999910593033))*3.847753306718862e-16;wa=wa+1|0}while(wa>>>0<i>>>0)}i=f[k>>2]|0;if((i|0)!=(lb|0)){if(i|0)ZDc(i);f[k>>2]=lb;f[cd>>2]=264}f[k>>2]=0;cd=k+4|0;f[cd>>2]=0;f[k+8>>2]=0;pHb(k,Y(f[f[l>>2]>>2]|0,ud)|0);if(Ad){Ad=k+8|0;lb=0;i=0;do{wa=f[(f[l>>2]|0)+(i<<2)>>2]|0;Qb=f[(f[q>>2]|0)+(i<<2)>>2]|0;Db=f[ka>>2]|0;yd=f[o>>2]|0;hb=(Db-yd|0)/28|0;vd=yd;yd=Db;if(Qb>>>0<=hb>>>0){do if(Qb>>>0<hb>>>0){Db=vd+(Qb*28|0)|0;if((yd|0)==(Db|0))break;f[ka>>2]=yd+(~(((yd+-28-Db|0)>>>0)/28|0)*28|0)}while(0);if(Qb|0){Hd=vd;ld=283}}else{IO(o,Qb-hb|0);Hd=f[o>>2]|0;ld=283}if((ld|0)==283){ld=0;yd=(f[e>>2]|0)+(lb*28|0)|0;ab=yd+(Qb*28|0)|0;Rb=yd;yd=Hd;while(1){f[yd>>2]=f[Rb>>2];f[yd+4>>2]=f[Rb+4>>2];_a=yd+8|0;Db=Rb+8|0;f[_a>>2]=f[Db>>2];f[_a+4>>2]=f[Db+4>>2];f[_a+8>>2]=f[Db+8>>2];f[_a+12>>2]=f[Db+12>>2];f[_a+16>>2]=f[Db+16>>2];Rb=Rb+28|0;if((Rb|0)==(ab|0))break;else yd=yd+28|0}}lb=Qb+lb|0;NHb(o,wa);yd=f[o>>2]|0;ab=f[ka>>2]|0;if((yd|0)!=(ab|0)){Rb=yd;do{yd=f[cd>>2]|0;if((yd|0)==(f[Ad>>2]|0))V_(k,Rb);else{f[yd>>2]=f[Rb>>2];f[yd+4>>2]=f[Rb+4>>2];hb=yd+8|0;vd=Rb+8|0;f[hb>>2]=f[vd>>2];f[hb+4>>2]=f[vd+4>>2];f[hb+8>>2]=f[vd+8>>2];f[hb+12>>2]=f[vd+12>>2];f[hb+16>>2]=f[vd+16>>2];f[cd>>2]=yd+28}Rb=Rb+28|0}while((Rb|0)!=(ab|0))}i=i+1|0}while((i|0)<(ud|0));Id=Ad}else Id=k+8|0;Ad=f[e>>2]|0;f[e>>2]=f[k>>2];f[k>>2]=Ad;ud=f[d>>2]|0;f[d>>2]=f[cd>>2];f[cd>>2]=ud;i=e+8|0;lb=f[i>>2]|0;f[i>>2]=f[Id>>2];f[Id>>2]=lb;lb=Ad;Id=ud;if(Ad|0){if((Id|0)!=(Ad|0))f[cd>>2]=Id+(~(((Id+-28-Ad|0)>>>0)/28|0)*28|0);YDc(lb)}}lb=f[e>>2]|0;Ad=(f[d>>2]|0)-lb|0;Id=(Ad|0)/28|0;cd=f[f[$>>2]>>2]|0;ud=(cd>>>0)/((1212424721>>>(f[C>>2]<<2&28)&15)>>>0)|0;i=lb;do if(Ad|0){lb=C+16|0;Hd=0-wd|0;ld=(X|0)<2;c:do if((wd|0)<(Hd|0)){if(ld){ab=0;while(1){Gd=+_6(0.0,0.0);Rb=f[e>>2]|0;n[Rb+(ab*28|0)+12>>2]=Gd;ab=ab+1|0;if(ab>>>0>=Id>>>0){Jd=Rb;break c}}}else{Kd=0;Ld=i;Md=cd}while(1){ab=f[Ld+(Kd*28|0)+20>>2]|0;td=f[z>>2]|0;Rb=mrc(+n[Ld+(Kd*28|0)+4>>2])|0;wa=(f[td+(ab<<4)+4>>2]|0)+Rb|0;Rb=mrc(+n[Ld+(Kd*28|0)>>2])|0;Qb=(f[lb>>2]|0)+(Y(wa,Md)|0)+((f[td+(ab<<4)>>2]|0)+Rb)|0;Rb=f[m>>2]|0;ab=0;td=1;wa=0;while(1){yd=f[Rb+(td<<2)>>2]|0;vd=0-yd|0;if((yd|0)<(vd|0)){Nd=0;Od=wa}else{hb=Y(td,ud)|0;Db=vd;vd=0;_a=wa;while(1){Cb=h[Qb+(Db+hb)>>0]|0;zb=h[Qb+(Db-hb)>>0]|0;zd=Cb+vd-zb|0;Pb=(Y(zb+Cb|0,Db)|0)+_a|0;if((Db|0)<(yd|0)){Db=Db+1|0;vd=zd;_a=Pb}else{Nd=zd;Od=Pb;break}}}ab=(Y(Nd,td)|0)+ab|0;if((td|0)==(wd|0))break;else{td=td+1|0;wa=Od}}Gd=+_6(+(ab|0),+(Od|0));wa=f[e>>2]|0;n[wa+(Kd*28|0)+12>>2]=Gd;td=Kd+1|0;if(td>>>0>=Id>>>0){Jd=wa;break c}Kd=td;Ld=wa;Md=f[f[$>>2]>>2]|0}}else{if(ld){wa=0;td=i;Qb=cd;while(1){Rb=f[td+(wa*28|0)+20>>2]|0;id=f[z>>2]|0;_a=mrc(+n[td+(wa*28|0)+4>>2])|0;vd=(f[id+(Rb<<4)+4>>2]|0)+_a|0;_a=mrc(+n[td+(wa*28|0)>>2])|0;Db=(f[lb>>2]|0)+(Y(vd,Qb)|0)+((f[id+(Rb<<4)>>2]|0)+_a)|0;_a=0;Rb=Hd;while(1){_a=(Y(h[Db+Rb>>0]|0,Rb)|0)+_a|0;if((Rb|0)>=(wd|0))break;else Rb=Rb+1|0}Gd=+_6(0.0,+(_a|0));Rb=f[e>>2]|0;n[Rb+(wa*28|0)+12>>2]=Gd;Db=wa+1|0;if(Db>>>0>=Id>>>0){Jd=Rb;break c}wa=Db;td=Rb;Qb=f[f[$>>2]>>2]|0}}else{Pd=0;Qd=i;Rd=cd}while(1){Qb=f[Qd+(Pd*28|0)+20>>2]|0;td=f[z>>2]|0;wa=mrc(+n[Qd+(Pd*28|0)+4>>2])|0;Rb=(f[td+(Qb<<4)+4>>2]|0)+wa|0;wa=mrc(+n[Qd+(Pd*28|0)>>2])|0;Db=(f[lb>>2]|0)+(Y(Rb,Rd)|0)+((f[td+(Qb<<4)>>2]|0)+wa)|0;wa=0;Qb=Hd;while(1){wa=(Y(h[Db+Qb>>0]|0,Qb)|0)+wa|0;if((Qb|0)>=(wd|0))break;else Qb=Qb+1|0}Qb=f[m>>2]|0;_a=0;td=1;Rb=wa;while(1){ab=f[Qb+(td<<2)>>2]|0;id=0-ab|0;if((ab|0)<(id|0)){Sd=0;Td=Rb}else{vd=Y(td,ud)|0;yd=id;id=0;hb=Rb;while(1){Pb=h[Db+(yd+vd)>>0]|0;zd=h[Db+(yd-vd)>>0]|0;Cb=Pb+id-zd|0;zb=(Y(zd+Pb|0,yd)|0)+hb|0;if((yd|0)<(ab|0)){yd=yd+1|0;id=Cb;hb=zb}else{Sd=Cb;Td=zb;break}}}_a=(Y(Sd,td)|0)+_a|0;if((td|0)==(wd|0))break;else{td=td+1|0;Rb=Td}}Gd=+_6(+(_a|0),+(Td|0));Rb=f[e>>2]|0;n[Rb+(Pd*28|0)+12>>2]=Gd;td=Pd+1|0;if(td>>>0>=Id>>>0){Jd=Rb;break c}Pd=td;Qd=Rb;Rd=f[f[$>>2]>>2]|0}}while(0);if((Ad|0)<=0)break;Hd=f[B>>2]|0;lb=0;do{Gd=+n[Hd+(f[Jd+(lb*28|0)+20>>2]<<2)>>2];ld=Jd+(lb*28|0)|0;n[ld>>2]=Gd*+n[ld>>2];ld=Jd+(lb*28|0)+4|0;n[ld>>2]=Gd*+n[ld>>2];lb=lb+1|0}while((lb|0)<(Id|0))}while(0);GQ(t);GQ(s);s=r+36|0;t=f[s>>2]|0;do if(t|0){Id=t+12|0;Jd=f[Id>>2]|0;f[Id>>2]=Jd+-1;if((Jd|0)!=1)break;_S(r)}while(0);f[s>>2]=0;s=r+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[Kb>>2]|0)>0){s=f[yb>>2]|0;yb=0;do{f[s+(yb<<2)>>2]=0;yb=yb+1|0}while((yb|0)<(f[Kb>>2]|0))}Kb=f[Sb>>2]|0;if((Kb|0)!=(kb|0))g0(Kb)}Kb=f[q>>2]|0;if(Kb|0){kb=f[Dd>>2]|0;if((kb|0)!=(Kb|0))f[Dd>>2]=kb+(~((kb+-4-Kb|0)>>>2)<<2);YDc(Kb)}Kb=f[o>>2]|0;if(Kb|0){kb=f[ka>>2]|0;if((kb|0)!=(Kb|0))f[ka>>2]=kb+(~(((kb+-28-Kb|0)>>>0)/28|0)*28|0);YDc(Kb)}Kb=f[m>>2]|0;if(Kb|0){kb=f[Bd>>2]|0;if((kb|0)!=(Kb|0))f[Bd>>2]=kb+(~((kb+-4-Kb|0)>>>2)<<2);YDc(Kb)}Kb=f[l>>2]|0;if(Kb|0){kb=f[Yb>>2]|0;if((kb|0)!=(Kb|0))f[Yb>>2]=kb+(~((kb+-4-Kb|0)>>>2)<<2);YDc(Kb)}}do if(V){Kb=_i[f[(f[a>>2]|0)+52>>2]&1023](a)|0;kb=(f[d>>2]|0)-(f[e>>2]|0)|0;if(!kb){u$(g);break}Y$(g,(kb|0)/28|0,Kb,0,-1,0,0);f[l>>2]=0;kb=l+4|0;f[kb>>2]=0;f[l+8>>2]=0;XIc(m|0,0,4096)|0;Yb=f[R>>2]|0;if((Yb|0)!=31){Bd=(Yb|0)/-2|0;ka=((Yb|0)/2|0)+1|0;Yb=ka-Bd|0;if((ka|0)==(Bd|0)){ka=0;do{f[m+(ka<<3)>>2]=Bd;f[m+(ka<<3)+4>>2]=Bd;ka=ka+1|0}while((ka|0)!=512);Ud=m}else{ka=0;Dd=882399033;Sb=0;while(1){yb=mJc(Dd|0,0,-130063606,0)|0;s=UIc(yb|0,J|0,Sb|0,0)|0;yb=J;f[m+(ka<<3)>>2]=((s>>>0)%(Yb>>>0)|0)+Bd;r=mJc(s|0,0,-130063606,0)|0;Dd=UIc(r|0,J|0,yb|0,0)|0;f[m+(ka<<3)+4>>2]=((Dd>>>0)%(Yb>>>0)|0)+Bd;ka=ka+1|0;if((ka|0)==512){Ud=m;break}else Sb=J}}}else Ud=107708;Sb=a+28|0;d:do switch(f[Sb>>2]|0){case 2:{ka=l+8|0;Bd=0;Yb=0;Dd=0;while(1){yb=Ud+(Bd<<3)|0;if((Yb|0)==(Dd|0))fga(l,yb);else{f[Yb>>2]=f[yb>>2];f[Yb+4>>2]=f[Ud+(Bd<<3)+4>>2];f[kb>>2]=Yb+8}yb=Bd+1|0;if((yb|0)==512)break d;Bd=yb;Yb=f[kb>>2]|0;Dd=f[ka>>2]|0}break}case 4:case 3:{ka=_i[f[(f[a>>2]|0)+52>>2]&1023](a)|0;Dd=ka<<2;Yb=f[Sb>>2]|0;Bd=Y(Yb,Dd)|0;yb=f[kb>>2]|0;r=f[l>>2]|0;s=yb-r>>3;t=r;r=yb;do if(Bd>>>0>s>>>0)Jua(l,Bd-s|0);else{if(Bd>>>0>=s>>>0)break;yb=t+(Bd<<3)|0;if((r|0)==(yb|0))break;f[kb>>2]=r+(~((r+-8-yb|0)>>>3)<<3)}while(0);if((ka|0)>0&(Yb|0)>0){Vd=0;Wd=305419896;Xd=0}else break d;e:while(1){r=Y(Vd,Yb)|0;Bd=0;t=Wd;s=Xd;while(1){yb=f[l>>2]|0;if((Bd|0)>0){Jd=t;Id=s;while(1){Ad=mJc(Jd|0,0,-130063606,0)|0;Rd=UIc(Ad|0,J|0,Id|0,0)|0;Ad=J;Qd=Rd&511;Pd=f[Ud+(Qd<<3)>>2]|0;Td=f[Ud+(Qd<<3)+4>>2]|0;Qd=0;while(1){wd=Qd+r|0;if((f[yb+(wd<<3)>>2]|0)==(Pd|0)?(f[yb+(wd<<3)+4>>2]|0)==(Td|0):0){Yd=Qd;break}wd=Qd+1|0;if((wd|0)<(Bd|0))Qd=wd;else{Yd=wd;break}}if((Yd|0)==(Bd|0)){Zd=Td;_d=Pd;$d=Rd;ae=Ad;break}else{Jd=Rd;Id=Ad}}}else{if(Bd|0)break e;Id=mJc(t|0,0,-130063606,0)|0;Jd=UIc(Id|0,J|0,s|0,0)|0;Id=Jd&511;Zd=f[Ud+(Id<<3)+4>>2]|0;_d=f[Ud+(Id<<3)>>2]|0;$d=Jd;ae=J}Jd=Bd+r|0;f[yb+(Jd<<3)>>2]=_d;f[yb+(Jd<<3)+4>>2]=Zd;Bd=Bd+1|0;if((Bd|0)==(Yb|0))break;else{t=$d;s=ae}}Vd=Vd+1|0;if((Vd|0)==(Dd|0))break d;else{Wd=$d;Xd=ae}}while(1){}break}default:{f[k>>2]=0;f[k+4>>2]=0;S=tT(k,38)|0;T=459924;U=S+38|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));z5(-215,k,463413,459750,1158)}}while(0);if(ya){Dd=o+8|0;Yb=o+12|0;ka=o+4|0;s=q+8|0;t=q+4|0;Bd=Q+4|0;r=k+36|0;_a=k+16|0;Jd=k+4|0;Id=k+40|0;Qd=k+44|0;wd=k+48|0;Sd=0;do{cT(k,C,(f[z>>2]|0)+(Sd<<4)|0);f[Dd>>2]=0;f[Yb>>2]=0;f[o>>2]=16842752;f[ka>>2]=k;ud=s;f[ud>>2]=0;f[ud+4>>2]=0;f[q>>2]=33619968;f[t>>2]=k;f[Q>>2]=7;f[Bd>>2]=7;Gfa(o,q,Q,2.0,2.0,4);ud=f[r>>2]|0;do if(ud|0){cd=ud+12|0;i=f[cd>>2]|0;f[cd>>2]=i+-1;if((i|0)!=1)break;_S(k)}while(0);f[r>>2]=0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[Jd>>2]|0)>0){ud=f[Id>>2]|0;i=0;do{f[ud+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[Jd>>2]|0))}i=f[Qd>>2]|0;if((i|0)!=(wd|0))g0(i);Sd=Sd+1|0}while((Sd|0)<(ja|0))}do if((d$(g)|0)==65536){Sd=f[g+4>>2]|0;f[o>>2]=f[Sd>>2];wd=o+4|0;Qd=Sd+4|0;f[wd>>2]=f[Qd>>2];Jd=o+8|0;f[Jd>>2]=f[Sd+8>>2];f[o+12>>2]=f[Sd+12>>2];f[o+16>>2]=f[Sd+16>>2];f[o+20>>2]=f[Sd+20>>2];f[o+24>>2]=f[Sd+24>>2];f[o+28>>2]=f[Sd+28>>2];f[o+32>>2]=f[Sd+32>>2];Id=f[Sd+36>>2]|0;f[o+36>>2]=Id;f[o+40>>2]=Jd;Jd=o+48|0;_a=o+44|0;f[_a>>2]=Jd;f[Jd>>2]=0;f[o+52>>2]=0;if(Id|0){Jd=Id+12|0;f[Jd>>2]=(f[Jd>>2]|0)+1}if((f[Qd>>2]|0)<3){Qd=f[Sd+44>>2]|0;Jd=f[_a>>2]|0;f[Jd>>2]=f[Qd>>2];f[Jd+4>>2]=f[Qd+4>>2];break}else{f[wd>>2]=0;ZS(o,Sd);break}}else a$(o,g,-1);while(0);Sd=f[Sb>>2]|0;wd=f[ia>>2]|0;Qd=f[e>>2]|0;Jd=(f[d>>2]|0)-Qd|0;_a=(Jd|0)/28|0;f:do if((Jd|0)>0){Id=C+16|0;r=o+16|0;Bd=o+44|0;t=(Kb|0)>0;s=f[B>>2]|0;ka=0;Yb=Qd;g:while(1){Dd=f[Yb+(ka*28|0)+20>>2]|0;i=f[z>>2]|0;Gd=1.0/+n[s+(Dd<<2)>>2];Fd=+n[Yb+(ka*28|0)+12>>2]*.01745329238474369;W=+O(+Fd);Ia=+P(+Fd);ud=mrc(Gd*+n[Yb+(ka*28|0)+4>>2])|0;cd=(f[i+(Dd<<4)+4>>2]|0)+ud|0;ud=mrc(Gd*+n[Yb+(ka*28|0)>>2])|0;Md=(f[Id>>2]|0)+(Y(f[f[$>>2]>>2]|0,cd)|0)+((f[i+(Dd<<4)>>2]|0)+ud)|0;ud=f[l>>2]|0;Dd=(f[r>>2]|0)+(Y(f[f[Bd>>2]>>2]|0,ka)|0)|0;h:do switch(Sd|0){case 2:{if(t){be=0;ce=ud}else break h;while(1){Gd=+(f[ce>>2]|0);Fd=+(f[ce+4>>2]|0);i=mrc(W*Gd-Ia*Fd)|0;cd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+i|0;i=b[cd>>0]|0;Fd=+(f[ce+8>>2]|0);Gd=+(f[ce+12>>2]|0);cd=mrc(W*Fd-Ia*Gd)|0;Ld=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+cd|0;cd=(i&255)<(h[Ld>>0]|0)&1;Gd=+(f[ce+16>>2]|0);Fd=+(f[ce+20>>2]|0);Ld=mrc(W*Gd-Ia*Fd)|0;i=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Ld|0;Ld=b[i>>0]|0;Fd=+(f[ce+24>>2]|0);Gd=+(f[ce+28>>2]|0);i=mrc(W*Fd-Ia*Gd)|0;Kd=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+i|0;i=((Ld&255)<(h[Kd>>0]|0)&1)<<1|cd;Gd=+(f[ce+32>>2]|0);Fd=+(f[ce+36>>2]|0);cd=mrc(W*Gd-Ia*Fd)|0;Kd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+cd|0;cd=b[Kd>>0]|0;Fd=+(f[ce+40>>2]|0);Gd=+(f[ce+44>>2]|0);Kd=mrc(W*Fd-Ia*Gd)|0;Ld=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Kd|0;Kd=i|((cd&255)<(h[Ld>>0]|0)&1)<<2;Gd=+(f[ce+48>>2]|0);Fd=+(f[ce+52>>2]|0);Ld=mrc(W*Gd-Ia*Fd)|0;cd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Ld|0;Ld=b[cd>>0]|0;Fd=+(f[ce+56>>2]|0);Gd=+(f[ce+60>>2]|0);cd=mrc(W*Fd-Ia*Gd)|0;i=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+cd|0;cd=Kd|((Ld&255)<(h[i>>0]|0)&1)<<3;Gd=+(f[ce+64>>2]|0);Fd=+(f[ce+68>>2]|0);i=mrc(W*Gd-Ia*Fd)|0;Ld=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+i|0;i=b[Ld>>0]|0;Fd=+(f[ce+72>>2]|0);Gd=+(f[ce+76>>2]|0);Ld=mrc(W*Fd-Ia*Gd)|0;Kd=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Ld|0;Ld=cd|((i&255)<(h[Kd>>0]|0)&1)<<4;Gd=+(f[ce+80>>2]|0);Fd=+(f[ce+84>>2]|0);Kd=mrc(W*Gd-Ia*Fd)|0;i=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Kd|0;Kd=b[i>>0]|0;Fd=+(f[ce+88>>2]|0);Gd=+(f[ce+92>>2]|0);i=mrc(W*Fd-Ia*Gd)|0;cd=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+i|0;i=Ld|((Kd&255)<(h[cd>>0]|0)&1)<<5;Gd=+(f[ce+96>>2]|0);Fd=+(f[ce+100>>2]|0);cd=mrc(W*Gd-Ia*Fd)|0;Kd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+cd|0;cd=b[Kd>>0]|0;Fd=+(f[ce+104>>2]|0);Gd=+(f[ce+108>>2]|0);Kd=mrc(W*Fd-Ia*Gd)|0;Ld=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Kd|0;Kd=i|((cd&255)<(h[Ld>>0]|0)&1)<<6;Gd=+(f[ce+112>>2]|0);Fd=+(f[ce+116>>2]|0);Ld=mrc(W*Gd-Ia*Fd)|0;cd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Ld|0;Ld=b[cd>>0]|0;Fd=+(f[ce+120>>2]|0);Gd=+(f[ce+124>>2]|0);cd=mrc(W*Fd-Ia*Gd)|0;i=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+cd|0;b[Dd+be>>0]=Kd|((Ld&255)<(h[i>>0]|0)&1)<<7;be=be+1|0;if((be|0)==(Kb|0))break;else ce=ce+128|0}break}case 3:{if(t){de=ud;ee=0}else break h;while(1){Gd=+(f[de>>2]|0);Fd=+(f[de+4>>2]|0);yb=mrc(W*Gd-Ia*Fd)|0;i=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+yb|0;yb=b[i>>0]|0;Fd=+(f[de+8>>2]|0);Gd=+(f[de+12>>2]|0);i=mrc(W*Fd-Ia*Gd)|0;Ld=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+i|0;i=b[Ld>>0]|0;Gd=+(f[de+16>>2]|0);Fd=+(f[de+20>>2]|0);Ld=mrc(W*Gd-Ia*Fd)|0;Kd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Ld|0;Ld=b[Kd>>0]|0;Fd=+(f[de+24>>2]|0);Gd=+(f[de+28>>2]|0);Kd=mrc(W*Fd-Ia*Gd)|0;cd=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Kd|0;Kd=b[cd>>0]|0;Gd=+(f[de+32>>2]|0);Fd=+(f[de+36>>2]|0);cd=mrc(W*Gd-Ia*Fd)|0;Od=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+cd|0;cd=b[Od>>0]|0;Fd=+(f[de+40>>2]|0);Gd=+(f[de+44>>2]|0);Od=mrc(W*Fd-Ia*Gd)|0;Nd=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Od|0;Od=b[Nd>>0]|0;Gd=+(f[de+48>>2]|0);Fd=+(f[de+52>>2]|0);Nd=mrc(W*Gd-Ia*Fd)|0;X=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Nd|0;Nd=b[X>>0]|0;Fd=+(f[de+56>>2]|0);Gd=+(f[de+60>>2]|0);X=mrc(W*Fd-Ia*Gd)|0;lb=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+X|0;X=b[lb>>0]|0;Gd=+(f[de+64>>2]|0);Fd=+(f[de+68>>2]|0);lb=mrc(W*Gd-Ia*Fd)|0;Hd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+lb|0;lb=b[Hd>>0]|0;Fd=+(f[de+72>>2]|0);Gd=+(f[de+76>>2]|0);Hd=mrc(W*Fd-Ia*Gd)|0;ld=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Hd|0;Hd=b[ld>>0]|0;Gd=+(f[de+80>>2]|0);Fd=+(f[de+84>>2]|0);ld=mrc(W*Gd-Ia*Fd)|0;Rb=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+ld|0;ld=b[Rb>>0]|0;Fd=+(f[de+88>>2]|0);Gd=+(f[de+92>>2]|0);Rb=mrc(W*Fd-Ia*Gd)|0;td=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Rb|0;Rb=b[td>>0]|0;b[Dd+ee>>0]=((Od&255)>(cd&255)?((Od&255)>(Kd&255)?2:0):(cd&255)>(Kd&255)&1)<<2|((Ld&255)>(i&255)?((Ld&255)>(yb&255)?2:0):(i&255)>(yb&255)&1)|((lb&255)>(X&255)?((lb&255)>(Nd&255)?2:0):(X&255)>(Nd&255)&1)<<4|((Rb&255)>(ld&255)?((Rb&255)>(Hd&255)?2:0):(ld&255)>(Hd&255)&1)<<6;ee=ee+1|0;if((ee|0)==(Kb|0))break;else de=de+96|0}break}case 4:{if(t){fe=ud;ge=0}else break h;while(1){Gd=+(f[fe>>2]|0);Fd=+(f[fe+4>>2]|0);Hd=mrc(W*Gd-Ia*Fd)|0;ld=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Hd|0;Hd=b[ld>>0]|0;Fd=+(f[fe+8>>2]|0);Gd=+(f[fe+12>>2]|0);ld=mrc(W*Fd-Ia*Gd)|0;Rb=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+ld|0;ld=b[Rb>>0]|0;Gd=+(f[fe+16>>2]|0);Fd=+(f[fe+20>>2]|0);Rb=mrc(W*Gd-Ia*Fd)|0;Nd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Rb|0;Rb=b[Nd>>0]|0;Fd=+(f[fe+24>>2]|0);Gd=+(f[fe+28>>2]|0);Nd=mrc(W*Fd-Ia*Gd)|0;X=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Nd|0;Nd=b[X>>0]|0;X=(ld&255)>(Hd&255);lb=(Nd&255)>(Rb&255);Gd=+(f[fe+32>>2]|0);Fd=+(f[fe+36>>2]|0);yb=mrc(W*Gd-Ia*Fd)|0;i=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+yb|0;yb=b[i>>0]|0;Fd=+(f[fe+40>>2]|0);Gd=+(f[fe+44>>2]|0);i=mrc(W*Fd-Ia*Gd)|0;Ld=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+i|0;i=b[Ld>>0]|0;Gd=+(f[fe+48>>2]|0);Fd=+(f[fe+52>>2]|0);Ld=mrc(W*Gd-Ia*Fd)|0;Kd=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Ld|0;Ld=b[Kd>>0]|0;Fd=+(f[fe+56>>2]|0);Gd=+(f[fe+60>>2]|0);Kd=mrc(W*Fd-Ia*Gd)|0;cd=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Kd|0;Kd=b[cd>>0]|0;cd=(i&255)>(yb&255);Od=(Kd&255)>(Ld&255);Gd=+(f[fe+64>>2]|0);Fd=+(f[fe+68>>2]|0);td=mrc(W*Gd-Ia*Fd)|0;Db=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+td|0;td=b[Db>>0]|0;Fd=+(f[fe+72>>2]|0);Gd=+(f[fe+76>>2]|0);Db=mrc(W*Fd-Ia*Gd)|0;Qb=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+Db|0;Db=b[Qb>>0]|0;Gd=+(f[fe+80>>2]|0);Fd=+(f[fe+84>>2]|0);Qb=mrc(W*Gd-Ia*Fd)|0;wa=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+Qb|0;Qb=b[wa>>0]|0;Fd=+(f[fe+88>>2]|0);Gd=+(f[fe+92>>2]|0);wa=mrc(W*Fd-Ia*Gd)|0;hb=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+wa|0;wa=b[hb>>0]|0;hb=(Db&255)>(td&255);id=(wa&255)>(Qb&255);Gd=+(f[fe+96>>2]|0);Fd=+(f[fe+100>>2]|0);yd=mrc(W*Gd-Ia*Fd)|0;ab=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+yd|0;yd=b[ab>>0]|0;Fd=+(f[fe+104>>2]|0);Gd=+(f[fe+108>>2]|0);ab=mrc(W*Fd-Ia*Gd)|0;vd=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+ab|0;ab=b[vd>>0]|0;Gd=+(f[fe+112>>2]|0);Fd=+(f[fe+116>>2]|0);vd=mrc(W*Gd-Ia*Fd)|0;zb=Md+(Y(mrc(Ia*Gd+W*Fd)|0,wd)|0)+vd|0;vd=b[zb>>0]|0;Fd=+(f[fe+120>>2]|0);Gd=+(f[fe+124>>2]|0);zb=mrc(W*Fd-Ia*Gd)|0;Cb=Md+(Y(mrc(Ia*Fd+W*Gd)|0,wd)|0)+zb|0;zb=b[Cb>>0]|0;Cb=(ab&255)>(yd&255);Pb=(zb&255)>(vd&255);b[Dd+ge>>0]=(((cd?i:yb)&255)>((Od?Kd:Ld)&255)?(cd?4:0):Od?12:8)|(((X?ld:Hd)&255)>((lb?Nd:Rb)&255)?X&1:lb?3:2)|(((hb?Db:td)&255)>((id?wa:Qb)&255)?(hb?16:0):id?48:32)|(((Cb?ab:yd)&255)>((Pb?zb:vd)&255)?(Cb?64:0):Pb?192:128);ge=ge+1|0;if((ge|0)==(Kb|0))break;else fe=fe+128|0}break}default:break g}while(0);Dd=ka+1|0;if((Dd|0)>=(_a|0))break f;ka=Dd;Yb=f[e>>2]|0}f[k>>2]=0;f[k+4>>2]=0;S=tT(k,38)|0;T=459963;U=S+38|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));z5(-201,k,460002,459750,342)}while(0);_a=o+36|0;Kb=f[_a>>2]|0;do if(Kb|0){wd=Kb+12|0;Sd=f[wd>>2]|0;f[wd>>2]=Sd+-1;if((Sd|0)!=1)break;_S(o)}while(0);f[_a>>2]=0;Kb=o+16|0;Sd=o+4|0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[Kb+8>>2]=0;f[Kb+12>>2]=0;if((f[Sd>>2]|0)>0){Kb=f[o+40>>2]|0;wd=0;do{f[Kb+(wd<<2)>>2]=0;wd=wd+1|0}while((wd|0)<(f[Sd>>2]|0))}Sd=f[o+44>>2]|0;if((Sd|0)!=(o+48|0))g0(Sd);Sd=f[l>>2]|0;if(Sd|0){wd=f[kb>>2]|0;if((wd|0)!=(Sd|0))f[kb>>2]=wd+(~((wd+-8-Sd|0)>>>3)<<3);YDc(Sd)}}while(0);l=f[Qa>>2]|0;do if(l|0){o=l+12|0;k=f[o>>2]|0;f[o>>2]=k+-1;if((k|0)!=1)break;_S(H)}while(0);f[Qa>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[Ua>>2]|0)>0){Oa=f[Wa>>2]|0;Wa=0;do{f[Oa+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[Ua>>2]|0))}Ua=f[Ya>>2]|0;if((Ua|0)!=(Xa|0))g0(Ua);Ua=f[Ha>>2]|0;do if(Ua|0){Xa=Ua+12|0;Ya=f[Xa>>2]|0;f[Xa>>2]=Ya+-1;if((Ya|0)!=1)break;_S(G)}while(0);f[Ha>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[xa>>2]|0)>0){sa=f[za>>2]|0;za=0;do{f[sa+(za<<2)>>2]=0;za=za+1|0}while((za|0)<(f[xa>>2]|0))}xa=f[Ea>>2]|0;if((xa|0)!=(Fa|0))g0(xa);GQ(F);GQ(E);E=D+36|0;F=f[E>>2]|0;do if(F|0){xa=F+12|0;Fa=f[xa>>2]|0;f[xa>>2]=Fa+-1;if((Fa|0)!=1)break;_S(D)}while(0);f[E>>2]=0;E=D+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[da>>2]|0)>0){E=f[_>>2]|0;_=0;do{f[E+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[da>>2]|0))}da=f[ea>>2]|0;if((da|0)!=(ga|0))g0(da);da=C+36|0;ga=f[da>>2]|0;do if(ga|0){ea=ga+12|0;_=f[ea>>2]|0;f[ea>>2]=_+-1;if((_|0)!=1)break;_S(C)}while(0);f[da>>2]=0;da=C+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ba>>2]|0)>0){da=f[ha>>2]|0;ha=0;do{f[da+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ba>>2]|0))}ba=f[$>>2]|0;if((ba|0)!=(ia|0))g0(ba);ba=f[B>>2]|0;if(ba|0){B=f[aa>>2]|0;if((B|0)!=(ba|0))f[aa>>2]=B+(~((B+-4-ba|0)>>>2)<<2);YDc(ba)}ba=f[A>>2]|0;if(ba|0){A=f[fa>>2]|0;if((A|0)!=(ba|0))f[fa>>2]=A+(~((A+-4-ba|0)>>>2)<<2);YDc(ba)}ba=f[z>>2]|0;if(ba|0){z=f[c>>2]|0;if((z|0)!=(ba|0))f[c>>2]=z+(~((z+-16-ba|0)>>>4)<<4);YDc(ba)}ba=f[Ja>>2]|0;do if(ba|0){z=ba+12|0;c=f[z>>2]|0;f[z>>2]=c+-1;if((c|0)!=1)break;_S(y)}while(0);f[Ja>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[Ta>>2]|0)>0){Sa=f[y+40>>2]|0;Ja=0;do{f[Sa+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[Ta>>2]|0))}Ta=f[y+44>>2]|0;if((Ta|0)!=(y+48|0))g0(Ta);Ta=f[Aa>>2]|0;do if(Ta|0){y=Ta+12|0;Ja=f[y>>2]|0;f[y>>2]=Ja+-1;if((Ja|0)!=1)break;_S(x)}while(0);f[Aa>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[ra>>2]|0)>0){la=f[x+40>>2]|0;Aa=0;do{f[la+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[ra>>2]|0))}ra=f[x+44>>2]|0;if((ra|0)!=(x+48|0))g0(ra);u=j;return}function WGb(a){a=a|0;return 32}function XGb(a){a=a|0;return 0}function YGb(a){a=a|0;var b=0;switch(f[a+28>>2]|0){case 2:{b=6;break}case 4:case 3:{b=7;break}default:b=-1}return b|0}function ZGb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function _Gb(a){a=a|0;return f[a+4>>2]|0}function $Gb(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function aHb(a){a=a|0;return +(+p[a+8>>3])}function bHb(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function cHb(a){a=a|0;return f[a+16>>2]|0}function dHb(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function eHb(a){a=a|0;return f[a+20>>2]|0}function fHb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if((c|0)>-1){f[a+24>>2]=c;u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;d=tT(e,16)|0;c=459719;a=d+16|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(a|0));z5(-215,e,459736,459750,676)}}function gHb(a){a=a|0;return f[a+24>>2]|0}function hHb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function iHb(a){a=a|0;return f[a+28>>2]|0}function jHb(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function kHb(a){a=a|0;return f[a+32>>2]|0}function lHb(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function mHb(a){a=a|0;return f[a+36>>2]|0}function nHb(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function oHb(a){a=a|0;return f[a+40>>2]|0}function pHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[a>>2]|0;e=d;if((((f[c>>2]|0)-d|0)/28|0)>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>153391689){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}h=f[g>>2]|0;i=VDc(b*28|0)|0;j=i+(((h-d|0)/28|0)*28|0)|0;d=j;k=i+(b*28|0)|0;b=h;if((b|0)==(e|0)){l=d;m=h}else{h=b;b=d;i=j;do{j=h;h=h+-28|0;f[i+-28>>2]=f[h>>2];f[i+-24>>2]=f[j+-24>>2];n=i+-20|0;o=j+-20|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];f[n+16>>2]=f[o+16>>2];i=b+-28|0;b=i}while((h|0)!=(e|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;if(!m)return;YDc(m);return}function qHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)mCc(a);d=b*12|0;e=VDc(d)|0;f[a>>2]=e;g=e+(b*12|0)|0;f[a+8>>2]=g;XIc(e|0,0,d|0)|0;f[c>>2]=g;return}function rHb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0;m=u;u=u+16|0;n=m;if((h|0)<=-1){f[n>>2]=0;f[n+4>>2]=0;o=tT(n,15)|0;q=460039;r=o+15|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));z5(-215,n,464481,459750,1209)}n=VDc(48)|0;r0(n);f[n>>2]=107572;f[n+4>>2]=c;p[n+8>>3]=d;f[n+16>>2]=e;f[n+20>>2]=g;f[n+24>>2]=h;f[n+28>>2]=i;f[n+32>>2]=j;f[n+36>>2]=k;f[n+40>>2]=l;l=VDc(16)|0;k=l+4|0;f[k>>2]=1;f[l>>2]=111812;f[l+8>>2]=n;f[a>>2]=l;f[a+4>>2]=n;f[k>>2]=(f[k>>2]|0)+1;n=f[k>>2]|0;f[k>>2]=n+-1;if((n|0)!=1){u=m;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=m;return}function sHb(a){a=a|0;YDc(a);return}function tHb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;XHb(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;tT(a,(f[c>>2]|0)+13|0)|0;g=f[c>>2]|0;if(!g)h=0;else{dJc(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;h=460122;a=c+13|0;do{b[c>>0]=b[h>>0]|0;c=c+1|0;h=h+1|0}while((c|0)<(a|0));uT(e);u=d;return}function vHb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=+j;var k=0;k=VDc(48)|0;r0(k);f[k>>2]=111832;f[k+4>>2]=c;p[k+8>>3]=d;p[k+16>>3]=e;f[k+24>>2]=g;f[k+28>>2]=h;b[k+32>>0]=i&1;p[k+40>>3]=j;i=VDc(16)|0;h=i+4|0;f[h>>2]=1;f[i>>2]=111952;f[i+8>>2]=k;f[a>>2]=i;f[a+4>>2]=k;f[h>>2]=(f[h>>2]|0)+1;k=f[h>>2]|0;f[h>>2]=k+-1;if((k|0)!=1)return;Yi[f[(f[i>>2]|0)+8>>2]&2047](i);return}function wHb(a){a=a|0;YDc(a);return}function xHb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function yHb(a){a=a|0;THb(a);YDc(a);return}function zHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0.0;g=u;u=u+160|0;h=g+144|0;i=g+88|0;j=g+32|0;k=g+16|0;l=g;if(r$(c)|0){m=f[d>>2]|0;o=d+4|0;q=f[o>>2]|0;if((q|0)==(m|0)){u=g;return}f[o>>2]=q+(~(((q+-28-m|0)>>>0)/28|0)*28|0);u=g;return}f[h>>2]=0;m=h+4|0;f[m>>2]=0;f[h+8>>2]=0;if((d$(c)|0)!=655360){do if((d$(c)|0)==65536){q=f[c+4>>2]|0;f[i>>2]=f[q>>2];o=i+4|0;r=q+4|0;f[o>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[q+8>>2];t=i+12|0;f[t>>2]=f[q+12>>2];v=i+16|0;f[v>>2]=f[q+16>>2];w=i+20|0;f[w>>2]=f[q+20>>2];x=i+24|0;f[x>>2]=f[q+24>>2];y=i+28|0;f[y>>2]=f[q+28>>2];z=i+32|0;f[z>>2]=f[q+32>>2];A=i+36|0;B=f[q+36>>2]|0;f[A>>2]=B;f[i+40>>2]=s;C=i+48|0;D=i+44|0;f[D>>2]=C;f[C>>2]=0;f[i+52>>2]=0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[r>>2]|0)<3){r=f[q+44>>2]|0;C=f[D>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2];E=o;F=s;G=t;H=v;I=v;J=w;K=x;L=y;M=z;N=A;O=A;P=i;break}else{f[o>>2]=0;ZS(i,q);E=o;F=s;G=t;H=v;I=v;J=w;K=x;L=y;M=z;N=A;O=A;P=i;break}}else{a$(i,c,-1);A=i+16|0;z=i+36|0;E=i+4|0;F=i+8|0;G=i+12|0;H=A;I=A;J=i+20|0;K=i+24|0;L=i+28|0;M=i+32|0;N=z;O=z;P=i}while(0);f[j>>2]=f[P>>2];z=j+4|0;A=f[E>>2]|0;f[z>>2]=A;y=j+8|0;f[y>>2]=f[F>>2];f[j+12>>2]=f[G>>2];G=j+16|0;f[G>>2]=f[I>>2];f[j+20>>2]=f[J>>2];f[j+24>>2]=f[K>>2];f[j+28>>2]=f[L>>2];f[j+32>>2]=f[M>>2];M=j+36|0;L=f[O>>2]|0;f[M>>2]=L;O=j+40|0;f[O>>2]=y;y=j+48|0;K=j+44|0;f[K>>2]=y;f[y>>2]=0;f[j+52>>2]=0;if(!L)Q=A;else{A=L+12|0;f[A>>2]=(f[A>>2]|0)+1;Q=f[E>>2]|0}if((Q|0)<3){Q=f[i+44>>2]|0;A=f[K>>2]|0;f[A>>2]=f[Q>>2];f[A+4>>2]=f[Q+4>>2]}else{f[z>>2]=0;ZS(j,i)}if(f[P>>2]&4095|0){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=i;P=l+8|0;f[P>>2]=0;f[P+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;Oga(k,l,6,0)}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=j;P=l+8|0;f[P>>2]=0;f[P+4>>2]=0;f[l>>2]=-2113732595;f[l+4>>2]=h;foa(k,l,f[a+4>>2]|0,+p[a+8>>3],+p[a+16>>3],e,f[a+24>>2]|0,f[a+28>>2]|0,(b[a+32>>0]|0)!=0,+p[a+40>>3]);l=f[M>>2]|0;if(l|0?(P=l+12|0,l=f[P>>2]|0,f[P>>2]=l+-1,(l|0)==1):0)_S(j);f[M>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[z>>2]|0)>0){G=f[O>>2]|0;O=0;do{f[G+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[z>>2]|0))}z=f[K>>2]|0;if((z|0)!=(y|0))g0(z);z=f[N>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)_S(i);f[N>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[E>>2]|0)>0){H=f[i+40>>2]|0;N=0;do{f[H+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[E>>2]|0))}E=f[i+44>>2]|0;if((E|0)!=(i+48|0))g0(E)}else{f[i>>2]=1124007936;E=i+4|0;N=i+8|0;H=i+20|0;z=i+24|0;y=i+28|0;K=i+32|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[K>>2]=N;O=i+40|0;G=i+36|0;f[G>>2]=O;f[i+44>>2]=0;f[O>>2]=0;if(!(c$(c,-1)|0)){e$(j,c,-1);O=j+24|0;M=f[O>>2]|0;if(M|0){l=M+8|0;f[l>>2]=(f[l>>2]|0)+1}l=f[z>>2]|0;if(l|0?(M=l+8|0,l=f[M>>2]|0,f[M>>2]=l+-1,(l|0)==1):0)HQ(i);if((f[E>>2]|0)>0){l=f[K>>2]|0;K=0;do{f[l+(K<<2)>>2]=0;K=K+1|0;R=f[E>>2]|0}while((K|0)<(R|0));f[z>>2]=0;f[i>>2]=f[j>>2];if((R|0)<3)S=17;else S=19}else{f[z>>2]=0;f[i>>2]=f[j>>2];S=17}if((S|0)==17){R=f[j+4>>2]|0;if((R|0)<3){f[E>>2]=R;f[N>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];N=f[j+36>>2]|0;R=f[G>>2]|0;f[R>>2]=f[N>>2];f[R+4>>2]=f[N+4>>2]}else S=19}if((S|0)==19)FQ(i,j);f[i+16>>2]=f[j+16>>2];if(!(f[H>>2]|0))f[H>>2]=f[j+20>>2];f[z>>2]=f[O>>2];f[y>>2]=f[j+28>>2];GQ(j)}else{y=j+8|0;f[y>>2]=0;f[y+4>>2]=0;f[j>>2]=34209792;f[j+4>>2]=i;Oga(c,j,6,0)}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17432576;f[j+4>>2]=i;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=-2113732595;f[k+4>>2]=h;foa(j,k,f[a+4>>2]|0,+p[a+8>>3],+p[a+16>>3],e,f[a+24>>2]|0,f[a+28>>2]|0,(b[a+32>>0]|0)!=0,+p[a+40>>3]);GQ(i)}i=f[m>>2]|0;e=f[h>>2]|0;k=i-e>>3;j=d+4|0;c=f[j>>2]|0;y=f[d>>2]|0;O=(c-y|0)/28|0;z=y;y=c;c=i;i=e;if(k>>>0<=O>>>0)if(k>>>0<O>>>0?(H=z+(k*28|0)|0,(y|0)!=(H|0)):0){S=y+(~(((y+-28-H|0)>>>0)/28|0)*28|0)|0;f[j>>2]=S;T=e;U=c;V=z;W=S;X=i}else{T=e;U=c;V=z;W=y;X=i}else{IO(d,k-O|0);O=f[h>>2]|0;T=O;U=f[m>>2]|0;V=f[d>>2]|0;W=f[j>>2]|0;X=O}O=T;if((O|0)!=(U|0)&(V|0)!=(W|0)){W=a+24|0;a=T;T=V;V=O;while(1){O=f[V+4>>2]|0;Y=+(f[W>>2]|0);f[T>>2]=f[a>>2];f[T+4>>2]=O;n[T+8>>2]=Y;n[T+12>>2]=-1.0;n[T+16>>2]=0.0;f[T+20>>2]=0;f[T+24>>2]=-1;O=V+8|0;d=T+28|0;if((O|0)!=(U|0)?(d|0)!=(f[j>>2]|0):0){a=O;T=d;V=O}else break}}if(X|0){if((U|0)!=(X|0))f[m>>2]=U+(~((U+-8-X|0)>>>3)<<3);YDc(X)}u=g;return}function AHb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function BHb(a){a=a|0;return f[a+4>>2]|0}function CHb(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function DHb(a){a=a|0;return +(+p[a+8>>3])}function EHb(a,b){a=a|0;b=+b;p[a+16>>3]=b;return}function FHb(a){a=a|0;return +(+p[a+16>>3])}function GHb(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function HHb(a){a=a|0;return f[a+24>>2]|0}function IHb(a,c){a=a|0;c=c|0;b[a+32>>0]=c&1;return}function JHb(a){a=a|0;return (b[a+32>>0]|0)!=0|0}function KHb(a,b){a=a|0;b=+b;p[a+40>>3]=b;return}function LHb(a){a=a|0;return +(+p[a+40>>3])}function MHb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=+i;var j=0;j=VDc(48)|0;r0(j);f[j>>2]=111832;f[j+4>>2]=c;p[j+8>>3]=d;p[j+16>>3]=e;f[j+24>>2]=g;f[j+28>>2]=3;b[j+32>>0]=h&1;p[j+40>>3]=i;h=VDc(16)|0;g=h+4|0;f[g>>2]=1;f[h>>2]=111952;f[h+8>>2]=j;f[a>>2]=h;f[a+4>>2]=j;f[g>>2]=(f[g>>2]|0)+1;j=f[g>>2]|0;f[g>>2]=j+-1;if((j|0)!=1)return;Yi[f[(f[h>>2]|0)+8>>2]&2047](h);return}function NHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0;c=u;u=u+48|0;d=c+8|0;e=c+44|0;g=c+40|0;h=c+36|0;i=c+32|0;j=c+28|0;k=c;if((b|0)<=-1){u=c;return}l=a+4|0;m=f[l>>2]|0;o=f[a>>2]|0;p=o;q=m;if(((m-o|0)/28|0)>>>0<=b>>>0){u=c;return}if(!b){if((q|0)==(p|0)){u=c;return}f[l>>2]=q+(~(((q+-28-o|0)>>>0)/28|0)*28|0);u=c;return}f[h>>2]=o;f[i>>2]=p+(b*28|0);f[j>>2]=m;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];f[d>>2]=f[j>>2];OHb(g,e,d,k);k=f[a>>2]|0;r=+n[k+((b+-1|0)*28|0)+16>>2];e=k+(b*28|0)|0;b=f[l>>2]|0;a:do if((e|0)==(b|0))s=e;else{k=b;g=e;while(1){j=g;while(1){if(!(+n[j+16>>2]>=r)){t=k;break}i=j+28|0;if((i|0)==(k|0)){s=k;break a}else j=i}while(1){v=t+-28|0;if((j|0)==(v|0)){s=j;break a}if(!(+n[t+-12>>2]>=r))t=v;else break}i=f[j>>2]|0;h=j+4|0;m=f[h>>2]|0;p=j+8|0;f[d>>2]=f[p>>2];f[d+4>>2]=f[p+4>>2];f[d+8>>2]=f[p+8>>2];f[d+12>>2]=f[p+12>>2];f[d+16>>2]=f[p+16>>2];f[j>>2]=f[v>>2];o=t+-24|0;f[h>>2]=f[o>>2];h=t+-20|0;f[p>>2]=f[h>>2];f[p+4>>2]=f[h+4>>2];f[p+8>>2]=f[h+8>>2];f[p+12>>2]=f[h+12>>2];f[p+16>>2]=f[h+16>>2];f[v>>2]=i;f[o>>2]=m;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[h+8>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];f[h+16>>2]=f[d+16>>2];h=j+28|0;if((h|0)==(v|0)){s=h;break}else{k=v;g=h}}}while(0);v=f[a>>2]|0;d=(s-v|0)/28|0;s=f[l>>2]|0;t=(s-v|0)/28|0;e=s;if(d>>>0>t>>>0){IO(a,d-t|0);u=c;return}if(d>>>0>=t>>>0){u=c;return}t=v+(d*28|0)|0;if((e|0)==(t|0)){u=c;return}f[l>>2]=e+(~(((e+-28-t|0)>>>0)/28|0)*28|0);u=c;return}
function lR(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=c+(Y(l,e)|0)|0;n=c+(Y(l|1,e)|0)|0;o=c+(Y(l|2,e)|0)|0;p=c+(Y(l|3,e)|0)|0;q=a+(l<<1)|0;r=0;do{s=q+(Y(r,b)|0)|0;d[m+(r<<1)>>1]=d[s>>1]|0;d[n+(r<<1)>>1]=d[s+2>>1]|0;d[o+(r<<1)>>1]=d[s+4>>1]|0;d[p+(r<<1)>>1]=d[s+6>>1]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=c+(Y(p,e)|0)|0;n=c+(Y(p|1,e)|0)|0;m=c+(Y(p|2,e)|0)|0;q=c+(Y(p|3,e)|0)|0;s=a+(p<<1)|0;t=0;do{u=s+(Y(t,b)|0)|0;v=t|1;w=s+(Y(v,b)|0)|0;x=t|2;y=s+(Y(x,b)|0)|0;z=t|3;A=s+(Y(z,b)|0)|0;d[o+(t<<1)>>1]=d[u>>1]|0;d[o+(v<<1)>>1]=d[w>>1]|0;d[o+(x<<1)>>1]=d[y>>1]|0;d[o+(z<<1)>>1]=d[A>>1]|0;d[n+(t<<1)>>1]=d[u+2>>1]|0;d[n+(v<<1)>>1]=d[w+2>>1]|0;d[n+(x<<1)>>1]=d[y+2>>1]|0;d[n+(z<<1)>>1]=d[A+2>>1]|0;d[m+(t<<1)>>1]=d[u+4>>1]|0;d[m+(v<<1)>>1]=d[w+4>>1]|0;d[m+(x<<1)>>1]=d[y+4>>1]|0;d[m+(z<<1)>>1]=d[A+4>>1]|0;d[q+(t<<1)>>1]=d[u+6>>1]|0;d[q+(v<<1)>>1]=d[w+6>>1]|0;d[q+(x<<1)>>1]=d[y+6>>1]|0;d[q+(z<<1)>>1]=d[A+6>>1]|0;t=t+4|0}while((t|0)<=(k|0));if(r){t=l;do{A=s+(Y(t,b)|0)|0;d[o+(t<<1)>>1]=d[A>>1]|0;d[n+(t<<1)>>1]=d[A+2>>1]|0;d[m+(t<<1)>>1]=d[A+4>>1]|0;d[q+(t<<1)>>1]=d[A+6>>1]|0;t=t+1|0}while((t|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)B=j;else return;do{p=c+(Y(B,e)|0)|0;l=a+(B<<1)|0;r=0;do{k=l+(Y(r,b)|0)|0;d[p+(r<<1)>>1]=d[k>>1]|0;r=r+1|0}while((r|0)!=(i|0));B=B+1|0}while((B|0)!=(h|0));return}B=i&-4;if((B|0)<(i|0))C=j;else{r=j;do{j=c+(Y(r,e)|0)|0;p=a+(r<<1)|0;l=0;do{k=p+(Y(l,b)|0)|0;t=l|1;q=p+(Y(t,b)|0)|0;m=l|2;n=p+(Y(m,b)|0)|0;o=l|3;s=p+(Y(o,b)|0)|0;d[j+(l<<1)>>1]=d[k>>1]|0;d[j+(t<<1)>>1]=d[q>>1]|0;d[j+(m<<1)>>1]=d[n>>1]|0;d[j+(o<<1)>>1]=d[s>>1]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=c+(Y(C,e)|0)|0;l=a+(C<<1)|0;j=0;do{p=l+(Y(j,b)|0)|0;s=j|1;o=l+(Y(s,b)|0)|0;n=j|2;m=l+(Y(n,b)|0)|0;q=j|3;t=l+(Y(q,b)|0)|0;d[r+(j<<1)>>1]=d[p>>1]|0;d[r+(s<<1)>>1]=d[o>>1]|0;d[r+(n<<1)>>1]=d[m>>1]|0;d[r+(q<<1)>>1]=d[t>>1]|0;j=j+4|0}while((j|0)<=(g|0));D=B;do{j=l+(Y(D,b)|0)|0;d[r+(D<<1)>>1]=d[j>>1]|0;D=D+1|0}while((D|0)!=(i|0));C=C+1|0}while((C|0)!=(h|0));return}function mR(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=d+(Y(l,e)|0)|0;n=d+(Y(l|1,e)|0)|0;o=d+(Y(l|2,e)|0)|0;p=d+(Y(l|3,e)|0)|0;q=a+(l*3|0)|0;r=0;do{s=q+(Y(r,c)|0)|0;t=m+(r*3|0)|0;b[t>>0]=b[s>>0]|0;b[t+1>>0]=b[s+1>>0]|0;b[t+2>>0]=b[s+2>>0]|0;t=s+3|0;u=n+(r*3|0)|0;b[u>>0]=b[t>>0]|0;b[u+1>>0]=b[t+1>>0]|0;b[u+2>>0]=b[t+2>>0]|0;t=s+6|0;u=o+(r*3|0)|0;b[u>>0]=b[t>>0]|0;b[u+1>>0]=b[t+1>>0]|0;b[u+2>>0]=b[t+2>>0]|0;t=s+9|0;s=p+(r*3|0)|0;b[s>>0]=b[t>>0]|0;b[s+1>>0]=b[t+1>>0]|0;b[s+2>>0]=b[t+2>>0]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=d+(Y(p,e)|0)|0;n=d+(Y(p|1,e)|0)|0;m=d+(Y(p|2,e)|0)|0;q=d+(Y(p|3,e)|0)|0;t=a+(p*3|0)|0;s=0;do{u=t+(Y(s,c)|0)|0;v=s|1;w=t+(Y(v,c)|0)|0;x=s|2;y=t+(Y(x,c)|0)|0;z=s|3;A=t+(Y(z,c)|0)|0;B=o+(s*3|0)|0;b[B>>0]=b[u>>0]|0;b[B+1>>0]=b[u+1>>0]|0;b[B+2>>0]=b[u+2>>0]|0;B=o+(v*3|0)|0;b[B>>0]=b[w>>0]|0;b[B+1>>0]=b[w+1>>0]|0;b[B+2>>0]=b[w+2>>0]|0;B=o+(x*3|0)|0;b[B>>0]=b[y>>0]|0;b[B+1>>0]=b[y+1>>0]|0;b[B+2>>0]=b[y+2>>0]|0;B=o+(z*3|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;B=u+3|0;C=n+(s*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=w+3|0;C=n+(v*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=y+3|0;C=n+(x*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=A+3|0;C=n+(z*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=u+6|0;C=m+(s*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=w+6|0;C=m+(v*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=y+6|0;C=m+(x*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=A+6|0;C=m+(z*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=u+9|0;u=q+(s*3|0)|0;b[u>>0]=b[B>>0]|0;b[u+1>>0]=b[B+1>>0]|0;b[u+2>>0]=b[B+2>>0]|0;B=w+9|0;w=q+(v*3|0)|0;b[w>>0]=b[B>>0]|0;b[w+1>>0]=b[B+1>>0]|0;b[w+2>>0]=b[B+2>>0]|0;B=y+9|0;y=q+(x*3|0)|0;b[y>>0]=b[B>>0]|0;b[y+1>>0]=b[B+1>>0]|0;b[y+2>>0]=b[B+2>>0]|0;B=A+9|0;A=q+(z*3|0)|0;b[A>>0]=b[B>>0]|0;b[A+1>>0]=b[B+1>>0]|0;b[A+2>>0]=b[B+2>>0]|0;s=s+4|0}while((s|0)<=(k|0));if(r){s=l;do{B=t+(Y(s,c)|0)|0;A=o+(s*3|0)|0;b[A>>0]=b[B>>0]|0;b[A+1>>0]=b[B+1>>0]|0;b[A+2>>0]=b[B+2>>0]|0;A=B+3|0;z=n+(s*3|0)|0;b[z>>0]=b[A>>0]|0;b[z+1>>0]=b[A+1>>0]|0;b[z+2>>0]=b[A+2>>0]|0;A=B+6|0;z=m+(s*3|0)|0;b[z>>0]=b[A>>0]|0;b[z+1>>0]=b[A+1>>0]|0;b[z+2>>0]=b[A+2>>0]|0;A=B+9|0;B=q+(s*3|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;s=s+1|0}while((s|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)D=j;else return;do{p=d+(Y(D,e)|0)|0;l=a+(D*3|0)|0;r=0;do{k=l+(Y(r,c)|0)|0;s=p+(r*3|0)|0;b[s>>0]=b[k>>0]|0;b[s+1>>0]=b[k+1>>0]|0;b[s+2>>0]=b[k+2>>0]|0;r=r+1|0}while((r|0)!=(i|0));D=D+1|0}while((D|0)!=(h|0));return}D=i&-4;if((D|0)<(i|0))E=j;else{r=j;do{j=d+(Y(r,e)|0)|0;p=a+(r*3|0)|0;l=0;do{k=p+(Y(l,c)|0)|0;s=l|1;q=p+(Y(s,c)|0)|0;m=l|2;n=p+(Y(m,c)|0)|0;o=l|3;t=p+(Y(o,c)|0)|0;A=j+(l*3|0)|0;b[A>>0]=b[k>>0]|0;b[A+1>>0]=b[k+1>>0]|0;b[A+2>>0]=b[k+2>>0]|0;k=j+(s*3|0)|0;b[k>>0]=b[q>>0]|0;b[k+1>>0]=b[q+1>>0]|0;b[k+2>>0]=b[q+2>>0]|0;q=j+(m*3|0)|0;b[q>>0]=b[n>>0]|0;b[q+1>>0]=b[n+1>>0]|0;b[q+2>>0]=b[n+2>>0]|0;n=j+(o*3|0)|0;b[n>>0]=b[t>>0]|0;b[n+1>>0]=b[t+1>>0]|0;b[n+2>>0]=b[t+2>>0]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=d+(Y(E,e)|0)|0;l=a+(E*3|0)|0;j=0;do{p=l+(Y(j,c)|0)|0;t=j|1;n=l+(Y(t,c)|0)|0;o=j|2;q=l+(Y(o,c)|0)|0;m=j|3;k=l+(Y(m,c)|0)|0;s=r+(j*3|0)|0;b[s>>0]=b[p>>0]|0;b[s+1>>0]=b[p+1>>0]|0;b[s+2>>0]=b[p+2>>0]|0;p=r+(t*3|0)|0;b[p>>0]=b[n>>0]|0;b[p+1>>0]=b[n+1>>0]|0;b[p+2>>0]=b[n+2>>0]|0;n=r+(o*3|0)|0;b[n>>0]=b[q>>0]|0;b[n+1>>0]=b[q+1>>0]|0;b[n+2>>0]=b[q+2>>0]|0;q=r+(m*3|0)|0;b[q>>0]=b[k>>0]|0;b[q+1>>0]=b[k+1>>0]|0;b[q+2>>0]=b[k+2>>0]|0;j=j+4|0}while((j|0)<=(g|0));F=D;do{j=l+(Y(F,c)|0)|0;k=r+(F*3|0)|0;b[k>>0]=b[j>>0]|0;b[k+1>>0]=b[j+1>>0]|0;b[k+2>>0]=b[j+2>>0]|0;F=F+1|0}while((F|0)!=(i|0));E=E+1|0}while((E|0)!=(h|0));return}function nR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<2)|0;q=0;do{r=p+(Y(q,b)|0)|0;f[l+(q<<2)>>2]=f[r>>2];f[m+(q<<2)>>2]=f[r+4>>2];f[n+(q<<2)>>2]=f[r+8>>2];f[o+(q<<2)>>2]=f[r+12>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;r=a+(o<<2)|0;s=0;do{t=r+(Y(s,b)|0)|0;u=s|1;v=r+(Y(u,b)|0)|0;w=s|2;x=r+(Y(w,b)|0)|0;y=s|3;z=r+(Y(y,b)|0)|0;f[n+(s<<2)>>2]=f[t>>2];f[n+(u<<2)>>2]=f[v>>2];f[n+(w<<2)>>2]=f[x>>2];f[n+(y<<2)>>2]=f[z>>2];f[m+(s<<2)>>2]=f[t+4>>2];f[m+(u<<2)>>2]=f[v+4>>2];f[m+(w<<2)>>2]=f[x+4>>2];f[m+(y<<2)>>2]=f[z+4>>2];f[l+(s<<2)>>2]=f[t+8>>2];f[l+(u<<2)>>2]=f[v+8>>2];f[l+(w<<2)>>2]=f[x+8>>2];f[l+(y<<2)>>2]=f[z+8>>2];f[p+(s<<2)>>2]=f[t+12>>2];f[p+(u<<2)>>2]=f[v+12>>2];f[p+(w<<2)>>2]=f[x+12>>2];f[p+(y<<2)>>2]=f[z+12>>2];s=s+4|0}while((s|0)<=(j|0));if(q){s=k;do{z=r+(Y(s,b)|0)|0;f[n+(s<<2)>>2]=f[z>>2];f[m+(s<<2)>>2]=f[z+4>>2];f[l+(s<<2)>>2]=f[z+8>>2];f[p+(s<<2)>>2]=f[z+12>>2];s=s+1|0}while((s|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)A=i;else return;do{o=c+(Y(A,d)|0)|0;k=a+(A<<2)|0;q=0;do{j=k+(Y(q,b)|0)|0;f[o+(q<<2)>>2]=f[j>>2];q=q+1|0}while((q|0)!=(h|0));A=A+1|0}while((A|0)!=(g|0));return}A=h&-4;if((A|0)<(h|0))B=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<2)|0;k=0;do{j=o+(Y(k,b)|0)|0;s=k|1;p=o+(Y(s,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;r=o+(Y(n,b)|0)|0;f[i+(k<<2)>>2]=f[j>>2];f[i+(s<<2)>>2]=f[p>>2];f[i+(l<<2)>>2]=f[m>>2];f[i+(n<<2)>>2]=f[r>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(B,d)|0)|0;k=a+(B<<2)|0;i=0;do{o=k+(Y(i,b)|0)|0;r=i|1;n=k+(Y(r,b)|0)|0;m=i|2;l=k+(Y(m,b)|0)|0;p=i|3;s=k+(Y(p,b)|0)|0;f[q+(i<<2)>>2]=f[o>>2];f[q+(r<<2)>>2]=f[n>>2];f[q+(m<<2)>>2]=f[l>>2];f[q+(p<<2)>>2]=f[s>>2];i=i+4|0}while((i|0)<=(e|0));C=A;do{i=k+(Y(C,b)|0)|0;f[q+(C<<2)>>2]=f[i>>2];C=C+1|0}while((C|0)!=(h|0));B=B+1|0}while((B|0)!=(g|0));return}function oR(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=c+(Y(l,e)|0)|0;n=c+(Y(l|1,e)|0)|0;o=c+(Y(l|2,e)|0)|0;p=c+(Y(l|3,e)|0)|0;q=a+(l*6|0)|0;r=0;do{s=q+(Y(r,b)|0)|0;t=m+(r*6|0)|0;d[t>>1]=d[s>>1]|0;d[t+2>>1]=d[s+2>>1]|0;d[t+4>>1]=d[s+4>>1]|0;t=s+6|0;u=n+(r*6|0)|0;d[u>>1]=d[t>>1]|0;d[u+2>>1]=d[t+2>>1]|0;d[u+4>>1]=d[t+4>>1]|0;t=s+12|0;u=o+(r*6|0)|0;d[u>>1]=d[t>>1]|0;d[u+2>>1]=d[t+2>>1]|0;d[u+4>>1]=d[t+4>>1]|0;t=s+18|0;s=p+(r*6|0)|0;d[s>>1]=d[t>>1]|0;d[s+2>>1]=d[t+2>>1]|0;d[s+4>>1]=d[t+4>>1]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=c+(Y(p,e)|0)|0;n=c+(Y(p|1,e)|0)|0;m=c+(Y(p|2,e)|0)|0;q=c+(Y(p|3,e)|0)|0;t=a+(p*6|0)|0;s=0;do{u=t+(Y(s,b)|0)|0;v=s|1;w=t+(Y(v,b)|0)|0;x=s|2;y=t+(Y(x,b)|0)|0;z=s|3;A=t+(Y(z,b)|0)|0;B=o+(s*6|0)|0;d[B>>1]=d[u>>1]|0;d[B+2>>1]=d[u+2>>1]|0;d[B+4>>1]=d[u+4>>1]|0;B=o+(v*6|0)|0;d[B>>1]=d[w>>1]|0;d[B+2>>1]=d[w+2>>1]|0;d[B+4>>1]=d[w+4>>1]|0;B=o+(x*6|0)|0;d[B>>1]=d[y>>1]|0;d[B+2>>1]=d[y+2>>1]|0;d[B+4>>1]=d[y+4>>1]|0;B=o+(z*6|0)|0;d[B>>1]=d[A>>1]|0;d[B+2>>1]=d[A+2>>1]|0;d[B+4>>1]=d[A+4>>1]|0;B=u+6|0;C=n+(s*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=w+6|0;C=n+(v*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=y+6|0;C=n+(x*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=A+6|0;C=n+(z*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=u+12|0;C=m+(s*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=w+12|0;C=m+(v*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=y+12|0;C=m+(x*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=A+12|0;C=m+(z*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=u+18|0;u=q+(s*6|0)|0;d[u>>1]=d[B>>1]|0;d[u+2>>1]=d[B+2>>1]|0;d[u+4>>1]=d[B+4>>1]|0;B=w+18|0;w=q+(v*6|0)|0;d[w>>1]=d[B>>1]|0;d[w+2>>1]=d[B+2>>1]|0;d[w+4>>1]=d[B+4>>1]|0;B=y+18|0;y=q+(x*6|0)|0;d[y>>1]=d[B>>1]|0;d[y+2>>1]=d[B+2>>1]|0;d[y+4>>1]=d[B+4>>1]|0;B=A+18|0;A=q+(z*6|0)|0;d[A>>1]=d[B>>1]|0;d[A+2>>1]=d[B+2>>1]|0;d[A+4>>1]=d[B+4>>1]|0;s=s+4|0}while((s|0)<=(k|0));if(r){s=l;do{B=t+(Y(s,b)|0)|0;A=o+(s*6|0)|0;d[A>>1]=d[B>>1]|0;d[A+2>>1]=d[B+2>>1]|0;d[A+4>>1]=d[B+4>>1]|0;A=B+6|0;z=n+(s*6|0)|0;d[z>>1]=d[A>>1]|0;d[z+2>>1]=d[A+2>>1]|0;d[z+4>>1]=d[A+4>>1]|0;A=B+12|0;z=m+(s*6|0)|0;d[z>>1]=d[A>>1]|0;d[z+2>>1]=d[A+2>>1]|0;d[z+4>>1]=d[A+4>>1]|0;A=B+18|0;B=q+(s*6|0)|0;d[B>>1]=d[A>>1]|0;d[B+2>>1]=d[A+2>>1]|0;d[B+4>>1]=d[A+4>>1]|0;s=s+1|0}while((s|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)D=j;else return;do{p=c+(Y(D,e)|0)|0;l=a+(D*6|0)|0;r=0;do{k=l+(Y(r,b)|0)|0;s=p+(r*6|0)|0;d[s>>1]=d[k>>1]|0;d[s+2>>1]=d[k+2>>1]|0;d[s+4>>1]=d[k+4>>1]|0;r=r+1|0}while((r|0)!=(i|0));D=D+1|0}while((D|0)!=(h|0));return}D=i&-4;if((D|0)<(i|0))E=j;else{r=j;do{j=c+(Y(r,e)|0)|0;p=a+(r*6|0)|0;l=0;do{k=p+(Y(l,b)|0)|0;s=l|1;q=p+(Y(s,b)|0)|0;m=l|2;n=p+(Y(m,b)|0)|0;o=l|3;t=p+(Y(o,b)|0)|0;A=j+(l*6|0)|0;d[A>>1]=d[k>>1]|0;d[A+2>>1]=d[k+2>>1]|0;d[A+4>>1]=d[k+4>>1]|0;k=j+(s*6|0)|0;d[k>>1]=d[q>>1]|0;d[k+2>>1]=d[q+2>>1]|0;d[k+4>>1]=d[q+4>>1]|0;q=j+(m*6|0)|0;d[q>>1]=d[n>>1]|0;d[q+2>>1]=d[n+2>>1]|0;d[q+4>>1]=d[n+4>>1]|0;n=j+(o*6|0)|0;d[n>>1]=d[t>>1]|0;d[n+2>>1]=d[t+2>>1]|0;d[n+4>>1]=d[t+4>>1]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=c+(Y(E,e)|0)|0;l=a+(E*6|0)|0;j=0;do{p=l+(Y(j,b)|0)|0;t=j|1;n=l+(Y(t,b)|0)|0;o=j|2;q=l+(Y(o,b)|0)|0;m=j|3;k=l+(Y(m,b)|0)|0;s=r+(j*6|0)|0;d[s>>1]=d[p>>1]|0;d[s+2>>1]=d[p+2>>1]|0;d[s+4>>1]=d[p+4>>1]|0;p=r+(t*6|0)|0;d[p>>1]=d[n>>1]|0;d[p+2>>1]=d[n+2>>1]|0;d[p+4>>1]=d[n+4>>1]|0;n=r+(o*6|0)|0;d[n>>1]=d[q>>1]|0;d[n+2>>1]=d[q+2>>1]|0;d[n+4>>1]=d[q+4>>1]|0;q=r+(m*6|0)|0;d[q>>1]=d[k>>1]|0;d[q+2>>1]=d[k+2>>1]|0;d[q+4>>1]=d[k+4>>1]|0;j=j+4|0}while((j|0)<=(g|0));F=D;do{j=l+(Y(F,b)|0)|0;k=r+(F*6|0)|0;d[k>>1]=d[j>>1]|0;d[k+2>>1]=d[j+2>>1]|0;d[k+4>>1]=d[j+4>>1]|0;F=F+1|0}while((F|0)!=(i|0));E=E+1|0}while((E|0)!=(h|0));return}function pR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<3)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=r;t=f[s+4>>2]|0;u=l+(q<<3)|0;f[u>>2]=f[s>>2];f[u+4>>2]=t;t=r+8|0;u=f[t+4>>2]|0;s=m+(q<<3)|0;f[s>>2]=f[t>>2];f[s+4>>2]=u;u=r+16|0;s=f[u+4>>2]|0;t=n+(q<<3)|0;f[t>>2]=f[u>>2];f[t+4>>2]=s;s=r+24|0;r=f[s+4>>2]|0;t=o+(q<<3)|0;f[t>>2]=f[s>>2];f[t+4>>2]=r;q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;r=a+(o<<3)|0;t=0;do{s=r+(Y(t,b)|0)|0;u=t|1;v=r+(Y(u,b)|0)|0;w=t|2;x=r+(Y(w,b)|0)|0;y=t|3;z=r+(Y(y,b)|0)|0;A=s;B=f[A+4>>2]|0;C=n+(t<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=v;C=f[B+4>>2]|0;A=n+(u<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=x;A=f[C+4>>2]|0;B=n+(w<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=z;B=f[A+4>>2]|0;C=n+(y<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=s+8|0;C=f[B+4>>2]|0;A=m+(t<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=v+8|0;A=f[C+4>>2]|0;B=m+(u<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=x+8|0;B=f[A+4>>2]|0;C=m+(w<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=z+8|0;C=f[B+4>>2]|0;A=m+(y<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=s+16|0;A=f[C+4>>2]|0;B=l+(t<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=v+16|0;B=f[A+4>>2]|0;C=l+(u<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=x+16|0;C=f[B+4>>2]|0;A=l+(w<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=z+16|0;A=f[C+4>>2]|0;B=l+(y<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=s+24|0;s=f[A+4>>2]|0;B=p+(t<<3)|0;f[B>>2]=f[A>>2];f[B+4>>2]=s;s=v+24|0;v=f[s+4>>2]|0;B=p+(u<<3)|0;f[B>>2]=f[s>>2];f[B+4>>2]=v;v=x+24|0;x=f[v+4>>2]|0;B=p+(w<<3)|0;f[B>>2]=f[v>>2];f[B+4>>2]=x;x=z+24|0;z=f[x+4>>2]|0;B=p+(y<<3)|0;f[B>>2]=f[x>>2];f[B+4>>2]=z;t=t+4|0}while((t|0)<=(j|0));if(q){t=k;do{z=r+(Y(t,b)|0)|0;B=z;x=f[B+4>>2]|0;y=n+(t<<3)|0;f[y>>2]=f[B>>2];f[y+4>>2]=x;x=z+8|0;y=f[x+4>>2]|0;B=m+(t<<3)|0;f[B>>2]=f[x>>2];f[B+4>>2]=y;y=z+16|0;B=f[y+4>>2]|0;x=l+(t<<3)|0;f[x>>2]=f[y>>2];f[x+4>>2]=B;B=z+24|0;z=f[B+4>>2]|0;x=p+(t<<3)|0;f[x>>2]=f[B>>2];f[x+4>>2]=z;t=t+1|0}while((t|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)D=i;else return;do{o=c+(Y(D,d)|0)|0;k=a+(D<<3)|0;q=0;do{j=k+(Y(q,b)|0)|0;t=f[j+4>>2]|0;p=o+(q<<3)|0;f[p>>2]=f[j>>2];f[p+4>>2]=t;q=q+1|0}while((q|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}D=h&-4;if((D|0)<(h|0))E=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<3)|0;k=0;do{t=k|1;p=o+(Y(t,b)|0)|0;j=k|2;l=o+(Y(j,b)|0)|0;m=k|3;n=o+(Y(m,b)|0)|0;r=o+(Y(k,b)|0)|0;z=f[r+4>>2]|0;x=i+(k<<3)|0;f[x>>2]=f[r>>2];f[x+4>>2]=z;z=p;p=f[z+4>>2]|0;x=i+(t<<3)|0;f[x>>2]=f[z>>2];f[x+4>>2]=p;p=l;l=f[p+4>>2]|0;x=i+(j<<3)|0;f[x>>2]=f[p>>2];f[x+4>>2]=l;l=n;n=f[l+4>>2]|0;x=i+(m<<3)|0;f[x>>2]=f[l>>2];f[x+4>>2]=n;k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(E,d)|0)|0;k=a+(E<<3)|0;i=0;do{o=i|1;n=k+(Y(o,b)|0)|0;x=i|2;l=k+(Y(x,b)|0)|0;m=i|3;p=k+(Y(m,b)|0)|0;j=k+(Y(i,b)|0)|0;z=f[j+4>>2]|0;t=q+(i<<3)|0;f[t>>2]=f[j>>2];f[t+4>>2]=z;z=n;n=f[z+4>>2]|0;t=q+(o<<3)|0;f[t>>2]=f[z>>2];f[t+4>>2]=n;n=l;l=f[n+4>>2]|0;t=q+(x<<3)|0;f[t>>2]=f[n>>2];f[t+4>>2]=l;l=p;p=f[l+4>>2]|0;t=q+(m<<3)|0;f[t>>2]=f[l>>2];f[t+4>>2]=p;i=i+4|0}while((i|0)<=(e|0));F=D;do{i=k+(Y(F,b)|0)|0;p=f[i+4>>2]|0;t=q+(F<<3)|0;f[t>>2]=f[i>>2];f[t+4>>2]=p;F=F+1|0}while((F|0)!=(h|0));E=E+1|0}while((E|0)!=(g|0));return}function qR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k*12|0)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q*12|0)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];s=r+12|0;t=m+(q*12|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];s=r+24|0;t=n+(q*12|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];s=r+36|0;r=o+(q*12|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o*12|0)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r*12|0)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];A=n+(u*12|0)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];A=n+(w*12|0)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];A=n+(y*12|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];A=t+12|0;B=m+(r*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=v+12|0;B=m+(u*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=x+12|0;B=m+(w*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=z+12|0;B=m+(y*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=t+24|0;B=l+(r*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=v+24|0;B=l+(u*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=x+24|0;B=l+(w*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=z+24|0;B=l+(y*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=t+36|0;t=p+(r*12|0)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];A=v+36|0;v=p+(u*12|0)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];A=x+36|0;x=p+(w*12|0)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];A=z+36|0;z=p+(y*12|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r*12|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];z=A+12|0;y=m+(r*12|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];z=A+24|0;y=l+(r*12|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];z=A+36|0;A=p+(r*12|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C*12|0)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q*12|0)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q*12|0)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k*12|0)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];j=i+(r*12|0)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];p=i+(l*12|0)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];m=i+(n*12|0)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D*12|0)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i*12|0)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];o=q+(s*12|0)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];m=q+(n*12|0)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];p=q+(l*12|0)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E*12|0)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function rR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<4)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q<<4)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];s=r+16|0;t=m+(q<<4)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=r+32|0;t=n+(q<<4)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=r+48|0;r=o+(q<<4)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o<<4)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r<<4)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];A=n+(u<<4)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];A=n+(w<<4)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];A=n+(y<<4)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];A=t+16|0;B=m+(r<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=v+16|0;B=m+(u<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=x+16|0;B=m+(w<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=z+16|0;B=m+(y<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=t+32|0;B=l+(r<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=v+32|0;B=l+(u<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=x+32|0;B=l+(w<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=z+32|0;B=l+(y<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=t+48|0;t=p+(r<<4)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];A=v+48|0;v=p+(u<<4)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];A=x+48|0;x=p+(w<<4)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];A=z+48|0;z=p+(y<<4)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r<<4)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];z=A+16|0;y=m+(r<<4)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];z=A+32|0;y=l+(r<<4)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];z=A+48|0;A=p+(r<<4)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C<<4)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q<<4)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<4)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k<<4)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];j=i+(r<<4)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];p=i+(l<<4)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];m=i+(n<<4)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D<<4)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i<<4)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];o=q+(s<<4)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];m=q+(n<<4)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];p=q+(l<<4)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E<<4)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function sR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k*24|0)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q*24|0)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];s=r+24|0;t=m+(q*24|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];s=r+48|0;t=n+(q*24|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];s=r+72|0;r=o+(q*24|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o*24|0)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r*24|0)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];f[A+16>>2]=f[t+16>>2];f[A+20>>2]=f[t+20>>2];A=n+(u*24|0)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];f[A+16>>2]=f[v+16>>2];f[A+20>>2]=f[v+20>>2];A=n+(w*24|0)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];f[A+16>>2]=f[x+16>>2];f[A+20>>2]=f[x+20>>2];A=n+(y*24|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];A=t+24|0;B=m+(r*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=v+24|0;B=m+(u*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=x+24|0;B=m+(w*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=z+24|0;B=m+(y*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=t+48|0;B=l+(r*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=v+48|0;B=l+(u*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=x+48|0;B=l+(w*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=z+48|0;B=l+(y*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=t+72|0;t=p+(r*24|0)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];f[t+16>>2]=f[A+16>>2];f[t+20>>2]=f[A+20>>2];A=v+72|0;v=p+(u*24|0)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];f[v+16>>2]=f[A+16>>2];f[v+20>>2]=f[A+20>>2];A=x+72|0;x=p+(w*24|0)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];f[x+16>>2]=f[A+16>>2];f[x+20>>2]=f[A+20>>2];A=z+72|0;z=p+(y*24|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r*24|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];z=A+24|0;y=m+(r*24|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];z=A+48|0;y=l+(r*24|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];z=A+72|0;A=p+(r*24|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C*24|0)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q*24|0)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q*24|0)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k*24|0)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[z+16>>2]=f[j+16>>2];f[z+20>>2]=f[j+20>>2];j=i+(r*24|0)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];p=i+(l*24|0)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];f[p+16>>2]=f[m+16>>2];f[p+20>>2]=f[m+20>>2];m=i+(n*24|0)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D*24|0)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i*24|0)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[r+16>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];o=q+(s*24|0)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];m=q+(n*24|0)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];p=q+(l*24|0)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];f[p+16>>2]=f[j+16>>2];f[p+20>>2]=f[j+20>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E*24|0)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function tR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<5)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q<<5)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];s=r+32|0;t=m+(q<<5)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];s=r+64|0;t=n+(q<<5)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];s=r+96|0;r=o+(q<<5)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o<<5)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r<<5)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];f[A+16>>2]=f[t+16>>2];f[A+20>>2]=f[t+20>>2];f[A+24>>2]=f[t+24>>2];f[A+28>>2]=f[t+28>>2];A=n+(u<<5)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];f[A+16>>2]=f[v+16>>2];f[A+20>>2]=f[v+20>>2];f[A+24>>2]=f[v+24>>2];f[A+28>>2]=f[v+28>>2];A=n+(w<<5)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];f[A+16>>2]=f[x+16>>2];f[A+20>>2]=f[x+20>>2];f[A+24>>2]=f[x+24>>2];f[A+28>>2]=f[x+28>>2];A=n+(y<<5)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];A=t+32|0;B=m+(r<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=v+32|0;B=m+(u<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=x+32|0;B=m+(w<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=z+32|0;B=m+(y<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=t+64|0;B=l+(r<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=v+64|0;B=l+(u<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=x+64|0;B=l+(w<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=z+64|0;B=l+(y<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=t+96|0;t=p+(r<<5)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];f[t+16>>2]=f[A+16>>2];f[t+20>>2]=f[A+20>>2];f[t+24>>2]=f[A+24>>2];f[t+28>>2]=f[A+28>>2];A=v+96|0;v=p+(u<<5)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];f[v+16>>2]=f[A+16>>2];f[v+20>>2]=f[A+20>>2];f[v+24>>2]=f[A+24>>2];f[v+28>>2]=f[A+28>>2];A=x+96|0;x=p+(w<<5)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];f[x+16>>2]=f[A+16>>2];f[x+20>>2]=f[A+20>>2];f[x+24>>2]=f[A+24>>2];f[x+28>>2]=f[A+28>>2];A=z+96|0;z=p+(y<<5)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r<<5)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];z=A+32|0;y=m+(r<<5)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];z=A+64|0;y=l+(r<<5)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];z=A+96|0;A=p+(r<<5)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C<<5)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q<<5)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];f[r+24>>2]=f[j+24>>2];f[r+28>>2]=f[j+28>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<5)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k<<5)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[z+16>>2]=f[j+16>>2];f[z+20>>2]=f[j+20>>2];f[z+24>>2]=f[j+24>>2];f[z+28>>2]=f[j+28>>2];j=i+(r<<5)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];p=i+(l<<5)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];f[p+16>>2]=f[m+16>>2];f[p+20>>2]=f[m+20>>2];f[p+24>>2]=f[m+24>>2];f[p+28>>2]=f[m+28>>2];m=i+(n<<5)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D<<5)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i<<5)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[r+16>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];f[r+24>>2]=f[o+24>>2];f[r+28>>2]=f[o+28>>2];o=q+(s<<5)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];m=q+(n<<5)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];p=q+(l<<5)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];f[p+16>>2]=f[j+16>>2];f[p+20>>2]=f[j+20>>2];f[p+24>>2]=f[j+24>>2];f[p+28>>2]=f[j+28>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E<<5)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function uR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((d|0)>0)e=0;else return;do{f=a+(Y(e,c)|0)|0;g=a+e|0;e=e+1|0;if((e|0)<(d|0)){h=e;do{i=f+h|0;j=g+(Y(h,c)|0)|0;k=b[i>>0]|0;b[i>>0]=b[j>>0]|0;b[j>>0]=k;h=h+1|0}while((h|0)!=(d|0))}}while((e|0)!=(d|0));return}function vR(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((c|0)>0)e=0;else return;do{f=a+(Y(e,b)|0)|0;g=a+(e<<1)|0;e=e+1|0;if((e|0)<(c|0)){h=e;do{i=f+(h<<1)|0;j=g+(Y(h,b)|0)|0;k=d[i>>1]|0;d[i>>1]=d[j>>1]|0;d[j>>1]=k;h=h+1|0}while((h|0)!=(c|0))}}while((e|0)!=(c|0));return}function wR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((d|0)>0)e=0;else return;do{f=a+(Y(e,c)|0)|0;g=a+(e*3|0)|0;e=e+1|0;if((e|0)<(d|0)){h=e;do{i=g+(Y(h,c)|0)|0;j=f+(h*3|0)|0;k=b[j>>0]|0;l=b[f+(h*3|0)+1>>0]|0;m=b[f+(h*3|0)+2>>0]|0;b[j>>0]=b[i>>0]|0;b[j+1>>0]=b[i+1>>0]|0;b[j+2>>0]=b[i+2>>0]|0;b[i>>0]=k;b[i+1>>0]=l;b[i+2>>0]=m;h=h+1|0}while((h|0)!=(d|0))}}while((e|0)!=(d|0));return}function xR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<2)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<2)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function yR(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((c|0)>0)e=0;else return;do{f=a+(Y(e,b)|0)|0;g=a+(e*6|0)|0;e=e+1|0;if((e|0)<(c|0)){h=e;do{i=f+(h*6|0)|0;j=g+(Y(h,b)|0)|0;k=d[i>>1]|0;l=d[f+(h*6|0)+2>>1]|0;m=d[f+(h*6|0)+4>>1]|0;d[i>>1]=d[j>>1]|0;d[i+2>>1]=d[j+2>>1]|0;d[i+4>>1]=d[j+4>>1]|0;d[j>>1]=k;d[j+2>>1]=l;d[j+4>>1]=m;h=h+1|0}while((h|0)!=(c|0))}}while((e|0)!=(c|0));return}function zR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<3)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<3)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<3)+4>>2]|0;m=j;n=f[m+4>>2]|0;o=i;f[o>>2]=f[m>>2];f[o+4>>2]=n;n=j;f[n>>2]=k;f[n+4>>2]=l;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function AR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d*12|0)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h*12|0)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h*12|0)+4>>2]|0;m=f[e+(h*12|0)+8>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function BR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<4)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<4)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<4)+4>>2]|0;m=f[e+(h<<4)+8>>2]|0;n=f[e+(h<<4)+12>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function CR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d*24|0)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h*24|0)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h*24|0)+4>>2]|0;m=f[e+(h*24|0)+8>>2]|0;n=f[e+(h*24|0)+12>>2]|0;o=f[e+(h*24|0)+16>>2]|0;p=f[e+(h*24|0)+20>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;f[j+16>>2]=o;f[j+20>>2]=p;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function DR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<5)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<5)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<5)+4>>2]|0;m=f[e+(h<<5)+8>>2]|0;n=f[e+(h<<5)+12>>2]|0;o=f[e+(h<<5)+16>>2]|0;p=f[e+(h<<5)+20>>2]|0;q=f[e+(h<<5)+24>>2]|0;r=f[e+(h<<5)+28>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[i+24>>2]=f[j+24>>2];f[i+28>>2]=f[j+28>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;f[j+16>>2]=o;f[j+20>>2]=p;f[j+24>>2]=q;f[j+28>>2]=r;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function ER(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+64|0;e=d+8|0;g=d;do if((d$(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){n=l+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;n=f[m>>2]|0;f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];o=i;p=k;break}else{f[i>>2]=0;ZS(e,h);o=i;p=k;break}}else{a$(e,a,-1);o=e+4|0;p=e+48|0}while(0);a=f[p>>2]|0;k=f[o>>2]|0;if((k|0)>0)if((k|0)<3)q=f[(f[e+44>>2]|0)+(k+-1<<2)>>2]|0;else{f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=tT(g,31)|0;t=s;v=216760;w=t+31|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));dR(-215,g,216792,547)}else q=0;k=f[e+8>>2]|0;if((k|0)!=(f[e+12>>2]|0)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=tT(g,31)|0;t=s;v=216760;w=t+31|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));dR(-215,g,216792,547)}g=e+16|0;v=f[g>>2]|0;t=e+44|0;if((k|0)>0)if(c){c=0;do{w=c;c=c+1|0;if((c|0)<(k|0)){s=Y(w,a)|0;r=Y(w,q)|0;w=c;do{dJc(v+((Y(w,q)|0)+s)|0,v+((Y(w,a)|0)+r)|0,q|0)|0;w=w+1|0}while((w|0)!=(k|0))}}while((c|0)!=(k|0))}else{c=0;do{if((c|0)>0){w=Y(c,a)|0;r=Y(c,q)|0;s=0;do{dJc(v+((Y(s,q)|0)+w)|0,v+((Y(s,a)|0)+r)|0,q|0)|0;s=s+1|0}while((s|0)!=(c|0))}c=c+1|0}while((c|0)!=(k|0))}k=e+36|0;c=f[k>>2]|0;if(c|0?(q=c+12|0,c=f[q>>2]|0,f[q>>2]=c+-1,(c|0)==1):0)_S(e);f[k>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[o>>2]|0)>0){g=f[e+40>>2]|0;e=0;do{f[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[o>>2]|0))}o=f[t>>2]|0;if((o|0)==(p|0)){u=d;return}g0(o);u=d;return}function FR(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;h=u;u=u+272|0;i=h+216|0;j=h+168|0;k=h+112|0;l=h+56|0;m=h;if((n$(a,-1)|0)>=3){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,16)|0;o=220293;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));dR(-215,i,216805,969)}q=c$(a,-1)|0;r=q&7;s=q&4088;if((g|0)<0)if(X$(c)|0)t=c$(c,-1)|0;else t=q;else t=g;g=(t|0)>-1?t:q;t=g&7;v=t|s;w=(e|0)==1;if(e>>>0>=4){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,88)|0;o=216812;p=n+88|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));dR(-215,i,216805,979)}f[j>>2]=1124007936;x=j+4|0;y=j+8|0;z=j+20|0;A=j+24|0;B=j+28|0;C=j+32|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[C>>2]=y;D=j+40|0;E=j+36|0;f[E>>2]=D;f[j+44>>2]=0;f[D>>2]=0;if((d$(a)|0)==655360){e$(i,a,-1);D=i+24|0;F=f[D>>2]|0;if(F|0){G=F+8|0;f[G>>2]=(f[G>>2]|0)+1}G=f[A>>2]|0;if(G|0?(F=G+8|0,G=f[F>>2]|0,f[F>>2]=G+-1,(G|0)==1):0)HQ(j);if((f[x>>2]|0)>0){G=f[C>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0;H=f[x>>2]|0}while((C|0)<(H|0));f[A>>2]=0;f[j>>2]=f[i>>2];if((H|0)<3)I=19;else I=21}else{f[A>>2]=0;f[j>>2]=f[i>>2];I=19}if((I|0)==19){H=f[i+4>>2]|0;if((H|0)<3){f[x>>2]=H;f[y>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];y=f[i+36>>2]|0;H=f[E>>2]|0;f[H>>2]=f[y>>2];f[H+4>>2]=f[y+4>>2]}else I=21}if((I|0)==21)FQ(j,i);f[j+16>>2]=f[i+16>>2];if(!(f[z>>2]|0))f[z>>2]=f[i+20>>2];f[A>>2]=f[D>>2];f[B>>2]=f[i+28>>2];GQ(i)}do if((d$(a)|0)==65536){B=f[a+4>>2]|0;f[k>>2]=f[B>>2];D=k+4|0;A=B+4|0;f[D>>2]=f[A>>2];z=k+8|0;f[z>>2]=f[B+8>>2];y=k+12|0;f[y>>2]=f[B+12>>2];f[k+16>>2]=f[B+16>>2];f[k+20>>2]=f[B+20>>2];f[k+24>>2]=f[B+24>>2];f[k+28>>2]=f[B+28>>2];f[k+32>>2]=f[B+32>>2];H=f[B+36>>2]|0;f[k+36>>2]=H;f[k+40>>2]=z;E=k+48|0;x=k+44|0;f[x>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(H|0){E=H+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[A>>2]|0)<3){A=f[B+44>>2]|0;E=f[x>>2]|0;f[E>>2]=f[A>>2];f[E+4>>2]=f[A+4>>2];J=y;K=z;break}else{f[D>>2]=0;ZS(k,B);J=y;K=z;break}}else{a$(k,a,-1);J=k+12|0;K=k+8|0}while(0);a=(d|0)==0;Y$(c,a?1:f[K>>2]|0,a?f[J>>2]|0:1,v,-1,0,0);do if((d$(c)|0)==65536){v=f[c+4>>2]|0;f[l>>2]=f[v>>2];d=l+4|0;z=v+4|0;f[d>>2]=f[z>>2];y=l+8|0;f[y>>2]=f[v+8>>2];B=l+12|0;f[B>>2]=f[v+12>>2];D=l+16|0;f[D>>2]=f[v+16>>2];A=l+20|0;f[A>>2]=f[v+20>>2];E=l+24|0;f[E>>2]=f[v+24>>2];x=l+28|0;f[x>>2]=f[v+28>>2];H=l+32|0;f[H>>2]=f[v+32>>2];C=l+36|0;G=f[v+36>>2]|0;f[C>>2]=G;f[l+40>>2]=y;F=l+48|0;L=l+44|0;f[L>>2]=F;f[F>>2]=0;f[l+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[z>>2]|0)<3){z=f[v+44>>2]|0;F=f[L>>2]|0;f[F>>2]=f[z>>2];f[F+4>>2]=f[z+4>>2];M=l;N=d;O=y;P=B;Q=D;R=D;S=A;T=E;U=x;V=H;W=C;X=C;break}else{f[d>>2]=0;ZS(l,v);M=l;N=d;O=y;P=B;Q=D;R=D;S=A;T=E;U=x;V=H;W=C;X=C;break}}else{a$(l,c,-1);C=l+16|0;H=l+36|0;M=l;N=l+4|0;O=l+8|0;P=l+12|0;Q=C;R=C;S=l+20|0;T=l+24|0;U=l+28|0;V=l+32|0;W=H;X=H}while(0);f[m>>2]=f[M>>2];c=m+4|0;H=f[N>>2]|0;f[c>>2]=H;C=m+8|0;f[C>>2]=f[O>>2];x=m+12|0;f[x>>2]=f[P>>2];E=m+16|0;f[E>>2]=f[R>>2];f[m+20>>2]=f[S>>2];f[m+24>>2]=f[T>>2];f[m+28>>2]=f[U>>2];f[m+32>>2]=f[V>>2];V=m+36|0;U=f[X>>2]|0;f[V>>2]=U;X=m+40|0;f[X>>2]=C;T=m+48|0;S=m+44|0;f[S>>2]=T;f[T>>2]=0;f[m+52>>2]=0;if(!U)Y=H;else{H=U+12|0;f[H>>2]=(f[H>>2]|0)+1;Y=f[N>>2]|0}if((Y|0)<3){Y=f[l+44>>2]|0;H=f[S>>2]|0;f[H>>2]=f[Y>>2];f[H+4>>2]=f[Y+4>>2]}else{f[c>>2]=0;ZS(m,l)}do if(w)if(!((g|q)&4)){Y=f[O>>2]|0;H=f[P>>2]|0;U=s|4;if(((f[c>>2]|0)<3?(f[C>>2]|0)==(Y|0):0)&(f[x>>2]|0)==(H|0)?!((f[E>>2]|0)==0?1:(f[m>>2]&4095|0)!=(U|0)):0){Z=4;_=0;break}f[i>>2]=Y;f[i+4>>2]=H;XS(m,2,i,U);Z=4;_=0}else{Z=t;_=0}else{Z=t;_=e}while(0);e=(_|0)==0;a:do if(a){if(e){t=(r|0)==0;if(t&(Z|0)==4){$=1160;break}x=(Z|0)==5;if(t&x){$=1161;break}C=(Z|0)==6;if(t&C){$=1162;break}t=(r|0)==2;if(t&x){$=1163;break}if(t&C){$=1164;break}t=(r|0)==3;if(t&x){$=1165;break}if(t&C){$=1166;break}t=(r|0)==5;if(t&x){$=1167;break}if(t&C){$=1168;break}else{aa=(r|0)==6&C?1154:0;I=88;break}}switch(_|0){case 2:{if(!(Z|r)){$=1169;break a}if((r|0)==2&(Z|0)==2){$=1170;break a}if((r|0)==3&(Z|0)==3){$=1171;break a}if((r|0)==5&(Z|0)==5){$=1172;break a}else{aa=(r|0)==6&(Z|0)==6?1155:0;I=88;break a}break}case 3:{if(!(Z|r)){$=1173;break a}if((r|0)==2&(Z|0)==2){$=1174;break a}if((r|0)==3&(Z|0)==3){$=1175;break a}if((r|0)==5&(Z|0)==5){$=1176;break a}else{aa=(r|0)==6&(Z|0)==6?1156:0;I=88;break a}break}default:{f[i>>2]=0;ba=i+4|0;f[ba>>2]=0;ca=tT(i,57)|0;n=ca;o=216901;p=n+57|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));dR(-210,i,216805,1111)}}}else{if(e){C=(r|0)==0;if(C&(Z|0)==4){$=1177;break}t=(Z|0)==5;if(C&t){$=1178;break}x=(Z|0)==6;if(C&x){$=1179;break}C=(r|0)==2;if(C&t){$=1180;break}if(C&x){$=1181;break}C=(r|0)==3;if(C&t){$=1182;break}if(C&x){$=1183;break}C=(r|0)==5;if(C&t){$=1184;break}if(C&x){$=1185;break}else{aa=(r|0)==6&x?1157:0;I=88;break}}switch(_|0){case 2:{if(!(Z|r)){$=1186;break a}if((r|0)==2&(Z|0)==2){$=1187;break a}if((r|0)==3&(Z|0)==3){$=1188;break a}if((r|0)==5&(Z|0)==5){$=1189;break a}else{aa=(r|0)==6&(Z|0)==6?1158:0;I=88;break a}break}case 3:{if(!(Z|r)){$=1190;break a}if((r|0)==2&(Z|0)==2){$=1191;break a}if((r|0)==3&(Z|0)==3){$=1192;break a}if((r|0)==5&(Z|0)==5){$=1193;break a}else{aa=(r|0)==6&(Z|0)==6?1159:0;I=88;break a}break}default:{f[i>>2]=0;ba=i+4|0;f[ba>>2]=0;ca=tT(i,57)|0;n=ca;o=216901;p=n+57|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));dR(-210,i,216805,1111)}}}while(0);if((I|0)==88)if(!aa){f[i>>2]=0;ba=i+4|0;f[ba>>2]=0;ca=tT(i,57)|0;n=ca;o=216901;p=n+57|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));dR(-210,i,216805,1111)}else $=aa;mi[$&2047](k,m);if(w){w=i+8|0;f[w>>2]=0;f[w+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;LZ(m,i,f[M>>2]&4095,1.0/+((a?f[K>>2]|0:f[J>>2]|0)|0),0.0)}J=f[V>>2]|0;if(J|0?(K=J+12|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0)_S(m);f[V>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[c>>2]|0)>0){E=f[X>>2]|0;X=0;do{f[E+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[c>>2]|0))}c=f[S>>2]|0;if((c|0)!=(T|0))g0(c);c=f[W>>2]|0;if(c|0?(T=c+12|0,c=f[T>>2]|0,f[T>>2]=c+-1,(c|0)==1):0)_S(l);f[W>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[N>>2]|0)>0){Q=f[l+40>>2]|0;W=0;do{f[Q+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[N>>2]|0))}N=f[l+44>>2]|0;if((N|0)!=(l+48|0))g0(N);N=k+36|0;l=f[N>>2]|0;if(l|0?(W=l+12|0,l=f[W>>2]|0,f[W>>2]=l+-1,(l|0)==1):0)_S(k);f[N>>2]=0;N=k+16|0;l=k+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[l>>2]|0)>0){N=f[k+40>>2]|0;W=0;do{f[N+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)==(k+48|0)){GQ(j);u=h;return}g0(l);GQ(j);u=h;return}function GR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=XDc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;p[r>>3]=+p[r>>3]+ +p[n+(q<<3)>>3];q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;s=0;do{t=k+(s<<3)|0;v=s|1;w=k+(v<<3)|0;x=+p[w>>3]+ +p[q+(v<<3)>>3];p[t>>3]=+p[t>>3]+ +p[q+(s<<3)>>3];p[w>>3]=x;w=s|2;t=k+(w<<3)|0;v=s|3;y=k+(v<<3)|0;x=+p[y>>3]+ +p[q+(v<<3)>>3];p[t>>3]=+p[t>>3]+ +p[q+(w<<3)>>3];p[y>>3]=x;s=s+4|0}while((s|0)<=(g|0));if(n){s=o;do{y=k+(s<<3)|0;p[y>>3]=+p[y>>3]+ +p[q+(s<<3)>>3];s=s+1|0}while((s|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}ZDc(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function HR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=XDc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;s=+p[r>>3];t=+p[n+(q<<3)>>3];p[r>>3]=s<t?t:s;q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;v=0;do{w=k+(v<<3)|0;s=+p[w>>3];t=+p[q+(v<<3)>>3];x=v|1;y=k+(x<<3)|0;z=+p[y>>3];A=+p[q+(x<<3)>>3];p[w>>3]=s<t?t:s;p[y>>3]=z<A?A:z;y=v|2;w=k+(y<<3)|0;z=+p[w>>3];A=+p[q+(y<<3)>>3];y=v|3;x=k+(y<<3)|0;s=+p[x>>3];t=+p[q+(y<<3)>>3];p[w>>3]=z<A?A:z;p[x>>3]=s<t?t:s;v=v+4|0}while((v|0)<=(g|0));if(n){v=o;do{x=k+(v<<3)|0;s=+p[x>>3];t=+p[q+(v<<3)>>3];p[x>>3]=s<t?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}ZDc(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function IR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=XDc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;s=+p[r>>3];t=+p[n+(q<<3)>>3];p[r>>3]=t<s?t:s;q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;v=0;do{w=k+(v<<3)|0;s=+p[w>>3];t=+p[q+(v<<3)>>3];x=v|1;y=k+(x<<3)|0;z=+p[y>>3];A=+p[q+(x<<3)>>3];p[w>>3]=t<s?t:s;p[y>>3]=A<z?A:z;y=v|2;w=k+(y<<3)|0;z=+p[w>>3];A=+p[q+(y<<3)>>3];y=v|3;x=k+(y<<3)|0;s=+p[x>>3];t=+p[q+(y<<3)>>3];p[w>>3]=A<z?A:z;p[x>>3]=t<s?t:s;v=v+4|0}while((v|0)<=(g|0));if(n){v=o;do{x=k+(v<<3)|0;s=+p[x>>3];t=+p[q+(v<<3)>>3];p[x>>3]=t<s?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}ZDc(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function JR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=u;x=j;while(1){y=w+ +p[r+(x+t<<3)>>3];x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;p[s+(t<<3)>>3]=v+z;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{w=+p[r+(A+e<<3)>>3];y=+p[r+(A<<3)>>3];t=j;do{x=t+A|0;y=y+ +p[r+(x<<3)>>3]+ +p[r+(x+j<<3)>>3];w=w+ +p[r+(x+e<<3)>>3]+ +p[r+(x+n<<3)>>3];t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=y;x=t;while(1){u=v+ +p[r+(x+A<<3)>>3];x=x+e|0;if((x|0)>=(g|0)){B=u;break}else v=u}}else B=y;p[s+(A<<3)>>3]=w+B;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function KR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=j;x=u;while(1){y=+p[r+(w+t<<3)>>3];z=x<y?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;p[s+(t<<3)>>3]=A<v?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+p[r+(B+e<<3)>>3];z=+p[r+(B<<3)>>3];t=j;do{w=t+B|0;y=+p[r+(w<<3)>>3];C=z<y?y:z;y=+p[r+(w+e<<3)>>3];D=x<y?y:x;y=+p[r+(w+j<<3)>>3];z=C<y?y:C;C=+p[r+(w+n<<3)>>3];x=D<C?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+p[r+(w+B<<3)>>3];D=v<u?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;p[s+(B<<3)>>3]=E<x?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function LR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=j;x=u;while(1){y=+p[r+(w+t<<3)>>3];z=y<x?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;p[s+(t<<3)>>3]=v<A?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+p[r+(B+e<<3)>>3];z=+p[r+(B<<3)>>3];t=j;do{w=t+B|0;y=+p[r+(w<<3)>>3];C=y<z?y:z;y=+p[r+(w+e<<3)>>3];D=y<x?y:x;y=+p[r+(w+j<<3)>>3];z=y<C?y:C;C=+p[r+(w+n<<3)>>3];x=C<D?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+p[r+(w+B<<3)>>3];D=u<v?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;p[s+(B<<3)>>3]=x<E?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function MR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=j;x=u;while(1){y=+n[r+(w+t<<2)>>2];z=y<x?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;n[s+(t<<2)>>2]=v<A?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+n[r+(B+e<<2)>>2];z=+n[r+(B<<2)>>2];t=j;do{w=t+B|0;y=+n[r+(w<<2)>>2];C=y<z?y:z;y=+n[r+(w+e<<2)>>2];D=y<x?y:x;y=+n[r+(w+j<<2)>>2];z=y<C?y:C;C=+n[r+(w+o<<2)>>2];x=C<D?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+n[r+(w+B<<2)>>2];D=u<v?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;n[s+(B<<2)>>2]=x<E?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function NR(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=y<<16>>16<x<<16>>16?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=v<<16>>16<A<<16>>16?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=y<<16>>16<x<<16>>16?y:x;y=d[r+(z+g<<1)>>1]|0;D=y<<16>>16<t<<16>>16?y:t;y=d[r+(z+k<<1)>>1]|0;x=y<<16>>16<C<<16>>16?y:C;C=d[r+(z+o<<1)>>1]|0;t=C<<16>>16<D<<16>>16?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=D<<16>>16<u<<16>>16?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=t<<16>>16<E<<16>>16?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function OR(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=(y&65535)<(x&65535)?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=(v&65535)<(A&65535)?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=(y&65535)<(x&65535)?y:x;y=d[r+(z+g<<1)>>1]|0;D=(y&65535)<(t&65535)?y:t;y=d[r+(z+k<<1)>>1]|0;x=(y&65535)<(C&65535)?y:C;C=d[r+(z+o<<1)>>1]|0;t=(C&65535)<(D&65535)?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=(D&65535)<(u&65535)?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=(t&65535)<(E&65535)?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function PR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a+40>>2]|0;e=f[d>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;i=Y(g,f[d+4>>2]|0)|0;if((e|0)<=0)return;d=a+16|0;j=a+44|0;a=c+16|0;k=c+44|0;c=(i|0)==(g|0);l=g<<1;m=g<<2;n=i-m|0;o=(l|0)>(n|0);p=g*3|0;q=(l|0)<(i|0);r=0;do{s=(f[d>>2]|0)+(Y(f[f[j>>2]>>2]|0,r)|0)|0;t=(f[a>>2]|0)+(Y(f[f[k>>2]>>2]|0,r)|0)|0;a:do if(c){u=0;do{b[t+u>>0]=b[s+u>>0]|0;u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=b[s+u>>0]|0;w=b[s+(u+g)>>0]|0;if(q){x=v;y=l;while(1){z=x&255;A=z-(h[221118+((z|256)-(h[s+(y+u)>>0]|0))>>0]|0)&255;y=y+g|0;if((y|0)>=(i|0)){B=A;break}else x=A}}else B=v;x=B&255;b[t+u>>0]=x-(h[221118+((x|256)-(w&255))>>0]|0);u=u+1|0;if((u|0)==(g|0))break a}}else C=0;do{u=b[s+(C+g)>>0]|0;x=b[s+C>>0]|0;y=l;while(1){A=y+C|0;z=x&255;D=z-(h[221118+((z|256)-(h[s+A>>0]|0))>>0]|0)|0;z=u&255;E=z-(h[221118+((z|256)-(h[s+(A+g)>>0]|0))>>0]|0)|0;F=D-(h[221118+((D&255|256)-(h[s+(A+l)>>0]|0))>>0]|0)|0;G=E-(h[221118+((E&255|256)-(h[s+(A+p)>>0]|0))>>0]|0)|0;y=y+m|0;if((y|0)>(n|0))break;else{u=G&255;x=F&255}}if((y|0)<(i|0)){x=F;u=y;while(1){w=x&255;v=w-(h[221118+((w|256)-(h[s+(u+C)>>0]|0))>>0]|0)|0;u=u+g|0;if((u|0)>=(i|0)){H=v;break}else x=v}}else H=F;b[t+C>>0]=H-(h[221118+((H&255|256)-(G&255))>>0]|0);C=C+1|0}while((C|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function QR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=j;x=u;while(1){y=+n[r+(w+t<<2)>>2];z=x<y?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;n[s+(t<<2)>>2]=A<v?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+n[r+(B+e<<2)>>2];z=+n[r+(B<<2)>>2];t=j;do{w=t+B|0;y=+n[r+(w<<2)>>2];C=z<y?y:z;y=+n[r+(w+e<<2)>>2];D=x<y?y:x;y=+n[r+(w+j<<2)>>2];z=C<y?y:C;C=+n[r+(w+o<<2)>>2];x=D<C?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+n[r+(w+B<<2)>>2];D=v<u?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;n[s+(B<<2)>>2]=E<x?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function RR(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=x<<16>>16<y<<16>>16?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=A<<16>>16<v<<16>>16?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=x<<16>>16<y<<16>>16?y:x;y=d[r+(z+g<<1)>>1]|0;D=t<<16>>16<y<<16>>16?y:t;y=d[r+(z+k<<1)>>1]|0;x=C<<16>>16<y<<16>>16?y:C;C=d[r+(z+o<<1)>>1]|0;t=D<<16>>16<C<<16>>16?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=u<<16>>16<D<<16>>16?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=E<<16>>16<t<<16>>16?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function SR(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=(x&65535)<(y&65535)?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=(A&65535)<(v&65535)?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=(x&65535)<(y&65535)?y:x;y=d[r+(z+g<<1)>>1]|0;D=(t&65535)<(y&65535)?y:t;y=d[r+(z+k<<1)>>1]|0;x=(C&65535)<(y&65535)?y:C;C=d[r+(z+o<<1)>>1]|0;t=(D&65535)<(C&65535)?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=(u&65535)<(D&65535)?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=(E&65535)<(t&65535)?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function TR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a+40>>2]|0;e=f[d>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;i=Y(g,f[d+4>>2]|0)|0;if((e|0)<=0)return;d=a+16|0;j=a+44|0;a=c+16|0;k=c+44|0;c=(i|0)==(g|0);l=g<<1;m=g<<2;n=i-m|0;o=(l|0)>(n|0);p=g*3|0;q=(l|0)<(i|0);r=0;do{s=(f[d>>2]|0)+(Y(f[f[j>>2]>>2]|0,r)|0)|0;t=(f[a>>2]|0)+(Y(f[f[k>>2]>>2]|0,r)|0)|0;a:do if(c){u=0;do{b[t+u>>0]=b[s+u>>0]|0;u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=b[s+u>>0]|0;w=b[s+(u+g)>>0]|0;if(q){x=v;y=l;while(1){z=x&255;A=(h[221118+(256-z+(h[s+(y+u)>>0]|0))>>0]|0)+z&255;y=y+g|0;if((y|0)>=(i|0)){B=A;break}else x=A}}else B=v;x=B&255;b[t+u>>0]=(h[221118+((w&255|256)-x)>>0]|0)+x;u=u+1|0;if((u|0)==(g|0))break a}}else C=0;do{u=b[s+(C+g)>>0]|0;x=b[s+C>>0]|0;y=l;while(1){A=y+C|0;z=x&255;D=(h[221118+(256-z+(h[s+A>>0]|0))>>0]|0)+z|0;z=u&255;E=(h[221118+(256-z+(h[s+(A+g)>>0]|0))>>0]|0)+z|0;F=(h[221118+(256-(D&255)+(h[s+(A+l)>>0]|0))>>0]|0)+D|0;G=(h[221118+(256-(E&255)+(h[s+(A+p)>>0]|0))>>0]|0)+E|0;y=y+m|0;if((y|0)>(n|0))break;else{u=G&255;x=F&255}}if((y|0)<(i|0)){x=F;u=y;while(1){w=x&255;v=(h[221118+(256-w+(h[s+(u+C)>>0]|0))>>0]|0)+w|0;u=u+g|0;if((u|0)>=(i|0)){H=v;break}else x=v}}else H=F;b[t+C>>0]=(h[221118+((G&255|256)-(H&255))>>0]|0)+H;C=C+1|0}while((C|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function UR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;q=(j|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+n[s+(u<<2)>>2];u=u+1|0}while((u|0)!=(e|0))}else{if(m){u=0;while(1){v=+n[s+(u<<2)>>2];w=+n[s+(u+e<<2)>>2];if(q){x=v;y=j;while(1){z=x+ +n[s+(y+u<<2)>>2];y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+n[s+(B+e<<2)>>2];z=+n[s+(B<<2)>>2];u=j;do{y=u+B|0;z=z+ +n[s+(y<<2)>>2]+ +n[s+(y+j<<2)>>2];x=x+ +n[s+(y+e<<2)>>2]+ +n[s+(y+o<<2)>>2];u=u+k|0}while((u|0)<=(l|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +n[s+(y+B<<2)>>2];y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function VR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=u;x=j;while(1){y=w+ +n[r+(x+t<<2)>>2];x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;n[s+(t<<2)>>2]=v+z;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{w=+n[r+(A+e<<2)>>2];y=+n[r+(A<<2)>>2];t=j;do{x=t+A|0;y=y+ +n[r+(x<<2)>>2]+ +n[r+(x+j<<2)>>2];w=w+ +n[r+(x+e<<2)>>2]+ +n[r+(x+o<<2)>>2];t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=y;x=t;while(1){u=v+ +n[r+(x+A<<2)>>2];x=x+e|0;if((x|0)>=(g|0)){B=u;break}else v=u}}else B=y;n[s+(A<<2)>>2]=w+B;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function WR(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;q=(k|0)<(h|0);r=0;do{s=c+(Y(i,r)|0)|0;t=a+(Y(j,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(g|0))}else{if(n){u=0;while(1){v=+(d[s+(u<<1)>>1]|0);w=+(d[s+(u+g<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(d[s+(y+u<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(g|0))break a}}else B=0;do{x=+(d[s+(B+g<<1)>>1]|0);z=+(d[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(d[s+(y<<1)>>1]|0)+ +(d[s+(y+k<<1)>>1]|0);x=x+ +(d[s+(y+g<<1)>>1]|0)+ +(d[s+(y+o<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(h|0)){w=z;y=u;while(1){v=w+ +(d[s+(y+B<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function XR(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;o=(k|0)>(m|0);p=g*3|0;q=(k|0)<(h|0);r=0;do{s=c+(Y(i,r)|0)|0;t=a+(Y(j,r)|0)|0;a:do if(b){u=0;do{n[t+(u<<2)>>2]=+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=+(d[s+(u<<1)>>1]|0);w=+(d[s+(u+g<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(d[s+(y+u<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=w+A;u=u+1|0;if((u|0)==(g|0))break a}}else B=0;do{x=+(d[s+(B+g<<1)>>1]|0);z=+(d[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(d[s+(y<<1)>>1]|0)+ +(d[s+(y+k<<1)>>1]|0);x=x+ +(d[s+(y+g<<1)>>1]|0)+ +(d[s+(y+p<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(h|0)){w=z;y=u;while(1){v=w+ +(d[s+(y+B<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){C=v;break}else w=v}}else C=z;n[t+(B<<2)>>2]=x+C;B=B+1|0}while((B|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function YR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);k=e<<1;l=e<<2;m=g-l|0;n=(k|0)>(m|0);o=e*3|0;q=(k|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(n){u=0;while(1){v=+(j[s+(u<<1)>>1]|0);w=+(j[s+(u+e<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(j[s+(y+u<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+(j[s+(B+e<<1)>>1]|0);z=+(j[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(j[s+(y<<1)>>1]|0)+ +(j[s+(y+k<<1)>>1]|0);x=x+ +(j[s+(y+e<<1)>>1]|0)+ +(j[s+(y+o<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +(j[s+(y+B<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function ZR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);k=e<<1;l=e<<2;m=g-l|0;o=(k|0)>(m|0);p=e*3|0;q=(k|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{n[t+(u<<2)>>2]=+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(o){u=0;while(1){v=+(j[s+(u<<1)>>1]|0);w=+(j[s+(u+e<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(j[s+(y+u<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+(j[s+(B+e<<1)>>1]|0);z=+(j[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(j[s+(y<<1)>>1]|0)+ +(j[s+(y+k<<1)>>1]|0);x=x+ +(j[s+(y+e<<1)>>1]|0)+ +(j[s+(y+p<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +(j[s+(y+B<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;n[t+(B<<2)>>2]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function _R(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;n=f[a+16>>2]|0;o=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;q=f[f[b+44>>2]>>2]|0;b=(i|0)<(g|0);r=0;do{s=n+(Y(o,r)|0)|0;t=a+(Y(q,r)|0)|0;a:do if(c){u=0;do{p[t+(u<<3)>>3]=+(h[s+u>>0]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(l){u=0;while(1){v=h[s+u>>0]|0;w=h[s+(u+e)>>0]|0;if(b){x=v;y=i;while(1){z=(h[s+(y+u)>>0]|0)+x|0;y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=+(A+w|0);u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{u=h[s+(B+e)>>0]|0;x=h[s+B>>0]|0;y=i;do{z=y+B|0;x=(h[s+z>>0]|0)+x+(h[s+(z+i)>>0]|0)|0;u=(h[s+(z+e)>>0]|0)+u+(h[s+(z+m)>>0]|0)|0;y=y+j|0}while((y|0)<=(k|0));if((y|0)<(g|0)){w=x;v=y;while(1){z=(h[s+(v+B)>>0]|0)+w|0;v=v+e|0;if((v|0)>=(g|0)){C=z;break}else w=z}}else C=x;p[t+(B<<3)>>3]=+(C+u|0);B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function $R(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;o=f[a+16>>2]|0;p=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;q=f[f[b+44>>2]>>2]|0;b=(i|0)<(g|0);r=0;do{s=o+(Y(p,r)|0)|0;t=a+(Y(q,r)|0)|0;a:do if(c){u=0;do{n[t+(u<<2)>>2]=+(h[s+u>>0]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(l){u=0;while(1){v=h[s+u>>0]|0;w=h[s+(u+e)>>0]|0;if(b){x=v;y=i;while(1){z=(h[s+(y+u)>>0]|0)+x|0;y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=+(A+w|0);u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{u=h[s+(B+e)>>0]|0;x=h[s+B>>0]|0;y=i;do{z=y+B|0;x=(h[s+z>>0]|0)+x+(h[s+(z+i)>>0]|0)|0;u=(h[s+(z+e)>>0]|0)+u+(h[s+(z+m)>>0]|0)|0;y=y+j|0}while((y|0)<=(k|0));if((y|0)<(g|0)){w=x;v=y;while(1){z=(h[s+(v+B)>>0]|0)+w|0;v=v+e|0;if((v|0)>=(g|0)){C=z;break}else w=z}}else C=x;n[t+(B<<2)>>2]=+(C+u|0);B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function aS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;n=f[a+16>>2]|0;o=f[a+44>>2]|0;a=f[b+16>>2]|0;p=f[b+44>>2]|0;b=(i|0)<(g|0);q=0;do{r=n+(Y(f[o>>2]|0,q)|0)|0;s=a+(Y(f[p>>2]|0,q)|0)|0;a:do if(c){t=0;do{f[s+(t<<2)>>2]=h[r+t>>0];t=t+1|0}while((t|0)!=(e|0))}else{if(l){t=0;while(1){u=h[r+t>>0]|0;v=h[r+(t+e)>>0]|0;if(b){w=u;x=i;while(1){y=(h[r+(x+t)>>0]|0)+w|0;x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;f[s+(t<<2)>>2]=z+v;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{t=h[r+(A+e)>>0]|0;w=h[r+A>>0]|0;x=i;do{y=x+A|0;w=(h[r+y>>0]|0)+w+(h[r+(y+i)>>0]|0)|0;t=(h[r+(y+e)>>0]|0)+t+(h[r+(y+m)>>0]|0)|0;x=x+j|0}while((x|0)<=(k|0));if((x|0)<(g|0)){v=w;u=x;while(1){y=(h[r+(u+A)>>0]|0)+v|0;u=u+e|0;if((u|0)>=(g|0)){B=y;break}else v=y}}else B=w;f[s+(A<<2)>>2]=B+t;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function bS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=XDc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;s=+n[r>>2];t=+n[o+(q<<2)>>2];n[r>>2]=t<s?t:s;q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;v=0;do{w=k+(v<<2)|0;s=+n[w>>2];t=+n[q+(v<<2)>>2];x=v|1;y=k+(x<<2)|0;z=+n[y>>2];A=+n[q+(x<<2)>>2];n[w>>2]=t<s?t:s;n[y>>2]=A<z?A:z;y=v|2;w=k+(y<<2)|0;z=+n[w>>2];A=+n[q+(y<<2)>>2];y=v|3;x=k+(y<<2)|0;s=+n[x>>2];t=+n[q+(y<<2)>>2];n[w>>2]=A<z?A:z;n[x>>2]=t<s?t:s;v=v+4|0}while((v|0)<=(g|0));if(o){v=p;do{x=k+(v<<2)|0;s=+n[x>>2];t=+n[q+(v<<2)>>2];n[x>>2]=t<s?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}ZDc(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function cS(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=XDc(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=t<<16>>16<s<<16>>16?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=w<<16>>16<v<<16>>16?w:v;d[y>>1]=A<<16>>16<z<<16>>16?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=v<<16>>16<y<<16>>16?v:y;d[w>>1]=x<<16>>16<r<<16>>16?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=w<<16>>16<x<<16>>16?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}ZDc(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function dS(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=XDc(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=(t&65535)<(s&65535)?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=(w&65535)<(v&65535)?w:v;d[y>>1]=(A&65535)<(z&65535)?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=(v&65535)<(y&65535)?v:y;d[w>>1]=(x&65535)<(r&65535)?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=(w&65535)<(x&65535)?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}ZDc(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function eS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+1040|0;e=d;g=f[a+40>>2]|0;i=f[g>>2]|0;j=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=XDc(j)|0;f[e>>2]=l;m=l}else m=g;l=f[c+16>>2]|0;c=f[a+16>>2]|0;n=f[a+48>>2]|0;a=(j|0)>0;if(a){o=0;do{b[m+o>>0]=b[c+o>>0]|0;o=o+1|0}while((o|0)!=(j|0))}o=i+-1|0;a:do if(o|0){i=j+-4|0;if((j|0)<4){p=c;q=o;while(1){p=p+n|0;if(a){r=0;do{s=m+r|0;t=h[s>>0]|0;b[s>>0]=t-(h[221118+((t|256)-(h[p+r>>0]|0))>>0]|0);r=r+1|0}while((r|0)!=(j|0))}q=q+-1|0;if(!q)break a}}q=j&-4;p=(q|0)<(j|0);r=c;t=o;do{r=r+n|0;s=0;do{v=m+s|0;w=h[v>>0]|0;x=s|1;y=m+x|0;z=h[y>>0]|0;A=z-(h[221118+((z|256)-(h[r+x>>0]|0))>>0]|0)&255;b[v>>0]=w-(h[221118+((w|256)-(h[r+s>>0]|0))>>0]|0);b[y>>0]=A;A=s|2;y=m+A|0;w=h[y>>0]|0;v=s|3;x=m+v|0;z=h[x>>0]|0;B=z-(h[221118+((z|256)-(h[r+v>>0]|0))>>0]|0)&255;b[y>>0]=w-(h[221118+((w|256)-(h[r+A>>0]|0))>>0]|0);b[x>>0]=B;s=s+4|0}while((s|0)<=(i|0));if(p){s=q;do{B=m+s|0;x=h[B>>0]|0;b[B>>0]=x-(h[221118+((x|256)-(h[r+s>>0]|0))>>0]|0);s=s+1|0}while((s|0)!=(j|0))}t=t+-1|0}while((t|0)!=0)}while(0);if(a){a=0;do{b[l+a>>0]=b[m+a>>0]|0;a=a+1|0}while((a|0)!=(j|0));C=f[e>>2]|0}else C=m;if((C|0)==(g|0)){u=d;return}if(C|0)ZDc(C);f[e>>2]=g;f[k>>2]=1032;u=d;return}function fS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=XDc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;s=+n[r>>2];t=+n[o+(q<<2)>>2];n[r>>2]=s<t?t:s;q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;v=0;do{w=k+(v<<2)|0;s=+n[w>>2];t=+n[q+(v<<2)>>2];x=v|1;y=k+(x<<2)|0;z=+n[y>>2];A=+n[q+(x<<2)>>2];n[w>>2]=s<t?t:s;n[y>>2]=z<A?A:z;y=v|2;w=k+(y<<2)|0;z=+n[w>>2];A=+n[q+(y<<2)>>2];y=v|3;x=k+(y<<2)|0;s=+n[x>>2];t=+n[q+(y<<2)>>2];n[w>>2]=z<A?A:z;n[x>>2]=s<t?t:s;v=v+4|0}while((v|0)<=(g|0));if(o){v=p;do{x=k+(v<<2)|0;s=+n[x>>2];t=+n[q+(v<<2)>>2];n[x>>2]=s<t?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}ZDc(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function gS(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=XDc(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=s<<16>>16<t<<16>>16?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=v<<16>>16<w<<16>>16?w:v;d[y>>1]=z<<16>>16<A<<16>>16?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=y<<16>>16<v<<16>>16?v:y;d[w>>1]=r<<16>>16<x<<16>>16?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=x<<16>>16<w<<16>>16?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}ZDc(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function hS(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=XDc(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=(s&65535)<(t&65535)?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=(v&65535)<(w&65535)?w:v;d[y>>1]=(z&65535)<(A&65535)?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=(y&65535)<(v&65535)?v:y;d[w>>1]=(r&65535)<(x&65535)?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=(x&65535)<(w&65535)?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}ZDc(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function iS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+1040|0;e=d;g=f[a+40>>2]|0;i=f[g>>2]|0;j=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=XDc(j)|0;f[e>>2]=l;m=l}else m=g;l=f[c+16>>2]|0;c=f[a+16>>2]|0;n=f[a+48>>2]|0;a=(j|0)>0;if(a){o=0;do{b[m+o>>0]=b[c+o>>0]|0;o=o+1|0}while((o|0)!=(j|0))}o=i+-1|0;a:do if(o|0){i=j+-4|0;if((j|0)<4){p=c;q=o;while(1){p=p+n|0;if(a){r=0;do{s=m+r|0;t=h[s>>0]|0;b[s>>0]=(h[221118+(256-t+(h[p+r>>0]|0))>>0]|0)+t;r=r+1|0}while((r|0)!=(j|0))}q=q+-1|0;if(!q)break a}}q=j&-4;p=(q|0)<(j|0);r=c;t=o;do{r=r+n|0;s=0;do{v=m+s|0;w=h[v>>0]|0;x=s|1;y=m+x|0;z=h[y>>0]|0;A=(h[221118+(256-z+(h[r+x>>0]|0))>>0]|0)+z&255;b[v>>0]=(h[221118+(256-w+(h[r+s>>0]|0))>>0]|0)+w;b[y>>0]=A;A=s|2;y=m+A|0;w=h[y>>0]|0;v=s|3;z=m+v|0;x=h[z>>0]|0;B=(h[221118+(256-x+(h[r+v>>0]|0))>>0]|0)+x&255;b[y>>0]=(h[221118+(256-w+(h[r+A>>0]|0))>>0]|0)+w;b[z>>0]=B;s=s+4|0}while((s|0)<=(i|0));if(p){s=q;do{B=m+s|0;z=h[B>>0]|0;b[B>>0]=(h[221118+(256-z+(h[r+s>>0]|0))>>0]|0)+z;s=s+1|0}while((s|0)!=(j|0))}t=t+-1|0}while((t|0)!=0)}while(0);if(a){a=0;do{b[l+a>>0]=b[m+a>>0]|0;a=a+1|0}while((a|0)!=(j|0));C=f[e>>2]|0}else C=m;if((C|0)==(g|0)){u=d;return}if(C|0)ZDc(C);f[e>>2]=g;f[k>>2]=1032;u=d;return}function jS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=XDc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+n[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;q=m;while(1){o=o+(l<<2)|0;if(a){r=0;do{s=k+(r<<3)|0;p[s>>3]=+p[s>>3]+ +n[o+(r<<2)>>2];r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;o=(q|0)<(h|0);r=b;s=m;do{r=r+(l<<2)|0;t=0;do{v=k+(t<<3)|0;w=t|1;x=k+(w<<3)|0;y=+p[x>>3]+ +n[r+(w<<2)>>2];p[v>>3]=+p[v>>3]+ +n[r+(t<<2)>>2];p[x>>3]=y;x=t|2;v=k+(x<<3)|0;w=t|3;z=k+(w<<3)|0;y=+p[z>>3]+ +n[r+(w<<2)>>2];p[v>>3]=+p[v>>3]+ +n[r+(x<<2)>>2];p[z>>3]=y;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=k+(t<<3)|0;p[z>>3]=+p[z>>3]+ +n[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}ZDc(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function kS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=XDc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;n[r>>2]=+n[r>>2]+ +n[o+(q<<2)>>2];q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;s=0;do{t=k+(s<<2)|0;v=s|1;w=k+(v<<2)|0;x=+n[w>>2]+ +n[q+(v<<2)>>2];n[t>>2]=+n[t>>2]+ +n[q+(s<<2)>>2];n[w>>2]=x;w=s|2;t=k+(w<<2)|0;v=s|3;y=k+(v<<2)|0;x=+n[y>>2]+ +n[q+(v<<2)>>2];n[t>>2]=+n[t>>2]+ +n[q+(w<<2)>>2];n[y>>2]=x;s=s+4|0}while((s|0)<=(g|0));if(o){s=p;do{y=k+(s<<2)|0;n[y>>2]=+n[y>>2]+ +n[q+(s<<2)>>2];s=s+1|0}while((s|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}ZDc(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function lS(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>136){k=XDc(i>>>0>536870911?-1:i<<3)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{p[l+(n<<3)>>3]=+(d[b+(n<<1)>>1]|0);n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;q=n;while(1){o=o+(m<<1)|0;if(a){r=0;do{s=l+(r<<3)|0;p[s>>3]=+p[s>>3]+ +(d[o+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;o=(q|0)<(i|0);r=b;s=n;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<3)|0;w=t|1;x=l+(w<<3)|0;y=+p[x>>3]+ +(d[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(d[r+(t<<1)>>1]|0);p[x>>3]=y;x=t|2;v=l+(x<<3)|0;w=t|3;z=l+(w<<3)|0;y=+p[z>>3]+ +(d[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(d[r+(x<<1)>>1]|0);p[z>>3]=y;t=t+4|0}while((t|0)<=(h|0));if(o){t=q;do{z=l+(t<<3)|0;p[z>>3]=+p[z>>3]+ +(d[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}ZDc(l);f[e>>2]=g;f[j>>2]=136;u=c;return}function mS(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1072|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>264){k=XDc(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){o=0;do{n[l+(o<<2)>>2]=+(d[b+(o<<1)>>1]|0);o=o+1|0}while((o|0)!=(i|0))}o=h+-1|0;a:do if(o|0){h=i+-4|0;if((i|0)<4){p=b;q=o;while(1){p=p+(m<<1)|0;if(a){r=0;do{s=l+(r<<2)|0;n[s>>2]=+n[s>>2]+ +(d[p+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;p=(q|0)<(i|0);r=b;s=o;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=+n[x>>2]+ +(d[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(d[r+(t<<1)>>1]|0);n[x>>2]=y;x=t|2;v=l+(x<<2)|0;w=t|3;z=l+(w<<2)|0;y=+n[z>>2]+ +(d[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(d[r+(x<<1)>>1]|0);n[z>>2]=y;t=t+4|0}while((t|0)<=(h|0));if(p){t=q;do{z=l+(t<<2)|0;n[z>>2]=+n[z>>2]+ +(d[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}ZDc(l);f[e>>2]=g;f[j>>2]=264;u=c;return}function nS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){k=XDc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(h|0)>0;if(a){n=0;do{p[l+(n<<3)>>3]=+(j[b+(n<<1)>>1]|0);n=n+1|0}while((n|0)!=(h|0))}n=g+-1|0;a:do if(n|0){g=h+-4|0;if((h|0)<4){o=b;q=n;while(1){o=o+(m<<1)|0;if(a){r=0;do{s=l+(r<<3)|0;p[s>>3]=+p[s>>3]+ +(j[o+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;o=(q|0)<(h|0);r=b;s=n;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<3)|0;w=t|1;x=l+(w<<3)|0;y=+p[x>>3]+ +(j[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[r+(t<<1)>>1]|0);p[x>>3]=y;x=t|2;v=l+(x<<3)|0;w=t|3;z=l+(w<<3)|0;y=+p[z>>3]+ +(j[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[r+(x<<1)>>1]|0);p[z>>3]=y;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=l+(t<<3)|0;p[z>>3]=+p[z>>3]+ +(j[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((l|0)==(e|0)){u=c;return}ZDc(l);f[d>>2]=e;f[i>>2]=136;u=c;return}function oS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){k=XDc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(h|0)>0;if(a){o=0;do{n[l+(o<<2)>>2]=+(j[b+(o<<1)>>1]|0);o=o+1|0}while((o|0)!=(h|0))}o=g+-1|0;a:do if(o|0){g=h+-4|0;if((h|0)<4){p=b;q=o;while(1){p=p+(m<<1)|0;if(a){r=0;do{s=l+(r<<2)|0;n[s>>2]=+n[s>>2]+ +(j[p+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;p=(q|0)<(h|0);r=b;s=o;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=+n[x>>2]+ +(j[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(j[r+(t<<1)>>1]|0);n[x>>2]=y;x=t|2;v=l+(x<<2)|0;w=t|3;z=l+(w<<2)|0;y=+n[z>>2]+ +(j[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(j[r+(x<<1)>>1]|0);n[z>>2]=y;t=t+4|0}while((t|0)<=(g|0));if(p){t=q;do{z=l+(t<<2)|0;n[z>>2]=+n[z>>2]+ +(j[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((l|0)==(e|0)){u=c;return}ZDc(l);f[d>>2]=e;f[i>>2]=264;u=c;return}function pS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=XDc(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){n=0;do{f[l+(n<<2)>>2]=h[b+n>>0];n=n+1|0}while((n|0)!=(i|0))}n=g+-1|0;a:do if(n|0){g=i+-4|0;if((i|0)<4){o=b;q=n;while(1){o=o+m|0;if(a){r=0;do{s=l+(r<<2)|0;f[s>>2]=(h[o+r>>0]|0)+(f[s>>2]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;o=(q|0)<(i|0);r=b;s=n;do{r=r+m|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=(h[r+w>>0]|0)+(f[x>>2]|0)|0;f[v>>2]=(h[r+t>>0]|0)+(f[v>>2]|0);f[x>>2]=y;y=t|2;x=l+(y<<2)|0;v=t|3;w=l+(v<<2)|0;z=(h[r+v>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(h[r+y>>0]|0)+(f[x>>2]|0);f[w>>2]=z;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=l+(t<<2)|0;f[z>>2]=(h[r+t>>0]|0)+(f[z>>2]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}ZDc(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function qS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=XDc(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){o=0;do{f[l+(o<<2)>>2]=h[b+o>>0];o=o+1|0}while((o|0)!=(i|0))}o=g+-1|0;a:do if(o|0){g=i+-4|0;if((i|0)<4){p=b;q=o;while(1){p=p+m|0;if(a){r=0;do{s=l+(r<<2)|0;f[s>>2]=(h[p+r>>0]|0)+(f[s>>2]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;p=(q|0)<(i|0);r=b;s=o;do{r=r+m|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=(h[r+w>>0]|0)+(f[x>>2]|0)|0;f[v>>2]=(h[r+t>>0]|0)+(f[v>>2]|0);f[x>>2]=y;y=t|2;x=l+(y<<2)|0;v=t|3;w=l+(v<<2)|0;z=(h[r+v>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(h[r+y>>0]|0)+(f[x>>2]|0);f[w>>2]=z;t=t+4|0}while((t|0)<=(g|0));if(p){t=q;do{z=l+(t<<2)|0;f[z>>2]=(h[r+t>>0]|0)+(f[z>>2]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{n[k+(a<<2)>>2]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}ZDc(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function rS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=XDc(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){n=0;do{f[l+(n<<2)>>2]=h[b+n>>0];n=n+1|0}while((n|0)!=(i|0))}n=g+-1|0;a:do if(n|0){g=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+m|0;if(a){q=0;do{r=l+(q<<2)|0;f[r>>2]=(h[o+q>>0]|0)+(f[r>>2]|0);q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;r=n;do{q=q+m|0;s=0;do{t=l+(s<<2)|0;v=s|1;w=l+(v<<2)|0;x=(h[q+v>>0]|0)+(f[w>>2]|0)|0;f[t>>2]=(h[q+s>>0]|0)+(f[t>>2]|0);f[w>>2]=x;x=s|2;w=l+(x<<2)|0;t=s|3;v=l+(t<<2)|0;y=(h[q+t>>0]|0)+(f[v>>2]|0)|0;f[w>>2]=(h[q+x>>0]|0)+(f[w>>2]|0);f[v>>2]=y;s=s+4|0}while((s|0)<=(g|0));if(o){s=p;do{y=l+(s<<2)|0;f[y>>2]=(h[q+s>>0]|0)+(f[y>>2]|0);s=s+1|0}while((s|0)!=(i|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}ZDc(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function sS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e+8|0;j=e;do if((d$(a)|0)==65536){k=f[a+4>>2]|0;f[g>>2]=f[k>>2];l=g+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=g+8|0;f[n>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=n;n=g+48|0;p=g+44|0;f[p>>2]=n;f[n>>2]=0;f[g+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];q=l;break}else{f[l>>2]=0;ZS(g,k);q=l;break}}else{a$(g,a,-1);q=g+4|0}while(0);if((f[q>>2]|0)>=3){f[h>>2]=0;r=h+4|0;f[r>>2]=0;s=tT(h,36)|0;t=s;v=216959;w=t+36|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));dR(-215,h,216996,1410)}a=f[g>>2]|0;if(a&4088|0){f[h>>2]=0;r=h+4|0;f[r>>2]=0;s=tT(h,36)|0;t=s;v=216959;w=t+36|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));dR(-215,h,216996,1410)}s=g+40|0;r=f[s>>2]|0;l=f[r>>2]|0;f[i>>2]=f[r+4>>2];f[i+4>>2]=l;v$(c,i,a&4095,-1,0,0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];i=h+4|0;l=a+4|0;f[i>>2]=f[l>>2];r=h+8|0;f[r>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];k=f[a+36>>2]|0;f[h+36>>2]=k;f[h+40>>2]=r;r=h+48|0;m=h+44|0;f[m>>2]=r;f[r>>2]=0;f[h+52>>2]=0;if(k|0){r=k+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;r=f[m>>2]|0;f[r>>2]=f[l>>2];f[r+4>>2]=f[l+4>>2];break}else{f[i>>2]=0;ZS(h,a);break}}else a$(h,c,-1);while(0);c=f[g>>2]&7;if((c|0)==7){f[j>>2]=0;f[j+4>>2]=0;t=tT(j,9)|0;v=251213;w=t+9|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));dR(-215,j,216996,1421)}Ti[f[42008+(c<<2)>>2]&511](g,h,d);d=h+36|0;c=f[d>>2]|0;if(c|0?(j=c+12|0,c=f[j>>2]|0,f[j>>2]=c+-1,(c|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;c=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[h+40>>2]|0;j=0;do{f[d+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))g0(c);c=g+36|0;h=f[c>>2]|0;if(h|0?(j=h+12|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)_S(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[s>>2]|0;s=0;do{f[c+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[g+44>>2]|0;if((q|0)==(g+48|0)){u=e;return}g0(q);u=e;return}function tS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+1056|0;g=e;h=e+8|0;i=h+8|0;f[h>>2]=i;j=h+4|0;f[j>>2]=1032;k=(d&1|0)==0;l=a+16|0;m=c+16|0;n=f[m>>2]|0;o=(f[l>>2]|0)==(n|0);p=(d&16|0)==0;d=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!k){f[j>>2]=q;if(q>>>0>1032){r=XDc(q)|0;f[h>>2]=r;s=d;t=q;v=r}else{s=d;t=q;v=i}}else{s=q;t=d;v=i}a:do if((s|0)>0){d=c+44|0;q=a+44|0;r=(t|0)>0;w=(t|0)/2|0;x=(t|0)>1;y=t+-1|0;if(k){z=p|x^1;A=0;B=n;while(1){C=B+(Y(f[f[d>>2]>>2]|0,A)|0)|0;if(!o)dJc(C|0,(f[l>>2]|0)+(Y(f[f[q>>2]>>2]|0,A)|0)|0,t|0)|0;$rc(C,C+t|0,g);if(!z){D=0;do{E=C+D|0;F=C+(y-D)|0;G=b[E>>0]|0;b[E>>0]=b[F>>0]|0;b[F>>0]=G;D=D+1|0}while((D|0)<(w|0))}D=A+1|0;if((D|0)>=(s|0))break a;A=D;B=f[m>>2]|0}}B=v+t|0;A=p|x^1;z=0;do{if(r){D=f[l>>2]|0;C=f[q>>2]|0;G=0;do{F=D+(Y(f[C>>2]|0,G)|0)+z|0;b[v+G>>0]=b[F>>0]|0;G=G+1|0}while((G|0)!=(t|0))}$rc(v,B,g);if(!A){G=0;do{C=v+G|0;D=v+(y-G)|0;F=b[C>>0]|0;b[C>>0]=b[D>>0]|0;b[D>>0]=F;G=G+1|0}while((G|0)<(w|0))}if(r){G=0;do{F=(f[m>>2]|0)+(Y(f[f[d>>2]>>2]|0,G)|0)+z|0;b[F>>0]=b[v+G>>0]|0;G=G+1|0}while((G|0)!=(t|0))}z=z+1|0}while((z|0)<(s|0))}while(0);s=f[h>>2]|0;if((s|0)==(i|0)){u=e;return}if(s|0)ZDc(s);f[h>>2]=i;f[j>>2]=1032;u=e;return}function uS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+1056|0;g=e;h=e+8|0;i=h+8|0;f[h>>2]=i;j=h+4|0;f[j>>2]=1032;k=(d&1|0)==0;l=a+16|0;m=c+16|0;n=f[m>>2]|0;o=(f[l>>2]|0)==(n|0);p=(d&16|0)==0;d=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!k){f[j>>2]=q;if(q>>>0>1032){r=XDc(q)|0;f[h>>2]=r;s=d;t=q;v=r}else{s=d;t=q;v=i}}else{s=q;t=d;v=i}a:do if((s|0)>0){d=c+44|0;q=a+44|0;r=(t|0)>0;w=(t|0)/2|0;x=(t|0)>1;y=t+-1|0;if(k){z=p|x^1;A=0;B=n;while(1){C=B+(Y(f[f[d>>2]>>2]|0,A)|0)|0;if(!o)dJc(C|0,(f[l>>2]|0)+(Y(f[f[q>>2]>>2]|0,A)|0)|0,t|0)|0;Vrc(C,C+t|0,g);if(!z){D=0;do{E=C+D|0;F=C+(y-D)|0;G=b[E>>0]|0;b[E>>0]=b[F>>0]|0;b[F>>0]=G;D=D+1|0}while((D|0)<(w|0))}D=A+1|0;if((D|0)>=(s|0))break a;A=D;B=f[m>>2]|0}}B=v+t|0;A=p|x^1;z=0;do{if(r){D=f[l>>2]|0;C=f[q>>2]|0;G=0;do{F=D+(Y(f[C>>2]|0,G)|0)+z|0;b[v+G>>0]=b[F>>0]|0;G=G+1|0}while((G|0)!=(t|0))}Vrc(v,B,g);if(!A){G=0;do{C=v+G|0;D=v+(y-G)|0;F=b[C>>0]|0;b[C>>0]=b[D>>0]|0;b[D>>0]=F;G=G+1|0}while((G|0)<(w|0))}if(r){G=0;do{F=(f[m>>2]|0)+(Y(f[f[d>>2]>>2]|0,G)|0)+z|0;b[F>>0]=b[v+G>>0]|0;G=G+1|0}while((G|0)!=(t|0))}z=z+1|0}while((z|0)<(s|0))}while(0);s=f[h>>2]|0;if((s|0)==(i|0)){u=e;return}if(s|0)ZDc(s);f[h>>2]=i;f[j>>2]=1032;u=e;return}function vS(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+1056|0;g=e;h=e+8|0;i=h+8|0;f[h>>2]=i;j=h+4|0;f[j>>2]=520;k=(c&1|0)==0;l=a+16|0;m=b+16|0;n=f[m>>2]|0;o=(f[l>>2]|0)==(n|0);p=(c&16|0)==0;c=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!k){f[j>>2]=q;if(q>>>0>520){r=XDc(q>>>0>2147483647?-1:q<<1)|0;f[h>>2]=r;s=c;t=q;v=r}else{s=c;t=q;v=i}}else{s=q;t=c;v=i}a:do if((s|0)>0){c=b+44|0;q=a+44|0;r=t<<1;w=(t|0)>0;x=(t|0)/2|0;y=(t|0)>1;z=t+-1|0;if(k){A=p|y^1;B=0;C=n;while(1){D=C+(Y(f[f[c>>2]>>2]|0,B)|0)|0;if(!o)dJc(D|0,(f[l>>2]|0)+(Y(f[f[q>>2]>>2]|0,B)|0)|0,r|0)|0;lsc(D,D+(t<<1)|0,g);if(!A){E=0;do{F=D+(E<<1)|0;G=D+(z-E<<1)|0;H=d[F>>1]|0;d[F>>1]=d[G>>1]|0;d[G>>1]=H;E=E+1|0}while((E|0)<(x|0))}E=B+1|0;if((E|0)>=(s|0))break a;B=E;C=f[m>>2]|0}}C=v+(t<<1)|0;B=p|y^1;A=0;do{if(w){r=f[l>>2]|0;E=f[f[q>>2]>>2]|0;D=0;do{H=r+(Y(E,D)|0)+(A<<1)|0;d[v+(D<<1)>>1]=d[H>>1]|0;D=D+1|0}while((D|0)!=(t|0))}lsc(v,C,g);if(!B){D=0;do{E=v+(D<<1)|0;r=v+(z-D<<1)|0;H=d[E>>1]|0;d[E>>1]=d[r>>1]|0;d[r>>1]=H;D=D+1|0}while((D|0)<(x|0))}if(w){D=f[m>>2]|0;H=f[f[c>>2]>>2]|0;r=0;do{E=D+(Y(H,r)|0)+(A<<1)|0;d[E>>1]=d[v+(r<<1)>>1]|0;r=r+1|0}while((r|0)!=(t|0))}A=A+1|0}while((A|0)<(s|0))}while(0);s=f[h>>2]|0;if((s|0)==(i|0)){u=e;return}if(s|0)ZDc(s);f[h>>2]=i;f[j>>2]=520;u=e;return}function wS(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+1056|0;g=e;h=e+8|0;i=h+8|0;f[h>>2]=i;j=h+4|0;f[j>>2]=520;k=(c&1|0)==0;l=a+16|0;m=b+16|0;n=f[m>>2]|0;o=(f[l>>2]|0)==(n|0);p=(c&16|0)==0;c=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!k){f[j>>2]=q;if(q>>>0>520){r=XDc(q>>>0>2147483647?-1:q<<1)|0;f[h>>2]=r;s=c;t=q;v=r}else{s=c;t=q;v=i}}else{s=q;t=c;v=i}a:do if((s|0)>0){c=b+44|0;q=a+44|0;r=t<<1;w=(t|0)>0;x=(t|0)/2|0;y=(t|0)>1;z=t+-1|0;if(k){A=p|y^1;B=0;C=n;while(1){D=C+(Y(f[f[c>>2]>>2]|0,B)|0)|0;if(!o)dJc(D|0,(f[l>>2]|0)+(Y(f[f[q>>2]>>2]|0,B)|0)|0,r|0)|0;fsc(D,D+(t<<1)|0,g);if(!A){E=0;do{F=D+(E<<1)|0;G=D+(z-E<<1)|0;H=d[F>>1]|0;d[F>>1]=d[G>>1]|0;d[G>>1]=H;E=E+1|0}while((E|0)<(x|0))}E=B+1|0;if((E|0)>=(s|0))break a;B=E;C=f[m>>2]|0}}C=v+(t<<1)|0;B=p|y^1;A=0;do{if(w){r=f[l>>2]|0;E=f[f[q>>2]>>2]|0;D=0;do{H=r+(Y(E,D)|0)+(A<<1)|0;d[v+(D<<1)>>1]=d[H>>1]|0;D=D+1|0}while((D|0)!=(t|0))}fsc(v,C,g);if(!B){D=0;do{E=v+(D<<1)|0;r=v+(z-D<<1)|0;H=d[E>>1]|0;d[E>>1]=d[r>>1]|0;d[r>>1]=H;D=D+1|0}while((D|0)<(x|0))}if(w){D=f[m>>2]|0;H=f[f[c>>2]>>2]|0;r=0;do{E=D+(Y(H,r)|0)+(A<<1)|0;d[E>>1]=d[v+(r<<1)>>1]|0;r=r+1|0}while((r|0)!=(t|0))}A=A+1|0}while((A|0)<(s|0))}while(0);s=f[h>>2]|0;if((s|0)==(i|0)){u=e;return}if(s|0)ZDc(s);f[h>>2]=i;f[j>>2]=520;u=e;return}function xS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+1072|0;e=d;g=d+8|0;h=g+8|0;f[g>>2]=h;i=g+4|0;f[i>>2]=264;j=(c&1|0)==0;k=a+16|0;l=b+16|0;m=f[l>>2]|0;n=(f[k>>2]|0)==(m|0);o=(c&16|0)==0;c=f[a+12>>2]|0;p=f[a+8>>2]|0;if(!j){f[i>>2]=p;if(p>>>0>264){q=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=q;r=c;s=p;t=q}else{r=c;s=p;t=h}}else{r=p;s=c;t=h}a:do if((r|0)>0){c=b+44|0;p=a+44|0;q=s<<2;v=(s|0)>0;w=(s|0)/2|0;x=(s|0)>1;y=s+-1|0;if(j){z=o|x^1;A=0;B=m;while(1){C=B+(Y(f[f[c>>2]>>2]|0,A)|0)|0;if(!n)dJc(C|0,(f[k>>2]|0)+(Y(f[f[p>>2]>>2]|0,A)|0)|0,q|0)|0;rsc(C,C+(s<<2)|0,e);if(!z){D=0;do{E=C+(D<<2)|0;F=C+(y-D<<2)|0;G=f[E>>2]|0;f[E>>2]=f[F>>2];f[F>>2]=G;D=D+1|0}while((D|0)<(w|0))}D=A+1|0;if((D|0)>=(r|0))break a;A=D;B=f[l>>2]|0}}B=t+(s<<2)|0;A=o|x^1;z=0;do{if(v){q=f[k>>2]|0;D=f[p>>2]|0;C=0;do{G=q+(Y(f[D>>2]|0,C)|0)+(z<<2)|0;f[t+(C<<2)>>2]=f[G>>2];C=C+1|0}while((C|0)!=(s|0))}rsc(t,B,e);if(!A){C=0;do{D=t+(C<<2)|0;q=t+(y-C<<2)|0;G=f[D>>2]|0;f[D>>2]=f[q>>2];f[q>>2]=G;C=C+1|0}while((C|0)<(w|0))}if(v){C=f[l>>2]|0;G=f[c>>2]|0;q=0;do{D=C+(Y(f[G>>2]|0,q)|0)+(z<<2)|0;f[D>>2]=f[t+(q<<2)>>2];q=q+1|0}while((q|0)!=(s|0))}z=z+1|0}while((z|0)<(r|0))}while(0);r=f[g>>2]|0;if((r|0)==(h|0)){u=d;return}if(r|0)ZDc(r);f[g>>2]=h;f[i>>2]=264;u=d;return}function yS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+1072|0;e=d;g=d+8|0;h=g+8|0;f[g>>2]=h;i=g+4|0;f[i>>2]=264;j=(c&1|0)==0;k=a+16|0;l=b+16|0;m=f[l>>2]|0;n=(f[k>>2]|0)==(m|0);o=(c&16|0)==0;c=f[a+12>>2]|0;p=f[a+8>>2]|0;if(!j){f[i>>2]=p;if(p>>>0>264){q=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=q;r=c;s=p;t=q}else{r=c;s=p;t=h}}else{r=p;s=c;t=h}a:do if((r|0)>0){c=b+44|0;p=a+44|0;q=s<<2;v=(s|0)>0;w=(s|0)/2|0;x=(s|0)>1;y=s+-1|0;if(j){z=o|x^1;A=0;B=m;while(1){C=B+(Y(f[f[c>>2]>>2]|0,A)|0)|0;if(!n)dJc(C|0,(f[k>>2]|0)+(Y(f[f[p>>2]>>2]|0,A)|0)|0,q|0)|0;xsc(C,C+(s<<2)|0,e);if(!z){D=0;do{E=C+(D<<2)|0;F=C+(y-D<<2)|0;G=f[E>>2]|0;f[E>>2]=f[F>>2];f[F>>2]=G;D=D+1|0}while((D|0)<(w|0))}D=A+1|0;if((D|0)>=(r|0))break a;A=D;B=f[l>>2]|0}}B=t+(s<<2)|0;A=o|x^1;z=0;do{if(v){q=f[k>>2]|0;D=f[f[p>>2]>>2]|0;C=0;do{G=q+(Y(D,C)|0)+(z<<2)|0;f[t+(C<<2)>>2]=f[G>>2];C=C+1|0}while((C|0)!=(s|0))}xsc(t,B,e);if(!A){C=0;do{D=t+(C<<2)|0;q=t+(y-C<<2)|0;G=f[D>>2]|0;f[D>>2]=f[q>>2];f[q>>2]=G;C=C+1|0}while((C|0)<(w|0))}if(v){C=f[l>>2]|0;G=f[f[c>>2]>>2]|0;q=0;do{D=C+(Y(G,q)|0)+(z<<2)|0;f[D>>2]=f[t+(q<<2)>>2];q=q+1|0}while((q|0)!=(s|0))}z=z+1|0}while((z|0)<(r|0))}while(0);r=f[g>>2]|0;if((r|0)==(h|0)){u=d;return}if(r|0)ZDc(r);f[g>>2]=h;f[i>>2]=264;u=d;return}function zS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0;d=u;u=u+1104|0;e=d+1096|0;g=d;h=g+8|0;f[g>>2]=h;i=g+4|0;f[i>>2]=136;j=(c&1|0)==0;k=a+16|0;l=b+16|0;m=f[l>>2]|0;n=(f[k>>2]|0)==(m|0);o=(c&16|0)==0;c=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!j){f[i>>2]=q;if(q>>>0>136){r=XDc(q>>>0>536870911?-1:q<<3)|0;f[g>>2]=r;s=c;t=q;v=r}else{s=c;t=q;v=h}}else{s=q;t=c;v=h}a:do if((s|0)>0){c=b+44|0;q=a+44|0;r=t<<3;w=(t|0)>0;x=(t|0)/2|0;y=(t|0)>1;z=t+-1|0;if(j){A=o|y^1;B=0;C=m;while(1){D=C+(Y(f[f[c>>2]>>2]|0,B)|0)|0;if(!n)dJc(D|0,(f[k>>2]|0)+(Y(f[f[q>>2]>>2]|0,B)|0)|0,r|0)|0;Dsc(D,D+(t<<3)|0,e);if(!A){E=0;do{F=D+(E<<3)|0;G=D+(z-E<<3)|0;H=+p[F>>3];p[F>>3]=+p[G>>3];p[G>>3]=H;E=E+1|0}while((E|0)<(x|0))}E=B+1|0;if((E|0)>=(s|0))break a;B=E;C=f[l>>2]|0}}C=v+(t<<3)|0;B=o|y^1;A=0;do{if(w){r=f[k>>2]|0;E=f[f[q>>2]>>2]|0;D=0;do{G=r+(Y(E,D)|0)+(A<<3)|0;p[v+(D<<3)>>3]=+p[G>>3];D=D+1|0}while((D|0)!=(t|0))}Dsc(v,C,e);if(!B){D=0;do{E=v+(D<<3)|0;r=v+(z-D<<3)|0;H=+p[E>>3];p[E>>3]=+p[r>>3];p[r>>3]=H;D=D+1|0}while((D|0)<(x|0))}if(w){D=f[l>>2]|0;r=f[f[c>>2]>>2]|0;E=0;do{G=D+(Y(r,E)|0)+(A<<3)|0;p[G>>3]=+p[v+(E<<3)>>3];E=E+1|0}while((E|0)!=(t|0))}A=A+1|0}while((A|0)<(s|0))}while(0);s=f[g>>2]|0;if((s|0)==(h|0)){u=d;return}if(s|0)ZDc(s);f[g>>2]=h;f[i>>2]=136;u=d;return}function AS(a){a=a|0;return}function BS(a,b,c){a=a|0;b=b|0;c=c|0;return}function CS(a,b){a=a|0;b=b|0;if(f[b+8>>2]|0)return;if(f[b+12>>2]|0)return;mi[f[(f[a>>2]|0)+16>>2]&2047](a,b);return}function DS(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;a=u;u=u+288|0;k=a+160|0;l=a+104|0;m=a+48|0;n=a+40|0;o=a+32|0;p=a;if(!c){u=a;return}q=f[c+16>>2]|0;a:do if((e|0)>0){c=e+-2|0;if(!h){r=0;while(1){s=f[g+(r<<2)>>2]|0;if((s|0)<=-1)break;if(!s)break a;f[k+(r<<2)>>2]=s;r=r+1|0;if((r|0)>=(e|0)){t=q;v=13;break a}}f[l>>2]=0;w=l+4|0;f[w>>2]=0;x=tT(l,24)|0;y=x;z=217062;A=y+24|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NS(-215,l,217360,33)}else{B=q;C=0}while(1){r=f[g+(C<<2)>>2]|0;if((r|0)<=-1)break;if(!r)break a;if((C|0)>(c|0))D=1;else D=f[i+(C<<2)>>2]|0;s=B+(Y(D,f[h+(C<<2)>>2]|0)|0)|0;f[k+(C<<2)>>2]=r;C=C+1|0;if((C|0)>=(e|0)){t=s;v=13;break a}else B=s}f[l>>2]=0;w=l+4|0;f[w>>2]=0;x=tT(l,24)|0;y=x;z=217062;A=y+24|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NS(-215,l,217360,33)}else{t=q;v=13}while(0);if((v|0)==13){v=l+4|0;q=l+8|0;z=l+16|0;x=l+20|0;w=l+40|0;y=v;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[w>>2]=q;q=l+48|0;B=l+44|0;f[B>>2]=q;f[l+52>>2]=0;f[q>>2]=0;f[l>>2]=1124007936;f[z>>2]=t;f[x>>2]=t;OS(l,e,k,i,1);PS(l);i=m+4|0;t=m+8|0;x=m+16|0;C=m+20|0;h=m+40|0;y=i;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[h>>2]=t;t=m+48|0;y=m+44|0;f[y>>2]=t;f[m+52>>2]=0;f[t>>2]=0;f[m>>2]=1124007936;f[x>>2]=d;f[C>>2]=d;OS(m,e,k,j,1);PS(m);f[n>>2]=l;f[n+4>>2]=m;z2(p,n,o,2);n=f[p+20>>2]|0;j=p+16|0;k=o+4|0;e=0;while(1){if(e>>>0>=(f[j>>2]|0)>>>0)break;dJc(f[k>>2]|0,f[o>>2]|0,n|0)|0;A2(p)|0;e=e+1|0}e=m+36|0;p=f[e>>2]|0;if((p|0?(n=p+12|0,p=f[n>>2]|0,f[n>>2]=p+-1,(p|0)==1):0)?(p=f[e>>2]|0,p|0):0){f[e>>2]=0;n=f[p+4>>2]|0;if(!n){o=f[m+32>>2]|0;if(!o)E=QS()|0;else E=o}else E=n;mi[f[(f[E>>2]|0)+24>>2]&2047](E,p)}f[e>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[i>>2]|0)>0){x=f[h>>2]|0;h=0;do{f[x+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[i>>2]|0))}i=f[y>>2]|0;if((i|0)!=(t|0))g0(i);i=l+36|0;t=f[i>>2]|0;if((t|0?(y=t+12|0,t=f[y>>2]|0,f[y>>2]=t+-1,(t|0)==1):0)?(t=f[i>>2]|0,t|0):0){f[i>>2]=0;y=f[t+4>>2]|0;if(!y){h=f[l+32>>2]|0;if(!h)F=QS()|0;else F=h}else F=y;mi[f[(f[F>>2]|0)+24>>2]&2047](F,t)}f[i>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[v>>2]|0)>0){z=f[w>>2]|0;w=0;do{f[z+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[v>>2]|0))}v=f[B>>2]|0;if((v|0)!=(q|0))g0(v)}u=a;return}function ES(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;a=u;u=u+288|0;k=a+160|0;l=a+104|0;m=a+48|0;n=a+40|0;o=a+32|0;p=a;if(!c){u=a;return}q=f[c+16>>2]|0;a:do if((e|0)>0){c=e+-2|0;if(!h){r=0;while(1){s=f[g+(r<<2)>>2]|0;if((s|0)<=-1)break;if(!s)break a;f[k+(r<<2)>>2]=s;r=r+1|0;if((r|0)>=(e|0)){t=q;v=13;break a}}f[l>>2]=0;w=l+4|0;f[w>>2]=0;x=tT(l,24)|0;y=x;z=217062;A=y+24|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NS(-215,l,217353,64)}else{B=q;C=0}while(1){r=f[g+(C<<2)>>2]|0;if((r|0)<=-1)break;if(!r)break a;if((C|0)>(c|0))D=1;else D=f[i+(C<<2)>>2]|0;s=B+(Y(D,f[h+(C<<2)>>2]|0)|0)|0;f[k+(C<<2)>>2]=r;C=C+1|0;if((C|0)>=(e|0)){t=s;v=13;break a}else B=s}f[l>>2]=0;w=l+4|0;f[w>>2]=0;x=tT(l,24)|0;y=x;z=217062;A=y+24|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NS(-215,l,217353,64)}else{t=q;v=13}while(0);if((v|0)==13){v=l+4|0;q=l+8|0;z=l+16|0;x=l+20|0;w=l+40|0;y=v;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[w>>2]=q;q=l+48|0;B=l+44|0;f[B>>2]=q;f[l+52>>2]=0;f[q>>2]=0;f[l>>2]=1124007936;f[z>>2]=d;f[x>>2]=d;OS(l,e,k,j,1);PS(l);j=m+4|0;d=m+8|0;x=m+16|0;C=m+20|0;h=m+40|0;y=j;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[h>>2]=d;d=m+48|0;y=m+44|0;f[y>>2]=d;f[m+52>>2]=0;f[d>>2]=0;f[m>>2]=1124007936;f[x>>2]=t;f[C>>2]=t;OS(m,e,k,i,1);PS(m);f[n>>2]=l;f[n+4>>2]=m;z2(p,n,o,2);n=f[p+20>>2]|0;i=p+16|0;k=o+4|0;e=0;while(1){if(e>>>0>=(f[i>>2]|0)>>>0)break;dJc(f[k>>2]|0,f[o>>2]|0,n|0)|0;A2(p)|0;e=e+1|0}e=m+36|0;p=f[e>>2]|0;if((p|0?(n=p+12|0,p=f[n>>2]|0,f[n>>2]=p+-1,(p|0)==1):0)?(p=f[e>>2]|0,p|0):0){f[e>>2]=0;n=f[p+4>>2]|0;if(!n){o=f[m+32>>2]|0;if(!o)E=QS()|0;else E=o}else E=n;mi[f[(f[E>>2]|0)+24>>2]&2047](E,p)}f[e>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[j>>2]|0)>0){x=f[h>>2]|0;h=0;do{f[x+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[j>>2]|0))}j=f[y>>2]|0;if((j|0)!=(d|0))g0(j);j=l+36|0;d=f[j>>2]|0;if((d|0?(y=d+12|0,d=f[y>>2]|0,f[y>>2]=d+-1,(d|0)==1):0)?(d=f[j>>2]|0,d|0):0){f[j>>2]=0;y=f[d+4>>2]|0;if(!y){h=f[l+32>>2]|0;if(!h)F=QS()|0;else F=h}else F=y;mi[f[(f[F>>2]|0)+24>>2]&2047](F,d)}f[j>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[v>>2]|0)>0){z=f[w>>2]|0;w=0;do{f[z+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[v>>2]|0))}v=f[B>>2]|0;if((v|0)!=(q|0))g0(v)}u=a;return}function FS(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;l=u;u=u+288|0;a=l+160|0;m=l+104|0;n=l+48|0;o=l+40|0;p=l+32|0;q=l;if(!((c|0)!=0&(d|0)!=0)){u=l;return}r=f[c+16>>2]|0;c=f[d+16>>2]|0;a:do if((e|0)>0){d=(j|0)==0;s=e+-2|0;if(h|0){t=r;v=0;w=c;while(1){x=f[g+(v<<2)>>2]|0;if((x|0)<=-1)break;if(!x)break a;y=(v|0)>(s|0);if(y)z=1;else z=f[i+(v<<2)>>2]|0;A=t+(Y(z,f[h+(v<<2)>>2]|0)|0)|0;if(d)B=w;else{if(y)C=1;else C=f[k+(v<<2)>>2]|0;B=w+(Y(C,f[j+(v<<2)>>2]|0)|0)|0}f[a+(v<<2)>>2]=x;v=v+1|0;if((v|0)>=(e|0)){D=A;E=B;F=23;break a}else{t=A;w=B}}f[m>>2]=0;G=m+4|0;f[G>>2]=0;H=tT(m,24)|0;I=H;J=217062;K=I+24|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));NS(-215,m,217087,97)}if(d){w=0;while(1){t=f[g+(w<<2)>>2]|0;if((t|0)<=-1)break;if(!t)break a;f[a+(w<<2)>>2]=t;w=w+1|0;if((w|0)>=(e|0)){D=r;E=c;F=23;break a}}f[m>>2]=0;G=m+4|0;f[G>>2]=0;H=tT(m,24)|0;I=H;J=217062;K=I+24|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));NS(-215,m,217087,97)}else{L=0;M=c}while(1){w=f[g+(L<<2)>>2]|0;if((w|0)<=-1)break;if(!w)break a;if((L|0)>(s|0))N=1;else N=f[k+(L<<2)>>2]|0;d=M+(Y(N,f[j+(L<<2)>>2]|0)|0)|0;f[a+(L<<2)>>2]=w;L=L+1|0;if((L|0)>=(e|0)){D=r;E=d;F=23;break a}else M=d}f[m>>2]=0;G=m+4|0;f[G>>2]=0;H=tT(m,24)|0;I=H;J=217062;K=I+24|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));NS(-215,m,217087,97)}else{D=r;E=c;F=23}while(0);if((F|0)==23){F=m+4|0;c=m+8|0;r=m+16|0;J=m+20|0;H=m+40|0;I=F;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[H>>2]=c;c=m+48|0;G=m+44|0;f[G>>2]=c;f[m+52>>2]=0;f[c>>2]=0;f[m>>2]=1124007936;f[r>>2]=D;f[J>>2]=D;OS(m,e,a,i,1);PS(m);i=n+4|0;D=n+8|0;J=n+16|0;M=n+20|0;L=n+40|0;I=i;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[L>>2]=D;D=n+48|0;I=n+44|0;f[I>>2]=D;f[n+52>>2]=0;f[D>>2]=0;f[n>>2]=1124007936;f[J>>2]=E;f[M>>2]=E;OS(n,e,a,k,1);PS(n);f[o>>2]=m;f[o+4>>2]=n;z2(q,o,p,2);o=f[q+20>>2]|0;k=q+16|0;a=p+4|0;e=0;while(1){if(e>>>0>=(f[k>>2]|0)>>>0)break;dJc(f[a>>2]|0,f[p>>2]|0,o|0)|0;A2(q)|0;e=e+1|0}e=n+36|0;q=f[e>>2]|0;if((q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)?(q=f[e>>2]|0,q|0):0){f[e>>2]=0;o=f[q+4>>2]|0;if(!o){p=f[n+32>>2]|0;if(!p)O=QS()|0;else O=p}else O=o;mi[f[(f[O>>2]|0)+24>>2]&2047](O,q)}f[e>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[i>>2]|0)>0){J=f[L>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[i>>2]|0))}i=f[I>>2]|0;if((i|0)!=(D|0))g0(i);i=m+36|0;D=f[i>>2]|0;if((D|0?(I=D+12|0,D=f[I>>2]|0,f[I>>2]=D+-1,(D|0)==1):0)?(D=f[i>>2]|0,D|0):0){f[i>>2]=0;I=f[D+4>>2]|0;if(!I){L=f[m+32>>2]|0;if(!L)P=QS()|0;else P=L}else P=I;mi[f[(f[P>>2]|0)+24>>2]&2047](P,D)}f[i>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[F>>2]|0)>0){r=f[H>>2]|0;H=0;do{f[r+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[F>>2]|0))}F=f[G>>2]|0;if((F|0)!=(c|0))g0(F)}u=l;return}function GS(a,c){a=a|0;c=c|0;if((b[519808]|0)==0?MIc(519808)|0:0)f[132544]=42048;return 530176}function HS(a){a=a|0;return -1}function IS(a){a=a|0;return -1}function JS(a,b){a=a|0;b=b|0;return}function KS(a){a=a|0;return}function LS(a){a=a|0;return}function MS(a){a=a|0;YDc(a);return}function NS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,217288,d);return}function OS(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+16|0;i=h;if(c>>>0>=33){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,33)|0;k=217187;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));NS(-215,i,217221,209)}m=a+4|0;if((f[m>>2]|0)!=(c|0)){n=a+44|0;o=f[n>>2]|0;p=a+48|0;if((o|0)!=(p|0)){g0(o);f[n>>2]=p;f[a+40>>2]=a+8}if((c|0)>2){p=f0(c<<3|4)|0;f[n>>2]=p;n=p+(c<<2)+4|0;f[a+40>>2]=n;f[n+-4>>2]=c;f[a+12>>2]=-1;f[a+8>>2]=-1}}f[m>>2]=c;if(!d){u=h;return}n=f[a>>2]|0;p=n&7;o=(n>>>3&511)+1<<(47696>>>(p<<1)&3);n=1212424721>>>(p<<2)&15;p=c+-1|0;if((c|0)<=0){u=h;return}q=f[a+40>>2]|0;r=f[a+44>>2]|0;a:do if(!e){s=p;t=o;while(1){v=f[d+(s<<2)>>2]|0;if((v|0)<=-1){w=18;break}f[q+(s<<2)>>2]=v;if(g){f[r+(s<<2)>>2]=t;x=mJc(v|0,((v|0)<0)<<31>>31|0,t|0,0)|0;if(!((x|0)==(x|0)&(J|0)==0)){w=22;break}y=x}else y=t;if((s|0)>0){s=s+-1|0;t=y}else break a}if((w|0)==18){f[i>>2]=0;z=i+4|0;f[z>>2]=0;A=tT(i,6)|0;b[A>>0]=b[217229]|0;b[A+1>>0]=b[217230]|0;b[A+2>>0]=b[217231]|0;b[A+3>>0]=b[217232]|0;b[A+4>>0]=b[217233]|0;b[A+5>>0]=b[217234]|0;NS(-215,i,217221,235)}else if((w|0)==22){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,51)|0;k=217236;l=j+51|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));NS(-211,i,217221,252)}}else{t=p;while(1){s=f[d+(t<<2)>>2]|0;if((s|0)<=-1){w=18;break}f[q+(t<<2)>>2]=s;s=f[e+(t<<2)>>2]|0;if((s>>>0)%(n>>>0)|0|0){w=20;break}f[r+(t<<2)>>2]=(t|0)<(p|0)?s:o;if((t|0)>0)t=t+-1|0;else break a}if((w|0)==18){f[i>>2]=0;z=i+4|0;f[z>>2]=0;A=tT(i,6)|0;b[A>>0]=b[217229]|0;b[A+1>>0]=b[217230]|0;b[A+2>>0]=b[217231]|0;b[A+3>>0]=b[217232]|0;b[A+4>>0]=b[217233]|0;b[A+5>>0]=b[217234]|0;NS(-215,i,217221,235)}else if((w|0)==20){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,31)|0;k=219387;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));NS(-13,i,217221,242)}}while(0);if((c|0)!=1){u=h;return}f[m>>2]=2;f[a+12>>2]=1;f[(f[a+44>>2]|0)+4>>2]=o;u=h;return}function PS(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=f[a>>2]|0;c=f[a+4>>2]|0;d=f[a+40>>2]|0;e=f[a+44>>2]|0;a:do if((c|0)>0){g=0;while(1){if((f[d+(g<<2)>>2]|0)>1){h=g;break a}i=g+1|0;if((i|0)<(c|0))g=i;else{h=i;break}}}else h=0;while(0);g=c+-1|0;i=f[d+(((g|0)<(h|0)?g:h)<<2)>>2]|0;j=mJc(i|0,((i|0)<0)<<31>>31|0,(b>>>3&511)+1|0,0)|0;i=g;k=j;j=J;while(1){if((i|0)<=(h|0)){l=7;break}m=f[d+(i<<2)>>2]|0;n=mJc(m|0,((m|0)<0)<<31>>31|0,k|0,j|0)|0;o=Y(f[e+(i<<2)>>2]|0,m)|0;i=i+-1|0;if(o>>>0<(f[e+(i<<2)>>2]|0)>>>0){l=9;break}else{k=n;j=J}}if((l|0)==7){i=$Ic(0,k|0,32)|0;if((k|0)==(i|0)&(j|0)==(J|0))p=b|16384;else l=9}if((l|0)==9)p=b&-16385;f[a>>2]=p;if((c|0)>2){f[a+12>>2]=-1;f[a+8>>2]=-1}p=f[a+36>>2]|0;if(!p)q=a+16|0;else{b=f[p+16>>2]|0;p=a+16|0;f[p>>2]=b;f[a+20>>2]=b;q=p}p=f[q>>2]|0;if(!p){f[a+28>>2]=0;f[a+24>>2]=0;return}q=f[d>>2]|0;b=f[e>>2]|0;l=(f[a+20>>2]|0)+(Y(b,q)|0)|0;f[a+28>>2]=l;if((q|0)<=0){f[a+24>>2]=l;return}l=p+(Y(f[e+(g<<2)>>2]|0,f[d+(g<<2)>>2]|0)|0)|0;p=a+24|0;f[p>>2]=l;if((c|0)<=1)return;c=l+(Y(b,q+-1|0)|0)|0;if((g|0)==1)r=c;else{q=1;b=c;while(1){c=b+(Y(f[e+(q<<2)>>2]|0,(f[d+(q<<2)>>2]|0)+-1|0)|0)|0;q=q+1|0;if((q|0)==(g|0)){r=c;break}else b=c}}f[p>>2]=r;return}function QS(){var a=0,b=0,c=0,d=0;if(f[132545]|0){a=f[132545]|0;return a|0}b=H5()|0;m6(b);if(!(f[132545]|0)){if(!(f[132546]|0)){c=H5()|0;m6(c);if(!(f[132546]|0)){d=VDc(4)|0;f[d>>2]=42080;f[132546]=d}n6(c)}f[132545]=f[132546]}n6(b);a=f[132545]|0;return a|0}function RS(a){a=a|0;YDc(a);return}function SS(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=u;u=u+16|0;i=j;k=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);e=c+-1|0;a:do if((c|0)>0){if(!h){l=e;m=k;while(1){n=Y(f[d+(l<<2)>>2]|0,m)|0;if((l|0)>0){l=l+-1|0;m=n}else{o=n;break a}}}if(!g){m=e;l=k;while(1){f[h+(m<<2)>>2]=l;n=Y(f[d+(m<<2)>>2]|0,l)|0;if((m|0)>0){m=m+-1|0;l=n}else{o=n;break a}}}else{p=e;q=k}while(1){l=h+(p<<2)|0;m=f[l>>2]|0;if((m|0)!=2147483647)if(q>>>0>m>>>0)break;else r=m;else{f[l>>2]=q;r=q}l=Y(f[d+(p<<2)>>2]|0,r)|0;if((p|0)>0){p=p+-1|0;q=l}else{o=l;break a}}f[i>>2]=0;f[i+4>>2]=0;l=tT(i,16)|0;m=217138;n=l+16|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));NS(-215,i,217155,139)}else o=k;while(0);k=(g|0)!=0;if(k)s=g;else s=f0(o)|0;g=VDc(52)|0;rQ(g,a);f[g+20>>2]=s;f[g+16>>2]=s;f[g+24>>2]=o;if(!k){u=j;return g|0}k=g+28|0;f[k>>2]=f[k>>2]|32;u=j;return g|0}function TS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (b|0)!=0|0}function US(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;a=u;u=u+16|0;d=a;if(!c){u=a;return}if(f[c+8>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,17)|0;g=217092;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));NS(-215,d,217110,168)}if(f[c+12>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,16)|0;g=217121;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));NS(-215,d,217110,169)}if(!(f[c+28>>2]&32)){d=c+20|0;g0(f[d>>2]|0);f[d>>2]=0}sQ(c);YDc(c);u=a;return}function VS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a:do if((b|0)>0){e=0;while(1){if((f[c+(e<<2)>>2]|0)>1){g=e;break a}h=e+1|0;if((h|0)<(b|0))e=h;else{g=h;break}}}else g=0;while(0);e=b+-1|0;b=f[c+(((e|0)<(g|0)?e:g)<<2)>>2]|0;h=mJc(b|0,((b|0)<0)<<31>>31|0,(a>>>3&511)+1|0,0)|0;b=e;e=h;h=J;while(1){if((b|0)<=(g|0)){i=7;break}j=f[c+(b<<2)>>2]|0;k=mJc(j|0,((j|0)<0)<<31>>31|0,e|0,h|0)|0;l=Y(f[d+(b<<2)>>2]|0,j)|0;b=b+-1|0;if(l>>>0<(f[d+(b<<2)>>2]|0)>>>0)break;else{e=k;h=J}}if((i|0)==7?(i=$Ic(0,e|0,32)|0,(e|0)==(i|0)&(h|0)==(J|0)):0){m=a|16384;return m|0}m=a&-16385;return m|0}function WS(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a>>2]|0;c=f[a+4>>2]|0;d=f[a+40>>2]|0;e=f[a+44>>2]|0;a:do if((c|0)>0){g=0;while(1){if((f[d+(g<<2)>>2]|0)>1){h=g;break a}i=g+1|0;if((i|0)<(c|0))g=i;else{h=i;break}}}else h=0;while(0);g=c+-1|0;c=f[d+(((g|0)<(h|0)?g:h)<<2)>>2]|0;i=mJc(c|0,((c|0)<0)<<31>>31|0,(b>>>3&511)+1|0,0)|0;c=g;g=i;i=J;while(1){if((c|0)<=(h|0)){j=7;break}k=f[d+(c<<2)>>2]|0;l=mJc(k|0,((k|0)<0)<<31>>31|0,g|0,i|0)|0;m=Y(f[e+(c<<2)>>2]|0,k)|0;c=c+-1|0;if(m>>>0<(f[e+(c<<2)>>2]|0)>>>0)break;else{g=l;i=J}}if((j|0)==7?(j=$Ic(0,g|0,32)|0,(g|0)==(j|0)&(i|0)==(J|0)):0){n=b|16384;f[a>>2]=n;return}n=b&-16385;f[a>>2]=n;return}function XS(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+144|0;h=g+8|0;i=g;if(!(c>>>0<33&(d|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,35)|0;k=217389;l=j+35|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));NS(-215,h,464481,321)}m=e&4095;e=a+16|0;do if(f[e>>2]|0){n=f[a+4>>2]|0;if((n|0)!=(c|0)?!((c|0)==1&(n|0)<3):0)break;if((m|0)==(f[a>>2]&4095|0)){if((c|0)==2)if((f[a+8>>2]|0)==(f[d>>2]|0)?(f[a+12>>2]|0)==(f[d+4>>2]|0):0){u=g;return}else o=11;else if((c|0)>0)o=11;else p=0;a:do if((o|0)==11){n=f[a+40>>2]|0;q=0;while(1){if((f[n+(q<<2)>>2]|0)!=(f[d+(q<<2)>>2]|0)){p=q;break a}r=q+1|0;if((r|0)<(c|0))q=r;else{p=r;break}}}while(0);if((p|0)==(c|0)){if((c|0)>1){u=g;return}if((f[(f[a+40>>2]|0)+4>>2]|0)==1){u=g;return}}}}while(0);p=a+40|0;if((f[p>>2]|0)==(d|0)){if((c|0)>0)dJc(h|0,d|0,c<<2|0)|0;s=h}else s=d;d=a+36|0;h=f[d>>2]|0;if((h|0?(o=h+12|0,h=f[o>>2]|0,f[o>>2]=h+-1,(h|0)==1):0)?(h=f[d>>2]|0,h|0):0){f[d>>2]=0;o=f[h+4>>2]|0;if(!o){q=f[a+32>>2]|0;if(!q)t=QS()|0;else t=q}else t=o;mi[f[(f[t>>2]|0)+24>>2]&2047](t,h)}f[d>>2]=0;h=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[h>>2]|0)>0){e=f[p>>2]|0;t=0;do{f[e+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[h>>2]|0))}if(c|0){f[a>>2]=m|1124007936;OS(a,c,s,0,1);s=f[h>>2]|0;if((s|0)<3)v=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{c=f[p>>2]|0;t=0;e=1;while(1){o=Y(f[c+(t<<2)>>2]|0,e)|0;t=t+1|0;if((t|0)==(s|0)){v=o;break}else e=o}}if(v|0){v=f[a+32>>2]|0;e=QS()|0;s=(v|0)==0?e:v;v=a+44|0;e=Ij[f[(f[s>>2]|0)+8>>2]&15](s,f[h>>2]|0,f[p>>2]|0,m,0,f[v>>2]|0,0,0)|0;f[d>>2]=e;if(!e){f[i>>2]=0;f[i+4>>2]=0;e=tT(i,6)|0;b[e>>0]=b[217425]|0;b[e+1>>0]=b[217426]|0;b[e+2>>0]=b[217427]|0;b[e+3>>0]=b[217428]|0;b[e+4>>0]=b[217429]|0;b[e+5>>0]=b[217430]|0;NS(-215,i,464481,361)}e=f[a>>2]|0;if((f[(f[v>>2]|0)+((f[h>>2]|0)+-1<<2)>>2]|0)!=((e>>>3&511)+1<<(47696>>>(e<<1&14)&3)|0)){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,43)|0;k=217432;l=j+43|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));NS(-215,i,464481,370)}}i=f[d>>2]|0;if(i|0){d=i+12|0;f[d>>2]=(f[d>>2]|0)+1}PS(a)}u=g;return}function YS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;XS(a,(f[b+4>>2]|0)-d>>2,d,c);return}function ZS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;OS(a,f[b+4>>2]|0,0,0,0);c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[b+40>>2]|0;e=f[a+40>>2]|0;g=f[b+44>>2]|0;b=f[a+44>>2]|0;a=0;do{f[e+(a<<2)>>2]=f[d+(a<<2)>>2];f[b+(a<<2)>>2]=f[g+(a<<2)>>2];a=a+1|0}while((a|0)<(f[c>>2]|0));return}function _S(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+36|0;c=f[b>>2]|0;if(!c)return;f[b>>2]=0;b=f[c+4>>2]|0;if(!b){d=f[a+32>>2]|0;if(!d)e=QS()|0;else e=d}else e=b;mi[f[(f[e>>2]|0)+24>>2]&2047](e,c);return}function $S(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+1152|0;h=g+56|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+12|0;m=a+16|0;n=a+32|0;o=a+36|0;p=a+40|0;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=k;s=a+48|0;t=a+44|0;f[t>>2]=s;f[a+52>>2]=0;f[s>>2]=0;v=c+4|0;w=f[v>>2]|0;if((w|0)<=1){f[h>>2]=0;f[h+4>>2]=0;q=tT(h,11)|0;x=217476;r=q+11|0;do{b[q>>0]=b[x>>0]|0;q=q+1|0;x=x+1|0}while((q|0)<(r|0));NS(-215,h,271731,406)}if((w|0)!=2){y=h+8|0;XIc(y|0,0,1088)|0;f[h>>2]=y;z=h+4|0;f[z>>2]=w;if(w>>>0>136){A=XDc(w>>>0>536870911?-1:w<<3)|0;XIc(A|0,0,w<<3|0)|0;f[h>>2]=A;B=A}else B=y;A=d;w=f[A+4>>2]|0;C=B;f[C>>2]=f[A>>2];f[C+4>>2]=w;w=f[h>>2]|0;C=e;A=f[C+4>>2]|0;B=w+8|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;if((f[v>>2]|0)>2){A=2;B=w;while(1){C=B+(A<<3)|0;f[C>>2]=-2147483648;f[C+4>>2]=2147483647;A=A+1|0;C=f[h>>2]|0;if((A|0)>=(f[v>>2]|0)){D=C;break}else B=C}}else D=w;aT(i,c,D);bT(a,i)|0;D=i+36|0;w=f[D>>2]|0;if((w|0?(B=w+12|0,w=f[B>>2]|0,f[B>>2]=w+-1,(w|0)==1):0)?(w=f[D>>2]|0,w|0):0){f[D>>2]=0;B=f[w+4>>2]|0;if(!B){v=f[i+32>>2]|0;if(!v)E=QS()|0;else E=v}else E=B;mi[f[(f[E>>2]|0)+24>>2]&2047](E,w)}f[D>>2]=0;D=i+16|0;w=i+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[w>>2]|0)>0){D=f[i+40>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[w>>2]|0))}w=f[i+44>>2]|0;if((w|0)!=(i+48|0))g0(w);w=f[h>>2]|0;if((w|0)!=(y|0)){if(w|0)ZDc(w);f[h>>2]=y;f[z>>2]=136}u=g;return}bT(a,c)|0;z=f[d>>2]|0;y=f[d+4>>2]|0;do if((z|0)!=-2147483648|(y|0)!=2147483647?(z|0?1:(y|0)!=(f[k>>2]|0)):0){if((z|0)<0|(y|0)<(z|0)){f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,83)|0;q=G;x=217488;r=q+83|0;do{b[q>>0]=b[x>>0]|0;q=q+1|0;x=x+1|0}while((q|0)<(r|0));NS(-215,h,271731,424)}if((y|0)>(f[c+8>>2]|0)){f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,83)|0;q=G;x=217488;r=q+83|0;do{b[q>>0]=b[x>>0]|0;q=q+1|0;x=x+1|0}while((q|0)<(r|0));NS(-215,h,271731,424)}else{f[k>>2]=y-z;d=Y(z,f[s>>2]|0)|0;f[m>>2]=(f[m>>2]|0)+d;f[a>>2]=f[a>>2]|32768;break}}while(0);s=f[e>>2]|0;z=f[e+4>>2]|0;if((s|0)!=-2147483648|(z|0)!=2147483647?(s|0?1:(z|0)!=(f[l>>2]|0)):0){if((s|0)<0|(z|0)<(s|0)){f[h>>2]=0;H=h+4|0;f[H>>2]=0;I=tT(h,83)|0;q=I;x=217572;r=q+83|0;do{b[q>>0]=b[x>>0]|0;q=q+1|0;x=x+1|0}while((q|0)<(r|0));NS(-215,h,271731,433)}if((z|0)>(f[c+12>>2]|0)){f[h>>2]=0;H=h+4|0;f[H>>2]=0;I=tT(h,83)|0;q=I;x=217572;r=q+83|0;do{b[q>>0]=b[x>>0]|0;q=q+1|0;x=x+1|0}while((q|0)<(r|0));NS(-215,h,271731,433)}f[l>>2]=z-s;z=f[j>>2]|0;if((z|0)>0)K=f[(f[t>>2]|0)+(z+-1<<2)>>2]|0;else K=0;z=Y(K,s)|0;f[m>>2]=(f[m>>2]|0)+z;f[a>>2]=f[a>>2]|32768}z=f[a>>2]|0;s=f[j>>2]|0;K=f[p>>2]|0;h=f[t>>2]|0;a:do if((s|0)>0){t=0;while(1){if((f[K+(t<<2)>>2]|0)>1){L=t;break a}x=t+1|0;if((x|0)<(s|0))t=x;else{L=x;break}}}else L=0;while(0);t=s+-1|0;s=f[K+(((t|0)<(L|0)?t:L)<<2)>>2]|0;x=mJc(s|0,((s|0)<0)<<31>>31|0,(z>>>3&511)+1|0,0)|0;s=t;t=x;x=J;while(1){if((s|0)<=(L|0)){M=45;break}q=f[K+(s<<2)>>2]|0;r=mJc(q|0,((q|0)<0)<<31>>31|0,t|0,x|0)|0;I=Y(f[h+(s<<2)>>2]|0,q)|0;s=s+-1|0;if(I>>>0<(f[h+(s<<2)>>2]|0)>>>0){M=47;break}else{t=r;x=J}}if((M|0)==45){s=$Ic(0,t|0,32)|0;if((t|0)==(s|0)&(x|0)==(J|0))N=z|16384;else M=47}if((M|0)==47)N=z&-16385;f[a>>2]=N;if((f[k>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=g;return}N=f[o>>2]|0;if((N|0?(a=N+12|0,N=f[a>>2]|0,f[a>>2]=N+-1,(N|0)==1):0)?(N=f[o>>2]|0,N|0):0){f[o>>2]=0;a=f[N+4>>2]|0;if(!a){z=f[n>>2]|0;if(!z)O=QS()|0;else O=z}else O=a;mi[f[(f[O>>2]|0)+24>>2]&2047](O,N)}f[o>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){m=f[p>>2]|0;p=0;do{f[m+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}f[l>>2]=0;f[k>>2]=0;u=g;return}function aT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+16|0;k=a+40|0;l=h;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=i;i=a+48|0;n=a+44|0;f[n>>2]=i;f[a+52>>2]=0;f[i>>2]=0;i=f[c+4>>2]|0;if(!d){f[g>>2]=0;f[g+4>>2]=0;o=tT(g,6)|0;b[o>>0]=b[217656]|0;b[o+1>>0]=b[217657]|0;b[o+2>>0]=b[217658]|0;b[o+3>>0]=b[217659]|0;b[o+4>>0]=b[217660]|0;b[o+5>>0]=b[217661]|0;NS(-215,g,271731,511)}o=(i|0)>0;do if(o){p=f[c+40>>2]|0;q=0;while(1){r=d+(q<<3)|0;s=f[r>>2]|0;t=f[r+4>>2]|0;if(!((s|0)==-2147483648&(t|0)==2147483647)){if(!((s|0)>-1&(s|0)<(t|0))){v=10;break}if((t|0)>(f[p+(q<<2)>>2]|0)){v=10;break}}q=q+1|0;if((q|0)>=(i|0)){v=6;break}}if((v|0)==6){bT(a,c)|0;if(o)w=0;else break;do{q=d+(w<<3)|0;p=f[q>>2]|0;t=f[q+4>>2]|0;if((p|0)!=-2147483648|(t|0)!=2147483647?(q=(f[k>>2]|0)+(w<<2)|0,p|0?1:(t|0)!=(f[q>>2]|0)):0){f[q>>2]=t-p;t=Y(f[(f[n>>2]|0)+(w<<2)>>2]|0,p)|0;f[j>>2]=(f[j>>2]|0)+t;f[a>>2]=f[a>>2]|32768}w=w+1|0}while((w|0)!=(i|0))}else if((v|0)==10){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,76)|0;t=217663;m=l+76|0;do{b[l>>0]=b[t>>0]|0;l=l+1|0;t=t+1|0}while((l|0)<(m|0));NS(-215,g,271731,515)}}else bT(a,c)|0;while(0);c=f[a>>2]|0;g=f[h>>2]|0;h=f[k>>2]|0;k=f[n>>2]|0;a:do if((g|0)>0){n=0;while(1){if((f[h+(n<<2)>>2]|0)>1){x=n;break a}l=n+1|0;if((l|0)<(g|0))n=l;else{x=l;break}}}else x=0;while(0);n=g+-1|0;g=f[h+(((n|0)<(x|0)?n:x)<<2)>>2]|0;l=mJc(g|0,((g|0)<0)<<31>>31|0,(c>>>3&511)+1|0,0)|0;g=n;n=l;l=J;while(1){if((g|0)<=(x|0)){v=18;break}m=f[h+(g<<2)>>2]|0;i=mJc(m|0,((m|0)<0)<<31>>31|0,n|0,l|0)|0;w=Y(f[k+(g<<2)>>2]|0,m)|0;g=g+-1|0;if(w>>>0<(f[k+(g<<2)>>2]|0)>>>0)break;else{n=i;l=J}}if((v|0)==18?(v=$Ic(0,n|0,32)|0,(n|0)==(v|0)&(l|0)==(J|0)):0){y=c|16384;f[a>>2]=y;u=e;return}y=c&-16385;f[a>>2]=y;u=e;return}function bT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if((a|0)==(b|0))return a|0;c=b+36|0;d=f[c>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+36|0;d=f[e>>2]|0;if((d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)?(d=f[e>>2]|0,d|0):0){f[e>>2]=0;g=f[d+4>>2]|0;if(!g){h=f[a+32>>2]|0;if(!h)i=QS()|0;else i=h}else i=g;mi[f[(f[i>>2]|0)+24>>2]&2047](i,d)}f[e>>2]=0;d=a+16|0;i=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){g=f[a+40>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0;j=f[i>>2]|0}while((h|0)<(j|0));f[a>>2]=f[b>>2];if((j|0)<3)k=17;else{l=f[b+4>>2]|0;k=19}}else{f[a>>2]=f[b>>2];k=17}if((k|0)==17){j=f[b+4>>2]|0;if((j|0)<3){f[i>>2]=j;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];h=f[b+44>>2]|0;g=f[a+44>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{l=j;k=19}}if((k|0)==19?(OS(a,l,0,0,0),(f[i>>2]|0)>0):0){l=f[b+40>>2]|0;k=f[a+40>>2]|0;j=f[b+44>>2]|0;h=f[a+44>>2]|0;g=0;do{f[k+(g<<2)>>2]=f[l+(g<<2)>>2];f[h+(g<<2)>>2]=f[j+(g<<2)>>2];g=g+1|0}while((g|0)<(f[i>>2]|0))}f[d>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[e>>2]=f[c>>2];return a|0}function cT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;f[a>>2]=h;i=a+4|0;f[i>>2]=2;j=a+8|0;k=d+12|0;f[j>>2]=f[k>>2];l=a+12|0;m=d+8|0;f[l>>2]=f[m>>2];n=a+16|0;o=d+4|0;p=c+44|0;q=(f[c+16>>2]|0)+(Y(f[f[p>>2]>>2]|0,f[o>>2]|0)|0)|0;f[n>>2]=q;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];r=a+32|0;f[r>>2]=f[c+32>>2];s=a+36|0;t=f[c+36>>2]|0;f[s>>2]=t;v=a+40|0;f[v>>2]=j;w=a+48|0;x=a+44|0;f[x>>2]=w;f[a+52>>2]=0;f[w>>2]=0;w=t;if((f[c+4>>2]|0)>=3){f[g>>2]=0;f[g+4>>2]=0;y=tT(g,11)|0;z=249001;A=y+11|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NS(-215,g,271731,461)}B=(h>>>3&511)+1<<(47696>>>(h<<1&14)&3);h=f[d>>2]|0;d=q+(Y(B,h)|0)|0;f[n>>2]=d;if((((((h|0)>-1?(d=f[m>>2]|0,(d|0)>-1):0)?(q=c+12|0,C=f[q>>2]|0,(d+h|0)<=(C|0)):0)?(h=f[o>>2]|0,(h|0)>-1):0)?(o=f[k>>2]|0,(o|0)>-1):0)?(D=c+8|0,(o+h|0)<=(f[D>>2]|0)):0){if(!t){E=d;F=C}else{C=w+12|0;f[C>>2]=(f[C>>2]|0)+1;E=f[m>>2]|0;F=f[q>>2]|0}if(!((E|0)>=(F|0)?(f[k>>2]|0)>=(f[D>>2]|0):0))f[a>>2]=f[a>>2]|32768;D=f[x>>2]|0;f[D>>2]=f[f[p>>2]>>2];f[D+4>>2]=B;B=f[a>>2]|0;p=f[i>>2]|0;x=f[v>>2]|0;a:do if((p|0)>0){k=0;while(1){if((f[x+(k<<2)>>2]|0)>1){G=k;break a}F=k+1|0;if((F|0)<(p|0))k=F;else{G=F;break}}}else G=0;while(0);k=p+-1|0;p=f[x+(((k|0)<(G|0)?k:G)<<2)>>2]|0;F=mJc(p|0,((p|0)<0)<<31>>31|0,(B>>>3&511)+1|0,0)|0;p=k;k=F;F=J;while(1){if((p|0)<=(G|0)){H=21;break}E=f[x+(p<<2)>>2]|0;q=mJc(E|0,((E|0)<0)<<31>>31|0,k|0,F|0)|0;m=Y(f[D+(p<<2)>>2]|0,E)|0;p=p+-1|0;if(m>>>0<(f[D+(p<<2)>>2]|0)>>>0){H=23;break}else{k=q;F=J}}if((H|0)==21){p=$Ic(0,k|0,32)|0;if((k|0)==(p|0)&(F|0)==(J|0))I=B|16384;else H=23}if((H|0)==23)I=B&-16385;f[a>>2]=I;if((f[j>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=e;return}I=f[s>>2]|0;if((I|0?(a=I+12|0,I=f[a>>2]|0,f[a>>2]=I+-1,(I|0)==1):0)?(I=f[s>>2]|0,I|0):0){f[s>>2]=0;a=f[I+4>>2]|0;if(!a){B=f[r>>2]|0;if(!B)K=QS()|0;else K=B}else K=a;mi[f[(f[K>>2]|0)+24>>2]&2047](K,I)}f[s>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[v>>2]|0;v=0;do{f[n+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[i>>2]|0))}f[l>>2]=0;f[j>>2]=0;u=e;return}f[g>>2]=0;f[g+4>>2]=0;y=tT(g,124)|0;z=217740;A=y+124|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NS(-215,g,271731,466)}function dT(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=a+8|0;i=a+16|0;j=a+20|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=h;h=a+48|0;f[a+44>>2]=h;f[a+52>>2]=0;f[h>>2]=0;f[a>>2]=d&4095|1124007936;f[i>>2]=e;f[j>>2]=e;OS(a,b,c,g,1);PS(a);return}function eT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=a+8|0;h=a+16|0;i=a+20|0;j=a+40|0;k=a+4|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=g;g=a+48|0;f[a+44>>2]=g;f[a+52>>2]=0;f[g>>2]=0;f[a>>2]=c&4095|1124007936;f[h>>2]=d;f[i>>2]=d;d=f[b>>2]|0;OS(a,(f[b+4>>2]|0)-d>>2,d,e,1);PS(a);return}function fT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+16|0;k=a+40|0;l=h;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=i;i=a+48|0;n=a+44|0;f[n>>2]=i;f[a+52>>2]=0;f[i>>2]=0;i=f[c+4>>2]|0;o=f[d>>2]|0;p=o;if(((f[d+4>>2]|0)-o>>3|0)!=(i|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;q=217865;m=l+23|0;do{b[l>>0]=b[q>>0]|0;l=l+1|0;q=q+1|0}while((l|0)<(m|0));NS(-215,g,271731,537)}o=(i|0)>0;do if(o){r=f[c+40>>2]|0;s=0;while(1){t=p+(s<<3)|0;v=f[t>>2]|0;w=f[t+4>>2]|0;if(!((v|0)==-2147483648&(w|0)==2147483647)){if(!((v|0)>-1&(v|0)<(w|0))){x=11;break}if((w|0)>(f[r+(s<<2)>>2]|0)){x=11;break}}s=s+1|0;if((s|0)>=(i|0)){x=6;break}}if((x|0)==6){bT(a,c)|0;if(!o)break;s=f[d>>2]|0;r=0;do{w=s+(r<<3)|0;v=f[w>>2]|0;t=f[w+4>>2]|0;if((v|0)!=-2147483648|(t|0)!=2147483647?(w=(f[k>>2]|0)+(r<<2)|0,v|0?1:(t|0)!=(f[w>>2]|0)):0){f[w>>2]=t-v;t=Y(f[(f[n>>2]|0)+(r<<2)>>2]|0,v)|0;f[j>>2]=(f[j>>2]|0)+t;f[a>>2]=f[a>>2]|32768}r=r+1|0}while((r|0)!=(i|0))}else if((x|0)==11){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,76)|0;q=217663;m=l+76|0;do{b[l>>0]=b[q>>0]|0;l=l+1|0;q=q+1|0}while((l|0)<(m|0));NS(-215,g,271731,541)}}else bT(a,c)|0;while(0);c=f[a>>2]|0;g=f[h>>2]|0;h=f[k>>2]|0;k=f[n>>2]|0;a:do if((g|0)>0){n=0;while(1){if((f[h+(n<<2)>>2]|0)>1){y=n;break a}q=n+1|0;if((q|0)<(g|0))n=q;else{y=q;break}}}else y=0;while(0);n=g+-1|0;g=f[h+(((n|0)<(y|0)?n:y)<<2)>>2]|0;q=mJc(g|0,((g|0)<0)<<31>>31|0,(c>>>3&511)+1|0,0)|0;g=n;n=q;q=J;while(1){if((g|0)<=(y|0)){x=19;break}l=f[h+(g<<2)>>2]|0;m=mJc(l|0,((l|0)<0)<<31>>31|0,n|0,q|0)|0;i=Y(f[k+(g<<2)>>2]|0,l)|0;g=g+-1|0;if(i>>>0<(f[k+(g<<2)>>2]|0)>>>0)break;else{n=m;q=J}}if((x|0)==19?(x=$Ic(0,n|0,32)|0,(n|0)==(x|0)&(q|0)==(J|0)):0){z=c|16384;f[a>>2]=z;u=e;return}z=c&-16385;f[a>>2]=z;u=e;return}function gT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=c+4|0;i=f[h>>2]|0;if((i|0)>=3){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,9)|0;k=217889;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));NS(-215,g,217899,560)}f[a>>2]=f[c>>2];g=a+4|0;f[g>>2]=i;i=a+8|0;k=c+8|0;f[i>>2]=f[k>>2];j=a+12|0;l=c+12|0;f[j>>2]=f[l>>2];m=a+16|0;f[m>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[a+36>>2]=n;o=a+40|0;f[o>>2]=i;p=a+48|0;q=a+44|0;f[q>>2]=p;f[p>>2]=0;f[a+52>>2]=0;if((n|0)!=0?(p=n+12|0,f[p>>2]=(f[p>>2]|0)+1,p=f[h>>2]|0,(p|0)>=3):0){f[g>>2]=0;OS(a,p,0,0,0);if((f[g>>2]|0)>0){p=f[c+40>>2]|0;n=f[o>>2]|0;r=f[c+44>>2]|0;s=f[q>>2]|0;t=0;do{f[n+(t<<2)>>2]=f[p+(t<<2)>>2];f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)<(f[g>>2]|0))}}else{t=f[c+44>>2]|0;r=f[q>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2]}t=f[h>>2]|0;if((t|0)>0)v=f[(f[c+44>>2]|0)+(t+-1<<2)>>2]|0;else v=0;if((d|0)>-1){t=(f[l>>2]|0)-d|0;h=f[k>>2]|0;r=Y(v,d)|0;w=(h|0)<(t|0)?h:t;x=(f[m>>2]|0)+r|0}else{r=(f[k>>2]|0)+d|0;k=f[l>>2]|0;w=(k|0)<(r|0)?k:r;x=(f[m>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,0-d|0)|0)|0}f[m>>2]=x;f[i>>2]=w;i=f[o>>2]|0;f[i>>2]=w;f[j>>2]=1;f[i+4>>2]=1;j=f[q>>2]|0;f[j>>2]=(f[j>>2]|0)+((w|0)>1?v:0);v=f[a>>2]|0;w=f[g>>2]|0;a:do if((w|0)>0){g=0;while(1){if((f[i+(g<<2)>>2]|0)>1){y=g;break a}q=g+1|0;if((q|0)<(w|0))g=q;else{y=q;break}}}else y=0;while(0);g=w+-1|0;w=f[i+(((g|0)<(y|0)?g:y)<<2)>>2]|0;q=mJc(w|0,((w|0)<0)<<31>>31|0,(v>>>3&511)+1|0,0)|0;w=g;g=q;q=J;while(1){if((w|0)<=(y|0)){z=20;break}o=f[i+(w<<2)>>2]|0;x=mJc(o|0,((o|0)<0)<<31>>31|0,g|0,q|0)|0;m=Y(f[j+(w<<2)>>2]|0,o)|0;w=w+-1|0;if(m>>>0<(f[j+(w<<2)>>2]|0)>>>0){z=22;break}else{g=x;q=J}}if((z|0)==20){w=$Ic(0,g|0,32)|0;if((g|0)==(w|0)&(q|0)==(J|0))A=v|16384;else z=22}if((z|0)==22)A=v&-16385;f[a>>2]=A;v=f[c+40>>2]|0;if(!((f[v>>2]|0)!=1?1:(f[v+4>>2]|0)!=1)){u=e;return}f[a>>2]=A|32768;u=e;return}function hT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+144|0;e=d+120|0;g=d+112|0;h=d+56|0;i=d;if((c|0)<=-1){f[e>>2]=0;f[e+4>>2]=0;j=tT(e,16)|0;k=217904;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));NS(-215,e,217921,626)}if((f[a>>2]&32768|0)==0?(k=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,c)|0)|0,k>>>0<=(f[a+28>>2]|0)>>>0):0){u=d;return}k=a+40|0;m=f[k>>2]|0;n=f[m>>2]|0;if(n>>>0>=c>>>0){u=d;return}f[m>>2]=c;m=a+4|0;o=f[m>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[k>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if((o|0)>0)v=f[(f[a+44>>2]|0)+(o+-1<<2)>>2]|0;else v=0;s=Y(v,p)|0;if(s>>>0<64){p=((Y(s+63|0,c)|0)>>>0)/(s>>>0)|0;f[f[k>>2]>>2]=p;w=f[m>>2]|0}else w=o;o=f[k>>2]|0;m=f[a>>2]&4095;f[h>>2]=1124007936;p=h+4|0;s=h+8|0;c=h+40|0;j=p;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));f[c>>2]=s;s=h+48|0;j=h+44|0;f[j>>2]=s;f[s>>2]=0;f[h+52>>2]=0;XS(h,w,o,m);f[f[k>>2]>>2]=n;if((n|0)>0){f[e>>2]=0;f[e+4>>2]=n;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;$S(i,h,e,g);g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=i;h_(a,e);e=i+36|0;g=f[e>>2]|0;if((g|0?(m=g+12|0,g=f[m>>2]|0,f[m>>2]=g+-1,(g|0)==1):0)?(g=f[e>>2]|0,g|0):0){f[e>>2]=0;m=f[g+4>>2]|0;if(!m){o=f[i+32>>2]|0;if(!o)x=QS()|0;else x=o}else x=m;mi[f[(f[x>>2]|0)+24>>2]&2047](x,g)}f[e>>2]=0;e=i+16|0;g=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[i+40>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[g>>2]|0))}g=f[i+44>>2]|0;if((g|0)!=(i+48|0))g0(g)}bT(a,h)|0;f[f[k>>2]>>2]=n;k=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,n)|0)|0;f[a+24>>2]=k;k=h+36|0;a=f[k>>2]|0;if((a|0?(n=a+12|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)?(a=f[k>>2]|0,a|0):0){f[k>>2]=0;n=f[a+4>>2]|0;if(!n){g=f[h+32>>2]|0;if(!g)y=QS()|0;else y=g}else y=n;mi[f[(f[y>>2]|0)+24>>2]&2047](y,a)}f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[p>>2]|0)>0){k=f[c>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[p>>2]|0))}p=f[j>>2]|0;if((p|0)!=(s|0))g0(p);u=d;return}function iT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=a+40|0;h=f[g>>2]|0;i=f[h>>2]|0;if((i|0)==(c|0)){u=d;return}if((c|0)<=-1){f[e>>2]=0;f[e+4>>2]=0;j=tT(e,16)|0;k=217904;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));NS(-215,e,251123,687)}if(!(f[a>>2]&32768)){e=a+44|0;k=f[e>>2]|0;j=(f[a+16>>2]|0)+(Y(f[k>>2]|0,c)|0)|0;if(j>>>0>(f[a+28>>2]|0)>>>0){m=e;n=7}else{o=h;p=k}}else{m=a+44|0;n=7}if((n|0)==7){hT(a,c);o=f[g>>2]|0;p=f[m>>2]|0}f[o>>2]=c;o=Y(f[p>>2]|0,c-i|0)|0;i=a+24|0;f[i>>2]=(f[i>>2]|0)+o;u=d;return}function jT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;if((h|0)>=3){f[g>>2]=0;i=g+4|0;f[i>>2]=0;j=tT(g,24)|0;k=j;l=217929;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));NS(-215,g,217954,757)}n=a+44|0;o=f[n>>2]|0;p=f[o>>2]|0;if(!p){f[g>>2]=0;i=g+4|0;f[i>>2]=0;j=tT(g,24)|0;k=j;l=217929;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));NS(-215,g,217954,757)}if((h|0)>0)q=f[o+(h+-1<<2)>>2]|0;else q=0;h=f[a+20>>2]|0;g=(f[a+16>>2]|0)-h|0;l=(f[a+24>>2]|0)-h|0;if(!g){f[d+4>>2]=0;r=0;s=0}else{h=(g>>>0)/(p>>>0)|0;f[d+4>>2]=h;r=((g-(Y(f[o>>2]|0,h)|0)|0)>>>0)/(q>>>0)|0;s=h}f[d>>2]=r;d=(f[a+12>>2]|0)+r|0;r=l-(Y(d,q)|0)|0;h=((r>>>0)/((f[f[n>>2]>>2]|0)>>>0)|0)+1|0;n=(f[a+8>>2]|0)+s|0;s=(h|0)<(n|0)?n:h;f[c+4>>2]=s;h=((l-(Y(s+-1|0,f[a+48>>2]|0)|0)|0)>>>0)/(q>>>0)|0;f[c>>2]=(h|0)<(d|0)?d:h;u=e;return}function kT(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+16|0;i=h+8|0;j=h;k=a+4|0;l=f[k>>2]|0;if((l|0)>=3){f[i>>2]=0;m=i+4|0;f[m>>2]=0;n=tT(i,24)|0;o=n;p=217929;q=o+24|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));NS(-215,i,217964,778)}r=a+44|0;s=f[r>>2]|0;if(!(f[s>>2]|0)){f[i>>2]=0;m=i+4|0;f[m>>2]=0;n=tT(i,24)|0;o=n;p=217929;q=o+24|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));NS(-215,i,217964,778)}f[i>>2]=0;p=i+4|0;f[p>>2]=0;f[j>>2]=0;o=j+4|0;f[o>>2]=0;if((l|0)>0)t=f[s+(l+-1<<2)>>2]|0;else t=0;jT(a,i,j);l=f[o>>2]|0;o=l-c|0;c=f[p>>2]|0;p=(o|0)>0?o:0;o=(c|0)<(p|0)?c:p;p=a+8|0;s=l+d+(f[p>>2]|0)|0;d=(c|0)<(s|0)?c:s;s=(d|0)>0?d:0;d=f[j>>2]|0;j=d-e|0;e=f[i>>2]|0;i=(j|0)>0?j:0;j=(e|0)<(i|0)?e:i;i=a+12|0;c=d+g+(f[i>>2]|0)|0;g=(e|0)<(c|0)?e:c;c=(g|0)>0?g:0;g=(o|0)>(s|0);e=g?s:o;q=(j|0)>(c|0);n=q?c:j;m=(Y(n-d|0,t)|0)+(Y(e-l|0,f[a+48>>2]|0)|0)|0;l=a+16|0;f[l>>2]=(f[l>>2]|0)+m;m=(g?o:s)-e|0;f[p>>2]=m;f[i>>2]=(q?j:c)-n;n=f[a+40>>2]|0;f[n>>2]=m;f[n+4>>2]=f[i>>2];i=f[a>>2]|0;c=f[k>>2]|0;k=f[r>>2]|0;a:do if((c|0)<1|(m|0)>1)v=0;else{r=0;while(1){j=r+1|0;if((j|0)>=(c|0)){v=j;break a}if((f[n+(j<<2)>>2]|0)>1){v=j;break}else r=j}}while(0);m=c+-1|0;c=f[n+(((m|0)<(v|0)?m:v)<<2)>>2]|0;r=mJc(c|0,((c|0)<0)<<31>>31|0,(i>>>3&511)+1|0,0)|0;c=m;m=r;r=J;while(1){if((c|0)<=(v|0)){w=12;break}j=f[n+(c<<2)>>2]|0;q=mJc(j|0,((j|0)<0)<<31>>31|0,m|0,r|0)|0;p=Y(f[k+(c<<2)>>2]|0,j)|0;c=c+-1|0;if(p>>>0<(f[k+(c<<2)>>2]|0)>>>0)break;else{m=q;r=J}}if((w|0)==12?(w=$Ic(0,m|0,32)|0,(m|0)==(w|0)&(r|0)==(J|0)):0){x=i|16384;f[a>>2]=x;u=h;return a|0}x=i&-16385;f[a>>2]=x;u=h;return a|0}function lT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;g=u;u=u+64|0;h=g+8|0;i=g;j=f[c>>2]|0;k=(j>>>3&511)+1|0;f[h>>2]=j;j=h+4|0;l=c+4|0;m=f[l>>2]|0;f[j>>2]=m;n=h+8|0;o=c+8|0;f[n>>2]=f[o>>2];p=h+12|0;q=c+12|0;f[p>>2]=f[q>>2];r=h+16|0;f[r>>2]=f[c+16>>2];s=h+20|0;f[s>>2]=f[c+20>>2];t=h+24|0;f[t>>2]=f[c+24>>2];v=h+28|0;f[v>>2]=f[c+28>>2];w=h+32|0;f[w>>2]=f[c+32>>2];x=h+36|0;y=f[c+36>>2]|0;f[x>>2]=y;z=h+40|0;f[z>>2]=n;A=h+48|0;B=h+44|0;f[B>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(!y)C=m;else{m=y+12|0;f[m>>2]=(f[m>>2]|0)+1;C=f[l>>2]|0}if((C|0)>=3){f[j>>2]=0;OS(h,C,0,0,0);if((f[j>>2]|0)>0){C=f[c+40>>2]|0;m=f[z>>2]|0;y=f[c+44>>2]|0;D=f[B>>2]|0;E=0;do{f[m+(E<<2)>>2]=f[C+(E<<2)>>2];f[D+(E<<2)>>2]=f[y+(E<<2)>>2];E=E+1|0}while((E|0)<(f[j>>2]|0))}}else{E=f[c+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[E>>2];f[y+4>>2]=f[E+4>>2]}E=f[l>>2]|0;do if((E|0)>2){if(!((d|0)!=0&(e|0)==0)){if((e|0)<=0){f[i>>2]=0;F=i+4|0;f[F>>2]=0;G=tT(i,9)|0;H=G;I=217889;J=H+9|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));NS(-215,i,217974,817)}f[i>>2]=e;y=f[c+40>>2]|0;D=0;C=1;do{C=Y(f[y+(D<<2)>>2]|0,C)|0;D=D+1|0}while((D|0)!=(E|0));f[i+4>>2]=(C>>>0)/(e>>>0)|0;mT(a,c,d,2,i);break}D=E+-1|0;if((Y(f[(f[c+40>>2]|0)+(D<<2)>>2]|0,k)|0)%(d|0)|0|0){f[i>>2]=0;F=i+4|0;f[F>>2]=0;G=tT(i,9)|0;H=G;I=217889;J=H+9|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));NS(-215,i,217974,817)}C=f[h>>2]|0;y=(d<<3)+-8|0;f[h>>2]=C&-4089|y;f[(f[B>>2]|0)+(D<<2)>>2]=(y>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(f[z>>2]|0)+((f[l>>2]|0)+-1<<2)|0;y=(Y(f[C>>2]|0,k)|0)/(d|0)|0;f[C>>2]=y;f[a>>2]=f[h>>2];y=a+4|0;C=f[j>>2]|0;f[y>>2]=C;m=a+8|0;f[m>>2]=f[n>>2];f[a+12>>2]=f[p>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[s>>2];f[a+24>>2]=f[t>>2];f[a+28>>2]=f[v>>2];f[a+32>>2]=f[w>>2];K=f[x>>2]|0;f[a+36>>2]=K;L=a+40|0;f[L>>2]=m;m=a+48|0;M=a+44|0;f[M>>2]=m;f[m>>2]=0;f[a+52>>2]=0;if(!K)N=C;else{C=K+12|0;f[C>>2]=(f[C>>2]|0)+1;N=f[j>>2]|0}if((N|0)<3){C=f[B>>2]|0;K=f[M>>2]|0;f[K>>2]=f[C>>2];f[K+4>>2]=f[C+4>>2];break}f[y>>2]=0;OS(a,N,0,0,0);if((f[y>>2]|0)>0){C=f[z>>2]|0;K=f[L>>2]|0;L=f[B>>2]|0;m=f[M>>2]|0;M=0;do{f[K+(M<<2)>>2]=f[C+(M<<2)>>2];f[m+(M<<2)>>2]=f[L+(M<<2)>>2];M=M+1|0}while((M|0)<(f[y>>2]|0))}}else{y=(d|0)==0?k:d;M=Y(f[q>>2]|0,k)|0;L=(e|0)==0;if((y|0)>(M|0))if(L)O=26;else{P=e;O=28}else if(L&((M|0)%(y|0)|0|0)!=0)O=26;else{Q=e;O=27}if((O|0)==26){Q=(Y(f[o>>2]|0,M)|0)/(y|0)|0;O=27}if((O|0)==27)if(!Q)R=M;else{P=Q;O=28}do if((O|0)==28){L=f[o>>2]|0;if((P|0)!=(L|0)){m=Y(L,M)|0;L=f[c>>2]|0;if(!(L&16384)){f[i>>2]=0;f[i+4>>2]=0;H=tT(i,72)|0;I=226321;J=H+72|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));NS(-13,i,217974,832)}if(P>>>0>m>>>0){f[i>>2]=0;f[i+4>>2]=0;H=tT(i,22)|0;I=226394;J=H+22|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));NS(-211,i,217974,835)}C=(m|0)/(P|0)|0;if((Y(C,P)|0)==(m|0)){f[n>>2]=P;K=Y(1212424721>>>(L<<2&28)&15,C)|0;f[f[B>>2]>>2]=K;R=C;break}else{f[i>>2]=0;f[i+4>>2]=0;H=tT(i,78)|0;I=226232;J=H+78|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));NS(-5,i,217974,841)}}else R=M}while(0);M=(R|0)/(y|0)|0;if((Y(M,y)|0)!=(R|0)){f[i>>2]=0;f[i+4>>2]=0;H=tT(i,62)|0;I=226417;J=H+62|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));NS(-15,i,217974,851)}f[p>>2]=M;L=f[h>>2]|0;m=(y<<3)+-8|0;C=L&-4089|m;f[h>>2]=C;f[(f[B>>2]|0)+4>>2]=(m>>>3&511)+1<<(47696>>>(L<<1&14)&3);f[a>>2]=C;C=a+4|0;L=f[j>>2]|0;f[C>>2]=L;m=a+8|0;f[m>>2]=f[n>>2];f[a+12>>2]=f[p>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[s>>2];f[a+24>>2]=f[t>>2];f[a+28>>2]=f[v>>2];f[a+32>>2]=f[w>>2];K=f[x>>2]|0;f[a+36>>2]=K;D=a+40|0;f[D>>2]=m;m=a+48|0;S=a+44|0;f[S>>2]=m;f[m>>2]=0;f[a+52>>2]=0;if(!K)T=L;else{L=K+12|0;f[L>>2]=(f[L>>2]|0)+1;T=f[j>>2]|0}if((T|0)<3){L=f[B>>2]|0;K=f[S>>2]|0;f[K>>2]=f[L>>2];f[K+4>>2]=f[L+4>>2];break}f[C>>2]=0;OS(a,T,0,0,0);if((f[C>>2]|0)>0){L=f[z>>2]|0;K=f[D>>2]|0;D=f[B>>2]|0;m=f[S>>2]|0;S=0;do{f[K+(S<<2)>>2]=f[L+(S<<2)>>2];f[m+(S<<2)>>2]=f[D+(S<<2)>>2];S=S+1|0}while((S|0)<(f[C>>2]|0))}}while(0);T=f[x>>2]|0;if((T|0?(a=T+12|0,T=f[a>>2]|0,f[a>>2]=T+-1,(T|0)==1):0)?(T=f[x>>2]|0,T|0):0){f[x>>2]=0;a=f[T+4>>2]|0;if(!a){v=f[w>>2]|0;if(!v)U=QS()|0;else U=v}else U=a;mi[f[(f[U>>2]|0)+24>>2]&2047](U,T)}f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[z>>2]|0;z=0;do{f[r+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[j>>2]|0))}j=f[B>>2]|0;if((j|0)==(A|0)){u=g;return}g0(j);u=g;return}function mT(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h+8|0;j=h;k=c+4|0;l=f[k>>2]|0;if((l|0)==(e|0)){if(!g){lT(a,c,d,0);u=h;return}if((e|0)==2){lT(a,c,d,f[g>>2]|0);u=h;return}}m=f[c>>2]|0;if(!(m&16384)){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,71)|0;o=218209;p=n+71|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));NS(-213,i,217974,907)}if(!((g|0)!=0&((d|0)>-1&(e+-1|0)>>>0<32))){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,62)|0;o=217982;p=n+62|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));NS(-215,i,217974,871)}if(d)if((d|0)<513)q=d;else{f[i>>2]=0;f[i+4>>2]=0;n=tT(i,16)|0;o=218045;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));NS(-215,i,217974,876)}else q=(m>>>3&511)+1|0;if((l|0)<3)r=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{d=f[c+40>>2]|0;s=0;t=1;while(1){v=Y(f[d+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(l|0)){r=v;break}else t=v}}t=Y((m>>>3&511)+1|0,r)|0;r=i+8|0;f[i>>2]=r;m=i+4|0;f[m>>2]=e;if(e>>>0>4){l=XDc(e>>>0>1073741823?-1:e<<2)|0;f[i>>2]=l;w=l}else w=r;a:do if((e|0)>0){l=c+40|0;s=q;d=0;while(1){v=f[g+(d<<2)>>2]|0;if((v|0)<=-1){x=23;break}if(!v){if((d|0)>=(f[k>>2]|0)){x=27;break}y=f[(f[l>>2]|0)+(d<<2)>>2]|0}else y=v;f[w+(d<<2)>>2]=y;v=Y(y,s)|0;d=d+1|0;if((d|0)>=(e|0)){z=v;break a}else s=v}if((x|0)==23){f[j>>2]=0;f[j+4>>2]=0;n=tT(j,14)|0;o=218062;p=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));NS(-215,j,217974,885)}else if((x|0)==27){f[j>>2]=0;f[j+4>>2]=0;n=tT(j,68)|0;o=218077;p=n+68|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));NS(-211,j,217974,892)}}else z=q;while(0);if((z|0)!=(t|0)){f[j>>2]=0;f[j+4>>2]=0;n=tT(j,62)|0;o=218146;p=n+62|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));NS(-209,j,217974,898)}f[a>>2]=f[c>>2];j=a+4|0;o=f[k>>2]|0;f[j>>2]=o;n=a+8|0;f[n>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];p=f[c+36>>2]|0;f[a+36>>2]=p;t=a+40|0;f[t>>2]=n;n=a+48|0;z=a+44|0;f[z>>2]=n;f[n>>2]=0;f[a+52>>2]=0;if(!p)A=o;else{o=p+12|0;f[o>>2]=(f[o>>2]|0)+1;A=f[k>>2]|0}if((A|0)>=3){f[j>>2]=0;OS(a,A,0,0,0);if((f[j>>2]|0)>0){A=f[c+40>>2]|0;k=f[t>>2]|0;t=f[c+44>>2]|0;o=f[z>>2]|0;p=0;do{f[k+(p<<2)>>2]=f[A+(p<<2)>>2];f[o+(p<<2)>>2]=f[t+(p<<2)>>2];p=p+1|0}while((p|0)<(f[j>>2]|0))}}else{j=f[c+44>>2]|0;c=f[z>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2]}f[a>>2]=f[a>>2]&-4089|(q<<3)+-8;OS(a,e,f[i>>2]|0,0,1);e=f[i>>2]|0;if((e|0)!=(r|0)){if(e|0)ZDc(e);f[i>>2]=r;f[m>>2]=4}u=h;return}function nT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=f[e>>2]|0;j=f[e+4>>2]|0;if((i|0)!=(j|0)){mT(a,c,d,j-i>>2,i);u=g;return}i=f[c+16>>2]|0;j=i;d=c+4|0;e=f[d>>2]|0;if(i|0){if((e|0)<3)k=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{i=f[c+40>>2]|0;l=0;m=1;while(1){n=Y(f[i+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(e|0)){k=n;break}else m=n}}if(!((e|0)==0|(k|0)==0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,7)|0;b[k>>0]=b[218281]|0;b[k+1>>0]=b[218282]|0;b[k+2>>0]=b[218283]|0;b[k+3>>0]=b[218284]|0;b[k+4>>0]=b[218285]|0;b[k+5>>0]=b[218286]|0;b[k+6>>0]=b[218287]|0;NS(-215,h,217974,915)}}f[a>>2]=f[c>>2];h=a+4|0;f[h>>2]=e;k=a+8|0;f[k>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=j;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];j=f[c+36>>2]|0;f[a+36>>2]=j;m=a+40|0;f[m>>2]=k;k=a+48|0;l=a+44|0;f[l>>2]=k;f[k>>2]=0;f[a+52>>2]=0;if(!j)o=e;else{e=j+12|0;f[e>>2]=(f[e>>2]|0)+1;o=f[d>>2]|0}if((o|0)<3){d=f[c+44>>2]|0;e=f[l>>2]|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2];u=g;return}f[h>>2]=0;OS(a,o,0,0,0);if((f[h>>2]|0)<=0){u=g;return}o=f[c+40>>2]|0;a=f[m>>2]|0;m=f[c+44>>2]|0;c=f[l>>2]|0;l=0;do{f[a+(l<<2)>>2]=f[o+(l<<2)>>2];f[c+(l<<2)>>2]=f[m+(l<<2)>>2];l=l+1|0}while((l|0)<(f[h>>2]|0));u=g;return}function oT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+112|0;e=d+48|0;g=d;h=d+32|0;i=c+12|0;j=f[i>>2]|0;k=f[c+8>>2]|0;if(!((j|0)==1|(k|0)==1)){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,26)|0;m=218289;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));NS(-215,e,217899,924)}m=j+-1+k|0;k=f[c>>2]&4095;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[a>>2]=1124007936;j=a+8|0;o=a+40|0;l=a+4|0;n=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));f[o>>2]=j;j=a+48|0;f[a+44>>2]=j;f[j>>2]=0;f[a+52>>2]=0;f[e>>2]=m;f[e+4>>2]=m;XS(a,2,e,k);k_(a,g)|0;gT(e,a,0);if((f[i>>2]|0)==1){i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;h_(c,g)}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;c=h+8|0;f[c>>2]=0;f[c+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=e;jR(g,h)}h=e+36|0;g=f[h>>2]|0;if((g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)?(g=f[h>>2]|0,g|0):0){f[h>>2]=0;c=f[g+4>>2]|0;if(!c){i=f[e+32>>2]|0;if(!i)p=QS()|0;else p=i}else p=c;mi[f[(f[p>>2]|0)+24>>2]&2047](p,g)}f[h>>2]=0;h=e+16|0;g=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[g>>2]|0)>0){h=f[e+40>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)==(e+48|0)){u=d;return}g0(g);u=d;return}function pT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;if(!(f[a+16>>2]|0)){e=-1;return e|0}g=f[a>>2]|0;if(!((c|0)<1|(g&7|0)==(c|0))){e=-1;return e|0}c=g&16384;if(!((c|0)!=0|d^1)){e=-1;return e|0}d=f[a+4>>2]|0;switch(d|0){case 2:{if((f[a+8>>2]|0)!=1?(h=f[a+12>>2]|0,(h|0)!=1):0){i=h;j=9}else j=7;if((j|0)==7?((g>>>3&511)+1|0)!=(b|0):0){i=f[a+12>>2]|0;j=9}if((j|0)==9?!((i|0)==(b|0)&(g&4088|0)==0):0){e=-1;return e|0}k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;break}case 3:{if(g&4088|0){e=-1;return e|0}i=f[a+40>>2]|0;if((f[i+8>>2]|0)!=(b|0)){e=-1;return e|0}if((f[i>>2]|0)!=1?(f[i+4>>2]|0)!=1:0){e=-1;return e|0}if((c|0)==0?(c=f[a+44>>2]|0,(f[c+4>>2]|0)!=(Y(f[c+8>>2]|0,b)|0)):0){e=-1;return e|0}c=f[a+40>>2]|0;a=0;i=1;while(1){j=Y(f[c+(a<<2)>>2]|0,i)|0;a=a+1|0;if((a|0)==(d|0)){k=j;break}else i=j}break}default:{e=-1;return e|0}}e=((Y((g>>>3&511)+1|0,k)|0)>>>0)/(b>>>0)|0;return e|0}function qT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=f[b+4>>2]|0;if((d|0)<3){e=f[b>>2]|0;g=f[b+12>>2]|0;h=f[b+8>>2]|0;b=mJc(g|0,((g|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;i=mJc(b|0,J|0,h|0,((h|0)<0)<<31>>31|0)|0;b=J;j=(e&16384|0)==0|((b|0)>0|(b|0)==0&i>>>0>2147483646);b=Y(g,c)|0;f[a>>2]=j?b:i;f[a+4>>2]=j?h:1;return}else _1(d,2,42124)}function rT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+64|0;h=g;i=f[c+4>>2]|0;if((i|0)>=3)_1(i,2,42152);i=f[d+4>>2]|0;if((i|0)>=3)_1(i,2,42180);i=f[c+40>>2]|0;j=f[d+40>>2]|0;if(!((f[i>>2]|0)!=(f[j>>2]|0)?1:(f[i+4>>2]|0)!=(f[j+4>>2]|0))){j=f[c>>2]|0;i=f[d>>2]|0;k=f[c+12>>2]|0;l=f[c+8>>2]|0;m=mJc(k|0,((k|0)<0)<<31>>31|0,e|0,((e|0)<0)<<31>>31|0)|0;n=mJc(m|0,J|0,l|0,((l|0)<0)<<31>>31|0)|0;m=J;o=(j&16384&i|0)==0|((m|0)>0|(m|0)==0&n>>>0>2147483646);m=Y(k,e)|0;p=o?l:1;q=o?m:n;f[a>>2]=q;r=a+4|0;f[r>>2]=p;u=g;return}n=c+8|0;m=f[n>>2]|0;o=c+12|0;l=f[o>>2]|0;k=Y(l,m)|0;if((k|0)!=(Y(f[d+12>>2]|0,f[d+8>>2]|0)|0))$1(k,Wk(d)|0,42208);i=d+12|0;j=d+8|0;if(!((l|0)==1|(m|0)==1)){f[h>>2]=0;f[h+4>>2]=0;s=tT(h,12)|0;t=218371;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));NS(-215,h,218384,974)}if(!((f[i>>2]|0)==1|(f[j>>2]|0)==1)){f[h>>2]=0;f[h+4>>2]=0;s=tT(h,12)|0;t=218404;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));NS(-215,h,218384,974)}m=(f[c>>2]&16384&f[d>>2]|0)==0;l=mJc(k|0,0,e|0,((e|0)<0)<<31>>31|0)|0;w=J;x=(w|0)>0|(w|0)==0&l>>>0>2147483646|m?k:1;lT(h,c,0,x);bT(c,h)|0;c=h+36|0;k=f[c>>2]|0;if((k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)?(k=f[c>>2]|0,k|0):0){f[c>>2]=0;m=f[k+4>>2]|0;if(!m){l=f[h+32>>2]|0;if(!l)y=QS()|0;else y=l}else y=m;mi[f[(f[y>>2]|0)+24>>2]&2047](y,k)}f[c>>2]=0;c=h+16|0;k=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[k>>2]|0)>0){c=f[h+40>>2]|0;y=0;do{f[c+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[k>>2]|0))}k=f[h+44>>2]|0;if((k|0)!=(h+48|0))g0(k);lT(h,d,0,x);bT(d,h)|0;d=h+36|0;x=f[d>>2]|0;if((x|0?(k=x+12|0,x=f[k>>2]|0,f[k>>2]=x+-1,(x|0)==1):0)?(x=f[d>>2]|0,x|0):0){f[d>>2]=0;k=f[x+4>>2]|0;if(!k){y=f[h+32>>2]|0;if(!y)z=QS()|0;else z=y}else z=k;mi[f[(f[z>>2]|0)+24>>2]&2047](z,x)}f[d>>2]=0;d=h+16|0;x=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[x>>2]|0)>0){d=f[h+40>>2]|0;z=0;do{f[d+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)!=(h+48|0))g0(x);x=f[o>>2]|0;if((x|0)!=(f[i>>2]|0)){f[h>>2]=0;A=h+4|0;f[A>>2]=0;B=tT(h,40)|0;s=B;t=218417;v=s+40|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));NS(-215,h,218384,982)}i=f[n>>2]|0;if((i|0)!=(f[j>>2]|0)){f[h>>2]=0;A=h+4|0;f[A>>2]=0;B=tT(h,40)|0;s=B;t=218417;v=s+40|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));NS(-215,h,218384,982)}p=i;q=Y(x,e)|0;f[a>>2]=q;r=a+4|0;f[r>>2]=p;u=g;return}function sT(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=u;u=u+64|0;i=h;j=f[c+4>>2]|0;if((j|0)>=3)_1(j,2,42236);j=f[d+4>>2]|0;if((j|0)>=3)_1(j,2,42264);j=f[e+4>>2]|0;if((j|0)>=3)_1(j,2,42292);j=f[c+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[d+40>>2]|0;if(!((l|0)!=(f[j>>2]|0)?1:(k|0)!=(f[j+4>>2]|0))?(j=f[e+40>>2]|0,!((l|0)!=(f[j>>2]|0)?1:(k|0)!=(f[j+4>>2]|0))):0){j=f[c>>2]|0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[c+12>>2]|0;n=f[c+8>>2]|0;o=mJc(m|0,((m|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;p=mJc(o|0,J|0,n|0,((n|0)<0)<<31>>31|0)|0;o=J;q=(j&16384&k&l|0)==0|((o|0)>0|(o|0)==0&p>>>0>2147483646);o=Y(m,g)|0;r=q?n:1;s=q?o:p;f[a>>2]=s;t=a+4|0;f[t>>2]=r;u=h;return}p=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;if((p|0)!=(Y(f[d+12>>2]|0,f[d+8>>2]|0)|0))$1(p,Wk(d)|0,42320);if((p|0)!=(Y(f[e+12>>2]|0,f[e+8>>2]|0)|0))$1(p,Wk(e)|0,42348);o=c+12|0;q=c+8|0;n=d+12|0;m=d+8|0;l=e+12|0;k=e+8|0;j=(f[l>>2]|0)==1|(f[k>>2]|0)==1;if(!((f[o>>2]|0)==1|(f[q>>2]|0)==1)){f[i>>2]=0;f[i+4>>2]=0;v=tT(i,12)|0;w=218371;x=v+12|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));NS(-215,i,218384,1003)}if(!((f[n>>2]|0)==1|(f[m>>2]|0)==1)){f[i>>2]=0;f[i+4>>2]=0;v=tT(i,12)|0;w=218404;x=v+12|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));NS(-215,i,218384,1003)}if(!j){f[i>>2]=0;f[i+4>>2]=0;v=tT(i,12)|0;w=218542;x=v+12|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));NS(-215,i,218384,1003)}j=(f[c>>2]&16384&f[d>>2]&f[e>>2]|0)==0;y=mJc(p|0,0,g|0,((g|0)<0)<<31>>31|0)|0;z=J;A=(z|0)>0|(z|0)==0&y>>>0>2147483646|j?p:1;lT(i,c,0,A);bT(c,i)|0;c=i+36|0;p=f[c>>2]|0;if((p|0?(j=p+12|0,p=f[j>>2]|0,f[j>>2]=p+-1,(p|0)==1):0)?(p=f[c>>2]|0,p|0):0){f[c>>2]=0;j=f[p+4>>2]|0;if(!j){y=f[i+32>>2]|0;if(!y)B=QS()|0;else B=y}else B=j;mi[f[(f[B>>2]|0)+24>>2]&2047](B,p)}f[c>>2]=0;c=i+16|0;p=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[i+40>>2]|0;B=0;do{f[c+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[p>>2]|0))}p=f[i+44>>2]|0;if((p|0)!=(i+48|0))g0(p);lT(i,d,0,A);bT(d,i)|0;d=i+36|0;p=f[d>>2]|0;if((p|0?(B=p+12|0,p=f[B>>2]|0,f[B>>2]=p+-1,(p|0)==1):0)?(p=f[d>>2]|0,p|0):0){f[d>>2]=0;B=f[p+4>>2]|0;if(!B){c=f[i+32>>2]|0;if(!c)C=QS()|0;else C=c}else C=B;mi[f[(f[C>>2]|0)+24>>2]&2047](C,p)}f[d>>2]=0;d=i+16|0;p=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[p>>2]|0)>0){d=f[i+40>>2]|0;C=0;do{f[d+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[p>>2]|0))}p=f[i+44>>2]|0;if((p|0)!=(i+48|0))g0(p);lT(i,e,0,A);bT(e,i)|0;e=i+36|0;A=f[e>>2]|0;if((A|0?(p=A+12|0,A=f[p>>2]|0,f[p>>2]=A+-1,(A|0)==1):0)?(A=f[e>>2]|0,A|0):0){f[e>>2]=0;p=f[A+4>>2]|0;do if(!p){C=f[i+32>>2]|0;if(C|0){D=C;break}D=QS()|0}else D=p;while(0);mi[f[(f[D>>2]|0)+24>>2]&2047](D,A)}f[e>>2]=0;e=i+16|0;A=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[A>>2]|0)>0){e=f[i+40>>2]|0;D=0;do{f[e+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[A>>2]|0))}A=f[i+44>>2]|0;if((A|0)!=(i+48|0))g0(A);A=f[o>>2]|0;if((A|0)!=(f[n>>2]|0)){f[i>>2]=0;E=i+4|0;f[E>>2]=0;F=tT(i,84)|0;v=F;w=218555;x=v+84|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));NS(-215,i,218384,1012)}n=f[q>>2]|0;if(!(((n|0)==(f[m>>2]|0)?(A|0)==(f[l>>2]|0):0)&(n|0)==(f[k>>2]|0))){f[i>>2]=0;E=i+4|0;f[E>>2]=0;F=tT(i,84)|0;v=F;w=218555;x=v+84|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));NS(-215,i,218384,1012)}r=n;s=Y(A,g)|0;f[a>>2]=s;t=a+4|0;f[t>>2]=r;u=h;return}function tT(a,c){a=a|0;c=c|0;var d=0,e=0;d=f0(c+8&-4)|0;f[d>>2]=1;e=d+4|0;f[a>>2]=e;f[a+4>>2]=c;b[e+c>>0]=0;return f[a>>2]|0}function uT(a){a=a|0;var b=0;b=f[a>>2]|0;f[a+4>>2]=0;f[a>>2]=0;if(!b)return;a=b+-4|0;b=f[a>>2]|0;f[a>>2]=b+-1;if((b|0)!=1)return;g0(a);return}function vT(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;i=u;u=u+208|0;j=i+152|0;k=i+96|0;l=i+80|0;m=i+16|0;o=i+48|0;q=i+44|0;r=i+40|0;s=i+36|0;t=i+32|0;v=i+28|0;w=i+24|0;x=i+8|0;y=i;z=c$(a,-1)|0;A=z&7;B=z>>>3&511;z=B+1|0;C=r$(h)|0;if(!B){if(!C?c$(h,-1)|0:0){f[j>>2]=0;E=j+4|0;f[E>>2]=0;F=tT(j,104)|0;G=F;H=218726;I=G+104|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));wT(-215,j,218831,759)}}else if((g|0)!=0|((e|0)!=0|C^1)){f[j>>2]=0;E=j+4|0;f[E>>2]=0;F=tT(j,104)|0;G=F;H=218726;I=G+104|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));wT(-215,j,218831,759)}do if((d$(a)|0)==65536){F=f[a+4>>2]|0;f[j>>2]=f[F>>2];E=j+4|0;C=F+4|0;f[E>>2]=f[C>>2];B=j+8|0;f[B>>2]=f[F+8>>2];f[j+12>>2]=f[F+12>>2];f[j+16>>2]=f[F+16>>2];f[j+20>>2]=f[F+20>>2];f[j+24>>2]=f[F+24>>2];f[j+28>>2]=f[F+28>>2];f[j+32>>2]=f[F+32>>2];J=f[F+36>>2]|0;f[j+36>>2]=J;f[j+40>>2]=B;B=j+48|0;K=j+44|0;f[K>>2]=B;f[B>>2]=0;f[j+52>>2]=0;if(J|0){B=J+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[C>>2]|0)<3){C=f[F+44>>2]|0;B=f[K>>2]|0;f[B>>2]=f[C>>2];f[B+4>>2]=f[C+4>>2];break}else{f[E>>2]=0;ZS(j,F);break}}else a$(j,a,-1);while(0);do if((d$(h)|0)==65536){a=f[h+4>>2]|0;f[k>>2]=f[a>>2];F=k+4|0;E=a+4|0;f[F>>2]=f[E>>2];C=k+8|0;f[C>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[k+36>>2]=B;f[k+40>>2]=C;C=k+48|0;K=k+44|0;f[K>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[E>>2]|0)<3){E=f[a+44>>2]|0;C=f[K>>2]|0;f[C>>2]=f[E>>2];f[C+4>>2]=f[E+4>>2];break}else{f[F>>2]=0;ZS(k,a);break}}else a$(k,h,-1);while(0);h=j+4|0;a=f[42376+(A<<2)>>2]|0;if((A|0)==7){f[l>>2]=0;f[l+4>>2]=0;G=tT(l,9)|0;H=251213;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));wT(-215,l,218831,776)}f[l>>2]=j;f[l+4>>2]=k;f[l+8>>2]=0;H=m;f[H>>2]=0;f[H+4>>2]=0;z2(o,l,m,-1);f[q>>2]=0;f[r>>2]=0;f[s>>2]=2147483647;f[t>>2]=-2147483648;n[v>>2]=D;n[w>>2]=-D;p[x>>3]=D;p[y>>3]=-D;l=Y(f[o+20>>2]|0,z)|0;z=(A|0)==5;if(!z)if((A|0)==6){L=y;M=x}else{L=t;M=s}else{L=w;M=v}H=o+16|0;if(f[H>>2]|0){G=m+4|0;I=0;F=1;while(1){wi[a&255](f[m>>2]|0,f[G>>2]|0,M,L,q,r,l,F);A2(o)|0;I=I+1|0;if(I>>>0>=(f[H>>2]|0)>>>0)break;else F=F+l|0}}l=j+16|0;do if(f[l>>2]|0){F=f[h>>2]|0;if((F|0)<3)N=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{H=f[j+40>>2]|0;I=0;o=1;while(1){L=Y(f[H+(I<<2)>>2]|0,o)|0;I=I+1|0;if((I|0)==(F|0)){N=L;break}else o=L}}if(!((F|0)==0|(N|0)==0)){if(f[k+16>>2]|0){o=f[k+4>>2]|0;if((o|0)<3)O=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{I=f[k+40>>2]|0;H=0;L=1;while(1){M=Y(f[I+(H<<2)>>2]|0,L)|0;H=H+1|0;if((H|0)==(o|0)){O=M;break}else L=M}}if(!((o|0)==0|(O|0)==0))break}if(!(f[q>>2]|0))f[q>>2]=1;if(!(f[r>>2]|0))f[r>>2]=1}}while(0);O=f[q>>2]|0;q=(O|0)==0;do if(!q){if(z){p[x>>3]=+n[v>>2];p[y>>3]=+n[w>>2];break}if(A>>>0<5){p[x>>3]=+(f[s>>2]|0);p[y>>3]=+(f[t>>2]|0)}}else{p[y>>3]=0.0;p[x>>3]=0.0}while(0);if(c|0)p[c>>3]=+p[x>>3];if(d|0)p[d>>3]=+p[y>>3];do if(e|0){y=f[h>>2]|0;d=(y|0)>0;if(q){if(!d)break;XIc(e|0,-1,y<<2|0)|0;break}if(d){d=f[j+40>>2]|0;x=y;y=O+-1|0;while(1){c=x;x=x+-1|0;t=f[d+(x<<2)>>2]|0;f[e+(x<<2)>>2]=(y>>>0)%(t>>>0)|0;if((c|0)<=1)break;else y=(y>>>0)/(t>>>0)|0}}}while(0);do if(g|0){e=f[r>>2]|0;O=f[h>>2]|0;q=(O|0)>0;if(!e){if(!q)break;XIc(g|0,-1,O<<2|0)|0;break}if(q){q=f[j+40>>2]|0;y=O;O=e+-1|0;while(1){e=y;y=y+-1|0;x=f[q+(y<<2)>>2]|0;f[g+(y<<2)>>2]=(O>>>0)%(x>>>0)|0;if((e|0)<=1)break;else O=(O>>>0)/(x>>>0)|0}}}while(0);g=k+36|0;r=f[g>>2]|0;if(r|0?(O=r+12|0,r=f[O>>2]|0,f[O>>2]=r+-1,(r|0)==1):0)_S(k);f[g>>2]=0;g=k+16|0;r=k+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[r>>2]|0)>0){g=f[k+40>>2]|0;O=0;do{f[g+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[r>>2]|0))}r=f[k+44>>2]|0;if((r|0)!=(k+48|0))g0(r);r=j+36|0;k=f[r>>2]|0;if(k|0?(O=k+12|0,k=f[O>>2]|0,f[O>>2]=k+-1,(k|0)==1):0)_S(j);f[r>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[h>>2]|0)>0){l=f[j+40>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[h>>2]|0))}h=f[j+44>>2]|0;if((h|0)==(j+48|0)){u=i;return}g0(h);u=i;return}function wT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,218841,d);return}function xT(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[d>>2]|0;m=f[e>>2]|0;n=f[g>>2]|0;o=f[i>>2]|0;p=(j|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=h[a+r>>0]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(j|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=m;t=o;s=n;q=l;while(1){r=(b[c+p>>0]|0)!=0;z=h[a+p>>0]|0;y=p+k|0;A=r&(z|0)<(q|0);x=A?z:q;v=A?y:s;A=r&(z|0)>(u|0);r=A?y:t;y=A?z:u;p=p+1|0;if((p|0)==(j|0)){B=x;C=y;D=r;E=v;break}else{u=y;t=r;s=v;q=x}}}else{B=l;C=m;D=o;E=n}f[g>>2]=E;f[i>>2]=D;f[d>>2]=B;f[e>>2]=C;return}function yT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){p=l;q=0;r=n;s=m;t=k;while(1){u=b[a+q>>0]|0;v=(u|0)<(t|0);w=q+j|0;x=v?w:s;y=v?u:t;v=(u|0)>(p|0);z=v?w:r;w=v?u:p;q=q+1|0;if((q|0)==(i|0)){A=y;B=w;C=z;D=x;break}else{p=w;r=z;s=x;t=y}}}else{A=k;B=l;C=n;D=m}else if(o){o=0;t=l;s=n;r=m;p=k;while(1){q=(b[c+o>>0]|0)!=0;y=b[a+o>>0]|0;x=o+j|0;z=q&(y|0)<(p|0);w=z?y:p;u=z?x:r;z=q&(y|0)>(t|0);q=z?x:s;x=z?y:t;o=o+1|0;if((o|0)==(i|0)){A=w;B=x;C=q;D=u;break}else{t=x;s=q;r=u;p=w}}}else{A=k;B=l;C=n;D=m}f[g>>2]=D;f[h>>2]=C;f[d>>2]=A;f[e>>2]=B;return}function zT(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[d>>2]|0;m=f[e>>2]|0;n=f[g>>2]|0;o=f[h>>2]|0;p=(i|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=j[a+(r<<1)>>1]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(i|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=l;t=m;s=o;q=n;while(1){r=(b[c+p>>0]|0)!=0;z=j[a+(p<<1)>>1]|0;y=p+k|0;A=r&(z|0)<(u|0);x=A?z:u;v=A?y:q;A=r&(z|0)>(t|0);r=A?y:s;y=A?z:t;p=p+1|0;if((p|0)==(i|0)){B=x;C=y;D=r;E=v;break}else{u=x;t=y;s=r;q=v}}}else{B=l;C=m;D=o;E=n}f[g>>2]=E;f[h>>2]=D;f[d>>2]=B;f[e>>2]=C;return}function AT(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=f[i>>2]|0;p=(j|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=d[a+(r<<1)>>1]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(j|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=l;t=m;s=o;q=n;while(1){r=(b[c+p>>0]|0)!=0;z=d[a+(p<<1)>>1]|0;y=p+k|0;A=r&(z|0)<(u|0);x=A?z:u;v=A?y:q;A=r&(z|0)>(t|0);r=A?y:s;y=A?z:t;p=p+1|0;if((p|0)==(j|0)){B=x;C=y;D=r;E=v;break}else{u=x;t=y;s=r;q=v}}}else{B=l;C=m;D=o;E=n}f[h>>2]=E;f[i>>2]=D;f[e>>2]=B;f[g>>2]=C;return}function BT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){p=l;q=0;r=n;s=m;t=k;while(1){u=f[a+(q<<2)>>2]|0;v=(u|0)<(t|0);w=q+j|0;x=v?w:s;y=v?u:t;v=(u|0)>(p|0);z=v?w:r;w=v?u:p;q=q+1|0;if((q|0)==(i|0)){A=y;B=w;C=z;D=x;break}else{p=w;r=z;s=x;t=y}}}else{A=k;B=l;C=n;D=m}else if(o){o=0;t=l;s=n;r=m;p=k;while(1){q=f[a+(o<<2)>>2]|0;y=(b[c+o>>0]|0)!=0;x=(q|0)<(p|0)&y;z=o+j|0;w=x?z:r;u=x?q:p;x=(q|0)>(t|0)&y;y=x?z:s;z=x?q:t;o=o+1|0;if((o|0)==(i|0)){A=u;B=z;C=y;D=w;break}else{t=z;s=y;r=w;p=u}}}else{A=k;B=l;C=n;D=m}f[g>>2]=D;f[h>>2]=C;f[d>>2]=A;f[e>>2]=B;return}function CT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0;k=+n[d>>2];l=+n[e>>2];m=f[g>>2]|0;o=f[h>>2]|0;p=(i|0)>0;if(!c)if(p){q=l;r=0;s=o;t=m;u=k;while(1){v=+n[a+(r<<2)>>2];w=v<u;x=r+j|0;y=w?x:t;z=w?v:u;w=v>q;A=w?x:s;B=w?v:q;r=r+1|0;if((r|0)==(i|0)){C=z;D=B;E=A;F=y;break}else{q=B;s=A;t=y;u=z}}}else{C=k;D=l;E=o;F=m}else if(p){p=0;u=l;t=o;s=m;q=k;while(1){z=+n[a+(p<<2)>>2];r=(b[c+p>>0]|0)!=0;y=z<q&r;A=p+j|0;w=y?A:s;B=y?z:q;y=z>u&r;r=y?A:t;v=y?z:u;p=p+1|0;if((p|0)==(i|0)){C=B;D=v;E=r;F=w;break}else{u=v;t=r;s=w;q=B}}}else{C=k;D=l;E=o;F=m}f[g>>2]=F;f[h>>2]=E;n[d>>2]=C;n[e>>2]=D;return}function DT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0;k=+p[d>>3];l=+p[e>>3];m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){q=l;r=0;s=n;t=m;u=k;while(1){v=+p[a+(r<<3)>>3];w=v<u;x=r+j|0;y=w?x:t;z=w?v:u;w=v>q;A=w?x:s;B=w?v:q;r=r+1|0;if((r|0)==(i|0)){C=z;D=B;E=A;F=y;break}else{q=B;s=A;t=y;u=z}}}else{C=k;D=l;E=n;F=m}else if(o){o=0;u=l;t=n;s=m;q=k;while(1){z=+p[a+(o<<3)>>3];r=(b[c+o>>0]|0)!=0;y=z<q&r;A=o+j|0;w=y?A:s;B=y?z:q;y=z>u&r;r=y?A:t;v=y?z:u;o=o+1|0;if((o|0)==(i|0)){C=B;D=v;E=r;F=w;break}else{u=v;t=r;s=w;q=B}}}else{C=k;D=l;E=n;F=m}f[g>>2]=F;f[h>>2]=E;p[d>>3]=C;p[e>>3]=D;return}function ET(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+16|0;j=i;if((n$(a,-1)|0)>=3){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,16)|0;l=218906;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));wT(-215,j,218923,829)}vT(a,c,d,e,g,h);if(e|0){h=e+4|0;d=f[e>>2]|0;f[e>>2]=f[h>>2];f[h>>2]=d}if(!g){u=i;return}d=g+4|0;h=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=h;u=i;return}function FT(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){l=d;m=f;n=a;o=k}else return;while(1){p=0;do{b[m+p>>0]=b[221118+((h[n+p>>0]|0|256)+(h[l+p>>0]|0))>>0]|0;p=p+1|0}while((p|0)!=(i|0));if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=i&-4;if((o|0)<(i|0)){q=d;r=f;s=a;t=k}else{n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=b[221118+((h[f+m>>0]|0|256)+(h[n+m>>0]|0))>>0]|0;b[d+k>>0]=b[221118+((h[f+k>>0]|0|256)+(h[n+k>>0]|0))>>0]|0;b[d+m>>0]=l;l=k|2;m=k|3;p=b[221118+((h[f+m>>0]|0|256)+(h[n+m>>0]|0))>>0]|0;b[d+l>>0]=b[221118+((h[f+l>>0]|0|256)+(h[n+l>>0]|0))>>0]|0;b[d+m>>0]=p;k=k+4|0}while((k|0)<=(j|0));if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[221118+((h[s+f>>0]|0|256)+(h[q+f>>0]|0))>>0]|0;b[r+a>>0]=b[221118+((h[s+a>>0]|0|256)+(h[q+a>>0]|0))>>0]|0;b[r+f>>0]=d;d=a|2;f=a|3;n=b[221118+((h[s+f>>0]|0|256)+(h[q+f>>0]|0))>>0]|0;b[r+d>>0]=b[221118+((h[s+d>>0]|0|256)+(h[q+d>>0]|0))>>0]|0;b[r+f>>0]=n;a=a+4|0}while((a|0)<=(j|0));u=o;do{b[r+u>>0]=b[221118+((h[s+u>>0]|0|256)+(h[q+u>>0]|0))>>0]|0;u=u+1|0}while((u|0)!=(i|0));if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0;t=t+-1|0}}return}function GT(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=(b[k+o>>0]|0)+(b[m+o>>0]|0)|0;b[l+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){q=d;r=f;s=a;t=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=(b[m+j>>0]|0)+(b[f+j>>0]|0)|0;k=j|1;o=(b[m+k>>0]|0)+(b[f+k>>0]|0)|0;b[d+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[d+k>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=j|2;k=(b[m+o>>0]|0)+(b[f+o>>0]|0)|0;l=j|3;p=(b[m+l>>0]|0)+(b[f+l>>0]|0)|0;b[d+o>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[d+l>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=(b[q+a>>0]|0)+(b[s+a>>0]|0)|0;d=a|1;m=(b[q+d>>0]|0)+(b[s+d>>0]|0)|0;b[r+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[r+d>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;m=a|2;d=(b[q+m>>0]|0)+(b[s+m>>0]|0)|0;f=a|3;j=(b[q+f>>0]|0)+(b[s+f>>0]|0)|0;b[r+m>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[r+f>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;a=a+4|0}while((a|0)<=(i|0));u=n;do{a=(b[q+u>>0]|0)+(b[s+u>>0]|0)|0;b[r+u>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;u=u+1|0}while((u|0)!=(h|0));if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0;t=t+-1|0}}return}function HT(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){l=c;m=f;n=a;o=g}else return;while(1){p=0;do{q=(j[l+(p<<1)>>1]|0)+(j[n+(p<<1)>>1]|0)|0;d[m+(p<<1)>>1]=q>>>0<65536?q:q|0?65535:0;p=p+1|0}while((p|0)!=(h|0));if(!o)break;else{l=l+(b<<1)|0;m=m+(e<<1)|0;n=n+(k<<1)|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=g;while(1){g=0;do{l=(j[m+(g<<1)>>1]|0)+(j[f+(g<<1)>>1]|0)|0;p=g|1;q=(j[m+(p<<1)>>1]|0)+(j[f+(p<<1)>>1]|0)|0;d[c+(g<<1)>>1]=l>>>0<65536?l:l|0?65535:0;d[c+(p<<1)>>1]=q>>>0<65536?q:q|0?65535:0;q=g|2;p=(j[m+(q<<1)>>1]|0)+(j[f+(q<<1)>>1]|0)|0;l=g|3;r=(j[m+(l<<1)>>1]|0)+(j[f+(l<<1)>>1]|0)|0;d[c+(q<<1)>>1]=p>>>0<65536?p:p|0?65535:0;d[c+(l<<1)>>1]=r>>>0<65536?r:r|0?65535:0;g=g+4|0}while((g|0)<=(i|0));if(n){g=o;do{r=(j[m+(g<<1)>>1]|0)+(j[f+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=r>>>0<65536?r:r|0?65535:0;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0;a=a+-1|0}}return}function IT(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=(d[k+(o<<1)>>1]|0)+(d[m+(o<<1)>>1]|0)|0;d[l+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=c;c=f;f=a;a=g;while(1){g=0;do{k=(d[l+(g<<1)>>1]|0)+(d[f+(g<<1)>>1]|0)|0;o=g|1;p=(d[l+(o<<1)>>1]|0)+(d[f+(o<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[c+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=g|2;o=(d[l+(p<<1)>>1]|0)+(d[f+(p<<1)>>1]|0)|0;k=g|3;q=(d[l+(k<<1)>>1]|0)+(d[f+(k<<1)>>1]|0)|0;d[c+(p<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[c+(k<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+4|0}while((g|0)<=(i|0));if(m){g=n;do{q=(d[l+(g<<1)>>1]|0)+(d[f+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}function JT(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{f[l+(o<<2)>>2]=(f[k+(o<<2)>>2]|0)+(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=c;q=e;r=a;s=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=g|1;k=(f[m+(l<<2)>>2]|0)+(f[e+(l<<2)>>2]|0)|0;f[c+(g<<2)>>2]=(f[m+(g<<2)>>2]|0)+(f[e+(g<<2)>>2]|0);f[c+(l<<2)>>2]=k;k=g|2;l=g|3;o=(f[m+(l<<2)>>2]|0)+(f[e+(l<<2)>>2]|0)|0;f[c+(k<<2)>>2]=(f[m+(k<<2)>>2]|0)+(f[e+(k<<2)>>2]|0);f[c+(l<<2)>>2]=o;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;c=(f[p+(e<<2)>>2]|0)+(f[r+(e<<2)>>2]|0)|0;f[q+(a<<2)>>2]=(f[p+(a<<2)>>2]|0)+(f[r+(a<<2)>>2]|0);f[q+(e<<2)>>2]=c;c=a|2;e=a|3;m=(f[p+(e<<2)>>2]|0)+(f[r+(e<<2)>>2]|0)|0;f[q+(c<<2)>>2]=(f[p+(c<<2)>>2]|0)+(f[r+(c<<2)>>2]|0);f[q+(e<<2)>>2]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{f[q+(t<<2)>>2]=(f[p+(t<<2)>>2]|0)+(f[r+(t<<2)>>2]|0);t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+(b<<2)|0;q=q+(d<<2)|0;r=r+(j<<2)|0;s=s+-1|0}}return}function KT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{n[k+(o<<2)>>2]=+n[l+(o<<2)>>2]+ +n[j+(o<<2)>>2];o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){p=c;q=e;r=a;s=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{k=f|1;t=+n[e+(k<<2)>>2]+ +n[l+(k<<2)>>2];n[c+(f<<2)>>2]=+n[e+(f<<2)>>2]+ +n[l+(f<<2)>>2];n[c+(k<<2)>>2]=t;k=f|2;j=f|3;t=+n[e+(j<<2)>>2]+ +n[l+(j<<2)>>2];n[c+(k<<2)>>2]=+n[e+(k<<2)>>2]+ +n[l+(k<<2)>>2];n[c+(j<<2)>>2]=t;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=+n[r+(e<<2)>>2]+ +n[p+(e<<2)>>2];n[q+(a<<2)>>2]=+n[r+(a<<2)>>2]+ +n[p+(a<<2)>>2];n[q+(e<<2)>>2]=t;e=a|2;c=a|3;t=+n[r+(c<<2)>>2]+ +n[p+(c<<2)>>2];n[q+(e<<2)>>2]=+n[r+(e<<2)>>2]+ +n[p+(e<<2)>>2];n[q+(c<<2)>>2]=t;a=a+4|0}while((a|0)<=(h|0));u=m;do{n[q+(u<<2)>>2]=+n[r+(u<<2)>>2]+ +n[p+(u<<2)>>2];u=u+1|0}while((u|0)!=(g|0));if(!s)break;else{p=p+(b<<2)|0;q=q+(d<<2)|0;r=r+(i<<2)|0;s=s+-1|0}}return}function LT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{p[k+(n<<3)>>3]=+p[l+(n<<3)>>3]+ +p[j+(n<<3)>>3];n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){o=c;q=e;r=a;s=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{k=f|1;t=+p[e+(k<<3)>>3]+ +p[l+(k<<3)>>3];p[c+(f<<3)>>3]=+p[e+(f<<3)>>3]+ +p[l+(f<<3)>>3];p[c+(k<<3)>>3]=t;k=f|2;j=f|3;t=+p[e+(j<<3)>>3]+ +p[l+(j<<3)>>3];p[c+(k<<3)>>3]=+p[e+(k<<3)>>3]+ +p[l+(k<<3)>>3];p[c+(j<<3)>>3]=t;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=+p[r+(e<<3)>>3]+ +p[o+(e<<3)>>3];p[q+(a<<3)>>3]=+p[r+(a<<3)>>3]+ +p[o+(a<<3)>>3];p[q+(e<<3)>>3]=t;e=a|2;c=a|3;t=+p[r+(c<<3)>>3]+ +p[o+(c<<3)>>3];p[q+(e<<3)>>3]=+p[r+(e<<3)>>3]+ +p[o+(e<<3)>>3];p[q+(c<<3)>>3]=t;a=a+4|0}while((a|0)<=(h|0));u=m;do{p[q+(u<<3)>>3]=+p[r+(u<<3)>>3]+ +p[o+(u<<3)>>3];u=u+1|0}while((u|0)!=(g|0));if(!s)break;else{o=o+(b<<3)|0;q=q+(d<<3)|0;r=r+(i<<3)|0;s=s+-1|0}}return}function MT(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){l=d;m=f;n=a;o=k}else return;while(1){p=0;do{b[m+p>>0]=b[221118+((h[n+p>>0]|0|256)-(h[l+p>>0]|0))>>0]|0;p=p+1|0}while((p|0)!=(i|0));if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=i&-4;if((o|0)<(i|0)){q=d;r=f;s=a;t=k}else{n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=b[221118+((h[f+m>>0]|0|256)-(h[n+m>>0]|0))>>0]|0;b[d+k>>0]=b[221118+((h[f+k>>0]|0|256)-(h[n+k>>0]|0))>>0]|0;b[d+m>>0]=l;l=k|2;m=k|3;p=b[221118+((h[f+m>>0]|0|256)-(h[n+m>>0]|0))>>0]|0;b[d+l>>0]=b[221118+((h[f+l>>0]|0|256)-(h[n+l>>0]|0))>>0]|0;b[d+m>>0]=p;k=k+4|0}while((k|0)<=(j|0));if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[221118+((h[s+f>>0]|0|256)-(h[q+f>>0]|0))>>0]|0;b[r+a>>0]=b[221118+((h[s+a>>0]|0|256)-(h[q+a>>0]|0))>>0]|0;b[r+f>>0]=d;d=a|2;f=a|3;n=b[221118+((h[s+f>>0]|0|256)-(h[q+f>>0]|0))>>0]|0;b[r+d>>0]=b[221118+((h[s+d>>0]|0|256)-(h[q+d>>0]|0))>>0]|0;b[r+f>>0]=n;a=a+4|0}while((a|0)<=(j|0));u=o;do{b[r+u>>0]=b[221118+((h[s+u>>0]|0|256)-(h[q+u>>0]|0))>>0]|0;u=u+1|0}while((u|0)!=(i|0));if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0;t=t+-1|0}}return}function NT(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=(b[m+o>>0]|0)-(b[k+o>>0]|0)|0;b[l+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){q=d;r=f;s=a;t=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=(b[f+j>>0]|0)-(b[m+j>>0]|0)|0;k=j|1;o=(b[f+k>>0]|0)-(b[m+k>>0]|0)|0;b[d+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[d+k>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=j|2;k=(b[f+o>>0]|0)-(b[m+o>>0]|0)|0;l=j|3;p=(b[f+l>>0]|0)-(b[m+l>>0]|0)|0;b[d+o>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[d+l>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=(b[s+a>>0]|0)-(b[q+a>>0]|0)|0;d=a|1;m=(b[s+d>>0]|0)-(b[q+d>>0]|0)|0;b[r+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[r+d>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;m=a|2;d=(b[s+m>>0]|0)-(b[q+m>>0]|0)|0;f=a|3;j=(b[s+f>>0]|0)-(b[q+f>>0]|0)|0;b[r+m>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[r+f>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;a=a+4|0}while((a|0)<=(i|0));u=n;do{a=(b[s+u>>0]|0)-(b[q+u>>0]|0)|0;b[r+u>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;u=u+1|0}while((u|0)!=(h|0));if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0;t=t+-1|0}}return}function OT(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){l=c;m=f;n=a;o=g}else return;while(1){p=0;do{q=(j[n+(p<<1)>>1]|0)-(j[l+(p<<1)>>1]|0)|0;d[m+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;p=p+1|0}while((p|0)!=(h|0));if(!o)break;else{l=l+(b<<1)|0;m=m+(e<<1)|0;n=n+(k<<1)|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=g;while(1){g=0;do{l=(j[f+(g<<1)>>1]|0)-(j[m+(g<<1)>>1]|0)|0;p=g|1;q=(j[f+(p<<1)>>1]|0)-(j[m+(p<<1)>>1]|0)|0;d[c+(g<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;d[c+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;q=g|2;p=(j[f+(q<<1)>>1]|0)-(j[m+(q<<1)>>1]|0)|0;l=g|3;r=(j[f+(l<<1)>>1]|0)-(j[m+(l<<1)>>1]|0)|0;d[c+(q<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;d[c+(l<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;g=g+4|0}while((g|0)<=(i|0));if(n){g=o;do{r=(j[f+(g<<1)>>1]|0)-(j[m+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0;a=a+-1|0}}return}function PT(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=(d[m+(o<<1)>>1]|0)-(d[k+(o<<1)>>1]|0)|0;d[l+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=c;c=f;f=a;a=g;while(1){g=0;do{k=(d[f+(g<<1)>>1]|0)-(d[l+(g<<1)>>1]|0)|0;o=g|1;p=(d[f+(o<<1)>>1]|0)-(d[l+(o<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[c+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=g|2;o=(d[f+(p<<1)>>1]|0)-(d[l+(p<<1)>>1]|0)|0;k=g|3;q=(d[f+(k<<1)>>1]|0)-(d[l+(k<<1)>>1]|0)|0;d[c+(p<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[c+(k<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+4|0}while((g|0)<=(i|0));if(m){g=n;do{q=(d[f+(g<<1)>>1]|0)-(d[l+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}function QT(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{f[l+(o<<2)>>2]=(f[m+(o<<2)>>2]|0)-(f[k+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=c;q=e;r=a;s=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=g|1;k=(f[e+(l<<2)>>2]|0)-(f[m+(l<<2)>>2]|0)|0;f[c+(g<<2)>>2]=(f[e+(g<<2)>>2]|0)-(f[m+(g<<2)>>2]|0);f[c+(l<<2)>>2]=k;k=g|2;l=g|3;o=(f[e+(l<<2)>>2]|0)-(f[m+(l<<2)>>2]|0)|0;f[c+(k<<2)>>2]=(f[e+(k<<2)>>2]|0)-(f[m+(k<<2)>>2]|0);f[c+(l<<2)>>2]=o;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;c=(f[r+(e<<2)>>2]|0)-(f[p+(e<<2)>>2]|0)|0;f[q+(a<<2)>>2]=(f[r+(a<<2)>>2]|0)-(f[p+(a<<2)>>2]|0);f[q+(e<<2)>>2]=c;c=a|2;e=a|3;m=(f[r+(e<<2)>>2]|0)-(f[p+(e<<2)>>2]|0)|0;f[q+(c<<2)>>2]=(f[r+(c<<2)>>2]|0)-(f[p+(c<<2)>>2]|0);f[q+(e<<2)>>2]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{f[q+(t<<2)>>2]=(f[r+(t<<2)>>2]|0)-(f[p+(t<<2)>>2]|0);t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+(b<<2)|0;q=q+(d<<2)|0;r=r+(j<<2)|0;s=s+-1|0}}return}function RT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{n[k+(o<<2)>>2]=+n[l+(o<<2)>>2]-+n[j+(o<<2)>>2];o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){p=c;q=e;r=a;s=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{k=f|1;t=+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2];n[c+(f<<2)>>2]=+n[e+(f<<2)>>2]-+n[l+(f<<2)>>2];n[c+(k<<2)>>2]=t;k=f|2;j=f|3;t=+n[e+(j<<2)>>2]-+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2];n[c+(j<<2)>>2]=t;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=+n[r+(e<<2)>>2]-+n[p+(e<<2)>>2];n[q+(a<<2)>>2]=+n[r+(a<<2)>>2]-+n[p+(a<<2)>>2];n[q+(e<<2)>>2]=t;e=a|2;c=a|3;t=+n[r+(c<<2)>>2]-+n[p+(c<<2)>>2];n[q+(e<<2)>>2]=+n[r+(e<<2)>>2]-+n[p+(e<<2)>>2];n[q+(c<<2)>>2]=t;a=a+4|0}while((a|0)<=(h|0));u=m;do{n[q+(u<<2)>>2]=+n[r+(u<<2)>>2]-+n[p+(u<<2)>>2];u=u+1|0}while((u|0)!=(g|0));if(!s)break;else{p=p+(b<<2)|0;q=q+(d<<2)|0;r=r+(i<<2)|0;s=s+-1|0}}return}function ST(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{p[k+(n<<3)>>3]=+p[l+(n<<3)>>3]-+p[j+(n<<3)>>3];n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){o=c;q=e;r=a;s=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{k=f|1;t=+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3];p[c+(f<<3)>>3]=+p[e+(f<<3)>>3]-+p[l+(f<<3)>>3];p[c+(k<<3)>>3]=t;k=f|2;j=f|3;t=+p[e+(j<<3)>>3]-+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3];p[c+(j<<3)>>3]=t;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=+p[r+(e<<3)>>3]-+p[o+(e<<3)>>3];p[q+(a<<3)>>3]=+p[r+(a<<3)>>3]-+p[o+(a<<3)>>3];p[q+(e<<3)>>3]=t;e=a|2;c=a|3;t=+p[r+(c<<3)>>3]-+p[o+(c<<3)>>3];p[q+(e<<3)>>3]=+p[r+(e<<3)>>3]-+p[o+(e<<3)>>3];p[q+(c<<3)>>3]=t;a=a+4|0}while((a|0)<=(h|0));u=m;do{p[q+(u<<3)>>3]=+p[r+(u<<3)>>3]-+p[o+(u<<3)>>3];u=u+1|0}while((u|0)!=(g|0));if(!s)break;else{o=o+(b<<3)|0;q=q+(d<<3)|0;r=r+(i<<3)|0;s=s+-1|0}}return}function TT(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){l=d;m=f;n=a;o=k}else return;while(1){p=0;do{q=h[n+p>>0]|0;b[m+p>>0]=q-(h[221118+((q|256)-(h[l+p>>0]|0))>>0]|0);p=p+1|0}while((p|0)!=(i|0));if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=i&-4;if((o|0)<(i|0)){r=d;s=f;t=a;u=k}else{n=d;d=f;f=a;a=k;while(1){k=0;do{m=h[f+k>>0]|0;l=k|1;p=h[f+l>>0]|0;q=p-(h[221118+((p|256)-(h[n+l>>0]|0))>>0]|0)&255;b[d+k>>0]=m-(h[221118+((m|256)-(h[n+k>>0]|0))>>0]|0);b[d+l>>0]=q;q=k|2;l=h[f+q>>0]|0;m=k|3;p=h[f+m>>0]|0;v=p-(h[221118+((p|256)-(h[n+m>>0]|0))>>0]|0)&255;b[d+q>>0]=l-(h[221118+((l|256)-(h[n+q>>0]|0))>>0]|0);b[d+m>>0]=v;k=k+4|0}while((k|0)<=(j|0));if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=h[t+a>>0]|0;d=a|1;n=h[t+d>>0]|0;k=n-(h[221118+((n|256)-(h[r+d>>0]|0))>>0]|0)&255;b[s+a>>0]=f-(h[221118+((f|256)-(h[r+a>>0]|0))>>0]|0);b[s+d>>0]=k;k=a|2;d=h[t+k>>0]|0;f=a|3;n=h[t+f>>0]|0;v=n-(h[221118+((n|256)-(h[r+f>>0]|0))>>0]|0)&255;b[s+k>>0]=d-(h[221118+((d|256)-(h[r+k>>0]|0))>>0]|0);b[s+f>>0]=v;a=a+4|0}while((a|0)<=(j|0));w=o;do{a=h[t+w>>0]|0;b[s+w>>0]=a-(h[221118+((a|256)-(h[r+w>>0]|0))>>0]|0);w=w+1|0}while((w|0)!=(i|0));if(!u)break;else{r=r+e|0;s=s+g|0;t=t+c|0;u=u+-1|0}}return}function UT(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=b[m+o>>0]|0;q=b[k+o>>0]|0;b[l+o>>0]=q<<24>>24<p<<24>>24?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=d;s=f;t=a;u=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=b[f+j>>0]|0;k=b[m+j>>0]|0;o=j|1;p=b[f+o>>0]|0;q=b[m+o>>0]|0;b[d+j>>0]=k<<24>>24<l<<24>>24?k:l;b[d+o>>0]=q<<24>>24<p<<24>>24?q:p;p=j|2;q=b[f+p>>0]|0;o=b[m+p>>0]|0;l=j|3;k=b[f+l>>0]|0;v=b[m+l>>0]|0;b[d+p>>0]=o<<24>>24<q<<24>>24?o:q;b[d+l>>0]=v<<24>>24<k<<24>>24?v:k;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=b[t+a>>0]|0;d=b[r+a>>0]|0;m=a|1;j=b[t+m>>0]|0;k=b[r+m>>0]|0;b[s+a>>0]=d<<24>>24<f<<24>>24?d:f;b[s+m>>0]=k<<24>>24<j<<24>>24?k:j;j=a|2;k=b[t+j>>0]|0;m=b[r+j>>0]|0;f=a|3;d=b[t+f>>0]|0;v=b[r+f>>0]|0;b[s+j>>0]=m<<24>>24<k<<24>>24?m:k;b[s+f>>0]=v<<24>>24<d<<24>>24?v:d;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=b[t+w>>0]|0;d=b[r+w>>0]|0;b[s+w>>0]=d<<24>>24<a<<24>>24?d:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+e|0;s=s+g|0;t=t+c|0;u=u+-1|0}}return}function VT(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;d[l+(o<<1)>>1]=(q&65535)<(p&65535)?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=f;t=a;u=g}else{m=c;c=f;f=a;a=g;while(1){g=0;do{l=d[f+(g<<1)>>1]|0;k=d[m+(g<<1)>>1]|0;o=g|1;p=d[f+(o<<1)>>1]|0;q=d[m+(o<<1)>>1]|0;d[c+(g<<1)>>1]=(k&65535)<(l&65535)?k:l;d[c+(o<<1)>>1]=(q&65535)<(p&65535)?q:p;p=g|2;q=d[f+(p<<1)>>1]|0;o=d[m+(p<<1)>>1]|0;l=g|3;k=d[f+(l<<1)>>1]|0;v=d[m+(l<<1)>>1]|0;d[c+(p<<1)>>1]=(o&65535)<(q&65535)?o:q;d[c+(l<<1)>>1]=(v&65535)<(k&65535)?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=d[t+(a<<1)>>1]|0;c=d[r+(a<<1)>>1]|0;m=a|1;g=d[t+(m<<1)>>1]|0;k=d[r+(m<<1)>>1]|0;d[s+(a<<1)>>1]=(c&65535)<(f&65535)?c:f;d[s+(m<<1)>>1]=(k&65535)<(g&65535)?k:g;g=a|2;k=d[t+(g<<1)>>1]|0;m=d[r+(g<<1)>>1]|0;f=a|3;c=d[t+(f<<1)>>1]|0;v=d[r+(f<<1)>>1]|0;d[s+(g<<1)>>1]=(m&65535)<(k&65535)?m:k;d[s+(f<<1)>>1]=(v&65535)<(c&65535)?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=d[t+(w<<1)>>1]|0;c=d[r+(w<<1)>>1]|0;d[s+(w<<1)>>1]=(c&65535)<(a&65535)?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0;u=u+-1|0}}return}function WT(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;d[l+(o<<1)>>1]=q<<16>>16<p<<16>>16?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=f;t=a;u=g}else{m=c;c=f;f=a;a=g;while(1){g=0;do{l=d[f+(g<<1)>>1]|0;k=d[m+(g<<1)>>1]|0;o=g|1;p=d[f+(o<<1)>>1]|0;q=d[m+(o<<1)>>1]|0;d[c+(g<<1)>>1]=k<<16>>16<l<<16>>16?k:l;d[c+(o<<1)>>1]=q<<16>>16<p<<16>>16?q:p;p=g|2;q=d[f+(p<<1)>>1]|0;o=d[m+(p<<1)>>1]|0;l=g|3;k=d[f+(l<<1)>>1]|0;v=d[m+(l<<1)>>1]|0;d[c+(p<<1)>>1]=o<<16>>16<q<<16>>16?o:q;d[c+(l<<1)>>1]=v<<16>>16<k<<16>>16?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=d[t+(a<<1)>>1]|0;c=d[r+(a<<1)>>1]|0;m=a|1;g=d[t+(m<<1)>>1]|0;k=d[r+(m<<1)>>1]|0;d[s+(a<<1)>>1]=c<<16>>16<f<<16>>16?c:f;d[s+(m<<1)>>1]=k<<16>>16<g<<16>>16?k:g;g=a|2;k=d[t+(g<<1)>>1]|0;m=d[r+(g<<1)>>1]|0;f=a|3;c=d[t+(f<<1)>>1]|0;v=d[r+(f<<1)>>1]|0;d[s+(g<<1)>>1]=m<<16>>16<k<<16>>16?m:k;d[s+(f<<1)>>1]=v<<16>>16<c<<16>>16?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=d[t+(w<<1)>>1]|0;c=d[r+(w<<1)>>1]|0;d[s+(w<<1)>>1]=c<<16>>16<a<<16>>16?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0;u=u+-1|0}}return}function XT(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{p=f[m+(o<<2)>>2]|0;q=f[k+(o<<2)>>2]|0;f[l+(o<<2)>>2]=(q|0)<(p|0)?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=e;t=a;u=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=f[e+(g<<2)>>2]|0;k=f[m+(g<<2)>>2]|0;o=g|1;p=f[e+(o<<2)>>2]|0;q=f[m+(o<<2)>>2]|0;f[c+(g<<2)>>2]=(k|0)<(l|0)?k:l;f[c+(o<<2)>>2]=(q|0)<(p|0)?q:p;p=g|2;q=f[e+(p<<2)>>2]|0;o=f[m+(p<<2)>>2]|0;l=g|3;k=f[e+(l<<2)>>2]|0;v=f[m+(l<<2)>>2]|0;f[c+(p<<2)>>2]=(o|0)<(q|0)?o:q;f[c+(l<<2)>>2]=(v|0)<(k|0)?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=f[t+(a<<2)>>2]|0;c=f[r+(a<<2)>>2]|0;m=a|1;g=f[t+(m<<2)>>2]|0;k=f[r+(m<<2)>>2]|0;f[s+(a<<2)>>2]=(c|0)<(e|0)?c:e;f[s+(m<<2)>>2]=(k|0)<(g|0)?k:g;g=a|2;k=f[t+(g<<2)>>2]|0;m=f[r+(g<<2)>>2]|0;e=a|3;c=f[t+(e<<2)>>2]|0;v=f[r+(e<<2)>>2]|0;f[s+(g<<2)>>2]=(m|0)<(k|0)?m:k;f[s+(e<<2)>>2]=(v|0)<(c|0)?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=f[t+(w<<2)>>2]|0;c=f[r+(w<<2)>>2]|0;f[s+(w<<2)>>2]=(c|0)<(a|0)?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(j<<2)|0;u=u+-1|0}}return}function YT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{p=+n[l+(o<<2)>>2];q=+n[j+(o<<2)>>2];n[k+(o<<2)>>2]=q<p?q:p;o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){r=c;s=e;t=a;u=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{p=+n[e+(f<<2)>>2];q=+n[l+(f<<2)>>2];k=f|1;v=+n[e+(k<<2)>>2];w=+n[l+(k<<2)>>2];n[c+(f<<2)>>2]=q<p?q:p;n[c+(k<<2)>>2]=w<v?w:v;k=f|2;v=+n[e+(k<<2)>>2];w=+n[l+(k<<2)>>2];j=f|3;p=+n[e+(j<<2)>>2];q=+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=w<v?w:v;n[c+(j<<2)>>2]=q<p?q:p;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{p=+n[t+(a<<2)>>2];q=+n[r+(a<<2)>>2];e=a|1;v=+n[t+(e<<2)>>2];w=+n[r+(e<<2)>>2];n[s+(a<<2)>>2]=q<p?q:p;n[s+(e<<2)>>2]=w<v?w:v;e=a|2;v=+n[t+(e<<2)>>2];w=+n[r+(e<<2)>>2];c=a|3;p=+n[t+(c<<2)>>2];q=+n[r+(c<<2)>>2];n[s+(e<<2)>>2]=w<v?w:v;n[s+(c<<2)>>2]=q<p?q:p;a=a+4|0}while((a|0)<=(h|0));x=m;do{p=+n[t+(x<<2)>>2];q=+n[r+(x<<2)>>2];n[s+(x<<2)>>2]=q<p?q:p;x=x+1|0}while((x|0)!=(g|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(i<<2)|0;u=u+-1|0}}return}function ZT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{o=+p[l+(n<<3)>>3];q=+p[j+(n<<3)>>3];p[k+(n<<3)>>3]=q<o?q:o;n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){r=c;s=e;t=a;u=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{o=+p[e+(f<<3)>>3];q=+p[l+(f<<3)>>3];k=f|1;v=+p[e+(k<<3)>>3];w=+p[l+(k<<3)>>3];p[c+(f<<3)>>3]=q<o?q:o;p[c+(k<<3)>>3]=w<v?w:v;k=f|2;v=+p[e+(k<<3)>>3];w=+p[l+(k<<3)>>3];j=f|3;o=+p[e+(j<<3)>>3];q=+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=w<v?w:v;p[c+(j<<3)>>3]=q<o?q:o;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{o=+p[t+(a<<3)>>3];q=+p[r+(a<<3)>>3];e=a|1;v=+p[t+(e<<3)>>3];w=+p[r+(e<<3)>>3];p[s+(a<<3)>>3]=q<o?q:o;p[s+(e<<3)>>3]=w<v?w:v;e=a|2;v=+p[t+(e<<3)>>3];w=+p[r+(e<<3)>>3];c=a|3;o=+p[t+(c<<3)>>3];q=+p[r+(c<<3)>>3];p[s+(e<<3)>>3]=w<v?w:v;p[s+(c<<3)>>3]=q<o?q:o;a=a+4|0}while((a|0)<=(h|0));x=m;do{o=+p[t+(x<<3)>>3];q=+p[r+(x<<3)>>3];p[s+(x<<3)>>3]=q<o?q:o;x=x+1|0}while((x|0)!=(g|0));if(!u)break;else{r=r+(b<<3)|0;s=s+(d<<3)|0;t=t+(i<<3)|0;u=u+-1|0}}return}function _T(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){l=d;m=f;n=a;o=k}else return;while(1){p=0;do{q=h[n+p>>0]|0;b[m+p>>0]=(h[221118+(256-q+(h[l+p>>0]|0))>>0]|0)+q;p=p+1|0}while((p|0)!=(i|0));if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=i&-4;n=(o|0)<(i|0);m=d;d=f;f=a;a=k;while(1){k=0;do{l=h[f+k>>0]|0;p=k|1;q=h[f+p>>0]|0;r=(h[221118+(256-q+(h[m+p>>0]|0))>>0]|0)+q&255;b[d+k>>0]=(h[221118+(256-l+(h[m+k>>0]|0))>>0]|0)+l;b[d+p>>0]=r;r=k|2;p=h[f+r>>0]|0;l=k|3;q=h[f+l>>0]|0;s=(h[221118+(256-q+(h[m+l>>0]|0))>>0]|0)+q&255;b[d+r>>0]=(h[221118+(256-p+(h[m+r>>0]|0))>>0]|0)+p;b[d+l>>0]=s;k=k+4|0}while((k|0)<=(j|0));if(n){k=o;do{s=h[f+k>>0]|0;b[d+k>>0]=(h[221118+(256-s+(h[m+k>>0]|0))>>0]|0)+s;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function $T(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=b[m+o>>0]|0;q=b[k+o>>0]|0;b[l+o>>0]=p<<24>>24<q<<24>>24?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=d;s=f;t=a;u=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=b[f+j>>0]|0;k=b[m+j>>0]|0;o=j|1;p=b[f+o>>0]|0;q=b[m+o>>0]|0;b[d+j>>0]=l<<24>>24<k<<24>>24?k:l;b[d+o>>0]=p<<24>>24<q<<24>>24?q:p;p=j|2;q=b[f+p>>0]|0;o=b[m+p>>0]|0;l=j|3;k=b[f+l>>0]|0;v=b[m+l>>0]|0;b[d+p>>0]=q<<24>>24<o<<24>>24?o:q;b[d+l>>0]=k<<24>>24<v<<24>>24?v:k;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=b[t+a>>0]|0;d=b[r+a>>0]|0;m=a|1;j=b[t+m>>0]|0;k=b[r+m>>0]|0;b[s+a>>0]=f<<24>>24<d<<24>>24?d:f;b[s+m>>0]=j<<24>>24<k<<24>>24?k:j;j=a|2;k=b[t+j>>0]|0;m=b[r+j>>0]|0;f=a|3;d=b[t+f>>0]|0;v=b[r+f>>0]|0;b[s+j>>0]=k<<24>>24<m<<24>>24?m:k;b[s+f>>0]=d<<24>>24<v<<24>>24?v:d;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=b[t+w>>0]|0;d=b[r+w>>0]|0;b[s+w>>0]=a<<24>>24<d<<24>>24?d:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+e|0;s=s+g|0;t=t+c|0;u=u+-1|0}}return}function aU(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;d[l+(o<<1)>>1]=(p&65535)<(q&65535)?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=f;t=a;u=g}else{m=c;c=f;f=a;a=g;while(1){g=0;do{l=d[f+(g<<1)>>1]|0;k=d[m+(g<<1)>>1]|0;o=g|1;p=d[f+(o<<1)>>1]|0;q=d[m+(o<<1)>>1]|0;d[c+(g<<1)>>1]=(l&65535)<(k&65535)?k:l;d[c+(o<<1)>>1]=(p&65535)<(q&65535)?q:p;p=g|2;q=d[f+(p<<1)>>1]|0;o=d[m+(p<<1)>>1]|0;l=g|3;k=d[f+(l<<1)>>1]|0;v=d[m+(l<<1)>>1]|0;d[c+(p<<1)>>1]=(q&65535)<(o&65535)?o:q;d[c+(l<<1)>>1]=(k&65535)<(v&65535)?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=d[t+(a<<1)>>1]|0;c=d[r+(a<<1)>>1]|0;m=a|1;g=d[t+(m<<1)>>1]|0;k=d[r+(m<<1)>>1]|0;d[s+(a<<1)>>1]=(f&65535)<(c&65535)?c:f;d[s+(m<<1)>>1]=(g&65535)<(k&65535)?k:g;g=a|2;k=d[t+(g<<1)>>1]|0;m=d[r+(g<<1)>>1]|0;f=a|3;c=d[t+(f<<1)>>1]|0;v=d[r+(f<<1)>>1]|0;d[s+(g<<1)>>1]=(k&65535)<(m&65535)?m:k;d[s+(f<<1)>>1]=(c&65535)<(v&65535)?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=d[t+(w<<1)>>1]|0;c=d[r+(w<<1)>>1]|0;d[s+(w<<1)>>1]=(a&65535)<(c&65535)?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0;u=u+-1|0}}return}function bU(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;d[l+(o<<1)>>1]=p<<16>>16<q<<16>>16?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=f;t=a;u=g}else{m=c;c=f;f=a;a=g;while(1){g=0;do{l=d[f+(g<<1)>>1]|0;k=d[m+(g<<1)>>1]|0;o=g|1;p=d[f+(o<<1)>>1]|0;q=d[m+(o<<1)>>1]|0;d[c+(g<<1)>>1]=l<<16>>16<k<<16>>16?k:l;d[c+(o<<1)>>1]=p<<16>>16<q<<16>>16?q:p;p=g|2;q=d[f+(p<<1)>>1]|0;o=d[m+(p<<1)>>1]|0;l=g|3;k=d[f+(l<<1)>>1]|0;v=d[m+(l<<1)>>1]|0;d[c+(p<<1)>>1]=q<<16>>16<o<<16>>16?o:q;d[c+(l<<1)>>1]=k<<16>>16<v<<16>>16?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=d[t+(a<<1)>>1]|0;c=d[r+(a<<1)>>1]|0;m=a|1;g=d[t+(m<<1)>>1]|0;k=d[r+(m<<1)>>1]|0;d[s+(a<<1)>>1]=f<<16>>16<c<<16>>16?c:f;d[s+(m<<1)>>1]=g<<16>>16<k<<16>>16?k:g;g=a|2;k=d[t+(g<<1)>>1]|0;m=d[r+(g<<1)>>1]|0;f=a|3;c=d[t+(f<<1)>>1]|0;v=d[r+(f<<1)>>1]|0;d[s+(g<<1)>>1]=k<<16>>16<m<<16>>16?m:k;d[s+(f<<1)>>1]=c<<16>>16<v<<16>>16?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=d[t+(w<<1)>>1]|0;c=d[r+(w<<1)>>1]|0;d[s+(w<<1)>>1]=a<<16>>16<c<<16>>16?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0;u=u+-1|0}}return}function cU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{p=f[m+(o<<2)>>2]|0;q=f[k+(o<<2)>>2]|0;f[l+(o<<2)>>2]=(p|0)<(q|0)?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=e;t=a;u=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=f[e+(g<<2)>>2]|0;k=f[m+(g<<2)>>2]|0;o=g|1;p=f[e+(o<<2)>>2]|0;q=f[m+(o<<2)>>2]|0;f[c+(g<<2)>>2]=(l|0)<(k|0)?k:l;f[c+(o<<2)>>2]=(p|0)<(q|0)?q:p;p=g|2;q=f[e+(p<<2)>>2]|0;o=f[m+(p<<2)>>2]|0;l=g|3;k=f[e+(l<<2)>>2]|0;v=f[m+(l<<2)>>2]|0;f[c+(p<<2)>>2]=(q|0)<(o|0)?o:q;f[c+(l<<2)>>2]=(k|0)<(v|0)?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=f[t+(a<<2)>>2]|0;c=f[r+(a<<2)>>2]|0;m=a|1;g=f[t+(m<<2)>>2]|0;k=f[r+(m<<2)>>2]|0;f[s+(a<<2)>>2]=(e|0)<(c|0)?c:e;f[s+(m<<2)>>2]=(g|0)<(k|0)?k:g;g=a|2;k=f[t+(g<<2)>>2]|0;m=f[r+(g<<2)>>2]|0;e=a|3;c=f[t+(e<<2)>>2]|0;v=f[r+(e<<2)>>2]|0;f[s+(g<<2)>>2]=(k|0)<(m|0)?m:k;f[s+(e<<2)>>2]=(c|0)<(v|0)?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=f[t+(w<<2)>>2]|0;c=f[r+(w<<2)>>2]|0;f[s+(w<<2)>>2]=(a|0)<(c|0)?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(j<<2)|0;u=u+-1|0}}return}function dU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{p=+n[l+(o<<2)>>2];q=+n[j+(o<<2)>>2];n[k+(o<<2)>>2]=p<q?q:p;o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){r=c;s=e;t=a;u=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{p=+n[e+(f<<2)>>2];q=+n[l+(f<<2)>>2];k=f|1;v=+n[e+(k<<2)>>2];w=+n[l+(k<<2)>>2];n[c+(f<<2)>>2]=p<q?q:p;n[c+(k<<2)>>2]=v<w?w:v;k=f|2;v=+n[e+(k<<2)>>2];w=+n[l+(k<<2)>>2];j=f|3;p=+n[e+(j<<2)>>2];q=+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=v<w?w:v;n[c+(j<<2)>>2]=p<q?q:p;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{p=+n[t+(a<<2)>>2];q=+n[r+(a<<2)>>2];e=a|1;v=+n[t+(e<<2)>>2];w=+n[r+(e<<2)>>2];n[s+(a<<2)>>2]=p<q?q:p;n[s+(e<<2)>>2]=v<w?w:v;e=a|2;v=+n[t+(e<<2)>>2];w=+n[r+(e<<2)>>2];c=a|3;p=+n[t+(c<<2)>>2];q=+n[r+(c<<2)>>2];n[s+(e<<2)>>2]=v<w?w:v;n[s+(c<<2)>>2]=p<q?q:p;a=a+4|0}while((a|0)<=(h|0));x=m;do{p=+n[t+(x<<2)>>2];q=+n[r+(x<<2)>>2];n[s+(x<<2)>>2]=p<q?q:p;x=x+1|0}while((x|0)!=(g|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(i<<2)|0;u=u+-1|0}}return}function eU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{o=+p[l+(n<<3)>>3];q=+p[j+(n<<3)>>3];p[k+(n<<3)>>3]=o<q?q:o;n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){r=c;s=e;t=a;u=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{o=+p[e+(f<<3)>>3];q=+p[l+(f<<3)>>3];k=f|1;v=+p[e+(k<<3)>>3];w=+p[l+(k<<3)>>3];p[c+(f<<3)>>3]=o<q?q:o;p[c+(k<<3)>>3]=v<w?w:v;k=f|2;v=+p[e+(k<<3)>>3];w=+p[l+(k<<3)>>3];j=f|3;o=+p[e+(j<<3)>>3];q=+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=v<w?w:v;p[c+(j<<3)>>3]=o<q?q:o;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{o=+p[t+(a<<3)>>3];q=+p[r+(a<<3)>>3];e=a|1;v=+p[t+(e<<3)>>3];w=+p[r+(e<<3)>>3];p[s+(a<<3)>>3]=o<q?q:o;p[s+(e<<3)>>3]=v<w?w:v;e=a|2;v=+p[t+(e<<3)>>3];w=+p[r+(e<<3)>>3];c=a|3;o=+p[t+(c<<3)>>3];q=+p[r+(c<<3)>>3];p[s+(e<<3)>>3]=v<w?w:v;p[s+(c<<3)>>3]=o<q?q:o;a=a+4|0}while((a|0)<=(h|0));x=m;do{o=+p[t+(x<<3)>>3];q=+p[r+(x<<3)>>3];p[s+(x<<3)>>3]=o<q?q:o;x=x+1|0}while((x|0)!=(g|0));if(!u)break;else{r=r+(b<<3)|0;s=s+(d<<3)|0;t=t+(i<<3)|0;u=u+-1|0}}return}function fU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=b[m+o>>0]|0;q=b[k+o>>0]|0;r=(p&255)>(q&255);b[l+o>>0]=((r?p:q)&255)-((r?q:p)&255);o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=d;d=f;f=a;a=j;while(1){j=0;do{k=b[f+j>>0]|0;o=b[l+j>>0]|0;p=(k&255)>(o&255);q=j|1;r=b[f+q>>0]|0;s=b[l+q>>0]|0;t=(r&255)>(s&255);b[d+j>>0]=((p?k:o)&255)-((p?o:k)&255);b[d+q>>0]=((t?r:s)&255)-((t?s:r)&255);r=j|2;s=b[f+r>>0]|0;t=b[l+r>>0]|0;q=(s&255)>(t&255);k=j|3;o=b[f+k>>0]|0;p=b[l+k>>0]|0;u=(o&255)>(p&255);b[d+r>>0]=((q?s:t)&255)-((q?t:s)&255);b[d+k>>0]=((u?o:p)&255)-((u?p:o)&255);j=j+4|0}while((j|0)<=(i|0));if(m){j=n;do{o=b[f+j>>0]|0;p=b[l+j>>0]|0;u=(o&255)>(p&255);b[d+j>>0]=((u?o:p)&255)-((u?p:o)&255);j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{l=l+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function gU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=(b[m+o>>0]|0)-(b[k+o>>0]|0)|0;q=(p|0)>-1?p:0-p|0;b[l+o>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=d;d=f;f=a;a=j;while(1){j=0;do{k=(b[f+j>>0]|0)-(b[l+j>>0]|0)|0;o=(k|0)>-1?k:0-k|0;k=j|1;q=(b[f+k>>0]|0)-(b[l+k>>0]|0)|0;p=(q|0)>-1?q:0-q|0;b[d+j>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;b[d+k>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;p=j|2;k=(b[f+p>>0]|0)-(b[l+p>>0]|0)|0;o=(k|0)>-1?k:0-k|0;k=j|3;q=(b[f+k>>0]|0)-(b[l+k>>0]|0)|0;r=(q|0)>-1?q:0-q|0;b[d+p>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;b[d+k>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(m){j=n;do{r=(b[f+j>>0]|0)-(b[l+j>>0]|0)|0;k=(r|0)>-1?r:0-r|0;b[d+j>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{l=l+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function hU(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;r=(p&65535)>(q&65535);d[l+(o<<1)>>1]=((r?p:q)&65535)-((r?q:p)&65535);o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=c;c=f;f=a;a=g;while(1){g=0;do{k=d[f+(g<<1)>>1]|0;o=d[l+(g<<1)>>1]|0;p=(k&65535)>(o&65535);q=g|1;r=d[f+(q<<1)>>1]|0;s=d[l+(q<<1)>>1]|0;t=(r&65535)>(s&65535);d[c+(g<<1)>>1]=((p?k:o)&65535)-((p?o:k)&65535);d[c+(q<<1)>>1]=((t?r:s)&65535)-((t?s:r)&65535);r=g|2;s=d[f+(r<<1)>>1]|0;t=d[l+(r<<1)>>1]|0;q=(s&65535)>(t&65535);k=g|3;o=d[f+(k<<1)>>1]|0;p=d[l+(k<<1)>>1]|0;u=(o&65535)>(p&65535);d[c+(r<<1)>>1]=((q?s:t)&65535)-((q?t:s)&65535);d[c+(k<<1)>>1]=((u?o:p)&65535)-((u?p:o)&65535);g=g+4|0}while((g|0)<=(i|0));if(m){g=n;do{o=d[f+(g<<1)>>1]|0;p=d[l+(g<<1)>>1]|0;u=(o&65535)>(p&65535);d[c+(g<<1)>>1]=((u?o:p)&65535)-((u?p:o)&65535);g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}function iU(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;k=(h|0)<4;l=h&-4;m=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(k)n=0;else{i=0;do{o=(d[f+(i<<1)>>1]|0)-(d[m+(i<<1)>>1]|0)|0;p=(o|0)>-1?o:0-o|0;o=i|1;q=(d[f+(o<<1)>>1]|0)-(d[m+(o<<1)>>1]|0)|0;r=(q|0)>-1?q:0-q|0;d[c+(i<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[c+(o<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=i|2;o=(d[f+(r<<1)>>1]|0)-(d[m+(r<<1)>>1]|0)|0;p=(o|0)>-1?o:0-o|0;o=i|3;q=(d[f+(o<<1)>>1]|0)-(d[m+(o<<1)>>1]|0)|0;s=(q|0)>-1?q:0-q|0;d[c+(r<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[c+(o<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;i=i+4|0}while((i|0)<=(g|0));n=l}if((n|0)<(h|0)){i=n;do{s=(d[f+(i<<1)>>1]|0)-(d[m+(i<<1)>>1]|0)|0;o=(s|0)>-1?s:0-s|0;d[c+(i<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0}}return}function jU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{p=f[m+(o<<2)>>2]|0;q=f[k+(o<<2)>>2]|0;f[l+(o<<2)>>2]=(p|0)>(q|0)?p-q|0:q-p|0;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=e;t=a;u=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=f[e+(g<<2)>>2]|0;k=f[m+(g<<2)>>2]|0;o=g|1;p=f[e+(o<<2)>>2]|0;q=f[m+(o<<2)>>2]|0;f[c+(g<<2)>>2]=(l|0)>(k|0)?l-k|0:k-l|0;f[c+(o<<2)>>2]=(p|0)>(q|0)?p-q|0:q-p|0;p=g|2;q=f[e+(p<<2)>>2]|0;o=f[m+(p<<2)>>2]|0;l=g|3;k=f[e+(l<<2)>>2]|0;v=f[m+(l<<2)>>2]|0;f[c+(p<<2)>>2]=(q|0)>(o|0)?q-o|0:o-q|0;f[c+(l<<2)>>2]=(k|0)>(v|0)?k-v|0:v-k|0;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=f[t+(a<<2)>>2]|0;c=f[r+(a<<2)>>2]|0;m=a|1;g=f[t+(m<<2)>>2]|0;k=f[r+(m<<2)>>2]|0;f[s+(a<<2)>>2]=(e|0)>(c|0)?e-c|0:c-e|0;f[s+(m<<2)>>2]=(g|0)>(k|0)?g-k|0:k-g|0;g=a|2;k=f[t+(g<<2)>>2]|0;m=f[r+(g<<2)>>2]|0;e=a|3;c=f[t+(e<<2)>>2]|0;v=f[r+(e<<2)>>2]|0;f[s+(g<<2)>>2]=(k|0)>(m|0)?k-m|0:m-k|0;f[s+(e<<2)>>2]=(c|0)>(v|0)?c-v|0:v-c|0;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=f[t+(w<<2)>>2]|0;c=f[r+(w<<2)>>2]|0;f[s+(w<<2)>>2]=(a|0)>(c|0)?a-c|0:c-a|0;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(j<<2)|0;u=u+-1|0}}return}function kU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0.0,v=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{p=+L(+(+n[l+(o<<2)>>2]-+n[j+(o<<2)>>2]));n[k+(o<<2)>>2]=p;o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){q=c;r=e;s=a;t=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{p=+L(+(+n[e+(f<<2)>>2]-+n[l+(f<<2)>>2]));k=f|1;u=+L(+(+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2]));n[c+(f<<2)>>2]=p;n[c+(k<<2)>>2]=u;k=f|2;u=+L(+(+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2]));j=f|3;p=+L(+(+n[e+(j<<2)>>2]-+n[l+(j<<2)>>2]));n[c+(k<<2)>>2]=u;n[c+(j<<2)>>2]=p;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{p=+L(+(+n[s+(a<<2)>>2]-+n[q+(a<<2)>>2]));e=a|1;u=+L(+(+n[s+(e<<2)>>2]-+n[q+(e<<2)>>2]));n[r+(a<<2)>>2]=p;n[r+(e<<2)>>2]=u;e=a|2;u=+L(+(+n[s+(e<<2)>>2]-+n[q+(e<<2)>>2]));c=a|3;p=+L(+(+n[s+(c<<2)>>2]-+n[q+(c<<2)>>2]));n[r+(e<<2)>>2]=u;n[r+(c<<2)>>2]=p;a=a+4|0}while((a|0)<=(h|0));v=m;do{p=+L(+(+n[s+(v<<2)>>2]-+n[q+(v<<2)>>2]));n[r+(v<<2)>>2]=p;v=v+1|0}while((v|0)!=(g|0));if(!t)break;else{q=q+(b<<2)|0;r=r+(d<<2)|0;s=s+(i<<2)|0;t=t+-1|0}}return}function lU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,u=0.0,v=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{o=+L(+(+p[l+(n<<3)>>3]-+p[j+(n<<3)>>3]));p[k+(n<<3)>>3]=o;n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){q=c;r=e;s=a;t=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{o=+L(+(+p[e+(f<<3)>>3]-+p[l+(f<<3)>>3]));k=f|1;u=+L(+(+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3]));p[c+(f<<3)>>3]=o;p[c+(k<<3)>>3]=u;k=f|2;u=+L(+(+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3]));j=f|3;o=+L(+(+p[e+(j<<3)>>3]-+p[l+(j<<3)>>3]));p[c+(k<<3)>>3]=u;p[c+(j<<3)>>3]=o;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{o=+L(+(+p[s+(a<<3)>>3]-+p[q+(a<<3)>>3]));e=a|1;u=+L(+(+p[s+(e<<3)>>3]-+p[q+(e<<3)>>3]));p[r+(a<<3)>>3]=o;p[r+(e<<3)>>3]=u;e=a|2;u=+L(+(+p[s+(e<<3)>>3]-+p[q+(e<<3)>>3]));c=a|3;o=+L(+(+p[s+(c<<3)>>3]-+p[q+(c<<3)>>3]));p[r+(e<<3)>>3]=u;p[r+(c<<3)>>3]=o;a=a+4|0}while((a|0)<=(h|0));v=m;do{o=+L(+(+p[s+(v<<3)>>3]-+p[q+(v<<3)>>3]));p[r+(v<<3)>>3]=o;v=v+1|0}while((v|0)!=(g|0));if(!t)break;else{q=q+(b<<3)|0;r=r+(d<<3)|0;s=s+(i<<3)|0;t=t+-1|0}}return}function mU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{b[l+o>>0]=b[k+o>>0]|b[m+o>>0];o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=d;q=f;r=a;s=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]|b[f+l>>0];b[d+j>>0]=b[m+j>>0]|b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;o=b[m+l>>0]|b[f+l>>0];b[d+k>>0]=b[m+k>>0]|b[f+k>>0];b[d+l>>0]=o;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[p+f>>0]|b[r+f>>0];b[q+a>>0]=b[p+a>>0]|b[r+a>>0];b[q+f>>0]=d;d=a|2;f=a|3;m=b[p+f>>0]|b[r+f>>0];b[q+d>>0]=b[p+d>>0]|b[r+d>>0];b[q+f>>0]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{b[q+t>>0]=b[p+t>>0]|b[r+t>>0];t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+e|0;q=q+g|0;r=r+c|0;s=s+-1|0}}return}function nU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{b[l+o>>0]=b[k+o>>0]^b[m+o>>0];o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=d;q=f;r=a;s=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]^b[f+l>>0];b[d+j>>0]=b[m+j>>0]^b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;o=b[m+l>>0]^b[f+l>>0];b[d+k>>0]=b[m+k>>0]^b[f+k>>0];b[d+l>>0]=o;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[p+f>>0]^b[r+f>>0];b[q+a>>0]=b[p+a>>0]^b[r+a>>0];b[q+f>>0]=d;d=a|2;f=a|3;m=b[p+f>>0]^b[r+f>>0];b[q+d>>0]=b[p+d>>0]^b[r+d>>0];b[q+f>>0]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{b[q+t>>0]=b[p+t>>0]^b[r+t>>0];t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+e|0;q=q+g|0;r=r+c|0;s=s+-1|0}}return}function oU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{b[l+o>>0]=b[k+o>>0]&b[m+o>>0];o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=d;q=f;r=a;s=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]&b[f+l>>0];b[d+j>>0]=b[m+j>>0]&b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;o=b[m+l>>0]&b[f+l>>0];b[d+k>>0]=b[m+k>>0]&b[f+k>>0];b[d+l>>0]=o;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[p+f>>0]&b[r+f>>0];b[q+a>>0]=b[p+a>>0]&b[r+a>>0];b[q+f>>0]=d;d=a|2;f=a|3;m=b[p+f>>0]&b[r+f>>0];b[q+d>>0]=b[p+d>>0]&b[r+d>>0];b[q+f>>0]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{b[q+t>>0]=b[p+t>>0]&b[r+t>>0];t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+e|0;q=q+g|0;r=r+c|0;s=s+-1|0}}return}function pU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){j=f;k=a;l=e}else return;while(1){d=0;do{b[j+d>>0]=~b[k+d>>0];d=d+1|0}while((d|0)!=(h|0));if(!l)break;else{j=j+g|0;k=k+c|0;l=l+-1|0}}return}l=h&-4;if((l|0)<(h|0)){m=f;n=a;o=e}else{k=f;f=a;a=e;while(1){e=0;do{j=e|1;d=~b[f+j>>0];b[k+e>>0]=~b[f+e>>0];b[k+j>>0]=d;d=e|2;j=e|3;p=~b[f+j>>0];b[k+d>>0]=~b[f+d>>0];b[k+j>>0]=p;e=e+4|0}while((e|0)<=(i|0));if(!a)break;else{k=k+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;k=~b[n+f>>0];b[m+a>>0]=~b[n+a>>0];b[m+f>>0]=k;k=a|2;f=a|3;e=~b[n+f>>0];b[m+k>>0]=~b[n+k>>0];b[m+f>>0]=e;a=a+4|0}while((a|0)<=(i|0));q=l;do{b[m+q>>0]=~b[n+q>>0];q=q+1|0}while((q|0)!=(h|0));if(!o)break;else{m=m+g|0;n=n+c|0;o=o+-1|0}}return}function qU(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{rU(a,c,d,e,g,h,i,j);u=l;return}case 1:{rU(d,e,a,c,g,h,i,j);u=l;return}case 4:{sU(a,c,d,e,g,h,i,j);u=l;return}case 2:{sU(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=j+-1|0;if(!j){u=l;return}n=i+-4|0;if((i|0)<4){if((i|0)>0){o=d;p=g;q=a;r=k}else{u=l;return}while(1){s=0;do{b[p+s>>0]=((b[q+s>>0]|0)==(b[o+s>>0]|0))<<31>>31;s=s+1|0}while((s|0)!=(i|0));if(!r)break;else{o=o+e|0;p=p+h|0;q=q+c|0;r=r+-1|0}}u=l;return}r=i&-4;if((r|0)<(i|0)){t=d;v=g;w=a;x=k}else{q=d;p=g;o=a;s=k;while(1){k=0;do{y=k|1;z=((b[o+y>>0]|0)==(b[q+y>>0]|0))<<31>>31;b[p+k>>0]=((b[o+k>>0]|0)==(b[q+k>>0]|0))<<31>>31;b[p+y>>0]=z;z=k|2;y=k|3;A=((b[o+y>>0]|0)==(b[q+y>>0]|0))<<31>>31;b[p+z>>0]=((b[o+z>>0]|0)==(b[q+z>>0]|0))<<31>>31;b[p+y>>0]=A;k=k+4|0}while((k|0)<=(n|0));if(!s)break;else{q=q+e|0;p=p+h|0;o=o+c|0;s=s+-1|0}}u=l;return}while(1){s=0;do{o=s|1;p=((b[w+o>>0]|0)==(b[t+o>>0]|0))<<31>>31;b[v+s>>0]=((b[w+s>>0]|0)==(b[t+s>>0]|0))<<31>>31;b[v+o>>0]=p;p=s|2;o=s|3;q=((b[w+o>>0]|0)==(b[t+o>>0]|0))<<31>>31;b[v+p>>0]=((b[w+p>>0]|0)==(b[t+p>>0]|0))<<31>>31;b[v+o>>0]=q;s=s+4|0}while((s|0)<=(n|0));B=r;do{b[v+B>>0]=((b[w+B>>0]|0)==(b[t+B>>0]|0))<<31>>31;B=B+1|0}while((B|0)!=(i|0));if(!x)break;else{t=t+e|0;v=v+h|0;w=w+c|0;x=x+-1|0}}u=l;return}case 5:{x=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){C=d;D=g;E=a;F=x}else{u=l;return}while(1){w=0;do{b[D+w>>0]=((b[E+w>>0]|0)!=(b[C+w>>0]|0))<<31>>31;w=w+1|0}while((w|0)!=(i|0));if(!F)break;else{C=C+e|0;D=D+h|0;E=E+c|0;F=F+-1|0}}u=l;return}F=i&-4;if((F|0)<(i|0)){G=d;H=g;I=a;J=x}else{E=d;d=g;g=a;a=x;while(1){x=0;do{D=x|1;C=((b[g+D>>0]|0)!=(b[E+D>>0]|0))<<31>>31;b[d+x>>0]=((b[g+x>>0]|0)!=(b[E+x>>0]|0))<<31>>31;b[d+D>>0]=C;C=x|2;D=x|3;w=((b[g+D>>0]|0)!=(b[E+D>>0]|0))<<31>>31;b[d+C>>0]=((b[g+C>>0]|0)!=(b[E+C>>0]|0))<<31>>31;b[d+D>>0]=w;x=x+4|0}while((x|0)<=(j|0));if(!a)break;else{E=E+e|0;d=d+h|0;g=g+c|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=((b[I+g>>0]|0)!=(b[G+g>>0]|0))<<31>>31;b[H+a>>0]=((b[I+a>>0]|0)!=(b[G+a>>0]|0))<<31>>31;b[H+g>>0]=d;d=a|2;g=a|3;E=((b[I+g>>0]|0)!=(b[G+g>>0]|0))<<31>>31;b[H+d>>0]=((b[I+d>>0]|0)!=(b[G+d>>0]|0))<<31>>31;b[H+g>>0]=E;a=a+4|0}while((a|0)<=(j|0));K=F;do{b[H+K>>0]=((b[I+K>>0]|0)!=(b[G+K>>0]|0))<<31>>31;K=K+1|0}while((K|0)!=(i|0));if(!J)break;else{G=G+e|0;H=H+h|0;I=I+c|0;J=J+-1|0}}u=l;return}default:{f[m>>2]=0;f[m+4>>2]=0;l=tT(m,15)|0;J=218933;c=l+15|0;do{b[l>>0]=b[J>>0]|0;l=l+1|0;J=J+1|0}while((l|0)<(c|0));tU(-215,m,218949,759)}}}function rU(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=f;o=a;p=k;while(1){if(l){q=0;do{b[n+q>>0]=((h[o+q>>0]|0)<(h[m+q>>0]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+c|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=((h[f+m>>0]|0)<(h[n+m>>0]|0))<<31>>31;b[d+k>>0]=((h[f+k>>0]|0)<(h[n+k>>0]|0))<<31>>31;b[d+m>>0]=l;l=k|2;m=k|3;q=((h[f+m>>0]|0)<(h[n+m>>0]|0))<<31>>31;b[d+l>>0]=((h[f+l>>0]|0)<(h[n+l>>0]|0))<<31>>31;b[d+m>>0]=q;k=k+4|0}while((k|0)<=(j|0));if(o){k=p;do{b[d+k>>0]=((h[f+k>>0]|0)<(h[n+k>>0]|0))<<31>>31;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function sU(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=f;o=a;p=k;while(1){if(l){q=0;do{b[n+q>>0]=((h[o+q>>0]|0)<=(h[m+q>>0]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+c|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=((h[f+m>>0]|0)<=(h[n+m>>0]|0))<<31>>31;b[d+k>>0]=((h[f+k>>0]|0)<=(h[n+k>>0]|0))<<31>>31;b[d+m>>0]=l;l=k|2;m=k|3;q=((h[f+m>>0]|0)<=(h[n+m>>0]|0))<<31>>31;b[d+l>>0]=((h[f+l>>0]|0)<=(h[n+l>>0]|0))<<31>>31;b[d+m>>0]=q;k=k+4|0}while((k|0)<=(j|0));if(o){k=p;do{b[d+k>>0]=((h[f+k>>0]|0)<=(h[n+k>>0]|0))<<31>>31;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function tU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,218958,d);return}function uU(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{vU(a,c,d,e,g,h,i,j);u=l;return}case 1:{vU(d,e,a,c,g,h,i,j);u=l;return}case 4:{wU(a,c,d,e,g,h,i,j);u=l;return}case 2:{wU(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=j+-1|0;if(!j){u=l;return}n=i+-4|0;if((i|0)<4){if((i|0)>0){o=d;p=g;q=a;r=k}else{u=l;return}while(1){s=0;do{b[p+s>>0]=((b[q+s>>0]|0)==(b[o+s>>0]|0))<<31>>31;s=s+1|0}while((s|0)!=(i|0));if(!r)break;else{o=o+e|0;p=p+h|0;q=q+c|0;r=r+-1|0}}u=l;return}r=i&-4;if((r|0)<(i|0)){t=d;v=g;w=a;x=k}else{q=d;p=g;o=a;s=k;while(1){k=0;do{y=k|1;z=((b[o+y>>0]|0)==(b[q+y>>0]|0))<<31>>31;b[p+k>>0]=((b[o+k>>0]|0)==(b[q+k>>0]|0))<<31>>31;b[p+y>>0]=z;z=k|2;y=k|3;A=((b[o+y>>0]|0)==(b[q+y>>0]|0))<<31>>31;b[p+z>>0]=((b[o+z>>0]|0)==(b[q+z>>0]|0))<<31>>31;b[p+y>>0]=A;k=k+4|0}while((k|0)<=(n|0));if(!s)break;else{q=q+e|0;p=p+h|0;o=o+c|0;s=s+-1|0}}u=l;return}while(1){s=0;do{o=s|1;p=((b[w+o>>0]|0)==(b[t+o>>0]|0))<<31>>31;b[v+s>>0]=((b[w+s>>0]|0)==(b[t+s>>0]|0))<<31>>31;b[v+o>>0]=p;p=s|2;o=s|3;q=((b[w+o>>0]|0)==(b[t+o>>0]|0))<<31>>31;b[v+p>>0]=((b[w+p>>0]|0)==(b[t+p>>0]|0))<<31>>31;b[v+o>>0]=q;s=s+4|0}while((s|0)<=(n|0));B=r;do{b[v+B>>0]=((b[w+B>>0]|0)==(b[t+B>>0]|0))<<31>>31;B=B+1|0}while((B|0)!=(i|0));if(!x)break;else{t=t+e|0;v=v+h|0;w=w+c|0;x=x+-1|0}}u=l;return}case 5:{x=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){C=d;D=g;E=a;F=x}else{u=l;return}while(1){w=0;do{b[D+w>>0]=((b[E+w>>0]|0)!=(b[C+w>>0]|0))<<31>>31;w=w+1|0}while((w|0)!=(i|0));if(!F)break;else{C=C+e|0;D=D+h|0;E=E+c|0;F=F+-1|0}}u=l;return}F=i&-4;if((F|0)<(i|0)){G=d;H=g;I=a;J=x}else{E=d;d=g;g=a;a=x;while(1){x=0;do{D=x|1;C=((b[g+D>>0]|0)!=(b[E+D>>0]|0))<<31>>31;b[d+x>>0]=((b[g+x>>0]|0)!=(b[E+x>>0]|0))<<31>>31;b[d+D>>0]=C;C=x|2;D=x|3;w=((b[g+D>>0]|0)!=(b[E+D>>0]|0))<<31>>31;b[d+C>>0]=((b[g+C>>0]|0)!=(b[E+C>>0]|0))<<31>>31;b[d+D>>0]=w;x=x+4|0}while((x|0)<=(j|0));if(!a)break;else{E=E+e|0;d=d+h|0;g=g+c|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=((b[I+g>>0]|0)!=(b[G+g>>0]|0))<<31>>31;b[H+a>>0]=((b[I+a>>0]|0)!=(b[G+a>>0]|0))<<31>>31;b[H+g>>0]=d;d=a|2;g=a|3;E=((b[I+g>>0]|0)!=(b[G+g>>0]|0))<<31>>31;b[H+d>>0]=((b[I+d>>0]|0)!=(b[G+d>>0]|0))<<31>>31;b[H+g>>0]=E;a=a+4|0}while((a|0)<=(j|0));K=F;do{b[H+K>>0]=((b[I+K>>0]|0)!=(b[G+K>>0]|0))<<31>>31;K=K+1|0}while((K|0)!=(i|0));if(!J)break;else{G=G+e|0;H=H+h|0;I=I+c|0;J=J+-1|0}}u=l;return}default:{f[m>>2]=0;f[m+4>>2]=0;l=tT(m,15)|0;J=218933;c=l+15|0;do{b[l>>0]=b[J>>0]|0;l=l+1|0;J=J+1|0}while((l|0)<(c|0));tU(-215,m,218949,759)}}}function vU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{b[m+p>>0]=((b[n+p>>0]|0)<(b[l+p>>0]|0))<<31>>31;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=((b[f+l>>0]|0)<(b[m+l>>0]|0))<<31>>31;b[d+j>>0]=((b[f+j>>0]|0)<(b[m+j>>0]|0))<<31>>31;b[d+l>>0]=k;k=j|2;l=j|3;p=((b[f+l>>0]|0)<(b[m+l>>0]|0))<<31>>31;b[d+k>>0]=((b[f+k>>0]|0)<(b[m+k>>0]|0))<<31>>31;b[d+l>>0]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{b[d+j>>0]=((b[f+j>>0]|0)<(b[m+j>>0]|0))<<31>>31;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function wU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{b[m+p>>0]=((b[n+p>>0]|0)<=(b[l+p>>0]|0))<<31>>31;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=((b[f+l>>0]|0)<=(b[m+l>>0]|0))<<31>>31;b[d+j>>0]=((b[f+j>>0]|0)<=(b[m+j>>0]|0))<<31>>31;b[d+l>>0]=k;k=j|2;l=j|3;p=((b[f+l>>0]|0)<=(b[m+l>>0]|0))<<31>>31;b[d+k>>0]=((b[f+k>>0]|0)<=(b[m+k>>0]|0))<<31>>31;b[d+l>>0]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{b[d+j>>0]=((b[f+j>>0]|0)<=(b[m+j>>0]|0))<<31>>31;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function xU(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;m=u;u=u+16|0;n=m;switch(l|0){case 3:{yU(a,c,e,g,h,i,j,k);u=m;return}case 1:{yU(e,g,a,c,h,i,j,k);u=m;return}case 4:{zU(a,c,e,g,h,i,j,k);u=m;return}case 2:{zU(e,g,a,c,h,i,j,k);u=m;return}case 0:{l=c>>>1;o=g>>>1;p=k+-1|0;if(!k){u=m;return}q=j+-4|0;if((j|0)<4){if((j|0)>0){r=e;s=h;t=a;v=p}else{u=m;return}while(1){w=0;do{b[s+w>>0]=((d[t+(w<<1)>>1]|0)==(d[r+(w<<1)>>1]|0))<<31>>31;w=w+1|0}while((w|0)!=(j|0));if(!v)break;else{r=r+(o<<1)|0;s=s+i|0;t=t+(l<<1)|0;v=v+-1|0}}u=m;return}v=j&-4;if((v|0)<(j|0)){x=e;y=h;z=a;A=p}else{t=e;s=h;r=a;w=p;while(1){p=0;do{B=p|1;C=((d[r+(B<<1)>>1]|0)==(d[t+(B<<1)>>1]|0))<<31>>31;b[s+p>>0]=((d[r+(p<<1)>>1]|0)==(d[t+(p<<1)>>1]|0))<<31>>31;b[s+B>>0]=C;C=p|2;B=p|3;D=((d[r+(B<<1)>>1]|0)==(d[t+(B<<1)>>1]|0))<<31>>31;b[s+C>>0]=((d[r+(C<<1)>>1]|0)==(d[t+(C<<1)>>1]|0))<<31>>31;b[s+B>>0]=D;p=p+4|0}while((p|0)<=(q|0));if(!w)break;else{t=t+(o<<1)|0;s=s+i|0;r=r+(l<<1)|0;w=w+-1|0}}u=m;return}while(1){w=0;do{r=w|1;s=((d[z+(r<<1)>>1]|0)==(d[x+(r<<1)>>1]|0))<<31>>31;b[y+w>>0]=((d[z+(w<<1)>>1]|0)==(d[x+(w<<1)>>1]|0))<<31>>31;b[y+r>>0]=s;s=w|2;r=w|3;t=((d[z+(r<<1)>>1]|0)==(d[x+(r<<1)>>1]|0))<<31>>31;b[y+s>>0]=((d[z+(s<<1)>>1]|0)==(d[x+(s<<1)>>1]|0))<<31>>31;b[y+r>>0]=t;w=w+4|0}while((w|0)<=(q|0));E=v;do{b[y+E>>0]=((d[z+(E<<1)>>1]|0)==(d[x+(E<<1)>>1]|0))<<31>>31;E=E+1|0}while((E|0)!=(j|0));if(!A)break;else{x=x+(o<<1)|0;y=y+i|0;z=z+(l<<1)|0;A=A+-1|0}}u=m;return}case 5:{A=c>>>1;c=g>>>1;g=k+-1|0;if(!k){u=m;return}k=j+-4|0;if((j|0)<4){if((j|0)>0){F=e;G=h;H=a;I=g}else{u=m;return}while(1){l=0;do{b[G+l>>0]=((d[H+(l<<1)>>1]|0)!=(d[F+(l<<1)>>1]|0))<<31>>31;l=l+1|0}while((l|0)!=(j|0));if(!I)break;else{F=F+(c<<1)|0;G=G+i|0;H=H+(A<<1)|0;I=I+-1|0}}u=m;return}I=j&-4;if((I|0)<(j|0)){J=e;K=h;L=a;M=g}else{H=e;e=h;h=a;a=g;while(1){g=0;do{G=g|1;F=((d[h+(G<<1)>>1]|0)!=(d[H+(G<<1)>>1]|0))<<31>>31;b[e+g>>0]=((d[h+(g<<1)>>1]|0)!=(d[H+(g<<1)>>1]|0))<<31>>31;b[e+G>>0]=F;F=g|2;G=g|3;l=((d[h+(G<<1)>>1]|0)!=(d[H+(G<<1)>>1]|0))<<31>>31;b[e+F>>0]=((d[h+(F<<1)>>1]|0)!=(d[H+(F<<1)>>1]|0))<<31>>31;b[e+G>>0]=l;g=g+4|0}while((g|0)<=(k|0));if(!a)break;else{H=H+(c<<1)|0;e=e+i|0;h=h+(A<<1)|0;a=a+-1|0}}u=m;return}while(1){a=0;do{h=a|1;e=((d[L+(h<<1)>>1]|0)!=(d[J+(h<<1)>>1]|0))<<31>>31;b[K+a>>0]=((d[L+(a<<1)>>1]|0)!=(d[J+(a<<1)>>1]|0))<<31>>31;b[K+h>>0]=e;e=a|2;h=a|3;H=((d[L+(h<<1)>>1]|0)!=(d[J+(h<<1)>>1]|0))<<31>>31;b[K+e>>0]=((d[L+(e<<1)>>1]|0)!=(d[J+(e<<1)>>1]|0))<<31>>31;b[K+h>>0]=H;a=a+4|0}while((a|0)<=(k|0));N=I;do{b[K+N>>0]=((d[L+(N<<1)>>1]|0)!=(d[J+(N<<1)>>1]|0))<<31>>31;N=N+1|0}while((N|0)!=(j|0));if(!M)break;else{J=J+(c<<1)|0;K=K+i|0;L=L+(A<<1)|0;M=M+-1|0}}u=m;return}default:{f[n>>2]=0;f[n+4>>2]=0;m=tT(n,15)|0;M=218933;A=m+15|0;do{b[m>>0]=b[M>>0]|0;m=m+1|0;M=M+1|0}while((m|0)<(A|0));tU(-215,n,218949,759)}}}function yU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>1;c=e>>>1;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){l=(h|0)>0;m=d;n=f;o=a;p=e;while(1){if(l){q=0;do{b[n+q>>0]=((j[o+(q<<1)>>1]|0)<(j[m+(q<<1)>>1]|0))<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{m=m+(c<<1)|0;n=n+g|0;o=o+(k<<1)|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);n=d;d=f;f=a;a=e;while(1){e=0;do{m=e|1;l=((j[f+(m<<1)>>1]|0)<(j[n+(m<<1)>>1]|0))<<31>>31;b[d+e>>0]=((j[f+(e<<1)>>1]|0)<(j[n+(e<<1)>>1]|0))<<31>>31;b[d+m>>0]=l;l=e|2;m=e|3;q=((j[f+(m<<1)>>1]|0)<(j[n+(m<<1)>>1]|0))<<31>>31;b[d+l>>0]=((j[f+(l<<1)>>1]|0)<(j[n+(l<<1)>>1]|0))<<31>>31;b[d+m>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(o){e=p;do{b[d+e>>0]=((j[f+(e<<1)>>1]|0)<(j[n+(e<<1)>>1]|0))<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{n=n+(c<<1)|0;d=d+g|0;f=f+(k<<1)|0;a=a+-1|0}}return}function zU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>1;c=e>>>1;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){l=(h|0)>0;m=d;n=f;o=a;p=e;while(1){if(l){q=0;do{b[n+q>>0]=((j[o+(q<<1)>>1]|0)<=(j[m+(q<<1)>>1]|0))<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{m=m+(c<<1)|0;n=n+g|0;o=o+(k<<1)|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);n=d;d=f;f=a;a=e;while(1){e=0;do{m=e|1;l=((j[f+(m<<1)>>1]|0)<=(j[n+(m<<1)>>1]|0))<<31>>31;b[d+e>>0]=((j[f+(e<<1)>>1]|0)<=(j[n+(e<<1)>>1]|0))<<31>>31;b[d+m>>0]=l;l=e|2;m=e|3;q=((j[f+(m<<1)>>1]|0)<=(j[n+(m<<1)>>1]|0))<<31>>31;b[d+l>>0]=((j[f+(l<<1)>>1]|0)<=(j[n+(l<<1)>>1]|0))<<31>>31;b[d+m>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(o){e=p;do{b[d+e>>0]=((j[f+(e<<1)>>1]|0)<=(j[n+(e<<1)>>1]|0))<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{n=n+(c<<1)|0;d=d+g|0;f=f+(k<<1)|0;a=a+-1|0}}return}function AU(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;m=u;u=u+16|0;n=m;switch(l|0){case 3:{BU(a,c,e,g,h,i,j,k);u=m;return}case 1:{BU(e,g,a,c,h,i,j,k);u=m;return}case 4:{CU(a,c,e,g,h,i,j,k);u=m;return}case 2:{CU(e,g,a,c,h,i,j,k);u=m;return}case 0:{l=c>>>1;o=g>>>1;p=k+-1|0;if(!k){u=m;return}q=j+-4|0;if((j|0)<4){if((j|0)>0){r=e;s=h;t=a;v=p}else{u=m;return}while(1){w=0;do{b[s+w>>0]=((d[t+(w<<1)>>1]|0)==(d[r+(w<<1)>>1]|0))<<31>>31;w=w+1|0}while((w|0)!=(j|0));if(!v)break;else{r=r+(o<<1)|0;s=s+i|0;t=t+(l<<1)|0;v=v+-1|0}}u=m;return}v=j&-4;if((v|0)<(j|0)){x=e;y=h;z=a;A=p}else{t=e;s=h;r=a;w=p;while(1){p=0;do{B=p|1;C=((d[r+(B<<1)>>1]|0)==(d[t+(B<<1)>>1]|0))<<31>>31;b[s+p>>0]=((d[r+(p<<1)>>1]|0)==(d[t+(p<<1)>>1]|0))<<31>>31;b[s+B>>0]=C;C=p|2;B=p|3;D=((d[r+(B<<1)>>1]|0)==(d[t+(B<<1)>>1]|0))<<31>>31;b[s+C>>0]=((d[r+(C<<1)>>1]|0)==(d[t+(C<<1)>>1]|0))<<31>>31;b[s+B>>0]=D;p=p+4|0}while((p|0)<=(q|0));if(!w)break;else{t=t+(o<<1)|0;s=s+i|0;r=r+(l<<1)|0;w=w+-1|0}}u=m;return}while(1){w=0;do{r=w|1;s=((d[z+(r<<1)>>1]|0)==(d[x+(r<<1)>>1]|0))<<31>>31;b[y+w>>0]=((d[z+(w<<1)>>1]|0)==(d[x+(w<<1)>>1]|0))<<31>>31;b[y+r>>0]=s;s=w|2;r=w|3;t=((d[z+(r<<1)>>1]|0)==(d[x+(r<<1)>>1]|0))<<31>>31;b[y+s>>0]=((d[z+(s<<1)>>1]|0)==(d[x+(s<<1)>>1]|0))<<31>>31;b[y+r>>0]=t;w=w+4|0}while((w|0)<=(q|0));E=v;do{b[y+E>>0]=((d[z+(E<<1)>>1]|0)==(d[x+(E<<1)>>1]|0))<<31>>31;E=E+1|0}while((E|0)!=(j|0));if(!A)break;else{x=x+(o<<1)|0;y=y+i|0;z=z+(l<<1)|0;A=A+-1|0}}u=m;return}case 5:{A=c>>>1;c=g>>>1;g=k+-1|0;if(!k){u=m;return}k=j+-4|0;if((j|0)<4){if((j|0)>0){F=e;G=h;H=a;I=g}else{u=m;return}while(1){l=0;do{b[G+l>>0]=((d[H+(l<<1)>>1]|0)!=(d[F+(l<<1)>>1]|0))<<31>>31;l=l+1|0}while((l|0)!=(j|0));if(!I)break;else{F=F+(c<<1)|0;G=G+i|0;H=H+(A<<1)|0;I=I+-1|0}}u=m;return}I=j&-4;if((I|0)<(j|0)){J=e;K=h;L=a;M=g}else{H=e;e=h;h=a;a=g;while(1){g=0;do{G=g|1;F=((d[h+(G<<1)>>1]|0)!=(d[H+(G<<1)>>1]|0))<<31>>31;b[e+g>>0]=((d[h+(g<<1)>>1]|0)!=(d[H+(g<<1)>>1]|0))<<31>>31;b[e+G>>0]=F;F=g|2;G=g|3;l=((d[h+(G<<1)>>1]|0)!=(d[H+(G<<1)>>1]|0))<<31>>31;b[e+F>>0]=((d[h+(F<<1)>>1]|0)!=(d[H+(F<<1)>>1]|0))<<31>>31;b[e+G>>0]=l;g=g+4|0}while((g|0)<=(k|0));if(!a)break;else{H=H+(c<<1)|0;e=e+i|0;h=h+(A<<1)|0;a=a+-1|0}}u=m;return}while(1){a=0;do{h=a|1;e=((d[L+(h<<1)>>1]|0)!=(d[J+(h<<1)>>1]|0))<<31>>31;b[K+a>>0]=((d[L+(a<<1)>>1]|0)!=(d[J+(a<<1)>>1]|0))<<31>>31;b[K+h>>0]=e;e=a|2;h=a|3;H=((d[L+(h<<1)>>1]|0)!=(d[J+(h<<1)>>1]|0))<<31>>31;b[K+e>>0]=((d[L+(e<<1)>>1]|0)!=(d[J+(e<<1)>>1]|0))<<31>>31;b[K+h>>0]=H;a=a+4|0}while((a|0)<=(k|0));N=I;do{b[K+N>>0]=((d[L+(N<<1)>>1]|0)!=(d[J+(N<<1)>>1]|0))<<31>>31;N=N+1|0}while((N|0)!=(j|0));if(!M)break;else{J=J+(c<<1)|0;K=K+i|0;L=L+(A<<1)|0;M=M+-1|0}}u=m;return}default:{f[n>>2]=0;f[n+4>>2]=0;m=tT(n,15)|0;M=218933;A=m+15|0;do{b[m>>0]=b[M>>0]|0;m=m+1|0;M=M+1|0}while((m|0)<(A|0));tU(-215,n,218949,759)}}}function BU(a,c,e,f,g,h,i,j){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>1;c=f>>>1;f=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=e;n=g;o=a;p=f;while(1){if(l){q=0;do{b[n+q>>0]=((d[o+(q<<1)>>1]|0)<(d[m+(q<<1)>>1]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+(c<<1)|0;n=n+h|0;o=o+(k<<1)|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=e;e=g;g=a;a=f;while(1){f=0;do{m=f|1;l=((d[g+(m<<1)>>1]|0)<(d[n+(m<<1)>>1]|0))<<31>>31;b[e+f>>0]=((d[g+(f<<1)>>1]|0)<(d[n+(f<<1)>>1]|0))<<31>>31;b[e+m>>0]=l;l=f|2;m=f|3;q=((d[g+(m<<1)>>1]|0)<(d[n+(m<<1)>>1]|0))<<31>>31;b[e+l>>0]=((d[g+(l<<1)>>1]|0)<(d[n+(l<<1)>>1]|0))<<31>>31;b[e+m>>0]=q;f=f+4|0}while((f|0)<=(j|0));if(o){f=p;do{b[e+f>>0]=((d[g+(f<<1)>>1]|0)<(d[n+(f<<1)>>1]|0))<<31>>31;f=f+1|0}while((f|0)!=(i|0))}if(!a)break;else{n=n+(c<<1)|0;e=e+h|0;g=g+(k<<1)|0;a=a+-1|0}}return}function CU(a,c,e,f,g,h,i,j){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>1;c=f>>>1;f=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=e;n=g;o=a;p=f;while(1){if(l){q=0;do{b[n+q>>0]=((d[o+(q<<1)>>1]|0)<=(d[m+(q<<1)>>1]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+(c<<1)|0;n=n+h|0;o=o+(k<<1)|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=e;e=g;g=a;a=f;while(1){f=0;do{m=f|1;l=((d[g+(m<<1)>>1]|0)<=(d[n+(m<<1)>>1]|0))<<31>>31;b[e+f>>0]=((d[g+(f<<1)>>1]|0)<=(d[n+(f<<1)>>1]|0))<<31>>31;b[e+m>>0]=l;l=f|2;m=f|3;q=((d[g+(m<<1)>>1]|0)<=(d[n+(m<<1)>>1]|0))<<31>>31;b[e+l>>0]=((d[g+(l<<1)>>1]|0)<=(d[n+(l<<1)>>1]|0))<<31>>31;b[e+m>>0]=q;f=f+4|0}while((f|0)<=(j|0));if(o){f=p;do{b[e+f>>0]=((d[g+(f<<1)>>1]|0)<=(d[n+(f<<1)>>1]|0))<<31>>31;f=f+1|0}while((f|0)!=(i|0))}if(!a)break;else{n=n+(c<<1)|0;e=e+h|0;g=g+(k<<1)|0;a=a+-1|0}}return}function DU(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{EU(a,c,d,e,g,h,i,j);u=l;return}case 1:{EU(d,e,a,c,g,h,i,j);u=l;return}case 4:{FU(a,c,d,e,g,h,i,j);u=l;return}case 2:{FU(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=c>>>2;n=e>>>2;o=j+-1|0;if(!j){u=l;return}p=i+-4|0;if((i|0)<4){if((i|0)>0){q=d;r=g;s=a;t=o}else{u=l;return}while(1){v=0;do{b[r+v>>0]=((f[s+(v<<2)>>2]|0)==(f[q+(v<<2)>>2]|0))<<31>>31;v=v+1|0}while((v|0)!=(i|0));if(!t)break;else{q=q+(n<<2)|0;r=r+h|0;s=s+(k<<2)|0;t=t+-1|0}}u=l;return}t=i&-4;if((t|0)<(i|0)){w=d;x=g;y=a;z=o}else{s=d;r=g;q=a;v=o;while(1){o=0;do{A=o|1;B=((f[q+(A<<2)>>2]|0)==(f[s+(A<<2)>>2]|0))<<31>>31;b[r+o>>0]=((f[q+(o<<2)>>2]|0)==(f[s+(o<<2)>>2]|0))<<31>>31;b[r+A>>0]=B;B=o|2;A=o|3;C=((f[q+(A<<2)>>2]|0)==(f[s+(A<<2)>>2]|0))<<31>>31;b[r+B>>0]=((f[q+(B<<2)>>2]|0)==(f[s+(B<<2)>>2]|0))<<31>>31;b[r+A>>0]=C;o=o+4|0}while((o|0)<=(p|0));if(!v)break;else{s=s+(n<<2)|0;r=r+h|0;q=q+(k<<2)|0;v=v+-1|0}}u=l;return}while(1){v=0;do{q=v|1;r=((f[y+(q<<2)>>2]|0)==(f[w+(q<<2)>>2]|0))<<31>>31;b[x+v>>0]=((f[y+(v<<2)>>2]|0)==(f[w+(v<<2)>>2]|0))<<31>>31;b[x+q>>0]=r;r=v|2;q=v|3;s=((f[y+(q<<2)>>2]|0)==(f[w+(q<<2)>>2]|0))<<31>>31;b[x+r>>0]=((f[y+(r<<2)>>2]|0)==(f[w+(r<<2)>>2]|0))<<31>>31;b[x+q>>0]=s;v=v+4|0}while((v|0)<=(p|0));D=t;do{b[x+D>>0]=((f[y+(D<<2)>>2]|0)==(f[w+(D<<2)>>2]|0))<<31>>31;D=D+1|0}while((D|0)!=(i|0));if(!z)break;else{w=w+(n<<2)|0;x=x+h|0;y=y+(k<<2)|0;z=z+-1|0}}u=l;return}case 5:{z=c>>>2;c=e>>>2;e=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){E=d;F=g;G=a;H=e}else{u=l;return}while(1){k=0;do{b[F+k>>0]=((f[G+(k<<2)>>2]|0)!=(f[E+(k<<2)>>2]|0))<<31>>31;k=k+1|0}while((k|0)!=(i|0));if(!H)break;else{E=E+(c<<2)|0;F=F+h|0;G=G+(z<<2)|0;H=H+-1|0}}u=l;return}H=i&-4;if((H|0)<(i|0)){I=d;J=g;K=a;L=e}else{G=d;d=g;g=a;a=e;while(1){e=0;do{F=e|1;E=((f[g+(F<<2)>>2]|0)!=(f[G+(F<<2)>>2]|0))<<31>>31;b[d+e>>0]=((f[g+(e<<2)>>2]|0)!=(f[G+(e<<2)>>2]|0))<<31>>31;b[d+F>>0]=E;E=e|2;F=e|3;k=((f[g+(F<<2)>>2]|0)!=(f[G+(F<<2)>>2]|0))<<31>>31;b[d+E>>0]=((f[g+(E<<2)>>2]|0)!=(f[G+(E<<2)>>2]|0))<<31>>31;b[d+F>>0]=k;e=e+4|0}while((e|0)<=(j|0));if(!a)break;else{G=G+(c<<2)|0;d=d+h|0;g=g+(z<<2)|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=((f[K+(g<<2)>>2]|0)!=(f[I+(g<<2)>>2]|0))<<31>>31;b[J+a>>0]=((f[K+(a<<2)>>2]|0)!=(f[I+(a<<2)>>2]|0))<<31>>31;b[J+g>>0]=d;d=a|2;g=a|3;G=((f[K+(g<<2)>>2]|0)!=(f[I+(g<<2)>>2]|0))<<31>>31;b[J+d>>0]=((f[K+(d<<2)>>2]|0)!=(f[I+(d<<2)>>2]|0))<<31>>31;b[J+g>>0]=G;a=a+4|0}while((a|0)<=(j|0));M=H;do{b[J+M>>0]=((f[K+(M<<2)>>2]|0)!=(f[I+(M<<2)>>2]|0))<<31>>31;M=M+1|0}while((M|0)!=(i|0));if(!L)break;else{I=I+(c<<2)|0;J=J+h|0;K=K+(z<<2)|0;L=L+-1|0}}u=l;return}default:{f[m>>2]=0;f[m+4>>2]=0;l=tT(m,15)|0;L=218933;z=l+15|0;do{b[l>>0]=b[L>>0]|0;l=l+1|0;L=L+1|0}while((l|0)<(z|0));tU(-215,m,218949,759)}}}function EU(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>2;c=e>>>2;e=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=g;o=a;p=e;while(1){if(l){q=0;do{b[n+q>>0]=((f[o+(q<<2)>>2]|0)<(f[m+(q<<2)>>2]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+(c<<2)|0;n=n+h|0;o=o+(k<<2)|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=g;g=a;a=e;while(1){e=0;do{m=e|1;l=((f[g+(m<<2)>>2]|0)<(f[n+(m<<2)>>2]|0))<<31>>31;b[d+e>>0]=((f[g+(e<<2)>>2]|0)<(f[n+(e<<2)>>2]|0))<<31>>31;b[d+m>>0]=l;l=e|2;m=e|3;q=((f[g+(m<<2)>>2]|0)<(f[n+(m<<2)>>2]|0))<<31>>31;b[d+l>>0]=((f[g+(l<<2)>>2]|0)<(f[n+(l<<2)>>2]|0))<<31>>31;b[d+m>>0]=q;e=e+4|0}while((e|0)<=(j|0));if(o){e=p;do{b[d+e>>0]=((f[g+(e<<2)>>2]|0)<(f[n+(e<<2)>>2]|0))<<31>>31;e=e+1|0}while((e|0)!=(i|0))}if(!a)break;else{n=n+(c<<2)|0;d=d+h|0;g=g+(k<<2)|0;a=a+-1|0}}return}function FU(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>2;c=e>>>2;e=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=g;o=a;p=e;while(1){if(l){q=0;do{b[n+q>>0]=((f[o+(q<<2)>>2]|0)<=(f[m+(q<<2)>>2]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+(c<<2)|0;n=n+h|0;o=o+(k<<2)|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=g;g=a;a=e;while(1){e=0;do{m=e|1;l=((f[g+(m<<2)>>2]|0)<=(f[n+(m<<2)>>2]|0))<<31>>31;b[d+e>>0]=((f[g+(e<<2)>>2]|0)<=(f[n+(e<<2)>>2]|0))<<31>>31;b[d+m>>0]=l;l=e|2;m=e|3;q=((f[g+(m<<2)>>2]|0)<=(f[n+(m<<2)>>2]|0))<<31>>31;b[d+l>>0]=((f[g+(l<<2)>>2]|0)<=(f[n+(l<<2)>>2]|0))<<31>>31;b[d+m>>0]=q;e=e+4|0}while((e|0)<=(j|0));if(o){e=p;do{b[d+e>>0]=((f[g+(e<<2)>>2]|0)<=(f[n+(e<<2)>>2]|0))<<31>>31;e=e+1|0}while((e|0)!=(i|0))}if(!a)break;else{n=n+(c<<2)|0;d=d+h|0;g=g+(k<<2)|0;a=a+-1|0}}return}function GU(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{HU(a,c,d,e,g,h,i,j);u=l;return}case 1:{HU(d,e,a,c,g,h,i,j);u=l;return}case 4:{IU(a,c,d,e,g,h,i,j);u=l;return}case 2:{IU(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=c>>>2;o=e>>>2;p=j+-1|0;if(!j){u=l;return}q=i+-4|0;if((i|0)<4){if((i|0)>0){r=d;s=g;t=a;v=p}else{u=l;return}while(1){w=0;do{b[s+w>>0]=(+n[t+(w<<2)>>2]==+n[r+(w<<2)>>2])<<31>>31;w=w+1|0}while((w|0)!=(i|0));if(!v)break;else{r=r+(o<<2)|0;s=s+h|0;t=t+(k<<2)|0;v=v+-1|0}}u=l;return}v=i&-4;if((v|0)<(i|0)){x=d;y=g;z=a;A=p}else{t=d;s=g;r=a;w=p;while(1){p=0;do{B=p|1;C=(+n[r+(B<<2)>>2]==+n[t+(B<<2)>>2])<<31>>31;b[s+p>>0]=(+n[r+(p<<2)>>2]==+n[t+(p<<2)>>2])<<31>>31;b[s+B>>0]=C;C=p|2;B=p|3;D=(+n[r+(B<<2)>>2]==+n[t+(B<<2)>>2])<<31>>31;b[s+C>>0]=(+n[r+(C<<2)>>2]==+n[t+(C<<2)>>2])<<31>>31;b[s+B>>0]=D;p=p+4|0}while((p|0)<=(q|0));if(!w)break;else{t=t+(o<<2)|0;s=s+h|0;r=r+(k<<2)|0;w=w+-1|0}}u=l;return}while(1){w=0;do{r=w|1;s=(+n[z+(r<<2)>>2]==+n[x+(r<<2)>>2])<<31>>31;b[y+w>>0]=(+n[z+(w<<2)>>2]==+n[x+(w<<2)>>2])<<31>>31;b[y+r>>0]=s;s=w|2;r=w|3;t=(+n[z+(r<<2)>>2]==+n[x+(r<<2)>>2])<<31>>31;b[y+s>>0]=(+n[z+(s<<2)>>2]==+n[x+(s<<2)>>2])<<31>>31;b[y+r>>0]=t;w=w+4|0}while((w|0)<=(q|0));E=v;do{b[y+E>>0]=(+n[z+(E<<2)>>2]==+n[x+(E<<2)>>2])<<31>>31;E=E+1|0}while((E|0)!=(i|0));if(!A)break;else{x=x+(o<<2)|0;y=y+h|0;z=z+(k<<2)|0;A=A+-1|0}}u=l;return}case 5:{A=c>>>2;c=e>>>2;e=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){F=d;G=g;H=a;I=e}else{u=l;return}while(1){k=0;do{b[G+k>>0]=(+n[H+(k<<2)>>2]!=+n[F+(k<<2)>>2])<<31>>31;k=k+1|0}while((k|0)!=(i|0));if(!I)break;else{F=F+(c<<2)|0;G=G+h|0;H=H+(A<<2)|0;I=I+-1|0}}u=l;return}I=i&-4;if((I|0)<(i|0)){J=d;K=g;L=a;M=e}else{H=d;d=g;g=a;a=e;while(1){e=0;do{G=e|1;F=(+n[g+(G<<2)>>2]!=+n[H+(G<<2)>>2])<<31>>31;b[d+e>>0]=(+n[g+(e<<2)>>2]!=+n[H+(e<<2)>>2])<<31>>31;b[d+G>>0]=F;F=e|2;G=e|3;k=(+n[g+(G<<2)>>2]!=+n[H+(G<<2)>>2])<<31>>31;b[d+F>>0]=(+n[g+(F<<2)>>2]!=+n[H+(F<<2)>>2])<<31>>31;b[d+G>>0]=k;e=e+4|0}while((e|0)<=(j|0));if(!a)break;else{H=H+(c<<2)|0;d=d+h|0;g=g+(A<<2)|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=(+n[L+(g<<2)>>2]!=+n[J+(g<<2)>>2])<<31>>31;b[K+a>>0]=(+n[L+(a<<2)>>2]!=+n[J+(a<<2)>>2])<<31>>31;b[K+g>>0]=d;d=a|2;g=a|3;H=(+n[L+(g<<2)>>2]!=+n[J+(g<<2)>>2])<<31>>31;b[K+d>>0]=(+n[L+(d<<2)>>2]!=+n[J+(d<<2)>>2])<<31>>31;b[K+g>>0]=H;a=a+4|0}while((a|0)<=(j|0));N=I;do{b[K+N>>0]=(+n[L+(N<<2)>>2]!=+n[J+(N<<2)>>2])<<31>>31;N=N+1|0}while((N|0)!=(i|0));if(!M)break;else{J=J+(c<<2)|0;K=K+h|0;L=L+(A<<2)|0;M=M+-1|0}}u=l;return}default:{f[m>>2]=0;f[m+4>>2]=0;l=tT(m,15)|0;M=218933;A=l+15|0;do{b[l>>0]=b[M>>0]|0;l=l+1|0;M=M+1|0}while((l|0)<(A|0));tU(-215,m,218949,759)}}}function HU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0;j=c>>>2;c=e>>>2;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;o=a;p=e;while(1){if(k){q=0;do{b[m+q>>0]=(+n[o+(q<<2)>>2]<+n[l+(q<<2)>>2])<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{l=l+(c<<2)|0;m=m+g|0;o=o+(j<<2)|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);m=d;d=f;f=a;a=e;while(1){e=0;do{l=e|1;k=(+n[f+(l<<2)>>2]<+n[m+(l<<2)>>2])<<31>>31;b[d+e>>0]=(+n[f+(e<<2)>>2]<+n[m+(e<<2)>>2])<<31>>31;b[d+l>>0]=k;k=e|2;l=e|3;q=(+n[f+(l<<2)>>2]<+n[m+(l<<2)>>2])<<31>>31;b[d+k>>0]=(+n[f+(k<<2)>>2]<+n[m+(k<<2)>>2])<<31>>31;b[d+l>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(o){e=p;do{b[d+e>>0]=(+n[f+(e<<2)>>2]<+n[m+(e<<2)>>2])<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{m=m+(c<<2)|0;d=d+g|0;f=f+(j<<2)|0;a=a+-1|0}}return}function IU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0;j=c>>>2;c=e>>>2;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;o=a;p=e;while(1){if(k){q=0;do{b[m+q>>0]=(+n[o+(q<<2)>>2]<=+n[l+(q<<2)>>2])<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{l=l+(c<<2)|0;m=m+g|0;o=o+(j<<2)|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);m=d;d=f;f=a;a=e;while(1){e=0;do{l=e|1;k=(+n[f+(l<<2)>>2]<=+n[m+(l<<2)>>2])<<31>>31;b[d+e>>0]=(+n[f+(e<<2)>>2]<=+n[m+(e<<2)>>2])<<31>>31;b[d+l>>0]=k;k=e|2;l=e|3;q=(+n[f+(l<<2)>>2]<=+n[m+(l<<2)>>2])<<31>>31;b[d+k>>0]=(+n[f+(k<<2)>>2]<=+n[m+(k<<2)>>2])<<31>>31;b[d+l>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(o){e=p;do{b[d+e>>0]=(+n[f+(e<<2)>>2]<=+n[m+(e<<2)>>2])<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{m=m+(c<<2)|0;d=d+g|0;f=f+(j<<2)|0;a=a+-1|0}}return}function JU(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{KU(a,c,d,e,g,h,i,j);u=l;return}case 1:{KU(d,e,a,c,g,h,i,j);u=l;return}case 4:{LU(a,c,d,e,g,h,i,j);u=l;return}case 2:{LU(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=c>>>3;n=e>>>3;o=j+-1|0;if(!j){u=l;return}q=i+-4|0;if((i|0)<4){if((i|0)>0){r=d;s=g;t=a;v=o}else{u=l;return}while(1){w=0;do{b[s+w>>0]=(+p[t+(w<<3)>>3]==+p[r+(w<<3)>>3])<<31>>31;w=w+1|0}while((w|0)!=(i|0));if(!v)break;else{r=r+(n<<3)|0;s=s+h|0;t=t+(k<<3)|0;v=v+-1|0}}u=l;return}v=i&-4;if((v|0)<(i|0)){x=d;y=g;z=a;A=o}else{t=d;s=g;r=a;w=o;while(1){o=0;do{B=o|1;C=(+p[r+(B<<3)>>3]==+p[t+(B<<3)>>3])<<31>>31;b[s+o>>0]=(+p[r+(o<<3)>>3]==+p[t+(o<<3)>>3])<<31>>31;b[s+B>>0]=C;C=o|2;B=o|3;D=(+p[r+(B<<3)>>3]==+p[t+(B<<3)>>3])<<31>>31;b[s+C>>0]=(+p[r+(C<<3)>>3]==+p[t+(C<<3)>>3])<<31>>31;b[s+B>>0]=D;o=o+4|0}while((o|0)<=(q|0));if(!w)break;else{t=t+(n<<3)|0;s=s+h|0;r=r+(k<<3)|0;w=w+-1|0}}u=l;return}while(1){w=0;do{r=w|1;s=(+p[z+(r<<3)>>3]==+p[x+(r<<3)>>3])<<31>>31;b[y+w>>0]=(+p[z+(w<<3)>>3]==+p[x+(w<<3)>>3])<<31>>31;b[y+r>>0]=s;s=w|2;r=w|3;t=(+p[z+(r<<3)>>3]==+p[x+(r<<3)>>3])<<31>>31;b[y+s>>0]=(+p[z+(s<<3)>>3]==+p[x+(s<<3)>>3])<<31>>31;b[y+r>>0]=t;w=w+4|0}while((w|0)<=(q|0));E=v;do{b[y+E>>0]=(+p[z+(E<<3)>>3]==+p[x+(E<<3)>>3])<<31>>31;E=E+1|0}while((E|0)!=(i|0));if(!A)break;else{x=x+(n<<3)|0;y=y+h|0;z=z+(k<<3)|0;A=A+-1|0}}u=l;return}case 5:{A=c>>>3;c=e>>>3;e=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){F=d;G=g;H=a;I=e}else{u=l;return}while(1){k=0;do{b[G+k>>0]=(+p[H+(k<<3)>>3]!=+p[F+(k<<3)>>3])<<31>>31;k=k+1|0}while((k|0)!=(i|0));if(!I)break;else{F=F+(c<<3)|0;G=G+h|0;H=H+(A<<3)|0;I=I+-1|0}}u=l;return}I=i&-4;if((I|0)<(i|0)){J=d;K=g;L=a;M=e}else{H=d;d=g;g=a;a=e;while(1){e=0;do{G=e|1;F=(+p[g+(G<<3)>>3]!=+p[H+(G<<3)>>3])<<31>>31;b[d+e>>0]=(+p[g+(e<<3)>>3]!=+p[H+(e<<3)>>3])<<31>>31;b[d+G>>0]=F;F=e|2;G=e|3;k=(+p[g+(G<<3)>>3]!=+p[H+(G<<3)>>3])<<31>>31;b[d+F>>0]=(+p[g+(F<<3)>>3]!=+p[H+(F<<3)>>3])<<31>>31;b[d+G>>0]=k;e=e+4|0}while((e|0)<=(j|0));if(!a)break;else{H=H+(c<<3)|0;d=d+h|0;g=g+(A<<3)|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=(+p[L+(g<<3)>>3]!=+p[J+(g<<3)>>3])<<31>>31;b[K+a>>0]=(+p[L+(a<<3)>>3]!=+p[J+(a<<3)>>3])<<31>>31;b[K+g>>0]=d;d=a|2;g=a|3;H=(+p[L+(g<<3)>>3]!=+p[J+(g<<3)>>3])<<31>>31;b[K+d>>0]=(+p[L+(d<<3)>>3]!=+p[J+(d<<3)>>3])<<31>>31;b[K+g>>0]=H;a=a+4|0}while((a|0)<=(j|0));N=I;do{b[K+N>>0]=(+p[L+(N<<3)>>3]!=+p[J+(N<<3)>>3])<<31>>31;N=N+1|0}while((N|0)!=(i|0));if(!M)break;else{J=J+(c<<3)|0;K=K+h|0;L=L+(A<<3)|0;M=M+-1|0}}u=l;return}default:{f[m>>2]=0;f[m+4>>2]=0;l=tT(m,15)|0;M=218933;A=l+15|0;do{b[l>>0]=b[M>>0]|0;l=l+1|0;M=M+1|0}while((l|0)<(A|0));tU(-215,m,219028,814)}}}function KU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0;j=c>>>3;c=e>>>3;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=e;while(1){if(k){q=0;do{b[m+q>>0]=(+p[n+(q<<3)>>3]<+p[l+(q<<3)>>3])<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!o)break;else{l=l+(c<<3)|0;m=m+g|0;n=n+(j<<3)|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=e;while(1){e=0;do{l=e|1;k=(+p[f+(l<<3)>>3]<+p[m+(l<<3)>>3])<<31>>31;b[d+e>>0]=(+p[f+(e<<3)>>3]<+p[m+(e<<3)>>3])<<31>>31;b[d+l>>0]=k;k=e|2;l=e|3;q=(+p[f+(l<<3)>>3]<+p[m+(l<<3)>>3])<<31>>31;b[d+k>>0]=(+p[f+(k<<3)>>3]<+p[m+(k<<3)>>3])<<31>>31;b[d+l>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(n){e=o;do{b[d+e>>0]=(+p[f+(e<<3)>>3]<+p[m+(e<<3)>>3])<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{m=m+(c<<3)|0;d=d+g|0;f=f+(j<<3)|0;a=a+-1|0}}return}function LU(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0;j=c>>>3;c=e>>>3;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=e;while(1){if(k){q=0;do{b[m+q>>0]=(+p[n+(q<<3)>>3]<=+p[l+(q<<3)>>3])<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!o)break;else{l=l+(c<<3)|0;m=m+g|0;n=n+(j<<3)|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=e;while(1){e=0;do{l=e|1;k=(+p[f+(l<<3)>>3]<=+p[m+(l<<3)>>3])<<31>>31;b[d+e>>0]=(+p[f+(e<<3)>>3]<=+p[m+(e<<3)>>3])<<31>>31;b[d+l>>0]=k;k=e|2;l=e|3;q=(+p[f+(l<<3)>>3]<=+p[m+(l<<3)>>3])<<31>>31;b[d+k>>0]=(+p[f+(k<<3)>>3]<=+p[m+(k<<3)>>3])<<31>>31;b[d+l>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(n){e=o;do{b[d+e>>0]=(+p[f+(e<<3)>>3]<=+p[m+(e<<3)>>3])<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{m=m+(c<<3)|0;d=d+g|0;f=f+(j<<3)|0;a=a+-1|0}}return}function MU(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=+p[k>>3];if(!(+L(+(l+-1.0))<=1.1920928955078125e-07)){if(!j)return;k=i+-4|0;m=(i|0)<4;o=i&-4;q=d;r=f;s=a;t=j;while(1){t=t+-1|0;if(m)u=0;else{v=0;do{w=mrc(l*+n[44016+((h[s+v>>0]|0)+128<<2)>>2]*+n[44016+((h[q+v>>0]|0)+128<<2)>>2])|0;x=v|1;y=mrc(l*+n[44016+((h[s+x>>0]|0)+128<<2)>>2]*+n[44016+((h[q+x>>0]|0)+128<<2)>>2])|0;b[r+v>>0]=w>>>0<256?w:(w|0)>0?255:0;b[r+x>>0]=y>>>0<256?y:(y|0)>0?255:0;y=v|2;x=mrc(l*+n[44016+((h[s+y>>0]|0)+128<<2)>>2]*+n[44016+((h[q+y>>0]|0)+128<<2)>>2])|0;w=v|3;z=mrc(l*+n[44016+((h[s+w>>0]|0)+128<<2)>>2]*+n[44016+((h[q+w>>0]|0)+128<<2)>>2])|0;b[r+y>>0]=x>>>0<256?x:(x|0)>0?255:0;b[r+w>>0]=z>>>0<256?z:(z|0)>0?255:0;v=v+4|0}while((v|0)<=(k|0));u=o}if((u|0)<(i|0)){v=u;do{z=mrc(l*+n[44016+((h[s+v>>0]|0)+128<<2)>>2]*+n[44016+((h[q+v>>0]|0)+128<<2)>>2])|0;b[r+v>>0]=z>>>0<256?z:(z|0)>0?255:0;v=v+1|0}while((v|0)!=(i|0))}if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0}}return}s=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){A=d;B=f;C=a;D=s}else return;while(1){r=0;do{q=Y(h[A+r>>0]|0,h[C+r>>0]|0)|0;b[B+r>>0]=q>>>0<256?q:q|0?255:0;r=r+1|0}while((r|0)!=(i|0));if(!D)break;else{A=A+e|0;B=B+g|0;C=C+c|0;D=D+-1|0}}return}D=i&-4;if((D|0)<(i|0)){E=d;F=f;G=a;H=s}else{C=d;d=f;f=a;a=s;while(1){s=0;do{B=Y(h[C+s>>0]|0,h[f+s>>0]|0)|0;A=s|1;r=Y(h[C+A>>0]|0,h[f+A>>0]|0)|0;b[d+s>>0]=B>>>0<256?B:B|0?255:0;b[d+A>>0]=r>>>0<256?r:r|0?255:0;r=s|2;A=Y(h[C+r>>0]|0,h[f+r>>0]|0)|0;B=s|3;q=Y(h[C+B>>0]|0,h[f+B>>0]|0)|0;b[d+r>>0]=A>>>0<256?A:A|0?255:0;b[d+B>>0]=q>>>0<256?q:q|0?255:0;s=s+4|0}while((s|0)<=(j|0));if(!a)break;else{C=C+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(h[E+a>>0]|0,h[G+a>>0]|0)|0;d=a|1;C=Y(h[E+d>>0]|0,h[G+d>>0]|0)|0;b[F+a>>0]=f>>>0<256?f:f|0?255:0;b[F+d>>0]=C>>>0<256?C:C|0?255:0;C=a|2;d=Y(h[E+C>>0]|0,h[G+C>>0]|0)|0;f=a|3;s=Y(h[E+f>>0]|0,h[G+f>>0]|0)|0;b[F+C>>0]=d>>>0<256?d:d|0?255:0;b[F+f>>0]=s>>>0<256?s:s|0?255:0;a=a+4|0}while((a|0)<=(j|0));I=D;do{a=Y(h[E+I>>0]|0,h[G+I>>0]|0)|0;b[F+I>>0]=a>>>0<256?a:a|0?255:0;I=I+1|0}while((I|0)!=(i|0));if(!H)break;else{E=E+e|0;F=F+g|0;G=G+c|0;H=H+-1|0}}return}function NU(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;k=+p[j>>3];j=i+-1|0;l=(i|0)==0;if(!(+L(+(k+-1.0))<=1.1920928955078125e-07)){if(l)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){m=d;n=f;o=a;q=j}else return;while(1){r=0;do{s=mrc(+(b[m+r>>0]|0)*(k*+(b[o+r>>0]|0)))|0;b[n+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(h|0));if(!q)break;else{m=m+e|0;n=n+g|0;o=o+c|0;q=q+-1|0}}return}q=h&-4;if((q|0)<(h|0)){t=d;u=f;v=a;w=j}else{o=d;n=f;m=a;r=j;while(1){s=0;do{x=mrc(+(b[o+s>>0]|0)*(k*+(b[m+s>>0]|0)))|0;y=s|1;z=mrc(+(b[o+y>>0]|0)*(k*+(b[m+y>>0]|0)))|0;b[n+s>>0]=(x+128|0)>>>0<256?x:(x|0)>0?127:128;b[n+y>>0]=(z+128|0)>>>0<256?z:(z|0)>0?127:128;z=s|2;y=mrc(+(b[o+z>>0]|0)*(k*+(b[m+z>>0]|0)))|0;x=s|3;A=mrc(+(b[o+x>>0]|0)*(k*+(b[m+x>>0]|0)))|0;b[n+z>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;b[n+x>>0]=(A+128|0)>>>0<256?A:(A|0)>0?127:128;s=s+4|0}while((s|0)<=(i|0));if(!r)break;else{o=o+e|0;n=n+g|0;m=m+c|0;r=r+-1|0}}return}while(1){r=0;do{m=mrc(+(b[t+r>>0]|0)*(k*+(b[v+r>>0]|0)))|0;n=r|1;o=mrc(+(b[t+n>>0]|0)*(k*+(b[v+n>>0]|0)))|0;b[u+r>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;b[u+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=r|2;n=mrc(+(b[t+o>>0]|0)*(k*+(b[v+o>>0]|0)))|0;m=r|3;s=mrc(+(b[t+m>>0]|0)*(k*+(b[v+m>>0]|0)))|0;b[u+o>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;b[u+m>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+4|0}while((r|0)<=(i|0));B=q;do{r=mrc(+(b[t+B>>0]|0)*(k*+(b[v+B>>0]|0)))|0;b[u+B>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;B=B+1|0}while((B|0)!=(h|0));if(!w)break;else{t=t+e|0;u=u+g|0;v=v+c|0;w=w+-1|0}}return}else{if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){C=d;D=f;E=a;F=j}else return;while(1){w=0;do{v=Y(b[C+w>>0]|0,b[E+w>>0]|0)|0;b[D+w>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;w=w+1|0}while((w|0)!=(h|0));if(!F)break;else{C=C+e|0;D=D+g|0;E=E+c|0;F=F+-1|0}}return}F=h&-4;if((F|0)<(h|0)){G=d;H=f;I=a;J=j}else{E=d;d=f;f=a;a=j;while(1){j=0;do{D=Y(b[E+j>>0]|0,b[f+j>>0]|0)|0;C=j|1;w=Y(b[E+C>>0]|0,b[f+C>>0]|0)|0;b[d+j>>0]=(D+128|0)>>>0<256?D:(D|0)>0?127:128;b[d+C>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;w=j|2;C=Y(b[E+w>>0]|0,b[f+w>>0]|0)|0;D=j|3;v=Y(b[E+D>>0]|0,b[f+D>>0]|0)|0;b[d+w>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;b[d+D>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;j=j+4|0}while((j|0)<=(l|0));if(!a)break;else{E=E+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(b[G+a>>0]|0,b[I+a>>0]|0)|0;d=a|1;E=Y(b[G+d>>0]|0,b[I+d>>0]|0)|0;b[H+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[H+d>>0]=(E+128|0)>>>0<256?E:(E|0)>0?127:128;E=a|2;d=Y(b[G+E>>0]|0,b[I+E>>0]|0)|0;f=a|3;j=Y(b[G+f>>0]|0,b[I+f>>0]|0)|0;b[H+E>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[H+f>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;a=a+4|0}while((a|0)<=(l|0));K=F;do{a=Y(b[G+K>>0]|0,b[I+K>>0]|0)|0;b[H+K>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;K=K+1|0}while((K|0)!=(h|0));if(!J)break;else{G=G+e|0;H=H+g|0;I=I+c|0;J=J+-1|0}}return}}function OU(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;l=+p[k>>3];k=b>>>1;b=e>>>1;e=g>>>1;if(!(+L(+(l+-1.0))<=1.1920928955078125e-07)){if(!i)return;g=h+-4|0;m=(h|0)<4;n=h&-4;o=c;q=f;r=a;s=i;while(1){s=s+-1|0;if(m)t=0;else{u=0;do{v=mrc(+(j[o+(u<<1)>>1]|0)*(l*+(j[r+(u<<1)>>1]|0)))|0;w=u|1;x=mrc(+(j[o+(w<<1)>>1]|0)*(l*+(j[r+(w<<1)>>1]|0)))|0;d[q+(u<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d[q+(w<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=u|2;w=mrc(+(j[o+(x<<1)>>1]|0)*(l*+(j[r+(x<<1)>>1]|0)))|0;v=u|3;y=mrc(+(j[o+(v<<1)>>1]|0)*(l*+(j[r+(v<<1)>>1]|0)))|0;d[q+(x<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[q+(v<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;u=u+4|0}while((u|0)<=(g|0));t=n}if((t|0)<(h|0)){u=t;do{y=mrc(+(j[o+(u<<1)>>1]|0)*(l*+(j[r+(u<<1)>>1]|0)))|0;d[q+(u<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;u=u+1|0}while((u|0)!=(h|0))}if(!s)break;else{o=o+(b<<1)|0;q=q+(e<<1)|0;r=r+(k<<1)|0}}return}r=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){z=c;A=f;B=a;C=r}else return;while(1){q=0;do{o=Y(j[z+(q<<1)>>1]|0,j[B+(q<<1)>>1]|0)|0;d[A+(q<<1)>>1]=o>>>0<65536?o:o|0?65535:0;q=q+1|0}while((q|0)!=(h|0));if(!C)break;else{z=z+(b<<1)|0;A=A+(e<<1)|0;B=B+(k<<1)|0;C=C+-1|0}}return}C=h&-4;if((C|0)<(h|0)){D=c;E=f;F=a;G=r}else{B=c;c=f;f=a;a=r;while(1){r=0;do{A=Y(j[B+(r<<1)>>1]|0,j[f+(r<<1)>>1]|0)|0;z=r|1;q=Y(j[B+(z<<1)>>1]|0,j[f+(z<<1)>>1]|0)|0;d[c+(r<<1)>>1]=A>>>0<65536?A:A|0?65535:0;d[c+(z<<1)>>1]=q>>>0<65536?q:q|0?65535:0;q=r|2;z=Y(j[B+(q<<1)>>1]|0,j[f+(q<<1)>>1]|0)|0;A=r|3;o=Y(j[B+(A<<1)>>1]|0,j[f+(A<<1)>>1]|0)|0;d[c+(q<<1)>>1]=z>>>0<65536?z:z|0?65535:0;d[c+(A<<1)>>1]=o>>>0<65536?o:o|0?65535:0;r=r+4|0}while((r|0)<=(i|0));if(!a)break;else{B=B+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(j[D+(a<<1)>>1]|0,j[F+(a<<1)>>1]|0)|0;c=a|1;B=Y(j[D+(c<<1)>>1]|0,j[F+(c<<1)>>1]|0)|0;d[E+(a<<1)>>1]=f>>>0<65536?f:f|0?65535:0;d[E+(c<<1)>>1]=B>>>0<65536?B:B|0?65535:0;B=a|2;c=Y(j[D+(B<<1)>>1]|0,j[F+(B<<1)>>1]|0)|0;f=a|3;r=Y(j[D+(f<<1)>>1]|0,j[F+(f<<1)>>1]|0)|0;d[E+(B<<1)>>1]=c>>>0<65536?c:c|0?65535:0;d[E+(f<<1)>>1]=r>>>0<65536?r:r|0?65535:0;a=a+4|0}while((a|0)<=(i|0));H=C;do{a=Y(j[D+(H<<1)>>1]|0,j[F+(H<<1)>>1]|0)|0;d[E+(H<<1)>>1]=a>>>0<65536?a:a|0?65535:0;H=H+1|0}while((H|0)!=(h|0));if(!G)break;else{D=D+(b<<1)|0;E=E+(e<<1)|0;F=F+(k<<1)|0;G=G+-1|0}}return}function PU(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=+p[j>>3];j=b>>>1;b=e>>>1;e=g>>>1;if(!(+L(+(k+-1.0))<=1.1920928955078125e-07)){if(!i)return;g=h+-4|0;l=(h|0)<4;m=h&-4;n=c;o=f;q=a;r=i;while(1){r=r+-1|0;if(l)s=0;else{t=0;do{u=mrc(+(d[n+(t<<1)>>1]|0)*(k*+(d[q+(t<<1)>>1]|0)))|0;v=t|1;w=mrc(+(d[n+(v<<1)>>1]|0)*(k*+(d[q+(v<<1)>>1]|0)))|0;d[o+(t<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[o+(v<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;w=t|2;v=mrc(+(d[n+(w<<1)>>1]|0)*(k*+(d[q+(w<<1)>>1]|0)))|0;u=t|3;x=mrc(+(d[n+(u<<1)>>1]|0)*(k*+(d[q+(u<<1)>>1]|0)))|0;d[o+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[o+(u<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;t=t+4|0}while((t|0)<=(g|0));s=m}if((s|0)<(h|0)){t=s;do{x=mrc(+(d[n+(t<<1)>>1]|0)*(k*+(d[q+(t<<1)>>1]|0)))|0;d[o+(t<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;t=t+1|0}while((t|0)!=(h|0))}if(!r)break;else{n=n+(b<<1)|0;o=o+(e<<1)|0;q=q+(j<<1)|0}}return}q=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){y=c;z=f;A=a;B=q}else return;while(1){o=0;do{n=Y(d[y+(o<<1)>>1]|0,d[A+(o<<1)>>1]|0)|0;d[z+(o<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;o=o+1|0}while((o|0)!=(h|0));if(!B)break;else{y=y+(b<<1)|0;z=z+(e<<1)|0;A=A+(j<<1)|0;B=B+-1|0}}return}B=h&-4;if((B|0)<(h|0)){C=c;D=f;E=a;F=q}else{A=c;c=f;f=a;a=q;while(1){q=0;do{z=Y(d[A+(q<<1)>>1]|0,d[f+(q<<1)>>1]|0)|0;y=q|1;o=Y(d[A+(y<<1)>>1]|0,d[f+(y<<1)>>1]|0)|0;d[c+(q<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[c+(y<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=q|2;y=Y(d[A+(o<<1)>>1]|0,d[f+(o<<1)>>1]|0)|0;z=q|3;n=Y(d[A+(z<<1)>>1]|0,d[f+(z<<1)>>1]|0)|0;d[c+(o<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[c+(z<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;q=q+4|0}while((q|0)<=(i|0));if(!a)break;else{A=A+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(d[C+(a<<1)>>1]|0,d[E+(a<<1)>>1]|0)|0;c=a|1;A=Y(d[C+(c<<1)>>1]|0,d[E+(c<<1)>>1]|0)|0;d[D+(a<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;d[D+(c<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;A=a|2;c=Y(d[C+(A<<1)>>1]|0,d[E+(A<<1)>>1]|0)|0;f=a|3;q=Y(d[C+(f<<1)>>1]|0,d[E+(f<<1)>>1]|0)|0;d[D+(A<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;d[D+(f<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;a=a+4|0}while((a|0)<=(i|0));G=B;do{a=Y(d[C+(G<<1)>>1]|0,d[E+(G<<1)>>1]|0)|0;d[D+(G<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0));if(!F)break;else{C=C+(b<<1)|0;D=D+(e<<1)|0;E=E+(j<<1)|0;F=F+-1|0}}return}function QU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=+p[i>>3];i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;k=(h|0)==0;if(!(+L(+(j+-1.0))<=1.1920928955078125e-07)){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;o=a;q=f}else return;while(1){r=0;do{n[m+(r<<2)>>2]=+n[l+(r<<2)>>2]*(j*+n[o+(r<<2)>>2]);r=r+1|0}while((r|0)!=(g|0));if(!q)break;else{l=l+(b<<2)|0;m=m+(d<<2)|0;o=o+(i<<2)|0;q=q+-1|0}}return}q=g&-4;if((q|0)<(g|0)){s=c;t=e;u=a;v=f}else{o=c;m=e;l=a;r=f;while(1){w=0;do{x=w|1;y=+n[o+(x<<2)>>2]*(j*+n[l+(x<<2)>>2]);n[m+(w<<2)>>2]=+n[o+(w<<2)>>2]*(j*+n[l+(w<<2)>>2]);n[m+(x<<2)>>2]=y;x=w|2;z=w|3;y=+n[o+(z<<2)>>2]*(j*+n[l+(z<<2)>>2]);n[m+(x<<2)>>2]=+n[o+(x<<2)>>2]*(j*+n[l+(x<<2)>>2]);n[m+(z<<2)>>2]=y;w=w+4|0}while((w|0)<=(h|0));if(!r)break;else{o=o+(b<<2)|0;m=m+(d<<2)|0;l=l+(i<<2)|0;r=r+-1|0}}return}while(1){r=0;do{l=r|1;y=+n[s+(l<<2)>>2]*(j*+n[u+(l<<2)>>2]);n[t+(r<<2)>>2]=+n[s+(r<<2)>>2]*(j*+n[u+(r<<2)>>2]);n[t+(l<<2)>>2]=y;l=r|2;m=r|3;y=+n[s+(m<<2)>>2]*(j*+n[u+(m<<2)>>2]);n[t+(l<<2)>>2]=+n[s+(l<<2)>>2]*(j*+n[u+(l<<2)>>2]);n[t+(m<<2)>>2]=y;r=r+4|0}while((r|0)<=(h|0));A=q;do{n[t+(A<<2)>>2]=+n[s+(A<<2)>>2]*(j*+n[u+(A<<2)>>2]);A=A+1|0}while((A|0)!=(g|0));if(!v)break;else{s=s+(b<<2)|0;t=t+(d<<2)|0;u=u+(i<<2)|0;v=v+-1|0}}return}else{if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){B=c;C=e;D=a;E=f}else return;while(1){v=0;do{n[C+(v<<2)>>2]=+n[D+(v<<2)>>2]*+n[B+(v<<2)>>2];v=v+1|0}while((v|0)!=(g|0));if(!E)break;else{B=B+(b<<2)|0;C=C+(d<<2)|0;D=D+(i<<2)|0;E=E+-1|0}}return}E=g&-4;if((E|0)<(g|0)){F=c;G=e;H=a;I=f}else{D=c;c=e;e=a;a=f;while(1){f=0;do{C=f|1;j=+n[e+(C<<2)>>2]*+n[D+(C<<2)>>2];n[c+(f<<2)>>2]=+n[e+(f<<2)>>2]*+n[D+(f<<2)>>2];n[c+(C<<2)>>2]=j;C=f|2;B=f|3;j=+n[e+(B<<2)>>2]*+n[D+(B<<2)>>2];n[c+(C<<2)>>2]=+n[e+(C<<2)>>2]*+n[D+(C<<2)>>2];n[c+(B<<2)>>2]=j;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{D=D+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;j=+n[H+(e<<2)>>2]*+n[F+(e<<2)>>2];n[G+(a<<2)>>2]=+n[H+(a<<2)>>2]*+n[F+(a<<2)>>2];n[G+(e<<2)>>2]=j;e=a|2;c=a|3;j=+n[H+(c<<2)>>2]*+n[F+(c<<2)>>2];n[G+(e<<2)>>2]=+n[H+(e<<2)>>2]*+n[F+(e<<2)>>2];n[G+(c<<2)>>2]=j;a=a+4|0}while((a|0)<=(k|0));J=E;do{n[G+(J<<2)>>2]=+n[H+(J<<2)>>2]*+n[F+(J<<2)>>2];J=J+1|0}while((J|0)!=(g|0));if(!I)break;else{F=F+(b<<2)|0;G=G+(d<<2)|0;H=H+(i<<2)|0;I=I+-1|0}}return}}function RU(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;k=+p[j>>3];j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;l=(i|0)==0;if(!(+L(+(k+-1.0))<=1.1920928955078125e-07)){if(l)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){m=c;n=e;o=a;q=g}else return;while(1){r=0;do{s=nrc(+(f[m+(r<<2)>>2]|0)*(k*+(f[o+(r<<2)>>2]|0)))|0;f[n+(r<<2)>>2]=s;r=r+1|0}while((r|0)!=(h|0));if(!q)break;else{m=m+(b<<2)|0;n=n+(d<<2)|0;o=o+(j<<2)|0;q=q+-1|0}}return}q=h&-4;if((q|0)<(h|0)){t=c;u=e;v=a;w=g}else{o=c;n=e;m=a;r=g;while(1){s=0;do{x=nrc(+(f[o+(s<<2)>>2]|0)*(k*+(f[m+(s<<2)>>2]|0)))|0;y=s|1;z=nrc(+(f[o+(y<<2)>>2]|0)*(k*+(f[m+(y<<2)>>2]|0)))|0;f[n+(s<<2)>>2]=x;f[n+(y<<2)>>2]=z;z=s|2;y=nrc(+(f[o+(z<<2)>>2]|0)*(k*+(f[m+(z<<2)>>2]|0)))|0;x=s|3;A=nrc(+(f[o+(x<<2)>>2]|0)*(k*+(f[m+(x<<2)>>2]|0)))|0;f[n+(z<<2)>>2]=y;f[n+(x<<2)>>2]=A;s=s+4|0}while((s|0)<=(i|0));if(!r)break;else{o=o+(b<<2)|0;n=n+(d<<2)|0;m=m+(j<<2)|0;r=r+-1|0}}return}while(1){r=0;do{m=nrc(+(f[t+(r<<2)>>2]|0)*(k*+(f[v+(r<<2)>>2]|0)))|0;n=r|1;o=nrc(+(f[t+(n<<2)>>2]|0)*(k*+(f[v+(n<<2)>>2]|0)))|0;f[u+(r<<2)>>2]=m;f[u+(n<<2)>>2]=o;o=r|2;n=nrc(+(f[t+(o<<2)>>2]|0)*(k*+(f[v+(o<<2)>>2]|0)))|0;m=r|3;s=nrc(+(f[t+(m<<2)>>2]|0)*(k*+(f[v+(m<<2)>>2]|0)))|0;f[u+(o<<2)>>2]=n;f[u+(m<<2)>>2]=s;r=r+4|0}while((r|0)<=(i|0));B=q;do{r=nrc(+(f[t+(B<<2)>>2]|0)*(k*+(f[v+(B<<2)>>2]|0)))|0;f[u+(B<<2)>>2]=r;B=B+1|0}while((B|0)!=(h|0));if(!w)break;else{t=t+(b<<2)|0;u=u+(d<<2)|0;v=v+(j<<2)|0;w=w+-1|0}}return}else{if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){C=c;D=e;E=a;F=g}else return;while(1){w=0;do{v=Y(f[C+(w<<2)>>2]|0,f[E+(w<<2)>>2]|0)|0;f[D+(w<<2)>>2]=v;w=w+1|0}while((w|0)!=(h|0));if(!F)break;else{C=C+(b<<2)|0;D=D+(d<<2)|0;E=E+(j<<2)|0;F=F+-1|0}}return}F=h&-4;if((F|0)<(h|0)){G=c;H=e;I=a;J=g}else{E=c;c=e;e=a;a=g;while(1){g=0;do{D=Y(f[E+(g<<2)>>2]|0,f[e+(g<<2)>>2]|0)|0;C=g|1;w=Y(f[E+(C<<2)>>2]|0,f[e+(C<<2)>>2]|0)|0;f[c+(g<<2)>>2]=D;f[c+(C<<2)>>2]=w;w=g|2;C=Y(f[E+(w<<2)>>2]|0,f[e+(w<<2)>>2]|0)|0;D=g|3;v=Y(f[E+(D<<2)>>2]|0,f[e+(D<<2)>>2]|0)|0;f[c+(w<<2)>>2]=C;f[c+(D<<2)>>2]=v;g=g+4|0}while((g|0)<=(l|0));if(!a)break;else{E=E+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=Y(f[G+(a<<2)>>2]|0,f[I+(a<<2)>>2]|0)|0;c=a|1;E=Y(f[G+(c<<2)>>2]|0,f[I+(c<<2)>>2]|0)|0;f[H+(a<<2)>>2]=e;f[H+(c<<2)>>2]=E;E=a|2;c=Y(f[G+(E<<2)>>2]|0,f[I+(E<<2)>>2]|0)|0;e=a|3;g=Y(f[G+(e<<2)>>2]|0,f[I+(e<<2)>>2]|0)|0;f[H+(E<<2)>>2]=c;f[H+(e<<2)>>2]=g;a=a+4|0}while((a|0)<=(l|0));K=F;do{a=Y(f[G+(K<<2)>>2]|0,f[I+(K<<2)>>2]|0)|0;f[H+(K<<2)>>2]=a;K=K+1|0}while((K|0)!=(h|0));if(!J)break;else{G=G+(b<<2)|0;H=H+(d<<2)|0;I=I+(j<<2)|0;J=J+-1|0}}return}}function SU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;j=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;k=(h|0)==0;if(+p[i>>3]==1.0){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;n=a;o=f}else return;while(1){q=0;do{p[m+(q<<3)>>3]=+p[n+(q<<3)>>3]*+p[l+(q<<3)>>3];q=q+1|0}while((q|0)!=(g|0));if(!o)break;else{l=l+(b<<3)|0;m=m+(d<<3)|0;n=n+(j<<3)|0;o=o+-1|0}}return}o=g&-4;if((o|0)<(g|0)){r=c;s=e;t=a;u=f}else{n=c;m=e;l=a;q=f;while(1){v=0;do{w=v|1;x=+p[l+(w<<3)>>3]*+p[n+(w<<3)>>3];p[m+(v<<3)>>3]=+p[l+(v<<3)>>3]*+p[n+(v<<3)>>3];p[m+(w<<3)>>3]=x;w=v|2;y=v|3;x=+p[l+(y<<3)>>3]*+p[n+(y<<3)>>3];p[m+(w<<3)>>3]=+p[l+(w<<3)>>3]*+p[n+(w<<3)>>3];p[m+(y<<3)>>3]=x;v=v+4|0}while((v|0)<=(h|0));if(!q)break;else{n=n+(b<<3)|0;m=m+(d<<3)|0;l=l+(j<<3)|0;q=q+-1|0}}return}while(1){q=0;do{l=q|1;x=+p[t+(l<<3)>>3]*+p[r+(l<<3)>>3];p[s+(q<<3)>>3]=+p[t+(q<<3)>>3]*+p[r+(q<<3)>>3];p[s+(l<<3)>>3]=x;l=q|2;m=q|3;x=+p[t+(m<<3)>>3]*+p[r+(m<<3)>>3];p[s+(l<<3)>>3]=+p[t+(l<<3)>>3]*+p[r+(l<<3)>>3];p[s+(m<<3)>>3]=x;q=q+4|0}while((q|0)<=(h|0));z=o;do{p[s+(z<<3)>>3]=+p[t+(z<<3)>>3]*+p[r+(z<<3)>>3];z=z+1|0}while((z|0)!=(g|0));if(!u)break;else{r=r+(b<<3)|0;s=s+(d<<3)|0;t=t+(j<<3)|0;u=u+-1|0}}return}else{if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){A=c;B=e;C=a;D=f}else return;while(1){u=0;do{p[B+(u<<3)>>3]=+p[A+(u<<3)>>3]*(+p[C+(u<<3)>>3]*+p[i>>3]);u=u+1|0}while((u|0)!=(g|0));if(!D)break;else{A=A+(b<<3)|0;B=B+(d<<3)|0;C=C+(j<<3)|0;D=D+-1|0}}return}D=g&-4;if((D|0)<(g|0)){E=c;F=e;G=a;H=f}else{C=c;c=e;e=a;a=f;while(1){f=0;do{x=+p[i>>3];B=f|1;I=x*+p[e+(B<<3)>>3]*+p[C+(B<<3)>>3];p[c+(f<<3)>>3]=+p[C+(f<<3)>>3]*(+p[e+(f<<3)>>3]*x);p[c+(B<<3)>>3]=I;B=f|2;I=+p[i>>3];A=f|3;x=I*+p[e+(A<<3)>>3]*+p[C+(A<<3)>>3];p[c+(B<<3)>>3]=+p[C+(B<<3)>>3]*(+p[e+(B<<3)>>3]*I);p[c+(A<<3)>>3]=x;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{C=C+(b<<3)|0;c=c+(d<<3)|0;e=e+(j<<3)|0;a=a+-1|0}}return}while(1){a=0;do{x=+p[i>>3];e=a|1;I=x*+p[G+(e<<3)>>3]*+p[E+(e<<3)>>3];p[F+(a<<3)>>3]=+p[E+(a<<3)>>3]*(+p[G+(a<<3)>>3]*x);p[F+(e<<3)>>3]=I;e=a|2;I=+p[i>>3];c=a|3;x=I*+p[G+(c<<3)>>3]*+p[E+(c<<3)>>3];p[F+(e<<3)>>3]=+p[E+(e<<3)>>3]*(+p[G+(e<<3)>>3]*I);p[F+(c<<3)>>3]=x;a=a+4|0}while((a|0)<=(k|0));J=D;do{p[F+(J<<3)>>3]=+p[E+(J<<3)>>3]*(+p[G+(J<<3)>>3]*+p[i>>3]);J=J+1|0}while((J|0)!=(g|0));if(!H)break;else{E=E+(b<<3)|0;F=F+(d<<3)|0;G=G+(j<<3)|0;H=H+-1|0}}return}}function TU(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=+p[k>>3];if(!j)return;k=i+-4|0;m=(i|0)<4;o=i&-4;q=d;d=f;f=a;a=j;while(1){a=a+-1|0;if(m)r=0;else{j=0;do{s=b[q+j>>0]|0;if(!(s<<24>>24))t=0;else{u=mrc(l*+n[44016+((h[f+j>>0]|0)+128<<2)>>2]/+n[44016+((s&255)+128<<2)>>2])|0;t=(u>>>0<256?u:(u|0)>0?255:0)&255}u=j|1;s=b[q+u>>0]|0;if(!(s<<24>>24))v=0;else{w=mrc(l*+n[44016+((h[f+u>>0]|0)+128<<2)>>2]/+n[44016+((s&255)+128<<2)>>2])|0;v=(w>>>0<256?w:(w|0)>0?255:0)&255}b[d+j>>0]=t;b[d+u>>0]=v;u=j|2;w=b[q+u>>0]|0;if(!(w<<24>>24))x=0;else{s=mrc(l*+n[44016+((h[f+u>>0]|0)+128<<2)>>2]/+n[44016+((w&255)+128<<2)>>2])|0;x=(s>>>0<256?s:(s|0)>0?255:0)&255}s=j|3;w=b[q+s>>0]|0;if(!(w<<24>>24))y=0;else{z=mrc(l*+n[44016+((h[f+s>>0]|0)+128<<2)>>2]/+n[44016+((w&255)+128<<2)>>2])|0;y=(z>>>0<256?z:(z|0)>0?255:0)&255}b[d+u>>0]=x;b[d+s>>0]=y;j=j+4|0}while((j|0)<=(k|0));r=o}if((r|0)<(i|0)){j=r;do{s=b[q+j>>0]|0;if(!(s<<24>>24))A=0;else{u=mrc(l*+n[44016+((h[f+j>>0]|0)+128<<2)>>2]/+n[44016+((s&255)+128<<2)>>2])|0;A=(u>>>0<256?u:(u|0)>0?255:0)&255}b[d+j>>0]=A;j=j+1|0}while((j|0)!=(i|0))}if(!a)break;else{q=q+e|0;d=d+g|0;f=f+c|0}}return}function UU(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=+p[j>>3];if(!i)return;j=h+-4|0;l=(h|0)<4;m=h&-4;n=d;d=f;f=a;a=i;while(1){a=a+-1|0;if(l)o=0;else{i=0;do{q=b[n+i>>0]|0;if(!(q<<24>>24))r=0;else{s=mrc(k*+(b[f+i>>0]|0)/+(q<<24>>24))|0;r=((s+128|0)>>>0<256?s:(s|0)>0?127:128)&255}s=i|1;q=b[n+s>>0]|0;if(!(q<<24>>24))t=0;else{u=mrc(k*+(b[f+s>>0]|0)/+(q<<24>>24))|0;t=((u+128|0)>>>0<256?u:(u|0)>0?127:128)&255}b[d+i>>0]=r;b[d+s>>0]=t;s=i|2;u=b[n+s>>0]|0;if(!(u<<24>>24))v=0;else{q=mrc(k*+(b[f+s>>0]|0)/+(u<<24>>24))|0;v=((q+128|0)>>>0<256?q:(q|0)>0?127:128)&255}q=i|3;u=b[n+q>>0]|0;if(!(u<<24>>24))w=0;else{x=mrc(k*+(b[f+q>>0]|0)/+(u<<24>>24))|0;w=((x+128|0)>>>0<256?x:(x|0)>0?127:128)&255}b[d+s>>0]=v;b[d+q>>0]=w;i=i+4|0}while((i|0)<=(j|0));o=m}if((o|0)<(h|0)){i=o;do{q=b[n+i>>0]|0;if(!(q<<24>>24))y=0;else{s=mrc(k*+(b[f+i>>0]|0)/+(q<<24>>24))|0;y=((s+128|0)>>>0<256?s:(s|0)>0?127:128)&255}b[d+i>>0]=y;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0}}return}function VU(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;l=+p[k>>3];k=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;m=(h|0)<4;n=h&-4;o=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(m)q=0;else{i=0;do{r=d[o+(i<<1)>>1]|0;if(!(r<<16>>16))s=0;else{t=mrc(l*+(j[f+(i<<1)>>1]|0)/+(r&65535))|0;s=(t>>>0<65536?t:(t|0)>0?65535:0)&65535}t=i|1;r=d[o+(t<<1)>>1]|0;if(!(r<<16>>16))u=0;else{v=mrc(l*+(j[f+(t<<1)>>1]|0)/+(r&65535))|0;u=(v>>>0<65536?v:(v|0)>0?65535:0)&65535}d[c+(i<<1)>>1]=s;d[c+(t<<1)>>1]=u;t=i|2;v=d[o+(t<<1)>>1]|0;if(!(v<<16>>16))w=0;else{r=mrc(l*+(j[f+(t<<1)>>1]|0)/+(v&65535))|0;w=(r>>>0<65536?r:(r|0)>0?65535:0)&65535}r=i|3;v=d[o+(r<<1)>>1]|0;if(!(v<<16>>16))x=0;else{y=mrc(l*+(j[f+(r<<1)>>1]|0)/+(v&65535))|0;x=(y>>>0<65536?y:(y|0)>0?65535:0)&65535}d[c+(t<<1)>>1]=w;d[c+(r<<1)>>1]=x;i=i+4|0}while((i|0)<=(g|0));q=n}if((q|0)<(h|0)){i=q;do{r=d[o+(i<<1)>>1]|0;if(!(r<<16>>16))z=0;else{t=mrc(l*+(j[f+(i<<1)>>1]|0)/+(r&65535))|0;z=(t>>>0<65536?t:(t|0)>0?65535:0)&65535}d[c+(i<<1)>>1]=z;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{o=o+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0}}return}function WU(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=+p[j>>3];j=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;l=(h|0)<4;m=h&-4;n=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(l)o=0;else{i=0;do{q=d[n+(i<<1)>>1]|0;if(!(q<<16>>16))r=0;else{s=mrc(k*+(d[f+(i<<1)>>1]|0)/+(q<<16>>16))|0;r=((s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768)&65535}s=i|1;q=d[n+(s<<1)>>1]|0;if(!(q<<16>>16))t=0;else{u=mrc(k*+(d[f+(s<<1)>>1]|0)/+(q<<16>>16))|0;t=((u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768)&65535}d[c+(i<<1)>>1]=r;d[c+(s<<1)>>1]=t;s=i|2;u=d[n+(s<<1)>>1]|0;if(!(u<<16>>16))v=0;else{q=mrc(k*+(d[f+(s<<1)>>1]|0)/+(u<<16>>16))|0;v=((q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768)&65535}q=i|3;u=d[n+(q<<1)>>1]|0;if(!(u<<16>>16))w=0;else{x=mrc(k*+(d[f+(q<<1)>>1]|0)/+(u<<16>>16))|0;w=((x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768)&65535}d[c+(s<<1)>>1]=v;d[c+(q<<1)>>1]=w;i=i+4|0}while((i|0)<=(g|0));o=m}if((o|0)<(h|0)){i=o;do{q=d[n+(i<<1)>>1]|0;if(!(q<<16>>16))y=0;else{s=mrc(k*+(d[f+(i<<1)>>1]|0)/+(q<<16>>16))|0;y=((s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768)&65535}d[c+(i<<1)>>1]=y;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{n=n+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0}}return}function XU(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=+p[j>>3];j=b>>>2;b=d>>>2;d=g>>>2;if(!i)return;g=h+-4|0;l=(h|0)<4;m=h&-4;n=c;c=e;e=a;a=i;while(1){a=a+-1|0;if(l)o=0;else{i=0;do{q=f[n+(i<<2)>>2]|0;if(!q)r=0;else r=mrc(k*+(f[e+(i<<2)>>2]|0)/+(q|0))|0;q=i|1;s=f[n+(q<<2)>>2]|0;if(!s)t=0;else t=mrc(k*+(f[e+(q<<2)>>2]|0)/+(s|0))|0;f[c+(i<<2)>>2]=r;f[c+(q<<2)>>2]=t;q=i|2;s=f[n+(q<<2)>>2]|0;if(!s)u=0;else u=mrc(k*+(f[e+(q<<2)>>2]|0)/+(s|0))|0;s=i|3;v=f[n+(s<<2)>>2]|0;if(!v)w=0;else w=mrc(k*+(f[e+(s<<2)>>2]|0)/+(v|0))|0;f[c+(q<<2)>>2]=u;f[c+(s<<2)>>2]=w;i=i+4|0}while((i|0)<=(g|0));o=m}if((o|0)<(h|0)){i=o;do{s=f[n+(i<<2)>>2]|0;if(!s)x=0;else x=mrc(k*+(f[e+(i<<2)>>2]|0)/+(s|0))|0;f[c+(i<<2)>>2]=x;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{n=n+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0}}return}function YU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0,W=0.0;j=+p[i>>3];i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;k=(h|0)==0;if(+L(+(j+-1.0))<=1.1920928955078125e-07){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;o=a;q=f}else return;while(1){r=0;do{s=+n[l+(r<<2)>>2];n[m+(r<<2)>>2]=s!=0.0?+n[o+(r<<2)>>2]/s:0.0;r=r+1|0}while((r|0)!=(g|0));if(!q)break;else{l=l+(b<<2)|0;m=m+(d<<2)|0;o=o+(i<<2)|0;q=q+-1|0}}return}q=g&-4;if((q|0)<(g|0)){t=c;u=e;v=a;w=f}else{o=c;m=e;l=a;r=f;while(1){x=0;do{s=+n[o+(x<<2)>>2];y=x|1;z=+n[o+(y<<2)>>2];A=z!=0.0?+n[l+(y<<2)>>2]/z:0.0;n[m+(x<<2)>>2]=s!=0.0?+n[l+(x<<2)>>2]/s:0.0;n[m+(y<<2)>>2]=A;y=x|2;A=+n[o+(y<<2)>>2];B=x|3;s=+n[o+(B<<2)>>2];z=s!=0.0?+n[l+(B<<2)>>2]/s:0.0;n[m+(y<<2)>>2]=A!=0.0?+n[l+(y<<2)>>2]/A:0.0;n[m+(B<<2)>>2]=z;x=x+4|0}while((x|0)<=(h|0));if(!r)break;else{o=o+(b<<2)|0;m=m+(d<<2)|0;l=l+(i<<2)|0;r=r+-1|0}}return}while(1){r=0;do{z=+n[t+(r<<2)>>2];l=r|1;A=+n[t+(l<<2)>>2];s=A!=0.0?+n[v+(l<<2)>>2]/A:0.0;n[u+(r<<2)>>2]=z!=0.0?+n[v+(r<<2)>>2]/z:0.0;n[u+(l<<2)>>2]=s;l=r|2;s=+n[t+(l<<2)>>2];m=r|3;z=+n[t+(m<<2)>>2];A=z!=0.0?+n[v+(m<<2)>>2]/z:0.0;n[u+(l<<2)>>2]=s!=0.0?+n[v+(l<<2)>>2]/s:0.0;n[u+(m<<2)>>2]=A;r=r+4|0}while((r|0)<=(h|0));C=q;do{A=+n[t+(C<<2)>>2];n[u+(C<<2)>>2]=A!=0.0?+n[v+(C<<2)>>2]/A:0.0;C=C+1|0}while((C|0)!=(g|0));if(!w)break;else{t=t+(b<<2)|0;u=u+(d<<2)|0;v=v+(i<<2)|0;w=w+-1|0}}return}if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){D=c;E=e;F=a;G=f}else return;while(1){w=0;do{A=+n[D+(w<<2)>>2];if(A!=0.0)H=j*+n[F+(w<<2)>>2]/A;else H=0.0;n[E+(w<<2)>>2]=H;w=w+1|0}while((w|0)!=(g|0));if(!G)break;else{D=D+(b<<2)|0;E=E+(d<<2)|0;F=F+(i<<2)|0;G=G+-1|0}}return}G=g&-4;if((G|0)<(g|0)){I=c;J=e;K=a;M=f}else{F=c;c=e;e=a;a=f;while(1){f=0;do{H=+n[F+(f<<2)>>2];if(H!=0.0)N=j*+n[e+(f<<2)>>2]/H;else N=0.0;E=f|1;H=+n[F+(E<<2)>>2];if(H!=0.0)O=j*+n[e+(E<<2)>>2]/H;else O=0.0;n[c+(f<<2)>>2]=N;n[c+(E<<2)>>2]=O;E=f|2;H=+n[F+(E<<2)>>2];if(H!=0.0)P=j*+n[e+(E<<2)>>2]/H;else P=0.0;D=f|3;H=+n[F+(D<<2)>>2];if(H!=0.0)Q=j*+n[e+(D<<2)>>2]/H;else Q=0.0;n[c+(E<<2)>>2]=P;n[c+(D<<2)>>2]=Q;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{F=F+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{Q=+n[I+(a<<2)>>2];if(Q!=0.0)R=j*+n[K+(a<<2)>>2]/Q;else R=0.0;e=a|1;Q=+n[I+(e<<2)>>2];if(Q!=0.0)S=j*+n[K+(e<<2)>>2]/Q;else S=0.0;n[J+(a<<2)>>2]=R;n[J+(e<<2)>>2]=S;e=a|2;Q=+n[I+(e<<2)>>2];if(Q!=0.0)T=j*+n[K+(e<<2)>>2]/Q;else T=0.0;c=a|3;Q=+n[I+(c<<2)>>2];if(Q!=0.0)U=j*+n[K+(c<<2)>>2]/Q;else U=0.0;n[J+(e<<2)>>2]=T;n[J+(c<<2)>>2]=U;a=a+4|0}while((a|0)<=(k|0));V=G;do{Q=+n[I+(V<<2)>>2];if(Q!=0.0)W=j*+n[K+(V<<2)>>2]/Q;else W=0.0;n[J+(V<<2)>>2]=W;V=V+1|0}while((V|0)!=(g|0));if(!M)break;else{I=I+(b<<2)|0;J=J+(d<<2)|0;K=K+(i<<2)|0;M=M+-1|0}}return}function ZU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0;j=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;k=(h|0)==0;if(+p[i>>3]==1.0){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;n=a;o=f}else return;while(1){q=0;do{r=+p[l+(q<<3)>>3];p[m+(q<<3)>>3]=r!=0.0?+p[n+(q<<3)>>3]/r:0.0;q=q+1|0}while((q|0)!=(g|0));if(!o)break;else{l=l+(b<<3)|0;m=m+(d<<3)|0;n=n+(j<<3)|0;o=o+-1|0}}return}o=g&-4;if((o|0)<(g|0)){s=c;t=e;u=a;v=f}else{n=c;m=e;l=a;q=f;while(1){w=0;do{r=+p[n+(w<<3)>>3];x=w|1;y=+p[n+(x<<3)>>3];z=y!=0.0?+p[l+(x<<3)>>3]/y:0.0;p[m+(w<<3)>>3]=r!=0.0?+p[l+(w<<3)>>3]/r:0.0;p[m+(x<<3)>>3]=z;x=w|2;z=+p[n+(x<<3)>>3];A=w|3;r=+p[n+(A<<3)>>3];y=r!=0.0?+p[l+(A<<3)>>3]/r:0.0;p[m+(x<<3)>>3]=z!=0.0?+p[l+(x<<3)>>3]/z:0.0;p[m+(A<<3)>>3]=y;w=w+4|0}while((w|0)<=(h|0));if(!q)break;else{n=n+(b<<3)|0;m=m+(d<<3)|0;l=l+(j<<3)|0;q=q+-1|0}}return}while(1){q=0;do{y=+p[s+(q<<3)>>3];l=q|1;z=+p[s+(l<<3)>>3];r=z!=0.0?+p[u+(l<<3)>>3]/z:0.0;p[t+(q<<3)>>3]=y!=0.0?+p[u+(q<<3)>>3]/y:0.0;p[t+(l<<3)>>3]=r;l=q|2;r=+p[s+(l<<3)>>3];m=q|3;y=+p[s+(m<<3)>>3];z=y!=0.0?+p[u+(m<<3)>>3]/y:0.0;p[t+(l<<3)>>3]=r!=0.0?+p[u+(l<<3)>>3]/r:0.0;p[t+(m<<3)>>3]=z;q=q+4|0}while((q|0)<=(h|0));B=o;do{z=+p[s+(B<<3)>>3];p[t+(B<<3)>>3]=z!=0.0?+p[u+(B<<3)>>3]/z:0.0;B=B+1|0}while((B|0)!=(g|0));if(!v)break;else{s=s+(b<<3)|0;t=t+(d<<3)|0;u=u+(j<<3)|0;v=v+-1|0}}return}if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){C=c;D=e;E=a;F=f}else return;while(1){v=0;do{z=+p[C+(v<<3)>>3];if(z!=0.0)G=+p[E+(v<<3)>>3]*+p[i>>3]/z;else G=0.0;p[D+(v<<3)>>3]=G;v=v+1|0}while((v|0)!=(g|0));if(!F)break;else{C=C+(b<<3)|0;D=D+(d<<3)|0;E=E+(j<<3)|0;F=F+-1|0}}return}F=g&-4;if((F|0)<(g|0)){H=c;I=e;J=a;K=f}else{E=c;c=e;e=a;a=f;while(1){f=0;do{G=+p[E+(f<<3)>>3];if(G!=0.0)L=+p[e+(f<<3)>>3]*+p[i>>3]/G;else L=0.0;D=f|1;G=+p[E+(D<<3)>>3];if(G!=0.0)M=+p[e+(D<<3)>>3]*+p[i>>3]/G;else M=0.0;p[c+(f<<3)>>3]=L;p[c+(D<<3)>>3]=M;D=f|2;G=+p[E+(D<<3)>>3];if(G!=0.0)N=+p[e+(D<<3)>>3]*+p[i>>3]/G;else N=0.0;C=f|3;G=+p[E+(C<<3)>>3];if(G!=0.0)O=+p[e+(C<<3)>>3]*+p[i>>3]/G;else O=0.0;p[c+(D<<3)>>3]=N;p[c+(C<<3)>>3]=O;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{E=E+(b<<3)|0;c=c+(d<<3)|0;e=e+(j<<3)|0;a=a+-1|0}}return}while(1){a=0;do{O=+p[H+(a<<3)>>3];if(O!=0.0)P=+p[J+(a<<3)>>3]*+p[i>>3]/O;else P=0.0;e=a|1;O=+p[H+(e<<3)>>3];if(O!=0.0)Q=+p[J+(e<<3)>>3]*+p[i>>3]/O;else Q=0.0;p[I+(a<<3)>>3]=P;p[I+(e<<3)>>3]=Q;e=a|2;O=+p[H+(e<<3)>>3];if(O!=0.0)R=+p[J+(e<<3)>>3]*+p[i>>3]/O;else R=0.0;c=a|3;O=+p[H+(c<<3)>>3];if(O!=0.0)S=+p[J+(c<<3)>>3]*+p[i>>3]/O;else S=0.0;p[I+(e<<3)>>3]=R;p[I+(c<<3)>>3]=S;a=a+4|0}while((a|0)<=(k|0));T=F;do{O=+p[H+(T<<3)>>3];if(O!=0.0)U=+p[J+(T<<3)>>3]*+p[i>>3]/O;else U=0.0;p[I+(T<<3)>>3]=U;T=T+1|0}while((T|0)!=(g|0));if(!K)break;else{H=H+(b<<3)|0;I=I+(d<<3)|0;J=J+(j<<3)|0;K=K+-1|0}}return}function _U(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,o=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=+p[k>>3];m=+p[k+8>>3];o=+p[k+16>>3];k=(j|0)==0;if(m==1.0&o==0.0){if(k)return;q=i+-4|0;r=(i|0)<4;s=i&-4;t=d;u=f;v=a;w=j;while(1){w=w+-1|0;if(r)x=0;else{y=0;do{z=mrc(+(h[t+y>>0]|0)+l*+n[44016+((h[v+y>>0]|0)+128<<2)>>2])|0;A=y|1;B=mrc(+(h[t+A>>0]|0)+l*+n[44016+((h[v+A>>0]|0)+128<<2)>>2])|0;b[u+y>>0]=z>>>0<256?z:(z|0)>0?255:0;b[u+A>>0]=B>>>0<256?B:(B|0)>0?255:0;B=y|2;A=mrc(+(h[t+B>>0]|0)+l*+n[44016+((h[v+B>>0]|0)+128<<2)>>2])|0;z=y|3;C=mrc(+(h[t+z>>0]|0)+l*+n[44016+((h[v+z>>0]|0)+128<<2)>>2])|0;b[u+B>>0]=A>>>0<256?A:(A|0)>0?255:0;b[u+z>>0]=C>>>0<256?C:(C|0)>0?255:0;y=y+4|0}while((y|0)<=(q|0));x=s}if((x|0)<(i|0)){y=x;do{C=mrc(+(h[t+y>>0]|0)+l*+n[44016+((h[v+y>>0]|0)+128<<2)>>2])|0;b[u+y>>0]=C>>>0<256?C:(C|0)>0?255:0;y=y+1|0}while((y|0)!=(i|0))}if(!w)break;else{t=t+e|0;u=u+g|0;v=v+c|0}}return}else{if(k)return;k=i+-4|0;v=(i|0)<4;u=i&-4;t=d;d=f;f=a;a=j;while(1){a=a+-1|0;if(v)D=0;else{j=0;do{w=mrc(o+(l*+n[44016+((h[f+j>>0]|0)+128<<2)>>2]+m*+n[44016+((h[t+j>>0]|0)+128<<2)>>2]))|0;x=j|1;s=mrc(o+(l*+n[44016+((h[f+x>>0]|0)+128<<2)>>2]+m*+n[44016+((h[t+x>>0]|0)+128<<2)>>2]))|0;b[d+j>>0]=w>>>0<256?w:(w|0)>0?255:0;b[d+x>>0]=s>>>0<256?s:(s|0)>0?255:0;s=j|2;x=mrc(o+(l*+n[44016+((h[f+s>>0]|0)+128<<2)>>2]+m*+n[44016+((h[t+s>>0]|0)+128<<2)>>2]))|0;w=j|3;q=mrc(o+(l*+n[44016+((h[f+w>>0]|0)+128<<2)>>2]+m*+n[44016+((h[t+w>>0]|0)+128<<2)>>2]))|0;b[d+s>>0]=x>>>0<256?x:(x|0)>0?255:0;b[d+w>>0]=q>>>0<256?q:(q|0)>0?255:0;j=j+4|0}while((j|0)<=(k|0));D=u}if((D|0)<(i|0)){j=D;do{q=mrc(o+(l*+n[44016+((h[f+j>>0]|0)+128<<2)>>2]+m*+n[44016+((h[t+j>>0]|0)+128<<2)>>2]))|0;b[d+j>>0]=q>>>0<256?q:(q|0)>0?255:0;j=j+1|0}while((j|0)!=(i|0))}if(!a)break;else{t=t+e|0;d=d+g|0;f=f+c|0}}return}}function $U(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];if(!(l==1.0&m==0.0)){if(!i)return;j=h+-4|0;n=(h|0)<4;o=h&-4;q=d;r=f;s=a;t=i;while(1){t=t+-1|0;if(n)u=0;else{v=0;do{w=mrc(m+(k*+(b[s+v>>0]|0)+l*+(b[q+v>>0]|0)))|0;x=v|1;y=mrc(m+(k*+(b[s+x>>0]|0)+l*+(b[q+x>>0]|0)))|0;b[r+v>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;b[r+x>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;y=v|2;x=mrc(m+(k*+(b[s+y>>0]|0)+l*+(b[q+y>>0]|0)))|0;w=v|3;z=mrc(m+(k*+(b[s+w>>0]|0)+l*+(b[q+w>>0]|0)))|0;b[r+y>>0]=(x+128|0)>>>0<256?x:(x|0)>0?127:128;b[r+w>>0]=(z+128|0)>>>0<256?z:(z|0)>0?127:128;v=v+4|0}while((v|0)<=(j|0));u=o}if((u|0)<(h|0)){v=u;do{z=mrc(m+(k*+(b[s+v>>0]|0)+l*+(b[q+v>>0]|0)))|0;b[r+v>>0]=(z+128|0)>>>0<256?z:(z|0)>0?127:128;v=v+1|0}while((v|0)!=(h|0))}if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0}}return}s=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){A=d;B=f;C=a;D=s}else return;while(1){r=0;do{q=mrc(+(b[A+r>>0]|0)+k*+(b[C+r>>0]|0))|0;b[B+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;r=r+1|0}while((r|0)!=(h|0));if(!D)break;else{A=A+e|0;B=B+g|0;C=C+c|0;D=D+-1|0}}return}D=h&-4;if((D|0)<(h|0)){E=d;F=f;G=a;H=s}else{C=d;d=f;f=a;a=s;while(1){s=0;do{B=mrc(+(b[C+s>>0]|0)+k*+(b[f+s>>0]|0))|0;A=s|1;r=mrc(+(b[C+A>>0]|0)+k*+(b[f+A>>0]|0))|0;b[d+s>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;b[d+A>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=s|2;A=mrc(+(b[C+r>>0]|0)+k*+(b[f+r>>0]|0))|0;B=s|3;q=mrc(+(b[C+B>>0]|0)+k*+(b[f+B>>0]|0))|0;b[d+r>>0]=(A+128|0)>>>0<256?A:(A|0)>0?127:128;b[d+B>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;s=s+4|0}while((s|0)<=(i|0));if(!a)break;else{C=C+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=mrc(+(b[E+a>>0]|0)+k*+(b[G+a>>0]|0))|0;d=a|1;C=mrc(+(b[E+d>>0]|0)+k*+(b[G+d>>0]|0))|0;b[F+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[F+d>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;C=a|2;d=mrc(+(b[E+C>>0]|0)+k*+(b[G+C>>0]|0))|0;f=a|3;s=mrc(+(b[E+f>>0]|0)+k*+(b[G+f>>0]|0))|0;b[F+C>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[F+f>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;a=a+4|0}while((a|0)<=(i|0));I=D;do{a=mrc(+(b[E+I>>0]|0)+k*+(b[G+I>>0]|0))|0;b[F+I>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;I=I+1|0}while((I|0)!=(h|0));if(!H)break;else{E=E+e|0;F=F+g|0;G=G+c|0;H=H+-1|0}}return}function aV(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;l=+p[k>>3];m=+p[k+8>>3];n=+p[k+16>>3];k=b>>>1;b=e>>>1;e=g>>>1;g=(i|0)==0;if(m==1.0&n==0.0){if(g)return;o=h+-4|0;q=(h|0)<4;r=h&-4;s=c;t=f;u=a;v=i;while(1){v=v+-1|0;if(q)w=0;else{x=0;do{y=mrc(+(j[s+(x<<1)>>1]|0)+l*+(j[u+(x<<1)>>1]|0))|0;z=x|1;A=mrc(+(j[s+(z<<1)>>1]|0)+l*+(j[u+(z<<1)>>1]|0))|0;d[t+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;d[t+(z<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;A=x|2;z=mrc(+(j[s+(A<<1)>>1]|0)+l*+(j[u+(A<<1)>>1]|0))|0;y=x|3;B=mrc(+(j[s+(y<<1)>>1]|0)+l*+(j[u+(y<<1)>>1]|0))|0;d[t+(A<<1)>>1]=z>>>0<65536?z:(z|0)>0?65535:0;d[t+(y<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;x=x+4|0}while((x|0)<=(o|0));w=r}if((w|0)<(h|0)){x=w;do{B=mrc(+(j[s+(x<<1)>>1]|0)+l*+(j[u+(x<<1)>>1]|0))|0;d[t+(x<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;x=x+1|0}while((x|0)!=(h|0))}if(!v)break;else{s=s+(b<<1)|0;t=t+(e<<1)|0;u=u+(k<<1)|0}}return}else{if(g)return;g=h+-4|0;u=(h|0)<4;t=h&-4;s=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(u)C=0;else{i=0;do{v=mrc(n+(l*+(j[f+(i<<1)>>1]|0)+m*+(j[s+(i<<1)>>1]|0)))|0;w=i|1;r=mrc(n+(l*+(j[f+(w<<1)>>1]|0)+m*+(j[s+(w<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d[c+(w<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=i|2;w=mrc(n+(l*+(j[f+(r<<1)>>1]|0)+m*+(j[s+(r<<1)>>1]|0)))|0;v=i|3;o=mrc(n+(l*+(j[f+(v<<1)>>1]|0)+m*+(j[s+(v<<1)>>1]|0)))|0;d[c+(r<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[c+(v<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;i=i+4|0}while((i|0)<=(g|0));C=t}if((C|0)<(h|0)){i=C;do{o=mrc(n+(l*+(j[f+(i<<1)>>1]|0)+m*+(j[s+(i<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{s=s+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0}}return}}function bV(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];j=b>>>1;b=e>>>1;e=g>>>1;g=(i|0)==0;if(l==1.0&m==0.0){if(g)return;n=h+-4|0;o=(h|0)<4;q=h&-4;r=c;s=f;t=a;u=i;while(1){u=u+-1|0;if(o)v=0;else{w=0;do{x=mrc(+(d[r+(w<<1)>>1]|0)+k*+(d[t+(w<<1)>>1]|0))|0;y=w|1;z=mrc(+(d[r+(y<<1)>>1]|0)+k*+(d[t+(y<<1)>>1]|0))|0;d[s+(w<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;d[s+(y<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;z=w|2;y=mrc(+(d[r+(z<<1)>>1]|0)+k*+(d[t+(z<<1)>>1]|0))|0;x=w|3;A=mrc(+(d[r+(x<<1)>>1]|0)+k*+(d[t+(x<<1)>>1]|0))|0;d[s+(z<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[s+(x<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;w=w+4|0}while((w|0)<=(n|0));v=q}if((v|0)<(h|0)){w=v;do{A=mrc(+(d[r+(w<<1)>>1]|0)+k*+(d[t+(w<<1)>>1]|0))|0;d[s+(w<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;w=w+1|0}while((w|0)!=(h|0))}if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0}}return}else{if(g)return;g=h+-4|0;t=(h|0)<4;s=h&-4;r=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(t)B=0;else{i=0;do{u=mrc(m+(k*+(d[f+(i<<1)>>1]|0)+l*+(d[r+(i<<1)>>1]|0)))|0;v=i|1;q=mrc(m+(k*+(d[f+(v<<1)>>1]|0)+l*+(d[r+(v<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[c+(v<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;q=i|2;v=mrc(m+(k*+(d[f+(q<<1)>>1]|0)+l*+(d[r+(q<<1)>>1]|0)))|0;u=i|3;n=mrc(m+(k*+(d[f+(u<<1)>>1]|0)+l*+(d[r+(u<<1)>>1]|0)))|0;d[c+(q<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[c+(u<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;i=i+4|0}while((i|0)<=(g|0));B=s}if((B|0)<(h|0)){i=B;do{n=mrc(m+(k*+(d[f+(i<<1)>>1]|0)+l*+(d[r+(i<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{r=r+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0}}return}}function cV(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;k=+p[j+8>>3];if(k==1.0?+p[j+16>>3]==0.0:0){l=b>>>2;m=d>>>2;n=g>>>2;o=i+-1|0;if(!i)return;q=h+-4|0;if((h|0)<4){if((h|0)<=0)return;r=+p[j>>3];s=c;t=e;u=a;v=o;while(1){w=0;do{x=nrc(+(f[s+(w<<2)>>2]|0)+r*+(f[u+(w<<2)>>2]|0))|0;f[t+(w<<2)>>2]=x;w=w+1|0}while((w|0)!=(h|0));if(!v)break;else{s=s+(m<<2)|0;t=t+(n<<2)|0;u=u+(l<<2)|0;v=v+-1|0}}return}v=h&-4;r=+p[j>>3];if((v|0)<(h|0)){y=c;z=e;A=a;B=o}else{u=c;t=e;s=a;w=o;while(1){o=0;do{x=nrc(+(f[u+(o<<2)>>2]|0)+r*+(f[s+(o<<2)>>2]|0))|0;C=o|1;D=nrc(+(f[u+(C<<2)>>2]|0)+r*+(f[s+(C<<2)>>2]|0))|0;f[t+(o<<2)>>2]=x;f[t+(C<<2)>>2]=D;D=o|2;C=nrc(+(f[u+(D<<2)>>2]|0)+r*+(f[s+(D<<2)>>2]|0))|0;x=o|3;E=nrc(+(f[u+(x<<2)>>2]|0)+r*+(f[s+(x<<2)>>2]|0))|0;f[t+(D<<2)>>2]=C;f[t+(x<<2)>>2]=E;o=o+4|0}while((o|0)<=(q|0));if(!w)break;else{u=u+(m<<2)|0;t=t+(n<<2)|0;s=s+(l<<2)|0;w=w+-1|0}}return}while(1){w=0;do{s=nrc(+(f[y+(w<<2)>>2]|0)+r*+(f[A+(w<<2)>>2]|0))|0;t=w|1;u=nrc(+(f[y+(t<<2)>>2]|0)+r*+(f[A+(t<<2)>>2]|0))|0;f[z+(w<<2)>>2]=s;f[z+(t<<2)>>2]=u;u=w|2;t=nrc(+(f[y+(u<<2)>>2]|0)+r*+(f[A+(u<<2)>>2]|0))|0;s=w|3;o=nrc(+(f[y+(s<<2)>>2]|0)+r*+(f[A+(s<<2)>>2]|0))|0;f[z+(u<<2)>>2]=t;f[z+(s<<2)>>2]=o;w=w+4|0}while((w|0)<=(q|0));F=v;do{w=nrc(+(f[y+(F<<2)>>2]|0)+r*+(f[A+(F<<2)>>2]|0))|0;f[z+(F<<2)>>2]=w;F=F+1|0}while((F|0)!=(h|0));if(!B)break;else{y=y+(m<<2)|0;z=z+(n<<2)|0;A=A+(l<<2)|0;B=B+-1|0}}return}B=b>>>2;b=d>>>2;d=g>>>2;if(!i)return;g=h+-4|0;l=j+16|0;A=h&-4;if((h|0)<4){n=(h|0)>0;z=c;m=e;y=a;F=i;while(1){F=F+-1|0;if(n){r=+p[j>>3];G=+p[l>>3];v=0;do{q=nrc(G+(r*+(f[y+(v<<2)>>2]|0)+k*+(f[z+(v<<2)>>2]|0)))|0;f[m+(v<<2)>>2]=q;v=v+1|0}while((v|0)!=(h|0))}if(!F)break;else{z=z+(b<<2)|0;m=m+(d<<2)|0;y=y+(B<<2)|0}}return}r=+p[j>>3];G=+p[l>>3];l=(A|0)<(h|0);j=c;c=e;e=a;a=i;while(1){i=0;do{y=nrc(G+(r*+(f[e+(i<<2)>>2]|0)+k*+(f[j+(i<<2)>>2]|0)))|0;m=i|1;z=nrc(G+(r*+(f[e+(m<<2)>>2]|0)+k*+(f[j+(m<<2)>>2]|0)))|0;f[c+(i<<2)>>2]=y;f[c+(m<<2)>>2]=z;z=i|2;m=nrc(G+(r*+(f[e+(z<<2)>>2]|0)+k*+(f[j+(z<<2)>>2]|0)))|0;y=i|3;F=nrc(G+(r*+(f[e+(y<<2)>>2]|0)+k*+(f[j+(y<<2)>>2]|0)))|0;f[c+(z<<2)>>2]=m;f[c+(y<<2)>>2]=F;i=i+4|0}while((i|0)<=(g|0));a=a+-1|0;if(l){i=A;do{F=nrc(G+(r*+(f[e+(i<<2)>>2]|0)+k*+(f[j+(i<<2)>>2]|0)))|0;f[c+(i<<2)>>2]=F;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{j=j+(b<<2)|0;c=c+(d<<2)|0;e=e+(B<<2)|0}}return}function dV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0;j=+p[i+8>>3];if(j==1.0?+p[i+16>>3]==0.0:0){k=b>>>2;l=d>>>2;m=f>>>2;o=h+-1|0;if(!h)return;q=g+-4|0;if((g|0)<4){if((g|0)<=0)return;r=+p[i>>3];s=c;t=e;u=a;v=o;while(1){w=0;do{n[t+(w<<2)>>2]=+n[s+(w<<2)>>2]+r*+n[u+(w<<2)>>2];w=w+1|0}while((w|0)!=(g|0));if(!v)break;else{s=s+(l<<2)|0;t=t+(m<<2)|0;u=u+(k<<2)|0;v=v+-1|0}}return}v=g&-4;r=+p[i>>3];if((v|0)<(g|0)){x=c;y=e;z=a;A=o}else{u=c;t=e;s=a;w=o;while(1){o=0;do{B=o|1;C=+n[u+(B<<2)>>2]+r*+n[s+(B<<2)>>2];n[t+(o<<2)>>2]=+n[u+(o<<2)>>2]+r*+n[s+(o<<2)>>2];n[t+(B<<2)>>2]=C;B=o|2;D=o|3;C=+n[u+(D<<2)>>2]+r*+n[s+(D<<2)>>2];n[t+(B<<2)>>2]=+n[u+(B<<2)>>2]+r*+n[s+(B<<2)>>2];n[t+(D<<2)>>2]=C;o=o+4|0}while((o|0)<=(q|0));if(!w)break;else{u=u+(l<<2)|0;t=t+(m<<2)|0;s=s+(k<<2)|0;w=w+-1|0}}return}while(1){w=0;do{s=w|1;C=+n[x+(s<<2)>>2]+r*+n[z+(s<<2)>>2];n[y+(w<<2)>>2]=+n[x+(w<<2)>>2]+r*+n[z+(w<<2)>>2];n[y+(s<<2)>>2]=C;s=w|2;t=w|3;C=+n[x+(t<<2)>>2]+r*+n[z+(t<<2)>>2];n[y+(s<<2)>>2]=+n[x+(s<<2)>>2]+r*+n[z+(s<<2)>>2];n[y+(t<<2)>>2]=C;w=w+4|0}while((w|0)<=(q|0));E=v;do{n[y+(E<<2)>>2]=+n[x+(E<<2)>>2]+r*+n[z+(E<<2)>>2];E=E+1|0}while((E|0)!=(g|0));if(!A)break;else{x=x+(l<<2)|0;y=y+(m<<2)|0;z=z+(k<<2)|0;A=A+-1|0}}return}A=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;k=i+16|0;if((g|0)<4){if((g|0)<=0)return;r=+p[i>>3];C=+p[k>>3];z=c;m=e;y=a;l=f;while(1){x=0;do{n[m+(x<<2)>>2]=C+(r*+n[y+(x<<2)>>2]+j*+n[z+(x<<2)>>2]);x=x+1|0}while((x|0)!=(g|0));if(!l)break;else{z=z+(b<<2)|0;m=m+(d<<2)|0;y=y+(A<<2)|0;l=l+-1|0}}return}l=g&-4;r=+p[i>>3];C=+p[k>>3];if((l|0)<(g|0)){F=c;G=e;H=a;I=f}else{k=c;c=e;e=a;a=f;while(1){f=0;do{i=f|1;J=C+(r*+n[e+(i<<2)>>2]+j*+n[k+(i<<2)>>2]);n[c+(f<<2)>>2]=C+(r*+n[e+(f<<2)>>2]+j*+n[k+(f<<2)>>2]);n[c+(i<<2)>>2]=J;i=f|2;y=f|3;J=C+(r*+n[e+(y<<2)>>2]+j*+n[k+(y<<2)>>2]);n[c+(i<<2)>>2]=C+(r*+n[e+(i<<2)>>2]+j*+n[k+(i<<2)>>2]);n[c+(y<<2)>>2]=J;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{k=k+(b<<2)|0;c=c+(d<<2)|0;e=e+(A<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;J=C+(r*+n[H+(e<<2)>>2]+j*+n[F+(e<<2)>>2]);n[G+(a<<2)>>2]=C+(r*+n[H+(a<<2)>>2]+j*+n[F+(a<<2)>>2]);n[G+(e<<2)>>2]=J;e=a|2;c=a|3;J=C+(r*+n[H+(c<<2)>>2]+j*+n[F+(c<<2)>>2]);n[G+(e<<2)>>2]=C+(r*+n[H+(e<<2)>>2]+j*+n[F+(e<<2)>>2]);n[G+(c<<2)>>2]=J;a=a+4|0}while((a|0)<=(h|0));K=l;do{n[G+(K<<2)>>2]=C+(r*+n[H+(K<<2)>>2]+j*+n[F+(K<<2)>>2]);K=K+1|0}while((K|0)!=(g|0));if(!I)break;else{F=F+(b<<2)|0;G=G+(d<<2)|0;H=H+(A<<2)|0;I=I+-1|0}}return}function eV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0;j=i+8|0;if(+p[j>>3]==1.0?+p[i+16>>3]==0.0:0){k=b>>>3;l=d>>>3;m=f>>>3;n=h+-1|0;if(!h)return;o=g+-4|0;if((g|0)<4){if((g|0)>0){q=c;r=e;s=a;t=n}else return;while(1){u=0;do{p[r+(u<<3)>>3]=+p[q+(u<<3)>>3]+ +p[s+(u<<3)>>3]*+p[i>>3];u=u+1|0}while((u|0)!=(g|0));if(!t)break;else{q=q+(l<<3)|0;r=r+(m<<3)|0;s=s+(k<<3)|0;t=t+-1|0}}return}t=g&-4;if((t|0)<(g|0)){v=c;w=e;x=a;y=n}else{s=c;r=e;q=a;u=n;while(1){n=0;do{z=+p[i>>3];A=n|1;B=z*+p[q+(A<<3)>>3]+ +p[s+(A<<3)>>3];p[r+(n<<3)>>3]=+p[s+(n<<3)>>3]+ +p[q+(n<<3)>>3]*z;p[r+(A<<3)>>3]=B;A=n|2;B=+p[i>>3];C=n|3;z=B*+p[q+(C<<3)>>3]+ +p[s+(C<<3)>>3];p[r+(A<<3)>>3]=+p[s+(A<<3)>>3]+ +p[q+(A<<3)>>3]*B;p[r+(C<<3)>>3]=z;n=n+4|0}while((n|0)<=(o|0));if(!u)break;else{s=s+(l<<3)|0;r=r+(m<<3)|0;q=q+(k<<3)|0;u=u+-1|0}}return}while(1){u=0;do{z=+p[i>>3];q=u|1;B=z*+p[x+(q<<3)>>3]+ +p[v+(q<<3)>>3];p[w+(u<<3)>>3]=+p[v+(u<<3)>>3]+ +p[x+(u<<3)>>3]*z;p[w+(q<<3)>>3]=B;q=u|2;B=+p[i>>3];r=u|3;z=B*+p[x+(r<<3)>>3]+ +p[v+(r<<3)>>3];p[w+(q<<3)>>3]=+p[v+(q<<3)>>3]+ +p[x+(q<<3)>>3]*B;p[w+(r<<3)>>3]=z;u=u+4|0}while((u|0)<=(o|0));D=t;do{p[w+(D<<3)>>3]=+p[v+(D<<3)>>3]+ +p[x+(D<<3)>>3]*+p[i>>3];D=D+1|0}while((D|0)!=(g|0));if(!y)break;else{v=v+(l<<3)|0;w=w+(m<<3)|0;x=x+(k<<3)|0;y=y+-1|0}}return}y=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;k=i+16|0;if((g|0)<4){if((g|0)>0){E=c;F=e;G=a;H=f}else return;while(1){x=0;do{p[F+(x<<3)>>3]=+p[k>>3]+(+p[G+(x<<3)>>3]*+p[i>>3]+ +p[E+(x<<3)>>3]*+p[j>>3]);x=x+1|0}while((x|0)!=(g|0));if(!H)break;else{E=E+(b<<3)|0;F=F+(d<<3)|0;G=G+(y<<3)|0;H=H+-1|0}}return}H=g&-4;if((H|0)<(g|0)){I=c;J=e;K=a;L=f}else{G=c;c=e;e=a;a=f;while(1){f=0;do{z=+p[i>>3];B=+p[j>>3];M=+p[k>>3];F=f|1;N=M+(z*+p[e+(F<<3)>>3]+B*+p[G+(F<<3)>>3]);p[c+(f<<3)>>3]=M+(+p[e+(f<<3)>>3]*z+ +p[G+(f<<3)>>3]*B);p[c+(F<<3)>>3]=N;F=f|2;N=+p[i>>3];B=+p[j>>3];z=+p[k>>3];E=f|3;M=z+(N*+p[e+(E<<3)>>3]+B*+p[G+(E<<3)>>3]);p[c+(F<<3)>>3]=z+(+p[e+(F<<3)>>3]*N+ +p[G+(F<<3)>>3]*B);p[c+(E<<3)>>3]=M;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{G=G+(b<<3)|0;c=c+(d<<3)|0;e=e+(y<<3)|0;a=a+-1|0}}return}while(1){a=0;do{M=+p[i>>3];B=+p[j>>3];N=+p[k>>3];e=a|1;z=N+(M*+p[K+(e<<3)>>3]+B*+p[I+(e<<3)>>3]);p[J+(a<<3)>>3]=N+(+p[K+(a<<3)>>3]*M+ +p[I+(a<<3)>>3]*B);p[J+(e<<3)>>3]=z;e=a|2;z=+p[i>>3];B=+p[j>>3];M=+p[k>>3];c=a|3;N=M+(z*+p[K+(c<<3)>>3]+B*+p[I+(c<<3)>>3]);p[J+(e<<3)>>3]=M+(+p[K+(e<<3)>>3]*z+ +p[I+(e<<3)>>3]*B);p[J+(c<<3)>>3]=N;a=a+4|0}while((a|0)<=(h|0));O=H;do{p[J+(O<<3)>>3]=+p[k>>3]+(+p[K+(O<<3)>>3]*+p[i>>3]+ +p[I+(O<<3)>>3]*+p[j>>3]);O=O+1|0}while((O|0)!=(g|0));if(!L)break;else{I=I+(b<<3)|0;J=J+(d<<3)|0;K=K+(y<<3)|0;L=L+-1|0}}return}function fV(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;i=+p[h>>3];if(!g)return;h=f+-4|0;j=(f|0)<4;k=f&-4;l=d;d=a;a=g;while(1){a=a+-1|0;if(j)m=0;else{g=0;do{o=b[d+g>>0]|0;if(!(o<<24>>24))q=0;else{r=mrc(i/+n[44016+((o&255)+128<<2)>>2])|0;q=(r>>>0<256?r:(r|0)>0?255:0)&255}r=g|1;o=b[d+r>>0]|0;if(!(o<<24>>24))s=0;else{t=mrc(i/+n[44016+((o&255)+128<<2)>>2])|0;s=(t>>>0<256?t:(t|0)>0?255:0)&255}b[l+g>>0]=q;b[l+r>>0]=s;r=g|2;t=b[d+r>>0]|0;if(!(t<<24>>24))u=0;else{o=mrc(i/+n[44016+((t&255)+128<<2)>>2])|0;u=(o>>>0<256?o:(o|0)>0?255:0)&255}o=g|3;t=b[d+o>>0]|0;if(!(t<<24>>24))v=0;else{w=mrc(i/+n[44016+((t&255)+128<<2)>>2])|0;v=(w>>>0<256?w:(w|0)>0?255:0)&255}b[l+r>>0]=u;b[l+o>>0]=v;g=g+4|0}while((g|0)<=(h|0));m=k}if((m|0)<(f|0)){g=m;do{o=b[d+g>>0]|0;if(!(o<<24>>24))x=0;else{r=mrc(i/+n[44016+((o&255)+128<<2)>>2])|0;x=(r>>>0<256?r:(r|0)>0?255:0)&255}b[l+g>>0]=x;g=g+1|0}while((g|0)!=(f|0))}if(!a)break;else{l=l+e|0;d=d+c|0}}return}function gV(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=+p[h>>3];if(!g)return;h=f+-4|0;j=(f|0)<4;k=f&-4;l=d;d=a;a=g;while(1){a=a+-1|0;if(j)m=0;else{g=0;do{n=b[d+g>>0]|0;if(!(n<<24>>24))o=0;else{q=mrc(i/+(n<<24>>24))|0;o=((q+128|0)>>>0<256?q:(q|0)>0?127:128)&255}q=g|1;n=b[d+q>>0]|0;if(!(n<<24>>24))r=0;else{s=mrc(i/+(n<<24>>24))|0;r=((s+128|0)>>>0<256?s:(s|0)>0?127:128)&255}b[l+g>>0]=o;b[l+q>>0]=r;q=g|2;s=b[d+q>>0]|0;if(!(s<<24>>24))t=0;else{n=mrc(i/+(s<<24>>24))|0;t=((n+128|0)>>>0<256?n:(n|0)>0?127:128)&255}n=g|3;s=b[d+n>>0]|0;if(!(s<<24>>24))u=0;else{v=mrc(i/+(s<<24>>24))|0;u=((v+128|0)>>>0<256?v:(v|0)>0?127:128)&255}b[l+q>>0]=t;b[l+n>>0]=u;g=g+4|0}while((g|0)<=(h|0));m=k}if((m|0)<(f|0)){g=m;do{n=b[d+g>>0]|0;if(!(n<<24>>24))w=0;else{q=mrc(i/+(n<<24>>24))|0;w=((q+128|0)>>>0<256?q:(q|0)>0?127:128)&255}b[l+g>>0]=w;g=g+1|0}while((g|0)!=(f|0))}if(!a)break;else{l=l+e|0;d=d+c|0}}return}function hV(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=+p[h>>3];h=b>>>1;b=e>>>1;if(!g)return;e=f+-4|0;j=(f|0)<4;k=f&-4;l=c;c=a;a=g;while(1){a=a+-1|0;if(j)m=0;else{g=0;do{n=d[c+(g<<1)>>1]|0;if(!(n<<16>>16))o=0;else{q=mrc(i/+(n&65535))|0;o=(q>>>0<65536?q:(q|0)>0?65535:0)&65535}q=g|1;n=d[c+(q<<1)>>1]|0;if(!(n<<16>>16))r=0;else{s=mrc(i/+(n&65535))|0;r=(s>>>0<65536?s:(s|0)>0?65535:0)&65535}d[l+(g<<1)>>1]=o;d[l+(q<<1)>>1]=r;q=g|2;s=d[c+(q<<1)>>1]|0;if(!(s<<16>>16))t=0;else{n=mrc(i/+(s&65535))|0;t=(n>>>0<65536?n:(n|0)>0?65535:0)&65535}n=g|3;s=d[c+(n<<1)>>1]|0;if(!(s<<16>>16))u=0;else{v=mrc(i/+(s&65535))|0;u=(v>>>0<65536?v:(v|0)>0?65535:0)&65535}d[l+(q<<1)>>1]=t;d[l+(n<<1)>>1]=u;g=g+4|0}while((g|0)<=(e|0));m=k}if((m|0)<(f|0)){g=m;do{n=d[c+(g<<1)>>1]|0;if(!(n<<16>>16))w=0;else{q=mrc(i/+(n&65535))|0;w=(q>>>0<65536?q:(q|0)>0?65535:0)&65535}d[l+(g<<1)>>1]=w;g=g+1|0}while((g|0)!=(f|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(h<<1)|0}}return}function iV(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=+p[h>>3];h=b>>>1;b=e>>>1;if(!g)return;e=f+-4|0;j=(f|0)<4;k=f&-4;l=c;c=a;a=g;while(1){a=a+-1|0;if(j)m=0;else{g=0;do{n=d[c+(g<<1)>>1]|0;if(!(n<<16>>16))o=0;else{q=mrc(i/+(n<<16>>16))|0;o=((q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768)&65535}q=g|1;n=d[c+(q<<1)>>1]|0;if(!(n<<16>>16))r=0;else{s=mrc(i/+(n<<16>>16))|0;r=((s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768)&65535}d[l+(g<<1)>>1]=o;d[l+(q<<1)>>1]=r;q=g|2;s=d[c+(q<<1)>>1]|0;if(!(s<<16>>16))t=0;else{n=mrc(i/+(s<<16>>16))|0;t=((n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768)&65535}n=g|3;s=d[c+(n<<1)>>1]|0;if(!(s<<16>>16))u=0;else{v=mrc(i/+(s<<16>>16))|0;u=((v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768)&65535}d[l+(q<<1)>>1]=t;d[l+(n<<1)>>1]=u;g=g+4|0}while((g|0)<=(e|0));m=k}if((m|0)<(f|0)){g=m;do{n=d[c+(g<<1)>>1]|0;if(!(n<<16>>16))w=0;else{q=mrc(i/+(n<<16>>16))|0;w=((q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768)&65535}d[l+(g<<1)>>1]=w;g=g+1|0}while((g|0)!=(f|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(h<<1)|0}}return}function jV(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=+p[h>>3];h=b>>>2;b=d>>>2;d=g+-1|0;if(!g)return;g=e+-4|0;if((e|0)<4){if((e|0)>0){j=c;k=a;l=d}else return;while(1){m=0;do{n=f[k+(m<<2)>>2]|0;if(!n)o=0;else o=mrc(i/+(n|0))|0;f[j+(m<<2)>>2]=o;m=m+1|0}while((m|0)!=(e|0));if(!l)break;else{j=j+(b<<2)|0;k=k+(h<<2)|0;l=l+-1|0}}return}l=e&-4;if((l|0)<(e|0)){q=c;r=a;s=d}else{k=c;c=a;a=d;while(1){d=0;do{j=f[c+(d<<2)>>2]|0;if(!j)t=0;else t=mrc(i/+(j|0))|0;j=d|1;o=f[c+(j<<2)>>2]|0;if(!o)u=0;else u=mrc(i/+(o|0))|0;f[k+(d<<2)>>2]=t;f[k+(j<<2)>>2]=u;j=d|2;o=f[c+(j<<2)>>2]|0;if(!o)v=0;else v=mrc(i/+(o|0))|0;o=d|3;m=f[c+(o<<2)>>2]|0;if(!m)w=0;else w=mrc(i/+(m|0))|0;f[k+(j<<2)>>2]=v;f[k+(o<<2)>>2]=w;d=d+4|0}while((d|0)<=(g|0));if(!a)break;else{k=k+(b<<2)|0;c=c+(h<<2)|0;a=a+-1|0}}return}while(1){a=0;do{c=f[r+(a<<2)>>2]|0;if(!c)x=0;else x=mrc(i/+(c|0))|0;c=a|1;k=f[r+(c<<2)>>2]|0;if(!k)y=0;else y=mrc(i/+(k|0))|0;f[q+(a<<2)>>2]=x;f[q+(c<<2)>>2]=y;c=a|2;k=f[r+(c<<2)>>2]|0;if(!k)z=0;else z=mrc(i/+(k|0))|0;k=a|3;w=f[r+(k<<2)>>2]|0;if(!w)A=0;else A=mrc(i/+(w|0))|0;f[q+(c<<2)>>2]=z;f[q+(k<<2)>>2]=A;a=a+4|0}while((a|0)<=(g|0));B=l;do{a=f[r+(B<<2)>>2]|0;if(!a)C=0;else C=mrc(i/+(a|0))|0;f[q+(B<<2)>>2]=C;B=B+1|0}while((B|0)!=(e|0));if(!s)break;else{q=q+(b<<2)|0;r=r+(h<<2)|0;s=s+-1|0}}return}function kV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,k=0,l=0,m=0.0,o=0,q=0,r=0,s=0.0,t=0;h=+p[g>>3];g=b>>>2;b=d>>>2;d=f+-1|0;if(!f)return;f=e+-4|0;if((e|0)<4){if((e|0)>0){i=c;j=a;k=d}else return;while(1){l=0;do{m=+n[j+(l<<2)>>2];n[i+(l<<2)>>2]=m!=0.0?h/m:0.0;l=l+1|0}while((l|0)!=(e|0));if(!k)break;else{i=i+(b<<2)|0;j=j+(g<<2)|0;k=k+-1|0}}return}k=e&-4;if((k|0)<(e|0)){o=c;q=a;r=d}else{j=c;c=a;a=d;while(1){d=0;do{m=+n[c+(d<<2)>>2];i=d|1;s=+n[c+(i<<2)>>2];n[j+(d<<2)>>2]=m!=0.0?h/m:0.0;n[j+(i<<2)>>2]=s!=0.0?h/s:0.0;i=d|2;s=+n[c+(i<<2)>>2];l=d|3;m=+n[c+(l<<2)>>2];n[j+(i<<2)>>2]=s!=0.0?h/s:0.0;n[j+(l<<2)>>2]=m!=0.0?h/m:0.0;d=d+4|0}while((d|0)<=(f|0));if(!a)break;else{j=j+(b<<2)|0;c=c+(g<<2)|0;a=a+-1|0}}return}while(1){a=0;do{m=+n[q+(a<<2)>>2];c=a|1;s=+n[q+(c<<2)>>2];n[o+(a<<2)>>2]=m!=0.0?h/m:0.0;n[o+(c<<2)>>2]=s!=0.0?h/s:0.0;c=a|2;s=+n[q+(c<<2)>>2];j=a|3;m=+n[q+(j<<2)>>2];n[o+(c<<2)>>2]=s!=0.0?h/s:0.0;n[o+(j<<2)>>2]=m!=0.0?h/m:0.0;a=a+4|0}while((a|0)<=(f|0));t=k;do{m=+n[q+(t<<2)>>2];n[o+(t<<2)>>2]=m!=0.0?h/m:0.0;t=t+1|0}while((t|0)!=(e|0));if(!r)break;else{o=o+(b<<2)|0;q=q+(g<<2)|0;r=r+-1|0}}return}function lV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;h=b>>>3;b=d>>>3;d=f+-1|0;if(!f)return;f=e+-4|0;if((e|0)<4){if((e|0)>0){i=c;j=a;k=d}else return;while(1){l=0;do{m=+p[j+(l<<3)>>3];if(m!=0.0)n=+p[g>>3]/m;else n=0.0;p[i+(l<<3)>>3]=n;l=l+1|0}while((l|0)!=(e|0));if(!k)break;else{i=i+(b<<3)|0;j=j+(h<<3)|0;k=k+-1|0}}return}k=e&-4;if((k|0)<(e|0)){o=c;q=a;r=d}else{j=c;c=a;a=d;while(1){d=0;do{n=+p[c+(d<<3)>>3];if(n!=0.0)s=+p[g>>3]/n;else s=0.0;i=d|1;n=+p[c+(i<<3)>>3];if(n!=0.0)t=+p[g>>3]/n;else t=0.0;p[j+(d<<3)>>3]=s;p[j+(i<<3)>>3]=t;i=d|2;n=+p[c+(i<<3)>>3];if(n!=0.0)u=+p[g>>3]/n;else u=0.0;l=d|3;n=+p[c+(l<<3)>>3];if(n!=0.0)v=+p[g>>3]/n;else v=0.0;p[j+(i<<3)>>3]=u;p[j+(l<<3)>>3]=v;d=d+4|0}while((d|0)<=(f|0));if(!a)break;else{j=j+(b<<3)|0;c=c+(h<<3)|0;a=a+-1|0}}return}while(1){a=0;do{v=+p[q+(a<<3)>>3];if(v!=0.0)w=+p[g>>3]/v;else w=0.0;c=a|1;v=+p[q+(c<<3)>>3];if(v!=0.0)x=+p[g>>3]/v;else x=0.0;p[o+(a<<3)>>3]=w;p[o+(c<<3)>>3]=x;c=a|2;v=+p[q+(c<<3)>>3];if(v!=0.0)y=+p[g>>3]/v;else y=0.0;j=a|3;v=+p[q+(j<<3)>>3];if(v!=0.0)z=+p[g>>3]/v;else z=0.0;p[o+(c<<3)>>3]=y;p[o+(j<<3)>>3]=z;a=a+4|0}while((a|0)<=(f|0));A=k;do{v=+p[q+(A<<3)>>3];if(v!=0.0)B=+p[g>>3]/v;else B=0.0;p[o+(A<<3)>>3]=B;A=A+1|0}while((A|0)!=(e|0));if(!r)break;else{o=o+(b<<3)|0;q=q+(h<<3)|0;r=r+-1|0}}return}function mV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;FT(a,b,c,d,e,f,g,h);return}function nV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;GT(a,b,c,d,e,f,g,h);return}function oV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;HT(a,b,c,d,e,f,g,h);return}function pV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;IT(a,b,c,d,e,f,g,h);return}function qV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;JT(a,b,c,d,e,f,g,h);return}function rV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;KT(a,b,c,d,e,f,g,h);return}function sV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;LT(a,b,c,d,e,f,g,h);return}function tV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;MT(a,b,c,d,e,f,g,h);return}function uV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;NT(a,b,c,d,e,f,g,h);return}function vV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OT(a,b,c,d,e,f,g,h);return}function wV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PT(a,b,c,d,e,f,g,h);return}function xV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QT(a,b,c,d,e,f,g,h);return}function yV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RT(a,b,c,d,e,f,g,h);return}function zV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ST(a,b,c,d,e,f,g,h);return}function AV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;TT(a,b,c,d,e,f,g,h);return}function BV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;UT(a,b,c,d,e,f,g,h);return}function CV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;VT(a,b,c,d,e,f,g,h);return}function DV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;WT(a,b,c,d,e,f,g,h);return}function EV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;XT(a,b,c,d,e,f,g,h);return}function FV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;YT(a,b,c,d,e,f,g,h);return}function GV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ZT(a,b,c,d,e,f,g,h);return}function HV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_T(a,b,c,d,e,f,g,h);return}function IV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$T(a,b,c,d,e,f,g,h);return}function JV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aU(a,b,c,d,e,f,g,h);return}function KV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bU(a,b,c,d,e,f,g,h);return}function LV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cU(a,b,c,d,e,f,g,h);return}function MV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dU(a,b,c,d,e,f,g,h);return}function NV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eU(a,b,c,d,e,f,g,h);return}function OV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fU(a,b,c,d,e,f,g,h);return}function PV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gU(a,b,c,d,e,f,g,h);return}function QV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hU(a,b,c,d,e,f,g,h);return}function RV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;iU(a,b,c,d,e,f,g,h);return}function SV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jU(a,b,c,d,e,f,g,h);return}function TV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kU(a,b,c,d,e,f,g,h);return}function UV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;lU(a,b,c,d,e,f,g,h);return}function VV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;mU(a,b,c,d,e,f,g,h);return}function WV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nU(a,b,c,d,e,f,g,h);return}function XV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;oU(a,b,c,d,e,f,g,h);return}function YV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pU(a,b,c,d,e,f,g,h);return}function ZV(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;qU(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function _V(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;uU(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function $V(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;xU(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function aW(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;AU(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function bW(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;DU(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function cW(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;GU(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function dW(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;JU(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function eW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;MU(a,b,c,d,e,f,g,h,i);return}function fW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;NU(a,b,c,d,e,f,g,h,i);return}function gW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OU(a,b,c,d,e,f,g,h,i);return}function hW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PU(a,b,c,d,e,f,g,h,i);return}function iW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QU(a,b,c,d,e,f,g,h,i);return}function jW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RU(a,b,c,d,e,f,g,h,i);return}function kW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;SU(a,b,c,d,e,f,g,h,i);return}function lW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;TU(a,b,c,d,e,f,g,h,i);return}function mW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;UU(a,b,c,d,e,f,g,h,i);return}function nW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;VU(a,b,c,d,e,f,g,h,i);return}function oW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;WU(a,b,c,d,e,f,g,h,i);return}function pW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;XU(a,b,c,d,e,f,g,h,i);return}function qW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;YU(a,b,c,d,e,f,g,h,i);return}function rW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ZU(a,b,c,d,e,f,g,h,i);return}function sW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_U(a,b,c,d,e,f,g,h,i);return}function tW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$U(a,b,c,d,e,f,g,h,i);return}function uW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aV(a,b,c,d,e,f,g,h,i);return}function vW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bV(a,b,c,d,e,f,g,h,i);return}function wW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cV(a,b,c,d,e,f,g,h,i);return}function xW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dV(a,b,c,d,e,f,g,h,i);return}function yW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eV(a,b,c,d,e,f,g,h,i);return}function zW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fV(c,d,e,f,g,h,i);return}function AW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gV(c,d,e,f,g,h,i);return}function BW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hV(c,d,e,f,g,h,i);return}function CW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;iV(c,d,e,f,g,h,i);return}function DW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jV(c,d,e,f,g,h,i);return}function EW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kV(c,d,e,f,g,h,i);return}function FW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;lV(c,d,e,f,g,h,i);return}function GW(a){a=a|0;return}function HW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+656|0;h=g+312|0;i=g+256|0;j=g+592|0;k=g+32|0;l=g+536|0;m=g;if(!(Mi[f[(f[a>>2]|0)+8>>2]&1023](a,b)|0)){f[j>>2]=1124007936;a=j+4|0;n=j+8|0;o=j+40|0;q=a;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;n=j+48|0;s=j+44|0;f[s>>2]=n;f[n>>2]=0;f[j+52>>2]=0;t=f[b>>2]|0;ei[f[(f[t>>2]|0)+12>>2]&511](t,b,j,-1);t=c;v=f[t>>2]|0;w=f[t+4>>2]|0;t=d;x=f[t+4>>2]|0;y=h;f[y>>2]=f[t>>2];f[y+4>>2]=x;x=i;f[x>>2]=v;f[x+4>>2]=w;$S(l,j,i,h);f[h>>2]=1124007936;w=h+4|0;x=h+8|0;v=h+40|0;q=w;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[v>>2]=x;x=h+48|0;y=h+44|0;f[y>>2]=x;f[x>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;t=i+4|0;z=i+8|0;A=i+40|0;q=t;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[A>>2]=z;z=i+48|0;B=i+44|0;f[B>>2]=z;f[z>>2]=0;f[i+52>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;dX(k,42528,0,l,h,i,1.0,1.0,m);eX(e,k)|0;$j(k);m=i+36|0;C=f[m>>2]|0;if(C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)_S(i);f[m>>2]=0;m=i+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[t>>2]|0)>0){m=f[A>>2]|0;A=0;do{f[m+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[t>>2]|0))}t=f[B>>2]|0;if((t|0)!=(z|0))g0(t);t=h+36|0;z=f[t>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)_S(h);f[t>>2]=0;t=h+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){t=f[v>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[y>>2]|0;if((w|0)!=(x|0))g0(w);w=l+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)_S(l);f[w>>2]=0;w=l+16|0;x=l+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[l+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[l+44>>2]|0;if((x|0)!=(l+48|0))g0(x);x=j+36|0;l=f[x>>2]|0;if(l|0?(y=l+12|0,l=f[y>>2]|0,f[y>>2]=l+-1,(l|0)==1):0)_S(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[a>>2]|0)>0){x=f[o>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[s>>2]|0;if((a|0)!=(n|0))g0(a);u=g;return}a=f[b>>2]|0;n=f[b+4>>2]|0;f[i>>2]=1124007936;s=i+4|0;o=i+8|0;x=i+40|0;q=s;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=o;o=i+48|0;l=i+44|0;f[l>>2]=o;f[o>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;y=j+4|0;w=j+8|0;v=j+40|0;q=y;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[v>>2]=w;w=j+48|0;t=j+44|0;f[t>>2]=w;f[w>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;z=k+4|0;B=k+8|0;A=k+40|0;q=z;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[A>>2]=B;B=k+48|0;q=k+44|0;f[q>>2]=B;f[B>>2]=0;f[k+52>>2]=0;dX(h,a,n,i,j,k,+p[b+176>>3],+p[b+184>>3],b+192|0);eX(e,h)|0;$j(h);n=k+36|0;a=f[n>>2]|0;if(a|0?(r=a+12|0,a=f[r>>2]|0,f[r>>2]=a+-1,(a|0)==1):0)_S(k);f[n>>2]=0;n=k+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[z>>2]|0)>0){n=f[A>>2]|0;A=0;do{f[n+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[z>>2]|0))}z=f[q>>2]|0;if((z|0)!=(B|0))g0(z);z=j+36|0;B=f[z>>2]|0;if(B|0?(q=B+12|0,B=f[q>>2]|0,f[q>>2]=B+-1,(B|0)==1):0)_S(j);f[z>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){z=f[v>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[y>>2]|0))}y=f[t>>2]|0;if((y|0)!=(w|0))g0(y);y=i+36|0;w=f[y>>2]|0;if(w|0?(t=w+12|0,w=f[t>>2]|0,f[t>>2]=w+-1,(w|0)==1):0)_S(i);f[y>>2]=0;y=i+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[s>>2]|0)>0){y=f[x>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}s=f[l>>2]|0;if((s|0)!=(o|0))g0(s);if(f[b+24>>2]|0){s=c;o=f[s>>2]|0;l=f[s+4>>2]|0;s=d;x=f[s+4>>2]|0;y=h;f[y>>2]=f[s>>2];f[y+4>>2]=x;x=i;f[x>>2]=o;f[x+4>>2]=l;$S(j,b+8|0,i,h);l=e+8|0;x=j+36|0;o=f[x>>2]|0;if((l|0)==(j|0))E=o;else{if(o|0){y=o+12|0;f[y>>2]=(f[y>>2]|0)+1}y=e+44|0;o=f[y>>2]|0;if(o|0?(s=o+12|0,o=f[s>>2]|0,f[s>>2]=o+-1,(o|0)==1):0)_S(l);f[y>>2]=0;o=e+24|0;s=e+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[s>>2]|0)>0){w=f[e+48>>2]|0;t=0;do{f[w+(t<<2)>>2]=0;t=t+1|0;F=f[s>>2]|0}while((t|0)<(F|0));f[l>>2]=f[j>>2];if((F|0)<3)G=38;else G=40}else{f[l>>2]=f[j>>2];G=38}if((G|0)==38){F=f[j+4>>2]|0;if((F|0)<3){f[s>>2]=F;f[e+16>>2]=f[j+8>>2];f[e+20>>2]=f[j+12>>2];F=f[j+44>>2]|0;s=f[e+52>>2]|0;f[s>>2]=f[F>>2];f[s+4>>2]=f[F+4>>2]}else G=40}if((G|0)==40)ZS(l,j);f[o>>2]=f[j+16>>2];f[e+28>>2]=f[j+20>>2];f[e+32>>2]=f[j+24>>2];f[e+36>>2]=f[j+28>>2];f[e+40>>2]=f[j+32>>2];o=f[x>>2]|0;f[y>>2]=o;E=o}if(E|0?(o=E+12|0,E=f[o>>2]|0,f[o>>2]=E+-1,(E|0)==1):0)_S(j);f[x>>2]=0;x=j+16|0;E=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[E>>2]|0)>0){x=f[j+40>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[E>>2]|0))}E=f[j+44>>2]|0;if((E|0)!=(j+48|0))g0(E)}if(f[b+80>>2]|0){E=c;o=f[E>>2]|0;x=f[E+4>>2]|0;E=d;y=f[E+4>>2]|0;l=h;f[l>>2]=f[E>>2];f[l+4>>2]=y;y=i;f[y>>2]=o;f[y+4>>2]=x;$S(j,b+64|0,i,h);x=e+64|0;y=j+36|0;o=f[y>>2]|0;if((x|0)==(j|0))H=o;else{if(o|0){l=o+12|0;f[l>>2]=(f[l>>2]|0)+1}l=e+100|0;o=f[l>>2]|0;if(o|0?(E=o+12|0,o=f[E>>2]|0,f[E>>2]=o+-1,(o|0)==1):0)_S(x);f[l>>2]=0;o=e+80|0;E=e+68|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[E>>2]|0)>0){F=f[e+104>>2]|0;s=0;do{f[F+(s<<2)>>2]=0;s=s+1|0;I=f[E>>2]|0}while((s|0)<(I|0));f[x>>2]=f[j>>2];if((I|0)<3)G=63;else G=65}else{f[x>>2]=f[j>>2];G=63}if((G|0)==63){I=f[j+4>>2]|0;if((I|0)<3){f[E>>2]=I;f[e+72>>2]=f[j+8>>2];f[e+76>>2]=f[j+12>>2];I=f[j+44>>2]|0;E=f[e+108>>2]|0;f[E>>2]=f[I>>2];f[E+4>>2]=f[I+4>>2]}else G=65}if((G|0)==65)ZS(x,j);f[o>>2]=f[j+16>>2];f[e+84>>2]=f[j+20>>2];f[e+88>>2]=f[j+24>>2];f[e+92>>2]=f[j+28>>2];f[e+96>>2]=f[j+32>>2];o=f[y>>2]|0;f[l>>2]=o;H=o}if(H|0?(o=H+12|0,H=f[o>>2]|0,f[o>>2]=H+-1,(H|0)==1):0)_S(j);f[y>>2]=0;y=j+16|0;H=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[H>>2]|0)>0){y=f[j+40>>2]|0;o=0;do{f[y+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[H>>2]|0))}H=f[j+44>>2]|0;if((H|0)!=(j+48|0))g0(H)}if(!(f[b+136>>2]|0)){u=g;return}H=c;c=f[H>>2]|0;o=f[H+4>>2]|0;H=d;d=f[H+4>>2]|0;y=h;f[y>>2]=f[H>>2];f[y+4>>2]=d;d=i;f[d>>2]=c;f[d+4>>2]=o;$S(j,b+120|0,i,h);h=e+120|0;i=j+36|0;b=f[i>>2]|0;if((h|0)==(j|0))J=b;else{if(b|0){o=b+12|0;f[o>>2]=(f[o>>2]|0)+1}o=e+156|0;b=f[o>>2]|0;if(b|0?(d=b+12|0,b=f[d>>2]|0,f[d>>2]=b+-1,(b|0)==1):0)_S(h);f[o>>2]=0;b=e+136|0;d=e+124|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){c=f[e+160>>2]|0;y=0;do{f[c+(y<<2)>>2]=0;y=y+1|0;K=f[d>>2]|0}while((y|0)<(K|0));f[h>>2]=f[j>>2];if((K|0)<3)G=88;else G=90}else{f[h>>2]=f[j>>2];G=88}if((G|0)==88){K=f[j+4>>2]|0;if((K|0)<3){f[d>>2]=K;f[e+128>>2]=f[j+8>>2];f[e+132>>2]=f[j+12>>2];K=f[j+44>>2]|0;d=f[e+164>>2]|0;f[d>>2]=f[K>>2];f[d+4>>2]=f[K+4>>2]}else G=90}if((G|0)==90)ZS(h,j);f[b>>2]=f[j+16>>2];f[e+140>>2]=f[j+20>>2];f[e+144>>2]=f[j+24>>2];f[e+148>>2]=f[j+28>>2];f[e+152>>2]=f[j+32>>2];e=f[i>>2]|0;f[o>>2]=e;J=e}if(J|0?(e=J+12|0,J=f[e>>2]|0,f[e>>2]=J+-1,(J|0)==1):0)_S(j);f[i>>2]=0;i=j+16|0;J=j+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[J>>2]|0)>0){i=f[j+40>>2]|0;e=0;do{f[i+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[J>>2]|0))}J=f[j+44>>2]|0;if((J|0)!=(j+48|0))g0(J);u=g;return}function IW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+656|0;g=e+256|0;h=e+32|0;i=e+592|0;j=e+536|0;k=e+480|0;l=e;if(!(Mi[f[(f[a>>2]|0)+8>>2]&1023](a,b)|0)){f[g>>2]=1124007936;a=g+4|0;m=g+8|0;n=g+40|0;o=a;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;m=g+48|0;r=g+44|0;f[r>>2]=m;f[m>>2]=0;f[g+52>>2]=0;s=f[b>>2]|0;ei[f[(f[s>>2]|0)+12>>2]&511](s,b,g,-1);gT(i,g,c);f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[v>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;x=k+4|0;y=k+8|0;z=k+40|0;o=x;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[z>>2]=y;y=k+48|0;A=k+44|0;f[A>>2]=y;f[y>>2]=0;f[k+52>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;dX(h,42528,0,i,j,k,1.0,1.0,l);eX(d,h)|0;$j(h);l=k+36|0;B=f[l>>2]|0;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)_S(k);f[l>>2]=0;l=k+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[x>>2]|0)>0){l=f[z>>2]|0;z=0;do{f[l+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}x=f[A>>2]|0;if((x|0)!=(y|0))g0(x);x=j+36|0;y=f[x>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)_S(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[v>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[w>>2]|0;if((s|0)!=(t|0))g0(s);s=i+36|0;t=f[s>>2]|0;if(t|0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0)_S(i);f[s>>2]=0;s=i+16|0;t=i+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[t>>2]|0)>0){s=f[i+40>>2]|0;w=0;do{f[s+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[i+44>>2]|0;if((t|0)!=(i+48|0))g0(t);t=g+36|0;w=f[t>>2]|0;if(w|0?(s=w+12|0,w=f[s>>2]|0,f[s>>2]=w+-1,(w|0)==1):0)_S(g);f[t>>2]=0;t=g+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[a>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(m|0))g0(a);u=e;return}a=f[b>>2]|0;m=f[b+4>>2]|0;f[h>>2]=1124007936;r=h+4|0;n=h+8|0;t=h+40|0;o=r;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[t>>2]=n;n=h+48|0;w=h+44|0;f[w>>2]=n;f[n>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;s=i+4|0;v=i+8|0;x=i+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[x>>2]=v;v=i+48|0;y=i+44|0;f[y>>2]=v;f[v>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;A=j+4|0;z=j+8|0;l=j+40|0;o=A;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[l>>2]=z;z=j+48|0;o=j+44|0;f[o>>2]=z;f[z>>2]=0;f[j+52>>2]=0;dX(g,a,m,h,i,j,+p[b+176>>3],+p[b+184>>3],b+192|0);eX(d,g)|0;$j(g);m=j+36|0;a=f[m>>2]|0;if(a|0?(q=a+12|0,a=f[q>>2]|0,f[q>>2]=a+-1,(a|0)==1):0)_S(j);f[m>>2]=0;m=j+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[A>>2]|0)>0){m=f[l>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[A>>2]|0))}A=f[o>>2]|0;if((A|0)!=(z|0))g0(A);A=i+36|0;z=f[A>>2]|0;if(z|0?(o=z+12|0,z=f[o>>2]|0,f[o>>2]=z+-1,(z|0)==1):0)_S(i);f[A>>2]=0;A=i+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[s>>2]|0)>0){A=f[x>>2]|0;x=0;do{f[A+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}s=f[y>>2]|0;if((s|0)!=(v|0))g0(s);s=h+36|0;v=f[s>>2]|0;if(v|0?(y=v+12|0,v=f[y>>2]|0,f[y>>2]=v+-1,(v|0)==1):0)_S(h);f[s>>2]=0;s=h+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[t>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[w>>2]|0;if((r|0)!=(n|0))g0(r);if(f[b+24>>2]|0){gT(g,b+8|0,c);r=d+8|0;n=g+36|0;w=f[n>>2]|0;if((r|0)==(g|0))D=w;else{if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}t=d+44|0;w=f[t>>2]|0;if(w|0?(s=w+12|0,w=f[s>>2]|0,f[s>>2]=w+-1,(w|0)==1):0)_S(r);f[t>>2]=0;w=d+24|0;s=d+12|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[s>>2]|0)>0){h=f[d+48>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0;E=f[s>>2]|0}while((v|0)<(E|0));f[r>>2]=f[g>>2];if((E|0)<3)F=38;else F=40}else{f[r>>2]=f[g>>2];F=38}if((F|0)==38){E=f[g+4>>2]|0;if((E|0)<3){f[s>>2]=E;f[d+16>>2]=f[g+8>>2];f[d+20>>2]=f[g+12>>2];E=f[g+44>>2]|0;s=f[d+52>>2]|0;f[s>>2]=f[E>>2];f[s+4>>2]=f[E+4>>2]}else F=40}if((F|0)==40)ZS(r,g);f[w>>2]=f[g+16>>2];f[d+28>>2]=f[g+20>>2];f[d+32>>2]=f[g+24>>2];f[d+36>>2]=f[g+28>>2];f[d+40>>2]=f[g+32>>2];w=f[n>>2]|0;f[t>>2]=w;D=w}if(D|0?(w=D+12|0,D=f[w>>2]|0,f[w>>2]=D+-1,(D|0)==1):0)_S(g);f[n>>2]=0;n=g+16|0;D=g+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[D>>2]|0)>0){n=f[g+40>>2]|0;w=0;do{f[n+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[D>>2]|0))}D=f[g+44>>2]|0;if((D|0)!=(g+48|0))g0(D)}if(f[b+80>>2]|0){gT(g,b+64|0,c);D=d+64|0;w=g+36|0;n=f[w>>2]|0;if((D|0)==(g|0))G=n;else{if(n|0){t=n+12|0;f[t>>2]=(f[t>>2]|0)+1}t=d+100|0;n=f[t>>2]|0;if(n|0?(r=n+12|0,n=f[r>>2]|0,f[r>>2]=n+-1,(n|0)==1):0)_S(D);f[t>>2]=0;n=d+80|0;r=d+68|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[r>>2]|0)>0){E=f[d+104>>2]|0;s=0;do{f[E+(s<<2)>>2]=0;s=s+1|0;H=f[r>>2]|0}while((s|0)<(H|0));f[D>>2]=f[g>>2];if((H|0)<3)F=63;else F=65}else{f[D>>2]=f[g>>2];F=63}if((F|0)==63){H=f[g+4>>2]|0;if((H|0)<3){f[r>>2]=H;f[d+72>>2]=f[g+8>>2];f[d+76>>2]=f[g+12>>2];H=f[g+44>>2]|0;r=f[d+108>>2]|0;f[r>>2]=f[H>>2];f[r+4>>2]=f[H+4>>2]}else F=65}if((F|0)==65)ZS(D,g);f[n>>2]=f[g+16>>2];f[d+84>>2]=f[g+20>>2];f[d+88>>2]=f[g+24>>2];f[d+92>>2]=f[g+28>>2];f[d+96>>2]=f[g+32>>2];n=f[w>>2]|0;f[t>>2]=n;G=n}if(G|0?(n=G+12|0,G=f[n>>2]|0,f[n>>2]=G+-1,(G|0)==1):0)_S(g);f[w>>2]=0;w=g+16|0;G=g+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[G>>2]|0)>0){w=f[g+40>>2]|0;n=0;do{f[w+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[G>>2]|0))}G=f[g+44>>2]|0;if((G|0)!=(g+48|0))g0(G)}if(!(f[b+136>>2]|0)){u=e;return}gT(g,b+120|0,c);c=d+120|0;b=g+36|0;G=f[b>>2]|0;if((c|0)==(g|0))I=G;else{if(G|0){n=G+12|0;f[n>>2]=(f[n>>2]|0)+1}n=d+156|0;G=f[n>>2]|0;if(G|0?(w=G+12|0,G=f[w>>2]|0,f[w>>2]=G+-1,(G|0)==1):0)_S(c);f[n>>2]=0;G=d+136|0;w=d+124|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[w>>2]|0)>0){t=f[d+160>>2]|0;D=0;do{f[t+(D<<2)>>2]=0;D=D+1|0;J=f[w>>2]|0}while((D|0)<(J|0));f[c>>2]=f[g>>2];if((J|0)<3)F=88;else F=90}else{f[c>>2]=f[g>>2];F=88}if((F|0)==88){J=f[g+4>>2]|0;if((J|0)<3){f[w>>2]=J;f[d+128>>2]=f[g+8>>2];f[d+132>>2]=f[g+12>>2];J=f[g+44>>2]|0;w=f[d+164>>2]|0;f[w>>2]=f[J>>2];f[w+4>>2]=f[J+4>>2]}else F=90}if((F|0)==90)ZS(c,g);f[G>>2]=f[g+16>>2];f[d+140>>2]=f[g+20>>2];f[d+144>>2]=f[g+24>>2];f[d+148>>2]=f[g+28>>2];f[d+152>>2]=f[g+32>>2];d=f[b>>2]|0;f[n>>2]=d;I=d}if(I|0?(d=I+12|0,I=f[d>>2]|0,f[d>>2]=I+-1,(I|0)==1):0)_S(g);f[b>>2]=0;b=g+16|0;I=g+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[I>>2]|0)>0){b=f[g+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[I>>2]|0))}I=f[g+44>>2]|0;if((I|0)!=(g+48|0))g0(I);u=e;return}function JW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;mL(d,e,g,e0()|0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function KW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;oL(d,e,g,e0()|0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function LW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=u;u=u+176|0;d=a+160|0;e=a+144|0;g=a+128|0;h=a+72|0;i=a+56|0;j=a;f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=j+48|0;p=j+44|0;f[p>>2]=l;f[l>>2]=0;f[j+52>>2]=0;q=f[b>>2]|0;ei[f[(f[q>>2]|0)+12>>2]&511](q,b,j,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=j;f[h>>2]=1124007936;b=h+4|0;q=h+8|0;r=h+40|0;n=b;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[r>>2]=q;q=h+48|0;n=h+44|0;f[n>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=h;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;MN(d,e,1.0,g,0.0,i,0);i=h+36|0;g=f[i>>2]|0;if(g|0?(e=g+12|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)_S(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[b>>2]|0)>0){i=f[r>>2]|0;r=0;do{f[i+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[b>>2]|0))}b=f[n>>2]|0;if((b|0)!=(q|0))g0(b);b=j+36|0;q=f[b>>2]|0;if(q|0?(n=q+12|0,q=f[n>>2]|0,f[n>>2]=q+-1,(q|0)==1):0)_S(j);f[b>>2]=0;b=j+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[k>>2]|0)>0){b=f[m>>2]|0;m=0;do{f[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[p>>2]|0;if((k|0)==(l|0)){u=a;return}g0(k);u=a;return}function MW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;rL(d,e,g,1.0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function NW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dL(d,e,g,e0()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function OW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;fL(d,e,g,e0()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function PW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;gL(d,e,g,e0()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function QW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0;e=u;u=u+144|0;g=e;h=e+88|0;i=e+32|0;j=f[c>>2]|0;if((j|0)!=(a|0)){ei[f[(f[j>>2]|0)+52>>2]&511](j,b,c,d);u=e;return};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[h>>2]=1124007936;j=h+4|0;a=h+8|0;k=h+40|0;l=j;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=a;n=h+48|0;o=h+44|0;f[o>>2]=n;f[n>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;q=i+4|0;r=i+8|0;s=i+40|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;l=i+48|0;m=i+44|0;f[m>>2]=l;f[l>>2]=0;f[i+52>>2]=0;t=f[b>>2]|0;do if((t|0)==42772){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){v=21;break}w=b+8|0;if((h|0)!=(w|0)){x=b+44|0;y=f[x>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){_S(h);B=z}else B=z}else B=h+36|0;f[B>>2]=0;z=h+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){y=f[k>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;C=f[j>>2]|0}while((A|0)<(C|0));f[h>>2]=f[w>>2];if((C|0)<3)v=16;else v=18}else{f[h>>2]=f[w>>2];v=16}if((v|0)==16){A=f[b+12>>2]|0;if((A|0)<3){f[j>>2]=A;f[a>>2]=f[b+16>>2];f[h+12>>2]=f[b+20>>2];A=f[b+52>>2]|0;y=f[o>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2]}else v=18}if((v|0)==18)ZS(h,w);f[z>>2]=f[b+24>>2];f[h+20>>2]=f[b+28>>2];f[h+24>>2]=f[b+32>>2];f[h+28>>2]=f[b+36>>2];f[h+32>>2]=f[b+40>>2];f[B>>2]=f[x>>2]}D=+p[b+176>>3];A=b+192|0;f[g>>2]=f[A>>2];f[g+4>>2]=f[A+4>>2];f[g+8>>2]=f[A+8>>2];f[g+12>>2]=f[A+12>>2];f[g+16>>2]=f[A+16>>2];f[g+20>>2]=f[A+20>>2];f[g+24>>2]=f[A+24>>2];f[g+28>>2]=f[A+28>>2];E=D}else v=21;while(0);if((v|0)==21){ei[f[(f[t>>2]|0)+12>>2]&511](t,b,h,-1);E=1.0}b=f[c>>2]|0;do if((b|0)==42772){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){v=41;break}t=c+8|0;if((i|0)!=(t|0)){B=c+44|0;a=f[B>>2]|0;if(a|0){C=a+12|0;f[C>>2]=(f[C>>2]|0)+1}C=i+36|0;a=f[C>>2]|0;if(a|0?(A=a+12|0,a=f[A>>2]|0,f[A>>2]=a+-1,(a|0)==1):0)_S(i);f[C>>2]=0;a=i+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){A=f[s>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0;F=f[q>>2]|0}while((y|0)<(F|0));f[i>>2]=f[t>>2];if((F|0)<3)v=36;else v=38}else{f[i>>2]=f[t>>2];v=36}if((v|0)==36){y=f[c+12>>2]|0;if((y|0)<3){f[q>>2]=y;f[r>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];y=f[c+52>>2]|0;A=f[m>>2]|0;f[A>>2]=f[y>>2];f[A+4>>2]=f[y+4>>2]}else v=38}if((v|0)==38)ZS(i,t);f[a>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[C>>2]=f[B>>2]}D=+p[c+176>>3];p[g>>3]=+p[c+192>>3]+ +p[g>>3];y=g+8|0;p[y>>3]=+p[c+200>>3]+ +p[y>>3];y=g+16|0;p[y>>3]=+p[c+208>>3]+ +p[y>>3];y=g+24|0;p[y>>3]=+p[c+216>>3]+ +p[y>>3];G=D}else v=41;while(0);if((v|0)==41){ei[f[(f[b>>2]|0)+12>>2]&511](b,c,i,-1);G=1.0}OX(d,h,i,E,G,g);g=i+36|0;d=f[g>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[m>>2]|0;if((q|0)!=(l|0))g0(q);q=h+36|0;l=f[q>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)_S(h);f[q>>2]=0;q=h+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[k>>2]|0;k=0;do{f[q+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)!=(n|0))g0(j);u=e;return}function RW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+56|0;g=a;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=e+48|0;m=e+44|0;f[m>>2]=i;f[i>>2]=0;f[e+52>>2]=0;n=f[b>>2]|0;ei[f[(f[n>>2]|0)+12>>2]&511](n,b,e,-1);f[g>>2]=1124007936;b=g+4|0;n=g+8|0;o=g+40|0;k=b;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[o>>2]=n;n=g+48|0;k=g+44|0;f[k>>2]=n;f[n>>2]=0;f[g+52>>2]=0;OX(d,e,g,1.0,0.0,c);c=g+36|0;d=f[c>>2]|0;if(d|0?(l=d+12|0,d=f[l>>2]|0,f[l>>2]=d+-1,(d|0)==1):0)_S(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[o>>2]|0;o=0;do{f[c+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[b>>2]|0))}b=f[k>>2]|0;if((b|0)!=(n|0))g0(b);b=e+36|0;n=f[b>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)_S(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[h>>2]|0)>0){b=f[j>>2]|0;j=0;do{f[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[m>>2]|0;if((h|0)==(i|0)){u=a;return}g0(h);u=a;return}function SW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0;e=u;u=u+144|0;g=e;h=e+88|0;i=e+32|0;j=f[c>>2]|0;if((j|0)!=(a|0)){ei[f[(f[j>>2]|0)+60>>2]&511](j,b,c,d);u=e;return};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[h>>2]=1124007936;j=h+4|0;a=h+8|0;k=h+40|0;l=j;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=a;n=h+48|0;o=h+44|0;f[o>>2]=n;f[n>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;q=i+4|0;r=i+8|0;s=i+40|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;l=i+48|0;m=i+44|0;f[m>>2]=l;f[l>>2]=0;f[i+52>>2]=0;t=f[b>>2]|0;do if((t|0)==42772){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){v=21;break}w=b+8|0;if((h|0)!=(w|0)){x=b+44|0;y=f[x>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){_S(h);B=z}else B=z}else B=h+36|0;f[B>>2]=0;z=h+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){y=f[k>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;C=f[j>>2]|0}while((A|0)<(C|0));f[h>>2]=f[w>>2];if((C|0)<3)v=16;else v=18}else{f[h>>2]=f[w>>2];v=16}if((v|0)==16){A=f[b+12>>2]|0;if((A|0)<3){f[j>>2]=A;f[a>>2]=f[b+16>>2];f[h+12>>2]=f[b+20>>2];A=f[b+52>>2]|0;y=f[o>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2]}else v=18}if((v|0)==18)ZS(h,w);f[z>>2]=f[b+24>>2];f[h+20>>2]=f[b+28>>2];f[h+24>>2]=f[b+32>>2];f[h+28>>2]=f[b+36>>2];f[h+32>>2]=f[b+40>>2];f[B>>2]=f[x>>2]}D=+p[b+176>>3];A=b+192|0;f[g>>2]=f[A>>2];f[g+4>>2]=f[A+4>>2];f[g+8>>2]=f[A+8>>2];f[g+12>>2]=f[A+12>>2];f[g+16>>2]=f[A+16>>2];f[g+20>>2]=f[A+20>>2];f[g+24>>2]=f[A+24>>2];f[g+28>>2]=f[A+28>>2];E=D}else v=21;while(0);if((v|0)==21){ei[f[(f[t>>2]|0)+12>>2]&511](t,b,h,-1);E=1.0}b=f[c>>2]|0;do if((b|0)==42772){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){v=41;break}t=c+8|0;if((i|0)!=(t|0)){B=c+44|0;a=f[B>>2]|0;if(a|0){C=a+12|0;f[C>>2]=(f[C>>2]|0)+1}C=i+36|0;a=f[C>>2]|0;if(a|0?(A=a+12|0,a=f[A>>2]|0,f[A>>2]=a+-1,(a|0)==1):0)_S(i);f[C>>2]=0;a=i+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){A=f[s>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0;F=f[q>>2]|0}while((y|0)<(F|0));f[i>>2]=f[t>>2];if((F|0)<3)v=36;else v=38}else{f[i>>2]=f[t>>2];v=36}if((v|0)==36){y=f[c+12>>2]|0;if((y|0)<3){f[q>>2]=y;f[r>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];y=f[c+52>>2]|0;A=f[m>>2]|0;f[A>>2]=f[y>>2];f[A+4>>2]=f[y+4>>2]}else v=38}if((v|0)==38)ZS(i,t);f[a>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[C>>2]=f[B>>2]}D=-+p[c+176>>3];p[g>>3]=+p[g>>3]-+p[c+192>>3];y=g+8|0;p[y>>3]=+p[y>>3]-+p[c+200>>3];y=g+16|0;p[y>>3]=+p[y>>3]-+p[c+208>>3];y=g+24|0;p[y>>3]=+p[y>>3]-+p[c+216>>3];G=D}else v=41;while(0);if((v|0)==41){ei[f[(f[b>>2]|0)+12>>2]&511](b,c,i,-1);G=-1.0}OX(d,h,i,E,G,g);g=i+36|0;d=f[g>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[m>>2]|0;if((q|0)!=(l|0))g0(q);q=h+36|0;l=f[q>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)_S(h);f[q>>2]=0;q=h+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[k>>2]|0;k=0;do{f[q+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)!=(n|0))g0(j);u=e;return}function TW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+56|0;g=a;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=e+48|0;m=e+44|0;f[m>>2]=i;f[i>>2]=0;f[e+52>>2]=0;n=f[c>>2]|0;ei[f[(f[n>>2]|0)+12>>2]&511](n,c,e,-1);f[g>>2]=1124007936;c=g+4|0;n=g+8|0;o=g+40|0;k=c;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[o>>2]=n;n=g+48|0;k=g+44|0;f[k>>2]=n;f[n>>2]=0;f[g+52>>2]=0;OX(d,e,g,-1.0,0.0,b);b=g+36|0;d=f[b>>2]|0;if(d|0?(l=d+12|0,d=f[l>>2]|0,f[l>>2]=d+-1,(d|0)==1):0)_S(g);f[b>>2]=0;b=g+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[o>>2]|0;o=0;do{f[b+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[c>>2]|0))}c=f[k>>2]|0;if((c|0)!=(n|0))g0(c);c=e+36|0;n=f[c>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[h>>2]|0)>0){c=f[j>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[m>>2]|0;if((h|0)==(i|0)){u=a;return}g0(h);u=a;return}function UW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0;g=u;u=u+112|0;h=g+56|0;i=g;j=f[c>>2]|0;if((j|0)!=(a|0)){ni[f[(f[j>>2]|0)+68>>2]&31](j,b,c,d,e);u=g;return}f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;r=i+4|0;s=i+8|0;t=i+40|0;m=r;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[t>>2]=s;m=i+48|0;n=i+44|0;f[n>>2]=m;f[m>>2]=0;f[i+52>>2]=0;v=f[b>>2]|0;do if(!((v|0)==43012?(f[b+4>>2]|0)==47:0))if((v|0)==42772){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){w=52;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){x=b+8|0;if((h|0)!=(x|0)){y=b+44|0;z=f[y>>2]|0;if(z){A=z+12|0;f[A>>2]=(f[A>>2]|0)+1;A=h+36|0;z=f[A>>2]|0;if((z|0)!=0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0){_S(h);C=A}else C=A}else C=h+36|0;f[C>>2]=0;A=h+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;B=0;do{f[z+(B<<2)>>2]=0;B=B+1|0;D=f[j>>2]|0}while((B|0)<(D|0));f[h>>2]=f[x>>2];if((D|0)<3)w=47;else w=49}else{f[h>>2]=f[x>>2];w=47}if((w|0)==47){B=f[b+12>>2]|0;if((B|0)<3){f[j>>2]=B;f[k>>2]=f[b+16>>2];f[h+12>>2]=f[b+20>>2];B=f[b+52>>2]|0;z=f[q>>2]|0;f[z>>2]=f[B>>2];f[z+4>>2]=f[B+4>>2]}else w=49}if((w|0)==49)ZS(h,x);f[A>>2]=f[b+24>>2];f[h+20>>2]=f[b+28>>2];f[h+24>>2]=f[b+32>>2];f[h+28>>2]=f[b+36>>2];f[h+32>>2]=f[b+40>>2];f[C>>2]=f[y>>2]}E=+p[b+176>>3]*e;w=53}else w=52}else w=52;else{if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){w=52;break}do if((a|0)==42772){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){w=27;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){F=+p[c+176>>3]*e;B=c+8|0;if((i|0)==(B|0))G=F;else{z=c+44|0;H=f[z>>2]|0;if(H){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1;I=i+36|0;H=f[I>>2]|0;if((H|0)!=0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0){_S(i);K=I}else K=I}else K=i+36|0;f[K>>2]=0;I=i+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[r>>2]|0)>0){H=f[t>>2]|0;J=0;do{f[H+(J<<2)>>2]=0;J=J+1|0;L=f[r>>2]|0}while((J|0)<(L|0));f[i>>2]=f[B>>2];if((L|0)<3)w=23;else w=25}else{f[i>>2]=f[B>>2];w=23}if((w|0)==23){J=f[c+12>>2]|0;if((J|0)<3){f[r>>2]=J;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];J=f[c+52>>2]|0;H=f[n>>2]|0;f[H>>2]=f[J>>2];f[H+4>>2]=f[J+4>>2]}else w=25}if((w|0)==25)ZS(i,B);f[I>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[K>>2]=f[z>>2];G=F}}else w=27}else w=27;while(0);if((w|0)==27){ei[f[(f[a>>2]|0)+12>>2]&511](a,c,i,-1);G=e}IX(d,47,i,b+8|0,G/+p[b+176>>3])}while(0);if((w|0)==52){ei[f[(f[v>>2]|0)+12>>2]&511](v,b,h,-1);E=e;w=53}if((w|0)==53){b=f[c>>2]|0;do if((b|0)==42772){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){w=95;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){v=c+8|0;if((i|0)!=(v|0)){a=c+44|0;K=f[a>>2]|0;if(K|0){L=K+12|0;f[L>>2]=(f[L>>2]|0)+1}L=i+36|0;K=f[L>>2]|0;if(K|0?(C=K+12|0,K=f[C>>2]|0,f[C>>2]=K+-1,(K|0)==1):0)_S(i);f[L>>2]=0;K=i+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[r>>2]|0)>0){C=f[t>>2]|0;k=0;do{f[C+(k<<2)>>2]=0;k=k+1|0;M=f[r>>2]|0}while((k|0)<(M|0));f[i>>2]=f[v>>2];if((M|0)<3)w=71;else w=73}else{f[i>>2]=f[v>>2];w=71}if((w|0)==71){k=f[c+12>>2]|0;if((k|0)<3){f[r>>2]=k;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];k=f[c+52>>2]|0;C=f[n>>2]|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2]}else w=73}if((w|0)==73)ZS(i,v);f[K>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[L>>2]=f[a>>2]}N=42;O=E*+p[c+176>>3]}else w=95}else if((b|0)==43012?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){w=95;break}k=c+8|0;if((i|0)!=(k|0)){C=c+44|0;D=f[C>>2]|0;if(D|0){y=D+12|0;f[y>>2]=(f[y>>2]|0)+1}y=i+36|0;D=f[y>>2]|0;if(D|0?(A=D+12|0,D=f[A>>2]|0,f[A>>2]=D+-1,(D|0)==1):0)_S(i);f[y>>2]=0;D=i+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[r>>2]|0)>0){A=f[t>>2]|0;x=0;do{f[A+(x<<2)>>2]=0;x=x+1|0;P=f[r>>2]|0}while((x|0)<(P|0));f[i>>2]=f[k>>2];if((P|0)<3)w=90;else w=92}else{f[i>>2]=f[k>>2];w=90}if((w|0)==90){x=f[c+12>>2]|0;if((x|0)<3){f[r>>2]=x;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];x=f[c+52>>2]|0;A=f[n>>2]|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2]}else w=92}if((w|0)==92)ZS(i,k);f[D>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[y>>2]=f[C>>2]}N=47;O=E*+p[c+176>>3]}else w=95;while(0);if((w|0)==95){ei[f[(f[b>>2]|0)+12>>2]&511](b,c,i,-1);N=42;O=E}IX(d,N,h,i,O)}N=i+36|0;d=f[N>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(i);f[N>>2]=0;N=i+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[r>>2]|0)>0){N=f[t>>2]|0;t=0;do{f[N+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[n>>2]|0;if((r|0)!=(m|0))g0(r);r=h+36|0;m=f[r>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)_S(h);f[r>>2]=0;r=h+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[l>>2]|0;l=0;do{f[r+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(o|0))g0(j);u=g;return}function VW(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+144|0;e=a+88|0;g=a+32|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;n=e+44|0;f[n>>2]=j;f[j>>2]=0;f[e+52>>2]=0;o=f[b>>2]|0;ei[f[(f[o>>2]|0)+12>>2]&511](o,b,e,-1);f[g>>2]=1124007936;b=g+4|0;o=g+8|0;p=g+40|0;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[p>>2]=o;o=g+48|0;l=g+44|0;f[l>>2]=o;f[o>>2]=0;f[g+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;OX(d,e,g,c,0.0,h);h=g+36|0;d=f[h>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)_S(g);f[h>>2]=0;h=g+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[b>>2]|0)>0){h=f[p>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[b>>2]|0))}b=f[l>>2]|0;if((b|0)!=(o|0))g0(b);b=e+36|0;o=f[b>>2]|0;if(o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)_S(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function WW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0.0,H=0,I=0;g=u;u=u+112|0;h=g+56|0;i=g;j=f[c>>2]|0;if((j|0)!=(a|0)){ni[f[(f[j>>2]|0)+76>>2]&31](j,b,c,d,e);u=g;return}j=f[b>>2]|0;do if((j|0)==43012?(f[b+4>>2]|0)==47:0){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if((a|0)==43012?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;IX(d,47,c+8|0,b+8|0,+p[b+176>>3]/+p[c+176>>3]);u=g;return}}while(0);f[h>>2]=1124007936;a=h+4|0;k=h+8|0;l=h+40|0;m=a;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;r=i+4|0;s=i+8|0;t=i+40|0;m=r;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[t>>2]=s;m=i+48|0;n=i+44|0;f[n>>2]=m;f[m>>2]=0;f[i+52>>2]=0;do if((j|0)==42772){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){v=32;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){w=b+8|0;if((h|0)!=(w|0)){x=b+44|0;y=f[x>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){_S(h);B=z}else B=z}else B=h+36|0;f[B>>2]=0;z=h+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[a>>2]|0)>0){y=f[l>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;C=f[a>>2]|0}while((A|0)<(C|0));f[h>>2]=f[w>>2];if((C|0)<3)v=27;else v=29}else{f[h>>2]=f[w>>2];v=27}if((v|0)==27){A=f[b+12>>2]|0;if((A|0)<3){f[a>>2]=A;f[k>>2]=f[b+16>>2];f[h+12>>2]=f[b+20>>2];A=f[b+52>>2]|0;y=f[q>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2]}else v=29}if((v|0)==29)ZS(h,w);f[z>>2]=f[b+24>>2];f[h+20>>2]=f[b+28>>2];f[h+24>>2]=f[b+32>>2];f[h+28>>2]=f[b+36>>2];f[h+32>>2]=f[b+40>>2];f[B>>2]=f[x>>2]}D=+p[b+176>>3]*e}else v=32}else v=32;while(0);if((v|0)==32){ei[f[(f[j>>2]|0)+12>>2]&511](j,b,h,-1);D=e}b=f[c>>2]|0;do if((b|0)==42772){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){v=75;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){j=c+8|0;if((i|0)!=(j|0)){B=c+44|0;k=f[B>>2]|0;if(k|0){C=k+12|0;f[C>>2]=(f[C>>2]|0)+1}C=i+36|0;k=f[C>>2]|0;if(k|0?(A=k+12|0,k=f[A>>2]|0,f[A>>2]=k+-1,(k|0)==1):0)_S(i);f[C>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[r>>2]|0)>0){A=f[t>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0;E=f[r>>2]|0}while((y|0)<(E|0));f[i>>2]=f[j>>2];if((E|0)<3)v=51;else v=53}else{f[i>>2]=f[j>>2];v=51}if((v|0)==51){y=f[c+12>>2]|0;if((y|0)<3){f[r>>2]=y;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];y=f[c+52>>2]|0;A=f[n>>2]|0;f[A>>2]=f[y>>2];f[A+4>>2]=f[y+4>>2]}else v=53}if((v|0)==53)ZS(i,j);f[k>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[C>>2]=f[B>>2]}F=47;G=D/+p[c+176>>3]}else v=75}else if((b|0)==43012?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){v=75;break}y=c+8|0;if((i|0)!=(y|0)){A=c+44|0;x=f[A>>2]|0;if(x|0){z=x+12|0;f[z>>2]=(f[z>>2]|0)+1}z=i+36|0;x=f[z>>2]|0;if(x|0?(w=x+12|0,x=f[w>>2]|0,f[w>>2]=x+-1,(x|0)==1):0)_S(i);f[z>>2]=0;x=i+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[r>>2]|0)>0){w=f[t>>2]|0;H=0;do{f[w+(H<<2)>>2]=0;H=H+1|0;I=f[r>>2]|0}while((H|0)<(I|0));f[i>>2]=f[y>>2];if((I|0)<3)v=70;else v=72}else{f[i>>2]=f[y>>2];v=70}if((v|0)==70){H=f[c+12>>2]|0;if((H|0)<3){f[r>>2]=H;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];H=f[c+52>>2]|0;w=f[n>>2]|0;f[w>>2]=f[H>>2];f[w+4>>2]=f[H+4>>2]}else v=72}if((v|0)==72)ZS(i,y);f[x>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[z>>2]=f[A>>2]}F=42;G=D/+p[c+176>>3]}else v=75;while(0);if((v|0)==75){ei[f[(f[b>>2]|0)+12>>2]&511](b,c,i,-1);F=47;G=D}IX(d,F,h,i,G);F=i+36|0;d=f[F>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(i);f[F>>2]=0;F=i+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[r>>2]|0)>0){F=f[t>>2]|0;t=0;do{f[F+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[n>>2]|0;if((r|0)!=(m|0))g0(r);r=h+36|0;m=f[r>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)_S(h);f[r>>2]=0;r=h+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[a>>2]|0)>0){r=f[l>>2]|0;l=0;do{f[r+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[a>>2]|0))}a=f[q>>2]|0;if((a|0)!=(o|0))g0(a);u=g;return}function XW(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+112|0;e=a+56|0;g=a;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=e+48|0;m=e+44|0;f[m>>2]=i;f[i>>2]=0;f[e+52>>2]=0;n=f[c>>2]|0;ei[f[(f[n>>2]|0)+12>>2]&511](n,c,e,-1);f[g>>2]=1124007936;c=g+4|0;n=g+8|0;o=g+40|0;k=c;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[o>>2]=n;n=g+48|0;k=g+44|0;f[k>>2]=n;f[n>>2]=0;f[g+52>>2]=0;IX(d,47,e,g,b);d=g+36|0;l=f[d>>2]|0;if(l|0?(p=l+12|0,l=f[p>>2]|0,f[p>>2]=l+-1,(l|0)==1):0)_S(g);f[d>>2]=0;d=g+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[o>>2]|0;o=0;do{f[d+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[c>>2]|0))}c=f[k>>2]|0;if((c|0)!=(n|0))g0(c);c=e+36|0;n=f[c>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[h>>2]|0)>0){c=f[j>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[m>>2]|0;if((h|0)==(i|0)){u=a;return}g0(h);u=a;return}function YW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;d=a+56|0;e=a;f[d>>2]=1124007936;g=d+4|0;h=d+8|0;i=d+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=d+48|0;l=d+44|0;f[l>>2]=h;f[h>>2]=0;f[d+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,d,-1);f[e>>2]=1124007936;b=e+4|0;m=e+8|0;n=e+40|0;j=b;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[n>>2]=m;m=e+48|0;j=e+44|0;f[j>>2]=m;f[m>>2]=0;f[e+52>>2]=0;IX(c,97,d,e,1.0);c=e+36|0;k=f[c>>2]|0;if(k|0?(o=k+12|0,k=f[o>>2]|0,f[o>>2]=k+-1,(k|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[n>>2]|0;n=0;do{f[c+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[b>>2]|0))}b=f[j>>2]|0;if((b|0)!=(m|0))g0(b);b=d+36|0;m=f[b>>2]|0;if(m|0?(j=m+12|0,m=f[j>>2]|0,f[j>>2]=m+-1,(m|0)==1):0)_S(d);f[b>>2]=0;b=d+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[g>>2]|0)>0){b=f[i>>2]|0;i=0;do{f[b+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[l>>2]|0;if((g|0)==(h|0)){u=a;return}g0(g);u=a;return}function ZW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;a=u;u=u+64|0;d=a;f[d>>2]=1124007936;e=d+4|0;g=d+8|0;h=d+40|0;i=e;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=d+48|0;i=d+44|0;f[i>>2]=g;f[g>>2]=0;f[d+52>>2]=0;j=f[b>>2]|0;ei[f[(f[j>>2]|0)+12>>2]&511](j,b,d,-1);GX(c,d,1.0);c=d+36|0;b=f[c>>2]|0;if(b|0?(j=b+12|0,b=f[j>>2]|0,f[j>>2]=b+-1,(b|0)==1):0)_S(d);f[c>>2]=0;c=d+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[e>>2]|0)>0){c=f[h>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[e>>2]|0))}e=f[i>>2]|0;if((e|0)==(g|0)){u=a;return}g0(e);u=a;return}function _W(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0;e=u;u=u+432|0;g=e+32|0;h=e;i=e+368|0;j=e+312|0;k=e+256|0;l=f[c>>2]|0;if((l|0)!=(a|0)){ei[f[(f[l>>2]|0)+92>>2]&511](l,b,c,d);u=e;return}f[i>>2]=1124007936;l=i+4|0;a=i+8|0;m=i+40|0;n=l;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=a;q=i+48|0;r=i+44|0;f[r>>2]=q;f[q>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;n=s;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[v>>2]=t;w=j+48|0;x=j+44|0;f[x>>2]=w;f[w>>2]=0;f[j+52>>2]=0;y=f[b>>2]|0;a:do if((y|0)==42768){z=+p[b+176>>3];A=b+8|0;if((i|0)==(A|0)){B=1;C=z}else{D=b+44|0;E=f[D>>2]|0;if(E){F=E+12|0;f[F>>2]=(f[F>>2]|0)+1;F=i+36|0;E=f[F>>2]|0;if((E|0)!=0?(G=E+12|0,E=f[G>>2]|0,f[G>>2]=E+-1,(E|0)==1):0){_S(i);H=F}else H=F}else H=i+36|0;f[H>>2]=0;F=i+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[l>>2]|0)>0){E=f[m>>2]|0;G=0;do{f[E+(G<<2)>>2]=0;G=G+1|0;I=f[l>>2]|0}while((G|0)<(I|0));f[i>>2]=f[A>>2];if((I|0)<3)J=14;else J=16}else{f[i>>2]=f[A>>2];J=14}if((J|0)==14){G=f[b+12>>2]|0;if((G|0)<3){f[l>>2]=G;f[a>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];G=f[b+52>>2]|0;E=f[r>>2]|0;f[E>>2]=f[G>>2];f[E+4>>2]=f[G+4>>2]}else J=16}if((J|0)==16)ZS(i,A);f[F>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[H>>2]=f[D>>2];B=1;C=z}}else{do if((y|0)==42772){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){K=+p[b+176>>3];G=b+8|0;if((i|0)==(G|0)){B=0;C=K;break a}E=b+44|0;L=f[E>>2]|0;if(L){M=L+12|0;f[M>>2]=(f[M>>2]|0)+1;M=i+36|0;L=f[M>>2]|0;if((L|0)!=0?(N=L+12|0,L=f[N>>2]|0,f[N>>2]=L+-1,(L|0)==1):0){_S(i);O=M}else O=M}else O=i+36|0;f[O>>2]=0;M=i+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[l>>2]|0)>0){L=f[m>>2]|0;N=0;do{f[L+(N<<2)>>2]=0;N=N+1|0;P=f[l>>2]|0}while((N|0)<(P|0));f[i>>2]=f[G>>2];if((P|0)<3)J=36;else J=38}else{f[i>>2]=f[G>>2];J=36}if((J|0)==36){N=f[b+12>>2]|0;if((N|0)<3){f[l>>2]=N;f[a>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];N=f[b+52>>2]|0;L=f[r>>2]|0;f[L>>2]=f[N>>2];f[L+4>>2]=f[N+4>>2]}else J=38}if((J|0)==38)ZS(i,G);f[M>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[O>>2]=f[E>>2];B=0;C=K;break a}}while(0);ei[f[(f[y>>2]|0)+12>>2]&511](y,b,i,-1);B=0;C=1.0}while(0);b=f[c>>2]|0;b:do if((b|0)==42768){y=B|2;z=C*+p[c+176>>3];O=c+8|0;if((j|0)==(O|0)){Q=y;R=z}else{a=c+44|0;P=f[a>>2]|0;if(P|0){H=P+12|0;f[H>>2]=(f[H>>2]|0)+1}H=j+36|0;P=f[H>>2]|0;if(P|0?(I=P+12|0,P=f[I>>2]|0,f[I>>2]=P+-1,(P|0)==1):0)_S(j);f[H>>2]=0;P=j+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[s>>2]|0)>0){I=f[v>>2]|0;D=0;do{f[I+(D<<2)>>2]=0;D=D+1|0;S=f[s>>2]|0}while((D|0)<(S|0));f[j>>2]=f[O>>2];if((S|0)<3)J=53;else J=55}else{f[j>>2]=f[O>>2];J=53}if((J|0)==53){D=f[c+12>>2]|0;if((D|0)<3){f[s>>2]=D;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];D=f[c+52>>2]|0;I=f[x>>2]|0;f[I>>2]=f[D>>2];f[I+4>>2]=f[D+4>>2]}else J=55}if((J|0)==55)ZS(j,O);f[P>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[H>>2]=f[a>>2];Q=y;R=z}}else{do if((b|0)==42772){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){T=C*+p[c+176>>3];D=c+8|0;if((j|0)==(D|0)){Q=B;R=T;break b}I=c+44|0;F=f[I>>2]|0;if(F|0){A=F+12|0;f[A>>2]=(f[A>>2]|0)+1}A=j+36|0;F=f[A>>2]|0;if(F|0?(N=F+12|0,F=f[N>>2]|0,f[N>>2]=F+-1,(F|0)==1):0)_S(j);f[A>>2]=0;F=j+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[s>>2]|0)>0){N=f[v>>2]|0;L=0;do{f[N+(L<<2)>>2]=0;L=L+1|0;U=f[s>>2]|0}while((L|0)<(U|0));f[j>>2]=f[D>>2];if((U|0)<3)J=75;else J=77}else{f[j>>2]=f[D>>2];J=75}if((J|0)==75){L=f[c+12>>2]|0;if((L|0)<3){f[s>>2]=L;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];L=f[c+52>>2]|0;N=f[x>>2]|0;f[N>>2]=f[L>>2];f[N+4>>2]=f[L+4>>2]}else J=77}if((J|0)==77)ZS(j,D);f[F>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[A>>2]=f[I>>2];Q=B;R=T;break b}}while(0);ei[f[(f[b>>2]|0)+12>>2]&511](b,c,j,-1);Q=B;R=C}while(0);f[k>>2]=1124007936;B=k+4|0;c=k+8|0;b=k+40|0;n=B;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[b>>2]=c;c=k+48|0;n=k+44|0;f[n>>2]=c;f[c>>2]=0;f[k+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;dX(g,42776,Q,i,j,k,R,1.0,h);eX(d,g)|0;$j(g);g=k+36|0;d=f[g>>2]|0;if(d|0?(h=d+12|0,d=f[h>>2]|0,f[h>>2]=d+-1,(d|0)==1):0)_S(k);f[g>>2]=0;g=k+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[B>>2]|0)>0){g=f[b>>2]|0;b=0;do{f[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[B>>2]|0))}B=f[n>>2]|0;if((B|0)!=(c|0))g0(B);B=j+36|0;c=f[B>>2]|0;if(c|0?(n=c+12|0,c=f[n>>2]|0,f[n>>2]=c+-1,(c|0)==1):0)_S(j);f[B>>2]=0;B=j+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[s>>2]|0)>0){B=f[v>>2]|0;v=0;do{f[B+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[x>>2]|0;if((s|0)!=(w|0))g0(s);s=i+36|0;w=f[s>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)_S(i);f[s>>2]=0;s=i+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[l>>2]|0)>0){s=f[m>>2]|0;m=0;do{f[s+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)!=(q|0))g0(l);u=e;return}function $W(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+64|0;e=a;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=e+48|0;j=e+44|0;f[j>>2]=h;f[h>>2]=0;f[e+52>>2]=0;k=f[b>>2]|0;ei[f[(f[k>>2]|0)+12>>2]&511](k,b,e,-1);cX(d,c,e);c=e+36|0;d=f[c>>2]|0;if(d|0?(b=d+12|0,d=f[b>>2]|0,f[b>>2]=d+-1,(d|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[i>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[j>>2]|0;if((g|0)==(h|0)){u=a;return}g0(g);u=a;return}function aX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(f[c+24>>2]|0){b=f[c+12>>2]|0;if((b|0)<3)d=Y(f[c+20>>2]|0,f[c+16>>2]|0)|0;else{e=f[c+48>>2]|0;g=0;h=1;while(1){i=Y(f[e+(g<<2)>>2]|0,h)|0;g=g+1|0;if((g|0)==(b|0)){d=i;break}else h=i}}if(!((b|0)==0|(d|0)==0))j=c+48|0;else k=8}else k=8;do if((k|0)==8){if(f[c+80>>2]|0){d=f[c+68>>2]|0;if((d|0)<3)l=Y(f[c+76>>2]|0,f[c+72>>2]|0)|0;else{b=f[c+104>>2]|0;h=0;g=1;while(1){e=Y(f[b+(h<<2)>>2]|0,g)|0;h=h+1|0;if((h|0)==(d|0)){l=e;break}else g=e}}if(!((d|0)==0|(l|0)==0)){j=c+160|0;break}}j=c+104|0}while(0);c=f[j>>2]|0;j=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=j;return}function bX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=b+8|0;if(f[b+24>>2]|0){c=f[b+12>>2]|0;if((c|0)<3)d=Y(f[b+20>>2]|0,f[b+16>>2]|0)|0;else{e=f[b+48>>2]|0;g=0;h=1;while(1){i=Y(f[e+(g<<2)>>2]|0,h)|0;g=g+1|0;if((g|0)==(c|0)){d=i;break}else h=i}}if(!((c|0)==0|(d|0)==0)){j=a;k=f[j>>2]|0;l=k&4095;return l|0}}a=b+64|0;if(f[b+80>>2]|0){d=f[b+68>>2]|0;if((d|0)<3)m=Y(f[b+76>>2]|0,f[b+72>>2]|0)|0;else{c=f[b+104>>2]|0;h=0;g=1;while(1){e=Y(f[c+(h<<2)>>2]|0,g)|0;h=h+1|0;if((h|0)==(d|0)){m=e;break}else g=e}}if(!((d|0)==0|(m|0)==0)){j=b+120|0;k=f[j>>2]|0;l=k&4095;return l|0}}j=a;k=f[j>>2]|0;l=k&4095;return l|0}function cX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+368|0;e=d+32|0;g=d+312|0;h=d+256|0;i=d;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=h+48|0;m=h+44|0;f[m>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;dX(e,42408,b,c,g,h,1.0,0.0,i);eX(a,e)|0;$j(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[r>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))g0(p);p=g+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)_S(g);f[p>>2]=0;p=g+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}g0(j);u=d;return}function dX(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0.0,B=0;f[a>>2]=b;f[a+4>>2]=c;c=a+8|0;f[c>>2]=f[d>>2];b=a+12|0;k=d+4|0;f[b>>2]=f[k>>2];l=a+16|0;f[l>>2]=f[d+8>>2];f[a+20>>2]=f[d+12>>2];f[a+24>>2]=f[d+16>>2];f[a+28>>2]=f[d+20>>2];f[a+32>>2]=f[d+24>>2];f[a+36>>2]=f[d+28>>2];f[a+40>>2]=f[d+32>>2];m=f[d+36>>2]|0;f[a+44>>2]=m;f[a+48>>2]=l;l=a+56|0;n=a+52|0;f[n>>2]=l;f[l>>2]=0;f[a+60>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[d+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[b>>2]=0;ZS(c,d)}d=a+64|0;f[d>>2]=f[e>>2];c=a+68|0;b=e+4|0;f[c>>2]=f[b>>2];k=a+72|0;f[k>>2]=f[e+8>>2];f[a+76>>2]=f[e+12>>2];f[a+80>>2]=f[e+16>>2];f[a+84>>2]=f[e+20>>2];f[a+88>>2]=f[e+24>>2];f[a+92>>2]=f[e+28>>2];f[a+96>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[a+100>>2]=l;f[a+104>>2]=k;k=a+112|0;n=a+108|0;f[n>>2]=k;f[k>>2]=0;f[a+116>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[b>>2]|0)<3){b=f[e+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2]}else{f[c>>2]=0;ZS(d,e)}e=a+120|0;f[e>>2]=f[g>>2];d=a+124|0;c=g+4|0;f[d>>2]=f[c>>2];b=a+128|0;f[b>>2]=f[g+8>>2];f[a+132>>2]=f[g+12>>2];f[a+136>>2]=f[g+16>>2];f[a+140>>2]=f[g+20>>2];f[a+144>>2]=f[g+24>>2];f[a+148>>2]=f[g+28>>2];f[a+152>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[a+156>>2]=k;f[a+160>>2]=b;b=a+168|0;n=a+164|0;f[n>>2]=b;f[b>>2]=0;f[a+172>>2]=0;if(k|0){b=k+12|0;f[b>>2]=(f[b>>2]|0)+1}if((f[c>>2]|0)<3){c=f[g+44>>2]|0;b=f[n>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];o=a+176|0;p[o>>3]=h;q=a+184|0;p[q>>3]=i;r=+p[j>>3];s=a+192|0;p[s>>3]=r;t=j+8|0;u=+p[t>>3];v=a+200|0;p[v>>3]=u;w=j+16|0;x=+p[w>>3];y=a+208|0;p[y>>3]=x;z=j+24|0;A=+p[z>>3];B=a+216|0;p[B>>3]=A;return}else{f[d>>2]=0;ZS(e,g);o=a+176|0;p[o>>3]=h;q=a+184|0;p[q>>3]=i;r=+p[j>>3];s=a+192|0;p[s>>3]=r;t=j+8|0;u=+p[t>>3];v=a+200|0;p[v>>3]=u;w=j+16|0;x=+p[w>>3];y=a+208|0;p[y>>3]=x;z=j+24|0;A=+p[z>>3];B=a+216|0;p[B>>3]=A;return}}function eX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=b;d=f[c+4>>2]|0;e=a;f[e>>2]=f[c>>2];f[e+4>>2]=d;d=a+8|0;e=b+8|0;c=(a|0)==(b|0);if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}l=b+44|0;m=f[l>>2]|0;if(m|0){n=m+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+44|0;m=f[n>>2]|0;if(m|0?(o=m+12|0,m=f[o>>2]|0,f[o>>2]=m+-1,(m|0)==1):0)_S(d);f[n>>2]=0;m=a+24|0;o=a+12|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){p=f[a+48>>2]|0;q=0;do{f[p+(q<<2)>>2]=0;q=q+1|0;r=f[o>>2]|0}while((q|0)<(r|0));f[d>>2]=f[e>>2];if((r|0)<3)s=12;else s=14}else{f[d>>2]=f[e>>2];s=12}if((s|0)==12){r=f[b+12>>2]|0;if((r|0)<3){f[o>>2]=r;f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];r=f[b+52>>2]|0;o=f[a+52>>2]|0;f[o>>2]=f[r>>2];f[o+4>>2]=f[r+4>>2]}else s=14}if((s|0)==14)ZS(d,e);f[m>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];f[a+40>>2]=f[b+40>>2];f[n>>2]=f[l>>2];l=a+64|0;n=b+64|0;if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}m=b+100|0;e=f[m>>2]|0;if(e|0){d=e+12|0;f[d>>2]=(f[d>>2]|0)+1}d=a+100|0;e=f[d>>2]|0;if(e|0?(r=e+12|0,e=f[r>>2]|0,f[r>>2]=e+-1,(e|0)==1):0)_S(l);f[d>>2]=0;e=a+80|0;r=a+68|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[r>>2]|0)>0){o=f[a+104>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0;t=f[r>>2]|0}while((q|0)<(t|0));f[l>>2]=f[n>>2];if((t|0)<3)s=26;else s=28}else{f[l>>2]=f[n>>2];s=26}if((s|0)==26){t=f[b+68>>2]|0;if((t|0)<3){f[r>>2]=t;f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];t=f[b+108>>2]|0;r=f[a+108>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2]}else s=28}if((s|0)==28)ZS(l,n);f[e>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];f[a+92>>2]=f[b+92>>2];f[a+96>>2]=f[b+96>>2];f[d>>2]=f[m>>2];m=a+120|0;d=b+120|0;if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}c=b+156|0;e=f[c>>2]|0;if(e|0){n=e+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+156|0;e=f[n>>2]|0;if(e|0?(l=e+12|0,e=f[l>>2]|0,f[l>>2]=e+-1,(e|0)==1):0)_S(m);f[n>>2]=0;e=a+136|0;l=a+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[l>>2]|0)>0){t=f[a+160>>2]|0;r=0;do{f[t+(r<<2)>>2]=0;r=r+1|0;u=f[l>>2]|0}while((r|0)<(u|0));f[m>>2]=f[d>>2];if((u|0)<3)s=40;else s=42}else{f[m>>2]=f[d>>2];s=40}if((s|0)==40){u=f[b+124>>2]|0;if((u|0)<3){f[l>>2]=u;f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];u=f[b+164>>2]|0;l=f[a+164>>2]|0;f[l>>2]=f[u>>2];f[l+4>>2]=f[u+4>>2]}else s=42}if((s|0)==42)ZS(m,d);f[e>>2]=f[b+136>>2];f[a+140>>2]=f[b+140>>2];f[a+144>>2]=f[b+144>>2];f[a+148>>2]=f[b+148>>2];f[a+152>>2]=f[b+152>>2];f[n>>2]=f[c>>2];g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}function fX(a){a=a|0;YDc(a);return}function gX(a,b){a=a|0;b=b|0;return 0}function hX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+96|0;e=a+32|0;g=a+16|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)n=e;else n=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=n;+fQ(g,h,f[b+4>>2]|0);if((f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;LZ(n,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)_S(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function iX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[c>>2]|0;if((f[b>>2]|0)==42408&(e|0)==42528){jX(d,f[b+4>>2]|0,b+8|0,c+8|0);return}if((a|0)==(e|0)){_W(e,b,c,d);return}else{ei[f[(f[e>>2]|0)+92>>2]&511](e,b,c,d);return}}function jX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+320|0;g=e+32|0;h=e+256|0;i=e;f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=h+48|0;m=h+44|0;f[m>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;dX(g,42532,b,c,d,h,1.0,1.0,i);eX(a,g)|0;$j(g);g=h+36|0;a=f[g>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[j>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=e;return}g0(j);u=e;return}function kX(a){a=a|0;YDc(a);return}function lX(a,b){a=a|0;b=b|0;return 0}function mX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)o=e;else o=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;n=i+8|0;f[n>>2]=0;f[n+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;oQ(g,h,i,f[b+4>>2]|0)|0;if((f[o+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;LZ(o,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)_S(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[l>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}g0(j);u=a;return}function nX(a){a=a|0;YDc(a);return}function oX(a,b){a=a|0;b=b|0;return 1}function pX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+16|0;g=a;h=c+8|0;if((e|0)!=-1?(i=f[h>>2]|0,(i&4095|0)!=(e|0)):0){if((i^e)&4088|0){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,34)|0;j=219063;k=i+34|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,g,224211,219098,1201)}j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=d;LZ(h,g,e,1.0,0.0);u=a;return}if((h|0)==(d|0)){u=a;return}e=c+44|0;g=f[e>>2]|0;if(g|0){j=g+12|0;f[j>>2]=(f[j>>2]|0)+1}j=d+36|0;g=f[j>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)_S(d);f[j>>2]=0;g=d+16|0;i=d+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){k=f[d+40>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;m=f[i>>2]|0}while((l|0)<(m|0));f[d>>2]=f[c+8>>2];if((m|0)<3)n=14;else n=16}else{f[d>>2]=f[c+8>>2];n=14}if((n|0)==14){m=f[c+12>>2]|0;if((m|0)<3){f[i>>2]=m;f[d+8>>2]=f[c+16>>2];f[d+12>>2]=f[c+20>>2];m=f[c+52>>2]|0;i=f[d+44>>2]|0;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2]}else n=16}if((n|0)==16)ZS(d,h);f[g>>2]=f[c+24>>2];f[d+20>>2]=f[c+28>>2];f[d+24>>2]=f[c+32>>2];f[d+28>>2]=f[c+36>>2];f[d+32>>2]=f[c+40>>2];f[j>>2]=f[e>>2];u=a;return}function qX(a){a=a|0;YDc(a);return}function rX(a,b){a=a|0;b=b|0;return 0}function sX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0;a=u;u=u+128|0;e=a+64|0;g=a+48|0;h=a+32|0;i=a+16|0;j=a;f[e>>2]=1124007936;k=e+4|0;l=e+8|0;m=e+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=e+48|0;n=e+44|0;f[n>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)q=e;else q=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;r=+p[b+176>>3];f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b+120;s=+p[b+184>>3];o=j+8|0;f[o>>2]=0;f[o+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=q;MN(g,h,r,i,s,j,f[b+4>>2]|0);if((f[q+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;LZ(q,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)_S(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[m>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=a;return}g0(k);u=a;return}function tX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0;e=u;u=u+256|0;g=e+32|0;h=e;i=f[b>>2]|0;j=(i|0)==42528;k=f[c>>2]|0;l=(k|0)==42528;m=j?1.0:+p[b+176>>3];n=l?1.0:+p[c+176>>3];o=+p[b+184>>3];a:do if(!((i|0)!=42776|(f[b+136>>2]|0)!=0&o!=0.0)){do if(!l){if((k|0)!=42772)if((k|0)==42768)break;else break a;if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break a;if(!(+p[c+192>>3]==0.0))break a;if(!(+p[c+200>>3]==0.0))break a;if(!(+p[c+208>>3]==0.0))break a;if(!(+p[c+216>>3]==0.0))break a}while(0);q=((k|0)==42768?4:0)|f[b+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;dX(g,42776,q,b+8|0,b+64|0,c+8|0,m,n,h);eX(d,g)|0;$j(g);u=e;return}while(0);b:do if(!((k|0)!=42776|(f[c+136>>2]|0?+p[c+184>>3]!=0.0:0))){do if(!j){if((i|0)!=42772)if((i|0)==42768)break;else break b;if(!((f[b+80>>2]|0)==0|o==0.0))break b;if(!(+p[b+192>>3]==0.0))break b;if(!(+p[b+200>>3]==0.0))break b;if(!(+p[b+208>>3]==0.0))break b;if(!(+p[b+216>>3]==0.0))break b}while(0);l=((i|0)==42768?4:0)|f[c+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;dX(g,42776,l,c+8|0,c+64|0,b+8|0,n,m,h);eX(d,g)|0;$j(g);u=e;return}while(0);if((a|0)==(k|0)){QW(k,b,c,d);u=e;return}else{ei[f[(f[k>>2]|0)+52>>2]&511](k,b,c,d);u=e;return}}function uX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0;e=u;u=u+256|0;g=e+32|0;h=e;i=f[b>>2]|0;j=(i|0)==42528;k=f[c>>2]|0;l=(k|0)==42528;m=j?1.0:+p[b+176>>3];n=l?1.0:+p[c+176>>3];o=+p[b+184>>3];a:do if(!((i|0)!=42776|(f[b+136>>2]|0)!=0&o!=0.0)){do if(!l){if((k|0)!=42772)if((k|0)==42768)break;else break a;if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break a;if(!(+p[c+192>>3]==0.0))break a;if(!(+p[c+200>>3]==0.0))break a;if(!(+p[c+208>>3]==0.0))break a;if(!(+p[c+216>>3]==0.0))break a}while(0);q=((k|0)==42768?4:0)|f[b+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;dX(g,42776,q,b+8|0,b+64|0,c+8|0,m,-n,h);eX(d,g)|0;$j(g);u=e;return}while(0);b:do if(!((k|0)!=42776|(f[c+136>>2]|0?+p[c+184>>3]!=0.0:0))){do if(!j){if((i|0)!=42772)if((i|0)==42768)break;else break b;if(!((f[b+80>>2]|0)==0|o==0.0))break b;if(!(+p[b+192>>3]==0.0))break b;if(!(+p[b+200>>3]==0.0))break b;if(!(+p[b+208>>3]==0.0))break b;if(!(+p[b+216>>3]==0.0))break b}while(0);l=((i|0)==42768?4:0)|f[c+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;dX(g,42776,l,c+8|0,c+64|0,b+8|0,-n,m,h);eX(d,g)|0;$j(g);u=e;return}while(0);if((a|0)==(k|0)){SW(k,b,c,d);u=e;return}else{ei[f[(f[k>>2]|0)+60>>2]&511](k,b,c,d);u=e;return}}function vX(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;eX(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;b=d+184|0;p[b>>3]=+p[b>>3]*c;return}function wX(a,b,c){a=a|0;b=b|0;c=c|0;eX(c,b)|0;a=f[b+4>>2]|0;f[c+4>>2]=(a<<1&2|a&4|a>>>1&1)^7;bR(c+8|0,c+64|0);return}function xX(a){a=a|0;YDc(a);return}function yX(a,b){a=a|0;b=b|0;return 1}function zX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,v=0,w=0.0,x=0.0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)o=e;else o=c;n=b+64|0;q=b+192|0;a:do if(!(f[b+80>>2]|0)){do if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){r=+p[b+176>>3];if((f[o+16>>2]|0)==(f[c+16>>2]|0)?!(+L(+r)!=1.0):0)break;s=g+8|0;f[s>>2]=0;f[s+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;LZ(b+8|0,g,d,r,+p[q>>3]);break a}while(0);r=+p[b+176>>3];if(r==1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;mL(g,h,i,e0()|0,-1);t=38;break}if(r==-1.0){f[g>>2]=-1056833530;f[g+4>>2]=q;f[g+8>>2]=1;f[g+12>>2]=4;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;oL(g,h,i,e0()|0,-1);t=38;break}else{s=b+8|0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o;LZ(s,g,f[s>>2]&4095,r,0.0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=o;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;mL(g,h,i,e0()|0,-1);t=38;break}}else{r=+p[q>>3];w=+p[b+200>>3];if(r==0.0&w==0.0?+p[b+208>>3]==0.0:0){if(w==0.0?+p[b+216>>3]!=0.0:0)t=9}else t=8;if((t|0)==8?w==0.0:0)t=9;if(((t|0)==9?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;w=+p[b+176>>3];f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;x=+p[b+184>>3];s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;tL(g,w,h,x,r,i,-1);t=38;break}r=+p[b+176>>3];x=+p[b+184>>3];s=x==1.0;do if(r==1.0){if(s){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;mL(g,h,i,e0()|0,-1);break}if(x==-1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;oL(g,h,i,e0()|0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=n;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;dO(g,x,h,i);break}}else{if(!s){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;tL(g,r,h,x,0.0,i,-1);break}if(r==-1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=n;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;oL(g,h,i,e0()|0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;dO(g,r,h,i);break}}while(0);if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){t=38;break}f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=o;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;mL(g,h,i,e0()|0,-1);t=38}while(0);if((t|0)==38?(f[o+16>>2]|0)!=(f[c+16>>2]|0):0){t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;LZ(o,g,f[c>>2]&4095,1.0,0.0)}c=e+36|0;g=f[c>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[j>>2]|0)>0){c=f[l>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}g0(j);u=a;return}function AX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;eX(d,b)|0;b=d+192|0;p[b>>3]=+p[c>>3]+ +p[b>>3];b=d+200|0;p[b>>3]=+p[c+8>>3]+ +p[b>>3];b=d+208|0;p[b>>3]=+p[c+16>>3]+ +p[b>>3];b=d+216|0;p[b>>3]=+p[c+24>>3]+ +p[b>>3];return}function BX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0.0,h=0,i=0.0;eX(d,c)|0;c=d+176|0;p[c>>3]=-+p[c>>3];c=d+184|0;p[c>>3]=-+p[c>>3];c=d+192|0;a=d+200|0;e=+p[b+8>>3]-+p[a>>3];f=d+208|0;g=+p[b+16>>3]-+p[f>>3];h=d+216|0;i=+p[b+24>>3]-+p[h>>3];p[c>>3]=+p[b>>3]-+p[c>>3];p[a>>3]=e;p[f>>3]=g;p[h>>3]=i;return}function CX(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;eX(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;b=d+184|0;p[b>>3]=+p[b>>3]*c;b=d+192|0;p[b>>3]=+p[b>>3]*c;b=d+200|0;p[b>>3]=+p[b>>3]*c;b=d+208|0;p[b>>3]=+p[b>>3]*c;b=d+216|0;p[b>>3]=+p[b>>3]*c;return}function DX(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;e=a;do if((f[c>>2]|0)==42772){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){g=c+8|0;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;k=e+48|0;l=e+44|0;f[l>>2]=k;f[k>>2]=0;f[e+52>>2]=0;IX(d,47,g,e,b/+p[c+176>>3]);m=e+36|0;n=f[m>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)_S(e);f[m>>2]=0;m=e+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[h>>2]|0)>0){m=f[j>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[h>>2]|0))}h=f[l>>2]|0;if((h|0)!=(k|0))g0(h);u=a;return}}while(0);XW(0,b,c,d);u=a;return}function EX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0;a=u;u=u+32|0;d=a;e=b+64|0;g=(f[b+80>>2]|0)!=0;if(g?(h=+p[b+184>>3],!(h==0.0)):0){i=h;j=+p[b+176>>3];k=8}else k=4;do if((k|0)==4){h=+p[b+176>>3];if(+L(+h)==1.0){l=-(+p[b+200>>3]*h);m=-(+p[b+208>>3]*h);n=-(+p[b+216>>3]*h);p[d>>3]=-(+p[b+192>>3]*h);p[d+8>>3]=l;p[d+16>>3]=m;p[d+24>>3]=n;HX(c,97,b+8|0,d);u=a;return}else{if(!g)break;i=+p[b+184>>3];j=h;k=8;break}}while(0);if((k|0)==8?j+i==0.0&j*i==-1.0:0){IX(c,97,b+8|0,e,1.0);u=a;return}YW(0,b,c);u=a;return}function FX(a,b,c){a=a|0;b=b|0;c=c|0;do if((f[b>>2]|0)==42772){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){GX(c,b+8|0,+p[b+176>>3]);return}}while(0);ZW(0,b,c);return}function GX(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+368|0;e=d+32|0;g=d+312|0;h=d+256|0;i=d;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=h+48|0;m=h+44|0;f[m>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;dX(e,42768,0,b,g,h,c,0.0,i);eX(a,e)|0;$j(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[r>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))g0(p);p=g+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)_S(g);f[p>>2]=0;p=g+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}g0(j);u=d;return}function HX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+336|0;g=e;h=e+280|0;i=e+224|0;f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=h+48|0;o=h+44|0;f[o>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;p=i+4|0;q=i+8|0;r=i+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=i+48|0;m=i+44|0;f[m>>2]=q;f[q>>2]=0;f[i+52>>2]=0;dX(g,43012,b<<24>>24,c,h,i,1.0,0.0,d);eX(a,g)|0;$j(g);g=i+36|0;a=f[g>>2]|0;if(a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)_S(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[p>>2]|0)>0){g=f[r>>2]|0;r=0;do{f[g+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))g0(p);p=h+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)_S(h);f[p>>2]=0;p=h+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=e;return}g0(j);u=e;return}function IX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+320|0;h=g+32|0;i=g+256|0;j=g;f[i>>2]=1124007936;k=i+4|0;l=i+8|0;m=i+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=i+48|0;n=i+44|0;f[n>>2]=l;f[l>>2]=0;f[i+52>>2]=0;o=f[d+16>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;dX(h,43012,b<<24>>24,c,d,i,e,+((o|0)!=0&1),j);eX(a,h)|0;$j(h);h=i+36|0;a=f[h>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)_S(i);f[h>>2]=0;h=i+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[m>>2]|0;m=0;do{f[h+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=g;return}g0(k);u=g;return}function JX(a){a=a|0;YDc(a);return}function KX(a,b){a=a|0;b=b|0;return 1}function LX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0;a=u;u=u+112|0;g=a+48|0;h=a+32|0;i=a+16|0;j=a;f[g>>2]=1124007936;k=g+4|0;l=g+8|0;m=g+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=g+48|0;q=g+44|0;f[q>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if((e|0)!=-1?(f[c+8>>2]&4095|0)!=(e|0):0)r=g;else r=d;a:do switch(f[c+4>>2]|0){case 42:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;qL(h,i,j,+p[c+176>>3],-1);break}case 47:{if(!(f[c+80>>2]|0)){t=+p[c+176>>3];f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;sL(t,h,i,-1);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;rL(h,i,j,+p[c+176>>3],-1);break a}break}case 38:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;dL(h,i,j,e0()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;dL(h,i,j,e0()|0);break a}break}case 124:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;fL(h,i,j,e0()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;fL(h,i,j,e0()|0);break a}break}case 94:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;gL(h,i,j,e0()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;gL(h,i,j,e0()|0);break a}break}case 126:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;hL(h,i,e0()|0);break a}else{f[h>>2]=0;v=h+4|0;f[v>>2]=0;w=tT(h,17)|0;n=w;x=219235;o=n+17|0;do{b[n>>0]=b[x>>0]|0;n=n+1|0;x=x+1|0}while((n|0)<(o|0));z5(-2,h,224211,219098,1371)}break}case 109:{lL(c+8|0,c+64|0,r);break}case 110:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=1;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;jL(h,i,j);break}case 77:{kL(c+8|0,c+64|0,r);break}case 78:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=1;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;iL(h,i,j);break}case 97:{if(f[c+80>>2]|0){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;pL(h,i,j);break a}if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;pL(h,i,j);break a}else{f[h>>2]=0;v=h+4|0;f[v>>2]=0;w=tT(h,17)|0;n=w;x=219235;o=n+17|0;do{b[n>>0]=b[x>>0]|0;n=n+1|0;x=x+1|0}while((n|0)<(o|0));z5(-2,h,224211,219098,1371)}break}default:{f[h>>2]=0;v=h+4|0;f[v>>2]=0;w=tT(h,17)|0;n=w;x=219235;o=n+17|0;do{b[n>>0]=b[x>>0]|0;n=n+1|0;x=x+1|0}while((n|0)<(o|0));z5(-2,h,224211,219098,1371)}}while(0);if((f[r+16>>2]|0)!=(f[d+16>>2]|0)){x=h+8|0;f[x>>2]=0;f[x+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;LZ(r,h,e,1.0,0.0)}e=g+36|0;h=f[e>>2]|0;if(h|0?(r=h+12|0,h=f[r>>2]|0,f[r>>2]=h+-1,(h|0)==1):0)_S(g);f[e>>2]=0;e=g+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[k>>2]|0)>0){e=f[m>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[q>>2]|0;if((k|0)==(l|0)){u=a;return}g0(k);u=a;return}function MX(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;switch(f[b+4>>2]|0){case 47:case 42:{eX(d,b)|0;a=d+176|0;p[a>>3]=+p[a>>3]*c;return}default:{VW(0,b,c,d);return}}}function NX(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0;a=u;u=u+96|0;e=a+32|0;g=a;do if((f[c+4>>2]|0)==47){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;k=e+48|0;l=e+44|0;f[l>>2]=k;f[k>>2]=0;f[e+52>>2]=0;m=+p[c+176>>3];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;OX(d,c+8|0,e,b/m,0.0,g);n=e+36|0;o=f[n>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)_S(e);f[n>>2]=0;n=e+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[h>>2]|0)>0){n=f[j>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[h>>2]|0))}h=f[l>>2]|0;if((h|0)!=(k|0))g0(h);u=a;return}while(0);XW(0,b,c,d);u=a;return}function OX(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+288|0;i=h;j=h+224|0;f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=j+48|0;n=j+44|0;f[n>>2]=l;f[l>>2]=0;f[j+52>>2]=0;dX(i,42772,0,b,c,j,d,e,g);eX(a,i)|0;$j(i);i=j+36|0;a=f[i>>2]|0;if(a|0?(g=a+12|0,a=f[g>>2]|0,f[g>>2]=a+-1,(a|0)==1):0)_S(j);f[i>>2]=0;i=j+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[k>>2]|0)>0){i=f[m>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=h;return}g0(k);u=h;return}function PX(a){a=a|0;YDc(a);return}function QX(a,b){a=a|0;b=b|0;return 0}function RX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0;a=u;u=u+96|0;e=a+32|0;g=a+16|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)n=e;else n=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=n;jR(g,h);o=+p[b+176>>3];if(o!=1.0?1:(f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;LZ(n,g,d,o,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)_S(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}g0(i);u=a;return}function SX(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;eX(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;return}function TX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0,k=0,l=0;a=u;u=u+96|0;d=a+32|0;e=a;g=+p[b+176>>3];h=b+8|0;if(g==1.0){UX(c,h);u=a;return}f[d>>2]=1124007936;b=d+4|0;i=d+8|0;j=d+40|0;k=b;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=d+48|0;k=d+44|0;f[k>>2]=i;f[i>>2]=0;f[d+52>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;OX(c,h,d,g,0.0,e);e=d+36|0;h=f[e>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)_S(d);f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[j>>2]|0;j=0;do{f[e+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[b>>2]|0))}b=f[k>>2]|0;if((b|0)!=(i|0))g0(b);u=a;return}function UX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+368|0;d=c+32|0;e=c+312|0;g=c+256|0;h=c;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;n=e+44|0;f[n>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;l=o;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[q>>2]=p;p=g+48|0;l=g+44|0;f[l>>2]=p;f[p>>2]=0;f[g+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;dX(d,42528,0,b,e,g,1.0,0.0,h);eX(a,d)|0;$j(d);d=g+36|0;a=f[d>>2]|0;if(a|0?(h=a+12|0,a=f[h>>2]|0,f[h>>2]=a+-1,(a|0)==1):0)_S(g);f[d>>2]=0;d=g+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[o>>2]|0)>0){d=f[q>>2]|0;q=0;do{f[d+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[l>>2]|0;if((o|0)!=(p|0))g0(o);o=e+36|0;p=f[o>>2]|0;if(p|0?(l=p+12|0,p=f[l>>2]|0,f[l>>2]=p+-1,(p|0)==1):0)_S(e);f[o>>2]=0;o=e+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[i>>2]|0)>0){o=f[k>>2]|0;k=0;do{f[o+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)==(j|0)){u=c;return}g0(i);u=c;return}function VX(a){a=a|0;YDc(a);return}function WX(a,b){a=a|0;b=b|0;return 1}function XX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;n=(d|0)==-1|(d|0)==0?c:e;if(!(f[b+80>>2]|0)){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h>>2]=-1056833530;f[h+4>>2]=b+176;f[h+8>>2]=1;f[h+12>>2]=1;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;uL(g,h,i,f[b+4>>2]|0)}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;uL(g,h,i,f[b+4>>2]|0)}if((f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;LZ(n,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)_S(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[l>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}g0(j);u=a;return}function YX(a){a=a|0;YDc(a);return}function ZX(a,b){a=a|0;b=b|0;return 0}function _X(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+64|0;g=a+32|0;h=a;i=(e|0)==-1?f[c+8>>2]&4095:e;e=c+12|0;j=f[e>>2]|0;k=f[c+48>>2]|0;do if((j|0)<3){l=f[k+4>>2]|0;m=f[k>>2]|0;n=i&4095;if(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(m|0):0)?(f[d+12>>2]|0)==(l|0):0)?(f[d>>2]&4095|0)==(n|0):0)?f[d+16>>2]|0:0)break;f[g>>2]=m;f[g+4>>2]=l;XS(d,2,g,n)}else XS(d,j,k,i);while(0);i=f[c+4>>2]|0;if((i|0)==73&(f[e>>2]|0)<3){e=g+8|0;f[e>>2]=0;f[e+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=d;p[h>>3]=+p[c+176>>3];e=h+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;hR(g,h);u=a;return}switch(i|0){case 48:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;k_(d,g)|0;u=a;return}case 49:{p[g>>3]=+p[c+176>>3];c=g+8|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;k_(d,g)|0;u=a;return}default:{f[g>>2]=0;f[g+4>>2]=0;a=tT(g,31)|0;d=219330;c=a+31|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(c|0));z5(-2,g,224211,219098,1606)}}}function $X(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;eX(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;return}function aY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=42528;f[a+4>>2]=0;c=a+8|0;f[c>>2]=f[b>>2];d=a+12|0;e=b+4|0;f[d>>2]=f[e>>2];g=a+16|0;f[g>>2]=f[b+8>>2];f[a+20>>2]=f[b+12>>2];f[a+24>>2]=f[b+16>>2];f[a+28>>2]=f[b+20>>2];f[a+32>>2]=f[b+24>>2];f[a+36>>2]=f[b+28>>2];f[a+40>>2]=f[b+32>>2];h=f[b+36>>2]|0;f[a+44>>2]=h;f[a+48>>2]=g;g=a+56|0;i=a+52|0;f[i>>2]=g;f[g>>2]=0;f[a+60>>2]=0;if(h|0){g=h+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[e>>2]|0)<3){e=f[b+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2]}else{f[d>>2]=0;ZS(c,b)}f[a+64>>2]=1124007936;b=a+72|0;c=a+104|0;d=a+68|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+112|0;f[a+108>>2]=b;f[b>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;b=a+128|0;c=a+160|0;d=a+124|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+168|0;f[a+164>>2]=b;f[b>>2]=0;f[a+172>>2]=0;p[a+176>>3]=1.0;d=a+184|0;e=d+40|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}function bY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ei[f[(f[g>>2]|0)+96>>2]&511](g,b,c,a);return}function cY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;OX(a,c,e,1.0,0.0,b);b=e+36|0;c=f[b>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)_S(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[g>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}g0(g);u=d;return}function dY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ei[f[(f[g>>2]|0)+56>>2]&511](g,b,c,a);return}function eY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ei[f[(f[g>>2]|0)+52>>2]&511](g,b,c,a);return}function fY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;OX(a,b,c,1.0,-1.0,e);u=d;return}function gY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;OX(a,c,e,-1.0,0.0,b);b=e+36|0;c=f[b>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)_S(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[g>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}g0(g);u=d;return}function hY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+224|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));i=f[b>>2]|0;j=f[(f[i>>2]|0)+60>>2]|0;aY(e,c);ei[j&511](i,b,e,a);$j(e);u=d;return}function iY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));i=f[b>>2]|0;j=f[(f[i>>2]|0)+56>>2]|0;k=-+p[c+8>>3];l=-+p[c+16>>3];m=-+p[c+24>>3];p[e>>3]=-+p[c>>3];p[e+8>>3]=k;p[e+16>>3]=l;p[e+24>>3]=m;ei[j&511](i,b,e,a);u=d;return}function jY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ei[f[(f[g>>2]|0)+60>>2]&511](g,b,c,a);return}function kY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+96|0;d=c+32|0;e=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[d>>2]=1124007936;g=d+4|0;h=d+8|0;k=d+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=d+48|0;i=d+44|0;f[i>>2]=h;f[h>>2]=0;f[d+52>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;OX(a,b,d,-1.0,0.0,e);e=d+36|0;b=f[e>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)_S(d);f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[k>>2]|0;k=0;do{f[e+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=c;return}g0(g);u=c;return}function lY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;e=a+16|0;g=a+48|0;h=a+12|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+56|0;f[a+52>>2]=e;f[e>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;e=a+72|0;g=a+104|0;h=a+68|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+112|0;f[a+108>>2]=e;f[e>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;e=a+128|0;g=a+160|0;h=a+124|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+168|0;f[a+164>>2]=e;h=e;i=h+56|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));h=f[b>>2]|0;i=f[(f[h>>2]|0)+64>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;ei[i&511](h,d,b,a);u=c;return}function mY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+320|0;e=d+32|0;g=d;h=d+256|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=1124007936;i=h+4|0;j=h+8|0;m=h+40|0;k=i;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[m>>2]=j;j=h+48|0;k=h+44|0;f[k>>2]=j;f[j>>2]=0;f[h+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;dX(e,42776,0,b,c,h,1.0,1.0,g);eX(a,e)|0;$j(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(g=a+12|0,a=f[g>>2]|0,f[g>>2]=a+-1,(a|0)==1):0)_S(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[i>>2]|0)>0){e=f[m>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[i>>2]|0))}i=f[k>>2]|0;if((i|0)==(j|0)){u=d;return}g0(i);u=d;return}function nY(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+96|0;e=d+32|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[e>>2]=1124007936;h=e+4|0;i=e+8|0;l=e+40|0;j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[l>>2]=i;i=e+48|0;j=e+44|0;f[j>>2]=i;f[i>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;OX(a,b,e,c,0.0,g);g=e+36|0;b=f[g>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)_S(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)==(i|0)){u=d;return}g0(h);u=d;return}function oY(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+96|0;e=d+32|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[e>>2]=1124007936;h=e+4|0;i=e+8|0;l=e+40|0;j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[l>>2]=i;i=e+48|0;j=e+44|0;f[j>>2]=i;f[i>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;OX(a,c,e,b,0.0,g);g=e+36|0;c=f[g>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)_S(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)==(i|0)){u=d;return}g0(h);u=d;return}function pY(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ri[f[(f[g>>2]|0)+72>>2]&15](g,b,c,a);return}function qY(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;IX(a,47,c,e,b);c=e+36|0;a=f[c>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}g0(g);u=d;return}function rY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+368|0;g=e+32|0;h=e+312|0;i=e+256|0;j=e;f[h>>2]=1124007936;k=h+4|0;l=h+8|0;m=h+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=h+48|0;p=h+44|0;f[p>>2]=l;f[l>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;q=i+4|0;r=i+8|0;s=i+40|0;n=q;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[s>>2]=r;r=i+48|0;n=i+44|0;f[n>>2]=r;f[r>>2]=0;f[i+52>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;dX(g,43480,b,c,h,i,d,1.0,j);eX(a,g)|0;$j(g);g=i+36|0;a=f[g>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)_S(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[n>>2]|0;if((q|0)!=(r|0))g0(q);q=h+36|0;r=f[q>>2]|0;if(r|0?(n=r+12|0,r=f[n>>2]|0,f[n>>2]=r+-1,(r|0)==1):0)_S(h);f[q>>2]=0;q=h+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[k>>2]|0)>0){q=f[m>>2]|0;m=0;do{f[q+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[p>>2]|0;if((k|0)==(l|0)){u=e;return}g0(k);u=e;return}function sY(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));rY(a,0,b,c);return}function tY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));IX(a,38,b,c,1.0);return}function uY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;e=a+16|0;g=a+48|0;h=a+12|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+56|0;f[a+52>>2]=e;f[e>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;e=a+72|0;g=a+104|0;h=a+68|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+112|0;f[a+108>>2]=e;f[e>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;e=a+128|0;g=a+160|0;h=a+124|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+168|0;f[a+164>>2]=e;h=e;i=h+56|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;HX(a,97,b,d);u=c;return}function vY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[b>>2]|0;if((c|0)==42768|(c|0)==42408){d=f[b+20>>2]|0;f[a>>2]=f[b+16>>2];f[a+4>>2]=d;return}if((c|0)==42776){d=f[b+16>>2]|0;f[a>>2]=f[b+76>>2];f[a+4>>2]=d;return}if((c|0)==42532){d=f[b+20>>2]|0;f[a>>2]=f[b+76>>2];f[a+4>>2]=d;return}if(!(f[132547]|0)){d=H5()|0;m6(d);if(!(f[132547]|0)){e=VDc(4)|0;f[e>>2]=43372;f[132547]=e}n6(d)}if((f[132547]|0)==(c|0)){c=f[b+48>>2]|0;d=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=d;return}d=f[b>>2]|0;if(!d){f[a>>2]=0;f[a+4>>2]=0;return}else{Ti[f[(f[d>>2]|0)+100>>2]&511](a,d,b);return}}function wY(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(!(f[132547]|0)){c=H5()|0;m6(c);if(!(f[132547]|0)){d=VDc(4)|0;f[d>>2]=43372;f[132547]=d}n6(c)}if((f[132547]|0)==(b|0)){e=f[a+8>>2]&4095;return e|0}b=f[a>>2]|0;if((b|0)==43480){e=0;return e|0}if(!b){e=-1;return e|0}e=Mi[f[(f[b>>2]|0)+104>>2]&1023](b,a)|0;return e|0}function xY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;c=a+16|0;d=a+48|0;e=a+12|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+56|0;f[a+52>>2]=c;f[c>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;c=a+72|0;d=a+104|0;e=a+68|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+112|0;f[a+108>>2]=c;f[c>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;c=a+128|0;d=a+160|0;e=a+124|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+168|0;f[a+164>>2]=c;e=c;g=e+56|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));GX(a,b,1.0);return}function yY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));cX(a,c,b);return}function zY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+224|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((d$(c)|0)==393216){j=f[c+4>>2]|0;k=f[j>>2]|0;h=f[(f[k>>2]|0)+68>>2]|0;aY(g,b);ni[h&31](k,g,j,a,d);$j(g);u=e;return}do if((d$(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;h=j+4|0;f[k>>2]=f[h>>2];i=g+8|0;f[i>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];l=f[j+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=i;i=g+48|0;m=g+44|0;f[m>>2]=i;f[i>>2]=0;f[g+52>>2]=0;if(l|0){i=l+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[h>>2]|0)<3){h=f[j+44>>2]|0;i=f[m>>2]|0;f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];break}else{f[k>>2]=0;ZS(g,j);break}}else a$(g,c,-1);while(0);IX(a,42,b,g,d);b=g+36|0;a=f[b>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)_S(g);f[b>>2]=0;b=g+16|0;a=g+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[a>>2]|0)>0){b=f[g+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))g0(a);u=e;return}function AY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=c;f[g+4>>2]=b;BY(a,48,g,d,1.0);u=e;return}function BY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+432|0;h=g+32|0;i=g+376|0;j=g+312|0;k=g+320|0;l=g+256|0;m=g;if(!(f[132547]|0)){n=H5()|0;m6(n);if(!(f[132547]|0)){o=VDc(4)|0;f[o>>2]=43372;f[132547]=o}n6(n)}n=f[132547]|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];CY(i,j,d,-286331154,0);f[k>>2]=1124007936;d=k+4|0;j=k+8|0;c=k+40|0;o=d;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[c>>2]=j;j=k+48|0;q=k+44|0;f[q>>2]=j;f[j>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;r=l+4|0;s=l+8|0;t=l+40|0;o=r;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[t>>2]=s;s=l+48|0;o=l+44|0;f[o>>2]=s;f[s>>2]=0;f[l+52>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;dX(h,n,b,i,k,l,e,0.0,m);eX(a,h)|0;$j(h);h=l+36|0;a=f[h>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)_S(l);f[h>>2]=0;h=l+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[r>>2]|0)>0){h=f[t>>2]|0;t=0;do{f[h+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[o>>2]|0;if((r|0)!=(s|0))g0(r);r=k+36|0;s=f[r>>2]|0;if(s|0?(o=s+12|0,s=f[o>>2]|0,f[o>>2]=s+-1,(s|0)==1):0)_S(k);f[r>>2]=0;r=k+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[d>>2]|0)>0){r=f[c>>2]|0;c=0;do{f[r+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[q>>2]|0;if((d|0)!=(j|0))g0(d);d=i+36|0;j=f[d>>2]|0;if(j|0?(q=j+12|0,j=f[q>>2]|0,f[q>>2]=j+-1,(j|0)==1):0)_S(i);f[d>>2]=0;d=i+16|0;j=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[i+40>>2]|0;q=0;do{f[d+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=g;return}g0(j);u=g;return}function CY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;i=h;f[a>>2]=d&4095|1124007936;f[a+4>>2]=2;j=a+8|0;k=f[c+4>>2]|0;f[j>>2]=k;l=f[c>>2]|0;f[a+12>>2]=l;f[a+16>>2]=e;f[a+20>>2]=e;c=a+24|0;m=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[a+40>>2]=j;j=a+48|0;f[a+44>>2]=j;f[a+52>>2]=0;f[j>>2]=0;if((Y(l,k)|0)!=0&(e|0)==0){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,28)|0;o=271702;p=n+28|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,i,271731,461938,608)}q=d&7;r=(d>>>3&511)+1<<(47696>>>(q<<1)&3);d=Y(l,r)|0;if(!g){s=d;f[j>>2]=s;t=a+52|0;f[t>>2]=r;v=Y(k,s)|0;w=e+v|0;f[m>>2]=w;x=0-s|0;y=w+x|0;z=y+d|0;f[c>>2]=z;WS(a);u=h;return}if(!((g>>>0)%((1212424721>>>(q<<2)&15)>>>0)|0)){s=g;f[j>>2]=s;t=a+52|0;f[t>>2]=r;v=Y(k,s)|0;w=e+v|0;f[m>>2]=w;x=0-s|0;y=w+x|0;z=y+d|0;f[c>>2]=z;WS(a);u=h;return}else{f[i>>2]=0;f[i+4>>2]=0;n=tT(i,31)|0;o=219387;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-13,i,271731,461938,622)}}function DY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];BY(a,48,e,c,1.0);u=d;return}function EY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=c;f[g+4>>2]=b;BY(a,49,g,d,1.0);u=e;return}function FY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];BY(a,49,e,c,1.0);u=d;return}function GY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=c;f[g+4>>2]=b;BY(a,73,g,d,1.0);u=e;return}function HY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];BY(a,73,e,c,1.0);u=d;return}function IY(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+-4|0;if((d|0)<4){f=0;g=0}else{i=0;j=0;do{k=i|1;l=i|2;m=i|3;j=(h[213486+((b[c+i>>0]^b[a+i>>0])&255)>>0]|0)+j+(h[213486+((b[c+k>>0]^b[a+k>>0])&255)>>0]|0)+(h[213486+((b[c+l>>0]^b[a+l>>0])&255)>>0]|0)+(h[213486+((b[c+m>>0]^b[a+m>>0])&255)>>0]|0)|0;i=i+4|0}while((i|0)<=(e|0));f=j;g=d&-4}if((g|0)<(d|0)){n=g;o=f}else{p=f;return p|0}while(1){f=(h[213486+((b[c+n>>0]^b[a+n>>0])&255)>>0]|0)+o|0;n=n+1|0;if((n|0)==(d|0)){p=f;break}else o=f}return p|0}function JY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(h[213486+(h[a+f>>0]|0)>>0]|0)+g+(h[213486+(h[a+(f|1)>>0]|0)>>0]|0)+(h[213486+(h[a+(f|2)>>0]|0)>>0]|0)+(h[213486+(h[a+(f|3)>>0]|0)>>0]|0)|0;f=f+4|0}while((f|0)<=(c|0));d=g;e=b&-4}if((e|0)<(b|0)){i=e;j=d}else{k=d;return k|0}while(1){d=(h[213486+(h[a+i>>0]|0)>>0]|0)+j|0;i=i+1|0;if((i|0)==(b|0)){k=d;break}else j=d}return k|0}function KY(a,b,c){a=a|0;b=b|0;c=c|0;return IY(a,b,c)|0}function LY(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[c>>2]|0;a:do if((h|0)==1){if((e|0)==1){dJc(g|0,a|0,d|0)|0;i=1;break}if((d|0)>0){j=0;k=0;while(1){b[g+j>>0]=b[a+k>>0]|0;j=j+1|0;if((j|0)==(d|0)){i=1;break}else k=k+e|0}}else return}else{k=f[c+4>>2]|0;if((h|0)==2)if((d|0)>0){j=0;l=0;while(1){b[g+l>>0]=b[a+j>>0]|0;b[k+l>>0]=b[a+(j+1)>>0]|0;l=l+1|0;if((l|0)==(d|0)){i=2;break a}else j=j+e|0}}else return;j=f[c+8>>2]|0;if((h|0)==3)if((d|0)>0){l=0;m=0;while(1){b[g+m>>0]=b[a+l>>0]|0;b[k+m>>0]=b[a+(l+1)>>0]|0;b[j+m>>0]=b[a+(l+2)>>0]|0;m=m+1|0;if((m|0)==(d|0)){i=3;break}else l=l+e|0}}else return;else{l=f[c+12>>2]|0;if((d|0)>0){m=0;n=0;while(1){b[g+n>>0]=b[a+m>>0]|0;b[k+n>>0]=b[a+(m+1)>>0]|0;b[j+n>>0]=b[a+(m+2)>>0]|0;b[l+n>>0]=b[a+(m+3)>>0]|0;n=n+1|0;if((n|0)==(d|0)){i=h;break}else m=m+e|0}}else return}}while(0);if((d|0)>0&(i|0)<(e|0))o=i;else return;do{i=f[c+(o<<2)>>2]|0;h=f[c+(o+1<<2)>>2]|0;g=f[c+(o+2<<2)>>2]|0;m=f[c+(o+3<<2)>>2]|0;n=o;l=0;while(1){b[i+l>>0]=b[a+n>>0]|0;b[h+l>>0]=b[a+(n+1)>>0]|0;b[g+l>>0]=b[a+(n+2)>>0]|0;b[m+l>>0]=b[a+(n+3)>>0]|0;l=l+1|0;if((l|0)==(d|0))break;else n=n+e|0}o=o+4|0}while((o|0)<(e|0));return}function MY(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[b>>2]|0;a:do if((h|0)==1){if((e|0)==1){dJc(g|0,a|0,c<<1|0)|0;i=1;break}if((c|0)>0){j=0;k=0;while(1){d[g+(j<<1)>>1]=d[a+(k<<1)>>1]|0;j=j+1|0;if((j|0)==(c|0)){i=1;break}else k=k+e|0}}else return}else{k=f[b+4>>2]|0;if((h|0)==2)if((c|0)>0){j=0;l=0;while(1){d[g+(l<<1)>>1]=d[a+(j<<1)>>1]|0;d[k+(l<<1)>>1]=d[a+(j+1<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0)){i=2;break a}else j=j+e|0}}else return;j=f[b+8>>2]|0;if((h|0)==3)if((c|0)>0){l=0;m=0;while(1){d[g+(m<<1)>>1]=d[a+(l<<1)>>1]|0;d[k+(m<<1)>>1]=d[a+(l+1<<1)>>1]|0;d[j+(m<<1)>>1]=d[a+(l+2<<1)>>1]|0;m=m+1|0;if((m|0)==(c|0)){i=3;break}else l=l+e|0}}else return;else{l=f[b+12>>2]|0;if((c|0)>0){m=0;n=0;while(1){d[g+(n<<1)>>1]=d[a+(m<<1)>>1]|0;d[k+(n<<1)>>1]=d[a+(m+1<<1)>>1]|0;d[j+(n<<1)>>1]=d[a+(m+2<<1)>>1]|0;d[l+(n<<1)>>1]=d[a+(m+3<<1)>>1]|0;n=n+1|0;if((n|0)==(c|0)){i=h;break}else m=m+e|0}}else return}}while(0);if((c|0)>0&(i|0)<(e|0))o=i;else return;do{i=f[b+(o<<2)>>2]|0;h=f[b+(o+1<<2)>>2]|0;g=f[b+(o+2<<2)>>2]|0;m=f[b+(o+3<<2)>>2]|0;n=o;l=0;while(1){d[i+(l<<1)>>1]=d[a+(n<<1)>>1]|0;d[h+(l<<1)>>1]=d[a+(n+1<<1)>>1]|0;d[g+(l<<1)>>1]=d[a+(n+2<<1)>>1]|0;d[m+(l<<1)>>1]=d[a+(n+3<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0))break;else n=n+e|0}o=o+4|0}while((o|0)<(e|0));return}function NY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[b>>2]|0;a:do if((g|0)==1){if((d|0)==1){dJc(e|0,a|0,c<<2|0)|0;h=1;break}if((c|0)>0){i=0;j=0;while(1){f[e+(i<<2)>>2]=f[a+(j<<2)>>2];i=i+1|0;if((i|0)==(c|0)){h=1;break}else j=j+d|0}}else return}else{j=f[b+4>>2]|0;if((g|0)==2)if((c|0)>0){i=0;k=0;while(1){f[e+(k<<2)>>2]=f[a+(i<<2)>>2];f[j+(k<<2)>>2]=f[a+(i+1<<2)>>2];k=k+1|0;if((k|0)==(c|0)){h=2;break a}else i=i+d|0}}else return;i=f[b+8>>2]|0;if((g|0)==3)if((c|0)>0){k=0;l=0;while(1){f[e+(l<<2)>>2]=f[a+(k<<2)>>2];f[j+(l<<2)>>2]=f[a+(k+1<<2)>>2];f[i+(l<<2)>>2]=f[a+(k+2<<2)>>2];l=l+1|0;if((l|0)==(c|0)){h=3;break}else k=k+d|0}}else return;else{k=f[b+12>>2]|0;if((c|0)>0){l=0;m=0;while(1){f[e+(m<<2)>>2]=f[a+(l<<2)>>2];f[j+(m<<2)>>2]=f[a+(l+1<<2)>>2];f[i+(m<<2)>>2]=f[a+(l+2<<2)>>2];f[k+(m<<2)>>2]=f[a+(l+3<<2)>>2];m=m+1|0;if((m|0)==(c|0)){h=g;break}else l=l+d|0}}else return}}while(0);if((c|0)>0&(h|0)<(d|0))n=h;else return;do{h=f[b+(n<<2)>>2]|0;g=f[b+(n+1<<2)>>2]|0;e=f[b+(n+2<<2)>>2]|0;l=f[b+(n+3<<2)>>2]|0;m=n;k=0;while(1){f[h+(k<<2)>>2]=f[a+(m<<2)>>2];f[g+(k<<2)>>2]=f[a+(m+1<<2)>>2];f[e+(k<<2)>>2]=f[a+(m+2<<2)>>2];f[l+(k<<2)>>2]=f[a+(m+3<<2)>>2];k=k+1|0;if((k|0)==(c|0))break;else m=m+d|0}n=n+4|0}while((n|0)<(d|0));return}function OY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[b>>2]|0;a:do if((g|0)==1){if((d|0)==1){dJc(e|0,a|0,c<<3|0)|0;h=1;break}if((c|0)>0){i=0;j=0;while(1){k=a+(j<<3)|0;l=f[k+4>>2]|0;m=e+(i<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=l;i=i+1|0;if((i|0)==(c|0)){h=1;break}else j=j+d|0}}else return}else{j=f[b+4>>2]|0;if((g|0)==2)if((c|0)>0){i=0;l=0;while(1){m=a+(i<<3)|0;k=f[m+4>>2]|0;n=e+(l<<3)|0;f[n>>2]=f[m>>2];f[n+4>>2]=k;k=a+(i+1<<3)|0;n=f[k+4>>2]|0;m=j+(l<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=n;l=l+1|0;if((l|0)==(c|0)){h=2;break a}else i=i+d|0}}else return;i=f[b+8>>2]|0;if((g|0)==3)if((c|0)>0){l=0;n=0;while(1){m=a+(l<<3)|0;k=f[m+4>>2]|0;o=e+(n<<3)|0;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=a+(l+1<<3)|0;o=f[k+4>>2]|0;m=j+(n<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=o;o=a+(l+2<<3)|0;m=f[o+4>>2]|0;k=i+(n<<3)|0;f[k>>2]=f[o>>2];f[k+4>>2]=m;n=n+1|0;if((n|0)==(c|0)){h=3;break}else l=l+d|0}}else return;else{l=f[b+12>>2]|0;if((c|0)>0){n=0;m=0;while(1){k=a+(n<<3)|0;o=f[k+4>>2]|0;p=e+(m<<3)|0;f[p>>2]=f[k>>2];f[p+4>>2]=o;o=a+(n+1<<3)|0;p=f[o+4>>2]|0;k=j+(m<<3)|0;f[k>>2]=f[o>>2];f[k+4>>2]=p;p=a+(n+2<<3)|0;k=f[p+4>>2]|0;o=i+(m<<3)|0;f[o>>2]=f[p>>2];f[o+4>>2]=k;k=a+(n+3<<3)|0;o=f[k+4>>2]|0;p=l+(m<<3)|0;f[p>>2]=f[k>>2];f[p+4>>2]=o;m=m+1|0;if((m|0)==(c|0)){h=g;break}else n=n+d|0}}else return}}while(0);if((c|0)>0&(h|0)<(d|0))q=h;else return;do{h=f[b+(q<<2)>>2]|0;g=f[b+(q+1<<2)>>2]|0;e=f[b+(q+2<<2)>>2]|0;n=f[b+(q+3<<2)>>2]|0;m=q;l=0;while(1){i=a+(m<<3)|0;j=f[i+4>>2]|0;o=h+(l<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=j;j=a+(m+1<<3)|0;o=f[j+4>>2]|0;i=g+(l<<3)|0;f[i>>2]=f[j>>2];f[i+4>>2]=o;o=a+(m+2<<3)|0;i=f[o+4>>2]|0;j=e+(l<<3)|0;f[j>>2]=f[o>>2];f[j+4>>2]=i;i=a+(m+3<<3)|0;j=f[i+4>>2]|0;o=n+(l<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=j;l=l+1|0;if((l|0)==(c|0))break;else m=m+d|0}q=q+4|0}while((q|0)<(d|0));return}function PY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+1104|0;e=d+1080|0;g=d+40|0;h=d+8|0;i=d;j=f[a>>2]|0;k=j&7;l=j>>>3&511;j=l+1|0;if(!l){m=e+8|0;f[m>>2]=0;f[m+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=c;h_(a,e);u=d;return}m=a+4|0;n=a+40|0;o=0;do{XS(c+(o*56|0)|0,f[m>>2]|0,f[n>>2]|0,k);o=o+1|0}while((o|0)!=(j|0));o=f[43484+(k<<2)>>2]|0;if((k|0)==7){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,9)|0;n=251213;p=k+9|0;do{b[k>>0]=b[n>>0]|0;k=k+1|0;n=n+1|0}while((k|0)<(p|0));QY(-215,e,391970,307)}n=f[m>>2]|0;if((n|0)>0)q=f[(f[a+44>>2]|0)+(n+-1<<2)>>2]|0;else q=0;n=1212424721>>>(f[a>>2]<<2&28)&15;f[e>>2]=((q+1023|0)>>>0)/(q>>>0)|0;m=l+2|0;l=(m<<3)+16|0;k=g+8|0;f[g>>2]=k;p=g+4|0;f[p>>2]=l;if(l>>>0>1032){r=XDc(l)|0;f[g>>2]=r;s=r}else s=k;r=s+(j<<2)+4+15&-16;l=r;f[s>>2]=a;a=0;do{t=a;a=a+1|0;f[s+(a<<2)>>2]=c+(t*56|0)}while((a|0)!=(j|0));a=r;z2(h,s,a,m);m=f[h+20>>2]|0;f[i>>2]=m;s=536870911/(j>>>0)|0;if(j>>>0<5)v=m;else{r=f[e>>2]|0;v=r>>>0<m>>>0?r:f[i>>2]|0}r=v>>>0<s>>>0?v:s;s=h+16|0;v=l+4|0;e=m;c=m;m=0;while(1){if(m>>>0>=(f[s>>2]|0)>>>0)break;if(!e){w=0;x=c}else{t=e;y=c;z=0;while(1){A=t-z|0;B=r>>>0<A>>>0?r:A;ei[o&511](f[a>>2]|0,v,B,j);z=z+r|0;if(z>>>0<y>>>0){A=Y(q,B)|0;f[a>>2]=(f[a>>2]|0)+A;A=Y(n,B)|0;B=0;do{B=B+1|0;C=l+(B<<2)|0;f[C>>2]=(f[C>>2]|0)+A}while((B|0)!=(j|0));D=f[i>>2]|0}else D=y;if(D>>>0<=z>>>0){w=D;x=D;break}else{t=D;y=D}}}A2(h)|0;e=w;c=x;m=m+1|0}m=f[g>>2]|0;if((m|0)!=(k|0)){if(m|0)ZDc(m);f[g>>2]=k;f[p>>2]=1032}u=d;return}function QY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,219419,d);return}function RY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+80|0;e=d+16|0;g=d;do if((d$(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];l=e+16|0;f[l>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];m=f[h+36>>2]|0;f[e+36>>2]=m;f[e+40>>2]=k;k=e+48|0;n=e+44|0;f[n>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(m|0){k=m+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=l;break}else{f[i>>2]=0;ZS(e,h);o=l;break}}else{a$(e,a,-1);o=e+16|0}while(0);if(f[o>>2]|0){a=e+4|0;l=f[a>>2]|0;if((l|0)<3)p=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{h=f[e+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(l|0)){p=k;break}else j=k}}if(!((l|0)==0|(p|0)==0)){if((X$(c)|0?!(r$(c)|0):0)?(p=c$(c,-1)|0,(p|0)!=(f[e>>2]&7|0)):0){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,58)|0;l=219483;j=p+58|0;do{b[p>>0]=b[l>>0]|0;p=p+1|0;l=l+1|0}while((p|0)<(j|0));QY(-215,g,391970,402)}l=f[e>>2]|0;p=l&7;j=l>>>3&511;Y$(c,j+1|0,1,p,-1,0,0);l=e+40|0;i=0;while(1){w$(c,f[a>>2]|0,f[l>>2]|0,p,i,0,0);if((i|0)<(j|0))i=i+1|0;else break}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f$(c,g);PY(e,f[g>>2]|0);mx(g)}else q=14}else q=14;if((q|0)==14)u$(c);c=e+36|0;q=f[c>>2]|0;if(q|0?(g=q+12|0,q=f[g>>2]|0,f[g>>2]=q+-1,(q|0)==1):0)_S(e);f[c>>2]=0;c=e+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[c>>2]|0)>0){o=f[e+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[c>>2]|0))}c=f[e+44>>2]|0;if((c|0)==(e+48|0)){u=d;return}g0(c);u=d;return}function SY(a,b){a=a|0;b=b|0;return f[43516+((b&7)<<5)+((a&7)<<2)>>2]|0}function TY(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;if((d|0)>0){j=a;k=e;l=0}else return;while(1){dJc(k|0,j|0,i|0)|0;l=l+1|0;if((l|0)==(d|0))break;else{j=j+b|0;k=k+g|0}}return}function UY(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=b[m+a>>0]|0;b[l+a>>0]=(g|0)>0?g:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+c|0}}return}function VY(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{g=j[n+(a<<1)>>1]|0;b[m+a>>0]=g>>>0<255?g:255;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+h|0;n=n+(i<<1)|0}}return}function WY(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=c>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;n=a}else return;while(1){a=0;do{h=d[n+(a<<1)>>1]|0;b[m+a>>0]=(h&65535)<256?h&65535:h<<16>>16>0?255:0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+i|0;n=n+(j<<1)|0}}return}function XY(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;b[l+a>>0]=g>>>0<256?g:(g|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<2)|0}}return}function YY(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=mrc(+n[m+(a<<2)>>2])|0;b[l+a>>0]=g>>>0<256?g:(g|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<2)|0}}return}function ZY(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>3;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=nrc(+p[m+(a<<3)>>3])|0;b[l+a>>0]=g>>>0<256?g:(g|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<3)|0}}return}function _Y(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;e=f[j+4>>2]|0;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{g=h[n+a>>0]|0;b[m+a>>0]=g>>>0<127?g:127;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+i|0;n=n+c|0}}return}function $Y(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{g=j[n+(a<<1)>>1]|0;b[m+a>>0]=g>>>0<127?g:127;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+h|0;n=n+(i<<1)|0}}return}function aZ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=c>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;n=a}else return;while(1){a=0;do{h=d[n+(a<<1)>>1]|0;c=h<<16>>16;b[m+a>>0]=(c+128|0)>>>0<256?c:h<<16>>16>0?127:128;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+i|0;n=n+(j<<1)|0}}return}function bZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;b[l+a>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<2)|0}}return}function cZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=mrc(+n[m+(a<<2)>>2])|0;b[l+a>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<2)|0}}return}function dZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>3;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=nrc(+p[m+(a<<3)>>3])|0;b[l+a>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<3)|0}}return}function eZ(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{d[m+(a<<1)>>1]=h[n+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(j<<1)|0;n=n+b|0}}return}function fZ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;n=a}else return;while(1){a=0;do{h=b[n+a>>0]|0;d[m+(a<<1)>>1]=(h|0)>0?h:0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+(j<<1)|0;n=n+c|0}}return}function gZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=f[h>>2]<<1;if((i|0)<=0)return;h=a;a=e;e=0;while(1){dJc(a|0,h|0,d|0)|0;e=e+1|0;if((e|0)==(i|0))break;else{h=h+b|0;a=a+g|0}}return}function hZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=d[m+(a<<1)>>1]|0;d[l+(a<<1)>>1]=(g|0)>0?g:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<1)|0}}return}function iZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;d[l+(a<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function jZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=mrc(+n[m+(a<<2)>>2])|0;d[l+(a<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function kZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=nrc(+p[m+(a<<3)>>3])|0;d[l+(a<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<3)|0}}return}function lZ(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{d[m+(a<<1)>>1]=h[n+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(j<<1)|0;n=n+b|0}}return}function mZ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;n=a}else return;while(1){a=0;do{d[m+(a<<1)>>1]=b[n+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+(j<<1)|0;n=n+c|0}}return}function nZ(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;if((k|0)>0&(e|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{g=j[n+(a<<1)>>1]|0;d[m+(a<<1)>>1]=g>>>0<32767?g:32767;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(b<<1)|0;n=n+(i<<1)|0}}return}function oZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;d[l+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function pZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=mrc(+n[m+(a<<2)>>2])|0;d[l+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function qZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=nrc(+p[m+(a<<3)>>3])|0;d[l+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<3)|0}}return}function rZ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>2;if((d|0)>0&(j|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{f[l+(a<<2)>>2]=h[m+a>>0];a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(i<<2)|0;m=m+b|0}}return}function sZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{f[l+(a<<2)>>2]=b[m+a>>0];a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(i<<2)|0;m=m+c|0}}return}function tZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if((d|0)>0&(i|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{f[l+(a<<2)>>2]=j[m+(a<<1)>>1];a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<2)|0;m=m+(h<<1)|0}}return}function uZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{f[l+(a<<2)>>2]=d[m+(a<<1)>>1];a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<2)|0;m=m+(i<<1)|0}}return}function vZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=f[h>>2]<<2;if((i|0)<=0)return;h=a;a=e;e=0;while(1){dJc(a|0,h|0,d|0)|0;e=e+1|0;if((e|0)==(i|0))break;else{h=h+b|0;a=a+g|0}}return}function wZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>2;if((d|0)>0&(i|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{e=mrc(+n[l+(a<<2)>>2])|0;f[k+(a<<2)>>2]=e;a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<2)|0;l=l+(h<<2)|0}}return}function xZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>3;b=g>>>2;if((d|0)>0&(i|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{e=nrc(+p[l+(a<<3)>>3])|0;f[k+(a<<2)>>2]=e;a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<2)|0;l=l+(h<<3)|0}}return}function yZ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>2;if((d|0)>0&(j|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{n[l+(a<<2)>>2]=+(h[m+a>>0]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(i<<2)|0;m=m+b|0}}return}function zZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{n[l+(a<<2)>>2]=+(b[m+a>>0]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(i<<2)|0;m=m+c|0}}return}function AZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if((i|0)>0&(d|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{n[l+(a<<2)>>2]=+(j[m+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<2)|0;m=m+(h<<1)|0}}return}function BZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>2;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{n[l+(a<<2)>>2]=+(d[m+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<2)|0;m=m+(i<<1)|0}}return}function CZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>2;if((i|0)>0&(d|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{n[k+(a<<2)>>2]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<2)|0;l=l+(h<<2)|0}}return}function DZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>3;b=g>>>2;if((i|0)>0&(d|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{n[k+(a<<2)>>2]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<2)|0;l=l+(h<<3)|0}}return}function EZ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>3;if((d|0)>0&(j|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{p[l+(a<<3)>>3]=+(h[m+a>>0]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(i<<3)|0;m=m+b|0}}return}function FZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>3;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{p[l+(a<<3)>>3]=+(b[m+a>>0]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(i<<3)|0;m=m+c|0}}return}function GZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>3;if((i|0)>0&(d|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{p[l+(a<<3)>>3]=+(j[m+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<3)|0;m=m+(h<<1)|0}}return}function HZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>3;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{p[l+(a<<3)>>3]=+(d[m+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<3)|0;m=m+(i<<1)|0}}return}function IZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>3;if((i|0)>0&(d|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{p[k+(a<<3)>>3]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<3)|0;l=l+(h<<2)|0}}return}function JZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>3;if((i|0)>0&(d|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{p[k+(a<<3)>>3]=+n[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<3)|0;l=l+(h<<2)|0}}return}function KZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=f[h>>2]<<3;if((i|0)<=0)return;h=a;a=e;e=0;while(1){dJc(a|0,h|0,d|0)|0;e=e+1|0;if((e|0)==(i|0))break;else{h=h+b|0;a=a+g|0}}return}function LZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+208|0;i=h+152|0;j=h+88|0;k=h+96|0;l=h+8|0;m=h+72|0;n=h+64|0;o=h;q=h+32|0;r=h+24|0;s=a+16|0;if(f[s>>2]|0){t=a+4|0;v=f[t>>2]|0;if((v|0)<3)w=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{x=f[a+40>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if(!((v|0)==0|(w|0)==0)){if(+L(+(e+-1.0))<2.220446049250313e-16)B=+L(+g)<2.220446049250313e-16;else B=0;do if((d|0)<0)if(X$(c)|0){w=c$(c,-1)|0;C=w;D=a;E=f[a>>2]|0;break}else{w=f[a>>2]|0;C=w&4095;D=a;E=w;break}else{w=f[a>>2]|0;C=w&4088|d&7;D=a;E=w}while(0);d=E&7;E=C&7;if(!((d|0)!=(E|0)|B^1)){h_(a,c);u=h;return}f[i>>2]=f[D>>2];w=i+4|0;v=f[t>>2]|0;f[w>>2]=v;z=i+8|0;f[z>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];y=i+16|0;f[y>>2]=f[s>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];s=i+36|0;x=f[a+36>>2]|0;f[s>>2]=x;A=i+40|0;f[A>>2]=z;z=i+48|0;F=i+44|0;f[F>>2]=z;f[z>>2]=0;f[i+52>>2]=0;if(!x)G=v;else{v=x+12|0;f[v>>2]=(f[v>>2]|0)+1;G=f[t>>2]|0}if((G|0)<3){G=f[a+44>>2]|0;v=f[F>>2]|0;f[v>>2]=f[G>>2];f[v+4>>2]=f[G+4>>2]}else{f[w>>2]=0;ZS(i,a)}G=f[t>>2]|0;v=f[a+40>>2]|0;if((G|0)<3){a=f[v>>2]|0;f[j>>2]=f[v+4>>2];f[j+4>>2]=a;v$(c,j,C,-1,0,0)}else w$(c,G,v,C,-1,0,0);do if((d$(c)|0)==65536){C=f[c+4>>2]|0;f[k>>2]=f[C>>2];v=k+4|0;G=C+4|0;f[v>>2]=f[G>>2];j=k+8|0;f[j>>2]=f[C+8>>2];f[k+12>>2]=f[C+12>>2];f[k+16>>2]=f[C+16>>2];f[k+20>>2]=f[C+20>>2];f[k+24>>2]=f[C+24>>2];f[k+28>>2]=f[C+28>>2];f[k+32>>2]=f[C+32>>2];a=f[C+36>>2]|0;f[k+36>>2]=a;f[k+40>>2]=j;j=k+48|0;x=k+44|0;f[x>>2]=j;f[j>>2]=0;f[k+52>>2]=0;if(a|0){j=a+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[G>>2]|0)<3){G=f[C+44>>2]|0;j=f[x>>2]|0;f[j>>2]=f[G>>2];f[j+4>>2]=f[G+4>>2];break}else{f[v>>2]=0;ZS(k,C);break}}else a$(k,c,-1);while(0);if(B)H=f[43516+(E<<5)+(d<<2)>>2]|0;else H=DL(d,E)|0;p[l>>3]=e;p[l+8>>3]=g;E=((f[D>>2]|0)>>>3&511)+1|0;if(!H){f[m>>2]=0;f[m+4>>2]=0;D=tT(m,9)|0;d=251213;B=D+9|0;do{b[D>>0]=b[d>>0]|0;D=D+1|0;d=d+1|0}while((D|0)<(B|0));MZ(-215,m,219542,449)}if((f[t>>2]|0)<3){rT(m,i,k,E);t=f[y>>2]|0;d=f[z>>2]|0;D=f[k+16>>2]|0;B=f[k+48>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];wi[H&255](t,d,0,0,D,B,n,l)}else{f[m>>2]=i;f[m+4>>2]=k;f[m+8>>2]=0;n=o;f[n>>2]=0;f[n+4>>2]=0;z2(q,m,o,-1);m=Y(f[q+20>>2]|0,E)|0;E=q+16|0;n=o+4|0;B=r+4|0;D=0;while(1){if(D>>>0>=(f[E>>2]|0)>>>0)break;d=f[o>>2]|0;t=f[n>>2]|0;f[r>>2]=m;f[B>>2]=1;wi[H&255](d,1,0,0,t,1,r,l);A2(q)|0;D=D+1|0}}D=k+36|0;q=f[D>>2]|0;if(q|0?(l=q+12|0,q=f[l>>2]|0,f[l>>2]=q+-1,(q|0)==1):0)_S(k);f[D>>2]=0;D=k+16|0;q=k+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[q>>2]|0)>0){D=f[k+40>>2]|0;l=0;do{f[D+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[q>>2]|0))}q=f[k+44>>2]|0;if((q|0)!=(k+48|0))g0(q);q=f[s>>2]|0;if(q|0?(k=q+12|0,q=f[k>>2]|0,f[k>>2]=q+-1,(q|0)==1):0)_S(i);f[s>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[w>>2]|0)>0){y=f[A>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[w>>2]|0))}w=f[F>>2]|0;if((w|0)!=(z|0))g0(w);u=h;return}}u$(c);u=h;return}function MZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,219552,d);return}function NZ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+192|0;e=d+128|0;g=d+64|0;h=d+48|0;i=d+120|0;j=d;k=d+8|0;l=d+40|0;switch(p$(a,-1)|0){case 5:{m=2;break}case 3:{n=143;o=5;break}default:{f[e>>2]=0;f[e+4>>2]=0;p=tT(e,23)|0;q=219682;r=p+23|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));MZ(-210,e,219635,496)}}if((m|0)==2)if(X$(c)|0){if((p$(c,-1)|0)!=3){f[e>>2]=0;f[e+4>>2]=0;p=tT(e,16)|0;q=219618;r=p+16|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));MZ(-215,e,219635,483)}m=q$(c,-1)|0;if((m|0)!=(q$(a,-1)|0)){f[e>>2]=0;f[e+4>>2]=0;p=tT(e,34)|0;q=219647;r=p+34|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));MZ(-215,e,219635,484)}else{n=144;o=3}}else{n=144;o=3}do if((d$(a)|0)==65536){q=f[a+4>>2]|0;f[e>>2]=f[q>>2];p=e+4|0;r=q+4|0;f[p>>2]=f[r>>2];m=e+8|0;f[m>>2]=f[q+8>>2];f[e+12>>2]=f[q+12>>2];f[e+16>>2]=f[q+16>>2];f[e+20>>2]=f[q+20>>2];f[e+24>>2]=f[q+24>>2];f[e+28>>2]=f[q+28>>2];f[e+32>>2]=f[q+32>>2];s=f[q+36>>2]|0;f[e+36>>2]=s;t=e+40|0;f[t>>2]=m;m=e+48|0;v=e+44|0;f[v>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(s|0){m=s+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[r>>2]|0)<3){r=f[q+44>>2]|0;m=f[v>>2]|0;f[m>>2]=f[r>>2];f[m+4>>2]=f[r+4>>2];w=p;x=t;y=e;break}else{f[p>>2]=0;ZS(e,q);w=p;x=t;y=e;break}}else{a$(e,a,-1);w=e+4|0;x=e+40|0;y=e}while(0);w$(c,f[w>>2]|0,f[x>>2]|0,f[y>>2]&4088|o,-1,0,0);do if((d$(c)|0)==65536){o=f[c+4>>2]|0;f[g>>2]=f[o>>2];a=g+4|0;t=o+4|0;f[a>>2]=f[t>>2];p=g+8|0;f[p>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];q=f[o+36>>2]|0;f[g+36>>2]=q;f[g+40>>2]=p;p=g+48|0;r=g+44|0;f[r>>2]=p;f[p>>2]=0;f[g+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[t>>2]|0)<3){t=f[o+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[t>>2];f[p+4>>2]=f[t+4>>2];break}else{f[a>>2]=0;ZS(g,o);break}}else a$(g,c,-1);while(0);c=((f[y>>2]|0)>>>3&511)+1|0;if((f[w>>2]|0)<3){rT(h,e,g,c);y=f[e+16>>2]|0;o=f[e+48>>2]|0;a=f[g+16>>2]|0;t=f[g+48>>2]|0;f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];wi[n&255](y,o,0,0,a,t,i,0)}else{f[h>>2]=e;f[h+4>>2]=g;f[h+8>>2]=0;i=j;f[i>>2]=0;f[i+4>>2]=0;z2(k,h,j,-1);h=Y(f[k+20>>2]|0,c)|0;c=k+16|0;i=j+4|0;t=l+4|0;a=0;while(1){if(a>>>0>=(f[c>>2]|0)>>>0)break;o=f[j>>2]|0;y=f[i>>2]|0;f[l>>2]=h;f[t>>2]=1;wi[n&255](o,0,0,0,y,0,l,0);A2(k)|0;a=a+1|0}}a=g+36|0;k=f[a>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(g);f[a>>2]=0;a=g+16|0;k=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[k>>2]|0)>0){a=f[g+40>>2]|0;l=0;do{f[a+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[g+44>>2]|0;if((k|0)!=(g+48|0))g0(k);k=e+36|0;g=f[k>>2]|0;if(g|0?(l=g+12|0,g=f[l>>2]|0,f[l>>2]=g+-1,(g|0)==1):0)_S(e);f[k>>2]=0;k=e+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[w>>2]|0)>0){k=f[x>>2]|0;x=0;do{f[k+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[w>>2]|0))}w=f[e+44>>2]|0;if((w|0)==(e+48|0)){u=d;return}g0(w);u=d;return}function OZ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;h=g&-2147483648;c=h^g;do if(c>>>0<=1199570943)if(c>>>0<947912704){o=(n[s>>2]=(f[s>>2]=c,+n[s>>2])+.5,f[s>>2]|0);break}else{o=(g+134221823+(g>>>13&1)|0)>>>13;break}else o=c>>>0>2139095040?32256:31744;while(0);d[l+(a<<1)>>1]=o|h>>>16;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function PZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if((i|0)>0&(d|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{e=j[m+(a<<1)>>1]|0;g=e<<13;c=g&268427264;o=c+939524096|0;p=e<<16&-2147483648;q=e&31744;a:do if(q<<16>>16<31744){switch(q<<16>>16){case 0:break;default:{r=o;break a}}r=(n[s>>2]=(f[s>>2]=c+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(q<<16>>16){case 31744:break;default:{r=o;break a}}r=g|1879048192}while(0);f[l+(a<<2)>>2]=r|p;a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<2)|0;m=m+(h<<1)|0}}return}function QZ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[a>>2]|0;a:do if((h|0)==1)if((d|0)>0){i=0;j=0;while(1){b[c+j>>0]=b[g+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else j=j+e|0}}else return;else{j=f[a+4>>2]|0;if((h|0)==2)if((d|0)>0){i=0;k=0;while(1){b[c+i>>0]=b[g+k>>0]|0;b[c+(i+1)>>0]=b[j+k>>0]|0;k=k+1|0;if((k|0)==(d|0))break a;else i=i+e|0}}else return;i=f[a+8>>2]|0;if((h|0)==3)if((d|0)>0){k=0;l=0;while(1){b[c+k>>0]=b[g+l>>0]|0;b[c+(k+1)>>0]=b[j+l>>0]|0;b[c+(k+2)>>0]=b[i+l>>0]|0;l=l+1|0;if((l|0)==(d|0))break;else k=k+e|0}}else return;else{k=f[a+12>>2]|0;if((d|0)>0){l=0;m=0;while(1){b[c+l>>0]=b[g+m>>0]|0;b[c+(l+1)>>0]=b[j+m>>0]|0;b[c+(l+2)>>0]=b[i+m>>0]|0;b[c+(l+3)>>0]=b[k+m>>0]|0;m=m+1|0;if((m|0)==(d|0))break;else l=l+e|0}}else return}}while(0);if((d|0)>0&(h|0)<(e|0))n=h;else return;do{h=f[a+(n<<2)>>2]|0;g=f[a+(n+1<<2)>>2]|0;l=f[a+(n+2<<2)>>2]|0;m=f[a+(n+3<<2)>>2]|0;k=n;i=0;while(1){b[c+k>>0]=b[h+i>>0]|0;b[c+(k+1)>>0]=b[g+i>>0]|0;b[c+(k+2)>>0]=b[l+i>>0]|0;b[c+(k+3)>>0]=b[m+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else k=k+e|0}n=n+4|0}while((n|0)<(e|0));return}function RZ(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[a>>2]|0;a:do if((h|0)==1)if((c|0)>0){i=0;j=0;while(1){d[b+(j<<1)>>1]=d[g+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else j=j+e|0}}else return;else{j=f[a+4>>2]|0;if((h|0)==2)if((c|0)>0){i=0;k=0;while(1){d[b+(i<<1)>>1]=d[g+(k<<1)>>1]|0;d[b+(i+1<<1)>>1]=d[j+(k<<1)>>1]|0;k=k+1|0;if((k|0)==(c|0))break a;else i=i+e|0}}else return;i=f[a+8>>2]|0;if((h|0)==3)if((c|0)>0){k=0;l=0;while(1){d[b+(k<<1)>>1]=d[g+(l<<1)>>1]|0;d[b+(k+1<<1)>>1]=d[j+(l<<1)>>1]|0;d[b+(k+2<<1)>>1]=d[i+(l<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0))break;else k=k+e|0}}else return;else{k=f[a+12>>2]|0;if((c|0)>0){l=0;m=0;while(1){d[b+(l<<1)>>1]=d[g+(m<<1)>>1]|0;d[b+(l+1<<1)>>1]=d[j+(m<<1)>>1]|0;d[b+(l+2<<1)>>1]=d[i+(m<<1)>>1]|0;d[b+(l+3<<1)>>1]=d[k+(m<<1)>>1]|0;m=m+1|0;if((m|0)==(c|0))break;else l=l+e|0}}else return}}while(0);if((c|0)>0&(h|0)<(e|0))n=h;else return;do{h=f[a+(n<<2)>>2]|0;g=f[a+(n+1<<2)>>2]|0;l=f[a+(n+2<<2)>>2]|0;m=f[a+(n+3<<2)>>2]|0;k=n;i=0;while(1){d[b+(k<<1)>>1]=d[h+(i<<1)>>1]|0;d[b+(k+1<<1)>>1]=d[g+(i<<1)>>1]|0;d[b+(k+2<<1)>>1]=d[l+(i<<1)>>1]|0;d[b+(k+3<<1)>>1]=d[m+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else k=k+e|0}n=n+4|0}while((n|0)<(e|0));return}function SZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[a>>2]|0;a:do if((g|0)==1)if((c|0)>0){h=0;i=0;while(1){f[b+(i<<2)>>2]=f[e+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else i=i+d|0}}else return;else{i=f[a+4>>2]|0;if((g|0)==2)if((c|0)>0){h=0;j=0;while(1){f[b+(h<<2)>>2]=f[e+(j<<2)>>2];f[b+(h+1<<2)>>2]=f[i+(j<<2)>>2];j=j+1|0;if((j|0)==(c|0))break a;else h=h+d|0}}else return;h=f[a+8>>2]|0;if((g|0)==3)if((c|0)>0){j=0;k=0;while(1){f[b+(j<<2)>>2]=f[e+(k<<2)>>2];f[b+(j+1<<2)>>2]=f[i+(k<<2)>>2];f[b+(j+2<<2)>>2]=f[h+(k<<2)>>2];k=k+1|0;if((k|0)==(c|0))break;else j=j+d|0}}else return;else{j=f[a+12>>2]|0;if((c|0)>0){k=0;l=0;while(1){f[b+(k<<2)>>2]=f[e+(l<<2)>>2];f[b+(k+1<<2)>>2]=f[i+(l<<2)>>2];f[b+(k+2<<2)>>2]=f[h+(l<<2)>>2];f[b+(k+3<<2)>>2]=f[j+(l<<2)>>2];l=l+1|0;if((l|0)==(c|0))break;else k=k+d|0}}else return}}while(0);if((c|0)>0&(g|0)<(d|0))m=g;else return;do{g=f[a+(m<<2)>>2]|0;e=f[a+(m+1<<2)>>2]|0;k=f[a+(m+2<<2)>>2]|0;l=f[a+(m+3<<2)>>2]|0;j=m;h=0;while(1){f[b+(j<<2)>>2]=f[g+(h<<2)>>2];f[b+(j+1<<2)>>2]=f[e+(h<<2)>>2];f[b+(j+2<<2)>>2]=f[k+(h<<2)>>2];f[b+(j+3<<2)>>2]=f[l+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else j=j+d|0}m=m+4|0}while((m|0)<(d|0));return}function TZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[a>>2]|0;a:do if((g|0)==1)if((c|0)>0){h=0;i=0;while(1){j=e+(h<<3)|0;k=f[j+4>>2]|0;l=b+(i<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=k;h=h+1|0;if((h|0)==(c|0))break;else i=i+d|0}}else return;else{i=f[a+4>>2]|0;if((g|0)==2)if((c|0)>0){h=0;k=0;while(1){l=e+(k<<3)|0;j=f[l+4>>2]|0;m=b+(h<<3)|0;f[m>>2]=f[l>>2];f[m+4>>2]=j;j=i+(k<<3)|0;m=f[j+4>>2]|0;l=b+(h+1<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=m;k=k+1|0;if((k|0)==(c|0))break a;else h=h+d|0}}else return;h=f[a+8>>2]|0;if((g|0)==3)if((c|0)>0){k=0;m=0;while(1){l=e+(m<<3)|0;j=f[l+4>>2]|0;n=b+(k<<3)|0;f[n>>2]=f[l>>2];f[n+4>>2]=j;j=i+(m<<3)|0;n=f[j+4>>2]|0;l=b+(k+1<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=n;n=h+(m<<3)|0;l=f[n+4>>2]|0;j=b+(k+2<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=l;m=m+1|0;if((m|0)==(c|0))break;else k=k+d|0}}else return;else{k=f[a+12>>2]|0;if((c|0)>0){m=0;l=0;while(1){j=e+(l<<3)|0;n=f[j+4>>2]|0;o=b+(m<<3)|0;f[o>>2]=f[j>>2];f[o+4>>2]=n;n=i+(l<<3)|0;o=f[n+4>>2]|0;j=b+(m+1<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=o;o=h+(l<<3)|0;j=f[o+4>>2]|0;n=b+(m+2<<3)|0;f[n>>2]=f[o>>2];f[n+4>>2]=j;j=k+(l<<3)|0;n=f[j+4>>2]|0;o=b+(m+3<<3)|0;f[o>>2]=f[j>>2];f[o+4>>2]=n;l=l+1|0;if((l|0)==(c|0))break;else m=m+d|0}}else return}}while(0);if((c|0)>0&(g|0)<(d|0))p=g;else return;do{g=f[a+(p<<2)>>2]|0;e=f[a+(p+1<<2)>>2]|0;m=f[a+(p+2<<2)>>2]|0;l=f[a+(p+3<<2)>>2]|0;k=p;h=0;while(1){i=g+(h<<3)|0;n=f[i+4>>2]|0;o=b+(k<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=n;n=e+(h<<3)|0;o=f[n+4>>2]|0;i=b+(k+1<<3)|0;f[i>>2]=f[n>>2];f[i+4>>2]=o;o=m+(h<<3)|0;i=f[o+4>>2]|0;n=b+(k+2<<3)|0;f[n>>2]=f[o>>2];f[n+4>>2]=i;i=l+(h<<3)|0;n=f[i+4>>2]|0;o=b+(k+3<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=n;h=h+1|0;if((h|0)==(c|0))break;else k=k+d|0}p=p+4|0}while((p|0)<(d|0));return}function UZ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+2208|0;g=e+2144|0;h=e+1080|0;i=e+40|0;j=e+8|0;k=e;if(!((a|0)!=0&(c|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,11)|0;m=219706;n=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));VZ(-215,g,219718,284)}o=f[a>>2]&7;p=f[a+40>>2]|0;q=f[p+-4>>2]|0;r=p+4|0;s=(q|0)==2;t=(q|0)>0;v=1;w=0;x=0;y=p;a:while(1){if(s){if((f[y>>2]|0)!=(f[p>>2]|0)){z=11;break}if((f[y+4>>2]|0)!=(f[r>>2]|0)){z=11;break}}else if(t){A=0;do{if((f[y+(A<<2)>>2]|0)!=(f[p+(A<<2)>>2]|0)){z=11;break a}A=A+1|0}while((A|0)<(q|0))}A=f[a+(x*56|0)>>2]|0;if((A&7|0)!=(o|0)){z=11;break}v=v&(A&4088|0)==0;B=A>>>3&511;C=w+1+B|0;x=x+1|0;if(x>>>0>=c>>>0){z=14;break}y=f[a+(x*56|0)+40>>2]|0;if((f[y+-4>>2]|0)!=(q|0)){z=11;break}else w=C}if((z|0)==11){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,50)|0;m=219724;n=l+50|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));VZ(-215,g,219718,293)}else if((z|0)==14){if((w+B|0)>>>0>=512){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,25)|0;m=219775;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));VZ(-215,g,219718,298)}w$(d,f[a+4>>2]|0,f[a+40>>2]|0,(C<<3)+-8|o,-1,0,0);do if((d$(d)|0)==65536){B=f[d+4>>2]|0;f[g>>2]=f[B>>2];w=g+4|0;z=B+4|0;f[w>>2]=f[z>>2];q=g+8|0;f[q>>2]=f[B+8>>2];f[g+12>>2]=f[B+12>>2];f[g+16>>2]=f[B+16>>2];f[g+20>>2]=f[B+20>>2];f[g+24>>2]=f[B+24>>2];f[g+28>>2]=f[B+28>>2];f[g+32>>2]=f[B+32>>2];y=f[B+36>>2]|0;f[g+36>>2]=y;f[g+40>>2]=q;q=g+48|0;x=g+44|0;f[x>>2]=q;f[q>>2]=0;f[g+52>>2]=0;if(y|0){q=y+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[z>>2]|0)<3){z=f[B+44>>2]|0;q=f[x>>2]|0;f[q>>2]=f[z>>2];f[q+4>>2]=f[z+4>>2];break}else{f[w>>2]=0;ZS(g,B);break}}else a$(g,d,-1);while(0);do if((c|0)!=1){if(!v){d=C<<1;B=h+8|0;f[h>>2]=B;w=h+4|0;f[w>>2]=d;if(d>>>0>264){z=XDc(d>>>0>1073741823?-1:d<<2)|0;f[h>>2]=z;D=z}else D=B;z=0;d=0;while(1){q=(f[a+(d*56|0)>>2]|0)>>>3&511;x=0;while(1){y=x+z|0;p=y<<1;f[D+(p<<2)>>2]=y;f[D+((p|1)<<2)>>2]=y;if((x|0)==(q|0))break;else x=x+1|0}d=d+1|0;if((d|0)==(c|0))break;else z=z+1+q|0}SQ(a,c,g,1,D,C);z=f[h>>2]|0;if((z|0)!=(B|0)){if(z|0)ZDc(z);f[h>>2]=B;f[w>>2]=264}break}z=f[43772+(o<<2)>>2]|0;if((o|0)==7){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,9)|0;m=251213;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));VZ(-215,h,219718,329)}w=f[g+4>>2]|0;if((w|0)>0)E=f[(f[g+44>>2]|0)+(w+-1<<2)>>2]|0;else E=0;w=1212424721>>>(f[g>>2]<<2&28)&15;f[h>>2]=((E+1023|0)>>>0)/(E>>>0)|0;B=C+1|0;d=(B<<3)+16|0;x=i+8|0;f[i>>2]=x;y=i+4|0;f[y>>2]=d;if(d>>>0>1032){p=XDc(d)|0;f[i>>2]=p;F=p}else F=x;p=F+(C<<2)+4+15&-16;d=p;t=p;f[F>>2]=g;p=0;do{r=p;p=p+1|0;f[F+(p<<2)>>2]=a+(r*56|0)}while((p|0)!=(C|0));z2(j,F,t,B);p=f[j+20>>2]|0;f[k>>2]=p;r=536870911/(C|0)|0;if((C|0)<5)G=p;else{s=f[h>>2]|0;G=s>>>0<p>>>0?s:f[k>>2]|0}s=G>>>0<r>>>0?G:r;r=j+16|0;A=d+4|0;H=p;I=p;p=0;while(1){if(p>>>0>=(f[r>>2]|0)>>>0)break;if(!H){J=0;K=I}else{L=H;M=I;N=0;while(1){O=L-N|0;P=s>>>0<O>>>0?s:O;ei[z&511](A,f[t>>2]|0,P,C);N=N+s|0;if(N>>>0<M>>>0){O=Y(E,P)|0;f[t>>2]=(f[t>>2]|0)+O;O=Y(w,P)|0;P=0;do{P=P+1|0;Q=d+(P<<2)|0;f[Q>>2]=(f[Q>>2]|0)+O}while((P|0)!=(C|0));R=f[k>>2]|0}else R=M;if(R>>>0<=N>>>0){J=R;K=R;break}else{L=R;M=R}}}A2(j)|0;H=J;I=K;p=p+1|0}p=f[i>>2]|0;if((p|0)!=(x|0)){if(p|0)ZDc(p);f[i>>2]=x;f[y>>2]=1032}}else{p=h+8|0;f[p>>2]=0;f[p+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;h_(a,h)}while(0);h=g+36|0;a=f[h>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(g);f[h>>2]=0;h=g+16|0;a=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[a>>2]|0)>0){h=f[g+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}g0(a);u=e;return}}function VZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,219801,d);return}function WZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;f$(a,d);a=f[d>>2]|0;g=f[e>>2]|0;UZ((a|0)==(g|0)?0:a,(g-a|0)/56|0,b);mx(d);u=c;return}function XZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if((k|0)!=0&(j|0)>0){l=a;m=d;n=g;o=k}else return;while(1){k=0;do{if(b[m+k>>0]|0)b[n+k>>0]=b[l+k>>0]|0;k=k+1|0}while((k|0)!=(j|0));o=o+-1|0;if(!o)break;else{l=l+c|0;m=m+e|0;n=n+h|0}}return}function YZ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;l=f[j+4>>2]|0;if((l|0)!=0&(k|0)>0){m=a;n=e;o=h;p=l}else return;while(1){l=0;do{if(b[n+l>>0]|0)d[o+(l<<1)>>1]=d[m+(l<<1)>>1]|0;l=l+1|0}while((l|0)!=(k|0));p=p+-1|0;if(!p)break;else{m=m+c|0;n=n+g|0;o=o+i|0}}return}function ZZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*3|0)|0;s=m+(q*3|0)|0;b[r>>0]=b[s>>0]|0;b[r+1>>0]=b[s+1>>0]|0;b[r+2>>0]=b[s+2>>0]|0}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*3|0)|0;l=m+(k*3|0)|0;b[p>>0]=b[l>>0]|0;b[p+1>>0]=b[l+1>>0]|0;b[p+2>>0]=b[l+2>>0]|0}l=k|1;if(b[a+l>>0]|0){p=d+(l*3|0)|0;q=m+(l*3|0)|0;b[p>>0]=b[q>>0]|0;b[p+1>>0]=b[q+1>>0]|0;b[p+2>>0]=b[q+2>>0]|0}q=k|2;if(b[a+q>>0]|0){p=d+(q*3|0)|0;l=m+(q*3|0)|0;b[p>>0]=b[l>>0]|0;b[p+1>>0]=b[l+1>>0]|0;b[p+2>>0]=b[l+2>>0]|0}l=k|3;if(b[a+l>>0]|0){p=d+(l*3|0)|0;q=m+(l*3|0)|0;b[p>>0]=b[q>>0]|0;b[p+1>>0]=b[q+1>>0]|0;b[p+2>>0]=b[q+2>>0]|0}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*3|0)|0;p=m+(k*3|0)|0;b[q>>0]=b[p>>0]|0;b[q+1>>0]=b[p+1>>0]|0;b[q+2>>0]=b[p+2>>0]|0}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function _Z(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0)f[o+(q<<2)>>2]=f[m+(q<<2)>>2];q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0)f[d+(k<<2)>>2]=f[m+(k<<2)>>2];p=k|1;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];p=k|2;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];p=k|3;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0)f[d+(k<<2)>>2]=f[m+(k<<2)>>2];k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function $Z(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=f[j>>2]|0;l=f[j+4>>2]|0;if(!l)return;j=k+-4|0;if((k|0)<4){m=(k|0)>0;n=a;o=e;p=h;q=l;while(1){q=q+-1|0;if(m){r=0;do{if(b[o+r>>0]|0){s=p+(r*6|0)|0;t=n+(r*6|0)|0;d[s>>1]=d[t>>1]|0;d[s+2>>1]=d[t+2>>1]|0;d[s+4>>1]=d[t+4>>1]|0}r=r+1|0}while((r|0)!=(k|0))}if(!q)break;else{n=n+c|0;o=o+g|0;p=p+i|0}}return}p=k&-4;o=(p|0)<(k|0);n=a;a=e;e=h;h=l;while(1){l=0;do{if(b[a+l>>0]|0){q=e+(l*6|0)|0;m=n+(l*6|0)|0;d[q>>1]=d[m>>1]|0;d[q+2>>1]=d[m+2>>1]|0;d[q+4>>1]=d[m+4>>1]|0}m=l|1;if(b[a+m>>0]|0){q=e+(m*6|0)|0;r=n+(m*6|0)|0;d[q>>1]=d[r>>1]|0;d[q+2>>1]=d[r+2>>1]|0;d[q+4>>1]=d[r+4>>1]|0}r=l|2;if(b[a+r>>0]|0){q=e+(r*6|0)|0;m=n+(r*6|0)|0;d[q>>1]=d[m>>1]|0;d[q+2>>1]=d[m+2>>1]|0;d[q+4>>1]=d[m+4>>1]|0}m=l|3;if(b[a+m>>0]|0){q=e+(m*6|0)|0;r=n+(m*6|0)|0;d[q>>1]=d[r>>1]|0;d[q+2>>1]=d[r+2>>1]|0;d[q+4>>1]=d[r+4>>1]|0}l=l+4|0}while((l|0)<=(j|0));h=h+-1|0;if(o){l=p;do{if(b[a+l>>0]|0){r=e+(l*6|0)|0;q=n+(l*6|0)|0;d[r>>1]=d[q>>1]|0;d[r+2>>1]=d[q+2>>1]|0;d[r+4>>1]=d[q+4>>1]|0}l=l+1|0}while((l|0)!=(k|0))}if(!h)break;else{n=n+c|0;a=a+g|0;e=e+i|0}}return}function a_(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=m+(q<<3)|0;s=f[r+4>>2]|0;t=o+(q<<3)|0;f[t>>2]=f[r>>2];f[t+4>>2]=s}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=m+(k<<3)|0;l=f[p+4>>2]|0;q=d+(k<<3)|0;f[q>>2]=f[p>>2];f[q+4>>2]=l}l=k|1;if(b[a+l>>0]|0){q=m+(l<<3)|0;p=f[q+4>>2]|0;s=d+(l<<3)|0;f[s>>2]=f[q>>2];f[s+4>>2]=p}p=k|2;if(b[a+p>>0]|0){s=m+(p<<3)|0;q=f[s+4>>2]|0;l=d+(p<<3)|0;f[l>>2]=f[s>>2];f[l+4>>2]=q}q=k|3;if(b[a+q>>0]|0){l=m+(q<<3)|0;s=f[l+4>>2]|0;p=d+(q<<3)|0;f[p>>2]=f[l>>2];f[p+4>>2]=s}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){s=m+(k<<3)|0;p=f[s+4>>2]|0;l=d+(k<<3)|0;f[l>>2]=f[s>>2];f[l+4>>2]=p}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function b_(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*12|0)|0;s=m+(q*12|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*12|0)|0;l=m+(k*12|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l*12|0)|0;q=m+(l*12|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q*12|0)|0;l=m+(q*12|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l*12|0)|0;q=m+(l*12|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*12|0)|0;p=m+(k*12|0)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function c_(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q<<4)|0;s=m+(q<<4)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k<<4)|0;l=m+(k<<4)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l<<4)|0;q=m+(l<<4)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q<<4)|0;l=m+(q<<4)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l<<4)|0;q=m+(l<<4)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k<<4)|0;p=m+(k<<4)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function d_(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*24|0)|0;s=m+(q*24|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*24|0)|0;l=m+(k*24|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l*24|0)|0;q=m+(l*24|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q*24|0)|0;l=m+(q*24|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l*24|0)|0;q=m+(l*24|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*24|0)|0;p=m+(k*24|0)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2];f[q+16>>2]=f[p+16>>2];f[q+20>>2]=f[p+20>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function e_(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q<<5)|0;s=m+(q<<5)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k<<5)|0;l=m+(k<<5)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2];f[p+24>>2]=f[l+24>>2];f[p+28>>2]=f[l+28>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l<<5)|0;q=m+(l<<5)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q<<5)|0;l=m+(q<<5)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2];f[p+24>>2]=f[l+24>>2];f[p+28>>2]=f[l+28>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l<<5)|0;q=m+(l<<5)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k<<5)|0;p=m+(k<<5)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2];f[q+16>>2]=f[p+16>>2];f[q+20>>2]=f[p+20>>2];f[q+24>>2]=f[p+24>>2];f[q+28>>2]=f[p+28>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function f_(a){a=a|0;var b=0;if(a>>>0<33){b=f[43804+(a<<2)>>2]|0;return ((b|0)==0?145:b)|0}else return 145;return 0}function g_(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=f[j>>2]|0;j=i+4|0;l=f[j>>2]|0;m=l+-1|0;f[j>>2]=m;if(!l)return;l=f[i>>2]|0;if(!k){n=(l|0)>0;o=m;do{if(n){p=0;do p=p+1|0;while((p|0)<(l|0))}p=o;o=o+-1|0}while((p|0)!=0);f[j>>2]=o;return}else{q=a;r=d;s=g;t=l;u=m}while(1){if((t|0)>0){m=s;l=q;g=0;d=t;while(1){if(!(b[r+g>>0]|0))v=d;else{a=0;do{b[m+a>>0]=b[l+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));v=f[i>>2]|0}g=g+1|0;if((g|0)>=(v|0))break;else{m=m+k|0;l=l+k|0;d=v}}w=f[j>>2]|0;x=v}else{w=u;x=t}u=w+-1|0;f[j>>2]=u;if(!w)break;else{q=q+c|0;r=r+e|0;s=s+h|0;t=x}}return}function h_(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+352|0;e=d+288|0;g=d+160|0;h=d;i=d+128|0;j=c$(c,-1)|0;if(X$(c)|0?(k=f[a>>2]|0,(j|0)!=(k&4095|0)):0){if((k^j)&4088|0){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,30)|0;m=219865;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));i_(-215,e,222385,254)}LZ(a,c,j,1.0,0.0);u=d;return}j=a+16|0;if(f[j>>2]|0){k=a+4|0;o=f[k>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[a+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if(!((o|0)==0|(p|0)==0)){p=(d$(c)|0)==655360;o=f[k>>2]|0;if(p){p=a+40|0;w$(c,o,f[p>>2]|0,f[a>>2]&4095,-1,0,0);e$(e,c,-1);s=e+24|0;if(!(f[s>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,13)|0;m=219896;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));i_(-215,g,222385,269)}l=g;n=l+128|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));r=f[k>>2]|0;if((r|0)<=0){f[i>>2]=0;v=i+4|0;f[v>>2]=0;w=tT(i,29)|0;l=w;m=219910;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));i_(-215,i,222385,271)}q=r+-1|0;t=f[(f[a+44>>2]|0)+(q<<2)>>2]|0;if(q>>>0>=31){f[i>>2]=0;v=i+4|0;f[v>>2]=0;w=tT(i,29)|0;l=w;m=219910;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));i_(-215,i,222385,271)}m=f[p>>2]|0;p=0;do{f[g+(p<<2)>>2]=f[m+(p<<2)>>2];p=p+1|0}while(p>>>0<r>>>0);p=g+(r+-1<<2)|0;r=Y(f[p>>2]|0,t)|0;f[p>>2]=r;RQ(e,h);r=f[k>>2]|0;p=h+(r+-1<<2)|0;m=Y(f[p>>2]|0,t)|0;f[p>>2]=m;m=f[s>>2]|0;s=f[m+4>>2]|0;wi[f[(f[s>>2]|0)+32>>2]&255](s,m,f[j>>2]|0,r,g,h,f[e+36>>2]|0,f[a+44>>2]|0);GQ(e);u=d;return}if((o|0)>=3){r=a+40|0;w$(c,o,f[r>>2]|0,f[a>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){o=f[c+4>>2]|0;f[e>>2]=f[o>>2];m=e+4|0;s=o+4|0;f[m>>2]=f[s>>2];p=e+8|0;f[p>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];t=e+16|0;f[t>>2]=f[o+16>>2];f[e+20>>2]=f[o+20>>2];f[e+24>>2]=f[o+24>>2];f[e+28>>2]=f[o+28>>2];f[e+32>>2]=f[o+32>>2];l=f[o+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=p;p=e+48|0;n=e+44|0;f[n>>2]=p;f[p>>2]=0;f[e+52>>2]=0;if(l|0){p=l+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[s>>2]|0)<3){s=f[o+44>>2]|0;p=f[n>>2]|0;f[p>>2]=f[s>>2];f[p+4>>2]=f[s+4>>2];x=t;break}else{f[m>>2]=0;ZS(e,o);x=t;break}}else{a$(e,c,-1);x=e+16|0}while(0);if((f[j>>2]|0)!=(f[x>>2]|0)){t=f[k>>2]|0;if((t|0)<3)y=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{o=f[r>>2]|0;r=0;m=1;while(1){s=Y(f[o+(r<<2)>>2]|0,m)|0;r=r+1|0;if((r|0)==(t|0)){y=s;break}else m=s}}if(y|0){f[g>>2]=a;f[g+4>>2]=e;y=h;f[y>>2]=0;f[y+4>>2]=0;z2(i,g,h,2);y=f[k>>2]|0;if((y|0)>0)z=f[(f[a+44>>2]|0)+(y+-1<<2)>>2]|0;else z=0;y=Y(z,f[i+20>>2]|0)|0;z=i+16|0;m=h+4|0;t=0;while(1){if(t>>>0>=(f[z>>2]|0)>>>0)break;dJc(f[m>>2]|0,f[h>>2]|0,y|0)|0;A2(i)|0;t=t+1|0}}}t=e+36|0;i=f[t>>2]|0;if(i|0?(y=i+12|0,i=f[y>>2]|0,f[y>>2]=i+-1,(i|0)==1):0)_S(e);f[t>>2]=0;t=e+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[t>>2]|0)>0){x=f[e+40>>2]|0;i=0;do{f[x+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[t>>2]|0))}t=f[e+44>>2]|0;if((t|0)!=(e+48|0))g0(t);u=d;return}t=a+8|0;i=a+12|0;Y$(c,f[t>>2]|0,f[i>>2]|0,f[a>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){x=f[c+4>>2]|0;f[e>>2]=f[x>>2];y=e+4|0;m=x+4|0;f[y>>2]=f[m>>2];z=e+8|0;f[z>>2]=f[x+8>>2];f[e+12>>2]=f[x+12>>2];r=e+16|0;f[r>>2]=f[x+16>>2];f[e+20>>2]=f[x+20>>2];f[e+24>>2]=f[x+24>>2];f[e+28>>2]=f[x+28>>2];f[e+32>>2]=f[x+32>>2];o=f[x+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=z;z=e+48|0;s=e+44|0;f[s>>2]=z;f[z>>2]=0;f[e+52>>2]=0;if(o|0){z=o+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[m>>2]|0)<3){m=f[x+44>>2]|0;z=f[s>>2]|0;f[z>>2]=f[m>>2];f[z+4>>2]=f[m+4>>2];A=r;break}else{f[y>>2]=0;ZS(e,x);A=r;break}}else{a$(e,c,-1);A=e+16|0}while(0);r=f[j>>2]|0;j=r;if(((r|0)!=(f[A>>2]|0)?(r=f[t>>2]|0,(r|0)>0):0)?(t=f[i>>2]|0,(t|0)>0):0){f[g>>2]=f[a>>2];i=g+4|0;x=f[k>>2]|0;f[i>>2]=x;y=g+8|0;f[y>>2]=r;f[g+12>>2]=t;t=g+16|0;f[t>>2]=j;f[g+20>>2]=f[a+20>>2];f[g+24>>2]=f[a+24>>2];f[g+28>>2]=f[a+28>>2];f[g+32>>2]=f[a+32>>2];j=g+36|0;r=f[a+36>>2]|0;f[j>>2]=r;m=g+40|0;f[m>>2]=y;y=g+48|0;z=g+44|0;f[z>>2]=y;f[y>>2]=0;f[g+52>>2]=0;if(!r)B=x;else{x=r+12|0;f[x>>2]=(f[x>>2]|0)+1;B=f[k>>2]|0}if((B|0)<3){B=f[a+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[B>>2];f[x+4>>2]=f[B+4>>2]}else{f[i>>2]=0;ZS(g,a)}B=f[k>>2]|0;if((B|0)>0)C=f[(f[a+44>>2]|0)+(B+-1<<2)>>2]|0;else C=0;rT(h,g,e,C);C=f[h>>2]|0;if((C|0)<=-1)_1(C,0,43936);B=f[t>>2]|0;a=f[A>>2]|0;k=h+4|0;x=f[k>>2]|0;f[k>>2]=x+-1;if(x|0?(x=e+48|0,dJc(a|0,B|0,C|0)|0,C=f[y>>2]|0,r=f[x>>2]|0,s=f[k>>2]|0,f[k>>2]=s+-1,s|0):0){s=a;a=B;B=r;r=C;do{s=s+B|0;a=a+r|0;dJc(s|0,a|0,f[h>>2]|0)|0;r=f[y>>2]|0;B=f[x>>2]|0;C=f[k>>2]|0;f[k>>2]=C+-1}while((C|0)!=0)}k=f[j>>2]|0;if(k|0?(x=k+12|0,k=f[x>>2]|0,f[x>>2]=k+-1,(k|0)==1):0)_S(g);f[j>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[i>>2]|0)>0){t=f[m>>2]|0;m=0;do{f[t+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[i>>2]|0))}i=f[z>>2]|0;if((i|0)!=(y|0))g0(i)}i=e+36|0;y=f[i>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)_S(e);f[i>>2]=0;i=e+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[i>>2]|0)>0){A=f[e+40>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)!=(e+48|0))g0(i);u=d;return}}u$(c);u=d;return}function i_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,219980,d);return}function j_(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+288|0;g=e+232|0;h=e+176|0;i=e+120|0;j=e;k=e+88|0;l=e+112|0;m=e+56|0;n=e+104|0;do if((d$(d)|0)==65536){o=f[d+4>>2]|0;f[g>>2]=f[o>>2];p=g+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];s=g+16|0;f[s>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];t=f[o+36>>2]|0;f[g+36>>2]=t;f[g+40>>2]=r;r=g+48|0;v=g+44|0;f[v>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(t|0){r=t+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=s;break}else{f[p>>2]=0;ZS(g,o);w=s;break}}else{a$(g,d,-1);w=g+16|0}while(0);if(f[w>>2]|0){d=f[g>>2]|0;s=d>>>3&511;o=s+1|0;if(d&7|0){f[h>>2]=0;x=h+4|0;f[x>>2]=0;y=tT(h,48)|0;z=y;A=220052;B=z+48|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));i_(-215,h,222385,372)}d=(s|0)==0;if(!(d|(s|0)==((f[a>>2]|0)>>>3&511|0))){f[h>>2]=0;x=h+4|0;f[x>>2]=0;y=tT(h,48)|0;z=y;A=220052;B=z+48|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));i_(-215,h,222385,372)}y=a+4|0;if((f[y>>2]|0)<3?(x=f[a+40>>2]|0,s=f[g+40>>2]|0,!((f[x>>2]|0)==(f[s>>2]|0)?(f[x+4>>2]|0)==(f[s+4>>2]|0):0)):0){f[h>>2]=0;f[h+4>>2]=0;z=tT(h,21)|0;A=220101;B=z+21|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));i_(-215,h,222385,376)}f[h>>2]=1124007936;A=h+4|0;s=h+8|0;x=h+40|0;z=A;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[x>>2]=s;z=h+48|0;B=h+44|0;f[B>>2]=z;f[z>>2]=0;f[h+52>>2]=0;do if((d$(c)|0)==65536){p=f[c+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];v=i+8|0;f[v>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=v;v=i+48|0;C=i+44|0;f[C>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(t|0){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;v=f[C>>2]|0;f[v>>2]=f[r>>2];f[v+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;ZS(i,p);break}}else a$(i,c,-1);while(0);w$(c,f[y>>2]|0,f[a+40>>2]|0,f[a>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){p=f[c+4>>2]|0;f[j>>2]=f[p>>2];q=j+4|0;r=p+4|0;f[q>>2]=f[r>>2];v=j+8|0;f[v>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];f[j+32>>2]=f[p+32>>2];C=j+36|0;t=f[p+36>>2]|0;f[C>>2]=t;f[j+40>>2]=v;v=j+48|0;D=j+44|0;f[D>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(t|0){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;v=f[D>>2]|0;f[v>>2]=f[r>>2];f[v+4>>2]=f[r+4>>2];E=C;break}else{f[q>>2]=0;ZS(j,p);E=C;break}}else{a$(j,c,-1);E=j+36|0}while(0);C=f[E>>2]|0;if(C|0){p=C+12|0;f[p>>2]=(f[p>>2]|0)+1}p=h+36|0;C=f[p>>2]|0;if(C|0?(q=C+12|0,C=f[q>>2]|0,f[q>>2]=C+-1,(C|0)==1):0)_S(h);f[p>>2]=0;C=h+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[A>>2]|0)>0){q=f[x>>2]|0;r=0;do{f[q+(r<<2)>>2]=0;r=r+1|0;F=f[A>>2]|0}while((r|0)<(F|0));f[h>>2]=f[j>>2];if((F|0)<3)G=40;else G=42}else{f[h>>2]=f[j>>2];G=40}if((G|0)==40){F=f[j+4>>2]|0;if((F|0)<3){f[A>>2]=F;f[s>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];s=f[j+44>>2]|0;F=f[B>>2]|0;f[F>>2]=f[s>>2];f[F+4>>2]=f[s+4>>2]}else G=42}if((G|0)==42)ZS(h,j);s=j+16|0;f[C>>2]=f[s>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];F=f[E>>2]|0;f[p>>2]=F;if(F|0?(r=F+12|0,F=f[r>>2]|0,f[r>>2]=F+-1,(F|0)==1):0)_S(j);f[E>>2]=0;E=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[E>>2]|0)>0){s=f[j+40>>2]|0;F=0;do{f[s+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[E>>2]|0))}E=f[j+44>>2]|0;if((E|0)!=(j+48|0))g0(E);E=i+16|0;if((f[C>>2]|0)!=(f[E>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;k_(h,j)|0}F=i+36|0;s=f[F>>2]|0;if(s|0?(r=s+12|0,s=f[r>>2]|0,f[r>>2]=s+-1,(s|0)==1):0)_S(i);f[F>>2]=0;F=i+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[F>>2]|0)>0){E=f[i+40>>2]|0;s=0;do{f[E+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[F>>2]|0))}F=f[i+44>>2]|0;if((F|0)!=(i+48|0))g0(F);do if(d){F=f[y>>2]|0;if((F|0)<=0){H=0;I=F;G=64;break}s=f[(f[a+44>>2]|0)+(F+-1<<2)>>2]|0;f[i>>2]=s;if(s>>>0<33){J=s;K=F;G=66}else{L=F;M=145}}else{H=1212424721>>>(f[a>>2]<<2&28)&15;I=f[y>>2]|0;G=64}while(0);if((G|0)==64){f[i>>2]=H;J=H;K=I;G=66}if((G|0)==66){I=f[43804+(J<<2)>>2]|0;L=K;M=(I|0)==0?145:I}if((L|0)<3){f[j>>2]=f[a>>2];I=j+4|0;f[I>>2]=L;L=j+8|0;f[L>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];K=j+16|0;f[K>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];J=j+36|0;H=f[a+36>>2]|0;f[J>>2]=H;d=j+40|0;f[d>>2]=L;L=j+48|0;F=j+44|0;f[F>>2]=L;f[L>>2]=0;f[j+52>>2]=0;do if(!H)G=70;else{s=H+12|0;f[s>>2]=(f[s>>2]|0)+1;if((f[y>>2]|0)<3){G=70;break}f[I>>2]=0;ZS(j,a)}while(0);if((G|0)==70){G=f[a+44>>2]|0;y=f[F>>2]|0;f[y>>2]=f[G>>2];f[y+4>>2]=f[G+4>>2]}sT(k,j,h,g,o);G=f[K>>2]|0;y=f[L>>2]|0;H=f[w>>2]|0;s=f[g+48>>2]|0;E=f[C>>2]|0;r=f[z>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];wi[M&255](G,y,H,s,E,r,l,i);l=f[J>>2]|0;do if(l|0){r=l+12|0;E=f[r>>2]|0;f[r>>2]=E+-1;if((E|0)!=1)break;_S(j)}while(0);f[J>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[I>>2]|0)>0){K=f[d>>2]|0;d=0;do{f[K+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[I>>2]|0))}I=f[F>>2]|0;if((I|0)!=(L|0))g0(I)}else{f[j>>2]=a;f[j+4>>2]=h;f[j+8>>2]=g;f[j+12>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;z2(m,j,k,-1);j=Y(f[m+20>>2]|0,o)|0;o=m+16|0;I=k+8|0;L=k+4|0;F=n+4|0;d=0;while(1){if(d>>>0>=(f[o>>2]|0)>>>0)break;K=f[k>>2]|0;J=f[I>>2]|0;l=f[L>>2]|0;f[n>>2]=j;f[F>>2]=1;wi[M&255](K,0,J,0,l,0,n,i);A2(m)|0;d=d+1|0}}d=f[p>>2]|0;do if(d|0){m=d+12|0;i=f[m>>2]|0;f[m>>2]=i+-1;if((i|0)!=1)break;_S(h)}while(0);f[p>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[A>>2]|0)>0){C=f[x>>2]|0;x=0;do{f[C+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[A>>2]|0))}A=f[B>>2]|0;if((A|0)!=(z|0))g0(A)}else h_(a,c);c=g+36|0;a=f[c>>2]|0;if(a|0?(A=a+12|0,a=f[A>>2]|0,f[A>>2]=a+-1,(a|0)==1):0)_S(g);f[c>>2]=0;c=g+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[c>>2]|0)>0){w=f[g+40>>2]|0;a=0;do{f[w+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)==(g+48|0)){u=e;return}g0(c);u=e;return}function k_(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+144|0;e=d+140|0;g=d+136|0;h=d+104|0;i=d;j=d+96|0;k=a+16|0;if(!(f[k>>2]|0)){u=d;return a|0}l=a+4|0;m=f[l>>2]|0;if((m|0)<3)n=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{o=f[a+40>>2]|0;p=0;q=1;while(1){r=Y(f[o+(p<<2)>>2]|0,q)|0;p=p+1|0;if((p|0)==(m|0)){n=r;break}else q=r}}if((m|0)==0|(n|0)==0){u=d;return a|0}f[e>>2]=a;z2(h,e,g,1);e=f[l>>2]|0;if((e|0)>0)s=f[(f[a+44>>2]|0)+(e+-1<<2)>>2]|0;else s=0;e=Y(s,f[h+20>>2]|0)|0;s=c;if((((f[s>>2]|0)==0&(f[s+4>>2]|0)==0?(s=c+8|0,(f[s>>2]|0)==0&(f[s+4>>2]|0)==0):0)?(s=c+16|0,(f[s>>2]|0)==0&(f[s+4>>2]|0)==0):0)?(s=c+24|0,(f[s>>2]|0)==0&(f[s+4>>2]|0)==0):0){s=h+16|0;if(f[s>>2]|0){l=0;do{XIc(f[g>>2]|0,0,e|0)|0;l=l+1|0;A2(h)|0}while(l>>>0<(f[s>>2]|0)>>>0)}}else t=15;if((t|0)==15?(t=h+16|0,f[t>>2]|0):0){c1(c,i,f[a>>2]&4095,12);c=(1212424721>>>(f[a>>2]<<2&28)&15)*12|0;a:do if(e|0){s=0;while(1){l=e-s|0;n=c>>>0>l>>>0?l:c;if(n>>>0>=97)break;dJc((f[g>>2]|0)+s|0,i|0,n|0)|0;s=s+c|0;if(e>>>0<=s>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;s=tT(j,20)|0;n=220123;l=s+20|0;do{b[s>>0]=b[n>>0]|0;s=s+1|0;n=n+1|0}while((s|0)<(l|0));i_(-215,j,518179,446)}while(0);if((f[t>>2]|0)>>>0>1){j=1;do{A2(h)|0;dJc(f[g>>2]|0,f[k>>2]|0,e|0)|0;j=j+1|0}while(j>>>0<(f[t>>2]|0)>>>0)}}u=d;return a|0}function l_(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+1232|0;g=e+1168|0;h=e+1112|0;i=e+1104|0;j=e+1088|0;k=e;l=e+1048|0;m=e+8|0;n=e+1080|0;if(!(f[a+16>>2]|0)){u=e;return a|0}o=a+4|0;p=f[o>>2]|0;if((p|0)<3)q=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{r=f[a+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(p|0)){q=v;break}else t=v}}if((p|0)==0|(q|0)==0){u=e;return a|0}do if((d$(c)|0)==65536){q=f[c+4>>2]|0;f[g>>2]=f[q>>2];p=g+4|0;t=q+4|0;f[p>>2]=f[t>>2];s=g+8|0;f[s>>2]=f[q+8>>2];f[g+12>>2]=f[q+12>>2];f[g+16>>2]=f[q+16>>2];f[g+20>>2]=f[q+20>>2];f[g+24>>2]=f[q+24>>2];f[g+28>>2]=f[q+28>>2];f[g+32>>2]=f[q+32>>2];r=f[q+36>>2]|0;f[g+36>>2]=r;f[g+40>>2]=s;s=g+48|0;v=g+44|0;f[v>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[t>>2]|0)<3){t=f[q+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];break}else{f[p>>2]=0;ZS(g,q);break}}else a$(g,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];q=h+4|0;p=c+4|0;f[q>>2]=f[p>>2];t=h+8|0;f[t>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];s=f[c+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=t;t=h+48|0;v=h+44|0;f[v>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[p>>2]|0)<3){p=f[c+44>>2]|0;t=f[v>>2]|0;f[t>>2]=f[p>>2];f[t+4>>2]=f[p+4>>2];break}else{f[q>>2]=0;ZS(h,c);break}}else a$(h,d,-1);while(0);d=f[a>>2]|0;c=g+4|0;if((f[c>>2]|0)>2){f[i>>2]=0;w=i+4|0;f[w>>2]=0;x=tT(i,60)|0;y=x;z=220144;A=y+60|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,528)}q=f[g>>2]|0;if(!(q&16384)){f[i>>2]=0;w=i+4|0;f[w>>2]=0;x=tT(i,60)|0;y=x;z=220144;A=y+60|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,528)}p=g+40|0;t=f[p>>2]|0;v=f[t+4>>2]|0;s=f[t>>2]|0;t=(v|0)==1;r=(s|0)==1;if(!(t|r)){f[i>>2]=0;w=i+4|0;f[w>>2]=0;x=tT(i,60)|0;y=x;z=220144;A=y+60|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,528)}B=(d>>>3&511)+1|0;if(!((v|0)==(B|0)&r|t&(r|(s|0)==(B|0)))?B>>>0>4|(q&4095|0)!=6|t&(s|0)==4^1:0){f[i>>2]=0;w=i+4|0;f[w>>2]=0;x=tT(i,60)|0;y=x;z=220144;A=y+60|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,528)}x=f[a>>2]|0;w=x>>>3&511;s=f[h>>2]|0;t=s>>>3&511;q=t+1|0;B=h+16|0;r=(f[B>>2]|0)==0;a:do if(!r){v=f[h+4>>2]|0;if((v|0)<3)C=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{d=f[h+40>>2]|0;D=0;E=1;while(1){F=Y(f[d+(D<<2)>>2]|0,E)|0;D=D+1|0;if((D|0)==(v|0)){C=F;break}else E=F}}if(!((v|0)==0|(C|0)==0)){if(s&7|0){f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,87)|0;y=H;z=220205;A=y+87|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,530)}if(!((t|0)==0|(t|0)==(w|0))){f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,87)|0;y=H;z=220205;A=y+87|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,530)}v=f[a+40>>2]|0;E=f[v+-4>>2]|0;D=f[h+40>>2]|0;if((E|0)!=(f[D+-4>>2]|0)){f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,87)|0;y=H;z=220205;A=y+87|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,530)}if((E|0)==2){if((f[v>>2]|0)!=(f[D>>2]|0)){f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,87)|0;y=H;z=220205;A=y+87|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,530)}if((f[v+4>>2]|0)==(f[D+4>>2]|0))break;f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,87)|0;y=H;z=220205;A=y+87|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,530)}else{if((E|0)>0)I=0;else break;while(1){if((f[v+(I<<2)>>2]|0)!=(f[D+(I<<2)>>2]|0))break;I=I+1|0;if((I|0)>=(E|0))break a}f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,87)|0;y=H;z=220205;A=y+87|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));i_(-215,i,224205,530)}}}while(0);if(!t){t=f[o>>2]|0;if((t|0)>0){o=f[(f[a+44>>2]|0)+(t+-1<<2)>>2]|0;f[i>>2]=o;if(o>>>0<33){J=o;K=48}else L=145}else{M=0;K=46}}else{M=1212424721>>>(x<<2&28)&15;K=46}if((K|0)==46){f[i>>2]=M;J=M;K=48}if((K|0)==48){M=f[43804+(J<<2)>>2]|0;L=(M|0)==0?145:M}f[j>>2]=a;if(!r){r=f[h+4>>2]|0;if((r|0)<3)N=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{M=f[h+40>>2]|0;J=0;x=1;while(1){o=Y(f[M+(J<<2)>>2]|0,x)|0;J=J+1|0;if((J|0)==(r|0)){N=o;break}else x=o}}x=j+4|0;if((r|0)==0|(N|0)==0){O=x;K=56}else{P=h;Q=x}}else{O=j+4|0;K=56}if((K|0)==56){P=0;Q=O}f[Q>>2]=P;f[j+8>>2]=0;P=k;f[P>>2]=0;f[P+4>>2]=0;z2(l,j,k,-1);j=Y(f[l+20>>2]|0,q)|0;P=f[i>>2]|0;Q=((P+1023|0)>>>0)/(P>>>0)|0;O=(Q|0)<(j|0)?Q:j;Q=O-((O|0)%(q|0)|0)|0;K=(Y(Q,P)|0)+32|0;P=m+8|0;f[m>>2]=P;x=m+4|0;f[x>>2]=K;if(K>>>0>1032){N=XDc(K)|0;f[m>>2]=N;R=N}else R=P;N=R+7&-8;cL(g,f[a>>2]&4095,N,(O|0)/(q|0)|0);q=l+16|0;O=k+4|0;R=n+4|0;b:do if((j|0)>0){K=0;while(1){if(K>>>0>=(f[q>>2]|0)>>>0)break b;r=0;J=f[k>>2]|0;do{M=j-r|0;o=(M|0)<(Q|0)?M:Q;M=Y(f[i>>2]|0,o)|0;t=f[O>>2]|0;if(!t)dJc(J|0,N|0,M|0)|0;else{f[n>>2]=o;f[R>>2]=1;wi[L&255](N,0,t,0,J,0,n,i);f[O>>2]=(f[O>>2]|0)+o}J=(f[k>>2]|0)+M|0;f[k>>2]=J;r=r+Q|0}while((j|0)>(r|0));A2(l)|0;K=K+1|0}}else{K=0;while(1){if(K>>>0>=(f[q>>2]|0)>>>0)break b;A2(l)|0;K=K+1|0}}while(0);l=f[m>>2]|0;if((l|0)!=(P|0)){if(l|0)ZDc(l);f[m>>2]=P;f[x>>2]=1032}x=h+36|0;P=f[x>>2]|0;if(P|0?(m=P+12|0,P=f[m>>2]|0,f[m>>2]=P+-1,(P|0)==1):0)_S(h);f[x>>2]=0;x=h+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[x>>2]|0)>0){B=f[h+40>>2]|0;P=0;do{f[B+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)!=(h+48|0))g0(x);x=g+36|0;h=f[x>>2]|0;do if(h|0){P=h+12|0;B=f[P>>2]|0;f[P>>2]=B+-1;if((B|0)!=1)break;_S(g)}while(0);f[x>>2]=0;x=g+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[c>>2]|0)>0){x=f[p>>2]|0;p=0;do{f[x+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))g0(c);u=e;return a|0}function m_(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=u;u=u+144|0;g=e+136|0;h=e+72|0;i=e+128|0;j=e+16|0;k=e+8|0;l=e;if((n$(a,-1)|0)>=3){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,16)|0;n=220293;o=m+16|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,g,220310,747)}b$(g,a,-1);n=f[g>>2]|0;if((d|0)<0)p=(f[g+4>>2]|0)==1?1:(n|0)==1?0:d;else p=d;d=(n|0)==1;if((!((p|0)>0&d)?(n=g+4|0,m=(f[n>>2]|0)==1,!((p|0)==0&m)):0)?(o=(p|0)<0,!(o&d&m)):0){do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[h>>2]=f[m>>2];d=h+4|0;q=m+4|0;f[d>>2]=f[q>>2];r=h+8|0;f[r>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];s=f[m+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=r;r=h+48|0;t=h+44|0;f[t>>2]=r;f[r>>2]=0;f[h+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[m+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];v=h;break}else{f[d>>2]=0;ZS(h,m);v=h;break}}else{a$(h,a,-1);v=h}while(0);m=f[v>>2]|0;v=m&4095;f[i>>2]=f[g>>2];f[i+4>>2]=f[n>>2];v$(c,i,v,-1,0,0);do if((d$(c)|0)==65536){i=f[c+4>>2]|0;f[j>>2]=f[i>>2];n=j+4|0;g=i+4|0;f[n>>2]=f[g>>2];d=j+8|0;f[d>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];q=j+16|0;f[q>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];r=f[i+36>>2]|0;f[j+36>>2]=r;f[j+40>>2]=d;d=j+48|0;t=j+44|0;f[t>>2]=d;f[d>>2]=0;f[j+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[g>>2]|0)<3){g=f[i+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[g>>2];f[s+4>>2]=f[g+4>>2];w=q;x=t;y=d;break}else{f[n>>2]=0;ZS(j,i);w=q;x=t;y=d;break}}else{a$(j,c,-1);w=j+16|0;x=j+44|0;y=j+48|0}while(0);d=(m>>>3&511)+1<<(47696>>>(v<<1&14)&3);v=h+16|0;m=f[v>>2]|0;t=h+44|0;q=h+48|0;i=f[q>>2]|0;n=f[w>>2]|0;g=f[y>>2]|0;s=h+40|0;r=f[s>>2]|0;z=f[r+4>>2]|0;A=f[r>>2]|0;a:do if((p|0)<1){r=A+-1|0;B=Y(z,d)|0;if((A|0)>0){C=n+(Y(r,g)|0)|0;D=m+(Y(r,i)|0)|0;r=0-i|0;E=0-g|0;F=B+-4|0;G=B+-16|0;H=(A+1|0)/2|0;if((B|0)<16){I=B&-4;J=(B|0)<4;K=D;L=C;M=0;N=m;O=n;while(1){if(((O|N|K|L)&3|0)!=0|J)P=0;else{Q=0;do{R=f[N+Q>>2]|0;f[O+Q>>2]=f[K+Q>>2];f[L+Q>>2]=R;Q=Q+4|0}while((Q|0)<=(F|0));P=I}if((P|0)<(B|0)){Q=P;do{R=b[N+Q>>0]|0;b[O+Q>>0]=b[K+Q>>0]|0;b[L+Q>>0]=R;Q=Q+1|0}while((Q|0)!=(B|0))}M=M+1|0;if((M|0)>=(H|0))break a;else{K=K+r|0;L=L+E|0;N=N+i|0;O=O+g|0}}}O=B&-16;N=(O|0)>(F|0);L=D;K=C;M=0;I=m;J=n;while(1){if(!((J|I|L|K)&3)){Q=0;do{R=I+Q|0;S=f[R>>2]|0;T=L+Q|0;U=J+Q|0;f[U>>2]=f[T>>2];V=K+Q|0;f[V>>2]=S;S=f[R+4>>2]|0;f[U+4>>2]=f[T+4>>2];f[V+4>>2]=S;S=f[R+8>>2]|0;f[U+8>>2]=f[T+8>>2];f[V+8>>2]=S;S=f[R+12>>2]|0;f[U+12>>2]=f[T+12>>2];f[V+12>>2]=S;Q=Q+16|0}while((Q|0)<=(G|0));if(N)W=O;else{Q=O;while(1){S=f[I+Q>>2]|0;f[J+Q>>2]=f[L+Q>>2];f[K+Q>>2]=S;S=Q+4|0;if((S|0)>(F|0)){W=S;break}else Q=S}}}else W=0;if((W|0)<(B|0)){Q=W;do{S=b[I+Q>>0]|0;b[J+Q>>0]=b[L+Q>>0]|0;b[K+Q>>0]=S;Q=Q+1|0}while((Q|0)!=(B|0))}M=M+1|0;if((M|0)>=(H|0))break;else{L=L+r|0;K=K+E|0;I=I+i|0;J=J+g|0}}}}else{f[k>>2]=z;f[k+4>>2]=A;n_(m,i,n,g,k,d)}while(0);if(o){o=f[w>>2]|0;k=f[y>>2]|0;g=f[j+40>>2]|0;n=f[g>>2]|0;f[l>>2]=f[g+4>>2];f[l+4>>2]=n;n_(o,k,o,k,l,d)}d=j+36|0;l=f[d>>2]|0;if(l|0?(k=l+12|0,l=f[k>>2]|0,f[k>>2]=l+-1,(l|0)==1):0)_S(j);f[d>>2]=0;d=j+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[d>>2]|0)>0){w=f[j+40>>2]|0;j=0;do{f[w+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[d>>2]|0))}d=f[x>>2]|0;if((d|0)!=(y|0))g0(d);d=h+36|0;y=f[d>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)_S(h);f[d>>2]=0;d=h+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[d>>2]|0)>0){v=f[s>>2]|0;s=0;do{f[v+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[d>>2]|0))}d=f[t>>2]|0;if((d|0)!=(q|0))g0(d);u=e;return}t$(a,c);u=e;return}function n_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+1072|0;j=i;k=f[g>>2]|0;l=Y((k+1|0)/2|0,h)|0;m=Y(k,h)|0;n=j+8|0;f[j>>2]=n;o=j+4|0;f[o>>2]=m;if(m>>>0>264){p=XDc(m>>>0>1073741823?-1:m<<2)|0;f[j>>2]=p;q=p}else q=n;a:do if((k|0)>0){if(!h){p=0;while(1){p=p+1|0;if((p|0)>=(k|0))break a}}p=f[g>>2]|0;m=(h|0)==1;r=0;s=k;while(1){t=~r;v=Y(r,h)|0;w=Y(s+t|0,h)|0;f[q+(v<<2)>>2]=w;if(!m){w=Y((f[g>>2]|0)+t|0,h)|0;t=1;do{f[q+(t+v<<2)>>2]=w+t;t=t+1|0}while((t|0)!=(h|0))}t=r+1|0;if((t|0)<(p|0)){r=t;s=p}else break}}while(0);h=g+4|0;g=f[h>>2]|0;k=g+-1|0;f[h>>2]=k;do if(!g)x=q;else{if((l|0)>0){y=d;z=a}else{p=k;do{s=p;p=p+-1|0}while((s|0)!=0);f[h>>2]=p;x=q;break}while(1){s=0;do{r=f[q+(s<<2)>>2]|0;m=b[z+s>>0]|0;b[y+s>>0]=b[z+r>>0]|0;b[y+r>>0]=m;s=s+1|0}while((s|0)!=(l|0));s=f[h>>2]|0;f[h>>2]=s+-1;if(!s)break;else{y=y+e|0;z=z+c|0}}x=f[j>>2]|0}while(0);if((x|0)==(n|0)){u=i;return}if(x|0)ZDc(x);f[j>>2]=n;f[o>>2]=264;u=i;return}function o_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;k=a+4|0;l=e+4|0;if((f[k>>2]|0)==(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,30)|0;n=220315;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,h,220346,867)}if((n$(a,-1)|0)>=3){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,16)|0;n=220293;o=m+16|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,h,220346,868)}if(!((c|0)>0&(d|0)>0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,16)|0;n=220353;o=m+16|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,h,220346,869)}b$(h,a,-1);n=h+4|0;m=Y(f[n>>2]|0,c)|0;c=Y(f[h>>2]|0,d)|0;Y$(e,m,c,c$(a,-1)|0,-1,0,0);do if((d$(a)|0)==65536){c=f[k>>2]|0;f[i>>2]=f[c>>2];m=i+4|0;d=c+4|0;f[m>>2]=f[d>>2];o=i+8|0;f[o>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];p=f[c+36>>2]|0;f[i+36>>2]=p;f[i+40>>2]=o;o=i+48|0;q=i+44|0;f[q>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[d>>2]|0)<3){d=f[c+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];break}else{f[m>>2]=0;ZS(i,c);break}}else a$(i,a,-1);while(0);do if((d$(e)|0)==65536){a=f[l>>2]|0;f[j>>2]=f[a>>2];k=j+4|0;c=a+4|0;f[k>>2]=f[c>>2];m=j+8|0;f[m>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];d=f[a+36>>2]|0;f[j+36>>2]=d;o=j+40|0;f[o>>2]=m;m=j+48|0;q=j+44|0;f[q>>2]=m;f[m>>2]=0;f[j+52>>2]=0;if(d|0){m=d+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[c>>2]|0)<3){c=f[a+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];r=o;break}else{f[k>>2]=0;ZS(j,a);r=o;break}}else{a$(j,e,-1);r=j+40|0}while(0);e=f[r>>2]|0;l=f[e+4>>2]|0;o=f[e>>2]|0;e=i+4|0;a=f[e>>2]|0;if((a|0)>0)s=f[(f[i+44>>2]|0)+(a+-1<<2)>>2]|0;else s=0;a=Y(f[h>>2]|0,s)|0;f[h>>2]=a;k=Y(s,l)|0;l=f[n>>2]|0;a:do if((l|0)>0){s=j+16|0;c=j+44|0;m=i+16|0;q=i+44|0;if((k|0)>0){t=0;v=a}else{d=0;while(1){p=d+1|0;if((p|0)<(l|0))d=p;else{w=p;x=l;break a}}}while(1){d=0;p=v;do{y=(f[s>>2]|0)+(Y(f[f[c>>2]>>2]|0,t)|0)+d|0;dJc(y|0,(f[m>>2]|0)+(Y(f[f[q>>2]>>2]|0,t)|0)|0,p|0)|0;p=f[h>>2]|0;d=p+d|0}while((d|0)<(k|0));d=t+1|0;y=f[n>>2]|0;if((d|0)<(y|0)){t=d;v=p}else{w=d;x=y;break}}}else{w=0;x=l}while(0);if((w|0)<(o|0)?(l=j+16|0,v=j+44|0,t=f[l>>2]|0,h=f[f[v>>2]>>2]|0,dJc(t+(Y(h,w)|0)|0,t+(Y(w-x|0,h)|0)|0,k|0)|0,h=w+1|0,(h|0)!=(o|0)):0){w=h;do{h=f[l>>2]|0;x=f[f[v>>2]>>2]|0;dJc(h+(Y(x,w)|0)|0,h+(Y(w-(f[n>>2]|0)|0,x)|0)|0,k|0)|0;w=w+1|0}while((w|0)!=(o|0))}o=j+36|0;w=f[o>>2]|0;if(w|0?(k=w+12|0,w=f[k>>2]|0,f[k>>2]=w+-1,(w|0)==1):0)_S(j);f[o>>2]=0;o=j+16|0;w=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[w>>2]|0)>0){o=f[r>>2]|0;r=0;do{f[o+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[w>>2]|0))}w=f[j+44>>2]|0;if((w|0)!=(j+48|0))g0(w);w=i+36|0;j=f[w>>2]|0;if(j|0?(r=j+12|0,j=f[r>>2]|0,f[r>>2]=j+-1,(j|0)==1):0)_S(i);f[w>>2]=0;w=i+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[e>>2]|0)>0){w=f[i+40>>2]|0;j=0;do{f[w+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[e>>2]|0))}e=f[i+44>>2]|0;if((e|0)==(i+48|0)){u=g;return}g0(e);u=g;return}function p_(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if(a>>>0<c>>>0){h=a;u=e;return h|0}switch(d|0){case 1:{h=(a|0)<0?0:c+-1|0;u=e;return h|0}case 2:case 4:{i=(d|0)==4;d=i&1;if((c|0)==1){h=0;u=e;return h|0}j=(c<<1)+-1+(i<<31>>31)|0;i=a;while(1){k=(i|0)<0?d+~i|0:j-i|0;if(k>>>0<c>>>0){h=k;break}else i=k}u=e;return h|0}case 3:{if((c|0)<=0){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,7)|0;b[i>>0]=b[232034]|0;b[i+1>>0]=b[232035]|0;b[i+2>>0]=b[232036]|0;b[i+3>>0]=b[232037]|0;b[i+4>>0]=b[232038]|0;b[i+5>>0]=b[232039]|0;b[i+6>>0]=b[232040]|0;i_(-215,g,220370,941)}i=a-c|0;if((a|0)<0)l=~i+a+((i+1|0)%(c|0)|0)|0;else l=a;if((l|0)<(c|0)){h=l;u=e;return h|0}h=(l|0)%(c|0)|0;u=e;return h|0}case 0:{h=-1;u=e;return h|0}default:{f[g>>2]=0;f[g+4>>2]=0;h=tT(g,31)|0;e=220388;c=h+31|0;do{b[h>>0]=b[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(c|0));i_(-5,g,220370,950)}}return 0}function q_(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;k=u;u=u+2272|0;l=k+1208|0;m=k+1152|0;n=k+1096|0;o=k;if((e|d|g|h|0)<=-1){f[l>>2]=0;q=l+4|0;f[q>>2]=0;r=tT(l,70)|0;s=r;t=220420;v=s+70|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));i_(-215,l,220491,1186)}if((n$(a,-1)|0)>=3){f[l>>2]=0;q=l+4|0;f[q>>2]=0;r=tT(l,70)|0;s=r;t=220420;v=s+70|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));i_(-215,l,220491,1186)}do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[m>>2]=f[r>>2];q=m+4|0;w=r+4|0;f[q>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[r+8>>2];f[m+12>>2]=f[r+12>>2];f[m+16>>2]=f[r+16>>2];f[m+20>>2]=f[r+20>>2];f[m+24>>2]=f[r+24>>2];f[m+28>>2]=f[r+28>>2];f[m+32>>2]=f[r+32>>2];y=f[r+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=x;x=m+48|0;z=m+44|0;f[z>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[r+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];A=m;break}else{f[q>>2]=0;ZS(m,r);A=m;break}}else{a$(m,a,-1);A=m}while(0);a=f[A>>2]|0;if((i&16|0)==0&(a&32768|0)!=0){f[l>>2]=0;r=l+4|0;f[r>>2]=0;f[n>>2]=0;q=n+4|0;f[q>>2]=0;jT(m,l,n);w=f[q>>2]|0;q=(w|0)>(d|0)?d:w;x=m+8|0;z=(f[r>>2]|0)-(f[x>>2]|0)-w|0;w=(z|0)>(e|0)?e:z;z=f[n>>2]|0;r=(z|0)>(g|0)?g:z;y=m+12|0;B=(f[l>>2]|0)-(f[y>>2]|0)-z|0;z=(B|0)>(h|0)?h:B;kT(m,q,w,r,z)|0;C=d-q|0;D=e-w|0;E=g-r|0;F=h-z|0;G=x;H=y}else{C=d;D=e;E=g;F=h;G=m+8|0;H=m+12|0}Y$(c,C+D+(f[G>>2]|0)|0,E+F+(f[H>>2]|0)|0,a&4095,-1,0,0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[n>>2]=f[a>>2];H=n+4|0;G=a+4|0;f[H>>2]=f[G>>2];h=n+8|0;f[h>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];g=f[a+36>>2]|0;f[n+36>>2]=g;f[n+40>>2]=h;h=n+48|0;e=n+44|0;f[e>>2]=h;f[h>>2]=0;f[n+52>>2]=0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[G>>2]|0)<3){G=f[a+44>>2]|0;h=f[e>>2]|0;f[h>>2]=f[G>>2];f[h+4>>2]=f[G+4>>2];break}else{f[H>>2]=0;ZS(n,a);break}}else a$(n,c,-1);while(0);do if(E|F|D|C){c=i&-17;if(!c){a=f[A>>2]|0;H=(a>>>3&511)+1|0;G=o+8|0;f[o>>2]=G;h=o+4|0;f[h>>2]=H;if(H>>>0<=136)if(H>>>0>4){I=G;J=88}else{K=H;L=G}else{e=XDc(H<<3)|0;f[o>>2]=e;I=e;J=88}if((J|0)==88){M=+p[j>>3];if(!(M==+p[j+8>>3])){f[l>>2]=0;N=l+4|0;f[N>>2]=0;O=tT(l,68)|0;s=O;t=220506;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));i_(-215,l,220491,1234)}if(!(M==+p[j+16>>3])){f[l>>2]=0;N=l+4|0;f[N>>2]=0;O=tT(l,68)|0;s=O;t=220506;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));i_(-215,l,220491,1234)}if(M==+p[j+24>>3]){K=1;L=I}else{f[l>>2]=0;N=l+4|0;f[N>>2]=0;O=tT(l,68)|0;s=O;t=220506;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));i_(-215,l,220491,1234)}}c1(j,L,a&7|(K<<3)+-8,H);e=f[m+16>>2]|0;g=f[m+48>>2]|0;d=f[m+40>>2]|0;y=f[d+4>>2]|0;x=f[d>>2]|0;d=f[n+16>>2]|0;z=f[n+48>>2]|0;r=f[n+40>>2]|0;w=f[r+4>>2]|0;q=f[r>>2]|0;r=f[m+4>>2]|0;if((r|0)>0)P=f[(f[m+44>>2]|0)+(r+-1<<2)>>2]|0;else P=0;r=f[o>>2]|0;B=Y(P,w)|0;Q=l+8|0;f[l>>2]=Q;R=l+4|0;f[R>>2]=B;if(B>>>0>1032){S=XDc(B)|0;f[l>>2]=S;T=S}else T=Q;S=w-(y+E)|0;U=q-C-x|0;if((w|0)>0&(P|0)>0){q=0;do{V=Y(q,P)|0;W=0;do{b[T+(W+V)>>0]=b[r+W>>0]|0;W=W+1|0}while((W|0)!=(P|0));q=q+1|0}while((q|0)!=(w|0))}w=Y(P,y)|0;q=Y(P,E)|0;r=Y(P,S)|0;H=d+(Y(z,C)|0)|0;if((x|0)>0){a=0-q|0;W=e;V=H+q|0;X=0;while(1){if((V|0)!=(W|0))dJc(V|0,W|0,w|0)|0;dJc(V+a|0,T|0,q|0)|0;dJc(V+w|0,T|0,r|0)|0;X=X+1|0;if((X|0)==(x|0))break;else{W=W+g|0;V=V+z|0}}}if((C|0)>0){V=0;do{dJc(H+(Y(V-C|0,z)|0)|0,T|0,B|0)|0;V=V+1|0}while((V|0)!=(C|0))}if((U|0)>0){V=0;do{dJc(H+(Y(V+x|0,z)|0)|0,T|0,B|0)|0;V=V+1|0}while((V|0)!=(U|0))}U=f[l>>2]|0;if((U|0)!=(Q|0)){if(U|0)ZDc(U);f[l>>2]=Q;f[R>>2]=1032}U=f[o>>2]|0;if((U|0)!=(G|0)){if(U|0)ZDc(U);f[o>>2]=G;f[h>>2]=136}break}U=f[m+16>>2]|0;V=f[m+48>>2]|0;B=f[m+40>>2]|0;z=f[B+4>>2]|0;x=f[B>>2]|0;B=f[n+16>>2]|0;H=f[n+48>>2]|0;g=f[n+40>>2]|0;W=f[g+4>>2]|0;X=f[g>>2]|0;g=f[m+4>>2]|0;if((g|0)>0)Z=f[(f[m+44>>2]|0)+(g+-1<<2)>>2]|0;else Z=0;g=((U|V|H|B|Z)&3|0)==0;r=g?4:1;w=g?(Z|0)/4|0:Z;q=W-z|0;a=Y(w,q)|0;e=l+8|0;f[l>>2]=e;d=l+4|0;f[d>>2]=a;if(a>>>0>264){S=XDc(a>>>0>1073741823?-1:a<<2)|0;f[l>>2]=S;_=S}else _=e;S=q-E|0;q=X-C-x|0;a:do if((E|0)>0){if((w|0)>0)$=0;else{X=0;while(1){p_(X-E|0,z,c)|0;X=X+1|0;if((X|0)>=(E|0))break a}}do{X=Y(p_($-E|0,z,c)|0,w)|0;a=Y($,w)|0;y=0;do{f[_+(y+a<<2)>>2]=y+X;y=y+1|0}while((y|0)!=(w|0));$=$+1|0}while(($|0)<(E|0))}while(0);b:do if((S|0)>0){if((w|0)>0)aa=0;else{h=0;while(1){p_(h+z|0,z,c)|0;h=h+1|0;if((h|0)>=(S|0))break b}}do{h=Y(p_(aa+z|0,z,c)|0,w)|0;G=Y(aa+E|0,w)|0;R=0;do{f[_+(R+G<<2)>>2]=R+h;R=R+1|0}while((R|0)!=(w|0));aa=aa+1|0}while((aa|0)<(S|0))}while(0);R=Y(w,z)|0;h=Y(w,W)|0;G=Y(w,E)|0;Q=Y(w,S)|0;y=B+(Y(H,C)|0)|0;X=y+(Y(G,r)|0)|0;c:do if((x|0)>0){a=(G|0)>0;ba=(Q|0)>0;ca=Y(R,r)|0;if(!g){if(a){da=X;ea=U;fa=0;while(1){if((da|0)==(ea|0))ga=0;else{dJc(da|0,ea|0,ca|0)|0;ga=0}do{b[da+(ga-G)>>0]=b[ea+(f[_+(ga<<2)>>2]|0)>>0]|0;ga=ga+1|0}while((ga|0)!=(G|0));if(ba){ha=0;do{b[da+(ha+R)>>0]=b[ea+(f[_+(ha+G<<2)>>2]|0)>>0]|0;ha=ha+1|0}while((ha|0)!=(Q|0))}fa=fa+1|0;if((fa|0)==(x|0))break c;else{da=da+H|0;ea=ea+V|0}}}if(ba){ia=X;ja=U;ka=0}else{ea=X;da=U;fa=0;while(1){if((ea|0)!=(da|0))dJc(ea|0,da|0,ca|0)|0;fa=fa+1|0;if((fa|0)==(x|0))break c;else{ea=ea+H|0;da=da+V|0}}}while(1){if((ia|0)==(ja|0))la=0;else{dJc(ia|0,ja|0,ca|0)|0;la=0}do{b[ia+(la+R)>>0]=b[ja+(f[_+(la+G<<2)>>2]|0)>>0]|0;la=la+1|0}while((la|0)!=(Q|0));ka=ka+1|0;if((ka|0)==(x|0))break c;else{ia=ia+H|0;ja=ja+V|0}}}if(a){da=X;ea=U;fa=0;while(1){if((da|0)!=(ea|0))dJc(da|0,ea|0,ca|0)|0;ha=0;do{f[da+(ha-G<<2)>>2]=f[ea+(f[_+(ha<<2)>>2]<<2)>>2];ha=ha+1|0}while((ha|0)!=(G|0));if(ba){ha=0;do{f[da+(ha+R<<2)>>2]=f[ea+(f[_+(ha+G<<2)>>2]<<2)>>2];ha=ha+1|0}while((ha|0)!=(Q|0))}fa=fa+1|0;if((fa|0)==(x|0))break c;else{da=da+H|0;ea=ea+V|0}}}if(ba){ma=X;na=U;oa=0}else{ea=X;da=U;fa=0;while(1){if((ea|0)!=(da|0))dJc(ea|0,da|0,ca|0)|0;fa=fa+1|0;if((fa|0)==(x|0))break c;else{ea=ea+H|0;da=da+V|0}}}while(1){if((ma|0)!=(na|0))dJc(ma|0,na|0,ca|0)|0;da=0;do{f[ma+(da+R<<2)>>2]=f[na+(f[_+(da+G<<2)>>2]<<2)>>2];da=da+1|0}while((da|0)!=(Q|0));oa=oa+1|0;if((oa|0)==(x|0))break;else{ma=ma+H|0;na=na+V|0}}}while(0);V=Y(h,r)|0;if((C|0)>0){Q=0;do{G=Q-C|0;dJc(y+(Y(G,H)|0)|0,y+(Y(p_(G,x,c)|0,H)|0)|0,V|0)|0;Q=Q+1|0}while((Q|0)<(C|0))}if((q|0)>0){Q=0;do{r=Q+x|0;dJc(y+(Y(r,H)|0)|0,y+(Y(p_(r,x,c)|0,H)|0)|0,V|0)|0;Q=Q+1|0}while((Q|0)<(q|0))}q=f[l>>2]|0;if((q|0)!=(e|0)){if(q|0)ZDc(q);f[l>>2]=e;f[d>>2]=264}}else{if((f[m+16>>2]|0)==(f[n+16>>2]|0)?(f[m+48>>2]|0)==(f[n+48>>2]|0):0)break;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;h_(m,l)}while(0);l=n+36|0;C=f[l>>2]|0;if(C|0?(na=C+12|0,C=f[na>>2]|0,f[na>>2]=C+-1,(C|0)==1):0)_S(n);f[l>>2]=0;l=n+16|0;C=n+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[C>>2]|0)>0){l=f[n+40>>2]|0;na=0;do{f[l+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[C>>2]|0))}C=f[n+44>>2]|0;if((C|0)!=(n+48|0))g0(C);C=m+36|0;n=f[C>>2]|0;if(n|0?(na=n+12|0,n=f[na>>2]|0,f[na>>2]=n+-1,(n|0)==1):0)_S(m);f[C>>2]=0;C=m+16|0;n=m+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[n>>2]|0)>0){C=f[m+40>>2]|0;na=0;do{f[C+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)==(m+48|0)){u=k;return}g0(n);u=k;return}function r_(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=u;u=u+208|0;g=e+144|0;h=e+88|0;i=e+72|0;j=e+56|0;k=e;l=(a|0)!=0;if((l?(c|0?(f[a>>2]&-65536|0)==1111752704:0):0)?(f[c>>2]&-65536|0)==1111752704:0){if(d|0){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,12)|0;n=220575;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,g,220588,1250)}p=a+4|0;f[c+4>>2]=f[p>>2];dJc(c+36|0,a+36|0,f[p>>2]<<2|0)|0;f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];p=c+16|0;I7(f[p>>2]|0);q=c+24|0;r=f[q>>2]|0;s=c+20|0;if((f[(f[a+16>>2]|0)+60>>2]|0)<(r*3|0)){t=s;v=r;w=f[s>>2]|0}else{i0(f[s>>2]|0);f[s>>2]=0;r=f[a+24>>2]|0;f[q>>2]=r;x=h0(r<<2)|0;f[s>>2]=x;t=s;v=f[q>>2]|0;w=x}XIc(w|0,0,v<<2|0)|0;v=L0(a,h)|0;a:do if(v|0){w=h+4|0;x=h+8|0;s=v;while(1){r=f[p>>2]|0;y=r+56|0;z=f[y>>2]|0;f[g>>2]=z;if(!z){H7(r,0,g)|0;A=f[p>>2]|0;B=f[g>>2]|0}else{f[y>>2]=f[z+4>>2];f[z>>2]=f[z>>2]&67108863;y=r+60|0;f[y>>2]=(f[y>>2]|0)+1;A=r;B=z}z=(f[q>>2]|0)+-1&f[s>>2];dJc(B|0,s|0,f[A+28>>2]|0)|0;r=(f[t>>2]|0)+(z<<2)|0;f[B+4>>2]=f[r>>2];f[r>>2]=B;r=f[(f[w>>2]|0)+4>>2]|0;if(!r){z=(f[x>>2]|0)+1|0;f[x>>2]=z;y=f[h>>2]|0;C=f[y+24>>2]|0;if((z|0)>=(C|0))break a;D=f[y+20>>2]|0;y=z;while(1){E=f[D+(y<<2)>>2]|0;if(E|0)break;z=y+1|0;if((z|0)<(C|0))y=z;else break a}f[x>>2]=y;F=E}else F=r;f[w>>2]=F;s=F}}while(0);u=e;return}O4(g,a,0,1,1,0);O4(h,c,0,1,1,0);if((f[h>>2]^f[g>>2])&7|0){f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,50)|0;m=H;n=220595;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,i,220588,1284)}F=g+40|0;E=f[F>>2]|0;B=f[E+-4>>2]|0;t=h+40|0;A=f[t>>2]|0;if((B|0)!=(f[A+-4>>2]|0)){f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,50)|0;m=H;n=220595;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,i,220588,1284)}b:do if((B|0)==2){if((f[E>>2]|0)!=(f[A>>2]|0)){f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,50)|0;m=H;n=220595;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,i,220588,1284)}if((f[E+4>>2]|0)!=(f[A+4>>2]|0)){f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,50)|0;m=H;n=220595;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,i,220588,1284)}}else if((B|0)>0){q=0;while(1){if((f[E+(q<<2)>>2]|0)!=(f[A+(q<<2)>>2]|0))break;q=q+1|0;if((q|0)>=(B|0))break b}f[i>>2]=0;G=i+4|0;f[G>>2]=0;H=tT(i,50)|0;m=H;n=220595;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,i,220588,1284)}while(0);if((l?(f[a>>2]|0)==112:0)?(f[a+68>>2]|0)!=0:0)I=Z0(a)|0;else I=0;if(((c|0)!=0?(f[c>>2]|0)==112:0)?(f[c+68>>2]|0)!=0:0)J=Z0(c)|0;else J=0;c=(J|0)==0;do if(!(J|I)){if((f[h>>2]^f[g>>2])&4088|0){f[i>>2]=0;f[i+4>>2]=0;m=tT(i,32)|0;n=220719;o=m+32|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,i,220588,1302)}if(!d){a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;h_(g,i);break}a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;O4(k,d,0,1,0,0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=k;j_(g,i,j);a=k+36|0;l=f[a>>2]|0;if(l|0?(H=l+12|0,l=f[H>>2]|0,f[H>>2]=l+-1,(l|0)==1):0)_S(k);f[a>>2]=0;a=k+16|0;l=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[l>>2]|0)>0){a=f[k+40>>2]|0;H=0;do{f[a+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))g0(l)}else{if((I|0)==0?f[g>>2]&4088|0:0){f[i>>2]=0;K=i+4|0;f[K>>2]=0;L=tT(i,72)|0;m=L;n=220646;o=m+72|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,i,220588,1295)}if(c?f[h>>2]&4088|0:0){f[i>>2]=0;K=i+4|0;f[K>>2]=0;L=tT(i,72)|0;m=L;n=220646;o=m+72|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));i_(-215,i,220588,1295)}l=I+-1|0;f[i>>2]=(l|0)>0?l:0;l=J+-1|0;f[i+4>>2]=(l|0)>0?l:0;SQ(g,1,h,1,i,1)}while(0);i=h+36|0;J=f[i>>2]|0;if(J|0?(I=J+12|0,J=f[I>>2]|0,f[I>>2]=J+-1,(J|0)==1):0)_S(h);f[i>>2]=0;i=h+16|0;J=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[J>>2]|0)>0){i=f[t>>2]|0;t=0;do{f[i+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[J>>2]|0))}J=f[h+44>>2]|0;if((J|0)!=(h+48|0))g0(J);J=g+36|0;h=f[J>>2]|0;if(h|0?(t=h+12|0,h=f[t>>2]|0,f[t>>2]=h+-1,(h|0)==1):0)_S(g);f[J>>2]=0;J=g+16|0;h=g+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[h>>2]|0)>0){J=f[F>>2]|0;F=0;do{f[J+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))g0(h);u=e;return}function s_(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+96|0;c=b+32|0;d=b;if(a|0?(f[a>>2]&-65536|0)==1111752704:0){I7(f[a+16>>2]|0);e=f[a+20>>2]|0;if(!e){u=b;return}XIc(e|0,0,f[a+24>>2]<<2|0)|0;u=b;return}O4(c,a,0,1,0,0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;k_(c,d)|0;d=c+36|0;a=f[d>>2]|0;if(a|0?(e=a+12|0,a=f[e>>2]|0,f[e>>2]=a+-1,(a|0)==1):0)_S(c);f[d>>2]=0;d=c+16|0;a=c+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[a>>2]|0)>0){d=f[c+40>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[a>>2]|0))}a=f[c+44>>2]|0;if((a|0)!=(c+48|0))g0(a);u=b;return}function t_(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=43972;b=a+20|0;c=a+24|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)==(e|0)){g=e;h=d}else{d=a+8|0;do{r1(f[d>>2]|0);e=(f[c>>2]|0)+-1|0;f[c>>2]=e;i=f[b>>2]|0}while((e|0)!=(i|0));g=i;h=e}b=g;if(g|0){if((h|0)!=(b|0))f[c>>2]=b;YDc(b)}uT(a+12|0);b=a+4|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}h=c+4|0;g=f[h>>2]|0;f[h>>2]=g+-1;if((g|0)!=1){f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}function u_(a){a=a|0;t_(a);YDc(a);return}function v_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;Yi[f[(f[a>>2]|0)+16>>2]&2047](a);e=a+4|0;g=f[b>>2]|0;if(!(f[d+4>>2]|0))h=0;else{b=f[d>>2]|0;h=(b|0)==0?1154740:b}b=d1((g|0)==0?1154740:g,0,c,h)|0;if(!b)i=0;else{h=VDc(16)|0;f[h+4>>2]=1;f[h>>2]=44004;f[h+8>>2]=b;i=h}h=f[e>>2]|0;f[e>>2]=i;f[a+8>>2]=b;if(h|0?(b=h+4|0,i=f[b>>2]|0,f[b>>2]=i+-1,(i|0)==1):0)Yi[f[(f[h>>2]|0)+8>>2]&2047](h);h=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[a+32>>2]=h?6:0;return h|0}function w_(a){a=a|0;var c=0,d=0;c=f[a+8>>2]|0;if(!c){d=0;return d|0}d=(b[c+300>>0]|0)!=0;return d|0}function x_(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+4|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+8>>2]=0;b=f[a+20>>2]|0;c=a+24|0;if((f[c>>2]|0)==(b|0)){g=a+32|0;f[g>>2]=0;return}f[c>>2]=b;g=a+32|0;f[g>>2]=0;return}function y_(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b+8>>2]|0;if(c|0?f[c+268>>2]|0:0)Q8(c,a);Yi[f[(f[b>>2]|0)+16>>2]&2047](b);return}function z_(a){a=a|0;YDc(a);return}function A_(a){a=a|0;b1(a+12|0,f[a+8>>2]|0);if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function B_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=43972;e=a+8|0;g=a+4+8|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;g=a+4|0;f[g>>2]=0;f[e>>2]=0;h=a+32|0;f[h>>2]=0;i=f[b>>2]|0;if(!(f[d+4>>2]|0))j=0;else{b=f[d>>2]|0;j=(b|0)==0?1154740:b}b=d1((i|0)==0?1154740:i,0,c,j)|0;if(!b)k=0;else{j=VDc(16)|0;f[j+4>>2]=1;f[j>>2]=44004;f[j+8>>2]=b;k=j}j=f[g>>2]|0;f[g>>2]=k;f[e>>2]=b;if(j|0?(b=j+4|0,e=f[b>>2]|0,f[b>>2]=e+-1,(e|0)==1):0)Yi[f[(f[j>>2]|0)+8>>2]&2047](j);j=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[h>>2]=j?6:0;return}function C_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=43972;d=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;if((b|0)==0|c^1)e=0;else{c=VDc(16)|0;f[c+4>>2]=1;f[c>>2]=44004;f[c+8>>2]=b;e=c}f[d>>2]=e;f[a+8>>2]=b;f[a+32>>2]=b|0?6:0;return}function D_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if(_i[f[(f[b>>2]|0)+12>>2]&1023](b)|0){d=f[b+8>>2]|0;e=p1(d,c)|0;g=d}else{e=0;g=0}f[a>>2]=g;f[a+4>>2]=e;return}function E_(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+8|0;i=d;j=d+24|0;k=f[c>>2]|0;l=(k|0)==0?1154740:k;if(!((_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0)&(l|0)!=0)){u=d;return a|0}k=b[l>>0]|0;switch(k<<24>>24){case 93:case 125:{m=f[a+20>>2]|0;n=a+24|0;o=f[n>>2]|0;if((m|0)==(o|0)){f[i>>2]=k<<24>>24;F5(e,220914,i);z5(-2,e,518366,220840,115)}i=o+-1|0;p=b[i>>0]|0;if(((k<<24>>24==93?91:123)|0)!=(p|0)){f[h>>2]=k<<24>>24;f[h+4>>2]=p;F5(e,220933,h);z5(-2,e,518366,220840,118)}f[n>>2]=i;if((m|0)==(i|0))q=6;else q=(b[o+-2>>0]|0)==123?6:1;f[a+32>>2]=q;r1(f[a+8>>2]|0);f[e>>2]=0;q=e+4|0;f[q>>2]=0;o=a+12|0;if((e|0)!=(o|0)){uT(o);i=f[e>>2]|0;if(!i)r=0;else{m=i+-4|0;f[m>>2]=(f[m>>2]|0)+1;r=f[e>>2]|0}f[o>>2]=r;f[a+16>>2]=f[q>>2]}uT(e);u=d;return a|0}default:{}}q=a+32|0;r=f[q>>2]|0;if((r|0)==6){if(!(((k&-33)+-65&255)<26|k<<24>>24==95)){f[g>>2]=l;F5(e,220982,g);z5(-2,e,518366,220840,128)}g=a+12|0;if((g|0)!=(c|0)){uT(g);o=f[c>>2]|0;if(!o)s=0;else{m=o+-4|0;f[m>>2]=(f[m>>2]|0)+1;s=f[c>>2]|0}f[g>>2]=s;f[a+16>>2]=f[c+4>>2]}f[q>>2]=5;u=d;return a|0}if((r&3|0)!=1){f[e>>2]=0;f[e+4>>2]=0;r=tT(e,16)|0;s=221008;g=r+16|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(g|0));z5(-2,e,518366,220840,158)}switch(k<<24>>24){case 91:case 123:break;default:{a:do if(k<<24>>24==92){s=l+1|0;switch(b[s>>0]|0){case 93:case 91:case 125:case 123:break;default:{t=45;break a}}f[e>>2]=0;f[e+4>>2]=0;r=Mpc(s)|0;if(r|0)dJc(tT(e,r)|0,s|0,r|0)|0}else t=45;while(0);if((t|0)==45?(t=f[c>>2]|0,f[e>>2]=t,f[e+4>>2]=f[c+4>>2],t|0):0){c=t+-4|0;f[c>>2]=(f[c>>2]|0)+1}if(!(f[a+16>>2]|0))v=0;else{c=f[a+12>>2]|0;v=(c|0)==0?1154740:c}c=f[e>>2]|0;u1(f[a+8>>2]|0,v,(c|0)==0?1154740:c,0);uT(e);if((f[q>>2]|0)!=5){u=d;return a|0}f[q>>2]=6;u=d;return a|0}}c=a+20|0;v=a+24|0;t=f[v>>2]|0;r=a+28|0;s=f[r>>2]|0;g=s;if((t|0)==(s|0)){s=f[c>>2]|0;m=t-s|0;o=m+1|0;i=s;if((o|0)<0)mCc(c);n=g-s|0;g=n<<1;h=n>>>0<1073741823?(g>>>0<o>>>0?o:g):2147483647;if(!h){w=0;x=k}else{g=VDc(h)|0;w=g;x=b[l>>0]|0}g=w+m|0;b[g>>0]=x;x=g+(0-m)|0;if((m|0)>0)dJc(x|0,i|0,m|0)|0;f[c>>2]=x;f[v>>2]=g+1;f[r>>2]=w+h;if(s|0)YDc(i)}else{b[t>>0]=k;f[v>>2]=(f[v>>2]|0)+1}v=l+1|0;k=(b[l>>0]|0)==123;t=k?6:5;f[q>>2]=k?6:1;k=(b[v>>0]|0)==58;q=k?l+2|0:v;v=f[a+8>>2]|0;l=a+12|0;i=a+16|0;if(!(f[i>>2]|0))y=0;else{s=f[l>>2]|0;y=(s|0)==0?1154740:s}s=b[q>>0]|0?q:0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];q1(v,y,k?t|8:t,s,e);f[e>>2]=0;s=e+4|0;f[s>>2]=0;if((e|0)!=(l|0)){uT(l);t=f[e>>2]|0;if(!t)z=0;else{k=t+-4|0;f[k>>2]=(f[k>>2]|0)+1;z=f[e>>2]|0}f[l>>2]=z;f[i>>2]=f[s>>2]}uT(e);u=d;return a|0}function F_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;if(!(_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0)){u=g;return}i=f[c>>2]|0;c=(i|0)==0?1154740:i;i=b[c>>0]|0;if((i+-48&255)<10){j=b[c+1>>0]|0;k=(i<<24>>24)+-48|0}else{j=i;k=1}switch(j<<24>>24){case 99:case 117:{l=1;break}case 119:{l=2;break}case 115:{l=2;break}case 105:{l=4;break}case 102:{l=4;break}case 100:{l=8;break}default:l=j<<24>>24==114?4:0}j=Y(l,k)|0;if((e>>>0)%(j>>>0)|0|0){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,19)|0;l=221025;i=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(i|0));z5(-215,h,221045,220840,169)}w1(f[a+8>>2]|0,d,(e>>>0)/(j>>>0)|0,c);u=g;return}function G_(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+1056|0;e=d+8|0;g=d;h=f[c>>2]|0;i=(h|0)==0?1154740:h;h=f[c+4>>2]|0;c=i+h|0;j=h+1|0;h=e+8|0;f[e>>2]=h;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=XDc(j)|0;f[e>>2]=l;m=l}else m=h;l=c+-1|0;a:do if(l>>>0>=i>>>0){j=l;n=c;b:while(1){o=j;p=n;c:while(1){switch(b[o>>0]|0){case 58:case 47:case 92:{q=p;break b;break}case 46:{if(!(b[n>>0]|0))break c;if(!(Wqc(n,221054,3)|0))break c;break}default:{}}r=o+-1|0;if(r>>>0<i>>>0){q=o;break b}else{s=o;o=r;p=s}}j=o+-1|0;if(j>>>0<i>>>0)break a;else n=o}if((q|0)!=(n|0)){j=b[q>>0]|0;if(((j&-33)+-65&255)<26|j<<24>>24==95)t=m;else{b[m>>0]=95;t=m+1|0}if(q>>>0<n>>>0){j=t;p=q;while(1){s=b[p>>0]|0;p=p+1|0;r=j+1|0;b[j>>0]=s<<24>>24==95|(s<<24>>24==45|((s+-48&255)<10|((s&-33)+-65&255)<26))?s:95;if((p|0)==(n|0)){v=r;break}else j=r}}else v=t;b[v>>0]=0;j=f[e>>2]|0;if(Ioc(j,244833)|0){f[a>>2]=0;f[a+4>>2]=0;if(j|0)w=19}else{n=j;p=n;b[p>>0]=117;b[p+1>>0]=110;b[p+2>>0]=110;b[p+3>>0]=97;p=n+4|0;b[p>>0]=109;b[p+1>>0]=101;b[p+2>>0]=100;b[p+3>>0]=0;f[a>>2]=0;f[a+4>>2]=0;w=19}if((w|0)==19?(p=Mpc(j)|0,p|0):0)dJc(tT(a,p)|0,j|0,p|0)|0;p=f[e>>2]|0;if((p|0)==(h|0)){u=d;return}if(p|0)ZDc(p);f[e>>2]=h;f[k>>2]=1032;u=d;return}}while(0);f[g>>2]=0;f[g+4>>2]=0;d=tT(g,16)|0;k=221058;h=d+16|0;do{b[d>>0]=b[k>>0]|0;d=d+1|0;k=k+1|0}while((d|0)<(h|0));z5(-5,g,221075,220840,223)}function H_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b+8>>2]|0;b=f[c>>2]|0;c=j1(d,0,(b|0)==0?1154740:b)|0;f[a>>2]=d;f[a+4>>2]=c;return}function I_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b>>2]|0;e=j1(d,f[b+4>>2]|0,c)|0;f[a>>2]=d;f[a+4>>2]=e;return}function J_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[a>>2]|0;e=d;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>536870911){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}h=f[g>>2]|0;i=VDc(b<<3)|0;j=i+(h-d>>3<<3)|0;d=j;k=i+(b<<3)|0;b=h;if((b|0)==(e|0)){l=d;m=h;n=h}else{h=b;b=d;i=j;do{j=h;h=h+-8|0;o=f[h>>2]|0;f[i+-8>>2]=o;f[i+-4>>2]=f[j+-4>>2];if(o|0){j=o+-4|0;f[j>>2]=(f[j>>2]|0)+1}i=b+-8|0;b=i}while((h|0)!=(e|0));l=b;m=f[a>>2]|0;n=f[g>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;k=m;c=n;while(1){n=c;if((n|0)==(k|0))break;d=n+-8|0;uT(d);c=d}if(!m)return;YDc(m);return}function K_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=a+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;if((b|0)!=0&(c|0)!=0?(g=f[c>>2]|0,h=g&7,h|0):0){f[a>>2]=b;b=a+4|0;f[b>>2]=c;a:do if((g&16|0)==0&(h+-5|0)>>>0<2){i=c+8|0;r7(f[i>>2]|0,e,0);j=f[c>>2]|0;switch(j&7){case 6:{k=f[(f[i>>2]|0)+60>>2]|0;break a;break}case 5:{k=f[(f[i>>2]|0)+24>>2]|0;break a;break}default:{k=(j&7|0)!=0&1;break a}}}else{f[a+20>>2]=c;f[a+12>>2]=0;k=1}while(0);c=a+40|0;f[c>>2]=k;if(!d)return;if((d|0)>0)l=(k|0)<(d|0)?k:d;else{h=f[b>>2]|0;b:do if(!h){m=0;n=17}else{b=f[h>>2]|0;switch(b&7){case 6:{o=f[(f[h+8>>2]|0)+60>>2]|0;break b;break}case 5:{o=f[(f[h+8>>2]|0)+24>>2]|0;break b;break}default:{m=(b&7|0)!=0;n=17;break b}}}while(0);if((n|0)==17)o=m&1;m=k-d|0;l=k-(o>>>0<m>>>0?o:m)|0}f[c>>2]=k-l;if(!(f[a+12>>2]|0))return;q7(e,l,1);return}f[a>>2]=0;f[a+4>>2]=0;f[a+40>>2]=0;return}function L_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)mCc(a);k=a+8|0;l=(f[k>>2]|0)-e|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(m)if(m>>>0>536870911){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m<<3)|0;break}else n=0;while(0);e=n+(g<<3)|0;h=e;l=n+(m<<3)|0;m=f[b>>2]|0;f[e>>2]=m;f[n+(g<<3)+4>>2]=f[b+4>>2];if(!m){o=j;p=i;q=d}else{d=m+-4|0;f[d>>2]=(f[d>>2]|0)+1;d=f[c>>2]|0;o=d;p=f[a>>2]|0;q=d}d=e+8|0;if((o|0)==(p|0)){r=h;s=o;t=q}else{q=o;o=h;h=e;do{e=q;q=q+-8|0;m=f[q>>2]|0;f[h+-8>>2]=m;f[h+-4>>2]=f[e+-4>>2];if(m|0){e=m+-4|0;f[e>>2]=(f[e>>2]|0)+1}h=o+-8|0;o=h}while((q|0)!=(p|0));r=o;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=d;f[k>>2]=l;l=s;k=t;while(1){t=k;if((t|0)==(l|0))break;d=t+-8|0;uT(d);k=d}if(!s)return;YDc(s);return}function M_(a){a=a|0;var b=0,c=0,d=0;b=f[a+4>>2]|0;a:do if(!b)c=0;else{a=f[b>>2]|0;switch(a&7){case 6:{d=f[(f[b+8>>2]|0)+60>>2]|0;return d|0}case 5:{d=f[(f[b+8>>2]|0)+24>>2]|0;return d|0}default:{c=(a&7|0)!=0;break a}}}while(0);d=c&1;return d|0}function N_(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+40|0;c=f[b>>2]|0;if(!c)return a|0;d=a+8|0;e=f[a+12>>2]|0;if((e|0)!=0?(g=a+20|0,h=(f[g>>2]|0)+(f[e+28>>2]|0)|0,f[g>>2]=h,h>>>0>=(f[a+28>>2]|0)>>>0):0){z7(d,1);i=f[b>>2]|0}else i=c;f[b>>2]=i+-1;return a|0}function O_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;if(!i){u=g;return a|0}j=f[a+4>>2]|0;if(!j){u=g;return a|0}k=a+40|0;l=f[k>>2]|0;if(!l){u=g;return a|0}m=f[c>>2]|0;c=(m|0)==0?1154740:m;m=b[c>>0]|0;if((m+-48&255)<10){n=(m<<24>>24)+-48|0;o=b[c+1>>0]|0}else{n=1;o=m}switch(o<<24>>24){case 99:case 117:{p=1;break}case 119:{p=2;break}case 115:{p=2;break}case 105:{p=4;break}case 102:{p=4;break}case 100:{p=8;break}default:p=o<<24>>24==114?4:0}if(!(Y(p,n)|0)){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,13)|0;o=221096;m=p+13|0;do{b[p>>0]=b[o>>0]|0;p=p+1|0;o=o+1|0}while((p|0)<(m|0));z5(-215,h,221110,220840,421)}h=l>>>0>e>>>0?e:l;if(!(f[a+12>>2]|0)){z1(i,j,d,c);q=0}else{y1(i,a+8|0,h,d,c);c=Y(h,n)|0;q=(f[k>>2]|0)-c|0}f[k>>2]=q;u=g;return a|0}function P_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[a+8>>2]|0;if(!(f[b+4>>2]|0)){e=0;s1(d,e,c);return}a=f[b>>2]|0;e=(a|0)==0?1154740:a;s1(d,e,c);return}function Q_(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;if(!(f[b+4>>2]|0))d=0;else{e=f[b>>2]|0;d=(e|0)==0?1154740:e}t1(f[a+8>>2]|0,d,c);return}function R_(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=f[a+8>>2]|0;if(!(f[b+4>>2]|0)){e=0;t1(d,e,c);return}a=f[b>>2]|0;e=(a|0)==0?1154740:a;t1(d,e,c);return}function S_(a,b){a=a|0;b=b|0;s1(f[a+8>>2]|0,0,b);return}function T_(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h+8|0;j=h;f[a>>2]=c;k=f[c+8>>2]|0;if(!(f[d+4>>2]|0))l=0;else{c=f[d>>2]|0;l=(c|0)==0?1154740:c}if(!(f[g+4>>2]|0))m=0;else{c=f[g>>2]|0;m=(c|0)==0?1154740:c}f[j>>2]=0;f[j+4>>2]=0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];q1(k,l,e,m,i);f[i>>2]=0;m=i+4|0;f[m>>2]=0;l=f[a>>2]|0;k=l+12|0;if((i|0)!=(k|0)){uT(k);j=f[i>>2]|0;if(!j)n=0;else{c=j+-4|0;f[c>>2]=(f[c>>2]|0)+1;n=f[i>>2]|0}f[k>>2]=n;f[l+16>>2]=f[m>>2]}uT(i);i=f[a>>2]|0;a=i+32|0;if((e&7|0)==5){f[a>>2]=1;e=i+20|0;m=i+24|0;l=f[m>>2]|0;n=i+28|0;k=f[n>>2]|0;if((l|0)!=(k|0)){b[l>>0]=91;f[m>>2]=(f[m>>2]|0)+1;u=h;return}c=f[e>>2]|0;j=l-c|0;l=j+1|0;g=c;if((l|0)<0)mCc(e);d=k-c|0;k=d<<1;o=d>>>0<1073741823?(k>>>0<l>>>0?l:k):2147483647;if(!o)p=0;else p=VDc(o)|0;k=p+j|0;b[k>>0]=91;l=k+(0-j)|0;if((j|0)>0)dJc(l|0,g|0,j|0)|0;f[e>>2]=l;f[m>>2]=k+1;f[n>>2]=p+o;if(!c){u=h;return}YDc(g);u=h;return}else{f[a>>2]=6;a=i+20|0;g=i+24|0;c=f[g>>2]|0;o=i+28|0;i=f[o>>2]|0;if((c|0)!=(i|0)){b[c>>0]=123;f[g>>2]=(f[g>>2]|0)+1;u=h;return}p=f[a>>2]|0;n=c-p|0;c=n+1|0;k=p;if((c|0)<0)mCc(a);m=i-p|0;i=m<<1;l=m>>>0<1073741823?(i>>>0<c>>>0?c:i):2147483647;if(!l)q=0;else q=VDc(l)|0;i=q+n|0;b[i>>0]=123;c=i+(0-n)|0;if((n|0)>0)dJc(c|0,k|0,n|0)|0;f[a>>2]=c;f[g>>2]=i+1;f[o>>2]=q+l;if(!p){u=h;return}YDc(k);u=h;return}}function U_(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;r1(f[(f[a>>2]|0)+8>>2]|0);e=f[a>>2]|0;a=e+24|0;g=f[a>>2]|0;h=g+-1|0;f[a>>2]=h;if((f[e+20>>2]|0)==(h|0))i=6;else i=(b[g+-2>>0]|0)==123?6:1;f[e+32>>2]=i;f[d>>2]=0;i=d+4|0;f[i>>2]=0;g=e+12|0;if((d|0)==(g|0)){uT(d);u=c;return}uT(g);h=f[d>>2]|0;if(!h)j=0;else{a=h+-4|0;f[a>>2]=(f[a>>2]|0)+1;j=f[d>>2]|0}f[g>>2]=j;f[e+16>>2]=f[i>>2];uT(d);u=c;return}function V_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/28|0;h=g+1|0;i=e;j=d;if(h>>>0>153391689)mCc(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/28|0;e=l<<1;m=l>>>0<76695844?(e>>>0<h>>>0?h:e):153391689;do if(m)if(m>>>0>153391689){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m*28|0)|0;break}else n=0;while(0);e=n+(g*28|0)|0;h=e;l=n+(m*28|0)|0;f[e>>2]=f[b>>2];f[n+(g*28|0)+4>>2]=f[b+4>>2];m=n+(g*28|0)+8|0;g=b+8|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];f[m+16>>2]=f[g+16>>2];g=e+28|0;if((j|0)==(i|0)){o=h;p=d}else{d=j;j=h;h=e;do{e=d;d=d+-28|0;f[h+-28>>2]=f[d>>2];f[h+-24>>2]=f[e+-24>>2];m=h+-20|0;b=e+-20|0;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[m+8>>2]=f[b+8>>2];f[m+12>>2]=f[b+12>>2];f[m+16>>2]=f[b+16>>2];h=j+-28|0;j=h}while((d|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[c>>2]=g;f[k>>2]=l;if(!p)return;YDc(p);return}function W_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;YDc(d);return}function X_(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!b){c=0;return c|0}c=f[b>>2]&7;return c|0}function Y_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[a+4>>2]|0;if(d)if((f[d>>2]&7|0)==1)e=f[d+8>>2]|0;else e=2147483647;else e=c;f[b>>2]=e;return}function Z_(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0.0;d=f[a+4>>2]|0;a:do if(!d)e=c;else switch(f[d>>2]&7){case 1:{e=+(f[d+8>>2]|0);break a;break}case 2:{e=+p[d+8>>3];break a;break}default:{e=3402823466385288598117041.0e14;break a}}while(0);n[b>>2]=e;return}function __(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0.0;d=f[a+4>>2]|0;a:do if(!d)e=c;else switch(f[d>>2]&7){case 1:{e=+(f[d+8>>2]|0);break a;break}case 2:{e=+p[d+8>>3];break a;break}default:{e=1797693134862315708145274.0e284;break a}}while(0);p[b>>3]=e;return}function $_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a+4>>2]|0;do if(!g){a=f[c>>2]|0;f[e>>2]=a;f[e+4>>2]=f[c+4>>2];if(a|0){h=a+-4|0;f[h>>2]=(f[h>>2]|0)+1}}else{if((f[g>>2]&7|0)!=3){f[e>>2]=0;f[e+4>>2]=0;break}h=f[g+8+4>>2]|0;f[e>>2]=0;f[e+4>>2]=0;if(h|0?(a=Mpc(h)|0,a|0):0)dJc(tT(e,a)|0,h|0,a|0)|0}while(0);if((e|0)==(b|0)){uT(e);u=d;return}uT(b);g=f[e>>2]|0;if(!g)i=0;else{c=g+-4|0;f[c>>2]=(f[c>>2]|0)+1;i=f[e>>2]|0}f[b>>2]=i;f[b+4>>2]=f[e+4>>2];uT(e);u=d;return}function a$(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+144|0;g=e+136|0;h=e;i=e+80|0;j=e+72|0;k=e+64|0;l=e+56|0;m=f[c>>2]|0;n=m&50331648;do switch(m>>>16&31){case 1:{o=f[c+4>>2]|0;if((d|0)>=0){f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;$S(a,o,g,h);u=e;return}f[a>>2]=f[o>>2];p=a+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=a+8|0;f[r>>2]=f[o+8>>2];f[a+12>>2]=f[o+12>>2];f[a+16>>2]=f[o+16>>2];f[a+20>>2]=f[o+20>>2];f[a+24>>2]=f[o+24>>2];f[a+28>>2]=f[o+28>>2];f[a+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[a+36>>2]=s;f[a+40>>2]=r;r=a+48|0;t=a+44|0;f[t>>2]=r;f[r>>2]=0;f[a+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];u=e;return}else{f[p>>2]=0;ZS(a,o);u=e;return}break}case 10:{o=f[c+4>>2]|0;if((d|0)<0){PQ(a,o,n);u=e;return}PQ(i,o,n);f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;$S(a,i,g,h);o=i+36|0;p=f[o>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)_S(i);f[o>>2]=0;o=i+16|0;p=i+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[p>>2]|0)>0){o=f[i+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[p>>2]|0))}p=f[i+44>>2]|0;if((p|0)==(i+48|0)){u=e;return}g0(p);u=e;return}case 6:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,5)|0;b[p>>0]=b[221887]|0;b[p+1>>0]=b[221888]|0;b[p+2>>0]=b[221889]|0;b[p+3>>0]=b[221890]|0;b[p+4>>0]=b[221891]|0;z5(-215,g,221893,221901,38)}p=f[c+4>>2]|0;f[a>>2]=1124007936;q=a+8|0;o=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[o>>2]=q;r=a+48|0;f[a+44>>2]=r;f[r>>2]=0;f[a+52>>2]=0;r=f[p>>2]|0;ei[f[(f[r>>2]|0)+12>>2]&511](r,p,a,-1);u=e;return}case 2:case 14:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;r=tT(g,5)|0;b[r>>0]=b[221887]|0;b[r+1>>0]=b[221888]|0;b[r+2>>0]=b[221889]|0;b[r+3>>0]=b[221890]|0;b[r+4>>0]=b[221891]|0;z5(-215,g,221893,221901,44)}f[j>>2]=f[c+8>>2];f[j+4>>2]=f[c+12>>2];CY(a,j,m,f[c+4>>2]|0,0);u=e;return}case 3:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;r=tT(g,5)|0;b[r>>0]=b[221887]|0;b[r+1>>0]=b[221888]|0;b[r+2>>0]=b[221889]|0;b[r+3>>0]=b[221890]|0;b[r+4>>0]=b[221891]|0;z5(-215,g,221893,221901,50)}r=f[c+4>>2]|0;if((f[r>>2]|0)==(f[r+4>>2]|0)){f[a>>2]=1124007936;t=a+8|0;s=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[s>>2]=t;p=a+48|0;f[a+44>>2]=p;f[p>>2]=0;f[a+52>>2]=0;u=e;return}b$(k,c,-1);p=f[r>>2]|0;f[a>>2]=m&4095|1124007936;f[a+4>>2]=2;q=a+8|0;o=f[k+4>>2]|0;f[q>>2]=o;x=f[k>>2]|0;f[a+12>>2]=x;f[a+16>>2]=p;f[a+20>>2]=p;y=a+24|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[a+40>>2]=q;q=a+48|0;f[a+44>>2]=q;z=a+52|0;f[z>>2]=0;f[q>>2]=0;if((p|0)==0&(Y(x,o)|0)!=0){f[g>>2]=0;f[g+4>>2]=0;v=tT(g,28)|0;A=271702;w=v+28|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,271731,461938,608)}r=(m>>>3&511)+1<<(47696>>>(m<<1&14)&3);t=Y(x,r)|0;f[q>>2]=t;f[z>>2]=r;r=p+(Y(t,o)|0)|0;f[a+28>>2]=r;f[y>>2]=r+(0-t)+t;WS(a);u=e;return}case 12:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;t=tT(g,5)|0;b[t>>0]=b[221887]|0;b[t+1>>0]=b[221888]|0;b[t+2>>0]=b[221889]|0;b[t+3>>0]=b[221890]|0;b[t+4>>0]=b[221891]|0;z5(-215,g,221893,221901,59)}t=f[c+4>>2]|0;r=f[t+4>>2]|0;if(!r){f[a>>2]=1124007936;s=a+8|0;B=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[B>>2]=s;y=a+48|0;f[a+44>>2]=y;f[y>>2]=0;f[a+52>>2]=0;u=e;return}f[h>>2]=1124007936;y=h+4|0;o=h+8|0;p=h+40|0;v=y;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[p>>2]=o;s=h+48|0;B=h+44|0;f[B>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[g>>2]=1;f[g+4>>2]=r;XS(h,2,g,0);z=h+16|0;q=f[z>>2]|0;if((r|0)>0){x=0;do{b[q+x>>0]=(f[(f[t>>2]|0)+(x>>>5<<2)>>2]&1<<(x&31)|0)!=0&1;x=x+1|0}while((x|0)!=(r|0));C=f[z>>2]|0}else C=q;f[a>>2]=f[h>>2];r=a+4|0;x=f[y>>2]|0;f[r>>2]=x;t=a+8|0;f[t>>2]=f[o>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=C;f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];D=h+36|0;E=f[D>>2]|0;f[a+36>>2]=E;f[a+40>>2]=t;t=a+48|0;F=a+44|0;f[F>>2]=t;f[t>>2]=0;f[a+52>>2]=0;if(!E)G=x;else{x=E+12|0;f[x>>2]=(f[x>>2]|0)+1;G=f[y>>2]|0}if((G|0)<3){x=f[B>>2]|0;E=f[F>>2]|0;f[E>>2]=f[x>>2];f[E+4>>2]=f[x+4>>2]}else{f[r>>2]=0;ZS(a,h)}r=f[D>>2]|0;if(r|0?(x=r+12|0,r=f[x>>2]|0,f[x>>2]=r+-1,(r|0)==1):0)_S(h);f[D>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){D=f[p>>2]|0;r=0;do{f[D+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[y>>2]|0))}y=f[B>>2]|0;if((y|0)!=(s|0))g0(y);u=e;return}case 0:{f[a>>2]=1124007936;y=a+8|0;r=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[r>>2]=y;s=a+48|0;f[a+44>>2]=s;f[s>>2]=0;f[a+52>>2]=0;u=e;return}case 4:{s=c$(c,d)|0;B=f[c+4>>2]|0;if((d|0)<=-1){f[g>>2]=0;H=g+4|0;f[H>>2]=0;I=tT(g,28)|0;v=I;A=221971;w=v+28|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,221893,221901,79)}y=f[B>>2]|0;r=y;if((((f[B+4>>2]|0)-y|0)/12|0|0)<=(d|0)){f[g>>2]=0;H=g+4|0;f[H>>2]=0;I=tT(g,28)|0;v=I;A=221971;w=v+28|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,221893,221901,79)}B=r+(d*12|0)|0;if((f[B>>2]|0)==(f[r+(d*12|0)+4>>2]|0)){f[a>>2]=1124007936;y=a+8|0;D=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[D>>2]=y;r=a+48|0;f[a+44>>2]=r;f[r>>2]=0;f[a+52>>2]=0;u=e;return}b$(l,c,d);r=f[B>>2]|0;f[a>>2]=s&4095|1124007936;f[a+4>>2]=2;p=a+8|0;z=f[l+4>>2]|0;f[p>>2]=z;o=f[l>>2]|0;f[a+12>>2]=o;f[a+16>>2]=r;f[a+20>>2]=r;q=a+24|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[a+40>>2]=p;p=a+48|0;f[a+44>>2]=p;x=a+52|0;f[x>>2]=0;f[p>>2]=0;if((r|0)==0&(Y(o,z)|0)!=0){f[g>>2]=0;f[g+4>>2]=0;v=tT(g,28)|0;A=271702;w=v+28|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,271731,461938,608)}B=(s>>>3&511)+1<<(47696>>>(s<<1&14)&3);y=Y(o,B)|0;f[p>>2]=y;f[x>>2]=B;B=r+(Y(y,z)|0)|0;f[a+28>>2]=B;f[q>>2]=B+(0-y)+y;WS(a);u=e;return}case 5:{y=f[c+4>>2]|0;if((d|0)<=-1){f[g>>2]=0;J=g+4|0;f[J>>2]=0;K=tT(g,27)|0;v=K;A=222e3;w=v+27|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,221893,221901,88)}q=f[y>>2]|0;z=q;if((((f[y+4>>2]|0)-q|0)/56|0|0)<=(d|0)){f[g>>2]=0;J=g+4|0;f[J>>2]=0;K=tT(g,27)|0;v=K;A=222e3;w=v+27|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,221893,221901,88)}y=z+(d*56|0)|0;f[a>>2]=f[y>>2];q=a+4|0;r=z+(d*56|0)+4|0;f[q>>2]=f[r>>2];x=a+8|0;f[x>>2]=f[z+(d*56|0)+8>>2];f[a+12>>2]=f[z+(d*56|0)+12>>2];f[a+16>>2]=f[z+(d*56|0)+16>>2];f[a+20>>2]=f[z+(d*56|0)+20>>2];f[a+24>>2]=f[z+(d*56|0)+24>>2];f[a+28>>2]=f[z+(d*56|0)+28>>2];f[a+32>>2]=f[z+(d*56|0)+32>>2];p=f[z+(d*56|0)+36>>2]|0;f[a+36>>2]=p;f[a+40>>2]=x;x=a+48|0;o=a+44|0;f[o>>2]=x;f[x>>2]=0;f[a+52>>2]=0;if(p|0){x=p+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[r>>2]|0)<3){r=f[z+(d*56|0)+44>>2]|0;x=f[o>>2]|0;f[x>>2]=f[r>>2];f[x+4>>2]=f[r+4>>2];u=e;return}else{f[q>>2]=0;ZS(a,y);u=e;return}break}case 15:{y=f[c+4>>2]|0;if((d|0)<=-1){f[g>>2]=0;L=g+4|0;f[L>>2]=0;M=tT(g,23)|0;v=M;A=222028;w=v+23|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,221893,221901,96)}if((f[c+12>>2]|0)<=(d|0)){f[g>>2]=0;L=g+4|0;f[L>>2]=0;M=tT(g,23)|0;v=M;A=222028;w=v+23|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,221893,221901,96)}z=y+(d*56|0)|0;f[a>>2]=f[z>>2];q=a+4|0;r=y+(d*56|0)+4|0;f[q>>2]=f[r>>2];x=a+8|0;f[x>>2]=f[y+(d*56|0)+8>>2];f[a+12>>2]=f[y+(d*56|0)+12>>2];f[a+16>>2]=f[y+(d*56|0)+16>>2];f[a+20>>2]=f[y+(d*56|0)+20>>2];f[a+24>>2]=f[y+(d*56|0)+24>>2];f[a+28>>2]=f[y+(d*56|0)+28>>2];f[a+32>>2]=f[y+(d*56|0)+32>>2];o=f[y+(d*56|0)+36>>2]|0;f[a+36>>2]=o;f[a+40>>2]=x;x=a+48|0;p=a+44|0;f[p>>2]=x;f[x>>2]=0;f[a+52>>2]=0;if(o|0){x=o+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[r>>2]|0)<3){r=f[y+(d*56|0)+44>>2]|0;x=f[p>>2]|0;f[x>>2]=f[r>>2];f[x+4>>2]=f[r+4>>2];u=e;return}else{f[q>>2]=0;ZS(a,z);u=e;return}break}case 11:{z=f[c+4>>2]|0;if((d|0)<=-1){f[g>>2]=0;N=g+4|0;f[N>>2]=0;O=tT(g,27)|0;v=O;A=222e3;w=v+27|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,221893,221901,104)}y=f[z>>2]|0;if((((f[z+4>>2]|0)-y|0)/48|0|0)<=(d|0)){f[g>>2]=0;N=g+4|0;f[N>>2]=0;O=tT(g,27)|0;v=O;A=222e3;w=v+27|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-215,g,221893,221901,104)}PQ(a,y+(d*48|0)|0,n);u=e;return}case 7:{if((d|0)<0){f[g>>2]=0;f[g+4>>2]=0;v=tT(g,75)|0;A=222052;w=v+75|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-213,g,221893,221901,112)}else{f[g>>2]=0;f[g+4>>2]=0;y=tT(g,5)|0;b[y>>0]=b[221887]|0;b[y+1>>0]=b[221888]|0;b[y+2>>0]=b[221889]|0;b[y+3>>0]=b[221890]|0;b[y+4>>0]=b[221891]|0;z5(-215,g,221893,221901,111)}break}case 9:{if((d|0)<0){f[g>>2]=0;f[g+4>>2]=0;v=tT(g,66)|0;A=222128;w=v+66|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-213,g,221893,221901,118)}else{f[g>>2]=0;f[g+4>>2]=0;y=tT(g,5)|0;b[y>>0]=b[221887]|0;b[y+1>>0]=b[221888]|0;b[y+2>>0]=b[221889]|0;b[y+3>>0]=b[221890]|0;b[y+4>>0]=b[221891]|0;z5(-215,g,221893,221901,117)}break}case 8:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;y=tT(g,5)|0;b[y>>0]=b[221887]|0;b[y+1>>0]=b[221888]|0;b[y+2>>0]=b[221889]|0;b[y+3>>0]=b[221890]|0;b[y+4>>0]=b[221891]|0;z5(-215,g,221893,221901,123)}y=f[c+4>>2]|0;z=f[y+4>>2]|0;f[g>>2]=f[y+8>>2];f[g+4>>2]=z;CY(a,g,f[y>>2]&4095,f[y+16>>2]|0,f[y+12>>2]|0);u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;v=tT(g,30)|0;A=222195;w=v+30|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(w|0));z5(-213,g,221893,221901,130)}}while(0)}function b$(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;do switch(h>>>16&31){case 1:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,5)|0;b[i>>0]=b[221887]|0;b[i+1>>0]=b[221888]|0;b[i+2>>0]=b[221889]|0;b[i+3>>0]=b[221890]|0;b[i+4>>0]=b[221891]|0;z5(-215,g,467763,221901,400)}i=f[(f[c+4>>2]|0)+40>>2]|0;j=f[i>>2]|0;f[a>>2]=f[i+4>>2];f[a+4>>2]=j;u=e;return}case 6:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,5)|0;b[j>>0]=b[221887]|0;b[j+1>>0]=b[221888]|0;b[j+2>>0]=b[221889]|0;b[j+3>>0]=b[221890]|0;b[j+4>>0]=b[221891]|0;z5(-215,g,467763,221901,406)}vY(a,f[c+4>>2]|0);u=e;return}case 10:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,5)|0;b[j>>0]=b[221887]|0;b[j+1>>0]=b[221888]|0;b[j+2>>0]=b[221889]|0;b[j+3>>0]=b[221890]|0;b[j+4>>0]=b[221891]|0;z5(-215,g,467763,221901,412)}j=f[(f[c+4>>2]|0)+32>>2]|0;i=f[j>>2]|0;f[a>>2]=f[j+4>>2];f[a+4>>2]=i;u=e;return}case 2:case 14:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,5)|0;b[i>>0]=b[221887]|0;b[i+1>>0]=b[221888]|0;b[i+2>>0]=b[221889]|0;b[i+3>>0]=b[221890]|0;b[i+4>>0]=b[221891]|0;z5(-215,g,467763,221901,418)}f[a>>2]=f[c+8>>2];f[a+4>>2]=f[c+12>>2];u=e;return}case 3:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,5)|0;b[i>>0]=b[221887]|0;b[i+1>>0]=b[221888]|0;b[i+2>>0]=b[221889]|0;b[i+3>>0]=b[221890]|0;b[i+4>>0]=b[221891]|0;z5(-215,g,467763,221901,424)}i=f[c+4>>2]|0;j=(f[i+4>>2]|0)-(f[i>>2]|0)|0;if((j|0)==(j>>2|0)){f[a>>2]=j;f[a+4>>2]=1;u=e;return}else{f[a>>2]=(j>>>0)/((h>>>3&511)+1<<(47696>>>(h<<1&14)&3)>>>0)|0;f[a+4>>2]=1;u=e;return}break}case 12:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,5)|0;b[j>>0]=b[221887]|0;b[j+1>>0]=b[221888]|0;b[j+2>>0]=b[221889]|0;b[j+3>>0]=b[221890]|0;b[j+4>>0]=b[221891]|0;z5(-215,g,467763,221901,433)}f[a>>2]=f[(f[c+4>>2]|0)+4>>2];f[a+4>>2]=1;u=e;return}case 0:{f[a>>2]=0;f[a+4>>2]=0;u=e;return}case 4:{j=f[c+4>>2]|0;if((d|0)<0){i=f[j>>2]|0;k=f[j+4>>2]|0;if((i|0)==(k|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(k-i|0)/12|0;f[a+4>>2]=1;u=e;return}}i=f[j>>2]|0;k=i;if((((f[j+4>>2]|0)-i|0)/12|0|0)<=(d|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,18)|0;m=222252;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,467763,221901,446)}i=(f[k+(d*12|0)+4>>2]|0)-(f[k+(d*12|0)>>2]|0)|0;o=f[j>>2]|0;if((i|0)==((f[o+(d*12|0)+4>>2]|0)-(f[o+(d*12|0)>>2]|0)>>2|0)){f[a>>2]=i;f[a+4>>2]=1;u=e;return}else{f[a>>2]=(i>>>0)/((h>>>3&511)+1<<(47696>>>(h<<1&14)&3)>>>0)|0;f[a+4>>2]=1;u=e;return}break}case 5:{i=f[c+4>>2]|0;if((d|0)>=0){o=f[i>>2]|0;if((((f[i+4>>2]|0)-o|0)/56|0|0)<=(d|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,18)|0;m=222252;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,467763,221901,458)}j=f[o+(d*56|0)+40>>2]|0;k=f[j>>2]|0;f[a>>2]=f[j+4>>2];f[a+4>>2]=k;u=e;return}k=f[i>>2]|0;j=f[i+4>>2]|0;if((k|0)==(j|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(j-k|0)/56|0;f[a+4>>2]=1;u=e;return}break}case 15:{k=f[c+4>>2]|0;j=f[c+12>>2]|0;if((d|0)>=0){if((j|0)<=(d|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,13)|0;m=222271;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,467763,221901,468)}i=f[k+(d*56|0)+40>>2]|0;o=f[i>>2]|0;f[a>>2]=f[i+4>>2];f[a+4>>2]=o;u=e;return}if(!j){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=j;f[a+4>>2]=1;u=e;return}break}case 13:{o=f[c+4>>2]|0;if((d|0)>=0){i=f[o>>2]|0;p=i;if((((f[o+4>>2]|0)-i|0)/36|0|0)<=(d|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,18)|0;m=222252;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,467763,221901,478)}j=f[p+(d*36|0)+4>>2]|0;f[a>>2]=f[p+(d*36|0)+8>>2];f[a+4>>2]=j;u=e;return}j=f[o>>2]|0;k=f[o+4>>2]|0;if((j|0)==(k|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(k-j|0)/36|0;f[a+4>>2]=1;u=e;return}break}case 11:{j=f[c+4>>2]|0;if((d|0)>=0){k=f[j>>2]|0;if((((f[j+4>>2]|0)-k|0)/48|0|0)<=(d|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,18)|0;m=222252;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,467763,221901,487)}o=f[k+(d*48|0)+32>>2]|0;p=f[o>>2]|0;f[a>>2]=f[o+4>>2];f[a+4>>2]=p;u=e;return}p=f[j>>2]|0;o=f[j+4>>2]|0;if((p|0)==(o|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(o-p|0)/48|0;f[a+4>>2]=1;u=e;return}break}case 7:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,5)|0;b[p>>0]=b[221887]|0;b[p+1>>0]=b[221888]|0;b[p+2>>0]=b[221889]|0;b[p+3>>0]=b[221890]|0;b[p+4>>0]=b[221891]|0;z5(-215,g,467763,221901,494)}p=f[c+4>>2]|0;o=f[p+8>>2]|0;f[a>>2]=f[p+12>>2];f[a+4>>2]=o;u=e;return}case 9:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;o=tT(g,5)|0;b[o>>0]=b[221887]|0;b[o+1>>0]=b[221888]|0;b[o+2>>0]=b[221889]|0;b[o+3>>0]=b[221890]|0;b[o+4>>0]=b[221891]|0;z5(-215,g,467763,221901,501)}o=f[c+4>>2]|0;p=f[o+4>>2]|0;f[a>>2]=f[o+8>>2];f[a+4>>2]=p;u=e;return}case 8:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,5)|0;b[p>>0]=b[221887]|0;b[p+1>>0]=b[221888]|0;b[p+2>>0]=b[221889]|0;b[p+3>>0]=b[221890]|0;b[p+4>>0]=b[221891]|0;z5(-215,g,467763,221901,508)}p=f[c+4>>2]|0;o=f[p+4>>2]|0;f[a>>2]=f[p+8>>2];f[a+4>>2]=o;u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;l=tT(g,30)|0;m=222195;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,g,467763,221901,513)}}while(0)}function c$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;do switch(g>>>16&31){case 1:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 10:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 6:{h=wY(f[a+4>>2]|0)|0;u=d;return h|0}case 2:case 3:case 4:case 12:case 14:{h=g&4095;u=d;return h|0}case 11:{i=f[a+4>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;if((j|0)==(k|0)){if((g|0)>=0){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,25)|0;m=222226;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,284842,221901,788)}h=g&4095;u=d;return h|0}else{if(((k-j|0)/48|0|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,18)|0;m=222252;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,284842,221901,791)}h=f[j+(((c|0)>0?c:0)*48|0)>>2]&4095;u=d;return h|0}break}case 5:{k=f[a+4>>2]|0;i=f[k>>2]|0;o=f[k+4>>2]|0;if((i|0)==(o|0)){if((g|0)>=0){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,25)|0;m=222226;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,284842,221901,800)}h=g&4095;u=d;return h|0}else{if(((o-i|0)/56|0|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,18)|0;m=222252;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,284842,221901,803)}h=f[i+(((c|0)>0?c:0)*56|0)>>2]&4095;u=d;return h|0}break}case 15:{o=f[a+4>>2]|0;j=f[a+12>>2]|0;if(!j){if((g|0)>=0){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,25)|0;m=222226;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,284842,221901,812)}h=g&4095;u=d;return h|0}else{if((j|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,13)|0;m=222271;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,284842,221901,815)}h=f[o+(((c|0)>0?c:0)*56|0)>>2]&4095;u=d;return h|0}break}case 13:{j=f[a+4>>2]|0;i=f[j>>2]|0;k=f[j+4>>2]|0;if((i|0)==(k|0)){if((g|0)>=0){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,25)|0;m=222226;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,284842,221901,824)}h=g&4095;u=d;return h|0}else{if(((k-i|0)/36|0|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,18)|0;m=222252;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,e,284842,221901,827)}h=f[i+(((c|0)>0?c:0)*36|0)>>2]&4095;u=d;return h|0}break}case 7:{h=f[(f[a+4>>2]|0)+16>>2]|0;u=d;return h|0}case 9:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 8:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 0:{h=-1;u=d;return h|0}default:{f[e>>2]=0;f[e+4>>2]=0;l=tT(e,30)|0;m=222195;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,e,284842,221901,840)}}while(0);return 0}function d$(a){a=a|0;return f[a>>2]&2031616|0}function e$(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+128|0;g=e+120|0;h=e+112|0;i=e+56|0;j=e;k=f[c>>2]|0;l=k&2031616;m=k&50331648;k=l&2097151;a:do if((k|0)>=655360){if((k|0)<720896){switch(k|0){case 655360:break;default:break a}n=f[c+4>>2]|0;if((d|0)>=0){f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;IQ(a,n,g,h);u=e;return}f[a>>2]=f[n>>2];o=a+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=a+8|0;f[q>>2]=f[n+8>>2];f[a+12>>2]=f[n+12>>2];f[a+16>>2]=f[n+16>>2];f[a+20>>2]=f[n+20>>2];r=f[n+24>>2]|0;f[a+24>>2]=r;f[a+28>>2]=f[n+28>>2];f[a+32>>2]=q;q=a+40|0;s=a+36|0;f[s>>2]=q;f[a+44>>2]=0;f[q>>2]=0;if(r|0){q=r+8|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+36>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];u=e;return}else{f[o>>2]=0;FQ(a,n);u=e;return}}switch(k|0){case 720896:break;default:break a}n=f[c+4>>2]|0;if((d|0)<=-1){f[g>>2]=0;t=g+4|0;f[t>>2]=0;v=tT(g,27)|0;w=v;x=222e3;y=w+27|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,g,222285,221901,149)}o=f[n>>2]|0;p=o;if((((f[n+4>>2]|0)-o|0)/48|0|0)<=(d|0)){f[g>>2]=0;t=g+4|0;f[t>>2]=0;v=tT(g,27)|0;w=v;x=222e3;y=w+27|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,g,222285,221901,149)}n=p+(d*48|0)|0;f[a>>2]=f[n>>2];o=a+4|0;q=p+(d*48|0)+4|0;f[o>>2]=f[q>>2];s=a+8|0;f[s>>2]=f[p+(d*48|0)+8>>2];f[a+12>>2]=f[p+(d*48|0)+12>>2];f[a+16>>2]=f[p+(d*48|0)+16>>2];f[a+20>>2]=f[p+(d*48|0)+20>>2];r=f[p+(d*48|0)+24>>2]|0;f[a+24>>2]=r;f[a+28>>2]=f[p+(d*48|0)+28>>2];f[a+32>>2]=s;s=a+40|0;z=a+36|0;f[z>>2]=s;f[a+44>>2]=0;f[s>>2]=0;if(r|0){s=r+8|0;f[s>>2]=(f[s>>2]|0)+1}if((f[q>>2]|0)<3){q=f[p+(d*48|0)+36>>2]|0;s=f[z>>2]|0;f[s>>2]=f[q>>2];f[s+4>>2]=f[q+4>>2];u=e;return}else{f[o>>2]=0;FQ(a,n);u=e;return}}else{switch(k|0){case 65536:break;default:break a}n=f[c+4>>2]|0;if((d|0)<0){BQ(a,n,m,0);u=e;return}f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;$S(i,n,g,h);BQ(a,i,m,0);n=i+36|0;o=f[n>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)_S(i);f[n>>2]=0;n=i+16|0;o=i+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[o>>2]|0)>0){n=f[i+40>>2]|0;q=0;do{f[n+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[i+44>>2]|0;if((o|0)==(i+48|0)){u=e;return}g0(o);u=e;return}while(0);do if((d|0)<0&(l|0)==65536){i=f[c+4>>2]|0;f[j>>2]=f[i>>2];h=j+4|0;g=i+4|0;f[h>>2]=f[g>>2];k=j+8|0;f[k>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];x=f[i+36>>2]|0;f[j+36>>2]=x;f[j+40>>2]=k;k=j+48|0;w=j+44|0;f[w>>2]=k;f[k>>2]=0;f[j+52>>2]=0;if(x|0){k=x+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[g>>2]|0)<3){g=f[i+44>>2]|0;k=f[w>>2]|0;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];break}else{f[h>>2]=0;ZS(j,i);break}}else a$(j,c,d);while(0);BQ(a,j,m,0);m=j+36|0;a=f[m>>2]|0;if(a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)_S(j);f[m>>2]=0;m=j+16|0;a=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[a>>2]|0)>0){m=f[j+40>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)==(j+48|0)){u=e;return}g0(a);u=e;return}function f$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=u;u=u+240|0;e=d+184|0;g=d+128|0;h=d+64|0;i=d;j=d+120|0;k=d+56|0;l=f[a>>2]|0;m=l&50331648;do switch(l>>>16&31){case 1:{n=f[a+4>>2]|0;o=n+40|0;p=f[f[o>>2]>>2]|0;g$(c,p);if((p|0)<=0){u=d;return}q=n+4|0;r=n+12|0;s=n+16|0;t=n+44|0;v=e+36|0;w=e+16|0;x=e+4|0;y=e+40|0;z=e+44|0;A=e+48|0;B=e+8|0;C=e+12|0;D=e+20|0;E=e+24|0;F=e+28|0;G=e+32|0;H=0;do{I=f[q>>2]|0;if((I|0)==2)Vj(e,1,f[r>>2]|0,f[n>>2]&4095,(f[s>>2]|0)+(Y(f[f[t>>2]>>2]|0,H)|0)|0,0);else{J=f[t>>2]|0;dT(e,I+-1|0,(f[o>>2]|0)+4|0,f[n>>2]&4095,(f[s>>2]|0)+(Y(f[J>>2]|0,H)|0)|0,J+4|0)}J=f[c>>2]|0;I=J+(H*56|0)|0;if((I|0)!=(e|0)){K=f[v>>2]|0;if(K|0){L=K+12|0;f[L>>2]=(f[L>>2]|0)+1}L=J+(H*56|0)+36|0;K=f[L>>2]|0;if(K|0?(M=K+12|0,K=f[M>>2]|0,f[M>>2]=K+-1,(K|0)==1):0)_S(I);f[L>>2]=0;K=J+(H*56|0)+16|0;M=J+(H*56|0)+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[M>>2]|0)>0){N=f[J+(H*56|0)+40>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0;P=f[M>>2]|0}while((O|0)<(P|0));f[I>>2]=f[e>>2];if((P|0)<3)Q=18;else Q=20}else{f[I>>2]=f[e>>2];Q=18}if((Q|0)==18){Q=0;O=f[x>>2]|0;if((O|0)<3){f[M>>2]=O;f[J+(H*56|0)+8>>2]=f[B>>2];f[J+(H*56|0)+12>>2]=f[C>>2];O=f[z>>2]|0;N=f[J+(H*56|0)+44>>2]|0;f[N>>2]=f[O>>2];f[N+4>>2]=f[O+4>>2]}else Q=20}if((Q|0)==20){Q=0;ZS(I,e)}f[K>>2]=f[w>>2];f[J+(H*56|0)+20>>2]=f[D>>2];f[J+(H*56|0)+24>>2]=f[E>>2];f[J+(H*56|0)+28>>2]=f[F>>2];f[J+(H*56|0)+32>>2]=f[G>>2];f[L>>2]=f[v>>2]}O=f[v>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)_S(e);f[v>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){O=f[y>>2]|0;N=0;do{f[O+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[x>>2]|0))}N=f[z>>2]|0;if((N|0)!=(A|0))g0(N);H=H+1|0}while((H|0)<(p|0));u=d;return}case 6:{p=f[a+4>>2]|0;f[h>>2]=1124007936;H=h+4|0;A=h+8|0;z=h+40|0;R=H;S=R+36|0;do{f[R>>2]=0;R=R+4|0}while((R|0)<(S|0));f[z>>2]=A;x=h+48|0;y=h+44|0;f[y>>2]=x;f[x>>2]=0;f[h+52>>2]=0;w=f[p>>2]|0;ei[f[(f[w>>2]|0)+12>>2]&511](w,p,h,-1);w=f[f[z>>2]>>2]|0;g$(c,w);if((w|0)>0){v=e+4|0;G=g+4|0;F=i+36|0;E=i+16|0;D=i+4|0;C=i+40|0;B=i+44|0;s=i+48|0;n=i+8|0;o=i+12|0;t=i+20|0;r=i+24|0;q=i+28|0;N=i+32|0;O=0;do{L=O;O=O+1|0;f[e>>2]=L;f[v>>2]=O;f[g>>2]=-2147483648;f[G>>2]=2147483647;$S(i,h,e,g);J=f[c>>2]|0;K=J+(L*56|0)|0;if((K|0)!=(i|0)){I=f[F>>2]|0;if(I|0){M=I+12|0;f[M>>2]=(f[M>>2]|0)+1}M=J+(L*56|0)+36|0;I=f[M>>2]|0;if(I|0?(T=I+12|0,I=f[T>>2]|0,f[T>>2]=I+-1,(I|0)==1):0)_S(K);f[M>>2]=0;I=J+(L*56|0)+16|0;T=J+(L*56|0)+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[T>>2]|0)>0){U=f[J+(L*56|0)+40>>2]|0;V=0;do{f[U+(V<<2)>>2]=0;V=V+1|0;W=f[T>>2]|0}while((V|0)<(W|0));f[K>>2]=f[i>>2];if((W|0)<3)Q=53;else Q=55}else{f[K>>2]=f[i>>2];Q=53}if((Q|0)==53){Q=0;V=f[D>>2]|0;if((V|0)<3){f[T>>2]=V;f[J+(L*56|0)+8>>2]=f[n>>2];f[J+(L*56|0)+12>>2]=f[o>>2];V=f[B>>2]|0;U=f[J+(L*56|0)+44>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else Q=55}if((Q|0)==55){Q=0;ZS(K,i)}f[I>>2]=f[E>>2];f[J+(L*56|0)+20>>2]=f[t>>2];f[J+(L*56|0)+24>>2]=f[r>>2];f[J+(L*56|0)+28>>2]=f[q>>2];f[J+(L*56|0)+32>>2]=f[N>>2];f[M>>2]=f[F>>2]}V=f[F>>2]|0;if(V|0?(U=V+12|0,V=f[U>>2]|0,f[U>>2]=V+-1,(V|0)==1):0)_S(i);f[F>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[D>>2]|0)>0){V=f[C>>2]|0;U=0;do{f[V+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[D>>2]|0))}U=f[B>>2]|0;if((U|0)!=(s|0))g0(U)}while((O|0)<(w|0))}w=h+36|0;O=f[w>>2]|0;if(O|0?(s=O+12|0,O=f[s>>2]|0,f[s>>2]=O+-1,(O|0)==1):0)_S(h);f[w>>2]=0;w=h+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[H>>2]|0)>0){w=f[z>>2]|0;O=0;do{f[w+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[H>>2]|0))}H=f[y>>2]|0;if((H|0)!=(x|0))g0(H);u=d;return}case 2:case 14:{H=f[a+12>>2]|0;O=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);g$(c,H);if(!H){u=d;return}w=a+8|0;z=a+4|0;s=e+36|0;B=e+16|0;D=e+4|0;C=e+40|0;E=e+44|0;F=e+48|0;N=e+8|0;q=e+12|0;r=e+20|0;t=e+24|0;o=e+28|0;n=e+32|0;G=0;do{v=f[w>>2]|0;Vj(e,1,v,f[a>>2]&4095,(f[z>>2]|0)+(Y(Y(G,O)|0,v)|0)|0,0);v=f[c>>2]|0;p=v+(G*56|0)|0;if((p|0)!=(e|0)){A=f[s>>2]|0;if(A|0){U=A+12|0;f[U>>2]=(f[U>>2]|0)+1}U=v+(G*56|0)+36|0;A=f[U>>2]|0;if(A|0?(V=A+12|0,A=f[V>>2]|0,f[V>>2]=A+-1,(A|0)==1):0)_S(p);f[U>>2]=0;A=v+(G*56|0)+16|0;V=v+(G*56|0)+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[V>>2]|0)>0){M=f[v+(G*56|0)+40>>2]|0;L=0;do{f[M+(L<<2)>>2]=0;L=L+1|0;X=f[V>>2]|0}while((L|0)<(X|0));f[p>>2]=f[e>>2];if((X|0)<3)Q=79;else Q=81}else{f[p>>2]=f[e>>2];Q=79}if((Q|0)==79){Q=0;L=f[D>>2]|0;if((L|0)<3){f[V>>2]=L;f[v+(G*56|0)+8>>2]=f[N>>2];f[v+(G*56|0)+12>>2]=f[q>>2];L=f[E>>2]|0;M=f[v+(G*56|0)+44>>2]|0;f[M>>2]=f[L>>2];f[M+4>>2]=f[L+4>>2]}else Q=81}if((Q|0)==81){Q=0;ZS(p,e)}f[A>>2]=f[B>>2];f[v+(G*56|0)+20>>2]=f[r>>2];f[v+(G*56|0)+24>>2]=f[t>>2];f[v+(G*56|0)+28>>2]=f[o>>2];f[v+(G*56|0)+32>>2]=f[n>>2];f[U>>2]=f[s>>2]}L=f[s>>2]|0;if(L|0?(M=L+12|0,L=f[M>>2]|0,f[M>>2]=L+-1,(L|0)==1):0)_S(e);f[s>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[D>>2]|0)>0){L=f[C>>2]|0;M=0;do{f[L+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[D>>2]|0))}M=f[E>>2]|0;if((M|0)!=(F|0))g0(M);G=G+1|0}while(G>>>0<H>>>0);u=d;return}case 3:{H=f[a+4>>2]|0;b$(j,a,-1);G=f[j>>2]|0;F=f[a>>2]|0;E=(F>>>3&511)+1|0;D=F&7;F=E<<(47696>>>(D<<1)&3);g$(c,G);if(!G){u=d;return}C=e+36|0;B=e+16|0;s=e+4|0;n=e+40|0;o=e+44|0;t=e+48|0;r=e+8|0;q=e+12|0;N=e+20|0;O=e+24|0;z=e+28|0;w=e+32|0;x=0;do{Vj(e,1,E,D,(f[H>>2]|0)+(Y(x,F)|0)|0,0);y=f[c>>2]|0;M=y+(x*56|0)|0;if((M|0)!=(e|0)){L=f[C>>2]|0;if(L|0){U=L+12|0;f[U>>2]=(f[U>>2]|0)+1}U=y+(x*56|0)+36|0;L=f[U>>2]|0;if(L|0?(v=L+12|0,L=f[v>>2]|0,f[v>>2]=L+-1,(L|0)==1):0)_S(M);f[U>>2]=0;L=y+(x*56|0)+16|0;v=y+(x*56|0)+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[v>>2]|0)>0){A=f[y+(x*56|0)+40>>2]|0;p=0;do{f[A+(p<<2)>>2]=0;p=p+1|0;Z=f[v>>2]|0}while((p|0)<(Z|0));f[M>>2]=f[e>>2];if((Z|0)<3)Q=105;else Q=107}else{f[M>>2]=f[e>>2];Q=105}if((Q|0)==105){Q=0;p=f[s>>2]|0;if((p|0)<3){f[v>>2]=p;f[y+(x*56|0)+8>>2]=f[r>>2];f[y+(x*56|0)+12>>2]=f[q>>2];p=f[o>>2]|0;A=f[y+(x*56|0)+44>>2]|0;f[A>>2]=f[p>>2];f[A+4>>2]=f[p+4>>2]}else Q=107}if((Q|0)==107){Q=0;ZS(M,e)}f[L>>2]=f[B>>2];f[y+(x*56|0)+20>>2]=f[N>>2];f[y+(x*56|0)+24>>2]=f[O>>2];f[y+(x*56|0)+28>>2]=f[z>>2];f[y+(x*56|0)+32>>2]=f[w>>2];f[U>>2]=f[C>>2]}p=f[C>>2]|0;if(p|0?(A=p+12|0,p=f[A>>2]|0,f[A>>2]=p+-1,(p|0)==1):0)_S(e);f[C>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[s>>2]|0)>0){p=f[n>>2]|0;A=0;do{f[p+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[s>>2]|0))}A=f[o>>2]|0;if((A|0)!=(t|0))g0(A);x=x+1|0}while(x>>>0<G>>>0);u=d;return}case 0:{G=f[c>>2]|0;x=c+4|0;t=f[x>>2]|0;if((t|0)==(G|0)){u=d;return}else _=t;do{t=_+-56|0;f[x>>2]=t;o=_+-20|0;s=f[o>>2]|0;if(s|0?(n=s+12|0,s=f[n>>2]|0,f[n>>2]=s+-1,(s|0)==1):0)_S(t);f[o>>2]=0;o=_+-40|0;t=_+-52|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[t>>2]|0)>0){o=f[_+-16>>2]|0;s=0;do{f[o+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[t>>2]|0))}t=f[_+-12>>2]|0;if((t|0)!=(_+-8|0))g0(t);_=f[x>>2]|0}while((_|0)!=(G|0));u=d;return}case 4:{G=f[a+4>>2]|0;x=(f[G+4>>2]|0)-(f[G>>2]|0)|0;t=(x|0)/12|0;g$(c,t);if((x|0)<=0){u=d;return}x=l&4095|1124007936;s=g+4|0;o=g+8|0;n=k+4|0;B=g+12|0;C=g+16|0;w=g+20|0;z=g+24|0;O=g+28|0;N=g+40|0;q=g+48|0;r=g+44|0;F=g+52|0;H=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);D=g+36|0;E=g+32|0;A=0;while(1){p=f[G>>2]|0;b$(k,a,A);U=f[p+(A*12|0)>>2]|0;f[g>>2]=x;f[s>>2]=2;p=f[n>>2]|0;f[o>>2]=p;y=f[k>>2]|0;f[B>>2]=y;f[C>>2]=U;f[w>>2]=U;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[N>>2]=o;f[r>>2]=q;f[F>>2]=0;f[q>>2]=0;if((U|0)==0&(Y(y,p)|0)!=0){Q=131;break}L=Y(y,H)|0;f[q>>2]=L;f[F>>2]=H;y=U+(Y(L,p)|0)|0;f[O>>2]=y;f[z>>2]=y+(0-L)+L;WS(g);L=f[c>>2]|0;y=L+(A*56|0)|0;if((y|0)!=(g|0)){p=f[D>>2]|0;if(p|0){U=p+12|0;f[U>>2]=(f[U>>2]|0)+1}U=L+(A*56|0)+36|0;p=f[U>>2]|0;if(p|0?(M=p+12|0,p=f[M>>2]|0,f[M>>2]=p+-1,(p|0)==1):0)_S(y);f[U>>2]=0;p=L+(A*56|0)+16|0;M=L+(A*56|0)+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[M>>2]|0)>0){v=f[L+(A*56|0)+40>>2]|0;V=0;do{f[v+(V<<2)>>2]=0;V=V+1|0;$=f[M>>2]|0}while((V|0)<($|0));f[y>>2]=f[g>>2];if(($|0)<3)Q=143;else Q=145}else{f[y>>2]=f[g>>2];Q=143}if((Q|0)==143){Q=0;V=f[s>>2]|0;if((V|0)<3){f[M>>2]=V;f[L+(A*56|0)+8>>2]=f[o>>2];f[L+(A*56|0)+12>>2]=f[B>>2];V=f[r>>2]|0;v=f[L+(A*56|0)+44>>2]|0;f[v>>2]=f[V>>2];f[v+4>>2]=f[V+4>>2]}else Q=145}if((Q|0)==145){Q=0;ZS(y,g)}f[p>>2]=f[C>>2];f[L+(A*56|0)+20>>2]=f[w>>2];f[L+(A*56|0)+24>>2]=f[z>>2];f[L+(A*56|0)+28>>2]=f[O>>2];f[L+(A*56|0)+32>>2]=f[E>>2];f[U>>2]=f[D>>2]}V=f[D>>2]|0;if(V|0?(v=V+12|0,V=f[v>>2]|0,f[v>>2]=V+-1,(V|0)==1):0)_S(g);f[D>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[s>>2]|0)>0){V=f[N>>2]|0;v=0;do{f[V+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}v=f[r>>2]|0;if((v|0)!=(q|0))g0(v);A=A+1|0;if((A|0)>=(t|0)){Q=219;break}}if((Q|0)==131){f[e>>2]=0;f[e+4>>2]=0;R=tT(e,28)|0;aa=271702;S=R+28|0;do{b[R>>0]=b[aa>>0]|0;R=R+1|0;aa=aa+1|0}while((R|0)<(S|0));z5(-215,e,271731,461938,608)}else if((Q|0)==219){u=d;return}break}case 5:{t=f[a+4>>2]|0;A=(f[t+4>>2]|0)-(f[t>>2]|0)|0;q=(A|0)/56|0;g$(c,q);if(!A){u=d;return}A=0;do{r=f[t>>2]|0;s=r+(A*56|0)|0;N=f[c>>2]|0;C=N+(A*56|0)|0;if((N|0)!=(r|0)){D=r+(A*56|0)+36|0;E=f[D>>2]|0;if(E|0){O=E+12|0;f[O>>2]=(f[O>>2]|0)+1}O=N+(A*56|0)+36|0;E=f[O>>2]|0;if(E|0?(z=E+12|0,E=f[z>>2]|0,f[z>>2]=E+-1,(E|0)==1):0)_S(C);f[O>>2]=0;E=N+(A*56|0)+16|0;z=N+(A*56|0)+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[z>>2]|0)>0){w=f[N+(A*56|0)+40>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0;ba=f[z>>2]|0}while((B|0)<(ba|0));f[C>>2]=f[s>>2];if((ba|0)<3)Q=169;else Q=171}else{f[C>>2]=f[s>>2];Q=169}if((Q|0)==169){Q=0;B=f[r+(A*56|0)+4>>2]|0;if((B|0)<3){f[z>>2]=B;f[N+(A*56|0)+8>>2]=f[r+(A*56|0)+8>>2];f[N+(A*56|0)+12>>2]=f[r+(A*56|0)+12>>2];B=f[r+(A*56|0)+44>>2]|0;w=f[N+(A*56|0)+44>>2]|0;f[w>>2]=f[B>>2];f[w+4>>2]=f[B+4>>2]}else Q=171}if((Q|0)==171){Q=0;ZS(C,s)}f[E>>2]=f[r+(A*56|0)+16>>2];f[N+(A*56|0)+20>>2]=f[r+(A*56|0)+20>>2];f[N+(A*56|0)+24>>2]=f[r+(A*56|0)+24>>2];f[N+(A*56|0)+28>>2]=f[r+(A*56|0)+28>>2];f[N+(A*56|0)+32>>2]=f[r+(A*56|0)+32>>2];f[O>>2]=f[D>>2]}A=A+1|0}while(A>>>0<q>>>0);u=d;return}case 15:{q=f[a+4>>2]|0;A=f[a+12>>2]|0;g$(c,A);if(!A){u=d;return}t=0;do{B=q+(t*56|0)|0;w=f[c>>2]|0;o=w+(t*56|0)|0;if((w|0)!=(q|0)){H=q+(t*56|0)+36|0;F=f[H>>2]|0;if(F|0){n=F+12|0;f[n>>2]=(f[n>>2]|0)+1}n=w+(t*56|0)+36|0;F=f[n>>2]|0;if(F|0?(x=F+12|0,F=f[x>>2]|0,f[x>>2]=F+-1,(F|0)==1):0)_S(o);f[n>>2]=0;F=w+(t*56|0)+16|0;x=w+(t*56|0)+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[x>>2]|0)>0){G=f[w+(t*56|0)+40>>2]|0;v=0;do{f[G+(v<<2)>>2]=0;v=v+1|0;ca=f[x>>2]|0}while((v|0)<(ca|0));f[o>>2]=f[B>>2];if((ca|0)<3)Q=187;else Q=189}else{f[o>>2]=f[B>>2];Q=187}if((Q|0)==187){Q=0;v=f[q+(t*56|0)+4>>2]|0;if((v|0)<3){f[x>>2]=v;f[w+(t*56|0)+8>>2]=f[q+(t*56|0)+8>>2];f[w+(t*56|0)+12>>2]=f[q+(t*56|0)+12>>2];v=f[q+(t*56|0)+44>>2]|0;G=f[w+(t*56|0)+44>>2]|0;f[G>>2]=f[v>>2];f[G+4>>2]=f[v+4>>2]}else Q=189}if((Q|0)==189){Q=0;ZS(o,B)}f[F>>2]=f[q+(t*56|0)+16>>2];f[w+(t*56|0)+20>>2]=f[q+(t*56|0)+20>>2];f[w+(t*56|0)+24>>2]=f[q+(t*56|0)+24>>2];f[w+(t*56|0)+28>>2]=f[q+(t*56|0)+28>>2];f[w+(t*56|0)+32>>2]=f[q+(t*56|0)+32>>2];f[n>>2]=f[H>>2]}t=t+1|0}while((t|0)!=(A|0));u=d;return}case 11:{A=f[a+4>>2]|0;t=(f[A+4>>2]|0)-(f[A>>2]|0)|0;q=(t|0)/48|0;g$(c,q);if(!t){u=d;return}t=e+36|0;v=e+16|0;G=e+4|0;D=e+40|0;O=e+44|0;r=e+48|0;N=e+8|0;E=e+12|0;s=e+20|0;C=e+24|0;z=e+28|0;V=e+32|0;U=0;do{PQ(e,(f[A>>2]|0)+(U*48|0)|0,m);L=f[c>>2]|0;p=L+(U*56|0)|0;if((p|0)!=(e|0)){y=f[t>>2]|0;if(y|0){M=y+12|0;f[M>>2]=(f[M>>2]|0)+1}M=L+(U*56|0)+36|0;y=f[M>>2]|0;if(y|0?(J=y+12|0,y=f[J>>2]|0,f[J>>2]=y+-1,(y|0)==1):0)_S(p);f[M>>2]=0;y=L+(U*56|0)+16|0;J=L+(U*56|0)+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[J>>2]|0)>0){I=f[L+(U*56|0)+40>>2]|0;K=0;do{f[I+(K<<2)>>2]=0;K=K+1|0;da=f[J>>2]|0}while((K|0)<(da|0));f[p>>2]=f[e>>2];if((da|0)<3)Q=205;else Q=207}else{f[p>>2]=f[e>>2];Q=205}if((Q|0)==205){Q=0;K=f[G>>2]|0;if((K|0)<3){f[J>>2]=K;f[L+(U*56|0)+8>>2]=f[N>>2];f[L+(U*56|0)+12>>2]=f[E>>2];K=f[O>>2]|0;I=f[L+(U*56|0)+44>>2]|0;f[I>>2]=f[K>>2];f[I+4>>2]=f[K+4>>2]}else Q=207}if((Q|0)==207){Q=0;ZS(p,e)}f[y>>2]=f[v>>2];f[L+(U*56|0)+20>>2]=f[s>>2];f[L+(U*56|0)+24>>2]=f[C>>2];f[L+(U*56|0)+28>>2]=f[z>>2];f[L+(U*56|0)+32>>2]=f[V>>2];f[M>>2]=f[t>>2]}K=f[t>>2]|0;if(K|0?(I=K+12|0,K=f[I>>2]|0,f[I>>2]=K+-1,(K|0)==1):0)_S(e);f[t>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[G>>2]|0)>0){K=f[D>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[G>>2]|0))}I=f[O>>2]|0;if((I|0)!=(r|0))g0(I);U=U+1|0}while(U>>>0<q>>>0);u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;R=tT(e,30)|0;aa=222195;S=R+30|0;do{b[R>>0]=b[aa>>0]|0;R=R+1|0;aa=aa+1|0}while((R|0)<(S|0));z5(-213,e,222293,221901,270)}}while(0)}function g$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/56|0;h=d;if(g>>>0<b>>>0){h$(a,b-g|0);return}if(g>>>0<=b>>>0)return;g=e+(b*56|0)|0;if((h|0)==(g|0))return;else i=h;do{h=i+-56|0;f[c>>2]=h;b=i+-20|0;e=f[b>>2]|0;if(e|0?(a=e+12|0,e=f[a>>2]|0,f[a>>2]=e+-1,(e|0)==1):0)_S(h);f[b>>2]=0;b=i+-40|0;h=i+-52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[h>>2]|0)>0){b=f[i+-16>>2]|0;e=0;do{f[b+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[h>>2]|0))}h=f[i+-12>>2]|0;if((h|0)!=(i+-8|0))g0(h);i=f[c>>2]|0}while((i|0)!=(g|0));return}function h$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/56|0)>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=1124007936;k=j+8|0;l=j+40|0;m=j+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=j+48|0;f[j+44>>2]=o;f[o>>2]=0;f[j+52>>2]=0;j=(f[g>>2]|0)+56|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);u=c;return}i=f[a>>2]|0;j=(h-i|0)/56|0;h=j+b|0;if(h>>>0>76695844)mCc(a);g=(e-i|0)/56|0;i=g<<1;e=g>>>0<38347922?(i>>>0<h>>>0?h:i):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>76695844){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{p=VDc(e*56|0)|0;break}else p=0;while(0);f[d>>2]=p;i=p+(j*56|0)|0;j=d+8|0;f[j>>2]=i;f[d+4>>2]=i;f[d+12>>2]=p+(e*56|0);e=b;b=i;while(1){f[b>>2]=1124007936;i=b+8|0;g=b+40|0;m=b+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[g>>2]=i;k=b+48|0;f[b+44>>2]=k;f[k>>2]=0;f[b+52>>2]=0;e=e+-1|0;if(!e)break;else b=b+56|0}f[j>>2]=p+(h*56|0);hx(a,d);ix(d);u=c;return}function i$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d;g=f[a>>2]|0;h=g&50331648;i=g&2031616;if((i|0)<655360){if((i|0)<65536){switch(i|0){case 0:break;default:{f[e>>2]=0;j=e+4|0;f[j>>2]=0;k=tT(e,30)|0;l=k;m=222195;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,e,378806,221901,332)}}g=f[c>>2]|0;o=c+4|0;while(1){p=f[o>>2]|0;if((p|0)==(g|0))break;q=p+-48|0;f[o>>2]=q;GQ(q)}u=d;return}if((i|0)<327680){switch(i|0){case 65536:break;default:{f[e>>2]=0;j=e+4|0;f[j>>2]=0;k=tT(e,30)|0;l=k;m=222195;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,e,378806,221901,332)}}o=f[a+4>>2]|0;g=c+4|0;q=f[g>>2]|0;p=f[c>>2]|0;r=q-p|0;s=(r|0)/48|0;t=p;p=q;if(r){if(s>>>0>1?(r=t+48|0,(p|0)!=(r|0)):0){t=p;do{p=t+-48|0;f[g>>2]=p;GQ(p);t=f[g>>2]|0}while((t|0)!=(r|0))}}else j$(c,1-s|0);BQ(e,o,h,0);o=f[c>>2]|0;if((o|0)!=(e|0)){s=e+24|0;r=f[s>>2]|0;if(r|0){t=r+8|0;f[t>>2]=(f[t>>2]|0)+1}t=o+24|0;r=f[t>>2]|0;if(r|0?(g=r+8|0,r=f[g>>2]|0,f[g>>2]=r+-1,(r|0)==1):0)HQ(o);r=o+4|0;if((f[r>>2]|0)>0){g=f[o+32>>2]|0;p=0;do{f[g+(p<<2)>>2]=0;p=p+1|0;v=f[r>>2]|0}while((p|0)<(v|0));f[t>>2]=0;f[o>>2]=f[e>>2];if((v|0)<3)w=118;else w=120}else{f[t>>2]=0;f[o>>2]=f[e>>2];w=118}if((w|0)==118){v=f[e+4>>2]|0;if((v|0)<3){f[r>>2]=v;f[o+8>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];v=f[e+36>>2]|0;r=f[o+36>>2]|0;f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2]}else w=120}if((w|0)==120)FQ(o,e);f[o+16>>2]=f[e+16>>2];v=o+20|0;if(!(f[v>>2]|0))f[v>>2]=f[e+20>>2];f[t>>2]=f[s>>2];f[o+28>>2]=f[e+28>>2]}GQ(e);u=d;return}switch(i|0){case 327680:break;default:{f[e>>2]=0;j=e+4|0;f[j>>2]=0;k=tT(e,30)|0;l=k;m=222195;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,e,378806,221901,332)}}o=f[a+4>>2]|0;s=(f[o+4>>2]|0)-(f[o>>2]|0)|0;t=(s|0)/56|0;v=c+4|0;r=f[v>>2]|0;p=f[c>>2]|0;g=(r-p|0)/48|0;q=p;p=r;if(t>>>0<=g>>>0){if(t>>>0<g>>>0?(r=q+(t*48|0)|0,(p|0)!=(r|0)):0){q=p;do{p=q+-48|0;f[v>>2]=p;GQ(p);q=f[v>>2]|0}while((q|0)!=(r|0))}}else j$(c,t-g|0);if(!s){u=d;return}s=e+24|0;g=e+4|0;r=e+8|0;q=e+12|0;v=e+36|0;p=e+16|0;x=e+20|0;y=e+28|0;z=0;do{BQ(e,(f[o>>2]|0)+(z*56|0)|0,h,0);A=f[c>>2]|0;B=A+(z*48|0)|0;if((B|0)!=(e|0)){C=f[s>>2]|0;if(C|0){D=C+8|0;f[D>>2]=(f[D>>2]|0)+1}D=A+(z*48|0)+24|0;C=f[D>>2]|0;if(C|0?(E=C+8|0,C=f[E>>2]|0,f[E>>2]=C+-1,(C|0)==1):0)HQ(B);C=A+(z*48|0)+4|0;if((f[C>>2]|0)>0){E=f[A+(z*48|0)+32>>2]|0;F=0;do{f[E+(F<<2)>>2]=0;F=F+1|0;G=f[C>>2]|0}while((F|0)<(G|0));f[D>>2]=0;f[B>>2]=f[e>>2];if((G|0)<3)w=23;else w=25}else{f[D>>2]=0;f[B>>2]=f[e>>2];w=23}if((w|0)==23){w=0;F=f[g>>2]|0;if((F|0)<3){f[C>>2]=F;f[A+(z*48|0)+8>>2]=f[r>>2];f[A+(z*48|0)+12>>2]=f[q>>2];F=f[v>>2]|0;E=f[A+(z*48|0)+36>>2]|0;f[E>>2]=f[F>>2];f[E+4>>2]=f[F+4>>2]}else w=25}if((w|0)==25){w=0;FQ(B,e)}f[A+(z*48|0)+16>>2]=f[p>>2];F=A+(z*48|0)+20|0;if(!(f[F>>2]|0))f[F>>2]=f[x>>2];f[D>>2]=f[s>>2];f[A+(z*48|0)+28>>2]=f[y>>2]}GQ(e);z=z+1|0}while(z>>>0<t>>>0);u=d;return}if((i|0)<720896){switch(i|0){case 655360:break;default:{f[e>>2]=0;j=e+4|0;f[j>>2]=0;k=tT(e,30)|0;l=k;m=222195;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,e,378806,221901,332)}}t=f[a+4>>2]|0;z=c+4|0;y=f[z>>2]|0;s=f[c>>2]|0;x=y-s|0;p=(x|0)/48|0;v=s;s=y;if(x){if(p>>>0>1?(x=v+48|0,(s|0)!=(x|0)):0){v=s;do{s=v+-48|0;f[z>>2]=s;GQ(s);v=f[z>>2]|0}while((v|0)!=(x|0))}}else j$(c,1-p|0);p=f[c>>2]|0;if((p|0)==(t|0)){u=d;return}x=t+24|0;v=f[x>>2]|0;if(v|0){z=v+8|0;f[z>>2]=(f[z>>2]|0)+1}z=p+24|0;v=f[z>>2]|0;if(v|0?(s=v+8|0,v=f[s>>2]|0,f[s>>2]=v+-1,(v|0)==1):0)HQ(p);v=p+4|0;if((f[v>>2]|0)>0){s=f[p+32>>2]|0;y=0;do{f[s+(y<<2)>>2]=0;y=y+1|0;H=f[v>>2]|0}while((y|0)<(H|0));f[z>>2]=0;f[p>>2]=f[t>>2];if((H|0)<3)w=96;else w=98}else{f[z>>2]=0;f[p>>2]=f[t>>2];w=96}if((w|0)==96){H=f[t+4>>2]|0;if((H|0)<3){f[v>>2]=H;f[p+8>>2]=f[t+8>>2];f[p+12>>2]=f[t+12>>2];H=f[t+36>>2]|0;v=f[p+36>>2]|0;f[v>>2]=f[H>>2];f[v+4>>2]=f[H+4>>2]}else w=98}if((w|0)==98)FQ(p,t);f[p+16>>2]=f[t+16>>2];H=p+20|0;if(!(f[H>>2]|0))f[H>>2]=f[t+20>>2];f[z>>2]=f[x>>2];f[p+28>>2]=f[t+28>>2];u=d;return}if((i|0)<983040){switch(i|0){case 720896:break;default:{f[e>>2]=0;j=e+4|0;f[j>>2]=0;k=tT(e,30)|0;l=k;m=222195;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,e,378806,221901,332)}}t=f[a+4>>2]|0;p=(f[t+4>>2]|0)-(f[t>>2]|0)|0;x=(p|0)/48|0;z=c+4|0;H=f[z>>2]|0;v=f[c>>2]|0;y=(H-v|0)/48|0;s=v;v=H;if(x>>>0<=y>>>0){if(x>>>0<y>>>0?(H=s+(x*48|0)|0,(v|0)!=(H|0)):0){s=v;do{v=s+-48|0;f[z>>2]=v;GQ(v);s=f[z>>2]|0}while((s|0)!=(H|0))}}else j$(c,x-y|0);if(!p){u=d;return}p=0;do{y=f[t>>2]|0;H=y+(p*48|0)|0;s=f[c>>2]|0;z=s+(p*48|0)|0;if((s|0)!=(y|0)){v=y+(p*48|0)+24|0;q=f[v>>2]|0;if(q|0){r=q+8|0;f[r>>2]=(f[r>>2]|0)+1}r=s+(p*48|0)+24|0;q=f[r>>2]|0;if(q|0?(g=q+8|0,q=f[g>>2]|0,f[g>>2]=q+-1,(q|0)==1):0)HQ(z);q=s+(p*48|0)+4|0;if((f[q>>2]|0)>0){g=f[s+(p*48|0)+32>>2]|0;G=0;do{f[g+(G<<2)>>2]=0;G=G+1|0;I=f[q>>2]|0}while((G|0)<(I|0));f[r>>2]=0;f[z>>2]=f[H>>2];if((I|0)<3)w=73;else w=75}else{f[r>>2]=0;f[z>>2]=f[H>>2];w=73}if((w|0)==73){w=0;G=f[y+(p*48|0)+4>>2]|0;if((G|0)<3){f[q>>2]=G;f[s+(p*48|0)+8>>2]=f[y+(p*48|0)+8>>2];f[s+(p*48|0)+12>>2]=f[y+(p*48|0)+12>>2];G=f[y+(p*48|0)+36>>2]|0;g=f[s+(p*48|0)+36>>2]|0;f[g>>2]=f[G>>2];f[g+4>>2]=f[G+4>>2]}else w=75}if((w|0)==75){w=0;FQ(z,H)}f[s+(p*48|0)+16>>2]=f[y+(p*48|0)+16>>2];G=s+(p*48|0)+20|0;if(!(f[G>>2]|0))f[G>>2]=f[y+(p*48|0)+20>>2];f[r>>2]=f[v>>2];f[s+(p*48|0)+28>>2]=f[y+(p*48|0)+28>>2]}p=p+1|0}while(p>>>0<x>>>0);u=d;return}else{switch(i|0){case 983040:break;default:{f[e>>2]=0;j=e+4|0;f[j>>2]=0;k=tT(e,30)|0;l=k;m=222195;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-213,e,378806,221901,332)}}m=f[a+4>>2]|0;l=f[a+12>>2]|0;a=c+4|0;n=f[a>>2]|0;k=f[c>>2]|0;j=(n-k|0)/48|0;i=k;k=n;if(l>>>0<=j>>>0){if(l>>>0<j>>>0?(n=i+(l*48|0)|0,(k|0)!=(n|0)):0){i=k;do{k=i+-48|0;f[a>>2]=k;GQ(k);i=f[a>>2]|0}while((i|0)!=(n|0))}if(!l){u=d;return}}else j$(c,l-j|0);j=e+24|0;n=e+4|0;i=e+8|0;a=e+12|0;k=e+36|0;x=e+16|0;p=e+20|0;I=e+28|0;t=0;do{BQ(e,m+(t*56|0)|0,h,0);G=f[c>>2]|0;g=G+(t*48|0)|0;if((g|0)!=(e|0)){A=f[j>>2]|0;if(A|0){D=A+8|0;f[D>>2]=(f[D>>2]|0)+1}D=G+(t*48|0)+24|0;A=f[D>>2]|0;if(A|0?(B=A+8|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)HQ(g);A=G+(t*48|0)+4|0;if((f[A>>2]|0)>0){B=f[G+(t*48|0)+32>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0;J=f[A>>2]|0}while((C|0)<(J|0));f[D>>2]=0;f[g>>2]=f[e>>2];if((J|0)<3)w=48;else w=50}else{f[D>>2]=0;f[g>>2]=f[e>>2];w=48}if((w|0)==48){w=0;C=f[n>>2]|0;if((C|0)<3){f[A>>2]=C;f[G+(t*48|0)+8>>2]=f[i>>2];f[G+(t*48|0)+12>>2]=f[a>>2];C=f[k>>2]|0;B=f[G+(t*48|0)+36>>2]|0;f[B>>2]=f[C>>2];f[B+4>>2]=f[C+4>>2]}else w=50}if((w|0)==50){w=0;FQ(g,e)}f[G+(t*48|0)+16>>2]=f[x>>2];C=G+(t*48|0)+20|0;if(!(f[C>>2]|0))f[C>>2]=f[p>>2];f[D>>2]=f[j>>2];f[G+(t*48|0)+28>>2]=f[I>>2]}GQ(e);t=t+1|0}while(t>>>0<l>>>0);u=d;return}}function j$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/48|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=1124007936;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[i+32>>2]=i+8;j=i+40|0;f[i+36>>2]=j;f[i+44>>2]=0;f[j>>2]=0;i=(f[e>>2]|0)+48|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/48|0;g=i+b|0;if(g>>>0>89478485)mCc(a);j=(d-h|0)/48|0;h=j<<1;d=j>>>0<44739242?(h>>>0<g>>>0?g:h):89478485;do if(d)if(d>>>0>89478485){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*48|0)|0;break}else k=0;while(0);h=k+(i*48|0)|0;i=h;g=k+(d*48|0)|0;d=b;b=i;k=h;do{f[k>>2]=1124007936;j=k+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[k+32>>2]=k+8;j=k+40|0;f[k+36>>2]=j;f[k+44>>2]=0;f[j>>2]=0;k=b+48|0;b=k;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;k=f[e>>2]|0;if((k|0)==(g|0)){l=i;m=g;n=k}else{j=k;k=i;i=h;do{h=i+-48|0;o=j;j=j+-48|0;f[h>>2]=f[j>>2];p=i+-44|0;q=o+-44|0;f[p>>2]=f[q>>2];r=i+-40|0;f[r>>2]=f[o+-40>>2];f[i+-36>>2]=f[o+-36>>2];f[i+-32>>2]=f[o+-32>>2];f[i+-28>>2]=f[o+-28>>2];s=f[o+-24>>2]|0;f[i+-24>>2]=s;f[i+-20>>2]=f[o+-20>>2];f[i+-16>>2]=r;r=i+-8|0;t=i+-12|0;f[t>>2]=r;f[i+-4>>2]=0;f[r>>2]=0;if(s|0){r=s+8|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+-12>>2]|0;o=f[t>>2]|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2]}else{f[p>>2]=0;FQ(h,j)}i=k+-48|0;k=i}while((j|0)!=(g|0));l=k;m=f[a>>2]|0;n=f[e>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=d;d=m;c=n;while(1){n=c;if((n|0)==(d|0))break;b=n+-48|0;GQ(b);c=b}if(!m)return;YDc(m);return}function k$(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;b$(d,a,b);u=c;return f[d+4>>2]|0}function l$(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;b$(d,a,b);u=c;return f[d>>2]|0}function m$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;e=f[b>>2]&2031616;g=f[a>>2]&2031616;a:do if((g|0)<655360){switch(g|0){case 65536:break;default:{h=36;break a}}i=f[a+4>>2]|0;j=e&2097151;b:do if((j|0)<655360){switch(j|0){case 65536:break;default:break b}k=f[i+40>>2]|0;l=f[k+-4>>2]|0;m=f[(f[b+4>>2]|0)+40>>2]|0;if((l|0)!=(f[m+-4>>2]|0)){n=0;break a}if((l|0)==2){if((f[k>>2]|0)!=(f[m>>2]|0)){n=0;break a}n=(f[k+4>>2]|0)==(f[m+4>>2]|0);break a}if((l|0)>0)o=0;else{n=1;break a}while(1){if((f[k+(o<<2)>>2]|0)!=(f[m+(o<<2)>>2]|0)){n=0;break a}o=o+1|0;if((o|0)>=(l|0)){n=1;break a}}}else{switch(j|0){case 655360:break;default:break b}l=f[i+40>>2]|0;m=f[l+-4>>2]|0;k=f[(f[b+4>>2]|0)+32>>2]|0;if((m|0)!=(f[k+-4>>2]|0)){n=0;break a}if((m|0)==2){if((f[l>>2]|0)!=(f[k>>2]|0)){n=0;break a}n=(f[l+4>>2]|0)==(f[k+4>>2]|0);break a}if((m|0)>0)p=0;else{n=1;break a}while(1){if((f[l+(p<<2)>>2]|0)!=(f[k+(p<<2)>>2]|0)){n=0;break a}p=p+1|0;if((p|0)>=(m|0)){n=1;break a}}}while(0);if((f[i+4>>2]|0)>2)n=0;else{j=f[i+40>>2]|0;q=f[j+4>>2]|0;r=f[j>>2]|0;h=37}}else{switch(g|0){case 655360:break;default:{h=36;break a}}j=f[a+4>>2]|0;m=e&2097151;c:do if((m|0)<655360){switch(m|0){case 65536:break;default:break c}k=f[j+32>>2]|0;l=f[k+-4>>2]|0;s=f[(f[b+4>>2]|0)+40>>2]|0;if((l|0)!=(f[s+-4>>2]|0)){n=0;break a}if((l|0)==2){if((f[k>>2]|0)!=(f[s>>2]|0)){n=0;break a}n=(f[k+4>>2]|0)==(f[s+4>>2]|0);break a}if((l|0)>0)t=0;else{n=1;break a}while(1){if((f[k+(t<<2)>>2]|0)!=(f[s+(t<<2)>>2]|0)){n=0;break a}t=t+1|0;if((t|0)>=(l|0)){n=1;break a}}}else{switch(m|0){case 655360:break;default:break c}l=f[j+32>>2]|0;s=f[l+-4>>2]|0;k=f[(f[b+4>>2]|0)+32>>2]|0;if((s|0)!=(f[k+-4>>2]|0)){n=0;break a}if((s|0)==2){if((f[l>>2]|0)!=(f[k>>2]|0)){n=0;break a}n=(f[l+4>>2]|0)==(f[k+4>>2]|0);break a}if((s|0)>0)v=0;else{n=1;break a}while(1){if((f[l+(v<<2)>>2]|0)!=(f[k+(v<<2)>>2]|0)){n=0;break a}v=v+1|0;if((v|0)>=(s|0)){n=1;break a}}}while(0);if((f[j+4>>2]|0)>2)n=0;else{m=f[j+32>>2]|0;q=f[m+4>>2]|0;r=f[m>>2]|0;h=37}}while(0);if((h|0)==36){b$(d,a,-1);q=f[d>>2]|0;r=f[d+4>>2]|0;h=37}if((h|0)==37)if((n$(b,-1)|0)>2)n=0;else{b$(d,b,-1);n=(f[d>>2]|0)==(q|0)?(f[d+4>>2]|0)==(r|0):0}u=c;return n|0}function n$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;do switch((f[a>>2]|0)>>>16&31){case 1:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[221887]|0;b[g+1>>0]=b[221888]|0;b[g+2>>0]=b[221889]|0;b[g+3>>0]=b[221890]|0;b[g+4>>0]=b[221891]|0;z5(-215,e,222306,221901,624)}h=f[(f[a+4>>2]|0)+4>>2]|0;u=d;return h|0}case 6:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[221887]|0;b[g+1>>0]=b[221888]|0;b[g+2>>0]=b[221889]|0;b[g+3>>0]=b[221890]|0;b[g+4>>0]=b[221891]|0;z5(-215,e,222306,221901,630)}h=f[(f[a+4>>2]|0)+12>>2]|0;u=d;return h|0}case 10:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[221887]|0;b[g+1>>0]=b[221888]|0;b[g+2>>0]=b[221889]|0;b[g+3>>0]=b[221890]|0;b[g+4>>0]=b[221891]|0;z5(-215,e,222306,221901,636)}h=f[(f[a+4>>2]|0)+4>>2]|0;u=d;return h|0}case 2:case 14:{if((c|0)<0){h=2;u=d;return h|0}else{f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[221887]|0;b[g+1>>0]=b[221888]|0;b[g+2>>0]=b[221889]|0;b[g+3>>0]=b[221890]|0;b[g+4>>0]=b[221891]|0;z5(-215,e,222306,221901,642)}break}case 3:case 12:{if((c|0)<0){h=2;u=d;return h|0}else{f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[221887]|0;b[g+1>>0]=b[221888]|0;b[g+2>>0]=b[221889]|0;b[g+3>>0]=b[221890]|0;b[g+4>>0]=b[221891]|0;z5(-215,e,222306,221901,648)}break}case 4:{if((c|0)<0){h=1;u=d;return h|0}g=f[a+4>>2]|0;if((((f[g+4>>2]|0)-(f[g>>2]|0)|0)/12|0|0)>(c|0)){h=2;u=d;return h|0}else{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,18)|0;j=222252;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,222306,221901,660)}break}case 5:{g=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}l=f[g>>2]|0;if((((f[g+4>>2]|0)-l|0)/56|0|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,18)|0;j=222252;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,222306,221901,669)}h=f[l+(c*56|0)+4>>2]|0;u=d;return h|0}case 15:{g=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}if((f[a+12>>2]|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,13)|0;j=222271;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,222306,221901,679)}h=f[g+(c*56|0)+4>>2]|0;u=d;return h|0}case 11:{l=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}m=f[l>>2]|0;if((((f[l+4>>2]|0)-m|0)/48|0|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,18)|0;j=222252;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,222306,221901,689)}h=f[m+(c*48|0)+4>>2]|0;u=d;return h|0}case 7:{if((c|0)<0){h=2;u=d;return h|0}else{f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[221887]|0;b[g+1>>0]=b[221888]|0;b[g+2>>0]=b[221889]|0;b[g+3>>0]=b[221890]|0;b[g+4>>0]=b[221891]|0;z5(-215,e,222306,221901,696)}break}case 9:{if((c|0)<0){h=2;u=d;return h|0}else{f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[221887]|0;b[g+1>>0]=b[221888]|0;b[g+2>>0]=b[221889]|0;b[g+3>>0]=b[221890]|0;b[g+4>>0]=b[221891]|0;z5(-215,e,222306,221901,702)}break}case 8:{if((c|0)<0){h=2;u=d;return h|0}else{f[e>>2]=0;f[e+4>>2]=0;g=tT(e,5)|0;b[g>>0]=b[221887]|0;b[g+1>>0]=b[221888]|0;b[g+2>>0]=b[221889]|0;b[g+3>>0]=b[221890]|0;b[g+4>>0]=b[221891]|0;z5(-215,e,222306,221901,708)}break}case 0:{h=0;u=d;return h|0}default:{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,30)|0;j=222195;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-213,e,222306,221901,712)}}while(0);return 0}function o$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d+8|0;g=d;h=f[a>>2]&2031616;a:do if((h|0)>=655360){if((h|0)<720896){switch(h|0){case 655360:break;default:break a}if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,5)|0;b[i>>0]=b[221887]|0;b[i+1>>0]=b[221888]|0;b[i+2>>0]=b[221889]|0;b[i+3>>0]=b[221890]|0;b[i+4>>0]=b[221891]|0;z5(-215,e,452815,221901,727)}i=f[a+4>>2]|0;j=f[i+4>>2]|0;if((j|0)<3){k=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;u=d;return k|0}l=f[i+32>>2]|0;i=0;m=1;while(1){n=Y(f[l+(i<<2)>>2]|0,m)|0;i=i+1|0;if((i|0)==(j|0)){k=n;break}else m=n}u=d;return k|0}if((h|0)<983040){switch(h|0){case 720896:break;default:break a}m=f[a+4>>2]|0;j=f[m>>2]|0;i=((f[m+4>>2]|0)-j|0)/48|0;m=j;if((c|0)<0){k=i;u=d;return k|0}if((i|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,18)|0;p=222252;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,e,452815,221901,757)}i=f[m+(c*48|0)+4>>2]|0;if((i|0)<3){k=Y(f[m+(c*48|0)+12>>2]|0,f[m+(c*48|0)+8>>2]|0)|0;u=d;return k|0}j=f[m+(c*48|0)+32>>2]|0;l=0;n=1;while(1){r=Y(f[j+(l<<2)>>2]|0,n)|0;l=l+1|0;if((l|0)==(i|0)){k=r;break}else n=r}u=d;return k|0}else{switch(h|0){case 983040:break;default:break a}n=f[a+4>>2]|0;i=f[a+12>>2]|0;if((c|0)<0){k=i;u=d;return k|0}if((i|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,13)|0;p=222271;q=o+13|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,e,452815,221901,747)}i=f[n+(c*56|0)+4>>2]|0;if((i|0)<3){k=Y(f[n+(c*56|0)+12>>2]|0,f[n+(c*56|0)+8>>2]|0)|0;u=d;return k|0}l=f[n+(c*56|0)+40>>2]|0;j=0;m=1;while(1){r=Y(f[l+(j<<2)>>2]|0,m)|0;j=j+1|0;if((j|0)==(i|0)){k=r;break}else m=r}u=d;return k|0}}else{if((h|0)<327680){switch(h|0){case 65536:break;default:break a}if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,5)|0;b[m>>0]=b[221887]|0;b[m+1>>0]=b[221888]|0;b[m+2>>0]=b[221889]|0;b[m+3>>0]=b[221890]|0;b[m+4>>0]=b[221891]|0;z5(-215,e,452815,221901,721)}m=f[a+4>>2]|0;i=f[m+4>>2]|0;if((i|0)<3){k=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;u=d;return k|0}j=f[m+40>>2]|0;m=0;l=1;while(1){n=Y(f[j+(m<<2)>>2]|0,l)|0;m=m+1|0;if((m|0)==(i|0)){k=n;break}else l=n}u=d;return k|0}switch(h|0){case 327680:break;default:break a}l=f[a+4>>2]|0;i=f[l>>2]|0;m=((f[l+4>>2]|0)-i|0)/56|0;l=i;if((c|0)<0){k=m;u=d;return k|0}if((m|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,18)|0;p=222252;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,e,452815,221901,737)}m=f[l+(c*56|0)+4>>2]|0;if((m|0)<3){k=Y(f[l+(c*56|0)+12>>2]|0,f[l+(c*56|0)+8>>2]|0)|0;u=d;return k|0}i=f[l+(c*56|0)+40>>2]|0;j=0;n=1;while(1){r=Y(f[i+(j<<2)>>2]|0,n)|0;j=j+1|0;if((j|0)==(m|0)){k=r;break}else n=r}u=d;return k|0}while(0);b$(g,a,c);k=Y(f[g+4>>2]|0,f[g>>2]|0)|0;u=d;return k|0}function p$(a,b){a=a|0;b=b|0;return (c$(a,b)|0)&7|0}function q$(a,b){a=a|0;b=b|0;return ((c$(a,b)|0)>>>3&511)+1|0}function r$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;do switch((f[a>>2]|0)>>>16&31){case 1:{e=f[a+4>>2]|0;if(!(f[e+16>>2]|0)){g=1;u=c;return g|0}h=f[e+4>>2]|0;if((h|0)<3)i=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{j=f[e+40>>2]|0;e=0;k=1;while(1){l=Y(f[j+(e<<2)>>2]|0,k)|0;e=e+1|0;if((e|0)==(h|0)){i=l;break}else k=l}}g=(h|0)==0|(i|0)==0;u=c;return g|0}case 10:{k=f[a+4>>2]|0;if(!(f[k+24>>2]|0)){g=1;u=c;return g|0}e=f[k+4>>2]|0;if((e|0)<3)m=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{j=f[k+32>>2]|0;k=0;l=1;while(1){n=Y(f[j+(k<<2)>>2]|0,l)|0;k=k+1|0;if((k|0)==(e|0)){m=n;break}else l=n}}g=(e|0)==0|(m|0)==0;u=c;return g|0}case 3:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 12:{g=(f[(f[a+4>>2]|0)+4>>2]|0)==0;u=c;return g|0}case 0:{g=1;u=c;return g|0}case 4:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 5:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 15:{g=(f[a+12>>2]|0)==0;u=c;return g|0}case 11:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 7:{l=f[a+4>>2]|0;if(!(f[l+8>>2]|0)){g=1;u=c;return g|0}g=(f[l+12>>2]|0)==0;u=c;return g|0}case 9:{g=(f[(f[a+4>>2]|0)+16>>2]|0)==0;u=c;return g|0}case 13:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 8:{g=(f[(f[a+4>>2]|0)+16>>2]|0)==0;u=c;return g|0}case 2:case 14:case 6:{g=0;u=c;return g|0}default:{f[d>>2]=0;f[d+4>>2]=0;l=tT(d,30)|0;k=222195;j=l+30|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(j|0));z5(-213,d,222311,221901,922)}}while(0);return 0}function s$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;switch((f[a>>2]|0)>>>16&31){case 1:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 10:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 5:{h=f[a+4>>2]|0;if((c|0)<=-1){f[e>>2]=0;i=e+4|0;f[i>>2]=0;j=tT(e,31)|0;k=j;l=222317;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,222349,221901,942)}n=f[h>>2]|0;if((((f[h+4>>2]|0)-n|0)/56|0)>>>0<=c>>>0){f[e>>2]=0;i=e+4|0;f[i>>2]=0;j=tT(e,31)|0;k=j;l=222317;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,222349,221901,942)}g=(f[n+(c*56|0)>>2]&16384|0)!=0;u=d;return g|0}case 15:{n=f[a+4>>2]|0;if((c|0)<=0){f[e>>2]=0;o=e+4|0;f[o>>2]=0;p=tT(e,22)|0;k=p;l=222362;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,222349,221901,949)}if((f[a+12>>2]|0)<=(c|0)){f[e>>2]=0;o=e+4|0;f[o>>2]=0;p=tT(e,22)|0;k=p;l=222362;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,222349,221901,949)}g=(f[n+(c*56|0)>>2]&16384|0)!=0;u=d;return g|0}case 11:{n=f[a+4>>2]|0;if((c|0)<=-1){f[e>>2]=0;q=e+4|0;f[q>>2]=0;r=tT(e,31)|0;k=r;l=222317;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,222349,221901,956)}p=f[n>>2]|0;if((((f[n+4>>2]|0)-p|0)/48|0)>>>0<=c>>>0){f[e>>2]=0;q=e+4|0;f[q>>2]=0;r=tT(e,31)|0;k=r;l=222317;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,222349,221901,956)}g=(f[p+(c*48|0)>>2]&16384|0)!=0;u=d;return g|0}case 9:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 0:case 2:case 3:case 4:case 6:case 12:case 14:{g=1;u=d;return g|0}default:{f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=222195;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-213,e,222349,221901,963)}}return 0}function t$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+112|0;d=c+56|0;e=c;g=f[a>>2]|0;switch(g>>>16&31){case 0:{u$(b);u=c;return}case 1:case 2:case 3:case 12:case 14:{do if((g&2031616|0)==65536){h=f[a+4>>2]|0;f[d>>2]=f[h>>2];i=d+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=d+8|0;f[k>>2]=f[h+8>>2];f[d+12>>2]=f[h+12>>2];f[d+16>>2]=f[h+16>>2];f[d+20>>2]=f[h+20>>2];f[d+24>>2]=f[h+24>>2];f[d+28>>2]=f[h+28>>2];f[d+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[d+36>>2]=l;f[d+40>>2]=k;k=d+48|0;m=d+44|0;f[m>>2]=k;f[k>>2]=0;f[d+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;ZS(d,h);break}}else a$(d,a,-1);while(0);h_(d,b);g=d+36|0;h=f[g>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)_S(d);f[g>>2]=0;g=d+16|0;h=d+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[d+40>>2]|0;i=0;do{f[g+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}h=f[d+44>>2]|0;if((h|0)!=(d+48|0))g0(h);u=c;return}case 6:{h=f[a+4>>2]|0;if((f[b>>2]&2031616|0)==65536){i=f[h>>2]|0;ei[f[(f[i>>2]|0)+12>>2]&511](i,h,f[b+4>>2]|0,-1);u=c;return}f[e>>2]=1124007936;i=e+4|0;g=e+8|0;j=e+40|0;k=i;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[j>>2]=g;g=e+48|0;k=e+44|0;f[k>>2]=g;f[g>>2]=0;f[e+52>>2]=0;m=f[h>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,h,e,-1);h_(e,b);h=e+36|0;m=f[h>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)_S(e);f[h>>2]=0;h=e+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[j>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[k>>2]|0;if((i|0)==(g|0)){u=c;return}g0(i);u=c;return}case 10:{NQ(f[a+4>>2]|0,b);u=c;return}default:{f[d>>2]=0;f[d+4>>2]=0;z5(-213,d,222385,221901,1154)}}}function u$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c+8|0;e=c;g=f[a>>2]|0;if(g&1073741824|0){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,12)|0;i=222392;j=h+12|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-215,d,222405,221901,1668)}do switch(g>>>16&31){case 1:{k=f[a+4>>2]|0;l=k+36|0;m=f[l>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)_S(k);f[l>>2]=0;l=k+16|0;m=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)<=0){u=c;return}l=f[k+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[m>>2]|0));u=c;return}case 10:{m=f[a+4>>2]|0;k=m+24|0;l=f[k>>2]|0;if(l|0?(n=l+8|0,l=f[n>>2]|0,f[n>>2]=l+-1,(l|0)==1):0)HQ(m);l=m+4|0;if((f[l>>2]|0)>0){n=f[m+32>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}f[k>>2]=0;u=c;return}case 9:{u=c;return}case 8:{u=c;return}case 7:{u3(f[a+4>>2]|0);u=c;return}case 3:{f[e>>2]=0;f[e+4>>2]=0;v$(a,e,g&4095,-1,0,0);u=c;return}case 4:{l=f[a+4>>2]|0;m=f[l>>2]|0;n=l+4|0;l=f[n>>2]|0;if((l|0)==(m|0)){u=c;return}else o=l;while(1){l=o+-12|0;f[n>>2]=l;p=f[l>>2]|0;if(!p)q=l;else{l=o+-8|0;if((f[l>>2]|0)!=(p|0))f[l>>2]=p;YDc(p);q=f[n>>2]|0}if((q|0)==(m|0))break;else o=q}u=c;return}case 5:{m=f[a+4>>2]|0;n=f[m>>2]|0;k=m+4|0;m=f[k>>2]|0;if((m|0)==(n|0)){u=c;return}else r=m;do{m=r+-56|0;f[k>>2]=m;p=r+-20|0;l=f[p>>2]|0;if(l|0?(s=l+12|0,l=f[s>>2]|0,f[s>>2]=l+-1,(l|0)==1):0)_S(m);f[p>>2]=0;p=r+-40|0;m=r+-52|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[r+-16>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[r+-12>>2]|0;if((m|0)!=(r+-8|0))g0(m);r=f[k>>2]|0}while((r|0)!=(n|0));u=c;return}case 11:{n=f[a+4>>2]|0;k=f[n>>2]|0;m=n+4|0;while(1){n=f[m>>2]|0;if((n|0)==(k|0))break;l=n+-48|0;f[m>>2]=l;GQ(l)}u=c;return}case 13:{m=f[a+4>>2]|0;k=f[m>>2]|0;l=m+4|0;while(1){m=f[l>>2]|0;if((m|0)==(k|0))break;f[l>>2]=m+-36}u=c;return}case 0:{u=c;return}default:{f[d>>2]=0;f[d+4>>2]=0;h=tT(d,30)|0;i=222195;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-213,d,222405,221901,1733)}}while(0)}function v$(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;l=k&2031616;m=(e|0)<0;do if(m&(l|0)==65536){if((h|0)==0&(g^1)){if(k&1073741824|0?(n=f[(f[a+4>>2]|0)+40>>2]|0,!((f[c>>2]|0)==(f[n+4>>2]|0)?(f[c+4>>2]|0)==(f[n>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,53)|0;p=222413;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1193)}n=f[a+4>>2]|0;if((k|0)<0?(f[n>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,44)|0;p=222467;q=o+44|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1194)}r=f[c>>2]|0;s=f[c+4>>2]|0;t=d&4095;if(((((f[n+4>>2]|0)<3?(f[n+8>>2]|0)==(s|0):0)?(f[n+12>>2]|0)==(r|0):0)?(f[n>>2]&4095|0)==(t|0):0)?f[n+16>>2]|0:0){u=i;return}f[j>>2]=s;f[j+4>>2]=r;XS(n,2,j,t);u=i;return}}else{if(m&(l|0)==655360){if(!((h|0)==0&(g^1)))break;if(k&1073741824|0?(t=f[(f[a+4>>2]|0)+32>>2]|0,!((f[c>>2]|0)==(f[t+4>>2]|0)?(f[c+4>>2]|0)==(f[t>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,54)|0;p=222512;q=o+54|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1200)}n=f[a+4>>2]|0;if((k|0)<0?(f[n>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,45)|0;p=222567;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1201)}t=f[c>>2]|0;r=f[c+4>>2]|0;s=d&4095;if(((((f[n+4>>2]|0)<3?(f[n+8>>2]|0)==(r|0):0)?(f[n+12>>2]|0)==(t|0):0)?(f[n>>2]&4095|0)==(s|0):0)?f[n+24>>2]|0:0){u=i;return}f[j>>2]=r;f[j+4>>2]=t;DQ(n,2,j,s,0);u=i;return}if(m&(l|0)==589824){if(!((h|0)==0&(g^1)))break;if(k&1073741824|0?(s=f[a+4>>2]|0,!((f[c>>2]|0)==(f[s+8>>2]|0)?(f[c+4>>2]|0)==(f[s+4>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,51)|0;p=222613;q=o+51|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1207)}n=f[a+4>>2]|0;if((k|0)>=0){v=f[c>>2]|0;w=c+4|0;x=f[w>>2]|0;T7(n,x,v,d)}if((f[n>>2]&4095|0)==(d|0)){v=f[c>>2]|0;w=c+4|0;x=f[w>>2]|0;T7(n,x,v,d)}else{f[j>>2]=0;f[j+4>>2]=0;o=tT(j,53)|0;p=222665;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1208)}}if(m&(l|0)==458752){if(!((h|0)==0&(g^1)))break;if(k&1073741824|0?(n=f[a+4>>2]|0,!((f[c>>2]|0)==(f[n+12>>2]|0)?(f[c+4>>2]|0)==(f[n+8>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,50)|0;p=222719;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1214)}n=f[a+4>>2]|0;if((k|0)<0?(f[n+16>>2]|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,52)|0;p=222770;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1215)}t3(n,f[c+4>>2]|0,f[c>>2]|0,d,34962,0);u=i;return}if(m&(l|0)==524288?(h|0)==0&(g^1):0){if(k&1073741824|0?(s=f[a+4>>2]|0,!((f[c>>2]|0)==(f[s+8>>2]|0)?(f[c+4>>2]|0)==(f[s+4>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,52)|0;p=222823;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1221)}n=f[a+4>>2]|0;if((k|0)>=0){y=f[c>>2]|0;z=c+4|0;A=f[z>>2]|0;a7(n,A,y,d)}if((f[n>>2]&4095|0)==(d|0)){y=f[c>>2]|0;z=c+4|0;A=f[z>>2]|0;a7(n,A,y,d)}else{f[j>>2]=0;f[j+4>>2]=0;o=tT(j,54)|0;p=222876;q=o+54|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,464481,221901,1222)}}}while(0);f[j>>2]=f[c+4>>2];f[j+4>>2]=f[c>>2];w$(a,2,j,d,e,g,h);u=i;return}function w$(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+32|0;k=j;l=j+16|0;m=j+8|0;if((c|0)==1){f[l>>2]=f[d>>2];f[l+4>>2]=1;n=2;o=l}else{n=c;o=d}d=f[a>>2]|0;c=d&2031616;l=e&4095;p=c&2097151;a:do if((p|0)<655360){if((p|0)>=131072){switch(p|0){case 131072:break;default:break a}if((g|0)>=0){f[m>>2]=0;f[m+4>>2]=0;q=tT(m,5)|0;b[q>>0]=b[221887]|0;b[q+1>>0]=b[221888]|0;b[q+2>>0]=b[221889]|0;b[q+3>>0]=b[221890]|0;b[q+4>>0]=b[221891]|0;z5(-215,m,464481,221901,1356)}q=d&4095;if((l|0)!=(q|0)){if(e&4088|0){f[m>>2]=0;r=m+4|0;f[r>>2]=0;s=tT(m,81)|0;t=s;v=223025;w=t+81|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1358)}if(!(1<<q&i)){f[m>>2]=0;r=m+4|0;f[r>>2]=0;s=tT(m,81)|0;t=s;v=223025;w=t+81|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1358)}}if((n|0)!=2){f[m>>2]=0;x=m+4|0;f[x>>2]=0;y=tT(m,129)|0;dJc(y|0,223107,129)|0;z5(-215,m,464481,221901,1360)}q=f[o>>2]|0;z=a+8|0;A=f[a+12>>2]|0;if((q|0)==(A|0)?(f[o+4>>2]|0)==(f[z>>2]|0):0){u=j;return}if(!h){f[m>>2]=0;x=m+4|0;f[x>>2]=0;y=tT(m,129)|0;dJc(y|0,223107,129)|0;z5(-215,m,464481,221901,1360)}if((q|0)!=(f[z>>2]|0)){f[m>>2]=0;x=m+4|0;f[x>>2]=0;y=tT(m,129)|0;dJc(y|0,223107,129)|0;z5(-215,m,464481,221901,1360)}if((f[o+4>>2]|0)==(A|0)){u=j;return}else{f[m>>2]=0;x=m+4|0;f[x>>2]=0;y=tT(m,129)|0;dJc(y|0,223107,129)|0;z5(-215,m,464481,221901,1360)}}switch(p|0){case 65536:break;default:break a}if((g|0)>=0){f[m>>2]=0;f[m+4>>2]=0;A=tT(m,5)|0;b[A>>0]=b[221887]|0;b[A+1>>0]=b[221888]|0;b[A+2>>0]=b[221889]|0;b[A+3>>0]=b[221890]|0;b[A+4>>0]=b[221891]|0;z5(-215,m,464481,221901,1288)}A=f[a+4>>2]|0;if(h){if(!(f[A>>2]&16384)){if(d>>>0>1073741823){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,28)|0;v=222931;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1294)}z=A+36|0;q=f[z>>2]|0;if(q|0?(B=q+12|0,q=f[B>>2]|0,f[B>>2]=q+-1,(q|0)==1):0)_S(A);f[z>>2]=0;z=A+16|0;q=A+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[q>>2]|0)>0){z=f[A+40>>2]|0;B=0;do{f[z+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[q>>2]|0))}}if((((((n|0)==2?(f[A+4>>2]|0)==2:0)?f[A+16>>2]|0:0)?(f[A>>2]&4095|0)==(l|0):0)?(f[A+8>>2]|0)==(f[o+4>>2]|0):0)?(f[A+12>>2]|0)==(f[o>>2]|0):0){u=j;return}}q=f[a>>2]|0;do if((q|0)<0){B=f[A>>2]|0;if(((B^e)&4088|0)==0?1<<(q&4095)&i|0:0){C=B&4095;break}if((l|0)!=(B&4095|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,30)|0;v=222960;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1308)}else C=l}else C=l;while(0);b:do if(q&1073741824|0){if((f[A+4>>2]|0)!=(n|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,11)|0;v=222991;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1312)}if((n|0)>0){B=f[A+40>>2]|0;z=0;while(1){if((f[B+(z<<2)>>2]|0)!=(f[o+(z<<2)>>2]|0))break;z=z+1|0;if((z|0)>=(n|0))break b}f[m>>2]=0;f[m+4>>2]=0;t=tT(m,21)|0;v=223003;w=t+21|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1314)}}while(0);XS(A,n,o,C);u=j;return}else{if((p|0)>=917504){switch(p|0){case 917504:break;default:break a}q=d&4095;if((l|0)!=(q|0)){if(e&4088|0){f[m>>2]=0;D=m+4|0;f[D>>2]=0;E=tT(m,81)|0;t=E;v=223025;w=t+81|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1367)}if(!(1<<q&i)){f[m>>2]=0;D=m+4|0;f[D>>2]=0;E=tT(m,81)|0;t=E;v=223025;w=t+81|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1367)}}if((n|0)!=2){f[m>>2]=0;F=m+4|0;f[F>>2]=0;G=tT(m,40)|0;t=G;v=223237;w=t+40|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1368)}q=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;if((q|0)==(Y(f[o+4>>2]|0,f[o>>2]|0)|0)){u=j;return}else{f[m>>2]=0;F=m+4|0;f[F>>2]=0;G=tT(m,40)|0;t=G;v=223237;w=t+40|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1368)}}switch(p|0){case 655360:break;default:break a}if((g|0)>=0){f[m>>2]=0;f[m+4>>2]=0;q=tT(m,5)|0;b[q>>0]=b[221887]|0;b[q+1>>0]=b[221888]|0;b[q+2>>0]=b[221889]|0;b[q+3>>0]=b[221890]|0;b[q+4>>0]=b[221891]|0;z5(-215,m,464481,221901,1322)}q=f[a+4>>2]|0;if(h){if(!(f[q>>2]&16384)){if(d>>>0>1073741823){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,28)|0;v=222931;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1328)}A=q+24|0;z=f[A>>2]|0;if(z|0?(B=z+8|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)HQ(q);z=q+4|0;if((f[z>>2]|0)>0){B=f[q+32>>2]|0;H=0;do{f[B+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[z>>2]|0))}f[A>>2]=0}if(((((((n|0)==2?(f[q+4>>2]|0)==2:0)?f[q+24>>2]|0:0)?(z=f[q+8>>2]|0,H=f[q+12>>2]|0,Y(H,z)|0):0)?(f[q>>2]&4095|0)==(l|0):0)?(z|0)==(f[o+4>>2]|0):0)?(H|0)==(f[o>>2]|0):0){u=j;return}}H=f[a>>2]|0;do if((H|0)<0){z=f[q>>2]|0;if(((z^e)&4088|0)==0?1<<(H&4095)&i|0:0){I=z&4095;break}if((l|0)!=(z&4095|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,30)|0;v=222960;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1342)}else I=l}else I=l;while(0);c:do if(H&1073741824|0){if((f[q+4>>2]|0)!=(n|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,11)|0;v=222991;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1346)}if((n|0)>0){A=f[q+32>>2]|0;z=0;while(1){if((f[A+(z<<2)>>2]|0)!=(f[o+(z<<2)>>2]|0))break;z=z+1|0;if((z|0)>=(n|0))break c}f[m>>2]=0;f[m+4>>2]=0;t=tT(m,21)|0;v=223003;w=t+21|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1348)}}while(0);DQ(q,n,o,I,0);u=j;return}while(0);I=(c|0)==262144;p=c&2097151;if((p|0)>=327680){if((p|0)<720896){switch(p|0){case 327680:break;default:{f[m>>2]=0;J=m+4|0;f[J>>2]=0;K=tT(m,30)|0;t=K;v=222195;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-213,m,464481,221901,1657)}}c=f[a+4>>2]|0;if((g|0)<0){if((n|0)!=2){f[m>>2]=0;L=m+4|0;f[L>>2]=0;M=tT(m,68)|0;t=M;v=223278;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1486)}G=f[o>>2]|0;F=f[o+4>>2]|0;E=Y(F,G)|0;if(!((G|0)==1|(F|0)==1|(E|0)==0)){f[m>>2]=0;L=m+4|0;f[L>>2]=0;M=tT(m,68)|0;t=M;v=223278;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1486)}M=(E|0)>0?G+-1+F|0:0;F=((f[c+4>>2]|0)-(f[c>>2]|0)|0)/56|0;if(!((d&1073741824|0)==0|(M|0)==(F|0))){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,27)|0;v=223670;w=t+27|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1489)}g$(c,M);G=f[a>>2]|0;if((G|0)>=0){u=j;return}E=G&4095;if(F>>>0>=M>>>0){u=j;return}G=f[c>>2]|0;L=F;while(1){F=G+(L*56|0)|0;D=f[F>>2]|0;if((D&4095|0)!=(E|0)){if(f[G+(L*56|0)+16>>2]|0){C=f[G+(L*56|0)+4>>2]|0;if((C|0)<3)N=Y(f[G+(L*56|0)+12>>2]|0,f[G+(L*56|0)+8>>2]|0)|0;else{y=f[G+(L*56|0)+40>>2]|0;x=0;s=1;while(1){r=Y(f[y+(x<<2)>>2]|0,s)|0;x=x+1|0;if((x|0)==(C|0)){N=r;break}else s=r}}if(!((C|0)==0|(N|0)==0)){O=256;break}}f[F>>2]=D&-4096|E}L=L+1|0;if(L>>>0>=M>>>0){O=390;break}}if((O|0)==256){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,12)|0;v=223698;w=t+12|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1498)}else if((O|0)==390){u=j;return}}M=f[c>>2]|0;L=M;if((((f[c+4>>2]|0)-M|0)/56|0|0)<=(g|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,17)|0;v=223711;w=t+17|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1505)}M=L+(g*56|0)|0;if(h){if(!(f[M>>2]&16384)){if(d>>>0>1073741823){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,28)|0;v=222931;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1512)}c=L+(g*56|0)+36|0;E=f[c>>2]|0;if(E|0?(N=E+12|0,E=f[N>>2]|0,f[N>>2]=E+-1,(E|0)==1):0)_S(M);f[c>>2]=0;c=L+(g*56|0)+16|0;E=L+(g*56|0)+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[E>>2]|0)>0){c=f[L+(g*56|0)+40>>2]|0;N=0;do{f[c+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[E>>2]|0))}}if((((((n|0)==2?(f[L+(g*56|0)+4>>2]|0)==2:0)?f[L+(g*56|0)+16>>2]|0:0)?(f[M>>2]&4095|0)==(l|0):0)?(f[L+(g*56|0)+8>>2]|0)==(f[o+4>>2]|0):0)?(f[L+(g*56|0)+12>>2]|0)==(f[o>>2]|0):0){u=j;return}}E=f[a>>2]|0;do if((E|0)<0){N=f[M>>2]|0;if(((N^e)&4088|0)==0?1<<(E&4095)&i|0:0){P=N&4095;break}if((l|0)!=(N&4095|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,30)|0;v=222960;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1526)}else P=l}else P=l;while(0);d:do if(E&1073741824|0){if((f[L+(g*56|0)+4>>2]|0)!=(n|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,11)|0;v=222991;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1530)}if((n|0)>0){D=f[L+(g*56|0)+40>>2]|0;F=0;while(1){if((f[D+(F<<2)>>2]|0)!=(f[o+(F<<2)>>2]|0))break;F=F+1|0;if((F|0)>=(n|0))break d}f[m>>2]=0;f[m+4>>2]=0;t=tT(m,21)|0;v=223003;w=t+21|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1532)}}while(0);XS(M,n,o,P);u=j;return}if((p|0)>=983040){switch(p|0){case 983040:break;default:{f[m>>2]=0;J=m+4|0;f[J>>2]=0;K=tT(m,30)|0;t=K;v=222195;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-213,m,464481,221901,1657)}}P=f[a+4>>2]|0;if((g|0)<0){if((n|0)!=2){f[m>>2]=0;Q=m+4|0;f[Q>>2]=0;R=tT(m,68)|0;t=R;v=223278;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1545)}M=f[o>>2]|0;L=f[o+4>>2]|0;E=Y(L,M)|0;if(!((M|0)==1|(L|0)==1|(E|0)==0)){f[m>>2]=0;Q=m+4|0;f[Q>>2]=0;R=tT(m,68)|0;t=R;v=223278;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1545)}if((((E|0)>0?M+-1+L|0:0)|0)==(f[a+12>>2]|0)){u=j;return}else{f[m>>2]=0;f[m+4>>2]=0;t=tT(m,11)|0;v=223729;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1548)}}if((f[a+12>>2]|0)<=(g|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,13)|0;v=222271;w=t+13|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1563)}L=P+(g*56|0)|0;if(h){if(!(f[L>>2]&16384)){if(d>>>0>1073741823){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,28)|0;v=222931;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1570)}M=P+(g*56|0)+36|0;E=f[M>>2]|0;if(E|0?(R=E+12|0,E=f[R>>2]|0,f[R>>2]=E+-1,(E|0)==1):0)_S(L);f[M>>2]=0;M=P+(g*56|0)+16|0;E=P+(g*56|0)+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[E>>2]|0)>0){M=f[P+(g*56|0)+40>>2]|0;R=0;do{f[M+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[E>>2]|0))}}if((((((n|0)==2?(f[P+(g*56|0)+4>>2]|0)==2:0)?f[P+(g*56|0)+16>>2]|0:0)?(f[L>>2]&4095|0)==(l|0):0)?(f[P+(g*56|0)+8>>2]|0)==(f[o+4>>2]|0):0)?(f[P+(g*56|0)+12>>2]|0)==(f[o>>2]|0):0){u=j;return}}E=f[a>>2]|0;do if((E|0)<0){R=f[L>>2]|0;if(((R^e)&4088|0)==0?1<<(E&4095)&i|0:0){S=R&4095;break}if((l|0)!=(R&4095|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,30)|0;v=222960;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1584)}else S=l}else S=l;while(0);e:do if(E&1073741824|0){if((f[P+(g*56|0)+4>>2]|0)!=(n|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,11)|0;v=222991;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1589)}if((n|0)>0){R=f[P+(g*56|0)+40>>2]|0;M=0;while(1){if((f[R+(M<<2)>>2]|0)!=(f[o+(M<<2)>>2]|0))break;M=M+1|0;if((M|0)>=(n|0))break e}f[m>>2]=0;f[m+4>>2]=0;t=tT(m,21)|0;v=223003;w=t+21|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1591)}}while(0);XS(L,n,o,S);u=j;return}switch(p|0){case 720896:break;default:{f[m>>2]=0;J=m+4|0;f[J>>2]=0;K=tT(m,30)|0;t=K;v=222195;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-213,m,464481,221901,1657)}}S=f[a+4>>2]|0;if((g|0)<0){if((n|0)!=2){f[m>>2]=0;T=m+4|0;f[T>>2]=0;U=tT(m,68)|0;t=U;v=223278;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1604)}L=f[o>>2]|0;P=f[o+4>>2]|0;E=Y(P,L)|0;if(!((L|0)==1|(P|0)==1|(E|0)==0)){f[m>>2]=0;T=m+4|0;f[T>>2]=0;U=tT(m,68)|0;t=U;v=223278;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1604)}U=(E|0)>0?L+-1+P|0:0;P=S+4|0;L=f[P>>2]|0;E=f[S>>2]|0;T=(L-E|0)/48|0;if(!((d&1073741824|0)==0|(U|0)==(T|0))){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,27)|0;v=223670;w=t+27|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1607)}M=U>>>0>T>>>0;R=E;E=L;if(!M){if(U>>>0<T>>>0?(L=R+(U*48|0)|0,(E|0)!=(L|0)):0){R=E;do{E=R+-48|0;f[P>>2]=E;GQ(E);R=f[P>>2]|0}while((R|0)!=(L|0))}}else j$(S,U-T|0);L=f[a>>2]|0;if((L|0)>=0){u=j;return}R=L&4095;if(!M){u=j;return}M=f[S>>2]|0;L=T;while(1){T=M+(L*48|0)|0;P=f[T>>2]|0;if((P&4095|0)!=(R|0)){if(f[M+(L*48|0)+24>>2]|0){E=f[M+(L*48|0)+4>>2]|0;if((E|0)<3)V=Y(f[M+(L*48|0)+12>>2]|0,f[M+(L*48|0)+8>>2]|0)|0;else{Q=f[M+(L*48|0)+32>>2]|0;F=0;D=1;while(1){C=Y(f[Q+(F<<2)>>2]|0,D)|0;F=F+1|0;if((F|0)==(E|0)){V=C;break}else D=C}}if(!((E|0)==0|(V|0)==0)){O=352;break}}f[T>>2]=P&-4096|R}L=L+1|0;if(L>>>0>=U>>>0){O=390;break}}if((O|0)==352){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,12)|0;v=223698;w=t+12|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1616)}else if((O|0)==390){u=j;return}}O=f[S>>2]|0;U=O;if((((f[S+4>>2]|0)-O|0)/48|0|0)<=(g|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,17)|0;v=223711;w=t+17|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1623)}O=U+(g*48|0)|0;if(h){if(!(f[O>>2]&16384)){if(d>>>0>1073741823){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,28)|0;v=222931;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1630)}h=U+(g*48|0)+24|0;S=f[h>>2]|0;if(S|0?(L=S+8|0,S=f[L>>2]|0,f[L>>2]=S+-1,(S|0)==1):0)HQ(O);S=U+(g*48|0)+4|0;if((f[S>>2]|0)>0){L=f[U+(g*48|0)+32>>2]|0;R=0;do{f[L+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[S>>2]|0))}f[h>>2]=0}if((((((n|0)==2?(f[U+(g*48|0)+4>>2]|0)==2:0)?f[U+(g*48|0)+24>>2]|0:0)?(f[O>>2]&4095|0)==(l|0):0)?(f[U+(g*48|0)+8>>2]|0)==(f[o+4>>2]|0):0)?(f[U+(g*48|0)+12>>2]|0)==(f[o>>2]|0):0){u=j;return}}h=f[a>>2]|0;do if((h|0)<0){S=f[O>>2]|0;if(((S^e)&4088|0)==0?1<<(h&4095)&i|0:0){W=S&4095;break}if((l|0)!=(S&4095|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,30)|0;v=222960;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1644)}else W=l}else W=l;while(0);f:do if(h&1073741824|0){if((f[U+(g*48|0)+4>>2]|0)!=(n|0)){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,11)|0;v=222991;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1648)}if((n|0)>0){P=f[U+(g*48|0)+32>>2]|0;T=0;while(1){if((f[P+(T<<2)>>2]|0)!=(f[o+(T<<2)>>2]|0))break;T=T+1|0;if((T|0)>=(n|0))break f}f[m>>2]=0;f[m+4>>2]=0;t=tT(m,21)|0;v=223003;w=t+21|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1650)}}while(0);DQ(O,n,o,W,0);u=j;return}if((p|0)<196608)switch(p|0){case 0:{f[m>>2]=0;f[m+4>>2]=0;t=tT(m,44)|0;v=223625;w=t+44|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-27,m,464481,221901,1477);break}default:{f[m>>2]=0;J=m+4|0;f[J>>2]=0;K=tT(m,30)|0;t=K;v=222195;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-213,m,464481,221901,1657)}}g:do if((p|0)<262144){switch(p|0){case 196608:{break g;break}default:{}}f[m>>2]=0;J=m+4|0;f[J>>2]=0;K=tT(m,30)|0;t=K;v=222195;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-213,m,464481,221901,1657)}else{switch(p|0){case 262144:{break g;break}default:{}}f[m>>2]=0;J=m+4|0;f[J>>2]=0;K=tT(m,30)|0;t=K;v=222195;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-213,m,464481,221901,1657)}while(0);if((n|0)!=2){f[m>>2]=0;X=m+4|0;f[X>>2]=0;Z=tT(m,68)|0;t=Z;v=223278;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1374)}n=f[o>>2]|0;K=f[o+4>>2]|0;o=Y(K,n)|0;if(!((n|0)==1|(K|0)==1|(o|0)==0)){f[m>>2]=0;X=m+4|0;f[X>>2]=0;Z=tT(m,68)|0;t=Z;v=223278;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1374)}Z=(o|0)>0?n+-1+K|0:0;K=f[a+4>>2]|0;a=(g|0)<0;do if(!I)if(a)_=K;else{f[m>>2]=0;f[m+4>>2]=0;n=tT(m,5)|0;b[n>>0]=b[221887]|0;b[n+1>>0]=b[221888]|0;b[n+2>>0]=b[221889]|0;b[n+3>>0]=b[221890]|0;b[n+4>>0]=b[221891]|0;z5(-215,m,464481,221901,1391)}else{if(!a){n=f[K>>2]|0;if((((f[K+4>>2]|0)-n|0)/12|0|0)>(g|0)){_=n+(g*12|0)|0;break}else{f[m>>2]=0;f[m+4>>2]=0;t=tT(m,18)|0;v=222252;w=t+18|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1387)}}n=K+4|0;o=f[n>>2]|0;X=f[K>>2]|0;if(d&1073741824|0?(Z|0)!=((o-X|0)/12|0|0):0){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,32)|0;v=223347;w=t+32|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1383)}J=(o-X|0)/12|0;p=o;if(Z>>>0>J>>>0){x$(K,Z-J|0);u=j;return}if(Z>>>0>=J>>>0){u=j;return}J=X+(Z*12|0)|0;if((p|0)==(J|0)){u=j;return}else $=p;while(1){p=$+-12|0;f[n>>2]=p;W=f[p>>2]|0;if(!W)aa=p;else{p=$+-8|0;if((f[p>>2]|0)!=(W|0))f[p>>2]=W;YDc(W);aa=f[n>>2]|0}if((aa|0)==(J|0))break;else $=aa}u=j;return}while(0);aa=d&4095;$=d>>>3&511;K=$+1|0;if((l|0)!=(aa|0)){if((e>>>3&511|0)!=($|0)){f[m>>2]=0;ba=m+4|0;f[ba>>2]=0;ca=tT(m,96)|0;t=ca;v=223380;w=t+96|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1394)}if(!(1<<aa&i)){f[m>>2]=0;ba=m+4|0;f[ba>>2]=0;ca=tT(m,96)|0;t=ca;v=223380;w=t+96|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1394)}}ca=K<<(47696>>>(d<<1&14)&3);if(d&1073741824|0?(Z|0)!=((((f[_+4>>2]|0)-(f[_>>2]|0)|0)>>>0)/(ca>>>0)|0|0):0){f[m>>2]=0;f[m+4>>2]=0;t=tT(m,61)|0;v=223477;w=t+61|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,m,464481,221901,1397)}do switch(ca&8191){case 1:{v=_+4|0;t=f[v>>2]|0;w=f[_>>2]|0;d=t-w|0;if(Z>>>0>d>>>0){y$(_,Z-d|0);u=j;return}if(Z>>>0>=d>>>0){u=j;return}d=w+Z|0;if((t|0)==(d|0)){u=j;return}f[v>>2]=d;u=j;return}case 2:{d=_+4|0;v=f[d>>2]|0;t=f[_>>2]|0;w=v-t>>1;K=v;if(Z>>>0>w>>>0){z$(_,Z-w|0);u=j;return}if(Z>>>0>=w>>>0){u=j;return}w=t+(Z<<1)|0;if((K|0)==(w|0)){u=j;return}f[d>>2]=K+(~((0-w+(K+-2)|0)>>>1)<<1);u=j;return}case 3:{K=_+4|0;w=f[K>>2]|0;d=f[_>>2]|0;t=(w-d|0)/3|0;v=w;if(Z>>>0>t>>>0){A$(_,Z-t|0);u=j;return}if(Z>>>0>=t>>>0){u=j;return}t=d+(Z*3|0)|0;if((v|0)==(t|0)){u=j;return}f[K>>2]=v+(~(((0-t+(v+-3)|0)>>>0)/3|0)*3|0);u=j;return}case 4:{v=_+4|0;t=f[v>>2]|0;K=f[_>>2]|0;d=t-K>>2;w=t;if(Z>>>0>d>>>0){lN(_,Z-d|0);u=j;return}if(Z>>>0>=d>>>0){u=j;return}d=K+(Z<<2)|0;if((w|0)==(d|0)){u=j;return}f[v>>2]=w+(~((w+-4-d|0)>>>2)<<2);u=j;return}case 6:{d=_+4|0;w=f[d>>2]|0;v=f[_>>2]|0;K=(w-v|0)/6|0;t=w;if(Z>>>0>K>>>0){B$(_,Z-K|0);u=j;return}if(Z>>>0>=K>>>0){u=j;return}K=v+(Z*6|0)|0;if((t|0)==(K|0)){u=j;return}f[d>>2]=t+(~(((t+-6-K|0)>>>0)/6|0)*6|0);u=j;return}case 8:{K=_+4|0;t=f[K>>2]|0;d=f[_>>2]|0;v=t-d>>3;w=t;if(Z>>>0>v>>>0){C$(_,Z-v|0);u=j;return}if(Z>>>0>=v>>>0){u=j;return}v=d+(Z<<3)|0;if((w|0)==(v|0)){u=j;return}f[K>>2]=w+(~((w+-8-v|0)>>>3)<<3);u=j;return}case 12:{v=_+4|0;w=f[v>>2]|0;K=f[_>>2]|0;d=(w-K|0)/12|0;t=w;if(Z>>>0>d>>>0){D$(_,Z-d|0);u=j;return}if(Z>>>0>=d>>>0){u=j;return}d=K+(Z*12|0)|0;if((t|0)==(d|0)){u=j;return}f[v>>2]=t+(~(((t+-12-d|0)>>>0)/12|0)*12|0);u=j;return}case 16:{d=_+4|0;t=f[d>>2]|0;v=f[_>>2]|0;K=t-v>>4;w=t;if(Z>>>0>K>>>0){E$(_,Z-K|0);u=j;return}if(Z>>>0>=K>>>0){u=j;return}K=v+(Z<<4)|0;if((w|0)==(K|0)){u=j;return}f[d>>2]=w+(~((w+-16-K|0)>>>4)<<4);u=j;return}case 20:{K=_+4|0;w=f[K>>2]|0;d=f[_>>2]|0;v=(w-d|0)/20|0;t=w;if(Z>>>0>v>>>0){F$(_,Z-v|0);u=j;return}if(Z>>>0>=v>>>0){u=j;return}v=d+(Z*20|0)|0;if((t|0)==(v|0)){u=j;return}f[K>>2]=t+(~(((t+-20-v|0)>>>0)/20|0)*20|0);u=j;return}case 24:{v=_+4|0;t=f[v>>2]|0;K=f[_>>2]|0;d=(t-K|0)/24|0;w=t;if(Z>>>0>d>>>0){G$(_,Z-d|0);u=j;return}if(Z>>>0>=d>>>0){u=j;return}d=K+(Z*24|0)|0;if((w|0)==(d|0)){u=j;return}f[v>>2]=w+(~(((w+-24-d|0)>>>0)/24|0)*24|0);u=j;return}case 28:{d=_+4|0;w=f[d>>2]|0;v=f[_>>2]|0;K=(w-v|0)/28|0;t=w;if(Z>>>0>K>>>0){H$(_,Z-K|0);u=j;return}if(Z>>>0>=K>>>0){u=j;return}K=v+(Z*28|0)|0;if((t|0)==(K|0)){u=j;return}f[d>>2]=t+(~(((t+-28-K|0)>>>0)/28|0)*28|0);u=j;return}case 32:{K=_+4|0;t=f[K>>2]|0;d=f[_>>2]|0;v=t-d>>5;w=t;if(Z>>>0>v>>>0){I$(_,Z-v|0);u=j;return}if(Z>>>0>=v>>>0){u=j;return}v=d+(Z<<5)|0;if((w|0)==(v|0)){u=j;return}f[K>>2]=w+(~((w+-32-v|0)>>>5)<<5);u=j;return}case 36:{v=_+4|0;w=f[v>>2]|0;K=f[_>>2]|0;d=(w-K|0)/36|0;t=w;if(Z>>>0>d>>>0){J$(_,Z-d|0);u=j;return}if(Z>>>0>=d>>>0){u=j;return}d=K+(Z*36|0)|0;if((t|0)==(d|0)){u=j;return}f[v>>2]=t+(~(((t+-36-d|0)>>>0)/36|0)*36|0);u=j;return}case 40:{d=_+4|0;t=f[d>>2]|0;v=f[_>>2]|0;K=(t-v|0)/40|0;w=t;if(Z>>>0>K>>>0){K$(_,Z-K|0);u=j;return}if(Z>>>0>=K>>>0){u=j;return}K=v+(Z*40|0)|0;if((w|0)==(K|0)){u=j;return}f[d>>2]=w+(~(((w+-40-K|0)>>>0)/40|0)*40|0);u=j;return}case 44:{K=_+4|0;w=f[K>>2]|0;d=f[_>>2]|0;v=(w-d|0)/44|0;t=w;if(Z>>>0>v>>>0){L$(_,Z-v|0);u=j;return}if(Z>>>0>=v>>>0){u=j;return}v=d+(Z*44|0)|0;if((t|0)==(v|0)){u=j;return}f[K>>2]=t+(~(((t+-44-v|0)>>>0)/44|0)*44|0);u=j;return}case 48:{v=_+4|0;t=f[v>>2]|0;K=f[_>>2]|0;d=(t-K|0)/48|0;w=t;if(Z>>>0>d>>>0){M$(_,Z-d|0);u=j;return}if(Z>>>0>=d>>>0){u=j;return}d=K+(Z*48|0)|0;if((w|0)==(d|0)){u=j;return}f[v>>2]=w+(~(((w+-48-d|0)>>>0)/48|0)*48|0);u=j;return}case 52:{d=_+4|0;w=f[d>>2]|0;v=f[_>>2]|0;K=(w-v|0)/52|0;t=w;if(Z>>>0>K>>>0){N$(_,Z-K|0);u=j;return}if(Z>>>0>=K>>>0){u=j;return}K=v+(Z*52|0)|0;if((t|0)==(K|0)){u=j;return}f[d>>2]=t+(~(((t+-52-K|0)>>>0)/52|0)*52|0);u=j;return}case 56:{K=_+4|0;t=f[K>>2]|0;d=f[_>>2]|0;v=(t-d|0)/56|0;w=t;if(Z>>>0>v>>>0){O$(_,Z-v|0);u=j;return}if(Z>>>0>=v>>>0){u=j;return}v=d+(Z*56|0)|0;if((w|0)==(v|0)){u=j;return}f[K>>2]=w+(~(((w+-56-v|0)>>>0)/56|0)*56|0);u=j;return}case 60:{v=_+4|0;w=f[v>>2]|0;K=f[_>>2]|0;d=(w-K|0)/60|0;t=w;if(Z>>>0>d>>>0){P$(_,Z-d|0);u=j;return}if(Z>>>0>=d>>>0){u=j;return}d=K+(Z*60|0)|0;if((t|0)==(d|0)){u=j;return}f[v>>2]=t+(~(((t+-60-d|0)>>>0)/60|0)*60|0);u=j;return}case 64:{d=_+4|0;t=f[d>>2]|0;v=f[_>>2]|0;K=t-v>>6;w=t;if(Z>>>0>K>>>0){Q$(_,Z-K|0);u=j;return}if(Z>>>0>=K>>>0){u=j;return}K=v+(Z<<6)|0;if((w|0)==(K|0)){u=j;return}f[d>>2]=w+(~((w+-64-K|0)>>>6)<<6);u=j;return}case 128:{K=_+4|0;w=f[K>>2]|0;d=f[_>>2]|0;v=w-d>>7;t=w;if(Z>>>0>v>>>0){R$(_,Z-v|0);u=j;return}if(Z>>>0>=v>>>0){u=j;return}v=d+(Z<<7)|0;if((t|0)==(v|0)){u=j;return}f[K>>2]=t+(~((t+-128-v|0)>>>7)<<7);u=j;return}case 256:{v=_+4|0;t=f[v>>2]|0;K=f[_>>2]|0;d=t-K>>8;w=t;if(Z>>>0>d>>>0){S$(_,Z-d|0);u=j;return}if(Z>>>0>=d>>>0){u=j;return}d=K+(Z<<8)|0;if((w|0)==(d|0)){u=j;return}f[v>>2]=w+(~((w+-256-d|0)>>>8)<<8);u=j;return}case 512:{d=_+4|0;w=f[d>>2]|0;v=f[_>>2]|0;K=w-v>>9;t=w;if(Z>>>0>K>>>0){T$(_,Z-K|0);u=j;return}if(Z>>>0>=K>>>0){u=j;return}K=v+(Z<<9)|0;if((t|0)==(K|0)){u=j;return}f[d>>2]=t+(~((t+-512-K|0)>>>9)<<9);u=j;return}default:{f[k>>2]=ca;F5(m,223539,k);z5(-5,m,464481,221901,1470)}}while(0)}function x$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){XIc(h|0,0,b*12|0)|0;f[g>>2]=h+(b*12|0);u=c;return}g=f[a>>2]|0;i=(h-g|0)/12|0;h=i+b|0;if(h>>>0>357913941)mCc(a);j=(e-g|0)/12|0;g=j<<1;e=j>>>0<178956970?(g>>>0<h>>>0?h:g):357913941;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>357913941){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}else{k=VDc(e*12|0)|0;break}else k=0;while(0);f[d>>2]=k;g=k+(i*12|0)|0;i=d+8|0;h=d+4|0;f[h>>2]=g;f[d+12>>2]=k+(e*12|0);XIc(g|0,0,b*12|0)|0;f[i>>2]=g+(b*12|0);U$(a,d);a=f[h>>2]|0;h=f[i>>2]|0;if((h|0)!=(a|0)){b=h;while(1){h=b+-12|0;f[i>>2]=h;g=f[h>>2]|0;if(!g)l=h;else{h=b+-8|0;if((f[h>>2]|0)!=(g|0))f[h>>2]=g;YDc(g);l=f[i>>2]|0}if((l|0)==(a|0))break;else b=l}}l=f[d>>2]|0;if(l|0)YDc(l);u=c;return}function y$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if((e-h|0)>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;j=(f[g>>2]|0)+1|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i|0;h=j+c|0;if((h|0)<0)mCc(a);k=e-i|0;i=k<<1;e=k>>>0<1073741823?(i>>>0<h>>>0?h:i):2147483647;if(!e)l=0;else l=VDc(e)|0;i=l+j|0;j=l+e|0;e=c;c=i;l=i;do{b[l>>0]=0;l=c+1|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(0-l)|0;if((l|0)>0)dJc(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;YDc(e);return}function z$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>1>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;b[j+1>>0]=0;j=(f[g>>2]|0)+2|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>1;h=j+c|0;if((h|0)<0)mCc(a);k=e-i|0;i=k>>1>>>0<1073741823?(k>>>0<h>>>0?h:k):2147483647;do if(i)if((i|0)<0){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{l=VDc(i<<1)|0;break}else l=0;while(0);k=l+(j<<1)|0;j=k;h=l+(i<<1)|0;i=c;c=k;l=j;do{b[c>>0]=0;b[c+1>>0]=0;c=l+2|0;l=c;i=i+-1|0}while((i|0)!=0);i=h;h=f[a>>2]|0;c=f[g>>2]|0;if((c|0)==(h|0)){m=j;n=h}else{e=c;c=j;j=k;do{k=e;e=e+-2|0;b[j+-2>>0]=b[e>>0]|0;b[j+-1>>0]=b[k+-1>>0]|0;j=c+-2|0;c=j}while((e|0)!=(h|0));m=c;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=l;f[d>>2]=i;if(!n)return;YDc(n);return}function A$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/3|0)>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;b[j+1>>0]=0;b[j+2>>0]=0;j=(f[g>>2]|0)+3|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/3|0;h=j+c|0;if(h>>>0>1431655765)mCc(a);k=(e-i|0)/3|0;i=k<<1;e=k>>>0<715827882?(i>>>0<h>>>0?h:i):1431655765;do if(e)if(e>>>0>1431655765){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{l=VDc(e*3|0)|0;break}else l=0;while(0);i=l+(j*3|0)|0;j=i;h=l+(e*3|0)|0;e=c;c=j;l=i;do{b[l>>0]=0;b[l+1>>0]=0;b[l+2>>0]=0;l=c+3|0;c=l;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(h|0)){m=j;n=h}else{k=l;l=j;j=i;do{i=k;k=k+-3|0;b[j+-3>>0]=b[k>>0]|0;b[j+-2>>0]=b[i+-2>>0]|0;b[j+-1>>0]=b[i+-1>>0]|0;j=l+-3|0;l=j}while((k|0)!=(h|0));m=l;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=c;f[d>>2]=e;if(!n)return;YDc(n);return}function B$(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;e=f[c>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/6|0)>>>0>=b>>>0){i=b;j=h;do{d[j>>1]=0;d[j+2>>1]=0;d[j+4>>1]=0;j=(f[g>>2]|0)+6|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/6|0;h=j+b|0;if(h>>>0>715827882)mCc(a);k=(e-i|0)/6|0;i=k<<1;e=k>>>0<357913941?(i>>>0<h>>>0?h:i):715827882;do if(e)if(e>>>0>715827882){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{l=VDc(e*6|0)|0;break}else l=0;while(0);i=l+(j*6|0)|0;j=i;h=l+(e*6|0)|0;e=b;b=i;l=j;do{d[b>>1]=0;d[b+2>>1]=0;d[b+4>>1]=0;b=l+6|0;l=b;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;b=f[g>>2]|0;if((b|0)==(h|0)){m=j;n=h}else{j=b;b=i;do{i=j;j=j+-6|0;d[b+-6>>1]=d[j>>1]|0;d[b+-4>>1]=d[i+-4>>1]|0;d[b+-2>>1]=d[i+-2>>1]|0;b=b+-6|0}while((j|0)!=(h|0));m=b;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=l;f[c>>2]=e;if(!n)return;YDc(n);return}function C$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){h=b;i=g;do{j=i;f[j>>2]=0;f[j+4>>2]=0;i=(f[e>>2]|0)+8|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>3;g=i+b|0;if(g>>>0>536870911)mCc(a);j=d-h|0;h=j>>2;d=j>>3>>>0<268435455?(h>>>0<g>>>0?g:h):536870911;do if(d)if(d>>>0>536870911){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<3)|0;break}else k=0;while(0);h=k+(i<<3)|0;i=h;g=k+(d<<3)|0;d=b;b=h;k=i;do{j=b;f[j>>2]=0;f[j+4>>2]=0;b=k+8|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-8-j|0;j=b;b=h;while(1){n=j;j=j+-8|0;f[b+-8>>2]=f[j>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-8|0}l=h+(~(i>>>3)<<3)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function D$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)mCc(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=h;g=k+(d*12|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=k+12|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-12|0;f[b+-12>>2]=f[i>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-12|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function E$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)mCc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function F$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)mCc(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=h;g=k+(d*20|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-20|0;f[b+-20>>2]=f[i>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-20|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function G$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=(f[e>>2]|0)+24|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/24|0;g=i+b|0;if(g>>>0>178956970)mCc(a);j=(d-h|0)/24|0;h=j<<1;d=j>>>0<89478485?(h>>>0<g>>>0?g:h):178956970;do if(d)if(d>>>0>178956970){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*24|0)|0;break}else k=0;while(0);h=k+(i*24|0)|0;i=h;g=k+(d*24|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;b=k+24|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-24|0;f[b+-24>>2]=f[i>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-24|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function H$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/28|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;i=(f[e>>2]|0)+28|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/28|0;g=i+b|0;if(g>>>0>153391689)mCc(a);j=(d-h|0)/28|0;h=j<<1;d=j>>>0<76695844?(h>>>0<g>>>0?g:h):153391689;do if(d)if(d>>>0>153391689){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*28|0)|0;break}else k=0;while(0);h=k+(i*28|0)|0;i=h;g=k+(d*28|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;b=k+28|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-28|0;f[b+-28>>2]=f[i>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-28|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function I$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>5>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;i=(f[e>>2]|0)+32|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>5;g=i+b|0;if(g>>>0>134217727)mCc(a);j=d-h|0;h=j>>4;d=j>>5>>>0<67108863?(h>>>0<g>>>0?g:h):134217727;do if(d)if(d>>>0>134217727){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<5)|0;break}else k=0;while(0);h=k+(i<<5)|0;i=h;g=k+(d<<5)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;b=k+32|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-32-j|0;j=b;b=h;while(1){n=j;j=j+-32|0;f[b+-32>>2]=f[j>>2];f[b+-28>>2]=f[n+-28>>2];f[b+-24>>2]=f[n+-24>>2];f[b+-20>>2]=f[n+-20>>2];f[b+-16>>2]=f[n+-16>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-32|0}l=h+(~(i>>>5)<<5)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function J$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/36|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+36|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/36|0;g=i+b|0;if(g>>>0>119304647)mCc(a);l=(d-h|0)/36|0;h=l<<1;d=l>>>0<59652323?(h>>>0<g>>>0?g:h):119304647;do if(d)if(d>>>0>119304647){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*36|0)|0;break}else m=0;while(0);h=m+(i*36|0)|0;i=h;g=m+(d*36|0)|0;d=b;b=h;m=i;do{j=b;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+36|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-36|0;f[b+-36>>2]=f[i>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-36|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function K$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/40|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+40|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+40|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/40|0;g=i+b|0;if(g>>>0>107374182)mCc(a);l=(d-h|0)/40|0;h=l<<1;d=l>>>0<53687091?(h>>>0<g>>>0?g:h):107374182;do if(d)if(d>>>0>107374182){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*40|0)|0;break}else m=0;while(0);h=m+(i*40|0)|0;i=h;g=m+(d*40|0)|0;d=b;b=h;m=i;do{j=b;k=j+40|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+40|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-40|0;f[b+-40>>2]=f[i>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-40|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function L$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/44|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+44|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/44|0;g=i+b|0;if(g>>>0>97612893)mCc(a);l=(d-h|0)/44|0;h=l<<1;d=l>>>0<48806446?(h>>>0<g>>>0?g:h):97612893;do if(d)if(d>>>0>97612893){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*44|0)|0;break}else m=0;while(0);h=m+(i*44|0)|0;i=h;g=m+(d*44|0)|0;d=b;b=h;m=i;do{j=b;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+44|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-44|0;f[b+-44>>2]=f[i>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-44|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function M$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/48|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+48|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/48|0;g=i+b|0;if(g>>>0>89478485)mCc(a);l=(d-h|0)/48|0;h=l<<1;d=l>>>0<44739242?(h>>>0<g>>>0?g:h):89478485;do if(d)if(d>>>0>89478485){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*48|0)|0;break}else m=0;while(0);h=m+(i*48|0)|0;i=h;g=m+(d*48|0)|0;d=b;b=h;m=i;do{j=b;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+48|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-48|0;f[b+-48>>2]=f[i>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-48|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function N$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/52|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+52|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+52|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/52|0;g=i+b|0;if(g>>>0>82595524)mCc(a);l=(d-h|0)/52|0;h=l<<1;d=l>>>0<41297762?(h>>>0<g>>>0?g:h):82595524;do if(d)if(d>>>0>82595524){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*52|0)|0;break}else m=0;while(0);h=m+(i*52|0)|0;i=h;g=m+(d*52|0)|0;d=b;b=h;m=i;do{j=b;k=j+52|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+52|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-52|0;f[b+-52>>2]=f[i>>2];f[b+-48>>2]=f[h+-48>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-52|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function O$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/56|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+56|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/56|0;g=i+b|0;if(g>>>0>76695844)mCc(a);l=(d-h|0)/56|0;h=l<<1;d=l>>>0<38347922?(h>>>0<g>>>0?g:h):76695844;do if(d)if(d>>>0>76695844){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*56|0)|0;break}else m=0;while(0);h=m+(i*56|0)|0;i=h;g=m+(d*56|0)|0;d=b;b=h;m=i;do{j=b;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+56|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-56|0;f[b+-56>>2]=f[i>>2];f[b+-52>>2]=f[h+-52>>2];f[b+-48>>2]=f[h+-48>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-56|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function P$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/60|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+60|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/60|0;g=i+b|0;if(g>>>0>71582788)mCc(a);l=(d-h|0)/60|0;h=l<<1;d=l>>>0<35791394?(h>>>0<g>>>0?g:h):71582788;do if(d)if(d>>>0>71582788){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*60|0)|0;break}else m=0;while(0);h=m+(i*60|0)|0;i=h;g=m+(d*60|0)|0;d=b;b=h;m=i;do{j=b;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+60|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-60|0;f[b+-60>>2]=f[i>>2];f[b+-56>>2]=f[h+-56>>2];f[b+-52>>2]=f[h+-52>>2];f[b+-48>>2]=f[h+-48>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-60|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function Q$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)mCc(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=h;g=m+(d<<6)|0;d=b;b=h;m=i;do{j=b;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){n=i;o=j}else{i=b+-64-j|0;j=b;b=h;while(1){k=j;j=j+-64|0;f[b+-64>>2]=f[j>>2];f[b+-60>>2]=f[k+-60>>2];f[b+-56>>2]=f[k+-56>>2];f[b+-52>>2]=f[k+-52>>2];f[b+-48>>2]=f[k+-48>>2];f[b+-44>>2]=f[k+-44>>2];f[b+-40>>2]=f[k+-40>>2];f[b+-36>>2]=f[k+-36>>2];f[b+-32>>2]=f[k+-32>>2];f[b+-28>>2]=f[k+-28>>2];f[b+-24>>2]=f[k+-24>>2];f[b+-20>>2]=f[k+-20>>2];f[b+-16>>2]=f[k+-16>>2];f[b+-12>>2]=f[k+-12>>2];f[b+-8>>2]=f[k+-8>>2];f[b+-4>>2]=f[k+-4>>2];if((j|0)==(g|0))break;else b=b+-64|0}n=h+(~(i>>>6)<<6)|0;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function R$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>7>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+128|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+128|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>7;g=i+b|0;if(g>>>0>33554431)mCc(a);l=d-h|0;h=l>>6;d=l>>7>>>0<16777215?(h>>>0<g>>>0?g:h):33554431;do if(d)if(d>>>0>33554431){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d<<7)|0;break}else m=0;while(0);h=m+(i<<7)|0;i=h;g=m+(d<<7)|0;d=b;b=h;m=i;do{j=b;k=j+128|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+128|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){n=i;o=j}else{i=b+-128-j|0;j=b;b=h;while(1){k=0;do{f[b+-128+(k<<2)>>2]=f[j+-128+(k<<2)>>2];k=k+1|0}while((k|0)!=32);j=j+-128|0;if((j|0)==(g|0))break;else b=b+-128|0}n=h+(~(i>>>7)<<7)|0;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;YDc(o);return}function S$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>8>>>0>=b>>>0){h=b;i=g;do{XIc(i|0,0,256)|0;i=(f[e>>2]|0)+256|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>8;g=i+b|0;if(g>>>0>16777215)mCc(a);j=d-h|0;h=j>>7;d=j>>8>>>0<8388607?(h>>>0<g>>>0?g:h):16777215;do if(d)if(d>>>0>16777215){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<8)|0;break}else k=0;while(0);h=k+(i<<8)|0;i=h;g=k+(d<<8)|0;d=b;b=h;k=i;do{XIc(b|0,0,256)|0;b=k+256|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-256-j|0;j=b;b=h;while(1){n=0;do{f[b+-256+(n<<2)>>2]=f[j+-256+(n<<2)>>2];n=n+1|0}while((n|0)!=64);j=j+-256|0;if((j|0)==(g|0))break;else b=b+-256|0}l=h+(~(i>>>8)<<8)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function T$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>9>>>0>=b>>>0){h=b;i=g;do{XIc(i|0,0,512)|0;i=(f[e>>2]|0)+512|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>9;g=i+b|0;if(g>>>0>8388607)mCc(a);j=d-h|0;h=j>>8;d=j>>9>>>0<4194303?(h>>>0<g>>>0?g:h):8388607;do if(d)if(d>>>0>8388607){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<9)|0;break}else k=0;while(0);h=k+(i<<9)|0;i=h;g=k+(d<<9)|0;d=b;b=h;k=i;do{XIc(b|0,0,512)|0;b=k+512|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-512-j|0;j=b;b=h;while(1){n=0;do{f[b+-512+(n<<2)>>2]=f[j+-512+(n<<2)>>2];n=n+1|0}while((n|0)!=128);j=j+-512|0;if((j|0)==(g|0))break;else b=b+-512|0}l=h+(~(i>>>9)<<9)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function U$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;do if((e|0)!=(c|0)){h=e;i=f[g>>2]|0;while(1){j=i+-12|0;f[j>>2]=0;k=i+-8|0;f[k>>2]=0;f[i+-4>>2]=0;l=h+-8|0;h=h+-12|0;m=(f[l>>2]|0)-(f[h>>2]|0)|0;if(m|0){if((m|0)<0){n=6;break}o=VDc(m)|0;f[k>>2]=o;f[j>>2]=o;f[i+-4>>2]=o+m;m=f[h>>2]|0;p=(f[l>>2]|0)-m|0;if((p|0)>0){dJc(o|0,m|0,p|0)|0;f[k>>2]=o+p}}i=(f[g>>2]|0)+-12|0;f[g>>2]=i;if((h|0)==(c|0)){n=10;break}}if((n|0)==6)mCc(j);else if((n|0)==10){q=g;r=a;s=i;t=f[a>>2]|0;break}}else{q=g;r=a;s=f[g>>2]|0;t=c}while(0);f[r>>2]=s;f[q>>2]=t;t=b+8|0;s=f[d>>2]|0;f[d>>2]=f[t>>2];f[t>>2]=s;s=a+8|0;a=b+12|0;t=f[s>>2]|0;f[s>>2]=f[a>>2];f[a>>2]=t;f[b>>2]=f[q>>2];return}function V$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;if((c|0)<0){if((g|0)!=65536){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,8)|0;i=h;b[i>>0]=107;b[i+1>>0]=32;b[i+2>>0]=61;b[i+3>>0]=61;i=h+4|0;b[i>>0]=32;b[i+1>>0]=77;b[i+2>>0]=65;b[i+3>>0]=84;z5(-215,e,223741,221901,1760)}j=f[a+4>>2]|0;u=d;return j|0}i=g&2097151;a:do if((i|0)<983040){switch(i|0){case 327680:{break a;break}default:{}}f[e>>2]=0;k=e+4|0;f[k>>2]=0;l=tT(e,41)|0;m=l;n=223751;o=m+41|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,223741,221901,1764)}else{switch(i|0){case 983040:{break a;break}default:{}}f[e>>2]=0;k=e+4|0;f[k>>2]=0;l=tT(e,41)|0;m=l;n=223751;o=m+41|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,223741,221901,1764)}while(0);l=f[a+4>>2]|0;if((g|0)==327680){g=f[l>>2]|0;if((((f[l+4>>2]|0)-g|0)/56|0|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,17)|0;n=223711;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,223741,221901,1769)}j=g+(c*56|0)|0;u=d;return j|0}else{if((f[a+12>>2]|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,23)|0;n=222028;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,223741,221901,1775)}j=l+(c*56|0)|0;u=d;return j|0}return 0}function W$(a){a=a|0;return (f[a>>2]&1073741824|0)!=0|0}function X$(a){a=a|0;return (f[a>>2]|0)<0|0}function Y$(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=u;u=u+16|0;k=j;l=f[a>>2]|0;m=l&2031616;n=(g|0)<0;do if(n&(m|0)==65536){if((i|0)==0&(h^1)){if(l&1073741824|0?(o=f[(f[a+4>>2]|0)+40>>2]|0,!((f[o>>2]|0)==(c|0)?(f[o+4>>2]|0)==(d|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,68)|0;q=223793;r=p+68|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1235)}o=f[a+4>>2]|0;if((l|0)<0?(f[o>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,44)|0;q=222467;r=p+44|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1236)}s=e&4095;if(((((f[o+4>>2]|0)<3?(f[o+8>>2]|0)==(c|0):0)?(f[o+12>>2]|0)==(d|0):0)?(f[o>>2]&4095|0)==(s|0):0)?f[o+16>>2]|0:0){u=j;return}f[k>>2]=c;f[k+4>>2]=d;XS(o,2,k,s);u=j;return}}else{if(n&(m|0)==655360){if(!((i|0)==0&(h^1)))break;if(l&1073741824|0?(s=f[(f[a+4>>2]|0)+32>>2]|0,!((f[s>>2]|0)==(c|0)?(f[s+4>>2]|0)==(d|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,69)|0;q=223862;r=p+69|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1242)}o=f[a+4>>2]|0;if((l|0)<0?(f[o>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,45)|0;q=222567;r=p+45|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1243)}s=e&4095;if(((((f[o+4>>2]|0)<3?(f[o+8>>2]|0)==(c|0):0)?(f[o+12>>2]|0)==(d|0):0)?(f[o>>2]&4095|0)==(s|0):0)?f[o+24>>2]|0:0){u=j;return}f[k>>2]=c;f[k+4>>2]=d;DQ(o,2,k,s,0);u=j;return}if(n&(m|0)==589824){if(!((i|0)==0&(h^1)))break;if(l&1073741824|0?(s=f[a+4>>2]|0,!((f[s+8>>2]|0)==(d|0)?(f[s+4>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,66)|0;q=223932;r=p+66|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1249)}o=f[a+4>>2]|0;if((l|0)>=0)T7(o,c,d,e);if((f[o>>2]&4095|0)==(e|0))T7(o,c,d,e);else{f[k>>2]=0;f[k+4>>2]=0;p=tT(k,53)|0;q=222665;r=p+53|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1250)}}if(n&(m|0)==458752){if(!((i|0)==0&(h^1)))break;if(l&1073741824|0?(o=f[a+4>>2]|0,!((f[o+12>>2]|0)==(d|0)?(f[o+8>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,65)|0;q=223999;r=p+65|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1256)}o=f[a+4>>2]|0;if((l|0)<0?(f[o+16>>2]|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,52)|0;q=222770;r=p+52|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1257)}t3(o,c,d,e,34962,0);u=j;return}if(n&(m|0)==524288?(i|0)==0&(h^1):0){if(l&1073741824|0?(s=f[a+4>>2]|0,!((f[s+8>>2]|0)==(d|0)?(f[s+4>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=tT(k,67)|0;q=224065;r=p+67|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1263)}o=f[a+4>>2]|0;if((l|0)>=0)a7(o,c,d,e);if((f[o>>2]&4095|0)==(e|0))a7(o,c,d,e);else{f[k>>2]=0;f[k+4>>2]=0;p=tT(k,54)|0;q=222876;r=p+54|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,k,464481,221901,1264)}}}while(0);f[k>>2]=c;f[k+4>>2]=d;w$(a,2,k,e,g,h,i);u=j;return}function Z$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+144|0;e=d+128|0;g=d;h=f[b>>2]&2031616;a:do if((h|0)>=65536)if((h|0)<655360){switch(h|0){case 65536:break;default:{i=8;break a}}j=f[b+4>>2]|0;k=f[j+4>>2]|0;if((k|0)<=0){l=k;break}m=f[j+40>>2]|0;j=0;do{f[g+(j<<2)>>2]=f[m+(j<<2)>>2];j=j+1|0}while((j|0)!=(k|0));l=k}else{switch(h|0){case 655360:break;default:{i=8;break a}}k=f[b+4>>2]|0;j=f[k+4>>2]|0;if((j|0)<=0){l=j;break}m=f[k+32>>2]|0;k=0;do{f[g+(k<<2)>>2]=f[m+(k<<2)>>2];k=k+1|0}while((k|0)!=(j|0));l=j}else switch(h|0){case 0:{l=0;break}default:i=8}while(0);if((i|0)==8){b$(e,b,-1);f[g>>2]=f[e+4>>2];f[g+4>>2]=f[e>>2];l=2}w$(a,l,g,c,-1,0,0);u=d;return}function _$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;if((e&2031616|0)!=65536){u$(a);u=c;return}if(e&1073741824|0){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,12)|0;g=222392;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));z5(-215,d,224133,221901,1742)}iT(f[a+4>>2]|0,0);u=c;return}function $$(a){a=a|0;return (f[a>>2]&2031616|0)!=0|0}function a0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0,I=0,J=0,K=0;e=u;u=u+112|0;g=e;h=e+56|0;i=f[a>>2]|0;switch(i>>>16&31){case 1:case 2:case 3:case 14:{do if((i&2031616|0)==65536){j=f[a+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;ZS(g,j);break}}else a$(g,a,-1);while(0);l_(g,c,d)|0;i=g+36|0;j=f[i>>2]|0;if(j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)_S(g);f[i>>2]=0;i=g+16|0;j=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){i=f[g+40>>2]|0;k=0;do{f[i+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))g0(j);u=e;return}case 10:{MQ(f[a+4>>2]|0,c,d)|0;u=e;return}case 9:{do if((f[c>>2]&2031616|0)==65536){j=f[c+4>>2]|0;f[h>>2]=f[j>>2];k=h+4|0;i=j+4|0;f[k>>2]=f[i>>2];l=h+8|0;f[l>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];m=f[j+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[i>>2]|0)<3){i=f[j+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];break}else{f[k>>2]=0;ZS(h,j);break}}else a$(h,c,-1);while(0);c=c$(a,-1)|0;if((f[h+4>>2]|0)>2){f[g>>2]=0;q=g+4|0;f[q>>2]=0;r=tT(g,65)|0;s=r;t=224139;v=s+65|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,224205,221901,1840)}j=f[h>>2]|0;if(!(j&16384)){f[g>>2]=0;q=g+4|0;f[q>>2]=0;r=tT(g,65)|0;s=r;t=224139;v=s+65|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,224205,221901,1840)}k=f[h+40>>2]|0;i=f[k+4>>2]|0;l=f[k>>2]|0;k=(i|0)==1;o=(l|0)==1;if(!(k|o)){f[g>>2]=0;q=g+4|0;f[q>>2]=0;r=tT(g,65)|0;s=r;t=224139;v=s+65|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,224205,221901,1840)}m=(c>>>3&511)+1|0;if((m|0)==(i|0)&o|k&(o|(m|0)==(l|0))){w=a+4|0;x=f[w>>2]|0;y=h+16|0;z=f[y>>2]|0;A=+p[z>>3];B=z+8|0;C=+p[B>>3];D=z+16|0;E=+p[D>>3];F=z+24|0;G=+p[F>>3];p[g>>3]=A;H=g+8|0;p[H>>3]=C;I=g+16|0;p[I>>3]=E;J=g+24|0;p[J>>3]=G;K=C6()|0;V7(x,g,d,K)|0}if(m>>>0>4|(j&4095|0)!=6|k&(l|0)==4^1){f[g>>2]=0;q=g+4|0;f[q>>2]=0;r=tT(g,65)|0;s=r;t=224139;v=s+65|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,224205,221901,1840)}else{w=a+4|0;x=f[w>>2]|0;y=h+16|0;z=f[y>>2]|0;A=+p[z>>3];B=z+8|0;C=+p[B>>3];D=z+16|0;E=+p[D>>3];F=z+24|0;G=+p[F>>3];p[g>>3]=A;H=g+8|0;p[H>>3]=C;I=g+16|0;p[I>>3]=E;J=g+24|0;p[J>>3]=G;K=C6()|0;V7(x,g,d,K)|0}break}case 0:{u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;z5(-213,g,224205,221901,1844)}}}function b0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+80|0;d=c+56|0;e=c;g=f[a>>2]&2031616;h=g&2097151;if((h|0)<131072){switch(h|0){case 65536:break;default:{f[d>>2]=0;i=d+4|0;f[i>>2]=0;z5(-213,d,224211,221901,1887)}}j=f[a+4>>2]|0;if((j|0)==(b|0)){u=c;return}k=b+36|0;l=f[k>>2]|0;if(l|0){m=l+12|0;f[m>>2]=(f[m>>2]|0)+1}m=j+36|0;l=f[m>>2]|0;if(l|0?(n=l+12|0,l=f[n>>2]|0,f[n>>2]=l+-1,(l|0)==1):0)_S(j);f[m>>2]=0;l=j+16|0;n=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[n>>2]|0)>0){o=f[j+40>>2]|0;p=0;do{f[o+(p<<2)>>2]=0;p=p+1|0;q=f[n>>2]|0}while((p|0)<(q|0));f[j>>2]=f[b>>2];if((q|0)<3)r=14;else r=16}else{f[j>>2]=f[b>>2];r=14}if((r|0)==14){q=f[b+4>>2]|0;if((q|0)<3){f[n>>2]=q;f[j+8>>2]=f[b+8>>2];f[j+12>>2]=f[b+12>>2];q=f[b+44>>2]|0;n=f[j+44>>2]|0;f[n>>2]=f[q>>2];f[n+4>>2]=f[q+4>>2]}else r=16}if((r|0)==16)ZS(j,b);f[l>>2]=f[b+16>>2];f[j+20>>2]=f[b+20>>2];f[j+24>>2]=f[b+24>>2];f[j+28>>2]=f[b+28>>2];f[j+32>>2]=f[b+32>>2];f[m>>2]=f[k>>2];u=c;return}if((h|0)>=655360){switch(h|0){case 655360:break;default:{f[d>>2]=0;i=d+4|0;f[i>>2]=0;z5(-213,d,224211,221901,1887)}}k=f[a+4>>2]|0;m=d+8|0;f[m>>2]=0;f[m+4>>2]=0;f[d>>2]=34209792;f[d+4>>2]=k;h_(b,d);u=c;return}switch(h|0){case 131072:break;default:{f[d>>2]=0;i=d+4|0;f[i>>2]=0;z5(-213,d,224211,221901,1887)}}do if((g|0)==65536){i=f[a+4>>2]|0;f[e>>2]=f[i>>2];h=e+4|0;k=i+4|0;f[h>>2]=f[k>>2];m=e+8|0;f[m>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];j=f[i+36>>2]|0;f[e+36>>2]=j;f[e+40>>2]=m;m=e+48|0;l=e+44|0;f[l>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(j|0){m=j+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;m=f[l>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];break}else{f[h>>2]=0;ZS(e,i);break}}else a$(e,a,-1);while(0);a=d+8|0;f[a>>2]=0;f[a+4>>2]=0;f[d>>2]=-1040121856;f[d+4>>2]=e;h_(b,d);d=e+36|0;b=f[d>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)_S(e);f[d>>2]=0;d=e+16|0;b=e+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[e+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[e+44>>2]|0;if((b|0)!=(e+48|0))g0(b);u=c;return}function c0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;if((g|0)<720896){switch(g|0){case 327680:break;default:{f[e>>2]=0;h=e+4|0;f[h>>2]=0;z5(-213,e,224211,221901,1925)}}i=f[a+4>>2]|0;j=f[i>>2]|0;k=c+4|0;l=f[k>>2]|0;m=f[c>>2]|0;n=j;if((((f[i+4>>2]|0)-j|0)/56|0|0)!=((l-m|0)/48|0|0)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,25)|0;p=224218;q=o+25|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,e,224211,221901,1912)}if((l|0)==(m|0)){u=d;return}j=e+8|0;r=e+4|0;s=0;t=m;m=n;n=l;while(1){l=t;v=l+(s*48|0)|0;w=m+(s*56|0)|0;x=f[m+(s*56|0)+36>>2]|0;if((x|0)!=0?(x|0)==(f[l+(s*48|0)+24>>2]|0):0){y=t;z=n}else{l=j;f[l>>2]=0;f[l+4>>2]=0;f[e>>2]=33619968;f[r>>2]=w;NQ(v,e);y=f[c>>2]|0;z=f[k>>2]|0}v=s+1|0;if(v>>>0>=((z-y|0)/48|0)>>>0)break;s=v;t=y;m=f[i>>2]|0;n=z}u=d;return}else{switch(g|0){case 720896:break;default:{f[e>>2]=0;h=e+4|0;f[h>>2]=0;z5(-213,e,224211,221901,1925)}}h=f[a+4>>2]|0;a=f[h>>2]|0;g=c+4|0;z=f[g>>2]|0;n=f[c>>2]|0;i=a;if(((f[h+4>>2]|0)-a|0)!=(z-n|0)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,25)|0;p=224218;q=o+25|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,e,224211,221901,1898)}if((z|0)==(n|0)){u=d;return}p=e+8|0;o=e+4|0;q=0;a=n;n=i;i=z;while(1){z=a;m=z+(q*48|0)|0;y=n+(q*48|0)|0;t=f[n+(q*48|0)+24>>2]|0;if((t|0)!=0?(t|0)==(f[z+(q*48|0)+24>>2]|0):0){A=a;B=i}else{z=p;f[z>>2]=0;f[z+4>>2]=0;f[e>>2]=34209792;f[o>>2]=y;NQ(m,e);A=f[c>>2]|0;B=f[g>>2]|0}m=q+1|0;if(m>>>0>=((B-A|0)/48|0)>>>0)break;q=m;a=A;n=f[h>>2]|0;i=B}u=d;return}}function d0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;if((g|0)<720896){switch(g|0){case 327680:break;default:{f[e>>2]=0;h=e+4|0;f[h>>2]=0;z5(-213,e,224211,221901,1963)}}i=f[a+4>>2]|0;j=f[i>>2]|0;k=c+4|0;l=f[k>>2]|0;m=f[c>>2]|0;n=j;if(((f[i+4>>2]|0)-j|0)!=(l-m|0)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,25)|0;p=224218;q=o+25|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,e,224211,221901,1950)}if((l|0)==(m|0)){u=d;return}j=e+8|0;r=e+4|0;s=0;t=m;m=n;n=l;while(1){l=t;v=l+(s*56|0)|0;w=m+(s*56|0)|0;x=f[m+(s*56|0)+36>>2]|0;if((x|0)!=0?(x|0)==(f[l+(s*56|0)+36>>2]|0):0){y=t;z=n}else{l=j;f[l>>2]=0;f[l+4>>2]=0;f[e>>2]=33619968;f[r>>2]=w;h_(v,e);y=f[c>>2]|0;z=f[k>>2]|0}v=s+1|0;if(v>>>0>=((z-y|0)/56|0)>>>0)break;s=v;t=y;m=f[i>>2]|0;n=z}u=d;return}else{switch(g|0){case 720896:break;default:{f[e>>2]=0;h=e+4|0;f[h>>2]=0;z5(-213,e,224211,221901,1963)}}h=f[a+4>>2]|0;a=f[h>>2]|0;g=c+4|0;z=f[g>>2]|0;n=f[c>>2]|0;i=a;if((((f[h+4>>2]|0)-a|0)/48|0|0)!=((z-n|0)/56|0|0)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,25)|0;p=224218;q=o+25|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,e,224211,221901,1936)}if((z|0)==(n|0)){u=d;return}p=e+8|0;o=e+4|0;q=0;a=n;n=i;i=z;while(1){z=a;m=z+(q*56|0)|0;y=n+(q*48|0)|0;t=f[n+(q*48|0)+24>>2]|0;if((t|0)!=0?(t|0)==(f[z+(q*56|0)+36>>2]|0):0){A=a;B=i}else{z=p;f[z>>2]=0;f[z+4>>2]=0;f[e>>2]=34209792;f[o>>2]=y;h_(m,e);A=f[c>>2]|0;B=f[g>>2]|0}m=q+1|0;if(m>>>0>=((B-A|0)/56|0)>>>0)break;q=m;a=A;n=f[h>>2]|0;i=B}u=d;return}}function e0(){return 45552}function f0(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;d=b+16|0;e=b+8|0;f[e>>2]=0;if(!(uoc(e,64,a)|0)){g=f[e>>2]|0;if(g|0){u=b;return g|0}}else f[e>>2]=0;e=c;f[e>>2]=a;f[e+4>>2]=0;F5(d,224244,c);z5(-4,d,224274,224291,55);return 0}function g0(a){a=a|0;poc(a);return}function h0(a){a=a|0;return f0(a)|0}function i0(a){a=a|0;poc(a);return}function j0(a){a=a|0;f[a>>2]=45576;return}function k0(a){a=a|0;YDc(a);return}function l0(a){a=a|0;return}function m0(a,b){a=a|0;b=b|0;return}function n0(a,b){a=a|0;b=b|0;return}function o0(a){a=a|0;return 0}function p0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+64|0;e=d+48|0;g=d+8|0;h=d;f[e>>2]=0;f[e+4>>2]=0;B_(g,c,1,e);uT(e);mi[f[(f[a>>2]|0)+28>>2]&2047](h,a);c=E_(g,h)|0;f[e>>2]=0;f[e+4>>2]=0;i=tT(e,1)|0;b[i>>0]=123;E_(c,e)|0;uT(e);uT(h);mi[f[(f[a>>2]|0)+12>>2]&2047](a,g);f[e>>2]=0;f[e+4>>2]=0;a=tT(e,1)|0;b[a>>0]=125;E_(g,e)|0;uT(e);t_(g);u=d;return}function q0(a,c){a=a|0;c=c|0;var d=0;f[a>>2]=0;f[a+4>>2]=0;c=tT(a,9)|0;a=224355;d=c+9|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(d|0));return}function r0(a){a=a|0;f[a>>2]=45576;return}function s0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;a=u;u=u+16|0;d=a;f[d>>2]=0;f[d+4>>2]=0;e=tT(d,6)|0;b[e>>0]=b[236362]|0;b[e+1>>0]=b[236363]|0;b[e+2>>0]=b[236364]|0;b[e+3>>0]=b[236365]|0;b[e+4>>0]=b[236366]|0;b[e+5>>0]=b[236367]|0;e=E_(c,d)|0;uT(d);if(!(_i[f[(f[c>>2]|0)+12>>2]&1023](e)|0)){u=a;return}g=c+32|0;if((f[g>>2]|0)==6){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,30)|0;i=471427;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-2,d,518366,471458,1188)}P_(e,c+12|0,3);if(!(f[g>>2]&4)){u=a;return}f[g>>2]=6;u=a;return}function t0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,224381,d);return}function u0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=v0(a,b,c)|0;w0(d);return d|0}function v0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=d&4095;if((c|a|0)<0){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,28)|0;j=224574;k=i+28|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-201,g,224603,119)}l=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);if((l|0)<1){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,19)|0;j=224621;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-210,g,224603,123)}g=Y(l,c)|0;l=h0(28)|0;f[l+4>>2]=g;f[l>>2]=h|1111638016;f[l+20>>2]=a;f[l+24>>2]=c;f[l+16>>2]=0;f[l+8>>2]=0;f[l+12>>2]=1;c=mJc(a|0,((a|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;g=J;if(!((g|0)>0|(g|0)==0&c>>>0>2147483647)){u=e;return l|0}f[l>>2]=h|1111621632;u=e;return l|0}function w0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;e=d+4|0;f[e>>2]=0;g=tT(d,38)|0;h=g;i=224535;j=h+38|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-5,d,224471,885)}k=f[a>>2]|0;l=k&-65536;if(((l|0)==1111621632?(m=f[a+24>>2]|0,(m|0)>-1):0)?(n=f[a+20>>2]|0,(n|0)>-1):0){o=f[a+4>>2]|0;if((m|0)==0|(n|0)==0){u=c;return}p=a+16|0;if(f[p>>2]|0){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,25)|0;i=224445;j=h+25|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-2,d,224471,806)}if(!o)q=Y(m,(k>>>3&511)+1<<(47696>>>(k<<1&14)&3))|0;else q=o;o=mJc(n|0,((n|0)<0)<<31>>31|0,q|0,0)|0;q=UIc(o|0,J|0,68,0)|0;if(!((q|0)==(q|0)&(J|0)==0)){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,27)|0;i=224484;j=h+27|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-4,d,224471,814)}o=h0(q)|0;f[a+8>>2]=o;f[p>>2]=o+4+63&-64;f[o>>2]=1;u=c;return}if((k|0)==112){o=a+68|0;if(f[o>>2]|0){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,25)|0;i=224445;j=h+25|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-2,d,224471,824)}p=f[132549]|0;if(!p){q=f[a+72>>2]|0;n=f[a+44>>2]|0;m=mJc(n|0,((n|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;q=f[a+64>>2]|0;if(!((q|0)==(m|0)&(((q|0)<0)<<31>>31|0)==(J|0))){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,22)|0;i=224512;j=h+22|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-4,d,224471,830)}m=h0(q)|0;f[a+108>>2]=m;f[o>>2]=m;u=c;return}else{m=a+16|0;o=f[m>>2]|0;q=a+40|0;n=f[q>>2]|0;switch(o|0){case 32:case 64:{r=Y((o|0)==32?4:8,n)|0;f[q>>2]=r;f[m>>2]=8;break}default:{}}Ti[p&511](a,0,0);f[q>>2]=n;f[m>>2]=o;u=c;return}}if((l|0)!=1111687168){f[d>>2]=0;e=d+4|0;f[e>>2]=0;g=tT(d,38)|0;h=g;i=224535;j=h+38|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-5,d,224471,885)}g=(k>>>3&511)+1<<(47696>>>(k<<1&14)&3);e=a+20|0;l=f[e>>2]|0;if(!l){u=c;return}o=a+16|0;if(f[o>>2]|0){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,25)|0;i=224445;j=h+25|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-2,d,224471,860)}if(!(k&16384)){k=f[a+4>>2]|0;if((k|0)>0){d=k;k=g;while(1){i=d;d=d+-1|0;h=Y(f[e+(d<<3)>>2]|0,f[e+(d<<3)+4>>2]|0)|0;j=k>>>0<h>>>0?h:k;if((i|0)<=1){s=j;break}else k=j}}else s=g}else{k=f[a+24>>2]|0;s=Y((k|0)==0?g:k,l)|0}l=h0(s+68|0)|0;f[a+8>>2]=l;f[o>>2]=l+4+63&-64;f[l>>2]=1;u=c;return}function x0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i;if(!a){f[j>>2]=0;f[j+4>>2]=0;t0(-27,j,224641,147)}if((d|c|0)<0){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,25)|0;l=224657;m=k+25|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-201,j,224641,153)}l=e&4095|1111621632;f[a>>2]=l;f[a+20>>2]=c;f[a+24>>2]=d;f[a+16>>2]=g;f[a+8>>2]=0;f[a+12>>2]=0;g=Y((e>>>3&511)+1<<(47696>>>(e<<1&14)&3),d)|0;if((h|0)<2147483647)switch(h|0){case 0:{n=g;break}default:o=6}else switch(h|0){case 2147483647:{n=g;break}default:o=6}if((o|0)==6)if((g|0)>(h|0)){f[j>>2]=0;f[j+4>>2]=0;t0(-13,j,224641,169)}else n=h;f[a+4>>2]=n;h=mJc(c|0,((c|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;j=J;f[a>>2]=l|((j|0)>0|(j|0)==0&h>>>0>2147483647?0:(n|0)==(g|0)|(c|0)==1?16384:0);u=i;return a|0}function y0(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;t0(-9,c,224683,190)}d=f[a>>2]|0;if(!d){u=b;return}e=f[d>>2]&-65536;a:do if((e|0)<1111687168){switch(e|0){case 1111621632:break;default:{g=7;break a}}if((f[d+24>>2]|0)>-1?(f[d+20>>2]|0)>-1:0){f[a>>2]=0;if(((f[d+24>>2]|0)>0?(f[d+20>>2]|0)>0:0)?(h=d+16|0,(f[h>>2]|0)!=0):0){f[h>>2]=0;h=d+8|0;i=f[h>>2]|0;if(i|0?(j=(f[i>>2]|0)+-1|0,f[i>>2]=j,(j|0)==0):0){i0(i);f[h>>2]=0}f[h>>2]=0;k=d}else k=d}else g=7}else{switch(e|0){case 1111687168:break;default:{g=7;break a}}f[a>>2]=0;h=d+16|0;if(!(f[h>>2]|0))k=d;else{f[h>>2]=0;h=d+8|0;i=f[h>>2]|0;if(i|0?(j=(f[i>>2]|0)+-1|0,f[i>>2]=j,(j|0)==0):0){i0(i);f[h>>2]=0}f[h>>2]=0;k=d}}while(0);if((g|0)==7){f[c>>2]=0;f[c+4>>2]=0;t0(-206,c,224683,197)}i0(k);u=b;return}function z0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if(((a|0?(e=f[a>>2]|0,(e&-65536|0)==1111621632):0)?(g=f[a+24>>2]|0,(g|0)>0):0)?(h=f[a+20>>2]|0,(h|0)>0):0){i=v0(h,g,e)|0;if(!(f[a+16>>2]|0)){u=c;return i|0}w0(i);r_(a,i,0);u=c;return i|0}f[d>>2]=0;f[d+4>>2]=0;i=tT(d,16)|0;c=224696;a=i+16|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(a|0));t0(-5,d,224713,212);return 0}function A0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+16|0;i=h;j=e&4095;k=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);if(!a){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,26)|0;m=224724;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-27,i,224751,238)}if(!k){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,23)|0;m=224769;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-210,i,224751,241)}if(!d){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,20)|0;m=224793;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-27,i,224751,244)}if((c+-1|0)>>>0>31){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,46)|0;m=224814;n=l+46|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-211,i,224751,248)}else{o=c;p=0;q=k}while(1){k=o;o=o+-1|0;e=d+(o<<2)|0;r=f[e>>2]|0;if((r|0)<0){s=11;break}f[a+20+(o<<3)>>2]=r;if((p|0)>0|(p|0)==0&q>>>0>2147483647){s=13;break}f[a+20+(o<<3)+4>>2]=q;r=f[e>>2]|0;q=mJc(r|0,((r|0)<0)<<31>>31|0,q|0,p|0)|0;p=J;if((k|0)<=1){s=9;break}}if((s|0)==9){f[a>>2]=((p|0)<0|(p|0)==0&q>>>0<2147483648?1111703552:1111687168)|j;f[a+4>>2]=c;f[a+16>>2]=g;f[a+8>>2]=0;f[a+12>>2]=0;u=h;return a|0}else if((s|0)==11){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,37)|0;m=224861;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-201,i,224751,253)}else if((s|0)==13){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,20)|0;m=224899;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-211,i,224751,256)}return 0}function B0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=C0(a,b,c)|0;w0(d);return d|0}function C0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;if((a+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,46)|0;i=224814;j=h+46|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-211,g,224920,287)}else{g=h0(276)|0;A0(g,a,c,d,0)|0;f[g+12>>2]=1;u=e;return g|0}return 0}function D0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+256|0;d=c+128|0;e=c+72|0;g=c+16|0;h=c;if(!a){f[d>>2]=0;i=d+4|0;f[i>>2]=0;j=tT(d,18)|0;k=j;l=224940;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-5,d,224959,302)}n=f[a>>2]|0;if((n&-65536|0)!=1111687168){f[d>>2]=0;i=d+4|0;f[i>>2]=0;j=tT(d,18)|0;k=j;l=224940;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-5,d,224959,302)}j=f[a+4>>2]|0;if((j|0)>=33){f[d>>2]=0;f[d+4>>2]=0;k=tT(d,23)|0;l=224972;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-215,d,224959,304)}if((j|0)>0){i=0;do{f[d+(i<<2)>>2]=f[a+20+(i<<3)>>2];i=i+1|0}while((i|0)!=(j|0))}i=C0(j,d,n)|0;if(!(f[a+16>>2]|0)){u=c;return i|0}w0(i);O4(e,a,0,1,0,0);O4(g,i,0,1,0,0);a=f[i+16>>2]|0;n=h+8|0;f[n>>2]=0;f[n+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;h_(e,h);n=g+16|0;if((f[n>>2]|0)!=(a|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,18)|0;l=224996;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-215,h,224959,319)}h=g+36|0;l=f[h>>2]|0;if(l|0?(k=l+12|0,l=f[k>>2]|0,f[k>>2]=l+-1,(l|0)==1):0)_S(g);f[h>>2]=0;h=g+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[h>>2]|0)>0){n=f[g+40>>2]|0;l=0;do{f[n+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))g0(h);h=e+36|0;g=f[h>>2]|0;if(g|0?(l=g+12|0,g=f[l>>2]|0,f[l>>2]=g+-1,(g|0)==1):0)_S(e);f[h>>2]=0;h=e+16|0;g=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[g>>2]|0)>0){h=f[e+40>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))g0(g);u=c;return i|0}function E0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;i=u;u=u+16|0;j=i+8|0;k=i;if((a+-1|0)>>>0>9){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,26)|0;m=225015;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-211,j,225042,394)}if(!((c|0)!=0&(e|0)!=0)){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,39)|0;m=225063;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-27,j,225042,397)}if(!g){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,24)|0;m=225103;n=l+24|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-27,j,225042,400)}if(d|0){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,35)|0;m=225128;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-5,j,225042,403)}d=h&255;o=(h&4|0)==0;h=0;p=-1;q=0;a:while(1){r=f[c+(q<<2)>>2]|0;if(!r){s=11;break}if((f[r>>2]&-65536|0)==1111687168?(f[r+16>>2]|0)!=0:0)t=r;else{f[j>>2]=0;v=F0(r,e+(q*276|0)|0,j)|0;if(f[j>>2]|0){s=15;break}t=v}v=g+184+(q<<2)|0;f[v>>2]=t;w=f[t+4>>2]|0;if((q|0)>0){if((w|0)!=(f[h+4>>2]|0)){s=19;break}switch(d&3){case 0:{if((f[h>>2]^f[t>>2])&4095|0){s=22;break a}break}case 1:{if((f[h>>2]^f[t>>2])&4088|0){s=24;break a}break}case 2:{if((f[h>>2]^f[t>>2])&4088|0){s=26;break a}break}default:{}}if(o&(w|0)>0){r=0;while(1){if((f[t+20+(r<<3)>>2]|0)!=(f[h+20+(r<<3)>>2]|0)){s=30;break a}r=r+1|0;if((r|0)>=(w|0)){x=h;break}}}else x=h}else x=t;r=f[t>>2]|0;y=(r>>>3&511)+1<<(47696>>>(r<<1&14)&3);r=w+-1|0;b:do if((r|0)>(p|0)){z=w;A=r;B=y;C=0;while(1){D=f[t+20+(A<<3)+4>>2]|0;if(!((B|0)==(D|0)&(C|0)==(((D|0)<0)<<31>>31|0))){E=z;F=A;G=C;H=B;break b}D=f[t+20+(A<<3)>>2]|0;I=mJc(D|0,((D|0)<0)<<31>>31|0,B|0,C|0)|0;D=J;K=A+-1|0;if((K|0)>(p|0)){L=A;A=K;B=I;C=D;z=L}else{E=A;F=K;G=D;H=I;break}}}else{E=w;F=r;G=0;H=y}while(0);y=(F|0)==(p|0)&((G|0)>0|(G|0)==0&H>>>0>2147483647)?E:F;p=(y|0)>(p|0)?y:p;f[v>>2]=t;f[g+16+(q<<2)>>2]=f[t+16>>2];q=q+1|0;if((q|0)>=(a|0)){s=35;break}else h=x}if((s|0)==11){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,39)|0;m=225063;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-27,j,225042,411)}else if((s|0)==15){f[k>>2]=0;f[k+4>>2]=0;l=tT(k,27)|0;m=225164;n=l+27|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-24,k,225042,420)}else if((s|0)==19){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,47)|0;m=225192;n=l+47|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-209,j,225042,429)}else if((s|0)==22){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,40)|0;m=225240;n=l+40|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-205,j,225042,436)}else if((s|0)==24){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,49)|0;m=225281;n=l+49|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-205,j,225042,441)}else if((s|0)==26){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,36)|0;m=225331;n=l+36|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-205,j,225042,446)}else if((s|0)==30){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,43)|0;m=225368;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t0(-209,j,225042,455)}else if((s|0)==35){s=w+-1|0;if((s|0)>(p|0)){w=1;j=s;do{w=Y(f[x+20+(j<<3)>>2]|0,w)|0;j=j+-1|0}while((j|0)>(p|0));M=w;N=1}else{M=1;N=1}w=p+1|0;f[g+4>>2]=w;f[g>>2]=a;a=g+8|0;f[a>>2]=M;f[a+4>>2]=N;if((p|0)<0){u=i;return w|0}else O=0;do{f[g+56+(O<<2)>>2]=f[x+20+(O<<3)>>2];O=O+1|0}while((O|0)!=(w|0));u=i;return w|0}return 0}function F0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+8|0;h=e;if(d|0)f[d>>2]=0;if(!((a|0)!=0&(c|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,28)|0;j=225412;k=i+28|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-27,g,225441,336)}l=f[a>>2]|0;if((l&-65536|0)==1111687168)if(!(f[a+16>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,32)|0;j=225452;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-27,g,225441,341)}else{m=a;u=e;return m|0}if((l|0)==112)n=G0(a,g,d,0)|0;else n=a;if(((n|0?(a=f[n>>2]|0,(a&-65536|0)==1111621632):0)?(d=n+24|0,(f[d>>2]|0)>0):0)?(g=n+20|0,(f[g>>2]|0)>0):0){l=f[n+16>>2]|0;if(!l){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,33)|0;j=225524;k=i+33|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-27,h,225441,356)}f[c+16>>2]=l;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=a;f[c+4>>2]=2;f[c+20>>2]=f[g>>2];f[c+24>>2]=f[n+4>>2];f[c+28>>2]=f[d>>2];f[c+32>>2]=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);m=c;u=e;return m|0}f[h>>2]=0;f[h+4>>2]=0;i=tT(h,38)|0;j=225485;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-5,h,225441,353);return 0}function G0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+16|0;h=g;if(!((a|0)!=0&(c|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,28)|0;j=225412;k=i+28|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-27,h,225558,2390)}l=f[a>>2]|0;m=l&-65536;if(((m|0)==1111621632?(f[a+24>>2]|0)>0:0)?(f[a+20>>2]|0)>0:0)if(!(f[a+16>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,32)|0;j=225452;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-27,h,225558,2395)}else{n=a;o=0}else p=8;do if((p|0)==8){if((l|0)!=112){if(!((e|0)!=0&(m|0)==1111687168)){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,38)|0;j=225485;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-206,h,225558,2492)}q=a+20|0;r=f[q>>2]|0;s=a+16|0;if(!(f[s>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,33)|0;j=225524;k=i+33|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-27,h,225558,2465)}if(!(l&16384)){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,44)|0;j=225761;k=i+44|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-5,h,225558,2468)}t=f[a+4>>2]|0;if((t|0)<=2)if((t|0)==1)v=1;else v=f[a+28>>2]|0;else{w=1;x=1;while(1){y=Y(f[q+(x<<3)>>2]|0,w)|0;x=x+1|0;if((x|0)==(t|0)){v=y;break}else w=y}}f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=f[s>>2];f[c+20>>2]=r;f[c+24>>2]=v;w=f[a>>2]|0;t=w&4095;f[c>>2]=t|1111638016;x=Y((w>>>3&511)+1<<(47696>>>(w<<1&14)&3),v)|0;w=(r|0)>1?x:0;f[c+4>>2]=w;x=mJc(w|0,((w|0)<0)<<31>>31|0,r|0,((r|0)<0)<<31>>31|0)|0;w=J;if(!((w|0)>0|(w|0)==0&x>>>0>2147483647)){n=c;o=0;break}f[c>>2]=t|1111621632;n=c;o=0;break}t=f[a+68>>2]|0;if(!t){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,31)|0;j=225567;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-27,h,225558,2405)}r=f[a+16>>2]|0;s=1125516576>>>((r>>>2&60)+(r>>31&20)|0);r=s&7;x=f[a+8>>2]|0;w=(x|0)>1?f[a+28>>2]|0:0;q=f[a+48>>2]|0;if(!q)if(!w){x0(c,f[a+44>>2]|0,f[a+40>>2]|0,r|(x<<3)+-8,t,f[a+72>>2]|0)|0;n=c;o=0;break}else{f[h>>2]=0;f[h+4>>2]=0;i=tT(h,40)|0;j=225720;k=i+40|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-206,h,225558,2451)}y=f[q>>2]|0;if((w|0)==1)if(!y){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,63)|0;j=225599;k=i+63|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-206,h,225558,2421)}else{w=t+(Y(f[a+64>>2]|0,y+-1|0)|0)|0;z=f[a+72>>2]|0;A=w+(Y(z,f[q+8>>2]|0)|0)|0;x0(c,f[q+16>>2]|0,f[q+12>>2]|0,r,A+(f[q+4>>2]<<(47696>>>(s<<1&14)&3))|0,z)|0;n=c;o=0;break}else{z=(x<<3)+-8|0;if((x|0)>512){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,56)|0;j=225663;k=i+56|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));t0(-15,h,225558,2437)}else{x=f[a+72>>2]|0;A=t+(Y(x,f[q+8>>2]|0)|0)|0;x0(c,f[q+16>>2]|0,f[q+12>>2]|0,r|z,A+(Y(f[q+4>>2]|0,(z>>>3&511)+1<<(47696>>>(s<<1&14)&3))|0)|0,x)|0;n=c;o=y;break}}}while(0);if(!d){u=g;return n|0}f[d>>2]=o;u=g;return n|0}function H0(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=f[a+4>>2]|0;if((b|0)<=0){c=0;return c|0}d=a+184|0;e=a+16|0;g=b;while(1){b=g;g=g+-1|0;if((f[a>>2]|0)>0){h=0;do{i=a+16+(h<<2)|0;f[i>>2]=(f[i>>2]|0)+(f[(f[a+184+(h<<2)>>2]|0)+20+(g<<3)+4>>2]|0);h=h+1|0}while((h|0)<(f[a>>2]|0))}h=a+56+(g<<2)|0;i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)>1){c=1;j=10;break}i=f[d>>2]|0;k=f[i+20+(g<<3)>>2]|0;l=f[a>>2]|0;if((l|0)>0?(m=0-k|0,n=(f[e>>2]|0)+(Y(f[i+20+(g<<3)+4>>2]|0,m)|0)|0,f[e>>2]=n,(l|0)!=1):0){n=1;do{i=a+16+(n<<2)|0;o=(f[i>>2]|0)+(Y(f[(f[a+184+(n<<2)>>2]|0)+20+(g<<3)+4>>2]|0,m)|0)|0;f[i>>2]=o;n=n+1|0}while((n|0)<(l|0))}f[h>>2]=k;if((b|0)<=1){c=0;j=10;break}}if((j|0)==10)return c|0;return 0}function I0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;h=d&4095;i=1212424721>>>(d<<2&28)&15;j=Y(i,(d>>>3&511)+1|0)|0;if(!j){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,23)|0;l=224769;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-210,g,225806,537)}if((a+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,24)|0;l=225824;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-211,g,225806,540)}if(!c){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,20)|0;l=224793;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-27,g,225806,543)}else n=0;while(1){if((f[c+(n<<2)>>2]|0)<1){o=9;break}n=n+1|0;if((n|0)>=(a|0)){o=10;break}}if((o|0)==9){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,37)|0;l=224861;m=k+37|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-201,g,225806,548)}else if((o|0)==10){o=a+-32|0;g=h0((((o|0)>0?o:0)<<2)+164|0)|0;f[g>>2]=h|1111752704;f[g+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=1;h=a<<2;dJc(g+36|0,c|0,h|0)|0;c=i+7&0-i;f[g+28>>2]=c;i=j+3+c&65532;f[g+32>>2]=i;c=G7(0,64,h+7+i&-8,c7(4096)|0)|0;f[g+16>>2]=c;f[g+24>>2]=1024;c=h0(4096)|0;f[g+20>>2]=c;XIc(c|0,0,4096)|0;u=e;return g|0}return 0}function J0(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;t0(-9,c,225849,581)}d=f[a>>2]|0;if(!d){u=b;return}if((f[d>>2]&-65536|0)!=1111752704){f[c>>2]=0;f[c+4>>2]=0;t0(-206,c,225849,588)}f[a>>2]=0;f[c>>2]=f[(f[d+16>>2]|0)+44>>2];f7(c);c=d+20|0;i0(f[c>>2]|0);f[c>>2]=0;i0(d);u=b;return}function K0(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(a|0?(e=f[a>>2]|0,(e&-65536|0)==1111752704):0){g=I0(f[a+4>>2]|0,a+36|0,e)|0;r_(a,g,0);u=c;return g|0}f[d>>2]=0;f[d+4>>2]=0;g=tT(d,27)|0;c=225868;a=g+27|0;do{b[g>>0]=b[c>>0]|0;g=g+1|0;c=c+1|0}while((g|0)<(a|0));t0(-5,d,225896,605);return 0}function L0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;if(a|0?(f[a>>2]&-65536|0)==1111752704:0){if(!c){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,21)|0;h=243284;i=g+21|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));t0(-27,e,225942,623)}f[c>>2]=a;j=c+4|0;f[j>>2]=0;k=f[a+24>>2]|0;if((k|0)<=0){l=0;m=0;n=c+8|0;f[n>>2]=l;u=d;return m|0}o=f[a+20>>2]|0;a=0;while(1){p=f[o+(a<<2)>>2]|0;if(p|0)break;q=a+1|0;if((q|0)<(k|0))a=q;else{l=q;m=0;r=11;break}}if((r|0)==11){n=c+8|0;f[n>>2]=l;u=d;return m|0}f[j>>2]=p;l=a;m=p;n=c+8|0;f[n>>2]=l;u=d;return m|0}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,28)|0;h=225913;i=g+28|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));t0(-5,e,225942,620);return 0}function M0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;if(a|0){e=f[a>>2]|0;g=e&-65536;a:do if((g|0)<1111687168){switch(g|0){case 1111621632:break;default:break a}if((f[a+24>>2]|0)>0?(f[a+20>>2]|0)>0:0){if((f[a+24>>2]|0)<=0){u=c;return}if((f[a+20>>2]|0)<=0){u=c;return}h=a+16|0;if(!(f[h>>2]|0)){u=c;return}f[h>>2]=0;h=a+8|0;i=f[h>>2]|0;if(i|0?(j=(f[i>>2]|0)+-1|0,f[i>>2]=j,(j|0)==0):0){i0(i);f[h>>2]=0}f[h>>2]=0;u=c;return}}else{switch(g|0){case 1111687168:break;default:break a}h=a+16|0;if(!(f[h>>2]|0)){u=c;return}f[h>>2]=0;h=a+8|0;i=f[h>>2]|0;if(i|0?(j=(f[i>>2]|0)+-1|0,f[i>>2]=j,(j|0)==0):0){i0(i);f[h>>2]=0}f[h>>2]=0;u=c;return}while(0);if((e|0)==112){e=f[132550]|0;if(!e){g=a+108|0;h=f[g>>2]|0;f[g>>2]=0;f[a+68>>2]=0;i0(h);u=c;return}else{mi[e&2047](a,2);u=c;return}}}f[d>>2]=0;f[d+4>>2]=0;c=tT(d,38)|0;a=224535;e=c+38|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));t0(-5,d,225966,1001)}function N0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+16|0;h=g;if(!a){f[h>>2]=0;i=h+4|0;f[i>>2]=0;j=tT(h,38)|0;k=j;l=224535;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-5,h,226002,1838)}n=f[a>>2]|0;o=n&-65536;if((((o|0)==1111621632?(p=f[a+24>>2]|0,(p|0)>0):0)?(q=f[a+20>>2]|0,(q|0)>0):0)?(r=f[a+16>>2]|0,r|0):0){if(!(p>>>0>d>>>0&q>>>0>c>>>0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,21)|0;l=225980;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-211,h,226002,1761)}if(e|0)f[e>>2]=n&4095;s=r+(Y(f[a+4>>2]|0,c)|0)+(Y((n>>>3&511)+1<<(47696>>>(n<<1&14)&3),d)|0)|0;u=g;return s|0}if((n|0)==112?(r=f[a+68>>2]|0,r|0):0){q=f[a+16>>2]|0;p=q>>>3&31;t=(f[a+28>>2]|0)==0;if(t)v=Y(f[a+8>>2]|0,p)|0;else v=p;p=f[a+48>>2]|0;do if(p){w=f[p+12>>2]|0;x=f[p+16>>2]|0;y=Y(f[a+72>>2]|0,f[p+8>>2]|0)|0;z=r+((Y(f[p+4>>2]|0,v)|0)+y)|0;if(!t){y=f[p>>2]|0;if(!y){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,45)|0;l=226010;m=k+45|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-24,h,226002,1792)}else{A=z+(Y(f[a+64>>2]|0,y+-1|0)|0)|0;B=x;C=w;break}}else{A=z;B=x;C=w}}else{A=r;B=f[a+44>>2]|0;C=f[a+40>>2]|0}while(0);if(!(C>>>0>d>>>0&B>>>0>c>>>0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,21)|0;l=225980;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-211,h,226002,1804)}B=A+((Y(f[a+72>>2]|0,c)|0)+(Y(v,d)|0))|0;if(!e){s=B;u=g;return s|0}v=(f[a+8>>2]|0)+-1|0;if(v>>>0>3){f[h>>2]=0;f[h+4>>2]=0;t0(-210,h,226002,1812)}f[e>>2]=1125516576>>>((q>>>2&60)+(q>>31&20)|0)&7|v<<3;s=B;u=g;return s|0}if((o|0)!=1111687168){if((o|0)!=1111752704){f[h>>2]=0;i=h+4|0;f[i>>2]=0;j=tT(h,38)|0;k=j;l=224535;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-5,h,226002,1838)}if((f[a+4>>2]|0)!=2){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,30)|0;l=226056;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-215,h,226002,1832)}f[h>>2]=c;f[h+4>>2]=d;s=O0(a,h,e,1,0)|0;u=g;return s|0}o=f[a+16>>2]|0;if(!o){f[h>>2]=0;i=h+4|0;f[i>>2]=0;j=tT(h,38)|0;k=j;l=224535;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-5,h,226002,1838)}if((f[a+4>>2]|0)!=2){f[h>>2]=0;D=h+4|0;f[D>>2]=0;E=tT(h,21)|0;k=E;l=225980;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-211,h,226002,1824)}if((f[a+20>>2]|0)>>>0<=c>>>0){f[h>>2]=0;D=h+4|0;f[D>>2]=0;E=tT(h,21)|0;k=E;l=225980;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-211,h,226002,1824)}if((f[a+28>>2]|0)>>>0<=d>>>0){f[h>>2]=0;D=h+4|0;f[D>>2]=0;E=tT(h,21)|0;k=E;l=225980;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-211,h,226002,1824)}h=o+(Y(f[a+24>>2]|0,c)|0)|0;c=h+(Y(f[a+32>>2]|0,d)|0)|0;if(!e){s=c;u=g;return s|0}f[e>>2]=n&4095;s=c;u=g;return s|0}function O0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+16|0;i=h;a:do if(!g){j=f[a+4>>2]|0;if((j|0)>0){k=0;l=0;while(1){m=f[c+(k<<2)>>2]|0;if(m>>>0>=(f[a+36+(k<<2)>>2]|0)>>>0)break;n=m+(Y(l,1540483477)|0)|0;k=k+1|0;if((k|0)>=(j|0)){o=n;break a}else l=n}f[i>>2]=0;f[i+4>>2]=0;l=tT(i,30)|0;j=226087;k=l+30|0;do{b[l>>0]=b[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(k|0));t0(-211,i,226118,657)}else o=0}else o=f[g>>2]|0;while(0);g=a+24|0;j=f[g>>2]|0;l=j+-1&o;k=o&2147483647;b:do if((e|0)>-2?(o=f[(f[a+20>>2]|0)+(l<<2)>>2]|0,(o|0)!=0):0){n=a+32|0;m=a+4|0;p=o;while(1){if((f[p>>2]|0)==(k|0)){o=p+(f[n>>2]|0)|0;q=f[m>>2]|0;c:do if((q|0)>0){r=0;while(1){if((f[c+(r<<2)>>2]|0)!=(f[o+(r<<2)>>2]|0)){s=r;break c}t=r+1|0;if((t|0)<(q|0))r=t;else{s=t;break}}}else s=0;while(0);if((s|0)==(q|0))break}o=f[p+4>>2]|0;if(!o){v=0;break b}else p=o}v=p+(f[a+28>>2]|0)|0}else v=0;while(0);if((e|0)!=0&(v|0)==0){s=a+16|0;m=f[s>>2]|0;if((f[m+60>>2]|0)<(j*3|0)){w=l;x=m}else{m=j<<1;j=(m|0)>1024?m:1024;m=j<<2;l=h0(m)|0;XIc(l|0,0,m|0)|0;m=L0(a,i)|0;if(m|0){n=i+4|0;o=i+8|0;r=j+-1|0;t=m;while(1){m=f[(f[n>>2]|0)+4>>2]|0;d:do if(!m){y=(f[o>>2]|0)+1|0;f[o>>2]=y;z=f[i>>2]|0;A=f[z+24>>2]|0;if((y|0)<(A|0)){B=f[z+20>>2]|0;z=y;while(1){C=f[B+(z<<2)>>2]|0;if(C|0)break;y=z+1|0;if((y|0)<(A|0))z=y;else{D=0;break d}}f[o>>2]=z;E=C;F=27}else D=0}else{E=m;F=27}while(0);if((F|0)==27){F=0;f[n>>2]=E;D=E}m=l+((f[t>>2]&r)<<2)|0;f[t+4>>2]=f[m>>2];f[m>>2]=t;if(!D)break;else t=D}}D=a+20|0;i0(f[D>>2]|0);f[D>>2]=l;f[g>>2]=j;w=j+2147483647&k;x=f[s>>2]|0}s=x+56|0;j=f[s>>2]|0;f[i>>2]=j;if(!j){H7(x,0,i)|0;G=f[i>>2]|0}else{f[s>>2]=f[j+4>>2];f[j>>2]=f[j>>2]&67108863;s=x+60|0;f[s>>2]=(f[s>>2]|0)+1;G=j}f[G>>2]=k;k=(f[a+20>>2]|0)+(w<<2)|0;f[G+4>>2]=f[k>>2];f[k>>2]=G;dJc(G+(f[a+32>>2]|0)|0,c|0,f[a+4>>2]<<2|0)|0;c=G+(f[a+28>>2]|0)|0;if((e|0)>0){e=f[a>>2]|0;XIc(c|0,0,(e>>>3&511)+1<<(47696>>>(e<<1&14)&3)|0)|0;H=c}else H=c}else H=v;if(!d){u=h;return H|0}f[d>>2]=f[a>>2]&4095;u=h;return H|0}function P0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if(a|0){e=f[a>>2]|0;g=e&-65536;a:do if((g|0)<1111687168){switch(g|0){case 1111621632:break;default:break a}if((f[a+24>>2]|0)>0?(f[a+20>>2]|0)>0:0)h=5}else if((g|0)<1111752704)switch(g|0){case 1111687168:{h=5;break a;break}default:break a}else switch(g|0){case 1111752704:{h=5;break a;break}default:break a}while(0);if((h|0)==5){i=e&4095;u=c;return i|0}if((e|0)==112?f[a+68>>2]|0:0){e=f[a+16>>2]|0;i=1125516576>>>((e>>>2&60)+(e>>31&20)|0)&7|(f[a+8>>2]<<3)+-8;u=c;return i|0}}f[d>>2]=0;f[d+4>>2]=0;i=tT(d,38)|0;c=224535;a=i+38|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(a|0));t0(-5,d,226132,1094);return 0}function Q0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;a:do if(a|0){g=f[a>>2]|0;h=g&-65536;if(((h|0)==1111621632?(i=a+24|0,(f[i>>2]|0)>0):0)?(j=f[a+20>>2]|0,(j|0)>0):0){if(!c){k=2;u=d;return k|0}f[c>>2]=j;f[c+4>>2]=f[i>>2];k=2;u=d;return k|0}if((g|0)==112?f[a+68>>2]|0:0){if(!c){k=2;u=d;return k|0}f[c>>2]=f[a+44>>2];f[c+4>>2]=f[a+40>>2];k=2;u=d;return k|0}if((h|0)>=1111752704){switch(h|0){case 1111752704:break;default:break a}g=f[a+4>>2]|0;if(!c){k=g;u=d;return k|0}dJc(c|0,a+36|0,g<<2|0)|0;k=g;u=d;return k|0}switch(h|0){case 1111687168:break;default:break a}h=f[a+4>>2]|0;if(!((c|0)!=0&(h|0)>0)){k=h;u=d;return k|0}g=a+20|0;i=0;do{f[c+(i<<2)>>2]=f[g+(i<<3)>>2];i=i+1|0}while((i|0)!=(h|0));k=h;u=d;return k|0}while(0);f[e>>2]=0;f[e+4>>2]=0;k=tT(e,38)|0;d=224535;c=k+38|0;do{b[k>>0]=b[d>>0]|0;k=k+1|0;d=d+1|0}while((k|0)<(c|0));t0(-5,e,226146,1148);return 0}function R0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=a;f[g>>2]=0;f[g+4>>2]=0;if(c|0){g=f[c>>2]|0;if(((g&-65536|0)==1111621632?(h=f[c+24>>2]|0,(h|0)>-1):0)?(i=f[c+20>>2]|0,(i|0)>-1):0){f[a>>2]=h;j=i;k=a+4|0;f[k>>2]=j;u=d;return}if((g|0)==112){g=f[c+48>>2]|0;i=(g|0)==0;f[a>>2]=f[(i?c+40|0:g+12|0)>>2];j=f[(i?c+44|0:g+16|0)>>2]|0;k=a+4|0;f[k>>2]=j;u=d;return}}f[e>>2]=0;f[e+4>>2]=0;d=tT(e,33)|0;j=226156;k=d+33|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));t0(-5,e,226190,1246)}function S0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+16|0;i=h;if(!c){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,23)|0;k=226200;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));t0(-27,i,226224,1887)}a:do if(a|0){m=f[a>>2]|0;n=m&-65536;b:do if((n|0)<1111687168){switch(n|0){case 1111621632:break;default:{o=16;break b}}if((f[a+24>>2]|0)>0){if(!((f[a+20>>2]|0)>0|(m|0)==112))break a}else o=16}else{if((n|0)>=1111752704){switch(n|0){case 1111752704:break;default:{o=16;break b}}p=O0(a,c,d,e,g)|0;u=h;return p|0}switch(n|0){case 1111687168:break;default:{o=16;break b}}q=f[a+16>>2]|0;if(!q)o=16;else{r=f[a+4>>2]|0;c:do if((r|0)>0){s=a+20|0;t=q;v=0;while(1){w=f[c+(v<<2)>>2]|0;if(w>>>0>=(f[s+(v<<3)>>2]|0)>>>0)break;x=t+(Y(f[s+(v<<3)+4>>2]|0,w)|0)|0;v=v+1|0;if((v|0)>=(r|0)){y=x;break c}else t=x}f[i>>2]=0;f[i+4>>2]=0;j=tT(i,21)|0;k=225980;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));t0(-211,i,226224,1901)}else y=q;while(0);if(!d){p=y;u=h;return p|0}f[d>>2]=m&4095;p=y;u=h;return p|0}}while(0);if((o|0)==16?(m|0)!=112:0)break;p=N0(a,f[c>>2]|0,f[c+4>>2]|0,d)|0;u=h;return p|0}while(0);f[i>>2]=0;f[i+4>>2]=0;j=tT(i,38)|0;k=224535;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));t0(-5,i,226224,1911);return 0}function T0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+16|0;h=g+8|0;i=g;if(!c){f[h>>2]=0;f[h+4>>2]=0;t0(-27,h,226311,2718)}if(((((a|0)!=0?(f[a>>2]&-65536|0)==1111621632:0)?(f[a+24>>2]|0)>0:0)?(f[a+20>>2]|0)>0:0)?(f[a+16>>2]|0)!=0:0)j=a;else k=8;do if((k|0)==8){f[h>>2]=0;l=G0(a,c,h,1)|0;if(!(f[h>>2]|0)){j=l;break}else{f[i>>2]=0;f[i+4>>2]=0;m=tT(i,20)|0;n=469779;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));t0(-24,i,226311,2725)}}while(0);if(d)if((d+-1|0)>>>0>3){f[h>>2]=0;f[h+4>>2]=0;t0(-15,h,226311,2731)}else p=d;else p=((f[j>>2]|0)>>>3&511)+1|0;if((j|0)!=(c|0)){d=c+12|0;i=f[d>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[c+8>>2]=0;f[d>>2]=i}i=f[j>>2]|0;d=Y((i>>>3&511)+1|0,f[j+24>>2]|0)|0;a=(e|0)==0;if((p|0)>(d|0))if(a)k=20;else{q=e;k=23}else if(a&((d|0)%(p|0)|0|0)!=0)k=20;else{r=e;k=21}if((k|0)==20){r=(Y(f[j+20>>2]|0,d)|0)/(p|0)|0;k=21}if((k|0)==21)if(!r){s=f[j+20>>2]|0;k=24}else{q=r;k=23}do if((k|0)==23){r=f[j+20>>2]|0;if((q|0)!=(r|0)){e=Y(r,d)|0;if(!(i&16384)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,72)|0;n=226321;o=m+72|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));t0(-13,h,226311,2756)}if(q>>>0>e>>>0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,22)|0;n=226394;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));t0(-211,h,226311,2759)}r=(e|0)/(q|0)|0;if((Y(r,q)|0)==(e|0)){f[c+20>>2]=q;t=r;v=Y(1212424721>>>(f[j>>2]<<2&28)&15,r)|0;break}else{f[h>>2]=0;f[h+4>>2]=0;m=tT(h,78)|0;n=226232;o=m+78|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));t0(-5,h,226311,2765)}}else{s=q;k=24}}while(0);if((k|0)==24){f[c+20>>2]=s;t=d;v=f[j+4>>2]|0}f[c+4>>2]=v;v=(t|0)/(p|0)|0;if((Y(v,p)|0)==(t|0)){f[c+24>>2]=v;v=f[j>>2]|0;f[c>>2]=v&7|(p<<3)+-8|v&-4096;u=g;return c|0}else{f[h>>2]=0;f[h+4>>2]=0;m=tT(h,62)|0;n=226417;o=m+62|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));t0(-15,h,226311,2775)}return 0}function U0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+16|0;j=i;if(!a){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,22)|0;l=226480;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-9,j,226503,2917)}f[a>>2]=112;k=a+4|0;m=k+108|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));n=e+-1|0;if(n>>>0<4){o=f[45608+(n<<3)+4>>2]|0;p=f[45608+(n<<3)>>2]|0}else{o=1154740;p=1154740}n=p;p=0;do{q=n+p|0;b[a+20+p>>0]=b[q>>0]|0;p=p+1|0}while((b[q>>0]|0)!=0&(p|0)<4);p=o;o=0;do{n=p+o|0;b[a+24+o>>0]=b[n>>0]|0;o=o+1|0}while((b[n>>0]|0)!=0&(o|0)<4);o=f[c>>2]|0;if((o|0)<0){f[j>>2]=0;r=j+4|0;f[r>>2]=0;s=tT(j,13)|0;k=s;l=226521;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-25,j,226503,2936)}p=f[c+4>>2]|0;if((p|0)<0){f[j>>2]=0;r=j+4|0;f[r>>2]=0;s=tT(j,13)|0;k=s;l=226521;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-25,j,226503,2936)}if((e|0)<0|(d|0)!=64&((d|0)!=32&((d|0)!=-2147483616&((d|0)!=-2147483632&((d|0)!=16&((d|0)!=-2147483640&((d|0)!=1&(d|0)!=8))))))){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,18)|0;l=226535;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-17,j,226503,2943)}if(g>>>0>1){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,16)|0;l=226554;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-20,j,226503,2945)}switch(h|0){case 4:case 8:break;default:{f[j>>2]=0;f[j+4>>2]=0;k=tT(j,15)|0;l=226571;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-21,j,226503,2948)}}f[a+40>>2]=o;f[a+44>>2]=p;s=f[a+48>>2]|0;if(s|0){f[s>>2]=0;f[s+8>>2]=0;f[s+4>>2]=0;f[s+12>>2]=o;f[s+16>>2]=p}s=(e|0)>1?e:1;f[a+8>>2]=s;f[a+16>>2]=d;f[a+36>>2]=h;e=h+-1+(((Y(Y(s,d&2147483647)|0,o)|0)+7|0)>>>3)&0-h;f[a+72>>2]=e;f[a+32>>2]=g;g=mJc(e|0,((e|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;f[a+64>>2]=g;if((g|0)==(g|0)&(((g|0)<0)<<31>>31|0)==(J|0)){u=i;return a|0}else{f[j>>2]=0;f[j+4>>2]=0;k=tT(j,22)|0;l=224512;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));t0(-4,j,226503,2970)}return 0}function V0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d+8|0;g=d;h=a;a=f[h>>2]|0;i=f[h+4>>2]|0;h=f[132548]|0;if(!h){j=h0(112)|0;k=g;f[k>>2]=a;f[k+4>>2]=i;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];U0(j,e,b,c,0,4)|0;l=j;w0(l);u=d;return l|0}j=c+-1|0;if(j>>>0<4){m=f[45608+(j<<3)+4>>2]|0;n=f[45608+(j<<3)>>2]|0}else{m=1154740;n=1154740}l=uj[h&0](c,0,b,n,m,0,0,4,a,i,0,0,0,0)|0;w0(l);u=d;return l|0}function W0(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;t0(-27,c,226605,3004)}c=f[a>>2]|0;if(!c){u=b;return}f[a>>2]=0;M0(c);a=f[132550]|0;if(!a){d=c+48|0;i0(f[d>>2]|0);f[d>>2]=0;i0(c);u=b;return}else{mi[a&2047](c,5);u=b;return}}function X0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;t0(-9,d,226620,3021)}e=b+8|0;g=f[e>>2]|0;if((((((g|0)>-1?(h=b+12|0,i=f[h>>2]|0,(i|0)>-1):0)?(j=f[b>>2]|0,k=f[a+40>>2]|0,(j|0)<(k|0)):0)?(l=b+4|0,m=f[l>>2]|0,n=f[a+44>>2]|0,(m|0)<(n|0)):0)?(o=j+g|0,(o|0)>=((g|0)>0|0)):0)?(g=m+i|0,(g|0)>=((i|0)>0|0)):0){i=(j|0)>0?j:0;f[b>>2]=i;b=(m|0)>0?m:0;f[l>>2]=b;l=((k|0)<(o|0)?k:o)-i|0;f[e>>2]=l;e=((n|0)<(g|0)?n:g)-b|0;f[h>>2]=e;h=a+48|0;a=f[h>>2]|0;if(a|0){f[a+4>>2]=i;f[a+8>>2]=b;f[a+12>>2]=l;f[a+16>>2]=e;u=c;return}a=f[132551]|0;if(!a){g=h0(20)|0;f[g>>2]=0;f[g+4>>2]=i;f[g+8>>2]=b;f[g+12>>2]=l;f[g+16>>2]=e;p=g}else p=_h[a&127](0,i,b,l,e)|0;f[h>>2]=p;u=c;return}f[d>>2]=0;f[d+4>>2]=0;dJc(tT(d,184)|0,226634,184)|0;t0(-215,d,226620,3027)}function Y0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;t0(-9,d,226819,3094)}if((f[a+8>>2]|0)>>>0<b>>>0){f[d>>2]=0;f[d+4>>2]=0;t0(-24,d,226819,3097)}d=a+48|0;e=f[d>>2]|0;g=(e|0)!=0;if(!((b|0)!=0|g)){u=c;return}if(g){f[e>>2]=b;u=c;return}e=f[a+40>>2]|0;g=f[a+44>>2]|0;a=f[132551]|0;if(!a){h=h0(20)|0;f[h>>2]=b;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=e;f[h+16>>2]=g;i=h}else i=_h[a&127](b,0,0,e,g)|0;f[d>>2]=i;u=c;return}function Z0(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;t0(-9,c,226833,3117)}c=f[a+48>>2]|0;if(!c){d=0;u=b;return d|0}d=f[c>>2]|0;u=b;return d|0}function _0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;e=d+4|0;f[e>>2]=0;g=tT(d,16)|0;h=g;i=226847;j=h+16|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-5,d,226864,3129)}if((f[a>>2]|0)!=112){f[d>>2]=0;e=d+4|0;f[e>>2]=0;g=tT(d,16)|0;h=g;i=226847;j=h+16|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));t0(-5,d,226864,3129)}d=f[132552]|0;if(d|0){k=_i[d&1023](a)|0;u=c;return k|0}d=h0(112)|0;h=d;i=a;j=h+108|0;do{f[h>>2]=f[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));f[d>>2]=112;f[d+108>>2]=0;i=d+68|0;f[i>>2]=0;h=d+48|0;f[h>>2]=0;j=f[a+48>>2]|0;if(j|0){g=f[j>>2]|0;e=f[j+4>>2]|0;l=f[j+8>>2]|0;m=f[j+12>>2]|0;n=f[j+16>>2]|0;j=f[132551]|0;if(!j){o=h0(20)|0;f[o>>2]=g;f[o+4>>2]=e;f[o+8>>2]=l;f[o+12>>2]=m;f[o+16>>2]=n;p=o}else p=_h[j&127](g,e,l,m,n)|0;f[h>>2]=p}p=a+68|0;if(!(f[p>>2]|0)){k=d;u=c;return k|0}h=f[a+64>>2]|0;w0(d);dJc(f[i>>2]|0,f[p>>2]|0,h|0)|0;k=d;u=c;return k|0}function $0(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;y0(c);u=a;return}function a1(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;f7(c);u=a;return}function b1(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;h1(c);u=a;return}function c1(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0;h=u;u=u+16|0;i=h;j=(e>>>3&511)+1|0;if(j>>>0>=5){f[i>>2]=0;f[i+4>>2]=0;k=tT(i,7)|0;b[k>>0]=b[226877]|0;b[k+1>>0]=b[226878]|0;b[k+2>>0]=b[226879]|0;b[k+3>>0]=b[226880]|0;b[k+4>>0]=b[226881]|0;b[k+5>>0]=b[226882]|0;b[k+6>>0]=b[226883]|0;t0(-215,i,226885,3241)}switch(e&7){case 0:{e=0;do{k=nrc(+p[a+(e<<3)>>3])|0;b[c+e>>0]=k>>>0<256?k:(k|0)>0?255:0;e=e+1|0}while((e|0)!=(j|0));if((j|0)<(g|0))l=j;else{u=h;return}do{b[c+l>>0]=b[c+(l-j)>>0]|0;l=l+1|0}while((l|0)!=(g|0));u=h;return}case 1:{l=0;do{e=nrc(+p[a+(l<<3)>>3])|0;b[c+l>>0]=(e+128|0)>>>0<256?e:(e|0)>0?127:128;l=l+1|0}while((l|0)!=(j|0));if((j|0)<(g|0))m=j;else{u=h;return}do{b[c+m>>0]=b[c+(m-j)>>0]|0;m=m+1|0}while((m|0)!=(g|0));u=h;return}case 2:{m=0;do{l=nrc(+p[a+(m<<3)>>3])|0;d[c+(m<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;m=m+1|0}while((m|0)!=(j|0));if((j|0)<(g|0))o=j;else{u=h;return}do{d[c+(o<<1)>>1]=d[c+(o-j<<1)>>1]|0;o=o+1|0}while((o|0)!=(g|0));u=h;return}case 3:{o=0;do{m=nrc(+p[a+(o<<3)>>3])|0;d[c+(o<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;o=o+1|0}while((o|0)!=(j|0));if((j|0)<(g|0))q=j;else{u=h;return}do{d[c+(q<<1)>>1]=d[c+(q-j<<1)>>1]|0;q=q+1|0}while((q|0)!=(g|0));u=h;return}case 4:{q=0;do{o=nrc(+p[a+(q<<3)>>3])|0;f[c+(q<<2)>>2]=o;q=q+1|0}while((q|0)!=(j|0));if((j|0)<(g|0))r=j;else{u=h;return}do{f[c+(r<<2)>>2]=f[c+(r-j<<2)>>2];r=r+1|0}while((r|0)!=(g|0));u=h;return}case 5:{r=0;do{n[c+(r<<2)>>2]=+p[a+(r<<3)>>3];r=r+1|0}while((r|0)!=(j|0));if((j|0)<(g|0))s=j;else{u=h;return}do{f[c+(s<<2)>>2]=f[c+(s-j<<2)>>2];s=s+1|0}while((s|0)!=(g|0));u=h;return}case 6:{s=0;do{p[c+(s<<3)>>3]=+p[a+(s<<3)>>3];s=s+1|0}while((s|0)!=(j|0));if((j|0)<(g|0))t=j;else{u=h;return}do{p[c+(t<<3)>>3]=+p[c+(t-j<<3)>>3];t=t+1|0}while((t|0)!=(g|0));u=h;return}default:{f[i>>2]=0;f[i+4>>2]=0;t0(-210,i,226885,3266)}}}function d1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;g=u;u=u+1152|0;h=g;i=g+44|0;j=g+40|0;k=g+28|0;l=g+16|0;m=g+4|0;f[j>>2]=0;n=d&3;o=(n|0)==2;p=d&4;q=(p|0)!=0;r=(n|0)!=0;n=r&(d&64|0)!=0;f[k>>2]=0;s=k+4|0;f[s>>2]=0;f[k+8>>2]=0;if(!q){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;t=Mpc(a)|0;if(t>>>0>4294967279)dEc(m);if(t>>>0<11){b[m+11>>0]=t;if(!t)v=m;else{w=m;x=7}}else{y=t+16&-16;z=VDc(y)|0;f[m>>2]=z;f[m+8>>2]=y|-2147483648;f[m+4>>2]=t;w=z;x=7}if((x|0)==7){dJc(w|0,a|0,t|0)|0;v=w}b[v+t>>0]=0;f[l>>2]=0;t=l+4|0;f[t>>2]=0;f[l+8>>2]=0;if((CEc(m,10,0)|0)==-1){v=DEc(m,63,-1)|0;w=b[m+11>>0]|0;z=w<<24>>24<0?f[m+4>>2]|0:w&255;gEc(i,m,0,v,m);w=f[t>>2]|0;y=l+8|0;if((w|0)==(f[y>>2]|0))e1(l,i);else{fEc(w,i);f[t>>2]=(f[t>>2]|0)+12}if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((v|0)!=-1?(w=v+1|0,w>>>0<z>>>0):0){v=i+11|0;A=w;while(1){w=CEc(m,38,A)|0;if((A+1|0)>>>0<z>>>0&((w|0)!=(A|0)|(w|0)==-1)){gEc(i,m,A,w-A|0,m);B=f[t>>2]|0;if((B|0)==(f[y>>2]|0))e1(l,i);else{fEc(B,i);f[t>>2]=(f[t>>2]|0)+12}if((b[v>>0]|0)<0)YDc(f[i>>2]|0)}if(w>>>0<z>>>0)A=w+1|0;else break}}}f1(k,f[l>>2]|0,f[t>>2]|0);A=f[l>>2]|0;if(A|0){z=f[t>>2]|0;if((z|0)==(A|0))C=A;else{v=z;while(1){z=v+-12|0;f[t>>2]=z;if((b[z+11>>0]|0)<0){YDc(f[z>>2]|0);D=f[t>>2]|0}else D=z;if((D|0)==(A|0))break;else v=D}C=f[l>>2]|0}YDc(C)}if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);m=f[k>>2]|0;C=f[s>>2]|0;D=(m|0)==(C|0);v=C;A=m;do if(!D)if((b[m+11>>0]|0)<0){E=f[m>>2]|0;break}else{E=m;break}else E=a;while(0);if(n){F=1;G=E}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=6;b[i>>0]=b[226901]|0;b[i+1>>0]=b[226902]|0;b[i+2>>0]=b[226903]|0;b[i+3>>0]=b[226904]|0;b[i+4>>0]=b[226905]|0;b[i+5>>0]=b[226906]|0;b[i+6>>0]=0;if(((v-A|0)/12|0)>>>0<2)H=0;else{a:do if(D)I=m;else{A=f[i>>2]&255;v=m;while(1){t=b[v+11>>0]|0;z=t<<24>>24<0;y=t&255;do if(((z?f[v+4>>2]|0:y)|0)==6){t=f[v>>2]|0;if(z)if(!(Arc(t,i,6)|0)){I=v;break a}else break;if((t&255)<<24>>24==A<<24>>24){t=v;w=y;B=i;do{w=w+-1|0;t=t+1|0;if(!w){I=v;break a}B=B+1|0}while((b[t>>0]|0)==(b[B>>0]|0))}}while(0);v=v+12|0;if((v|0)==(C|0)){I=C;break}}}while(0);H=(I|0)!=(C|0)}F=H&r;G=E}}else{F=n;G=a}a=(G|0)!=0;if(a?(b[G>>0]|0)!=0:0){J=q;K=Mpc(G)|0}else if(r){J=1;K=0}else{f[i>>2]=0;f[i+4>>2]=0;n=p>>>1|20;p=tT(i,n)|0;dJc(p|0,(q?226908:226931)|0,n|0)|0;g1(-27,i,226952,98)}if(o&J){f[i>>2]=0;f[i+4>>2]=0;L=tT(i,68)|0;M=226970;N=L+68|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-206,i,226952,105)}n=h0(304)|0;f[j>>2]=n;if(!n){f[i>>2]=0;f[i+4>>2]=0;q=tT(i,2)|0;b[q>>0]=102;b[q+1>>0]=115;g1(-215,i,226952,108)}XIc(n|0,0,304)|0;n=c7(262144)|0;q=f[j>>2]|0;f[q+16>>2]=n;f[q+20>>2]=(c|0)==0?n:c;f[q>>2]=1280131417;f[q+8>>2]=r&1;b:do if(!J){r=j7(n,K+1|0)|0;f[(f[j>>2]|0)+60>>2]=r;kqc(r,G)|0;r=f[j>>2]|0;c=f[r+60>>2]|0;p=Crc(c,46)|0;do if((p|0?(b[p+1>>0]|0)==103:0)?(b[p+2>>0]|0)==122:0){E=p+3|0;H=b[E>>0]|0;C=H<<24>>24==0;if(!C){if((H+-48&255)>=10)break;if(b[p+4>>0]|0)break}if(o){h1(j);f[i>>2]=0;f[i+4>>2]=0;L=tT(i,52)|0;M=227039;N=L+52|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-213,i,226952,131)}if(C){O=0;P=K;Q=r;R=c}else{b[E>>0]=0;I=f[j>>2]|0;O=H;P=K+-1|0;Q=I;R=f[I+60>>2]|0}b[i>>0]=f[Q+8>>2]|0?119:114;b[i+1>>0]=98;b[i+2>>0]=O<<24>>24?O:51;b[i+3>>0]=0;I=rnc(R,i)|0;m=f[j>>2]|0;f[m+68>>2]=I;if(!I){S=m;break b}else{T=1;U=P;V=m;x=74;break b}}while(0);p=yqc(c,(f[r+8>>2]|0)==0?227099:o?227092:227096)|0;m=f[j>>2]|0;f[m+64>>2]=p;if(!p)S=m;else{T=0;U=K;V=m;x=74}}else{T=0;U=K;V=q;x=74}while(0);if((x|0)==74){f[V+32>>2]=0;f[V+40>>2]=0;f[V+44>>2]=0;f[V+84>>2]=71;if(!(f[V+8>>2]|0)){if(J){f[V+256>>2]=G;f[V+260>>2]=U}H8(V,i,14)|0;if((b[i>>0]|0)==-17?(b[i+1>>0]|0)==-69:0)W=(b[i+2>>0]|0)==-65?i+3|0:i;else W=i;U=W-i|0;do if(Wqc(W,247101,5)|0){if((b[W>>0]|0)==123){X=24;Y=f[j>>2]|0;break}q=(Wqc(W,243489,5)|0)==0;K=f[j>>2]|0;if(!q)if((f[K+260>>2]|0)==(U|0)){f[l>>2]=0;f[l+4>>2]=0;L=tT(l,19)|0;M=227441;N=L+19|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-49,l,226952,388)}else{f[l>>2]=0;f[l+4>>2]=0;L=tT(l,31)|0;M=227461;N=L+31|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-49,l,226952,390)}else{X=8;Y=K}}else{X=16;Y=f[j>>2]|0}while(0);f[Y+4>>2]=X;if(T){Z=1048576;_=Y}else{if(J){$=f[Y+260>>2]|0;aa=Y}else{Gqc(f[Y+64>>2]|0,0,2)|0;Y=Tpc(f[(f[j>>2]|0)+64>>2]|0)|0;$=Y;aa=f[j>>2]|0}Y=$>>>0<1048576?$:1048576;Z=Y>>>0>9216?Y:9216;_=aa}K8(_);_=f[j>>2]|0;f[_+264>>2]=U;U=L8(0,72,16,f[_+16>>2]|0,256)|0;_=f[j>>2]|0;f[_+28>>2]=U;U=m7(0,56,16,f[_+16>>2]|0)|0;f[(f[j>>2]|0)+32>>2]=U;U=h0(Z+256|0)|0;_=f[j>>2]|0;f[_+76>>2]=U;f[_+72>>2]=U;f[_+80>>2]=U+Z;b[U>>0]=10;b[(f[(f[j>>2]|0)+72>>2]|0)+1>>0]=0;U=f[j>>2]|0;switch(f[U+4>>2]|0){case 8:{W7(U);break}case 16:{b9(U);break}case 24:{j8(U);break}default:{}}i0(f[(f[j>>2]|0)+76>>2]|0);U=f[j>>2]|0;f[U+76>>2]=0;f[U+80>>2]=0;f[U+72>>2]=0;ba=U}else{U=d&56;if(J){J=VDc(24)|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;f[J+16>>2]=0;f[J+20>>2]=0;f[V+268>>2]=J}c:do if((U|0)==0&a){J=G;V=0;d=0;d:while(1){switch(b[J>>0]|0){case 0:{break d;break}case 46:{ca=d;da=J;break}default:{ca=V;da=d}}J=J+1|0;V=ca;d=da}if((((d|0)!=0?(Mpc(d)|0)==3:0)?(J=Jqc(b[d>>0]|0)|0,(J|0)==(Jqc(46)|0)):0)?(J=Jqc(b[d+1>>0]|0)|0,(J|0)==(Jqc(103)|0)):0){J=Jqc(b[d+2>>0]|0)|0;K=(J|0)==(Jqc(122)|0);ea=K?1:0}else ea=0;K=(V|0)!=0&ea?V:d;if(K){if(((((Mpc(K)|0)==4?(J=Jqc(b[K>>0]|0)|0,(J|0)==(Jqc(46)|0)):0)?(J=Jqc(b[K+1>>0]|0)|0,(J|0)==(Jqc(120)|0)):0)?(J=Jqc(b[K+2>>0]|0)|0,(J|0)==(Jqc(109)|0)):0)?(J=Jqc(b[K+3>>0]|0)|0,(J|0)==(Jqc(108)|0)):0){fa=8;break}do if(((((Mpc(K)|0)==7?(J=Jqc(b[K>>0]|0)|0,(J|0)==(Jqc(46)|0)):0)?(J=Jqc(b[K+1>>0]|0)|0,(J|0)==(Jqc(120)|0)):0)?(J=Jqc(b[K+2>>0]|0)|0,(J|0)==(Jqc(109)|0)):0)?(J=Jqc(b[K+3>>0]|0)|0,(J|0)==(Jqc(108)|0)):0){J=Jqc(b[K+4>>0]|0)|0;if((J|0)!=(Jqc(46)|0))break;J=Jqc(b[K+5>>0]|0)|0;if((J|0)!=(Jqc(103)|0))break;J=Jqc(b[K+6>>0]|0)|0;if((J|0)==(Jqc(122)|0)){fa=8;break c}}while(0);do if((((Mpc(K)|0)==5?(d=Jqc(b[K>>0]|0)|0,(d|0)==(Jqc(46)|0)):0)?(d=Jqc(b[K+1>>0]|0)|0,(d|0)==(Jqc(106)|0)):0)?(d=Jqc(b[K+2>>0]|0)|0,(d|0)==(Jqc(115)|0)):0){d=Jqc(b[K+3>>0]|0)|0;if((d|0)!=(Jqc(111)|0))break;d=Jqc(b[K+4>>0]|0)|0;if((d|0)==(Jqc(110)|0)){fa=24;break c}}while(0);if((((Mpc(K)|0)==8?(d=Jqc(b[K>>0]|0)|0,(d|0)==(Jqc(46)|0)):0)?(d=Jqc(b[K+1>>0]|0)|0,(d|0)==(Jqc(106)|0)):0)?(d=Jqc(b[K+2>>0]|0)|0,(d|0)==(Jqc(115)|0)):0){d=Jqc(b[K+3>>0]|0)|0;if((d|0)!=(Jqc(111)|0)){fa=16;break}d=Jqc(b[K+4>>0]|0)|0;if((d|0)!=(Jqc(110)|0)){fa=16;break}d=Jqc(b[K+5>>0]|0)|0;if((d|0)!=(Jqc(46)|0)){fa=16;break}d=Jqc(b[K+6>>0]|0)|0;if((d|0)!=(Jqc(103)|0)){fa=16;break}d=Jqc(b[K+7>>0]|0)|0;V=(d|0)==(Jqc(122)|0);fa=V?24:16}else fa=16}else fa=16}else fa=U|0?U:8;while(0);U=f[j>>2]|0;f[U+4>>2]=fa;ea=(fa|0)==8?25600:17408;if(o){Gqc(f[U+64>>2]|0,0,2)|0;o=(Tpc(f[(f[j>>2]|0)+64>>2]|0)|0)!=0;da=f[j>>2]|0;ga=o;ha=f[da+4>>2]|0;ia=da}else{ga=0;ha=fa;ia=U}U=m7(0,56,(ha|0)==8?24:4,f[ia+16>>2]|0)|0;ia=f[j>>2]|0;f[ia+36>>2]=U;f[ia+12>>2]=1;f[ia+40>>2]=0;f[ia+44>>2]=32;ia=h0(ea+1024|0)|0;U=f[j>>2]|0;f[U+72>>2]=ia;f[U+76>>2]=ia;f[U+80>>2]=ia+ea;f[U+272>>2]=0;b[U+276>>0]=F&1;f[U+280>>2]=0;b[U+284>>0]=0;f[U+288>>2]=0;f[U+292>>2]=0;f[U+296>>2]=0;switch(f[U+4>>2]|0){case 8:{F=f[U+64>>2]|0;if(!F){ja=U;ka=0}else{ea=Tpc(F)|0;ja=f[j>>2]|0;ka=ea}ea=e7(f[ja+16>>2]|0)|0;ja=f[j>>2]|0;f[ja+24>>2]=ea;do if(!((ka|0)==0|ga^1)){ea=(ka|0)<1024?ka:1024;Gqc(f[ja+64>>2]|0,0-ea|0,2)|0;F=h0(ea+2|0)|0;ia=-1;e:while(1){while(1){la=Tpc(f[(f[j>>2]|0)+64>>2]|0)|0;ma=H8(f[j>>2]|0,F,ea)|0;if(!ma)break e;ha=Erc(ma,227283)|0;if(ha|0){na=ha;break}}while(1){H=Erc(na+17|0,227283)|0;if(!H)break;else na=H}ia=la-ma+na|0}i0(F);if((ia|0)<0){h1(j);f[i>>2]=0;f[i+4>>2]=0;L=tT(i,53)|0;M=227301;N=L+53|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-2,i,226952,287)}J8(f[j>>2]|0);F=yqc(f[(f[j>>2]|0)+60>>2]|0,227355)|0;f[(f[j>>2]|0)+64>>2]=F;if(!F){f[i>>2]=0;f[i+4>>2]=0;ea=tT(i,8)|0;K=ea;b[K>>0]=102;b[K+1>>0]=115;b[K+2>>0]=45;b[K+3>>0]=62;K=ea+4|0;b[K>>0]=102;b[K+1>>0]=105;b[K+2>>0]=108;b[K+3>>0]=101;g1(-215,i,226952,291)}else{Gqc(F,ia,0)|0;D8(f[j>>2]|0,227359);Gqc(f[(f[j>>2]|0)+64>>2]|0,0,2)|0;D8(f[j>>2]|0,502002);break}}else{do if(e){if(!(Ioc(e,227102)|0)){h1(j);f[i>>2]=0;oa=i+4|0;f[oa>>2]=0;pa=tT(i,57)|0;L=pa;M=227123;N=L+57|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-5,i,226952,246)}if(!(Ioc(e,227109)|0)){h1(j);f[i>>2]=0;oa=i+4|0;f[oa>>2]=0;pa=tT(i,57)|0;L=pa;M=227123;N=L+57|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-5,i,226952,246)}if(!(Ioc(e,227116)|0)){h1(j);f[i>>2]=0;oa=i+4|0;f[oa>>2]=0;pa=tT(i,57)|0;L=pa;M=227123;N=L+57|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-5,i,226952,246)}if((Mpc(e)|0)>>>0<1e3){f[h>>2]=e;Aqc(i,227205,h)|0;D8(f[j>>2]|0,i);break}else{f[i>>2]=0;f[i+4>>2]=0;L=tT(i,23)|0;M=227181;N=L+23|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-215,i,226952,249)}}else D8(ja,227242);while(0);D8(f[j>>2]|0,227265)}while(0);qa=f[j>>2]|0;ra=339;sa=25;ta=267;ua=340;va=1707;wa=1708;xa=266;break}case 16:{if(ga)D8(U,227392);else D8(U,227377);qa=f[j>>2]|0;ra=341;sa=26;ta=269;ua=342;va=1709;wa=1710;xa=268;break}default:{do if(ga){if(!(Gqc(f[U+64>>2]|0,0,2)|0))ya=0;else{f[i>>2]=0;za=i+4|0;f[za>>2]=0;Aa=tT(i,39)|0;L=Aa;M=227401;N=L+39|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-2,i,226952,351)}while(1){if((Noc(f[(f[j>>2]|0)+64>>2]|0)|0)==125)break;ja=ya+-1|0;if(!(Gqc(f[(f[j>>2]|0)+64>>2]|0,ja,2)|0))ya=ja;else{x=139;break}}if((x|0)==139){f[i>>2]=0;za=i+4|0;f[za>>2]=0;Aa=tT(i,39)|0;L=Aa;M=227401;N=L+39|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));g1(-2,i,226952,351)}Gqc(f[(f[j>>2]|0)+64>>2]|0,ya,2)|0;J8(f[j>>2]|0);ja=yqc(f[(f[j>>2]|0)+60>>2]|0,227355)|0;f[(f[j>>2]|0)+64>>2]=ja;if(!ja){f[i>>2]=0;f[i+4>>2]=0;h=tT(i,8)|0;e=h;b[e>>0]=102;b[e+1>>0]=115;b[e+2>>0]=45;b[e+3>>0]=62;e=h+4|0;b[e>>0]=102;b[e+1>>0]=105;b[e+2>>0]=108;b[e+3>>0]=101;g1(-215,i,226952,345)}else{Gqc(ja,ya,2)|0;sqc(44,f[(f[j>>2]|0)+64>>2]|0)|0;break}}else D8(U,481302);while(0);U=f[j>>2]|0;f[U+40>>2]=4;qa=U;ra=343;sa=27;ta=271;ua=344;va=1711;wa=1712;xa=270}}f[qa+228>>2]=xa;f[qa+232>>2]=va;f[qa+236>>2]=ra;f[qa+240>>2]=sa;f[qa+244>>2]=ta;f[qa+248>>2]=ua;f[qa+252>>2]=wa;ba=qa}b[ba+300>>0]=1;S=ba}f:do if(!S)Ba=0;else{do if((j6()|0)>=0){ba=f[j>>2]|0;if((((f[ba+64>>2]|0)==0?(f[ba+68>>2]|0)==0:0)?(f[ba+268>>2]|0)==0:0)?(f[ba+256>>2]|0)==0:0)break;if(f[ba+8>>2]|0){Ba=ba;break f}J8(ba);ba=f[j>>2]|0;b[ba+300>>0]=1;Ba=ba;break f}while(0);h1(j);Ba=f[j>>2]|0}while(0);j=f[k>>2]|0;if(!j){u=g;return Ba|0}S=f[s>>2]|0;if((S|0)==(j|0))Ca=j;else{ba=S;while(1){S=ba+-12|0;f[s>>2]=S;if((b[S+11>>0]|0)<0){YDc(f[S>>2]|0);Da=f[s>>2]|0}else Da=S;if((Da|0)==(j|0))break;else ba=Da}Ca=f[k>>2]|0}YDc(Ca);u=g;return Ba|0}function e1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[a>>2]|0;g=((f[d>>2]|0)-e|0)/12|0;h=g+1|0;if(h>>>0>357913941)mCc(a);i=a+8|0;j=((f[i>>2]|0)-e|0)/12|0;e=j<<1;k=j>>>0<178956970?(e>>>0<h>>>0?h:e):357913941;do if(k)if(k>>>0>357913941){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{l=VDc(k*12|0)|0;break}else l=0;while(0);e=l+(g*12|0)|0;g=e;h=l+(k*12|0)|0;fEc(e,c);c=e+12|0;k=f[a>>2]|0;l=f[d>>2]|0;if((l|0)==(k|0)){m=g;n=k;o=k}else{j=l;l=g;g=e;do{j=j+-12|0;fEc(g+-12|0,j);g=l+-12|0;l=g}while((j|0)!=(k|0));m=l;n=f[a>>2]|0;o=f[d>>2]|0}f[a>>2]=m;f[d>>2]=c;f[i>>2]=h;h=n;if((o|0)!=(h|0)){i=o;do{i=i+-12|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0)}while((i|0)!=(h|0))}if(!n)return;YDc(n);return}function f1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=(d-c|0)/12|0;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=i;if(e>>>0<=((h-i|0)/12|0)>>>0){k=a+4|0;l=((f[k>>2]|0)-i|0)/12|0;m=e>>>0>l>>>0;n=c+(l*12|0)|0;l=m?n:d;if((l|0)==(c|0))o=j;else{p=c;q=j;while(1){iEc(q,p)|0;p=p+12|0;r=q+12|0;if((p|0)==(l|0)){o=r;break}else q=r}}if(m){if((l|0)==(d|0))return;l=n;n=f[k>>2]|0;do{fEc(n,l);l=l+12|0;n=(f[k>>2]|0)+12|0;f[k>>2]=n}while((l|0)!=(d|0));return}l=f[k>>2]|0;if((l|0)==(o|0))return;else s=l;while(1){l=s+-12|0;f[k>>2]=l;if((b[l+11>>0]|0)<0){YDc(f[l>>2]|0);t=f[k>>2]|0}else t=l;if((t|0)==(o|0))break;else s=t}return}if(!i)u=h;else{h=a+4|0;t=f[h>>2]|0;if((t|0)==(j|0))v=i;else{i=t;while(1){t=i+-12|0;f[h>>2]=t;if((b[t+11>>0]|0)<0){YDc(f[t>>2]|0);w=f[h>>2]|0}else w=t;if((w|0)==(j|0))break;else i=w}v=f[a>>2]|0}YDc(v);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;u=0}if(e>>>0>357913941)mCc(a);h=(u|0)/12|0;u=h<<1;v=h>>>0<178956970?(u>>>0<e>>>0?e:u):357913941;if(v>>>0>357913941)mCc(a);u=VDc(v*12|0)|0;e=a+4|0;f[e>>2]=u;f[a>>2]=u;f[g>>2]=u+(v*12|0);if((c|0)==(d|0))return;v=c;c=u;do{fEc(c,v);v=v+12|0;c=(f[e>>2]|0)+12|0;f[e>>2]=c}while((v|0)!=(d|0));return}function g1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,227514,d);return}function h1(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,35)|0;g=246544;h=e+35|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));g1(-27,d,227493,469)}d=f[a>>2]|0;if(!d){u=c;return}f[a>>2]=0;Q8(d,0);f7(d+24|0);a=d+76|0;i0(f[a>>2]|0);f[a>>2]=0;f7(d+16|0);a=f[d+268>>2]|0;if(a|0){g=a+4|0;e=f[g>>2]|0;h=a+16|0;i=f[h>>2]|0;j=e+(i>>>12<<2)|0;k=a+8|0;l=f[k>>2]|0;m=l;n=e;if((l|0)==(e|0)){o=0;p=a+20|0;q=0}else{l=a+20|0;r=(f[l>>2]|0)+i|0;o=(f[e+(r>>>12<<2)>>2]|0)+(r&4095)|0;p=l;q=(f[j>>2]|0)+(i&4095)|0}i=j;j=q;a:while(1){q=j;do{l=q;if((l|0)==(o|0))break a;q=l+1|0}while((q-(f[i>>2]|0)|0)!=4096);q=i+4|0;i=q;j=f[q>>2]|0}f[p>>2]=0;p=m-n>>2;if(p>>>0>2){n=e;do{YDc(f[n>>2]|0);n=(f[g>>2]|0)+4|0;f[g>>2]=n;e=(f[k>>2]|0)-n>>2}while(e>>>0>2);s=e}else s=p;switch(s|0){case 1:{t=2048;v=17;break}case 2:{t=4096;v=17;break}default:{}}if((v|0)==17)f[h>>2]=t;t=f[g>>2]|0;h=f[k>>2]|0;if((t|0)!=(h|0)){v=t;do{YDc(f[v>>2]|0);v=v+4|0}while((v|0)!=(h|0));h=f[g>>2]|0;g=f[k>>2]|0;if((g|0)!=(h|0))f[k>>2]=g+(~((g+-4-h|0)>>>2)<<2)}h=f[a>>2]|0;if(h|0)YDc(h);YDc(a)}a=f[d+272>>2]|0;if(a|0){d4(a);YDc(a)}a=f[d+288>>2]|0;if(a|0)ZDc(a);a=f[d+296>>2]|0;if(a|0)ZDc(a);XIc(d|0,0,304)|0;i0(d);u=c;return}function i1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;g=u;u=u+80|0;h=g+76|0;i=g+40|0;j=g+8|0;k=g;f[h>>2]=0;C_(i,d1(a,c,0,0)|0,1);if(!(w_(i)|0)){l=0;t_(i);u=g;return l|0}a=i+8|0;m=f[a>>2]|0;a:do if(!d){n=f[m+32>>2]|0;if((f[n+24>>2]|0)<=0){f[j>>2]=0;o=j+4|0;f[o>>2]=0;p=tT(j,44)|0;q=p;r=227606;s=q+44|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));g1(-204,j,227599,544)}t=j+12|0;v=j+20|0;w=0;x=n;b:while(1){y=o7(x,w)|0;if(!y){z=7;break}c:do if((f[y>>2]&7|0)==6){A=f[y+8>>2]|0;r7(A,j,0);B=A+24|0;C=f[B>>2]|0;if((C|0)>0){D=A+28|0;A=0;E=C;while(1){F=f[t>>2]|0;if((f[F>>2]|0)>-1)break;C=F+(f[D>>2]|0)|0;f[t>>2]=C;if(C>>>0<(f[v>>2]|0)>>>0)G=E;else{z7(j,1);G=f[B>>2]|0}A=A+1|0;if((A|0)>=(G|0)){H=0;I=0;break c}else E=G}H=10;I=F}else{H=0;I=0}}else{H=1;I=y}while(0);switch(H&15){case 10:{J=I;break a;break}case 0:break;default:break b}w=w+1|0;x=f[(f[a>>2]|0)+32>>2]|0;if((w|0)>=(f[x+24>>2]|0)){J=I;break a}}if((z|0)==7){f[k>>2]=0;f[k+4>>2]=0;q=tT(k,12)|0;r=227586;s=q+12|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));g1(-215,k,227599,519)}if(!H)J=I;else{l=0;t_(i);u=g;return l|0}}else J=j1(m,0,d)|0;while(0);if(!J){f[j>>2]=0;o=j+4|0;f[o>>2]=0;p=tT(j,44)|0;q=p;r=227606;s=q+44|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));g1(-204,j,227599,544)}if(!(f[J>>2]&64))K=0;else K=f[(f[J+16>>2]|0)+8>>2]|0;p=k1(f[a>>2]|0,J,0)|0;f[h>>2]=p;if(!((c|0)!=0|(p|0)==0)){if((f[p>>2]&-65536|0)==1117323264){f[j>>2]=0;L=j+4|0;f[L>>2]=0;M=tT(j,78)|0;q=M;r=227651;s=q+78|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));g1(-27,j,227599,552)}if((f[p>>2]&-65536|0)==1117257728){f[j>>2]=0;L=j+4|0;f[L>>2]=0;M=tT(j,78)|0;q=M;r=227651;s=q+78|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));g1(-27,j,227599,552)}}if((j6()|0)<0){l1(h);N=0}else N=K;do if(e|0)if(!N){f[e>>2]=0;break}else{K=h0(Mpc(N)|0)|0;f[e>>2]=K;dJc(K|0,N|0,Mpc(N)|0)|0;break}while(0);l=f[h>>2]|0;t_(i);u=g;return l|0}function j1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;if(!a){h=0;u=e;return h|0}if((f[a>>2]|0)!=1280131417){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,31)|0;j=231878;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(-5,g,227858,727)}if(!d){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,17)|0;j=227878;k=i+17|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(-27,g,227858,730)}l=b[d>>0]|0;if(!(l<<24>>24)){m=0;n=0}else{o=0;p=0;q=l;while(1){l=(q&255)+(o*33|0)|0;r=p+1|0;q=b[d+r>>0]|0;if(!(q<<24>>24)){m=l;n=r;break}else{o=l;p=r}}}p=m&2147483647;a:do if(!c){m=f[a+32>>2]|0;if(!m){h=0;u=e;return h|0}o=f[m+24>>2]|0;if((o|0)<=0){h=0;u=e;return h|0}m=a+32|0;q=0;b:while(1){s=o7(f[m>>2]|0,q)|0;switch(f[s>>2]&7){case 5:{t=22;break b;break}case 0:{h=0;t=35;break b;break}case 6:break;default:{t=24;break b}}r=f[s+8>>2]|0;l=f[r+64>>2]|0;v=l+-1|0;if(!(v&l))w=v&p;else w=(p>>>0)%(l>>>0)|0;l=f[(f[r+68>>2]|0)+(w<<2)>>2]|0;if(l|0){r=l;do{l=f[r+16>>2]|0;if(((f[l>>2]|0)==(p|0)?(f[l+4>>2]|0)==(n|0):0)?(Arc(f[l+8>>2]|0,d,n)|0)==0:0){x=r;t=34;break a}r=f[r+20>>2]|0}while((r|0)!=0)}q=q+1|0;if((q|0)>=(o|0)){h=0;t=35;break}}if((t|0)==22){y=s;break}else if((t|0)==24){f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,49)|0;i=A;j=227896;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(-2,g,227858,757)}else if((t|0)==35){u=e;return h|0}}else switch(f[c>>2]&7){case 5:{y=c;break a;break}case 6:{o=f[c+8>>2]|0;q=f[o+64>>2]|0;m=q+-1|0;if(!(m&q))B=m&p;else B=(p>>>0)%(q>>>0)|0;q=f[(f[o+68>>2]|0)+(B<<2)>>2]|0;if(!q){h=0;u=e;return h|0}else C=q;while(1){q=f[C+16>>2]|0;if(((f[q>>2]|0)==(p|0)?(f[q+4>>2]|0)==(n|0):0)?(Arc(f[q+8>>2]|0,d,n)|0)==0:0){x=C;t=34;break a}C=f[C+20>>2]|0;if(!C){h=0;break}}u=e;return h|0}case 0:{h=0;u=e;return h|0}default:{f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,49)|0;i=A;j=227896;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(-2,g,227858,757)}}while(0);if((t|0)==34){h=x;u=e;return h|0}if(!(f[(f[y+8>>2]|0)+24>>2]|0)){h=0;u=e;return h|0}else{f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,49)|0;i=A;j=227896;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(-2,g,227858,757)}return 0}function k1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(h?(f[a>>2]|0)==1280131417:0){if(!c){i=0;u=e;return i|0}if(f[c>>2]&16|0?(j=f[c+4>>2]|0,j|0):0){k=Mi[f[j+28>>2]&1023](a,c)|0;if(!d){i=k;u=e;return i|0}f[d>>2]=0;f[d+4>>2]=0;i=k;u=e;return i|0}f[g>>2]=0;f[g+4>>2]=0;l=tT(g,57)|0;m=227800;n=l+57|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));g1(-2,g,227793,1426)}i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;l=tT(g,31)|0;m=231878;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));g1(i,g,227793,1420);return 0}function l1(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,19)|0;g=234686;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));g1(-27,d,227730,1380)}i=f[a>>2]|0;if(!i){u=c;return}j=f[132940]|0;a:do if(j|0){k=j;while(1){if(_i[f[k+20>>2]&1023](i)|0)break;l=f[k+12>>2]|0;if(!l)break a;else k=l}l=f[k+24>>2]|0;if(!l){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,32)|0;g=227760;h=e+32|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));g1(-2,d,227730,1388)}Yi[l&2047](a);f[a>>2]=0;u=c;return}while(0);f[d>>2]=0;f[d+4>>2]=0;e=tT(d,19)|0;g=227740;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));g1(-2,d,227730,1386)}function m1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!a){c=0;return c|0}else d=a;a:while(1){e=f[d>>2]|0;if(!e){c=0;g=8;break}a=f[e>>2]|0;if(a|0){h=0;i=a;j=0;while(1){h=h+1|0;if(!(Ioc(b,i)|0)){g=7;break a}a=h<<1;i=f[e+(a<<2)>>2]|0;if(!i)break;else j=a}}d=f[d+4>>2]|0;if(!d){c=0;g=8;break}}if((g|0)==7){c=f[e+((j|1)<<2)>>2]|0;return c|0}else if((g|0)==8)return c|0;return 0}function n1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;i=g;if(!a){j=0;u=g;return j|0}k=f[a+28>>2]|0;if((d|0)<0){a=b[c>>0]|0;if(!(a<<24>>24)){l=0;m=0}else{n=0;o=0;p=a;while(1){a=(p&255)+(o*33|0)|0;q=n+1|0;p=b[c+q>>0]|0;if(!(p<<24>>24)){l=q;m=a;break}else{n=q;o=a}}}}else if(!d){l=0;m=0}else{o=0;n=0;while(1){p=(h[c+n>>0]|0)+(o*33|0)|0;n=n+1|0;if((n|0)>=(d|0)){l=d;m=p;break}else o=p}}o=m&2147483647;m=f[k+64>>2]|0;d=m+-1|0;if(!(d&m))r=d&o;else r=(o>>>0)%(m>>>0)|0;m=k+68|0;d=f[(f[m>>2]|0)+(r<<2)>>2]|0;a:do if(d|0){n=d;while(1){if(((f[n>>2]|0)==(o|0)?(f[n+4>>2]|0)==(l|0):0)?(Arc(f[n+8>>2]|0,c,l)|0)==0:0){j=n;break}n=f[n+12>>2]|0;if(!n)break a}u=g;return j|0}while(0);if(!e){j=0;u=g;return j|0}e=k+56|0;d=f[e>>2]|0;f[i>>2]=d;if(!d){H7(k,0,i)|0;s=f[i>>2]|0}else{f[e>>2]=f[d+4>>2];f[d>>2]=f[d>>2]&67108863;e=k+60|0;f[e>>2]=(f[e>>2]|0)+1;s=d}f[s>>2]=o;l7(i,f[k+44>>2]|0,c,l);l=i;i=f[l+4>>2]|0;c=s+4|0;f[c>>2]=f[l>>2];f[c+4>>2]=i;i=(f[m>>2]|0)+(r<<2)|0;f[s+12>>2]=f[i>>2];f[i>>2]=s;j=s;u=g;return j|0}function o1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+16|0;h=g;if(!a){i=0;u=g;return i|0}if((f[a>>2]|0)!=1280131417){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,31)|0;k=231878;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(-5,h,227946,653)}if(!d){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,16)|0;k=227960;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(-27,h,227946,656)}a:do if(c){m=f[a+32>>2]|0;if(!m){i=0;u=g;return i|0}n=f[m+24>>2]|0;if((n|0)<=0){i=0;u=g;return i|0}m=n+-1|0;o=(e|0)!=0;p=c+8|0;q=0;r=0;b:while(1){switch(f[c>>2]&7){case 5:{s=c;t=27;break a;break}case 0:{i=0;t=43;break b;break}case 6:break;default:{t=28;break b}}v=f[p>>2]|0;w=f[v+64>>2]|0;x=w+-1|0;y=f[d>>2]|0;if(!(x&w))z=y&x;else z=(y>>>0)%(w>>>0)|0;w=v+68|0;y=f[w>>2]|0;x=f[y+(z<<2)>>2]|0;if(x|0){A=x;do{if((f[A+16>>2]|0)==(d|0)){B=A;break a}A=f[A+20>>2]|0}while((A|0)!=0)}if(o&(r|0)==(m|0)){A=v+56|0;x=f[A>>2]|0;f[h>>2]=x;if(!x){H7(v,0,h)|0;C=f[h>>2]|0;D=f[w>>2]|0}else{f[A>>2]=f[x+4>>2];f[x>>2]=f[x>>2]&67108863;A=v+60|0;f[A>>2]=(f[A>>2]|0)+1;C=x;D=y}f[C+16>>2]=d;x=D+(z<<2)|0;f[C+20>>2]=f[x>>2];f[x>>2]=C;E=C}else E=q;r=r+1|0;if((r|0)>=(n|0)){i=E;t=43;break}else q=E}if((t|0)==28){f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,49)|0;j=G;k=227896;l=j+49|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(-2,h,227946,679)}else if((t|0)==43){u=g;return i|0}}else{q=(e|0)==0;n=o7(f[a+32>>2]|0,0)|0;if(!n){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,16)|0;k=227977;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(-215,h,227946,674)}switch(f[n>>2]&7){case 6:{r=f[n+8>>2]|0;m=f[r+64>>2]|0;o=m+-1|0;p=f[d>>2]|0;if(!(o&m))H=p&o;else H=(p>>>0)%(m>>>0)|0;m=r+68|0;p=f[m>>2]|0;o=f[p+(H<<2)>>2]|0;if(o|0){x=o;do{if((f[x+16>>2]|0)==(d|0)){B=x;break a}x=f[x+20>>2]|0}while((x|0)!=0)}if(q){i=0;u=g;return i|0}x=r+56|0;o=f[x>>2]|0;f[h>>2]=o;if(!o){H7(r,0,h)|0;I=f[h>>2]|0;J=f[m>>2]|0}else{f[x>>2]=f[o+4>>2];f[o>>2]=f[o>>2]&67108863;x=r+60|0;f[x>>2]=(f[x>>2]|0)+1;I=o;J=p}f[I+16>>2]=d;o=J+(H<<2)|0;f[I+20>>2]=f[o>>2];f[o>>2]=I;i=I;u=g;return i|0}case 5:{s=n;t=27;break a;break}case 0:{i=0;u=g;return i|0}default:{f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,49)|0;j=G;k=227896;l=j+49|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(-2,h,227946,679)}}}while(0);if((t|0)==27)if(!(f[(f[s+8>>2]|0)+24>>2]|0)){i=0;u=g;return i|0}else{f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,49)|0;j=G;k=227896;l=j+49|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(-2,h,227946,679)}if(e|0)M8(a,227946,227994,227514,699);i=B;u=g;return i|0}function p1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=(a|0)!=0;if(g?(f[a>>2]|0)==1280131417:0){h=f[a+32>>2]|0;if(!h){i=0;u=d;return i|0}if((f[h+24>>2]|0)>>>0<=c>>>0){i=0;u=d;return i|0}i=o7(h,c)|0;u=d;return i|0}i=g?-5:-27;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,31)|0;d=231878;c=g+31|0;do{b[g>>0]=b[d>>0]|0;g=g+1|0;d=d+1|0}while((g|0)<(c|0));g1(i,e,228009,789);return 0}function q1(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(!i){j=i?-5:-27;f[h>>2]=0;k=h+4|0;f[k>>2]=0;l=tT(h,31)|0;m=l;n=231878;o=m+31|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));g1(j,h,228027,801)}if((f[a>>2]|0)!=1280131417){j=i?-5:-27;f[h>>2]=0;k=h+4|0;f[k>>2]=0;l=tT(h,31)|0;m=l;n=231878;o=m+31|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));g1(j,h,228027,801)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,38)|0;n=231923;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));g1(-2,h,228027,801)}V8(a,0);j=a+280|0;l=f[j>>2]|0;if((l|0)==1){U8(a,0);p=f[j>>2]|0}else p=l;l=(p|0)==0;k=(d&7|0)==5;if(k&l?(e|0)==0&(b[a+276>>0]|0)!=0:0){W8(a,c,d,0);u=g;return}if(e|0?(Arc(e,247471,6)|0)==0:0){if(!k){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,55)|0;n=228046;o=m+55|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));g1(-5,h,228027,822)}if(!l){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,69)|0;n=228102;o=m+69|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));g1(-2,h,228027,824)}ei[f[a+228>>2]&511](a,c,d,e);if(f[j>>2]|0)U8(a,0);U8(a,2);u=g;return}if((p|0)==2){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,62)|0;n=228172;o=m+62|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));g1(-2,h,228027,836)}ei[f[a+228>>2]&511](a,c,d,e);if(f[j>>2]|0)U8(a,0);U8(a,1);u=g;return}function r1(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=(a|0)!=0;if(e?(f[a>>2]|0)==1280131417:0){if(!(f[a+8>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;g=tT(d,38)|0;h=231923;i=g+38|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));g1(-2,d,228235,850)}V8(a,0);if(!(f[a+280>>2]|0)){j=a+232|0;k=f[j>>2]|0;Yi[k&2047](a);u=c;return}U8(a,0);j=a+232|0;k=f[j>>2]|0;Yi[k&2047](a);u=c;return}c=e?-5:-27;f[d>>2]=0;f[d+4>>2]=0;g=tT(d,31)|0;h=231878;i=g+31|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));g1(c,d,228235,850)}function s1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(h?(f[a>>2]|0)==1280131417:0)if(!(f[a+8>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,38)|0;j=231923;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(-2,g,228252,863)}else{Ti[f[a+236>>2]&511](a,c,d);u=e;return}e=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;i=tT(g,31)|0;j=231878;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(e,g,228252,863)}function t1(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(h?(f[a>>2]|0)==1280131417:0)if(!(f[a+8>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,38)|0;j=231923;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(-2,g,228263,871)}else{Vi[f[a+240>>2]&31](a,c,d);u=e;return}e=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;i=tT(g,31)|0;j=231878;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(e,g,228263,871)}function u1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(i?(f[a>>2]|0)==1280131417:0)if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,38)|0;k=231923;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(-2,h,228275,879)}else{ei[f[a+244>>2]&511](a,c,d,e);u=g;return}g=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;j=tT(h,31)|0;k=231878;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(g,h,228275,879)}function v1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(h?(f[a>>2]|0)==1280131417:0)if(!(f[a+8>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,38)|0;j=231923;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(-2,g,228289,887)}else{Ti[f[a+248>>2]&511](a,c,d);u=e;return}e=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;i=tT(g,31)|0;j=231878;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));g1(e,g,228289,887)}function w1(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;i=u;u=u+1296|0;k=i+8|0;l=i+1032|0;m=i;a:do if(!(b[a+276>>0]|0)){switch(f[a+280>>2]|0){case 2:{break a;break}case 0:{U8(a,1);break}default:{}}XIc(l|0,0,256)|0;if((f[a>>2]|0)!=1280131417){f[m>>2]=0;f[m+4>>2]=0;o=tT(m,31)|0;q=231878;r=o+31|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));g1(-5,m,228304,918)}if(!(f[a+8>>2]|0)){f[m>>2]=0;f[m+4>>2]=0;o=tT(m,38)|0;q=231923;r=o+38|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));g1(-2,m,228304,918)}if((e|0)<0){f[m>>2]=0;f[m+4>>2]=0;o=tT(m,27)|0;q=228319;r=o+27|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));g1(-211,m,228304,921)}s=Z8(g,k,128)|0;b:do if(e|0){if(!c){f[m>>2]=0;f[m+4>>2]=0;o=tT(m,17)|0;q=228347;r=o+17|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));g1(-27,m,228304,929)}if((s|0)==1){t=Y(f[k>>2]|0,e)|0;f[k>>2]=t;v=1}else v=e;t=(s|0)>0;w=a+4|0;x=c;y=0;z=v;c:while(1){z=z+-1|0;if(t){A=0;B=y;while(1){C=A<<1;D=f[k+(C<<2)>>2]|0;E=f[k+((C|1)<<2)>>2]|0;C=(E>>>3&511)+1<<(47696>>>(E<<1&14)&3);F=B+-1+C&0-C;C=c+F|0;d:do if((D|0)>0){G=(E+-5|0)>>>0<2;if(!E){H=D+F|0;I=C;J=0;do{K=C8(h[I>>0]|0,l,10)|0;I=I+1|0;switch(f[w>>2]|0){case 8:{e8(a,0,K,Mpc(K)|0);break}case 16:{g9(a,0,K);break}default:{do if(G){L=Mpc(K)|0;if(!L)break;if((b[K+(L+-1)>>0]|0)!=46)break;b[l+L>>0]=48;b[l+(L+1)>>0]=0}while(0);p8(a,0,K)}}J=J+1|0}while((J|0)!=(D|0));M=c+H|0;break}else{N=C;O=0}while(1){switch(E|0){case 7:{P=C8(f[N>>2]|0,l,10)|0;Q=4;break}case 1:{P=C8(b[N>>0]|0,l,10)|0;Q=1;break}case 2:{P=C8(j[N>>1]|0,l,10)|0;Q=2;break}case 3:{P=C8(d[N>>1]|0,l,10)|0;Q=2;break}case 4:{P=C8(f[N>>2]|0,l,10)|0;Q=4;break}case 5:{S8(l,+n[N>>2])|0;P=l;Q=4;break}case 6:{R8(l,+p[N>>3])|0;P=l;Q=8;break}default:break c}J=N+Q|0;switch(f[w>>2]|0){case 8:{e8(a,0,P,Mpc(P)|0);break}case 16:{g9(a,0,P);break}default:{do if(G){I=Mpc(P)|0;if(!I)break;if((b[P+(I+-1)>>0]|0)!=46)break;b[l+I>>0]=48;b[l+(I+1)>>0]=0}while(0);p8(a,0,P)}}O=O+1|0;if((O|0)>=(D|0)){M=J;break d}else N=J}}else M=C;while(0);C=M-x|0;A=A+1|0;if((A|0)>=(s|0)){R=C;break}else B=C}}else R=y;if(!z)break b;else y=R}f[m>>2]=0;f[m+4>>2]=0;o=tT(m,16)|0;q=287952;r=o+16|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));g1(-210,m,228304,986)}while(0);u=i;return}while(0);o4(a,c,e,g);u=i;return}function x1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!h){i=h?-5:-27;f[g>>2]=0;j=g+4|0;f[j>>2]=0;k=tT(g,31)|0;l=k;m=231878;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));g1(i,g,228365,1025)}if((f[a>>2]|0)!=1280131417){i=h?-5:-27;f[g>>2]=0;j=g+4|0;f[j>>2]=0;k=tT(g,31)|0;l=k;m=231878;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));g1(i,g,228365,1025)}if(!((c|0)!=0&(d|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,42)|0;m=228384;n=l+42|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));g1(-27,g,228365,1028)}i=f[c>>2]|0;if(((i&7)+-1|0)>>>0<2){f[d+12>>2]=c;f[d+20>>2]=c+32;f[d+16>>2]=c;f[d+4>>2]=0;u=e;return}switch(i&7){case 5:{r7(f[c+8>>2]|0,d,0);u=e;return}case 0:{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;l=tT(g,56)|0;m=228427;n=l+56|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));g1(-5,g,228365,1048)}}}function y1(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0;i=u;u=u+1040|0;j=i+8|0;k=i;l=(a|0)!=0;if(!l){m=l?-5:-27;f[k>>2]=0;o=k+4|0;f[o>>2]=0;q=tT(k,31)|0;r=q;s=231878;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));g1(m,k,228484,1060)}if((f[a>>2]|0)!=1280131417){m=l?-5:-27;f[k>>2]=0;o=k+4|0;f[o>>2]=0;q=tT(k,31)|0;r=q;s=231878;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));g1(m,k,228484,1060)}if(!((c|0)!=0&(g|0)!=0)){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,43)|0;s=228503;t=r+43|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));g1(-27,k,228484,1063)}m=c+4|0;if((e|0)!=1&(f[m>>2]|0)==0){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,49)|0;s=228547;t=r+49|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));g1(-201,k,228484,1066)}q=Z8(h,j,128)|0;o=$8(h,0)|0;h=(q|0)>0;l=c+12|0;a=c+20|0;v=e;e=g;a:while(1){if(h){g=e;w=0;x=0;y=v;while(1){z=w<<1;A=f[j+((z|1)<<2)>>2]|0;B=(A>>>3&511)+1<<(47696>>>(A<<1&14)&3);C=f[j+(z<<2)>>2]|0;z=e+(x+-1+B&0-B)|0;b:do if((C|0)>0){B=z;D=y;E=0;while(1){F=f[l>>2]|0;c:do switch(f[F>>2]&7){case 1:{G=f[F+8>>2]|0;switch(A|0){case 0:{b[B>>0]=G>>>0<256?G:(G|0)>0?255:0;H=1;break c;break}case 1:{b[B>>0]=(G+128|0)>>>0<256?G:(G|0)>0?127:128;H=1;break c;break}case 2:{d[B>>1]=G>>>0<65536?G:(G|0)>0?65535:0;H=2;break c;break}case 3:{d[B>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;H=2;break c;break}case 4:{f[B>>2]=G;H=4;break c;break}case 5:{n[B>>2]=+(G|0);H=4;break c;break}case 6:{p[B>>3]=+(G|0);H=8;break c;break}case 7:{f[B>>2]=G;H=4;break c;break}default:{I=22;break a}}break}case 2:{J=+p[F+8>>3];switch(A|0){case 0:{G=nrc(J)|0;b[B>>0]=G>>>0<256?G:(G|0)>0?255:0;H=1;break c;break}case 1:{G=nrc(J)|0;b[B>>0]=(G+128|0)>>>0<256?G:(G|0)>0?127:128;H=1;break c;break}case 2:{G=nrc(J)|0;d[B>>1]=G>>>0<65536?G:(G|0)>0?65535:0;H=2;break c;break}case 3:{G=nrc(J)|0;d[B>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;H=2;break c;break}case 4:{G=nrc(J)|0;f[B>>2]=G;H=4;break c;break}case 5:{n[B>>2]=J;H=4;break c;break}case 6:{p[B>>3]=J;H=8;break c;break}case 7:{G=nrc(J)|0;f[B>>2]=G;H=4;break c;break}default:{I=32;break a}}break}default:{I=33;break a}}while(0);F=B+H|0;G=(f[l>>2]|0)+16|0;f[l>>2]=G;if(G>>>0>=(f[a>>2]|0)>>>0)z7(c,1);G=D+-1|0;if(!G){I=40;break a}K=E+1|0;if((K|0)<(C|0)){B=F;D=G;E=K}else{L=F;M=G;break b}}}else{L=z;M=y}while(0);z=w+1|0;if((z|0)<(q|0)){w=z;x=L-g|0;y=M}else{N=M;break}}}else N=v;v=N;e=e+o|0}if((I|0)==22){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,16)|0;s=287952;t=r+16|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));g1(-210,k,228484,1126)}else if((I|0)==32){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,16)|0;s=287952;t=r+16|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));g1(-210,k,228484,1176)}else if((I|0)==33){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,46)|0;s=228597;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));g1(-2,k,228484,1182)}else if((I|0)==40){if(!((w|0)==(q+-1|0)&(E|0)==(C+-1|0))){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,60)|0;s=228644;t=r+60|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));g1(-201,k,228484,1197)}if(f[m>>2]|0){u=i;return}f[l>>2]=(f[l>>2]|0)+-16;u=i;return}}function z1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!((c|0)!=0&(d|0)!=0)){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,54)|0;k=228705;l=j+54|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));g1(-27,i,228760,1211)}x1(a,c,h);if((f[c>>2]&7|0)!=5){m=1;y1(a,h,m,d,e);u=g;return}m=f[(f[c+8>>2]|0)+24>>2]|0;y1(a,h,m,d,e);u=g;return}function A1(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;e=d+4|0;f[e>>2]=0;g=tT(d,17)|0;h=g;i=228774;j=h+17|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));g1(-201,d,228792,1271)}if((f[a+4>>2]|0)!=40){f[d>>2]=0;e=d+4|0;f[e>>2]=0;g=tT(d,17)|0;h=g;i=228774;j=h+17|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));g1(-201,d,228792,1271)}if(((f[a+20>>2]|0?f[a+24>>2]|0:0)?f[a+28>>2]|0:0)?f[a+32>>2]|0:0){g=a+16|0;e=f[g>>2]|0;k=b[e>>0]|0;if(!(k<<24>>24==95|((k&-33)+-65&255)<26)){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,41)|0;i=228889;j=h+41|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));g1(-5,d,228792,1281)}l=Mpc(e)|0;a:do if((l|0)>0){m=0;n=k;b:while(1){if(!((n+-48&255)<10|((n&-33)+-65&255)<26))switch(n<<24>>24){case 45:case 95:break;default:break b}o=m+1|0;if((o|0)>=(l|0))break a;m=o;n=b[e+o>>0]|0}f[d>>2]=0;f[d+4>>2]=0;h=tT(d,54)|0;i=228931;j=h+54|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));g1(-5,d,228792,1290)}while(0);e=h0(l+41|0)|0;h=e;i=a;j=h+40|0;do{f[h>>2]=f[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));a=e+40|0;f[e+16>>2]=a;dJc(a|0,f[g>>2]|0,l+1|0)|0;f[e>>2]=0;l=f[132940]|0;f[e+12>>2]=l;f[e+8>>2]=0;f[(l|0?l+8|0:531764)>>2]=e;f[132940]=e;u=c;return}f[d>>2]=0;f[d+4>>2]=0;h=tT(d,81)|0;i=228807;j=h+81|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));g1(-27,d,228792,1277)}function B1(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[132940]|0;if(!b)return;else c=b;while(1){if(!(Ioc(f[c+16>>2]|0,a)|0))break;b=f[c+12>>2]|0;if(!b){d=8;break}else c=b}if((d|0)==8)return;d=c+8|0;a=f[d>>2]|0;b=c+12|0;f[((a|0)==0?531760:a+12|0)>>2]=f[b>>2];a=f[b>>2]|0;f[((a|0)==0?531764:a+8|0)>>2]=f[d>>2];if(!((f[132940]|0)!=0&(f[132941]|0)!=0)){f[132941]=0;f[132940]=0}i0(c);return}function C1(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a){b=0;return b|0}c=f[132940]|0;if(!c){b=0;return b|0}else d=c;while(1){if(!(Ioc(f[d+16>>2]|0,a)|0)){b=d;e=5;break}d=f[d+12>>2]|0;if(!d){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function D1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g+8|0;i=g;j=(a|0)!=0;if(!j){k=j?-5:-27;f[h>>2]=0;l=h+4|0;f[l>>2]=0;m=tT(h,31)|0;n=m;o=231878;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));g1(k,h,228986,1443)}if((f[a>>2]|0)!=1280131417){k=j?-5:-27;f[h>>2]=0;l=h+4|0;f[l>>2]=0;m=tT(h,31)|0;n=m;o=231878;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));g1(k,h,228986,1443)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;n=tT(h,38)|0;o=231923;p=n+38|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));g1(-2,h,228986,1443)}if(!d){f[h>>2]=0;f[h+4>>2]=0;n=tT(h,34)|0;o=228994;p=n+34|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));g1(-27,h,228986,1446)}k=f[132940]|0;if(!k){f[h>>2]=0;q=h+4|0;f[q>>2]=0;r=tT(h,14)|0;n=r;o=229029;p=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));g1(-5,h,228986,1450)}else s=k;while(1){if(_i[f[s+20>>2]&1023](d)|0)break;k=f[s+12>>2]|0;if(!k){t=11;break}else s=k}if((t|0)==11){f[h>>2]=0;q=h+4|0;f[q>>2]=0;r=tT(h,14)|0;n=r;o=229029;p=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));g1(-5,h,228986,1450)}r=f[s+32>>2]|0;if(!r){f[h>>2]=0;f[h+4>>2]=0;n=tT(h,39)|0;o=229044;p=n+39|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));g1(-5,h,228986,1453)}else{o=e;e=f[o+4>>2]|0;n=i;f[n>>2]=f[o>>2];f[n+4>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];ei[r&511](a,c,d,h);u=g;return}}function E1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=d+8|0;f[e>>2]=f[45640+((c&7)<<2)>>2];f[e+4>>2]=(c>>>3&511)+1;F5(g,229159,e);e=f[g+4>>2]|0;if(e|0){c=f[g>>2]|0;f[a>>2]=c;f[a+4>>2]=e;if(!c){uT(g);u=d;return}e=c+-4|0;f[e>>2]=(f[e>>2]|0)+1;uT(g);u=d;return}if((b[519816]|0)==0?MIc(519816)|0:0){f[132553]=0;f[132554]=0;e=tT(530212,14)|0;c=229165;h=e+14|0;do{b[e>>0]=b[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(h|0));be(1713,530212,x|0)|0}c=f[132553]|0;f[a>>2]=c;f[a+4>>2]=f[132554];if(!c){uT(g);u=d;return}a=c+-4|0;f[a>>2]=(f[a>>2]|0)+1;uT(g);u=d;return}function F1(a){a=a|0;uT(a);return}function G1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+32|0;iEc(d,c)|0;c=a+44|0;f[c>>2]=0;e=a+48|0;g=f[e>>2]|0;if(g&8|0){h=b[d+11>>0]|0;if(h<<24>>24<0){i=f[d>>2]|0;j=i;k=i;l=i+(f[a+36>>2]|0)|0}else{j=d;k=d;l=d+(h&255)|0}f[c>>2]=l;f[a+8>>2]=j;f[a+12>>2]=k;f[a+16>>2]=l}if(!(g&16))return;g=d+11|0;l=b[g>>0]|0;if(l<<24>>24<0){k=f[a+36>>2]|0;f[c>>2]=(f[d>>2]|0)+k;m=(f[a+40>>2]&2147483647)+-1|0;n=k}else{k=l&255;f[c>>2]=d+k;m=10;n=k}oEc(d,m,0);m=b[g>>0]|0;if(m<<24>>24<0){g=f[d>>2]|0;o=g;p=f[a+36>>2]|0;q=g}else{o=d;p=m&255;q=d}d=a+24|0;f[d>>2]=q;f[a+20>>2]=q;f[a+28>>2]=o+p;if(!(f[e>>2]&3))return;f[d>>2]=q+n;return}function H1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e+12|0;h=e;i=e+8|0;juc(h,a);if(!(b[h>>0]|0)){kuc(h);u=e;return a|0}j=(f[a>>2]|0)+-12|0;f[i>>2]=f[a+(f[j>>2]|0)+24>>2];k=a+(f[j>>2]|0)|0;j=f[k+4>>2]|0;l=c+d|0;d=k+76|0;m=f[d>>2]|0;if((m|0)==-1){cuc(g,k);n=Hvc(g,885240)|0;o=Mi[f[(f[n>>2]|0)+28>>2]&1023](n,32)|0;Ivc(g);n=o<<24>>24;f[d>>2]=n;p=n}else p=m;f[g>>2]=f[i>>2];if(L1(g,c,(j&176|0)==32?l:c,l,k,p&255)|0){kuc(h);u=e;return a|0}p=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(p,f[p+16>>2]|5);kuc(h);u=e;return a|0}function I1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=f[c+48>>2]|0;if(d&16|0){e=c+44|0;g=f[e>>2]|0;h=f[c+24>>2]|0;if(g>>>0<h>>>0){f[e>>2]=h;i=h}else i=g;g=f[c+20>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=i-g|0;if(h>>>0>4294967279)dEc(a);if(h>>>0<11){b[a+11>>0]=h;j=a}else{e=h+16&-16;k=VDc(e)|0;f[a>>2]=k;f[a+8>>2]=e|-2147483648;f[a+4>>2]=h;j=k}if((g|0)==(i|0))l=j;else{k=j;e=g;while(1){b[k>>0]=b[e>>0]|0;e=e+1|0;if((e|0)==(i|0))break;else k=k+1|0}l=j+h|0}b[l>>0]=0;return}if(!(d&8)){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}d=f[c+8>>2]|0;l=f[c+16>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=l-d|0;if(c>>>0>4294967279)dEc(a);if(c>>>0<11){b[a+11>>0]=c;m=a}else{h=c+16&-16;j=VDc(h)|0;f[a>>2]=j;f[a+8>>2]=h|-2147483648;f[a+4>>2]=c;m=j}if((d|0)==(l|0))n=m;else{j=m;a=d;while(1){b[j>>0]=b[a>>0]|0;a=a+1|0;if((a|0)==(l|0))break;else j=j+1|0}n=m+c|0}b[n>>0]=0;return}function J1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(-2,a,b,c,d);return}function K1(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=45684;c=a+64|0;f[c>>2]=45724;f[a+8>>2]=45704;d=a+12|0;f[d>>2]=45740;e=a+44|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);Qsc(d);Ytc(a,45800);Lsc(c);return}function L1(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;if(!k){l=0;u=i;return l|0}m=e;e=c;n=m-e|0;o=g+12|0;g=f[o>>2]|0;p=(g|0)>(n|0)?g-n|0:0;n=d;g=n-e|0;if((g|0)>0?(hj[f[(f[k>>2]|0)+48>>2]&511](k,c,g)|0)!=(g|0):0){f[a>>2]=0;l=0;u=i;return l|0}if((p|0)>0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(p>>>0<11){g=j+11|0;b[g>>0]=p;q=j;r=g;s=j}else{g=p+16&-16;c=VDc(g)|0;f[j>>2]=c;f[j+8>>2]=g|-2147483648;f[j+4>>2]=p;q=c;r=j+11|0;s=j}XIc(q|0,h|0,p|0)|0;b[q+p>>0]=0;if((hj[f[(f[k>>2]|0)+48>>2]&511](k,(b[r>>0]|0)<0?f[s>>2]|0:j,p)|0)==(p|0)){t=1;v=k}else{f[a>>2]=0;t=0;v=0}if((b[r>>0]|0)<0)YDc(f[s>>2]|0);if(t)w=v;else{l=0;u=i;return l|0}}else w=k;k=m-n|0;if((k|0)>0?(hj[f[(f[w>>2]|0)+48>>2]&511](w,d,k)|0)!=(k|0):0){f[a>>2]=0;l=0;u=i;return l|0}f[o>>2]=0;l=w;u=i;return l|0}function M1(a){a=a|0;var c=0;f[a>>2]=45740;c=a+32|0;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);Qsc(a);return}function N1(a){a=a|0;var c=0;f[a>>2]=45740;c=a+32|0;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);Qsc(a);YDc(a);return}function O1(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=c+44|0;j=f[i>>2]|0;k=c+24|0;l=f[k>>2]|0;m=l;if(j>>>0<l>>>0){f[i>>2]=l;n=m}else n=j;j=h&24;a:do if((j|0)!=0?!((g|0)==1&(j|0)==24):0){b:do switch(g|0){case 0:{o=0;p=0;break}case 1:{if(!(h&8)){i=m-(f[c+20>>2]|0)|0;o=i;p=((i|0)<0)<<31>>31;break b}else{i=(f[c+12>>2]|0)-(f[c+8>>2]|0)|0;o=i;p=((i|0)<0)<<31>>31;break b}break}case 2:{i=c+32|0;if((b[i+11>>0]|0)<0)q=f[i>>2]|0;else q=i;i=n-q|0;o=i;p=((i|0)<0)<<31>>31;break}default:{r=-1;s=-1;break a}}while(0);i=UIc(o|0,p|0,d|0,e|0)|0;t=J;if((t|0)>=0){u=c+32|0;if((b[u+11>>0]|0)<0)v=f[u>>2]|0;else v=u;u=n-v|0;w=((u|0)<0)<<31>>31;if(!((w|0)<(t|0)|(w|0)==(t|0)&u>>>0<i>>>0)){u=h&8;if(!((i|0)==0&(t|0)==0)){if(u|0?(f[c+12>>2]|0)==0:0){r=-1;s=-1;break}if((h&16|0)!=0&(l|0)==0){r=-1;s=-1;break}}if(u|0){f[c+12>>2]=(f[c+8>>2]|0)+i;f[c+16>>2]=n}if(!(h&16)){r=i;s=t}else{f[k>>2]=(f[c+20>>2]|0)+i;r=i;s=t}}else{r=-1;s=-1}}else{r=-1;s=-1}}else{r=-1;s=-1}while(0);c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=r;f[c+4>>2]=s;return}function P1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=c+8|0;Fh[f[(f[b>>2]|0)+16>>2]&255](a,b,f[e>>2]|0,f[e+4>>2]|0,0,d);return}function Q1(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,i=0;b=a+44|0;c=f[b>>2]|0;d=f[a+24>>2]|0;if(c>>>0<d>>>0){f[b>>2]=d;e=d}else e=c;if(!(f[a+48>>2]&8)){g=-1;return g|0}c=a+16|0;d=f[c>>2]|0;if(d>>>0<e>>>0){f[c>>2]=e;i=e}else i=d;d=f[a+12>>2]|0;if(d>>>0>=i>>>0){g=-1;return g|0}g=h[d>>0]|0;return g|0}function R1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+44|0;e=f[d>>2]|0;g=f[a+24>>2]|0;if(e>>>0<g>>>0){f[d>>2]=g;h=g}else h=e;e=h;h=a+12|0;g=f[h>>2]|0;if((f[a+8>>2]|0)>>>0>=g>>>0){i=-1;return i|0}if((c|0)==-1){f[h>>2]=g+-1;f[a+16>>2]=e;i=0;return i|0}if(!(f[a+48>>2]&16)){d=c&255;j=g+-1|0;if(d<<24>>24==(b[j>>0]|0)){k=d;l=j}else{i=-1;return i|0}}else{k=c&255;l=g+-1|0}f[h>>2]=l;f[a+16>>2]=e;b[l>>0]=k;i=c;return i|0}function S1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;if((c|0)==-1){g=0;u=d;return g|0}h=a+12|0;i=a+8|0;j=(f[h>>2]|0)-(f[i>>2]|0)|0;k=a+24|0;l=f[k>>2]|0;m=a+28|0;n=f[m>>2]|0;if((l|0)==(n|0)){o=a+48|0;if(!(f[o>>2]&16)){g=-1;u=d;return g|0}p=a+20|0;q=f[p>>2]|0;r=a+44|0;s=(f[r>>2]|0)-q|0;t=a+32|0;vEc(t,0);v=t+11|0;if((b[v>>0]|0)<0)w=(f[a+40>>2]&2147483647)+-1|0;else w=10;oEc(t,w,0);w=b[v>>0]|0;if(w<<24>>24<0){x=f[t>>2]|0;y=f[a+36>>2]|0}else{x=t;y=w&255}w=x+y|0;f[p>>2]=x;f[m>>2]=w;m=x+(l-q)|0;f[k>>2]=m;q=x+s|0;f[r>>2]=q;z=r;A=o;B=r;C=m;D=q;E=w}else{w=a+44|0;z=w;A=a+48|0;B=w;C=l;D=f[w>>2]|0;E=n}n=C+1|0;f[e>>2]=n;w=f[(n>>>0<D>>>0?B:e)>>2]|0;f[z>>2]=w;if(f[A>>2]&8|0){A=a+32|0;if((b[A+11>>0]|0)<0)F=f[A>>2]|0;else F=A;f[i>>2]=F;f[h>>2]=F+j;f[a+16>>2]=w}if((C|0)==(E|0)){g=Mi[f[(f[a>>2]|0)+52>>2]&1023](a,c&255)|0;u=d;return g|0}else{f[k>>2]=n;b[C>>0]=c;g=c&255;u=d;return g|0}return 0}function T1(a){a=a|0;K1(a);YDc(a);return}function U1(a){a=a|0;K1(a+-8|0);return}function V1(a){a=a|0;var b=0;b=a+-8|0;K1(b);YDc(b);return}function W1(a){a=a|0;K1(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function X1(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;K1(b);YDc(b);return}function Y1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+176|0;g=e+160|0;h=e+16|0;i=e;e=h+64|0;j=h+8|0;f[j>>2]=45704;k=h+12|0;f[h>>2]=6980;f[e>>2]=7e3;f[h+4>>2]=0;auc(h+64|0,k);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=45684;f[e>>2]=45724;f[j>>2]=45704;fuc(k);f[k>>2]=45740;j=h+44|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[h+60>>2]=24;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;G1(k,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);j=h+8|0;h=f[d+16>>2]|0;e=H1(H1(j,h,Mpc(h)|0)|0,229180,13)|0;h=d+20|0;l=f[h>>2]|0;m=H1(H1(e,l,Mpc(l)|0)|0,517879,1)|0;l=d+12|0;e=f[l>>2]|0;if(e>>>0<7)n=f[45836+(e<<2)>>2]|0;else n=229194;e=H1(H1(m,n,Mpc(n)|0)|0,517879,1)|0;n=d+24|0;m=f[n>>2]|0;o=H1(H1(e,m,Mpc(m)|0)|0,229198,9)|0;cuc(g,o+(f[(f[o>>2]|0)+-12>>2]|0)|0);m=Hvc(g,885240)|0;e=Mi[f[(f[m>>2]|0)+28>>2]&1023](m,10)|0;Ivc(g);wuc(o,e)|0;iuc(o)|0;e=H1(o,229208,5)|0;o=f[h>>2]|0;h=H1(suc(H1(H1(e,o,Mpc(o)|0)|0,229214,5)|0,a)|0,517842,2)|0;E1(i,a);a=f[i>>2]|0;o=(a|0)==0?1154740:a;a=H1(H1(h,o,Mpc(o)|0)|0,517845,1)|0;cuc(g,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);o=Hvc(g,885240)|0;h=Mi[f[(f[o>>2]|0)+28>>2]&1023](o,10)|0;Ivc(g);wuc(a,h)|0;iuc(a)|0;uT(i);a=f[l>>2]|0;if((a|0)!=0&(a|0)<7){a=H1(j,229220,8)|0;h=f[l>>2]|0;if(h>>>0<7)p=f[45864+(h<<2)>>2]|0;else p=229194;h=H1(a,p,Mpc(p)|0)|0;cuc(g,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);p=Hvc(g,885240)|0;a=Mi[f[(f[p>>2]|0)+28>>2]&1023](p,10)|0;Ivc(g);wuc(h,a)|0;iuc(h)|0}h=H1(j,229208,5)|0;j=f[n>>2]|0;n=H1(suc(H1(H1(h,j,Mpc(j)|0)|0,229214,5)|0,c)|0,517842,2)|0;E1(g,c);c=f[g>>2]|0;j=(c|0)==0?1154740:c;H1(H1(n,j,Mpc(j)|0)|0,517845,1)|0;uT(g);I1(i,k);f[g>>2]=0;f[g+4>>2]=0;k=i+11|0;j=b[k>>0]|0;n=j<<24>>24<0?f[i+4>>2]|0:j&255;if(!n){q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;J1(g,q,s,v)}j=tT(g,n)|0;dJc(j|0,((b[k>>0]|0)<0?f[i>>2]|0:i)|0,n|0)|0;q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;J1(g,q,s,v)}function Z1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+176|0;g=e+160|0;h=e+16|0;i=e;e=h+64|0;j=h+8|0;f[j>>2]=45704;k=h+12|0;f[h>>2]=6980;f[e>>2]=7e3;f[h+4>>2]=0;auc(h+64|0,k);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=45684;f[e>>2]=45724;f[j>>2]=45704;fuc(k);f[k>>2]=45740;j=h+44|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[h+60>>2]=24;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;G1(k,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);j=h+8|0;h=f[d+16>>2]|0;e=H1(H1(j,h,Mpc(h)|0)|0,229180,13)|0;h=d+20|0;l=f[h>>2]|0;m=H1(H1(e,l,Mpc(l)|0)|0,517879,1)|0;l=d+12|0;e=f[l>>2]|0;if(e>>>0<7)n=f[45836+(e<<2)>>2]|0;else n=229194;e=H1(H1(m,n,Mpc(n)|0)|0,517879,1)|0;n=d+24|0;m=f[n>>2]|0;o=H1(H1(e,m,Mpc(m)|0)|0,229198,9)|0;cuc(g,o+(f[(f[o>>2]|0)+-12>>2]|0)|0);m=Hvc(g,885240)|0;e=Mi[f[(f[m>>2]|0)+28>>2]&1023](m,10)|0;Ivc(g);wuc(o,e)|0;iuc(o)|0;e=H1(o,229208,5)|0;o=f[h>>2]|0;h=H1(H1(e,o,Mpc(o)|0)|0,229214,5)|0;o=suc(h,f[a>>2]|0)|0;cuc(g,o+(f[(f[o>>2]|0)+-12>>2]|0)|0);a=Hvc(g,885240)|0;h=Mi[f[(f[a>>2]|0)+28>>2]&1023](a,10)|0;Ivc(g);wuc(o,h)|0;iuc(o)|0;o=f[l>>2]|0;if((o|0)!=0&(o|0)<7){o=H1(j,229220,8)|0;h=f[l>>2]|0;if(h>>>0<7)p=f[45864+(h<<2)>>2]|0;else p=229194;h=H1(o,p,Mpc(p)|0)|0;cuc(g,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);p=Hvc(g,885240)|0;o=Mi[f[(f[p>>2]|0)+28>>2]&1023](p,10)|0;Ivc(g);wuc(h,o)|0;iuc(h)|0}h=H1(j,229208,5)|0;j=f[n>>2]|0;n=H1(H1(h,j,Mpc(j)|0)|0,229214,5)|0;suc(n,f[c>>2]|0)|0;I1(i,k);f[g>>2]=0;f[g+4>>2]=0;k=i+11|0;c=b[k>>0]|0;n=c<<24>>24<0?f[i+4>>2]|0:c&255;if(!n){q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;J1(g,q,s,v)}c=tT(g,n)|0;dJc(c|0,((b[k>>0]|0)<0?f[i>>2]|0:i)|0,n|0)|0;q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;J1(g,q,s,v)}function _1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+4|0;g=d;f[e>>2]=a;f[g>>2]=b;Z1(e,g,c)}function $1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+176|0;g=e+160|0;h=e+16|0;i=e;e=h+64|0;j=h+8|0;f[j>>2]=45704;k=h+12|0;f[h>>2]=6980;f[e>>2]=7e3;f[h+4>>2]=0;auc(h+64|0,k);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=45684;f[e>>2]=45724;f[j>>2]=45704;fuc(k);f[k>>2]=45740;j=h+44|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[h+60>>2]=24;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;G1(k,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);j=h+8|0;h=f[d+16>>2]|0;e=H1(H1(j,h,Mpc(h)|0)|0,229180,13)|0;h=d+20|0;l=f[h>>2]|0;m=H1(H1(e,l,Mpc(l)|0)|0,517879,1)|0;l=d+12|0;e=f[l>>2]|0;if(e>>>0<7)n=f[45836+(e<<2)>>2]|0;else n=229194;e=H1(H1(m,n,Mpc(n)|0)|0,517879,1)|0;n=d+24|0;m=f[n>>2]|0;o=H1(H1(e,m,Mpc(m)|0)|0,229198,9)|0;cuc(g,o+(f[(f[o>>2]|0)+-12>>2]|0)|0);m=Hvc(g,885240)|0;e=Mi[f[(f[m>>2]|0)+28>>2]&1023](m,10)|0;Ivc(g);wuc(o,e)|0;iuc(o)|0;e=H1(o,229208,5)|0;o=f[h>>2]|0;h=tuc(H1(H1(e,o,Mpc(o)|0)|0,229214,5)|0,a)|0;cuc(g,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);a=Hvc(g,885240)|0;o=Mi[f[(f[a>>2]|0)+28>>2]&1023](a,10)|0;Ivc(g);wuc(h,o)|0;iuc(h)|0;h=f[l>>2]|0;if((h|0)!=0&(h|0)<7){h=H1(j,229220,8)|0;o=f[l>>2]|0;if(o>>>0<7)p=f[45864+(o<<2)>>2]|0;else p=229194;o=H1(h,p,Mpc(p)|0)|0;cuc(g,o+(f[(f[o>>2]|0)+-12>>2]|0)|0);p=Hvc(g,885240)|0;h=Mi[f[(f[p>>2]|0)+28>>2]&1023](p,10)|0;Ivc(g);wuc(o,h)|0;iuc(o)|0}o=H1(j,229208,5)|0;j=f[n>>2]|0;tuc(H1(H1(o,j,Mpc(j)|0)|0,229214,5)|0,c)|0;I1(i,k);f[g>>2]=0;f[g+4>>2]=0;k=i+11|0;c=b[k>>0]|0;j=c<<24>>24<0?f[i+4>>2]|0:c&255;if(!j){q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;J1(g,q,s,v)}c=tT(g,j)|0;dJc(c|0,((b[k>>0]|0)<0?f[i>>2]|0:i)|0,j|0)|0;q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;J1(g,q,s,v)}function a2(a,c,d){a=+a;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+176|0;g=e+160|0;h=e+16|0;i=e;e=h+64|0;j=h+8|0;f[j>>2]=45704;k=h+12|0;f[h>>2]=6980;f[e>>2]=7e3;f[h+4>>2]=0;auc(h+64|0,k);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=45684;f[e>>2]=45724;f[j>>2]=45704;fuc(k);f[k>>2]=45740;j=h+44|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[h+60>>2]=24;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;G1(k,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);j=h+8|0;h=f[d+16>>2]|0;e=H1(H1(j,h,Mpc(h)|0)|0,229180,13)|0;h=d+20|0;l=f[h>>2]|0;m=H1(H1(e,l,Mpc(l)|0)|0,517879,1)|0;l=d+12|0;e=f[l>>2]|0;if(e>>>0<7)n=f[45836+(e<<2)>>2]|0;else n=229194;e=H1(H1(m,n,Mpc(n)|0)|0,517879,1)|0;n=d+24|0;m=f[n>>2]|0;o=H1(H1(e,m,Mpc(m)|0)|0,229198,9)|0;cuc(g,o+(f[(f[o>>2]|0)+-12>>2]|0)|0);m=Hvc(g,885240)|0;e=Mi[f[(f[m>>2]|0)+28>>2]&1023](m,10)|0;Ivc(g);wuc(o,e)|0;iuc(o)|0;e=H1(o,229208,5)|0;o=f[h>>2]|0;h=vuc(H1(H1(e,o,Mpc(o)|0)|0,229214,5)|0,a)|0;cuc(g,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);o=Hvc(g,885240)|0;e=Mi[f[(f[o>>2]|0)+28>>2]&1023](o,10)|0;Ivc(g);wuc(h,e)|0;iuc(h)|0;h=f[l>>2]|0;if((h|0)!=0&(h|0)<7){h=H1(j,229220,8)|0;e=f[l>>2]|0;if(e>>>0<7)p=f[45864+(e<<2)>>2]|0;else p=229194;e=H1(h,p,Mpc(p)|0)|0;cuc(g,e+(f[(f[e>>2]|0)+-12>>2]|0)|0);p=Hvc(g,885240)|0;h=Mi[f[(f[p>>2]|0)+28>>2]&1023](p,10)|0;Ivc(g);wuc(e,h)|0;iuc(e)|0}e=H1(j,229208,5)|0;j=f[n>>2]|0;vuc(H1(H1(e,j,Mpc(j)|0)|0,229214,5)|0,c)|0;I1(i,k);f[g>>2]=0;f[g+4>>2]=0;k=i+11|0;j=b[k>>0]|0;e=j<<24>>24<0?f[i+4>>2]|0:j&255;if(!e){q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;J1(g,q,s,v)}j=tT(g,e)|0;dJc(j|0,((b[k>>0]|0)<0?f[i>>2]|0:i)|0,e|0)|0;q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;J1(g,q,s,v)}function b2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+176|0;e=d+160|0;g=d+16|0;h=d;d=g+64|0;i=g+8|0;f[i>>2]=45704;j=g+12|0;f[g>>2]=6980;f[d>>2]=7e3;f[g+4>>2]=0;auc(g+64|0,j);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=45684;f[d>>2]=45724;f[i>>2]=45704;fuc(j);f[j>>2]=45740;i=g+44|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[g+60>>2]=24;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G1(j,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);i=f[c+16>>2]|0;d=H1(H1(g+8|0,i,Mpc(i)|0)|0,502433,1)|0;cuc(e,d+(f[(f[d>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885240)|0;g=Mi[f[(f[i>>2]|0)+28>>2]&1023](i,10)|0;Ivc(e);wuc(d,g)|0;iuc(d)|0;g=H1(d,229208,5)|0;d=f[c+24>>2]|0;i=H1(H1(g,d,Mpc(d)|0)|0,229471,1)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);d=Hvc(e,885240)|0;g=Mi[f[(f[d>>2]|0)+28>>2]&1023](d,10)|0;Ivc(e);wuc(i,g)|0;iuc(i)|0;g=H1(i,229473,5)|0;cuc(e,g+(f[(f[g>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885240)|0;d=Mi[f[(f[i>>2]|0)+28>>2]&1023](i,10)|0;Ivc(e);wuc(g,d)|0;iuc(g)|0;d=H1(g,229208,5)|0;g=f[c+20>>2]|0;i=H1(suc(H1(H1(d,g,Mpc(g)|0)|0,229214,5)|0,a)|0,517842,2)|0;if(a>>>0<8)k=f[45640+(a<<2)>>2]|0;else k=0;a=k|0?k:229084;H1(H1(i,a,Mpc(a)|0)|0,517845,1)|0;I1(h,j);f[e>>2]=0;f[e+4>>2]=0;j=h+11|0;a=b[j>>0]|0;i=a<<24>>24<0?f[h+4>>2]|0:a&255;if(!i){l=f[c>>2]|0;m=c+4|0;n=f[m>>2]|0;o=c+8|0;p=f[o>>2]|0;J1(e,l,n,p)}a=tT(e,i)|0;dJc(a|0,((b[j>>0]|0)<0?f[h>>2]|0:h)|0,i|0)|0;l=f[c>>2]|0;m=c+4|0;n=f[m>>2]|0;o=c+8|0;p=f[o>>2]|0;J1(e,l,n,p)}function c2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+176|0;e=d+160|0;g=d+16|0;h=d;d=g+64|0;i=g+8|0;f[i>>2]=45704;j=g+12|0;f[g>>2]=6980;f[d>>2]=7e3;f[g+4>>2]=0;auc(g+64|0,j);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=45684;f[d>>2]=45724;f[i>>2]=45704;fuc(j);f[j>>2]=45740;i=g+44|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[g+60>>2]=24;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G1(j,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);i=f[c+16>>2]|0;d=H1(H1(g+8|0,i,Mpc(i)|0)|0,502433,1)|0;cuc(e,d+(f[(f[d>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885240)|0;g=Mi[f[(f[i>>2]|0)+28>>2]&1023](i,10)|0;Ivc(e);wuc(d,g)|0;iuc(d)|0;g=H1(d,229208,5)|0;d=f[c+24>>2]|0;i=H1(H1(g,d,Mpc(d)|0)|0,229471,1)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);d=Hvc(e,885240)|0;g=Mi[f[(f[d>>2]|0)+28>>2]&1023](d,10)|0;Ivc(e);wuc(i,g)|0;iuc(i)|0;g=H1(i,229473,5)|0;cuc(e,g+(f[(f[g>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885240)|0;d=Mi[f[(f[i>>2]|0)+28>>2]&1023](i,10)|0;Ivc(e);wuc(g,d)|0;iuc(g)|0;d=H1(g,229208,5)|0;g=f[c+20>>2]|0;i=H1(suc(H1(H1(d,g,Mpc(g)|0)|0,229214,5)|0,a)|0,517842,2)|0;E1(e,a);a=f[e>>2]|0;g=(a|0)==0?1154740:a;H1(H1(i,g,Mpc(g)|0)|0,517845,1)|0;uT(e);I1(h,j);f[e>>2]=0;f[e+4>>2]=0;j=h+11|0;g=b[j>>0]|0;i=g<<24>>24<0?f[h+4>>2]|0:g&255;if(!i){k=f[c>>2]|0;l=c+4|0;m=f[l>>2]|0;n=c+8|0;o=f[n>>2]|0;J1(e,k,m,o)}g=tT(e,i)|0;dJc(g|0,((b[j>>0]|0)<0?f[h>>2]|0:h)|0,i|0)|0;k=f[c>>2]|0;l=c+4|0;m=f[l>>2]|0;n=c+8|0;o=f[n>>2]|0;J1(e,k,m,o)}function d2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+176|0;e=d+160|0;g=d+16|0;h=d;d=g+64|0;i=g+8|0;f[i>>2]=45704;j=g+12|0;f[g>>2]=6980;f[d>>2]=7e3;f[g+4>>2]=0;auc(g+64|0,j);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=45684;f[d>>2]=45724;f[i>>2]=45704;fuc(j);f[j>>2]=45740;i=g+44|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[g+60>>2]=24;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G1(j,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);i=f[c+16>>2]|0;d=H1(H1(g+8|0,i,Mpc(i)|0)|0,502433,1)|0;cuc(e,d+(f[(f[d>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885240)|0;g=Mi[f[(f[i>>2]|0)+28>>2]&1023](i,10)|0;Ivc(e);wuc(d,g)|0;iuc(d)|0;g=H1(d,229208,5)|0;d=f[c+24>>2]|0;i=H1(H1(g,d,Mpc(d)|0)|0,229471,1)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);d=Hvc(e,885240)|0;g=Mi[f[(f[d>>2]|0)+28>>2]&1023](d,10)|0;Ivc(e);wuc(i,g)|0;iuc(i)|0;g=H1(i,229473,5)|0;cuc(e,g+(f[(f[g>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885240)|0;d=Mi[f[(f[i>>2]|0)+28>>2]&1023](i,10)|0;Ivc(e);wuc(g,d)|0;iuc(g)|0;d=H1(g,229208,5)|0;g=f[c+20>>2]|0;i=H1(H1(d,g,Mpc(g)|0)|0,229214,5)|0;suc(i,f[a>>2]|0)|0;I1(h,j);f[e>>2]=0;f[e+4>>2]=0;j=h+11|0;a=b[j>>0]|0;i=a<<24>>24<0?f[h+4>>2]|0:a&255;if(!i){k=f[c>>2]|0;l=c+4|0;m=f[l>>2]|0;n=c+8|0;o=f[n>>2]|0;J1(e,k,m,o)}a=tT(e,i)|0;dJc(a|0,((b[j>>0]|0)<0?f[h>>2]|0:h)|0,i|0)|0;k=f[c>>2]|0;l=c+4|0;m=f[l>>2]|0;n=c+8|0;o=f[n>>2]|0;J1(e,k,m,o)}function e2(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=a;d2(d,b)}function f2(){var a=0;a=u6(229479,1e3)|0;f[132555]=a;return}function g2(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0.0,Ib=0,Jb=0.0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0.0,oc=0,pc=0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0,yc=0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0.0,Ec=0,Fc=0,Gc=0.0,Hc=0.0,Ic=0.0;j=u;u=u+2208|0;k=j+552|0;l=j+2144|0;m=j+2136|0;o=j+2112|0;q=j+2056|0;r=j+1944|0;t=j+1888|0;v=j+1832|0;w=j+2e3|0;x=j+1768|0;y=j+1712|0;z=j+1600|0;A=j+1336|0;B=j;C=j+816|0;D=j+1824|0;E=j+520|0;F=j+1656|0;do if((d$(a)|0)==65536){G=f[a+4>>2]|0;f[q>>2]=f[G>>2];H=q+4|0;I=G+4|0;f[H>>2]=f[I>>2];K=q+8|0;f[K>>2]=f[G+8>>2];L=q+12|0;f[L>>2]=f[G+12>>2];f[q+16>>2]=f[G+16>>2];f[q+20>>2]=f[G+20>>2];f[q+24>>2]=f[G+24>>2];f[q+28>>2]=f[G+28>>2];f[q+32>>2]=f[G+32>>2];M=f[G+36>>2]|0;f[q+36>>2]=M;f[q+40>>2]=K;N=q+48|0;O=q+44|0;f[O>>2]=N;f[N>>2]=0;f[q+52>>2]=0;if(M|0){N=M+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;N=f[O>>2]|0;f[N>>2]=f[I>>2];f[N+4>>2]=f[I+4>>2];P=L;Q=q;R=H;S=K;break}else{f[H>>2]=0;ZS(q,G);P=L;Q=q;R=H;S=K;break}}else{a$(q,a,-1);P=q+12|0;Q=q;R=q+4|0;S=q+8|0}while(0);a=f[S>>2]|0;S=(a|0)==1;K=f[P>>2]|0;P=S?K:a;a=f[Q>>2]|0;Q=Y((a>>>3&511)+1|0,S?1:K)|0;K=(g|0)>1?g:1;if(!((c|0)>0&((f[R>>2]|0)<3&(a&7|0)==5))){f[k>>2]=0;f[k+4>>2]=0;T=tT(k,42)|0;U=229514;V=T+42|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));z5(-215,k,229557,229564,240)}if((P|0)<(c|0)){f[k>>2]=0;f[k+4>>2]=0;a=tT(k,6)|0;b[a>>0]=b[229629]|0;b[a+1>>0]=b[229630]|0;b[a+2>>0]=b[229631]|0;b[a+3>>0]=b[229632]|0;b[a+4>>0]=b[229633]|0;b[a+5>>0]=b[229634]|0;z5(-215,k,229557,229564,241)}a=q+16|0;g=q+44|0;H=q+48|0;Vj(r,P,Q,5,f[a>>2]|0,S?Q<<2:f[H>>2]|0);Y$(d,P,1,4,-1,1,0);f[t>>2]=1124007936;S=t+4|0;L=t+8|0;G=t+40|0;T=S;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[G>>2]=L;I=t+48|0;N=t+44|0;f[N>>2]=I;f[I>>2]=0;f[t+52>>2]=0;do if((d$(d)|0)==65536){O=f[d+4>>2]|0;f[v>>2]=f[O>>2];M=v+4|0;W=O+4|0;f[M>>2]=f[W>>2];X=v+8|0;f[X>>2]=f[O+8>>2];Z=v+12|0;f[Z>>2]=f[O+12>>2];f[v+16>>2]=f[O+16>>2];f[v+20>>2]=f[O+20>>2];f[v+24>>2]=f[O+24>>2];f[v+28>>2]=f[O+28>>2];f[v+32>>2]=f[O+32>>2];_=f[O+36>>2]|0;f[v+36>>2]=_;f[v+40>>2]=X;$=v+48|0;aa=v+44|0;f[aa>>2]=$;f[$>>2]=0;f[v+52>>2]=0;if(_|0){$=_+12|0;f[$>>2]=(f[$>>2]|0)+1}if((f[W>>2]|0)<3){W=f[O+44>>2]|0;$=f[aa>>2]|0;f[$>>2]=f[W>>2];f[$+4>>2]=f[W+4>>2];ba=Z;ca=X;break}else{f[M>>2]=0;ZS(v,O);ba=Z;ca=X;break}}else{a$(v,d,-1);ba=v+12|0;ca=v+8|0}while(0);X=(h&1|0)!=0;Z=f[ba>>2]|0;O=f[ca>>2]|0;M=((Z|0)==1|(O|0)==1)&(Y(O,Z)|0)==(P|0);a:do if(X){if(!M){f[k>>2]=0;da=k+4|0;f[da>>2]=0;ea=tT(k,152)|0;dJc(ea|0,229636,152)|0;z5(-215,k,229557,229564,253)}if((f[v>>2]&20479|0)!=16388){f[k>>2]=0;da=k+4|0;f[da>>2]=0;ea=tT(k,152)|0;dJc(ea|0,229636,152)|0;z5(-215,k,229557,229564,253)}lT(w,v,1,P);Z=k+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=t;h_(w,k);Z=w+36|0;O=f[Z>>2]|0;if(O|0?(W=O+12|0,O=f[W>>2]|0,f[W>>2]=O+-1,(O|0)==1):0)_S(w);f[Z>>2]=0;Z=w+16|0;O=w+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[O>>2]|0)>0){Z=f[w+40>>2]|0;W=0;do{f[Z+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[O>>2]|0))}O=f[w+44>>2]|0;if((O|0)!=(w+48|0))g0(O);if((P|0)>0){O=f[t+16>>2]|0;W=f[G>>2]|0;Z=W+4|0;$=f[N>>2]|0;aa=f[t+12>>2]|0;if(f[t>>2]&16384|0){_=0;while(1){if((f[O+(_<<2)>>2]|0)>>>0>=c>>>0)break;_=_+1|0;if((_|0)>=(P|0))break a}f[k>>2]=0;fa=k+4|0;f[fa>>2]=0;ga=tT(k,42)|0;T=ga;U=229789;V=T+42|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));z5(-215,k,229557,229564,257)}_=(f[W>>2]|0)==1;ha=0;while(1){do if(!_){ia=f[$>>2]|0;if((f[Z>>2]|0)==1){ja=O+(Y(ia,ha)|0)|0;break}else{ka=(ha|0)/(aa|0)|0;ja=O+(Y(ka,ia)|0)+(ha-(Y(ka,aa)|0)<<2)|0;break}}else ja=O+(ha<<2)|0;while(0);ha=ha+1|0;if((f[ja>>2]|0)>>>0>=c>>>0)break;if((ha|0)>=(P|0))break a}f[k>>2]=0;fa=k+4|0;f[fa>>2]=0;ga=tT(k,42)|0;T=ga;U=229789;V=T+42|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));z5(-215,k,229557,229564,257)}}else{if(M?(ha=f[v>>2]|0,(ha&20479|0)==16388):0)la=ha;else{Y$(d,P,1,4,-1,0,0);do if((d$(d)|0)==65536){ha=f[d+4>>2]|0;f[k>>2]=f[ha>>2];O=k+4|0;aa=ha+4|0;f[O>>2]=f[aa>>2];Z=k+8|0;f[Z>>2]=f[ha+8>>2];f[k+12>>2]=f[ha+12>>2];f[k+16>>2]=f[ha+16>>2];f[k+20>>2]=f[ha+20>>2];f[k+24>>2]=f[ha+24>>2];f[k+28>>2]=f[ha+28>>2];f[k+32>>2]=f[ha+32>>2];$=k+36|0;_=f[ha+36>>2]|0;f[$>>2]=_;f[k+40>>2]=Z;Z=k+48|0;W=k+44|0;f[W>>2]=Z;f[Z>>2]=0;f[k+52>>2]=0;if(_|0){Z=_+12|0;f[Z>>2]=(f[Z>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[ha+44>>2]|0;Z=f[W>>2]|0;f[Z>>2]=f[aa>>2];f[Z+4>>2]=f[aa+4>>2];ma=$;break}else{f[O>>2]=0;ZS(k,ha);ma=$;break}}else{a$(k,d,-1);ma=k+36|0}while(0);$=f[ma>>2]|0;if($|0){ha=$+12|0;f[ha>>2]=(f[ha>>2]|0)+1}ha=v+36|0;$=f[ha>>2]|0;if($|0?(O=$+12|0,$=f[O>>2]|0,f[O>>2]=$+-1,($|0)==1):0)_S(v);f[ha>>2]=0;$=v+16|0;O=v+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[O>>2]|0)>0){aa=f[v+40>>2]|0;Z=0;do{f[aa+(Z<<2)>>2]=0;Z=Z+1|0;na=f[O>>2]|0}while((Z|0)<(na|0));f[v>>2]=f[k>>2];if((na|0)<3)oa=63;else oa=65}else{f[v>>2]=f[k>>2];oa=63}if((oa|0)==63){Z=f[k+4>>2]|0;if((Z|0)<3){f[O>>2]=Z;f[ca>>2]=f[k+8>>2];f[ba>>2]=f[k+12>>2];Z=f[k+44>>2]|0;aa=f[v+44>>2]|0;f[aa>>2]=f[Z>>2];f[aa+4>>2]=f[Z+4>>2]}else oa=65}if((oa|0)==65)ZS(v,k);Z=k+16|0;f[$>>2]=f[Z>>2];f[v+20>>2]=f[k+20>>2];f[v+24>>2]=f[k+24>>2];f[v+28>>2]=f[k+28>>2];f[v+32>>2]=f[k+32>>2];aa=f[ma>>2]|0;f[ha>>2]=aa;if(aa|0?(W=aa+12|0,aa=f[W>>2]|0,f[W>>2]=aa+-1,(aa|0)==1):0)_S(k);f[ma>>2]=0;aa=k+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[aa>>2]|0)>0){Z=f[k+40>>2]|0;W=0;do{f[Z+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[aa>>2]|0))}aa=f[k+44>>2]|0;if((aa|0)!=(k+48|0))g0(aa);la=f[v>>2]|0}aa=f[v+40>>2]|0;W=f[aa+4>>2]|0;Z=f[aa>>2]|0;aa=la&4095;if(((((f[S>>2]|0)<3?(f[L>>2]|0)==(Z|0):0)?(f[t+12>>2]|0)==(W|0):0)?(f[t>>2]&4095|0)==(aa|0):0)?f[t+16>>2]|0:0)break;f[k>>2]=Z;f[k+4>>2]=W;XS(t,2,k,aa)}while(0);L=t+16|0;la=f[L>>2]|0;f[x>>2]=1124007936;ma=x+4|0;ba=x+8|0;ca=x+40|0;T=ma;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[ca>>2]=ba;ba=x+48|0;na=x+44|0;f[na>>2]=ba;f[ba>>2]=0;f[x+52>>2]=0;f[k>>2]=c;d=k+4|0;f[d>>2]=Q;XS(x,2,k,5);f[y>>2]=1124007936;M=y+4|0;ga=y+8|0;fa=y+40|0;T=M;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[fa>>2]=ga;ga=y+48|0;ja=y+44|0;f[ja>>2]=ga;f[ga>>2]=0;f[y+52>>2]=0;f[k>>2]=c;f[d>>2]=Q;XS(y,2,k,5);f[z>>2]=1124007936;w=z+4|0;ea=z+8|0;da=z+40|0;T=w;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[da>>2]=ea;ea=z+48|0;aa=z+44|0;f[aa>>2]=ea;f[ea>>2]=0;f[z+52>>2]=0;f[k>>2]=1;f[d>>2]=Q;XS(z,2,k,5);d=A+8|0;f[A>>2]=d;W=A+4|0;Z=c>>>0>64;f[W>>2]=c;if(Z){ha=XDc(c>>>0>1073741823?-1:c<<2)|0;f[A>>2]=ha}ha=B+8|0;f[B>>2]=ha;$=B+4|0;f[$>>2]=P;if(P>>>0>64){O=XDc(P>>>0>536870911?-1:P<<3)|0;f[B>>2]=O}O=K4()|0;_=f[e>>2]|0;ka=e+8|0;if(!(_&2))pa=1.1920928955078125e-07;else{qa=+p[ka>>3];pa=qa<0.0?0.0:qa}p[ka>>3]=pa*pa;ia=e+4|0;if(!(_&1))ra=100;else{_=f[ia>>2]|0;e=(_|0)>2?_:2;ra=(e|0)<100?e:100}e=(c|0)==1;_=e?1:K;f[ia>>2]=e?2:ra;ra=C+8|0;XIc(ra|0,0,512)|0;f[C>>2]=ra;e=C+4|0;f[e>>2]=Q;if(Q>>>0>64){K=XDc(Q>>>0>536870911?-1:Q<<3)|0;XIc(K|0,0,Q<<3|0)|0;f[C>>2]=K;sa=K}else sa=ra;K=(h&2|0)!=0;if(!K){h=r+16|0;ta=f[h>>2]|0;ua=r+44|0;va=(Q|0)>0;if(va?(wa=f[ta>>2]|0,f[sa>>2]=wa,f[sa+4>>2]=wa,(Q|0)!=1):0){wa=1;do{sa=f[C>>2]|0;xa=f[ta+(wa<<2)>>2]|0;f[sa+(wa<<3)>>2]=xa;f[sa+(wa<<3)+4>>2]=xa;wa=wa+1|0}while((wa|0)!=(Q|0))}if((P|0)>1?(wa=f[h>>2]|0,h=f[f[ua>>2]>>2]|0,ua=f[C>>2]|0,va):0){va=1;do{ta=wa+(Y(h,va)|0)|0;xa=0;do{sa=f[ta+(xa<<2)>>2]|0;f[k>>2]=sa;ya=ua+(xa<<3)|0;pa=(f[s>>2]=sa,+n[s>>2]);f[ya>>2]=f[(pa<+n[ya>>2]?k:ya)>>2];ya=ua+(xa<<3)+4|0;f[ya>>2]=f[(+n[ya>>2]<pa?k:ya)>>2];xa=xa+1|0}while((xa|0)!=(Q|0));va=va+1|0}while((va|0)!=(P|0))}}b:do if((_|0)>0){va=r+12|0;ua=r+8|0;h=k+8|0;wa=k+4|0;xa=c>>>0>1073741823?-1:c<<2;ta=l+8|0;ya=l+4|0;sa=r+16|0;za=r+44|0;Aa=(c|0)>1;Ba=m+4|0;Ca=o+4|0;Da=o+8|0;Ea=o+12|0;Fa=o+16|0;Ga=x+16|0;pa=1.0/+(Q|0);Ha=(Q|0)>0;qa=pa*2.0+1.0;Ia=k+4|0;Ja=l+4|0;Ka=l+8|0;La=l+12|0;Ma=l+16|0;Na=(Y(Y(P,c)|0,Q)|0)+-1|0;Oa=(P|0)>0;Pa=z+16|0;Qa=y+16|0;Ra=k+4|0;Sa=l+4|0;Ta=l+8|0;Ua=l+12|0;Va=l+16|0;Wa=(Y(Q,P)|0)+-1|0;Xa=D+4|0;Ya=k+8|0;Za=k+12|0;_a=k+4|0;$a=l+36|0;ab=l+16|0;bb=l+4|0;cb=l+40|0;db=l+44|0;eb=l+48|0;fb=F+36|0;gb=F+16|0;hb=F+4|0;ib=F+40|0;jb=F+44|0;kb=F+48|0;lb=k+8|0;mb=k+4|0;nb=c<<2;ob=1797693134862315708145274.0e284;pb=0;c:while(1){qb=X&(pb|0)<1;rb=0;while(1){sb=(rb|0)==0;tb=sb?1797693134862315708145274.0e284:0.0;bR(x,y);d:do if(qb|sb^1){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;k_(x,k)|0;XIc(f[A>>2]|0,0,nb|0)|0;e:do if(Oa){ub=f[sa>>2]|0;vb=f[za>>2]|0;wb=f[Ga>>2]|0;xb=f[na>>2]|0;yb=f[A>>2]|0;if(Ha)zb=0;else{Ab=0;while(1){Bb=yb+(f[la+(Ab<<2)>>2]<<2)|0;f[Bb>>2]=(f[Bb>>2]|0)+1;Ab=Ab+1|0;if((Ab|0)==(P|0))break e}}do{Ab=ub+(Y(f[vb>>2]|0,zb)|0)|0;Bb=f[la+(zb<<2)>>2]|0;Cb=wb+(Y(f[xb>>2]|0,Bb)|0)|0;Db=0;do{Eb=Cb+(Db<<2)|0;n[Eb>>2]=+n[Ab+(Db<<2)>>2]+ +n[Eb>>2];Db=Db+1|0}while((Db|0)!=(Q|0));Db=yb+(Bb<<2)|0;f[Db>>2]=(f[Db>>2]|0)+1;zb=zb+1|0}while((zb|0)!=(P|0))}while(0);yb=0;xb=f[A>>2]|0;while(1){do if(!(f[xb+(yb<<2)>>2]|0)){if(Aa){wb=1;vb=0;while(1){ub=(f[xb+(vb<<2)>>2]|0)<(f[xb+(wb<<2)>>2]|0)?wb:vb;wb=wb+1|0;if((wb|0)==(c|0)){Fb=ub;break}else vb=ub}}else Fb=0;vb=f[Ga>>2]|0;wb=f[na>>2]|0;Bb=vb+(Y(f[wb>>2]|0,Fb)|0)|0;ub=f[Pa>>2]|0;Db=f[xb+(Fb<<2)>>2]|0;Gb=1.0/+(Db|0);if(Ha){Ab=0;do{n[ub+(Ab<<2)>>2]=Gb*+n[Bb+(Ab<<2)>>2];Ab=Ab+1|0}while((Ab|0)!=(Q|0))}if(Oa){Ab=0;Cb=-1;Gb=0.0;while(1){if((f[la+(Ab<<2)>>2]|0)==(Fb|0)){Hb=+OO((f[sa>>2]|0)+(Y(f[f[za>>2]>>2]|0,Ab)|0)|0,ub,Q);Eb=!(Gb<=Hb);Ib=Eb?Cb:Ab;Jb=Eb?Gb:Hb}else{Ib=Cb;Jb=Gb}Ab=Ab+1|0;if((Ab|0)>=(P|0))break;else{Cb=Ib;Gb=Jb}}Cb=f[A>>2]|0;Kb=Ib;Lb=Cb;Mb=f[Cb+(Fb<<2)>>2]|0;Nb=f[na>>2]|0;Ob=f[Ga>>2]|0}else{Kb=-1;Lb=xb;Mb=Db;Nb=wb;Ob=vb}f[Lb+(Fb<<2)>>2]=Mb+-1;Cb=Lb+(yb<<2)|0;f[Cb>>2]=(f[Cb>>2]|0)+1;f[la+(Kb<<2)>>2]=yb;Cb=(f[sa>>2]|0)+(Y(f[f[za>>2]>>2]|0,Kb)|0)|0;Ab=Ob+(Y(f[Nb>>2]|0,yb)|0)|0;if(Ha)Pb=0;else{Qb=Lb;break}do{ub=Cb+(Pb<<2)|0;Eb=Bb+(Pb<<2)|0;n[Eb>>2]=+n[Eb>>2]-+n[ub>>2];Eb=Ab+(Pb<<2)|0;n[Eb>>2]=+n[ub>>2]+ +n[Eb>>2];Pb=Pb+1|0}while((Pb|0)!=(Q|0));Qb=Lb}else Qb=xb;while(0);yb=yb+1|0;if((yb|0)>=(c|0))break;else xb=Qb}xb=f[Ga>>2]|0;yb=f[f[na>>2]>>2]|0;Ab=f[A>>2]|0;Bb=(rb|0)>0;Cb=f[Qa>>2]|0;vb=f[ja>>2]|0;if(Ha){Rb=0;Sb=tb}else{wb=0;Gb=tb;while(1){if(!(f[Ab+(wb<<2)>>2]|0)){oa=204;break c}Hb=Bb&Gb<0.0?0.0:Gb;wb=wb+1|0;if((wb|0)>=(c|0)){Tb=Hb;break d}else Gb=Hb}}while(1){wb=xb+(Y(yb,Rb)|0)|0;Db=f[Ab+(Rb<<2)>>2]|0;if(!Db){oa=204;break c}Gb=1.0/+(Db|0);Db=0;do{Eb=wb+(Db<<2)|0;n[Eb>>2]=Gb*+n[Eb>>2];Db=Db+1|0}while((Db|0)!=(Q|0));if(Bb){Db=Cb+(Y(f[vb>>2]|0,Rb)|0)|0;Eb=0;Gb=0.0;do{Hb=+n[wb+(Eb<<2)>>2]-+n[Db+(Eb<<2)>>2];Gb=Gb+Hb*Hb;Eb=Eb+1|0}while((Eb|0)!=(Q|0));Ub=Sb<Gb?Gb:Sb}else Ub=Sb;Rb=Rb+1|0;if((Rb|0)>=(c|0)){Tb=Ub;break}else Sb=Ub}}else{if(!K){vb=f[C>>2]|0;Cb=f[Ga>>2]|0;Bb=f[f[na>>2]>>2]|0;if(!Ha){Tb=tb;break}Ab=O;yb=0;xb=f[Ab>>2]|0;Eb=f[Ab+4>>2]|0;while(1){Ab=Cb+(Y(Bb,yb)|0)|0;Db=0;Vb=xb;Wb=Eb;do{wb=mJc(Vb|0,0,-130063606,0)|0;Vb=UIc(wb|0,J|0,Wb|0,0)|0;Wb=J;Hb=+n[vb+(Db<<3)>>2];n[Ab+(Db<<2)>>2]=Hb+(+n[vb+(Db<<3)+4>>2]-Hb)*(qa*(+(Vb>>>0)*2.3283064365386963e-10)-pa);Db=Db+1|0}while((Db|0)!=(Q|0));yb=yb+1|0;if((yb|0)==(c|0))break;else{xb=Vb;Eb=Wb}}Eb=O;f[Eb>>2]=Vb;f[Eb+4>>2]=Wb;Tb=tb;break}Eb=f[va>>2]|0;xb=f[ua>>2]|0;f[k>>2]=h;f[wa>>2]=c;if(Z){yb=XDc(xa)|0;f[k>>2]=yb;Xb=yb}else Xb=h;yb=xb*3|0;f[l>>2]=ta;f[ya>>2]=0;if(!xb){f[ya>>2]=0;Yb=ta}else{f[ya>>2]=yb;vb=XDc(yb>>>0>1073741823?-1:yb<<2)|0;f[l>>2]=vb;Yb=vb}vb=Yb;yb=Yb+(xb<<2)|0;Bb=yb;Cb=yb+(xb<<2)|0;yb=O;Db=f[yb+4>>2]|0;Ab=mJc(f[yb>>2]|0,0,-130063606,0)|0;yb=UIc(Ab|0,J|0,Db|0,0)|0;Db=O;f[Db>>2]=yb;f[Db+4>>2]=J;Db=(yb>>>0)%(xb>>>0)|0;f[Xb>>2]=Db;yb=(xb|0)>0;f:do if(yb){Ab=0;Gb=0.0;wb=Db;while(1){ub=f[sa>>2]|0;Zb=f[f[za>>2]>>2]|0;Hb=+OO(ub+(Y(Zb,Ab)|0)|0,ub+(Y(Zb,wb)|0)|0,Eb);n[Yb+(Ab<<2)>>2]=Hb;_b=Gb+Hb;Zb=Ab+1|0;if((Zb|0)>=(xb|0)){$b=_b;break f}Ab=Zb;Gb=_b;wb=f[Xb>>2]|0}}else $b=0.0;while(0);if(Aa){Db=xb+-1|0;wb=(xb|0)>1;Ab=(Y(xb,Eb)|0)+-1|0;Zb=1;Gb=$b;ub=Cb;ac=vb;bc=Bb;while(1){cc=ac;do if(wb){dc=0;ec=-1;_b=1797693134862315708145274.0e284;fc=ub;gc=bc;while(1){hc=O;ic=f[hc+4>>2]|0;jc=mJc(f[hc>>2]|0,0,-130063606,0)|0;hc=UIc(jc|0,J|0,ic|0,0)|0;ic=J;jc=mJc(hc|0,0,-130063606,0)|0;kc=UIc(jc|0,J|0,ic|0,0)|0;ic=O;f[ic>>2]=kc;f[ic+4>>2]=J;ic=0;Hb=Gb*((+(kc>>>0)+4294967296.0*+(hc>>>0))*5.421010862427522e-20);while(1){Hb=Hb-+n[cc+(ic<<2)>>2];if(Hb<=0.0){lc=ic;break}hc=ic+1|0;if((hc|0)>=(Db|0)){lc=hc;break}else ic=hc}f[m>>2]=0;f[Ba>>2]=xb;ic=fc;f[o>>2]=45900;f[Ca>>2]=ic;f[Da>>2]=r;f[Ea>>2]=cc;f[Fa>>2]=lc;hc=f[132555]|0;y8(m,o,+((((hc+Ab|0)>>>0)/(hc>>>0)|0)>>>0));hc=0;Hb=0.0;do{Hb=Hb+ +n[ic+(hc<<2)>>2];hc=hc+1|0}while((hc|0)!=(xb|0));if(Hb<_b){mc=lc;nc=Hb;oc=gc;pc=fc}else{mc=ec;nc=_b;oc=fc;pc=gc}dc=dc+1|0;if((dc|0)>=3){qc=mc;rc=nc;sc=oc;tc=pc;break}else{ec=mc;_b=nc;fc=oc;gc=pc}}}else{gc=O;fc=f[gc+4>>2]|0;ec=mJc(f[gc>>2]|0,0,-130063606,0)|0;gc=UIc(ec|0,J|0,fc|0,0)|0;fc=J;ec=mJc(gc|0,0,-130063606,0)|0;gc=UIc(ec|0,J|0,fc|0,0)|0;fc=O;f[fc>>2]=gc;f[fc+4>>2]=J;f[m>>2]=0;f[Ba>>2]=xb;fc=ub;f[o>>2]=45900;f[Ca>>2]=fc;f[Da>>2]=r;f[Ea>>2]=cc;f[Fa>>2]=0;gc=f[132555]|0;y8(m,o,+((((gc+Ab|0)>>>0)/(gc>>>0)|0)>>>0));if(yb){gc=0;_b=0.0;do{_b=_b+ +n[fc+(gc<<2)>>2];gc=gc+1|0}while((gc|0)!=(xb|0));if(_b<1797693134862315708145274.0e284){uc=_b;oa=155}else{vc=-1;wc=1797693134862315708145274.0e284;xc=ub;yc=bc}}else{uc=0.0;oa=155}if((oa|0)==155){oa=0;vc=0;wc=uc;xc=bc;yc=ub}gc=O;fc=f[gc+4>>2]|0;ec=mJc(f[gc>>2]|0,0,-130063606,0)|0;gc=UIc(ec|0,J|0,fc|0,0)|0;fc=J;ec=mJc(gc|0,0,-130063606,0)|0;gc=UIc(ec|0,J|0,fc|0,0)|0;fc=O;f[fc>>2]=gc;f[fc+4>>2]=J;f[m>>2]=0;f[Ba>>2]=xb;fc=xc;f[o>>2]=45900;f[Ca>>2]=fc;f[Da>>2]=r;f[Ea>>2]=cc;f[Fa>>2]=0;gc=f[132555]|0;y8(m,o,+((((gc+Ab|0)>>>0)/(gc>>>0)|0)>>>0));if(yb){gc=0;zc=0.0;while(1){Ac=zc+ +n[fc+(gc<<2)>>2];gc=gc+1|0;if((gc|0)==(xb|0)){Bc=Ac;break}else zc=Ac}}else Bc=0.0;if(Bc<wc){Cc=0;Dc=Bc;Ec=yc;Fc=xc}else{Cc=vc;Dc=wc;Ec=xc;Fc=yc}gc=O;fc=f[gc+4>>2]|0;ec=mJc(f[gc>>2]|0,0,-130063606,0)|0;gc=UIc(ec|0,J|0,fc|0,0)|0;fc=J;ec=mJc(gc|0,0,-130063606,0)|0;gc=UIc(ec|0,J|0,fc|0,0)|0;fc=O;f[fc>>2]=gc;f[fc+4>>2]=J;f[m>>2]=0;f[Ba>>2]=xb;fc=Ec;f[o>>2]=45900;f[Ca>>2]=fc;f[Da>>2]=r;f[Ea>>2]=cc;f[Fa>>2]=0;gc=f[132555]|0;y8(m,o,+((((gc+Ab|0)>>>0)/(gc>>>0)|0)>>>0));if(yb){gc=0;zc=0.0;while(1){_b=zc+ +n[fc+(gc<<2)>>2];gc=gc+1|0;if((gc|0)==(xb|0)){Gc=_b;break}else zc=_b}}else Gc=0.0;if(!(Gc<Dc)){qc=Cc;rc=Dc;sc=Ec;tc=Fc;break}qc=0;rc=Gc;sc=Fc;tc=Ec}while(0);f[Xb+(Zb<<2)>>2]=qc;Zb=Zb+1|0;if((Zb|0)>=(c|0))break;else{cc=ac;Gb=rc;ub=sc;ac=tc;bc=cc}}}bc=f[sa>>2]|0;ac=f[f[za>>2]>>2]|0;ub=f[Ga>>2]|0;Zb=f[f[na>>2]>>2]|0;if((Eb|0)>0){xb=0;do{yb=bc+(Y(f[Xb+(xb<<2)>>2]|0,ac)|0)|0;Ab=ub+(Y(xb,Zb)|0)|0;Db=0;do{f[Ab+(Db<<2)>>2]=f[yb+(Db<<2)>>2];Db=Db+1|0}while((Db|0)!=(Eb|0));xb=xb+1|0}while((xb|0)!=(c|0))}xb=f[l>>2]|0;if((xb|0)!=(ta|0)){if(xb|0)ZDc(xb);f[l>>2]=ta;f[ya>>2]=0}xb=f[k>>2]|0;if((xb|0)!=(h|0)){if(xb|0)ZDc(xb);f[k>>2]=h;f[wa>>2]=64}Tb=tb}while(0);sb=rb+1|0;xb=f[ia>>2]|0;if((sb|0)==(((xb|0)>2?xb:2)|0))break;if(Tb<=+p[ka>>3])break;f[k>>2]=0;f[Ia>>2]=P;xb=f[B>>2]|0;f[l>>2]=45940;f[Ja>>2]=xb;f[Ka>>2]=la;f[La>>2]=r;f[Ma>>2]=x;xb=f[132555]|0;y8(k,l,+((((Na+xb|0)>>>0)/(xb>>>0)|0)>>>0));rb=sb}f[k>>2]=0;f[Ra>>2]=P;rb=f[B>>2]|0;f[l>>2]=45920;f[Sa>>2]=rb;f[Ta>>2]=la;f[Ua>>2]=r;f[Va>>2]=x;rb=f[132555]|0;y8(k,l,+((((Wa+rb|0)>>>0)/(rb>>>0)|0)>>>0));f[D>>2]=P;f[Xa>>2]=1;CY(l,D,6,f[B>>2]|0,0);f[Ya>>2]=0;f[Za>>2]=0;f[k>>2]=16842752;f[_a>>2]=l;L6(E,k);tb=+p[E>>3];rb=f[$a>>2]|0;if(rb|0?(qb=rb+12|0,rb=f[qb>>2]|0,f[qb>>2]=rb+-1,(rb|0)==1):0)_S(l);f[$a>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[bb>>2]|0)>0){rb=f[cb>>2]|0;qb=0;do{f[rb+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[bb>>2]|0))}qb=f[db>>2]|0;if((qb|0)!=(eb|0))g0(qb);if(tb<ob){g:do if($$(i)|0){do if(X$(i)|0){if((q$(i,-1)|0)!=(Q|0))break;lT(F,x,Q,0);h_(F,i);qb=f[fb>>2]|0;do if(qb|0){rb=qb+12|0;sb=f[rb>>2]|0;f[rb>>2]=sb+-1;if((sb|0)!=1)break;_S(F)}while(0);f[fb>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[hb>>2]|0)>0){qb=f[ib>>2]|0;sb=0;do{f[qb+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[hb>>2]|0))}sb=f[jb>>2]|0;if((sb|0)==(kb|0))break g;g0(sb);break g}while(0);h_(x,i)}while(0);sb=lb;f[sb>>2]=0;f[sb+4>>2]=0;f[k>>2]=33619968;f[mb>>2]=v;h_(t,k);Hc=tb}else Hc=ob;pb=pb+1|0;if((pb|0)>=(_|0)){Ic=Hc;break b}else ob=Hc}if((oa|0)==204){f[k>>2]=0;f[k+4>>2]=0;T=tT(k,16)|0;U=229832;V=T+16|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));z5(-215,k,229557,229564,408)}}else Ic=1797693134862315708145274.0e284;while(0);k=f[C>>2]|0;if((k|0)!=(ra|0)){if(k|0)ZDc(k);f[C>>2]=ra;f[e>>2]=64}e=f[B>>2]|0;if((e|0)!=(ha|0)){if(e|0)ZDc(e);f[B>>2]=ha;f[$>>2]=64}$=f[A>>2]|0;if(($|0)!=(d|0)){if($|0)ZDc($);f[A>>2]=d;f[W>>2]=64}W=z+36|0;d=f[W>>2]|0;if(d|0?(A=d+12|0,d=f[A>>2]|0,f[A>>2]=d+-1,(d|0)==1):0)_S(z);f[W>>2]=0;W=z+16|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[w>>2]|0)>0){W=f[da>>2]|0;da=0;do{f[W+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[w>>2]|0))}w=f[aa>>2]|0;if((w|0)!=(ea|0))g0(w);w=y+36|0;ea=f[w>>2]|0;do if(ea|0){aa=ea+12|0;da=f[aa>>2]|0;f[aa>>2]=da+-1;if((da|0)!=1)break;_S(y)}while(0);f[w>>2]=0;w=y+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[M>>2]|0)>0){w=f[fa>>2]|0;fa=0;do{f[w+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[M>>2]|0))}M=f[ja>>2]|0;if((M|0)!=(ga|0))g0(M);M=x+36|0;ga=f[M>>2]|0;do if(ga|0){ja=ga+12|0;fa=f[ja>>2]|0;f[ja>>2]=fa+-1;if((fa|0)!=1)break;_S(x)}while(0);f[M>>2]=0;M=x+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[ma>>2]|0)>0){M=f[ca>>2]|0;ca=0;do{f[M+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[ma>>2]|0))}ma=f[na>>2]|0;if((ma|0)!=(ba|0))g0(ma);ma=v+36|0;ba=f[ma>>2]|0;do if(ba|0){na=ba+12|0;ca=f[na>>2]|0;f[na>>2]=ca+-1;if((ca|0)!=1)break;_S(v)}while(0);f[ma>>2]=0;ma=v+16|0;ba=v+4|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ba>>2]|0)>0){ma=f[v+40>>2]|0;ca=0;do{f[ma+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[ba>>2]|0))}ba=f[v+44>>2]|0;if((ba|0)!=(v+48|0))g0(ba);ba=t+36|0;v=f[ba>>2]|0;do if(v|0){ca=v+12|0;ma=f[ca>>2]|0;f[ca>>2]=ma+-1;if((ma|0)!=1)break;_S(t)}while(0);f[ba>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[S>>2]|0)>0){L=f[G>>2]|0;G=0;do{f[L+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[S>>2]|0))}S=f[N>>2]|0;if((S|0)!=(I|0))g0(S);S=r+36|0;I=f[S>>2]|0;do if(I|0){N=I+12|0;G=f[N>>2]|0;f[N>>2]=G+-1;if((G|0)!=1)break;_S(r)}while(0);f[S>>2]=0;S=r+16|0;I=r+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[I>>2]|0)>0){S=f[r+40>>2]|0;G=0;do{f[S+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[I>>2]|0))}I=f[r+44>>2]|0;if((I|0)!=(r+48|0))g0(I);I=q+36|0;r=f[I>>2]|0;do if(r|0){G=r+12|0;S=f[G>>2]|0;f[G>>2]=S+-1;if((S|0)!=1)break;_S(q)}while(0);f[I>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[R>>2]|0)>0){a=f[q+40>>2]|0;q=0;do{f[a+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[R>>2]|0))}R=f[g>>2]|0;if((R|0)==(H|0)){u=j;return +Ic}g0(R);u=j;return +Ic}function h2(a){a=a|0;YDc(a);return}function i2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;b=a+16|0;e=f[b>>2]|0;g=f[e+8>>2]|0;h=f[e+12>>2]|0;if((c|0)>=(d|0))return;e=a+12|0;i=a+4|0;j=a+8|0;if((g|0)>0)k=c;else{a=f[i>>2]|0;l=f[j>>2]|0;m=c;do{p[a+(m<<3)>>3]=1797693134862315708145274.0e284;f[l+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(d|0));return}do{m=f[e>>2]|0;l=(f[m+16>>2]|0)+(Y(f[f[m+44>>2]>>2]|0,k)|0)|0;m=0;n=1797693134862315708145274.0e284;a=0;do{c=f[b>>2]|0;o=+OO(l,(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,m)|0)|0,h);c=n>o;a=c?m:a;n=c?o:n;m=m+1|0}while((m|0)!=(g|0));p[(f[i>>2]|0)+(k<<3)>>3]=n;f[(f[j>>2]|0)+(k<<2)>>2]=a;k=k+1|0}while((k|0)!=(d|0));return}function j2(a){a=a|0;YDc(a);return}function k2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;b=a+16|0;e=f[b>>2]|0;g=f[e+12>>2]|0;if((c|0)>=(d|0))return;h=a+12|0;i=a+8|0;j=a+4|0;a=c;c=e;while(1){e=f[h>>2]|0;k=(f[e+16>>2]|0)+(Y(f[f[e+44>>2]>>2]|0,a)|0)|0;l=+OO(k,(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,f[(f[i>>2]|0)+(a<<2)>>2]|0)|0)|0,g);p[(f[j>>2]|0)+(a<<3)>>3]=l;k=a+1|0;if((k|0)==(d|0))break;a=k;c=f[b>>2]|0}return}function l2(a){a=a|0;YDc(a);return}function m2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0;c=u;u=u+16|0;d=c;e=f[b>>2]|0;g=f[b+4>>2]|0;b=a+8|0;h=f[b>>2]|0;i=f[h+12>>2]|0;if((e|0)>=(g|0)){u=c;return}j=a+16|0;k=a+12|0;l=a+4|0;a=e;e=h;while(1){h=f[e+16>>2]|0;m=f[f[e+44>>2]>>2]|0;o=h+(Y(m,a)|0)|0;p=+OO(o,h+(Y(f[j>>2]|0,m)|0)|0,i);n[d>>2]=p;m=(f[k>>2]|0)+(a<<2)|0;f[(f[l>>2]|0)+(a<<2)>>2]=f[(+n[m>>2]<p?m:d)>>2];m=a+1|0;if((m|0)==(g|0))break;a=m;e=f[b>>2]|0}u=c;return}function n2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return o2(a,b,c,d,e,f)|0}function o2(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0;h=b>>>2;b=e>>>2;e=(c|0)>0;a:do if(e){i=(d|0)==0;j=i|(g|0)<1;k=i|(g|0)<1;i=1;l=0;while(1){m=l;l=l+1|0;o=(l|0)<(c|0);if(o){p=m;q=l;while(1){r=a+((Y(q,h)|0)+m<<2)|0;s=+L(+(+n[r>>2]));r=a+((Y(p,h)|0)+m<<2)|0;t=s>+L(+(+n[r>>2]));r=t?q:p;q=q+1|0;if((q|0)==(c|0)){u=r;break}else p=r}}else u=m;p=Y(u,h)|0;if(+L(+(+n[a+(p+m<<2)>>2]))<1.1920928955078125e-06){v=0;break}if((u|0)==(m|0))w=i;else{q=Y(m,h)|0;r=m;do{t=a+(r+q<<2)|0;x=a+(r+p<<2)|0;y=f[t>>2]|0;f[t>>2]=f[x>>2];f[x>>2]=y;r=r+1|0}while((r|0)!=(c|0));if(!k){r=Y(m,b)|0;p=Y(u,b)|0;q=0;do{y=d+(q+r<<2)|0;x=d+(q+p<<2)|0;t=f[y>>2]|0;f[y>>2]=f[x>>2];f[x>>2]=t;q=q+1|0}while((q|0)!=(g|0))}w=0-i|0}q=Y(m,h)|0;s=-1.0/+n[a+(q+m<<2)>>2];if(!o){z=w;break a}p=Y(m,b)|0;r=l;do{t=Y(r,h)|0;A=s*+n[a+(t+m<<2)>>2];x=l;do{y=a+(x+t<<2)|0;n[y>>2]=+n[y>>2]+A*+n[a+(x+q<<2)>>2];x=x+1|0}while((x|0)!=(c|0));if(!j){x=Y(r,b)|0;t=0;do{y=d+(t+x<<2)|0;n[y>>2]=+n[y>>2]+A*+n[d+(t+p<<2)>>2];t=t+1|0}while((t|0)!=(g|0))}r=r+1|0}while((r|0)!=(c|0));if(!o){z=w;break a}else i=w}return v|0}else z=1;while(0);if(e&(d|0)!=0&(g|0)>0)B=c;else{v=z;return v|0}do{e=B;B=B+-1|0;w=Y(B,b)|0;u=Y(B,h)|0;i=a+(u+B<<2)|0;if((e|0)<(c|0)){j=0;do{l=d+(j+w<<2)|0;s=+n[l>>2];k=e;do{r=d+((Y(k,b)|0)+j<<2)|0;s=s-+n[a+(k+u<<2)>>2]*+n[r>>2];k=k+1|0}while((k|0)!=(c|0));n[l>>2]=s/+n[i>>2];j=j+1|0}while((j|0)!=(g|0))}else{j=0;do{u=d+(j+w<<2)|0;n[u>>2]=+n[u>>2]/+n[i>>2];j=j+1|0}while((j|0)!=(g|0))}}while((e|0)>1);v=z;return v|0}function p2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return q2(a,b,c,d,e,f)|0}function q2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0;g=b>>>3;b=e>>>3;e=(c|0)>0;a:do if(e){h=(d|0)==0;i=h|(f|0)<1;j=h|(f|0)<1;h=1;k=0;while(1){l=k;k=k+1|0;m=(k|0)<(c|0);if(m){n=l;o=k;while(1){q=a+((Y(o,g)|0)+l<<3)|0;r=+L(+(+p[q>>3]));q=a+((Y(n,g)|0)+l<<3)|0;s=r>+L(+(+p[q>>3]));q=s?o:n;o=o+1|0;if((o|0)==(c|0)){t=q;break}else n=q}}else t=l;n=Y(t,g)|0;if(+L(+(+p[a+(n+l<<3)>>3]))<2.220446049250313e-14){u=0;break}if((t|0)==(l|0))v=h;else{o=Y(l,g)|0;q=l;do{s=a+(q+o<<3)|0;w=a+(q+n<<3)|0;r=+p[s>>3];p[s>>3]=+p[w>>3];p[w>>3]=r;q=q+1|0}while((q|0)!=(c|0));if(!j){q=Y(l,b)|0;n=Y(t,b)|0;o=0;do{w=d+(o+q<<3)|0;s=d+(o+n<<3)|0;r=+p[w>>3];p[w>>3]=+p[s>>3];p[s>>3]=r;o=o+1|0}while((o|0)!=(f|0))}v=0-h|0}o=Y(l,g)|0;r=-1.0/+p[a+(o+l<<3)>>3];if(!m){x=v;break a}n=Y(l,b)|0;q=k;do{s=Y(q,g)|0;y=r*+p[a+(s+l<<3)>>3];w=k;do{z=a+(w+s<<3)|0;p[z>>3]=+p[z>>3]+y*+p[a+(w+o<<3)>>3];w=w+1|0}while((w|0)!=(c|0));if(!i){w=Y(q,b)|0;s=0;do{z=d+(s+w<<3)|0;p[z>>3]=+p[z>>3]+y*+p[d+(s+n<<3)>>3];s=s+1|0}while((s|0)!=(f|0))}q=q+1|0}while((q|0)!=(c|0));if(!m){x=v;break a}else h=v}return u|0}else x=1;while(0);if(e&(d|0)!=0&(f|0)>0)A=c;else{u=x;return u|0}do{e=A;A=A+-1|0;v=Y(A,b)|0;t=Y(A,g)|0;h=a+(t+A<<3)|0;if((e|0)<(c|0)){i=0;do{k=d+(i+v<<3)|0;r=+p[k>>3];j=e;do{q=d+((Y(j,b)|0)+i<<3)|0;r=r-+p[a+(j+t<<3)>>3]*+p[q>>3];j=j+1|0}while((j|0)!=(c|0));p[k>>3]=r/+p[h>>3];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{t=d+(i+v<<3)|0;p[t>>3]=+p[t>>3]/+p[h>>3];i=i+1|0}while((i|0)!=(f|0))}}while((e|0)>1);u=x;return u|0}function r2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return s2(a,b,c,d,e,f)|0}function s2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=b>>>2;b=e>>>2;e=(c|0)>0;a:do if(e){h=0;while(1){i=(h|0)>0;j=Y(h,g)|0;if(i){k=0;do{l=a+(k+j<<2)|0;m=+n[l>>2];o=Y(k,g)|0;if((k|0)>0){p=m;q=0;while(1){r=p-+n[a+(q+j<<2)>>2]*+n[a+(q+o<<2)>>2];q=q+1|0;if((q|0)==(k|0)){s=r;break}else p=r}}else s=m;n[l>>2]=s*+n[a+(o+k<<2)>>2];k=k+1|0}while((k|0)!=(h|0));k=a+(j+h<<2)|0;p=+n[k>>2];if(i){q=0;r=p;while(1){t=+n[a+(q+j<<2)>>2];u=r-t*t;q=q+1|0;if((q|0)==(h|0)){v=u;w=k;break}else r=u}}else{v=p;w=k}}else{q=a+(j+h<<2)|0;v=+n[q>>2];w=q}if(v<1.1920928955078125e-07){x=0;break}r=1.0/+M(+v);n[w>>2]=r;h=h+1|0;if((h|0)>=(c|0))break a}return x|0}while(0);if(!d){if(e)y=0;else{x=1;return x|0}do{w=a+((Y(y,g)|0)+y<<2)|0;n[w>>2]=1.0/+n[w>>2];y=y+1|0}while((y|0)!=(c|0));x=1;return x|0}if(!e){x=1;return x|0}if((f|0)>0){y=0;do{w=Y(y,b)|0;h=Y(y,g)|0;q=a+(h+y<<2)|0;if((y|0)>0){i=0;do{z=d+(i+w<<2)|0;A=0;v=+n[z>>2];do{B=d+((Y(A,b)|0)+i<<2)|0;v=v-+n[a+(A+h<<2)>>2]*+n[B>>2];A=A+1|0}while((A|0)!=(y|0));n[z>>2]=v*+n[q>>2];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{h=d+(i+w<<2)|0;n[h>>2]=+n[h>>2]*+n[q>>2];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0}while((y|0)!=(c|0));y=c+-1|0;if(!e){x=1;return x|0}if((f|0)>0){i=y;while(1){q=Y(i,b)|0;w=a+((Y(i,g)|0)+i<<2)|0;if((y|0)>(i|0)){h=0;do{A=d+(h+q<<2)|0;j=y;p=+n[A>>2];do{k=a+((Y(j,g)|0)+i<<2)|0;B=d+((Y(j,b)|0)+h<<2)|0;p=p-+n[k>>2]*+n[B>>2];j=j+-1|0}while((j|0)>(i|0));n[A>>2]=p*+n[w>>2];h=h+1|0}while((h|0)!=(f|0))}else{h=0;do{j=d+(h+q<<2)|0;n[j>>2]=+n[j>>2]*+n[w>>2];h=h+1|0}while((h|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else break}if(!e){x=1;return x|0}else C=0}else C=0}else C=0;do{e=a+((Y(C,g)|0)+C<<2)|0;n[e>>2]=1.0/+n[e>>2];C=C+1|0}while((C|0)!=(c|0));x=1;return x|0}function t2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return u2(a,b,c,d,e,f)|0}function u2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=b>>>3;b=e>>>3;e=(c|0)>0;a:do if(e){h=0;while(1){i=(h|0)>0;j=Y(h,g)|0;if(i){k=0;do{l=a+(k+j<<3)|0;m=+p[l>>3];n=Y(k,g)|0;if((k|0)>0){o=m;q=0;while(1){r=o-+p[a+(q+j<<3)>>3]*+p[a+(q+n<<3)>>3];q=q+1|0;if((q|0)==(k|0)){s=r;break}else o=r}}else s=m;p[l>>3]=s*+p[a+(n+k<<3)>>3];k=k+1|0}while((k|0)!=(h|0));k=a+(j+h<<3)|0;o=+p[k>>3];if(i){q=0;r=o;while(1){t=+p[a+(q+j<<3)>>3];u=r-t*t;q=q+1|0;if((q|0)==(h|0)){v=u;w=k;break}else r=u}}else{v=o;w=k}}else{q=a+(j+h<<3)|0;v=+p[q>>3];w=q}if(v<2.220446049250313e-16){x=0;break}r=1.0/+M(+v);p[w>>3]=r;h=h+1|0;if((h|0)>=(c|0))break a}return x|0}while(0);if(!d){if(e)y=0;else{x=1;return x|0}do{w=a+((Y(y,g)|0)+y<<3)|0;p[w>>3]=1.0/+p[w>>3];y=y+1|0}while((y|0)!=(c|0));x=1;return x|0}if(!e){x=1;return x|0}if((f|0)>0){y=0;do{w=Y(y,b)|0;h=Y(y,g)|0;q=a+(h+y<<3)|0;if((y|0)>0){i=0;do{z=d+(i+w<<3)|0;A=0;v=+p[z>>3];do{B=d+((Y(A,b)|0)+i<<3)|0;v=v-+p[a+(A+h<<3)>>3]*+p[B>>3];A=A+1|0}while((A|0)!=(y|0));p[z>>3]=v*+p[q>>3];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{h=d+(i+w<<3)|0;p[h>>3]=+p[h>>3]*+p[q>>3];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0}while((y|0)!=(c|0));y=c+-1|0;if(!e){x=1;return x|0}if((f|0)>0){i=y;while(1){q=Y(i,b)|0;w=a+((Y(i,g)|0)+i<<3)|0;if((y|0)>(i|0)){h=0;do{A=d+(h+q<<3)|0;j=y;o=+p[A>>3];do{k=a+((Y(j,g)|0)+i<<3)|0;B=d+((Y(j,b)|0)+h<<3)|0;o=o-+p[k>>3]*+p[B>>3];j=j+-1|0}while((j|0)>(i|0));p[A>>3]=o*+p[w>>3];h=h+1|0}while((h|0)!=(f|0))}else{h=0;do{j=d+(h+q<<3)|0;p[j>>3]=+p[j>>3]*+p[w>>3];h=h+1|0}while((h|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else break}if(!e){x=1;return x|0}else C=0}else C=0}else C=0;do{e=a+((Y(C,g)|0)+C<<3)|0;p[e>>3]=1.0/+p[e>>3];C=C+1|0}while((C|0)!=(c|0));x=1;return x|0}function v2(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+1072|0;k=j;l=b>>>2;b=h>>>2;h=k+8|0;f[k>>2]=h;m=k+4|0;o=(c|0)==0?(i|0)!=0&1:d+c|0;f[m>>2]=o;if(o>>>0>264){p=XDc(o>>>0>1073741823?-1:o<<2)|0;f[k>>2]=p;q=p}else q=h;p=(i|0)==0?q+(c<<2)|0:i;a:do if((d|0)>0){i=0;o=c;while(1){r=c-i|0;s=(r|0)>0;if(s){t=0;v=0.0;while(1){w=a+((Y(t+i|0,l)|0)+i<<2)|0;x=+n[w>>2];n[q+(t<<2)>>2]=x;y=v+x*x;t=t+1|0;if((t|0)==(o|0)){z=y;break}else v=y}}else z=0.0;v=+n[q>>2];y=v+ +M(+z)*(!(v>=0.0)?-1.0:1.0);n[q>>2]=y;x=+M(+(z+y*y-v*v));if(s?(n[q>>2]=y/x,(o|0)!=1):0){t=1;do{w=q+(t<<2)|0;n[w>>2]=+n[w>>2]/x;t=t+1|0}while((t|0)!=(o|0))}if((i|0)<(c|0)){t=i;do{s=i;x=0.0;do{w=a+((Y(s,l)|0)+t<<2)|0;x=x+ +n[q+(s-i<<2)>>2]*+n[w>>2];s=s+1|0}while((s|0)!=(c|0));A=i;do{s=a+((Y(A,l)|0)+t<<2)|0;n[s>>2]=+n[s>>2]-x*(+n[q+(A-i<<2)>>2]*2.0);A=A+1|0}while((A|0)!=(c|0));t=t+1|0}while((t|0)!=(d|0))}x=+n[q>>2];n[p+(i<<2)>>2]=x*x;if((r|0)>1){x=+n[q>>2];t=1;do{s=a+((Y(t+i|0,l)|0)+i<<2)|0;n[s>>2]=+n[q+(t<<2)>>2]/x;t=t+1|0}while((t|0)!=(o|0))}i=i+1|0;if((i|0)==(d|0))break;else o=o+-1|0}if(g){o=(e|0)>0;if(o){i=0;t=c;while(1){n[q>>2]=1.0;if((c-i|0)>1){r=1;do{s=a+((Y(r+i|0,l)|0)+i<<2)|0;f[q+(r<<2)>>2]=f[s>>2];r=r+1|0}while((r|0)!=(t|0))}r=p+(i<<2)|0;if((i|0)<(c|0)){s=0;do{w=i;x=0.0;do{B=g+((Y(w,b)|0)+s<<2)|0;x=x+ +n[q+(w-i<<2)>>2]*+n[B>>2];w=w+1|0}while((w|0)!=(c|0));C=i;do{w=g+((Y(C,b)|0)+s<<2)|0;n[w>>2]=+n[w>>2]-+n[r>>2]*(x*(+n[q+(C-i<<2)>>2]*2.0));C=C+1|0}while((C|0)!=(c|0));s=s+1|0}while((s|0)!=(e|0))}i=i+1|0;if((i|0)==(d|0))break;else t=t+-1|0}}else{t=0;i=c;while(1){n[q>>2]=1.0;if((c-t|0)>1){s=1;do{r=a+((Y(s+t|0,l)|0)+t<<2)|0;f[q+(s<<2)>>2]=f[r>>2];s=s+1|0}while((s|0)!=(i|0))}t=t+1|0;if((t|0)==(d|0))break;else i=i+-1|0}}i=d+-1|0;if(!o){t=i;while(1){s=a+((Y(t,l)|0)+t<<2)|0;if(+L(+(+n[s>>2]))<1.1920928955078125e-06){D=0;break a}if((t|0)>0)t=t+-1|0;else{D=1;break a}}}if((e|0)==1){t=i;while(1){o=Y(t,l)|0;if((i|0)>(t|0)){s=g+((Y(t,b)|0)<<2)|0;r=i;do{w=g+((Y(r,b)|0)<<2)|0;n[s>>2]=+n[s>>2]-+n[w>>2]*+n[a+(r+o<<2)>>2];r=r+-1|0}while((r|0)>(t|0))}x=+n[a+(o+t<<2)>>2];if(+L(+x)<1.1920928955078125e-06){D=0;break a}r=g+((Y(t,b)|0)<<2)|0;n[r>>2]=+n[r>>2]/x;if((t|0)>0)t=t+-1|0;else{D=1;break a}}}else E=i;while(1){t=Y(E,l)|0;if((i|0)>(E|0)){r=Y(E,b)|0;s=i;do{w=Y(s,b)|0;B=a+(s+t<<2)|0;F=0;do{G=g+(F+r<<2)|0;n[G>>2]=+n[G>>2]-+n[g+(F+w<<2)>>2]*+n[B>>2];F=F+1|0}while((F|0)!=(e|0));s=s+-1|0}while((s|0)>(E|0))}s=a+(t+E<<2)|0;x=+n[s>>2];if(+L(+x)<1.1920928955078125e-06){D=0;break a}r=Y(E,b)|0;o=g+(r<<2)|0;n[o>>2]=+n[o>>2]/x;o=1;do{F=g+(o+r<<2)|0;n[F>>2]=+n[F>>2]/+n[s>>2];o=o+1|0}while((o|0)!=(e|0));if((E|0)>0)E=E+-1|0;else{D=1;break}}}else D=1}else D=1;while(0);if((q|0)==(h|0)){u=j;return D|0}ZDc(q);f[k>>2]=h;f[m>>2]=264;u=j;return D|0}function w2(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+1104|0;k=j;l=b>>>3;b=h>>>3;h=k+8|0;f[k>>2]=h;m=k+4|0;n=(c|0)==0?(i|0)!=0&1:d+c|0;f[m>>2]=n;if(n>>>0>136){o=XDc(n>>>0>536870911?-1:n<<3)|0;f[k>>2]=o;q=o}else q=h;o=(i|0)==0?q+(c<<3)|0:i;a:do if((d|0)>0){i=0;n=c;while(1){r=c-i|0;s=(r|0)>0;if(s){t=0;v=0.0;while(1){w=a+((Y(t+i|0,l)|0)+i<<3)|0;x=+p[w>>3];p[q+(t<<3)>>3]=x;y=v+x*x;t=t+1|0;if((t|0)==(n|0)){z=y;break}else v=y}}else z=0.0;v=+p[q>>3];y=v+ +M(+z)*(!(v>=0.0)?-1.0:1.0);p[q>>3]=y;x=+M(+(z+y*y-v*v));if(s?(p[q>>3]=y/x,(n|0)!=1):0){t=1;do{w=q+(t<<3)|0;p[w>>3]=+p[w>>3]/x;t=t+1|0}while((t|0)!=(n|0))}if((i|0)<(c|0)){t=i;do{s=i;x=0.0;do{w=a+((Y(s,l)|0)+t<<3)|0;x=x+ +p[q+(s-i<<3)>>3]*+p[w>>3];s=s+1|0}while((s|0)!=(c|0));A=i;do{s=a+((Y(A,l)|0)+t<<3)|0;p[s>>3]=+p[s>>3]-x*(+p[q+(A-i<<3)>>3]*2.0);A=A+1|0}while((A|0)!=(c|0));t=t+1|0}while((t|0)!=(d|0))}x=+p[q>>3];p[o+(i<<3)>>3]=x*x;if((r|0)>1){x=+p[q>>3];t=1;do{s=a+((Y(t+i|0,l)|0)+i<<3)|0;p[s>>3]=+p[q+(t<<3)>>3]/x;t=t+1|0}while((t|0)!=(n|0))}i=i+1|0;if((i|0)==(d|0))break;else n=n+-1|0}if(g){n=(e|0)>0;if(n){i=0;t=c;while(1){p[q>>3]=1.0;if((c-i|0)>1){r=1;do{s=a+((Y(r+i|0,l)|0)+i<<3)|0;p[q+(r<<3)>>3]=+p[s>>3];r=r+1|0}while((r|0)!=(t|0))}r=o+(i<<3)|0;if((i|0)<(c|0)){s=0;do{w=i;x=0.0;do{B=g+((Y(w,b)|0)+s<<3)|0;x=x+ +p[q+(w-i<<3)>>3]*+p[B>>3];w=w+1|0}while((w|0)!=(c|0));C=i;do{w=g+((Y(C,b)|0)+s<<3)|0;p[w>>3]=+p[w>>3]-+p[r>>3]*(x*(+p[q+(C-i<<3)>>3]*2.0));C=C+1|0}while((C|0)!=(c|0));s=s+1|0}while((s|0)!=(e|0))}i=i+1|0;if((i|0)==(d|0))break;else t=t+-1|0}}else{t=0;i=c;while(1){p[q>>3]=1.0;if((c-t|0)>1){s=1;do{r=a+((Y(s+t|0,l)|0)+t<<3)|0;p[q+(s<<3)>>3]=+p[r>>3];s=s+1|0}while((s|0)!=(i|0))}t=t+1|0;if((t|0)==(d|0))break;else i=i+-1|0}}i=d+-1|0;if(!n){t=i;while(1){s=a+((Y(t,l)|0)+t<<3)|0;if(+L(+(+p[s>>3]))<2.220446049250313e-14){D=0;break a}if((t|0)>0)t=t+-1|0;else{D=1;break a}}}if((e|0)==1){t=i;while(1){n=Y(t,l)|0;if((i|0)>(t|0)){s=g+((Y(t,b)|0)<<3)|0;r=i;do{w=g+((Y(r,b)|0)<<3)|0;p[s>>3]=+p[s>>3]-+p[w>>3]*+p[a+(r+n<<3)>>3];r=r+-1|0}while((r|0)>(t|0))}x=+p[a+(n+t<<3)>>3];if(+L(+x)<2.220446049250313e-14){D=0;break a}r=g+((Y(t,b)|0)<<3)|0;p[r>>3]=+p[r>>3]/x;if((t|0)>0)t=t+-1|0;else{D=1;break a}}}else E=i;while(1){t=Y(E,l)|0;if((i|0)>(E|0)){r=Y(E,b)|0;s=i;do{w=Y(s,b)|0;B=a+(s+t<<3)|0;F=0;do{G=g+(F+r<<3)|0;p[G>>3]=+p[G>>3]-+p[g+(F+w<<3)>>3]*+p[B>>3];F=F+1|0}while((F|0)!=(e|0));s=s+-1|0}while((s|0)>(E|0))}s=a+(t+E<<3)|0;x=+p[s>>3];if(+L(+x)<2.220446049250313e-14){D=0;break a}r=Y(E,b)|0;n=g+(r<<3)|0;p[n>>3]=+p[n>>3]/x;n=1;do{F=g+(n+r<<3)|0;p[F>>3]=+p[F>>3]/+p[s>>3];n=n+1|0}while((n|0)!=(e|0));if((E|0)>0)E=E+-1|0;else{D=1;break}}}else D=1}else D=1;while(0);if((q|0)==(h|0)){u=j;return D|0}ZDc(q);f[k>>2]=h;f[m>>2]=136;u=j;return D|0}function x2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;y2(a,b,c,0,d);return}function y2(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;h=u;u=u+64|0;i=h;if(!c){f[i>>2]=0;j=i+4|0;f[j>>2]=0;k=tT(i,29)|0;l=k;m=229953;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,274596,229983,30)}if(!((d|0)!=0|(e|0)!=0)){f[i>>2]=0;j=i+4|0;f[j>>2]=0;k=tT(i,29)|0;l=k;m=229953;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,274596,229983,30)}f[a>>2]=c;k=a+8|0;f[k>>2]=e;e=a+4|0;f[e>>2]=d;d=a+12|0;f[d>>2]=g;j=a+16|0;f[j>>2]=0;o=a+20|0;f[o>>2]=0;if((g|0)<0){p=0;while(1)if(!(f[c+(p<<2)>>2]|0))break;else p=p+1|0;f[d>>2]=p;if((p|0)<1001)q=p;else{f[i>>2]=0;f[i+4>>2]=0;l=tT(i,15)|0;m=230057;n=l+15|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,274596,229983,45)}}else q=g;g=a+24|0;f[g>>2]=0;p=(q|0)>0;do if(p){r=f[c>>2]|0;if(!r){f[i>>2]=0;s=i+4|0;f[s>>2]=0;t=tT(i,14)|0;l=t;m=230073;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,274596,229983,52)}else{v=-1;w=-1;x=0;y=0;z=0;A=r}a:while(1){B=f[k>>2]|0;if(!B)C=A+16|0;else{D=A+16|0;f[B+(y<<2)>>2]=f[D>>2];C=D}if(f[C>>2]|0){b:do if((w|0)<0){D=f[A+4>>2]|0;if((D|0)>0){B=f[A+40>>2]|0;E=0;while(1){if((f[B+(E<<2)>>2]|0)>1){F=D;G=y;H=E;break b}I=E+1|0;if((I|0)<(D|0))E=I;else{F=D;G=y;H=I;break}}}else{F=D;G=y;H=0}}else{E=f[A+40>>2]|0;B=f[E+-4>>2]|0;I=f[(f[(f[a>>2]|0)+(w<<2)>>2]|0)+40>>2]|0;if((B|0)!=(f[I+-4>>2]|0)){K=27;break a}if((B|0)==2){if((f[E>>2]|0)!=(f[I>>2]|0)){K=27;break a}if((f[E+4>>2]|0)==(f[I+4>>2]|0)){F=v;G=w;H=x;break}else{K=27;break a}}if((B|0)>0){L=0;while(1){if((f[E+(L<<2)>>2]|0)!=(f[I+(L<<2)>>2]|0)){K=27;break a}L=L+1|0;if((L|0)>=(B|0)){F=v;G=w;H=x;break}}}else{F=v;G=w;H=x}}while(0);if(!(f[A>>2]&16384)){B=F+-1|0;L=f[A+44>>2]|0;I=f[L+(B<<2)>>2]|0;E=f[A+4>>2]|0;if((E|0)>0)M=f[L+(E+-1<<2)>>2]|0;else M=0;if((I|0)!=(M|0)){K=33;break}E=A+40|0;D=I;I=B;while(1){if((I|0)<=(H|0))break;B=Y(f[(f[E>>2]|0)+(I<<2)>>2]|0,D)|0;N=I+-1|0;D=f[L+(N<<2)>>2]|0;if(B>>>0<D>>>0)break;else I=N}D=(z|0)<(I|0)?I:z;f[g>>2]=D;O=F;P=G;Q=H;R=D}else{O=F;P=G;Q=H;R=z}}else{O=v;P=w;Q=x;R=z}y=y+1|0;if((y|0)>=(q|0)){K=39;break}A=f[(f[a>>2]|0)+(y<<2)>>2]|0;if(!A){K=10;break}else{v=O;w=P;x=Q;z=R}}if((K|0)==10){f[i>>2]=0;s=i+4|0;f[s>>2]=0;t=tT(i,14)|0;l=t;m=230073;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,274596,229983,52)}else if((K|0)==27){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,26)|0;m=230088;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,274596,229983,72)}else if((K|0)==33){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,27)|0;m=230115;n=l+27|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,274596,229983,76)}else if((K|0)==39){if((P|0)<=-1){K=45;break}r=O+-1|0;D=f[(f[(f[a>>2]|0)+(P<<2)>>2]|0)+40>>2]|0;L=f[D+(r<<2)>>2]|0;E=r;while(1){f[o>>2]=L;if((E|0)<=(R|0))break;r=E+-1|0;N=f[D+(r<<2)>>2]|0;L=mJc(N|0,((N|0)<0)<<31>>31|0,L|0,0)|0;if(!((L|0)==(L|0)&(J|0)==(((L|0)<0)<<31>>31|0)))break;else E=r}L=(E|0)==(Q|0)?0:E;f[g>>2]=L;f[j>>2]=1;if((L|0)>0){S=1;T=L}else break;do{L=T;T=T+-1|0;S=Y(S,f[D+(T<<2)>>2]|0)|0;f[j>>2]=S}while((L|0)>1)}}else K=45;while(0);if((K|0)==45)f[g>>2]=0;f[a+28>>2]=0;if((f[e>>2]|0)==0|p^1){u=h;return}p=i+4|0;g=i+8|0;S=i+40|0;j=i+48|0;T=i+44|0;Q=i+52|0;R=i+36|0;P=i+16|0;O=i+12|0;t=i+20|0;s=i+24|0;z=i+28|0;x=i+32|0;w=i+36|0;v=i+16|0;A=i+4|0;y=i+40|0;q=i+44|0;H=i+48|0;G=i+8|0;F=i+12|0;M=i+20|0;C=i+24|0;k=i+28|0;c=i+32|0;D=0;while(1){E=f[(f[a>>2]|0)+(D<<2)>>2]|0;if(!E){K=49;break}L=f[E+16>>2]|0;if(!L){f[i>>2]=1124007936;l=p;n=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));f[S>>2]=g;f[T>>2]=j;f[j>>2]=0;f[Q>>2]=0;r=f[e>>2]|0;N=r+(D*56|0)|0;if((N|0)!=(i|0)){B=r+(D*56|0)+36|0;U=f[B>>2]|0;if(U|0?(V=U+12|0,U=f[V>>2]|0,f[V>>2]=U+-1,(U|0)==1):0)_S(N);f[B>>2]=0;U=r+(D*56|0)+16|0;V=r+(D*56|0)+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[V>>2]|0)>0){W=f[r+(D*56|0)+40>>2]|0;X=0;do{f[W+(X<<2)>>2]=0;X=X+1|0;Z=f[V>>2]|0}while((X|0)<(Z|0));f[N>>2]=f[i>>2];if((Z|0)<3)K=60;else K=62}else{f[N>>2]=f[i>>2];K=60}if((K|0)==60){K=0;X=f[p>>2]|0;if((X|0)<3){f[V>>2]=X;f[r+(D*56|0)+8>>2]=f[g>>2];f[r+(D*56|0)+12>>2]=f[O>>2];X=f[T>>2]|0;W=f[r+(D*56|0)+44>>2]|0;f[W>>2]=f[X>>2];f[W+4>>2]=f[X+4>>2]}else K=62}if((K|0)==62){K=0;ZS(N,i)}f[U>>2]=f[P>>2];f[r+(D*56|0)+20>>2]=f[t>>2];f[r+(D*56|0)+24>>2]=f[s>>2];f[r+(D*56|0)+28>>2]=f[z>>2];f[r+(D*56|0)+32>>2]=f[x>>2];f[B>>2]=f[R>>2];X=f[R>>2]|0;if(X|0?(W=X+12|0,X=f[W>>2]|0,f[W>>2]=X+-1,(X|0)==1):0)_S(i)}f[R>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[p>>2]|0)>0){X=f[S>>2]|0;W=0;do{f[X+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[p>>2]|0))}W=f[T>>2]|0;if((W|0)!=(j|0))g0(W)}else{Vj(i,1,f[o>>2]|0,f[E>>2]&4095,L,0);W=f[e>>2]|0;X=W+(D*56|0)|0;if((X|0)!=(i|0)){B=f[w>>2]|0;if(B|0){r=B+12|0;f[r>>2]=(f[r>>2]|0)+1}r=W+(D*56|0)+36|0;B=f[r>>2]|0;if(B|0?(U=B+12|0,B=f[U>>2]|0,f[U>>2]=B+-1,(B|0)==1):0)_S(X);f[r>>2]=0;B=W+(D*56|0)+16|0;U=W+(D*56|0)+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[U>>2]|0)>0){N=f[W+(D*56|0)+40>>2]|0;V=0;do{f[N+(V<<2)>>2]=0;V=V+1|0;_=f[U>>2]|0}while((V|0)<(_|0));f[X>>2]=f[i>>2];if((_|0)<3)K=83;else K=85}else{f[X>>2]=f[i>>2];K=83}if((K|0)==83){K=0;V=f[A>>2]|0;if((V|0)<3){f[U>>2]=V;f[W+(D*56|0)+8>>2]=f[G>>2];f[W+(D*56|0)+12>>2]=f[F>>2];V=f[q>>2]|0;N=f[W+(D*56|0)+44>>2]|0;f[N>>2]=f[V>>2];f[N+4>>2]=f[V+4>>2]}else K=85}if((K|0)==85){K=0;ZS(X,i)}f[B>>2]=f[v>>2];f[W+(D*56|0)+20>>2]=f[M>>2];f[W+(D*56|0)+24>>2]=f[C>>2];f[W+(D*56|0)+28>>2]=f[k>>2];f[W+(D*56|0)+32>>2]=f[c>>2];f[r>>2]=f[w>>2]}V=f[w>>2]|0;if(V|0?(N=V+12|0,V=f[N>>2]|0,f[N>>2]=V+-1,(V|0)==1):0)_S(i);f[w>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){V=f[y>>2]|0;N=0;do{f[V+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[A>>2]|0))}N=f[q>>2]|0;if((N|0)!=(H|0))g0(N)}D=D+1|0;if((D|0)>=(f[d>>2]|0)){K=97;break}}if((K|0)==49){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,14)|0;m=230073;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,274596,229983,113)}else if((K|0)==97){u=h;return}}function z2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;y2(a,b,0,c,d);return}function A2(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=a+28|0;c=f[b>>2]|0;if(c>>>0>=((f[a+16>>2]|0)+-1|0)>>>0)return a|0;d=c+1|0;f[b>>2]=d;b=f[a+24>>2]|0;if((b|0)!=1){c=f[a+12>>2]|0;if((c|0)<=0)return a|0;e=a+8|0;g=a+4|0;h=(d|0)>0&(b|0)>0;i=0;do{j=f[(f[a>>2]|0)+(i<<2)>>2]|0;k=f[j+16>>2]|0;if(k|0){if(h){l=f[j+40>>2]|0;m=f[j+44>>2]|0;j=b;n=k;o=d;while(1){p=j;j=j+-1|0;q=f[l+(j<<2)>>2]|0;r=o;o=(o|0)/(q|0)|0;s=r-(Y(o,q)|0)|0;q=n+(Y(s,f[m+(j<<2)>>2]|0)|0)|0;if(!((o|0)>0&(p|0)>1)){t=q;break}else n=q}}else t=k;n=f[e>>2]|0;if(n|0)f[n+(i<<2)>>2]=t;n=f[g>>2]|0;if(n|0)f[n+(i*56|0)+16>>2]=t}i=i+1|0}while((i|0)<(c|0));return a|0}c=a+8|0;i=f[c>>2]|0;a:do if(i|0?(t=f[a+12>>2]|0,(t|0)>0):0){g=0;e=i;while(1){b=e+(g<<2)|0;if(f[b>>2]|0){h=f[(f[a>>2]|0)+(g<<2)>>2]|0;n=(f[h+16>>2]|0)+(Y(d,f[f[h+44>>2]>>2]|0)|0)|0;f[b>>2]=n}n=g+1|0;if((n|0)>=(t|0))break a;g=n;e=f[c>>2]|0}}while(0);c=f[a+4>>2]|0;if(!c)return a|0;i=f[a+12>>2]|0;if((i|0)<=0)return a|0;e=0;do{g=c+(e*56|0)+16|0;if(f[g>>2]|0){t=f[(f[a>>2]|0)+(e<<2)>>2]|0;k=(f[t+16>>2]|0)+(Y(d,f[f[t+44>>2]>>2]|0)|0)|0;f[g>>2]=k}e=e+1|0}while((e|0)<(i|0));return a|0}function B2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=f[a>>2]|0;if(f[d>>2]&16384|0){e=a+12|0;g=a+8|0;h=(f[(c?g:e)>>2]|0)+(Y(f[a+4>>2]|0,b)|0)|0;f[g>>2]=h;i=f[e>>2]|0;if(h>>>0<i>>>0){f[g>>2]=i;return}i=f[a+16>>2]|0;if(h>>>0<=i>>>0)return;f[g>>2]=i;return}i=f[d+4>>2]|0;if((i|0)==2){if(c){g=f[d+16>>2]|0;h=(f[a+8>>2]|0)-g|0;e=f[f[d+44>>2]>>2]|0;j=(h>>>0)/(e>>>0)|0;k=f[d+12>>2]|0;l=Y(k,j)|0;m=h-(Y(j,e)|0)|0;j=a+4|0;h=f[j>>2]|0;n=l+b+((m>>>0)/(h>>>0)|0)|0;o=j;p=k;q=e;r=g;s=h}else{h=a+4|0;n=b;o=h;p=f[d+12>>2]|0;q=f[f[d+44>>2]>>2]|0;r=f[d+16>>2]|0;s=f[h>>2]|0}h=(n|0)/(p|0)|0;g=(h|0)<0;e=f[d+8>>2]|0;k=e+-1|0;j=g?0:h;m=r+(Y(q,(k|0)<(j|0)?k:j)|0)|0;f[a+12>>2]=m;j=m+(Y(s,p)|0)|0;f[a+16>>2]=j;if(!g)if((h|0)<(e|0)){e=n-(Y(p,h)|0)|0;t=m+(Y(e,f[o>>2]|0)|0)|0}else t=j;else t=m;f[a+8>>2]=t;return}if(c){if((i|0)>0){c=f[d+44>>2]|0;t=f[d+40>>2]|0;m=(f[a+8>>2]|0)-(f[d+16>>2]|0)|0;j=0;o=0;while(1){e=f[c+(o<<2)>>2]|0;h=(m>>>0)/(e>>>0)|0;m=m-(Y(h,e)|0)|0;e=(Y(f[t+(o<<2)>>2]|0,j)|0)+h|0;o=o+1|0;if((o|0)==(i|0)){u=e;break}else j=e}}else u=0;v=u+b|0}else v=b;b=(v|0)>0?v:0;v=f[d+40>>2]|0;u=f[v+(i+-1<<2)>>2]|0;j=(b|0)/(u|0)|0;o=b-(Y(j,u)|0)|0;b=f[d+16>>2]|0;t=f[a+4>>2]|0;m=Y(o,t)|0;o=a+8|0;f[o>>2]=b+m;c=a+12|0;f[c>>2]=b;e=i+-2|0;if((e|0)>-1){i=f[d+44>>2]|0;d=e;e=j;h=b;while(1){p=f[v+(d<<2)>>2]|0;n=e;e=(e|0)/(p|0)|0;g=n-(Y(e,p)|0)|0;h=h+(Y(g,f[i+(d<<2)>>2]|0)|0)|0;if((d|0)<=0)break;else d=d+-1|0}f[c>>2]=h;w=e;x=h}else{w=j;x=b}b=x+(Y(t,u)|0)|0;f[a+16>>2]=b;f[o>>2]=(w|0)>0?b:x+m|0;return}function C2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=f[a>>2]|0;e=f[d+4>>2]|0;do if(b){if((e|0)==2){g=Y(f[(f[d+40>>2]|0)+4>>2]|0,f[b>>2]|0)|0;h=g+(f[b+4>>2]|0)|0;break}if((e|0)>0){g=f[d+40>>2]|0;i=0;j=0;while(1){k=Y(f[g+(j<<2)>>2]|0,i)|0;l=k+(f[b+(j<<2)>>2]|0)|0;j=j+1|0;if((j|0)==(e|0)){h=l;break}else i=l}}else h=0}else h=0;while(0);B2(a,h,c);return}function D2(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0;e=u;u=u+1264|0;g=e+1208|0;h=e+1152|0;i=e+8|0;j=e+1136|0;k=e;l=e+1104|0;m=e+40|0;do if((d$(c)|0)==65536){n=f[c+4>>2]|0;f[g>>2]=f[n>>2];o=g+4|0;q=n+4|0;f[o>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[n+8>>2];f[g+12>>2]=f[n+12>>2];f[g+16>>2]=f[n+16>>2];f[g+20>>2]=f[n+20>>2];f[g+24>>2]=f[n+24>>2];f[g+28>>2]=f[n+28>>2];f[g+32>>2]=f[n+32>>2];s=f[n+36>>2]|0;f[g+36>>2]=s;f[g+40>>2]=r;r=g+48|0;t=g+44|0;f[t>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[n+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[o>>2]=0;ZS(g,n);break}}else a$(g,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];n=h+4|0;o=c+4|0;f[n>>2]=f[o>>2];q=h+8|0;f[q>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];r=h+16|0;f[r>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];t=f[c+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=q;q=h+48|0;s=h+44|0;f[s>>2]=q;f[q>>2]=0;f[h+52>>2]=0;if(t|0){q=t+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[o>>2]|0)<3){o=f[c+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];v=r;break}else{f[n>>2]=0;ZS(h,c);v=r;break}}else{a$(h,d,-1);v=h+16|0}while(0);if(f[v>>2]|0){d=f[h+4>>2]|0;if((d|0)<3)w=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{r=f[h+40>>2]|0;c=0;n=1;while(1){o=Y(f[r+(c<<2)>>2]|0,n)|0;c=c+1|0;if((c|0)==(d|0)){w=o;break}else n=o}}if(!((d|0)==0|(w|0)==0)?f[h>>2]&4095|0:0){f[i>>2]=0;f[i+4>>2]=0;x=tT(i,36)|0;y=230143;z=x+36|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));E2(i,230180,112)}}w=f[g>>2]|0;d=w>>>3&511;n=d+1|0;c=w&7;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;w=D6(c)|0;if(!(n>>>0<5&(w|0)!=0)){f[j>>2]=0;f[j+4>>2]=0;x=tT(j,20)|0;y=241864;z=x+20|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));E2(j,230180,121)}f[j>>2]=g;f[j+4>>2]=h;f[j+8>>2]=0;y=k;f[y>>2]=0;f[y+4>>2]=0;z2(l,j,k,-1);j=f[l+20>>2]|0;y=m+8|0;f[m>>2]=y;x=m+4|0;f[x>>2]=264;z=c>>>0<4;if(z){r=c>>>0<2?8388608:32768;c=(r|0)<(j|0)?r:j;f[x>>2]=n;XIc(y|0,0,(d<<2)+4|0)|0;d=f[g+4>>2]|0;if((d|0)>0){A=f[(f[g+44>>2]|0)+(d+-1<<2)>>2]|0;B=y;C=c;D=r}else{A=0;B=y;C=c;D=r}}else{A=0;B=i;C=j;D=0}r=l+16|0;c=(j|0)>0;d=k+4|0;o=0;q=0;s=0;while(1){if(o>>>0>=(f[r>>2]|0)>>>0)break;t=o+1|0;a:do if(c){E=f[k>>2]|0;F=f[d>>2]|0;if(z){G=0;H=q;I=s;J=E;K=F}else{L=0;M=q;N=s;O=E;E=F;while(1){F=j-L|0;P=(C|0)<(F|0)?C:F;F=_h[w&127](O,E,B,P,n)|0;Q=F+N|0;R=F+M|0;F=Y(P,A)|0;O=(f[k>>2]|0)+F|0;f[k>>2]=O;F=f[d>>2]|0;if(!F)S=0;else{T=F+P|0;f[d>>2]=T;S=T}L=L+C|0;if((j|0)<=(L|0)){U=R;V=Q;break a}else{M=R;N=Q;E=S}}}while(1){E=j-G|0;N=(C|0)<(E|0)?C:E;E=_h[w&127](J,K,B,N,n)|0;M=E+I|0;L=E+H|0;if((M+C|0)<(D|0)?((N+G|0)<(j|0)?1:t>>>0<(f[r>>2]|0)>>>0):0)W=M;else{X=0;Z=34}if((Z|0)==34)while(1){Z=0;M=B+(X<<2)|0;E=i+(X<<3)|0;p[E>>3]=+p[E>>3]+ +(f[M>>2]|0);f[M>>2]=0;X=X+1|0;if((X|0)==(n|0)){W=0;break}else Z=34}M=Y(N,A)|0;J=(f[k>>2]|0)+M|0;f[k>>2]=J;M=f[d>>2]|0;if(!M)_=0;else{E=M+N|0;f[d>>2]=E;_=E}G=G+C|0;if((j|0)<=(G|0)){U=L;V=W;break}else{H=L;I=W;K=_}}}else{U=q;V=s}while(0);A2(l)|0;o=t;q=U;s=V}$=(q|0)==0?0.0:1.0/+(q>>>0);aa=$*+p[i+8>>3];ba=$*+p[i+16>>3];ca=$*+p[i+24>>3];p[a>>3]=$*+p[i>>3];p[a+8>>3]=aa;p[a+16>>3]=ba;p[a+24>>3]=ca;a=f[m>>2]|0;if((a|0)!=(y|0)){if(a|0)ZDc(a);f[m>>2]=y;f[x>>2]=264}x=h+36|0;y=f[x>>2]|0;if(y|0?(m=y+12|0,y=f[m>>2]|0,f[m>>2]=y+-1,(y|0)==1):0)_S(h);f[x>>2]=0;x=h+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[x>>2]|0)>0){v=f[h+40>>2]|0;y=0;do{f[v+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)!=(h+48|0))g0(x);x=g+36|0;h=f[x>>2]|0;if(h|0?(y=h+12|0,h=f[y>>2]|0,f[y>>2]=h+-1,(h|0)==1):0)_S(g);f[x>>2]=0;x=g+16|0;h=g+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[h>>2]|0)>0){x=f[g+40>>2]|0;y=0;do{f[x+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}g0(h);u=e;return}function E2(a,b,c){a=a|0;b=b|0;c=c|0;z5(-215,a,b,230185,c);return}function F2(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0;g=u;u=u+1344|0;h=g+1288|0;i=g+1232|0;j=g+1216|0;k=g+1112|0;l=g+1184|0;m=g+16|0;n=g;o=g+1128|0;q=g+1120|0;if(r$(a)|0){f[h>>2]=0;f[h+4>>2]=0;r=tT(h,13)|0;s=371005;t=r+13|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));E2(h,230248,807)}if(!(r$(e)|0)?c$(e,-1)|0:0){f[h>>2]=0;f[h+4>>2]=0;r=tT(h,40)|0;s=230259;t=r+40|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));E2(h,230248,808)}do if((d$(a)|0)==65536){v=f[a+4>>2]|0;f[h>>2]=f[v>>2];w=h+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=h+8|0;f[y>>2]=f[v+8>>2];f[h+12>>2]=f[v+12>>2];f[h+16>>2]=f[v+16>>2];f[h+20>>2]=f[v+20>>2];f[h+24>>2]=f[v+24>>2];f[h+28>>2]=f[v+28>>2];f[h+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[h+36>>2]=z;f[h+40>>2]=y;y=h+48|0;A=h+44|0;f[A>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;ZS(h,v);break}}else a$(h,a,-1);while(0);do if((d$(e)|0)==65536){a=f[e+4>>2]|0;f[i>>2]=f[a>>2];v=i+4|0;w=a+4|0;f[v>>2]=f[w>>2];x=i+8|0;f[x>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[i+36>>2]=y;f[i+40>>2]=x;x=i+48|0;A=i+44|0;f[A>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;ZS(i,a);break}}else a$(i,e,-1);while(0);e=f[h>>2]|0;a=e>>>3;v=a&511;w=v+1|0;x=e&7;e=f[45952+(x<<2)>>2]|0;if((x|0)==7){f[j>>2]=0;f[j+4>>2]=0;r=tT(j,9)|0;s=251213;t=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));E2(j,230248,824)}f[j>>2]=h;f[j+4>>2]=i;f[j+8>>2]=0;A=k;f[A>>2]=0;f[A+4>>2]=0;z2(l,j,k,-1);j=f[l+20>>2]|0;A=m+8|0;f[m>>2]=A;y=m+4|0;f[y>>2]=w<<2;if(w>>>0>34){z=XDc(w<<5)|0;f[m>>2]=z;B=z}else B=A;z=B+(w<<3)|0;C=x>>>0<4;D=0;do{p[z+(D<<3)>>3]=0.0;p[B+(D<<3)>>3]=0.0;D=D+1|0}while((D|0)!=(w|0));D=x>>>0<2;if(C){x=(j|0)<32768;E=z+(w<<3)|0;F=D?E+(w<<2)|0:z;G=0;do{f[F+(G<<2)>>2]=0;f[E+(G<<2)>>2]=0;G=G+1|0}while((G|0)!=(w|0));G=x?j:32768;x=f[h+4>>2]|0;if((x|0)>0){H=f[(f[h+44>>2]|0)+(x+-1<<2)>>2]|0;I=E;J=G;K=32768;L=F}else{H=0;I=E;J=G;K=32768;L=F}}else{H=0;I=B;J=j;K=0;L=z}F=l+16|0;G=(j|0)>0;E=k+4|0;x=0;N=0;O=0;while(1){if(O>>>0>=(f[F>>2]|0)>>>0)break;P=O+1|0;a:do if(G){Q=f[k>>2]|0;R=f[E>>2]|0;if(C){S=0;T=x;U=N;V=Q;W=R}else{X=0;Z=x;_=N;$=Q;Q=R;while(1){R=j-X|0;aa=(J|0)<(R|0)?J:R;R=xg[e&127]($,Q,I,L,aa,w)|0;ba=R+Z|0;ca=R+_|0;R=Y(aa,H)|0;$=(f[k>>2]|0)+R|0;f[k>>2]=$;R=f[E>>2]|0;if(!R)da=0;else{ea=R+aa|0;f[E>>2]=ea;da=ea}X=X+J|0;if((j|0)<=(X|0)){fa=ba;ga=ca;break a}else{Z=ba;_=ca;Q=da}}}while(1){Q=j-S|0;_=(J|0)<(Q|0)?J:Q;Q=xg[e&127](V,W,I,L,_,w)|0;Z=Q+T|0;X=Q+U|0;if((Z+J|0)<(K|0)?((_+S|0)<(j|0)?1:P>>>0<(f[F>>2]|0)>>>0):0)ha=Z;else{ia=0;ja=37}if((ja|0)==37){while(1){ja=0;Z=I+(ia<<2)|0;Q=B+(ia<<3)|0;p[Q>>3]=+p[Q>>3]+ +(f[Z>>2]|0);f[Z>>2]=0;ia=ia+1|0;if((ia|0)==(w|0))break;else ja=37}if(D){Z=0;do{Q=L+(Z<<2)|0;$=z+(Z<<3)|0;p[$>>3]=+p[$>>3]+ +(f[Q>>2]|0);f[Q>>2]=0;Z=Z+1|0}while((Z|0)!=(w|0));ha=0}else ha=0}Z=Y(_,H)|0;V=(f[k>>2]|0)+Z|0;f[k>>2]=V;Z=f[E>>2]|0;if(!Z)ka=0;else{Q=Z+_|0;f[E>>2]=Q;ka=Q}S=S+J|0;if((j|0)<=(S|0)){fa=ha;ga=X;break}else{T=ha;U=X;W=ka}}}else{fa=x;ga=N}while(0);A2(l)|0;x=fa;N=ga;O=P}la=(N|0)==0?0.0:1.0/+(N|0);N=0;do{O=B+(N<<3)|0;ma=la*+p[O>>3];p[O>>3]=ma;O=z+(N<<3)|0;na=la*+p[O>>3]-ma*ma;ma=+M(+(na<0.0?0.0:na));p[O>>3]=ma;N=N+1|0}while((N|0)!=(w|0));N=n+8|0;O=n+12|0;ga=n+4|0;fa=o+4|0;x=o+8|0;l=o+12|0;ka=o+16|0;W=o+20|0;U=o+24|0;ha=o+28|0;T=o+32|0;S=o+36|0;j=o+40|0;J=o+48|0;E=o+44|0;V=o+52|0;k=(a|536870400)^511;a=0;while(1){H=(a|0)==0;L=H?B:z;D=H?c:d;H=D;ia=f[H+4>>2]|0;I=n;f[I>>2]=f[H>>2];f[I+4>>2]=ia;f[N>>2]=f[D+8>>2];f[O>>2]=f[D+12>>2];if($$(n)|0){if(!(W$(n)|0))Y$(n,w,1,6,-1,1,0);do if((d$(n)|0)==65536){D=f[ga>>2]|0;f[o>>2]=f[D>>2];ia=D+4|0;f[fa>>2]=f[ia>>2];f[x>>2]=f[D+8>>2];f[l>>2]=f[D+12>>2];f[ka>>2]=f[D+16>>2];f[W>>2]=f[D+20>>2];f[U>>2]=f[D+24>>2];f[ha>>2]=f[D+28>>2];f[T>>2]=f[D+32>>2];I=f[D+36>>2]|0;f[S>>2]=I;f[j>>2]=x;f[E>>2]=J;f[J>>2]=0;f[V>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[ia>>2]|0)<3){ia=f[D+44>>2]|0;H=f[E>>2]|0;f[H>>2]=f[ia>>2];f[H+4>>2]=f[ia+4>>2];break}else{f[fa>>2]=0;ZS(o,D);break}}else a$(o,n,-1);while(0);P=f[fa>>2]|0;if((P|0)<3)oa=Y(f[l>>2]|0,f[x>>2]|0)|0;else{D=f[j>>2]|0;ia=0;H=1;while(1){I=Y(f[D+(ia<<2)>>2]|0,H)|0;ia=ia+1|0;if((ia|0)==(P|0)){oa=I;break}else H=I}}if((f[o>>2]&20479|0)!=16390){ja=68;break}if((f[l>>2]|0)==1){if((oa|0)<=(v|0)){ja=68;break}}else if((oa|0)<=(v|0)|(f[x>>2]|0)!=1){ja=68;break}H=f[ka>>2]|0;P=0;do{p[H+(P<<3)>>3]=+p[L+(P<<3)>>3];P=P+1|0}while((P|0)!=(w|0));if((w|0)<(oa|0))XIc(H+(w<<3)|0,0,k+oa<<3|0)|0;P=f[S>>2]|0;if(P|0?(L=P+12|0,P=f[L>>2]|0,f[L>>2]=P+-1,(P|0)==1):0)_S(o);f[S>>2]=0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[fa>>2]|0)>0){P=f[j>>2]|0;L=0;do{f[P+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[fa>>2]|0))}L=f[E>>2]|0;if((L|0)!=(J|0))g0(L)}a=a+1|0;if((a|0)>=2){ja=83;break}}if((ja|0)==68){f[q>>2]=0;f[q+4>>2]=0;r=tT(q,91)|0;s=230300;t=r+91|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));E2(q,230248,902)}else if((ja|0)==83){ja=f[m>>2]|0;if((ja|0)!=(A|0)){if(ja|0)ZDc(ja);f[m>>2]=A;f[y>>2]=136}y=i+36|0;A=f[y>>2]|0;if(A|0?(m=A+12|0,A=f[m>>2]|0,f[m>>2]=A+-1,(A|0)==1):0)_S(i);f[y>>2]=0;y=i+16|0;A=i+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[A>>2]|0)>0){y=f[i+40>>2]|0;m=0;do{f[y+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[A>>2]|0))}A=f[i+44>>2]|0;if((A|0)!=(i+48|0))g0(A);A=h+36|0;i=f[A>>2]|0;if(i|0?(m=i+12|0,i=f[m>>2]|0,f[m>>2]=i+-1,(i|0)==1):0)_S(h);f[A>>2]=0;A=h+16|0;i=h+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[i>>2]|0)>0){A=f[h+40>>2]|0;m=0;do{f[A+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=g;return}g0(i);u=g;return}}function G2(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[d>>2]|0;l=f[e>>2]|0;if((g|0)>0){m=a;n=k;o=l;p=0;while(1){q=h[m>>0]|0;r=q+n|0;s=(Y(q,q)|0)+o|0;p=p+1|0;if((p|0)==(g|0)){t=r;u=s;break}else{m=m+i|0;n=r;o=s}}}else{t=k;u=l}f[d>>2]=t;f[e>>2]=u;break}case 2:{u=f[d>>2]|0;t=d+4|0;l=f[t>>2]|0;k=f[e>>2]|0;o=e+4|0;n=f[o>>2]|0;if((g|0)>0){m=u;p=l;s=k;r=n;q=0;v=a;while(1){w=h[v>>0]|0;x=w+m|0;y=(Y(w,w)|0)+s|0;w=h[v+1>>0]|0;z=w+p|0;A=(Y(w,w)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){B=x;C=z;D=y;E=A;break}else{m=x;p=z;s=y;r=A;v=v+i|0}}}else{B=u;C=l;D=k;E=n}f[d>>2]=B;f[t>>2]=C;f[e>>2]=D;f[o>>2]=E;break}case 3:{E=f[d>>2]|0;o=d+4|0;D=f[o>>2]|0;C=d+8|0;t=f[C>>2]|0;B=f[e>>2]|0;n=e+4|0;k=f[n>>2]|0;l=e+8|0;u=f[l>>2]|0;if((g|0)>0){v=E;r=0;s=u;p=k;m=B;q=t;A=D;y=a;while(1){z=h[y>>0]|0;x=z+v|0;w=(Y(z,z)|0)+m|0;z=h[y+1>>0]|0;F=z+A|0;G=(Y(z,z)|0)+p|0;z=h[y+2>>0]|0;H=z+q|0;I=(Y(z,z)|0)+s|0;r=r+1|0;if((r|0)==(g|0)){J=x;K=I;L=G;M=w;N=H;O=F;break}else{v=x;s=I;p=G;m=w;q=H;A=F;y=y+i|0}}}else{J=E;K=u;L=k;M=B;N=t;O=D}f[d>>2]=J;f[o>>2]=O;f[C>>2]=N;f[e>>2]=M;f[n>>2]=L;f[l>>2]=K;break}default:{}}if((j|0)<(i|0)&(g|0)>0)P=j;else{Q=g;return Q|0}do{j=d+(P<<2)|0;K=P+1|0;l=d+(K<<2)|0;L=P+2|0;n=d+(L<<2)|0;M=P+3|0;N=d+(M<<2)|0;C=e+(P<<2)|0;O=e+(K<<2)|0;K=e+(L<<2)|0;L=e+(M<<2)|0;M=0;o=f[L>>2]|0;J=f[K>>2]|0;D=f[O>>2]|0;t=f[C>>2]|0;B=f[N>>2]|0;k=f[n>>2]|0;u=f[l>>2]|0;E=f[j>>2]|0;y=a+P|0;while(1){A=h[y>>0]|0;E=A+E|0;t=(Y(A,A)|0)+t|0;A=h[y+1>>0]|0;u=A+u|0;D=(Y(A,A)|0)+D|0;A=h[y+2>>0]|0;k=A+k|0;J=(Y(A,A)|0)+J|0;A=h[y+3>>0]|0;B=A+B|0;o=(Y(A,A)|0)+o|0;M=M+1|0;if((M|0)==(g|0))break;else y=y+i|0}f[j>>2]=E;f[l>>2]=u;f[n>>2]=k;f[N>>2]=B;f[C>>2]=t;f[O>>2]=D;f[K>>2]=J;f[L>>2]=o;P=P+4|0}while((P|0)<(i|0));Q=g;return Q|0}switch(i|0){case 1:{P=f[d>>2]|0;y=f[e>>2]|0;if((g|0)>0){M=y;A=P;q=0;m=0;while(1){if(!(b[c+m>>0]|0)){R=M;S=A;T=q}else{p=h[a+m>>0]|0;R=(Y(p,p)|0)+M|0;S=p+A|0;T=q+1|0}m=m+1|0;if((m|0)==(g|0)){U=R;V=S;W=T;break}else{M=R;A=S;q=T}}}else{U=y;V=P;W=0}f[d>>2]=V;f[e>>2]=U;Q=W;return Q|0}case 3:{W=f[d>>2]|0;U=d+4|0;V=f[U>>2]|0;P=d+8|0;y=f[P>>2]|0;T=f[e>>2]|0;q=e+4|0;S=f[q>>2]|0;A=e+8|0;R=f[A>>2]|0;if((g|0)>0){M=R;m=S;p=T;s=y;v=V;r=W;F=0;H=0;w=a;while(1){if(!(b[c+F>>0]|0)){X=M;Z=m;_=p;$=s;aa=v;ba=r;ca=H}else{G=h[w>>0]|0;I=h[w+1>>0]|0;x=h[w+2>>0]|0;X=(Y(x,x)|0)+M|0;Z=(Y(I,I)|0)+m|0;_=(Y(G,G)|0)+p|0;$=x+s|0;aa=I+v|0;ba=G+r|0;ca=H+1|0}F=F+1|0;if((F|0)==(g|0)){da=X;ea=Z;fa=_;ga=$;ha=aa;ia=ba;ja=ca;break}else{M=X;m=Z;p=_;s=$;v=aa;r=ba;H=ca;w=w+3|0}}}else{da=R;ea=S;fa=T;ga=y;ha=V;ia=W;ja=0}f[d>>2]=ia;f[U>>2]=ha;f[P>>2]=ga;f[e>>2]=fa;f[q>>2]=ea;f[A>>2]=da;Q=ja;return Q|0}default:{if((g|0)<=0){Q=0;return Q|0}if((i|0)>0){ka=0;la=0;ma=a}else{a=0;ja=0;while(1){da=((b[c+a>>0]|0)!=0&1)+ja|0;a=a+1|0;if((a|0)==(g|0)){Q=da;break}else ja=da}return Q|0}while(1){if(!(b[c+ka>>0]|0))na=la;else{ja=0;do{a=d+(ja<<2)|0;da=h[ma+ja>>0]|0;A=e+(ja<<2)|0;ea=(f[A>>2]|0)+(Y(da,da)|0)|0;f[a>>2]=(f[a>>2]|0)+da;f[A>>2]=ea;ja=ja+1|0}while((ja|0)!=(i|0));na=la+1|0}ka=ka+1|0;if((ka|0)==(g|0)){Q=na;break}else{la=na;ma=ma+i|0}}return Q|0}}return 0}function H2(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=f[d>>2]|0;k=f[e>>2]|0;if((g|0)>0){l=a;m=j;n=k;o=0;while(1){p=b[l>>0]|0;q=p+m|0;r=(Y(p,p)|0)+n|0;o=o+1|0;if((o|0)==(g|0)){s=q;t=r;break}else{l=l+h|0;m=q;n=r}}}else{s=j;t=k}f[d>>2]=s;f[e>>2]=t;break}case 2:{t=f[d>>2]|0;s=d+4|0;k=f[s>>2]|0;j=f[e>>2]|0;n=e+4|0;m=f[n>>2]|0;if((g|0)>0){l=t;o=k;r=j;q=m;p=0;u=a;while(1){v=b[u>>0]|0;w=v+l|0;x=(Y(v,v)|0)+r|0;v=b[u+1>>0]|0;y=v+o|0;z=(Y(v,v)|0)+q|0;p=p+1|0;if((p|0)==(g|0)){A=w;B=y;C=x;D=z;break}else{l=w;o=y;r=x;q=z;u=u+h|0}}}else{A=t;B=k;C=j;D=m}f[d>>2]=A;f[s>>2]=B;f[e>>2]=C;f[n>>2]=D;break}case 3:{D=f[d>>2]|0;n=d+4|0;C=f[n>>2]|0;B=d+8|0;s=f[B>>2]|0;A=f[e>>2]|0;m=e+4|0;j=f[m>>2]|0;k=e+8|0;t=f[k>>2]|0;if((g|0)>0){u=D;q=0;r=t;o=j;l=A;p=s;z=C;x=a;while(1){y=b[x>>0]|0;w=y+u|0;v=(Y(y,y)|0)+l|0;y=b[x+1>>0]|0;E=y+z|0;F=(Y(y,y)|0)+o|0;y=b[x+2>>0]|0;G=y+p|0;H=(Y(y,y)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){I=w;J=H;K=F;L=v;M=G;N=E;break}else{u=w;r=H;o=F;l=v;p=G;z=E;x=x+h|0}}}else{I=D;J=t;K=j;L=A;M=s;N=C}f[d>>2]=I;f[n>>2]=N;f[B>>2]=M;f[e>>2]=L;f[m>>2]=K;f[k>>2]=J;break}default:{}}if((i|0)<(h|0)&(g|0)>0)O=i;else{P=g;return P|0}do{i=d+(O<<2)|0;J=O+1|0;k=d+(J<<2)|0;K=O+2|0;m=d+(K<<2)|0;L=O+3|0;M=d+(L<<2)|0;B=e+(O<<2)|0;N=e+(J<<2)|0;J=e+(K<<2)|0;K=e+(L<<2)|0;L=0;n=f[K>>2]|0;I=f[J>>2]|0;C=f[N>>2]|0;s=f[B>>2]|0;A=f[M>>2]|0;j=f[m>>2]|0;t=f[k>>2]|0;D=f[i>>2]|0;x=a+O|0;while(1){z=b[x>>0]|0;D=z+D|0;s=(Y(z,z)|0)+s|0;z=b[x+1>>0]|0;t=z+t|0;C=(Y(z,z)|0)+C|0;z=b[x+2>>0]|0;j=z+j|0;I=(Y(z,z)|0)+I|0;z=b[x+3>>0]|0;A=z+A|0;n=(Y(z,z)|0)+n|0;L=L+1|0;if((L|0)==(g|0))break;else x=x+h|0}f[i>>2]=D;f[k>>2]=t;f[m>>2]=j;f[M>>2]=A;f[B>>2]=s;f[N>>2]=C;f[J>>2]=I;f[K>>2]=n;O=O+4|0}while((O|0)<(h|0));P=g;return P|0}switch(h|0){case 1:{O=f[d>>2]|0;x=f[e>>2]|0;if((g|0)>0){L=x;z=O;p=0;l=0;while(1){if(!(b[c+l>>0]|0)){Q=L;R=z;S=p}else{o=b[a+l>>0]|0;Q=(Y(o,o)|0)+L|0;R=o+z|0;S=p+1|0}l=l+1|0;if((l|0)==(g|0)){T=Q;U=R;V=S;break}else{L=Q;z=R;p=S}}}else{T=x;U=O;V=0}f[d>>2]=U;f[e>>2]=T;P=V;return P|0}case 3:{V=f[d>>2]|0;T=d+4|0;U=f[T>>2]|0;O=d+8|0;x=f[O>>2]|0;S=f[e>>2]|0;p=e+4|0;R=f[p>>2]|0;z=e+8|0;Q=f[z>>2]|0;if((g|0)>0){L=Q;l=R;o=S;r=x;u=U;q=V;E=0;G=0;v=a;while(1){if(!(b[c+E>>0]|0)){W=L;X=l;Z=o;_=r;$=u;aa=q;ba=G}else{F=b[v>>0]|0;H=b[v+1>>0]|0;w=b[v+2>>0]|0;W=(Y(w,w)|0)+L|0;X=(Y(H,H)|0)+l|0;Z=(Y(F,F)|0)+o|0;_=w+r|0;$=H+u|0;aa=F+q|0;ba=G+1|0}E=E+1|0;if((E|0)==(g|0)){ca=W;da=X;ea=Z;fa=_;ga=$;ha=aa;ia=ba;break}else{L=W;l=X;o=Z;r=_;u=$;q=aa;G=ba;v=v+3|0}}}else{ca=Q;da=R;ea=S;fa=x;ga=U;ha=V;ia=0}f[d>>2]=ha;f[T>>2]=ga;f[O>>2]=fa;f[e>>2]=ea;f[p>>2]=da;f[z>>2]=ca;P=ia;return P|0}default:{if((g|0)<=0){P=0;return P|0}if((h|0)>0){ja=0;ka=0;la=a}else{a=0;ia=0;while(1){ca=((b[c+a>>0]|0)!=0&1)+ia|0;a=a+1|0;if((a|0)==(g|0)){P=ca;break}else ia=ca}return P|0}while(1){if(!(b[c+ja>>0]|0))ma=ka;else{ia=0;do{a=d+(ia<<2)|0;ca=b[la+ia>>0]|0;z=e+(ia<<2)|0;da=(f[z>>2]|0)+(Y(ca,ca)|0)|0;f[a>>2]=(f[a>>2]|0)+ca;f[z>>2]=da;ia=ia+1|0}while((ia|0)!=(h|0));ma=ka+1|0}ja=ja+1|0;if((ja|0)==(g|0)){P=ma;break}else{ka=ma;la=la+h|0}}return P|0}}return 0}function I2(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[e>>2]|0;l=+p[g>>3];if((h|0)>0){m=a;n=k;o=l;q=0;while(1){r=d[m>>1]|0;s=(r&65535)+n|0;t=+(r&65535);u=o+t*t;q=q+1|0;if((q|0)==(h|0)){v=s;w=u;break}else{m=m+(i<<1)|0;n=s;o=u}}}else{v=k;w=l}f[e>>2]=v;p[g>>3]=w;break}case 2:{v=f[e>>2]|0;k=e+4|0;n=f[k>>2]|0;w=+p[g>>3];m=g+8|0;l=+p[m>>3];if((h|0)>0){q=v;s=n;o=w;u=l;r=0;x=a;while(1){y=d[x>>1]|0;z=d[x+2>>1]|0;A=(y&65535)+q|0;t=+(y&65535);B=o+t*t;y=(z&65535)+s|0;t=+(z&65535);C=u+t*t;r=r+1|0;if((r|0)==(h|0)){D=A;E=y;F=B;G=C;break}else{q=A;s=y;o=B;u=C;x=x+(i<<1)|0}}}else{D=v;E=n;F=w;G=l}f[e>>2]=D;f[k>>2]=E;p[g>>3]=F;p[m>>3]=G;break}case 3:{m=f[e>>2]|0;E=e+4|0;k=f[E>>2]|0;D=e+8|0;n=f[D>>2]|0;G=+p[g>>3];v=g+8|0;F=+p[v>>3];x=g+16|0;l=+p[x>>3];if((h|0)>0){s=m;q=0;w=l;u=F;o=G;r=n;y=k;A=a;while(1){z=d[A>>1]|0;H=d[A+2>>1]|0;I=d[A+4>>1]|0;J=(z&65535)+s|0;C=+(z&65535);B=o+C*C;z=(H&65535)+y|0;C=+(H&65535);t=u+C*C;H=(I&65535)+r|0;C=+(I&65535);K=w+C*C;q=q+1|0;if((q|0)==(h|0)){L=J;M=K;N=t;O=B;P=H;Q=z;break}else{s=J;w=K;u=t;o=B;r=H;y=z;A=A+(i<<1)|0}}}else{L=m;M=l;N=F;O=G;P=n;Q=k}f[e>>2]=L;f[E>>2]=Q;f[D>>2]=P;p[g>>3]=O;p[v>>3]=N;p[x>>3]=M;break}default:{}}if((j|0)<(i|0)&(h|0)>0)R=j;else{S=h;return S|0}do{j=e+(R<<2)|0;x=R+1|0;v=e+(x<<2)|0;P=R+2|0;D=e+(P<<2)|0;Q=R+3|0;E=e+(Q<<2)|0;L=g+(R<<3)|0;k=g+(x<<3)|0;x=g+(P<<3)|0;P=g+(Q<<3)|0;Q=0;M=+p[P>>3];N=+p[x>>3];O=+p[k>>3];G=+p[L>>3];n=f[E>>2]|0;m=f[D>>2]|0;A=f[v>>2]|0;y=f[j>>2]|0;r=a+(R<<1)|0;while(1){s=d[r>>1]|0;q=d[r+2>>1]|0;y=(s&65535)+y|0;F=+(s&65535);G=G+F*F;A=(q&65535)+A|0;F=+(q&65535);O=O+F*F;q=d[r+4>>1]|0;s=d[r+6>>1]|0;m=(q&65535)+m|0;F=+(q&65535);N=N+F*F;n=(s&65535)+n|0;F=+(s&65535);M=M+F*F;Q=Q+1|0;if((Q|0)==(h|0))break;else r=r+(i<<1)|0}f[j>>2]=y;f[v>>2]=A;f[D>>2]=m;f[E>>2]=n;p[L>>3]=G;p[k>>3]=O;p[x>>3]=N;p[P>>3]=M;R=R+4|0}while((R|0)<(i|0));S=h;return S|0}switch(i|0){case 1:{R=f[e>>2]|0;F=+p[g>>3];if((h|0)>0){l=F;r=R;Q=0;s=0;while(1){if(!(b[c+s>>0]|0)){T=l;U=r;V=Q}else{q=d[a+(s<<1)>>1]|0;o=+(q&65535);T=l+o*o;U=(q&65535)+r|0;V=Q+1|0}s=s+1|0;if((s|0)==(h|0)){W=T;X=U;Y=V;break}else{l=T;r=U;Q=V}}}else{W=F;X=R;Y=0}f[e>>2]=X;p[g>>3]=W;S=Y;return S|0}case 3:{Y=f[e>>2]|0;X=e+4|0;R=f[X>>2]|0;V=e+8|0;Q=f[V>>2]|0;W=+p[g>>3];U=g+8|0;F=+p[U>>3];r=g+16|0;T=+p[r>>3];if((h|0)>0){l=T;o=F;u=W;s=Q;q=R;z=Y;H=0;J=0;I=a;while(1){if(!(b[c+H>>0]|0)){Z=l;_=o;$=u;aa=s;ba=q;ca=z;da=J}else{ea=d[I>>1]|0;fa=d[I+2>>1]|0;ga=d[I+4>>1]|0;w=+(ea&65535);B=+(fa&65535);t=+(ga&65535);Z=l+t*t;_=o+B*B;$=u+w*w;aa=(ga&65535)+s|0;ba=(fa&65535)+q|0;ca=(ea&65535)+z|0;da=J+1|0}H=H+1|0;if((H|0)==(h|0)){ha=Z;ia=_;ja=$;ka=aa;la=ba;ma=ca;na=da;break}else{l=Z;o=_;u=$;s=aa;q=ba;z=ca;J=da;I=I+6|0}}}else{ha=T;ia=F;ja=W;ka=Q;la=R;ma=Y;na=0}f[e>>2]=ma;f[X>>2]=la;f[V>>2]=ka;p[g>>3]=ja;p[U>>3]=ia;p[r>>3]=ha;S=na;return S|0}default:{if((h|0)<=0){S=0;return S|0}if((i|0)>0){oa=0;pa=0;qa=a}else{a=0;na=0;while(1){r=((b[c+a>>0]|0)!=0&1)+na|0;a=a+1|0;if((a|0)==(h|0)){S=r;break}else na=r}return S|0}while(1){if(!(b[c+oa>>0]|0))ra=pa;else{na=0;do{a=d[qa+(na<<1)>>1]|0;r=e+(na<<2)|0;U=g+(na<<3)|0;ha=+(a&65535);ia=+p[U>>3]+ha*ha;f[r>>2]=(f[r>>2]|0)+(a&65535);p[U>>3]=ia;na=na+1|0}while((na|0)!=(i|0));ra=pa+1|0}oa=oa+1|0;if((oa|0)==(h|0)){S=ra;break}else{pa=ra;qa=qa+(i<<1)|0}}return S|0}}return 0}function J2(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[e>>2]|0;l=+p[g>>3];if((h|0)>0){m=a;n=k;o=l;q=0;while(1){r=d[m>>1]|0;s=(r<<16>>16)+n|0;t=+(r<<16>>16);u=o+t*t;q=q+1|0;if((q|0)==(h|0)){v=s;w=u;break}else{m=m+(i<<1)|0;n=s;o=u}}}else{v=k;w=l}f[e>>2]=v;p[g>>3]=w;break}case 2:{v=f[e>>2]|0;k=e+4|0;n=f[k>>2]|0;w=+p[g>>3];m=g+8|0;l=+p[m>>3];if((h|0)>0){q=v;s=n;o=w;u=l;r=0;x=a;while(1){y=d[x>>1]|0;z=d[x+2>>1]|0;A=(y<<16>>16)+q|0;t=+(y<<16>>16);B=o+t*t;y=(z<<16>>16)+s|0;t=+(z<<16>>16);C=u+t*t;r=r+1|0;if((r|0)==(h|0)){D=A;E=y;F=B;G=C;break}else{q=A;s=y;o=B;u=C;x=x+(i<<1)|0}}}else{D=v;E=n;F=w;G=l}f[e>>2]=D;f[k>>2]=E;p[g>>3]=F;p[m>>3]=G;break}case 3:{m=f[e>>2]|0;E=e+4|0;k=f[E>>2]|0;D=e+8|0;n=f[D>>2]|0;G=+p[g>>3];v=g+8|0;F=+p[v>>3];x=g+16|0;l=+p[x>>3];if((h|0)>0){s=m;q=0;w=l;u=F;o=G;r=n;y=k;A=a;while(1){z=d[A>>1]|0;H=d[A+2>>1]|0;I=d[A+4>>1]|0;J=(z<<16>>16)+s|0;C=+(z<<16>>16);B=o+C*C;z=(H<<16>>16)+y|0;C=+(H<<16>>16);t=u+C*C;H=(I<<16>>16)+r|0;C=+(I<<16>>16);K=w+C*C;q=q+1|0;if((q|0)==(h|0)){L=J;M=K;N=t;O=B;P=H;Q=z;break}else{s=J;w=K;u=t;o=B;r=H;y=z;A=A+(i<<1)|0}}}else{L=m;M=l;N=F;O=G;P=n;Q=k}f[e>>2]=L;f[E>>2]=Q;f[D>>2]=P;p[g>>3]=O;p[v>>3]=N;p[x>>3]=M;break}default:{}}if((j|0)<(i|0)&(h|0)>0)R=j;else{S=h;return S|0}do{j=e+(R<<2)|0;x=R+1|0;v=e+(x<<2)|0;P=R+2|0;D=e+(P<<2)|0;Q=R+3|0;E=e+(Q<<2)|0;L=g+(R<<3)|0;k=g+(x<<3)|0;x=g+(P<<3)|0;P=g+(Q<<3)|0;Q=0;M=+p[P>>3];N=+p[x>>3];O=+p[k>>3];G=+p[L>>3];n=f[E>>2]|0;m=f[D>>2]|0;A=f[v>>2]|0;y=f[j>>2]|0;r=a+(R<<1)|0;while(1){s=d[r>>1]|0;q=d[r+2>>1]|0;y=(s<<16>>16)+y|0;F=+(s<<16>>16);G=G+F*F;A=(q<<16>>16)+A|0;F=+(q<<16>>16);O=O+F*F;q=d[r+4>>1]|0;s=d[r+6>>1]|0;m=(q<<16>>16)+m|0;F=+(q<<16>>16);N=N+F*F;n=(s<<16>>16)+n|0;F=+(s<<16>>16);M=M+F*F;Q=Q+1|0;if((Q|0)==(h|0))break;else r=r+(i<<1)|0}f[j>>2]=y;f[v>>2]=A;f[D>>2]=m;f[E>>2]=n;p[L>>3]=G;p[k>>3]=O;p[x>>3]=N;p[P>>3]=M;R=R+4|0}while((R|0)<(i|0));S=h;return S|0}switch(i|0){case 1:{R=f[e>>2]|0;F=+p[g>>3];if((h|0)>0){l=F;r=R;Q=0;s=0;while(1){if(!(b[c+s>>0]|0)){T=l;U=r;V=Q}else{q=d[a+(s<<1)>>1]|0;o=+(q<<16>>16);T=l+o*o;U=(q<<16>>16)+r|0;V=Q+1|0}s=s+1|0;if((s|0)==(h|0)){W=T;X=U;Y=V;break}else{l=T;r=U;Q=V}}}else{W=F;X=R;Y=0}f[e>>2]=X;p[g>>3]=W;S=Y;return S|0}case 3:{Y=f[e>>2]|0;X=e+4|0;R=f[X>>2]|0;V=e+8|0;Q=f[V>>2]|0;W=+p[g>>3];U=g+8|0;F=+p[U>>3];r=g+16|0;T=+p[r>>3];if((h|0)>0){l=T;o=F;u=W;s=Q;q=R;z=Y;H=0;J=0;I=a;while(1){if(!(b[c+H>>0]|0)){Z=l;_=o;$=u;aa=s;ba=q;ca=z;da=J}else{ea=d[I>>1]|0;fa=d[I+2>>1]|0;ga=d[I+4>>1]|0;w=+(ea<<16>>16);B=+(fa<<16>>16);t=+(ga<<16>>16);Z=l+t*t;_=o+B*B;$=u+w*w;aa=(ga<<16>>16)+s|0;ba=(fa<<16>>16)+q|0;ca=(ea<<16>>16)+z|0;da=J+1|0}H=H+1|0;if((H|0)==(h|0)){ha=Z;ia=_;ja=$;ka=aa;la=ba;ma=ca;na=da;break}else{l=Z;o=_;u=$;s=aa;q=ba;z=ca;J=da;I=I+6|0}}}else{ha=T;ia=F;ja=W;ka=Q;la=R;ma=Y;na=0}f[e>>2]=ma;f[X>>2]=la;f[V>>2]=ka;p[g>>3]=ja;p[U>>3]=ia;p[r>>3]=ha;S=na;return S|0}default:{if((h|0)<=0){S=0;return S|0}if((i|0)>0){oa=0;pa=0;qa=a}else{a=0;na=0;while(1){r=((b[c+a>>0]|0)!=0&1)+na|0;a=a+1|0;if((a|0)==(h|0)){S=r;break}else na=r}return S|0}while(1){if(!(b[c+oa>>0]|0))ra=pa;else{na=0;do{a=d[qa+(na<<1)>>1]|0;r=e+(na<<2)|0;U=g+(na<<3)|0;ha=+(a<<16>>16);ia=+p[U>>3]+ha*ha;f[r>>2]=(f[r>>2]|0)+(a<<16>>16);p[U>>3]=ia;na=na+1|0}while((na|0)!=(i|0));ra=pa+1|0}oa=oa+1|0;if((oa|0)==(h|0)){S=ra;break}else{pa=ra;qa=qa+(i<<1)|0}}return S|0}}return 0}function K2(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=+p[d>>3];k=+p[e>>3];if((g|0)>0){l=a;m=j;n=k;o=0;while(1){q=+(f[l>>2]|0);r=m+q;s=n+q*q;o=o+1|0;if((o|0)==(g|0)){t=r;u=s;break}else{l=l+(h<<2)|0;m=r;n=s}}}else{t=j;u=k}p[d>>3]=t;p[e>>3]=u;break}case 2:{u=+p[d>>3];l=d+8|0;t=+p[l>>3];k=+p[e>>3];o=e+8|0;j=+p[o>>3];if((g|0)>0){n=u;m=t;s=k;r=j;v=0;w=a;while(1){q=+(f[w>>2]|0);x=n+q;y=s+q*q;q=+(f[w+4>>2]|0);z=m+q;A=r+q*q;v=v+1|0;if((v|0)==(g|0)){B=x;C=z;D=y;E=A;break}else{n=x;m=z;s=y;r=A;w=w+(h<<2)|0}}}else{B=u;C=t;D=k;E=j}p[d>>3]=B;p[l>>3]=C;p[e>>3]=D;p[o>>3]=E;break}case 3:{E=+p[d>>3];o=d+8|0;D=+p[o>>3];l=d+16|0;C=+p[l>>3];B=+p[e>>3];w=e+8|0;j=+p[w>>3];v=e+16|0;k=+p[v>>3];if((g|0)>0){t=E;F=0;u=k;r=j;s=B;m=C;n=D;G=a;while(1){A=+(f[G>>2]|0);y=t+A;z=s+A*A;A=+(f[G+4>>2]|0);x=n+A;q=r+A*A;A=+(f[G+8>>2]|0);H=m+A;I=u+A*A;F=F+1|0;if((F|0)==(g|0)){J=y;K=I;L=q;M=z;N=H;O=x;break}else{t=y;u=I;r=q;s=z;m=H;n=x;G=G+(h<<2)|0}}}else{J=E;K=k;L=j;M=B;N=C;O=D}p[d>>3]=J;p[o>>3]=O;p[l>>3]=N;p[e>>3]=M;p[w>>3]=L;p[v>>3]=K;break}default:{}}if((i|0)<(h|0)&(g|0)>0)P=i;else{Q=g;return Q|0}do{i=d+(P<<3)|0;v=P+1|0;w=d+(v<<3)|0;l=P+2|0;o=d+(l<<3)|0;G=P+3|0;F=d+(G<<3)|0;R=e+(P<<3)|0;S=e+(v<<3)|0;v=e+(l<<3)|0;l=e+(G<<3)|0;G=0;K=+p[l>>3];L=+p[v>>3];M=+p[S>>3];N=+p[R>>3];O=+p[F>>3];J=+p[o>>3];D=+p[w>>3];C=+p[i>>3];T=a+(P<<2)|0;while(1){B=+(f[T>>2]|0);C=C+B;N=N+B*B;B=+(f[T+4>>2]|0);D=D+B;M=M+B*B;B=+(f[T+8>>2]|0);J=J+B;L=L+B*B;B=+(f[T+12>>2]|0);O=O+B;K=K+B*B;G=G+1|0;if((G|0)==(g|0))break;else T=T+(h<<2)|0}p[i>>3]=C;p[w>>3]=D;p[o>>3]=J;p[F>>3]=O;p[R>>3]=N;p[S>>3]=M;p[v>>3]=L;p[l>>3]=K;P=P+4|0}while((P|0)<(h|0));Q=g;return Q|0}switch(h|0){case 1:{B=+p[d>>3];j=+p[e>>3];if((g|0)>0){k=j;E=B;P=0;T=0;while(1){if(!(b[c+T>>0]|0)){U=k;V=E;W=P}else{n=+(f[a+(T<<2)>>2]|0);U=k+n*n;V=E+n;W=P+1|0}T=T+1|0;if((T|0)==(g|0)){X=U;Y=V;Z=W;break}else{k=U;E=V;P=W}}}else{X=j;Y=B;Z=0}p[d>>3]=Y;p[e>>3]=X;Q=Z;return Q|0}case 3:{X=+p[d>>3];Z=d+8|0;Y=+p[Z>>3];W=d+16|0;B=+p[W>>3];j=+p[e>>3];P=e+8|0;V=+p[P>>3];T=e+16|0;E=+p[T>>3];if((g|0)>0){U=E;k=V;n=j;m=B;s=Y;r=X;G=0;_=0;$=a;while(1){if(!(b[c+G>>0]|0)){aa=U;ba=k;ca=n;da=m;ea=s;fa=r;ga=_}else{u=+(f[$>>2]|0);t=+(f[$+4>>2]|0);x=+(f[$+8>>2]|0);aa=U+x*x;ba=k+t*t;ca=n+u*u;da=m+x;ea=s+t;fa=r+u;ga=_+1|0}G=G+1|0;if((G|0)==(g|0)){ha=aa;ia=ba;ja=ca;ka=da;la=ea;ma=fa;na=ga;break}else{U=aa;k=ba;n=ca;m=da;s=ea;r=fa;_=ga;$=$+12|0}}}else{ha=E;ia=V;ja=j;ka=B;la=Y;ma=X;na=0}p[d>>3]=ma;p[Z>>3]=la;p[W>>3]=ka;p[e>>3]=ja;p[P>>3]=ia;p[T>>3]=ha;Q=na;return Q|0}default:{if((g|0)<=0){Q=0;return Q|0}if((h|0)>0){oa=0;pa=0;qa=a}else{a=0;na=0;while(1){T=((b[c+a>>0]|0)!=0&1)+na|0;a=a+1|0;if((a|0)==(g|0)){Q=T;break}else na=T}return Q|0}while(1){if(!(b[c+oa>>0]|0))ra=pa;else{na=0;do{a=d+(na<<3)|0;ha=+(f[qa+(na<<2)>>2]|0);T=e+(na<<3)|0;ia=+p[T>>3]+ha*ha;p[a>>3]=+p[a>>3]+ha;p[T>>3]=ia;na=na+1|0}while((na|0)!=(h|0));ra=pa+1|0}oa=oa+1|0;if((oa|0)==(g|0)){Q=ra;break}else{pa=ra;qa=qa+(h<<2)|0}}return Q|0}}return 0}function L2(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=+p[e>>3];if((f|0)>0){k=a;l=i;m=j;o=0;while(1){q=+n[k>>2];r=l+q;s=m+q*q;o=o+1|0;if((o|0)==(f|0)){t=r;u=s;break}else{k=k+(g<<2)|0;l=r;m=s}}}else{t=i;u=j}p[d>>3]=t;p[e>>3]=u;break}case 2:{u=+p[d>>3];k=d+8|0;t=+p[k>>3];j=+p[e>>3];o=e+8|0;i=+p[o>>3];if((f|0)>0){m=u;l=t;s=j;r=i;v=0;w=a;while(1){q=+n[w>>2];x=m+q;y=s+q*q;q=+n[w+4>>2];z=l+q;A=r+q*q;v=v+1|0;if((v|0)==(f|0)){B=x;C=z;D=y;E=A;break}else{m=x;l=z;s=y;r=A;w=w+(g<<2)|0}}}else{B=u;C=t;D=j;E=i}p[d>>3]=B;p[k>>3]=C;p[e>>3]=D;p[o>>3]=E;break}case 3:{E=+p[d>>3];o=d+8|0;D=+p[o>>3];k=d+16|0;C=+p[k>>3];B=+p[e>>3];w=e+8|0;i=+p[w>>3];v=e+16|0;j=+p[v>>3];if((f|0)>0){t=E;F=0;u=j;r=i;s=B;l=C;m=D;G=a;while(1){A=+n[G>>2];y=t+A;z=s+A*A;A=+n[G+4>>2];x=m+A;q=r+A*A;A=+n[G+8>>2];H=l+A;I=u+A*A;F=F+1|0;if((F|0)==(f|0)){J=y;K=I;L=q;M=z;N=H;O=x;break}else{t=y;u=I;r=q;s=z;l=H;m=x;G=G+(g<<2)|0}}}else{J=E;K=j;L=i;M=B;N=C;O=D}p[d>>3]=J;p[o>>3]=O;p[k>>3]=N;p[e>>3]=M;p[w>>3]=L;p[v>>3]=K;break}default:{}}if((h|0)<(g|0)&(f|0)>0)P=h;else{Q=f;return Q|0}do{h=d+(P<<3)|0;v=P+1|0;w=d+(v<<3)|0;k=P+2|0;o=d+(k<<3)|0;G=P+3|0;F=d+(G<<3)|0;R=e+(P<<3)|0;S=e+(v<<3)|0;v=e+(k<<3)|0;k=e+(G<<3)|0;G=0;K=+p[k>>3];L=+p[v>>3];M=+p[S>>3];N=+p[R>>3];O=+p[F>>3];J=+p[o>>3];D=+p[w>>3];C=+p[h>>3];T=a+(P<<2)|0;while(1){B=+n[T>>2];C=C+B;N=N+B*B;B=+n[T+4>>2];D=D+B;M=M+B*B;B=+n[T+8>>2];J=J+B;L=L+B*B;B=+n[T+12>>2];O=O+B;K=K+B*B;G=G+1|0;if((G|0)==(f|0))break;else T=T+(g<<2)|0}p[h>>3]=C;p[w>>3]=D;p[o>>3]=J;p[F>>3]=O;p[R>>3]=N;p[S>>3]=M;p[v>>3]=L;p[k>>3]=K;P=P+4|0}while((P|0)<(g|0));Q=f;return Q|0}switch(g|0){case 1:{B=+p[d>>3];i=+p[e>>3];if((f|0)>0){j=i;E=B;P=0;T=0;while(1){if(!(b[c+T>>0]|0)){U=j;V=E;W=P}else{m=+n[a+(T<<2)>>2];U=j+m*m;V=E+m;W=P+1|0}T=T+1|0;if((T|0)==(f|0)){X=U;Y=V;Z=W;break}else{j=U;E=V;P=W}}}else{X=i;Y=B;Z=0}p[d>>3]=Y;p[e>>3]=X;Q=Z;return Q|0}case 3:{X=+p[d>>3];Z=d+8|0;Y=+p[Z>>3];W=d+16|0;B=+p[W>>3];i=+p[e>>3];P=e+8|0;V=+p[P>>3];T=e+16|0;E=+p[T>>3];if((f|0)>0){U=E;j=V;m=i;l=B;s=Y;r=X;G=0;_=0;$=a;while(1){if(!(b[c+G>>0]|0)){aa=U;ba=j;ca=m;da=l;ea=s;fa=r;ga=_}else{u=+n[$>>2];t=+n[$+4>>2];x=+n[$+8>>2];aa=U+x*x;ba=j+t*t;ca=m+u*u;da=l+x;ea=s+t;fa=r+u;ga=_+1|0}G=G+1|0;if((G|0)==(f|0)){ha=aa;ia=ba;ja=ca;ka=da;la=ea;ma=fa;na=ga;break}else{U=aa;j=ba;m=ca;l=da;s=ea;r=fa;_=ga;$=$+12|0}}}else{ha=E;ia=V;ja=i;ka=B;la=Y;ma=X;na=0}p[d>>3]=ma;p[Z>>3]=la;p[W>>3]=ka;p[e>>3]=ja;p[P>>3]=ia;p[T>>3]=ha;Q=na;return Q|0}default:{if((f|0)<=0){Q=0;return Q|0}if((g|0)>0){oa=0;pa=0;qa=a}else{a=0;na=0;while(1){T=((b[c+a>>0]|0)!=0&1)+na|0;a=a+1|0;if((a|0)==(f|0)){Q=T;break}else na=T}return Q|0}while(1){if(!(b[c+oa>>0]|0))ra=pa;else{na=0;do{a=d+(na<<3)|0;ha=+n[qa+(na<<2)>>2];T=e+(na<<3)|0;ia=+p[T>>3]+ha*ha;p[a>>3]=+p[a>>3]+ha;p[T>>3]=ia;na=na+1|0}while((na|0)!=(g|0));ra=pa+1|0}oa=oa+1|0;if((oa|0)==(f|0)){Q=ra;break}else{pa=ra;qa=qa+(g<<2)|0}}return Q|0}}return 0}function M2(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0.0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=+p[e>>3];if((f|0)>0){k=a;l=i;m=j;n=0;while(1){o=+p[k>>3];q=l+o;r=m+o*o;n=n+1|0;if((n|0)==(f|0)){s=q;t=r;break}else{k=k+(g<<3)|0;l=q;m=r}}}else{s=i;t=j}p[d>>3]=s;p[e>>3]=t;break}case 2:{t=+p[d>>3];k=d+8|0;s=+p[k>>3];j=+p[e>>3];n=e+8|0;i=+p[n>>3];if((f|0)>0){m=t;l=s;r=j;q=i;u=0;v=a;while(1){o=+p[v>>3];w=+p[v+8>>3];x=m+o;y=r+o*o;o=l+w;z=q+w*w;u=u+1|0;if((u|0)==(f|0)){A=x;B=o;C=y;D=z;break}else{m=x;l=o;r=y;q=z;v=v+(g<<3)|0}}}else{A=t;B=s;C=j;D=i}p[d>>3]=A;p[k>>3]=B;p[e>>3]=C;p[n>>3]=D;break}case 3:{D=+p[d>>3];n=d+8|0;C=+p[n>>3];k=d+16|0;B=+p[k>>3];A=+p[e>>3];v=e+8|0;i=+p[v>>3];u=e+16|0;j=+p[u>>3];if((f|0)>0){s=D;E=0;t=j;q=i;r=A;l=B;m=C;F=a;while(1){z=+p[F>>3];y=+p[F+8>>3];o=+p[F+16>>3];x=s+z;w=r+z*z;z=m+y;G=q+y*y;y=l+o;H=t+o*o;E=E+1|0;if((E|0)==(f|0)){I=x;J=H;K=G;L=w;M=y;N=z;break}else{s=x;t=H;q=G;r=w;l=y;m=z;F=F+(g<<3)|0}}}else{I=D;J=j;K=i;L=A;M=B;N=C}p[d>>3]=I;p[n>>3]=N;p[k>>3]=M;p[e>>3]=L;p[v>>3]=K;p[u>>3]=J;break}default:{}}if((h|0)<(g|0)&(f|0)>0)O=h;else{P=f;return P|0}do{h=d+(O<<3)|0;u=O+1|0;v=d+(u<<3)|0;k=O+2|0;n=d+(k<<3)|0;F=O+3|0;E=d+(F<<3)|0;Q=e+(O<<3)|0;R=e+(u<<3)|0;u=e+(k<<3)|0;k=e+(F<<3)|0;F=0;J=+p[k>>3];K=+p[u>>3];L=+p[R>>3];M=+p[Q>>3];N=+p[E>>3];I=+p[n>>3];C=+p[v>>3];B=+p[h>>3];S=a+(O<<3)|0;while(1){A=+p[S>>3];i=+p[S+8>>3];B=B+A;M=M+A*A;C=C+i;L=L+i*i;i=+p[S+16>>3];A=+p[S+24>>3];I=I+i;K=K+i*i;N=N+A;J=J+A*A;F=F+1|0;if((F|0)==(f|0))break;else S=S+(g<<3)|0}p[h>>3]=B;p[v>>3]=C;p[n>>3]=I;p[E>>3]=N;p[Q>>3]=M;p[R>>3]=L;p[u>>3]=K;p[k>>3]=J;O=O+4|0}while((O|0)<(g|0));P=f;return P|0}switch(g|0){case 1:{A=+p[d>>3];i=+p[e>>3];if((f|0)>0){j=i;D=A;O=0;S=0;while(1){if(!(b[c+S>>0]|0)){T=j;U=D;V=O}else{m=+p[a+(S<<3)>>3];T=j+m*m;U=D+m;V=O+1|0}S=S+1|0;if((S|0)==(f|0)){W=T;X=U;Y=V;break}else{j=T;D=U;O=V}}}else{W=i;X=A;Y=0}p[d>>3]=X;p[e>>3]=W;P=Y;return P|0}case 3:{W=+p[d>>3];Y=d+8|0;X=+p[Y>>3];V=d+16|0;A=+p[V>>3];i=+p[e>>3];O=e+8|0;U=+p[O>>3];S=e+16|0;D=+p[S>>3];if((f|0)>0){T=D;j=U;m=i;l=A;r=X;q=W;F=0;Z=0;_=a;while(1){if(!(b[c+F>>0]|0)){$=T;aa=j;ba=m;ca=l;da=r;ea=q;fa=Z}else{t=+p[_>>3];s=+p[_+8>>3];z=+p[_+16>>3];$=T+z*z;aa=j+s*s;ba=m+t*t;ca=l+z;da=r+s;ea=q+t;fa=Z+1|0}F=F+1|0;if((F|0)==(f|0)){ga=$;ha=aa;ia=ba;ja=ca;ka=da;la=ea;ma=fa;break}else{T=$;j=aa;m=ba;l=ca;r=da;q=ea;Z=fa;_=_+24|0}}}else{ga=D;ha=U;ia=i;ja=A;ka=X;la=W;ma=0}p[d>>3]=la;p[Y>>3]=ka;p[V>>3]=ja;p[e>>3]=ia;p[O>>3]=ha;p[S>>3]=ga;P=ma;return P|0}default:{if((f|0)<=0){P=0;return P|0}if((g|0)>0){na=0;oa=0;pa=a}else{a=0;ma=0;while(1){S=((b[c+a>>0]|0)!=0&1)+ma|0;a=a+1|0;if((a|0)==(f|0)){P=S;break}else ma=S}return P|0}while(1){if(!(b[c+na>>0]|0))qa=oa;else{ma=0;do{ga=+p[pa+(ma<<3)>>3];a=d+(ma<<3)|0;S=e+(ma<<3)|0;ha=ga*ga+ +p[S>>3];p[a>>3]=ga+ +p[a>>3];p[S>>3]=ha;ma=ma+1|0}while((ma|0)!=(g|0));qa=oa+1|0}na=na+1|0;if((na|0)==(f|0)){P=qa;break}else{oa=qa;pa=pa+(g<<3)|0}}return P|0}}return 0}function N2(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+112|0;d=c+48|0;e=c+40|0;g=c+32|0;h=c;if((c$(a,-1)|0)&4088|0){f[d>>2]=0;f[d+4>>2]=0;i=tT(d,7)|0;b[i>>0]=b[372156]|0;b[i+1>>0]=b[372157]|0;b[i+2>>0]=b[372158]|0;b[i+3>>0]=b[372159]|0;b[i+4>>0]=b[372160]|0;b[i+5>>0]=b[372161]|0;b[i+6>>0]=b[372162]|0;O2(d,230392,298)}do if((d$(a)|0)==65536){i=f[a+4>>2]|0;f[d>>2]=f[i>>2];j=d+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=d+8|0;f[l>>2]=f[i+8>>2];f[d+12>>2]=f[i+12>>2];f[d+16>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];f[d+28>>2]=f[i+28>>2];f[d+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[d+36>>2]=m;f[d+40>>2]=l;l=d+48|0;n=d+44|0;f[n>>2]=l;f[l>>2]=0;f[d+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];o=d;break}else{f[j>>2]=0;ZS(d,i);o=d;break}}else{a$(d,a,-1);o=d}while(0);a=f[o>>2]&7;o=f[45984+(a<<2)>>2]|0;if((a|0)==7){f[e>>2]=0;f[e+4>>2]=0;a=tT(e,9)|0;i=251213;j=a+9|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(j|0));O2(e,230392,314)}f[e>>2]=d;f[e+4>>2]=0;f[g>>2]=0;z2(h,e,g,-1);e=f[h+20>>2]|0;i=h+16|0;a=0;j=0;while(1){if(a>>>0>=(f[i>>2]|0)>>>0)break;k=(Mi[o&1023](f[g>>2]|0,e)|0)+j|0;A2(h)|0;a=a+1|0;j=k}a=d+36|0;h=f[a>>2]|0;if(h|0?(e=h+12|0,h=f[e>>2]|0,f[e>>2]=h+-1,(h|0)==1):0)_S(d);f[a>>2]=0;a=d+16|0;h=d+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[d+40>>2]|0;e=0;do{f[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[h>>2]|0))}h=f[d+44>>2]|0;if((h|0)==(d+48|0)){u=c;return j|0}g0(h);u=c;return j|0}function O2(a,b,c){a=a|0;b=b|0;c=c|0;z5(-215,a,b,230405,c);return}function P2(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;if((c|0)>0){d=0;e=0}else{f=0;return f|0}while(1){g=((b[a+e>>0]|0)!=0&1)+d|0;e=e+1|0;if((e|0)==(c|0)){f=g;break}else d=g}return f|0}function Q2(a,b){a=a|0;b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){e=0;f=0}else{g=0;h=0;do{h=((d[a+(g<<1)>>1]|0)!=0&1)+h+((d[a+((g|1)<<1)>>1]|0)!=0&1)+((d[a+((g|2)<<1)>>1]|0)!=0&1)+((d[a+((g|3)<<1)>>1]|0)!=0&1)|0;g=g+4|0}while((g|0)<=(c|0));e=h;f=b&-4}if((f|0)<(b|0)){i=f;j=e}else{k=e;return k|0}while(1){e=((d[a+(i<<1)>>1]|0)!=0&1)+j|0;i=i+1|0;if((i|0)==(b|0)){k=e;break}else j=e}return k|0}function R2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{g=0;h=0;do{h=((f[a+(g<<2)>>2]|0)!=0&1)+h+((f[a+((g|1)<<2)>>2]|0)!=0&1)+((f[a+((g|2)<<2)>>2]|0)!=0&1)+((f[a+((g|3)<<2)>>2]|0)!=0&1)|0;g=g+4|0}while((g|0)<=(c|0));d=h;e=b&-4}if((e|0)<(b|0)){i=e;j=d}else{k=d;return k|0}while(1){d=((f[a+(i<<2)>>2]|0)!=0&1)+j|0;i=i+1|0;if((i|0)==(b|0)){k=d;break}else j=d}return k|0}function S2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(+n[a+(f<<2)>>2]!=0.0&1)+g+(+n[a+((f|1)<<2)>>2]!=0.0&1)+(+n[a+((f|2)<<2)>>2]!=0.0&1)+(+n[a+((f|3)<<2)>>2]!=0.0&1)|0;f=f+4|0}while((f|0)<=(c|0));d=g;e=b&-4}if((e|0)<(b|0)){h=e;i=d}else{j=d;return j|0}while(1){d=(+n[a+(h<<2)>>2]!=0.0&1)+i|0;h=h+1|0;if((h|0)==(b|0)){j=d;break}else i=d}return j|0}function T2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(+p[a+(f<<3)>>3]!=0.0&1)+g+(+p[a+((f|1)<<3)>>3]!=0.0&1)+(+p[a+((f|2)<<3)>>3]!=0.0&1)+(+p[a+((f|3)<<3)>>3]!=0.0&1)|0;f=f+4|0}while((f|0)<=(c|0));d=g;e=b&-4}if((e|0)<(b|0)){h=e;i=d}else{j=d;return j|0}while(1){d=(+p[a+(h<<3)>>3]!=0.0&1)+i|0;h=h+1|0;if((h|0)==(b|0)){j=d;break}else i=d}return j|0}function U2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+64|0;g=e;if((c|0)<0&(d|0)>255){i=1;u=e;return i|0}if((d|0)<(c|0)|((c|0)>255|(d|0)<0)){f[b>>2]=0;f[b+4>>2]=0;i=0;u=e;return i|0}lT(g,a,1,0);j=f[g+8>>2]|0;a:do if((j|0)>0?(k=f[g+12>>2]|0,l=f[g+16>>2]|0,(k|0)>0):0){m=f[f[g+44>>2]>>2]|0;n=0;b:while(1){o=l+(Y(m,n)|0)|0;p=0;while(1){q=h[o+p>>0]|0;if((q|0)<(c|0)|(q|0)>(d|0))break b;q=p+1|0;if((q|0)<(k|0))p=q;else break}o=n+1|0;if((o|0)<(j|0))n=o;else{r=1;break a}}f[b+4>>2]=n;f[b>>2]=(p|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;r=0}else r=1;while(0);a=g+36|0;p=f[a>>2]|0;if(p|0?(b=p+12|0,p=f[b>>2]|0,f[b>>2]=p+-1,(p|0)==1):0)_S(g);f[a>>2]=0;a=g+16|0;p=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[p>>2]|0)>0){a=f[g+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[p>>2]|0))}p=f[g+44>>2]|0;if((p|0)!=(g+48|0))g0(p);i=r;u=e;return i|0}function V2(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+64|0;h=g;if((d|0)<-128&(e|0)>127){i=1;u=g;return i|0}if((e|0)<(d|0)|((d|0)>127|(e|0)<-128)){f[c>>2]=0;f[c+4>>2]=0;i=0;u=g;return i|0}lT(h,a,1,0);j=f[h+8>>2]|0;a:do if((j|0)>0?(k=f[h+12>>2]|0,l=f[h+16>>2]|0,(k|0)>0):0){m=f[f[h+44>>2]>>2]|0;n=0;b:while(1){o=l+(Y(m,n)|0)|0;p=0;while(1){q=b[o+p>>0]|0;if((q|0)<(d|0)|(q|0)>(e|0))break b;q=p+1|0;if((q|0)<(k|0))p=q;else break}o=n+1|0;if((o|0)<(j|0))n=o;else{r=1;break a}}f[c+4>>2]=n;f[c>>2]=(p|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;r=0}else r=1;while(0);a=h+36|0;p=f[a>>2]|0;if(p|0?(c=p+12|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)_S(h);f[a>>2]=0;a=h+16|0;p=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[p>>2]|0)>0){a=f[h+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[p>>2]|0))}p=f[h+44>>2]|0;if((p|0)!=(h+48|0))g0(p);i=r;u=g;return i|0}function W2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+64|0;g=e;if((c|0)<0&(d|0)>65535){h=1;u=e;return h|0}if((d|0)<(c|0)|((c|0)>65535|(d|0)<0)){f[b>>2]=0;f[b+4>>2]=0;h=0;u=e;return h|0}lT(g,a,1,0);i=f[g+8>>2]|0;a:do if((i|0)>0?(k=f[g+12>>2]|0,l=f[g+16>>2]|0,(k|0)>0):0){m=f[f[g+44>>2]>>2]|0;n=0;b:while(1){o=l+(Y(m,n)|0)|0;p=0;while(1){q=j[o+(p<<1)>>1]|0;if((q|0)<(c|0)|(q|0)>(d|0))break b;q=p+1|0;if((q|0)<(k|0))p=q;else break}o=n+1|0;if((o|0)<(i|0))n=o;else{r=1;break a}}f[b+4>>2]=n;f[b>>2]=(p|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;r=0}else r=1;while(0);a=g+36|0;p=f[a>>2]|0;if(p|0?(b=p+12|0,p=f[b>>2]|0,f[b>>2]=p+-1,(p|0)==1):0)_S(g);f[a>>2]=0;a=g+16|0;p=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[p>>2]|0)>0){a=f[g+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[p>>2]|0))}p=f[g+44>>2]|0;if((p|0)!=(g+48|0))g0(p);h=r;u=e;return h|0}function X2(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+64|0;h=g;if((c|0)<-32768&(e|0)>32767){i=1;u=g;return i|0}if((e|0)<(c|0)|((c|0)>32767|(e|0)<-32768)){f[b>>2]=0;f[b+4>>2]=0;i=0;u=g;return i|0}lT(h,a,1,0);j=f[h+8>>2]|0;a:do if((j|0)>0?(k=f[h+12>>2]|0,l=f[h+16>>2]|0,(k|0)>0):0){m=f[f[h+44>>2]>>2]|0;n=0;b:while(1){o=l+(Y(m,n)|0)|0;p=0;while(1){q=d[o+(p<<1)>>1]|0;if((q|0)<(c|0)|(q|0)>(e|0))break b;q=p+1|0;if((q|0)<(k|0))p=q;else break}o=n+1|0;if((o|0)<(j|0))n=o;else{r=1;break a}}f[b+4>>2]=n;f[b>>2]=(p|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;r=0}else r=1;while(0);a=h+36|0;p=f[a>>2]|0;if(p|0?(b=p+12|0,p=f[b>>2]|0,f[b>>2]=p+-1,(p|0)==1):0)_S(h);f[a>>2]=0;a=h+16|0;p=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[p>>2]|0)>0){a=f[h+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[p>>2]|0))}p=f[h+44>>2]|0;if((p|0)!=(h+48|0))g0(p);i=r;u=g;return i|0}function Y2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e;if((d|0)<(c|0)){f[b>>2]=0;f[b+4>>2]=0;h=0;u=e;return h|0}lT(g,a,1,0);i=f[g+8>>2]|0;a:do if((i|0)>0?(j=f[g+12>>2]|0,k=f[g+16>>2]|0,(j|0)>0):0){l=f[f[g+44>>2]>>2]|0;m=0;b:while(1){n=k+(Y(l,m)|0)|0;o=0;while(1){p=f[n+(o<<2)>>2]|0;if((p|0)<(c|0)|(p|0)>(d|0))break b;p=o+1|0;if((p|0)<(j|0))o=p;else break}n=m+1|0;if((n|0)<(i|0))m=n;else{q=1;break a}}f[b+4>>2]=m;f[b>>2]=(o|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;q=0}else q=1;while(0);a=g+36|0;o=f[a>>2]|0;if(o|0?(b=o+12|0,o=f[b>>2]|0,f[b>>2]=o+-1,(o|0)==1):0)_S(g);f[a>>2]=0;a=g+16|0;o=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[o>>2]|0)>0){a=f[g+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[o>>2]|0))}o=f[g+44>>2]|0;if((o|0)!=(g+48|0))g0(o);h=q;u=e;return h|0}function Z2(a){a=+a;var b=0,c=0,d=0,e=0;b=(n[s>>2]=a,f[s>>2]|0);c=(b>>>23&255)+-127|0;d=(c|0)%3|0;e=d+-3-(d>>31&-3)|0;a=(f[s>>2]=(e<<23)+1065353216|b&8388607,+n[s>>2]);return +(b|0?(f[s>>2]=(((c-e|0)/3|0)<<23)+(b&-2147483648)+(n[s>>2]=(a*(a*(a*(a*45.2548339756803+192.2798368355061)+119.16548242855816)+13.432501390862399)+.16361612265857542)/(a*(a*(a*(a*14.808840932191346+151.97140510444356)+168.52544141015682)+33.99059413502156)+1.0),f[s>>2]|0),+n[s>>2]):0.0)}function _2(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+240|0;g=e+176|0;h=e+120|0;i=e+64|0;j=e+48|0;k=e+32|0;l=e;m=c$(a,-1)|0;n=p$(a,-1)|0;o=q$(a,-1)|0;b$(g,a,-1);b$(h,c,-1);if(!((f[g>>2]|0)==(f[h>>2]|0)?(f[g+4>>2]|0)==(f[h+4>>2]|0):0)){f[g>>2]=0;p=g+4|0;f[p>>2]=0;q=tT(g,89)|0;r=q;s=230478;t=r+89|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,g,230568,230578,151)}if((m|0)!=(c$(c,-1)|0)){f[g>>2]=0;p=g+4|0;f[p>>2]=0;q=tT(g,89)|0;r=q;s=230478;t=r+89|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,g,230568,230578,151)}if((n+-5|0)>>>0>=2){f[g>>2]=0;p=g+4|0;f[p>>2]=0;q=tT(g,89)|0;r=q;s=230478;t=r+89|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,g,230568,230578,151)}do if((d$(a)|0)==65536){s=f[a+4>>2]|0;f[g>>2]=f[s>>2];r=g+4|0;t=s+4|0;f[r>>2]=f[t>>2];q=g+8|0;f[q>>2]=f[s+8>>2];f[g+12>>2]=f[s+12>>2];f[g+16>>2]=f[s+16>>2];f[g+20>>2]=f[s+20>>2];f[g+24>>2]=f[s+24>>2];f[g+28>>2]=f[s+28>>2];f[g+32>>2]=f[s+32>>2];p=f[s+36>>2]|0;f[g+36>>2]=p;f[g+40>>2]=q;q=g+48|0;m=g+44|0;f[m>>2]=q;f[q>>2]=0;f[g+52>>2]=0;if(p|0){q=p+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[t>>2]|0)<3){t=f[s+44>>2]|0;q=f[m>>2]|0;f[q>>2]=f[t>>2];f[q+4>>2]=f[t+4>>2];break}else{f[r>>2]=0;ZS(g,s);break}}else a$(g,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];s=h+4|0;r=a+4|0;f[s>>2]=f[r>>2];t=h+8|0;f[t>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=t;t=h+48|0;m=h+44|0;f[m>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(q|0){t=q+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[r>>2]|0)<3){r=f[a+44>>2]|0;t=f[m>>2]|0;f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];break}else{f[s>>2]=0;ZS(h,a);break}}else a$(h,c,-1);while(0);c=g+4|0;a=g+40|0;w$(d,f[c>>2]|0,f[a>>2]|0,f[g>>2]&4095,-1,0,0);do if((d$(d)|0)==65536){s=f[d+4>>2]|0;f[i>>2]=f[s>>2];r=i+4|0;t=s+4|0;f[r>>2]=f[t>>2];m=i+8|0;f[m>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];f[i+20>>2]=f[s+20>>2];f[i+24>>2]=f[s+24>>2];f[i+28>>2]=f[s+28>>2];f[i+32>>2]=f[s+32>>2];q=f[s+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=m;m=i+48|0;p=i+44|0;f[p>>2]=m;f[m>>2]=0;f[i+52>>2]=0;if(q|0){m=q+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[t>>2]|0)<3){t=f[s+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[t>>2];f[m+4>>2]=f[t+4>>2];break}else{f[r>>2]=0;ZS(i,s);break}}else a$(i,d,-1);while(0);f[j>>2]=g;f[j+4>>2]=h;f[j+8>>2]=i;f[j+12>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;z2(l,j,k,-1);j=Y(f[l+20>>2]|0,o)|0;o=l+16|0;d=k+4|0;s=k+8|0;a:do if((n|0)==5){r=0;while(1){if(r>>>0>=(f[o>>2]|0)>>>0)break a;Q6(f[k>>2]|0,f[d>>2]|0,f[s>>2]|0,j);A2(l)|0;r=r+1|0}}else{r=0;while(1){if(r>>>0>=(f[o>>2]|0)>>>0)break a;R6(f[k>>2]|0,f[d>>2]|0,f[s>>2]|0,j);A2(l)|0;r=r+1|0}}while(0);l=i+36|0;j=f[l>>2]|0;if(j|0?(s=j+12|0,j=f[s>>2]|0,f[s>>2]=j+-1,(j|0)==1):0)_S(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[i+40>>2]|0;s=0;do{f[l+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(s=i+12|0,i=f[s>>2]|0,f[s>>2]=i+-1,(i|0)==1):0)_S(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[h+40>>2]|0;s=0;do{f[j+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))g0(i);i=g+36|0;h=f[i>>2]|0;if(h|0?(s=h+12|0,h=f[s>>2]|0,f[s>>2]=h+-1,(h|0)==1):0)_S(g);f[i>>2]=0;i=g+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[c>>2]|0)>0){i=f[a>>2]|0;a=0;do{f[i+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)==(g+48|0)){u=e;return}g0(c);u=e;return}function $2(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+304|0;i=h+240|0;j=h+184|0;k=h+128|0;l=h+72|0;m=h+48|0;n=h+32|0;o=h;do if((d$(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;ZS(i,p);break}}else a$(i,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];p=j+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[j+36>>2]=s;v=j+40|0;f[v>>2]=r;r=j+48|0;t=j+44|0;f[t>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=v;break}else{f[p>>2]=0;ZS(j,a);w=v;break}}else{a$(j,c,-1);w=j+40|0}while(0);c=f[i>>2]|0;v=c&4095;a=c&7;p=c>>>3&511;c=p+1|0;q=i+40|0;r=f[q>>2]|0;t=f[r+-4>>2]|0;s=f[w>>2]|0;if((t|0)!=(f[s+-4>>2]|0)){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,76)|0;z=y;A=230646;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,230723,230578,277)}a:do if((t|0)==2){if((f[r>>2]|0)!=(f[s>>2]|0)){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,76)|0;z=y;A=230646;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,230723,230578,277)}if((f[r+4>>2]|0)!=(f[s+4>>2]|0)){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,76)|0;z=y;A=230646;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,230723,230578,277)}}else if((t|0)>0){C=0;while(1){if((f[r+(C<<2)>>2]|0)!=(f[s+(C<<2)>>2]|0))break;C=C+1|0;if((C|0)>=(t|0))break a}f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,76)|0;z=y;A=230646;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,230723,230578,277)}while(0);if((v|0)!=(f[j>>2]&4095|0)){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,76)|0;z=y;A=230646;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,230723,230578,277)}t=(a|0)==5;if((a+-5|0)>>>0>=2){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,76)|0;z=y;A=230646;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,230723,230578,277)}A=i+4|0;w$(d,f[A>>2]|0,r,v,-1,0,0);w$(e,f[A>>2]|0,f[q>>2]|0,v,-1,0,0);do if((d$(d)|0)==65536){v=f[d+4>>2]|0;f[k>>2]=f[v>>2];r=k+4|0;z=v+4|0;f[r>>2]=f[z>>2];B=k+8|0;f[B>>2]=f[v+8>>2];f[k+12>>2]=f[v+12>>2];f[k+16>>2]=f[v+16>>2];f[k+20>>2]=f[v+20>>2];f[k+24>>2]=f[v+24>>2];f[k+28>>2]=f[v+28>>2];f[k+32>>2]=f[v+32>>2];y=f[v+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=B;B=k+48|0;x=k+44|0;f[x>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(y|0){B=y+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[z>>2]|0)<3){z=f[v+44>>2]|0;B=f[x>>2]|0;f[B>>2]=f[z>>2];f[B+4>>2]=f[z+4>>2];break}else{f[r>>2]=0;ZS(k,v);break}}else a$(k,d,-1);while(0);do if((d$(e)|0)==65536){d=f[e+4>>2]|0;f[l>>2]=f[d>>2];v=l+4|0;r=d+4|0;f[v>>2]=f[r>>2];z=l+8|0;f[z>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];B=f[d+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=z;z=l+48|0;x=l+44|0;f[x>>2]=z;f[z>>2]=0;f[l+52>>2]=0;if(B|0){z=B+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;z=f[x>>2]|0;f[z>>2]=f[r>>2];f[z+4>>2]=f[r+4>>2];break}else{f[v>>2]=0;ZS(l,d);break}}else a$(l,e,-1);while(0);f[m>>2]=i;f[m+4>>2]=j;f[m+8>>2]=k;f[m+12>>2]=l;f[m+16>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;z2(o,m,n,-1);m=Y(f[o+20>>2]|0,c)|0;e=p|1024;p=e-((e>>>0)%(c>>>0)|0)|0;c=(p|0)<(m|0)?p:m;p=1212424721>>>(f[i>>2]<<2&28)&15;e=o+16|0;d=(m|0)>0;v=n+4|0;r=n+8|0;z=n+12|0;x=0;while(1){if(x>>>0>=(f[e>>2]|0)>>>0)break;if(d)if(t){B=0;y=f[n>>2]|0;a=f[v>>2]|0;s=f[r>>2]|0;C=f[z>>2]|0;do{D=m-B|0;E=(c|0)<(D|0)?c:D;Q6(y,a,s,E);N6(a,y,C,E,g);D=Y(E,p)|0;y=(f[n>>2]|0)+D|0;f[n>>2]=y;a=(f[v>>2]|0)+D|0;f[v>>2]=a;s=(f[r>>2]|0)+D|0;f[r>>2]=s;C=(f[z>>2]|0)+D|0;f[z>>2]=C;B=B+c|0}while((m|0)>(B|0))}else{B=0;C=f[n>>2]|0;s=f[v>>2]|0;a=f[r>>2]|0;y=f[z>>2]|0;do{D=m-B|0;E=(c|0)<(D|0)?c:D;R6(C,s,a,E);O6(s,C,y,E,g);D=Y(E,p)|0;C=(f[n>>2]|0)+D|0;f[n>>2]=C;s=(f[v>>2]|0)+D|0;f[v>>2]=s;a=(f[r>>2]|0)+D|0;f[r>>2]=a;y=(f[z>>2]|0)+D|0;f[z>>2]=y;B=B+c|0}while((m|0)>(B|0))}A2(o)|0;x=x+1|0}x=l+36|0;o=f[x>>2]|0;if(o|0?(m=o+12|0,o=f[m>>2]|0,f[m>>2]=o+-1,(o|0)==1):0)_S(l);f[x>>2]=0;x=l+16|0;o=l+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[o>>2]|0)>0){x=f[l+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))g0(o);o=k+36|0;l=f[o>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)_S(k);f[o>>2]=0;o=k+16|0;l=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){o=f[k+40>>2]|0;m=0;do{f[o+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))g0(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)_S(j);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[w>>2]|0;w=0;do{f[l+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))g0(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(w=j+12|0,j=f[w>>2]|0,f[w>>2]=j+-1,(j|0)==1):0)_S(i);f[k>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[A>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[A>>2]|0))}A=f[i+44>>2]|0;if((A|0)==(i+48|0)){u=h;return}g0(A);u=h;return}function a3(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0;h=u;u=u+1360|0;i=h+1304|0;j=h+1248|0;k=h+1192|0;l=h+1136|0;m=h+1112|0;o=h+1096|0;q=h+1064|0;r=h;s=c$(c,-1)|0;t=s&7;v=s>>>3&511;w=v+1|0;x=(t|0)==5;y=(t|0)==6;if((t+-5|0)>>>0>=2){f[i>>2]=0;z=i+4|0;f[z>>2]=0;A=tT(i,77)|0;B=A;C=230735;D=B+77|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,i,230813,230578,567)}if(!(r$(a)|0)?(c$(a,-1)|0)!=(s|0):0){f[i>>2]=0;z=i+4|0;f[z>>2]=0;A=tT(i,77)|0;B=A;C=230735;D=B+77|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,i,230813,230578,567)}do if((d$(a)|0)==65536){A=f[a+4>>2]|0;f[i>>2]=f[A>>2];z=i+4|0;t=A+4|0;f[z>>2]=f[t>>2];E=i+8|0;f[E>>2]=f[A+8>>2];f[i+12>>2]=f[A+12>>2];f[i+16>>2]=f[A+16>>2];f[i+20>>2]=f[A+20>>2];f[i+24>>2]=f[A+24>>2];f[i+28>>2]=f[A+28>>2];f[i+32>>2]=f[A+32>>2];F=f[A+36>>2]|0;f[i+36>>2]=F;f[i+40>>2]=E;E=i+48|0;G=i+44|0;f[G>>2]=E;f[E>>2]=0;f[i+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[t>>2]|0)<3){t=f[A+44>>2]|0;E=f[G>>2]|0;f[E>>2]=f[t>>2];f[E+4>>2]=f[t+4>>2];break}else{f[z>>2]=0;ZS(i,A);break}}else a$(i,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];A=j+4|0;z=a+4|0;f[A>>2]=f[z>>2];t=j+8|0;f[t>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];E=f[a+36>>2]|0;f[j+36>>2]=E;f[j+40>>2]=t;t=j+48|0;G=j+44|0;f[G>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(E|0){t=E+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;t=f[G>>2]|0;f[t>>2]=f[z>>2];f[t+4>>2]=f[z+4>>2];break}else{f[A>>2]=0;ZS(j,a);break}}else a$(j,c,-1);while(0);c=i+16|0;a:do if(f[c>>2]|0){a=f[i+4>>2]|0;if((a|0)<3)H=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{A=f[i+40>>2]|0;z=0;t=1;while(1){G=Y(f[A+(z<<2)>>2]|0,t)|0;z=z+1|0;if((z|0)==(a|0)){H=G;break}else t=G}}if(!((a|0)==0|(H|0)==0)){t=f[j+40>>2]|0;z=f[t+-4>>2]|0;A=f[i+40>>2]|0;if((z|0)!=(f[A+-4>>2]|0)){f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,37)|0;B=J;C=230825;D=B+37|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,k,230813,230578,573)}if((z|0)==2){if((f[t>>2]|0)!=(f[A>>2]|0)){f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,37)|0;B=J;C=230825;D=B+37|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,k,230813,230578,573)}if((f[t+4>>2]|0)==(f[A+4>>2]|0))break;f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,37)|0;B=J;C=230825;D=B+37|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,k,230813,230578,573)}else{if((z|0)>0)K=0;else break;while(1){if((f[t+(K<<2)>>2]|0)!=(f[A+(K<<2)>>2]|0))break;K=K+1|0;if((K|0)>=(z|0))break a}f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,37)|0;B=J;C=230825;D=B+37|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,k,230813,230578,573)}}}while(0);C=j+4|0;B=j+40|0;w$(d,f[C>>2]|0,f[B>>2]|0,s,-1,0,0);w$(e,f[C>>2]|0,f[B>>2]|0,s,-1,0,0);do if((d$(d)|0)==65536){s=f[d+4>>2]|0;f[k>>2]=f[s>>2];D=k+4|0;J=s+4|0;f[D>>2]=f[J>>2];I=k+8|0;f[I>>2]=f[s+8>>2];f[k+12>>2]=f[s+12>>2];f[k+16>>2]=f[s+16>>2];f[k+20>>2]=f[s+20>>2];f[k+24>>2]=f[s+24>>2];f[k+28>>2]=f[s+28>>2];f[k+32>>2]=f[s+32>>2];K=f[s+36>>2]|0;f[k+36>>2]=K;f[k+40>>2]=I;I=k+48|0;H=k+44|0;f[H>>2]=I;f[I>>2]=0;f[k+52>>2]=0;if(K|0){I=K+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[J>>2]|0)<3){J=f[s+44>>2]|0;I=f[H>>2]|0;f[I>>2]=f[J>>2];f[I+4>>2]=f[J+4>>2];break}else{f[D>>2]=0;ZS(k,s);break}}else a$(k,d,-1);while(0);do if((d$(e)|0)==65536){d=f[e+4>>2]|0;f[l>>2]=f[d>>2];s=l+4|0;D=d+4|0;f[s>>2]=f[D>>2];J=l+8|0;f[J>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];I=f[d+36>>2]|0;f[l+36>>2]=I;f[l+40>>2]=J;J=l+48|0;H=l+44|0;f[H>>2]=J;f[J>>2]=0;f[l+52>>2]=0;if(I|0){J=I+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[D>>2]|0)<3){D=f[d+44>>2]|0;J=f[H>>2]|0;f[J>>2]=f[D>>2];f[J+4>>2]=f[D+4>>2];break}else{f[s>>2]=0;ZS(l,d);break}}else a$(l,e,-1);while(0);f[m>>2]=i;f[m+4>>2]=j;f[m+8>>2]=k;f[m+12>>2]=l;f[m+16>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;z2(q,m,o,-1);m=r+8|0;f[r>>2]=m;e=r+4|0;f[e>>2]=264;d=Y(f[q+20>>2]|0,w)|0;s=v|1024;v=s-((s>>>0)%(w>>>0)|0)|0;w=(v|0)<(d|0)?v:d;v=1212424721>>>(f[j>>2]<<2&28)&15;if(y){y=w<<1;f[e>>2]=y;if(y>>>0>264){s=XDc(y>>>0>1073741823?-1:y<<2)|0;f[r>>2]=s;L=s}else L=m;M=L;N=L+(w<<2)|0}else{M=0;N=0}L=q+16|0;s=(d|0)>0;y=o+4|0;D=o+8|0;J=o+12|0;O=g?.17777777777777778:10.185916357881302;g=0;while(1){if(g>>>0>=(f[L>>2]|0)>>>0)break;if(s){H=0;do{I=d-H|0;K=(w|0)<(I|0)?w:I;do if(x){I=f[o>>2]|0;z=f[y>>2]|0;A=f[D>>2]|0;t=f[J>>2]|0;a=(K|0)>0;if(a){G=0;do{P=O*+n[z+(G<<2)>>2];E=nrc(P)|0;Q=P-+(E|0);P=Q*(Q*(Q*-1.5767166072981726e-04)+.09817477042468103);R=Q*(Q*-.004817389940423465)+1.0;Q=+p[7152+((E&63)<<3)>>3];S=+p[7152+((16-E&63)<<3)>>3];n[t+(G<<2)>>2]=Q*R+S*P;n[A+(G<<2)>>2]=S*R-Q*P;G=G+1|0}while((G|0)!=(K|0));if((I|0)!=0&a){G=0;do{P=+n[I+(G<<2)>>2];z=A+(G<<2)|0;n[z>>2]=P*+n[z>>2];z=t+(G<<2)|0;n[z>>2]=P*+n[z>>2];G=G+1|0}while((G|0)<(K|0));T=I;U=71}else{V=I;U=72}}else{V=I;U=72}}else{G=f[o>>2]|0;t=f[y>>2]|0;A=f[D>>2]|0;a=f[J>>2]|0;z=(K|0)>0;if(z){E=0;do{n[M+(E<<2)>>2]=+p[t+(E<<3)>>3];E=E+1|0}while((E|0)<(K|0));if(z){E=0;do{t=M+(E<<2)|0;P=O*+n[t>>2];I=nrc(P)|0;Q=P-+(I|0);P=Q*(Q*(Q*-1.5767166072981726e-04)+.09817477042468103);R=Q*(Q*-.004817389940423465)+1.0;Q=+p[7152+((I&63)<<3)>>3];S=+p[7152+((16-I&63)<<3)>>3];n[N+(E<<2)>>2]=Q*R+S*P;n[t>>2]=S*R-Q*P;E=E+1|0}while((E|0)!=(K|0))}}if(!G){E=K<<2;dJc(A|0,M|0,E|0)|0;dJc(a|0,N|0,E|0)|0;V=f[o>>2]|0;U=72;break}if(z){E=0;do{P=+p[G+(E<<3)>>3];p[A+(E<<3)>>3]=P*+n[M+(E<<2)>>2];p[a+(E<<3)>>3]=P*+n[N+(E<<2)>>2];E=E+1|0}while((E|0)<(K|0));T=G;U=71}else{V=G;U=72}}while(0);if((U|0)==71){U=0;W=T;X=Y(K,v)|0;U=73}else if((U|0)==72){U=0;E=Y(K,v)|0;if(!V)Z=E;else{W=V;X=E;U=73}}if((U|0)==73){U=0;f[o>>2]=W+X;Z=X}f[y>>2]=(f[y>>2]|0)+Z;f[D>>2]=(f[D>>2]|0)+Z;f[J>>2]=(f[J>>2]|0)+Z;H=H+w|0}while((d|0)>(H|0))}A2(q)|0;g=g+1|0}g=f[r>>2]|0;if((g|0)!=(m|0)){if(g|0)ZDc(g);f[r>>2]=m;f[e>>2]=264}e=l+36|0;m=f[e>>2]|0;if(m|0?(r=m+12|0,m=f[r>>2]|0,f[r>>2]=m+-1,(m|0)==1):0)_S(l);f[e>>2]=0;e=l+16|0;m=l+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[l+40>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))g0(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(r=l+12|0,l=f[r>>2]|0,f[r>>2]=l+-1,(l|0)==1):0)_S(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[k+40>>2]|0;r=0;do{f[m+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))g0(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(r=k+12|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)_S(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[C>>2]|0)>0){l=f[B>>2]|0;B=0;do{f[l+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[C>>2]|0))}C=f[j+44>>2]|0;if((C|0)!=(j+48|0))g0(C);C=i+36|0;j=f[C>>2]|0;do if(j|0){B=j+12|0;l=f[B>>2]|0;f[B>>2]=l+-1;if((l|0)!=1)break;_S(i)}while(0);f[C>>2]=0;C=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[C>>2]|0)>0){c=f[i+40>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[C>>2]|0))}C=f[i+44>>2]|0;if((C|0)==(i+48|0)){u=h;return}g0(C);u=h;return}function b3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+176|0;e=d+112|0;g=d+56|0;h=d+40|0;i=d;j=d+8|0;k=c$(a,-1)|0;l=p$(a,-1)|0;m=q$(a,-1)|0;n=(l|0)==5;if((l+-5|0)>>>0>=2){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,34)|0;o=230863;p=l+34|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));z5(-215,e,230898,230578,668)}do if((d$(a)|0)==65536){o=f[a+4>>2]|0;f[e>>2]=f[o>>2];l=e+4|0;p=o+4|0;f[l>>2]=f[p>>2];q=e+8|0;f[q>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[e+16>>2]=f[o+16>>2];f[e+20>>2]=f[o+20>>2];f[e+24>>2]=f[o+24>>2];f[e+28>>2]=f[o+28>>2];f[e+32>>2]=f[o+32>>2];r=f[o+36>>2]|0;f[e+36>>2]=r;s=e+40|0;f[s>>2]=q;q=e+48|0;t=e+44|0;f[t>>2]=q;f[q>>2]=0;f[e+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[o+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];v=s;w=l;break}else{f[l>>2]=0;ZS(e,o);v=s;w=l;break}}else{a$(e,a,-1);v=e+40|0;w=e+4|0}while(0);w$(c,f[w>>2]|0,f[v>>2]|0,k,-1,0,0);do if((d$(c)|0)==65536){k=f[c+4>>2]|0;f[g>>2]=f[k>>2];a=g+4|0;l=k+4|0;f[a>>2]=f[l>>2];s=g+8|0;f[s>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=s;s=g+48|0;p=g+44|0;f[p>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(o|0){s=o+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[l>>2]|0)<3){l=f[k+44>>2]|0;s=f[p>>2]|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];break}else{f[a>>2]=0;ZS(g,k);break}}else a$(g,c,-1);while(0);f[h>>2]=e;f[h+4>>2]=g;f[h+8>>2]=0;c=i;f[c>>2]=0;f[c+4>>2]=0;z2(j,h,i,-1);h=Y(f[j+20>>2]|0,m)|0;m=j+16|0;c=i+4|0;a:do if(n){k=0;while(1){if(k>>>0>=(f[m>>2]|0)>>>0)break a;W6(f[i>>2]|0,f[c>>2]|0,h);A2(j)|0;k=k+1|0}}else{k=0;while(1){if(k>>>0>=(f[m>>2]|0)>>>0)break a;X6(f[i>>2]|0,f[c>>2]|0,h);A2(j)|0;k=k+1|0}}while(0);j=g+36|0;h=f[j>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)_S(g);f[j>>2]=0;j=g+16|0;h=g+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[g+40>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))g0(h);h=e+36|0;g=f[h>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)_S(e);f[h>>2]=0;h=e+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[w>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[e+44>>2]|0;if((w|0)==(e+48|0)){u=d;return}g0(w);u=d;return}function c3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+176|0;e=d+112|0;g=d+56|0;h=d+40|0;i=d;j=d+8|0;k=c$(a,-1)|0;l=p$(a,-1)|0;m=q$(a,-1)|0;n=(l|0)==5;if((l+-5|0)>>>0>=2){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,34)|0;o=230863;p=l+34|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));z5(-215,e,230902,230578,701)}do if((d$(a)|0)==65536){o=f[a+4>>2]|0;f[e>>2]=f[o>>2];l=e+4|0;p=o+4|0;f[l>>2]=f[p>>2];q=e+8|0;f[q>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[e+16>>2]=f[o+16>>2];f[e+20>>2]=f[o+20>>2];f[e+24>>2]=f[o+24>>2];f[e+28>>2]=f[o+28>>2];f[e+32>>2]=f[o+32>>2];r=f[o+36>>2]|0;f[e+36>>2]=r;s=e+40|0;f[s>>2]=q;q=e+48|0;t=e+44|0;f[t>>2]=q;f[q>>2]=0;f[e+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[o+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];v=s;w=l;break}else{f[l>>2]=0;ZS(e,o);v=s;w=l;break}}else{a$(e,a,-1);v=e+40|0;w=e+4|0}while(0);w$(c,f[w>>2]|0,f[v>>2]|0,k,-1,0,0);do if((d$(c)|0)==65536){k=f[c+4>>2]|0;f[g>>2]=f[k>>2];a=g+4|0;l=k+4|0;f[a>>2]=f[l>>2];s=g+8|0;f[s>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=s;s=g+48|0;p=g+44|0;f[p>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(o|0){s=o+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[l>>2]|0)<3){l=f[k+44>>2]|0;s=f[p>>2]|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];break}else{f[a>>2]=0;ZS(g,k);break}}else a$(g,c,-1);while(0);f[h>>2]=e;f[h+4>>2]=g;f[h+8>>2]=0;c=i;f[c>>2]=0;f[c+4>>2]=0;z2(j,h,i,-1);h=Y(f[j+20>>2]|0,m)|0;m=j+16|0;c=i+4|0;a:do if(n){k=0;while(1){if(k>>>0>=(f[m>>2]|0)>>>0)break a;Y6(f[i>>2]|0,f[c>>2]|0,h);A2(j)|0;k=k+1|0}}else{k=0;while(1){if(k>>>0>=(f[m>>2]|0)>>>0)break a;Z6(f[i>>2]|0,f[c>>2]|0,h);A2(j)|0;k=k+1|0}}while(0);j=g+36|0;h=f[j>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)_S(g);f[j>>2]=0;j=g+16|0;h=g+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[g+40>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))g0(h);h=e+36|0;g=f[h>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)_S(e);f[h>>2]=0;h=e+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[w>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[e+44>>2]|0;if((w|0)==(e+48|0)){u=d;return}g0(w);u=d;return}function d3(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0;e=u;u=u+1216|0;g=e+1152|0;h=e+8|0;i=e+1136|0;j=e;k=e+1104|0;l=e+64|0;m=c$(a,-1)|0;o=m&7;q=m>>>3&511;r=q+1|0;s=nrc(c)|0;t=+L(+(+(s|0)-c))<2.220446049250313e-16;a:do if(!t){if((o+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;v=tT(g,34)|0;w=230863;x=v+34|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,g,388363,230578,1241)}}else switch(s|0){case 0:{Z$(d,a,m);p[h>>3]=1.0;p[h+8>>3]=1.0;p[h+16>>3]=1.0;p[h+24>>3]=1.0;f[g>>2]=-1056833530;f[g+4>>2]=h;f[g+8>>2]=1;f[g+12>>2]=4;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;a0(d,g,i);u=e;return}case 1:{t$(a,d);u=e;return}case 2:{qL(a,a,d,1.0,-1);u=e;return}default:break a}while(0);do if((d$(a)|0)==65536){y=f[a+4>>2]|0;f[g>>2]=f[y>>2];z=g+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=g+8|0;f[B>>2]=f[y+8>>2];f[g+12>>2]=f[y+12>>2];f[g+16>>2]=f[y+16>>2];f[g+20>>2]=f[y+20>>2];f[g+24>>2]=f[y+24>>2];f[g+28>>2]=f[y+28>>2];f[g+32>>2]=f[y+32>>2];E=f[y+36>>2]|0;f[g+36>>2]=E;F=g+40|0;f[F>>2]=B;B=g+48|0;G=g+44|0;f[G>>2]=B;f[B>>2]=0;f[g+52>>2]=0;if(E|0){B=E+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[G>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];H=F;I=z;break}else{f[z>>2]=0;ZS(g,y);H=F;I=z;break}}else{a$(g,a,-1);H=g+40|0;I=g+4|0}while(0);w$(d,f[I>>2]|0,f[H>>2]|0,m,-1,0,0);do if((d$(d)|0)==65536){m=f[d+4>>2]|0;f[h>>2]=f[m>>2];a=h+4|0;z=m+4|0;f[a>>2]=f[z>>2];F=h+8|0;f[F>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];y=f[m+36>>2]|0;f[h+36>>2]=y;f[h+40>>2]=F;F=h+48|0;A=h+44|0;f[A>>2]=F;f[F>>2]=0;f[h+52>>2]=0;if(y|0){F=y+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[z>>2]|0)<3){z=f[m+44>>2]|0;F=f[A>>2]|0;f[F>>2]=f[z>>2];f[F+4>>2]=f[z+4>>2];break}else{f[a>>2]=0;ZS(h,m);break}}else a$(h,d,-1);while(0);f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;d=j;f[d>>2]=0;f[d+4>>2]=0;z2(k,i,j,-1);i=Y(f[k+20>>2]|0,r)|0;b:do if(!t){if(+L(+(+L(+c)+-.5))<2.220446049250313e-16){d=(o|0)==5;m=c<0.0?(d?346:345):d?348:347;d=k+16|0;a=j+4|0;z=0;while(1){if(z>>>0>=(f[d>>2]|0)>>>0)break b;Ti[m&511](f[j>>2]|0,f[a>>2]|0,i);A2(k)|0;z=z+1|0}}z=q|1024;a=z-((z>>>0)%(r>>>0)|0)|0;z=(a|0)<(i|0)?a:i;a=1212424721>>>(f[g>>2]<<2&28)&15;m=l+8|0;f[l>>2]=m;d=l+4|0;f[d>>2]=1032;if((f[g+16>>2]|0)==(f[h+16>>2]|0)){F=Y(a,z)|0;f[d>>2]=F;if(F>>>0>1032){A=XDc(F)|0;f[l>>2]=A;J=A}else J=m;K=J;M=J}else{K=0;M=0}A=k+16|0;F=(i|0)>0;y=(o|0)==5;B=(M|0)!=0;G=j+4|0;E=c<0.0;N=(K|0)!=0;O=0;while(1){if(O>>>0>=(f[A>>2]|0)>>>0)break;if(F){P=0;Q=f[j>>2]|0;do{R=i-P|0;S=(z|0)<(R|0)?z:R;do if(y){R=B?M:Q;T=f[G>>2]|0;if((R|0)!=(Q|0))dJc(R|0,Q|0,Y(S,a)|0)|0;Y6(R,T,S);R=(S|0)>0;if(R)U=0;else{W6(T,T,S);break}do{V=T+(U<<2)|0;n[V>>2]=+n[V>>2]*c;U=U+1|0}while((U|0)<(S|0));W6(T,T,S);if(R)if(E){V=0;do{W=+n[Q+(V<<2)>>2];if(W<=0.0)n[T+(V<<2)>>2]=W==0.0?D:C;V=V+1|0}while((V|0)<(S|0))}else{V=0;do{if(+n[Q+(V<<2)>>2]<0.0)n[T+(V<<2)>>2]=C;V=V+1|0}while((V|0)<(S|0))}}else{V=N?K:Q;T=f[G>>2]|0;if((V|0)!=(Q|0))dJc(V|0,Q|0,Y(S,a)|0)|0;Z6(V,T,S);V=(S|0)>0;if(V)X=0;else{X6(T,T,S);break}do{R=T+(X<<3)|0;p[R>>3]=+p[R>>3]*c;X=X+1|0}while((X|0)<(S|0));X6(T,T,S);if(V)if(E){R=0;do{W=+p[Q+(R<<3)>>3];if(W<=0.0)p[T+(R<<3)>>3]=W==0.0?D:C;R=R+1|0}while((R|0)<(S|0))}else{R=0;do{if(+p[Q+(R<<3)>>3]<0.0)p[T+(R<<3)>>3]=C;R=R+1|0}while((R|0)<(S|0))}}while(0);R=Y(S,a)|0;Q=(f[j>>2]|0)+R|0;f[j>>2]=Q;f[G>>2]=(f[G>>2]|0)+R;P=P+z|0}while((i|0)>(P|0))}A2(k)|0;O=O+1|0}O=f[l>>2]|0;if((O|0)!=(m|0)){if(O|0)ZDc(O);f[l>>2]=m;f[d>>2]=1032}}else{O=f[46036+(o<<2)>>2]|0;if((o|0)==7){f[l>>2]=0;f[l+4>>2]=0;v=tT(l,9)|0;w=251213;x=v+9|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,l,388363,230578,1257)}d=k+16|0;m=j+4|0;z=0;while(1){if(z>>>0>=(f[d>>2]|0)>>>0)break b;ei[O&511](f[j>>2]|0,f[m>>2]|0,i,s);A2(k)|0;z=z+1|0}}while(0);k=h+36|0;s=f[k>>2]|0;if(s|0?(i=s+12|0,s=f[i>>2]|0,f[i>>2]=s+-1,(s|0)==1):0)_S(h);f[k>>2]=0;k=h+16|0;s=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[s>>2]|0)>0){k=f[h+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[s>>2]|0))}s=f[h+44>>2]|0;if((s|0)!=(h+48|0))g0(s);s=g+36|0;h=f[s>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)_S(g);f[s>>2]=0;s=g+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[I>>2]|0)>0){s=f[H>>2]|0;H=0;do{f[s+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}I=f[g+44>>2]|0;if((I|0)!=(g+48|0))g0(I);u=e;return}function e3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){b[g>>0]=0;i=e<<1&2;j=(i^2)+-1|0;b[g+1>>0]=j>>>0<256?j:(i|0)==0?255:0;b[g+2>>0]=-1;b[g+3>>0]=1;b[g+4>>0]=(e|0)==-1&1;if((d|0)>0){i=0;do{j=b[a+i>>0]|0;if((j&255)<3)k=b[g+((j&255)+2)>>0]|0;else k=0;b[c+i>>0]=k;i=i+1|0}while((i|0)!=(d|0))}u=f;return}if((d|0)<=0){u=f;return}if((e|0)>1)l=0;else{i=0;do{b[c+i>>0]=b[a+i>>0]|0;i=i+1|0}while((i|0)!=(d|0));u=f;return}do{i=h[a+l>>0]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:i,k)|0;i=Y(i,i)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,i)|0;b[c+l>>0]=g>>>0<255?g:255;l=l+1|0}while((l|0)!=(d|0));u=f;return}function f3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){h=(e|0)==-1;b[g>>0]=((h<<31>>31)+128|0)>>>0<256?h<<31>>31:-128;b[g+1>>0]=(e<<1&2^2)+255;b[g+2>>0]=127;b[g+3>>0]=1;b[g+4>>0]=h&1;if((d|0)>0){h=0;do{i=b[a+h>>0]|0;j=i<<24>>24;if(((i<<24>>24>-1?j:0-j|0)|0)<3)k=b[g+(j+2)>>0]|0;else k=0;b[c+h>>0]=k;h=h+1|0}while((h|0)!=(d|0))}u=f;return}if((d|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{k=b[a+h>>0]|0;g=k<<24>>24;b[c+h>>0]=(g+128|0)>>>0<256?g:k<<24>>24>0?127:128;h=h+1|0}while((h|0)!=(d|0));u=f;return}do{h=b[a+l>>0]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;b[c+l>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;l=l+1|0}while((l|0)!=(d|0));u=f;return}function g3(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){d[g>>1]=0;h=e<<1&2;i=(h^2)+-1|0;d[g+2>>1]=i>>>0<65536?i:(h|0)==0?65535:0;d[g+4>>1]=-1;d[g+6>>1]=1;d[g+8>>1]=(e|0)==-1&1;if((c|0)>0){h=0;do{i=d[a+(h<<1)>>1]|0;if((i&65535)<3)k=d[g+((i&65535)+2<<1)>>1]|0;else k=0;d[b+(h<<1)>>1]=k;h=h+1|0}while((h|0)!=(c|0))}u=f;return}if((c|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{d[b+(h<<1)>>1]=d[a+(h<<1)>>1]|0;h=h+1|0}while((h|0)!=(c|0));u=f;return}do{h=j[a+(l<<1)>>1]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;d[b+(l<<1)>>1]=g>>>0<65535?g:65535;l=l+1|0}while((l|0)!=(c|0));u=f;return}function h3(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){h=(e|0)==-1;d[g>>1]=((h<<31>>31)+32768|0)>>>0<65536?h<<31>>31:-32768;d[g+2>>1]=(e<<1&2^2)+65535;d[g+4>>1]=32767;d[g+6>>1]=1;d[g+8>>1]=h&1;if((c|0)>0){h=0;do{i=d[a+(h<<1)>>1]|0;j=i<<16>>16;if(((i<<16>>16>-1?j:0-j|0)|0)<3)k=d[g+(j+2<<1)>>1]|0;else k=0;d[b+(h<<1)>>1]=k;h=h+1|0}while((h|0)!=(c|0))}u=f;return}if((c|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{k=d[a+(h<<1)>>1]|0;g=k<<16>>16;d[b+(h<<1)>>1]=(g+32768|0)>>>0<65536?g:k<<16>>16>0?32767:32768;h=h+1|0}while((h|0)!=(c|0));u=f;return}do{h=d[a+(l<<1)>>1]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;d[b+(l<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;l=l+1|0}while((l|0)!=(c|0));u=f;return}function i3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e;if((d|0)<0){h=(d|0)==-1;f[g>>2]=h<<31>>31;f[g+4>>2]=(d<<1&2^2)+-1;f[g+8>>2]=2147483647;f[g+12>>2]=1;f[g+16>>2]=h&1;if((c|0)>0){h=0;do{i=f[a+(h<<2)>>2]|0;if((((i|0)>-1?i:0-i|0)|0)<3)j=f[g+(i+2<<2)>>2]|0;else j=0;f[b+(h<<2)>>2]=j;h=h+1|0}while((h|0)!=(c|0))}u=e;return}if((c|0)<=0){u=e;return}if((d|0)>1)k=0;else{h=0;do{f[b+(h<<2)>>2]=f[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(c|0));u=e;return}do{h=f[a+(k<<2)>>2]|0;j=1;g=d;while(1){j=Y((g&1|0)==0?1:h,j)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(j,h)|0;f[b+(k<<2)>>2]=g;k=k+1|0}while((k|0)!=(c|0));u=e;return}function j3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0.0,j=0.0,k=0.0;e=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;g=(d|0)<0;if((e|0)<=1)if(g){d=0;do{n[b+(d<<2)>>2]=1.0/+n[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}else{d=0;do{f[b+(d<<2)>>2]=f[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}if(g){g=0;do{h=1.0/+n[a+(g<<2)>>2];i=1.0;d=e;while(1){i=(d&1|0)==0?i:h*i;h=h*h;if(d>>>0<=3)break;else d=d>>>1}n[b+(g<<2)>>2]=h*i;g=g+1|0}while((g|0)!=(c|0));return}else{g=0;do{j=+n[a+(g<<2)>>2];k=1.0;d=e;while(1){k=(d&1|0)==0?k:j*k;j=j*j;if(d>>>0<=3)break;else d=d>>>1}n[b+(g<<2)>>2]=j*k;g=g+1|0}while((g|0)!=(c|0));return}}function k3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0;e=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;f=(d|0)<0;if((e|0)<=1)if(f){d=0;do{p[b+(d<<3)>>3]=1.0/+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}else{d=0;do{p[b+(d<<3)>>3]=+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}if(f){f=0;do{g=1.0/+p[a+(f<<3)>>3];h=1.0;d=e;while(1){h=(d&1|0)==0?h:g*h;g=g*g;if(d>>>0<=3)break;else d=d>>>1}p[b+(f<<3)>>3]=g*h;f=f+1|0}while((f|0)!=(c|0));return}else{f=0;do{i=+p[a+(f<<3)>>3];j=1.0;d=e;while(1){j=(d&1|0)==0?j:i*j;i=i*i;if(d>>>0<=3)break;else d=d>>>1}p[b+(f<<3)>>3]=i*j;f=f+1|0}while((f|0)!=(c|0));return}}function l3(a,b){a=a|0;b=b|0;d3(a,.5,b);return}function m3(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;h=u;u=u+320|0;i=h+64|0;j=h+56|0;k=h;l=h+288|0;m=h+176|0;o=h+160|0;q=h+232|0;r=h+152|0;t=h+96|0;p[s>>3]=e;v=f[s>>2]|0;w=f[s+4>>2]|0;p[s>>3]=g;x=f[s>>2]|0;y=f[s+4>>2]|0;do if((d$(a)|0)==65536){z=f[a+4>>2]|0;f[m>>2]=f[z>>2];A=m+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=m+8|0;f[C>>2]=f[z+8>>2];f[m+12>>2]=f[z+12>>2];f[m+16>>2]=f[z+16>>2];f[m+20>>2]=f[z+20>>2];f[m+24>>2]=f[z+24>>2];f[m+28>>2]=f[z+28>>2];f[m+32>>2]=f[z+32>>2];D=f[z+36>>2]|0;f[m+36>>2]=D;f[m+40>>2]=C;C=m+48|0;E=m+44|0;f[E>>2]=C;f[C>>2]=0;f[m+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];F=A;break}else{f[A>>2]=0;ZS(m,z);F=A;break}}else{a$(m,a,-1);F=m+4|0}while(0);a=f[F>>2]|0;if((a|0)>2){if(d|0){f[j>>2]=0;f[j+4>>2]=0;G=tT(j,10)|0;A=230906;H=G+10|0;do{b[G>>0]=b[A>>0]|0;G=G+1|0;A=A+1|0}while((G|0)<(H|0));z5(-215,j,230917,230578,1462)}f[j>>2]=m;f[j+4>>2]=0;A=k+40|0;z=k+48|0;B=k+44|0;C=k+52|0;E=k+8|0;G=k+4|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[A>>2]=E;f[B>>2]=z;f[z>>2]=0;f[C>>2]=0;f[k>>2]=1124007936;x2(l,j,k,-1);C=l+16|0;z=l+4|0;B=o+8|0;E=o+12|0;A=o+4|0;G=0;while(1){if(G>>>0>=(f[C>>2]|0)>>>0){I=1;break}H=f[z>>2]|0;f[B>>2]=0;f[E>>2]=0;f[o>>2]=16842752;f[A>>2]=H;if(!(m3(o,c,0,e,g)|0)){I=0;break}A2(l)|0;G=G+1|0}G=k+36|0;A=f[G>>2]|0;if(A|0?(E=A+12|0,A=f[E>>2]|0,f[E>>2]=A+-1,(A|0)==1):0)_S(k);f[G>>2]=0;G=k+16|0;A=k+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){G=f[k+40>>2]|0;E=0;do{f[G+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[A>>2]|0))}A=f[k+44>>2]|0;if((A|0)!=(k+48|0))g0(A);K=I}else{I=f[m>>2]|0;A=I&7;f[o>>2]=-1;E=o+4|0;f[E>>2]=-1;if(A>>>0<5){G=~~e;B=!(e<=-2147483648.0)?G-(+(G|0)>e&1)|0:-2147483648;G=~~g;z=g>2147483647.0?2147483647:G+-1+(+(G|0)<g&1)|0;G=f[46016+(A<<2)>>2]|0;f[q>>2]=I;C=q+4|0;f[C>>2]=a;a=q+8|0;f[a>>2]=f[m+8>>2];f[q+12>>2]=f[m+12>>2];H=q+16|0;f[H>>2]=f[m+16>>2];f[q+20>>2]=f[m+20>>2];f[q+24>>2]=f[m+24>>2];f[q+28>>2]=f[m+28>>2];f[q+32>>2]=f[m+32>>2];D=q+36|0;L=f[m+36>>2]|0;f[D>>2]=L;M=q+40|0;f[M>>2]=a;a=q+48|0;N=q+44|0;f[N>>2]=a;f[a>>2]=0;f[q+52>>2]=0;if((L|0)!=0?(O=L+12|0,f[O>>2]=(f[O>>2]|0)+1,(f[F>>2]|0)>=3):0){f[C>>2]=0;ZS(q,m)}else{O=f[m+44>>2]|0;L=f[N>>2]|0;f[L>>2]=f[O>>2];f[L+4>>2]=f[O+4>>2]}hh[G&127](q,o,B,z)|0;z=f[D>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)_S(q);f[D>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[C>>2]|0)>0){H=f[M>>2]|0;M=0;do{f[H+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[C>>2]|0))}C=f[N>>2]|0;if((C|0)!=(a|0))g0(C)}else{C=(I>>>3&511)+1|0;qT(j,m,C);I=f[m+16>>2]|0;a=f[m+48>>2]|0;a:do if((A|0)==5){N=a>>>2;M=(n[s>>2]=e<-3402823466385288598117041.0e14?-3402823466385288598117041.0e14:e,f[s>>2]|0);H=(n[s>>2]=g>3402823466385288598117041.0e14?3402823466385288598117041.0e14:g,f[s>>2]|0);D=M>>31&2147483647^M;M=H>>31&2147483647^H;H=j+4|0;q=f[o>>2]|0;if((q|0)<0){z=m+12|0;B=0;G=I;O=q;q=f[H>>2]|0;b:while(1){L=f[j>>2]|0;P=(L|0)>0;Q=q+-1|0;if(!q){R=Q;break}else{S=B;T=G;U=Q}while(1){if(P)break;Q=U+-1|0;if(!U){R=Q;break b}else{S=L+S|0;T=T+(N<<2)|0;U=Q}}f[H>>2]=U;P=0;while(1){Q=f[T+(P<<2)>>2]|0;V=Q>>31&2147483647^Q;if(!((V|0)>=(D|0)&(V|0)<(M|0))){W=45;break}V=P+1|0;if((V|0)<(L|0))P=V;else{X=O;break}}if((W|0)==45){W=0;V=(P+S|0)/(C|0)|0;Q=f[z>>2]|0;Y=(V|0)%(Q|0)|0;f[o>>2]=Y;f[E>>2]=(V|0)/(Q|0)|0;X=Y}if((X|0)<0){B=L+S|0;G=T+(N<<2)|0;O=X;q=U}else break a}f[H>>2]=R}}else{q=a>>>3;O=$Ic(v|0,w|0,63)|0;N=O^v;O=J&2147483647^w;G=$Ic(x|0,y|0,63)|0;B=G^x;G=J&2147483647^y;z=j+4|0;M=f[o>>2]|0;if((M|0)<0){D=f[j>>2]|0;Y=f[m+12>>2]|0;Q=f[z>>2]|0;c:do if((D|0)>0){V=I;Z=0;_=Q;$=M;while(1){aa=_+-1|0;if(!_){ba=aa;break c}else ca=0;while(1){da=V+(ca<<3)|0;ea=f[da>>2]|0;fa=f[da+4>>2]|0;da=$Ic(ea|0,fa|0,63)|0;ga=da^ea;ea=J&2147483647^fa;if(!(((ea|0)>(O|0)|(ea|0)==(O|0)&ga>>>0>=N>>>0)&((ea|0)<(G|0)|(ea|0)==(G|0)&ga>>>0<B>>>0))){W=53;break}ga=ca+1|0;if((ga|0)<(D|0))ca=ga;else{ha=$;break}}if((W|0)==53){W=0;ga=(ca+Z|0)/(C|0)|0;ea=(ga|0)%(Y|0)|0;f[o>>2]=ea;f[E>>2]=(ga|0)/(Y|0)|0;ha=ea}if((ha|0)<0){V=V+(q<<3)|0;Z=D+Z|0;_=aa;$=ha}else{ba=aa;break}}}else{$=Q;while(1){_=$+-1|0;if(!$){ba=_;break}else $=_}}while(0);f[z>>2]=ba}}while(0)}ba=f[o>>2]|0;if((ba|0)>-1){if(d|0){f[d>>2]=ba;f[d+4>>2]=f[E>>2]}if(c)ia=0;else{f[r>>2]=0;f[r+4>>2]=0;c=f[E>>2]|0;f[j>>2]=ba;f[j+4>>2]=ba+1;f[k>>2]=c;f[k+4>>2]=c+1;$S(t,m,k,j);p9(l,0);c=f[l+4>>2]|0;Ti[f[(f[c>>2]|0)+8>>2]&511](k,c,t);c=k+4|0;ba=f[c>>2]|0;Yi[f[(f[ba>>2]|0)+4>>2]&2047](ba);ba=f[c>>2]|0;d=_i[f[f[ba>>2]>>2]&1023](ba)|0;if(d|0){ba=j+4|0;ha=d;do{f[j>>2]=0;f[ba>>2]=0;d=Mpc(ha)|0;if(d|0)dJc(tT(j,d)|0,ha|0,d|0)|0;n3(r,j)|0;uT(j);d=f[c>>2]|0;ha=_i[f[f[d>>2]>>2]&1023](d)|0}while((ha|0)!=0)}ha=f[k>>2]|0;if(ha|0?(ba=ha+4|0,d=f[ba>>2]|0,f[ba>>2]=d+-1,(d|0)==1):0)Yi[f[(f[ha>>2]|0)+8>>2]&2047](ha);f[k>>2]=0;f[c>>2]=0;c=f[l>>2]|0;if(c|0?(l=c+4|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);c=t+36|0;k=f[c>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(t);f[c>>2]=0;c=t+16|0;k=t+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[k>>2]|0)>0){c=f[t+40>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[t+44>>2]|0;if((k|0)==(t+48|0)){ja=f[o>>2]|0;ka=f[E>>2]|0;la=f[r>>2]|0;ma=(la|0)==0;na=ma?1154740:la;f[i>>2]=ja;oa=i+4|0;f[oa>>2]=ka;pa=i+8|0;f[pa>>2]=na;qa=i+16|0;p[qa>>3]=e;ra=i+24|0;p[ra>>3]=g;F5(j,230928,i);z5(-211,j,230917,230578,1563)}g0(k);ja=f[o>>2]|0;ka=f[E>>2]|0;la=f[r>>2]|0;ma=(la|0)==0;na=ma?1154740:la;f[i>>2]=ja;oa=i+4|0;f[oa>>2]=ka;pa=i+8|0;f[pa>>2]=na;qa=i+16|0;p[qa>>3]=e;ra=i+24|0;p[ra>>3]=g;F5(j,230928,i);z5(-211,j,230917,230578,1563)}}else ia=1;K=ia}ia=m+36|0;j=f[ia>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)_S(m);f[ia>>2]=0;ia=m+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[F>>2]|0)>0){ia=f[m+40>>2]|0;j=0;do{f[ia+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[F>>2]|0))}F=f[m+44>>2]|0;if((F|0)==(m+48|0)){u=h;return K|0}g0(F);u=h;return K|0}function n3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;g=a+4|0;h=b+4|0;tT(d,(f[h>>2]|0)+(f[g>>2]|0)|0)|0;i=f[g>>2]|0;if(i|0)dJc(f[d>>2]|0,f[a>>2]|0,i|0)|0;i=f[h>>2]|0;if(i|0)dJc((f[d>>2]|0)+(f[g>>2]|0)|0,f[b>>2]|0,i|0)|0;if((d|0)==(a|0)){uT(d);u=c;return a|0}uT(a);i=f[d>>2]|0;if(!i)j=0;else{b=i+-4|0;f[b>>2]=(f[b>>2]|0)+1;j=f[d>>2]|0}f[a>>2]=j;f[g>>2]=f[e>>2];uT(d);u=c;return a|0}function o3(a,b){a=+a;b=+b;return +(+_6(a,b))}function p3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,P=0,Q=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0;d=u;u=u+112|0;e=d+56|0;g=d;do if((d$(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=e;break}else{f[i>>2]=0;ZS(e,h);o=e;break}}else{a$(e,a,-1);o=e}while(0);a=f[o>>2]&4095;h=(a|0)==5;if((a+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,34)|0;j=230978;k=i+34|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,g,231013,230578,1756)}j=e+40|0;i=f[j>>2]|0;k=f[i+4>>2]|0;m=f[i>>2]|0;if(!((k+-3|0)>>>0<2&(m|0)==1)?!((k|0)==1&(m+-3|0)>>>0<2):0){f[g>>2]=0;f[g+4>>2]=0;dJc(tT(g,130)|0,231024,130)|0;z5(-215,g,231013,230578,1760)}Y$(c,3,1,a,-1,1,96);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[g>>2]=f[a>>2];m=g+4|0;k=a+4|0;f[m>>2]=f[k>>2];i=g+8|0;f[i>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[g+16>>2]=f[a+16>>2];f[g+20>>2]=f[a+20>>2];f[g+24>>2]=f[a+24>>2];f[g+28>>2]=f[a+28>>2];f[g+32>>2]=f[a+32>>2];l=f[a+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=i;i=g+48|0;q=g+44|0;f[q>>2]=i;f[i>>2]=0;f[g+52>>2]=0;if(l|0){i=l+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+44>>2]|0;i=f[q>>2]|0;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];break}else{f[m>>2]=0;ZS(g,a);break}}else a$(g,c,-1);while(0);c=f[e+12>>2]|0;a=(c+(f[e+8>>2]|0)|0)==5;m=e+16|0;if(h){if(a){h=f[m>>2]|0;r=0;s=+n[h>>2];t=h;v=h}else{h=f[m>>2]|0;r=-1;s=1.0;t=h;v=h}h=r+1|0;do if(!(f[o>>2]&16384)){k=f[j>>2]|0;do if((f[k>>2]|0)!=1){i=f[f[e+44>>2]>>2]|0;if((f[k+4>>2]|0)==1){w=t+(Y(i,h)|0)|0;break}else{q=(h|0)/(c|0)|0;w=t+(Y(q,i)|0)+(h-(Y(q,c)|0)<<2)|0;break}}else w=t+(h<<2)|0;while(0);x=+n[w>>2];k=r+2|0;q=f[j>>2]|0;do if((f[q>>2]|0)!=1){i=f[f[e+44>>2]>>2]|0;if((f[q+4>>2]|0)==1){y=t+(Y(i,k)|0)|0;break}else{l=(k|0)/(c|0)|0;y=t+(Y(l,i)|0)+(k-(Y(l,c)|0)<<2)|0;break}}else y=t+(k<<2)|0;while(0);z=+n[y>>2];k=r+3|0;q=f[j>>2]|0;if((f[q>>2]|0)!=1){l=f[f[e+44>>2]>>2]|0;if((f[q+4>>2]|0)==1){A=t+(Y(l,k)|0)|0;B=z;C=x;break}else{q=(k|0)/(c|0)|0;A=t+(Y(q,l)|0)+(k-(Y(q,c)|0)<<2)|0;B=z;C=x;break}}else{D=k;E=z;F=x;G=37}}else{D=r+3|0;E=+n[t+(r+2<<2)>>2];F=+n[v+(h<<2)>>2];G=37}while(0);if((G|0)==37){A=t+(D<<2)|0;B=E;C=F}H=+n[A>>2];I=B;J=C;K=s}else{if(a){a=f[m>>2]|0;P=0;Q=+p[a>>3];S=a;T=a}else{a=f[m>>2]|0;P=-1;Q=1.0;S=a;T=a}a=P+1|0;do if(!(f[o>>2]&16384)){m=f[j>>2]|0;do if((f[m>>2]|0)!=1){A=f[f[e+44>>2]>>2]|0;if((f[m+4>>2]|0)==1){U=S+(Y(A,a)|0)|0;break}else{D=(a|0)/(c|0)|0;U=S+(Y(D,A)|0)+(a-(Y(D,c)|0)<<3)|0;break}}else U=S+(a<<3)|0;while(0);x=+p[U>>3];m=P+2|0;D=f[j>>2]|0;do if((f[D>>2]|0)!=1){A=f[f[e+44>>2]>>2]|0;if((f[D+4>>2]|0)==1){V=S+(Y(A,m)|0)|0;break}else{t=(m|0)/(c|0)|0;V=S+(Y(t,A)|0)+(m-(Y(t,c)|0)<<3)|0;break}}else V=S+(m<<3)|0;while(0);s=+p[V>>3];m=P+3|0;D=f[j>>2]|0;if((f[D>>2]|0)!=1){t=f[f[e+44>>2]>>2]|0;if((f[D+4>>2]|0)==1){W=S+(Y(t,m)|0)|0;X=s;Z=x;break}else{D=(m|0)/(c|0)|0;W=S+(Y(D,t)|0)+(m-(Y(D,c)|0)<<3)|0;X=s;Z=x;break}}else{_=m;$=s;aa=x;G=58}}else{_=P+3|0;$=+p[S+(P+2<<3)>>3];aa=+p[T+(a<<3)>>3];G=58}while(0);if((G|0)==58){W=S+(_<<3)|0;X=$;Z=aa}H=+p[W>>3];I=X;J=Z;K=Q}do if(K==0.0){if(!(J==0.0)){Q=I*I-J*4.0*H;if(!(Q>=0.0)){ba=0.0;ca=0;da=0.0;ea=0.0;break}Z=+M(+Q);Q=(Z-I)*.5;X=(I+Z)*-.5;W=+L(+Q)>+L(+X);aa=W?Q:X;ba=0.0;ca=Z>0.0?2:1;da=H/aa;ea=aa/J;break}if(I==0.0){ba=0.0;ca=(H==0.0)<<31>>31;da=0.0;ea=0.0;break}else{ba=0.0;ca=1;da=0.0;ea=-H/I;break}}else{aa=1.0/K;Z=J*aa;X=I*aa;Q=(Z*Z-X*3.0)*.1111111111111111;$=(H*aa*27.0+(Z*(Z*(Z*2.0))-X*(Z*9.0)))*.018518518518518517;X=Q*(Q*Q);aa=X-$*$;if(aa>0.0){s=+M(+Q)*-2.0;C=+R(+($/+M(+X)))*.3333333333333333;X=Z*.3333333333333333;ba=s*+O(+(C+4.1887902047863905))-X;ca=3;da=s*+O(+(C+2.0943951023931953))-X;ea=s*+O(+C)-X;break}if(!(aa==0.0)){X=+N(+(+M(+-aa)+ +L(+$)),.3333333333333333);aa=$>0.0?-X:X;ba=0.0;ca=1;da=0.0;ea=aa+Q/aa-Z*.3333333333333333;break}aa=Z/3.0;if(!($>=0.0)){Z=+N(+-$,.3333333333333333);fa=Z*2.0;ga=-Z}else{Z=+N(+$,.3333333333333333);fa=Z*-2.0;ga=Z}Z=ga-aa;$=fa-aa;W=$==Z;ba=0.0;ca=W?1:2;da=W?0.0:Z;ea=$}while(0);W=f[g>>2]|0;_=g+16|0;S=f[_>>2]|0;if((W&4095|0)==5){n[S>>2]=ea;do if(!(W&16384)){a=f[g+40>>2]|0;do if((f[a>>2]|0)!=1){T=f[f[g+44>>2]>>2]|0;if((f[a+4>>2]|0)==1){ha=S+T|0;break}else{P=f[g+12>>2]|0;c=(P+1|0)>>>0<3?P:0;ha=S+(Y(c,T)|0)+(1-(Y(c,P)|0)<<2)|0;break}}else ha=S+4|0;while(0);n[ha>>2]=da;a=f[g+40>>2]|0;if((f[a>>2]|0)!=1){P=f[f[g+44>>2]>>2]|0;if((f[a+4>>2]|0)==1){ia=S+(P<<1)|0;break}else{a=f[g+12>>2]|0;c=2/(a|0)|0;ia=S+(Y(c,P)|0)+(2-(Y(c,a)|0)<<2)|0;break}}else G=87}else{n[S+4>>2]=da;G=87}while(0);if((G|0)==87)ia=S+8|0;n[ia>>2]=ba}else{p[S>>3]=ea;do if(!(W&16384)){ia=f[g+40>>2]|0;do if((f[ia>>2]|0)!=1){ha=f[f[g+44>>2]>>2]|0;if((f[ia+4>>2]|0)==1){ja=S+ha|0;break}else{a=f[g+12>>2]|0;c=(a+1|0)>>>0<3?a:0;ja=S+(Y(c,ha)|0)+(1-(Y(c,a)|0)<<3)|0;break}}else ja=S+8|0;while(0);p[ja>>3]=da;ia=f[g+40>>2]|0;if((f[ia>>2]|0)!=1){a=f[f[g+44>>2]>>2]|0;if((f[ia+4>>2]|0)==1){ka=S+(a<<1)|0;break}else{ia=f[g+12>>2]|0;c=2/(ia|0)|0;ka=S+(Y(c,a)|0)+(2-(Y(c,ia)|0)<<3)|0;break}}else G=100}else{p[S+8>>3]=da;G=100}while(0);if((G|0)==100)ka=S+16|0;p[ka>>3]=ba}ka=g+36|0;S=f[ka>>2]|0;if(S|0?(G=S+12|0,S=f[G>>2]|0,f[G>>2]=S+-1,(S|0)==1):0)_S(g);f[ka>>2]=0;ka=g+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[ka>>2]|0)>0){_=f[g+40>>2]|0;S=0;do{f[_+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[ka>>2]|0))}ka=f[g+44>>2]|0;if((ka|0)!=(g+48|0))g0(ka);ka=e+36|0;g=f[ka>>2]|0;if(g|0?(S=g+12|0,g=f[S>>2]|0,f[S>>2]=g+-1,(g|0)==1):0)_S(e);f[ka>>2]=0;ka=e+16|0;g=e+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[g>>2]|0)>0){ka=f[j>>2]|0;j=0;do{f[ka+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)==(e+48|0)){u=d;return ca|0}g0(g);u=d;return ca|0}function q3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0;e=u;u=u+1552|0;g=e+1528|0;h=e+1472|0;i=e+1416|0;j=e;k=e+1352|0;l=e+1408|0;m=e+1296|0;n=e+1184|0;o=e+1160|0;q=e+1240|0;r=e+1176|0;do if((d$(a)|0)==65536){s=f[a+4>>2]|0;f[h>>2]=f[s>>2];t=h+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=h+8|0;f[w>>2]=f[s+8>>2];f[h+12>>2]=f[s+12>>2];f[h+16>>2]=f[s+16>>2];f[h+20>>2]=f[s+20>>2];f[h+24>>2]=f[s+24>>2];f[h+28>>2]=f[s+28>>2];f[h+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[h+36>>2]=x;f[h+40>>2]=w;w=h+48|0;y=h+44|0;f[y>>2]=w;f[w>>2]=0;f[h+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;ZS(h,s);break}}else a$(h,a,-1);while(0);s=c$(a,-1)|0;a=s&7;if(a>>>0<=4){f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,54)|0;B=A;C=231155;D=B+54|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,g,231210,230578,1907)}if(((s>>>3&511)+1|0)>>>0>=3){f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,54)|0;B=A;C=231155;D=B+54|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,g,231210,230578,1907)}A=f[h+8>>2]|0;z=f[h+12>>2]|0;if(!((A|0)==1|(z|0)==1)){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,38)|0;C=231220;D=B+38|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,g,231210,230578,1908)}C=A+-2+z|0;Y$(c,C,1,a|8,-1,1,96);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];s=i+4|0;t=a+4|0;f[s>>2]=f[t>>2];v=i+8|0;f[v>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];w=f[a+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=v;v=i+48|0;y=i+44|0;f[y>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;ZS(i,a);break}}else a$(i,c,-1);while(0);c=(C<<1)+2|0;a=j+8|0;XIc(a|0,0,1152)|0;f[j>>2]=a;s=j+4|0;f[s>>2]=c;if(c>>>0>72){t=XDc(c>>>0>268435455?-1:c<<4)|0;XIc(t|0,0,c<<4|0)|0;f[j>>2]=t;E=t}else E=a;t=E+(C<<4)+16|0;c=h+40|0;v=f[c>>2]|0;y=f[v>>2]|0;f[l>>2]=f[v+4>>2];f[l+4>>2]=y;y=((f[h>>2]|0)>>>3&511)+1|0;CY(k,l,(y<<3)+-2|0,(y|0)==2?E:t,0);y=g+8|0;f[y>>2]=0;f[y+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;LZ(h,g,f[k>>2]&4095,1.0,0.0);if(!(f[h>>2]&4088))if((C|0)<0){F=C;G=0}else{y=A+z+-1|0;z=0;do{p[E+(z<<4)>>3]=+p[t+(z<<3)>>3];p[E+(z<<4)+8>>3]=0.0;z=z+1|0}while((z|0)!=(y|0));H=25}else H=25;do if((H|0)==25){if((C|0)<=1)if((C|0)==1){I=1;J=1}else{F=C;G=0;break}else{y=C;while(1){K=+L(+(+p[E+(y<<4)>>3]));if(K+ +L(+(+p[E+(y<<4)+8>>3]))>2.220446049250313e-16){O=y;break}y=y+-1|0;if((y|0)<=1){O=1;break}}I=O;J=(O|0)>0}y=0;K=1.0;P=0.0;while(1){z=t+(y<<4)|0;p[z>>3]=K;p[z+8>>3]=P;Q=K+P;y=y+1|0;if((y|0)==(I|0)){F=I;G=J;break}else{K=K-P;P=Q}}}while(0);J=(d|0)<1?1e3:d;a:do if((J|0)>0){d=E+(F<<4)|0;I=E+(F<<4)+8|0;O=m+4|0;y=m+8|0;z=m+40|0;A=m+48|0;l=m+44|0;v=m+52|0;w=g+4|0;x=n+4|0;R=n+8|0;S=n+40|0;T=n+48|0;U=n+44|0;V=n+52|0;W=m+16|0;X=m+12|0;Z=g+8|0;_=g+12|0;$=g+4|0;aa=o+8|0;ba=o+4|0;ca=n+16|0;da=n+36|0;ea=m+36|0;fa=0;while(1){if(G){ga=0.0;ha=0}else{ia=0.0;break a}do{ja=t+(ha<<4)|0;P=+p[ja>>3];ka=ja+8|0;K=+p[ka>>3];Q=+p[d>>3];la=+p[I>>3];ma=0;na=1;oa=Q;pa=Q;Q=la;qa=la;while(1){ra=F-ma+-1|0;la=pa;pa=P*pa-K*Q+ +p[E+(ra<<4)>>3];Q=K*la+P*Q+ +p[E+(ra<<4)+8>>3];do if((ma|0)!=(ha|0)){ra=t+(ma<<4)|0;la=P-+p[ra>>3];sa=K-+p[ra+8>>3];if(la!=0.0|sa!=0.0){ta=na;ua=oa*la-qa*sa;va=qa*la+oa*sa;break}else{ta=na+1|0;ua=oa;va=qa;break}}else{ta=na;ua=oa;va=qa}while(0);ma=ma+1|0;if((ma|0)==(F|0))break;else{na=ta;oa=ua;qa=va}}qa=1.0/(ua*ua+va*va);oa=qa*(ua*pa+va*Q);sa=qa*(ua*Q-va*pa);if((ta|0)>1){if(((ta<<31>>31)+(ta>>>1)|0)>0){qa=oa+ +M(+(oa*oa+sa*sa));la=+M(+(qa*.5));wa=+M(+((qa-oa)*.5));xa=la;ya=oa<0.0?-wa:wa}else{xa=oa;ya=sa}if(!(ta&1)){za=xa;Aa=ya}else{f[m>>2]=1124007936;B=O;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[z>>2]=y;f[l>>2]=A;f[A>>2]=0;f[v>>2]=0;f[g>>2]=4;f[w>>2]=1;XS(m,2,g,6);f[n>>2]=1124007936;B=x;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[S>>2]=R;f[U>>2]=T;f[T>>2]=0;f[V>>2]=0;f[g>>2]=3;f[w>>2]=1;XS(n,2,g,14);pa=-+N(+oa,3.0);na=(f[m>>2]&16384|0)==0;ma=f[W>>2]|0;do if(na?(ra=f[z>>2]|0,(f[ra>>2]|0)!=1):0){Ba=f[f[l>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ca=ma+(Ba*3|0)|0;break}else{ra=f[X>>2]|0;Da=3/(ra|0)|0;Ca=ma+(Y(Da,Ba)|0)+(3-(Y(Da,ra)|0)<<3)|0;break}}else H=48;while(0);if((H|0)==48){H=0;Ca=ma+24|0}p[Ca>>3]=pa;Q=-(oa*oa*15.0+sa*sa*27.0);do if(na){ra=f[z>>2]|0;do if((f[ra>>2]|0)!=1){Da=f[f[l>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ea=ma+(Da<<1)|0;break}else{Ba=f[X>>2]|0;Fa=2/(Ba|0)|0;Ea=ma+(Y(Fa,Da)|0)+(2-(Y(Fa,Ba)|0)<<3)|0;break}}else Ea=ma+16|0;while(0);p[Ea>>3]=Q;wa=oa*-48.0;ra=f[z>>2]|0;if((f[ra>>2]|0)==1){Ga=wa;H=60;break}Ba=f[f[l>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ha=ma+Ba|0;Ia=wa;break}else{ra=f[X>>2]|0;Fa=(ra+1|0)>>>0<3?ra:0;Ha=ma+(Y(Fa,Ba)|0)+(1-(Y(Fa,ra)|0)<<3)|0;Ia=wa;break}}else{p[ma+16>>3]=Q;Ga=oa*-48.0;H=60}while(0);if((H|0)==60){H=0;Ha=ma+8|0;Ia=Ga}p[Ha>>3]=Ia;p[ma>>3]=64.0;f[Z>>2]=0;f[_>>2]=0;f[g>>2]=16842752;f[$>>2]=m;na=aa;f[na>>2]=0;f[na+4>>2]=0;f[o>>2]=33619968;f[ba>>2]=n;p3(g,o)|0;Q=+p[f[ca>>2]>>3];if(!(Q>=0.0))Ja=-+N(+-Q,.3333333333333333);else Ja=+N(+Q,.3333333333333333);Q=+M(+(Ja*Ja/3.0-oa/(Ja*3.0)));na=f[da>>2]|0;do if(na|0){ra=na+12|0;Fa=f[ra>>2]|0;f[ra>>2]=Fa+-1;if((Fa|0)!=1)break;_S(n)}while(0);f[da>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[x>>2]|0)>0){na=f[S>>2]|0;ma=0;do{f[na+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[x>>2]|0))}ma=f[U>>2]|0;if((ma|0)!=(T|0))g0(ma);ma=f[ea>>2]|0;do if(ma|0){na=ma+12|0;Fa=f[na>>2]|0;f[na>>2]=Fa+-1;if((Fa|0)!=1)break;_S(m)}while(0);f[ea>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[O>>2]|0)>0){ma=f[z>>2]|0;Fa=0;do{f[ma+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[O>>2]|0))}Fa=f[l>>2]|0;if((Fa|0)!=(A|0))g0(Fa);za=Ja;Aa=Q}}else{za=oa;Aa=sa}p[ja>>3]=P-za;p[ka>>3]=K-Aa;pa=+M(+(za*za+Aa*Aa));ga=ga<pa?pa:ga;ha=ha+1|0}while((ha|0)<(F|0));fa=fa+1|0;if(!(!(ga<=0.0)&(fa|0)<(J|0))){Ka=ga;H=86;break}}}else{Ka=0.0;H=86}while(0);if((H|0)==86)if((f[h>>2]&4088|0)==0&G){G=0;do{H=t+(G<<4)+8|0;if(+L(+(+p[H>>3]))<1.0e-100)p[H>>3]=0.0;G=G+1|0}while((G|0)!=(F|0));ia=Ka}else ia=Ka;if((F|0)<(C|0)){G=F;do{F=t+(G<<4)|0;G=G+1|0;H=t+(G<<4)|0;f[H>>2]=f[F>>2];f[H+4>>2]=f[F+4>>2];f[H+8>>2]=f[F+8>>2];f[H+12>>2]=f[F+12>>2]}while((G|0)!=(C|0))}C=i+40|0;G=f[C>>2]|0;F=f[G>>2]|0;f[r>>2]=f[G+4>>2];f[r+4>>2]=F;CY(q,r,14,t,0);t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=i;LZ(q,g,f[i>>2]&4095,1.0,0.0);g=q+36|0;t=f[g>>2]|0;if(t|0?(r=t+12|0,t=f[r>>2]|0,f[r>>2]=t+-1,(t|0)==1):0)_S(q);f[g>>2]=0;g=q+16|0;t=q+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[t>>2]|0)>0){g=f[q+40>>2]|0;r=0;do{f[g+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[t>>2]|0))}t=f[q+44>>2]|0;if((t|0)!=(q+48|0))g0(t);t=k+36|0;q=f[t>>2]|0;if(q|0?(r=q+12|0,q=f[r>>2]|0,f[r>>2]=q+-1,(q|0)==1):0)_S(k);f[t>>2]=0;t=k+16|0;q=k+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[q>>2]|0)>0){t=f[k+40>>2]|0;r=0;do{f[t+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[k+44>>2]|0;if((q|0)!=(k+48|0))g0(q);q=f[j>>2]|0;if((q|0)!=(a|0)){if(q|0)ZDc(q);f[j>>2]=a;f[s>>2]=72}s=i+36|0;a=f[s>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)_S(i);f[s>>2]=0;s=i+16|0;a=i+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[C>>2]|0;C=0;do{f[s+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[a>>2]|0))}a=f[i+44>>2]|0;if((a|0)!=(i+48|0))g0(a);a=h+36|0;i=f[a>>2]|0;do if(i|0){C=i+12|0;s=f[C>>2]|0;f[C>>2]=s+-1;if((s|0)!=1)break;_S(h)}while(0);f[a>>2]=0;a=h+16|0;i=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=e;return +ia}g0(i);u=e;return +ia}function r3(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;f[c>>2]=0;f[c+4>>2]=0;a=tT(c,46)|0;d=231259;e=a+46|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));s3(-218,c,231306,64)}function s3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,231319,d);return}function t3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;r3()}function u3(a){a=a|0;return}function v3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if(!((a|0)!=0&(c|0)!=0&(e|0)!=0)){f=0;return f|0}g=a+d|0;d=e-((e>>>0)%3|0)|0;a=g+d|0;if((d|0)>0){d=c;i=g;while(1){j=b[i+1>>0]|0;k=i+3|0;l=b[i+2>>0]|0;m=h[i>>0]|0;b[d>>0]=b[231384+(m>>>2)>>0]|0;n=j&255;b[d+1>>0]=b[231384+(n>>>4|m<<4&48)>>0]|0;m=l&255;b[d+2>>0]=b[231384+(m>>>6|n<<2&60)>>0]|0;n=d+4|0;b[d+3>>0]=b[231384+(m&63)>>0]|0;if(k>>>0<a>>>0){d=n;i=k}else{o=n;p=k;break}}}else{o=c;p=g}i=g+e-p|0;switch(i|0){case 1:{e=h[p>>0]|0;b[o>>0]=b[231384+(e>>>2)>>0]|0;q=o+1|0;r=2;s=e<<4;t=48;u=7;break}case 2:{e=b[p+1>>0]|0;g=h[p>>0]|0;b[o>>0]=b[231384+(g>>>2)>>0]|0;p=e&255;b[o+1>>0]=b[231384+(g<<4&48|p>>>4)>>0]|0;q=o+2|0;r=3;s=p<<2;t=60;u=7;break}default:v=o}if((u|0)==7){b[q>>0]=b[231384+(s&t)>>0]|0;v=o+r|0}switch(i|0){case 1:{b[v>>0]=61;w=v+1|0;u=10;break}case 2:{w=v;u=10;break}default:x=v}if((u|0)==10){b[w>>0]=61;x=w+1|0}b[x>>0]=0;f=x-c|0;return f|0}function w3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0;if(!((a|0)!=0&(c|0)!=0&(e|0)!=0&(e&3|0)==0)){f=0;return f|0}g=a+d|0;i=g+e|0;if((e|0)>0){e=a+(d+4)|0;j=((((i>>>0>e>>>0?i:e)+(~a-d)|0)>>>2)*3|0)+3|0;d=c;a=g;while(1){g=b[231449+(h[a+3>>0]|0)>>0]|0;e=h[231449+(h[a+2>>0]|0)>>0]|0;k=h[231449+(h[a+1>>0]|0)>>0]|0;b[d>>0]=k>>>4&3|(h[231449+(h[a>>0]|0)>>0]|0)<<2;a=a+4|0;b[d+1>>0]=e>>>2&15|k<<4;b[d+2>>0]=g&255|e<<6;if(a>>>0>=i>>>0)break;else d=d+3|0}l=c+j|0}else l=c;b[l>>0]=0;f=l-c|0;return f|0}function x3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(!d)e=Mpc(a)|0;else e=d;return w3(a,b,c,e)|0}function y3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;if(!d)e=Mpc(a)|0;else e=d;if(!a){f=0;return f|0}d=a+c|0;if(!d){f=0;return f|0}if(!e)g=Mpc(a)|0;else g=e;if(!((g|0)!=0&(g&3|0)==0)){f=0;return f|0}e=d+g|0;g=e+-1|0;if((b[g>>0]|0)==61){a=g+-1|0;h=(b[a>>0]|0)==61?a:g}else h=e;if(d>>>0<h>>>0)i=d;else{f=1;return f|0}while(1){d=b[i>>0]|0;if((d&255)>126){f=0;j=14;break}i=i+1|0;if(!(d<<24>>24==65|(b[231449+(d&255)>>0]|0)!=0)){f=0;j=14;break}if(i>>>0>=h>>>0){f=1;j=14;break}}if((j|0)==14)return f|0;return 0}function z3(a,b){a=a|0;b=b|0;return ((a>>>2)*3|0)+(b&1)|0}function A3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;e=0;f=c+a|0;while(1){f=f+-1|0;if((b[f>>0]|0)!=61)break;else e=e+1|0}return (d&1)+((a>>>2)*3|0)-e|0}function B3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+160|0;e=d+136|0;g=d;h=g+56|0;i=g+4|0;f[g>>2]=7676;f[h>>2]=7696;auc(g+56|0,i);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=46080;f[h>>2]=46100;fuc(i);f[i>>2]=45740;h=g+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G1(i,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);h=H1(g,c,Mpc(c)|0)|0;b[e>>0]=32;H1(h,e,1)|0;I1(a,i);i=a+11|0;h=b[i>>0]|0;if(h<<24>>24<0)j=f[a+4>>2]|0;else j=h&255;if(j>>>0>=24){f[e>>2]=0;f[e+4>>2]=0;j=tT(e,27)|0;h=231576;c=j+27|0;do{b[j>>0]=b[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(c|0));C3(-215,e,231604,303)}mEc(a,24);e=a+4|0;while(1){h=b[i>>0]|0;if(h<<24>>24<0)k=f[e>>2]|0;else k=h&255;if(k>>>0>=24)break;vEc(a,32)}D3(g);u=d;return}function C3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,231623,d);return}function D3(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=46080;c=a+56|0;f[c>>2]=46100;d=a+4|0;f[d>>2]=45740;e=a+36|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);Qsc(d);Mtc(a,46112);Lsc(c);return}function E3(a){a=a|0;D3(a);YDc(a);return}function F3(a){a=a|0;D3(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function G3(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;D3(b);YDc(b);return}function H3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+160|0;e=d+12|0;g=d;h=f[a>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=Mpc(h)|0;if(a>>>0>4294967279)dEc(g);if(a>>>0<11){b[g+11>>0]=a;if(!a)i=g;else{j=g;k=6}}else{l=a+16&-16;m=VDc(l)|0;f[g>>2]=m;f[g+8>>2]=l|-2147483648;f[g+4>>2]=a;j=m;k=6}if((k|0)==6){dJc(j|0,h|0,a|0)|0;i=j}b[i+a>>0]=0;a=e+60|0;i=e+8|0;f[e>>2]=7732;f[a>>2]=7752;f[e+4>>2]=0;auc(e+60|0,i);f[e+132>>2]=0;f[e+136>>2]=-1;f[e>>2]=46136;f[a>>2]=46156;fuc(i);f[i>>2]=45740;a=e+40|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[e+56>>2]=8;G1(i,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);g=I3(e,c)|0;c=(f[g+(f[(f[g>>2]|0)+-12>>2]|0)+16>>2]&5|0)==0;J3(e);u=d;return c|0}function I3(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+4|0;i=e;huc(g,a,0);if(!(b[g>>0]|0)){g=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(g,f[g+16>>2]|4);u=e;return a|0}g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[g>>0]=0}g=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;j=f[g+12>>2]|0;k=(j|0)<1?2147483647:j;cuc(i,g);g=Hvc(i,885240)|0;Ivc(i);a:do if((k|0)>0){i=g+8|0;j=0;while(1){l=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;m=f[l+12>>2]|0;if((m|0)==(f[l+16>>2]|0)){n=_i[f[(f[l>>2]|0)+36>>2]&1023](l)|0;if((n|0)==-1){o=j;p=2;break a}else q=n}else q=h[m>>0]|0;m=q&255;if(m<<24>>24>-1?d[(f[i>>2]|0)+(q<<24>>24<<1)>>1]&8192:0){o=j;p=0;break a}vEc(c,m);m=j+1|0;n=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;l=n+12|0;r=f[l>>2]|0;if((r|0)==(f[n+16>>2]|0))_i[f[(f[n>>2]|0)+40>>2]&1023](n)|0;else f[l>>2]=r+1;if((m|0)<(k|0))j=m;else{o=m;p=0;break}}}else{o=0;p=0}while(0);f[a+(f[(f[a>>2]|0)+-12>>2]|0)+12>>2]=0;k=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(k,f[k+16>>2]|((o|0)==0?p|4:p));u=e;return a|0}function J3(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=46136;c=a+60|0;f[c>>2]=46156;d=a+8|0;f[d>>2]=45740;e=a+40|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);Qsc(d);Ctc(a,46168);Lsc(c);return}function K3(a){a=a|0;J3(a);YDc(a);return}function L3(a){a=a|0;J3(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function M3(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;J3(b);YDc(b);return}function N3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;f[a>>2]=c;f[a+4>>2]=c+d;d=a+8|0;f[d>>2]=0;c=a+12|0;f[c>>2]=0;f[a+16>>2]=0;e=VDc(120)|0;f[c>>2]=e;f[d>>2]=e;f[a+16>>2]=e+120;d=120;g=e;do{b[g>>0]=0;g=(f[c>>2]|0)+1|0;f[c>>2]=g;d=d+-1|0}while((d|0)!=0);d=a+20|0;g=a+24|0;c=a+28|0;e=a+32|0;h=a+36|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;i=VDc(161)|0;f[h>>2]=i;f[e>>2]=i;f[a+40>>2]=i+161;a=161;j=i;do{b[j>>0]=0;j=(f[h>>2]|0)+1|0;f[h>>2]=j;a=a+-1|0}while((a|0)!=0);a=f[e>>2]|0;f[d>>2]=a;f[g>>2]=a;f[c>>2]=a+120;return}function O3(a){a=a|0;var b=0,c=0;if((f[a+24>>2]|0)!=(f[a+20>>2]|0))P3(a)|0;b=f[a+32>>2]|0;if(b|0){c=a+36|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;YDc(b)}b=f[a+8>>2]|0;if(!b)return;c=a+12|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;YDc(b);return}function P3(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;e=a+20|0;g=f[e>>2]|0;h=a+24|0;i=f[h>>2]|0;j=i-g|0;k=i;if(!g){l=0;u=c;return l|0}if(!j)m=Mpc(g)|0;else m=j;if(!((m|0)!=0&(m&3|0)==0)){l=0;u=c;return l|0}i=g+m|0;m=i+-1|0;if((b[m>>0]|0)==61){n=m+-1|0;o=(b[n>>0]|0)==61?n:m}else o=i;a:do if(g>>>0<o>>>0){i=g;while(1){m=b[i>>0]|0;if((m&255)>126){l=0;p=17;break}i=i+1|0;if(!(m<<24>>24==65|(b[231449+(m&255)>>0]|0)!=0)){l=0;p=17;break}if(i>>>0>=o>>>0)break a}if((p|0)==17){u=c;return l|0}}while(0);if((k|0)==(g|0)){l=1;u=c;return l|0}k=f[a+32>>2]|0;p=w3(g,k,0,j)|0;f[h>>2]=f[e>>2];if(!p){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,8)|0;h=e;b[h>>0]=108;b[h+1>>0]=101;b[h+2>>0]=110;b[h+3>>0]=32;h=e+4|0;b[h>>0]=33;b[h+1>>0]=61;b[h+2>>0]=32;b[h+3>>0]=48;C3(-215,d,231840,379)}h=f[a>>2]|0;if((h+p|0)>>>0>=(f[a+4>>2]|0)>>>0){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,23)|0;j=231846;g=e+23|0;do{b[e>>0]=b[j>>0]|0;e=e+1|0;j=j+1|0}while((e|0)<(g|0));C3(-215,d,231840,382)}dJc(h|0,k|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;l=1;u=c;return l|0}function Q3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;if(c>>>0>=d>>>0){u=e;return a|0}h=d;i=a+28|0;j=a+24|0;k=c;while(1){c=h-k|0;l=f[j>>2]|0;m=(f[i>>2]|0)-l|0;n=(m|0)<(c|0)?m:c;dJc(l|0,k|0,n|0)|0;k=k+n|0;l=(f[j>>2]|0)+n|0;f[j>>2]=l;if(l>>>0>=(f[i>>2]|0)>>>0?!(P3(a)|0):0){o=6;break}if(k>>>0>=d>>>0){o=7;break}}if((o|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,7)|0;b[d>>0]=b[231870]|0;b[d+1>>0]=b[231871]|0;b[d+2>>0]=b[231872]|0;b[d+3>>0]=b[231873]|0;b[d+4>>0]=b[231874]|0;b[d+5>>0]=b[231875]|0;b[d+6>>0]=b[231876]|0;C3(-215,g,471667,359)}else if((o|0)==7){u=e;return a|0}return 0}function R3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=VDc(40)|0;S3(g,c);f[a>>2]=g;g=a+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;g=(c|0)!=0;if(g?(f[c>>2]|0)==1280131417:0)if(!(f[c+8>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,38)|0;i=231923;j=h+38|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));C3(-2,e,231910,852)}else{u=d;return}f[e>>2]=0;f[e+4>>2]=0;h=tT(e,31)|0;i=231878;j=h+31|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));C3(g?-5:-27,e,231910,852)}function S3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[a>>2]=c;g=a+4|0;f[g>>2]=0;h=a+8|0;f[h>>2]=0;f[a+12>>2]=0;i=VDc(48)|0;f[h>>2]=i;f[g>>2]=i;f[a+12>>2]=i+48;j=48;k=i;do{b[k>>0]=0;k=(f[h>>2]|0)+1|0;f[h>>2]=k;j=j+-1|0}while((j|0)!=0);j=a+16|0;f[j>>2]=0;k=a+20|0;f[k>>2]=0;f[a+24>>2]=0;h=VDc(65)|0;f[k>>2]=h;f[j>>2]=h;f[a+24>>2]=h+65;j=65;i=h;do{b[i>>0]=0;i=(f[k>>2]|0)+1|0;f[k>>2]=i;j=j+-1|0}while((j|0)!=0);j=f[g>>2]|0;f[a+28>>2]=j;f[a+36>>2]=j+48;f[a+32>>2]=j;j=(c|0)!=0;if(!j){f[e>>2]=0;l=e+4|0;f[l>>2]=0;m=tT(e,31)|0;n=m;o=231878;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=j?-5:-27;C3(q,e,231962,417)}if((f[c>>2]|0)!=1280131417){f[e>>2]=0;l=e+4|0;f[l>>2]=0;m=tT(e,31)|0;n=m;o=231878;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=j?-5:-27;C3(q,e,231962,417)}if(!(f[c+8>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;n=tT(e,38)|0;o=231923;p=n+38|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));C3(-2,e,231962,417)}if((f[c+4>>2]|0)==24){e=c+72|0;o=f[e>>2]|0;f[e>>2]=o+1;b[o>>0]=0;o=c+76|0;D8(c,f[o>>2]|0);f[e>>2]=f[o>>2];o=f[a>>2]|0;XIc(f[o+76>>2]|0,0,f[o+56>>2]|0)|0;D8(c,231983);u=d;return}else{P8(f[a>>2]|0)|0;u=d;return}}function T3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+32|0;g=e;U3(a,d);V3(g,b,c,a+4|0);c=f[a>>2]|0;a=VDc(1024)|0;XIc(a|0,0,1024)|0;b=g+4|0;d=f[b>>2]|0;h=g+8|0;if(d>>>0<(f[h>>2]|0)>>>0){i=g+16|0;j=g+20|0;k=g+12|0;l=c+36|0;m=c+32|0;n=d;while(1){d=f[i>>2]|0;o=(f[j>>2]|0)-d>>3;if(!o)p=n;else{q=0;r=d;d=n;while(1){s=f[r+(q<<3)>>2]|0;Mi[f[r+(q<<3)+4>>2]&1023](d+s|0,a+s|0)|0;s=q+1|0;if((s|0)==(o|0))break;q=s;r=f[i>>2]|0;d=f[b>>2]|0}p=f[b>>2]|0}d=f[k>>2]|0;r=p+d|0;f[b>>2]=r;q=a+d|0;if((d|0)>0){d=q;o=a;do{s=d-o|0;t=f[m>>2]|0;v=(f[l>>2]|0)-t|0;w=(v|0)<(s|0)?v:s;dJc(t|0,o|0,w|0)|0;o=o+w|0;t=(f[m>>2]|0)+w|0;f[m>>2]=t;if(t>>>0>=(f[l>>2]|0)>>>0)W3(c)|0}while(o>>>0<q>>>0);x=f[b>>2]|0}else x=r;if(x>>>0<(f[h>>2]|0)>>>0)n=x;else break}}YDc(a);a=f[g+16>>2]|0;if(!a){u=e;return}x=g+20|0;g=f[x>>2]|0;if((g|0)!=(a|0))f[x>>2]=g+(~((g+-8-a|0)>>>3)<<3);YDc(a);u=e;return}function U3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;if(!c){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,13)|0;h=232095;i=g+13|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));C3(-5,e,232109,877)}j=a+4|0;k=b[j+11>>0]|0;l=k<<24>>24<0;if(l)m=f[a+8>>2]|0;else m=k&255;if(m|0){m=Mpc(c)|0;if((m|0)!=((l?f[a+8>>2]|0:k&255)|0)){f[e>>2]=0;n=e+4|0;f[n>>2]=0;o=tT(e,20)|0;g=o;h=232118;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));C3(-5,e,232109,888)}if(!(EEc(j,0,-1,c,m)|0)){u=d;return}else{f[e>>2]=0;n=e+4|0;f[n>>2]=0;o=tT(e,20)|0;g=o;h=232118;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));C3(-5,e,232109,888)}}nEc(j,c)|0;B3(e,c);c=e+11|0;j=b[c>>0]|0;h=j<<24>>24<0;g=h?f[e>>2]|0:e;i=h?f[e+4>>2]|0:j&255;h=g+i|0;o=f[a>>2]|0;if((i|0)>0){i=h;a=o+36|0;n=o+32|0;m=g;do{g=i-m|0;k=f[n>>2]|0;l=(f[a>>2]|0)-k|0;p=(l|0)<(g|0)?l:g;dJc(k|0,m|0,p|0)|0;m=m+p|0;k=(f[n>>2]|0)+p|0;f[n>>2]=k;if(k>>>0>=(f[a>>2]|0)>>>0)W3(o)|0}while(m>>>0<h>>>0);q=b[c>>0]|0}else q=j;if(q<<24>>24<0)YDc(f[e>>2]|0);u=d;return}function V3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g;f[a>>2]=c;i=a+4|0;f[i>>2]=0;j=a+8|0;f[j>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if(!c){f[h>>2]=0;f[h+4>>2]=0;c=tT(h,3)|0;b[c>>0]=b[231993]|0;b[c+1>>0]=b[231994]|0;b[c+2>>0]=b[231995]|0;C3(-215,h,231997,553)}c=e+11|0;k=b[c>>0]|0;if(!((k<<24>>24<0?f[e+4>>2]|0:k&255)|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,11)|0;l=232022;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));C3(-215,h,231997,554)}if((d|0)>0){X3(a,e);l=f[a>>2]|0;f[j>>2]=l;f[i>>2]=l;l=$8((b[c>>0]|0)<0?f[e>>2]|0:e,0)|0;f[a+12>>2]=l;e=(f[a>>2]|0)+(Y(l,d)|0)|0;f[j>>2]=e;u=g;return}else{f[h>>2]=0;f[h+4>>2]=0;g=tT(h,7)|0;b[g>>0]=b[232034]|0;b[g+1>>0]=b[232035]|0;b[g+2>>0]=b[232036]|0;b[g+3>>0]=b[232037]|0;b[g+4>>0]=b[232038]|0;b[g+5>>0]=b[232039]|0;b[g+6>>0]=b[232040]|0;C3(-215,h,231997,555)}}function W3(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+80|0;d=c;e=a+28|0;g=f[e>>2]|0;h=a+16|0;i=a+32|0;if(!(v3(g,f[h>>2]|0,0,(f[i>>2]|0)-g|0)|0)){j=0;u=c;return j|0}f[i>>2]=f[e>>2];e=f[a>>2]|0;if((f[e+4>>2]|0)==24){D8(e,f[h>>2]|0);j=1;u=c;return j|0}else{i=f[e+40>>2]|0;XIc(d|0,32,i|0)|0;b[d+i>>0]=0;D8(e,d);D8(f[a>>2]|0,f[h>>2]|0);D8(f[a>>2]|0,502002);P8(f[a>>2]|0)|0;j=1;u=c;return j|0}return 0}function X3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+176|0;e=d+156|0;g=d+160|0;h=d+16|0;i=d;j=d+8|0;f[e>>2]=0;b[g>>0]=0;k=h+60|0;l=h+8|0;f[h>>2]=7732;f[k>>2]=7752;f[h+4>>2]=0;auc(h+60|0,l);f[h+132>>2]=0;f[h+136>>2]=-1;f[h>>2]=46136;f[k>>2]=46156;fuc(l);f[l>>2]=45740;k=h+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[h+56>>2]=8;G1(l,c);c=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;a:do if(!(c&2)){l=i+4|0;k=a+20|0;m=a+24|0;n=a+16|0;o=0;b:while(1){p=muc(h,e)|0;if(!(f[p+(f[(f[p>>2]|0)+-12>>2]|0)+16>>2]&5)){if(!(f[e>>2]|0)){q=7;break}}else{$tc(h+(f[(f[h>>2]|0)+-12>>2]|0)|0,0);f[e>>2]=1}p=Y3(h,g)|0;if(f[p+(f[(f[p>>2]|0)+-12>>2]|0)+16>>2]&5|0){q=9;break}p=f[e>>2]|0;r=p+-1|0;f[e>>2]=r;c:do if(!p)s=o;else{t=o;v=r;while(1){switch(b[g>>0]|0){case 99:case 117:{w=1;x=522;break}case 115:case 119:{w=2;x=523;break}case 105:{w=4;x=524;break}case 102:{w=4;x=525;break}case 100:{w=8;x=526;break}default:{q=16;break b}}f[l>>2]=x;y=t+-1+w&0-w;f[i>>2]=y;z=f[k>>2]|0;if((z|0)==(f[m>>2]|0)){c4(n,i);A=f[e>>2]|0}else{B=i;C=f[B+4>>2]|0;D=z;f[D>>2]=f[B>>2];f[D+4>>2]=C;f[k>>2]=(f[k>>2]|0)+8;A=v}C=y+w|0;v=A+-1|0;f[e>>2]=v;if(!A){s=C;break c}else t=C}}while(0);r=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;if(!(r&2))o=s;else{E=r;break a}}if((q|0)==7){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,8)|0;k=o;b[k>>0]=99;b[k+1>>0]=110;b[k+2>>0]=116;b[k+3>>0]=32;k=o+4|0;b[k>>0]=62;b[k+1>>0]=32;b[k+2>>0]=48;b[k+3>>0]=85;C3(-215,i,232042,607)}else if((q|0)==9){E=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;break}else if((q|0)==16){f[j>>2]=0;f[j+4>>2]=0;F=tT(j,21)|0;G=232063;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));C3(-2,j,232042,642)}}else E=c;while(0);if(!(E&2)){f[i>>2]=0;f[i+4>>2]=0;F=tT(i,9)|0;G=232085;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));C3(-215,i,232042,653)}else{J3(h);u=d;return}}function Y3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;huc(e,a,0);if(!(b[e>>0]|0)){u=d;return a|0}e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;g=e+12|0;i=f[g>>2]|0;if((i|0)==(f[e+16>>2]|0)){j=_i[f[(f[e>>2]|0)+40>>2]&1023](e)|0;if((j|0)==-1){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(e,f[e+16>>2]|6);u=d;return a|0}else k=j}else{f[g>>2]=i+1;k=h[i>>0]|0}b[c>>0]=k;u=d;return a|0}function Z3(a,c){a=a|0;c=c|0;var d=0,e=0;d=a;a=f[d>>2]|0;e=f[d+4>>2]|0;b[c>>0]=a;d=aJc(a|0,e|0,8)|0;b[c+1>>0]=d;d=aJc(a|0,e|0,16)|0;b[c+2>>0]=d;d=aJc(a|0,e|0,24)|0;b[c+3>>0]=d;b[c+4>>0]=e;d=aJc(a|0,e|0,40)|0;b[c+5>>0]=d;d=aJc(a|0,e|0,48)|0;b[c+6>>0]=d;d=aJc(a|0,e|0,56)|0;b[c+7>>0]=d;return 8}function _3(a,c){a=a|0;c=c|0;var d=0;d=f[a>>2]|0;b[c>>0]=d;b[c+1>>0]=d>>>8;b[c+2>>0]=d>>>16;b[c+3>>0]=d>>>24;return 4}function $3(a,c){a=a|0;c=c|0;var d=0;d=f[a>>2]|0;b[c>>0]=d;b[c+1>>0]=d>>>8;b[c+2>>0]=d>>>16;b[c+3>>0]=d>>>24;return 4}function a4(a,c){a=a|0;c=c|0;var e=0;e=d[a>>1]|0;b[c>>0]=e;b[c+1>>0]=(e&65535)>>>8;return 2}function b4(a,c){a=a|0;c=c|0;b[c>>0]=b[a>>0]|0;return 1}function c4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function d4(a){a=a|0;var c=0;c=f[a>>2]|0;if(c|0){e4(c);YDc(c)}c=a+4|0;if((b[c+11>>0]|0)>=0)return;YDc(f[c>>2]|0);return}function e4(a){a=a|0;var b=0,c=0;if((f[a+32>>2]|0)!=(f[a+28>>2]|0))W3(a)|0;b=f[a>>2]|0;if((f[b+4>>2]|0)==24){D8(b,501908);b=f[a>>2]|0;f[b+72>>2]=f[b+76>>2];P8(b)|0;b=f[a>>2]|0;XIc(f[b+76>>2]|0,0,f[b+56>>2]|0)|0;b=f[a>>2]|0;f[b+72>>2]=f[b+76>>2]}b=f[a+16>>2]|0;if(b|0){c=a+20|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;YDc(b)}b=f[a+4>>2]|0;if(!b)return;c=a+8|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;YDc(b);return}function f4(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;i=u;u=u+64|0;k=i+16|0;l=i;m=i+24|0;f[l+4>>2]=0;g4(m,a,c,e);e=m+8|0;c=m+28|0;a=m+20|0;o=m+16|0;q=m+12|0;r=l+8|0;s=l+8|0;while(1){t=f[m>>2]|0;if(t>>>0>=(f[e>>2]|0)>>>0)break;v=k;f[v>>2]=0;f[v+4>>2]=0;v=f[c>>2]|0;Mi[f[v+8>>2]&1023](t+(f[v+4>>2]|0)|0,k)|0;v=f[c>>2]|0;t=f[v>>2]|0;switch(t|0){case 0:{f[r>>2]=h[k>>0];w=11;break}case 1:{f[r>>2]=b[k>>0];w=11;break}case 2:{f[r>>2]=j[k>>1];w=11;break}case 3:{f[r>>2]=d[k>>1];w=11;break}case 4:{f[r>>2]=f[k>>2];w=11;break}case 5:{p[s>>3]=+n[k>>2];w=11;break}case 6:{p[s>>3]=+p[k>>3];w=11;break}default:x=t}if((w|0)==11){w=0;x=f[v>>2]|0}switch(x|0){case 4:case 3:case 2:case 1:case 0:{y=1;w=14;break}case 6:case 5:{y=2;w=14;break}default:{}}if((w|0)==14){w=0;f[l>>2]=y}t=v+12|0;f[c>>2]=t;if((t|0)==(f[a>>2]|0)){f[c>>2]=f[o>>2];f[m>>2]=(f[m>>2]|0)+(f[q>>2]|0)}A7(g,l)|0}l=f[o>>2]|0;if(!l){u=i;return}o=f[a>>2]|0;if((o|0)!=(l|0))f[a>>2]=o+(~(((o+-12-l|0)>>>0)/12|0)*12|0);YDc(l);u=i;return}function g4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;f[a>>2]=c;i=a+4|0;f[i>>2]=c;j=a+8|0;f[j>>2]=c;k=a+16|0;f[k>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if(!c){f[h>>2]=0;f[h+4>>2]=0;c=tT(h,3)|0;b[c>>0]=b[231993]|0;b[c+1>>0]=b[231994]|0;b[c+2>>0]=b[231995]|0;C3(-215,h,232139,673)}if(!e){f[h>>2]=0;f[h+4>>2]=0;c=tT(h,2)|0;b[c>>0]=100;b[c+1>>0]=116;C3(-215,h,232139,674)}if((d|0)>-1){h4(a,e);f[a+28>>2]=f[k>>2];k=$8(e,0)|0;f[a+12>>2]=k;a=(f[i>>2]|0)+(Y(k,d)|0)|0;f[j>>2]=a;u=g;return}else{f[h>>2]=0;f[h+4>>2]=0;g=tT(h,8)|0;a=g;b[a>>0]=108;b[a+1>>0]=101;b[a+2>>0]=110;b[a+3>>0]=32;a=g+4|0;b[a>>0]=62;b[a+1>>0]=61;b[a+2>>0]=32;b[a+3>>0]=48;C3(-215,h,232139,675)}}function h4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+176|0;e=d+160|0;g=d+164|0;h=d+20|0;i=d+8|0;j=d;f[e>>2]=0;b[g>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=Mpc(c)|0;if(k>>>0>4294967279)dEc(i);if(k>>>0<11){b[i+11>>0]=k;if(!k)l=i;else{m=i;n=6}}else{o=k+16&-16;p=VDc(o)|0;f[i>>2]=p;f[i+8>>2]=o|-2147483648;f[i+4>>2]=k;m=p;n=6}if((n|0)==6){dJc(m|0,c|0,k|0)|0;l=m}b[l+k>>0]=0;k=h+60|0;l=h+8|0;f[h>>2]=7732;f[k>>2]=7752;f[h+4>>2]=0;auc(h+60|0,l);f[h+132>>2]=0;f[h+136>>2]=-1;f[h>>2]=46136;f[k>>2]=46156;fuc(l);f[l>>2]=45740;k=h+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[h+56>>2]=8;G1(l,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);l=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;a:do if(!(l&2)){k=i+8|0;m=i+4|0;c=a+20|0;p=a+24|0;o=a+16|0;q=0;b:while(1){r=muc(h,e)|0;if(!(f[r+(f[(f[r>>2]|0)+-12>>2]|0)+16>>2]&5)){if(!(f[e>>2]|0)){n=15;break}}else{$tc(h+(f[(f[h>>2]|0)+-12>>2]|0)|0,0);f[e>>2]=1}r=Y3(h,g)|0;if(f[r+(f[(f[r>>2]|0)+-12>>2]|0)+16>>2]&5|0){n=17;break}r=f[e>>2]|0;s=r+-1|0;f[e>>2]=s;c:do if(!r)t=q;else{v=q;w=s;while(1){x=b[g>>0]|0;switch(x|0){case 99:case 117:{y=1;z=530;n=25;break}case 115:case 119:{y=2;z=531;n=25;break}case 105:{f[k>>2]=527;A=v+3&-4;f[m>>2]=A;B=A+4|0;n=29;break}case 102:{f[k>>2]=528;A=v+3&-4;f[m>>2]=A;C=A+4|0;n=30;break}case 100:{f[k>>2]=529;A=v+7&-8;f[m>>2]=A;D=A+8|0;n=31;break}default:{n=24;break b}}d:do if((n|0)==25){n=0;f[k>>2]=z;A=v+-1+y&0-y;f[m>>2]=A;E=A+y|0;switch(x|0){case 99:{F=1;G=E;break d;break}case 105:{B=E;n=29;break d;break}case 102:{C=E;n=30;break d;break}case 100:{D=E;n=31;break d;break}case 117:{F=0;G=E;break d;break}case 119:{F=2;G=E;break d;break}case 115:{F=3;G=E;break d;break}default:{n=32;break b}}}while(0);if((n|0)==29){n=0;F=4;G=B}else if((n|0)==30){n=0;F=5;G=C}else if((n|0)==31){n=0;F=6;G=D}f[i>>2]=F;x=f[c>>2]|0;if((x|0)==(f[p>>2]|0)){n4(o,i);H=f[e>>2]|0}else{f[x>>2]=f[i>>2];f[x+4>>2]=f[i+4>>2];f[x+8>>2]=f[i+8>>2];f[c>>2]=(f[c>>2]|0)+12;H=w}w=H+-1|0;f[e>>2]=w;if(!H){t=G;break c}else v=G}}while(0);s=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;if(!(s&2))q=t;else{I=s;break a}}if((n|0)==15){f[i>>2]=0;f[i+4>>2]=0;q=tT(i,8)|0;c=q;b[c>>0]=99;b[c+1>>0]=110;b[c+2>>0]=116;b[c+3>>0]=32;c=q+4|0;b[c>>0]=62;b[c+1>>0]=32;b[c+2>>0]=48;b[c+3>>0]=85;C3(-215,i,232162,766)}else if((n|0)==17){I=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;break}else if((n|0)==24){f[j>>2]=0;f[j+4>>2]=0;J=tT(j,21)|0;K=232063;L=J+21|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));C3(-2,j,232162,802)}else if((n|0)==32){f[j>>2]=0;f[j+4>>2]=0;J=tT(j,21)|0;K=232063;L=J+21|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));C3(-2,j,232162,821)}}else I=l;while(0);if(!(I&2)){f[i>>2]=0;f[i+4>>2]=0;J=tT(i,9)|0;K=232085;L=J+9|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));C3(-215,i,232162,828)}if((f[a+20>>2]|0)==(f[a+16>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;J=tT(i,22)|0;K=232173;L=J+22|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));C3(-215,i,232162,829)}else{J3(h);u=d;return}}function i4(a,b){a=a|0;b=b|0;var c=0,d=0;f[b>>2]=0;c=h[a>>0]|0;f[b>>2]=c;d=(h[a+1>>0]|0)<<8|c;f[b>>2]=d;c=(h[a+2>>0]|0)<<16|d;f[b>>2]=c;f[b>>2]=(h[a+3>>0]|0)<<24|c;return 4}function j4(a,b){a=a|0;b=b|0;f[b>>2]=(h[a+1>>0]|0)<<8|(h[a>>0]|0)|(h[a+2>>0]|0)<<16|(h[a+3>>0]|0)<<24;return 4}function k4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0;c=h[a>>0]|0;d=jJc(h[a+1>>0]|0|0,0,8)|0;e=J;g=jJc(h[a+2>>0]|0|0,0,16)|0;i=e|J;e=jJc(h[a+3>>0]|0|0,0,24)|0;j=i|J|(h[a+4>>0]|0);i=jJc(h[a+5>>0]|0|0,0,40)|0;k=j|J;j=jJc(h[a+6>>0]|0|0,0,48)|0;l=k|J;k=jJc(h[a+7>>0]|0|0,0,56)|0;a=b;f[a>>2]=d|c|g|e|i|j|k;f[a+4>>2]=l|J;return 8}function l4(a,c){a=a|0;c=c|0;var e=0;d[c>>1]=0;e=b[a>>0]|0;d[c>>1]=e&255;d[c>>1]=(h[a+1>>0]|0)<<8|e&255;return 2}function m4(a,c){a=a|0;c=c|0;b[c>>0]=0;b[c>>0]=b[a>>0]|0;return 1}function n4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)mCc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;YDc(d);return}function o4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;if(!a){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,2)|0;b[i>>0]=102;b[i+1>>0]=115;C3(-215,h,232196,911)}if((f[a>>2]|0)!=1280131417){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,31)|0;k=231878;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));C3(-5,h,232196,912)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,38)|0;k=231923;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));C3(-2,h,232196,912)}V8(a,1);switch(f[a+280>>2]|0){case 0:{U8(a,2);m=a+272|0;n=f[m>>2]|0;T3(n,c,d,e);u=g;return}case 2:{m=a+272|0;n=f[m>>2]|0;T3(n,c,d,e);u=g;return}default:{f[h>>2]=0;f[h+4>>2]=0;j=tT(h,37)|0;k=232217;l=j+37|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));C3(-2,h,232196,922)}}}function p4(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;e=d;g=f[e>>2]|0;h=f[e+4>>2]|0;if(!(b[1149316]|0)){f[132556]=1991057938;f[132557]=0;n[132684]=1.7290404663583558e-09;n[132811]=1.6030947680434338e-09;n[132812]=1.0;n[132939]=2.6696291752159595e-03;e=126;i=3.442619855899;while(1){j=i;i=+M(+(+W(+(.00991256303526217/i+ +V(+(i*(i*-.5)))))*-2.0));f[530224+(e+1<<2)>>2]=~~(i/j*2147483648.0)>>>0;j=+V(+(i*(i*-.5)));n[531248+(e<<2)>>2]=j;n[530736+(e<<2)>>2]=i*4.656612873077393e-10;if((e|0)<=1)break;else e=e+-1|0}b[1149316]=1}if((c|0)>0){k=0;l=g;m=h}else{o=g;p=h;q=d;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}while(1){h=l;g=m;while(1){e=mJc(h|0,0,-130063606,0)|0;u=UIc(e|0,J|0,g|0,0)|0;e=J;v=h&127;i=+n[530736+(v<<2)>>2]*+(h|0);if(((h|0)>-1?h:0-h|0)>>>0<(f[530224+(v<<2)>>2]|0)>>>0){w=i;x=u;y=e;break}if(!v){z=u;A=e;B=9;break}C=mJc(u|0,0,-130063606,0)|0;D=UIc(C|0,J|0,e|0,0)|0;e=J;j=+n[531248+(v<<2)>>2];E=i;if(!(j+ +(u>>>0)*2.3283064365386963e-10*(+n[531248+(v+-1<<2)>>2]-j)<+V(+(E*(E*-.5))))){h=D;g=e}else{w=i;x=D;y=e;break}}if((B|0)==9){while(1){B=0;g=mJc(z|0,0,-130063606,0)|0;e=UIc(g|0,J|0,A|0,0)|0;g=J;D=mJc(e|0,0,-130063606,0)|0;v=z;z=UIc(D|0,J|0,g|0,0)|0;A=J;F=-+W(+(+(v>>>0)*2.3283064365386963e-10+1.1754943508222875e-38))*.2904764;i=+W(+(+(e>>>0)*2.3283064365386963e-10+1.1754943508222875e-38));if(!(-i-i<F*F))break;else B=9}w=(h|0)>0?F+3.442620038986206:-3.442620038986206-F;x=z;y=A}n[a+(k<<2)>>2]=w;k=k+1|0;if((k|0)==(c|0)){o=x;p=y;break}else{l=x;m=y}}q=d;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}function q4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;i=u;u=u+2496|0;j=i+2440|0;k=i+2384|0;l=i+2328|0;m=i+1096|0;o=i+2264|0;q=i+2320|0;r=i+2232|0;t=i+2256|0;v=i+2248|0;w=i+2224|0;x=i+2192|0;y=i;if(r$(c)|0){f[j>>2]=0;f[j+4>>2]=0;z=tT(j,13)|0;A=232255;B=z+13|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,j,389409,232269,514)}do if((d$(c)|0)==65536){C=f[c+4>>2]|0;f[j>>2]=f[C>>2];D=j+4|0;E=C+4|0;f[D>>2]=f[E>>2];F=j+8|0;f[F>>2]=f[C+8>>2];f[j+12>>2]=f[C+12>>2];f[j+16>>2]=f[C+16>>2];f[j+20>>2]=f[C+20>>2];f[j+24>>2]=f[C+24>>2];f[j+28>>2]=f[C+28>>2];f[j+32>>2]=f[C+32>>2];G=f[C+36>>2]|0;f[j+36>>2]=G;f[j+40>>2]=F;F=j+48|0;H=j+44|0;f[H>>2]=F;f[F>>2]=0;f[j+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;F=f[H>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[D>>2]=0;ZS(j,C);break}}else a$(j,c,-1);while(0);do if((d$(e)|0)==65536){c=f[e+4>>2]|0;f[k>>2]=f[c>>2];C=k+4|0;D=c+4|0;f[C>>2]=f[D>>2];E=k+8|0;f[E>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];F=f[c+36>>2]|0;f[k+36>>2]=F;f[k+40>>2]=E;E=k+48|0;H=k+44|0;f[H>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[c+44>>2]|0;E=f[H>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];break}else{f[C>>2]=0;ZS(k,c);break}}else a$(k,e,-1);while(0);do if((d$(g)|0)==65536){e=f[g+4>>2]|0;f[l>>2]=f[e>>2];c=l+4|0;C=e+4|0;f[c>>2]=f[C>>2];D=l+8|0;f[D>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];f[l+16>>2]=f[e+16>>2];f[l+20>>2]=f[e+20>>2];f[l+24>>2]=f[e+24>>2];f[l+28>>2]=f[e+28>>2];f[l+32>>2]=f[e+32>>2];E=f[e+36>>2]|0;f[l+36>>2]=E;f[l+40>>2]=D;D=l+48|0;H=l+44|0;f[H>>2]=D;f[D>>2]=0;f[l+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[e+44>>2]|0;D=f[H>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[c>>2]=0;ZS(l,e);break}}else a$(l,g,-1);while(0);g=f[j>>2]|0;e=g&7;c=g>>>3&511;C=c+1|0;D=m+8|0;f[m>>2]=D;H=m+4|0;f[H>>2]=136;E=f[k>>2]|0;if(E&4088|0){f[o>>2]=0;I=o+4|0;f[I>>2]=0;K=tT(o,223)|0;dJc(K|0,232332,223)|0;z5(-215,o,389409,232269,527)}F=f[k+8>>2]|0;G=f[k+12>>2]|0;if(!((F|0)==1|(G|0)==1)){f[o>>2]=0;I=o+4|0;f[I>>2]=0;K=tT(o,223)|0;dJc(K|0,232332,223)|0;z5(-215,o,389409,232269,527)}L=F+-1+G|0;if(!((L|0)==(C|0)|(L|0)==1)?(L=f[k+40>>2]|0,C>>>0>4|(E&4095|0)!=6|((f[L>>2]|0)!=4?1:(f[L+4>>2]|0)!=1)):0){f[o>>2]=0;I=o+4|0;f[I>>2]=0;K=tT(o,223)|0;dJc(K|0,232332,223)|0;z5(-215,o,389409,232269,527)}K=f[l>>2]|0;if(K&4088|0){f[o>>2]=0;M=o+4|0;f[M>>2]=0;N=tT(o,295)|0;dJc(N|0,232556,295)|0;z5(-215,o,389409,232269,532)}I=l+8|0;L=f[I>>2]|0;O=f[l+12>>2]|0;if((L|0)!=1)if((O|0)==1){P=1;Q=32}else{R=O;Q=35}else{P=O;Q=32}if((Q|0)==32){O=L+-1+P|0;if(!((O|0)==(C|0)|(O|0)==1)){O=f[k+40>>2]|0;if(((f[O>>2]|0)==4?(f[O+4>>2]|0)==1:0)?C>>>0<5&(E&4095|0)==6:0)S=P;else{R=P;Q=35}}else S=P}if((Q|0)==35){if((L|0)!=(C|0)){f[o>>2]=0;M=o+4|0;f[M>>2]=0;N=tT(o,295)|0;dJc(N|0,232556,295)|0;z5(-215,o,389409,232269,532)}if((d|0)==1&(R|0)==(C|0))S=C;else{f[o>>2]=0;M=o+4|0;f[M>>2]=0;N=tT(o,295)|0;dJc(N|0,232556,295)|0;z5(-215,o,389409,232269,532)}}N=k+4|0;M=f[N>>2]|0;if((M|0)<3)T=Y(G,F)|0;else{F=f[k+40>>2]|0;G=0;R=1;while(1){P=Y(f[F+(G<<2)>>2]|0,R)|0;G=G+1|0;if((G|0)==(M|0)){T=P;break}else R=P}}R=l+4|0;M=f[R>>2]|0;if((M|0)<3)U=Y(S,L)|0;else{L=f[l+40>>2]|0;S=0;G=1;while(1){F=Y(f[L+(S<<2)>>2]|0,G)|0;S=S+1|0;if((S|0)==(M|0)){U=F;break}else G=F}}G=(d|0)==0;do if(G){M=T+(C<<3)+U|0;f[H>>2]=M;if(M>>>0>136){S=XDc(M>>>0>536870911?-1:M<<3)|0;f[m>>2]=S;V=S}else V=D;S=f[l+16>>2]|0;if((E&16384|0)!=0?(T|0)==(C|0)&(E&4095|0)==6:0){W=f[k+16>>2]|0;X=K}else{M=f[k+40>>2]|0;L=f[M>>2]|0;f[q>>2]=f[M+4>>2];f[q+4>>2]=L;CY(o,q,6,V,0);L=r+8|0;f[L>>2]=0;f[L+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=o;LZ(k,r,6,1.0,0.0);if((T|0)<=(c|0)){L=T;while(1){p[V+(L<<3)>>3]=+p[V+(L-T<<3)>>3];if((L|0)<(c|0))L=L+1|0;else break}}L=o+36|0;M=f[L>>2]|0;if(M|0?(F=M+12|0,M=f[F>>2]|0,f[F>>2]=M+-1,(M|0)==1):0)_S(o);f[L>>2]=0;L=o+16|0;M=o+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){L=f[o+40>>2]|0;F=0;do{f[L+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[M>>2]|0))}M=f[o+44>>2]|0;if((M|0)!=(o+48|0))g0(M);W=V;X=f[l>>2]|0}if((X&16384|0)!=0?(U|0)==(C|0)&(X&4095|0)==6:0)Z=S;else{M=f[l+40>>2]|0;F=f[M>>2]|0;f[t>>2]=f[M+4>>2];f[t+4>>2]=F;F=V+(C<<3)|0;CY(o,t,6,F,0);M=r+8|0;f[M>>2]=0;f[M+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=o;LZ(l,r,6,1.0,0.0);if((U|0)<=(c|0)){M=U;while(1){p[F+(M<<3)>>3]=+p[F+(M-U<<3)>>3];if((M|0)<(c|0))M=M+1|0;else break}}M=o+36|0;S=f[M>>2]|0;do if(S|0){L=S+12|0;P=f[L>>2]|0;f[L>>2]=P+-1;if((P|0)!=1)break;_S(o)}while(0);f[M>>2]=0;S=o+16|0;P=o+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[P>>2]|0)>0){S=f[o+40>>2]|0;L=0;do{f[S+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[P>>2]|0))}P=f[o+44>>2]|0;if((P|0)!=(o+48|0))g0(P);Z=F}do if(e>>>0>=5){_=(e|0)==6?5.421010862427522e-20:2.3283064365386963e-10;$=h?3402823466385288598117041.0e14:1797693134862315708145274.0e284;P=V+(C<<1<<3)|0;if((e|0)==5){L=0;do{aa=+p[Z+(L<<3)>>3];ba=+p[W+(L<<3)>>3];ca=aa-ba;S=P+(L<<3)|0;n[S>>2]=_*(ca<$?ca:$);n[S+4>>2]=(aa+ba)*.5;L=L+1|0}while((L|0)!=(C|0));da=0;ea=0;fa=0;ga=P;ha=0;ia=1;ja=0;break}else{L=0;do{S=Z+(L<<3)|0;M=W+(L<<3)|0;$=+p[S>>3]-+p[M>>3];p[P+(L<<4)>>3]=_*($<1797693134862315708145274.0e284?$:1797693134862315708145274.0e284);p[P+(L<<4)+8>>3]=(+p[S>>3]+ +p[M>>3])*.5;L=L+1|0}while((L|0)!=(C|0));da=0;ea=0;fa=P;ga=0;ha=0;ia=1;ja=0}}else{P=V+(C<<1<<3)|0;L=(e|2|0)==2;M=g&255;S=(e|0)==3;_=S?32768.0:2147483647.0;if(h){O=L|(e|0)!=1;$=L?0.0:S?-32768.0:-2147483648.0;S=1;L=1;ka=0;while(1){ba=+p[Z+(ka<<3)>>3];aa=+p[W+(ka<<3)>>3];ca=ba<aa?ba:aa;la=aa<ba?ba:aa;a:do if(O){aa=ca<$?$:ca;switch(M&7){case 0:{ma=aa;na=256.0;break a;break}case 1:{oa=aa;Q=81;break a;break}case 2:{ma=aa;na=65536.0;break a;break}default:{ma=aa;na=_;break a}}}else{oa=ca<-128.0?-128.0:ca;Q=81}while(0);if((Q|0)==81){Q=0;ma=oa;na=128.0}ca=na<la?na:la;pa=~~ma;qa=(+(pa|0)<ma&1)+pa|0;pa=P+(ka<<3)|0;ra=pa+4|0;f[ra>>2]=qa;sa=~~ca;ta=sa-(+(sa|0)>ca&1)-qa|0;qa=(ta|0)<1?0:ta+-1|0;f[pa>>2]=qa;aa=ca-ma;ta=(qa+1&qa|0)==0;do if(S<<24>>24!=0&aa<=4294967296.0){sa=ta&1;if(!ta){ua=sa;Q=86;break}va=(L&1)!=0&(qa|0)<256&1;wa=sa}else{ua=0;Q=86}while(0);do if((Q|0)==86){Q=0;if(aa>2147483647.0)f[pa>>2]=2147483647;if(!(ma<-1073741824.0)){va=L;wa=ua;break}f[ra>>2]=-1073741824;va=L;wa=ua}while(0);ka=ka+1|0;if((ka|0)==(C|0)){xa=wa;ya=va;break}else{S=wa;L=va}}}else{L=1;S=1;ka=0;while(1){_=+p[Z+(ka<<3)>>3];$=+p[W+(ka<<3)>>3];aa=_<$?_:$;la=$<_?_:$;M=~~aa;O=(+(M|0)<aa&1)+M|0;M=P+(ka<<3)|0;ra=M+4|0;f[ra>>2]=O;pa=~~la;qa=pa-(+(pa|0)>la&1)-O|0;O=(qa|0)<1?0:qa+-1|0;f[M>>2]=O;$=la-aa;qa=(O+1&O|0)==0;do if(L<<24>>24!=0&$<=4294967296.0){pa=qa&1;if(!qa){za=pa;Q=95;break}Aa=(S&1)!=0&(O|0)<256&1;Ba=pa}else{za=0;Q=95}while(0);do if((Q|0)==95){Q=0;if($>2147483647.0)f[M>>2]=2147483647;if(!(aa<-1073741824.0)){Aa=S;Ba=za;break}f[ra>>2]=-1073741824;Aa=S;Ba=za}while(0);ka=ka+1|0;if((ka|0)==(C|0)){xa=Ba;ya=Aa;break}else{L=Ba;S=Aa}}}if(!(xa<<24>>24)){S=P+(C<<3)|0;L=0;do{ka=P+(L<<3)|0;f[S+(L*20|0)+16>>2]=f[ka+4>>2];ra=(f[ka>>2]|0)+1|0;f[S+(L*20|0)>>2]=ra;ka=0;while(1){Ca=jJc(1,0,ka|0)|0;Da=J;if(Da>>>0<0|(Da|0)==0&Ca>>>0<ra>>>0)ka=ka+1|0;else break}M=TIc(Ca|0,Da|0,ra|0,0)|0;O=cJc(0,M|0,ra|0,0)|0;f[S+(L*20|0)+4>>2]=O+1;f[S+(L*20|0)+8>>2]=(ka|0)<1?ka:1;O=ka+-1|0;f[S+(L*20|0)+12>>2]=(O|0)>0?O:0;L=L+1|0}while((L|0)!=(C|0));Ea=S}else Ea=0;da=P;ea=xa;fa=0;ga=0;ha=Ea;ia=ya;ja=xa&255}while(0);F=f[46180+(ja<<5)+(e<<2)>>2]|0;if(!F){f[o>>2]=0;f[o+4>>2]=0;z=tT(o,9)|0;A=251213;B=z+9|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,o,389409,232269,656)}else{Fa=0;Ga=0;Ha=F;Ia=da;Ja=0;Ka=0;La=(ea&1)!=0;Ma=fa;Na=ga;Oa=ha;Pa=(ia&1)!=0;break}}else{if((d|0)!=1){f[o>>2]=0;f[o+4>>2]=0;z=tT(o,25)|0;A=232867;B=z+25|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-5,o,389409,232269,697)}F=(T|0)<=(c|0);S=F?C:T;L=(U|0)<=(c|0);O=(L?C:U)+S|0;f[H>>2]=O;if(O>>>0>136){M=XDc(O>>>0>536870911?-1:O<<3)|0;f[m>>2]=M;Qa=M}else Qa=D;M=(e|0)==6?6:5;O=47696>>>(M<<1)&3;if((E&16384|0)!=0?!(F|(E&4095|0)!=(M|0)):0)Ra=f[k+16>>2]|0;else{qa=f[k+40>>2]|0;pa=f[qa>>2]|0;f[v>>2]=f[qa+4>>2];f[v+4>>2]=pa;CY(o,v,M,Qa,0);pa=r+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=o;LZ(k,r,M,1.0,0.0);pa=o+36|0;qa=f[pa>>2]|0;if(qa|0?(ta=qa+12|0,qa=f[ta>>2]|0,f[ta>>2]=qa+-1,(qa|0)==1):0)_S(o);f[pa>>2]=0;pa=o+16|0;qa=o+4|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[qa>>2]|0)>0){pa=f[o+40>>2]|0;ta=0;do{f[pa+(ta<<2)>>2]=0;ta=ta+1|0}while((ta|0)<(f[qa>>2]|0))}qa=f[o+44>>2]|0;if((qa|0)!=(o+48|0))g0(qa);Ra=Qa}if(F?(qa=T<<O,ta=C<<O,(qa|0)<(ta|0)):0){pa=qa;do{b[Ra+pa>>0]=b[Ra+(pa-qa)>>0]|0;pa=pa+1|0}while((pa|0)!=(ta|0))}ta=f[l>>2]|0;if((ta&16384|0)!=0?!(L|(ta&4095|0)!=(M|0)):0)Sa=f[l+16>>2]|0;else{ta=f[l+40>>2]|0;pa=f[ta>>2]|0;f[w>>2]=f[ta+4>>2];f[w+4>>2]=pa;pa=Qa+(S<<3)|0;CY(o,w,M,pa,0);ta=r+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=o;LZ(l,r,M,1.0,0.0);ta=o+36|0;qa=f[ta>>2]|0;do if(qa|0){F=qa+12|0;sa=f[F>>2]|0;f[F>>2]=sa+-1;if((sa|0)!=1)break;_S(o)}while(0);f[ta>>2]=0;qa=o+16|0;M=o+4|0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[M>>2]|0)>0){qa=f[o+40>>2]|0;S=0;do{f[qa+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[M>>2]|0))}M=f[o+44>>2]|0;if((M|0)!=(o+48|0))g0(M);Sa=pa}do if(L){M=U<<O;S=C<<O;if((M|0)<(S|0))Ta=M;else break;do{b[Sa+Ta>>0]=b[Sa+(Ta-M)>>0]|0;Ta=Ta+1|0}while((Ta|0)!=(S|0))}while(0);if((e|0)==7){f[o>>2]=0;f[o+4>>2]=0;z=tT(o,14)|0;A=232852;B=z+14|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,o,389409,232269,694)}else{Fa=f[46244+(e<<2)>>2]|0;Ga=(f[I>>2]|0)==(C|0)?(f[l+12>>2]|0)==(C|0):0;Ha=0;Ia=0;Ja=Sa;Ka=Ra;La=0;Ma=0;Na=0;Oa=0;Pa=1;break}}while(0);f[o>>2]=j;f[o+4>>2]=0;z2(x,o,r,1);o=f[x+20>>2]|0;Ra=((c|1024)>>>0)/(C>>>0)|0;c=(o|0)<(Ra|0)?o:Ra;Ra=j+4|0;Sa=f[Ra>>2]|0;if((Sa|0)>0)Ua=f[(f[j+44>>2]|0)+(Sa+-1<<2)>>2]|0;else Ua=0;Sa=y+8|0;f[y>>2]=Sa;I=y+4|0;f[I>>2]=136;A=Y(c,C)|0;do if(G){z=A<<2;f[I>>2]=z;if(z>>>0>136){B=XDc(z>>>0>536870911?-1:z<<3)|0;f[y>>2]=B;Va=B}else Va=Sa;if(e>>>0<5)if(La){if((A|0)>0)Wa=0;else{Xa=0;Ya=Va;break}do{B=0;do{z=Ia+(B<<3)|0;Ta=Va+(B+Wa<<3)|0;f[s>>2]=f[z>>2];f[s+4>>2]=f[z+4>>2];p[s>>3]=+p[s>>3];f[Ta>>2]=f[s>>2];f[Ta+4>>2]=f[s+4>>2];B=B+1|0}while((B|0)!=(C|0));Wa=Wa+C|0}while((Wa|0)<(A|0));Xa=0;Ya=Va}else{if((A|0)>0)Za=0;else{Xa=0;Ya=Va;break}do{B=0;do{Ta=Oa+(B*20|0)|0;z=Va+((B+Za|0)*20|0)|0;f[z>>2]=f[Ta>>2];f[z+4>>2]=f[Ta+4>>2];f[z+8>>2]=f[Ta+8>>2];f[z+12>>2]=f[Ta+12>>2];f[z+16>>2]=f[Ta+16>>2];B=B+1|0}while((B|0)!=(C|0));Za=Za+C|0}while((Za|0)<(A|0));Xa=0;Ya=Va}else if((e|0)==5){if((A|0)>0)_a=0;else{Xa=0;Ya=Va;break}do{B=0;do{Ta=Na+(B<<3)|0;z=Va+(B+_a<<3)|0;f[s>>2]=f[Ta>>2];f[s+4>>2]=f[Ta+4>>2];p[s>>3]=+p[s>>3];f[z>>2]=f[s>>2];f[z+4>>2]=f[s+4>>2];B=B+1|0}while((B|0)!=(C|0));_a=_a+C|0}while((_a|0)<(A|0));Xa=0;Ya=Va}else{if((A|0)>0)$a=0;else{Xa=0;Ya=Va;break}do{B=0;do{z=Ma+(B<<4)|0;Ta=Va+(B+$a<<4)|0;f[Ta>>2]=f[z>>2];f[Ta+4>>2]=f[z+4>>2];f[Ta+8>>2]=f[z+8>>2];f[Ta+12>>2]=f[z+12>>2];B=B+1|0}while((B|0)!=(C|0));$a=$a+C|0}while(($a|0)<(A|0));Xa=0;Ya=Va}}else{B=(A+1|0)/2|0;f[I>>2]=B;if(B>>>0>136){z=XDc(B>>>0>536870911?-1:B<<3)|0;f[y>>2]=z;Xa=z;Ya=0}else{Xa=Sa;Ya=0}}while(0);A=x+16|0;b:do if((o|0)>0){Va=0;while(1){if(Va>>>0>=(f[A>>2]|0)>>>0)break b;if(G){$a=0;Ma=f[r>>2]|0;do{_a=o-$a|0;Na=(c|0)<(_a|0)?c:_a;_a=Y(Na,C)|0;gi[Ha&255](Ma,_a,a,Ya,Pa);_a=Y(Na,Ua)|0;Ma=(f[r>>2]|0)+_a|0;f[r>>2]=Ma;$a=$a+c|0}while((o|0)>($a|0))}else{$a=0;do{Ma=o-$a|0;_a=(c|0)<(Ma|0)?c:Ma;p4(Xa,Y(_a,C)|0,a);Ii[Fa&127](Xa,f[r>>2]|0,_a,C,Ka,Ja,Ga);Ma=Y(_a,Ua)|0;f[r>>2]=(f[r>>2]|0)+Ma;$a=$a+c|0}while((o|0)>($a|0))}A2(x)|0;Va=Va+1|0}}else{Va=0;while(1){if(Va>>>0>=(f[A>>2]|0)>>>0)break b;A2(x)|0;Va=Va+1|0}}while(0);x=f[y>>2]|0;if((x|0)!=(Sa|0)){if(x|0)ZDc(x);f[y>>2]=Sa;f[I>>2]=136}I=f[m>>2]|0;if((I|0)!=(D|0)){if(I|0)ZDc(I);f[m>>2]=D;f[H>>2]=136}H=l+36|0;D=f[H>>2]|0;if(D|0?(m=D+12|0,D=f[m>>2]|0,f[m>>2]=D+-1,(D|0)==1):0)_S(l);f[H>>2]=0;H=l+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[R>>2]|0)>0){H=f[l+40>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[R>>2]|0))}R=f[l+44>>2]|0;if((R|0)!=(l+48|0))g0(R);R=k+36|0;l=f[R>>2]|0;do if(l|0){D=l+12|0;H=f[D>>2]|0;f[D>>2]=H+-1;if((H|0)!=1)break;_S(k)}while(0);f[R>>2]=0;R=k+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[N>>2]|0)>0){R=f[k+40>>2]|0;l=0;do{f[R+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[N>>2]|0))}N=f[k+44>>2]|0;if((N|0)!=(k+48|0))g0(N);N=j+36|0;k=f[N>>2]|0;do if(k|0){l=k+12|0;R=f[l>>2]|0;f[l>>2]=R+-1;if((R|0)!=1)break;_S(j)}while(0);f[N>>2]=0;N=j+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Ra>>2]|0)>0){N=f[j+40>>2]|0;k=0;do{f[N+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[Ra>>2]|0))}Ra=f[j+44>>2]|0;if((Ra|0)==(j+48|0)){u=i;return}g0(Ra);u=i;return}function r4(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((d|0)>0&(e|0)>0){i=c;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=mrc(m)|0;b[i+h>>0]=o>>>0<256?o:(o|0)>0?255:0;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(d|0))break;else{i=i+e|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((d|0)>0)r=0;else return;do{j=mrc(p+q*+n[a+(r<<2)>>2])|0;b[c+r>>0]=j>>>0<256?j:(j|0)>0?255:0;r=r+1|0}while((r|0)!=(d|0));return}if((d|0)>0&(e|0)>0){s=a;t=c;u=0}else return;while(1){c=0;do{a=mrc(+n[s+(c<<2)>>2]*+n[g+(c<<2)>>2]+ +n[f+(c<<2)>>2])|0;b[t+c>>0]=a>>>0<256?a:(a|0)>0?255:0;c=c+1|0}while((c|0)!=(e|0));u=u+1|0;if((u|0)==(d|0))break;else{s=s+(e<<2)|0;t=t+e|0}}return}function s4(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((d|0)>0&(e|0)>0){i=c;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=mrc(m)|0;b[i+h>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(d|0))break;else{i=i+e|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((d|0)>0)r=0;else return;do{j=mrc(p+q*+n[a+(r<<2)>>2])|0;b[c+r>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;r=r+1|0}while((r|0)!=(d|0));return}if((d|0)>0&(e|0)>0){s=a;t=c;u=0}else return;while(1){c=0;do{a=mrc(+n[s+(c<<2)>>2]*+n[g+(c<<2)>>2]+ +n[f+(c<<2)>>2])|0;b[t+c>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;c=c+1|0}while((c|0)!=(e|0));u=u+1|0;if((u|0)==(d|0))break;else{s=s+(e<<2)|0;t=t+e|0}}return}function t4(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(e|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=mrc(m)|0;d[i+(h<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(e<<1)|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=mrc(p+q*+n[a+(r<<2)>>2])|0;d[b+(r<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(e|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=mrc(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[f+(b<<2)>>2])|0;d[t+(b<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;b=b+1|0}while((b|0)!=(e|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(e<<2)|0;t=t+(e<<1)|0}}return}function u4(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(e|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=mrc(m)|0;d[i+(h<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(e<<1)|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=mrc(p+q*+n[a+(r<<2)>>2])|0;d[b+(r<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(e|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=mrc(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[f+(b<<2)>>2])|0;d[t+(b<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;b=b+1|0}while((b|0)!=(e|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(e<<2)|0;t=t+(e<<1)|0}}return}function v4(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(d|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,d)|0;m=+n[e+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(d|0));o=mrc(m)|0;f[i+(h<<2)>>2]=o;h=h+1|0}while((h|0)!=(d|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(d<<2)|0;j=j+(d<<2)|0}}return}if((d|0)==1){p=+n[e>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=mrc(p+q*+n[a+(r<<2)>>2])|0;f[b+(r<<2)>>2]=j;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(d|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=mrc(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[e+(b<<2)>>2])|0;f[t+(b<<2)>>2]=a;b=b+1|0}while((b|0)!=(d|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(d<<2)|0;t=t+(d<<2)|0}}return}function w4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;if(g){if((c|0)>0&(d|0)>0){h=b;i=a;j=0}else return;while(1){g=0;do{k=Y(g,d)|0;l=+n[e+(g<<2)>>2];m=0;do{l=l+ +n[i+(m<<2)>>2]*+n[f+(m+k<<2)>>2];m=m+1|0}while((m|0)!=(d|0));n[h+(g<<2)>>2]=l;g=g+1|0}while((g|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{h=h+(d<<2)|0;i=i+(d<<2)|0}}return}if((d|0)==1){o=+n[e>>2];p=+n[f>>2];if((c|0)>0)q=0;else return;do{n[b+(q<<2)>>2]=o+p*+n[a+(q<<2)>>2];q=q+1|0}while((q|0)!=(c|0));return}if((c|0)>0&(d|0)>0){r=a;s=b;t=0}else return;while(1){b=0;do{n[s+(b<<2)>>2]=+n[r+(b<<2)>>2]*+n[f+(b<<2)>>2]+ +n[e+(b<<2)>>2];b=b+1|0}while((b|0)!=(d|0));t=t+1|0;if((t|0)==(c|0))break;else{r=r+(d<<2)|0;s=s+(d<<2)|0}}return}function x4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0;if(g){if((c|0)>0&(d|0)>0){h=b;i=a;j=0}else return;while(1){g=0;do{k=Y(g,d)|0;l=+p[e+(g<<3)>>3];m=0;do{l=l+ +n[i+(m<<2)>>2]*+p[f+(m+k<<3)>>3];m=m+1|0}while((m|0)!=(d|0));p[h+(g<<3)>>3]=l;g=g+1|0}while((g|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{h=h+(d<<3)|0;i=i+(d<<2)|0}}return}if((d|0)==1){o=+p[e>>3];q=+p[f>>3];if((c|0)>0)r=0;else return;do{p[b+(r<<3)>>3]=o+q*+n[a+(r<<2)>>2];r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(d|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{p[t+(b<<3)>>3]=+n[s+(b<<2)>>2]*+p[f+(b<<3)>>3]+ +p[e+(b<<3)>>3];b=b+1|0}while((b|0)!=(d|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(d<<2)|0;t=t+(d<<3)|0}}return}function y4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d;h=f[g>>2]|0;i=f[g+4>>2]|0;g=c+-4|0;if((c|0)<4){j=0;k=h;l=i}else{m=0;n=h;h=i;do{i=mJc(n|0,0,-130063606,0)|0;o=UIc(i|0,J|0,h|0,0)|0;i=J;p=mJc(o|0,0,-130063606,0)|0;q=UIc(p|0,J|0,i|0,0)|0;i=J;mJc(o|0,0,f[e+(m*20|0)+4>>2]|0,0)|0;p=J;r=m|1;mJc(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(m*20|0)+8>>2]|0))+p|0)>>>(f[e+(m*20|0)+12>>2]|0),f[e+(m*20|0)>>2]|0)|0)|0;p=t+(f[e+(m*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+m>>0]=p>>>0<256?p:(p|0)>0?255:0;b[a+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=mJc(q|0,0,-130063606,0)|0;q=UIc(s|0,J|0,i|0,0)|0;i=J;s=mJc(q|0,0,-130063606,0)|0;n=UIc(s|0,J|0,i|0,0)|0;h=J;i=m|2;mJc(f[e+(i*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=m|3;mJc(f[e+(r*20|0)+4>>2]|0,0,n|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(i*20|0)+8>>2]|0))+s|0)>>>(f[e+(i*20|0)+12>>2]|0),f[e+(i*20|0)>>2]|0)|0)|0;s=t+(f[e+(i*20|0)+16>>2]|0)|0;t=n-(Y((((n-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+i>>0]=s>>>0<256?s:(s|0)>0?255:0;b[a+r>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+4|0}while((m|0)<=(g|0));j=c&-4;k=n;l=h}if((j|0)<(c|0)){u=j;v=k;w=l}else{x=k;y=l;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){l=mJc(v|0,0,-130063606,0)|0;k=UIc(l|0,J|0,w|0,0)|0;l=J;mJc(k|0,0,f[e+(u*20|0)+4>>2]|0,0)|0;j=J;h=k-(Y((((k-j|0)>>>(f[e+(u*20|0)+8>>2]|0))+j|0)>>>(f[e+(u*20|0)+12>>2]|0),f[e+(u*20|0)>>2]|0)|0)|0;j=h+(f[e+(u*20|0)+16>>2]|0)|0;b[a+u>>0]=j>>>0<256?j:(j|0)>0?255:0;u=u+1|0;if((u|0)==(c|0)){x=k;y=l;break}else{v=k;w=l}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function z4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d;h=f[g>>2]|0;i=f[g+4>>2]|0;g=c+-4|0;if((c|0)<4){j=0;k=h;l=i}else{m=0;n=h;h=i;do{i=mJc(n|0,0,-130063606,0)|0;o=UIc(i|0,J|0,h|0,0)|0;i=J;p=mJc(o|0,0,-130063606,0)|0;q=UIc(p|0,J|0,i|0,0)|0;i=J;mJc(o|0,0,f[e+(m*20|0)+4>>2]|0,0)|0;p=J;r=m|1;mJc(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(m*20|0)+8>>2]|0))+p|0)>>>(f[e+(m*20|0)+12>>2]|0),f[e+(m*20|0)>>2]|0)|0)|0;p=t+(f[e+(m*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+m>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;b[a+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=mJc(q|0,0,-130063606,0)|0;q=UIc(s|0,J|0,i|0,0)|0;i=J;s=mJc(q|0,0,-130063606,0)|0;n=UIc(s|0,J|0,i|0,0)|0;h=J;i=m|2;mJc(f[e+(i*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=m|3;mJc(f[e+(r*20|0)+4>>2]|0,0,n|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(i*20|0)+8>>2]|0))+s|0)>>>(f[e+(i*20|0)+12>>2]|0),f[e+(i*20|0)>>2]|0)|0)|0;s=t+(f[e+(i*20|0)+16>>2]|0)|0;t=n-(Y((((n-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+i>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[a+r>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;m=m+4|0}while((m|0)<=(g|0));j=c&-4;k=n;l=h}if((j|0)<(c|0)){u=j;v=k;w=l}else{x=k;y=l;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){l=mJc(v|0,0,-130063606,0)|0;k=UIc(l|0,J|0,w|0,0)|0;l=J;mJc(k|0,0,f[e+(u*20|0)+4>>2]|0,0)|0;j=J;h=k-(Y((((k-j|0)>>>(f[e+(u*20|0)+8>>2]|0))+j|0)>>>(f[e+(u*20|0)+12>>2]|0),f[e+(u*20|0)>>2]|0)|0)|0;j=h+(f[e+(u*20|0)+16>>2]|0)|0;b[a+u>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;u=u+1|0;if((u|0)==(c|0)){x=k;y=l;break}else{v=k;w=l}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function A4(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;if((b|0)<4){j=0;k=h;l=i}else{m=0;n=h;h=i;do{i=mJc(n|0,0,-130063606,0)|0;o=UIc(i|0,J|0,h|0,0)|0;i=J;p=mJc(o|0,0,-130063606,0)|0;q=UIc(p|0,J|0,i|0,0)|0;i=J;mJc(o|0,0,f[e+(m*20|0)+4>>2]|0,0)|0;p=J;r=m|1;mJc(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(m*20|0)+8>>2]|0))+p|0)>>>(f[e+(m*20|0)+12>>2]|0),f[e+(m*20|0)>>2]|0)|0)|0;p=t+(f[e+(m*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(m<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;d[a+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=mJc(q|0,0,-130063606,0)|0;q=UIc(s|0,J|0,i|0,0)|0;i=J;s=mJc(q|0,0,-130063606,0)|0;n=UIc(s|0,J|0,i|0,0)|0;h=J;i=m|2;mJc(f[e+(i*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=m|3;mJc(f[e+(r*20|0)+4>>2]|0,0,n|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(i*20|0)+8>>2]|0))+s|0)>>>(f[e+(i*20|0)+12>>2]|0),f[e+(i*20|0)>>2]|0)|0)|0;s=t+(f[e+(i*20|0)+16>>2]|0)|0;t=n-(Y((((n-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(i<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[a+(r<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;m=m+4|0}while((m|0)<=(g|0));j=b&-4;k=n;l=h}if((j|0)<(b|0)){u=j;v=k;w=l}else{x=k;y=l;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){l=mJc(v|0,0,-130063606,0)|0;k=UIc(l|0,J|0,w|0,0)|0;l=J;mJc(k|0,0,f[e+(u*20|0)+4>>2]|0,0)|0;j=J;h=k-(Y((((k-j|0)>>>(f[e+(u*20|0)+8>>2]|0))+j|0)>>>(f[e+(u*20|0)+12>>2]|0),f[e+(u*20|0)>>2]|0)|0)|0;j=h+(f[e+(u*20|0)+16>>2]|0)|0;d[a+(u<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;u=u+1|0;if((u|0)==(b|0)){x=k;y=l;break}else{v=k;w=l}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function B4(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;if((b|0)<4){j=0;k=h;l=i}else{m=0;n=h;h=i;do{i=mJc(n|0,0,-130063606,0)|0;o=UIc(i|0,J|0,h|0,0)|0;i=J;p=mJc(o|0,0,-130063606,0)|0;q=UIc(p|0,J|0,i|0,0)|0;i=J;mJc(o|0,0,f[e+(m*20|0)+4>>2]|0,0)|0;p=J;r=m|1;mJc(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(m*20|0)+8>>2]|0))+p|0)>>>(f[e+(m*20|0)+12>>2]|0),f[e+(m*20|0)>>2]|0)|0)|0;p=t+(f[e+(m*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(m<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[a+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=mJc(q|0,0,-130063606,0)|0;q=UIc(s|0,J|0,i|0,0)|0;i=J;s=mJc(q|0,0,-130063606,0)|0;n=UIc(s|0,J|0,i|0,0)|0;h=J;i=m|2;mJc(f[e+(i*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=m|3;mJc(f[e+(r*20|0)+4>>2]|0,0,n|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(i*20|0)+8>>2]|0))+s|0)>>>(f[e+(i*20|0)+12>>2]|0),f[e+(i*20|0)>>2]|0)|0)|0;s=t+(f[e+(i*20|0)+16>>2]|0)|0;t=n-(Y((((n-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(i<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[a+(r<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;m=m+4|0}while((m|0)<=(g|0));j=b&-4;k=n;l=h}if((j|0)<(b|0)){u=j;v=k;w=l}else{x=k;y=l;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){l=mJc(v|0,0,-130063606,0)|0;k=UIc(l|0,J|0,w|0,0)|0;l=J;mJc(k|0,0,f[e+(u*20|0)+4>>2]|0,0)|0;j=J;h=k-(Y((((k-j|0)>>>(f[e+(u*20|0)+8>>2]|0))+j|0)>>>(f[e+(u*20|0)+12>>2]|0),f[e+(u*20|0)>>2]|0)|0)|0;j=h+(f[e+(u*20|0)+16>>2]|0)|0;d[a+(u<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;u=u+1|0;if((u|0)==(b|0)){x=k;y=l;break}else{v=k;w=l}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function C4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=0;j=g;k=h}else{l=0;m=g;g=h;do{h=mJc(m|0,0,-130063606,0)|0;n=UIc(h|0,J|0,g|0,0)|0;h=J;o=mJc(n|0,0,-130063606,0)|0;p=UIc(o|0,J|0,h|0,0)|0;h=J;mJc(n|0,0,f[d+(l*20|0)+4>>2]|0,0)|0;o=J;q=l|1;mJc(p|0,0,f[d+(q*20|0)+4>>2]|0,0)|0;r=J;s=Y((((n-o|0)>>>(f[d+(l*20|0)+8>>2]|0))+o|0)>>>(f[d+(l*20|0)+12>>2]|0),f[d+(l*20|0)>>2]|0)|0;o=Y((((p-r|0)>>>(f[d+(q*20|0)+8>>2]|0))+r|0)>>>(f[d+(q*20|0)+12>>2]|0),f[d+(q*20|0)>>2]|0)|0;r=(f[d+(q*20|0)+16>>2]|0)+p-o|0;f[a+(l<<2)>>2]=(f[d+(l*20|0)+16>>2]|0)+n-s;f[a+(q<<2)>>2]=r;r=mJc(p|0,0,-130063606,0)|0;p=UIc(r|0,J|0,h|0,0)|0;h=J;r=mJc(p|0,0,-130063606,0)|0;m=UIc(r|0,J|0,h|0,0)|0;g=J;h=l|2;mJc(f[d+(h*20|0)+4>>2]|0,0,p|0,0)|0;r=J;q=l|3;mJc(f[d+(q*20|0)+4>>2]|0,0,m|0,0)|0;s=J;n=Y((((p-r|0)>>>(f[d+(h*20|0)+8>>2]|0))+r|0)>>>(f[d+(h*20|0)+12>>2]|0),f[d+(h*20|0)>>2]|0)|0;r=Y((((m-s|0)>>>(f[d+(q*20|0)+8>>2]|0))+s|0)>>>(f[d+(q*20|0)+12>>2]|0),f[d+(q*20|0)>>2]|0)|0;s=(f[d+(q*20|0)+16>>2]|0)+m-r|0;f[a+(h<<2)>>2]=(f[d+(h*20|0)+16>>2]|0)+p-n;f[a+(q<<2)>>2]=s;l=l+4|0}while((l|0)<=(e|0));i=b&-4;j=m;k=g}if((i|0)<(b|0)){t=i;u=j;v=k}else{w=j;x=k;y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}while(1){k=mJc(u|0,0,-130063606,0)|0;j=UIc(k|0,J|0,v|0,0)|0;k=J;mJc(j|0,0,f[d+(t*20|0)+4>>2]|0,0)|0;i=J;g=Y((((j-i|0)>>>(f[d+(t*20|0)+8>>2]|0))+i|0)>>>(f[d+(t*20|0)+12>>2]|0),f[d+(t*20|0)>>2]|0)|0;f[a+(t<<2)>>2]=(f[d+(t*20|0)+16>>2]|0)+j-g;t=t+1|0;if((t|0)==(b|0)){w=j;x=k;break}else{u=j;v=k}}y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}function D4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=0;j=g;k=h}else{l=0;m=g;g=h;do{h=mJc(m|0,0,-130063606,0)|0;o=UIc(h|0,J|0,g|0,0)|0;h=J;p=mJc(o|0,0,-130063606,0)|0;q=UIc(p|0,J|0,h|0,0)|0;h=J;p=mJc(q|0,0,-130063606,0)|0;r=UIc(p|0,J|0,h|0,0)|0;h=J;p=mJc(r|0,0,-130063606,0)|0;m=UIc(p|0,J|0,h|0,0)|0;g=J;n[a+(l<<2)>>2]=+(o|0)*+n[d+(l<<3)>>2]+ +n[d+(l<<3)+4>>2];o=l|1;n[a+(o<<2)>>2]=+(q|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];o=l|2;n[a+(o<<2)>>2]=+(r|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];o=l|3;n[a+(o<<2)>>2]=+(m|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];l=l+4|0}while((l|0)<=(e|0));i=b&-4;j=m;k=g}if((i|0)<(b|0)){s=i;t=j;u=k}else{v=j;w=k;x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}while(1){k=mJc(t|0,0,-130063606,0)|0;j=UIc(k|0,J|0,u|0,0)|0;k=J;n[a+(s<<2)>>2]=+(j|0)*+n[d+(s<<3)>>2]+ +n[d+(s<<3)+4>>2];s=s+1|0;if((s|0)==(b|0)){v=j;w=k;break}else{t=j;u=k}}x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}function E4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=0;j=g;k=h}else{l=0;m=g;g=h;do{h=mJc(m|0,0,-130063606,0)|0;n=UIc(h|0,J|0,g|0,0)|0;h=J;o=(+(h>>>0)+4294967296.0*+(n|0))*+p[d+(l<<4)>>3]+ +p[d+(l<<4)+8>>3];q=mJc(n|0,0,-130063606,0)|0;n=UIc(q|0,J|0,h|0,0)|0;h=J;q=l|1;r=(+(h>>>0)+4294967296.0*+(n|0))*+p[d+(q<<4)>>3]+ +p[d+(q<<4)+8>>3];p[a+(l<<3)>>3]=o;p[a+(q<<3)>>3]=r;q=mJc(n|0,0,-130063606,0)|0;n=UIc(q|0,J|0,h|0,0)|0;h=J;q=l|2;r=(+(h>>>0)+4294967296.0*+(n|0))*+p[d+(q<<4)>>3]+ +p[d+(q<<4)+8>>3];s=mJc(n|0,0,-130063606,0)|0;m=UIc(s|0,J|0,h|0,0)|0;g=J;h=l|3;o=(+(g>>>0)+4294967296.0*+(m|0))*+p[d+(h<<4)>>3]+ +p[d+(h<<4)+8>>3];p[a+(q<<3)>>3]=r;p[a+(h<<3)>>3]=o;l=l+4|0}while((l|0)<=(e|0));i=b&-4;j=m;k=g}if((i|0)<(b|0)){t=i;u=j;v=k}else{w=j;x=k;y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}while(1){k=mJc(u|0,0,-130063606,0)|0;j=UIc(k|0,J|0,v|0,0)|0;k=J;p[a+(t<<3)>>3]=(+(k>>>0)+4294967296.0*+(j|0))*+p[d+(t<<4)>>3]+ +p[d+(t<<4)+8>>3];t=t+1|0;if((t|0)==(b|0)){w=j;x=k;break}else{u=j;v=k}}y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}function F4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=d;i=f[h>>2]|0;j=f[h+4>>2]|0;h=c+-4|0;k=(c|0)<4;if(g)if(k){l=0;m=i;n=j}else{g=0;o=i;p=j;do{q=mJc(o|0,0,-130063606,0)|0;o=UIc(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(g<<3)>>2])+(f[e+(g<<3)+4>>2]|0)|0;r=g|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;b[a+g>>0]=q>>>0<256?q:(q|0)>0?255:0;b[a+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=g|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=g|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;b[a+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[a+q>>0]=t>>>0<256?t:(t|0)>0?255:0;g=g+4|0}while((g|0)<=(h|0));l=c&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=mJc(p|0,0,-130063606,0)|0;o=UIc(j|0,J|0,i|0,0)|0;j=J;g=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=mJc(o|0,0,-130063606,0)|0;o=UIc(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;b[a+k>>0]=g>>>0<256?g:(g|0)>0?255:0;b[a+t>>0]=q>>>0<256?q:(q|0)>0?255:0;q=mJc(o|0,0,-130063606,0)|0;o=UIc(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;g=mJc(o|0,0,-130063606,0)|0;p=UIc(g|0,J|0,j|0,0)|0;i=J;j=k|3;g=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;b[a+q>>0]=t>>>0<256?t:(t|0)>0?255:0;b[a+j>>0]=g>>>0<256?g:(g|0)>0?255:0;k=k+4|0}while((k|0)<=(h|0));l=c&-4;m=p;n=i}if((l|0)<(c|0)){u=l;v=m;w=n}else{x=m;y=n;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=mJc(v|0,0,-130063606,0)|0;m=UIc(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;b[a+u>>0]=l>>>0<256?l:(l|0)>0?255:0;u=u+1|0;if((u|0)==(c|0)){x=m;y=n;break}else{v=m;w=n}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function G4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=d;i=f[h>>2]|0;j=f[h+4>>2]|0;h=c+-4|0;k=(c|0)<4;if(g)if(k){l=0;m=i;n=j}else{g=0;o=i;p=j;do{q=mJc(o|0,0,-130063606,0)|0;o=UIc(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(g<<3)>>2])+(f[e+(g<<3)+4>>2]|0)|0;r=g|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;b[a+g>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[a+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=g|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=g|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;b[a+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[a+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;g=g+4|0}while((g|0)<=(h|0));l=c&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=mJc(p|0,0,-130063606,0)|0;o=UIc(j|0,J|0,i|0,0)|0;j=J;g=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=mJc(o|0,0,-130063606,0)|0;o=UIc(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;b[a+k>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;b[a+t>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;q=mJc(o|0,0,-130063606,0)|0;o=UIc(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;g=mJc(o|0,0,-130063606,0)|0;p=UIc(g|0,J|0,j|0,0)|0;i=J;j=k|3;g=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;b[a+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;b[a+j>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;k=k+4|0}while((k|0)<=(h|0));l=c&-4;m=p;n=i}if((l|0)<(c|0)){u=l;v=m;w=n}else{x=m;y=n;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=mJc(v|0,0,-130063606,0)|0;m=UIc(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;b[a+u>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;u=u+1|0;if((u|0)==(c|0)){x=m;y=n;break}else{v=m;w=n}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function H4(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=c;i=f[h>>2]|0;j=f[h+4>>2]|0;h=b+-4|0;k=(b|0)<4;if(g)if(k){l=0;m=i;n=j}else{g=0;o=i;p=j;do{q=mJc(o|0,0,-130063606,0)|0;o=UIc(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(g<<3)>>2])+(f[e+(g<<3)+4>>2]|0)|0;r=g|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;d[a+(g<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[a+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=g|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=g|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;d[a+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[a+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;g=g+4|0}while((g|0)<=(h|0));l=b&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=mJc(p|0,0,-130063606,0)|0;o=UIc(j|0,J|0,i|0,0)|0;j=J;g=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=mJc(o|0,0,-130063606,0)|0;o=UIc(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;d[a+(k<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;d[a+(t<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;q=mJc(o|0,0,-130063606,0)|0;o=UIc(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;g=mJc(o|0,0,-130063606,0)|0;p=UIc(g|0,J|0,j|0,0)|0;i=J;j=k|3;g=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;d[a+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[a+(j<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;k=k+4|0}while((k|0)<=(h|0));l=b&-4;m=p;n=i}if((l|0)<(b|0)){u=l;v=m;w=n}else{x=m;y=n;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=mJc(v|0,0,-130063606,0)|0;m=UIc(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;d[a+(u<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;u=u+1|0;if((u|0)==(b|0)){x=m;y=n;break}else{v=m;w=n}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function I4(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=c;i=f[h>>2]|0;j=f[h+4>>2]|0;h=b+-4|0;k=(b|0)<4;if(g)if(k){l=0;m=i;n=j}else{g=0;o=i;p=j;do{q=mJc(o|0,0,-130063606,0)|0;o=UIc(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(g<<3)>>2])+(f[e+(g<<3)+4>>2]|0)|0;r=g|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;d[a+(g<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[a+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=g|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=g|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;d[a+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[a+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;g=g+4|0}while((g|0)<=(h|0));l=b&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=mJc(p|0,0,-130063606,0)|0;o=UIc(j|0,J|0,i|0,0)|0;j=J;g=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=mJc(o|0,0,-130063606,0)|0;o=UIc(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;d[a+(k<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;d[a+(t<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;q=mJc(o|0,0,-130063606,0)|0;o=UIc(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;g=mJc(o|0,0,-130063606,0)|0;p=UIc(g|0,J|0,j|0,0)|0;i=J;j=k|3;g=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;d[a+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[a+(j<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;k=k+4|0}while((k|0)<=(h|0));l=b&-4;m=p;n=i}if((l|0)<(b|0)){u=l;v=m;w=n}else{x=m;y=n;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=mJc(v|0,0,-130063606,0)|0;m=UIc(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;d[a+(u<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;u=u+1|0;if((u|0)==(b|0)){x=m;y=n;break}else{v=m;w=n}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function J4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;j=(b|0)<4;if(e)if(j){k=0;l=h;m=i}else{e=0;n=h;o=i;do{p=mJc(n|0,0,-130063606,0)|0;n=UIc(p|0,J|0,o|0,0)|0;o=J;p=e|1;q=(n>>8&f[d+(p<<3)>>2])+(f[d+(p<<3)+4>>2]|0)|0;f[a+(e<<2)>>2]=(n&f[d+(e<<3)>>2])+(f[d+(e<<3)+4>>2]|0);f[a+(p<<2)>>2]=q;q=e|2;p=e|3;r=(f[d+(p<<3)>>2]&n>>24)+(f[d+(p<<3)+4>>2]|0)|0;f[a+(q<<2)>>2]=(f[d+(q<<3)>>2]&n>>16)+(f[d+(q<<3)+4>>2]|0);f[a+(p<<2)>>2]=r;e=e+4|0}while((e|0)<=(g|0));k=b&-4;l=n;m=o}else if(j){k=0;l=h;m=i}else{j=0;o=h;h=i;do{i=mJc(o|0,0,-130063606,0)|0;n=UIc(i|0,J|0,h|0,0)|0;i=J;e=(n&f[d+(j<<3)>>2])+(f[d+(j<<3)+4>>2]|0)|0;r=mJc(n|0,0,-130063606,0)|0;n=UIc(r|0,J|0,i|0,0)|0;i=J;r=j|1;p=(n&f[d+(r<<3)>>2])+(f[d+(r<<3)+4>>2]|0)|0;f[a+(j<<2)>>2]=e;f[a+(r<<2)>>2]=p;p=mJc(n|0,0,-130063606,0)|0;n=UIc(p|0,J|0,i|0,0)|0;i=J;p=j|2;r=(n&f[d+(p<<3)>>2])+(f[d+(p<<3)+4>>2]|0)|0;e=mJc(n|0,0,-130063606,0)|0;o=UIc(e|0,J|0,i|0,0)|0;h=J;i=j|3;e=(o&f[d+(i<<3)>>2])+(f[d+(i<<3)+4>>2]|0)|0;f[a+(p<<2)>>2]=r;f[a+(i<<2)>>2]=e;j=j+4|0}while((j|0)<=(g|0));k=b&-4;l=o;m=h}if((k|0)<(b|0)){s=k;t=l;u=m}else{v=l;w=m;x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}while(1){m=mJc(t|0,0,-130063606,0)|0;l=UIc(m|0,J|0,u|0,0)|0;m=J;f[a+(s<<2)>>2]=(l&f[d+(s<<3)>>2])+(f[d+(s<<3)+4>>2]|0);s=s+1|0;if((s|0)==(b|0)){v=l;w=m;break}else{t=l;u=m}}x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}function K4(){return T5(S5()|0)|0}function L4(a){a=a|0;var b=0,c=0;b=(a|0)!=0;c=T5(S5()|0)|0;f[c>>2]=b?a:-1;f[c+4>>2]=b?((a|0)<0)<<31>>31:0;return}function M4(a,b,c){a=a|0;b=b|0;c=c|0;q4(T5(S5()|0)|0,a,0,b,c,0);return}function N4(a,b,c){a=a|0;b=b|0;c=c|0;q4(T5(S5()|0)|0,a,1,b,c,0);return}function O4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;e=u;u=u+352|0;i=e+216|0;j=e+72|0;k=e+16|0;l=e;m=e+208|0;n=e+200|0;if(!c){f[a>>2]=1124007936;o=a+8|0;p=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}o=f[c>>2]|0;p=o&-65536;if((p|0)==1111621632){s=f[c+24>>2]|0;if((s|0)>-1?(t=f[c+20>>2]|0,(t|0)>-1):0){f[a>>2]=1124007936;v=a+4|0;w=a+8|0;x=a+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=w;x=a+48|0;f[a+44>>2]=x;f[x>>2]=0;y=a+52|0;f[y>>2]=0;z=f[c+4>>2]|0;if(d){f[a+16>>2]=0;f[a+24>>2]=0;f[a+20>>2]=0;Vj(i,t,s,o,f[c+16>>2]|0,z);A=j+8|0;f[A>>2]=0;f[A+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=a;h_(i,j);A=i+36|0;B=f[A>>2]|0;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)_S(i);f[A>>2]=0;A=i+16|0;B=i+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[i+40>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[B>>2]|0))}B=f[i+44>>2]|0;if((B|0)!=(i+48|0))g0(B)}else{f[a>>2]=o&20479|1124007936;f[v>>2]=2;f[w>>2]=t;f[a+12>>2]=s;w=f[c+16>>2]|0;f[a+16>>2]=w;f[a+20>>2]=w;v=(o>>>3&511)+1<<(47696>>>(o<<1&14)&3);B=Y(s,v)|0;s=(z|0)==0?B:z;z=w+(Y(s,t)|0)|0;f[a+28>>2]=z;f[a+24>>2]=z+(0-s)+B;f[x>>2]=s;f[y>>2]=v}u=e;return}}else if((p|0)==1111687168?(v=f[c+16>>2]|0,y=v,v|0):0){v=a+4|0;s=a+8|0;x=a+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=s;B=a+48|0;z=a+44|0;f[z>>2]=B;f[B>>2]=0;f[a+52>>2]=0;B=a+16|0;f[B>>2]=y;t=a+20|0;f[t>>2]=y;f[a>>2]=o&4095|1124007936;y=f[c+4>>2]|0;if((y|0)>0){w=0;do{f[i+(w<<2)>>2]=f[c+20+(w<<3)>>2];f[j+(w<<2)>>2]=f[c+20+(w<<3)+4>>2];w=w+1|0}while((w|0)!=(y|0))}OS(a,y,i,j,0);PS(a);if(d){f[k>>2]=f[a>>2];y=k+4|0;w=f[v>>2]|0;f[y>>2]=w;C=k+8|0;f[C>>2]=f[s>>2];f[k+12>>2]=f[a+12>>2];s=k+16|0;f[s>>2]=f[B>>2];f[k+20>>2]=f[t>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];t=k+36|0;A=a+36|0;D=f[A>>2]|0;f[t>>2]=D;E=k+40|0;f[E>>2]=C;C=k+48|0;F=k+44|0;f[F>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(!D)G=w;else{w=D+12|0;f[w>>2]=(f[w>>2]|0)+1;G=f[v>>2]|0}if((G|0)<3){G=f[z>>2]|0;z=f[F>>2]|0;f[z>>2]=f[G>>2];f[z+4>>2]=f[G+4>>2]}else{f[y>>2]=0;ZS(k,a)}G=f[A>>2]|0;if(G|0?(z=G+12|0,G=f[z>>2]|0,f[z>>2]=G+-1,(G|0)==1):0)_S(a);f[A>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[v>>2]|0)>0){B=f[x>>2]|0;x=0;do{f[B+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=l+8|0;f[v>>2]=0;f[v+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=a;h_(k,l);l=f[t>>2]|0;if(l|0?(v=l+12|0,l=f[v>>2]|0,f[v>>2]=l+-1,(l|0)==1):0)_S(k);f[t>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[y>>2]|0)>0){s=f[E>>2]|0;E=0;do{f[s+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[y>>2]|0))}y=f[F>>2]|0;if((y|0)!=(C|0))g0(y)}u=e;return}if((o|0)==112?(y=f[c+68>>2]|0,C=y,y|0):0){F=c+48|0;E=f[F>>2]|0;if(!g)if(E)if((f[E>>2]|0)>0){f[i>>2]=0;f[i+4>>2]=0;q=tT(i,36)|0;H=232960;r=q+36|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));z5(-24,i,232997,232893,161)}else I=E;else I=0;else I=E;f[a>>2]=1124007936;E=a+4|0;g=a+8|0;s=a+40|0;t=E+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;f[s>>2]=g;t=a+48|0;l=a+44|0;f[l>>2]=t;v=a+52|0;f[v>>2]=0;f[E>>2]=2;x=f[c+16>>2]|0;B=1125516576>>>((x>>>2&60)+(x>>31&20)|0);x=f[c+72>>2]|0;f[t>>2]=x;t=c+28|0;A=f[t>>2]|0;G=(A|0)==0;do if(!I)if(G){z=((f[c+8>>2]<<3)+-8|B&7)+1124007936|0;f[a>>2]=z;w=f[c+44>>2]|0;f[g>>2]=w;D=f[c+40>>2]|0;J=a+12|0;f[J>>2]=D;f[a+16>>2]=C;K=a+20|0;f[K>>2]=C;L=(z>>>3&511)+1<<(47696>>>(z<<1&14)&3);M=K;N=J;O=w;P=y;Q=D;break}else{f[i>>2]=0;f[i+4>>2]=0;q=tT(i,38)|0;H=233008;r=q+38|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));z5(-215,i,233047,232893,106)}else{D=f[I>>2]|0;do if(!G)if(D){w=B&7;if((A|0)==1){R=1;S=w;T=1;break}else{U=w;V=58;break}}else{f[i>>2]=0;f[i+4>>2]=0;q=tT(i,60)|0;H=233061;r=q+60|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));z5(-215,i,233047,232893,115)}else{U=B&7;V=58}while(0);if((V|0)==58){R=f[c+8>>2]|0;S=U;T=0}w=((R<<3)+-8|S)+1124007936|0;f[a>>2]=w;J=f[I+16>>2]|0;f[g>>2]=J;K=f[I+12>>2]|0;z=a+12|0;f[z>>2]=K;W=(w>>>3&511)+1<<(47696>>>(w<<1&14)&3);if(T){w=Y(D+-1|0,x)|0;X=Y(w,f[c+44>>2]|0)|0}else X=0;w=y+X+(Y(f[I+8>>2]|0,x)|0)|0;Z=w+(Y(f[I+4>>2]|0,W)|0)|0;f[a+16>>2]=Z;w=a+20|0;f[w>>2]=Z;L=W;M=w;N=z;O=J;P=Z;Q=K}while(0);I=P+(Y(O,x)|0)|0;X=a+28|0;f[X>>2]=I;I=P+(Y(O+-1|0,x)|0)+(Y(L,Q)|0)|0;Q=a+24|0;f[Q>>2]=I;f[v>>2]=L;WS(a);if(!d){u=e;return}f[j>>2]=f[a>>2];L=j+4|0;v=f[E>>2]|0;f[L>>2]=v;I=j+8|0;f[I>>2]=f[g>>2];g=j+12|0;f[g>>2]=f[N>>2];N=j+16|0;x=a+16|0;f[N>>2]=f[x>>2];f[j+20>>2]=f[M>>2];f[j+24>>2]=f[Q>>2];f[j+28>>2]=f[X>>2];f[j+32>>2]=f[a+32>>2];X=j+36|0;Q=a+36|0;M=f[Q>>2]|0;f[X>>2]=M;O=j+40|0;f[O>>2]=I;P=j+48|0;y=j+44|0;f[y>>2]=P;f[P>>2]=0;f[j+52>>2]=0;if(!M)_=v;else{v=M+12|0;f[v>>2]=(f[v>>2]|0)+1;_=f[E>>2]|0}if((_|0)<3){_=f[l>>2]|0;l=f[y>>2]|0;f[l>>2]=f[_>>2];f[l+4>>2]=f[_+4>>2]}else{f[L>>2]=0;ZS(j,a)}_=f[Q>>2]|0;if(_|0?(l=_+12|0,_=f[l>>2]|0,f[l>>2]=_+-1,(_|0)==1):0)_S(a);f[Q>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[E>>2]|0)>0){x=f[s>>2]|0;s=0;do{f[x+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[E>>2]|0))}E=f[F>>2]|0;if(((E|0)!=0?(F=f[E>>2]|0,(F|0)!=0):0)?(f[t>>2]|0)!=1:0){f[k>>2]=F+-1;f[k+4>>2]=0;F=f[g>>2]|0;g=f[j>>2]&4095;f[i>>2]=f[I>>2];f[i+4>>2]=F;XS(a,2,i,g);SQ(j,1,a,1,k,1)}else{k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;h_(j,i)}k=f[X>>2]|0;if(k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)_S(j);f[X>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[L>>2]|0)>0){N=f[O>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[y>>2]|0;if((L|0)!=(P|0))g0(L);u=e;return}if((p|0)!=1117323264){f[i>>2]=0;f[i+4>>2]=0;q=tT(i,18)|0;H=233167;r=q+18|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));z5(-5,i,232997,232893,185)}p=f[c+24>>2]|0;L=o&4095;P=f[c+28>>2]|0;if(!p){f[a>>2]=1124007936;y=a+8|0;O=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[O>>2]=y;y=a+48|0;f[a+44>>2]=y;f[y>>2]=0;f[a+52>>2]=0;u=e;return}if((p|0)<=0){f[i>>2]=0;$=i+4|0;f[$>>2]=0;aa=tT(i,44)|0;q=aa;H=233122;r=q+44|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));z5(-215,i,232997,232893,170)}if(((o>>>3&511)+1<<(47696>>>(o<<1&14)&3)|0)!=(P|0)){f[i>>2]=0;$=i+4|0;f[$>>2]=0;aa=tT(i,44)|0;q=aa;H=233122;r=q+44|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));z5(-215,i,232997,232893,170)}if(!d?(d=f[c+52>>2]|0,(f[d+4>>2]|0)==(d|0)):0){Vj(a,p,1,L,f[d+16>>2]|0,0);u=e;return}if(h|0){d=(Y(P,p)|0)+7|0;P=d>>>3;H=h+4|0;do if((f[H>>2]|0)>>>0<P>>>0){aa=f[h>>2]|0;$=h+8|0;if((aa|0)==($|0))ba=aa;else{if(aa|0)ZDc(aa);f[h>>2]=$;f[H>>2]=136;ba=$}f[H>>2]=P;if(d>>>0>1095){$=XDc(P<<3)|0;f[h>>2]=$;ca=$;break}else{ca=ba;break}}else{f[H>>2]=P;ca=f[h>>2]|0}while(0);f[m>>2]=0;f[m+4>>2]=1073741823;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];p7(c,ca,i)|0;Vj(a,p,1,L,ca,0);u=e;return}f[j>>2]=1124007936;ca=j+4|0;m=j+8|0;h=j+40|0;q=ca;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[h>>2]=m;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;f[i>>2]=p;f[i+4>>2]=1;XS(j,2,i,L);L=j+16|0;p=f[L>>2]|0;f[n>>2]=0;f[n+4>>2]=1073741823;f[i>>2]=f[n>>2];f[i+4>>2]=f[n+4>>2];p7(c,p,i)|0;f[a>>2]=f[j>>2];i=a+4|0;p=f[ca>>2]|0;f[i>>2]=p;c=a+8|0;f[c>>2]=f[m>>2];f[a+12>>2]=f[j+12>>2];f[a+16>>2]=f[L>>2];f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];m=j+36|0;n=f[m>>2]|0;f[a+36>>2]=n;f[a+40>>2]=c;c=a+48|0;P=a+44|0;f[P>>2]=c;f[c>>2]=0;f[a+52>>2]=0;if(!n)da=p;else{p=n+12|0;f[p>>2]=(f[p>>2]|0)+1;da=f[ca>>2]|0}if((da|0)<3){da=f[r>>2]|0;p=f[P>>2]|0;f[p>>2]=f[da>>2];f[p+4>>2]=f[da+4>>2]}else{f[i>>2]=0;ZS(a,j)}a=f[m>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(j);f[m>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[ca>>2]|0)>0){L=f[h>>2]|0;h=0;do{f[L+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[ca>>2]|0))}ca=f[r>>2]|0;if((ca|0)!=(q|0))g0(ca);u=e;return}function P4(){var a=0,b=0;a=u;u=u+48|0;b=a;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=233186;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=942;f[b+24>>2]=1714;f[b+36>>2]=943;f[b+28>>2]=532;f[b+32>>2]=272;A1(b);f[132942]=f[132940];be(1715,531768,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=233202;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=942;f[b+24>>2]=1714;f[b+36>>2]=943;f[b+28>>2]=533;f[b+32>>2]=272;A1(b);f[132943]=f[132940];be(1715,531772,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=233223;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=944;f[b+24>>2]=1716;f[b+36>>2]=945;f[b+28>>2]=534;f[b+32>>2]=273;A1(b);f[132944]=f[132940];be(1715,531776,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=233236;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=946;f[b+24>>2]=1717;f[b+36>>2]=947;f[b+28>>2]=535;f[b+32>>2]=274;A1(b);f[132945]=f[132940];be(1715,531780,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=233257;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=948;f[b+24>>2]=1718;f[b+36>>2]=949;f[b+28>>2]=536;f[b+32>>2]=275;A1(b);f[132946]=f[132940];be(1715,531784,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=233270;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=950;f[b+24>>2]=1719;f[b+36>>2]=951;f[b+28>>2]=537;f[b+32>>2]=276;A1(b);f[132947]=f[132940];be(1715,531788,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=233284;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=952;f[b+24>>2]=1720;f[b+36>>2]=953;f[b+28>>2]=538;f[b+32>>2]=277;A1(b);f[132948]=f[132940];be(1715,531792,x|0)|0;u=a;return}function Q4(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1117323264;return b&1|0}function R4(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,19)|0;g=234686;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));n5(-27,d,235148,510)}else{f[a>>2]=0;u=c;return}}function S4(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b+8|0;d=b;f[d>>2]=0;f[d+4>>2]=1073741823;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];d=E7(a,c,0,1)|0;u=b;return d|0}function T4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+560|0;e=d+528|0;g=d+16|0;h=d+8|0;i=d;f[h>>2]=0;j=j1(a,c,233997)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)k=f[j+8+4>>2]|0;else k=0;j=j1(a,c,234933)|0;a:do if(!j)l=-1;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break a;break}case 2:{l=nrc(+p[j+8>>3])|0;break a;break}default:{l=2147483647;break a}}while(0);j=j1(a,c,233309)|0;if(!j){f[i>>2]=0;m=i+4|0;f[m>>2]=0;n=tT(i,48)|0;o=n;q=234939;r=o+48|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,i,234988,723)}if((f[j>>2]&7|0)!=3){f[i>>2]=0;m=i+4|0;f[m>>2]=0;n=tT(i,48)|0;o=n;q=234939;r=o+48|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,i,234988,723)}s=f[j+8+4>>2]|0;if(!((k|0)!=0&(l|0)!=-1&(s|0)!=0)){f[i>>2]=0;m=i+4|0;f[m>>2]=0;n=tT(i,48)|0;o=n;q=234939;r=o+48|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,i,234988,723)}do if(((b[k>>0]|0)+-48&255)<10){n=yrc(k,h,16)|0;if((n&-65536|0)==1117323264?(f[h>>2]|0)!=(k|0):0){t=n&33279|n<<2&16384|((n&3584|0)==512?1117327360:1117323264);break}else{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,30)|0;q=234414;r=o+30|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,i,234988,740)}}else{n=(Erc(k,234999)|0)==0;m=n?1117323264:1117327360;n=(Erc(k,235005)|0)==0;j=n?m:m|16384;m=(Erc(k,235012)|0)==0;n=m?j:j|32768;if(!(Erc(k,235017)|0))t=a9(s)|0|n;else t=n}while(0);k=j1(a,c,234066)|0;if((k|0)!=0?(f[k>>2]&7|0)==3:0)v=f[k+8+4>>2]|0;else v=0;k=j1(a,c,234184)|0;h=(v|0)!=0;n=(k|0)!=0;if(h^n){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,74)|0;q=234445;r=o+74|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,i,234988,774)}j=j1(a,c,466640)|0;m=j1(a,c,233708)|0;w=(j|0)!=0;x=(m|0)!=0;if(((w&1)+(n&1)+(x&1)|0)>>>0>1){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,66)|0;q=235025;r=o+66|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,i,234988,780)}if(h)y=_8(v,56)|0;else y=w?88:x?64:56;z=_8(s,0)|0;A=m7(t,y,z,f[a+20>>2]|0)|0;do if(n)if(h){z1(a,k,A+56|0,v);break}else{f[i>>2]=0;f[i+4>>2]=0;o=tT(i,9)|0;q=234066;r=o+9|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-215,i,234988,796)}else{if(!w){if(!x)break;z=j1(a,m,443329)|0;b:do if(!z)B=0;else switch(f[z>>2]&7){case 1:{B=f[z+8>>2]|0;break b;break}case 2:{B=nrc(+p[z+8>>3])|0;break b;break}default:{B=2147483647;break b}}while(0);f[A+56>>2]=B;z=j1(a,m,233745)|0;c:do if(!z)C=0;else switch(f[z>>2]&7){case 1:{C=f[z+8>>2]|0;break c;break}case 2:{C=nrc(+p[z+8>>3])|0;break c;break}default:{C=2147483647;break c}}while(0);f[A+60>>2]=C;break}z=j1(a,j,443329)|0;d:do if(!z)D=0;else switch(f[z>>2]&7){case 1:{D=f[z+8>>2]|0;break d;break}case 2:{D=nrc(+p[z+8>>3])|0;break d;break}default:{D=2147483647;break d}}while(0);f[A+56>>2]=D;z=j1(a,j,233745)|0;e:do if(!z)E=0;else switch(f[z>>2]&7){case 1:{E=f[z+8>>2]|0;break e;break}case 2:{E=nrc(+p[z+8>>3])|0;break e;break}default:{E=2147483647;break e}}while(0);f[A+60>>2]=E;z=j1(a,j,467281)|0;f:do if(!z)F=0;else switch(f[z>>2]&7){case 1:{F=f[z+8>>2]|0;break f;break}case 2:{F=nrc(+p[z+8>>3])|0;break f;break}default:{F=2147483647;break f}}while(0);f[A+64>>2]=F;z=j1(a,j,467287)|0;g:do if(!z)G=0;else switch(f[z>>2]&7){case 1:{G=f[z+8>>2]|0;break g;break}case 2:{G=nrc(+p[z+8>>3])|0;break g;break}default:{G=2147483647;break g}}while(0);f[A+68>>2]=G;z=j1(a,c,234170)|0;h:do if(!z)H=0;else switch(f[z>>2]&7){case 1:{H=f[z+8>>2]|0;break h;break}case 2:{H=nrc(+p[z+8>>3])|0;break h;break}default:{H=2147483647;break h}}while(0);f[A+72>>2]=H}while(0);C7(A,0,l,0);H=Z8(s,g,128)|0;G=H<<1;if((H|0)>0){H=0;j=0;while(1){F=(f[g+(H<<2)>>2]|0)+j|0;H=H+2|0;if((H|0)>=(G|0)){I=F;break}else j=F}}else I=0;j=j1(a,c,391200)|0;if(!j){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,43)|0;q=233846;r=o+43|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,i,234988,823)}c=f[j>>2]&7;if(c>>>0>4)J=f[(f[j+8>>2]|0)+24>>2]|0;else J=(c|0)!=0&1;if((J|0)!=(Y(I,l)|0)){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,55)|0;q=235092;r=o+55|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,i,234988,826)}x1(a,j,e);j=A+52|0;i=f[j>>2]|0;if(!i){u=d;return A|0}else K=i;while(1){i=Y(f[K+12>>2]|0,I)|0;y1(a,e,i,f[K+16>>2]|0,s);if((K|0)==(f[f[j>>2]>>2]|0)){L=76;break}K=f[K+4>>2]|0;if(!K){L=76;break}}if((L|0)==76){u=d;return A|0}return 0}function U4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e+24|0;j=e;k=m1(d,234901)|0;if((((k|0?Ioc(k,508558)|0:0)?Ioc(k,519047)|0:0)?Ioc(k,502801)|0:0)?Ioc(k,241503)|0:0){f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];q1(a,b,6,233202,g);f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];q1(a,234722,5,0,g);P7(h,c,2147483647);g=f[h>>2]|0;if(g|0){j=d+4|0;i=h+4|0;k=g;do{r5(a,0,k,f[d>>2]|0,f[j>>2]|0,f[i>>2]|0);Q7(h)|0;k=f[h>>2]|0}while((k|0)!=0)}r1(a);r1(a);u=e;return}r5(a,b,c,f[d>>2]|0,f[d+4>>2]|0,-1);u=e;return}function V4(a){a=a|0;B1(f[(f[a>>2]|0)+16>>2]|0);return}function W4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+48|0;e=d+8|0;g=d;h=j1(a,c,234722)|0;if(!h){f[g>>2]=0;i=g+4|0;f[i>>2]=0;j=tT(g,90)|0;k=j;l=234732;m=k+90|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));n5(-212,g,234823,856)}if((f[h>>2]&7|0)!=5){f[g>>2]=0;i=g+4|0;f[i>>2]=0;j=tT(g,90)|0;k=j;l=234732;m=k+90|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));n5(-212,g,234823,856)}j=f[h+8>>2]|0;h=f[j+24>>2]|0;r7(j,e,0);if((h|0)<=0){n=0;u=d;return n|0}i=e+12|0;c=j+28|0;j=e+20|0;o=0;q=0;r=0;s=0;t=0;v=0;while(1){w=f[i>>2]|0;x=s;s=k1(a,w,0)|0;if(!s){y=7;break}z=j1(a,w,234838)|0;if(!z){y=13;break}switch(f[z>>2]&7){case 1:{A=f[z+8>>2]|0;y=12;break}case 2:{A=nrc(+p[z+8>>3])|0;y=12;break}default:B=2147483647}if((y|0)==12){y=0;if((A|0)<0){y=13;break}else B=A}z=(o|0)==0;w=z?s:v;o=z?s:o;if((B|0)<=(r|0)){if((B|0)<(r|0)){z=r;C=x;while(1){D=f[C+16>>2]|0;if((z|0)>(B|0)){z=z+-1|0;C=D}else{E=D;F=C;break}}}else{E=q;F=x}f[s+8>>2]=F;if(!F)G=E;else{f[F+12>>2]=s;G=E}}else{if(x|0)f[x+20>>2]=s;f[s+8>>2]=0;G=x}f[s+16>>2]=G;C=(f[i>>2]|0)+(f[c>>2]|0)|0;f[i>>2]=C;if(C>>>0>=(f[j>>2]|0)>>>0)z7(e,1);t=t+1|0;if((t|0)>=(h|0)){n=w;y=25;break}else{q=G;r=B;v=w}}if((y|0)==7){f[g>>2]=0;f[g+4>>2]=0;v=tT(g,3)|0;b[v>>0]=b[247463]|0;b[v+1>>0]=b[247464]|0;b[v+2>>0]=b[247465]|0;n5(-215,g,234823,868)}else if((y|0)==13){f[g>>2]=0;f[g+4>>2]=0;k=tT(g,56)|0;l=234844;m=k+56|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));n5(-212,g,234823,871)}else if((y|0)==25){u=d;return n|0}return 0}function X4(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-53248|0)==1117261824;return b&1|0}function Y4(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,19)|0;g=234686;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));n5(-27,d,234706,912)}else{f[a>>2]=0;u=c;return}}function Z4(a){a=a|0;return N7(a,0)|0}function _4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;d=u;u=u+672|0;e=d;g=d+160|0;h=d+152|0;i=d+24|0;j=d+16|0;k=d+8|0;f[h>>2]=0;l=j1(a,c,233997)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)m=f[l+8+4>>2]|0;else m=0;l=j1(a,c,234016)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)n=f[l+8+4>>2]|0;else n=0;l=j1(a,c,234037)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)o=f[l+8+4>>2]|0;else o=0;l=j1(a,c,234003)|0;a:do if(!l)q=-1;else switch(f[l>>2]&7){case 1:{q=f[l+8>>2]|0;break a;break}case 2:{q=nrc(+p[l+8>>3])|0;break a;break}default:{q=2147483647;break a}}while(0);l=j1(a,c,234026)|0;b:do if(!l)r=-1;else switch(f[l>>2]&7){case 1:{r=f[l+8>>2]|0;break b;break}case 2:{r=nrc(+p[l+8>>3])|0;break b;break}default:{r=2147483647;break b}}while(0);if(!((o|0)!=0&(((m|0)==0|(q|0)==-1|(r|0)==-1)^1))){f[i>>2]=0;f[i+4>>2]=0;s=tT(i,45)|0;t=234355;v=s+45|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-2,i,234401,1087)}do if(Zqc(b[m>>0]|0)|0){l=yrc(m,h,16)|0;if((l&-65536|0)==1117257728?(f[h>>2]|0)!=(m|0):0){w=(l&4096|0)==0;break}else{f[i>>2]=0;f[i+4>>2]=0;s=tT(i,30)|0;t=234414;v=s+30|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-2,i,234401,1100)}}else w=(Erc(m,233988)|0)==0;while(0);m=w?1117261824:1117278208;w=j1(a,c,234066)|0;if((w|0)!=0?(f[w>>2]&7|0)==3:0)x=f[w+8+4>>2]|0;else x=0;w=j1(a,c,234184)|0;l=(x|0)!=0;y=(w|0)!=0;if(l^y){f[i>>2]=0;f[i+4>>2]=0;s=tT(i,74)|0;t=234445;v=s+74|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-2,i,234401,1115)}if(l)z=_8(x,68)|0;else z=68;A=(n|0)==0;if(!A){B=_8(n,0)|0;C=_8(n,8)|0;D=Z8(o,g,128)|0;E=D<<1;if((D|0)>0){D=0;F=0;while(1){G=(f[g+(F<<2)>>2]|0)+D|0;F=F+2|0;if((F|0)>=(E|0)){H=C;I=B;J=G;K=g;break}else D=G}}else{H=C;I=B;J=0;K=g}}else{H=8;I=0;J=0;K=g}B=Z8(o,K,128)|0;if(!((B|0)>1&(f[K>>2]|0)==2)){f[j>>2]=0;L=j+4|0;f[L>>2]=0;M=tT(j,52)|0;s=M;t=234520;v=s+52|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-5,j,234401,1141)}if((f[g+4>>2]|0)!=4){f[j>>2]=0;L=j+4|0;f[L>>2]=0;M=tT(j,52)|0;s=M;t=234520;v=s+52|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-5,j,234401,1141)}if((f[g+8>>2]|0)<1){f[j>>2]=0;L=j+4|0;f[L>>2]=0;M=tT(j,52)|0;s=M;t=234520;v=s+52|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-5,j,234401,1141)}if((f[g+12>>2]|0)!=5){f[j>>2]=0;L=j+4|0;f[L>>2]=0;M=tT(j,52)|0;s=M;t=234520;v=s+52|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-5,j,234401,1141)}if((B|0)>2){M=f[g+20>>2]|0;N=((M>>>3&511)+1<<(47696>>>(M<<1&14)&3)|0)>7?8:4}else N=4;M=B<<1;if((M|0)>2){B=2;L=2;while(1){K=(f[g+(B<<2)>>2]|0)+L|0;B=B+2|0;if((B|0)>=(M|0)){O=K;break}else L=K}}else O=2;L=o+2|0;M=b[L>>0]|0;switch(M<<24>>24){case 102:{P=47;break}case 49:{if((b[o+3>>0]|0)==102)P=47;else P=48;break}default:P=48}if((P|0)==47)Q=o+3+((M+-48&255)<10&1)|0;else if((P|0)==48){M=(yrc(L,h,10)|0)+-1|0;L=f[h>>2]|0;f[e>>2]=M;f[e+4>>2]=L;Aqc(i,234573,e)|0;Q=i}e=_8(Q,24)|0;Q=_8(o,0)|0;L=J7(m,z,H,e,f[a+20>>2]|0)|0;do if(y)if(l){z1(a,w,L+68|0,x);break}else{f[i>>2]=0;f[i+4>>2]=0;s=tT(i,9)|0;t=234066;v=s+9|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-215,i,234401,1168)}while(0);x=I*3|0;w=(x|0)>65536?x:65536;x=Q*3|0;l=(x|0)<(w|0)?w:x;x=h0(l)|0;w=h0(q<<2)|0;y=j1(a,c,234051)|0;z=j1(a,c,234060)|0;if(!z){f[i>>2]=0;f[i+4>>2]=0;s=tT(i,13)|0;t=234579;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-5,i,234401,1180)}if(!(A|(y|0)!=0)){f[i>>2]=0;f[i+4>>2]=0;s=tT(i,16)|0;t=234593;v=s+16|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-5,i,234401,1182)}A=N+-1|0;c=0-N|0;N=0;c:while(1){m=(N|0)==0;M=m?n:o;h=m?H:e;B=m?I:Q;g=m?J:O;K=m?q:r;C=(l>>>0)/(((B|0)>1?B:1)>>>0)|0;D=(M|0)!=0;if(D)x1(a,m?y:z,i);d:do if((K|0)>0){E=(h|0)>24;F=h+-24|0;if(D){R=0;S=x;T=0}else{G=x;U=0;while(1){if(!m){f[j>>2]=0;V=f[G>>2]|0;W=f[G+4>>2]|0;if(!(V>>>0<q>>>0&W>>>0<q>>>0)){P=75;break c}if(!(M7(L,f[w+(V<<2)>>2]|0,f[w+(W<<2)>>2]|0,0,j)|0)){P=77;break c}W=f[j>>2]|0;f[W+4>>2]=f[G+8>>2];if(E)dJc(W+24|0,A+(G+12)&c|0,F|0)|0}else{K7(L,0,j)|0;f[w+(U<<2)>>2]=f[j>>2]}U=U+1|0;if((K|0)<=(U|0))break d;else G=G+B|0}}while(1){G=K-T|0;U=Y((G|0)>(C|0)?C:G,g)|0;if(!R){y1(a,i,U,x,M);X=U;Z=x}else{X=R;Z=S}if(!m){f[j>>2]=0;U=f[Z>>2]|0;G=f[Z+4>>2]|0;if(!(U>>>0<q>>>0&G>>>0<q>>>0)){P=75;break c}if(!(M7(L,f[w+(U<<2)>>2]|0,f[w+(G<<2)>>2]|0,0,j)|0)){P=77;break c}G=f[j>>2]|0;f[G+4>>2]=f[Z+8>>2];if(E)dJc(G+24|0,A+(Z+12)&c|0,F|0)|0}else{K7(L,0,j)|0;f[w+(T<<2)>>2]=f[j>>2];dJc((f[j>>2]|0)+8|0,Z|0,B|0)|0}T=T+1|0;if((K|0)<=(T|0))break;else{R=X+-1|0;S=Z+B|0}}}while(0);N=N+1|0;if((N|0)>=2){P=83;break}}if((P|0)==75){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,46)|0;t=234610;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-211,k,234401,1227)}else if((P|0)==77){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,28)|0;t=234657;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));n5(-5,k,234401,1233)}else if((P|0)==83){i0(x);i0(w);u=d;return L|0}return 0}function $4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+960|0;g=e+56|0;h=e;i=e+24|0;j=e+824|0;k=e+696|0;l=e+568|0;m=e+16|0;n=e+8|0;o=f[c+60>>2]|0;p=c+64|0;q=f[(f[p>>2]|0)+60>>2]|0;r=h0(o<<2)|0;r7(c,i,0);s=c+24|0;if((f[s>>2]|0)>0){t=i+12|0;v=c+28|0;w=i+20|0;x=0;y=0;while(1){z=f[t>>2]|0;A=f[z>>2]|0;if((A|0)>-1){f[r+(x<<2)>>2]=A;f[z>>2]=x;B=x+1|0}else B=x;A=z+(f[v>>2]|0)|0;f[t>>2]=A;if(A>>>0>=(f[w>>2]|0)>>>0)z7(i,1);y=y+1|0;if((y|0)>=(f[s>>2]|0))break;else x=B}}f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];q1(a,b,6,233223,g);u1(a,233997,f[c>>2]&16384|0?233988:1154740,1);s1(a,234003,o);o=p5(c,234016,d,8,k)|0;if(o|0)u1(a,234016,o,0);s1(a,234026,q);q=p5(f[p>>2]|0,234037,d,24,j)|0;f[h>>2]=q|0?q:1154740;Aqc(l,234045,h)|0;u1(a,234037,l,0);q5(a,c,d,68);d=c+28|0;h=(f[d>>2]|0)*3|0;q=(h|0)>65536?h:65536;h=(f[(f[p>>2]|0)+28>>2]|0)*3|0;j=(h|0)<(q|0)?q:h;h=h0(j)|0;q=g+20|0;k=n+4|0;b=i+12|0;m=i+20|0;B=0;do{x=(B|0)==0;y=x?o:l;if(y|0){if(x)C=c;else C=f[p>>2]|0;w=C+28|0;t=f[w>>2]|0;v=_8(y,0)|0;A=(j|0)/(v|0)|0;if((B|0)==1){if((Z8(y,g,128)|0)>2){z=f[q>>2]|0;D=((z>>>3&511)+1<<(47696>>>(z<<1&14)&3)|0)>7?8:4}else D=4;E=D}else E=4;f[n>>2]=0;f[k>>2]=0;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];q1(a,x?234051:234060,13,0,g);r7(C,i,0);z=C+24|0;if((f[z>>2]|0)>0){F=t+-24|0;G=E+-1|0;H=0-E|0;if(!x)if((t|0)>24){t=0;x=h;I=0;while(1){J=f[b>>2]|0;if((f[J>>2]|0)>-1){K=x+3&-4;L=K;f[K>>2]=f[f[J+16>>2]>>2];f[L+4>>2]=f[f[J+20>>2]>>2];f[L+8>>2]=f[J+4>>2];dJc(G+(L+12)&H|0,J+24|0,F|0)|0;J=t+1|0;if((J|0)<(A|0)){M=J;N=L+v|0}else{w1(a,h,J,y);M=0;N=h}}else{M=t;N=x}J=(f[b>>2]|0)+(f[w>>2]|0)|0;f[b>>2]=J;if(J>>>0>=(f[m>>2]|0)>>>0)z7(i,1);I=I+1|0;if((I|0)>=(f[z>>2]|0)){O=M;break}else{t=M;x=N}}}else{x=0;t=h;I=0;while(1){F=f[b>>2]|0;if((f[F>>2]|0)>-1){H=t+3&-4;G=H;f[H>>2]=f[f[F+16>>2]>>2];f[G+4>>2]=f[f[F+20>>2]>>2];f[G+8>>2]=f[F+4>>2];H=x+1|0;if((H|0)<(A|0)){P=H;Q=G+v|0;R=F}else{w1(a,h,H,y);P=0;Q=h;R=f[b>>2]|0}}else{P=x;Q=t;R=F}F=R+(f[w>>2]|0)|0;f[b>>2]=F;if(F>>>0>=(f[m>>2]|0)>>>0)z7(i,1);I=I+1|0;if((I|0)>=(f[z>>2]|0)){O=P;break}else{x=P;t=Q}}}else{t=0;x=h;I=0;while(1){F=f[b>>2]|0;if((f[F>>2]|0)>-1){dJc(x|0,F+8|0,v|0)|0;F=t+1|0;if((F|0)<(A|0)){S=F;T=x+v|0}else{w1(a,h,F,y);S=0;T=h}}else{S=t;T=x}F=(f[b>>2]|0)+(f[w>>2]|0)|0;f[b>>2]=F;if(F>>>0>=(f[m>>2]|0)>>>0)z7(i,1);I=I+1|0;if((I|0)>=(f[z>>2]|0)){O=S;break}else{t=S;x=T}}}if((O|0)>0)w1(a,h,O,y)}r1(a)}B=B+1|0}while((B|0)!=2);r1(a);r7(c,i,0);c=f[s>>2]|0;if((c|0)>0){U=0;V=0;W=c}else{i0(h);i0(r);u=e;return}while(1){c=f[b>>2]|0;if((f[c>>2]|0)>-1){f[c>>2]=f[r+(U<<2)>>2];X=U+1|0}else X=U;a=c+(f[d>>2]|0)|0;f[b>>2]=a;if(a>>>0<(f[m>>2]|0)>>>0)Y=W;else{z7(i,1);Y=f[s>>2]|0}V=V+1|0;if((V|0)>=(Y|0))break;else{U=X;W=Y}}i0(h);i0(r);u=e;return}function a5(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1111752704;return b&1|0}function b5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+304|0;e=d+264|0;g=d+136|0;h=d+8|0;i=d;j=j1(a,c,233301)|0;k=j1(a,c,233309)|0;if(!k){f[h>>2]=0;l=h+4|0;f[l>>2]=0;m=tT(h,46)|0;n=m;o=233312;p=n+46|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-2,h,233890,312)}if((f[k>>2]&7|0)!=3){f[h>>2]=0;l=h+4|0;f[l>>2]=0;m=tT(h,46)|0;n=m;o=233312;p=n+46|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-2,h,233890,312)}q=f[k+8+4>>2]|0;if(!((j|0)!=0&(q|0)!=0)){f[h>>2]=0;l=h+4|0;f[l>>2]=0;m=tT(h,46)|0;n=m;o=233312;p=n+46|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-2,h,233890,312)}m=f[j>>2]&7;if((m|0)==5)r=f[(f[j+8>>2]|0)+24>>2]|0;else r=(m|0)==1?1:-1;m=r+-1|0;if(m>>>0>31){f[h>>2]=0;f[h+4>>2]=0;n=tT(h,48)|0;o=233907;p=n+48|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-212,h,233890,318)}z1(a,j,g,233307);j=a9(q)|0;l=j1(a,c,391200)|0;if(!l){f[h>>2]=0;s=h+4|0;f[s>>2]=0;t=tT(h,44)|0;n=t;o=233418;p=n+44|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-2,h,233890,325)}if((f[l>>2]&7|0)!=5){f[h>>2]=0;s=h+4|0;f[s>>2]=0;t=tT(h,44)|0;n=t;o=233418;p=n+44|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-2,h,233890,325)}t=I0(r,g,j)|0;g=j>>>3&511;j=g+1|0;s=f[l+8>>2]|0;x1(a,l,e);l=s+24|0;if((f[l>>2]|0)<=0){v=t;u=d;return v|0}c=e+12|0;k=h+(m<<2)|0;w=s+28|0;s=e+20|0;x=g+2|0;g=0;a:while(1){y=f[c>>2]|0;if((f[y>>2]&7|0)!=1){z=17;break}A=f[y+8>>2]|0;B=(g|0)>0;if(!(B&(A|0)>-1)){if(B)C=m+A|0;else{f[h>>2]=A;C=1}if((C|0)<(r|0)){B=C;D=g;E=y;while(1){F=E+(f[w>>2]|0)|0;f[c>>2]=F;if(F>>>0<(f[s>>2]|0)>>>0){G=F;H=F}else{z7(e,1);F=f[c>>2]|0;G=F;H=F}F=D+1|0;if((f[G>>2]&7|0)!=1){z=28;break a}I=f[G+8>>2]|0;if((I|0)<0){z=28;break a}f[h+(B<<2)>>2]=I;B=B+1|0;if((B|0)>=(r|0)){J=F;K=H;break}else{D=F;E=G}}}else{J=g;K=y}}else{f[k>>2]=A;J=g;K=y}E=K+(f[w>>2]|0)|0;f[c>>2]=E;if(E>>>0>=(f[s>>2]|0)>>>0)z7(e,1);y1(a,e,j,S0(t,h,0,1,0)|0,q);g=x+J|0;if((g|0)>=(f[l>>2]|0)){v=t;z=33;break}}if((z|0)==17){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,31)|0;o=233956;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-212,i,233890,340)}else if((z|0)==28){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,31)|0;o=233956;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-212,i,233890,356)}else if((z|0)==33){u=d;return v|0}return 0}function c5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+112|0;e=d+80|0;g=d+76|0;i=d+64|0;j=d+32|0;k=d+16|0;l=d+88|0;m=d+24|0;n=d+8|0;o=d;p=c7(0)|0;f[g>>2]=p;f[m>>2]=0;f[m+4>>2]=0;f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];q1(a,b,6,233236,e);b=Q0(c,0)|0;f[k>>2]=b;f[n>>2]=0;f[n+4>>2]=0;f[e>>2]=f[n>>2];f[e+4>>2]=f[n+4>>2];q1(a,233301,13,0,e);w1(a,c+36|0,b,233307);r1(a);u1(a,233309,Y8(f[c>>2]&4095,l)|0,0);f[o>>2]=0;f[o+4>>2]=0;f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];q1(a,391200,13,0,e);o=m7(7,56,4,p)|0;p=L0(c,i)|0;if(p|0){b=c+32|0;n=i+4|0;m=i+8|0;q=p;a:while(1){f[e>>2]=q+(f[b>>2]|0);A7(o,e)|0;p=f[(f[n>>2]|0)+4>>2]|0;if(!p){r=(f[m>>2]|0)+1|0;f[m>>2]=r;s=f[i>>2]|0;t=f[s+24>>2]|0;if((r|0)>=(t|0))break;v=f[s+20>>2]|0;s=r;while(1){w=f[v+(s<<2)>>2]|0;if(w|0)break;r=s+1|0;if((r|0)<(t|0))s=r;else break a}f[m>>2]=s;x=w}else x=p;f[n>>2]=x;q=x}}F7(o,307,k);r7(o,j,0);x=o+24|0;if((f[x>>2]|0)<=0){r1(a);r1(a);f7(g);u=d;return}o=j+12|0;q=j+20|0;n=c+32|0;w=c+28|0;c=a+236|0;m=0;i=0;do{e=f[o>>2]|0;b=i;i=h[e>>0]|h[e+1>>0]<<8|h[e+2>>0]<<16|h[e+3>>0]<<24;t=e+4|0;f[o>>2]=t;if(t>>>0>=(f[q>>2]|0)>>>0)z7(j,1);if((m|0)>0){t=0;while(1){y=t+1|0;if((f[i+(t<<2)>>2]|0)==(f[b+(t<<2)>>2]|0))t=y;else break}b=f[k>>2]|0;if((t|0)<(b+-1|0)){Ti[f[c>>2]&511](a,0,y-b|0);z=t}else z=t}else z=0;if((z|0)<(f[k>>2]|0)){b=z;do{Ti[f[c>>2]&511](a,0,f[i+(b<<2)>>2]|0);b=b+1|0}while((b|0)<(f[k>>2]|0))}w1(a,i+(0-(f[n>>2]|0))+(f[w>>2]|0)|0,1,l);m=m+1|0}while((m|0)<(f[x>>2]|0));r1(a);r1(a);f7(g);u=d;return}function d5(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]|0)==112;return b&1|0}function e5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+80|0;e=d+56|0;g=d+16|0;h=d+48|0;i=d;j=j1(a,c,467281)|0;a:do if(!j)k=0;else switch(f[j>>2]&7){case 1:{k=f[j+8>>2]|0;break a;break}case 2:{k=nrc(+p[j+8>>3])|0;break a;break}default:{k=2147483647;break a}}while(0);j=j1(a,c,467287)|0;b:do if(!j)l=0;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break b;break}case 2:{l=nrc(+p[j+8>>3])|0;break b;break}default:{l=2147483647;break b}}while(0);j=j1(a,c,233309)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)m=f[j+8+4>>2]|0;else m=0;j=j1(a,c,233708)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)n=f[j+8+4>>2]|0;else n=0;if((k|0)==0|(l|0)==0|(m|0)==0|(n|0)==0){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,45)|0;q=233751;r=o+45|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,e,233797,448)}n=a9(m)|0;j=j1(a,c,233734)|0;if(j){if((f[j>>2]&7|0)!=3){f[e>>2]=0;s=e+4|0;f[s>>2]=0;t=tT(e,35)|0;o=t;q=233810;r=o+35|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,e,233797,453)}v=f[j+8+4>>2]|0;if(!v){f[e>>2]=0;s=e+4|0;f[s>>2]=0;t=tT(e,35)|0;o=t;q=233810;r=o+35|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,e,233797,453)}else w=v}else w=233722;if(Ioc(w,233722)|0){f[e>>2]=0;s=e+4|0;f[s>>2]=0;t=tT(e,35)|0;o=t;q=233810;r=o+35|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,e,233797,453)}t=j1(a,c,391200)|0;if(!t){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,43)|0;q=233846;r=o+43|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-2,e,233797,457)}s=f[t>>2]&7;if(s>>>0>4)x=f[(f[t+8>>2]|0)+24>>2]|0;else x=(s|0)!=0&1;s=Y(l,k)|0;w=(n>>>3&511)+1|0;if((x|0)!=(Y(w,s)|0)){f[e>>2]=0;f[e+4>>2]=0;o=tT(e,63)|0;q=233463;r=o+63|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));n5(-209,e,233797,461)}q=n&7;f[h>>2]=k;f[h+4>>2]=l;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];h=V0(e,1212424721>>>(q<<2)<<3&120|((q|0)==4|(q|2|0)==3?-2147483648:0),w)|0;q=j1(a,c,233741)|0;if(q|0){c=j1(a,q,443329)|0;c:do if(!c)y=0;else switch(f[c>>2]&7){case 1:{y=f[c+8>>2]|0;break c;break}case 2:{y=nrc(+p[c+8>>3])|0;break c;break}default:{y=2147483647;break c}}while(0);c=j1(a,q,233745)|0;d:do if(!c)z=0;else switch(f[c>>2]&7){case 1:{z=f[c+8>>2]|0;break d;break}case 2:{z=nrc(+p[c+8>>3])|0;break d;break}default:{z=2147483647;break d}}while(0);c=j1(a,q,467281)|0;e:do if(!c)A=0;else switch(f[c>>2]&7){case 1:{A=f[c+8>>2]|0;break e;break}case 2:{A=nrc(+p[c+8>>3])|0;break e;break}default:{A=2147483647;break e}}while(0);c=j1(a,q,467287)|0;f:do if(!c)B=0;else switch(f[c>>2]&7){case 1:{B=f[c+8>>2]|0;break f;break}case 2:{B=nrc(+p[c+8>>3])|0;break f;break}default:{B=2147483647;break f}}while(0);c=j1(a,q,233747)|0;g:do if(!c)C=0;else switch(f[c>>2]&7){case 1:{C=f[c+8>>2]|0;break g;break}case 2:{C=nrc(+p[c+8>>3])|0;break g;break}default:{C=2147483647;break g}}while(0);f[i>>2]=y;f[i+4>>2]=z;f[i+8>>2]=A;f[i+12>>2]=B;f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];X0(h,e);Y0(h,C)}C=Y(w<<(47696>>>(n<<1&14)&3),k)|0;n=h+72|0;e=(C|0)==(f[n>>2]|0);C=e?1:l;l=Y(e?s:k,w)|0;x1(a,t,g);if((C|0)<=0){u=d;return h|0}t=h+68|0;w=0;do{y1(a,g,l,(f[t>>2]|0)+(Y(f[n>>2]|0,w)|0)|0,m);w=w+1|0}while((w|0)!=(C|0));u=d;return h|0}function f5(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e+32|0;h=e;i=e+40|0;j=e+24|0;k=e+16|0;l=e+8|0;m=d+28|0;if((f[m>>2]|0)==1){f[g>>2]=0;f[g+4>>2]=0;n=tT(g,48)|0;o=233624;p=n+48|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-210,g,233673,390)}f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];q1(a,c,6,233257,g);c=d+40|0;s1(a,467281,f[c>>2]|0);j=d+44|0;s1(a,467287,f[j>>2]|0);u1(a,233708,(f[d+32>>2]|0)==0?233687:233696,0);u1(a,233734,(f[m>>2]|0)==1?233715:233722,0);m=d+48|0;if(f[m>>2]|0){f[k>>2]=0;f[k+4>>2]=0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];q1(a,233741,14,0,g);s1(a,443329,f[(f[m>>2]|0)+4>>2]|0);s1(a,233745,f[(f[m>>2]|0)+8>>2]|0);s1(a,467281,f[(f[m>>2]|0)+12>>2]|0);s1(a,467287,f[(f[m>>2]|0)+16>>2]|0);s1(a,233747,f[f[m>>2]>>2]|0);r1(a)}m=f[d+16>>2]|0;k=1125516576>>>((m>>>2&60)+(m>>31&20)|0);m=d+8|0;o=f[m>>2]|0;n=(X8(k&7)|0)<<24>>24;f[h>>2]=o;f[h+4>>2]=n;Aqc(i,246939,h)|0;h=i+((b[i+2>>0]|0)==0&(b[i>>0]|0)==49&1)|0;u1(a,233309,h,0);i=f[c>>2]|0;c=f[j>>2]|0;j=(Y(f[m>>2]|0,i)|0)<<(47696>>>(k<<1&14)&3);k=d+72|0;m=(j|0)==(f[k>>2]|0);j=Y(m?c:1,i)|0;i=m?1:c;f[l>>2]=0;f[l+4>>2]=0;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];q1(a,391200,13,0,g);if((i|0)<=0){r1(a);r1(a);u=e;return}g=d+68|0;d=0;do{w1(a,(f[g>>2]|0)+(Y(f[k>>2]|0,d)|0)|0,j,h);d=d+1|0}while((d|0)!=(i|0));r1(a);r1(a);u=e;return}function g5(a){a=a|0;var b=0;if(((a|0)!=0?(f[a>>2]&-65536|0)==1111621632:0)?(f[a+24>>2]|0)>-1:0)b=(f[a+20>>2]|0)>-1;else b=0;return b&1|0}function h5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;d=u;u=u+16|0;e=d;g=j1(a,c,233603)|0;a:do if(!g)h=-1;else switch(f[g>>2]&7){case 1:{h=f[g+8>>2]|0;break a;break}case 2:{h=nrc(+p[g+8>>3])|0;break a;break}default:{h=2147483647;break a}}while(0);g=j1(a,c,233608)|0;b:do if(!g)i=-1;else switch(f[g>>2]&7){case 1:{i=f[g+8>>2]|0;break b;break}case 2:{i=nrc(+p[g+8>>3])|0;break b;break}default:{i=2147483647;break b}}while(0);g=j1(a,c,233309)|0;if((g|0?(f[g>>2]&7|0)==3:0)?(j=f[g+8+4>>2]|0,(i|h|0)>-1&(j|0)!=0):0){g=a9(j)|0;k=j1(a,c,391200)|0;if(!k){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,44)|0;m=233418;n=l+44|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));n5(-2,e,233613,88)}c=f[k>>2]&7;if(c>>>0>4)o=f[(f[k+8>>2]|0)+24>>2]|0;else o=(c|0)!=0&1;if((o|0)<=0){q=v0(h,i,g)|0;u=d;return q|0}if((o|0)!=(Y(Y(i,h)|0,(g>>>3&511)+1|0)|0)){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,63)|0;m=233463;n=l+63|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));n5(-209,e,233613,93)}o=u0(h,i,g)|0;z1(a,k,f[o+16>>2]|0,j);q=o;u=d;return q|0}f[e>>2]=0;f[e+4>>2]=0;l=tT(e,46)|0;m=233312;n=l+46|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));n5(-2,e,233613,82);return 0}function i5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+24|0;g=d+32|0;h=d+16|0;i=d+8|0;j=d;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];q1(a,b,6,233270,e);s1(a,233603,f[c+20>>2]|0);s1(a,233608,f[c+24>>2]|0);u1(a,233309,Y8(f[c>>2]&4095,g)|0,0);f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];q1(a,391200,13,0,e);R0(j,c);e=f[j>>2]|0;i=f[j+4>>2]|0;if(!((e|0)>0&(i|0)>0)){r1(a);r1(a);u=d;return}j=c+16|0;b=f[j>>2]|0;if(!b){r1(a);r1(a);u=d;return}h=(f[c>>2]&16384|0)==0;k=Y(h?1:i,e)|0;e=h?i:1;if((e|0)<=0){r1(a);r1(a);u=d;return}i=c+4|0;w1(a,b,k,g);if((e|0)==1){r1(a);r1(a);u=d;return}else l=1;do{w1(a,(f[j>>2]|0)+(Y(f[i>>2]|0,l)|0)|0,k,g);l=l+1|0}while((l|0)!=(e|0));r1(a);r1(a);u=d;return}function j5(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1111687168;return b&1|0}function k5(a){a=a|0;y0(a);return}function l5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+144|0;e=d+8|0;g=d;h=e;i=h+128|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));j=j1(a,c,233301)|0;k=j1(a,c,233309)|0;if(!k){f[g>>2]=0;l=g+4|0;f[l>>2]=0;m=tT(g,46)|0;h=m;n=233312;i=h+46|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));n5(-2,g,233359,161)}if((f[k>>2]&7|0)!=3){f[g>>2]=0;l=g+4|0;f[l>>2]=0;m=tT(g,46)|0;h=m;n=233312;i=h+46|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));n5(-2,g,233359,161)}o=f[k+8+4>>2]|0;if(!((j|0)!=0&(o|0)!=0)){f[g>>2]=0;l=g+4|0;f[l>>2]=0;m=tT(g,46)|0;h=m;n=233312;i=h+46|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));n5(-2,g,233359,161)}m=f[j>>2]&7;if((m|0)==5)p=f[(f[j+8>>2]|0)+24>>2]|0;else p=(m|0)==1?1:-1;if((p+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,45)|0;n=233372;i=h+45|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));n5(-212,g,233359,167)}z1(a,j,e,233307);j=a9(o)|0;m=j1(a,c,391200)|0;if(!m){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,44)|0;n=233418;i=h+44|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));n5(-2,g,233359,174)}c=(j>>>3&511)+1|0;l=0;do{k=f[e+(l<<2)>>2]|0;if(!k){q=14;break}c=Y(k,c)|0;l=l+1|0}while((l|0)<(p|0));if((q|0)==14){f[g>>2]=0;f[g+4>>2]=0;q=tT(g,8)|0;l=q;b[l>>0]=115;b[l+1>>0]=105;b[l+2>>0]=122;b[l+3>>0]=101;l=q+4|0;b[l>>0]=115;b[l+1>>0]=91;b[l+2>>0]=105;b[l+3>>0]=93;n5(-215,g,233359,180)}l=f[m>>2]&7;if(l>>>0>4)r=f[(f[m+8>>2]|0)+24>>2]|0;else r=(l|0)!=0&1;l=(r|0)>0;if(!((r|0)==(c|0)|l^1)){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,63)|0;n=233463;i=h+63|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));n5(-209,g,233359,188)}if(l){l=B0(p,e,j)|0;z1(a,m,f[l+16>>2]|0,o);s=l;u=d;return s|0}else{s=C0(p,e,j)|0;u=d;return s|0}return 0}
function Nj(a){a=a|0;var b=0;b=u;u=u+a|0;u=u+15&-16;return b|0}function Oj(){return u|0}function Pj(a){a=a|0;u=a}function Qj(a,b){a=a|0;b=b|0;u=a;v=b}function Rj(a,b){a=a|0;b=b|0;if(!y){y=a;z=b}}function Sj(a){a=a|0;J=a}function Tj(){return J|0}function Uj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=VDc(56)|0;Vj(f,a,b,c,d,e);return f|0}function Vj(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+16|0;j=i;f[a>>2]=e&4095|1124007936;f[a+4>>2]=2;k=a+8|0;f[k>>2]=c;f[a+12>>2]=d;f[a+16>>2]=g;f[a+20>>2]=g;l=a+24|0;m=a+28|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[a+40>>2]=k;k=a+48|0;f[a+44>>2]=k;f[a+52>>2]=0;f[k>>2]=0;if((Y(d,c)|0)!=0&(g|0)==0){f[j>>2]=0;f[j+4>>2]=0;n=tT(j,28)|0;o=271702;p=n+28|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Ov(-215,j,579)}q=e&7;r=(e>>>3&511)+1<<(47696>>>(q<<1)&3);e=Y(r,d)|0;if(!h){s=e;f[k>>2]=s;t=a+52|0;f[t>>2]=r;v=Y(s,c)|0;w=g+v|0;f[m>>2]=w;x=0-s|0;y=w+x|0;z=y+e|0;f[l>>2]=z;WS(a);u=i;return}if(!((h>>>0)%((1212424721>>>(q<<2)&15)>>>0)|0)){s=h;f[k>>2]=s;t=a+52|0;f[t>>2]=r;v=Y(s,c)|0;w=g+v|0;f[m>>2]=w;x=0-s|0;y=w+x|0;z=y+e|0;f[l>>2]=z;WS(a);u=i;return}else{f[j>>2]=0;f[j+4>>2]=0;n=tT(j,31)|0;o=219387;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));Ov(-13,j,592)}}function Wj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;LZ(a,h,c,d,e);u=g;return}function Xj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;LZ(a,e,c,1.0,0.0);u=d;return}function Yj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;LZ(a,g,c,d,0.0);u=e;return}function Zj(a,b){a=a|0;b=b|0;var c=0;c=f[b+40>>2]|0;b=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=b;return}function _j(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;AY(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;ei[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);$j(g);u=e;return}function $j(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+120|0;c=a+156|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+136|0;b=a+124|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+160>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+164>>2]|0;if((b|0)!=(a+168|0))g0(b);b=a+64|0;d=a+100|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+80|0;b=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+104>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+108>>2]|0;if((b|0)!=(a+112|0))g0(b);b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;g0(b);return}function ak(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];DY(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);$j(e);u=d;return}function bk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;EY(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;ei[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);$j(g);u=e;return}function ck(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];FY(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);$j(e);u=d;return}function dk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;e=+zO(a,d);u=c;return +e}function ek(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+240|0;g=e;h=e+224|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;zY(g,b,h,d);f[a>>2]=1124007936;h=a+8|0;b=a+40|0;c=a+4|0;i=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(i|0));f[b>>2]=h;h=a+48|0;f[a+44>>2]=h;f[h>>2]=0;f[a+52>>2]=0;h=f[g>>2]|0;ei[f[(f[h>>2]|0)+12>>2]&511](h,g,a,-1);$j(g);u=e;return}function fk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+224|0;d=c;xY(d,b);f[a>>2]=1124007936;b=a+8|0;e=a+40|0;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=b;b=a+48|0;f[a+44>>2]=b;f[b>>2]=0;f[a+52>>2]=0;b=f[d>>2]|0;ei[f[(f[b>>2]|0)+12>>2]&511](b,d,a,-1);$j(d);u=c;return}function gk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+224|0;e=d;yY(e,b,c);f[a>>2]=1124007936;c=a+8|0;b=a+40|0;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[b>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);$j(e);u=d;return}function hk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;h_(a,d);u=c;return}function ik(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;j_(a,e,g);u=d;return}function jk(a,b,c){a=a|0;b=b|0;c=c|0;gT(a,b,c);return}function kk(a,b){a=a|0;b=b|0;gT(a,b,0);return}function lk(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=-1056833530;f[d+4>>2]=b;f[d+8>>2]=1;f[d+12>>2]=4;l_(a,d,e0()|0)|0;u=c;return}function mk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e>>2]=-1056833530;f[e+4>>2]=b;f[e+8>>2]=1;f[e+12>>2]=4;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;l_(a,e,g)|0;u=d;return}function nk(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;JO(b,d);b=Lf()|0;f[a>>2]=b;Qv(b,190186,d);Qv(b,190186,d+8|0);Qv(b,190186,d+16|0);Qv(b,190186,d+24|0);u=c;return}function ok(a,b){a=a|0;b=b|0;KO(a,b);return}function pk(a,b){a=a|0;b=b|0;LO(a,b);return}function qk(a){a=a|0;return a&7|0}function rk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;ET(e,a,a+8|0,a+16|0,a+24|0,g);u=d;return}function sk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;ET(d,a,a+8|0,a+16|0,a+24|0,e0()|0);u=c;return}function tk(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;n[a>>2]=0.0;n[a+4>>2]=0.0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;Kxa(d,a,a+8|0);u=c;return}function uk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+64|0;g=e;h=e+32|0;i=e+16|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];fDa(h,i,c,g);g=Lf()|0;f[a>>2]=g;Rv(g,190186,h);Sv(g,190186,c);u=e;return}function vk(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g;i=g+16|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];e=dDa(i,d,h)|0;i=Lf()|0;f[a>>2]=i;if((b[519768]|0)==0?MIc(519768)|0:0){c=Af(2,23960)|0;f[132507]=c}c=f[132507]|0;f[h>>2]=e;Ed(c|0,i|0,190186,h|0);Sv(f[a>>2]|0,190186,d);u=g;return}function wk(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=f[c+4>>2]|0;e=f[c+8>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(e>>>0>4294967279)dEc(a);if(e>>>0<11){b[a+11>>0]=e;if(!e){g=a;h=g+e|0;b[h>>0]=0;return}else i=a}else{c=e+16&-16;j=VDc(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=e;i=j}dJc(i|0,d|0,e|0)|0;g=i;h=g+e|0;b[h>>0]=0;return}function xk(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=a+4|0;uT(d);a=c+11|0;e=b[a>>0]|0;g=e<<24>>24<0?f[c+4>>2]|0:e&255;if(!g)return;e=tT(d,g)|0;dJc(e|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,g|0)|0;return}function yk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=b;f[a>>2]=46284;b=f[c+4>>2]|0;f[a+4>>2]=b;f[a+8>>2]=f[c+8>>2];if(b|0){d=b+-4|0;f[d>>2]=(f[d>>2]|0)+1}f[a+12>>2]=f[c+12>>2];d=f[c+16>>2]|0;f[a+16>>2]=d;f[a+20>>2]=f[c+20>>2];if(d|0){b=d+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c+24>>2]|0;f[a+24>>2]=b;f[a+28>>2]=f[c+28>>2];if(b|0){d=b+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[c+32>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[c+36>>2];if(!d){e=a+40|0;g=c+40|0;h=f[g>>2]|0;f[e>>2]=h;return}b=d+-4|0;f[b>>2]=(f[b>>2]|0)+1;e=a+40|0;g=c+40|0;h=f[g>>2]|0;f[e>>2]=h;return}function zk(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=i6()|0;d=f[c>>2]|0;e=f[c+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(e>>>0>4294967279)dEc(a);if(e>>>0<11){b[a+11>>0]=e;if(!e){g=a;h=g+e|0;b[h>>0]=0;return}else i=a}else{c=e+16&-16;j=VDc(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=e;i=j}dJc(i|0,d|0,e|0)|0;g=i;h=g+e|0;b[h>>0]=0;return}function Ak(a){a=a|0;var b=0;Bk(190191);Ck(190201);Dk(190213);Ek(190226);Fk(190238);Gk(190248);Hk(190259);Ce(4608,4784,4800,0,205334,817,205337,0,205337,0,271731,205339,1636);ae(4608,1,24444,205334,818,1);ae(4608,2,24448,205353,420,819);ae(4608,3,24456,205376,247,421);ae(4608,4,24468,205381,46,248);ae(4608,5,24484,206710,92,47);ae(4608,6,24504,206717,70,93);Yf(4608,190274,3,24528,205376,249,186);Yf(4608,190274,4,24540,205381,48,164);Yf(4608,190278,3,24528,205376,249,187);Yf(4608,190278,4,24540,205381,48,165);Yf(4608,190283,3,24528,205376,249,188);Yf(4608,190283,4,24540,205381,48,166);a=VDc(4)|0;f[a>>2]=8;b=VDc(4)|0;f[b>>2]=8;we(4608,233603,23856,205353,422,a|0,23856,205342,189,b|0);b=VDc(4)|0;f[b>>2]=12;a=VDc(4)|0;f[a>>2]=12;we(4608,233608,23856,205353,422,b|0,23856,205342,189,a|0);a=VDc(4)|0;f[a>>2]=1027;we(4608,190289,4272,205353,423,a|0,0,0,0,0);a=VDc(4)|0;f[a>>2]=1028;we(4608,190297,4272,205353,423,a|0,0,0,0,0);a=VDc(4)|0;f[a>>2]=1029;we(4608,391200,4272,205353,423,a|0,0,0,0,0);a=VDc(4)|0;f[a>>2]=1030;we(4608,190302,4272,205353,423,a|0,0,0,0,0);a=VDc(4)|0;f[a>>2]=1031;we(4608,190309,4272,205353,423,a|0,0,0,0,0);a=VDc(4)|0;f[a>>2]=1032;we(4608,190317,4272,205353,423,a|0,0,0,0,0);a=VDc(4)|0;f[a>>2]=1033;we(4608,190325,4272,205353,423,a|0,0,0,0,0);a=VDc(4)|0;f[a>>2]=1034;we(4608,190333,4272,205353,423,a|0,0,0,0,0);a=VDc(4)|0;f[a>>2]=1035;we(4608,190341,4272,205353,423,a|0,0,0,0,0);a=VDc(8)|0;f[a>>2]=820;f[a+4>>2]=0;ff(4608,190349,2,24556,205353,424,a|0,0);a=VDc(8)|0;f[a>>2]=821;f[a+4>>2]=0;ff(4608,190358,2,24556,205353,424,a|0,0);a=VDc(8)|0;f[a>>2]=822;f[a+4>>2]=0;ff(4608,190368,2,24564,205353,425,a|0,0);a=VDc(4)|0;f[a>>2]=1;ff(4608,219542,6,24572,206942,1,a|0,0);a=VDc(4)|0;f[a>>2]=190;ff(4608,219542,4,24596,205347,167,a|0,0);a=VDc(4)|0;f[a>>2]=6;ff(4608,219542,5,24612,206950,5,a|0,0);a=VDc(8)|0;f[a>>2]=823;f[a+4>>2]=0;ff(4608,452815,2,24556,205353,424,a|0,0);a=VDc(8)|0;f[a>>2]=191;f[a+4>>2]=0;ff(4608,190377,3,24632,205376,250,a|0,0);a=VDc(8)|0;f[a>>2]=168;f[a+4>>2]=0;ff(4608,464481,5,24644,206957,93,a|0,0);a=VDc(8)|0;f[a>>2]=192;f[a+4>>2]=0;ff(4608,464481,4,24664,205347,169,a|0,0);a=VDc(8)|0;f[a>>2]=170;f[a+4>>2]=0;ff(4608,190381,4,24680,205381,49,a|0,0);a=VDc(8)|0;f[a>>2]=193;f[a+4>>2]=0;ff(4608,190381,3,24696,205376,251,a|0,0);a=VDc(4)|0;f[a>>2]=1036;ff(4608,222385,3,24708,205342,194,a|0,0);a=VDc(4)|0;f[a>>2]=195;ff(4608,222385,4,24720,205347,171,a|0,0);a=VDc(8)|0;f[a>>2]=824;f[a+4>>2]=0;ff(4608,284842,2,24564,205353,425,a|0,0);a=VDc(8)|0;f[a>>2]=825;f[a+4>>2]=0;ff(4608,222311,2,24736,205353,426,a|0,0);a=VDc(8)|0;f[a>>2]=172;f[a+4>>2]=0;ff(4608,190390,4,24680,205381,49,a|0,0);a=VDc(8)|0;f[a>>2]=196;f[a+4>>2]=0;ff(4608,190390,3,24696,205376,251,a|0,0);a=VDc(8)|0;f[a>>2]=427;f[a+4>>2]=0;ff(4608,190399,3,24744,205376,252,a|0,0);a=VDc(8)|0;f[a>>2]=1037;f[a+4>>2]=0;ff(4608,190405,2,24756,205353,428,a|0,0);a=VDc(8)|0;f[a>>2]=826;f[a+4>>2]=0;ff(4608,371427,2,24564,205353,425,a|0,0);a=VDc(8)|0;f[a>>2]=197;f[a+4>>2]=0;ff(4608,190411,3,24632,205376,250,a|0,0);a=VDc(4)|0;f[a>>2]=5;ff(4608,213465,3,24764,206976,10,a|0,0);a=VDc(4)|0;f[a>>2]=7;ff(4608,190415,4,24776,205725,1,a|0,0);a=VDc(4)|0;f[a>>2]=198;ff(4608,190419,3,24792,205376,253,a|0,0);a=VDc(4)|0;f[a>>2]=1038;ff(4608,502799,2,24804,205353,429,a|0,0);a=VDc(8)|0;f[a>>2]=199;f[a+4>>2]=0;ff(4608,233741,3,24812,205376,254,a|0,0);a=VDc(4)|0;f[a>>2]=200;ff(4608,217899,3,24792,205376,253,a|0,0);a=VDc(4)|0;f[a>>2]=1039;ff(4608,217899,2,24804,205353,429,a|0,0);a=VDc(8)|0;f[a>>2]=827;f[a+4>>2]=0;ff(4608,222349,2,24736,205353,426,a|0,0);a=VDc(4)|0;f[a>>2]=1040;ff(4608,224205,3,24824,205342,201,a|0,0);a=VDc(4)|0;f[a>>2]=202;ff(4608,224205,4,24836,205347,173,a|0,0);a=VDc(4)|0;f[a>>2]=1041;ff(4608,467763,2,24852,205353,430,a|0,0);a=VDc(4)|0;f[a>>2]=203;ff(4608,215813,3,24860,205376,255,a|0,0);a=VDc(4)|0;f[a>>2]=174;ff(4608,215813,4,24872,205381,50,a|0,0);a=VDc(4)|0;f[a>>2]=203;ff(4608,190423,3,24860,205376,255,a|0,0);a=VDc(4)|0;f[a>>2]=174;ff(4608,190423,4,24872,205381,50,a|0,0);a=VDc(4)|0;f[a>>2]=204;ff(4608,190432,3,24860,205376,255,a|0,0);a=VDc(4)|0;f[a>>2]=175;ff(4608,190432,4,24872,205381,50,a|0,0);a=VDc(4)|0;f[a>>2]=205;ff(4608,190440,3,24860,205376,255,a|0,0);a=VDc(4)|0;f[a>>2]=176;ff(4608,190440,4,24872,205381,50,a|0,0);a=VDc(4)|0;f[a>>2]=206;ff(4608,190449,3,24860,205376,255,a|0,0);a=VDc(4)|0;f[a>>2]=177;ff(4608,190449,4,24872,205381,50,a|0,0);a=VDc(4)|0;f[a>>2]=207;ff(4608,190459,3,24860,205376,255,a|0,0);a=VDc(4)|0;f[a>>2]=178;ff(4608,190459,4,24872,205381,50,a|0,0);a=VDc(4)|0;f[a>>2]=208;ff(4608,190466,3,24860,205376,255,a|0,0);a=VDc(4)|0;f[a>>2]=179;ff(4608,190466,4,24872,205381,50,a|0,0);a=VDc(4)|0;f[a>>2]=209;ff(4608,190475,3,24860,205376,255,a|0,0);a=VDc(4)|0;f[a>>2]=180;ff(4608,190475,4,24872,205381,50,a|0,0);a=VDc(8)|0;f[a>>2]=431;f[a+4>>2]=0;ff(4608,190485,3,24888,205376,256,a|0,0);a=VDc(8)|0;f[a>>2]=257;f[a+4>>2]=0;ff(4608,190485,4,24900,205381,51,a|0,0);a=VDc(8)|0;f[a>>2]=52;f[a+4>>2]=0;ff(4608,190485,5,24916,206710,94,a|0,0);a=VDc(8)|0;f[a>>2]=432;f[a+4>>2]=0;ff(4608,190492,3,24936,205376,258,a|0,0);a=VDc(8)|0;f[a>>2]=259;f[a+4>>2]=0;ff(4608,190492,4,24948,205381,53,a|0,0);a=VDc(8)|0;f[a>>2]=54;f[a+4>>2]=0;ff(4608,190492,5,24964,206710,95,a|0,0);a=VDc(8)|0;f[a>>2]=433;f[a+4>>2]=0;ff(4608,190500,3,24984,205376,260,a|0,0);a=VDc(8)|0;f[a>>2]=261;f[a+4>>2]=0;ff(4608,190500,4,24996,205381,55,a|0,0);a=VDc(8)|0;f[a>>2]=56;f[a+4>>2]=0;ff(4608,190500,5,25012,206710,96,a|0,0);a=VDc(8)|0;f[a>>2]=434;f[a+4>>2]=0;ff(4608,190508,3,25032,205376,262,a|0,0);a=VDc(8)|0;f[a>>2]=263;f[a+4>>2]=0;ff(4608,190508,4,25044,205381,57,a|0,0);a=VDc(8)|0;f[a>>2]=58;f[a+4>>2]=0;ff(4608,190508,5,25060,206710,97,a|0,0);a=VDc(8)|0;f[a>>2]=435;f[a+4>>2]=0;ff(4608,190517,3,25080,205376,264,a|0,0);a=VDc(8)|0;f[a>>2]=265;f[a+4>>2]=0;ff(4608,190517,4,25092,205381,59,a|0,0);a=VDc(8)|0;f[a>>2]=60;f[a+4>>2]=0;ff(4608,190517,5,25108,206710,98,a|0,0);a=VDc(8)|0;f[a>>2]=436;f[a+4>>2]=0;ff(4608,190523,3,25128,206981,11,a|0,0);a=VDc(8)|0;f[a>>2]=266;f[a+4>>2]=0;ff(4608,190523,4,25140,206986,3,a|0,0);a=VDc(8)|0;f[a>>2]=61;f[a+4>>2]=0;ff(4608,190523,5,25156,206992,1,a|0,0);a=VDc(8)|0;f[a>>2]=62;f[a+4>>2]=0;ff(4608,190531,5,25176,206999,2,a|0,0);a=VDc(8)|0;f[a>>2]=437;f[a+4>>2]=0;ff(4608,190531,3,25196,206976,12,a|0,0);a=VDc(8)|0;f[a>>2]=267;f[a+4>>2]=0;ff(4608,190531,4,25208,207006,4,a|0,0);cf(4920,190540,233307,2,205339,1637);a=VDc(4)|0;f[a>>2]=0;b=VDc(4)|0;f[b>>2]=0;ne(4920,274521,23856,205353,438,a|0,23856,205342,210,b|0);b=VDc(4)|0;f[b>>2]=4;a=VDc(4)|0;f[a>>2]=4;ne(4920,436928,23856,205353,438,b|0,23856,205342,210,a|0);ze(4920);cf(4928,190546,233307,3,205339,1638);a=VDc(4)|0;f[a>>2]=0;b=VDc(4)|0;f[b>>2]=0;ne(4928,284842,23856,205353,439,a|0,23856,205342,211,b|0);b=VDc(4)|0;f[b>>2]=4;a=VDc(4)|0;f[a>>2]=4;ne(4928,190559,23856,205353,439,b|0,23856,205342,211,a|0);a=VDc(4)|0;f[a>>2]=8;b=VDc(4)|0;f[b>>2]=8;ne(4928,428696,23896,207032,6,a|0,23896,205714,1,b|0);ze(4928);cf(4816,190568,233307,4,205339,1639);b=VDc(4)|0;f[b>>2]=0;a=VDc(4)|0;f[a>>2]=0;ne(4816,467281,23856,205353,440,b|0,23856,205342,212,a|0);a=VDc(4)|0;f[a>>2]=4;b=VDc(4)|0;f[b>>2]=4;ne(4816,467287,23856,205353,440,a|0,23856,205342,212,b|0);ze(4816);cf(4936,190568,233307,5,205339,1640);b=VDc(4)|0;f[b>>2]=0;a=VDc(4)|0;f[a>>2]=0;ne(4936,467281,23888,207051,7,b|0,23888,205542,2,a|0);a=VDc(4)|0;f[a>>2]=4;b=VDc(4)|0;f[b>>2]=4;ne(4936,467287,23888,207051,7,a|0,23888,205542,2,b|0);ze(4936);cf(4520,190568,233307,6,205339,1641);b=VDc(4)|0;f[b>>2]=0;a=VDc(4)|0;f[a>>2]=0;ne(4520,443329,23856,205353,441,b|0,23856,205342,213,a|0);a=VDc(4)|0;f[a>>2]=4;b=VDc(4)|0;f[b>>2]=4;ne(4520,233745,23856,205353,441,a|0,23856,205342,213,b|0);ze(4520);cf(4160,190568,233307,7,205339,1642);b=VDc(4)|0;f[b>>2]=0;a=VDc(4)|0;f[a>>2]=0;ne(4160,443329,23888,207051,8,b|0,23888,205542,3,a|0);a=VDc(4)|0;f[a>>2]=4;b=VDc(4)|0;f[b>>2]=4;ne(4160,233745,23888,207051,8,a|0,23888,205542,3,b|0);ze(4160);cf(4176,190574,233307,8,205339,1643);b=VDc(4)|0;f[b>>2]=0;a=VDc(4)|0;f[a>>2]=0;ne(4176,443329,23856,205353,442,b|0,23856,205342,214,a|0);a=VDc(4)|0;f[a>>2]=4;b=VDc(4)|0;f[b>>2]=4;ne(4176,233745,23856,205353,442,a|0,23856,205342,214,b|0);b=VDc(4)|0;f[b>>2]=8;a=VDc(4)|0;f[a>>2]=8;ne(4176,467281,23856,205353,442,b|0,23856,205342,214,a|0);a=VDc(4)|0;f[a>>2]=12;b=VDc(4)|0;f[b>>2]=12;ne(4176,467287,23856,205353,442,a|0,23856,205342,214,b|0);ze(4176);cf(4944,190579,233307,9,205339,1644);b=VDc(4)|0;f[b>>2]=0;a=VDc(4)|0;f[a>>2]=0;ne(4944,443329,23888,207051,9,b|0,23888,205542,4,a|0);a=VDc(4)|0;f[a>>2]=4;b=VDc(4)|0;f[b>>2]=4;ne(4944,233745,23888,207051,9,a|0,23888,205542,4,b|0);b=VDc(4)|0;f[b>>2]=8;a=VDc(4)|0;f[a>>2]=8;ne(4944,467281,23888,207051,9,b|0,23888,205542,4,a|0);a=VDc(4)|0;f[a>>2]=12;b=VDc(4)|0;f[b>>2]=12;ne(4944,467287,23888,207051,9,a|0,23888,205542,4,b|0);ze(4944);cf(4168,190586,233307,10,205339,1645);b=VDc(4)|0;f[b>>2]=0;a=VDc(4)|0;f[a>>2]=0;ne(4168,190598,4160,205353,443,b|0,4160,205342,215,a|0);a=VDc(4)|0;f[a>>2]=8;b=VDc(4)|0;f[b>>2]=8;ne(4168,467763,4936,205353,444,a|0,4936,205342,216,b|0);b=VDc(4)|0;f[b>>2]=16;a=VDc(4)|0;f[a>>2]=16;ne(4168,190605,23888,207051,10,b|0,23888,205542,5,a|0);ze(4168);Of(190611,2,25224,205353,445,1042);Of(190629,2,25232,205353,446,1043);Of(190653,2,25240,205353,447,1044);cf(4776,190679,233307,11,205339,1646);a=VDc(4)|0;f[a>>2]=12;b=VDc(4)|0;f[b>>2]=12;ne(4776,190605,23888,207051,11,a|0,23888,205542,6,b|0);b=VDc(4)|0;f[b>>2]=24;a=VDc(4)|0;f[a>>2]=24;ne(4776,190688,23856,205353,448,b|0,23856,205342,217,a|0);a=VDc(4)|0;f[a>>2]=20;b=VDc(4)|0;f[b>>2]=20;ne(4776,190697,23856,205353,448,a|0,23856,205342,217,b|0);b=VDc(4)|0;f[b>>2]=0;a=VDc(4)|0;f[a>>2]=0;ne(4776,190704,4160,205353,449,b|0,4160,205342,218,a|0);a=VDc(4)|0;f[a>>2]=16;b=VDc(4)|0;f[b>>2]=16;ne(4776,190707,23888,207051,11,a|0,23888,205542,6,b|0);b=VDc(4)|0;f[b>>2]=8;a=VDc(4)|0;f[a>>2]=8;ne(4776,467763,23888,207051,11,b|0,23888,205542,6,a|0);ze(4776);sf(4848,190716,233307,12,205339,1647);Ef(4848,23896,207032,12,0,23896,205714,7,0);Ef(4848,23896,207032,12,1,23896,205714,7,1);Ef(4848,23896,207032,12,2,23896,205714,7,2);Ef(4848,23896,207032,12,3,23896,205714,7,3);ce(4848);cf(4952,190723,233307,13,205339,1648);a=VDc(4)|0;f[a>>2]=0;b=VDc(4)|0;f[b>>2]=0;ne(4952,190733,23896,207032,13,a|0,23896,205714,8,b|0);b=VDc(4)|0;f[b>>2]=8;a=VDc(4)|0;f[a>>2]=8;ne(4952,190740,23896,207032,13,b|0,23896,205714,8,a|0);a=VDc(4)|0;f[a>>2]=16;b=VDc(4)|0;f[b>>2]=16;ne(4952,190747,4520,205353,450,a|0,4520,205342,219,b|0);b=VDc(4)|0;f[b>>2]=24;a=VDc(4)|0;f[a>>2]=24;ne(4952,190754,4520,205353,450,b|0,4520,205342,219,a|0);ze(4952);cf(4960,190761,233307,14,205339,1649);a=VDc(4)|0;f[a>>2]=0;b=VDc(4)|0;f[b>>2]=0;ne(4960,190598,4160,205353,451,a|0,4160,205342,220,b|0);b=VDc(4)|0;f[b>>2]=8;a=VDc(4)|0;f[a>>2]=8;ne(4960,190768,23888,207051,14,b|0,23888,205542,9,a|0);ze(4960);cf(4968,190775,233307,15,205339,1650);a=VDc(4)|0;f[a>>2]=0;b=VDc(4)|0;f[b>>2]=0;ne(4968,190783,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=8;a=VDc(4)|0;f[a>>2]=8;ne(4968,190787,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=16;b=VDc(4)|0;f[b>>2]=16;ne(4968,190791,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=24;a=VDc(4)|0;f[a>>2]=24;ne(4968,190795,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=32;b=VDc(4)|0;f[b>>2]=32;ne(4968,190799,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=40;a=VDc(4)|0;f[a>>2]=40;ne(4968,190803,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=48;b=VDc(4)|0;f[b>>2]=48;ne(4968,190807,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=56;a=VDc(4)|0;f[a>>2]=56;ne(4968,190811,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=64;b=VDc(4)|0;f[b>>2]=64;ne(4968,190815,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=72;a=VDc(4)|0;f[a>>2]=72;ne(4968,190819,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=80;b=VDc(4)|0;f[b>>2]=80;ne(4968,190823,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=88;a=VDc(4)|0;f[a>>2]=88;ne(4968,190828,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=96;b=VDc(4)|0;f[b>>2]=96;ne(4968,190833,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=104;a=VDc(4)|0;f[a>>2]=104;ne(4968,190838,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=112;b=VDc(4)|0;f[b>>2]=112;ne(4968,190843,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=120;a=VDc(4)|0;f[a>>2]=120;ne(4968,190848,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=128;b=VDc(4)|0;f[b>>2]=128;ne(4968,190853,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=136;a=VDc(4)|0;f[a>>2]=136;ne(4968,190858,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=144;b=VDc(4)|0;f[b>>2]=144;ne(4968,190863,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=152;a=VDc(4)|0;f[a>>2]=152;ne(4968,190868,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=160;b=VDc(4)|0;f[b>>2]=160;ne(4968,190873,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=168;a=VDc(4)|0;f[a>>2]=168;ne(4968,190878,23896,207032,15,b|0,23896,205714,10,a|0);a=VDc(4)|0;f[a>>2]=176;b=VDc(4)|0;f[b>>2]=176;ne(4968,190883,23896,207032,15,a|0,23896,205714,10,b|0);b=VDc(4)|0;f[b>>2]=184;a=VDc(4)|0;f[a>>2]=184;ne(4968,190888,23896,207032,15,b|0,23896,205714,10,a|0);ze(4968);cf(7776,190893,233307,16,205339,1651);a=VDc(4)|0;f[a>>2]=12;b=VDc(4)|0;f[b>>2]=12;ne(7776,190903,23856,205353,452,a|0,23856,205342,221,b|0);b=VDc(4)|0;f[b>>2]=1045;a=VDc(4)|0;f[a>>2]=1046;ne(7776,190908,4984,205353,453,b|0,4984,205342,222,a|0);ze(7776);Of(190912,2,25248,205353,454,1047);Of(286480,2,25256,205353,455,1048);Of(218923,3,25264,205376,268,223);Of(218923,2,25276,205353,456,1049);Of(190929,1,25284,205334,828,1652);Of(190958,2,25288,205353,457,829);Of(190971,4,25296,205381,63,181);Of(372200,4,25296,205381,63,182);Of(190980,1,25312,205334,830,1653);fe(191e3,23856,0);fe(191008,23856,8);fe(191016,23856,16);fe(191024,23856,24);fe(191032,23856,1);fe(191040,23856,9);fe(191048,23856,17);fe(191056,23856,25);fe(191064,23856,2);fe(191073,23856,10);fe(191082,23856,18);fe(191091,23856,26);fe(191100,23856,3);fe(191109,23856,11);fe(191118,23856,19);fe(191127,23856,27);fe(426648,23856,4);fe(191136,23856,12);fe(191145,23856,20);fe(191154,23856,28);fe(450050,23856,5);fe(191163,23856,13);fe(191172,23856,21);fe(191181,23856,29);fe(191190,23856,6);fe(191199,23856,14);fe(191208,23856,22);fe(191217,23856,30);fe(229100,23856,0);fe(229106,23856,1);fe(229112,23856,2);fe(229119,23856,3);fe(229126,23856,4);fe(229133,23856,5);fe(229140,23856,6);fe(191226,23856,-2147483648);fe(191234,23856,2147483647);return}function Bk(a){a=a|0;Ce(4216,4240,4256,0,205334,831,205337,0,205337,0,a|0,205339,1654);ae(4216,1,23968,205334,832,17);a=VDc(8)|0;f[a>>2]=1050;f[a+4>>2]=0;ff(4216,205128,3,23972,205342,224,a|0,0);a=VDc(8)|0;f[a>>2]=225;f[a+4>>2]=0;ff(4216,251123,4,23984,205347,183,a|0,0);a=VDc(8)|0;f[a>>2]=833;f[a+4>>2]=0;ff(4216,467763,2,24e3,205353,458,a|0,0);a=VDc(4)|0;f[a>>2]=226;ff(4216,382158,3,24008,205376,269,a|0,0);a=VDc(4)|0;f[a>>2]=270;ff(4216,205138,4,24020,205381,64,a|0,0);return}function Ck(a){a=a|0;Ce(4304,4328,4344,0,205334,834,205337,0,205337,0,a|0,205339,1655);ae(4304,1,24036,205334,835,18);a=VDc(8)|0;f[a>>2]=1051;f[a+4>>2]=0;ff(4304,205128,3,24040,205542,11,a|0,0);a=VDc(8)|0;f[a>>2]=227;f[a+4>>2]=0;ff(4304,251123,4,24052,205547,8,a|0,0);a=VDc(8)|0;f[a>>2]=836;f[a+4>>2]=0;ff(4304,467763,2,24068,205353,459,a|0,0);a=VDc(4)|0;f[a>>2]=228;ff(4304,382158,3,24076,205376,271,a|0,0);a=VDc(4)|0;f[a>>2]=272;ff(4304,205138,4,24088,205553,2,a|0,0);return}function Dk(a){a=a|0;Ce(4384,4408,4424,0,205334,837,205337,0,205337,0,a|0,205339,1656);ae(4384,1,24104,205334,838,19);a=VDc(8)|0;f[a>>2]=1052;f[a+4>>2]=0;ff(4384,205128,3,24108,205714,12,a|0,0);a=VDc(8)|0;f[a>>2]=229;f[a+4>>2]=0;ff(4384,251123,4,24120,205719,9,a|0,0);a=VDc(8)|0;f[a>>2]=839;f[a+4>>2]=0;ff(4384,467763,2,24136,205353,460,a|0,0);a=VDc(4)|0;f[a>>2]=230;ff(4384,382158,3,24144,205376,273,a|0,0);a=VDc(4)|0;f[a>>2]=274;ff(4384,205138,4,24156,205725,3,a|0,0);return}function Ek(a){a=a|0;Ce(4464,4488,4504,0,205334,840,205337,0,205337,0,a|0,205339,1657);ae(4464,1,24172,205334,841,20);a=VDc(8)|0;f[a>>2]=1053;f[a+4>>2]=0;ff(4464,205128,3,24176,205342,231,a|0,0);a=VDc(8)|0;f[a>>2]=232;f[a+4>>2]=0;ff(4464,251123,4,24188,205347,184,a|0,0);a=VDc(8)|0;f[a>>2]=842;f[a+4>>2]=0;ff(4464,467763,2,24204,205353,461,a|0,0);a=VDc(4)|0;f[a>>2]=233;ff(4464,382158,3,24212,205376,275,a|0,0);a=VDc(4)|0;f[a>>2]=276;ff(4464,205138,4,24224,205381,65,a|0,0);return}function Fk(a){a=a|0;Ce(4552,4576,4592,0,205334,843,205337,0,205337,0,a|0,205339,1658);ae(4552,1,24240,205334,844,21);a=VDc(8)|0;f[a>>2]=1054;f[a+4>>2]=0;ff(4552,205128,3,24244,205342,234,a|0,0);a=VDc(8)|0;f[a>>2]=235;f[a+4>>2]=0;ff(4552,251123,4,24256,205347,185,a|0,0);a=VDc(8)|0;f[a>>2]=845;f[a+4>>2]=0;ff(4552,467763,2,24272,205353,462,a|0,0);a=VDc(4)|0;f[a>>2]=236;ff(4552,382158,3,24280,205376,277,a|0,0);a=VDc(4)|0;f[a>>2]=278;ff(4552,205138,4,24292,205381,66,a|0,0);return}function Gk(a){a=a|0;Ce(4640,4664,4680,0,205334,846,205337,0,205337,0,a|0,205339,1659);ae(4640,1,24308,205334,847,22);a=VDc(8)|0;f[a>>2]=1055;f[a+4>>2]=0;ff(4640,205128,3,24312,205342,237,a|0,0);a=VDc(8)|0;f[a>>2]=238;f[a+4>>2]=0;ff(4640,251123,4,24324,205347,186,a|0,0);a=VDc(8)|0;f[a>>2]=848;f[a+4>>2]=0;ff(4640,467763,2,24340,205353,463,a|0,0);a=VDc(4)|0;f[a>>2]=239;ff(4640,382158,3,24348,205376,279,a|0,0);a=VDc(4)|0;f[a>>2]=280;ff(4640,205138,4,24360,205381,67,a|0,0);return}function Hk(a){a=a|0;Ce(4720,4744,4760,0,205334,849,205337,0,205337,0,a|0,205339,1660);ae(4720,1,24376,205334,850,23);a=VDc(8)|0;f[a>>2]=1056;f[a+4>>2]=0;ff(4720,205128,3,24380,205342,240,a|0,0);a=VDc(8)|0;f[a>>2]=241;f[a+4>>2]=0;ff(4720,251123,4,24392,205347,187,a|0,0);a=VDc(8)|0;f[a>>2]=851;f[a+4>>2]=0;ff(4720,467763,2,24408,205353,464,a|0,0);a=VDc(4)|0;f[a>>2]=242;ff(4720,382158,3,24416,205376,281,a|0,0);a=VDc(4)|0;f[a>>2]=282;ff(4720,205138,4,24428,205381,68,a|0,0);return}function Ik(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];HY(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);$j(e);u=d;return}function Jk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;GY(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;ei[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);$j(g);u=e;return}function Kk(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=Lf()|0;f[a>>2]=g;h=c+4|0;if((f[h>>2]|0)<=0){u=d;return}i=c+40|0;c=0;j=g;while(1){g=(f[i>>2]|0)+(c<<2)|0;if((b[519728]|0)==0?MIc(519728)|0:0){k=Af(2,23920)|0;f[132502]=k}k=f[132502]|0;f[e>>2]=f[g>>2];Ed(k|0,j|0,190186,e|0);k=c+1|0;if((k|0)>=(f[h>>2]|0))break;c=k;j=f[a>>2]|0}u=d;return}function Lk(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=Lf()|0;f[a>>2]=g;h=c+4|0;if((f[h>>2]|0)<=0){u=d;return}i=c+44|0;c=0;j=g;while(1){g=(f[i>>2]|0)+(c<<2)|0;if((b[519736]|0)==0?MIc(519736)|0:0){k=Af(2,23928)|0;f[132503]=k}k=f[132503]|0;f[e>>2]=f[g>>2];Ed(k|0,j|0,190186,e|0);k=c+1|0;if((k|0)>=(f[h>>2]|0))break;c=k;j=f[a>>2]|0}u=d;return}function Mk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=Y(l,g)|0;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4864,d|0)|0;f[a>>2]=g;u=c;return}function Nk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=Y(l,g)|0;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4872,d|0)|0;f[a>>2]=g;u=c;return}function Ok(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>1;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4880,d|0)|0;f[a>>2]=g;u=c;return}function Pk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>1;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4888,d|0)|0;f[a>>2]=g;u=c;return}function Qk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>2;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4896,d|0)|0;f[a>>2]=g;u=c;return}function Rk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>2;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4904,d|0)|0;f[a>>2]=g;u=c;return}function Sk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>3;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4912,d|0)|0;f[a>>2]=g;u=c;return}function Tk(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if((b|0)<=0){c=0;return c|0}c=f[(f[a+44>>2]|0)+(b+-1<<2)>>2]|0;return c|0}function Uk(a){a=a|0;return 1212424721>>>(f[a>>2]<<2&28)&15|0}function Vk(a){a=a|0;return ((f[a>>2]|0)>>>3&511)+1|0}function Wk(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if((b|0)<3){c=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;return c|0}d=f[a+40>>2]|0;a=0;e=1;while(1){g=Y(f[d+(a<<2)>>2]|0,e)|0;a=a+1|0;if((a|0)>=(b|0)){c=g;break}else e=g}return c|0}function Xk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=c;f[e+4>>2]=c+1;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;$S(a,b,e,g);u=d;return}function Yk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=d&4095;if(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(b|0):0)?(f[a+12>>2]|0)==(c|0):0)?(f[a>>2]&4095|0)==(h|0):0)?f[a+16>>2]|0:0){u=e;return}f[g>>2]=b;f[g+4>>2]=c;XS(a,2,g,h);u=e;return}function Zk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b+4>>2]|0;h=f[b>>2]|0;b=c&4095;if(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(g|0):0)?(f[a+12>>2]|0)==(h|0):0)?(f[a>>2]&4095|0)==(b|0):0)?f[a+16>>2]|0:0){u=d;return}f[e>>2]=g;f[e+4>>2]=h;XS(a,2,e,b);u=d;return}function _k(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=c;f[g+4>>2]=d;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;$S(a,b,g,h);u=e;return}function $k(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;$S(a,b,c,e);u=d;return}function al(a){a=a|0;return f[a>>2]&4095|0}function bl(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+16>>2]|0))return 1;b=f[a+4>>2]|0;if((b|0)<3){c=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;d=(c|0)==0;e=(b|0)==0;g=d|e;return g|0}h=f[a+40>>2]|0;a=0;i=1;while(1){j=Y(f[h+(a<<2)>>2]|0,i)|0;a=a+1|0;if((a|0)==(b|0)){c=j;break}else i=j}d=(c|0)==0;e=(b|0)==0;g=d|e;return g|0}function cl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=c;f[h+4>>2]=d;$S(a,b,g,h);u=e;return}function dl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;$S(a,b,e,c);u=d;return}function el(a,b){a=a|0;b=b|0;return ((f[(f[a+44>>2]|0)+(b<<2)>>2]|0)>>>0)/((1212424721>>>(f[a>>2]<<2&28)&15)>>>0)|0|0}function fl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=1124007936;e=a+8|0;g=a+40|0;h=a+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+48|0;f[a+44>>2]=e;f[e>>2]=0;f[a+52>>2]=0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=a;h_(b,d);u=c;return}function gl(a){a=a|0;return f[a>>2]&7|0}function hl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=c;f[g+4>>2]=c+1;$S(a,b,e,g);u=d;return}function il(a,b,c){a=a|0;b=b|0;c=c|0;cT(a,b,c);return}function jl(a){a=a|0;return (f[a>>2]&16384|0)!=0|0}function kl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4864,e|0)|0;f[a>>2]=h;u=d;return}function ll(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4864,g|0)|0;f[a>>2]=j;u=e;return}function ml(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4872,e|0)|0;f[a>>2]=h;u=d;return}function nl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4872,g|0)|0;f[a>>2]=j;u=e;return}function ol(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4888,e|0)|0;f[a>>2]=h;u=d;return}function pl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4888,g|0)|0;f[a>>2]=j;u=e;return}function ql(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4880,e|0)|0;f[a>>2]=h;u=d;return}function rl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4880,g|0)|0;f[a>>2]=j;u=e;return}function sl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4896,e|0)|0;f[a>>2]=h;u=d;return}function tl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4896,g|0)|0;f[a>>2]=j;u=e;return}function ul(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4904,e|0)|0;f[a>>2]=h;u=d;return}function vl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4904,g|0)|0;f[a>>2]=j;u=e;return}function wl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4912,e|0)|0;f[a>>2]=h;u=d;return}function xl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4912,g|0)|0;f[a>>2]=j;u=e;return}function yl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0))|0;return g|0}}g=c+b|0;return g|0}function zl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+c|0}function Al(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Bl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0))|0;return g|0}}g=c+b|0;return g|0}function Cl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+c|0}function Dl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function El(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<1)|0;return g|0}}g=c+(b<<1)|0;return g|0}function Fl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function Gl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Hl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<1)|0;return g|0}}g=c+(b<<1)|0;return g|0}function Il(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function Jl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Kl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<2)|0;return g|0}}g=c+(b<<2)|0;return g|0}function Ll(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function Ml(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Nl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<2)|0;return g|0}}g=c+(b<<2)|0;return g|0}function Ol(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function Pl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Ql(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Rl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<3)|0;return g|0}}g=c+(b<<3)|0;return g|0}function Sl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<3)|0}function Tl(a){a=a|0;p[a>>3]=1797693134862315708145274.0e284;p[a+8>>3]=1797693134862315708145274.0e284;p[a+16>>3]=1797693134862315708145274.0e284;p[a+24>>3]=1797693134862315708145274.0e284;return}function Ul(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Mna(i,j,c,d,e,g);u=h;return}function Vl(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Mna(h,i,c,d,e,0);u=g;return}function Wl(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Mna(g,h,c,d,3,0);u=e;return}function Xl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;coa(i,j,k,d,e,g);u=h;return}function Yl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;coa(h,i,j,d,e,0);u=g;return}function Zl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Gfa(i,j,k,d,e,g);u=h;return}function _l(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Gfa(h,i,j,d,e,4);u=g;return}function $l(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Gfa(g,h,i,d,0.0,4);u=e;return}function am(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;bxa(l,m,c,d,e,g,h,i,j);u=k;return}function bm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;bxa(k,l,c,d,e,g,h,i,0);u=j;return}function cm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;bxa(j,k,c,d,e,g,h,0,0);u=i;return}function dm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;bxa(i,j,c,d,e,g,100.0,0,0);u=h;return}function em(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;bxa(h,i,c,d,e,100.0,100.0,0,0);u=g;return}function fm(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;j=+j;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;Rwa(l,m,c,d,e,g,h,i,j);u=k;return}function gm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;Rwa(k,l,c,d,e,g,h,i,3.141592653589793);u=j;return}function hm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;Rwa(j,k,c,d,e,g,h,0.0,3.141592653589793);u=i;return}function im(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Rwa(i,j,c,d,e,g,0.0,0.0,3.141592653589793);u=h;return}function jm(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Rwa(h,i,c,d,e,0.0,0.0,0.0,3.141592653589793);u=g;return}function km(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;_wa(j,k,c,d,e,g,h);u=i;return}function lm(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;_wa(i,j,c,d,e,g,0.0);u=h;return}function mm(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;_wa(h,i,c,d,e,0.0,0.0);u=g;return}function nm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;Joa(j,k,c,d,e,g,h);u=i;return}function om(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Joa(i,j,c,d,e,g,4);u=h;return}function pm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Joa(h,i,c,d,e,0.0,4);u=g;return}function qm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Joa(g,h,c,d,1.0,0.0,4);u=e;return}function rm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Joa(e,g,c,1,1.0,0.0,4);u=d;return}function sm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;Ioa(k,l,c,d,e,g,h,i);u=j;return}function tm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;Ioa(j,k,c,d,e,g,h,4);u=i;return}function um(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Ioa(i,j,c,d,e,g,0.0,4);u=h;return}function vm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Ioa(h,i,c,d,e,1.0,0.0,4);u=g;return}function wm(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;Hoa(l,m,c,d,e,g,h,i,j);u=k;return}function xm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;Hoa(k,l,c,d,e,g,h,i,4);u=j;return}function ym(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;Hoa(j,k,c,d,e,g,h,0.0,4);u=i;return}function zm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Hoa(i,j,c,d,e,g,1.0,0.0,4);u=h;return}function Am(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Hoa(h,i,c,d,e,3,1.0,0.0,4);u=g;return}function Bm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;pL(e,g,h);u=d;return}function Cm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;Ixa(j,k,c,d,e,g,h);u=i;return}function Dm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;mL(h,i,j,k,e);u=g;return}function Em(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;mL(g,h,i,j,-1);u=e;return}function Fm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;mL(e,g,h,e0()|0,-1);u=d;return}function Gm(a,b,c,d,e,g,h){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=g;tL(j,b,k,d,e,l,h);u=i;return}function Hm(a,b,c,d,e,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=g;tL(i,b,j,d,e,k,-1);u=h;return}function Im(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;yfa(g,h,c,d);u=e;return}function Jm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+Nxa(d,b);u=c;return +e}function Km(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Gna(i,j,c,d,e,g);u=h;return}function Lm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Gna(h,i,c,d,e,4);u=g;return}function Mm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;dL(g,h,i,j);u=e;return}function Nm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;dL(e,g,h,e0()|0);u=d;return}function Om(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;hL(e,g,h);u=d;return}function Pm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;hL(d,e,e0()|0);u=c;return}function Qm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;fL(g,h,i,j);u=e;return}function Rm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;fL(e,g,h,e0()|0);u=d;return}function Sm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;gL(g,h,i,j);u=e;return}function Tm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;gL(e,g,h,e0()|0);u=d;return}function Um(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];Zma(h,i,j,k,e);u=g;return}function Vm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];Zma(g,h,i,j,4);u=e;return}function Wm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+8|0;i=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=-1;f[i+4>>2]=-1;Zma(e,g,h,i,4);u=d;return}function Xm(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;Qxa(a,d);u=c;return}function Ym(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];Yma(j,k,c,l,m,g,h);u=i;return}function Zm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];Yma(i,j,c,k,l,g,4);u=h;return}function _m(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Yma(h,i,c,j,k,1,4);u=g;return}function $m(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[j>>2]=-1;f[j+4>>2]=-1;Yma(g,h,c,i,j,1,4);u=e;return}function an(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+32|0;l=h+40|0;m=h+16|0;n=h+4|0;o=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;Vf(a|0);bn(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=d;d=f[e>>2]|0;f[o>>2]=d;Vf(d|0);cn(n,o);fha(i,j,l,m,n,g);m=f[n>>2]|0;if(m|0){l=n+4|0;n=f[l>>2]|0;if((n|0)!=(m|0))f[l>>2]=n+(~((n+-4-m|0)>>>2)<<2);YDc(m)}Ae(f[o>>2]|0);o=f[j>>2]|0;if(!o){p=f[k>>2]|0;Ae(p|0);u=h;return}m=j+4|0;j=f[m>>2]|0;if((j|0)!=(o|0))f[m>>2]=j+(~((j+-4-o|0)>>>2)<<2);YDc(o);p=f[k>>2]|0;Ae(p|0);u=h;return}function bn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(207238)|0;i=Nd(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,23864,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=bf(23864,d|0)|0;n=Nd(l|0,m|0)|0;Ae(m|0);j=+pe(n|0,23856,d|0);Ie(f[d>>2]|0);m=~~j;f[e>>2]=m;l=f[i>>2]|0;if(l>>>0<(f[g>>2]|0)>>>0){f[l>>2]=m;f[i>>2]=l+4}else QA(a,e);Ae(n|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function cn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0.0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(207238)|0;i=Nd(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,23864,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=bf(23864,d|0)|0;o=Nd(l|0,m|0)|0;Ae(m|0);j=+pe(o|0,23888,d|0);Ie(f[d>>2]|0);p=j;n[e>>2]=p;m=f[i>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){n[m>>2]=p;f[i>>2]=m+4}else RA(a,e);Ae(o|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function dn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+112|0;j=i+88|0;k=i+72|0;l=i+48|0;m=i+56|0;n=i+32|0;o=i+20|0;p=i+4|0;q=i+8|0;r=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=a;a=f[b>>2]|0;f[l>>2]=a;Vf(a|0);bn(k,l);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=d;d=f[e>>2]|0;f[p>>2]=d;Vf(d|0);bn(o,p);d=f[g>>2]|0;f[r>>2]=d;Vf(d|0);cn(q,r);dha(j,k,m,n,o,q,h);h=f[q>>2]|0;if(h|0){n=q+4|0;q=f[n>>2]|0;if((q|0)!=(h|0))f[n>>2]=q+(~((q+-4-h|0)>>>2)<<2);YDc(h)}Ae(f[r>>2]|0);r=f[o>>2]|0;if(r|0){h=o+4|0;o=f[h>>2]|0;if((o|0)!=(r|0))f[h>>2]=o+(~((o+-4-r|0)>>>2)<<2);YDc(r)}Ae(f[p>>2]|0);p=f[k>>2]|0;if(!p){s=f[l>>2]|0;Ae(s|0);u=i;return}r=k+4|0;k=f[r>>2]|0;if((k|0)!=(p|0))f[r>>2]=k+(~((k+-4-p|0)>>>2)<<2);YDc(p);s=f[l>>2]|0;Ae(s|0);u=i;return}function en(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+112|0;i=h+88|0;j=h+72|0;k=h+48|0;l=h+56|0;m=h+32|0;n=h+20|0;o=h+4|0;p=h+8|0;q=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;Vf(a|0);bn(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=d;d=f[e>>2]|0;f[o>>2]=d;Vf(d|0);bn(n,o);d=f[g>>2]|0;f[q>>2]=d;Vf(d|0);cn(p,q);dha(i,j,l,m,n,p,0);m=f[p>>2]|0;if(m|0){l=p+4|0;p=f[l>>2]|0;if((p|0)!=(m|0))f[l>>2]=p+(~((p+-4-m|0)>>>2)<<2);YDc(m)}Ae(f[q>>2]|0);q=f[n>>2]|0;if(q|0){m=n+4|0;n=f[m>>2]|0;if((n|0)!=(q|0))f[m>>2]=n+(~((n+-4-q|0)>>>2)<<2);YDc(q)}Ae(f[o>>2]|0);o=f[j>>2]|0;if(!o){r=f[k>>2]|0;Ae(r|0);u=h;return}q=j+4|0;j=f[q>>2]|0;if((j|0)!=(o|0))f[q>>2]=j+(~((j+-4-o|0)>>>2)<<2);YDc(o);r=f[k>>2]|0;Ae(r|0);u=h;return}function fn(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+32|0;n=l+16|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;b=o+8|0;f[b>>2]=0;f[b+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=c;qEa(m,n,o,d,e,g,h,i,j,k);u=l;return}function gn(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;m=u;u=u+128|0;n=m;o=m+104|0;p=m+88|0;q=m+72|0;r=m+56|0;s=m+40|0;t=m+24|0;v=m+16|0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=a;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=b;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=c;c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=50397184;f[r+4>>2]=d;d=s+8|0;f[d>>2]=0;f[d+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=e;e=t+8|0;f[e>>2]=0;f[e+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=g;f[v>>2]=f[h>>2];f[v+4>>2]=f[h+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[n+8>>2]=f[j+8>>2];f[n+12>>2]=f[j+12>>2];lEa(o,p,q,r,s,t,v,i,n,k,l);u=m;return}function hn(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=u;u=u+128|0;m=l;n=l+104|0;o=l+88|0;p=l+72|0;q=l+56|0;r=l+40|0;s=l+24|0;t=l+16|0;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=a;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=b;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=c;c=q+8|0;f[c>>2]=0;f[c+4>>2]=0;f[q>>2]=50397184;f[q+4>>2]=d;d=r+8|0;f[d>>2]=0;f[d+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=e;e=s+8|0;f[e>>2]=0;f[e+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=g;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];lEa(n,o,p,q,r,s,t,i,m,k,.0001);u=l;return}function jn(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=u;u=u+128|0;l=k;m=k+104|0;n=k+88|0;o=k+72|0;p=k+56|0;q=k+40|0;r=k+24|0;s=k+16|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=c;c=p+8|0;f[c>>2]=0;f[c+4>>2]=0;f[p>>2]=50397184;f[p+4>>2]=d;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=e;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=g;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];f[l+12>>2]=f[j+12>>2];lEa(m,n,o,p,q,r,s,i,l,0,.0001);u=k;return}function kn(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=u;u=u+144|0;k=j+16|0;l=j+120|0;m=j+104|0;n=j+88|0;o=j+72|0;q=j+56|0;r=j+40|0;s=j+32|0;t=j;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=c;c=o+8|0;f[c>>2]=0;f[c+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=d;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=e;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=g;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[t>>2]=3;f[t+4>>2]=30;p[t+8>>3]=.01;f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];lEa(l,m,n,o,q,r,s,i,k,0,.0001);u=j;return}function ln(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;i=u;u=u+144|0;j=i+16|0;k=i+120|0;l=i+104|0;m=i+88|0;n=i+72|0;o=i+56|0;q=i+40|0;r=i+32|0;s=i;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=d;d=o+8|0;f[d>>2]=0;f[d+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=e;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=g;f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[s>>2]=3;f[s+4>>2]=30;p[s+8>>3]=.01;f[j>>2]=f[s>>2];f[j+4>>2]=f[s+4>>2];f[j+8>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];lEa(k,l,m,n,o,q,r,3,j,0,.0001);u=i;return}function mn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+144|0;i=h+16|0;j=h+120|0;k=h+104|0;l=h+88|0;m=h+72|0;n=h+56|0;o=h+40|0;q=h+32|0;r=h;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=d;d=n+8|0;f[d>>2]=0;f[d+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=e;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=g;f[q>>2]=21;f[q+4>>2]=21;f[r>>2]=3;f[r+4>>2]=30;p[r+8>>3]=.01;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];lEa(j,k,l,m,n,o,q,3,i,0,.0001);u=h;return}function nn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;$2(h,i,j,k,e);u=g;return}function on(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;$2(g,h,i,j,0);u=e;return}function pn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+8|0;k=i;l=j+8|0;f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];Ega(j,k,c,d,e,g,h);u=i;return}function qn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+8|0;j=h;k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];Ega(i,j,c,d,e,g,0);u=h;return}function rn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+8|0;i=g;j=h+8|0;f[j>>2]=0;f[j+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];Ega(h,i,c,d,e,8,0);u=g;return}function sn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+8|0;h=e;i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];Ega(g,h,c,d,1,8,0);u=e;return}function tn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;uL(g,h,i,d);u=e;return}function un(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;h=+gha(e,g,c);u=d;return +h}function vn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=qaa(g,h,c,d)|0;u=e;return b|0}function wn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=qaa(e,g,c,4)|0;u=d;return b|0}function xn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b=qaa(d,e,8,4)|0;u=c;return b|0}function yn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+48|0;j=h+32|0;k=h+16|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=d;d=Maa(i,j,k,l,e,g)|0;u=h;return d|0}function zn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;d=Maa(h,i,j,k,e,4)|0;u=g;return d|0}function An(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;d=Maa(g,h,i,j,8,4)|0;u=e;return d|0}function Bn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+Oxa(d,b);u=c;return +e}function Cn(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+Oxa(c,0);u=b;return +d}function Dn(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;zM(g,h,c,d);u=e;return}function En(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;zM(e,g,c,0.0);u=d;return}function Fn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;zM(d,e,1.0,0.0);u=c;return}function Gn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Xxa(g,h,c,d);u=e;return}function Hn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Xxa(e,g,c,1);u=d;return}function In(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;Xxa(d,e,0,1);u=c;return}function Jn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;iya(e,g,h);u=d;return}function Kn(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;q_(k,l,c,d,e,g,h,i);u=j;return}function Ln(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;q_(j,k,c,d,e,g,h,l);u=i;return}function Mn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Epa(i,j,c,d,e,g);u=h;return}function Nn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Epa(h,i,c,d,e,4);u=g;return}function On(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Bpa(h,i,c,d,e);u=g;return}function Pn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Bpa(g,h,c,d,4);u=e;return}function Qn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Bpa(e,g,c,3,4);u=d;return}function Rn(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;a=N2(c)|0;u=b;return a|0}function Sn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Oga(g,h,c,d);u=e;return}function Tn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Oga(e,g,c,0);u=d;return}function Un(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;oka(g,h,c,d);u=e;return}function Vn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;oka(e,g,c,0);u=d;return}function Wn(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+eQ(c);u=b;return +d}function Xn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;uN(g,h,c,d);u=e;return}function Yn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;uN(e,g,c,0);u=d;return}function Zn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;uN(d,e,0,0);u=c;return}function _n(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];bka(j,k,l,m,e,g,h);u=i;return}function $n(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;bka(i,j,k,l,e,g,m);u=h;return}function ao(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;bka(h,i,j,k,e,0,l);u=g;return}function bo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;bka(g,h,i,j,1,0,k);u=e;return}function co(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=-1;f[i+4>>2]=-1;p[j>>3]=1797693134862315708145274.0e284;p[j+8>>3]=1797693134862315708145274.0e284;p[j+16>>3]=1797693134862315708145274.0e284;p[j+24>>3]=1797693134862315708145274.0e284;bka(e,g,h,i,1,0,j);u=d;return}function eo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Yya(h,i,c,d,e);u=g;return}function fo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Yya(g,h,c,d,5);u=e;return}function go(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;Sya(i,j,k,d,e,g);u=h;return}function ho(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;Sya(h,i,j,d,e,0);u=g;return}function io(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;rL(h,i,j,d,e);u=g;return}function jo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;rL(g,h,i,d,-1);u=e;return}function ko(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;rL(e,g,h,1.0,-1);u=d;return}function lo(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;sL(a,g,h,d);u=e;return}function mo(a,b,c){a=+a;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;sL(a,e,g,-1);u=d;return}function no(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+64|0;l=k+40|0;m=k+24|0;n=k+8|0;o=k;p=l+8|0;f[p>>2]=0;f[p+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=17104896;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=h;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];Iga(l,m,c,d,e,g,n,i,o);u=k;return}function oo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+64|0;k=j+40|0;l=j+24|0;m=j+8|0;n=j;o=k+8|0;f[o>>2]=0;f[o+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=17104896;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=h;f[n>>2]=0;f[n+4>>2]=0;Iga(k,l,c,d,e,g,m,i,n);u=j;return}function po(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;n=j+8|0;f[n>>2]=0;f[n+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17104896;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;f[m>>2]=0;f[m+4>>2]=0;Iga(j,k,c,d,e,g,l,2147483647,m);u=i;return}function qo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=b;b=e0()|0;f[k>>2]=0;f[k+4>>2]=0;Iga(i,j,c,d,e,g,b,2147483647,k);u=h;return}function ro(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=b;b=e0()|0;f[j>>2]=0;f[j+4>>2]=0;Iga(h,i,c,d,e,8,b,2147483647,j);u=g;return}function so(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=b;b=e0()|0;f[i>>2]=0;f[i+4>>2]=0;Iga(g,h,c,d,1,8,b,2147483647,i);u=e;return}function to(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g;k=g+8|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=f[b>>2]|0;f[j>>2]=a;Vf(a|0);uo(i,j);a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;xIb(h,i,k,d,e);e=f[i>>2]|0;if(!e){l=f[j>>2]|0;Ae(l|0);u=g;return}d=i+4|0;i=f[d>>2]|0;if((i|0)!=(e|0))f[d>>2]=i+(~(((i+-28-e|0)>>>0)/28|0)*28|0);YDc(e);l=f[j>>2]|0;Ae(l|0);u=g;return}function uo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+48|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(207238)|0;i=Nd(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,23864,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=e+4|0;k=e+8|0;l=a+8|0;m=0;do{n=f[b>>2]|0;f[d>>2]=m;o=bf(23864,d|0)|0;p=Nd(n|0,o|0)|0;Ae(o|0);j=+pe(p|0,4776,d|0);o=f[d>>2]|0;n=~~j>>>0;q=n;f[e>>2]=f[n>>2];f[g>>2]=f[q+4>>2];n=q+8|0;f[k>>2]=f[n>>2];f[k+4>>2]=f[n+4>>2];f[k+8>>2]=f[n+8>>2];f[k+12>>2]=f[n+12>>2];f[k+16>>2]=f[n+16>>2];Ie(o|0);o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[o>>2]=f[e>>2];f[o+4>>2]=f[g>>2];n=o+8|0;f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[n+8>>2]=f[k+8>>2];f[n+12>>2]=f[k+12>>2];f[n+16>>2]=f[k+16>>2];f[i>>2]=(f[i>>2]|0)+28}else SA(a,e);Ae(p|0);m=m+1|0}while(m>>>0<h>>>0);u=c;return}function vo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+8|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=f[b>>2]|0;f[i>>2]=a;Vf(a|0);uo(h,i);a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=c;xIb(g,h,j,d,0);d=f[h>>2]|0;if(!d){k=f[i>>2]|0;Ae(k|0);u=e;return}j=h+4|0;h=f[j>>2]|0;if((h|0)!=(d|0))f[j>>2]=h+(~(((h+-28-d|0)>>>0)/28|0)*28|0);YDc(d);k=f[i>>2]|0;Ae(k|0);u=e;return}function wo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+32|0;i=d+40|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=f[b>>2]|0;f[h>>2]=a;Vf(a|0);uo(g,h);a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=c;p[j>>3]=-1.0;p[j+8>>3]=-1.0;p[j+16>>3]=-1.0;p[j+24>>3]=-1.0;xIb(e,g,i,j,0);j=f[g>>2]|0;if(!j){k=f[h>>2]|0;Ae(k|0);u=d;return}i=g+4|0;g=f[i>>2]|0;if((g|0)!=(j|0))f[i>>2]=g+(~(((g+-28-j|0)>>>0)/28|0)*28|0);YDc(j);k=f[h>>2]|0;Ae(k|0);u=d;return}function xo(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;l=u;u=u+128|0;m=l+104|0;n=l+88|0;o=l+64|0;p=l+72|0;q=l+52|0;r=l+20|0;s=l+40|0;t=l+4|0;v=l+24|0;w=l+8|0;x=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;a=f[b>>2]|0;f[o>>2]=a;Vf(a|0);uo(n,o);f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=c;c=f[d>>2]|0;f[r>>2]=c;Vf(c|0);uo(q,r);c=f[e>>2]|0;f[t>>2]=c;Vf(c|0);yo(s,t);c=v+8|0;f[c>>2]=0;f[c+4>>2]=0;f[v>>2]=50397184;f[v+4>>2]=g;g=f[j>>2]|0;f[x>>2]=g;Vf(g|0);zo(w,x);AIb(m,n,p,q,s,v,h,i,w,k);k=f[w>>2]|0;if(k|0){i=w+4|0;if((f[i>>2]|0)!=(k|0))f[i>>2]=k;YDc(k)}Ae(f[x>>2]|0);x=f[s>>2]|0;if(x|0){k=s+4|0;s=f[k>>2]|0;if((s|0)!=(x|0))f[k>>2]=s+(~((s+-16-x|0)>>>4)<<4);YDc(x)}Ae(f[t>>2]|0);t=f[q>>2]|0;if(t|0){x=q+4|0;q=f[x>>2]|0;if((q|0)!=(t|0))f[x>>2]=q+(~(((q+-28-t|0)>>>0)/28|0)*28|0);YDc(t)}Ae(f[r>>2]|0);r=f[n>>2]|0;if(!r){y=f[o>>2]|0;Ae(y|0);u=l;return}t=n+4|0;n=f[t>>2]|0;if((n|0)!=(r|0))f[t>>2]=n+(~(((n+-28-r|0)>>>0)/28|0)*28|0);YDc(r);y=f[o>>2]|0;Ae(y|0);u=l;return}function yo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(207238)|0;i=Nd(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,23864,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=bf(23864,d|0)|0;n=Nd(l|0,m|0)|0;Ae(m|0);j=+pe(n|0,5008,d|0);m=f[d>>2]|0;l=~~j>>>0;f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];Ie(m|0);m=f[i>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];f[i>>2]=(f[i>>2]|0)+16}else TA(a,e);Ae(n|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function zo(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=jg(207238)|0;i=Nd(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,23864,e|0);Ie(f[e>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=d;return}g=a+8|0;k=0;while(1){l=f[c>>2]|0;f[e>>2]=k;m=bf(23864,e|0)|0;n=Nd(l|0,m|0)|0;Ae(m|0);j=+pe(n|0,23816,e|0);Ie(f[e>>2]|0);m=~~j;l=f[i>>2]|0;o=f[g>>2]|0;p=o;if(l>>>0>=o>>>0){o=f[a>>2]|0;q=l-o|0;r=q+1|0;s=o;if((r|0)<0){t=7;break}v=p-o|0;p=v<<1;w=v>>>0<1073741823?(p>>>0<r>>>0?r:p):2147483647;if(!w)x=0;else x=VDc(w)|0;p=x+q|0;b[p>>0]=m;r=p+(0-q)|0;if((q|0)>0)dJc(r|0,s|0,q|0)|0;f[a>>2]=r;f[i>>2]=p+1;f[g>>2]=x+w;if(o|0)YDc(s)}else{b[l>>0]=m;f[i>>2]=(f[i>>2]|0)+1}Ae(n|0);k=k+1|0;if(k>>>0>=h>>>0){t=3;break}}if((t|0)==3){u=d;return}else if((t|0)==7)mCc(a)}function Ao(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;k=u;u=u+128|0;l=k+104|0;m=k+88|0;n=k+64|0;o=k+72|0;p=k+52|0;q=k+20|0;r=k+40|0;s=k+4|0;t=k+24|0;v=k+8|0;w=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=f[b>>2]|0;f[n>>2]=a;Vf(a|0);uo(m,n);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=c;c=f[d>>2]|0;f[q>>2]=c;Vf(c|0);uo(p,q);c=f[e>>2]|0;f[s>>2]=c;Vf(c|0);yo(r,s);c=t+8|0;f[c>>2]=0;f[c+4>>2]=0;f[t>>2]=50397184;f[t+4>>2]=g;g=f[j>>2]|0;f[w>>2]=g;Vf(g|0);zo(v,w);AIb(l,m,o,p,r,t,h,i,v,0);i=f[v>>2]|0;if(i|0){h=v+4|0;if((f[h>>2]|0)!=(i|0))f[h>>2]=i;YDc(i)}Ae(f[w>>2]|0);w=f[r>>2]|0;if(w|0){i=r+4|0;r=f[i>>2]|0;if((r|0)!=(w|0))f[i>>2]=r+(~((r+-16-w|0)>>>4)<<4);YDc(w)}Ae(f[s>>2]|0);s=f[p>>2]|0;if(s|0){w=p+4|0;p=f[w>>2]|0;if((p|0)!=(s|0))f[w>>2]=p+(~(((p+-28-s|0)>>>0)/28|0)*28|0);YDc(s)}Ae(f[q>>2]|0);q=f[m>>2]|0;if(!q){x=f[n>>2]|0;Ae(x|0);u=k;return}s=m+4|0;m=f[s>>2]|0;if((m|0)!=(q|0))f[s>>2]=m+(~(((m+-28-q|0)>>>0)/28|0)*28|0);YDc(q);x=f[n>>2]|0;Ae(x|0);u=k;return}function Bo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;j=u;u=u+128|0;k=j+104|0;l=j+88|0;m=j+64|0;n=j+72|0;o=j+52|0;p=j+16|0;q=j+40|0;r=j;s=j+24|0;t=j+4|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=f[b>>2]|0;f[m>>2]=a;Vf(a|0);uo(l,m);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=c;c=f[d>>2]|0;f[p>>2]=c;Vf(c|0);uo(o,p);c=f[e>>2]|0;f[r>>2]=c;Vf(c|0);yo(q,r);c=s+8|0;f[c>>2]=0;f[c+4>>2]=0;f[s>>2]=50397184;f[s+4>>2]=g;f[t>>2]=0;g=t+4|0;f[g>>2]=0;f[t+8>>2]=0;AIb(k,l,n,o,q,s,h,i,t,0);i=f[t>>2]|0;if(i|0){if((f[g>>2]|0)!=(i|0))f[g>>2]=i;YDc(i)}i=f[q>>2]|0;if(i|0){g=q+4|0;q=f[g>>2]|0;if((q|0)!=(i|0))f[g>>2]=q+(~((q+-16-i|0)>>>4)<<4);YDc(i)}Ae(f[r>>2]|0);r=f[o>>2]|0;if(r|0){i=o+4|0;o=f[i>>2]|0;if((o|0)!=(r|0))f[i>>2]=o+(~(((o+-28-r|0)>>>0)/28|0)*28|0);YDc(r)}Ae(f[p>>2]|0);p=f[l>>2]|0;if(!p){v=f[m>>2]|0;Ae(v|0);u=j;return}r=l+4|0;l=f[r>>2]|0;if((l|0)!=(p|0))f[r>>2]=l+(~(((l+-28-p|0)>>>0)/28|0)*28|0);YDc(p);v=f[m>>2]|0;Ae(v|0);u=j;return}function Co(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+160|0;j=i+136|0;k=i+120|0;l=i+96|0;m=i+104|0;n=i+84|0;o=i+48|0;q=i+72|0;r=i+32|0;s=i+56|0;t=i;v=i+36|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=f[b>>2]|0;f[l>>2]=a;Vf(a|0);uo(k,l);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=f[d>>2]|0;f[o>>2]=c;Vf(c|0);uo(n,o);c=f[e>>2]|0;f[r>>2]=c;Vf(c|0);yo(q,r);c=s+8|0;f[c>>2]=0;f[c+4>>2]=0;f[s>>2]=50397184;f[s+4>>2]=g;p[t>>3]=-1.0;p[t+8>>3]=-1.0;p[t+16>>3]=-1.0;p[t+24>>3]=-1.0;f[v>>2]=0;g=v+4|0;f[g>>2]=0;f[v+8>>2]=0;AIb(j,k,m,n,q,s,h,t,v,0);t=f[v>>2]|0;if(t|0){if((f[g>>2]|0)!=(t|0))f[g>>2]=t;YDc(t)}t=f[q>>2]|0;if(t|0){g=q+4|0;q=f[g>>2]|0;if((q|0)!=(t|0))f[g>>2]=q+(~((q+-16-t|0)>>>4)<<4);YDc(t)}Ae(f[r>>2]|0);r=f[n>>2]|0;if(r|0){t=n+4|0;n=f[t>>2]|0;if((n|0)!=(r|0))f[t>>2]=n+(~(((n+-28-r|0)>>>0)/28|0)*28|0);YDc(r)}Ae(f[o>>2]|0);o=f[k>>2]|0;if(!o){w=f[l>>2]|0;Ae(w|0);u=i;return}r=k+4|0;k=f[r>>2]|0;if((k|0)!=(o|0))f[r>>2]=k+(~(((k+-28-o|0)>>>0)/28|0)*28|0);YDc(o);w=f[l>>2]|0;Ae(w|0);u=i;return}function Do(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+192|0;i=h+168|0;j=h+152|0;k=h+128|0;l=h+136|0;m=h+116|0;n=h+80|0;o=h+104|0;q=h+76|0;r=h+88|0;s=h+32|0;t=h;v=h+64|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;Vf(a|0);uo(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=f[d>>2]|0;f[n>>2]=c;Vf(c|0);uo(m,n);c=f[e>>2]|0;f[q>>2]=c;Vf(c|0);yo(o,q);c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=50397184;f[r+4>>2]=g;p[s>>3]=-1.0;p[s+8>>3]=-1.0;p[s+16>>3]=-1.0;p[s+24>>3]=-1.0;p[t>>3]=-1.0;p[t+8>>3]=-1.0;p[t+16>>3]=-1.0;p[t+24>>3]=-1.0;f[v>>2]=0;g=v+4|0;f[g>>2]=0;f[v+8>>2]=0;AIb(i,j,l,m,o,r,s,t,v,0);t=f[v>>2]|0;if(t|0){if((f[g>>2]|0)!=(t|0))f[g>>2]=t;YDc(t)}t=f[o>>2]|0;if(t|0){g=o+4|0;o=f[g>>2]|0;if((o|0)!=(t|0))f[g>>2]=o+(~((o+-16-t|0)>>>4)<<4);YDc(t)}Ae(f[q>>2]|0);q=f[m>>2]|0;if(q|0){t=m+4|0;m=f[t>>2]|0;if((m|0)!=(q|0))f[t>>2]=m+(~(((m+-28-q|0)>>>0)/28|0)*28|0);YDc(q)}Ae(f[n>>2]|0);n=f[j>>2]|0;if(!n){w=f[k>>2]|0;Ae(w|0);u=h;return}q=j+4|0;j=f[q>>2]|0;if((j|0)!=(n|0))f[q>>2]=j+(~(((j+-28-n|0)>>>0)/28|0)*28|0);YDc(n);w=f[k>>2]|0;Ae(w|0);u=h;return}function Eo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;c=iQ(e,g,h)|0;u=d;return c|0}function Fo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b=iQ(d,e,e0()|0)|0;u=c;return b|0}function Go(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;p=m+8|0;f[p>>2]=0;f[p+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=a;f[n>>2]=f[b>>2];f[n+4>>2]=f[b+4>>2];f[o>>2]=f[c>>2];f[o+4>>2]=f[c+4>>2];Fga(m,n,o,d,e,g,h,i,j,k);u=l;return}function Ho(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;o=l+8|0;f[o>>2]=0;f[o+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];Fga(l,m,n,d,e,g,h,i,j,0);u=k;return}function Io(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;n=k+8|0;f[n>>2]=0;f[n+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l>>2]=f[b>>2];f[l+4>>2]=f[b+4>>2];f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];Fga(k,l,m,d,e,g,h,i,8,0);u=j;return}function Jo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Fga(j,k,l,d,e,g,h,1,8,0);u=i;return}function Ko(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;Gga(h,b,c,d,e);u=g;return}function Lo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;Gga(g,b,c,d,8);u=e;return}function Mo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;Gga(e,b,c,1,8);u=d;return}function No(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[a>>2];f[j+4>>2]=f[a+4>>2];f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];dga(j,k,c,d,e,g,h);u=i;return}function Oo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;hha(d,e);u=c;return}function Po(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];$ja(j,k,l,m,e,g,h);u=i;return}function Qo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;$ja(i,j,k,l,e,g,m);u=h;return}function Ro(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;$ja(h,i,j,k,e,0,l);u=g;return}function So(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;$ja(g,h,i,j,1,0,k);u=e;return}function To(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=-1;f[i+4>>2]=-1;p[j>>3]=1797693134862315708145274.0e284;p[j+8>>3]=1797693134862315708145274.0e284;p[j+16>>3]=1797693134862315708145274.0e284;p[j+24>>3]=1797693134862315708145274.0e284;$ja(e,g,h,i,1,0,j);u=d;return}function Uo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;mEa(a,g,h,d);u=e;return}function Vo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;nEa(a,j,k,d,e,g,h);u=i;return}function Wo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b3(d,e);u=c;return}function Xo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];kwa(j,k,c,l,m,g,h);u=i;return}function Yo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+40|0;j=h+24|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];kwa(i,j,c,k,l,g,4);u=h;return}function Zo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];kwa(h,i,c,j,k,0.0,4);u=g;return}function _o(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;f[j>>2]=-1;f[j+4>>2]=-1;kwa(g,h,c,i,j,0.0,4);u=e;return}function $o(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+64|0;i=h+40|0;j=h+24|0;k=h+8|0;l=h;m=i+8|0;f[m>>2]=0;f[m+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33882112;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];wfa(i,j,k,d,e,l);u=h;return}function ap(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g+8|0;k=g;l=h+8|0;f[l>>2]=0;f[l+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k>>2]=0;f[k+4>>2]=0;wfa(h,i,j,d,e,k);u=g;return}function bp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0.0;h=u;u=u+80|0;i=h;j=h+64|0;k=h+48|0;l=h+32|0;m=h+16|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;b=l+8|0;f[b>>2]=0;f[b+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=c;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];n=+OEa(j,k,l,d,i,m);u=h;return +n}function cp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0;g=u;u=u+80|0;h=g+16|0;i=g+64|0;j=g+48|0;k=g+32|0;l=g;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];e=e0()|0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];m=+OEa(i,j,k,d,h,e);u=g;return +m}function dp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0;e=u;u=u+80|0;g=e+16|0;h=e+64|0;i=e+48|0;j=e+32|0;k=e;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=c;f[k>>2]=3;f[k+4>>2]=50;p[k+8>>3]=.001;c=e0()|0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];l=+OEa(h,i,j,d,g,c);u=e;return +l}function ep(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0;d=u;u=u+80|0;e=d+16|0;g=d+64|0;h=d+48|0;i=d+32|0;j=d;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=c;f[j>>2]=3;f[j+4>>2]=50;p[j+8>>3]=.001;c=e0()|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];k=+OEa(g,h,i,2,e,c);u=d;return +k}function fp(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;Pxa(a,d);u=c;return}function gp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Opa(i,j,c,d,e,g);u=h;return}function hp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;m_(e,g,c);u=d;return}function ip(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i+16|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=g;MN(j,k,c,l,e,m,h);u=i;return}function jp(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+48|0;j=h+32|0;k=h+16|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;d=l+8|0;f[d>>2]=0;f[d+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=g;MN(i,j,c,k,e,l,0);u=h;return}function kp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;zpa(a,e,g);u=d;return}function lp(a){a=a|0;return wN(a)|0}function mp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;ypa(a,e,g);u=d;return}function np(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];vpa(a,g,c,d);u=e;return}function op(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];Zja(a,b,g,h);u=e;return}function pp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[g>>2]=-1;f[g+4>>2]=-1;Zja(a,b,e,g);u=d;return}function qp(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=g;ooa(l,m,c,d,e,n,h,i,j);u=k;return}function rp(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+16|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;ooa(k,l,c,d,e,m,h,i,.04);u=j;return}function sp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;ooa(j,k,c,d,e,l,h,0,.04);u=i;return}function tp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;ooa(i,j,c,d,e,k,3,0,.04);u=h;return}function up(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;ooa(h,i,c,d,e,e0()|0,3,0,.04);u=g;return}function vp(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+32|0;n=l+16|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;a=n+8|0;f[a>>2]=0;f[a+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=b;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=g;foa(m,n,c,d,e,o,h,i,j,k);u=l;return}function wp(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=g;foa(l,m,c,d,e,n,h,i,j,.04);u=k;return}function xp(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+16|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;foa(k,l,c,d,e,m,h,i,0,.04);u=j;return}function yp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+80|0;j=i+64|0;k=i+48|0;l=i+16|0;m=i+32|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=b;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=d;d=n+8|0;f[d>>2]=0;f[d+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=e;toa(j,k,l,m,n,g,h);u=i;return}function zp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+80|0;i=h+64|0;j=h+48|0;k=h+16|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[k+8>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=d;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=e;toa(i,j,k,l,m,g,2);u=h;return}function Ap(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aPb(a,b,c,d);return}function Bp(a,b,c){a=a|0;b=b|0;c=c|0;aPb(a,b,c,.2);return}function Cp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;eR(d,e);u=c;return}function Dp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;vL(g,h,i,j);u=e;return}function Ep(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=u;u=u+112|0;k=j+88|0;l=j+72|0;m=j+56|0;n=j+40|0;o=j+16|0;p=j+24|0;q=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=d;f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];e=p+8|0;f[e>>2]=0;f[e+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;h=q+8|0;f[h>>2]=0;f[h+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=i;Gpa(k,l,m,n,o,g,p,q);u=j;return}function Fp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;jqa(e,g,c);u=d;return}function Gp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;jqa(d,e,-1);u=c;return}function Hp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;kqa(h,i,j,d,e);u=g;return}function Ip(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;kqa(g,h,i,d,-1);u=e;return}function Jp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;kqa(e,g,h,-1,-1);u=d;return}function Kp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;h=+fQ(e,g,c);u=d;return +h}function Lp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;g=+fQ(d,e,0);u=c;return +g}function Mp(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;a=jya(c)|0;u=b;return a|0}function Np(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0;i=u;u=u+64|0;j=i;k=i+48|0;l=i+32|0;m=i+16|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=h;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];n=+g2(k,b,l,j,e,g,m);u=i;return +n}function Op(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0;h=u;u=u+64|0;i=h+16|0;j=h+48|0;k=h+32|0;l=h;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[l+8>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];d=e0()|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];m=+g2(j,b,k,i,e,g,d);u=h;return +m}function Pp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];jga(j,k,l,d,e,g,h);u=i;return}function Qp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];jga(i,j,k,d,e,g,0);u=h;return}function Rp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];jga(h,i,j,d,e,8,0);u=g;return}function Sp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];jga(g,h,i,d,1,8,0);u=e;return}function Tp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;c3(d,e);u=c;return}function Up(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;_2(e,g,h);u=d;return}function Vp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0.0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;i=+nka(g,h,c,d);u=e;return +i}function Wp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=e;Cfa(h,i,j,d,k);u=g;return}function Xp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;Cfa(g,h,i,d,e0()|0);u=e;return}function Yp(a,b,c){a=a|0;b=b|0;c=c|0;kL(a,b,c);return}function Zp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;D2(a,e,g);u=d;return}function _p(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;D2(a,d,e0()|0);u=c;return}function $p(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;F2(g,h,i,j);u=e;return}function aq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;F2(e,g,h,e0()|0);u=d;return}function bq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Uxa(e,g,c);u=d;return}function cq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;WZ(d,e);u=c;return}function dq(a,b,c){a=a|0;b=b|0;c=c|0;lL(a,b,c);return}function eq(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;Apa(a,d);u=c;return}function fq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+4|0;i=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50659328;f[g+4>>2]=b;b=f[c>>2]|0;f[i>>2]=b;Vf(b|0);bn(h,i);$Q(e,g,h);g=f[h>>2]|0;if(!g){j=f[i>>2]|0;Ae(j|0);u=d;return}e=h+4|0;h=f[e>>2]|0;if((h|0)!=(g|0))f[e>>2]=h+(~((h+-4-g|0)>>>2)<<2);YDc(g);j=f[i>>2]|0;Ae(j|0);u=d;return}function gq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;eka(a,e,c);u=d;return}function hq(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;eka(a,d,0);u=c;return}function iq(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+64|0;k=j+40|0;l=j+24|0;m=j+8|0;n=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];cka(k,l,c,m,n,g,h,i);u=j;return}function jq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+96|0;j=i+72|0;k=i+56|0;l=i+40|0;m=i+32|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];p[n>>3]=1797693134862315708145274.0e284;p[n+8>>3]=1797693134862315708145274.0e284;p[n+16>>3]=1797693134862315708145274.0e284;p[n+24>>3]=1797693134862315708145274.0e284;cka(j,k,c,l,m,g,h,n);u=i;return}function kq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;cka(i,j,c,k,l,g,0,m);u=h;return}function lq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;cka(h,i,c,j,k,1,0,l);u=g;return}function mq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;f[j>>2]=-1;f[j+4>>2]=-1;p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;cka(g,h,c,i,j,1,0,k);u=e;return}function nq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;qL(h,i,j,d,e);u=g;return}function oq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;qL(g,h,i,d,-1);u=e;return}function pq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;qL(e,g,h,1.0,-1);u=d;return}function qq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;h=+PO(e,b,g);u=d;return +h}function rq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+PO(d,b,e0()|0);u=c;return +e}function sq(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+PO(c,4,e0()|0);u=b;return +d}function tq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;j=+uP(g,h,c,i);u=e;return +j}function uq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;h=+uP(e,g,c,e0()|0);u=d;return +h}function vq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;g=+uP(d,e,4,e0()|0);u=c;return +g}function wq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;IM(j,k,c,d,e,g,l);u=i;return}function xq(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=b;IM(i,j,c,d,e,g,e0()|0);u=h;return}function yq(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=b;IM(h,i,c,d,e,-1,e0()|0);u=g;return}function zq(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=b;IM(g,h,c,d,4,-1,e0()|0);u=e;return}function Aq(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=b;IM(e,g,c,0.0,4,-1,e0()|0);u=d;return}function Bq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=b;IM(d,e,1.0,0.0,4,-1,e0()|0);u=c;return}function Cq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;aO(e,g,h);u=d;return}function Dq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+8|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];h=+mha(e,g,c);u=d;return +h}function Eq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;a3(h,i,j,k,e);u=g;return}function Fq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;a3(g,h,i,j,0);u=e;return}function Gq(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;d3(e,b,g);u=d;return}function Hq(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0;l=u;u=u+64|0;m=l+48|0;n=l+40|0;o=l+32|0;q=l;r=m+8|0;f[r>>2]=0;f[r+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=a;f[n>>2]=0;f[n+4>>2]=0;a=c+11|0;r=b[a>>0]|0;s=r<<24>>24<0?f[c+4>>2]|0:r&255;if(s|0){r=tT(n,s)|0;dJc(r|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,s|0)|0}f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];p[q>>3]=+p[h>>3];p[q+8>>3]=+p[h+8>>3];p[q+16>>3]=+p[h+16>>3];p[q+24>>3]=+p[h+24>>3];Hga(m,n,o,e,g,q,i,j,k);uT(n);u=l;return}function Iq(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0;k=u;u=u+64|0;l=k+48|0;m=k+40|0;n=k+32|0;o=k;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m>>2]=0;f[m+4>>2]=0;a=c+11|0;q=b[a>>0]|0;r=q<<24>>24<0?f[c+4>>2]|0:q&255;if(r|0){q=tT(m,r)|0;dJc(q|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,r|0)|0}f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];p[o>>3]=+p[h>>3];p[o+8>>3]=+p[h+8>>3];p[o+16>>3]=+p[h+16>>3];p[o+24>>3]=+p[h+24>>3];Hga(l,m,n,e,g,o,i,j,0);uT(m);u=k;return}function Jq(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0;j=u;u=u+64|0;k=j+48|0;l=j+40|0;m=j+32|0;n=j;o=k+8|0;f[o>>2]=0;f[o+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l>>2]=0;f[l+4>>2]=0;a=c+11|0;o=b[a>>0]|0;q=o<<24>>24<0?f[c+4>>2]|0:o&255;if(q|0){o=tT(l,q)|0;dJc(o|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,q|0)|0}f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];p[n>>3]=+p[h>>3];p[n+8>>3]=+p[h+8>>3];p[n+16>>3]=+p[h+16>>3];p[n+24>>3]=+p[h+24>>3];Hga(k,l,m,e,g,n,i,8,0);uT(l);u=j;return}function Kq(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+64|0;j=i+48|0;k=i+40|0;l=i+32|0;m=i;n=j+8|0;f[n>>2]=0;f[n+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=0;f[k+4>>2]=0;a=c+11|0;n=b[a>>0]|0;o=n<<24>>24<0?f[c+4>>2]|0:n&255;if(o|0){n=tT(k,o)|0;dJc(n|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,o|0)|0}f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=+p[h>>3];p[m+8>>3]=+p[h+8>>3];p[m+16>>3]=+p[h+16>>3];p[m+24>>3]=+p[h+24>>3];Hga(j,k,l,e,g,m,1,8,0);uT(k);u=i;return}function Lq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;tna(g,h,c,d);u=e;return}function Mq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;tna(e,g,c,4);u=d;return}function Nq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c+24|0;e=c+8|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;tna(d,e,g,4);u=c;return}function Oq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Ana(g,h,c,d);u=e;return}function Pq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Ana(e,g,c,4);u=d;return}function Qq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c+24|0;e=c+8|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;Ana(d,e,g,4);u=c;return}function Rq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;N4(e,g,h);u=d;return}function Sq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;M4(e,g,h);u=d;return}function Tq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Dga(j,k,l,d,e,g,h);u=i;return}function Uq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Dga(i,j,k,d,e,g,0);u=h;return}function Vq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Dga(h,i,j,d,e,8,0);u=g;return}function Wq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Dga(g,h,i,d,1,8,0);u=e;return}function Xq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;FR(h,i,c,d,e);u=g;return}function Yq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;FR(g,h,c,d,-1);u=e;return}function Zq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i+16|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;Moa(j,k,l,m,e,g,h);u=i;return}function _q(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+80|0;j=h+64|0;k=h+48|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Moa(i,j,k,l,e,g,m);u=h;return}function $q(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+80|0;i=g+64|0;j=g+48|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Moa(h,i,j,k,e,0,l);u=g;return}function ar(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;o_(g,b,c,h);u=e;return}function br(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];nfa(i,j,k,d,e,g);u=h;return}function cr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];nfa(h,i,j,d,e,1);u=g;return}function dr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];nfa(g,h,i,d,0.0,1);u=e;return}function er(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d+8|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];nfa(e,g,h,0.0,0.0,1);u=d;return}function fr(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+80|0;k=j+56|0;l=j+40|0;m=j+24|0;n=j+8|0;o=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=e;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];lwa(k,l,c,m,n,o,h,i);u=j;return}function gr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+80|0;j=i+56|0;k=i+40|0;l=i+24|0;m=i+8|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=e;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];lwa(j,k,c,l,m,n,h,4);u=i;return}function hr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+80|0;i=h+56|0;j=h+40|0;k=h+24|0;l=h+8|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=e;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];lwa(i,j,c,k,l,m,0.0,4);u=h;return}function ir(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+56|0;i=g+40|0;j=g+24|0;k=g+8|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=e;f[l>>2]=-1;f[l+4>>2]=-1;lwa(h,i,c,j,k,l,0.0,4);u=g;return}function jr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=50397184;f[d+4>>2]=a;hR(d,b);u=c;return}function kr(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+48|0;c=b+32|0;d=b;e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=50397184;f[c+4>>2]=a;p[d>>3]=1.0;a=d+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;hR(c,d);u=b;return}function lr(a){a=a|0;L4(a);return}function mr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=oQ(g,h,i,d)|0;u=e;return c|0}function nr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;c=oQ(e,g,h,0)|0;u=d;return c|0}function or(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;h=+q3(e,g,c);u=d;return +h}function pr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;g=+q3(d,e,300);u=c;return +g}function qr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33882112;f[e+4>>2]=b;RY(d,e);u=c;return}function rr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;l3(d,e);u=c;return}function sr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;oL(h,i,j,k,e);u=g;return}function tr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;oL(g,h,i,j,-1);u=e;return}function ur(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;oL(e,g,h,e0()|0,-1);u=d;return}function vr(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0,j=0.0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;j=+Cxa(h,i,c,d,e);u=g;return +j}function wr(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;iR(a,d);u=c;return}function xr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;NN(e,g,h);u=d;return}function yr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;jR(d,e);u=c;return}function zr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+64|0;i=g+48|0;j=g+32|0;k=g+16|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=e;Npa(h,i,j,k,l);u=g;return}function Ar(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;Npa(g,h,i,j,e0()|0);u=e;return}function Br(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;gR(d,e);u=c;return}function Cr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];opa(j,k,l,m,e,g,h);u=i;return}function Dr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;opa(i,j,k,l,e,g,m);u=h;return}function Er(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;opa(h,i,j,k,e,0,l);u=g;return}function Fr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;opa(g,h,i,j,1,0,k);u=e;return}function Gr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];upa(j,k,l,m,e,g,h);u=i;return}function Hr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;upa(i,j,k,l,e,g,m);u=h;return}function Ir(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;upa(h,i,j,k,e,0,l);u=g;return}function Jr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;upa(g,h,i,j,1,0,k);u=e;return}function Kr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=b;lka(d,e);u=c;return}function Lr(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;oFa(a,k,c,d,e,g,h,i);u=j;return}function Mr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;oFa(a,j,c,d,e,g,h,5);u=i;return}function Nr(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;oFa(a,i,c,d,e,g,0,5);u=h;return}function Or(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;oFa(a,h,c,d,e,0,0,5);u=g;return}function Pr(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0;e=u;u=u+48|0;g=e+32|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;oFa(a,g,c,d,h,0,0,5);u=e;return}function Qr(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;d=u;u=u+64|0;e=d+40|0;g=d+32|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;oFa(a,e,c,g,h,0,0,5);u=d;return}function Rr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+64|0;d=c+40|0;e=c+32|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;f[e>>2]=0;f[e+4>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;oFa(a,d,1.0,e,g,0,0,5);u=c;return}function Sr(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h>>2]=0;f[h+4>>2]=0;k=c+11|0;l=b[k>>0]|0;m=l<<24>>24<0?f[c+4>>2]|0:l&255;if(m|0){l=tT(h,m)|0;dJc(l|0,((b[k>>0]|0)<0?f[c>>2]|0:c)|0,m|0)|0}f[i>>2]=0;f[i+4>>2]=0;m=d+11|0;c=b[m>>0]|0;k=c<<24>>24<0?f[d+4>>2]|0:c&255;if(k|0){c=tT(i,k)|0;dJc(c|0,((b[m>>0]|0)<0?f[d>>2]|0:d)|0,k|0)|0}f[j>>2]=0;f[j+4>>2]=0;k=e+11|0;d=b[k>>0]|0;m=d<<24>>24<0?f[e+4>>2]|0:d&255;if(!m){OHa(a,h,i,j);uT(j);uT(i);uT(h);u=g;return}d=tT(j,m)|0;dJc(d|0,((b[k>>0]|0)<0?f[e>>2]|0:e)|0,m|0)|0;OHa(a,h,i,j);uT(j);uT(i);uT(h);u=g;return}function Tr(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g>>2]=0;f[g+4>>2]=0;j=c+11|0;k=b[j>>0]|0;l=k<<24>>24<0?f[c+4>>2]|0:k&255;if(l|0){k=tT(g,l)|0;dJc(k|0,((b[j>>0]|0)<0?f[c>>2]|0:c)|0,l|0)|0}f[h>>2]=0;f[h+4>>2]=0;l=d+11|0;c=b[l>>0]|0;j=c<<24>>24<0?f[d+4>>2]|0:c&255;if(j|0){c=tT(h,j)|0;dJc(c|0,((b[l>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0}f[i>>2]=0;f[i+4>>2]=0;OHa(a,g,h,i);uT(i);uT(h);uT(g);u=e;return}function Ur(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[e>>2]=0;f[e+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=tT(e,k)|0;dJc(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;OHa(a,e,g,h);uT(h);uT(g);uT(e);u=d;return}function Vr(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+48|0;h=g+32|0;i=g+20|0;j=g+4|0;k=g+8|0;l=g;f[h>>2]=0;f[h+4>>2]=0;m=c+11|0;n=b[m>>0]|0;o=n<<24>>24<0?f[c+4>>2]|0:n&255;if(o|0){n=tT(h,o)|0;dJc(n|0,((b[m>>0]|0)<0?f[c>>2]|0:c)|0,o|0)|0}o=f[d>>2]|0;f[j>>2]=o;Vf(o|0);Wr(i,j);o=f[e>>2]|0;f[l>>2]=o;Vf(o|0);Wr(k,l);PHa(a,h,i,k);a=f[k>>2]|0;if(a|0){o=k+4|0;if((f[o>>2]|0)!=(a|0))f[o>>2]=a;YDc(a)}Ae(f[l>>2]|0);l=f[i>>2]|0;if(!l){p=f[j>>2]|0;Ae(p|0);uT(h);u=g;return}a=i+4|0;if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);p=f[j>>2]|0;Ae(p|0);uT(h);u=g;return}function Wr(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=jg(207238)|0;i=Nd(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,23864,e|0);Ie(f[e>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=d;return}g=a+8|0;k=0;while(1){l=f[c>>2]|0;f[e>>2]=k;m=bf(23864,e|0)|0;n=Nd(l|0,m|0)|0;Ae(m|0);j=+pe(n|0,23824,e|0);Ie(f[e>>2]|0);m=~~j&255;l=f[i>>2]|0;o=f[g>>2]|0;p=o;if(l>>>0>=o>>>0){o=f[a>>2]|0;q=l-o|0;r=q+1|0;s=o;if((r|0)<0){t=7;break}v=p-o|0;p=v<<1;w=v>>>0<1073741823?(p>>>0<r>>>0?r:p):2147483647;if(!w)x=0;else x=VDc(w)|0;p=x+q|0;b[p>>0]=m;r=p+(0-q)|0;if((q|0)>0)dJc(r|0,s|0,q|0)|0;f[a>>2]=r;f[i>>2]=p+1;f[g>>2]=x+w;if(o|0)YDc(s)}else{b[l>>0]=m;f[i>>2]=(f[i>>2]|0)+1}Ae(n|0);k=k+1|0;if(k>>>0>=h>>>0){t=3;break}}if((t|0)==3){u=d;return}else if((t|0)==7)mCc(a)}function Xr(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;j=e+4|0;f[g>>2]=0;f[g+4>>2]=0;k=c+11|0;l=b[k>>0]|0;m=l<<24>>24<0?f[c+4>>2]|0:l&255;if(m|0){l=tT(g,m)|0;dJc(l|0,((b[k>>0]|0)<0?f[c>>2]|0:c)|0,m|0)|0}m=f[d>>2]|0;f[i>>2]=m;Vf(m|0);Wr(h,i);f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;PHa(a,g,h,j);a=f[j>>2]|0;if(a|0){if((f[m>>2]|0)!=(a|0))f[m>>2]=a;YDc(a)}a=f[h>>2]|0;if(!a){n=f[i>>2]|0;Ae(n|0);uT(g);u=e;return}m=h+4|0;if((f[m>>2]|0)!=(a|0))f[m>>2]=a;YDc(a);n=f[i>>2]|0;Ae(n|0);uT(g);u=e;return}function Yr(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=0;f[g+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=tT(g,k)|0;dJc(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[h>>2]=0;f[h+4>>2]=0;k=d+11|0;c=b[k>>0]|0;i=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!i){qLa(a,g,h);uT(h);uT(g);u=e;return}c=tT(h,i)|0;dJc(c|0,((b[k>>0]|0)<0?f[d>>2]|0:d)|0,i|0)|0;qLa(a,g,h);uT(h);uT(g);u=e;return}function Zr(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=0;f[e+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;if(j|0){i=tT(e,j)|0;dJc(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,j|0)|0}f[g>>2]=0;f[g+4>>2]=0;qLa(a,e,g);uT(g);uT(e);u=d;return}function _r(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+20|0;g=d+4|0;h=d+8|0;i=d;j=f[b>>2]|0;f[g>>2]=j;Vf(j|0);Wr(e,g);j=f[c>>2]|0;f[i>>2]=j;Vf(j|0);Wr(h,i);DLa(a,e,h);a=f[h>>2]|0;if(a|0){j=h+4|0;if((f[j>>2]|0)!=(a|0))f[j>>2]=a;YDc(a)}Ae(f[i>>2]|0);i=f[e>>2]|0;if(!i){k=f[g>>2]|0;Ae(k|0);u=d;return}a=e+4|0;if((f[a>>2]|0)!=(i|0))f[a>>2]=i;YDc(i);k=f[g>>2]|0;Ae(k|0);u=d;return}function $r(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c+16|0;e=c;g=c+4|0;h=f[b>>2]|0;f[e>>2]=h;Vf(h|0);Wr(d,e);f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;DLa(a,d,g);a=f[g>>2]|0;if(a|0){if((f[h>>2]|0)!=(a|0))f[h>>2]=a;YDc(a)}a=f[d>>2]|0;if(!a){i=f[e>>2]|0;Ae(i|0);u=c;return}h=d+4|0;if((f[h>>2]|0)!=(a|0))f[h>>2]=a;YDc(a);i=f[e>>2]|0;Ae(i|0);u=c;return}function as(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=0;f[g+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=tT(g,k)|0;dJc(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[h>>2]=0;f[h+4>>2]=0;k=d+11|0;c=b[k>>0]|0;i=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!i){$Ka(a,g,h);uT(h);uT(g);u=e;return}c=tT(h,i)|0;dJc(c|0,((b[k>>0]|0)<0?f[d>>2]|0:d)|0,i|0)|0;$Ka(a,g,h);uT(h);uT(g);u=e;return}function bs(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=0;f[e+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;if(j|0){i=tT(e,j)|0;dJc(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,j|0)|0}f[g>>2]=0;f[g+4>>2]=0;$Ka(a,e,g);uT(g);uT(e);u=d;return}function cs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+20|0;g=d+4|0;h=d+8|0;i=d;j=f[b>>2]|0;f[g>>2]=j;Vf(j|0);Wr(e,g);j=f[c>>2]|0;f[i>>2]=j;Vf(j|0);Wr(h,i);pLa(a,e,h);a=f[h>>2]|0;if(a|0){j=h+4|0;if((f[j>>2]|0)!=(a|0))f[j>>2]=a;YDc(a)}Ae(f[i>>2]|0);i=f[e>>2]|0;if(!i){k=f[g>>2]|0;Ae(k|0);u=d;return}a=e+4|0;if((f[a>>2]|0)!=(i|0))f[a>>2]=i;YDc(i);k=f[g>>2]|0;Ae(k|0);u=d;return}function ds(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c+16|0;e=c;g=c+4|0;h=f[b>>2]|0;f[e>>2]=h;Vf(h|0);Wr(d,e);f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;pLa(a,d,g);a=f[g>>2]|0;if(a|0){if((f[h>>2]|0)!=(a|0))f[h>>2]=a;YDc(a)}a=f[d>>2]|0;if(!a){i=f[e>>2]|0;Ae(i|0);u=c;return}h=d+4|0;if((f[h>>2]|0)!=(a|0))f[h>>2]=a;YDc(a);i=f[e>>2]|0;Ae(i|0);u=c;return}function es(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c+11|0;h=b[g>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;if(i|0){h=tT(e,i)|0;dJc(h|0,((b[g>>0]|0)<0?f[c>>2]|0:c)|0,i|0)|0}yIa(a,e);uT(e);u=d;return}function fs(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=0;f[g+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=tT(g,k)|0;dJc(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[h>>2]=0;f[h+4>>2]=0;k=d+11|0;c=b[k>>0]|0;i=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!i){RIa(a,g,h);uT(h);uT(g);u=e;return}c=tT(h,i)|0;dJc(c|0,((b[k>>0]|0)<0?f[d>>2]|0:d)|0,i|0)|0;RIa(a,g,h);uT(h);uT(g);u=e;return}function gs(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=0;f[e+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;if(j|0){i=tT(e,j)|0;dJc(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,j|0)|0}f[g>>2]=0;f[g+4>>2]=0;RIa(a,e,g);uT(g);uT(e);u=d;return}function hs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+20|0;g=d+4|0;h=d+8|0;i=d;j=f[b>>2]|0;f[g>>2]=j;Vf(j|0);Wr(e,g);j=f[c>>2]|0;f[i>>2]=j;Vf(j|0);Wr(h,i);_Ja(a,e,h);a=f[h>>2]|0;if(a|0){j=h+4|0;if((f[j>>2]|0)!=(a|0))f[j>>2]=a;YDc(a)}Ae(f[i>>2]|0);i=f[e>>2]|0;if(!i){k=f[g>>2]|0;Ae(k|0);u=d;return}a=e+4|0;if((f[a>>2]|0)!=(i|0))f[a>>2]=i;YDc(i);k=f[g>>2]|0;Ae(k|0);u=d;return}function is(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c+16|0;e=c;g=c+4|0;h=f[b>>2]|0;f[e>>2]=h;Vf(h|0);Wr(d,e);f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;_Ja(a,d,g);a=f[g>>2]|0;if(a|0){if((f[h>>2]|0)!=(a|0))f[h>>2]=a;YDc(a)}a=f[d>>2]|0;if(!a){i=f[e>>2]|0;Ae(i|0);u=c;return}h=d+4|0;if((f[h>>2]|0)!=(a|0))f[h>>2]=a;YDc(a);i=f[e>>2]|0;Ae(i|0);u=c;return}function js(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;if(j|0){i=tT(g,j)|0;dJc(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,j|0)|0}FKa(a,g,d);uT(g);u=e;return}function ks(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c+11|0;h=b[g>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;if(i|0){h=tT(e,i)|0;dJc(h|0,((b[g>>0]|0)<0?f[c>>2]|0:c)|0,i|0)|0}FKa(a,e,1);uT(e);u=d;return}function ls(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e+8|0;h=e;i=f[(f[a>>2]|0)+20>>2]|0;f[g>>2]=0;f[g+4>>2]=0;j=c+11|0;k=b[j>>0]|0;l=k<<24>>24<0?f[c+4>>2]|0:k&255;if(l|0){k=tT(g,l)|0;dJc(k|0,((b[j>>0]|0)<0?f[c>>2]|0:c)|0,l|0)|0}f[h>>2]=0;f[h+4>>2]=0;l=d+11|0;c=b[l>>0]|0;j=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!j){m=hj[i&511](a,g,h)|0;uT(h);uT(g);u=e;return m|0}c=tT(h,j)|0;dJc(c|0,((b[l>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0;m=hj[i&511](a,g,h)|0;uT(h);uT(g);u=e;return m|0}function ms(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;h=f[(f[a>>2]|0)+20>>2]|0;f[e>>2]=0;f[e+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=tT(e,k)|0;dJc(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[g>>2]=0;f[g+4>>2]=0;k=hj[h&511](a,e,g)|0;uT(g);uT(e);u=d;return k|0}function ns(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+8>>2]|0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;mi[e&2047](a,d);u=c;return}function os(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;p=f[(f[a>>2]|0)+44>>2]|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];Yg[p&3](a,m,c,d,e,n,o,i,j,k);u=l;return}function ps(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;o=f[(f[a>>2]|0)+44>>2]|0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];Yg[o&3](a,l,c,d,e,m,n,i,j,0);u=k;return}function qs(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;n=f[(f[a>>2]|0)+44>>2]|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];Yg[n&3](a,k,c,d,e,l,m,i,2.0,0);u=j;return}function rs(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=f[(f[a>>2]|0)+44>>2]|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];Yg[m&3](a,j,c,d,e,k,l,1.05,2.0,0);u=i;return}function ss(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=f[(f[a>>2]|0)+44>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[k>>2]=0;f[k+4>>2]=0;Yg[l&3](a,i,c,d,e,j,k,1.05,2.0,0);u=h;return}function ts(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=f[(f[a>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;Yg[k&3](a,h,c,d,e,i,j,1.05,2.0,0);u=g;return}function us(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=f[(f[a>>2]|0)+44>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;Yg[j&3](a,g,c,d,0.0,h,i,1.05,2.0,0);u=e;return}function vs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;$h[i&63](a,g,h,d);u=e;return}function ws(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;$h[h&63](a,e,g,-1.0);u=d;return}function xs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+36>>2]|0;g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;mi[e&2047](a,d);u=c;return}function ys(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;RDa(a,b,c,d);return}function zs(a,b,c){a=a|0;b=b|0;c=+c;RDa(a,b,c,1);return}function As(a,b){a=a|0;b=b|0;RDa(a,b,16.0,1);return}function Bs(a){a=a|0;RDa(a,500,16.0,1);return}function Cs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;$h[i&63](a,g,h,d);u=e;return}function Ds(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;$h[h&63](a,e,g,-1.0);u=d;return}function Es(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+44>>2]|0;f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];mi[e&2047](a,d);u=c;return}function Fs(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];mya(a,b,e);u=d;return}function Gs(a,b){a=a|0;b=+b;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=8;f[d+4>>2]=8;mya(a,b,d);u=c;return}function Hs(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=8;f[c+4>>2]=8;mya(a,40.0,c);u=b;return}function Is(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+36>>2]&31](a,b);return}function Js(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;Ti[h&511](a,e,g);u=d;return}function Ks(a,b,c){a=a|0;b=b|0;c=c|0;mLb(a,b,c);return}function Ls(a,b){a=a|0;b=b|0;mLb(a,b,0);return}function Ms(a){a=a|0;mLb(a,4,0);return}function Ns(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function Os(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+96>>2]&2047](a,b);return}function Ps(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+88>>2]&2047](a,b);return}function Qs(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;eKb(a,b,c,d,e,f,g);return}function Rs(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;eKb(a,b,c,d,e,f,1);return}function Ss(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;eKb(a,b,c,d,e,4,1);return}function Ts(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;eKb(a,b,c,d,4,4,1);return}function Us(a,b,c){a=a|0;b=b|0;c=c|0;eKb(a,b,c,1.0000000474974513e-03,4,4,1);return}function Vs(a,b){a=a|0;b=b|0;eKb(a,b,0,1.0000000474974513e-03,4,4,1);return}function Ws(a){a=a|0;eKb(a,0,0,1.0000000474974513e-03,4,4,1);return}function Xs(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function Ys(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+104>>2]&2047](a,b);return}function Zs(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function _s(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+80>>2]&31](a,b);return}function $s(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function at(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;ei[i&511](a,g,c,h);u=e;return}function bt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=e0()|0;ei[g&511](a,e,c,b);u=d;return}function ct(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+36>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=17104896;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=d;ei[i&511](a,g,c,h);u=e;return}function dt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[(f[a>>2]|0)+36>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=b;b=e0()|0;ei[g&511](a,e,c,b);u=d;return}function et(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+40>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;ei[i&511](a,g,c,h);u=e;return}function ft(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+44>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=17104896;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33882112;f[h+4>>2]=d;ei[i&511](a,g,c,h);u=e;return}function gt(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;l=f[(f[a>>2]|0)+48>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=e;Fh[l&255](a,i,j,d,k,g);u=h;return}function ht(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;k=f[(f[a>>2]|0)+48>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=e;Fh[k&255](a,h,i,d,j,0);u=g;return}function it(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function jt(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+96>>2]&2047](a,b);return}function kt(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+88>>2]&2047](a,b);return}function lt(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;MHb(a,b,c,d,e,f,g);return}function mt(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;MHb(a,b,c,d,e,f,.04);return}function nt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;MHb(a,b,c,d,e,0,.04);return}function ot(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;MHb(a,b,c,d,3,0,.04);return}function pt(a,b,c){a=a|0;b=b|0;c=+c;MHb(a,b,c,1.0,3,0,.04);return}function qt(a,b){a=a|0;b=b|0;MHb(a,b,.01,1.0,3,0,.04);return}function rt(a){a=a|0;MHb(a,1e3,.01,1.0,3,0,.04);return}function st(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;h=+h;vHb(a,b,c,d,e,f,g,h);return}function tt(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+72>>2]&31](a,b);return}function ut(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function vt(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+104>>2]&31](a,b);return}function wt(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+80>>2]&31](a,b);return}function xt(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;kLb(a,j,k,d,e,l,h);u=i;return}function yt(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;kLb(a,i,j,d,e,k,0);u=h;return}function zt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;kLb(a,h,i,d,e,e0()|0,0);u=g;return}function At(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=e;lLb(a,i,c,d,j,g);u=h;return}function Bt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=e;lLb(a,h,c,d,i,0);u=g;return}function Ct(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;lLb(a,g,c,d,e0()|0,0);u=e;return}function Dt(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c+11|0;h=b[g>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;if(i|0){h=tT(e,i)|0;dJc(h|0,((b[g>>0]|0)<0?f[c>>2]|0:c)|0,i|0)|0}nLb(a,e);uT(e);u=d;return}function Et(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;iLb(a,j,k,d,e,l,h);u=i;return}function Ft(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;iLb(a,i,j,d,e,k,0);u=h;return}function Gt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;iLb(a,h,i,d,e,e0()|0,0);u=g;return}function Ht(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=e;jLb(a,i,c,d,j,g);u=h;return}function It(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=e;jLb(a,h,c,d,i,0);u=g;return}function Jt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;jLb(a,g,c,d,e0()|0,0);u=e;return}function Kt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+32>>2]|0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=b;mi[e&2047](a,d);u=c;return}function Lt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=e;fLb(a,h,i,d,j);u=g;return}function Mt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;fLb(a,g,h,d,e0()|0);u=e;return}function Nt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=d;gLb(a,g,c,h);u=e;return}function Ot(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;gLb(a,e,c,e0()|0);u=d;return}function Pt(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+8|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=0;f[j+4>>2]=0;c=d+11|0;k=b[c>>0]|0;l=k<<24>>24<0?f[d+4>>2]|0:k&255;if(l|0){k=tT(j,l)|0;dJc(k|0,((b[c>>0]|0)<0?f[d>>2]|0:d)|0,l|0)|0}BHa(a,i,j,e,g);uT(j);u=h;return}function Qt(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+64|0;h=g+40|0;i=g+32|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=0;f[i+4>>2]=0;c=d+11|0;k=b[c>>0]|0;l=k<<24>>24<0?f[d+4>>2]|0:k&255;if(l|0){k=tT(i,l)|0;dJc(k|0,((b[c>>0]|0)<0?f[d>>2]|0:d)|0,l|0)|0};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;BHa(a,h,i,e,j);uT(i);u=g;return}function Rt(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+64|0;g=e+40|0;h=e+32|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;f[h>>2]=0;f[h+4>>2]=0;c=d+11|0;j=b[c>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;if(k|0){j=tT(h,k)|0;dJc(j|0,((b[c>>0]|0)<0?f[d>>2]|0:d)|0,k|0)|0};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;BHa(a,g,h,1.0,i);uT(h);u=e;return}function St(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+64|0;d=c+40|0;e=c+32|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;f[e>>2]=0;f[e+4>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;BHa(a,d,e,1.0,g);uT(e);u=c;return}function Tt(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;h=d+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[d+4>>2]|0:i&255;if(j|0){i=tT(g,j)|0;dJc(i|0,((b[h>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0}uGa(a,c,g);uT(g);u=e;return}function Ut(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=0;f[d+4>>2]=0;uGa(a,b,d);uT(d);u=c;return}function Vt(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+8|0;h=e;i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=33882112;f[g+4>>2]=c;f[h>>2]=0;f[h+4>>2]=0;c=d+11|0;i=b[c>>0]|0;j=i<<24>>24<0?f[d+4>>2]|0:i&255;if(!j){xHa(a,g,h);uT(h);u=e;return}i=tT(h,j)|0;dJc(i|0,((b[c>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0;xHa(a,g,h);uT(h);u=e;return}function Wt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+32|0;d=c+8|0;e=c;g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=33882112;f[d+4>>2]=b;f[e>>2]=0;f[e+4>>2]=0;xHa(a,d,e);uT(e);u=c;return}function Xt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d+16|0;g=d+4|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=33882112;f[e+4>>2]=b;b=f[c>>2]|0;f[h>>2]=b;Vf(b|0);Yt(g,h);yHa(a,e,g);e=f[g>>2]|0;if(!e){j=f[h>>2]|0;Ae(j|0);u=d;return}a=g+4|0;while(1){b=f[a>>2]|0;if((b|0)==(e|0))break;c=b+-8|0;f[a>>2]=c;uT(c)}YDc(f[g>>2]|0);j=f[h>>2]|0;Ae(j|0);u=d;return}function Yt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(207238)|0;i=Nd(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,23864,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=e+4|0;k=a+8|0;l=0;do{m=f[b>>2]|0;f[d>>2]=l;n=bf(23864,d|0)|0;o=Nd(m|0,n|0)|0;Ae(n|0);j=+pe(o|0,5016,d|0);n=f[d>>2]|0;m=~~j>>>0;p=f[m>>2]|0;f[e>>2]=p;f[g>>2]=f[m+4>>2];if(p|0){m=p+-4|0;f[m>>2]=(f[m>>2]|0)+1}Ie(n|0);n=f[i>>2]|0;if(n>>>0<(f[k>>2]|0)>>>0){m=f[e>>2]|0;f[n>>2]=m;f[n+4>>2]=f[g>>2];if(!m)q=n;else{n=m+-4|0;f[n>>2]=(f[n>>2]|0)+1;q=f[i>>2]|0}f[i>>2]=q+8}else UA(a,e);uT(e);Ae(o|0);l=l+1|0}while(l>>>0<h>>>0);u=c;return}function Zt(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function _t(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function $t(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;jMb(a,b,c,d,e,f,g,h,i,j);return}function au(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;jMb(a,b,c,d,e,f,g,h,i,5);return}function bu(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;jMb(a,b,c,d,e,f,g,h,.003,5);return}function cu(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;jMb(a,b,c,d,e,f,g,1.01,.003,5);return}function du(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;jMb(a,b,c,d,e,f,200,1.01,.003,5);return}function eu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;jMb(a,b,c,d,e,.2,200,1.01,.003,5);return}function fu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jMb(a,b,c,d,.25,.2,200,1.01,.003,5);return}function gu(a,b,c){a=a|0;b=b|0;c=c|0;jMb(a,b,c,14400,.25,.2,200,1.01,.003,5);return}function hu(a,b){a=a|0;b=b|0;jMb(a,b,60,14400,.25,.2,200,1.01,.003,5);return}function iu(a){a=a|0;jMb(a,5,60,14400,.25,.2,200,1.01,.003,5);return}function ju(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+84>>2]&2047](a,b);return}function ku(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+92>>2]&2047](a,b);return}function lu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[(f[a>>2]|0)+64>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;ei[h&511](a,g,c,d);u=e;return}function mu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+68>>2]&2047](a,b);return}function nu(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function ou(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yLb(a,b,c,d);return}function pu(a,b,c){a=a|0;b=b|0;c=c|0;yLb(a,b,c,3);return}function qu(a,b){a=a|0;b=b|0;yLb(a,b,1,3);return}function ru(a){a=a|0;yLb(a,10,1,3);return}function su(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function tu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function uu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+80>>2]&2047](a,b);return}function vu(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c+11|0;h=b[g>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;if(i|0){h=tT(e,i)|0;dJc(h|0,((b[g>>0]|0)<0?f[c>>2]|0:c)|0,i|0)|0}i=nPb(a,e)|0;uT(e);u=d;return i|0}function wu(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];uPb(a,l,c,d,e,g,h,m,n);u=k;return}function xu(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];f[m>>2]=0;f[m+4>>2]=0;uPb(a,k,c,d,e,g,h,l,m);u=j;return}function yu(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=0;f[l+4>>2]=0;uPb(a,j,c,d,e,g,h,k,l);u=i;return}function zu(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;uPb(a,i,c,d,e,g,0,j,k);u=h;return}function Au(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;uPb(a,h,c,d,e,3,0,i,j);u=g;return}function Bu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;uPb(a,g,c,d,1.1,3,0,h,i);u=e;return}function Cu(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+32|0;n=m+16|0;o=m+8|0;p=m;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];vPb(a,n,c,d,e,g,h,i,o,p,l);u=m;return}function Du(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];vPb(a,m,c,d,e,g,h,i,n,o,0);u=l;return}function Eu(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[n>>2]=0;f[n+4>>2]=0;vPb(a,l,c,d,e,g,h,i,m,n,0);u=k;return}function Fu(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=0;f[l+4>>2]=0;f[m>>2]=0;f[m+4>>2]=0;vPb(a,k,c,d,e,g,h,i,l,m,0);u=j;return}function Gu(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=0;f[l+4>>2]=0;vPb(a,j,c,d,e,g,h,0,k,l,0);u=i;return}function Hu(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;vPb(a,i,c,d,e,g,3,0,j,k,0);u=h;return}function Iu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;vPb(a,h,c,d,e,1.1,3,0,i,j,0);u=g;return}function Ju(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];tPb(a,k,c,d,e,g,l,m);u=j;return}function Ku(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[l>>2]=0;f[l+4>>2]=0;tPb(a,j,c,d,e,g,k,l);u=i;return}function Lu(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;tPb(a,i,c,d,e,g,j,k);u=h;return}function Mu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;tPb(a,h,c,d,e,0,i,j);u=g;return}function Nu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;tPb(a,g,c,d,3,0,h,i);u=e;return}function Ou(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;tPb(a,e,c,1.1,3,0,g,h);u=d;return}function Pu(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function Qu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mIb(a,b,c,d);return}function Ru(a,b,c){a=a|0;b=b|0;c=c|0;mIb(a,b,c,2);return}function Su(a,b){a=a|0;b=b|0;mIb(a,b,1,2);return}function Tu(a){a=a|0;mIb(a,10,1,2);return}function Uu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function Vu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function Wu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+80>>2]&2047](a,b);return}function Xu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+104>>2]&2047](a,b);return}function Yu(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function Zu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function _u(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+96>>2]&2047](a,b);return}function $u(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;tGb(a,b,c,d,e,f,g,h);return}function av(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;tGb(a,b,c,d,e,f,g,1);return}function bv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;tGb(a,b,c,d,e,f,4,1);return}function cv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;tGb(a,b,c,d,e,4,4,1);return}function dv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;tGb(a,b,c,d,1.0000000474974513e-03,4,4,1);return}function ev(a,b,c){a=a|0;b=b|0;c=c|0;tGb(a,b,c,3,1.0000000474974513e-03,4,4,1);return}function fv(a,b){a=a|0;b=b|0;tGb(a,b,0,3,1.0000000474974513e-03,4,4,1);return}function gv(a){a=a|0;tGb(a,5,0,3,1.0000000474974513e-03,4,4,1);return}function hv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+80>>2]&2047](a,b);return}function iv(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+88>>2]&31](a,b);return}function jv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function kv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+112>>2]&2047](a,b);return}function lv(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function mv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+88>>2]&2047](a,b);return}function nv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+96>>2]&2047](a,b);return}function ov(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;rHb(a,b,c,d,e,f,g,h,i,j);return}function pv(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rHb(a,b,c,d,e,f,g,h,i,20);return}function qv(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;rHb(a,b,c,d,e,f,g,h,31,20);return}function rv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;rHb(a,b,c,d,e,f,g,0,31,20);return}function sv(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;rHb(a,b,c,d,e,f,2,0,31,20);return}function tv(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;rHb(a,b,c,d,e,0,2,0,31,20);return}function uv(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;rHb(a,b,c,d,31,0,2,0,31,20);return}function vv(a,b,c){a=a|0;b=b|0;c=+c;rHb(a,b,c,8,31,0,2,0,31,20);return}function wv(a,b){a=a|0;b=b|0;rHb(a,b,1.2000000476837158,8,31,0,2,0,31,20);return}function xv(a){a=a|0;rHb(a,500,1.2000000476837158,8,31,0,2,0,31,20);return}function yv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function zv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+80>>2]&2047](a,b);return}function Av(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+120>>2]&2047](a,b);return}function Bv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+104>>2]&2047](a,b);return}function Cv(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+72>>2]&31](a,b);return}function Dv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+112>>2]&2047](a,b);return}function Ev(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+28>>2]&2047](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;uT(e);u=d;return}function Fv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;fJb(a,b,c,d);return}function Gv(a,b,c){a=a|0;b=b|0;c=c|0;fJb(a,b,c,1.0);return}function Hv(a,b){a=a|0;b=b|0;fJb(a,b,3,1.0);return}function Iv(a){a=a|0;fJb(a,30,3,1.0);return}function Jv(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+48|0;i=h+36|0;j=h+20|0;k=h+24|0;l=h+4|0;m=h+8|0;n=h;o=f[b>>2]|0;f[j>>2]=o;Vf(o|0);cn(i,j);o=f[c>>2]|0;f[l>>2]=o;Vf(o|0);bn(k,l);o=f[g>>2]|0;f[n>>2]=o;Vf(o|0);bn(m,n);iJb(a,i,k,d,e,m);a=f[m>>2]|0;if(a|0){o=m+4|0;m=f[o>>2]|0;if((m|0)!=(a|0))f[o>>2]=m+(~((m+-4-a|0)>>>2)<<2);YDc(a)}Ae(f[n>>2]|0);n=f[k>>2]|0;if(n|0){a=k+4|0;k=f[a>>2]|0;if((k|0)!=(n|0))f[a>>2]=k+(~((k+-4-n|0)>>>2)<<2);YDc(n)}Ae(f[l>>2]|0);l=f[i>>2]|0;if(!l){p=f[j>>2]|0;Ae(p|0);u=h;return}n=i+4|0;i=f[n>>2]|0;if((i|0)!=(l|0))f[n>>2]=i+(~((i+-4-l|0)>>>2)<<2);YDc(l);p=f[j>>2]|0;Ae(p|0);u=h;return}function Kv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+20|0;k=g;l=g+4|0;m=f[b>>2]|0;f[i>>2]=m;Vf(m|0);cn(h,i);m=f[c>>2]|0;f[k>>2]=m;Vf(m|0);bn(j,k);f[l>>2]=0;m=l+4|0;f[m>>2]=0;f[l+8>>2]=0;iJb(a,h,j,d,e,l);a=f[l>>2]|0;if(a|0){l=f[m>>2]|0;if((l|0)!=(a|0))f[m>>2]=l+(~((l+-4-a|0)>>>2)<<2);YDc(a)}a=f[j>>2]|0;if(a|0){l=j+4|0;j=f[l>>2]|0;if((j|0)!=(a|0))f[l>>2]=j+(~((j+-4-a|0)>>>2)<<2);YDc(a)}Ae(f[k>>2]|0);k=f[h>>2]|0;if(!k){n=f[i>>2]|0;Ae(n|0);u=g;return}a=h+4|0;h=f[a>>2]|0;if((h|0)!=(k|0))f[a>>2]=h+(~((h+-4-k|0)>>>2)<<2);YDc(k);n=f[i>>2]|0;Ae(n|0);u=g;return}function Lv(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=u;u=u+48|0;k=j+36|0;l=j+20|0;m=j+24|0;n=j+4|0;o=j+8|0;p=j;q=f[d>>2]|0;f[l>>2]=q;Vf(q|0);cn(k,l);q=f[e>>2]|0;f[n>>2]=q;Vf(q|0);bn(m,n);q=f[i>>2]|0;f[p>>2]=q;Vf(q|0);bn(o,p);kJb(a,b,c,k,m,g,h,o);c=f[o>>2]|0;if(c|0){b=o+4|0;o=f[b>>2]|0;if((o|0)!=(c|0))f[b>>2]=o+(~((o+-4-c|0)>>>2)<<2);YDc(c)}Ae(f[p>>2]|0);p=f[m>>2]|0;if(p|0){c=m+4|0;m=f[c>>2]|0;if((m|0)!=(p|0))f[c>>2]=m+(~((m+-4-p|0)>>>2)<<2);YDc(p)}Ae(f[n>>2]|0);n=f[k>>2]|0;if(!n){r=f[l>>2]|0;Ae(r|0);u=j;return}p=k+4|0;k=f[p>>2]|0;if((k|0)!=(n|0))f[p>>2]=k+(~((k+-4-n|0)>>>2)<<2);YDc(n);r=f[l>>2]|0;Ae(r|0);u=j;return}function Mv(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i+20|0;m=i;n=i+4|0;o=f[d>>2]|0;f[k>>2]=o;Vf(o|0);cn(j,k);o=f[e>>2]|0;f[m>>2]=o;Vf(o|0);bn(l,m);f[n>>2]=0;o=n+4|0;f[o>>2]=0;f[n+8>>2]=0;kJb(a,b,c,j,l,g,h,n);c=f[n>>2]|0;if(c|0){n=f[o>>2]|0;if((n|0)!=(c|0))f[o>>2]=n+(~((n+-4-c|0)>>>2)<<2);YDc(c)}c=f[l>>2]|0;if(c|0){n=l+4|0;l=f[n>>2]|0;if((l|0)!=(c|0))f[n>>2]=l+(~((l+-4-c|0)>>>2)<<2);YDc(c)}Ae(f[m>>2]|0);m=f[j>>2]|0;if(!m){p=f[k>>2]|0;Ae(p|0);u=i;return}c=j+4|0;j=f[c>>2]|0;if((j|0)!=(m|0))f[c>>2]=j+(~((j+-4-m|0)>>>2)<<2);YDc(m);p=f[k>>2]|0;Ae(p|0);u=i;return}function Nv(a){a=a|0;var b=0;Of(269072,7,25316,207271,1,1);Of(269072,6,25344,207280,1,1);Of(269072,5,25368,207288,2,1);Of(191242,7,25388,207295,1,2);Of(191242,6,25416,206942,2,3);Of(191249,7,25440,207295,2,3);Of(191249,6,25468,206942,3,4);Of(191249,5,25492,206950,6,10);Of(285318,10,25512,207304,1,1);Of(285318,9,25552,207316,1,1);Of(285318,8,25588,207327,1,1);Of(285318,7,25620,207337,1,1);Of(285318,6,24572,206942,4,5);Of(191262,10,25648,207346,1,1);Of(191262,9,25688,207358,1,1);Of(191262,8,25724,207369,1,1);Of(191262,7,25756,207379,1,1);Of(191262,6,25344,207280,1,2);Of(191273,8,25724,207369,1,2);Of(191273,7,25756,207379,1,2);Of(191273,6,25344,207280,1,3);Of(191285,8,25784,207388,1,3);Of(191285,7,25816,207398,1,5);Of(191285,6,25844,207407,1,7);Of(191285,5,25868,206957,94,188);Of(191285,4,24596,205347,189,243);Of(191295,9,25888,207415,1,2);Of(191295,8,25924,207426,1,2);Of(191295,7,25956,207436,1,2);Of(191295,6,25984,207445,94,95);Of(191302,10,26008,207453,1,2);Of(191302,9,26048,207465,1,2);Of(191302,8,26084,207476,1,2);Of(191302,7,26116,207486,63,95);Of(191302,6,25984,207445,94,96);Of(191308,4,26144,205347,190,244);Of(286169,8,26160,207495,1,1);Of(463765,6,26192,207445,96,97);Of(463765,5,26216,206957,98,191);Of(463765,4,26144,205347,190,245);Of(191316,8,26236,207505,1,1);Of(191316,7,26268,207515,1,1);Of(255306,5,26296,207524,1,7);Of(286571,3,26316,206976,13,16);Of(268879,7,26328,207295,4,4);Of(268879,6,24572,206942,4,6);Of(191328,5,26216,206957,98,192);Of(191328,4,26144,205347,190,246);Of(191340,4,24720,205347,193,247);Of(191340,3,24708,205342,248,1057);Of(191352,5,26216,206957,98,194);Of(191352,4,26144,205347,190,249);Of(191363,5,26216,206957,98,195);Of(191363,4,26144,205347,190,250);Of(191375,6,26356,207445,97,99);Of(191375,5,26380,206957,100,196);Of(191375,4,26400,205347,197,251);Of(191380,2,26416,205353,465,1058);Of(191393,8,26424,207531,122,64);Of(191393,7,26456,207486,65,98);Of(191393,6,26484,207445,99,101);Of(191393,5,26508,206957,102,198);Of(258217,7,26528,207436,3,3);Of(257679,8,26556,207531,123,66);Of(257679,7,26588,207486,67,100);Of(191403,11,26616,207541,1,1);Of(191428,12,26660,207554,1,1);Of(191428,11,26708,207568,1,2);Of(191428,10,26752,207581,3,93);Of(191428,9,26792,207593,94,124);Of(191428,8,26828,207531,125,68);Of(191428,7,26860,207486,69,101);Of(230723,6,26888,207445,102,103);Of(230723,5,26912,206957,104,199);Of(256605,8,26932,207531,126,70);Of(256605,7,26964,207486,71,103);Of(256605,6,26992,207445,104,105);Of(256605,5,27016,206957,106,200);Of(211033,5,27036,206957,107,201);Of(258446,4,27056,207006,5,14);Of(249786,5,27072,206710,99,69);Of(249786,4,27092,205381,70,283);Of(249786,3,27108,205376,284,466);Of(250602,7,27120,207604,7,71);Of(250602,6,27148,206717,72,100);Of(250602,5,27172,206710,101,71);Of(286634,3,26316,206976,13,17);Of(286634,2,27192,207032,18,19);Of(211461,5,25368,207288,2,2);Of(211461,4,27200,205719,11,13);Of(211461,3,24708,205342,248,1059);Of(287219,5,27216,206957,108,202);Of(287219,4,27236,205347,203,252);Of(287219,3,24708,205342,248,1060);Of(287386,4,26144,205347,190,253);Of(220491,9,27252,207593,95,127);Of(220491,8,27288,207531,128,72);Of(191449,7,27320,207613,1,2);Of(191449,6,25844,207407,1,8);Of(191462,6,25984,207445,94,109);Of(191462,5,25868,206957,94,204);Of(191462,4,24596,205347,189,254);Of(230392,2,27348,205353,467,852);Of(257078,5,25868,206957,94,205);Of(257078,4,24596,205347,189,255);Of(265410,5,25868,206957,94,206);Of(265410,4,24596,205347,189,256);Of(214732,2,27192,207032,18,20);Of(212501,5,25868,206957,94,207);Of(212501,4,24596,205347,189,257);Of(212501,3,24708,205342,248,1061);Of(191480,8,27356,207531,129,73);Of(191480,7,27388,207486,74,105);Of(191480,6,27416,207445,106,110);Of(191480,5,27440,206957,111,208);Of(191480,4,24720,205347,193,258);Of(288703,6,25984,207445,94,112);Of(288703,5,25868,206957,94,209);Of(191487,7,27460,207486,75,107);Of(191487,6,27488,207445,108,113);Of(191515,6,27512,207622,3,2);Of(191515,5,27536,206950,9,12);Of(191515,4,26144,205347,190,259);Of(191522,5,27556,207630,1,1);Of(191522,4,27576,207637,4,1);Of(256867,10,27592,207581,4,96);Of(256867,9,27632,207593,97,130);Of(256867,8,27668,207531,131,76);Of(256867,7,27700,207486,77,109);Of(256867,6,27728,207445,110,114);Of(256867,5,27752,206957,115,210);Of(460665,6,27772,207445,111,116);Of(460665,5,27796,206957,117,211);Of(460665,4,27816,205347,212,260);Of(460844,11,27832,207568,2,5);Of(460844,10,27876,207581,6,98);Of(460844,9,27916,207593,99,132);Of(460844,8,27952,207531,133,78);Of(460844,7,27984,207486,79,112);Of(214985,4,28012,205381,72,285);Of(214985,3,28028,205376,286,468);Of(256713,11,28040,207643,1,1);Of(256713,10,28084,207656,1,1);Of(256713,9,28124,207668,1,1);Of(256713,8,28160,207679,1,1);Of(191530,6,28192,207445,113,118);Of(191530,5,28216,206957,119,213);Of(191530,4,28236,205347,214,261);Of(191539,8,28252,207531,134,80);Of(258540,3,24708,205342,248,1062);Of(191552,8,27356,207531,129,81);Of(191552,7,27388,207486,74,114);Of(191552,6,27416,207445,106,120);Of(191552,5,27440,206957,111,215);Of(191552,4,24720,205347,193,262);Of(374126,4,28284,205381,73,216);Of(191558,7,28300,207689,1,2);Of(230898,3,24708,205342,248,1063);Of(191582,8,28328,207698,1,3);Of(191582,7,28360,207436,4,4);Of(191582,6,28388,207445,115,121);Of(191582,5,28412,206957,122,217);Of(254979,7,28432,207486,82,116);Of(254979,6,28460,207445,117,123);Of(374787,7,28484,207708,1,1);Of(374787,6,28512,207717,2,3);Of(374787,5,28536,206999,4,6);Of(374787,4,28556,207006,7,15);Of(286693,2,28572,205353,469,1064);Of(273740,7,25620,207337,1,2);Of(220310,4,24596,205347,189,263);Of(212730,8,28580,207725,1,1);Of(212730,7,28612,207735,1,1);Of(271945,3,28640,205376,287,264);Of(191591,2,25288,205353,457,853);Of(271854,3,28640,205376,287,265);Of(191609,4,28652,207744,1,3);Of(264164,4,28668,205381,74,218);Of(264164,3,28684,205376,288,266);Of(269567,10,28696,207750,1,1);Of(269567,9,28736,207762,1,1);Of(269567,8,28772,207773,1,2);Of(269567,7,28804,207295,5,5);Of(269567,6,24572,206942,4,7);Of(191629,11,28832,207783,1,1);Of(191629,10,28876,207796,1,1);Of(191629,9,28916,207762,2,2);Of(270051,8,28952,207531,135,83);Of(270051,7,28984,207486,84,118);Of(471256,5,29012,206950,10,13);Of(471256,4,29032,205347,219,267);Of(216453,3,29048,205342,268,1065);Of(211227,5,29060,206957,124,220);Of(273039,9,29080,207593,100,136);Of(273916,4,24596,205347,189,269);Of(273916,3,24708,205342,248,1066);Of(191650,6,27488,207445,108,125);Of(191650,5,29116,206957,126,221);Of(191650,4,29136,205347,222,270);Of(214901,4,29152,207006,8,16);Of(214901,3,29168,206976,17,19);Of(287475,2,29180,205353,470,854);Of(229557,8,29188,207808,1,2);Of(229557,7,29220,207708,3,3);Of(256363,8,29248,207531,137,85);Of(256363,7,29280,207486,86,119);Of(256363,6,29308,207445,120,127);Of(256363,5,29332,206957,128,223);Of(230902,3,24708,205342,248,1067);Of(230568,4,26144,205347,190,271);Of(264580,5,29352,207818,1,1);Of(255787,6,29372,207445,121,129);Of(255787,5,27036,206957,107,224);Of(454907,4,26144,205347,190,272);Of(230180,3,29396,205376,289,273);Of(230180,2,29408,205353,471,1068);Of(230248,5,29416,206957,130,225);Of(230248,4,29136,205347,222,274);Of(286978,4,24596,205347,189,275);Of(219718,3,29048,205342,268,1069);Of(191660,4,26144,205347,190,276);Of(191664,2,28572,205353,469,1070);Of(216127,4,29436,205347,226,277);Of(264414,3,29452,205376,290,278);Of(264414,2,29464,205353,472,1071);Of(264186,9,29472,207593,101,138);Of(264186,8,29508,207531,139,87);Of(264186,7,29540,207486,88,122);Of(264186,6,28388,207445,115,131);Of(264186,5,28412,206957,122,227);Of(191676,6,27512,207622,3,3);Of(191676,5,27536,206950,9,14);Of(191676,4,26144,205347,190,279);Of(214432,4,29568,207006,9,18);Of(214432,3,29584,206976,19,20);Of(214432,2,27192,207032,18,21);Of(191685,5,29596,206999,5,10);Of(191685,4,27056,207006,5,20);Of(191685,3,24764,206976,21,21);Of(211579,8,29616,207825,3,1);Of(211579,7,29648,207271,3,2);Of(211579,6,25344,207280,1,4);Of(211579,5,25368,207288,2,4);Of(211579,4,27200,205719,11,14);Of(211579,3,24708,205342,248,1072);Of(213226,4,24720,205347,193,280);Of(258731,4,29676,207006,11,22);Of(230813,6,26888,207445,102,132);Of(230813,5,26912,206957,104,228);Of(388363,4,29692,207835,8,3);Of(191691,10,29708,207841,1,2);Of(191691,9,29748,207853,1,2);Of(191691,8,29784,207864,2,1);Of(191691,7,29816,207613,4,4);Of(268251,5,29844,206957,133,229);Of(268251,4,29864,205347,230,281);Of(268251,3,24708,205342,248,1073);Of(268497,5,29844,206957,133,231);Of(268497,4,29864,205347,230,282);Of(268497,3,24708,205342,248,1074);Of(191699,4,29880,205347,232,283);Of(191705,4,29880,205347,232,284);Of(256518,8,29248,207531,137,89);Of(256518,7,29280,207486,86,123);Of(256518,6,29308,207445,120,134);Of(256518,5,29332,206957,128,233);Of(216805,6,25984,207445,94,135);Of(216805,5,25868,206957,94,234);Of(270967,8,29896,207531,140,90);Of(270967,7,29928,207486,91,124);Of(270967,6,29956,207445,125,136);Of(220346,5,29980,206957,137,235);Of(251123,7,25440,207295,2,6);Of(251123,6,25468,206942,3,8);Of(251123,5,25492,206950,6,15);Of(251123,4,26400,205347,197,285);Of(283626,9,3e4,207874,1,2);Of(283626,8,30036,207476,2,5);Of(283626,7,30068,207486,92,126);Of(283626,6,30096,207445,127,138);Of(216641,3,24824,205342,286,1075);Of(216641,2,30120,207885,1076,1661);Of(191711,2,30128,207885,1077,1662);Of(215327,5,30136,206710,102,75);Of(215327,4,30156,205381,76,291);Of(231210,4,29152,207006,8,23);Of(231210,3,29168,206976,17,22);Of(391970,3,30172,205342,287,1078);Of(191722,3,24708,205342,248,1079);Of(191727,6,26192,207445,96,139);Of(191727,5,26216,206957,98,236);Of(191727,4,26144,205347,190,288);Of(467837,6,30184,207889,1,1);Of(216653,2,29408,205353,471,1080);Of(213198,4,24720,205347,193,289);Of(216689,3,24708,205342,248,1081);Of(273699,6,30208,207445,128,140);Of(273699,5,30232,206957,141,237);Of(216618,3,29048,205342,268,1082);Of(271445,8,30252,207531,141,93);Of(271445,7,30284,207486,94,129);Of(271445,6,30312,207445,130,142);Of(271445,5,30336,206957,143,238);Of(271609,8,30252,207531,141,95);Of(271609,7,30284,207486,94,131);Of(271609,6,30312,207445,130,144);Of(271609,5,30336,206957,143,239);Of(264470,3,24708,205342,248,1083);Of(191736,8,30356,207897,1,1);Of(191736,7,30388,207907,1,1);Of(191736,6,30416,207916,1,1);Of(191736,5,30440,207924,1,1);Of(191736,4,30460,207931,1,9);Of(191736,3,30476,207937,1,15);Of(191736,2,24804,205353,473,1084);Of(381346,4,30488,205381,77,240);Of(381346,3,30504,205376,292,290);Of(381346,2,30516,205353,474,1085);Of(191750,4,30524,205381,78,241);Of(191750,3,30540,205376,293,291);Of(191759,3,30504,205376,292,292);Of(191759,2,30516,205353,474,1086);Of(191776,3,30552,205376,294,293);Of(191776,2,30564,205353,475,1087);Of(389563,3,30504,205376,292,294);Of(389563,2,30516,205353,474,1088);Of(191794,3,30552,205376,294,295);Of(191794,2,30564,205353,475,1089);Of(191814,2,30516,205353,474,1090);Of(191830,3,30504,205376,292,296);Of(191830,2,30516,205353,474,1091);Of(191852,3,30552,205376,294,297);Of(191852,2,30564,205353,475,1092);Of(191875,3,30572,205376,295,298);Of(191875,2,30516,205353,474,1093);Ce(20064,5032,5048,0,205334,855,205337,0,205337,0,191892,205339,1663);a=VDc(4)|0;f[a>>2]=296;ff(20064,191906,4,30584,205381,79,a|0,0);a=VDc(4)|0;f[a>>2]=476;ff(20064,191906,3,30600,205376,297,a|0,0);ae(20064,1,30612,205334,856,24);ae(20064,13,30616,208026,1,1);ae(20064,2,30668,205353,477,857);Yf(20064,191911,1,30676,205334,858,1664);Yf(20064,191936,1,30676,205334,858,1665);a=VDc(4)|0;f[a>>2]=1094;ff(20064,471710,3,30680,205342,299,a|0,0);a=VDc(4)|0;f[a>>2]=2;ff(20064,466708,11,30692,208041,1,a|0,0);a=VDc(4)|0;f[a>>2]=1;ff(20064,466708,10,30736,208054,1,a|0,0);a=VDc(4)|0;f[a>>2]=1;ff(20064,466708,9,30776,208066,1,a|0,0);a=VDc(4)|0;f[a>>2]=2;ff(20064,466708,8,30812,207864,3,a|0,0);a=VDc(4)|0;f[a>>2]=5;ff(20064,466708,7,30844,207613,5,a|0,0);a=VDc(4)|0;f[a>>2]=11;ff(20064,466708,6,30872,207407,5,a|0,0);a=VDc(4)|0;f[a>>2]=242;ff(20064,466708,5,30896,206957,145,a|0,0);a=VDc(4)|0;f[a>>2]=4;b=VDc(4)|0;f[b>>2]=4;we(20064,471391,4816,205353,478,a|0,4816,205342,300,b|0);b=VDc(4)|0;f[b>>2]=12;a=VDc(4)|0;f[a>>2]=12;we(20064,471399,4816,205353,478,b|0,4816,205342,300,a|0);a=VDc(4)|0;f[a>>2]=20;b=VDc(4)|0;f[b>>2]=20;we(20064,471409,4816,205353,478,a|0,4816,205342,300,b|0);b=VDc(4)|0;f[b>>2]=28;a=VDc(4)|0;f[a>>2]=28;we(20064,471672,4816,205353,478,b|0,4816,205342,300,a|0);a=VDc(4)|0;f[a>>2]=36;b=VDc(4)|0;f[b>>2]=36;we(20064,471421,23856,205353,479,a|0,23856,205342,301,b|0);b=VDc(4)|0;f[b>>2]=40;a=VDc(4)|0;f[a>>2]=40;we(20064,471545,23856,205353,479,b|0,23856,205342,301,a|0);a=VDc(4)|0;f[a>>2]=48;b=VDc(4)|0;f[b>>2]=48;we(20064,471681,23896,207032,23,a|0,23896,205714,16,b|0);b=VDc(4)|0;f[b>>2]=56;a=VDc(4)|0;f[a>>2]=56;we(20064,471559,23856,205353,479,b|0,23856,205342,301,a|0);a=VDc(4)|0;f[a>>2]=64;b=VDc(4)|0;f[b>>2]=64;we(20064,471577,23896,207032,23,a|0,23896,205714,16,b|0);b=VDc(4)|0;f[b>>2]=72;a=VDc(4)|0;f[a>>2]=72;we(20064,471592,23808,205353,480,b|0,23808,205342,302,a|0);a=VDc(4)|0;f[a>>2]=76;b=VDc(4)|0;f[b>>2]=76;we(20064,191961,4304,205353,481,a|0,4304,205342,303,b|0);b=VDc(4)|0;f[b>>2]=140;a=VDc(4)|0;f[a>>2]=140;we(20064,471608,23856,205353,479,b|0,23856,205342,301,a|0);a=VDc(4)|0;f[a>>2]=144;b=VDc(4)|0;f[b>>2]=144;we(20064,471616,23808,205353,480,a|0,23808,205342,302,b|0);Ce(5064,5080,5096,6960,205334,859,205334,860,205334,861,191973,205339,1666);b=VDc(4)|0;f[b>>2]=16;ff(5064,440714,5,30916,206950,12,b|0,0);b=VDc(4)|0;f[b>>2]=304;ff(5064,440714,4,30936,205347,243,b|0,0);b=VDc(4)|0;f[b>>2]=1095;ff(5064,372373,3,30952,205342,305,b|0,0);Ce(5112,5128,5144,5064,205334,862,205334,863,205334,864,191994,205339,1667);ae(5112,4,30964,207931,2,10);ae(5112,3,30980,207937,2,17);ae(5112,2,30992,205353,482,1096);ae(5112,1,31e3,205334,865,1668);b=VDc(4)|0;f[b>>2]=17;ff(5112,440714,5,31004,206950,13,b|0,0);b=VDc(4)|0;f[b>>2]=306;ff(5112,440714,4,31024,205347,244,b|0,0);Nf(5160,5112,192019,0,205334,866,233307,25,205334,867,205339,1669);Ce(5168,5184,5200,6960,205334,868,205334,869,205334,870,192049,205339,1670);b=VDc(4)|0;f[b>>2]=1097;ff(5168,192055,3,31040,205342,307,b|0,0);ae(5168,3,31052,208366,1,4);ae(5168,2,31064,208371,1,19);ae(5168,1,31072,205334,871,1671);b=VDc(8)|0;f[b>>2]=52;f[b+4>>2]=1;ff(5168,192072,2,31076,207885,1098,b|0,1);b=VDc(4)|0;f[b>>2]=20;ff(5168,192087,3,31084,205714,18,b|0,0);b=VDc(8)|0;f[b>>2]=48;f[b+4>>2]=1;ff(5168,192100,2,31096,205353,483,b|0,1);b=VDc(8)|0;f[b>>2]=40;f[b+4>>2]=1;ff(5168,192117,2,31104,207032,24,b|0,1);b=VDc(4)|0;f[b>>2]=308;ff(5168,440714,4,31112,205347,245,b|0,0);Nf(5216,5168,192130,0,205334,872,233307,26,205334,873,205339,1672);Ce(19584,5224,5240,19568,205334,874,205334,875,205334,876,192141,205339,1673);ae(19584,3,31128,205376,298,309);ae(19584,2,31140,205353,484,1099);ae(19584,1,31148,205334,877,1674);Nf(5256,19584,192151,0,205334,878,233307,27,205334,879,205339,1675);Ce(19520,5264,5280,19248,205334,880,205334,881,205334,882,192166,205339,1676);b=VDc(4)|0;f[b>>2]=1100;ff(19520,192171,3,31152,205342,310,b|0,0);b=VDc(4)|0;f[b>>2]=1101;ff(19520,192183,3,31164,205342,311,b|0,0);b=VDc(8)|0;f[b>>2]=92;f[b+4>>2]=1;ff(19520,192200,2,31176,205353,485,b|0,1);b=VDc(8)|0;f[b>>2]=100;f[b+4>>2]=1;ff(19520,192212,2,31176,205353,485,b|0,1);b=VDc(4)|0;f[b>>2]=1102;ff(19520,192229,3,31164,205342,311,b|0,0);b=VDc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19520,192241,2,31184,205353,486,b|0,1);ae(19520,7,31192,208482,1,2);ae(19520,6,31220,208491,1,2);ae(19520,5,31244,208499,1,4);ae(19520,4,31264,205553,4,18);ae(19520,3,31280,205376,299,312);ae(19520,2,31292,205353,487,1103);ae(19520,1,31300,205334,883,1677);b=VDc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19520,192252,2,31184,205353,486,b|0,1);b=VDc(4)|0;f[b>>2]=1104;ff(19520,192264,3,31152,205342,310,b|0,0);b=VDc(4)|0;f[b>>2]=1105;ff(19520,192275,3,31164,205342,311,b|0,0);b=VDc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19520,192290,2,31304,207032,25,b|0,1);b=VDc(4)|0;f[b>>2]=1106;ff(19520,192303,2,31312,205353,488,b|0,0);b=VDc(8)|0;f[b>>2]=108;f[b+4>>2]=1;ff(19520,192318,2,31176,205353,485,b|0,1);b=VDc(4)|0;f[b>>2]=21;ff(19520,192333,3,31320,205714,19,b|0,0);Nf(5296,19520,192346,0,205334,884,233307,28,205334,885,205339,1678);Ce(6960,5304,5320,0,205334,886,205337,0,205337,0,192356,205339,1679);Ce(19248,5336,5352,6960,205334,887,205334,888,205334,889,460443,205339,1680);b=VDc(4)|0;f[b>>2]=1107;ff(19248,192303,2,31332,205353,489,b|0,0);b=VDc(4)|0;f[b>>2]=246;ff(19248,471356,5,31340,206957,146,b|0,0);b=VDc(4)|0;f[b>>2]=313;ff(19248,471356,4,31360,205347,247,b|0,0);b=VDc(4)|0;f[b>>2]=248;ff(19248,192366,5,31376,206957,147,b|0,0);b=VDc(4)|0;f[b>>2]=314;ff(19248,192366,4,31396,205347,249,b|0,0);b=VDc(4)|0;f[b>>2]=250;ff(19248,460360,5,31412,206957,148,b|0,0);b=VDc(4)|0;f[b>>2]=251;ff(19248,192374,5,31432,206957,149,b|0,0);b=VDc(8)|0;f[b>>2]=60;f[b+4>>2]=1;ff(19248,192383,2,31452,205353,490,b|0,0);b=VDc(4)|0;f[b>>2]=132;ff(19248,463413,7,31460,207486,96,b|0,0);b=VDc(4)|0;f[b>>2]=150;ff(19248,463413,6,31488,207445,133,b|0,0);b=VDc(8)|0;f[b>>2]=52;f[b+4>>2]=1;ff(19248,192395,2,31452,205353,490,b|0,0);b=VDc(8)|0;f[b>>2]=56;f[b+4>>2]=1;ff(19248,192410,2,31452,205353,490,b|0,0);b=VDc(8)|0;f[b>>2]=20;f[b+4>>2]=1;ff(19248,222311,2,31512,205353,491,b|0,0);Ce(19200,5416,5432,19248,205334,890,205334,891,205334,892,192425,205339,1681);b=VDc(8)|0;f[b>>2]=92;f[b+4>>2]=1;ff(19200,192438,2,31520,205353,492,b|0,1);b=VDc(4)|0;f[b>>2]=1108;ff(19200,192303,2,31528,205353,493,b|0,0);b=VDc(8)|0;f[b>>2]=108;f[b+4>>2]=1;ff(19200,192451,2,31536,207032,26,b|0,1);b=VDc(4)|0;f[b>>2]=1109;ff(19200,192456,3,31544,205342,315,b|0,0);b=VDc(4)|0;f[b>>2]=1110;ff(19200,192474,3,31556,205342,316,b|0,0);ae(19200,7,31568,208799,1,1);ae(19200,6,31596,208808,1,3);ae(19200,5,31620,208816,1,5);ae(19200,4,31640,207744,2,5);ae(19200,3,31656,207937,3,20);ae(19200,2,31668,205353,494,1111);ae(19200,1,31676,205334,893,1682);ae(19200,8,31680,208823,1,1);b=VDc(4)|0;f[b>>2]=22;ff(19200,192487,3,31712,205714,21,b|0,0);b=VDc(4)|0;f[b>>2]=1112;ff(19200,192503,3,31556,205342,316,b|0,0);b=VDc(4)|0;f[b>>2]=23;ff(19200,192518,3,31712,205714,21,b|0,0);b=VDc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19200,192523,2,31520,205353,492,b|0,1);b=VDc(4)|0;f[b>>2]=24;ff(19200,192538,3,31712,205714,21,b|0,0);b=VDc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19200,192553,2,31536,207032,26,b|0,1);b=VDc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19200,192568,2,31536,207032,26,b|0,1);b=VDc(8)|0;f[b>>2]=100;f[b+4>>2]=1;ff(19200,192584,2,31724,205353,495,b|0,1);Nf(5448,19200,192602,0,205334,894,233307,29,205334,895,205339,1683);Ce(19568,5456,5472,6960,205334,896,205334,897,205334,898,192620,205339,1684);b=VDc(4)|0;f[b>>2]=3;ff(19568,464345,8,31732,209032,4,b|0,0);b=VDc(4)|0;f[b>>2]=6;ff(19568,464345,7,31764,209042,6,b|0,0);b=VDc(4)|0;f[b>>2]=14;ff(19568,464345,6,31792,209051,6,b|0,0);b=VDc(4)|0;f[b>>2]=3;ff(19568,192638,7,31816,209059,4,b|0,0);b=VDc(4)|0;f[b>>2]=5;ff(19568,192638,6,31844,209068,7,b|0,0);b=VDc(4)|0;f[b>>2]=19;ff(19568,192638,5,31868,209076,15,b|0,0);ae(19568,2,31888,205353,496,1113);b=VDc(8)|0;f[b>>2]=8;f[b+4>>2]=1;ff(19568,224133,2,31896,207885,1114,b|0,0);b=VDc(4)|0;f[b>>2]=97;ff(19568,464284,8,31904,207531,142,b|0,0);b=VDc(4)|0;f[b>>2]=134;ff(19568,464284,7,31936,207486,98,b|0,0);b=VDc(4)|0;f[b>>2]=151;ff(19568,464284,6,31964,207445,135,b|0,0);b=VDc(4)|0;f[b>>2]=136;ff(19568,192651,7,31988,207486,99,b|0,0);b=VDc(4)|0;f[b>>2]=152;ff(19568,192651,6,32016,207445,137,b|0,0);b=VDc(4)|0;f[b>>2]=252;ff(19568,192651,5,32040,206957,153,b|0,0);b=VDc(4)|0;f[b>>2]=1115;ff(19568,463765,3,32060,205342,317,b|0,0);b=VDc(8)|0;f[b>>2]=40;f[b+4>>2]=1;ff(19568,192661,2,31896,207885,1114,b|0,0);b=VDc(4)|0;f[b>>2]=154;ff(19568,192667,6,32072,207445,138,b|0,0);b=VDc(4)|0;f[b>>2]=253;ff(19568,192667,5,32096,206957,155,b|0,0);b=VDc(4)|0;f[b>>2]=254;ff(19568,192673,5,32116,206957,156,b|0,0);b=VDc(4)|0;f[b>>2]=318;ff(19568,192673,4,32136,205347,255,b|0,0);b=VDc(8)|0;f[b>>2]=36;f[b+4>>2]=1;ff(19568,192680,2,32152,205353,497,b|0,1);b=VDc(8)|0;f[b>>2]=20;f[b+4>>2]=1;ff(19568,222311,2,32152,205353,497,b|0,0);Nf(5536,19568,192696,0,205334,899,233307,30,205334,900,205339,1685);Ce(5024,5592,5608,0,205334,901,205337,0,205337,0,192719,205339,1686);b=VDc(4)|0;f[b>>2]=6;ff(5024,381022,6,32160,207622,8,b|0,0);b=VDc(4)|0;f[b>>2]=20;ff(5024,381022,5,32184,206950,16,b|0,0);b=VDc(4)|0;f[b>>2]=319;ff(5024,381022,4,32204,205347,256,b|0,0);b=VDc(4)|0;f[b>>2]=1116;ff(5024,381022,3,32220,205342,320,b|0,0);b=VDc(4)|0;f[b>>2]=321;ff(5024,453206,3,32232,205376,300,b|0,0);b=VDc(4)|0;f[b>>2]=1117;ff(5024,453206,2,32244,205353,498,b|0,0);b=VDc(4)|0;f[b>>2]=322;ff(5024,192727,4,32252,205347,257,b|0,0);b=VDc(4)|0;f[b>>2]=1118;ff(5024,192727,3,32268,205342,323,b|0,0);b=VDc(4)|0;f[b>>2]=324;ff(5024,192736,4,32280,205347,258,b|0,0);Ce(19664,5624,5640,19248,205334,902,205334,903,205334,904,192745,205339,1687);b=VDc(4)|0;f[b>>2]=1119;ff(19664,192303,2,32296,205353,499,b|0,0);b=VDc(8)|0;f[b>>2]=96;f[b+4>>2]=1;ff(19664,192750,2,32304,205353,500,b|0,1);b=VDc(4)|0;f[b>>2]=1120;ff(19664,192763,3,32312,205342,325,b|0,0);b=VDc(8)|0;f[b>>2]=72;f[b+4>>2]=1;ff(19664,192774,2,32324,205353,501,b|0,1);ae(19664,10,32332,209351,1,1);ae(19664,9,32372,209363,1,1);ae(19664,8,32408,209374,1,1);ae(19664,7,32440,209384,1,6);ae(19664,6,32468,209393,1,6);ae(19664,5,32492,209401,5,17);ae(19664,4,32512,205381,80,259);ae(19664,3,32528,205376,301,326);ae(19664,2,32540,205353,502,1121);ae(19664,1,32548,205334,905,1688);b=VDc(8)|0;f[b>>2]=88;f[b+4>>2]=1;ff(19664,192783,2,32324,205353,501,b|0,1);b=VDc(4)|0;f[b>>2]=1122;ff(19664,192794,3,32312,205342,325,b|0,0);b=VDc(4)|0;f[b>>2]=1123;ff(19664,192805,3,32552,205342,327,b|0,0);b=VDc(8)|0;f[b>>2]=80;f[b+4>>2]=1;ff(19664,192818,2,32324,205353,501,b|0,1);b=VDc(4)|0;f[b>>2]=260;ff(19664,464814,5,32564,206957,157,b|0,0);b=VDc(4)|0;f[b>>2]=1124;ff(19664,192829,3,32312,205342,325,b|0,0);Nf(5656,19664,192838,0,205334,906,233307,31,205334,907,205339,1689);Ce(19616,5712,5728,19248,205334,908,205334,909,205334,910,192848,205339,1690);b=VDc(4)|0;f[b>>2]=1125;ff(19616,192303,2,32584,205353,503,b|0,0);b=VDc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19616,192869,2,32592,205353,504,b|0,1);b=VDc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19616,192290,2,32600,205353,505,b|0,1);ae(19616,4,32608,205381,81,261);ae(19616,3,32624,205376,302,328);ae(19616,2,32636,205353,506,1126);ae(19616,1,32644,205334,911,1691);b=VDc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19616,192890,2,32600,205353,505,b|0,1);b=VDc(4)|0;f[b>>2]=1127;ff(19616,192898,3,32648,205342,329,b|0,0);b=VDc(4)|0;f[b>>2]=1128;ff(19616,192333,3,32660,205342,330,b|0,0);b=VDc(4)|0;f[b>>2]=1129;ff(19616,192919,3,32660,205342,330,b|0,0);Nf(5744,19616,192927,0,205334,912,233307,32,205334,913,205339,1692);Ce(5752,5760,5776,0,205334,914,205337,0,205337,0,192953,205339,1693);b=VDc(4)|0;f[b>>2]=507;ff(5752,191906,3,32672,205376,303,b|0,0);b=VDc(4)|0;f[b>>2]=3;ff(5752,192971,10,32684,207841,2,b|0,0);b=VDc(4)|0;f[b>>2]=3;ff(5752,192971,9,32724,207853,2,b|0,0);b=VDc(4)|0;f[b>>2]=5;ff(5752,192971,8,32760,207864,5,b|0,0);b=VDc(4)|0;f[b>>2]=9;ff(5752,192971,7,32792,207613,7,b|0,0);b=VDc(4)|0;f[b>>2]=18;ff(5752,192971,6,32820,207407,7,b|0,0);b=VDc(4)|0;f[b>>2]=262;ff(5752,192971,5,32844,206957,158,b|0,0);ae(5752,1,32864,205334,915,33);ae(5752,2,32868,205353,508,916);b=VDc(4)|0;f[b>>2]=2;ff(5752,192989,12,32876,209735,1,b|0,0);b=VDc(4)|0;f[b>>2]=3;ff(5752,192989,11,32924,209749,1,b|0,0);b=VDc(4)|0;f[b>>2]=3;ff(5752,192989,10,32968,209762,1,b|0,0);b=VDc(4)|0;f[b>>2]=6;ff(5752,192989,9,33008,209774,1,b|0,0);b=VDc(4)|0;f[b>>2]=8;ff(5752,192989,8,33044,207698,3,b|0,0);b=VDc(4)|0;f[b>>2]=8;ff(5752,192989,7,33076,207436,6,b|0,0);b=VDc(4)|0;f[b>>2]=159;ff(5752,192989,6,33104,207445,139,b|0,0);b=VDc(8)|0;f[b>>2]=917;f[b+4>>2]=0;ff(5752,222311,2,33128,205353,509,b|0,0);b=VDc(4)|0;f[b>>2]=2;ff(5752,466708,9,33136,209785,4,b|0,0);b=VDc(4)|0;f[b>>2]=3;ff(5752,466708,8,33172,209796,4,b|0,0);b=VDc(4)|0;f[b>>2]=4;ff(5752,466708,7,33204,209806,6,b|0,0);b=VDc(4)|0;f[b>>2]=7;ff(5752,466708,6,33232,207622,10,b|0,0);b=VDc(4)|0;f[b>>2]=21;ff(5752,466708,5,33256,206950,19,b|0,0);b=VDc(4)|0;f[b>>2]=331;ff(5752,466708,4,33276,205347,263,b|0,0);Ce(19264,5792,5808,19248,205334,918,205334,919,205334,920,193007,205339,1694);b=VDc(4)|0;f[b>>2]=1130;ff(19264,192303,2,33292,205353,510,b|0,0);b=VDc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19264,192869,2,33300,205353,511,b|0,1);b=VDc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19264,192290,2,33308,205353,512,b|0,1);ae(19264,4,33316,205381,82,264);ae(19264,3,33332,205376,304,332);ae(19264,2,33344,205353,513,1131);ae(19264,1,33352,205334,921,1695);b=VDc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19264,192890,2,33308,205353,512,b|0,1);b=VDc(4)|0;f[b>>2]=1132;ff(19264,192898,3,33356,205342,333,b|0,0);b=VDc(4)|0;f[b>>2]=1133;ff(19264,192333,3,33368,205342,334,b|0,0);b=VDc(4)|0;f[b>>2]=1134;ff(19264,192919,3,33368,205342,334,b|0,0);Nf(5824,19264,193027,0,205334,922,233307,34,205334,923,205339,1696);Ce(19104,5832,5848,19248,205334,924,205334,925,205334,926,193052,205339,1697);b=VDc(4)|0;f[b>>2]=1135;ff(19104,192183,3,33380,205342,335,b|0,0);b=VDc(4)|0;f[b>>2]=1136;ff(19104,192303,2,33392,205353,514,b|0,0);b=VDc(4)|0;f[b>>2]=1137;ff(19104,193058,3,33380,205342,335,b|0,0);b=VDc(8)|0;f[b>>2]=108;f[b+4>>2]=1;ff(19104,192212,2,33400,205353,515,b|0,1);b=VDc(4)|0;f[b>>2]=1138;ff(19104,192229,3,33380,205342,335,b|0,0);b=VDc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19104,193076,2,33400,205353,515,b|0,1);b=VDc(8)|0;f[b>>2]=92;f[b+4>>2]=1;ff(19104,192290,2,33408,207032,27,b|0,1);ae(19104,8,33416,209958,1,5);ae(19104,7,33448,209968,1,7);ae(19104,6,33476,209977,1,11);ae(19104,5,33500,209985,6,20);ae(19104,4,33520,205381,83,265);ae(19104,3,33536,205376,305,336);ae(19104,2,33548,205353,516,1139);ae(19104,1,33556,205334,927,1698);b=VDc(8)|0;f[b>>2]=100;f[b+4>>2]=1;ff(19104,192200,2,33400,205353,515,b|0,1);b=VDc(4)|0;f[b>>2]=1140;ff(19104,193094,3,33380,205342,335,b|0,0);b=VDc(4)|0;f[b>>2]=25;ff(19104,192333,3,33560,205714,22,b|0,0);b=VDc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19104,193116,2,33400,205353,515,b|0,1);b=VDc(4)|0;f[b>>2]=1141;ff(19104,193138,3,33380,205342,335,b|0,0);b=VDc(4)|0;f[b>>2]=1142;ff(19104,192275,3,33380,205342,335,b|0,0);b=VDc(8)|0;f[b>>2]=116;f[b+4>>2]=1;ff(19104,192318,2,33400,205353,515,b|0,1);b=VDc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19104,470986,2,33400,205353,515,b|0,1);Nf(5864,19104,193156,0,205334,928,233307,35,205334,929,205339,1699);Ce(19152,5872,5888,19248,205334,930,205334,931,205334,932,193167,205339,1700);b=VDc(4)|0;f[b>>2]=1143;ff(19152,192303,2,33572,205353,517,b|0,0);b=VDc(4)|0;f[b>>2]=1144;ff(19152,193171,3,33580,205342,337,b|0,0);b=VDc(4)|0;f[b>>2]=1145;ff(19152,459736,3,33580,205342,337,b|0,0);ae(19152,10,33592,210035,1,1);ae(19152,9,33632,210047,1,1);ae(19152,8,33668,210058,2,2);ae(19152,7,33700,210068,2,2);ae(19152,6,33728,210077,2,2);ae(19152,5,33752,210085,2,2);ae(19152,4,33772,210092,3,11);ae(19152,3,33788,210098,4,23);ae(19152,2,33800,205353,518,1146);ae(19152,1,33808,205334,933,1701);b=VDc(8)|0;f[b>>2]=132;f[b+4>>2]=1;ff(19152,193188,2,33812,205353,519,b|0,1);b=VDc(4)|0;f[b>>2]=1147;ff(19152,192503,3,33580,205342,337,b|0,0);b=VDc(4)|0;f[b>>2]=1148;ff(19152,193205,3,33580,205342,337,b|0,0);b=VDc(4)|0;f[b>>2]=1149;ff(19152,193216,3,33580,205342,337,b|0,0);b=VDc(4)|0;f[b>>2]=1150;ff(19152,193229,3,33580,205342,337,b|0,0);b=VDc(4)|0;f[b>>2]=26;ff(19152,193238,3,33820,205714,24,b|0,0);b=VDc(4)|0;f[b>>2]=1151;ff(19152,193253,3,33580,205342,337,b|0,0);Nf(5904,19152,193266,0,205334,934,233307,36,205334,935,205339,1702);Ce(19328,5912,5928,19248,205334,936,205334,937,205334,938,193275,205339,1703);b=VDc(4)|0;f[b>>2]=1152;ff(19328,192303,2,33832,205353,520,b|0,0);ae(19328,4,33840,205553,5,22);ae(19328,3,33856,205376,306,338);ae(19328,2,33868,205353,521,1153);ae(19328,1,33876,205334,939,1704);ae(19328,6,33880,210152,1,7);ae(19328,5,33904,210160,1,9);ae(19328,8,33924,210167,1,3);ae(19328,7,33956,210177,1,3);Nf(5944,19328,193281,0,205334,940,233307,37,205334,941,205339,1705);fe(193292,23856,67108864);fe(193304,23856,50331648);fe(193316,23856,16777216);fe(193328,23856,50331648);fe(193338,23856,33554432);fe(193351,23856,1);fe(193378,23856,0);fe(193401,23856,3);fe(193423,23856,2);fe(193453,23856,5);fe(193475,23856,4);fe(193505,23856,0);fe(193536,23856,1);fe(193569,23856,2);fe(193602,23856,10001);fe(193642,23856,3);fe(193673,23856,1e4);fe(193704,23856,0);fe(193720,23856,4);fe(193735,23856,16);fe(193751,23856,2);fe(193766,23856,4);fe(193784,23856,4);fe(193803,23856,1);fe(193820,23856,5);fe(193839,23856,3);fe(193851,23856,1);fe(193876,23856,8);fe(193900,23856,4);fe(193928,23856,2);fe(193948,23856,-1);fe(193960,23856,1);fe(193970,23856,0);fe(193977,23856,4);fe(193990,23856,3);fe(194005,23856,0);fe(194018,23856,5);fe(194030,23856,1);fe(194042,23856,2);fe(194056,23856,1);fe(194074,23856,2);fe(194094,23856,4);fe(194117,23856,3);fe(194138,23856,0);fe(194145,23856,2);fe(194152,23856,1);fe(194159,23856,4);fe(194166,23856,3);fe(194173,23856,5);fe(194180,23856,0);fe(194196,23856,1);fe(194210,23856,8);fe(194224,23856,11);fe(194237,23856,9);fe(194250,23856,2);fe(194263,23856,5);fe(194278,23856,12);fe(194294,23856,10);fe(194308,23856,4);fe(194325,23856,7);fe(194341,23856,6);fe(194357,23856,3);fe(194373,23856,22);fe(194390,23856,12);fe(194407,23856,0);fe(194422,23856,6);fe(194437,23856,52);fe(194451,23856,68);fe(194470,23856,40);fe(194484,23856,66);fe(194503,23856,44);fe(194517,23856,50);fe(194531,23856,4);fe(194545,23856,2);fe(194560,23856,32);fe(194574,23856,36);fe(194590,23856,82);fe(194604,23856,128);fe(194623,23856,128);fe(194642,23856,132);fe(194661,23856,24);fe(194678,23856,28);fe(194696,23856,31);fe(194714,23856,25);fe(194731,23856,29);fe(194749,23856,14);fe(194766,23856,18);fe(194784,23856,21);fe(194802,23856,15);fe(194819,23856,19);fe(194837,23856,1);fe(194852,23856,26);fe(194870,23856,16);fe(194888,23856,10);fe(194904,23856,3);fe(194919,23856,5);fe(194935,23856,130);fe(194955,23856,130);fe(194975,23856,134);fe(194995,23856,46);fe(195013,23856,139);fe(195032,23856,135);fe(195053,23856,62);fe(195075,23856,86);fe(195094,23856,48);fe(195112,23856,141);fe(195131,23856,137);fe(195152,23856,64);fe(195174,23856,47);fe(195192,23856,140);fe(195211,23856,136);fe(195232,23856,63);fe(195254,23856,87);fe(195273,23856,49);fe(195291,23856,142);fe(195310,23856,138);fe(195331,23856,65);fe(195353,23856,49);fe(195371,23856,142);fe(195390,23856,138);fe(195411,23856,65);fe(195433,23856,89);fe(195452,23856,47);fe(195470,23856,140);fe(195489,23856,136);fe(195510,23856,63);fe(195532,23856,48);fe(195550,23856,141);fe(195569,23856,137);fe(195590,23856,64);fe(195612,23856,88);fe(195631,23856,46);fe(195649,23856,139);fe(195668,23856,135);fe(195689,23856,62);fe(195711,23856,143);fe(195730,23856,8);fe(195745,23856,30);fe(195763,23856,20);fe(195781,23856,9);fe(195797,23856,8);fe(195812,23856,9);fe(195828,23856,60);fe(195842,23856,72);fe(195861,23856,61);fe(195875,23856,73);fe(195894,23856,54);fe(195908,23856,70);fe(195927,23856,55);fe(195941,23856,71);fe(195960,23856,74);fe(195975,23856,76);fe(195990,23856,75);fe(196005,23856,77);fe(196020,23856,56);fe(196034,23856,78);fe(196049,23856,79);fe(196064,23856,57);fe(196078,23856,58);fe(196092,23856,80);fe(196107,23856,81);fe(196122,23856,59);fe(196136,23856,4);fe(196150,23856,23);fe(196167,23856,13);fe(196184,23856,2);fe(196199,23856,7);fe(196214,23856,53);fe(196228,23856,69);fe(196247,23856,41);fe(196261,23856,67);fe(196280,23856,45);fe(196294,23856,51);fe(196308,23856,0);fe(196323,23856,33);fe(196337,23856,37);fe(196353,23856,83);fe(196367,23856,127);fe(196386,23856,127);fe(196405,23856,131);fe(196424,23856,3);fe(196439,23856,27);fe(196457,23856,17);fe(196475,23856,5);fe(196491,23856,11);fe(196507,23856,1);fe(196522,23856,129);fe(196542,23856,129);fe(196562,23856,133);fe(196582,23856,125);fe(196599,23856,34);fe(196613,23856,35);fe(196627,23856,38);fe(196643,23856,39);fe(196659,23856,84);fe(196673,23856,105);fe(196693,23856,105);fe(196713,23856,95);fe(196733,23856,97);fe(196753,23856,112);fe(196773,23856,112);fe(196793,23856,112);fe(196813,23856,120);fe(196833,23856,120);fe(196853,23856,120);fe(196873,23856,103);fe(196893,23856,122);fe(196913,23856,101);fe(196932,23856,101);fe(196951,23856,91);fe(196970,23856,93);fe(196989,23856,108);fe(197008,23856,108);fe(197027,23856,108);fe(197046,23856,116);fe(197065,23856,116);fe(197084,23856,116);fe(197103,23856,99);fe(197122,23856,118);fe(197141,23856,106);fe(197160,23856,106);fe(197180,23856,106);fe(197200,23856,106);fe(197220,23856,106);fe(197240,23856,123);fe(197260,23856,123);fe(197280,23856,123);fe(197300,23856,124);fe(197320,23856,124);fe(197340,23856,124);fe(197360,23856,106);fe(197380,23856,124);fe(197400,23856,85);fe(197414,23856,104);fe(197434,23856,104);fe(197454,23856,94);fe(197474,23856,96);fe(197494,23856,111);fe(197514,23856,111);fe(197534,23856,111);fe(197554,23856,119);fe(197574,23856,119);fe(197594,23856,119);fe(197614,23856,102);fe(197634,23856,121);fe(197654,23856,100);fe(197673,23856,100);fe(197692,23856,90);fe(197711,23856,92);fe(197730,23856,107);fe(197749,23856,107);fe(197768,23856,107);fe(197787,23856,115);fe(197806,23856,115);fe(197825,23856,115);fe(197844,23856,98);fe(197863,23856,117);fe(197882,23856,99);fe(197900,23856,103);fe(197919,23856,106);fe(197938,23856,98);fe(197956,23856,102);fe(197975,23856,93);fe(197994,23856,97);fe(198014,23856,106);fe(198034,23856,92);fe(198053,23856,96);fe(198073,23856,126);fe(198090,23856,1);fe(198108,23856,2);fe(198126,23856,3);fe(198144,23856,16);fe(198155,23856,1);fe(198168,23856,8);fe(198179,23856,4);fe(198191,23856,0);fe(198207,23856,2);fe(198221,23856,1);fe(198233,23856,4);fe(198242,23856,3);fe(198258,23856,2);fe(198269,23856,0);fe(198279,23856,16);fe(198293,23856,4);fe(198303,23856,1);fe(198314,23856,64);fe(198332,23856,16);fe(198351,23856,1);fe(198363,23856,32);fe(198379,23856,4);fe(198388,23856,2);fe(198398,23856,3);fe(198405,23856,5);fe(198415,23856,7);fe(198426,23856,1);fe(198434,23856,4);fe(198443,23856,2);fe(198451,23856,0);fe(198468,23856,1);fe(198485,23856,3);fe(198497,23856,5);fe(198509,23856,0);fe(198527,23856,-1);fe(198537,23856,6);fe(198549,23856,2);fe(198578,23856,4);fe(198615,23856,5);fe(198655,23856,3);fe(198687,23856,6);fe(198720,23856,1);fe(198749,23856,0);fe(198774,23856,1);fe(198808,23856,4);fe(198845,23856,2);fe(198885,23856,-1);fe(198892,23856,65536);fe(198914,23856,131072);fe(198934,23856,3);fe(198955,23856,5);fe(198982,23856,2);fe(199002,23856,1);fe(199021,23856,7);fe(199049,23856,6);fe(199077,23856,0);fe(199098,23856,4);fe(199119,23856,16);fe(199131,23856,10002);fe(199158,23856,10001);fe(199197,23856,1e4);fe(199227,23856,0);fe(199256,23856,1);fe(199286,23856,2);fe(199316,23856,32);fe(199331,23856,2);fe(199346,23856,8);fe(199360,23856,1);fe(199373,23856,6);fe(199386,23856,64);fe(199401,23856,0);fe(199415,23856,2);fe(199429,23856,4);fe(199442,23856,5);fe(199455,23856,3);fe(199468,23856,3);fe(199484,23856,7);fe(199503,23856,16);fe(199517,23856,2);fe(199536,23856,64);fe(199555,23856,0);fe(199579,23856,24);fe(199603,23856,56);fe(199627,23856,8);fe(199650,23856,16);fe(199674,23856,4);fe(199697,23856,4);fe(199716,23856,2);fe(199742,23856,0);fe(199759,23856,0);fe(199781,23856,1);fe(199808,23856,1);fe(199826,23856,65);fe(199851,23856,5);fe(199867,23856,2);fe(199885,23856,0);fe(199907,23856,1);fe(199928,23856,4);fe(199948,23856,3);fe(199969,23856,0);fe(199976,23856,2);fe(199984,23856,3);fe(200005,23856,1);fe(200012,23856,1);fe(200030,23856,0);fe(200048,23856,2);fe(200058,23856,3);fe(200068,23856,1);fe(200077,23856,2);fe(200086,23856,4);fe(200095,23856,3);fe(200117,23856,1);fe(200132,23856,4);fe(200151,23856,0);fe(200166,23856,3);fe(200184,23856,2);fe(200202,23856,5);fe(200217,23856,64);fe(200247,23856,0);fe(200267,23856,3);fe(200282,23856,2);fe(200300,23856,1);fe(200320,23856,0);fe(200335,23856,6);fe(200352,23856,2);fe(200367,23856,0);fe(200382,23856,1);fe(200400,23856,3);fe(200411,23856,5);fe(200422,23856,10);fe(200434,23856,2);fe(200446,23856,4);fe(200461,23856,1);fe(200474,23856,5);fe(200493,23856,7);fe(200503,23856,0);fe(200517,23856,32);fe(200532,23856,1024);fe(200548,23856,3);fe(200570,23856,0);fe(200586,23856,1);fe(200602,23856,2);fe(200621,23856,2);fe(200639,23856,0);fe(200661,23856,1);fe(200687,23856,4);fe(200694,23856,8);fe(200701,23856,16);fe(200709,23856,2);fe(200724,23856,0);fe(200740,23856,1);fe(200755,23856,0);fe(200768,23856,3);fe(200783,23856,4);fe(200797,23856,2);fe(200809,23856,1);fe(200829,23856,6);fe(200850,23856,5);fe(200869,23856,6);fe(200884,23856,3);fe(200896,23856,1);fe(200908,23856,1);fe(200921,23856,2);fe(200935,23856,0);fe(200947,23856,4);fe(200962,23856,7);fe(200976,23856,2);fe(200987,23856,0);fe(200998,23856,5);fe(201011,23856,2);fe(201025,23856,1);fe(201042,23856,3);fe(201060,23856,0);fe(201079,23856,0);fe(201093,23856,16384);fe(201113,23864,7);fe(201128,23864,-65536);fe(201143,23856,1124007936);fe(201157,23856,32768);fe(201176,23864,4095);fe(201190,23856,6);fe(201203,23856,7);fe(201217,23856,1);fe(201226,23856,2);fe(201234,23856,4);fe(201242,23856,5);fe(201253,23856,32);fe(201265,23856,8);fe(201279,23856,7);fe(201294,23856,256);fe(201321,23856,8);fe(201350,23856,4);fe(201375,23856,1);fe(201390,23856,0);fe(201407,23856,32);fe(201418,23856,1);fe(201434,23856,0);fe(201450,23856,2);fe(201462,23856,1);fe(201484,23856,0);fe(201505,23856,6);fe(201521,23856,1);fe(201535,23856,7);fe(201547,23856,0);fe(201557,23856,4);fe(201567,23856,5);fe(201584,23856,2);fe(201595,23856,12);fe(201608,23856,3);fe(201621,23856,11);fe(201633,23856,9);fe(201646,23856,8);fe(201665,23856,1);fe(201676,23856,2);fe(201687,23856,3);fe(201698,23856,0);fe(201709,23856,2);fe(201720,23856,0);fe(201734,23856,4);fe(201749,23856,1);fe(201759,23856,3);fe(201769,23856,1);fe(201780,23856,0);fe(201792,23856,1);fe(201803,23856,0);fe(201823,23856,2);fe(201850,23856,1);fe(201864,23856,0);fe(201879,23856,-2);fe(201897,23856,-1);fe(201916,23856,0);fe(201931,23856,16);fe(201947,23856,1);fe(201965,23856,0);fe(201980,23856,4);fe(201992,23856,1);fe(202005,23856,2);fe(202015,23864,-2147483648);fe(202034,23864,1540483477);fe(202055,23864,1123876864);fe(202075,23864,32);fe(202093,23856,34);fe(202118,23856,19);fe(202144,23856,0);fe(202169,23856,49);fe(202196,23856,51);fe(202221,23856,32);fe(202247,23856,17);fe(202272,23856,2);fe(202299,23856,-2);fe(202320,23856,0);fe(202342,23856,2);fe(202365,23856,-1);fe(202393,23856,1);fe(202415,23856,0);fe(202429,23856,1);fe(202447,23856,7);fe(202459,23856,8);fe(202471,23856,3);fe(202485,23856,4);fe(202503,23856,16);fe(202519,23856,2);fe(202532,23856,4);fe(202542,23856,5);fe(202559,23856,2);fe(202568,23856,3);fe(202584,23856,0);fe(202594,23856,1);fe(202611,23856,1);fe(202630,23856,2);fe(202647,23856,1);fe(202669,23856,128);fe(202692,23856,1);fe(202713,23856,4);fe(202743,23856,64);fe(202770,23856,2);fe(202798,23856,24);fe(202824,23856,8);fe(202843,23856,32);fe(202867,23856,0);fe(202882,23856,16384);fe(202903,23864,7);fe(202919,23864,-65536);fe(202935,23856,1124007936);fe(202950,23856,32768);fe(202970,23864,4095);fe(202985,23856,2);fe(203014,23856,1);fe(203041,23856,4);fe(203070,23856,0);fe(203084,23856,8);fe(203103,23856,16);fe(203120,23856,0);fe(203138,23856,256);fe(203153,23856,589824);fe(203178,23856,524288);fe(203204,23856,393216);fe(203221,23856,1073741824);fe(203244,23856,-2147483648);fe(203267,23856,2031616);fe(203289,23856,16);fe(203312,23856,65536);fe(203328,23856,131072);fe(203345,23856,0);fe(203362,23856,458752);fe(203388,23856,917504);fe(203410,23856,983040);fe(203436,23856,786432);fe(203464,23856,196608);fe(203487,23856,851968);fe(203523,23856,327680);fe(203550,23856,720896);fe(203578,23856,262144);fe(203608,23856,655360);fe(203625,23856,8);fe(203653,23856,4);fe(203681,23856,32);fe(203709,23856,16);fe(203737,23856,64);fe(203765,23856,2);fe(203792,23856,1);fe(203819,23856,127);fe(203847,23856,125);fe(203882,23856,96);fe(203910,23856,2147483647);fe(203935,23856,-21);fe(203944,23856,-18);fe(203960,23856,-24);fe(203967,23856,-22);fe(203979,23856,-12);fe(203990,23856,-17);fe(203999,23856,-10);fe(204012,23856,-14);fe(204028,23856,-16);fe(204044,23856,-15);fe(204059,23856,-11);fe(204069,23856,-19);fe(204078,23856,-20);fe(204088,23856,-25);fe(204099,23856,-13);fe(204107,23856,-23);fe(204119,23856,-217);fe(204135,23856,-216);fe(204151,23856,-9);fe(204164,23856,-26);fe(204176,23856,-220);fe(204195,23856,-221);fe(204220,23856,-222);fe(204236,23856,-223);fe(204255,23856,-219);fe(204274,23856,-218);fe(204293,23856,-215);fe(204303,23856,-8);fe(204316,23856,-1);fe(204329,23856,-5);fe(204339,23856,-206);fe(204350,23856,-6);fe(204361,23856,-208);fe(204372,23856,-214);fe(204387,23856,-207);fe(204399,23856,-201);fe(204410,23856,-202);fe(204423,23856,-2);fe(204432,23856,-31);fe(204451,23856,-29);fe(204477,23856,-203);fe(204500,23856,-3);fe(204512,23856,-30);fe(204538,23856,-7);fe(204548,23856,-4);fe(204557,23856,-213);fe(204575,23856,-27);fe(204586,23856,-204);fe(204604,23856,0);fe(204610,23856,-211);fe(204624,23856,-212);fe(204638,23856,-205);fe(204658,23856,-209);fe(204676,23856,-210);fe(204697,23856,-28);fe(204713,23856,0);fe(204725,23856,1);fe(204733,23856,5);fe(204741,23856,6);fe(204749,23856,3);fe(204757,23856,4);fe(204765,23856,2);fe(204773,23856,0);fe(204793,23856,1);fe(204812,23856,2);fe(204841,23856,3);fe(204860,23856,0);fe(204875,23856,4);fe(204891,23856,3);fe(204909,23856,1);fe(204927,23856,2);fe(204950,23856,2);fe(204974,23856,1);fe(204988,23856,0);fe(204999,23856,1);fe(205008,23856,2);fe(205020,23856,0);fe(205031,23856,3);fe(205040,23856,0);fe(205053,23856,1);fe(205065,23856,2);return}function Ov(a,b,c){a=a|0;b=b|0;c=c|0;z5(a,b,271731,461938,c);return}function Pv(a){a=a|0;Rd(a|0)|0;jFc()}function Qv(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[519744]|0)==0?MIc(519744)|0:0){h=Af(2,23936)|0;f[132504]=h}h=f[132504]|0;i=VDc(8)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[g>>2]=i;Ed(h|0,a|0,c|0,g|0);u=e;return}function Rv(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[519752]|0)==0?MIc(519752)|0:0){h=Af(2,23944)|0;f[132505]=h}h=f[132505]|0;i=VDc(20)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[g>>2]=i;Ed(h|0,a|0,c|0,g|0);u=e;return}function Sv(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[519760]|0)==0?MIc(519760)|0:0){h=Af(2,23952)|0;f[132506]=h}h=f[132506]|0;i=VDc(16)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[g>>2]=i;Ed(h|0,a|0,c|0,g|0);u=e;return}function Tv(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Yv(a,b);return}else{f[d>>2]=f[b>>2];f[c>>2]=d+4;return}}function Uv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>2;i=e;if(h>>>0<b>>>0){Zv(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<2)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-4-h|0)>>>2)<<2);return}function Vv(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>2|0}function Wv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>2>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}f[e>>2]=f[g+(c<<2)>>2];h=bf(23856,e|0)|0;f[a>>2]=h;u=d;return}function Xv(a,b,c){a=a|0;b=b|0;c=c|0;f[(f[a>>2]|0)+(b<<2)>>2]=f[c>>2];return 1}function Yv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function Zv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>2>>>0>=b>>>0){j=b;k=i;while(1){f[k>>2]=f[c>>2];j=j+-1|0;if(!j)break;else k=k+4|0}f[g>>2]=i+(b<<2);return}i=f[a>>2]|0;k=h-i|0;h=k>>2;j=h+b|0;if(j>>>0>1073741823)mCc(a);l=e-i|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<j>>>0?j:e):1073741823;do if(m)if(m>>>0>1073741823){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m<<2)|0;break}else n=0;while(0);e=n+(h<<2)|0;j=n+(m<<2)|0;m=b;n=e;while(1){f[n>>2]=f[c>>2];m=m+-1|0;if(!m)break;else n=n+4|0}n=e+(0-h<<2)|0;if((k|0)>0)dJc(n|0,i|0,k|0)|0;f[a>>2]=n;f[g>>2]=e+(b<<2);f[d>>2]=j;if(!i)return;YDc(i);return}function _v(a){a=a|0;return 4216}function $v(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}YDc(a);return}function aw(){var a=0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function bw(a){a=a|0;return yj[a&63]()|0}function cw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;f[e>>2]=c;mi[i&2047](a,e);u=d;return}function dw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;f[g>>2]=d;Ti[j&511](a,c,g);u=e;return}function ew(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function fw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);Vf(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function gw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;f[g>>2]=d;d=hj[h&511](b,c,g)|0;u=e;return d|0}function hw(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){mw(a,b);return}else{f[d>>2]=f[b>>2];f[c>>2]=d+4;return}}function iw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>2;i=e;if(h>>>0<b>>>0){nw(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<2)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-4-h|0)>>>2)<<2);return}function jw(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>2|0}function kw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>2>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}f[e>>2]=f[g+(c<<2)>>2];h=bf(23888,e|0)|0;f[a>>2]=h;u=d;return}function lw(a,b,c){a=a|0;b=b|0;c=c|0;f[(f[a>>2]|0)+(b<<2)>>2]=f[c>>2];return 1}function mw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function nw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>2>>>0>=b>>>0){i=h+(b<<2)|0;j=b;k=h;while(1){f[k>>2]=f[c>>2];j=j+-1|0;if(!j)break;else k=k+4|0}f[g>>2]=i;return}i=f[a>>2]|0;k=h-i|0;h=k>>2;j=h+b|0;if(j>>>0>1073741823)mCc(a);l=e-i|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<j>>>0?j:e):1073741823;do if(m)if(m>>>0>1073741823){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m<<2)|0;break}else n=0;while(0);e=n+(h<<2)|0;l=n+(m<<2)|0;m=b;b=e;while(1){f[b>>2]=f[c>>2];m=m+-1|0;if(!m)break;else b=b+4|0}b=e+(0-h<<2)|0;if((k|0)>0)dJc(b|0,i|0,k|0)|0;f[a>>2]=b;f[g>>2]=n+(j<<2);f[d>>2]=l;if(!i)return;YDc(i);return}function ow(a){a=a|0;return 4304}function pw(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}YDc(a);return}function qw(){var a=0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function rw(a){a=a|0;return yj[a&63]()|0}function sw(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;n[e>>2]=c;mi[i&2047](a,e);u=d;return}function tw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;n[g>>2]=d;Ti[j&511](a,c,g);u=e;return}function uw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function vw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);Vf(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function ww(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;n[g>>2]=d;a=hj[h&511](b,c,g)|0;u=e;return a|0}function xw(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Cw(a,b);return}else{p[d>>3]=+p[b>>3];f[c>>2]=d+8;return}}function yw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>3;i=e;if(h>>>0<b>>>0){Dw(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<3)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-8-h|0)>>>3)<<3);return}function zw(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>3|0}function Aw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>3>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}p[e>>3]=+p[g+(c<<3)>>3];h=bf(23896,e|0)|0;f[a>>2]=h;u=d;return}function Bw(a,b,c){a=a|0;b=b|0;c=c|0;p[(f[a>>2]|0)+(b<<3)>>3]=+p[c>>3];return 1}function Cw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;p[k>>3]=+p[b>>3];b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function Dw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=b;k=i;while(1){p[k>>3]=+p[c>>3];j=j+-1|0;if(!j)break;else k=k+8|0}f[g>>2]=i+(b<<3);return}i=f[a>>2]|0;k=h-i|0;h=k>>3;j=h+b|0;if(j>>>0>536870911)mCc(a);l=e-i|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<j>>>0?j:e):536870911;do if(m)if(m>>>0>536870911){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m<<3)|0;break}else n=0;while(0);e=n+(h<<3)|0;j=n+(m<<3)|0;m=b;n=e;while(1){p[n>>3]=+p[c>>3];m=m+-1|0;if(!m)break;else n=n+8|0}n=e+(0-h<<3)|0;if((k|0)>0)dJc(n|0,i|0,k|0)|0;f[a>>2]=n;f[g>>2]=e+(b<<3);f[d>>2]=j;if(!i)return;YDc(i);return}function Ew(a){a=a|0;return 4384}function Fw(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b)}YDc(a);return}function Gw(){var a=0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Hw(a){a=a|0;return yj[a&63]()|0}function Iw(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;p[e>>3]=c;mi[i&2047](a,e);u=d;return}function Jw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;p[g>>3]=d;Ti[j&511](a,c,g);u=e;return}function Kw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function Lw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);Vf(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function Mw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;p[g>>3]=d;a=hj[h&511](b,c,g)|0;u=e;return a|0}function Nw(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Sw(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[c>>2]=d+8;return}}function Ow(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>3;i=e;if(h>>>0<b>>>0){Tw(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<3)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-8-h|0)>>>3)<<3);return}function Pw(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>3|0}function Qw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((f[b+4>>2]|0)-g>>3>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=VDc(8)|0;f[g>>2]=f[h+(c<<3)>>2];f[g+4>>2]=f[h+(c<<3)+4>>2];f[e>>2]=g;i=bf(4520,e|0)|0;f[a>>2]=i;u=d;return}function Rw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b<<3)>>2]=f[c>>2];f[d+(b<<3)+4>>2]=f[c+4>>2];return 1}function Sw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;while(1){m=n;n=n+-8|0;f[j+-8>>2]=f[n>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-8|0}o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function Tw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=c+4|0;k=b;l=i;while(1){f[l>>2]=f[c>>2];f[l+4>>2]=f[j>>2];k=k+-1|0;if(!k)break;else l=l+8|0}f[g>>2]=i+(b<<3);return}l=f[a>>2]|0;k=h-l>>3;h=k+b|0;j=l;if(h>>>0>536870911)mCc(a);m=e-l|0;e=m>>2;n=m>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(n)if(n>>>0>536870911){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{o=VDc(n<<3)|0;break}else o=0;while(0);e=o+(k<<3)|0;k=o+(n<<3)|0;n=c+4|0;o=b;h=e;while(1){f[h>>2]=f[c>>2];f[h+4>>2]=f[n>>2];o=o+-1|0;if(!o)break;else h=h+8|0}h=k;k=e+(b<<3)|0;if((i|0)==(j|0)){p=e;q=l}else{b=i+-8-l|0;l=i;i=e;while(1){o=l;l=l+-8|0;f[i+-8>>2]=f[l>>2];f[i+-4>>2]=f[o+-4>>2];if((l|0)==(j|0))break;else i=i+-8|0}p=e+(~(b>>>3)<<3)|0;q=f[a>>2]|0}f[a>>2]=p;f[g>>2]=k;f[d>>2]=h;if(!q)return;YDc(q);return}function Uw(a){a=a|0;return 4464}function Vw(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b)}YDc(a);return}function Ww(){var a=0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Xw(a){a=a|0;return yj[a&63]()|0}function Yw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;mi[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;mi[g&2047](a,c);return}}function Zw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;Ti[h&511](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;Ti[h&511](a,c,d);return}}function _w(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function $w(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);Vf(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function ax(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[a>>2]&511](b,c,d)|0}function bx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){gx(a,b);return}f[d>>2]=f[b>>2];a=d+4|0;e=b+4|0;f[a>>2]=f[e>>2];g=d+8|0;f[g>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[d+16>>2]=f[b+16>>2];f[d+20>>2]=f[b+20>>2];f[d+24>>2]=f[b+24>>2];f[d+28>>2]=f[b+28>>2];f[d+32>>2]=f[b+32>>2];h=f[b+36>>2]|0;f[d+36>>2]=h;f[d+40>>2]=g;g=d+48|0;i=d+44|0;f[i>>2]=g;f[g>>2]=0;f[d+52>>2]=0;if(h|0){g=h+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[e>>2]|0)<3){e=f[b+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2]}else{f[a>>2]=0;ZS(d,b)}f[c>>2]=(f[c>>2]|0)+56;return}function cx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/56|0;i=e;if(h>>>0<b>>>0){jx(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*56|0)|0;if((i|0)==(h|0))return;else j=i;do{i=j+-56|0;f[d>>2]=i;b=j+-20|0;g=f[b>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)_S(i);f[b>>2]=0;b=j+-40|0;i=j+-52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[j+-16>>2]|0;g=0;do{f[b+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[j+-12>>2]|0;if((i|0)!=(j+-8|0))g0(i);j=f[d>>2]|0}while((j|0)!=(h|0));return}function dx(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/56|0|0}function ex(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((((f[b+4>>2]|0)-g|0)/56|0)>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}b=tx(g+(c*56|0)|0)|0;f[e>>2]=b;h=bf(4608,e|0)|0;f[a>>2]=h;u=d;return}function fx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[a>>2]|0;a=d+(b*56|0)|0;if((a|0)==(c|0))return 1;e=c+36|0;g=f[e>>2]|0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}h=d+(b*56|0)+36|0;g=f[h>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)_S(a);f[h>>2]=0;g=d+(b*56|0)+16|0;i=d+(b*56|0)+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){j=f[d+(b*56|0)+40>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0;l=f[i>>2]|0}while((k|0)<(l|0));f[a>>2]=f[c>>2];if((l|0)<3)m=12;else m=14}else{f[a>>2]=f[c>>2];m=12}if((m|0)==12){l=f[c+4>>2]|0;if((l|0)<3){f[i>>2]=l;f[d+(b*56|0)+8>>2]=f[c+8>>2];f[d+(b*56|0)+12>>2]=f[c+12>>2];l=f[c+44>>2]|0;i=f[d+(b*56|0)+44>>2]|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2]}else m=14}if((m|0)==14)ZS(a,c);f[g>>2]=f[c+16>>2];f[d+(b*56|0)+20>>2]=f[c+20>>2];f[d+(b*56|0)+24>>2]=f[c+24>>2];f[d+(b*56|0)+28>>2]=f[c+28>>2];f[d+(b*56|0)+32>>2]=f[c+32>>2];f[h>>2]=f[e>>2];return 1}function gx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/56|0;h=g+1|0;if(h>>>0>76695844)mCc(a);i=((f[a+8>>2]|0)-e|0)/56|0;e=i<<1;j=i>>>0<38347922?(e>>>0<h>>>0?h:e):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>76695844){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{k=VDc(j*56|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*56|0)|0;h=d+8|0;f[h>>2]=e;f[d+4>>2]=e;f[d+12>>2]=k+(j*56|0);f[e>>2]=f[b>>2];j=k+(g*56|0)+4|0;i=b+4|0;l=f[i>>2]|0;f[j>>2]=l;m=k+(g*56|0)+8|0;f[m>>2]=f[b+8>>2];f[k+(g*56|0)+12>>2]=f[b+12>>2];f[k+(g*56|0)+16>>2]=f[b+16>>2];f[k+(g*56|0)+20>>2]=f[b+20>>2];f[k+(g*56|0)+24>>2]=f[b+24>>2];f[k+(g*56|0)+28>>2]=f[b+28>>2];f[k+(g*56|0)+32>>2]=f[b+32>>2];n=f[b+36>>2]|0;f[k+(g*56|0)+36>>2]=n;f[k+(g*56|0)+40>>2]=m;m=k+(g*56|0)+48|0;o=k+(g*56|0)+44|0;f[o>>2]=m;f[m>>2]=0;f[k+(g*56|0)+52>>2]=0;if(!n)p=l;else{l=n+12|0;f[l>>2]=(f[l>>2]|0)+1;p=f[i>>2]|0}if((p|0)<3){p=f[b+44>>2]|0;i=f[o>>2]|0;f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;hx(a,d);ix(d);u=c;return}else{f[j>>2]=0;ZS(e,b);q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;hx(a,d);ix(d);u=c;return}}function hx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;if((e|0)==(c|0)){h=g;i=a;j=f[g>>2]|0;k=c;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}t=e;e=f[g>>2]|0;do{u=e+-56|0;v=t;t=t+-56|0;f[u>>2]=f[t>>2];w=e+-52|0;x=v+-52|0;f[w>>2]=f[x>>2];y=e+-48|0;f[y>>2]=f[v+-48>>2];f[e+-44>>2]=f[v+-44>>2];f[e+-40>>2]=f[v+-40>>2];f[e+-36>>2]=f[v+-36>>2];f[e+-32>>2]=f[v+-32>>2];f[e+-28>>2]=f[v+-28>>2];f[e+-24>>2]=f[v+-24>>2];z=f[v+-20>>2]|0;f[e+-20>>2]=z;f[e+-16>>2]=y;y=e+-8|0;A=e+-12|0;f[A>>2]=y;f[y>>2]=0;f[e+-4>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+-12>>2]|0;v=f[A>>2]|0;f[v>>2]=f[x>>2];f[v+4>>2]=f[x+4>>2]}else{f[w>>2]=0;ZS(u,t)}e=(f[g>>2]|0)+-56|0;f[g>>2]=e}while((t|0)!=(c|0));h=g;i=a;j=e;k=f[a>>2]|0;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}function ix(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;c=a+8|0;d=f[c>>2]|0;if((d|0)!=(b|0)){e=d;do{d=e+-56|0;f[c>>2]=d;g=e+-20|0;h=f[g>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)_S(d);f[g>>2]=0;g=e+-40|0;d=e+-52|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){g=f[e+-16>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[d>>2]|0))}d=f[e+-12>>2]|0;if((d|0)!=(e+-8|0))g0(d);e=f[c>>2]|0}while((e|0)!=(b|0))}b=f[a>>2]|0;if(!b)return;YDc(b);return}function jx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d;g=f[a+8>>2]|0;h=a+4|0;i=f[h>>2]|0;if(((g-i|0)/56|0)>>>0>=b>>>0){j=c+4|0;k=c+8|0;l=c+12|0;m=c+16|0;n=c+20|0;o=c+24|0;p=c+28|0;q=c+32|0;r=c+36|0;s=c+44|0;t=b;v=i;do{f[v>>2]=f[c>>2];w=v+4|0;f[w>>2]=f[j>>2];x=v+8|0;f[x>>2]=f[k>>2];f[v+12>>2]=f[l>>2];f[v+16>>2]=f[m>>2];f[v+20>>2]=f[n>>2];f[v+24>>2]=f[o>>2];f[v+28>>2]=f[p>>2];f[v+32>>2]=f[q>>2];y=f[r>>2]|0;f[v+36>>2]=y;f[v+40>>2]=x;x=v+48|0;z=v+44|0;f[z>>2]=x;f[x>>2]=0;f[v+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[j>>2]|0)<3){x=f[s>>2]|0;y=f[z>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2]}else{f[w>>2]=0;ZS(v,c)}v=(f[h>>2]|0)+56|0;f[h>>2]=v;t=t+-1|0}while((t|0)!=0);u=d;return}t=f[a>>2]|0;v=(i-t|0)/56|0;i=v+b|0;if(i>>>0>76695844)mCc(a);h=(g-t|0)/56|0;t=h<<1;g=h>>>0<38347922?(t>>>0<i>>>0?i:t):76695844;f[e+12>>2]=0;f[e+16>>2]=a+8;do if(g)if(g>>>0>76695844){t=af(8)|0;bEc(t,503977);f[t>>2]=185532;ig(t|0,23696,1627)}else{A=VDc(g*56|0)|0;break}else A=0;while(0);f[e>>2]=A;t=A+(v*56|0)|0;v=e+8|0;f[v>>2]=t;f[e+4>>2]=t;f[e+12>>2]=A+(g*56|0);g=c+4|0;A=c+8|0;i=c+12|0;h=c+16|0;s=c+20|0;j=c+24|0;r=c+28|0;q=c+32|0;p=c+36|0;o=c+44|0;n=b;b=t;do{f[b>>2]=f[c>>2];t=b+4|0;f[t>>2]=f[g>>2];m=b+8|0;f[m>>2]=f[A>>2];f[b+12>>2]=f[i>>2];f[b+16>>2]=f[h>>2];f[b+20>>2]=f[s>>2];f[b+24>>2]=f[j>>2];f[b+28>>2]=f[r>>2];f[b+32>>2]=f[q>>2];l=f[p>>2]|0;f[b+36>>2]=l;f[b+40>>2]=m;m=b+48|0;k=b+44|0;f[k>>2]=m;f[m>>2]=0;f[b+52>>2]=0;if(l|0){m=l+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){m=f[o>>2]|0;l=f[k>>2]|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2]}else{f[t>>2]=0;ZS(b,c)}b=(f[v>>2]|0)+56|0;f[v>>2]=b;n=n+-1|0}while((n|0)!=0);hx(a,e);ix(e);u=d;return}function kx(a){a=a|0;return 4552}function lx(a){a=a|0;if(!a)return;mx(a);YDc(a);return}function mx(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;do{d=g+-56|0;f[c>>2]=d;h=g+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)_S(d);f[h>>2]=0;h=g+-40|0;d=g+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[d>>2]|0)>0){h=f[g+-16>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[g+-12>>2]|0;if((d|0)!=(g+-8|0))g0(d);g=f[c>>2]|0}while((g|0)!=(b|0));e=f[a>>2]|0}YDc(e);return}function nx(){var a=0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function ox(a){a=a|0;return yj[a&63]()|0}function px(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;mi[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;mi[g&2047](a,c);return}}function qx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;Ti[h&511](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;Ti[h&511](a,c,d);return}}function rx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function sx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);Vf(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function tx(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=VDc(56)|0;f[b>>2]=f[a>>2];c=b+4|0;d=a+4|0;e=f[d>>2]|0;f[c>>2]=e;g=b+8|0;f[g>>2]=f[a+8>>2];f[b+12>>2]=f[a+12>>2];f[b+16>>2]=f[a+16>>2];f[b+20>>2]=f[a+20>>2];f[b+24>>2]=f[a+24>>2];f[b+28>>2]=f[a+28>>2];f[b+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[b+36>>2]=h;f[b+40>>2]=g;g=b+48|0;i=b+44|0;f[i>>2]=g;f[g>>2]=0;f[b+52>>2]=0;if(!h)j=e;else{e=h+12|0;f[e>>2]=(f[e>>2]|0)+1;j=f[d>>2]|0}if((j|0)<3){j=f[a+44>>2]|0;d=f[i>>2]|0;f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];return b|0}else{f[c>>2]=0;ZS(b,a);return b|0}return 0}function ux(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[a>>2]&511](b,c,d)|0}function vx(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Ax(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[d+8>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[c>>2]=d+16;return}}function wx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>4;i=e;if(h>>>0<b>>>0){Bx(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<4)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-16-h|0)>>>4)<<4);return}function xx(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>4|0}function yx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((f[b+4>>2]|0)-g>>4>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=VDc(16)|0;f[g>>2]=f[h+(c<<4)>>2];f[g+4>>2]=f[h+(c<<4)+4>>2];f[g+8>>2]=f[h+(c<<4)+8>>2];f[g+12>>2]=f[h+(c<<4)+12>>2];f[e>>2]=g;i=bf(4176,e|0)|0;f[a>>2]=i;u=d;return}function zx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b<<4)>>2]=f[c>>2];f[d+(b<<4)+4>>2]=f[c+4>>2];f[d+(b<<4)+8>>2]=f[c+8>>2];f[d+(b<<4)+12>>2]=f[c+12>>2];return 1}function Ax(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function Bx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>4>>>0>=b>>>0){j=c+4|0;k=c+8|0;l=c+12|0;m=b;n=i;while(1){f[n>>2]=f[c>>2];f[n+4>>2]=f[j>>2];f[n+8>>2]=f[k>>2];f[n+12>>2]=f[l>>2];m=m+-1|0;if(!m)break;else n=n+16|0}f[g>>2]=i+(b<<4);return}n=f[a>>2]|0;m=h-n>>4;h=m+b|0;l=n;if(h>>>0>268435455)mCc(a);k=e-n|0;e=k>>3;j=k>>4>>>0<134217727?(e>>>0<h>>>0?h:e):268435455;do if(j)if(j>>>0>268435455){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{o=VDc(j<<4)|0;break}else o=0;while(0);e=o+(m<<4)|0;m=o+(j<<4)|0;j=c+4|0;o=c+8|0;h=c+12|0;k=b;p=e;while(1){f[p>>2]=f[c>>2];f[p+4>>2]=f[j>>2];f[p+8>>2]=f[o>>2];f[p+12>>2]=f[h>>2];k=k+-1|0;if(!k)break;else p=p+16|0}p=m;m=e+(b<<4)|0;if((i|0)==(l|0)){q=e;r=n}else{b=i+-16-n|0;n=i;i=e;while(1){k=n;n=n+-16|0;f[i+-16>>2]=f[n>>2];f[i+-12>>2]=f[k+-12>>2];f[i+-8>>2]=f[k+-8>>2];f[i+-4>>2]=f[k+-4>>2];if((n|0)==(l|0))break;else i=i+-16|0}q=e+(~(b>>>4)<<4)|0;r=f[a>>2]|0}f[a>>2]=q;f[g>>2]=m;f[d>>2]=p;if(!r)return;YDc(r);return}function Cx(a){a=a|0;return 4640}function Dx(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);YDc(b)}YDc(a);return}function Ex(){var a=0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Fx(a){a=a|0;return yj[a&63]()|0}function Gx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;mi[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;mi[g&2047](a,c);return}}function Hx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;Ti[h&511](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;Ti[h&511](a,c,d);return}}function Ix(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function Jx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);Vf(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function Kx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[a>>2]&511](b,c,d)|0}function Lx(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Qx(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];a=d+8|0;d=b+8|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[c>>2]=(f[c>>2]|0)+28;return}}function Mx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/28|0;i=e;if(h>>>0<b>>>0){Rx(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*28|0)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~(((i+-28-h|0)>>>0)/28|0)*28|0);return}function Nx(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/28|0|0}function Ox(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((((f[b+4>>2]|0)-g|0)/28|0)>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=VDc(28)|0;f[g>>2]=f[h+(c*28|0)>>2];f[g+4>>2]=f[h+(c*28|0)+4>>2];b=g+8|0;j=h+(c*28|0)+8|0;f[b>>2]=f[j>>2];f[b+4>>2]=f[j+4>>2];f[b+8>>2]=f[j+8>>2];f[b+12>>2]=f[j+12>>2];f[b+16>>2]=f[j+16>>2];f[e>>2]=g;i=bf(4776,e|0)|0;f[a>>2]=i;u=d;return}function Px(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b*28|0)>>2]=f[c>>2];f[d+(b*28|0)+4>>2]=f[c+4>>2];a=d+(b*28|0)+8|0;b=c+8|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];return 1}function Qx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/28|0;h=g+1|0;i=e;j=d;if(h>>>0>153391689)mCc(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/28|0;e=l<<1;m=l>>>0<76695844?(e>>>0<h>>>0?h:e):153391689;do if(m)if(m>>>0>153391689){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m*28|0)|0;break}else n=0;while(0);e=n+(g*28|0)|0;h=e;l=n+(m*28|0)|0;f[e>>2]=f[b>>2];f[n+(g*28|0)+4>>2]=f[b+4>>2];m=n+(g*28|0)+8|0;g=b+8|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];f[m+16>>2]=f[g+16>>2];g=e+28|0;if((j|0)==(i|0)){o=h;p=d}else{d=j;j=h;h=e;do{e=d;d=d+-28|0;f[h+-28>>2]=f[d>>2];f[h+-24>>2]=f[e+-24>>2];m=h+-20|0;b=e+-20|0;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[m+8>>2]=f[b+8>>2];f[m+12>>2]=f[b+12>>2];f[m+16>>2]=f[b+16>>2];h=j+-28|0;j=h}while((d|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[c>>2]=g;f[k>>2]=l;if(!p)return;YDc(p);return}function Rx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/28|0)>>>0>=b>>>0){i=c+4|0;j=c+8|0;k=b;l=h;do{f[l>>2]=f[c>>2];f[l+4>>2]=f[i>>2];m=l+8|0;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];f[m+16>>2]=f[j+16>>2];l=(f[g>>2]|0)+28|0;f[g>>2]=l;k=k+-1|0}while((k|0)!=0);return}k=f[a>>2]|0;l=(h-k|0)/28|0;h=l+b|0;if(h>>>0>153391689)mCc(a);j=(e-k|0)/28|0;k=j<<1;e=j>>>0<76695844?(k>>>0<h>>>0?h:k):153391689;do if(e)if(e>>>0>153391689){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{n=VDc(e*28|0)|0;break}else n=0;while(0);k=n+(l*28|0)|0;l=k;h=n+(e*28|0)|0;e=c+4|0;n=c+8|0;j=b;b=l;i=k;do{f[i>>2]=f[c>>2];f[i+4>>2]=f[e>>2];m=i+8|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];f[m+16>>2]=f[n+16>>2];i=b+28|0;b=i;j=j+-1|0}while((j|0)!=0);j=h;h=f[a>>2]|0;i=f[g>>2]|0;if((i|0)==(h|0)){o=l;p=h}else{n=i;i=l;l=k;do{k=n;n=n+-28|0;f[l+-28>>2]=f[n>>2];f[l+-24>>2]=f[k+-24>>2];e=l+-20|0;c=k+-20|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[e+8>>2]=f[c+8>>2];f[e+12>>2]=f[c+12>>2];f[e+16>>2]=f[c+16>>2];l=i+-28|0;i=l}while((n|0)!=(h|0));o=i;p=f[a>>2]|0}f[a>>2]=o;f[g>>2]=b;f[d>>2]=j;if(!p)return;YDc(p);return}function Sx(a){a=a|0;return 4720}function Tx(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~(((d+-28-b|0)>>>0)/28|0)*28|0);YDc(b)}YDc(a);return}function Ux(){var a=0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Vx(a){a=a|0;return yj[a&63]()|0}function Wx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;mi[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;mi[g&2047](a,c);return}}function Xx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;Ti[h&511](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;Ti[h&511](a,c,d);return}}function Yx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function Zx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);Vf(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function _x(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[a>>2]&511](b,c,d)|0}function $x(a){a=a|0;return 4608}function ay(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=a+36|0;c=f[b>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;c=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[a+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+44>>2]|0;if((c|0)!=(a+48|0))g0(c);YDc(a);return}function by(){var a=0,b=0,c=0,d=0,e=0;a=VDc(56)|0;f[a>>2]=1124007936;b=a+8|0;c=a+40|0;d=a+4|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+48|0;f[a+44>>2]=b;f[b>>2]=0;f[a+52>>2]=0;return a|0}function cy(a){a=a|0;return yj[a&63]()|0}function dy(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=VDc(56)|0;f[b>>2]=f[a>>2];c=b+4|0;d=a+4|0;e=f[d>>2]|0;f[c>>2]=e;g=b+8|0;f[g>>2]=f[a+8>>2];f[b+12>>2]=f[a+12>>2];f[b+16>>2]=f[a+16>>2];f[b+20>>2]=f[a+20>>2];f[b+24>>2]=f[a+24>>2];f[b+28>>2]=f[a+28>>2];f[b+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[b+36>>2]=h;f[b+40>>2]=g;g=b+48|0;i=b+44|0;f[i>>2]=g;f[g>>2]=0;f[b+52>>2]=0;if(!h)j=e;else{e=h+12|0;f[e>>2]=(f[e>>2]|0)+1;j=f[d>>2]|0}if((j|0)<3){j=f[a+44>>2]|0;d=f[i>>2]|0;f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];return b|0}else{f[c>>2]=0;ZS(b,a);return b|0}return 0}function ey(a,b){a=a|0;b=b|0;return _i[a&1023](b)|0}function fy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=VDc(56)|0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=f[b>>2]|0;f[e>>2]=1124007936;b=e+8|0;i=e+40|0;j=e+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=b;b=e+48|0;f[e+44>>2]=b;f[b>>2]=0;f[e+52>>2]=0;f[d>>2]=h;f[d+4>>2]=g;XS(e,2,d,a&4095);u=c;return e|0}function gy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[g>>2]=c;c=Mi[a&1023](e,g)|0;u=d;return c|0}function hy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=VDc(56)|0;h=f[a>>2]|0;a=f[b>>2]|0;b=f[c>>2]|0;f[g>>2]=1124007936;c=g+8|0;i=g+40|0;j=g+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=c;c=g+48|0;f[g+44>>2]=c;f[c>>2]=0;f[g+52>>2]=0;f[e>>2]=h;f[e+4>>2]=a;XS(g,2,e,b&4095);u=d;return g|0}function iy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e+8|0;h=e+4|0;i=e;f[g>>2]=b;f[h>>2]=c;f[i>>2]=d;d=hj[a&511](g,h,i)|0;u=e;return d|0}function jy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=VDc(56)|0;i=f[a>>2]|0;a=f[b>>2]|0;b=f[c>>2]|0;f[h>>2]=1124007936;c=h+8|0;j=h+40|0;k=h+4|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=c;c=h+48|0;f[h+44>>2]=c;f[c>>2]=0;f[h+52>>2]=0;f[g>>2]=i;f[g+4>>2]=a;XS(h,2,g,b&4095);k_(h,d)|0;u=e;return h|0}function ky(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;f[h>>2]=b;f[i>>2]=c;f[j>>2]=d;d=hh[a&127](h,i,j,e)|0;u=g;return d|0}function ly(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _h[a&127](b,c,d,e,f)|0}function my(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d+8|0;g=d;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];Ti[a&511](e,g,c);c=VDc(56)|0;f[c>>2]=f[e>>2];g=e+4|0;a=f[g>>2]|0;f[c+4>>2]=a;b=c+8|0;h=e+8|0;f[b>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=b;b=c+44|0;l=c+48|0;f[b>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[b>>2]=f[n>>2];b=e+40|0;f[k>>2]=f[b>>2];k=e+48|0;f[n>>2]=k;f[b>>2]=h;o=k}f[e>>2]=1124007936;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}g0(o);u=d;return c|0}function ny(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;ei[a&511](g,b,c,d);d=VDc(56)|0;f[d>>2]=f[g>>2];c=g+4|0;b=f[c>>2]|0;f[d+4>>2]=b;a=d+8|0;h=g+8|0;f[a>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];j=g+36|0;f[d+36>>2]=f[j>>2];k=d+40|0;f[k>>2]=a;a=d+44|0;l=d+48|0;f[a>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}g0(o);u=e;return d|0}function oy(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function py(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function qy(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[f[a>>2]&2047](d,b);Vf(f[d>>2]|0);b=f[d>>2]|0;Ae(b|0);u=c;return b|0}function ry(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function sy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function ty(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;Kh[f[a>>2]&15](b,c,d,e,g);return}function uy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function vy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function wy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;Ti[i&511](e,a,c);c=VDc(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}g0(o);u=d;return c|0}function xy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1)){i=g;ei[i&511](a,c,d,e);return}else{i=f[(f[a>>2]|0)+g>>2]|0;ei[i&511](a,c,d,e);return}}function yy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];Ti[j&511](a,g,d);u=e;return}function zy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;ei[j&511](g,a,c,d);d=VDc(56)|0;f[d>>2]=f[g>>2];c=g+4|0;a=f[c>>2]|0;f[d+4>>2]=a;j=d+8|0;h=g+8|0;f[j>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];b=g+36|0;f[d+36>>2]=f[b>>2];k=d+40|0;f[k>>2]=j;j=d+44|0;l=d+48|0;f[j>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[j>>2]=f[n>>2];j=g+40|0;f[k>>2]=f[j>>2];k=g+48|0;f[n>>2]=k;f[j>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[b>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}g0(o);u=e;return d|0}function Ay(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;Ti[i&511](e,a,c);c=VDc(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}g0(o);u=d;return c|0}function By(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function Cy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function Dy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function Ey(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;return Mi[g&1023](a,c)|0}function Fy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;mi[h&2047](d,a);a=VDc(56)|0;f[a>>2]=f[d>>2];h=d+4|0;e=f[h>>2]|0;f[a+4>>2]=e;g=a+8|0;b=d+8|0;f[g>>2]=f[b>>2];f[a+12>>2]=f[d+12>>2];i=d+16|0;f[a+16>>2]=f[i>>2];f[a+20>>2]=f[d+20>>2];f[a+24>>2]=f[d+24>>2];f[a+28>>2]=f[d+28>>2];f[a+32>>2]=f[d+32>>2];j=d+36|0;f[a+36>>2]=f[j>>2];k=a+40|0;f[k>>2]=g;g=a+44|0;l=a+48|0;f[g>>2]=l;m=a+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=b;o=k}f[d>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return a|0}g0(o);u=c;return a|0}function Gy(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[f[a>>2]&31](b,c))}function Hy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e;$h[f[a>>2]&63](g,b,c,d);c=VDc(56)|0;f[c>>2]=f[g>>2];b=g+4|0;a=f[b>>2]|0;f[c+4>>2]=a;h=c+8|0;i=g+8|0;f[h>>2]=f[i>>2];f[c+12>>2]=f[g+12>>2];j=g+16|0;f[c+16>>2]=f[j>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];k=g+36|0;f[c+36>>2]=f[k>>2];l=c+40|0;f[l>>2]=h;h=c+44|0;m=c+48|0;f[h>>2]=m;n=c+52|0;f[n>>2]=0;f[m>>2]=0;o=g+44|0;if((a|0)<3){a=f[o>>2]|0;f[m>>2]=f[a>>2];f[n>>2]=f[a+4>>2];p=a}else{f[h>>2]=f[o>>2];h=g+40|0;f[l>>2]=f[h>>2];l=g+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[g>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(g+48|0)){u=e;return c|0}g0(p);u=e;return c|0}function Iy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;Ti[f[a>>2]&511](e,b,c);c=VDc(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}g0(o);u=d;return c|0}function Jy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;mi[f[a>>2]&2047](d,b);b=VDc(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}g0(o);u=c;return b|0}function Ky(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;Ti[i&511](e,a,c);c=VDc(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}g0(o);u=d;return c|0}function Ly(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function My(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function Ny(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[f[a>>2]&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function Oy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);Vf(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function Py(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[f[a>>2]&511](g,b,c,d);Vf(f[g>>2]|0);d=f[g>>2]|0;Ae(d|0);u=e;return d|0}function Qy(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=c+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Mi[h&1023](a,d)|0;return b[e>>0]|0}function Ry(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=c+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hj[i&511](a,d,e)|0;return b[g>>0]|0}function Sy(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=c+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=hh[j&127](a,d,e,g)|0;return b[h>>0]|0}function Ty(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=c+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Mi[h&1023](a,d)|0;return b[e>>0]|0}function Uy(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=c+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hj[i&511](a,d,e)|0;return b[g>>0]|0}function Vy(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=c+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=hh[j&127](a,d,e,g)|0;return b[h>>0]|0}function Wy(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Mi[h&1023](a,c)|0;return d[e>>1]|0}function Xy(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hj[i&511](a,c,e)|0;return d[g>>1]|0}function Yy(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=hh[j&127](a,c,e,g)|0;return d[h>>1]|0}function Zy(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Mi[h&1023](a,c)|0;return d[e>>1]|0}function _y(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hj[i&511](a,c,e)|0;return d[g>>1]|0}function $y(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=hh[j&127](a,c,e,g)|0;return d[h>>1]|0}function az(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Mi[g&1023](a,c)|0;return f[d>>2]|0}function bz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=hj[h&511](a,c,d)|0;return f[e>>2]|0}function cz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hh[i&127](a,c,d,e)|0;return f[g>>2]|0}function dz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Mi[g&1023](a,c)|0;return +(+n[d>>2])}function ez(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=hj[h&511](a,c,d)|0;return +(+n[e>>2])}function fz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hh[i&127](a,c,d,e)|0;return +(+n[g>>2])}function gz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hh[i&127](a,c,d,e)|0;return +(+p[g>>3])}function hz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Mi[g&1023](a,c)|0;return +(+p[d>>3])}function iz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=hj[h&511](a,c,d)|0;return +(+p[e>>3])}function jz(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function kz(a){a=a|0;if(!a)return;YDc(a);return}function lz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function mz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function nz(){var a=0;a=VDc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function oz(a){a=a|0;if(!a)return;YDc(a);return}function pz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function qz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function rz(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function sz(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function tz(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function uz(a){a=a|0;if(!a)return;YDc(a);return}function vz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function wz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function xz(){var a=0;a=VDc(8)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;return a|0}function yz(a){a=a|0;if(!a)return;YDc(a);return}function zz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Az(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Bz(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function Cz(a){a=a|0;if(!a)return;YDc(a);return}function Dz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Ez(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Fz(){var a=0;a=VDc(8)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;return a|0}function Gz(a){a=a|0;if(!a)return;YDc(a);return}function Hz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Iz(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Jz(){var a=0;a=VDc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function Kz(a){a=a|0;if(!a)return;YDc(a);return}function Lz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Mz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Nz(){var a=0;a=VDc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function Oz(a){a=a|0;if(!a)return;YDc(a);return}function Pz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Qz(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Rz(){var a=0;a=VDc(20)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;return a|0}function Sz(a){a=a|0;if(!a)return;YDc(a);return}function Tz(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Uz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Vz(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Wz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Xz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Yz(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Zz(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);Vf(f[d>>2]|0);b=f[d>>2]|0;Ae(b|0);u=c;return b|0}function _z(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function $z(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function aA(){var a=0;a=VDc(28)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;n[a+8>>2]=0.0;n[a+12>>2]=-1.0;n[a+16>>2]=0.0;f[a+20>>2]=0;f[a+24>>2]=-1;return a|0}function bA(a){a=a|0;if(!a)return;YDc(a);return}function cA(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function dA(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function eA(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function fA(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function gA(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function hA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function iA(){var a=0;a=VDc(32)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function jA(a){a=a|0;if(!a)return;YDc(a);return}function kA(a,b){a=a|0;b=b|0;return +(+p[b+(a<<3)>>3])}function lA(a,b,c){a=a|0;b=b|0;c=+c;p[b+(a<<3)>>3]=c;return}function mA(){var a=0;a=VDc(32)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function nA(a){a=a|0;if(!a)return;YDc(a);return}function oA(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function pA(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function qA(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function rA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function sA(){var a=0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function tA(a){a=a|0;if(!a)return;YDc(a);return}function uA(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function vA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function wA(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function xA(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function yA(){var a=0;a=VDc(192)|0;dka(a);return a|0}function zA(a){a=a|0;if(!a)return;YDc(a);return}function AA(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function BA(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function CA(){var a=0;a=VDc(44)|0;Q5(a);return a|0}function DA(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function EA(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function FA(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function GA(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function HA(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)dEc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=VDc(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){dJc(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;mi[h&2047](c,g);if((b[g+11>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function IA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c;mi[a&2047](d,b);b=VDc(44)|0;f[b>>2]=46284;a=f[d+4>>2]|0;f[b+4>>2]=a;f[b+8>>2]=f[d+8>>2];if(a|0){e=a+-4|0;f[e>>2]=(f[e>>2]|0)+1}f[b+12>>2]=f[d+12>>2];e=f[d+16>>2]|0;f[b+16>>2]=e;f[b+20>>2]=f[d+20>>2];if(e|0){a=e+-4|0;f[a>>2]=(f[a>>2]|0)+1}a=f[d+24>>2]|0;f[b+24>>2]=a;f[b+28>>2]=f[d+28>>2];if(a|0){e=a+-4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[d+32>>2]|0;f[b+32>>2]=e;f[b+36>>2]=f[d+36>>2];if(!e){g=b+40|0;h=d+40|0;i=f[h>>2]|0;f[g>>2]=i;t5(d);u=c;return b|0}a=e+-4|0;f[a>>2]=(f[a>>2]|0)+1;g=b+40|0;h=d+40|0;i=f[h>>2]|0;f[g>>2]=i;t5(d);u=c;return b|0}function JA(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(12)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];u=c;return b|0}function KA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;Ti[a&511](e,b,c);c=VDc(32)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];u=d;return c|0}function LA(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;mi[a&2047](d,b);b=VDc(32)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];f[b+16>>2]=f[d+16>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];u=c;return b|0}function MA(a){a=a|0;var b=0,c=0;b=u;u=u+32|0;c=b;Yi[a&2047](c);a=VDc(32)|0;p[a>>3]=+p[c>>3];p[a+8>>3]=+p[c+8>>3];p[a+16>>3]=+p[c+16>>3];p[a+24>>3]=+p[c+24>>3];u=b;return a|0}function NA(a,b){a=a|0;b=b|0;return _i[a&1023](b)|0}function OA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;h=e+16|0;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];ei[a&511](h,b,c,g);Vf(f[h>>2]|0);g=f[h>>2]|0;Ae(g|0);u=e;return g|0}function PA(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;Yi[a&2047](d);a=b[d+11>>0]|0;e=a<<24>>24<0;g=e?f[d+4>>2]|0:a&255;a=ooc(g+4|0)|0;f[a>>2]=g;h=f[d>>2]|0;dJc(a+4|0,(e?h:d)|0,g|0)|0;if(!e){u=c;return a|0}YDc(h);u=c;return a|0}function QA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function RA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function SA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/28|0;h=g+1|0;i=e;j=d;if(h>>>0>153391689)mCc(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/28|0;e=l<<1;m=l>>>0<76695844?(e>>>0<h>>>0?h:e):153391689;do if(m)if(m>>>0>153391689){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m*28|0)|0;break}else n=0;while(0);e=n+(g*28|0)|0;h=e;l=n+(m*28|0)|0;f[e>>2]=f[b>>2];f[n+(g*28|0)+4>>2]=f[b+4>>2];m=n+(g*28|0)+8|0;g=b+8|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];f[m+16>>2]=f[g+16>>2];g=e+28|0;if((j|0)==(i|0)){o=h;p=d}else{d=j;j=h;h=e;do{e=d;d=d+-28|0;f[h+-28>>2]=f[d>>2];f[h+-24>>2]=f[e+-24>>2];m=h+-20|0;b=e+-20|0;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[m+8>>2]=f[b+8>>2];f[m+12>>2]=f[b+12>>2];f[m+16>>2]=f[b+16>>2];h=j+-28|0;j=h}while((d|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[c>>2]=g;f[k>>2]=l;if(!p)return;YDc(p);return}function TA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;YDc(d);return}function UA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)mCc(a);k=a+8|0;l=(f[k>>2]|0)-e|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(m)if(m>>>0>536870911){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m<<3)|0;break}else n=0;while(0);e=n+(g<<3)|0;h=e;l=n+(m<<3)|0;m=f[b>>2]|0;f[e>>2]=m;f[n+(g<<3)+4>>2]=f[b+4>>2];if(!m){o=j;p=i;q=d}else{d=m+-4|0;f[d>>2]=(f[d>>2]|0)+1;d=f[c>>2]|0;o=d;p=f[a>>2]|0;q=d}d=e+8|0;if((o|0)==(p|0)){r=h;s=o;t=q}else{q=o;o=h;h=e;do{e=q;q=q+-8|0;m=f[q>>2]|0;f[h+-8>>2]=m;f[h+-4>>2]=f[e+-4>>2];if(m|0){e=m+-4|0;f[e>>2]=(f[e>>2]|0)+1}h=o+-8|0;o=h}while((q|0)!=(p|0));r=o;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=d;f[k>>2]=l;l=s;k=t;while(1){t=k;if((t|0)==(l|0))break;d=t+-8|0;uT(d);k=d}if(!s)return;YDc(s);return}function VA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;Ig[a&3](b,c,d,e,f,g);return}function WA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;Ni[a&7](b,c,d,e,f);return}function XA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;qi[a&7](b,c,d,e);return}function YA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Zh[a&7](b,c,d,e,f,g);return}function ZA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Kh[a&15](b,c,d,e,f);return}function _A(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];Zh[a&7](b,c,j,e,g,h);u=i;return}function $A(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];Kh[a&15](b,c,i,e,g);u=h;return}function aB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];$h[a&63](b,c,h,e);u=g;return}function bB(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Bh[a&1](b,c,d,e,f,g,h,i,j);return}function cB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;Ag[a&1](b,c,d,e,f,g,h,i);return}function dB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;Eg[a&1](b,c,d,e,f,g,h);return}function eB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;Th[a&3](b,c,d,e,f,g);return}function fB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Kh[a&15](b,c,d,e,f);return}function gB(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;Mg[a&1](b,c,d,e,f,g,h,i,j);return}function hB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;Nh[a&1](b,c,d,e,f,g,h,i);return}function iB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;Gg[a&3](b,c,d,e,f,g,h);return}function jB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;Jg[a&3](b,c,d,e,f,g);return}function kB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;zg[a&7](b,c,d,e,f,g,h);return}function lB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;Lj[a&7](b,c,d,e,f,g);return}function mB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ni[a&31](b,c,d,e,f);return}function nB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function oB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function pB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;ug[a&3](b,c,d,e,f,g,h,i);return}function qB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;Tg[a&3](b,c,d,e,f,g,h);return}function rB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;Dh[a&15](b,c,d,e,f,g);return}function sB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function tB(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;zi[a&3](b,c,d,e,f,g,h,i,j);return}function uB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;bj[a&3](b,c,d,e,f,g,h,i);return}function vB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Ki[a&7](b,c,d,e,f,g,h);return}function wB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function xB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function yB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;th[a&1](b,c,d,e,f,g,h);return}function zB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function AB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function BB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Cj[a&1](b,c,d,e,f,g,h);return}function CB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;aj[a&1](b,c,d,e,f,g);return}function DB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ri[a&15](b,c,d,e);return}function EB(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[a&31](b,c))}function FB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Zh[a&7](b,c,d,e,f,g);return}function GB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function HB(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b,c);return}function IB(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];gi[a&255](b,c,i,j,g);u=h;return}function JB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];ei[a&511](b,c,h,i);u=g;return}function KB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];Ti[a&511](b,c,g);u=e;return}function LB(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function MB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Ii[a&127](b,c,d,k,l,h,i);u=j;return}function NB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Fh[a&255](b,c,d,j,k,h);u=i;return}function OB(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];gi[a&255](b,c,d,i,j);u=h;return}function PB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];ei[a&511](b,c,d,h);u=g;return}function QB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+4|0;k=i;f[j>>2]=c;f[k>>2]=g;Dh[a&15](b,j,d,e,k,h);Ae(f[k>>2]|0);Ae(f[j>>2]|0);u=i;return}function RB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j+4|0;m=j;f[k>>2]=c;f[l>>2]=g;f[m>>2]=h;Ii[a&127](b,k,d,e,l,m,i);Ae(f[m>>2]|0);Ae(f[l>>2]|0);Ae(f[k>>2]|0);u=j;return}function SB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i+8|0;k=i+4|0;l=i;f[j>>2]=c;f[k>>2]=g;f[l>>2]=h;Fh[a&255](b,j,d,e,k,l);Ae(f[l>>2]|0);Ae(f[k>>2]|0);Ae(f[j>>2]|0);u=i;return}function TB(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;Xh[a&1](b,c,d,e,f,g,h,i,j,k);return}function UB(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;var n=0,o=0,p=0;n=u;u=u+32|0;o=n;p=n+16|0;f[p>>2]=f[i>>2];f[p+4>>2]=f[i+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];Dg[a&1](b,c,d,e,g,h,p,j,o,l,m);u=n;return}function VB(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+32|0;n=m;o=m+16|0;f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[n+8>>2]=f[k+8>>2];f[n+12>>2]=f[k+12>>2];Oh[a&7](b,c,d,e,g,h,o,j,n,l);u=m;return}function WB(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+32|0;m=l;n=l+16|0;f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];f[m+8>>2]=f[k+8>>2];f[m+12>>2]=f[k+12>>2];Li[a&127](b,c,d,e,g,h,n,j,m);u=l;return}function XB(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];wi[a&255](b,c,d,e,g,h,l,j);u=k;return}function YB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];Ii[a&127](b,c,d,e,g,h,k);u=j;return}function ZB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function _B(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function $B(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function aC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Ii[a&127](b,k,d,e,g,h,i);u=j;return}function bC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Fh[a&255](b,j,d,e,g,h);u=i;return}function cC(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];gi[a&255](b,i,d,e,g);u=h;return}function dC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];ei[a&511](b,h,d,e);u=g;return}function eC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function fC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Sh[a&31](b,c,d))}function gC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hh[a&127](b,c,d,e)|0}function hC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[a&511](b,c,d)|0}function iC(a,b,c){a=a|0;b=b|0;c=c|0;return Mi[a&1023](b,c)|0}function jC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xg[a&127](b,c,d,e,f,g)|0}function kC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _h[a&127](b,c,d,e,f)|0}function lC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hh[a&127](b,c,d,e)|0}function mC(a,b){a=a|0;b=b|0;return +(+Vg[a&31](b))}function nC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;Vi[a&31](b,c,d);return}function oC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function pC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function qC(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wi[a&255](b,c,d,e,f,g,h,i);return}function rC(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ii[a&127](b,c,d,e,f,g,h);return}function sC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ej[a&15](b,c,d,e,f,g);return}function tC(a,b){a=a|0;b=b|0;return _i[a&1023](b)|0}function uC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Ii[a&127](b,c,d,k,g,h,i);u=j;return}function vC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];Fh[a&255](b,c,d,j,g,h);u=i;return}function wC(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];gi[a&255](b,c,d,i,g);u=h;return}function xC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];ei[a&511](b,c,d,h);u=g;return}function yC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function zC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function AC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;Lh[a&7](b,c,d,e,f);return}function BC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[a&63](b,c,d,e);return}function CC(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;Pi[a&1](b,c,d,e);return}function DC(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;$g[a&1](b,c,d);return}function EC(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];Li[a&127](b,c,d,e,g,h,i,j,m);u=l;return}function FC(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wi[a&255](b,c,d,e,f,g,h,i);return}function GC(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ii[a&127](b,c,d,e,f,g,h);return}function HC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function IC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function JC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function KC(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=c;gi[a&255](b,i,d,e,g);Ae(f[i>>2]|0);u=h;return}function LC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=c;ei[a&511](b,h,d,e);Ae(f[h>>2]|0);u=g;return}function MC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=c;Ti[a&511](b,g,d);Ae(f[g>>2]|0);u=e;return}function NC(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0;m=u;u=u+16|0;n=m+12|0;o=m+8|0;p=m+4|0;q=m;f[n>>2]=c;f[o>>2]=e;f[p>>2]=g;f[q>>2]=k;Oh[a&7](b,n,d,o,p,h,i,j,q,l);Ae(f[q>>2]|0);Ae(f[p>>2]|0);Ae(f[o>>2]|0);Ae(f[n>>2]|0);u=m;return}function OC(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+16|0;m=l+12|0;n=l+8|0;o=l+4|0;p=l;f[m>>2]=c;f[n>>2]=e;f[o>>2]=g;f[p>>2]=k;Li[a&127](b,m,d,n,o,h,i,j,p);Ae(f[p>>2]|0);Ae(f[o>>2]|0);Ae(f[n>>2]|0);Ae(f[m>>2]|0);u=l;return}function PC(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k+4|0;n=k;f[l>>2]=c;f[m>>2]=e;f[n>>2]=g;wi[a&255](b,l,d,m,n,h,i,j);Ae(f[n>>2]|0);Ae(f[m>>2]|0);Ae(f[l>>2]|0);u=k;return}function QC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j+4|0;m=j;f[k>>2]=c;f[l>>2]=e;f[m>>2]=g;Ii[a&127](b,k,d,l,m,h,i);Ae(f[m>>2]|0);Ae(f[l>>2]|0);Ae(f[k>>2]|0);u=j;return}function RC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i+8|0;k=i+4|0;l=i;f[j>>2]=c;f[k>>2]=e;f[l>>2]=g;Fh[a&255](b,j,d,k,l,h);Ae(f[l>>2]|0);Ae(f[k>>2]|0);Ae(f[j>>2]|0);u=i;return}function SC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[a&511](b,c,d)|0}function TC(a,b,c){a=a|0;b=b|0;c=c|0;return Mi[a&1023](b,c)|0}function UC(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+16|0;n=m+8|0;o=m;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];xi[a&1](b,n,o,e,g,h,i,j,k,l);u=m;return}function VC(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l+8|0;n=l;f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];sh[a&1](b,m,n,e,g,h,i,j,k);u=l;return}function WC(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k+8|0;m=k;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];vi[a&1](b,l,m,e,g,h,i,j);u=k;return}function XC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];jh[a&1](b,k,l,e,g,h,i);u=j;return}function YC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function ZC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function _C(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function $C(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Ii[a&127](k,l,d,e,g,h,i);u=j;return}function aD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;ei[a&511](g,b,c,d);d=VDc(56)|0;f[d>>2]=f[g>>2];c=g+4|0;b=f[c>>2]|0;f[d+4>>2]=b;a=d+8|0;h=g+8|0;f[a>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];j=g+36|0;f[d+36>>2]=f[j>>2];k=d+40|0;f[k>>2]=a;a=d+44|0;l=d+48|0;f[a>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}g0(o);u=e;return d|0}function bD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+64|0;j=i;Lg[a&15](j,b,c,d,e,g,h);h=VDc(56)|0;f[h>>2]=f[j>>2];e=j+4|0;d=f[e>>2]|0;f[h+4>>2]=d;c=h+8|0;b=j+8|0;f[c>>2]=f[b>>2];f[h+12>>2]=f[j+12>>2];a=j+16|0;f[h+16>>2]=f[a>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];k=j+36|0;f[h+36>>2]=f[k>>2];l=h+40|0;f[l>>2]=c;c=h+44|0;m=h+48|0;f[c>>2]=m;n=h+52|0;f[n>>2]=0;f[m>>2]=0;o=j+44|0;if((d|0)<3){d=f[o>>2]|0;f[m>>2]=f[d>>2];f[n>>2]=f[d+4>>2];p=d}else{f[c>>2]=f[o>>2];c=j+40|0;f[l>>2]=f[c>>2];l=j+48|0;f[o>>2]=l;f[c>>2]=b;p=l}f[j>>2]=1124007936;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[k>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((p|0)==(j+48|0)){u=i;return h|0}g0(p);u=i;return h|0}function cD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Lg[a&15](b,c,d,e,k,h,i);u=j;return}function dD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];Dh[a&15](b,c,d,e,j,h);u=i;return}function eD(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];gi[a&255](b,c,d,e,i);u=h;return}function fD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function gD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];Fh[a&255](b,c,d,e,g,j);u=i;return}function hD(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function iD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];k=+Aj[a&3](b,c,d,e,j,h);u=i;return +k}function jD(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0;h=u;u=u+16|0;i=h;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];j=+pj[a&7](b,c,d,e,i);u=h;return +j}function kD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+Ai[a&15](b,c,d,e))}function lD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Sh[a&31](b,c,d))}function mD(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;mi[a&2047](d,b);b=VDc(20)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];f[b+16>>2]=f[d+16>>2];u=c;return b|0}function nD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;ij[a&1](b,c,d,e,f,g,h);return}function oD(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;Hj[a&1](b,c,d,e,f,g);return}function pD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;Ti[a&511](e,b,c);c=VDc(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}g0(o);u=d;return c|0}function qD(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+8|0;h=e;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];qi[a&7](g,h,c,d);h=VDc(56)|0;f[h>>2]=f[g>>2];a=g+4|0;b=f[a>>2]|0;f[h+4>>2]=b;i=h+8|0;j=g+8|0;f[i>>2]=f[j>>2];f[h+12>>2]=f[g+12>>2];k=g+16|0;f[h+16>>2]=f[k>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];l=g+36|0;f[h+36>>2]=f[l>>2];m=h+40|0;f[m>>2]=i;i=h+44|0;n=h+48|0;f[i>>2]=n;o=h+52|0;f[o>>2]=0;f[n>>2]=0;p=g+44|0;if((b|0)<3){b=f[p>>2]|0;f[n>>2]=f[b>>2];f[o>>2]=f[b+4>>2];q=b}else{f[i>>2]=f[p>>2];i=g+40|0;f[m>>2]=f[i>>2];m=g+48|0;f[p>>2]=m;f[i>>2]=j;q=m}f[g>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[l>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((q|0)==(g+48|0)){u=e;return h|0}g0(q);u=e;return h|0}function rD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+80|0;g=e+16|0;h=e+8|0;i=e;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];ei[a&511](g,b,h,i);i=VDc(56)|0;f[i>>2]=f[g>>2];h=g+4|0;b=f[h>>2]|0;f[i+4>>2]=b;a=i+8|0;d=g+8|0;f[a>>2]=f[d>>2];f[i+12>>2]=f[g+12>>2];c=g+16|0;f[i+16>>2]=f[c>>2];f[i+20>>2]=f[g+20>>2];f[i+24>>2]=f[g+24>>2];f[i+28>>2]=f[g+28>>2];f[i+32>>2]=f[g+32>>2];j=g+36|0;f[i+36>>2]=f[j>>2];k=i+40|0;f[k>>2]=a;a=i+44|0;l=i+48|0;f[a>>2]=l;m=i+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=d;o=k}f[g>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((o|0)==(g+48|0)){u=e;return i|0}g0(o);u=e;return i|0}function sD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d+8|0;g=d;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];Ti[a&511](e,b,g);g=VDc(56)|0;f[g>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[g+4>>2]=a;c=g+8|0;h=e+8|0;f[c>>2]=f[h>>2];f[g+12>>2]=f[e+12>>2];i=e+16|0;f[g+16>>2]=f[i>>2];f[g+20>>2]=f[e+20>>2];f[g+24>>2]=f[e+24>>2];f[g+28>>2]=f[e+28>>2];f[g+32>>2]=f[e+32>>2];j=e+36|0;f[g+36>>2]=f[j>>2];k=g+40|0;f[k>>2]=c;c=g+44|0;l=g+48|0;f[c>>2]=l;m=g+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[c>>2]=f[n>>2];c=e+40|0;f[k>>2]=f[c>>2];k=e+48|0;f[n>>2]=k;f[c>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return g|0}g0(o);u=d;return g|0}function tD(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;eh[a&1](b,c,d,e,f,g,h,i,j);return}function uD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;fj[a&3](b,c,d,e,f,g,h,i);return}function vD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Rg[a&3](b,c,d,e,f,g,h);return}function wD(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Zh[a&7](b,c,d,e,f,g);return}function xD(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;Yh[a&1](b,c,d,e,f,g,h,i,j,k);return}function yD(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;dh[a&1](b,c,d,e,f,g,h,i,j);return}function zD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;fj[a&3](b,c,d,e,f,g,h,i);return}function AD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[k+8>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];Ii[a&127](b,c,k,e,g,h,i);u=j;return}function BD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];Fh[a&255](b,c,j,e,g,h);u=i;return}function CD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[a&63](b,c,d,e);return}function DD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function ED(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b,c);return}function FD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function GD(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];wi[a&255](b,c,d,e,l,h,i,j);u=k;return}function HD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function ID(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function JD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Sh[a&31](b,c,d))}function KD(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[a&31](b,c))}function LD(a,b){a=a|0;b=b|0;return _i[a&1023](b)|0}function MD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[k+8>>2]=f[e+8>>2];f[k+12>>2]=f[e+12>>2];l=+ah[a&3](b,c,d,k,g,h,i);u=j;return +l}function ND(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];k=+Aj[a&3](b,c,d,j,g,h);u=i;return +k}function OD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];Ii[a&127](b,k,l,e,g,h,i);u=j;return}function PD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];Fh[a&255](b,j,k,e,g,h);u=i;return}function QD(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];gi[a&255](b,i,j,e,g);u=h;return}function RD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];ei[a&511](b,h,i,e);u=g;return}function SD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +(+ui[a&1](b,c,d,e))}function TD(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function UD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;Ti[a&511](e,b,c);c=VDc(32)|0;p[c>>3]=+p[e>>3];p[c+8>>3]=+p[e+8>>3];p[c+16>>3]=+p[e+16>>3];p[c+24>>3]=+p[e+24>>3];u=d;return c|0}function VD(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;mi[a&2047](d,b);b=VDc(32)|0;p[b>>3]=+p[d>>3];p[b+8>>3]=+p[d+8>>3];p[b+16>>3]=+p[d+16>>3];p[b+24>>3]=+p[d+24>>3];u=c;return b|0}function WD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function XD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;Ti[a&511](b,c,g);Ae(f[g>>2]|0);u=e;return}function YD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+192|0;e=d;Ti[a&511](e,b,c);c=VDc(192)|0;dJc(c|0,e|0,192)|0;u=d;return c|0}function ZD(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+192|0;d=c;mi[a&2047](d,b);b=VDc(192)|0;dJc(b|0,d|0,192)|0;u=c;return b|0}function _D(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];wi[a&255](b,c,d,e,l,h,i,j);u=k;return}function $D(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Ii[a&127](b,c,d,e,k,h,i);u=j;return}function aE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];Fh[a&255](b,c,d,e,j,h);u=i;return}function bE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Sh[a&31](b,c,d))}function cE(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[a&31](b,c))}function dE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+Ai[a&15](b,c,d,e))}function eE(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[a&31](b,c))}function fE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;ph[a&1](b,c,d,e,f,g,h);return}function gE(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;Ig[a&3](b,c,d,e,f,g);return}function hE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0;e=u;u=u+16|0;g=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];h=+Sh[a&31](b,g,d);u=e;return +h}function iE(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;Hg[a&7](b,c,d);return}function jE(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;m=u;u=u+64|0;n=m+40|0;o=m+32|0;q=m;r=d+4|0;s=f[d>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;if(s>>>0>4294967279)dEc(n);if(s>>>0<11){b[n+11>>0]=s;if(!s)t=n;else{v=n;w=6}}else{d=s+16&-16;x=VDc(d)|0;f[n>>2]=x;f[n+8>>2]=d|-2147483648;f[n+4>>2]=s;v=x;w=6}if((w|0)==6){dJc(v|0,r|0,s|0)|0;t=v}b[t+s>>0]=0;f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];p[q>>3]=+p[i>>3];p[q+8>>3]=+p[i+8>>3];p[q+16>>3]=+p[i+16>>3];p[q+24>>3]=+p[i+24>>3];uh[a&7](c,n,o,g,h,q,j,k,l);if((b[n+11>>0]|0)>=0){u=m;return}YDc(f[n>>2]|0);u=m;return}function kE(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;l=u;u=u+64|0;m=l+40|0;n=l+32|0;o=l;q=d+4|0;r=f[d>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if(r>>>0>4294967279)dEc(m);if(r>>>0<11){b[m+11>>0]=r;if(!r)s=m;else{t=m;v=6}}else{d=r+16&-16;w=VDc(d)|0;f[m>>2]=w;f[m+8>>2]=d|-2147483648;f[m+4>>2]=r;t=w;v=6}if((v|0)==6){dJc(t|0,q|0,r|0)|0;s=t}b[s+r>>0]=0;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];p[o>>3]=+p[i>>3];p[o+8>>3]=+p[i+8>>3];p[o+16>>3]=+p[i+16>>3];p[o+24>>3]=+p[i+24>>3];tg[a&7](c,m,n,g,h,o,j,k);if((b[m+11>>0]|0)>=0){u=l;return}YDc(f[m>>2]|0);u=l;return}function lE(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0;k=u;u=u+64|0;l=k+40|0;m=k+32|0;n=k;o=d+4|0;q=f[d>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if(q>>>0>4294967279)dEc(l);if(q>>>0<11){b[l+11>>0]=q;if(!q)r=l;else{s=l;t=6}}else{d=q+16&-16;v=VDc(d)|0;f[l>>2]=v;f[l+8>>2]=d|-2147483648;f[l+4>>2]=q;s=v;t=6}if((t|0)==6){dJc(s|0,o|0,q|0)|0;r=s}b[r+q>>0]=0;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];p[n>>3]=+p[i>>3];p[n+8>>3]=+p[i+8>>3];p[n+16>>3]=+p[i+16>>3];p[n+24>>3]=+p[i+24>>3];oj[a&7](c,l,m,g,h,n,j);if((b[l+11>>0]|0)>=0){u=k;return}YDc(f[l>>2]|0);u=k;return}function mE(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=u;u=u+64|0;k=j+40|0;l=j+32|0;m=j;n=d+4|0;o=f[d>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(o>>>0>4294967279)dEc(k);if(o>>>0<11){b[k+11>>0]=o;if(!o)q=k;else{r=k;s=6}}else{d=o+16&-16;t=VDc(d)|0;f[k>>2]=t;f[k+8>>2]=d|-2147483648;f[k+4>>2]=o;r=t;s=6}if((s|0)==6){dJc(r|0,n|0,o|0)|0;q=r}b[q+o>>0]=0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];p[m>>3]=+p[i>>3];p[m+8>>3]=+p[i+8>>3];p[m+16>>3]=+p[i+16>>3];p[m+24>>3]=+p[i+24>>3];ej[a&15](c,k,l,g,h,m);if((b[k+11>>0]|0)>=0){u=j;return}YDc(f[k>>2]|0);u=j;return}function nE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function oE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function pE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function qE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ii[a&127](b,c,d,e,f,g,h);return}function rE(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function sE(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function tE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function uE(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];Hh[a&3](b,c,d,e,g,l,i,j);u=k;return}function vE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];Ki[a&7](b,c,d,e,g,k,i);u=j;return}function wE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];Fh[a&255](b,c,d,e,g,j);u=i;return}function xE(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function yE(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b,c);return}function zE(a,b){a=a|0;b=b|0;Yi[a&2047](b);return}function AE(a,b){a=a|0;b=b|0;Yi[a&2047](b);return}function BE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hh[a&127](b,c,d,e)|0}function CE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[a&511](b,c,d)|0}function DE(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b,c);return}function EE(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +(+Qh[a&1](b,c,d,e,f))}function FE(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function GE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function HE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Ii[a&127](b,c,d,k,g,h,i);u=j;return}function IE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];Fh[a&255](b,c,d,j,g,h);u=i;return}function JE(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];gi[a&255](b,c,d,i,g);u=h;return}function KE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];ei[a&511](b,c,d,h);u=g;return}function LE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=u;u=u+64|0;k=j;Uh[a&3](k,b,c,d,e,g,h,i);i=VDc(56)|0;f[i>>2]=f[k>>2];h=k+4|0;g=f[h>>2]|0;f[i+4>>2]=g;e=i+8|0;d=k+8|0;f[e>>2]=f[d>>2];f[i+12>>2]=f[k+12>>2];b=k+16|0;f[i+16>>2]=f[b>>2];f[i+20>>2]=f[k+20>>2];f[i+24>>2]=f[k+24>>2];f[i+28>>2]=f[k+28>>2];f[i+32>>2]=f[k+32>>2];a=k+36|0;f[i+36>>2]=f[a>>2];l=i+40|0;f[l>>2]=e;e=i+44|0;m=i+48|0;f[e>>2]=m;n=i+52|0;f[n>>2]=0;f[m>>2]=0;o=k+44|0;if((g|0)<3){g=f[o>>2]|0;f[m>>2]=f[g>>2];f[n>>2]=f[g+4>>2];p=g}else{f[e>>2]=f[o>>2];e=k+40|0;f[l>>2]=f[e>>2];l=k+48|0;f[o>>2]=l;f[e>>2]=d;p=l}f[k>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[a>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((p|0)==(k+48|0)){u=j;return i|0}g0(p);u=j;return i|0}function ME(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+64|0;j=i;vh[a&3](j,b,c,d,e,g,h);h=VDc(56)|0;f[h>>2]=f[j>>2];g=j+4|0;e=f[g>>2]|0;f[h+4>>2]=e;d=h+8|0;b=j+8|0;f[d>>2]=f[b>>2];f[h+12>>2]=f[j+12>>2];a=j+16|0;f[h+16>>2]=f[a>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];k=j+36|0;f[h+36>>2]=f[k>>2];l=h+40|0;f[l>>2]=d;d=h+44|0;m=h+48|0;f[d>>2]=m;n=h+52|0;f[n>>2]=0;f[m>>2]=0;o=j+44|0;if((e|0)<3){e=f[o>>2]|0;f[m>>2]=f[e>>2];f[n>>2]=f[e+4>>2];p=e}else{f[d>>2]=f[o>>2];d=j+40|0;f[l>>2]=f[d>>2];l=j+48|0;f[o>>2]=l;f[d>>2]=b;p=l}f[j>>2]=1124007936;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[k>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((p|0)==(j+48|0)){u=i;return h|0}g0(p);u=i;return h|0}function NE(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+64|0;i=h;Bg[a&3](i,b,c,d,e,g);g=VDc(56)|0;f[g>>2]=f[i>>2];e=i+4|0;d=f[e>>2]|0;f[g+4>>2]=d;b=g+8|0;a=i+8|0;f[b>>2]=f[a>>2];f[g+12>>2]=f[i+12>>2];j=i+16|0;f[g+16>>2]=f[j>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];k=i+36|0;f[g+36>>2]=f[k>>2];l=g+40|0;f[l>>2]=b;b=g+44|0;m=g+48|0;f[b>>2]=m;n=g+52|0;f[n>>2]=0;f[m>>2]=0;o=i+44|0;if((d|0)<3){d=f[o>>2]|0;f[m>>2]=f[d>>2];f[n>>2]=f[d+4>>2];p=d}else{f[b>>2]=f[o>>2];b=i+40|0;f[l>>2]=f[b>>2];l=i+48|0;f[o>>2]=l;f[b>>2]=a;p=l}f[i>>2]=1124007936;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(i+48|0)){u=h;return g|0}g0(p);u=h;return g|0}function OE(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+64|0;h=g;bi[a&3](h,b,c,d,e);e=VDc(56)|0;f[e>>2]=f[h>>2];d=h+4|0;b=f[d>>2]|0;f[e+4>>2]=b;a=e+8|0;i=h+8|0;f[a>>2]=f[i>>2];f[e+12>>2]=f[h+12>>2];j=h+16|0;f[e+16>>2]=f[j>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];k=h+36|0;f[e+36>>2]=f[k>>2];l=e+40|0;f[l>>2]=a;a=e+44|0;m=e+48|0;f[a>>2]=m;n=e+52|0;f[n>>2]=0;f[m>>2]=0;o=h+44|0;if((b|0)<3){b=f[o>>2]|0;f[m>>2]=f[b>>2];f[n>>2]=f[b+4>>2];p=b}else{f[a>>2]=f[o>>2];a=h+40|0;f[l>>2]=f[a>>2];l=h+48|0;f[o>>2]=l;f[a>>2]=i;p=l}f[h>>2]=1124007936;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(h+48|0)){u=g;return e|0}g0(p);u=g;return e|0}function PE(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e;ri[a&15](g,b,c,d);d=VDc(56)|0;f[d>>2]=f[g>>2];b=g+4|0;a=f[b>>2]|0;f[d+4>>2]=a;h=d+8|0;i=g+8|0;f[h>>2]=f[i>>2];f[d+12>>2]=f[g+12>>2];j=g+16|0;f[d+16>>2]=f[j>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];k=g+36|0;f[d+36>>2]=f[k>>2];l=d+40|0;f[l>>2]=h;h=d+44|0;m=d+48|0;f[h>>2]=m;n=d+52|0;f[n>>2]=0;f[m>>2]=0;o=g+44|0;if((a|0)<3){a=f[o>>2]|0;f[m>>2]=f[a>>2];f[n>>2]=f[a+4>>2];p=a}else{f[h>>2]=f[o>>2];h=g+40|0;f[l>>2]=f[h>>2];l=g+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[g>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(g+48|0)){u=e;return d|0}g0(p);u=e;return d|0}function QE(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d;Vi[a&31](e,b,c);b=VDc(56)|0;f[b>>2]=f[e>>2];a=e+4|0;g=f[a>>2]|0;f[b+4>>2]=g;h=b+8|0;i=e+8|0;f[h>>2]=f[i>>2];f[b+12>>2]=f[e+12>>2];j=e+16|0;f[b+16>>2]=f[j>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];f[b+28>>2]=f[e+28>>2];f[b+32>>2]=f[e+32>>2];k=e+36|0;f[b+36>>2]=f[k>>2];l=b+40|0;f[l>>2]=h;h=b+44|0;m=b+48|0;f[h>>2]=m;n=b+52|0;f[n>>2]=0;f[m>>2]=0;o=e+44|0;if((g|0)<3){g=f[o>>2]|0;f[m>>2]=f[g>>2];f[n>>2]=f[g+4>>2];p=g}else{f[h>>2]=f[o>>2];h=e+40|0;f[l>>2]=f[h>>2];l=e+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(e+48|0)){u=d;return b|0}g0(p);u=d;return b|0}function RE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;mi[a&2047](d,b);b=VDc(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}g0(o);u=c;return b|0}function SE(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+48|0;h=g+40|0;i=g+24|0;j=g+12|0;k=g;l=c+4|0;m=f[c>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(m>>>0>4294967279)dEc(i);if(m>>>0<11){b[i+11>>0]=m;if(!m)n=i;else{o=i;p=6}}else{c=m+16&-16;q=VDc(c)|0;f[i>>2]=q;f[i+8>>2]=c|-2147483648;f[i+4>>2]=m;o=q;p=6}if((p|0)==6){dJc(o|0,l|0,m|0)|0;n=o}b[n+m>>0]=0;m=d+4|0;n=f[d>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)dEc(j);if(n>>>0<11){b[j+11>>0]=n;if(!n)r=j;else{s=j;p=12}}else{d=n+16&-16;o=VDc(d)|0;f[j>>2]=o;f[j+8>>2]=d|-2147483648;f[j+4>>2]=n;s=o;p=12}if((p|0)==12){dJc(s|0,m|0,n|0)|0;r=s}b[r+n>>0]=0;n=e+4|0;r=f[e>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(r>>>0>4294967279)dEc(k);if(r>>>0<11){b[k+11>>0]=r;if(!r)t=k;else{v=k;p=18}}else{e=r+16&-16;s=VDc(e)|0;f[k>>2]=s;f[k+8>>2]=e|-2147483648;f[k+4>>2]=r;v=s;p=18}if((p|0)==18){dJc(v|0,n|0,r|0)|0;t=v}b[t+r>>0]=0;ei[a&511](h,i,j,k);a=VDc(8)|0;r=f[h>>2]|0;f[a>>2]=r;f[a+4>>2]=f[h+4>>2];if(r|0){t=r+4|0;f[t>>2]=(f[t>>2]|0)+1}fGa(h);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[i+11>>0]|0)>=0){u=g;return a|0}YDc(f[i>>2]|0);u=g;return a|0}function TE(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+32|0;g=e+24|0;h=e+12|0;i=e;j=c+4|0;k=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)dEc(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{c=k+16&-16;o=VDc(c)|0;f[h>>2]=o;f[h+8>>2]=c|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){dJc(m|0,j|0,k|0)|0;l=m}b[l+k>>0]=0;k=d+4|0;l=f[d>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(l>>>0>4294967279)dEc(i);if(l>>>0<11){b[i+11>>0]=l;if(!l)p=i;else{q=i;n=12}}else{d=l+16&-16;m=VDc(d)|0;f[i>>2]=m;f[i+8>>2]=d|-2147483648;f[i+4>>2]=l;q=m;n=12}if((n|0)==12){dJc(q|0,k|0,l|0)|0;p=q}b[p+l>>0]=0;Ti[a&511](g,h,i);a=VDc(8)|0;l=f[g>>2]|0;f[a>>2]=l;f[a+4>>2]=f[g+4>>2];if(l|0){p=l+4|0;f[p>>2]=(f[p>>2]|0)+1}fGa(g);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=e;return a|0}YDc(f[h>>2]|0);u=e;return a|0}function UE(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d+16|0;g=d;h=c+4|0;i=f[c>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)dEc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{c=i+16&-16;m=VDc(c)|0;f[g>>2]=m;f[g+8>>2]=c|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){dJc(k|0,h|0,i|0)|0;j=k}b[j+i>>0]=0;mi[a&2047](e,g);a=VDc(8)|0;i=f[e>>2]|0;f[a>>2]=i;f[a+4>>2]=f[e+4>>2];if(i|0){j=i+4|0;f[j>>2]=(f[j>>2]|0)+1}fGa(e);if((b[g+11>>0]|0)>=0){u=d;return a|0}YDc(f[g>>2]|0);u=d;return a|0}function VE(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+32|0;h=g+24|0;i=g+8|0;j=g+4|0;k=g;l=c+4|0;m=f[c>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(m>>>0>4294967279)dEc(i);if(m>>>0<11){b[i+11>>0]=m;if(!m)n=i;else{o=i;p=6}}else{c=m+16&-16;q=VDc(c)|0;f[i>>2]=q;f[i+8>>2]=c|-2147483648;f[i+4>>2]=m;o=q;p=6}if((p|0)==6){dJc(o|0,l|0,m|0)|0;n=o}b[n+m>>0]=0;f[j>>2]=d;f[k>>2]=e;ei[a&511](h,i,j,k);a=VDc(8)|0;e=f[h>>2]|0;f[a>>2]=e;f[a+4>>2]=f[h+4>>2];if(e|0){d=e+4|0;f[d>>2]=(f[d>>2]|0)+1}fGa(h);Ae(f[k>>2]|0);Ae(f[j>>2]|0);if((b[i+11>>0]|0)>=0){u=g;return a|0}YDc(f[i>>2]|0);u=g;return a|0}function WE(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e+16|0;h=e+4|0;i=e;j=c+4|0;k=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)dEc(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{c=k+16&-16;o=VDc(c)|0;f[h>>2]=o;f[h+8>>2]=c|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){dJc(m|0,j|0,k|0)|0;l=m}b[l+k>>0]=0;f[i>>2]=d;Ti[a&511](g,h,i);a=VDc(8)|0;d=f[g>>2]|0;f[a>>2]=d;f[a+4>>2]=f[g+4>>2];if(d|0){k=d+4|0;f[k>>2]=(f[k>>2]|0)+1}fGa(g);Ae(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=e;return a|0}YDc(f[h>>2]|0);u=e;return a|0}function XE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d+8|0;g=d+4|0;h=d;f[g>>2]=b;f[h>>2]=c;Ti[a&511](e,g,h);a=VDc(8)|0;c=f[e>>2]|0;f[a>>2]=c;f[a+4>>2]=f[e+4>>2];if(c|0){b=c+4|0;f[b>>2]=(f[b>>2]|0)+1}fGa(e);Ae(f[h>>2]|0);Ae(f[g>>2]|0);u=d;return a|0}function YE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c+8|0;e=c;f[e>>2]=b;mi[a&2047](d,e);a=VDc(8)|0;b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];if(b|0){g=b+4|0;f[g>>2]=(f[g>>2]|0)+1}fGa(d);Ae(f[e>>2]|0);u=c;return a|0}function ZE(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;i=c+4|0;j=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)dEc(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{c=j+16&-16;n=VDc(c)|0;f[h>>2]=n;f[h+8>>2]=c|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){dJc(l|0,i|0,j|0)|0;k=l}b[k+j>>0]=0;Ti[a&511](g,h,d);d=VDc(8)|0;a=f[g>>2]|0;f[d>>2]=a;f[d+4>>2]=f[g+4>>2];if(a|0){j=a+4|0;f[j>>2]=(f[j>>2]|0)+1}fGa(g);if((b[h+11>>0]|0)>=0){u=e;return d|0}YDc(f[h>>2]|0);u=e;return d|0}function _E(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function $E(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function aF(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+32|0;h=g+12|0;i=g;j=f[a>>2]|0;a=d+4|0;k=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)dEc(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{d=k+16&-16;o=VDc(d)|0;f[h>>2]=o;f[h+8>>2]=d|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){dJc(m|0,a|0,k|0)|0;l=m}b[l+k>>0]=0;k=e+4|0;l=f[e>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(l>>>0>4294967279)dEc(i);if(l>>>0<11){b[i+11>>0]=l;if(!l)p=i;else{q=i;n=12}}else{e=l+16&-16;m=VDc(e)|0;f[i>>2]=m;f[i+8>>2]=e|-2147483648;f[i+4>>2]=l;q=m;n=12}if((n|0)==12){dJc(q|0,k|0,l|0)|0;p=q}b[p+l>>0]=0;l=hj[j&511](c,h,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=g;return l|0}YDc(f[h>>2]|0);u=g;return l|0}function bF(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)dEc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=VDc(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){dJc(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;i=Mi[h&1023](c,g)|0;if((b[g+11>>0]|0)>=0){u=e;return i|0}YDc(f[g>>2]|0);u=e;return i|0}function cF(){var a=0,c=0;a=VDc(152)|0;f[a>>2]=137704;f[a+4>>2]=64;f[a+8>>2]=128;f[a+12>>2]=16;f[a+16>>2]=16;f[a+20>>2]=8;f[a+24>>2]=8;f[a+28>>2]=8;f[a+32>>2]=8;f[a+36>>2]=9;f[a+40>>2]=1;p[a+48>>3]=-1.0;f[a+56>>2]=0;p[a+64>>3]=.2;b[a+72>>0]=1;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+88>>2]=1124007936;c=a+92|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[a+120>>2]=a+96;c=a+128|0;f[a+124>>2]=c;f[a+132>>2]=0;f[c>>2]=0;n[a+136>>2]=-1.0;f[a+140>>2]=64;b[a+144>>0]=0;return a|0}function dF(a){a=a|0;return yj[a&63]()|0}function eF(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0;q=VDc(152)|0;r=f[a>>2]|0;s=f[a+4>>2]|0;a=f[c>>2]|0;t=f[c+4>>2]|0;c=f[d>>2]|0;u=f[d+4>>2]|0;d=f[e>>2]|0;v=f[e+4>>2]|0;e=f[g>>2]|0;g=f[h>>2]|0;w=+p[i>>3];i=f[j>>2]|0;x=+p[k>>3];k=b[l>>0]|0;l=f[m>>2]|0;m=b[o>>0]|0;f[q>>2]=137704;f[q+4>>2]=r;f[q+8>>2]=s;f[q+12>>2]=a;f[q+16>>2]=t;f[q+20>>2]=c;f[q+24>>2]=u;f[q+28>>2]=d;f[q+32>>2]=v;f[q+36>>2]=e;f[q+40>>2]=g;p[q+48>>3]=w;f[q+56>>2]=i;p[q+64>>3]=x;b[q+72>>0]=k;f[q+76>>2]=0;f[q+80>>2]=0;f[q+84>>2]=0;f[q+88>>2]=1124007936;k=q+92|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[q+120>>2]=q+96;k=q+128|0;f[q+124>>2]=k;f[q+132>>2]=0;f[k>>2]=0;n[q+136>>2]=-1.0;f[q+140>>2]=l;b[q+144>>0]=m;return q|0}function fF(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;l=+l;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;q=u;u=u+80|0;r=q+56|0;s=q+48|0;t=q+40|0;v=q+32|0;w=q+28|0;x=q+24|0;y=q+8|0;z=q+20|0;A=q;B=q+65|0;C=q+16|0;D=q+64|0;f[r>>2]=f[c>>2];f[r+4>>2]=f[c+4>>2];f[s>>2]=f[d>>2];f[s+4>>2]=f[d+4>>2];f[t>>2]=f[e>>2];f[t+4>>2]=f[e+4>>2];f[v>>2]=f[g>>2];f[v+4>>2]=f[g+4>>2];f[w>>2]=h;f[x>>2]=i;p[y>>3]=j;f[z>>2]=k;p[A>>3]=l;b[B>>0]=m&1;f[C>>2]=n;b[D>>0]=o&1;o=rj[a&1](r,s,t,v,w,x,y,z,A,B,C,D)|0;u=q;return o|0}function gF(a){a=a|0;var b=0;b=VDc(152)|0;iF(b,a);return b|0}function hF(a,b){a=a|0;b=b|0;return _i[a&1023](b)|0}function iF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=137704;e=a+4|0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[a+88>>2]=1124007936;e=a+92|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[a+120>>2]=a+96;e=a+128|0;f[a+124>>2]=e;f[a+132>>2]=0;f[e>>2]=0;e=f[34431]|0;f[d>>2]=0;f[d+4>>2]=0;hj[e&511](a,b,d)|0;uT(d);u=c;return}function jF(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(12)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];u=b;return a|0}function kF(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function lF(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+16|0;n=m+8|0;o=m;p=f[a>>2]|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];Yg[p&3](b,c,d,e,g,n,o,j,k,l);u=m;return}function mF(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,n=0,o=0;l=u;u=u+16|0;m=l+8|0;n=l;o=f[a>>2]|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];fh[o&1](b,c,d,e,g,m,n,j,k);u=l;return}function nF(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k;n=f[a>>2]|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];wg[n&1](b,c,d,e,g,l,m,j);u=k;return}function oF(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j;m=f[a>>2]|0;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];oj[m&7](b,c,d,e,g,k,l);u=j;return}function pF(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];ej[k&15](b,c,d,e,g,j);u=i;return}function qF(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;ni[f[a>>2]&31](b,c,d,e,g);return}function rF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function sF(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function tF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function uF(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function vF(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function wF(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function xF(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function yF(a,c){a=a|0;c=c|0;return (b[c+(f[a>>2]|0)>>0]|0)!=0|0}function zF(a,c,d){a=a|0;c=c|0;d=d|0;b[c+(f[a>>2]|0)>>0]=d&1;return}function AF(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=VDc(12)|0;CF(a,c);return a|0}function BF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;if((d|0)==(c|0))return;DF(d,f[c>>2]|0,f[c+4>>2]|0);return}function CF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;dJc(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function DF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)fJc(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);YDc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)mCc(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)mCc(a);j=VDc(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;dJc(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function EF(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function FF(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function GF(a){a=a|0;return a|0}function HF(a){a=a|0;return a|0}function IF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function JF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function KF(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function LF(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function MF(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function NF(a){a=a|0;return a|0}function OF(a){a=a|0;return a|0}function PF(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ri[a&15](g,b,c,d);d=VDc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function QF(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;Vi[a&31](e,b,c);b=VDc(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function RF(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function SF(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function TF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function UF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function VF(a){a=a|0;return f[a+4>>2]|0}function WF(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function XF(a){a=a|0;return 0}function YF(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function ZF(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function _F(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $F(a){a=a|0;return a|0}function aG(a){a=a|0;return a|0}function bG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];mi[g&2047](b,e);u=d;return}function cG(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=d+8|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];Hg[a&7](e,b,g);g=VDc(8)|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];u=d;return g|0}function dG(a,b){a=a|0;b=+b;var c=0,d=0;c=u;u=u+16|0;d=c;ji[a&31](d,b);a=VDc(8)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return a|0}function eG(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function fG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;Yi[e&2047](a);return}else{e=f[(f[a>>2]|0)+c>>2]|0;Yi[e&2047](a);return}}function gG(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function hG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;mi[h&2047](d,a);a=VDc(8)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return a|0}function iG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+Vg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+Vg[e&31](a);return +g}return +(0.0)}function jG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function kG(a){a=a|0;return f[a+4>>2]|0}function lG(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function mG(a){a=a|0;return 0}function nG(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function oG(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function pG(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function qG(a){a=a|0;return a|0}function rG(a){a=a|0;return a|0}function sG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=VDc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function tG(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function uG(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function vG(a){a=a|0;return f[a+4>>2]|0}function wG(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function xG(a){a=a|0;return 0}function yG(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function zG(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function AG(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function BG(a){a=a|0;return a|0}function CG(a){a=a|0;return a|0}function DG(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function EG(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function FG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function GG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function HG(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;vg[a&3](j,b,c,d,e,g,h);h=VDc(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function IG(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;tj[a&7](i,b,c,d,e,g);g=VDc(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function JG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;Lh[a&7](h,b,c,d,e);e=VDc(8)|0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];u=g;return e|0}function KG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;$h[a&63](g,b,c,d);c=VDc(8)|0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];u=e;return c|0}function LG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=VDc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function MG(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function NG(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function OG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+Vg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+Vg[e&31](a);return +g}return +(0.0)}function PG(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function QG(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function RG(a){a=a|0;return f[a+4>>2]|0}function SG(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function TG(a){a=a|0;return 0}function UG(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function VG(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function WG(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function XG(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function YG(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ZG(a){a=a|0;return a|0}function _G(a){a=a|0;return a|0}function $G(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function aH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function bH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function cH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function dH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function eH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function fH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function gH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function hH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;Fh[f[a>>2]&255](b,c,d,e,g,h);return}function iH(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function jH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function kH(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function lH(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function mH(a){a=a|0;return a|0}function nH(a){a=a|0;return a|0}function oH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function pH(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function qH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+Vg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+Vg[e&31](a);return +g}return +(0.0)}function rH(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function sH(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function tH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;h=+h;var i=0,j=0;i=u;u=u+16|0;j=i;qh[a&1](j,b,c,d,e,g,h);g=VDc(8)|0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];u=i;return g|0}function uH(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Ig[a&3](i,b,c,d,e,g);g=VDc(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function vH(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;Ni[a&7](h,b,c,d,e);e=VDc(8)|0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];u=g;return e|0}function wH(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;qi[a&7](g,b,c,d);b=VDc(8)|0;f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];u=e;return b|0}function xH(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;Vi[a&31](e,b,c);b=VDc(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function yH(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function zH(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function AH(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;i=+i;var j=0,k=0;j=u;u=u+16|0;k=j;fi[a&1](k,b,c,d,e,g,h,i);h=VDc(8)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];u=j;return h|0}function BH(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function CH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function DH(a){a=a|0;return f[a+4>>2]|0}function EH(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function FH(a){a=a|0;return 0}function GH(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function HH(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function IH(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function JH(a){a=a|0;return a|0}function KH(a){a=a|0;return a|0}function LH(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;oj[f[a>>2]&7](b,c,d,e,g,h,i);return}function MH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;ej[f[a>>2]&15](b,c,d,e,g,h);return}function NH(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;ni[f[a>>2]&31](b,c,d,e,g);return}function OH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;tj[f[a>>2]&7](b,c,d,e,g,h);return}function PH(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;Lh[f[a>>2]&7](b,c,d,e,g);return}function QH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function RH(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d;g=d+8|0;h=c+4|0;i=f[c>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)dEc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{c=i+16&-16;m=VDc(c)|0;f[g>>2]=m;f[g+8>>2]=c|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){dJc(k|0,h|0,i|0)|0;j=k}b[j+i>>0]=0;mi[a&2047](e,g);a=VDc(8)|0;f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];i=e;f[i>>2]=0;f[i+4>>2]=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}YDc(f[g>>2]|0);u=d;return a|0}function SH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;Yi[e&2047](a);return}else{e=f[(f[a>>2]|0)+c>>2]|0;Yi[e&2047](a);return}}function TH(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;Ii[f[a>>2]&127](b,c,d,e,g,h,i);return}function UH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;Fh[f[a>>2]&255](b,c,d,e,g,h);return}function VH(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function WH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;Fh[f[a>>2]&255](b,c,d,e,g,h);return}function XH(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function YH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function ZH(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function _H(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function $H(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function aI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function bI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function cI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function dI(a){a=a|0;return f[a+4>>2]|0}function eI(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function fI(a){a=a|0;return 0}function gI(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function hI(a){a=a|0;return 5024}function iI(a){a=a|0;if(!a)return;fGa(a);YDc(a);return}function jI(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;a=e+4|0;l=f[e>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(l>>>0>4294967279)dEc(j);if(l>>>0<11){b[j+11>>0]=l;if(!l)m=j;else{n=j;o=6}}else{e=l+16&-16;p=VDc(e)|0;f[j>>2]=p;f[j+8>>2]=e|-2147483648;f[j+4>>2]=l;n=p;o=6}if((o|0)==6){dJc(n|0,a|0,l|0)|0;m=n}b[m+l>>0]=0;Lh[k&7](c,d,j,g,h);if((b[j+11>>0]|0)>=0){u=i;return}YDc(f[j>>2]|0);u=i;return}function kI(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;j=f[a>>2]|0;a=e+4|0;k=f[e>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(k>>>0>4294967279)dEc(i);if(k>>>0<11){b[i+11>>0]=k;if(!k)l=i;else{m=i;n=6}}else{e=k+16&-16;o=VDc(e)|0;f[i>>2]=o;f[i+8>>2]=e|-2147483648;f[i+4>>2]=k;m=o;n=6}if((n|0)==6){dJc(m|0,a|0,k|0)|0;l=m}b[l+k>>0]=0;$h[j&63](c,d,i,g);if((b[i+11>>0]|0)>=0){u=h;return}YDc(f[i>>2]|0);u=h;return}function lI(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;a=e+4|0;j=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)dEc(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{e=j+16&-16;n=VDc(e)|0;f[h>>2]=n;f[h+8>>2]=e|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){dJc(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;Ti[i&511](c,d,h);if((b[h+11>>0]|0)>=0){u=g;return}YDc(f[h>>2]|0);u=g;return}function mI(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function nI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+80|0;g=e+16|0;h=e;i=f[a>>2]|0;a=d+4|0;j=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)dEc(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{d=j+16&-16;n=VDc(d)|0;f[h>>2]=n;f[h+8>>2]=d|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){dJc(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;Ti[i&511](g,c,h);c=VDc(56)|0;f[c>>2]=f[g>>2];i=g+4|0;j=f[i>>2]|0;f[c+4>>2]=j;k=c+8|0;l=g+8|0;f[k>>2]=f[l>>2];f[c+12>>2]=f[g+12>>2];a=g+16|0;f[c+16>>2]=f[a>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];m=g+36|0;f[c+36>>2]=f[m>>2];n=c+40|0;f[n>>2]=k;k=c+44|0;d=c+48|0;f[k>>2]=d;o=c+52|0;f[o>>2]=0;f[d>>2]=0;p=g+44|0;if((j|0)<3){j=f[p>>2]|0;f[d>>2]=f[j>>2];f[o>>2]=f[j+4>>2];q=j}else{f[k>>2]=f[p>>2];k=g+40|0;f[n>>2]=f[k>>2];n=g+48|0;f[p>>2]=n;f[k>>2]=l;q=n}f[g>>2]=1124007936;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[m>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((q|0)!=(g+48|0))g0(q);if((b[h+11>>0]|0)>=0){u=e;return c|0}YDc(f[h>>2]|0);u=e;return c|0}function oI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;mi[f[a>>2]&2047](d,b);b=VDc(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}g0(o);u=c;return b|0}function pI(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;a=e+4|0;j=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)dEc(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{e=j+16&-16;n=VDc(e)|0;f[h>>2]=n;f[h+8>>2]=e|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){dJc(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;Ti[i&511](c,d,h);if((b[h+11>>0]|0)>=0){u=g;return}YDc(f[h>>2]|0);u=g;return}function qI(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function rI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;f[g>>2]=d;Ti[h&511](b,c,g);Ae(f[g>>2]|0);u=e;return}function sI(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function tI(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uI(a){a=a|0;return a|0}function vI(a){a=a|0;return a|0}function wI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function xI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function yI(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function zI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function AI(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;Ug[a&1](m,b,c,d,e,g,h,i,j,k);k=VDc(8)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];u=l;return k|0}function BI(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=+i;j=+j;var k=0,l=0;k=u;u=u+16|0;l=k;Ri[a&1](l,b,c,d,e,g,h,i,j);h=VDc(8)|0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];u=k;return h|0}function CI(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=+i;var j=0,k=0;j=u;u=u+16|0;k=j;lj[a&1](k,b,c,d,e,g,h,i);h=VDc(8)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];u=j;return h|0}function DI(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;zg[a&7](j,b,c,d,e,g,h);h=VDc(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function EI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0;h=u;u=u+16|0;i=h;Lj[a&7](i,b,c,d,e,g);d=VDc(8)|0;f[d>>2]=f[i>>2];f[d+4>>2]=f[i+4>>2];u=h;return d|0}function FI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;ni[a&31](h,b,c,d,e);d=VDc(8)|0;f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];u=g;return d|0}function GI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[a&511](g,b,c,d);d=VDc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function HI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=VDc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function II(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function JI(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function KI(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function LI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function MI(a){a=a|0;return f[a+4>>2]|0}function NI(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function OI(a){a=a|0;return 0}function PI(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function QI(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function RI(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function SI(a){a=a|0;return a|0}function TI(a){a=a|0;return a|0}function UI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function VI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function WI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function XI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[a&511](g,b,c,d);d=VDc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function YI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=VDc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function ZI(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function _I(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function $I(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function aJ(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function bJ(a){a=a|0;return f[a+4>>2]|0}function cJ(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function dJ(a){a=a|0;return 0}function eJ(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function fJ(a){a=a|0;return 5752}function gJ(a){a=a|0;if(!a)return;qPb(a);YDc(a);return}function hJ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)dEc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=VDc(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){dJc(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;i=Mi[h&1023](c,g)|0;if((b[g+11>>0]|0)>=0){u=e;return i|0}YDc(f[g>>2]|0);u=e;return i|0}function iJ(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+16|0;m=l+8|0;n=l;o=f[a>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];uh[o&7](b,c,d,e,g,h,i,m,n);u=l;return}function jJ(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k;m=f[a>>2]|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];tg[m&7](b,c,d,e,g,h,i,l);u=k;return}function kJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;oj[f[a>>2]&7](b,c,d,e,g,h,i);return}function lJ(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;ej[f[a>>2]&15](b,c,d,e,g,h);return}function mJ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;ni[f[a>>2]&31](b,c,d,e,g);return}function nJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function oJ(){var a=0;a=VDc(8)|0;lPb(a);return a|0}function pJ(a){a=a|0;return yj[a&63]()|0}function qJ(a){a=a|0;var b=0;b=VDc(8)|0;mPb(b,a);return b|0}function rJ(a,b){a=a|0;b=b|0;return _i[a&1023](b)|0}function sJ(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0;n=u;u=u+16|0;o=n+8|0;p=n;q=f[a>>2]|0;f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];ih[q&3](b,c,d,e,g,h,i,j,o,p,m);u=n;return}function tJ(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+16|0;n=m+8|0;o=m;p=f[a>>2]|0;f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];Xi[p&3](b,c,d,e,g,h,i,j,n,o);u=m;return}function uJ(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l;n=f[a>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];Gj[n&3](b,c,d,e,g,h,i,j,m);u=l;return}function vJ(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;Ei[f[a>>2]&7](b,c,d,e,g,h,i,j);return}function wJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;Lg[f[a>>2]&15](b,c,d,e,g,h,i);return}function xJ(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;Dh[f[a>>2]&15](b,c,d,e,g,h);return}function yJ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function zJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function AJ(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k;n=f[a>>2]|0;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];Gh[n&3](b,c,d,e,g,h,l,m);u=k;return}function BJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j;l=f[a>>2]|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];vg[l&3](b,c,d,e,g,h,k);u=j;return}function CJ(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;tj[f[a>>2]&7](b,c,d,e,g,h);return}function DJ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;Lh[f[a>>2]&7](b,c,d,e,g);return}function EJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function FJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function GJ(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function HJ(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function IJ(a){a=a|0;return a|0}function JJ(a){a=a|0;return a|0}function KJ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function LJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function MJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function NJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[a&511](g,b,c,d);d=VDc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function OJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=VDc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function PJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function QJ(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function RJ(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function SJ(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function TJ(a){a=a|0;return f[a+4>>2]|0}function UJ(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function VJ(a){a=a|0;return 0}function WJ(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function XJ(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function YJ(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ZJ(a){a=a|0;return a|0}function _J(a){a=a|0;return a|0}function $J(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function aK(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function bK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function cK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+Vg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+Vg[e&31](a);return +g}return +(0.0)}function dK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;tg[a&7](k,b,c,d,e,g,h,i);i=VDc(8)|0;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];u=j;return i|0}function eK(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;oj[a&7](j,b,c,d,e,g,h);h=VDc(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function fK(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;ej[a&15](i,b,c,d,e,g);g=VDc(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function gK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;ni[a&31](h,b,c,d,e);d=VDc(8)|0;f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];u=g;return d|0}function hK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[a&511](g,b,c,d);d=VDc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function iK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=VDc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function jK(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function kK(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function lK(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function mK(a){a=a|0;return f[a+4>>2]|0}function nK(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function oK(a){a=a|0;return 0}function pK(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function qK(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function rK(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function sK(a){a=a|0;return a|0}function tK(a){a=a|0;return a|0}function uK(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function vK(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function wK(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;ii[a&1](m,b,c,d,e,g,h,i,j,k);k=VDc(8)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];u=l;return k|0}function xK(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;gj[a&1](l,b,c,d,e,g,h,i,j);j=VDc(8)|0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];u=k;return j|0}function yK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Uh[a&3](k,b,c,d,e,g,h,i);i=VDc(8)|0;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];u=j;return i|0}function zK(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;vh[a&3](j,b,c,d,e,g,h);h=VDc(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function AK(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Bg[a&3](i,b,c,d,e,g);g=VDc(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function BK(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;bi[a&3](h,b,c,d,e);e=VDc(8)|0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];u=g;return e|0}function CK(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ri[a&15](g,b,c,d);d=VDc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function DK(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;Vi[a&31](e,b,c);b=VDc(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function EK(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function FK(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function GK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&1023](a)|0}function HK(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function IK(a){a=a|0;return f[a+4>>2]|0}function JK(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function KK(a){a=a|0;return 0}function LK(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function MK(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function NK(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function OK(a){a=a|0;return a|0}function PK(a){a=a|0;return a|0}function QK(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=ooc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;dJc(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}YDc(h);u=d;return c|0}function RK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;$h[a&63](g,b,c,d);c=VDc(8)|0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];u=e;return c|0}function SK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=VDc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function TK(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=VDc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function UK(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&2047](c);a=VDc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function VK(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h;j=h+16|0;k=h+12|0;l=h+8|0;f[j>>2]=b;f[k>>2]=c;f[l>>2]=g;Zh[a&7](i,j,k,d,e,l);a=VDc(8)|0;f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];g=i;f[g>>2]=0;f[g+4>>2]=0;Ae(f[l>>2]|0);Ae(f[k>>2]|0);Ae(f[j>>2]|0);u=h;return a|0}function WK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;i=g+12|0;j=g+8|0;f[i>>2]=b;f[j>>2]=c;Kh[a&15](h,i,j,d,e);a=VDc(8)|0;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];c=h;f[c>>2]=0;f[c+4>>2]=0;Ae(f[j>>2]|0);Ae(f[i>>2]|0);u=g;return a|0}function XK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j;l=j+16|0;m=j+12|0;n=j+8|0;f[l>>2]=d;f[m>>2]=e;f[n>>2]=i;ug[a&3](k,b,c,l,m,g,h,n);c=VDc(8)|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];b=k;f[b>>2]=0;f[b+4>>2]=0;Ae(f[n>>2]|0);Ae(f[m>>2]|0);Ae(f[l>>2]|0);u=j;return c|0}function YK(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i;k=i+12|0;l=i+8|0;f[k>>2]=d;f[l>>2]=e;Tg[a&3](j,b,c,k,l,g,h);c=VDc(8)|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];b=j;f[b>>2]=0;f[b+4>>2]=0;Ae(f[l>>2]|0);Ae(f[k>>2]|0);u=i;return c|0}function ZK(a){a=a|0;return f[a+4>>2]|0}function _K(){var a=0;a=VDc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function $K(a){a=a|0;return 0}function aL(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);YDc(a);return}function bL(){Ak(0);Nv(0);return}function cL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=g+8|0;j=f[a+4>>2]|0;if((j|0)<3)k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{l=f[a+40>>2]|0;m=0;n=1;while(1){o=Y(f[l+(m<<2)>>2]|0,n)|0;m=m+1|0;if((m|0)==(j|0)){k=o;break}else n=o}}n=c>>>3&511;j=n+1|0;m=c&7;l=j<<(47696>>>(m<<1)&3);o=SY(f[a>>2]&7,c)|0;c=f[a+16>>2]|0;a=(k|0)<=(n|0);f[h>>2]=a?k:j;f[h+4>>2]=1;wi[o&255](c,1,0,1,d,1,h,0);if(a){if((k|0)!=1){f[i>>2]=0;f[i+4>>2]=0;k=tT(i,8)|0;a=k;b[a>>0]=115;b[a+1>>0]=99;b[a+2>>0]=110;b[a+3>>0]=32;a=k+4|0;b[a>>0]=61;b[a+1>>0]=61;b[a+2>>0]=32;b[a+3>>0]=49;z5(-215,i,210186,210209,68)}i=1212424721>>>(m<<2)&15;if(i>>>0<l>>>0){m=i;do{b[d+m>>0]=b[d+(m-i)>>0]|0;m=m+1|0}while((m|0)!=(l|0))}}m=Y(l,e)|0;if(l>>>0<m>>>0)p=l;else{u=g;return}do{b[d+p>>0]=b[d+(p-l)>>0]|0;p=p+1|0}while((p|0)!=(m|0));u=g;return}function dL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=102;eL(a,b,c,d,g,1,9);u=e;return}function eL(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;j=u;u=u+1440|0;k=j+1376|0;l=j+1368|0;m=j+1352|0;n=j+1360|0;o=j+312|0;q=j+256|0;r=j;s=j+184|0;t=j+128|0;v=j+104|0;w=j+88|0;x=j+56|0;y=j+248|0;z=j+240|0;A=a;B=c;C=d$(a)|0;D=d$(c)|0;E=c$(a,-1)|0;F=E&7;G=(E>>>3&511)+1|0;H=c$(c,-1)|0;I=H&7;J=(H>>>3&511)+1|0;K=n$(a,-1)|0;L=n$(c,-1)|0;M=(K|0)<3;if(M)b$(l,a,-1);else{f[l>>2]=0;f[l+4>>2]=0}K=(L|0)<3;if(K)b$(m,c,-1);else{f[m>>2]=0;f[m+4>>2]=0}L=r$(e)|0;do if(((C|0)==(D|0)&(M&K)?(N=f[l>>2]|0,O=f[l+4>>2]|0,(N|0)==(f[m>>2]|0)?(O|0)==(f[m+4>>2]|0):0):0)?!((E|0)!=(H|0)|L^1):0){f[n>>2]=N;f[n+4>>2]=O;v$(d,n,E,-1,0,0);if(h){P=g;Q=G<<(47696>>>(E<<1&14)&3)}else{P=g+(F<<2)|0;Q=G}O=f[P>>2]|0;do if((d$(a)|0)==65536){N=f[a+4>>2]|0;f[k>>2]=f[N>>2];R=k+4|0;S=N+4|0;f[R>>2]=f[S>>2];T=k+8|0;f[T>>2]=f[N+8>>2];f[k+12>>2]=f[N+12>>2];f[k+16>>2]=f[N+16>>2];f[k+20>>2]=f[N+20>>2];f[k+24>>2]=f[N+24>>2];f[k+28>>2]=f[N+28>>2];f[k+32>>2]=f[N+32>>2];U=f[N+36>>2]|0;f[k+36>>2]=U;f[k+40>>2]=T;T=k+48|0;V=k+44|0;f[V>>2]=T;f[T>>2]=0;f[k+52>>2]=0;if(U|0){T=U+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[N+44>>2]|0;T=f[V>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];break}else{f[R>>2]=0;ZS(k,N);break}}else a$(k,a,-1);while(0);do if((d$(c)|0)==65536){N=f[c+4>>2]|0;f[o>>2]=f[N>>2];R=o+4|0;S=N+4|0;f[R>>2]=f[S>>2];T=o+8|0;f[T>>2]=f[N+8>>2];f[o+12>>2]=f[N+12>>2];f[o+16>>2]=f[N+16>>2];f[o+20>>2]=f[N+20>>2];f[o+24>>2]=f[N+24>>2];f[o+28>>2]=f[N+28>>2];f[o+32>>2]=f[N+32>>2];V=f[N+36>>2]|0;f[o+36>>2]=V;f[o+40>>2]=T;T=o+48|0;U=o+44|0;f[U>>2]=T;f[T>>2]=0;f[o+52>>2]=0;if(V|0){T=V+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[N+44>>2]|0;T=f[U>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];break}else{f[R>>2]=0;ZS(o,N);break}}else a$(o,c,-1);while(0);do if((d$(d)|0)==65536){N=f[d+4>>2]|0;f[q>>2]=f[N>>2];R=q+4|0;S=N+4|0;f[R>>2]=f[S>>2];T=q+8|0;f[T>>2]=f[N+8>>2];f[q+12>>2]=f[N+12>>2];f[q+16>>2]=f[N+16>>2];f[q+20>>2]=f[N+20>>2];f[q+24>>2]=f[N+24>>2];f[q+28>>2]=f[N+28>>2];f[q+32>>2]=f[N+32>>2];U=f[N+36>>2]|0;f[q+36>>2]=U;f[q+40>>2]=T;T=q+48|0;V=q+44|0;f[V>>2]=T;f[T>>2]=0;f[q+52>>2]=0;if(U|0){T=U+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[N+44>>2]|0;T=f[V>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];break}else{f[R>>2]=0;ZS(q,N);break}}else a$(q,d,-1);while(0);sT(r,k,o,q,1);N=Y(f[r>>2]|0,Q)|0;if(N>>>0<2147483647){f[r>>2]=N;Li[O&127](f[k+16>>2]|0,f[k+48>>2]|0,f[o+16>>2]|0,f[o+48>>2]|0,f[q+16>>2]|0,f[q+48>>2]|0,N,f[r+4>>2]|0,0);W=1}else W=0;N=q+36|0;R=f[N>>2]|0;if(R|0?(S=R+12|0,R=f[S>>2]|0,f[S>>2]=R+-1,(R|0)==1):0)_S(q);f[N>>2]=0;N=q+16|0;R=q+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[R>>2]|0)>0){N=f[q+40>>2]|0;S=0;do{f[N+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[R>>2]|0))}R=f[q+44>>2]|0;if((R|0)!=(q+48|0))g0(R);R=o+36|0;S=f[R>>2]|0;if(S|0?(N=S+12|0,S=f[N>>2]|0,f[N>>2]=S+-1,(S|0)==1):0)_S(o);f[R>>2]=0;R=o+16|0;S=o+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[S>>2]|0)>0){R=f[o+40>>2]|0;N=0;do{f[R+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[S>>2]|0))}S=f[o+44>>2]|0;if((S|0)!=(o+48|0))g0(S);S=k+36|0;N=f[S>>2]|0;if(N|0?(R=N+12|0,N=f[R>>2]|0,f[R>>2]=N+-1,(N|0)==1):0)_S(k);f[S>>2]=0;S=k+16|0;N=k+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[N>>2]|0)>0){S=f[k+40>>2]|0;R=0;do{f[S+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[N>>2]|0))}N=f[k+44>>2]|0;if((N|0)!=(k+48|0))g0(N);if(!W){X=Q;break}u=j;return}else X=G;while(0);a:do if((i|0)==12){Z=1;_=F;$=E;aa=X;ba=B;ca=A}else{Q=(C|0)==131072;W=(D|0)==131072;if(((W&1)+(Q&1)|0)!=1?(E|0)==(H|0)&(m$(a,c)|0):0){if(m$(a,c)|0){Z=0;_=F;$=E;aa=X;ba=B;ca=A;break}f[k>>2]=0;f[k+4>>2]=0;da=tT(k,41)|0;ea=210415;fa=da+41|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,k,210405,210209,234)}b:do if((n$(a,-1)|0)<=2?s$(a,-1)|0:0){b$(k,a,-1);P=f[k>>2]|0;n=(P|0)==1;if(n){if(!((C|0)!=131072&W)){ga=f[k+4>>2]|0;ha=70}}else if(!((C|0)!=131072&W|(f[k+4>>2]|0)!=1)){ga=1;ha=70}do if((ha|0)==70){K=(ga|0)==1;if(!((P|0)==(J|0)&K|n&(K|(ga|0)==(J|0)))){if(!(n&(ga|0)==4))break;if(!(J>>>0<5&(c$(a,-1)|0)==6))break b}K=f[l>>2]|0;M=l+4|0;N=f[M>>2]|0;f[l>>2]=f[m>>2];R=m+4|0;f[M>>2]=f[R>>2];f[m>>2]=K;f[R>>2]=N;Z=1;_=I;$=H;aa=J;ba=A;ca=B;break a}while(0)}while(0);if((n$(c,-1)|0)>2){f[k>>2]=0;ia=k+4|0;f[ia>>2]=0;ja=tT(k,130)|0;dJc(ja|0,210274,130)|0;z5(-209,k,210405,210209,229)}if(!(s$(c,-1)|0)){f[k>>2]=0;ia=k+4|0;f[ia>>2]=0;ja=tT(k,130)|0;dJc(ja|0,210274,130)|0;z5(-209,k,210405,210209,229)}b$(k,c,-1);W=f[k>>2]|0;n=(W|0)==1;if(n){if(!(Q&(D|0)!=131072)){ka=f[k+4>>2]|0;ha=82}}else if(!(Q&(D|0)!=131072|(f[k+4>>2]|0)!=1)){ka=1;ha=82}if((ha|0)==82){P=(ka|0)==1;if((W|0)==(G|0)&P|n&(P|(ka|0)==(G|0))){Z=1;_=F;$=E;aa=X;ba=B;ca=A;break}if(n&(ka|0)==4){if(G>>>0<5&(c$(c,-1)|0)==6){Z=1;_=F;$=E;aa=X;ba=B;ca=A;break}f[k>>2]=0;ia=k+4|0;f[ia>>2]=0;ja=tT(k,130)|0;dJc(ja|0,210274,130)|0;z5(-209,k,210405,210209,229)}}f[k>>2]=0;ia=k+4|0;f[ia>>2]=0;ja=tT(k,130)|0;dJc(ja|0,210274,130)|0;z5(-209,k,210405,210209,229)}while(0);ja=($>>>3&511)+1<<(47696>>>($<<1&14)&3);f[k>>2]=ja;ia=((ja+1023|0)>>>0)/(ja>>>0)|0;if(!L){if((c$(e,-1)|0|1|0)!=1){f[o>>2]=0;la=o+4|0;f[la>>2]=0;ma=tT(o,60)|0;da=ma;ea=210457;fa=da+60|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,o,210405,210209,245)}ja=ca;if(!(m$(e,ja)|0)){f[o>>2]=0;la=o+4|0;f[la>>2]=0;ma=tT(o,60)|0;da=ma;ea=210457;fa=da+60|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,o,210405,210209,245)}ea=f_(f[k>>2]|0)|0;if(m$(d,ja)|0){na=(c$(d,-1)|0)!=($|0);oa=ea;pa=ja}else{na=1;oa=ea;pa=ja}}else{na=0;oa=0;pa=ca}ca=o+8|0;f[o>>2]=ca;ja=o+4|0;f[ja>>2]=1032;Z$(d,pa,$);if(!(L|na^1)){p[r>>3]=0.0;f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;a0(d,q,s)}do if((d$(pa)|0)==65536){na=f[pa+4>>2]|0;f[q>>2]=f[na>>2];$=q+4|0;ea=na+4|0;f[$>>2]=f[ea>>2];da=q+8|0;f[da>>2]=f[na+8>>2];f[q+12>>2]=f[na+12>>2];f[q+16>>2]=f[na+16>>2];f[q+20>>2]=f[na+20>>2];f[q+24>>2]=f[na+24>>2];f[q+28>>2]=f[na+28>>2];f[q+32>>2]=f[na+32>>2];fa=f[na+36>>2]|0;f[q+36>>2]=fa;f[q+40>>2]=da;da=q+48|0;ma=q+44|0;f[ma>>2]=da;f[da>>2]=0;f[q+52>>2]=0;if(fa|0){da=fa+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[na+44>>2]|0;da=f[ma>>2]|0;f[da>>2]=f[ea>>2];f[da+4>>2]=f[ea+4>>2];break}else{f[$>>2]=0;ZS(q,na);break}}else a$(q,pa,-1);while(0);pa=ba;do if((d$(pa)|0)==65536){ba=f[pa+4>>2]|0;f[r>>2]=f[ba>>2];na=r+4|0;$=ba+4|0;f[na>>2]=f[$>>2];ea=r+8|0;f[ea>>2]=f[ba+8>>2];f[r+12>>2]=f[ba+12>>2];f[r+16>>2]=f[ba+16>>2];f[r+20>>2]=f[ba+20>>2];f[r+24>>2]=f[ba+24>>2];f[r+28>>2]=f[ba+28>>2];f[r+32>>2]=f[ba+32>>2];da=f[ba+36>>2]|0;f[r+36>>2]=da;f[r+40>>2]=ea;ea=r+48|0;ma=r+44|0;f[ma>>2]=ea;f[ea>>2]=0;f[r+52>>2]=0;if(da|0){ea=da+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[$>>2]|0)<3){$=f[ba+44>>2]|0;ea=f[ma>>2]|0;f[ea>>2]=f[$>>2];f[ea+4>>2]=f[$+4>>2];break}else{f[na>>2]=0;ZS(r,ba);break}}else a$(r,pa,-1);while(0);do if((d$(d)|0)==65536){pa=f[d+4>>2]|0;f[s>>2]=f[pa>>2];ba=s+4|0;na=pa+4|0;f[ba>>2]=f[na>>2];$=s+8|0;f[$>>2]=f[pa+8>>2];f[s+12>>2]=f[pa+12>>2];f[s+16>>2]=f[pa+16>>2];f[s+20>>2]=f[pa+20>>2];f[s+24>>2]=f[pa+24>>2];f[s+28>>2]=f[pa+28>>2];f[s+32>>2]=f[pa+32>>2];ea=f[pa+36>>2]|0;f[s+36>>2]=ea;f[s+40>>2]=$;$=s+48|0;ma=s+44|0;f[ma>>2]=$;f[$>>2]=0;f[s+52>>2]=0;if(ea|0){$=ea+12|0;f[$>>2]=(f[$>>2]|0)+1}if((f[na>>2]|0)<3){na=f[pa+44>>2]|0;$=f[ma>>2]|0;f[$>>2]=f[na>>2];f[$+4>>2]=f[na+4>>2];break}else{f[ba>>2]=0;ZS(s,pa);break}}else a$(s,d,-1);while(0);do if((d$(e)|0)==65536){d=f[e+4>>2]|0;f[t>>2]=f[d>>2];pa=t+4|0;ba=d+4|0;f[pa>>2]=f[ba>>2];na=t+8|0;f[na>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];$=f[d+36>>2]|0;f[t+36>>2]=$;f[t+40>>2]=na;na=t+48|0;ma=t+44|0;f[ma>>2]=na;f[na>>2]=0;f[t+52>>2]=0;if($|0){na=$+12|0;f[na>>2]=(f[na>>2]|0)+1}if((f[ba>>2]|0)<3){ba=f[d+44>>2]|0;na=f[ma>>2]|0;f[na>>2]=f[ba>>2];f[na+4>>2]=f[ba+4>>2];break}else{f[pa>>2]=0;ZS(t,d);break}}else a$(t,e,-1);while(0);e=h?f[k>>2]|0:aa;aa=f[(h?g:g+(_<<2)|0)>>2]|0;if(Z){f[v>>2]=q;f[v+4>>2]=s;f[v+8>>2]=t;f[v+12>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;z2(x,v,w,-1);Z=f[x+20>>2]|0;_=ia>>>0<Z>>>0?ia:Z;g=(Y(Y(f[k>>2]|0,L?1:2)|0,_)|0)+32|0;if((f[ja>>2]|0)>>>0<g>>>0){h=f[o>>2]|0;if((h|0)!=(ca|0)){if(h|0)ZDc(h);f[o>>2]=ca;f[ja>>2]=1032}f[ja>>2]=g;if(g>>>0>1032){h=XDc(g)|0;f[o>>2]=h;qa=h}else qa=ca}else{f[ja>>2]=g;qa=f[o>>2]|0}g=qa+(Y(f[k>>2]|0,_)|0)+15&-16;cL(r,f[q>>2]&4095,qa,_);h=x+16|0;d=w+4|0;pa=w+8|0;ba=z+4|0;c:do if(!Z){na=0;while(1){if(na>>>0>=(f[h>>2]|0)>>>0)break c;A2(x)|0;na=na+1|0}}else{na=0;while(1){if(na>>>0>=(f[h>>2]|0)>>>0)break c;Q=f[w>>2]|0;if(L){ma=0;$=Q;ea=f[d>>2]|0;do{da=Z-ma|0;fa=da>>>0>_>>>0?_:da;da=Y(fa,e)|0;Li[aa&127]($,0,qa,0,ea,0,da,1,0);da=Y(f[k>>2]|0,fa)|0;$=(f[w>>2]|0)+da|0;f[w>>2]=$;ea=(f[d>>2]|0)+da|0;f[d>>2]=ea;ma=ma+_|0}while(Z>>>0>ma>>>0)}else{ma=0;ea=Q;do{$=Z-ma|0;da=$>>>0>_>>>0?_:$;$=Y(da,e)|0;Li[aa&127](ea,0,qa,0,g,0,$,1,0);$=f[pa>>2]|0;fa=f[d>>2]|0;f[z>>2]=da;f[ba>>2]=1;wi[oa&255](g,0,$,0,fa,0,z,k);f[pa>>2]=(f[pa>>2]|0)+da;fa=Y(f[k>>2]|0,da)|0;ea=(f[w>>2]|0)+fa|0;f[w>>2]=ea;f[d>>2]=(f[d>>2]|0)+fa;ma=ma+_|0}while(Z>>>0>ma>>>0)}A2(x)|0;na=na+1|0}}while(0)}else{f[v>>2]=q;f[v+4>>2]=r;f[v+8>>2]=s;f[v+12>>2]=t;f[v+16>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;z2(x,v,w,-1);v=f[x+20>>2]|0;if((Y(v,e)|0)<0)ra=2147483647/(e|0)|0;else ra=v;do if(!L){Z=ia>>>0<ra>>>0?ia:ra;_=Y(f[k>>2]|0,Z)|0;if((f[ja>>2]|0)>>>0>=_>>>0){f[ja>>2]=_;sa=f[o>>2]|0;ta=Z;break}d=f[o>>2]|0;if((d|0)!=(ca|0)){if(d|0)ZDc(d);f[o>>2]=ca;f[ja>>2]=1032}f[ja>>2]=_;if(_>>>0>1032){d=XDc(_)|0;f[o>>2]=d;sa=d;ta=Z}else{sa=ca;ta=Z}}else{sa=0;ta=ra}while(0);ra=x+16|0;ia=(v|0)==0;Z=w+4|0;d=w+8|0;_=w+12|0;pa=y+4|0;z=0;while(1){if(z>>>0>=(f[ra>>2]|0)>>>0)break;d:do if(!ia){g=f[w>>2]|0;ba=f[Z>>2]|0;if(!L){qa=0;h=g;na=ba;while(1){ma=v-qa|0;ea=ma>>>0>ta>>>0?ta:ma;ma=Y(ea,e)|0;Li[aa&127](h,0,na,0,sa,0,ma,1,0);ma=f[_>>2]|0;Q=f[d>>2]|0;f[y>>2]=ea;f[pa>>2]=1;wi[oa&255](sa,0,ma,0,Q,0,y,k);f[_>>2]=(f[_>>2]|0)+ea;Q=Y(f[k>>2]|0,ea)|0;h=(f[w>>2]|0)+Q|0;f[w>>2]=h;na=(f[Z>>2]|0)+Q|0;f[Z>>2]=na;f[d>>2]=(f[d>>2]|0)+Q;qa=qa+ta|0;if(v>>>0<=qa>>>0)break d}}qa=0;na=g;h=ba;Q=f[d>>2]|0;do{ea=v-qa|0;ma=ea>>>0>ta>>>0?ta:ea;ea=Y(ma,e)|0;Li[aa&127](na,0,h,0,Q,0,ea,1,0);ea=Y(f[k>>2]|0,ma)|0;na=(f[w>>2]|0)+ea|0;f[w>>2]=na;h=(f[Z>>2]|0)+ea|0;f[Z>>2]=h;Q=(f[d>>2]|0)+ea|0;f[d>>2]=Q;qa=qa+ta|0}while(v>>>0>qa>>>0)}while(0);A2(x)|0;z=z+1|0}}z=t+36|0;x=f[z>>2]|0;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)_S(t);f[z>>2]=0;z=t+16|0;x=t+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[x>>2]|0)>0){z=f[t+40>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[x>>2]|0))}x=f[t+44>>2]|0;if((x|0)!=(t+48|0))g0(x);x=s+36|0;t=f[x>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)_S(s);f[x>>2]=0;x=s+16|0;t=s+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[t>>2]|0)>0){x=f[s+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))g0(t);t=r+36|0;s=f[t>>2]|0;if(s|0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0)_S(r);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))g0(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){v=r+12|0;t=f[v>>2]|0;f[v>>2]=t+-1;if((t|0)!=1)break;_S(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))g0(r);r=f[o>>2]|0;if((r|0)!=(ca|0)){if(r|0)ZDc(r);f[o>>2]=ca;f[ja>>2]=1032}u=j;return}function fL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=103;eL(a,b,c,d,g,1,10);u=e;return}function gL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=104;eL(a,b,c,d,g,1,11);u=e;return}function hL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=105;eL(a,a,b,c,e,1,12);u=d;return}function iL(a,b,c){a=a|0;b=b|0;c=c|0;eL(a,b,c,e0()|0,33984,0,14);return}function jL(a,b,c){a=a|0;b=b|0;c=c|0;eL(a,b,c,e0()|0,34016,0,13);return}function kL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;eL(g,h,e,e0()|0,33984,0,14);u=d;return}function lL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;eL(g,h,e,e0()|0,34016,0,13);u=d;return}function mL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nL(a,b,c,d,e,34048,0,0,0);return}function nL(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;k=u;u=u+1504|0;l=k+1448|0;m=k+1440|0;n=k+1432|0;o=k+1424|0;q=k;r=k+1368|0;s=k+1312|0;t=k+1168|0;v=k+128|0;w=k+104|0;x=k+88|0;y=k+56|0;z=k+1304|0;A=k+1296|0;B=k+1288|0;C=k+1280|0;D=k+1272|0;E=k+1264|0;F=k+1256|0;G=k+1248|0;H=k+1240|0;I=k+1232|0;J=k+1224|0;K=a;L=c;M=d$(a)|0;N=d$(c)|0;O=r$(e)|0;P=O^1;Q=c$(a,-1)|0;R=Q&7;S=Q>>>3&511;T=S+1|0;U=c$(c,-1)|0;V=U&7;f[m>>2]=V;W=(U>>>3&511)+1|0;X=n$(a,-1)|0;Z=n$(c,-1)|0;_=(X|0)<3;if(_)b$(n,a,-1);else{f[n>>2]=0;f[n+4>>2]=0}$=(Z|0)<3;if($)b$(o,c,-1);else{f[o>>2]=0;f[o+4>>2]=0}if((n$(a,-1)|0)<=2?s$(a,-1)|0:0){b$(l,a,-1);aa=f[l>>2]|0;ba=(aa|0)==1;if(!ba?(f[l+4>>2]|0)!=1:0)ca=0;else if(!((M|0)!=131072&(N|0)==131072)){da=f[l+4>>2]|0;ea=(da|0)==1;if(!((aa|0)==(W|0)&ea|ba&(ea|(da|0)==(W|0))))if(ba&(da|0)==4)ca=W>>>0<5&(c$(a,-1)|0)==6;else ca=0;else ca=1}else ca=0;fa=ca}else fa=0;if((n$(c,-1)|0)<=2?s$(c,-1)|0:0){b$(l,c,-1);ca=f[l>>2]|0;da=(ca|0)==1;if(!da?(f[l+4>>2]|0)!=1:0)ga=0;else if(!((M|0)==131072&(N|0)!=131072)){ba=f[l+4>>2]|0;ea=(ba|0)==1;if(!((ca|0)==(T|0)&ea|da&(ea|(ba|0)==(T|0))))if(da&(ba|0)==4)ga=T>>>0<5&(c$(c,-1)|0)==6;else ga=0;else ga=1}else ga=0;ha=ga}else ha=0;do if((M|0)==(N|0)|(S|0)==0?!((Q|0)!=(U|0)|P|$&(_&((f[n>>2]|0)==(f[o>>2]|0)?(f[n+4>>2]|0)==(f[o+4>>2]|0):0))^1):0){if(!(X$(d)|0)?(g|0)<0|(g&7|0)==(R|0):0){if(fa^ha)break}else{if(!(X$(d)|0))break;if(fa^ha|(c$(d,-1)|0)!=(Q|0))break}Z$(d,a,Q);do if((d$(a)|0)==65536){ga=f[a+4>>2]|0;f[l>>2]=f[ga>>2];ba=l+4|0;da=ga+4|0;f[ba>>2]=f[da>>2];ea=l+8|0;f[ea>>2]=f[ga+8>>2];f[l+12>>2]=f[ga+12>>2];f[l+16>>2]=f[ga+16>>2];f[l+20>>2]=f[ga+20>>2];f[l+24>>2]=f[ga+24>>2];f[l+28>>2]=f[ga+28>>2];f[l+32>>2]=f[ga+32>>2];ca=f[ga+36>>2]|0;f[l+36>>2]=ca;f[l+40>>2]=ea;ea=l+48|0;aa=l+44|0;f[aa>>2]=ea;f[ea>>2]=0;f[l+52>>2]=0;if(ca|0){ea=ca+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ga+44>>2]|0;ea=f[aa>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];break}else{f[ba>>2]=0;ZS(l,ga);break}}else a$(l,a,-1);while(0);do if((d$(c)|0)==65536){ga=f[c+4>>2]|0;f[q>>2]=f[ga>>2];ba=q+4|0;da=ga+4|0;f[ba>>2]=f[da>>2];ea=q+8|0;f[ea>>2]=f[ga+8>>2];f[q+12>>2]=f[ga+12>>2];f[q+16>>2]=f[ga+16>>2];f[q+20>>2]=f[ga+20>>2];f[q+24>>2]=f[ga+24>>2];f[q+28>>2]=f[ga+28>>2];f[q+32>>2]=f[ga+32>>2];aa=f[ga+36>>2]|0;f[q+36>>2]=aa;f[q+40>>2]=ea;ea=q+48|0;ca=q+44|0;f[ca>>2]=ea;f[ea>>2]=0;f[q+52>>2]=0;if(aa|0){ea=aa+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ga+44>>2]|0;ea=f[ca>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];break}else{f[ba>>2]=0;ZS(q,ga);break}}else a$(q,c,-1);while(0);do if((d$(d)|0)==65536){ga=f[d+4>>2]|0;f[r>>2]=f[ga>>2];ba=r+4|0;da=ga+4|0;f[ba>>2]=f[da>>2];ea=r+8|0;f[ea>>2]=f[ga+8>>2];f[r+12>>2]=f[ga+12>>2];f[r+16>>2]=f[ga+16>>2];f[r+20>>2]=f[ga+20>>2];f[r+24>>2]=f[ga+24>>2];f[r+28>>2]=f[ga+28>>2];f[r+32>>2]=f[ga+32>>2];ca=f[ga+36>>2]|0;f[r+36>>2]=ca;f[r+40>>2]=ea;ea=r+48|0;aa=r+44|0;f[aa>>2]=ea;f[ea>>2]=0;f[r+52>>2]=0;if(ca|0){ea=ca+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ga+44>>2]|0;ea=f[aa>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];break}else{f[ba>>2]=0;ZS(r,ga);break}}else a$(r,d,-1);while(0);sT(s,l,q,r,((f[l>>2]|0)>>>3&511)+1|0);ga=l+16|0;ba=l+44|0;da=l+48|0;ea=q+16|0;aa=q+44|0;ca=q+48|0;ia=r+16|0;ja=r+44|0;ka=r+48|0;Li[f[h+(R<<2)>>2]&127](f[ga>>2]|0,f[da>>2]|0,f[ea>>2]|0,f[ca>>2]|0,f[ia>>2]|0,f[ka>>2]|0,f[s>>2]|0,f[s+4>>2]|0,j);la=r+36|0;ma=f[la>>2]|0;if(ma|0?(na=ma+12|0,ma=f[na>>2]|0,f[na>>2]=ma+-1,(ma|0)==1):0)_S(r);f[la>>2]=0;la=r+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[la>>2]|0)>0){ia=f[r+40>>2]|0;ma=0;do{f[ia+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[la>>2]|0))}la=f[ja>>2]|0;if((la|0)!=(ka|0))g0(la);la=q+36|0;ma=f[la>>2]|0;if(ma|0?(ia=ma+12|0,ma=f[ia>>2]|0,f[ia>>2]=ma+-1,(ma|0)==1):0)_S(q);f[la>>2]=0;la=q+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[la>>2]|0)>0){ma=f[q+40>>2]|0;ia=0;do{f[ma+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[la>>2]|0))}la=f[aa>>2]|0;if((la|0)!=(ca|0))g0(la);la=l+36|0;ia=f[la>>2]|0;if(ia|0?(ma=ia+12|0,ia=f[ma>>2]|0,f[ma>>2]=ia+-1,(ia|0)==1):0)_S(l);f[la>>2]=0;la=l+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[la>>2]|0)>0){ia=f[l+40>>2]|0;ma=0;do{f[ia+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[la>>2]|0))}la=f[ba>>2]|0;if((la|0)!=(da|0))g0(la);u=k;return}while(0);do if((X|0)==(Z|0)?(ha=f[n>>2]|0,fa=f[n+4>>2]|0,(T|0)==(W|0)&((ha|0)==(f[o>>2]|0)?(fa|0)==(f[o+4>>2]|0):0)):0){if((M|0)==131072?(ha|0)==1&((fa|0)==4|(fa|0)==1):0){oa=84;break}if((N|0)==131072?(ha|0)==1&((fa|0)==4|(fa|0)==1):0)oa=84;else{pa=0;qa=0;ra=Q;sa=R;ta=T;ua=U;va=L;wa=K}}else oa=84;while(0);do if((oa|0)==84){a:do if((n$(a,-1)|0)<=2?s$(a,-1)|0:0){b$(l,a,-1);Z=f[l>>2]|0;X=(Z|0)==1;if(!(!X?(f[l+4>>2]|0)!=1:0))oa=88;do if((oa|0)==88?!((M|0)!=131072&(N|0)==131072):0){fa=f[l+4>>2]|0;ha=(fa|0)==1;if(!((Z|0)==(W|0)&ha|X&(ha|(fa|0)==(W|0)))){if(!(X&(fa|0)==4))break;if(!(W>>>0<5&(c$(a,-1)|0)==6)){oa=95;break a}}fa=f[n>>2]|0;ha=n+4|0;_=f[ha>>2]|0;f[n>>2]=f[o>>2];$=o+4|0;f[ha>>2]=f[$>>2];f[o>>2]=fa;f[$>>2]=_;f[m>>2]=R;xa=1;ya=U;za=V;Aa=W;Ba=Q;Ca=T;Da=K;Ea=L;break a}while(0);oa=95}else oa=95;while(0);do if((oa|0)==95){if((n$(c,-1)|0)>2){f[l>>2]=0;Fa=l+4|0;f[Fa>>2]=0;Ga=tT(l,153)|0;dJc(Ga|0,210518,153)|0;z5(-209,l,210672,210209,663)}if(!(s$(c,-1)|0)){f[l>>2]=0;Fa=l+4|0;f[Fa>>2]=0;Ga=tT(l,153)|0;dJc(Ga|0,210518,153)|0;z5(-209,l,210672,210209,663)}b$(l,c,-1);da=f[l>>2]|0;ba=(da|0)==1;if(!(!ba?(f[l+4>>2]|0)!=1:0))oa=99;if((oa|0)==99?!((M|0)==131072&(N|0)!=131072):0){X=f[l+4>>2]|0;Z=(X|0)==1;if((da|0)==(T|0)&Z|ba&(Z|(X|0)==(T|0))){xa=0;ya=Q;za=R;Aa=T;Ba=U;Ca=W;Da=L;Ea=K;break}if(ba&(X|0)==4){if(T>>>0<5&(c$(c,-1)|0)==6){xa=0;ya=Q;za=R;Aa=T;Ba=U;Ca=W;Da=L;Ea=K;break}f[l>>2]=0;Fa=l+4|0;f[Fa>>2]=0;Ga=tT(l,153)|0;dJc(Ga|0,210518,153)|0;z5(-209,l,210672,210209,663)}}f[l>>2]=0;Fa=l+4|0;f[Fa>>2]=0;Ga=tT(l,153)|0;dJc(Ga|0,210518,153)|0;z5(-209,l,210672,210209,663)}while(0);if((Ba|0)!=6){f[l>>2]=0;Ha=l+4|0;f[Ha>>2]=0;Ia=tT(l,55)|0;Ja=Ia;Ka=210682;La=Ja+55|0;do{b[Ja>>0]=b[Ka>>0]|0;Ja=Ja+1|0;Ka=Ka+1|0}while((Ja|0)<(La|0));z5(-215,l,210672,210209,665)}X=o+4|0;switch(f[X>>2]|0){case 4:case 1:break;default:{f[l>>2]=0;Ha=l+4|0;f[Ha>>2]=0;Ia=tT(l,55)|0;Ja=Ia;Ka=210682;La=Ja+55|0;do{b[Ja>>0]=b[Ka>>0]|0;Ja=Ja+1|0;Ka=Ka+1|0}while((Ja|0)<(La|0));z5(-215,l,210672,210209,665)}}if(i){f[m>>2]=6;pa=1;qa=xa<<24>>24!=0;ra=ya;sa=za;ta=Aa;ua=6;va=Da;wa=Ea;break}ba=Da;do if((d$(ba)|0)==65536){Z=f[ba+4>>2]|0;f[l>>2]=f[Z>>2];da=l+4|0;_=Z+4|0;f[da>>2]=f[_>>2];$=l+8|0;f[$>>2]=f[Z+8>>2];f[l+12>>2]=f[Z+12>>2];fa=l+16|0;f[fa>>2]=f[Z+16>>2];f[l+20>>2]=f[Z+20>>2];f[l+24>>2]=f[Z+24>>2];f[l+28>>2]=f[Z+28>>2];f[l+32>>2]=f[Z+32>>2];ha=f[Z+36>>2]|0;f[l+36>>2]=ha;f[l+40>>2]=$;$=l+48|0;S=l+44|0;f[S>>2]=$;f[$>>2]=0;f[l+52>>2]=0;if(ha|0){$=ha+12|0;f[$>>2]=(f[$>>2]|0)+1}if((f[_>>2]|0)<3){_=f[Z+44>>2]|0;$=f[S>>2]|0;f[$>>2]=f[_>>2];f[$+4>>2]=f[_+4>>2];Ma=S;Na=fa;break}else{f[da>>2]=0;ZS(l,Z);Ma=S;Na=fa;break}}else{a$(l,ba,-1);Ma=l+44|0;Na=l+16|0}while(0);ba=f[Na>>2]|0;fa=(f[o>>2]|0)==1&(f[X>>2]|0)==1?Ca:Aa;S=0;Z=-2147483648;da=2147483647;while(1){Oa=+p[ba+(S<<3)>>3];_=nrc(Oa)|0;if(+(_|0)!=Oa){oa=123;break}Z=(Z|0)<(_|0)?_:Z;da=(da|0)>(_|0)?_:da;S=S+1|0;if((S|0)>=(fa|0)){oa=120;break}}if((oa|0)==120){fa=(da|0)>-1;if(!(fa&(Z|0)<256))if((da|0)>-129&(Z|0)<128)Pa=1;else Pa=fa&(Z|0)<65536?2:(da|0)>-32769&(Z|0)<32768?3:4;else Pa=0}else if((oa|0)==123){f[m>>2]=6;Pa=za>>>0<4|(za|0)==5?5:6}f[m>>2]=Pa;fa=l+36|0;S=f[fa>>2]|0;if(S|0?(ba=S+12|0,S=f[ba>>2]|0,f[ba>>2]=S+-1,(S|0)==1):0)_S(l);f[fa>>2]=0;fa=l+4|0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;if((f[fa>>2]|0)>0){S=f[l+40>>2]|0;ba=0;do{f[S+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[fa>>2]|0))}fa=f[Ma>>2]|0;if((fa|0)!=(l+48|0))g0(fa);pa=1;qa=xa<<24>>24!=0;ra=ya;sa=za;ta=Aa;ua=6;va=Da;wa=Ea}while(0);do if((g|0)<0){if(X$(d)|0){Qa=c$(d,-1)|0;break}if((ra|0)==(ua|0)|pa)Qa=ra;else{f[l>>2]=0;f[l+4>>2]=0;dJc(tT(l,136)|0,210738,136)|0;z5(-5,l,210672,210209,687)}}else Qa=g;while(0);g=Qa&7;Ea=f[m>>2]|0;do if(!((sa|0)==(Ea|0)&(g|0)==(sa|0))){if(i){m=(Ea|0)>5?Ea:5;Da=(sa|0)<(m|0)?m:sa;Ra=(Da|0)<(g|0)?g:Da;break}if((sa|0)<2&(Ea|0)<2)Sa=3;else Sa=(sa|0)<5&(Ea|0)<5?4:(sa|0)<(Ea|0)?Ea:sa;Da=(Sa|0)<(g|0)?g:Sa;if(g>>>0<5)Ra=(sa|0)<5|(Ea|0)<5?4:Da;else Ra=Da}else Ra=sa;while(0);sa=(ta<<3)+-8|0;Ea=g|sa;g=Ra&7;Sa=g|sa;do if(O)Z$(d,wa,Ea);else{if((c$(e,-1)|0|1|0)!=1){f[l>>2]=0;Ta=l+4|0;f[Ta>>2]=0;Ua=tT(l,64)|0;Ja=Ua;Ka=210875;La=Ja+64|0;do{b[Ja>>0]=b[Ka>>0]|0;Ja=Ja+1|0;Ka=Ka+1|0}while((Ja|0)<(La|0));z5(-215,l,210672,210209,719)}i=wa;if(!(m$(e,i)|0)){f[l>>2]=0;Ta=l+4|0;f[Ta>>2]=0;Ua=tT(l,64)|0;Ja=Ua;Ka=210875;La=Ja+64|0;do{b[Ja>>0]=b[Ka>>0]|0;Ja=Ja+1|0;Ka=Ka+1|0}while((Ja|0)<(La|0));z5(-215,l,210672,210209,719)}if(m$(d,i)|0){Da=(c$(d,-1)|0)==(Ea|0);Z$(d,i,Ea);if(Da)break}else Z$(d,i,Ea);p[q>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=q;f[l+8>>2]=1;f[l+12>>2]=1;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;a0(d,l,r)}while(0);if((ra|0)==(Sa|0))Va=0;else Va=SY(ra,Sa)|0;if((ua|0)!=(ra|0))if((ua|0)==(Sa|0))Wa=0;else Wa=SY(ua,Sa)|0;else Wa=Va;if((Ea|0)==(Sa|0))Xa=0;else Xa=SY(Sa,Ea)|0;Ea=(ra>>>3&511)+1<<(47696>>>(ra<<1&14)&3);ra=(ua>>>3&511)+1<<(47696>>>(ua<<1&14)&3);ua=(sa>>>3&511)+1|0;sa=ua<<(47696>>>(Qa<<1&14)&3);f[l>>2]=sa;Qa=ua<<(47696>>>(Ra<<1&14)&3);Ra=((Qa+1023|0)>>>0)/(Qa>>>0)|0;ua=f_(sa)|0;sa=wa;do if((d$(sa)|0)==65536){wa=f[sa+4>>2]|0;f[q>>2]=f[wa>>2];Ka=q+4|0;Ja=wa+4|0;f[Ka>>2]=f[Ja>>2];La=q+8|0;f[La>>2]=f[wa+8>>2];f[q+12>>2]=f[wa+12>>2];f[q+16>>2]=f[wa+16>>2];f[q+20>>2]=f[wa+20>>2];f[q+24>>2]=f[wa+24>>2];f[q+28>>2]=f[wa+28>>2];f[q+32>>2]=f[wa+32>>2];Ua=f[wa+36>>2]|0;f[q+36>>2]=Ua;f[q+40>>2]=La;La=q+48|0;Ta=q+44|0;f[Ta>>2]=La;f[La>>2]=0;f[q+52>>2]=0;if(Ua|0){La=Ua+12|0;f[La>>2]=(f[La>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[wa+44>>2]|0;La=f[Ta>>2]|0;f[La>>2]=f[Ja>>2];f[La+4>>2]=f[Ja+4>>2];break}else{f[Ka>>2]=0;ZS(q,wa);break}}else a$(q,sa,-1);while(0);sa=va;do if((d$(sa)|0)==65536){va=f[sa+4>>2]|0;f[r>>2]=f[va>>2];wa=r+4|0;Ka=va+4|0;f[wa>>2]=f[Ka>>2];Ja=r+8|0;f[Ja>>2]=f[va+8>>2];f[r+12>>2]=f[va+12>>2];f[r+16>>2]=f[va+16>>2];f[r+20>>2]=f[va+20>>2];f[r+24>>2]=f[va+24>>2];f[r+28>>2]=f[va+28>>2];f[r+32>>2]=f[va+32>>2];La=f[va+36>>2]|0;f[r+36>>2]=La;f[r+40>>2]=Ja;Ja=r+48|0;Ta=r+44|0;f[Ta>>2]=Ja;f[Ja>>2]=0;f[r+52>>2]=0;if(La|0){Ja=La+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}if((f[Ka>>2]|0)<3){Ka=f[va+44>>2]|0;Ja=f[Ta>>2]|0;f[Ja>>2]=f[Ka>>2];f[Ja+4>>2]=f[Ka+4>>2];break}else{f[wa>>2]=0;ZS(r,va);break}}else a$(r,sa,-1);while(0);do if((d$(d)|0)==65536){sa=f[d+4>>2]|0;f[s>>2]=f[sa>>2];va=s+4|0;wa=sa+4|0;f[va>>2]=f[wa>>2];Ka=s+8|0;f[Ka>>2]=f[sa+8>>2];f[s+12>>2]=f[sa+12>>2];f[s+16>>2]=f[sa+16>>2];f[s+20>>2]=f[sa+20>>2];f[s+24>>2]=f[sa+24>>2];f[s+28>>2]=f[sa+28>>2];f[s+32>>2]=f[sa+32>>2];Ja=f[sa+36>>2]|0;f[s+36>>2]=Ja;f[s+40>>2]=Ka;Ka=s+48|0;Ta=s+44|0;f[Ta>>2]=Ka;f[Ka>>2]=0;f[s+52>>2]=0;if(Ja|0){Ka=Ja+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[wa>>2]|0)<3){wa=f[sa+44>>2]|0;Ka=f[Ta>>2]|0;f[Ka>>2]=f[wa>>2];f[Ka+4>>2]=f[wa+4>>2];break}else{f[va>>2]=0;ZS(s,sa);break}}else a$(s,d,-1);while(0);do if((d$(e)|0)==65536){d=f[e+4>>2]|0;f[t>>2]=f[d>>2];sa=t+4|0;va=d+4|0;f[sa>>2]=f[va>>2];wa=t+8|0;f[wa>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];Ka=f[d+36>>2]|0;f[t+36>>2]=Ka;f[t+40>>2]=wa;wa=t+48|0;Ta=t+44|0;f[Ta>>2]=wa;f[wa>>2]=0;f[t+52>>2]=0;if(Ka|0){wa=Ka+12|0;f[wa>>2]=(f[wa>>2]|0)+1}if((f[va>>2]|0)<3){va=f[d+44>>2]|0;wa=f[Ta>>2]|0;f[wa>>2]=f[va>>2];f[wa+4>>2]=f[va+4>>2];break}else{f[sa>>2]=0;ZS(t,d);break}}else a$(t,e,-1);while(0);e=v+8|0;f[v>>2]=e;d=v+4|0;f[d>>2]=1032;sa=(Va|0)!=0;va=(Wa|0)!=0;wa=(Xa|0)!=0;Ta=(pa|va?Qa:0)+(sa?Qa:0)+(wa?Qa:0)+(O?0:f[l>>2]|0)|0;Ka=f[h+(g<<2)>>2]|0;if(pa){f[w>>2]=q;f[w+4>>2]=s;f[w+8>>2]=t;f[w+12>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;z2(y,w,x,-1);pa=f[y+20>>2]|0;g=Ra>>>0<pa>>>0?Ra:pa;h=(Y(g,Ta)|0)+64|0;do if((f[d>>2]|0)>>>0<h>>>0){Ja=f[v>>2]|0;if((Ja|0)!=(e|0)){if(Ja|0)ZDc(Ja);f[v>>2]=e;f[d>>2]=1032}f[d>>2]=h;if(h>>>0<=1032){Ya=e;break}Ja=XDc(h)|0;f[v>>2]=Ja;Ya=Ja}else{f[d>>2]=h;Ya=f[v>>2]|0}while(0);h=Y(g,Qa)|0;Ja=sa?Ya+h+15&-16:Ya;La=sa?Ya:0;Ya=Ja+h+15&-16;Ua=O?Ya:wa?Ya+h+15&-16:Ya;cL(r,Sa,Ja,g);Sa=y+16|0;h=(pa|0)==0;Da=Ja;Ja=x+4|0;m=F+4|0;Aa=La;za=wa|P;ya=G+4|0;xa=I+4|0;Ma=x+8|0;Na=J+4|0;Pa=H+4|0;oa=0;while(1){if(oa>>>0>=(f[Sa>>2]|0)>>>0)break;if(!h){Ca=0;o=f[x>>2]|0;Ia=f[Ja>>2]|0;do{Ha=pa-Ca|0;Ba=Ha>>>0>g>>>0?g:Ha;Ha=Y(Ba,ta)|0;if(sa){f[F>>2]=Ha;f[m>>2]=1;wi[Va&255](o,1,0,1,La,1,F,0);Za=Aa}else Za=o;Ga=qa?Da:Za;Fa=qa?Za:Da;do if(za){Li[Ka&127](Ga,1,Fa,1,Ya,1,Ha,1,j);if(O){f[G>>2]=Ha;f[ya>>2]=1;wi[Xa&255](Ya,1,0,1,Ia,1,G,0);break}if(wa){f[I>>2]=Ha;f[xa>>2]=1;wi[Xa&255](Ya,1,0,1,Ua,1,I,0);K=f[Ma>>2]|0;f[J>>2]=Ba;f[Na>>2]=1;wi[ua&255](Ua,1,K,1,Ia,1,J,l)}else{K=f[Ma>>2]|0;f[H>>2]=Ba;f[Pa>>2]=1;wi[ua&255](Ya,1,K,1,Ia,1,H,l)}f[Ma>>2]=(f[Ma>>2]|0)+Ba}else Li[Ka&127](Ga,1,Fa,1,Ia,1,Ha,1,j);while(0);Ha=Y(Ba,Ea)|0;o=(f[x>>2]|0)+Ha|0;f[x>>2]=o;Ha=Y(f[l>>2]|0,Ba)|0;Ia=(f[Ja>>2]|0)+Ha|0;f[Ja>>2]=Ia;Ca=Ca+g|0}while(pa>>>0>Ca>>>0)}A2(y)|0;oa=oa+1|0}}else{f[w>>2]=q;f[w+4>>2]=r;f[w+8>>2]=s;f[w+12>>2]=t;f[w+16>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;z2(y,w,x,-1);w=f[y+20>>2]|0;oa=(sa|P|va|wa)&Ra>>>0<w>>>0?Ra:w;Ra=(Y(oa,Ta)|0)+64|0;do if((f[d>>2]|0)>>>0<Ra>>>0){Ta=f[v>>2]|0;if((Ta|0)!=(e|0)){if(Ta|0)ZDc(Ta);f[v>>2]=e;f[d>>2]=1032}f[d>>2]=Ra;if(Ra>>>0<=1032){_a=e;break}Ta=XDc(Ra)|0;f[v>>2]=Ta;_a=Ta}else{f[d>>2]=Ra;_a=f[v>>2]|0}while(0);Ra=Y(oa,Qa)|0;Qa=sa?_a+Ra+15&-16:_a;Ta=sa?_a:0;pa=va?Qa+Ra+15&-16:Qa;g=va?Qa:0;Qa=O?pa:wa?pa+Ra+15&-16:pa;Ra=y+16|0;Ja=(w|0)==0;Ma=x+4|0;H=x+8|0;Ya=z+4|0;Pa=va^1;va=wa|P;P=B+4|0;J=D+4|0;Ua=x+12|0;Na=E+4|0;I=C+4|0;xa=A+4|0;G=0;while(1){if(G>>>0>=(f[Ra>>2]|0)>>>0)break;if(!Ja){ya=0;za=f[x>>2]|0;Da=f[Ma>>2]|0;Za=f[H>>2]|0;do{qa=w-ya|0;Aa=qa>>>0>oa>>>0?oa:qa;qa=Y(Aa,ta)|0;if(sa){f[z>>2]=qa;f[Ya>>2]=1;wi[Va&255](za,1,0,1,Ta,1,z,0);$a=_a;ab=f[x>>2]|0;bb=f[Ma>>2]|0}else{$a=za;ab=za;bb=Da}F=(ab|0)==(bb|0);if(F|Pa)cb=F?$a:Da;else{f[A>>2]=qa;f[xa>>2]=1;wi[Wa&255](Da,1,0,1,g,1,A,0);cb=g}do if(va){Li[Ka&127]($a,1,cb,1,pa,0,qa,1,j);if(O){f[B>>2]=qa;f[P>>2]=1;wi[Xa&255](pa,1,0,1,Za,1,B,0);break}if(wa){f[D>>2]=qa;f[J>>2]=1;wi[Xa&255](pa,1,0,1,Qa,1,D,0);F=f[Ua>>2]|0;f[E>>2]=Aa;f[Na>>2]=1;wi[ua&255](Qa,1,F,1,Za,1,E,l)}else{F=f[Ua>>2]|0;f[C>>2]=Aa;f[I>>2]=1;wi[ua&255](pa,1,F,1,Za,1,C,l)}f[Ua>>2]=(f[Ua>>2]|0)+Aa}else Li[Ka&127]($a,1,cb,1,Za,1,qa,1,j);while(0);qa=Y(Aa,Ea)|0;za=(f[x>>2]|0)+qa|0;f[x>>2]=za;qa=Y(Aa,ra)|0;Da=(f[Ma>>2]|0)+qa|0;f[Ma>>2]=Da;qa=Y(f[l>>2]|0,Aa)|0;Za=(f[H>>2]|0)+qa|0;f[H>>2]=Za;ya=ya+oa|0}while(w>>>0>ya>>>0)}A2(y)|0;G=G+1|0}}G=f[v>>2]|0;if((G|0)!=(e|0)){if(G|0)ZDc(G);f[v>>2]=e;f[d>>2]=1032}d=t+36|0;e=f[d>>2]|0;do if(e|0){v=e+12|0;G=f[v>>2]|0;f[v>>2]=G+-1;if((G|0)!=1)break;_S(t)}while(0);f[d>>2]=0;d=t+16|0;e=t+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[t+40>>2]|0;G=0;do{f[d+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[e>>2]|0))}e=f[t+44>>2]|0;if((e|0)!=(t+48|0))g0(e);e=s+36|0;t=f[e>>2]|0;do if(t|0){G=t+12|0;d=f[G>>2]|0;f[G>>2]=d+-1;if((d|0)!=1)break;_S(s)}while(0);f[e>>2]=0;e=s+16|0;t=s+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[t>>2]|0)>0){e=f[s+40>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))g0(t);t=r+36|0;s=f[t>>2]|0;do if(s|0){d=s+12|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1)break;_S(r)}while(0);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;e=0;do{f[t+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))g0(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){e=r+12|0;t=f[e>>2]|0;f[e>>2]=t+-1;if((t|0)!=1)break;_S(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))g0(r);u=k;return}function oL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nL(a,b,c,d,e,34080,0,0,1);return}function pL(a,b,c){a=a|0;b=b|0;c=c|0;nL(a,b,c,e0()|0,-1,34112,0,0,3);return}function qL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,i=0;f=u;u=u+16|0;g=f;p[g>>3]=d;h=e0()|0;i=+L(+(d+-1.0))<2.220446049250313e-16;nL(a,b,c,h,e,34144,1,g,i?4:5);u=f;return}function rL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0;f=u;u=u+16|0;g=f;p[g>>3]=d;nL(a,b,c,e0()|0,e,34176,1,g,6);u=f;return}function sL(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+16|0;f=e;p[f>>3]=a;nL(b,b,c,e0()|0,d,34208,1,f,7);u=e;return}function tL(a,b,c,d,e,f,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,i=0;h=u;u=u+32|0;i=h;p[i>>3]=b;p[i+8>>3]=d;p[i+16>>3]=e;nL(a,c,f,e0()|0,g,34240,1,i,8);u=h;return}function uL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0;g=u;u=u+1456|0;h=g+1392|0;i=g+1384|0;j=g+1264|0;k=g+1376|0;l=g+1208|0;m=g+1192|0;n=g+1320|0;o=g+96|0;q=g+1152|0;r=g+112|0;s=g+88|0;t=g+1184|0;v=g+56|0;w=g;f[i>>2]=e;if(e>>>0>=6){f[h>>2]=0;f[h+4>>2]=0;x=tT(h,92)|0;y=210940;z=x+92|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,h,211033,210209,1238)}e=r$(a)|0;if(e^(r$(c)|0)){f[h>>2]=0;f[h+4>>2]=0;x=tT(h,30)|0;y=211041;z=x+30|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,h,211033,210209,1240)}if(r$(a)|0?r$(c)|0:0){u$(d);u=g;return}y=(d$(a)|0)==131072&1;if(((((d$(c)|0)==131072&1)+y|0)!=1?m$(a,c)|0:0)?(y=c$(a,-1)|0,(y|0)==(c$(c,-1)|0)):0)A=0;else B=11;do if((B|0)==11){y=c$(c,-1)|0;x=d$(a)|0;z=d$(c)|0;if((n$(a,-1)|0)<=2?s$(a,-1)|0:0){b$(h,a,-1);e=f[h>>2]|0;C=(e|0)==1;if(!C?(f[h+4>>2]|0)!=1:0)D=0;else{E=(y>>>3&511)+1|0;if(!((x|0)!=131072&(z|0)==131072)){z=f[h+4>>2]|0;x=(z|0)==1;if(!((e|0)==(E|0)&x|C&(x|(z|0)==(E|0))))if(C&(z|0)==4)D=E>>>0<5&(c$(a,-1)|0)==6;else D=0;else D=1}else D=0}F=D}else F=0;E=c$(a,-1)|0;z=d$(c)|0;C=d$(a)|0;if((n$(c,-1)|0)<=2?s$(c,-1)|0:0){b$(h,c,-1);x=f[h>>2]|0;e=(x|0)==1;if(!e?(f[h+4>>2]|0)!=1:0)G=0;else{y=(E>>>3&511)+1|0;if(!((z|0)!=131072&(C|0)==131072)){C=f[h+4>>2]|0;z=(C|0)==1;if(!((x|0)==(y|0)&z|e&(z|(C|0)==(y|0))))if(e&(C|0)==4)G=y>>>0<5&(c$(c,-1)|0)==6;else G=0;else G=1}else G=0}H=G}else H=0;if(H|F^1){if(F^H){A=1;break}f[h>>2]=0;f[h+4>>2]=0;dJc(tT(h,139)|0,211072,139)|0;z5(-209,h,211033,210209,1267)}y=f[i>>2]|0;switch(y|0){case 3:{I=1;break}case 4:{I=2;break}case 2:{I=4;break}default:I=(y|0)==1?3:y}f[i>>2]=I;uL(c,a,d,I);u=g;return}while(0);I=d$(a)|0;H=d$(c)|0;do if((d$(a)|0)==65536){F=f[a+4>>2]|0;f[h>>2]=f[F>>2];G=h+4|0;D=F+4|0;f[G>>2]=f[D>>2];y=h+8|0;f[y>>2]=f[F+8>>2];f[h+12>>2]=f[F+12>>2];f[h+16>>2]=f[F+16>>2];f[h+20>>2]=f[F+20>>2];f[h+24>>2]=f[F+24>>2];f[h+28>>2]=f[F+28>>2];f[h+32>>2]=f[F+32>>2];C=f[F+36>>2]|0;f[h+36>>2]=C;f[h+40>>2]=y;y=h+48|0;e=h+44|0;f[e>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(C|0){y=C+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[D>>2]|0)<3){D=f[F+44>>2]|0;y=f[e>>2]|0;f[y>>2]=f[D>>2];f[y+4>>2]=f[D+4>>2];break}else{f[G>>2]=0;ZS(h,F);break}}else a$(h,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];F=j+4|0;G=a+4|0;f[F>>2]=f[G>>2];D=j+8|0;f[D>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[j+36>>2]=y;f[j+40>>2]=D;D=j+48|0;e=j+44|0;f[e>>2]=D;f[D>>2]=0;f[j+52>>2]=0;if(y|0){D=y+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[G>>2]|0)<3){G=f[a+44>>2]|0;D=f[e>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=f[G+4>>2];break}else{f[F>>2]=0;ZS(j,a);break}}else a$(j,c,-1);while(0);c=h+4|0;a=f[c>>2]|0;if(((I|0)==(H|0)&(a|0)<3?(f[j+4>>2]|0)<3:0)?(H=h+40|0,I=f[H>>2]|0,F=f[I+4>>2]|0,G=f[I>>2]|0,D=f[j+40>>2]|0,(G|0)==(f[D>>2]|0)?(F|0)==(f[D+4>>2]|0):0):0){D=f[h>>2]|0;e=f[j>>2]|0;y=(D>>>3&511)+1|0;if(!((e^D)&4095)){f[k>>2]=F;f[k+4>>2]=G;v$(d,k,(y<<3)+-8|0,-1,0,0);do if((d$(d)|0)==65536){k=f[d+4>>2]|0;f[l>>2]=f[k>>2];G=l+4|0;F=k+4|0;f[G>>2]=f[F>>2];C=l+8|0;f[C>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];z=f[k+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=C;C=l+48|0;x=l+44|0;f[x>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(z|0){C=z+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[F>>2]|0)<3){F=f[k+44>>2]|0;C=f[x>>2]|0;f[C>>2]=f[F>>2];f[C+4>>2]=f[F+4>>2];break}else{f[G>>2]=0;ZS(l,k);break}}else a$(l,d,-1);while(0);sT(m,h,j,l,((f[h>>2]|0)>>>3&511)+1|0);k=l+16|0;G=l+44|0;F=l+48|0;Li[f[34272+((f[h>>2]&7)<<2)>>2]&127](f[h+16>>2]|0,f[h+48>>2]|0,f[j+16>>2]|0,f[j+48>>2]|0,f[k>>2]|0,f[F>>2]|0,f[m>>2]|0,f[m+4>>2]|0,i);C=l+36|0;x=f[C>>2]|0;if(x|0?(z=x+12|0,x=f[z>>2]|0,f[z>>2]=x+-1,(x|0)==1):0)_S(l);f[C>>2]=0;C=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[C>>2]|0)>0){k=f[l+40>>2]|0;x=0;do{f[k+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[C>>2]|0))}C=f[G>>2]|0;if((C|0)!=(F|0))g0(C);J=j+36|0}else{K=j;L=H;M=D;N=e;O=y;P=I;Q=h;B=72}}else{I=f[h>>2]|0;y=h+40|0;K=j;L=y;M=I;N=f[j>>2]|0;O=(I>>>3&511)+1|0;P=f[y>>2]|0;Q=h;B=72}if((B|0)==72){y=M&7;M=N&7;w$(d,a,P,(O<<3)+-8|0,-1,0,0);lT(l,h,1,0);O=l+36|0;P=f[O>>2]|0;if(P|0){a=P+12|0;f[a>>2]=(f[a>>2]|0)+1}a=h+36|0;P=f[a>>2]|0;if(P|0?(N=P+12|0,P=f[N>>2]|0,f[N>>2]=P+-1,(P|0)==1):0)_S(h);f[a>>2]=0;P=h+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[c>>2]|0)>0){N=f[L>>2]|0;L=0;do{f[N+(L<<2)>>2]=0;L=L+1|0;R=f[c>>2]|0}while((L|0)<(R|0));f[Q>>2]=f[l>>2];if((R|0)<3)B=82;else B=84}else{f[Q>>2]=f[l>>2];B=82}if((B|0)==82){Q=f[l+4>>2]|0;if((Q|0)<3){f[c>>2]=Q;f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];Q=f[l+44>>2]|0;R=f[h+44>>2]|0;f[R>>2]=f[Q>>2];f[R+4>>2]=f[Q+4>>2]}else B=84}if((B|0)==84)ZS(h,l);Q=l+16|0;f[P>>2]=f[Q>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];P=f[O>>2]|0;f[a>>2]=P;if(P|0?(a=P+12|0,P=f[a>>2]|0,f[a>>2]=P+-1,(P|0)==1):0)_S(l);f[O>>2]=0;O=l+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[O>>2]|0)>0){Q=f[l+40>>2]|0;P=0;do{f[Q+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[O>>2]|0))}O=f[l+44>>2]|0;if((O|0)!=(l+48|0))g0(O);lT(l,j,1,0);O=l+36|0;P=f[O>>2]|0;if(P|0){Q=P+12|0;f[Q>>2]=(f[Q>>2]|0)+1}Q=j+36|0;P=f[Q>>2]|0;if(P|0?(a=P+12|0,P=f[a>>2]|0,f[a>>2]=P+-1,(P|0)==1):0)_S(j);f[Q>>2]=0;P=j+16|0;a=j+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[a>>2]|0)>0){R=f[j+40>>2]|0;L=0;do{f[R+(L<<2)>>2]=0;L=L+1|0;S=f[a>>2]|0}while((L|0)<(S|0));f[K>>2]=f[l>>2];if((S|0)<3)B=103;else B=105}else{f[K>>2]=f[l>>2];B=103}if((B|0)==103){K=f[l+4>>2]|0;if((K|0)<3){f[a>>2]=K;f[j+8>>2]=f[l+8>>2];f[j+12>>2]=f[l+12>>2];K=f[l+44>>2]|0;a=f[j+44>>2]|0;f[a>>2]=f[K>>2];f[a+4>>2]=f[K+4>>2]}else B=105}if((B|0)==105)ZS(j,l);K=l+16|0;f[P>>2]=f[K>>2];f[j+20>>2]=f[l+20>>2];f[j+24>>2]=f[l+24>>2];f[j+28>>2]=f[l+28>>2];f[j+32>>2]=f[l+32>>2];a=f[O>>2]|0;f[Q>>2]=a;if(a|0?(S=a+12|0,a=f[S>>2]|0,f[S>>2]=a+-1,(a|0)==1):0)_S(l);f[O>>2]=0;O=l+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[O>>2]|0)>0){K=f[l+40>>2]|0;a=0;do{f[K+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[O>>2]|0))}O=f[l+44>>2]|0;if((O|0)!=(l+48|0))g0(O);do if((d$(d)|0)==65536){O=f[d+4>>2]|0;f[n>>2]=f[O>>2];a=n+4|0;K=O+4|0;f[a>>2]=f[K>>2];S=n+8|0;f[S>>2]=f[O+8>>2];f[n+12>>2]=f[O+12>>2];f[n+16>>2]=f[O+16>>2];f[n+20>>2]=f[O+20>>2];f[n+24>>2]=f[O+24>>2];f[n+28>>2]=f[O+28>>2];f[n+32>>2]=f[O+32>>2];L=f[O+36>>2]|0;f[n+36>>2]=L;f[n+40>>2]=S;S=n+48|0;R=n+44|0;f[R>>2]=S;f[S>>2]=0;f[n+52>>2]=0;if(L|0){S=L+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[K>>2]|0)<3){K=f[O+44>>2]|0;S=f[R>>2]|0;f[S>>2]=f[K>>2];f[S+4>>2]=f[K+4>>2];break}else{f[a>>2]=0;ZS(n,O);break}}else a$(n,d,-1);while(0);lT(l,n,1,0);d=n+36|0;O=f[d>>2]|0;do if(O|0){a=O+12|0;K=f[a>>2]|0;f[a>>2]=K+-1;if((K|0)!=1)break;_S(n)}while(0);f[d>>2]=0;d=n+16|0;O=n+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[O>>2]|0)>0){d=f[n+40>>2]|0;K=0;do{f[d+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[O>>2]|0))}O=f[n+44>>2]|0;if((O|0)!=(n+48|0))g0(O);O=f[c>>2]|0;if((O|0)>0)T=f[(f[h+44>>2]|0)+(O+-1<<2)>>2]|0;else T=0;O=(T|0)==0?1:T;T=((O+1023|0)>>>0)/(O>>>0)|0;c=f[34272+(y<<2)>>2]|0;if(A){f[m>>2]=h;f[m+4>>2]=l;f[m+8>>2]=0;A=o;f[A>>2]=0;f[A+4>>2]=0;z2(q,m,o,-1);A=f[q+20>>2]|0;n=T>>>0<A>>>0?T:A;T=Y(n,O)|0;K=r+8|0;f[r>>2]=K;d=r+4|0;f[d>>2]=T;if(T>>>0>1032){a=XDc(T)|0;f[r>>2]=a;U=a}else U=K;a:do if(y>>>0>4){cL(j,y,U,n);B=159}else{p[s>>3]=0.0;a=SY(M,6)|0;T=f[P>>2]|0;f[t>>2]=1;f[t+4>>2]=1;wi[a&255](T,1,0,1,s,1,t,0);V=+p[s>>3];do if(V<+p[5952+(y<<3)>>3]){T=f[i>>2]|0;W=(T|0)==5|(T+-1|0)>>>0<2?255.0:0.0;p[v>>3]=W;p[v+8>>3]=W;p[v+16>>3]=W;p[v+24>>3]=W;k_(l,v)|0}else{if(V>+p[6016+(y<<3)>>3]){W=((f[i>>2]|0)+-3|0)>>>0<3?255.0:0.0;p[v>>3]=W;p[v+8>>3]=W;p[v+16>>3]=W;p[v+24>>3]=W;k_(l,v)|0;break}T=nrc(V)|0;f[v>>2]=T;b:do if(V!=+(T|0)){a=f[i>>2]|0;if((a|1|0)==3){S=~~V;f[v>>2]=(+(S|0)<V&1)+S;break}switch(a|0){case 1:case 4:{S=~~V;f[v>>2]=S-(+(S|0)>V&1);break b;break}default:{W=(a|0)==5?255.0:0.0;p[w>>3]=W;p[w+8>>3]=W;p[w+16>>3]=W;p[w+24>>3]=W;k_(l,w)|0;break a}}}while(0);f[w>>2]=1124007940;T=w+4|0;f[T>>2]=2;a=w+8|0;f[a>>2]=1;f[w+12>>2]=1;S=w+16|0;f[S>>2]=v;f[w+20>>2]=v;R=w+24|0;L=w+40|0;N=R+8|0;f[N>>2]=0;f[N+4>>2]=0;f[L>>2]=a;a=w+48|0;N=w+44|0;f[N>>2]=a;f[a>>2]=4;f[w+52>>2]=4;I=v+4|0;f[w+28>>2]=I;f[R>>2]=I;WS(w);cL(w,y,U,n);I=w+36|0;R=f[I>>2]|0;do if(R|0){e=R+12|0;D=f[e>>2]|0;f[e>>2]=D+-1;if((D|0)!=1)break;_S(w)}while(0);f[I>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[T>>2]|0)>0){R=f[L>>2]|0;D=0;do{f[R+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[T>>2]|0))}T=f[N>>2]|0;if((T|0)!=(a|0))g0(T);B=159;break a}while(0)}while(0);c:do if((B|0)==159){w=q+16|0;y=o+4|0;if(!A){v=0;while(1){if(v>>>0>=(f[w>>2]|0)>>>0)break c;A2(q)|0;v=v+1|0}}else X=0;while(1){if(X>>>0>=(f[w>>2]|0)>>>0)break c;v=0;s=f[o>>2]|0;t=f[y>>2]|0;do{P=A-v|0;M=P>>>0>n>>>0?n:P;Li[c&127](s,0,U,0,t,0,M,1,i);P=Y(M,O)|0;s=(f[o>>2]|0)+P|0;f[o>>2]=s;t=(f[y>>2]|0)+M|0;f[y>>2]=t;v=v+n|0}while(A>>>0>v>>>0);A2(q)|0;X=X+1|0}}while(0);X=f[r>>2]|0;if((X|0)!=(K|0)){if(X|0)ZDc(X);f[r>>2]=K;f[d>>2]=1032}}else{f[m>>2]=h;f[m+4>>2]=j;f[m+8>>2]=l;f[m+12>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;z2(q,m,o,-1);m=f[q+20>>2]|0;d=q+16|0;K=o+4|0;r=o+8|0;X=0;while(1){if(X>>>0>=(f[d>>2]|0)>>>0)break;Li[c&127](f[o>>2]|0,0,f[K>>2]|0,0,f[r>>2]|0,0,m,1,i);A2(q)|0;X=X+1|0}}X=l+36|0;q=f[X>>2]|0;do if(q|0){i=q+12|0;m=f[i>>2]|0;f[i>>2]=m+-1;if((m|0)!=1)break;_S(l)}while(0);f[X>>2]=0;X=l+16|0;q=l+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[q>>2]|0)>0){X=f[l+40>>2]|0;m=0;do{f[X+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[q>>2]|0))}q=f[l+44>>2]|0;if((q|0)!=(l+48|0))g0(q);J=Q}Q=f[J>>2]|0;if(Q|0?(q=Q+12|0,Q=f[q>>2]|0,f[q>>2]=Q+-1,(Q|0)==1):0)_S(j);f[J>>2]=0;J=j+16|0;Q=j+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[Q>>2]|0)>0){J=f[j+40>>2]|0;q=0;do{f[J+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[Q>>2]|0))}Q=f[j+44>>2]|0;if((Q|0)!=(j+48|0))g0(Q);Q=h+36|0;j=f[Q>>2]|0;if(j|0?(q=j+12|0,j=f[q>>2]|0,f[q>>2]=j+-1,(j|0)==1):0)_S(h);f[Q>>2]=0;Q=h+16|0;j=h+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[j>>2]|0)>0){Q=f[h+40>>2]|0;q=0;do{f[Q+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[j>>2]|0))}j=f[h+44>>2]|0;if((j|0)!=(h+48|0))g0(j);u=g;return}function vL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;g=u;u=u+1424|0;h=g+1368|0;i=g+1312|0;j=g+1256|0;k=g+1200|0;l=g+1188|0;m=g+1168|0;n=g+1144|0;o=g+1104|0;q=g+56|0;r=g;s=g+1160|0;t=g+1136|0;v=g+1096|0;if(r$(a)|0){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,14)|0;x=211212;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,h,211227,210209,1766)}z=d$(a)|0;A=d$(c)|0;B=d$(d)|0;do if((d$(a)|0)==65536){C=f[a+4>>2]|0;f[h>>2]=f[C>>2];D=h+4|0;E=C+4|0;f[D>>2]=f[E>>2];F=h+8|0;f[F>>2]=f[C+8>>2];f[h+12>>2]=f[C+12>>2];f[h+16>>2]=f[C+16>>2];f[h+20>>2]=f[C+20>>2];f[h+24>>2]=f[C+24>>2];f[h+28>>2]=f[C+28>>2];f[h+32>>2]=f[C+32>>2];G=f[C+36>>2]|0;f[h+36>>2]=G;f[h+40>>2]=F;F=h+48|0;H=h+44|0;f[H>>2]=F;f[F>>2]=0;f[h+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;F=f[H>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[D>>2]=0;ZS(h,C);break}}else a$(h,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];C=i+4|0;D=a+4|0;f[C>>2]=f[D>>2];E=i+8|0;f[E>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];F=f[a+36>>2]|0;f[i+36>>2]=F;f[i+40>>2]=E;E=i+48|0;H=i+44|0;f[H>>2]=E;f[E>>2]=0;f[i+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[a+44>>2]|0;E=f[H>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];break}else{f[C>>2]=0;ZS(i,a);break}}else a$(i,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[j>>2]=f[c>>2];a=j+4|0;C=c+4|0;f[a>>2]=f[C>>2];D=j+8|0;f[D>>2]=f[c+8>>2];f[j+12>>2]=f[c+12>>2];f[j+16>>2]=f[c+16>>2];f[j+20>>2]=f[c+20>>2];f[j+24>>2]=f[c+24>>2];f[j+28>>2]=f[c+28>>2];f[j+32>>2]=f[c+32>>2];E=f[c+36>>2]|0;f[j+36>>2]=E;f[j+40>>2]=D;D=j+48|0;H=j+44|0;f[H>>2]=D;f[D>>2]=0;f[j+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[c+44>>2]|0;D=f[H>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[a>>2]=0;ZS(j,c);break}}else a$(j,d,-1);while(0);d=(z|0)!=131072;a:do if(!(d&(A|0)==131072)?(c=f[h+40>>2]|0,a=f[c+-4>>2]|0,C=f[i+40>>2]|0,(a|0)==(f[C+-4>>2]|0)):0){if((a|0)==2){if((f[c>>2]|0)!=(f[C>>2]|0)){I=33;break}if((f[c+4>>2]|0)!=(f[C+4>>2]|0)){I=33;break}}else if((a|0)>0){D=0;do{if((f[c+(D<<2)>>2]|0)!=(f[C+(D<<2)>>2]|0)){I=33;break a}D=D+1|0}while((D|0)<(a|0))}a=f[h>>2]|0;if(!((f[i>>2]^a)&4095)){J=0;K=a}else I=33}else I=33;while(0);if((I|0)==33){a=f[h>>2]|0;if((f[i+4>>2]|0)>2){f[k>>2]=0;L=k+4|0;f[L>>2]=0;M=tT(k,90)|0;w=M;x=211235;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1782)}D=f[i>>2]|0;if(!(D&16384)){f[k>>2]=0;L=k+4|0;f[L>>2]=0;M=tT(k,90)|0;w=M;x=211235;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1782)}C=f[i+40>>2]|0;c=f[C+4>>2]|0;H=f[C>>2]|0;C=(c|0)==1;E=(H|0)==1;if(!(C|E)){f[k>>2]=0;L=k+4|0;f[L>>2]=0;M=tT(k,90)|0;w=M;x=211235;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1782)}F=(a>>>3&511)+1|0;if((z|0)==131072&(A|0)!=131072){f[k>>2]=0;L=k+4|0;f[L>>2]=0;M=tT(k,90)|0;w=M;x=211235;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1782)}if(!((c|0)==(F|0)&E|C&(E|(H|0)==(F|0)))?F>>>0>4|(D&4095|0)!=6|C&(H|0)==4^1:0){f[k>>2]=0;L=k+4|0;f[L>>2]=0;M=tT(k,90)|0;w=M;x=211235;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1782)}else{J=1;K=a}}b:do if(!(d&(B|0)==131072)?(a=f[h+40>>2]|0,M=f[a+-4>>2]|0,L=f[j+40>>2]|0,(M|0)==(f[L+-4>>2]|0)):0){if((M|0)==2){if((f[a>>2]|0)!=(f[L>>2]|0)){I=49;break}if((f[a+4>>2]|0)!=(f[L+4>>2]|0)){I=49;break}}else if((M|0)>0){H=0;do{if((f[a+(H<<2)>>2]|0)!=(f[L+(H<<2)>>2]|0)){I=49;break b}H=H+1|0}while((H|0)<(M|0))}if(!((f[j>>2]^K)&4095))if(J){f[k>>2]=0;N=k+4|0;f[N>>2]=0;O=tT(k,20)|0;w=O;x=211417;y=w+20|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,k,211227,210209,1795)}else{M=K>>>3;H=M&511;P=0;Q=M;R=H;S=H+1|0;T=h;U=0;V=0;break}else I=49}else I=49;while(0);if((I|0)==49){if((f[j+4>>2]|0)>2){f[k>>2]=0;W=k+4|0;f[W>>2]=0;X=tT(k,90)|0;w=X;x=211326;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1791)}d=f[j>>2]|0;if(!(d&16384)){f[k>>2]=0;W=k+4|0;f[W>>2]=0;X=tT(k,90)|0;w=X;x=211326;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1791)}H=f[j+40>>2]|0;M=f[H+4>>2]|0;L=f[H>>2]|0;H=(M|0)==1;a=(L|0)==1;if(!(H|a)){f[k>>2]=0;W=k+4|0;f[W>>2]=0;X=tT(k,90)|0;w=X;x=211326;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1791)}C=K>>>3;D=C&511;F=D+1|0;if((z|0)==131072&(B|0)!=131072){f[k>>2]=0;W=k+4|0;f[W>>2]=0;X=tT(k,90)|0;w=X;x=211326;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1791)}if(!((M|0)==(F|0)&a|H&(a|(L|0)==(F|0)))?F>>>0>4|(d&4095|0)!=6|H&(L|0)==4^1:0){f[k>>2]=0;W=k+4|0;f[W>>2]=0;X=tT(k,90)|0;w=X;x=211326;y=w+90|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-209,k,211227,210209,1791)}if(J){P=1;Q=C;R=D;S=F;T=h;U=1;V=J&1}else{f[k>>2]=0;N=k+4|0;f[N>>2]=0;O=tT(k,20)|0;w=O;x=211417;y=w+20|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,k,211227,210209,1795)}}O=K&7;K=h+4|0;N=f[K>>2]|0;if((N|0)>0)Z=f[(f[h+44>>2]|0)+(N+-1<<2)>>2]|0;else Z=0;F=((Z+1023|0)>>>0)/(Z>>>0)|0;D=h+40|0;w$(e,N,f[D>>2]|0,0,-1,0,0);do if((d$(e)|0)==65536){N=f[e+4>>2]|0;f[k>>2]=f[N>>2];C=k+4|0;X=N+4|0;f[C>>2]=f[X>>2];W=k+8|0;f[W>>2]=f[N+8>>2];f[k+12>>2]=f[N+12>>2];f[k+16>>2]=f[N+16>>2];f[k+20>>2]=f[N+20>>2];f[k+24>>2]=f[N+24>>2];f[k+28>>2]=f[N+28>>2];f[k+32>>2]=f[N+32>>2];L=f[N+36>>2]|0;f[k+36>>2]=L;f[k+40>>2]=W;W=k+48|0;H=k+44|0;f[H>>2]=W;f[W>>2]=0;f[k+52>>2]=0;if(L|0){W=L+12|0;f[W>>2]=(f[W>>2]|0)+1}if((f[X>>2]|0)<3){X=f[N+44>>2]|0;W=f[H>>2]|0;f[W>>2]=f[X>>2];f[W+4>>2]=f[X+4>>2];break}else{f[C>>2]=0;ZS(k,N);break}}else a$(k,e,-1);while(0);e=f[34304+(O<<2)>>2]|0;f[l>>2]=h;f[l+4>>2]=k;f[l+8>>2]=0;f[m>>2]=h;f[m+4>>2]=k;f[m+8>>2]=i;f[m+12>>2]=j;f[m+16>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;N=J&P;z2(o,N?l:m,n,-1);m=f[o+20>>2]|0;l=F>>>0<m>>>0?F:m;F=(S<<3)+128+(Y(l,(Y(Z,V+U|0)|0)+S|0)|0)|0;U=q+8|0;f[q>>2]=U;V=q+4|0;f[V>>2]=F;if(F>>>0>1032){C=XDc(F)|0;f[q>>2]=C;_=C}else _=U;C=_+(Y(l,S)|0)+15&-16;if(N){N=Y(l,Z)|0;F=C+N+15&-16;X=f[i>>2]|0;if((f[j>>2]^X)&4095|0){f[r>>2]=0;f[r+4>>2]=0;w=tT(r,22)|0;x=211438;y=w+22|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,r,211227,210209,1822)}x=X&7;if(O>>>0<4&(x|0)!=(O|0)){X=F+N+15&-16;N=X;w=X;X=w+(S<<2)|0;y=SY(x,4)|0;x=i+16|0;W=f[x>>2]|0;H=i+44|0;f[s>>2]=S;f[s+4>>2]=1;wi[y&255](W,1,0,1,N,1,s,0);s=j+16|0;W=f[s>>2]|0;L=j+44|0;f[t>>2]=S;f[t+4>>2]=1;wi[y&255](W,1,0,1,X,1,t,0);t=nrc(+p[5952+(O<<3)>>3])|0;W=nrc(+p[6016+(O<<3)>>3])|0;O=t+1|0;y=0;do{d=w+(y<<2)|0;a=f[d>>2]|0;M=X+(y<<2)|0;B=f[M>>2]|0;if((B|0)<(t|0)|((a|0)>(W|0)|(a|0)>(B|0))){f[d>>2]=O;f[M>>2]=t}y=y+1|0}while((y|0)!=(S|0));Vj(r,S,1,4,N,0);N=r+36|0;y=f[N>>2]|0;if(y|0){t=y+12|0;f[t>>2]=(f[t>>2]|0)+1}t=i+36|0;y=f[t>>2]|0;if(y|0?(O=y+12|0,y=f[O>>2]|0,f[O>>2]=y+-1,(y|0)==1):0)_S(i);f[t>>2]=0;y=i+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[y>>2]|0)>0){O=f[i+40>>2]|0;W=0;do{f[O+(W<<2)>>2]=0;W=W+1|0;$=f[y>>2]|0}while((W|0)<($|0));f[i>>2]=f[r>>2];if(($|0)<3)I=89;else I=91}else{f[i>>2]=f[r>>2];I=89}if((I|0)==89){$=f[r+4>>2]|0;if(($|0)<3){f[y>>2]=$;f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];$=f[r+44>>2]|0;y=f[H>>2]|0;f[y>>2]=f[$>>2];f[y+4>>2]=f[$+4>>2]}else I=91}if((I|0)==91)ZS(i,r);$=r+16|0;f[x>>2]=f[$>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[i+28>>2]=f[r+28>>2];f[i+32>>2]=f[r+32>>2];x=f[N>>2]|0;f[t>>2]=x;if(x|0?(t=x+12|0,x=f[t>>2]|0,f[t>>2]=x+-1,(x|0)==1):0)_S(r);f[N>>2]=0;N=r+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[N>>2]|0)>0){$=f[r+40>>2]|0;x=0;do{f[$+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[N>>2]|0))}N=f[r+44>>2]|0;if((N|0)!=(r+48|0))g0(N);Vj(r,S,1,4,X,0);X=r+36|0;N=f[X>>2]|0;if(N|0){x=N+12|0;f[x>>2]=(f[x>>2]|0)+1}x=j+36|0;N=f[x>>2]|0;do if(N|0){$=N+12|0;t=f[$>>2]|0;f[$>>2]=t+-1;if((t|0)!=1)break;_S(j)}while(0);f[x>>2]=0;N=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[N>>2]|0)>0){t=f[j+40>>2]|0;$=0;do{f[t+($<<2)>>2]=0;$=$+1|0;aa=f[N>>2]|0}while(($|0)<(aa|0));f[j>>2]=f[r>>2];if((aa|0)<3)I=110;else I=112}else{f[j>>2]=f[r>>2];I=110}do if((I|0)==110){aa=f[r+4>>2]|0;if((aa|0)>=3){I=112;break}f[N>>2]=aa;f[j+8>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];aa=f[r+44>>2]|0;$=f[L>>2]|0;f[$>>2]=f[aa>>2];f[$+4>>2]=f[aa+4>>2]}while(0);if((I|0)==112)ZS(j,r);I=r+16|0;f[s>>2]=f[I>>2];f[j+20>>2]=f[r+20>>2];f[j+24>>2]=f[r+24>>2];f[j+28>>2]=f[r+28>>2];f[j+32>>2]=f[r+32>>2];s=f[X>>2]|0;f[x>>2]=s;do if(s|0){x=s+12|0;L=f[x>>2]|0;f[x>>2]=L+-1;if((L|0)!=1)break;_S(r)}while(0);f[X>>2]=0;X=r+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[X>>2]|0)>0){I=f[r+40>>2]|0;s=0;do{f[I+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[X>>2]|0))}X=f[r+44>>2]|0;if((X|0)!=(r+48|0))g0(X)}cL(i,f[T>>2]&4095,C,l);cL(j,f[T>>2]&4095,F,l);ba=C;ca=F}else{ba=0;ca=0}F=o+16|0;C=(m|0)==0;T=n+((J?2:3)<<2)|0;X=(R|0)==0;r=n+4|0;s=v+4|0;I=Q+1&3;Q=(I|0)==0?4:I;I=Q&255;L=Q>>>0>=S>>>0;x=n+8|0;N=0;while(1){if(N>>>0>=(f[F>>2]|0)>>>0)break;if(!C){aa=0;do{$=m-aa|0;t=$>>>0>l>>>0?l:$;$=Y(t,Z)|0;if(J)da=ba;else{y=f[x>>2]|0;f[x>>2]=y+$;da=y}if(P)ea=ca;else{y=f[T>>2]|0;f[T>>2]=y+$;ea=y}y=f[n>>2]|0;H=X?f[r>>2]|0:_;W=Y(t,S)|0;f[v>>2]=W;f[s>>2]=1;Li[e&127](y,0,da,0,ea,0,H,0,v);c:do if(!X){H=f[r>>2]|0;switch(I&7){case 1:{if(!t)break c;else{fa=0;ga=0}while(1){b[H+fa>>0]=b[_+ga>>0]|0;fa=fa+1|0;if((fa|0)==(t|0))break;else ga=ga+S|0}break}case 2:{if(!t)break c;else{ha=0;ia=0}while(1){b[H+ia>>0]=b[_+(ha+1)>>0]&b[_+ha>>0];ia=ia+1|0;if((ia|0)==(t|0))break;else ha=ha+S|0}break}case 3:{if(!t)break c;else{ja=0;ka=0}while(1){b[H+ka>>0]=b[_+(ja+1)>>0]&b[_+ja>>0]&b[_+(ja+2)>>0];ka=ka+1|0;if((ka|0)==(t|0))break;else ja=ja+S|0}break}default:{if(!t)break c;else{la=0;ma=0}while(1){b[H+la>>0]=b[_+(ma+1)>>0]&b[_+ma>>0]&b[_+(ma+2)>>0]&b[_+(ma+3)>>0];la=la+1|0;if((la|0)==(t|0))break;else ma=ma+S|0}}}if(!(L|(t|0)==0)){y=Q;do{W=0;O=y;while(1){w=H+W|0;b[w>>0]=b[_+(O+1)>>0]&b[_+O>>0]&b[_+(O+2)>>0]&b[_+(O+3)>>0]&b[w>>0];W=W+1|0;if((W|0)==(t|0))break;else O=O+S|0}y=y+4|0}while((y|0)<=(R|0))}}while(0);f[n>>2]=(f[n>>2]|0)+$;f[r>>2]=(f[r>>2]|0)+t;aa=aa+l|0}while(m>>>0>aa>>>0)}A2(o)|0;N=N+1|0}N=f[q>>2]|0;if((N|0)!=(U|0)){if(N|0)ZDc(N);f[q>>2]=U;f[V>>2]=1032}V=k+36|0;U=f[V>>2]|0;if(U|0?(q=U+12|0,U=f[q>>2]|0,f[q>>2]=U+-1,(U|0)==1):0)_S(k);f[V>>2]=0;V=k+16|0;U=k+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[U>>2]|0)>0){V=f[k+40>>2]|0;q=0;do{f[V+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[U>>2]|0))}U=f[k+44>>2]|0;if((U|0)!=(k+48|0))g0(U);U=j+36|0;k=f[U>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)_S(j);f[U>>2]=0;U=j+16|0;k=j+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[k>>2]|0)>0){U=f[j+40>>2]|0;q=0;do{f[U+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))g0(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(q=j+12|0,j=f[q>>2]|0,f[q>>2]=j+-1,(j|0)==1):0)_S(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=h+36|0;i=f[j>>2]|0;do if(i|0){q=i+12|0;k=f[q>>2]|0;f[q>>2]=k+-1;if((k|0)!=1)break;_S(h)}while(0);f[j>>2]=0;j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[K>>2]|0)>0){j=f[D>>2]|0;D=0;do{f[j+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[K>>2]|0))}K=f[h+44>>2]|0;if((K|0)==(h+48|0)){u=g;return}g0(K);u=g;return}function wL(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=f[l>>2]|0;n=f[l+4>>2]|0;if(!n)return;l=m+-4|0;if((m|0)<4){o=(m|0)>0;p=a;q=j;r=g;s=d;t=n;while(1){t=t+-1|0;if(o){u=0;do{v=b[p+u>>0]|0;if((h[s+u>>0]|0)>(v&255))w=0;else w=(v&255)<=(h[r+u>>0]|0);b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(m|0))}if(!t)break;else{p=p+c|0;q=q+k|0;r=r+i|0;s=s+e|0}}return}s=m&-4;r=(s|0)<(m|0);q=a;a=j;j=g;g=d;d=n;while(1){n=0;do{p=b[q+n>>0]|0;if((h[g+n>>0]|0)>(p&255))x=0;else x=(p&255)<=(h[j+n>>0]|0);p=n|1;t=b[q+p>>0]|0;if((h[g+p>>0]|0)>(t&255))y=0;else y=(t&255)<=(h[j+p>>0]|0);b[a+n>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=n|2;t=b[q+p>>0]|0;if((h[g+p>>0]|0)>(t&255))z=0;else z=(t&255)<=(h[j+p>>0]|0);t=n|3;w=b[q+t>>0]|0;if((h[g+t>>0]|0)>(w&255))A=0;else A=(w&255)<=(h[j+t>>0]|0);b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;n=n+4|0}while((n|0)<=(l|0));d=d+-1|0;if(r){n=s;do{t=b[q+n>>0]|0;if((h[g+n>>0]|0)>(t&255))B=0;else B=(t&255)<=(h[j+n>>0]|0);b[a+n>>0]=B<<31>>31;n=n+1|0}while((n|0)!=(m|0))}if(!d)break;else{q=q+c|0;a=a+k|0;j=j+i|0;g=g+e|0}}return}function xL(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=f[k>>2]|0;m=f[k+4>>2]|0;if(!m)return;k=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;p=i;q=g;r=d;s=m;while(1){s=s+-1|0;if(n){t=0;do{u=b[o+t>>0]|0;if((b[r+t>>0]|0)>u<<24>>24)v=0;else v=u<<24>>24<=(b[q+t>>0]|0);b[p+t>>0]=v<<31>>31;t=t+1|0}while((t|0)!=(l|0))}if(!s)break;else{o=o+c|0;p=p+j|0;q=q+h|0;r=r+e|0}}return}r=l&-4;q=(r|0)<(l|0);p=a;a=i;i=g;g=d;d=m;while(1){m=0;do{o=b[p+m>>0]|0;if((b[g+m>>0]|0)>o<<24>>24)w=0;else w=o<<24>>24<=(b[i+m>>0]|0);o=m|1;s=b[p+o>>0]|0;if((b[g+o>>0]|0)>s<<24>>24)x=0;else x=s<<24>>24<=(b[i+o>>0]|0);b[a+m>>0]=w<<31>>31;b[a+o>>0]=x<<31>>31;o=m|2;s=b[p+o>>0]|0;if((b[g+o>>0]|0)>s<<24>>24)y=0;else y=s<<24>>24<=(b[i+o>>0]|0);s=m|3;v=b[p+s>>0]|0;if((b[g+s>>0]|0)>v<<24>>24)z=0;else z=v<<24>>24<=(b[i+s>>0]|0);b[a+o>>0]=y<<31>>31;b[a+s>>0]=z<<31>>31;m=m+4|0}while((m|0)<=(k|0));d=d+-1|0;if(q){m=r;do{s=b[p+m>>0]|0;if((b[g+m>>0]|0)>s<<24>>24)A=0;else A=s<<24>>24<=(b[i+m>>0]|0);b[a+m>>0]=A<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{p=p+c|0;a=a+j|0;i=i+h|0;g=g+e|0}}return}function yL(a,c,e,g,h,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=f[m>>2]|0;o=f[m+4>>2]|0;m=c>>>1;c=g>>>1;g=i>>>1;if(!o)return;i=n+-4|0;if((n|0)<4){p=(n|0)>0;q=a;r=k;s=h;t=e;u=o;while(1){u=u+-1|0;if(p){v=0;do{w=d[q+(v<<1)>>1]|0;if((j[t+(v<<1)>>1]|0)>(w&65535))x=0;else x=(w&65535)<=(j[s+(v<<1)>>1]|0);b[r+v>>0]=x<<31>>31;v=v+1|0}while((v|0)!=(n|0))}if(!u)break;else{q=q+(m<<1)|0;r=r+l|0;s=s+(g<<1)|0;t=t+(c<<1)|0}}return}t=n&-4;s=(t|0)<(n|0);r=a;a=k;k=h;h=e;e=o;while(1){o=0;do{q=d[r+(o<<1)>>1]|0;if((j[h+(o<<1)>>1]|0)>(q&65535))y=0;else y=(q&65535)<=(j[k+(o<<1)>>1]|0);q=o|1;u=d[r+(q<<1)>>1]|0;if((j[h+(q<<1)>>1]|0)>(u&65535))z=0;else z=(u&65535)<=(j[k+(q<<1)>>1]|0);b[a+o>>0]=y<<31>>31;b[a+q>>0]=z<<31>>31;q=o|2;u=d[r+(q<<1)>>1]|0;if((j[h+(q<<1)>>1]|0)>(u&65535))A=0;else A=(u&65535)<=(j[k+(q<<1)>>1]|0);u=o|3;x=d[r+(u<<1)>>1]|0;if((j[h+(u<<1)>>1]|0)>(x&65535))B=0;else B=(x&65535)<=(j[k+(u<<1)>>1]|0);b[a+q>>0]=A<<31>>31;b[a+u>>0]=B<<31>>31;o=o+4|0}while((o|0)<=(i|0));e=e+-1|0;if(s){o=t;do{u=d[r+(o<<1)>>1]|0;if((j[h+(o<<1)>>1]|0)>(u&65535))C=0;else C=(u&65535)<=(j[k+(o<<1)>>1]|0);b[a+o>>0]=C<<31>>31;o=o+1|0}while((o|0)!=(n|0))}if(!e)break;else{r=r+(m<<1)|0;a=a+l|0;k=k+(g<<1)|0;h=h+(c<<1)|0}}return}function zL(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=c>>>1;c=g>>>1;g=i>>>1;if(!n)return;i=m+-4|0;if((m|0)<4){o=(m|0)>0;p=a;q=j;r=h;s=e;t=n;while(1){t=t+-1|0;if(o){u=0;do{v=d[p+(u<<1)>>1]|0;if((d[s+(u<<1)>>1]|0)>v<<16>>16)w=0;else w=v<<16>>16<=(d[r+(u<<1)>>1]|0);b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(m|0))}if(!t)break;else{p=p+(l<<1)|0;q=q+k|0;r=r+(g<<1)|0;s=s+(c<<1)|0}}return}s=m&-4;r=(s|0)<(m|0);q=a;a=j;j=h;h=e;e=n;while(1){n=0;do{p=d[q+(n<<1)>>1]|0;if((d[h+(n<<1)>>1]|0)>p<<16>>16)x=0;else x=p<<16>>16<=(d[j+(n<<1)>>1]|0);p=n|1;t=d[q+(p<<1)>>1]|0;if((d[h+(p<<1)>>1]|0)>t<<16>>16)y=0;else y=t<<16>>16<=(d[j+(p<<1)>>1]|0);b[a+n>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=n|2;t=d[q+(p<<1)>>1]|0;if((d[h+(p<<1)>>1]|0)>t<<16>>16)z=0;else z=t<<16>>16<=(d[j+(p<<1)>>1]|0);t=n|3;w=d[q+(t<<1)>>1]|0;if((d[h+(t<<1)>>1]|0)>w<<16>>16)A=0;else A=w<<16>>16<=(d[j+(t<<1)>>1]|0);b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;n=n+4|0}while((n|0)<=(i|0));e=e+-1|0;if(r){n=s;do{t=d[q+(n<<1)>>1]|0;if((d[h+(n<<1)>>1]|0)>t<<16>>16)B=0;else B=t<<16>>16<=(d[j+(n<<1)>>1]|0);b[a+n>>0]=B<<31>>31;n=n+1|0}while((n|0)!=(m|0))}if(!e)break;else{q=q+(l<<1)|0;a=a+k|0;j=j+(g<<1)|0;h=h+(c<<1)|0}}return}function AL(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>2;c=e>>>2;e=h>>>2;if(!m)return;h=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;p=i;q=g;r=d;s=m;while(1){s=s+-1|0;if(n){t=0;do{u=f[o+(t<<2)>>2]|0;if((f[r+(t<<2)>>2]|0)>(u|0))v=0;else v=(u|0)<=(f[q+(t<<2)>>2]|0);b[p+t>>0]=v<<31>>31;t=t+1|0}while((t|0)!=(l|0))}if(!s)break;else{o=o+(k<<2)|0;p=p+j|0;q=q+(e<<2)|0;r=r+(c<<2)|0}}return}r=l&-4;q=(r|0)<(l|0);p=a;a=i;i=g;g=d;d=m;while(1){m=0;do{o=f[p+(m<<2)>>2]|0;if((f[g+(m<<2)>>2]|0)>(o|0))w=0;else w=(o|0)<=(f[i+(m<<2)>>2]|0);o=m|1;s=f[p+(o<<2)>>2]|0;if((f[g+(o<<2)>>2]|0)>(s|0))x=0;else x=(s|0)<=(f[i+(o<<2)>>2]|0);b[a+m>>0]=w<<31>>31;b[a+o>>0]=x<<31>>31;o=m|2;s=f[p+(o<<2)>>2]|0;if((f[g+(o<<2)>>2]|0)>(s|0))y=0;else y=(s|0)<=(f[i+(o<<2)>>2]|0);s=m|3;v=f[p+(s<<2)>>2]|0;if((f[g+(s<<2)>>2]|0)>(v|0))z=0;else z=(v|0)<=(f[i+(s<<2)>>2]|0);b[a+o>>0]=y<<31>>31;b[a+s>>0]=z<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(q){m=r;do{s=f[p+(m<<2)>>2]|0;if((f[g+(m<<2)>>2]|0)>(s|0))A=0;else A=(s|0)<=(f[i+(m<<2)>>2]|0);b[a+m>>0]=A<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{p=p+(k<<2)|0;a=a+j|0;i=i+(e<<2)|0;g=g+(c<<2)|0}}return}function BL(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>2;c=e>>>2;e=h>>>2;if(!m)return;h=l+-4|0;if((l|0)<4){o=(l|0)>0;p=a;q=i;r=g;s=d;t=m;while(1){t=t+-1|0;if(o){u=0;do{v=+n[p+(u<<2)>>2];if(!(+n[s+(u<<2)>>2]<=v))w=0;else w=v<=+n[r+(u<<2)>>2];b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(l|0))}if(!t)break;else{p=p+(k<<2)|0;q=q+j|0;r=r+(e<<2)|0;s=s+(c<<2)|0}}return}s=l&-4;r=(s|0)<(l|0);q=a;a=i;i=g;g=d;d=m;while(1){m=0;do{v=+n[q+(m<<2)>>2];if(!(+n[g+(m<<2)>>2]<=v))x=0;else x=v<=+n[i+(m<<2)>>2];p=m|1;v=+n[q+(p<<2)>>2];if(!(+n[g+(p<<2)>>2]<=v))y=0;else y=v<=+n[i+(p<<2)>>2];b[a+m>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=m|2;v=+n[q+(p<<2)>>2];if(!(+n[g+(p<<2)>>2]<=v))z=0;else z=v<=+n[i+(p<<2)>>2];t=m|3;v=+n[q+(t<<2)>>2];if(!(+n[g+(t<<2)>>2]<=v))A=0;else A=v<=+n[i+(t<<2)>>2];b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(r){m=s;do{v=+n[q+(m<<2)>>2];if(!(+n[g+(m<<2)>>2]<=v))B=0;else B=v<=+n[i+(m<<2)>>2];b[a+m>>0]=B<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{q=q+(k<<2)|0;a=a+j|0;i=i+(e<<2)|0;g=g+(c<<2)|0}}return}function CL(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>3;c=e>>>3;e=h>>>3;if(!m)return;h=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;q=i;r=g;s=d;t=m;while(1){t=t+-1|0;if(n){u=0;do{v=+p[o+(u<<3)>>3];if(!(+p[s+(u<<3)>>3]<=v))w=0;else w=v<=+p[r+(u<<3)>>3];b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(l|0))}if(!t)break;else{o=o+(k<<3)|0;q=q+j|0;r=r+(e<<3)|0;s=s+(c<<3)|0}}return}s=l&-4;r=(s|0)<(l|0);q=a;a=i;i=g;g=d;d=m;while(1){m=0;do{v=+p[q+(m<<3)>>3];if(!(+p[g+(m<<3)>>3]<=v))x=0;else x=v<=+p[i+(m<<3)>>3];o=m|1;v=+p[q+(o<<3)>>3];if(!(+p[g+(o<<3)>>3]<=v))y=0;else y=v<=+p[i+(o<<3)>>3];b[a+m>>0]=x<<31>>31;b[a+o>>0]=y<<31>>31;o=m|2;v=+p[q+(o<<3)>>3];if(!(+p[g+(o<<3)>>3]<=v))z=0;else z=v<=+p[i+(o<<3)>>3];t=m|3;v=+p[q+(t<<3)>>3];if(!(+p[g+(t<<3)>>3]<=v))A=0;else A=v<=+p[i+(t<<3)>>3];b[a+o>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(r){m=s;do{v=+p[q+(m<<3)>>3];if(!(+p[g+(m<<3)>>3]<=v))B=0;else B=v<=+p[i+(m<<3)>>3];b[a+m>>0]=B<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{q=q+(k<<3)|0;a=a+j|0;i=i+(e<<3)|0;g=g+(c<<3)|0}}return}function DL(a,b){a=a|0;b=b|0;return f[34336+((b&7)<<5)+((a&7)<<2)>>2]|0}function EL(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(m+l*+(h[o+g>>0]|0))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+c|0;q=q+i|0}}return}function FL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(b[n+g>>0]|0))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+h|0}}return}function GL(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(m+l*+(j[o+(g<<1)>>1]|0))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+(k<<1)|0;q=q+h|0}}return}function HL(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=mrc(m+l*+(d[o+(h<<1)>>1]|0))|0;b[q+h>>0]=a>>>0<256?a:(a|0)>0?255:0;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+(k<<1)|0;q=q+i|0}}return}function IL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(f[n+(g<<2)>>2]|0))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(j<<2)|0;o=o+h|0}}return}function JL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(l+k*+n[o+(g<<2)>>2])|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{o=o+(j<<2)|0;q=q+h|0}}return}function KL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if((d|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=nrc(l+k*+p[n+(g<<3)>>3])|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(i<<3)|0;o=o+h|0}}return}function LL(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(m+l*+(h[o+g>>0]|0))|0;b[q+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+c|0;q=q+i|0}}return}function ML(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(b[n+g>>0]|0))|0;b[o+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+h|0}}return}function NL(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(m+l*+(j[o+(g<<1)>>1]|0))|0;b[q+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+(k<<1)|0;q=q+h|0}}return}function OL(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=mrc(m+l*+(d[o+(h<<1)>>1]|0))|0;b[q+h>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+(k<<1)|0;q=q+i|0}}return}function PL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(f[n+(g<<2)>>2]|0))|0;b[o+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(j<<2)|0;o=o+h|0}}return}function QL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(l+k*+n[o+(g<<2)>>2])|0;b[q+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{o=o+(j<<2)|0;q=q+h|0}}return}function RL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if((d|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=nrc(l+k*+p[n+(g<<3)>>3])|0;b[o+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(i<<3)|0;o=o+h|0}}return}function SL(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((c|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(m+l*+(h[o+g>>0]|0))|0;d[q+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(c|0))break;else{o=o+b|0;q=q+(k<<1)|0}}return}function TL(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=mrc(m+l*+(b[o+h>>0]|0))|0;d[q+(h<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+c|0;q=q+(k<<1)|0}}return}function UL(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(m+l*+(j[o+(g<<1)>>1]|0))|0;d[q+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(c|0))break;else{o=o+(k<<1)|0;q=q+(b<<1)|0}}return}function VL(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(d[n+(g<<1)>>1]|0))|0;d[o+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<1)|0;o=o+(b<<1)|0}}return}function WL(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(f[n+(g<<2)>>2]|0))|0;d[o+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<2)|0;o=o+(b<<1)|0}}return}function XL(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(l+k*+n[o+(g<<2)>>2])|0;d[q+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(j<<2)|0;q=q+(b<<1)|0}}return}function YL(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((c|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=nrc(l+k*+p[n+(g<<3)>>3])|0;d[o+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(i<<3)|0;o=o+(b<<1)|0}}return}function ZL(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((c|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(m+l*+(h[o+g>>0]|0))|0;d[q+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(c|0))break;else{o=o+b|0;q=q+(k<<1)|0}}return}function _L(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=mrc(m+l*+(b[o+h>>0]|0))|0;d[q+(h<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+c|0;q=q+(k<<1)|0}}return}function $L(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(m+l*+(j[o+(g<<1)>>1]|0))|0;d[q+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(c|0))break;else{o=o+(k<<1)|0;q=q+(b<<1)|0}}return}function aM(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(d[n+(g<<1)>>1]|0))|0;d[o+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<1)|0;o=o+(b<<1)|0}}return}function bM(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(f[n+(g<<2)>>2]|0))|0;d[o+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<2)|0;o=o+(b<<1)|0}}return}function cM(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(l+k*+n[o+(g<<2)>>2])|0;d[q+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(j<<2)|0;q=q+(b<<1)|0}}return}function dM(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((c|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=nrc(l+k*+p[n+(g<<3)>>3])|0;d[o+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(i<<3)|0;o=o+(b<<1)|0}}return}function eM(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>2;if((c|0)>0&(d|0)>0){m=0;n=a;o=e}else return;while(1){e=0;do{a=mrc(l+k*+(h[n+e>>0]|0))|0;f[o+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+b|0;o=o+(j<<2)|0}}return}function fM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>2;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(b[n+g>>0]|0))|0;f[o+(g<<2)>>2]=a;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+(j<<2)|0}}return}function gM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,n=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;if((c|0)>0&(d|0)>0){m=0;n=a;o=e}else return;while(1){e=0;do{a=mrc(l+k*+(j[n+(e<<1)>>1]|0))|0;f[o+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(i<<1)|0;o=o+(b<<2)|0}}return}function hM(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>2;if((c|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(l+k*+(d[n+(g<<1)>>1]|0))|0;f[o+(g<<2)>>2]=a;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<1)|0;o=o+(b<<2)|0}}return}function iM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if((c|0)>0&(d|0)>0){l=0;m=a;n=e}else return;while(1){e=0;do{a=nrc(k+j*+(f[m+(e<<2)>>2]|0))|0;f[n+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;n=n+(b<<2)|0}}return}function jM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if((c|0)>0&(d|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{a=mrc(k+j*+n[m+(e<<2)>>2])|0;f[o+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;o=o+(b<<2)|0}}return}function kM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>2;if((c|0)>0&(d|0)>0){l=0;m=a;n=e}else return;while(1){e=0;do{a=nrc(k+j*+p[m+(e<<3)>>3])|0;f[n+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<3)|0;n=n+(b<<2)|0}}return}function lM(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>2;if((c|0)>0&(d|0)>0){m=0;o=a;q=e}else return;while(1){e=0;do{n[q+(e<<2)>>2]=l+k*+(h[o+e>>0]|0);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+b|0;q=q+(j<<2)|0}}return}function mM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>2;if((d|0)>0&(e|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{n[q+(g<<2)>>2]=l+k*+(b[o+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{o=o+c|0;q=q+(j<<2)|0}}return}function nM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,o=0,q=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;if((d|0)>0&(c|0)>0){m=0;o=a;q=e}else return;while(1){e=0;do{n[q+(e<<2)>>2]=l+k*+(j[o+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(i<<1)|0;q=q+(b<<2)|0}}return}function oM(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>2;if((e|0)>0&(c|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{n[q+(g<<2)>>2]=l+k*+(d[o+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(j<<1)|0;q=q+(b<<2)|0}}return}function pM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if((d|0)>0&(c|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{n[o+(e<<2)>>2]=k+j*+(f[m+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;o=o+(b<<2)|0}}return}function qM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if((d|0)>0&(c|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{n[o+(e<<2)>>2]=k+j*+n[m+(e<<2)>>2];e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;o=o+(b<<2)|0}}return}function rM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>2;if((d|0)>0&(c|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{n[o+(e<<2)>>2]=k+j*+p[m+(e<<3)>>3];e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<3)|0;o=o+(b<<2)|0}}return}function sM(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>3;if((c|0)>0&(d|0)>0){m=0;n=a;o=e}else return;while(1){e=0;do{p[o+(e<<3)>>3]=l+k*+(h[n+e>>0]|0);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+b|0;o=o+(j<<3)|0}}return}function tM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>3;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{p[o+(g<<3)>>3]=l+k*+(b[n+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+(j<<3)|0}}return}function uM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,n=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>3;if((d|0)>0&(c|0)>0){m=0;n=a;o=e}else return;while(1){e=0;do{p[o+(e<<3)>>3]=l+k*+(j[n+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(i<<1)|0;o=o+(b<<3)|0}}return}function vM(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>3;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{p[o+(g<<3)>>3]=l+k*+(d[n+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<1)|0;o=o+(b<<3)|0}}return}function wM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>3;if((d|0)>0&(c|0)>0){l=0;m=a;n=e}else return;while(1){e=0;do{p[n+(e<<3)>>3]=k+j*+(f[m+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;n=n+(b<<3)|0}}return}function xM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>3;if((d|0)>0&(c|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{p[o+(e<<3)>>3]=k+j*+n[m+(e<<2)>>2];e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;o=o+(b<<3)|0}}return}function yM(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>3;if((d|0)>0&(c|0)>0){l=0;m=a;n=e}else return;while(1){e=0;do{p[n+(e<<3)>>3]=k+j*+p[m+(e<<3)>>3];e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<3)|0;n=n+(b<<3)|0}}return}function zM(a,c,d,e){a=a|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+208|0;h=g+144|0;i=g+8|0;j=g+88|0;k=g+72|0;l=g+64|0;m=g;n=g+24|0;o=g+56|0;do if((d$(a)|0)==65536){q=f[a+4>>2]|0;f[h>>2]=f[q>>2];r=h+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=h+8|0;f[t>>2]=f[q+8>>2];f[h+12>>2]=f[q+12>>2];f[h+16>>2]=f[q+16>>2];f[h+20>>2]=f[q+20>>2];f[h+24>>2]=f[q+24>>2];f[h+28>>2]=f[q+28>>2];f[h+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[h+36>>2]=v;w=h+40|0;f[w>>2]=t;t=h+48|0;x=h+44|0;f[x>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];y=r;z=w;A=h;break}else{f[r>>2]=0;ZS(h,q);y=r;z=w;A=h;break}}else{a$(h,a,-1);y=h+4|0;z=h+40|0;A=h}while(0);a=((f[A>>2]|0)>>>3&511)+1|0;p[i>>3]=d;p[i+8>>3]=e;w$(c,f[y>>2]|0,f[z>>2]|0,(a<<3)+-8|0,-1,0,0);do if((d$(c)|0)==65536){w=f[c+4>>2]|0;f[j>>2]=f[w>>2];r=j+4|0;q=w+4|0;f[r>>2]=f[q>>2];s=j+8|0;f[s>>2]=f[w+8>>2];f[j+12>>2]=f[w+12>>2];f[j+16>>2]=f[w+16>>2];f[j+20>>2]=f[w+20>>2];f[j+24>>2]=f[w+24>>2];f[j+28>>2]=f[w+28>>2];f[j+32>>2]=f[w+32>>2];t=f[w+36>>2]|0;f[j+36>>2]=t;f[j+40>>2]=s;s=j+48|0;x=j+44|0;f[x>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[q>>2]|0)<3){q=f[w+44>>2]|0;s=f[x>>2]|0;f[s>>2]=f[q>>2];f[s+4>>2]=f[q+4>>2];break}else{f[r>>2]=0;ZS(j,w);break}}else a$(j,c,-1);while(0);c=f[A>>2]&7;A=f[34592+(c<<2)>>2]|0;if((c|0)==7){f[k>>2]=0;f[k+4>>2]=0;c=tT(k,9)|0;w=251213;r=c+9|0;do{b[c>>0]=b[w>>0]|0;c=c+1|0;w=w+1|0}while((c|0)<(r|0));AM(-215,k,211461,426)}if((f[y>>2]|0)<3){rT(k,h,j,a);w=f[h+16>>2]|0;c=f[h+48>>2]|0;r=f[j+16>>2]|0;q=f[j+48>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];wi[A&255](w,c,0,0,r,q,l,i)}else{f[k>>2]=h;f[k+4>>2]=j;f[k+8>>2]=0;l=m;f[l>>2]=0;f[l+4>>2]=0;z2(n,k,m,-1);k=Y(f[n+20>>2]|0,a)|0;a=n+16|0;l=m+4|0;q=o+4|0;r=0;while(1){if(r>>>0>=(f[a>>2]|0)>>>0)break;c=f[m>>2]|0;w=f[l>>2]|0;f[o>>2]=k;f[q>>2]=1;wi[A&255](c,0,0,0,w,0,o,i);A2(n)|0;r=r+1|0}}r=j+36|0;n=f[r>>2]|0;if(n|0?(i=n+12|0,n=f[i>>2]|0,f[i>>2]=n+-1,(n|0)==1):0)_S(j);f[r>>2]=0;r=j+16|0;n=j+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[n>>2]|0)>0){r=f[j+40>>2]|0;i=0;do{f[r+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[n>>2]|0))}n=f[j+44>>2]|0;if((n|0)!=(j+48|0))g0(n);n=h+36|0;j=f[n>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)_S(h);f[n>>2]=0;n=h+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[y>>2]|0)>0){n=f[z>>2]|0;z=0;do{f[n+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)==(h+48|0)){u=g;return}g0(y);u=g;return}function AM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,211477,d);return}function BM(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(+L(+(m+l*+(h[o+g>>0]|0))))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+c|0;q=q+i|0}}return}function CM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(+L(+(l+k*+(b[n+g>>0]|0))))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+h|0}}return}function DM(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(+L(+(m+l*+(j[o+(g<<1)>>1]|0))))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+(k<<1)|0;q=q+h|0}}return}function EM(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=mrc(+L(+(m+l*+(d[o+(h<<1)>>1]|0))))|0;b[q+h>>0]=a>>>0<256?a:(a|0)>0?255:0;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+(k<<1)|0;q=q+i|0}}return}function FM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=mrc(+L(+(l+k*+(f[n+(g<<2)>>2]|0))))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(j<<2)|0;o=o+h|0}}return}function GM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=mrc(+L(+(l+k*+n[o+(g<<2)>>2])))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{o=o+(j<<2)|0;q=q+h|0}}return}function HM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if((d|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=nrc(+L(+(l+k*+p[n+(g<<3)>>3])))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(i<<3)|0;o=o+h|0}}return}function IM(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0;j=u;u=u+128|0;k=j+56|0;l=j;m=j+112|0;n=c$(a,-1)|0;if((h|0)<0)if(X$(c)|0)o=p$(c,-1)|0;else o=n&7;else o=h;switch(g|0){case 32:{p[k>>3]=0.0;p[l>>3]=0.0;q=d>e?e:d;vT(a,k,l,0,0,i);r=+p[k>>3];s=+p[l>>3]-r;t=((d<e?e:d)-q)*(s>2.220446049250313e-16?1.0/s:0.0);if((o|0)==5){s=t;v=s;w=q-r*s}else{v=t;w=q-r*t}x=v;y=w;break}case 1:case 2:case 4:{w=+PO(a,g,i);x=w>2.220446049250313e-16?d/w:0.0;y=0.0;break}default:{f[k>>2]=0;f[k+4>>2]=0;z=tT(k,29)|0;g=211549;A=z+29|0;do{b[z>>0]=b[g>>0]|0;z=z+1|0;g=g+1|0}while((z|0)<(A|0));AM(-5,k,211579,572)}}do if((d$(a)|0)==65536){g=f[a+4>>2]|0;f[k>>2]=f[g>>2];h=k+4|0;n=g+4|0;f[h>>2]=f[n>>2];B=k+8|0;f[B>>2]=f[g+8>>2];f[k+12>>2]=f[g+12>>2];f[k+16>>2]=f[g+16>>2];f[k+20>>2]=f[g+20>>2];f[k+24>>2]=f[g+24>>2];f[k+28>>2]=f[g+28>>2];f[k+32>>2]=f[g+32>>2];C=f[g+36>>2]|0;f[k+36>>2]=C;f[k+40>>2]=B;B=k+48|0;D=k+44|0;f[D>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[n>>2]|0)<3){n=f[g+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[n>>2];f[B+4>>2]=f[n+4>>2];break}else{f[h>>2]=0;ZS(k,g);break}}else a$(k,a,-1);while(0);if(!(r$(i)|0)){f[l>>2]=1124007936;a=l+4|0;g=l+8|0;h=l+40|0;z=a;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[h>>2]=g;g=l+48|0;z=l+44|0;f[z>>2]=g;f[g>>2]=0;f[l+52>>2]=0;A=m+8|0;f[A>>2]=0;f[A+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=l;LZ(k,m,o,x,y);j_(l,c,i);i=l+36|0;m=f[i>>2]|0;if(m|0?(A=m+12|0,m=f[A>>2]|0,f[A>>2]=m+-1,(m|0)==1):0)_S(l);f[i>>2]=0;i=l+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[h>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[z>>2]|0;if((a|0)!=(g|0))g0(a)}else LZ(k,c,o,x,y);o=k+36|0;c=f[o>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)_S(k);f[o>>2]=0;o=k+16|0;c=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[c>>2]|0)>0){o=f[k+40>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[k+44>>2]|0;if((c|0)==(k+48|0)){u=j;return}g0(c);u=j;return}function JM(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=VDc(12)|0;f[j>>2]=34632;f[j+4>>2]=0;b[j+8>>0]=0;KM(j);YDc(j);j=VDc(2296)|0;f[j>>2]=34652;k=j+8|0;b[j+48>>0]=0;f[j+44>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;d[k+32>>1]=0;b[k+34>>0]=0;k=(R5(4)|0)&1;b[j+43>>0]=k;f[j+192>>2]=j+200;f[j+196>>2]=1032;f[j+1232>>2]=j+1240;f[j+1236>>2]=264;f[j+12>>2]=j+56;LM(j,c,e,g,h,i);i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=34672;f[i+8>>2]=j;f[a>>2]=i;f[a+4>>2]=j;return}function KM(a){a=a|0;f[a>>2]=34632;return}function LM(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0;i=a+8|0;j=a+36|0;k=f[j>>2]|0;l=(g&128|0)==0;m=(e|0)==5?8:16;n=a+40|0;o=g&1;b[n>>0]=o;q=(g&32|0)!=0;b[a+42>>0]=(g&144|0)==16&1;r=a+16|0;p[r>>3]=1.0;f[a+32>>2]=c;f[j>>2]=c;b[a+48>>0]=0;s=(k|0)!=(c|0);k=a+12|0;t=f[k>>2]|0;if(s){if((c|0)>=6){u=(c+-1^c)+1>>1;if((u|0)>1){f[t>>2]=u;if((u|0)!=(c|0)?(v=(c>>>0)/(u>>>0)|0,(v|0)>1):0){w=3;x=v;y=1;z=8}else A=1}else{w=3;x=c;y=0;z=8}a:do if((z|0)==8){b:while(1){z=0;v=w;while(1){B=(x|0)/(v|0)|0;if((Y(B,v)|0)==(x|0))break;u=v+2|0;if((Y(u,u)|0)>(x|0))break b;else v=u}u=y+1|0;f[t+(y<<2)>>2]=v;if((B|0)>1){w=v;x=B;y=u;z=8}else{A=u;break a}}f[t+(y<<2)>>2]=x;A=y+1|0}while(0);y=f[t>>2]&1^1;x=(y+A|0)/2|0;if((y|0)<(x|0)){B=A+-1+y|0;w=y;do{y=t+(w<<2)|0;u=f[y>>2]|0;C=t+(B-w<<2)|0;f[y>>2]=f[C>>2];f[C>>2]=u;w=w+1|0}while((w|0)!=(x|0));D=A}else D=A}else{f[t>>2]=c;D=1}f[i>>2]=D;A=(f[t>>2]|0)==(f[t+(D+-1<<2)>>2]|0);if(!s)if(A)E=1;else{F=i;z=18}else{G=i;H=A;z=19}}else if((f[t>>2]|0)==(f[t+((f[i>>2]|0)+-1<<2)>>2]|0))E=1;else{F=i;z=18}if((z|0)==18)if(o<<24>>24==0|q^1)E=0;else{G=F;H=0;z=19}if((z|0)==19){F=a+192|0;o=Y(f[j>>2]|0,m)|0;i=a+196|0;if((f[i>>2]|0)>>>0<o>>>0){t=f[F>>2]|0;A=a+200|0;if((t|0)==(A|0))I=t;else{if(t|0)ZDc(t);f[F>>2]=A;f[i>>2]=1032;I=A}f[i>>2]=o;if(o>>>0>1032){A=XDc(o)|0;f[F>>2]=A;J=A}else J=I}else{f[i>>2]=o;J=f[F>>2]|0}F=a+28|0;f[F>>2]=J;J=a+1232|0;o=f[j>>2]|0;i=a+1236|0;if((f[i>>2]|0)>>>0<o>>>0){I=f[J>>2]|0;A=a+1240|0;if((I|0)==(A|0))K=I;else{if(I|0)ZDc(I);f[J>>2]=A;f[i>>2]=264;K=A}f[i>>2]=o;if(o>>>0>264){A=XDc(o>>>0>1073741823?-1:o<<2)|0;f[J>>2]=A;L=A}else L=K}else{f[i>>2]=o;L=f[J>>2]|0}f[a+24>>2]=L;if(l)M=q&(b[n>>0]|0)!=0;else M=0;PM(f[j>>2]|0,f[G>>2]|0,f[k>>2]|0,L,m,f[F>>2]|0,M&1);E=H}do if(!h)z=44;else{if(l){if(E|(b[h>>0]|0)==0?(c&1|0)==0|q^1:0){z=44;break}}else if(E){N=0;O=1;break}b[h>>0]=1;z=44}while(0);if((z|0)==44){z=l^1;if(z|q^1){N=0;O=z}else{N=(b[n>>0]|0)==0?1:2;O=0}}f[a+44>>2]=f[34684+(((e|0)==6?N+3|0:N)<<2)>>2];if((g&66|0)!=2)return;P=1.0/+(Y((g&4|0)==0|O?d:1,c)|0);p[r>>3]=P;return}function MM(a){a=a|0;return}function NM(a){a=a|0;YDc(a);return}function OM(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function PM(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,N=0.0,O=0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0;j=u;u=u+272|0;k=j+136|0;l=j;m=f[c>>2]|0;do if((a|0)<6){f[d>>2]=0;o=a+-1|0;f[d+(o<<2)>>2]=o;if((a|0)==4){f[d+4>>2]=2;f[d+8>>2]=1;q=2;break}if((o|0)>1)r=1;else{u=j;return}do{f[d+(r<<2)>>2]=r;r=r+1|0}while((r|0)!=(o|0));if((a|0)!=5){u=j;return}if((e|0)==16){p[g>>3]=1.0;p[g+8>>3]=0.0;u=j;return}else{f[g>>2]=1065353216;f[g+4>>2]=0;u=j;return}}else{f[l+(b<<2)>>2]=1;f[k+(b<<2)>>2]=0;if((b|0)>0){XIc(k|0,0,b<<2|0)|0;o=0;do{s=b-o|0;t=s+-1|0;v=Y(f[c+(t<<2)>>2]|0,f[l+(s<<2)>>2]|0)|0;f[l+(t<<2)>>2]=v;o=o+1|0}while((o|0)!=(b|0))}if(!i)w=d;else w=(m|0)==(f[c+(b+-1<<2)>>2]|0)?d:g;a:do if(!(m&1)){o=f[l+4>>2]|0;v=Y(o,m)|0;t=v>>1;s=0;while(1)if(1<<s>>>0<m>>>0)s=s+1|0;else break;x=v>>2;do if((m|0)>=3)if((m|0)<257){y=10-s|0;z=m+-4|0;if((m|0)<4)break;else A=0;do{B=Y((h[211786+(A>>2)>>0]|0)>>>y,o)|0;f[w+(A<<2)>>2]=B;C=B+t|0;f[w+((A|1)<<2)>>2]=C;f[w+((A|2)<<2)>>2]=B+x;f[w+((A|3)<<2)>>2]=C+x;A=A+4|0}while((A|0)<=(z|0))}else{z=34-s|0;y=0;do{C=Y(((h[211786+(y>>>10&255)>>0]|0)<<16|(h[211786+(y>>>2&255)>>0]|0)<<24|(h[211786+(y>>>18&255)>>0]|0)<<8|(h[211786+(y>>26)>>0]|0))>>>z,o)|0;f[w+(y<<2)>>2]=C;B=C+t|0;f[w+((y|1)<<2)>>2]=B;f[w+((y|2)<<2)>>2]=C+x;f[w+((y|3)<<2)>>2]=B+x;y=y+4|0}while((y|0)<(m|0))}else{f[w>>2]=0;f[w+4>>2]=t}while(0);t=k+4|0;f[t>>2]=(f[t>>2]|0)+1;if((b|0)>1?(x=f[l+8>>2]|0,(m|0)<(a|0)):0){o=c+4|0;if((m|0)>0){v=x;y=m;b:while(1){z=0;do{f[w+(z+y<<2)>>2]=(f[w+(z<<2)>>2]|0)+v;z=z+1|0}while((z|0)!=(m|0));z=y+m|0;if((z|0)>=(a|0)){D=s;break a}B=x+v|0;C=(f[t>>2]|0)+1|0;f[t>>2]=C;if((C|0)<(f[o>>2]|0)){v=B;y=z;continue}else{E=B;F=1;G=t}while(1){f[G>>2]=0;B=(f[l+(F+2<<2)>>2]|0)+E-(f[l+(F<<2)>>2]|0)|0;C=F+1|0;H=k+(C<<2)|0;I=(f[H>>2]|0)+1|0;f[H>>2]=I;if((I|0)<(f[c+(C<<2)>>2]|0)){v=B;y=z;continue b}else{E=B;F=C;G=H}}}}else{y=m<<1;if((y|0)>=(a|0)){D=s;break}v=f[o>>2]|0;x=y;do{y=(f[t>>2]|0)+1|0;f[t>>2]=y;if((y|0)>=(v|0)){y=1;z=t;do{f[z>>2]=0;y=y+1|0;z=k+(y<<2)|0;H=(f[z>>2]|0)+1|0;f[z>>2]=H}while((H|0)>=(f[c+(y<<2)>>2]|0))}x=x+m|0}while((x|0)<(a|0));D=s}}else D=s}else{f[w>>2]=0;if((a|0)>1){x=f[l+4>>2]|0;t=0;v=1;while(1){o=x+t|0;y=(f[k>>2]|0)+1|0;f[k>>2]=y;if((y|0)<(f[c>>2]|0))J=o;else{y=0;z=o;o=k;while(1){f[o>>2]=0;H=(f[l+(y+2<<2)>>2]|0)+z-(f[l+(y<<2)>>2]|0)|0;y=y+1|0;o=k+(y<<2)|0;C=(f[o>>2]|0)+1|0;f[o>>2]=C;if((C|0)<(f[c+(y<<2)>>2]|0)){J=H;break}else z=H}}f[w+(v<<2)>>2]=J;v=v+1|0;if((v|0)==(a|0)){D=0;break}else t=J}}else D=0}while(0);if((w|0)!=(d|0)?(f[d>>2]=0,t=a&1,(t|0)<(a|0)):0){v=t;do{t=v+1|0;x=f[w+(t<<2)>>2]|0;f[d+(f[w+(v<<2)>>2]<<2)>>2]=v;f[d+(x<<2)>>2]=t;v=v+2|0}while((v|0)<(a|0));q=D}else q=D}while(0);if(!(a+-1&a)){K=+p[6104+(q<<4)>>3];L=-+p[6104+(q<<4)+8>>3]}else{N=+P(+(-6.283185307179586/+(a|0)));K=+M(+(1.0-N*N));L=N}q=(a+1|0)/2|0;D=(a&1|0)==0;if((e|0)==16){p[g>>3]=1.0;p[g+8>>3]=0.0;if(D){p[g+(q<<4)>>3]=-1.0;p[g+(q<<4)+8>>3]=0.0}if((a|0)>2){O=1;Q=K;R=L}else{u=j;return}while(1){p[g+(O<<4)>>3]=Q;p[g+(O<<4)+8>>3]=R;e=a-O|0;p[g+(e<<4)>>3]=Q;p[g+(e<<4)+8>>3]=-R;N=K*R+L*Q;O=O+1|0;if((O|0)>=(q|0))break;else{Q=K*Q-L*R;R=N}}u=j;return}else{n[g>>2]=1.0;n[g+4>>2]=0.0;if(D){n[g+(q<<3)>>2]=-1.0;n[g+(q<<3)+4>>2]=0.0}if((a|0)>2){S=1;T=K;U=L}else{u=j;return}while(1){R=T;n[g+(S<<3)>>2]=R;Q=U;n[g+(S<<3)+4>>2]=Q;D=a-S|0;n[g+(D<<3)>>2]=R;n[g+(D<<3)+4>>2]=-Q;Q=K*U+L*T;S=S+1|0;if((S|0)>=(q|0))break;else{T=K*T-L*U;U=Q}}u=j;return}}function QM(a,b,c){a=a|0;b=b|0;c=c|0;$M(a,b,c);return}function RM(a,b,c){a=a|0;b=b|0;c=c|0;aN(a,b,c);return}function SM(a,b,c){a=a|0;b=b|0;c=c|0;_M(a,b,c);return}function TM(a,b,c){a=a|0;b=b|0;c=c|0;XM(a,b,c);return}function UM(a,b,c){a=a|0;b=b|0;c=c|0;ZM(a,b,c);return}function VM(a,b,c){a=a|0;b=b|0;c=c|0;WM(a,b,c);return}function WM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0,O=0.0,P=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=(b[a+34>>0]|0)!=0;j=+p[a+8>>3];if(i){k=c+8|0;l=+p[k>>3];m=+p[c>>3];p[k>>3]=m;n=k;o=l;q=m}else{n=c;o=0.0;q=+p[c>>3]}a:do switch(h|0){case 1:{p[d>>3]=j*q;break}case 2:{m=+p[n+8>>3];p[d+8>>3]=j*(q-m);p[d>>3]=j*(q+m);break}default:{c=h+1>>1;if(h&1|0){k=n+-8|0;p[d>>3]=q;p[d+8>>3]=0.0;if((c|0)>1){r=f[a+16>>2]|0;s=1;do{t=f[r+(s<<2)>>2]|0;v=f[r+(h-s<<2)>>2]|0;m=+p[k+(s<<4)>>3];l=+p[k+(s<<4)+8>>3];p[d+(t<<4)>>3]=m;p[d+(t<<4)+8>>3]=-l;p[d+(v<<4)>>3]=m;p[d+(v<<4)+8>>3]=l;s=s+1|0}while((s|0)!=(c|0))}w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;f[g+28>>2]=h;XM(g,d,d);p[d>>3]=j*+p[d>>3];if((h|0)>1){s=1;do{k=s<<1;l=j*+p[d+(k+2<<3)>>3];p[d+(s<<3)>>3]=j*+p[d+(k<<3)>>3];p[d+(s+1<<3)>>3]=l;s=s+2|0}while((s|0)<(h|0))}break a}s=(n|0)==(d|0);k=f[a+20>>2]|0;l=+p[n+8>>3];m=+p[n+(h+-1<<3)>>3];p[d>>3]=q+m;p[d+8>>3]=m-q;r=k+16|0;do if((c|0)>2){if(s){v=r;m=l;t=2;z=k;while(1){A=h-t|0;B=+p[d+(A+-1<<3)>>3];C=m+B;D=d+(t<<3)|0;E=+p[D>>3];F=d+(A<<3)|0;G=+p[F>>3];H=E-G;I=m-B;B=E+G;G=+p[v>>3];E=+p[z+24>>3];J=I*G+B*E;K=B*G-I*E;L=d+((t|1)<<3)|0;m=+p[L>>3];p[D>>3]=C-K;p[L>>3]=-H-J;p[F>>3]=C+K;p[d+(A+1<<3)>>3]=H-J;t=t+2|0;if((t|0)>=(c|0))break;else{A=v;v=v+16|0;z=A}}M=m;N=c+1&-2;break}z=f[a+16>>2]|0;v=r;J=l;t=2;A=k;while(1){F=h-t|0;H=+p[n+(F+-1<<3)>>3];K=J+H;C=+p[n+(t<<3)>>3];E=+p[n+(F<<3)>>3];I=C-E;G=J-H;H=C+E;E=+p[v>>3];C=+p[A+24>>3];B=G*E+H*C;O=H*E-G*C;J=+p[n+((t|1)<<3)>>3];F=t>>1;L=f[z+(F<<2)>>2]|0;p[d+(L<<3)>>3]=K-O;p[d+(L+1<<3)>>3]=-I-B;L=f[z+(c-F<<2)>>2]|0;p[d+(L<<3)>>3]=K+O;p[d+(L+1<<3)>>3]=I-B;t=t+2|0;if((t|0)>=(c|0))break;else{L=v;v=v+16|0;A=L}}M=J;N=c+1&-2}else{M=l;N=2}while(0);if((N|0)<=(c|0)){l=+p[n+(c<<3)>>3]*2.0;if(s)P=c;else P=f[(f[a+16>>2]|0)+(c<<2)>>2]<<1;p[d+(P<<3)>>3]=M*2.0;p[d+(P+1<<3)>>3]=l}k=a+4|0;r=f[k>>2]|0;A=f[r>>2]>>1;f[r>>2]=A;w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));r=(A|0)==1&1;v=g+4|0;f[v>>2]=(f[v>>2]|0)+(r<<2);f[g>>2]=(f[g>>2]|0)-r;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=(s^1)&1;p[g+8>>3]=1.0;f[g+28>>2]=c;XM(g,d,d);r=f[k>>2]|0;f[r>>2]=f[r>>2]<<1;if((h|0)>0){r=0;do{v=d+(r<<3)|0;t=d+((r|1)<<3)|0;l=-(j*+p[t>>3]);p[v>>3]=j*+p[v>>3];p[t>>3]=l;r=r+2|0}while((r|0)<(h|0))}}}while(0);if(!i){u=e;return}p[n>>3]=o;u=e;return}function XM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=u;u=u+1168|0;g=e;h=f[a+20>>2]|0;i=f[a+16>>2]|0;j=a+28|0;k=f[j>>2]|0;l=(b[a+32>>0]|0)!=0;m=a+24|0;n=f[m>>2]|0;o=+p[a+8>>3];if((n|0)!=(k|0))if((n|0)==(k<<1|0))q=2;else q=(n|0)/(k|0)|0;else q=1;do if((d|0)==(c|0)){a:do if(!(b[a+33>>0]|0)){r=f[a+4>>2]|0;s=f[a>>2]|0;if((f[r>>2]|0)!=(f[r+(s+-1<<2)>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;r=tT(g,33)|0;t=211686;v=r+33|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));YM(-215,g,211720,657)}if((s|0)!=1){if((k|0)>0){w=0;x=i}else break;while(1){t=f[x>>2]|0;if((t|0)>(w|0)){r=d+(w<<4)|0;y=+p[r>>3];z=+p[d+(w<<4)+8>>3];v=d+(t<<4)|0;f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2];f[r+8>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];p[v>>3]=y;p[d+(t<<4)+8>>3]=z}w=w+1|0;if((w|0)==(k|0))break a;else x=x+(q<<2)|0}}if((k&3|0)==0?(s=(k|0)/2|0,t=d+(s<<4)|0,(k|0)>1):0){v=q<<1;r=0;A=i;while(1){B=f[A>>2]|0;C=r|1;D=d+(C<<4)|0;z=+p[D>>3];y=+p[d+(C<<4)+8>>3];E=t+(B<<4)|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2];f[D+8>>2]=f[E+8>>2];f[D+12>>2]=f[E+12>>2];p[E>>3]=z;p[E+8>>3]=y;if((B|0)>(r|0)){E=d+(r<<4)|0;y=+p[E>>3];z=+p[d+(r<<4)+8>>3];D=d+(B<<4)|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];f[E+8>>2]=f[D+8>>2];f[E+12>>2]=f[D+12>>2];p[D>>3]=y;p[d+(B<<4)+8>>3]=z;D=t+(C<<4)|0;z=+p[D>>3];y=+p[D+8>>3];C=t+(B+1<<4)|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];f[D+8>>2]=f[C+8>>2];f[D+12>>2]=f[C+12>>2];p[C>>3]=z;p[C+8>>3]=y}r=r+2|0;if((r|0)>=(s|0))break;else A=A+(v<<2)|0}}}while(0);if(l){v=k+-2|0;if((k|0)<2)F=0;else{A=0;do{s=d+(A<<4)+8|0;r=d+((A|1)<<4)+8|0;y=-+p[r>>3];p[s>>3]=-+p[s>>3];p[r>>3]=y;A=A+2|0}while((A|0)<=(v|0));F=k&-2}v=d+(k+-1<<4)+8|0;if((F|0)<(k|0))p[v>>3]=-+p[v>>3]}}else{v=k+-2|0;A=(k|0)<2;if(l){if(A)G=0;else{r=q<<1;s=0;t=i;while(1){C=f[t>>2]|0;D=f[t+(q<<2)>>2]|0;y=-+p[c+(C<<4)+8>>3];p[d+(s<<4)>>3]=+p[c+(C<<4)>>3];p[d+(s<<4)+8>>3]=y;y=-+p[c+(D<<4)+8>>3];C=s|1;p[d+(C<<4)>>3]=+p[c+(D<<4)>>3];p[d+(C<<4)+8>>3]=y;s=s+2|0;if((s|0)>(v|0))break;else t=t+(r<<2)|0}G=k&-2}if((G|0)>=(k|0))break;r=k+-1|0;y=-+p[c+(r<<4)+8>>3];p[d+(G<<4)>>3]=+p[c+(r<<4)>>3];p[d+(G<<4)+8>>3]=y;break}else{if(A)H=0;else{r=q<<1;t=0;s=i;while(1){C=f[s+(q<<2)>>2]|0;D=c+(f[s>>2]<<4)|0;B=d+(t<<4)|0;f[B>>2]=f[D>>2];f[B+4>>2]=f[D+4>>2];f[B+8>>2]=f[D+8>>2];f[B+12>>2]=f[D+12>>2];D=c+(C<<4)|0;C=d+((t|1)<<4)|0;f[C>>2]=f[D>>2];f[C+4>>2]=f[D+4>>2];f[C+8>>2]=f[D+8>>2];f[C+12>>2]=f[D+12>>2];t=t+2|0;if((t|0)>(v|0))break;else s=s+(r<<2)|0}H=k&-2}r=k+-1|0;if((H|0)>=(k|0))break;s=c+(r<<4)|0;v=d+(r<<4)|0;f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2];f[v+8>>2]=f[s+8>>2];f[v+12>>2]=f[s+12>>2];break}}while(0);c=a+4|0;k=f[c>>2]|0;H=f[k>>2]|0;q=H&1;if(!q){if((H|0)<4){I=1;J=n}else{i=f[j>>2]|0;G=(i|0)>0;F=1;x=n;w=4;while(1){s=(x|0)/4|0;if(G){v=F<<1;r=(F|0)>1;t=0;do{A=d+(t<<4)|0;D=A+(v<<4)|0;y=+p[D>>3];C=D+8|0;z=+p[C>>3];B=D+(F<<4)|0;K=+p[B>>3];E=B+8|0;L=+p[E>>3];M=y+K;N=z+L;O=z-L;L=K-y;y=+p[A>>3];P=d+(t<<4)+8|0;K=+p[P>>3];Q=A+(F<<4)|0;z=+p[Q>>3];R=Q+8|0;S=+p[R>>3];T=y+z;U=K+S;V=y-z;z=K-S;p[A>>3]=M+T;p[P>>3]=N+U;p[D>>3]=T-M;p[C>>3]=U-N;p[Q>>3]=O+V;p[R>>3]=L+z;p[B>>3]=V-O;p[E>>3]=z-L;if(r){E=s;B=1;while(1){R=A+(B<<4)|0;Q=R+(v<<4)|0;C=R+(F<<4)|0;L=+p[C>>3];D=E<<1;z=+p[h+(D<<4)>>3];P=C+8|0;O=+p[P>>3];V=+p[h+(D<<4)+8>>3];N=L*z-O*V;U=z*O+L*V;V=+p[Q>>3];L=+p[h+(E<<4)+8>>3];D=Q+8|0;O=+p[D>>3];z=+p[h+(E<<4)>>3];M=V*L+O*z;T=V*z-L*O;W=Q+(F<<4)|0;O=+p[W>>3];X=E*3|0;L=+p[h+(X<<4)+8>>3];Z=W+8|0;z=+p[Z>>3];V=+p[h+(X<<4)>>3];S=O*L+z*V;K=O*V-L*z;z=T+K;L=M+S;V=M-S;S=K-T;T=+p[R>>3];X=R+8|0;K=+p[X>>3];M=N+T;O=U+K;y=T-N;N=K-U;p[R>>3]=M+z;p[X>>3]=O+L;p[Q>>3]=M-z;p[D>>3]=O-L;p[C>>3]=y+V;p[P>>3]=N+S;p[W>>3]=y-V;p[Z>>3]=N-S;B=B+1|0;if((B|0)==(F|0))break;else E=E+s|0}}t=t+w|0}while((t|0)<(i|0))}t=w<<2;if((t|0)>(H|0)){I=w;J=s;break}else{v=w;x=s;w=t;F=v}}}if((I|0)<(H|0)){F=f[j>>2]|0;w=(F|0)>0;x=I;i=J;while(1){G=x<<1;v=(i|0)/2|0;b:do if(w){if((x|0)>1)_=0;else{t=0;while(1){r=d+(t<<4)|0;S=+p[r>>3];E=r+(x<<4)|0;N=+p[E>>3];B=d+(t<<4)+8|0;V=+p[B>>3];A=E+8|0;y=+p[A>>3];p[r>>3]=S+N;p[B>>3]=V+y;p[E>>3]=S-N;p[A>>3]=V-y;t=t+G|0;if((t|0)>=(F|0))break b}}do{t=d+(_<<4)|0;y=+p[t>>3];A=t+(x<<4)|0;V=+p[A>>3];E=d+(_<<4)+8|0;N=+p[E>>3];B=A+8|0;S=+p[B>>3];p[t>>3]=y+V;p[E>>3]=N+S;p[A>>3]=y-V;p[B>>3]=N-S;B=v;A=1;while(1){E=t+(A<<4)|0;r=E+(x<<4)|0;S=+p[r>>3];N=+p[h+(B<<4)>>3];Z=r+8|0;V=+p[Z>>3];y=+p[h+(B<<4)+8>>3];L=S*N-V*y;O=N*V+S*y;y=+p[E>>3];W=E+8|0;S=+p[W>>3];p[E>>3]=y+L;p[W>>3]=S+O;p[r>>3]=y-L;p[Z>>3]=S-O;A=A+1|0;if((A|0)==(x|0))break;else B=B+v|0}_=_+G|0}while((_|0)<(F|0))}while(0);if((G|0)<(H|0)){x=G;i=v}else{$=G;aa=v;break}}}else{$=I;aa=J}}else{$=1;aa=n}n=q^1;c:do if((n|0)<(f[a>>2]|0)){q=g+8|0;J=g+4|0;I=n;i=$;x=aa;H=k;while(1){F=f[H+(I<<2)>>2]|0;_=Y(F,i)|0;w=(x|0)/(F|0)|0;d:do switch(F|0){case 3:{s=f[j>>2]|0;if((s|0)>0){B=i<<1;if((i|0)>1)ba=0;else{A=0;while(1){t=d+(A<<4)|0;Z=t+(i<<4)|0;O=+p[Z>>3];r=t+(B<<4)|0;S=+p[r>>3];L=O+S;W=Z+8|0;y=+p[W>>3];E=r+8|0;V=+p[E>>3];N=y+V;z=+p[t>>3];P=d+(A<<4)+8|0;M=+p[P>>3];U=(y-V)*.8660254037844386;V=(S-O)*.8660254037844386;p[t>>3]=L+z;p[P>>3]=N+M;O=z-L*.5;L=M-N*.5;p[Z>>3]=O+U;p[W>>3]=V+L;p[r>>3]=O-U;p[E>>3]=L-V;A=A+_|0;if((A|0)>=(s|0))break d}}do{A=d+(ba<<4)|0;E=A+(i<<4)|0;V=+p[E>>3];r=A+(B<<4)|0;L=+p[r>>3];U=V+L;W=E+8|0;O=+p[W>>3];Z=r+8|0;N=+p[Z>>3];M=O+N;z=+p[A>>3];P=d+(ba<<4)+8|0;S=+p[P>>3];y=(O-N)*.8660254037844386;N=(L-V)*.8660254037844386;p[A>>3]=U+z;p[P>>3]=M+S;V=z-U*.5;U=S-M*.5;p[E>>3]=V+y;p[W>>3]=N+U;p[r>>3]=V-y;p[Z>>3]=U-N;Z=w;r=1;while(1){W=A+(r<<4)|0;E=W+(i<<4)|0;N=+p[E>>3];U=+p[h+(Z<<4)>>3];P=E+8|0;y=+p[P>>3];V=+p[h+(Z<<4)+8>>3];M=N*U-y*V;S=U*y+N*V;t=W+(B<<4)|0;V=+p[t>>3];C=Z<<1;N=+p[h+(C<<4)>>3];D=t+8|0;y=+p[D>>3];U=+p[h+(C<<4)+8>>3];z=V*N-y*U;L=N*y+V*U;U=M+z;V=S+L;y=(S-L)*.8660254037844386;L=(z-M)*.8660254037844386;M=+p[W>>3];C=W+8|0;z=+p[C>>3];p[W>>3]=M+U;p[C>>3]=z+V;S=M-U*.5;U=z-V*.5;p[E>>3]=y+S;p[P>>3]=L+U;p[t>>3]=S-y;p[D>>3]=U-L;r=r+1|0;if((r|0)==(i|0))break;else Z=Z+w|0}ba=ba+_|0}while((ba|0)<(s|0))}break}case 5:{s=f[j>>2]|0;if((s|0)>0){B=(i|0)>0;Z=i<<1;r=0;do{if(B){A=d+(r<<4)|0;D=0;t=0;while(1){P=A+(t<<4)|0;E=P+(Z<<4)|0;C=E+(Z<<4)|0;W=P+(i<<4)|0;L=+p[W>>3];U=+p[h+(D<<4)>>3];Q=W+8|0;y=+p[Q>>3];S=+p[h+(D<<4)+8>>3];V=L*U-y*S;z=U*y+L*S;S=+p[C>>3];X=D<<2;L=+p[h+(X<<4)>>3];R=C+8|0;y=+p[R>>3];U=+p[h+(X<<4)+8>>3];M=S*L-y*U;N=L*y+S*U;U=V+M;S=z+N;y=V-M;M=z-N;X=E+(i<<4)|0;N=+p[X>>3];ca=D*3|0;z=+p[h+(ca<<4)>>3];da=X+8|0;V=+p[da>>3];L=+p[h+(ca<<4)+8>>3];O=N*z-V*L;K=z*V+N*L;L=+p[E>>3];ca=D<<1;N=+p[h+(ca<<4)>>3];ea=E+8|0;V=+p[ea>>3];z=+p[h+(ca<<4)+8>>3];T=L*N-V*z;fa=N*V+L*z;z=O+T;L=K+fa;V=O-T;T=K-fa;fa=+p[P>>3];ca=P+8|0;K=+p[ca>>3];O=U+z;N=S+L;p[P>>3]=fa+O;p[ca>>3]=K+N;ga=fa-O*.25;O=K-N*.25;N=(U-z)*.5590169943749475;z=(S-L)*.5590169943749475;L=(M+T)*.9510565162951535;S=(y+V)*-.9510565162951535;U=L-M*.36327126400268045;M=y*.36327126400268045+S;y=L-T*1.5388417685876268;T=V*1.5388417685876268+S;S=N+ga;V=z+O;L=ga-N;N=O-z;p[W>>3]=y+S;p[Q>>3]=T+V;p[C>>3]=S-y;p[R>>3]=V-T;p[E>>3]=U+L;p[ea>>3]=M+N;p[X>>3]=L-U;p[da>>3]=N-M;t=t+1|0;if((t|0)==(i|0))break;else D=D+w|0}}r=r+_|0}while((r|0)<(s|0))}break}default:{s=F+-1|0;r=(s|0)/2|0;Z=(f[m>>2]|0)/(F|0)|0;B=r<<1;XIc(q|0,0,1152)|0;f[g>>2]=q;f[J>>2]=B;if(B>>>0>72){D=XDc(B>>>0>268435455?-1:B<<4)|0;XIc(D|0,0,r<<5|0)|0;f[g>>2]=D;ha=D}else ha=q;D=ha+(r<<4)|0;B=f[j>>2]|0;if((B|0)>0){t=(i|0)>0;A=(F|0)<3;da=(s|0)>1;s=0;X=B;while(1){if(t){B=d+(s<<4)|0;ea=0;E=0;while(1){R=B+(ea<<4)|0;M=+p[R>>3];C=R+8|0;N=+p[C>>3];if(!ea){if(!A){Q=i;W=1;U=M;L=N;while(1){ca=R+(Q<<4)|0;T=+p[ca>>3];P=R+(_-Q<<4)|0;V=+p[P>>3];y=T+V;S=+p[ca+8>>3];z=+p[P+8>>3];O=S+z;ga=U+y;K=L+O;P=W+-1|0;p[ha+(P<<4)>>3]=y;p[ha+(P<<4)+8>>3]=S-z;ca=D+(P<<4)|0;p[ca>>3]=T-V;p[ca+8>>3]=O;if((W|0)<(r|0)){Q=Q+i|0;W=W+1|0;U=ga;L=K}else{ia=ga;ja=K;ka=82;break}}}}else{W=h+((Y(E,F)|0)<<4)|0;if(!A){Q=E;ca=i;P=1;L=M;U=N;while(1){la=R+(ca<<4)|0;K=+p[la>>3];ga=+p[h+(Q<<4)>>3];O=+p[la+8>>3];V=+p[h+(Q<<4)+8>>3];T=K*ga-O*V;z=ga*O+K*V;la=R+(_-ca<<4)|0;V=+p[la>>3];ma=W+(0-Q<<4)|0;K=+p[ma>>3];O=+p[la+8>>3];ga=+p[ma+8>>3];S=V*K-O*ga;y=K*O+V*ga;ga=T+S;V=z+y;O=L+ga;K=U+V;ma=P+-1|0;p[ha+(ma<<4)>>3]=ga;p[ha+(ma<<4)+8>>3]=z-y;la=D+(ma<<4)|0;p[la>>3]=T-S;p[la+8>>3]=V;if((P|0)<(r|0)){Q=Q+E|0;ca=ca+i|0;P=P+1|0;L=O;U=K}else{ia=O;ja=K;ka=82;break}}}}e:do if((ka|0)==82?(ka=0,p[R>>3]=ia,p[C>>3]=ja,!A):0){if(da){na=i;oa=1}else{P=i;ca=1;while(1){Q=R+(P<<4)|0;p[Q>>3]=M;p[Q+8>>3]=N;Q=R+(_-P<<4)|0;p[Q>>3]=M;p[Q+8>>3]=N;if((ca|0)<(r|0)){P=P+i|0;ca=ca+1|0}else break e}}while(1){ca=Y(oa,Z)|0;P=f[m>>2]|0;Q=0;W=ca;U=M;L=M;K=N;O=N;while(1){V=+p[h+(W<<4)>>3];S=V*+p[ha+(Q<<4)>>3];T=+p[h+(W<<4)+8>>3];y=T*+p[ha+(Q<<4)+8>>3];la=D+(Q<<4)|0;z=V*+p[la+8>>3];V=T*+p[la>>3];U=U+(S+y);L=L+(S-y);K=K+(z-V);O=O+(z+V);la=W+ca|0;Q=Q+1|0;if((Q|0)>=(r|0))break;else W=la-((la|0)>=(P|0)?P:0)|0}P=R+(na<<4)|0;p[P>>3]=L;p[P+8>>3]=O;P=R+(_-na<<4)|0;p[P>>3]=U;p[P+8>>3]=K;if((oa|0)<(r|0)){na=na+i|0;oa=oa+1|0}else break}}while(0);ea=ea+1|0;if((ea|0)==(i|0))break;else E=E+w|0}pa=f[j>>2]|0}else pa=X;s=s+_|0;if((s|0)>=(pa|0))break;else X=pa}}if((ha|0)!=(q|0)){ZDc(ha);f[g>>2]=q;f[J>>2]=72}}}while(0);F=I+1|0;if((F|0)>=(f[a>>2]|0))break c;I=F;i=_;x=w;H=f[c>>2]|0}}while(0);if(o!=1.0){ja=l?-o:o;c=f[j>>2]|0;if((c|0)>0)qa=0;else{u=e;return}do{a=d+(qa<<4)|0;g=d+(qa<<4)+8|0;ia=ja*+p[g>>3];p[a>>3]=o*+p[a>>3];p[g>>3]=ia;qa=qa+1|0}while((qa|0)<(c|0));u=e;return}if(!l){u=e;return}l=f[j>>2]|0;if((l|0)<2)ra=0;else{j=l+-2|0;c=((j|0)>1?j:1)&2147483646;qa=0;do{g=d+(qa<<4)+8|0;a=d+((qa|1)<<4)+8|0;o=-+p[a>>3];p[g>>3]=-+p[g>>3];p[a>>3]=o;qa=qa+2|0}while((qa|0)<=(j|0));ra=c+2|0}c=d+(l+-1<<4)+8|0;if((ra|0)>=(l|0)){u=e;return}p[c>>3]=-+p[c>>3];u=e;return}function YM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,211724,d);return}function ZM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=b[a+34>>0]|0;j=i<<24>>24!=0;k=i&255;l=+p[a+8>>3];i=d+(k<<3)|0;d=(h|0)==1;do if(d){p[i>>3]=l*+p[c>>3];m=i}else{if((h|0)==2){n=+p[c>>3];o=+p[c+8>>3];p[i+8>>3]=l*(n-o);p[i>>3]=l*(n+o);m=i;break}if(h&1|0){q=i+(0-k<<3)|0;p[q>>3]=l*+p[c>>3];r=q+8|0;p[r>>3]=0.0;if((h|0)>1){s=f[a+16>>2]|0;t=1;do{v=t+1|0;o=l*+p[c+(f[s+(v<<2)>>2]<<3)>>3];p[q+(t<<4)>>3]=l*+p[c+(f[s+(t<<2)>>2]<<3)>>3];p[q+(t<<4)+8>>3]=0.0;p[q+(v<<4)>>3]=o;p[q+(v<<4)+8>>3]=0.0;t=t+2|0}while((t|0)<(h|0))}w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;XM(g,q,q);if(!j)p[r>>3]=+p[q>>3];m=q;break}o=l*.5;t=h>>1;s=a+4|0;v=f[s>>2]|0;z=f[v>>2]>>1;f[v>>2]=z;w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));q=(z|0)==1&1;r=g+4|0;f[r>>2]=(f[r>>2]|0)+(q<<2);f[g>>2]=(f[g>>2]|0)-q;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=0;p[g+8>>3]=1.0;f[g+28>>2]=t;XM(g,c,i);q=f[s>>2]|0;f[q>>2]=f[q>>2]<<1;n=+p[i>>3];q=i+8|0;A=+p[q>>3];p[i>>3]=l*(n+A);B=l*(n-A);p[q>>3]=B;q=i+(t<<3)|0;A=+p[q>>3];r=i+(h+-1<<3)|0;n=+p[r>>3];p[r>>3]=B;if((t|0)>2){B=n;r=f[a+20>>2]|0;v=2;do{C=r;r=r+16|0;D=+p[i+((v|1)<<3)>>3];E=o*(B+D);F=h-v|0;G=i+(F<<3)|0;H=+p[G>>3];I=i+(v<<3)|0;J=+p[I>>3];K=o*(H-J);L=o*(H+J);J=o*(D-B);D=+p[r>>3];H=+p[C+24>>3];M=E*D-K*H;N=E*H+D*K;C=i+(F+-1<<3)|0;B=+p[C>>3];p[i+(v+-1<<3)>>3]=L+M;p[C>>3]=L-M;p[I>>3]=J+N;p[G>>3]=N-J;v=v+2|0}while((v|0)<(t|0));O=B;P=t+1&-2}else{O=n;P=2}if((P|0)<=(t|0)){p[i+(t+-1<<3)>>3]=l*A;p[q>>3]=-(l*O)}m=i}while(0);if(!j){u=e;return}if(!(d|(h&1|0)==0)){u=e;return}p[m+-8>>3]=+p[m>>3];p[m>>3]=0.0;if((h|0)<=1){u=e;return}p[m+(h<<3)>>3]=0.0;u=e;return}function _M(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,o=0,q=0.0,r=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0.0,R=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=(b[a+34>>0]|0)!=0;j=+p[a+8>>3];if(i){k=c+4|0;l=+n[k>>2];m=f[c>>2]|0;f[k>>2]=m;o=k;q=l;r=(f[s>>2]=m,+n[s>>2])}else{o=c;q=0.0;r=+n[c>>2]}a:do switch(h|0){case 1:{n[d>>2]=j*r;break}case 2:{l=+n[o+4>>2];n[d+4>>2]=j*(r-l);n[d>>2]=j*(r+l);break}default:{c=h+1>>1;if(h&1|0){m=o+-4|0;n[d>>2]=r;n[d+4>>2]=0.0;if((c|0)>1){k=f[a+16>>2]|0;t=1;do{v=f[k+(t<<2)>>2]|0;w=f[k+(h-t<<2)>>2]|0;x=f[m+(t<<3)>>2]|0;l=+n[m+(t<<3)+4>>2];f[d+(v<<3)>>2]=x;n[d+(v<<3)+4>>2]=-l;f[d+(w<<3)>>2]=x;n[d+(w<<3)+4>>2]=l;t=t+1|0}while((t|0)!=(c|0))}y=g;z=a;A=y+48|0;do{f[y>>2]=f[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;f[g+28>>2]=h;$M(g,d,d);n[d>>2]=j*+n[d>>2];if((h|0)>1){t=1;do{m=t<<1;l=j*+n[d+(m+2<<2)>>2];n[d+(t<<2)>>2]=j*+n[d+(m<<2)>>2];n[d+(t+1<<2)>>2]=l;t=t+2|0}while((t|0)<(h|0))}break a}t=(o|0)==(d|0);m=f[a+20>>2]|0;l=+n[o+4>>2];B=+n[o+(h+-1<<2)>>2];n[d>>2]=r+B;n[d+4>>2]=B-r;k=m+8|0;do if((c|0)>2){if(t){w=k;B=l;x=2;v=m;while(1){C=h-x|0;D=+n[d+(C+-1<<2)>>2];E=B+D;F=d+(x<<2)|0;G=+n[F>>2];H=d+(C<<2)|0;I=+n[H>>2];J=G-I;K=B-D;D=G+I;I=+n[w>>2];G=+n[v+12>>2];L=K*I+D*G;M=D*I-K*G;N=d+((x|1)<<2)|0;B=+n[N>>2];n[F>>2]=E-M;n[N>>2]=-J-L;n[H>>2]=E+M;n[d+(C+1<<2)>>2]=J-L;x=x+2|0;if((x|0)>=(c|0))break;else{C=w;w=w+8|0;v=C}}O=B;P=c+1&-2;break}v=f[a+16>>2]|0;w=k;L=l;x=2;C=m;while(1){H=h-x|0;J=+n[o+(H+-1<<2)>>2];M=L+J;E=+n[o+(x<<2)>>2];G=+n[o+(H<<2)>>2];K=E-G;I=L-J;J=E+G;G=+n[w>>2];E=+n[C+12>>2];D=I*G+J*E;Q=J*G-I*E;L=+n[o+((x|1)<<2)>>2];H=x>>1;N=f[v+(H<<2)>>2]|0;n[d+(N<<2)>>2]=M-Q;n[d+(N+1<<2)>>2]=-K-D;N=f[v+(c-H<<2)>>2]|0;n[d+(N<<2)>>2]=M+Q;n[d+(N+1<<2)>>2]=K-D;x=x+2|0;if((x|0)>=(c|0))break;else{N=w;w=w+8|0;C=N}}O=L;P=c+1&-2}else{O=l;P=2}while(0);if((P|0)<=(c|0)){l=+n[o+(c<<2)>>2]*2.0;if(t)R=c;else R=f[(f[a+16>>2]|0)+(c<<2)>>2]<<1;n[d+(R<<2)>>2]=O*2.0;n[d+(R+1<<2)>>2]=l}m=a+4|0;k=f[m>>2]|0;C=f[k>>2]>>1;f[k>>2]=C;y=g;z=a;A=y+48|0;do{f[y>>2]=f[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));k=(C|0)==1&1;w=g+4|0;f[w>>2]=(f[w>>2]|0)+(k<<2);f[g>>2]=(f[g>>2]|0)-k;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=(t^1)&1;p[g+8>>3]=1.0;f[g+28>>2]=c;$M(g,d,d);k=f[m>>2]|0;f[k>>2]=f[k>>2]<<1;if((h|0)>0){k=0;do{w=d+(k<<2)|0;x=d+((k|1)<<2)|0;l=-(j*+n[x>>2]);n[w>>2]=j*+n[w>>2];n[x>>2]=l;k=k+2|0}while((k|0)<(h|0))}}}while(0);if(!i){u=e;return}n[o>>2]=q;u=e;return}function $M(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+1104|0;g=e;h=f[a+20>>2]|0;i=f[a+16>>2]|0;j=a+28|0;k=f[j>>2]|0;l=(b[a+32>>0]|0)!=0;m=a+24|0;o=f[m>>2]|0;q=+p[a+8>>3];if((o|0)!=(k|0))if((o|0)==(k<<1|0))r=2;else r=(o|0)/(k|0)|0;else r=1;do if((d|0)==(c|0)){a:do if(!(b[a+33>>0]|0)){s=f[a+4>>2]|0;t=f[a>>2]|0;if((f[s>>2]|0)!=(f[s+(t+-1<<2)>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;s=tT(g,33)|0;v=211686;w=s+33|0;do{b[s>>0]=b[v>>0]|0;s=s+1|0;v=v+1|0}while((s|0)<(w|0));YM(-215,g,211720,657)}if((t|0)!=1){if((k|0)>0){x=0;y=i}else break;while(1){v=f[y>>2]|0;if((v|0)>(x|0)){s=d+(x<<3)|0;w=f[s>>2]|0;z=f[d+(x<<3)+4>>2]|0;A=d+(v<<3)|0;B=A;C=f[B+4>>2]|0;D=s;f[D>>2]=f[B>>2];f[D+4>>2]=C;f[A>>2]=w;f[d+(v<<3)+4>>2]=z}x=x+1|0;if((x|0)==(k|0))break a;else y=y+(r<<2)|0}}if((k&3|0)==0?(t=(k|0)/2|0,z=d+(t<<3)|0,(k|0)>1):0){v=r<<1;w=0;A=i;while(1){C=f[A>>2]|0;D=w|1;B=d+(D<<3)|0;s=f[B>>2]|0;E=f[d+(D<<3)+4>>2]|0;F=z+(C<<3)|0;G=F;H=f[G+4>>2]|0;I=B;f[I>>2]=f[G>>2];f[I+4>>2]=H;f[F>>2]=s;f[F+4>>2]=E;if((C|0)>(w|0)){E=d+(w<<3)|0;F=f[E>>2]|0;s=f[d+(w<<3)+4>>2]|0;H=d+(C<<3)|0;I=H;G=f[I+4>>2]|0;B=E;f[B>>2]=f[I>>2];f[B+4>>2]=G;f[H>>2]=F;f[d+(C<<3)+4>>2]=s;s=z+(D<<3)|0;D=f[s>>2]|0;F=f[s+4>>2]|0;H=z+(C+1<<3)|0;C=H;G=f[C+4>>2]|0;B=s;f[B>>2]=f[C>>2];f[B+4>>2]=G;f[H>>2]=D;f[H+4>>2]=F}w=w+2|0;if((w|0)>=(t|0))break;else A=A+(v<<2)|0}}}while(0);if(l){v=k+-2|0;if((k|0)<2)J=0;else{A=0;do{t=d+(A<<3)+4|0;w=d+((A|1)<<3)+4|0;K=-+n[w>>2];n[t>>2]=-+n[t>>2];n[w>>2]=K;A=A+2|0}while((A|0)<=(v|0));J=k&-2}v=d+(k+-1<<3)+4|0;if((J|0)<(k|0))n[v>>2]=-+n[v>>2]}}else{v=k+-2|0;A=(k|0)<2;if(l){if(A)L=0;else{w=r<<1;t=0;z=i;while(1){F=f[z>>2]|0;H=f[z+(r<<2)>>2]|0;K=-+n[c+(F<<3)+4>>2];f[d+(t<<3)>>2]=f[c+(F<<3)>>2];n[d+(t<<3)+4>>2]=K;K=-+n[c+(H<<3)+4>>2];F=t|1;f[d+(F<<3)>>2]=f[c+(H<<3)>>2];n[d+(F<<3)+4>>2]=K;t=t+2|0;if((t|0)>(v|0))break;else z=z+(w<<2)|0}L=k&-2}if((L|0)>=(k|0))break;w=k+-1|0;K=-+n[c+(w<<3)+4>>2];f[d+(L<<3)>>2]=f[c+(w<<3)>>2];n[d+(L<<3)+4>>2]=K;break}else{if(A)M=0;else{w=r<<1;z=0;t=i;while(1){F=f[t+(r<<2)>>2]|0;H=c+(f[t>>2]<<3)|0;D=f[H+4>>2]|0;G=d+(z<<3)|0;f[G>>2]=f[H>>2];f[G+4>>2]=D;D=c+(F<<3)|0;F=f[D+4>>2]|0;G=d+((z|1)<<3)|0;f[G>>2]=f[D>>2];f[G+4>>2]=F;z=z+2|0;if((z|0)>(v|0))break;else t=t+(w<<2)|0}M=k&-2}w=k+-1|0;if((M|0)>=(k|0))break;t=c+(w<<3)|0;v=f[t+4>>2]|0;z=d+(w<<3)|0;f[z>>2]=f[t>>2];f[z+4>>2]=v;break}}while(0);c=a+4|0;k=f[c>>2]|0;M=f[k>>2]|0;r=M&1;if(!r){if((M|0)<4){N=1;O=o}else{i=f[j>>2]|0;L=(i|0)>0;J=1;y=o;x=4;while(1){v=(y|0)/4|0;if(L){z=J<<1;t=(J|0)>1;w=0;do{A=d+(w<<3)|0;F=A+(z<<3)|0;K=+n[F>>2];G=F+4|0;P=+n[G>>2];D=F+(J<<3)|0;Q=+n[D>>2];H=D+4|0;R=+n[H>>2];S=K+Q;T=P+R;U=P-R;R=Q-K;K=+n[A>>2];B=d+(w<<3)+4|0;Q=+n[B>>2];C=A+(J<<3)|0;P=+n[C>>2];s=C+4|0;V=+n[s>>2];W=K+P;X=Q+V;Z=K-P;P=Q-V;n[A>>2]=S+W;n[B>>2]=T+X;n[F>>2]=W-S;n[G>>2]=X-T;n[C>>2]=U+Z;n[s>>2]=R+P;n[D>>2]=Z-U;n[H>>2]=P-R;if(t){H=v;D=1;while(1){s=A+(D<<3)|0;C=s+(z<<3)|0;G=s+(J<<3)|0;R=+n[G>>2];F=H<<1;P=+n[h+(F<<3)>>2];B=G+4|0;U=+n[B>>2];Z=+n[h+(F<<3)+4>>2];T=R*P-U*Z;X=P*U+R*Z;Z=+n[C>>2];R=+n[h+(H<<3)+4>>2];F=C+4|0;U=+n[F>>2];P=+n[h+(H<<3)>>2];S=Z*R+U*P;W=Z*P-R*U;I=C+(J<<3)|0;U=+n[I>>2];E=H*3|0;R=+n[h+(E<<3)+4>>2];_=I+4|0;P=+n[_>>2];Z=+n[h+(E<<3)>>2];V=U*R+P*Z;Q=U*Z-R*P;P=W+Q;R=S+V;Z=S-V;V=Q-W;W=+n[s>>2];E=s+4|0;Q=+n[E>>2];S=T+W;U=X+Q;K=W-T;T=Q-X;n[s>>2]=S+P;n[E>>2]=U+R;n[C>>2]=S-P;n[F>>2]=U-R;n[G>>2]=K+Z;n[B>>2]=T+V;n[I>>2]=K-Z;n[_>>2]=T-V;D=D+1|0;if((D|0)==(J|0))break;else H=H+v|0}}w=w+x|0}while((w|0)<(i|0))}w=x<<2;if((w|0)>(M|0)){N=x;O=v;break}else{z=x;y=v;x=w;J=z}}}if((N|0)<(M|0)){J=f[j>>2]|0;x=(J|0)>0;y=N;i=O;while(1){L=y<<1;z=(i|0)/2|0;b:do if(x){if((y|0)>1)$=0;else{w=0;while(1){t=d+(w<<3)|0;V=+n[t>>2];H=t+(y<<3)|0;T=+n[H>>2];D=d+(w<<3)+4|0;Z=+n[D>>2];A=H+4|0;K=+n[A>>2];n[t>>2]=V+T;n[D>>2]=Z+K;n[H>>2]=V-T;n[A>>2]=Z-K;w=w+L|0;if((w|0)>=(J|0))break b}}do{w=d+($<<3)|0;K=+n[w>>2];A=w+(y<<3)|0;Z=+n[A>>2];H=d+($<<3)+4|0;T=+n[H>>2];D=A+4|0;V=+n[D>>2];n[w>>2]=K+Z;n[H>>2]=T+V;n[A>>2]=K-Z;n[D>>2]=T-V;D=z;A=1;while(1){H=w+(A<<3)|0;t=H+(y<<3)|0;V=+n[t>>2];T=+n[h+(D<<3)>>2];_=t+4|0;Z=+n[_>>2];K=+n[h+(D<<3)+4>>2];R=V*T-Z*K;U=T*Z+V*K;K=+n[H>>2];I=H+4|0;V=+n[I>>2];n[H>>2]=K+R;n[I>>2]=V+U;n[t>>2]=K-R;n[_>>2]=V-U;A=A+1|0;if((A|0)==(y|0))break;else D=D+z|0}$=$+L|0}while(($|0)<(J|0))}while(0);if((L|0)<(M|0)){y=L;i=z}else{aa=L;ba=z;break}}}else{aa=N;ba=O}}else{aa=1;ba=o}o=r^1;c:do if((o|0)<(f[a>>2]|0)){r=g+8|0;O=g+4|0;N=o;i=aa;y=ba;M=k;while(1){J=f[M+(N<<2)>>2]|0;$=Y(J,i)|0;x=(y|0)/(J|0)|0;d:do switch(J|0){case 3:{v=f[j>>2]|0;if((v|0)>0){D=i<<1;if((i|0)>1)ca=0;else{A=0;while(1){w=d+(A<<3)|0;_=w+(i<<3)|0;U=+n[_>>2];t=w+(D<<3)|0;V=+n[t>>2];R=U+V;I=_+4|0;K=+n[I>>2];H=t+4|0;Z=+n[H>>2];T=K+Z;P=+n[w>>2];B=d+(A<<3)+4|0;S=+n[B>>2];X=(K-Z)*.8660253882408142;Z=(V-U)*.8660253882408142;n[w>>2]=R+P;n[B>>2]=T+S;U=P-R*.5;R=S-T*.5;n[_>>2]=U+X;n[I>>2]=Z+R;n[t>>2]=U-X;n[H>>2]=R-Z;A=A+$|0;if((A|0)>=(v|0))break d}}do{A=d+(ca<<3)|0;H=A+(i<<3)|0;Z=+n[H>>2];t=A+(D<<3)|0;R=+n[t>>2];X=Z+R;I=H+4|0;U=+n[I>>2];_=t+4|0;T=+n[_>>2];S=U+T;P=+n[A>>2];B=d+(ca<<3)+4|0;V=+n[B>>2];K=(U-T)*.8660253882408142;T=(R-Z)*.8660253882408142;n[A>>2]=X+P;n[B>>2]=S+V;Z=P-X*.5;X=V-S*.5;n[H>>2]=Z+K;n[I>>2]=T+X;n[t>>2]=Z-K;n[_>>2]=X-T;_=x;t=1;while(1){I=A+(t<<3)|0;H=I+(i<<3)|0;T=+n[H>>2];X=+n[h+(_<<3)>>2];B=H+4|0;K=+n[B>>2];Z=+n[h+(_<<3)+4>>2];S=T*X-K*Z;V=X*K+T*Z;w=I+(D<<3)|0;Z=+n[w>>2];G=_<<1;T=+n[h+(G<<3)>>2];F=w+4|0;K=+n[F>>2];X=+n[h+(G<<3)+4>>2];P=Z*T-K*X;R=T*K+Z*X;X=S+P;Z=V+R;K=(V-R)*.8660253882408142;R=(P-S)*.8660253882408142;S=+n[I>>2];G=I+4|0;P=+n[G>>2];n[I>>2]=S+X;n[G>>2]=P+Z;V=S-X*.5;X=P-Z*.5;n[H>>2]=K+V;n[B>>2]=R+X;n[w>>2]=V-K;n[F>>2]=X-R;t=t+1|0;if((t|0)==(i|0))break;else _=_+x|0}ca=ca+$|0}while((ca|0)<(v|0))}break}case 5:{v=f[j>>2]|0;if((v|0)>0){D=(i|0)>0;_=i<<1;t=0;do{if(D){A=d+(t<<3)|0;F=0;w=0;while(1){B=A+(w<<3)|0;H=B+(_<<3)|0;G=H+(_<<3)|0;I=B+(i<<3)|0;R=+n[I>>2];X=+n[h+(F<<3)>>2];C=I+4|0;K=+n[C>>2];V=+n[h+(F<<3)+4>>2];Z=R*X-K*V;P=X*K+R*V;V=+n[G>>2];E=F<<2;R=+n[h+(E<<3)>>2];s=G+4|0;K=+n[s>>2];X=+n[h+(E<<3)+4>>2];S=V*R-K*X;T=R*K+V*X;X=Z+S;V=P+T;K=Z-S;S=P-T;E=H+(i<<3)|0;T=+n[E>>2];da=F*3|0;P=+n[h+(da<<3)>>2];ea=E+4|0;Z=+n[ea>>2];R=+n[h+(da<<3)+4>>2];U=T*P-Z*R;Q=P*Z+T*R;R=+n[H>>2];da=F<<1;T=+n[h+(da<<3)>>2];fa=H+4|0;Z=+n[fa>>2];P=+n[h+(da<<3)+4>>2];W=R*T-Z*P;ga=T*Z+R*P;P=U+W;R=Q+ga;Z=U-W;W=Q-ga;ga=+n[B>>2];da=B+4|0;Q=+n[da>>2];U=X+P;T=V+R;n[B>>2]=ga+U;n[da>>2]=Q+T;ha=ga-U*.25;U=Q-T*.25;T=(X-P)*.55901700258255;P=(V-R)*.55901700258255;R=(S+W)*.9510565400123596;V=(K+Z)*-.9510565400123596;X=R-S*.3632712662220001;S=K*.3632712662220001+V;K=R-W*1.538841724395752;W=Z*1.538841724395752+V;V=T+ha;Z=P+U;R=ha-T;T=U-P;n[I>>2]=K+V;n[C>>2]=W+Z;n[G>>2]=V-K;n[s>>2]=Z-W;n[H>>2]=X+R;n[fa>>2]=S+T;n[E>>2]=R-X;n[ea>>2]=T-S;w=w+1|0;if((w|0)==(i|0))break;else F=F+x|0}}t=t+$|0}while((t|0)<(v|0))}break}default:{v=J+-1|0;t=(v|0)/2|0;_=(f[m>>2]|0)/(J|0)|0;D=t<<1;XIc(r|0,0,1088)|0;f[g>>2]=r;f[O>>2]=D;if(D>>>0>136){F=XDc(D>>>0>536870911?-1:D<<3)|0;XIc(F|0,0,t<<4|0)|0;f[g>>2]=F;ia=F}else ia=r;F=ia+(t<<3)|0;D=f[j>>2]|0;if((D|0)>0){w=(i|0)>0;A=(J|0)<3;ea=(v|0)>1;v=0;E=D;while(1){if(w){D=d+(v<<3)|0;fa=0;H=0;while(1){s=D+(fa<<3)|0;S=+n[s>>2];G=s+4|0;T=+n[G>>2];if(!fa){if(!A){C=i;I=1;X=S;R=T;while(1){da=s+(C<<3)|0;W=+n[da>>2];B=s+($-C<<3)|0;Z=+n[B>>2];K=W+Z;V=+n[da+4>>2];P=+n[B+4>>2];U=V+P;ha=X+K;Q=R+U;B=I+-1|0;n[ia+(B<<3)>>2]=K;n[ia+(B<<3)+4>>2]=V-P;da=F+(B<<3)|0;n[da>>2]=W-Z;n[da+4>>2]=U;if((I|0)<(t|0)){C=C+i|0;I=I+1|0;X=ha;R=Q}else{ja=ha;ka=Q;la=82;break}}}}else{I=h+((Y(H,J)|0)<<3)|0;if(!A){C=H;da=i;B=1;R=S;X=T;while(1){ma=s+(da<<3)|0;Q=+n[ma>>2];ha=+n[h+(C<<3)>>2];U=+n[ma+4>>2];Z=+n[h+(C<<3)+4>>2];W=Q*ha-U*Z;P=ha*U+Q*Z;ma=s+($-da<<3)|0;Z=+n[ma>>2];na=I+(0-C<<3)|0;Q=+n[na>>2];U=+n[ma+4>>2];ha=+n[na+4>>2];V=Z*Q-U*ha;K=Q*U+Z*ha;ha=W+V;Z=P+K;U=R+ha;Q=X+Z;na=B+-1|0;n[ia+(na<<3)>>2]=ha;n[ia+(na<<3)+4>>2]=P-K;ma=F+(na<<3)|0;n[ma>>2]=W-V;n[ma+4>>2]=Z;if((B|0)<(t|0)){C=C+H|0;da=da+i|0;B=B+1|0;R=U;X=Q}else{ja=U;ka=Q;la=82;break}}}}e:do if((la|0)==82?(la=0,n[s>>2]=ja,n[G>>2]=ka,!A):0){if(ea){oa=i;pa=1}else{B=i;da=1;while(1){C=s+(B<<3)|0;n[C>>2]=S;n[C+4>>2]=T;C=s+($-B<<3)|0;n[C>>2]=S;n[C+4>>2]=T;if((da|0)<(t|0)){B=B+i|0;da=da+1|0}else break e}}while(1){da=Y(pa,_)|0;B=f[m>>2]|0;C=0;I=da;X=S;R=S;Q=T;U=T;while(1){Z=+n[h+(I<<3)>>2];V=Z*+n[ia+(C<<3)>>2];W=+n[h+(I<<3)+4>>2];K=W*+n[ia+(C<<3)+4>>2];ma=F+(C<<3)|0;P=Z*+n[ma+4>>2];Z=W*+n[ma>>2];X=X+(V+K);R=R+(V-K);Q=Q+(P-Z);U=U+(P+Z);ma=I+da|0;C=C+1|0;if((C|0)>=(t|0))break;else I=ma-((ma|0)>=(B|0)?B:0)|0}B=s+(oa<<3)|0;n[B>>2]=R;n[B+4>>2]=U;B=s+($-oa<<3)|0;n[B>>2]=X;n[B+4>>2]=Q;if((pa|0)<(t|0)){oa=oa+i|0;pa=pa+1|0}else break}}while(0);fa=fa+1|0;if((fa|0)==(i|0))break;else H=H+x|0}qa=f[j>>2]|0}else qa=E;v=v+$|0;if((v|0)>=(qa|0))break;else E=qa}}if((ia|0)!=(r|0)){ZDc(ia);f[g>>2]=r;f[O>>2]=136}}}while(0);J=N+1|0;if((J|0)>=(f[a>>2]|0))break c;N=J;i=$;y=x;M=f[c>>2]|0}}while(0);if(q!=1.0){ka=l?-q:q;c=f[j>>2]|0;if((c|0)>0)ra=0;else{u=e;return}do{a=d+(ra<<3)|0;g=d+(ra<<3)+4|0;ja=ka*+n[g>>2];n[a>>2]=q*+n[a>>2];n[g>>2]=ja;ra=ra+1|0}while((ra|0)<(c|0));u=e;return}if(!l){u=e;return}l=f[j>>2]|0;if((l|0)<2)sa=0;else{j=l+-2|0;c=((j|0)>1?j:1)&2147483646;ra=0;do{g=d+(ra<<3)+4|0;a=d+((ra|1)<<3)+4|0;q=-+n[a>>2];n[g>>2]=-+n[g>>2];n[a>>2]=q;ra=ra+2|0}while((ra|0)<=(j|0));sa=c+2|0}c=d+(l+-1<<3)+4|0;if((sa|0)>=(l|0)){u=e;return}n[c>>2]=-+n[c>>2];u=e;return}function aN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=b[a+34>>0]|0;j=i<<24>>24!=0;k=i&255;l=+p[a+8>>3];i=d+(k<<2)|0;d=(h|0)==1;do if(d){n[i>>2]=l*+n[c>>2];m=i}else{if((h|0)==2){o=+n[c>>2];q=+n[c+4>>2];n[i+4>>2]=l*(o-q);n[i>>2]=l*(o+q);m=i;break}if(h&1|0){r=i+(0-k<<2)|0;n[r>>2]=l*+n[c>>2];s=r+4|0;n[s>>2]=0.0;if((h|0)>1){t=f[a+16>>2]|0;v=1;do{w=v+1|0;q=l*+n[c+(f[t+(w<<2)>>2]<<2)>>2];n[r+(v<<3)>>2]=l*+n[c+(f[t+(v<<2)>>2]<<2)>>2];n[r+(v<<3)+4>>2]=0.0;n[r+(w<<3)>>2]=q;n[r+(w<<3)+4>>2]=0.0;v=v+2|0}while((v|0)<(h|0))}x=g;y=a;z=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;$M(g,r,r);if(!j)f[s>>2]=f[r>>2];m=r;break}q=l*.5;v=h>>1;t=a+4|0;w=f[t>>2]|0;A=f[w>>2]>>1;f[w>>2]=A;x=g;y=a;z=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));r=(A|0)==1&1;s=g+4|0;f[s>>2]=(f[s>>2]|0)+(r<<2);f[g>>2]=(f[g>>2]|0)-r;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=0;p[g+8>>3]=1.0;f[g+28>>2]=v;$M(g,c,i);r=f[t>>2]|0;f[r>>2]=f[r>>2]<<1;o=+n[i>>2];r=i+4|0;B=+n[r>>2];n[i>>2]=l*(o+B);C=l*(o-B);n[r>>2]=C;r=i+(v<<2)|0;B=+n[r>>2];s=i+(h+-1<<2)|0;o=+n[s>>2];n[s>>2]=C;if((v|0)>2){C=o;s=f[a+20>>2]|0;w=2;do{D=s;s=s+8|0;E=+n[i+((w|1)<<2)>>2];F=q*(C+E);G=h-w|0;H=i+(G<<2)|0;I=+n[H>>2];J=i+(w<<2)|0;K=+n[J>>2];L=q*(I-K);M=q*(I+K);K=q*(E-C);E=+n[s>>2];I=+n[D+12>>2];N=F*E-L*I;O=F*I+E*L;D=i+(G+-1<<2)|0;C=+n[D>>2];n[i+(w+-1<<2)>>2]=M+N;n[D>>2]=M-N;n[J>>2]=K+O;n[H>>2]=O-K;w=w+2|0}while((w|0)<(v|0));P=C;Q=v+1&-2}else{P=o;Q=2}if((Q|0)<=(v|0)){n[i+(v+-1<<2)>>2]=l*B;n[r>>2]=-(l*P)}m=i}while(0);if(!j){u=e;return}if(!(d|(h&1|0)==0)){u=e;return}f[m+-4>>2]=f[m>>2];n[m>>2]=0.0;if((h|0)<=1){u=e;return}n[m+(h<<2)>>2]=0.0;u=e;return}function bN(a,b,c){a=a|0;b=b|0;c=c|0;Ti[f[a+44>>2]&511](a+8|0,b,c);return}function cN(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=34652;b=a+1232|0;c=f[b>>2]|0;d=a+1240|0;if((c|0)!=(d|0)){if(c|0)ZDc(c);f[b>>2]=d;f[a+1236>>2]=264}d=a+192|0;b=f[d>>2]|0;c=a+200|0;if((b|0)==(c|0))return;if(b|0)ZDc(b);f[d>>2]=c;f[a+196>>2]=1032;return}function dN(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=34652;b=a+1232|0;c=f[b>>2]|0;d=a+1240|0;if((c|0)!=(d|0)){if(c|0)ZDc(c);f[b>>2]=d;f[a+1236>>2]=264}d=f[a+192>>2]|0;if((d|0)==(a+200|0)|(d|0)==0){YDc(a);return}ZDc(d);YDc(a);return}function eN(a,b,c){a=a|0;b=b|0;c=c|0;return}function fN(a){a=a|0;YDc(a);return}function gN(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k;m=VDc(12)|0;f[m>>2]=34716;f[m+4>>2]=0;b[m+8>>0]=0;hN(m);YDc(m);if((c|0)==1&(j|0)>0){f[l>>2]=0;f[l+4>>2]=0;dJc(tT(l,190)|0,212105,190)|0;YM(-213,l,464481,3303)}else{l=VDc(4244)|0;f[l>>2]=34736;m=l+4|0;f[l+60>>2]=0;f[l+64>>2]=0;f[l+68>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[l+84>>2]=l+92;f[l+88>>2]=1032;f[l+1124>>2]=l+1132;f[l+1128>>2]=1032;f[l+2164>>2]=l+2172;f[l+2168>>2]=1032;f[l+3204>>2]=l+3212;f[l+3208>>2]=1032;b[l+20>>0]=0;b[l+21>>0]=0;b[l+22>>0]=0;m=l+24|0;f[l+52>>2]=0;b[l+56>>0]=0;b[l+57>>0]=0;b[l+72>>0]=0;f[l+76>>2]=0;f[l+80>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;b[m+24>>0]=0;iN(l,c,d,e,g,h,i,j);j=VDc(16)|0;f[j+4>>2]=1;f[j>>2]=34756;f[j+8>>2]=l;f[a>>2]=j;f[a+4>>2]=l;u=k;return}}function hN(a){a=a|0;f[a>>2]=34716;return}function iN(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;l=u;u=u+16|0;m=l;n=(g|0)!=(i|0);f[a+52>>2]=k;k=a+24|0;f[k>>2]=c;o=a+28|0;f[o>>2]=d;p=a+44|0;f[p>>2]=e;f[a+76>>2]=g;f[a+80>>2]=i;q=j&1;r=q&255;s=(g|0)==1;t=(i|0)==1;v=s&t;if(!q)if(!v){q=(i|0)==2;if(!(s&q))if((g|0)==2&q)w=3;else x=8;else w=2}else w=1;else if(!v){v=(g|0)==2;if(!(v&t))if(v&(i|0)==2)w=6;else x=8;else w=5}else w=4;if((x|0)==8)w=0;i=a+32|0;f[i>>2]=w;v=a+22|0;b[v>>0]=r;r=a+56|0;t=j>>>2&1;b[r>>0]=t;g=a+57|0;b[g>>0]=j>>>1&1;q=a+20|0;b[q>>0]=0;s=a+21|0;b[s>>0]=0;y=a+48|0;b[y>>0]=(w|0)!=6&(w|0)!=3&1;z=(e|0)==5?4:8;e=a+36|0;f[e>>2]=z;A=z<<1;z=a+40|0;f[z>>2]=A;switch(w&7){case 3:case 6:{f[e>>2]=A;break}default:{}}do if(!(t<<24>>24)){A=(d|0)>1;if(A&(c|0)==1){B=2-(j>>>9&1)|0;x=15;break}if((d|0)!=1){e=a+60|0;if(A&(c|0)>1){A=a+64|0;C=f[A>>2]|0;D=f[e>>2]|0;E=C-D>>2;F=D;G=C;if(E>>>0>=2)if((E|0)!=2?(C=F+8|0,(G|0)!=(C|0)):0){f[A>>2]=G+(~((G+-4-C|0)>>>2)<<2);H=D;I=w;J=F}else{H=D;I=w;J=F}else{lN(e,2-E|0);E=f[e>>2]|0;H=E;I=f[i>>2]|0;J=E}E=(I&-2|0)==4;f[J>>2]=E&1;f[J+4>>2]=(E^1)&1;K=e;L=H}else{M=e;N=0;x=23}}else{B=1;x=15}}else{B=1;x=15}while(0);if((x|0)==15){M=a+60|0;N=B;x=23}if((x|0)==23){x=a+64|0;B=f[x>>2]|0;H=f[M>>2]|0;J=B;switch(B-H>>2|0){case 0:{lN(M,1);break}case 1:break;default:{B=H+4|0;if((J|0)!=(B|0))f[x>>2]=J+(~((J+-4-B|0)>>>2)<<2)}}f[f[a+60>>2]>>2]=(N|0)==2&1;K=M;L=f[M>>2]|0}M=K+4|0;N=(f[M>>2]|0)-L>>2;if(!N){u=l;return}L=a+4|0;B=m+4|0;J=a+8|0;x=a+88|0;H=a+84|0;I=a+92|0;i=a+12|0;w=m+4|0;c=a+16|0;d=a+2168|0;t=a+2164|0;e=a+2172|0;E=a+3208|0;F=a+3204|0;D=a+3212|0;C=a+1128|0;G=a+1124|0;A=a+1132|0;a=n;n=(j&1024|0)!=0;j=0;O=f[K>>2]|0;P=N;do{N=(j|0)==1;n=N|n;a=a&(N^1);N=j;j=j+1|0;Q=h[v>>0]|0;R=(b[g>>0]|0)==0?Q:Q|2;Q=(b[r>>0]|0)==0;S=Q?R:R|4;R=a?S|16:S;S=(b[y>>0]|0)==0?R:R|32;R=(j|0)==(P|0)?S:S|64;S=f[k>>2]|0;T=f[o>>2]|0;do if(!(f[O+(N<<2)>>2]|0)){U=(S|0)!=1|Q^1;V=U?S:T;b[q>>0]=n&1;JM(m,V,U?T:1,f[p>>2]|0,R,q);U=f[m>>2]|0;W=f[B>>2]|0;if(U|0){X=U+4|0;f[X>>2]=(f[X>>2]|0)+1}X=f[L>>2]|0;f[L>>2]=U;f[J>>2]=W;if(X|0?(W=X+4|0,U=f[W>>2]|0,f[W>>2]=U+-1,(U|0)==1):0)Yi[f[(f[X>>2]|0)+8>>2]&2047](X);X=f[m>>2]|0;if(X|0?(U=X+4|0,W=f[U>>2]|0,f[U>>2]=W+-1,(W|0)==1):0)Yi[f[(f[X>>2]|0)+8>>2]&2047](X);if(b[q>>0]|0){X=Y(f[z>>2]|0,V)|0;if((f[x>>2]|0)>>>0>=X>>>0){f[x>>2]=X;break}V=f[H>>2]|0;if((V|0)!=(I|0)){if(V|0)ZDc(V);f[H>>2]=I;f[x>>2]=1032}f[x>>2]=X;if(X>>>0>1032){V=XDc(X)|0;f[H>>2]=V}}}else{b[s>>0]=n&1;JM(m,T,S,f[p>>2]|0,R|128,s);V=f[m>>2]|0;X=f[w>>2]|0;if(V|0){W=V+4|0;f[W>>2]=(f[W>>2]|0)+1}W=f[i>>2]|0;f[i>>2]=V;f[c>>2]=X;if(W|0?(X=W+4|0,V=f[X>>2]|0,f[X>>2]=V+-1,(V|0)==1):0)Yi[f[(f[W>>2]|0)+8>>2]&2047](W);W=f[m>>2]|0;if(W|0?(V=W+4|0,X=f[V>>2]|0,f[V>>2]=X+-1,(X|0)==1):0)Yi[f[(f[W>>2]|0)+8>>2]&2047](W);do if(b[s>>0]|0){W=Y(f[z>>2]|0,T)|0;if((f[C>>2]|0)>>>0>=W>>>0){f[C>>2]=W;break}X=f[G>>2]|0;if((X|0)!=(A|0)){if(X|0)ZDc(X);f[G>>2]=A;f[C>>2]=1032}f[C>>2]=W;if(W>>>0>1032){X=XDc(W)|0;f[G>>2]=X}}while(0);X=Y(f[z>>2]|0,T)|0;if((f[d>>2]|0)>>>0<X>>>0){W=f[t>>2]|0;if((W|0)!=(e|0)){if(W|0)ZDc(W);f[t>>2]=e;f[d>>2]=1032}f[d>>2]=X;if(X>>>0>1032){W=XDc(X)|0;f[t>>2]=W}}else f[d>>2]=X;X=Y(f[z>>2]|0,T)|0;if((f[E>>2]|0)>>>0>=X>>>0){f[E>>2]=X;break}W=f[F>>2]|0;if((W|0)!=(D|0)){if(W|0)ZDc(W);f[F>>2]=D;f[E>>2]=1032}f[E>>2]=X;if(X>>>0>1032){W=XDc(X)|0;f[F>>2]=W}}while(0);O=f[K>>2]|0;P=(f[M>>2]|0)-O>>2}while(j>>>0<P>>>0);u=l;return}function jN(a){a=a|0;YDc(a);return}function kN(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function lN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){XIc(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)mCc(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;XIc(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;YDc(h);return}function mN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=a+60|0;h=a+64|0;i=f[g>>2]|0;j=(f[h>>2]|0)-i>>2;if(!j)return;k=a+76|0;l=a+80|0;m=c;c=0;n=b;b=i;i=j;do{j=f[l>>2]|0;o=(c|0)==1;p=o?j:f[k>>2]|0;m=o?e:m;n=o?d:n;o=c;c=c+1|0;q=(c|0)==(i|0);if(!(f[b+(o<<2)>>2]|0))pN(a,n,m,d,e,(p|0)!=(j|0),q);else qN(a,n,m,d,e,p,j,q);b=f[g>>2]|0;i=(f[h>>2]|0)-b>>2}while(c>>>0<i>>>0);return}function nN(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=34736;b=a+3204|0;c=f[b>>2]|0;d=a+3212|0;if((c|0)!=(d|0)){if(c|0)ZDc(c);f[b>>2]=d;f[a+3208>>2]=1032}d=a+2164|0;b=f[d>>2]|0;c=a+2172|0;if((b|0)!=(c|0)){if(b|0)ZDc(b);f[d>>2]=c;f[a+2168>>2]=1032}c=a+1124|0;d=f[c>>2]|0;b=a+1132|0;if((d|0)!=(b|0)){if(d|0)ZDc(d);f[c>>2]=b;f[a+1128>>2]=1032}b=a+84|0;c=f[b>>2]|0;d=a+92|0;if((c|0)!=(d|0)){if(c|0)ZDc(c);f[b>>2]=d;f[a+88>>2]=1032}d=f[a+60>>2]|0;if(d|0){b=a+64|0;c=f[b>>2]|0;if((c|0)!=(d|0))f[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);YDc(d)}d=a+12|0;c=f[d>>2]|0;if(c|0?(b=c+4|0,e=f[b>>2]|0,f[b>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[d>>2]=0;f[a+16>>2]=0;d=a+4|0;c=f[d>>2]|0;if(!c){f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}e=c+4|0;b=f[e>>2]|0;f[e>>2]=b+-1;if((b|0)!=1){f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}function oN(a){a=a|0;nN(a);YDc(a);return}function pN(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=f[a+24>>2]|0;k=f[a+28>>2]|0;if((j|0)==1?(b[a+56>>0]|0)==0:0){l=k;m=1}else{l=j;m=k}k=a+36|0;j=f[k>>2]|0;o=Y(j,l)|0;q=a+20|0;r=b[q>>0]|0;if(!(r<<24>>24))s=0;else s=(l|0)>1&(l&1|0)!=0&(f[a+32>>2]|0)==1?j:0;if((b[a+22>>0]|0)!=0|h^1)t=o;else t=(f[(l&1|0?k:a+40|0)>>2]|0)+o|0;o=f[a+52>>2]|0;k=(o|0)<1|(o|0)>(m|0)?m:o;o=(k|0)>0;a:do if(o){h=a+8|0;j=a+84|0;u=0;v=r;while(1){w=c+(Y(u,d)|0)|0;x=e+(Y(u,g)|0)|0;if(!(v<<24>>24))y=x;else y=f[j>>2]|0;z=f[h>>2]|0;Ti[f[f[z>>2]>>2]&511](z,w,y);if(b[q>>0]|0)dJc(x|0,y+s|0,t|0)|0;x=u+1|0;if((x|0)==(k|0)){A=k;break a}u=x;v=b[q>>0]|0}}else A=0;while(0);if((A|0)<(m|0)){q=A;do{XIc(e+(Y(q,g)|0)|0,0,t|0)|0;q=q+1|0}while((q|0)!=(m|0))}if(!i)return;if((f[a+32>>2]|0)!=2)return;if((f[a+44>>2]|0)==5){a=g>>>2;if(!o)return;i=(l+1|0)/2|0;if((l|0)>2)B=0;else return;do{m=e+((Y(B,a)|0)<<2)|0;q=1;do{t=q<<1;A=l-q<<1;f[m+(A<<2)>>2]=f[m+(t<<2)>>2];n[m+((A|1)<<2)>>2]=-+n[m+((t|1)<<2)>>2];q=q+1|0}while((q|0)<(i|0));B=B+1|0}while((B|0)!=(k|0));return}else{B=g>>>3;if(!o)return;o=(l+1|0)/2|0;if((l|0)>2)C=0;else return;do{g=e+((Y(C,B)|0)<<3)|0;i=1;do{a=i<<1;q=l-i<<1;p[g+(q<<3)>>3]=+p[g+(a<<3)>>3];p[g+((q|1)<<3)>>3]=-+p[g+((a|1)<<3)>>3];i=i+1|0}while((i|0)<(o|0));C=C+1|0}while((C|0)!=(k|0));return}}function qN(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;k=f[a+28>>2]|0;l=f[a+24>>2]|0;m=a+2164|0;o=f[m>>2]|0;q=a+3204|0;r=f[q>>2]|0;if(!(b[a+21>>0]|0)){s=r;t=o}else{s=f[a+1124>>2]|0;t=r}if(!(b[a+48>>0]|0)){u=0;v=l;w=e;x=c}else{y=(l&1|0)==0;z=(l+1|0)/2|0;A=a+22|0;a:do if(!(b[A>>0]|0)){B=a+40|0;XIc(o|0,0,Y(f[B>>2]|0,k)|0)|0;C=f[m>>2]|0;D=a+36|0;E=d>>>2;F=(f[B>>2]|0)>>>2;switch(f[D>>2]|0){case 4:{if((k|0)>0){G=c;H=0;I=C;while(1){f[I>>2]=f[G>>2];H=H+1|0;if((H|0)==(k|0))break;else{G=G+(E<<2)|0;I=I+(F<<2)|0}}}break}case 8:{if((k|0)>0){I=c;G=0;H=C;while(1){J=f[I+4>>2]|0;f[H>>2]=f[I>>2];f[H+4>>2]=J;G=G+1|0;if((G|0)==(k|0))break;else{I=I+(E<<2)|0;H=H+(F<<2)|0}}}break}case 16:{if((k|0)>0){H=c;I=0;G=C;while(1){J=f[H+4>>2]|0;f[G>>2]=f[H>>2];f[G+4>>2]=J;J=f[H+12>>2]|0;f[G+8>>2]=f[H+8>>2];f[G+12>>2]=J;I=I+1|0;if((I|0)==(k|0))break;else{H=H+(E<<2)|0;G=G+(F<<2)|0}}}break}default:{}}F=c+(Y(f[D>>2]|0,i)|0)|0;if(y){XIc(f[q>>2]|0,0,Y(f[B>>2]|0,k)|0)|0;G=f[D>>2]|0;H=F+(Y(G,l+-2|0)|0)|0;I=f[q>>2]|0;C=(f[B>>2]|0)>>>2;switch(G|0){case 4:{if((k|0)>0){K=H;L=0;M=I}else{N=F;O=I;P=56;break a}while(1){f[M>>2]=f[K>>2];L=L+1|0;if((L|0)==(k|0)){Q=F;P=54;break}else{K=K+(E<<2)|0;M=M+(C<<2)|0}}break}case 8:{if((k|0)>0){R=H;S=0;T=I}else{N=F;O=I;P=56;break a}while(1){B=f[R+4>>2]|0;f[T>>2]=f[R>>2];f[T+4>>2]=B;S=S+1|0;if((S|0)==(k|0)){Q=F;P=54;break}else{R=R+(E<<2)|0;T=T+(C<<2)|0}}break}case 16:{if((k|0)>0){U=H;V=0;W=I}else{N=F;O=I;P=56;break a}while(1){B=f[U+4>>2]|0;f[W>>2]=f[U>>2];f[W+4>>2]=B;B=f[U+12>>2]|0;f[W+8>>2]=f[U+8>>2];f[W+12>>2]=B;V=V+1|0;if((V|0)==(k|0)){Q=F;P=54;break}else{U=U+(E<<2)|0;W=W+(C<<2)|0}}break}default:{N=F;O=I;P=56;break a}}}else X=F}else{if((h|0)!=1){C=a+40|0;E=f[C>>2]|0;H=d>>>2;B=E>>>2;switch(E|0){case 4:{if((k|0)>0){E=c;D=0;G=o;while(1){f[G>>2]=f[E>>2];D=D+1|0;if((D|0)==(k|0))break;else{E=E+(H<<2)|0;G=G+(B<<2)|0}}}break}case 8:{if((k|0)>0){G=c;E=0;D=o;while(1){F=f[G+4>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=F;E=E+1|0;if((E|0)==(k|0))break;else{G=G+(H<<2)|0;D=D+(B<<2)|0}}}break}case 16:{if((k|0)>0){D=c;G=0;E=o;while(1){F=f[D+4>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=F;F=f[D+12>>2]|0;f[E+8>>2]=f[D+8>>2];f[E+12>>2]=F;G=G+1|0;if((G|0)==(k|0))break;else{D=D+(H<<2)|0;E=E+(B<<2)|0}}}break}default:{}}b:do if(y){B=f[C>>2]|0;E=c+(Y(B,z)|0)|0;D=B>>>2;switch(B|0){case 4:{if((k|0)>0){Z=E;_=0;$=r}else break b;while(1){f[$>>2]=f[Z>>2];_=_+1|0;if((_|0)==(k|0))break;else{Z=Z+(H<<2)|0;$=$+(D<<2)|0}}break}case 8:{if((k|0)>0){aa=E;ba=0;ca=r}else break b;while(1){B=f[aa+4>>2]|0;f[ca>>2]=f[aa>>2];f[ca+4>>2]=B;ba=ba+1|0;if((ba|0)==(k|0))break;else{aa=aa+(H<<2)|0;ca=ca+(D<<2)|0}}break}case 16:{if((k|0)>0){da=E;ea=0;fa=r}else break b;while(1){B=f[da+4>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=B;B=f[da+12>>2]|0;f[fa+8>>2]=f[da+8>>2];f[fa+12>>2]=B;ea=ea+1|0;if((ea|0)==(k|0))break;else{da=da+(H<<2)|0;fa=fa+(D<<2)|0}}break}default:break b}}while(0);Q=c+(f[C>>2]|0)|0;P=54;break}H=a+36|0;D=f[H>>2]|0;E=d>>>2;B=D>>>2;switch(D|0){case 4:{if((k|0)>0){D=c;G=0;F=o;while(1){f[F>>2]=f[D>>2];G=G+1|0;if((G|0)==(k|0))break;else{D=D+(E<<2)|0;F=F+(B<<2)|0}}}break}case 8:{if((k|0)>0){F=c;D=0;G=o;while(1){C=f[F+4>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=C;D=D+1|0;if((D|0)==(k|0))break;else{F=F+(E<<2)|0;G=G+(B<<2)|0}}}break}case 16:{if((k|0)>0){G=c;F=0;D=o;while(1){C=f[G+4>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=C;C=f[G+12>>2]|0;f[D+8>>2]=f[G+8>>2];f[D+12>>2]=C;F=F+1|0;if((F|0)==(k|0))break;else{G=G+(E<<2)|0;D=D+(B<<2)|0}}}break}default:{}}rN(o,k,f[H>>2]|0);if(y){B=f[H>>2]|0;D=c+(Y(B,l+-1|0)|0)|0;G=f[q>>2]|0;F=B>>>2;switch(B|0){case 4:{if((k|0)>0){B=D;C=0;I=G;while(1){f[I>>2]=f[B>>2];C=C+1|0;if((C|0)==(k|0))break;else{B=B+(E<<2)|0;I=I+(F<<2)|0}}}break}case 8:{if((k|0)>0){I=D;B=0;C=G;while(1){J=f[I+4>>2]|0;f[C>>2]=f[I>>2];f[C+4>>2]=J;B=B+1|0;if((B|0)==(k|0))break;else{I=I+(E<<2)|0;C=C+(F<<2)|0}}}break}case 16:{if((k|0)>0){C=D;I=0;B=G;while(1){J=f[C+4>>2]|0;f[B>>2]=f[C>>2];f[B+4>>2]=J;J=f[C+12>>2]|0;f[B+8>>2]=f[C+8>>2];f[B+12>>2]=J;I=I+1|0;if((I|0)==(k|0))break;else{C=C+(E<<2)|0;B=B+(F<<2)|0}}}break}default:{}}rN(G,k,f[H>>2]|0)}Q=c+(f[H>>2]|0)|0;P=54}while(0);if((P|0)==54)if(y){N=Q;O=f[q>>2]|0;P=56}else X=Q;if((P|0)==56){P=f[a+16>>2]|0;Ti[f[f[P>>2]>>2]&511](P,O,s);X=N}N=f[a+16>>2]|0;Ti[f[f[N>>2]>>2]&511](N,f[m>>2]|0,t);c:do if((i|0)==1)if(!(b[A>>0]|0)){N=a+36|0;O=f[N>>2]|0;dJc(t+O|0,t|0,O|0)|0;O=f[N>>2]|0;P=t+O|0;Q=O>>>2;c=g>>>2;switch(O|0){case 4:{if((k|0)>0){O=P;o=0;fa=e;while(1){f[fa>>2]=f[O>>2];o=o+1|0;if((o|0)==(k|0))break;else{O=O+(Q<<2)|0;fa=fa+(c<<2)|0}}}break}case 8:{if((k|0)>0){fa=P;O=0;o=e;while(1){H=f[fa+4>>2]|0;f[o>>2]=f[fa>>2];f[o+4>>2]=H;O=O+1|0;if((O|0)==(k|0))break;else{fa=fa+(Q<<2)|0;o=o+(c<<2)|0}}}break}case 16:{if((k|0)>0){o=P;fa=0;O=e;while(1){H=f[o+4>>2]|0;f[O>>2]=f[o>>2];f[O+4>>2]=H;H=f[o+12>>2]|0;f[O+8>>2]=f[o+8>>2];f[O+12>>2]=H;fa=fa+1|0;if((fa|0)==(k|0))break;else{o=o+(Q<<2)|0;O=O+(c<<2)|0}}}break}default:{}}if(!y){ga=N;break}O=f[N>>2]|0;dJc(s+O|0,s|0,O|0)|0;O=f[N>>2]|0;Q=s+O|0;o=e+(Y(O,l+-1|0)|0)|0;fa=O>>>2;switch(O|0){case 4:{if((k|0)>0){ha=Q;ia=0;ja=o}else{ga=N;break c}while(1){f[ja>>2]=f[ha>>2];ia=ia+1|0;if((ia|0)==(k|0)){ga=N;break}else{ha=ha+(fa<<2)|0;ja=ja+(c<<2)|0}}break}case 8:{if((k|0)>0){ka=Q;la=0;ma=o}else{ga=N;break c}while(1){O=f[ka+4>>2]|0;f[ma>>2]=f[ka>>2];f[ma+4>>2]=O;la=la+1|0;if((la|0)==(k|0)){ga=N;break}else{ka=ka+(fa<<2)|0;ma=ma+(c<<2)|0}}break}case 16:{if((k|0)>0){na=Q;oa=0;pa=o}else{ga=N;break c}while(1){O=f[na+4>>2]|0;f[pa>>2]=f[na>>2];f[pa+4>>2]=O;O=f[na+12>>2]|0;f[pa+8>>2]=f[na+8>>2];f[pa+12>>2]=O;oa=oa+1|0;if((oa|0)==(k|0)){ga=N;break}else{na=na+(fa<<2)|0;pa=pa+(c<<2)|0}}break}default:{ga=N;break c}}}else{c=a+40|0;fa=a+36|0;o=(f[c>>2]|0)>>>2;Q=g>>>2;switch(f[fa>>2]|0){case 4:{if((k|0)>0){O=t;P=0;H=e;while(1){f[H>>2]=f[O>>2];P=P+1|0;if((P|0)==(k|0))break;else{O=O+(o<<2)|0;H=H+(Q<<2)|0}}}break}case 8:{if((k|0)>0){H=t;O=0;P=e;while(1){N=f[H+4>>2]|0;f[P>>2]=f[H>>2];f[P+4>>2]=N;O=O+1|0;if((O|0)==(k|0))break;else{H=H+(o<<2)|0;P=P+(Q<<2)|0}}}break}case 16:{if((k|0)>0){P=t;H=0;O=e;while(1){N=f[P+4>>2]|0;f[O>>2]=f[P>>2];f[O+4>>2]=N;N=f[P+12>>2]|0;f[O+8>>2]=f[P+8>>2];f[O+12>>2]=N;H=H+1|0;if((H|0)==(k|0))break;else{P=P+(o<<2)|0;O=O+(Q<<2)|0}}}break}default:{}}if(!y){ga=fa;break}O=f[fa>>2]|0;o=e+(Y(O,l+-1|0)|0)|0;P=(f[c>>2]|0)>>>2;switch(O|0){case 4:{if((k|0)>0){qa=s;ra=0;sa=o}else{ga=fa;break c}while(1){f[sa>>2]=f[qa>>2];ra=ra+1|0;if((ra|0)==(k|0)){ga=fa;break}else{qa=qa+(P<<2)|0;sa=sa+(Q<<2)|0}}break}case 8:{if((k|0)>0){ta=s;ua=0;va=o}else{ga=fa;break c}while(1){c=f[ta+4>>2]|0;f[va>>2]=f[ta>>2];f[va+4>>2]=c;ua=ua+1|0;if((ua|0)==(k|0)){ga=fa;break}else{ta=ta+(P<<2)|0;va=va+(Q<<2)|0}}break}case 16:{if((k|0)>0){wa=s;xa=0;ya=o}else{ga=fa;break c}while(1){c=f[wa+4>>2]|0;f[ya>>2]=f[wa>>2];f[ya+4>>2]=c;c=f[wa+12>>2]|0;f[ya+8>>2]=f[wa+8>>2];f[ya+12>>2]=c;xa=xa+1|0;if((xa|0)==(k|0)){ga=fa;break}else{wa=wa+(P<<2)|0;ya=ya+(Q<<2)|0}}break}default:{ga=fa;break c}}}else{Q=a+40|0;P=f[Q>>2]|0;o=P>>>2;c=g>>>2;switch(P|0){case 4:{if((k|0)>0){P=t;O=0;H=e;while(1){f[H>>2]=f[P>>2];O=O+1|0;if((O|0)==(k|0))break;else{P=P+(o<<2)|0;H=H+(c<<2)|0}}}break}case 8:{if((k|0)>0){H=t;P=0;O=e;while(1){fa=f[H+4>>2]|0;f[O>>2]=f[H>>2];f[O+4>>2]=fa;P=P+1|0;if((P|0)==(k|0))break;else{H=H+(o<<2)|0;O=O+(c<<2)|0}}}break}case 16:{if((k|0)>0){O=t;H=0;P=e;while(1){fa=f[O+4>>2]|0;f[P>>2]=f[O>>2];f[P+4>>2]=fa;fa=f[O+12>>2]|0;f[P+8>>2]=f[O+8>>2];f[P+12>>2]=fa;H=H+1|0;if((H|0)==(k|0))break;else{O=O+(o<<2)|0;P=P+(c<<2)|0}}}break}default:{}}if(y){P=f[Q>>2]|0;o=e+(Y(P,z)|0)|0;O=P>>>2;switch(P|0){case 4:{if((k|0)>0){za=s;Aa=0;Ba=o}else{ga=Q;break c}while(1){f[Ba>>2]=f[za>>2];Aa=Aa+1|0;if((Aa|0)==(k|0)){ga=Q;break}else{za=za+(O<<2)|0;Ba=Ba+(c<<2)|0}}break}case 8:{if((k|0)>0){Ca=s;Da=0;Ea=o}else{ga=Q;break c}while(1){P=f[Ca+4>>2]|0;f[Ea>>2]=f[Ca>>2];f[Ea+4>>2]=P;Da=Da+1|0;if((Da|0)==(k|0)){ga=Q;break}else{Ca=Ca+(O<<2)|0;Ea=Ea+(c<<2)|0}}break}case 16:{if((k|0)>0){Fa=s;Ga=0;Ha=o}else{ga=Q;break c}while(1){P=f[Fa+4>>2]|0;f[Ha>>2]=f[Fa>>2];f[Ha+4>>2]=P;P=f[Fa+12>>2]|0;f[Ha+8>>2]=f[Fa+8>>2];f[Ha+12>>2]=P;Ga=Ga+1|0;if((Ga|0)==(k|0)){ga=Q;break}else{Fa=Fa+(O<<2)|0;Ha=Ha+(c<<2)|0}}break}default:{ga=Q;break c}}}else ga=Q}while(0);u=1;v=z;w=e+(f[ga>>2]|0)|0;x=X}if((u|0)<(v|0)){X=a+40|0;ga=d>>>2;d=a+16|0;z=(k|0)>0;Ha=k<<1;Fa=k<<2;Ga=g>>>2;Ea=u;u=x;x=w;while(1){w=(Ea+1|0)<(v|0);Ca=f[m>>2]|0;d:do if(w){Da=f[q>>2]|0;switch(f[X>>2]|0){case 4:{if(z){Ba=u;za=0;while(1){Aa=f[Ba+4>>2]|0;f[Ca+(za<<2)>>2]=f[Ba>>2];f[Da+(za<<2)>>2]=Aa;za=za+1|0;if((za|0)==(k|0))break;else Ba=Ba+(ga<<2)|0}}break}case 8:{if(z){Ba=u;za=0;while(1){Aa=f[Ba+4>>2]|0;f[Ca+(za<<2)>>2]=f[Ba>>2];y=za|1;f[Ca+(y<<2)>>2]=Aa;Aa=f[Ba+12>>2]|0;f[Da+(za<<2)>>2]=f[Ba+8>>2];f[Da+(y<<2)>>2]=Aa;za=za+2|0;if((za|0)>=(Ha|0))break;else Ba=Ba+(ga<<2)|0}}break}case 16:{if(z){Ba=0;za=u;while(1){Aa=f[za+4>>2]|0;f[Ca+(Ba<<2)>>2]=f[za>>2];y=Ba|1;f[Ca+(y<<2)>>2]=Aa;Aa=f[za+12>>2]|0;ya=Ba|2;f[Ca+(ya<<2)>>2]=f[za+8>>2];wa=Ba|3;f[Ca+(wa<<2)>>2]=Aa;Aa=f[za+20>>2]|0;f[Da+(Ba<<2)>>2]=f[za+16>>2];f[Da+(y<<2)>>2]=Aa;Aa=f[za+28>>2]|0;f[Da+(ya<<2)>>2]=f[za+24>>2];f[Da+(wa<<2)>>2]=Aa;Ba=Ba+4|0;if((Ba|0)>=(Fa|0))break;else za=za+(ga<<2)|0}}break}default:{}}za=f[d>>2]|0;Ti[f[f[za>>2]>>2]&511](za,Da,s);Ia=f[m>>2]|0}else{za=f[X>>2]|0;Ba=za>>>2;switch(za|0){case 4:{if(z){Ja=u;Ka=0;La=Ca}else{Ia=Ca;break d}while(1){f[La>>2]=f[Ja>>2];Ka=Ka+1|0;if((Ka|0)==(k|0)){Ia=Ca;break}else{Ja=Ja+(ga<<2)|0;La=La+(Ba<<2)|0}}break}case 8:{if(z){Ma=u;Na=0;Oa=Ca}else{Ia=Ca;break d}while(1){Da=f[Ma+4>>2]|0;f[Oa>>2]=f[Ma>>2];f[Oa+4>>2]=Da;Na=Na+1|0;if((Na|0)==(k|0)){Ia=Ca;break}else{Ma=Ma+(ga<<2)|0;Oa=Oa+(Ba<<2)|0}}break}case 16:{if(z){Pa=u;Qa=0;Ra=Ca}else{Ia=Ca;break d}while(1){Da=f[Pa+4>>2]|0;f[Ra>>2]=f[Pa>>2];f[Ra+4>>2]=Da;Da=f[Pa+12>>2]|0;f[Ra+8>>2]=f[Pa+8>>2];f[Ra+12>>2]=Da;Qa=Qa+1|0;if((Qa|0)==(k|0)){Ia=Ca;break}else{Pa=Pa+(ga<<2)|0;Ra=Ra+(Ba<<2)|0}}break}default:{Ia=Ca;break d}}}while(0);Ca=f[d>>2]|0;Ti[f[f[Ca>>2]>>2]&511](Ca,Ia,t);Ca=f[X>>2]|0;e:do if(w)switch(Ca|0){case 4:{if(z){Sa=0;Ta=x}else break e;while(1){Q=f[s+(Sa<<2)>>2]|0;f[Ta>>2]=f[t+(Sa<<2)>>2];f[Ta+4>>2]=Q;Sa=Sa+1|0;if((Sa|0)==(k|0))break;else Ta=Ta+(Ga<<2)|0}break}case 8:{if(z){Ua=0;Va=x}else break e;while(1){Q=Ua|1;Ba=f[t+(Q<<2)>>2]|0;f[Va>>2]=f[t+(Ua<<2)>>2];f[Va+4>>2]=Ba;Ba=f[s+(Q<<2)>>2]|0;f[Va+8>>2]=f[s+(Ua<<2)>>2];f[Va+12>>2]=Ba;Ua=Ua+2|0;if((Ua|0)>=(Ha|0))break;else Va=Va+(Ga<<2)|0}break}case 16:{if(z){Wa=x;Xa=0}else break e;while(1){Ba=Xa|1;Q=f[t+(Ba<<2)>>2]|0;f[Wa>>2]=f[t+(Xa<<2)>>2];f[Wa+4>>2]=Q;Q=Xa|2;Da=Xa|3;za=f[t+(Da<<2)>>2]|0;f[Wa+8>>2]=f[t+(Q<<2)>>2];f[Wa+12>>2]=za;za=f[s+(Ba<<2)>>2]|0;f[Wa+16>>2]=f[s+(Xa<<2)>>2];f[Wa+20>>2]=za;za=f[s+(Da<<2)>>2]|0;f[Wa+24>>2]=f[s+(Q<<2)>>2];f[Wa+28>>2]=za;Xa=Xa+4|0;if((Xa|0)>=(Fa|0))break;else Wa=Wa+(Ga<<2)|0}break}default:break e}else{za=Ca>>>2;switch(Ca|0){case 4:{if(z){Ya=t;Za=0;_a=x}else break e;while(1){f[_a>>2]=f[Ya>>2];Za=Za+1|0;if((Za|0)==(k|0))break;else{Ya=Ya+(za<<2)|0;_a=_a+(Ga<<2)|0}}break}case 8:{if(z){$a=t;ab=0;bb=x}else break e;while(1){Q=f[$a+4>>2]|0;f[bb>>2]=f[$a>>2];f[bb+4>>2]=Q;ab=ab+1|0;if((ab|0)==(k|0))break;else{$a=$a+(za<<2)|0;bb=bb+(Ga<<2)|0}}break}case 16:{if(z){cb=t;db=0;eb=x}else break e;while(1){Q=f[cb+4>>2]|0;f[eb>>2]=f[cb>>2];f[eb+4>>2]=Q;Q=f[cb+12>>2]|0;f[eb+8>>2]=f[cb+8>>2];f[eb+12>>2]=Q;db=db+1|0;if((db|0)==(k|0))break;else{cb=cb+(za<<2)|0;eb=eb+(Ga<<2)|0}}break}default:break e}}while(0);Ca=f[X>>2]<<1;Ea=Ea+2|0;if((Ea|0)>=(v|0))break;else{u=u+Ca|0;x=x+Ca|0}}}if(!j)return;if((f[a+32>>2]|0)!=2)return;if((f[a+44>>2]|0)==5){a=g>>>2;if((k|0)<=0)return;j=(l+1|0)/2|0;if((l|0)>2)fb=0;else return;do{x=e+((Y(fb,a)|0)<<2)|0;u=e+((Y(k-fb|0,a)|0)<<2)|0;v=(fb|0)==0|(fb<<1|0)==(k|0)?x:u;u=1;do{Ea=u<<1;X=l-u<<1;f[x+(X<<2)>>2]=f[v+(Ea<<2)>>2];n[x+((X|1)<<2)>>2]=-+n[v+((Ea|1)<<2)>>2];u=u+1|0}while((u|0)<(j|0));fb=fb+1|0}while((fb|0)!=(k|0));return}else{fb=g>>>3;if((k|0)<=0)return;g=(l+1|0)/2|0;if((l|0)>2)gb=0;else return;do{j=e+((Y(gb,fb)|0)<<3)|0;a=e+((Y(k-gb|0,fb)|0)<<3)|0;u=(gb|0)==0|(gb<<1|0)==(k|0)?j:a;a=1;do{v=a<<1;x=l-a<<1;p[j+(x<<3)>>3]=+p[u+(v<<3)>>3];p[j+((x|1)<<3)>>3]=-+p[u+((v|1)<<3)>>3];a=a+1|0}while((a|0)<(g|0));gb=gb+1|0}while((gb|0)!=(k|0));return}}function rN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;if((c|0)==4){c=b+1|0;d=(c|0)/2|0;if((b|0)>2){e=1;do{g=e<<1;h=b-e<<1;f[a+(h<<2)>>2]=f[a+(g+-1<<2)>>2];n[a+((h|1)<<2)>>2]=-+n[a+(g<<2)>>2];e=e+1|0}while((e|0)<(d|0))}d=b+-1|0;if(!(b&1)){f[a+(b<<2)>>2]=f[a+(d<<2)>>2];n[a+(c<<2)>>2]=0.0;i=d}else i=b;if((i|0)>1){d=i;do{i=d;d=d+-1|0;f[a+(i<<2)>>2]=f[a+(d<<2)>>2]}while((d|0)>1)}n[a+4>>2]=0.0;return}else{d=b+1|0;i=(d|0)/2|0;if((b|0)>2){c=1;do{e=c<<1;g=b-c<<1;p[a+(g<<3)>>3]=+p[a+(e+-1<<3)>>3];p[a+((g|1)<<3)>>3]=-+p[a+(e<<3)>>3];c=c+1|0}while((c|0)<(i|0))}i=b+-1|0;if(!(b&1)){p[a+(b<<3)>>3]=+p[a+(i<<3)>>3];p[a+(d<<3)>>3]=0.0;j=i}else j=b;if((j|0)>1){b=j;do{j=b;b=b+-1|0;p[a+(j<<3)>>3]=+p[a+(b<<3)>>3]}while((b|0)>1)}p[a+8>>3]=0.0;return}}function sN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function tN(a){a=a|0;YDc(a);return}function uN(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;g=u;u=u+208|0;h=g+144|0;i=g+88|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g;n=g+8|0;do if((d$(a)|0)==65536){o=f[a+4>>2]|0;f[h>>2]=f[o>>2];p=h+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=h+8|0;f[r>>2]=f[o+8>>2];s=h+12|0;f[s>>2]=f[o+12>>2];t=h+16|0;f[t>>2]=f[o+16>>2];v=h+20|0;f[v>>2]=f[o+20>>2];w=h+24|0;f[w>>2]=f[o+24>>2];x=h+28|0;f[x>>2]=f[o+28>>2];y=h+32|0;f[y>>2]=f[o+32>>2];z=h+36|0;A=f[o+36>>2]|0;f[z>>2]=A;f[h+40>>2]=r;B=h+48|0;C=h+44|0;f[C>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(A|0){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;B=f[C>>2]|0;f[B>>2]=f[q>>2];f[B+4>>2]=f[q+4>>2];D=p;E=r;F=s;G=t;H=t;I=v;J=w;K=x;L=y;M=z;N=z;O=h;break}else{f[p>>2]=0;ZS(h,o);D=p;E=r;F=s;G=t;H=t;I=v;J=w;K=x;L=y;M=z;N=z;O=h;break}}else{a$(h,a,-1);z=h+16|0;y=h+36|0;D=h+4|0;E=h+8|0;F=h+12|0;G=z;H=z;I=h+20|0;J=h+24|0;K=h+28|0;L=h+32|0;M=y;N=y;O=h}while(0);f[i>>2]=f[O>>2];O=i+4|0;a=f[D>>2]|0;f[O>>2]=a;y=i+8|0;f[y>>2]=f[E>>2];E=i+12|0;f[E>>2]=f[F>>2];F=i+16|0;f[F>>2]=f[H>>2];f[i+20>>2]=f[I>>2];f[i+24>>2]=f[J>>2];f[i+28>>2]=f[K>>2];f[i+32>>2]=f[L>>2];L=i+36|0;K=f[N>>2]|0;f[L>>2]=K;N=i+40|0;f[N>>2]=y;J=i+48|0;I=i+44|0;f[I>>2]=J;f[J>>2]=0;f[i+52>>2]=0;if(!K)P=a;else{a=K+12|0;f[a>>2]=(f[a>>2]|0)+1;P=f[D>>2]|0}if((P|0)<3){P=f[h+44>>2]|0;a=f[I>>2]|0;f[a>>2]=f[P>>2];f[a+4>>2]=f[P+4>>2]}else{f[O>>2]=0;ZS(i,h)}P=(d&1|0)==0;a=f[i>>2]|0;K=a&4095;H=a&7;switch(a&4095){case 5:case 6:case 13:case 14:break;default:{f[j>>2]=0;f[j+4>>2]=0;Q=tT(j,76)|0;R=212424;S=Q+76|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));YM(-215,j,212501,3335)}}if(!((d&64|0)==0|(a&4088|0)==8)){f[j>>2]=0;f[j+4>>2]=0;Q=tT(j,53)|0;R=212505;S=Q+53|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));YM(-215,j,212501,3338)}R=a>>>3&511;if(P)if((d&16|0)==0|(R|0)!=0)T=22;else{P=f[N>>2]|0;a=f[P>>2]|0;f[k>>2]=f[P+4>>2];f[k+4>>2]=a;v$(c,k,H|8,-1,0,0)}else if((d&32|0)==0|(R|0)!=1)T=22;else{R=f[N>>2]|0;k=f[R>>2]|0;f[l>>2]=f[R+4>>2];f[l+4>>2]=k;v$(c,l,H,-1,0,0)}if((T|0)==22){T=f[N>>2]|0;l=f[T>>2]|0;f[m>>2]=f[T+4>>2];f[m+4>>2]=l;v$(c,m,K,-1,0,0)}do if((d$(c)|0)==65536){K=f[c+4>>2]|0;f[j>>2]=f[K>>2];m=j+4|0;l=K+4|0;f[m>>2]=f[l>>2];T=j+8|0;f[T>>2]=f[K+8>>2];f[j+12>>2]=f[K+12>>2];f[j+16>>2]=f[K+16>>2];f[j+20>>2]=f[K+20>>2];f[j+24>>2]=f[K+24>>2];f[j+28>>2]=f[K+28>>2];f[j+32>>2]=f[K+32>>2];k=f[K+36>>2]|0;f[j+36>>2]=k;f[j+40>>2]=T;T=j+48|0;R=j+44|0;f[R>>2]=T;f[T>>2]=0;f[j+52>>2]=0;if(k|0){T=k+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[l>>2]|0)<3){l=f[K+44>>2]|0;T=f[R>>2]|0;f[T>>2]=f[l>>2];f[T+4>>2]=f[l+4>>2];break}else{f[m>>2]=0;ZS(j,K);break}}else a$(j,c,-1);while(0);c=f[i>>2]|0;K=f[j>>2]|0;m=d&7|((c&16384|0)==0?0:K>>>5&512);d=j+16|0;gN(n,f[E>>2]|0,f[y>>2]|0,H,(c>>>3&511)+1|0,(K>>>3&511)+1|0,(f[F>>2]|0)==(f[d>>2]|0)?m|1024:m,e);e=f[n+4>>2]|0;m=j+48|0;gi[f[f[e>>2]>>2]&255](e,f[F>>2]|0,f[J>>2]|0,f[d>>2]|0,f[m>>2]|0);e=f[n>>2]|0;if(e|0?(n=e+4|0,K=f[n>>2]|0,f[n>>2]=K+-1,(K|0)==1):0)Yi[f[(f[e>>2]|0)+8>>2]&2047](e);e=j+36|0;K=f[e>>2]|0;if(K|0?(n=K+12|0,K=f[n>>2]|0,f[n>>2]=K+-1,(K|0)==1):0)_S(j);f[e>>2]=0;e=j+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[j+40>>2]|0;K=0;do{f[d+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[e>>2]|0))}e=f[j+44>>2]|0;if((e|0)!=(m|0))g0(e);e=f[L>>2]|0;if(e|0?(m=e+12|0,e=f[m>>2]|0,f[m>>2]=e+-1,(e|0)==1):0)_S(i);f[L>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[O>>2]|0)>0){F=f[N>>2]|0;N=0;do{f[F+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[O>>2]|0))}O=f[I>>2]|0;if((O|0)!=(J|0))g0(O);O=f[M>>2]|0;if(O|0?(J=O+12|0,O=f[J>>2]|0,f[J>>2]=O+-1,(O|0)==1):0)_S(h);f[M>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[D>>2]|0)>0){G=f[h+40>>2]|0;M=0;do{f[G+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[D>>2]|0))}D=f[h+44>>2]|0;if((D|0)==(h+48|0)){u=g;return}g0(D);u=g;return}function vN(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;h=u;u=u+240|0;i=h+224|0;j=h+168|0;k=h+112|0;l=h+56|0;m=h;do if((d$(a)|0)==65536){o=f[a+4>>2]|0;f[j>>2]=f[o>>2];q=j+4|0;r=o+4|0;f[q>>2]=f[r>>2];s=j+8|0;f[s>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[j+16>>2]=f[o+16>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];t=f[o+36>>2]|0;f[j+36>>2]=t;f[j+40>>2]=s;s=j+48|0;v=j+44|0;f[v>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[o+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;ZS(j,o);break}}else a$(j,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];o=k+4|0;q=a+4|0;f[o>>2]=f[q>>2];r=k+8|0;f[r>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[k+36>>2]=s;f[k+40>>2]=r;r=k+48|0;v=k+44|0;f[v>>2]=r;f[r>>2]=0;f[k+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=k;break}else{f[o>>2]=0;ZS(k,a);w=k;break}}else{a$(k,c,-1);w=k}while(0);c=f[j>>2]|0;a=c&7;o=c>>>3&511;q=o+1|0;r=c&4095;v=f[j+8>>2]|0;s=f[j+12>>2]|0;if((r|0)!=(f[w>>2]&4095|0)){f[i>>2]=0;x=i+4|0;f[x>>2]=0;y=tT(i,49)|0;z=y;A=212559;B=z+49|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));YM(-215,i,212609,3541)}t=j+40|0;C=f[t>>2]|0;D=k+40|0;E=f[D>>2]|0;if(!((f[C>>2]|0)==(f[E>>2]|0)?(f[C+4>>2]|0)==(f[E+4>>2]|0):0)){f[i>>2]=0;x=i+4|0;f[x>>2]=0;y=tT(i,49)|0;z=y;A=212559;B=z+49|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));YM(-215,i,212609,3541)}switch(c&4095){case 5:case 6:case 13:case 14:break;default:{f[i>>2]=0;f[i+4>>2]=0;z=tT(i,76)|0;A=212424;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));YM(-215,i,212609,3542)}}Y$(d,v,s,r,-1,0,0);do if((d$(d)|0)==65536){r=f[d+4>>2]|0;f[l>>2]=f[r>>2];A=l+4|0;c=r+4|0;f[A>>2]=f[c>>2];y=l+8|0;f[y>>2]=f[r+8>>2];f[l+12>>2]=f[r+12>>2];x=l+16|0;f[x>>2]=f[r+16>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];E=f[r+36>>2]|0;f[l+36>>2]=E;f[l+40>>2]=y;y=l+48|0;C=l+44|0;f[C>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(E|0){y=E+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[c>>2]|0)<3){c=f[r+44>>2]|0;y=f[C>>2]|0;f[y>>2]=f[c>>2];f[y+4>>2]=f[c+4>>2];F=x;break}else{f[A>>2]=0;ZS(l,r);F=x;break}}else{a$(l,d,-1);F=l+16|0}while(0);d=k+16|0;if((f[F>>2]|0)==(f[d>>2]|0)){f[m>>2]=1124007936;x=m+4|0;r=m+8|0;A=m+40|0;z=x;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[A>>2]=r;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;c=i+8|0;f[c>>2]=0;f[c+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;h_(k,i);i=m+36|0;c=f[i>>2]|0;if(c|0){y=c+12|0;f[y>>2]=(f[y>>2]|0)+1}y=k+36|0;c=f[y>>2]|0;if(c|0?(C=c+12|0,c=f[C>>2]|0,f[C>>2]=c+-1,(c|0)==1):0)_S(k);f[y>>2]=0;c=k+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){C=f[D>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0;G=f[c>>2]|0}while((E|0)<(G|0));f[w>>2]=f[m>>2];if((G|0)<3)H=38;else H=40}else{f[w>>2]=f[m>>2];H=38}if((H|0)==38){G=f[x>>2]|0;if((G|0)<3){f[c>>2]=G;f[k+8>>2]=f[r>>2];f[k+12>>2]=f[m+12>>2];r=f[B>>2]|0;G=f[k+44>>2]|0;f[G>>2]=f[r>>2];f[G+4>>2]=f[r+4>>2]}else H=40}if((H|0)==40)ZS(k,m);r=m+16|0;f[d>>2]=f[r>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];f[k+32>>2]=f[m+32>>2];G=f[i>>2]|0;f[y>>2]=G;if(G|0?(y=G+12|0,G=f[y>>2]|0,f[y>>2]=G+-1,(G|0)==1):0)_S(m);f[i>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[x>>2]|0)>0){r=f[A>>2]|0;A=0;do{f[r+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[x>>2]|0))}x=f[B>>2]|0;if((x|0)!=(z|0))g0(x)}x=(e&4|0)!=0;if(!(x|(v|0)==1))if(((s|0)==1?(f[j>>2]&16384|0)!=0:0)?(f[w>>2]&16384|0)!=0:0)I=(f[l>>2]&16384|0)!=0;else I=0;else I=1;w=x|I^1;x=s+(w?0:v+-1|0)|0;s=w?v:1;v=(o|0)==0;w=v&1;e=x&1;z=(e|0)==0;B=(Y(x,q)|0)-((e|o|0)==0&1)|0;o=j+16|0;e=f[o>>2]|0;a:do if((a|0)==5){q=f[d>>2]|0;A=f[F>>2]|0;r=f[j+48>>2]|0;i=f[k+48>>2]|0;m=f[l+48>>2]|0;G=(e|0)==(A|0);y=I|v^1;if(g)if(G){do if(!y){n[e>>2]=+n[e>>2]*+n[q>>2];c=s+-2|0;E=(c|0)==0;if(!E){C=1;do{J=e+(Y(C,m)|0)|0;K=+n[J>>2];L=C+1|0;M=e+(Y(L,m)|0)|0;N=+n[M>>2];O=q+(Y(C,i)|0)|0;P=+n[O>>2];O=q+(Y(L,i)|0)|0;Q=-+n[O>>2];n[J>>2]=K*P-N*Q;n[M>>2]=N*P+K*Q;C=C+2|0}while(C>>>0<=c>>>0);if(!(s&1)){R=s+-1|0;H=117}}else{R=1;H=117}if((H|0)==117){C=e+(Y(R,m)|0)|0;M=q+(Y(R,i)|0)|0;n[C>>2]=+n[C>>2]*+n[M>>2]}if(z){M=q+(x<<2)+-4|0;C=e+(x<<2)+-4|0;n[C>>2]=+n[C>>2]*+n[M>>2];if(!E){J=1;do{O=C+(Y(J,m)|0)|0;Q=+n[O>>2];L=J+1|0;S=C+(Y(L,m)|0)|0;K=+n[S>>2];T=M+(Y(J,i)|0)|0;P=+n[T>>2];T=M+(Y(L,i)|0)|0;N=-+n[T>>2];n[O>>2]=Q*P-K*N;n[S>>2]=K*P+Q*N;J=J+2|0}while(J>>>0<=c>>>0);if(!(s&1))U=s+-1|0;else break}else U=1;c=C+(Y(U,m)|0)|0;J=M+(Y(U,i)|0)|0;n[c>>2]=+n[c>>2]*+n[J>>2]}}while(0);J=v&I;c=s+-1|0;if(!s)break;E=w>>>0<B>>>0;S=J&z;if(!J){if(E){V=e;W=q;X=c}else break;while(1){J=w;do{O=V+(J<<2)|0;N=+n[O>>2];T=J+1|0;L=V+(T<<2)|0;Q=+n[L>>2];P=+n[W+(J<<2)>>2];K=-+n[W+(T<<2)>>2];n[O>>2]=N*P-Q*K;n[L>>2]=Q*P+N*K;J=J+2|0}while(J>>>0<B>>>0);if(!X)break a;else{V=V+m|0;W=W+i|0;X=X+-1|0}}}if(!E)if(S){J=e;M=q;C=e;L=c;while(1){n[C>>2]=+n[J>>2]*+n[M>>2];n[C+(B<<2)>>2]=+n[J+(B<<2)>>2]*+n[M+(B<<2)>>2];if(!L)break a;else{J=J+r|0;M=M+i|0;C=C+m|0;L=L+-1|0}}}else{L=c;C=e;M=q;J=e;while(1){n[J>>2]=+n[C>>2]*+n[M>>2];if(!L)break a;else{L=L+-1|0;C=C+r|0;M=M+i|0;J=J+m|0}}}if(S){J=e;M=q;C=e;L=c;while(1){n[C>>2]=+n[J>>2]*+n[M>>2];E=w;do{O=C+(E<<2)|0;K=+n[O>>2];T=E+1|0;Z=C+(T<<2)|0;N=+n[Z>>2];P=+n[M+(E<<2)>>2];Q=-+n[M+(T<<2)>>2];n[O>>2]=K*P-N*Q;n[Z>>2]=N*P+K*Q;E=E+2|0}while(E>>>0<B>>>0);n[C+(B<<2)>>2]=+n[J+(B<<2)>>2]*+n[M+(B<<2)>>2];if(!L)break;else{J=J+r|0;M=M+i|0;C=C+m|0;L=L+-1|0}}}else{L=e;C=q;M=e;J=c;while(1){n[M>>2]=+n[L>>2]*+n[C>>2];S=w;do{E=M+(S<<2)|0;Q=+n[E>>2];Z=S+1|0;O=M+(Z<<2)|0;K=+n[O>>2];P=+n[C+(S<<2)>>2];N=-+n[C+(Z<<2)>>2];n[E>>2]=Q*P-K*N;n[O>>2]=K*P+Q*N;S=S+2|0}while(S>>>0<B>>>0);if(!J)break;else{L=L+r|0;C=C+i|0;M=M+m|0;J=J+-1|0}}}}else{do if(!y){n[A>>2]=+n[e>>2]*+n[q>>2];J=s+-2|0;M=(J|0)==0;if(!M){C=1;do{L=e+(Y(C,r)|0)|0;N=+n[L>>2];L=C+1|0;c=e+(Y(L,r)|0)|0;Q=+n[c>>2];c=q+(Y(C,i)|0)|0;P=+n[c>>2];c=q+(Y(L,i)|0)|0;K=-+n[c>>2];c=A+(Y(C,m)|0)|0;n[c>>2]=N*P-Q*K;c=A+(Y(L,m)|0)|0;n[c>>2]=Q*P+N*K;C=C+2|0}while(C>>>0<=J>>>0);if(!(s&1)){_=s+-1|0;H=144}}else{_=1;H=144}if((H|0)==144){C=A+(Y(_,m)|0)|0;c=q+(Y(_,i)|0)|0;L=e+(Y(_,r)|0)|0;n[C>>2]=+n[L>>2]*+n[c>>2]}if(z){c=e+(x<<2)+-4|0;L=q+(x<<2)+-4|0;C=A+(x<<2)+-4|0;n[C>>2]=+n[c>>2]*+n[L>>2];if(!M){S=1;do{O=c+(Y(S,r)|0)|0;K=+n[O>>2];O=S+1|0;E=c+(Y(O,r)|0)|0;N=+n[E>>2];E=L+(Y(S,i)|0)|0;P=+n[E>>2];E=L+(Y(O,i)|0)|0;Q=-+n[E>>2];E=C+(Y(S,m)|0)|0;n[E>>2]=K*P-N*Q;E=C+(Y(O,m)|0)|0;n[E>>2]=N*P+K*Q;S=S+2|0}while(S>>>0<=J>>>0);if(!(s&1))$=s+-1|0;else break}else $=1;J=C+(Y($,m)|0)|0;S=L+(Y($,i)|0)|0;M=c+(Y($,r)|0)|0;n[J>>2]=+n[M>>2]*+n[S>>2]}}while(0);S=v&I;M=s+-1|0;if(!s)break;J=w>>>0<B>>>0;E=S&z;if(!S){if(J){aa=e;ba=q;ca=A;da=M}else break;while(1){S=w;do{Q=+n[aa+(S<<2)>>2];O=S+1|0;K=+n[aa+(O<<2)>>2];P=+n[ba+(S<<2)>>2];N=-+n[ba+(O<<2)>>2];n[ca+(S<<2)>>2]=Q*P-K*N;n[ca+(O<<2)>>2]=K*P+Q*N;S=S+2|0}while(S>>>0<B>>>0);if(!da)break a;else{aa=aa+r|0;ba=ba+i|0;ca=ca+m|0;da=da+-1|0}}}if(!J)if(E){S=e;c=q;L=A;C=M;while(1){n[L>>2]=+n[S>>2]*+n[c>>2];n[L+(B<<2)>>2]=+n[S+(B<<2)>>2]*+n[c+(B<<2)>>2];if(!C)break a;else{S=S+r|0;c=c+i|0;L=L+m|0;C=C+-1|0}}}else{C=e;L=q;c=A;S=M;while(1){n[c>>2]=+n[C>>2]*+n[L>>2];if(!S)break a;else{C=C+r|0;L=L+i|0;c=c+m|0;S=S+-1|0}}}if(E){S=e;c=q;L=A;C=M;while(1){n[L>>2]=+n[S>>2]*+n[c>>2];J=w;do{N=+n[S+(J<<2)>>2];O=J+1|0;Q=+n[S+(O<<2)>>2];P=+n[c+(J<<2)>>2];K=-+n[c+(O<<2)>>2];n[L+(J<<2)>>2]=N*P-Q*K;n[L+(O<<2)>>2]=Q*P+N*K;J=J+2|0}while(J>>>0<B>>>0);n[L+(B<<2)>>2]=+n[S+(B<<2)>>2]*+n[c+(B<<2)>>2];if(!C)break;else{S=S+r|0;c=c+i|0;L=L+m|0;C=C+-1|0}}}else{C=e;L=q;c=A;S=M;while(1){n[c>>2]=+n[C>>2]*+n[L>>2];E=w;do{K=+n[C+(E<<2)>>2];J=E+1|0;N=+n[C+(J<<2)>>2];P=+n[L+(E<<2)>>2];Q=-+n[L+(J<<2)>>2];n[c+(E<<2)>>2]=K*P-N*Q;n[c+(J<<2)>>2]=N*P+K*Q;E=E+2|0}while(E>>>0<B>>>0);if(!S)break;else{C=C+r|0;L=L+i|0;c=c+m|0;S=S+-1|0}}}}else if(G){do if(!y){n[e>>2]=+n[e>>2]*+n[q>>2];S=s+-2|0;c=(S|0)==0;if(!c){L=1;do{C=e+(Y(L,m)|0)|0;Q=+n[C>>2];M=L+1|0;E=e+(Y(M,m)|0)|0;K=+n[E>>2];J=q+(Y(L,i)|0)|0;P=+n[J>>2];J=q+(Y(M,i)|0)|0;N=+n[J>>2];n[C>>2]=Q*P-K*N;n[E>>2]=K*P+Q*N;L=L+2|0}while(L>>>0<=S>>>0);if(!(s&1)){ea=s+-1|0;H=62}}else{ea=1;H=62}if((H|0)==62){L=e+(Y(ea,m)|0)|0;E=q+(Y(ea,i)|0)|0;n[L>>2]=+n[L>>2]*+n[E>>2]}if(z){E=q+(x<<2)+-4|0;L=e+(x<<2)+-4|0;n[L>>2]=+n[L>>2]*+n[E>>2];if(!c){C=1;do{J=L+(Y(C,m)|0)|0;N=+n[J>>2];M=C+1|0;O=L+(Y(M,m)|0)|0;Q=+n[O>>2];Z=E+(Y(C,i)|0)|0;P=+n[Z>>2];Z=E+(Y(M,i)|0)|0;K=+n[Z>>2];n[J>>2]=N*P-Q*K;n[O>>2]=Q*P+N*K;C=C+2|0}while(C>>>0<=S>>>0);if(!(s&1))fa=s+-1|0;else break}else fa=1;S=L+(Y(fa,m)|0)|0;C=E+(Y(fa,i)|0)|0;n[S>>2]=+n[S>>2]*+n[C>>2]}}while(0);G=v&I;C=s+-1|0;if(!s)break;S=w>>>0<B>>>0;c=G&z;if(!G){if(S){ga=e;ha=q;ia=C}else break;while(1){G=w;do{O=ga+(G<<2)|0;K=+n[O>>2];J=G+1|0;Z=ga+(J<<2)|0;N=+n[Z>>2];P=+n[ha+(G<<2)>>2];Q=+n[ha+(J<<2)>>2];n[O>>2]=K*P-N*Q;n[Z>>2]=N*P+K*Q;G=G+2|0}while(G>>>0<B>>>0);if(!ia)break a;else{ga=ga+m|0;ha=ha+i|0;ia=ia+-1|0}}}if(!S)if(c){G=e;E=q;L=e;Z=C;while(1){n[L>>2]=+n[G>>2]*+n[E>>2];n[L+(B<<2)>>2]=+n[G+(B<<2)>>2]*+n[E+(B<<2)>>2];if(!Z)break a;else{G=G+r|0;E=E+i|0;L=L+m|0;Z=Z+-1|0}}}else{Z=e;L=q;E=e;G=C;while(1){n[E>>2]=+n[Z>>2]*+n[L>>2];if(!G)break a;else{Z=Z+r|0;L=L+i|0;E=E+m|0;G=G+-1|0}}}if(c){G=e;E=q;L=e;Z=C;while(1){n[L>>2]=+n[G>>2]*+n[E>>2];S=w;do{O=L+(S<<2)|0;Q=+n[O>>2];J=S+1|0;M=L+(J<<2)|0;K=+n[M>>2];P=+n[E+(S<<2)>>2];N=+n[E+(J<<2)>>2];n[O>>2]=Q*P-K*N;n[M>>2]=K*P+Q*N;S=S+2|0}while(S>>>0<B>>>0);n[L+(B<<2)>>2]=+n[G+(B<<2)>>2]*+n[E+(B<<2)>>2];if(!Z)break;else{G=G+r|0;E=E+i|0;L=L+m|0;Z=Z+-1|0}}}else{Z=e;L=q;E=e;G=C;while(1){n[E>>2]=+n[Z>>2]*+n[L>>2];c=w;do{S=E+(c<<2)|0;N=+n[S>>2];M=c+1|0;O=E+(M<<2)|0;Q=+n[O>>2];P=+n[L+(c<<2)>>2];K=+n[L+(M<<2)>>2];n[S>>2]=N*P-Q*K;n[O>>2]=Q*P+N*K;c=c+2|0}while(c>>>0<B>>>0);if(!G)break;else{Z=Z+r|0;L=L+i|0;E=E+m|0;G=G+-1|0}}}}else{do if(!y){n[A>>2]=+n[e>>2]*+n[q>>2];G=s+-2|0;E=(G|0)==0;if(!E){L=1;do{Z=e+(Y(L,r)|0)|0;K=+n[Z>>2];Z=L+1|0;C=e+(Y(Z,r)|0)|0;N=+n[C>>2];C=q+(Y(L,i)|0)|0;P=+n[C>>2];C=q+(Y(Z,i)|0)|0;Q=+n[C>>2];C=A+(Y(L,m)|0)|0;n[C>>2]=K*P-N*Q;C=A+(Y(Z,m)|0)|0;n[C>>2]=N*P+K*Q;L=L+2|0}while(L>>>0<=G>>>0);if(!(s&1)){ja=s+-1|0;H=89}}else{ja=1;H=89}if((H|0)==89){L=A+(Y(ja,m)|0)|0;C=q+(Y(ja,i)|0)|0;Z=e+(Y(ja,r)|0)|0;n[L>>2]=+n[Z>>2]*+n[C>>2]}if(z){C=e+(x<<2)+-4|0;Z=q+(x<<2)+-4|0;L=A+(x<<2)+-4|0;n[L>>2]=+n[C>>2]*+n[Z>>2];if(!E){c=1;do{O=C+(Y(c,r)|0)|0;Q=+n[O>>2];O=c+1|0;S=C+(Y(O,r)|0)|0;K=+n[S>>2];S=Z+(Y(c,i)|0)|0;P=+n[S>>2];S=Z+(Y(O,i)|0)|0;N=+n[S>>2];S=L+(Y(c,m)|0)|0;n[S>>2]=Q*P-K*N;S=L+(Y(O,m)|0)|0;n[S>>2]=K*P+Q*N;c=c+2|0}while(c>>>0<=G>>>0);if(!(s&1))ka=s+-1|0;else break}else ka=1;G=L+(Y(ka,m)|0)|0;c=Z+(Y(ka,i)|0)|0;E=C+(Y(ka,r)|0)|0;n[G>>2]=+n[E>>2]*+n[c>>2]}}while(0);y=v&I;c=s+-1|0;if(!s)break;E=w>>>0<B>>>0;G=y&z;if(!y){if(E){la=e;ma=q;na=A;oa=c}else break;while(1){y=w;do{N=+n[la+(y<<2)>>2];S=y+1|0;Q=+n[la+(S<<2)>>2];P=+n[ma+(y<<2)>>2];K=+n[ma+(S<<2)>>2];n[na+(y<<2)>>2]=N*P-Q*K;n[na+(S<<2)>>2]=Q*P+N*K;y=y+2|0}while(y>>>0<B>>>0);if(!oa)break a;else{la=la+r|0;ma=ma+i|0;na=na+m|0;oa=oa+-1|0}}}if(!E)if(G){y=e;C=q;Z=A;L=c;while(1){n[Z>>2]=+n[y>>2]*+n[C>>2];n[Z+(B<<2)>>2]=+n[y+(B<<2)>>2]*+n[C+(B<<2)>>2];if(!L)break a;else{y=y+r|0;C=C+i|0;Z=Z+m|0;L=L+-1|0}}}else{L=e;Z=q;C=A;y=c;while(1){n[C>>2]=+n[L>>2]*+n[Z>>2];if(!y)break a;else{L=L+r|0;Z=Z+i|0;C=C+m|0;y=y+-1|0}}}if(G){y=e;C=q;Z=A;L=c;while(1){n[Z>>2]=+n[y>>2]*+n[C>>2];E=w;do{K=+n[y+(E<<2)>>2];S=E+1|0;N=+n[y+(S<<2)>>2];P=+n[C+(E<<2)>>2];Q=+n[C+(S<<2)>>2];n[Z+(E<<2)>>2]=K*P-N*Q;n[Z+(S<<2)>>2]=N*P+K*Q;E=E+2|0}while(E>>>0<B>>>0);n[Z+(B<<2)>>2]=+n[y+(B<<2)>>2]*+n[C+(B<<2)>>2];if(!L)break;else{y=y+r|0;C=C+i|0;Z=Z+m|0;L=L+-1|0}}}else{L=e;Z=q;C=A;y=c;while(1){n[C>>2]=+n[L>>2]*+n[Z>>2];G=w;do{Q=+n[L+(G<<2)>>2];E=G+1|0;K=+n[L+(E<<2)>>2];P=+n[Z+(G<<2)>>2];N=+n[Z+(E<<2)>>2];n[C+(G<<2)>>2]=Q*P-K*N;n[C+(E<<2)>>2]=K*P+Q*N;G=G+2|0}while(G>>>0<B>>>0);if(!y)break;else{L=L+r|0;Z=Z+i|0;C=C+m|0;y=y+-1|0}}}}}else{y=f[d>>2]|0;m=f[F>>2]|0;C=f[j+48>>2]|0;i=f[k+48>>2]|0;Z=f[l+48>>2]|0;r=(e|0)==(m|0);L=I|v^1;if(g)if(r){do if(!L){p[e>>3]=+p[e>>3]*+p[y>>3];c=s+-2|0;A=(c|0)==0;if(!A){q=1;do{G=e+(Y(q,Z)|0)|0;N=+p[G>>3];E=q+1|0;S=e+(Y(E,Z)|0)|0;Q=+p[S>>3];O=y+(Y(q,i)|0)|0;P=+p[O>>3];O=y+(Y(E,i)|0)|0;K=-+p[O>>3];p[G>>3]=N*P-Q*K;p[S>>3]=Q*P+N*K;q=q+2|0}while(q>>>0<=c>>>0);if(!(s&1)){pa=s+-1|0;H=228}}else{pa=1;H=228}if((H|0)==228){q=e+(Y(pa,Z)|0)|0;S=y+(Y(pa,i)|0)|0;p[q>>3]=+p[q>>3]*+p[S>>3]}if(z){S=y+(x<<3)+-8|0;q=e+(x<<3)+-8|0;p[q>>3]=+p[q>>3]*+p[S>>3];if(!A){G=1;do{O=q+(Y(G,Z)|0)|0;K=+p[O>>3];E=G+1|0;M=q+(Y(E,Z)|0)|0;N=+p[M>>3];J=S+(Y(G,i)|0)|0;P=+p[J>>3];J=S+(Y(E,i)|0)|0;Q=-+p[J>>3];p[O>>3]=K*P-N*Q;p[M>>3]=N*P+K*Q;G=G+2|0}while(G>>>0<=c>>>0);if(!(s&1))qa=s+-1|0;else break}else qa=1;c=q+(Y(qa,Z)|0)|0;G=S+(Y(qa,i)|0)|0;p[c>>3]=+p[c>>3]*+p[G>>3]}}while(0);G=v&I;c=s+-1|0;if(!s)break;A=w>>>0<B>>>0;M=G&z;if(!G){if(A){ra=e;sa=y;ta=c}else break;while(1){G=w;do{O=ra+(G<<3)|0;Q=+p[O>>3];J=G+1|0;E=ra+(J<<3)|0;K=+p[E>>3];P=+p[sa+(G<<3)>>3];N=-+p[sa+(J<<3)>>3];p[O>>3]=Q*P-K*N;p[E>>3]=K*P+Q*N;G=G+2|0}while(G>>>0<B>>>0);if(!ta)break a;else{ra=ra+Z|0;sa=sa+i|0;ta=ta+-1|0}}}if(!A)if(M){G=e;S=y;q=e;E=c;while(1){p[q>>3]=+p[G>>3]*+p[S>>3];p[q+(B<<3)>>3]=+p[G+(B<<3)>>3]*+p[S+(B<<3)>>3];if(!E)break a;else{G=G+C|0;S=S+i|0;q=q+Z|0;E=E+-1|0}}}else{E=e;q=y;S=e;G=c;while(1){p[S>>3]=+p[E>>3]*+p[q>>3];if(!G)break a;else{E=E+C|0;q=q+i|0;S=S+Z|0;G=G+-1|0}}}if(M){G=e;S=y;q=e;E=c;while(1){p[q>>3]=+p[G>>3]*+p[S>>3];A=w;do{O=q+(A<<3)|0;N=+p[O>>3];J=A+1|0;T=q+(J<<3)|0;Q=+p[T>>3];P=+p[S+(A<<3)>>3];K=-+p[S+(J<<3)>>3];p[O>>3]=N*P-Q*K;p[T>>3]=Q*P+N*K;A=A+2|0}while(A>>>0<B>>>0);p[q+(B<<3)>>3]=+p[G+(B<<3)>>3]*+p[S+(B<<3)>>3];if(!E)break;else{G=G+C|0;S=S+i|0;q=q+Z|0;E=E+-1|0}}}else{E=e;q=y;S=e;G=c;while(1){p[S>>3]=+p[E>>3]*+p[q>>3];M=w;do{A=S+(M<<3)|0;K=+p[A>>3];T=M+1|0;O=S+(T<<3)|0;N=+p[O>>3];P=+p[q+(M<<3)>>3];Q=-+p[q+(T<<3)>>3];p[A>>3]=K*P-N*Q;p[O>>3]=N*P+K*Q;M=M+2|0}while(M>>>0<B>>>0);if(!G)break;else{E=E+C|0;q=q+i|0;S=S+Z|0;G=G+-1|0}}}}else{do if(!L){p[m>>3]=+p[e>>3]*+p[y>>3];G=s+-2|0;S=(G|0)==0;if(!S){q=1;do{E=e+(Y(q,C)|0)|0;Q=+p[E>>3];E=q+1|0;c=e+(Y(E,C)|0)|0;K=+p[c>>3];c=y+(Y(q,i)|0)|0;P=+p[c>>3];c=y+(Y(E,i)|0)|0;N=-+p[c>>3];c=m+(Y(q,Z)|0)|0;p[c>>3]=Q*P-K*N;c=m+(Y(E,Z)|0)|0;p[c>>3]=K*P+Q*N;q=q+2|0}while(q>>>0<=G>>>0);if(!(s&1)){ua=s+-1|0;H=255}}else{ua=1;H=255}if((H|0)==255){q=m+(Y(ua,Z)|0)|0;c=y+(Y(ua,i)|0)|0;E=e+(Y(ua,C)|0)|0;p[q>>3]=+p[E>>3]*+p[c>>3]}if(z){c=e+(x<<3)+-8|0;E=y+(x<<3)+-8|0;q=m+(x<<3)+-8|0;p[q>>3]=+p[c>>3]*+p[E>>3];if(!S){M=1;do{O=c+(Y(M,C)|0)|0;N=+p[O>>3];O=M+1|0;A=c+(Y(O,C)|0)|0;Q=+p[A>>3];A=E+(Y(M,i)|0)|0;P=+p[A>>3];A=E+(Y(O,i)|0)|0;K=-+p[A>>3];A=q+(Y(M,Z)|0)|0;p[A>>3]=N*P-Q*K;A=q+(Y(O,Z)|0)|0;p[A>>3]=Q*P+N*K;M=M+2|0}while(M>>>0<=G>>>0);if(!(s&1))va=s+-1|0;else break}else va=1;G=q+(Y(va,Z)|0)|0;M=E+(Y(va,i)|0)|0;S=c+(Y(va,C)|0)|0;p[G>>3]=+p[S>>3]*+p[M>>3]}}while(0);M=v&I;S=s+-1|0;if(!s)break;G=w>>>0<B>>>0;A=M&z;if(!M){if(G){wa=e;xa=y;ya=m;za=S}else break;while(1){M=w;do{K=+p[wa+(M<<3)>>3];O=M+1|0;N=+p[wa+(O<<3)>>3];P=+p[xa+(M<<3)>>3];Q=-+p[xa+(O<<3)>>3];p[ya+(M<<3)>>3]=K*P-N*Q;p[ya+(O<<3)>>3]=N*P+K*Q;M=M+2|0}while(M>>>0<B>>>0);if(!za)break a;else{wa=wa+C|0;xa=xa+i|0;ya=ya+Z|0;za=za+-1|0}}}if(!G)if(A){M=e;c=y;E=m;q=S;while(1){p[E>>3]=+p[M>>3]*+p[c>>3];p[E+(B<<3)>>3]=+p[M+(B<<3)>>3]*+p[c+(B<<3)>>3];if(!q)break a;else{M=M+C|0;c=c+i|0;E=E+Z|0;q=q+-1|0}}}else{q=e;E=y;c=m;M=S;while(1){p[c>>3]=+p[q>>3]*+p[E>>3];if(!M)break a;else{q=q+C|0;E=E+i|0;c=c+Z|0;M=M+-1|0}}}if(A){M=e;c=y;E=m;q=S;while(1){p[E>>3]=+p[M>>3]*+p[c>>3];G=w;do{Q=+p[M+(G<<3)>>3];O=G+1|0;K=+p[M+(O<<3)>>3];P=+p[c+(G<<3)>>3];N=-+p[c+(O<<3)>>3];p[E+(G<<3)>>3]=Q*P-K*N;p[E+(O<<3)>>3]=K*P+Q*N;G=G+2|0}while(G>>>0<B>>>0);p[E+(B<<3)>>3]=+p[M+(B<<3)>>3]*+p[c+(B<<3)>>3];if(!q)break;else{M=M+C|0;c=c+i|0;E=E+Z|0;q=q+-1|0}}}else{q=e;E=y;c=m;M=S;while(1){p[c>>3]=+p[q>>3]*+p[E>>3];A=w;do{N=+p[q+(A<<3)>>3];G=A+1|0;Q=+p[q+(G<<3)>>3];P=+p[E+(A<<3)>>3];K=-+p[E+(G<<3)>>3];p[c+(A<<3)>>3]=N*P-Q*K;p[c+(G<<3)>>3]=Q*P+N*K;A=A+2|0}while(A>>>0<B>>>0);if(!M)break;else{q=q+C|0;E=E+i|0;c=c+Z|0;M=M+-1|0}}}}else if(r){do if(!L){p[e>>3]=+p[e>>3]*+p[y>>3];M=s+-2|0;c=(M|0)==0;if(!c){E=1;do{q=e+(Y(E,Z)|0)|0;K=+p[q>>3];S=E+1|0;A=e+(Y(S,Z)|0)|0;N=+p[A>>3];G=y+(Y(E,i)|0)|0;P=+p[G>>3];G=y+(Y(S,i)|0)|0;Q=+p[G>>3];p[q>>3]=K*P-N*Q;p[A>>3]=N*P+K*Q;E=E+2|0}while(E>>>0<=M>>>0);if(!(s&1)){Aa=s+-1|0;H=173}}else{Aa=1;H=173}if((H|0)==173){E=e+(Y(Aa,Z)|0)|0;A=y+(Y(Aa,i)|0)|0;p[E>>3]=+p[E>>3]*+p[A>>3]}if(z){A=y+(x<<3)+-8|0;E=e+(x<<3)+-8|0;p[E>>3]=+p[E>>3]*+p[A>>3];if(!c){q=1;do{G=E+(Y(q,Z)|0)|0;Q=+p[G>>3];S=q+1|0;O=E+(Y(S,Z)|0)|0;K=+p[O>>3];T=A+(Y(q,i)|0)|0;P=+p[T>>3];T=A+(Y(S,i)|0)|0;N=+p[T>>3];p[G>>3]=Q*P-K*N;p[O>>3]=K*P+Q*N;q=q+2|0}while(q>>>0<=M>>>0);if(!(s&1))Ba=s+-1|0;else break}else Ba=1;M=E+(Y(Ba,Z)|0)|0;q=A+(Y(Ba,i)|0)|0;p[M>>3]=+p[M>>3]*+p[q>>3]}}while(0);r=v&I;q=s+-1|0;if(!s)break;M=w>>>0<B>>>0;c=r&z;if(!r){if(M){Ca=e;Da=y;Ea=q}else break;while(1){r=w;do{O=Ca+(r<<3)|0;N=+p[O>>3];G=r+1|0;T=Ca+(G<<3)|0;Q=+p[T>>3];P=+p[Da+(r<<3)>>3];K=+p[Da+(G<<3)>>3];p[O>>3]=N*P-Q*K;p[T>>3]=Q*P+N*K;r=r+2|0}while(r>>>0<B>>>0);if(!Ea)break a;else{Ca=Ca+Z|0;Da=Da+i|0;Ea=Ea+-1|0}}}if(!M)if(c){r=e;A=y;E=e;T=q;while(1){p[E>>3]=+p[r>>3]*+p[A>>3];p[E+(B<<3)>>3]=+p[r+(B<<3)>>3]*+p[A+(B<<3)>>3];if(!T)break a;else{r=r+C|0;A=A+i|0;E=E+Z|0;T=T+-1|0}}}else{T=e;E=y;A=e;r=q;while(1){p[A>>3]=+p[T>>3]*+p[E>>3];if(!r)break a;else{T=T+C|0;E=E+i|0;A=A+Z|0;r=r+-1|0}}}if(c){r=e;A=y;E=e;T=q;while(1){p[E>>3]=+p[r>>3]*+p[A>>3];M=w;do{O=E+(M<<3)|0;K=+p[O>>3];G=M+1|0;S=E+(G<<3)|0;N=+p[S>>3];P=+p[A+(M<<3)>>3];Q=+p[A+(G<<3)>>3];p[O>>3]=K*P-N*Q;p[S>>3]=N*P+K*Q;M=M+2|0}while(M>>>0<B>>>0);p[E+(B<<3)>>3]=+p[r+(B<<3)>>3]*+p[A+(B<<3)>>3];if(!T)break;else{r=r+C|0;A=A+i|0;E=E+Z|0;T=T+-1|0}}}else{T=e;E=y;A=e;r=q;while(1){p[A>>3]=+p[T>>3]*+p[E>>3];c=w;do{M=A+(c<<3)|0;Q=+p[M>>3];S=c+1|0;O=A+(S<<3)|0;K=+p[O>>3];P=+p[E+(c<<3)>>3];N=+p[E+(S<<3)>>3];p[M>>3]=Q*P-K*N;p[O>>3]=K*P+Q*N;c=c+2|0}while(c>>>0<B>>>0);if(!r)break;else{T=T+C|0;E=E+i|0;A=A+Z|0;r=r+-1|0}}}}else{do if(!L){p[m>>3]=+p[e>>3]*+p[y>>3];r=s+-2|0;A=(r|0)==0;if(!A){E=1;do{T=e+(Y(E,C)|0)|0;N=+p[T>>3];T=E+1|0;q=e+(Y(T,C)|0)|0;Q=+p[q>>3];q=y+(Y(E,i)|0)|0;P=+p[q>>3];q=y+(Y(T,i)|0)|0;K=+p[q>>3];q=m+(Y(E,Z)|0)|0;p[q>>3]=N*P-Q*K;q=m+(Y(T,Z)|0)|0;p[q>>3]=Q*P+N*K;E=E+2|0}while(E>>>0<=r>>>0);if(!(s&1)){Fa=s+-1|0;H=200}}else{Fa=1;H=200}if((H|0)==200){E=m+(Y(Fa,Z)|0)|0;q=y+(Y(Fa,i)|0)|0;T=e+(Y(Fa,C)|0)|0;p[E>>3]=+p[T>>3]*+p[q>>3]}if(z){q=e+(x<<3)+-8|0;T=y+(x<<3)+-8|0;E=m+(x<<3)+-8|0;p[E>>3]=+p[q>>3]*+p[T>>3];if(!A){c=1;do{O=q+(Y(c,C)|0)|0;K=+p[O>>3];O=c+1|0;M=q+(Y(O,C)|0)|0;N=+p[M>>3];M=T+(Y(c,i)|0)|0;P=+p[M>>3];M=T+(Y(O,i)|0)|0;Q=+p[M>>3];M=E+(Y(c,Z)|0)|0;p[M>>3]=K*P-N*Q;M=E+(Y(O,Z)|0)|0;p[M>>3]=N*P+K*Q;c=c+2|0}while(c>>>0<=r>>>0);if(!(s&1))Ga=s+-1|0;else break}else Ga=1;r=E+(Y(Ga,Z)|0)|0;c=T+(Y(Ga,i)|0)|0;A=q+(Y(Ga,C)|0)|0;p[r>>3]=+p[A>>3]*+p[c>>3]}}while(0);L=v&I;c=s+-1|0;if(!s)break;A=w>>>0<B>>>0;r=L&z;if(!L){if(A){Ha=e;Ia=y;Ja=m;Ka=c}else break;while(1){L=w;do{Q=+p[Ha+(L<<3)>>3];M=L+1|0;K=+p[Ha+(M<<3)>>3];P=+p[Ia+(L<<3)>>3];N=+p[Ia+(M<<3)>>3];p[Ja+(L<<3)>>3]=Q*P-K*N;p[Ja+(M<<3)>>3]=K*P+Q*N;L=L+2|0}while(L>>>0<B>>>0);if(!Ka)break a;else{Ha=Ha+C|0;Ia=Ia+i|0;Ja=Ja+Z|0;Ka=Ka+-1|0}}}if(!A)if(r){L=e;q=y;T=m;E=c;while(1){p[T>>3]=+p[L>>3]*+p[q>>3];p[T+(B<<3)>>3]=+p[L+(B<<3)>>3]*+p[q+(B<<3)>>3];if(!E)break a;else{L=L+C|0;q=q+i|0;T=T+Z|0;E=E+-1|0}}}else{E=e;T=y;q=m;L=c;while(1){p[q>>3]=+p[E>>3]*+p[T>>3];if(!L)break a;else{E=E+C|0;T=T+i|0;q=q+Z|0;L=L+-1|0}}}if(r){L=e;q=y;T=m;E=c;while(1){p[T>>3]=+p[L>>3]*+p[q>>3];A=w;do{N=+p[L+(A<<3)>>3];M=A+1|0;Q=+p[L+(M<<3)>>3];P=+p[q+(A<<3)>>3];K=+p[q+(M<<3)>>3];p[T+(A<<3)>>3]=N*P-Q*K;p[T+(M<<3)>>3]=Q*P+N*K;A=A+2|0}while(A>>>0<B>>>0);p[T+(B<<3)>>3]=+p[L+(B<<3)>>3]*+p[q+(B<<3)>>3];if(!E)break;else{L=L+C|0;q=q+i|0;T=T+Z|0;E=E+-1|0}}}else{E=e;T=y;q=m;L=c;while(1){p[q>>3]=+p[E>>3]*+p[T>>3];r=w;do{K=+p[E+(r<<3)>>3];A=r+1|0;N=+p[E+(A<<3)>>3];P=+p[T+(r<<3)>>3];Q=+p[T+(A<<3)>>3];p[q+(r<<3)>>3]=K*P-N*Q;p[q+(A<<3)>>3]=N*P+K*Q;r=r+2|0}while(r>>>0<B>>>0);if(!L)break;else{E=E+C|0;T=T+i|0;q=q+Z|0;L=L+-1|0}}}}}while(0);B=l+36|0;w=f[B>>2]|0;if(w|0?(e=w+12|0,w=f[e>>2]|0,f[e>>2]=w+-1,(w|0)==1):0)_S(l);f[B>>2]=0;B=l+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[B>>2]|0)>0){F=f[l+40>>2]|0;w=0;do{f[F+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[B>>2]|0))}B=f[l+44>>2]|0;if((B|0)!=(l+48|0))g0(B);B=k+36|0;l=f[B>>2]|0;if(l|0?(w=l+12|0,l=f[w>>2]|0,f[w>>2]=l+-1,(l|0)==1):0)_S(k);f[B>>2]=0;B=k+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[B>>2]|0)>0){d=f[D>>2]|0;D=0;do{f[d+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[k+44>>2]|0;if((B|0)!=(k+48|0))g0(B);B=j+36|0;k=f[B>>2]|0;if(k|0?(D=k+12|0,k=f[D>>2]|0,f[D>>2]=k+-1,(k|0)==1):0)_S(j);f[B>>2]=0;B=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[B>>2]|0)>0){o=f[t>>2]|0;t=0;do{f[o+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[B>>2]|0))}B=f[j+44>>2]|0;if((B|0)==(j+48|0)){u=h;return}g0(B);u=h;return}function wN(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if(a>>>0>2125763999){b=-1;return b|0}else{c=1650;d=0}do{e=c+d>>1;g=(f[34768+(e<<2)>>2]|0)<(a|0);d=g?e+1|0:d;c=g?c:e}while((d|0)<(c|0));b=f[34768+(c<<2)>>2]|0;return b|0}function xN(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;q=u;u=u+448|0;r=q+392|0;s=q+336|0;t=q+280|0;v=q+224|0;w=q+168|0;x=q+112|0;y=q+56|0;z=q;A=(o&2|0)==0;B=(o&1|0)!=0;C=B?l:m;D=B?m:l;B=A?C:n;E=A?n:C;C=(o&4|0)==0;A=C?D:n;F=C?n:D;f[r>>2]=1124007936;C=r+4|0;G=r+8|0;H=r+40|0;I=C;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[H>>2]=G;K=r+48|0;L=r+44|0;f[L>>2]=K;f[K>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;O=s+40|0;I=M;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[O>>2]=N;P=s+48|0;Q=s+44|0;f[Q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[T>>2]=S;I=t+48|0;J=t+44|0;f[J>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(a|0){Vj(v,l,m,p,a,b);b=v+36|0;a=f[b>>2]|0;if(a|0){m=a+12|0;f[m>>2]=(f[m>>2]|0)+1}m=r+36|0;a=f[m>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)_S(r);f[m>>2]=0;a=r+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){l=f[H>>2]|0;U=0;do{f[l+(U<<2)>>2]=0;U=U+1|0;V=f[C>>2]|0}while((U|0)<(V|0));f[r>>2]=f[v>>2];if((V|0)<3)W=12;else W=14}else{f[r>>2]=f[v>>2];W=12}if((W|0)==12){V=f[v+4>>2]|0;if((V|0)<3){f[C>>2]=V;f[G>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];V=f[v+44>>2]|0;U=f[L>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else W=14}if((W|0)==14)ZS(r,v);V=v+16|0;f[a>>2]=f[V>>2];f[r+20>>2]=f[v+20>>2];f[r+24>>2]=f[v+24>>2];f[r+28>>2]=f[v+28>>2];f[r+32>>2]=f[v+32>>2];a=f[b>>2]|0;f[m>>2]=a;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)_S(v);f[b>>2]=0;b=v+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[b>>2]|0)>0){V=f[v+40>>2]|0;a=0;do{f[V+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[v+44>>2]|0;if((b|0)!=(v+48|0))g0(b)}if(c|0){Vj(v,B,E,p,c,d);d=v+36|0;c=f[d>>2]|0;if(c|0){E=c+12|0;f[E>>2]=(f[E>>2]|0)+1}E=s+36|0;c=f[E>>2]|0;if(c|0?(B=c+12|0,c=f[B>>2]|0,f[B>>2]=c+-1,(c|0)==1):0)_S(s);f[E>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){B=f[O>>2]|0;b=0;do{f[B+(b<<2)>>2]=0;b=b+1|0;X=f[M>>2]|0}while((b|0)<(X|0));f[s>>2]=f[v>>2];if((X|0)<3)W=35;else W=37}else{f[s>>2]=f[v>>2];W=35}if((W|0)==35){X=f[v+4>>2]|0;if((X|0)<3){f[M>>2]=X;f[N>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];X=f[v+44>>2]|0;b=f[Q>>2]|0;f[b>>2]=f[X>>2];f[b+4>>2]=f[X+4>>2]}else W=37}if((W|0)==37)ZS(s,v);X=v+16|0;f[c>>2]=f[X>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];c=f[d>>2]|0;f[E>>2]=c;if(c|0?(E=c+12|0,c=f[E>>2]|0,f[E>>2]=c+-1,(c|0)==1):0)_S(v);f[d>>2]=0;d=v+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[d>>2]|0)>0){X=f[v+40>>2]|0;c=0;do{f[X+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[v+44>>2]|0;if((d|0)!=(v+48|0))g0(d)}if((g|0)!=0&i!=0.0){Vj(v,A,F,p,g,h);h=v+36|0;g=f[h>>2]|0;if(g|0){F=g+12|0;f[F>>2]=(f[F>>2]|0)+1}F=t+36|0;g=f[F>>2]|0;if(g|0?(A=g+12|0,g=f[A>>2]|0,f[A>>2]=g+-1,(g|0)==1):0)_S(t);f[F>>2]=0;g=t+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[R>>2]|0)>0){A=f[T>>2]|0;d=0;do{f[A+(d<<2)>>2]=0;d=d+1|0;Y=f[R>>2]|0}while((d|0)<(Y|0));f[t>>2]=f[v>>2];if((Y|0)<3)W=58;else W=60}else{f[t>>2]=f[v>>2];W=58}if((W|0)==58){Y=f[v+4>>2]|0;if((Y|0)<3){f[R>>2]=Y;f[S>>2]=f[v+8>>2];f[t+12>>2]=f[v+12>>2];Y=f[v+44>>2]|0;d=f[J>>2]|0;f[d>>2]=f[Y>>2];f[d+4>>2]=f[Y+4>>2]}else W=60}if((W|0)==60)ZS(t,v);W=v+16|0;f[g>>2]=f[W>>2];f[t+20>>2]=f[v+20>>2];f[t+24>>2]=f[v+24>>2];f[t+28>>2]=f[v+28>>2];f[t+32>>2]=f[v+32>>2];g=f[h>>2]|0;f[F>>2]=g;if(g|0?(F=g+12|0,g=f[F>>2]|0,f[F>>2]=g+-1,(g|0)==1):0)_S(v);f[h>>2]=0;h=v+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[h>>2]|0)>0){W=f[v+40>>2]|0;g=0;do{f[W+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[v+44>>2]|0;if((h|0)!=(v+48|0))g0(h)}Vj(v,D,n,p,j,k);f[w>>2]=f[r>>2];k=w+4|0;j=f[C>>2]|0;f[k>>2]=j;p=w+8|0;f[p>>2]=f[G>>2];f[w+12>>2]=f[r+12>>2];G=w+16|0;n=r+16|0;f[G>>2]=f[n>>2];f[w+20>>2]=f[r+20>>2];f[w+24>>2]=f[r+24>>2];f[w+28>>2]=f[r+28>>2];f[w+32>>2]=f[r+32>>2];D=w+36|0;h=r+36|0;g=f[h>>2]|0;f[D>>2]=g;W=w+40|0;f[W>>2]=p;p=w+48|0;F=w+44|0;f[F>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(!g)Z=j;else{j=g+12|0;f[j>>2]=(f[j>>2]|0)+1;Z=f[C>>2]|0}if((Z|0)<3){Z=f[L>>2]|0;j=f[F>>2]|0;f[j>>2]=f[Z>>2];f[j+4>>2]=f[Z+4>>2]}else{f[k>>2]=0;ZS(w,r)}f[x>>2]=f[s>>2];Z=x+4|0;j=f[M>>2]|0;f[Z>>2]=j;g=x+8|0;f[g>>2]=f[N>>2];f[x+12>>2]=f[s+12>>2];N=x+16|0;Y=s+16|0;f[N>>2]=f[Y>>2];f[x+20>>2]=f[s+20>>2];f[x+24>>2]=f[s+24>>2];f[x+28>>2]=f[s+28>>2];f[x+32>>2]=f[s+32>>2];d=x+36|0;A=s+36|0;c=f[A>>2]|0;f[d>>2]=c;X=x+40|0;f[X>>2]=g;g=x+48|0;E=x+44|0;f[E>>2]=g;f[g>>2]=0;f[x+52>>2]=0;if(!c)_=j;else{j=c+12|0;f[j>>2]=(f[j>>2]|0)+1;_=f[M>>2]|0}if((_|0)<3){_=f[Q>>2]|0;j=f[E>>2]|0;f[j>>2]=f[_>>2];f[j+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;ZS(x,s)}f[y>>2]=f[t>>2];_=y+4|0;j=f[R>>2]|0;f[_>>2]=j;c=y+8|0;f[c>>2]=f[S>>2];f[y+12>>2]=f[t+12>>2];S=y+16|0;b=t+16|0;f[S>>2]=f[b>>2];f[y+20>>2]=f[t+20>>2];f[y+24>>2]=f[t+24>>2];f[y+28>>2]=f[t+28>>2];f[y+32>>2]=f[t+32>>2];B=y+36|0;a=t+36|0;V=f[a>>2]|0;f[B>>2]=V;m=y+40|0;f[m>>2]=c;c=y+48|0;U=y+44|0;f[U>>2]=c;f[c>>2]=0;f[y+52>>2]=0;if(!V)$=j;else{j=V+12|0;f[j>>2]=(f[j>>2]|0)+1;$=f[R>>2]|0}if(($|0)<3){$=f[J>>2]|0;j=f[U>>2]|0;f[j>>2]=f[$>>2];f[j+4>>2]=f[$+4>>2]}else{f[_>>2]=0;ZS(y,t)}f[z>>2]=f[v>>2];$=z+4|0;j=v+4|0;V=f[j>>2]|0;f[$>>2]=V;l=z+8|0;f[l>>2]=f[v+8>>2];f[z+12>>2]=f[v+12>>2];aa=z+16|0;ba=v+16|0;f[aa>>2]=f[ba>>2];f[z+20>>2]=f[v+20>>2];f[z+24>>2]=f[v+24>>2];f[z+28>>2]=f[v+28>>2];f[z+32>>2]=f[v+32>>2];ca=z+36|0;da=v+36|0;ea=f[da>>2]|0;f[ca>>2]=ea;fa=z+40|0;f[fa>>2]=l;l=z+48|0;ga=z+44|0;f[ga>>2]=l;f[l>>2]=0;f[z+52>>2]=0;if(!ea)ha=V;else{V=ea+12|0;f[V>>2]=(f[V>>2]|0)+1;ha=f[j>>2]|0}if((ha|0)<3){ha=f[v+44>>2]|0;V=f[ga>>2]|0;f[V>>2]=f[ha>>2];f[V+4>>2]=f[ha+4>>2]}else{f[$>>2]=0;ZS(z,v)}yN(w,x,e,y,i,z,o);o=f[ca>>2]|0;if(o|0?(ha=o+12|0,o=f[ha>>2]|0,f[ha>>2]=o+-1,(o|0)==1):0)_S(z);f[ca>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[fa>>2]|0;fa=0;do{f[aa+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[$>>2]|0))}$=f[ga>>2]|0;if(($|0)!=(l|0))g0($);$=f[B>>2]|0;if($|0?(l=$+12|0,$=f[l>>2]|0,f[l>>2]=$+-1,($|0)==1):0)_S(y);f[B>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[_>>2]|0)>0){S=f[m>>2]|0;m=0;do{f[S+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[_>>2]|0))}_=f[U>>2]|0;if((_|0)!=(c|0))g0(_);_=f[d>>2]|0;if(_|0?(c=_+12|0,_=f[c>>2]|0,f[c>>2]=_+-1,(_|0)==1):0)_S(x);f[d>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Z>>2]|0)>0){N=f[X>>2]|0;X=0;do{f[N+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[Z>>2]|0))}Z=f[E>>2]|0;if((Z|0)!=(g|0))g0(Z);Z=f[D>>2]|0;do if(Z|0){g=Z+12|0;E=f[g>>2]|0;f[g>>2]=E+-1;if((E|0)!=1)break;_S(w)}while(0);f[D>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[k>>2]|0)>0){G=f[W>>2]|0;W=0;do{f[G+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[k>>2]|0))}k=f[F>>2]|0;if((k|0)!=(p|0))g0(k);k=f[da>>2]|0;do if(k|0){p=k+12|0;F=f[p>>2]|0;f[p>>2]=F+-1;if((F|0)!=1)break;_S(v)}while(0);f[da>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[j>>2]|0)>0){ba=f[v+40>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))g0(j);j=f[a>>2]|0;do if(j|0){v=j+12|0;da=f[v>>2]|0;f[v>>2]=da+-1;if((da|0)!=1)break;_S(t)}while(0);f[a>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[R>>2]|0)>0){b=f[T>>2]|0;T=0;do{f[b+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[J>>2]|0;if((R|0)!=(I|0))g0(R);R=f[A>>2]|0;do if(R|0){I=R+12|0;J=f[I>>2]|0;f[I>>2]=J+-1;if((J|0)!=1)break;_S(s)}while(0);f[A>>2]=0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[M>>2]|0)>0){Y=f[O>>2]|0;O=0;do{f[Y+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))g0(M);M=f[h>>2]|0;do if(M|0){P=M+12|0;Q=f[P>>2]|0;f[P>>2]=Q+-1;if((Q|0)!=1)break;_S(r)}while(0);f[h>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[H>>2]|0;H=0;do{f[n+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[C>>2]|0))}C=f[L>>2]|0;if((C|0)==(K|0)){u=q;return}g0(C);u=q;return}function yN(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0;j=u;u=u+1104|0;k=j+64|0;l=j+56|0;m=j+48|0;o=j+40|0;q=j+32|0;r=j+24|0;s=j+16|0;t=j+8|0;v=j;w=f[a+40>>2]|0;x=f[w+4>>2]|0;y=f[w>>2]|0;w=f[a>>2]|0;z=w&4095;switch(i&3){case 0:{A=c+8|0;B=c+12|0;C=y;break}case 1:{A=c+8|0;B=c+12|0;C=x;break}case 2:{A=c+12|0;B=c+8|0;C=y;break}case 3:{A=c+12|0;B=c+8|0;C=x;break}default:{}}D=f[B>>2]|0;B=f[A>>2]|0;a:do if((i|0)==0&(B+-2|0)>>>0<3?(B|0)==(D|0)|(B|0)==(C|0):0){switch(w&4095){case 5:{A=f[h+16>>2]|0;E=f[a+16>>2]|0;F=f[c+16>>2]|0;G=f[e+16>>2]|0;H=f[h+48>>2]|0;I=H>>>2;J=f[a+48>>2]|0;K=J>>>2;L=f[c+48>>2]|0;M=L>>>2;if(!G)N=0;else N=(f[e+48>>2]|0)>>>2;O=(G|0)==0?530032:G;switch(B|0){case 2:{if(!((D|0)!=2|(F|0)==(A|0))){if((C|0)<=0){u=j;return}P=F+(M<<2)|0;Q=F+4|0;R=F+(M+1<<2)|0;S=0;T=A;U=E;V=O;while(1){W=+n[U>>2];X=+n[U+4>>2];Z=W*+n[Q>>2]+X*+n[R>>2];n[T>>2]=(W*+n[F>>2]+X*+n[P>>2])*d+ +n[V>>2]*g;n[T+4>>2]=Z*d+ +n[V+4>>2]*g;S=S+1|0;if((S|0)==(C|0))break;else{T=T+(I<<2)|0;U=U+(K<<2)|0;V=V+(N<<2)|0}}u=j;return}if((E|0)!=(A|0)){V=(O|0)==530032;U=(V^1)&1;T=V?1:N;if((D|0)<=0){u=j;return}V=E+4|0;S=E+(K<<2)|0;P=E+(K+1<<2)|0;R=F;Q=0;_=A;$=O;while(1){Z=+n[R>>2];X=+n[R+(M<<2)>>2];W=Z*+n[S>>2]+X*+n[P>>2];n[_>>2]=(+n[E>>2]*Z+ +n[V>>2]*X)*d+ +n[$>>2]*g;n[_+(I<<2)>>2]=W*d+ +n[$+(T<<2)>>2]*g;Q=Q+1|0;if((Q|0)==(D|0))break;else{R=R+4|0;_=_+4|0;$=$+(U<<2)|0}}u=j;return}break}case 3:{if(!((D|0)!=3|(F|0)==(A|0))){if((C|0)<=0){u=j;return}U=F+(M<<2)|0;$=M<<1;_=F+($<<2)|0;R=F+4|0;Q=F+(M+1<<2)|0;T=F+(($|1)<<2)|0;V=F+8|0;P=F+(M+2<<2)|0;S=F+($+2<<2)|0;$=E;aa=0;ba=A;ca=O;while(1){W=+n[$>>2];X=+n[$+4>>2];Z=+n[$+8>>2];da=W*+n[R>>2]+X*+n[Q>>2]+Z*+n[T>>2];ea=W*+n[V>>2]+X*+n[P>>2]+Z*+n[S>>2];n[ba>>2]=(W*+n[F>>2]+X*+n[U>>2]+Z*+n[_>>2])*d+ +n[ca>>2]*g;n[ba+4>>2]=da*d+ +n[ca+4>>2]*g;n[ba+8>>2]=ea*d+ +n[ca+8>>2]*g;aa=aa+1|0;if((aa|0)==(C|0))break;else{$=$+(K<<2)|0;ba=ba+(I<<2)|0;ca=ca+(N<<2)|0}}u=j;return}if((E|0)!=(A|0)){ca=(O|0)==530032;ba=(ca^1)&1;$=ca?1:N;if((D|0)<=0){u=j;return}ca=E+4|0;aa=E+8|0;_=M<<1;U=E+(K<<2)|0;S=E+(K+1<<2)|0;P=E+(K+2<<2)|0;V=K<<1;T=E+(V<<2)|0;Q=E+((V|1)<<2)|0;R=E+(V+2<<2)|0;V=$<<1;fa=I<<1;ga=F;ha=0;ia=A;ja=O;while(1){ea=+n[ga>>2];da=+n[ga+(M<<2)>>2];Z=+n[ga+(_<<2)>>2];X=ea*+n[U>>2]+da*+n[S>>2]+Z*+n[P>>2];W=ea*+n[T>>2]+da*+n[Q>>2]+Z*+n[R>>2];n[ia>>2]=(+n[E>>2]*ea+ +n[ca>>2]*da+ +n[aa>>2]*Z)*d+ +n[ja>>2]*g;n[ia+(I<<2)>>2]=X*d+ +n[ja+($<<2)>>2]*g;n[ia+(fa<<2)>>2]=W*d+ +n[ja+(V<<2)>>2]*g;ha=ha+1|0;if((ha|0)==(D|0))break;else{ga=ga+4|0;ia=ia+4|0;ja=ja+(ba<<2)|0}}u=j;return}break}case 4:{if(!((D|0)!=4|(F|0)==(A|0))){if((C|0)<=0){u=j;return}ba=F+(M<<2)|0;ja=M<<1;ia=F+(ja<<2)|0;ga=M*3|0;ha=F+(ga<<2)|0;V=F+4|0;fa=F+(M+1<<2)|0;$=F+((ja|1)<<2)|0;aa=F+(ga+1<<2)|0;ca=F+8|0;R=F+(M+2<<2)|0;Q=F+(ja+2<<2)|0;T=F+(ga+2<<2)|0;P=F+12|0;S=F+(M+3<<2)|0;U=F+(ja+3<<2)|0;ja=F+(ga+3<<2)|0;ga=E;_=0;ka=A;la=O;while(1){W=+n[ga>>2];X=+n[ga+4>>2];Z=+n[ga+8>>2];da=+n[ga+12>>2];ea=W*+n[V>>2]+X*+n[fa>>2]+Z*+n[$>>2]+da*+n[aa>>2];ma=W*+n[ca>>2]+X*+n[R>>2]+Z*+n[Q>>2]+da*+n[T>>2];na=W*+n[P>>2]+X*+n[S>>2]+Z*+n[U>>2]+da*+n[ja>>2];n[ka>>2]=(W*+n[F>>2]+X*+n[ba>>2]+Z*+n[ia>>2]+da*+n[ha>>2])*d+ +n[la>>2]*g;n[ka+4>>2]=ea*d+ +n[la+4>>2]*g;n[ka+8>>2]=ma*d+ +n[la+8>>2]*g;n[ka+12>>2]=na*d+ +n[la+12>>2]*g;_=_+1|0;if((_|0)==(C|0))break;else{ga=ga+(K<<2)|0;ka=ka+(I<<2)|0;la=la+(N<<2)|0}}u=j;return}if((E|0)!=(A|0)){la=(O|0)==530032;ka=(la^1)&1;ga=la?1:N;if((D|0)<=0){u=j;return}la=E+4|0;_=E+8|0;ha=M<<1;ia=E+12|0;ba=M*3|0;ja=E+(K<<2)|0;U=E+(K+1<<2)|0;S=E+(K+2<<2)|0;P=E+(K+3<<2)|0;T=K<<1;Q=E+(T<<2)|0;R=E+((T|1)<<2)|0;ca=E+(T+2<<2)|0;aa=E+(T+3<<2)|0;T=K*3|0;$=E+(T<<2)|0;fa=E+(T+1<<2)|0;V=E+(T+2<<2)|0;oa=E+(T+3<<2)|0;T=ga<<1;pa=I<<1;qa=ga*3|0;ra=I*3|0;sa=F;ta=0;ua=A;va=O;while(1){na=+n[sa>>2];ma=+n[sa+(M<<2)>>2];ea=+n[sa+(ha<<2)>>2];da=+n[sa+(ba<<2)>>2];Z=na*+n[ja>>2]+ma*+n[U>>2]+ea*+n[S>>2]+da*+n[P>>2];X=na*+n[Q>>2]+ma*+n[R>>2]+ea*+n[ca>>2]+da*+n[aa>>2];W=na*+n[$>>2]+ma*+n[fa>>2]+ea*+n[V>>2]+da*+n[oa>>2];n[ua>>2]=(+n[E>>2]*na+ +n[la>>2]*ma+ +n[_>>2]*ea+ +n[ia>>2]*da)*d+ +n[va>>2]*g;n[ua+(I<<2)>>2]=Z*d+ +n[va+(ga<<2)>>2]*g;n[ua+(pa<<2)>>2]=X*d+ +n[va+(T<<2)>>2]*g;n[ua+(ra<<2)>>2]=W*d+ +n[va+(qa<<2)>>2]*g;ta=ta+1|0;if((ta|0)==(D|0))break;else{sa=sa+4|0;ua=ua+4|0;va=va+(ka<<2)|0}}u=j;return}break}default:{}}if((z|0)==6){wa=H;xa=J;ya=L;za=G;Aa=G;Ba=F;Ca=A;Da=E}else break a;break}case 6:{ka=f[e+16>>2]|0;wa=f[h+48>>2]|0;xa=f[a+48>>2]|0;ya=f[c+48>>2]|0;za=ka;Aa=ka;Ba=f[c+16>>2]|0;Ca=f[h+16>>2]|0;Da=f[a+16>>2]|0;break}default:break a}ka=wa>>>3;va=xa>>>3;ua=ya>>>3;if(!za)Ea=0;else Ea=(f[e+48>>2]|0)>>>3;sa=(Aa|0)==0?519776:Aa;switch(B|0){case 2:{if(!((D|0)!=2|(Ba|0)==(Ca|0))){if((C|0)<=0){u=j;return}ta=Ba+(ua<<3)|0;qa=Ba+8|0;ra=Ba+(ua+1<<3)|0;T=Ca;pa=Da;ga=sa;I=0;while(1){W=+p[pa>>3];X=+p[pa+8>>3];Z=W*+p[qa>>3]+X*+p[ra>>3];p[T>>3]=(W*+p[Ba>>3]+X*+p[ta>>3])*d+ +p[ga>>3]*g;p[T+8>>3]=Z*d+ +p[ga+8>>3]*g;I=I+1|0;if((I|0)==(C|0))break;else{T=T+(ka<<3)|0;pa=pa+(va<<3)|0;ga=ga+(Ea<<3)|0}}u=j;return}if((Da|0)==(Ca|0))break a;ga=(sa|0)==519776;pa=(ga^1)&1;T=ga?1:Ea;if((D|0)<=0){u=j;return}ga=Da+8|0;I=Da+(va<<3)|0;ta=Da+(va+1<<3)|0;ra=Ba;qa=Ca;E=sa;A=0;while(1){Z=+p[ra>>3];X=+p[ra+(ua<<3)>>3];W=Z*+p[I>>3]+X*+p[ta>>3];p[qa>>3]=(+p[Da>>3]*Z+ +p[ga>>3]*X)*d+ +p[E>>3]*g;p[qa+(ka<<3)>>3]=W*d+ +p[E+(T<<3)>>3]*g;A=A+1|0;if((A|0)==(D|0))break;else{ra=ra+8|0;qa=qa+8|0;E=E+(pa<<3)|0}}u=j;return}case 3:{if(!((D|0)!=3|(Ba|0)==(Ca|0))){if((C|0)<=0){u=j;return}pa=Ba+(ua<<3)|0;E=ua<<1;qa=Ba+(E<<3)|0;ra=Ba+8|0;A=Ba+(ua+1<<3)|0;T=Ba+((E|1)<<3)|0;ga=Ba+16|0;ta=Ba+(ua+2<<3)|0;I=Ba+(E+2<<3)|0;E=Da;F=Ca;G=sa;L=0;while(1){W=+p[E>>3];X=+p[E+8>>3];Z=+p[E+16>>3];da=W*+p[ra>>3]+X*+p[A>>3]+Z*+p[T>>3];ea=W*+p[ga>>3]+X*+p[ta>>3]+Z*+p[I>>3];p[F>>3]=(W*+p[Ba>>3]+X*+p[pa>>3]+Z*+p[qa>>3])*d+ +p[G>>3]*g;p[F+8>>3]=da*d+ +p[G+8>>3]*g;p[F+16>>3]=ea*d+ +p[G+16>>3]*g;L=L+1|0;if((L|0)==(C|0))break;else{E=E+(va<<3)|0;F=F+(ka<<3)|0;G=G+(Ea<<3)|0}}u=j;return}if((Da|0)==(Ca|0))break a;G=(sa|0)==519776;F=(G^1)&1;E=G?1:Ea;if((D|0)<=0){u=j;return}G=Da+8|0;L=Da+16|0;qa=ua<<1;pa=Da+(va<<3)|0;I=Da+(va+1<<3)|0;ta=Da+(va+2<<3)|0;ga=va<<1;T=Da+(ga<<3)|0;A=Da+((ga|1)<<3)|0;ra=Da+(ga+2<<3)|0;ga=E<<1;J=ka<<1;H=Ba;ia=Ca;_=sa;la=0;while(1){ea=+p[H>>3];da=+p[H+(ua<<3)>>3];Z=+p[H+(qa<<3)>>3];X=ea*+p[pa>>3]+da*+p[I>>3]+Z*+p[ta>>3];W=ea*+p[T>>3]+da*+p[A>>3]+Z*+p[ra>>3];p[ia>>3]=(+p[Da>>3]*ea+ +p[G>>3]*da+ +p[L>>3]*Z)*d+ +p[_>>3]*g;p[ia+(ka<<3)>>3]=X*d+ +p[_+(E<<3)>>3]*g;p[ia+(J<<3)>>3]=W*d+ +p[_+(ga<<3)>>3]*g;la=la+1|0;if((la|0)==(D|0))break;else{H=H+8|0;ia=ia+8|0;_=_+(F<<3)|0}}u=j;return}case 4:{if(!((D|0)!=4|(Ba|0)==(Ca|0))){if((C|0)<=0){u=j;return}F=Ba+(ua<<3)|0;_=ua<<1;ia=Ba+(_<<3)|0;H=ua*3|0;la=Ba+(H<<3)|0;ga=Ba+8|0;J=Ba+(ua+1<<3)|0;E=Ba+((_|1)<<3)|0;L=Ba+(H+1<<3)|0;G=Ba+16|0;ra=Ba+(ua+2<<3)|0;A=Ba+(_+2<<3)|0;T=Ba+(H+2<<3)|0;ta=Ba+24|0;I=Ba+(ua+3<<3)|0;pa=Ba+(_+3<<3)|0;_=Ba+(H+3<<3)|0;H=0;qa=Da;oa=Ca;V=sa;while(1){W=+p[qa>>3];X=+p[qa+8>>3];Z=+p[qa+16>>3];da=+p[qa+24>>3];ea=W*+p[ga>>3]+X*+p[J>>3]+Z*+p[E>>3]+da*+p[L>>3];ma=W*+p[G>>3]+X*+p[ra>>3]+Z*+p[A>>3]+da*+p[T>>3];na=W*+p[ta>>3]+X*+p[I>>3]+Z*+p[pa>>3]+da*+p[_>>3];p[oa>>3]=(W*+p[Ba>>3]+X*+p[F>>3]+Z*+p[ia>>3]+da*+p[la>>3])*d+ +p[V>>3]*g;p[oa+8>>3]=ea*d+ +p[V+8>>3]*g;p[oa+16>>3]=ma*d+ +p[V+16>>3]*g;p[oa+24>>3]=na*d+ +p[V+24>>3]*g;H=H+1|0;if((H|0)==(C|0))break;else{qa=qa+(va<<3)|0;oa=oa+(ka<<3)|0;V=V+(Ea<<3)|0}}u=j;return}if((D|0)>16|(Da|0)==(Ca|0))break a;V=(sa|0)==519776;oa=V?1:Ea;qa=(V^1)&1;if((D|0)<=0){u=j;return}V=Da+8|0;H=Da+16|0;la=ua<<1;ia=Da+24|0;F=ua*3|0;_=Da+(va<<3)|0;pa=Da+(va+1<<3)|0;I=Da+(va+2<<3)|0;ta=Da+(va+3<<3)|0;T=va<<1;A=Da+(T<<3)|0;ra=Da+((T|1)<<3)|0;G=Da+(T+2<<3)|0;L=Da+(T+3<<3)|0;T=va*3|0;E=Da+(T<<3)|0;J=Da+(T+1<<3)|0;ga=Da+(T+2<<3)|0;fa=Da+(T+3<<3)|0;T=oa<<1;$=ka<<1;aa=oa*3|0;ca=ka*3|0;R=0;Q=Ba;P=Ca;S=sa;while(1){na=+p[Q>>3];ma=+p[Q+(ua<<3)>>3];ea=+p[Q+(la<<3)>>3];da=+p[Q+(F<<3)>>3];Z=na*+p[_>>3]+ma*+p[pa>>3]+ea*+p[I>>3]+da*+p[ta>>3];X=na*+p[A>>3]+ma*+p[ra>>3]+ea*+p[G>>3]+da*+p[L>>3];W=na*+p[E>>3]+ma*+p[J>>3]+ea*+p[ga>>3]+da*+p[fa>>3];p[P>>3]=(+p[Da>>3]*na+ +p[V>>3]*ma+ +p[H>>3]*ea+ +p[ia>>3]*da)*d+ +p[S>>3]*g;p[P+(ka<<3)>>3]=Z*d+ +p[S+(oa<<3)>>3]*g;p[P+($<<3)>>3]=X*d+ +p[S+(T<<3)>>3]*g;p[P+(ca<<3)>>3]=W*d+ +p[S+(aa<<3)>>3]*g;R=R+1|0;if((R|0)==(D|0))break;else{Q=Q+8|0;P=P+8|0;S=S+(qa<<3)|0}}u=j;return}default:break a}}while(0);Da=f[c+48>>2]|0;Ca=f[e+16>>2]|0;Ba=(Ca|0)==0;if(Ba)Fa=0;else Fa=f[e+48>>2]|0;Ea=k+8|0;f[k>>2]=Ea;Aa=k+4|0;f[Aa>>2]=1032;switch(w&4095){case 5:{Ga=2;Ha=106;Ia=1;break}case 6:{Ga=3;Ha=107;Ia=2;break}case 13:{Ga=4;Ha=108;Ia=3;break}case 14:{Ga=5;Ha=109;Ia=4;break}default:{f[l>>2]=0;f[l+4>>2]=0;za=tT(l,16)|0;ya=212622;xa=za+16|0;do{b[za>>0]=b[ya>>0]|0;za=za+1|0;ya=ya+1|0}while((za|0)<(xa|0));z5(-215,l,212639,212648,1218)}}l=(D|0)==1;if((i&2|0)==0&(l|(B|0)==1)?(f[c>>2]&16384|0)!=0:0){if(l)Ja=0;else Ja=(w>>>3&511)+1<<(47696>>>(z<<1&14)&3);Ka=i|2;La=Ja}else{Ka=i;La=Da}if((C|0)<65)if((B|0)<10001)Ma=83;else Ma=81;else if((B|0)<11|(D|0)<65&(B|0)<10001)Ma=83;else Ma=81;do if((Ma|0)==81){if((D|0)<129?(C|0)<129&(B|0)<129:0){Ma=83;break}Da=w&7;i=(w>>>3&511)+1<<(47696>>>(Da<<1)&3);Ja=i<<((Da|0)==5&1);Da=(Ka&1|0)!=0;z=a+48|0;l=f[z>>2]|0;ya=Da?i:l;za=Da?l:i;l=(Ka&2|0)!=0;xa=l?i:La;wa=l?La:i;if(!Ba){N=f[e+4>>2]|0;if((N|0)<3)Na=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{qa=f[e+40>>2]|0;S=0;P=1;while(1){Q=Y(f[qa+(S<<2)>>2]|0,P)|0;S=S+1|0;if((S|0)==(N|0)){Na=Q;break}else P=Q}}if(!((N|0)==0|(Na|0)==0)){P=(Ka&4|0)==0;S=f[e+48>>2]|0;Oa=P?i:S;Pa=P?S:i;Qa=Ka}else Ma=90}else Ma=90;if((Ma|0)==90){Oa=0;Pa=0;Qa=Ka&-5}S=(C|0)<128?C:128;P=(D|0)<128?D:128;qa=16384/(S|0)|0;Q=16384/(P|0)|0;R=(Q|0)<(qa|0)?Q:qa;qa=(B|0)<(R|0)?B:R;if((Y(qa,S)|0)>16384)Ra=16384/(qa|0)|0;else Ra=S;if((Y(qa,P)|0)>16384)Sa=16384/(qa|0)|0;else Sa=P;P=((qa|0)/8|0)+qa|0;S=Y(Sa+2+((Sa|0)/8|0)&-2,P+1|0)|0;Q=Y(S,i)|0;aa=Y(S,Ja)|0;if(Da){Ta=Y(Y(P+2&-2,i)|0,Ra+1+((Ra|0)/8|0)|0)|0;Ua=Qa&-2}else{Ta=0;Ua=Qa}P=aa+Q+Ta|0;f[Aa>>2]=P;if(P>>>0>1032){S=XDc(P)|0;f[k>>2]=S;Va=S}else Va=Ea;S=Va+aa|0;aa=S+Q|0;Q=Da?aa:0;if((C|0)>0){P=C<<3;ca=(D|0)>0;T=h+16|0;$=h+44|0;oa=h+48|0;ka=D<<3;ia=(B|0)>(R|0);R=(B|0)>0;H=v+4|0;V=a+16|0;fa=c+16|0;ga=B<<3;J=Da&(Q|0)!=0;E=(i|0)==4;L=i&65535;G=i>>>2;ra=q+4|0;A=r+4|0;ta=s+4|0;I=t+4|0;pa=0;_=Ua;while(1){F=pa+Ra|0;if((F|0)<(C|0)?((F<<3)+Ra|0)<=(P|0):0)Wa=Ra;else Wa=C-pa|0;if(ca){F=Ca+(Y(pa,Pa)|0)|0;la=Y(pa,ya)|0;ua=0;sa=_;while(1){va=f[oa>>2]|0;U=Y(ua,i)|0;ja=(f[T>>2]|0)+(Y(va,pa)|0)+U|0;ba=F+(Y(ua,Oa)|0)|0;ha=ua+Sa|0;if((ha|0)<(D|0)?((ha<<3)+Sa|0)<=(ka|0):0)Xa=Sa;else Xa=D-ua|0;ha=sa&15;M=Y(Xa,Ja)|0;O=ia?Va:ja;ja=ia?M:va;if(R){va=Y(ua,wa)|0;M=(Xa|0)<(D|0);K=0;Ya=ha;while(1){Za=(f[V>>2]|0)+la+(Y(K,za)|0)|0;_a=f[z>>2]|0;$a=(f[fa>>2]|0)+(Y(K,xa)|0)+va|0;ab=K+qa|0;if((ab|0)<(B|0)?((ab<<3)+qa|0)<=(ga|0):0)bb=qa;else bb=B-K|0;ab=Da?Wa:bb;cb=Da?bb:Wa;b:do if(J){db=Y(bb,i)|0;if((ab|0)<=0){eb=db;fb=aa;gb=cb;hb=ab;break}ib=(cb|0)>0;if(E){if(ib){jb=Za;kb=aa;lb=0}else{eb=db;fb=Q;gb=cb;hb=ab;break}while(1){mb=0;nb=jb;while(1){f[kb+(mb<<2)>>2]=f[nb>>2];mb=mb+1|0;if((mb|0)==(cb|0))break;else nb=nb+_a|0}lb=lb+1|0;if((lb|0)==(ab|0)){eb=db;fb=Q;gb=cb;hb=ab;break b}else{jb=jb+4|0;kb=kb+db|0}}}nb=cb<<2;mb=cb<<1;switch(L&8191){case 16:{ob=Za;pb=aa;qb=0;while(1){if(ib){rb=ob;sb=0;while(1){tb=f[rb+4>>2]|0;f[pb+(sb<<2)>>2]=f[rb>>2];f[pb+((sb|1)<<2)>>2]=tb;tb=f[rb+12>>2]|0;f[pb+((sb|2)<<2)>>2]=f[rb+8>>2];f[pb+((sb|3)<<2)>>2]=tb;sb=sb+4|0;if((sb|0)>=(nb|0))break;else rb=rb+_a|0}}qb=qb+1|0;if((qb|0)==(ab|0)){eb=db;fb=Q;gb=cb;hb=ab;break}else{ob=ob+i|0;pb=pb+db|0}}break}case 8:{pb=Za;ob=aa;qb=0;while(1){if(ib){nb=pb;rb=0;while(1){sb=f[nb+4>>2]|0;f[ob+(rb<<2)>>2]=f[nb>>2];f[ob+((rb|1)<<2)>>2]=sb;rb=rb+2|0;if((rb|0)>=(mb|0))break;else nb=nb+_a|0}}qb=qb+1|0;if((qb|0)==(ab|0)){eb=db;fb=Q;gb=cb;hb=ab;break}else{pb=pb+i|0;ob=ob+db|0}}break}default:{eb=db;fb=aa;gb=cb;hb=ab;break b}}}else{eb=_a;fb=Za;gb=ab;hb=cb}while(0);c:do if(M){cb=l?bb:Xa;ab=l?Xa:bb;Za=Y(cb,i)|0;_a=Y(cb,G)|0;if(!ab){ub=Za;vb=S;break}cb=_a+-4|0;if((_a|0)<4){ob=(_a|0)>0;pb=S;qb=$a;mb=ab;while(1){mb=mb+-1|0;if(ob){ib=0;do{f[pb+(ib<<2)>>2]=f[qb+(ib<<2)>>2];ib=ib+1|0}while((ib|0)!=(_a|0))}if(!mb){ub=Za;vb=S;break c}else{pb=pb+Za|0;qb=qb+La|0}}}qb=_a&-4;pb=(qb|0)<(_a|0);mb=S;ob=$a;db=ab;while(1){ib=0;do{nb=ib|1;rb=f[ob+(nb<<2)>>2]|0;f[mb+(ib<<2)>>2]=f[ob+(ib<<2)>>2];f[mb+(nb<<2)>>2]=rb;rb=ib|2;nb=ib|3;sb=f[ob+(nb<<2)>>2]|0;f[mb+(rb<<2)>>2]=f[ob+(rb<<2)>>2];f[mb+(nb<<2)>>2]=sb;ib=ib+4|0}while((ib|0)<=(cb|0));db=db+-1|0;if(pb){ib=qb;do{f[mb+(ib<<2)>>2]=f[ob+(ib<<2)>>2];ib=ib+1|0}while((ib|0)!=(_a|0))}if(!db){ub=Za;vb=S;break}else{mb=mb+Za|0;ob=ob+La|0}}}else{ub=La;vb=$a}while(0);if(ia){f[q>>2]=gb;f[ra>>2]=hb;f[r>>2]=Xa;f[A>>2]=Wa;Li[Ha&127](fb,eb,vb,ub,O,ja,q,r,Ya)}else{f[s>>2]=gb;f[ta>>2]=hb;f[t>>2]=Xa;f[I>>2]=Wa;wh[Ia&7](fb,eb,vb,ub,ba,Fa,O,ja,s,t,d,g,Ya)}$a=Ya|16;K=bb+K|0;if((B|0)<=(K|0)){wb=$a;break}else Ya=$a}}else wb=ha;if(ia){Ya=(f[T>>2]|0)+(Y(f[f[$>>2]>>2]|0,pa)|0)+U|0;K=f[oa>>2]|0;f[v>>2]=Xa;f[H>>2]=Wa;$i[Ga&7](ba,Fa,O,ja,Ya,K,v,d,g,wb)}ua=Xa+ua|0;if((D|0)<=(ua|0)){xb=wb;break}else sa=wb}}else xb=_;pa=Wa+pa|0;if((C|0)<=(pa|0))break;else _=xb}}}while(0);if((Ma|0)==83){Ma=f[a+16>>2]|0;xb=f[a+48>>2]|0;a=f[c+16>>2]|0;c=f[h+16>>2]|0;Wa=f[h+48>>2]|0;f[m>>2]=x;f[m+4>>2]=y;f[o>>2]=D;f[o+4>>2]=C;wh[Ia&7](Ma,xb,a,La,Ca,Fa,c,Wa,m,o,d,g,Ka)}Ka=f[k>>2]|0;if((Ka|0)!=(Ea|0)){if(Ka|0)ZDc(Ka);f[k>>2]=Ea;f[Aa>>2]=1032}u=j;return}function zN(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;o=u;u=u+2192|0;q=o+1096|0;r=o;s=f[j>>2]|0;t=f[j+4>>2]|0;j=f[k>>2]|0;v=f[k+4>>2]|0;k=q+8|0;f[q>>2]=k;w=q+4|0;f[w>>2]=136;x=b>>>3;y=d>>>3;z=g>>>3;g=i>>>3;i=(e|0)==0;A=(n&4|0)==0;B=i?0:A?z:1;C=i?0:A?1:z;if(n&1)if(b>>>0>15&(t|0)>1){f[w>>2]=t;if(t>>>0>136){z=XDc(t>>>0>536870911?-1:t<<3)|0;f[q>>2]=z;D=x;E=1;F=z;G=t;H=43}else{D=x;E=1;F=k;G=t;H=43}}else{I=x;J=1;K=t;H=5}else{I=1;J=x;K=s;H=5}if((H|0)==5)if((K|0)==1){s=r+8|0;f[r>>2]=s;z=r+4|0;f[z>>2]=136;if(b>>>0>15&(t|0)>1){f[w>>2]=v;if(v>>>0>136){t=XDc(v>>>0>536870911?-1:v<<3)|0;f[q>>2]=t;L=t}else L=k;if((v|0)>0){t=0;do{b=a+((Y(t,x)|0)<<3)|0;p[L+(t<<3)>>3]=+p[b>>3];t=t+1|0}while((t|0)!=(v|0));M=L}else M=L}else M=a;if(d>>>0>15){f[z>>2]=j;if(j>>>0>136){d=XDc(j>>>0>536870911?-1:j<<3)|0;f[r>>2]=d;N=d}else N=s;if((j|0)>0){d=0;do{L=c+((Y(d,y)|0)<<3)|0;p[N+(d<<3)>>3]=+p[L>>3];d=d+1|0}while((d|0)!=(j|0));O=N;P=N}else{O=N;P=N}}else{O=c;P=s}a:do if((v|0)>0){N=C<<1;if((j|0)<2){if((j|0)==1){Q=h;R=0;S=e}else break;while(1){T=+p[M+(R<<3)>>3]*l*+p[O>>3];if(!S)U=T;else U=T+ +p[S>>3]*m;p[Q>>3]=U;R=R+1|0;if((R|0)==(v|0))break a;else{Q=Q+(g<<3)|0;S=S+(B<<3)|0}}}d=j+-2|0;L=((d|0)>1?d:1)>>>1;t=Y(L,N)|0;x=(L<<1)+2|0;if((x|0)>=(j|0)){L=h;b=0;A=e;while(1){T=+p[M+(b<<3)>>3]*l;i=A;V=0;while(1){W=T*+p[O+(V<<3)>>3];X=V|1;Z=T*+p[O+(X<<3)>>3];if(!i){p[L+(V<<3)>>3]=W;_=Z}else{p[L+(V<<3)>>3]=W+ +p[i>>3]*m;_=Z+ +p[i+(C<<3)>>3]*m}p[L+(X<<3)>>3]=_;V=V+2|0;if((V|0)>(d|0))break;else i=i+(N<<3)|0}b=b+1|0;if((b|0)==(v|0))break a;else{L=L+(g<<3)|0;A=A+(B<<3)|0}}}A=h;L=0;b=e;i=e+(N<<3)|0;while(1){T=+p[M+(L<<3)>>3]*l;V=b;X=0;while(1){Z=T*+p[O+(X<<3)>>3];$=X|1;W=T*+p[O+($<<3)>>3];if(!V){p[A+(X<<3)>>3]=Z;aa=W}else{p[A+(X<<3)>>3]=Z+ +p[V>>3]*m;aa=W+ +p[V+(C<<3)>>3]*m}p[A+($<<3)>>3]=aa;X=X+2|0;if((X|0)>(d|0))break;else V=V+(N<<3)|0}V=i+(t<<3)|0;X=x;while(1){W=T*+p[O+(X<<3)>>3];if(!V)ba=W;else ba=W+ +p[V>>3]*m;p[A+(X<<3)>>3]=ba;X=X+1|0;if((X|0)==(j|0))break;else V=V+(C<<3)|0}L=L+1|0;if((L|0)==(v|0))break;else{A=A+(g<<3)|0;b=b+(B<<3)|0;i=i+(B<<3)|0}}}while(0);if((P|0)!=(s|0)){ZDc(P);f[r>>2]=s;f[z>>2]=136}}else{D=I;E=J;F=0;G=K;H=43}b:do if((H|0)==43){if(n&2|0){if((v|0)<=0)break;K=(F|0)==0;J=(j|0)>0;I=G+-4|0;z=(G|0)<4;s=G&-4;P=K|(G|0)<1;O=(G|0)>0;M=(s|0)<(G|0);ba=l*0.0;S=a;Q=h;R=0;i=e;while(1){if(P)ca=K?S:F;else{b=0;do{A=S+((Y(b,D)|0)<<3)|0;p[F+(b<<3)>>3]=+p[A>>3];b=b+1|0}while((b|0)!=(G|0));ca=F}c:do if(J){if(z){if(O){da=c;ea=i;fa=0}else{b=i;A=0;while(1){if(!b)ga=ba;else ga=ba+ +p[b>>3]*m;p[Q+(A<<3)>>3]=ga;A=A+1|0;if((A|0)==(j|0))break c;else b=b+(C<<3)|0}}while(1){aa=0.0;b=0;do{aa=aa+ +p[ca+(b<<3)>>3]*+p[da+(b<<3)>>3];b=b+1|0}while((b|0)!=(G|0));_=(aa+0.0)*l;if(!ea)ha=_;else ha=_+ +p[ea>>3]*m;p[Q+(fa<<3)>>3]=ha;fa=fa+1|0;if((fa|0)==(j|0))break c;else{da=da+(y<<3)|0;ea=ea+(C<<3)|0}}}if(M){ia=c;ja=i;ka=0}else{b=c;A=i;L=0;while(1){_=0.0;U=0.0;T=0.0;W=0.0;x=0;do{W=W+ +p[ca+(x<<3)>>3]*+p[b+(x<<3)>>3];t=x|1;T=T+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];t=x|2;U=U+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];t=x|3;_=_+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];x=x+4|0}while((x|0)<=(I|0));aa=(_+(U+(T+W)))*l;if(!A)la=aa;else la=aa+ +p[A>>3]*m;p[Q+(L<<3)>>3]=la;L=L+1|0;if((L|0)==(j|0))break c;else{b=b+(y<<3)|0;A=A+(C<<3)|0}}}while(1){aa=0.0;Z=0.0;ma=0.0;na=0.0;A=0;while(1){oa=na+ +p[ca+(A<<3)>>3]*+p[ia+(A<<3)>>3];b=A|1;ma=ma+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];b=A|2;Z=Z+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];b=A|3;aa=aa+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];A=A+4|0;if((A|0)>(I|0)){pa=oa;qa=s;break}else na=oa}do{pa=pa+ +p[ca+(qa<<3)>>3]*+p[ia+(qa<<3)>>3];qa=qa+1|0}while((qa|0)!=(G|0));na=(aa+(Z+(ma+pa)))*l;if(!ja)ra=na;else ra=na+ +p[ja>>3]*m;p[Q+(ka<<3)>>3]=ra;ka=ka+1|0;if((ka|0)==(j|0))break;else{ia=ia+(y<<3)|0;ja=ja+(C<<3)|0}}}while(0);R=R+1|0;if((R|0)==(v|0))break b;else{S=S+(E<<3)|0;Q=Q+(g<<3)|0;i=i+(B<<3)|0}}}i=j<<3;if(i>>>0<1601){if((v|0)<=0)break;Q=(F|0)==0;S=j+-4|0;R=(j|0)<4;s=(G|0)>0;I=C<<2;M=C<<1;O=C*3|0;z=S>>>2;J=(z<<2)+4|0;K=Q|(G|0)<1;ba=l*0.0;P=a;A=h;b=0;L=e;x=e+(Y((z<<5)+32|0,C)|0)|0;while(1){if(K)sa=Q?P:F;else{z=0;do{t=P+((Y(z,D)|0)<<3)|0;p[F+(z<<3)>>3]=+p[t>>3];z=z+1|0}while((z|0)!=(G|0));sa=F}d:do if(R){ta=L;ua=0}else{if(s){va=L;wa=0}else{z=L;t=0;while(1){N=t|1;d=t|2;if(!z){p[A+(t<<3)>>3]=ba;p[A+(N<<3)>>3]=ba;p[A+(d<<3)>>3]=ba;xa=ba}else{p[A+(t<<3)>>3]=ba+ +p[z>>3]*m;p[A+(N<<3)>>3]=ba+ +p[z+(C<<3)>>3]*m;p[A+(d<<3)>>3]=ba+ +p[z+(M<<3)>>3]*m;xa=ba+ +p[z+(O<<3)>>3]*m}p[A+((t|3)<<3)>>3]=xa;t=t+4|0;if((t|0)>(S|0)){ta=x;ua=J;break d}else z=z+(I<<3)|0}}while(1){na=0.0;W=0.0;T=0.0;U=0.0;z=c+(wa<<3)|0;t=0;while(1){_=+p[sa+(t<<3)>>3];U=U+_*+p[z>>3];T=T+_*+p[z+8>>3];W=W+_*+p[z+16>>3];na=na+_*+p[z+24>>3];t=t+1|0;if((t|0)==(G|0))break;else z=z+(y<<3)|0}ma=U*l;Z=na*l;z=wa|1;t=wa|2;aa=W*l;_=T*l;if(!va){p[A+(wa<<3)>>3]=ma;p[A+(z<<3)>>3]=_;p[A+(t<<3)>>3]=aa;ya=Z}else{p[A+(wa<<3)>>3]=ma+ +p[va>>3]*m;p[A+(z<<3)>>3]=_+ +p[va+(C<<3)>>3]*m;p[A+(t<<3)>>3]=aa+ +p[va+(M<<3)>>3]*m;ya=Z+ +p[va+(O<<3)>>3]*m}p[A+((wa|3)<<3)>>3]=ya;wa=wa+4|0;if((wa|0)>(S|0)){ta=x;ua=J;break}else va=va+(I<<3)|0}}while(0);e:do if((ua|0)<(j|0)){if(s){za=ta;Aa=ua}else{t=ta;z=ua;while(1){if(!t)Ba=ba;else Ba=ba+ +p[t>>3]*m;p[A+(z<<3)>>3]=Ba;z=z+1|0;if((z|0)==(j|0))break e;else t=t+(C<<3)|0}}while(1){Z=0.0;t=c+(Aa<<3)|0;z=0;while(1){Z=Z+ +p[sa+(z<<3)>>3]*+p[t>>3];z=z+1|0;if((z|0)==(G|0))break;else t=t+(y<<3)|0}T=Z*l;if(!za)Ca=T;else Ca=T+ +p[za>>3]*m;p[A+(Aa<<3)>>3]=Ca;Aa=Aa+1|0;if((Aa|0)==(j|0))break;else za=za+(C<<3)|0}}while(0);b=b+1|0;if((b|0)==(v|0))break b;else{P=P+(E<<3)|0;A=A+(g<<3)|0;L=L+(B<<3)|0;x=x+(B<<3)|0}}}x=r+8|0;f[r>>2]=x;L=r+4|0;f[L>>2]=j;if(j>>>0>136){A=XDc(j>>>0>536870911?-1:j<<3)|0;f[r>>2]=A;Da=A;Ea=A}else{Da=x;Ea=x}if((v|0)>0){A=(F|0)==0;P=(j|0)>0;b=(G|0)>0;s=j+-4|0;I=(j|0)<4;J=j&-4;S=A|(G|0)<1;O=(J|0)<(j|0);M=a;R=h;Q=0;K=e;while(1){if(S)Fa=A?M:F;else{t=0;do{z=M+((Y(t,D)|0)<<3)|0;p[F+(t<<3)>>3]=+p[z>>3];t=t+1|0}while((t|0)!=(G|0));Fa=F}if(P)XIc(Ea|0,0,i|0)|0;f:do if(b){if(I){if(P){Ga=c;Ha=0}else break;while(1){ba=+p[Fa+(Ha<<3)>>3];t=0;do{z=Ea+(t<<3)|0;p[z>>3]=+p[z>>3]+ba*+p[Ga+(t<<3)>>3];t=t+1|0}while((t|0)!=(j|0));Ha=Ha+1|0;if((Ha|0)==(G|0))break f;else Ga=Ga+(y<<3)|0}}if(O){Ia=c;Ja=0}else{t=c;z=0;while(1){ba=+p[Fa+(z<<3)>>3];d=0;do{N=Ea+(d<<3)|0;V=d|1;X=Ea+(V<<3)|0;Z=+p[X>>3]+ba*+p[t+(V<<3)>>3];p[N>>3]=+p[N>>3]+ba*+p[t+(d<<3)>>3];p[X>>3]=Z;X=d|2;N=Ea+(X<<3)|0;V=d|3;$=Ea+(V<<3)|0;Z=+p[$>>3]+ba*+p[t+(V<<3)>>3];p[N>>3]=+p[N>>3]+ba*+p[t+(X<<3)>>3];p[$>>3]=Z;d=d+4|0}while((d|0)<=(s|0));z=z+1|0;if((z|0)==(G|0))break f;else t=t+(y<<3)|0}}while(1){ba=+p[Fa+(Ja<<3)>>3];t=0;do{z=Ea+(t<<3)|0;d=t|1;$=Ea+(d<<3)|0;Z=+p[$>>3]+ba*+p[Ia+(d<<3)>>3];p[z>>3]=+p[z>>3]+ba*+p[Ia+(t<<3)>>3];p[$>>3]=Z;$=t|2;z=Ea+($<<3)|0;d=t|3;X=Ea+(d<<3)|0;Z=+p[X>>3]+ba*+p[Ia+(d<<3)>>3];p[z>>3]=+p[z>>3]+ba*+p[Ia+($<<3)>>3];p[X>>3]=Z;t=t+4|0}while((t|0)<=(s|0));Ka=J;do{t=Ea+(Ka<<3)|0;p[t>>3]=+p[t>>3]+ba*+p[Ia+(Ka<<3)>>3];Ka=Ka+1|0}while((Ka|0)!=(j|0));Ja=Ja+1|0;if((Ja|0)==(G|0))break;else Ia=Ia+(y<<3)|0}}while(0);if(!K){if(P){t=0;do{p[R+(t<<3)>>3]=+p[Ea+(t<<3)>>3]*l;t=t+1|0}while((t|0)!=(j|0))}}else if(P){t=0;X=K;while(1){p[R+(t<<3)>>3]=+p[Ea+(t<<3)>>3]*l+ +p[X>>3]*m;t=t+1|0;if((t|0)==(j|0))break;else X=X+(C<<3)|0}}Q=Q+1|0;if((Q|0)==(v|0)){La=Da;break}else{M=M+(E<<3)|0;R=R+(g<<3)|0;K=K+(B<<3)|0}}}else La=Ea;if((La|0)!=(x|0)){ZDc(La);f[r>>2]=x;f[L>>2]=136}}while(0);r=f[q>>2]|0;if((r|0)==(k|0)){u=o;return}if(r|0)ZDc(r);f[q>>2]=k;f[w>>2]=136;u=o;return}function AN(a,b,c,d,e,g,h,i,j,k,l,m,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0,Ra=0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;q=u;u=u+2256|0;r=q+1160|0;s=q;t=f[j>>2]|0;v=f[j+4>>2]|0;j=f[k>>2]|0;w=f[k+4>>2]|0;k=r+8|0;XIc(k|0,0,1088)|0;f[r>>2]=k;x=r+4|0;f[x>>2]=136;y=b>>>3;z=d>>>3;A=g>>>3;g=i>>>3;i=(e|0)==0;B=(o&4|0)==0;C=i?0:B?A:1;D=i?0:B?1:A;if(o&1)if(b>>>0>15&(v|0)>1){f[x>>2]=v;if(v>>>0>136){A=XDc(v>>>0>536870911?-1:v<<3)|0;XIc(A|0,0,v<<3|0)|0;f[r>>2]=A;E=y;F=1;G=A;H=v;I=33}else{E=y;F=1;G=k;H=v;I=33}}else{J=y;K=1;L=v;I=5}else{J=1;K=y;L=t;I=5}if((I|0)==5)if((L|0)==1){t=s+8|0;XIc(t|0,0,1088)|0;f[s>>2]=t;A=s+4|0;f[A>>2]=136;if(b>>>0>15&(v|0)>1){f[x>>2]=w;if(w>>>0>136){v=XDc(w>>>0>536870911?-1:w<<3)|0;XIc(v|0,0,w<<3|0)|0;f[r>>2]=v;M=v}else M=k;if((w|0)>0){v=0;do{b=a+((Y(v,y)|0)<<3)|0;B=f[b+4>>2]|0;i=M+(v<<3)|0;f[i>>2]=f[b>>2];f[i+4>>2]=B;v=v+1|0}while((v|0)!=(w|0));N=M}else N=M}else N=a;if(d>>>0>15){f[A>>2]=j;if(j>>>0>136){d=XDc(j>>>0>536870911?-1:j<<3)|0;XIc(d|0,0,j<<3|0)|0;f[s>>2]=d;O=d}else O=t;if((j|0)>0){d=0;do{M=c+((Y(d,z)|0)<<3)|0;v=f[M+4>>2]|0;y=O+(d<<3)|0;f[y>>2]=f[M>>2];f[y+4>>2]=v;d=d+1|0}while((d|0)<(j|0));P=O}else P=O}else P=c;if((w|0)>0){O=D<<1;d=(j|0)<2;v=j+-2|0;y=v>>>1;M=(y<<1)+2|0;B=e;i=0;b=h;Q=e+(Y(D,(y<<4)+16|0)|0)|0;while(1){R=+n[N+(i<<3)>>2]*l;S=+n[N+(i<<3)+4>>2]*l;if(d){T=B;U=0}else{y=B;V=0;while(1){W=+n[P+(V<<3)>>2];X=+n[P+(V<<3)+4>>2];Z=R*W-S*X;_=S*W+R*X;$=V|1;X=+n[P+($<<3)>>2];W=+n[P+($<<3)+4>>2];aa=R*X-S*W;ba=S*X+R*W;if(!y){n[b+(V<<3)>>2]=Z;n[b+(V<<3)+4>>2]=_;ca=ba;da=aa}else{W=_+ +n[y+4>>2]*m;n[b+(V<<3)>>2]=Z+ +n[y>>2]*m;n[b+(V<<3)+4>>2]=W;ca=ba+ +n[y+(D<<3)+4>>2]*m;da=aa+ +n[y+(D<<3)>>2]*m}n[b+($<<3)>>2]=da;n[b+($<<3)+4>>2]=ca;V=V+2|0;if((V|0)>(v|0)){T=Q;U=M;break}else y=y+(O<<3)|0}}if((U|0)<(j|0)){y=T;V=U;while(1){aa=+n[P+(V<<3)>>2];ba=+n[P+(V<<3)+4>>2];W=R*aa-S*ba;Z=S*aa+R*ba;if(!y){ea=W;fa=Z}else{ea=W+ +n[y>>2]*m;fa=Z+ +n[y+4>>2]*m}n[b+(V<<3)>>2]=ea;n[b+(V<<3)+4>>2]=fa;V=V+1|0;if((V|0)==(j|0))break;else y=y+(D<<3)|0}}i=i+1|0;if((i|0)==(w|0))break;else{B=B+(C<<3)|0;b=b+(g<<3)|0;Q=Q+(C<<3)|0}}}Q=f[s>>2]|0;if((Q|0)!=(t|0)){if(Q|0)ZDc(Q);f[s>>2]=t;f[A>>2]=136}}else{E=J;F=K;G=0;H=L;I=33}a:do if((I|0)==33){if(o&2|0){if((w|0)<=0)break;L=(G|0)==0;K=H+-4|0;J=(H|0)<4;A=H&-4;t=L|(H|0)<1;Q=(j|0)>0;b=a;B=e;i=0;P=h;while(1){if(t)ga=L?b:G;else{U=0;do{T=b+((Y(U,E)|0)<<3)|0;O=f[T+4>>2]|0;M=G+(U<<3)|0;f[M>>2]=f[T>>2];f[M+4>>2]=O;U=U+1|0}while((U|0)!=(H|0));ga=G}if(Q){U=c;O=B;M=0;while(1){if(J){ha=0;ia=0.0;ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0;oa=0.0;pa=0.0}else{T=0;fa=0.0;ea=0.0;ca=0.0;da=0.0;R=0.0;S=0.0;Z=0.0;W=0.0;while(1){ba=+n[ga+(T<<3)>>2];aa=+n[ga+(T<<3)+4>>2];_=+n[U+(T<<3)>>2];X=+n[U+(T<<3)+4>>2];qa=da+(ba*_-aa*X);ra=R+(aa*_+ba*X);v=T|1;X=+n[ga+(v<<3)>>2];ba=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];aa=+n[U+(v<<3)+4>>2];sa=ca+(X*_-ba*aa);ta=W+(ba*_+X*aa);v=T|2;aa=+n[ga+(v<<3)>>2];X=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];ba=+n[U+(v<<3)+4>>2];ua=ea+(aa*_-X*ba);va=Z+(X*_+aa*ba);v=T|3;ba=+n[ga+(v<<3)>>2];aa=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];X=+n[U+(v<<3)+4>>2];wa=fa+(ba*_-aa*X);xa=S+(aa*_+ba*X);T=T+4|0;if((T|0)>(K|0)){ha=A;ia=wa;ja=ua;ka=sa;la=qa;ma=ra;na=xa;oa=va;pa=ta;break}else{fa=wa;ea=ua;ca=sa;da=qa;R=ra;S=xa;Z=va;W=ta}}}if((ha|0)<(H|0)){T=ha;W=la;Z=ma;while(1){S=+n[ga+(T<<3)>>2];R=+n[ga+(T<<3)+4>>2];da=+n[U+(T<<3)>>2];ca=+n[U+(T<<3)+4>>2];ea=W+(S*da-R*ca);fa=Z+(R*da+S*ca);T=T+1|0;if((T|0)==(H|0)){ya=ea;za=fa;break}else{W=ea;Z=fa}}}else{ya=la;za=ma}Z=(ia+(ja+(ka+ya)))*l;W=(na+(oa+(pa+za)))*l;if(!O){Aa=W;Ba=Z}else{Aa=W+ +n[O+4>>2]*m;Ba=Z+ +n[O>>2]*m}n[P+(M<<3)>>2]=Ba;n[P+(M<<3)+4>>2]=Aa;M=M+1|0;if((M|0)==(j|0))break;else{U=U+(z<<3)|0;O=O+(D<<3)|0}}}i=i+1|0;if((i|0)==(w|0))break a;else{b=b+(F<<3)|0;B=B+(C<<3)|0;P=P+(g<<3)|0}}}if(j<<3>>>0<1601){if((w|0)<=0)break;P=(G|0)==0;B=j+-4|0;b=(j|0)<4;i=(H|0)>0;A=D<<2;K=D<<1;J=D*3|0;Q=B>>>2;L=(Q<<2)+4|0;t=P|(H|0)<1;Z=l*0.0;O=a;U=e;M=0;T=h;v=e+(Y((Q<<5)+32|0,D)|0)|0;while(1){if(t)Ca=P?O:G;else{Q=0;do{d=O+((Y(Q,E)|0)<<3)|0;N=f[d+4>>2]|0;y=G+(Q<<3)|0;f[y>>2]=f[d>>2];f[y+4>>2]=N;Q=Q+1|0}while((Q|0)!=(H|0));Ca=G}if(b){Da=U;Ea=0}else{Q=U;N=0;while(1){if(i){y=c+(N<<3)|0;d=0;W=0.0;fa=0.0;ea=0.0;ca=0.0;S=0.0;da=0.0;R=0.0;ta=0.0;while(1){va=+n[Ca+(d<<3)>>2];xa=+n[Ca+(d<<3)+4>>2];ra=+n[y>>2];qa=+n[y+4>>2];sa=ca+(va*ra-xa*qa);ua=ta+(xa*ra+va*qa);qa=+n[y+8>>2];ra=+n[y+12>>2];wa=ea+(va*qa-xa*ra);X=R+(xa*qa+va*ra);ra=+n[y+16>>2];qa=+n[y+20>>2];ba=fa+(va*ra-xa*qa);_=da+(xa*ra+va*qa);qa=+n[y+24>>2];ra=+n[y+28>>2];aa=W+(va*qa-xa*ra);Fa=S+(xa*qa+va*ra);d=d+1|0;if((d|0)==(H|0)){Ga=aa;Ha=ba;Ia=wa;Ja=sa;Ka=Fa;La=_;Ma=X;Na=ua;break}else{y=y+(z<<3)|0;W=aa;fa=ba;ea=wa;ca=sa;S=Fa;da=_;R=X;ta=ua}}}else{Ga=0.0;Ha=0.0;Ia=0.0;Ja=0.0;Ka=0.0;La=0.0;Ma=0.0;Na=0.0}ta=Ja*l;R=Na*l;if(!Q){n[T+(N<<3)>>2]=ta;n[T+(N<<3)+4>>2]=R;y=N|1;n[T+(y<<3)>>2]=Ia*l;n[T+(y<<3)+4>>2]=Ma*l;y=N|2;n[T+(y<<3)>>2]=Ha*l;n[T+(y<<3)+4>>2]=La*l;Oa=Ka*l;Pa=Ga*l}else{da=R+ +n[Q+4>>2]*m;n[T+(N<<3)>>2]=ta+ +n[Q>>2]*m;n[T+(N<<3)+4>>2]=da;da=Ma*l+ +n[Q+(D<<3)+4>>2]*m;y=N|1;n[T+(y<<3)>>2]=Ia*l+ +n[Q+(D<<3)>>2]*m;n[T+(y<<3)+4>>2]=da;da=La*l+ +n[Q+(K<<3)+4>>2]*m;y=N|2;n[T+(y<<3)>>2]=Ha*l+ +n[Q+(K<<3)>>2]*m;n[T+(y<<3)+4>>2]=da;Oa=Ka*l+ +n[Q+(J<<3)+4>>2]*m;Pa=Ga*l+ +n[Q+(J<<3)>>2]*m}y=N|3;n[T+(y<<3)>>2]=Pa;n[T+(y<<3)+4>>2]=Oa;N=N+4|0;if((N|0)>(B|0)){Da=v;Ea=L;break}else Q=Q+(A<<3)|0}}b:do if((Ea|0)<(j|0)){if(i){Qa=Da;Ra=Ea}else{Q=Da;N=Ea;while(1){if(!Q){Sa=Z;Ta=Z}else{Sa=Z+ +n[Q+4>>2]*m;Ta=Z+ +n[Q>>2]*m}n[T+(N<<3)>>2]=Ta;n[T+(N<<3)+4>>2]=Sa;N=N+1|0;if((N|0)==(j|0))break b;else Q=Q+(D<<3)|0}}while(1){Q=c+(Ra<<3)|0;N=0;da=0.0;ta=0.0;while(1){R=+n[Ca+(N<<3)>>2];S=+n[Ca+(N<<3)+4>>2];ca=+n[Q>>2];ea=+n[Q+4>>2];da=da+(R*ca-S*ea);ta=ta+(S*ca+R*ea);N=N+1|0;if((N|0)==(H|0))break;else Q=Q+(z<<3)|0}ea=da*l;R=ta*l;if(!Qa){Ua=R;Va=ea}else{Ua=R+ +n[Qa+4>>2]*m;Va=ea+ +n[Qa>>2]*m}n[T+(Ra<<3)>>2]=Va;n[T+(Ra<<3)+4>>2]=Ua;Ra=Ra+1|0;if((Ra|0)==(j|0))break;else Qa=Qa+(D<<3)|0}}while(0);M=M+1|0;if((M|0)==(w|0))break a;else{O=O+(F<<3)|0;U=U+(C<<3)|0;T=T+(g<<3)|0;v=v+(C<<3)|0}}}v=s+8|0;XIc(v|0,0,1152)|0;f[s>>2]=v;T=s+4|0;f[T>>2]=j;if(j>>>0>72){U=XDc(j>>>0>268435455?-1:j<<4)|0;XIc(U|0,0,j<<4|0)|0;f[s>>2]=U;Wa=U}else Wa=v;if((w|0)>0){U=(G|0)==0;O=(j|0)>0;M=(H|0)>0;i=j+-4|0;A=(j|0)<4;L=j<<4;B=j&-4;J=U|(H|0)<1;K=a;b=e;P=0;t=h;while(1){if(J)Xa=U?K:G;else{Q=0;do{N=K+((Y(Q,E)|0)<<3)|0;y=f[N+4>>2]|0;d=G+(Q<<3)|0;f[d>>2]=f[N>>2];f[d+4>>2]=y;Q=Q+1|0}while((Q|0)!=(H|0));Xa=G}if(O)XIc(Wa|0,0,L|0)|0;if(M){Q=c;y=0;while(1){Z=+n[Xa+(y<<3)>>2];ea=+n[Xa+(y<<3)+4>>2];if(A)Ya=0;else{d=0;do{R=+n[Q+(d<<3)>>2];ca=+n[Q+(d<<3)+4>>2];N=Wa+(d<<4)|0;V=Wa+(d<<4)+8|0;S=+p[V>>3]+(ea*R+Z*ca);$=d|1;fa=+n[Q+($<<3)>>2];W=+n[Q+($<<3)+4>>2];Za=Wa+($<<4)|0;_a=Wa+($<<4)+8|0;ua=+p[Za>>3]+(Z*fa-ea*W);X=+p[_a>>3]+(ea*fa+Z*W);p[N>>3]=+p[N>>3]+(Z*R-ea*ca);p[V>>3]=S;p[Za>>3]=ua;p[_a>>3]=X;_a=d|2;X=+n[Q+(_a<<3)>>2];ua=+n[Q+(_a<<3)+4>>2];Za=Wa+(_a<<4)|0;V=Wa+(_a<<4)+8|0;S=+p[V>>3]+(ea*X+Z*ua);_a=d|3;ca=+n[Q+(_a<<3)>>2];R=+n[Q+(_a<<3)+4>>2];N=Wa+(_a<<4)|0;$=Wa+(_a<<4)+8|0;W=+p[N>>3]+(Z*ca-ea*R);fa=+p[$>>3]+(ea*ca+Z*R);p[Za>>3]=+p[Za>>3]+(Z*X-ea*ua);p[V>>3]=S;p[N>>3]=W;p[$>>3]=fa;d=d+4|0}while((d|0)<=(i|0));Ya=B}if((Ya|0)<(j|0)){d=Ya;do{fa=+n[Q+(d<<3)>>2];W=+n[Q+(d<<3)+4>>2];$=Wa+(d<<4)|0;p[$>>3]=+p[$>>3]+(Z*fa-ea*W);$=Wa+(d<<4)+8|0;p[$>>3]=+p[$>>3]+(ea*fa+Z*W);d=d+1|0}while((d|0)!=(j|0))}y=y+1|0;if((y|0)==(H|0))break;else Q=Q+(z<<3)|0}}if(!b){if(O){Q=0;do{Z=+p[Wa+(Q<<4)+8>>3]*l;n[t+(Q<<3)>>2]=+p[Wa+(Q<<4)>>3]*l;n[t+(Q<<3)+4>>2]=Z;Q=Q+1|0}while((Q|0)!=(j|0))}}else if(O){Q=0;y=b;while(1){Z=+p[Wa+(Q<<4)+8>>3]*l+ +n[y+4>>2]*m;n[t+(Q<<3)>>2]=+p[Wa+(Q<<4)>>3]*l+ +n[y>>2]*m;n[t+(Q<<3)+4>>2]=Z;Q=Q+1|0;if((Q|0)==(j|0))break;else y=y+(D<<3)|0}}P=P+1|0;if((P|0)==(w|0))break;else{K=K+(F<<3)|0;b=b+(C<<3)|0;t=t+(g<<3)|0}}$a=f[s>>2]|0}else $a=Wa;if(($a|0)!=(v|0)){if($a|0)ZDc($a);f[s>>2]=v;f[T>>2]=72}}while(0);s=f[r>>2]|0;if((s|0)==(k|0)){u=q;return}if(s|0)ZDc(s);f[r>>2]=k;f[x>>2]=136;u=q;return}function BN(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;o=u;u=u+2320|0;q=o+1160|0;r=o;s=f[j>>2]|0;t=f[j+4>>2]|0;j=f[k>>2]|0;v=f[k+4>>2]|0;k=q+8|0;XIc(k|0,0,1152)|0;f[q>>2]=k;w=q+4|0;f[w>>2]=72;x=b>>>4;y=d>>>4;z=g>>>4;g=i>>>4;i=(e|0)==0;A=(n&4|0)==0;B=i?0:A?z:1;C=i?0:A?1:z;if(n&1)if(b>>>0>31&(t|0)>1){f[w>>2]=t;if(t>>>0>72){z=XDc(t>>>0>268435455?-1:t<<4)|0;XIc(z|0,0,t<<4|0)|0;f[q>>2]=z;D=x;E=1;F=z;G=t;H=40}else{D=x;E=1;F=k;G=t;H=40}}else{I=x;J=1;K=t;H=5}else{I=1;J=x;K=s;H=5}if((H|0)==5)if((K|0)==1){s=r+8|0;XIc(s|0,0,1152)|0;f[r>>2]=s;z=r+4|0;f[z>>2]=72;if(b>>>0>31&(t|0)>1){f[w>>2]=v;if(v>>>0>72){t=XDc(v>>>0>268435455?-1:v<<4)|0;XIc(t|0,0,v<<4|0)|0;f[q>>2]=t;L=t}else L=k;if((v|0)>0){t=0;do{b=a+((Y(t,x)|0)<<4)|0;A=L+(t<<4)|0;f[A>>2]=f[b>>2];f[A+4>>2]=f[b+4>>2];f[A+8>>2]=f[b+8>>2];f[A+12>>2]=f[b+12>>2];t=t+1|0}while((t|0)!=(v|0));M=L}else M=L}else M=a;if(d>>>0>31){f[z>>2]=j;if(j>>>0>72){d=XDc(j>>>0>268435455?-1:j<<4)|0;XIc(d|0,0,j<<4|0)|0;f[r>>2]=d;N=d}else N=s;if((j|0)>0){d=0;do{L=c+((Y(d,y)|0)<<4)|0;t=N+(d<<4)|0;f[t>>2]=f[L>>2];f[t+4>>2]=f[L+4>>2];f[t+8>>2]=f[L+8>>2];f[t+12>>2]=f[L+12>>2];d=d+1|0}while((d|0)<(j|0));O=N}else O=N}else O=c;a:do if((v|0)>0){N=C<<1;d=j+-2|0;if((j|0)<2){L=(j|0)==1;t=e;x=0;b=h;while(1){P=+p[M+(x<<4)>>3]*l;Q=+p[M+(x<<4)+8>>3]*l;if(L){A=t;i=0;while(1){R=+p[O+(i<<4)>>3];S=+p[O+(i<<4)+8>>3];T=P*R-Q*S;U=Q*R+P*S;if(!A){V=U;W=T}else{V=U+ +p[A+8>>3]*m;W=T+ +p[A>>3]*m}p[b+(i<<4)>>3]=W;p[b+(i<<4)+8>>3]=V;i=i+1|0;if((i|0)==(j|0))break;else A=A+(C<<4)|0}}x=x+1|0;if((x|0)==(v|0))break a;else{t=t+(B<<4)|0;b=b+(g<<4)|0}}}b=d>>>1;t=(b<<1)+2|0;x=(t|0)<(j|0);L=e;A=0;i=h;X=e+(Y(C,(b<<5)+32|0)|0)|0;while(1){P=+p[M+(A<<4)>>3]*l;Q=+p[M+(A<<4)+8>>3]*l;b=L;Z=0;while(1){T=+p[O+(Z<<4)>>3];U=+p[O+(Z<<4)+8>>3];S=P*T-Q*U;R=Q*T+P*U;_=Z|1;U=+p[O+(_<<4)>>3];T=+p[O+(_<<4)+8>>3];$=P*U-Q*T;aa=Q*U+P*T;if(!b){p[i+(Z<<4)>>3]=S;p[i+(Z<<4)+8>>3]=R;ba=aa;ca=$}else{T=R+ +p[b+8>>3]*m;p[i+(Z<<4)>>3]=S+ +p[b>>3]*m;p[i+(Z<<4)+8>>3]=T;ba=aa+ +p[b+(C<<4)+8>>3]*m;ca=$+ +p[b+(C<<4)>>3]*m}p[i+(_<<4)>>3]=ca;p[i+(_<<4)+8>>3]=ba;Z=Z+2|0;if((Z|0)>(d|0))break;else b=b+(N<<4)|0}if(x){b=X;Z=t;while(1){$=+p[O+(Z<<4)>>3];aa=+p[O+(Z<<4)+8>>3];T=P*$-Q*aa;S=Q*$+P*aa;if(!b){da=S;ea=T}else{da=S+ +p[b+8>>3]*m;ea=T+ +p[b>>3]*m}p[i+(Z<<4)>>3]=ea;p[i+(Z<<4)+8>>3]=da;Z=Z+1|0;if((Z|0)==(j|0))break;else b=b+(C<<4)|0}}A=A+1|0;if((A|0)==(v|0))break;else{L=L+(B<<4)|0;i=i+(g<<4)|0;X=X+(B<<4)|0}}}while(0);O=f[r>>2]|0;if((O|0)!=(s|0)){if(O|0)ZDc(O);f[r>>2]=s;f[z>>2]=72}}else{D=I;E=J;F=0;G=K;H=40}b:do if((H|0)==40){if(n&2|0){if((v|0)<=0)break;K=(F|0)==0;J=G+-4|0;I=(G|0)<4;z=G&-4;s=K|(G|0)<1;O=(j|0)>0;M=a;X=e;i=0;L=h;while(1){if(s)fa=K?M:F;else{A=0;do{t=M+((Y(A,D)|0)<<4)|0;x=F+(A<<4)|0;f[x>>2]=f[t>>2];f[x+4>>2]=f[t+4>>2];f[x+8>>2]=f[t+8>>2];f[x+12>>2]=f[t+12>>2];A=A+1|0}while((A|0)!=(G|0));fa=F}if(O){A=c;t=X;x=0;while(1){if(I){ga=0;ha=0.0;ia=0.0;ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0;oa=0.0}else{N=0;da=0.0;ea=0.0;ba=0.0;ca=0.0;V=0.0;W=0.0;P=0.0;Q=0.0;while(1){T=+p[fa+(N<<4)>>3];S=+p[fa+(N<<4)+8>>3];aa=+p[A+(N<<4)>>3];$=+p[A+(N<<4)+8>>3];R=ca+(T*aa-S*$);U=V+(S*aa+T*$);d=N|1;$=+p[fa+(d<<4)>>3];T=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];S=+p[A+(d<<4)+8>>3];pa=ba+($*aa-T*S);qa=Q+(T*aa+$*S);d=N|2;S=+p[fa+(d<<4)>>3];$=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];T=+p[A+(d<<4)+8>>3];ra=ea+(S*aa-$*T);sa=P+($*aa+S*T);d=N|3;T=+p[fa+(d<<4)>>3];S=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];$=+p[A+(d<<4)+8>>3];ta=da+(T*aa-S*$);ua=W+(S*aa+T*$);N=N+4|0;if((N|0)>(J|0)){ga=z;ha=ta;ia=ra;ja=pa;ka=R;la=U;ma=ua;na=sa;oa=qa;break}else{da=ta;ea=ra;ba=pa;ca=R;V=U;W=ua;P=sa;Q=qa}}}if((ga|0)<(G|0)){N=ga;Q=ka;P=la;while(1){W=+p[fa+(N<<4)>>3];V=+p[fa+(N<<4)+8>>3];ca=+p[A+(N<<4)>>3];ba=+p[A+(N<<4)+8>>3];ea=Q+(W*ca-V*ba);da=P+(V*ca+W*ba);N=N+1|0;if((N|0)==(G|0)){va=ea;wa=da;break}else{Q=ea;P=da}}}else{va=ka;wa=la}P=(ha+(ia+(ja+va)))*l;Q=(ma+(na+(oa+wa)))*l;if(!t){xa=Q;ya=P}else{xa=Q+ +p[t+8>>3]*m;ya=P+ +p[t>>3]*m}p[L+(x<<4)>>3]=ya;p[L+(x<<4)+8>>3]=xa;x=x+1|0;if((x|0)==(j|0))break;else{A=A+(y<<4)|0;t=t+(C<<4)|0}}}i=i+1|0;if((i|0)==(v|0))break b;else{M=M+(E<<4)|0;X=X+(B<<4)|0;L=L+(g<<4)|0}}}L=j<<4;if(L>>>0<1601){if((v|0)<=0)break;X=(F|0)==0;M=j+-4|0;i=(j|0)<4;z=(G|0)>0;J=C<<2;I=C<<1;O=C*3|0;K=M>>>2;s=(K<<2)+4|0;t=X|(G|0)<1;P=l*0.0;A=a;x=e;N=0;d=h;b=e+(Y((K<<6)+64|0,C)|0)|0;while(1){if(t)za=X?A:F;else{K=0;do{Z=A+((Y(K,D)|0)<<4)|0;_=F+(K<<4)|0;f[_>>2]=f[Z>>2];f[_+4>>2]=f[Z+4>>2];f[_+8>>2]=f[Z+8>>2];f[_+12>>2]=f[Z+12>>2];K=K+1|0}while((K|0)!=(G|0));za=F}if(i){Aa=x;Ba=0}else{K=x;Z=0;while(1){if(z){_=c+(Z<<4)|0;Ca=0;Q=0.0;da=0.0;ea=0.0;ba=0.0;W=0.0;ca=0.0;V=0.0;qa=0.0;while(1){sa=+p[za+(Ca<<4)>>3];ua=+p[za+(Ca<<4)+8>>3];U=+p[_>>3];R=+p[_+8>>3];pa=da+(sa*U-ua*R);ra=V+(ua*U+sa*R);R=+p[_+16>>3];U=+p[_+24>>3];ta=Q+(sa*R-ua*U);$=ca+(ua*R+sa*U);U=+p[_+32>>3];R=+p[_+40>>3];T=ba+(sa*U-ua*R);aa=W+(ua*U+sa*R);R=+p[_+48>>3];U=+p[_+56>>3];S=ea+(sa*R-ua*U);Da=qa+(ua*R+sa*U);Ca=Ca+1|0;if((Ca|0)==(G|0)){Ea=ta;Fa=pa;Ga=S;Ha=T;Ia=aa;Ja=$;Ka=ra;La=Da;break}else{_=_+(y<<4)|0;Q=ta;da=pa;ea=S;ba=T;W=aa;ca=$;V=ra;qa=Da}}}else{Ea=0.0;Fa=0.0;Ga=0.0;Ha=0.0;Ia=0.0;Ja=0.0;Ka=0.0;La=0.0}qa=Fa*l;V=Ka*l;if(!K){p[d+(Z<<4)>>3]=qa;p[d+(Z<<4)+8>>3]=V;_=Z|1;p[d+(_<<4)>>3]=Ea*l;p[d+(_<<4)+8>>3]=Ja*l;_=Z|2;p[d+(_<<4)>>3]=Ha*l;p[d+(_<<4)+8>>3]=Ia*l;Ma=La*l;Na=Ga*l}else{ca=V+ +p[K+8>>3]*m;p[d+(Z<<4)>>3]=qa+ +p[K>>3]*m;p[d+(Z<<4)+8>>3]=ca;ca=Ja*l+ +p[K+(C<<4)+8>>3]*m;_=Z|1;p[d+(_<<4)>>3]=Ea*l+ +p[K+(C<<4)>>3]*m;p[d+(_<<4)+8>>3]=ca;ca=Ia*l+ +p[K+(I<<4)+8>>3]*m;_=Z|2;p[d+(_<<4)>>3]=Ha*l+ +p[K+(I<<4)>>3]*m;p[d+(_<<4)+8>>3]=ca;Ma=La*l+ +p[K+(O<<4)+8>>3]*m;Na=Ga*l+ +p[K+(O<<4)>>3]*m}_=Z|3;p[d+(_<<4)>>3]=Na;p[d+(_<<4)+8>>3]=Ma;Z=Z+4|0;if((Z|0)>(M|0)){Aa=b;Ba=s;break}else K=K+(J<<4)|0}}c:do if((Ba|0)<(j|0)){if(z){Oa=Aa;Pa=Ba}else{K=Aa;Z=Ba;while(1){if(!K){Qa=P;Ra=P}else{Qa=P+ +p[K+8>>3]*m;Ra=P+ +p[K>>3]*m}p[d+(Z<<4)>>3]=Ra;p[d+(Z<<4)+8>>3]=Qa;Z=Z+1|0;if((Z|0)==(j|0))break c;else K=K+(C<<4)|0}}while(1){K=c+(Pa<<4)|0;Z=0;ca=0.0;qa=0.0;while(1){V=+p[za+(Z<<4)>>3];W=+p[za+(Z<<4)+8>>3];ba=+p[K>>3];ea=+p[K+8>>3];ca=ca+(V*ba-W*ea);qa=qa+(W*ba+V*ea);Z=Z+1|0;if((Z|0)==(G|0))break;else K=K+(y<<4)|0}ea=ca*l;V=qa*l;if(!Oa){Sa=V;Ta=ea}else{Sa=V+ +p[Oa+8>>3]*m;Ta=ea+ +p[Oa>>3]*m}p[d+(Pa<<4)>>3]=Ta;p[d+(Pa<<4)+8>>3]=Sa;Pa=Pa+1|0;if((Pa|0)==(j|0))break;else Oa=Oa+(C<<4)|0}}while(0);N=N+1|0;if((N|0)==(v|0))break b;else{A=A+(E<<4)|0;x=x+(B<<4)|0;d=d+(g<<4)|0;b=b+(B<<4)|0}}}b=r+8|0;XIc(b|0,0,1152)|0;f[r>>2]=b;d=r+4|0;f[d>>2]=j;if(j>>>0>72){x=XDc(j>>>0>268435455?-1:j<<4)|0;XIc(x|0,0,L|0)|0;f[r>>2]=x;Ua=x}else Ua=b;if((v|0)>0){x=(F|0)==0;A=(j|0)>0;N=(G|0)>0;z=j+-4|0;J=(j|0)<4;s=j&-4;M=x|(G|0)<1;O=a;I=e;i=0;X=h;while(1){if(M)Va=x?O:F;else{t=0;do{K=O+((Y(t,D)|0)<<4)|0;Z=F+(t<<4)|0;f[Z>>2]=f[K>>2];f[Z+4>>2]=f[K+4>>2];f[Z+8>>2]=f[K+8>>2];f[Z+12>>2]=f[K+12>>2];t=t+1|0}while((t|0)!=(G|0));Va=F}if(A)XIc(Ua|0,0,L|0)|0;if(N){t=c;K=0;while(1){P=+p[Va+(K<<4)>>3];ea=+p[Va+(K<<4)+8>>3];if(J)Wa=0;else{Z=0;do{V=+p[t+(Z<<4)>>3];ba=+p[t+(Z<<4)+8>>3];_=Ua+(Z<<4)|0;Ca=Ua+(Z<<4)+8|0;W=+p[Ca>>3]+(ea*V+P*ba);Xa=Z|1;da=+p[t+(Xa<<4)>>3];Q=+p[t+(Xa<<4)+8>>3];Ya=Ua+(Xa<<4)|0;Za=Ua+(Xa<<4)+8|0;Da=+p[Ya>>3]+(P*da-ea*Q);ra=+p[Za>>3]+(ea*da+P*Q);p[_>>3]=+p[_>>3]+(P*V-ea*ba);p[Ca>>3]=W;p[Ya>>3]=Da;p[Za>>3]=ra;Za=Z|2;ra=+p[t+(Za<<4)>>3];Da=+p[t+(Za<<4)+8>>3];Ya=Ua+(Za<<4)|0;Ca=Ua+(Za<<4)+8|0;W=+p[Ca>>3]+(ea*ra+P*Da);Za=Z|3;ba=+p[t+(Za<<4)>>3];V=+p[t+(Za<<4)+8>>3];_=Ua+(Za<<4)|0;Xa=Ua+(Za<<4)+8|0;Q=+p[_>>3]+(P*ba-ea*V);da=+p[Xa>>3]+(ea*ba+P*V);p[Ya>>3]=+p[Ya>>3]+(P*ra-ea*Da);p[Ca>>3]=W;p[_>>3]=Q;p[Xa>>3]=da;Z=Z+4|0}while((Z|0)<=(z|0));Wa=s}if((Wa|0)<(j|0)){Z=Wa;do{da=+p[t+(Z<<4)>>3];Q=+p[t+(Z<<4)+8>>3];Xa=Ua+(Z<<4)|0;p[Xa>>3]=+p[Xa>>3]+(P*da-ea*Q);Xa=Ua+(Z<<4)+8|0;p[Xa>>3]=ea*da+P*Q+ +p[Xa>>3];Z=Z+1|0}while((Z|0)!=(j|0))}K=K+1|0;if((K|0)==(G|0))break;else t=t+(y<<4)|0}}if(!I){if(A){t=0;do{P=+p[Ua+(t<<4)+8>>3]*l;p[X+(t<<4)>>3]=+p[Ua+(t<<4)>>3]*l;p[X+(t<<4)+8>>3]=P;t=t+1|0}while((t|0)!=(j|0))}}else if(A){t=0;K=I;while(1){P=+p[Ua+(t<<4)+8>>3]*l+ +p[K+8>>3]*m;p[X+(t<<4)>>3]=+p[Ua+(t<<4)>>3]*l+ +p[K>>3]*m;p[X+(t<<4)+8>>3]=P;t=t+1|0;if((t|0)==(j|0))break;else K=K+(C<<4)|0}}i=i+1|0;if((i|0)==(v|0))break;else{O=O+(E<<4)|0;I=I+(B<<4)|0;X=X+(g<<4)|0}}_a=f[r>>2]|0}else _a=Ua;if((_a|0)!=(b|0)){if(_a|0)ZDc(_a);f[r>>2]=b;f[d>>2]=72}}while(0);r=f[q>>2]|0;if((r|0)==(k|0)){u=o;return}if(r|0)ZDc(r);f[q>>2]=k;f[w>>2]=72;u=o;return}function CN(a,b,c,d,e,g,h,i,j,k,l,m,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;q=u;u=u+2160|0;r=q+1096|0;s=q;t=f[j>>2]|0;v=f[j+4>>2]|0;j=f[k>>2]|0;w=f[k+4>>2]|0;k=r+8|0;f[r>>2]=k;x=r+4|0;f[x>>2]=264;y=b>>>2;z=d>>>2;A=g>>>2;g=i>>>2;i=(e|0)==0;B=(o&4|0)==0;C=i?0:B?A:1;D=i?0:B?1:A;if(o&1)if(b>>>0>7&(v|0)>1){f[x>>2]=v;if(v>>>0>264){A=XDc(v>>>0>1073741823?-1:v<<2)|0;f[r>>2]=A;E=y;F=1;G=A;H=v;I=43}else{E=y;F=1;G=k;H=v;I=43}}else{J=y;K=1;L=v;I=5}else{J=1;K=y;L=t;I=5}if((I|0)==5)if((L|0)==1){t=s+8|0;f[s>>2]=t;A=s+4|0;f[A>>2]=264;if(b>>>0>7&(v|0)>1){f[x>>2]=w;if(w>>>0>264){v=XDc(w>>>0>1073741823?-1:w<<2)|0;f[r>>2]=v;M=v}else M=k;if((w|0)>0){v=0;do{b=a+((Y(v,y)|0)<<2)|0;f[M+(v<<2)>>2]=f[b>>2];v=v+1|0}while((v|0)!=(w|0));N=M}else N=M}else N=a;if(d>>>0>7){f[A>>2]=j;if(j>>>0>264){d=XDc(j>>>0>1073741823?-1:j<<2)|0;f[s>>2]=d;O=d}else O=t;if((j|0)>0){d=0;do{M=c+((Y(d,z)|0)<<2)|0;f[O+(d<<2)>>2]=f[M>>2];d=d+1|0}while((d|0)!=(j|0));P=O;Q=O}else{P=O;Q=O}}else{P=c;Q=t}a:do if((w|0)>0){O=D<<1;if((j|0)<2){if((j|0)==1){R=h;S=0;T=e}else break;while(1){U=+n[N+(S<<2)>>2]*l*+n[P>>2];if(!T)V=U;else V=U+ +n[T>>2]*m;n[R>>2]=V;S=S+1|0;if((S|0)==(w|0))break a;else{R=R+(g<<2)|0;T=T+(C<<2)|0}}}d=j+-2|0;M=((d|0)>1?d:1)>>>1;v=Y(M,O)|0;y=(M<<1)+2|0;if((y|0)>=(j|0)){M=h;b=0;B=e;while(1){U=+n[N+(b<<2)>>2]*l;i=B;W=0;while(1){X=U*+n[P+(W<<2)>>2];Z=W|1;_=U*+n[P+(Z<<2)>>2];if(!i){n[M+(W<<2)>>2]=X;$=_}else{n[M+(W<<2)>>2]=X+ +n[i>>2]*m;$=_+ +n[i+(D<<2)>>2]*m}n[M+(Z<<2)>>2]=$;W=W+2|0;if((W|0)>(d|0))break;else i=i+(O<<2)|0}b=b+1|0;if((b|0)==(w|0))break a;else{M=M+(g<<2)|0;B=B+(C<<2)|0}}}B=h;M=0;b=e;i=e+(O<<2)|0;while(1){U=+n[N+(M<<2)>>2]*l;W=b;Z=0;while(1){_=U*+n[P+(Z<<2)>>2];aa=Z|1;X=U*+n[P+(aa<<2)>>2];if(!W){n[B+(Z<<2)>>2]=_;ba=X}else{n[B+(Z<<2)>>2]=_+ +n[W>>2]*m;ba=X+ +n[W+(D<<2)>>2]*m}n[B+(aa<<2)>>2]=ba;Z=Z+2|0;if((Z|0)>(d|0))break;else W=W+(O<<2)|0}W=i+(v<<2)|0;Z=y;while(1){X=U*+n[P+(Z<<2)>>2];if(!W)ca=X;else ca=X+ +n[W>>2]*m;n[B+(Z<<2)>>2]=ca;Z=Z+1|0;if((Z|0)==(j|0))break;else W=W+(D<<2)|0}M=M+1|0;if((M|0)==(w|0))break;else{B=B+(g<<2)|0;b=b+(C<<2)|0;i=i+(C<<2)|0}}}while(0);if((Q|0)!=(t|0)){ZDc(Q);f[s>>2]=t;f[A>>2]=264}}else{E=J;F=K;G=0;H=L;I=43}b:do if((I|0)==43){if(o&2|0){if((w|0)<=0)break;L=(G|0)==0;K=(j|0)>0;J=H+-4|0;A=(H|0)<4;t=H&-4;Q=L|(H|0)<1;P=(H|0)>0;N=(t|0)<(H|0);ca=l*0.0;T=a;R=h;S=0;i=e;while(1){if(Q)da=L?T:G;else{b=0;do{B=T+((Y(b,E)|0)<<2)|0;f[G+(b<<2)>>2]=f[B>>2];b=b+1|0}while((b|0)!=(H|0));da=G}c:do if(K){if(!A){b=c;B=i;M=0;while(1){ba=0.0;$=0.0;V=0.0;U=0.0;y=0;do{U=U+ +n[da+(y<<2)>>2]*+n[b+(y<<2)>>2];v=y|1;V=V+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];v=y|2;$=$+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];v=y|3;ba=ba+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];y=y+4|0}while((y|0)<=(J|0));if(N){X=U;y=t;while(1){_=X+ +n[da+(y<<2)>>2]*+n[b+(y<<2)>>2];y=y+1|0;if((y|0)==(H|0)){ea=_;break}else X=_}}else ea=U;X=(ba+($+(V+ea)))*l;if(!B)fa=X;else fa=X+ +n[B>>2]*m;n[R+(M<<2)>>2]=fa;M=M+1|0;if((M|0)==(j|0))break c;else{b=b+(z<<2)|0;B=B+(D<<2)|0}}}if(P){ga=c;ha=i;ia=0}else{B=i;b=0;while(1){if(!B)ja=ca;else ja=ca+ +n[B>>2]*m;n[R+(b<<2)>>2]=ja;b=b+1|0;if((b|0)==(j|0))break c;else B=B+(D<<2)|0}}while(1){X=0.0;B=0;do{X=X+ +n[da+(B<<2)>>2]*+n[ga+(B<<2)>>2];B=B+1|0}while((B|0)!=(H|0));V=(X+0.0)*l;if(!ha)ka=V;else ka=V+ +n[ha>>2]*m;n[R+(ia<<2)>>2]=ka;ia=ia+1|0;if((ia|0)==(j|0))break;else{ga=ga+(z<<2)|0;ha=ha+(D<<2)|0}}}while(0);S=S+1|0;if((S|0)==(w|0))break b;else{T=T+(F<<2)|0;R=R+(g<<2)|0;i=i+(C<<2)|0}}}if(j<<2>>>0<1601){if((w|0)<=0)break;i=(G|0)==0;R=j+-4|0;T=(j|0)<4;S=(H|0)>0;P=D<<2;t=D<<1;N=D*3|0;J=R>>>2;A=(J<<2)+4|0;K=i|(H|0)<1;ca=l*0.0;V=ca;L=a;Q=h;B=0;b=e;M=e+(Y((J<<4)+16|0,D)|0)|0;while(1){if(K)la=i?L:G;else{J=0;do{y=L+((Y(J,E)|0)<<2)|0;f[G+(J<<2)>>2]=f[y>>2];J=J+1|0}while((J|0)!=(H|0));la=G}d:do if(T){ma=b;na=0}else{if(S){oa=b;pa=0}else{J=b;y=0;while(1){v=y|2;O=y|1;if(!J){n[Q+(y<<2)>>2]=V;n[Q+(O<<2)>>2]=V;n[Q+(v<<2)>>2]=V;qa=ca}else{n[Q+(y<<2)>>2]=ca+ +n[J>>2]*m;n[Q+(O<<2)>>2]=ca+ +n[J+(D<<2)>>2]*m;n[Q+(v<<2)>>2]=ca+ +n[J+(t<<2)>>2]*m;qa=ca+ +n[J+(N<<2)>>2]*m}n[Q+((y|3)<<2)>>2]=qa;y=y+4|0;if((y|0)>(R|0)){ma=M;na=A;break d}else J=J+(P<<2)|0}}while(1){$=0.0;ba=0.0;U=0.0;_=0.0;J=c+(pa<<2)|0;y=0;while(1){ra=+n[la+(y<<2)>>2];_=_+ra*+n[J>>2];U=U+ra*+n[J+4>>2];ba=ba+ra*+n[J+8>>2];$=$+ra*+n[J+12>>2];y=y+1|0;if((y|0)==(H|0))break;else J=J+(z<<2)|0}X=_*l;J=pa|2;ra=U*l;y=pa|1;sa=ba*l;ta=$*l;if(!oa){n[Q+(pa<<2)>>2]=X;n[Q+(y<<2)>>2]=ra;n[Q+(J<<2)>>2]=sa;ua=ta}else{n[Q+(pa<<2)>>2]=X+ +n[oa>>2]*m;n[Q+(y<<2)>>2]=ra+ +n[oa+(D<<2)>>2]*m;n[Q+(J<<2)>>2]=sa+ +n[oa+(t<<2)>>2]*m;ua=ta+ +n[oa+(N<<2)>>2]*m}n[Q+((pa|3)<<2)>>2]=ua;pa=pa+4|0;if((pa|0)>(R|0)){ma=M;na=A;break}else oa=oa+(P<<2)|0}}while(0);e:do if((na|0)<(j|0)){if(S){va=ma;wa=na}else{J=ma;y=na;while(1){if(!J)xa=ca;else xa=ca+ +n[J>>2]*m;n[Q+(y<<2)>>2]=xa;y=y+1|0;if((y|0)==(j|0))break e;else J=J+(D<<2)|0}}while(1){ta=0.0;J=c+(wa<<2)|0;y=0;while(1){ta=ta+ +n[la+(y<<2)>>2]*+n[J>>2];y=y+1|0;if((y|0)==(H|0))break;else J=J+(z<<2)|0}$=ta*l;if(!va)ya=$;else ya=$+ +n[va>>2]*m;n[Q+(wa<<2)>>2]=ya;wa=wa+1|0;if((wa|0)==(j|0))break;else va=va+(D<<2)|0}}while(0);B=B+1|0;if((B|0)==(w|0))break b;else{L=L+(F<<2)|0;Q=Q+(g<<2)|0;b=b+(C<<2)|0;M=M+(C<<2)|0}}}M=s+8|0;f[s>>2]=M;b=s+4|0;f[b>>2]=j;if(j>>>0>136){Q=XDc(j>>>0>536870911?-1:j<<3)|0;f[s>>2]=Q;za=Q;Aa=Q}else{za=M;Aa=M}if((w|0)>0){Q=(G|0)==0;L=(j|0)>0;B=(H|0)>0;S=j+-4|0;P=(j|0)<4;A=j<<3;R=j&-4;N=Q|(H|0)<1;t=(R|0)<(j|0);T=a;i=h;K=0;J=e;while(1){if(N)Ba=Q?T:G;else{y=0;do{v=T+((Y(y,E)|0)<<2)|0;f[G+(y<<2)>>2]=f[v>>2];y=y+1|0}while((y|0)!=(H|0));Ba=G}if(L)XIc(Aa|0,0,A|0)|0;f:do if(B){if(P){if(L){Ca=c;Da=0}else break;while(1){ca=+n[Ba+(Da<<2)>>2];y=0;do{v=Aa+(y<<3)|0;p[v>>3]=+p[v>>3]+ca*+n[Ca+(y<<2)>>2];y=y+1|0}while((y|0)!=(j|0));Da=Da+1|0;if((Da|0)==(H|0))break f;else Ca=Ca+(z<<2)|0}}if(t){Ea=c;Fa=0}else{y=c;v=0;while(1){ca=+n[Ba+(v<<2)>>2];O=0;do{d=Aa+(O<<3)|0;W=O|1;Z=Aa+(W<<3)|0;ta=+p[Z>>3]+ca*+n[y+(W<<2)>>2];p[d>>3]=+p[d>>3]+ca*+n[y+(O<<2)>>2];p[Z>>3]=ta;Z=O|2;d=Aa+(Z<<3)|0;W=O|3;aa=Aa+(W<<3)|0;ta=+p[aa>>3]+ca*+n[y+(W<<2)>>2];p[d>>3]=+p[d>>3]+ca*+n[y+(Z<<2)>>2];p[aa>>3]=ta;O=O+4|0}while((O|0)<=(S|0));v=v+1|0;if((v|0)==(H|0))break f;else y=y+(z<<2)|0}}while(1){ca=+n[Ba+(Fa<<2)>>2];y=0;do{v=Aa+(y<<3)|0;O=y|1;aa=Aa+(O<<3)|0;ta=+p[aa>>3]+ca*+n[Ea+(O<<2)>>2];p[v>>3]=+p[v>>3]+ca*+n[Ea+(y<<2)>>2];p[aa>>3]=ta;aa=y|2;v=Aa+(aa<<3)|0;O=y|3;Z=Aa+(O<<3)|0;ta=+p[Z>>3]+ca*+n[Ea+(O<<2)>>2];p[v>>3]=+p[v>>3]+ca*+n[Ea+(aa<<2)>>2];p[Z>>3]=ta;y=y+4|0}while((y|0)<=(S|0));Ga=R;do{y=Aa+(Ga<<3)|0;p[y>>3]=+p[y>>3]+ca*+n[Ea+(Ga<<2)>>2];Ga=Ga+1|0}while((Ga|0)!=(j|0));Fa=Fa+1|0;if((Fa|0)==(H|0))break;else Ea=Ea+(z<<2)|0}}while(0);if(!J){if(L){y=0;do{n[i+(y<<2)>>2]=+p[Aa+(y<<3)>>3]*l;y=y+1|0}while((y|0)!=(j|0))}}else if(L){y=0;Z=J;while(1){n[i+(y<<2)>>2]=+p[Aa+(y<<3)>>3]*l+ +n[Z>>2]*m;y=y+1|0;if((y|0)==(j|0))break;else Z=Z+(D<<2)|0}}K=K+1|0;if((K|0)==(w|0)){Ha=za;break}else{T=T+(F<<2)|0;i=i+(g<<2)|0;J=J+(C<<2)|0}}}else Ha=Aa;if((Ha|0)!=(M|0)){ZDc(Ha);f[s>>2]=M;f[b>>2]=136}}while(0);s=f[r>>2]|0;if((s|0)==(k|0)){u=q;return}if(s|0)ZDc(s);f[r>>2]=k;f[x>>2]=264;u=q;return}function DN(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0.0;k=u;u=u+1104|0;l=k;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[i>>2]|0;o=f[i+4>>2]|0;i=l+8|0;f[l>>2]=i;q=l+4|0;f[q>>2]=136;r=j&16;s=b>>>3;b=d>>>3;d=g>>>3;if(j&1){f[q>>2]=n;if(n>>>0>136){g=XDc(n>>>0>536870911?-1:n<<3)|0;f[l>>2]=g;t=s;v=1;w=g;x=n;y=g}else{t=s;v=1;w=i;x=n;y=i}}else{t=1;v=s;w=0;x=m;y=i}m=(o|0)>0;if(!(j&2)){if(m){j=(w|0)==0;s=h+-4|0;n=(h|0)<4;g=(r|0)==0;z=(x|0)>0;A=h&-4;B=(x|0)<1|j;C=(s>>>2<<5)+32|0;D=e;E=0;F=a;while(1){G=e+((Y(d,E)|0)<<3)|0;if(B)H=j?F:w;else{I=0;do{J=F+((Y(I,t)|0)<<3)|0;p[w+(I<<3)>>3]=+p[J>>3];I=I+1|0}while((I|0)!=(x|0));H=w}a:do if(!n)if(g){if(z)K=0;else{XIc(G|0,0,C|0)|0;L=A;break}do{I=c+(K<<3)|0;M=0.0;N=0.0;O=0.0;P=0.0;J=0;while(1){Q=+p[H+(J<<3)>>3];P=P+Q*+p[I>>3];O=O+Q*+p[I+8>>3];N=N+Q*+p[I+16>>3];M=M+Q*+p[I+24>>3];J=J+1|0;if((J|0)==(x|0))break;else I=I+(b<<3)|0}p[D+(K<<3)>>3]=P;p[D+((K|1)<<3)>>3]=O;p[D+((K|2)<<3)>>3]=N;p[D+((K|3)<<3)>>3]=M;K=K+4|0}while((K|0)<=(s|0));L=A}else{if(z)R=0;else{I=0;while(1){I=I+4|0;if((I|0)>(s|0)){L=A;break a}}}do{I=D+((R|3)<<3)|0;J=D+((R|2)<<3)|0;S=D+((R|1)<<3)|0;T=D+(R<<3)|0;U=c+(R<<3)|0;Q=+p[I>>3];V=+p[J>>3];W=+p[S>>3];X=+p[T>>3];Z=0;while(1){_=+p[H+(Z<<3)>>3];X=X+_*+p[U>>3];W=W+_*+p[U+8>>3];V=V+_*+p[U+16>>3];Q=Q+_*+p[U+24>>3];Z=Z+1|0;if((Z|0)==(x|0))break;else U=U+(b<<3)|0}p[T>>3]=X;p[S>>3]=W;p[J>>3]=V;p[I>>3]=Q;R=R+4|0}while((R|0)<=(s|0));L=A}else L=0;while(0);b:do if((h|0)>(L|0)){if(!g){if(z)$=L;else break;while(1){U=D+($<<3)|0;Z=c+($<<3)|0;M=+p[U>>3];aa=0;while(1){M=M+ +p[H+(aa<<3)>>3]*+p[Z>>3];aa=aa+1|0;if((aa|0)==(x|0))break;else Z=Z+(b<<3)|0}p[U>>3]=M;$=$+1|0;if(($|0)==(h|0))break b}}if(z)ba=L;else{XIc(G+(L<<3)|0,0,h-L<<3|0)|0;break}do{Z=c+(ba<<3)|0;Q=0.0;aa=0;while(1){Q=Q+ +p[H+(aa<<3)>>3]*+p[Z>>3];aa=aa+1|0;if((aa|0)==(x|0))break;else Z=Z+(b<<3)|0}p[D+(ba<<3)>>3]=Q;ba=ba+1|0}while((ba|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(o|0))break;else{D=D+(d<<3)|0;F=F+(v<<3)|0}}}}else if(m){m=(w|0)==0;F=(h|0)>0;D=(r|0)==0;r=x+-2|0;E=(x|0)<2;ba=x&-2;H=(x|0)<1|m;L=(x|0)>0;z=(ba|0)<(x|0);$=(x|0)>0;g=(ba|0)<(x|0);A=e;e=0;s=a;while(1){if(H)ca=m?s:w;else{a=0;do{R=s+((Y(a,t)|0)<<3)|0;p[w+(a<<3)>>3]=+p[R>>3];a=a+1|0}while((a|0)!=(x|0));ca=w}c:do if(F)if(D){if(E){a=c;R=0;while(1){if(L){M=0.0;K=0;while(1){V=M+ +p[ca+(K<<3)>>3]*+p[a+(K<<3)>>3];K=K+1|0;if((K|0)==(x|0)){da=V;break}else M=V}}else da=0.0;p[A+(R<<3)>>3]=da+0.0;R=R+1|0;if((R|0)==(h|0))break c;else a=a+(b<<3)|0}}else{ea=c;fa=0}while(1){M=0.0;Q=0.0;a=0;do{Q=Q+ +p[ca+(a<<3)>>3]*+p[ea+(a<<3)>>3];R=a|1;M=M+ +p[ca+(R<<3)>>3]*+p[ea+(R<<3)>>3];a=a+2|0}while((a|0)<=(r|0));if(z){V=Q;a=ba;while(1){W=V+ +p[ca+(a<<3)>>3]*+p[ea+(a<<3)>>3];a=a+1|0;if((a|0)==(x|0)){ga=W;break}else V=W}}else ga=Q;p[A+(fa<<3)>>3]=M+ga;fa=fa+1|0;if((fa|0)==(h|0))break;else ea=ea+(b<<3)|0}}else{if(E){a=c;R=0;while(1){K=A+(R<<3)|0;V=+p[K>>3];if($){W=V;C=0;while(1){X=W+ +p[ca+(C<<3)>>3]*+p[a+(C<<3)>>3];C=C+1|0;if((C|0)==(x|0)){ha=X;break}else W=X}}else ha=V;p[K>>3]=ha+0.0;R=R+1|0;if((R|0)==(h|0))break c;else a=a+(b<<3)|0}}else{ia=c;ja=0}while(1){a=A+(ja<<3)|0;W=0.0;M=+p[a>>3];R=0;do{M=M+ +p[ca+(R<<3)>>3]*+p[ia+(R<<3)>>3];C=R|1;W=W+ +p[ca+(C<<3)>>3]*+p[ia+(C<<3)>>3];R=R+2|0}while((R|0)<=(r|0));if(g){V=M;R=ba;while(1){Q=V+ +p[ca+(R<<3)>>3]*+p[ia+(R<<3)>>3];R=R+1|0;if((R|0)==(x|0)){ka=Q;break}else V=Q}}else ka=M;p[a>>3]=W+ka;ja=ja+1|0;if((ja|0)==(h|0))break;else ia=ia+(b<<3)|0}}while(0);e=e+1|0;if((e|0)==(o|0))break;else{A=A+(d<<3)|0;s=s+(v<<3)|0}}}if((y|0)==(i|0)){u=k;return}ZDc(y);f[l>>2]=i;f[q>>2]=136;u=k;return}function EN(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0,Ia=0.0,Ja=0.0;k=u;u=u+1104|0;l=k;m=f[h>>2]|0;o=f[h+4>>2]|0;h=f[i>>2]|0;q=f[i+4>>2]|0;i=l+8|0;XIc(i|0,0,1088)|0;f[l>>2]=i;r=l+4|0;f[r>>2]=136;s=j&16;t=b>>>3;b=d>>>3;d=g>>>4;if(j&1){f[r>>2]=o;if(o>>>0>136){g=XDc(o>>>0>536870911?-1:o<<3)|0;XIc(g|0,0,o<<3|0)|0;f[l>>2]=g;v=t;w=1;x=g;y=o}else{v=t;w=1;x=i;y=o}}else{v=1;w=t;x=0;y=m}m=(q|0)>0;if(!(j&2)){if(m){j=(x|0)==0;t=h+-4|0;o=(h|0)<4;g=(s|0)==0;z=(y|0)>0;A=h&-4;B=(y|0)<1|j;C=a;D=e;E=0;while(1){F=e+((Y(d,E)|0)<<4)|0;if(B)G=j?C:x;else{H=0;do{I=C+((Y(H,v)|0)<<3)|0;J=f[I+4>>2]|0;K=x+(H<<3)|0;f[K>>2]=f[I>>2];f[K+4>>2]=J;H=H+1|0}while((H|0)!=(y|0));G=x}if(o)L=0;else{H=0;do{if(g){M=0.0;N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0}else{J=H|1;K=H|2;I=H|3;M=+p[D+(K<<4)>>3];N=+p[D+(J<<4)>>3];O=+p[D+(H<<4)>>3];P=+p[D+(I<<4)>>3];Q=+p[D+(I<<4)+8>>3];R=+p[D+(K<<4)+8>>3];S=+p[D+(J<<4)+8>>3];T=+p[D+(H<<4)+8>>3]}if(z){J=c+(H<<3)|0;K=0;U=M;V=N;W=O;X=P;Z=Q;_=R;$=S;aa=T;while(1){ba=+n[G+(K<<3)>>2];ca=+n[G+(K<<3)+4>>2];da=+n[J>>2];ea=+n[J+4>>2];fa=W+(ba*da-ca*ea);ga=aa+(ca*da+ba*ea);ea=+n[J+8>>2];da=+n[J+12>>2];ha=V+(ba*ea-ca*da);ia=$+(ca*ea+ba*da);da=+n[J+16>>2];ea=+n[J+20>>2];ja=U+(ba*da-ca*ea);ka=_+(ca*da+ba*ea);ea=+n[J+24>>2];da=+n[J+28>>2];la=X+(ba*ea-ca*da);ma=Z+(ca*ea+ba*da);K=K+1|0;if((K|0)==(y|0)){na=ja;oa=ha;pa=fa;qa=la;ra=ma;sa=ka;ta=ia;ua=ga;break}else{J=J+(b<<3)|0;U=ja;V=ha;W=fa;X=la;Z=ma;_=ka;$=ia;aa=ga}}}else{na=M;oa=N;pa=O;qa=P;ra=Q;sa=R;ta=S;ua=T}p[D+(H<<4)>>3]=pa;p[D+(H<<4)+8>>3]=ua;J=H|1;p[D+(J<<4)>>3]=oa;p[D+(J<<4)+8>>3]=ta;J=H|2;p[D+(J<<4)>>3]=na;p[D+(J<<4)+8>>3]=sa;J=H|3;p[D+(J<<4)>>3]=qa;p[D+(J<<4)+8>>3]=ra;H=H+4|0}while((H|0)<=(t|0));L=A}a:do if((h|0)>(L|0))if(g){if(z)va=L;else{XIc(F+(L<<4)|0,0,h-L<<4|0)|0;break}do{H=c+(va<<3)|0;J=0;aa=0.0;$=0.0;while(1){_=+n[G+(J<<3)>>2];Z=+n[G+(J<<3)+4>>2];X=+n[H>>2];W=+n[H+4>>2];aa=aa+(_*X-Z*W);$=$+(Z*X+_*W);J=J+1|0;if((J|0)==(y|0))break;else H=H+(b<<3)|0}p[D+(va<<4)>>3]=aa;p[D+(va<<4)+8>>3]=$;va=va+1|0}while((va|0)!=(h|0))}else{if(z)wa=L;else{H=L;while(1){H=H+1|0;if((H|0)==(h|0))break a}}do{H=D+(wa<<4)+8|0;J=D+(wa<<4)|0;K=c+(wa<<3)|0;I=0;W=+p[J>>3];_=+p[H>>3];while(1){X=+n[G+(I<<3)>>2];Z=+n[G+(I<<3)+4>>2];V=+n[K>>2];U=+n[K+4>>2];W=W+(X*V-Z*U);_=_+(Z*V+X*U);I=I+1|0;if((I|0)==(y|0))break;else K=K+(b<<3)|0}p[J>>3]=W;p[H>>3]=_;wa=wa+1|0}while((wa|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(q|0))break;else{C=C+(w<<3)|0;D=D+(d<<4)|0}}}}else if(m){m=(x|0)==0;D=(s|0)==0;s=y+-2|0;C=(y|0)<2;E=y&-2;wa=(y|0)<1|m;G=(h|0)>0;L=(y|0)>0;z=(E|0)<(y|0);va=(y|0)>0;g=(E|0)<(y|0);A=a;a=e;e=0;while(1){if(wa)xa=m?A:x;else{t=0;do{o=A+((Y(t,v)|0)<<3)|0;j=f[o+4>>2]|0;B=x+(t<<3)|0;f[B>>2]=f[o>>2];f[B+4>>2]=j;t=t+1|0}while((t|0)!=(y|0));xa=x}b:do if(G)if(D){if(C){t=c;j=0;while(1){if(L){B=0;ra=0.0;qa=0.0;while(1){sa=+n[xa+(B<<3)>>2];na=+n[xa+(B<<3)+4>>2];ta=+n[t+(B<<3)>>2];oa=+n[t+(B<<3)+4>>2];ua=ra+(sa*ta-na*oa);pa=qa+(na*ta+sa*oa);B=B+1|0;if((B|0)==(y|0)){ya=ua;za=pa;break}else{ra=ua;qa=pa}}}else{ya=0.0;za=0.0}p[a+(j<<4)>>3]=ya+0.0;p[a+(j<<4)+8>>3]=za+0.0;j=j+1|0;if((j|0)==(h|0))break b;else t=t+(b<<3)|0}}else{Aa=c;Ba=0}while(1){t=0;qa=0.0;ra=0.0;_=0.0;W=0.0;do{pa=+n[xa+(t<<3)>>2];ua=+n[xa+(t<<3)+4>>2];oa=+n[Aa+(t<<3)>>2];sa=+n[Aa+(t<<3)+4>>2];ra=ra+(pa*oa-ua*sa);_=_+(ua*oa+pa*sa);j=t|1;sa=+n[xa+(j<<3)>>2];pa=+n[xa+(j<<3)+4>>2];oa=+n[Aa+(j<<3)>>2];ua=+n[Aa+(j<<3)+4>>2];qa=qa+(sa*oa-pa*ua);W=W+(pa*oa+sa*ua);t=t+2|0}while((t|0)<=(s|0));if(z){t=E;ua=ra;sa=_;while(1){oa=+n[xa+(t<<3)>>2];pa=+n[xa+(t<<3)+4>>2];ta=+n[Aa+(t<<3)>>2];na=+n[Aa+(t<<3)+4>>2];T=ua+(oa*ta-pa*na);S=sa+(pa*ta+oa*na);t=t+1|0;if((t|0)==(y|0)){Ca=T;Da=S;break}else{ua=T;sa=S}}}else{Ca=ra;Da=_}p[a+(Ba<<4)>>3]=qa+Ca;p[a+(Ba<<4)+8>>3]=W+Da;Ba=Ba+1|0;if((Ba|0)==(h|0))break;else Aa=Aa+(b<<3)|0}}else{if(C){t=c;j=0;while(1){B=a+(j<<4)+8|0;H=a+(j<<4)|0;sa=+p[H>>3];ua=+p[B>>3];if(va){J=0;S=sa;T=ua;while(1){na=+n[xa+(J<<3)>>2];oa=+n[xa+(J<<3)+4>>2];ta=+n[t+(J<<3)>>2];pa=+n[t+(J<<3)+4>>2];R=S+(na*ta-oa*pa);Q=T+(oa*ta+na*pa);J=J+1|0;if((J|0)==(y|0)){Ea=R;Fa=Q;break}else{S=R;T=Q}}}else{Ea=sa;Fa=ua}p[H>>3]=Ea+0.0;p[B>>3]=Fa+0.0;j=j+1|0;if((j|0)==(h|0))break b;else t=t+(b<<3)|0}}else{Ga=c;Ha=0}while(1){t=a+(Ha<<4)+8|0;j=a+(Ha<<4)|0;J=0;T=0.0;S=+p[j>>3];W=+p[t>>3];qa=0.0;do{_=+n[xa+(J<<3)>>2];ra=+n[xa+(J<<3)+4>>2];Q=+n[Ga+(J<<3)>>2];R=+n[Ga+(J<<3)+4>>2];S=S+(_*Q-ra*R);W=W+(ra*Q+_*R);o=J|1;R=+n[xa+(o<<3)>>2];_=+n[xa+(o<<3)+4>>2];Q=+n[Ga+(o<<3)>>2];ra=+n[Ga+(o<<3)+4>>2];T=T+(R*Q-_*ra);qa=qa+(_*Q+R*ra);J=J+2|0}while((J|0)<=(s|0));if(g){J=E;ua=S;sa=W;while(1){ra=+n[xa+(J<<3)>>2];R=+n[xa+(J<<3)+4>>2];Q=+n[Ga+(J<<3)>>2];_=+n[Ga+(J<<3)+4>>2];pa=ua+(ra*Q-R*_);na=sa+(R*Q+ra*_);J=J+1|0;if((J|0)==(y|0)){Ia=pa;Ja=na;break}else{ua=pa;sa=na}}}else{Ia=S;Ja=W}p[j>>3]=T+Ia;p[t>>3]=qa+Ja;Ha=Ha+1|0;if((Ha|0)==(h|0))break;else Ga=Ga+(b<<3)|0}}while(0);e=e+1|0;if((e|0)==(q|0))break;else{A=A+(w<<3)|0;a=a+(d<<4)|0}}}d=f[l>>2]|0;if((d|0)==(i|0)){u=k;return}if(d|0)ZDc(d);f[l>>2]=i;f[r>>2]=136;u=k;return}function FN(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0.0,Ba=0.0;k=u;u=u+1168|0;l=k;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[i>>2]|0;o=f[i+4>>2]|0;i=l+8|0;XIc(i|0,0,1152)|0;f[l>>2]=i;q=l+4|0;f[q>>2]=72;r=j&16;s=b>>>4;b=d>>>4;d=g>>>4;if(j&1){f[q>>2]=n;if(n>>>0>72){g=XDc(n>>>0>268435455?-1:n<<4)|0;XIc(g|0,0,n<<4|0)|0;f[l>>2]=g;t=s;v=1;w=g;x=n}else{t=s;v=1;w=i;x=n}}else{t=1;v=s;w=0;x=m}m=(o|0)>0;if(!(j&2)){if(m){j=(w|0)==0;s=h+-4|0;n=(h|0)<4;g=(r|0)==0;y=(x|0)>0;z=h&-4;A=(x|0)<1|j;B=(s>>>2<<6)+64|0;C=a;D=e;E=0;while(1){F=e+((Y(d,E)|0)<<4)|0;if(A)G=j?C:w;else{H=0;do{I=C+((Y(H,t)|0)<<4)|0;J=w+(H<<4)|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];f[J+8>>2]=f[I+8>>2];f[J+12>>2]=f[I+12>>2];H=H+1|0}while((H|0)!=(x|0));G=w}a:do if(!n)if(g){if(y)K=0;else{XIc(F|0,0,B|0)|0;L=z;break}do{H=c+(K<<4)|0;I=0;M=0.0;N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;while(1){U=+p[G+(I<<4)>>3];V=+p[G+(I<<4)+8>>3];W=+p[H>>3];X=+p[H+8>>3];N=N+(U*W-V*X);T=T+(V*W+U*X);X=+p[H+16>>3];W=+p[H+24>>3];M=M+(U*X-V*W);R=R+(V*X+U*W);W=+p[H+32>>3];X=+p[H+40>>3];P=P+(U*W-V*X);S=S+(V*W+U*X);X=+p[H+48>>3];W=+p[H+56>>3];O=O+(U*X-V*W);Q=Q+(V*X+U*W);I=I+1|0;if((I|0)==(x|0))break;else H=H+(b<<4)|0}p[D+(K<<4)>>3]=N;p[D+(K<<4)+8>>3]=T;H=K|1;p[D+(H<<4)>>3]=M;p[D+(H<<4)+8>>3]=R;H=K|2;p[D+(H<<4)>>3]=P;p[D+(H<<4)+8>>3]=S;H=K|3;p[D+(H<<4)>>3]=O;p[D+(H<<4)+8>>3]=Q;K=K+4|0}while((K|0)<=(s|0));L=z}else{if(y)Z=0;else{H=0;while(1){H=H+4|0;if((H|0)>(s|0)){L=z;break a}}}do{H=D+(Z<<4)|0;I=D+(Z<<4)+8|0;J=Z|1;_=D+(J<<4)|0;$=D+(J<<4)+8|0;J=Z|2;aa=D+(J<<4)|0;ba=D+(J<<4)+8|0;J=Z|3;ca=D+(J<<4)|0;da=D+(J<<4)+8|0;J=c+(Z<<4)|0;ea=0;W=+p[_>>3];U=+p[H>>3];X=+p[ca>>3];V=+p[aa>>3];fa=+p[da>>3];ga=+p[$>>3];ha=+p[ba>>3];ia=+p[I>>3];while(1){ja=+p[G+(ea<<4)>>3];ka=+p[G+(ea<<4)+8>>3];la=+p[J>>3];ma=+p[J+8>>3];U=U+(ja*la-ka*ma);ia=ia+(ka*la+ja*ma);ma=+p[J+16>>3];la=+p[J+24>>3];W=W+(ja*ma-ka*la);ga=ga+(ka*ma+ja*la);la=+p[J+32>>3];ma=+p[J+40>>3];V=V+(ja*la-ka*ma);ha=ha+(ka*la+ja*ma);ma=+p[J+48>>3];la=+p[J+56>>3];X=X+(ja*ma-ka*la);fa=fa+(ka*ma+ja*la);ea=ea+1|0;if((ea|0)==(x|0))break;else J=J+(b<<4)|0}p[H>>3]=U;p[I>>3]=ia;p[_>>3]=W;p[$>>3]=ga;p[aa>>3]=V;p[ba>>3]=ha;p[ca>>3]=X;p[da>>3]=fa;Z=Z+4|0}while((Z|0)<=(s|0));L=z}else L=0;while(0);b:do if((h|0)>(L|0))if(g){if(y)na=L;else{XIc(F+(L<<4)|0,0,h-L<<4|0)|0;break}do{J=c+(na<<4)|0;ea=0;Q=0.0;O=0.0;while(1){S=+p[G+(ea<<4)>>3];P=+p[G+(ea<<4)+8>>3];R=+p[J>>3];M=+p[J+8>>3];Q=Q+(S*R-P*M);O=O+(P*R+S*M);ea=ea+1|0;if((ea|0)==(x|0))break;else J=J+(b<<4)|0}p[D+(na<<4)>>3]=Q;p[D+(na<<4)+8>>3]=O;na=na+1|0}while((na|0)!=(h|0))}else{if(y)oa=L;else{J=L;while(1){J=J+1|0;if((J|0)==(h|0))break b}}do{J=D+(oa<<4)+8|0;ea=D+(oa<<4)|0;da=c+(oa<<4)|0;ca=0;fa=+p[ea>>3];X=+p[J>>3];while(1){ha=+p[G+(ca<<4)>>3];V=+p[G+(ca<<4)+8>>3];ga=+p[da>>3];W=+p[da+8>>3];fa=fa+(ha*ga-V*W);X=X+(V*ga+ha*W);ca=ca+1|0;if((ca|0)==(x|0))break;else da=da+(b<<4)|0}p[ea>>3]=fa;p[J>>3]=X;oa=oa+1|0}while((oa|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(o|0))break;else{C=C+(v<<4)|0;D=D+(d<<4)|0}}}}else if(m){m=(w|0)==0;D=(r|0)==0;r=x+-2|0;C=(x|0)<2;E=x&-2;oa=(x|0)<1|m;G=(h|0)>0;L=(x|0)>0;y=(E|0)<(x|0);na=(x|0)>0;g=(E|0)<(x|0);z=a;a=e;e=0;while(1){if(oa)pa=m?z:w;else{s=0;do{Z=z+((Y(s,t)|0)<<4)|0;K=w+(s<<4)|0;f[K>>2]=f[Z>>2];f[K+4>>2]=f[Z+4>>2];f[K+8>>2]=f[Z+8>>2];f[K+12>>2]=f[Z+12>>2];s=s+1|0}while((s|0)!=(x|0));pa=w}c:do if(G)if(D){if(C){s=c;Z=0;while(1){if(L){K=0;O=0.0;Q=0.0;while(1){W=+p[pa+(K<<4)>>3];ha=+p[pa+(K<<4)+8>>3];ga=+p[s+(K<<4)>>3];V=+p[s+(K<<4)+8>>3];ia=O+(W*ga-ha*V);U=Q+(ha*ga+W*V);K=K+1|0;if((K|0)==(x|0)){qa=ia;ra=U;break}else{O=ia;Q=U}}}else{qa=0.0;ra=0.0}p[a+(Z<<4)>>3]=qa+0.0;p[a+(Z<<4)+8>>3]=ra+0.0;Z=Z+1|0;if((Z|0)==(h|0))break c;else s=s+(b<<4)|0}}else{sa=c;ta=0}while(1){s=0;Q=0.0;O=0.0;X=0.0;fa=0.0;do{U=+p[pa+(s<<4)>>3];ia=+p[pa+(s<<4)+8>>3];V=+p[sa+(s<<4)>>3];W=+p[sa+(s<<4)+8>>3];O=O+(U*V-ia*W);X=X+(ia*V+U*W);Z=s|1;W=+p[pa+(Z<<4)>>3];U=+p[pa+(Z<<4)+8>>3];V=+p[sa+(Z<<4)>>3];ia=+p[sa+(Z<<4)+8>>3];Q=Q+(W*V-U*ia);fa=fa+(U*V+W*ia);s=s+2|0}while((s|0)<=(r|0));if(y){s=E;ia=O;W=X;while(1){V=+p[pa+(s<<4)>>3];U=+p[pa+(s<<4)+8>>3];ga=+p[sa+(s<<4)>>3];ha=+p[sa+(s<<4)+8>>3];M=ia+(V*ga-U*ha);S=W+(U*ga+V*ha);s=s+1|0;if((s|0)==(x|0)){ua=M;va=S;break}else{ia=M;W=S}}}else{ua=O;va=X}p[a+(ta<<4)>>3]=Q+ua;p[a+(ta<<4)+8>>3]=fa+va;ta=ta+1|0;if((ta|0)==(h|0))break;else sa=sa+(b<<4)|0}}else{if(C){s=c;Z=0;while(1){K=a+(Z<<4)+8|0;J=a+(Z<<4)|0;W=+p[J>>3];ia=+p[K>>3];if(na){ea=0;S=W;M=ia;while(1){ha=+p[pa+(ea<<4)>>3];V=+p[pa+(ea<<4)+8>>3];ga=+p[s+(ea<<4)>>3];U=+p[s+(ea<<4)+8>>3];R=S+(ha*ga-V*U);P=M+(V*ga+ha*U);ea=ea+1|0;if((ea|0)==(x|0)){wa=R;xa=P;break}else{S=R;M=P}}}else{wa=W;xa=ia}p[J>>3]=wa+0.0;p[K>>3]=xa+0.0;Z=Z+1|0;if((Z|0)==(h|0))break c;else s=s+(b<<4)|0}}else{ya=c;za=0}while(1){s=a+(za<<4)+8|0;Z=a+(za<<4)|0;ea=0;M=0.0;S=+p[Z>>3];fa=+p[s>>3];Q=0.0;do{X=+p[pa+(ea<<4)>>3];O=+p[pa+(ea<<4)+8>>3];P=+p[ya+(ea<<4)>>3];R=+p[ya+(ea<<4)+8>>3];S=S+(X*P-O*R);fa=fa+(O*P+X*R);B=ea|1;R=+p[pa+(B<<4)>>3];X=+p[pa+(B<<4)+8>>3];P=+p[ya+(B<<4)>>3];O=+p[ya+(B<<4)+8>>3];M=M+(R*P-X*O);Q=Q+(X*P+R*O);ea=ea+2|0}while((ea|0)<=(r|0));if(g){ea=E;ia=S;W=fa;while(1){O=+p[pa+(ea<<4)>>3];R=+p[pa+(ea<<4)+8>>3];P=+p[ya+(ea<<4)>>3];X=+p[ya+(ea<<4)+8>>3];U=ia+(O*P-R*X);ha=W+(R*P+O*X);ea=ea+1|0;if((ea|0)==(x|0)){Aa=U;Ba=ha;break}else{ia=U;W=ha}}}else{Aa=S;Ba=fa}p[Z>>3]=M+Aa;p[s>>3]=Q+Ba;za=za+1|0;if((za|0)==(h|0))break;else ya=ya+(b<<4)|0}}while(0);e=e+1|0;if((e|0)==(o|0))break;else{z=z+(v<<4)|0;a=a+(d<<4)|0}}}d=f[l>>2]|0;if((d|0)==(i|0)){u=k;return}if(d|0)ZDc(d);f[l>>2]=i;f[q>>2]=72;u=k;return}function GN(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0;k=u;u=u+1072|0;l=k;m=f[h>>2]|0;o=f[h+4>>2]|0;h=f[i>>2]|0;q=f[i+4>>2]|0;i=l+8|0;f[l>>2]=i;r=l+4|0;f[r>>2]=264;s=j&16;t=b>>>2;b=d>>>2;d=g>>>3;if(j&1){f[r>>2]=o;if(o>>>0>264){g=XDc(o>>>0>1073741823?-1:o<<2)|0;f[l>>2]=g;v=t;w=1;x=g;y=o;z=g}else{v=t;w=1;x=i;y=o;z=i}}else{v=1;w=t;x=0;y=m;z=i}m=(q|0)>0;if(!(j&2)){if(m){j=(x|0)==0;t=h+-4|0;o=(h|0)<4;g=(s|0)==0;A=(y|0)>0;B=h&-4;C=(y|0)<1|j;D=(t>>>2<<5)+32|0;E=e;F=0;G=a;while(1){H=e+((Y(d,F)|0)<<3)|0;if(C)I=j?G:x;else{J=0;do{K=G+((Y(J,v)|0)<<2)|0;f[x+(J<<2)>>2]=f[K>>2];J=J+1|0}while((J|0)!=(y|0));I=x}a:do if(!o)if(g){if(A)L=0;else{XIc(H|0,0,D|0)|0;M=B;break}do{J=c+(L<<2)|0;N=0.0;O=0.0;P=0.0;Q=0.0;K=0;while(1){R=+n[I+(K<<2)>>2];Q=Q+R*+n[J>>2];P=P+R*+n[J+4>>2];O=O+R*+n[J+8>>2];N=N+R*+n[J+12>>2];K=K+1|0;if((K|0)==(y|0))break;else J=J+(b<<2)|0}p[E+(L<<3)>>3]=Q;p[E+((L|1)<<3)>>3]=P;p[E+((L|2)<<3)>>3]=O;p[E+((L|3)<<3)>>3]=N;L=L+4|0}while((L|0)<=(t|0));M=B}else{if(A)S=0;else{J=0;while(1){J=J+4|0;if((J|0)>(t|0)){M=B;break a}}}do{J=E+((S|3)<<3)|0;K=E+((S|2)<<3)|0;T=E+((S|1)<<3)|0;U=E+(S<<3)|0;V=c+(S<<2)|0;R=+p[J>>3];W=+p[K>>3];X=+p[T>>3];Z=+p[U>>3];_=0;while(1){$=+n[I+(_<<2)>>2];Z=Z+$*+n[V>>2];X=X+$*+n[V+4>>2];W=W+$*+n[V+8>>2];R=R+$*+n[V+12>>2];_=_+1|0;if((_|0)==(y|0))break;else V=V+(b<<2)|0}p[U>>3]=Z;p[T>>3]=X;p[K>>3]=W;p[J>>3]=R;S=S+4|0}while((S|0)<=(t|0));M=B}else M=0;while(0);b:do if((h|0)>(M|0)){if(!g){if(A)aa=M;else break;while(1){V=E+(aa<<3)|0;_=c+(aa<<2)|0;N=+p[V>>3];ba=0;while(1){N=N+ +n[I+(ba<<2)>>2]*+n[_>>2];ba=ba+1|0;if((ba|0)==(y|0))break;else _=_+(b<<2)|0}p[V>>3]=N;aa=aa+1|0;if((aa|0)==(h|0))break b}}if(A)ca=M;else{XIc(H+(M<<3)|0,0,h-M<<3|0)|0;break}do{_=c+(ca<<2)|0;R=0.0;ba=0;while(1){R=R+ +n[I+(ba<<2)>>2]*+n[_>>2];ba=ba+1|0;if((ba|0)==(y|0))break;else _=_+(b<<2)|0}p[E+(ca<<3)>>3]=R;ca=ca+1|0}while((ca|0)!=(h|0))}while(0);F=F+1|0;if((F|0)==(q|0))break;else{E=E+(d<<3)|0;G=G+(w<<2)|0}}}}else if(m){m=(x|0)==0;G=(h|0)>0;E=(s|0)==0;s=y+-2|0;F=(y|0)<2;ca=y&-2;I=(y|0)<1|m;M=(y|0)>0;A=(ca|0)<(y|0);aa=(y|0)>0;g=(ca|0)<(y|0);B=e;e=0;t=a;while(1){if(I)da=m?t:x;else{a=0;do{S=t+((Y(a,v)|0)<<2)|0;f[x+(a<<2)>>2]=f[S>>2];a=a+1|0}while((a|0)!=(y|0));da=x}c:do if(G)if(E){if(F){a=c;S=0;while(1){if(M){N=0.0;L=0;while(1){W=N+ +n[da+(L<<2)>>2]*+n[a+(L<<2)>>2];L=L+1|0;if((L|0)==(y|0)){ea=W;break}else N=W}}else ea=0.0;p[B+(S<<3)>>3]=ea+0.0;S=S+1|0;if((S|0)==(h|0))break c;else a=a+(b<<2)|0}}else{fa=c;ga=0}while(1){N=0.0;R=0.0;a=0;do{R=R+ +n[da+(a<<2)>>2]*+n[fa+(a<<2)>>2];S=a|1;N=N+ +n[da+(S<<2)>>2]*+n[fa+(S<<2)>>2];a=a+2|0}while((a|0)<=(s|0));if(A){W=R;a=ca;while(1){X=W+ +n[da+(a<<2)>>2]*+n[fa+(a<<2)>>2];a=a+1|0;if((a|0)==(y|0)){ha=X;break}else W=X}}else ha=R;p[B+(ga<<3)>>3]=N+ha;ga=ga+1|0;if((ga|0)==(h|0))break;else fa=fa+(b<<2)|0}}else{if(F){a=c;S=0;while(1){L=B+(S<<3)|0;W=+p[L>>3];if(aa){X=W;D=0;while(1){Z=X+ +n[da+(D<<2)>>2]*+n[a+(D<<2)>>2];D=D+1|0;if((D|0)==(y|0)){ia=Z;break}else X=Z}}else ia=W;p[L>>3]=ia+0.0;S=S+1|0;if((S|0)==(h|0))break c;else a=a+(b<<2)|0}}else{ja=c;ka=0}while(1){a=B+(ka<<3)|0;X=0.0;N=+p[a>>3];S=0;do{N=N+ +n[da+(S<<2)>>2]*+n[ja+(S<<2)>>2];D=S|1;X=X+ +n[da+(D<<2)>>2]*+n[ja+(D<<2)>>2];S=S+2|0}while((S|0)<=(s|0));if(g){W=N;S=ca;while(1){R=W+ +n[da+(S<<2)>>2]*+n[ja+(S<<2)>>2];S=S+1|0;if((S|0)==(y|0)){la=R;break}else W=R}}else la=N;p[a>>3]=X+la;ka=ka+1|0;if((ka|0)==(h|0))break;else ja=ja+(b<<2)|0}}while(0);e=e+1|0;if((e|0)==(q|0))break;else{B=B+(d<<3)|0;t=t+(w<<2)|0}}}if((z|0)==(i|0)){u=k;return}ZDc(z);f[l>>2]=i;f[r>>2]=264;u=k;return}function HN(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>3;b=d>>>3;d=g>>>3;g=(a|0)==0;n=(k&4|0)==0;k=g?0:n?h:1;o=g?0:n?1:h;if(!m)return;h=o<<1;n=o*3|0;g=o<<2;q=(l|0)<4;r=l+-4|0;s=(r|0)>3?r:3;t=(s&2147483644)+4|0;u=s>>>2;s=Y(u,g)|0;v=(u<<2)+4|0;u=c;c=e;e=a;w=m;m=a+(g<<3)|0;while(1){w=w+-1|0;if(!e){if(q)x=0;else{a=0;do{y=a|1;z=+p[u+(y<<3)>>3]*i;p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i;p[c+(y<<3)>>3]=z;y=a|2;A=a|3;z=+p[u+(A<<3)>>3]*i;p[c+(y<<3)>>3]=+p[u+(y<<3)>>3]*i;p[c+(A<<3)>>3]=z;a=a+4|0}while((a|0)<=(r|0));x=t}if((x|0)<(l|0)){a=x;do{p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i;a=a+1|0}while((a|0)!=(l|0))}}else{if(q){B=e;C=0}else{a=0;A=e;while(1){y=a|1;z=+p[u+(y<<3)>>3]*i+ +p[A+(o<<3)>>3]*j;p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i+ +p[A>>3]*j;p[c+(y<<3)>>3]=z;y=a|2;D=a|3;z=+p[u+(D<<3)>>3]*i+ +p[A+(n<<3)>>3]*j;p[c+(y<<3)>>3]=+p[u+(y<<3)>>3]*i+ +p[A+(h<<3)>>3]*j;p[c+(D<<3)>>3]=z;a=a+4|0;if((a|0)>(r|0))break;else A=A+(g<<3)|0}B=m+(s<<3)|0;C=v}if((C|0)<(l|0)){A=C;a=B;while(1){p[c+(A<<3)>>3]=+p[u+(A<<3)>>3]*i+ +p[a>>3]*j;A=A+1|0;if((A|0)==(l|0))break;else a=a+(o<<3)|0}}}if(!w)break;else{u=u+(b<<3)|0;c=c+(d<<3)|0;e=e+(k<<3)|0;m=m+(k<<3)|0}}return}function IN(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>3;b=d>>>4;d=g>>>3;g=(a|0)==0;o=(k&4|0)==0;k=g?0:o?h:1;q=g?0:o?1:h;if(!m)return;h=q<<1;o=q*3|0;g=q<<2;r=(l|0)<4;s=l+-4|0;t=s>>>2;u=(t<<2)+4|0;v=c;c=e;e=a;w=m;m=a+(Y(q,(t<<5)+32|0)|0)|0;while(1){w=w+-1|0;if(!e){if(r)x=0;else{t=0;do{a=t|1;y=+p[v+(a<<4)>>3]*i;z=+p[v+(a<<4)+8>>3]*i;A=+p[v+(t<<4)+8>>3]*i;n[c+(t<<3)>>2]=+p[v+(t<<4)>>3]*i;n[c+(t<<3)+4>>2]=A;n[c+(a<<3)>>2]=y;n[c+(a<<3)+4>>2]=z;a=t|2;B=t|3;z=+p[v+(B<<4)>>3]*i;y=+p[v+(B<<4)+8>>3]*i;A=+p[v+(a<<4)+8>>3]*i;n[c+(a<<3)>>2]=+p[v+(a<<4)>>3]*i;n[c+(a<<3)+4>>2]=A;n[c+(B<<3)>>2]=z;n[c+(B<<3)+4>>2]=y;t=t+4|0}while((t|0)<=(s|0));x=u}if((x|0)<(l|0)){t=x;do{y=+p[v+(t<<4)+8>>3]*i;n[c+(t<<3)>>2]=+p[v+(t<<4)>>3]*i;n[c+(t<<3)+4>>2]=y;t=t+1|0}while((t|0)!=(l|0))}}else{if(r){C=e;D=0}else{t=e;B=0;while(1){a=B|1;y=+p[v+(a<<4)>>3]*i+ +n[t+(q<<3)>>2]*j;z=+p[v+(a<<4)+8>>3]*i+ +n[t+(q<<3)+4>>2]*j;A=+p[v+(B<<4)+8>>3]*i+ +n[t+4>>2]*j;n[c+(B<<3)>>2]=+p[v+(B<<4)>>3]*i+ +n[t>>2]*j;n[c+(B<<3)+4>>2]=A;n[c+(a<<3)>>2]=y;n[c+(a<<3)+4>>2]=z;a=B|2;E=B|3;z=+p[v+(E<<4)>>3]*i+ +n[t+(o<<3)>>2]*j;y=+p[v+(E<<4)+8>>3]*i+ +n[t+(o<<3)+4>>2]*j;A=+p[v+(a<<4)+8>>3]*i+ +n[t+(h<<3)+4>>2]*j;n[c+(a<<3)>>2]=+p[v+(a<<4)>>3]*i+ +n[t+(h<<3)>>2]*j;n[c+(a<<3)+4>>2]=A;n[c+(E<<3)>>2]=z;n[c+(E<<3)+4>>2]=y;B=B+4|0;if((B|0)>(s|0)){C=m;D=u;break}else t=t+(g<<3)|0}}if((D|0)<(l|0)){t=C;B=D;while(1){y=+p[v+(B<<4)+8>>3]*i+ +n[t+4>>2]*j;n[c+(B<<3)>>2]=+p[v+(B<<4)>>3]*i+ +n[t>>2]*j;n[c+(B<<3)+4>>2]=y;B=B+1|0;if((B|0)==(l|0))break;else t=t+(q<<3)|0}}}if(!w)break;else{v=v+(b<<4)|0;c=c+(d<<3)|0;e=e+(k<<3)|0;m=m+(k<<3)|0}}return}function JN(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>4;b=d>>>4;d=g>>>4;g=(a|0)==0;n=(k&4|0)==0;k=g?0:n?h:1;o=g?0:n?1:h;if(!m)return;h=o<<1;n=o*3|0;g=o<<2;q=(l|0)<4;r=l+-4|0;s=r>>>2;t=(s<<2)+4|0;u=a;v=c;c=e;e=m;m=a+(Y(o,(s<<6)+64|0)|0)|0;while(1){e=e+-1|0;if(!u){if(q)w=0;else{s=0;do{x=+p[v+(s<<4)+8>>3]*i;a=s|1;y=+p[v+(a<<4)>>3]*i;z=+p[v+(a<<4)+8>>3]*i;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i;p[c+(s<<4)+8>>3]=x;p[c+(a<<4)>>3]=y;p[c+(a<<4)+8>>3]=z;a=s|2;z=+p[v+(a<<4)+8>>3]*i;A=s|3;y=+p[v+(A<<4)>>3]*i;x=+p[v+(A<<4)+8>>3]*i;p[c+(a<<4)>>3]=+p[v+(a<<4)>>3]*i;p[c+(a<<4)+8>>3]=z;p[c+(A<<4)>>3]=y;p[c+(A<<4)+8>>3]=x;s=s+4|0}while((s|0)<=(r|0));w=t}if((w|0)<(l|0)){s=w;do{x=+p[v+(s<<4)+8>>3]*i;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i;p[c+(s<<4)+8>>3]=x;s=s+1|0}while((s|0)!=(l|0))}}else{if(q){B=0;C=u}else{s=0;A=u;while(1){a=s|1;x=+p[v+(s<<4)+8>>3]*i+ +p[A+8>>3]*j;y=+p[v+(a<<4)>>3]*i+ +p[A+(o<<4)>>3]*j;z=+p[v+(a<<4)+8>>3]*i+ +p[A+(o<<4)+8>>3]*j;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i+ +p[A>>3]*j;p[c+(s<<4)+8>>3]=x;p[c+(a<<4)>>3]=y;p[c+(a<<4)+8>>3]=z;a=s|2;D=s|3;z=+p[v+(a<<4)+8>>3]*i+ +p[A+(h<<4)+8>>3]*j;y=+p[v+(D<<4)>>3]*i+ +p[A+(n<<4)>>3]*j;x=+p[v+(D<<4)+8>>3]*i+ +p[A+(n<<4)+8>>3]*j;p[c+(a<<4)>>3]=+p[v+(a<<4)>>3]*i+ +p[A+(h<<4)>>3]*j;p[c+(a<<4)+8>>3]=z;p[c+(D<<4)>>3]=y;p[c+(D<<4)+8>>3]=x;s=s+4|0;if((s|0)>(r|0)){B=t;C=m;break}else A=A+(g<<4)|0}}if((B|0)<(l|0)){A=C;s=B;while(1){x=+p[v+(s<<4)+8>>3]*i+ +p[A+8>>3]*j;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i+ +p[A>>3]*j;p[c+(s<<4)+8>>3]=x;s=s+1|0;if((s|0)==(l|0))break;else A=A+(o<<4)|0}}}if(!e)break;else{u=u+(k<<4)|0;v=v+(b<<4)|0;c=c+(d<<4)|0;m=m+(k<<4)|0}}return}function KN(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>2;b=d>>>3;d=g>>>2;g=(a|0)==0;o=(k&4|0)==0;k=g?0:o?h:1;q=g?0:o?1:h;if(!m)return;h=q<<1;o=q*3|0;g=q<<2;r=(l|0)<4;s=l+-4|0;t=(s|0)>3?s:3;u=(t&2147483644)+4|0;v=t>>>2;t=Y(v,g)|0;w=(v<<2)+4|0;v=c;c=e;e=a;x=m;m=a+(g<<2)|0;while(1){x=x+-1|0;if(!e){if(r)y=0;else{a=0;do{z=a|1;A=+p[v+(z<<3)>>3]*i;n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i;n[c+(z<<2)>>2]=A;z=a|2;B=a|3;A=+p[v+(B<<3)>>3]*i;n[c+(z<<2)>>2]=+p[v+(z<<3)>>3]*i;n[c+(B<<2)>>2]=A;a=a+4|0}while((a|0)<=(s|0));y=u}if((y|0)<(l|0)){a=y;do{n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i;a=a+1|0}while((a|0)!=(l|0))}}else{if(r){C=e;D=0}else{a=0;B=e;while(1){z=a|1;A=+p[v+(z<<3)>>3]*i+ +n[B+(q<<2)>>2]*j;n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i+ +n[B>>2]*j;n[c+(z<<2)>>2]=A;z=a|2;E=a|3;A=+p[v+(E<<3)>>3]*i+ +n[B+(o<<2)>>2]*j;n[c+(z<<2)>>2]=+p[v+(z<<3)>>3]*i+ +n[B+(h<<2)>>2]*j;n[c+(E<<2)>>2]=A;a=a+4|0;if((a|0)>(s|0))break;else B=B+(g<<2)|0}C=m+(t<<2)|0;D=w}if((D|0)<(l|0)){B=D;a=C;while(1){n[c+(B<<2)>>2]=+p[v+(B<<3)>>3]*i+ +n[a>>2]*j;B=B+1|0;if((B|0)==(l|0))break;else a=a+(q<<2)|0}}}if(!x)break;else{v=v+(b<<3)|0;c=c+(d<<2)|0;e=e+(k<<2)|0;m=m+(k<<2)|0}}return}function LN(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;q=u;u=u+448|0;r=q+392|0;s=q+336|0;t=q+280|0;v=q+224|0;w=q+168|0;x=q+112|0;y=q+56|0;z=q;A=(o&2|0)==0;B=(o&1|0)!=0;C=B?l:m;D=B?m:l;B=A?C:n;E=A?n:C;C=(o&4|0)==0;A=C?D:n;F=C?n:D;f[r>>2]=1124007936;C=r+4|0;G=r+8|0;H=r+40|0;I=C;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[H>>2]=G;K=r+48|0;L=r+44|0;f[L>>2]=K;f[K>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;O=s+40|0;I=M;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[O>>2]=N;P=s+48|0;Q=s+44|0;f[Q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[T>>2]=S;I=t+48|0;J=t+44|0;f[J>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(a|0){Vj(v,l,m,p,a,b);b=v+36|0;a=f[b>>2]|0;if(a|0){m=a+12|0;f[m>>2]=(f[m>>2]|0)+1}m=r+36|0;a=f[m>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)_S(r);f[m>>2]=0;a=r+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){l=f[H>>2]|0;U=0;do{f[l+(U<<2)>>2]=0;U=U+1|0;V=f[C>>2]|0}while((U|0)<(V|0));f[r>>2]=f[v>>2];if((V|0)<3)W=12;else W=14}else{f[r>>2]=f[v>>2];W=12}if((W|0)==12){V=f[v+4>>2]|0;if((V|0)<3){f[C>>2]=V;f[G>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];V=f[v+44>>2]|0;U=f[L>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else W=14}if((W|0)==14)ZS(r,v);V=v+16|0;f[a>>2]=f[V>>2];f[r+20>>2]=f[v+20>>2];f[r+24>>2]=f[v+24>>2];f[r+28>>2]=f[v+28>>2];f[r+32>>2]=f[v+32>>2];a=f[b>>2]|0;f[m>>2]=a;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)_S(v);f[b>>2]=0;b=v+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[b>>2]|0)>0){V=f[v+40>>2]|0;a=0;do{f[V+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[v+44>>2]|0;if((b|0)!=(v+48|0))g0(b)}if(c|0){Vj(v,B,E,p,c,d);d=v+36|0;c=f[d>>2]|0;if(c|0){E=c+12|0;f[E>>2]=(f[E>>2]|0)+1}E=s+36|0;c=f[E>>2]|0;if(c|0?(B=c+12|0,c=f[B>>2]|0,f[B>>2]=c+-1,(c|0)==1):0)_S(s);f[E>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){B=f[O>>2]|0;b=0;do{f[B+(b<<2)>>2]=0;b=b+1|0;X=f[M>>2]|0}while((b|0)<(X|0));f[s>>2]=f[v>>2];if((X|0)<3)W=35;else W=37}else{f[s>>2]=f[v>>2];W=35}if((W|0)==35){X=f[v+4>>2]|0;if((X|0)<3){f[M>>2]=X;f[N>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];X=f[v+44>>2]|0;b=f[Q>>2]|0;f[b>>2]=f[X>>2];f[b+4>>2]=f[X+4>>2]}else W=37}if((W|0)==37)ZS(s,v);X=v+16|0;f[c>>2]=f[X>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];c=f[d>>2]|0;f[E>>2]=c;if(c|0?(E=c+12|0,c=f[E>>2]|0,f[E>>2]=c+-1,(c|0)==1):0)_S(v);f[d>>2]=0;d=v+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[d>>2]|0)>0){X=f[v+40>>2]|0;c=0;do{f[X+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[v+44>>2]|0;if((d|0)!=(v+48|0))g0(d)}if((g|0)!=0&i!=0.0){Vj(v,A,F,p,g,h);h=v+36|0;g=f[h>>2]|0;if(g|0){F=g+12|0;f[F>>2]=(f[F>>2]|0)+1}F=t+36|0;g=f[F>>2]|0;if(g|0?(A=g+12|0,g=f[A>>2]|0,f[A>>2]=g+-1,(g|0)==1):0)_S(t);f[F>>2]=0;g=t+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[R>>2]|0)>0){A=f[T>>2]|0;d=0;do{f[A+(d<<2)>>2]=0;d=d+1|0;Y=f[R>>2]|0}while((d|0)<(Y|0));f[t>>2]=f[v>>2];if((Y|0)<3)W=58;else W=60}else{f[t>>2]=f[v>>2];W=58}if((W|0)==58){Y=f[v+4>>2]|0;if((Y|0)<3){f[R>>2]=Y;f[S>>2]=f[v+8>>2];f[t+12>>2]=f[v+12>>2];Y=f[v+44>>2]|0;d=f[J>>2]|0;f[d>>2]=f[Y>>2];f[d+4>>2]=f[Y+4>>2]}else W=60}if((W|0)==60)ZS(t,v);W=v+16|0;f[g>>2]=f[W>>2];f[t+20>>2]=f[v+20>>2];f[t+24>>2]=f[v+24>>2];f[t+28>>2]=f[v+28>>2];f[t+32>>2]=f[v+32>>2];g=f[h>>2]|0;f[F>>2]=g;if(g|0?(F=g+12|0,g=f[F>>2]|0,f[F>>2]=g+-1,(g|0)==1):0)_S(v);f[h>>2]=0;h=v+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[h>>2]|0)>0){W=f[v+40>>2]|0;g=0;do{f[W+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[v+44>>2]|0;if((h|0)!=(v+48|0))g0(h)}Vj(v,D,n,p,j,k);f[w>>2]=f[r>>2];k=w+4|0;j=f[C>>2]|0;f[k>>2]=j;p=w+8|0;f[p>>2]=f[G>>2];f[w+12>>2]=f[r+12>>2];G=w+16|0;n=r+16|0;f[G>>2]=f[n>>2];f[w+20>>2]=f[r+20>>2];f[w+24>>2]=f[r+24>>2];f[w+28>>2]=f[r+28>>2];f[w+32>>2]=f[r+32>>2];D=w+36|0;h=r+36|0;g=f[h>>2]|0;f[D>>2]=g;W=w+40|0;f[W>>2]=p;p=w+48|0;F=w+44|0;f[F>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(!g)Z=j;else{j=g+12|0;f[j>>2]=(f[j>>2]|0)+1;Z=f[C>>2]|0}if((Z|0)<3){Z=f[L>>2]|0;j=f[F>>2]|0;f[j>>2]=f[Z>>2];f[j+4>>2]=f[Z+4>>2]}else{f[k>>2]=0;ZS(w,r)}f[x>>2]=f[s>>2];Z=x+4|0;j=f[M>>2]|0;f[Z>>2]=j;g=x+8|0;f[g>>2]=f[N>>2];f[x+12>>2]=f[s+12>>2];N=x+16|0;Y=s+16|0;f[N>>2]=f[Y>>2];f[x+20>>2]=f[s+20>>2];f[x+24>>2]=f[s+24>>2];f[x+28>>2]=f[s+28>>2];f[x+32>>2]=f[s+32>>2];d=x+36|0;A=s+36|0;c=f[A>>2]|0;f[d>>2]=c;X=x+40|0;f[X>>2]=g;g=x+48|0;E=x+44|0;f[E>>2]=g;f[g>>2]=0;f[x+52>>2]=0;if(!c)_=j;else{j=c+12|0;f[j>>2]=(f[j>>2]|0)+1;_=f[M>>2]|0}if((_|0)<3){_=f[Q>>2]|0;j=f[E>>2]|0;f[j>>2]=f[_>>2];f[j+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;ZS(x,s)}f[y>>2]=f[t>>2];_=y+4|0;j=f[R>>2]|0;f[_>>2]=j;c=y+8|0;f[c>>2]=f[S>>2];f[y+12>>2]=f[t+12>>2];S=y+16|0;b=t+16|0;f[S>>2]=f[b>>2];f[y+20>>2]=f[t+20>>2];f[y+24>>2]=f[t+24>>2];f[y+28>>2]=f[t+28>>2];f[y+32>>2]=f[t+32>>2];B=y+36|0;a=t+36|0;V=f[a>>2]|0;f[B>>2]=V;m=y+40|0;f[m>>2]=c;c=y+48|0;U=y+44|0;f[U>>2]=c;f[c>>2]=0;f[y+52>>2]=0;if(!V)$=j;else{j=V+12|0;f[j>>2]=(f[j>>2]|0)+1;$=f[R>>2]|0}if(($|0)<3){$=f[J>>2]|0;j=f[U>>2]|0;f[j>>2]=f[$>>2];f[j+4>>2]=f[$+4>>2]}else{f[_>>2]=0;ZS(y,t)}f[z>>2]=f[v>>2];$=z+4|0;j=v+4|0;V=f[j>>2]|0;f[$>>2]=V;l=z+8|0;f[l>>2]=f[v+8>>2];f[z+12>>2]=f[v+12>>2];aa=z+16|0;ba=v+16|0;f[aa>>2]=f[ba>>2];f[z+20>>2]=f[v+20>>2];f[z+24>>2]=f[v+24>>2];f[z+28>>2]=f[v+28>>2];f[z+32>>2]=f[v+32>>2];ca=z+36|0;da=v+36|0;ea=f[da>>2]|0;f[ca>>2]=ea;fa=z+40|0;f[fa>>2]=l;l=z+48|0;ga=z+44|0;f[ga>>2]=l;f[l>>2]=0;f[z+52>>2]=0;if(!ea)ha=V;else{V=ea+12|0;f[V>>2]=(f[V>>2]|0)+1;ha=f[j>>2]|0}if((ha|0)<3){ha=f[v+44>>2]|0;V=f[ga>>2]|0;f[V>>2]=f[ha>>2];f[V+4>>2]=f[ha+4>>2]}else{f[$>>2]=0;ZS(z,v)}yN(w,x,e,y,i,z,o);o=f[ca>>2]|0;if(o|0?(ha=o+12|0,o=f[ha>>2]|0,f[ha>>2]=o+-1,(o|0)==1):0)_S(z);f[ca>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[fa>>2]|0;fa=0;do{f[aa+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[$>>2]|0))}$=f[ga>>2]|0;if(($|0)!=(l|0))g0($);$=f[B>>2]|0;if($|0?(l=$+12|0,$=f[l>>2]|0,f[l>>2]=$+-1,($|0)==1):0)_S(y);f[B>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[_>>2]|0)>0){S=f[m>>2]|0;m=0;do{f[S+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[_>>2]|0))}_=f[U>>2]|0;if((_|0)!=(c|0))g0(_);_=f[d>>2]|0;if(_|0?(c=_+12|0,_=f[c>>2]|0,f[c>>2]=_+-1,(_|0)==1):0)_S(x);f[d>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Z>>2]|0)>0){N=f[X>>2]|0;X=0;do{f[N+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[Z>>2]|0))}Z=f[E>>2]|0;if((Z|0)!=(g|0))g0(Z);Z=f[D>>2]|0;do if(Z|0){g=Z+12|0;E=f[g>>2]|0;f[g>>2]=E+-1;if((E|0)!=1)break;_S(w)}while(0);f[D>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[k>>2]|0)>0){G=f[W>>2]|0;W=0;do{f[G+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[k>>2]|0))}k=f[F>>2]|0;if((k|0)!=(p|0))g0(k);k=f[da>>2]|0;do if(k|0){p=k+12|0;F=f[p>>2]|0;f[p>>2]=F+-1;if((F|0)!=1)break;_S(v)}while(0);f[da>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[j>>2]|0)>0){ba=f[v+40>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))g0(j);j=f[a>>2]|0;do if(j|0){v=j+12|0;da=f[v>>2]|0;f[v>>2]=da+-1;if((da|0)!=1)break;_S(t)}while(0);f[a>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[R>>2]|0)>0){b=f[T>>2]|0;T=0;do{f[b+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[J>>2]|0;if((R|0)!=(I|0))g0(R);R=f[A>>2]|0;do if(R|0){I=R+12|0;J=f[I>>2]|0;f[I>>2]=J+-1;if((J|0)!=1)break;_S(s)}while(0);f[A>>2]=0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[M>>2]|0)>0){Y=f[O>>2]|0;O=0;do{f[Y+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))g0(M);M=f[h>>2]|0;do if(M|0){P=M+12|0;Q=f[P>>2]|0;f[P>>2]=Q+-1;if((Q|0)!=1)break;_S(r)}while(0);f[h>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[H>>2]|0;H=0;do{f[n+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[C>>2]|0))}C=f[L>>2]|0;if((C|0)==(K|0)){u=q;return}g0(C);u=q;return}function MN(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;j=u;u=u+352|0;k=j+336|0;l=j+280|0;m=j+224|0;n=j+168|0;o=j+112|0;p=j+56|0;q=j;do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[l>>2]=f[r>>2];s=l+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=l+8|0;f[v>>2]=f[r+8>>2];f[l+12>>2]=f[r+12>>2];f[l+16>>2]=f[r+16>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[l+36>>2]=w;f[l+40>>2]=v;v=l+48|0;x=l+44|0;f[x>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;ZS(l,r);break}}else a$(l,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];r=m+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=m+8|0;f[t>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=t;t=m+48|0;x=m+44|0;f[x>>2]=t;f[t>>2]=0;f[m+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;ZS(m,a);break}}else a$(m,c,-1);while(0);do if(g!=0.0){if((d$(e)|0)!=65536){a$(n,e,-1);break}c=f[e+4>>2]|0;f[n>>2]=f[c>>2];a=n+4|0;r=c+4|0;f[a>>2]=f[r>>2];s=n+8|0;f[s>>2]=f[c+8>>2];f[n+12>>2]=f[c+12>>2];f[n+16>>2]=f[c+16>>2];f[n+20>>2]=f[c+20>>2];f[n+24>>2]=f[c+24>>2];f[n+28>>2]=f[c+28>>2];f[n+32>>2]=f[c+32>>2];t=f[c+36>>2]|0;f[n+36>>2]=t;f[n+40>>2]=s;s=n+48|0;x=n+44|0;f[x>>2]=s;f[s>>2]=0;f[n+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[c+44>>2]|0;s=f[x>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[a>>2]=0;ZS(n,c);break}}else{f[n>>2]=1124007936;c=n+8|0;a=n+40|0;y=n+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[a>>2]=c;r=n+48|0;f[n+44>>2]=r;f[r>>2]=0;f[n+52>>2]=0}while(0);e=l+40|0;r=f[e>>2]|0;s=f[r+4>>2]|0;x=f[r>>2]|0;r=f[l>>2]|0;t=r&4095;if((t|0)!=(f[m>>2]&4095|0)){f[k>>2]=0;f[k+4>>2]=0;y=tT(k,16)|0;A=212713;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));z5(-215,k,212730,212648,1558)}if(((r&4087)+-5|0)>>>0>=2){f[k>>2]=0;f[k+4>>2]=0;dJc(tT(k,210)|0,212735,210)|0;z5(-215,k,212730,212648,1558)}switch(i&3){case 0:{if((s|0)==(f[m+8>>2]|0)){B=f[m+12>>2]|0;C=x}else{f[k>>2]=0;f[k+4>>2]=0;y=tT(k,19)|0;A=212946;z=y+19|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));z5(-215,k,212730,212648,1565)}break}case 1:{if((x|0)==(f[m+8>>2]|0)){B=f[m+12>>2]|0;C=s}else{f[k>>2]=0;f[k+4>>2]=0;y=tT(k,20)|0;A=212966;z=y+20|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));z5(-215,k,212730,212648,1570)}break}case 2:{if((s|0)==(f[m+12>>2]|0)){B=f[m+8>>2]|0;C=x}else{f[k>>2]=0;f[k+4>>2]=0;y=tT(k,19)|0;A=212946;z=y+19|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));z5(-215,k,212730,212648,1575)}break}case 3:{if((x|0)==(f[m+12>>2]|0)){B=f[m+8>>2]|0;C=s}else{f[k>>2]=0;f[k+4>>2]=0;y=tT(k,20)|0;A=212966;z=y+20|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));z5(-215,k,212730,212648,1580)}break}default:{}}v=n+16|0;do if(f[v>>2]|0){w=f[n+4>>2]|0;if((w|0)<3)D=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{E=f[n+40>>2]|0;F=0;G=1;while(1){H=Y(f[E+(F<<2)>>2]|0,G)|0;F=F+1|0;if((F|0)==(w|0)){D=H;break}else G=H}}if(!((w|0)==0|(D|0)==0)){if((f[n>>2]&4095|0)!=(t|0)){f[k>>2]=0;f[k+4>>2]=0;y=tT(k,16)|0;A=212987;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));z5(-215,k,212730,212648,1588)}w=f[n+8>>2]|0;if(!(i&4)){if((w|0)!=(C|0)){f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,158)|0;dJc(J|0,213004,158)|0;z5(-215,k,212730,212648,1588)}if((f[n+12>>2]|0)==(B|0))break;f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,158)|0;dJc(J|0,213004,158)|0;z5(-215,k,212730,212648,1588)}else{if((w|0)!=(B|0)){f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,158)|0;dJc(J|0,213004,158)|0;z5(-215,k,212730,212648,1588)}if((f[n+12>>2]|0)==(C|0))break;f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,158)|0;dJc(J|0,213004,158)|0;z5(-215,k,212730,212648,1588)}}}while(0);Y$(h,C,B,t,-1,0,0);do if((d$(h)|0)==65536){t=f[h+4>>2]|0;f[o>>2]=f[t>>2];J=o+4|0;I=t+4|0;f[J>>2]=f[I>>2];D=o+8|0;f[D>>2]=f[t+8>>2];f[o+12>>2]=f[t+12>>2];f[o+16>>2]=f[t+16>>2];f[o+20>>2]=f[t+20>>2];f[o+24>>2]=f[t+24>>2];f[o+28>>2]=f[t+28>>2];f[o+32>>2]=f[t+32>>2];w=f[t+36>>2]|0;f[o+36>>2]=w;f[o+40>>2]=D;D=o+48|0;G=o+44|0;f[G>>2]=D;f[D>>2]=0;f[o+52>>2]=0;if(w|0){D=w+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[I>>2]|0)<3){I=f[t+44>>2]|0;D=f[G>>2]|0;f[D>>2]=f[I>>2];f[D+4>>2]=f[I+4>>2];break}else{f[J>>2]=0;ZS(o,t);break}}else a$(o,h,-1);while(0);if(i&4){h=o+16|0;if((f[v>>2]|0)==(f[h>>2]|0)){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=n;t=p+8|0;f[t>>2]=0;f[t+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=n;jR(k,p);K=i&-5;L=h}else{K=i;L=h}}else{K=i;L=o+16|0}f[p>>2]=1124007936;i=p+4|0;h=p+8|0;t=p+40|0;y=i;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[t>>2]=h;J=p+48|0;I=p+44|0;f[I>>2]=J;f[J>>2]=0;f[p+52>>2]=0;D=f[L>>2]|0;G=l+16|0;if((D|0)!=(f[G>>2]|0)?(D|0)!=(f[m+16>>2]|0):0)M=o;else{D=f[o>>2]&4095;f[q>>2]=1124007936;w=q+4|0;F=q+8|0;E=q+40|0;y=w;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[E>>2]=F;c=q+48|0;a=q+44|0;f[a>>2]=c;f[c>>2]=0;f[q+52>>2]=0;f[k>>2]=C;f[k+4>>2]=B;XS(q,2,k,D);D=q+36|0;B=f[D>>2]|0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}C=p+36|0;B=f[C>>2]|0;if(B|0?(H=B+12|0,B=f[H>>2]|0,f[H>>2]=B+-1,(B|0)==1):0)_S(p);f[C>>2]=0;B=p+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[i>>2]|0)>0){H=f[t>>2]|0;N=0;do{f[H+(N<<2)>>2]=0;N=N+1|0;O=f[i>>2]|0}while((N|0)<(O|0));f[p>>2]=f[q>>2];if((O|0)<3)P=75;else P=77}else{f[p>>2]=f[q>>2];P=75}if((P|0)==75){O=f[w>>2]|0;if((O|0)<3){f[i>>2]=O;f[h>>2]=f[F>>2];f[p+12>>2]=f[q+12>>2];F=f[a>>2]|0;h=f[I>>2]|0;f[h>>2]=f[F>>2];f[h+4>>2]=f[F+4>>2]}else P=77}if((P|0)==77)ZS(p,q);P=q+16|0;f[B>>2]=f[P>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2];f[p+32>>2]=f[q+32>>2];B=f[D>>2]|0;f[C>>2]=B;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)_S(q);f[D>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[w>>2]|0)>0){P=f[E>>2]|0;E=0;do{f[P+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[w>>2]|0))}w=f[a>>2]|0;if((w|0)!=(c|0))g0(w);M=p}switch(r&4095){case 5:{xN(f[G>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[M+16>>2]|0,f[M+48>>2]|0,x,s,f[M+12>>2]|0,K,5);break}case 6:{LN(f[G>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[M+16>>2]|0,f[M+48>>2]|0,x,s,f[M+12>>2]|0,K,6);break}case 13:{xN(f[G>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[M+16>>2]|0,f[M+48>>2]|0,x,s,f[M+12>>2]|0,K,13);break}case 14:{LN(f[G>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[L>>2]|0,f[o+48>>2]|0,x,s,f[M+12>>2]|0,K,14);break}default:{f[k>>2]=0;f[k+4>>2]=0;y=tT(k,16)|0;A=212622;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));z5(-215,k,212730,212648,1623)}}if((M|0)!=(o|0)){A=k+8|0;f[A>>2]=0;f[A+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=o;h_(M,k)}k=p+36|0;M=f[k>>2]|0;if(M|0?(A=M+12|0,M=f[A>>2]|0,f[A>>2]=M+-1,(M|0)==1):0)_S(p);f[k>>2]=0;k=p+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[t>>2]|0;t=0;do{f[k+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}i=f[I>>2]|0;if((i|0)!=(J|0))g0(i);i=o+36|0;J=f[i>>2]|0;if(J|0?(I=J+12|0,J=f[I>>2]|0,f[I>>2]=J+-1,(J|0)==1):0)_S(o);f[i>>2]=0;i=o+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[i>>2]|0)>0){L=f[o+40>>2]|0;J=0;do{f[L+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[i>>2]|0))}i=f[o+44>>2]|0;if((i|0)!=(o+48|0))g0(i);i=n+36|0;o=f[i>>2]|0;if(o|0?(J=o+12|0,o=f[J>>2]|0,f[J>>2]=o+-1,(o|0)==1):0)_S(n);f[i>>2]=0;i=n+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[i>>2]|0)>0){v=f[n+40>>2]|0;o=0;do{f[v+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))g0(i);i=m+36|0;n=f[i>>2]|0;do if(n|0){o=n+12|0;v=f[o>>2]|0;f[o>>2]=v+-1;if((v|0)!=1)break;_S(m)}while(0);f[i>>2]=0;i=m+16|0;n=m+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[n>>2]|0)>0){i=f[m+40>>2]|0;v=0;do{f[i+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))g0(n);n=l+36|0;m=f[n>>2]|0;do if(m|0){v=m+12|0;i=f[v>>2]|0;f[v>>2]=i+-1;if((i|0)!=1)break;_S(l)}while(0);f[n>>2]=0;n=l+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[n>>2]|0)>0){G=f[e>>2]|0;e=0;do{f[G+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)==(l+48|0)){u=j;return}g0(n);u=j;return}function NN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0;e=u;u=u+1408|0;g=e+1392|0;h=e+1096|0;i=e+1336|0;j=e+1280|0;k=e+1272|0;l=e+1216|0;m=e;o=e+1160|0;q=e+1104|0;do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[i>>2]=f[r>>2];s=i+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=i+8|0;f[v>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[i+28>>2]=f[r+28>>2];f[i+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=v;v=i+48|0;x=i+44|0;f[x>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;ZS(i,r);break}}else a$(i,a,-1);while(0);do if((d$(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];r=j+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[a+8>>2];v=j+12|0;f[v>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[j+36>>2]=x;f[j+40>>2]=t;w=j+48|0;y=j+44|0;f[y>>2]=w;f[w>>2]=0;f[j+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[s>>2];f[w+4>>2]=f[s+4>>2];z=v;A=t;break}else{f[r>>2]=0;ZS(j,a);z=v;A=t;break}}else{a$(j,d,-1);z=j+12|0;A=j+8|0}while(0);d=f[i>>2]|0;t=d&7;v=d>>>3&511;d=v+1|0;a=f[A>>2]|0;r=f[z>>2]|0;s=v+2|0;if(!((d|0)==(r|0)|(s|0)==(r|0))){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,34)|0;C=213163;D=B+34|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,g,213198,212648,2090)}r=i+40|0;w=f[r>>2]|0;y=f[w>>2]|0;f[k>>2]=f[w+4>>2];f[k+4>>2]=y;v$(c,k,(a<<3)+-8|t,-1,0,0);do if((d$(c)|0)==65536){k=f[c+4>>2]|0;f[l>>2]=f[k>>2];y=l+4|0;w=k+4|0;f[y>>2]=f[w>>2];x=l+8|0;f[x>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];E=f[k+36>>2]|0;f[l+36>>2]=E;f[l+40>>2]=x;x=l+48|0;F=l+44|0;f[F>>2]=x;f[x>>2]=0;f[l+52>>2]=0;if(E|0){x=E+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[k+44>>2]|0;x=f[F>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[y>>2]=0;ZS(l,k);break}}else a$(l,c,-1);while(0);c=(t|2|0)==6;k=c?6:5;y=m+8|0;f[m>>2]=y;w=m+4|0;f[w>>2]=136;x=f[j>>2]|0;if((f[z>>2]|0)==(s|0)&((x&16384|0)!=0&(x&4095|0)==(k|0)))G=f[j+16>>2]|0;else{x=Y(s,a)|0;f[w>>2]=x;if(x>>>0>136){F=XDc(x>>>0>536870911?-1:x<<3)|0;f[m>>2]=F;H=F}else H=y;Vj(o,a,s,k,H,0);F=o+16|0;x=f[F>>2]|0;E=o+44|0;I=o+4|0;J=f[I>>2]|0;if((J|0)<3)K=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{M=f[o+40>>2]|0;N=0;O=1;while(1){P=Y(f[M+(N<<2)>>2]|0,O)|0;N=N+1|0;if((N|0)==(J|0)){K=P;break}else O=P}}if((J|0)>0)Q=f[(f[E>>2]|0)+(J+-1<<2)>>2]|0;else Q=0;XIc(x|0,0,Y(Q,K)|0)|0;K=f[z>>2]|0;if((K|0)!=(s|0)){f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=K;$S(q,o,g,h);K=g+8|0;f[K>>2]=0;f[K+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=q;LZ(j,g,k,1.0,0.0);K=q+36|0;s=f[K>>2]|0;if(s|0?(Q=s+12|0,s=f[Q>>2]|0,f[Q>>2]=s+-1,(s|0)==1):0)_S(q);f[K>>2]=0;K=q+16|0;s=q+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[s>>2]|0)>0){K=f[q+40>>2]|0;Q=0;do{f[K+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)!=(q+48|0))g0(s)}else{s=g+8|0;f[s>>2]=0;f[s+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o;LZ(j,g,k,1.0,0.0)}k=o+36|0;s=f[k>>2]|0;if(s|0){q=s+12|0;f[q>>2]=(f[q>>2]|0)+1}q=j+36|0;s=f[q>>2]|0;if(s|0?(Q=s+12|0,s=f[Q>>2]|0,f[Q>>2]=s+-1,(s|0)==1):0)_S(j);f[q>>2]=0;s=j+16|0;Q=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[Q>>2]|0)>0){K=f[j+40>>2]|0;x=0;do{f[K+(x<<2)>>2]=0;x=x+1|0;R=f[Q>>2]|0}while((x|0)<(R|0));f[j>>2]=f[o>>2];if((R|0)<3)S=54;else S=56}else{f[j>>2]=f[o>>2];S=54}if((S|0)==54){R=f[I>>2]|0;if((R|0)<3){f[Q>>2]=R;f[A>>2]=f[o+8>>2];f[z>>2]=f[o+12>>2];A=f[E>>2]|0;R=f[j+44>>2]|0;f[R>>2]=f[A>>2];f[R+4>>2]=f[A+4>>2]}else S=56}if((S|0)==56)ZS(j,o);f[s>>2]=f[F>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];s=f[k>>2]|0;f[q>>2]=s;if(s|0?(q=s+12|0,s=f[q>>2]|0,f[q>>2]=s+-1,(s|0)==1):0)_S(o);f[k>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[I>>2]|0)>0){F=f[o+40>>2]|0;k=0;do{f[F+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[I>>2]|0))}I=f[E>>2]|0;if((I|0)!=(o+48|0))g0(I);G=H}a:do if((d|0)==(a|0)){T=c?2.220446049250313e-16:1.1920928955078125e-07;H=f[j+16>>2]|0;if(v|0){I=f[f[j+44>>2]>>2]|0;if(c){E=0;while(1){k=H+(Y(I,E)|0)|0;F=0;while(1){if((E|0)!=(F|0)?+L(+(+p[k+(F<<3)>>3]))>T:0){U=41372;S=96;break a}if((F|0)<(v|0))F=F+1|0;else break}if((E|0)<(v|0))E=E+1|0;else{U=41404;S=96;break a}}}else{E=0;while(1){F=H+(Y(I,E)|0)|0;k=0;while(1){if((E|0)!=(k|0)?+L(+(+n[F+(k<<2)>>2]))>T:0){U=41372;S=96;break a}if((k|0)<(v|0))k=k+1|0;else break}if((E|0)<(v|0))E=E+1|0;else{U=41404;S=96;break a}}}}if(c){T=+p[H>>3];do if((f[j>>2]&16384|0)==0?(E=f[j+40>>2]|0,(f[E>>2]|0)!=1):0){I=f[f[j+44>>2]>>2]|0;if((f[E+4>>2]|0)==1){V=H+I|0;break}else{E=f[z>>2]|0;k=(E+1|0)>>>0<3?E:0;V=H+(Y(k,I)|0)+(1-(Y(k,E)|0)<<3)|0;break}}else S=85;while(0);if((S|0)==85)V=H+8|0;W=+p[V>>3];X=T}else{Z=+n[H>>2];do if((f[j>>2]&16384|0)==0?(E=f[j+40>>2]|0,(f[E>>2]|0)!=1):0){k=f[f[j+44>>2]>>2]|0;if((f[E+4>>2]|0)==1){_=H+k|0;break}else{E=f[z>>2]|0;I=(E+1|0)>>>0<3?E:0;_=H+(Y(I,k)|0)+(1-(Y(I,E)|0)<<2)|0;break}}else S=78;while(0);if((S|0)==78)_=H+4|0;W=+n[_>>2];X=Z}E=g+8|0;f[E>>2]=0;f[E+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=l;LZ(i,g,f[l>>2]&4095,X,W)}else{U=41372;S=96}while(0);if((S|0)==96){S=f[U+(t<<2)>>2]|0;if(!S){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,9)|0;C=251213;D=B+9|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,g,213198,212648,2146)}f[g>>2]=i;f[g+4>>2]=l;f[g+8>>2]=0;C=h;f[C>>2]=0;f[C+4>>2]=0;z2(o,g,h,-1);g=f[o+20>>2]|0;C=o+16|0;B=h+4|0;D=0;while(1){if(D>>>0>=(f[C>>2]|0)>>>0)break;Fh[S&255](f[h>>2]|0,f[B>>2]|0,G,g,d,a);A2(o)|0;D=D+1|0}}D=f[m>>2]|0;if((D|0)!=(y|0)){if(D|0)ZDc(D);f[m>>2]=y;f[w>>2]=136}w=l+36|0;y=f[w>>2]|0;if(y|0?(m=y+12|0,y=f[m>>2]|0,f[m>>2]=y+-1,(y|0)==1):0)_S(l);f[w>>2]=0;w=l+16|0;y=l+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[y>>2]|0)>0){w=f[l+40>>2]|0;m=0;do{f[w+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[y>>2]|0))}y=f[l+44>>2]|0;if((y|0)!=(l+48|0))g0(y);y=j+36|0;l=f[y>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)_S(j);f[y>>2]=0;y=j+16|0;l=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[l>>2]|0)>0){y=f[j+40>>2]|0;m=0;do{f[y+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))g0(l);l=i+36|0;j=f[l>>2]|0;if(j|0?(m=j+12|0,j=f[m>>2]|0,f[m>>2]=j+-1,(j|0)==1):0)_S(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[r>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=e;return}g0(j);u=e;return}function ON(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;i=d+8|0;j=d+16|0;k=d+20|0;l=0;do{m=mrc(+n[i>>2]+ +n[d>>2]*+(h[a+l>>0]|0))|0;o=l|1;p=mrc(+n[k>>2]+ +n[j>>2]*+(h[a+o>>0]|0))|0;b[c+l>>0]=m>>>0<256?m:(m|0)>0?255:0;b[c+o>>0]=p>>>0<256?p:(p|0)>0?255:0;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;l=d+12|0;j=d+20|0;k=d+28|0;i=d+40|0;p=d+44|0;o=0;do{m=mrc(+n[l>>2]+ +n[d>>2]*+(h[a+o>>0]|0))|0;q=o+1|0;r=mrc(+n[k>>2]+ +n[j>>2]*+(h[a+q>>0]|0))|0;s=o+2|0;t=mrc(+n[p>>2]+ +n[i>>2]*+(h[a+s>>0]|0))|0;b[c+o>>0]=m>>>0<256?m:(m|0)>0?255:0;b[c+q>>0]=r>>>0<256?r:(r|0)>0?255:0;b[c+s>>0]=t>>>0<256?t:(t|0)>0?255:0;o=o+3|0}while((o|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;o=d+16|0;i=d+24|0;p=d+36|0;j=d+48|0;k=d+56|0;l=d+72|0;t=d+76|0;s=0;do{r=mrc(+n[o>>2]+ +n[d>>2]*+(h[a+s>>0]|0))|0;q=s|1;m=mrc(+n[p>>2]+ +n[i>>2]*+(h[a+q>>0]|0))|0;b[c+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[c+q>>0]=m>>>0<256?m:(m|0)>0?255:0;m=s|2;q=mrc(+n[k>>2]+ +n[j>>2]*+(h[a+m>>0]|0))|0;r=s|3;u=mrc(+n[t>>2]+ +n[l>>2]*+(h[a+r>>0]|0))|0;b[c+m>>0]=q>>>0<256?q:(q|0)>0?255:0;b[c+r>>0]=u>>>0<256?u:(u|0)>0?255:0;s=s+4|0}while((s|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){v=a;w=c;x=0}else return;while(1){c=d;a=0;while(1){s=mrc(+(h[v+a>>0]|0)*+n[c+(a<<2)>>2]+ +n[c+(f<<2)>>2])|0;b[w+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0;if((a|0)==(f|0))break;else c=c+(g<<2)|0}x=x+1|0;if((x|0)==(e|0))break;else{v=v+f|0;w=w+f|0}}return}}}function PN(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=d+8|0;i=d+16|0;j=d+20|0;k=0;do{l=mrc(+n[h>>2]+ +n[d>>2]*+(b[a+k>>0]|0))|0;m=k|1;o=mrc(+n[j>>2]+ +n[i>>2]*+(b[a+m>>0]|0))|0;b[c+k>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[c+m>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;k=k+2|0}while((k|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;k=d+12|0;i=d+20|0;j=d+28|0;h=d+40|0;o=d+44|0;m=0;do{l=mrc(+n[k>>2]+ +n[d>>2]*+(b[a+m>>0]|0))|0;p=m+1|0;q=mrc(+n[j>>2]+ +n[i>>2]*+(b[a+p>>0]|0))|0;r=m+2|0;s=mrc(+n[o>>2]+ +n[h>>2]*+(b[a+r>>0]|0))|0;b[c+m>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[c+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[c+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;m=m+3|0}while((m|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;m=d+16|0;h=d+24|0;o=d+36|0;i=d+48|0;j=d+56|0;k=d+72|0;s=d+76|0;r=0;do{q=mrc(+n[m>>2]+ +n[d>>2]*+(b[a+r>>0]|0))|0;p=r|1;l=mrc(+n[o>>2]+ +n[h>>2]*+(b[a+p>>0]|0))|0;b[c+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[c+p>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;l=r|2;p=mrc(+n[j>>2]+ +n[i>>2]*+(b[a+l>>0]|0))|0;q=r|3;t=mrc(+n[s>>2]+ +n[k>>2]*+(b[a+q>>0]|0))|0;b[c+l>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;b[c+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;r=r+4|0}while((r|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){u=a;v=c;w=0}else return;while(1){c=d;a=0;while(1){r=mrc(+(b[u+a>>0]|0)*+n[c+(a<<2)>>2]+ +n[c+(f<<2)>>2])|0;b[v+a>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;a=a+1|0;if((a|0)==(f|0))break;else c=c+(g<<2)|0}w=w+1|0;if((w|0)==(e|0))break;else{u=u+f|0;v=v+f|0}}return}}}function QN(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=+n[c>>2];i=+n[c+8>>2];k=+n[c+16>>2];l=+n[c+20>>2];m=0;do{o=mrc(i+h*+(j[a+(m<<1)>>1]|0))|0;p=m|1;q=mrc(l+k*+(j[a+(p<<1)>>1]|0))|0;d[b+(m<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;d[b+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;m=m+2|0}while((m|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;k=+n[c>>2];l=+n[c+12>>2];h=+n[c+20>>2];i=+n[c+28>>2];r=+n[c+40>>2];s=+n[c+44>>2];m=0;do{q=mrc(l+k*+(j[a+(m<<1)>>1]|0))|0;p=m+1|0;o=mrc(i+h*+(j[a+(p<<1)>>1]|0))|0;t=m+2|0;u=mrc(s+r*+(j[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[b+(p<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;d[b+(t<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;m=m+3|0}while((m|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;r=+n[c>>2];s=+n[c+16>>2];h=+n[c+24>>2];i=+n[c+36>>2];k=+n[c+48>>2];l=+n[c+56>>2];v=+n[c+72>>2];w=+n[c+76>>2];m=0;do{u=mrc(s+r*+(j[a+(m<<1)>>1]|0))|0;t=m|1;o=mrc(i+h*+(j[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[b+(t<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=m|2;t=mrc(l+k*+(j[a+(o<<1)>>1]|0))|0;u=m|3;p=mrc(w+v*+(j[a+(u<<1)>>1]|0))|0;d[b+(o<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[b+(u<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;m=m+4|0}while((m|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){x=a;y=b;z=0}else return;while(1){b=c;a=0;while(1){m=mrc(+(j[x+(a<<1)>>1]|0)*+n[b+(a<<2)>>2]+ +n[b+(f<<2)>>2])|0;d[y+(a<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;a=a+1|0;if((a|0)==(f|0))break;else b=b+(g<<2)|0}z=z+1|0;if((z|0)==(e|0))break;else{x=x+(f<<1)|0;y=y+(f<<1)|0}}return}}}function RN(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0.0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=+n[c>>2];i=+n[c+8>>2];j=+n[c+16>>2];k=+n[c+20>>2];l=0;do{m=mrc(i+h*+(d[a+(l<<1)>>1]|0))|0;o=l|1;p=mrc(k+j*+(d[a+(o<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[b+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;j=+n[c>>2];k=+n[c+12>>2];h=+n[c+20>>2];i=+n[c+28>>2];q=+n[c+40>>2];r=+n[c+44>>2];l=0;do{p=mrc(k+j*+(d[a+(l<<1)>>1]|0))|0;o=l+1|0;m=mrc(i+h*+(d[a+(o<<1)>>1]|0))|0;s=l+2|0;t=mrc(r+q*+(d[a+(s<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[b+(o<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;l=l+3|0}while((l|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;q=+n[c>>2];r=+n[c+16>>2];h=+n[c+24>>2];i=+n[c+36>>2];j=+n[c+48>>2];k=+n[c+56>>2];u=+n[c+72>>2];v=+n[c+76>>2];l=0;do{t=mrc(r+q*+(d[a+(l<<1)>>1]|0))|0;s=l|1;m=mrc(i+h*+(d[a+(s<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[b+(s<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=l|2;s=mrc(k+j*+(d[a+(m<<1)>>1]|0))|0;t=l|3;o=mrc(v+u*+(d[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+(t<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;l=l+4|0}while((l|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){w=a;x=b;y=0}else return;while(1){b=c;a=0;while(1){l=mrc(+(d[w+(a<<1)>>1]|0)*+n[b+(a<<2)>>2]+ +n[b+(f<<2)>>2])|0;d[x+(a<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;a=a+1|0;if((a|0)==(f|0))break;else b=b+(g<<2)|0}y=y+1|0;if((y|0)==(e|0))break;else{w=w+(f<<1)|0;x=x+(f<<1)|0}}return}}}function SN(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0;switch(e|0){case 2:{g=d<<1;if((d|0)<=0)return;h=+p[c>>3];i=+p[c+16>>3];j=+p[c+32>>3];k=+p[c+40>>3];l=0;do{m=nrc(i+h*+(f[a+(l<<2)>>2]|0))|0;n=l|1;o=nrc(k+j*+(f[a+(n<<2)>>2]|0))|0;f[b+(l<<2)>>2]=m;f[b+(n<<2)>>2]=o;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=d*3|0;if((d|0)<=0)return;j=+p[c>>3];k=+p[c+24>>3];h=+p[c+40>>3];i=+p[c+56>>3];q=+p[c+80>>3];r=+p[c+88>>3];l=0;do{o=nrc(k+j*+(f[a+(l<<2)>>2]|0))|0;n=l+1|0;m=nrc(i+h*+(f[a+(n<<2)>>2]|0))|0;s=l+2|0;t=nrc(r+q*+(f[a+(s<<2)>>2]|0))|0;f[b+(l<<2)>>2]=o;f[b+(n<<2)>>2]=m;f[b+(s<<2)>>2]=t;l=l+3|0}while((l|0)<(g|0));return}case 4:{g=d<<2;if((d|0)<=0)return;q=+p[c>>3];r=+p[c+32>>3];h=+p[c+48>>3];i=+p[c+72>>3];j=+p[c+96>>3];k=+p[c+112>>3];u=+p[c+144>>3];v=+p[c+152>>3];l=0;do{t=nrc(r+q*+(f[a+(l<<2)>>2]|0))|0;s=l|1;m=nrc(i+h*+(f[a+(s<<2)>>2]|0))|0;f[b+(l<<2)>>2]=t;f[b+(s<<2)>>2]=m;m=l|2;s=nrc(k+j*+(f[a+(m<<2)>>2]|0))|0;t=l|3;n=nrc(v+u*+(f[a+(t<<2)>>2]|0))|0;f[b+(m<<2)>>2]=s;f[b+(t<<2)>>2]=n;l=l+4|0}while((l|0)<(g|0));return}default:{if((d|0)<=0)return;g=e+1|0;if((e|0)>0){w=a;x=b;y=0}else return;while(1){b=c;a=0;while(1){l=nrc(+(f[w+(a<<2)>>2]|0)*+p[b+(a<<3)>>3]+ +p[b+(e<<3)>>3])|0;f[x+(a<<2)>>2]=l;a=a+1|0;if((a|0)==(e|0))break;else b=b+(g<<3)|0}y=y+1|0;if((y|0)==(d|0))break;else{w=w+(e<<2)|0;x=x+(e<<2)|0}}return}}}function TN(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0;switch(e|0){case 2:{f=d<<1;if((d|0)<=0)return;g=c+8|0;h=c+16|0;i=c+20|0;j=0;do{k=j|1;l=+n[h>>2]*+n[a+(k<<2)>>2]+ +n[i>>2];n[b+(j<<2)>>2]=+n[c>>2]*+n[a+(j<<2)>>2]+ +n[g>>2];n[b+(k<<2)>>2]=l;j=j+2|0}while((j|0)<(f|0));return}case 3:{f=d*3|0;if((d|0)<=0)return;j=c+12|0;g=c+20|0;i=c+28|0;h=c+40|0;k=c+44|0;m=0;do{o=m+1|0;l=+n[g>>2]*+n[a+(o<<2)>>2]+ +n[i>>2];p=m+2|0;q=+n[h>>2]*+n[a+(p<<2)>>2]+ +n[k>>2];n[b+(m<<2)>>2]=+n[c>>2]*+n[a+(m<<2)>>2]+ +n[j>>2];n[b+(o<<2)>>2]=l;n[b+(p<<2)>>2]=q;m=m+3|0}while((m|0)<(f|0));return}case 4:{f=d<<2;if((d|0)<=0)return;m=c+16|0;j=c+24|0;k=c+36|0;h=c+48|0;i=c+56|0;g=c+72|0;p=c+76|0;o=0;do{r=o|1;q=+n[j>>2]*+n[a+(r<<2)>>2]+ +n[k>>2];n[b+(o<<2)>>2]=+n[c>>2]*+n[a+(o<<2)>>2]+ +n[m>>2];n[b+(r<<2)>>2]=q;r=o|2;s=o|3;q=+n[g>>2]*+n[a+(s<<2)>>2]+ +n[p>>2];n[b+(r<<2)>>2]=+n[h>>2]*+n[a+(r<<2)>>2]+ +n[i>>2];n[b+(s<<2)>>2]=q;o=o+4|0}while((o|0)<(f|0));return}default:{if((d|0)<=0)return;f=e+1|0;if((e|0)>0){t=a;u=b;v=0}else return;while(1){b=c;a=0;while(1){n[u+(a<<2)>>2]=+n[t+(a<<2)>>2]*+n[b+(a<<2)>>2]+ +n[b+(e<<2)>>2];a=a+1|0;if((a|0)==(e|0))break;else b=b+(f<<2)|0}v=v+1|0;if((v|0)==(d|0))break;else{t=t+(e<<2)|0;u=u+(e<<2)|0}}return}}}function UN(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,u=0,v=0;switch(e|0){case 2:{f=d<<1;if((d|0)<=0)return;g=c+16|0;h=c+32|0;i=c+40|0;j=0;do{k=j|1;l=+p[h>>3]*+p[a+(k<<3)>>3]+ +p[i>>3];p[b+(j<<3)>>3]=+p[c>>3]*+p[a+(j<<3)>>3]+ +p[g>>3];p[b+(k<<3)>>3]=l;j=j+2|0}while((j|0)<(f|0));return}case 3:{f=d*3|0;if((d|0)<=0)return;j=c+24|0;g=c+40|0;i=c+56|0;h=c+80|0;k=c+88|0;m=0;do{n=m+1|0;l=+p[g>>3]*+p[a+(n<<3)>>3]+ +p[i>>3];o=m+2|0;q=+p[h>>3]*+p[a+(o<<3)>>3]+ +p[k>>3];p[b+(m<<3)>>3]=+p[c>>3]*+p[a+(m<<3)>>3]+ +p[j>>3];p[b+(n<<3)>>3]=l;p[b+(o<<3)>>3]=q;m=m+3|0}while((m|0)<(f|0));return}case 4:{f=d<<2;if((d|0)<=0)return;m=c+32|0;j=c+48|0;k=c+72|0;h=c+96|0;i=c+112|0;g=c+144|0;o=c+152|0;n=0;do{r=n|1;q=+p[j>>3]*+p[a+(r<<3)>>3]+ +p[k>>3];p[b+(n<<3)>>3]=+p[c>>3]*+p[a+(n<<3)>>3]+ +p[m>>3];p[b+(r<<3)>>3]=q;r=n|2;s=n|3;q=+p[g>>3]*+p[a+(s<<3)>>3]+ +p[o>>3];p[b+(r<<3)>>3]=+p[h>>3]*+p[a+(r<<3)>>3]+ +p[i>>3];p[b+(s<<3)>>3]=q;n=n+4|0}while((n|0)<(f|0));return}default:{if((d|0)<=0)return;f=e+1|0;if((e|0)>0){t=a;u=b;v=0}else return;while(1){b=c;a=0;while(1){p[u+(a<<3)>>3]=+p[t+(a<<3)>>3]*+p[b+(a<<3)>>3]+ +p[b+(e<<3)>>3];a=a+1|0;if((a|0)==(e|0))break;else b=b+(f<<3)|0}v=v+1|0;if((v|0)==(d|0))break;else{t=t+(e<<3)|0;u=u+(e<<3)|0}}return}}}function VN(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0;if((f|0)==2&(g|0)==2){i=e<<1;if((e|0)<=0)return;j=d+4|0;k=d+8|0;l=d+12|0;m=d+16|0;o=d+20|0;p=0;do{q=+(h[a+p>>0]|0);r=p|1;s=+(h[a+r>>0]|0);t=mrc(+n[k>>2]+(q*+n[d>>2]+s*+n[j>>2]))|0;u=mrc(+n[o>>2]+(q*+n[l>>2]+s*+n[m>>2]))|0;b[c+p>>0]=t>>>0<256?t:(t|0)>0?255:0;b[c+r>>0]=u>>>0<256?u:(u|0)>0?255:0;p=p+2|0}while((p|0)<(i|0));return}i=(f|0)==3;if(i&(g|0)==3){p=e*3|0;if((e|0)<=0)return;m=d+4|0;l=d+8|0;o=d+12|0;j=d+16|0;k=d+20|0;u=d+24|0;r=d+28|0;t=d+32|0;v=d+36|0;w=d+40|0;x=d+44|0;y=0;do{s=+(h[a+y>>0]|0);z=y+1|0;q=+(h[a+z>>0]|0);A=y+2|0;B=+(h[a+A>>0]|0);C=mrc(+n[o>>2]+(s*+n[d>>2]+q*+n[m>>2]+B*+n[l>>2]))|0;D=mrc(+n[r>>2]+(s*+n[j>>2]+q*+n[k>>2]+B*+n[u>>2]))|0;E=mrc(+n[x>>2]+(s*+n[t>>2]+q*+n[v>>2]+B*+n[w>>2]))|0;b[c+y>>0]=C>>>0<256?C:(C|0)>0?255:0;b[c+z>>0]=D>>>0<256?D:(D|0)>0?255:0;b[c+A>>0]=E>>>0<256?E:(E|0)>0?255:0;y=y+3|0}while((y|0)<(p|0));return}if(i&(g|0)==1){if((e|0)<=0)return;i=d+4|0;p=d+8|0;y=d+12|0;w=a;v=0;while(1){t=mrc(+n[y>>2]+(+n[d>>2]*+(h[w>>0]|0)+ +n[i>>2]*+(h[w+1>>0]|0)+ +n[p>>2]*+(h[w+2>>0]|0)))|0;b[c+v>>0]=t>>>0<256?t:(t|0)>0?255:0;v=v+1|0;if((v|0)==(e|0))break;else w=w+3|0}return}if((f|0)==4&(g|0)==4){w=e<<2;if((e|0)<=0)return;v=d+4|0;p=d+8|0;i=d+12|0;y=d+16|0;t=d+20|0;x=d+24|0;u=d+28|0;k=d+32|0;j=d+36|0;r=d+40|0;l=d+44|0;m=d+48|0;o=d+52|0;E=d+56|0;A=d+60|0;D=d+64|0;z=d+68|0;C=d+72|0;F=d+76|0;G=0;do{B=+(h[a+G>>0]|0);H=G|1;q=+(h[a+H>>0]|0);I=G|2;s=+(h[a+I>>0]|0);J=G|3;K=+(h[a+J>>0]|0);L=mrc(+n[y>>2]+(B*+n[d>>2]+q*+n[v>>2]+s*+n[p>>2]+K*+n[i>>2]))|0;M=mrc(+n[j>>2]+(B*+n[t>>2]+q*+n[x>>2]+s*+n[u>>2]+K*+n[k>>2]))|0;b[c+G>>0]=L>>>0<256?L:(L|0)>0?255:0;b[c+H>>0]=M>>>0<256?M:(M|0)>0?255:0;M=mrc(+n[E>>2]+(B*+n[r>>2]+q*+n[l>>2]+s*+n[m>>2]+K*+n[o>>2]))|0;H=mrc(+n[F>>2]+(B*+n[A>>2]+q*+n[D>>2]+s*+n[z>>2]+K*+n[C>>2]))|0;b[c+I>>0]=M>>>0<256?M:(M|0)>0?255:0;b[c+J>>0]=H>>>0<256?H:(H|0)>0?255:0;G=G+4|0}while((G|0)<(w|0));return}if((e|0)<=0)return;w=f+1|0;if((g|0)<=0)return;if((f|0)>0){N=c;O=a;P=0}else{a=c;c=0;while(1){G=0;C=d;while(1){z=mrc(+n[C+(f<<2)>>2])|0;b[a+G>>0]=z>>>0<256?z:(z|0)>0?255:0;G=G+1|0;if((G|0)==(g|0))break;else C=C+(w<<2)|0}c=c+1|0;if((c|0)==(e|0))break;else a=a+g|0}return}while(1){a=0;c=d;while(1){C=0;K=+n[c+(f<<2)>>2];do{K=K+ +n[c+(C<<2)>>2]*+(h[O+C>>0]|0);C=C+1|0}while((C|0)!=(f|0));C=mrc(K)|0;b[N+a>>0]=C>>>0<256?C:(C|0)>0?255:0;a=a+1|0;if((a|0)==(g|0))break;else c=c+(w<<2)|0}P=P+1|0;if((P|0)==(e|0))break;else{N=N+g|0;O=O+f|0}}return}function WN(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=d+4|0;j=d+8|0;k=d+12|0;l=d+16|0;m=d+20|0;o=0;do{p=+(b[a+o>>0]|0);q=o|1;r=+(b[a+q>>0]|0);s=mrc(+n[j>>2]+(p*+n[d>>2]+r*+n[i>>2]))|0;t=mrc(+n[m>>2]+(p*+n[k>>2]+r*+n[l>>2]))|0;b[c+o>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[c+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;o=o+2|0}while((o|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){o=e*3|0;if((e|0)<=0)return;l=d+4|0;k=d+8|0;m=d+12|0;i=d+16|0;j=d+20|0;t=d+24|0;q=d+28|0;s=d+32|0;u=d+36|0;v=d+40|0;w=d+44|0;x=0;do{r=+(b[a+x>>0]|0);y=x+1|0;p=+(b[a+y>>0]|0);z=x+2|0;A=+(b[a+z>>0]|0);B=mrc(+n[m>>2]+(r*+n[d>>2]+p*+n[l>>2]+A*+n[k>>2]))|0;C=mrc(+n[q>>2]+(r*+n[i>>2]+p*+n[j>>2]+A*+n[t>>2]))|0;D=mrc(+n[w>>2]+(r*+n[s>>2]+p*+n[u>>2]+A*+n[v>>2]))|0;b[c+x>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;b[c+y>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;b[c+z>>0]=(D+128|0)>>>0<256?D:(D|0)>0?127:128;x=x+3|0}while((x|0)<(o|0));return}if(h&(g|0)==1){if((e|0)<=0)return;h=d+4|0;o=d+8|0;x=d+12|0;v=a;u=0;while(1){s=mrc(+n[x>>2]+(+n[d>>2]*+(b[v>>0]|0)+ +n[h>>2]*+(b[v+1>>0]|0)+ +n[o>>2]*+(b[v+2>>0]|0)))|0;b[c+u>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;u=u+1|0;if((u|0)==(e|0))break;else v=v+3|0}return}if((f|0)==4&(g|0)==4){v=e<<2;if((e|0)<=0)return;u=d+4|0;o=d+8|0;h=d+12|0;x=d+16|0;s=d+20|0;w=d+24|0;t=d+28|0;j=d+32|0;i=d+36|0;q=d+40|0;k=d+44|0;l=d+48|0;m=d+52|0;D=d+56|0;z=d+60|0;C=d+64|0;y=d+68|0;B=d+72|0;E=d+76|0;F=0;do{A=+(b[a+F>>0]|0);G=F|1;p=+(b[a+G>>0]|0);H=F|2;r=+(b[a+H>>0]|0);I=F|3;J=+(b[a+I>>0]|0);K=mrc(+n[x>>2]+(A*+n[d>>2]+p*+n[u>>2]+r*+n[o>>2]+J*+n[h>>2]))|0;L=mrc(+n[i>>2]+(A*+n[s>>2]+p*+n[w>>2]+r*+n[t>>2]+J*+n[j>>2]))|0;b[c+F>>0]=(K+128|0)>>>0<256?K:(K|0)>0?127:128;b[c+G>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;L=mrc(+n[D>>2]+(A*+n[q>>2]+p*+n[k>>2]+r*+n[l>>2]+J*+n[m>>2]))|0;G=mrc(+n[E>>2]+(A*+n[z>>2]+p*+n[C>>2]+r*+n[y>>2]+J*+n[B>>2]))|0;b[c+H>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;b[c+I>>0]=(G+128|0)>>>0<256?G:(G|0)>0?127:128;F=F+4|0}while((F|0)<(v|0));return}if((e|0)<=0)return;v=f+1|0;if((g|0)<=0)return;if((f|0)>0){M=c;N=a;O=0}else{a=c;c=0;while(1){F=0;B=d;while(1){y=mrc(+n[B+(f<<2)>>2])|0;b[a+F>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;F=F+1|0;if((F|0)==(g|0))break;else B=B+(v<<2)|0}c=c+1|0;if((c|0)==(e|0))break;else a=a+g|0}return}while(1){a=0;c=d;while(1){B=0;J=+n[c+(f<<2)>>2];do{J=J+ +n[c+(B<<2)>>2]*+(b[N+B>>0]|0);B=B+1|0}while((B|0)!=(f|0));B=mrc(J)|0;b[M+a>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;a=a+1|0;if((a|0)==(g|0))break;else c=c+(v<<2)|0}O=O+1|0;if((O|0)==(e|0))break;else{M=M+g|0;N=N+f|0}}return}function XN(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=+n[c>>2];k=+n[c+4>>2];l=+n[c+8>>2];m=+n[c+12>>2];o=+n[c+16>>2];p=+n[c+20>>2];q=0;do{r=+(j[a+(q<<1)>>1]|0);s=q|1;t=+(j[a+(s<<1)>>1]|0);u=mrc(l+(i*r+k*t))|0;v=mrc(p+(m*r+o*t))|0;d[b+(q<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[b+(s<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+2|0}while((q|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){q=e*3|0;if((e|0)<=0)return;o=+n[c>>2];m=+n[c+4>>2];p=+n[c+8>>2];k=+n[c+12>>2];i=+n[c+16>>2];l=+n[c+20>>2];t=+n[c+24>>2];r=+n[c+28>>2];w=+n[c+32>>2];x=+n[c+36>>2];y=+n[c+40>>2];z=+n[c+44>>2];v=0;do{A=+(j[a+(v<<1)>>1]|0);s=v+1|0;B=+(j[a+(s<<1)>>1]|0);u=v+2|0;C=+(j[a+(u<<1)>>1]|0);D=mrc(k+(o*A+m*B+p*C))|0;E=mrc(r+(i*A+l*B+t*C))|0;F=mrc(z+(w*A+x*B+y*C))|0;d[b+(v<<1)>>1]=D>>>0<65536?D:(D|0)>0?65535:0;d[b+(s<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;d[b+(u<<1)>>1]=F>>>0<65536?F:(F|0)>0?65535:0;v=v+3|0}while((v|0)<(q|0));return}if(h&(g|0)==1){if((e|0)<=0)return;y=+n[c>>2];x=+n[c+4>>2];w=+n[c+8>>2];z=+n[c+12>>2];h=a;q=0;while(1){v=mrc(z+(y*+(j[h>>1]|0)+x*+(j[h+2>>1]|0)+w*+(j[h+4>>1]|0)))|0;d[b+(q<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+1|0;if((q|0)==(e|0))break;else h=h+6|0}return}if((f|0)==4&(g|0)==4){h=e<<2;if((e|0)<=0)return;w=+n[c>>2];x=+n[c+4>>2];y=+n[c+8>>2];z=+n[c+12>>2];t=+n[c+16>>2];l=+n[c+20>>2];i=+n[c+24>>2];r=+n[c+28>>2];p=+n[c+32>>2];m=+n[c+36>>2];o=+n[c+40>>2];k=+n[c+44>>2];C=+n[c+48>>2];B=+n[c+52>>2];A=+n[c+56>>2];G=+n[c+60>>2];H=+n[c+64>>2];I=+n[c+68>>2];J=+n[c+72>>2];K=+n[c+76>>2];q=0;do{L=+(j[a+(q<<1)>>1]|0);v=q|1;M=+(j[a+(v<<1)>>1]|0);F=q|2;N=+(j[a+(F<<1)>>1]|0);u=q|3;O=+(j[a+(u<<1)>>1]|0);E=mrc(t+(w*L+x*M+y*N+z*O))|0;s=mrc(m+(l*L+i*M+r*N+p*O))|0;d[b+(q<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;d[b+(v<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=mrc(A+(o*L+k*M+C*N+B*O))|0;v=mrc(K+(G*L+H*M+I*N+J*O))|0;d[b+(F<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[b+(u<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+4|0}while((q|0)<(h|0));return}if((e|0)<=0)return;h=f+1|0;if((g|0)<=0)return;if((f|0)>0){P=b;Q=a;R=0}else{a=b;b=0;while(1){q=0;v=c;while(1){u=mrc(+n[v+(f<<2)>>2])|0;d[a+(q<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;q=q+1|0;if((q|0)==(g|0))break;else v=v+(h<<2)|0}b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<1)|0}return}while(1){a=0;b=c;while(1){v=0;J=+n[b+(f<<2)>>2];do{J=J+ +n[b+(v<<2)>>2]*+(j[Q+(v<<1)>>1]|0);v=v+1|0}while((v|0)!=(f|0));v=mrc(J)|0;d[P+(a<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<2)|0}R=R+1|0;if((R|0)==(e|0))break;else{P=P+(g<<1)|0;Q=Q+(f<<1)|0}}return}function YN(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=+n[c>>2];j=+n[c+4>>2];k=+n[c+8>>2];l=+n[c+12>>2];m=+n[c+16>>2];o=+n[c+20>>2];p=0;do{q=+(d[a+(p<<1)>>1]|0);r=p|1;s=+(d[a+(r<<1)>>1]|0);t=mrc(k+(i*q+j*s))|0;u=mrc(o+(l*q+m*s))|0;d[b+(p<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[b+(r<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+2|0}while((p|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){p=e*3|0;if((e|0)<=0)return;m=+n[c>>2];l=+n[c+4>>2];o=+n[c+8>>2];j=+n[c+12>>2];i=+n[c+16>>2];k=+n[c+20>>2];s=+n[c+24>>2];q=+n[c+28>>2];v=+n[c+32>>2];w=+n[c+36>>2];x=+n[c+40>>2];y=+n[c+44>>2];u=0;do{z=+(d[a+(u<<1)>>1]|0);r=u+1|0;A=+(d[a+(r<<1)>>1]|0);t=u+2|0;B=+(d[a+(t<<1)>>1]|0);C=mrc(j+(m*z+l*A+o*B))|0;D=mrc(q+(i*z+k*A+s*B))|0;E=mrc(y+(v*z+w*A+x*B))|0;d[b+(u<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;d[b+(r<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;d[b+(t<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;u=u+3|0}while((u|0)<(p|0));return}if(h&(g|0)==1){if((e|0)<=0)return;x=+n[c>>2];w=+n[c+4>>2];v=+n[c+8>>2];y=+n[c+12>>2];h=a;p=0;while(1){u=mrc(y+(x*+(d[h>>1]|0)+w*+(d[h+2>>1]|0)+v*+(d[h+4>>1]|0)))|0;d[b+(p<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+1|0;if((p|0)==(e|0))break;else h=h+6|0}return}if((f|0)==4&(g|0)==4){h=e<<2;if((e|0)<=0)return;v=+n[c>>2];w=+n[c+4>>2];x=+n[c+8>>2];y=+n[c+12>>2];s=+n[c+16>>2];k=+n[c+20>>2];i=+n[c+24>>2];q=+n[c+28>>2];o=+n[c+32>>2];l=+n[c+36>>2];m=+n[c+40>>2];j=+n[c+44>>2];B=+n[c+48>>2];A=+n[c+52>>2];z=+n[c+56>>2];F=+n[c+60>>2];G=+n[c+64>>2];H=+n[c+68>>2];I=+n[c+72>>2];J=+n[c+76>>2];p=0;do{K=+(d[a+(p<<1)>>1]|0);u=p|1;L=+(d[a+(u<<1)>>1]|0);E=p|2;M=+(d[a+(E<<1)>>1]|0);t=p|3;N=+(d[a+(t<<1)>>1]|0);D=mrc(s+(v*K+w*L+x*M+y*N))|0;r=mrc(l+(k*K+i*L+q*M+o*N))|0;d[b+(p<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;d[b+(u<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=mrc(z+(m*K+j*L+B*M+A*N))|0;u=mrc(J+(F*K+G*L+H*M+I*N))|0;d[b+(E<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[b+(t<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+4|0}while((p|0)<(h|0));return}if((e|0)<=0)return;h=f+1|0;if((g|0)<=0)return;if((f|0)>0){O=b;P=a;Q=0}else{a=b;b=0;while(1){p=0;u=c;while(1){t=mrc(+n[u+(f<<2)>>2])|0;d[a+(p<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;p=p+1|0;if((p|0)==(g|0))break;else u=u+(h<<2)|0}b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<1)|0}return}while(1){a=0;b=c;while(1){u=0;I=+n[b+(f<<2)>>2];do{I=I+ +n[b+(u<<2)>>2]*+(d[P+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(f|0));u=mrc(I)|0;d[O+(a<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<2)|0}Q=Q+1|0;if((Q|0)==(e|0))break;else{O=O+(g<<1)|0;P=P+(f<<1)|0}}return}function ZN(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0;if((e|0)==2&(g|0)==2){h=d<<1;if((d|0)<=0)return;i=+p[c>>3];j=+p[c+8>>3];k=+p[c+16>>3];l=+p[c+24>>3];m=+p[c+32>>3];n=+p[c+40>>3];o=0;do{q=+(f[a+(o<<2)>>2]|0);r=o|1;s=+(f[a+(r<<2)>>2]|0);t=nrc(k+(i*q+j*s))|0;u=nrc(n+(l*q+m*s))|0;f[b+(o<<2)>>2]=t;f[b+(r<<2)>>2]=u;o=o+2|0}while((o|0)<(h|0));return}h=(e|0)==3;if(h&(g|0)==3){o=d*3|0;if((d|0)<=0)return;m=+p[c>>3];l=+p[c+8>>3];n=+p[c+16>>3];j=+p[c+24>>3];i=+p[c+32>>3];k=+p[c+40>>3];s=+p[c+48>>3];q=+p[c+56>>3];v=+p[c+64>>3];w=+p[c+72>>3];x=+p[c+80>>3];y=+p[c+88>>3];u=0;do{z=+(f[a+(u<<2)>>2]|0);r=u+1|0;A=+(f[a+(r<<2)>>2]|0);t=u+2|0;B=+(f[a+(t<<2)>>2]|0);C=nrc(j+(m*z+l*A+n*B))|0;D=nrc(q+(i*z+k*A+s*B))|0;E=nrc(y+(v*z+w*A+x*B))|0;f[b+(u<<2)>>2]=C;f[b+(r<<2)>>2]=D;f[b+(t<<2)>>2]=E;u=u+3|0}while((u|0)<(o|0));return}if(h&(g|0)==1){if((d|0)<=0)return;x=+p[c>>3];w=+p[c+8>>3];v=+p[c+16>>3];y=+p[c+24>>3];h=a;o=0;while(1){u=nrc(y+(x*+(f[h>>2]|0)+w*+(f[h+4>>2]|0)+v*+(f[h+8>>2]|0)))|0;f[b+(o<<2)>>2]=u;o=o+1|0;if((o|0)==(d|0))break;else h=h+12|0}return}if((e|0)==4&(g|0)==4){h=d<<2;if((d|0)<=0)return;v=+p[c>>3];w=+p[c+8>>3];x=+p[c+16>>3];y=+p[c+24>>3];s=+p[c+32>>3];k=+p[c+40>>3];i=+p[c+48>>3];q=+p[c+56>>3];n=+p[c+64>>3];l=+p[c+72>>3];m=+p[c+80>>3];j=+p[c+88>>3];B=+p[c+96>>3];A=+p[c+104>>3];z=+p[c+112>>3];F=+p[c+120>>3];G=+p[c+128>>3];H=+p[c+136>>3];I=+p[c+144>>3];J=+p[c+152>>3];o=0;do{K=+(f[a+(o<<2)>>2]|0);u=o|1;L=+(f[a+(u<<2)>>2]|0);E=o|2;M=+(f[a+(E<<2)>>2]|0);t=o|3;N=+(f[a+(t<<2)>>2]|0);D=nrc(s+(v*K+w*L+x*M+y*N))|0;r=nrc(l+(k*K+i*L+q*M+n*N))|0;f[b+(o<<2)>>2]=D;f[b+(u<<2)>>2]=r;r=nrc(z+(m*K+j*L+B*M+A*N))|0;u=nrc(J+(F*K+G*L+H*M+I*N))|0;f[b+(E<<2)>>2]=r;f[b+(t<<2)>>2]=u;o=o+4|0}while((o|0)<(h|0));return}if((d|0)<=0)return;h=e+1|0;if((g|0)<=0)return;if((e|0)>0){O=b;P=a;Q=0}else{a=b;b=0;while(1){o=0;u=c;while(1){t=nrc(+p[u+(e<<3)>>3])|0;f[a+(o<<2)>>2]=t;o=o+1|0;if((o|0)==(g|0))break;else u=u+(h<<3)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(g<<2)|0}return}while(1){a=0;b=c;while(1){u=0;I=+p[b+(e<<3)>>3];do{I=I+ +p[b+(u<<3)>>3]*+(f[P+(u<<2)>>2]|0);u=u+1|0}while((u|0)!=(e|0));u=nrc(I)|0;f[O+(a<<2)>>2]=u;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<3)|0}Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(g<<2)|0;P=P+(e<<2)|0}}return}function _N(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;if((e|0)==2&(g|0)==2){h=d<<1;if((d|0)<=0)return;i=c+4|0;j=c+8|0;k=c+12|0;l=c+16|0;m=c+20|0;o=0;do{p=+n[a+(o<<2)>>2];q=o|1;r=+n[a+(q<<2)>>2];s=+n[m>>2]+(p*+n[k>>2]+r*+n[l>>2]);n[b+(o<<2)>>2]=+n[j>>2]+(p*+n[c>>2]+r*+n[i>>2]);n[b+(q<<2)>>2]=s;o=o+2|0}while((o|0)<(h|0));return}h=(e|0)==3;if(h&(g|0)==3){o=d*3|0;if((d|0)<=0)return;i=c+4|0;j=c+8|0;l=c+12|0;k=c+16|0;m=c+20|0;q=c+24|0;t=c+28|0;u=c+32|0;v=c+36|0;w=c+40|0;x=c+44|0;y=0;do{s=+n[a+(y<<2)>>2];z=y+1|0;r=+n[a+(z<<2)>>2];A=y+2|0;p=+n[a+(A<<2)>>2];B=+n[t>>2]+(s*+n[k>>2]+r*+n[m>>2]+p*+n[q>>2]);C=+n[x>>2]+(s*+n[u>>2]+r*+n[v>>2]+p*+n[w>>2]);n[b+(y<<2)>>2]=+n[l>>2]+(s*+n[c>>2]+r*+n[i>>2]+p*+n[j>>2]);n[b+(z<<2)>>2]=B;n[b+(A<<2)>>2]=C;y=y+3|0}while((y|0)<(o|0));return}if(h&(g|0)==1){if((d|0)<=0)return;h=c+4|0;o=c+8|0;y=c+12|0;j=a;i=0;while(1){n[b+(i<<2)>>2]=+n[y>>2]+(+n[c>>2]*+n[j>>2]+ +n[h>>2]*+n[j+4>>2]+ +n[o>>2]*+n[j+8>>2]);i=i+1|0;if((i|0)==(d|0))break;else j=j+12|0}return}if((e|0)==4&(g|0)==4){j=d<<2;if((d|0)<=0)return;i=c+4|0;o=c+8|0;h=c+12|0;y=c+16|0;l=c+20|0;w=c+24|0;v=c+28|0;u=c+32|0;x=c+36|0;q=c+40|0;m=c+44|0;k=c+48|0;t=c+52|0;A=c+56|0;z=c+60|0;D=c+64|0;E=c+68|0;F=c+72|0;G=c+76|0;H=0;do{C=+n[a+(H<<2)>>2];I=H|1;B=+n[a+(I<<2)>>2];J=H|2;p=+n[a+(J<<2)>>2];K=H|3;r=+n[a+(K<<2)>>2];s=+n[x>>2]+(C*+n[l>>2]+B*+n[w>>2]+p*+n[v>>2]+r*+n[u>>2]);n[b+(H<<2)>>2]=+n[y>>2]+(C*+n[c>>2]+B*+n[i>>2]+p*+n[o>>2]+r*+n[h>>2]);n[b+(I<<2)>>2]=s;s=+n[G>>2]+(C*+n[z>>2]+B*+n[D>>2]+p*+n[E>>2]+r*+n[F>>2]);n[b+(J<<2)>>2]=+n[A>>2]+(C*+n[q>>2]+B*+n[m>>2]+p*+n[k>>2]+r*+n[t>>2]);n[b+(K<<2)>>2]=s;H=H+4|0}while((H|0)<(j|0));return}if((d|0)<=0)return;j=e+1|0;if((g|0)<=0)return;if((e|0)>0){L=b;M=a;N=0}else{a=b;b=0;while(1){H=0;t=c;while(1){f[a+(H<<2)>>2]=f[t+(e<<2)>>2];H=H+1|0;if((H|0)==(g|0))break;else t=t+(j<<2)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(g<<2)|0}return}while(1){a=0;b=c;while(1){t=0;s=+n[b+(e<<2)>>2];do{s=s+ +n[b+(t<<2)>>2]*+n[M+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0));n[L+(a<<2)>>2]=s;a=a+1|0;if((a|0)==(g|0))break;else b=b+(j<<2)|0}N=N+1|0;if((N|0)==(d|0))break;else{L=L+(g<<2)|0;M=M+(e<<2)|0}}return}function $N(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;if((e|0)==2&(f|0)==2){g=d<<1;if((d|0)<=0)return;h=c+8|0;i=c+16|0;j=c+24|0;k=c+32|0;l=c+40|0;m=0;do{n=+p[a+(m<<3)>>3];o=m|1;q=+p[a+(o<<3)>>3];r=+p[l>>3]+(n*+p[j>>3]+q*+p[k>>3]);p[b+(m<<3)>>3]=+p[i>>3]+(n*+p[c>>3]+q*+p[h>>3]);p[b+(o<<3)>>3]=r;m=m+2|0}while((m|0)<(g|0));return}g=(e|0)==3;if(g&(f|0)==3){m=d*3|0;if((d|0)<=0)return;h=c+8|0;i=c+16|0;k=c+24|0;j=c+32|0;l=c+40|0;o=c+48|0;s=c+56|0;t=c+64|0;u=c+72|0;v=c+80|0;w=c+88|0;x=0;do{r=+p[a+(x<<3)>>3];y=x+1|0;q=+p[a+(y<<3)>>3];z=x+2|0;n=+p[a+(z<<3)>>3];A=+p[s>>3]+(r*+p[j>>3]+q*+p[l>>3]+n*+p[o>>3]);B=+p[w>>3]+(r*+p[t>>3]+q*+p[u>>3]+n*+p[v>>3]);p[b+(x<<3)>>3]=+p[k>>3]+(r*+p[c>>3]+q*+p[h>>3]+n*+p[i>>3]);p[b+(y<<3)>>3]=A;p[b+(z<<3)>>3]=B;x=x+3|0}while((x|0)<(m|0));return}if(g&(f|0)==1){if((d|0)<=0)return;g=c+8|0;m=c+16|0;x=c+24|0;i=a;h=0;while(1){p[b+(h<<3)>>3]=+p[x>>3]+(+p[c>>3]*+p[i>>3]+ +p[g>>3]*+p[i+8>>3]+ +p[m>>3]*+p[i+16>>3]);h=h+1|0;if((h|0)==(d|0))break;else i=i+24|0}return}if((e|0)==4&(f|0)==4){i=d<<2;if((d|0)<=0)return;h=c+8|0;m=c+16|0;g=c+24|0;x=c+32|0;k=c+40|0;v=c+48|0;u=c+56|0;t=c+64|0;w=c+72|0;o=c+80|0;l=c+88|0;j=c+96|0;s=c+104|0;z=c+112|0;y=c+120|0;C=c+128|0;D=c+136|0;E=c+144|0;F=c+152|0;G=0;do{B=+p[a+(G<<3)>>3];H=G|1;A=+p[a+(H<<3)>>3];I=G|2;n=+p[a+(I<<3)>>3];J=G|3;q=+p[a+(J<<3)>>3];r=+p[w>>3]+(B*+p[k>>3]+A*+p[v>>3]+n*+p[u>>3]+q*+p[t>>3]);p[b+(G<<3)>>3]=+p[x>>3]+(B*+p[c>>3]+A*+p[h>>3]+n*+p[m>>3]+q*+p[g>>3]);p[b+(H<<3)>>3]=r;r=+p[F>>3]+(B*+p[y>>3]+A*+p[C>>3]+n*+p[D>>3]+q*+p[E>>3]);p[b+(I<<3)>>3]=+p[z>>3]+(B*+p[o>>3]+A*+p[l>>3]+n*+p[j>>3]+q*+p[s>>3]);p[b+(J<<3)>>3]=r;G=G+4|0}while((G|0)<(i|0));return}if((d|0)<=0)return;i=e+1|0;if((f|0)<=0)return;if((e|0)>0){K=b;L=a;M=0}else{a=b;b=0;while(1){G=0;s=c;while(1){p[a+(G<<3)>>3]=+p[s+(e<<3)>>3];G=G+1|0;if((G|0)==(f|0))break;else s=s+(i<<3)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(f<<3)|0}return}while(1){a=0;b=c;while(1){s=0;r=+p[b+(e<<3)>>3];do{r=r+ +p[b+(s<<3)>>3]*+p[L+(s<<3)>>3];s=s+1|0}while((s|0)!=(e|0));p[K+(a<<3)>>3]=r;a=a+1|0;if((a|0)==(f|0))break;else b=b+(i<<3)|0}M=M+1|0;if((M|0)==(d|0))break;else{K=K+(f<<3)|0;L=L+(e<<3)|0}}return}function aO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+1376|0;g=e+1320|0;h=e+1264|0;i=e+1208|0;j=e+1200|0;k=e+16|0;l=e+1144|0;m=e;n=e+1112|0;do if((d$(a)|0)==65536){o=f[a+4>>2]|0;f[g>>2]=f[o>>2];p=g+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[g+36>>2]=s;f[g+40>>2]=r;r=g+48|0;t=g+44|0;f[t>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;ZS(g,o);break}}else a$(g,a,-1);while(0);do if((d$(d)|0)==65536){a=f[d+4>>2]|0;f[h>>2]=f[a>>2];o=h+4|0;p=a+4|0;f[o>>2]=f[p>>2];q=h+8|0;f[q>>2]=f[a+8>>2];r=h+12|0;f[r>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=q;s=h+48|0;v=h+44|0;f[v>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[p>>2]|0)<3){p=f[a+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[p>>2];f[s+4>>2]=f[p+4>>2];w=q;x=r;break}else{f[o>>2]=0;ZS(h,a);w=q;x=r;break}}else{a$(h,d,-1);w=h+8|0;x=h+12|0}while(0);d=f[g>>2]|0;r=d&7;q=d>>>3&511;d=q+1|0;a=f[w>>2]|0;o=a+-1|0;p=q+2|0;if((p|0)!=(f[x>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;y=tT(i,17)|0;z=213208;A=y+17|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,i,213226,212648,2270)}q=(r|0)==5;if((r+-5|0)>>>0>=2){f[i>>2]=0;f[i+4>>2]=0;y=tT(i,34)|0;z=230863;A=y+34|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,i,213226,212648,2271)}z=g+40|0;y=f[z>>2]|0;A=f[y>>2]|0;f[j>>2]=f[y+4>>2];f[j+4>>2]=A;v$(c,j,(a<<3)+-16|r,-1,0,0);do if((d$(c)|0)==65536){r=f[c+4>>2]|0;f[i>>2]=f[r>>2];j=i+4|0;A=r+4|0;f[j>>2]=f[A>>2];y=i+8|0;f[y>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[i+28>>2]=f[r+28>>2];f[i+32>>2]=f[r+32>>2];s=f[r+36>>2]|0;f[i+36>>2]=s;f[i+40>>2]=y;y=i+48|0;v=i+44|0;f[v>>2]=y;f[y>>2]=0;f[i+52>>2]=0;if(s|0){y=s+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[A>>2]|0)<3){A=f[r+44>>2]|0;y=f[v>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2];break}else{f[j>>2]=0;ZS(i,r);break}}else a$(i,c,-1);while(0);c=k+8|0;f[k>>2]=c;r=k+4|0;f[r>>2]=136;j=h+16|0;A=h+44|0;if((f[h>>2]&20479|0)==16390)B=f[j>>2]|0;else{y=Y(p,a)|0;f[r>>2]=y;if(y>>>0>136){v=XDc(y>>>0>536870911?-1:y<<3)|0;f[k>>2]=v;C=v}else C=c;Vj(l,a,p,6,C,0);p=m+8|0;f[p>>2]=0;f[p+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=l;LZ(h,m,6,1.0,0.0);p=l+36|0;a=f[p>>2]|0;if(a|0){v=a+12|0;f[v>>2]=(f[v>>2]|0)+1}v=h+36|0;a=f[v>>2]|0;if(a|0?(y=a+12|0,a=f[y>>2]|0,f[y>>2]=a+-1,(a|0)==1):0)_S(h);f[v>>2]=0;a=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[a>>2]|0)>0){y=f[h+40>>2]|0;s=0;do{f[y+(s<<2)>>2]=0;s=s+1|0;D=f[a>>2]|0}while((s|0)<(D|0));f[h>>2]=f[l>>2];if((D|0)<3)E=39;else E=41}else{f[h>>2]=f[l>>2];E=39}if((E|0)==39){D=f[l+4>>2]|0;if((D|0)<3){f[a>>2]=D;f[w>>2]=f[l+8>>2];f[x>>2]=f[l+12>>2];x=f[l+44>>2]|0;w=f[A>>2]|0;f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2]}else E=41}if((E|0)==41)ZS(h,l);E=l+16|0;f[j>>2]=f[E>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];x=f[p>>2]|0;f[v>>2]=x;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)_S(l);f[p>>2]=0;p=l+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[p>>2]|0)>0){E=f[l+40>>2]|0;x=0;do{f[E+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[p>>2]|0))}p=f[l+44>>2]|0;if((p|0)!=(l+48|0))g0(p);B=C}C=q?141:140;f[l>>2]=g;f[l+4>>2]=i;f[l+8>>2]=0;q=m;f[q>>2]=0;f[q+4>>2]=0;z2(n,l,m,-1);l=f[n+20>>2]|0;q=n+16|0;p=m+4|0;x=0;while(1){if(x>>>0>=(f[q>>2]|0)>>>0)break;Fh[C&255](f[m>>2]|0,f[p>>2]|0,B,l,d,o);A2(n)|0;x=x+1|0}x=f[k>>2]|0;if((x|0)!=(c|0)){if(x|0)ZDc(x);f[k>>2]=c;f[r>>2]=136}r=i+36|0;c=f[r>>2]|0;if(c|0?(k=c+12|0,c=f[k>>2]|0,f[k>>2]=c+-1,(c|0)==1):0)_S(i);f[r>>2]=0;r=i+16|0;c=i+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[i+40>>2]|0;k=0;do{f[r+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[c>>2]|0))}c=f[i+44>>2]|0;if((c|0)!=(i+48|0))g0(c);c=h+36|0;i=f[c>>2]|0;if(i|0?(k=i+12|0,i=f[k>>2]|0,f[k>>2]=i+-1,(i|0)==1):0)_S(h);f[c>>2]=0;c=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[c>>2]|0)>0){j=f[h+40>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=f[A>>2]|0;if((c|0)!=(h+48|0))g0(c);c=g+36|0;h=f[c>>2]|0;if(h|0?(A=h+12|0,h=f[A>>2]|0,f[A>>2]=h+-1,(h|0)==1):0)_S(g);f[c>>2]=0;c=g+16|0;h=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[h>>2]|0)>0){c=f[z>>2]|0;z=0;do{f[c+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}g0(h);u=e;return}function bO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0;g=(f|0)==2;if((e|0)==2&g){h=d<<1;if((d|0)<=0)return;i=+p[c+48>>3];j=+p[c+56>>3];k=+p[c+64>>3];l=c+8|0;m=c+16|0;o=c+24|0;q=c+32|0;r=c+40|0;s=0;do{t=s|1;u=+n[a+(s<<2)>>2];v=+n[a+(t<<2)>>2];w=k+(i*u+j*v);if(+L(+w)>1.1920928955078125e-07){x=1.0/w;n[b+(s<<2)>>2]=x*(+p[m>>3]+(u*+p[c>>3]+v*+p[l>>3]));y=t;z=x*(+p[r>>3]+(u*+p[o>>3]+v*+p[q>>3]))}else{n[b+(t<<2)>>2]=0.0;y=s;z=0.0}n[b+(y<<2)>>2]=z;s=s+2|0}while((s|0)<(h|0));return}h=(e|0)==3;if(h&(f|0)==3){s=d*3|0;if((d|0)<=0)return;z=+p[c+96>>3];j=+p[c+104>>3];i=+p[c+112>>3];k=+p[c+120>>3];y=c+8|0;q=c+16|0;o=c+24|0;r=c+32|0;l=c+40|0;m=c+48|0;t=c+56|0;A=c+64|0;B=c+72|0;C=c+80|0;D=c+88|0;E=0;do{F=E+1|0;G=E+2|0;v=+n[a+(E<<2)>>2];u=+n[a+(F<<2)>>2];x=+n[a+(G<<2)>>2];w=k+(z*v+j*u+i*x);if(+L(+w)>1.1920928955078125e-07){H=1.0/w;n[b+(E<<2)>>2]=H*(+p[o>>3]+(v*+p[c>>3]+u*+p[y>>3]+x*+p[q>>3]));I=G;J=H*(+p[t>>3]+(v*+p[r>>3]+u*+p[l>>3]+x*+p[m>>3]));K=H*(+p[D>>3]+(v*+p[A>>3]+u*+p[B>>3]+x*+p[C>>3]))}else{n[b+(G<<2)>>2]=0.0;I=E;J=0.0;K=0.0}n[b+(F<<2)>>2]=J;n[b+(I<<2)>>2]=K;E=E+3|0}while((E|0)<(s|0));return}s=(d|0)>0;if(h&g){if(!s)return;K=+p[c+64>>3];J=+p[c+72>>3];i=+p[c+80>>3];j=+p[c+88>>3];g=c+8|0;h=c+16|0;E=c+24|0;I=c+32|0;C=c+40|0;B=c+48|0;A=c+56|0;D=a;m=b;l=0;while(1){z=+n[D>>2];k=+n[D+4>>2];x=+n[D+8>>2];u=j+(K*z+J*k+i*x);if(+L(+u)>1.1920928955078125e-07){v=1.0/u;n[m>>2]=v*(+p[E>>3]+(z*+p[c>>3]+k*+p[g>>3]+x*+p[h>>3]));M=m+4|0;N=v*(+p[A>>3]+(z*+p[I>>3]+k*+p[C>>3]+x*+p[B>>3]))}else{n[m+4>>2]=0.0;M=m;N=0.0}n[M>>2]=N;l=l+1|0;if((l|0)==(d|0))break;else{D=D+12|0;m=m+8|0}}return}if(!s)return;s=e+1|0;m=c+((Y(s,f)|0)<<3)|0;N=+p[m+(e<<3)>>3];D=(f|0)>0;l=f<<2;if((e|0)>0){if(D){O=a;P=b;Q=0}else return;while(1){a=b+((Y(Q,f)|0)<<2)|0;M=0;i=N;do{i=i+ +p[m+(M<<3)>>3]*+n[O+(M<<2)>>2];M=M+1|0}while((M|0)!=(e|0));if(+L(+i)>1.1920928955078125e-07){M=0;B=c;while(1){J=+p[B+(e<<3)>>3];C=0;do{J=J+ +p[B+(C<<3)>>3]*+n[O+(C<<2)>>2];C=C+1|0}while((C|0)!=(e|0));n[P+(M<<2)>>2]=i*J;M=M+1|0;if((M|0)==(f|0))break;else B=B+(s<<3)|0}}else XIc(a|0,0,l|0)|0;Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(e<<2)|0;P=P+(f<<2)|0}}return}else{if(!(+L(+N)>1.1920928955078125e-07)){if(D)R=0;else return;do{XIc(b+((Y(R,f)|0)<<2)|0,0,l|0)|0;R=R+1|0}while((R|0)!=(d|0));return}if(D){S=b;T=0}else return;while(1){b=0;D=c;while(1){n[S+(b<<2)>>2]=N*+p[D+(e<<3)>>3];b=b+1|0;if((b|0)==(f|0))break;else D=D+(s<<3)|0}T=T+1|0;if((T|0)==(d|0))break;else S=S+(f<<2)|0}return}}function cO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0,M=0,N=0,O=0,P=0,Q=0;g=(f|0)==2;if((e|0)==2&g){h=d<<1;if((d|0)<=0)return;i=c+48|0;j=c+56|0;k=c+64|0;l=c+8|0;m=c+16|0;n=c+24|0;o=c+32|0;q=c+40|0;r=0;do{s=+p[a+(r<<3)>>3];t=r|1;u=+p[a+(t<<3)>>3];v=+p[k>>3]+(s*+p[i>>3]+u*+p[j>>3]);if(+L(+v)>1.1920928955078125e-07){w=1.0/v;p[b+(r<<3)>>3]=w*(+p[m>>3]+(s*+p[c>>3]+u*+p[l>>3]));x=t;y=w*(+p[q>>3]+(s*+p[n>>3]+u*+p[o>>3]))}else{p[b+(t<<3)>>3]=0.0;x=r;y=0.0}p[b+(x<<3)>>3]=y;r=r+2|0}while((r|0)<(h|0));return}h=(e|0)==3;if(h&(f|0)==3){r=d*3|0;if((d|0)<=0)return;x=c+96|0;o=c+104|0;n=c+112|0;q=c+120|0;l=c+8|0;m=c+16|0;j=c+24|0;i=c+32|0;k=c+40|0;t=c+48|0;z=c+56|0;A=c+64|0;B=c+72|0;C=c+80|0;D=c+88|0;E=0;do{y=+p[a+(E<<3)>>3];F=E+1|0;u=+p[a+(F<<3)>>3];G=E+2|0;s=+p[a+(G<<3)>>3];w=+p[q>>3]+(y*+p[x>>3]+u*+p[o>>3]+s*+p[n>>3]);if(+L(+w)>1.1920928955078125e-07){v=1.0/w;p[b+(E<<3)>>3]=v*(+p[j>>3]+(y*+p[c>>3]+u*+p[l>>3]+s*+p[m>>3]));p[b+(F<<3)>>3]=v*(+p[z>>3]+(y*+p[i>>3]+u*+p[k>>3]+s*+p[t>>3]));H=G;I=v*(+p[D>>3]+(y*+p[A>>3]+u*+p[B>>3]+s*+p[C>>3]))}else{p[b+(G<<3)>>3]=0.0;p[b+(F<<3)>>3]=0.0;H=E;I=0.0}p[b+(H<<3)>>3]=I;E=E+3|0}while((E|0)<(r|0));return}r=(d|0)>0;if(h&g){if(!r)return;g=c+64|0;h=c+72|0;E=c+80|0;H=c+88|0;C=c+8|0;B=c+16|0;A=c+24|0;D=c+32|0;t=c+40|0;k=c+48|0;i=c+56|0;z=a;m=b;l=0;while(1){I=+p[z>>3];s=+p[z+8>>3];u=+p[z+16>>3];y=+p[H>>3]+(I*+p[g>>3]+s*+p[h>>3]+u*+p[E>>3]);if(+L(+y)>1.1920928955078125e-07){v=1.0/y;p[m>>3]=v*(+p[A>>3]+(I*+p[c>>3]+s*+p[C>>3]+u*+p[B>>3]));J=m+8|0;K=v*(+p[i>>3]+(I*+p[D>>3]+s*+p[t>>3]+u*+p[k>>3]))}else{p[m+8>>3]=0.0;J=m;K=0.0}p[J>>3]=K;l=l+1|0;if((l|0)==(d|0))break;else{z=z+24|0;m=m+16|0}}return}if(!r)return;r=e+1|0;m=c+((Y(r,f)|0)<<3)|0;z=m+(e<<3)|0;l=(f|0)>0;J=f<<3;if((e|0)<=0){if(l){M=b;N=0}else return;while(1){K=+p[z>>3];if(+L(+K)>1.1920928955078125e-07){k=0;t=c;while(1){p[M+(k<<3)>>3]=K*+p[t+(e<<3)>>3];k=k+1|0;if((k|0)==(f|0))break;else t=t+(r<<3)|0}}else XIc(b+((Y(N,f)|0)<<3)|0,0,J|0)|0;N=N+1|0;if((N|0)==(d|0))break;else M=M+(f<<3)|0}return}if(l){O=a;P=b;Q=0}else return;while(1){a=b+((Y(Q,f)|0)<<3)|0;l=0;K=+p[z>>3];do{K=K+ +p[m+(l<<3)>>3]*+p[O+(l<<3)>>3];l=l+1|0}while((l|0)!=(e|0));if(+L(+K)>1.1920928955078125e-07){l=0;M=c;while(1){u=+p[M+(e<<3)>>3];N=0;do{u=u+ +p[M+(N<<3)>>3]*+p[O+(N<<3)>>3];N=N+1|0}while((N|0)!=(e|0));p[P+(l<<3)>>3]=K*u;l=l+1|0;if((l|0)==(f|0))break;else M=M+(r<<3)|0}}else XIc(a|0,0,J|0)|0;Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(e<<3)|0;P=P+(f<<3)|0}}return}function dO(a,c,d,e){a=a|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+256|0;h=g;i=g+192|0;j=g+136|0;k=g+80|0;l=g+72|0;m=g+56|0;o=g+40|0;q=g+8|0;p[h>>3]=c;r=c$(a,-1)|0;s=r&7;t=(r>>>3&511)+1|0;if((r|0)!=(c$(d,-1)|0)){f[i>>2]=0;f[i+4>>2]=0;v=tT(i,20)|0;w=213247;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,i,213268,212648,2400)}if(s>>>0<5){tL(a,c,d,1.0,0.0,e,s);u=g;return}do if((d$(a)|0)==65536){y=f[a+4>>2]|0;f[i>>2]=f[y>>2];z=i+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=i+8|0;f[B>>2]=f[y+8>>2];f[i+12>>2]=f[y+12>>2];f[i+16>>2]=f[y+16>>2];f[i+20>>2]=f[y+20>>2];f[i+24>>2]=f[y+24>>2];f[i+28>>2]=f[y+28>>2];f[i+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[i+36>>2]=C;f[i+40>>2]=B;B=i+48|0;D=i+44|0;f[D>>2]=B;f[B>>2]=0;f[i+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;ZS(i,y);break}}else a$(i,a,-1);while(0);do if((d$(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];y=j+4|0;z=a+4|0;f[y>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[j+36>>2]=B;D=j+40|0;f[D>>2]=A;A=j+48|0;C=j+44|0;f[C>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];E=D;break}else{f[y>>2]=0;ZS(j,a);E=D;break}}else{a$(j,d,-1);E=j+40|0}while(0);d=i+40|0;D=f[d>>2]|0;a=f[D+-4>>2]|0;y=f[E>>2]|0;if((a|0)!=(f[y+-4>>2]|0)){f[k>>2]=0;F=k+4|0;f[F>>2]=0;G=tT(k,22)|0;v=G;w=213277;x=v+22|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,k,213268,212648,2412)}a:do if((a|0)==2){if((f[D>>2]|0)!=(f[y>>2]|0)){f[k>>2]=0;F=k+4|0;f[F>>2]=0;G=tT(k,22)|0;v=G;w=213277;x=v+22|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,k,213268,212648,2412)}if((f[D+4>>2]|0)!=(f[y+4>>2]|0)){f[k>>2]=0;F=k+4|0;f[F>>2]=0;G=tT(k,22)|0;v=G;w=213277;x=v+22|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,k,213268,212648,2412)}}else if((a|0)>0){z=0;while(1){if((f[D+(z<<2)>>2]|0)!=(f[y+(z<<2)>>2]|0))break;z=z+1|0;if((z|0)>=(a|0))break a}f[k>>2]=0;F=k+4|0;f[F>>2]=0;G=tT(k,22)|0;v=G;w=213277;x=v+22|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,k,213268,212648,2412)}while(0);w=i+4|0;w$(e,f[w>>2]|0,D,r,-1,0,0);do if((d$(e)|0)==65536){r=f[e+4>>2]|0;f[k>>2]=f[r>>2];D=k+4|0;v=r+4|0;f[D>>2]=f[v>>2];x=k+8|0;f[x>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[k+16>>2]=f[r+16>>2];f[k+20>>2]=f[r+20>>2];f[k+24>>2]=f[r+24>>2];f[k+28>>2]=f[r+28>>2];f[k+32>>2]=f[r+32>>2];G=f[r+36>>2]|0;f[k+36>>2]=G;f[k+40>>2]=x;x=k+48|0;F=k+44|0;f[F>>2]=x;f[x>>2]=0;f[k+52>>2]=0;if(G|0){x=G+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[v>>2]|0)<3){v=f[r+44>>2]|0;x=f[F>>2]|0;f[x>>2]=f[v>>2];f[x+4>>2]=f[v+4>>2];break}else{f[D>>2]=0;ZS(k,r);break}}else a$(k,e,-1);while(0);n[l>>2]=+p[h>>3];e=(s|0)==5;s=e?l:h;h=e?161:160;if(((f[i>>2]&16384|0)!=0?(f[j>>2]&16384|0)!=0:0)?(f[k>>2]&16384|0)!=0:0){e=f[w>>2]|0;if((e|0)<3)H=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{l=f[d>>2]|0;r=0;D=1;while(1){v=Y(f[l+(r<<2)>>2]|0,D)|0;r=r+1|0;if((r|0)==(e|0)){H=v;break}else D=v}}D=Y(H,t)|0;gi[h&255](f[i+16>>2]|0,f[j+16>>2]|0,f[k+16>>2]|0,D,s)}else{f[m>>2]=i;f[m+4>>2]=j;f[m+8>>2]=k;f[m+12>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;z2(q,m,o,-1);m=Y(f[q+20>>2]|0,t)|0;t=q+16|0;D=o+4|0;H=o+8|0;e=0;while(1){if(e>>>0>=(f[t>>2]|0)>>>0)break;gi[h&255](f[o>>2]|0,f[D>>2]|0,f[H>>2]|0,m,s);A2(q)|0;e=e+1|0}}e=k+36|0;q=f[e>>2]|0;if(q|0?(s=q+12|0,q=f[s>>2]|0,f[s>>2]=q+-1,(q|0)==1):0)_S(k);f[e>>2]=0;e=k+16|0;q=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){e=f[k+40>>2]|0;s=0;do{f[e+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[k+44>>2]|0;if((q|0)!=(k+48|0))g0(q);q=j+36|0;k=f[q>>2]|0;if(k|0?(s=k+12|0,k=f[s>>2]|0,f[s>>2]=k+-1,(k|0)==1):0)_S(j);f[q>>2]=0;q=j+16|0;k=j+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[k>>2]|0)>0){q=f[E>>2]|0;E=0;do{f[q+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))g0(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(E=j+12|0,j=f[E>>2]|0,f[E>>2]=j+-1,(j|0)==1):0)_S(i);f[k>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[w>>2]|0)>0){k=f[d>>2]|0;d=0;do{f[k+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[w>>2]|0))}w=f[i+44>>2]|0;if((w|0)!=(i+48|0))g0(w);u=g;return}function eO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0;f=+n[e>>2];if((d|0)>0)g=0;else return;do{n[c+(g<<2)>>2]=f*+n[a+(g<<2)>>2]+ +n[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(d|0));return}function fO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0;f=+p[e>>3];if((d|0)>0)g=0;else return;do{p[c+(g<<3)>>3]=f*+p[a+(g<<3)>>3]+ +p[b+(g<<3)>>3];g=g+1|0}while((g|0)!=(d|0));return}function gO(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=u;u=u+352|0;j=i+288|0;k=i+232|0;l=i+176|0;m=i+120|0;n=i+104|0;o=i+88|0;p=i+72|0;q=i+16|0;r=i;do if((d$(a)|0)==65536){s=f[a+4>>2]|0;f[j>>2]=f[s>>2];t=j+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=j+8|0;f[w>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];f[j+16>>2]=f[s+16>>2];f[j+20>>2]=f[s+20>>2];f[j+24>>2]=f[s+24>>2];f[j+28>>2]=f[s+28>>2];f[j+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[j+36>>2]=x;f[j+40>>2]=w;w=j+48|0;y=j+44|0;f[y>>2]=w;f[w>>2]=0;f[j+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;ZS(j,s);break}}else a$(j,a,-1);while(0);do if((d$(e)|0)==65536){a=f[e+4>>2]|0;f[k>>2]=f[a>>2];s=k+4|0;t=a+4|0;f[s>>2]=f[t>>2];v=k+8|0;f[v>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];w=f[a+36>>2]|0;f[k+36>>2]=w;f[k+40>>2]=v;v=k+48|0;y=k+44|0;f[y>>2]=v;f[v>>2]=0;f[k+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=k;break}else{f[s>>2]=0;ZS(k,a);z=k;break}}else{a$(k,e,-1);z=k}while(0);e=f[j>>2]|0;a=e&4095;s=((h|0)>-1?h:e)&7;h=f[z>>2]|0;z=h&7;t=s>>>0<z>>>0?z:s;s=(t|0)>5?t:5;if(e&4088|0){f[l>>2]=0;f[l+4>>2]=0;A=tT(l,19)|0;B=213300;C=A+19|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,l,213320,212648,2873)}e=k+16|0;if(f[e>>2]|0){z=f[k+4>>2]|0;if((z|0)<3)D=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{v=f[k+40>>2]|0;y=0;w=1;while(1){x=Y(f[v+(y<<2)>>2]|0,w)|0;y=y+1|0;if((y|0)==(z|0)){D=x;break}else w=x}}if(!((z|0)==0|(D|0)==0)){if(h&4088|0){f[l>>2]=0;f[l+4>>2]=0;A=tT(l,21)|0;B=213334;C=A+21|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,l,213320,212648,2879)}D=f[k+8>>2]|0;if(!((D|0)==1?1:(D|0)==(f[j+8>>2]|0))){f[l>>2]=0;f[l+4>>2]=0;A=tT(l,43)|0;B=213356;C=A+43|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,l,213320,212648,2879)}D=f[k+12>>2]|0;if(!((D|0)==1?1:(D|0)==(f[j+12>>2]|0))){f[l>>2]=0;f[l+4>>2]=0;A=tT(l,43)|0;B=213400;C=A+43|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,l,213320,212648,2879)}if((h&4095|0)!=(s|0)){h=l+8|0;f[h>>2]=0;f[h+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;LZ(k,l,s,1.0,0.0)}}}h=j+8|0;B=j+12|0;D=d?f[B>>2]|0:f[h>>2]|0;Y$(c,D,D,s,-1,0,0);do if((d$(c)|0)==65536){D=f[c+4>>2]|0;f[l>>2]=f[D>>2];z=l+4|0;w=D+4|0;f[z>>2]=f[w>>2];y=l+8|0;f[y>>2]=f[D+8>>2];f[l+12>>2]=f[D+12>>2];v=l+16|0;f[v>>2]=f[D+16>>2];f[l+20>>2]=f[D+20>>2];f[l+24>>2]=f[D+24>>2];f[l+28>>2]=f[D+28>>2];f[l+32>>2]=f[D+32>>2];x=f[D+36>>2]|0;f[l+36>>2]=x;f[l+40>>2]=y;y=l+48|0;E=l+44|0;f[E>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(x|0){y=x+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[w>>2]|0)<3){w=f[D+44>>2]|0;y=f[E>>2]|0;f[y>>2]=f[w>>2];f[y+4>>2]=f[w+4>>2];F=v;break}else{f[z>>2]=0;ZS(l,D);F=v;break}}else{a$(l,c,-1);F=l+16|0}while(0);c=j+16|0;do if((f[c>>2]|0)==(f[F>>2]|0))G=42;else{if(((a|0)==(s|0)?(f[l+12>>2]|0)>99:0)?((f[B>>2]|0)>99?(f[l+8>>2]|0)>99:0)&(f[h>>2]|0)>99:0){G=42;break}v=(a|0)==0;D=(t|0)<6;do if(!(v&D)){z=(s|0)==6;if(v&z){H=d?26:25;break}w=(a|0)==2;if(w&D){H=d?28:27;break}if(w&z){H=d?30:29;break}w=(a|0)==3;if(w&D){H=d?32:31;break}if(w&z){H=d?34:33;break}w=(a|0)==5;if(w&D){H=d?36:35;break}if(w&z){H=d?38:37;break}if((a|0)==6&z)H=d?40:39;else{f[m>>2]=0;f[m+4>>2]=0;z5(-210,m,213320,212648,2974)}}else H=d?24:23;while(0);$h[H&63](j,l,k,g);D=m+8|0;f[D>>2]=0;f[D+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=l;ER(m,0)}while(0);if((G|0)==42){f[m>>2]=1124007936;G=m+4|0;H=m+8|0;a=m+40|0;A=G;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[a>>2]=H;H=m+48|0;s=m+44|0;f[s>>2]=H;f[H>>2]=0;f[m+52>>2]=0;do if(f[e>>2]|0){t=f[k+4>>2]|0;if((t|0)<3)I=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{D=f[k+40>>2]|0;v=0;z=1;while(1){w=Y(f[D+(v<<2)>>2]|0,z)|0;v=v+1|0;if((v|0)==(t|0)){I=w;break}else z=w}}if(!((t|0)==0|(I|0)==0)){z=f[k+40>>2]|0;v=f[j+40>>2]|0;if((f[z>>2]|0)==(f[v>>2]|0)?(f[z+4>>2]|0)==(f[v+4>>2]|0):0){f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=j;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;v=p+8|0;f[v>>2]=0;f[v+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=m;oL(n,o,p,e0()|0,-1);J=m;break}else{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=k;v=f[h>>2]|0;z=f[k+8>>2]|0;D=f[B>>2]|0;w=f[k+12>>2]|0;y=o+8|0;f[y>>2]=0;f[y+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;o_(n,(v|0)/(z|0)|0,(D|0)/(w|0)|0,o);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=j;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=m;w=p+8|0;f[w>>2]=0;f[w+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=m;oL(n,o,p,e0()|0,-1);J=m;break}}else J=j}else J=j;while(0);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=J;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=J;f[q>>2]=1124007936;J=q+4|0;B=q+8|0;h=q+40|0;A=J;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[h>>2]=B;B=q+48|0;A=q+44|0;f[A>>2]=B;f[B>>2]=0;f[q+52>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=q;C=r+8|0;f[C>>2]=0;f[C+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=l;MN(n,o,g,p,0.0,r,d?1:2);d=q+36|0;r=f[d>>2]|0;if(r|0?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)_S(q);f[d>>2]=0;d=q+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[J>>2]|0)>0){d=f[h>>2]|0;h=0;do{f[d+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[J>>2]|0))}J=f[A>>2]|0;if((J|0)!=(B|0))g0(J);J=m+36|0;B=f[J>>2]|0;if(B|0?(A=B+12|0,B=f[A>>2]|0,f[A>>2]=B+-1,(B|0)==1):0)_S(m);f[J>>2]=0;J=m+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[G>>2]|0)>0){J=f[a>>2]|0;a=0;do{f[J+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[s>>2]|0;if((G|0)!=(H|0))g0(G)}G=l+36|0;H=f[G>>2]|0;if(H|0?(s=H+12|0,H=f[s>>2]|0,f[s>>2]=H+-1,(H|0)==1):0)_S(l);f[G>>2]=0;G=l+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[G>>2]|0)>0){F=f[l+40>>2]|0;H=0;do{f[F+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[G>>2]|0))}G=f[l+44>>2]|0;if((G|0)!=(l+48|0))g0(G);G=k+36|0;l=f[G>>2]|0;if(l|0?(H=l+12|0,l=f[H>>2]|0,f[H>>2]=l+-1,(l|0)==1):0)_S(k);f[G>>2]=0;G=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[G>>2]|0)>0){e=f[k+40>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[G>>2]|0))}G=f[k+44>>2]|0;if((G|0)!=(k+48|0))g0(G);G=j+36|0;k=f[G>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(j);f[G>>2]=0;G=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[G>>2]|0)>0){c=f[j+40>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[G>>2]|0))}G=f[j+44>>2]|0;if((G|0)==(j+48|0)){u=i;return}g0(G);u=i;return}function hO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=XDc(o)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=d*0.0;E=d*0.0;F=d*0.0;G=j;H=0;while(1){if(B){if(o){I=0;do{J=i+((Y(I,l)|0)+H)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(h[J>>0]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=i+((Y(I,l)|0)+H)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(h[t>>0]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=i+M|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(h[K>>0]|0)-+n[I>>2]);P=P+R*(+(h[K+1>>0]|0)-+n[I+4>>2]);O=O+R*(+(h[K+2>>0]|0)-+n[I+8>>2]);N=N+R*(+(h[K+3>>0]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+l|0}}n[G+(M<<2)>>2]=Q*d;n[G+(M+1<<2)>>2]=P*d;n[G+(M+2<<2)>>2]=O*d;n[G+(M+3<<2)>>2]=N*d;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=i+K|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(h[I>>0]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+l|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+K|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(h[t>>0]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+l|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=d*0.0;D=d*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j)|0;n[v+(L<<2)>>2]=+(h[y>>0]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+T|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(h[L>>0]|0);O=O+Q*+(h[L+1>>0]|0);R=R+Q*+(h[L+2>>0]|0);F=F+Q*+(h[L+3>>0]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+l|0}n[x+(T<<2)>>2]=P*d;n[x+(T+1<<2)>>2]=O*d;n[x+(T+2<<2)>>2]=R*d;n[x+(T+3<<2)>>2]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+U|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(h[L>>0]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+l|0}n[x+(U<<2)>>2]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=e;return}ZDc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function iO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;e=u;u=u+1056|0;g=e+1040|0;i=e;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=j+(Y(x,m)|0)|0;if(r){A=x;do{B=j+(Y(A,m)|0)|0;if(v){C=0;D=0.0;while(1){E=D+ +(h[z+C>>0]|0)*+(h[B+C>>0]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*d;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=j+(Y(A,m)|0)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(h[z+B>>0]|0)*+(h[C+B>>0]|0)+ +(h[z+G>>0]|0)*+(h[C+G>>0]|0)+ +(h[z+H>>0]|0)*+(h[C+H>>0]|0)+ +(h[z+I>>0]|0)*+(h[C+I>>0]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(h[z+B>>0]|0)*+(h[C+B>>0]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*d;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=e;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=x;if(x>>>0>1032){c=XDc(x)|0;f[i>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=g+12|0;v=g+8|0;r=g+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=g+C|0;H=0;G=k;k=l+C|0;while(1){C=j+(Y(H,m)|0)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(h[C+N>>0]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(h[C+N>>0]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=j+(Y(P,m)|0)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[g>>2]=C;a:do if(z){S=0.0;T=g;U=0}else{K=0.0;M=g;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(h[N+V>>0]|0)-F)+ +n[L+(W<<2)>>2]*(+(h[N+W>>0]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(h[N+X>>0]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(h[N+Z>>0]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(h[N+V>>0]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*d;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=j+(Y(Q,m)|0)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(h[C+V>>0]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(h[C+M>>0]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(h[C+X>>0]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(h[C+Z>>0]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(h[C+V>>0]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){ZDc(L);f[i>>2]=t;f[w>>2]=1032}u=e;return}function jO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=XDc(n)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=j;H=0;while(1){if(n){if(C){I=0;do{J=i+((Y(I,l)|0)+H)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(h[J>>0]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=i+((Y(I,l)|0)+H)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(h[t>>0]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=i+M|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(h[K>>0]|0)-+p[I>>3]);P=P+R*(+(h[K+1>>0]|0)-+p[I+8>>3]);O=O+R*(+(h[K+2>>0]|0)-+p[I+16>>3]);N=N+R*(+(h[K+3>>0]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+l|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=i+K|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(h[I>>0]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+l|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+K|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(h[t>>0]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+l|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j)|0;p[v+(L<<3)>>3]=+(h[y>>0]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+T|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(h[L>>0]|0);O=O+Q*+(h[L+1>>0]|0);R=R+Q*+(h[L+2>>0]|0);F=F+Q*+(h[L+3>>0]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+l|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+U|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(h[L>>0]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+l|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=e;return}ZDc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function kO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;i=e+32|0;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=j+(Y(w,m)|0)|0;if(r){z=w;do{A=j+(Y(z,m)|0)|0;if(t){B=0;C=0.0;while(1){D=C+ +(h[y+B>>0]|0)*+(h[A+B>>0]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=j+(Y(z,m)|0)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(h[y+A>>0]|0)*+(h[B+A>>0]|0)+ +(h[y+F>>0]|0)*+(h[B+F>>0]|0)+ +(h[y+G>>0]|0)*+(h[B+G>>0]|0)+ +(h[y+H>>0]|0)*+(h[B+H>>0]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(h[y+A>>0]|0)*+(h[B+A>>0]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=i+8|0;f[i>>2]=s;v=i+4|0;f[v>>2]=w;if(w>>>0>1032){c=XDc(w)|0;f[i>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=k;k=l+H|0;while(1){H=j+(Y(G,m)|0)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(h[H+M>>0]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(h[H+M>>0]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=j+(Y(O,m)|0)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(h[M+H>>0]|0)-D)+ +p[K+(U<<3)>>3]*(+(h[M+U>>0]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(h[M+V>>0]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(h[M+W>>0]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(h[M+L>>0]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=j+(Y(P,m)|0)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(h[H+L>>0]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(h[H+V>>0]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(h[H+W>>0]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(h[H+U>>0]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(h[H+L>>0]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){ZDc(K);f[i>>2]=s;f[v>>2]=1032}u=e;return}function lO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=XDc(o)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(B){if(o){I=0;do{J=h+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(j[J>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=h+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(j[t>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=h+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(j[K>>1]|0)-+n[I>>2]);P=P+R*(+(j[K+2>>1]|0)-+n[I+4>>2]);O=O+R*(+(j[K+4>>1]|0)-+n[I+8>>2]);N=N+R*(+(j[K+6>>1]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+(l<<1)|0}}n[G+(M<<2)>>2]=Q*d;n[G+(M+1<<2)>>2]=P*d;n[G+(M+2<<2)>>2]=O*d;n[G+(M+3<<2)>>2]=N*d;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=h+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(j[I>>1]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+(l<<1)|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<1)|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(j[t>>1]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+(l<<1)|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=d*0.0;D=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,l)|0)+i<<1)|0;n[v+(L<<2)>>2]=+(j[y>>1]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(j[L>>1]|0);O=O+Q*+(j[L+2>>1]|0);R=R+Q*+(j[L+4>>1]|0);F=F+Q*+(j[L+6>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(T<<2)>>2]=P*d;n[x+(T+1<<2)>>2]=O*d;n[x+(T+2<<2)>>2]=R*d;n[x+(T+3<<2)>>2]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(j[L>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(U<<2)>>2]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=e;return}ZDc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function mO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;e=u;u=u+1056|0;g=e+1040|0;h=e;i=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=i+((Y(x,m)|0)<<1)|0;if(r){A=x;do{B=i+((Y(A,m)|0)<<1)|0;if(v){C=0;D=0.0;while(1){E=D+ +(j[z+(C<<1)>>1]|0)*+(j[B+(C<<1)>>1]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*d;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=i+((Y(A,m)|0)<<1)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(j[z+(B<<1)>>1]|0)*+(j[C+(B<<1)>>1]|0)+ +(j[z+(G<<1)>>1]|0)*+(j[C+(G<<1)>>1]|0)+ +(j[z+(H<<1)>>1]|0)*+(j[C+(H<<1)>>1]|0)+ +(j[z+(I<<1)>>1]|0)*+(j[C+(I<<1)>>1]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(j[z+(B<<1)>>1]|0)*+(j[C+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*d;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=e;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=h+8|0;f[h>>2]=t;w=h+4|0;f[w>>2]=x;if(x>>>0>1032){c=XDc(x)|0;f[h>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=g+12|0;v=g+8|0;r=g+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=g+C|0;H=0;G=k;k=l+C|0;while(1){C=i+((Y(H,m)|0)<<1)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(j[C+(N<<1)>>1]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(j[C+(N<<1)>>1]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=i+((Y(P,m)|0)<<1)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[g>>2]=C;a:do if(z){S=0.0;T=g;U=0}else{K=0.0;M=g;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(j[N+(V<<1)>>1]|0)-F)+ +n[L+(W<<2)>>2]*(+(j[N+(W<<1)>>1]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(j[N+(X<<1)>>1]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(j[N+(Z<<1)>>1]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(j[N+(V<<1)>>1]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*d;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=i+((Y(Q,m)|0)<<1)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(j[C+(V<<1)>>1]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(j[C+(M<<1)>>1]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(j[C+(X<<1)>>1]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(j[C+(Z<<1)>>1]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(j[C+(V<<1)>>1]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){ZDc(L);f[h>>2]=t;f[w>>2]=1032}u=e;return}function nO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=XDc(n)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(n){if(C){I=0;do{J=h+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(j[J>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=h+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(j[t>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=h+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(j[K>>1]|0)-+p[I>>3]);P=P+R*(+(j[K+2>>1]|0)-+p[I+8>>3]);O=O+R*(+(j[K+4>>1]|0)-+p[I+16>>3]);N=N+R*(+(j[K+6>>1]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(l<<1)|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=h+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(j[I>>1]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(l<<1)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<1)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(j[t>>1]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(l<<1)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,l)|0)+i<<1)|0;p[v+(L<<3)>>3]=+(j[y>>1]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(j[L>>1]|0);O=O+Q*+(j[L+2>>1]|0);R=R+Q*+(j[L+4>>1]|0);F=F+Q*+(j[L+6>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(j[L>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=e;return}ZDc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function oO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=i+((Y(w,m)|0)<<1)|0;if(r){z=w;do{A=i+((Y(z,m)|0)<<1)|0;if(t){B=0;C=0.0;while(1){D=C+ +(j[y+(B<<1)>>1]|0)*+(j[A+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=i+((Y(z,m)|0)<<1)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(j[y+(A<<1)>>1]|0)*+(j[B+(A<<1)>>1]|0)+ +(j[y+(F<<1)>>1]|0)*+(j[B+(F<<1)>>1]|0)+ +(j[y+(G<<1)>>1]|0)*+(j[B+(G<<1)>>1]|0)+ +(j[y+(H<<1)>>1]|0)*+(j[B+(H<<1)>>1]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(j[y+(A<<1)>>1]|0)*+(j[B+(A<<1)>>1]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=h+8|0;f[h>>2]=s;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=XDc(w)|0;f[h>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=k;k=l+H|0;while(1){H=i+((Y(G,m)|0)<<1)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(j[H+(M<<1)>>1]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(j[H+(M<<1)>>1]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=i+((Y(O,m)|0)<<1)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(j[M+(H<<1)>>1]|0)-D)+ +p[K+(U<<3)>>3]*(+(j[M+(U<<1)>>1]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(j[M+(V<<1)>>1]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(j[M+(W<<1)>>1]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(j[M+(L<<1)>>1]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=i+((Y(P,m)|0)<<1)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(j[H+(L<<1)>>1]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(j[H+(V<<1)>>1]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(j[H+(W<<1)>>1]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(j[H+(U<<1)>>1]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(j[H+(L<<1)>>1]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){ZDc(K);f[h>>2]=s;f[v>>2]=1032}u=e;return}function pO(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;g=u;u=u+1040|0;h=g;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=h+8|0;f[h>>2]=c;q=h+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=XDc(o)|0;f[h>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=e*0.0;E=e*0.0;F=e*0.0;G=j;H=0;while(1){if(B){if(o){I=0;do{J=i+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(d[J>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=i+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(d[t>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=i+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(d[K>>1]|0)-+n[I>>2]);P=P+R*(+(d[K+2>>1]|0)-+n[I+4>>2]);O=O+R*(+(d[K+4>>1]|0)-+n[I+8>>2]);N=N+R*(+(d[K+6>>1]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+(l<<1)|0}}n[G+(M<<2)>>2]=Q*e;n[G+(M+1<<2)>>2]=P*e;n[G+(M+2<<2)>>2]=O*e;n[G+(M+3<<2)>>2]=N*e;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=i+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(d[I>>1]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+(l<<1)|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*e;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+(K<<1)|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(d[t>>1]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+(l<<1)|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*e;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=e*0.0;D=e*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j<<1)|0;n[v+(L<<2)>>2]=+(d[y>>1]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(d[L>>1]|0);O=O+Q*+(d[L+2>>1]|0);R=R+Q*+(d[L+4>>1]|0);F=F+Q*+(d[L+6>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(T<<2)>>2]=P*e;n[x+(T+1<<2)>>2]=O*e;n[x+(T+2<<2)>>2]=R*e;n[x+(T+3<<2)>>2]=F*e;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(d[L>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(U<<2)>>2]=Q*e;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=g;return}ZDc(v);f[h>>2]=c;f[q>>2]=1032;u=g;return}function qO(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;g=u;u=u+1056|0;h=g+1040|0;i=g;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=g;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=j+((Y(x,m)|0)<<1)|0;if(r){A=x;do{B=j+((Y(A,m)|0)<<1)|0;if(v){C=0;D=0.0;while(1){E=D+ +(d[z+(C<<1)>>1]|0)*+(d[B+(C<<1)>>1]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*e;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=j+((Y(A,m)|0)<<1)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(d[z+(B<<1)>>1]|0)*+(d[C+(B<<1)>>1]|0)+ +(d[z+(G<<1)>>1]|0)*+(d[C+(G<<1)>>1]|0)+ +(d[z+(H<<1)>>1]|0)*+(d[C+(H<<1)>>1]|0)+ +(d[z+(I<<1)>>1]|0)*+(d[C+(I<<1)>>1]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(d[z+(B<<1)>>1]|0)*+(d[C+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*e;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=g;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=x;if(x>>>0>1032){c=XDc(x)|0;f[i>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=h+12|0;v=h+8|0;r=h+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=h+C|0;H=0;G=k;k=l+C|0;while(1){C=j+((Y(H,m)|0)<<1)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(d[C+(N<<1)>>1]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(d[C+(N<<1)>>1]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=j+((Y(P,m)|0)<<1)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[h>>2]=C;a:do if(z){S=0.0;T=h;U=0}else{K=0.0;M=h;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(d[N+(V<<1)>>1]|0)-F)+ +n[L+(W<<2)>>2]*(+(d[N+(W<<1)>>1]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(d[N+(X<<1)>>1]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(d[N+(Z<<1)>>1]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(d[N+(V<<1)>>1]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*e;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=j+((Y(Q,m)|0)<<1)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(d[C+(V<<1)>>1]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(d[C+(M<<1)>>1]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(d[C+(X<<1)>>1]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(d[C+(Z<<1)>>1]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(d[C+(V<<1)>>1]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*e;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){ZDc(L);f[i>>2]=t;f[w>>2]=1032}u=g;return}function rO(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;g=u;u=u+1040|0;h=g;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=h+8|0;f[h>>2]=c;q=h+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=XDc(n)|0;f[h>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=e*0.0;E=e*0.0;F=e*0.0;G=j;H=0;while(1){if(n){if(C){I=0;do{J=i+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(d[J>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=i+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(d[t>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=i+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(d[K>>1]|0)-+p[I>>3]);P=P+R*(+(d[K+2>>1]|0)-+p[I+8>>3]);O=O+R*(+(d[K+4>>1]|0)-+p[I+16>>3]);N=N+R*(+(d[K+6>>1]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(l<<1)|0}}p[G+(M<<3)>>3]=Q*e;p[G+(M+1<<3)>>3]=P*e;p[G+(M+2<<3)>>3]=O*e;p[G+(M+3<<3)>>3]=N*e;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=i+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(d[I>>1]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(l<<1)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*e;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+(K<<1)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(d[t>>1]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(l<<1)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*e;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=e*0.0;B=e*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j<<1)|0;p[v+(L<<3)>>3]=+(d[y>>1]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(d[L>>1]|0);O=O+Q*+(d[L+2>>1]|0);R=R+Q*+(d[L+4>>1]|0);F=F+Q*+(d[L+6>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(T<<3)>>3]=P*e;p[x+(T+1<<3)>>3]=O*e;p[x+(T+2<<3)>>3]=R*e;p[x+(T+3<<3)>>3]=F*e;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(d[L>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(U<<3)>>3]=Q*e;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=g;return}ZDc(v);f[h>>2]=c;f[q>>2]=1032;u=g;return}function sO(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;g=u;u=u+1072|0;h=g;i=g+32|0;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=g;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=j+((Y(w,m)|0)<<1)|0;if(r){z=w;do{A=j+((Y(z,m)|0)<<1)|0;if(t){B=0;C=0.0;while(1){D=C+ +(d[y+(B<<1)>>1]|0)*+(d[A+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*e;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=j+((Y(z,m)|0)<<1)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(d[y+(A<<1)>>1]|0)*+(d[B+(A<<1)>>1]|0)+ +(d[y+(F<<1)>>1]|0)*+(d[B+(F<<1)>>1]|0)+ +(d[y+(G<<1)>>1]|0)*+(d[B+(G<<1)>>1]|0)+ +(d[y+(H<<1)>>1]|0)*+(d[B+(H<<1)>>1]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(d[y+(A<<1)>>1]|0)*+(d[B+(A<<1)>>1]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*e;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=g;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=i+8|0;f[i>>2]=s;v=i+4|0;f[v>>2]=w;if(w>>>0>1032){c=XDc(w)|0;f[i>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=h+24|0;t=h+16|0;r=h+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=h+H|0;G=0;F=k;k=l+H|0;while(1){H=j+((Y(G,m)|0)<<1)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(d[H+(M<<1)>>1]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(d[H+(M<<1)>>1]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=j+((Y(O,m)|0)<<1)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[h>>3]=J;a:do if(y){R=0.0;S=h;T=0}else{E=0.0;L=h;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(d[M+(H<<1)>>1]|0)-D)+ +p[K+(U<<3)>>3]*(+(d[M+(U<<1)>>1]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(d[M+(V<<1)>>1]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(d[M+(W<<1)>>1]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(d[M+(L<<1)>>1]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*e;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=j+((Y(P,m)|0)<<1)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(d[H+(L<<1)>>1]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(d[H+(V<<1)>>1]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(d[H+(W<<1)>>1]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(d[H+(U<<1)>>1]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(d[H+(L<<1)>>1]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*e;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){ZDc(K);f[i>>2]=s;f[v>>2]=1032}u=g;return}function tO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>2;l=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;p=g+4|0;f[p>>2]=1032;q=(j|0)!=0;r=(m|0)<(a|0);m=q&r?o*20|0:o<<2;f[p>>2]=m;if(m>>>0>1032){s=XDc(m)|0;f[g>>2]=s;t=s}else t=c;a:do if(q){do if(r){s=t+(o<<2)|0;if((o|0)<=0)if(!s){v=11;break a}else{w=s;x=s;y=b|0?4:0;break}else z=0;do{m=j+((Y(z,b)|0)<<2)|0;A=f[m>>2]|0;m=z<<2;f[s+((m|3)<<2)>>2]=A;f[s+((m|2)<<2)>>2]=A;f[s+((m|1)<<2)>>2]=A;f[s+(m<<2)>>2]=A;z=z+1|0}while((z|0)!=(o|0));w=s;x=s;y=b|0?4:0}else{w=j;x=0;y=b}while(0);if((a|0)>0){A=(x|0)!=0;m=(o|0)>0;B=a+-4|0;C=d*0.0;D=d*0.0;E=d*0.0;F=i;G=0;while(1){if(A){if(m){H=0;do{I=h+((Y(H,k)|0)+G<<2)|0;J=x+((Y(H,y)|0)<<2)|0;n[t+(H<<2)>>2]=+n[I>>2]-+n[J>>2];H=H+1|0}while((H|0)!=(o|0))}}else if(m){H=0;do{s=h+((Y(H,k)|0)+G<<2)|0;J=w+((Y(H,y)|0)+G<<2)|0;n[t+(H<<2)>>2]=+n[s>>2]-+n[J>>2];H=H+1|0}while((H|0)!=(o|0))}b:do if((G|0)>(B|0))K=G;else{if(m)L=G;else{H=G;while(1){n[F+(H<<2)>>2]=E;n[F+(H+1<<2)>>2]=E;n[F+(H+2<<2)>>2]=E;n[F+(H+3<<2)>>2]=E;J=H+4|0;if((J|0)>(B|0)){K=J;break b}else H=J}}while(1){H=A?x:w+(L<<2)|0;J=h+(L<<2)|0;M=0.0;N=0.0;O=0.0;P=0.0;s=0;while(1){Q=+n[t+(s<<2)>>2];P=P+Q*(+n[J>>2]-+n[H>>2]);O=O+Q*(+n[J+4>>2]-+n[H+4>>2]);N=N+Q*(+n[J+8>>2]-+n[H+8>>2]);M=M+Q*(+n[J+12>>2]-+n[H+12>>2]);s=s+1|0;if((s|0)==(o|0))break;else{H=H+(y<<2)|0;J=J+(k<<2)|0}}n[F+(L<<2)>>2]=P*d;n[F+(L+1<<2)>>2]=O*d;n[F+(L+2<<2)>>2]=N*d;n[F+(L+3<<2)>>2]=M*d;J=L+4|0;if((J|0)>(B|0)){K=J;break}else L=J}}while(0);c:do if((K|0)<(a|0)){if(!m)if(A){J=K;while(1){n[F+(J<<2)>>2]=C;J=J+1|0;if((J|0)==(a|0))break c}}else{J=K;while(1){n[F+(J<<2)>>2]=D;J=J+1|0;if((J|0)==(a|0))break c}}if(A){J=K;do{H=h+(J<<2)|0;Q=0.0;s=x;I=0;while(1){Q=Q+ +n[t+(I<<2)>>2]*(+n[H>>2]-+n[s>>2]);I=I+1|0;if((I|0)==(o|0))break;else{H=H+(k<<2)|0;s=s+(y<<2)|0}}n[F+(J<<2)>>2]=Q*d;J=J+1|0}while((J|0)!=(a|0))}else{J=K;do{s=h+(J<<2)|0;M=0.0;H=w+(J<<2)|0;I=0;while(1){M=M+ +n[t+(I<<2)>>2]*(+n[s>>2]-+n[H>>2]);I=I+1|0;if((I|0)==(o|0))break;else{s=s+(k<<2)|0;H=H+(y<<2)|0}}n[F+(J<<2)>>2]=M*d;J=J+1|0}while((J|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else F=F+(l<<2)|0}}}else v=11;while(0);if((v|0)==11?(a|0)>0:0){v=(o|0)>0;y=a+-4|0;D=d*0.0;C=d*0.0;w=i;i=0;while(1){if(v){K=0;do{x=h+((Y(K,k)|0)+i<<2)|0;f[t+(K<<2)>>2]=f[x>>2];K=K+1|0}while((K|0)!=(o|0))}d:do if((i|0)>(y|0))R=i;else{if(v)S=i;else{K=i;while(1){n[w+(K<<2)>>2]=C;n[w+(K+1<<2)>>2]=C;n[w+(K+2<<2)>>2]=C;n[w+(K+3<<2)>>2]=C;x=K+4|0;if((x|0)>(y|0)){R=x;break d}else K=x}}while(1){K=h+(S<<2)|0;E=0.0;Q=0.0;N=0.0;O=0.0;x=0;while(1){P=+n[t+(x<<2)>>2];O=O+P*+n[K>>2];N=N+P*+n[K+4>>2];Q=Q+P*+n[K+8>>2];E=E+P*+n[K+12>>2];x=x+1|0;if((x|0)==(o|0))break;else K=K+(k<<2)|0}n[w+(S<<2)>>2]=O*d;n[w+(S+1<<2)>>2]=N*d;n[w+(S+2<<2)>>2]=Q*d;n[w+(S+3<<2)>>2]=E*d;K=S+4|0;if((K|0)>(y|0)){R=K;break}else S=K}}while(0);e:do if((R|0)<(a|0)){if(v)T=R;else{K=R;while(1){n[w+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break e}}do{K=h+(T<<2)|0;P=0.0;x=0;while(1){P=P+ +n[t+(x<<2)>>2]*+n[K>>2];x=x+1|0;if((x|0)==(o|0))break;else K=K+(k<<2)|0}n[w+(T<<2)>>2]=P*d;T=T+1|0}while((T|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else w=w+(l<<2)|0}}if((t|0)==(c|0)){u=e;return}ZDc(t);f[g>>2]=c;f[p>>2]=1032;u=e;return}function uO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0.0,$=0,aa=0,ba=0.0;e=u;u=u+1056|0;g=e+1040|0;h=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>2;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;if(!k){if((p|0)<=0){u=e;return}c=a+-4|0;q=(a|0)<4;r=a&-4;t=(a|0)>0;v=(r|0)<(a|0);w=0;x=j;while(1){y=i+((Y(w,l)|0)<<2)|0;if(q){z=w;do{A=i+((Y(z,l)|0)<<2)|0;if(t){B=0;C=0.0;while(1){D=C+ +n[y+(B<<2)>>2]*+n[A+(B<<2)>>2];B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;n[x+(z<<2)>>2]=E*d;z=z+1|0}while((z|0)!=(p|0))}else{z=w;do{B=i+((Y(z,l)|0)<<2)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+n[y+(A<<2)>>2]*+n[B+(A<<2)>>2]+ +n[y+(F<<2)>>2]*+n[B+(F<<2)>>2]+ +n[y+(G<<2)>>2]*+n[B+(G<<2)>>2]+ +n[y+(H<<2)>>2]*+n[B+(H<<2)>>2]);A=A+4|0}while((A|0)<=(c|0));if(v){A=r;D=C;while(1){I=D+ +n[y+(A<<2)>>2]*+n[B+(A<<2)>>2];A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;n[x+(z<<2)>>2]=J*d;z=z+1|0}while((z|0)!=(p|0))}w=w+1|0;if((w|0)==(p|0))break;else x=x+(m<<2)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<2;r=h+8|0;f[h>>2]=r;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=XDc(w)|0;f[h>>2]=c;K=c}else K=r;if((p|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+12|0;t=g+8|0;q=g+4|0;z=a+-4|0;y=(a|0)<4;A=a&-4;B=Y(x,A)|0;H=g+B|0;G=0;F=j;j=k+B|0;while(1){B=i+((Y(G,l)|0)<<2)|0;L=k+((Y(G,b)|0)<<2)|0;if(c)if(o){M=0;do{n[K+(M<<2)>>2]=+n[B+(M<<2)>>2]-+n[L>>2];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{n[K+(M<<2)>>2]=+n[B+(M<<2)>>2]-+n[L+(M<<2)>>2];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=j;N=31}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=j;N=31}}if((N|0)==22)while(1){N=0;M=i+((Y(O,l)|0)<<2)|0;L=k+((Y(O,b)|0)<<2)|0;B=f[L>>2]|0;f[w>>2]=B;f[t>>2]=B;f[q>>2]=B;f[g>>2]=B;a:do if(y){R=0.0;S=g;T=0}else{J=0.0;L=g;U=0;E=(f[s>>2]=B,+n[s>>2]);while(1){V=U|1;W=U|2;X=U|3;D=J+(+n[K+(U<<2)>>2]*(+n[M+(U<<2)>>2]-E)+ +n[K+(V<<2)>>2]*(+n[M+(V<<2)>>2]-+n[L+4>>2])+ +n[K+(W<<2)>>2]*(+n[M+(W<<2)>>2]-+n[L+8>>2])+ +n[K+(X<<2)>>2]*(+n[M+(X<<2)>>2]-+n[L+12>>2]));X=U+4|0;W=L+(x<<2)|0;if((X|0)>(z|0)){R=D;S=H;T=A;break a}J=D;L=W;U=X;E=+n[W>>2]}}while(0);if((T|0)<(a|0)){C=R;B=S;U=T;while(1){E=C+ +n[K+(U<<2)>>2]*(+n[M+(U<<2)>>2]-+n[B>>2]);U=U+1|0;if((U|0)==(a|0)){Z=E;break}else{C=E;B=B+4|0}}}else Z=R;n[F+(O<<2)>>2]=Z*d;O=O+1|0;if((O|0)==(p|0))break;else N=22}else if((N|0)==31)while(1){N=0;B=i+((Y(P,l)|0)<<2)|0;U=k+((Y(P,b)|0)<<2)|0;if(y){_=0.0;$=U;aa=0}else{C=0.0;M=U;U=0;while(1){L=U|1;W=U|2;X=U|3;E=C+(+n[K+(U<<2)>>2]*(+n[B+(U<<2)>>2]-+n[M>>2])+ +n[K+(L<<2)>>2]*(+n[B+(L<<2)>>2]-+n[M+4>>2])+ +n[K+(W<<2)>>2]*(+n[B+(W<<2)>>2]-+n[M+8>>2])+ +n[K+(X<<2)>>2]*(+n[B+(X<<2)>>2]-+n[M+12>>2]));U=U+4|0;if((U|0)>(z|0)){_=E;$=Q;aa=A;break}else{C=E;M=M+(x<<2)|0}}}if((aa|0)<(a|0)){C=_;M=$;U=aa;while(1){E=C+ +n[K+(U<<2)>>2]*(+n[B+(U<<2)>>2]-+n[M>>2]);U=U+1|0;if((U|0)==(a|0)){ba=E;break}else{C=E;M=M+4|0}}}else ba=_;n[F+(P<<2)>>2]=ba*d;P=P+1|0;if((P|0)==(p|0))break;else{Q=Q+(b<<2)|0;N=31}}G=G+1|0;if((G|0)==(p|0))break;else{F=F+(m<<2)|0;j=j+(b<<2)|0}}}if((K|0)!=(r|0)){ZDc(K);f[h>>2]=r;f[v>>2]=1032}u=e;return}function vO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>2;l=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(j|0)!=0;s=(m|0)<(a|0);m=r&s?o*40|0:o<<3;f[q>>2]=m;if(m>>>0>1032){t=XDc(m)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{m=j+((Y(A,b)|0)<<3)|0;B=+p[m>>3];m=A<<2;p[t+((m|3)<<3)>>3]=B;p[t+((m|2)<<3)>>3]=B;p[t+((m|1)<<3)>>3]=B;p[t+(m<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=j;y=0;z=b}while(0);if((a|0)>0){m=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(m){if(C){I=0;do{J=h+((Y(I,k)|0)+H<<2)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+n[J>>2]-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=h+((Y(I,k)|0)+H<<2)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+n[t>>2]-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=m?y:x+(M<<3)|0;K=h+(M<<2)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+n[K>>2]-+p[I>>3]);P=P+R*(+n[K+4>>2]-+p[I+8>>3]);O=O+R*(+n[K+8>>2]-+p[I+16>>3]);N=N+R*(+n[K+12>>2]-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(k<<2)|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(m){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(m){K=L;do{I=h+(K<<2)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+n[I>>2]-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(k<<2)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<2)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+n[t>>2]-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(k<<2)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(l<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,k)|0)+i<<2)|0;p[v+(L<<3)>>3]=+n[y>>2];L=L+1|0}while((L|0)!=(o|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<2)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+n[L>>2];O=O+Q*+n[L+4>>2];R=R+Q*+n[L+8>>2];F=F+Q*+n[L+12>>2];y=y+1|0;if((y|0)==(o|0))break;else L=L+(k<<2)|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<2)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+n[L>>2];y=y+1|0;if((y|0)==(o|0))break;else L=L+(k<<2)|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(l<<3)|0}}if((v|0)==(c|0)){u=e;return}ZDc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function wO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>2;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!k){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=j;while(1){y=i+((Y(w,l)|0)<<2)|0;if(r){z=w;do{A=i+((Y(z,l)|0)<<2)|0;if(t){B=0;C=0.0;while(1){D=C+ +n[y+(B<<2)>>2]*+n[A+(B<<2)>>2];B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=i+((Y(z,l)|0)<<2)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+n[y+(A<<2)>>2]*+n[B+(A<<2)>>2]+ +n[y+(F<<2)>>2]*+n[B+(F<<2)>>2]+ +n[y+(G<<2)>>2]*+n[B+(G<<2)>>2]+ +n[y+(H<<2)>>2]*+n[B+(H<<2)>>2]);A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +n[y+(A<<2)>>2]*+n[B+(A<<2)>>2];A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(m<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=h+8|0;f[h>>2]=s;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=XDc(w)|0;f[h>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=j;j=k+H|0;while(1){H=i+((Y(G,l)|0)<<2)|0;L=k+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+n[H+(M<<2)>>2]-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+n[H+(M<<2)>>2]-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=j;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=j;N=30}}if((N|0)==22)while(1){N=0;M=i+((Y(O,l)|0)<<2)|0;L=k+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+n[M+(H<<2)>>2]-D)+ +p[K+(U<<3)>>3]*(+n[M+(U<<2)>>2]-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+n[M+(V<<2)>>2]-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+n[M+(W<<2)>>2]-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+n[M+(L<<2)>>2]-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=i+((Y(P,l)|0)<<2)|0;L=k+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+n[H+(L<<2)>>2]-+p[M>>3])+ +p[K+(V<<3)>>3]*(+n[H+(V<<2)>>2]-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+n[H+(W<<2)>>2]-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+n[H+(U<<2)>>2]-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+n[H+(L<<2)>>2]-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(m<<3)|0;j=j+(b<<3)|0}}}if((K|0)!=(s|0)){ZDc(K);f[h>>2]=s;f[v>>2]=1032}u=e;return}function xO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>3;l=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;n=f[c>>2]|0;c=g+8|0;f[g>>2]=c;o=g+4|0;f[o>>2]=1032;q=(j|0)!=0;r=(m|0)<(a|0);m=q&r?n*40|0:n<<3;f[o>>2]=m;if(m>>>0>1032){s=XDc(m)|0;f[g>>2]=s;t=s}else t=c;a:do if(q){do if(r){s=t+(n<<3)|0;if((n|0)<=0)if(!s){v=11;break a}else{w=s;x=s;y=b|0?4:0;break}else z=0;do{m=j+((Y(z,b)|0)<<3)|0;A=+p[m>>3];m=z<<2;p[s+((m|3)<<3)>>3]=A;p[s+((m|2)<<3)>>3]=A;p[s+((m|1)<<3)>>3]=A;p[s+(m<<3)>>3]=A;z=z+1|0}while((z|0)!=(n|0));w=s;x=s;y=b|0?4:0}else{w=j;x=0;y=b}while(0);if((a|0)>0){m=(x|0)!=0;B=(n|0)>0;C=a+-4|0;A=d*0.0;D=d*0.0;E=d*0.0;F=i;G=0;while(1){if(m){if(B){H=0;do{I=h+((Y(H,k)|0)+G<<3)|0;J=x+((Y(H,y)|0)<<3)|0;p[t+(H<<3)>>3]=+p[I>>3]-+p[J>>3];H=H+1|0}while((H|0)!=(n|0))}}else if(B){H=0;do{s=h+((Y(H,k)|0)+G<<3)|0;J=w+((Y(H,y)|0)+G<<3)|0;p[t+(H<<3)>>3]=+p[s>>3]-+p[J>>3];H=H+1|0}while((H|0)!=(n|0))}b:do if((G|0)>(C|0))K=G;else{if(B)L=G;else{H=G;while(1){p[F+(H<<3)>>3]=E;p[F+(H+1<<3)>>3]=E;p[F+(H+2<<3)>>3]=E;p[F+(H+3<<3)>>3]=E;J=H+4|0;if((J|0)>(C|0)){K=J;break b}else H=J}}while(1){H=m?x:w+(L<<3)|0;J=h+(L<<3)|0;M=0.0;N=0.0;O=0.0;P=0.0;s=0;while(1){Q=+p[t+(s<<3)>>3];P=P+Q*(+p[J>>3]-+p[H>>3]);O=O+Q*(+p[J+8>>3]-+p[H+8>>3]);N=N+Q*(+p[J+16>>3]-+p[H+16>>3]);M=M+Q*(+p[J+24>>3]-+p[H+24>>3]);s=s+1|0;if((s|0)==(n|0))break;else{H=H+(y<<3)|0;J=J+(k<<3)|0}}p[F+(L<<3)>>3]=P*d;p[F+(L+1<<3)>>3]=O*d;p[F+(L+2<<3)>>3]=N*d;p[F+(L+3<<3)>>3]=M*d;J=L+4|0;if((J|0)>(C|0)){K=J;break}else L=J}}while(0);c:do if((K|0)<(a|0)){if(!B)if(m){J=K;while(1){p[F+(J<<3)>>3]=A;J=J+1|0;if((J|0)==(a|0))break c}}else{J=K;while(1){p[F+(J<<3)>>3]=D;J=J+1|0;if((J|0)==(a|0))break c}}if(m){J=K;do{H=h+(J<<3)|0;Q=0.0;s=x;I=0;while(1){Q=Q+ +p[t+(I<<3)>>3]*(+p[H>>3]-+p[s>>3]);I=I+1|0;if((I|0)==(n|0))break;else{H=H+(k<<3)|0;s=s+(y<<3)|0}}p[F+(J<<3)>>3]=Q*d;J=J+1|0}while((J|0)!=(a|0))}else{J=K;do{s=h+(J<<3)|0;M=0.0;H=w+(J<<3)|0;I=0;while(1){M=M+ +p[t+(I<<3)>>3]*(+p[s>>3]-+p[H>>3]);I=I+1|0;if((I|0)==(n|0))break;else{s=s+(k<<3)|0;H=H+(y<<3)|0}}p[F+(J<<3)>>3]=M*d;J=J+1|0}while((J|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else F=F+(l<<3)|0}}}else v=11;while(0);if((v|0)==11?(a|0)>0:0){v=(n|0)>0;y=a+-4|0;D=d*0.0;A=d*0.0;w=i;i=0;while(1){if(v){K=0;do{x=h+((Y(K,k)|0)+i<<3)|0;p[t+(K<<3)>>3]=+p[x>>3];K=K+1|0}while((K|0)!=(n|0))}d:do if((i|0)>(y|0))R=i;else{if(v)S=i;else{K=i;while(1){p[w+(K<<3)>>3]=A;p[w+(K+1<<3)>>3]=A;p[w+(K+2<<3)>>3]=A;p[w+(K+3<<3)>>3]=A;x=K+4|0;if((x|0)>(y|0)){R=x;break d}else K=x}}while(1){K=h+(S<<3)|0;E=0.0;Q=0.0;N=0.0;O=0.0;x=0;while(1){P=+p[t+(x<<3)>>3];O=O+P*+p[K>>3];N=N+P*+p[K+8>>3];Q=Q+P*+p[K+16>>3];E=E+P*+p[K+24>>3];x=x+1|0;if((x|0)==(n|0))break;else K=K+(k<<3)|0}p[w+(S<<3)>>3]=O*d;p[w+(S+1<<3)>>3]=N*d;p[w+(S+2<<3)>>3]=Q*d;p[w+(S+3<<3)>>3]=E*d;K=S+4|0;if((K|0)>(y|0)){R=K;break}else S=K}}while(0);e:do if((R|0)<(a|0)){if(v)T=R;else{K=R;while(1){p[w+(K<<3)>>3]=D;K=K+1|0;if((K|0)==(a|0))break e}}do{K=h+(T<<3)|0;P=0.0;x=0;while(1){P=P+ +p[t+(x<<3)>>3]*+p[K>>3];x=x+1|0;if((x|0)==(n|0))break;else K=K+(k<<3)|0}p[w+(T<<3)>>3]=P*d;T=T+1|0}while((T|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else w=w+(l<<3)|0}}if((t|0)==(c|0)){u=e;return}ZDc(t);f[g>>2]=c;f[o>>2]=1032;u=e;return}function yO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>3;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;if(!k){if((o|0)<=0){u=e;return}c=a+-4|0;q=(a|0)<4;r=a&-4;s=(a|0)>0;t=(r|0)<(a|0);v=0;w=j;while(1){x=i+((Y(v,l)|0)<<3)|0;if(q){y=v;do{z=i+((Y(y,l)|0)<<3)|0;if(s){A=0;B=0.0;while(1){C=B+ +p[x+(A<<3)>>3]*+p[z+(A<<3)>>3];A=A+1|0;if((A|0)==(a|0)){D=C;break}else B=C}}else D=0.0;p[w+(y<<3)>>3]=D*d;y=y+1|0}while((y|0)!=(o|0))}else{y=v;do{A=i+((Y(y,l)|0)<<3)|0;z=0;B=0.0;do{E=z|1;F=z|2;G=z|3;B=B+(+p[x+(z<<3)>>3]*+p[A+(z<<3)>>3]+ +p[x+(E<<3)>>3]*+p[A+(E<<3)>>3]+ +p[x+(F<<3)>>3]*+p[A+(F<<3)>>3]+ +p[x+(G<<3)>>3]*+p[A+(G<<3)>>3]);z=z+4|0}while((z|0)<=(c|0));if(t){z=r;C=B;while(1){H=C+ +p[x+(z<<3)>>3]*+p[A+(z<<3)>>3];z=z+1|0;if((z|0)==(a|0)){I=H;break}else C=H}}else I=B;p[w+(y<<3)>>3]=I*d;y=y+1|0}while((y|0)!=(o|0))}v=v+1|0;if((v|0)==(o|0))break;else w=w+(m<<3)|0}u=e;return}w=(n|0)==(a|0)?4:0;v=a<<3;r=h+8|0;f[h>>2]=r;t=h+4|0;f[t>>2]=v;if(v>>>0>1032){c=XDc(v)|0;f[h>>2]=c;J=c}else J=r;if((o|0)>0){c=(n|0)<(a|0);n=(a|0)>0;v=g+24|0;s=g+16|0;q=g+8|0;y=a+-4|0;x=(a|0)<4;z=y>>>2;A=(z<<2)+4|0;G=Y(w,(z<<3)+8|0)|0;z=g+G|0;F=0;E=j;j=k+G|0;while(1){G=i+((Y(F,l)|0)<<3)|0;K=k+((Y(F,b)|0)<<3)|0;if(c)if(n){L=0;do{p[J+(L<<3)>>3]=+p[G+(L<<3)>>3]-+p[K>>3];L=L+1|0}while((L|0)!=(a|0));M=21}else{N=F;M=22}else if(n){L=0;do{p[J+(L<<3)>>3]=+p[G+(L<<3)>>3]-+p[K+(L<<3)>>3];L=L+1|0}while((L|0)!=(a|0));M=21}else{O=F;P=j;M=30}if((M|0)==21){M=0;if(c){N=F;M=22}else{O=F;P=j;M=30}}if((M|0)==22)while(1){M=0;L=i+((Y(N,l)|0)<<3)|0;K=k+((Y(N,b)|0)<<3)|0;I=+p[K>>3];p[v>>3]=I;p[s>>3]=I;p[q>>3]=I;p[g>>3]=I;a:do if(x){Q=0.0;R=g;S=0}else{D=0.0;K=g;G=0;C=I;while(1){T=G|1;U=G|2;V=G|3;H=D+(+p[J+(G<<3)>>3]*(+p[L+(G<<3)>>3]-C)+ +p[J+(T<<3)>>3]*(+p[L+(T<<3)>>3]-+p[K+8>>3])+ +p[J+(U<<3)>>3]*(+p[L+(U<<3)>>3]-+p[K+16>>3])+ +p[J+(V<<3)>>3]*(+p[L+(V<<3)>>3]-+p[K+24>>3]));V=G+4|0;U=K+(w<<3)|0;if((V|0)>(y|0)){Q=H;R=z;S=A;break a}D=H;K=U;G=V;C=+p[U>>3]}}while(0);if((S|0)<(a|0)){I=Q;G=R;K=S;while(1){B=I+ +p[J+(K<<3)>>3]*(+p[L+(K<<3)>>3]-+p[G>>3]);K=K+1|0;if((K|0)==(a|0)){W=B;break}else{I=B;G=G+8|0}}}else W=Q;p[E+(N<<3)>>3]=W*d;N=N+1|0;if((N|0)==(o|0))break;else M=22}else if((M|0)==30)while(1){M=0;G=i+((Y(O,l)|0)<<3)|0;K=k+((Y(O,b)|0)<<3)|0;if(x){X=0.0;Z=K;_=0}else{I=0.0;L=K;K=0;while(1){U=K|1;V=K|2;T=K|3;B=I+(+p[J+(K<<3)>>3]*(+p[G+(K<<3)>>3]-+p[L>>3])+ +p[J+(U<<3)>>3]*(+p[G+(U<<3)>>3]-+p[L+8>>3])+ +p[J+(V<<3)>>3]*(+p[G+(V<<3)>>3]-+p[L+16>>3])+ +p[J+(T<<3)>>3]*(+p[G+(T<<3)>>3]-+p[L+24>>3]));K=K+4|0;if((K|0)>(y|0)){X=B;Z=P;_=A;break}else{I=B;L=L+(w<<3)|0}}}if((_|0)<(a|0)){I=X;L=Z;K=_;while(1){B=I+ +p[J+(K<<3)>>3]*(+p[G+(K<<3)>>3]-+p[L>>3]);K=K+1|0;if((K|0)==(a|0)){$=B;break}else{I=B;L=L+8|0}}}else $=X;p[E+(O<<3)>>3]=$*d;O=O+1|0;if((O|0)==(o|0))break;else{P=P+(b<<3)|0;M=30}}F=F+1|0;if((F|0)==(o|0))break;else{E=E+(m<<3)|0;j=j+(b<<3)|0}}}if((J|0)!=(r|0)){ZDc(J);f[h>>2]=r;f[t>>2]=1032}u=e;return}function zO(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0;d=u;u=u+112|0;e=d+56|0;g=d+40|0;h=d;i=d+8|0;do if((d$(c)|0)==65536){j=f[c+4>>2]|0;f[e>>2]=f[j>>2];k=e+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[e+16>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[e+36>>2]=n;f[e+40>>2]=m;m=e+48|0;o=e+44|0;f[o>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];p=e;break}else{f[k>>2]=0;ZS(e,j);p=e;break}}else{a$(e,c,-1);p=e}while(0);c=f[a>>2]|0;j=(c>>>3&511)+1|0;k=c&7;l=f[41436+(k<<2)>>2]|0;m=f[p>>2]|0;if((m^c)&4095|0){f[g>>2]=0;f[g+4>>2]=0;q=tT(g,20)|0;r=213444;s=q+20|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,g,213465,212648,3274)}p=e+40|0;o=f[p>>2]|0;n=f[o+-4>>2]|0;t=f[a+40>>2]|0;if((n|0)!=(f[t+-4>>2]|0)){f[g>>2]=0;v=g+4|0;f[v>>2]=0;w=tT(g,16)|0;q=w;r=213469;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,g,213465,212648,3274)}a:do if((n|0)==2){if((f[o>>2]|0)!=(f[t>>2]|0)){f[g>>2]=0;v=g+4|0;f[v>>2]=0;w=tT(g,16)|0;q=w;r=213469;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,g,213465,212648,3274)}if((f[o+4>>2]|0)!=(f[t+4>>2]|0)){f[g>>2]=0;v=g+4|0;f[v>>2]=0;w=tT(g,16)|0;q=w;r=213469;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,g,213465,212648,3274)}}else if((n|0)>0){x=0;while(1){if((f[o+(x<<2)>>2]|0)!=(f[t+(x<<2)>>2]|0))break;x=x+1|0;if((x|0)>=(n|0))break a}f[g>>2]=0;v=g+4|0;f[v>>2]=0;w=tT(g,16)|0;q=w;r=213469;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,g,213465,212648,3274)}while(0);if((k|0)==7){f[g>>2]=0;f[g+4>>2]=0;q=tT(g,9)|0;r=251213;s=q+9|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,g,213465,212648,3274)}if(!(c&m&16384)){f[g>>2]=a;f[g+4>>2]=e;f[g+8>>2]=0;m=h;f[m>>2]=0;f[m+4>>2]=0;z2(i,g,h,-1);g=Y(f[i+20>>2]|0,j)|0;m=i+16|0;c=h+4|0;r=0;y=0.0;while(1){if(r>>>0>=(f[m>>2]|0)>>>0)break;z=y+ +Sh[l&31](f[h>>2]|0,f[c>>2]|0,g);A2(i)|0;r=r+1|0;y=z}A=y}else{r=f[a+4>>2]|0;if((r|0)<3)B=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{i=0;g=1;while(1){c=Y(f[t+(i<<2)>>2]|0,g)|0;i=i+1|0;if((i|0)==(r|0)){B=c;break}else g=c}}g=Y(B,j)|0;A=+Sh[l&31](f[a+16>>2]|0,f[e+16>>2]|0,g)}g=e+36|0;a=f[g>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)_S(e);f[g>>2]=0;g=e+16|0;a=e+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[a>>2]|0)>0){g=f[p>>2]|0;p=0;do{f[g+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[a>>2]|0))}a=f[e+44>>2]|0;if((a|0)==(e+48|0)){u=d;return +A}g0(a);u=d;return +A}function AO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;i=0.0;do{j=g|1;k=g|2;l=g|3;i=i+(+(h[a+g>>0]|0)*+(h[b+g>>0]|0)+ +(h[a+j>>0]|0)*+(h[b+j>>0]|0)+ +(h[a+k>>0]|0)*+(h[b+k>>0]|0)+ +(h[a+l>>0]|0)*+(h[b+l>>0]|0));g=g+4|0}while((g|0)<=(d|0));e=i;f=c&-4}if((f|0)<(c|0)){m=f;n=e}else{o=e;p=o+0.0;return +p}while(1){e=n+ +(h[a+m>>0]|0)*+(h[b+m>>0]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}p=o+0.0;return +p}function BO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=d+-4|0;if((d|0)<4){f=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(b[a+h>>0]|0)*+(b[c+h>>0]|0)+ +(b[a+j>>0]|0)*+(b[c+j>>0]|0)+ +(b[a+k>>0]|0)*+(b[c+k>>0]|0)+ +(b[a+l>>0]|0)*+(b[c+l>>0]|0));h=h+4|0}while((h|0)<=(e|0));f=i;g=d&-4}if((g|0)<(d|0)){m=g;n=f}else{o=f;p=o+0.0;return +p}while(1){f=n+ +(b[a+m>>0]|0)*+(b[c+m>>0]|0);m=m+1|0;if((m|0)==(d|0)){o=f;break}else n=f}p=o+0.0;return +p}function CO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,k=0,l=0,m=0,n=0.0,o=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;k=g|2;l=g|3;h=h+(+(j[a+(g<<1)>>1]|0)*+(j[b+(g<<1)>>1]|0)+ +(j[a+(i<<1)>>1]|0)*+(j[b+(i<<1)>>1]|0)+ +(j[a+(k<<1)>>1]|0)*+(j[b+(k<<1)>>1]|0)+ +(j[a+(l<<1)>>1]|0)*+(j[b+(l<<1)>>1]|0));g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){m=f;n=e}else{o=e;return +o}while(1){e=n+ +(j[a+(m<<1)>>1]|0)*+(j[b+(m<<1)>>1]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}return +o}function DO(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;e=c+-4|0;if((c|0)<4){f=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(d[a+(h<<1)>>1]|0)*+(d[b+(h<<1)>>1]|0)+ +(d[a+(j<<1)>>1]|0)*+(d[b+(j<<1)>>1]|0)+ +(d[a+(k<<1)>>1]|0)*+(d[b+(k<<1)>>1]|0)+ +(d[a+(l<<1)>>1]|0)*+(d[b+(l<<1)>>1]|0));h=h+4|0}while((h|0)<=(e|0));f=i;g=c&-4}if((g|0)<(c|0)){m=g;n=f}else{o=f;return +o}while(1){f=n+ +(d[a+(m<<1)>>1]|0)*+(d[b+(m<<1)>>1]|0);m=m+1|0;if((m|0)==(c|0)){o=f;break}else n=f}return +o}function EO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;d=c+-4|0;if((c|0)<4){e=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(f[a+(h<<2)>>2]|0)*+(f[b+(h<<2)>>2]|0)+ +(f[a+(j<<2)>>2]|0)*+(f[b+(j<<2)>>2]|0)+ +(f[a+(k<<2)>>2]|0)*+(f[b+(k<<2)>>2]|0)+ +(f[a+(l<<2)>>2]|0)*+(f[b+(l<<2)>>2]|0));h=h+4|0}while((h|0)<=(d|0));e=i;g=c&-4}if((g|0)<(c|0)){m=g;n=e}else{o=e;return +o}while(1){e=n+ +(f[a+(m<<2)>>2]|0)*+(f[b+(m<<2)>>2]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}return +o}function FO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;j=g|2;k=g|3;h=h+(+n[a+(g<<2)>>2]*+n[b+(g<<2)>>2]+ +n[a+(i<<2)>>2]*+n[b+(i<<2)>>2]+ +n[a+(j<<2)>>2]*+n[b+(j<<2)>>2]+ +n[a+(k<<2)>>2]*+n[b+(k<<2)>>2]);g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){l=f;m=e}else{o=e;p=o+0.0;return +p}while(1){e=m+ +n[a+(l<<2)>>2]*+n[b+(l<<2)>>2];l=l+1|0;if((l|0)==(c|0)){o=e;break}else m=e}p=o+0.0;return +p}function GO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0.0,n=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;j=g|2;k=g|3;h=h+(+p[a+(g<<3)>>3]*+p[b+(g<<3)>>3]+ +p[a+(i<<3)>>3]*+p[b+(i<<3)>>3]+ +p[a+(j<<3)>>3]*+p[b+(j<<3)>>3]+ +p[a+(k<<3)>>3]*+p[b+(k<<3)>>3]);g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){l=f;m=e}else{n=e;return +n}while(1){e=m+ +p[a+(l<<3)>>3]*+p[b+(l<<3)>>3];l=l+1|0;if((l|0)==(c|0)){n=e;break}else m=e}return +n}function HO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){XIc(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;g=j+b|0;k=i;if(g>>>0>536870911)mCc(a);l=d-i|0;d=l>>2;m=l>>3>>>0<268435455?(d>>>0<g>>>0?g:d):536870911;do if(m)if(m>>>0>536870911){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{n=VDc(m<<3)|0;break}else n=0;while(0);d=n+(j<<3)|0;j=n+(m<<3)|0;XIc(d|0,0,b<<3|0)|0;m=d+(b<<3)|0;if((h|0)==(k|0)){o=d;p=i}else{b=h+-8-i|0;i=h;h=d;do{n=h;h=h+-8|0;g=i;i=i+-8|0;f[h>>2]=f[i>>2];f[n+-4>>2]=f[g+-4>>2]}while((i|0)!=(k|0));o=d+(~(b>>>3)<<3)|0;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;YDc(p);return}function IO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/28|0)>>>0>=b>>>0){i=b;j=h;while(1){n[j>>2]=0.0;n[j+4>>2]=0.0;n[j+8>>2]=0.0;n[j+12>>2]=-1.0;n[j+16>>2]=0.0;f[j+20>>2]=0;f[j+24>>2]=-1;i=i+-1|0;if(!i)break;else j=j+28|0}f[e>>2]=h+(b*28|0);return}j=f[a>>2]|0;i=(g-j|0)/28|0;k=i+b|0;l=j;if(k>>>0>153391689)mCc(a);m=(d-j|0)/28|0;j=m<<1;d=m>>>0<76695844?(j>>>0<k>>>0?k:j):153391689;do if(d)if(d>>>0>153391689){j=af(8)|0;bEc(j,503977);f[j>>2]=185532;ig(j|0,23696,1627)}else{o=VDc(d*28|0)|0;break}else o=0;while(0);j=o+(i*28|0)|0;i=o+(d*28|0)|0;d=b;o=j;while(1){n[o>>2]=0.0;n[o+4>>2]=0.0;n[o+8>>2]=0.0;n[o+12>>2]=-1.0;n[o+16>>2]=0.0;f[o+20>>2]=0;f[o+24>>2]=-1;d=d+-1|0;if(!d)break;else o=o+28|0}o=j;d=i;i=j+(b*28|0)|0;if((h|0)==(l|0)){p=o;q=g}else{g=h;h=o;o=j;do{j=g;g=g+-28|0;f[o+-28>>2]=f[g>>2];f[o+-24>>2]=f[j+-24>>2];b=o+-20|0;k=j+-20|0;f[b>>2]=f[k>>2];f[b+4>>2]=f[k+4>>2];f[b+8>>2]=f[k+8>>2];f[b+12>>2]=f[k+12>>2];f[b+16>>2]=f[k+16>>2];o=h+-28|0;h=o}while((g|0)!=(l|0));p=h;q=f[a>>2]|0}f[a>>2]=p;f[e>>2]=i;f[c>>2]=d;if(!q)return;YDc(q);return}function JO(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0,k=0.0;c=+n[a+16>>2]*3.141592653589793/180.0;d=+O(+c)*.5;e=+P(+c)*.5;c=+n[a+12>>2];f=e*c;g=+n[a+8>>2];h=d*g;i=+n[a>>2]-f-h;n[b>>2]=i;j=a+4|0;k=d*c;c=e*g;g=k+ +n[j>>2]-c;n[b+4>>2]=g;e=f+ +n[a>>2]-h;n[b+8>>2]=e;h=+n[j>>2]-k-c;n[b+12>>2]=h;n[b+16>>2]=+n[a>>2]*2.0-i;n[b+20>>2]=+n[j>>2]*2.0-g;n[b+24>>2]=+n[a>>2]*2.0-e;n[b+28>>2]=+n[j>>2]*2.0-h;return}function KO(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0;c=+n[b+16>>2]*3.141592653589793/180.0;d=+O(+c)*.5;e=+P(+c)*.5;c=+n[b>>2];g=+n[b+12>>2];h=e*g;i=+n[b+8>>2];j=d*i;k=c-h-j;l=+n[b+4>>2];m=d*g;g=e*i;i=m+l-g;e=h+c-j;j=l-m-g;g=c*2.0;c=g-k;m=l*2.0;l=m-i;h=g-e;g=m-j;m=e<k?e:k;d=c<m?c:m;m=h<d?h:d;b=~~m;o=b-(+(b|0)>m&1)|0;m=j<i?j:i;d=l<m?l:m;m=g<d?g:d;b=~~m;p=b-(+(b|0)>m&1)|0;m=k<e?e:k;k=m<c?c:m;m=k<h?h:k;b=~~m;k=i<j?j:i;i=k<l?l:k;k=i<g?g:i;q=~~k;f[a>>2]=o;f[a+4>>2]=p;f[a+8>>2]=(+(b|0)<m&1)+b+1-o;f[a+12>>2]=1-p+((+(q|0)<k&1)+q);return}function LO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+48|0;d=c+16|0;e=c+12|0;g=c+8|0;h=c+4|0;i=c;j=+n[b+16>>2]*3.141592653589793/180.0;k=+O(+j)*.5;l=+P(+j)*.5;j=+n[b>>2];m=+n[b+12>>2];o=l*m;p=+n[b+8>>2];q=k*p;r=j-o-q;n[d>>2]=r;t=+n[b+4>>2];v=k*m;m=l*p;p=v+t-m;b=d+4|0;n[b>>2]=p;l=o+j-q;w=d+8|0;n[w>>2]=l;q=t-v-m;x=d+12|0;n[x>>2]=q;m=j*2.0;j=m-r;y=d+16|0;n[y>>2]=j;v=t*2.0;t=v-p;z=d+20|0;n[z>>2]=t;o=m-l;A=d+24|0;n[A>>2]=o;m=v-q;B=d+28|0;n[B>>2]=m;C=l<r?w:d;D=j<+n[C>>2]?y:C;C=f[(o<+n[D>>2]?A:D)>>2]|0;D=q<p?x:b;E=t<+n[D>>2]?z:D;D=f[(m<+n[E>>2]?B:E)>>2]|0;f[e>>2]=C;f[g>>2]=D;E=r<l?w:d;d=+n[E>>2]<j?y:E;E=f[(+n[d>>2]<o?A:d)>>2]|0;d=p<q?x:b;b=+n[d>>2]<t?z:d;d=f[(+n[b>>2]<m?B:b)>>2]|0;f[h>>2]=E;f[i>>2]=d;m=(f[s>>2]=E,+n[s>>2]);t=(f[s>>2]=C,+n[s>>2]);C=f[(m<t?h:e)>>2]|0;f[a>>2]=C;q=(f[s>>2]=d,+n[s>>2]);p=(f[s>>2]=D,+n[s>>2]);D=f[(q<p?i:g)>>2]|0;f[a+4>>2]=D;n[a+8>>2]=(t<m?m:t)-(f[s>>2]=C,+n[s>>2]);n[a+12>>2]=(p<q?q:p)-(f[s>>2]=D,+n[s>>2]);u=c;return}function MO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0;switch(c|0){case 1:{d=JY(a,b)|0;return d|0}case 2:{e=213998;break}case 4:{e=213742;break}default:{d=-1;return d|0}}c=b+-4|0;if((b|0)<4){f=0;g=0}else{i=0;j=0;do{j=(h[e+(h[a+i>>0]|0)>>0]|0)+j+(h[e+(h[a+(i|1)>>0]|0)>>0]|0)+(h[e+(h[a+(i|2)>>0]|0)>>0]|0)+(h[e+(h[a+(i|3)>>0]|0)>>0]|0)|0;i=i+4|0}while((i|0)<=(c|0));f=j;g=b&-4}if((g|0)<(b|0)){k=g;l=f}else{d=f;return d|0}while(1){f=(h[e+(h[a+k>>0]|0)>>0]|0)+l|0;k=k+1|0;if((k|0)==(b|0)){d=f;break}else l=f}return d|0}function NO(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;switch(e|0){case 1:{f=KY(a,c,d)|0;return f|0}case 2:{g=213998;break}case 4:{g=213742;break}default:{f=-1;return f|0}}e=d+-4|0;if((d|0)<4){i=0;j=0}else{k=0;l=0;do{m=k|1;n=k|2;o=k|3;l=(h[g+((b[c+k>>0]^b[a+k>>0])&255)>>0]|0)+l+(h[g+((b[c+m>>0]^b[a+m>>0])&255)>>0]|0)+(h[g+((b[c+n>>0]^b[a+n>>0])&255)>>0]|0)+(h[g+((b[c+o>>0]^b[a+o>>0])&255)>>0]|0)|0;k=k+4|0}while((k|0)<=(e|0));i=l;j=d&-4}if((j|0)<(d|0)){p=j;q=i}else{f=i;return f|0}while(1){i=(h[g+((b[c+p>>0]^b[a+p>>0])&255)>>0]|0)+q|0;p=p+1|0;if((p|0)==(d|0)){f=i;break}else q=i}return f|0}function OO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0;d=c+-4|0;if((c|0)<4){e=0;f=0.0}else{g=0.0;h=0;do{i=+n[a+(h<<2)>>2]-+n[b+(h<<2)>>2];j=h|1;k=+n[a+(j<<2)>>2]-+n[b+(j<<2)>>2];j=h|2;l=+n[a+(j<<2)>>2]-+n[b+(j<<2)>>2];j=h|3;m=+n[a+(j<<2)>>2]-+n[b+(j<<2)>>2];g=g+(i*i+k*k+l*l+m*m);h=h+4|0}while((h|0)<=(d|0));e=c&-4;f=g}if((e|0)<(c|0)){o=f;p=e}else{q=f;return +q}while(1){f=+n[a+(p<<2)>>2]-+n[b+(p<<2)>>2];g=o+f*f;p=p+1|0;if((p|0)==(c|0)){q=g;break}else o=g}return +q}function PO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,N=0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=u;u=u+256|0;g=e+200|0;i=e+144|0;j=e+88|0;k=e+32|0;l=e;m=e+56|0;o=e+48|0;q=c&7;r=(q|0)==1;t=(q|0)==2;v=(q|0)==4;w=(q|0)==5;x=c&255;switch(x&7){case 1:case 2:case 4:case 5:break;default:{if((q|1|0)!=7){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,177)|0;dJc(z|0,214254,177)|0;QO(g,214432,633)}if(c$(a,-1)|0){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,177)|0;dJc(z|0,214254,177)|0;QO(g,214432,633)}}}do if((d$(a)|0)==65536){z=f[a+4>>2]|0;f[g>>2]=f[z>>2];y=g+4|0;c=z+4|0;f[y>>2]=f[c>>2];A=g+8|0;f[A>>2]=f[z+8>>2];f[g+12>>2]=f[z+12>>2];f[g+16>>2]=f[z+16>>2];f[g+20>>2]=f[z+20>>2];f[g+24>>2]=f[z+24>>2];f[g+28>>2]=f[z+28>>2];f[g+32>>2]=f[z+32>>2];B=f[z+36>>2]|0;f[g+36>>2]=B;f[g+40>>2]=A;A=g+48|0;C=g+44|0;f[C>>2]=A;f[A>>2]=0;f[g+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[c>>2]|0)<3){c=f[z+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[c>>2];f[A+4>>2]=f[c+4>>2];break}else{f[y>>2]=0;ZS(g,z);break}}else a$(g,a,-1);while(0);do if((d$(d)|0)==65536){a=f[d+4>>2]|0;f[i>>2]=f[a>>2];z=i+4|0;y=a+4|0;f[z>>2]=f[y>>2];c=i+8|0;f[c>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[i+36>>2]=A;f[i+40>>2]=c;c=i+48|0;C=i+44|0;f[C>>2]=c;f[c>>2]=0;f[i+52>>2]=0;if(A|0){c=A+12|0;f[c>>2]=(f[c>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;c=f[C>>2]|0;f[c>>2]=f[y>>2];f[c+4>>2]=f[y+4>>2];break}else{f[z>>2]=0;ZS(i,a);break}}else a$(i,d,-1);while(0);d=f[g>>2]|0;a=d&7;z=(d>>>3&511)+1|0;y=f[i+16>>2]|0;a:do if(!(d&16384))D=64;else{if(y|0){c=f[i+4>>2]|0;if((c|0)<3)E=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{C=f[i+40>>2]|0;A=0;B=1;while(1){F=Y(f[C+(A<<2)>>2]|0,B)|0;A=A+1|0;if((A|0)==(c|0)){E=F;break}else B=F}}if(!((c|0)==0|(E|0)==0)){D=64;break}}B=f[g+4>>2]|0;if((B|0)<3)G=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{A=f[g+40>>2]|0;C=0;F=1;while(1){H=Y(f[A+(C<<2)>>2]|0,F)|0;C=C+1|0;if((C|0)==(B|0)){G=H;break}else F=H}}F=Y(G,z)|0;switch(d&7){case 5:break;case 0:{B=f[g+16>>2]|0;switch(x&7){case 6:{I=+(JY(B,F)|0);break a;break}case 7:break;default:{D=64;break a}}C=F+-4|0;if((F|0)<4){J=0;K=0}else{A=0;c=0;do{c=(h[213998+(h[B+A>>0]|0)>>0]|0)+c+(h[213998+(h[B+(A|1)>>0]|0)>>0]|0)+(h[213998+(h[B+(A|2)>>0]|0)>>0]|0)+(h[213998+(h[B+(A|3)>>0]|0)>>0]|0)|0;A=A+4|0}while((A|0)<=(C|0));J=c;K=F&-4}if((K|0)<(F|0)){C=K;A=J;while(1){H=(h[213998+(h[B+C>>0]|0)>>0]|0)+A|0;C=C+1|0;if((C|0)==(F|0)){N=H;break}else A=H}}else N=J;I=+(N|0);break a;break}default:{D=64;break a}}A=f[g+16>>2]|0;if(v){C=F+-4|0;if((F|0)<4){O=0.0;P=0}else{B=0;Q=0.0;do{R=+n[A+(B<<2)>>2];S=+n[A+((B|1)<<2)>>2];T=+n[A+((B|2)<<2)>>2];U=+n[A+((B|3)<<2)>>2];Q=Q+(R*R+S*S+T*T+U*U);B=B+4|0}while((B|0)<=(C|0));O=Q;P=F&-4}if((P|0)<(F|0)){C=P;U=O;while(1){T=+n[A+(C<<2)>>2];S=U+T*T;C=C+1|0;if((C|0)==(F|0)){V=S;break}else U=S}}else V=O;I=+M(+(V+0.0));break}if(w){C=F+-4|0;if((F|0)<4){W=0.0;X=0}else{B=0;U=0.0;do{Q=+n[A+(B<<2)>>2];S=+n[A+((B|1)<<2)>>2];T=+n[A+((B|2)<<2)>>2];R=+n[A+((B|3)<<2)>>2];U=U+(Q*Q+S*S+T*T+R*R);B=B+4|0}while((B|0)<=(C|0));W=U;X=F&-4}if((X|0)<(F|0)){C=X;R=W;while(1){T=+n[A+(C<<2)>>2];S=R+T*T;C=C+1|0;if((C|0)==(F|0)){Z=S;break}else R=S}}else Z=W;I=Z+0.0;break}if(!t){if(!r){D=64;break}if((F|0)>0){C=0;R=0.0;while(1){U=+L(+(+n[A+(C<<2)>>2]));S=R<U?U:R;C=C+1|0;if((C|0)==(F|0)){_=S;break}else R=S}}else _=0.0;I=_>0.0?_:0.0;break}C=F+-4|0;if((F|0)<4){$=0;aa=0.0}else{R=0.0;B=0;do{S=+L(+(+n[A+(B<<2)>>2]));U=S+ +L(+(+n[A+((B|1)<<2)>>2]));S=U+ +L(+(+n[A+((B|2)<<2)>>2]));R=R+(S+ +L(+(+n[A+((B|3)<<2)>>2])));B=B+4|0}while((B|0)<=(C|0));$=F&-4;aa=R}if(($|0)<(F|0)){S=aa;C=$;while(1){U=S+ +L(+(+n[A+(C<<2)>>2]));C=C+1|0;if((C|0)==(F|0)){ba=U;break}else S=U}}else ba=aa;I=ba+0.0}while(0);do if((D|0)==64){$=(y|0)==0;if(!$){X=f[i+4>>2]|0;if((X|0)<3)ca=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{w=f[i+40>>2]|0;P=0;N=1;while(1){J=Y(f[w+(P<<2)>>2]|0,N)|0;P=P+1|0;if((P|0)==(X|0)){ca=J;break}else N=J}}if(!((X|0)==0|(ca|0)==0)?f[i>>2]&4095|0:0){f[j>>2]=0;f[j+4>>2]=0;da=tT(j,36)|0;ea=230143;fa=da+36|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));QO(j,214432,700)}}X=(q|0)==6;N=q|1;if((N|0)==7){if(!$){P=f[i+4>>2]|0;if((P|0)<3)ga=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{w=f[i+40>>2]|0;J=0;K=1;while(1){x=Y(f[w+(J<<2)>>2]|0,K)|0;J=J+1|0;if((J|0)==(P|0)){ga=x;break}else K=x}}if(!((P|0)==0|(ga|0)==0)){f[j>>2]=1124007936;K=j+4|0;J=j+8|0;w=j+40|0;da=K;fa=da+36|0;do{f[da>>2]=0;da=da+4|0}while((da|0)<(fa|0));f[w>>2]=J;P=j+48|0;$=j+44|0;f[$>>2]=P;f[P>>2]=0;f[j+52>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=i;x=m+8|0;f[x>>2]=0;f[x+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;dL(k,l,m,e0()|0);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=j;ba=+PO(k,q,e0()|0);x=j+36|0;d=f[x>>2]|0;if(d|0?(G=d+12|0,d=f[G>>2]|0,f[G>>2]=d+-1,(d|0)==1):0)_S(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[K>>2]|0)>0){x=f[w>>2]|0;d=0;do{f[x+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[K>>2]|0))}K=f[$>>2]|0;if((K|0)!=(P|0))g0(K);I=ba;break}}K=X?1:2;f[j>>2]=g;f[j+4>>2]=0;f[k>>2]=0;z2(l,j,k,-1);d=f[l+20>>2]|0;x=l+16|0;w=0;J=0;while(1){if(w>>>0>=(f[x>>2]|0)>>>0)break;G=(MO(f[k>>2]|0,d,K)|0)+J|0;A2(l)|0;w=w+1|0;J=G}I=+(J|0);break}w=f[41468+(q>>>1<<5)+(a<<2)>>2]|0;if(!w){f[j>>2]=0;f[j+4>>2]=0;da=tT(j,9)|0;ea=251213;fa=da+9|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));QO(j,214432,727)}f[j>>2]=g;f[j+4>>2]=i;f[j+8>>2]=0;J=k;f[J>>2]=0;f[J+4>>2]=0;p[l>>3]=0.0;z2(m,j,k,-1);J=f[m+20>>2]|0;K=a>>>0<2;f[o>>2]=0;if(t&a>>>0<4|(N|0)==5&K){d=((t&K?8388608:32768)>>>0)/(z>>>0)|0;K=(d|0)<(J|0)?d:J;x=f[g+4>>2]|0;if((x|0)>0){ha=f[(f[g+44>>2]|0)+(x+-1<<2)>>2]|0;ia=o;ja=d;ka=K;la=1}else{ha=0;ia=o;ja=d;ka=K;la=1}}else{ha=0;ia=l;ja=0;ka=J;la=0}K=m+16|0;d=k+4|0;b:do if((J|0)>0){x=0;X=0;while(1){if(x>>>0>=(f[K>>2]|0)>>>0)break b;P=x+1|0;$=f[k>>2]|0;G=f[d>>2]|0;if(la){E=0;F=X;C=$;A=G;while(1){B=J-E|0;c=(ka|0)<(B|0)?ka:B;_h[w&127](C,A,ia,c,z)|0;B=c+F|0;if((B+ka|0)<(ja|0)?((c+E|0)<(J|0)?1:P>>>0<(f[K>>2]|0)>>>0):0)ma=B;else{p[l>>3]=+p[l>>3]+ +(f[o>>2]|0);f[o>>2]=0;ma=0}B=Y(c,ha)|0;C=(f[k>>2]|0)+B|0;f[k>>2]=C;B=f[d>>2]|0;if(!B)na=0;else{H=B+c|0;f[d>>2]=H;na=H}E=E+ka|0;if((J|0)<=(E|0)){oa=ma;break}else{F=ma;A=na}}}else{A=0;F=X;E=$;C=G;while(1){H=J-A|0;c=(ka|0)<(H|0)?ka:H;_h[w&127](E,C,ia,c,z)|0;H=c+F|0;B=Y(c,ha)|0;E=(f[k>>2]|0)+B|0;f[k>>2]=E;B=f[d>>2]|0;if(!B)pa=0;else{qa=B+c|0;f[d>>2]=qa;pa=qa}A=A+ka|0;if((J|0)<=(A|0)){oa=H;break}else{F=H;C=pa}}}A2(m)|0;x=P;X=oa}}else{X=0;while(1){if(X>>>0>=(f[K>>2]|0)>>>0)break b;A2(m)|0;X=X+1|0}}while(0);if(r){if((a|0)!=6){K=f[l>>2]|0;p[l>>3]=(a|0)==5?(f[s>>2]=K,+n[s>>2]):+(K|0)}}else if(v){ba=+M(+(+p[l>>3]));p[l>>3]=ba}I=+p[l>>3]}while(0);l=i+36|0;v=f[l>>2]|0;if(v|0?(a=v+12|0,v=f[a>>2]|0,f[a>>2]=v+-1,(v|0)==1):0)_S(i);f[l>>2]=0;l=i+16|0;v=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[v>>2]|0)>0){l=f[i+40>>2]|0;a=0;do{f[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[v>>2]|0))}v=f[i+44>>2]|0;if((v|0)!=(i+48|0))g0(v);v=g+36|0;i=f[v>>2]|0;if(i|0?(a=i+12|0,i=f[a>>2]|0,f[a>>2]=i+-1,(i|0)==1):0)_S(g);f[v>>2]=0;v=g+16|0;i=g+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[i>>2]|0)>0){v=f[g+40>>2]|0;a=0;do{f[v+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[i>>2]|0))}i=f[g+44>>2]|0;if((i|0)==(g+48|0)){u=e;return +I}g0(i);u=e;return +I}function QO(a,b,c){a=a|0;b=b|0;c=c|0;z5(-215,a,b,214437,c);return}function RO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[d>>2]|0;if(!c){j=Y(g,e)|0;if((j|0)>0){k=0;l=0;while(1){m=h[a+l>>0]|0;n=(k|0)<(m|0)?m:k;l=l+1|0;if((l|0)==(j|0)){o=n;break}else k=n}}else o=0;p=(i|0)<(o|0)?o:i;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=i}else{p=i;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{i=0;a=s;while(1){o=h[r+i>>0]|0;k=(a|0)<(o|0)?o:a;i=i+1|0;if((i|0)==(g|0)){t=k;break}else a=k}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+g|0;s=t}}f[d>>2]=p;return 0}function SO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){j=0;k=0;while(1){l=b[a+k>>0]|0;m=l<<24>>24;n=l<<24>>24>-1?m:0-m|0;m=(j|0)<(n|0)?n:j;k=k+1|0;if((k|0)==(i|0)){o=m;break}else j=m}}else o=0;p=(h|0)<(o|0)?o:h;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=h}else{p=h;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{h=0;a=s;while(1){o=b[r+h>>0]|0;j=o<<24>>24;i=o<<24>>24>-1?j:0-j|0;j=(a|0)<(i|0)?i:a;h=h+1|0;if((h|0)==(g|0)){t=j;break}else a=j}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+g|0;s=t}}f[d>>2]=p;return 0}function TO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){k=0;l=0;while(1){m=j[a+(l<<1)>>1]|0;n=(k|0)<(m|0)?m:k;l=l+1|0;if((l|0)==(i|0)){o=n;break}else k=n}}else o=0;p=(h|0)<(o|0)?o:h;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=h}else{p=h;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{h=0;a=s;while(1){o=j[r+(h<<1)>>1]|0;k=(a|0)<(o|0)?o:a;h=h+1|0;if((h|0)==(g|0)){t=k;break}else a=k}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+(g<<1)|0;s=t}}f[d>>2]=p;return 0}function UO(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!c){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=d[a+(l<<1)>>1]|0;n=m<<16>>16;o=m<<16>>16>-1?n:0-n|0;n=(k|0)<(o|0)?o:k;l=l+1|0;if((l|0)==(j|0)){p=n;break}else k=n}}else p=0;q=(i|0)<(p|0)?p:i;f[e>>2]=q;return 0}if((g|0)>0&(h|0)>0){r=0;s=a;t=i}else{q=i;f[e>>2]=q;return 0}while(1){if(!(b[c+r>>0]|0))u=t;else{i=0;a=t;while(1){p=d[s+(i<<1)>>1]|0;k=p<<16>>16;j=p<<16>>16>-1?k:0-k|0;k=(a|0)<(j|0)?j:a;i=i+1|0;if((i|0)==(h|0)){u=k;break}else a=k}}r=r+1|0;if((r|0)==(g|0)){q=u;break}else{s=s+(h<<1)|0;t=u}}f[e>>2]=q;return 0}function VO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){j=0;k=0;while(1){l=f[a+(k<<2)>>2]|0;m=(l|0)>-1?l:0-l|0;l=(j|0)<(m|0)?m:j;k=k+1|0;if((k|0)==(i|0)){n=l;break}else j=l}}else n=0;o=(h|0)<(n|0)?n:h;f[d>>2]=o;return 0}if((e|0)>0&(g|0)>0){p=0;q=a;r=h}else{o=h;f[d>>2]=o;return 0}while(1){if(!(b[c+p>>0]|0))s=r;else{h=0;a=r;while(1){n=f[q+(h<<2)>>2]|0;j=(n|0)>-1?n:0-n|0;n=(a|0)<(j|0)?j:a;h=h+1|0;if((h|0)==(g|0)){s=n;break}else a=n}}p=p+1|0;if((p|0)==(e|0)){o=s;break}else{q=q+(g<<2)|0;r=s}}f[d>>2]=o;return 0}function WO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0,u=0.0,v=0,w=0.0,x=0;h=f[d>>2]|0;i=(f[s>>2]=h,+n[s>>2]);if(!c){j=Y(g,e)|0;if((j|0)>0){k=0;l=0.0;while(1){m=+L(+(+n[a+(k<<2)>>2]));o=l<m?m:l;k=k+1|0;if((k|0)==(j|0)){p=o;break}else l=o}}else p=0.0;q=(n[s>>2]=i<p?p:i,f[s>>2]|0);f[d>>2]=q;return 0}if((e|0)>0&(g|0)>0){r=0;t=a;u=i;v=h}else{q=h;f[d>>2]=q;return 0}while(1){if(!(b[c+r>>0]|0)){w=u;x=v}else{h=0;i=u;do{p=+L(+(+n[t+(h<<2)>>2]));i=i<p?p:i;h=h+1|0}while((h|0)!=(g|0));w=i;x=(n[s>>2]=i,f[s>>2]|0)}r=r+1|0;if((r|0)==(e|0)){q=x;break}else{t=t+(g<<2)|0;u=w;v=x}}f[d>>2]=q;return 0}function XO(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0,r=0.0,s=0.0;g=+p[d>>3];if(!c){h=Y(f,e)|0;if((h|0)>0){i=0.0;j=0;while(1){k=+L(+(+p[a+(j<<3)>>3]));l=i<k?k:i;j=j+1|0;if((j|0)==(h|0)){m=l;break}else i=l}}else m=0.0;n=g<m?m:g;p[d>>3]=n;return 0}if((e|0)>0&(f|0)>0){o=0;q=a;r=g}else{n=g;p[d>>3]=n;return 0}while(1){if(!(b[c+o>>0]|0))s=r;else{a=0;g=r;while(1){m=+L(+(+p[q+(a<<3)>>3]));i=g<m?m:g;a=a+1|0;if((a|0)==(f|0)){s=i;break}else g=i}}o=o+1|0;if((o|0)==(e|0)){n=s;break}else{q=q+(f<<3)|0;r=s}}p[d>>3]=n;return 0}function YO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){j=0;k=i;l=a}else{m=i;f[d>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=(h[l+o>>0]|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=q;break}else p=q}}j=j+1|0;if((j|0)==(e|0)){m=n;break}else{k=n;l=l+g|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){r=0;s=0}else{g=0;n=0;do{g=(h[a+n>>0]|0)+g+(h[a+(n|1)>>0]|0)+(h[a+(n|2)>>0]|0)+(h[a+(n|3)>>0]|0)|0;n=n+4|0}while((n|0)<=(e|0));r=l&-4;s=g}if((r|0)<(l|0)){g=s;e=r;while(1){r=(h[a+e>>0]|0)+g|0;e=e+1|0;if((e|0)==(l|0)){t=r;break}else g=r}}else t=s;m=t+i|0;f[d>>2]=m;return 0}function ZO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return tP(a,b,c,d,e)|0}function _O(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;k=h;l=a}else{m=h;f[d>>2]=m;return 0}while(1){if(!(b[c+i>>0]|0))n=k;else{o=0;p=k;while(1){q=(j[l+(o<<1)>>1]|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=q;break}else p=q}}i=i+1|0;if((i|0)==(e|0)){m=n;break}else{k=n;l=l+(g<<1)|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){r=0;s=0}else{g=0;n=0;do{g=(j[a+(n<<1)>>1]|0)+g+(j[a+((n|1)<<1)>>1]|0)+(j[a+((n|2)<<1)>>1]|0)+(j[a+((n|3)<<1)>>1]|0)|0;n=n+4|0}while((n|0)<=(e|0));r=l&-4;s=g}if((r|0)<(l|0)){g=s;e=r;while(1){r=(j[a+(e<<1)>>1]|0)+g|0;e=e+1|0;if((e|0)==(l|0)){t=r;break}else g=r}}else t=s;m=t+h|0;f[d>>2]=m;return 0}function $O(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return sP(a,b,c,d,e)|0}function aP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return rP(a,b,c,d,e)|0}function bP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return qP(a,b,c,d,e)|0}function cP(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;n=i;while(1){o=n+ +L(+(+p[j+(m<<3)>>3]));m=m+1|0;if((m|0)==(f|0)){l=o;break}else n=o}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<3)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){q=0;r=0.0}else{l=0.0;f=0;do{i=+L(+(+p[a+(f<<3)>>3]));n=i+ +L(+(+p[a+((f|1)<<3)>>3]));i=n+ +L(+(+p[a+((f|2)<<3)>>3]));l=l+(i+ +L(+(+p[a+((f|3)<<3)>>3])));f=f+4|0}while((f|0)<=(e|0));q=j&-4;r=l}if((q|0)<(j|0)){l=r;e=q;while(1){i=l+ +L(+(+p[a+(e<<3)>>3]));e=e+1|0;if((e|0)==(j|0)){s=i;break}else l=i}}else s=r;k=g+s;p[d>>3]=k;return 0}function dP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return pP(a,b,c,d,e)|0}function eP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return oP(a,b,c,d,e)|0}function fP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nP(a,b,c,d,e)|0}function gP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return mP(a,b,c,d,e)|0}function hP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return lP(a,b,c,d,e)|0}function iP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return kP(a,b,c,d,e)|0}function jP(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;n=i;while(1){o=+p[j+(m<<3)>>3];q=n+o*o;m=m+1|0;if((m|0)==(f|0)){l=q;break}else n=q}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<3)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){r=0.0;s=0}else{f=0;l=0.0;do{i=+p[a+(f<<3)>>3];n=+p[a+((f|1)<<3)>>3];q=+p[a+((f|2)<<3)>>3];o=+p[a+((f|3)<<3)>>3];l=l+(i*i+n*n+q*q+o*o);f=f+4|0}while((f|0)<=(e|0));r=l;s=j&-4}if((s|0)<(j|0)){e=s;l=r;while(1){o=+p[a+(e<<3)>>3];q=l+o*o;e=e+1|0;if((e|0)==(j|0)){t=q;break}else l=q}}else t=r;k=g+t;p[d>>3]=k;return 0}function kP(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;o=i;while(1){q=+n[j+(m<<2)>>2];r=o+q*q;m=m+1|0;if((m|0)==(f|0)){l=r;break}else o=r}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<2)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){s=0.0;t=0}else{f=0;l=0.0;do{i=+n[a+(f<<2)>>2];o=+n[a+((f|1)<<2)>>2];r=+n[a+((f|2)<<2)>>2];q=+n[a+((f|3)<<2)>>2];l=l+(i*i+o*o+r*r+q*q);f=f+4|0}while((f|0)<=(e|0));s=l;t=j&-4}if((t|0)<(j|0)){e=t;l=s;while(1){q=+n[a+(e<<2)>>2];r=l+q*q;e=e+1|0;if((e|0)==(j|0)){u=r;break}else l=r}}else u=s;k=g+u;p[d>>3]=k;return 0}function lP(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[d>>3];if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[d>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=+(f[k+(n<<2)>>2]|0);r=o+q*q;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+(g<<2)|0}}p[d>>3]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0.0;t=0}else{g=0;m=0.0;do{j=+(f[a+(g<<2)>>2]|0);o=+(f[a+((g|1)<<2)>>2]|0);r=+(f[a+((g|2)<<2)>>2]|0);q=+(f[a+((g|3)<<2)>>2]|0);m=m+(j*j+o*o+r*r+q*q);g=g+4|0}while((g|0)<=(e|0));s=m;t=k&-4}if((t|0)<(k|0)){e=t;m=s;while(1){q=+(f[a+(e<<2)>>2]|0);r=m+q*q;e=e+1|0;if((e|0)==(k|0)){u=r;break}else m=r}}else u=s;l=h+u;p[d>>3]=l;return 0}function mP(a,c,e,f,g){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[e>>3];if(c|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[e>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=+(d[k+(n<<1)>>1]|0);r=o+q*q;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(f|0)){l=m;break}else{j=m;k=k+(g<<1)|0}}p[e>>3]=l;return 0}k=Y(g,f)|0;f=k+-4|0;if((k|0)<4){s=0.0;t=0}else{g=0;m=0.0;do{j=+(d[a+(g<<1)>>1]|0);o=+(d[a+((g|1)<<1)>>1]|0);r=+(d[a+((g|2)<<1)>>1]|0);q=+(d[a+((g|3)<<1)>>1]|0);m=m+(j*j+o*o+r*r+q*q);g=g+4|0}while((g|0)<=(f|0));s=m;t=k&-4}if((t|0)<(k|0)){f=t;m=s;while(1){q=+(d[a+(f<<1)>>1]|0);r=m+q*q;f=f+1|0;if((f|0)==(k|0)){u=r;break}else m=r}}else u=s;l=h+u;p[e>>3]=l;return 0}function nP(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;k=a}else{l=g;p[d>>3]=l;return 0}while(1){if(!(b[c+h>>0]|0))m=i;else{n=0;o=i;while(1){q=+(j[k+(n<<1)>>1]|0);r=o+q*q;n=n+1|0;if((n|0)==(f|0)){m=r;break}else o=r}}h=h+1|0;if((h|0)==(e|0)){l=m;break}else{i=m;k=k+(f<<1)|0}}p[d>>3]=l;return 0}k=Y(f,e)|0;e=k+-4|0;if((k|0)<4){s=0.0;t=0}else{f=0;m=0.0;do{i=+(j[a+(f<<1)>>1]|0);o=+(j[a+((f|1)<<1)>>1]|0);r=+(j[a+((f|2)<<1)>>1]|0);q=+(j[a+((f|3)<<1)>>1]|0);m=m+(i*i+o*o+r*r+q*q);f=f+4|0}while((f|0)<=(e|0));s=m;t=k&-4}if((t|0)<(k|0)){e=t;m=s;while(1){q=+(j[a+(e<<1)>>1]|0);r=m+q*q;e=e+1|0;if((e|0)==(k|0)){u=r;break}else m=r}}else u=s;l=g+u;p[d>>3]=l;return 0}function oP(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;f[d>>2]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){p=b[k+n>>0]|0;q=(Y(p,p)|0)+o|0;n=n+1|0;if((n|0)==(g|0)){m=q;break}else o=q}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+g|0}}f[d>>2]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){r=0;s=0}else{g=0;m=0;do{j=b[a+g>>0]|0;i=b[a+(g|1)>>0]|0;c=b[a+(g|2)>>0]|0;o=b[a+(g|3)>>0]|0;m=(Y(j,j)|0)+m+(Y(i,i)|0)+(Y(c,c)|0)+(Y(o,o)|0)|0;g=g+4|0}while((g|0)<=(e|0));r=m;s=k&-4}if((s|0)<(k|0)){m=s;s=r;while(1){e=b[a+m>>0]|0;g=(Y(e,e)|0)+s|0;m=m+1|0;if((m|0)==(k|0)){t=g;break}else s=g}}else t=r;l=t+h|0;f[d>>2]=l;return 0}function pP(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){j=0;k=i;l=a}else{m=i;f[d>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=h[l+o>>0]|0;r=(Y(q,q)|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=r;break}else p=r}}j=j+1|0;if((j|0)==(e|0)){m=n;break}else{k=n;l=l+g|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){s=0;t=0}else{g=0;n=0;do{k=h[a+g>>0]|0;j=h[a+(g|1)>>0]|0;c=h[a+(g|2)>>0]|0;p=h[a+(g|3)>>0]|0;n=(Y(k,k)|0)+n+(Y(j,j)|0)+(Y(c,c)|0)+(Y(p,p)|0)|0;g=g+4|0}while((g|0)<=(e|0));s=n;t=l&-4}if((t|0)<(l|0)){n=t;t=s;while(1){e=h[a+n>>0]|0;g=(Y(e,e)|0)+t|0;n=n+1|0;if((n|0)==(l|0)){u=g;break}else t=g}}else u=s;m=u+i|0;f[d>>2]=m;return 0}function qP(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0.0,t=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;o=i;while(1){q=o+ +L(+(+n[j+(m<<2)>>2]));m=m+1|0;if((m|0)==(f|0)){l=q;break}else o=q}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<2)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){r=0;s=0.0}else{l=0.0;f=0;do{i=+L(+(+n[a+(f<<2)>>2]));o=i+ +L(+(+n[a+((f|1)<<2)>>2]));i=o+ +L(+(+n[a+((f|2)<<2)>>2]));l=l+(i+ +L(+(+n[a+((f|3)<<2)>>2])));f=f+4|0}while((f|0)<=(e|0));r=j&-4;s=l}if((r|0)<(j|0)){l=s;e=r;while(1){i=l+ +L(+(+n[a+(e<<2)>>2]));e=e+1|0;if((e|0)==(j|0)){t=i;break}else l=i}}else t=s;k=g+t;p[d>>3]=k;return 0}function rP(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0;h=+p[d>>3];if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[d>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=f[k+(n<<2)>>2]|0;r=o+ +(((q|0)>-1?q:0-q|0)|0);n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+(g<<2)|0}}p[d>>3]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0.0}else{m=0.0;g=0;do{i=f[a+(g<<2)>>2]|0;c=f[a+((g|1)<<2)>>2]|0;n=f[a+((g|2)<<2)>>2]|0;q=f[a+((g|3)<<2)>>2]|0;m=m+(+(((i|0)>-1?i:0-i|0)|0)+ +(((c|0)>-1?c:0-c|0)|0)+ +(((n|0)>-1?n:0-n|0)|0)+ +(((q|0)>-1?q:0-q|0)|0));g=g+4|0}while((g|0)<=(e|0));s=k&-4;t=m}if((s|0)<(k|0)){m=t;e=s;while(1){s=f[a+(e<<2)>>2]|0;j=m+ +(((s|0)>-1?s:0-s|0)|0);e=e+1|0;if((e|0)==(k|0)){u=j;break}else m=j}}else u=t;l=h+u;p[d>>3]=l;return 0}function sP(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(c|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a}else{m=i;f[e>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=d[l+(o<<1)>>1]|0;r=q<<16>>16;s=(q<<16>>16>-1?r:0-r|0)+p|0;o=o+1|0;if((o|0)==(h|0)){n=s;break}else p=s}}j=j+1|0;if((j|0)==(g|0)){m=n;break}else{k=n;l=l+(h<<1)|0}}f[e>>2]=m;return 0}l=Y(h,g)|0;g=l+-4|0;if((l|0)<4){t=0;u=0}else{h=0;n=0;do{k=d[a+(n<<1)>>1]|0;j=k<<16>>16;c=d[a+((n|1)<<1)>>1]|0;p=c<<16>>16;o=d[a+((n|2)<<1)>>1]|0;s=o<<16>>16;r=d[a+((n|3)<<1)>>1]|0;q=r<<16>>16;h=(k<<16>>16>-1?j:0-j|0)+h+(c<<16>>16>-1?p:0-p|0)+(o<<16>>16>-1?s:0-s|0)+(r<<16>>16>-1?q:0-q|0)|0;n=n+4|0}while((n|0)<=(g|0));t=l&-4;u=h}if((t|0)<(l|0)){h=u;g=t;while(1){t=d[a+(g<<1)>>1]|0;n=t<<16>>16;q=(t<<16>>16>-1?n:0-n|0)+h|0;g=g+1|0;if((g|0)==(l|0)){v=q;break}else h=q}}else v=u;m=v+i|0;f[e>>2]=m;return 0}function tP(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;f[d>>2]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){p=b[k+n>>0]|0;q=p<<24>>24;r=(p<<24>>24>-1?q:0-q|0)+o|0;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+g|0}}f[d>>2]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0}else{g=0;m=0;do{j=b[a+m>>0]|0;i=j<<24>>24;c=b[a+(m|1)>>0]|0;o=c<<24>>24;n=b[a+(m|2)>>0]|0;r=n<<24>>24;q=b[a+(m|3)>>0]|0;p=q<<24>>24;g=(j<<24>>24>-1?i:0-i|0)+g+(c<<24>>24>-1?o:0-o|0)+(n<<24>>24>-1?r:0-r|0)+(q<<24>>24>-1?p:0-p|0)|0;m=m+4|0}while((m|0)<=(e|0));s=k&-4;t=g}if((s|0)<(k|0)){g=t;e=s;while(1){s=b[a+e>>0]|0;m=s<<24>>24;p=(s<<24>>24>-1?m:0-m|0)+g|0;e=e+1|0;if((e|0)==(k|0)){u=p;break}else g=p}}else u=t;l=u+h|0;f[d>>2]=l;return 0}function uP(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;g=u;u=u+320|0;h=g+256|0;i=g+200|0;j=g+144|0;k=g+88|0;l=g+32|0;m=g;o=g+56|0;q=g+48|0;if(!(m$(a,c)|0)){f[h>>2]=0;r=h+4|0;f[r>>2]=0;t=tT(h,53)|0;v=t;w=214500;x=v+53|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));QO(h,214432,1092)}y=c$(a,-1)|0;if((y|0)!=(c$(c,-1)|0)){f[h>>2]=0;r=h+4|0;f[r>>2]=0;t=tT(h,53)|0;v=t;w=214500;x=v+53|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));QO(h,214432,1092)}if(d&8|0){z=+uP(a,c,d&-9,e);A=z/(+PO(c,d,e)+2.220446049250313e-16);u=g;return +A}do if((d$(a)|0)==65536){t=f[a+4>>2]|0;f[h>>2]=f[t>>2];r=h+4|0;y=t+4|0;f[r>>2]=f[y>>2];B=h+8|0;f[B>>2]=f[t+8>>2];f[h+12>>2]=f[t+12>>2];f[h+16>>2]=f[t+16>>2];f[h+20>>2]=f[t+20>>2];f[h+24>>2]=f[t+24>>2];f[h+28>>2]=f[t+28>>2];f[h+32>>2]=f[t+32>>2];C=f[t+36>>2]|0;f[h+36>>2]=C;f[h+40>>2]=B;B=h+48|0;D=h+44|0;f[D>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[y>>2]|0)<3){y=f[t+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[y>>2];f[B+4>>2]=f[y+4>>2];break}else{f[r>>2]=0;ZS(h,t);break}}else a$(h,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];t=i+4|0;r=a+4|0;f[t>>2]=f[r>>2];y=i+8|0;f[y>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[i+36>>2]=B;f[i+40>>2]=y;y=i+48|0;D=i+44|0;f[D>>2]=y;f[y>>2]=0;f[i+52>>2]=0;if(B|0){y=B+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[r>>2]|0)<3){r=f[a+44>>2]|0;y=f[D>>2]|0;f[y>>2]=f[r>>2];f[y+4>>2]=f[r+4>>2];break}else{f[t>>2]=0;ZS(i,a);break}}else a$(i,c,-1);while(0);do if((d$(e)|0)==65536){c=f[e+4>>2]|0;f[j>>2]=f[c>>2];a=j+4|0;t=c+4|0;f[a>>2]=f[t>>2];r=j+8|0;f[r>>2]=f[c+8>>2];f[j+12>>2]=f[c+12>>2];f[j+16>>2]=f[c+16>>2];f[j+20>>2]=f[c+20>>2];f[j+24>>2]=f[c+24>>2];f[j+28>>2]=f[c+28>>2];f[j+32>>2]=f[c+32>>2];y=f[c+36>>2]|0;f[j+36>>2]=y;f[j+40>>2]=r;r=j+48|0;D=j+44|0;f[D>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(y|0){r=y+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[t>>2]|0)<3){t=f[c+44>>2]|0;r=f[D>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2];break}else{f[a>>2]=0;ZS(j,c);break}}else a$(j,e,-1);while(0);e=f[h>>2]|0;c=e&7;a=(e>>>3&511)+1|0;t=d&7;r=(t|0)==1;D=(t|0)==2;y=(t|0)==4;B=(t|0)==5;switch(d&7){case 1:case 2:case 4:case 5:break;default:if(!((t|1|0)==7&(e&4095|0)==0)){f[k>>2]=0;f[k+4>>2]=0;dJc(tT(k,177)|0,214554,177)|0;QO(k,214432,1117)}}do if((e&16384|0)!=0?(f[i>>2]&16384|0)!=0:0){if(f[j+16>>2]|0){d=f[j+4>>2]|0;if((d|0)<3)E=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{C=f[j+40>>2]|0;F=0;G=1;while(1){H=Y(f[C+(F<<2)>>2]|0,G)|0;F=F+1|0;if((F|0)==(d|0)){E=H;break}else G=H}}if(!((d|0)==0|(E|0)==0)){I=68;break}}G=f[h+4>>2]|0;if((G|0)<3)J=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{F=f[h+40>>2]|0;C=0;H=1;while(1){K=Y(f[F+(C<<2)>>2]|0,H)|0;C=C+1|0;if((C|0)==(G|0)){J=K;break}else H=K}}H=Y(a,J)|0;if((c|0)==5){G=f[h+16>>2]|0;C=f[i+16>>2]|0;if(y){F=H+-4|0;if((H|0)<4){N=0.0;O=0}else{d=0;z=0.0;do{P=+n[G+(d<<2)>>2]-+n[C+(d<<2)>>2];K=d|1;Q=+n[G+(K<<2)>>2]-+n[C+(K<<2)>>2];K=d|2;R=+n[G+(K<<2)>>2]-+n[C+(K<<2)>>2];K=d|3;S=+n[G+(K<<2)>>2]-+n[C+(K<<2)>>2];z=z+(P*P+Q*Q+R*R+S*S);d=d+4|0}while((d|0)<=(F|0));N=z;O=H&-4}if((O|0)<(H|0)){F=O;S=N;while(1){R=+n[G+(F<<2)>>2]-+n[C+(F<<2)>>2];Q=S+R*R;F=F+1|0;if((F|0)==(H|0)){T=Q;break}else S=Q}}else T=N;U=+M(+(T+0.0));break}if(B){F=H+-4|0;if((H|0)<4){V=0.0;W=0}else{d=0;S=0.0;do{z=+n[G+(d<<2)>>2]-+n[C+(d<<2)>>2];K=d|1;Q=+n[G+(K<<2)>>2]-+n[C+(K<<2)>>2];K=d|2;R=+n[G+(K<<2)>>2]-+n[C+(K<<2)>>2];K=d|3;P=+n[G+(K<<2)>>2]-+n[C+(K<<2)>>2];S=S+(z*z+Q*Q+R*R+P*P);d=d+4|0}while((d|0)<=(F|0));V=S;W=H&-4}if((W|0)<(H|0)){F=W;P=V;while(1){R=+n[G+(F<<2)>>2]-+n[C+(F<<2)>>2];Q=P+R*R;F=F+1|0;if((F|0)==(H|0)){X=Q;break}else P=Q}}else X=V;U=X+0.0;break}if(!D){if(!r){I=68;break}if((H|0)>0){F=0;P=0.0;while(1){S=+L(+(+n[G+(F<<2)>>2]-+n[C+(F<<2)>>2]));Q=P<S?S:P;F=F+1|0;if((F|0)==(H|0)){Z=Q;break}else P=Q}}else Z=0.0;U=Z>0.0?Z:0.0;break}F=H+-4|0;if((H|0)<4){_=0.0;$=0}else{d=0;P=0.0;do{K=d|1;aa=d|2;ba=d|3;P=P+(+L(+(+n[G+(d<<2)>>2]-+n[C+(d<<2)>>2]))+ +L(+(+n[G+(K<<2)>>2]-+n[C+(K<<2)>>2]))+ +L(+(+n[G+(aa<<2)>>2]-+n[C+(aa<<2)>>2]))+ +L(+(+n[G+(ba<<2)>>2]-+n[C+(ba<<2)>>2])));d=d+4|0}while((d|0)<=(F|0));_=P;$=H&-4}if(($|0)<(H|0)){F=$;Q=_;while(1){S=Q+ +L(+(+n[G+(F<<2)>>2]-+n[C+(F<<2)>>2]));F=F+1|0;if((F|0)==(H|0)){ca=S;break}else Q=S}}else ca=_;U=ca+0.0}else I=68}else I=68;while(0);do if((I|0)==68){$=(f[j+16>>2]|0)==0;if(!$){W=f[j+4>>2]|0;if((W|0)<3)da=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{B=f[j+40>>2]|0;O=0;J=1;while(1){E=Y(f[B+(O<<2)>>2]|0,J)|0;O=O+1|0;if((O|0)==(W|0)){da=E;break}else J=E}}if(!((W|0)==0|(da|0)==0)?f[j>>2]&4095|0:0){f[k>>2]=0;f[k+4>>2]=0;v=tT(k,36)|0;w=230143;x=v+36|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));QO(k,214432,1157)}}W=(t|0)==6;J=t|1;if((J|0)==7){if(!$){O=f[j+4>>2]|0;if((O|0)<3)ea=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{B=f[j+40>>2]|0;E=0;e=1;while(1){H=Y(f[B+(E<<2)>>2]|0,e)|0;E=E+1|0;if((E|0)==(O|0)){ea=H;break}else e=H}}if(!((O|0)==0|(ea|0)==0)){f[k>>2]=1124007936;e=k+4|0;E=k+8|0;B=k+40|0;v=e;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[B>>2]=E;O=k+48|0;$=k+44|0;f[$>>2]=O;f[O>>2]=0;f[k+52>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;H=o+8|0;f[H>>2]=0;f[H+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;gL(l,m,o,e0()|0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=k;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=j;H=o+8|0;f[H>>2]=0;f[H+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;dL(l,m,o,e0()|0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=k;ca=+PO(l,t,e0()|0);H=k+36|0;F=f[H>>2]|0;if(F|0?(C=F+12|0,F=f[C>>2]|0,f[C>>2]=F+-1,(F|0)==1):0)_S(k);f[H>>2]=0;H=k+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[e>>2]|0)>0){H=f[B>>2]|0;F=0;do{f[H+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[e>>2]|0))}e=f[$>>2]|0;if((e|0)!=(O|0))g0(e);U=ca;break}}e=W?1:2;f[k>>2]=h;f[k+4>>2]=i;f[k+8>>2]=0;F=l;f[F>>2]=0;f[F+4>>2]=0;z2(m,k,l,-1);F=f[m+20>>2]|0;H=m+16|0;B=l+4|0;E=0;C=0;while(1){if(E>>>0>=(f[H>>2]|0)>>>0)break;G=(NO(f[l>>2]|0,f[B>>2]|0,F,e)|0)+C|0;A2(m)|0;E=E+1|0;C=G}U=+(C|0);break}E=f[41564+(t>>>1<<5)+(c<<2)>>2]|0;if(!E){f[k>>2]=0;f[k+4>>2]=0;v=tT(k,9)|0;w=251213;x=v+9|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));QO(k,214432,1185)}f[k>>2]=h;f[k+4>>2]=i;f[k+8>>2]=j;f[k+12>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;p[m>>3]=0.0;z2(o,k,l,-1);C=f[o+20>>2]|0;e=c>>>0<2;f[q>>2]=0;if(D&c>>>0<4|(J|0)==5&e){F=D&e?8388608:32768;e=(F|0)<(C|0)?F:C;B=f[h+4>>2]|0;if((B|0)>0){fa=f[(f[h+44>>2]|0)+(B+-1<<2)>>2]|0;ga=q;ha=F;ia=e;ja=1}else{fa=0;ga=q;ha=F;ia=e;ja=1}}else{fa=0;ga=m;ha=0;ia=C;ja=0}e=o+16|0;F=(C|0)>0;B=l+4|0;H=l+8|0;W=0;O=0;while(1){if(W>>>0>=(f[e>>2]|0)>>>0)break;$=W+1|0;a:do if(F){G=f[l>>2]|0;d=f[B>>2]|0;ba=f[H>>2]|0;if(ja){ka=0;la=O;ma=G;na=d;oa=ba}else{aa=0;K=O;pa=G;G=d;d=ba;while(1){ba=C-aa|0;qa=(ia|0)<(ba|0)?ia:ba;xg[E&127](pa,G,d,ga,qa,a)|0;ba=qa+K|0;ra=Y(qa,fa)|0;pa=(f[l>>2]|0)+ra|0;f[l>>2]=pa;G=(f[B>>2]|0)+ra|0;f[B>>2]=G;ra=f[H>>2]|0;if(!ra)sa=0;else{ta=ra+qa|0;f[H>>2]=ta;sa=ta}aa=aa+ia|0;if((C|0)<=(aa|0)){ua=ba;break a}else{K=ba;d=sa}}}while(1){d=C-ka|0;K=(ia|0)<(d|0)?ia:d;xg[E&127](ma,na,oa,ga,K,a)|0;d=K+la|0;if((d+ia|0)<(ha|0)?((K+ka|0)<(C|0)?1:$>>>0<(f[e>>2]|0)>>>0):0)va=d;else{p[m>>3]=+p[m>>3]+ +((f[q>>2]|0)>>>0);f[q>>2]=0;va=0}d=Y(K,fa)|0;ma=(f[l>>2]|0)+d|0;f[l>>2]=ma;na=(f[B>>2]|0)+d|0;f[B>>2]=na;d=f[H>>2]|0;if(!d)wa=0;else{aa=d+K|0;f[H>>2]=aa;wa=aa}ka=ka+ia|0;if((C|0)<=(ka|0)){ua=va;break}else{la=va;oa=wa}}}else ua=O;while(0);A2(o)|0;W=$;O=ua}if(r){if((c|0)!=6){O=f[m>>2]|0;p[m>>3]=(c|0)==5?(f[s>>2]=O,+n[s>>2]):+(O>>>0)}}else if(y){ca=+M(+(+p[m>>3]));p[m>>3]=ca}U=+p[m>>3]}while(0);m=j+36|0;y=f[m>>2]|0;if(y|0?(c=y+12|0,y=f[c>>2]|0,f[c>>2]=y+-1,(y|0)==1):0)_S(j);f[m>>2]=0;m=j+16|0;y=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[y>>2]|0)>0){m=f[j+40>>2]|0;c=0;do{f[m+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[y>>2]|0))}y=f[j+44>>2]|0;if((y|0)!=(j+48|0))g0(y);y=i+36|0;j=f[y>>2]|0;if(j|0?(c=j+12|0,j=f[c>>2]|0,f[c>>2]=j+-1,(j|0)==1):0)_S(i);f[y>>2]=0;y=i+16|0;j=i+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){y=f[i+40>>2]|0;c=0;do{f[y+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)_S(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[h+40>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))g0(i);A=U;u=g;return +A}function vP(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=f[e>>2]|0;if(!d){k=Y(i,g)|0;if((k|0)>0){l=0;m=0;while(1){n=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(j|0)<(p|0)?p:j;f[e>>2]=q;return 0}if((g|0)>0&(i|0)>0){r=0;s=a;t=c;u=j}else{q=j;f[e>>2]=q;return 0}while(1){if(!(b[d+r>>0]|0))v=u;else{j=0;c=u;while(1){a=(h[s+j>>0]|0)-(h[t+j>>0]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;j=j+1|0;if((j|0)==(i|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(g|0)){q=v;break}else{s=s+i|0;t=t+i|0;u=v}}f[e>>2]=q;return 0}function wP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!d){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;n=(m|0)>-1?m:0-m|0;m=(k|0)<(n|0)?n:k;l=l+1|0;if((l|0)==(j|0)){o=m;break}else k=m}}else o=0;p=(i|0)<(o|0)?o:i;f[e>>2]=p;return 0}if((g|0)>0&(h|0)>0){q=0;r=a;s=c;t=i}else{p=i;f[e>>2]=p;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{i=0;c=t;while(1){a=(b[r+i>>0]|0)-(b[s+i>>0]|0)|0;o=(a|0)>-1?a:0-a|0;a=(c|0)<(o|0)?o:c;i=i+1|0;if((i|0)==(h|0)){u=a;break}else c=a}}q=q+1|0;if((q|0)==(g|0)){p=u;break}else{r=r+h|0;s=s+h|0;t=u}}f[e>>2]=p;return 0}function xP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(!d){k=Y(h,g)|0;if((k|0)>0){l=0;m=0;while(1){n=(j[a+(m<<1)>>1]|0)-(j[c+(m<<1)>>1]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(i|0)<(p|0)?p:i;f[e>>2]=q;return 0}if((g|0)>0&(h|0)>0){r=0;s=a;t=c;u=i}else{q=i;f[e>>2]=q;return 0}while(1){if(!(b[d+r>>0]|0))v=u;else{i=0;c=u;while(1){a=(j[s+(i<<1)>>1]|0)-(j[t+(i<<1)>>1]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;i=i+1|0;if((i|0)==(h|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(g|0)){q=v;break}else{s=s+(h<<1)|0;t=t+(h<<1)|0;u=v}}f[e>>2]=q;return 0}function yP(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=f[g>>2]|0;if(!e){k=Y(i,h)|0;if((k|0)>0){l=0;m=0;while(1){n=(d[a+(m<<1)>>1]|0)-(d[c+(m<<1)>>1]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(j|0)<(p|0)?p:j;f[g>>2]=q;return 0}if((h|0)>0&(i|0)>0){r=0;s=a;t=c;u=j}else{q=j;f[g>>2]=q;return 0}while(1){if(!(b[e+r>>0]|0))v=u;else{j=0;c=u;while(1){a=(d[s+(j<<1)>>1]|0)-(d[t+(j<<1)>>1]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;j=j+1|0;if((j|0)==(i|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(h|0)){q=v;break}else{s=s+(i<<1)|0;t=t+(i<<1)|0;u=v}}f[g>>2]=q;return 0}function zP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!d){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=(f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0;n=(m|0)>-1?m:0-m|0;m=(k|0)<(n|0)?n:k;l=l+1|0;if((l|0)==(j|0)){o=m;break}else k=m}}else o=0;p=(i|0)<(o|0)?o:i;f[e>>2]=p;return 0}if((g|0)>0&(h|0)>0){q=0;r=a;s=c;t=i}else{p=i;f[e>>2]=p;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{i=0;c=t;while(1){a=(f[r+(i<<2)>>2]|0)-(f[s+(i<<2)>>2]|0)|0;o=(a|0)>-1?a:0-a|0;a=(c|0)<(o|0)?o:c;i=i+1|0;if((i|0)==(h|0)){u=a;break}else c=a}}q=q+1|0;if((q|0)==(g|0)){p=u;break}else{r=r+(h<<2)|0;s=s+(h<<2)|0;t=u}}f[e>>2]=p;return 0}function AP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0;i=f[e>>2]|0;j=(f[s>>2]=i,+n[s>>2]);if(!d){k=Y(h,g)|0;if((k|0)>0){l=0;m=0.0;while(1){o=+L(+(+n[a+(l<<2)>>2]-+n[c+(l<<2)>>2]));p=m<o?o:m;l=l+1|0;if((l|0)==(k|0)){q=p;break}else m=p}}else q=0.0;r=(n[s>>2]=j<q?q:j,f[s>>2]|0);f[e>>2]=r;return 0}if((g|0)>0&(h|0)>0){t=0;u=a;v=c;w=j;x=i}else{r=i;f[e>>2]=r;return 0}while(1){if(!(b[d+t>>0]|0)){y=w;z=x}else{i=0;j=w;do{q=+L(+(+n[u+(i<<2)>>2]-+n[v+(i<<2)>>2]));j=j<q?q:j;i=i+1|0}while((i|0)!=(h|0));y=j;z=(n[s>>2]=j,f[s>>2]|0)}t=t+1|0;if((t|0)==(g|0)){r=z;break}else{u=u+(h<<2)|0;v=v+(h<<2)|0;w=y;x=z}}f[e>>2]=r;return 0}function BP(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0;h=+p[e>>3];if(!d){i=Y(g,f)|0;if((i|0)>0){j=0.0;k=0;while(1){l=+L(+(+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3]));m=j<l?l:j;k=k+1|0;if((k|0)==(i|0)){n=m;break}else j=m}}else n=0.0;o=h<n?n:h;p[e>>3]=o;return 0}if((f|0)>0&(g|0)>0){q=0;r=a;s=c;t=h}else{o=h;p[e>>3]=o;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{c=0;h=t;while(1){n=+L(+(+p[r+(c<<3)>>3]-+p[s+(c<<3)>>3]));j=h<n?n:h;c=c+1|0;if((c|0)==(g|0)){u=j;break}else h=j}}q=q+1|0;if((q|0)==(f|0)){o=u;break}else{r=r+(g<<3)|0;s=s+(g<<3)|0;t=u}}p[e>>3]=o;return 0}function CP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bQ(a,b,c,d,e,f)|0}function DP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return aQ(a,b,c,d,e,f)|0}function EP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $P(a,b,c,d,e,f)|0}function FP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _P(a,b,c,d,e,f)|0}function GP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ZP(a,b,c,d,e,f)|0}function HP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return YP(a,b,c,d,e,f)|0}function IP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return XP(a,b,c,d,e,f)|0}function JP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WP(a,b,c,d,e,f)|0}function KP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return VP(a,b,c,d,e,f)|0}function LP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UP(a,b,c,d,e,f)|0}function MP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return TP(a,b,c,d,e,f)|0}function NP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return SP(a,b,c,d,e,f)|0}function OP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return RP(a,b,c,d,e,f)|0}function PP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return QP(a,b,c,d,e,f)|0}function QP(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=c;l=a}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))n=j;else{o=0;q=j;while(1){r=+p[l+(o<<3)>>3]-+p[k+(o<<3)>>3];s=q+r*r;o=o+1|0;if((o|0)==(g|0)){n=s;break}else q=s}}i=i+1|0;if((i|0)==(f|0)){m=n;break}else{j=n;k=k+(g<<3)|0;l=l+(g<<3)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){t=0.0;u=0}else{g=0;n=0.0;do{j=+p[a+(g<<3)>>3]-+p[c+(g<<3)>>3];k=g|1;q=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];k=g|2;s=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];k=g|3;r=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];n=n+(j*j+q*q+s*s+r*r);g=g+4|0}while((g|0)<=(f|0));t=n;u=l&-4}if((u|0)<(l|0)){f=u;n=t;while(1){r=+p[a+(f<<3)>>3]-+p[c+(f<<3)>>3];s=n+r*r;f=f+1|0;if((f|0)==(l|0)){v=s;break}else n=s}}else v=t;m=h+v;p[e>>3]=m;return 0}function RP(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=c;l=a}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))o=j;else{q=0;r=j;while(1){s=+n[l+(q<<2)>>2]-+n[k+(q<<2)>>2];t=r+s*s;q=q+1|0;if((q|0)==(g|0)){o=t;break}else r=t}}i=i+1|0;if((i|0)==(f|0)){m=o;break}else{j=o;k=k+(g<<2)|0;l=l+(g<<2)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){u=0.0;v=0}else{g=0;o=0.0;do{j=+n[a+(g<<2)>>2]-+n[c+(g<<2)>>2];k=g|1;r=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];k=g|2;t=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];k=g|3;s=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];o=o+(j*j+r*r+t*t+s*s);g=g+4|0}while((g|0)<=(f|0));u=o;v=l&-4}if((v|0)<(l|0)){f=v;o=u;while(1){s=+n[a+(f<<2)>>2]-+n[c+(f<<2)>>2];t=o+s*s;f=f+1|0;if((f|0)==(l|0)){w=t;break}else o=t}}else w=u;m=h+w;p[e>>3]=m;return 0}function SP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;i=+p[e>>3];if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;p[e>>3]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{q=0;r=k;while(1){s=+((f[m+(q<<2)>>2]|0)-(f[l+(q<<2)>>2]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<2)|0;m=m+(h<<2)|0}}p[e>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{k=+((f[a+(h<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)|0);l=h|1;r=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);l=h|2;t=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);l=h|3;s=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);o=o+(k*k+r*r+t*t+s*s);h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){s=+((f[a+(g<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)|0);t=o+s*s;g=g+1|0;if((g|0)==(m|0)){w=t;break}else o=t}}else w=u;n=i+w;p[e>>3]=n;return 0}function TP(a,c,e,f,g,h){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;i=+p[f>>3];if(e|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;p[f>>3]=n;return 0}while(1){if(!(b[e+j>>0]|0))o=k;else{q=0;r=k;while(1){s=+((d[m+(q<<1)>>1]|0)-(d[l+(q<<1)>>1]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<1)|0;m=m+(h<<1)|0}}p[f>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{k=+((d[a+(h<<1)>>1]|0)-(d[c+(h<<1)>>1]|0)|0);l=h|1;r=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);l=h|2;t=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);l=h|3;s=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);o=o+(k*k+r*r+t*t+s*s);h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){s=+((d[a+(g<<1)>>1]|0)-(d[c+(g<<1)>>1]|0)|0);t=o+s*s;g=g+1|0;if((g|0)==(m|0)){w=t;break}else o=t}}else w=u;n=i+w;p[f>>3]=n;return 0}function UP(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;k=h;l=c;m=a}else{n=h;p[e>>3]=n;return 0}while(1){if(!(b[d+i>>0]|0))o=k;else{q=0;r=k;while(1){s=+((j[m+(q<<1)>>1]|0)-(j[l+(q<<1)>>1]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(g|0)){o=t;break}else r=t}}i=i+1|0;if((i|0)==(f|0)){n=o;break}else{k=o;l=l+(g<<1)|0;m=m+(g<<1)|0}}p[e>>3]=n;return 0}m=Y(g,f)|0;f=m+-4|0;if((m|0)<4){u=0.0;v=0}else{g=0;o=0.0;do{k=+((j[a+(g<<1)>>1]|0)-(j[c+(g<<1)>>1]|0)|0);l=g|1;r=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);l=g|2;t=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);l=g|3;s=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);o=o+(k*k+r*r+t*t+s*s);g=g+4|0}while((g|0)<=(f|0));u=o;v=m&-4}if((v|0)<(m|0)){f=v;o=u;while(1){s=+((j[a+(f<<1)>>1]|0)-(j[c+(f<<1)>>1]|0)|0);t=o+s*s;f=f+1|0;if((f|0)==(m|0)){w=t;break}else o=t}}else w=u;n=h+w;p[e>>3]=n;return 0}function VP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;f[e>>2]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{p=0;q=k;while(1){r=(b[m+p>>0]|0)-(b[l+p>>0]|0)|0;s=(Y(r,r)|0)+q|0;p=p+1|0;if((p|0)==(h|0)){o=s;break}else q=s}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+h|0;m=m+h|0}}f[e>>2]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){t=0;u=0}else{h=0;l=0;do{o=(b[a+h>>0]|0)-(b[c+h>>0]|0)|0;k=h|1;j=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|2;d=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|3;q=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;l=(Y(o,o)|0)+l+(Y(j,j)|0)+(Y(d,d)|0)+(Y(q,q)|0)|0;h=h+4|0}while((h|0)<=(g|0));t=l;u=m&-4}if((u|0)<(m|0)){l=u;u=t;while(1){g=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;h=(Y(g,g)|0)+u|0;l=l+1|0;if((l|0)==(m|0)){v=h;break}else u=h}}else v=t;n=v+i|0;f[e>>2]=n;return 0}function WP(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[e>>2]|0;if(d|0){if((g|0)>0&(i|0)>0){k=0;l=j;m=c;n=a}else{o=j;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(h[n+q>>0]|0)-(h[m+q>>0]|0)|0;t=(Y(s,s)|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+i|0;n=n+i|0}}f[e>>2]=o;return 0}n=Y(i,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(h[a+i>>0]|0)-(h[c+i>>0]|0)|0;l=i|1;k=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|2;d=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|3;r=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;m=(Y(p,p)|0)+m+(Y(k,k)|0)+(Y(d,d)|0)+(Y(r,r)|0)|0;i=i+4|0}while((i|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;i=(Y(g,g)|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[e>>2]=o;return 0}function XP(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))n=j;else{o=0;q=j;while(1){r=q+ +L(+(+p[k+(o<<3)>>3]-+p[l+(o<<3)>>3]));o=o+1|0;if((o|0)==(g|0)){n=r;break}else q=r}}i=i+1|0;if((i|0)==(f|0)){m=n;break}else{j=n;k=k+(g<<3)|0;l=l+(g<<3)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){s=0.0;t=0}else{g=0;n=0.0;do{k=g|1;i=g|2;d=g|3;n=n+(+L(+(+p[a+(g<<3)>>3]-+p[c+(g<<3)>>3]))+ +L(+(+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3]))+ +L(+(+p[a+(i<<3)>>3]-+p[c+(i<<3)>>3]))+ +L(+(+p[a+(d<<3)>>3]-+p[c+(d<<3)>>3])));g=g+4|0}while((g|0)<=(f|0));s=n;t=l&-4}if((t|0)<(l|0)){f=t;n=s;while(1){j=n+ +L(+(+p[a+(f<<3)>>3]-+p[c+(f<<3)>>3]));f=f+1|0;if((f|0)==(l|0)){u=j;break}else n=j}}else u=s;m=h+u;p[e>>3]=m;return 0}function YP(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))o=j;else{q=0;r=j;while(1){s=r+ +L(+(+n[k+(q<<2)>>2]-+n[l+(q<<2)>>2]));q=q+1|0;if((q|0)==(g|0)){o=s;break}else r=s}}i=i+1|0;if((i|0)==(f|0)){m=o;break}else{j=o;k=k+(g<<2)|0;l=l+(g<<2)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){t=0.0;u=0}else{g=0;o=0.0;do{k=g|1;i=g|2;d=g|3;o=o+(+L(+(+n[a+(g<<2)>>2]-+n[c+(g<<2)>>2]))+ +L(+(+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2]))+ +L(+(+n[a+(i<<2)>>2]-+n[c+(i<<2)>>2]))+ +L(+(+n[a+(d<<2)>>2]-+n[c+(d<<2)>>2])));g=g+4|0}while((g|0)<=(f|0));t=o;u=l&-4}if((u|0)<(l|0)){f=u;o=t;while(1){j=o+ +L(+(+n[a+(f<<2)>>2]-+n[c+(f<<2)>>2]));f=f+1|0;if((f|0)==(l|0)){v=j;break}else o=j}}else v=t;m=h+v;p[e>>3]=m;return 0}function ZP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0.0;i=+p[e>>3];if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;p[e>>3]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{q=0;r=k;while(1){s=(f[l+(q<<2)>>2]|0)-(f[m+(q<<2)>>2]|0)|0;t=r+ +(((s|0)>-1?s:0-s|0)|0);q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<2)|0;m=m+(h<<2)|0}}p[e>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{l=h|1;j=h|2;d=h|3;o=o+(+L(+(+((f[a+(h<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)|0)))+ +L(+(+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0)))+ +L(+(+((f[a+(j<<2)>>2]|0)-(f[c+(j<<2)>>2]|0)|0)))+ +L(+(+((f[a+(d<<2)>>2]|0)-(f[c+(d<<2)>>2]|0)|0))));h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){k=o+ +L(+(+((f[a+(g<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)|0)));g=g+1|0;if((g|0)==(m|0)){w=k;break}else o=k}}else w=u;n=i+w;p[e>>3]=n;return 0}function _P(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[g>>2]|0;if(e|0){if((h|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[g>>2]=o;return 0}while(1){if(!(b[e+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(d[m+(q<<1)>>1]|0)-(d[n+(q<<1)>>1]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(h|0)){o=p;break}else{l=p;m=m+(i<<1)|0;n=n+(i<<1)|0}}f[g>>2]=o;return 0}n=Y(i,h)|0;h=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(d[a+(i<<1)>>1]|0)-(d[c+(i<<1)>>1]|0)|0;l=i|1;k=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;l=i|2;e=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;l=i|3;r=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((e|0)>-1?e:0-e|0)+((r|0)>-1?r:0-r|0)|0;i=i+4|0}while((i|0)<=(h|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){h=(d[a+(m<<1)>>1]|0)-(d[c+(m<<1)>>1]|0)|0;i=((h|0)>-1?h:0-h|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[g>>2]=o;return 0}function $P(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){k=0;l=i;m=a;n=c}else{o=i;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(j[m+(q<<1)>>1]|0)-(j[n+(q<<1)>>1]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(h|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+(h<<1)|0;n=n+(h<<1)|0}}f[e>>2]=o;return 0}n=Y(h,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{h=0;m=0;do{p=(j[a+(h<<1)>>1]|0)-(j[c+(h<<1)>>1]|0)|0;l=h|1;k=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;l=h|2;d=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;l=h|3;r=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((d|0)>-1?d:0-d|0)+((r|0)>-1?r:0-r|0)|0;h=h+4|0}while((h|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(j[a+(m<<1)>>1]|0)-(j[c+(m<<1)>>1]|0)|0;h=((g|0)>-1?g:0-g|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=h;break}else v=h}}else w=u;o=w+i|0;f[e>>2]=o;return 0}function aQ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;f[e>>2]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{p=0;q=k;while(1){r=(b[l+p>>0]|0)-(b[m+p>>0]|0)|0;s=((r|0)>-1?r:0-r|0)+q|0;p=p+1|0;if((p|0)==(h|0)){o=s;break}else q=s}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+h|0;m=m+h|0}}f[e>>2]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){t=0;u=0}else{h=0;l=0;do{o=(b[a+h>>0]|0)-(b[c+h>>0]|0)|0;k=h|1;j=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|2;d=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|3;q=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;l=((o|0)>-1?o:0-o|0)+l+((j|0)>-1?j:0-j|0)+((d|0)>-1?d:0-d|0)+((q|0)>-1?q:0-q|0)|0;h=h+4|0}while((h|0)<=(g|0));t=l;u=m&-4}if((u|0)<(m|0)){l=u;u=t;while(1){g=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;h=((g|0)>-1?g:0-g|0)+u|0;l=l+1|0;if((l|0)==(m|0)){v=h;break}else u=h}}else v=t;n=v+i|0;f[e>>2]=n;return 0}function bQ(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[e>>2]|0;if(d|0){if((g|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(h[m+q>>0]|0)-(h[n+q>>0]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+i|0;n=n+i|0}}f[e>>2]=o;return 0}n=Y(i,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(h[a+i>>0]|0)-(h[c+i>>0]|0)|0;l=i|1;k=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|2;d=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|3;r=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((d|0)>-1?d:0-d|0)+((r|0)>-1?r:0-r|0)|0;i=i+4|0}while((i|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;i=((g|0)>-1?g:0-g|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[e>>2]=o;return 0}function cQ(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0.0,ya=0,za=0.0;l=u;u=u+1104|0;m=l;o=m+8|0;f[m>>2]=o;q=m+4|0;f[q>>2]=h;if(h>>>0>136){r=XDc(h>>>0>536870911?-1:h<<3)|0;f[m>>2]=r;s=r}else s=o;r=(g|0)>30?g:30;t=b>>>2;b=e>>>2;e=(h|0)>0;a:do if(e){v=(d|0)==0;w=h<<2;if((g|0)>0)x=0;else{y=0;while(1){z=Y(b,y)|0;p[s+(y<<3)>>3]=0.0;if(!v){XIc(d+(z<<2)|0,0,w|0)|0;n[d+(z+y<<2)>>2]=1.0}y=y+1|0;if((y|0)==(h|0))break a}}do{y=Y(b,x)|0;z=d+(y<<2)|0;A=Y(x,t)|0;B=0;C=0.0;do{D=+n[a+(B+A<<2)>>2];C=C+D*D;B=B+1|0}while((B|0)!=(g|0));p[s+(x<<3)>>3]=C;if(!v){XIc(z|0,0,w|0)|0;n[d+(y+x<<2)>>2]=1.0}x=x+1|0}while((x|0)!=(h|0))}while(0);b:do if((r|0)>0){x=h+-1|0;w=(h|0)>1;v=(g|0)>0;D=k;B=(d|0)==0;A=0;do{if(w){E=0;F=0}else break b;while(1){G=F;F=F+1|0;if((F|0)<(h|0)){H=a+((Y(G,t)|0)<<2)|0;I=s+(G<<3)|0;K=d+((Y(G,b)|0)<<2)|0;G=F;N=E;while(1){O=a+((Y(G,t)|0)<<2)|0;P=+p[I>>3];Q=s+(G<<3)|0;R=+p[Q>>3];if(v){S=0.0;T=0;while(1){U=S+ +n[H+(T<<2)>>2]*+n[O+(T<<2)>>2];T=T+1|0;if((T|0)==(g|0)){V=U;break}else S=U}}else V=0.0;if(!(+L(+V)<=D*+M(+(P*R)))){S=V*2.0;U=P-R;W=+L(+S);X=+L(+U);if(!(W>X))if(U!=U|0.0!=0.0|U==0.0)Z=0.0;else{_=W/X;$=X;aa=_*_;ba=32}else{_=X/W;$=W;aa=_*_;ba=32}if((ba|0)==32){ba=0;Z=$*+M(+(aa+1.0))}if(U<0.0){_=+M(+((Z-U)*.5/Z));ca=S/(Z*_*2.0);da=_}else{_=+M(+((U+Z)/(Z*2.0)));ca=_;da=S/(Z*_*2.0)}if(v){_=0.0;S=0.0;T=0;while(1){ea=H+(T<<2)|0;U=+n[ea>>2];fa=O+(T<<2)|0;W=+n[fa>>2];X=ca*U+da*W;ga=ca*W-da*U;n[ea>>2]=X;n[fa>>2]=ga;U=X;X=_+U*U;U=ga;ga=S+U*U;T=T+1|0;if((T|0)==(g|0)){ha=X;ia=ga;break}else{_=X;S=ga}}}else{ha=0.0;ia=0.0}p[I>>3]=ha;p[Q>>3]=ia;if(!B?(T=d+((Y(G,b)|0)<<2)|0,e):0){O=0;do{fa=K+(O<<2)|0;S=+n[fa>>2];ea=T+(O<<2)|0;_=+n[ea>>2];n[fa>>2]=ca*S+da*_;n[ea>>2]=ca*_-da*S;O=O+1|0}while((O|0)!=(h|0));ja=1}else ja=1}else ja=N;G=G+1|0;if((G|0)==(h|0)){ka=ja;break}else N=ja}}else ka=E;if((F|0)==(x|0))break;else E=ka}A=A+1|0}while(ka&(A|0)<(r|0))}while(0);if(e){if((g|0)>0){r=0;do{ka=Y(r,t)|0;da=0.0;E=0;do{ca=+n[a+(E+ka<<2)>>2];da=da+ca*ca;E=E+1|0}while((E|0)!=(g|0));ca=+M(+da);p[s+(r<<3)>>3]=ca;r=r+1|0}while((r|0)!=(h|0))}else XIc(s|0,0,h<<3|0)|0;r=h+-1|0;c:do if((h|0)>1){E=(g|0)>0;if(!d){ka=0;while(1){F=ka;ka=ka+1|0;if((ka|0)<(h|0)){ja=F;ba=ka;while(1){A=+p[s+(ja<<3)>>3]<+p[s+(ba<<3)>>3]?ba:ja;ba=ba+1|0;if((ba|0)==(h|0)){la=A;break}else ja=A}}else la=F;if((F|0)!=(la|0)){ja=s+(F<<3)|0;ba=s+(la<<3)|0;ca=+p[ja>>3];p[ja>>3]=+p[ba>>3];p[ba>>3]=ca}if((ka|0)==(r|0))break c}}else ma=0;do{ka=ma;ma=ma+1|0;if((ma|0)<(h|0)){ba=ka;ja=ma;while(1){A=+p[s+(ba<<3)>>3]<+p[s+(ja<<3)>>3]?ja:ba;ja=ja+1|0;if((ja|0)==(h|0)){na=A;break}else ba=A}}else na=ka;if((ka|0)!=(na|0)){ba=s+(ka<<3)|0;ja=s+(na<<3)|0;da=+p[ba>>3];p[ba>>3]=+p[ja>>3];p[ja>>3]=da;if(E){ja=Y(ka,t)|0;ba=Y(na,t)|0;F=0;do{A=a+(F+ja<<2)|0;x=a+(F+ba<<2)|0;B=f[A>>2]|0;f[A>>2]=f[x>>2];f[x>>2]=B;F=F+1|0}while((F|0)!=(g|0))}F=Y(ka,b)|0;ba=Y(na,b)|0;ja=0;do{B=d+(ja+F<<2)|0;x=d+(ja+ba<<2)|0;A=f[B>>2]|0;f[B>>2]=f[x>>2];f[x>>2]=A;ja=ja+1|0}while((ja|0)!=(h|0))}}while((ma|0)!=(r|0))}while(0);if(e){e=0;do{n[c+(e<<2)>>2]=+p[s+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0))}}if((d|0)!=0&(i|0)>0){d=(g|0)>0;da=1.0/+(g|0);ca=-da;ia=k*100.0;e=305419896;c=0;r=0;while(1){if((r|0)<(h|0))oa=+p[s+(r<<3)>>3];else oa=0.0;if(!(oa<=j)){pa=oa;qa=e;ra=c}else{ma=Y(r,t)|0;b=(r|0)>0;na=0;la=e;E=c;while(1){if(d){ja=0;ba=la;F=E;while(1){ka=mJc(ba|0,0,-130063606,0)|0;A=UIc(ka|0,J|0,F|0,0)|0;ka=J;n[a+(ja+ma<<2)>>2]=(A&256|0)!=0|0!=0?da:ca;ja=ja+1|0;if((ja|0)==(g|0)){sa=A;ta=ka;break}else{ba=A;F=ka}}}else{sa=la;ta=E}d:do if(b){if(d){F=0;do{ba=Y(F,t)|0;ja=0;k=0.0;do{k=k+ +n[a+(ja+ma<<2)>>2]*+n[a+(ja+ba<<2)>>2];ja=ja+1|0}while((ja|0)!=(g|0));ua=0.0;va=0;do{ja=a+(va+ma<<2)|0;ha=+n[ja>>2]-k*+n[a+(va+ba<<2)>>2];n[ja>>2]=ha;ua=ua+ +L(+ha);va=va+1|0}while((va|0)!=(g|0));k=ua>ia?1.0/ua:0.0;ba=0;do{ja=a+(ba+ma<<2)|0;n[ja>>2]=k*+n[ja>>2];ba=ba+1|0}while((ba|0)!=(g|0));F=F+1|0}while((F|0)!=(r|0))}else{F=0;do F=F+1|0;while((F|0)!=(r|0))}if(b){if(d)wa=0;else{F=0;while(1){F=F+1|0;if((F|0)==(r|0))break d}}do{F=Y(wa,t)|0;ba=0;k=0.0;do{k=k+ +n[a+(ba+ma<<2)>>2]*+n[a+(ba+F<<2)>>2];ba=ba+1|0}while((ba|0)!=(g|0));xa=0.0;ya=0;do{ba=a+(ya+ma<<2)|0;ha=+n[ba>>2]-k*+n[a+(ya+F<<2)>>2];n[ba>>2]=ha;xa=xa+ +L(+ha);ya=ya+1|0}while((ya|0)!=(g|0));k=xa>ia?1.0/xa:0.0;F=0;do{ba=a+(F+ma<<2)|0;n[ba>>2]=k*+n[ba>>2];F=F+1|0}while((F|0)!=(g|0));wa=wa+1|0}while((wa|0)!=(r|0))}}while(0);if(d){F=0;k=0.0;while(1){ha=+n[a+(F+ma<<2)>>2];Z=k+ha*ha;F=F+1|0;if((F|0)==(g|0)){za=Z;break}else k=Z}}else za=0.0;k=+M(+za);if(!(k<=j)|(na|0)>98){pa=k;qa=sa;ra=ta;break}else{na=na+1|0;la=sa;E=ta}}}k=pa>j?1.0/pa:0.0;if(d){E=Y(r,t)|0;la=0;do{na=a+(la+E<<2)|0;n[na>>2]=k*+n[na>>2];la=la+1|0}while((la|0)!=(g|0))}r=r+1|0;if((r|0)==(i|0))break;else{e=qa;c=ra}}}ra=f[m>>2]|0;if((ra|0)==(o|0)){u=l;return}if(ra|0)ZDc(ra);f[m>>2]=o;f[q>>2]=136;u=l;return}function dQ(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0;l=u;u=u+1104|0;m=l;n=m+8|0;f[m>>2]=n;o=m+4|0;f[o>>2]=h;if(h>>>0>136){q=XDc(h>>>0>536870911?-1:h<<3)|0;f[m>>2]=q;r=q}else r=n;q=(g|0)>30?g:30;s=b>>>3;b=e>>>3;e=(h|0)>0;a:do if(e){t=(d|0)==0;v=h<<3;if((g|0)<=0)if(t){XIc(r|0,0,v|0)|0;break}else{w=0;while(1){x=Y(b,w)|0;p[r+(w<<3)>>3]=0.0;XIc(d+(x<<3)|0,0,v|0)|0;p[d+(x+w<<3)>>3]=1.0;w=w+1|0;if((w|0)==(h|0))break a}}else y=0;do{w=Y(b,y)|0;x=d+(w<<3)|0;z=Y(y,s)|0;A=0;B=0.0;do{C=+p[a+(A+z<<3)>>3];B=B+C*C;A=A+1|0}while((A|0)!=(g|0));p[r+(y<<3)>>3]=B;if(!t){XIc(x|0,0,v|0)|0;p[d+(w+y<<3)>>3]=1.0}y=y+1|0}while((y|0)!=(h|0))}while(0);b:do if((q|0)>0){y=h+-1|0;v=(h|0)>1;t=(g|0)>0;A=(d|0)==0;z=0;do{if(v){D=0;E=0}else break b;while(1){F=E;E=E+1|0;if((E|0)<(h|0)){G=a+((Y(F,s)|0)<<3)|0;H=r+(F<<3)|0;I=d+((Y(F,b)|0)<<3)|0;F=E;K=D;while(1){N=a+((Y(F,s)|0)<<3)|0;C=+p[H>>3];O=r+(F<<3)|0;P=+p[O>>3];if(t){Q=0.0;R=0;while(1){S=Q+ +p[G+(R<<3)>>3]*+p[N+(R<<3)>>3];R=R+1|0;if((R|0)==(g|0)){T=S;break}else Q=S}}else T=0.0;if(!(+L(+T)<=+M(+(C*P))*k)){Q=T*2.0;S=C-P;U=+L(+Q);V=+L(+S);if(!(U>V))if(S!=S|0.0!=0.0|S==0.0)W=0.0;else{X=U/V;Z=V;_=X*X;$=32}else{X=V/U;Z=U;_=X*X;$=32}if(($|0)==32){$=0;W=Z*+M(+(_+1.0))}if(S<0.0){X=+M(+((W-S)*.5/W));aa=Q/(W*X*2.0);ba=X}else{X=+M(+((S+W)/(W*2.0)));aa=X;ba=Q/(W*X*2.0)}if(t){X=0.0;Q=0.0;R=0;while(1){ca=G+(R<<3)|0;S=+p[ca>>3];da=N+(R<<3)|0;U=+p[da>>3];V=aa*S+ba*U;ea=aa*U-ba*S;p[ca>>3]=V;p[da>>3]=ea;S=X+V*V;V=Q+ea*ea;R=R+1|0;if((R|0)==(g|0)){fa=S;ga=V;break}else{X=S;Q=V}}}else{fa=0.0;ga=0.0}p[H>>3]=fa;p[O>>3]=ga;if(!A?(R=d+((Y(F,b)|0)<<3)|0,e):0){N=0;do{da=I+(N<<3)|0;Q=+p[da>>3];ca=R+(N<<3)|0;X=+p[ca>>3];p[da>>3]=aa*Q+ba*X;p[ca>>3]=aa*X-ba*Q;N=N+1|0}while((N|0)!=(h|0));ha=1}else ha=1}else ha=K;F=F+1|0;if((F|0)==(h|0)){ia=ha;break}else K=ha}}else ia=D;if((E|0)==(y|0))break;else D=ia}z=z+1|0}while(ia&(z|0)<(q|0))}while(0);if(e){if((g|0)>0){q=0;do{ia=Y(q,s)|0;ba=0.0;D=0;do{aa=+p[a+(D+ia<<3)>>3];ba=ba+aa*aa;D=D+1|0}while((D|0)!=(g|0));aa=+M(+ba);p[r+(q<<3)>>3]=aa;q=q+1|0}while((q|0)!=(h|0))}else XIc(r|0,0,h<<3|0)|0;q=h+-1|0;c:do if((h|0)>1){D=(g|0)>0;if(!d){ia=0;while(1){E=ia;ia=ia+1|0;if((ia|0)<(h|0)){ha=E;$=ia;while(1){z=+p[r+(ha<<3)>>3]<+p[r+($<<3)>>3]?$:ha;$=$+1|0;if(($|0)==(h|0)){ja=z;break}else ha=z}}else ja=E;if((E|0)!=(ja|0)){ha=r+(E<<3)|0;$=r+(ja<<3)|0;aa=+p[ha>>3];p[ha>>3]=+p[$>>3];p[$>>3]=aa}if((ia|0)==(q|0))break c}}else ka=0;do{ia=ka;ka=ka+1|0;if((ka|0)<(h|0)){$=ia;ha=ka;while(1){z=+p[r+($<<3)>>3]<+p[r+(ha<<3)>>3]?ha:$;ha=ha+1|0;if((ha|0)==(h|0)){la=z;break}else $=z}}else la=ia;if((ia|0)!=(la|0)){$=r+(ia<<3)|0;ha=r+(la<<3)|0;ba=+p[$>>3];p[$>>3]=+p[ha>>3];p[ha>>3]=ba;if(D){ha=Y(ia,s)|0;$=Y(la,s)|0;E=0;do{z=a+(E+ha<<3)|0;y=a+(E+$<<3)|0;ba=+p[z>>3];p[z>>3]=+p[y>>3];p[y>>3]=ba;E=E+1|0}while((E|0)!=(g|0))}E=Y(ia,b)|0;$=Y(la,b)|0;ha=0;do{y=d+(ha+E<<3)|0;z=d+(ha+$<<3)|0;ba=+p[y>>3];p[y>>3]=+p[z>>3];p[z>>3]=ba;ha=ha+1|0}while((ha|0)!=(h|0))}}while((ka|0)!=(q|0))}while(0);if(e){e=0;do{p[c+(e<<3)>>3]=+p[r+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0))}}if((d|0)!=0&(i|0)>0){d=(g|0)>0;ba=1.0/+(g|0);aa=-ba;ga=k*100.0;e=305419896;c=0;q=0;while(1){if((q|0)<(h|0))ma=+p[r+(q<<3)>>3];else ma=0.0;if(!(ma<=j)){na=ma;oa=e;pa=c}else{ka=Y(q,s)|0;b=(q|0)>0;la=0;ja=e;D=c;while(1){if(d){ha=0;$=ja;E=D;while(1){ia=mJc($|0,0,-130063606,0)|0;z=UIc(ia|0,J|0,E|0,0)|0;ia=J;p[a+(ha+ka<<3)>>3]=(z&256|0)!=0|0!=0?ba:aa;ha=ha+1|0;if((ha|0)==(g|0)){qa=z;ra=ia;break}else{$=z;E=ia}}}else{qa=ja;ra=D}d:do if(b){if(d){E=0;do{$=Y(E,s)|0;ha=0;k=0.0;do{k=k+ +p[a+(ha+ka<<3)>>3]*+p[a+(ha+$<<3)>>3];ha=ha+1|0}while((ha|0)!=(g|0));sa=0.0;ta=0;do{ha=a+(ta+ka<<3)|0;fa=+p[ha>>3]-k*+p[a+(ta+$<<3)>>3];p[ha>>3]=fa;sa=sa+ +L(+fa);ta=ta+1|0}while((ta|0)!=(g|0));k=sa>ga?1.0/sa:0.0;$=0;do{ha=a+($+ka<<3)|0;p[ha>>3]=k*+p[ha>>3];$=$+1|0}while(($|0)!=(g|0));E=E+1|0}while((E|0)!=(q|0))}else{E=0;do E=E+1|0;while((E|0)!=(q|0))}if(b){if(d)ua=0;else{E=0;while(1){E=E+1|0;if((E|0)==(q|0))break d}}do{E=Y(ua,s)|0;$=0;k=0.0;do{k=k+ +p[a+($+ka<<3)>>3]*+p[a+($+E<<3)>>3];$=$+1|0}while(($|0)!=(g|0));va=0.0;wa=0;do{$=a+(wa+ka<<3)|0;fa=+p[$>>3]-k*+p[a+(wa+E<<3)>>3];p[$>>3]=fa;va=va+ +L(+fa);wa=wa+1|0}while((wa|0)!=(g|0));k=va>ga?1.0/va:0.0;E=0;do{$=a+(E+ka<<3)|0;p[$>>3]=k*+p[$>>3];E=E+1|0}while((E|0)!=(g|0));ua=ua+1|0}while((ua|0)!=(q|0))}}while(0);if(d){E=0;k=0.0;while(1){fa=+p[a+(E+ka<<3)>>3];W=k+fa*fa;E=E+1|0;if((E|0)==(g|0)){xa=W;break}else k=W}}else xa=0.0;k=+M(+xa);if(!(k<=j)|(la|0)>98){na=k;oa=qa;pa=ra;break}else{la=la+1|0;ja=qa;D=ra}}}k=na>j?1.0/na:0.0;if(d){D=Y(q,s)|0;ja=0;do{la=a+(ja+D<<3)|0;p[la>>3]=k*+p[la>>3];ja=ja+1|0}while((ja|0)!=(g|0))}q=q+1|0;if((q|0)==(i|0))break;else{e=oa;c=pa}}}pa=f[m>>2]|0;if((pa|0)==(n|0)){u=l;return}if(pa|0)ZDc(pa);f[m>>2]=n;f[o>>2]=136;u=l;return}function eQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0;c=u;u=u+1168|0;d=c+1112|0;e=c+72|0;g=c+16|0;h=c;do if((d$(a)|0)==65536){i=f[a+4>>2]|0;f[d>>2]=f[i>>2];j=d+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=d+8|0;f[l>>2]=f[i+8>>2];f[d+12>>2]=f[i+12>>2];m=d+16|0;f[m>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];f[d+28>>2]=f[i+28>>2];f[d+32>>2]=f[i+32>>2];o=f[i+36>>2]|0;f[d+36>>2]=o;f[d+40>>2]=l;q=d+48|0;r=d+44|0;f[r>>2]=q;f[q>>2]=0;f[d+52>>2]=0;if(o|0){s=o+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;s=f[r>>2]|0;f[s>>2]=f[k>>2];f[s+4>>2]=f[k+4>>2];t=l;v=q;w=m;x=r;y=d;break}else{f[j>>2]=0;ZS(d,i);t=l;v=q;w=m;x=r;y=d;break}}else{a$(d,a,-1);t=d+8|0;v=d+48|0;w=d+16|0;x=d+44|0;y=d}while(0);a=f[y>>2]&4095;y=f[t>>2]|0;t=f[v>>2]|0;r=f[w>>2]|0;if(!r){f[e>>2]=0;z=e+4|0;f[z>>2]=0;A=tT(e,12)|0;B=A;C=461290;D=B+12|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,e,214732,214744,777)}m=d+4|0;q=f[m>>2]|0;if((q|0)<3)E=Y(f[d+12>>2]|0,y)|0;else{l=f[d+40>>2]|0;i=0;j=1;while(1){k=Y(f[l+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(q|0)){E=k;break}else j=k}}if((q|0)==0|(E|0)==0){f[e>>2]=0;z=e+4|0;f[z>>2]=0;A=tT(e,12)|0;B=A;C=461290;D=B+12|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,e,214732,214744,777)}if(!((a+-5|0)>>>0<2?(y|0)==(f[d+12>>2]|0):0)){f[e>>2]=0;f[e+4>>2]=0;B=tT(e,58)|0;C=214809;D=B+58|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,e,214732,214744,778)}C=(y|0)==2;a:do if((a|0)==5){if(C){B=r+t|0;F=+n[r>>2]*+n[B+4>>2]-+n[r+4>>2]*+n[B>>2];break}switch(y|0){case 3:{B=r+t|0;G=+n[B+4>>2];D=r+(t<<1)|0;H=+n[D+8>>2];I=+n[B+8>>2];J=+n[D+4>>2];K=+n[B>>2];L=+n[D>>2];F=+n[r+8>>2]*(J*K-G*L)+(+n[r>>2]*(G*H-I*J)-+n[r+4>>2]*(H*K-I*L));break a;break}case 1:{F=+n[r>>2];break a;break}default:{D=Y(y<<2,y)|0;B=e+8|0;f[e>>2]=B;A=e+4|0;f[A>>2]=D;if(D>>>0>1032){z=XDc(D)|0;f[e>>2]=z;M=z}else M=B;Vj(g,y,y,5,M,0);z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;h_(d,h);z=g+16|0;D=g+44|0;E=g+48|0;q=n2(f[z>>2]|0,f[E>>2]|0,y,0,0,0)|0;L=+(q|0);if((q|0)!=0&(y|0)>0){q=f[z>>2]|0;j=f[f[D>>2]>>2]|0;I=L;i=0;while(1){l=q+(Y(j,i)|0)+(i<<2)|0;K=I*+n[l>>2];i=i+1|0;if((i|0)==(y|0)){N=K;break}else I=K}}else N=L;i=g+36|0;j=f[i>>2]|0;if(j|0?(q=j+12|0,j=f[q>>2]|0,f[q>>2]=j+-1,(j|0)==1):0)_S(g);f[i>>2]=0;i=g+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[i>>2]|0)>0){j=f[g+40>>2]|0;q=0;do{f[j+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[i>>2]|0))}i=f[D>>2]|0;if((i|0)!=(E|0))g0(i);i=f[e>>2]|0;if((i|0)!=(B|0)){if(i|0)ZDc(i);f[e>>2]=B;f[A>>2]=1032}F=N;break a}}}else{if(C){i=r+t|0;F=+p[r>>3]*+p[i+8>>3]-+p[r+8>>3]*+p[i>>3];break}switch(y|0){case 3:{i=r+t|0;L=+p[i+8>>3];q=r+(t<<1)|0;I=+p[q+16>>3];K=+p[i+16>>3];H=+p[q+8>>3];J=+p[i>>3];G=+p[q>>3];F=+p[r+16>>3]*(H*J-L*G)+(+p[r>>3]*(L*I-K*H)-+p[r+8>>3]*(I*J-K*G));break a;break}case 1:{F=+p[r>>3];break a;break}default:{q=Y(y<<3,y)|0;i=e+8|0;f[e>>2]=i;j=e+4|0;f[j>>2]=q;if(q>>>0>1032){z=XDc(q)|0;f[e>>2]=z;O=z}else O=i;Vj(g,y,y,6,O,0);z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;h_(d,h);z=g+16|0;q=g+44|0;l=g+48|0;k=p2(f[z>>2]|0,f[l>>2]|0,y,0,0,0)|0;G=+(k|0);if((k|0)!=0&(y|0)>0){k=f[z>>2]|0;s=f[f[q>>2]>>2]|0;o=0;K=G;while(1){P=k+(Y(s,o)|0)+(o<<3)|0;J=K*+p[P>>3];o=o+1|0;if((o|0)==(y|0)){Q=J;break}else K=J}}else Q=G;o=g+36|0;s=f[o>>2]|0;if(s|0?(k=s+12|0,s=f[k>>2]|0,f[k>>2]=s+-1,(s|0)==1):0)_S(g);f[o>>2]=0;o=g+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[o>>2]|0)>0){s=f[g+40>>2]|0;k=0;do{f[s+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[o>>2]|0))}o=f[q>>2]|0;if((o|0)!=(l|0))g0(o);o=f[e>>2]|0;if((o|0)!=(i|0)){if(o|0)ZDc(o);f[e>>2]=i;f[j>>2]=1032}F=Q;break a}}}while(0);e=d+36|0;g=f[e>>2]|0;if(g|0?(y=g+12|0,g=f[y>>2]|0,f[y>>2]=g+-1,(g|0)==1):0)_S(d);f[e>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){w=f[d+40>>2]|0;d=0;do{f[w+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[m>>2]|0))}m=f[x>>2]|0;if((m|0)==(v|0)){u=c;return +F}g0(m);u=c;return +F}function fQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0,la=0,ma=0;e=u;u=u+2384|0;g=e+2328|0;h=e+1288|0;i=e+88|0;j=e+1232|0;k=e+32|0;l=e;m=e+1216|0;o=e+1200|0;q=e+1184|0;r=e+1128|0;do if((d$(a)|0)==65536){s=f[a+4>>2]|0;f[g>>2]=f[s>>2];t=g+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=g+8|0;f[w>>2]=f[s+8>>2];f[g+12>>2]=f[s+12>>2];f[g+16>>2]=f[s+16>>2];f[g+20>>2]=f[s+20>>2];f[g+24>>2]=f[s+24>>2];f[g+28>>2]=f[s+28>>2];f[g+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[g+36>>2]=x;f[g+40>>2]=w;w=g+48|0;y=g+44|0;f[y>>2]=w;f[w>>2]=0;f[g+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];z=g;break}else{f[t>>2]=0;ZS(g,s);z=g;break}}else{a$(g,a,-1);z=g}while(0);a=f[z>>2]|0;z=a&4095;s=(z|0)==5;t=(z|0)==6;if((z+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;A=tT(h,32)|0;B=214868;C=A+32|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,h,214901,214744,853)}v=(a>>>3&511)+1<<(47696>>>(z<<1&14)&3);a=f[g+8>>2]|0;w=f[g+12>>2]|0;do if((d|0)==1){y=(w|0)<(a|0)?w:a;x=Y(y,a)|0;D=(Y(x+y+(Y(y,w)|0)|0,v)|0)+8|0;E=h+8|0;f[h>>2]=E;F=h+4|0;f[F>>2]=D;if(D>>>0>1032){G=XDc(D)|0;f[h>>2]=G;H=G}else H=E;Vj(i,a,y,z,v+-1+H&0-v,0);G=i+16|0;D=i+44|0;Vj(j,y,1,z,(f[G>>2]|0)+(Y(x,v)|0)|0,0);x=j+16|0;I=j+44|0;Vj(k,y,w,z,(f[x>>2]|0)+(Y(y,v)|0)|0,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;y=m+8|0;f[y>>2]=0;f[y+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;y=o+8|0;f[y>>2]=0;f[y+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;y=q+8|0;f[y>>2]=0;f[y+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=k;gQ(l,m,o,q,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[r>>2]=1124007936;y=r+4|0;J=r+8|0;K=r+40|0;A=y;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[K>>2]=J;L=r+48|0;M=r+44|0;f[M>>2]=L;f[L>>2]=0;f[r+52>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=r;hQ(l,m,o,q,c);N=r+36|0;O=f[N>>2]|0;if(O|0?(P=O+12|0,O=f[P>>2]|0,f[P>>2]=O+-1,(O|0)==1):0)_S(r);f[N>>2]=0;N=r+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[y>>2]|0)>0){N=f[K>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[y>>2]|0))}y=f[M>>2]|0;if((y|0)!=(L|0))g0(y);y=f[x>>2]|0;if(s){Q=+n[y>>2];if(!(Q>=1.1920928955078125e-07))R=0.0;else R=+n[y+(w+-1<<2)>>2]/Q}else{Q=+p[y>>3];if(!(Q>=2.220446049250313e-16))R=0.0;else R=+p[y+(w+-1<<3)>>3]/Q}y=k+36|0;O=f[y>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)_S(k);f[y>>2]=0;y=k+16|0;O=k+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[O>>2]|0)>0){y=f[k+40>>2]|0;N=0;do{f[y+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[O>>2]|0))}O=f[k+44>>2]|0;if((O|0)!=(k+48|0))g0(O);O=j+36|0;N=f[O>>2]|0;if(N|0?(y=N+12|0,N=f[y>>2]|0,f[y>>2]=N+-1,(N|0)==1):0)_S(j);f[O>>2]=0;O=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[O>>2]|0)>0){N=f[j+40>>2]|0;y=0;do{f[N+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[O>>2]|0))}O=f[I>>2]|0;if((O|0)!=(j+48|0))g0(O);O=i+36|0;y=f[O>>2]|0;if(y|0?(N=y+12|0,y=f[N>>2]|0,f[N>>2]=y+-1,(y|0)==1):0)_S(i);f[O>>2]=0;O=i+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[O>>2]|0)>0){y=f[i+40>>2]|0;N=0;do{f[y+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[O>>2]|0))}O=f[D>>2]|0;if((O|0)!=(i+48|0))g0(O);O=f[h>>2]|0;if((O|0)!=(E|0)){if(O|0)ZDc(O);f[h>>2]=E;f[F>>2]=1032}S=R}else{if((a|0)!=(w|0)){f[h>>2]=0;f[h+4>>2]=0;O=tT(h,6)|0;b[O>>0]=b[214908]|0;b[O+1>>0]=b[214909]|0;b[O+2>>0]=b[214910]|0;b[O+3>>0]=b[214911]|0;b[O+4>>0]=b[214912]|0;b[O+5>>0]=b[214913]|0;z5(-215,h,214901,214744,877)}if((d|0)==2){O=Y(a,a)|0;N=(Y((O<<1)+a|0,v)|0)+8|0;y=h+8|0;f[h>>2]=y;G=h+4|0;f[G>>2]=N;if(N>>>0>1032){I=XDc(N)|0;f[h>>2]=I;T=I}else T=y;Vj(i,a,a,z,v+-1+T&0-v,0);I=i+16|0;N=i+44|0;Vj(j,a,1,z,(f[I>>2]|0)+(Y(O,v)|0)|0,0);O=j+16|0;x=j+44|0;Vj(k,a,a,z,(f[O>>2]|0)+(Y(a,v)|0)|0,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;L=m+8|0;f[L>>2]=0;f[L+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;L=o+8|0;f[L>>2]=0;f[L+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;iQ(l,m,o)|0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=k;L=m+8|0;f[L>>2]=0;f[L+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=i;jR(l,m);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[r>>2]=1124007936;L=r+4|0;M=r+8|0;K=r+40|0;A=L;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[K>>2]=M;F=r+48|0;E=r+44|0;f[E>>2]=F;f[F>>2]=0;f[r+52>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=r;hQ(l,m,o,q,c);D=r+36|0;J=f[D>>2]|0;if(J|0?(P=J+12|0,J=f[P>>2]|0,f[P>>2]=J+-1,(J|0)==1):0)_S(r);f[D>>2]=0;D=r+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[L>>2]|0)>0){D=f[K>>2]|0;J=0;do{f[D+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[L>>2]|0))}L=f[E>>2]|0;if((L|0)!=(F|0))g0(L);L=f[O>>2]|0;if(s){Q=+n[L>>2];if(!(Q>=1.1920928955078125e-07))U=0.0;else U=+n[L+(a+-1<<2)>>2]/Q}else{Q=+p[L>>3];if(!(Q>=2.220446049250313e-16))U=0.0;else U=+p[L+(a+-1<<3)>>3]/Q}L=k+36|0;J=f[L>>2]|0;if(J|0?(D=J+12|0,J=f[D>>2]|0,f[D>>2]=J+-1,(J|0)==1):0)_S(k);f[L>>2]=0;L=k+16|0;J=k+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[J>>2]|0)>0){L=f[k+40>>2]|0;D=0;do{f[L+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[J>>2]|0))}J=f[k+44>>2]|0;if((J|0)!=(k+48|0))g0(J);J=j+36|0;D=f[J>>2]|0;if(D|0?(L=D+12|0,D=f[L>>2]|0,f[L>>2]=D+-1,(D|0)==1):0)_S(j);f[J>>2]=0;J=j+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[J>>2]|0)>0){D=f[j+40>>2]|0;L=0;do{f[D+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[J>>2]|0))}J=f[x>>2]|0;if((J|0)!=(j+48|0))g0(J);J=i+36|0;L=f[J>>2]|0;do if(L|0){D=L+12|0;O=f[D>>2]|0;f[D>>2]=O+-1;if((O|0)!=1)break;_S(i)}while(0);f[J>>2]=0;L=i+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[L>>2]|0)>0){x=f[i+40>>2]|0;O=0;do{f[x+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[N>>2]|0;if((L|0)!=(i+48|0))g0(L);L=f[h>>2]|0;if((L|0)!=(y|0)){if(L|0)ZDc(L);f[h>>2]=y;f[G>>2]=1032}S=U;break}L=(d|0)==0;O=(d|0)==3;switch(d|0){case 0:case 3:break;default:{f[h>>2]=0;f[h+4>>2]=0;A=tT(h,48)|0;B=214915;C=A+48|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,h,214901,214744,897)}}Y$(c,a,a,z,-1,0,0);do if((d$(c)|0)==65536){G=f[c+4>>2]|0;f[h>>2]=f[G>>2];y=h+4|0;N=G+4|0;f[y>>2]=f[N>>2];x=h+8|0;f[x>>2]=f[G+8>>2];f[h+12>>2]=f[G+12>>2];f[h+16>>2]=f[G+16>>2];f[h+20>>2]=f[G+20>>2];f[h+24>>2]=f[G+24>>2];f[h+28>>2]=f[G+28>>2];f[h+32>>2]=f[G+32>>2];I=f[G+36>>2]|0;f[h+36>>2]=I;f[h+40>>2]=x;x=h+48|0;J=h+44|0;f[J>>2]=x;f[x>>2]=0;f[h+52>>2]=0;if(I|0){x=I+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[N>>2]|0)<3){N=f[G+44>>2]|0;x=f[J>>2]|0;f[x>>2]=f[N>>2];f[x+4>>2]=f[N+4>>2];break}else{f[y>>2]=0;ZS(h,G);break}}else a$(h,c,-1);while(0);a:do if((a|0)<4){G=f[g+16>>2]|0;y=f[h+16>>2]|0;N=f[g+48>>2]|0;x=f[h+48>>2]|0;b:do switch(a|0){case 2:{if(s){Q=+n[G>>2];J=G+N|0;V=+n[J+4>>2];I=G+4|0;W=Q*V-+n[I>>2]*+n[J>>2];if(!(W!=0.0))break b;X=1.0/W;D=y+x|0;n[D+4>>2]=Q*X;n[y>>2]=V*X;V=X*-+n[J>>2];n[y+4>>2]=X*-+n[I>>2];n[D>>2]=V;Z=1;break a}else{V=+p[G>>3];D=G+N|0;X=+p[D+8>>3];I=G+8|0;Q=V*X-+p[I>>3]*+p[D>>3];if(!(Q!=0.0))break b;W=1.0/Q;J=y+x|0;p[J+8>>3]=V*W;p[y>>3]=X*W;X=-(W*+p[D>>3]);p[y+8>>3]=-(W*+p[I>>3]);p[J>>3]=X;Z=1;break a}break}case 3:{J=N<<1;if(s){X=+n[G>>2];I=G+N|0;W=+n[I+4>>2];D=G+J|0;V=+n[D+8>>2];Q=+n[I+8>>2];_=+n[D+4>>2];$=W*V-Q*_;aa=+n[G+4>>2];ba=+n[I>>2];ca=V*ba;da=+n[D>>2];ea=Q*da;fa=+n[G+8>>2];ga=_*ba-W*da;ha=fa*ga+(X*$-aa*(ca-ea));if(!(ha!=0.0))break b;ia=1.0/ha;n[y>>2]=$*ia;n[y+4>>2]=(_*fa-V*aa)*ia;n[y+8>>2]=(Q*aa-W*fa)*ia;D=y+x|0;n[D>>2]=(ea-ca)*ia;n[D+4>>2]=(X*V-da*fa)*ia;n[D+8>>2]=(ba*fa-X*Q)*ia;D=y+(x<<1)|0;n[D>>2]=ga*ia;n[D+4>>2]=(aa*da-X*_)*ia;n[D+8>>2]=(X*W-aa*ba)*ia;Z=1;break a}else{ia=+p[G>>3];D=G+N|0;ba=+p[D+8>>3];I=G+J|0;aa=+p[I+16>>3];W=+p[D+16>>3];X=+p[I+8>>3];_=ba*aa-W*X;da=+p[G+8>>3];ga=+p[D>>3];Q=aa*ga;fa=+p[I>>3];V=W*fa;ca=+p[G+16>>3];ea=X*ga-ba*fa;$=ca*ea+(ia*_-da*(Q-V));if(!($!=0.0))break b;ha=1.0/$;p[y>>3]=_*ha;p[y+8>>3]=(X*ca-aa*da)*ha;p[y+16>>3]=(W*da-ba*ca)*ha;I=y+x|0;p[I>>3]=(V-Q)*ha;p[I+8>>3]=(ia*aa-fa*ca)*ha;p[I+16>>3]=(ga*ca-ia*W)*ha;I=y+(x<<1)|0;p[I>>3]=ea*ha;p[I+8>>3]=(da*fa-ia*X)*ha;p[I+16>>3]=(ia*ba-da*ga)*ha;Z=1;break a}break}default:if(s){ha=+n[G>>2];if(!(ha!=0.0))break b;n[y>>2]=1.0/ha;Z=1;break a}else{ha=+p[G>>3];if(!(ha!=0.0))break b;p[y>>3]=1.0/ha;Z=1;break a}}while(0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;k_(h,i)|0;Z=0}else{y=Y(Y(a,v)|0,a)|0;G=i+8|0;f[i>>2]=G;x=i+4|0;f[x>>2]=y;if(y>>>0>1032){N=XDc(y)|0;f[i>>2]=N;ja=N}else ja=G;Vj(j,a,a,z,ja,0);N=k+8|0;f[N>>2]=0;f[N+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;h_(g,k);N=k+8|0;f[N>>2]=0;f[N+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=h;p[l>>3]=1.0;N=l+8|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;f[N+16>>2]=0;f[N+20>>2]=0;hR(k,l);do if(L&s)if(!(n2(f[j+16>>2]|0,f[j+48>>2]|0,a,f[h+16>>2]|0,f[h+48>>2]|0,a)|0))ka=139;else la=1;else{if(L&t)if(!(p2(f[j+16>>2]|0,f[j+48>>2]|0,a,f[h+16>>2]|0,f[h+48>>2]|0,a)|0)){ka=139;break}else{la=1;break}N=f[j+16>>2]|0;if(O&s)ma=r2(N,f[j+48>>2]|0,a,f[h+16>>2]|0,f[h+48>>2]|0,a)|0;else ma=t2(N,f[j+48>>2]|0,a,f[h+16>>2]|0,f[h+48>>2]|0,a)|0;if(ma)la=1;else ka=139}while(0);if((ka|0)==139){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;k_(h,k)|0;la=0}N=j+36|0;y=f[N>>2]|0;if(y|0?(I=y+12|0,y=f[I>>2]|0,f[I>>2]=y+-1,(y|0)==1):0)_S(j);f[N>>2]=0;N=j+16|0;y=j+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[y>>2]|0)>0){N=f[j+40>>2]|0;I=0;do{f[N+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[y>>2]|0))}y=f[j+44>>2]|0;if((y|0)!=(j+48|0))g0(y);y=f[i>>2]|0;if((y|0)!=(G|0)){if(y|0)ZDc(y);f[i>>2]=G;f[x>>2]=1032}Z=la}while(0);O=h+36|0;L=f[O>>2]|0;if(L|0?(y=L+12|0,L=f[y>>2]|0,f[y>>2]=L+-1,(L|0)==1):0)_S(h);f[O>>2]=0;O=h+16|0;L=h+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[L>>2]|0)>0){O=f[h+40>>2]|0;y=0;do{f[O+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[L>>2]|0))}L=f[h+44>>2]|0;if((L|0)!=(h+48|0))g0(L);S=+(Z&1)}while(0);Z=g+36|0;h=f[Z>>2]|0;if(h|0?(la=h+12|0,h=f[la>>2]|0,f[la>>2]=h+-1,(h|0)==1):0)_S(g);f[Z>>2]=0;Z=g+16|0;h=g+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[h>>2]|0)>0){Z=f[g+40>>2]|0;la=0;do{f[Z+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return +S}g0(h);u=e;return +S}function gQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=u;u=u+1392|0;i=h+1336|0;j=h+296|0;k=h+240|0;l=h+184|0;m=h+128|0;n=h+72|0;o=h;p=h+56|0;do if((d$(a)|0)==65536){q=f[a+4>>2]|0;f[i>>2]=f[q>>2];r=i+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=i+8|0;f[t>>2]=f[q+8>>2];v=i+12|0;f[v>>2]=f[q+12>>2];f[i+16>>2]=f[q+16>>2];f[i+20>>2]=f[q+20>>2];f[i+24>>2]=f[q+24>>2];f[i+28>>2]=f[q+28>>2];f[i+32>>2]=f[q+32>>2];w=f[q+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=t;x=i+48|0;y=i+44|0;f[y>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(w|0){x=w+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;x=f[y>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];z=v;A=i;B=t;break}else{f[r>>2]=0;ZS(i,q);z=v;A=i;B=t;break}}else{a$(i,a,-1);z=i+12|0;A=i;B=i+8|0}while(0);a=f[B>>2]|0;B=f[z>>2]|0;z=f[A>>2]&4095;if($$(d)|0)C=1;else C=$$(e)|0;A=(z|0)==5;if((z+-5|0)>>>0>=2){f[j>>2]=0;f[j+4>>2]=0;D=tT(j,32)|0;t=214868;E=D+32|0;do{b[D>>0]=b[t>>0]|0;D=D+1|0;t=t+1|0}while((D|0)<(E|0));z5(-215,j,215256,214744,1462)}if(!(g&2)){t=(a|0)<(B|0);v=t?B:a;q=t?a:B;F=C;G=q;H=v;I=t;J=g&4|0?v:q}else{u$(d);u$(e);q=(a|0)<(B|0);v=q?a:B;F=0;G=v;H=q?B:a;I=q;J=v}v=i+4|0;q=f[v>>2]|0;if((q|0)>0)K=f[(f[i+44>>2]|0)+(q+-1<<2)>>2]|0;else K=0;q=(Y(K,H)|0)+15&-16;a=Y(K,G)|0;K=a+15&-16;B=Y(q,J)|0;g=a+32+(Y(K,G)|0)+B|0;t=j+8|0;f[j>>2]=t;C=j+4|0;f[C>>2]=g;if(g>>>0>1032){r=XDc(g)|0;f[j>>2]=r;L=r}else L=t;r=L+15&-16;Vj(k,G,H,z,r,q);L=r+B|0;Vj(l,G,1,z,L,0);Vj(m,J,H,z,r,q);f[n>>2]=1124007936;q=n+4|0;r=n+8|0;B=n+40|0;D=q;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[B>>2]=r;D=n+48|0;E=n+44|0;f[E>>2]=D;f[D>>2]=0;f[n+52>>2]=0;if(F){Vj(o,G,G,z,L+a+15&-16,K);K=o+36|0;a=f[K>>2]|0;if(a|0){L=a+12|0;f[L>>2]=(f[L>>2]|0)+1}L=n+36|0;a=f[L>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)_S(n);f[L>>2]=0;a=n+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){z=f[B>>2]|0;g=0;do{f[z+(g<<2)>>2]=0;g=g+1|0;M=f[q>>2]|0}while((g|0)<(M|0));f[n>>2]=f[o>>2];if((M|0)<3)N=30;else N=32}else{f[n>>2]=f[o>>2];N=30}if((N|0)==30){M=f[o+4>>2]|0;if((M|0)<3){f[q>>2]=M;f[r>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];r=f[o+44>>2]|0;M=f[E>>2]|0;f[M>>2]=f[r>>2];f[M+4>>2]=f[r+4>>2]}else N=32}if((N|0)==32)ZS(n,o);N=o+16|0;f[a>>2]=f[N>>2];f[n+20>>2]=f[o+20>>2];f[n+24>>2]=f[o+24>>2];f[n+28>>2]=f[o+28>>2];f[n+32>>2]=f[o+32>>2];a=f[K>>2]|0;f[L>>2]=a;if(a|0?(L=a+12|0,a=f[L>>2]|0,f[L>>2]=a+-1,(a|0)==1):0)_S(o);f[K>>2]=0;K=o+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[K>>2]|0)>0){N=f[o+40>>2]|0;a=0;do{f[N+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[K>>2]|0))}K=f[o+44>>2]|0;if((K|0)!=(o+48|0))g0(K)}if((J|0)>(G|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;k_(m,o)|0}if(I){K=o+8|0;f[K>>2]=0;f[K+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;h_(i,o)}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=i;K=p+8|0;f[K>>2]=0;f[K+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=k;jR(o,p)}p=k+16|0;K=f[p>>2]|0;if(A){A=f[n+16>>2]|0;a=F?J:0;cQ(K,f[m+48>>2]|0,f[l+16>>2]|0,A,f[D>>2]|0,H,G,(A|0)==0?0:(a|0)<0?G:a,1.1754943508222875e-38,2.384185791015625e-07)}else{a=f[n+16>>2]|0;A=F?J:0;dQ(K,f[m+48>>2]|0,f[l+16>>2]|0,a,f[D>>2]|0,H,G,(a|0)==0?0:(A|0)<0?G:A,2.2250738585072014e-308,2.220446049250313e-15)}h_(l,c);do if(F){c=$$(d)|0;if(I){if(c){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=n;jR(o,d)}if(!($$(e)|0))break;h_(m,e);break}else{if(c){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=m;jR(o,d)}if(!($$(e)|0))break;h_(n,e);break}}while(0);e=n+36|0;d=f[e>>2]|0;if(d|0?(o=d+12|0,d=f[o>>2]|0,f[o>>2]=d+-1,(d|0)==1):0)_S(n);f[e>>2]=0;e=n+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){e=f[B>>2]|0;B=0;do{f[e+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[q>>2]|0))}q=f[E>>2]|0;if((q|0)!=(D|0))g0(q);q=m+36|0;D=f[q>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)_S(m);f[q>>2]=0;q=m+16|0;D=m+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[D>>2]|0)>0){q=f[m+40>>2]|0;E=0;do{f[q+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[D>>2]|0))}D=f[m+44>>2]|0;if((D|0)!=(m+48|0))g0(D);D=l+36|0;m=f[D>>2]|0;if(m|0?(E=m+12|0,m=f[E>>2]|0,f[E>>2]=m+-1,(m|0)==1):0)_S(l);f[D>>2]=0;D=l+16|0;m=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[m>>2]|0)>0){D=f[l+40>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))g0(m);m=k+36|0;l=f[m>>2]|0;do if(l|0){E=l+12|0;D=f[E>>2]|0;f[E>>2]=D+-1;if((D|0)!=1)break;_S(k)}while(0);f[m>>2]=0;m=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[k+40>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))g0(m);m=f[j>>2]|0;if((m|0)!=(t|0)){if(m|0)ZDc(m);f[j>>2]=t;f[C>>2]=1032}C=i+36|0;t=f[C>>2]|0;do if(t|0){j=t+12|0;m=f[j>>2]|0;f[j>>2]=m+-1;if((m|0)!=1)break;_S(i)}while(0);f[C>>2]=0;C=i+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){C=f[i+40>>2]|0;t=0;do{f[C+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[i+44>>2]|0;if((v|0)==(i+48|0)){u=h;return}g0(v);u=h;return}function hQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=u;u=u+1328|0;i=h+1272|0;j=h+1216|0;k=h+1160|0;l=h+1104|0;m=h+64|0;n=h+8|0;o=h;do if((d$(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;ZS(i,p);break}}else a$(i,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];p=j+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;v=j+44|0;f[v>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;ZS(j,a);break}}else a$(j,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[k>>2]=f[c>>2];a=k+4|0;p=c+4|0;f[a>>2]=f[p>>2];q=k+8|0;f[q>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];r=f[c+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=q;q=k+48|0;v=k+44|0;f[v>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[c+44>>2]|0;q=f[v>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[a>>2]=0;ZS(k,c);break}}else a$(k,d,-1);while(0);do if((d$(e)|0)==65536){d=f[e+4>>2]|0;f[l>>2]=f[d>>2];c=l+4|0;a=d+4|0;f[c>>2]=f[a>>2];p=l+8|0;f[p>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];q=f[d+36>>2]|0;f[l+36>>2]=q;f[l+40>>2]=p;p=l+48|0;v=l+44|0;f[v>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+44>>2]|0;p=f[v>>2]|0;f[p>>2]=f[a>>2];f[p+4>>2]=f[a+4>>2];break}else{f[c>>2]=0;ZS(l,d);break}}else a$(l,e,-1);while(0);e=f[i>>2]|0;d=e&4095;c=i+4|0;a=f[c>>2]|0;if((a|0)>0)w=f[(f[i+44>>2]|0)+(a+-1<<2)>>2]|0;else w=0;a=f[j+8>>2]|0;p=f[k+12>>2]|0;v=l+16|0;q=f[v>>2]|0;r=q|0?f[l+12>>2]|0:a;s=(p|0)<(a|0)?p:a;if((f[i+8>>2]|0)==1)x=w;else x=((f[i+12>>2]|0)==1?0:w)+(f[i+48>>2]|0)|0;w=(r<<3)+16|0;t=m+8|0;f[m>>2]=t;y=m+4|0;f[y>>2]=w;if(w>>>0>1032){z=XDc(w)|0;f[m>>2]=z}if((d|0)!=(f[j>>2]&4095|0)){f[n>>2]=0;A=n+4|0;f[A>>2]=0;B=tT(n,76)|0;C=B;D=214991;E=C+76|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1550)}if((d|0)!=(f[k>>2]&4095|0)){f[n>>2]=0;A=n+4|0;f[A>>2]=0;B=tT(n,76)|0;C=B;D=214991;E=C+76|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1550)}z=j+16|0;if(!(f[z>>2]|0)){f[n>>2]=0;A=n+4|0;f[A>>2]=0;B=tT(n,76)|0;C=B;D=214991;E=C+76|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1550)}w=k+16|0;if(!(f[w>>2]|0)){f[n>>2]=0;A=n+4|0;f[A>>2]=0;B=tT(n,76)|0;C=B;D=214991;E=C+76|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1550)}F=i+16|0;if(!(f[F>>2]|0)){f[n>>2]=0;A=n+4|0;f[A>>2]=0;B=tT(n,76)|0;C=B;D=214991;E=C+76|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1550)}B=f[j+12>>2]|0;if((B|0)<(s|0)){f[n>>2]=0;G=n+4|0;f[G>>2]=0;H=tT(n,122)|0;C=H;D=215078;E=C+122|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1552)}A=f[k+8>>2]|0;if((A|0)<(s|0)){f[n>>2]=0;G=n+4|0;f[G>>2]=0;H=tT(n,122)|0;C=H;D=215078;E=C+122|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1552)}I=i+40|0;J=f[I>>2]|0;K=f[J+4>>2]|0;L=f[J>>2]|0;if((!((K|0)==(s|0)&(L|0)==1)?!((K|0)==1&(L|0)==(s|0)):0)?!((K|0)==(A|0)&(L|0)==(B|0)):0){f[n>>2]=0;G=n+4|0;f[G>>2]=0;H=tT(n,122)|0;C=H;D=215078;E=C+122|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1552)}if(q|0){if((f[l>>2]&4095|0)!=(d|0)){f[n>>2]=0;M=n+4|0;f[M>>2]=0;N=tT(n,54)|0;C=N;D=215201;E=C+54|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1553)}if((f[l+8>>2]|0)!=(a|0)){f[n>>2]=0;M=n+4|0;f[M>>2]=0;N=tT(n,54)|0;C=N;D=215201;E=C+54|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,n,215068,214744,1553)}}Y$(g,p,r,d,-1,0,0);do if((d$(g)|0)==65536){d=f[g+4>>2]|0;f[n>>2]=f[d>>2];D=n+4|0;C=d+4|0;f[D>>2]=f[C>>2];E=n+8|0;f[E>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];N=f[d+36>>2]|0;f[n+36>>2]=N;f[n+40>>2]=E;E=n+48|0;M=n+44|0;f[M>>2]=E;f[E>>2]=0;f[n+52>>2]=0;if(N|0){E=N+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[C>>2]|0)<3){C=f[d+44>>2]|0;E=f[M>>2]|0;f[E>>2]=f[C>>2];f[E+4>>2]=f[C+4>>2];break}else{f[D>>2]=0;ZS(n,d);break}}else a$(n,g,-1);while(0);switch(e&4095){case 5:{lQ(a,p,f[F>>2]|0,x,f[z>>2]|0,f[j+48>>2]|0,0,f[w>>2]|0,f[k+48>>2]|0,f[v>>2]|0,f[l+48>>2]|0,r,f[n+16>>2]|0,f[n+48>>2]|0,f[m>>2]|0);break}case 6:{mQ(a,p,f[F>>2]|0,x,f[z>>2]|0,f[j+48>>2]|0,0,f[w>>2]|0,f[k+48>>2]|0,f[v>>2]|0,f[l+48>>2]|0,r,f[n+16>>2]|0,f[n+48>>2]|0,f[m>>2]|0);break}default:{f[o>>2]=0;f[o+4>>2]=0;z5(-210,o,215068,214744,1566)}}o=n+36|0;r=f[o>>2]|0;if(r|0?(x=r+12|0,r=f[x>>2]|0,f[x>>2]=r+-1,(r|0)==1):0)_S(n);f[o>>2]=0;o=n+16|0;r=n+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[r>>2]|0)>0){o=f[n+40>>2]|0;x=0;do{f[o+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[r>>2]|0))}r=f[n+44>>2]|0;if((r|0)!=(n+48|0))g0(r);r=f[m>>2]|0;if((r|0)!=(t|0)){if(r|0)ZDc(r);f[m>>2]=t;f[y>>2]=1032}y=l+36|0;t=f[y>>2]|0;do if(t|0){m=t+12|0;r=f[m>>2]|0;f[m>>2]=r+-1;if((r|0)!=1)break;_S(l)}while(0);f[y>>2]=0;y=l+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[y>>2]|0)>0){v=f[l+40>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[y>>2]|0))}y=f[l+44>>2]|0;if((y|0)!=(l+48|0))g0(y);y=k+36|0;l=f[y>>2]|0;do if(l|0){t=l+12|0;v=f[t>>2]|0;f[t>>2]=v+-1;if((v|0)!=1)break;_S(k)}while(0);f[y>>2]=0;y=k+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[y>>2]|0)>0){w=f[k+40>>2]|0;l=0;do{f[w+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[y>>2]|0))}y=f[k+44>>2]|0;if((y|0)!=(k+48|0))g0(y);y=j+36|0;k=f[y>>2]|0;do if(k|0){l=k+12|0;w=f[l>>2]|0;f[l>>2]=w+-1;if((w|0)!=1)break;_S(j)}while(0);f[y>>2]=0;y=j+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){z=f[j+40>>2]|0;k=0;do{f[z+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[y>>2]|0))}y=f[j+44>>2]|0;if((y|0)!=(j+48|0))g0(y);y=i+36|0;j=f[y>>2]|0;do if(j|0){k=j+12|0;z=f[k>>2]|0;f[k>>2]=z+-1;if((z|0)!=1)break;_S(i)}while(0);f[y>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[c>>2]|0)>0){F=f[I>>2]|0;I=0;do{f[F+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[c>>2]|0))}c=f[i+44>>2]|0;if((c|0)==(i+48|0)){u=h;return}g0(c);u=h;return}function iQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+1280|0;g=e+1224|0;h=e+1168|0;i=e+128|0;j=e+72|0;k=e+16|0;l=e;do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[g>>2]=f[m>>2];n=g+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=g+8|0;f[p>>2]=f[m+8>>2];q=g+12|0;f[q>>2]=f[m+12>>2];f[g+16>>2]=f[m+16>>2];f[g+20>>2]=f[m+20>>2];f[g+24>>2]=f[m+24>>2];f[g+28>>2]=f[m+28>>2];f[g+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[g+36>>2]=r;f[g+40>>2]=p;s=g+48|0;t=g+44|0;f[t>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[o>>2];f[s+4>>2]=f[o+4>>2];v=p;w=q;x=g;break}else{f[n>>2]=0;ZS(g,m);v=p;w=q;x=g;break}}else{a$(g,a,-1);v=g+8|0;w=g+12|0;x=g}while(0);a=f[x>>2]&4095;x=f[v>>2]|0;if((x|0)!=(f[w>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;y=tT(h,20)|0;z=214964;A=y+20|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,h,214985,214744,1384)}w=(a|0)==5;if((a+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;y=tT(h,32)|0;z=214868;A=y+32|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,h,214985,214744,1385)}f[h>>2]=1124007936;z=h+4|0;v=h+8|0;q=h+40|0;y=z;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[q>>2]=v;y=h+48|0;A=h+44|0;f[A>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if($$(d)|0){Y$(d,x,x,a,-1,0,0);do if((d$(d)|0)==65536){p=f[d+4>>2]|0;f[i>>2]=f[p>>2];m=i+4|0;n=p+4|0;f[m>>2]=f[n>>2];o=i+8|0;f[o>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];s=i+36|0;t=f[p+36>>2]|0;f[s>>2]=t;f[i+40>>2]=o;o=i+48|0;r=i+44|0;f[r>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(t|0){o=t+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[p+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];B=s;break}else{f[m>>2]=0;ZS(i,p);B=s;break}}else{a$(i,d,-1);B=i+36|0}while(0);d=f[B>>2]|0;if(d|0){s=d+12|0;f[s>>2]=(f[s>>2]|0)+1}s=h+36|0;d=f[s>>2]|0;if(d|0?(p=d+12|0,d=f[p>>2]|0,f[p>>2]=d+-1,(d|0)==1):0)_S(h);f[s>>2]=0;d=h+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[z>>2]|0)>0){p=f[q>>2]|0;m=0;do{f[p+(m<<2)>>2]=0;m=m+1|0;C=f[z>>2]|0}while((m|0)<(C|0));f[h>>2]=f[i>>2];if((C|0)<3)D=30;else D=32}else{f[h>>2]=f[i>>2];D=30}if((D|0)==30){C=f[i+4>>2]|0;if((C|0)<3){f[z>>2]=C;f[v>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];v=f[i+44>>2]|0;C=f[A>>2]|0;f[C>>2]=f[v>>2];f[C+4>>2]=f[v+4>>2]}else D=32}if((D|0)==32)ZS(h,i);D=i+16|0;f[d>>2]=f[D>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];d=f[B>>2]|0;f[s>>2]=d;if(d|0?(s=d+12|0,d=f[s>>2]|0,f[s>>2]=d+-1,(d|0)==1):0)_S(i);f[B>>2]=0;B=i+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[B>>2]|0)>0){D=f[i+40>>2]|0;d=0;do{f[D+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[B>>2]|0))}B=f[i+44>>2]|0;if((B|0)!=(i+48|0))g0(B)}B=g+4|0;d=f[B>>2]|0;if((d|0)>0)E=f[(f[g+44>>2]|0)+(d+-1<<2)>>2]|0;else E=0;d=Y(E,x)|0;D=d+15&-16;s=Y(D,x)|0;v=(Y(x*5|0,E)|0)+32+s|0;E=i+8|0;f[i>>2]=E;C=i+4|0;f[C>>2]=v;if(v>>>0>1032){m=XDc(v)|0;f[i>>2]=m;F=m}else F=E;m=F+15&-16;Vj(j,x,x,a,m,D);Vj(k,x,1,a,m+s|0,0);a=m+(s+d)|0;d=l+8|0;f[d>>2]=0;f[d+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;h_(g,l);l=j+16|0;d=f[l>>2]|0;if(w)G=jQ(d,f[j+48>>2]|0,f[k+16>>2]|0,f[h+16>>2]|0,f[y>>2]|0,x,a)|0;else G=kQ(d,f[j+48>>2]|0,f[k+16>>2]|0,f[h+16>>2]|0,f[y>>2]|0,x,a)|0;h_(k,c);c=k+36|0;a=f[c>>2]|0;if(a|0?(x=a+12|0,a=f[x>>2]|0,f[x>>2]=a+-1,(a|0)==1):0)_S(k);f[c>>2]=0;c=k+16|0;a=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[k+40>>2]|0;x=0;do{f[c+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}a=f[k+44>>2]|0;if((a|0)!=(k+48|0))g0(a);a=j+36|0;k=f[a>>2]|0;if(k|0?(x=k+12|0,k=f[x>>2]|0,f[x>>2]=k+-1,(k|0)==1):0)_S(j);f[a>>2]=0;a=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[a>>2]|0)>0){l=f[j+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)!=(j+48|0))g0(a);a=f[i>>2]|0;if((a|0)!=(E|0)){if(a|0)ZDc(a);f[i>>2]=E;f[C>>2]=1032}C=h+36|0;E=f[C>>2]|0;if(E|0?(i=E+12|0,E=f[i>>2]|0,f[i>>2]=E+-1,(E|0)==1):0)_S(h);f[C>>2]=0;C=h+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[z>>2]|0)>0){C=f[q>>2]|0;q=0;do{f[C+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[z>>2]|0))}z=f[A>>2]|0;if((z|0)!=(y|0))g0(z);z=g+36|0;y=f[z>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)_S(g);f[z>>2]=0;z=g+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[B>>2]|0)>0){z=f[g+40>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[B>>2]|0))}B=f[g+44>>2]|0;if((B|0)==(g+48|0)){u=e;return G|0}g0(B);u=e;return G|0}function jQ(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=b>>>2;b=(d|0)!=0;if(b){j=e>>>2;if((g|0)>0){k=g<<2;l=0;do{m=Y(j,l)|0;XIc(d+(m<<2)|0,0,k|0)|0;n[d+(m+l<<2)>>2]=1.0;l=l+1|0}while((l|0)!=(g|0));o=j}else o=j}else o=e;e=Y(g*30|0,g)|0;j=h+3&-4;h=j+(g<<2)|0;if((g|0)<=0)return 1;l=i+1|0;k=g+-1|0;m=0;do{p=a+((Y(m,l)|0)<<2)|0;f[c+(m<<2)>>2]=f[p>>2];if((m|0)<(k|0)){p=m+1|0;q=Y(m,i)|0;r=m+2|0;if((r|0)<(g|0)){s=p;t=+L(+(+n[a+(q+p<<2)>>2]));u=r;while(1){v=+L(+(+n[a+(u+q<<2)>>2]));r=t<v;w=r?u:s;u=u+1|0;if((u|0)==(g|0)){x=w;break}else{s=w;t=r?v:t}}}else x=p;f[j+(m<<2)>>2]=x}if((m|0)>0){if((m|0)==1)y=0;else{s=0;t=+L(+(+n[a+(m<<2)>>2]));u=1;while(1){q=a+((Y(u,i)|0)+m<<2)|0;v=+L(+(+n[q>>2]));q=t<v;r=q?u:s;u=u+1|0;if((u|0)>=(m|0)){y=r;break}else{s=r;t=q?v:t}}}f[h+(m<<2)>>2]=y}m=m+1|0}while((m|0)!=(g|0));m=(g|0)>1;y=g+-1|0;if(m&(e|0)>0){x=(y|0)>1;k=(g|0)<1|b^1;l=0;do{s=f[j>>2]|0;t=+L(+(+n[a+(s<<2)>>2]));if(x){u=0;p=1;v=t;do{q=Y(p,i)|0;z=+L(+(+n[a+((f[j+(p<<2)>>2]|0)+q<<2)>>2]));q=v<z;v=q?z:v;u=q?p:u;p=p+1|0}while((p|0)!=(y|0));A=f[j+(u<<2)>>2]|0;B=u;C=1;D=v}else{A=s;B=0;C=1;D=t}while(1){p=f[h+(C<<2)>>2]|0;q=a+((Y(p,i)|0)+C<<2)|0;z=+L(+(+n[q>>2]));q=D<z;A=q?C:A;B=q?p:B;C=C+1|0;if((C|0)==(g|0))break;else D=q?z:D}s=Y(B,i)|0;u=a+(s+A<<2)|0;t=+n[u>>2];v=+L(+t);if(v<=1.1920928955078125e-07)break;q=c+(A<<2)|0;p=c+(B<<2)|0;z=(+n[q>>2]-+n[p>>2])*.5;E=+L(+z);if(!(v>E))if(z!=z|0.0!=0.0|z==0.0)F=0.0;else{G=v/E;H=E;I=G*G;J=38}else{G=E/v;H=v;I=G*G;J=38}if((J|0)==38){J=0;F=H*+M(+(I+1.0))}G=E+F;E=+L(+G);if(!(v>E))if(G!=G|0.0!=0.0|G==0.0)K=0.0;else{N=v/E;O=E;P=N*N;J=43}else{N=E/v;O=v;P=N*N;J=43}if((J|0)==43){J=0;K=O*+M(+(P+1.0))}N=G/K;v=t/K;E=t*(t/G);r=z<0.0;z=r?-E:E;E=r?-v:v;n[u>>2]=0.0;n[p>>2]=+n[p>>2]-z;n[q>>2]=z+ +n[q>>2];q=(B|0)>0;if(q){p=0;do{u=Y(p,i)|0;r=a+(u+B<<2)|0;z=+n[r>>2];w=a+(u+A<<2)|0;v=+n[w>>2];n[r>>2]=N*z-E*v;n[w>>2]=E*z+N*v;p=p+1|0}while((p|0)!=(B|0))}p=B+1|0;if((p|0)<(A|0)){w=p;do{r=a+(w+s<<2)|0;v=+n[r>>2];u=a+((Y(w,i)|0)+A<<2)|0;z=+n[u>>2];n[r>>2]=N*v-E*z;n[u>>2]=E*v+N*z;w=w+1|0}while((w|0)!=(A|0))}w=A+1|0;if((w|0)<(g|0)){u=Y(A,i)|0;r=w;do{Q=a+(r+s<<2)|0;z=+n[Q>>2];R=a+(r+u<<2)|0;v=+n[R>>2];n[Q>>2]=N*z-E*v;n[R>>2]=E*z+N*v;r=r+1|0}while((r|0)!=(g|0))}if(!k){r=Y(B,o)|0;u=Y(A,o)|0;R=0;do{Q=d+(R+r<<2)|0;v=+n[Q>>2];S=d+(R+u<<2)|0;z=+n[S>>2];n[Q>>2]=N*v-E*z;n[S>>2]=E*v+N*z;R=R+1|0}while((R|0)!=(g|0))}if((B|0)<(y|0)){R=B+2|0;if((R|0)<(g|0)){u=p;N=+L(+(+n[a+(s+p<<2)>>2]));r=R;while(1){E=+L(+(+n[a+(r+s<<2)>>2]));R=N<E;S=R?r:u;r=r+1|0;if((r|0)==(g|0)){T=S;break}else{u=S;N=R?E:N}}}else T=p;f[j+(B<<2)>>2]=T}if(q){if((B|0)==1)U=0;else{N=+L(+(+n[a+(B<<2)>>2]));u=1;r=0;while(1){s=a+((Y(u,i)|0)+B<<2)|0;E=+L(+(+n[s>>2]));s=N<E;R=s?u:r;u=u+1|0;if((u|0)>=(B|0)){U=R;break}else{N=s?E:N;r=R}}}f[h+(B<<2)>>2]=U}if((A|0)<(y|0)){r=Y(A,i)|0;u=A+2|0;if((u|0)<(g|0)){q=w;N=+L(+(+n[a+(r+w<<2)>>2]));p=u;while(1){E=+L(+(+n[a+(p+r<<2)>>2]));u=N<E;R=u?p:q;p=p+1|0;if((p|0)==(g|0)){V=R;break}else{q=R;N=u?E:N}}}else V=w;f[j+(A<<2)>>2]=V}if((A|0)>0){if((A|0)==1)W=0;else{N=+L(+(+n[a+(A<<2)>>2]));q=1;p=0;while(1){r=a+((Y(q,i)|0)+A<<2)|0;E=+L(+(+n[r>>2]));r=N<E;u=r?q:p;q=q+1|0;if((q|0)>=(A|0)){W=u;break}else{N=r?E:N;p=u}}}f[h+(A<<2)>>2]=W}l=l+1|0}while((l|0)<(e|0));if(!m)return 1}else if(!m)return 1;if(b)X=0;else{b=0;do{m=b;b=b+1|0;if((b|0)<(g|0)){e=b;l=m;while(1){W=+n[c+(l<<2)>>2]<+n[c+(e<<2)>>2]?e:l;e=e+1|0;if((e|0)==(g|0)){Z=W;break}else l=W}}else Z=m;if((m|0)!=(Z|0)){l=c+(Z<<2)|0;e=c+(m<<2)|0;W=f[l>>2]|0;f[l>>2]=f[e>>2];f[e>>2]=W}}while((b|0)!=(y|0));return 1}do{b=X;X=X+1|0;if((X|0)<(g|0)){Z=X;W=b;while(1){e=+n[c+(W<<2)>>2]<+n[c+(Z<<2)>>2]?Z:W;Z=Z+1|0;if((Z|0)==(g|0)){_=e;break}else W=e}}else _=b;if((b|0)!=(_|0)){W=c+(_<<2)|0;Z=c+(b<<2)|0;m=f[W>>2]|0;f[W>>2]=f[Z>>2];f[Z>>2]=m;m=Y(_,o)|0;Z=Y(b,o)|0;W=0;do{e=d+(W+m<<2)|0;l=d+(W+Z<<2)|0;A=f[e>>2]|0;f[e>>2]=f[l>>2];f[l>>2]=A;W=W+1|0}while((W|0)!=(g|0))}}while((X|0)!=(y|0));return 1}function kQ(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=b>>>3;b=(d|0)!=0;if(b){j=e>>>3;if((g|0)>0){k=g<<3;l=0;do{m=Y(j,l)|0;XIc(d+(m<<3)|0,0,k|0)|0;p[d+(m+l<<3)>>3]=1.0;l=l+1|0}while((l|0)!=(g|0));n=j}else n=j}else n=e;e=Y(g*30|0,g)|0;j=h+3&-4;h=j+(g<<2)|0;if((g|0)<=0)return 1;l=i+1|0;k=g+-1|0;m=0;do{o=a+((Y(m,l)|0)<<3)|0;p[c+(m<<3)>>3]=+p[o>>3];if((m|0)<(k|0)){o=m+1|0;q=Y(m,i)|0;r=m+2|0;if((r|0)<(g|0)){s=o;t=+L(+(+p[a+(q+o<<3)>>3]));u=r;while(1){v=+L(+(+p[a+(u+q<<3)>>3]));r=t<v;w=r?u:s;u=u+1|0;if((u|0)==(g|0)){x=w;break}else{s=w;t=r?v:t}}}else x=o;f[j+(m<<2)>>2]=x}if((m|0)>0){if((m|0)==1)y=0;else{s=0;t=+L(+(+p[a+(m<<3)>>3]));u=1;while(1){q=a+((Y(u,i)|0)+m<<3)|0;v=+L(+(+p[q>>3]));q=t<v;r=q?u:s;u=u+1|0;if((u|0)>=(m|0)){y=r;break}else{s=r;t=q?v:t}}}f[h+(m<<2)>>2]=y}m=m+1|0}while((m|0)!=(g|0));m=(g|0)>1;y=g+-1|0;if(m&(e|0)>0){x=(y|0)>1;k=(g|0)<1|b^1;l=0;do{s=f[j>>2]|0;t=+L(+(+p[a+(s<<3)>>3]));if(x){u=0;o=1;v=t;do{q=Y(o,i)|0;z=+L(+(+p[a+((f[j+(o<<2)>>2]|0)+q<<3)>>3]));q=v<z;v=q?z:v;u=q?o:u;o=o+1|0}while((o|0)!=(y|0));A=f[j+(u<<2)>>2]|0;B=u;C=1;D=v}else{A=s;B=0;C=1;D=t}while(1){o=f[h+(C<<2)>>2]|0;q=a+((Y(o,i)|0)+C<<3)|0;z=+L(+(+p[q>>3]));q=D<z;A=q?C:A;B=q?o:B;C=C+1|0;if((C|0)==(g|0))break;else D=q?z:D}s=Y(B,i)|0;u=a+(s+A<<3)|0;t=+p[u>>3];v=+L(+t);if(v<=2.220446049250313e-16)break;q=c+(A<<3)|0;o=c+(B<<3)|0;z=(+p[q>>3]-+p[o>>3])*.5;E=+L(+z);if(!(v>E))if(z!=z|0.0!=0.0|z==0.0)F=0.0;else{G=v/E;H=E;I=G*G;J=38}else{G=E/v;H=v;I=G*G;J=38}if((J|0)==38){J=0;F=H*+M(+(I+1.0))}G=E+F;E=+L(+G);if(!(v>E))if(G!=G|0.0!=0.0|G==0.0)K=0.0;else{N=v/E;O=E;P=N*N;J=43}else{N=E/v;O=v;P=N*N;J=43}if((J|0)==43){J=0;K=O*+M(+(P+1.0))}N=G/K;v=t/K;E=t*(t/G);r=z<0.0;z=r?-E:E;E=r?-v:v;p[u>>3]=0.0;p[o>>3]=+p[o>>3]-z;p[q>>3]=z+ +p[q>>3];q=(B|0)>0;if(q){o=0;do{u=Y(o,i)|0;r=a+(u+B<<3)|0;z=+p[r>>3];w=a+(u+A<<3)|0;v=+p[w>>3];p[r>>3]=N*z-E*v;p[w>>3]=E*z+N*v;o=o+1|0}while((o|0)!=(B|0))}o=B+1|0;if((o|0)<(A|0)){w=o;do{r=a+(w+s<<3)|0;v=+p[r>>3];u=a+((Y(w,i)|0)+A<<3)|0;z=+p[u>>3];p[r>>3]=N*v-E*z;p[u>>3]=E*v+N*z;w=w+1|0}while((w|0)!=(A|0))}w=A+1|0;if((w|0)<(g|0)){u=Y(A,i)|0;r=w;do{Q=a+(r+s<<3)|0;z=+p[Q>>3];R=a+(r+u<<3)|0;v=+p[R>>3];p[Q>>3]=N*z-E*v;p[R>>3]=E*z+N*v;r=r+1|0}while((r|0)!=(g|0))}if(!k){r=Y(B,n)|0;u=Y(A,n)|0;R=0;do{Q=d+(R+r<<3)|0;v=+p[Q>>3];S=d+(R+u<<3)|0;z=+p[S>>3];p[Q>>3]=N*v-E*z;p[S>>3]=E*v+N*z;R=R+1|0}while((R|0)!=(g|0))}if((B|0)<(y|0)){R=B+2|0;if((R|0)<(g|0)){u=o;N=+L(+(+p[a+(s+o<<3)>>3]));r=R;while(1){E=+L(+(+p[a+(r+s<<3)>>3]));R=N<E;S=R?r:u;r=r+1|0;if((r|0)==(g|0)){T=S;break}else{u=S;N=R?E:N}}}else T=o;f[j+(B<<2)>>2]=T}if(q){if((B|0)==1)U=0;else{N=+L(+(+p[a+(B<<3)>>3]));u=1;r=0;while(1){s=a+((Y(u,i)|0)+B<<3)|0;E=+L(+(+p[s>>3]));s=N<E;R=s?u:r;u=u+1|0;if((u|0)>=(B|0)){U=R;break}else{N=s?E:N;r=R}}}f[h+(B<<2)>>2]=U}if((A|0)<(y|0)){r=Y(A,i)|0;u=A+2|0;if((u|0)<(g|0)){q=w;N=+L(+(+p[a+(r+w<<3)>>3]));o=u;while(1){E=+L(+(+p[a+(o+r<<3)>>3]));u=N<E;R=u?o:q;o=o+1|0;if((o|0)==(g|0)){V=R;break}else{q=R;N=u?E:N}}}else V=w;f[j+(A<<2)>>2]=V}if((A|0)>0){if((A|0)==1)W=0;else{N=+L(+(+p[a+(A<<3)>>3]));q=1;o=0;while(1){r=a+((Y(q,i)|0)+A<<3)|0;E=+L(+(+p[r>>3]));r=N<E;u=r?q:o;q=q+1|0;if((q|0)>=(A|0)){W=u;break}else{N=r?E:N;o=u}}}f[h+(A<<2)>>2]=W}l=l+1|0}while((l|0)<(e|0));if(!m)return 1}else if(!m)return 1;if(b)X=0;else{b=0;do{m=b;b=b+1|0;if((b|0)<(g|0)){e=b;l=m;while(1){W=+p[c+(l<<3)>>3]<+p[c+(e<<3)>>3]?e:l;e=e+1|0;if((e|0)==(g|0)){Z=W;break}else l=W}}else Z=m;if((m|0)!=(Z|0)){l=c+(Z<<3)|0;e=c+(m<<3)|0;K=+p[l>>3];p[l>>3]=+p[e>>3];p[e>>3]=K}}while((b|0)!=(y|0));return 1}do{b=X;X=X+1|0;if((X|0)<(g|0)){Z=X;e=b;while(1){l=+p[c+(e<<3)>>3]<+p[c+(Z<<3)>>3]?Z:e;Z=Z+1|0;if((Z|0)==(g|0)){_=l;break}else e=l}}else _=b;if((b|0)!=(_|0)){e=c+(_<<3)|0;Z=c+(b<<3)|0;K=+p[e>>3];p[e>>3]=+p[Z>>3];p[Z>>3]=K;Z=Y(_,n)|0;e=Y(b,n)|0;m=0;do{l=d+(m+Z<<3)|0;W=d+(m+e<<3)|0;K=+p[l>>3];p[l>>3]=+p[W>>3];p[W>>3]=K;m=m+1|0}while((m|0)!=(g|0))}}while((X|0)!=(y|0));return 1}function lQ(a,b,c,d,e,f,g,h,i,j,k,l,m,o,q){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;r=(d|0)==0?1:d>>>2;d=f>>>2;f=i>>>2;i=k>>>2;k=o>>>2;o=q+7&-8;q=o;s=o;o=g?d:1;t=g?1:d;d=(b|0)<(a|0)?b:a;g=(j|0)!=0;u=g?l:a;l=(b|0)>0;v=(u|0)>0;if(l&v){w=u<<2;x=0;do{XIc(m+((Y(x,k)|0)<<2)|0,0,w|0)|0;x=x+1|0}while((x|0)!=(b|0))}if((d|0)>0){y=0.0;z=0}else return;do{x=c+((Y(z,r)|0)<<2)|0;y=y+ +n[x>>2];z=z+1|0}while((z|0)<(d|0));A=y*4.440892098500626e-16;z=(u|0)==1;x=(a|0)>0;w=u+-4|0;B=(u|0)<4;C=u&-4;D=(C|0)<(u|0);E=u<<3;F=e;e=h;h=0;while(1){G=c+((Y(h,r)|0)<<2)|0;y=+n[G>>2];a:do if(!(+L(+y)<=A)){H=1.0/y;if(z){if(g)if(x){I=0.0;G=0;while(1){J=F+((Y(G,t)|0)<<2)|0;K=j+((Y(G,i)|0)<<2)|0;M=I+ +n[J>>2]*+n[K>>2];G=G+1|0;if((G|0)==(a|0)){N=M;break}else I=M}}else N=0.0;else N=+n[F>>2];I=H*N;if(l)O=0;else break;while(1){G=m+((Y(O,k)|0)<<2)|0;n[G>>2]=+n[G>>2]+I*+n[e+(O<<2)>>2];O=O+1|0;if((O|0)==(b|0))break a}}b:do if(g){if(v)XIc(q|0,0,E|0)|0;c:do if(x){if(B){if(v){P=j;Q=0}else break b;while(1){G=F+((Y(Q,t)|0)<<2)|0;I=+n[G>>2];G=0;do{K=s+(G<<3)|0;p[K>>3]=+p[K>>3]+I*+n[P+(G<<2)>>2];G=G+1|0}while((G|0)!=(u|0));Q=Q+1|0;if((Q|0)==(a|0))break c;else P=P+(i<<2)|0}}if(D){R=j;S=0}else{G=j;K=0;while(1){J=F+((Y(K,t)|0)<<2)|0;I=+n[J>>2];J=0;do{T=s+(J<<3)|0;U=J|1;V=s+(U<<3)|0;M=+p[V>>3]+I*+n[G+(U<<2)>>2];p[T>>3]=+p[T>>3]+I*+n[G+(J<<2)>>2];p[V>>3]=M;V=J|2;T=s+(V<<3)|0;U=J|3;W=s+(U<<3)|0;M=+p[W>>3]+I*+n[G+(U<<2)>>2];p[T>>3]=+p[T>>3]+I*+n[G+(V<<2)>>2];p[W>>3]=M;J=J+4|0}while((J|0)<=(w|0));K=K+1|0;if((K|0)==(a|0))break c;else G=G+(i<<2)|0}}while(1){G=F+((Y(S,t)|0)<<2)|0;I=+n[G>>2];G=0;do{K=s+(G<<3)|0;J=G|1;W=s+(J<<3)|0;M=+p[W>>3]+I*+n[R+(J<<2)>>2];p[K>>3]=+p[K>>3]+I*+n[R+(G<<2)>>2];p[W>>3]=M;W=G|2;K=s+(W<<3)|0;J=G|3;V=s+(J<<3)|0;M=+p[V>>3]+I*+n[R+(J<<2)>>2];p[K>>3]=+p[K>>3]+I*+n[R+(W<<2)>>2];p[V>>3]=M;G=G+4|0}while((G|0)<=(w|0));X=C;do{G=s+(X<<3)|0;p[G>>3]=+p[G>>3]+I*+n[R+(X<<2)>>2];X=X+1|0}while((X|0)!=(u|0));S=S+1|0;if((S|0)==(a|0))break;else R=R+(i<<2)|0}}while(0);if(v){G=0;do{V=s+(G<<3)|0;p[V>>3]=H*+p[V>>3];G=G+1|0}while((G|0)!=(u|0))}}else if(v){G=0;do{V=F+((Y(G,t)|0)<<2)|0;p[s+(G<<3)>>3]=H*+n[V>>2];G=G+1|0}while((G|0)!=(u|0))}while(0);if(l){if(B){if(v){Z=m;_=0}else break;while(1){H=+n[e+(_<<2)>>2];G=0;do{V=Z+(G<<2)|0;n[V>>2]=+n[V>>2]+H*+p[s+(G<<3)>>3];G=G+1|0}while((G|0)!=(u|0));_=_+1|0;if((_|0)==(b|0))break a;else Z=Z+(k<<2)|0}}if(D){$=m;aa=0}else{G=m;V=0;while(1){H=+n[e+(V<<2)>>2];W=0;do{K=G+(W<<2)|0;J=W|1;T=G+(J<<2)|0;I=+n[T>>2]+H*+p[s+(J<<3)>>3];n[K>>2]=+n[K>>2]+H*+p[s+(W<<3)>>3];n[T>>2]=I;T=W|2;K=G+(T<<2)|0;J=W|3;U=G+(J<<2)|0;I=+n[U>>2]+H*+p[s+(J<<3)>>3];n[K>>2]=+n[K>>2]+H*+p[s+(T<<3)>>3];n[U>>2]=I;W=W+4|0}while((W|0)<=(w|0));V=V+1|0;if((V|0)==(b|0))break a;else G=G+(k<<2)|0}}while(1){H=+n[e+(aa<<2)>>2];G=0;do{V=$+(G<<2)|0;W=G|1;U=$+(W<<2)|0;I=+n[U>>2]+H*+p[s+(W<<3)>>3];n[V>>2]=+n[V>>2]+H*+p[s+(G<<3)>>3];n[U>>2]=I;U=G|2;V=$+(U<<2)|0;W=G|3;T=$+(W<<2)|0;I=+n[T>>2]+H*+p[s+(W<<3)>>3];n[V>>2]=+n[V>>2]+H*+p[s+(U<<3)>>3];n[T>>2]=I;G=G+4|0}while((G|0)<=(w|0));ba=C;do{G=$+(ba<<2)|0;n[G>>2]=+n[G>>2]+H*+p[s+(ba<<3)>>3];ba=ba+1|0}while((ba|0)!=(u|0));aa=aa+1|0;if((aa|0)==(b|0))break;else $=$+(k<<2)|0}}}while(0);h=h+1|0;if((h|0)>=(d|0))break;else{F=F+(o<<2)|0;e=e+(f<<2)|0}}return}function mQ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0;q=(d|0)==0?1:d>>>3;d=f>>>3;f=i>>>3;i=k>>>3;k=n>>>3;n=o+7&-8;o=n;r=n;n=g?d:1;s=g?1:d;d=(b|0)<(a|0)?b:a;g=(j|0)!=0;t=g?l:a;l=(b|0)>0;u=(t|0)>0;if(l&u){v=t<<3;w=0;do{XIc(m+((Y(w,k)|0)<<3)|0,0,v|0)|0;w=w+1|0}while((w|0)!=(b|0))}if((d|0)>0){x=0.0;y=0}else return;do{w=c+((Y(y,q)|0)<<3)|0;x=x+ +p[w>>3];y=y+1|0}while((y|0)<(d|0));z=x*4.440892098500626e-16;y=(t|0)==1;w=(a|0)>0;v=t<<3;A=e;e=h;h=0;while(1){B=c+((Y(h,q)|0)<<3)|0;x=+p[B>>3];a:do if(!(+L(+x)<=z)){C=1.0/x;if(y){if(g)if(w){D=0.0;B=0;while(1){E=A+((Y(B,s)|0)<<3)|0;F=j+((Y(B,i)|0)<<3)|0;G=D+ +p[E>>3]*+p[F>>3];B=B+1|0;if((B|0)==(a|0)){H=G;break}else D=G}}else H=0.0;else H=+p[A>>3];D=C*H;if(l)I=0;else break;while(1){B=m+((Y(I,k)|0)<<3)|0;p[B>>3]=+p[B>>3]+D*+p[e+(I<<3)>>3];I=I+1|0;if((I|0)==(b|0))break a}}do if(!g){if(u){B=0;do{F=A+((Y(B,s)|0)<<3)|0;p[r+(B<<3)>>3]=C*+p[F>>3];B=B+1|0}while((B|0)!=(t|0))}}else{if(!u){nQ(a,t,j,i,A,s,r,0);break}XIc(o|0,0,v|0)|0;nQ(a,t,j,i,A,s,r,0);B=0;do{F=r+(B<<3)|0;p[F>>3]=C*+p[F>>3];B=B+1|0}while((B|0)!=(t|0))}while(0);nQ(b,t,r,0,e,1,m,k)}while(0);h=h+1|0;if((h|0)>=(d|0))break;else{A=A+(n<<3)|0;e=e+(f<<3)|0}}return}function nQ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0.0,t=0;if((a|0)<=0)return;i=b+-4|0;if((b|0)<4){j=(b|0)>0;k=g;l=0;m=c;while(1){n=e+((Y(l,f)|0)<<3)|0;o=+p[n>>3];if(j){n=0;do{q=k+(n<<3)|0;p[q>>3]=+p[q>>3]+o*+p[m+(n<<3)>>3];n=n+1|0}while((n|0)!=(b|0))}l=l+1|0;if((l|0)==(a|0))break;else{k=k+(h<<3)|0;m=m+(d<<3)|0}}return}m=b&-4;k=(m|0)<(b|0);l=g;g=0;j=c;while(1){c=e+((Y(g,f)|0)<<3)|0;o=+p[c>>3];c=0;do{n=l+(c<<3)|0;q=c|1;r=l+(q<<3)|0;s=+p[r>>3]+o*+p[j+(q<<3)>>3];p[n>>3]=+p[n>>3]+o*+p[j+(c<<3)>>3];p[r>>3]=s;r=c|2;n=l+(r<<3)|0;q=c|3;t=l+(q<<3)|0;s=+p[t>>3]+o*+p[j+(q<<3)>>3];p[n>>3]=+p[n>>3]+o*+p[j+(r<<3)>>3];p[t>>3]=s;c=c+4|0}while((c|0)<=(i|0));if(k){c=m;do{t=l+(c<<3)|0;p[t>>3]=+p[t>>3]+o*+p[j+(c<<3)>>3];c=c+1|0}while((c|0)!=(b|0))}g=g+1|0;if((g|0)==(a|0))break;else{l=l+(h<<3)|0;j=j+(d<<3)|0}}return}function oQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;g=u;u=u+1680|0;h=g;i=g+1616|0;j=g+1560|0;k=g+1504|0;l=g+464|0;m=g+408|0;o=g+352|0;q=g+240|0;r=g+184|0;s=g+128|0;t=g+72|0;v=g+56|0;w=g+296|0;do if((d$(a)|0)==65536){x=f[a+4>>2]|0;f[j>>2]=f[x>>2];y=j+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[x+8>>2];f[j+12>>2]=f[x+12>>2];f[j+16>>2]=f[x+16>>2];f[j+20>>2]=f[x+20>>2];f[j+24>>2]=f[x+24>>2];f[j+28>>2]=f[x+28>>2];f[j+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[j+36>>2]=B;f[j+40>>2]=A;A=j+48|0;C=j+44|0;f[C>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;ZS(j,x);break}}else a$(j,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];x=k+4|0;y=a+4|0;f[x>>2]=f[y>>2];z=k+8|0;f[z>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[k+36>>2]=A;f[k+40>>2]=z;z=k+48|0;C=k+44|0;f[C>>2]=z;f[z>>2]=0;f[k+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];D=k;break}else{f[x>>2]=0;ZS(k,a);D=k;break}}else{a$(k,c,-1);D=k}while(0);c=f[j>>2]|0;a=c&4095;x=(e&16|0)!=0;y=f[D>>2]|0;if((a|0)!=(y&4095|0)){f[h>>2]=0;E=h+4|0;f[E>>2]=0;F=tT(h,58)|0;G=F;H=215268;I=G+58|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));z5(-215,h,215327,214744,1086)}D=(a|0)==5;if((a+-5|0)>>>0>=2){f[h>>2]=0;E=h+4|0;f[E>>2]=0;F=tT(h,58)|0;G=F;H=215268;I=G+58|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));z5(-215,h,215327,214744,1086)}F=e&-17;if(F>>>0>=5)e2(F,41660);a:do switch(e|0){case 0:case 3:case 16:case 19:{if(!x?(f[j+8>>2]|0)!=(f[j+12>>2]|0):0){f[h>>2]=0;f[h+4>>2]=0;G=tT(h,87)|0;H=215333;I=G+87|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));z5(-215,h,215327,214744,1093)}switch(e|0){case 0:case 3:case 16:case 19:break;default:{J=61;break a}}if(((!x?(E=j+8|0,z=f[E>>2]|0,(z|0)<4):0)?(z|0)==(f[j+12>>2]|0):0)?(f[k+12>>2]|0)==1:0){Y$(d,z,1,a,-1,0,0);do if((d$(d)|0)==65536){z=f[d+4>>2]|0;f[h>>2]=f[z>>2];C=h+4|0;A=z+4|0;f[C>>2]=f[A>>2];B=h+8|0;f[B>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];K=h+16|0;f[K>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];L=f[z+36>>2]|0;f[h+36>>2]=L;f[h+40>>2]=B;B=h+48|0;M=h+44|0;f[M>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(L|0){N=L+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[A>>2]|0)<3){A=f[z+44>>2]|0;N=f[M>>2]|0;f[N>>2]=f[A>>2];f[N+4>>2]=f[A+4>>2];O=K;P=M;Q=B;break}else{f[C>>2]=0;ZS(h,z);O=K;P=M;Q=B;break}}else{a$(h,d,-1);O=h+16|0;P=h+44|0;Q=h+48|0}while(0);B=f[j+16>>2]|0;M=f[k+16>>2]|0;K=f[O>>2]|0;z=f[j+48>>2]|0;C=f[k+48>>2]|0;A=f[Q>>2]|0;b:do switch(f[E>>2]|0){case 2:{if(D){R=+n[B>>2];N=B+z|0;S=+n[N+4>>2];T=+n[B+4>>2];U=+n[N>>2];V=R*S-T*U;if(!(V!=0.0)){W=0;break b}X=1.0/V;V=+n[M>>2];Z=+n[M+C>>2];n[K+A>>2]=X*(R*Z-U*V);n[K>>2]=X*(S*V-T*Z);W=1;break b}else{Z=+p[B>>3];N=B+z|0;T=+p[N+8>>3];V=+p[B+8>>3];S=+p[N>>3];X=Z*T-V*S;if(!(X!=0.0)){W=0;break b}U=1.0/X;X=+p[M>>3];R=+p[M+C>>3];p[K+A>>3]=U*(Z*R-S*X);p[K>>3]=U*(T*X-V*R);W=1;break b}break}case 3:{N=z<<1;if(D){R=+n[B>>2];L=B+z|0;V=+n[L+4>>2];_=B+N|0;X=+n[_+8>>2];T=X;U=+n[L+8>>2];S=+n[_+4>>2];Z=V*T-U*S;$=+n[B+4>>2];aa=+n[L>>2];ba=+n[_>>2];ca=T*aa-U*ba;da=+n[B+8>>2];ea=S*aa-V*ba;fa=da*ea+(R*Z-$*ca);if(!(fa!=0.0)){W=0;break b}ga=1.0/fa;fa=+n[M>>2];ha=+n[M+C>>2];ia=ha;ja=+n[M+(C<<1)>>2];ka=U*ja;U=S*ia;S=V*ja;V=aa*ja-ba*ia;n[K>>2]=ga*(da*(U-S)+(Z*fa-$*(T*ia-ka)));n[K+A>>2]=ga*(da*V+(R*(X*ha-ka)-ca*fa));n[K+(A<<1)>>2]=ga*(ea*fa+(R*(S-U)-$*V));W=1;break b}else{V=+p[B>>3];_=B+z|0;$=+p[_+8>>3];L=B+N|0;U=+p[L+16>>3];S=+p[_+16>>3];R=+p[L+8>>3];fa=$*U-S*R;ea=+p[B+8>>3];ga=+p[_>>3];ca=U*ga;ka=+p[L>>3];ha=S*ka;X=+p[B+16>>3];da=R*ga-$*ka;ia=X*da+(V*fa-ea*(ca-ha));if(!(ia!=0.0)){W=0;break b}T=1.0/ia;ia=+p[M>>3];Z=+p[M+C>>3];ba=+p[M+(C<<1)>>3];p[K>>3]=T*(fa*ia+(R*X-U*ea)*Z+(S*ea-$*X)*ba);p[K+A>>3]=T*((ha-ca)*ia+(V*U-ka*X)*Z+(ga*X-V*S)*ba);p[K+(A<<1)>>3]=T*(da*ia+(ea*ka-V*R)*Z+(V*$-ea*ga)*ba);W=1;break b}break}default:if(D){ba=+n[B>>2];if(!(ba!=0.0)){W=0;break b}n[K>>2]=+n[M>>2]/ba;W=1;break b}else{ba=+p[B>>3];if(!(ba!=0.0)){W=0;break b}p[K>>3]=+p[M>>3]/ba;W=1;break b}}while(0);M=h+36|0;K=f[M>>2]|0;if(K|0?(B=K+12|0,K=f[B>>2]|0,f[B>>2]=K+-1,(K|0)==1):0)_S(h);f[M>>2]=0;M=h+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[M>>2]|0)>0){K=f[h+40>>2]|0;B=0;do{f[K+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[M>>2]|0))}M=f[P>>2]|0;if((M|0)!=(Q|0))g0(M);la=W;ma=k+36|0}else J=61;break}default:J=61}while(0);if((J|0)==61){W=f[j+8>>2]|0;Q=j+12|0;P=f[Q>>2]|0;O=f[k+12>>2]|0;M=(c>>>3&511)+1<<(47696>>>(a<<1&14)&3);c=Y(P,M)|0;B=c+15&-16;K=(Y(W,M)|0)+15&-16;A=(e|0)!=1?B:K;K=l+8|0;f[l>>2]=K;C=l+4|0;f[C>>2]=1032;f[m>>2]=y;y=m+4|0;z=k+4|0;E=f[z>>2]|0;f[y>>2]=E;L=m+8|0;f[L>>2]=f[k+8>>2];_=m+12|0;f[_>>2]=O;N=m+16|0;f[N>>2]=f[k+16>>2];na=m+20|0;f[na>>2]=f[k+20>>2];oa=m+24|0;f[oa>>2]=f[k+24>>2];pa=m+28|0;f[pa>>2]=f[k+28>>2];qa=m+32|0;f[qa>>2]=f[k+32>>2];ra=m+36|0;sa=k+36|0;ta=f[sa>>2]|0;f[ra>>2]=ta;ua=m+40|0;f[ua>>2]=L;va=m+48|0;wa=m+44|0;f[wa>>2]=va;f[va>>2]=0;f[m+52>>2]=0;if(!ta)xa=E;else{E=ta+12|0;f[E>>2]=(f[E>>2]|0)+1;xa=f[z>>2]|0}if((xa|0)<3){xa=f[k+44>>2]|0;z=f[wa>>2]|0;f[z>>2]=f[xa>>2];f[z+4>>2]=f[xa+4>>2]}else{f[y>>2]=0;ZS(m,k)}Y$(d,f[Q>>2]|0,f[_>>2]|0,f[j>>2]&4095,-1,0,0);do if((d$(d)|0)==65536){Q=f[d+4>>2]|0;f[o>>2]=f[Q>>2];xa=o+4|0;z=Q+4|0;f[xa>>2]=f[z>>2];E=o+8|0;f[E>>2]=f[Q+8>>2];f[o+12>>2]=f[Q+12>>2];f[o+16>>2]=f[Q+16>>2];f[o+20>>2]=f[Q+20>>2];f[o+24>>2]=f[Q+24>>2];f[o+28>>2]=f[Q+28>>2];f[o+32>>2]=f[Q+32>>2];ta=f[Q+36>>2]|0;f[o+36>>2]=ta;f[o+40>>2]=E;E=o+48|0;ya=o+44|0;f[ya>>2]=E;f[E>>2]=0;f[o+52>>2]=0;if(ta|0){E=ta+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[z>>2]|0)<3){z=f[Q+44>>2]|0;E=f[ya>>2]|0;f[E>>2]=f[z>>2];f[E+4>>2]=f[z+4>>2];break}else{f[xa>>2]=0;ZS(o,Q);break}}else a$(o,d,-1);while(0);if((W|0)<(P|0)){f[h>>2]=0;f[h+4>>2]=0;G=tT(h,58)|0;H=215421;I=G+58|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));z5(-5,h,215327,214744,1239)}H=(W|0)==(P|0);if(H){za=F;Aa=0;Ba=W}else{za=(e|0)==17?2:F;Aa=x;Ba=x?P:W}x=(za|0)==1;F=Y(Aa|x?P:W,A)|0;e=Y(c,O)|0;c=(Aa?e+32|0:32)+F|0;d=(za|0)==2;if((za+-1|0)>>>0<2)Ca=(O<<3)+32+(Y(B+(M*5|0)|0,P)|0)+c|0;else Ca=c;if((f[C>>2]|0)>>>0<Ca>>>0){c=f[l>>2]|0;if((c|0)==(K|0))Da=c;else{if(c|0)ZDc(c);f[l>>2]=K;f[C>>2]=1032;Da=K}f[C>>2]=Ca;if(Ca>>>0>1032){c=XDc(Ca)|0;f[l>>2]=c;Ea=c}else Ea=Da}else{f[C>>2]=Ca;Ea=f[l>>2]|0}Ca=Ea+15&-16;Vj(q,Ba,P,a,Ca,A);c:do if(Aa){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=j;Ea=i+8|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;gO(h,i,1,e0()|0,1.0,-1);Ea=Ca+F|0;switch(za|0){case 0:case 3:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=j;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=m;f[s>>2]=1124007936;Da=s+4|0;c=s+8|0;Q=s+40|0;G=Da;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Q>>2]=c;xa=s+48|0;z=s+44|0;f[z>>2]=xa;f[xa>>2]=0;f[s+52>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=s;E=t+8|0;f[E>>2]=0;f[E+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=o;MN(h,i,1.0,r,0.0,t,1);E=s+36|0;ya=f[E>>2]|0;if(ya|0?(ta=ya+12|0,ya=f[ta>>2]|0,f[ta>>2]=ya+-1,(ya|0)==1):0)_S(s);f[E>>2]=0;E=s+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[Da>>2]|0)>0){E=f[Q>>2]|0;ya=0;do{f[E+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[Da>>2]|0))}Da=f[z>>2]|0;if((Da|0)!=(xa|0))g0(Da);Fa=Ea;break c;break}default:{}}Vj(h,P,O,a,Ea,0);Da=Ca+F+e|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=j;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;f[t>>2]=1124007936;ya=t+4|0;E=t+8|0;Q=t+40|0;G=ya;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Q>>2]=E;Ea=t+48|0;xa=t+44|0;f[xa>>2]=Ea;f[Ea>>2]=0;f[t+52>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=t;z=v+8|0;f[z>>2]=0;f[z+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=h;MN(i,r,1.0,s,0.0,v,1);z=t+36|0;c=f[z>>2]|0;if(c|0?(ta=c+12|0,c=f[ta>>2]|0,f[ta>>2]=c+-1,(c|0)==1):0)_S(t);f[z>>2]=0;z=t+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[ya>>2]|0)>0){z=f[Q>>2]|0;c=0;do{f[z+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[ya>>2]|0))}ya=f[xa>>2]|0;if((ya|0)!=(Ea|0))g0(ya);ya=h+36|0;c=f[ya>>2]|0;if(c|0){z=c+12|0;f[z>>2]=(f[z>>2]|0)+1}z=f[ra>>2]|0;do if(z|0){c=z+12|0;Q=f[c>>2]|0;f[c>>2]=Q+-1;if((Q|0)!=1)break;_S(m)}while(0);f[ra>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[y>>2]|0)>0){z=f[ua>>2]|0;Ea=0;do{f[z+(Ea<<2)>>2]=0;Ea=Ea+1|0;Ga=f[y>>2]|0}while((Ea|0)<(Ga|0));f[m>>2]=f[h>>2];if((Ga|0)<3)J=142;else J=144}else{f[m>>2]=f[h>>2];J=142}do if((J|0)==142){Ea=f[h+4>>2]|0;if((Ea|0)>=3){J=144;break}f[y>>2]=Ea;f[L>>2]=f[h+8>>2];f[_>>2]=f[h+12>>2];Ea=f[h+44>>2]|0;z=f[wa>>2]|0;f[z>>2]=f[Ea>>2];f[z+4>>2]=f[Ea+4>>2]}while(0);if((J|0)==144)ZS(m,h);Ea=h+16|0;f[N>>2]=f[Ea>>2];f[na>>2]=f[h+20>>2];f[oa>>2]=f[h+24>>2];f[pa>>2]=f[h+28>>2];f[qa>>2]=f[h+32>>2];z=f[ya>>2]|0;f[ra>>2]=z;do if(z|0){xa=z+12|0;Q=f[xa>>2]|0;f[xa>>2]=Q+-1;if((Q|0)!=1)break;_S(h)}while(0);f[ya>>2]=0;z=h+4|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[z>>2]|0)>0){Q=f[h+40>>2]|0;xa=0;do{f[Q+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[z>>2]|0))}z=f[h+44>>2]|0;if((z|0)!=(h+48|0))g0(z);Fa=Da}else{if(x){Vj(h,P,Ba,a,Ca,A);z=h+36|0;xa=f[z>>2]|0;if(xa|0){Q=xa+12|0;f[Q>>2]=(f[Q>>2]|0)+1}Q=q+36|0;xa=f[Q>>2]|0;do if(xa|0){Ea=xa+12|0;ya=f[Ea>>2]|0;f[Ea>>2]=ya+-1;if((ya|0)!=1)break;_S(q)}while(0);f[Q>>2]=0;xa=q+16|0;Da=q+4|0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((f[Da>>2]|0)>0){ya=f[q+40>>2]|0;Ea=0;do{f[ya+(Ea<<2)>>2]=0;Ea=Ea+1|0;Ha=f[Da>>2]|0}while((Ea|0)<(Ha|0));f[q>>2]=f[h>>2];if((Ha|0)<3)J=101;else J=103}else{f[q>>2]=f[h>>2];J=101}do if((J|0)==101){Ea=f[h+4>>2]|0;if((Ea|0)>=3){J=103;break}f[Da>>2]=Ea;f[q+8>>2]=f[h+8>>2];f[q+12>>2]=f[h+12>>2];Ea=f[h+44>>2]|0;ya=f[q+44>>2]|0;f[ya>>2]=f[Ea>>2];f[ya+4>>2]=f[Ea+4>>2]}while(0);if((J|0)==103)ZS(q,h);Da=h+16|0;f[xa>>2]=f[Da>>2];f[q+20>>2]=f[h+20>>2];f[q+24>>2]=f[h+24>>2];f[q+28>>2]=f[h+28>>2];f[q+32>>2]=f[h+32>>2];Ea=f[z>>2]|0;f[Q>>2]=Ea;do if(Ea|0){ya=Ea+12|0;c=f[ya>>2]|0;f[ya>>2]=c+-1;if((c|0)!=1)break;_S(h)}while(0);f[z>>2]=0;Ea=h+4|0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[Ea>>2]|0)>0){Q=f[h+40>>2]|0;xa=0;do{f[Q+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[Ea>>2]|0))}Ea=f[h+44>>2]|0;if((Ea|0)!=(h+48|0))g0(Ea);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=j;Ea=i+8|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;jR(h,i)}else{Ea=h+8|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;h_(j,h)}Ea=Ca+F|0;switch(za|0){case 0:case 3:break;default:{Fa=Ea;break c}}xa=h+8|0;f[xa>>2]=0;f[xa+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=o;h_(m,h);Fa=Ea}while(0);d:do switch(za|0){case 0:{F=f[q+16>>2]|0;if(D)if(!(n2(F,f[q+48>>2]|0,P,f[o+16>>2]|0,f[o+48>>2]|0,O)|0)){J=281;break d}else{Ia=1;break d}else if(!(p2(F,f[q+48>>2]|0,P,f[o+16>>2]|0,f[o+48>>2]|0,O)|0)){J=281;break d}else{Ia=1;break d}break}case 3:{F=f[q+16>>2]|0;if(D)Ja=r2(F,f[q+48>>2]|0,P,f[o+16>>2]|0,f[o+48>>2]|0,O)|0;else Ja=t2(F,f[q+48>>2]|0,P,f[o+16>>2]|0,f[o+48>>2]|0,O)|0;if(Ja)Ia=1;else J=281;break}case 4:{f[r>>2]=1124007936;F=r+4|0;Ca=r+8|0;Ha=r+40|0;G=F;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Ha>>2]=Ca;A=r+48|0;x=r+44|0;f[x>>2]=A;f[A>>2]=0;f[r+52>>2]=0;if(H|Aa){qa=h+8|0;f[qa>>2]=0;f[qa+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=o;h_(m,h);qa=o+36|0;pa=f[qa>>2]|0;if(pa|0){oa=pa+12|0;f[oa>>2]=(f[oa>>2]|0)+1}oa=r+36|0;pa=f[oa>>2]|0;do if(pa|0){na=pa+12|0;_=f[na>>2]|0;f[na>>2]=_+-1;if((_|0)!=1)break;_S(r)}while(0);f[oa>>2]=0;pa=r+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[F>>2]|0)>0){_=f[Ha>>2]|0;na=0;do{f[_+(na<<2)>>2]=0;na=na+1|0;Ka=f[F>>2]|0}while((na|0)<(Ka|0));f[r>>2]=f[o>>2];if((Ka|0)<3)J=172;else J=174}else{f[r>>2]=f[o>>2];J=172}do if((J|0)==172){na=f[o+4>>2]|0;if((na|0)>=3){J=174;break}f[F>>2]=na;f[Ca>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];na=f[o+44>>2]|0;_=f[x>>2]|0;f[_>>2]=f[na>>2];f[_+4>>2]=f[na+4>>2]}while(0);if((J|0)==174)ZS(r,o);f[pa>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];f[r+24>>2]=f[o+24>>2];f[r+28>>2]=f[o+28>>2];f[r+32>>2]=f[o+32>>2];f[oa>>2]=f[qa>>2]}else{f[i>>2]=1124007936;na=i+4|0;_=i+8|0;L=i+40|0;G=na;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[L>>2]=_;qa=i+48|0;oa=i+44|0;f[oa>>2]=qa;f[qa>>2]=0;f[i+52>>2]=0;f[h>>2]=W;f[h+4>>2]=O;XS(i,2,h,a);pa=i+36|0;Ga=f[pa>>2]|0;if(Ga|0){t=Ga+12|0;f[t>>2]=(f[t>>2]|0)+1}t=r+36|0;Ga=f[t>>2]|0;do if(Ga|0){v=Ga+12|0;s=f[v>>2]|0;f[v>>2]=s+-1;if((s|0)!=1)break;_S(r)}while(0);f[t>>2]=0;Ga=r+16|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[F>>2]|0)>0){s=f[Ha>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0;La=f[F>>2]|0}while((v|0)<(La|0));f[r>>2]=f[i>>2];if((La|0)<3)J=186;else J=188}else{f[r>>2]=f[i>>2];J=186}do if((J|0)==186){v=f[na>>2]|0;if((v|0)>=3){J=188;break}f[F>>2]=v;f[Ca>>2]=f[_>>2];f[r+12>>2]=f[i+12>>2];v=f[oa>>2]|0;s=f[x>>2]|0;f[s>>2]=f[v>>2];f[s+4>>2]=f[v+4>>2]}while(0);if((J|0)==188)ZS(r,i);_=i+16|0;f[Ga>>2]=f[_>>2];f[r+20>>2]=f[i+20>>2];f[r+24>>2]=f[i+24>>2];f[r+28>>2]=f[i+28>>2];f[r+32>>2]=f[i+32>>2];v=f[pa>>2]|0;f[t>>2]=v;do if(v|0){s=v+12|0;e=f[s>>2]|0;f[s>>2]=e+-1;if((e|0)!=1)break;_S(i)}while(0);f[pa>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[na>>2]|0)>0){v=f[L>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[na>>2]|0))}na=f[oa>>2]|0;if((na|0)!=(qa|0))g0(na);na=h+8|0;f[na>>2]=0;f[na+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=r;h_(m,h)}na=f[q+16>>2]|0;if(D)Ma=v2(na,f[q+48>>2]|0,f[q+8>>2]|0,f[q+12>>2]|0,f[r+12>>2]|0,f[r+16>>2]|0,f[A>>2]|0,0)|0;else Ma=w2(na,f[q+48>>2]|0,f[q+8>>2]|0,f[q+12>>2]|0,f[r+12>>2]|0,f[r+16>>2]|0,f[A>>2]|0,0)|0;na=(Ma|0)==0;t=f[o+8>>2]|0;do if((f[Ca>>2]|0)!=(t|0)){f[h>>2]=0;f[h+4>>2]=t;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;$S(w,r,h,i);v=h+8|0;f[v>>2]=0;f[v+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=o;h_(w,h);v=w+36|0;L=f[v>>2]|0;do if(L|0){_=L+12|0;pa=f[_>>2]|0;f[_>>2]=pa+-1;if((pa|0)!=1)break;_S(w)}while(0);f[v>>2]=0;L=w+16|0;pa=w+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[pa>>2]|0)>0){L=f[w+40>>2]|0;_=0;do{f[L+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[pa>>2]|0))}pa=f[w+44>>2]|0;if((pa|0)==(w+48|0))break;g0(pa)}while(0);t=r+36|0;Ca=f[t>>2]|0;do if(Ca|0){qa=Ca+12|0;oa=f[qa>>2]|0;f[qa>>2]=oa+-1;if((oa|0)!=1)break;_S(r)}while(0);f[t>>2]=0;Ca=r+16|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[F>>2]|0)>0){Ca=f[Ha>>2]|0;oa=0;do{f[Ca+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[F>>2]|0))}F=f[x>>2]|0;if((F|0)!=(A|0))g0(F);if(na)J=281;else Ia=1;break}default:{F=Fa+15&-16;Vj(h,P,P,a,F,B);Vj(i,P,1,a,F+(Y(B,P)|0)|0,0);f[r>>2]=1124007936;oa=r+4|0;Ca=r+8|0;Ha=r+40|0;G=oa;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Ha>>2]=Ca;na=r+48|0;A=r+44|0;f[A>>2]=na;f[na>>2]=0;f[r+52>>2]=0;x=F+(Y(B+M|0,P)|0)|0;t=f[q+16>>2]|0;e:do if(d){if(D)jQ(t,f[q+48>>2]|0,f[i+16>>2]|0,f[h+16>>2]|0,f[h+48>>2]|0,P,x)|0;else kQ(t,f[q+48>>2]|0,f[i+16>>2]|0,f[h+16>>2]|0,f[h+48>>2]|0,P,x)|0;qa=h+36|0;pa=f[qa>>2]|0;if(pa|0){_=pa+12|0;f[_>>2]=(f[_>>2]|0)+1}_=r+36|0;pa=f[_>>2]|0;do if(pa|0){L=pa+12|0;v=f[L>>2]|0;f[L>>2]=v+-1;if((v|0)!=1)break;_S(r)}while(0);f[_>>2]=0;pa=r+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[oa>>2]|0)>0){v=f[Ha>>2]|0;L=0;do{f[v+(L<<2)>>2]=0;L=L+1|0;Na=f[oa>>2]|0}while((L|0)<(Na|0));f[r>>2]=f[h>>2];if((Na|0)<3)J=233}else{f[r>>2]=f[h>>2];J=233}do if((J|0)==233){L=f[h+4>>2]|0;if((L|0)>=3)break;f[oa>>2]=L;f[Ca>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];L=f[h+44>>2]|0;v=f[A>>2]|0;f[v>>2]=f[L>>2];f[v+4>>2]=f[L+4>>2];Oa=qa;Pa=_;Qa=pa;Ra=h;break e}while(0);ZS(r,h);Oa=qa;Pa=_;Qa=pa;Ra=h}else{if(D){L=f[h+16>>2]|0;cQ(t,f[q+48>>2]|0,f[i+16>>2]|0,L,f[h+48>>2]|0,Ba,P,(L|0)==0?0:P,1.1754943508222875e-38,2.384185791015625e-07)}else{L=f[h+16>>2]|0;dQ(t,f[q+48>>2]|0,f[i+16>>2]|0,L,f[h+48>>2]|0,Ba,P,(L|0)==0?0:P,2.2250738585072014e-308,2.220446049250313e-15)}L=q+36|0;v=f[L>>2]|0;if(v|0){Ga=v+12|0;f[Ga>>2]=(f[Ga>>2]|0)+1}Ga=r+36|0;v=f[Ga>>2]|0;do if(v|0){e=v+12|0;s=f[e>>2]|0;f[e>>2]=s+-1;if((s|0)!=1)break;_S(r)}while(0);f[Ga>>2]=0;v=r+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[oa>>2]|0)>0){pa=f[Ha>>2]|0;_=0;do{f[pa+(_<<2)>>2]=0;_=_+1|0;Sa=f[oa>>2]|0}while((_|0)<(Sa|0));f[r>>2]=f[q>>2];if((Sa|0)<3)J=249}else{f[r>>2]=f[q>>2];J=249}do if((J|0)==249){_=f[q+4>>2]|0;if((_|0)>=3)break;f[oa>>2]=_;f[Ca>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];_=f[q+44>>2]|0;pa=f[A>>2]|0;f[pa>>2]=f[_>>2];f[pa+4>>2]=f[_+4>>2];Oa=L;Pa=Ga;Qa=v;Ra=q;break e}while(0);ZS(r,q);Oa=L;Pa=Ga;Qa=v;Ra=q}while(0);f[Qa>>2]=f[Ra+16>>2];f[r+20>>2]=f[Ra+20>>2];f[r+24>>2]=f[Ra+24>>2];f[r+28>>2]=f[Ra+28>>2];f[r+32>>2]=f[Ra+32>>2];f[Pa>>2]=f[Oa>>2];Ca=i+16|0;t=f[Ca>>2]|0;if(D)lQ(Ba,P,t,0,f[r+16>>2]|0,f[na>>2]|0,1,f[h+16>>2]|0,f[h+48>>2]|0,f[N>>2]|0,f[va>>2]|0,O,f[o+16>>2]|0,f[o+48>>2]|0,x);else mQ(Ba,P,t,0,f[r+16>>2]|0,f[na>>2]|0,1,f[h+16>>2]|0,f[h+48>>2]|0,f[N>>2]|0,f[va>>2]|0,O,f[o+16>>2]|0,f[o+48>>2]|0,x);t=r+36|0;F=f[t>>2]|0;if(F|0?(_=F+12|0,F=f[_>>2]|0,f[_>>2]=F+-1,(F|0)==1):0)_S(r);f[t>>2]=0;t=r+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[oa>>2]|0)>0){t=f[Ha>>2]|0;F=0;do{f[t+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[oa>>2]|0))}oa=f[A>>2]|0;if((oa|0)!=(na|0))g0(oa);oa=i+36|0;F=f[oa>>2]|0;do if(F|0){t=F+12|0;Ha=f[t>>2]|0;f[t>>2]=Ha+-1;if((Ha|0)!=1)break;_S(i)}while(0);f[oa>>2]=0;F=i+4|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[F>>2]|0)>0){na=f[i+40>>2]|0;A=0;do{f[na+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[F>>2]|0))}F=f[i+44>>2]|0;if((F|0)!=(i+48|0))g0(F);F=h+36|0;A=f[F>>2]|0;do if(A|0){na=A+12|0;Ca=f[na>>2]|0;f[na>>2]=Ca+-1;if((Ca|0)!=1)break;_S(h)}while(0);f[F>>2]=0;A=h+16|0;Ca=h+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[Ca>>2]|0)>0){A=f[h+40>>2]|0;na=0;do{f[A+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[Ca>>2]|0))}Ca=f[h+44>>2]|0;if((Ca|0)!=(h+48|0))g0(Ca);Ia=1}}while(0);if((J|0)==281){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;k_(o,h)|0;Ia=0}h=q+36|0;J=f[h>>2]|0;if(J|0?(i=J+12|0,J=f[i>>2]|0,f[i>>2]=J+-1,(J|0)==1):0)_S(q);f[h>>2]=0;h=q+16|0;J=q+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[J>>2]|0)>0){h=f[q+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[J>>2]|0))}J=f[q+44>>2]|0;if((J|0)!=(q+48|0))g0(J);J=o+36|0;q=f[J>>2]|0;if(q|0?(i=q+12|0,q=f[i>>2]|0,f[i>>2]=q+-1,(q|0)==1):0)_S(o);f[J>>2]=0;J=o+16|0;q=o+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[q>>2]|0)>0){J=f[o+40>>2]|0;i=0;do{f[J+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}q=f[o+44>>2]|0;if((q|0)!=(o+48|0))g0(q);q=f[ra>>2]|0;do if(q|0){o=q+12|0;i=f[o>>2]|0;f[o>>2]=i+-1;if((i|0)!=1)break;_S(m)}while(0);f[ra>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[y>>2]|0)>0){N=f[ua>>2]|0;ua=0;do{f[N+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[y>>2]|0))}y=f[wa>>2]|0;if((y|0)!=(va|0))g0(y);y=f[l>>2]|0;if((y|0)!=(K|0)){if(y|0)ZDc(y);f[l>>2]=K;f[C>>2]=1032}la=Ia;ma=sa}sa=f[ma>>2]|0;if(sa|0?(Ia=sa+12|0,sa=f[Ia>>2]|0,f[Ia>>2]=sa+-1,(sa|0)==1):0)_S(k);f[ma>>2]=0;ma=k+16|0;sa=k+4|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[sa>>2]|0)>0){ma=f[k+40>>2]|0;Ia=0;do{f[ma+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[sa>>2]|0))}sa=f[k+44>>2]|0;if((sa|0)!=(k+48|0))g0(sa);sa=j+36|0;k=f[sa>>2]|0;if(k|0?(Ia=k+12|0,k=f[Ia>>2]|0,f[Ia>>2]=k+-1,(k|0)==1):0)_S(j);f[sa>>2]=0;sa=j+16|0;k=j+4|0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[k>>2]|0)>0){sa=f[j+40>>2]|0;Ia=0;do{f[sa+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=g;return la|0}g0(k);u=g;return la|0}function pQ(){k6(530048);k6(530052);k6(530056);k6(530060);k6(530064);k6(530068);k6(530072);k6(530076);k6(530080);k6(530084);k6(530088);k6(530092);k6(530096);k6(530100);k6(530104);k6(530108);k6(530112);k6(530116);k6(530120);k6(530124);k6(530128);k6(530132);k6(530136);k6(530140);k6(530144);k6(530148);k6(530152);k6(530156);k6(530160);k6(530164);k6(530168);be(1706,0,x|0)|0;return}function qQ(a){a=a|0;l6(530168);l6(530164);l6(530160);l6(530156);l6(530152);l6(530148);l6(530144);l6(530140);l6(530136);l6(530132);l6(530128);l6(530124);l6(530120);l6(530116);l6(530112);l6(530108);l6(530104);l6(530100);l6(530096);l6(530092);l6(530088);l6(530084);l6(530080);l6(530076);l6(530072);l6(530068);l6(530064);l6(530060);l6(530056);l6(530052);l6(530048);return}function rQ(a,b){a=a|0;b=b|0;f[a+4>>2]=b;f[a>>2]=b;b=a+8|0;a=b+44|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function sQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if(f[a+44>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,13)|0;g=215701;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));z5(-215,d,215715,215725,78)}d=a+16|0;g=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;d=f[g>>2]|0;if(!d){u=c;return}a=d+12|0;e=f[a>>2]|0;f[a>>2]=e+-1;if((e|0)==1){if(f[d+44>>2]|0){e=f[d+4>>2]|0;if(!e)i=QS()|0;else i=e;mi[f[(f[i>>2]|0)+24>>2]&2047](i,d)}i=d+8|0;e=f[i>>2]|0;f[i>>2]=e+-1;if((e|0)==1){e=f[d+4>>2]|0;mi[f[(f[e>>2]|0)+16>>2]&2047](e,d)}}else{e=d+8|0;f[e>>2]=(f[e>>2]|0)+-1}f[g>>2]=0;u=c;return}function tQ(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;if(!(f[132543]|0)){d=H5()|0;m6(d);if(!(f[132543]|0)){e=VDc(8)|0;o6(e);f[e>>2]=41696;f[132543]=e}n6(d)}d=T5(f[132543]|0)|0;if(!d){f[c>>2]=0;f[c+4>>2]=0;e=tT(c,3)|0;b[e>>0]=b[215813]|0;b[e+1>>0]=b[215814]|0;b[e+2>>0]=b[215815]|0;z5(-215,c,215817,215824,761)}else{u=a;return d|0}return 0}function uQ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=a+4|0;if((g|0)!=(f[h>>2]|0)?(g|0)!=(f[a+8>>2]|0):0){if(f[a>>2]|0){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,16)|0;j=215791;k=i+16|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,215808,215725,167)}f[a>>2]=1;f[h>>2]=g;m6(530048+((((f[c>>2]|0)>>>0)%31|0)<<2)|0);u=d;return}f[c>>2]=0;u=d;return}function vQ(a){a=a|0;f[a>>2]=41696;d6(a);w5(a);return}function wQ(a){a=a|0;f[a>>2]=41696;d6(a);w5(a);YDc(a);return}function xQ(a){a=a|0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function yQ(a,b){a=a|0;b=b|0;if(!b)return;YDc(b);return}function zQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=(c|0)==0;i=(d|0)==0;if(h&i){u=e;return}if((f[a>>2]|0)!=1){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,16)|0;k=215947;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,g,222405,215725,195)}f[a>>2]=0;if(!h)n6(530048+(((c>>>0)%31|0)<<2)|0);if(!i)n6(530048+(((d>>>0)%31|0)<<2)|0);f[a+4>>2]=0;f[a+8>>2]=0;u=e;return}function AQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+16|0;i=h;if(c>>>0>=33){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,33)|0;k=217187;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,i,217221,215725,270)}m=a+4|0;if((f[m>>2]|0)!=(c|0)){n=a+36|0;o=f[n>>2]|0;p=a+40|0;if((o|0)!=(p|0)){g0(o);f[n>>2]=p;f[a+32>>2]=a+8}if((c|0)>2){p=f0(c<<3|4)|0;f[n>>2]=p;n=p+(c<<2)+4|0;f[a+32>>2]=n;f[n+-4>>2]=c;f[a+12>>2]=-1;f[a+8>>2]=-1}}f[m>>2]=c;if(!d){u=h;return}n=f[a>>2]|0;p=(n>>>3&511)+1<<(47696>>>(n<<1&14)&3);n=c+-1|0;if((c|0)<=0){u=h;return}o=f[a+32>>2]|0;q=f[a+36>>2]|0;a:do if(!e){if(g){r=n;s=p}else{t=n;while(1){v=f[d+(t<<2)>>2]|0;if((v|0)<=-1){w=18;break a}f[o+(t<<2)>>2]=v;if((t|0)>0)t=t+-1|0;else break a}}while(1){t=f[d+(r<<2)>>2]|0;if((t|0)<=-1){w=18;break a}f[o+(r<<2)>>2]=t;f[q+(r<<2)>>2]=s;s=mJc(t|0,((t|0)<0)<<31>>31|0,s|0,0)|0;if(!((s|0)==(s|0)&(J|0)==0))break;if((r|0)<=0)break a;else r=r+-1|0}f[i>>2]=0;f[i+4>>2]=0;j=tT(i,51)|0;k=217236;l=j+51|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-211,i,217221,215725,307)}else{t=n;while(1){v=f[d+(t<<2)>>2]|0;if((v|0)<=-1){w=18;break a}f[o+(t<<2)>>2]=v;if((t|0)<(n|0))x=f[e+(t<<2)>>2]|0;else x=p;f[q+(t<<2)>>2]=x;if((t|0)>0)t=t+-1|0;else break}}while(0);if((w|0)==18){f[i>>2]=0;f[i+4>>2]=0;w=tT(i,6)|0;b[w>>0]=b[217229]|0;b[w+1>>0]=b[217230]|0;b[w+2>>0]=b[217231]|0;b[w+3>>0]=b[217232]|0;b[w+4>>0]=b[217233]|0;b[w+5>>0]=b[217234]|0;z5(-215,i,217221,215725,297)}if((c|0)!=1){u=h;return}f[m>>2]=2;f[a+12>>2]=1;f[(f[a+36>>2]|0)+4>>2]=p;u=h;return}function BQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+192|0;h=g+136|0;i=g+128|0;j=g+120|0;k=g+64|0;l=g;m=g+48|0;f[h>>2]=1124007936;n=h+4|0;o=h+8|0;p=h+20|0;q=h+24|0;r=h+28|0;s=h+32|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[s>>2]=o;t=h+40|0;v=h+36|0;f[v>>2]=t;f[h+44>>2]=0;f[t>>2]=0;w=c+16|0;x=f[w>>2]|0;a:do if(x){y=c+20|0;do if((x|0)!=(f[y>>2]|0)){f[i>>2]=0;z=i+4|0;f[z>>2]=0;f[j>>2]=0;A=j+4|0;f[A>>2]=0;jT(c,i,j);B=f[c+12>>2]|0;C=f[c+8>>2]|0;if(!(f[A>>2]|f[j>>2])){if((f[w>>2]|0)==(f[y>>2]|0))break;f[i>>2]=0;f[i+4>>2]=0;D=tT(i,17)|0;E=215964;F=D+17|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,i,222285,215725,358)}f[k>>2]=f[c>>2];G=k+4|0;H=c+4|0;I=f[H>>2]|0;f[G>>2]=I;J=k+8|0;f[J>>2]=C;K=k+12|0;f[K>>2]=B;L=k+16|0;f[L>>2]=f[w>>2];f[k+20>>2]=f[y>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];M=k+36|0;N=f[c+36>>2]|0;f[M>>2]=N;O=k+40|0;f[O>>2]=J;P=k+48|0;Q=k+44|0;f[Q>>2]=P;f[P>>2]=0;f[k+52>>2]=0;if(!N)R=I;else{I=N+12|0;f[I>>2]=(f[I>>2]|0)+1;R=f[H>>2]|0}if((R|0)<3){H=f[c+44>>2]|0;I=f[Q>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2]}else{f[G>>2]=0;ZS(k,c)}H=f[A>>2]|0;I=f[j>>2]|0;kT(k,H,(f[z>>2]|0)-H-(f[J>>2]|0)|0,I,(f[i>>2]|0)-I-(f[K>>2]|0)|0)|0;BQ(l,k,d,e);K=f[A>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=K;f[m+8>>2]=B;f[m+12>>2]=C;CQ(a,l,m);K=l+24|0;I=f[K>>2]|0;if(I|0?(J=I+8|0,I=f[J>>2]|0,f[J>>2]=I+-1,(I|0)==1):0){I=f[K>>2]|0;f[K>>2]=0;J=f[I+4>>2]|0;mi[f[(f[J>>2]|0)+16>>2]&2047](J,I)}I=l+4|0;if((f[I>>2]|0)>0){J=f[l+32>>2]|0;H=0;do{f[J+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}f[K>>2]=0;I=f[l+36>>2]|0;if((I|0)!=(l+40|0))g0(I);I=f[M>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)_S(k);f[M>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[G>>2]|0)>0){I=f[O>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[G>>2]|0))}G=f[Q>>2]|0;if((G|0)!=(P|0))g0(G);break a}while(0);y=d|50331648;G=f[c+32>>2]|0;H=QS()|0;I=(G|0)==0?H:G;G=c+4|0;H=c+40|0;O=c+44|0;L=Ij[f[(f[I>>2]|0)+8>>2]&15](I,f[G>>2]|0,f[H>>2]|0,f[c>>2]&4095,f[w>>2]|0,f[O>>2]|0,y,e)|0;I=c+36|0;f[L+48>>2]=f[I>>2];M=QS()|0;if(!(hh[f[(f[M>>2]|0)+12>>2]&127](M,L,y,e)|0)?(M=QS()|0,!(hh[f[(f[M>>2]|0)+12>>2]&127](M,L,y,e)|0)):0){f[i>>2]=0;f[i+4>>2]=0;D=tT(i,9)|0;E=215982;F=D+9|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,i,222285,215725,381)}y=f[I>>2]|0;if(y|0){M=y+12|0;f[M>>2]=(f[M>>2]|0)+1;M=(f[I>>2]|0)+8|0;f[M>>2]=(f[M>>2]|0)+1}f[h>>2]=f[c>>2];AQ(h,f[G>>2]|0,f[H>>2]|0,f[O>>2]|0,0);M=VS(f[h>>2]|0,f[n>>2]|0,f[s>>2]|0,f[v>>2]|0)|0;f[h>>2]=M;y=f[n>>2]|0;if((y|0)>2){f[h+12>>2]=-1;f[o>>2]=-1}f[q>>2]=L;f[r>>2]=0;if(!L){S=M;T=y;U=L;V=0}else{y=L+8|0;f[y>>2]=(f[y>>2]|0)+1;S=f[h>>2]|0;T=f[n>>2]|0;U=f[q>>2]|0;V=f[r>>2]|0}f[a>>2]=S;y=a+4|0;f[y>>2]=T;M=a+8|0;f[M>>2]=f[o>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=f[h+16>>2];f[a+20>>2]=f[p>>2];f[a+24>>2]=U;f[a+28>>2]=V;K=a+32|0;f[K>>2]=M;M=a+40|0;J=a+36|0;f[J>>2]=M;f[a+44>>2]=0;f[M>>2]=0;if(!U)W=T;else{M=U+8|0;f[M>>2]=(f[M>>2]|0)+1;W=f[n>>2]|0}if((W|0)<3){M=f[v>>2]|0;C=f[J>>2]|0;f[C>>2]=f[M>>2];f[C+4>>2]=f[M+4>>2];break}f[y>>2]=0;AQ(a,W,0,0,0);if((f[y>>2]|0)>0){M=f[s>>2]|0;C=f[K>>2]|0;K=f[v>>2]|0;B=f[J>>2]|0;J=0;do{f[C+(J<<2)>>2]=f[M+(J<<2)>>2];f[B+(J<<2)>>2]=f[K+(J<<2)>>2];J=J+1|0}while((J|0)<(f[y>>2]|0))}}else{f[a>>2]=1124007936;y=a+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[y+24>>2]=0;f[a+32>>2]=a+8;y=a+40|0;f[a+36>>2]=y;f[y>>2]=0;f[a+44>>2]=0}while(0);a=f[q>>2]|0;if(a|0?(W=a+8|0,a=f[W>>2]|0,f[W>>2]=a+-1,(a|0)==1):0){a=f[q>>2]|0;f[q>>2]=0;W=f[a+4>>2]|0;mi[f[(f[W>>2]|0)+16>>2]&2047](W,a)}if((f[n>>2]|0)>0){a=f[s>>2]|0;s=0;do{f[a+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[n>>2]|0))}f[q>>2]=0;q=f[v>>2]|0;if((q|0)==(t|0)){u=g;return}g0(q);u=g;return}function CQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;f[a>>2]=h;i=a+4|0;f[i>>2]=2;j=a+8|0;k=d+12|0;f[j>>2]=f[k>>2];l=a+12|0;m=d+8|0;f[l>>2]=f[m>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];n=a+24|0;o=f[c+24>>2]|0;f[n>>2]=o;p=a+28|0;q=d+4|0;r=c+36|0;s=(Y(f[f[r>>2]>>2]|0,f[q>>2]|0)|0)+(f[c+28>>2]|0)|0;f[p>>2]=s;t=a+32|0;f[t>>2]=j;v=a+40|0;w=a+36|0;f[w>>2]=v;f[a+44>>2]=0;f[v>>2]=0;v=o;if((f[c+4>>2]|0)>=3){f[g>>2]=0;f[g+4>>2]=0;x=tT(g,11)|0;y=249001;z=x+11|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,g,215992,215725,540)}A=(h>>>3&511)+1<<(47696>>>(h<<1&14)&3);h=f[d>>2]|0;d=(Y(A,h)|0)+s|0;f[p>>2]=d;if((((((h|0)>-1?(d=f[m>>2]|0,(d|0)>-1):0)?(p=c+12|0,s=f[p>>2]|0,(d+h|0)<=(s|0)):0)?(h=f[q>>2]|0,(h|0)>-1):0)?(q=f[k>>2]|0,(q|0)>-1):0)?(B=c+8|0,(q+h|0)<=(f[B>>2]|0)):0){if(!o){C=d;D=s}else{s=v+8|0;f[s>>2]=(f[s>>2]|0)+1;C=f[m>>2]|0;D=f[p>>2]|0}if(!((C|0)>=(D|0)?(f[k>>2]|0)>=(f[B>>2]|0):0))f[a>>2]=f[a>>2]|32768;B=f[w>>2]|0;f[B>>2]=f[f[r>>2]>>2];f[B+4>>2]=A;A=VS(f[a>>2]|0,f[i>>2]|0,f[t>>2]|0,B)|0;f[a>>2]=A;if((f[j>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=e;return}A=f[n>>2]|0;if(A|0?(a=A+8|0,A=f[a>>2]|0,f[a>>2]=A+-1,(A|0)==1):0){A=f[n>>2]|0;f[n>>2]=0;a=f[A+4>>2]|0;mi[f[(f[a>>2]|0)+16>>2]&2047](a,A)}if((f[i>>2]|0)>0){A=f[t>>2]|0;t=0;do{f[A+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}f[n>>2]=0;f[l>>2]=0;f[j>>2]=0;u=e;return}f[g>>2]=0;f[g+4>>2]=0;x=tT(g,124)|0;y=217740;z=x+124|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,g,215992,215725,545)}function DQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+144|0;i=h+8|0;j=h;k=a+20|0;f[k>>2]=g;if(!(c>>>0<33&(d|0)!=0)){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,35)|0;m=217389;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,i,464481,215725,408)}g=e&4095;e=a+24|0;o=f[e>>2]|0;p=(o|0)==0;do if(!p){q=f[a+4>>2]|0;if((q|0)!=(c|0)?!((c|0)==1&(q|0)<3):0)break;if((g|0)==(f[a>>2]&4095|0)){if((c|0)==2)if((f[a+8>>2]|0)==(f[d>>2]|0)?(f[a+12>>2]|0)==(f[d+4>>2]|0):0){u=h;return}else r=11;else if((c|0)>0)r=11;else s=0;a:do if((r|0)==11){q=f[a+32>>2]|0;t=0;while(1){if((f[q+(t<<2)>>2]|0)!=(f[d+(t<<2)>>2]|0)){s=t;break a}v=t+1|0;if((v|0)<(c|0))t=v;else{s=v;break}}}while(0);if((s|0)==(c|0)){if((c|0)>1){u=h;return}if((f[(f[a+32>>2]|0)+4>>2]|0)==1){u=h;return}}}}while(0);s=a+32|0;if((f[s>>2]|0)==(d|0)){if((c|0)>0)dJc(i|0,d|0,c<<2|0)|0;w=i}else w=d;if(!p?(p=o+8|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0){o=f[e>>2]|0;f[e>>2]=0;p=f[o+4>>2]|0;mi[f[(f[p>>2]|0)+16>>2]&2047](p,o)}o=a+4|0;if((f[o>>2]|0)>0){p=f[s>>2]|0;d=0;do{f[p+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[o>>2]|0))}f[e>>2]=0;if(c|0){f[a>>2]=g|1124007936;AQ(a,c,w,0,1);f[a+28>>2]=0;w=f[o>>2]|0;if((w|0)<3)x=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{c=f[s>>2]|0;d=0;p=1;while(1){i=Y(f[c+(d<<2)>>2]|0,p)|0;d=d+1|0;if((d|0)==(w|0)){x=i;break}else p=i}}if(x){x=f[a+16>>2]|0;p=QS()|0;if(!x){QS()|0;y=p}else y=x;x=a+36|0;p=Ij[f[(f[y>>2]|0)+8>>2]&15](y,f[o>>2]|0,f[s>>2]|0,g,0,f[x>>2]|0,0,f[k>>2]|0)|0;f[e>>2]=p;if(!p){f[j>>2]=0;f[j+4>>2]=0;p=tT(j,6)|0;b[p>>0]=b[217425]|0;b[p+1>>0]=b[217426]|0;b[p+2>>0]=b[217427]|0;b[p+3>>0]=b[217428]|0;b[p+4>>0]=b[217429]|0;b[p+5>>0]=b[217430]|0;z5(-215,j,464481,215725,448)}p=f[o>>2]|0;k=f[x>>2]|0;x=f[a>>2]|0;if((f[k+(p+-1<<2)>>2]|0)==((x>>>3&511)+1<<(47696>>>(x<<1&14)&3)|0)){z=x;A=p;B=k}else{f[j>>2]=0;f[j+4>>2]=0;l=tT(j,43)|0;m=217432;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,j,464481,215725,456)}}else{z=f[a>>2]|0;A=w;B=f[a+36>>2]|0}w=VS(z,A,f[s>>2]|0,B)|0;f[a>>2]=w;if((f[o>>2]|0)>2){f[a+12>>2]=-1;f[a+8>>2]=-1}a=f[e>>2]|0;if(a|0){e=a+8|0;f[e>>2]=(f[e>>2]|0)+1}}u=h;return}function EQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[b>>2]|0;DQ(a,(f[b+4>>2]|0)-e>>2,e,c,d);return}function FQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;AQ(a,f[b+4>>2]|0,0,0,0);c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[b+32>>2]|0;e=f[a+32>>2]|0;g=f[b+36>>2]|0;b=f[a+36>>2]|0;a=0;do{f[e+(a<<2)>>2]=f[d+(a<<2)>>2];f[b+(a<<2)>>2]=f[g+(a<<2)>>2];a=a+1|0}while((a|0)<(f[c>>2]|0));return}function GQ(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=f[b>>2]|0;if(c|0?(d=c+8|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0){c=f[b>>2]|0;f[b>>2]=0;d=f[c+4>>2]|0;mi[f[(f[d>>2]|0)+16>>2]&2047](d,c)}c=a+4|0;if((f[c>>2]|0)>0){d=f[a+32>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}f[b>>2]=0;b=f[a+36>>2]|0;if((b|0)==(a+40|0))return;g0(b);return}function HQ(a){a=a|0;var b=0;b=a+24|0;a=f[b>>2]|0;f[b>>2]=0;b=f[a+4>>2]|0;mi[f[(f[b>>2]|0)+16>>2]&2047](b,a);return}function IQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+1152|0;h=g+48|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+12|0;m=a+24|0;n=a+28|0;o=a+32|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[o>>2]=k;p=a+40|0;q=a+36|0;f[q>>2]=p;f[a+44>>2]=0;f[p>>2]=0;r=c+4|0;s=f[r>>2]|0;if((s|0)<=1){f[h>>2]=0;f[h+4>>2]=0;t=tT(h,11)|0;v=217476;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,215992,215725,497)}if((s|0)!=2){x=h+8|0;XIc(x|0,0,1088)|0;f[h>>2]=x;y=h+4|0;f[y>>2]=s;if(s>>>0>136){z=XDc(s>>>0>536870911?-1:s<<3)|0;XIc(z|0,0,s<<3|0)|0;f[h>>2]=z;A=z}else A=x;z=d;s=f[z+4>>2]|0;B=A;f[B>>2]=f[z>>2];f[B+4>>2]=s;s=f[h>>2]|0;B=e;z=f[B+4>>2]|0;A=s+8|0;f[A>>2]=f[B>>2];f[A+4>>2]=z;if((f[r>>2]|0)>2){z=2;A=s;while(1){B=A+(z<<3)|0;f[B>>2]=-2147483648;f[B+4>>2]=2147483647;z=z+1|0;B=f[h>>2]|0;if((z|0)>=(f[r>>2]|0)){C=B;break}else A=B}}else C=s;JQ(i,c,C);KQ(a,i)|0;C=i+24|0;s=f[C>>2]|0;if(s|0?(A=s+8|0,s=f[A>>2]|0,f[A>>2]=s+-1,(s|0)==1):0){s=f[C>>2]|0;f[C>>2]=0;A=f[s+4>>2]|0;mi[f[(f[A>>2]|0)+16>>2]&2047](A,s)}s=i+4|0;if((f[s>>2]|0)>0){A=f[i+32>>2]|0;r=0;do{f[A+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[s>>2]|0))}f[C>>2]=0;C=f[i+36>>2]|0;if((C|0)!=(i+40|0))g0(C);C=f[h>>2]|0;if((C|0)!=(x|0)){if(C|0)ZDc(C);f[h>>2]=x;f[y>>2]=136}u=g;return}KQ(a,c)|0;y=f[d>>2]|0;x=f[d+4>>2]|0;do if((y|0)!=-2147483648|(x|0)!=2147483647?(y|0?1:(x|0)!=(f[k>>2]|0)):0){if((y|0)<0|(x|0)<(y|0)){f[h>>2]=0;D=h+4|0;f[D>>2]=0;E=tT(h,83)|0;t=E;v=217488;w=t+83|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,215992,215725,512)}if((x|0)>(f[c+8>>2]|0)){f[h>>2]=0;D=h+4|0;f[D>>2]=0;E=tT(h,83)|0;t=E;v=217488;w=t+83|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,215992,215725,512)}else{f[k>>2]=x-y;d=Y(y,f[p>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+d;f[a>>2]=f[a>>2]|32768;break}}while(0);p=f[e>>2]|0;y=f[e+4>>2]|0;if((p|0)!=-2147483648|(y|0)!=2147483647?(p|0?1:(y|0)!=(f[l>>2]|0)):0){if((p|0)<0|(y|0)<(p|0)){f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,83)|0;t=G;v=217572;w=t+83|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,215992,215725,520)}if((y|0)>(f[c+12>>2]|0)){f[h>>2]=0;F=h+4|0;f[F>>2]=0;G=tT(h,83)|0;t=G;v=217572;w=t+83|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,215992,215725,520)}f[l>>2]=y-p;y=f[j>>2]|0;if((y|0)>0)H=f[(f[q>>2]|0)+(y+-1<<2)>>2]|0;else H=0;y=Y(H,p)|0;f[n>>2]=(f[n>>2]|0)+y;f[a>>2]=f[a>>2]|32768}y=VS(f[a>>2]|0,f[j>>2]|0,f[o>>2]|0,f[q>>2]|0)|0;f[a>>2]=y;if((f[k>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=g;return}y=f[m>>2]|0;if(y|0?(a=y+8|0,y=f[a>>2]|0,f[a>>2]=y+-1,(y|0)==1):0){y=f[m>>2]|0;f[m>>2]=0;a=f[y+4>>2]|0;mi[f[(f[a>>2]|0)+16>>2]&2047](a,y)}if((f[j>>2]|0)>0){y=f[o>>2]|0;o=0;do{f[y+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[j>>2]|0))}f[m>>2]=0;f[l>>2]=0;f[k>>2]=0;u=g;return}function JQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+28|0;j=a+32|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[j>>2]=a+8;k=a+40|0;l=a+36|0;f[l>>2]=k;f[a+44>>2]=0;f[k>>2]=0;k=f[c+4>>2]|0;if(!d){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,6)|0;b[m>>0]=b[217656]|0;b[m+1>>0]=b[217657]|0;b[m+2>>0]=b[217658]|0;b[m+3>>0]=b[217659]|0;b[m+4>>0]=b[217660]|0;b[m+5>>0]=b[217661]|0;z5(-215,g,215992,215725,567)}m=(k|0)>0;if(!m){KQ(a,c)|0;n=f[a>>2]|0;o=f[h>>2]|0;p=f[j>>2]|0;q=f[l>>2]|0;r=VS(n,o,p,q)|0;f[a>>2]=r;u=e;return}s=f[c+32>>2]|0;t=0;while(1){v=d+(t<<3)|0;w=f[v>>2]|0;x=f[v+4>>2]|0;if(!((w|0)==-2147483648&(x|0)==2147483647)){if(!((w|0)>-1&(w|0)<(x|0))){y=9;break}if((x|0)>(f[s+(t<<2)>>2]|0)){y=9;break}}t=t+1|0;if((t|0)>=(k|0)){y=11;break}}if((y|0)==9){f[g>>2]=0;f[g+4>>2]=0;t=tT(g,76)|0;s=217663;x=t+76|0;do{b[t>>0]=b[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(x|0));z5(-215,g,215992,215725,571)}else if((y|0)==11){KQ(a,c)|0;if(m)z=0;else{n=f[a>>2]|0;o=f[h>>2]|0;p=f[j>>2]|0;q=f[l>>2]|0;r=VS(n,o,p,q)|0;f[a>>2]=r;u=e;return}do{m=d+(z<<3)|0;c=f[m>>2]|0;y=f[m+4>>2]|0;if((c|0)!=-2147483648|(y|0)!=2147483647?(m=(f[j>>2]|0)+(z<<2)|0,c|0?1:(y|0)!=(f[m>>2]|0)):0){f[m>>2]=y-c;y=Y(f[(f[l>>2]|0)+(z<<2)>>2]|0,c)|0;f[i>>2]=(f[i>>2]|0)+y;f[a>>2]=f[a>>2]|32768}z=z+1|0}while((z|0)!=(k|0));n=f[a>>2]|0;o=f[h>>2]|0;p=f[j>>2]|0;q=f[l>>2]|0;r=VS(n,o,p,q)|0;f[a>>2]=r;u=e;return}}function KQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((a|0)==(b|0))return a|0;c=b+24|0;d=f[c>>2]|0;if(d|0){e=d+8|0;f[e>>2]=(f[e>>2]|0)+1}e=a+24|0;d=f[e>>2]|0;if(d|0?(g=d+8|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0){d=f[e>>2]|0;f[e>>2]=0;g=f[d+4>>2]|0;mi[f[(f[g>>2]|0)+16>>2]&2047](g,d)}d=a+4|0;if((f[d>>2]|0)>0){g=f[a+32>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0;i=f[d>>2]|0}while((h|0)<(i|0));f[e>>2]=0;f[a>>2]=f[b>>2];if((i|0)<3)j=13;else{k=f[b+4>>2]|0;j=15}}else{f[e>>2]=0;f[a>>2]=f[b>>2];j=13}if((j|0)==13){i=f[b+4>>2]|0;if((i|0)<3){f[d>>2]=i;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];h=f[b+36>>2]|0;g=f[a+36>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{k=i;j=15}}if((j|0)==15?(AQ(a,k,0,0,0),(f[d>>2]|0)>0):0){k=f[b+32>>2]|0;j=f[a+32>>2]|0;i=f[b+36>>2]|0;h=f[a+36>>2]|0;g=0;do{f[j+(g<<2)>>2]=f[k+(g<<2)>>2];f[h+(g<<2)>>2]=f[i+(g<<2)>>2];g=g+1|0}while((g|0)<(f[d>>2]|0))}f[a+16>>2]=f[b+16>>2];d=a+20|0;if(!(f[d>>2]|0))f[d>>2]=f[b+20>>2];f[e>>2]=f[c>>2];f[a+28>>2]=f[b+28>>2];return a|0}function LQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;i=f[c>>2]|0;j=(i>>>3&511)+1|0;f[a>>2]=i;i=a+4|0;k=c+4|0;l=f[k>>2]|0;f[i>>2]=l;m=a+8|0;n=c+8|0;f[m>>2]=f[n>>2];o=a+12|0;p=c+12|0;f[o>>2]=f[p>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];q=f[c+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[c+28>>2];r=a+32|0;f[r>>2]=m;s=a+40|0;t=a+36|0;f[t>>2]=s;f[a+44>>2]=0;f[s>>2]=0;if(!q)v=l;else{l=q+8|0;f[l>>2]=(f[l>>2]|0)+1;v=f[k>>2]|0}if((v|0)>=3){f[i>>2]=0;AQ(a,v,0,0,0);if((f[i>>2]|0)>0){v=f[c+32>>2]|0;l=f[r>>2]|0;q=f[c+36>>2]|0;s=f[t>>2]|0;w=0;do{f[l+(w<<2)>>2]=f[v+(w<<2)>>2];f[s+(w<<2)>>2]=f[q+(w<<2)>>2];w=w+1|0}while((w|0)<(f[i>>2]|0))}}else{i=f[c+36>>2]|0;w=f[t>>2]|0;f[w>>2]=f[i>>2];f[w+4>>2]=f[i+4>>2]}i=f[k>>2]|0;w=(e|0)==0;if((d|0)!=0&(w&(i|0)>2)){q=i+-1|0;if((Y(f[(f[c+32>>2]|0)+(q<<2)>>2]|0,j)|0)%(d|0)|0|0){f[h>>2]=0;x=h+4|0;f[x>>2]=0;y=tT(h,9)|0;z=y;A=217889;B=z+9|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,217974,215725,699)}s=f[a>>2]|0;v=(d<<3)+-8|0;f[a>>2]=s&-4089|v;f[(f[t>>2]|0)+(q<<2)>>2]=(v>>>3&511)+1<<(47696>>>(s<<1&14)&3);s=(f[r>>2]|0)+((f[k>>2]|0)+-1<<2)|0;k=(Y(f[s>>2]|0,j)|0)/(d|0)|0;f[s>>2]=k;u=g;return}if((i|0)>=3){f[h>>2]=0;x=h+4|0;f[x>>2]=0;y=tT(h,9)|0;z=y;A=217889;B=z+9|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,h,217974,215725,699)}y=(d|0)==0?j:d;d=Y(f[p>>2]|0,j)|0;if((y|0)>(d|0))if(w)C=16;else{D=e;C=18}else if(w&((d|0)%(y|0)|0|0)!=0)C=16;else{E=e;C=17}if((C|0)==16){E=(Y(f[n>>2]|0,d)|0)/(y|0)|0;C=17}if((C|0)==17)if(!E)F=d;else{D=E;C=18}do if((C|0)==18){E=f[n>>2]|0;if((D|0)!=(E|0)){e=Y(E,d)|0;E=f[c>>2]|0;if(!(E&16384)){f[h>>2]=0;f[h+4>>2]=0;z=tT(h,72)|0;A=226321;B=z+72|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-13,h,217974,215725,714)}if(D>>>0>e>>>0){f[h>>2]=0;f[h+4>>2]=0;z=tT(h,22)|0;A=226394;B=z+22|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-211,h,217974,215725,717)}w=(e|0)/(D|0)|0;if((Y(w,D)|0)==(e|0)){f[m>>2]=D;j=Y(1212424721>>>(E<<2&28)&15,w)|0;f[f[t>>2]>>2]=j;F=w;break}else{f[h>>2]=0;f[h+4>>2]=0;z=tT(h,78)|0;A=226232;B=z+78|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-5,h,217974,215725,723)}}else F=d}while(0);d=(F|0)/(y|0)|0;if((Y(d,y)|0)!=(F|0)){f[h>>2]=0;f[h+4>>2]=0;z=tT(h,62)|0;A=226417;B=z+62|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-15,h,217974,215725,733)}f[o>>2]=d;d=f[a>>2]|0;o=(y<<3)+-8|0;f[a>>2]=d&-4089|o;f[(f[t>>2]|0)+4>>2]=(o>>>3&511)+1<<(47696>>>(d<<1&14)&3);u=g;return}function MQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+64|0;e=d;g=r$(c)|0;PQ(e,a,g?33554432:50331648);l_(e,b,c)|0;c=e+36|0;b=f[c>>2]|0;if(b|0?(g=b+12|0,b=f[g>>2]|0,f[g>>2]=b+-1,(b|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;b=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[e+40>>2]|0;g=0;do{f[c+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[b>>2]|0))}b=f[e+44>>2]|0;if((b|0)==(e+48|0)){u=d;return a|0}g0(b);u=d;return a|0}function NQ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+448|0;e=d+320|0;g=d+192|0;h=d+64|0;i=d+8|0;j=d;k=c$(c,-1)|0;if(X$(c)|0?(l=f[a>>2]|0,(k|0)!=(l&4095|0)):0){if((l^k)&4088|0){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,30)|0;l=219865;n=m+30|0;do{b[m>>0]=b[l>>0]|0;m=m+1|0;l=l+1|0}while((m|0)<(n|0));z5(-215,e,222385,215725,888)}OQ(a,c,k,1.0,0.0);u=d;return}k=a+24|0;if(f[k>>2]|0){l=a+4|0;o=f[l>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[a+32>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if(!((o|0)==0|(p|0)==0)){m=e;n=m+128|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));m=(o|0)>0;if(m)v=f[(f[a+36>>2]|0)+(o+-1<<2)>>2]|0;else v=0;n=f[a+32>>2]|0;p=0;do{f[e+(p<<2)>>2]=f[n+(p<<2)>>2];p=p+1|0}while(p>>>0<o>>>0);p=o+-1|0;n=e+(p<<2)|0;s=Y(f[n>>2]|0,v)|0;f[n>>2]=s;if(m){m=f[a+36>>2]|0;s=0;n=f[a+28>>2]|0;do{r=f[m+(s<<2)>>2]|0;q=(n>>>0)/(r>>>0)|0;f[g+(s<<2)>>2]=q;n=n-(Y(q,r)|0)|0;s=s+1|0}while((s|0)<(o|0))}s=g+(p<<2)|0;p=Y(f[s>>2]|0,v)|0;f[s>>2]=p;w$(c,o,f[a+32>>2]|0,f[a>>2]&4095,-1,0,0);do if((d$(c)|0)==655360){e$(i,c,-1);o=i+24|0;p=f[o>>2]|0;if(!p){f[j>>2]=0;f[j+4>>2]=0;s=tT(j,5)|0;b[s>>0]=b[215997]|0;b[s+1>>0]=b[215998]|0;b[s+2>>0]=b[215999]|0;b[s+3>>0]=b[216e3]|0;b[s+4>>0]=b[216001]|0;z5(-215,j,222385,215725,910)}s=f[k>>2]|0;if((s|0)==(p|0)?(f[i+28>>2]|0)==(f[a+28>>2]|0):0){n=p+8|0;m=f[n>>2]|0;f[n>>2]=m+-1;if((m|0)==1){m=f[o>>2]|0;f[o>>2]=0;n=f[m+4>>2]|0;mi[f[(f[n>>2]|0)+16>>2]&2047](n,m)}m=i+4|0;if((f[m>>2]|0)>0){n=f[i+32>>2]|0;r=0;do{f[n+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[m>>2]|0))}f[o>>2]=0;m=f[i+36>>2]|0;if((m|0)!=(i+40|0))g0(m);break}m=f[s+4>>2]|0;if((m|0)!=(f[p+4>>2]|0)){r=p+8|0;n=f[r>>2]|0;f[r>>2]=n+-1;if((n|0)==1){n=f[o>>2]|0;f[o>>2]=0;r=f[n+4>>2]|0;mi[f[(f[r>>2]|0)+16>>2]&2047](r,n)}n=i+4|0;if((f[n>>2]|0)>0){r=f[i+32>>2]|0;q=0;do{f[r+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[n>>2]|0))}f[o>>2]=0;n=f[i+36>>2]|0;if((n|0)!=(i+40|0))g0(n);w=39;break}n=i+4|0;q=f[n>>2]|0;if((q|0)>0){r=i+36|0;t=f[r>>2]|0;x=0;y=f[i+28>>2]|0;do{z=f[t+(x<<2)>>2]|0;A=(y>>>0)/(z>>>0)|0;f[h+(x<<2)>>2]=A;y=y-(Y(A,z)|0)|0;x=x+1|0}while((x|0)<(q|0));B=r;C=t}else{t=i+36|0;B=t;C=f[t>>2]|0}t=f[l>>2]|0;r=h+(t+-1<<2)|0;q=Y(f[r>>2]|0,v)|0;f[r>>2]=q;Oh[f[(f[m>>2]|0)+36>>2]&7](m,s,p,t,e,g,f[a+36>>2]|0,h,C,0);t=f[o>>2]|0;if(t|0?(q=t+8|0,t=f[q>>2]|0,f[q>>2]=t+-1,(t|0)==1):0){t=f[o>>2]|0;f[o>>2]=0;q=f[t+4>>2]|0;mi[f[(f[q>>2]|0)+16>>2]&2047](q,t)}if((f[n>>2]|0)>0){t=f[i+32>>2]|0;q=0;do{f[t+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[n>>2]|0))}f[o>>2]=0;n=f[B>>2]|0;if((n|0)!=(i+40|0))g0(n)}else w=39;while(0);if((w|0)==39){do if((d$(c)|0)==65536){w=f[c+4>>2]|0;f[i>>2]=f[w>>2];B=i+4|0;C=w+4|0;f[B>>2]=f[C>>2];h=i+8|0;f[h>>2]=f[w+8>>2];f[i+12>>2]=f[w+12>>2];v=i+16|0;f[v>>2]=f[w+16>>2];f[i+20>>2]=f[w+20>>2];f[i+24>>2]=f[w+24>>2];f[i+28>>2]=f[w+28>>2];f[i+32>>2]=f[w+32>>2];j=f[w+36>>2]|0;f[i+36>>2]=j;f[i+40>>2]=h;h=i+48|0;n=i+44|0;f[n>>2]=h;f[h>>2]=0;f[i+52>>2]=0;if(j|0){h=j+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[C>>2]|0)<3){C=f[w+44>>2]|0;h=f[n>>2]|0;f[h>>2]=f[C>>2];f[h+4>>2]=f[C+4>>2];D=v;E=n;break}else{f[B>>2]=0;ZS(i,w);D=v;E=n;break}}else{a$(i,c,-1);D=i+16|0;E=i+44|0}while(0);n=f[k>>2]|0;k=f[n+4>>2]|0;wi[f[(f[k>>2]|0)+28>>2]&255](k,n,f[D>>2]|0,f[l>>2]|0,e,g,f[a+36>>2]|0,f[E>>2]|0);a=i+36|0;g=f[a>>2]|0;if(g|0?(e=g+12|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)_S(i);f[a>>2]=0;a=i+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[a>>2]|0)>0){D=f[i+40>>2]|0;g=0;do{f[D+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[a>>2]|0))}a=f[E>>2]|0;if((a|0)!=(i+48|0))g0(a)}u=d;return}}u$(c);u=d;return}function OQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+112|0;h=g+56|0;i=g;if(+L(+(d+-1.0))<2.220446049250313e-16)j=+L(+e)<2.220446049250313e-16;else j=0;k=f[a>>2]|0;if((c|0)<0)if(X$(b)|0)l=c$(b,-1)|0;else l=k&4095;else l=k&4088|c&7;if(!(((l^k)&7|0)!=0|j^1)){NQ(a,b);u=g;return}f[h>>2]=f[a>>2];j=h+4|0;k=a+4|0;c=f[k>>2]|0;f[j>>2]=c;m=h+8|0;f[m>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];n=h+24|0;o=f[a+24>>2]|0;f[n>>2]=o;f[h+28>>2]=f[a+28>>2];p=h+32|0;f[p>>2]=m;m=h+40|0;q=h+36|0;f[q>>2]=m;f[h+44>>2]=0;f[m>>2]=0;if(!o)r=c;else{c=o+8|0;f[c>>2]=(f[c>>2]|0)+1;r=f[k>>2]|0}if((r|0)>=3){f[j>>2]=0;AQ(h,r,0,0,0);if((f[j>>2]|0)>0){r=f[a+32>>2]|0;h=f[p>>2]|0;k=f[a+36>>2]|0;c=f[q>>2]|0;o=0;do{f[h+(o<<2)>>2]=f[r+(o<<2)>>2];f[c+(o<<2)>>2]=f[k+(o<<2)>>2];o=o+1|0}while((o|0)<(f[j>>2]|0))}}else{o=f[a+36>>2]|0;k=f[q>>2]|0;f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2]}PQ(i,a,16777216);LZ(i,b,l,d,e);l=i+36|0;b=f[l>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)_S(i);f[l>>2]=0;l=i+16|0;b=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[b>>2]|0)>0){l=f[i+40>>2]|0;a=0;do{f[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[i+44>>2]|0;if((b|0)!=(i+48|0))g0(b);b=f[n>>2]|0;if(b|0?(i=b+8|0,b=f[i>>2]|0,f[i>>2]=b+-1,(b|0)==1):0){b=f[n>>2]|0;f[n>>2]=0;i=f[b+4>>2]|0;mi[f[(f[i>>2]|0)+16>>2]&2047](i,b)}if((f[j>>2]|0)>0){b=f[p>>2]|0;p=0;do{f[b+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}f[n>>2]=0;n=f[q>>2]|0;if((n|0)!=(m|0))g0(n);u=g;return}function PQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+8|0;h=e;i=c+24|0;j=f[i>>2]|0;if(!j){f[a>>2]=1124007936;k=a+8|0;l=a+40|0;m=a+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=a+48|0;f[a+44>>2]=k;f[k>>2]=0;f[a+52>>2]=0;u=e;return}f[g>>2]=j;j=g+4|0;f[j>>2]=0;uQ(tQ()|0,g);k=(f[i>>2]|0)+12|0;l=f[k>>2]|0;f[k>>2]=l+1;if(!l){l=f[i>>2]|0;k=f[l+4>>2]|0;Ti[f[(f[k>>2]|0)+20>>2]&511](k,l,d|50331648)}d=f[i>>2]|0;l=f[d+16>>2]|0;do if(!l){k=d+12|0;f[k>>2]=(f[k>>2]|0)+-1;if(!(f[(f[i>>2]|0)+16>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,55)|0;k=216003;n=m+55|0;do{b[m>>0]=b[k>>0]|0;m=m+1|0;k=k+1|0}while((m|0)<(n|0));z5(-215,h,216059,215725,838)}else{f[a>>2]=1124007936;k=a+8|0;o=a+40|0;m=a+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[o>>2]=k;p=a+48|0;f[a+44>>2]=p;f[p>>2]=0;f[a+52>>2]=0;break}}else{p=c+28|0;dT(a,f[c+4>>2]|0,f[c+32>>2]|0,f[c>>2]&4095,l+(f[p>>2]|0)|0,f[c+36>>2]|0);f[a>>2]=f[c>>2];q=f[i>>2]|0;f[a+36>>2]=q;r=f[q+16>>2]|0;f[a+20>>2]=r;f[a+16>>2]=r+(f[p>>2]|0);p=r+(f[q+24>>2]|0)|0;f[a+24>>2]=p;f[a+28>>2]=p}while(0);a=tQ()|0;zQ(a,f[g>>2]|0,f[j>>2]|0);u=e;return}function QQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h+8|0;j=h;k=c+4|0;l=f[k>>2]|0;if((l|0)==(e|0)){if(!g){LQ(a,c,d,0);u=h;return}if((e|0)==2){LQ(a,c,d,f[g>>2]|0);u=h;return}}m=f[c>>2]|0;if(!(m&16384)){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,71)|0;o=218209;p=n+71|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-213,i,217974,215725,813)}if(!((g|0)!=0&((d|0)>-1&(e+-1|0)>>>0<32))){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,62)|0;o=217982;p=n+62|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,i,217974,215725,777)}if(d)if((d|0)<513)q=d;else{f[i>>2]=0;f[i+4>>2]=0;n=tT(i,16)|0;o=218045;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,i,217974,215725,782)}else q=(m>>>3&511)+1|0;if((l|0)<3)r=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{d=f[c+32>>2]|0;s=0;t=1;while(1){v=Y(f[d+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(l|0)){r=v;break}else t=v}}t=Y((m>>>3&511)+1|0,r)|0;r=i+8|0;f[i>>2]=r;m=i+4|0;f[m>>2]=e;if(e>>>0>4){l=XDc(e>>>0>1073741823?-1:e<<2)|0;f[i>>2]=l;w=l}else w=r;a:do if((e|0)>0){l=c+32|0;s=q;d=0;while(1){v=f[g+(d<<2)>>2]|0;if((v|0)<=-1){x=23;break}if(!v){if((d|0)>=(f[k>>2]|0)){x=27;break}y=f[(f[l>>2]|0)+(d<<2)>>2]|0}else y=v;f[w+(d<<2)>>2]=y;v=Y(y,s)|0;d=d+1|0;if((d|0)>=(e|0)){z=v;break a}else s=v}if((x|0)==23){f[j>>2]=0;f[j+4>>2]=0;n=tT(j,14)|0;o=218062;p=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-215,j,217974,215725,791)}else if((x|0)==27){f[j>>2]=0;f[j+4>>2]=0;n=tT(j,68)|0;o=218077;p=n+68|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-211,j,217974,215725,798)}}else z=q;while(0);if((z|0)!=(t|0)){f[j>>2]=0;f[j+4>>2]=0;n=tT(j,62)|0;o=218146;p=n+62|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-209,j,217974,215725,804)}f[a>>2]=f[c>>2];j=a+4|0;o=f[k>>2]|0;f[j>>2]=o;n=a+8|0;f[n>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];p=f[c+24>>2]|0;f[a+24>>2]=p;f[a+28>>2]=f[c+28>>2];t=a+32|0;f[t>>2]=n;n=a+40|0;z=a+36|0;f[z>>2]=n;f[a+44>>2]=0;f[n>>2]=0;if(!p)A=o;else{o=p+8|0;f[o>>2]=(f[o>>2]|0)+1;A=f[k>>2]|0}if((A|0)>=3){f[j>>2]=0;AQ(a,A,0,0,0);if((f[j>>2]|0)>0){A=f[c+32>>2]|0;k=f[t>>2]|0;t=f[c+36>>2]|0;o=f[z>>2]|0;p=0;do{f[k+(p<<2)>>2]=f[A+(p<<2)>>2];f[o+(p<<2)>>2]=f[t+(p<<2)>>2];p=p+1|0}while((p|0)<(f[j>>2]|0))}}else{j=f[c+36>>2]|0;c=f[z>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2]}f[a>>2]=f[a>>2]&-4089|(q<<3)+-8;AQ(a,e,f[i>>2]|0,0,1);e=f[i>>2]|0;if((e|0)!=(r|0)){if(e|0)ZDc(e);f[i>>2]=r;f[m>>2]=4}u=h;return}function RQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[a+36>>2]|0;e=0;g=f[a+28>>2]|0;do{a=f[d+(e<<2)>>2]|0;h=(g>>>0)/(a>>>0)|0;f[b+(e<<2)>>2]=h;g=g-(Y(h,a)|0)|0;e=e+1|0}while((e|0)<(f[c>>2]|0));return}function SQ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+1072|0;j=i+32|0;k=i;if(!h){u=i;return}if(!((a|0)!=0&(c|0)!=0&(d|0)!=0&(e|0)!=0&(g|0)!=0)){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,60)|0;m=216066;n=l+60|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));TQ(j,216127,101)}o=f[d>>2]|0;p=1212424721>>>(o<<2&28)&15;q=o&7;o=e+c|0;r=(o<<3)+8+(h<<5)|0;s=j+8|0;f[j>>2]=s;t=j+4|0;f[t>>2]=r;if(r>>>0>1032){v=XDc(r)|0;f[j>>2]=v;w=v}else w=s;v=w+(c<<2)+(e<<2)|0;r=v+(c<<2)+(e<<2)+4|0;x=r+(h<<2)|0;y=x+(h<<2)|0;z=y+(h<<2<<2)|0;A=z+(h<<2)|0;B=0;do{f[w+(B<<2)>>2]=a+(B*56|0);B=B+1|0}while((B|0)!=(c|0));C=0;do{f[w+(C+c<<2)>>2]=d+(C*56|0);C=C+1|0}while((C|0)!=(e|0));f[v+(o<<2)>>2]=0;C=0;a:while(1){B=C<<1;D=f[g+(B<<2)>>2]|0;E=f[g+((B|1)<<2)>>2]|0;if((D|0)>-1){B=D;D=0;while(1){F=a+(D*56|0)|0;G=f[F>>2]|0;H=G>>>3&511;if((B|0)<=(H|0))break;I=D+1|0;if(I>>>0<c>>>0){B=B+-1-H|0;D=I}else{J=21;break a}}if((G&7|0)!=(q|0)){J=21;break}I=C<<2;f[y+(I<<2)>>2]=D;H=Y(B,p)|0;f[y+((I|1)<<2)>>2]=H;K=((f[F>>2]|0)>>>3&511)+1|0}else{H=C<<2;f[y+(H<<2)>>2]=o;f[y+((H|1)<<2)>>2]=0;K=0}f[z+(C<<2)>>2]=K;H=E;I=0;while(1){L=d+(I*56|0)|0;M=f[L>>2]|0;N=M>>>3&511;if((H|0)<=(N|0))break;O=I+1|0;if(O>>>0<e>>>0){H=H+-1-N|0;I=O}else{J=22;break a}}if(!((H|0)>-1&(M&7|0)==(q|0))){J=22;break}E=C<<2;f[y+((E|2)<<2)>>2]=I+c;B=Y(H,p)|0;f[y+((E|3)<<2)>>2]=B;f[A+(C<<2)>>2]=((f[L>>2]|0)>>>3&511)+1;C=C+1|0;if(C>>>0>=h>>>0){J=23;break}}if((J|0)==21){f[k>>2]=0;f[k+4>>2]=0;l=tT(k,36)|0;m=216139;n=l+36|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));TQ(k,216127,128)}else if((J|0)==22){f[k>>2]=0;f[k+4>>2]=0;l=tT(k,47)|0;m=216176;n=l+47|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));TQ(k,216127,141)}else if((J|0)==23){z2(k,w,v,o);o=f[k+20>>2]|0;w=((p+1023|0)>>>0)/(p>>>0)|0;J=(w|0)<(o|0)?w:o;w=f[41712+(q<<2)>>2]|0;q=k+16|0;m=(o|0)>0;l=Y(J,p)|0;p=0;while(1){if(p>>>0<(f[q>>2]|0)>>>0)P=0;else break;do{n=P<<2;f[r+(P<<2)>>2]=(f[v+(f[y+(n<<2)>>2]<<2)>>2]|0)+(f[y+((n|1)<<2)>>2]|0);f[x+(P<<2)>>2]=(f[v+(f[y+((n|2)<<2)>>2]<<2)>>2]|0)+(f[y+((n|3)<<2)>>2]|0);P=P+1|0}while((P|0)!=(h|0));b:do if(m){H=0;do{I=o-H|0;Fh[w&255](r,z,x,A,(J|0)<(I|0)?J:I,h);H=H+J|0;I=(H|0)<(o|0);if(I)Q=0;else break b;do{n=Y(l,f[z+(Q<<2)>>2]|0)|0;C=r+(Q<<2)|0;f[C>>2]=(f[C>>2]|0)+n;n=Y(l,f[A+(Q<<2)>>2]|0)|0;C=x+(Q<<2)|0;f[C>>2]=(f[C>>2]|0)+n;Q=Q+1|0}while((Q|0)!=(h|0))}while(I)}while(0);A2(k)|0;p=p+1|0}p=f[j>>2]|0;if((p|0)!=(s|0)){if(p|0)ZDc(p);f[j>>2]=s;f[t>>2]=1032}u=i;return}}function TQ(a,b,c){a=a|0;b=b|0;c=c|0;z5(-215,a,b,216224,c);return}function UQ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((h|0)<=0)return;i=g+-2|0;if((g|0)<2){if((g|0)==1)j=0;else return;do{k=f[a+(j<<2)>>2]|0;if(!k)l=0;else l=b[k>>0]|0;b[f[d+(j<<2)>>2]>>0]=l;j=j+1|0}while((j|0)!=(h|0));return}j=g&-2;if((j|0)<(g|0))m=0;else{g=0;do{l=f[a+(g<<2)>>2]|0;k=f[d+(g<<2)>>2]|0;n=f[c+(g<<2)>>2]|0;o=f[e+(g<<2)>>2]|0;if(!l){p=o<<1;q=k;r=0;while(1){b[q+o>>0]=0;b[q>>0]=0;r=r+2|0;if((r|0)>(i|0))break;else q=q+p|0}}else{p=n<<1;q=o<<1;r=l;s=k;t=0;while(1){u=b[r+n>>0]|0;b[s>>0]=b[r>>0]|0;b[s+o>>0]=u;t=t+2|0;if((t|0)>(i|0))break;else{r=r+p|0;s=s+q|0}}}g=g+1|0}while((g|0)!=(h|0));return}do{g=f[a+(m<<2)>>2]|0;q=f[d+(m<<2)>>2]|0;s=f[c+(m<<2)>>2]|0;p=f[e+(m<<2)>>2]|0;if(!g){r=p<<1;t=q;o=0;while(1){b[t+p>>0]=0;b[t>>0]=0;o=o+2|0;if((o|0)>(i|0))break;else t=t+r|0}r=q+(Y(p,j)|0)|0;b[r>>0]=0}else{r=s<<1;t=p<<1;o=Y(s,j)|0;n=g;k=q;l=0;while(1){u=b[n+s>>0]|0;b[k>>0]=b[n>>0]|0;b[k+p>>0]=u;l=l+2|0;if((l|0)>(i|0))break;else{n=n+r|0;k=k+t|0}}t=q+(Y(p,j)|0)|0;b[t>>0]=b[g+o>>0]|0}m=m+1|0}while((m|0)!=(h|0));return}function VQ(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((h|0)<=0)return;i=g+-2|0;if((g|0)<2){if((g|0)==1)j=0;else return;do{k=f[a+(j<<2)>>2]|0;if(!k)l=0;else l=d[k>>1]|0;d[f[c+(j<<2)>>2]>>1]=l;j=j+1|0}while((j|0)!=(h|0));return}j=i>>>1;l=(j<<2)+4|0;if(((j<<1)+2|0)<(g|0))m=0;else{g=0;do{j=f[a+(g<<2)>>2]|0;k=f[c+(g<<2)>>2]|0;n=f[b+(g<<2)>>2]|0;o=f[e+(g<<2)>>2]|0;if(!j){p=o<<1;q=k;r=0;while(1){d[q+(o<<1)>>1]=0;d[q>>1]=0;r=r+2|0;if((r|0)>(i|0))break;else q=q+(p<<1)|0}}else{p=n<<1;q=o<<1;r=j;s=k;t=0;while(1){u=d[r+(n<<1)>>1]|0;d[s>>1]=d[r>>1]|0;d[s+(o<<1)>>1]=u;t=t+2|0;if((t|0)>(i|0))break;else{r=r+(p<<1)|0;s=s+(q<<1)|0}}}g=g+1|0}while((g|0)!=(h|0));return}do{g=f[a+(m<<2)>>2]|0;q=f[c+(m<<2)>>2]|0;s=f[b+(m<<2)>>2]|0;p=f[e+(m<<2)>>2]|0;if(!g){r=p<<1;t=Y(p,l)|0;o=q;n=0;while(1){d[o+(p<<1)>>1]=0;d[o>>1]=0;n=n+2|0;if((n|0)>(i|0))break;else o=o+(r<<1)|0}d[q+t>>1]=0}else{r=s<<1;o=p<<1;n=Y(s,l)|0;k=Y(p,l)|0;j=g;u=q;v=0;while(1){w=d[j+(s<<1)>>1]|0;d[u>>1]=d[j>>1]|0;d[u+(p<<1)>>1]=w;v=v+2|0;if((v|0)>(i|0))break;else{j=j+(r<<1)|0;u=u+(o<<1)|0}}d[q+k>>1]=d[g+n>>1]|0}m=m+1|0}while((m|0)!=(h|0));return}function WQ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((g|0)<=0)return;h=e+-2|0;if((e|0)<2){if((e|0)==1)i=0;else return;do{j=f[a+(i<<2)>>2]|0;if(!j)k=0;else k=f[j>>2]|0;f[f[c+(i<<2)>>2]>>2]=k;i=i+1|0}while((i|0)!=(g|0));return}i=h>>>1;k=(i<<3)+8|0;if(((i<<1)+2|0)<(e|0))l=0;else{e=0;do{i=f[a+(e<<2)>>2]|0;j=f[c+(e<<2)>>2]|0;m=f[b+(e<<2)>>2]|0;n=f[d+(e<<2)>>2]|0;if(!i){o=n<<1;p=j;q=0;while(1){f[p+(n<<2)>>2]=0;f[p>>2]=0;q=q+2|0;if((q|0)>(h|0))break;else p=p+(o<<2)|0}}else{o=m<<1;p=n<<1;q=i;r=j;s=0;while(1){t=f[q+(m<<2)>>2]|0;f[r>>2]=f[q>>2];f[r+(n<<2)>>2]=t;s=s+2|0;if((s|0)>(h|0))break;else{q=q+(o<<2)|0;r=r+(p<<2)|0}}}e=e+1|0}while((e|0)!=(g|0));return}do{e=f[a+(l<<2)>>2]|0;p=f[c+(l<<2)>>2]|0;r=f[b+(l<<2)>>2]|0;o=f[d+(l<<2)>>2]|0;if(!e){q=o<<1;s=Y(o,k)|0;n=p;m=0;while(1){f[n+(o<<2)>>2]=0;f[n>>2]=0;m=m+2|0;if((m|0)>(h|0))break;else n=n+(q<<2)|0}f[p+s>>2]=0}else{q=r<<1;n=o<<1;m=Y(r,k)|0;j=Y(o,k)|0;i=e;t=p;u=0;while(1){v=f[i+(r<<2)>>2]|0;f[t>>2]=f[i>>2];f[t+(o<<2)>>2]=v;u=u+2|0;if((u|0)>(h|0))break;else{i=i+(q<<2)|0;t=t+(n<<2)|0}}f[p+j>>2]=f[e+m>>2]}l=l+1|0}while((l|0)!=(g|0));return}function XQ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;if((g|0)<=0)return;h=e+-2|0;if((e|0)<2){if((e|0)==1)i=0;else return;do{j=f[a+(i<<2)>>2]|0;if(!j){k=0;l=0}else{m=j;k=f[m>>2]|0;l=f[m+4>>2]|0}m=f[c+(i<<2)>>2]|0;f[m>>2]=k;f[m+4>>2]=l;i=i+1|0}while((i|0)!=(g|0));return}i=h>>>1;l=(i<<4)+16|0;if(((i<<1)+2|0)<(e|0))n=0;else{e=0;do{i=f[a+(e<<2)>>2]|0;k=f[c+(e<<2)>>2]|0;m=f[b+(e<<2)>>2]|0;j=f[d+(e<<2)>>2]|0;if(!i){o=j<<1;p=k;q=0;while(1){r=p+(j<<3)|0;f[r>>2]=0;f[r+4>>2]=0;r=p;f[r>>2]=0;f[r+4>>2]=0;q=q+2|0;if((q|0)>(h|0))break;else p=p+(o<<3)|0}}else{o=m<<1;p=j<<1;q=i;r=k;s=0;while(1){t=q;u=f[t+4>>2]|0;v=q+(m<<3)|0;w=f[v>>2]|0;x=f[v+4>>2]|0;v=r;f[v>>2]=f[t>>2];f[v+4>>2]=u;u=r+(j<<3)|0;f[u>>2]=w;f[u+4>>2]=x;s=s+2|0;if((s|0)>(h|0))break;else{q=q+(o<<3)|0;r=r+(p<<3)|0}}}e=e+1|0}while((e|0)!=(g|0));return}do{e=f[a+(n<<2)>>2]|0;p=f[c+(n<<2)>>2]|0;r=f[b+(n<<2)>>2]|0;o=f[d+(n<<2)>>2]|0;if(!e){q=o<<1;s=Y(o,l)|0;j=p;m=0;while(1){k=j+(o<<3)|0;f[k>>2]=0;f[k+4>>2]=0;k=j;f[k>>2]=0;f[k+4>>2]=0;m=m+2|0;if((m|0)>(h|0))break;else j=j+(q<<3)|0}q=p+s|0;f[q>>2]=0;f[q+4>>2]=0}else{q=r<<1;j=o<<1;m=Y(r,l)|0;k=Y(o,l)|0;i=e;x=p;u=0;while(1){w=i;v=f[w+4>>2]|0;t=i+(r<<3)|0;y=f[t>>2]|0;z=f[t+4>>2]|0;t=x;f[t>>2]=f[w>>2];f[t+4>>2]=v;v=x+(o<<3)|0;f[v>>2]=y;f[v+4>>2]=z;u=u+2|0;if((u|0)>(h|0))break;else{i=i+(q<<3)|0;x=x+(j<<3)|0}}j=e+m|0;x=f[j+4>>2]|0;q=p+k|0;f[q>>2]=f[j>>2];f[q+4>>2]=x}n=n+1|0}while((n|0)!=(g|0));return}function YQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=0;do{f[a+8+(d*56|0)>>2]=1124007936;e=a+8+(d*56|0)+8|0;g=a+8+(d*56|0)+40|0;h=a+8+(d*56|0)+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;j=a+8+(d*56|0)+48|0;f[a+8+(d*56|0)+44>>2]=j;f[j>>2]=0;f[a+8+(d*56|0)+52>>2]=0;d=d+1|0}while((d|0)!=26);f[a>>2]=c;c=a+4|0;f[c>>2]=26;if(b>>>0<=26){f[c>>2]=b;return}_Q(a);f[c>>2]=b;c=b*56|0;d=XDc(b>>>0>76695844|c>>>0>4294967291?-1:c+4|0)|0;f[d>>2]=b;c=d+4|0;d=c+(b*56|0)|0;b=c;do{f[b>>2]=1124007936;j=b+8|0;k=b+40|0;h=b+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[k>>2]=j;e=b+48|0;f[b+44>>2]=e;f[e>>2]=0;f[b+52>>2]=0;b=b+56|0}while((b|0)!=(d|0));f[a>>2]=c;return}function ZQ(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;_Q(a);b=a+8|0;c=a+1464|0;do{a=c;c=c+-56|0;d=a+-20|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)_S(c);f[d>>2]=0;d=a+-40|0;e=a+-52|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[a+-16>>2]|0;g=0;do{f[d+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[e>>2]|0))}e=f[a+-12>>2]|0;if((e|0)!=(a+-8|0))g0(e)}while((c|0)!=(b|0));return}function _Q(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;c=a+8|0;if((b|0)==(c|0))return;if(b|0){d=b+-4|0;e=f[d>>2]|0;if(e|0){g=b+(e*56|0)|0;do{e=g;g=g+-56|0;h=e+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)_S(g);f[h>>2]=0;h=e+-40|0;i=e+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[e+-16>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[e+-12>>2]|0;if((i|0)!=(e+-8|0))g0(i)}while((g|0)!=(b|0))}ZDc(d)}f[a>>2]=c;f[a+4>>2]=26;return}function $Q(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+1520|0;g=e+56|0;h=e;i=d+4|0;if((f[d>>2]|0)==(f[i>>2]|0)){u=e;return}if(((d$(a)|0)!=327680?(d$(a)|0)!=983040:0)?(d$(a)|0)!=262144:0)j=(d$(a)|0)!=720896;else j=0;if(((d$(c)|0)!=327680?(d$(c)|0)!=983040:0)?(d$(c)|0)!=262144:0)k=(d$(c)|0)!=720896;else k=0;if(j)l=1;else l=o$(a,-1)|0;if(k)m=1;else m=o$(c,-1)|0;if(!((m|0)>0&((l|0)>0?((f[i>>2]|0)-(f[d>>2]|0)&4|0)==0:0))){f[g>>2]=0;f[g+4>>2]=0;n=tT(g,44)|0;o=216291;p=n+44|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));TQ(g,216127,328)}YQ(g,m+l|0);o=f[g>>2]|0;n=a+4|0;p=h+4|0;q=h+8|0;r=h+12|0;s=h+16|0;t=h+20|0;v=h+24|0;w=h+28|0;x=h+32|0;y=h+36|0;z=h+40|0;A=h+48|0;B=h+44|0;C=h+52|0;D=0;do{E=j?-1:D;do if((E|0)<0&(d$(a)|0)==65536){F=f[n>>2]|0;f[h>>2]=f[F>>2];G=F+4|0;f[p>>2]=f[G>>2];f[q>>2]=f[F+8>>2];f[r>>2]=f[F+12>>2];f[s>>2]=f[F+16>>2];f[t>>2]=f[F+20>>2];f[v>>2]=f[F+24>>2];f[w>>2]=f[F+28>>2];f[x>>2]=f[F+32>>2];H=f[F+36>>2]|0;f[y>>2]=H;f[z>>2]=q;f[B>>2]=A;f[A>>2]=0;f[C>>2]=0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[G>>2]|0)<3){G=f[F+44>>2]|0;I=f[B>>2]|0;f[I>>2]=f[G>>2];f[I+4>>2]=f[G+4>>2];break}else{f[p>>2]=0;ZS(h,F);break}}else a$(h,a,E);while(0);E=o+(D*56|0)|0;if((E|0)!=(h|0)){F=f[y>>2]|0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}G=o+(D*56|0)+36|0;F=f[G>>2]|0;if(F|0?(I=F+12|0,F=f[I>>2]|0,f[I>>2]=F+-1,(F|0)==1):0)_S(E);f[G>>2]=0;F=o+(D*56|0)+16|0;I=o+(D*56|0)+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[I>>2]|0)>0){H=f[o+(D*56|0)+40>>2]|0;J=0;do{f[H+(J<<2)>>2]=0;J=J+1|0;K=f[I>>2]|0}while((J|0)<(K|0));f[E>>2]=f[h>>2];if((K|0)<3)L=36;else L=38}else{f[E>>2]=f[h>>2];L=36}if((L|0)==36){L=0;J=f[p>>2]|0;if((J|0)<3){f[I>>2]=J;f[o+(D*56|0)+8>>2]=f[q>>2];f[o+(D*56|0)+12>>2]=f[r>>2];J=f[B>>2]|0;H=f[o+(D*56|0)+44>>2]|0;f[H>>2]=f[J>>2];f[H+4>>2]=f[J+4>>2]}else L=38}if((L|0)==38){L=0;ZS(E,h)}f[F>>2]=f[s>>2];f[o+(D*56|0)+20>>2]=f[t>>2];f[o+(D*56|0)+24>>2]=f[v>>2];f[o+(D*56|0)+28>>2]=f[w>>2];f[o+(D*56|0)+32>>2]=f[x>>2];f[G>>2]=f[y>>2]}J=f[y>>2]|0;if(J|0?(H=J+12|0,J=f[H>>2]|0,f[H>>2]=J+-1,(J|0)==1):0)_S(h);f[y>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[p>>2]|0)>0){J=f[z>>2]|0;H=0;do{f[J+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[p>>2]|0))}H=f[B>>2]|0;if((H|0)!=(A|0))g0(H);D=D+1|0}while((D|0)<(l|0));D=c+4|0;A=h+4|0;B=h+8|0;p=h+12|0;z=h+16|0;s=h+20|0;y=h+24|0;x=h+28|0;w=h+32|0;v=h+36|0;t=h+40|0;r=h+48|0;q=h+44|0;K=h+52|0;a=0;do{C=k?-1:a;do if((C|0)<0&(d$(c)|0)==65536){n=f[D>>2]|0;f[h>>2]=f[n>>2];j=n+4|0;f[A>>2]=f[j>>2];f[B>>2]=f[n+8>>2];f[p>>2]=f[n+12>>2];f[z>>2]=f[n+16>>2];f[s>>2]=f[n+20>>2];f[y>>2]=f[n+24>>2];f[x>>2]=f[n+28>>2];f[w>>2]=f[n+32>>2];H=f[n+36>>2]|0;f[v>>2]=H;f[t>>2]=B;f[q>>2]=r;f[r>>2]=0;f[K>>2]=0;if(H|0){J=H+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[j>>2]|0)<3){j=f[n+44>>2]|0;J=f[q>>2]|0;f[J>>2]=f[j>>2];f[J+4>>2]=f[j+4>>2];break}else{f[A>>2]=0;ZS(h,n);break}}else a$(h,c,C);while(0);C=a+l|0;n=o+(C*56|0)|0;if((n|0)!=(h|0)){j=f[v>>2]|0;if(j|0){J=j+12|0;f[J>>2]=(f[J>>2]|0)+1}J=o+(C*56|0)+36|0;j=f[J>>2]|0;if(j|0?(H=j+12|0,j=f[H>>2]|0,f[H>>2]=j+-1,(j|0)==1):0)_S(n);f[J>>2]=0;j=o+(C*56|0)+16|0;H=o+(C*56|0)+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[H>>2]|0)>0){G=f[o+(C*56|0)+40>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0;M=f[H>>2]|0}while((F|0)<(M|0));f[n>>2]=f[h>>2];if((M|0)<3)L=67;else L=69}else{f[n>>2]=f[h>>2];L=67}if((L|0)==67){L=0;F=f[A>>2]|0;if((F|0)<3){f[H>>2]=F;f[o+(C*56|0)+8>>2]=f[B>>2];f[o+(C*56|0)+12>>2]=f[p>>2];F=f[q>>2]|0;G=f[o+(C*56|0)+44>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2]}else L=69}if((L|0)==69){L=0;ZS(n,h)}f[j>>2]=f[z>>2];f[o+(C*56|0)+20>>2]=f[s>>2];f[o+(C*56|0)+24>>2]=f[y>>2];f[o+(C*56|0)+28>>2]=f[x>>2];f[o+(C*56|0)+32>>2]=f[w>>2];f[J>>2]=f[v>>2]}F=f[v>>2]|0;if(F|0?(G=F+12|0,F=f[G>>2]|0,f[G>>2]=F+-1,(F|0)==1):0)_S(h);f[v>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[A>>2]|0)>0){F=f[t>>2]|0;G=0;do{f[F+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[A>>2]|0))}G=f[q>>2]|0;if((G|0)!=(r|0))g0(G);a=a+1|0}while((a|0)<(m|0));a=f[d>>2]|0;SQ(o,l,o+(l*56|0)|0,m,a,(f[i>>2]|0)-a>>2>>>1);ZQ(g);u=e;return}function aR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+128|0;g=e+112|0;h=e+56|0;i=e;j=c$(a,-1)|0;k=j&7;if((d|0)<=-1){f[g>>2]=0;l=g+4|0;f[l>>2]=0;m=tT(g,20)|0;n=m;o=216336;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));TQ(g,216357,425)}if((j>>>3&511|0)<(d|0)){f[g>>2]=0;l=g+4|0;f[l>>2]=0;m=tT(g,20)|0;n=m;o=216336;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));TQ(g,216357,425)}f[g>>2]=d;f[g+4>>2]=0;do if((d$(a)|0)==65536){d=f[a+4>>2]|0;f[h>>2]=f[d>>2];o=h+4|0;n=d+4|0;f[o>>2]=f[n>>2];p=h+8|0;f[p>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];f[h+16>>2]=f[d+16>>2];f[h+20>>2]=f[d+20>>2];f[h+24>>2]=f[d+24>>2];f[h+28>>2]=f[d+28>>2];f[h+32>>2]=f[d+32>>2];m=f[d+36>>2]|0;f[h+36>>2]=m;l=h+40|0;f[l>>2]=p;p=h+48|0;j=h+44|0;f[j>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(m|0){p=m+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[n>>2]|0)<3){n=f[d+44>>2]|0;p=f[j>>2]|0;f[p>>2]=f[n>>2];f[p+4>>2]=f[n+4>>2];q=l;r=o;break}else{f[o>>2]=0;ZS(h,d);q=l;r=o;break}}else{a$(h,a,-1);q=h+40|0;r=h+4|0}while(0);w$(c,f[r>>2]|0,f[q>>2]|0,k,-1,0,0);do if((d$(c)|0)==65536){k=f[c+4>>2]|0;f[i>>2]=f[k>>2];a=i+4|0;o=k+4|0;f[a>>2]=f[o>>2];l=i+8|0;f[l>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];f[i+16>>2]=f[k+16>>2];f[i+20>>2]=f[k+20>>2];f[i+24>>2]=f[k+24>>2];f[i+28>>2]=f[k+28>>2];f[i+32>>2]=f[k+32>>2];d=f[k+36>>2]|0;f[i+36>>2]=d;f[i+40>>2]=l;l=i+48|0;n=i+44|0;f[n>>2]=l;f[l>>2]=0;f[i+52>>2]=0;if(d|0){l=d+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[o>>2]|0)<3){o=f[k+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[o>>2];f[l+4>>2]=f[o+4>>2];break}else{f[a>>2]=0;ZS(i,k);break}}else a$(i,c,-1);while(0);SQ(h,1,i,1,g,1);g=i+36|0;c=f[g>>2]|0;if(c|0?(k=c+12|0,c=f[k>>2]|0,f[k>>2]=c+-1,(c|0)==1):0)_S(i);f[g>>2]=0;g=i+16|0;c=i+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[c>>2]|0)>0){g=f[i+40>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[c>>2]|0))}c=f[i+44>>2]|0;if((c|0)!=(i+48|0))g0(c);c=h+36|0;i=f[c>>2]|0;if(i|0?(k=i+12|0,i=f[k>>2]|0,f[k>>2]=i+-1,(i|0)==1):0)_S(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[r>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[r>>2]|0))}r=f[h+44>>2]|0;if((r|0)==(h+48|0)){u=e;return}g0(r);u=e;return}function bR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=c;c=a+4|0;d=b+4|0;e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=a+8|0;d=b+8|0;c=f[e>>2]|0;f[e>>2]=f[d>>2];f[d>>2]=c;c=a+12|0;g=b+12|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+16|0;g=b+16|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+20|0;g=b+20|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+24|0;g=b+24|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+28|0;g=b+28|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+32|0;g=b+32|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+36|0;g=b+36|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+40|0;g=b+40|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+44|0;i=b+44|0;j=f[c>>2]|0;f[c>>2]=f[i>>2];f[i>>2]=j;k=a+48|0;l=b+48|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;m=a+52|0;a=b+52|0;b=f[m>>2]|0;f[m>>2]=f[a>>2];f[a>>2]=b;if((f[c>>2]|0)==(l|0)){f[c>>2]=k;f[h>>2]=e;n=f[i>>2]|0}else n=j;if((n|0)!=(k|0))return;f[i>>2]=l;f[g>>2]=d;return}function cR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;if(!((a|0)!=0&(c|0)!=0)){u$(d);u=e;return}j=a+8|0;k=0;l=0;while(1){if((f[a+(k*56|0)+4>>2]|0)>=3){m=15;break}n=f[a+(k*56|0)+8>>2]|0;if((n|0)!=(f[j>>2]|0)){m=15;break}o=f[a>>2]|0;if((o^f[a+(k*56|0)>>2])&4095|0){m=15;break}l=(f[a+(k*56|0)+12>>2]|0)+l|0;k=k+1|0;if(k>>>0>=c>>>0){m=4;break}}if((m|0)==4){Y$(d,n,l,o&4095,-1,0,0);do if((d$(d)|0)==65536){o=f[d+4>>2]|0;f[g>>2]=f[o>>2];l=g+4|0;n=o+4|0;f[l>>2]=f[n>>2];k=g+8|0;f[k>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];j=f[o+36>>2]|0;f[g+36>>2]=j;f[g+40>>2]=k;k=g+48|0;p=g+44|0;f[p>>2]=k;f[k>>2]=0;f[g+52>>2]=0;if(j|0){k=j+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[n>>2]|0)<3){n=f[o+44>>2]|0;k=f[p>>2]|0;f[k>>2]=f[n>>2];f[k+4>>2]=f[n+4>>2];break}else{f[l>>2]=0;ZS(g,o);break}}else a$(g,d,-1);while(0);d=i+4|0;o=i+8|0;l=i+12|0;n=i+8|0;k=i+4|0;p=h+36|0;j=h+16|0;q=h+4|0;r=h+40|0;s=h+44|0;t=h+48|0;v=0;w=0;while(1){x=a+(w*56|0)+12|0;y=f[x>>2]|0;z=f[a+(w*56|0)+8>>2]|0;f[i>>2]=v;f[d>>2]=0;f[o>>2]=y;f[l>>2]=z;cT(h,g,i);z=n;f[z>>2]=0;f[z+4>>2]=0;f[i>>2]=33619968;f[k>>2]=h;h_(a+(w*56|0)|0,i);z=f[x>>2]|0;x=f[p>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)_S(h);f[p>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){x=f[r>>2]|0;y=0;do{f[x+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[q>>2]|0))}y=f[s>>2]|0;if((y|0)!=(t|0))g0(y);w=w+1|0;if(w>>>0>=c>>>0)break;else v=z+v|0}v=g+36|0;c=f[v>>2]|0;if(c|0?(w=c+12|0,c=f[w>>2]|0,f[w>>2]=c+-1,(c|0)==1):0)_S(g);f[v>>2]=0;v=g+16|0;c=g+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[c>>2]|0)>0){v=f[g+40>>2]|0;w=0;do{f[v+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))g0(c);u=e;return}else if((m|0)==15){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,80)|0;e=216372;c=m+80|0;do{b[m>>0]=b[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(c|0));dR(-215,g,216453,63)}}function dR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,216461,d);return}function eR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;f$(a,d);a=f[d>>2]|0;g=f[e>>2]|0;cR((a|0)==(g|0)?0:a,(g-a|0)/56|0,b);mx(d);u=c;return}function fR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;if(!((a|0)!=0&(c|0)!=0)){u$(d);u=e;return}j=a+12|0;k=0;l=0;while(1){if((f[a+(k*56|0)+4>>2]|0)>=3){m=15;break}n=f[a+(k*56|0)+12>>2]|0;if((n|0)!=(f[j>>2]|0)){m=15;break}o=f[a>>2]|0;if((o^f[a+(k*56|0)>>2])&4095|0){m=15;break}l=(f[a+(k*56|0)+8>>2]|0)+l|0;k=k+1|0;if(k>>>0>=c>>>0){m=4;break}}if((m|0)==4){Y$(d,l,n,o&4095,-1,0,0);do if((d$(d)|0)==65536){o=f[d+4>>2]|0;f[g>>2]=f[o>>2];n=g+4|0;l=o+4|0;f[n>>2]=f[l>>2];k=g+8|0;f[k>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];j=f[o+36>>2]|0;f[g+36>>2]=j;f[g+40>>2]=k;k=g+48|0;p=g+44|0;f[p>>2]=k;f[k>>2]=0;f[g+52>>2]=0;if(j|0){k=j+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[l>>2]|0)<3){l=f[o+44>>2]|0;k=f[p>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];break}else{f[n>>2]=0;ZS(g,o);break}}else a$(g,d,-1);while(0);d=i+4|0;o=i+8|0;n=i+12|0;l=i+8|0;k=i+4|0;p=h+36|0;j=h+16|0;q=h+4|0;r=h+40|0;s=h+44|0;t=h+48|0;v=0;w=0;while(1){x=f[a+(w*56|0)+12>>2]|0;y=a+(w*56|0)+8|0;z=f[y>>2]|0;f[i>>2]=0;f[d>>2]=v;f[o>>2]=x;f[n>>2]=z;cT(h,g,i);z=l;f[z>>2]=0;f[z+4>>2]=0;f[i>>2]=33619968;f[k>>2]=h;h_(a+(w*56|0)|0,i);z=f[y>>2]|0;y=f[p>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)_S(h);f[p>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){y=f[r>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[q>>2]|0))}x=f[s>>2]|0;if((x|0)!=(t|0))g0(x);w=w+1|0;if(w>>>0>=c>>>0)break;else v=z+v|0}v=g+36|0;c=f[v>>2]|0;if(c|0?(w=c+12|0,c=f[w>>2]|0,f[w>>2]=c+-1,(c|0)==1):0)_S(g);f[v>>2]=0;v=g+16|0;c=g+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[c>>2]|0)>0){v=f[g+40>>2]|0;w=0;do{f[v+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))g0(c);u=e;return}else if((m|0)==15){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,80)|0;e=216537;c=m+80|0;do{b[m>>0]=b[e>>0]|0;m=m+1|0;e=e+1|0}while((m|0)<(c|0));dR(-215,g,216618,108)}}function gR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;f$(a,d);a=f[d>>2]|0;g=f[e>>2]|0;fR((a|0)==(g|0)?0:a,(g-a|0)/56|0,b);mx(d);u=c;return}function hR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0;d=u;u=u+144|0;e=d+88|0;g=d;h=d+32|0;if((n$(a,-1)|0)>=3){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,14)|0;j=216626;k=i+14|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));dR(-215,e,216641,184)}do if((d$(a)|0)==65536){j=f[a+4>>2]|0;f[e>>2]=f[j>>2];i=e+4|0;k=j+4|0;f[i>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[j+8>>2];m=e+12|0;f[m>>2]=f[j+12>>2];f[e+16>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=l;q=e+48|0;r=e+44|0;f[r>>2]=q;f[q>>2]=0;f[e+52>>2]=0;if(o|0){q=o+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[k>>2]|0)<3){k=f[j+44>>2]|0;q=f[r>>2]|0;f[q>>2]=f[k>>2];f[q+4>>2]=f[k+4>>2];s=m;t=e;v=l;break}else{f[i>>2]=0;ZS(e,j);s=m;t=e;v=l;break}}else{a$(e,a,-1);s=e+12|0;t=e;v=e+8|0}while(0);a=f[v>>2]|0;v=f[s>>2]|0;a:do switch(f[t>>2]&4095){case 5:{s=f[e+16>>2]|0;w=+p[c>>3];l=(f[e+48>>2]|0)>>>2;if((a|0)>0){if((v|0)<=0){m=0;j=s;while(1){if((m|0)<(v|0))n[j+(m<<2)>>2]=w;m=m+1|0;if((m|0)==(a|0))break a;else j=j+(l<<2)|0}}j=v<<2;m=0;i=s;while(1){XIc(s+((Y(l,m)|0)<<2)|0,0,j|0)|0;if((m|0)<(v|0))n[i+(m<<2)>>2]=w;m=m+1|0;if((m|0)==(a|0))break;else i=i+(l<<2)|0}}break}case 6:{w=+p[c>>3];l=(f[e+48>>2]|0)>>>3;if((a|0)>0&(v|0)>0){i=0;m=f[e+16>>2]|0;while(1){j=0;do{p[m+(j<<3)>>3]=(j|0)==(i|0)?w:0.0;j=j+1|0}while((j|0)!=(v|0));i=i+1|0;if((i|0)==(a|0))break;else m=m+(l<<3)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;k_(e,g)|0;gT(h,e,0);k_(h,c)|0;l=h+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)_S(h);f[l>>2]=0;l=h+16|0;m=h+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[h+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[h+44>>2]|0;if((m|0)!=(h+48|0))g0(m)}}while(0);h=e+36|0;c=f[h>>2]|0;if(c|0?(g=c+12|0,c=f[g>>2]|0,f[g>>2]=c+-1,(c|0)==1):0)_S(e);f[h>>2]=0;h=e+16|0;c=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[c>>2]|0)>0){h=f[e+40>>2]|0;g=0;do{f[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[c>>2]|0))}c=f[e+44>>2]|0;if((c|0)==(e+48|0)){u=d;return}g0(c);u=d;return}function iR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0.0;d=u;u=u+128|0;e=d+72|0;g=d+56|0;h=d;do if((d$(c)|0)==65536){i=f[c+4>>2]|0;f[e>>2]=f[i>>2];j=e+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[e+36>>2]=m;f[e+40>>2]=l;l=e+48|0;o=e+44|0;f[o>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];q=j;break}else{f[j>>2]=0;ZS(e,i);q=j;break}}else{a$(e,c,-1);q=e+4|0}while(0);if((f[q>>2]|0)>=3){f[g>>2]=0;f[g+4>>2]=0;c=tT(g,11)|0;j=249001;i=c+11|0;do{b[c>>0]=b[j>>0]|0;c=c+1|0;j=j+1|0}while((c|0)<(i|0));dR(-215,g,216653,232)}j=f[e+12>>2]|0;c=f[e+8>>2]|0;i=(j|0)<(c|0)?j:c;switch(f[e>>2]&4095){case 5:{c=f[e+16>>2]|0;j=((f[e+48>>2]|0)>>>2)+1|0;if((i|0)>0){k=0;r=0.0;while(1){l=c+((Y(k,j)|0)<<2)|0;s=r+ +n[l>>2];k=k+1|0;if((k|0)>=(i|0)){t=s;break}else r=s}}else t=0.0;p[a>>3]=t;k=a+8|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;break}case 6:{k=f[e+16>>2]|0;j=((f[e+48>>2]|0)>>>3)+1|0;if((i|0)>0){t=0.0;c=0;while(1){l=k+((Y(c,j)|0)<<3)|0;r=t+ +p[l>>3];c=c+1|0;if((c|0)>=(i|0)){v=r;break}else t=r}}else v=0.0;p[a>>3]=v;i=a+8|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;break}default:{gT(h,e,0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=h;L6(a,g);g=h+36|0;a=f[g>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(h);f[g>>2]=0;g=h+16|0;a=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[a>>2]|0)>0){g=f[h+40>>2]|0;i=0;do{f[g+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))g0(a)}}a=e+36|0;h=f[a>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)_S(e);f[a>>2]=0;a=e+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){a=f[e+40>>2]|0;h=0;do{f[a+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[q>>2]|0))}q=f[e+44>>2]|0;if((q|0)==(e+48|0)){u=d;return}g0(q);u=d;return}function jR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+144|0;e=d+80|0;g=d+24|0;h=d;i=d+16|0;j=c$(a,-1)|0;k=(j>>>3&511)+1<<(47696>>>(j<<1&14)&3);if(!((n$(a,-1)|0)<3&(k|0)<33)){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,29)|0;m=216659;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));dR(-215,e,216689,498)}do if((d$(a)|0)==65536){j=f[a+4>>2]|0;f[e>>2]=f[j>>2];o=e+4|0;p=j+4|0;f[o>>2]=f[p>>2];q=e+8|0;f[q>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];r=e+16|0;f[r>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];s=f[j+36>>2]|0;f[e+36>>2]=s;f[e+40>>2]=q;q=e+48|0;t=e+44|0;f[t>>2]=q;f[q>>2]=0;f[e+52>>2]=0;if(s|0){q=s+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[j+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];v=r;break}else{f[o>>2]=0;ZS(e,j);v=r;break}}else{a$(e,a,-1);v=e+16|0}while(0);if(f[v>>2]|0){a=f[e+4>>2]|0;if((a|0)<3)w=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{r=f[e+40>>2]|0;j=0;o=1;while(1){p=Y(f[r+(j<<2)>>2]|0,o)|0;j=j+1|0;if((j|0)==(a|0)){w=p;break}else o=p}}if(!((a|0)==0|(w|0)==0)){w=e+12|0;a=e+8|0;Y$(c,f[w>>2]|0,f[a>>2]|0,f[e>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){o=f[c+4>>2]|0;f[g>>2]=f[o>>2];j=g+4|0;r=o+4|0;f[j>>2]=f[r>>2];p=g+8|0;f[p>>2]=f[o+8>>2];q=g+12|0;f[q>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];t=f[o+36>>2]|0;f[g+36>>2]=t;f[g+40>>2]=p;p=g+48|0;s=g+44|0;f[s>>2]=p;f[p>>2]=0;f[g+52>>2]=0;if(t|0){p=t+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[r>>2]|0)<3){r=f[o+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[r>>2];f[p+4>>2]=f[r+4>>2];x=q;break}else{f[j>>2]=0;ZS(g,o);x=q;break}}else{a$(g,c,-1);x=g+12|0}while(0);q=f[a>>2]|0;do if((q|0)==(f[x>>2]|0)?(a=f[w>>2]|0,(a|0)==(f[g+8>>2]|0)):0){o=f[g+16>>2]|0;j=f[v>>2]|0;if((o|0)!=(j|0)){r=f[41876+(k<<2)>>2]|0;if(!r){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,9)|0;m=251213;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));dR(-215,h,216689,533)}else{p=f[e+48>>2]|0;s=f[g+48>>2]|0;t=f[e+40>>2]|0;y=f[t>>2]|0;f[i>>2]=f[t+4>>2];f[i+4>>2]=y;gi[r&255](j,p,o,s,i);break}}s=f[41744+(k<<2)>>2]|0;if(!s){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,9)|0;m=251213;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));dR(-215,h,216689,526)}if((q|0)==(a|0)){Ti[s&511](o,f[g+48>>2]|0,q);break}else{f[h>>2]=0;f[h+4>>2]=0;l=tT(h,20)|0;m=376326;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));dR(-215,h,216689,527)}}else z=26;while(0);do if((z|0)==26){k=f[e+40>>2]|0;i=f[g+40>>2]|0;if(!((f[k>>2]|0)==(f[i>>2]|0)?(f[k+4>>2]|0)==(f[i+4>>2]|0):0)){f[h>>2]=0;A=h+4|0;f[A>>2]=0;B=tT(h,60)|0;l=B;m=216699;n=l+60|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));dR(-215,h,216689,516)}if((f[w>>2]|0)==1|(q|0)==1){i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;h_(e,h);break}else{f[h>>2]=0;A=h+4|0;f[A>>2]=0;B=tT(h,60)|0;l=B;m=216699;n=l+60|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));dR(-215,h,216689,516)}}while(0);h=g+36|0;m=f[h>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)_S(g);f[h>>2]=0;h=g+16|0;m=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[m>>2]|0)>0){h=f[g+40>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[g+44>>2]|0;if((m|0)!=(g+48|0))g0(m)}else z=16}else z=16;if((z|0)==16)u$(c);c=e+36|0;z=f[c>>2]|0;if(z|0?(m=z+12|0,z=f[m>>2]|0,f[m>>2]=z+-1,(z|0)==1):0)_S(e);f[c>>2]=0;c=e+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[c>>2]|0)>0){v=f[e+40>>2]|0;z=0;do{f[v+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=f[e+44>>2]|0;if((c|0)==(e+48|0)){u=d;return}g0(c);u=d;return}function kR(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=d+(Y(l,e)|0)|0;n=d+(Y(l|1,e)|0)|0;o=d+(Y(l|2,e)|0)|0;p=d+(Y(l|3,e)|0)|0;q=a+l|0;r=0;do{s=q+(Y(r,c)|0)|0;b[m+r>>0]=b[s>>0]|0;b[n+r>>0]=b[s+1>>0]|0;b[o+r>>0]=b[s+2>>0]|0;b[p+r>>0]=b[s+3>>0]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=d+(Y(p,e)|0)|0;n=d+(Y(p|1,e)|0)|0;m=d+(Y(p|2,e)|0)|0;q=d+(Y(p|3,e)|0)|0;s=a+p|0;t=0;do{u=s+(Y(t,c)|0)|0;v=t|1;w=s+(Y(v,c)|0)|0;x=t|2;y=s+(Y(x,c)|0)|0;z=t|3;A=s+(Y(z,c)|0)|0;b[o+t>>0]=b[u>>0]|0;b[o+v>>0]=b[w>>0]|0;b[o+x>>0]=b[y>>0]|0;b[o+z>>0]=b[A>>0]|0;b[n+t>>0]=b[u+1>>0]|0;b[n+v>>0]=b[w+1>>0]|0;b[n+x>>0]=b[y+1>>0]|0;b[n+z>>0]=b[A+1>>0]|0;b[m+t>>0]=b[u+2>>0]|0;b[m+v>>0]=b[w+2>>0]|0;b[m+x>>0]=b[y+2>>0]|0;b[m+z>>0]=b[A+2>>0]|0;b[q+t>>0]=b[u+3>>0]|0;b[q+v>>0]=b[w+3>>0]|0;b[q+x>>0]=b[y+3>>0]|0;b[q+z>>0]=b[A+3>>0]|0;t=t+4|0}while((t|0)<=(k|0));if(r){t=l;do{A=s+(Y(t,c)|0)|0;b[o+t>>0]=b[A>>0]|0;b[n+t>>0]=b[A+1>>0]|0;b[m+t>>0]=b[A+2>>0]|0;b[q+t>>0]=b[A+3>>0]|0;t=t+1|0}while((t|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)B=j;else return;do{p=d+(Y(B,e)|0)|0;l=a+B|0;r=0;do{k=l+(Y(r,c)|0)|0;b[p+r>>0]=b[k>>0]|0;r=r+1|0}while((r|0)!=(i|0));B=B+1|0}while((B|0)!=(h|0));return}B=i&-4;if((B|0)<(i|0))C=j;else{r=j;do{j=d+(Y(r,e)|0)|0;p=a+r|0;l=0;do{k=p+(Y(l,c)|0)|0;t=l|1;q=p+(Y(t,c)|0)|0;m=l|2;n=p+(Y(m,c)|0)|0;o=l|3;s=p+(Y(o,c)|0)|0;b[j+l>>0]=b[k>>0]|0;b[j+t>>0]=b[q>>0]|0;b[j+m>>0]=b[n>>0]|0;b[j+o>>0]=b[s>>0]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=d+(Y(C,e)|0)|0;l=a+C|0;j=0;do{p=l+(Y(j,c)|0)|0;s=j|1;o=l+(Y(s,c)|0)|0;n=j|2;m=l+(Y(n,c)|0)|0;q=j|3;t=l+(Y(q,c)|0)|0;b[r+j>>0]=b[p>>0]|0;b[r+s>>0]=b[o>>0]|0;b[r+n>>0]=b[m>>0]|0;b[r+q>>0]=b[t>>0]|0;j=j+4|0}while((j|0)<=(g|0));D=B;do{j=l+(Y(D,c)|0)|0;b[r+D>>0]=b[j>>0]|0;D=D+1|0}while((D|0)!=(i|0));C=C+1|0}while((C|0)!=(h|0));return}
function OHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+64|0;g=e+8|0;h=e;i=e+56|0;j=e+52|0;k=e+48|0;l=e+44|0;m=e+28|0;o=e+40|0;p=e+36|0;q=e+32|0;r=f[b>>2]|0;s=f[c>>2]|0;if((r|0)==(s|0)){u=e;return}t=f[b>>2]|0;b=s;s=r;a:while(1){r=b+-28|0;v=r;w=(s|0)==(b|0);x=b;y=b+-28|0;z=y;A=b+-12|0;B=b+-24|0;C=b+-20|0;D=f[a>>2]|0;b:while(1){E=D;F=x-D|0;G=(F|0)/28|0;switch(G|0){case 2:{H=5;break a;break}case 3:{H=7;break a;break}case 1:case 0:{H=67;break a;break}default:{}}if((F|0)<224){H=9;break a}F=G>>>1;G=E+(F*28|0)|0;f[m>>2]=G;f[o>>2]=D;f[p>>2]=G;f[q>>2]=v;f[i>>2]=f[o>>2];f[h>>2]=f[p>>2];f[g>>2]=f[q>>2];I=PHb(i,h,g,d)|0;f[h>>2]=v;J=+n[E+(F*28|0)+16>>2];if(+n[E+16>>2]>J){K=I;L=r;break}else M=r;while(1){N=M+-28|0;f[h>>2]=N;if((E|0)==(N|0))break;if(+n[M+-12>>2]>J){H=40;break b}else M=N}F=E+28|0;G=F;f[h>>2]=z;if(+n[E+16>>2]>+n[A>>2]){O=y;P=G}else{if((F|0)==(y|0)){H=65;break a}J=+n[E+16>>2];Q=G;G=F;while(1){if(J>+n[G+16>>2])break;F=G+28|0;if((F|0)==(y|0)){H=65;break a}else{Q=F;G=F}}F=Q;R=f[F>>2]|0;S=G+4|0;T=f[S>>2]|0;U=G+8|0;f[g>>2]=f[U>>2];f[g+4>>2]=f[U+4>>2];f[g+8>>2]=f[U+8>>2];f[g+12>>2]=f[U+12>>2];f[g+16>>2]=f[U+16>>2];f[F>>2]=f[y>>2];f[S>>2]=f[B>>2];f[U>>2]=f[C>>2];f[U+4>>2]=f[C+4>>2];f[U+8>>2]=f[C+8>>2];f[U+12>>2]=f[C+12>>2];f[U+16>>2]=f[C+16>>2];f[y>>2]=R;f[B>>2]=T;f[C>>2]=f[g>>2];f[C+4>>2]=f[g+4>>2];f[C+8>>2]=f[g+8>>2];f[C+12>>2]=f[g+12>>2];f[C+16>>2]=f[g+16>>2];O=f[h>>2]|0;P=G+28|0}if((P|0)==(O|0)){H=65;break a}T=(f[a>>2]|0)+16|0;R=P;while(1){U=R;J=+n[T>>2];if(J>+n[U+16>>2]){V=U;W=R}else{S=U;do{U=S;S=S+28|0}while(!(J>+n[U+44>>2]));V=S;W=S}U=f[h>>2]|0;while(1){X=U+-28|0;f[h>>2]=X;if(J>+n[U+-12>>2])U=X;else break}if(V>>>0>=X>>>0)break;S=W;F=f[S>>2]|0;Y=V+4|0;Z=f[Y>>2]|0;_=V+8|0;f[g>>2]=f[_>>2];f[g+4>>2]=f[_+4>>2];f[g+8>>2]=f[_+8>>2];f[g+12>>2]=f[_+12>>2];f[g+16>>2]=f[_+16>>2];f[S>>2]=f[X>>2];S=U+-24|0;f[Y>>2]=f[S>>2];Y=U+-20|0;f[_>>2]=f[Y>>2];f[_+4>>2]=f[Y+4>>2];f[_+8>>2]=f[Y+8>>2];f[_+12>>2]=f[Y+12>>2];f[_+16>>2]=f[Y+16>>2];f[X>>2]=F;f[S>>2]=Z;f[Y>>2]=f[g>>2];f[Y+4>>2]=f[g+4>>2];f[Y+8>>2]=f[g+8>>2];f[Y+12>>2]=f[g+12>>2];f[Y+16>>2]=f[g+16>>2];R=V+28|0}if(s>>>0<V>>>0){H=65;break a}f[a>>2]=W;if(w){H=67;break a}else D=W}if((H|0)==40){H=0;w=D;C=f[w>>2]|0;B=E+4|0;y=f[B>>2]|0;A=E+8|0;f[g>>2]=f[A>>2];f[g+4>>2]=f[A+4>>2];f[g+8>>2]=f[A+8>>2];f[g+12>>2]=f[A+12>>2];f[g+16>>2]=f[A+16>>2];f[w>>2]=f[N>>2];w=M+-24|0;f[B>>2]=f[w>>2];B=M+-20|0;f[A>>2]=f[B>>2];f[A+4>>2]=f[B+4>>2];f[A+8>>2]=f[B+8>>2];f[A+12>>2]=f[B+12>>2];f[A+16>>2]=f[B+16>>2];f[N>>2]=C;f[w>>2]=y;f[B>>2]=f[g>>2];f[B+4>>2]=f[g+4>>2];f[B+8>>2]=f[g+8>>2];f[B+12>>2]=f[g+12>>2];f[B+16>>2]=f[g+16>>2];K=I+1|0;L=f[h>>2]|0}B=E+28|0;y=B;w=f[m>>2]|0;c:do if(B>>>0<L>>>0){C=K;A=w;z=y;while(1){r=z;if(+n[r+16>>2]>+n[A+16>>2]){J=+n[A+16>>2];v=r;do{x=v;v=v+28|0}while(+n[x+44>>2]>J);$=v;aa=v}else{$=r;aa=z}J=+n[A+16>>2];U=f[h>>2]|0;while(1){ba=U+-28|0;f[h>>2]=ba;if(+n[U+-12>>2]>J)break;else U=ba}if($>>>0>=ba>>>0){ca=C;da=A;ea=aa;break c}r=aa;v=f[r>>2]|0;x=$+4|0;R=f[x>>2]|0;T=$+8|0;f[g>>2]=f[T>>2];f[g+4>>2]=f[T+4>>2];f[g+8>>2]=f[T+8>>2];f[g+12>>2]=f[T+12>>2];f[g+16>>2]=f[T+16>>2];f[r>>2]=f[ba>>2];r=U+-24|0;f[x>>2]=f[r>>2];x=U+-20|0;f[T>>2]=f[x>>2];f[T+4>>2]=f[x+4>>2];f[T+8>>2]=f[x+8>>2];f[T+12>>2]=f[x+12>>2];f[T+16>>2]=f[x+16>>2];f[ba>>2]=v;f[r>>2]=R;f[x>>2]=f[g>>2];f[x+4>>2]=f[g+4>>2];f[x+8>>2]=f[g+8>>2];f[x+12>>2]=f[g+12>>2];f[x+16>>2]=f[g+16>>2];x=f[m>>2]|0;if((x|0)==($|0)){R=f[h>>2]|0;f[m>>2]=R;fa=R}else fa=x;C=C+1|0;A=fa;z=$+28|0}}else{ca=K;da=w;ea=y}while(0);y=ea;if((y|0)!=(da|0)?+n[da+16>>2]>+n[y+16>>2]:0){w=ea;B=f[w>>2]|0;z=y+4|0;A=f[z>>2]|0;C=y+8|0;f[g>>2]=f[C>>2];f[g+4>>2]=f[C+4>>2];f[g+8>>2]=f[C+8>>2];f[g+12>>2]=f[C+12>>2];f[g+16>>2]=f[C+16>>2];f[w>>2]=f[da>>2];w=da+4|0;f[z>>2]=f[w>>2];z=da+8|0;f[C>>2]=f[z>>2];f[C+4>>2]=f[z+4>>2];f[C+8>>2]=f[z+8>>2];f[C+12>>2]=f[z+12>>2];f[C+16>>2]=f[z+16>>2];f[da>>2]=B;f[w>>2]=A;f[z>>2]=f[g>>2];f[z+4>>2]=f[g+4>>2];f[z+8>>2]=f[g+8>>2];f[z+12>>2]=f[g+12>>2];f[z+16>>2]=f[g+16>>2];ga=ca+1|0}else ga=ca;if((t|0)==(y|0)){H=65;break}if(!ga)if(t>>>0<y>>>0){f[m>>2]=D;z=D;A=h;while(1){f[A>>2]=z;w=f[h>>2]|0;B=w+28|0;C=B;f[h>>2]=C;if((B|0)==(y|0)){H=65;break a}if(+n[w+44>>2]>+n[(f[m>>2]|0)+16>>2])break;else{z=C;A=m}}}else{f[m>>2]=ea;A=ea;z=h;while(1){f[z>>2]=A;C=f[h>>2]|0;w=C+28|0;B=w;f[h>>2]=B;if((w|0)==(b|0)){H=65;break a}if(+n[C+44>>2]>+n[(f[m>>2]|0)+16>>2])break;else{A=B;z=m}}}z=t>>>0<y>>>0;f[(z?c:a)>>2]=z?ea:y+28|0;z=f[c>>2]|0;if((t|0)==(z|0)){H=67;break}else{b=z;s=t}}if((H|0)==5){t=b+-28|0;f[c>>2]=t;if(!(+n[b+-12>>2]>+n[E+16>>2])){u=e;return}s=D;ea=f[s>>2]|0;a=E+4|0;m=f[a>>2]|0;ga=E+8|0;f[g>>2]=f[ga>>2];f[g+4>>2]=f[ga+4>>2];f[g+8>>2]=f[ga+8>>2];f[g+12>>2]=f[ga+12>>2];f[g+16>>2]=f[ga+16>>2];f[s>>2]=f[t>>2];s=b+-24|0;f[a>>2]=f[s>>2];a=b+-20|0;f[ga>>2]=f[a>>2];f[ga+4>>2]=f[a+4>>2];f[ga+8>>2]=f[a+8>>2];f[ga+12>>2]=f[a+12>>2];f[ga+16>>2]=f[a+16>>2];f[t>>2]=ea;f[s>>2]=m;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];u=e;return}else if((H|0)==7){f[j>>2]=D;f[k>>2]=D+28;a=b+-28|0;f[c>>2]=a;f[l>>2]=a;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];f[g>>2]=f[l>>2];PHb(i,h,g,d)|0;u=e;return}else if((H|0)==9){d=b+-28|0;i=D;if((i|0)==(d|0)){u=e;return}D=i;do{f[h>>2]=D;if((D|0)==(b|0))ha=b;else{i=h;l=g;d:while(1){f[l>>2]=f[i>>2];ia=f[h>>2]|0;k=ia+16|0;j=f[g>>2]|0;do{a=j;j=j+28|0;if((j|0)==(b|0))break d}while(!(+n[a+44>>2]>+n[k>>2]));f[g>>2]=j;i=g;l=h}ha=ia}if((ha|0)!=(D|0)){l=f[D>>2]|0;i=D+4|0;y=f[i>>2]|0;k=D+8|0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[D>>2]=f[ha>>2];a=ha+4|0;f[i>>2]=f[a>>2];i=ha+8|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];f[k+16>>2]=f[i+16>>2];f[ha>>2]=l;f[a>>2]=y;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];f[i+16>>2]=f[g+16>>2]}D=D+28|0}while((D|0)!=(d|0));u=e;return}else if((H|0)==65){u=e;return}else if((H|0)==67){u=e;return}}function PHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+32|0;e=d;g=f[b>>2]|0;b=f[a>>2]|0;a=g+16|0;h=+n[a>>2];i=b+16|0;j=f[c>>2]|0;c=j+16|0;k=+n[c>>2]>h;if(!(h>+n[i>>2])){if(!k){l=0;u=d;return l|0}m=f[g>>2]|0;o=g+4|0;p=f[o>>2]|0;q=g+8|0;f[e>>2]=f[q>>2];f[e+4>>2]=f[q+4>>2];f[e+8>>2]=f[q+8>>2];f[e+12>>2]=f[q+12>>2];f[e+16>>2]=f[q+16>>2];f[g>>2]=f[j>>2];r=j+4|0;f[o>>2]=f[r>>2];s=j+8|0;f[q>>2]=f[s>>2];f[q+4>>2]=f[s+4>>2];f[q+8>>2]=f[s+8>>2];f[q+12>>2]=f[s+12>>2];f[q+16>>2]=f[s+16>>2];f[j>>2]=m;f[r>>2]=p;f[s>>2]=f[e>>2];f[s+4>>2]=f[e+4>>2];f[s+8>>2]=f[e+8>>2];f[s+12>>2]=f[e+12>>2];f[s+16>>2]=f[e+16>>2];if(!(+n[a>>2]>+n[i>>2])){l=1;u=d;return l|0}i=f[b>>2]|0;s=b+4|0;p=f[s>>2]|0;r=b+8|0;f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[e+16>>2]=f[r+16>>2];f[b>>2]=f[g>>2];f[s>>2]=f[o>>2];f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];f[r+8>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];f[r+16>>2]=f[q+16>>2];f[g>>2]=i;f[o>>2]=p;f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];f[q+8>>2]=f[e+8>>2];f[q+12>>2]=f[e+12>>2];f[q+16>>2]=f[e+16>>2];l=2;u=d;return l|0}if(k){k=f[b>>2]|0;q=b+4|0;p=f[q>>2]|0;o=b+8|0;f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[e+16>>2]=f[o+16>>2];f[b>>2]=f[j>>2];i=j+4|0;f[q>>2]=f[i>>2];q=j+8|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[j>>2]=k;f[i>>2]=p;f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];f[q+8>>2]=f[e+8>>2];f[q+12>>2]=f[e+12>>2];f[q+16>>2]=f[e+16>>2];l=1;u=d;return l|0}q=f[b>>2]|0;p=b+4|0;i=f[p>>2]|0;k=b+8|0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[e+16>>2]=f[k+16>>2];f[b>>2]=f[g>>2];b=g+4|0;f[p>>2]=f[b>>2];p=g+8|0;f[k>>2]=f[p>>2];f[k+4>>2]=f[p+4>>2];f[k+8>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[g>>2]=q;f[b>>2]=i;f[p>>2]=f[e>>2];f[p+4>>2]=f[e+4>>2];f[p+8>>2]=f[e+8>>2];f[p+12>>2]=f[e+12>>2];f[p+16>>2]=f[e+16>>2];if(!(+n[c>>2]>+n[a>>2])){l=1;u=d;return l|0};f[e>>2]=f[p>>2];f[e+4>>2]=f[p+4>>2];f[e+8>>2]=f[p+8>>2];f[e+12>>2]=f[p+12>>2];f[e+16>>2]=f[p+16>>2];f[g>>2]=f[j>>2];g=j+4|0;f[b>>2]=f[g>>2];b=j+8|0;f[p>>2]=f[b>>2];f[p+4>>2]=f[b+4>>2];f[p+8>>2]=f[b+8>>2];f[p+12>>2]=f[b+12>>2];f[p+16>>2]=f[b+16>>2];f[j>>2]=q;f[g>>2]=i;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];l=2;u=d;return l|0}function QHb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+28|0;g=d+24|0;h=d+20|0;i=d+16|0;j=d;if((c|0)<=0){u=d;return}k=f[b+4>>2]|0;l=c<<1;if((k|0)>(l|0)?(m=f[b>>2]|0,(m|0)>(l|0)):0){f[h>>2]=f[a>>2];l=a+4|0;f[i>>2]=f[l>>2];b=m-c|0;m=k-c|0;k=(b|0)<(c|0)?b:c;n=(m|0)<(c|0)?m:c;f[j>>2]=k;f[j+4>>2]=n;f[j+8>>2]=((b|0)>(c|0)?b:c)-k;f[j+12>>2]=((m|0)>(c|0)?m:c)-n;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];i=RHb(g,e,j)|0;j=f[l>>2]|0;if((i|0)==(j|0)){u=d;return}f[l>>2]=j+(~(((j+-28-i|0)>>>0)/28|0)*28|0);u=d;return}i=f[a>>2]|0;j=a+4|0;a=f[j>>2]|0;if((a|0)==(i|0)){u=d;return}f[j>>2]=a+(~(((a+-28-i|0)>>>0)/28|0)*28|0);u=d;return}function RHb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0;d=f[a>>2]|0;e=f[b>>2]|0;a:do if((d|0)==(e|0))g=d;else{b=f[c>>2]|0;h=(f[c+8>>2]|0)+b|0;i=f[c+4>>2]|0;j=(f[c+12>>2]|0)+i|0;k=d;do{l=mrc(+n[k>>2])|0;m=mrc(+n[k+4>>2])|0;if(!((m|0)<(j|0)&(((l|0)>=(h|0)|(b|0)>(l|0)|(i|0)>(m|0))^1))){g=k;break a}k=k+28|0}while((k|0)!=(e|0));f[a>>2]=e;o=e;return o|0}while(0);f[a>>2]=g;if((g|0)==(e|0)){o=e;return o|0}d=g+28|0;if((d|0)==(e|0)){o=g;return o|0}k=c+8|0;i=c+4|0;b=c+12|0;h=d;d=g;j=g;while(1){p=+n[h>>2];g=mrc(p)|0;q=+n[d+32>>2];m=mrc(q)|0;l=f[c>>2]|0;if((((l|0)<=(g|0)?(g|0)<((f[k>>2]|0)+l|0):0)?(l=f[i>>2]|0,(l|0)<=(m|0)):0)?(m|0)<((f[b>>2]|0)+l|0):0){n[j>>2]=p;n[j+4>>2]=q;l=j+8|0;m=d+36|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];f[l+12>>2]=f[m+12>>2];f[l+16>>2]=f[m+16>>2];m=j+28|0;f[a>>2]=m;r=m}else r=j;m=h+28|0;if((m|0)==(e|0)){o=r;break}else{l=h;h=m;j=r;d=l}}return o|0}function SHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0;d=u;u=u+64|0;e=d;g=f[c+16>>2]|0;h=g;if(!g){u=d;return}g=c+4|0;i=f[g>>2]|0;if((i|0)<3)j=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{k=f[c+40>>2]|0;l=0;m=1;while(1){o=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(i|0)){j=o;break}else m=o}}if((i|0)==0|(j|0)==0){u=d;return}j=f[a>>2]|0;m=a+4|0;a=f[m>>2]|0;f[e>>2]=f[c>>2];l=e+4|0;f[l>>2]=i;k=e+8|0;f[k>>2]=f[c+8>>2];f[e+12>>2]=f[c+12>>2];o=e+16|0;f[o>>2]=h;f[e+20>>2]=f[c+20>>2];f[e+24>>2]=f[c+24>>2];f[e+28>>2]=f[c+28>>2];f[e+32>>2]=f[c+32>>2];h=e+36|0;p=f[c+36>>2]|0;f[h>>2]=p;q=e+40|0;f[q>>2]=k;k=e+48|0;r=e+44|0;f[r>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(!p)s=i;else{i=p+12|0;f[i>>2]=(f[i>>2]|0)+1;s=f[g>>2]|0}if((s|0)<3){s=f[c+44>>2]|0;g=f[r>>2]|0;f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2]}else{f[l>>2]=0;ZS(e,c)}a:do if((j|0)==(a|0)){t=j;v=16}else{c=f[o>>2]|0;s=f[f[r>>2]>>2]|0;g=j;while(1){i=c+(Y(~~(+n[g+4>>2]+.5),s)|0)+~~(+n[g>>2]+.5)|0;if(!(b[i>>0]|0)){t=g;v=16;break a}g=g+28|0;if((g|0)==(a|0)){w=a;break}}}while(0);if((v|0)==16)if((t|0)!=(a|0)){v=t+28|0;if((v|0)==(a|0))w=t;else{j=v;v=t;g=t;while(1){x=+n[g+32>>2];y=+n[j>>2];t=(f[o>>2]|0)+(Y(f[f[r>>2]>>2]|0,~~(x+.5))|0)+~~(y+.5)|0;if(!(b[t>>0]|0))z=v;else{n[v>>2]=y;n[v+4>>2]=x;t=v+8|0;s=g+36|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];z=v+28|0}s=j+28|0;if((s|0)==(a|0)){w=z;break}else{t=j;j=s;v=z;g=t}}}}else w=a;a=f[m>>2]|0;if((w|0)!=(a|0))f[m>>2]=a+(~(((a+-28-w|0)>>>0)/28|0)*28|0);w=f[h>>2]|0;if(w|0?(a=w+12|0,w=f[a>>2]|0,f[a>>2]=w+-1,(w|0)==1):0)_S(e);f[h>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){o=f[q>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)==(k|0)){u=d;return}g0(l);u=d;return}function THb(a){a=a|0;j0(a);return}function UHb(a,b){a=a|0;b=b|0;return}function VHb(a,b){a=a|0;b=b|0;return}function WHb(a){a=a|0;return 1}function XHb(a,c){a=a|0;c=c|0;var d=0;f[a>>2]=0;f[a+4>>2]=0;c=tT(a,9)|0;a=460443;d=c+9|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(d|0));return}function YHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;if(!(r$(b)|0)){e=f[(f[a>>2]|0)+48>>2]|0;g=e0()|0;Fh[e&255](a,b,d,c,g,0);return}g=f[c>>2]|0;d=c+4|0;c=f[d>>2]|0;if((c|0)==(g|0))return;f[d>>2]=c+(~(((c+-28-g|0)>>>0)/28|0)*28|0);return}function ZHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;g=u;u=u+112|0;h=g+100|0;i=g+88|0;j=g+72|0;k=g+56|0;l=g;f[h>>2]=0;m=h+4|0;f[m>>2]=0;f[h+8>>2]=0;f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;f$(c,h);c=(f[m>>2]|0)-(f[h>>2]|0)|0;m=(c|0)/56|0;if(!(r$(e)|0)?(f$(e,i),(((f[n>>2]|0)-(f[i>>2]|0)|0)/56|0|0)!=(m|0)):0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,23)|0;e=460419;p=o+23|0;do{b[o>>0]=b[e>>0]|0;o=o+1|0;e=e+1|0}while((o|0)<(p|0));eIb(-215,j,471356,88)}e=d+4|0;q=f[e>>2]|0;r=f[d>>2]|0;s=(q-r|0)/12|0;t=r;r=q;if(m>>>0<=s>>>0){if(m>>>0<s>>>0?(q=t+(m*12|0)|0,(r|0)!=(q|0)):0){t=r;while(1){r=t+-12|0;f[e>>2]=r;v=f[r>>2]|0;if(!v)w=r;else{r=t+-8|0;x=f[r>>2]|0;if((x|0)!=(v|0))f[r>>2]=x+(~(((x+-28-v|0)>>>0)/28|0)*28|0);YDc(v);w=f[e>>2]|0}if((w|0)==(q|0))break;else t=w}}}else fIb(d,m-s|0);if(!c){mx(i);mx(h);u=g;return}c=j+8|0;s=j+12|0;w=j+4|0;t=l+4|0;q=l+8|0;e=l+40|0;v=l+48|0;x=l+44|0;r=l+52|0;y=k+8|0;z=k+12|0;A=k+4|0;B=l+36|0;C=l+16|0;D=l+12|0;E=l+20|0;F=l+24|0;G=l+28|0;H=l+32|0;I=0;do{J=f[(f[a>>2]|0)+32>>2]|0;K=(f[h>>2]|0)+(I*56|0)|0;f[c>>2]=0;f[s>>2]=0;f[j>>2]=16842752;f[w>>2]=K;K=(f[d>>2]|0)+(I*12|0)|0;L=f[i>>2]|0;do if((L|0)!=(f[n>>2]|0)){M=L+(I*56|0)|0;f[l>>2]=f[M>>2];N=L+(I*56|0)+4|0;f[t>>2]=f[N>>2];f[q>>2]=f[L+(I*56|0)+8>>2];f[D>>2]=f[L+(I*56|0)+12>>2];f[C>>2]=f[L+(I*56|0)+16>>2];f[E>>2]=f[L+(I*56|0)+20>>2];f[F>>2]=f[L+(I*56|0)+24>>2];f[G>>2]=f[L+(I*56|0)+28>>2];f[H>>2]=f[L+(I*56|0)+32>>2];O=f[L+(I*56|0)+36>>2]|0;f[B>>2]=O;f[e>>2]=q;f[x>>2]=v;f[v>>2]=0;f[r>>2]=0;if(O|0){P=O+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[N>>2]|0)<3){N=f[L+(I*56|0)+44>>2]|0;P=f[x>>2]|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];break}else{f[t>>2]=0;ZS(l,M);break}}else{f[l>>2]=1124007936;o=t;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[e>>2]=q;f[x>>2]=v;f[v>>2]=0;f[r>>2]=0}while(0);f[y>>2]=0;f[z>>2]=0;f[k>>2]=16842752;f[A>>2]=l;ei[J&511](a,j,K,k);L=f[B>>2]|0;if(L|0?(M=L+12|0,L=f[M>>2]|0,f[M>>2]=L+-1,(L|0)==1):0)_S(l);f[B>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[t>>2]|0)>0){L=f[e>>2]|0;M=0;do{f[L+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[t>>2]|0))}M=f[x>>2]|0;if((M|0)!=(v|0))g0(M);I=I+1|0}while(I>>>0<m>>>0);mx(i);mx(h);u=g;return}function _Hb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;if(r$(b)|0){u$(d);return}else{e=f[(f[a>>2]|0)+48>>2]|0;g=e0()|0;Fh[e&255](a,b,g,c,d,1);return}}function $Hb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;if(!($$(e)|0)){u=g;return}f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;f$(c,h);c=(f[k>>2]|0)-(f[h>>2]|0)|0;k=(c|0)/56|0;if((((f[d+4>>2]|0)-(f[d>>2]|0)|0)/12|0|0)!=(k|0)){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,27)|0;m=460332;n=l+27|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));eIb(-215,i,460360,133)}if((d$(e)|0)!=327680){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,50)|0;m=460368;n=l+50|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));eIb(-215,i,460360,134)}m=f[e+4>>2]|0;g$(m,k);if(c|0){c=i+8|0;e=i+12|0;l=i+4|0;n=j+8|0;o=j+4|0;p=0;do{q=f[(f[a>>2]|0)+40>>2]|0;r=(f[h>>2]|0)+(p*56|0)|0;f[c>>2]=0;f[e>>2]=0;f[i>>2]=16842752;f[l>>2]=r;r=(f[d>>2]|0)+(p*12|0)|0;s=(f[m>>2]|0)+(p*56|0)|0;t=n;f[t>>2]=0;f[t+4>>2]=0;f[j>>2]=33619968;f[o>>2]=s;ei[q&511](a,i,r,j);p=p+1|0}while(p>>>0<k>>>0)}mx(h);u=g;return}function aIb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=u;u=u+16|0;e=g;f[e>>2]=0;f[e+4>>2]=0;eIb(-213,e,463413,154)}function bIb(a){a=a|0;return 0}function cIb(a){a=a|0;return 5}function dIb(a){a=a|0;var b=0;b=(_i[f[(f[a>>2]|0)+56>>2]&1023](a)|0)==0;return (b?6:4)|0}function eIb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,460258,d);return}function fIb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){XIc(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)mCc(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{n=VDc(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;XIc(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{g=g+-12|0;gIb(j+-12|0,g);j=h+-12|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~(((q+-28-d|0)>>>0)/28|0)*28|0);YDc(d)}}while((c|0)!=(k|0))}if(!p)return;YDc(p);return}function gIb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/28|0;if(!e)return;if(g>>>0>153391689)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*28|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];h=g+8|0;a=d+8|0;f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];d=d+28|0;g=(f[c>>2]|0)+28|0;f[c>>2]=g}while((d|0)!=(b|0));return}function hIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;XHb(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;tT(a,(f[c>>2]|0)+20|0)|0;g=f[c>>2]|0;if(!g)h=0;else{dJc(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;h=460469;a=c+20|0;do{b[c>>0]=b[h>>0]|0;c=c+1|0;h=h+1|0}while((c|0)<(a|0));uT(e);u=d;return}function iIb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;do if((d$(a)|0)==65536){k=f[a+4>>2]|0;f[j>>2]=f[k>>2];l=j+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=j+8|0;f[n>>2]=f[k+8>>2];f[j+12>>2]=f[k+12>>2];f[j+16>>2]=f[k+16>>2];f[j+20>>2]=f[k+20>>2];f[j+24>>2]=f[k+24>>2];f[j+28>>2]=f[k+28>>2];f[j+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[j+36>>2]=o;f[j+40>>2]=n;n=j+48|0;p=j+44|0;f[p>>2]=n;f[n>>2]=0;f[j+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;ZS(j,k);break}}else a$(j,a,-1);while(0);if((c|0)<=20){k=f[j+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[j>>2]&4095;f[i>>2]=1124007936;n=i+4|0;p=i+8|0;o=i+40|0;q=n;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=p;p=i+48|0;q=i+44|0;f[q>>2]=p;f[p>>2]=0;f[i+52>>2]=0;f[h>>2]=m;f[h+4>>2]=l;XS(i,2,h,k);k=i+16|0;h=i+36|0;l=f[h>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)_S(i);f[h>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[n>>2]|0)>0){k=f[o>>2]|0;o=0;do{f[k+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[q>>2]|0;if((n|0)!=(p|0))g0(n)}switch(e|0){case 0:{jIb(a,b,c,d);break}case 1:{kIb(a,b,c,d);break}case 2:{lIb(a,b,c,d);break}default:{}}d=j+36|0;c=f[d>>2]|0;if(c|0?(b=c+12|0,c=f[b>>2]|0,f[b>>2]=c+-1,(c|0)==1):0)_S(j);f[d>>2]=0;d=j+16|0;c=j+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[j+40>>2]|0;b=0;do{f[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)==(j+48|0)){u=g;return}g0(c);u=g;return}function jIb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0.0,Ra=0.0,Sa=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((d$(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;ZS(j,d);y=t;break}}else{a$(j,a,-1);y=j+48|0}while(0);mMb(k,f[y>>2]|0,8);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=XDc(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;XIc(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=3;X=i;while(1){i=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(W+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;XIc($|0,0,X|0)|0;if((W|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=i+(Y(Z,W)|0)+3|0;Z=0;while(1){i=h[ba>>0]|0;ca=l+(0-i)+255|0;da=h[ba+(f[k>>2]|0)>>0]|0;ea=h[ba+(f[A>>2]|0)>>0]|0;fa=b[ca+ea>>0]|b[ca+da>>0];a:do if(fa<<24>>24!=0?(ga=h[ba+(f[B>>2]|0)>>0]|0,ha=h[ba+(f[C>>2]|0)>>0]|0,ia=h[ba+(f[D>>2]|0)>>0]|0,ja=h[ba+(f[E>>2]|0)>>0]|0,ka=h[ba+(f[F>>2]|0)>>0]|0,la=(b[ca+ha>>0]|b[ca+ga>>0])&fa&(b[ca+ja>>0]|b[ca+ia>>0])&(b[ca+(h[ba+(f[G>>2]|0)>>0]|0)>>0]|b[ca+ka>>0]),la<<24>>24!=0):0){ma=h[ba+(f[H>>2]|0)>>0]|0;na=h[ba+(f[I>>2]|0)>>0]|0;oa=h[ba+(f[J>>2]|0)>>0]|0;pa=h[ba+(f[K>>2]|0)>>0]|0;qa=h[ba+(f[L>>2]|0)>>0]|0;ra=h[ba+(f[N>>2]|0)>>0]|0;sa=(b[ca+na>>0]|b[ca+ma>>0])&la&(b[ca+pa>>0]|b[ca+oa>>0])&(b[ca+(h[ba+(f[M>>2]|0)>>0]|0)>>0]|b[ca+qa>>0])&(b[ca+(h[ba+(f[O>>2]|0)>>0]|0)>>0]|b[ca+ra>>0])&255;b:do if(sa&1){la=i-a|0;ta=(oa|0)<(la|0)?((ga|0)<(la|0)?((ma|0)<(la|0)?((da|0)<(la|0)?4:3):2):1):0;if((ia|0)<(la|0)){if(ta>>>0<=3){ua=ta+1|0;va=67}}else{ua=0;va=67}do if((va|0)==67){va=0;if((qa|0)<(la|0))if((ua|0)>3)break;else wa=ua+1|0;else wa=0;if((ka|0)<(la|0))if((wa|0)>3)break;else xa=wa+1|0;else xa=0;if((ra|0)<(la|0))if((xa|0)>3)break;else ya=xa+1|0;else ya=0;if((ea|0)<(la|0))if((ya|0)>3)break;else za=ya+1|0;else za=0;if((na|0)<(la|0))if((za|0)>3)break;else Aa=za+1|0;else Aa=0;if((ha|0)<(la|0))if((Aa|0)>3)break;else Ba=Aa+1|0;else Ba=0;if((pa|0)<(la|0))if((Ba|0)>3)break;else Ca=Ba+1|0;else Ca=0;if(!((ja|0)<(la|0)&(Ca|0)>3)){Da=Z;break b}}while(0);la=Z+1|0;f[aa+(Z<<2)>>2]=_;if(e){ta=(pMb(ba,k,a)|0)&255;b[$+_>>0]=ta;Da=la}else Da=la}else Da=Z;while(0);if(sa&2){ja=a+i|0;pa=(h[ba+(f[J>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ba+(f[B>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ba+(f[H>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ba+(f[k>>2]|0)>>0]|0)>>>0>ja>>>0?4:3):2):1):0;if((h[ba+(f[D>>2]|0)>>0]|0)>>>0>ja>>>0){if(pa>>>0<=3){Ea=pa+1|0;va=83}}else{Ea=0;va=83}do if((va|0)==83){va=0;if((h[ba+(f[L>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ea|0)>3)break;else Fa=Ea+1|0;else Fa=0;if((h[ba+(f[F>>2]|0)>>0]|0)>>>0>ja>>>0)if((Fa|0)>3)break;else Ga=Fa+1|0;else Ga=0;if((h[ba+(f[N>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ga|0)>3)break;else Ha=Ga+1|0;else Ha=0;if((h[ba+(f[A>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ha|0)>3)break;else Ia=Ha+1|0;else Ia=0;if((h[ba+(f[I>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ia|0)>3)break;else Ja=Ia+1|0;else Ja=0;if((h[ba+(f[C>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ja|0)>3)break;else Ka=Ja+1|0;else Ka=0;if((h[ba+(f[K>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ka|0)>3)break;else La=Ka+1|0;else La=0;if(!((La|0)>3?(h[ba+(f[E>>2]|0)>>0]|0)>>>0>ja>>>0:0)){Ma=Da;break a}}while(0);ja=Da+1|0;f[aa+(Da<<2)>>2]=_;if(e){sa=(pMb(ba,k,a)|0)&255;b[$+_>>0]=sa;Ma=ja}else Ma=ja}else Ma=Da}else Ma=Z;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){Na=Ma;break}else{ba=ba+1|0;Z=Ma}}}else Na=0;f[aa+-4>>2]=Na;c:do if((W|0)!=3?(Z=W+-1|0,ba=(Z|0)%3|0,_=f[o+(ba<<2)>>2]|0,i=f[o+(((W+-2|0)%3|0)<<2)>>2]|0,ea=f[p+(ba<<2)>>2]|0,ba=f[ea+-4>>2]|0,(ba|0)>0):0){Oa=+(Z|0);if(e)Pa=0;else{Z=0;while(1){da=f[ea+(Z<<2)>>2]|0;Qa=+(da|0);Ra=+(h[_+da>>0]|0);n[q>>2]=Qa;n[P>>2]=Oa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=Ra;f[T>>2]=0;f[U>>2]=-1;da=f[t>>2]|0;if((da|0)==(f[V>>2]|0))V_(c,q);else{n[da>>2]=Qa;n[da+4>>2]=Oa;ca=da+8|0;f[ca>>2]=f[Q>>2];f[ca+4>>2]=f[Q+4>>2];f[ca+8>>2]=f[Q+8>>2];f[ca+12>>2]=f[Q+12>>2];f[ca+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}Z=Z+1|0;if((Z|0)>=(ba|0))break c}}do{Z=f[ea+(Pa<<2)>>2]|0;ca=b[_+Z>>0]|0;da=Z+1|0;do if(((((((ca&255)>(h[_+da>>0]|0)?(fa=Z+-1|0,(ca&255)>(h[_+fa>>0]|0)):0)?(ca&255)>(h[i+fa>>0]|0):0)?(ca&255)>(h[i+Z>>0]|0):0)?(ca&255)>(h[i+da>>0]|0):0)?(ca&255)>(h[$+fa>>0]|0):0)?(ca&255)>(h[$+Z>>0]|0):0){if((ca&255)<=(h[$+da>>0]|0))break;Qa=+(Z|0);n[q>>2]=Qa;n[P>>2]=Oa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(ca&255);f[T>>2]=0;f[U>>2]=-1;fa=f[t>>2]|0;if((fa|0)==(f[V>>2]|0))V_(c,q);else{n[fa>>2]=Qa;n[fa+4>>2]=Oa;ja=fa+8|0;f[ja>>2]=f[Q>>2];f[ja+4>>2]=f[Q+4>>2];f[ja+8>>2]=f[Q+8>>2];f[ja+12>>2]=f[Q+12>>2];f[ja+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}}while(0);Pa=Pa+1|0}while((Pa|0)<(ba|0))}while(0);$=W+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=$;X=f[d>>2]|0}Sa=f[m>>2]|0}else Sa=z;if((Sa|0)!=(s|0)){if(Sa|0)ZDc(Sa);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)_S(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}g0(s);u=g;return}function kIb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((d$(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;ZS(j,d);y=t;break}}else{a$(j,a,-1);y=j+48|0}while(0);mMb(k,f[y>>2]|0,12);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=XDc(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;XIc(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=3;X=i;while(1){i=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(W+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;XIc($|0,0,X|0)|0;if((W|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=i+(Y(Z,W)|0)+3|0;Z=0;while(1){i=h[ba>>0]|0;ca=l+(0-i)+255|0;da=b[ba+(f[k>>2]|0)>>0]|0;ea=b[ca+(h[ba+(f[A>>2]|0)>>0]|0)>>0]|b[ca+(da&255)>>0];a:do if(ea<<24>>24!=0?(fa=(b[ca+(h[ba+(f[C>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[B>>2]|0)>>0]|0)>>0])&ea&(b[ca+(h[ba+(f[E>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[D>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[G>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[F>>2]|0)>>0]|0)>>0]),fa<<24>>24!=0):0){ga=(b[ca+(h[ba+(f[I>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[H>>2]|0)>>0]|0)>>0])&fa&(b[ca+(h[ba+(f[K>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[J>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[M>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[L>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[O>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[N>>2]|0)>>0]|0)>>0])&255;b:do if(ga&1){fa=i-a|0;ha=0;ia=0;ja=da;while(1){if((ja&255|0)<(fa|0))if((ia|0)>5)break;else ka=ia+1|0;else ka=0;la=ha+1|0;if((la|0)>=19){ma=Z;break b}ha=la;ia=ka;ja=b[ba+(f[k+(la<<2)>>2]|0)>>0]|0}ja=Z+1|0;f[aa+(Z<<2)>>2]=_;if(e){ia=(oMb(ba,k,a)|0)&255;b[$+_>>0]=ia;ma=ja}else ma=ja}else ma=Z;while(0);if(ga&2){ja=a+i|0;ia=0;ha=0;while(1){if((h[ba+(f[k+(ha<<2)>>2]|0)>>0]|0)>>>0>ja>>>0)if((ia|0)>5)break;else na=ia+1|0;else na=0;ha=ha+1|0;if((ha|0)>=19){oa=ma;break a}else ia=na}ia=ma+1|0;f[aa+(ma<<2)>>2]=_;if(e){ha=(oMb(ba,k,a)|0)&255;b[$+_>>0]=ha;oa=ia}else oa=ia}else oa=ma}else oa=Z;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){pa=oa;break}else{ba=ba+1|0;Z=oa}}}else pa=0;f[aa+-4>>2]=pa;c:do if((W|0)!=3?(Z=W+-1|0,ba=(Z|0)%3|0,_=f[o+(ba<<2)>>2]|0,i=f[o+(((W+-2|0)%3|0)<<2)>>2]|0,da=f[p+(ba<<2)>>2]|0,ba=f[da+-4>>2]|0,(ba|0)>0):0){qa=+(Z|0);if(e)ra=0;else{Z=0;while(1){ca=f[da+(Z<<2)>>2]|0;sa=+(ca|0);ta=+(h[_+ca>>0]|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=ta;f[T>>2]=0;f[U>>2]=-1;ca=f[t>>2]|0;if((ca|0)==(f[V>>2]|0))V_(c,q);else{n[ca>>2]=sa;n[ca+4>>2]=qa;ea=ca+8|0;f[ea>>2]=f[Q>>2];f[ea+4>>2]=f[Q+4>>2];f[ea+8>>2]=f[Q+8>>2];f[ea+12>>2]=f[Q+12>>2];f[ea+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}Z=Z+1|0;if((Z|0)>=(ba|0))break c}}do{Z=f[da+(ra<<2)>>2]|0;ea=b[_+Z>>0]|0;ca=Z+1|0;do if(((((((ea&255)>(h[_+ca>>0]|0)?(ia=Z+-1|0,(ea&255)>(h[_+ia>>0]|0)):0)?(ea&255)>(h[i+ia>>0]|0):0)?(ea&255)>(h[i+Z>>0]|0):0)?(ea&255)>(h[i+ca>>0]|0):0)?(ea&255)>(h[$+ia>>0]|0):0)?(ea&255)>(h[$+Z>>0]|0):0){if((ea&255)<=(h[$+ca>>0]|0))break;sa=+(Z|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(ea&255);f[T>>2]=0;f[U>>2]=-1;ia=f[t>>2]|0;if((ia|0)==(f[V>>2]|0))V_(c,q);else{n[ia>>2]=sa;n[ia+4>>2]=qa;ha=ia+8|0;f[ha>>2]=f[Q>>2];f[ha+4>>2]=f[Q+4>>2];f[ha+8>>2]=f[Q+8>>2];f[ha+12>>2]=f[Q+12>>2];f[ha+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}}while(0);ra=ra+1|0}while((ra|0)<(ba|0))}while(0);$=W+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=$;X=f[d>>2]|0}ua=f[m>>2]|0}else ua=z;if((ua|0)!=(s|0)){if(ua|0)ZDc(ua);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)_S(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}g0(s);u=g;return}function lIb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((d$(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;ZS(j,d);y=t;break}}else{a$(j,a,-1);y=j+48|0}while(0);mMb(k,f[y>>2]|0,16);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=XDc(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;XIc(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=3;X=i;while(1){i=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(W+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;XIc($|0,0,X|0)|0;if((W|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=i+(Y(Z,W)|0)+3|0;Z=0;while(1){i=h[ba>>0]|0;ca=l+(0-i)+255|0;da=b[ba+(f[k>>2]|0)>>0]|0;ea=b[ca+(h[ba+(f[A>>2]|0)>>0]|0)>>0]|b[ca+(da&255)>>0];a:do if(ea<<24>>24!=0?(fa=(b[ca+(h[ba+(f[C>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[B>>2]|0)>>0]|0)>>0])&ea&(b[ca+(h[ba+(f[E>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[D>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[G>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[F>>2]|0)>>0]|0)>>0]),fa<<24>>24!=0):0){ga=(b[ca+(h[ba+(f[I>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[H>>2]|0)>>0]|0)>>0])&fa&(b[ca+(h[ba+(f[K>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[J>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[M>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[L>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[O>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[N>>2]|0)>>0]|0)>>0])&255;b:do if(ga&1){fa=i-a|0;ha=0;ia=0;ja=da;while(1){if((ja&255|0)<(fa|0))if((ia|0)>7)break;else ka=ia+1|0;else ka=0;la=ha+1|0;if((la|0)>=25){ma=Z;break b}ha=la;ia=ka;ja=b[ba+(f[k+(la<<2)>>2]|0)>>0]|0}ja=Z+1|0;f[aa+(Z<<2)>>2]=_;if(e){ia=(nMb(ba,k,a)|0)&255;b[$+_>>0]=ia;ma=ja}else ma=ja}else ma=Z;while(0);if(ga&2){ja=a+i|0;ia=0;ha=0;while(1){if((h[ba+(f[k+(ha<<2)>>2]|0)>>0]|0)>>>0>ja>>>0)if((ia|0)>7)break;else na=ia+1|0;else na=0;ha=ha+1|0;if((ha|0)>=25){oa=ma;break a}else ia=na}ia=ma+1|0;f[aa+(ma<<2)>>2]=_;if(e){ha=(nMb(ba,k,a)|0)&255;b[$+_>>0]=ha;oa=ia}else oa=ia}else oa=ma}else oa=Z;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){pa=oa;break}else{ba=ba+1|0;Z=oa}}}else pa=0;f[aa+-4>>2]=pa;c:do if((W|0)!=3?(Z=W+-1|0,ba=(Z|0)%3|0,_=f[o+(ba<<2)>>2]|0,i=f[o+(((W+-2|0)%3|0)<<2)>>2]|0,da=f[p+(ba<<2)>>2]|0,ba=f[da+-4>>2]|0,(ba|0)>0):0){qa=+(Z|0);if(e)ra=0;else{Z=0;while(1){ca=f[da+(Z<<2)>>2]|0;sa=+(ca|0);ta=+(h[_+ca>>0]|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=ta;f[T>>2]=0;f[U>>2]=-1;ca=f[t>>2]|0;if((ca|0)==(f[V>>2]|0))V_(c,q);else{n[ca>>2]=sa;n[ca+4>>2]=qa;ea=ca+8|0;f[ea>>2]=f[Q>>2];f[ea+4>>2]=f[Q+4>>2];f[ea+8>>2]=f[Q+8>>2];f[ea+12>>2]=f[Q+12>>2];f[ea+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}Z=Z+1|0;if((Z|0)>=(ba|0))break c}}do{Z=f[da+(ra<<2)>>2]|0;ea=b[_+Z>>0]|0;ca=Z+1|0;do if(((((((ea&255)>(h[_+ca>>0]|0)?(ia=Z+-1|0,(ea&255)>(h[_+ia>>0]|0)):0)?(ea&255)>(h[i+ia>>0]|0):0)?(ea&255)>(h[i+Z>>0]|0):0)?(ea&255)>(h[i+ca>>0]|0):0)?(ea&255)>(h[$+ia>>0]|0):0)?(ea&255)>(h[$+Z>>0]|0):0){if((ea&255)<=(h[$+ca>>0]|0))break;sa=+(Z|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(ea&255);f[T>>2]=0;f[U>>2]=-1;ia=f[t>>2]|0;if((ia|0)==(f[V>>2]|0))V_(c,q);else{n[ia>>2]=sa;n[ia+4>>2]=qa;ha=ia+8|0;f[ha>>2]=f[Q>>2];f[ha+4>>2]=f[Q+4>>2];f[ha+8>>2]=f[Q+8>>2];f[ha+12>>2]=f[Q+12>>2];f[ha+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}}while(0);ra=ra+1|0}while((ra|0)<(ba|0))}while(0);$=W+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=$;X=f[d>>2]|0}ua=f[m>>2]|0}else ua=z;if((ua|0)!=(s|0)){if(ua|0)ZDc(ua);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)_S(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}g0(s);u=g;return}function mIb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;g=VDc(16)|0;r0(g);f[g>>2]=111972;f[g+4>>2]=c;b[g+8>>0]=d&1;f[g+12>>2]=e<<16>>16;e=VDc(16)|0;d=e+4|0;f[d>>2]=1;f[e>>2]=112068;f[e+8>>2]=g;f[a>>2]=e;f[a+4>>2]=g;f[d>>2]=(f[d>>2]|0)+1;g=f[d>>2]|0;f[d>>2]=g+-1;if((g|0)!=1)return;Yi[f[(f[e>>2]|0)+8>>2]&2047](e);return}function nIb(a){a=a|0;YDc(a);return}function oIb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pIb(a){a=a|0;THb(a);YDc(a);return}function qIb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+192|0;h=g+136|0;i=g+80|0;j=g+32|0;k=g+16|0;l=g;if(r$(c)|0){m=f[d>>2]|0;n=d+4|0;o=f[n>>2]|0;if((o|0)==(m|0)){u=g;return}f[n>>2]=o+(~(((o+-28-m|0)>>>0)/28|0)*28|0);u=g;return}do if((d$(e)|0)==65536){m=f[e+4>>2]|0;f[h>>2]=f[m>>2];o=h+4|0;n=m+4|0;f[o>>2]=f[n>>2];p=h+8|0;f[p>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[n>>2]|0)<3){n=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[n>>2];f[p+4>>2]=f[n+4>>2];break}else{f[o>>2]=0;ZS(h,m);break}}else a$(h,e,-1);while(0);f[i>>2]=1124007936;e=i+4|0;m=i+8|0;o=i+40|0;n=e;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[o>>2]=m;m=i+48|0;n=i+44|0;f[n>>2]=m;f[m>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;p=j+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[j+32>>2]=j+8;p=j+40|0;f[j+36>>2]=p;f[j+44>>2]=0;f[p>>2]=0;p=c;r=f[p+4>>2]|0;q=k;f[q>>2]=f[p>>2];f[q+4>>2]=r;r=k+8|0;f[r>>2]=f[c+8>>2];q=k+12|0;f[q>>2]=f[c+12>>2];if(c$(c,-1)|0){p=(d$(c)|0)==655360;s=l+8|0;f[s>>2]=0;f[s+4>>2]=0;if(p){f[l>>2]=34209792;f[l+4>>2]=j}else{f[l>>2]=33619968;f[l+4>>2]=i}Oga(c,l,6,0);c=l;p=f[c+4>>2]|0;s=k;f[s>>2]=f[c>>2];f[s+4>>2]=p;f[r>>2]=f[l+8>>2];f[q>>2]=f[l+12>>2]}iIb(k,d,f[a+4>>2]|0,(b[a+8>>0]|0)!=0,f[a+12>>2]|0);SHb(d,h);GQ(j);j=i+36|0;d=f[j>>2]|0;if(d|0?(a=d+12|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)_S(i);f[j>>2]=0;j=i+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[e>>2]|0)>0){j=f[o>>2]|0;o=0;do{f[j+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[e>>2]|0))}e=f[n>>2]|0;if((e|0)!=(m|0))g0(e);e=h+36|0;m=f[e>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)_S(h);f[e>>2]=0;e=h+16|0;m=h+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[h+40>>2]|0;n=0;do{f[e+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[h+44>>2]|0;if((m|0)!=(h+48|0))g0(m);u=g;return}function rIb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function sIb(a){a=a|0;return f[a+4>>2]|0}function tIb(a,c){a=a|0;c=c|0;b[a+8>>0]=c&1;return}function uIb(a){a=a|0;return (b[a+8>>0]|0)!=0|0}function vIb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function wIb(a){a=a|0;return f[a+12>>2]|0}function xIb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;do if(!(g&1)){if((c$(a,-1)|0)==16){t$(a,d);break}if(!(c$(a,-1)|0)){Oga(a,d,8,0);break}else{f[i>>2]=0;f[i+4>>2]=0;j=tT(i,31)|0;k=460633;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));yIb(-5,i,460665,108)}}while(0);a=K4()|0;if((+p[e>>3]==-1.0?+p[e+8>>3]==-1.0:0)?+p[e+16>>3]==-1.0:0)m=+p[e+24>>3]==-1.0;else m=0;if(r$(d)|0){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,17)|0;k=460679;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));yIb(-215,i,460665,115)}k=f[c>>2]|0;j=f[c+4>>2]|0;if((k|0)==(j|0)){u=h;return}c=i+8|0;l=i+16|0;n=i+24|0;o=e+8|0;q=e+16|0;r=e+24|0;if(m){m=k;do{s=a;t=f[s+4>>2]|0;v=mJc(f[s>>2]|0,0,-130063606,0)|0;s=UIc(v|0,J|0,t|0,0)|0;t=J;v=mJc(s|0,0,-130063606,0)|0;w=UIc(v|0,J|0,t|0,0)|0;t=J;v=mJc(w|0,0,-130063606,0)|0;x=UIc(v|0,J|0,t|0,0)|0;t=a;f[t>>2]=x;f[t+4>>2]=J;p[i>>3]=+((s&255)>>>0);p[c>>3]=+((w&255)>>>0);p[l>>3]=+((x&255)>>>0);p[n>>3]=255.0;zIb(d,m,i,g);m=m+28|0}while((m|0)!=(j|0));u=h;return}else{m=k;do{p[i>>3]=+p[e>>3];p[c>>3]=+p[o>>3];p[l>>3]=+p[q>>3];p[n>>3]=+p[r>>3];zIb(d,m,i,g);m=m+28|0}while((m|0)!=(j|0));u=h;return}}function yIb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,460724,d);return}function zIb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0;g=u;u=u+48|0;h=g+32|0;i=g+24|0;j=g+16|0;k=g+8|0;l=g;if(r$(a)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,12)|0;o=460697;p=m+12|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));yIb(-215,h,460710,55)}h=mrc(+n[c>>2]*16.0)|0;o=mrc(+n[c+4>>2]*16.0)|0;if(!(e&4)){f[l>>2]=h;f[l+4>>2]=o;Ega(a,l,48,d,1,16,4);u=g;return}l=mrc(+n[c+8>>2]*.5*16.0)|0;f[i>>2]=h;f[i+4>>2]=o;Ega(a,i,l,d,1,16,4);q=+n[c+12>>2];if(!(q!=-1.0)){u=g;return}r=q*3.1415927410125732/180.0;q=+(l|0);l=mrc(q*+O(+r))|0;c=mrc(q*+P(+r))|0;f[j>>2]=h;f[j+4>>2]=o;f[k>>2]=l+h;f[k+4>>2]=c+o;jga(a,j,k,d,1,16,4);u=g;return}function AIb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;m=u;u=u+144|0;n=m+88|0;o=m+32|0;p=m+16|0;q=m;r=f[k>>2]|0;s=k+4|0;t=f[s>>2]|0;if((r|0)!=(t|0)?(t-r|0)!=((f[g+4>>2]|0)-(f[g>>2]|0)>>4|0):0){f[n>>2]=0;f[n+4>>2]=0;v=tT(n,50)|0;w=460793;x=v+50|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));yIb(-201,n,460844,198)}f[n>>2]=1124007936;r=n+4|0;t=n+8|0;y=n+40|0;v=r;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[y>>2]=t;t=n+48|0;z=n+44|0;f[z>>2]=t;f[t>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;A=o+4|0;B=o+8|0;C=o+40|0;v=A;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[C>>2]=B;B=o+48|0;D=o+44|0;f[D>>2]=B;f[B>>2]=0;f[o+52>>2]=0;BIb(a,c,d,e,h,n,o,j,l);j=g+4|0;d=f[j>>2]|0;a=f[g>>2]|0;a:do if((d|0)!=(a|0)){E=c+4|0;F=e+4|0;G=p+8|0;H=p+4|0;I=q+8|0;J=q+4|0;K=0;L=d;M=a;while(1){N=M;O=f[k>>2]|0;if((O|0)!=(f[s>>2]|0)?(b[O+K>>0]|0)==0:0){P=M;Q=L}else{O=f[N+(K<<4)>>2]|0;R=f[N+(K<<4)+4>>2]|0;if((O|0)<=-1){S=18;break}N=f[c>>2]|0;if((O|0)>=(((f[E>>2]|0)-N|0)/28|0|0)){S=18;break}if((R|0)<=-1){S=21;break}T=f[e>>2]|0;if((R|0)>=(((f[F>>2]|0)-T|0)/28|0|0)){S=21;break}U=G;f[U>>2]=0;f[U+4>>2]=0;f[p>>2]=50397184;f[H>>2]=n;U=I;f[U>>2]=0;f[U+4>>2]=0;f[q>>2]=50397184;f[J>>2]=o;CIb(h,p,q,N+(O*28|0)|0,T+(R*28|0)|0,i,l);P=f[g>>2]|0;Q=f[j>>2]|0}K=K+1|0;if(K>>>0>=Q-P>>4>>>0)break a;else{L=Q;M=P}}if((S|0)==18){f[p>>2]=0;f[p+4>>2]=0;v=tT(p,51)|0;w=460856;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));yIb(-215,p,460844,211)}else if((S|0)==21){f[p>>2]=0;f[p+4>>2]=0;v=tT(p,51)|0;w=460908;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));yIb(-215,p,460844,212)}}while(0);p=o+36|0;w=f[p>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)_S(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[A>>2]|0)>0){p=f[C>>2]|0;C=0;do{f[p+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[D>>2]|0;if((A|0)!=(B|0))g0(A);A=n+36|0;B=f[A>>2]|0;if(B|0?(D=B+12|0,B=f[D>>2]|0,f[D>>2]=B+-1,(B|0)==1):0)_S(n);f[A>>2]=0;A=n+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[r>>2]|0)>0){A=f[y>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[r>>2]|0))}r=f[z>>2]|0;if((r|0)==(t|0)){u=m;return}g0(r);u=m;return}function BIb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;l=u;u=u+224|0;m=l+168|0;n=l+160|0;o=l+152|0;p=l;q=l+88|0;r=l+144|0;s=l+72|0;t=l+56|0;f[m>>2]=1124007936;v=m+4|0;w=m+8|0;x=m+40|0;y=v;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[x>>2]=w;A=m+48|0;B=m+44|0;f[B>>2]=A;f[A>>2]=0;f[m+52>>2]=0;b$(n,a,-1);b$(o,d,-1);C=(f[o>>2]|0)+(f[n>>2]|0)|0;D=n+4|0;E=o+4|0;F=f[((f[D>>2]|0)<(f[E>>2]|0)?o:n)+4>>2]|0;do if(!(k&1)){f[r>>2]=C;f[r+4>>2]=F;v$(g,r,(p$(a,-1)|0)&7|16,-1,0,0);do if((d$(g)|0)==65536){G=f[g+4>>2]|0;f[p>>2]=f[G>>2];H=p+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=p+8|0;f[J>>2]=f[G+8>>2];f[p+12>>2]=f[G+12>>2];f[p+16>>2]=f[G+16>>2];f[p+20>>2]=f[G+20>>2];f[p+24>>2]=f[G+24>>2];f[p+28>>2]=f[G+28>>2];f[p+32>>2]=f[G+32>>2];K=p+36|0;L=f[G+36>>2]|0;f[K>>2]=L;f[p+40>>2]=J;J=p+48|0;M=p+44|0;f[M>>2]=J;f[J>>2]=0;f[p+52>>2]=0;if(L|0){J=L+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[M>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];N=K;break}else{f[H>>2]=0;ZS(p,G);N=K;break}}else{a$(p,g,-1);N=p+36|0}while(0);K=f[N>>2]|0;if(K|0){G=K+12|0;f[G>>2]=(f[G>>2]|0)+1}G=m+36|0;K=f[G>>2]|0;if(K|0?(H=K+12|0,K=f[H>>2]|0,f[H>>2]=K+-1,(K|0)==1):0)_S(m);f[G>>2]=0;K=m+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[v>>2]|0)>0){H=f[x>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0;O=f[v>>2]|0}while((I|0)<(O|0));f[m>>2]=f[p>>2];if((O|0)<3)P=98;else P=100}else{f[m>>2]=f[p>>2];P=98}if((P|0)==98){I=f[p+4>>2]|0;if((I|0)<3){f[v>>2]=I;f[w>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];I=f[p+44>>2]|0;H=f[B>>2]|0;f[H>>2]=f[I>>2];f[H+4>>2]=f[I+4>>2]}else P=100}if((P|0)==100)ZS(m,p);I=p+16|0;f[K>>2]=f[I>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];H=f[N>>2]|0;f[G>>2]=H;if(H|0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)_S(p);f[N>>2]=0;H=p+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[H>>2]|0)>0){I=f[p+40>>2]|0;J=0;do{f[I+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[p+44>>2]|0;if((H|0)!=(p+48|0))g0(H);f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;k_(m,p)|0;H=f[n>>2]|0;J=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=H;f[q+12>>2]=J;cT(p,m,q);if((p|0)==(h|0)){Q=p+36|0;R=f[h+36>>2]|0}else{J=p+36|0;H=f[J>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=h+36|0;H=f[I>>2]|0;if(H|0?(G=H+12|0,H=f[G>>2]|0,f[G>>2]=H+-1,(H|0)==1):0)_S(h);f[I>>2]=0;H=h+16|0;G=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[G>>2]|0)>0){K=f[h+40>>2]|0;M=0;do{f[K+(M<<2)>>2]=0;M=M+1|0;S=f[G>>2]|0}while((M|0)<(S|0));f[h>>2]=f[p>>2];if((S|0)<3)P=121;else P=123}else{f[h>>2]=f[p>>2];P=121}if((P|0)==121){M=f[p+4>>2]|0;if((M|0)<3){f[G>>2]=M;f[h+8>>2]=f[p+8>>2];f[h+12>>2]=f[p+12>>2];M=f[p+44>>2]|0;K=f[h+44>>2]|0;f[K>>2]=f[M>>2];f[K+4>>2]=f[M+4>>2]}else P=123}if((P|0)==123)ZS(h,p);f[H>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];M=f[J>>2]|0;f[I>>2]=M;Q=J;R=M}if(R|0?(M=R+12|0,K=f[M>>2]|0,f[M>>2]=K+-1,(K|0)==1):0)_S(p);f[Q>>2]=0;K=p+16|0;M=p+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[M>>2]|0)>0){K=f[p+40>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[M>>2]|0))}M=f[p+44>>2]|0;if((M|0)!=(p+48|0))g0(M);M=f[o>>2]|0;L=f[E>>2]|0;f[q>>2]=f[n>>2];f[q+4>>2]=0;f[q+8>>2]=M;f[q+12>>2]=L;cT(p,m,q);if((p|0)==(i|0)){T=p+36|0;U=f[i+36>>2]|0}else{L=p+36|0;M=f[L>>2]|0;if(M|0){K=M+12|0;f[K>>2]=(f[K>>2]|0)+1}K=i+36|0;M=f[K>>2]|0;if(M|0?(J=M+12|0,M=f[J>>2]|0,f[J>>2]=M+-1,(M|0)==1):0)_S(i);f[K>>2]=0;M=i+16|0;J=i+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[J>>2]|0)>0){I=f[i+40>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0;V=f[J>>2]|0}while((H|0)<(V|0));f[i>>2]=f[p>>2];if((V|0)<3)P=145;else P=147}else{f[i>>2]=f[p>>2];P=145}if((P|0)==145){H=f[p+4>>2]|0;if((H|0)<3){f[J>>2]=H;f[i+8>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];H=f[p+44>>2]|0;I=f[i+44>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2]}else P=147}if((P|0)==147)ZS(i,p);f[M>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];H=f[L>>2]|0;f[K>>2]=H;T=L;U=H}if(U|0?(H=U+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)_S(p);f[T>>2]=0;I=p+16|0;H=p+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[H>>2]|0)>0){I=f[p+40>>2]|0;G=0;do{f[I+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[H>>2]|0))}H=f[p+44>>2]|0;if((H|0)!=(p+48|0))g0(H);if(!(c$(a,-1)|0)){H=p+8|0;f[H>>2]=0;f[H+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;Oga(a,p,8,0)}else{H=p+8|0;f[H>>2]=0;f[H+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;t$(a,p)}if(!(c$(d,-1)|0)){H=p+8|0;f[H>>2]=0;f[H+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;Oga(d,p,8,0);break}else{H=p+8|0;f[H>>2]=0;f[H+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;t$(d,p);break}}else{do if((d$(g)|0)==65536){H=f[g+4>>2]|0;f[p>>2]=f[H>>2];G=p+4|0;I=H+4|0;f[G>>2]=f[I>>2];L=p+8|0;f[L>>2]=f[H+8>>2];f[p+12>>2]=f[H+12>>2];f[p+16>>2]=f[H+16>>2];f[p+20>>2]=f[H+20>>2];f[p+24>>2]=f[H+24>>2];f[p+28>>2]=f[H+28>>2];f[p+32>>2]=f[H+32>>2];K=p+36|0;M=f[H+36>>2]|0;f[K>>2]=M;f[p+40>>2]=L;L=p+48|0;J=p+44|0;f[J>>2]=L;f[L>>2]=0;f[p+52>>2]=0;if(M|0){L=M+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[I>>2]|0)<3){I=f[H+44>>2]|0;L=f[J>>2]|0;f[L>>2]=f[I>>2];f[L+4>>2]=f[I+4>>2];W=K;break}else{f[G>>2]=0;ZS(p,H);W=K;break}}else{a$(p,g,-1);W=p+36|0}while(0);K=f[W>>2]|0;if(K|0){H=K+12|0;f[H>>2]=(f[H>>2]|0)+1}H=m+36|0;K=f[H>>2]|0;if(K|0?(G=K+12|0,K=f[G>>2]|0,f[G>>2]=K+-1,(K|0)==1):0)_S(m);f[H>>2]=0;K=m+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[v>>2]|0)>0){G=f[x>>2]|0;I=0;do{f[G+(I<<2)>>2]=0;I=I+1|0;X=f[v>>2]|0}while((I|0)<(X|0));f[m>>2]=f[p>>2];if((X|0)<3)P=19;else P=21}else{f[m>>2]=f[p>>2];P=19}if((P|0)==19){I=f[p+4>>2]|0;if((I|0)<3){f[v>>2]=I;f[w>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];I=f[p+44>>2]|0;G=f[B>>2]|0;f[G>>2]=f[I>>2];f[G+4>>2]=f[I+4>>2]}else P=21}if((P|0)==21)ZS(m,p);I=p+16|0;f[K>>2]=f[I>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];G=f[W>>2]|0;f[H>>2]=G;if(G|0?(L=G+12|0,G=f[L>>2]|0,f[L>>2]=G+-1,(G|0)==1):0)_S(p);f[W>>2]=0;G=p+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[G>>2]|0)>0){I=f[p+40>>2]|0;L=0;do{f[I+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[G>>2]|0))}G=f[p+44>>2]|0;if((G|0)!=(p+48|0))g0(G);if((F|0)>(f[w>>2]|0)?1:(C|0)>(f[m+12>>2]|0)){f[p>>2]=0;f[p+4>>2]=0;y=tT(p,61)|0;G=460960;z=y+61|0;do{b[y>>0]=b[G>>0]|0;y=y+1|0;G=G+1|0}while((y|0)<(z|0));yIb(-201,p,461022,137)}G=f[n>>2]|0;L=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=G;f[q+12>>2]=L;cT(p,m,q);if((p|0)==(h|0)){Y=p+36|0;Z=f[h+36>>2]|0}else{L=p+36|0;G=f[L>>2]|0;if(G|0){I=G+12|0;f[I>>2]=(f[I>>2]|0)+1}I=h+36|0;G=f[I>>2]|0;if(G|0?(H=G+12|0,G=f[H>>2]|0,f[H>>2]=G+-1,(G|0)==1):0)_S(h);f[I>>2]=0;G=h+16|0;H=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[H>>2]|0)>0){K=f[h+40>>2]|0;J=0;do{f[K+(J<<2)>>2]=0;J=J+1|0;_=f[H>>2]|0}while((J|0)<(_|0));f[h>>2]=f[p>>2];if((_|0)<3)P=44;else P=46}else{f[h>>2]=f[p>>2];P=44}if((P|0)==44){J=f[p+4>>2]|0;if((J|0)<3){f[H>>2]=J;f[h+8>>2]=f[p+8>>2];f[h+12>>2]=f[p+12>>2];J=f[p+44>>2]|0;K=f[h+44>>2]|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2]}else P=46}if((P|0)==46)ZS(h,p);f[G>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];J=f[L>>2]|0;f[I>>2]=J;Y=L;Z=J}if(Z|0?(J=Z+12|0,K=f[J>>2]|0,f[J>>2]=K+-1,(K|0)==1):0)_S(p);f[Y>>2]=0;K=p+16|0;J=p+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[J>>2]|0)>0){K=f[p+40>>2]|0;M=0;do{f[K+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[J>>2]|0))}J=f[p+44>>2]|0;if((J|0)!=(p+48|0))g0(J);J=f[o>>2]|0;M=f[E>>2]|0;f[q>>2]=f[n>>2];f[q+4>>2]=0;f[q+8>>2]=J;f[q+12>>2]=M;cT(p,m,q);if((p|0)==(i|0)){$=p+36|0;aa=f[i+36>>2]|0}else{M=p+36|0;J=f[M>>2]|0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}K=i+36|0;J=f[K>>2]|0;if(J|0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0)_S(i);f[K>>2]=0;J=i+16|0;L=i+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[L>>2]|0)>0){I=f[i+40>>2]|0;G=0;do{f[I+(G<<2)>>2]=0;G=G+1|0;ba=f[L>>2]|0}while((G|0)<(ba|0));f[i>>2]=f[p>>2];if((ba|0)<3)P=68;else P=70}else{f[i>>2]=f[p>>2];P=68}do if((P|0)==68){G=f[p+4>>2]|0;if((G|0)>=3){P=70;break}f[L>>2]=G;f[i+8>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];G=f[p+44>>2]|0;I=f[i+44>>2]|0;f[I>>2]=f[G>>2];f[I+4>>2]=f[G+4>>2]}while(0);if((P|0)==70)ZS(i,p);f[J>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];L=f[M>>2]|0;f[K>>2]=L;$=M;aa=L}if(aa|0?(L=aa+12|0,G=f[L>>2]|0,f[L>>2]=G+-1,(G|0)==1):0)_S(p);f[$>>2]=0;G=p+16|0;L=p+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[L>>2]|0)>0){G=f[p+40>>2]|0;I=0;do{f[G+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[L>>2]|0))}L=f[p+44>>2]|0;if((L|0)!=(p+48|0))g0(L)}while(0);if(!(k&2)){$=f[n>>2]|0;aa=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=$;f[q+12>>2]=aa;cT(p,m,q);f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=p;aa=s+8|0;f[aa>>2]=0;f[aa+4>>2]=0;f[s>>2]=50397184;f[s+4>>2]=p;aa=k|1;xIb(q,c,s,j,aa);c=f[o>>2]|0;o=f[E>>2]|0;f[s>>2]=f[n>>2];f[s+4>>2]=0;f[s+8>>2]=c;f[s+12>>2]=o;cT(q,m,s);f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=q;o=t+8|0;f[o>>2]=0;f[o+4>>2]=0;f[t>>2]=50397184;f[t+4>>2]=q;xIb(s,e,t,j,aa);aa=q+36|0;j=f[aa>>2]|0;if(j|0?(t=j+12|0,j=f[t>>2]|0,f[t>>2]=j+-1,(j|0)==1):0)_S(q);f[aa>>2]=0;aa=q+16|0;j=q+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[j>>2]|0)>0){aa=f[q+40>>2]|0;t=0;do{f[aa+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[q+44>>2]|0;if((j|0)!=(q+48|0))g0(j);j=p+36|0;q=f[j>>2]|0;if(q|0?(t=q+12|0,q=f[t>>2]|0,f[t>>2]=q+-1,(q|0)==1):0)_S(p);f[j>>2]=0;j=p+16|0;q=p+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){j=f[p+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[q>>2]|0))}q=f[p+44>>2]|0;if((q|0)!=(p+48|0))g0(q)}q=m+36|0;p=f[q>>2]|0;if(p|0?(t=p+12|0,p=f[t>>2]|0,f[t>>2]=p+-1,(p|0)==1):0)_S(m);f[q>>2]=0;q=m+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[v>>2]|0)>0){q=f[x>>2]|0;x=0;do{f[q+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[B>>2]|0;if((v|0)==(A|0)){u=l;return}g0(v);u=l;return}function CIb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0;i=u;u=u+64|0;j=i;k=i+56|0;l=i+48|0;m=i+40|0;o=i+32|0;q=K4()|0;r=+p[g>>3];s=+p[g+8>>3];if(r==-1.0&s==-1.0)if(+p[g+16>>3]==-1.0){t=+p[g+24>>3];if(t==-1.0){v=q;w=f[v+4>>2]|0;x=mJc(f[v>>2]|0,0,-130063606,0)|0;v=UIc(x|0,J|0,w|0,0)|0;w=J;x=mJc(v|0,0,-130063606,0)|0;y=UIc(x|0,J|0,w|0,0)|0;w=J;x=mJc(y|0,0,-130063606,0)|0;z=UIc(x|0,J|0,w|0,0)|0;w=q;f[w>>2]=z;f[w+4>>2]=J;A=255.0;B=+((z&255)>>>0);C=+((y&255)>>>0);D=+((v&255)>>>0);E=j}else{A=t;B=-1.0;C=-1.0;D=r;E=j}}else{F=-1.0;G=3}else{F=s;G=3}if((G|0)==3){A=+p[g+24>>3];B=+p[g+16>>3];C=F;D=r;E=j}p[j>>3]=D;p[j+8>>3]=C;p[j+16>>3]=B;p[j+24>>3]=A;zIb(b,d,j,h);zIb(c,e,j,h);A=+n[d>>2];B=+n[d+4>>2];C=+n[e>>2];D=+n[e+4>>2];b$(k,b,-1);r=C+ +(f[k>>2]|0);b$(l,a,-1);C=+((f[l>>2]|0)+-1|0);l=mrc(A*16.0)|0;k=mrc(B*16.0)|0;f[m>>2]=l;f[m+4>>2]=k;k=mrc((C<r?C:r)*16.0)|0;l=mrc(D*16.0)|0;f[o>>2]=k;f[o+4>>2]=l;jga(a,m,o,j,1,16,4);u=i;return}function DIb(a){a=a|0;var b=0;f[a>>2]=112088;b=f[a+12>>2]|0;if(b|0)ZDc(b);b=f[a+40>>2]|0;if(b|0)ZDc(b);b=f[a+44>>2]|0;if(b|0)ZDc(b);b=f[a+20>>2]|0;if(b|0)ZDc(b);b=f[a+24>>2]|0;if(!b){THb(a);return}ZDc(b);THb(a);return}function EIb(a){a=a|0;DIb(a);YDc(a);return}function FIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;XHb(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;tT(a,(f[c>>2]|0)+6|0)|0;g=f[c>>2]|0;if(!g)h=0;else{dJc(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;b[c>>0]=b[461465]|0;b[c+1>>0]=b[461466]|0;b[c+2>>0]=b[461467]|0;b[c+3>>0]=b[461468]|0;b[c+4>>0]=b[461469]|0;b[c+5>>0]=b[461470]|0;uT(e);u=d;return}function GIb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;KIb(a,b,c,d,e,$$(e)|0,1,f);return}function HIb(a){a=a|0;return f[a+28>>2]|0}function IIb(a){a=a|0;return 0}function JIb(a){a=a|0;return 6}function KIb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0,na=0;k=u;u=u+304|0;l=k+248|0;m=k+192|0;o=k+176|0;q=k+120|0;r=k+64|0;s=k+8|0;t=k;do if((d$(c)|0)==65536){v=f[c+4>>2]|0;f[l>>2]=f[v>>2];w=l+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=l+8|0;f[y>>2]=f[v+8>>2];f[l+12>>2]=f[v+12>>2];f[l+16>>2]=f[v+16>>2];f[l+20>>2]=f[v+20>>2];f[l+24>>2]=f[v+24>>2];f[l+28>>2]=f[v+28>>2];f[l+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=y;y=l+48|0;A=l+44|0;f[A>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;ZS(l,v);break}}else a$(l,c,-1);while(0);do if((d$(d)|0)==65536){v=f[d+4>>2]|0;f[m>>2]=f[v>>2];w=m+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[v+8>>2];f[m+12>>2]=f[v+12>>2];f[m+16>>2]=f[v+16>>2];f[m+20>>2]=f[v+20>>2];f[m+24>>2]=f[v+24>>2];f[m+28>>2]=f[v+28>>2];f[m+32>>2]=f[v+32>>2];A=f[v+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=y;y=m+48|0;z=m+44|0;f[z>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(A|0){y=A+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[z>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;ZS(m,v);break}}else a$(m,d,-1);while(0);if(f[l>>2]&4095|0){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;v=q+8|0;f[v>>2]=0;f[v+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;Oga(o,q,6,0)}if(j)B=i;else{LIb(a,c,d,e);B=1}d=e+4|0;c=(f[d>>2]|0)-(f[e>>2]|0)|0;i=(c|0)/28|0;f[o>>2]=0;j=o+4|0;f[j>>2]=0;f[o+8>>2]=0;if(c|0)lN(o,i);if((b[527128]|0)==0?MIc(527128)|0:0)n[220472]=4.906890869140625;if(!c)C=i;else{c=f[o>>2]|0;v=f[e>>2]|0;w=a+24|0;x=l+12|0;y=l+8|0;z=i;i=0;A=c;D=v;E=v;v=c;while(1){c=~~(64.0/+n[220472]*(+W(+(+n[E+(i*28|0)+8>>2]/7.200000286102295))/.6931471824645996)+.5);F=(c|0)>0?c:0;c=F>>>0<63?F:63;f[v+(i<<2)>>2]=c;F=f[(f[w>>2]|0)+(c<<2)>>2]|0;G=+(F|0);H=+n[E+(i*28|0)>>2];if((H<G?0:!(H>=+((f[x>>2]|0)-F|0)))?(H=+n[E+(i*28|0)+4>>2],!(H<G?1:H>=+((f[y>>2]|0)-F|0))):0){I=z;J=i;K=A;L=D;M=v;N=E}else{F=D+(i*28|0)|0;c=F+28|0;O=f[d>>2]|0;if((c|0)!=(O|0)){P=c;Q=F;do{f[Q>>2]=f[P>>2];f[Q+4>>2]=f[P+4>>2];R=Q+8|0;S=P+8|0;f[R>>2]=f[S>>2];f[R+4>>2]=f[S+4>>2];f[R+8>>2]=f[S+8>>2];f[R+12>>2]=f[S+12>>2];f[R+16>>2]=f[S+16>>2];P=P+28|0;Q=Q+28|0}while((P|0)!=(O|0));O=f[d>>2]|0;if((O|0)!=(Q|0)){T=Q;V=O;X=31}}else{T=F;V=c;X=31}if((X|0)==31){X=0;f[d>>2]=V+(~(((V+-28-T|0)>>>0)/28|0)*28|0)}O=A+(i<<2)|0;P=O+4|0;S=f[j>>2]|0;R=S-P|0;Z=R>>2;if(!Z)_=S;else{fJc(O|0,P|0,R|0)|0;_=f[j>>2]|0}R=O+(Z<<2)|0;if((_|0)!=(R|0))f[j>>2]=_+(~((_+-4-R|0)>>>2)<<2);R=(i|0)==0;Z=f[e>>2]|0;O=f[o>>2]|0;I=z+-1|0;J=i+-1|0;K=R?O:A;L=R?Z:D;M=O;N=Z}i=J+1|0;if(i>>>0>=I>>>0){C=I;break}else{z=I;A=K;D=L;E=N;v=M}}}f[q>>2]=1124007936;M=q+4|0;v=q+8|0;N=q+40|0;E=M;L=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(L|0));f[N>>2]=v;v=q+48|0;D=q+44|0;f[D>>2]=v;f[v>>2]=0;f[q+52>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=l;K=s+8|0;f[K>>2]=0;f[K+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=q;jqa(r,s,-1);K=a+16|0;A=f[K>>2]|0;I=XDc(A>>>0>1073741823?-1:A<<2)|0;f[r>>2]=1124007936;A=r+4|0;z=r+8|0;i=r+40|0;E=A;L=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(L|0));f[i>>2]=z;J=r+48|0;_=r+44|0;f[_>>2]=J;f[J>>2]=0;f[r+52>>2]=0;if(h){Y$(g,C,f[a+28>>2]|0,0,-1,0,0);do if((d$(g)|0)==65536){T=f[g+4>>2]|0;f[s>>2]=f[T>>2];V=s+4|0;d=T+4|0;f[V>>2]=f[d>>2];y=s+8|0;f[y>>2]=f[T+8>>2];f[s+12>>2]=f[T+12>>2];f[s+16>>2]=f[T+16>>2];f[s+20>>2]=f[T+20>>2];f[s+24>>2]=f[T+24>>2];f[s+28>>2]=f[T+28>>2];f[s+32>>2]=f[T+32>>2];x=s+36|0;w=f[T+36>>2]|0;f[x>>2]=w;f[s+40>>2]=y;y=s+48|0;Z=s+44|0;f[Z>>2]=y;f[y>>2]=0;f[s+52>>2]=0;if(w|0){y=w+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[d>>2]|0)<3){d=f[T+44>>2]|0;y=f[Z>>2]|0;f[y>>2]=f[d>>2];f[y+4>>2]=f[d+4>>2];$=x;break}else{f[V>>2]=0;ZS(s,T);$=x;break}}else{a$(s,g,-1);$=s+36|0}while(0);g=f[$>>2]|0;if(g|0){x=g+12|0;f[x>>2]=(f[x>>2]|0)+1}x=r+36|0;g=f[x>>2]|0;if(g|0?(T=g+12|0,g=f[T>>2]|0,f[T>>2]=g+-1,(g|0)==1):0)_S(r);f[x>>2]=0;g=r+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[A>>2]|0)>0){T=f[i>>2]|0;V=0;do{f[T+(V<<2)>>2]=0;V=V+1|0;aa=f[A>>2]|0}while((V|0)<(aa|0));f[r>>2]=f[s>>2];if((aa|0)<3)X=57;else X=59}else{f[r>>2]=f[s>>2];X=57}if((X|0)==57){aa=f[s+4>>2]|0;if((aa|0)<3){f[A>>2]=aa;f[z>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];z=f[s+44>>2]|0;aa=f[_>>2]|0;f[aa>>2]=f[z>>2];f[aa+4>>2]=f[z+4>>2]}else X=59}if((X|0)==59)ZS(r,s);z=s+16|0;f[g>>2]=f[z>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2];f[r+32>>2]=f[s+32>>2];aa=f[$>>2]|0;f[x>>2]=aa;if(aa|0?(x=aa+12|0,aa=f[x>>2]|0,f[x>>2]=aa+-1,(aa|0)==1):0)_S(s);f[$>>2]=0;$=s+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[$>>2]|0)>0){z=f[s+40>>2]|0;aa=0;do{f[z+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[$>>2]|0))}$=f[s+44>>2]|0;if(($|0)!=(s+48|0))g0($);p[t>>3]=0.0;f[s>>2]=-1056833530;f[s+4>>2]=t;f[s+8>>2]=1;f[s+12>>2]=1;l_(r,s,e0()|0)|0;ba=g}else ba=r+16|0;a:do if(C|0){g=a+40|0;t=a+48|0;$=a+28|0;aa=a+44|0;z=a+52|0;x=h^1;V=f[ba>>2]|0;T=0;b:while(1){d=f[e>>2]|0;y=(f[o>>2]|0)+(T<<2)|0;Z=d+(T*28|0)|0;w=d+(T*28|0)+4|0;if(B){if(!(f[K>>2]|0))ca=0;else{O=0;do{R=MIb(a,l,q,+n[Z>>2],+n[w>>2],f[y>>2]|0,0,O)|0;f[I+(O<<2)>>2]=R;O=O+1|0;R=f[K>>2]|0}while(O>>>0<R>>>0);ca=R}O=f[aa>>2]|0;R=f[z>>2]|0;P=O+(R<<4)|0;if((R|0)>0){R=O;O=0;S=0;while(1){da=f[R>>2]|0;if(da>>>0>=ca>>>0){X=78;break b}ea=f[R+4>>2]|0;if(ea>>>0>=ca>>>0){X=78;break b}fa=(f[I+(da<<2)>>2]|0)-(f[I+(ea<<2)>>2]|0)|0;ea=(Y(fa,f[R+8>>2]|0)|0)/1024|0;da=ea+S|0;ea=((Y(f[R+12>>2]|0,fa)|0)/1024|0)+O|0;R=R+16|0;if(R>>>0>=P>>>0){ga=ea;ha=da;break}else{O=ea;S=da}}}else{ga=0;ha=0}H=+U(+(+(ga|0)),+(+(ha|0)))/3.141592653589793*180.0;S=d+(T*28|0)+12|0;n[S>>2]=H;if(H<0.0&x)n[S>>2]=H+360.0}if(h){S=d+(T*28|0)+12|0;H=+n[S>>2];if(!(H==-1.0)){O=~~(H/360.0*1024.0+.5);P=(O|0)<0?O+1024|0:O;O=(P|0)>1023?P+-1024|0:P;if(H<0.0){ia=O;ja=H;X=84}else ka=O}else{ia=0;ja=-1.0;X=84}if((X|0)==84){X=0;n[S>>2]=ja+360.0;ka=ia}if(!(f[K>>2]|0))la=0;else{S=0;do{O=MIb(a,l,q,+n[Z>>2],+n[w>>2],f[y>>2]|0,ka,S)|0;f[I+(S<<2)>>2]=O;S=S+1|0;O=f[K>>2]|0}while(S>>>0<O>>>0);la=O}S=f[g>>2]|0;y=f[t>>2]|0;w=S+(y<<3)|0;c:do if((y|0)>0){Z=f[S>>2]|0;if(Z>>>0>=la>>>0){X=92;break b}d=V;O=0;P=S;R=la;da=Z;while(1){Z=f[P+4>>2]|0;if(Z>>>0>=R>>>0){X=92;break b}if((f[I+(da<<2)>>2]|0)>(f[I+(Z<<2)>>2]|0))f[d>>2]=f[d>>2]|1<<O;Z=O+1|0;ea=(Z|0)==32;P=P+8|0;if(P>>>0>=w>>>0)break c;R=f[K>>2]|0;da=f[P>>2]|0;if(da>>>0>=R>>>0){X=92;break b}else{d=ea?d+4|0:d;O=ea?0:Z}}}while(0);ma=V+(f[$>>2]|0)|0}else ma=V;T=T+1|0;if(T>>>0>=C>>>0)break a;else V=ma}if((X|0)==78){f[s>>2]=0;f[s+4>>2]=0;E=tT(s,38)|0;na=461050;L=E+38|0;do{b[E>>0]=b[na>>0]|0;E=E+1|0;na=na+1|0}while((E|0)<(L|0));NIb(s,461089,744)}else if((X|0)==92){f[s>>2]=0;f[s+4>>2]=0;E=tT(s,38)|0;na=461050;L=E+38|0;do{b[E>>0]=b[na>>0]|0;E=E+1|0;na=na+1|0}while((E|0)<(L|0));NIb(s,461089,800)}}while(0);ZDc(I);I=r+36|0;s=f[I>>2]|0;if(s|0?(na=s+12|0,s=f[na>>2]|0,f[na>>2]=s+-1,(s|0)==1):0)_S(r);f[I>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[A>>2]|0)>0){ba=f[i>>2]|0;i=0;do{f[ba+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[A>>2]|0))}A=f[_>>2]|0;if((A|0)!=(J|0))g0(A);A=q+36|0;J=f[A>>2]|0;if(J|0?(_=J+12|0,J=f[_>>2]|0,f[_>>2]=J+-1,(J|0)==1):0)_S(q);f[A>>2]=0;A=q+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[M>>2]|0)>0){A=f[N>>2]|0;N=0;do{f[A+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[M>>2]|0))}M=f[D>>2]|0;if((M|0)!=(v|0))g0(M);M=f[o>>2]|0;if(M|0){o=f[j>>2]|0;if((o|0)!=(M|0))f[j>>2]=o+(~((o+-4-M|0)>>>2)<<2);YDc(M)}M=m+36|0;o=f[M>>2]|0;if(o|0?(j=o+12|0,o=f[j>>2]|0,f[j>>2]=o+-1,(o|0)==1):0)_S(m);f[M>>2]=0;M=m+16|0;o=m+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[o>>2]|0)>0){M=f[m+40>>2]|0;j=0;do{f[M+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))g0(o);o=l+36|0;m=f[o>>2]|0;do if(m|0){j=m+12|0;M=f[j>>2]|0;f[j>>2]=M+-1;if((M|0)!=1)break;_S(l)}while(0);f[o>>2]=0;o=l+16|0;m=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[l+40>>2]|0;M=0;do{f[o+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=k;return}g0(m);u=k;return}function LIb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;do if((d$(b)|0)==65536){j=f[b+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;ZS(g,j);break}}else a$(g,b,-1);while(0);do if((d$(c)|0)==65536){j=f[c+4>>2]|0;f[h>>2]=f[j>>2];k=h+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=h+8|0;f[m>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=m;m=h+48|0;n=h+44|0;f[n>>2]=m;f[m>>2]=0;f[h+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[n>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;ZS(h,j);break}}else a$(h,c,-1);while(0);if(f[g>>2]&4095|0){c=i+8|0;f[c>>2]=0;f[c+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=g;Oga(b,i,6,0)}b=f[a+8>>2]|0;f[i+4>>2]=0;c=i+8|0;f[c>>2]=0;f[i+12>>2]=0;f[i>>2]=(b|0)==0?1:b<<1;OIb(i,g);PIb(i,f[a+4>>2]|0,d);SHb(d,h);d=i+4|0;i=f[d>>2]|0;if(i|0){while(1){a=f[c>>2]|0;if((a|0)==(i|0))break;b=a+-328|0;f[c>>2]=b;QIb(b)}YDc(f[d>>2]|0)}d=h+36|0;c=f[d>>2]|0;if(c|0?(i=c+12|0,c=f[i>>2]|0,f[i>>2]=c+-1,(c|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;c=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[h+40>>2]|0;i=0;do{f[d+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))g0(c);c=g+36|0;h=f[c>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)_S(g);f[c>>2]=0;c=g+16|0;h=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[h>>2]|0)>0){c=f[g+40>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}g0(h);u=e;return}function MIb(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=+e;g=+g;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;l=u;u=u+16|0;m=l;o=f[a+12>>2]|0;p=(Y(f[a+16>>2]|0,(i<<10)+j|0)|0)+k|0;q=+n[o+(p*12|0)>>2]+e;e=+n[o+(p*12|0)+4>>2]+g;k=~~q;j=~~e;i=c+12|0;g=+n[o+(p*12|0)+8>>2];r=g*(g*4.0);if(g<.5){p=~~((q-+(k|0))*1024.0);o=~~((e-+(j|0))*1024.0);a=1024-p|0;s=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,j)|0)+k|0;k=f[c+48>>2]|0;j=Y(h[s>>0]|0,a)|0;t=Y(h[s+1>>0]|0,p)|0;v=Y(h[s+k>>0]|0,p)|0;w=(Y(t+j|0,1024-o|0)|0)+512+(Y((Y(h[s+(k+1)>>0]|0,a)|0)+v|0,o)|0)|0;x=1024;y=(w|0)/(x|0)|0;u=l;return y|0}o=~~(4194304.0/r);z=+(o|0);v=~~(r*z*.0009765625);if(!v){f[m>>2]=0;f[m+4>>2]=0;a=tT(m,13)|0;k=461194;s=a+13|0;do{b[a>>0]=b[k>>0]|0;a=a+1|0;k=k+1|0}while((a|0)<(s|0));NIb(m,461208,509)}m=f[i>>2]|0;i=m+1|0;r=q-g;A=q+g;q=e-g;B=e+g;k=~~(r+.5);a=~~(q+.5);s=~~(A+.5);j=~~(B+.5);g=+(k|0)-r+.5;r=+(a|0)-q+.5;q=A-+(s|0)+.5;A=B-+(j|0)+.5;t=s-k|0;s=t+-1|0;p=1-t|0;C=j-a+-1|0;j=~~(z*(q*r));D=~~(z*(q*A));E=~~(z*(g*A));F=~~(z*g);G=~~(z*r);H=~~(z*q);I=~~(z*A);J=(f[c+16>>2]|0)+k+(Y(m,a)|0)|0;c=Y(h[J>>0]|0,~~(z*(g*r)))|0;if((s+C|0)>2){K=J+t|0;L=(Y(h[K>>0]|0,j)|0)+c|0;M=K+((Y(m,C)|0)+1)|0;K=L+(Y(h[M>>0]|0,D)|0)|0;L=K+(Y(h[M+(0-t)>>0]|0,E)|0)|0;M=(f[d+16>>2]|0)+(k<<2)+((Y(i,a)|0)<<2)+4|0;a=M+(s<<2)|0;s=a+(i<<2)|0;k=f[s>>2]|0;d=s+4|0;s=Y(i,C)|0;K=d+(s<<2)|0;N=K+-4|0;O=f[N>>2]|0;P=N+(i<<2)|0;i=P+(p<<2)|0;N=i+(~m<<2)|0;Q=f[N>>2]|0;R=N+-4|0;N=R+(0-s<<2)|0;s=f[N+4>>2]|0;S=L+(Y(k-(f[d>>2]|0)+(f[K>>2]|0)-O|0,H)|0)+(Y((f[P>>2]|0)-O-(f[i>>2]|0)+Q|0,I)|0)+(Y((f[M>>2]|0)-(f[a>>2]|0)+k-s|0,G)|0)+(Y(O-k-Q+s|0,o)|0)+(Y(Q-(f[R>>2]|0)+(f[N>>2]|0)-s|0,F)|0)|0}else{s=J+1|0;N=J+t|0;R=(t|0)>1;Q=h[s>>0]|0;if(R){k=c;O=s;s=Q;while(1){a=(Y(s,G)|0)+k|0;M=O+1|0;i=h[M>>0]|0;if(M>>>0<N>>>0){k=a;O=M;s=i}else{T=a;U=i;V=O;break}}}else{T=c;U=Q;V=J}J=(Y(U,j)|0)+T|0;T=p+-1+m|0;p=V+1+T|0;V=Y(m,C)|0;C=p+V|0;m=h[p>>0]|0;if((V|0)>0){V=J;j=p;U=m;while(1){Q=(Y(U,F)|0)+V|0;c=j+1|0;O=j+t|0;s=h[c>>0]|0;if(R){k=c;c=Q;N=s;while(1){G=(Y(N,o)|0)+c|0;i=k+1|0;a=h[i>>0]|0;if(i>>>0<O>>>0){k=i;c=G;N=a}else{W=G;X=a;Z=k;break}}}else{W=Q;X=s;Z=j}k=(Y(X,H)|0)+W|0;N=Z+1+T|0;c=h[N>>0]|0;if(N>>>0<C>>>0){V=k;j=N;U=c}else{_=k;$=N;aa=c;break}}}else{_=J;$=p;aa=m}m=(Y(aa,E)|0)+_|0;_=$+1|0;E=$+t|0;t=h[_>>0]|0;if(R){R=_;_=m;$=t;while(1){aa=(Y($,I)|0)+_|0;R=R+1|0;p=h[R>>0]|0;if(R>>>0>=E>>>0){ba=aa;ca=p;break}else{_=aa;$=p}}}else{ba=m;ca=t}S=(Y(ca,D)|0)+ba|0}w=S+((v|0)/2|0)|0;x=v;y=(w|0)/(x|0)|0;u=l;return y|0}function NIb(a,b,c){a=a|0;b=b|0;c=c|0;z5(-215,a,b,461124,c);return}function OIb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+720|0;d=c+384|0;e=c+56|0;g=c;h=a+4|0;i=f[h>>2]|0;j=a+8|0;while(1){k=f[j>>2]|0;if((k|0)==(i|0))break;l=k+-328|0;f[j>>2]=l;QIb(l)}f[g>>2]=1124007936;i=g+4|0;l=g+8|0;k=g+40|0;m=i;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[k>>2]=l;l=g+48|0;m=g+44|0;f[m>>2]=l;f[l>>2]=0;f[g+52>>2]=0;n=d+8|0;f[n>>2]=0;f[n+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=g;h_(b,d);ZIb(e,g,1.0,0.0);b=f[j>>2]|0;n=a+12|0;if((b|0)==(f[n>>2]|0))$Ib(h,e);else{_Ib(b,e);f[j>>2]=(f[j>>2]|0)+328}QIb(e);e=g+36|0;b=f[e>>2]|0;if(b|0?(o=b+12|0,b=f[o>>2]|0,f[o>>2]=b+-1,(b|0)==1):0)_S(g);f[e>>2]=0;e=g+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[i>>2]|0)>0){e=f[k>>2]|0;k=0;do{f[e+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[m>>2]|0;if((i|0)!=(l|0))g0(i);if((f[a>>2]|0)<=1){u=c;return}aJb(d,(f[j>>2]|0)+-328|0,1);i=f[j>>2]|0;if((i|0)==(f[n>>2]|0))$Ib(h,d);else{_Ib(i,d);f[j>>2]=(f[j>>2]|0)+328}QIb(d);i=f[a>>2]|0;if((i|0)<=2){u=c;return}a=2;do{aJb(d,(f[h>>2]|0)+((a+-2|0)*328|0)|0,0);l=f[j>>2]|0;if((l|0)==(f[n>>2]|0))$Ib(h,d);else{_Ib(l,d);f[j>>2]=(f[j>>2]|0)+328}QIb(d);aJb(d,(f[h>>2]|0)+((a+-1|0)*328|0)|0,0);l=f[j>>2]|0;if((l|0)==(f[n>>2]|0))$Ib(h,d);else{_Ib(l,d);f[j>>2]=(f[j>>2]|0)+328}QIb(d);a=a+2&255}while((a|0)<(i|0));u=c;return}function PIb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0;e=u;u=u+128|0;g=e+104|0;h=e+100|0;i=e+96|0;j=e+68|0;k=e+116|0;l=e+40|0;m=e+36|0;o=e+32|0;p=e+28|0;q=e;r=d+4|0;s=f[r>>2]|0;t=f[d>>2]|0;v=s;w=t;if((s|0)==(t|0)|(v|0)==(w|0))x=s;else{s=v+(~(((v+-28-t|0)>>>0)/28|0)*28|0)|0;f[r>>2]=s;x=s}s=d+8|0;if((((f[s>>2]|0)-t|0)/28|0)>>>0<2e3){v=VDc(56e3)|0;y=v+(((x-t|0)/28|0)*28|0)|0;t=y;z=v+56e3|0;v=x;if((v|0)==(w|0)){A=t;B=x}else{x=v;v=t;C=y;do{y=x;x=x+-28|0;f[C+-28>>2]=f[x>>2];f[C+-24>>2]=f[y+-24>>2];D=C+-20|0;E=y+-20|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2];f[D+8>>2]=f[E+8>>2];f[D+12>>2]=f[E+12>>2];f[D+16>>2]=f[E+16>>2];C=v+-28|0;v=C}while((x|0)!=(w|0));A=v;B=f[d>>2]|0}f[d>>2]=A;f[r>>2]=t;f[s>>2]=z;if(B|0)YDc(B)}F=+(c|0);c=~~F;f[g>>2]=0;B=g+4|0;f[B>>2]=0;f[g+8>>2]=0;z=f[a>>2]|0;a:do if(z){fIb(g,z);t=f[a>>2]|0;if((t|0)>0){A=a+4|0;v=0;do{RIb((f[A>>2]|0)+(v*328|0)|0,c,(f[g>>2]|0)+(v*12|0)|0);v=v+1|0;G=f[a>>2]|0}while((v|0)<(G|0));if((G|0)==1){v=f[g>>2]|0;A=(f[v+4>>2]|0)-(f[v>>2]|0)|0;w=(A|0)/28|0;if(A|0){A=v;v=a+4|0;x=j+4|0;C=j+8|0;E=j+12|0;D=j+16|0;y=j+20|0;H=j+24|0;if((f[B>>2]|0)==(A|0))nCc(g);else{I=0;J=A}do{A=f[J>>2]|0;K=A+(I*28|0)|0;L=A+(I*28|0)+4|0;if(SIb(a,0,~~+n[K>>2],~~+n[L>>2])|0){A=f[v>>2]|0;M=TIb(A,+n[K>>2]+-1.0,+n[L>>2]+-1.0,1,1.0)|0;N=TIb(A,+n[K>>2],+n[L>>2]+-1.0,1,1.0)|0;O=TIb(A,+n[K>>2]+1.0,+n[L>>2]+-1.0,1,1.0)|0;P=TIb(A,+n[K>>2]+1.0,+n[L>>2],1,1.0)|0;Q=TIb(A,+n[K>>2],+n[L>>2],1,1.0)|0;R=TIb(A,+n[K>>2]+-1.0,+n[L>>2],1,1.0)|0;S=TIb(A,+n[K>>2]+-1.0,+n[L>>2]+1.0,1,1.0)|0;T=TIb(A,+n[K>>2],+n[L>>2]+1.0,1,1.0)|0;U=+UIb(a,M,R,S,N,Q,T,O,P,TIb(A,+n[K>>2]+1.0,+n[L>>2]+1.0,1,1.0)|0,h,i);V=+n[K>>2]+ +n[h>>2];W=+n[L>>2]+ +n[i>>2];n[j>>2]=V;n[x>>2]=W;n[C>>2]=12.0;n[E>>2]=-1.0;n[D>>2]=U;f[y>>2]=0;f[H>>2]=-1;L=f[r>>2]|0;if((L|0)==(f[s>>2]|0))V_(d,j);else{n[L>>2]=V;n[L+4>>2]=W;K=L+8|0;f[K>>2]=f[C>>2];f[K+4>>2]=f[C+4>>2];f[K+8>>2]=f[C+8>>2];f[K+12>>2]=f[C+12>>2];f[K+16>>2]=f[C+16>>2];f[r>>2]=(f[r>>2]|0)+28}}I=I+1|0;if(I>>>0>=w>>>0)break a;J=f[g>>2]|0}while((f[B>>2]|0)!=(J|0));nCc(g)}}else{X=G;Y=24}}else{X=t;Y=24}}else{X=0;Y=24}while(0);if((Y|0)==24)b:do if((X|0)>0){G=a+4|0;J=q+4|0;I=q+8|0;z=q+12|0;w=q+16|0;C=q+20|0;H=q+24|0;y=l+4|0;D=l+8|0;E=l+12|0;x=l+16|0;v=l+20|0;K=l+24|0;L=0;A=X;c:while(1){P=f[G>>2]|0;O=P+(L*328|0)|0;T=f[g>>2]|0;Q=(f[T+(L*12|0)+4>>2]|0)-(f[T+(L*12|0)>>2]|0)|0;N=(Q|0)/28|0;S=(Q|0)!=0;Q=T;d:do if((L|0)==(A+-1|0)){if(S){T=P+(L*328|0)+112|0;R=P+(L*328|0)+116|0;if((((f[B>>2]|0)-Q|0)/12|0)>>>0>L>>>0){Z=0;_=Q}else{Y=32;break c}while(1){M=f[_+(L*12|0)>>2]|0;$=M+(Z*28|0)|0;aa=M+(Z*28|0)+4|0;if(SIb(a,L,~~+n[$>>2],~~+n[aa>>2])|0?(W=+n[$>>2],V=+n[aa>>2],+VIb(a,L,~~W,~~V,TIb(O,W,V,c,1.0)|0,k,l,m),b[k>>0]|0):0){M=TIb(O,+n[$>>2]+-1.0,+n[aa>>2]+-1.0,1,1.0)|0;ba=TIb(O,+n[$>>2],+n[aa>>2]+-1.0,1,1.0)|0;ca=TIb(O,+n[$>>2]+1.0,+n[aa>>2]+-1.0,1,1.0)|0;da=TIb(O,+n[$>>2]+1.0,+n[aa>>2],1,1.0)|0;ea=TIb(O,+n[$>>2],+n[aa>>2],1,1.0)|0;fa=TIb(O,+n[$>>2]+-1.0,+n[aa>>2],1,1.0)|0;ga=TIb(O,+n[$>>2]+-1.0,+n[aa>>2]+1.0,1,1.0)|0;ha=TIb(O,+n[$>>2],+n[aa>>2]+1.0,1,1.0)|0;V=+UIb(a,M,fa,ga,ba,ea,ha,ca,da,TIb(O,+n[$>>2]+1.0,+n[aa>>2]+1.0,1,1.0)|0,o,p);W=+n[T>>2];U=+n[R>>2];ia=(+n[$>>2]+ +n[o>>2])*W+U;ja=U+W*(+n[aa>>2]+ +n[p>>2]);n[q>>2]=ia;n[J>>2]=ja;n[I>>2]=W*12.0;n[z>>2]=-1.0;n[w>>2]=V;f[C>>2]=L;f[H>>2]=-1;aa=f[r>>2]|0;if((aa|0)==(f[s>>2]|0))V_(d,q);else{n[aa>>2]=ia;n[aa+4>>2]=ja;$=aa+8|0;f[$>>2]=f[I>>2];f[$+4>>2]=f[I+4>>2];f[$+8>>2]=f[I+8>>2];f[$+12>>2]=f[I+12>>2];f[$+16>>2]=f[I+16>>2];f[r>>2]=(f[r>>2]|0)+28}}Z=Z+1|0;if(Z>>>0>=N>>>0)break d;_=f[g>>2]|0;if((((f[B>>2]|0)-_|0)/12|0)>>>0<=L>>>0){Y=32;break c}}}}else if(S){if((((f[B>>2]|0)-Q|0)/12|0)>>>0>L>>>0){ka=0;la=Q}else{Y=42;break c}while(1){R=f[la+(L*12|0)>>2]|0;T=R+(ka*28|0)|0;$=R+(ka*28|0)+4|0;if(SIb(a,L,~~+n[T>>2],~~+n[$>>2])|0?(b[k>>0]=0,ja=+WIb(a,L,~~+n[T>>2],~~+n[$>>2],h,i,j,k),ja>F&(b[k>>0]|0)!=0):0){$=f[h>>2]|0;T=f[i>>2]|0;ia=+n[j>>2]*12.0;f[l>>2]=$;f[y>>2]=T;n[D>>2]=ia;n[E>>2]=-1.0;n[x>>2]=ja;f[v>>2]=L;f[K>>2]=-1;R=f[r>>2]|0;if((R|0)==(f[s>>2]|0))V_(d,l);else{f[R>>2]=$;f[R+4>>2]=T;T=R+8|0;f[T>>2]=f[D>>2];f[T+4>>2]=f[D+4>>2];f[T+8>>2]=f[D+8>>2];f[T+12>>2]=f[D+12>>2];f[T+16>>2]=f[D+16>>2];f[r>>2]=(f[r>>2]|0)+28}}ka=ka+1|0;if(ka>>>0>=N>>>0)break d;la=f[g>>2]|0;if((((f[B>>2]|0)-la|0)/12|0)>>>0<=L>>>0){Y=42;break c}}}while(0);L=L+1|0;A=f[a>>2]|0;if((L|0)>=(A|0))break b}if((Y|0)==32)nCc(g);else if((Y|0)==42)nCc(g)}while(0);Y=f[g>>2]|0;if(!Y){u=e;return}a=f[B>>2]|0;if((a|0)==(Y|0))ma=Y;else{la=a;while(1){a=la+-12|0;f[B>>2]=a;ka=f[a>>2]|0;if(!ka)na=a;else{a=la+-8|0;r=f[a>>2]|0;if((r|0)!=(ka|0))f[a>>2]=r+(~(((r+-28-ka|0)>>>0)/28|0)*28|0);YDc(ka);na=f[B>>2]|0}if((na|0)==(Y|0))break;else la=na}ma=f[g>>2]|0}YDc(ma);u=e;return}function QIb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+120|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+124>>2]=0;b=a+56|0;c=a+92|0;e=f[c>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;e=f[b>>2]|0;if(e|0?(c=e+12|0,e=f[c>>2]|0,f[c>>2]=e+-1,(e|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;e=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[e>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[e>>2]|0))}e=f[a+44>>2]|0;if((e|0)==(a+48|0))return;g0(e);return}function RIb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=a+124|0;i=f[h>>2]|0;mi[f[(f[i>>2]|0)+64>>2]&2047](i,c);c=f[h>>2]|0;h=f[(f[c>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;i=e0()|0;ei[h&511](c,g,d,i);i=f[d>>2]|0;g=(f[d+4>>2]|0)-i|0;c=(g|0)/28|0;if(!g){u=e;return}g=a+72|0;h=a+100|0;a=0;j=i;while(1){i=mrc(+n[j+(a*28|0)+16>>2])|0;k=(f[g>>2]|0)+(Y(f[f[h>>2]>>2]|0,~~+n[j+(a*28|0)+4>>2])|0)+~~+n[j+(a*28|0)>>2]|0;b[k>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+1|0;if(i>>>0>=c>>>0)break;a=i;j=f[d>>2]|0}u=e;return}function SIb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;g=u;u=u+16|0;i=g+4|0;j=g;k=f[a+4>>2]|0;a=f[k+(c*328|0)+68>>2]|0;l=k+(c*328|0)+72|0;c=(f[l>>2]|0)+(Y(a,e)|0)+d|0;k=b[c>>0]|0;m=c+-1|0;c=b[m>>0]|0;n=k&255;o=c&255;if((k&255)<(c&255)){p=0;u=g;return p|0}q=m+2|0;m=b[q>>0]|0;r=m&255;if((k&255)<(m&255)){p=0;u=g;return p|0}s=q+~a|0;q=b[s>>0]|0;t=q&255;if((k&255)<(q&255)){p=0;u=g;return p|0}v=a<<1;w=s+v|0;s=b[w>>0]|0;x=s&255;if((k&255)<(s&255)){p=0;u=g;return p|0}y=w+-1|0;w=b[y>>0]|0;z=w&255;if((k&255)<(w&255)){p=0;u=g;return p|0}A=y+2|0;y=b[A>>0]|0;B=y&255;if((k&255)<(y&255)){p=0;u=g;return p|0}C=A+(0-v)|0;v=b[C>>0]|0;A=v&255;if((k&255)<(v&255)){p=0;u=g;return p|0}D=b[C+-2>>0]|0;C=D&255;if((k&255)<(D&255)){p=0;u=g;return p|0}f[i>>2]=0;E=i+4|0;f[E>>2]=0;f[i+8>>2]=0;if(k<<24>>24==D<<24>>24){f[j>>2]=-1;g6(i,j);D=f[E>>2]|0;F=f[i+8>>2]|0;f[j>>2]=-1;if((D|0)==(F|0))g6(i,j);else{f[D>>2]=-1;f[E>>2]=D+4}}if(k<<24>>24==q<<24>>24){f[j>>2]=0;q=f[E>>2]|0;D=i+8|0;F=f[D>>2]|0;if((q|0)==(F|0)){g6(i,j);G=f[E>>2]|0;H=f[D>>2]|0}else{f[q>>2]=0;D=q+4|0;f[E>>2]=D;G=D;H=F}f[j>>2]=-1;if((G|0)==(H|0))g6(i,j);else{f[G>>2]=-1;f[E>>2]=G+4}}if(k<<24>>24==v<<24>>24){f[j>>2]=1;v=f[E>>2]|0;G=i+8|0;H=f[G>>2]|0;if((v|0)==(H|0)){g6(i,j);I=f[E>>2]|0;J=f[G>>2]|0}else{f[v>>2]=1;G=v+4|0;f[E>>2]=G;I=G;J=H}f[j>>2]=-1;if((I|0)==(J|0))g6(i,j);else{f[I>>2]=-1;f[E>>2]=I+4}}if(k<<24>>24==c<<24>>24){f[j>>2]=-1;c=f[E>>2]|0;I=i+8|0;J=f[I>>2]|0;if((c|0)==(J|0)){g6(i,j);K=f[E>>2]|0;L=f[I>>2]|0}else{f[c>>2]=-1;I=c+4|0;f[E>>2]=I;K=I;L=J}f[j>>2]=0;if((K|0)==(L|0))g6(i,j);else{f[K>>2]=0;f[E>>2]=K+4}}if(k<<24>>24==m<<24>>24){f[j>>2]=1;m=f[E>>2]|0;K=i+8|0;L=f[K>>2]|0;if((m|0)==(L|0)){g6(i,j);M=f[E>>2]|0;N=f[K>>2]|0}else{f[m>>2]=1;K=m+4|0;f[E>>2]=K;M=K;N=L}f[j>>2]=0;if((M|0)==(N|0))g6(i,j);else{f[M>>2]=0;f[E>>2]=M+4}}if(k<<24>>24==w<<24>>24){f[j>>2]=-1;w=f[E>>2]|0;M=i+8|0;N=f[M>>2]|0;if((w|0)==(N|0)){g6(i,j);O=f[E>>2]|0;P=f[M>>2]|0}else{f[w>>2]=-1;M=w+4|0;f[E>>2]=M;O=M;P=N}f[j>>2]=1;if((O|0)==(P|0))g6(i,j);else{f[O>>2]=1;f[E>>2]=O+4}}if(k<<24>>24==s<<24>>24){f[j>>2]=0;s=f[E>>2]|0;O=i+8|0;P=f[O>>2]|0;if((s|0)==(P|0)){g6(i,j);Q=f[E>>2]|0;R=f[O>>2]|0}else{f[s>>2]=0;O=s+4|0;f[E>>2]=O;Q=O;R=P}f[j>>2]=1;if((Q|0)==(R|0))g6(i,j);else{f[Q>>2]=1;f[E>>2]=Q+4}}if(k<<24>>24==y<<24>>24){f[j>>2]=1;y=f[E>>2]|0;k=i+8|0;Q=f[k>>2]|0;if((y|0)==(Q|0)){g6(i,j);S=f[E>>2]|0;T=f[k>>2]|0}else{f[y>>2]=1;k=y+4|0;f[E>>2]=k;S=k;T=Q}f[j>>2]=1;if((S|0)==(T|0))g6(i,j);else{f[S>>2]=1;f[E>>2]=S+4}}S=f[E>>2]|0;j=f[i>>2]|0;i=S-j>>2;T=j;Q=S;a:do if(!i)U=1;else{S=(r+o+t+x<<1)+(n<<2)+z+B+A+C|0;k=f[l>>2]|0;y=e+-1|0;R=0;while(1){P=k+(Y(y+(f[T+((R|1)<<2)>>2]|0)|0,a)|0)+d|0;O=P+(f[T+(R<<2)>>2]|0)+-1|0;P=O+1|0;s=P+1|0;N=s+a|0;M=N+-1|0;w=M+-1|0;L=w+a|0;K=L+1|0;R=R+2|0;if(((h[s>>0]|0)+(h[O>>0]|0)+((h[M>>0]|0)<<2)+(h[L>>0]|0)+(h[K+1>>0]|0)+((h[N>>0]|0)+(h[P>>0]|0)+(h[w>>0]|0)+(h[K>>0]|0)<<1)|0)>(S|0)){U=0;break a}if(R>>>0>=i>>>0){U=1;break}}}while(0);i=j;if(j|0){if((Q|0)!=(T|0))f[E>>2]=Q+(~((Q+-4-j|0)>>>2)<<2);YDc(i)}p=U;u=g;return p|0}function TIb(a,c,d,e,g){a=a|0;c=+c;d=+d;e=e|0;g=+g;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0,I=0.0;if(!(g<=1.0)){i=g*.5;j=~~(c-i);k=~~(i+c+1.0);if((j|0)<=(k|0)?(l=~~(d-i),m=~~(i+d+1.0),n=a+12|0,o=a+8|0,p=a+72|0,q=a+100|0,r=a+16|0,s=a+44|0,t=a+228|0,u=e+-1|0,(l|0)<=(m|0)):0){v=j;while(1){if((v|0)>=3){j=l;while(1){if((((j|0)>=3?((f[n>>2]|0)+-3|0)>(v|0):0)?((f[o>>2]|0)+-3|0)>(j|0):0)?(w=(f[p>>2]|0)+(Y(f[f[q>>2]>>2]|0,j)|0)+v|0,(h[w>>0]|0)<=2):0){x=tLb((f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,j)|0)+v|0,t,u)|0;b[w>>0]=(x&255|0)<(e|0)?0:x&255}if((j|0)<(m|0))j=j+1|0;else break}}if((v|0)<(k|0))v=v+1|0;else break}}y=YIb(a,a+56|0,c,d,g)|0;return y|0}v=~~c;g=c-+(v|0);c=1.0-g;k=~~d;i=d-+(k|0);d=1.0-i;z=c*d;m=(v|0)<3;u=(k|0)<3;if((!(m|u)?((f[a+12>>2]|0)+-3|0)>(v|0):0)?((f[a+8>>2]|0)+-3|0)>(k|0):0){t=(f[a+72>>2]|0)+(Y(f[f[a+100>>2]>>2]|0,k)|0)+v|0;s=b[t>>0]|0;if((s&255)>2)A=s;else{s=tLb((f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,k)|0)+v|0,a+228|0,e+-1|0)|0;r=(s&255|0)<(e|0)?0:s&255;b[t>>0]=r;A=r}B=+(A&255)}else B=0.0;C=z*B;B=g*d;A=v+1|0;r=(A|0)<3;if((!(r|u)?((f[a+12>>2]|0)+-3|0)>(A|0):0)?((f[a+8>>2]|0)+-3|0)>(k|0):0){u=(f[a+72>>2]|0)+(Y(f[f[a+100>>2]>>2]|0,k)|0)+A|0;t=b[u>>0]|0;if((t&255)>2)D=t;else{t=tLb((f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,k)|0)+A|0,a+228|0,e+-1|0)|0;s=(t&255|0)<(e|0)?0:t&255;b[u>>0]=s;D=s}E=+(D&255)}else E=0.0;d=C+B*E;E=c*i;D=k+1|0;k=(D|0)<3;if((!(m|k)?((f[a+12>>2]|0)+-3|0)>(v|0):0)?((f[a+8>>2]|0)+-3|0)>(D|0):0){m=(f[a+72>>2]|0)+(Y(f[f[a+100>>2]>>2]|0,D)|0)+v|0;s=b[m>>0]|0;if((s&255)>2)F=s;else{s=tLb((f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,D)|0)+v|0,a+228|0,e+-1|0)|0;v=(s&255|0)<(e|0)?0:s&255;b[m>>0]=v;F=v}G=+(F&255)}else G=0.0;c=d+E*G;G=g*i;if((!(r|k)?((f[a+12>>2]|0)+-3|0)>(A|0):0)?((f[a+8>>2]|0)+-3|0)>(D|0):0){k=(f[a+72>>2]|0)+(Y(f[f[a+100>>2]>>2]|0,D)|0)+A|0;r=b[k>>0]|0;if((r&255)>2)H=r;else{r=tLb((f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,D)|0)+A|0,a+228|0,e+-1|0)|0;a=(r&255|0)<(e|0)?0:r&255;b[k>>0]=a;H=a}I=+(H&255)}else I=0.0;y=~~(c+G*I)&255;return y|0}function UIb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;a=d+b|0;m=a-(f<<1)+h+j|0;o=g+e|0;p=c-(o<<1)+i+m|0;q=p*3|0;r=o-(i+c<<1)+m|0;m=r*3|0;o=d-h|0;s=o+b-j|0;t=Y(c-i+s|0,-3)|0;u=Y(e-g-(o<<1)+s|0,-3)|0;s=b-d-h+j<<2;d=0-((Y(f,-5)|0)+(a-(e+c+g+i<<1))+h+j)<<1;j=(Y(p*12|0,m)|0)-(Y(s,s)|0)|0;if(!j){n[k>>2]=0.0;n[l>>2]=0.0;v=+(d|0)/18.0;return +v}if(!((p|0)<0&(j|0)>0)){h=t+s+u|0;n[k>>2]=1.0;n[l>>2]=1.0;i=u-t-s|0;if((i|0)>(h|0)){n[k>>2]=-1.0;n[l>>2]=1.0;w=i}else w=h;h=t-u-s|0;if((h|0)>(w|0)){n[k>>2]=1.0;n[l>>2]=-1.0;x=h}else x=w;w=s-t-u|0;if((w|0)>(x|0)){n[k>>2]=-1.0;n[l>>2]=-1.0;y=w}else y=x;v=+(m+q+d+y|0)/18.0;return +v}y=r*6|0;z=+(0-j|0);A=+((Y(y,t)|0)-(Y(u,s)|0)|0)/z;n[k>>2]=A;j=p*6|0;A=+((Y(j,u)|0)-(Y(t,s)|0)|0)/z;n[l>>2]=A;z=+n[k>>2];do if(z>1.0){p=A>1.0;r=A<-1.0;B=-+(u+s|0)/+(y|0);if(!(B>1.0))if(B<-1.0)if(p){C=-1.0;D=1.0;E=21}else{F=-1.0;G=1.0;H=r;E=24}else{I=B;J=1.0;K=p;L=r;E=20}else{I=1.0;J=1.0;K=p;L=r;E=20}}else{r=A>1.0;p=A<-1.0;if(z<-1.0){B=-+(u-s|0)/+(y|0);if(B>1.0){I=1.0;J=-1.0;K=r;L=p;E=20;break}if(!(B<-1.0)){I=B;J=-1.0;K=r;L=p;E=20;break}if(r){C=-1.0;D=-1.0;E=21;break}else{F=-1.0;G=-1.0;H=p;E=24;break}}else{if(p|r){I=0.0;J=0.0;K=r;L=p;E=20;break}v=(+(d|0)+(A*(+(s|0)*z)+(+(u|0)*A+(+(t|0)*z+(A*(+(m|0)*A)+z*(+(q|0)*z))))))/18.0;return +v}}while(0);if((E|0)==20)if(K){C=I;D=J;E=21}else{F=I;G=J;H=L;E=24}if((E|0)==21){J=-+(t+s|0)/+(j|0);if(!(J>1.0))if(J<-1.0){M=1.0;N=C;O=-1.0;P=D}else{M=1.0;N=C;O=J;P=D}else{M=1.0;N=C;O=1.0;P=D}}else if((E|0)==24)if(H){D=-+(t-s|0)/+(j|0);if(!(D>1.0))if(D<-1.0){M=-1.0;N=F;O=-1.0;P=G}else{M=-1.0;N=F;O=D;P=G}else{M=-1.0;N=F;O=1.0;P=G}}else{M=0.0;N=F;O=0.0;P=G}G=+(q|0);F=+(m|0);D=+(t|0);C=+(u|0);J=+(s|0);I=+(d|0);z=(I+(J*P*N+(C*N+(D*P+(P*(G*P)+N*(F*N))))))/18.0;A=(I+(J*O*M+(C*M+(D*O+(O*(G*O)+M*(F*M))))))/18.0;d=z>A;n[k>>2]=d?P:O;n[l>>2]=d?N:M;v=d?z:A;return +v}function VIb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0.0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0,qb=0,rb=0.0,sb=0.0,tb=0,ub=0,vb=0.0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0,Cb=0.0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0,Ib=0,Jb=0.0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0.0,dc=0.0,ec=0,fc=0.0,gc=0.0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;o=k+4|0;p=k;b[h>>0]=0;q=(c&1|0)==0;if(q){r=d<<3;s=e<<3;t=+((r|1)+-4|0)/6.0;v=+(r|5|0)/6.0;w=+((s|1)+-4|0)/6.0;x=+(s|5|0)/6.0}else{s=d*6|1;r=e*6|1;t=+(s+-3|0)*.25;v=+(s+3|0)*.25;w=+(r+-3|0)*.25;x=+(r+3|0)*.25}if((c|0)<=0){f[l>>2]=0;f[l+4>>2]=0;r=tT(l,9)|0;s=461263;y=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(y|0));NIb(l,461273,1634)}s=c+-1|0;c=f[a+4>>2]|0;r=c+(s*328|0)|0;y=~~t;z=y+1|0;A=~~w;B=A+1|0;C=+(TIb(r,t,w,1,1.0)|0);n[l>>2]=C;D=+(g|0);if(C>D){E=0.0;u=k;return +E}g=~~v;F=(y|0)<(g|0);do if(F){G=C;y=z;H=z;I=+n[l>>2];while(1){J=+(TIb(r,+(H|0),w,1,1.0)|0);if(J>D)break;K=J>G;L=K?J:I;G=K?J:G;y=K?H:y;if((H|0)>=(g|0)){M=11;break}else{H=H+1|0;I=L}}if((M|0)==11){n[l>>2]=L;N=G;O=y;break}n[l>>2]=I;E=0.0;u=k;return +E}else{N=C;O=z}while(0);C=+(TIb(r,v,w,1,1.0)|0);if(C>D){E=0.0;u=k;return +E}if(C>N){n[l>>2]=C;P=C;Q=g}else{P=N;Q=O}O=~~x;do if((A|0)<(O|0)){H=~~(t+1.0);K=c+(s*328|0)+12|0;R=c+(s*328|0)+8|0;S=c+(s*328|0)+72|0;T=c+(s*328|0)+100|0;U=c+(s*328|0)+16|0;V=c+(s*328|0)+44|0;W=c+(s*328|0)+228|0;N=P;X=B;Z=B;_=Q;C=+n[l>>2];a:while(1){w=+(Z|0);L=+(TIb(r,t,w,1,1.0)|0);if(L>D){$=C;M=213;break}if(L>N){aa=L;ba=Z;ca=H;da=L}else{aa=N;ba=X;ca=_;da=C}if(F){ea=(Z|0)<3;fa=Z+1|0;ga=(fa|0)<3;ha=Z+-1|0;ia=(Z|0)<4;L=aa;ja=z;ka=ba;la=ca;ma=da;while(1){na=(ja|0)<3;if((!(ea|na)?((f[K>>2]|0)+-3|0)>(ja|0):0)?((f[R>>2]|0)+-3|0)>(Z|0):0){oa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Z)|0)+ja|0;pa=b[oa>>0]|0;if((pa&255)>2)qa=pa;else{pa=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Z)|0)+ja|0,W,0)|0;ra=(pa&255|0)==0?0:pa&255;b[oa>>0]=ra;qa=ra}sa=qa&255}else sa=0;J=+(sa|0);if(J>D){M=212;break a}if(J==L){ra=ja+-1|0;oa=(ja|0)<4;do if(ea|oa)ta=0;else{if(((f[K>>2]|0)+-3|0)<(ja|0)){ta=0;break}if(((f[R>>2]|0)+-3|0)<=(Z|0)){ta=0;break}pa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Z)|0)+ra|0;ua=b[pa>>0]|0;if((ua&255)>2)va=ua;else{ua=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Z)|0)+ra|0,W,0)|0;wa=(ua&255|0)==0?0:ua&255;b[pa>>0]=wa;va=wa}ta=va&255}while(0);wa=ja+1|0;pa=(wa|0)<3;do if(ea|pa)xa=0;else{if(((f[K>>2]|0)+-3|0)<=(wa|0)){xa=0;break}if(((f[R>>2]|0)+-3|0)<=(Z|0)){xa=0;break}ua=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Z)|0)+wa|0;ya=b[ua>>0]|0;if((ya&255)>2)za=ya;else{ya=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Z)|0)+wa|0,W,0)|0;Aa=(ya&255|0)==0?0:ya&255;b[ua>>0]=Aa;za=Aa}xa=za&255}while(0);Aa=xa+ta|0;do if(ga|na)Ba=0;else{if(((f[K>>2]|0)+-3|0)<=(ja|0)){Ba=0;break}if(((f[R>>2]|0)+-3|0)<=(fa|0)){Ba=0;break}ua=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,fa)|0)+ja|0;ya=b[ua>>0]|0;if((ya&255)>2)Ca=ya;else{ya=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,fa)|0)+ja|0,W,0)|0;Da=(ya&255|0)==0?0:ya&255;b[ua>>0]=Da;Ca=Da}Ba=Ca&255}while(0);Da=Aa+Ba|0;do if(ia|na)Ea=0;else{if(((f[K>>2]|0)+-3|0)<=(ja|0)){Ea=0;break}if(((f[R>>2]|0)+-3|0)<(Z|0)){Ea=0;break}ua=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ha)|0)+ja|0;ya=b[ua>>0]|0;if((ya&255)>2)Fa=ya;else{ya=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ha)|0)+ja|0,W,0)|0;Ga=(ya&255|0)==0?0:ya&255;b[ua>>0]=Ga;Fa=Ga}Ea=Fa&255}while(0);na=Da+Ea<<1;do if(ga|pa)Ha=0;else{if(((f[K>>2]|0)+-3|0)<=(wa|0)){Ha=0;break}if(((f[R>>2]|0)+-3|0)<=(fa|0)){Ha=0;break}Aa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,fa)|0)+wa|0;Ga=b[Aa>>0]|0;if((Ga&255)>2)Ia=Ga;else{Ga=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,fa)|0)+wa|0,W,0)|0;ua=(Ga&255|0)==0?0:Ga&255;b[Aa>>0]=ua;Ia=ua}Ha=Ia&255}while(0);do if(ga|oa)Ja=0;else{if(((f[K>>2]|0)+-3|0)<(ja|0)){Ja=0;break}if(((f[R>>2]|0)+-3|0)<=(fa|0)){Ja=0;break}Da=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,fa)|0)+ra|0;ua=b[Da>>0]|0;if((ua&255)>2)Ka=ua;else{ua=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,fa)|0)+ra|0,W,0)|0;Aa=(ua&255|0)==0?0:ua&255;b[Da>>0]=Aa;Ka=Aa}Ja=Ka&255}while(0);do if(ia|pa)La=0;else{if(((f[K>>2]|0)+-3|0)<=(wa|0)){La=0;break}if(((f[R>>2]|0)+-3|0)<(Z|0)){La=0;break}Aa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ha)|0)+wa|0;Da=b[Aa>>0]|0;if((Da&255)>2)Ma=Da;else{Da=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ha)|0)+wa|0,W,0)|0;ua=(Da&255|0)==0?0:Da&255;b[Aa>>0]=ua;Ma=ua}La=Ma&255}while(0);do if(ia|oa)Na=0;else{if(((f[K>>2]|0)+-3|0)<(ja|0)){Na=0;break}if(((f[R>>2]|0)+-3|0)<(Z|0)){Na=0;break}wa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ha)|0)+ra|0;pa=b[wa>>0]|0;if((pa&255)>2)Oa=pa;else{pa=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ha)|0)+ra|0,W,0)|0;ua=(pa&255|0)==0?0:pa&255;b[wa>>0]=ua;Oa=ua}Na=Oa&255}while(0);ra=Ha+na+Ja+La+Na|0;oa=la+-1|0;ua=(la|0)<4;wa=(ka|0)<3;do if(wa|ua)Pa=0;else{if(((f[K>>2]|0)+-3|0)<(la|0)){Pa=0;break}if(((f[R>>2]|0)+-3|0)<=(ka|0)){Pa=0;break}pa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ka)|0)+oa|0;Aa=b[pa>>0]|0;if((Aa&255)>2)Qa=Aa;else{Aa=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ka)|0)+oa|0,W,0)|0;Da=(Aa&255|0)==0?0:Aa&255;b[pa>>0]=Da;Qa=Da}Pa=Qa&255}while(0);na=la+1|0;Da=(na|0)<3;do if(wa|Da)Ra=0;else{if(((f[K>>2]|0)+-3|0)<=(na|0)){Ra=0;break}if(((f[R>>2]|0)+-3|0)<=(ka|0)){Ra=0;break}pa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ka)|0)+na|0;Aa=b[pa>>0]|0;if((Aa&255)>2)Sa=Aa;else{Aa=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ka)|0)+na|0,W,0)|0;Ga=(Aa&255|0)==0?0:Aa&255;b[pa>>0]=Ga;Sa=Ga}Ra=Sa&255}while(0);wa=Ra+Pa|0;Ga=ka+1|0;pa=(la|0)<3;Aa=(Ga|0)<3;do if(pa|Aa)Ta=0;else{if(((f[K>>2]|0)+-3|0)<=(la|0)){Ta=0;break}if(((f[R>>2]|0)+-3|0)<=(Ga|0)){Ta=0;break}ya=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Ga)|0)+la|0;Ua=b[ya>>0]|0;if((Ua&255)>2)Va=Ua;else{Ua=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Ga)|0)+la|0,W,0)|0;Wa=(Ua&255|0)==0?0:Ua&255;b[ya>>0]=Wa;Va=Wa}Ta=Va&255}while(0);Wa=wa+Ta|0;ya=ka+-1|0;Ua=(ka|0)<4;do if(Ua|pa)Xa=0;else{if(((f[K>>2]|0)+-3|0)<=(la|0)){Xa=0;break}if(((f[R>>2]|0)+-3|0)<(ka|0)){Xa=0;break}Ya=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ya)|0)+la|0;Za=b[Ya>>0]|0;if((Za&255)>2)_a=Za;else{Za=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ya)|0)+la|0,W,0)|0;$a=(Za&255|0)==0?0:Za&255;b[Ya>>0]=$a;_a=$a}Xa=_a&255}while(0);pa=Wa+Xa<<1;do if(Aa|Da)ab=0;else{if(((f[K>>2]|0)+-3|0)<=(na|0)){ab=0;break}if(((f[R>>2]|0)+-3|0)<=(Ga|0)){ab=0;break}wa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Ga)|0)+na|0;$a=b[wa>>0]|0;if(($a&255)>2)bb=$a;else{$a=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Ga)|0)+na|0,W,0)|0;Ya=($a&255|0)==0?0:$a&255;b[wa>>0]=Ya;bb=Ya}ab=bb&255}while(0);do if(ua|Aa)cb=0;else{if(((f[K>>2]|0)+-3|0)<(la|0)){cb=0;break}if(((f[R>>2]|0)+-3|0)<=(Ga|0)){cb=0;break}Wa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Ga)|0)+oa|0;Ya=b[Wa>>0]|0;if((Ya&255)>2)db=Ya;else{Ya=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Ga)|0)+oa|0,W,0)|0;wa=(Ya&255|0)==0?0:Ya&255;b[Wa>>0]=wa;db=wa}cb=db&255}while(0);do if(Ua|Da)eb=0;else{if(((f[K>>2]|0)+-3|0)<=(na|0)){eb=0;break}if(((f[R>>2]|0)+-3|0)<(ka|0)){eb=0;break}Ga=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ya)|0)+na|0;Aa=b[Ga>>0]|0;if((Aa&255)>2)fb=Aa;else{Aa=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ya)|0)+na|0,W,0)|0;wa=(Aa&255|0)==0?0:Aa&255;b[Ga>>0]=wa;fb=wa}eb=fb&255}while(0);do if(Ua|ua)gb=0;else{if(((f[K>>2]|0)+-3|0)<(la|0)){gb=0;break}if(((f[R>>2]|0)+-3|0)<(ka|0)){gb=0;break}na=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ya)|0)+oa|0;Da=b[na>>0]|0;if((Da&255)>2)hb=Da;else{Da=tLb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ya)|0)+oa|0,W,0)|0;wa=(Da&255|0)==0?0:Da&255;b[na>>0]=wa;hb=wa}gb=hb&255}while(0);oa=(ra|0)>(ab+pa+cb+eb+gb|0);ib=oa?Z:ka;jb=oa?ja:la}else{ib=ka;jb=la}if(J>L){kb=J;lb=Z;mb=ja;nb=J}else{kb=L;lb=ib;mb=jb;nb=ma}if((ja|0)<(g|0)){L=kb;ja=ja+1|0;ka=lb;la=mb;ma=nb}else{ob=kb;pb=lb;qb=mb;rb=nb;break}}}else{ob=aa;pb=ba;qb=ca;rb=da}L=+(TIb(r,v,w,1,1.0)|0);if(L>D){$=rb;M=213;break}if(L>ob){sb=L;tb=Z;ub=g;vb=L}else{sb=ob;tb=pb;ub=qb;vb=rb}if((Z|0)<(O|0)){N=sb;X=tb;Z=Z+1|0;_=ub;C=vb}else{M=134;break}}if((M|0)==134){n[l>>2]=vb;wb=sb;xb=tb;yb=ub;break}else if((M|0)==212){n[l>>2]=ma;E=0.0;u=k;return +E}else if((M|0)==213){n[l>>2]=$;E=0.0;u=k;return +E}}else{wb=P;xb=B;yb=Q}while(0);P=+(TIb(r,t,x,1,1.0)|0);if(P>wb){n[l>>2]=P;zb=P;Ab=~~(t+1.0);Bb=O}else{zb=wb;Ab=yb;Bb=xb}if(F){wb=zb;F=z;z=Ab;xb=Bb;t=+n[l>>2];while(1){P=+(TIb(r,+(F|0),x,1,1.0)|0);if(P>wb){Cb=P;Db=O;Eb=F;Fb=P}else{Cb=wb;Db=xb;Eb=z;Fb=t}if((F|0)<(g|0)){wb=Cb;F=F+1|0;z=Eb;xb=Db;t=Fb}else break}n[l>>2]=Fb;Gb=Cb;Hb=Eb;Ib=Db}else{Gb=zb;Hb=Ab;Ib=Bb}zb=+(TIb(r,v,x,1,1.0)|0);if(zb>Gb){n[l>>2]=zb;Jb=zb;Kb=O;Lb=g}else{Jb=Gb;Kb=Ib;Lb=Hb}Hb=Lb+-1|0;Ib=Kb+-1|0;g=(Lb|0)<4;O=(Kb|0)<4;if((!(O|g)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>=(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>=(Kb|0):0){r=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Ib)|0)+Hb|0;Bb=b[r>>0]|0;if((Bb&255)>2)Mb=Bb;else{Bb=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Ib)|0)+Hb|0,c+(s*328|0)+228|0,0)|0;Ab=(Bb&255|0)==0?0:Bb&255;b[r>>0]=Ab;Mb=Ab}Nb=Mb&255}else Nb=0;Mb=(Lb|0)<3;if((!(O|Mb)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>=(Kb|0):0){Ab=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Ib)|0)+Lb|0;r=b[Ab>>0]|0;if((r&255)>2)Ob=r;else{r=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Ib)|0)+Lb|0,c+(s*328|0)+228|0,0)|0;Bb=(r&255|0)==0?0:r&255;b[Ab>>0]=Bb;Ob=Bb}Pb=Ob&255}else Pb=0;Ob=Lb+1|0;Bb=(Ob|0)<3;if((!(O|Bb)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Ob|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>=(Kb|0):0){O=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Ib)|0)+Ob|0;Ab=b[O>>0]|0;if((Ab&255)>2)Qb=Ab;else{Ab=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Ib)|0)+Ob|0,c+(s*328|0)+228|0,0)|0;Ib=(Ab&255|0)==0?0:Ab&255;b[O>>0]=Ib;Qb=Ib}Rb=Qb&255}else Rb=0;Qb=(Kb|0)<3;if((!(Qb|Bb)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Ob|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>(Kb|0):0){Ib=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Kb)|0)+Ob|0;O=b[Ib>>0]|0;if((O&255)>2)Sb=O;else{O=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Kb)|0)+Ob|0,c+(s*328|0)+228|0,0)|0;Ab=(O&255|0)==0?0:O&255;b[Ib>>0]=Ab;Sb=Ab}Tb=Sb&255}else Tb=0;if((!(Qb|Mb)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>(Kb|0):0){Sb=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Kb)|0)+Lb|0;Ab=b[Sb>>0]|0;if((Ab&255)>2)Ub=Ab;else{Ab=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Kb)|0)+Lb|0,c+(s*328|0)+228|0,0)|0;Ib=(Ab&255|0)==0?0:Ab&255;b[Sb>>0]=Ib;Ub=Ib}Vb=Ub&255}else Vb=0;if((!(Qb|g)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>=(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>(Kb|0):0){Qb=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Kb)|0)+Hb|0;Ub=b[Qb>>0]|0;if((Ub&255)>2)Wb=Ub;else{Ub=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Kb)|0)+Hb|0,c+(s*328|0)+228|0,0)|0;Ib=(Ub&255|0)==0?0:Ub&255;b[Qb>>0]=Ib;Wb=Ib}Xb=Wb&255}else Xb=0;Wb=Kb+1|0;Ib=(Wb|0)<3;if((!(g|Ib)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>=(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>(Wb|0):0){g=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Wb)|0)+Hb|0;Qb=b[g>>0]|0;if((Qb&255)>2)Yb=Qb;else{Qb=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Wb)|0)+Hb|0,c+(s*328|0)+228|0,0)|0;Hb=(Qb&255|0)==0?0:Qb&255;b[g>>0]=Hb;Yb=Hb}Zb=Yb&255}else Zb=0;do if(!(Mb|Ib)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Lb|0):0){if(((f[c+(s*328|0)+8>>2]|0)+-3|0)<=(Wb|0)){_b=0;break}Yb=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Wb)|0)+Lb|0;Hb=b[Yb>>0]|0;if((Hb&255)>2)$b=Hb;else{Hb=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Wb)|0)+Lb|0,c+(s*328|0)+228|0,0)|0;g=(Hb&255|0)==0?0:Hb&255;b[Yb>>0]=g;$b=g}_b=$b&255}else _b=0;while(0);do if(Ib|Bb)ac=0;else{if(((f[c+(s*328|0)+12>>2]|0)+-3|0)<=(Ob|0)){ac=0;break}if(((f[c+(s*328|0)+8>>2]|0)+-3|0)<=(Wb|0)){ac=0;break}$b=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Wb)|0)+Ob|0;Mb=b[$b>>0]|0;if((Mb&255)>2)bc=Mb;else{Mb=tLb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Wb)|0)+Ob|0,c+(s*328|0)+228|0,0)|0;g=(Mb&255|0)==0?0:Mb&255;b[$b>>0]=g;bc=g}ac=bc&255}while(0);Gb=+UIb(a,Nb,Xb,Zb,Pb,Vb,_b,Rb,Tb,ac,m,o);n[p>>2]=Gb;zb=+(Lb|0)+ +n[m>>2];x=+(d|0);v=+(Kb|0)+ +n[o>>2];if(q){n[i>>2]=(zb*6.0+1.0)*.125-x;cc=(v*6.0+1.0)*.125}else{n[i>>2]=(zb*4.0+-1.0)/6.0-x;cc=(v*4.0+-1.0)/6.0}v=cc-+(e|0);n[j>>2]=v;cc=+n[i>>2];if(!(cc>1.0))if(cc<-1.0){dc=-1.0;M=204}else{ec=1;fc=v}else{dc=1.0;M=204}if((M|0)==204){n[i>>2]=dc;ec=0;fc=+n[j>>2]}do if(fc>1.0){n[j>>2]=1.0;b[h>>0]=1;gc=Jb}else{if(fc<-1.0){n[j>>2]=-1.0;b[h>>0]=1;gc=Jb;break}b[h>>0]=1;if(!ec){gc=Jb;break}gc=Gb<Jb?+n[l>>2]:+n[p>>2]}while(0);E=gc;u=k;return +E}function WIb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0;k=u;u=u+32|0;l=k+20|0;m=k+16|0;o=k+12|0;p=k+8|0;q=k+4|0;r=k;b[j>>0]=1;s=a+4|0;t=f[s>>2]|0;v=(d|0)<3;w=(e|0)<3;x=v|w;if((!x?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){y=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+d|0;z=b[y>>0]|0;if((z&255)>2)A=z;else{z=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+d|0,t+(c*328|0)+228|0,0)|0;B=(z&255|0)==0?0:z&255;b[y>>0]=B;A=B}C=A&255}else C=0;n[l>>2]=0.0;n[m>>2]=0.0;D=+XIb(a,c,d,e,C,j,l,m);if(!(b[j>>0]|0)){E=0.0;u=k;return +E}if(!(c&1)){A=(c|0)==0;do if(A){B=f[s>>2]|0;y=d+-1|0;z=e+-1|0;if((!x?((f[B+12>>2]|0)+-2|0)>=(d|0):0)?((f[B+8>>2]|0)+-2|0)>=(e|0):0){F=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,z)|0)+y|0,B+128|0,0)|0;G=(F|0)>0?F:0}else G=0;F=(d|0)<2;if((!(F|w)?((f[B+12>>2]|0)+-2|0)>(d|0):0)?((f[B+8>>2]|0)+-2|0)>=(e|0):0){H=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,z)|0)+d|0,B+128|0,0)|0;I=(H|0)>0?H:0}else I=0;H=I>>>0<G>>>0?G:I;J=d+1|0;K=(J|0)<2;if((!(K|w)?((f[B+12>>2]|0)+-2|0)>(J|0):0)?((f[B+8>>2]|0)+-2|0)>=(e|0):0){L=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,z)|0)+J|0,B+128|0,0)|0;M=(L|0)>0?L:0}else M=0;L=(M|0)<(H|0)?H:M;H=(e|0)<2;if((!(K|H)?((f[B+12>>2]|0)+-2|0)>(J|0):0)?((f[B+8>>2]|0)+-2|0)>(e|0):0){N=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,e)|0)+J|0,B+128|0,0)|0;O=(N|0)>0?N:0}else O=0;N=(O|0)<(L|0)?L:O;if((!(F|H)?((f[B+12>>2]|0)+-2|0)>(d|0):0)?((f[B+8>>2]|0)+-2|0)>(e|0):0){L=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,e)|0)+d|0,B+128|0,0)|0;P=(L|0)>0?L:0}else P=0;L=(P|0)<(N|0)?N:P;if((!(v|H)?((f[B+12>>2]|0)+-2|0)>=(d|0):0)?((f[B+8>>2]|0)+-2|0)>(e|0):0){H=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,e)|0)+y|0,B+128|0,0)|0;Q=(H|0)>0?H:0}else Q=0;H=(Q|0)<(L|0)?L:Q;L=e+1|0;N=(L|0)<2;if((!(v|N)?((f[B+12>>2]|0)+-2|0)>=(d|0):0)?((f[B+8>>2]|0)+-2|0)>(L|0):0){R=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,L)|0)+y|0,B+128|0,0)|0;S=(R|0)>0?R:0}else S=0;R=(S|0)<(H|0)?H:S;if((!(F|N)?((f[B+12>>2]|0)+-2|0)>(d|0):0)?((f[B+8>>2]|0)+-2|0)>(L|0):0){F=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,L)|0)+d|0,B+128|0,0)|0;T=(F|0)>0?F:0}else T=0;F=(T|0)<(R|0)?R:T;if((!(K|N)?((f[B+12>>2]|0)+-2|0)>(J|0):0)?((f[B+8>>2]|0)+-2|0)>(L|0):0){N=qLb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,L)|0)+J|0,B+128|0,0)|0;U=(N|0)>0?N:0}else U=0;+UIb(a,G,Q,S,I,P,T,M,O,U,o,p);V=+(((U|0)<(F|0)?F:U)|0);W=y;X=z}else{Z=+VIb(a,c,d,e,C,j,o,p);if(b[j>>0]|0){V=Z;W=d+-1|0;X=e+-1|0;break}E=0.0;u=k;return +E}while(0);U=(d|0)<4;O=(e|0)<4;if((!(U|O)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){M=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,X)|0)+W|0;T=b[M>>0]|0;if((T&255)>2)_=T;else{T=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,X)|0)+W|0,t+(c*328|0)+228|0,0)|0;P=(T&255|0)==0?0:T&255;b[M>>0]=P;_=P}$=_&255}else $=0;if((!(v|O)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){_=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,X)|0)+d|0;P=b[_>>0]|0;if((P&255)>2)aa=P;else{P=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,X)|0)+d|0,t+(c*328|0)+228|0,0)|0;M=(P&255|0)==0?0:P&255;b[_>>0]=M;aa=M}ba=aa&255}else ba=0;aa=d+1|0;M=(aa|0)<3;if((!(M|O)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(aa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){O=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,X)|0)+aa|0;_=b[O>>0]|0;if((_&255)>2)ca=_;else{_=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,X)|0)+aa|0,t+(c*328|0)+228|0,0)|0;X=(_&255|0)==0?0:_&255;b[O>>0]=X;ca=X}da=ca&255}else da=0;if((!(M|w)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(aa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){ca=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+aa|0;X=b[ca>>0]|0;if((X&255)>2)ea=X;else{X=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+aa|0,t+(c*328|0)+228|0,0)|0;O=(X&255|0)==0?0:X&255;b[ca>>0]=O;ea=O}fa=ea&255}else fa=0;if((!x?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){ea=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+d|0;O=b[ea>>0]|0;if((O&255)>2)ga=O;else{O=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+d|0,t+(c*328|0)+228|0,0)|0;ca=(O&255|0)==0?0:O&255;b[ea>>0]=ca;ga=ca}ha=ga&255}else ha=0;if((!(U|w)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){ga=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+W|0;ca=b[ga>>0]|0;if((ca&255)>2)ia=ca;else{ca=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+W|0,t+(c*328|0)+228|0,0)|0;ea=(ca&255|0)==0?0:ca&255;b[ga>>0]=ea;ia=ea}ja=ia&255}else ja=0;ia=e+1|0;ea=(ia|0)<3;if((!(U|ea)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(ia|0):0){U=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,ia)|0)+W|0;ga=b[U>>0]|0;if((ga&255)>2)ka=ga;else{ga=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,ia)|0)+W|0,t+(c*328|0)+228|0,0)|0;W=(ga&255|0)==0?0:ga&255;b[U>>0]=W;ka=W}la=ka&255}else la=0;if((!(v|ea)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(ia|0):0){ka=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,ia)|0)+d|0;W=b[ka>>0]|0;if((W&255)>2)ma=W;else{W=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,ia)|0)+d|0,t+(c*328|0)+228|0,0)|0;U=(W&255|0)==0?0:W&255;b[ka>>0]=U;ma=U}na=ma&255}else na=0;if((!(M|ea)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(aa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(ia|0):0){ea=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,ia)|0)+aa|0;M=b[ea>>0]|0;if((M&255)>2)oa=M;else{M=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,ia)|0)+aa|0,t+(c*328|0)+228|0,0)|0;aa=(M&255|0)==0?0:M&255;b[ea>>0]=aa;oa=aa}pa=oa&255}else pa=0;Z=+UIb(a,$,ja,la,ba,ha,na,da,fa,pa,q,r);qa=+(C|0);ra=qa<Z?Z:qa;pa=~~(V*1024.0+.5);fa=~~(ra*1024.0+.5);da=~~(D*1024.0+.5);do if(A){na=(pa<<1)-(fa<<2)+(da<<1)|0;if((na|0)>-1){if(!(!(ra>=V)|!(ra>=D))){sa=1.0;ta=ra;ua=120;break}if(!(!(V>=D)|!(V>=ra))){sa=.699999988079071;ta=V;ua=120;break}if(!(!(D>=V)|!(D>=ra))){ua=121;break}}qa=+((Y(pa,-5)|0)+(Y(da,-3)|0)+(fa<<3)|0);Z=-qa/+(na<<1|0);if(!(Z<.699999988079071))if(Z>1.5)va=1.5;else va=Z;else va=.699999988079071;wa=(qa*va+(+(((pa-fa|0)*3|0)+da|0)+va*(+(na|0)*va)))*.0009765625;xa=va;ua=122}else{na=(pa<<4)+(da<<3)+(Y(fa,-24)|0)|0;if((na|0)>-1){if(!(!(ra>=V)|!(ra>=D))){sa=1.0;ta=ra;ua=120;break}if(!(!(V>=D)|!(V>=ra))){sa=.75;ta=V;ua=120;break}if(!(!(D>=V)|!(D>=ra))){ua=121;break}}qa=+((Y(pa,-40)|0)+(Y(da,-14)|0)+(fa*54|0)|0);Z=-qa/+(na<<1|0);if(!(Z<.75))if(Z>1.5)ya=1.5;else ya=Z;else ya=.75;wa=(qa*ya+(+((pa*24|0)+(da*6|0)+(Y(fa,-27)|0)|0)+ya*(+(na|0)*ya)))/3072.0;xa=ya;ua=122}while(0);if((ua|0)==120){n[i>>2]=sa;za=sa;Aa=ta;Ba=+n[q>>2];Ca=+(d|0);ua=124}else if((ua|0)==121){n[i>>2]=1.5;Da=1.5;Ea=D;Fa=+n[q>>2];Ga=+(d|0);ua=123}else if((ua|0)==122){n[i>>2]=xa;ta=+(d|0);sa=+n[q>>2];if(xa>1.0){Da=xa;Ea=wa;Fa=sa;Ga=ta;ua=123}else{za=xa;Aa=wa;Ba=sa;Ca=ta;ua=124}}do if((ua|0)==123){ta=(1.5-Da)*2.0;sa=1.0-ta;fa=t+(c*328|0)+112|0;da=t+(c*328|0)+116|0;n[g>>2]=+n[da>>2]+ +n[fa>>2]*(Ga+(ta*Fa+sa*+n[l>>2]));Ha=Ea;Ia=fa;Ja=+n[da>>2]+ +n[fa>>2]*(+(e|0)+(ta*+n[r>>2]+sa*+n[m>>2]))}else if((ua|0)==124){sa=+n[o>>2];if(A){ta=(za+-.5)*2.0;wa=1.0-ta;n[g>>2]=Ca+(ta*Ba+wa*sa);Ha=Aa;Ia=t+(c*328|0)+112|0;Ja=+(e|0)+(ta*+n[r>>2]+wa*+n[p>>2]);break}else{wa=(za+-.75)*4.0;ta=1.0-wa;fa=t+(c*328|0)+112|0;da=t+(c*328|0)+116|0;n[g>>2]=(Ca+(wa*Ba+ta*sa))*+n[fa>>2]+ +n[da>>2];Ha=Aa;Ia=fa;Ja=+n[da>>2]+ +n[fa>>2]*(+(e|0)+(wa*+n[r>>2]+ta*+n[p>>2]));break}}while(0);n[h>>2]=Ja;Ka=Ha;La=Ia}else{Ha=+VIb(a,c,d,e,C,j,o,p);if(!(b[j>>0]|0)){E=0.0;u=k;return +E}j=d+-1|0;Ia=e+-1|0;A=(d|0)<4;fa=(e|0)<4;if((!(A|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){da=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Ia)|0)+j|0;pa=b[da>>0]|0;if((pa&255)>2)Ma=pa;else{pa=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Ia)|0)+j|0,t+(c*328|0)+228|0,0)|0;na=(pa&255|0)==0?0:pa&255;b[da>>0]=na;Ma=na}Na=Ma&255}else Na=0;if((!(v|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){Ma=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Ia)|0)+d|0;na=b[Ma>>0]|0;if((na&255)>2)Oa=na;else{na=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Ia)|0)+d|0,t+(c*328|0)+228|0,0)|0;da=(na&255|0)==0?0:na&255;b[Ma>>0]=da;Oa=da}Pa=Oa&255}else Pa=0;Oa=d+1|0;da=(Oa|0)<3;if((!(da|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(Oa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){fa=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Ia)|0)+Oa|0;Ma=b[fa>>0]|0;if((Ma&255)>2)Qa=Ma;else{Ma=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Ia)|0)+Oa|0,t+(c*328|0)+228|0,0)|0;Ia=(Ma&255|0)==0?0:Ma&255;b[fa>>0]=Ia;Qa=Ia}Ra=Qa&255}else Ra=0;if((!(da|w)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(Oa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){Qa=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+Oa|0;Ia=b[Qa>>0]|0;if((Ia&255)>2)Sa=Ia;else{Ia=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+Oa|0,t+(c*328|0)+228|0,0)|0;fa=(Ia&255|0)==0?0:Ia&255;b[Qa>>0]=fa;Sa=fa}Ta=Sa&255}else Ta=0;if((!x?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){x=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+d|0;Sa=b[x>>0]|0;if((Sa&255)>2)Ua=Sa;else{Sa=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+d|0,t+(c*328|0)+228|0,0)|0;fa=(Sa&255|0)==0?0:Sa&255;b[x>>0]=fa;Ua=fa}Va=Ua&255}else Va=0;if((!(A|w)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){w=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+j|0;Ua=b[w>>0]|0;if((Ua&255)>2)Wa=Ua;else{Ua=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+j|0,t+(c*328|0)+228|0,0)|0;fa=(Ua&255|0)==0?0:Ua&255;b[w>>0]=fa;Wa=fa}Xa=Wa&255}else Xa=0;Wa=e+1|0;fa=(Wa|0)<3;if((!(A|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(Wa|0):0){A=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Wa)|0)+j|0;w=b[A>>0]|0;if((w&255)>2)Ya=w;else{w=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Wa)|0)+j|0,t+(c*328|0)+228|0,0)|0;j=(w&255|0)==0?0:w&255;b[A>>0]=j;Ya=j}Za=Ya&255}else Za=0;if((!(v|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(Wa|0):0){v=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Wa)|0)+d|0;Ya=b[v>>0]|0;if((Ya&255)>2)_a=Ya;else{Ya=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Wa)|0)+d|0,t+(c*328|0)+228|0,0)|0;j=(Ya&255|0)==0?0:Ya&255;b[v>>0]=j;_a=j}$a=_a&255}else $a=0;if((!(da|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(Oa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(Wa|0):0){fa=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Wa)|0)+Oa|0;da=b[fa>>0]|0;if((da&255)>2)ab=da;else{da=tLb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Wa)|0)+Oa|0,t+(c*328|0)+228|0,0)|0;Oa=(da&255|0)==0?0:da&255;b[fa>>0]=Oa;ab=Oa}bb=ab&255}else bb=0;Ja=+UIb(a,Na,Xa,Za,Pa,Va,$a,Ra,Ta,bb,q,r);Aa=+(C|0);Ba=Aa<Ja?Ja:Aa;C=~~(Ha*1024.0+.5);bb=~~(Ba*1024.0+.5);Ta=~~(D*1024.0+.5);Ra=(Y(bb,-18)|0)+((C+Ta|0)*9|0)|0;do if((Ra|0)>-1){if(!(Ba>=Ha)|!(Ba>=D))if(!(Ha>=D)|!(Ha>=Ba)){if(!(D>=Ha)|!(D>=Ba)){ua=189;break}n[i>>2]=1.3333333730697632;cb=D;db=4.0;eb=+n[q>>2];fb=+(d|0);ua=194;break}else{gb=.6666666865348816;hb=Ha}else{gb=1.0;hb=Ba}n[i>>2]=gb;ib=hb;jb=gb*3.0;kb=+n[q>>2];lb=+(d|0);ua=195}else ua=189;while(0);if((ua|0)==189){gb=+((Y(C,-21)|0)+(Y(Ta,-15)|0)+(bb*36|0)|0);hb=-gb/+(Ra<<1|0);if(!(hb<.6666666865348816))if(hb>1.3333333730697632)mb=1.3333333730697632;else mb=hb;else mb=.6666666865348816;hb=(gb*mb+(+((C*12|0)+(Ta*6|0)-(bb<<4)|0)+mb*(+(Ra|0)*mb)))*.00048828125;n[i>>2]=mb;gb=mb*3.0;Ba=+(d|0);Ha=+n[q>>2];if(mb>1.0){cb=hb;db=gb;eb=Ha;fb=Ba;ua=194}else{ib=hb;jb=gb;kb=Ha;lb=Ba;ua=195}}if((ua|0)==194){Ba=4.0-db;db=1.0-Ba;q=t+(c*328|0)+112|0;d=t+(c*328|0)+116|0;n[g>>2]=+n[d>>2]+ +n[q>>2]*(fb+(eb*Ba+db*+n[l>>2]));nb=q;ob=d;pb=cb;qb=Ba*+n[r>>2];rb=db*+n[m>>2]}else if((ua|0)==195){db=jb+-2.0;jb=1.0-db;ua=t+(c*328|0)+112|0;m=t+(c*328|0)+116|0;n[g>>2]=+n[m>>2]+ +n[ua>>2]*(lb+(kb*db+jb*+n[o>>2]));nb=ua;ob=m;pb=ib;qb=db*+n[r>>2];rb=jb*+n[p>>2]}n[h>>2]=+n[ob>>2]+ +n[nb>>2]*(+(e|0)+(rb+qb));Ka=pb;La=nb}n[i>>2]=+n[La>>2]*+n[i>>2];E=Ka;u=k;return +E}function XIb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0,ea=0,fa=0.0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0.0,oa=0.0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0,Oa=0,Pa=0.0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0.0,jb=0.0,kb=0,lb=0.0,mb=0.0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;o=k+4|0;p=k;b[h>>0]=0;q=c+1|0;if((q|0)>=(f[a>>2]|0)){f[l>>2]=0;f[l+4>>2]=0;r=tT(l,19)|0;s=461226;t=r+19|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));NIb(l,461246,1438)}s=f[a+4>>2]|0;r=s+(q*328|0)|0;t=(c&1|0)==0;if(t){c=d<<2;v=e<<2;w=+(c+-3|0)/6.0;x=+(c|1|0)/6.0;y=+(v+-3|0)/6.0;z=+(v|1|0)/6.0}else{v=d*6|0;c=e*6|0;w=+(v+-4|0)*.125;x=+(v+2|0)*.125;y=+(c+-4|0)*.125;z=+(c+2|0)*.125}c=~~w;v=c+1|0;A=~~y;B=A+1|0;C=+(TIb(r,w,y,1,1.0)|0);n[l>>2]=C;D=+(g|0);if(C>D){E=0.0;u=k;return +E}F=~~x;G=(c|0)<(F|0);do if(G){H=C;c=v;I=v;J=+n[l>>2];while(1){K=+(TIb(r,+(I|0),y,1,1.0)|0);if(K>D)break;L=K>H;M=L?K:J;H=L?K:H;c=L?I:c;if((I|0)>=(F|0)){N=11;break}else{I=I+1|0;J=M}}if((N|0)==11){n[l>>2]=M;O=H;P=c;break}n[l>>2]=J;E=0.0;u=k;return +E}else{O=C;P=v}while(0);C=+(TIb(r,x,y,1,1.0)|0);if(C>D){E=0.0;u=k;return +E}if(C>O){n[l>>2]=C;Q=C;R=F}else{Q=O;R=P}P=~~z;do if((A|0)<(P|0)){I=~~(w+1.0);L=s+(q*328|0)+12|0;S=s+(q*328|0)+8|0;T=s+(q*328|0)+72|0;U=s+(q*328|0)+100|0;V=s+(q*328|0)+16|0;W=s+(q*328|0)+44|0;X=s+(q*328|0)+228|0;Z=(g|0)<0;O=Q;_=B;$=B;aa=R;C=+n[l>>2];a:while(1){y=+($|0);M=+(TIb(r,w,y,1,1.0)|0);if(M>D){ba=C;N=118;break}if(M>O){ca=M;da=$;ea=I;fa=M}else{ca=O;da=_;ea=aa;fa=C}b:do if(G){if(($|0)<3){M=ca;ga=v;ha=da;ia=ea;ja=fa;while(1){if(Z){N=116;break a}if(M<0.0){ka=0.0;la=$;ma=ga;na=0.0}else{ka=M;la=ha;ma=ia;na=ja}if((ga|0)<(F|0)){M=ka;ga=ga+1|0;ha=la;ia=ma;ja=na}else{oa=ka;pa=la;qa=ma;ra=na;break b}}}else{sa=fa;ta=v;ua=da;va=ea}while(1){if(((ta|0)>=3?((f[L>>2]|0)+-3|0)>(ta|0):0)?((f[S>>2]|0)+-3|0)>($|0):0){ia=(f[T>>2]|0)+(Y(f[f[U>>2]>>2]|0,$)|0)+ta|0;ha=b[ia>>0]|0;if((ha&255)>2)wa=ha;else{ha=tLb((f[V>>2]|0)+(Y(f[f[W>>2]>>2]|0,$)|0)+ta|0,X,0)|0;ga=(ha&255|0)==0?0:ha&255;b[ia>>0]=ga;wa=ga}xa=wa&255}else xa=0;M=+(xa|0);if(M>D){N=117;break a}ga=M>sa;K=ga?M:sa;ia=ga?$:ua;ha=ga?ta:va;if((ta|0)<(F|0)){sa=K;ta=ta+1|0;ua=ia;va=ha}else{oa=K;pa=ia;qa=ha;ra=K;break}}}else{oa=ca;pa=da;qa=ea;ra=fa}while(0);K=+(TIb(r,x,y,1,1.0)|0);if(K>D){ba=ra;N=118;break}if(K>oa){ya=K;za=$;Aa=F;Ba=K}else{ya=oa;za=pa;Aa=qa;Ba=ra}if(($|0)<(P|0)){O=ya;_=za;$=$+1|0;aa=Aa;C=Ba}else{N=38;break}}if((N|0)==38){n[l>>2]=Ba;Ca=ya;Da=za;Ea=Aa;break}else if((N|0)==116){n[l>>2]=ja;E=0.0;u=k;return +E}else if((N|0)==117){n[l>>2]=sa;E=0.0;u=k;return +E}else if((N|0)==118){n[l>>2]=ba;E=0.0;u=k;return +E}}else{Ca=Q;Da=B;Ea=R}while(0);Q=+(TIb(r,w,z,1,1.0)|0);if(Q>Ca){n[l>>2]=Q;Fa=Q;Ga=~~(w+1.0);Ha=P}else{Fa=Ca;Ga=Ea;Ha=Da}if(G){Ca=Fa;G=v;v=Ga;Da=Ha;w=+n[l>>2];while(1){Q=+(TIb(r,+(G|0),z,1,1.0)|0);if(Q>Ca){Ia=Q;Ja=G;Ka=P;La=Q}else{Ia=Ca;Ja=v;Ka=Da;La=w}if((G|0)<(F|0)){Ca=Ia;G=G+1|0;v=Ja;Da=Ka;w=La}else break}n[l>>2]=La;Ma=Ia;Na=Ja;Oa=Ka}else{Ma=Fa;Na=Ga;Oa=Ha}Fa=+(TIb(r,x,z,1,1.0)|0);if(Fa>Ma){n[l>>2]=Fa;Pa=Fa;Qa=F;Ra=P}else{Pa=Ma;Qa=Na;Ra=Oa}Oa=Qa+-1|0;Na=Ra+-1|0;P=(Qa|0)<4;F=(Ra|0)<4;if((!(F|P)?((f[s+(q*328|0)+12>>2]|0)+-3|0)>=(Qa|0):0)?((f[s+(q*328|0)+8>>2]|0)+-3|0)>=(Ra|0):0){r=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,Na)|0)+Oa|0;Ha=b[r>>0]|0;if((Ha&255)>2)Sa=Ha;else{Ha=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,Na)|0)+Oa|0,s+(q*328|0)+228|0,0)|0;Ga=(Ha&255|0)==0?0:Ha&255;b[r>>0]=Ga;Sa=Ga}Ta=Sa&255}else Ta=0;Sa=(Qa|0)<3;if((!(F|Sa)?((f[s+(q*328|0)+12>>2]|0)+-3|0)>(Qa|0):0)?((f[s+(q*328|0)+8>>2]|0)+-3|0)>=(Ra|0):0){Ga=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,Na)|0)+Qa|0;r=b[Ga>>0]|0;if((r&255)>2)Ua=r;else{r=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,Na)|0)+Qa|0,s+(q*328|0)+228|0,0)|0;Ha=(r&255|0)==0?0:r&255;b[Ga>>0]=Ha;Ua=Ha}Va=Ua&255}else Va=0;Ua=Qa+1|0;Ha=(Ua|0)<3;if((!(F|Ha)?((f[s+(q*328|0)+12>>2]|0)+-3|0)>(Ua|0):0)?((f[s+(q*328|0)+8>>2]|0)+-3|0)>=(Ra|0):0){F=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,Na)|0)+Ua|0;Ga=b[F>>0]|0;if((Ga&255)>2)Wa=Ga;else{Ga=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,Na)|0)+Ua|0,s+(q*328|0)+228|0,0)|0;Na=(Ga&255|0)==0?0:Ga&255;b[F>>0]=Na;Wa=Na}Xa=Wa&255}else Xa=0;Wa=(Ra|0)<3;if((!(Wa|Ha)?((f[s+(q*328|0)+12>>2]|0)+-3|0)>(Ua|0):0)?((f[s+(q*328|0)+8>>2]|0)+-3|0)>(Ra|0):0){Na=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,Ra)|0)+Ua|0;F=b[Na>>0]|0;if((F&255)>2)Ya=F;else{F=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,Ra)|0)+Ua|0,s+(q*328|0)+228|0,0)|0;Ga=(F&255|0)==0?0:F&255;b[Na>>0]=Ga;Ya=Ga}Za=Ya&255}else Za=0;if((!(Wa|Sa)?((f[s+(q*328|0)+12>>2]|0)+-3|0)>(Qa|0):0)?((f[s+(q*328|0)+8>>2]|0)+-3|0)>(Ra|0):0){Ya=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,Ra)|0)+Qa|0;Ga=b[Ya>>0]|0;if((Ga&255)>2)_a=Ga;else{Ga=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,Ra)|0)+Qa|0,s+(q*328|0)+228|0,0)|0;Na=(Ga&255|0)==0?0:Ga&255;b[Ya>>0]=Na;_a=Na}$a=_a&255}else $a=0;if((!(Wa|P)?((f[s+(q*328|0)+12>>2]|0)+-3|0)>=(Qa|0):0)?((f[s+(q*328|0)+8>>2]|0)+-3|0)>(Ra|0):0){Wa=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,Ra)|0)+Oa|0;_a=b[Wa>>0]|0;if((_a&255)>2)ab=_a;else{_a=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,Ra)|0)+Oa|0,s+(q*328|0)+228|0,0)|0;Na=(_a&255|0)==0?0:_a&255;b[Wa>>0]=Na;ab=Na}bb=ab&255}else bb=0;ab=Ra+1|0;Na=(ab|0)<3;if((!(P|Na)?((f[s+(q*328|0)+12>>2]|0)+-3|0)>=(Qa|0):0)?((f[s+(q*328|0)+8>>2]|0)+-3|0)>(ab|0):0){P=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,ab)|0)+Oa|0;Wa=b[P>>0]|0;if((Wa&255)>2)cb=Wa;else{Wa=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,ab)|0)+Oa|0,s+(q*328|0)+228|0,0)|0;Oa=(Wa&255|0)==0?0:Wa&255;b[P>>0]=Oa;cb=Oa}db=cb&255}else db=0;do if(!(Sa|Na)?((f[s+(q*328|0)+12>>2]|0)+-3|0)>(Qa|0):0){if(((f[s+(q*328|0)+8>>2]|0)+-3|0)<=(ab|0)){eb=0;break}cb=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,ab)|0)+Qa|0;Oa=b[cb>>0]|0;if((Oa&255)>2)fb=Oa;else{Oa=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,ab)|0)+Qa|0,s+(q*328|0)+228|0,0)|0;P=(Oa&255|0)==0?0:Oa&255;b[cb>>0]=P;fb=P}eb=fb&255}else eb=0;while(0);do if(Na|Ha)gb=0;else{if(((f[s+(q*328|0)+12>>2]|0)+-3|0)<=(Ua|0)){gb=0;break}if(((f[s+(q*328|0)+8>>2]|0)+-3|0)<=(ab|0)){gb=0;break}fb=(f[s+(q*328|0)+72>>2]|0)+(Y(f[f[s+(q*328|0)+100>>2]>>2]|0,ab)|0)+Ua|0;Sa=b[fb>>0]|0;if((Sa&255)>2)hb=Sa;else{Sa=tLb((f[s+(q*328|0)+16>>2]|0)+(Y(f[f[s+(q*328|0)+44>>2]>>2]|0,ab)|0)+Ua|0,s+(q*328|0)+228|0,0)|0;P=(Sa&255|0)==0?0:Sa&255;b[fb>>0]=P;hb=P}gb=hb&255}while(0);Ma=+UIb(a,Ta,bb,db,Va,$a,eb,Xa,Za,gb,m,o);n[p>>2]=Ma;Fa=+(Qa|0)+ +n[m>>2];z=+(Ra|0)+ +n[o>>2];x=+(d|0);if(t){n[i>>2]=(Fa*6.0+1.0)*.25-x;ib=(z*6.0+1.0)*.25}else{n[i>>2]=(Fa*8.0+1.0)/6.0-x;ib=(z*8.0+1.0)/6.0}z=ib-+(e|0);n[j>>2]=z;ib=+n[i>>2];if(!(ib>1.0))if(ib<-1.0){jb=-1.0;N=108}else{kb=1;lb=z}else{jb=1.0;N=108}if((N|0)==108){n[i>>2]=jb;kb=0;lb=+n[j>>2]}do if(lb>1.0){n[j>>2]=1.0;b[h>>0]=1;mb=Pa}else{if(lb<-1.0){n[j>>2]=-1.0;b[h>>0]=1;mb=Pa;break}b[h>>0]=1;if(!kb){mb=Pa;break}mb=Ma<Pa?+n[l>>2]:+n[p>>2]}while(0);E=mb;u=k;return +E}function YIb(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=+g;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;a=u;u=u+16|0;i=a;j=f[c+16>>2]|0;if(!j){f[i>>2]=0;k=i+4|0;f[k>>2]=0;l=tT(i,12)|0;m=l;n=461290;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));NIb(i,498520,2204)}p=f[c+4>>2]|0;if((p|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{r=f[c+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(p|0)){q=v;break}else t=v}}if((p|0)==0|(q|0)==0){f[i>>2]=0;k=i+4|0;f[k>>2]=0;l=tT(i,12)|0;m=l;n=461290;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));NIb(i,498520,2204)}l=~~d;k=l-(+(l|0)>d&1)|0;l=~~e;q=l-(+(l|0)>e&1)|0;l=c+12|0;w=g*.5;g=w*(w*4.0);if(w<.5){c=~~((d-+(k|0))*1024.0);p=~~((e-+(q|0))*1024.0);t=1024-c|0;s=f[l>>2]|0;r=j+k+(Y(s,q)|0)|0;q=Y(h[r>>0]|0,t)|0;k=r+1|0;r=Y(h[k>>0]|0,c)|0;v=k+s|0;s=Y(h[v>>0]|0,c)|0;x=((Y(r+q|0,1024-p|0)|0)+512+(Y((Y(h[v+-1>>0]|0,t)|0)+s|0,p)|0)|0)/1048576|0;y=x&255;u=a;return y|0}p=~~(4194304.0/g);z=+(p|0);s=~~(g*z*.0009765625);if(!s){f[i>>2]=0;f[i+4>>2]=0;m=tT(i,13)|0;n=461194;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));NIb(i,498520,2240)}g=d-w;A=w+d;d=e-w;B=w+e;i=~~(g+.5);n=~~(d+.5);m=~~(A+.5);o=~~(B+.5);e=+(i|0)-g+.5;g=+(n|0)-d+.5;d=A-+(m|0)+.5;A=B-+(o|0)+.5;t=m-i|0;m=1-t|0;v=o+~n|0;o=~~(z*(d*g));q=~~(z*(d*A));r=~~(z*(e*A));c=~~(z*e);k=~~(z*g);C=~~(z*d);D=~~(z*A);E=f[l>>2]|0;l=j+i+(Y(E,n)|0)|0;n=Y(h[l>>0]|0,~~(z*(e*g)))|0;i=l+1|0;j=l+t|0;F=(t|0)>1;G=h[i>>0]|0;if(F){H=n;I=i;i=G;while(1){J=(Y(i,k)|0)+H|0;K=I+1|0;L=h[K>>0]|0;if(K>>>0<j>>>0){H=J;I=K;i=L}else{M=J;N=L;O=I;break}}}else{M=n;N=G;O=l}l=(Y(N,o)|0)+M|0;M=m+-1+E|0;m=O+1+M|0;O=Y(E,v)|0;v=m+O|0;E=h[m>>0]|0;if((O|0)>0){O=m;o=l;N=E;while(1){G=(Y(N,c)|0)+o|0;n=O+1|0;I=O+t|0;i=h[n>>0]|0;if(F){H=n;n=G;j=i;while(1){k=(Y(j,p)|0)+n|0;L=H+1|0;J=h[L>>0]|0;if(L>>>0<I>>>0){H=L;n=k;j=J}else{P=k;Q=J;R=H;break}}}else{P=G;Q=i;R=O}H=(Y(Q,C)|0)+P|0;j=R+1+M|0;n=h[j>>0]|0;if(j>>>0<v>>>0){O=j;o=H;N=n}else{S=H;T=j;U=n;break}}}else{S=l;T=m;U=E}E=(Y(U,r)|0)+S|0;S=T+1|0;r=T+t|0;t=h[S>>0]|0;if(F){F=S;S=E;T=t;while(1){U=(Y(T,D)|0)+S|0;F=F+1|0;m=h[F>>0]|0;if(F>>>0>=r>>>0){V=U;W=m;break}else{S=U;T=m}}}else{V=E;W=t}x=((V+((s|0)/2|0)+(Y(W,q)|0)|0)/(s|0)|0|0)/1024|0;y=x&255;u=a;return y|0}function ZIb(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+224|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;m=a+48|0;o=a+44|0;f[o>>2]=m;f[m>>2]=0;f[a+52>>2]=0;p=a+56|0;q=a+64|0;r=a+96|0;k=a+60|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[r>>2]=q;q=a+104|0;f[a+100>>2]=q;f[q>>2]=0;f[a+108>>2]=0;f[p>>2]=1124007936;q=a+120|0;f[q>>2]=0;r=a+124|0;f[r>>2]=0;if((a|0)!=(b|0)){k=b+36|0;l=f[k>>2]|0;if(l){s=l+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+36|0;l=f[s>>2]|0;if((l|0)!=0?(t=l+12|0,l=f[t>>2]|0,f[t>>2]=l+-1,(l|0)==1):0){_S(a);v=s}else v=s}else v=a+36|0;f[v>>2]=0;s=a+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[h>>2]|0)>0){l=f[j>>2]|0;j=0;do{f[l+(j<<2)>>2]=0;j=j+1|0;w=f[h>>2]|0}while((j|0)<(w|0));f[a>>2]=f[b>>2];if((w|0)<3)x=12;else x=14}else{f[a>>2]=f[b>>2];x=12}if((x|0)==12){w=f[b+4>>2]|0;if((w|0)<3){f[h>>2]=w;f[i>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];i=f[b+44>>2]|0;w=f[o>>2]|0;f[w>>2]=f[i>>2];f[w+4>>2]=f[i+4>>2]}else x=14}if((x|0)==14)ZS(a,b);f[s>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[v>>2]=f[k>>2]}AY(g,f[b+8>>2]|0,f[b+12>>2]|0,0);b=f[g>>2]|0;ei[f[(f[b>>2]|0)+12>>2]&511](b,g,p,0);$j(g);n[a+112>>2]=c;n[a+116>>2]=d;yLb(g,1,0,3);p=f[g>>2]|0;b=f[g+4>>2]|0;if(p|0){k=p+4|0;f[k>>2]=(f[k>>2]|0)+1}k=f[q>>2]|0;f[q>>2]=p;f[r>>2]=b;if(k|0?(b=k+4|0,r=f[b>>2]|0,f[b>>2]=r+-1,(r|0)==1):0)Yi[f[(f[k>>2]|0)+8>>2]&2047](k);k=f[g>>2]|0;if(!k){y=a+128|0;z=f[m>>2]|0;oLb(y,z,0);A=a+228|0;B=f[m>>2]|0;oLb(A,B,3);u=e;return}g=k+4|0;r=f[g>>2]|0;f[g>>2]=r+-1;if((r|0)!=1){y=a+128|0;z=f[m>>2]|0;oLb(y,z,0);A=a+228|0;B=f[m>>2]|0;oLb(A,B,3);u=e;return}Yi[f[(f[k>>2]|0)+8>>2]&2047](k);y=a+128|0;z=f[m>>2]|0;oLb(y,z,0);A=a+228|0;B=f[m>>2]|0;oLb(A,B,3);u=e;return}function _Ib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=f[b>>2];c=a+4|0;d=b+4|0;f[c>>2]=f[d>>2];e=a+8|0;f[e>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];g=f[b+36>>2]|0;f[a+36>>2]=g;f[a+40>>2]=e;e=a+48|0;h=a+44|0;f[h>>2]=e;f[e>>2]=0;f[a+52>>2]=0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[d>>2]|0)<3){d=f[b+44>>2]|0;e=f[h>>2]|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2]}else{f[c>>2]=0;ZS(a,b)}c=a+56|0;d=b+56|0;f[c>>2]=f[d>>2];e=a+60|0;h=b+60|0;f[e>>2]=f[h>>2];g=a+64|0;f[g>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[a+80>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];i=f[b+92>>2]|0;f[a+92>>2]=i;f[a+96>>2]=g;g=a+104|0;j=a+100|0;f[j>>2]=g;f[g>>2]=0;f[a+108>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+100>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(c,d)}d=b+112|0;c=f[d+4>>2]|0;e=a+112|0;f[e>>2]=f[d>>2];f[e+4>>2]=c;c=f[b+120>>2]|0;f[a+120>>2]=c;f[a+124>>2]=f[b+124>>2];if(!c){k=a+128|0;l=b+128|0;dJc(k|0,l|0,200)|0;return}e=c+4|0;f[e>>2]=(f[e>>2]|0)+1;k=a+128|0;l=b+128|0;dJc(k|0,l|0,200)|0;return}function $Ib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/328|0;g=e+1|0;if(g>>>0>13094412)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/328|0;d=i<<1;j=i>>>0<6547206?(d>>>0<g>>>0?g:d):13094412;do if(j)if(j>>>0>13094412){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*328|0)|0;break}else k=0;while(0);d=k+(e*328|0)|0;e=d;g=k+(j*328|0)|0;_Ib(d,b);b=d+328|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=k}else{i=k;k=e;e=d;do{i=i+-328|0;_Ib(e+-328|0,i);e=k+-328|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;h=n;while(1){n=h;if((n|0)==(g|0))break;b=n+-328|0;QIb(b);h=b}if(!m)return;YDc(m);return}function aJb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;d=u;u=u+224|0;e=d;f[a>>2]=1124007936;g=a+8|0;h=a+40|0;i=a+4|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;h=a+48|0;f[a+44>>2]=h;f[h>>2]=0;f[a+52>>2]=0;k=a+56|0;l=a+64|0;m=a+96|0;i=a+60|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[m>>2]=l;l=a+104|0;f[a+100>>2]=l;f[l>>2]=0;f[a+108>>2]=0;f[k>>2]=1124007936;l=a+120|0;f[l>>2]=0;m=a+124|0;f[m>>2]=0;i=f[b+8>>2]|0;if(!c){c=(f[b+12>>2]|0)/2|0;f[e>>2]=(i|0)/2|0;f[e+4>>2]=c;XS(a,2,e,0);bJb(b,a);o=2.0}else{c=((f[b+12>>2]|0)/3|0)<<1;f[e>>2]=((i|0)/3|0)<<1;f[e+4>>2]=c;XS(a,2,e,0);cJb(b,a);o=1.5}p=o*+n[b+112>>2];n[a+112>>2]=p;n[a+116>>2]=p*.5+-.5;AY(e,f[g>>2]|0,f[a+12>>2]|0,0);g=f[e>>2]|0;ei[f[(f[g>>2]|0)+12>>2]&511](g,e,k,0);$j(e);yLb(e,1,0,3);k=f[e>>2]|0;g=f[e+4>>2]|0;if(k|0){b=k+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[l>>2]|0;f[l>>2]=k;f[m>>2]=g;if(b|0?(g=b+4|0,m=f[g>>2]|0,f[g>>2]=m+-1,(m|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);b=f[e>>2]|0;if(!b){q=a+128|0;r=f[h>>2]|0;oLb(q,r,0);s=a+228|0;t=f[h>>2]|0;oLb(s,t,3);u=d;return}e=b+4|0;m=f[e>>2]|0;f[e>>2]=m+-1;if((m|0)!=1){q=a+128|0;r=f[h>>2]|0;oLb(q,r,0);s=a+228|0;t=f[h>>2]|0;oLb(s,t,3);u=d;return}Yi[f[(f[b>>2]|0)+8>>2]&2047](b);q=a+128|0;r=f[h>>2]|0;oLb(q,r,0);s=a+228|0;t=f[h>>2]|0;oLb(s,t,3);u=d;return}function bJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+48|0;e=d+24|0;g=d;h=d+16|0;if(((f[a+12>>2]|0)/2|0|0)!=(f[c+12>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,30)|0;j=461392;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));NIb(e,461423,2312)}if(((f[a+8>>2]|0)/2|0|0)==(f[c+8>>2]|0)){f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;a=f[c+40>>2]|0;c=f[a>>2]|0;f[h>>2]=f[a+4>>2];f[h+4>>2]=c;nfa(e,g,h,0.0,0.0,3);u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,30)|0;j=461434;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));NIb(e,461423,2313)}}function cJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+48|0;e=d+24|0;g=d;h=d+16|0;if((((f[a+12>>2]|0)/3|0)<<1|0)!=(f[c+12>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,36)|0;j=461303;k=i+36|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));NIb(e,461340,2323)}if((((f[a+8>>2]|0)/3|0)<<1|0)==(f[c+8>>2]|0)){f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;a=f[c+40>>2]|0;c=f[a>>2]|0;f[h>>2]=f[a+4>>2];f[h+4>>2]=c;nfa(e,g,h,0.0,0.0,3);u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,36)|0;j=461355;k=i+36|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));NIb(e,461340,2324)}}function dJb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;r0(a);f[a>>2]=112088;f[a+4>>2]=b;f[a+8>>2]=c;f[g>>2]=0;c=g+4|0;f[c>>2]=0;f[g+8>>2]=0;f[h>>2]=0;b=h+4|0;f[b>>2]=0;f[h+8>>2]=0;fqb(g,5);j=f[b>>2]|0;k=f[h>>2]|0;l=k;m=j-k>>2;o=k;k=j;if(m>>>0>=5)if((m|0)!=5?(j=o+20|0,(k|0)!=(j|0)):0){f[b>>2]=k+(~((k+-4-j|0)>>>2)<<2);p=l}else p=l;else{lN(h,5-m|0);p=f[h>>2]|0}q=d;d=q*.85;m=f[g>>2]|0;n[m>>2]=d*0.0;n[m+4>>2]=d*2.9;n[m+8>>2]=d*4.9;n[m+12>>2]=d*7.4;n[m+16>>2]=d*10.8;f[p>>2]=1;f[p+4>>2]=10;f[p+8>>2]=14;f[p+12>>2]=15;f[p+16>>2]=20;f[i>>2]=0;p=i+4|0;f[p>>2]=0;f[i+8>>2]=0;eJb(a,g,h,q*5.85,q*8.2,i);a=f[i>>2]|0;if(a|0){i=f[p>>2]|0;if((i|0)!=(a|0))f[p>>2]=i+(~((i+-4-a|0)>>>2)<<2);YDc(a)}a=f[h>>2]|0;if(a|0){h=f[b>>2]|0;if((h|0)!=(a|0))f[b>>2]=h+(~((h+-4-a|0)>>>2)<<2);YDc(a)}a=f[g>>2]|0;if(!a){u=e;return}g=f[c>>2]|0;if((g|0)!=(a|0))f[c>>2]=g+(~((g+-4-a|0)>>>2)<<2);YDc(a);u=e;return}function eJb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0.0,R=0,S=0,T=0.0,U=0.0,V=0,W=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;i=u;u=u+32|0;j=i+8|0;k=i;jFa(j,h);h=a+32|0;n[h>>2]=e;l=a+36|0;n[l>>2]=g;m=(f[c+4>>2]|0)-(f[c>>2]|0)|0;o=m>>2;if(!o){f[k>>2]=0;p=k+4|0;f[p>>2]=0;q=tT(k,64)|0;r=q;s=461502;t=r+64|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));NIb(k,461567,354)}v=f[d>>2]|0;w=v;if((o|0)!=((f[d+4>>2]|0)-v>>2|0)){f[k>>2]=0;p=k+4|0;f[p>>2]=0;q=tT(k,64)|0;r=q;s=461502;t=r+64|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));NIb(k,461567,354)}q=a+16|0;f[q>>2]=0;p=(m|0)>0;if(p){m=0;v=0;while(1){x=v+(f[w+(m<<2)>>2]|0)|0;f[q>>2]=x;m=m+1|0;if((m|0)>=(o|0)){y=x;break}else v=x}}else y=0;v=y<<16;y=XDc(v>>>0>357913941?-1:v*12|0)|0;v=a+12|0;f[v>>2]=y;if((b[527136]|0)==0?MIc(527136)|0:0)n[220473]=4.906890869140625;if((b[527144]|0)==0?MIc(527144)|0:0)n[220474]=+n[220473]*.015625;m=XDc(256)|0;f[a+20>>2]=m;w=XDc(256)|0;f[a+24>>2]=w;x=y;y=0;while(1){g=+Od(+(+(y>>>0)*+n[220474]));z=m+(y<<2)|0;n[z>>2]=g;f[w+(y<<2)>>2]=0;A=f[d>>2]|0;B=f[c>>2]|0;C=m+(y<<2)|0;D=w+(y<<2)|0;E=0;F=x;while(1){g=+(E>>>0)*2.0*3.141592653589793*.0009765625;if(p){G=0;H=F;while(1){I=A+(G<<2)|0;J=f[I>>2]|0;if((J|0)>0){K=B+(G<<2)|0;e=+n[K>>2];L=f[D>>2]|0;if(!G){M=0;N=H;Q=e;R=L;S=J;while(1){T=g+ +(M|0)*2.0*3.141592653589793/+(S|0);U=+O(+T)*(+n[C>>2]*Q);n[N>>2]=U;U=+P(+T)*(+n[C>>2]*+n[K>>2]);n[N+4>>2]=U;U=+n[C>>2]*1.2999999523162842*.5;n[N+8>>2]=U;Q=+n[K>>2];T=U+ +n[z>>2]*Q;V=~~T;W=V+1+(+(V|0)<T&1)|0;if(R>>>0<W>>>0){f[D>>2]=W;Z=f[I>>2]|0;_=W}else{Z=S;_=R}W=N+12|0;M=M+1|0;if((M|0)>=(Z|0)){$=W;break}else{N=W;R=_;S=Z}}}else{S=0;R=H;N=J;Q=e;M=L;while(1){T=+(N|0);U=g+ +(S|0)*2.0*3.141592653589793/T;aa=+O(+U)*(+n[C>>2]*Q);n[R>>2]=aa;aa=+P(+U)*(+n[C>>2]*+n[K>>2]);n[R+4>>2]=aa;aa=+n[C>>2]*1.2999999523162842*+n[K>>2]*+P(+(3.141592653589793/T));n[R+8>>2]=aa;Q=+n[K>>2];T=aa+ +n[z>>2]*Q;W=~~T;V=W+1+(+(W|0)<T&1)|0;if(M>>>0<V>>>0){f[D>>2]=V;ba=f[I>>2]|0;ca=V}else{ba=N;ca=M}V=R+12|0;S=S+1|0;if((S|0)>=(ba|0)){$=V;break}else{R=V;N=ba;M=ca}}}}else $=H;G=G+1|0;if((G|0)>=(o|0)){da=$;break}else H=$}}else da=F;E=E+1|0;if((E|0)==1024)break;else F=da}y=y+1|0;if((y|0)==64)break;else x=da}da=f[q>>2]|0;x=(Y(da+-1|0,da)|0)>>>1;da=XDc(x>>>0>536870911?-1:x<<3)|0;y=a+40|0;f[y>>2]=da;da=XDc(x>>>0>268435455?-1:x<<4)|0;$=a+44|0;f[$>>2]=da;da=a+48|0;f[da>>2]=0;o=a+52|0;f[o>>2]=0;ca=j+4|0;ba=f[ca>>2]|0;Z=f[j>>2]|0;_=ba-Z>>2;p=Z;w=ba;if(!_){if(!x){ea=Z;fa=ba;ga=p;ha=w}else{lN(j,x);x=f[ca>>2]|0;ba=f[j>>2]|0;ea=ba;fa=x;ga=ba;ha=x}x=fa-ea>>2;if(!x){ia=0;ja=ha;ka=ga}else{ea=0;do{f[ga+(ea<<2)>>2]=ea;ea=ea+1|0}while((ea|0)!=(x|0));ia=x;ja=ha;ka=ga}}else{ia=_;ja=w;ka=p}g=+n[l>>2];Q=g*g;g=+n[h>>2];e=g*g;h=f[q>>2]|0;a:do if(h>>>0>1){l=f[j>>2]|0;p=1;w=h;b:while(1){if(!p)la=w;else{_=0;do{ga=f[v>>2]|0;g=+n[ga+(_*12|0)>>2]-+n[ga+(p*12|0)>>2];T=+n[ga+(_*12|0)+4>>2]-+n[ga+(p*12|0)+4>>2];aa=g*g+T*T;if(!(aa>Q)){if(aa<e){ga=f[da>>2]|0;if(ga>>>0>=ia>>>0)break b;ha=f[y>>2]|0;x=f[l+(ga<<2)>>2]|0;f[ha+(x<<3)+4>>2]=_;f[ha+(x<<3)>>2]=p;ma=da;na=ga;oa=47}}else{ga=f[$>>2]|0;x=f[o>>2]|0;f[ga+(x<<4)+8>>2]=~~(g/aa*2048.0+.5);f[ga+(x<<4)+12>>2]=~~(T/aa*2048.0+.5);f[ga+(x<<4)>>2]=p;f[ga+(x<<4)+4>>2]=_;ma=o;na=x;oa=47}if((oa|0)==47){oa=0;f[ma>>2]=na+1}_=_+1|0}while(_>>>0<p>>>0);la=f[q>>2]|0}p=p+1|0;if(p>>>0>=la>>>0){pa=l;break a}else w=la}f[k>>2]=0;f[k+4>>2]=0;r=tT(k,23)|0;s=461582;t=r+23|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));NIb(k,461567,454)}else pa=ka;while(0);ka=~~+X(+(+((f[da>>2]|0)>>>0)*.0078125))<<4;f[a+28>>2]=ka;if(!pa){u=i;return}if((ja|0)!=(pa|0))f[ca>>2]=ja+(~((ja+-4-pa|0)>>>2)<<2);YDc(pa);u=i;return}function fJb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0;e=VDc(56)|0;dJb(e,b,c,d);c=VDc(16)|0;b=c+4|0;f[b>>2]=1;f[c>>2]=112160;f[c+8>>2]=e;f[a>>2]=c;f[a+4>>2]=e;f[b>>2]=(f[b>>2]|0)+1;e=f[b>>2]|0;f[b>>2]=e+-1;if((e|0)!=1)return;Yi[f[(f[c>>2]|0)+8>>2]&2047](c);return}function gJb(a){a=a|0;YDc(a);return}function hJb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function iJb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h+4|0;j=h;k=h+8|0;n[i>>2]=d;n[j>>2]=e;jJb(k,b,c,i,j,g);g=f[k>>2]|0;f[a>>2]=g;f[a+4>>2]=f[k+4>>2];a=g;if(!g){l=k;m=a}else{g=a+4|0;f[g>>2]=(f[g>>2]|0)+1;l=k;m=f[k>>2]|0}if(!m){f[l>>2]=0;u=h;return}k=m+4|0;g=f[k>>2]|0;f[k>>2]=g+-1;if((g|0)!=1){f[l>>2]=0;u=h;return}Yi[f[(f[m>>2]|0)+8>>2]&2047](m);f[l>>2]=0;u=h;return}function jJb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0.0;h=u;u=u+16|0;i=h;j=VDc(56)|0;k=+n[d>>2];l=+n[e>>2];jFa(i,g);r0(j);f[j>>2]=112088;eJb(j,b,c,k,l,i);f[j+4>>2]=20;f[j+8>>2]=3;c=VDc(16)|0;f[c+4>>2]=1;f[c>>2]=112160;f[c+8>>2]=j;f[a>>2]=c;f[a+4>>2]=j;j=f[i>>2]|0;if(!j){u=h;return}a=i+4|0;i=f[a>>2]|0;if((i|0)!=(j|0))f[a>>2]=i+(~((i+-4-j|0)>>>2)<<2);YDc(j);u=h;return}function kJb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;j=u;u=u+32|0;k=j+12|0;l=j+8|0;m=j+4|0;o=j;p=j+16|0;f[k>>2]=b;f[l>>2]=c;n[m>>2]=g;n[o>>2]=h;lJb(p,k,l,d,e,m,o,i);i=f[p>>2]|0;f[a>>2]=i;f[a+4>>2]=f[p+4>>2];a=i;if(!i){q=p;r=a}else{i=a+4|0;f[i>>2]=(f[i>>2]|0)+1;q=p;r=f[p>>2]|0}if(!r){f[q>>2]=0;u=j;return}p=r+4|0;i=f[p>>2]|0;f[p>>2]=i+-1;if((i|0)!=1){f[q>>2]=0;u=j;return}Yi[f[(f[r>>2]|0)+8>>2]&2047](r);f[q>>2]=0;u=j;return}function lJb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0.0,p=0.0;j=u;u=u+16|0;k=j;l=VDc(56)|0;m=f[b>>2]|0;b=f[c>>2]|0;o=+n[g>>2];p=+n[h>>2];jFa(k,i);r0(l);f[l>>2]=112088;eJb(l,d,e,o,p,k);f[l+4>>2]=m;f[l+8>>2]=b;b=VDc(16)|0;f[b+4>>2]=1;f[b>>2]=112160;f[b+8>>2]=l;f[a>>2]=b;f[a+4>>2]=l;l=f[k>>2]|0;if(!l){u=j;return}a=k+4|0;k=f[a>>2]|0;if((k|0)!=(l|0))f[a>>2]=k+(~((k+-4-l|0)>>>2)<<2);YDc(l);u=j;return}function mJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a;e=c;c=d+68|0;do{f[d>>2]=f[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(c|0));f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;e=a+88|0;g=a+112|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[g>>2]=1124007936;e=a+120|0;h=a+152|0;d=a+116|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[h>>2]=e;e=a+160|0;f[a+156>>2]=e;f[e>>2]=0;f[a+164>>2]=0;e=a+168|0;f[e>>2]=1124007936;h=a+176|0;i=a+208|0;d=a+172|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[i>>2]=h;h=a+216|0;f[a+212>>2]=h;f[h>>2]=0;f[a+220>>2]=0;f[a+224>>2]=1124007936;h=a+232|0;i=a+264|0;d=a+228|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[i>>2]=h;h=a+272|0;f[a+268>>2]=h;f[h>>2]=0;f[a+276>>2]=0;f[a+80>>2]=0;b[a+84>>0]=1;h=f[a+44>>2]|0;if((h|0)<=0){oJb(a);return}if((f[a+40>>2]|0)<=3){oJb(a);return}nJb(g,e,h,f[a+52>>2]|0,f[a+48>>2]|0);oJb(a);return}function nJb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0;h=u;u=u+544|0;i=h;j=h+536|0;k=h+312|0;l=h+256|0;m=h+200|0;n=h+144|0;o=h+88|0;q=h+32|0;r=h+480|0;s=h+424|0;t=h+368|0;if((g*162|0)<(d|0)){f[i>>2]=0;f[i+4>>2]=0;v=tT(i,97)|0;w=461676;x=v+97|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,i,461774,461802,2224)}f[k>>2]=1124007936;w=k+4|0;y=k+8|0;z=k+40|0;v=w;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[z>>2]=y;A=k+48|0;B=k+44|0;f[B>>2]=A;f[A>>2]=0;f[k+52>>2]=0;f[i>>2]=162;C=i+4|0;f[C>>2]=5;XS(k,2,i,4);D=(e<<1)+-1|0;E=k+16|0;F=f[E>>2]|0;G=f[B>>2]|0;H=0;I=0;K=5;L=3;M=4;while(1){N=I+2|0;O=Y(N,N)|0;P=((D+N|0)>>>0)/(N>>>0)|0;a:do if(!O)Q=H;else{R=0;S=H;T=L;while(1){U=R;R=R+1|0;V=(R|0)<(O|0);if(!V){Q=S;break a}W=(Y((U|0)%(N|0)|0,P)|0)-e|0;X=(Y((U|0)/(N|0)|0,P)|0)-e|0;U=R;Z=S;while(1){_=F+(Y(f[G>>2]|0,Z)|0)|0;f[_>>2]=I;_=F+(Y(f[G>>2]|0,Z)|0)+4|0;f[_>>2]=W;_=F+(Y(f[G>>2]|0,Z)|0)+8|0;f[_>>2]=X;_=(Y((U|0)%(N|0)|0,P)|0)-e|0;$=F+(Y(f[G>>2]|0,Z)|0)+12|0;f[$>>2]=_;_=(Y((U|0)/(N|0)|0,P)|0)-e|0;$=F+(Y(f[G>>2]|0,Z)|0)+16|0;f[$>>2]=_;U=U+1|0;if((U|0)==(M|0))break;else Z=Z+1|0}Z=S+T|0;if(!V){Q=Z;break}else{S=Z;T=T+-1|0}}}while(0);I=I+1|0;L=L+K|0;M=M+K|0;if((I|0)==3)break;else{H=Q;K=K+2|0}}K=((d+-1+g|0)>>>0)/(g>>>0)|0;Q=Y(K,g)|0;f[l>>2]=1124007936;H=l+4|0;I=l+8|0;M=l+40|0;v=H;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[M>>2]=I;I=l+48|0;L=l+44|0;f[L>>2]=I;f[I>>2]=0;f[l+52>>2]=0;f[i>>2]=Q;f[C>>2]=2;XS(l,2,i,4);p[i>>3]=1.0e3;Q=i+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;f[Q+16>>2]=0;f[Q+20>>2]=0;k_(l,i)|0;f[m>>2]=1124007936;Q=m+4|0;G=m+8|0;F=m+40|0;v=Q;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[F>>2]=G;G=m+48|0;e=m+44|0;f[e>>2]=G;f[G>>2]=0;f[m+52>>2]=0;f[i>>2]=29;f[C>>2]=3;XS(m,2,i,4);sJb(n,k);p[i>>3]=-1.0;C=i+8|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;k_(m,i)|0;if((K|0)>0){C=i+4|0;D=j+4|0;P=o+4|0;N=q+4|0;O=o+8|0;T=q+8|0;S=o+12|0;R=q+12|0;Z=o+16|0;U=q+16|0;X=o+20|0;W=q+20|0;_=o+24|0;$=q+24|0;aa=o+28|0;ba=q+28|0;ca=o+32|0;da=q+32|0;ea=o+36|0;fa=q+36|0;ga=o+40|0;ha=o+48|0;ia=o+44|0;ja=o+52|0;ka=q+44|0;la=q+40|0;ma=q+48|0;na=n+8|0;oa=i+4|0;pa=j+4|0;qa=i+8|0;ra=i+4|0;sa=r+36|0;ta=r+16|0;ua=r+4|0;va=r+40|0;wa=r+44|0;xa=r+48|0;ya=n+16|0;za=n+44|0;Aa=m+16|0;Ba=l+16|0;Ca=0;Da=0;Ea=1024;Fa=0;while(1){Ga=(f[y>>2]|0)-Ca|0;Ha=mJc(Ea|0,0,-130063606,0)|0;Ia=UIc(Ha|0,J|0,Fa|0,0)|0;if(!Ga){Ja=0;Ka=Ea;La=Fa}else{Ja=(Ia>>>0)%(Ga>>>0)|0;Ka=Ia;La=J}Ia=(Ca|0)<6?Ca:Ja;b:do if((Da|0)>0){Ga=f[Aa>>2]|0;Ha=f[e>>2]|0;Ma=f[Ha>>2]|0;Na=f[ya>>2]|0;Oa=f[za>>2]|0;Pa=f[Oa>>2]|0;Qa=Na+(Y(Pa,Ia)|0)|0;Ra=f[Qa>>2]|0;Sa=Qa+4|0;Ta=Qa+8|0;Qa=0;while(1){Ua=Ga+(Y(Ma,Qa)|0)|0;if(((f[Ua>>2]|0)==(Ra|0)?(f[Ua+4>>2]|0)==(f[Sa>>2]|0):0)?(f[Ua+8>>2]|0)==(f[Ta>>2]|0):0)break;Ua=Qa+1|0;if((Ua|0)<(Da|0))Qa=Ua;else{Va=Pa;Wa=Na;Xa=Ma;Ya=Ga;Za=Oa;_a=Ha;$a=23;break b}}Ma=Y(Qa,g)|0;Pa=Y(Ca,g)|0;Ta=f[Ba>>2]|0;Sa=f[L>>2]|0;Ra=Ta+(Y(f[Sa>>2]|0,Pa)|0)|0;f[Ra>>2]=Ma;Ra=Ta+(Y(f[Sa>>2]|0,Pa+1|0)|0)|0;f[Ra>>2]=Ma+1;Ra=Ta+(Y(f[Sa>>2]|0,Pa+2|0)|0)|0;f[Ra>>2]=Ma+2;ab=Da;bb=Oa;cb=Ha;db=Na;eb=Ga;fb=Sa;gb=Ta}else{Ta=f[za>>2]|0;Sa=f[e>>2]|0;Va=f[Ta>>2]|0;Wa=f[ya>>2]|0;Xa=f[Sa>>2]|0;Ya=f[Aa>>2]|0;Za=Ta;_a=Sa;$a=23}while(0);if(($a|0)==23){$a=0;Sa=Wa+(Y(Va,Ia)|0)|0;Ta=Ya+(Y(Xa,Da)|0)|0;f[Ta>>2]=f[Sa>>2];Sa=Wa+(Y(f[Za>>2]|0,Ia)|0)+4|0;Ta=Ya+(Y(f[_a>>2]|0,Da)|0)+4|0;f[Ta>>2]=f[Sa>>2];Sa=Wa+(Y(f[Za>>2]|0,Ia)|0)+8|0;Ta=Ya+(Y(f[_a>>2]|0,Da)|0)+8|0;f[Ta>>2]=f[Sa>>2];Sa=Y(Da,g)|0;Ta=Y(Ca,g)|0;Ma=f[Ba>>2]|0;Ra=f[L>>2]|0;Pa=Ma+(Y(f[Ra>>2]|0,Ta)|0)|0;f[Pa>>2]=Sa;Pa=Ma+(Y(f[Ra>>2]|0,Ta+1|0)|0)|0;f[Pa>>2]=Sa+1;Pa=Ma+(Y(f[Ra>>2]|0,Ta+2|0)|0)|0;f[Pa>>2]=Sa+2;ab=Da+1|0;bb=Za;cb=_a;db=Wa;eb=Ya;fb=Ra;gb=Ma}c:do if((ab|0)>0){Ma=f[cb>>2]|0;Ra=f[bb>>2]|0;Sa=db+(Y(Ra,Ia)|0)|0;Pa=f[Sa>>2]|0;Ta=Sa+12|0;Ua=Sa+16|0;Sa=0;while(1){hb=eb+(Y(Ma,Sa)|0)|0;if(((f[hb>>2]|0)==(Pa|0)?(f[hb+4>>2]|0)==(f[Ta>>2]|0):0)?(f[hb+8>>2]|0)==(f[Ua>>2]|0):0)break;hb=Sa+1|0;if((hb|0)<(ab|0))Sa=hb;else{ib=Ra;jb=Ma;$a=32;break c}}Ma=Y(Sa,g)|0;Ra=Y(Ca,g)|0;Ua=gb+(Y(f[fb>>2]|0,Ra)|0)+4|0;f[Ua>>2]=Ma;Ua=gb+(Y(f[fb>>2]|0,Ra+1|0)|0)+4|0;f[Ua>>2]=Ma+1;Ua=gb+(Y(f[fb>>2]|0,Ra+2|0)|0)+4|0;f[Ua>>2]=Ma+2;kb=ab}else{ib=f[bb>>2]|0;jb=f[cb>>2]|0;$a=32}while(0);if(($a|0)==32){$a=0;Ma=db+(Y(ib,Ia)|0)|0;Ua=eb+(Y(jb,ab)|0)|0;f[Ua>>2]=f[Ma>>2];Ma=db+(Y(f[bb>>2]|0,Ia)|0)+12|0;Ua=eb+(Y(f[cb>>2]|0,ab)|0)+4|0;f[Ua>>2]=f[Ma>>2];Ma=db+(Y(f[bb>>2]|0,Ia)|0)+16|0;Ua=eb+(Y(f[cb>>2]|0,ab)|0)+8|0;f[Ua>>2]=f[Ma>>2];Ma=Y(ab,g)|0;Ua=Y(Ca,g)|0;Ra=gb+(Y(f[fb>>2]|0,Ua)|0)+4|0;f[Ra>>2]=Ma;Ra=gb+(Y(f[fb>>2]|0,Ua+1|0)|0)+4|0;f[Ra>>2]=Ma+1;Ra=gb+(Y(f[fb>>2]|0,Ua+2|0)|0)+4|0;f[Ra>>2]=Ma+2;kb=ab+1|0}f[i>>2]=Ia;f[C>>2]=Ia+1;f[j>>2]=-2147483648;f[D>>2]=2147483647;$S(q,n,i,j);f[o>>2]=f[q>>2];Ma=f[N>>2]|0;f[P>>2]=Ma;f[O>>2]=f[T>>2];f[S>>2]=f[R>>2];f[Z>>2]=f[U>>2];f[X>>2]=f[W>>2];f[_>>2]=f[$>>2];f[aa>>2]=f[ba>>2];f[ca>>2]=f[da>>2];Ra=f[fa>>2]|0;f[ea>>2]=Ra;f[ga>>2]=O;f[ia>>2]=ha;f[ha>>2]=0;f[ja>>2]=0;if(!Ra)lb=Ma;else{Ma=Ra+12|0;f[Ma>>2]=(f[Ma>>2]|0)+1;lb=f[N>>2]|0}if((lb|0)<3){Ma=f[ka>>2]|0;Ra=f[ia>>2]|0;f[Ra>>2]=f[Ma>>2];f[Ra+4>>2]=f[Ma+4>>2]}else{f[P>>2]=0;ZS(o,q)}Ma=f[fa>>2]|0;if(Ma|0?(Ra=Ma+12|0,Ma=f[Ra>>2]|0,f[Ra>>2]=Ma+-1,(Ma|0)==1):0)_S(q);f[fa>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[N>>2]|0)>0){Ma=f[la>>2]|0;Ra=0;do{f[Ma+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[N>>2]|0))}Ra=f[ka>>2]|0;if((Ra|0)!=(ma|0))g0(Ra);Ra=(f[na>>2]|0)-Ca|0;f[i>>2]=Ra+-1;f[oa>>2]=Ra;f[j>>2]=-2147483648;f[pa>>2]=2147483647;$S(r,n,i,j);Ra=qa;f[Ra>>2]=0;f[Ra+4>>2]=0;f[i>>2]=33619968;f[ra>>2]=o;h_(r,i);Ra=f[sa>>2]|0;if(Ra|0?(Ma=Ra+12|0,Ra=f[Ma>>2]|0,f[Ma>>2]=Ra+-1,(Ra|0)==1):0)_S(r);f[sa>>2]=0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[ua>>2]|0)>0){Ra=f[va>>2]|0;Ma=0;do{f[Ra+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[ua>>2]|0))}Ma=f[wa>>2]|0;if((Ma|0)!=(xa|0))g0(Ma);Ma=f[ea>>2]|0;if(Ma|0?(Ra=Ma+12|0,Ma=f[Ra>>2]|0,f[Ra>>2]=Ma+-1,(Ma|0)==1):0)_S(o);f[ea>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[P>>2]|0)>0){Ma=f[ga>>2]|0;Ra=0;do{f[Ma+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[P>>2]|0))}Ra=f[ia>>2]|0;if((Ra|0)!=(ha|0))g0(Ra);Ca=Ca+1|0;if((Ca|0)>=(K|0)){mb=kb;break}else{Da=kb;Ea=Ka;Fa=La}}}else mb=0;f[i>>2]=0;f[i+4>>2]=mb;f[j>>2]=-2147483648;f[j+4>>2]=2147483647;$S(s,m,i,j);f[o>>2]=1124007936;mb=o+4|0;La=o+8|0;Fa=o+40|0;v=mb;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[Fa>>2]=La;Ka=o+48|0;Ea=o+44|0;f[Ea>>2]=Ka;f[Ka>>2]=0;f[o+52>>2]=0;kb=i+8|0;f[kb>>2]=0;f[kb+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;h_(s,i);if((o|0)==(a|0)){nb=o+36|0;ob=f[a+36>>2]|0}else{kb=o+36|0;Da=f[kb>>2]|0;if(Da|0){K=Da+12|0;f[K>>2]=(f[K>>2]|0)+1}K=a+36|0;Da=f[K>>2]|0;if(Da|0?(Ca=Da+12|0,Da=f[Ca>>2]|0,f[Ca>>2]=Da+-1,(Da|0)==1):0)_S(a);f[K>>2]=0;Da=a+16|0;Ca=a+4|0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[Ca>>2]|0)>0){ha=f[a+40>>2]|0;ia=0;do{f[ha+(ia<<2)>>2]=0;ia=ia+1|0;pb=f[Ca>>2]|0}while((ia|0)<(pb|0));f[a>>2]=f[o>>2];if((pb|0)<3)$a=74;else $a=76}else{f[a>>2]=f[o>>2];$a=74}if(($a|0)==74){pb=f[mb>>2]|0;if((pb|0)<3){f[Ca>>2]=pb;f[a+8>>2]=f[La>>2];f[a+12>>2]=f[o+12>>2];La=f[Ea>>2]|0;pb=f[a+44>>2]|0;f[pb>>2]=f[La>>2];f[pb+4>>2]=f[La+4>>2]}else $a=76}if(($a|0)==76)ZS(a,o);f[Da>>2]=f[o+16>>2];f[a+20>>2]=f[o+20>>2];f[a+24>>2]=f[o+24>>2];f[a+28>>2]=f[o+28>>2];f[a+32>>2]=f[o+32>>2];a=f[kb>>2]|0;f[K>>2]=a;nb=kb;ob=a}if(ob|0?(a=ob+12|0,ob=f[a>>2]|0,f[a>>2]=ob+-1,(ob|0)==1):0)_S(o);f[nb>>2]=0;nb=o+16|0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[mb>>2]|0)>0){nb=f[Fa>>2]|0;Fa=0;do{f[nb+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[mb>>2]|0))}mb=f[Ea>>2]|0;if((mb|0)!=(Ka|0))g0(mb);mb=s+36|0;Ka=f[mb>>2]|0;if(Ka|0?(Ea=Ka+12|0,Ka=f[Ea>>2]|0,f[Ea>>2]=Ka+-1,(Ka|0)==1):0)_S(s);f[mb>>2]=0;mb=s+16|0;Ka=s+4|0;f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;f[mb+12>>2]=0;if((f[Ka>>2]|0)>0){mb=f[s+40>>2]|0;Ea=0;do{f[mb+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[Ka>>2]|0))}Ka=f[s+44>>2]|0;if((Ka|0)!=(s+48|0))g0(Ka);f[i>>2]=0;f[i+4>>2]=d;f[j>>2]=-2147483648;f[j+4>>2]=2147483647;$S(t,l,i,j);f[o>>2]=1124007936;j=o+4|0;d=o+8|0;Ka=o+40|0;v=j;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[Ka>>2]=d;v=o+48|0;x=o+44|0;f[x>>2]=v;f[v>>2]=0;f[o+52>>2]=0;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;h_(t,i);if((o|0)==(c|0)){qb=o+36|0;rb=f[c+36>>2]|0}else{i=o+36|0;s=f[i>>2]|0;if(s|0){Ea=s+12|0;f[Ea>>2]=(f[Ea>>2]|0)+1}Ea=c+36|0;s=f[Ea>>2]|0;if(s|0?(mb=s+12|0,s=f[mb>>2]|0,f[mb>>2]=s+-1,(s|0)==1):0)_S(c);f[Ea>>2]=0;s=c+16|0;mb=c+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[mb>>2]|0)>0){Fa=f[c+40>>2]|0;nb=0;do{f[Fa+(nb<<2)>>2]=0;nb=nb+1|0;sb=f[mb>>2]|0}while((nb|0)<(sb|0));f[c>>2]=f[o>>2];if((sb|0)<3)$a=106;else $a=108}else{f[c>>2]=f[o>>2];$a=106}if(($a|0)==106){sb=f[j>>2]|0;if((sb|0)<3){f[mb>>2]=sb;f[c+8>>2]=f[d>>2];f[c+12>>2]=f[o+12>>2];d=f[x>>2]|0;sb=f[c+44>>2]|0;f[sb>>2]=f[d>>2];f[sb+4>>2]=f[d+4>>2]}else $a=108}if(($a|0)==108)ZS(c,o);f[s>>2]=f[o+16>>2];f[c+20>>2]=f[o+20>>2];f[c+24>>2]=f[o+24>>2];f[c+28>>2]=f[o+28>>2];f[c+32>>2]=f[o+32>>2];c=f[i>>2]|0;f[Ea>>2]=c;qb=i;rb=c}if(rb|0?(c=rb+12|0,rb=f[c>>2]|0,f[c>>2]=rb+-1,(rb|0)==1):0)_S(o);f[qb>>2]=0;qb=o+16|0;f[qb>>2]=0;f[qb+4>>2]=0;f[qb+8>>2]=0;f[qb+12>>2]=0;if((f[j>>2]|0)>0){qb=f[Ka>>2]|0;Ka=0;do{f[qb+(Ka<<2)>>2]=0;Ka=Ka+1|0}while((Ka|0)<(f[j>>2]|0))}j=f[x>>2]|0;if((j|0)!=(v|0))g0(j);j=t+36|0;v=f[j>>2]|0;if(v|0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0)_S(t);f[j>>2]=0;j=t+16|0;v=t+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[v>>2]|0)>0){j=f[t+40>>2]|0;x=0;do{f[j+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[t+44>>2]|0;if((v|0)!=(t+48|0))g0(v);v=n+36|0;t=f[v>>2]|0;if(t|0?(x=t+12|0,t=f[x>>2]|0,f[x>>2]=t+-1,(t|0)==1):0)_S(n);f[v>>2]=0;v=n+16|0;t=n+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[n+40>>2]|0;x=0;do{f[v+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[t>>2]|0))}t=f[n+44>>2]|0;if((t|0)!=(n+48|0))g0(t);t=m+36|0;n=f[t>>2]|0;do if(n|0){x=n+12|0;v=f[x>>2]|0;f[x>>2]=v+-1;if((v|0)!=1)break;_S(m)}while(0);f[t>>2]=0;t=m+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[Q>>2]|0)>0){t=f[F>>2]|0;F=0;do{f[t+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[Q>>2]|0))}Q=f[e>>2]|0;if((Q|0)!=(G|0))g0(Q);Q=l+36|0;G=f[Q>>2]|0;do if(G|0){e=G+12|0;F=f[e>>2]|0;f[e>>2]=F+-1;if((F|0)!=1)break;_S(l)}while(0);f[Q>>2]=0;Q=l+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[H>>2]|0)>0){Q=f[M>>2]|0;M=0;do{f[Q+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[H>>2]|0))}H=f[L>>2]|0;if((H|0)!=(I|0))g0(H);H=k+36|0;I=f[H>>2]|0;do if(I|0){L=I+12|0;M=f[L>>2]|0;f[L>>2]=M+-1;if((M|0)!=1)break;_S(k)}while(0);f[H>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[w>>2]|0)>0){E=f[z>>2]|0;z=0;do{f[E+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[w>>2]|0))}w=f[B>>2]|0;if((w|0)==(A|0)){u=h;return}g0(w);u=h;return}function oJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;b=u;u=u+352|0;c=b+24|0;d=b+12|0;e=b+8|0;g=b+4|0;h=b;switch(f[a+40>>2]|0){case 5:case 4:{i=14.142135620117188;break}case 3:case 2:{i=16.970561981201172;break}default:i=0.0}j=f[a>>2]|0;a:do if((j|0)>0){k=a+12|0;l=a+8|0;m=a+4|0;o=c+4|0;p=c+8|0;q=c+40|0;r=c+48|0;s=c+44|0;t=c+52|0;v=c+56|0;w=c+60|0;x=c+64|0;y=c+96|0;z=c+104|0;A=c+100|0;B=c+108|0;C=c+112|0;D=c+116|0;E=c+120|0;F=c+152|0;G=c+160|0;H=c+156|0;I=c+164|0;J=c+168|0;K=c+172|0;L=c+176|0;M=c+208|0;N=c+216|0;O=c+212|0;P=c+220|0;Q=c+224|0;R=c+228|0;S=c+232|0;T=c+264|0;U=c+272|0;V=c+268|0;W=c+280|0;X=c+284|0;Y=a+16|0;Z=c+292|0;_=a+20|0;$=c+304|0;aa=c+288|0;ba=c+296|0;ca=c+300|0;da=c+308|0;ea=c+312|0;fa=a+72|0;ga=a+76|0;ha=a+68|0;ia=1;ja=0;ka=j;while(1){la=+(ia|0);ma=1.0/la;na=~~(ma*+(f[k>>2]|0));oa=~~(ma*+(f[l>>2]|0));if((ja|0)!=0&((na|0)<40|(oa|0)<80))break;pa=f[m>>2]|0;if((pa|0)>0){ma=+(ja|0);qa=0;ra=pa;do{f[c>>2]=1124007936;pa=o;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[q>>2]=p;f[s>>2]=r;f[r>>2]=0;f[t>>2]=0;f[v>>2]=1124007936;pa=w;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[y>>2]=x;f[A>>2]=z;f[z>>2]=0;f[B>>2]=0;f[C>>2]=1124007936;pa=D;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[F>>2]=E;f[H>>2]=G;f[G>>2]=0;f[I>>2]=0;f[J>>2]=1124007936;pa=K;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[M>>2]=L;f[O>>2]=N;f[N>>2]=0;f[P>>2]=0;f[Q>>2]=1124007936;pa=R;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[T>>2]=S;f[V>>2]=U;pa=U;f[pa>>2]=0;f[pa+4>>2]=0;f[W>>2]=oa;f[X>>2]=na;ta=+n[Y>>2];ua=ta*+Me(+(ma+ +(qa|0)/+(ra|0)));n[Z>>2]=ua;pa=mrc(ua*+n[_>>2]/la)|0;f[$>>2]=pa;n[aa>>2]=ua*ua*.5;f[ba>>2]=ja;f[ca>>2]=qa;n[da>>2]=la;sa=(mrc(i*+(pa|0))|0)+1|0;f[ea>>2]=sa;sa=f[fa>>2]|0;if((sa|0)==(f[ga>>2]|0))qJb(ha,c);else{pJb(sa,c);f[fa>>2]=(f[fa>>2]|0)+316}SGb(c);qa=qa+1|0;ra=f[m>>2]|0}while((qa|0)<(ra|0));va=f[a>>2]|0}else va=ka;ra=ja+1|0;if((ra|0)<(va|0)){ia=ia<<1;ja=ra;ka=va}else{wa=fa;xa=ha;break a}}f[a>>2]=ja;wa=fa;xa=ha}else{wa=a+72|0;xa=a+68|0}while(0);va=f[xa>>2]|0;if((((f[wa>>2]|0)-va|0)/316|0)>>>0<=1){u=b;return}j=d+4|0;ka=d+8|0;ia=a+84|0;m=a+104|0;ga=a+108|0;ea=a+100|0;da=a+92|0;ca=a+96|0;ba=a+88|0;aa=a+80|0;a=1;$=va;while(1){va=$;f[c>>2]=0;f[d>>2]=0;f[j>>2]=0;f[ka>>2]=0;n[e>>2]=+n[va+(a*316|0)+288>>2]-+n[va+((a+-1|0)*316|0)+288>>2];f[g>>2]=1;n[h>>2]=.25;va=qMb(e,g,h,ia,d)|0;f[c>>2]=va;_=f[m>>2]|0;if((_|0)==(f[ga>>2]|0))g6(ea,c);else{f[_>>2]=va;f[m>>2]=_+4}ya=f[da>>2]|0;if((ya|0)==(f[ca>>2]|0)){rJb(ba,d);za=f[d>>2]|0}else{f[ya>>2]=0;_=ya+4|0;f[_>>2]=0;f[ya+8>>2]=0;va=f[d>>2]|0;Z=(f[j>>2]|0)-va|0;Y=Z>>2;if(Y){if(Y>>>0>1073741823){Aa=26;break}X=VDc(Z)|0;f[_>>2]=X;f[ya>>2]=X;f[ya+8>>2]=X+(Y<<2);Y=f[d>>2]|0;Z=(f[j>>2]|0)-Y|0;if((Z|0)>0){dJc(X|0,Y|0,Z|0)|0;f[_>>2]=X+(Z>>>2<<2);Ba=Y}else Ba=Y}else Ba=va;f[da>>2]=(f[da>>2]|0)+12;za=Ba}f[aa>>2]=(f[aa>>2]|0)+1;if(za|0){va=f[j>>2]|0;if((va|0)!=(za|0))f[j>>2]=va+(~((va+-4-za|0)>>>2)<<2);YDc(za)}a=a+1|0;$=f[xa>>2]|0;if(a>>>0>=(((f[wa>>2]|0)-$|0)/316|0)>>>0){Aa=19;break}}if((Aa|0)==19){u=b;return}else if((Aa|0)==26)mCc(ya)}function pJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=f[b>>2];c=a+4|0;d=b+4|0;f[c>>2]=f[d>>2];e=a+8|0;f[e>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];g=f[b+36>>2]|0;f[a+36>>2]=g;f[a+40>>2]=e;e=a+48|0;h=a+44|0;f[h>>2]=e;f[e>>2]=0;f[a+52>>2]=0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[d>>2]|0)<3){d=f[b+44>>2]|0;e=f[h>>2]|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2]}else{f[c>>2]=0;ZS(a,b)}c=a+56|0;d=b+56|0;f[c>>2]=f[d>>2];e=a+60|0;h=b+60|0;f[e>>2]=f[h>>2];g=a+64|0;f[g>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[a+80>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];i=f[b+92>>2]|0;f[a+92>>2]=i;f[a+96>>2]=g;g=a+104|0;j=a+100|0;f[j>>2]=g;f[g>>2]=0;f[a+108>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+100>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(c,d)}d=a+112|0;c=b+112|0;f[d>>2]=f[c>>2];e=a+116|0;h=b+116|0;f[e>>2]=f[h>>2];g=a+120|0;f[g>>2]=f[b+120>>2];f[a+124>>2]=f[b+124>>2];f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];f[a+136>>2]=f[b+136>>2];f[a+140>>2]=f[b+140>>2];f[a+144>>2]=f[b+144>>2];j=f[b+148>>2]|0;f[a+148>>2]=j;f[a+152>>2]=g;g=a+160|0;i=a+156|0;f[i>>2]=g;f[g>>2]=0;f[a+164>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+156>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(d,c)}c=a+168|0;d=b+168|0;f[c>>2]=f[d>>2];e=a+172|0;h=b+172|0;f[e>>2]=f[h>>2];g=a+176|0;f[g>>2]=f[b+176>>2];f[a+180>>2]=f[b+180>>2];f[a+184>>2]=f[b+184>>2];f[a+188>>2]=f[b+188>>2];f[a+192>>2]=f[b+192>>2];f[a+196>>2]=f[b+196>>2];f[a+200>>2]=f[b+200>>2];i=f[b+204>>2]|0;f[a+204>>2]=i;f[a+208>>2]=g;g=a+216|0;j=a+212|0;f[j>>2]=g;f[g>>2]=0;f[a+220>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+212>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(c,d)}d=a+224|0;c=b+224|0;f[d>>2]=f[c>>2];e=a+228|0;h=b+228|0;f[e>>2]=f[h>>2];g=a+232|0;f[g>>2]=f[b+232>>2];f[a+236>>2]=f[b+236>>2];f[a+240>>2]=f[b+240>>2];f[a+244>>2]=f[b+244>>2];f[a+248>>2]=f[b+248>>2];f[a+252>>2]=f[b+252>>2];f[a+256>>2]=f[b+256>>2];j=f[b+260>>2]|0;f[a+260>>2]=j;f[a+264>>2]=g;g=a+272|0;i=a+268|0;f[i>>2]=g;f[g>>2]=0;f[a+276>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+268>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];k=a+280|0;l=b+280|0;m=f[l>>2]|0;f[k>>2]=m;n=a+284|0;o=b+284|0;p=f[o>>2]|0;f[n>>2]=p;q=a+288|0;r=b+288|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];f[q+20>>2]=f[r+20>>2];f[q+24>>2]=f[r+24>>2];return}else{f[e>>2]=0;ZS(d,c);k=a+280|0;l=b+280|0;m=f[l>>2]|0;f[k>>2]=m;n=a+284|0;o=b+284|0;p=f[o>>2]|0;f[n>>2]=p;q=a+288|0;r=b+288|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];f[q+20>>2]=f[r+20>>2];f[q+24>>2]=f[r+24>>2];return}}function qJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/316|0;g=e+1|0;if(g>>>0>13591668)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/316|0;d=i<<1;j=i>>>0<6795834?(d>>>0<g>>>0?g:d):13591668;do if(j)if(j>>>0>13591668){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*316|0)|0;break}else k=0;while(0);d=k+(e*316|0)|0;e=d;g=k+(j*316|0)|0;pJb(d,b);b=d+316|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=k}else{i=k;k=e;e=d;do{i=i+-316|0;pJb(e+-316|0,i);e=k+-316|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;h=n;while(1){n=h;if((n|0)==(g|0))break;b=n+-316|0;SGb(b);h=b}if(!m)return;YDc(m);return}function rJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;CF(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-12|0;CF(e+-12|0,i);e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-4-b|0)>>>2)<<2);YDc(b)}}while((h|0)!=(g|0))}if(!m)return;YDc(m);return}function sJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+80|0;d=c+56|0;e=c;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=e+48|0;j=e+44|0;f[j>>2]=h;f[h>>2]=0;f[e+52>>2]=0;k=d+8|0;f[k>>2]=0;f[k+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=e;h_(b,d);tJb(a,e);a=e+36|0;d=f[a>>2]|0;if(d|0?(b=d+12|0,d=f[b>>2]|0,f[b>>2]=d+-1,(d|0)==1):0)_S(e);f[a>>2]=0;a=e+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[g>>2]|0)>0){a=f[i>>2]|0;i=0;do{f[a+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[j>>2]|0;if((g|0)==(h|0)){u=c;return}g0(g);u=c;return}function tJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007940;uJb(a,b)|0;return}function uJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d;g=f[c>>2]|0;if((g&4095|0)==4){if((a|0)==(c|0)){h=a;u=d;return h|0}i=c+36|0;j=f[i>>2]|0;if(j|0){k=j+12|0;f[k>>2]=(f[k>>2]|0)+1}k=a+36|0;j=f[k>>2]|0;if(j|0?(l=j+12|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)_S(a);f[k>>2]=0;j=a+16|0;l=a+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[l>>2]|0)>0){m=f[a+40>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0;o=f[l>>2]|0}while((n|0)<(o|0));f[a>>2]=f[c>>2];if((o|0)<3)p=13;else p=15}else{f[a>>2]=f[c>>2];p=13}if((p|0)==13){o=f[c+4>>2]|0;if((o|0)<3){f[l>>2]=o;f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];o=f[c+44>>2]|0;l=f[a+44>>2]|0;f[l>>2]=f[o>>2];f[l+4>>2]=f[o+4>>2]}else p=15}if((p|0)==15)ZS(a,c);f[j>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[k>>2]=f[i>>2];h=a;u=d;return h|0}if((g&7|0)==4){mT(e,c,1,f[c+4>>2]|0,0);i=uJb(a,e)|0;k=e+36|0;j=f[k>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)_S(e);f[k>>2]=0;k=e+16|0;j=e+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[e+40>>2]|0;p=0;do{f[k+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}j=f[e+44>>2]|0;if((j|0)!=(e+48|0))g0(j);h=i;u=d;return h|0}else{if(g&4088|0?f[c+16>>2]|0:0){g=f[c+4>>2]|0;if((g|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{i=f[c+40>>2]|0;j=0;p=1;while(1){k=Y(f[i+(j<<2)>>2]|0,p)|0;j=j+1|0;if((j|0)==(g|0)){q=k;break}else p=k}}if(!((g|0)==0|(q|0)==0)){f[e>>2]=0;f[e+4>>2]=0;q=tT(e,52)|0;g=461885;p=q+52|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(p|0));z5(-215,e,518179,461938,1756)}}g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=-2113863676;f[e+4>>2]=a;LZ(c,e,4,1.0,0.0);h=a;u=d;return h|0}return 0}function vJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0.0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;d=u;u=u+688|0;e=d+624|0;g=d+568|0;h=d+512|0;i=d+456|0;j=d+440|0;k=d+416|0;l=d+360|0;m=d+352|0;o=d+296|0;p=d+240|0;q=d+184|0;r=d+128|0;s=d+72|0;t=d+64|0;v=d+56|0;w=d+48|0;x=d+32|0;y=d+16|0;z=d;A=a+68|0;B=a+72|0;if((f[B>>2]|0)==(f[A>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;C=tT(e,20)|0;D=462021;E=C+20|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,e,462042,461802,436)}f[l>>2]=1124007936;F=l+4|0;G=l+8|0;H=l+40|0;C=F;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[H>>2]=G;G=l+48|0;I=l+44|0;f[I>>2]=G;f[G>>2]=0;f[l+52>>2]=0;J=h+8|0;f[J>>2]=0;f[J+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=l;do if((d$(c)|0)==65536){J=f[c+4>>2]|0;f[e>>2]=f[J>>2];K=e+4|0;L=J+4|0;f[K>>2]=f[L>>2];N=e+8|0;f[N>>2]=f[J+8>>2];f[e+12>>2]=f[J+12>>2];f[e+16>>2]=f[J+16>>2];f[e+20>>2]=f[J+20>>2];f[e+24>>2]=f[J+24>>2];f[e+28>>2]=f[J+28>>2];f[e+32>>2]=f[J+32>>2];O=f[J+36>>2]|0;f[e+36>>2]=O;f[e+40>>2]=N;N=e+48|0;P=e+44|0;f[P>>2]=N;f[N>>2]=0;f[e+52>>2]=0;if(O|0){N=O+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[L>>2]|0)<3){L=f[J+44>>2]|0;N=f[P>>2]|0;f[N>>2]=f[L>>2];f[N+4>>2]=f[L+4>>2];Q=e;break}else{f[K>>2]=0;ZS(e,J);Q=e;break}}else{a$(e,c,-1);Q=e}while(0);J=f[Q>>2]|0;if(!(J&4088))R=J;else{J=g+8|0;f[J>>2]=0;f[J+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;Oga(c,g,6,0);R=f[Q>>2]|0}switch(R&7){case 5:{b0(h,e);break}case 0:{LZ(e,h,5,.00392156862745098,0.0);break}case 2:{LZ(e,h,5,1.5259021896696422e-05,0.0);break}default:{}}R=e+36|0;Q=f[R>>2]|0;if(Q|0?(c=Q+12|0,Q=f[c>>2]|0,f[c>>2]=Q+-1,(Q|0)==1):0)_S(e);f[R>>2]=0;R=e+16|0;Q=e+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Q>>2]|0)>0){R=f[e+40>>2]|0;c=0;do{f[R+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[Q>>2]|0))}Q=f[e+44>>2]|0;if((Q|0)!=(e+48|0))g0(Q);S=+n[a+16>>2];T=((S+-.800000011920929)/.30000001192092896+1.0)*2.0;Q=~~T;c=(+(Q|0)<T&1)+Q|1;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=l;Q=(f[A>>2]|0)+168|0;R=g+8|0;f[R>>2]=0;f[R+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=Q;f[m>>2]=c;f[m+4>>2]=c;T=S;Gfa(e,g,m,T,T,1);m=f[A>>2]|0;c=e+8|0;f[c>>2]=0;f[c+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=m+112;h_(m+168|0,e);if(((f[B>>2]|0)-(f[A>>2]|0)|0)!=316){f[o>>2]=1124007936;m=o+4|0;c=o+8|0;Q=o+40|0;C=m;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[Q>>2]=c;c=o+48|0;R=o+44|0;f[R>>2]=c;f[c>>2]=0;f[o+52>>2]=0;f[p>>2]=1124007936;J=p+4|0;K=p+8|0;L=p+40|0;C=J;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[L>>2]=K;K=p+48|0;N=p+44|0;f[N>>2]=K;f[K>>2]=0;f[p+52>>2]=0;f[q>>2]=1124007936;P=q+4|0;O=q+8|0;U=q+40|0;C=P;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[U>>2]=O;O=q+48|0;V=q+44|0;f[V>>2]=O;f[O>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;W=r+4|0;X=r+8|0;Z=r+40|0;C=W;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[Z>>2]=X;X=r+48|0;_=r+44|0;f[_>>2]=X;f[X>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;$=s+4|0;aa=s+8|0;ba=s+40|0;C=$;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[ba>>2]=aa;aa=s+48|0;ca=s+44|0;f[ca>>2]=aa;f[aa>>2]=0;f[s+52>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=l;da=g+8|0;f[da>>2]=0;f[da+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=q;f[t>>2]=5;f[t+4>>2]=5;Gfa(e,g,t,1.0,1.0,1);f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=q;t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o;Ioa(e,g,5,1,0,1.0,0.0,4);f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=q;t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=p;Ioa(e,g,5,0,1,1.0,0.0,4);t=q+36|0;da=f[t>>2]|0;if(da|0?(ea=da+12|0,da=f[ea>>2]|0,f[ea>>2]=da+-1,(da|0)==1):0)_S(q);f[t>>2]=0;da=q+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[P>>2]|0)>0){ea=f[U>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[P>>2]|0))}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;fa=j+4|0;f[fa>>2]=o;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;ea=k+4|0;f[ea>>2]=p;T=+n[a+60>>2];ga=f[a+64>>2]|0;if((ga|0)<=2){f[e>>2]=0;f[e+4>>2]=0;C=tT(e,9)|0;D=462071;E=C+9|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,e,462081,461802,307)}if(r$(j)|0){f[e>>2]=0;f[e+4>>2]=0;C=tT(e,12)|0;D=462099;E=C+12|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,e,462081,461802,308)}do if((d$(j)|0)==65536){ha=f[fa>>2]|0;f[g>>2]=f[ha>>2];ia=g+4|0;ja=ha+4|0;f[ia>>2]=f[ja>>2];ka=g+8|0;f[ka>>2]=f[ha+8>>2];f[g+12>>2]=f[ha+12>>2];f[g+16>>2]=f[ha+16>>2];f[g+20>>2]=f[ha+20>>2];f[g+24>>2]=f[ha+24>>2];f[g+28>>2]=f[ha+28>>2];f[g+32>>2]=f[ha+32>>2];la=f[ha+36>>2]|0;f[g+36>>2]=la;f[g+40>>2]=ka;ka=g+48|0;ma=g+44|0;f[ma>>2]=ka;f[ka>>2]=0;f[g+52>>2]=0;if(la|0){ka=la+12|0;f[ka>>2]=(f[ka>>2]|0)+1}if((f[ja>>2]|0)<3){ja=f[ha+44>>2]|0;ka=f[ma>>2]|0;f[ka>>2]=f[ja>>2];f[ka+4>>2]=f[ja+4>>2];break}else{f[ia>>2]=0;ZS(g,ha);break}}else a$(g,j,-1);while(0);do if((d$(k)|0)==65536){fa=f[ea>>2]|0;f[h>>2]=f[fa>>2];ha=h+4|0;ia=fa+4|0;f[ha>>2]=f[ia>>2];ja=h+8|0;f[ja>>2]=f[fa+8>>2];f[h+12>>2]=f[fa+12>>2];f[h+16>>2]=f[fa+16>>2];f[h+20>>2]=f[fa+20>>2];f[h+24>>2]=f[fa+24>>2];f[h+28>>2]=f[fa+28>>2];f[h+32>>2]=f[fa+32>>2];ka=f[fa+36>>2]|0;f[h+36>>2]=ka;f[h+40>>2]=ja;ja=h+48|0;ma=h+44|0;f[ma>>2]=ja;f[ja>>2]=0;f[h+52>>2]=0;if(ka|0){ja=ka+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[ia>>2]|0)<3){ia=f[fa+44>>2]|0;ja=f[ma>>2]|0;f[ja>>2]=f[ia>>2];f[ja+4>>2]=f[ia+4>>2];break}else{f[ha>>2]=0;ZS(h,fa);break}}else a$(h,k,-1);while(0);ea=g+8|0;fa=(f[ea>>2]|0)+-2|0;ha=g+12|0;ia=(f[ha>>2]|0)+-2|0;f[i>>2]=1124007936;ja=i+4|0;ma=i+8|0;ka=i+40|0;C=ja;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[ka>>2]=ma;la=i+48|0;na=i+44|0;f[na>>2]=la;f[la>>2]=0;f[i+52>>2]=0;f[e>>2]=fa;f[e+4>>2]=ia;XS(i,2,e,5);ia=Y(f[ma>>2]|0,f[i+12>>2]|0)|0;ma=i+16|0;fa=f[ma>>2]|0;oa=(f[ea>>2]|0)+-1|0;if((oa|0)>1?(ea=f[g+16>>2]|0,pa=f[f[g+44>>2]>>2]|0,qa=f[h+16>>2]|0,ra=f[f[h+44>>2]>>2]|0,sa=f[ha>>2]|0,ha=sa+-2|0,(sa|0)>2):0){sa=fa;ta=1;S=0.0;while(1){ua=ea+(Y(ta,pa)|0)+4|0;va=qa+(Y(ta,ra)|0)+4|0;wa=0;xa=sa;ya=S;while(1){za=+n[ua+(wa<<2)>>2];Aa=+n[va+(wa<<2)>>2];Ba=+M(+(za*za+Aa*Aa));n[xa>>2]=Ba;ya=ya<Ba?Ba:ya;wa=wa+1|0;if((wa|0)==(ha|0))break;else xa=xa+4|0}ta=ta+1|0;if((ta|0)==(oa|0))break;else{sa=sa+(ha<<2)|0;S=ya}}if(!(ya==0.0)){ha=e+8|0;f[ha>>2]=0;f[ha+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=i;LZ(i,e,-1,+(ga+-1|0)/ya,0.0);f[e>>2]=0;ha=e+4|0;f[ha>>2]=0;f[e+8>>2]=0;do if(ga)if(ga>>>0>1073741823)mCc(e);else{sa=ga<<2;oa=VDc(sa)|0;f[e>>2]=oa;ta=oa+(ga<<2)|0;f[e+8>>2]=ta;XIc(oa|0,0,sa|0)|0;f[ha>>2]=ta;Ca=oa;Da=ta;Ea=oa;break}else{Ca=0;Da=0;Ea=0}while(0);if((ia|0)>0){oa=0;do{ta=Ca+(~~+n[fa+(oa<<2)>>2]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;oa=oa+1|0}while((oa|0)!=(ia|0))}oa=~~(T*+(ia-(f[Ca>>2]|0)|0));a:do if((ga|0)>1){ia=1;fa=0;while(1){if((fa|0)>=(oa|0))break;fa=(f[Ca+(ia<<2)>>2]|0)+fa|0;ta=ia+1|0;if((ta|0)>=(ga|0)){Fa=.029999999329447746;break a}else ia=ta}Fa=ya*+(ia|0)/+(ga|0)}else Fa=.029999999329447746;while(0);if((Da|0)!=(Ca|0))f[ha>>2]=Da+(~((Da+-4-Ca|0)>>>2)<<2);YDc(Ea);Ga=Fa}else Ga=.029999999329447746}else Ga=.029999999329447746;Ea=i+36|0;Ca=f[Ea>>2]|0;if(Ca|0?(Da=Ca+12|0,Ca=f[Da>>2]|0,f[Da>>2]=Ca+-1,(Ca|0)==1):0)_S(i);f[Ea>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ja>>2]|0)>0){ma=f[ka>>2]|0;ka=0;do{f[ma+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[ja>>2]|0))}ja=f[na>>2]|0;if((ja|0)!=(la|0))g0(ja);ja=h+36|0;la=f[ja>>2]|0;do if(la|0){na=la+12|0;ka=f[na>>2]|0;f[na>>2]=ka+-1;if((ka|0)!=1)break;_S(h)}while(0);f[ja>>2]=0;ja=h+16|0;la=h+4|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[la>>2]|0)>0){ja=f[h+40>>2]|0;ka=0;do{f[ja+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[la>>2]|0))}la=f[h+44>>2]|0;if((la|0)!=(h+48|0))g0(la);la=g+36|0;ka=f[la>>2]|0;do if(ka|0){ja=ka+12|0;na=f[ja>>2]|0;f[ja>>2]=na+-1;if((na|0)!=1)break;_S(g)}while(0);f[la>>2]=0;la=g+16|0;ka=g+4|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[ka>>2]|0)>0){la=f[g+40>>2]|0;na=0;do{f[la+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[ka>>2]|0))}ka=f[g+44>>2]|0;if((ka|0)!=(g+48|0))g0(ka);ka=f[B>>2]|0;na=f[A>>2]|0;b:do if(((ka-na|0)/316|0)>>>0>1){la=e+8|0;ja=e+12|0;ma=e+4|0;Ea=g+8|0;Ca=g+4|0;Da=v+4|0;ha=e+8|0;ga=e+12|0;oa=e+4|0;fa=g+8|0;ta=g+4|0;sa=w+4|0;ra=e+8|0;qa=e+12|0;pa=e+4|0;ea=g+8|0;xa=g+4|0;wa=e+8|0;va=e+12|0;ua=e+4|0;Ha=g+8|0;Ia=g+4|0;Ja=h+8|0;Ka=h+12|0;La=h+4|0;Ma=i+8|0;Na=i+12|0;Oa=i+4|0;Pa=j+8|0;Qa=j+4|0;Ra=a+28|0;Sa=a+88|0;Ta=x+8|0;Ua=x+12|0;Va=x+4|0;Wa=y+8|0;Xa=y+12|0;Ya=y+4|0;Za=z+8|0;_a=z+4|0;$a=g+4|0;ab=g+8|0;bb=g+12|0;cb=g+16|0;db=g+20|0;eb=g+24|0;fb=g+28|0;gb=g+32|0;hb=g+36|0;ib=g+40|0;jb=g+48|0;kb=g+44|0;lb=g+52|0;mb=h+4|0;nb=h+8|0;ob=h+12|0;pb=h+16|0;qb=h+20|0;rb=h+24|0;sb=h+28|0;tb=h+32|0;ub=h+36|0;vb=h+40|0;wb=h+48|0;xb=h+44|0;yb=h+52|0;zb=i+4|0;Ab=i+8|0;Bb=i+12|0;Cb=i+16|0;Db=i+20|0;Eb=i+24|0;Fb=i+28|0;Gb=i+32|0;Hb=i+36|0;Ib=i+40|0;Jb=i+48|0;Kb=i+44|0;Lb=i+52|0;Mb=j+4|0;Nb=k+4|0;Ob=k+8|0;Pb=k+12|0;Qb=k+16|0;Rb=e+8|0;Sb=e+12|0;Tb=e+4|0;Ub=g+8|0;Vb=g+12|0;Wb=g+4|0;Xb=h+8|0;Yb=h+4|0;Zb=e+8|0;_b=e+4|0;$b=1;Fa=Ga;ac=f[A>>2]|0;c:while(1){bc=$b+-1|0;if((f[ac+($b*316|0)+296>>2]|0)>(f[ac+(bc*316|0)+296>>2]|0)){f[la>>2]=0;f[ja>>2]=0;f[e>>2]=16842752;f[ma>>2]=ac+(bc*316|0)+112;cc=ac+($b*316|0)+112|0;dc=Ea;f[dc>>2]=0;f[dc+4>>2]=0;f[g>>2]=33619968;f[Ca>>2]=cc;f[v>>2]=f[ac+($b*316|0)+280>>2];f[Da>>2]=f[ac+($b*316|0)+284>>2];nfa(e,g,v,0.0,0.0,3);ec=Fa*.75;fc=cc}else{cc=ac+($b*316|0)+112|0;dc=Zb;f[dc>>2]=0;f[dc+4>>2]=0;f[e>>2]=33619968;f[_b>>2]=cc;h_(ac+(bc*316|0)+112|0,e);ec=Fa;fc=cc}f[ha>>2]=0;f[ga>>2]=0;f[e>>2]=16842752;f[oa>>2]=fc;cc=ac+($b*316|0)+168|0;dc=fa;f[dc>>2]=0;f[dc+4>>2]=0;f[g>>2]=33619968;f[ta>>2]=cc;f[w>>2]=5;f[sa>>2]=5;Gfa(e,g,w,1.0,1.0,1);f[ra>>2]=0;f[qa>>2]=0;f[e>>2]=16842752;f[pa>>2]=cc;dc=ea;f[dc>>2]=0;f[dc+4>>2]=0;f[g>>2]=33619968;f[xa>>2]=o;Ioa(e,g,5,1,0,1.0,0.0,4);f[wa>>2]=0;f[va>>2]=0;f[e>>2]=16842752;f[ua>>2]=cc;cc=Ha;f[cc>>2]=0;f[cc+4>>2]=0;f[g>>2]=33619968;f[Ia>>2]=p;Ioa(e,g,5,0,1,1.0,0.0,4);f[Ja>>2]=0;f[Ka>>2]=0;f[h>>2]=16842752;f[La>>2]=o;f[Ma>>2]=0;f[Na>>2]=0;f[i>>2]=16842752;f[Oa>>2]=p;cc=Pa;f[cc>>2]=0;f[cc+4>>2]=0;f[j>>2]=33619968;f[Qa>>2]=r;gc=f[Ra>>2]|0;b$(e,h,-1);v$(j,e,c$(h,-1)|0,-1,0,0);switch(gc|0){case 0:{tMb(h,i,j,ec);break}case 1:{uMb(h,i,j,ec);break}case 2:{vMb(h,i,j,ec);break}case 3:{wMb(h,i,j,ec);break}default:break c}cc=f[Sa>>2]|0;dc=cc+(bc*12|0)|0;hc=cc+(bc*12|0)+4|0;bc=f[dc>>2]|0;if((f[hc>>2]|0)!=(bc|0)){cc=0;ic=bc;do{ya=+n[ic+(cc<<2)>>2]*.5;f[Ta>>2]=0;f[Ua>>2]=0;f[x>>2]=16842752;f[Va>>2]=fc;f[Wa>>2]=0;f[Xa>>2]=0;f[y>>2]=16842752;f[Ya>>2]=r;bc=Za;f[bc>>2]=0;f[bc+4>>2]=0;f[z>>2]=33619968;f[_a>>2]=s;b$(e,x,-1);v$(z,e,c$(x,-1)|0,-1,0,0);do if((d$(x)|0)==65536){bc=f[Va>>2]|0;f[g>>2]=f[bc>>2];jc=bc+4|0;f[$a>>2]=f[jc>>2];f[ab>>2]=f[bc+8>>2];f[bb>>2]=f[bc+12>>2];f[cb>>2]=f[bc+16>>2];f[db>>2]=f[bc+20>>2];f[eb>>2]=f[bc+24>>2];f[fb>>2]=f[bc+28>>2];f[gb>>2]=f[bc+32>>2];kc=f[bc+36>>2]|0;f[hb>>2]=kc;f[ib>>2]=ab;f[kb>>2]=jb;f[jb>>2]=0;f[lb>>2]=0;if(kc|0){lc=kc+12|0;f[lc>>2]=(f[lc>>2]|0)+1}if((f[jc>>2]|0)<3){jc=f[bc+44>>2]|0;lc=f[kb>>2]|0;f[lc>>2]=f[jc>>2];f[lc+4>>2]=f[jc+4>>2];break}else{f[$a>>2]=0;ZS(g,bc);break}}else a$(g,x,-1);while(0);do if((d$(y)|0)==65536){bc=f[Ya>>2]|0;f[h>>2]=f[bc>>2];jc=bc+4|0;f[mb>>2]=f[jc>>2];f[nb>>2]=f[bc+8>>2];f[ob>>2]=f[bc+12>>2];f[pb>>2]=f[bc+16>>2];f[qb>>2]=f[bc+20>>2];f[rb>>2]=f[bc+24>>2];f[sb>>2]=f[bc+28>>2];f[tb>>2]=f[bc+32>>2];lc=f[bc+36>>2]|0;f[ub>>2]=lc;f[vb>>2]=nb;f[xb>>2]=wb;f[wb>>2]=0;f[yb>>2]=0;if(lc|0){kc=lc+12|0;f[kc>>2]=(f[kc>>2]|0)+1}if((f[jc>>2]|0)<3){jc=f[bc+44>>2]|0;kc=f[xb>>2]|0;f[kc>>2]=f[jc>>2];f[kc+4>>2]=f[jc+4>>2];break}else{f[mb>>2]=0;ZS(h,bc);break}}else a$(h,y,-1);while(0);do if((d$(z)|0)==65536){bc=f[_a>>2]|0;f[i>>2]=f[bc>>2];jc=bc+4|0;f[zb>>2]=f[jc>>2];f[Ab>>2]=f[bc+8>>2];f[Bb>>2]=f[bc+12>>2];f[Cb>>2]=f[bc+16>>2];f[Db>>2]=f[bc+20>>2];f[Eb>>2]=f[bc+24>>2];f[Fb>>2]=f[bc+28>>2];f[Gb>>2]=f[bc+32>>2];kc=f[bc+36>>2]|0;f[Hb>>2]=kc;f[Ib>>2]=Ab;f[Kb>>2]=Jb;f[Jb>>2]=0;f[Lb>>2]=0;if(kc|0){lc=kc+12|0;f[lc>>2]=(f[lc>>2]|0)+1}if((f[jc>>2]|0)<3){jc=f[bc+44>>2]|0;lc=f[Kb>>2]|0;f[lc>>2]=f[jc>>2];f[lc+4>>2]=f[jc+4>>2];break}else{f[zb>>2]=0;ZS(i,bc);break}}else a$(i,z,-1);while(0);bc=f[ab>>2]|0;f[j>>2]=0;f[Mb>>2]=bc;f[k>>2]=112200;f[Nb>>2]=g;f[Ob>>2]=h;f[Pb>>2]=i;n[Qb>>2]=ya;y8(j,k,-1.0);bc=f[Hb>>2]|0;do if(bc|0){jc=bc+12|0;lc=f[jc>>2]|0;f[jc>>2]=lc+-1;if((lc|0)!=1)break;_S(i)}while(0);f[Hb>>2]=0;f[Cb>>2]=0;f[Cb+4>>2]=0;f[Cb+8>>2]=0;f[Cb+12>>2]=0;if((f[zb>>2]|0)>0){bc=f[Ib>>2]|0;lc=0;do{f[bc+(lc<<2)>>2]=0;lc=lc+1|0}while((lc|0)<(f[zb>>2]|0))}lc=f[Kb>>2]|0;if((lc|0)!=(Jb|0))g0(lc);lc=f[ub>>2]|0;do if(lc|0){bc=lc+12|0;jc=f[bc>>2]|0;f[bc>>2]=jc+-1;if((jc|0)!=1)break;_S(h)}while(0);f[ub>>2]=0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[mb>>2]|0)>0){lc=f[vb>>2]|0;jc=0;do{f[lc+(jc<<2)>>2]=0;jc=jc+1|0}while((jc|0)<(f[mb>>2]|0))}jc=f[xb>>2]|0;if((jc|0)!=(wb|0))g0(jc);jc=f[hb>>2]|0;do if(jc|0){lc=jc+12|0;bc=f[lc>>2]|0;f[lc>>2]=bc+-1;if((bc|0)!=1)break;_S(g)}while(0);f[hb>>2]=0;f[cb>>2]=0;f[cb+4>>2]=0;f[cb+8>>2]=0;f[cb+12>>2]=0;if((f[$a>>2]|0)>0){jc=f[ib>>2]|0;bc=0;do{f[jc+(bc<<2)>>2]=0;bc=bc+1|0}while((bc|0)<(f[$a>>2]|0))}bc=f[kb>>2]|0;if((bc|0)!=(jb|0))g0(bc);f[Rb>>2]=0;f[Sb>>2]=0;f[e>>2]=16842752;f[Tb>>2]=fc;f[Ub>>2]=0;f[Vb>>2]=0;f[g>>2]=16842752;f[Wb>>2]=s;bc=Xb;f[bc>>2]=0;f[bc+4>>2]=0;f[h>>2]=33619968;f[Yb>>2]=fc;mL(e,g,h,e0()|0,-1);cc=cc+1|0;ic=f[dc>>2]|0}while(cc>>>0<(f[hc>>2]|0)-ic>>2>>>0)}$b=$b+1|0;ic=f[B>>2]|0;hc=f[A>>2]|0;if($b>>>0>=((ic-hc|0)/316|0)>>>0){mc=hc;nc=ic;break b}else{Fa=ec;ac=hc}}f[g>>2]=0;f[g+4>>2]=0;C=tT(g,28)|0;D=462112;E=C+28|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(gc,g,462141,461802,401)}else{mc=na;nc=ka}while(0);f[e>>2]=0;f[e+4>>2]=(nc-mc|0)/316|0;f[g>>2]=112180;f[g+4>>2]=A;y8(e,g,-1.0);mc=s+36|0;nc=f[mc>>2]|0;do if(nc|0){ka=nc+12|0;na=f[ka>>2]|0;f[ka>>2]=na+-1;if((na|0)!=1)break;_S(s)}while(0);f[mc>>2]=0;mc=s+16|0;f[mc>>2]=0;f[mc+4>>2]=0;f[mc+8>>2]=0;f[mc+12>>2]=0;if((f[$>>2]|0)>0){mc=f[ba>>2]|0;ba=0;do{f[mc+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[$>>2]|0))}$=f[ca>>2]|0;if(($|0)!=(aa|0))g0($);$=r+36|0;aa=f[$>>2]|0;do if(aa|0){ca=aa+12|0;ba=f[ca>>2]|0;f[ca>>2]=ba+-1;if((ba|0)!=1)break;_S(r)}while(0);f[$>>2]=0;$=r+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[W>>2]|0)>0){$=f[Z>>2]|0;Z=0;do{f[$+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[W>>2]|0))}W=f[_>>2]|0;if((W|0)!=(X|0))g0(W);W=f[t>>2]|0;do if(W|0){X=W+12|0;_=f[X>>2]|0;f[X>>2]=_+-1;if((_|0)!=1)break;_S(q)}while(0);f[t>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[P>>2]|0)>0){da=f[U>>2]|0;U=0;do{f[da+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[P>>2]|0))}P=f[V>>2]|0;if((P|0)!=(O|0))g0(P);P=p+36|0;O=f[P>>2]|0;do if(O|0){V=O+12|0;U=f[V>>2]|0;f[V>>2]=U+-1;if((U|0)!=1)break;_S(p)}while(0);f[P>>2]=0;P=p+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[J>>2]|0)>0){P=f[L>>2]|0;L=0;do{f[P+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[J>>2]|0))}J=f[N>>2]|0;if((J|0)!=(K|0))g0(J);J=o+36|0;K=f[J>>2]|0;do if(K|0){N=K+12|0;L=f[N>>2]|0;f[N>>2]=L+-1;if((L|0)!=1)break;_S(o)}while(0);f[J>>2]=0;J=o+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[m>>2]|0)>0){J=f[Q>>2]|0;Q=0;do{f[J+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[m>>2]|0))}m=f[R>>2]|0;if((m|0)!=(c|0))g0(m)}else{f[e>>2]=0;f[e+4>>2]=1;f[g>>2]=112180;f[g+4>>2]=A;y8(e,g,-1.0)}g=l+36|0;e=f[g>>2]|0;if(e|0?(A=e+12|0,e=f[A>>2]|0,f[A>>2]=e+-1,(e|0)==1):0)_S(l);f[g>>2]=0;g=l+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[F>>2]|0)>0){g=f[H>>2]|0;H=0;do{f[g+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[F>>2]|0))}F=f[I>>2]|0;if((F|0)==(G|0)){u=d;return}g0(F);u=d;return}function wJb(a){a=a|0;YDc(a);return}function xJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;g=f[a+8>>2]|0;h=f[a+12>>2]|0;i=+n[a+16>>2];a=f[b>>2]|0;j=f[b+4>>2]|0;b=f[e+40>>2]|0;k=f[b+4>>2]|0;l=f[b>>2]|0;b=f[e>>2]&4095;if(!(((((f[h+4>>2]|0)<3?(f[h+8>>2]|0)==(l|0):0)?(f[h+12>>2]|0)==(k|0):0)?(f[h>>2]&4095|0)==(b|0):0)?(f[h+16>>2]|0)!=0:0)){f[d>>2]=l;f[d+4>>2]=k;XS(h,2,d,b)}b=f[e+12>>2]|0;d=b+-2|0;if(!a){k=f[e+16>>2]|0;l=k+4|0;m=f[g+16>>2]|0;o=m+4|0;p=k+(f[f[e+44>>2]>>2]|0)+4|0;k=m+(f[f[g+44>>2]>>2]|0)+4|0;m=f[h+16>>2]|0;n[m>>2]=0.0;q=m+4|0;if((b|0)>2){m=0;do{r=+n[o+(m<<2)>>2];s=m;m=m+1|0;t=+n[l+(s<<2)>>2];v=s+-1|0;n[q+(s<<2)>>2]=i*((r+ +n[o+(m<<2)>>2])*(+n[l+(m<<2)>>2]-t)+(r+ +n[o+(v<<2)>>2])*(+n[l+(v<<2)>>2]-t)+(r+ +n[k+(s<<2)>>2])*(+n[p+(s<<2)>>2]-t))}while((m|0)!=(d|0))}n[q+(d<<2)>>2]=0.0;w=1}else w=a;a=f[e+8>>2]|0;q=a+-1|0;m=(q|0)>(j|0)?j:q;if((w|0)<(m|0)){q=f[e+16>>2]|0;p=f[f[e+44>>2]>>2]|0;k=f[g+16>>2]|0;l=f[f[g+44>>2]>>2]|0;o=f[h+16>>2]|0;s=f[f[h+44>>2]>>2]|0;v=(b|0)>2;x=b+-3|0;y=w;do{z=y+-1|0;A=q+(Y(z,p)|0)|0;B=k+(Y(z,l)|0)|0;z=q+(Y(y,p)|0)|0;C=k+(Y(y,l)|0)|0;D=y;y=y+1|0;E=q+(Y(y,p)|0)|0;F=k+(Y(y,l)|0)|0;G=o+(Y(D,s)|0)|0;t=+n[C>>2];D=C+4|0;C=z+4|0;r=+n[z>>2];n[G>>2]=i*((t+ +n[D>>2])*(+n[C>>2]-r)+(t+ +n[F>>2])*(+n[E>>2]-r)+(t+ +n[B>>2])*(+n[A>>2]-r));z=A+4|0;A=E+4|0;E=B+4|0;B=F+4|0;F=G+4|0;if(v){G=0;do{r=+n[D+(G<<2)>>2];H=G;G=G+1|0;t=+n[C+(H<<2)>>2];I=H+-1|0;n[F+(H<<2)>>2]=i*((r+ +n[D+(G<<2)>>2])*(+n[C+(G<<2)>>2]-t)+(r+ +n[D+(I<<2)>>2])*(+n[C+(I<<2)>>2]-t)+(r+ +n[B+(H<<2)>>2])*(+n[A+(H<<2)>>2]-t)+(r+ +n[E+(H<<2)>>2])*(+n[z+(H<<2)>>2]-t))}while((G|0)!=(d|0))}t=+n[D+(d<<2)>>2];r=+n[C+(d<<2)>>2];n[F+(d<<2)>>2]=i*((t+ +n[D+(x<<2)>>2])*(+n[C+(x<<2)>>2]-r)+(t+ +n[B+(d<<2)>>2])*(+n[A+(d<<2)>>2]-r)+(t+ +n[E+(d<<2)>>2])*(+n[z+(d<<2)>>2]-r))}while((y|0)<(m|0));J=m}else J=w;if((a|0)!=(j|0)){u=c;return}j=J+-1|0;a=f[e+16>>2]|0;w=f[f[e+44>>2]>>2]|0;e=a+(Y(w,j)|0)+4|0;m=f[g+16>>2]|0;y=f[f[g+44>>2]>>2]|0;g=m+(Y(y,j)|0)+4|0;j=a+(Y(w,J)|0)+4|0;w=m+(Y(y,J)|0)+4|0;y=(f[h+16>>2]|0)+(Y(f[f[h+44>>2]>>2]|0,J)|0)|0;n[y>>2]=0.0;J=y+4|0;if((b|0)>2){b=0;do{r=+n[w+(b<<2)>>2];y=b;b=b+1|0;t=+n[j+(y<<2)>>2];h=y+-1|0;n[J+(y<<2)>>2]=i*((r+ +n[w+(b<<2)>>2])*(+n[j+(b<<2)>>2]-t)+(r+ +n[w+(h<<2)>>2])*(+n[j+(h<<2)>>2]-t)+(r+ +n[g+(y<<2)>>2])*(+n[e+(y<<2)>>2]-t))}while((b|0)!=(d|0))}n[J+(d<<2)>>2]=0.0;u=c;return}function yJb(a){a=a|0;YDc(a);return}function zJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0.0,Zc=0.0,_c=0;c=u;u=u+736|0;d=c+720|0;e=c+664|0;g=c+608|0;h=c+552|0;i=c+496|0;j=c+440|0;k=c+384|0;l=c+328|0;m=c+272|0;o=c+216|0;p=c+160|0;q=c+104|0;r=c+96|0;s=c+88|0;t=c+80|0;v=c+72|0;w=c+64|0;x=c+48|0;y=c+32|0;z=c+16|0;A=c;f[j>>2]=1124007936;B=j+4|0;C=j+8|0;D=j+40|0;E=B;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[D>>2]=C;C=j+48|0;G=j+44|0;f[G>>2]=C;f[C>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;H=k+4|0;I=k+8|0;J=k+40|0;E=H;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[J>>2]=I;I=k+48|0;K=k+44|0;f[K>>2]=I;f[I>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;L=l+4|0;M=l+8|0;N=l+40|0;E=L;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[N>>2]=M;M=l+48|0;O=l+44|0;f[O>>2]=M;f[M>>2]=0;f[l+52>>2]=0;P=f[b>>2]|0;Q=b+4|0;if((P|0)<(f[Q>>2]|0)){b=a+4|0;a=m+4|0;R=m+8|0;S=m+40|0;T=m+48|0;U=m+44|0;V=m+52|0;W=o+4|0;X=o+8|0;Z=o+40|0;_=o+48|0;$=o+44|0;aa=o+52|0;ba=p+4|0;ca=p+8|0;da=p+40|0;ea=p+48|0;fa=p+44|0;ga=p+52|0;ha=q+4|0;ia=q+8|0;ja=q+40|0;ka=q+48|0;la=q+44|0;ma=q+52|0;na=d+8|0;oa=d+4|0;pa=e+8|0;qa=e+4|0;ra=d+8|0;sa=d+4|0;ta=e+8|0;ua=e+4|0;va=d+8|0;wa=d+12|0;xa=d+4|0;ya=e+8|0;za=e+4|0;Aa=g+8|0;Ba=g+12|0;Ca=g+4|0;Da=h+8|0;Ea=h+12|0;Fa=h+4|0;Ga=r+4|0;Ha=d+8|0;Ia=d+12|0;Ja=d+4|0;Ka=e+8|0;La=e+4|0;Ma=g+8|0;Na=g+12|0;Oa=g+4|0;Pa=h+8|0;Qa=h+12|0;Ra=h+4|0;Sa=s+4|0;Ta=d+8|0;Ua=d+12|0;Va=d+4|0;Wa=e+8|0;Xa=e+4|0;Ya=g+8|0;Za=g+12|0;_a=g+4|0;$a=h+8|0;ab=h+12|0;bb=h+4|0;cb=t+4|0;db=d+8|0;eb=d+12|0;fb=d+4|0;gb=e+8|0;hb=e+4|0;ib=g+8|0;jb=g+12|0;kb=g+4|0;lb=h+8|0;mb=h+12|0;nb=h+4|0;ob=v+4|0;pb=d+8|0;qb=d+12|0;rb=d+4|0;sb=e+8|0;tb=e+4|0;ub=g+8|0;vb=g+12|0;wb=g+4|0;xb=h+8|0;yb=h+12|0;zb=h+4|0;Ab=w+4|0;Bb=x+8|0;Cb=x+12|0;Db=x+4|0;Eb=y+8|0;Fb=y+12|0;Gb=y+4|0;Hb=z+8|0;Ib=z+12|0;Jb=z+4|0;Kb=A+8|0;Lb=A+4|0;Mb=e+4|0;Nb=e+8|0;Ob=e+12|0;Pb=e+16|0;Qb=e+20|0;Rb=e+24|0;Sb=e+28|0;Tb=e+32|0;Ub=e+36|0;Vb=e+40|0;Wb=e+48|0;Xb=e+44|0;Yb=e+52|0;Zb=g+4|0;_b=g+8|0;$b=g+12|0;ac=g+16|0;bc=g+20|0;cc=g+24|0;dc=g+28|0;ec=g+32|0;fc=g+36|0;gc=g+40|0;hc=g+48|0;ic=g+44|0;jc=g+52|0;kc=h+4|0;lc=h+8|0;mc=h+12|0;nc=h+16|0;oc=h+20|0;pc=h+24|0;qc=h+28|0;rc=h+32|0;sc=h+36|0;tc=h+40|0;uc=h+48|0;vc=h+44|0;wc=h+52|0;xc=i+4|0;yc=i+8|0;zc=i+12|0;Ac=i+16|0;Bc=i+20|0;Cc=i+24|0;Dc=i+28|0;Ec=i+32|0;Fc=i+36|0;Gc=i+40|0;Hc=i+48|0;Ic=i+44|0;Jc=i+52|0;Kc=q+36|0;Lc=q+16|0;Mc=p+36|0;Nc=p+16|0;Oc=o+36|0;Pc=o+16|0;Qc=m+36|0;Rc=m+16|0;Sc=P;do{P=f[f[b>>2]>>2]|0;f[m>>2]=1124007936;E=a;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[S>>2]=R;f[U>>2]=T;f[T>>2]=0;f[V>>2]=0;f[o>>2]=1124007936;E=W;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[Z>>2]=X;f[$>>2]=_;f[_>>2]=0;f[aa>>2]=0;f[p>>2]=1124007936;E=ba;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[da>>2]=ca;f[fa>>2]=ea;f[ea>>2]=0;f[ga>>2]=0;f[q>>2]=1124007936;E=ha;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[ja>>2]=ia;f[la>>2]=ka;f[ka>>2]=0;f[ma>>2]=0;Tc=na;f[Tc>>2]=0;f[Tc+4>>2]=0;f[d>>2]=33619968;f[oa>>2]=m;Tc=pa;f[Tc>>2]=0;f[Tc+4>>2]=0;f[e>>2]=33619968;f[qa>>2]=o;Tc=P+(Sc*316|0)+304|0;zMb(d,e,1,0,f[Tc>>2]|0);Uc=ra;f[Uc>>2]=0;f[Uc+4>>2]=0;f[d>>2]=33619968;f[sa>>2]=p;Uc=ta;f[Uc>>2]=0;f[Uc+4>>2]=0;f[e>>2]=33619968;f[ua>>2]=q;zMb(d,e,0,1,f[Tc>>2]|0);Uc=P+(Sc*316|0)+168|0;f[va>>2]=0;f[wa>>2]=0;f[d>>2]=16842752;f[xa>>2]=Uc;Vc=P+(Sc*316|0)|0;Wc=ya;f[Wc>>2]=0;f[Wc+4>>2]=0;f[e>>2]=33619968;f[za>>2]=Vc;f[Aa>>2]=0;f[Ba>>2]=0;f[g>>2]=16842752;f[Ca>>2]=m;f[Da>>2]=0;f[Ea>>2]=0;f[h>>2]=16842752;f[Fa>>2]=o;f[r>>2]=-1;f[Ga>>2]=-1;lwa(d,e,5,g,h,r,0.0,4);f[Ha>>2]=0;f[Ia>>2]=0;f[d>>2]=16842752;f[Ja>>2]=Vc;Wc=Ka;f[Wc>>2]=0;f[Wc+4>>2]=0;f[e>>2]=33619968;f[La>>2]=j;f[Ma>>2]=0;f[Na>>2]=0;f[g>>2]=16842752;f[Oa>>2]=m;f[Pa>>2]=0;f[Qa>>2]=0;f[h>>2]=16842752;f[Ra>>2]=o;f[s>>2]=-1;f[Sa>>2]=-1;lwa(d,e,5,g,h,s,0.0,4);f[Ta>>2]=0;f[Ua>>2]=0;f[d>>2]=16842752;f[Va>>2]=Vc;Vc=Wa;f[Vc>>2]=0;f[Vc+4>>2]=0;f[e>>2]=33619968;f[Xa>>2]=k;f[Ya>>2]=0;f[Za>>2]=0;f[g>>2]=16842752;f[_a>>2]=p;f[$a>>2]=0;f[ab>>2]=0;f[h>>2]=16842752;f[bb>>2]=q;f[t>>2]=-1;f[cb>>2]=-1;lwa(d,e,5,g,h,t,0.0,4);f[db>>2]=0;f[eb>>2]=0;f[d>>2]=16842752;f[fb>>2]=Uc;Vc=P+(Sc*316|0)+56|0;Wc=gb;f[Wc>>2]=0;f[Wc+4>>2]=0;f[e>>2]=33619968;f[hb>>2]=Vc;f[ib>>2]=0;f[jb>>2]=0;f[g>>2]=16842752;f[kb>>2]=p;f[lb>>2]=0;f[mb>>2]=0;f[h>>2]=16842752;f[nb>>2]=q;f[v>>2]=-1;f[ob>>2]=-1;lwa(d,e,5,g,h,v,0.0,4);f[pb>>2]=0;f[qb>>2]=0;f[d>>2]=16842752;f[rb>>2]=Vc;Vc=sb;f[Vc>>2]=0;f[Vc+4>>2]=0;f[e>>2]=33619968;f[tb>>2]=l;f[ub>>2]=0;f[vb>>2]=0;f[g>>2]=16842752;f[wb>>2]=p;f[xb>>2]=0;f[yb>>2]=0;f[h>>2]=16842752;f[zb>>2]=q;f[w>>2]=-1;f[Ab>>2]=-1;lwa(d,e,5,g,h,w,0.0,4);Vc=P+(Sc*316|0)+204|0;Wc=f[Vc>>2]|0;if(Wc|0?(Xc=Wc+12|0,Wc=f[Xc>>2]|0,f[Xc>>2]=Wc+-1,(Wc|0)==1):0)_S(Uc);f[Vc>>2]=0;Vc=P+(Sc*316|0)+184|0;Uc=P+(Sc*316|0)+172|0;f[Vc>>2]=0;f[Vc+4>>2]=0;f[Vc+8>>2]=0;f[Vc+12>>2]=0;if((f[Uc>>2]|0)>0){Vc=f[P+(Sc*316|0)+208>>2]|0;Wc=0;do{f[Vc+(Wc<<2)>>2]=0;Wc=Wc+1|0}while((Wc|0)<(f[Uc>>2]|0))}Uc=f[Tc>>2]|0;Wc=Y(Uc,Uc)|0;Yc=+(Y(Wc,Wc)|0);f[Bb>>2]=0;f[Cb>>2]=0;f[x>>2]=16842752;f[Db>>2]=j;f[Eb>>2]=0;f[Fb>>2]=0;f[y>>2]=16842752;f[Gb>>2]=k;f[Hb>>2]=0;f[Ib>>2]=0;f[z>>2]=16842752;f[Jb>>2]=l;Wc=Kb;f[Wc>>2]=0;f[Wc+4>>2]=0;f[A>>2]=33619968;f[Lb>>2]=P+(Sc*316|0)+224;b$(d,x,-1);v$(A,d,c$(x,-1)|0,-1,0,0);do if((d$(x)|0)==65536){Wc=f[Db>>2]|0;f[e>>2]=f[Wc>>2];Uc=Wc+4|0;f[Mb>>2]=f[Uc>>2];f[Nb>>2]=f[Wc+8>>2];f[Ob>>2]=f[Wc+12>>2];f[Pb>>2]=f[Wc+16>>2];f[Qb>>2]=f[Wc+20>>2];f[Rb>>2]=f[Wc+24>>2];f[Sb>>2]=f[Wc+28>>2];f[Tb>>2]=f[Wc+32>>2];Vc=f[Wc+36>>2]|0;f[Ub>>2]=Vc;f[Vb>>2]=Nb;f[Xb>>2]=Wb;f[Wb>>2]=0;f[Yb>>2]=0;if(Vc|0){Xc=Vc+12|0;f[Xc>>2]=(f[Xc>>2]|0)+1}if((f[Uc>>2]|0)<3){Uc=f[Wc+44>>2]|0;Xc=f[Xb>>2]|0;f[Xc>>2]=f[Uc>>2];f[Xc+4>>2]=f[Uc+4>>2];break}else{f[Mb>>2]=0;ZS(e,Wc);break}}else a$(e,x,-1);while(0);do if((d$(y)|0)==65536){P=f[Gb>>2]|0;f[g>>2]=f[P>>2];Tc=P+4|0;f[Zb>>2]=f[Tc>>2];f[_b>>2]=f[P+8>>2];f[$b>>2]=f[P+12>>2];f[ac>>2]=f[P+16>>2];f[bc>>2]=f[P+20>>2];f[cc>>2]=f[P+24>>2];f[dc>>2]=f[P+28>>2];f[ec>>2]=f[P+32>>2];Wc=f[P+36>>2]|0;f[fc>>2]=Wc;f[gc>>2]=_b;f[ic>>2]=hc;f[hc>>2]=0;f[jc>>2]=0;if(Wc|0){Uc=Wc+12|0;f[Uc>>2]=(f[Uc>>2]|0)+1}if((f[Tc>>2]|0)<3){Tc=f[P+44>>2]|0;Uc=f[ic>>2]|0;f[Uc>>2]=f[Tc>>2];f[Uc+4>>2]=f[Tc+4>>2];break}else{f[Zb>>2]=0;ZS(g,P);break}}else a$(g,y,-1);while(0);do if((d$(z)|0)==65536){P=f[Jb>>2]|0;f[h>>2]=f[P>>2];Tc=P+4|0;f[kc>>2]=f[Tc>>2];f[lc>>2]=f[P+8>>2];f[mc>>2]=f[P+12>>2];f[nc>>2]=f[P+16>>2];f[oc>>2]=f[P+20>>2];f[pc>>2]=f[P+24>>2];f[qc>>2]=f[P+28>>2];f[rc>>2]=f[P+32>>2];Uc=f[P+36>>2]|0;f[sc>>2]=Uc;f[tc>>2]=lc;f[vc>>2]=uc;f[uc>>2]=0;f[wc>>2]=0;if(Uc|0){Wc=Uc+12|0;f[Wc>>2]=(f[Wc>>2]|0)+1}if((f[Tc>>2]|0)<3){Tc=f[P+44>>2]|0;Wc=f[vc>>2]|0;f[Wc>>2]=f[Tc>>2];f[Wc+4>>2]=f[Tc+4>>2];break}else{f[kc>>2]=0;ZS(h,P);break}}else a$(h,z,-1);while(0);do if((d$(A)|0)==65536){P=f[Lb>>2]|0;f[i>>2]=f[P>>2];Tc=P+4|0;f[xc>>2]=f[Tc>>2];f[yc>>2]=f[P+8>>2];f[zc>>2]=f[P+12>>2];f[Ac>>2]=f[P+16>>2];f[Bc>>2]=f[P+20>>2];f[Cc>>2]=f[P+24>>2];f[Dc>>2]=f[P+28>>2];f[Ec>>2]=f[P+32>>2];Wc=f[P+36>>2]|0;f[Fc>>2]=Wc;f[Gc>>2]=yc;f[Ic>>2]=Hc;f[Hc>>2]=0;f[Jc>>2]=0;if(Wc|0){Uc=Wc+12|0;f[Uc>>2]=(f[Uc>>2]|0)+1}if((f[Tc>>2]|0)<3){Tc=f[P+44>>2]|0;Uc=f[Ic>>2]|0;f[Uc>>2]=f[Tc>>2];f[Uc+4>>2]=f[Tc+4>>2];break}else{f[xc>>2]=0;ZS(i,P);break}}else a$(i,A,-1);while(0);P=f[Pb>>2]|0;Tc=f[ac>>2]|0;Uc=f[nc>>2]|0;Wc=f[Ac>>2]|0;Xc=Y(f[Nb>>2]|0,f[Ob>>2]|0)|0;if((Xc|0)>0){Vc=0;do{Zc=+n[Tc+(Vc<<2)>>2];n[Wc+(Vc<<2)>>2]=Yc*(+n[P+(Vc<<2)>>2]*+n[Uc+(Vc<<2)>>2]-Zc*Zc);Vc=Vc+1|0}while((Vc|0)!=(Xc|0))}Xc=f[Fc>>2]|0;if(Xc|0?(Vc=Xc+12|0,Xc=f[Vc>>2]|0,f[Vc>>2]=Xc+-1,(Xc|0)==1):0)_S(i);f[Fc>>2]=0;f[Ac>>2]=0;f[Ac+4>>2]=0;f[Ac+8>>2]=0;f[Ac+12>>2]=0;if((f[xc>>2]|0)>0){Xc=f[Gc>>2]|0;Vc=0;do{f[Xc+(Vc<<2)>>2]=0;Vc=Vc+1|0}while((Vc|0)<(f[xc>>2]|0))}Vc=f[Ic>>2]|0;if((Vc|0)!=(Hc|0))g0(Vc);Vc=f[sc>>2]|0;if(Vc|0?(Xc=Vc+12|0,Vc=f[Xc>>2]|0,f[Xc>>2]=Vc+-1,(Vc|0)==1):0)_S(h);f[sc>>2]=0;f[nc>>2]=0;f[nc+4>>2]=0;f[nc+8>>2]=0;f[nc+12>>2]=0;if((f[kc>>2]|0)>0){Vc=f[tc>>2]|0;Xc=0;do{f[Vc+(Xc<<2)>>2]=0;Xc=Xc+1|0}while((Xc|0)<(f[kc>>2]|0))}Xc=f[vc>>2]|0;if((Xc|0)!=(uc|0))g0(Xc);Xc=f[fc>>2]|0;if(Xc|0?(Vc=Xc+12|0,Xc=f[Vc>>2]|0,f[Vc>>2]=Xc+-1,(Xc|0)==1):0)_S(g);f[fc>>2]=0;f[ac>>2]=0;f[ac+4>>2]=0;f[ac+8>>2]=0;f[ac+12>>2]=0;if((f[Zb>>2]|0)>0){Xc=f[gc>>2]|0;Vc=0;do{f[Xc+(Vc<<2)>>2]=0;Vc=Vc+1|0}while((Vc|0)<(f[Zb>>2]|0))}Vc=f[ic>>2]|0;if((Vc|0)!=(hc|0))g0(Vc);Vc=f[Ub>>2]|0;do if(Vc|0){Xc=Vc+12|0;Uc=f[Xc>>2]|0;f[Xc>>2]=Uc+-1;if((Uc|0)!=1)break;_S(e)}while(0);f[Ub>>2]=0;f[Pb>>2]=0;f[Pb+4>>2]=0;f[Pb+8>>2]=0;f[Pb+12>>2]=0;if((f[Mb>>2]|0)>0){Vc=f[Vb>>2]|0;Uc=0;do{f[Vc+(Uc<<2)>>2]=0;Uc=Uc+1|0}while((Uc|0)<(f[Mb>>2]|0))}Uc=f[Xb>>2]|0;if((Uc|0)!=(Wb|0))g0(Uc);Uc=f[Kc>>2]|0;do if(Uc|0){Vc=Uc+12|0;Xc=f[Vc>>2]|0;f[Vc>>2]=Xc+-1;if((Xc|0)!=1)break;_S(q)}while(0);f[Kc>>2]=0;f[Lc>>2]=0;f[Lc+4>>2]=0;f[Lc+8>>2]=0;f[Lc+12>>2]=0;if((f[ha>>2]|0)>0){Uc=f[ja>>2]|0;Xc=0;do{f[Uc+(Xc<<2)>>2]=0;Xc=Xc+1|0}while((Xc|0)<(f[ha>>2]|0))}Xc=f[la>>2]|0;if((Xc|0)!=(ka|0))g0(Xc);Xc=f[Mc>>2]|0;do if(Xc|0){Uc=Xc+12|0;Vc=f[Uc>>2]|0;f[Uc>>2]=Vc+-1;if((Vc|0)!=1)break;_S(p)}while(0);f[Mc>>2]=0;f[Nc>>2]=0;f[Nc+4>>2]=0;f[Nc+8>>2]=0;f[Nc+12>>2]=0;if((f[ba>>2]|0)>0){Xc=f[da>>2]|0;Vc=0;do{f[Xc+(Vc<<2)>>2]=0;Vc=Vc+1|0}while((Vc|0)<(f[ba>>2]|0))}Vc=f[fa>>2]|0;if((Vc|0)!=(ea|0))g0(Vc);Vc=f[Oc>>2]|0;do if(Vc|0){Xc=Vc+12|0;Uc=f[Xc>>2]|0;f[Xc>>2]=Uc+-1;if((Uc|0)!=1)break;_S(o)}while(0);f[Oc>>2]=0;f[Pc>>2]=0;f[Pc+4>>2]=0;f[Pc+8>>2]=0;f[Pc+12>>2]=0;if((f[W>>2]|0)>0){Vc=f[Z>>2]|0;Uc=0;do{f[Vc+(Uc<<2)>>2]=0;Uc=Uc+1|0}while((Uc|0)<(f[W>>2]|0))}Uc=f[$>>2]|0;if((Uc|0)!=(_|0))g0(Uc);Uc=f[Qc>>2]|0;do if(Uc|0){Vc=Uc+12|0;Xc=f[Vc>>2]|0;f[Vc>>2]=Xc+-1;if((Xc|0)!=1)break;_S(m)}while(0);f[Qc>>2]=0;f[Rc>>2]=0;f[Rc+4>>2]=0;f[Rc+8>>2]=0;f[Rc+12>>2]=0;if((f[a>>2]|0)>0){Uc=f[S>>2]|0;Xc=0;do{f[Uc+(Xc<<2)>>2]=0;Xc=Xc+1|0}while((Xc|0)<(f[a>>2]|0))}Xc=f[U>>2]|0;if((Xc|0)!=(T|0))g0(Xc);Sc=Sc+1|0}while((Sc|0)<(f[Q>>2]|0));Q=l+36|0;Sc=f[Q>>2]|0;if((Sc|0)!=0?(T=Sc+12|0,Sc=f[T>>2]|0,f[T>>2]=Sc+-1,(Sc|0)==1):0){_S(l);_c=Q}else _c=Q}else _c=l+36|0;f[_c>>2]=0;_c=l+16|0;f[_c>>2]=0;f[_c+4>>2]=0;f[_c+8>>2]=0;f[_c+12>>2]=0;if((f[L>>2]|0)>0){_c=f[N>>2]|0;N=0;do{f[_c+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[L>>2]|0))}L=f[O>>2]|0;if((L|0)!=(M|0))g0(L);L=k+36|0;M=f[L>>2]|0;if(M|0?(O=M+12|0,M=f[O>>2]|0,f[O>>2]=M+-1,(M|0)==1):0)_S(k);f[L>>2]=0;L=k+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[H>>2]|0)>0){L=f[J>>2]|0;J=0;do{f[L+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[K>>2]|0;if((H|0)!=(I|0))g0(H);H=j+36|0;I=f[H>>2]|0;if(I|0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0)_S(j);f[H>>2]=0;H=j+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[B>>2]|0)>0){H=f[D>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[G>>2]|0;if((B|0)==(C|0)){u=c;return}g0(B);u=c;return}function AJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c+24|0;e=c+12|0;g=c;h=f[b>>2]|0;i=b+4|0;j=f[i>>2]|0;if((j|0)!=(h|0))f[i>>2]=j+(~(((j+-28-h|0)>>>0)/28|0)*28|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;BJb(a,g);CJb(a,g,b);h=((f[i>>2]|0)-(f[b>>2]|0)|0)/28|0;f[d>>2]=0;f[d+4>>2]=h;f[e>>2]=112220;f[e+4>>2]=b;f[e+8>>2]=a+68;y8(d,e,-1.0);mx(g);u=c;return}function BJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a+68|0;i=a+72|0;g$(c,((f[i>>2]|0)-(f[h>>2]|0)|0)/316|0);j=((f[i>>2]|0)-(f[h>>2]|0)|0)/316|0;f[e>>2]=0;f[e+4>>2]=j;j=f[a+32>>2]|0;f[g>>2]=112436;f[g+4>>2]=h;f[g+8>>2]=c;f[g+12>>2]=j;y8(e,g,-1.0);g=c+4|0;e=f[c>>2]|0;j=((f[g>>2]|0)-e|0)/56|0;a=e;if(j>>>0>1){e=1;i=a;while(1){k=f[i+(e*56|0)+16>>2]|0;l=e+-1|0;m=f[i+(l*56|0)+16>>2]|0;o=f[h>>2]|0;p=f[o+(e*316|0)+240>>2]|0;q=f[o+(l*316|0)+240>>2]|0;r=(~~+n[o+(e*316|0)+308>>2]|0)/(~~+n[o+(l*316|0)+308>>2]|0)|0;s=Y(f[o+(e*316|0)+304>>2]|0,r)|0;o=i+(e*56|0)+8|0;if((f[o>>2]|0)>0){t=i+(e*56|0)+12|0;v=Y(s,s)|0;w=f[t>>2]|0;x=0;y=0;z=w;A=w;while(1){a:do if((A|0)>0){w=Y(y,r)|0;B=w-s|0;C=w+s|0;if((B|0)<(C|0)){D=0;E=x;F=z}else{G=0;H=x;while(1){G=G+1|0;I=H+1|0;if((G|0)>=(A|0)){J=I;K=z;L=A;break a}else H=I}}while(1){b:do if((b[k+E>>0]|0)!=0?(H=Y(D,r)|0,G=f[c>>2]|0,I=f[G+(l*56|0)+12>>2]|0,M=f[G+(l*56|0)+16>>2]|0,N=f[f[G+(l*56|0)+44>>2]>>2]|0,G=H-s|0,O=H+s|0,(G|0)<(O|0)):0){P=B;c:while(1){Q=M+(Y(P,N)|0)|0;R=P-w|0;S=Y(R,R)|0;T=G;while(1){if(b[Q+T>>0]|0?(R=T-H|0,((Y(R,R)|0)+S|0)>>>0<=v>>>0):0)break c;R=T+1|0;if((R|0)<(O|0))T=R;else break}S=P+1|0;if((S|0)<(C|0))P=S;else{U=F;break b}}O=T+(Y(P,I)|0)|0;if(+n[p+(E<<2)>>2]>+n[q+(O<<2)>>2]){b[m+O>>0]=0;U=f[t>>2]|0}else U=F}else U=F;while(0);D=D+1|0;O=E+1|0;if((D|0)>=(U|0)){J=O;K=U;L=U;break}else{E=O;F=U}}}else{J=x;K=z;L=A}while(0);y=y+1|0;if((y|0)>=(f[o>>2]|0))break;else{x=J;z=K;A=L}}}e=e+1|0;A=f[c>>2]|0;z=((f[g>>2]|0)-A|0)/56|0;x=A;if(e>>>0>=z>>>0){V=z;W=x;break}else i=x}}else{V=j;W=a}a=V+-2|0;if((a|0)<=-1){u=d;return}V=a;a=W;while(1){W=f[a+(V*56|0)+16>>2]|0;j=V+1|0;i=f[a+(j*56|0)+16>>2]|0;e=f[h>>2]|0;g=f[e+(V*316|0)+240>>2]|0;L=f[e+(j*316|0)+240>>2]|0;K=(~~+n[e+(j*316|0)+308>>2]|0)/(~~+n[e+(V*316|0)+308>>2]|0)|0;J=f[e+(j*316|0)+304>>2]|0;e=a+(V*56|0)+8|0;if((f[e>>2]|0)>0){U=a+(V*56|0)+12|0;F=Y(J,J)|0;E=0;D=0;T=f[U>>2]|0;while(1){if((T|0)>0){x=0;z=D;A=T;while(1){d:do if(((b[W+z>>0]|0)!=0?(o=(x|0)/(K|0)|0,y=(E|0)/(K|0)|0,t=f[c>>2]|0,m=f[t+(j*56|0)+12>>2]|0,q=f[t+(j*56|0)+16>>2]|0,p=y-J|0,v=y+J|0,(p|0)<(v|0)):0)?(s=f[f[t+(j*56|0)+44>>2]>>2]|0,t=o-J|0,l=o+J|0,(t|0)<(l|0)):0){r=p;e:while(1){p=q+(Y(r,s)|0)|0;k=r-y|0;C=Y(k,k)|0;X=t;while(1){if(b[p+X>>0]|0?(k=X-o|0,((Y(k,k)|0)+C|0)>>>0<=F>>>0):0)break e;k=X+1|0;if((k|0)<(l|0))X=k;else break}C=r+1|0;if((C|0)<(v|0))r=C;else{Z=A;break d}}v=X+(Y(r,m)|0)|0;if(+n[g+(z<<2)>>2]>+n[L+(v<<2)>>2]){b[i+v>>0]=0;Z=f[U>>2]|0}else Z=A}else Z=A;while(0);x=x+1|0;v=z+1|0;if((x|0)>=(Z|0)){_=v;$=Z;break}else{z=v;A=Z}}}else{_=D;$=T}E=E+1|0;if((E|0)>=(f[e>>2]|0))break;else{D=_;T=$}}}if((V|0)<=0)break;V=V+-1|0;a=f[c>>2]|0}u=d;return}function CJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0.0,ua=0.0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;e=u;u=u+112|0;g=e+80|0;h=e+64|0;i=e+56|0;j=e+48|0;k=e+32|0;l=e+16|0;m=e;o=c+4|0;p=f[o>>2]|0;q=f[c>>2]|0;if((p|0)==(q|0)){u=e;return}r=a+68|0;s=g+4|0;t=g+8|0;v=g+12|0;w=g+16|0;x=g+20|0;y=g+24|0;z=a+20|0;a=h+4|0;A=h+8|0;B=h+12|0;C=i+4|0;D=j+4|0;E=k+8|0;F=k+12|0;G=k+4|0;H=l+8|0;I=l+12|0;J=l+4|0;K=m+4|0;M=m+8|0;N=m+12|0;O=d+4|0;P=d+8|0;Q=0;R=p;p=q;while(1){q=p;S=f[r>>2]|0;T=f[S+(Q*316|0)+240>>2]|0;U=S+(Q*316|0)+308|0;V=+n[U>>2];W=f[S+(Q*316|0)+236>>2]|0;X=f[q+(Q*56|0)+16>>2]|0;Z=q+(Q*56|0)+8|0;_=f[Z>>2]|0;if((_|0)>0){$=q+(Q*56|0)+12|0;q=S+(Q*316|0)+292|0;aa=S+(Q*316|0)+296|0;ba=(V+-1.0)*.5;S=0;ca=0;da=_;_=f[$>>2]|0;while(1){if((_|0)>0){ea=+(ca|0);fa=Y(ca,W)|0;ga=ca+1|0;ha=Y(ga,W)|0;ia=Y(ca+-1|0,W)|0;ja=0;ka=S;la=_;while(1){if(!(b[X+ka>>0]|0))ma=la;else{n[w>>2]=0.0;na=+n[U>>2];n[g>>2]=+(ja|0)*na;n[s>>2]=ea*na;n[t>>2]=+n[q>>2]*+n[z>>2];n[v>>2]=-1.0;f[w>>2]=f[T+(ka<<2)>>2];f[x>>2]=f[aa>>2];f[y>>2]=Q;oa=ja+fa|0;na=+n[T+(oa+1<<2)>>2];pa=+n[T+(oa+-1<<2)>>2];qa=ja+ha|0;ra=+n[T+(qa<<2)>>2];sa=ja+ia|0;ta=+n[T+(sa<<2)>>2];ua=+n[T+(oa<<2)>>2]*2.0;va=(+n[T+(qa+1<<2)>>2]+ +n[T+(sa+-1<<2)>>2]-+n[T+(sa+1<<2)>>2]-+n[T+(qa+-1<<2)>>2])*.25;n[h>>2]=na+pa-ua;n[a>>2]=va;n[A>>2]=va;n[B>>2]=ra+ta-ua;n[i>>2]=-((na-pa)*.5);n[C>>2]=-((ra-ta)*.5);n[j>>2]=0.0;n[D>>2]=0.0;f[k>>2]=-1056833531;f[G>>2]=h;f[E>>2]=2;f[F>>2]=2;f[l>>2]=-1056833531;f[J>>2]=i;f[H>>2]=1;f[I>>2]=2;f[m>>2]=-1040056315;f[K>>2]=j;f[M>>2]=1;f[N>>2]=2;oQ(k,l,m,0)|0;ta=+n[j>>2];ra=+n[D>>2];do if(!(+L(+ta)>1.0)?!(+L(+ra)>1.0):0){pa=ba+V*ta+ +n[g>>2];n[g>>2]=pa;na=ba+V*ra+ +n[s>>2];n[s>>2]=na;n[v>>2]=0.0;n[t>>2]=+n[t>>2]*2.0;qa=f[O>>2]|0;if((qa|0)==(f[P>>2]|0)){V_(d,g);break}else{n[qa>>2]=pa;n[qa+4>>2]=na;sa=qa+8|0;f[sa>>2]=f[t>>2];f[sa+4>>2]=f[t+4>>2];f[sa+8>>2]=f[t+8>>2];f[sa+12>>2]=f[t+12>>2];f[sa+16>>2]=f[t+16>>2];f[O>>2]=(f[O>>2]|0)+28;break}}while(0);ma=f[$>>2]|0}ja=ja+1|0;ka=ka+1|0;if((ja|0)>=(ma|0))break;else la=ma}wa=ka;xa=ga;ya=ma;za=f[Z>>2]|0}else{wa=S;xa=ca+1|0;ya=_;za=da}if((xa|0)<(za|0)){S=wa;ca=xa;da=za;_=ya}else break}Aa=f[c>>2]|0;Ba=f[o>>2]|0}else{Aa=p;Ba=R}Q=Q+1|0;if(Q>>>0>=((Ba-Aa|0)/56|0)>>>0)break;else{R=Ba;p=Aa}}u=e;return}function DJb(a){a=a|0;YDc(a);return}function EJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0;d=u;u=u+1936|0;e=d+1920|0;g=d+1480|0;h=d+1044|0;i=d+608|0;j=d+436|0;k=d;l=f[c>>2]|0;m=c+4|0;if((l|0)>=(f[m>>2]|0)){u=d;return}c=a+4|0;o=a+8|0;a=j+168|0;p=j+28|0;q=j+140|0;r=l;a:while(1){l=f[f[c>>2]>>2]|0;s=f[f[o>>2]>>2]|0;t=f[l+(r*28|0)+24>>2]|0;v=+n[s+(t*316|0)+308>>2];w=mrc(+n[l+(r*28|0)+8>>2]*.5/v)|0;x=mrc(+n[l+(r*28|0)>>2]/v)|0;y=mrc(+n[l+(r*28|0)+4>>2]/v)|0;if((b[527152]|0)==0?MIc(527152)|0:0){z=-6;A=0;while(1){B=Y(z,z)|0;C=(z|0)>-1?z:0-z|0;D=-6;E=A;while(1){if(((Y(D,D)|0)+B|0)>>>0<36){if((E|0)>=109){F=10;break a}f[881900+(E<<2)>>2]=f[112232+(C*28|0)+(((D|0)>-1?D:0-D|0)<<2)>>2];f[882772+(E<<2)>>2]=z;f[882336+(E<<2)>>2]=D;G=E+1|0}else G=E;D=D+1|0;if((D|0)>=7)break;else E=G}z=z+1|0;if((z|0)>=7)break;else A=G}}A=w*6|0;if((A|0)>(x|0)){F=16;break}if((x+A|0)>=(f[s+(t*316|0)+12>>2]|0)){F=16;break}if((A|0)>(y|0)){F=20;break}if((y+A|0)>=(f[s+(t*316|0)+8>>2]|0)){F=20;break}A=f[s+(t*316|0)+16>>2]|0;z=f[f[s+(t*316|0)+44>>2]>>2]|0;E=f[s+(t*316|0)+72>>2]|0;D=f[f[s+(t*316|0)+100>>2]>>2]|0;C=0;do{B=(Y(f[882772+(C<<2)>>2]|0,w)|0)+y|0;H=(Y(f[882336+(C<<2)>>2]|0,w)|0)+x|0;v=+n[881900+(C<<2)>>2];I=A+(Y(B,z)|0)+(H<<2)|0;n[g+(C<<2)>>2]=v*+n[I>>2];I=E+(Y(B,D)|0)+(H<<2)|0;n[h+(C<<2)>>2]=v*+n[I>>2];C=C+1|0}while((C|0)!=109);P6(h,g,i,109,0);XIc(j|0,0,172)|0;C=0;do{D=~~(+n[i+(C<<2)>>2]/.14959965646266937);E=j+((D>>>0>41?0:D)<<2)|0;f[E>>2]=(f[E>>2]|0)+1;C=C+1|0}while((C|0)!=109);C=1;E=f[j>>2]|0;do{D=j+(C<<2)|0;E=(f[D>>2]|0)+E|0;f[D>>2]=E;C=C+1|0}while((C|0)!=43);if((f[a>>2]|0)==109)J=0;else{F=27;break}do{C=~~(+n[i+(J<<2)>>2]/.14959965646266937);E=j+((C>>>0>41?0:C)<<2)|0;C=(f[E>>2]|0)+-1|0;f[E>>2]=C;f[k+(C<<2)>>2]=J;J=J+1|0}while((J|0)!=109);C=f[j>>2]|0;E=f[p>>2]|0;if((C|0)<(E|0)){v=0.0;D=C;K=0.0;while(1){z=f[k+(D<<2)>>2]|0;L=K+ +n[g+(z<<2)>>2];M=v+ +n[h+(z<<2)>>2];D=D+1|0;if((D|0)==(E|0)){N=L;O=M;break}else{v=M;K=L}}}else{N=0.0;O=0.0}K=O*O+N*N;D=1;v=O;L=N;z=C;A=E;while(1){x=z;z=f[j+(D<<2)>>2]|0;w=f[j+(D+7<<2)>>2]|0;if((z|0)==(x|0)&(w|0)==(A|0)){P=K;Q=L;R=v;S=A}else{if((z|0)<(w|0)){x=z;M=0.0;T=0.0;while(1){y=f[k+(x<<2)>>2]|0;U=T+ +n[g+(y<<2)>>2];V=M+ +n[h+(y<<2)>>2];x=x+1|0;if((x|0)==(w|0)){W=V;X=U;break}else{M=V;T=U}}}else{W=0.0;X=0.0}T=X*X+W*W;x=T>K;P=x?T:K;Q=x?X:L;R=x?W:v;S=w}D=D+1|0;if((D|0)==36)break;else{K=P;v=R;L=Q;A=S}}A=f[a>>2]|0;D=36;L=P;v=R;K=Q;z=f[q>>2]|0;E=C;while(1){x=D+-35|0;y=z;z=f[j+(D<<2)>>2]|0;if((z|0)==(y|0)?(f[j+(x<<2)>>2]|0)==(E|0):0){Z=L;_=K;$=v;aa=E}else{if((z|0)<(A|0)){y=z;T=0.0;M=0.0;while(1){t=f[k+(y<<2)>>2]|0;U=M+ +n[g+(t<<2)>>2];V=T+ +n[h+(t<<2)>>2];y=y+1|0;if((y|0)==(A|0)){ba=V;ca=U;break}else{T=V;M=U}}}else{ba=0.0;ca=0.0}y=f[j+(x<<2)>>2]|0;if((C|0)<(y|0)){w=C;M=ba;T=ca;while(1){t=f[k+(w<<2)>>2]|0;U=T+ +n[g+(t<<2)>>2];V=M+ +n[h+(t<<2)>>2];w=w+1|0;if((w|0)==(y|0)){da=V;ea=U;break}else{M=V;T=U}}}else{da=ba;ea=ca}T=ea*ea+da*da;w=T>L;Z=w?T:L;_=w?ea:K;$=w?da:v;aa=y}D=D+1|0;if((D|0)==42)break;else{L=Z;v=$;K=_;E=aa}}K=+_6($,_);n[l+(r*28|0)+12>>2]=K;r=r+1|0;if((r|0)>=(f[m>>2]|0)){F=3;break}}if((F|0)==3){u=d;return}else if((F|0)==10){f[e>>2]=0;f[e+4>>2]=0;d=tT(e,7)|0;b[d>>0]=b[462241]|0;b[d+1>>0]=b[462242]|0;b[d+2>>0]=b[462243]|0;b[d+3>>0]=b[462244]|0;b[d+4>>0]=b[462245]|0;b[d+5>>0]=b[462246]|0;b[d+6>>0]=b[462247]|0;z5(-215,e,462249,461802,1283)}else if((F|0)==16){f[e>>2]=0;f[e+4>>2]=0;fa=tT(e,47)|0;ga=462256;ha=fa+47|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));z5(-215,e,462304,461802,1294)}else if((F|0)==20){f[e>>2]=0;f[e+4>>2]=0;fa=tT(e,47)|0;ga=462339;ha=fa+47|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));z5(-215,e,462304,461802,1295)}else if((F|0)==27){f[e>>2]=0;f[e+4>>2]=0;fa=tT(e,15)|0;ga=462387;ha=fa+15|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));z5(-215,e,462403,461802,1342)}}function FJb(a){a=a|0;YDc(a);return}function GJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=u;u=u+240|0;e=d;g=d+224|0;h=f[c>>2]|0;i=c+4|0;if((h|0)>=(f[i>>2]|0)){u=d;return}c=a+4|0;j=a+8|0;k=g+4|0;l=a+12|0;a=h;do{h=f[f[c>>2]>>2]|0;m=f[f[j>>2]>>2]|0;o=f[h+(a*316|0)+264>>2]|0;p=f[o>>2]|0;f[g>>2]=f[o+4>>2];f[k>>2]=p;DY(e,g,0);p=f[e>>2]|0;ei[f[(f[p>>2]|0)+12>>2]&511](p,e,m+(a*56|0)|0,-1);$j(e);p=h+(a*316|0)+312|0;o=f[p>>2]|0;q=o+1|0;r=h+(a*316|0)+232|0;s=f[r>>2]|0;if((q|0)<(s|0)?(t=f[h+(a*316|0)+240>>2]|0,v=f[f[h+(a*316|0)+268>>2]>>2]|0,w=m+(a*56|0)+16|0,x=f[w>>2]|0,y=m+(a*56|0)+44|0,z=f[h+(a*316|0)+304>>2]|0,(o|0)<(s-o|0)):0){s=t+(Y(v,q)|0)|0;q=t+(Y(v,o)|0)|0;A=t+(Y(v,o+-1|0)|0)|0;v=h+(a*316|0)+236|0;h=m+(a*56|0)+12|0;m=Y(z,z)|0;B=o;C=A;A=q;q=s;s=o;o=f[v>>2]|0;while(1){a:do if((s|0)<(o-s|0)){D=B-z|0;E=B+z|0;if((D|0)<(E|0)){F=s;G=s;H=o}else{I=s;J=s;K=o;while(1){L=+n[A+(I<<2)>>2];do if(((((((!(L<=+n[l>>2])?(M=I+-1|0,!(L<=+n[A+(M<<2)>>2])):0)?(N=I+1|0,!(L<=+n[A+(N<<2)>>2])):0)?!(L<=+n[C+(M<<2)>>2]):0)?!(L<=+n[C+(I<<2)>>2]):0)?!(L<=+n[C+(N<<2)>>2]):0)?!(L<=+n[q+(M<<2)>>2]):0)?!(L<=+n[q+(I<<2)>>2]):0){if(L<=+n[q+(N<<2)>>2]){O=J;P=K;break}N=(f[w>>2]|0)+(Y(f[f[y>>2]>>2]|0,B)|0)+I|0;b[N>>0]=1;O=f[p>>2]|0;P=f[v>>2]|0}else{O=J;P=K}while(0);I=I+1|0;if((I|0)>=(P-O|0)){Q=P;R=O;break a}else{J=O;K=P}}}while(1){L=+n[A+(F<<2)>>2];b:do if((((((((!(L<=+n[l>>2])?(K=F+-1|0,!(L<=+n[A+(K<<2)>>2])):0)?(J=F+1|0,!(L<=+n[A+(J<<2)>>2])):0)?!(L<=+n[C+(K<<2)>>2]):0)?!(L<=+n[C+(F<<2)>>2]):0)?!(L<=+n[C+(J<<2)>>2]):0)?!(L<=+n[q+(K<<2)>>2]):0)?!(L<=+n[q+(F<<2)>>2]):0)?!(L<=+n[q+(J<<2)>>2]):0){J=f[h>>2]|0;K=f[w>>2]|0;I=f[f[y>>2]>>2]|0;N=F-z|0;M=F+z|0;c:do if((N|0)<(M|0)){S=D;d:while(1){T=K+(Y(S,I)|0)|0;U=S-B|0;V=Y(U,U)|0;W=N;while(1){if(b[T+W>>0]|0?(U=W-F|0,((Y(U,U)|0)+V|0)>>>0<=m>>>0):0)break d;U=W+1|0;if((U|0)<(M|0))W=U;else break}V=S+1|0;if((V|0)<(E|0))S=V;else{X=I;Z=K;break c}}V=W+(Y(S,J)|0)|0;if(!(L>+n[t+(V<<2)>>2])){_=G;$=H;break b}b[x+V>>0]=0;X=f[f[y>>2]>>2]|0;Z=f[w>>2]|0}else{X=I;Z=K}while(0);K=Z+(Y(X,B)|0)+F|0;b[K>>0]=1;_=f[p>>2]|0;$=f[v>>2]|0}else{_=G;$=H}while(0);F=F+1|0;if((F|0)>=($-_|0)){Q=$;R=_;break}else{G=_;H=$}}}else{Q=o;R=s}while(0);B=B+1|0;if((B|0)>=((f[r>>2]|0)-R|0))break;else{E=q;D=A;q=q+(Q<<2)|0;s=R;o=Q;A=E;C=D}}}a=a+1|0}while((a|0)<(f[i>>2]|0));u=d;return}function HJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+432|0;g=e+368|0;h=e+360|0;i=e+168|0;j=e+304|0;k=e+112|0;l=e+56|0;m=e;n=c+4|0;o=f[n>>2]|0;p=f[c>>2]|0;q=p;a:do if((o|0)!=(p|0)){r=a+68|0;s=a+72|0;t=(o-p|0)/28|0;v=0;while(1){w=f[q+(v*28|0)+24>>2]|0;if((w|0)<=-1){x=7;break}v=v+1|0;if((w|0)>=(((f[s>>2]|0)-(f[r>>2]|0)|0)/316|0|0)){x=7;break}if(v>>>0>=t>>>0)break a}if((x|0)==7){f[g>>2]=0;f[g+4>>2]=0;t=tT(g,79)|0;v=465406;r=t+79|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(r|0));z5(-215,g,462491,461802,1192)}}while(0);x=a+40|0;if((f[x>>2]|0)>3){q=f[a+44>>2]|0;if(!q)y=(f[a+48>>2]|0)*162|0;else y=q;z=0;A=(y+7|0)>>>3}else{z=5;A=64}Y$(d,(o-p|0)/28|0,A,z,-1,0,0);do if((d$(d)|0)==65536){z=f[d+4>>2]|0;f[g>>2]=f[z>>2];A=g+4|0;p=z+4|0;f[A>>2]=f[p>>2];o=g+8|0;f[o>>2]=f[z+8>>2];f[g+12>>2]=f[z+12>>2];f[g+16>>2]=f[z+16>>2];f[g+20>>2]=f[z+20>>2];f[g+24>>2]=f[z+24>>2];f[g+28>>2]=f[z+28>>2];f[g+32>>2]=f[z+32>>2];y=f[z+36>>2]|0;f[g+36>>2]=y;f[g+40>>2]=o;o=g+48|0;q=g+44|0;f[q>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(y|0){o=y+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[p>>2]|0)<3){p=f[z+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[p>>2];f[o+4>>2]=f[p+4>>2];break}else{f[A>>2]=0;ZS(g,z);break}}else a$(g,d,-1);while(0);b:do switch(f[x>>2]|0){case 2:{d=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=d;f[i>>2]=112456;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;y8(h,i,-1.0);break}case 3:{d=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=d;f[i>>2]=112476;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;y8(h,i,-1.0);break}case 4:{if(!(f[a+44>>2]|0)){d=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=d;f[i>>2]=112496;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;f[i+16>>2]=a;y8(h,i,-1.0);break b}d=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=d;d=a+112|0;f[j>>2]=f[d>>2];z=j+4|0;A=a+116|0;p=f[A>>2]|0;f[z>>2]=p;o=j+8|0;f[o>>2]=f[a+120>>2];f[j+12>>2]=f[a+124>>2];q=j+16|0;f[q>>2]=f[a+128>>2];f[j+20>>2]=f[a+132>>2];f[j+24>>2]=f[a+136>>2];f[j+28>>2]=f[a+140>>2];f[j+32>>2]=f[a+144>>2];y=j+36|0;v=f[a+148>>2]|0;f[y>>2]=v;t=j+40|0;f[t>>2]=o;o=j+48|0;r=j+44|0;f[r>>2]=o;f[o>>2]=0;f[j+52>>2]=0;if(!v)B=p;else{p=v+12|0;f[p>>2]=(f[p>>2]|0)+1;B=f[A>>2]|0}if((B|0)<3){A=f[a+156>>2]|0;p=f[r>>2]|0;f[p>>2]=f[A>>2];f[p+4>>2]=f[A+4>>2]}else{f[z>>2]=0;ZS(j,d)}d=a+168|0;f[k>>2]=f[d>>2];A=k+4|0;p=a+172|0;v=f[p>>2]|0;f[A>>2]=v;s=k+8|0;f[s>>2]=f[a+176>>2];f[k+12>>2]=f[a+180>>2];w=k+16|0;f[w>>2]=f[a+184>>2];f[k+20>>2]=f[a+188>>2];f[k+24>>2]=f[a+192>>2];f[k+28>>2]=f[a+196>>2];f[k+32>>2]=f[a+200>>2];C=k+36|0;D=f[a+204>>2]|0;f[C>>2]=D;E=k+40|0;f[E>>2]=s;s=k+48|0;F=k+44|0;f[F>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(!D)G=v;else{v=D+12|0;f[v>>2]=(f[v>>2]|0)+1;G=f[p>>2]|0}if((G|0)<3){p=f[a+212>>2]|0;v=f[F>>2]|0;f[v>>2]=f[p>>2];f[v+4>>2]=f[p+4>>2]}else{f[A>>2]=0;ZS(k,d)}IJb(i,c,g,a+68|0,a,j,k);y8(h,i,-1.0);JJb(i);d=f[C>>2]|0;if(d|0?(p=d+12|0,d=f[p>>2]|0,f[p>>2]=d+-1,(d|0)==1):0)_S(k);f[C>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[A>>2]|0)>0){w=f[E>>2]|0;E=0;do{f[w+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[A>>2]|0))}A=f[F>>2]|0;if((A|0)!=(s|0))g0(A);A=f[y>>2]|0;if(A|0?(E=A+12|0,A=f[E>>2]|0,f[E>>2]=A+-1,(A|0)==1):0)_S(j);f[y>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[z>>2]|0)>0){A=f[t>>2]|0;E=0;do{f[A+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[z>>2]|0))}z=f[r>>2]|0;if((z|0)!=(o|0))g0(z);break}case 5:{if(!(f[a+44>>2]|0)){z=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=z;f[i>>2]=112516;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;f[i+16>>2]=a;y8(h,i,-1.0);break b}z=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=z;z=a+112|0;f[l>>2]=f[z>>2];E=l+4|0;A=a+116|0;t=f[A>>2]|0;f[E>>2]=t;q=l+8|0;f[q>>2]=f[a+120>>2];f[l+12>>2]=f[a+124>>2];y=l+16|0;f[y>>2]=f[a+128>>2];f[l+20>>2]=f[a+132>>2];f[l+24>>2]=f[a+136>>2];f[l+28>>2]=f[a+140>>2];f[l+32>>2]=f[a+144>>2];s=l+36|0;F=f[a+148>>2]|0;f[s>>2]=F;w=l+40|0;f[w>>2]=q;q=l+48|0;C=l+44|0;f[C>>2]=q;f[q>>2]=0;f[l+52>>2]=0;if(!F)H=t;else{t=F+12|0;f[t>>2]=(f[t>>2]|0)+1;H=f[A>>2]|0}if((H|0)<3){A=f[a+156>>2]|0;t=f[C>>2]|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2]}else{f[E>>2]=0;ZS(l,z)}z=a+168|0;f[m>>2]=f[z>>2];A=m+4|0;t=a+172|0;F=f[t>>2]|0;f[A>>2]=F;d=m+8|0;f[d>>2]=f[a+176>>2];f[m+12>>2]=f[a+180>>2];p=m+16|0;f[p>>2]=f[a+184>>2];f[m+20>>2]=f[a+188>>2];f[m+24>>2]=f[a+192>>2];f[m+28>>2]=f[a+196>>2];f[m+32>>2]=f[a+200>>2];v=m+36|0;D=f[a+204>>2]|0;f[v>>2]=D;I=m+40|0;f[I>>2]=d;d=m+48|0;J=m+44|0;f[J>>2]=d;f[d>>2]=0;f[m+52>>2]=0;if(!D)K=F;else{F=D+12|0;f[F>>2]=(f[F>>2]|0)+1;K=f[t>>2]|0}if((K|0)<3){t=f[a+212>>2]|0;F=f[J>>2]|0;f[F>>2]=f[t>>2];f[F+4>>2]=f[t+4>>2]}else{f[A>>2]=0;ZS(m,z)}KJb(i,c,g,a+68|0,a,l,m);y8(h,i,-1.0);LJb(i);z=f[v>>2]|0;if(z|0?(t=z+12|0,z=f[t>>2]|0,f[t>>2]=z+-1,(z|0)==1):0)_S(m);f[v>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[A>>2]|0)>0){p=f[I>>2]|0;I=0;do{f[p+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[A>>2]|0))}A=f[J>>2]|0;if((A|0)!=(d|0))g0(A);A=f[s>>2]|0;if(A|0?(I=A+12|0,A=f[I>>2]|0,f[I>>2]=A+-1,(A|0)==1):0)_S(l);f[s>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[E>>2]|0)>0){A=f[w>>2]|0;I=0;do{f[A+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[E>>2]|0))}E=f[C>>2]|0;if((E|0)!=(q|0))g0(E);break}default:{}}while(0);l=g+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)_S(g);f[l>>2]=0;l=g+16|0;m=g+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[g+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[g+44>>2]|0;if((m|0)==(g+48|0)){u=e;return}g0(m);u=e;return}function IJb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;f[a>>2]=112556;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=d;f[a+16>>2]=e;e=a+20|0;f[e>>2]=f[g>>2];d=a+24|0;c=g+4|0;f[d>>2]=f[c>>2];b=a+28|0;f[b>>2]=f[g+8>>2];f[a+32>>2]=f[g+12>>2];f[a+36>>2]=f[g+16>>2];f[a+40>>2]=f[g+20>>2];f[a+44>>2]=f[g+24>>2];f[a+48>>2]=f[g+28>>2];f[a+52>>2]=f[g+32>>2];i=f[g+36>>2]|0;f[a+56>>2]=i;f[a+60>>2]=b;b=a+68|0;j=a+64|0;f[j>>2]=b;f[b>>2]=0;f[a+72>>2]=0;if(i|0){b=i+12|0;f[b>>2]=(f[b>>2]|0)+1}if((f[c>>2]|0)<3){c=f[g+44>>2]|0;b=f[j>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2]}else{f[d>>2]=0;ZS(e,g)}g=a+76|0;f[g>>2]=f[h>>2];e=a+80|0;d=h+4|0;f[e>>2]=f[d>>2];c=a+84|0;f[c>>2]=f[h+8>>2];f[a+88>>2]=f[h+12>>2];f[a+92>>2]=f[h+16>>2];f[a+96>>2]=f[h+20>>2];f[a+100>>2]=f[h+24>>2];f[a+104>>2]=f[h+28>>2];f[a+108>>2]=f[h+32>>2];b=f[h+36>>2]|0;f[a+112>>2]=b;f[a+116>>2]=c;c=a+124|0;j=a+120|0;f[j>>2]=c;f[c>>2]=0;f[a+128>>2]=0;if(b|0){a=b+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[d>>2]|0)<3){d=f[h+44>>2]|0;a=f[j>>2]|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];return}else{f[e>>2]=0;ZS(g,h);return}}function JJb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=112556;b=a+76|0;c=a+112|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+92|0;b=a+80|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+116>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+120>>2]|0;if((b|0)!=(a+124|0))g0(b);b=a+20|0;d=a+56|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+36|0;b=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+60>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+64>>2]|0;if((b|0)==(a+68|0))return;g0(b);return}function KJb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;f[a>>2]=112536;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=d;f[a+16>>2]=e;e=a+20|0;f[e>>2]=f[g>>2];d=a+24|0;c=g+4|0;f[d>>2]=f[c>>2];b=a+28|0;f[b>>2]=f[g+8>>2];f[a+32>>2]=f[g+12>>2];f[a+36>>2]=f[g+16>>2];f[a+40>>2]=f[g+20>>2];f[a+44>>2]=f[g+24>>2];f[a+48>>2]=f[g+28>>2];f[a+52>>2]=f[g+32>>2];i=f[g+36>>2]|0;f[a+56>>2]=i;f[a+60>>2]=b;b=a+68|0;j=a+64|0;f[j>>2]=b;f[b>>2]=0;f[a+72>>2]=0;if(i|0){b=i+12|0;f[b>>2]=(f[b>>2]|0)+1}if((f[c>>2]|0)<3){c=f[g+44>>2]|0;b=f[j>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2]}else{f[d>>2]=0;ZS(e,g)}g=a+76|0;f[g>>2]=f[h>>2];e=a+80|0;d=h+4|0;f[e>>2]=f[d>>2];c=a+84|0;f[c>>2]=f[h+8>>2];f[a+88>>2]=f[h+12>>2];f[a+92>>2]=f[h+16>>2];f[a+96>>2]=f[h+20>>2];f[a+100>>2]=f[h+24>>2];f[a+104>>2]=f[h+28>>2];f[a+108>>2]=f[h+32>>2];b=f[h+36>>2]|0;f[a+112>>2]=b;f[a+116>>2]=c;c=a+124|0;j=a+120|0;f[j>>2]=c;f[c>>2]=0;f[a+128>>2]=0;if(b|0){a=b+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[d>>2]|0)<3){d=f[h+44>>2]|0;a=f[j>>2]|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];return}else{f[e>>2]=0;ZS(g,h);return}}function LJb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=112536;b=a+76|0;c=a+112|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+92|0;b=a+80|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+116>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+120>>2]|0;if((b|0)!=(a+124|0))g0(b);b=a+20|0;d=a+56|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+36|0;b=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+60>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+64>>2]|0;if((b|0)==(a+68|0))return;g0(b);return}function MJb(a){a=a|0;LJb(a);YDc(a);return}function NJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;OJb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function OJb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0.0,Ma=0,Na=0,Oa=0;g=u;u=u+544|0;i=g+480|0;j=g+424|0;k=g+368|0;l=g+20|0;m=g+8|0;o=g;p=f[a+16>>2]|0;q=f[a+12>>2]|0;r=+(1<<f[c+20>>2]|0);s=mrc(+n[c+8>>2]*.5/r)|0;t=+n[c+12>>2]*.01745329238474369;v=f[c+24>>2]|0;w=f[q>>2]|0;x=w+(v*316|0)|0;f[i>>2]=f[x>>2];y=i+4|0;z=w+(v*316|0)+4|0;f[y>>2]=f[z>>2];A=i+8|0;f[A>>2]=f[w+(v*316|0)+8>>2];f[i+12>>2]=f[w+(v*316|0)+12>>2];B=i+16|0;f[B>>2]=f[w+(v*316|0)+16>>2];f[i+20>>2]=f[w+(v*316|0)+20>>2];f[i+24>>2]=f[w+(v*316|0)+24>>2];f[i+28>>2]=f[w+(v*316|0)+28>>2];f[i+32>>2]=f[w+(v*316|0)+32>>2];C=i+36|0;D=f[w+(v*316|0)+36>>2]|0;f[C>>2]=D;E=i+40|0;f[E>>2]=A;A=i+48|0;F=i+44|0;f[F>>2]=A;f[A>>2]=0;f[i+52>>2]=0;if(D|0){G=D+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[z>>2]|0)<3){z=f[w+(v*316|0)+44>>2]|0;w=f[F>>2]|0;f[w>>2]=f[z>>2];f[w+4>>2]=f[z+4>>2]}else{f[y>>2]=0;ZS(i,x)}x=f[q>>2]|0;z=x+(v*316|0)+56|0;f[j>>2]=f[z>>2];w=j+4|0;G=x+(v*316|0)+60|0;D=f[G>>2]|0;f[w>>2]=D;H=j+8|0;f[H>>2]=f[x+(v*316|0)+64>>2];f[j+12>>2]=f[x+(v*316|0)+68>>2];I=j+16|0;f[I>>2]=f[x+(v*316|0)+72>>2];f[j+20>>2]=f[x+(v*316|0)+76>>2];f[j+24>>2]=f[x+(v*316|0)+80>>2];f[j+28>>2]=f[x+(v*316|0)+84>>2];f[j+32>>2]=f[x+(v*316|0)+88>>2];J=j+36|0;K=f[x+(v*316|0)+92>>2]|0;f[J>>2]=K;L=j+40|0;f[L>>2]=H;H=j+48|0;N=j+44|0;f[N>>2]=H;f[H>>2]=0;f[j+52>>2]=0;if(!K)Q=D;else{D=K+12|0;f[D>>2]=(f[D>>2]|0)+1;Q=f[G>>2]|0}if((Q|0)<3){Q=f[x+(v*316|0)+100>>2]|0;x=f[N>>2]|0;f[x>>2]=f[Q>>2];f[x+4>>2]=f[Q+4>>2]}else{f[w>>2]=0;ZS(j,z)}z=f[q>>2]|0;q=z+(v*316|0)+112|0;f[k>>2]=f[q>>2];Q=k+4|0;x=z+(v*316|0)+116|0;G=f[x>>2]|0;f[Q>>2]=G;D=k+8|0;f[D>>2]=f[z+(v*316|0)+120>>2];K=k+12|0;f[K>>2]=f[z+(v*316|0)+124>>2];R=k+16|0;f[R>>2]=f[z+(v*316|0)+128>>2];f[k+20>>2]=f[z+(v*316|0)+132>>2];f[k+24>>2]=f[z+(v*316|0)+136>>2];f[k+28>>2]=f[z+(v*316|0)+140>>2];f[k+32>>2]=f[z+(v*316|0)+144>>2];S=k+36|0;T=f[z+(v*316|0)+148>>2]|0;f[S>>2]=T;U=k+40|0;f[U>>2]=D;V=k+48|0;W=k+44|0;f[W>>2]=V;f[V>>2]=0;f[k+52>>2]=0;if(!T)X=G;else{G=T+12|0;f[G>>2]=(f[G>>2]|0)+1;X=f[x>>2]|0}if((X|0)<3){X=f[z+(v*316|0)+156>>2]|0;v=f[W>>2]|0;f[v>>2]=f[X>>2];f[v+4>>2]=f[X+4>>2]}else{f[Q>>2]=0;ZS(k,q)}Z=+n[c+4>>2]/r;_=+n[c>>2]/r;r=+O(+t);$=+P(+t);c=f[p+48>>2]|0;if((c|0)>=4){f[l>>2]=0;f[l+4>>2]=0;aa=tT(l,24)|0;ba=462511;ca=aa+24|0;do{b[aa>>0]=b[ba>>0]|0;aa=aa+1|0;ba=ba+1|0}while((aa|0)<(ca|0));z5(-215,l,462536,461802,2022)}XIc(l|0,0,348)|0;q=f[p+52>>2]|0;if(q&1|0){f[m>>2]=0;f[m+4>>2]=0;aa=tT(m,23)|0;ba=462563;ca=aa+23|0;do{b[aa>>0]=b[ba>>0]|0;aa=aa+1|0;ba=ba+1|0}while((aa|0)<(ca|0));z5(-215,m,462536,461802,2027)}f[m>>2]=q;f[m+4>>2]=(((q<<1)+2|0)>>>0)/3|0;f[m+8>>2]=(q+1|0)>>>1;q=f[a+28>>2]|0;a:do if((q|0)>0){p=f[a+36>>2]|0;X=f[f[a+64>>2]>>2]|0;v=0-s|0;z=f[K>>2]|0;x=f[D>>2]|0;G=f[R>>2]|0;T=f[W>>2]|0;da=f[B>>2]|0;ea=f[F>>2]|0;fa=f[I>>2]|0;ga=f[N>>2]|0;ha=0;ia=c;while(1){ja=p+(Y(X,ha)|0)|0;ka=f[ja>>2]|0;if(ka>>>0>=3)break;la=f[m+(ka<<2)>>2]|0;if((la|0)>0){ka=f[ja+4>>2]|0;ma=f[ja+8>>2]|0;ja=ka+la|0;na=ma+la|0;la=ka;t=0.0;oa=0.0;pa=0.0;ka=ia;while(1){qa=+(Y(la,s)|0);ra=$*qa;sa=r*qa;ta=ma;qa=oa;ua=pa;va=t;wa=ka;while(1){xa=_+(sa+$*+(Y(ta,v)|0));ya=mrc(Z+(ra+r*+(Y(ta,s)|0)))|0;za=mrc(xa)|0;b:do if((za|ya|0)>-1&(za|0)<(z|0)&(ya|0)<(x|0)){Aa=G+(Y(f[T>>2]|0,ya)|0)+(za<<2)|0;xa=ua+ +n[Aa>>2];if((wa|0)>1){Aa=da+(Y(f[ea>>2]|0,ya)|0)+(za<<2)|0;Ba=+n[Aa>>2];Aa=fa+(Y(f[ga>>2]|0,ya)|0)+(za<<2)|0;Ca=+n[Aa>>2];switch(wa|0){case 2:{Da=xa;Ea=va;Fa=qa+ +M(+(Ba*Ba+Ca*Ca));Ga=2;break b;break}case 3:{Da=xa;Ea=va+(r*Ca-$*Ba);Fa=qa+(r*Ba+$*Ca);Ga=3;break b;break}default:{Da=xa;Ea=va;Fa=qa;Ga=wa;break b}}}else{Da=xa;Ea=va;Fa=qa;Ga=wa}}else{Da=ua;Ea=va;Fa=qa;Ga=wa}while(0);ta=ta+1|0;if((ta|0)>=(na|0))break;else{qa=Fa;ua=Da;va=Ea;wa=Ga}}la=la+1|0;if((la|0)>=(ja|0)){Ha=Ea;Ia=Fa;Ja=Da;Ka=Ga;break}else{t=Ea;oa=Fa;pa=Da;ka=Ga}}}else{Ha=0.0;Ia=0.0;Ja=0.0;Ka=ia}ka=l+((Y(ha,c)|0)<<2)|0;n[ka>>2]=Ja;switch(c|0){case 2:{La=Ia;Ma=1;Na=37;break}case 3:{n[ka+4>>2]=Ia;La=Ha;Ma=2;Na=37;break}default:{}}if((Na|0)==37){Na=0;n[ka+(Ma<<2)>>2]=La}ha=ha+1|0;if((ha|0)>=(q|0))break a;else ia=Ka}f[o>>2]=0;f[o+4>>2]=0;aa=tT(o,31)|0;ba=462587;ca=aa+31|0;do{b[aa>>0]=b[ba>>0]|0;aa=aa+1|0;ba=ba+1|0}while((aa|0)<(ca|0));z5(-215,o,462536,461802,2036)}while(0);Ka=f[a+92>>2]|0;q=a+84|0;if((((f[q>>2]|0)+7|0)>>>3|0)!=(e|0)){f[o>>2]=0;f[o+4>>2]=0;aa=tT(o,43)|0;ba=462619;ca=aa+43|0;do{b[aa>>0]=b[ba>>0]|0;aa=aa+1|0;ba=ba+1|0}while((aa|0)<(ca|0));z5(-215,o,462536,461802,2086)}XIc(d|0,0,e|0)|0;e=f[q>>2]|0;if((e|0)>0){o=0;ba=e;while(1){e=o<<1;if(+n[l+(f[Ka+(e<<2)>>2]<<2)>>2]>+n[l+(f[Ka+((e|1)<<2)>>2]<<2)>>2]){e=d+((o|0)/8|0)|0;b[e>>0]=h[e>>0]|0|1<<(o&7);Oa=f[q>>2]|0}else Oa=ba;o=o+1|0;if((o|0)>=(Oa|0))break;else ba=Oa}}Oa=f[S>>2]|0;if(Oa|0?(ba=Oa+12|0,Oa=f[ba>>2]|0,f[ba>>2]=Oa+-1,(Oa|0)==1):0)_S(k);f[S>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Q>>2]|0)>0){R=f[U>>2]|0;U=0;do{f[R+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[Q>>2]|0))}Q=f[W>>2]|0;if((Q|0)!=(V|0))g0(Q);Q=f[J>>2]|0;if(Q|0?(V=Q+12|0,Q=f[V>>2]|0,f[V>>2]=Q+-1,(Q|0)==1):0)_S(j);f[J>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[w>>2]|0)>0){I=f[L>>2]|0;L=0;do{f[I+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[w>>2]|0))}w=f[N>>2]|0;if((w|0)!=(H|0))g0(w);w=f[C>>2]|0;if(w|0?(H=w+12|0,w=f[H>>2]|0,f[H>>2]=w+-1,(w|0)==1):0)_S(i);f[C>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[y>>2]|0)>0){B=f[E>>2]|0;E=0;do{f[B+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[y>>2]|0))}y=f[F>>2]|0;if((y|0)==(A|0)){u=g;return}g0(y);u=g;return}function PJb(a){a=a|0;YDc(a);return}function QJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;RJb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function RJb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0;g=u;u=u+224|0;i=g+24|0;j=g+8|0;k=g;l=a+16|0;m=f[l>>2]|0;if((f[m+48>>2]|0)>=4){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,45)|0;p=462701;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,i,462747,461802,1955)}r=f[m+52>>2]|0;if(r&1|0){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,23)|0;p=462563;q=o+23|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,462747,461802,1959)}f[j>>2]=r;f[j+4>>2]=(((r<<1)+2|0)>>>0)/3|0;f[j+8>>2]=(r+1|0)>>>1;s=+(1<<f[c+20>>2]|0);t=+(mrc(+n[c+8>>2]*.5/s)|0);v=+n[c>>2]/s;w=+n[c+4>>2]/s;s=+n[c+12>>2]*.01745329238474369;x=+O(+s);y=+P(+s);XIc(d|0,0,e|0)|0;m=c+24|0;c=0;z=0;A=r;r=5;B=3;while(1){C=c+2|0;D=Y(C,C)|0;SJb(a,i,A,f[m>>2]|0,v,w,x,y,t);C=f[(f[l>>2]|0)+48>>2]|0;E=Y(C,D)|0;if((E|0)>0){F=0;do{G=i+(F<<2)|0;H=f[G>>2]|0;f[G>>2]=H>>31&2147483647^H;F=F+1|0}while((F|0)!=(E|0))}if((D|0)!=0&(C|0)>0){E=0;F=z;while(1){H=0;G=F;I=B;while(1){J=i+((Y(H,C)|0)+E<<2)|0;K=f[J>>2]|0;H=H+1|0;if((H|0)<(D|0)){J=H;L=G;while(1){M=i+((Y(J,C)|0)+E<<2)|0;if((K|0)>(f[M>>2]|0)){M=d+(L>>3)|0;b[M>>0]=h[M>>0]|0|1<<(L&7)}J=J+1|0;if((J|0)==(D|0))break;else L=L+1|0}N=G+I|0}else N=G;if((H|0)==(D|0))break;else{G=N;I=I+-1|0}}E=E+1|0;if((E|0)==(C|0)){Q=N;break}else F=N}}else Q=z;F=c+1|0;if((F|0)==3)break;C=B+r|0;c=F;z=Q;A=f[j+(F<<2)>>2]|0;r=r+2|0;B=C}if((Q|0)!=486){f[k>>2]=0;f[k+4>>2]=0;o=tT(k,11)|0;p=462772;q=o+11|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,462747,461802,1985)}if((e|0)==61){u=g;return}else{f[k>>2]=0;f[k+4>>2]=0;o=tT(k,27)|0;p=462784;q=o+27|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,k,462747,461802,1986)}}function SJb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=+i;j=+j;k=+k;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0.0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0;l=u;u=u+176|0;m=l+120|0;o=l+64|0;p=l+8|0;q=l;r=f[a+12>>2]|0;s=f[a+16>>2]|0;a=f[s+52>>2]|0;t=f[s+48>>2]|0;s=f[r>>2]|0;v=s+(e*316|0)|0;f[m>>2]=f[v>>2];w=m+4|0;x=s+(e*316|0)+4|0;f[w>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[s+(e*316|0)+8>>2];f[m+12>>2]=f[s+(e*316|0)+12>>2];z=m+16|0;f[z>>2]=f[s+(e*316|0)+16>>2];f[m+20>>2]=f[s+(e*316|0)+20>>2];f[m+24>>2]=f[s+(e*316|0)+24>>2];f[m+28>>2]=f[s+(e*316|0)+28>>2];f[m+32>>2]=f[s+(e*316|0)+32>>2];A=m+36|0;B=f[s+(e*316|0)+36>>2]|0;f[A>>2]=B;C=m+40|0;f[C>>2]=y;y=m+48|0;D=m+44|0;f[D>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(B|0){E=B+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[x>>2]|0)<3){x=f[s+(e*316|0)+44>>2]|0;s=f[D>>2]|0;f[s>>2]=f[x>>2];f[s+4>>2]=f[x+4>>2]}else{f[w>>2]=0;ZS(m,v)}v=f[r>>2]|0;x=v+(e*316|0)+56|0;f[o>>2]=f[x>>2];s=o+4|0;E=v+(e*316|0)+60|0;B=f[E>>2]|0;f[s>>2]=B;F=o+8|0;f[F>>2]=f[v+(e*316|0)+64>>2];f[o+12>>2]=f[v+(e*316|0)+68>>2];G=o+16|0;f[G>>2]=f[v+(e*316|0)+72>>2];f[o+20>>2]=f[v+(e*316|0)+76>>2];f[o+24>>2]=f[v+(e*316|0)+80>>2];f[o+28>>2]=f[v+(e*316|0)+84>>2];f[o+32>>2]=f[v+(e*316|0)+88>>2];H=o+36|0;I=f[v+(e*316|0)+92>>2]|0;f[H>>2]=I;J=o+40|0;f[J>>2]=F;F=o+48|0;K=o+44|0;f[K>>2]=F;f[F>>2]=0;f[o+52>>2]=0;if(!I)L=B;else{B=I+12|0;f[B>>2]=(f[B>>2]|0)+1;L=f[E>>2]|0}if((L|0)<3){L=f[v+(e*316|0)+100>>2]|0;v=f[K>>2]|0;f[v>>2]=f[L>>2];f[v+4>>2]=f[L+4>>2]}else{f[s>>2]=0;ZS(o,x)}x=f[r>>2]|0;r=x+(e*316|0)+112|0;f[p>>2]=f[r>>2];L=p+4|0;v=x+(e*316|0)+116|0;E=f[v>>2]|0;f[L>>2]=E;B=p+8|0;f[B>>2]=f[x+(e*316|0)+120>>2];I=p+12|0;f[I>>2]=f[x+(e*316|0)+124>>2];N=p+16|0;f[N>>2]=f[x+(e*316|0)+128>>2];f[p+20>>2]=f[x+(e*316|0)+132>>2];f[p+24>>2]=f[x+(e*316|0)+136>>2];f[p+28>>2]=f[x+(e*316|0)+140>>2];f[p+32>>2]=f[x+(e*316|0)+144>>2];O=p+36|0;P=f[x+(e*316|0)+148>>2]|0;f[O>>2]=P;Q=p+40|0;f[Q>>2]=B;R=p+48|0;S=p+44|0;f[S>>2]=R;f[R>>2]=0;f[p+52>>2]=0;if(!P)T=E;else{E=P+12|0;f[E>>2]=(f[E>>2]|0)+1;T=f[v>>2]|0}if((T|0)<3){T=f[x+(e*316|0)+156>>2]|0;e=f[S>>2]|0;f[e>>2]=f[T>>2];f[e+4>>2]=f[T+4>>2]}else{f[L>>2]=0;ZS(p,r)}r=f[Q>>2]|0;T=f[r+4>>2]|0;e=f[r>>2]|0;r=f[C>>2]|0;if(!((e|0)==(f[r>>2]|0)?(T|0)==(f[r+4>>2]|0):0)){f[q>>2]=0;f[q+4>>2]=0;U=tT(q,17)|0;V=462812;W=U+17|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));z5(-215,q,462830,461802,1864)}r=f[J>>2]|0;if(!((e|0)==(f[r>>2]|0)?(T|0)==(f[r+4>>2]|0):0)){f[q>>2]=0;f[q+4>>2]=0;U=tT(q,17)|0;V=462847;W=U+17|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));z5(-215,q,462830,461802,1865)}q=0-a|0;if((a|0)>(q|0)){V=(t|0)>1;U=(t|0)==2;W=f[N>>2]|0;r=f[S>>2]|0;T=f[z>>2]|0;e=f[D>>2]|0;x=f[G>>2]|0;v=f[K>>2]|0;E=(d|0)>0;P=0;X=q;while(1){Z=X;X=X+d|0;_=q;$=P;do{if(E){aa=_+d|0;ba=f[B>>2]|0;ca=f[I>>2]|0;da=0.0;ea=0.0;fa=0.0;ga=0;ha=Z;while(1){ia=+(ha|0);ja=ia*j*k;ka=ia*i*k;if(V){la=_;ia=da;ma=ea;na=fa;oa=ga;while(1){pa=mrc(ja+ +(la|0)*i*k+h)|0;qa=mrc(ka+ +(0-la|0)*j*k+g)|0;do if((pa|0)<0){ra=ia;sa=oa;ta=ma;ua=na}else{if(!((qa|0)>-1&(pa|0)<(ba|0)&(qa|0)<(ca|0))){ra=ia;sa=oa;ta=ma;ua=na;break}va=W+(Y(f[r>>2]|0,pa)|0)+(qa<<2)|0;wa=T+(Y(f[e>>2]|0,pa)|0)+(qa<<2)|0;xa=+n[wa>>2];wa=x+(Y(f[v>>2]|0,pa)|0)+(qa<<2)|0;ya=+n[wa>>2];if(U){za=na;Aa=+M(+(xa*xa+ya*ya))}else{za=na+(xa*i+ya*j);Aa=ya*i-xa*j}ra=ia+ +n[va>>2];sa=oa+1|0;ta=ma+Aa;ua=za}while(0);la=la+1|0;if((la|0)>=(aa|0)){Ba=ra;Ca=ta;Da=ua;Ea=sa;break}else{ia=ra;ma=ta;na=ua;oa=sa}}}else{oa=_;na=da;la=ga;while(1){qa=mrc(ja+ +(oa|0)*i*k+h)|0;pa=mrc(ka+ +(0-oa|0)*j*k+g)|0;do if((qa|0)<0){Fa=na;Ga=la}else{if(!((pa|0)>-1&(qa|0)<(ba|0)&(pa|0)<(ca|0))){Fa=na;Ga=la;break}va=W+(Y(f[r>>2]|0,qa)|0)+(pa<<2)|0;Fa=na+ +n[va>>2];Ga=la+1|0}while(0);oa=oa+1|0;if((oa|0)>=(aa|0)){Ba=Fa;Ca=ea;Da=fa;Ea=Ga;break}else{na=Fa;la=Ga}}}ha=ha+1|0;if((ha|0)>=(X|0))break;else{da=Ba;ea=Ca;fa=Da;ga=Ea}}if((Ea|0)>0){fa=1.0/+(Ea|0);Ha=fa*Ba;Ia=Ca*fa;Ja=Da*fa}else{Ha=Ba;Ia=Ca;Ja=Da}}else{Ha=0.0;Ia=0.0;Ja=0.0}n[c+($<<2)>>2]=Ha;if(V?(n[c+($+1<<2)>>2]=Ia,!U):0)n[c+($+2<<2)>>2]=Ja;$=$+t|0;_=_+d|0}while((_|0)<(a|0));if((X|0)>=(a|0))break;else P=$}}P=f[O>>2]|0;if(P|0?(a=P+12|0,P=f[a>>2]|0,f[a>>2]=P+-1,(P|0)==1):0)_S(p);f[O>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[L>>2]|0)>0){N=f[Q>>2]|0;Q=0;do{f[N+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[L>>2]|0))}L=f[S>>2]|0;if((L|0)!=(R|0))g0(L);L=f[H>>2]|0;if(L|0?(R=L+12|0,L=f[R>>2]|0,f[R>>2]=L+-1,(L|0)==1):0)_S(o);f[H>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[s>>2]|0)>0){G=f[J>>2]|0;J=0;do{f[G+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[s>>2]|0))}s=f[K>>2]|0;if((s|0)!=(F|0))g0(s);s=f[A>>2]|0;if(s|0?(F=s+12|0,s=f[F>>2]|0,f[F>>2]=s+-1,(s|0)==1):0)_S(m);f[A>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[w>>2]|0)>0){z=f[C>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[w>>2]|0))}w=f[D>>2]|0;if((w|0)==(y|0)){u=l;return}g0(w);u=l;return}function TJb(a){a=a|0;JJb(a);YDc(a);return}function UJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;VJb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function VJb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0;g=u;u=u+544|0;i=g+480|0;j=g+424|0;k=g+368|0;l=g+20|0;m=g+8|0;o=g;p=f[a+16>>2]|0;q=f[a+12>>2]|0;r=+(1<<f[c+20>>2]|0);s=mrc(+n[c+8>>2]*.5/r)|0;t=f[c+24>>2]|0;v=f[q>>2]|0;w=v+(t*316|0)|0;f[i>>2]=f[w>>2];x=i+4|0;y=v+(t*316|0)+4|0;f[x>>2]=f[y>>2];z=i+8|0;f[z>>2]=f[v+(t*316|0)+8>>2];f[i+12>>2]=f[v+(t*316|0)+12>>2];A=i+16|0;f[A>>2]=f[v+(t*316|0)+16>>2];f[i+20>>2]=f[v+(t*316|0)+20>>2];f[i+24>>2]=f[v+(t*316|0)+24>>2];f[i+28>>2]=f[v+(t*316|0)+28>>2];f[i+32>>2]=f[v+(t*316|0)+32>>2];B=i+36|0;C=f[v+(t*316|0)+36>>2]|0;f[B>>2]=C;D=i+40|0;f[D>>2]=z;z=i+48|0;E=i+44|0;f[E>>2]=z;f[z>>2]=0;f[i+52>>2]=0;if(C|0){F=C+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[y>>2]|0)<3){y=f[v+(t*316|0)+44>>2]|0;v=f[E>>2]|0;f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2]}else{f[x>>2]=0;ZS(i,w)}w=f[q>>2]|0;y=w+(t*316|0)+56|0;f[j>>2]=f[y>>2];v=j+4|0;F=w+(t*316|0)+60|0;C=f[F>>2]|0;f[v>>2]=C;G=j+8|0;f[G>>2]=f[w+(t*316|0)+64>>2];f[j+12>>2]=f[w+(t*316|0)+68>>2];H=j+16|0;f[H>>2]=f[w+(t*316|0)+72>>2];f[j+20>>2]=f[w+(t*316|0)+76>>2];f[j+24>>2]=f[w+(t*316|0)+80>>2];f[j+28>>2]=f[w+(t*316|0)+84>>2];f[j+32>>2]=f[w+(t*316|0)+88>>2];I=j+36|0;J=f[w+(t*316|0)+92>>2]|0;f[I>>2]=J;K=j+40|0;f[K>>2]=G;G=j+48|0;L=j+44|0;f[L>>2]=G;f[G>>2]=0;f[j+52>>2]=0;if(!J)N=C;else{C=J+12|0;f[C>>2]=(f[C>>2]|0)+1;N=f[F>>2]|0}if((N|0)<3){N=f[w+(t*316|0)+100>>2]|0;w=f[L>>2]|0;f[w>>2]=f[N>>2];f[w+4>>2]=f[N+4>>2]}else{f[v>>2]=0;ZS(j,y)}y=f[q>>2]|0;q=y+(t*316|0)+112|0;f[k>>2]=f[q>>2];N=k+4|0;w=y+(t*316|0)+116|0;F=f[w>>2]|0;f[N>>2]=F;C=k+8|0;f[C>>2]=f[y+(t*316|0)+120>>2];J=k+12|0;f[J>>2]=f[y+(t*316|0)+124>>2];O=k+16|0;f[O>>2]=f[y+(t*316|0)+128>>2];f[k+20>>2]=f[y+(t*316|0)+132>>2];f[k+24>>2]=f[y+(t*316|0)+136>>2];f[k+28>>2]=f[y+(t*316|0)+140>>2];f[k+32>>2]=f[y+(t*316|0)+144>>2];P=k+36|0;Q=f[y+(t*316|0)+148>>2]|0;f[P>>2]=Q;R=k+40|0;f[R>>2]=C;S=k+48|0;T=k+44|0;f[T>>2]=S;f[S>>2]=0;f[k+52>>2]=0;if(!Q)U=F;else{F=Q+12|0;f[F>>2]=(f[F>>2]|0)+1;U=f[w>>2]|0}if((U|0)<3){U=f[y+(t*316|0)+156>>2]|0;t=f[T>>2]|0;f[t>>2]=f[U>>2];f[t+4>>2]=f[U+4>>2]}else{f[N>>2]=0;ZS(k,q)}V=+n[c+4>>2]/r;W=+n[c>>2]/r;c=f[p+48>>2]|0;if((c|0)>=4){f[l>>2]=0;f[l+4>>2]=0;X=tT(l,24)|0;Z=462511;_=X+24|0;do{b[X>>0]=b[Z>>0]|0;X=X+1|0;Z=Z+1|0}while((X|0)<(_|0));z5(-215,l,462901,461802,2127)}XIc(l|0,0,348)|0;q=f[p+52>>2]|0;if(q&1|0){f[m>>2]=0;f[m+4>>2]=0;X=tT(m,23)|0;Z=462563;_=X+23|0;do{b[X>>0]=b[Z>>0]|0;X=X+1|0;Z=Z+1|0}while((X|0)<(_|0));z5(-215,m,462901,461802,2131)}f[m>>2]=q;f[m+4>>2]=(((q<<1)+2|0)>>>0)/3|0;f[m+8>>2]=(q+1|0)>>>1;q=f[a+28>>2]|0;a:do if((q|0)>0){p=f[a+36>>2]|0;U=f[f[a+64>>2]>>2]|0;t=f[J>>2]|0;y=f[C>>2]|0;w=f[O>>2]|0;F=f[T>>2]|0;Q=f[A>>2]|0;$=f[E>>2]|0;aa=f[H>>2]|0;ba=f[L>>2]|0;ca=0;while(1){da=p+(Y(U,ca)|0)|0;ea=f[da>>2]|0;if(ea>>>0>=3)break;fa=f[m+(ea<<2)>>2]|0;if((fa|0)>0){ea=f[da+4>>2]|0;ga=f[da+8>>2]|0;da=ea+fa|0;ha=ga+fa|0;r=0.0;ia=0.0;fa=ea;ja=0.0;ea=c;while(1){ka=mrc(W+ +(Y(fa,s)|0))|0;if((ka|0)<(t|0)){la=ga;ma=ia;na=ja;oa=r;pa=ea;while(1){qa=mrc(V+ +(Y(la,s)|0))|0;b:do if((ka|qa|0)>-1&(qa|0)<(y|0)){ra=w+(Y(f[F>>2]|0,qa)|0)+(ka<<2)|0;sa=oa+ +n[ra>>2];if((pa|0)<=1){ta=sa;ua=ma;va=na;wa=pa;break}ra=Q+(Y(f[$>>2]|0,qa)|0)+(ka<<2)|0;xa=+n[ra>>2];ra=aa+(Y(f[ba>>2]|0,qa)|0)+(ka<<2)|0;ya=+n[ra>>2];switch(pa|0){case 2:{ta=sa;ua=ma+ +M(+(xa*xa+ya*ya));va=na;wa=2;break b;break}case 3:{ta=sa;ua=ma+xa;va=na+ya;wa=3;break b;break}default:{ta=sa;ua=ma;va=na;wa=pa;break b}}}else{ta=oa;ua=ma;va=na;wa=pa}while(0);la=la+1|0;if((la|0)>=(ha|0)){za=wa;Aa=va;Ba=ua;Ca=ta;break}else{ma=ua;na=va;oa=ta;pa=wa}}}else{za=ea;Aa=ja;Ba=ia;Ca=r}fa=fa+1|0;if((fa|0)>=(da|0)){Da=Ca;Ea=Ba;Fa=Aa;break}else{r=Ca;ia=Ba;ja=Aa;ea=za}}}else{Da=0.0;Ea=0.0;Fa=0.0}ea=l+((Y(ca,c)|0)<<2)|0;n[ea>>2]=Da;switch(c|0){case 2:{Ga=Ea;Ha=1;Ia=37;break}case 3:{n[ea+4>>2]=Ea;Ga=Fa;Ha=2;Ia=37;break}default:{}}if((Ia|0)==37){Ia=0;n[ea+(Ha<<2)>>2]=Ga}ca=ca+1|0;if((ca|0)>=(q|0))break a}f[o>>2]=0;f[o+4>>2]=0;X=tT(o,31)|0;Z=462587;_=X+31|0;do{b[X>>0]=b[Z>>0]|0;X=X+1|0;Z=Z+1|0}while((X|0)<(_|0));z5(-215,o,462901,461802,2140)}while(0);q=f[a+92>>2]|0;Ha=a+84|0;if((((f[Ha>>2]|0)+7|0)>>>3|0)!=(e|0)){f[o>>2]=0;f[o+4>>2]=0;X=tT(o,43)|0;Z=462619;_=X+43|0;do{b[X>>0]=b[Z>>0]|0;X=X+1|0;Z=Z+1|0}while((X|0)<(_|0));z5(-215,o,462901,461802,2189)}XIc(d|0,0,e|0)|0;e=f[Ha>>2]|0;if((e|0)>0){o=0;Z=e;while(1){e=o<<1;if(+n[l+(f[q+(e<<2)>>2]<<2)>>2]>+n[l+(f[q+((e|1)<<2)>>2]<<2)>>2]){e=d+((o|0)/8|0)|0;b[e>>0]=h[e>>0]|0|1<<(o&7);Ja=f[Ha>>2]|0}else Ja=Z;o=o+1|0;if((o|0)>=(Ja|0))break;else Z=Ja}}Ja=f[P>>2]|0;if(Ja|0?(Z=Ja+12|0,Ja=f[Z>>2]|0,f[Z>>2]=Ja+-1,(Ja|0)==1):0)_S(k);f[P>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[N>>2]|0)>0){O=f[R>>2]|0;R=0;do{f[O+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[N>>2]|0))}N=f[T>>2]|0;if((N|0)!=(S|0))g0(N);N=f[I>>2]|0;if(N|0?(S=N+12|0,N=f[S>>2]|0,f[S>>2]=N+-1,(N|0)==1):0)_S(j);f[I>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[v>>2]|0)>0){H=f[K>>2]|0;K=0;do{f[H+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[v>>2]|0))}v=f[L>>2]|0;if((v|0)!=(G|0))g0(v);v=f[B>>2]|0;if(v|0?(G=v+12|0,v=f[G>>2]|0,f[G>>2]=v+-1,(v|0)==1):0)_S(i);f[B>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[x>>2]|0)>0){A=f[D>>2]|0;D=0;do{f[A+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[x>>2]|0))}x=f[E>>2]|0;if((x|0)==(z|0)){u=g;return}g0(x);u=g;return}function WJb(a){a=a|0;YDc(a);return}function XJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;YJb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function YJb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0;g=u;u=u+384|0;i=g+192|0;j=g+136|0;k=g+80|0;l=g+24|0;m=g+8|0;o=g;p=a+16|0;if((f[(f[p>>2]|0)+48>>2]|0)>=4){f[i>>2]=0;f[i+4>>2]=0;q=tT(i,43)|0;r=462982;s=q+43|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,i,463026,461802,1758)}t=f[a+12>>2]|0;v=+(1<<f[c+20>>2]|0);a=mrc(+n[c+8>>2]*.5/v)|0;w=f[c+24>>2]|0;x=f[t>>2]|0;y=x+(w*316|0)|0;f[j>>2]=f[y>>2];z=j+4|0;A=x+(w*316|0)+4|0;f[z>>2]=f[A>>2];B=j+8|0;f[B>>2]=f[x+(w*316|0)+8>>2];f[j+12>>2]=f[x+(w*316|0)+12>>2];C=j+16|0;f[C>>2]=f[x+(w*316|0)+16>>2];f[j+20>>2]=f[x+(w*316|0)+20>>2];f[j+24>>2]=f[x+(w*316|0)+24>>2];f[j+28>>2]=f[x+(w*316|0)+28>>2];f[j+32>>2]=f[x+(w*316|0)+32>>2];D=j+36|0;E=f[x+(w*316|0)+36>>2]|0;f[D>>2]=E;F=j+40|0;f[F>>2]=B;B=j+48|0;G=j+44|0;f[G>>2]=B;f[B>>2]=0;f[j+52>>2]=0;if(E|0){H=E+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[A>>2]|0)<3){A=f[x+(w*316|0)+44>>2]|0;x=f[G>>2]|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2]}else{f[z>>2]=0;ZS(j,y)}y=f[t>>2]|0;A=y+(w*316|0)+56|0;f[k>>2]=f[A>>2];x=k+4|0;H=y+(w*316|0)+60|0;E=f[H>>2]|0;f[x>>2]=E;I=k+8|0;f[I>>2]=f[y+(w*316|0)+64>>2];f[k+12>>2]=f[y+(w*316|0)+68>>2];J=k+16|0;f[J>>2]=f[y+(w*316|0)+72>>2];f[k+20>>2]=f[y+(w*316|0)+76>>2];f[k+24>>2]=f[y+(w*316|0)+80>>2];f[k+28>>2]=f[y+(w*316|0)+84>>2];f[k+32>>2]=f[y+(w*316|0)+88>>2];K=k+36|0;L=f[y+(w*316|0)+92>>2]|0;f[K>>2]=L;M=k+40|0;f[M>>2]=I;I=k+48|0;N=k+44|0;f[N>>2]=I;f[I>>2]=0;f[k+52>>2]=0;if(!L)O=E;else{E=L+12|0;f[E>>2]=(f[E>>2]|0)+1;O=f[H>>2]|0}if((O|0)<3){O=f[y+(w*316|0)+100>>2]|0;y=f[N>>2]|0;f[y>>2]=f[O>>2];f[y+4>>2]=f[O+4>>2]}else{f[x>>2]=0;ZS(k,A)}A=f[t>>2]|0;t=A+(w*316|0)+112|0;f[l>>2]=f[t>>2];O=l+4|0;y=A+(w*316|0)+116|0;H=f[y>>2]|0;f[O>>2]=H;E=l+8|0;f[E>>2]=f[A+(w*316|0)+120>>2];L=l+12|0;f[L>>2]=f[A+(w*316|0)+124>>2];P=l+16|0;f[P>>2]=f[A+(w*316|0)+128>>2];f[l+20>>2]=f[A+(w*316|0)+132>>2];f[l+24>>2]=f[A+(w*316|0)+136>>2];f[l+28>>2]=f[A+(w*316|0)+140>>2];f[l+32>>2]=f[A+(w*316|0)+144>>2];Q=l+36|0;R=f[A+(w*316|0)+148>>2]|0;f[Q>>2]=R;S=l+40|0;f[S>>2]=E;T=l+48|0;U=l+44|0;f[U>>2]=T;f[T>>2]=0;f[l+52>>2]=0;if(!R)V=H;else{H=R+12|0;f[H>>2]=(f[H>>2]|0)+1;V=f[y>>2]|0}if((V|0)<3){V=f[A+(w*316|0)+156>>2]|0;w=f[U>>2]|0;f[w>>2]=f[V>>2];f[w+4>>2]=f[V+4>>2]}else{f[O>>2]=0;ZS(l,t)}W=+n[c+4>>2]/v;X=+n[c>>2]/v;c=f[(f[p>>2]|0)+52>>2]|0;if(c&1|0){f[m>>2]=0;f[m+4>>2]=0;q=tT(m,23)|0;r=462563;s=q+23|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,m,463026,461802,1773)}f[m>>2]=c;f[m+4>>2]=(((c<<1)+2|0)>>>0)/3|0;f[m+8>>2]=(c+1|0)>>>1;XIc(d|0,0,e|0)|0;p=0-c|0;t=(c|0)>(p|0);V=f[P>>2]|0;w=f[U>>2]|0;A=f[C>>2]|0;y=f[G>>2]|0;H=f[J>>2]|0;R=f[N>>2]|0;Z=0;_=0;$=c;aa=15;ba=9;ca=5;da=4;while(1){if(t){ea=($|0)>0;fa=f[E>>2]|0;ga=f[L>>2]|0;ha=0;ia=p;while(1){ja=p;ka=ha;do{if(ea){v=0.0;la=0.0;ma=0.0;na=0;oa=0;while(1){pa=mrc(X+ +(Y(oa+ia|0,a)|0))|0;if((pa|0)>-1&(pa|0)<(ga|0)){qa=0;ra=v;sa=la;ta=ma;ua=na;while(1){va=mrc(W+ +(Y(qa+ja|0,a)|0))|0;if((va|0)>-1&(va|0)<(fa|0)){wa=V+(Y(f[w>>2]|0,va)|0)+(pa<<2)|0;xa=A+(Y(f[y>>2]|0,va)|0)+(pa<<2)|0;ya=H+(Y(f[R>>2]|0,va)|0)+(pa<<2)|0;za=ra+ +n[wa>>2];Aa=sa+ +n[xa>>2];Ba=ta+ +n[ya>>2];Ca=ua+1|0}else{za=ra;Aa=sa;Ba=ta;Ca=ua}qa=qa+1|0;if((qa|0)==($|0)){Da=za;Ea=Aa;Fa=Ba;Ga=Ca;break}else{ra=za;sa=Aa;ta=Ba;ua=Ca}}}else{Da=v;Ea=la;Fa=ma;Ga=na}oa=oa+1|0;if((oa|0)==($|0))break;else{v=Da;la=Ea;ma=Fa;na=Ga}}if((Ga|0)>0){ma=1.0/+(Ga|0);Ha=ma*Da;Ia=Ea*ma;Ja=Fa*ma}else{Ha=Da;Ia=Ea;Ja=Fa}}else{Ha=0.0;Ia=0.0;Ja=0.0}na=i+(ka*3<<2)|0;n[na>>2]=Ha;n[na+4>>2]=Ia;n[na+8>>2]=Ja;ka=ka+1|0;ja=ja+$|0}while((ja|0)<(c|0));ia=ia+$|0;if((ia|0)>=(c|0))break;else ha=ka}}ha=_+2|0;ia=Y(ha,ha)|0;a:do if(!ia)Ka=Z;else{ha=0;fa=Z;ga=ba;while(1){ea=ha;ha=ha+1|0;ja=(ha|0)<(ia|0);if(!ja){Ka=fa;break a}na=i+(ea*3<<2)|0;ma=+n[na>>2];la=+n[na+4>>2];v=+n[na+8>>2];na=ha;ea=fa;while(1){oa=i+(na*3<<2)|0;if(ma>+n[oa>>2]){ua=d+((ea|0)/8|0)|0;b[ua>>0]=h[ua>>0]|0|1<<(ea&7)}ua=ea+1|0;if(la>+n[oa+4>>2]){qa=d+((ua|0)/8|0)|0;b[qa>>0]=h[qa>>0]|0|1<<(ua&7)}ua=ea+2|0;if(v>+n[oa+8>>2]){oa=d+((ua|0)/8|0)|0;b[oa>>0]=h[oa>>0]|0|1<<(ua&7)}na=na+1|0;if((na|0)==(da|0))break;else ea=ea+3|0}ea=fa+ga|0;if(!ja){Ka=ea;break}else{fa=ea;ga=ga+-3|0}}}while(0);ia=_+1|0;if((ia|0)==3)break;ga=da+ca|0;fa=ba+aa|0;Z=Ka;_=ia;$=f[m+(ia<<2)>>2]|0;aa=aa+6|0;ba=fa;ca=ca+2|0;da=ga}if((Ka|0)>(e<<3|0)){f[o>>2]=0;f[o+4>>2]=0;q=tT(o,22)|0;r=463059;s=q+22|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,o,463026,461802,1849)}if(((Ka+7|0)>>>3|0)!=(e|0)){f[o>>2]=0;f[o+4>>2]=0;q=tT(o,30)|0;r=463082;s=q+30|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,o,463026,461802,1850)}o=f[Q>>2]|0;if(o|0?(r=o+12|0,o=f[r>>2]|0,f[r>>2]=o+-1,(o|0)==1):0)_S(l);f[Q>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[O>>2]|0)>0){P=f[S>>2]|0;S=0;do{f[P+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[O>>2]|0))}O=f[U>>2]|0;if((O|0)!=(T|0))g0(O);O=f[K>>2]|0;if(O|0?(T=O+12|0,O=f[T>>2]|0,f[T>>2]=O+-1,(O|0)==1):0)_S(k);f[K>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[x>>2]|0)>0){J=f[M>>2]|0;M=0;do{f[J+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[x>>2]|0))}x=f[N>>2]|0;if((x|0)!=(I|0))g0(x);x=f[D>>2]|0;if(x|0?(I=x+12|0,x=f[I>>2]|0,f[I>>2]=x+-1,(x|0)==1):0)_S(j);f[D>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[z>>2]|0)>0){C=f[F>>2]|0;F=0;do{f[C+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[z>>2]|0))}z=f[G>>2]|0;if((z|0)==(B|0)){u=g;return}g0(z);u=g;return}function ZJb(a){a=a|0;YDc(a);return}function _Jb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;$Jb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function $Jb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0,X=0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;g=u;u=u+112|0;h=g+56|0;i=g;if((e|0)!=64){f[h>>2]=0;f[h+4>>2]=0;e=tT(h,18)|0;j=463157;k=e+18|0;do{b[e>>0]=b[j>>0]|0;e=e+1|0;j=j+1|0}while((e|0)<(k|0));z5(-215,h,463176,461802,1620)}j=f[a+12>>2]|0;l=+(1<<f[c+20>>2]|0);a=mrc(+n[c+8>>2]*.5/l)|0;m=+n[c+12>>2]*.01745329238474369;e=f[c+24>>2]|0;k=f[j>>2]|0;o=k+(e*316|0)|0;f[h>>2]=f[o>>2];p=h+4|0;q=k+(e*316|0)+4|0;f[p>>2]=f[q>>2];r=h+8|0;f[r>>2]=f[k+(e*316|0)+8>>2];s=h+12|0;f[s>>2]=f[k+(e*316|0)+12>>2];t=h+16|0;f[t>>2]=f[k+(e*316|0)+16>>2];f[h+20>>2]=f[k+(e*316|0)+20>>2];f[h+24>>2]=f[k+(e*316|0)+24>>2];f[h+28>>2]=f[k+(e*316|0)+28>>2];f[h+32>>2]=f[k+(e*316|0)+32>>2];v=h+36|0;w=f[k+(e*316|0)+36>>2]|0;f[v>>2]=w;x=h+40|0;f[x>>2]=r;y=h+48|0;z=h+44|0;f[z>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(w|0){A=w+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[q>>2]|0)<3){q=f[k+(e*316|0)+44>>2]|0;k=f[z>>2]|0;f[k>>2]=f[q>>2];f[k+4>>2]=f[q+4>>2]}else{f[p>>2]=0;ZS(h,o)}o=f[j>>2]|0;j=o+(e*316|0)+56|0;f[i>>2]=f[j>>2];q=i+4|0;k=o+(e*316|0)+60|0;A=f[k>>2]|0;f[q>>2]=A;w=i+8|0;f[w>>2]=f[o+(e*316|0)+64>>2];f[i+12>>2]=f[o+(e*316|0)+68>>2];B=i+16|0;f[B>>2]=f[o+(e*316|0)+72>>2];f[i+20>>2]=f[o+(e*316|0)+76>>2];f[i+24>>2]=f[o+(e*316|0)+80>>2];f[i+28>>2]=f[o+(e*316|0)+84>>2];f[i+32>>2]=f[o+(e*316|0)+88>>2];C=i+36|0;D=f[o+(e*316|0)+92>>2]|0;f[C>>2]=D;E=i+40|0;f[E>>2]=w;w=i+48|0;F=i+44|0;f[F>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(!D)G=A;else{A=D+12|0;f[A>>2]=(f[A>>2]|0)+1;G=f[k>>2]|0}if((G|0)<3){G=f[o+(e*316|0)+100>>2]|0;e=f[F>>2]|0;f[e>>2]=f[G>>2];f[e+4>>2]=f[G+4>>2]}else{f[q>>2]=0;ZS(i,j)}H=+n[c+4>>2]/l;I=+n[c>>2]/l;l=+O(+m);J=+P(+m);c=0-a|0;m=+(a|0)*2.5;K=m*(m*2.0);j=f[t>>2]|0;G=f[z>>2]|0;e=f[B>>2]|0;o=f[F>>2]|0;k=f[s>>2]|0;s=f[r>>2]|0;m=-.5;r=0;A=-8;N=0.0;while(1){D=A+-4|0;m=m+1.0;Q=+(Y(A+1|0,a)|0);R=l*Q;S=J*Q;Q=m+-2.0;T=Q*Q;U=A+4|0;Q=-.5;W=-8;X=r;Z=N;while(1){_=W+-4|0;$=I+(R+J*+(Y(a,~W)|0));aa=H+(S+l*+(Y(W+1|0,a)|0));ba=W+4|0;ca=D;da=0.0;ea=0.0;fa=0.0;ga=0.0;while(1){ha=+(Y(ca,a)|0);ia=J*ha;ja=l*ha;ka=_;ha=da;la=ea;ma=fa;na=ga;while(1){oa=H+(ia+l*+(Y(ka,a)|0));pa=I+(ja+J*+(Y(ka,c)|0));qa=$-pa;ra=aa-oa;sa=+V(+(-(qa*qa+ra*ra)/K));ta=~~oa;ua=ta-(+(ta|0)>oa&1)|0;ta=~~pa;va=ta-(+(ta|0)>pa&1)|0;ta=ua+1|0;wa=va+1|0;if((va|ua|0)>-1&(wa|0)<(k|0)&(ta|0)<(s|0)){ra=pa-+(va|0);pa=oa-+(ua|0);xa=f[G>>2]|0;ya=j+(Y(xa,ua)|0)|0;za=j+(Y(xa,ta)|0)|0;oa=1.0-ra;qa=1.0-pa;Aa=oa*qa;Ba=ra*qa;qa=pa*oa;oa=ra*pa;pa=Aa*+n[ya+(va<<2)>>2]+Ba*+n[ya+(wa<<2)>>2]+qa*+n[za+(va<<2)>>2]+oa*+n[za+(wa<<2)>>2];za=f[o>>2]|0;ya=e+(Y(za,ua)|0)|0;ua=e+(Y(za,ta)|0)|0;ra=Aa*+n[ya+(va<<2)>>2]+Ba*+n[ya+(wa<<2)>>2]+qa*+n[ua+(va<<2)>>2]+oa*+n[ua+(wa<<2)>>2];oa=sa*(l*pa+J*ra);qa=sa*(l*ra-J*pa);Ca=ha+qa;Da=la+ +L(+oa);Ea=ma+ +L(+qa);Fa=na+oa}else{Ca=ha;Da=la;Ea=ma;Fa=na}if((ka|0)<(ba|0)){ka=ka+1|0;ha=Ca;la=Da;ma=Ea;na=Fa}else break}if((ca|0)<(U|0)){ca=ca+1|0;da=Ca;ea=Da;fa=Ea;ga=Fa}else break}Q=Q+1.0;ga=Q+-2.0;fa=+V(+(-(T+ga*ga)/4.5));n[d+(X<<2)>>2]=Ca*fa;n[d+((X|1)<<2)>>2]=Fa*fa;n[d+((X|2)<<2)>>2]=Ea*fa;n[d+((X|3)<<2)>>2]=Da*fa;Z=Z+fa*((Da*Da+(Ea*Ea+(Fa*Fa+Ca*Ca)))*fa);W=W+5|0;if((W|0)>=12)break;else X=X+4|0}A=A+5|0;if((A|0)>=12)break;else{r=r+16|0;N=Z}}N=1.0/+M(+Z);r=0;do{A=d+(r<<2)|0;n[A>>2]=N*+n[A>>2];r=r+1|0}while((r|0)!=64);r=f[C>>2]|0;if(r|0?(d=r+12|0,r=f[d>>2]|0,f[d>>2]=r+-1,(r|0)==1):0)_S(i);f[C>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[q>>2]|0)>0){B=f[E>>2]|0;E=0;do{f[B+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[q>>2]|0))}q=f[F>>2]|0;if((q|0)!=(w|0))g0(q);q=f[v>>2]|0;if(q|0?(w=q+12|0,q=f[w>>2]|0,f[w>>2]=q+-1,(q|0)==1):0)_S(h);f[v>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[p>>2]|0)>0){t=f[x>>2]|0;x=0;do{f[t+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[p>>2]|0))}p=f[z>>2]|0;if((p|0)==(y|0)){u=g;return}g0(p);u=g;return}function aKb(a){a=a|0;YDc(a);return}function bKb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;cKb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function cKb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0;g=u;u=u+112|0;h=g+56|0;i=g;if((e|0)!=64){f[h>>2]=0;f[h+4>>2]=0;e=tT(h,18)|0;j=463157;k=e+18|0;do{b[e>>0]=b[j>>0]|0;e=e+1|0;j=j+1|0}while((e|0)<(k|0));z5(-215,h,463235,461802,1487)}j=f[a+12>>2]|0;l=+(1<<f[c+20>>2]|0);a=mrc(+n[c+8>>2]*.5/l)|0;e=f[c+24>>2]|0;k=f[j>>2]|0;m=k+(e*316|0)|0;f[h>>2]=f[m>>2];o=h+4|0;p=k+(e*316|0)+4|0;f[o>>2]=f[p>>2];q=h+8|0;f[q>>2]=f[k+(e*316|0)+8>>2];r=h+12|0;f[r>>2]=f[k+(e*316|0)+12>>2];s=h+16|0;f[s>>2]=f[k+(e*316|0)+16>>2];f[h+20>>2]=f[k+(e*316|0)+20>>2];f[h+24>>2]=f[k+(e*316|0)+24>>2];f[h+28>>2]=f[k+(e*316|0)+28>>2];f[h+32>>2]=f[k+(e*316|0)+32>>2];t=h+36|0;v=f[k+(e*316|0)+36>>2]|0;f[t>>2]=v;w=h+40|0;f[w>>2]=q;x=h+48|0;y=h+44|0;f[y>>2]=x;f[x>>2]=0;f[h+52>>2]=0;if(v|0){z=v+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[p>>2]|0)<3){p=f[k+(e*316|0)+44>>2]|0;k=f[y>>2]|0;f[k>>2]=f[p>>2];f[k+4>>2]=f[p+4>>2]}else{f[o>>2]=0;ZS(h,m)}m=f[j>>2]|0;j=m+(e*316|0)+56|0;f[i>>2]=f[j>>2];p=i+4|0;k=m+(e*316|0)+60|0;z=f[k>>2]|0;f[p>>2]=z;v=i+8|0;f[v>>2]=f[m+(e*316|0)+64>>2];f[i+12>>2]=f[m+(e*316|0)+68>>2];A=i+16|0;f[A>>2]=f[m+(e*316|0)+72>>2];f[i+20>>2]=f[m+(e*316|0)+76>>2];f[i+24>>2]=f[m+(e*316|0)+80>>2];f[i+28>>2]=f[m+(e*316|0)+84>>2];f[i+32>>2]=f[m+(e*316|0)+88>>2];B=i+36|0;C=f[m+(e*316|0)+92>>2]|0;f[B>>2]=C;D=i+40|0;f[D>>2]=v;v=i+48|0;E=i+44|0;f[E>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(!C)F=z;else{z=C+12|0;f[z>>2]=(f[z>>2]|0)+1;F=f[k>>2]|0}if((F|0)<3){F=f[m+(e*316|0)+100>>2]|0;e=f[E>>2]|0;f[e>>2]=f[F>>2];f[e+4>>2]=f[F+4>>2]}else{f[p>>2]=0;ZS(i,j)}G=+n[c+4>>2]/l;H=+n[c>>2]/l;l=+(a|0)*2.5;I=l*(l*2.0);c=f[s>>2]|0;j=f[y>>2]|0;F=f[A>>2]|0;e=f[E>>2]|0;m=f[r>>2]|0;r=f[q>>2]|0;l=-.5;q=0;k=-8;J=0.0;while(1){z=k+-4|0;l=l+1.0;K=G+ +(Y(k+1|0,a)|0);N=l+-2.0;O=N*N;C=k+4|0;N=-.5;P=-8;Q=q;R=J;while(1){S=P+-4|0;T=H+ +(Y(P+1|0,a)|0);P=P+5|0;U=z;W=0.0;X=0.0;Z=0.0;_=0.0;while(1){$=G+ +(Y(U,a)|0);aa=K-$;ba=aa*aa;ca=~~$;da=ca-(+(ca|0)>$&1)|0;ca=da+1|0;aa=$-+(da|0);$=1.0-aa;if((ca|0)<(r|0)){ea=S;fa=W;ga=X;ha=Z;ia=_;while(1){ja=H+ +(Y(ea,a)|0);ka=T-ja;la=+V(+(-(ba+ka*ka)/I));ma=~~ja;na=ma-(+(ma|0)>ja&1)|0;ma=na+1|0;if((na|da|0)>-1&(ma|0)<(m|0)){ka=ja-+(na|0);oa=f[j>>2]|0;pa=c+(Y(oa,da)|0)|0;qa=c+(Y(oa,ca)|0)|0;ja=1.0-ka;ra=$*ja;sa=$*ka;ta=aa*ja;ja=aa*ka;oa=f[e>>2]|0;ua=F+(Y(oa,da)|0)|0;va=F+(Y(oa,ca)|0)|0;ka=la*(ra*+n[pa+(na<<2)>>2]+sa*+n[pa+(ma<<2)>>2]+ta*+n[qa+(na<<2)>>2]+ja*+n[qa+(ma<<2)>>2]);wa=la*(ra*+n[ua+(na<<2)>>2]+sa*+n[ua+(ma<<2)>>2]+ta*+n[va+(na<<2)>>2]+ja*+n[va+(ma<<2)>>2]);xa=fa+ka;ya=ga+ +L(+wa);za=ha+ +L(+ka);Aa=ia+wa}else{xa=fa;ya=ga;za=ha;Aa=ia}ea=ea+1|0;if((ea|0)>=(P|0)){Ba=xa;Ca=ya;Da=za;Ea=Aa;break}else{fa=xa;ga=ya;ha=za;ia=Aa}}}else{Ba=W;Ca=X;Da=Z;Ea=_}if((U|0)<(C|0)){U=U+1|0;W=Ba;X=Ca;Z=Da;_=Ea}else break}N=N+1.0;_=N+-2.0;Z=+V(+(-(O+_*_)/4.5));n[d+(Q<<2)>>2]=Ba*Z;n[d+((Q|1)<<2)>>2]=Ea*Z;n[d+((Q|2)<<2)>>2]=Da*Z;n[d+((Q|3)<<2)>>2]=Ca*Z;R=R+Z*((Ca*Ca+(Da*Da+(Ea*Ea+Ba*Ba)))*Z);if((P|0)>=12)break;else Q=Q+4|0}k=k+5|0;if((k|0)>=12)break;else{q=q+16|0;J=R}}J=1.0/+M(+R);q=0;do{k=d+(q<<2)|0;n[k>>2]=J*+n[k>>2];q=q+1|0}while((q|0)!=64);q=f[B>>2]|0;if(q|0?(d=q+12|0,q=f[d>>2]|0,f[d>>2]=q+-1,(q|0)==1):0)_S(i);f[B>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[p>>2]|0)>0){A=f[D>>2]|0;D=0;do{f[A+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[p>>2]|0))}p=f[E>>2]|0;if((p|0)!=(v|0))g0(p);p=f[t>>2]|0;if(p|0?(v=p+12|0,p=f[v>>2]|0,f[v>>2]=p+-1,(p|0)==1):0)_S(h);f[t>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[o>>2]|0)>0){s=f[w>>2]|0;w=0;do{f[s+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[o>>2]|0))}o=f[y>>2]|0;if((o|0)==(x|0)){u=g;return}g0(o);u=g;return}function dKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;XHb(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;tT(a,(f[c>>2]|0)+5|0)|0;g=f[c>>2]|0;if(!g)h=0;else{dJc(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;b[c>>0]=b[463310]|0;b[c+1>>0]=b[463311]|0;b[c+2>>0]=b[463312]|0;b[c+3>>0]=b[463313]|0;b[c+4>>0]=b[463314]|0;uT(e);u=d;return}function eKb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0;j=VDc(24)|0;r0(j);f[j>>2]=112576;b[j+4>>0]=c&1;b[j+5>>0]=d&1;n[j+8>>2]=e;f[j+12>>2]=g;f[j+16>>2]=h;f[j+20>>2]=i;i=VDc(16)|0;h=i+4|0;f[h>>2]=1;f[i>>2]=112696;f[i+8>>2]=j;f[a>>2]=i;f[a+4>>2]=j;f[h>>2]=(f[h>>2]|0)+1;j=f[h>>2]|0;f[h>>2]=j+-1;if((j|0)!=1)return;Yi[f[(f[i>>2]|0)+8>>2]&2047](i);return}function fKb(a){a=a|0;YDc(a);return}function gKb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hKb(a){a=a|0;THb(a);YDc(a);return}function iKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;s0(a,c);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,8)|0;i=g;b[i>>0]=101;b[i+1>>0]=120;b[i+2>>0]=116;b[i+3>>0]=101;i=g+4|0;b[i>>0]=110;b[i+1>>0]=100;b[i+2>>0]=101;b[i+3>>0]=100;i=E_(c,e)|0;uT(e);g=h[a+4>>0]|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](i)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(i,c+12|0,g);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;j=tT(e,7)|0;b[j>>0]=b[463604]|0;b[j+1>>0]=b[463605]|0;b[j+2>>0]=b[463606]|0;b[j+3>>0]=b[463607]|0;b[j+4>>0]=b[463608]|0;b[j+5>>0]=b[463609]|0;b[j+6>>0]=b[463610]|0;j=E_(c,e)|0;uT(e);g=h[a+5>>0]|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,g);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,9)|0;l=467837;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=E_(c,e)|0;uT(e);g=a+8|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](i)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}Q_(i,c+12|0,+n[g>>2]);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;j=tT(e,7)|0;b[j>>0]=b[463612]|0;b[j+1>>0]=b[463613]|0;b[j+2>>0]=b[463614]|0;b[j+3>>0]=b[463615]|0;b[j+4>>0]=b[463616]|0;b[j+5>>0]=b[463617]|0;b[j+6>>0]=b[463618]|0;j=E_(c,e)|0;uT(e);g=a+12|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,f[g>>2]|0);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,9)|0;l=463620;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=E_(c,e)|0;uT(e);g=a+16|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](i)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(i,c+12|0,f[g>>2]|0);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,11)|0;l=463630;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=E_(c,e)|0;uT(e);g=a+20|0;if(!(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0)){u=d;return}a=c+32|0;if((f[a>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,f[g>>2]|0);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function jKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+64|0;e=d+48|0;g=d+40|0;h=d+32|0;i=d+24|0;j=d+16|0;k=d+8|0;l=d;I_(g,c,463595);Y_(g,e,0);b[a+4>>0]=(f[e>>2]|0)!=0&1;I_(h,c,463604);Y_(h,e,0);b[a+5>>0]=(f[e>>2]|0)!=0&1;I_(i,c,467837);Z_(i,e,0.0);f[a+8>>2]=f[e>>2];I_(j,c,463612);Y_(j,e,0);f[a+12>>2]=f[e>>2];I_(k,c,463620);Y_(k,e,0);f[a+16>>2]=f[e>>2];I_(l,c,463630);Y_(l,e,0);f[a+20>>2]=f[e>>2];u=d;return}function kKb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=u;u=u+336|0;j=i+272|0;k=i+216|0;l=i+168|0;m=i+64|0;o=i+8|0;p=i;do if((d$(c)|0)==65536){q=f[c+4>>2]|0;f[j>>2]=f[q>>2];r=j+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];x=j;break}else{f[r>>2]=0;ZS(j,q);x=j;break}}else{a$(j,c,-1);x=j}while(0);q=f[x>>2]|0;if(!(q&4088))y=q;else{q=k+8|0;f[q>>2]=0;f[q+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;Oga(c,k,6,0);y=f[x>>2]|0}f[k>>2]=1124007936;c=k+4|0;q=k+8|0;r=k+40|0;s=c;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;w=k+48|0;v=k+44|0;f[v>>2]=w;f[w>>2]=0;f[k+52>>2]=0;switch(y&7){case 5:{y=j+36|0;z=f[y>>2]|0;if(z){A=z+12|0;f[A>>2]=(f[A>>2]|0)+1;A=k+36|0;z=f[A>>2]|0;if((z|0)!=0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0){_S(k);C=A}else C=A}else C=k+36|0;f[C>>2]=0;A=k+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[c>>2]|0)>0){z=f[r>>2]|0;B=0;do{f[z+(B<<2)>>2]=0;B=B+1|0;D=f[c>>2]|0}while((B|0)<(D|0));f[k>>2]=f[x>>2];if((D|0)<3)E=21;else E=23}else{f[k>>2]=f[x>>2];E=21}if((E|0)==21){x=f[j+4>>2]|0;if((x|0)<3){f[c>>2]=x;f[q>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];x=f[j+44>>2]|0;D=f[v>>2]|0;f[D>>2]=f[x>>2];f[D+4>>2]=f[x+4>>2]}else E=23}if((E|0)==23)ZS(k,j);f[A>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];f[C>>2]=f[y>>2];break}case 0:{y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;LZ(j,l,5,.00392156862745098,0.0);break}case 2:{y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;LZ(j,l,5,1.5259021896696422e-05,0.0);break}default:{}}y=k+16|0;if(!(f[y>>2]|0)){f[l>>2]=0;F=l+4|0;f[F>>2]=0;G=tT(l,17)|0;s=G;H=463395;t=s+17|0;do{b[s>>0]=b[H>>0]|0;s=s+1|0;H=H+1|0}while((s|0)<(t|0));z5(-215,l,463413,463430,127)}C=f[c>>2]|0;if((C|0)<3)I=Y(f[k+12>>2]|0,f[q>>2]|0)|0;else{q=f[r>>2]|0;A=0;E=1;while(1){x=Y(f[q+(A<<2)>>2]|0,E)|0;A=A+1|0;if((A|0)==(C|0)){I=x;break}else E=x}}if((C|0)==0|(I|0)==0){f[l>>2]=0;F=l+4|0;f[F>>2]=0;G=tT(l,17)|0;s=G;H=463395;t=s+17|0;do{b[s>>0]=b[H>>0]|0;s=s+1|0;H=H+1|0}while((s|0)<(t|0));z5(-215,l,463413,463430,127)}n[l+4>>2]=1.600000023841858;n[l+24>>2]=1.0;n[l+32>>2]=.009999999776482582;n[l+36>>2]=.699999988079071;f[l+40>>2]=300;f[l+16>>2]=f[j+12>>2];f[l+20>>2]=f[j+8>>2];b[l+45>>0]=b[a+4>>0]|0;b[l+44>>0]=b[a+5>>0]|0;f[l+28>>2]=f[a+8>>2];f[l+8>>2]=f[a+12>>2];f[l+12>>2]=f[a+16>>2];f[l>>2]=f[a+20>>2];EMb(m,l);IMb(m,k)|0;if(!h)NMb(m,e);if(!(r$(d)|0)){do if((d$(d)|0)==65536){h=f[d+4>>2]|0;f[o>>2]=f[h>>2];l=o+4|0;G=h+4|0;f[l>>2]=f[G>>2];F=o+8|0;f[F>>2]=f[h+8>>2];f[o+12>>2]=f[h+12>>2];f[o+16>>2]=f[h+16>>2];f[o+20>>2]=f[h+20>>2];f[o+24>>2]=f[h+24>>2];f[o+28>>2]=f[h+28>>2];f[o+32>>2]=f[h+32>>2];I=f[h+36>>2]|0;f[o+36>>2]=I;f[o+40>>2]=F;F=o+48|0;C=o+44|0;f[C>>2]=F;f[F>>2]=0;f[o+52>>2]=0;if(I|0){F=I+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[G>>2]|0)<3){G=f[h+44>>2]|0;F=f[C>>2]|0;f[F>>2]=f[G>>2];f[F+4>>2]=f[G+4>>2];break}else{f[l>>2]=0;ZS(o,h);break}}else a$(o,d,-1);while(0);SHb(e,o);d=o+36|0;h=f[d>>2]|0;if(h|0?(l=h+12|0,h=f[l>>2]|0,f[l>>2]=h+-1,(h|0)==1):0)_S(o);f[d>>2]=0;d=o+16|0;h=o+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[h>>2]|0)>0){d=f[o+40>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[o+44>>2]|0;if((h|0)!=(o+48|0))g0(h)}if($$(g)|0){f[o>>2]=1124007936;h=o+4|0;l=o+8|0;d=o+40|0;s=h;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[d>>2]=l;G=o+48|0;F=o+44|0;f[F>>2]=G;f[G>>2]=0;f[o+52>>2]=0;TMb(m,e,o);h_(o,g);if(f[l>>2]|0){g=f[o+12>>2]|0;if((g|0)!=(_i[f[(f[a>>2]|0)+52>>2]&1023](a)|0)){f[p>>2]=0;f[p+4>>2]=0;s=tT(p,45)|0;H=463499;t=s+45|0;do{b[s>>0]=b[H>>0]|0;s=s+1|0;H=H+1|0}while((s|0)<(t|0));z5(-215,p,463413,463430,158)}if(f[l>>2]|0?(l=f[o>>2]|0,(l&4095|0)!=(_i[f[(f[a>>2]|0)+56>>2]&1023](a)|0)):0){f[p>>2]=0;f[p+4>>2]=0;s=tT(p,49)|0;H=463545;t=s+49|0;do{b[s>>0]=b[H>>0]|0;s=s+1|0;H=H+1|0}while((s|0)<(t|0));z5(-215,p,463413,463430,159)}}p=o+36|0;H=f[p>>2]|0;if(H|0?(s=H+12|0,H=f[s>>2]|0,f[s>>2]=H+-1,(H|0)==1):0)_S(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[h>>2]|0)>0){p=f[d>>2]|0;d=0;do{f[p+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[h>>2]|0))}h=f[F>>2]|0;if((h|0)!=(G|0))g0(h)}AKb(m);m=k+36|0;h=f[m>>2]|0;if(h|0?(G=h+12|0,h=f[G>>2]|0,f[G>>2]=h+-1,(h|0)==1):0)_S(k);f[m>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[r>>2]|0;r=0;do{f[y+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[c>>2]|0))}c=f[v>>2]|0;if((c|0)!=(w|0))g0(c);c=j+36|0;w=f[c>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)_S(j);f[c>>2]=0;c=j+16|0;w=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[w>>2]|0)>0){c=f[j+40>>2]|0;v=0;do{f[c+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[j+44>>2]|0;if((w|0)==(j+48|0)){u=i;return}g0(w);u=i;return}function lKb(a){a=a|0;return (b[a+4>>0]|0?128:64)|0}function mKb(a){a=a|0;return 5}function nKb(a){a=a|0;return 4}function oKb(a,c){a=a|0;c=c|0;b[a+4>>0]=c&1;return}function pKb(a){a=a|0;return (b[a+4>>0]|0)!=0|0}function qKb(a,c){a=a|0;c=c|0;b[a+5>>0]=c&1;return}function rKb(a){a=a|0;return (b[a+5>>0]|0)!=0|0}function sKb(a,b){a=a|0;b=+b;n[a+8>>2]=b;return}function tKb(a){a=a|0;return +(+n[a+8>>2])}function uKb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function vKb(a){a=a|0;return f[a+12>>2]|0}function wKb(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function xKb(a){a=a|0;return f[a+16>>2]|0}function yKb(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function zKb(a){a=a|0;return f[a+20>>2]|0}function AKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+92>>2]|0;if(b|0){c=a+96|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=a+80|0;d=f[b>>2]|0;if(d|0){c=a+84|0;e=f[c>>2]|0;if((e|0)==(d|0))g=d;else{h=e;while(1){e=h+-12|0;f[c>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-4-i|0)>>>2)<<2);YDc(i);j=f[c>>2]|0}if((j|0)==(d|0))break;else h=j}g=f[b>>2]|0}YDc(g)}g=a+60|0;b=f[g>>2]|0;if(b|0){j=a+64|0;h=f[j>>2]|0;if((h|0)==(b|0))l=b;else{d=h;while(1){h=d+-12|0;f[j>>2]=h;c=f[h>>2]|0;if(!c)m=h;else{h=d+-8|0;i=f[h>>2]|0;if((i|0)!=(c|0))f[h>>2]=i+(~(((i+-28-c|0)>>>0)/28|0)*28|0);YDc(c);m=f[j>>2]|0}if((m|0)==(b|0))break;else d=m}l=f[g>>2]|0}YDc(l)}l=a+48|0;g=f[l>>2]|0;if(!g)return;m=a+52|0;while(1){a=f[m>>2]|0;if((a|0)==(g|0))break;d=a+-468|0;f[m>>2]=d;BKb(d)}YDc(f[l>>2]|0);return}function BKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+392|0;c=a+428|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+408|0;b=a+396|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+432>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+436>>2]|0;if((b|0)!=(a+440|0))g0(b);b=a+336|0;d=a+372|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+352|0;b=a+340|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+376>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+380>>2]|0;if((b|0)!=(a+384|0))g0(b);b=a+280|0;c=a+316|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+296|0;b=a+284|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+320>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+324>>2]|0;if((b|0)!=(a+328|0))g0(b);b=a+224|0;d=a+260|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+240|0;b=a+228|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+264>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+268>>2]|0;if((b|0)!=(a+272|0))g0(b);b=a+168|0;c=a+204|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+184|0;b=a+172|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+208>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+212>>2]|0;if((b|0)!=(a+216|0))g0(b);b=a+112|0;d=a+148|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+128|0;b=a+116|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+152>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+156>>2]|0;if((b|0)!=(a+160|0))g0(b);b=a+56|0;c=a+92|0;d=f[c>>2]|0;do if(d|0){e=d+12|0;g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)!=1)break;_S(b)}while(0);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;do if(d|0){c=d+12|0;g=f[c>>2]|0;f[c>>2]=g+-1;if((g|0)!=1)break;_S(a)}while(0);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;g=0;do{f[b+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function CKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=112716;b=a+16|0;c=f[b>>2]|0;if(c|0){d=a+20|0;while(1){e=f[d>>2]|0;if((e|0)==(c|0))break;g=e+-48|0;f[d>>2]=g;GQ(g)}YDc(f[b>>2]|0)}mx(a+4|0);j0(a);return}function DKb(a){a=a|0;CKb(a);YDc(a);return}function EKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+16>>2]|0;c=a+20|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-48|0;f[c>>2]=e;GQ(e)}c=f[a+4>>2]|0;b=a+8|0;a=f[b>>2]|0;if((a|0)==(c|0))return;else g=a;do{a=g+-56|0;f[b>>2]=a;e=g+-20|0;d=f[e>>2]|0;if(d|0?(h=d+12|0,d=f[h>>2]|0,f[h>>2]=d+-1,(d|0)==1):0)_S(a);f[e>>2]=0;e=g+-40|0;a=g+-52|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[a>>2]|0)>0){e=f[g+-16>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[g+-12>>2]|0;if((a|0)!=(g+-8|0))g0(a);g=f[b>>2]|0}while((g|0)!=(c|0));return}function FKb(a,b){a=a|0;b=b|0;return}function GKb(a,b){a=a|0;b=b|0;return}function HKb(a){a=a|0;var b=0;if((f[a+4>>2]|0)!=(f[a+8>>2]|0)){b=0;return b|0}b=(f[a+16>>2]|0)==(f[a+20>>2]|0);return b|0}function IKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+128|0;e=d+72|0;g=d+64|0;h=d+60|0;i=d+12|0;j=d+56|0;k=d+52|0;l=d+48|0;m=d+44|0;n=d+40|0;o=d+36|0;p=d+32|0;q=d+28|0;r=d+24|0;s=d+8|0;t=d+4|0;v=d;if((d$(c)|0)==720896){f[i>>2]=0;w=i+4|0;f[w>>2]=0;f[i+8>>2]=0;i$(c,i);f[j>>2]=f[a+20>>2];f[k>>2]=f[i>>2];f[l>>2]=f[w>>2];f[h>>2]=f[j>>2];f[g>>2]=f[k>>2];f[e>>2]=f[l>>2];KKb(a+16|0,h,g,e)|0;l=f[i>>2]|0;if(l|0){while(1){k=f[w>>2]|0;if((k|0)==(l|0))break;j=k+-48|0;f[w>>2]=j;GQ(j)}YDc(f[i>>2]|0)}u=d;return}if((d$(c)|0)==655360){e$(e,c,-1);LKb(i,1,e);GQ(e);f[m>>2]=f[a+20>>2];f[n>>2]=f[i>>2];w=i+4|0;f[o>>2]=f[w>>2];f[h>>2]=f[m>>2];f[g>>2]=f[n>>2];f[e>>2]=f[o>>2];KKb(a+16|0,h,g,e)|0;o=f[i>>2]|0;if(o|0){while(1){n=f[w>>2]|0;if((n|0)==(o|0))break;m=n+-48|0;f[w>>2]=m;GQ(m)}YDc(f[i>>2]|0)}u=d;return}if((d$(c)|0)==327680){f[i>>2]=0;w=i+4|0;f[w>>2]=0;f[i+8>>2]=0;f$(c,i);f[p>>2]=f[a+8>>2];f[q>>2]=f[i>>2];f[r>>2]=f[w>>2];f[h>>2]=f[p>>2];f[g>>2]=f[q>>2];f[e>>2]=f[r>>2];MKb(a+4|0,h,g,e)|0;mx(i);u=d;return}if((d$(c)|0)!=65536){if((d$(c)|0)==655360){u=d;return}if((d$(c)|0)==720896){u=d;return}if((d$(c)|0)==65536){u=d;return}if((d$(c)|0)==327680){u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;r=tT(e,106)|0;q=463658;p=r+106|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));NKb(-215,e,463765,553)}}do if((d$(c)|0)==65536){q=f[c+4>>2]|0;f[e>>2]=f[q>>2];r=e+4|0;p=q+4|0;f[r>>2]=f[p>>2];w=e+8|0;f[w>>2]=f[q+8>>2];f[e+12>>2]=f[q+12>>2];f[e+16>>2]=f[q+16>>2];f[e+20>>2]=f[q+20>>2];f[e+24>>2]=f[q+24>>2];f[e+28>>2]=f[q+28>>2];f[e+32>>2]=f[q+32>>2];o=f[q+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=w;w=e+48|0;m=e+44|0;f[m>>2]=w;f[w>>2]=0;f[e+52>>2]=0;if(o|0){w=o+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[p>>2]|0)<3){p=f[q+44>>2]|0;w=f[m>>2]|0;f[w>>2]=f[p>>2];f[w+4>>2]=f[p+4>>2];break}else{f[r>>2]=0;ZS(e,q);break}}else a$(e,c,-1);while(0);qFa(i,1,e);c=e+36|0;q=f[c>>2]|0;if(q|0?(r=q+12|0,q=f[r>>2]|0,f[r>>2]=q+-1,(q|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;q=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[e+40>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[e+44>>2]|0;if((q|0)!=(e+48|0))g0(q);f[s>>2]=f[a+8>>2];f[t>>2]=f[i>>2];f[v>>2]=f[i+4>>2];f[h>>2]=f[s>>2];f[g>>2]=f[t>>2];f[e>>2]=f[v>>2];MKb(a+4|0,h,g,e)|0;mx(i);u=d;return}function JKb(a){a=a|0;return}function KKb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=f[a>>2]|0;i=h;j=(f[b>>2]|0)-i|0;b=h+(((j|0)/48|0)*48|0)|0;h=f[c>>2]|0;k=f[d>>2]|0;d=k-h|0;l=(d|0)/48|0;m=h;n=k;if((d|0)<=0){o=b;u=e;return o|0}d=f[a+8>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((l|0)>((d-r|0)/48|0|0)){s=((r-i|0)/48|0)+l|0;if(s>>>0>89478485)mCc(a);t=(d-i|0)/48|0;i=t<<1;d=t>>>0<44739242?(i>>>0<s>>>0?s:i):89478485;i=(j|0)/48|0;f[g+12>>2]=0;f[g+16>>2]=a+8;do if(d)if(d>>>0>89478485){j=af(8)|0;bEc(j,503977);f[j>>2]=185532;ig(j|0,23696,1627)}else{v=VDc(d*48|0)|0;break}else v=0;while(0);f[g>>2]=v;j=v+(i*48|0)|0;i=g+8|0;f[i>>2]=j;s=g+4|0;f[s>>2]=j;f[g+12>>2]=v+(d*48|0);if((m|0)!=(n|0)){d=h;h=m;v=j;while(1){f[v>>2]=f[h>>2];j=v+4|0;t=h+4|0;f[j>>2]=f[t>>2];w=v+8|0;f[w>>2]=f[h+8>>2];f[v+12>>2]=f[h+12>>2];f[v+16>>2]=f[h+16>>2];f[v+20>>2]=f[h+20>>2];x=f[h+24>>2]|0;f[v+24>>2]=x;f[v+28>>2]=f[h+28>>2];f[v+32>>2]=w;w=v+40|0;y=v+36|0;f[y>>2]=w;f[v+44>>2]=0;f[w>>2]=0;if(x|0){w=x+8|0;f[w>>2]=(f[w>>2]|0)+1}if((f[t>>2]|0)<3){t=f[h+36>>2]|0;w=f[y>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2]}else{f[j>>2]=0;FQ(v,h)}j=(f[i>>2]|0)+48|0;f[i>>2]=j;t=d+48|0;if((t|0)==(n|0))break;else{d=t;h=t;v=j}}}v=RKb(a,g,b)|0;h=f[s>>2]|0;while(1){s=f[i>>2]|0;if((s|0)==(h|0))break;d=s+-48|0;f[i>>2]=d;GQ(d)}i=f[g>>2]|0;if(i|0)YDc(i);o=v;u=e;return o|0}v=r-b|0;r=(v|0)/48|0;do if((l|0)>(r|0)){i=m+(r*48|0)|0;g=i;if((i|0)!=(n|0)){h=g;d=i;i=q;while(1){f[i>>2]=f[d>>2];s=i+4|0;j=d+4|0;f[s>>2]=f[j>>2];t=i+8|0;f[t>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];w=f[d+24>>2]|0;f[i+24>>2]=w;f[i+28>>2]=f[d+28>>2];f[i+32>>2]=t;t=i+40|0;y=i+36|0;f[y>>2]=t;f[i+44>>2]=0;f[t>>2]=0;if(w|0){t=w+8|0;f[t>>2]=(f[t>>2]|0)+1}if((f[j>>2]|0)<3){j=f[d+36>>2]|0;t=f[y>>2]|0;f[t>>2]=f[j>>2];f[t+4>>2]=f[j+4>>2]}else{f[s>>2]=0;FQ(i,d)}s=h+48|0;j=(f[p>>2]|0)+48|0;f[p>>2]=j;if((s|0)==(n|0))break;else{h=s;d=s;i=j}}}if((v|0)>0){z=g;A=f[c>>2]|0;break}else{o=b;u=e;return o|0}}else{z=k;A=m}while(0);QKb(a,b,q,b+(l*48|0)|0);l=z;if((A|0)==(l|0)){o=b;u=e;return o|0}else{B=b;C=A}while(1){if((B|0)!=(C|0)){A=C+24|0;z=f[A>>2]|0;if(z|0){q=z+8|0;f[q>>2]=(f[q>>2]|0)+1}q=B+24|0;z=f[q>>2]|0;if(z|0?(a=z+8|0,z=f[a>>2]|0,f[a>>2]=z+-1,(z|0)==1):0)HQ(B);z=B+4|0;if((f[z>>2]|0)>0){a=f[B+32>>2]|0;m=0;do{f[a+(m<<2)>>2]=0;m=m+1|0;D=f[z>>2]|0}while((m|0)<(D|0));f[q>>2]=0;f[B>>2]=f[C>>2];if((D|0)<3)E=25;else E=27}else{f[q>>2]=0;f[B>>2]=f[C>>2];E=25}if((E|0)==25){E=0;m=f[C+4>>2]|0;if((m|0)<3){f[z>>2]=m;f[B+8>>2]=f[C+8>>2];f[B+12>>2]=f[C+12>>2];m=f[C+36>>2]|0;a=f[B+36>>2]|0;f[a>>2]=f[m>>2];f[a+4>>2]=f[m+4>>2]}else E=27}if((E|0)==27){E=0;FQ(B,C)}f[B+16>>2]=f[C+16>>2];m=B+20|0;if(!(f[m>>2]|0))f[m>>2]=f[C+20>>2];f[q>>2]=f[A>>2];f[B+28>>2]=f[C+28>>2]}C=C+48|0;if((C|0)==(l|0)){o=b;break}else B=B+48|0}u=e;return o|0}function LKb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>89478485)mCc(a);e=VDc(b*48|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*48|0);a=c+4|0;g=c+8|0;h=c+12|0;i=c+16|0;j=c+20|0;k=c+24|0;l=c+28|0;m=c+36|0;n=b;b=e;do{f[b>>2]=f[c>>2];e=b+4|0;f[e>>2]=f[a>>2];o=b+8|0;f[o>>2]=f[g>>2];f[b+12>>2]=f[h>>2];f[b+16>>2]=f[i>>2];f[b+20>>2]=f[j>>2];p=f[k>>2]|0;f[b+24>>2]=p;f[b+28>>2]=f[l>>2];f[b+32>>2]=o;o=b+40|0;q=b+36|0;f[q>>2]=o;f[b+44>>2]=0;f[o>>2]=0;if(p|0){o=p+8|0;f[o>>2]=(f[o>>2]|0)+1}if((f[a>>2]|0)<3){o=f[m>>2]|0;p=f[q>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2]}else{f[e>>2]=0;FQ(b,c)}b=(f[d>>2]|0)+48|0;f[d>>2]=b;n=n+-1|0}while((n|0)!=0);return}function MKb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+32|0;g=e;h=f[a>>2]|0;i=h;j=(f[b>>2]|0)-i|0;b=h+(((j|0)/56|0)*56|0)|0;h=f[c>>2]|0;k=f[d>>2]|0;d=k-h|0;l=(d|0)/56|0;m=h;n=k;if((d|0)<=0){o=b;u=e;return o|0}d=f[a+8>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((l|0)>((d-r|0)/56|0|0)){s=((r-i|0)/56|0)+l|0;if(s>>>0>76695844)mCc(a);t=(d-i|0)/56|0;i=t<<1;d=t>>>0<38347922?(i>>>0<s>>>0?s:i):76695844;i=(j|0)/56|0;f[g+12>>2]=0;f[g+16>>2]=a+8;do if(d)if(d>>>0>76695844){j=af(8)|0;bEc(j,503977);f[j>>2]=185532;ig(j|0,23696,1627)}else{v=VDc(d*56|0)|0;break}else v=0;while(0);f[g>>2]=v;j=v+(i*56|0)|0;i=g+8|0;f[i>>2]=j;f[g+4>>2]=j;f[g+12>>2]=v+(d*56|0);if((m|0)!=(n|0)){d=h;h=m;v=j;while(1){f[v>>2]=f[h>>2];j=v+4|0;s=h+4|0;f[j>>2]=f[s>>2];t=v+8|0;f[t>>2]=f[h+8>>2];f[v+12>>2]=f[h+12>>2];f[v+16>>2]=f[h+16>>2];f[v+20>>2]=f[h+20>>2];f[v+24>>2]=f[h+24>>2];f[v+28>>2]=f[h+28>>2];f[v+32>>2]=f[h+32>>2];w=f[h+36>>2]|0;f[v+36>>2]=w;f[v+40>>2]=t;t=v+48|0;x=v+44|0;f[x>>2]=t;f[t>>2]=0;f[v+52>>2]=0;if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[h+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[j>>2]=0;ZS(v,h)}j=(f[i>>2]|0)+56|0;f[i>>2]=j;s=d+56|0;if((s|0)==(n|0))break;else{d=s;h=s;v=j}}}v=PKb(a,g,b)|0;ix(g);o=v;u=e;return o|0}v=r-b|0;r=(v|0)/56|0;do if((l|0)>(r|0)){g=m+(r*56|0)|0;h=g;if((g|0)!=(n|0)){d=h;i=g;g=q;while(1){f[g>>2]=f[i>>2];j=g+4|0;s=i+4|0;f[j>>2]=f[s>>2];t=g+8|0;f[t>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];x=f[i+36>>2]|0;f[g+36>>2]=x;f[g+40>>2]=t;t=g+48|0;w=g+44|0;f[w>>2]=t;f[t>>2]=0;f[g+52>>2]=0;if(x|0){t=x+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[i+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[j>>2]=0;ZS(g,i)}j=d+56|0;s=(f[p>>2]|0)+56|0;f[p>>2]=s;if((j|0)==(n|0))break;else{d=j;i=j;g=s}}}if((v|0)>0){y=h;z=f[c>>2]|0;break}else{o=b;u=e;return o|0}}else{y=k;z=m}while(0);OKb(a,b,q,b+(l*56|0)|0);l=y;if((z|0)==(l|0)){o=b;u=e;return o|0}else{A=b;B=z}while(1){if((A|0)!=(B|0)){z=B+36|0;y=f[z>>2]|0;if(y|0){q=y+12|0;f[q>>2]=(f[q>>2]|0)+1}q=A+36|0;y=f[q>>2]|0;if(y|0?(a=y+12|0,y=f[a>>2]|0,f[a>>2]=y+-1,(y|0)==1):0)_S(A);f[q>>2]=0;y=A+16|0;a=A+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[a>>2]|0)>0){m=f[A+40>>2]|0;k=0;do{f[m+(k<<2)>>2]=0;k=k+1|0;C=f[a>>2]|0}while((k|0)<(C|0));f[A>>2]=f[B>>2];if((C|0)<3)D=25;else D=27}else{f[A>>2]=f[B>>2];D=25}if((D|0)==25){D=0;k=f[B+4>>2]|0;if((k|0)<3){f[a>>2]=k;f[A+8>>2]=f[B+8>>2];f[A+12>>2]=f[B+12>>2];k=f[B+44>>2]|0;m=f[A+44>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2]}else D=27}if((D|0)==27){D=0;ZS(A,B)}f[y>>2]=f[B+16>>2];f[A+20>>2]=f[B+20>>2];f[A+24>>2]=f[B+24>>2];f[A+28>>2]=f[B+28>>2];f[A+32>>2]=f[B+32>>2];f[q>>2]=f[z>>2]}B=B+56|0;if((B|0)==(l|0)){o=b;break}else A=A+56|0}u=e;return o|0}function NKb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,463769,d);return}function OKb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;a=f[e>>2]|0;g=a-d|0;d=b+(((g|0)/56|0)*56|0)|0;if(d>>>0<c>>>0){h=d;i=a;do{f[i>>2]=f[h>>2];j=i+4|0;k=h+4|0;f[j>>2]=f[k>>2];l=i+8|0;f[l>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];f[i+16>>2]=f[h+16>>2];f[i+20>>2]=f[h+20>>2];f[i+24>>2]=f[h+24>>2];f[i+28>>2]=f[h+28>>2];f[i+32>>2]=f[h+32>>2];m=f[h+36>>2]|0;f[i+36>>2]=m;f[i+40>>2]=l;l=i+48|0;n=i+44|0;f[n>>2]=l;f[l>>2]=0;f[i+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[h+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;ZS(i,h)}h=h+56|0;i=(f[e>>2]|0)+56|0;f[e>>2]=i}while(h>>>0<c>>>0)}if(!g)return;else{o=d;p=a}do{a=o;o=o+-56|0;d=p;p=p+-56|0;if((d|0)!=(a|0)){g=a+-20|0;c=f[g>>2]|0;if(c|0){h=c+12|0;f[h>>2]=(f[h>>2]|0)+1}h=d+-20|0;c=f[h>>2]|0;if(c|0?(i=c+12|0,c=f[i>>2]|0,f[i>>2]=c+-1,(c|0)==1):0)_S(p);f[h>>2]=0;c=d+-40|0;i=d+-52|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[i>>2]|0)>0){e=f[d+-16>>2]|0;j=0;do{f[e+(j<<2)>>2]=0;j=j+1|0;q=f[i>>2]|0}while((j|0)<(q|0));f[p>>2]=f[o>>2];if((q|0)<3)r=15;else r=17}else{f[p>>2]=f[o>>2];r=15}if((r|0)==15){r=0;j=f[a+-52>>2]|0;if((j|0)<3){f[i>>2]=j;f[d+-48>>2]=f[a+-48>>2];f[d+-44>>2]=f[a+-44>>2];j=f[a+-12>>2]|0;e=f[d+-12>>2]|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2]}else r=17}if((r|0)==17){r=0;ZS(p,o)}f[c>>2]=f[a+-40>>2];f[d+-36>>2]=f[a+-36>>2];f[d+-32>>2]=f[a+-32>>2];f[d+-28>>2]=f[a+-28>>2];f[d+-24>>2]=f[a+-24>>2];f[h>>2]=f[g>>2]}}while((o|0)!=(b|0));return}function PKb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=b+4|0;e=f[d>>2]|0;g=f[a>>2]|0;if((g|0)==(c|0))h=e;else{i=c;j=e;while(1){k=j+-56|0;l=i;i=i+-56|0;f[k>>2]=f[i>>2];m=j+-52|0;n=l+-52|0;f[m>>2]=f[n>>2];o=j+-48|0;f[o>>2]=f[l+-48>>2];f[j+-44>>2]=f[l+-44>>2];f[j+-40>>2]=f[l+-40>>2];f[j+-36>>2]=f[l+-36>>2];f[j+-32>>2]=f[l+-32>>2];f[j+-28>>2]=f[l+-28>>2];f[j+-24>>2]=f[l+-24>>2];p=f[l+-20>>2]|0;f[j+-20>>2]=p;f[j+-16>>2]=o;o=j+-8|0;q=j+-12|0;f[q>>2]=o;f[o>>2]=0;f[j+-4>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+-12>>2]|0;l=f[q>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2]}else{f[m>>2]=0;ZS(k,i)}k=(f[d>>2]|0)+-56|0;f[d>>2]=k;if((i|0)==(g|0)){h=k;break}else j=k}}j=a+4|0;g=f[j>>2]|0;i=b+8|0;if((g|0)==(c|0)){r=d;s=h;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[j>>2]|0;v=f[i>>2]|0;f[j>>2]=v;f[i>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}h=c;c=f[i>>2]|0;do{f[c>>2]=f[h>>2];k=c+4|0;m=h+4|0;f[k>>2]=f[m>>2];n=c+8|0;f[n>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];f[c+28>>2]=f[h+28>>2];f[c+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[c+36>>2]=l;f[c+40>>2]=n;n=c+48|0;q=c+44|0;f[q>>2]=n;f[n>>2]=0;f[c+52>>2]=0;if(l|0){n=l+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[h+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[k>>2]=0;ZS(c,h)}h=h+56|0;c=(f[i>>2]|0)+56|0;f[i>>2]=c}while((h|0)!=(g|0));r=d;s=f[d>>2]|0;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[j>>2]|0;v=f[i>>2]|0;f[j>>2]=v;f[i>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}function QKb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;a=f[e>>2]|0;g=a-d|0;d=b+(((g|0)/48|0)*48|0)|0;if(d>>>0<c>>>0){h=d;i=a;do{f[i>>2]=f[h>>2];j=i+4|0;k=h+4|0;f[j>>2]=f[k>>2];l=i+8|0;f[l>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];f[i+16>>2]=f[h+16>>2];f[i+20>>2]=f[h+20>>2];m=f[h+24>>2]|0;f[i+24>>2]=m;f[i+28>>2]=f[h+28>>2];f[i+32>>2]=l;l=i+40|0;n=i+36|0;f[n>>2]=l;f[i+44>>2]=0;f[l>>2]=0;if(m|0){l=m+8|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[h+36>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;FQ(i,h)}h=h+48|0;i=(f[e>>2]|0)+48|0;f[e>>2]=i}while(h>>>0<c>>>0)}if(!g)return;else{o=d;p=a}do{a=o;o=o+-48|0;d=p;p=p+-48|0;if((d|0)!=(a|0)){g=a+-24|0;c=f[g>>2]|0;if(c|0){h=c+8|0;f[h>>2]=(f[h>>2]|0)+1}h=d+-24|0;c=f[h>>2]|0;if(c|0?(i=c+8|0,c=f[i>>2]|0,f[i>>2]=c+-1,(c|0)==1):0)HQ(p);c=d+-44|0;if((f[c>>2]|0)>0){i=f[d+-16>>2]|0;e=0;do{f[i+(e<<2)>>2]=0;e=e+1|0;q=f[c>>2]|0}while((e|0)<(q|0));f[h>>2]=0;f[p>>2]=f[o>>2];if((q|0)<3)r=15;else r=17}else{f[h>>2]=0;f[p>>2]=f[o>>2];r=15}if((r|0)==15){r=0;e=f[a+-44>>2]|0;if((e|0)<3){f[c>>2]=e;f[d+-40>>2]=f[a+-40>>2];f[d+-36>>2]=f[a+-36>>2];e=f[a+-12>>2]|0;i=f[d+-12>>2]|0;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2]}else r=17}if((r|0)==17){r=0;FQ(p,o)}f[d+-32>>2]=f[a+-32>>2];e=d+-28|0;if(!(f[e>>2]|0))f[e>>2]=f[a+-28>>2];f[h>>2]=f[g>>2];f[d+-20>>2]=f[a+-20>>2]}}while((o|0)!=(b|0));return}function RKb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=b+4|0;e=f[d>>2]|0;g=f[a>>2]|0;if((g|0)==(c|0))h=e;else{i=c;j=e;while(1){k=j+-48|0;l=i;i=i+-48|0;f[k>>2]=f[i>>2];m=j+-44|0;n=l+-44|0;f[m>>2]=f[n>>2];o=j+-40|0;f[o>>2]=f[l+-40>>2];f[j+-36>>2]=f[l+-36>>2];f[j+-32>>2]=f[l+-32>>2];f[j+-28>>2]=f[l+-28>>2];p=f[l+-24>>2]|0;f[j+-24>>2]=p;f[j+-20>>2]=f[l+-20>>2];f[j+-16>>2]=o;o=j+-8|0;q=j+-12|0;f[q>>2]=o;f[j+-4>>2]=0;f[o>>2]=0;if(p|0){o=p+8|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+-12>>2]|0;l=f[q>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2]}else{f[m>>2]=0;FQ(k,i)}k=(f[d>>2]|0)+-48|0;f[d>>2]=k;if((i|0)==(g|0)){h=k;break}else j=k}}j=a+4|0;g=f[j>>2]|0;i=b+8|0;if((g|0)==(c|0)){r=d;s=h;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[j>>2]|0;v=f[i>>2]|0;f[j>>2]=v;f[i>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}h=c;c=f[i>>2]|0;do{f[c>>2]=f[h>>2];k=c+4|0;m=h+4|0;f[k>>2]=f[m>>2];n=c+8|0;f[n>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];l=f[h+24>>2]|0;f[c+24>>2]=l;f[c+28>>2]=f[h+28>>2];f[c+32>>2]=n;n=c+40|0;q=c+36|0;f[q>>2]=n;f[c+44>>2]=0;f[n>>2]=0;if(l|0){n=l+8|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[h+36>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[k>>2]=0;FQ(c,h)}h=h+48|0;c=(f[i>>2]|0)+48|0;f[i>>2]=c}while((h|0)!=(g|0));r=d;s=f[d>>2]|0;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[j>>2]|0;v=f[i>>2]|0;f[j>>2]=v;f[i>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}function SKb(a){a=a|0;CKb(a);YDc(a);return}function TKb(a){a=a|0;return 1}function UKb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=u;u=u+128|0;g=e+112|0;h=e+56|0;i=e;j=VDc(36)|0;k=f[c+28>>2]|0;l=b[c+32>>0]|0;r0(j);m=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[j>>2]=112780;f[j+28>>2]=k;b[j+32>>0]=l;l=VDc(16)|0;k=l+4|0;f[k>>2]=1;f[l>>2]=112844;f[l+8>>2]=j;n=l;o=j;if(!d?(d=c+4|0,j=c+8|0,g$(m,((f[j>>2]|0)-(f[d>>2]|0)|0)/56|0),c=f[d>>2]|0,d=f[j>>2]|0,(c|0)!=(d|0)):0){j=i+4|0;p=i+8|0;q=i+12|0;r=i+16|0;s=i+20|0;t=i+24|0;v=i+28|0;w=i+32|0;x=i+36|0;y=i+40|0;z=i+48|0;A=i+44|0;B=i+52|0;C=h+36|0;D=h+16|0;E=h+4|0;F=h+40|0;G=h+44|0;H=h+48|0;I=h+8|0;J=h+12|0;K=h+20|0;L=h+24|0;M=h+28|0;N=h+32|0;O=h+52|0;P=g+8|0;Q=g+4|0;R=c;c=f[m>>2]|0;while(1){f[i>>2]=f[R>>2];m=R+4|0;f[j>>2]=f[m>>2];f[p>>2]=f[R+8>>2];f[q>>2]=f[R+12>>2];f[r>>2]=f[R+16>>2];f[s>>2]=f[R+20>>2];f[t>>2]=f[R+24>>2];f[v>>2]=f[R+28>>2];f[w>>2]=f[R+32>>2];S=f[R+36>>2]|0;f[x>>2]=S;f[y>>2]=p;f[A>>2]=z;f[z>>2]=0;f[B>>2]=0;if(S|0){T=S+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[m>>2]|0)<3){m=f[R+44>>2]|0;T=f[A>>2]|0;f[T>>2]=f[m>>2];f[T+4>>2]=f[m+4>>2]}else{f[j>>2]=0;ZS(i,R)}f[h>>2]=1124007936;m=E;T=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(T|0));f[F>>2]=I;f[G>>2]=H;f[H>>2]=0;f[O>>2]=0;m=P;f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=33619968;f[Q>>2]=h;h_(i,g);if((c|0)!=(h|0)){m=f[C>>2]|0;if(m|0){T=m+12|0;f[T>>2]=(f[T>>2]|0)+1}T=c+36|0;m=f[T>>2]|0;if(m|0?(S=m+12|0,m=f[S>>2]|0,f[S>>2]=m+-1,(m|0)==1):0)_S(c);f[T>>2]=0;m=c+16|0;S=c+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[S>>2]|0)>0){U=f[c+40>>2]|0;V=0;do{f[U+(V<<2)>>2]=0;V=V+1|0;W=f[S>>2]|0}while((V|0)<(W|0));f[c>>2]=f[h>>2];if((W|0)<3)X=20;else X=22}else{f[c>>2]=f[h>>2];X=20}if((X|0)==20){X=0;V=f[E>>2]|0;if((V|0)<3){f[S>>2]=V;f[c+8>>2]=f[I>>2];f[c+12>>2]=f[J>>2];V=f[G>>2]|0;U=f[c+44>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else X=22}if((X|0)==22){X=0;ZS(c,h)}f[m>>2]=f[D>>2];f[c+20>>2]=f[K>>2];f[c+24>>2]=f[L>>2];f[c+28>>2]=f[M>>2];f[c+32>>2]=f[N>>2];f[T>>2]=f[C>>2]}V=f[C>>2]|0;if(V|0?(U=V+12|0,V=f[U>>2]|0,f[U>>2]=V+-1,(V|0)==1):0)_S(h);f[C>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[E>>2]|0)>0){V=f[F>>2]|0;U=0;do{f[V+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[E>>2]|0))}U=f[G>>2]|0;if((U|0)!=(H|0))g0(U);U=f[x>>2]|0;if(U|0?(V=U+12|0,U=f[V>>2]|0,f[V>>2]=U+-1,(U|0)==1):0)_S(i);f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){U=f[y>>2]|0;V=0;do{f[U+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[j>>2]|0))}V=f[A>>2]|0;if((V|0)!=(z|0))g0(V);R=R+56|0;if((R|0)==(d|0))break;else c=c+56|0}}f[a>>2]=n;f[a+4>>2]=o;f[k>>2]=(f[k>>2]|0)+1;o=f[k>>2]|0;f[k>>2]=o+-1;if((o|0)!=1){u=e;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=e;return}function VKb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;i=u;u=u+368|0;j=i+344|0;k=i+288|0;l=i+232|0;m=i+176|0;n=i+120|0;o=i+104|0;p=i+88|0;q=i+72|0;r=i+56|0;s=i;t=a+4|0;v=f[t>>2]|0;w=a+8|0;if((v|0)==(f[w>>2]|0))x=f[a+16>>2]|0;else x=v;v=f[x>>2]&4095;if((c$(c,-1)|0)!=(v|0)){f[j>>2]=0;f[j+4>>2]=0;y=tT(j,41)|0;z=463867;A=y+41|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NKb(-215,j,463925,753)}do if(!(r$(c)|0)){if((f[t>>2]|0)==(f[w>>2]|0)?(f[a+16>>2]|0)==(f[a+20>>2]|0):0)break;f[j>>2]=0;v=j+4|0;f[v>>2]=0;f[j+8>>2]=0;f$(g,j);if((f[t>>2]|0)!=(f[w>>2]|0)?(x=a+16|0,B=f[x>>2]|0,C=a+20|0,D=f[C>>2]|0,(B|0)!=(D|0)):0){if((D-B|0)>0){E=k+4|0;F=k+8|0;G=k+40|0;H=k+48|0;I=k+44|0;K=k+52|0;L=l+8|0;M=l+4|0;N=a+12|0;O=k+36|0;P=k+16|0;Q=k+12|0;R=k+20|0;S=k+24|0;T=k+28|0;U=k+32|0;V=0;W=B;do{f[k>>2]=1124007936;y=E;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[G>>2]=F;f[I>>2]=H;f[H>>2]=0;f[K>>2]=0;X=L;f[X>>2]=0;f[X+4>>2]=0;f[l>>2]=33619968;f[M>>2]=k;NQ(W+(V*48|0)|0,l);X=f[w>>2]|0;if((X|0)==(f[N>>2]|0))Bxa(t,k);else{f[X>>2]=f[k>>2];Z=X+4|0;f[Z>>2]=f[E>>2];_=X+8|0;f[_>>2]=f[F>>2];f[X+12>>2]=f[Q>>2];f[X+16>>2]=f[P>>2];f[X+20>>2]=f[R>>2];f[X+24>>2]=f[S>>2];f[X+28>>2]=f[T>>2];f[X+32>>2]=f[U>>2];$=f[O>>2]|0;f[X+36>>2]=$;f[X+40>>2]=_;_=X+48|0;aa=X+44|0;f[aa>>2]=_;f[_>>2]=0;f[X+52>>2]=0;if($|0){_=$+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[E>>2]|0)<3){_=f[I>>2]|0;$=f[aa>>2]|0;f[$>>2]=f[_>>2];f[$+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;ZS(X,k)}f[w>>2]=(f[w>>2]|0)+56}X=f[O>>2]|0;if(X|0?(Z=X+12|0,X=f[Z>>2]|0,f[Z>>2]=X+-1,(X|0)==1):0)_S(k);f[O>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[E>>2]|0)>0){X=f[G>>2]|0;Z=0;do{f[X+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[E>>2]|0))}Z=f[I>>2]|0;if((Z|0)!=(H|0))g0(Z);V=V+1|0;ba=f[C>>2]|0;Z=f[x>>2]|0;W=Z}while((V|0)<((ba-Z|0)/48|0|0));ca=ba;da=W}else{ca=D;da=B}if((ca|0)!=(da|0)){V=ca;do{x=V+-48|0;f[C>>2]=x;GQ(x);V=f[C>>2]|0}while((V|0)!=(da|0))}}do if((d$(c)|0)==65536){V=f[c+4>>2]|0;f[k>>2]=f[V>>2];C=k+4|0;B=V+4|0;f[C>>2]=f[B>>2];D=k+8|0;f[D>>2]=f[V+8>>2];f[k+12>>2]=f[V+12>>2];f[k+16>>2]=f[V+16>>2];f[k+20>>2]=f[V+20>>2];f[k+24>>2]=f[V+24>>2];f[k+28>>2]=f[V+28>>2];f[k+32>>2]=f[V+32>>2];W=f[V+36>>2]|0;f[k+36>>2]=W;f[k+40>>2]=D;D=k+48|0;x=k+44|0;f[x>>2]=D;f[D>>2]=0;f[k+52>>2]=0;if(W|0){D=W+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[B>>2]|0)<3){B=f[V+44>>2]|0;D=f[x>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2];break}else{f[C>>2]=0;ZS(k,V);break}}else a$(k,c,-1);while(0);if((f[t>>2]|0)==(f[w>>2]|0)?(V=a+16|0,C=f[V>>2]|0,B=a+20|0,D=f[B>>2]|0,(C|0)!=(D|0)):0){if((D-C|0)>0){x=l+4|0;W=l+8|0;H=l+40|0;I=l+48|0;E=l+44|0;G=l+52|0;P=m+8|0;O=m+4|0;U=a+12|0;T=l+36|0;S=l+16|0;R=l+12|0;Q=l+20|0;F=l+24|0;N=l+28|0;M=l+32|0;L=0;K=C;do{f[l>>2]=1124007936;y=x;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[H>>2]=W;f[E>>2]=I;f[I>>2]=0;f[G>>2]=0;Z=P;f[Z>>2]=0;f[Z+4>>2]=0;f[m>>2]=33619968;f[O>>2]=l;NQ(K+(L*48|0)|0,m);Z=f[w>>2]|0;if((Z|0)==(f[U>>2]|0))Bxa(t,l);else{f[Z>>2]=f[l>>2];X=Z+4|0;f[X>>2]=f[x>>2];_=Z+8|0;f[_>>2]=f[W>>2];f[Z+12>>2]=f[R>>2];f[Z+16>>2]=f[S>>2];f[Z+20>>2]=f[Q>>2];f[Z+24>>2]=f[F>>2];f[Z+28>>2]=f[N>>2];f[Z+32>>2]=f[M>>2];$=f[T>>2]|0;f[Z+36>>2]=$;f[Z+40>>2]=_;_=Z+48|0;aa=Z+44|0;f[aa>>2]=_;f[_>>2]=0;f[Z+52>>2]=0;if($|0){_=$+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[x>>2]|0)<3){_=f[E>>2]|0;$=f[aa>>2]|0;f[$>>2]=f[_>>2];f[$+4>>2]=f[_+4>>2]}else{f[X>>2]=0;ZS(Z,l)}f[w>>2]=(f[w>>2]|0)+56}Z=f[T>>2]|0;if(Z|0?(X=Z+12|0,Z=f[X>>2]|0,f[X>>2]=Z+-1,(Z|0)==1):0)_S(l);f[T>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[x>>2]|0)>0){Z=f[H>>2]|0;X=0;do{f[Z+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[x>>2]|0))}X=f[E>>2]|0;if((X|0)!=(I|0))g0(X);L=L+1|0;ea=f[B>>2]|0;X=f[V>>2]|0;K=X}while((L|0)<((ea-X|0)/48|0|0));fa=ea;ga=K}else{fa=D;ga=C}if((fa|0)!=(ga|0)){L=fa;do{V=L+-48|0;f[B>>2]=V;GQ(V);L=f[B>>2]|0}while((L|0)!=(ga|0))}}L=k+8|0;aLb(d,f[L>>2]|0);f[l>>2]=1124007936;B=l+4|0;C=l+8|0;D=l+40|0;y=B;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[D>>2]=C;K=l+48|0;V=l+44|0;f[V>>2]=K;f[K>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;I=m+4|0;E=m+8|0;x=m+40|0;y=I;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[x>>2]=E;H=m+48|0;S=m+44|0;f[S>>2]=H;f[H>>2]=0;f[m+52>>2]=0;T=f[t>>2]|0;M=(f[w>>2]|0)-T|0;N=(M|0)/56|0;F=a+28|0;Q=T;switch(f[F>>2]|0){case 7:case 6:{ha=1;break}case 2:{ha=(f[k>>2]&4095|0)==0;break}default:ha=0}T=ha?4:5;R=jJc(N|0,((N|0)<0)<<31>>31|0,18)|0;W=J;if(!((W|0)<0|(W|0)==0&R>>>0<2147483647)){f[n>>2]=0;f[n+4>>2]=0;y=tT(n,36)|0;z=463938;A=y+36|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NKb(-215,n,463925,848)}a:do if((M|0)>0){E=n+8|0;R=n+12|0;W=n+4|0;U=o+8|0;O=o+12|0;P=o+4|0;G=p+8|0;X=p+4|0;Z=q+8|0;_=q+4|0;$=s+4|0;aa=s+8|0;ia=s+40|0;ja=s+48|0;ka=s+44|0;la=s+52|0;ma=r+8|0;na=r+12|0;oa=r+4|0;pa=a+32|0;qa=s+36|0;ra=s+16|0;sa=s+12|0;ta=s+20|0;ua=s+24|0;va=s+28|0;wa=s+32|0;if((f[Q+8>>2]|0)<262144){xa=0;ya=0;za=Q}else{f[n>>2]=0;Aa=n+4|0;f[Aa>>2]=0;Ba=tT(n,43)|0;y=Ba;z=463975;A=y+43|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NKb(-215,n,463925,852)}while(1){f[E>>2]=0;f[R>>2]=0;f[n>>2]=16842752;f[W>>2]=k;f[U>>2]=0;f[O>>2]=0;f[o>>2]=16842752;f[P>>2]=za+(ya*56|0);Ca=G;f[Ca>>2]=0;f[Ca+4>>2]=0;f[p>>2]=33619968;f[X>>2]=l;Ca=Z;f[Ca>>2]=0;f[Ca+4>>2]=0;f[q>>2]=33619968;f[_>>2]=m;Ca=f[F>>2]|0;Da=f[j>>2]|0;do if((Da|0)!=(f[v>>2]|0)){Ea=Da+(ya*56|0)|0;f[s>>2]=f[Ea>>2];Fa=Da+(ya*56|0)+4|0;f[$>>2]=f[Fa>>2];f[aa>>2]=f[Da+(ya*56|0)+8>>2];f[sa>>2]=f[Da+(ya*56|0)+12>>2];f[ra>>2]=f[Da+(ya*56|0)+16>>2];f[ta>>2]=f[Da+(ya*56|0)+20>>2];f[ua>>2]=f[Da+(ya*56|0)+24>>2];f[va>>2]=f[Da+(ya*56|0)+28>>2];f[wa>>2]=f[Da+(ya*56|0)+32>>2];Ga=f[Da+(ya*56|0)+36>>2]|0;f[qa>>2]=Ga;f[ia>>2]=aa;f[ka>>2]=ja;f[ja>>2]=0;f[la>>2]=0;if(Ga|0){Ha=Ga+12|0;f[Ha>>2]=(f[Ha>>2]|0)+1}if((f[Fa>>2]|0)<3){Fa=f[Da+(ya*56|0)+44>>2]|0;Ha=f[ka>>2]|0;f[Ha>>2]=f[Fa>>2];f[Ha+4>>2]=f[Fa+4>>2];break}else{f[$>>2]=0;ZS(s,Ea);break}}else{f[s>>2]=1124007936;y=$;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[ia>>2]=aa;f[ka>>2]=ja;f[ja>>2]=0;f[la>>2]=0}while(0);f[ma>>2]=0;f[na>>2]=0;f[r>>2]=16842752;f[oa>>2]=s;tmc(n,o,p,T,q,Ca,e,r,xa,(b[pa>>0]|0)!=0);Da=f[qa>>2]|0;if(Da|0?(Ea=Da+12|0,Da=f[Ea>>2]|0,f[Ea>>2]=Da+-1,(Da|0)==1):0)_S(s);f[qa>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[$>>2]|0)>0){Da=f[ia>>2]|0;Ea=0;do{f[Da+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[$>>2]|0))}Ea=f[ka>>2]|0;if((Ea|0)!=(ja|0))g0(Ea);ya=ya+1|0;if((ya|0)>=(N|0))break a;za=f[t>>2]|0;if((f[za+(ya*56|0)+8>>2]|0)>=262144)break;else xa=xa+262144|0}f[n>>2]=0;Aa=n+4|0;f[Aa>>2]=0;Ba=tT(n,43)|0;y=Ba;z=463975;A=y+43|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));NKb(-215,n,463925,852)}while(0);if(ha){f[n>>2]=1124007936;N=n+4|0;T=n+8|0;v=n+40|0;y=N;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[v>>2]=T;F=n+48|0;Q=n+44|0;f[Q>>2]=F;f[F>>2]=0;f[n+52>>2]=0;M=o+8|0;f[M>>2]=0;f[M+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=n;LZ(l,o,5,1.0,0.0);M=n+36|0;ja=f[M>>2]|0;if(ja|0){ka=ja+12|0;f[ka>>2]=(f[ka>>2]|0)+1}ka=l+36|0;ja=f[ka>>2]|0;if(ja|0?($=ja+12|0,ja=f[$>>2]|0,f[$>>2]=ja+-1,(ja|0)==1):0)_S(l);f[ka>>2]=0;ja=l+16|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[B>>2]|0)>0){$=f[D>>2]|0;ia=0;do{f[$+(ia<<2)>>2]=0;ia=ia+1|0;Ia=f[B>>2]|0}while((ia|0)<(Ia|0));f[l>>2]=f[n>>2];if((Ia|0)<3)Ja=108;else Ja=110}else{f[l>>2]=f[n>>2];Ja=108}if((Ja|0)==108){ia=f[N>>2]|0;if((ia|0)<3){f[B>>2]=ia;f[C>>2]=f[T>>2];f[l+12>>2]=f[n+12>>2];ia=f[Q>>2]|0;$=f[V>>2]|0;f[$>>2]=f[ia>>2];f[$+4>>2]=f[ia+4>>2]}else Ja=110}if((Ja|0)==110)ZS(l,n);ia=n+16|0;f[ja>>2]=f[ia>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[l+32>>2]=f[n+32>>2];$=f[M>>2]|0;f[ka>>2]=$;if($|0?(ra=$+12|0,$=f[ra>>2]|0,f[ra>>2]=$+-1,($|0)==1):0)_S(n);f[M>>2]=0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[N>>2]|0)>0){ia=f[v>>2]|0;$=0;do{f[ia+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[N>>2]|0))}N=f[Q>>2]|0;if((N|0)!=(F|0))g0(N)}b:do if((f[L>>2]|0)>0){N=l+16|0;$=m+16|0;ia=n+4|0;v=n+8|0;M=d+4|0;ka=d+8|0;ja=m+12|0;T=h^1;C=n+4|0;ra=n+8|0;qa=n+12|0;pa=0;while(1){oa=(f[N>>2]|0)+(Y(f[f[V>>2]>>2]|0,pa)|0)|0;na=(f[$>>2]|0)+(Y(f[f[S>>2]>>2]|0,pa)|0)|0;f[n>>2]=0;f[ia>>2]=0;f[v>>2]=0;Ka=f[M>>2]|0;if((Ka|0)==(f[ka>>2]|0)){bLb(d,n);La=f[n>>2]|0}else{f[Ka>>2]=0;ma=Ka+4|0;f[ma>>2]=0;f[Ka+8>>2]=0;la=f[n>>2]|0;aa=(f[ia>>2]|0)-la|0;wa=aa>>4;if(wa){if(wa>>>0>268435455)break;va=VDc(aa)|0;f[ma>>2]=va;f[Ka>>2]=va;f[Ka+8>>2]=va+(wa<<4);wa=f[n>>2]|0;aa=(f[ia>>2]|0)-wa|0;if((aa|0)>0){dJc(va|0,wa|0,aa|0)|0;f[ma>>2]=va+(aa>>>4<<4);Ma=wa}else Ma=wa}else Ma=la;f[M>>2]=(f[M>>2]|0)+12;La=Ma}if(La|0){la=f[ia>>2]|0;if((la|0)!=(La|0))f[ia>>2]=la+(~((la+-16-La|0)>>>4)<<4);YDc(La)}la=f[M>>2]|0;wa=la+-12|0;cLb(wa,e);aa=la+-8|0;c:do if((f[ja>>2]|0)>0){va=la+-4|0;ma=0;do{ua=f[na+(ma<<2)>>2]|0;if((ua|0)<0)break c;ta=f[oa+(ma<<2)>>2]|0;f[n>>2]=pa;f[C>>2]=ua&262143;f[ra>>2]=ua>>>18;f[qa>>2]=ta;ta=f[aa>>2]|0;if((ta|0)==(f[va>>2]|0))W_(wa,n);else{f[ta>>2]=f[n>>2];f[ta+4>>2]=f[n+4>>2];f[ta+8>>2]=f[n+8>>2];f[ta+12>>2]=f[n+12>>2];f[aa>>2]=(f[aa>>2]|0)+16}ma=ma+1|0}while((ma|0)<(f[ja>>2]|0))}while(0);if(!((f[wa>>2]|0)!=(f[aa>>2]|0)|T)){oa=f[M>>2]|0;na=oa+-12|0;la=oa;while(1){oa=la+-12|0;f[M>>2]=oa;ma=f[oa>>2]|0;if(!ma)Na=oa;else{oa=la+-8|0;va=f[oa>>2]|0;if((va|0)!=(ma|0))f[oa>>2]=va+(~((va+-16-ma|0)>>>4)<<4);YDc(ma);Na=f[M>>2]|0}if((Na|0)==(na|0))break;else la=Na}}pa=pa+1|0;if((pa|0)>=(f[L>>2]|0))break b}mCc(Ka)}while(0);L=m+36|0;F=f[L>>2]|0;if(F|0?(Q=F+12|0,F=f[Q>>2]|0,f[Q>>2]=F+-1,(F|0)==1):0)_S(m);f[L>>2]=0;L=m+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[I>>2]|0)>0){L=f[x>>2]|0;F=0;do{f[L+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[I>>2]|0))}I=f[S>>2]|0;if((I|0)!=(H|0))g0(I);I=l+36|0;F=f[I>>2]|0;if(F|0?(L=F+12|0,F=f[L>>2]|0,f[L>>2]=F+-1,(F|0)==1):0)_S(l);f[I>>2]=0;I=l+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[B>>2]|0)>0){I=f[D>>2]|0;F=0;do{f[I+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[B>>2]|0))}B=f[V>>2]|0;if((B|0)!=(K|0))g0(B);B=k+36|0;F=f[B>>2]|0;do if(F|0){I=F+12|0;D=f[I>>2]|0;f[I>>2]=D+-1;if((D|0)!=1)break;_S(k)}while(0);f[B>>2]=0;F=k+16|0;K=k+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[K>>2]|0)>0){F=f[k+40>>2]|0;V=0;do{f[F+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[K>>2]|0))}K=f[k+44>>2]|0;if((K|0)!=(k+48|0))g0(K);mx(j);u=i;return}while(0);j=f[d>>2]|0;k=d+4|0;d=f[k>>2]|0;if((d|0)==(j|0)){u=i;return}else Oa=d;while(1){d=Oa+-12|0;f[k>>2]=d;l=f[d>>2]|0;if(!l)Pa=d;else{d=Oa+-8|0;m=f[d>>2]|0;if((m|0)!=(l|0))f[d>>2]=m+(~((m+-16-l|0)>>>4)<<4);YDc(l);Pa=f[k>>2]|0}if((Pa|0)==(j|0))break;else Oa=Pa}u=i;return}function WKb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0;i=u;u=u+352|0;j=i;k=i+328|0;l=i+272|0;m=i+216|0;o=i+160|0;p=i+144|0;q=i+128|0;r=i+112|0;s=i+56|0;t=a+4|0;v=f[t>>2]|0;w=a+8|0;if((v|0)==(f[w>>2]|0))x=f[a+16>>2]|0;else x=v;v=f[x>>2]&4095;if((c$(c,-1)|0)!=(v|0)){f[j>>2]=0;f[j+4>>2]=0;y=tT(j,41)|0;v=463867;z=y+41|0;do{b[y>>0]=b[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));NKb(-215,j,463909,904)}do if(!(r$(c)|0)){if((f[t>>2]|0)==(f[w>>2]|0)?(f[a+16>>2]|0)==(f[a+20>>2]|0):0)break;f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;f$(g,k);if((f[t>>2]|0)!=(f[w>>2]|0)?(x=a+16|0,A=f[x>>2]|0,B=a+20|0,C=f[B>>2]|0,(A|0)!=(C|0)):0){if((C-A|0)>0){D=j+4|0;E=j+8|0;F=j+40|0;G=j+48|0;H=j+44|0;I=j+52|0;J=l+8|0;K=l+4|0;L=a+12|0;M=j+36|0;N=j+16|0;O=j+12|0;P=j+20|0;Q=j+24|0;R=j+28|0;S=j+32|0;T=0;U=A;do{f[j>>2]=1124007936;y=D;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[F>>2]=E;f[H>>2]=G;f[G>>2]=0;f[I>>2]=0;V=J;f[V>>2]=0;f[V+4>>2]=0;f[l>>2]=33619968;f[K>>2]=j;NQ(U+(T*48|0)|0,l);V=f[w>>2]|0;if((V|0)==(f[L>>2]|0))Bxa(t,j);else{f[V>>2]=f[j>>2];W=V+4|0;f[W>>2]=f[D>>2];X=V+8|0;f[X>>2]=f[E>>2];f[V+12>>2]=f[O>>2];f[V+16>>2]=f[N>>2];f[V+20>>2]=f[P>>2];f[V+24>>2]=f[Q>>2];f[V+28>>2]=f[R>>2];f[V+32>>2]=f[S>>2];Z=f[M>>2]|0;f[V+36>>2]=Z;f[V+40>>2]=X;X=V+48|0;_=V+44|0;f[_>>2]=X;f[X>>2]=0;f[V+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[D>>2]|0)<3){X=f[H>>2]|0;Z=f[_>>2]|0;f[Z>>2]=f[X>>2];f[Z+4>>2]=f[X+4>>2]}else{f[W>>2]=0;ZS(V,j)}f[w>>2]=(f[w>>2]|0)+56}V=f[M>>2]|0;if(V|0?(W=V+12|0,V=f[W>>2]|0,f[W>>2]=V+-1,(V|0)==1):0)_S(j);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[D>>2]|0)>0){V=f[F>>2]|0;W=0;do{f[V+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[D>>2]|0))}W=f[H>>2]|0;if((W|0)!=(G|0))g0(W);T=T+1|0;$=f[B>>2]|0;W=f[x>>2]|0;U=W}while((T|0)<(($-W|0)/48|0|0));aa=$;ba=U}else{aa=C;ba=A}if((aa|0)!=(ba|0)){T=aa;do{x=T+-48|0;f[B>>2]=x;GQ(x);T=f[B>>2]|0}while((T|0)!=(ba|0))}}do if((d$(c)|0)==65536){T=f[c+4>>2]|0;f[l>>2]=f[T>>2];B=l+4|0;A=T+4|0;f[B>>2]=f[A>>2];C=l+8|0;f[C>>2]=f[T+8>>2];f[l+12>>2]=f[T+12>>2];f[l+16>>2]=f[T+16>>2];f[l+20>>2]=f[T+20>>2];f[l+24>>2]=f[T+24>>2];f[l+28>>2]=f[T+28>>2];f[l+32>>2]=f[T+32>>2];U=f[T+36>>2]|0;f[l+36>>2]=U;f[l+40>>2]=C;C=l+48|0;x=l+44|0;f[x>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(U|0){C=U+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[A>>2]|0)<3){A=f[T+44>>2]|0;C=f[x>>2]|0;f[C>>2]=f[A>>2];f[C+4>>2]=f[A+4>>2];break}else{f[B>>2]=0;ZS(l,T);break}}else a$(l,c,-1);while(0);if((f[t>>2]|0)==(f[w>>2]|0)?(T=a+16|0,B=f[T>>2]|0,A=a+20|0,C=f[A>>2]|0,(B|0)!=(C|0)):0){if((C-B|0)>0){x=j+4|0;U=j+8|0;G=j+40|0;H=j+48|0;D=j+44|0;F=j+52|0;N=m+8|0;M=m+4|0;S=a+12|0;R=j+36|0;Q=j+16|0;P=j+12|0;O=j+20|0;E=j+24|0;L=j+28|0;K=j+32|0;J=0;I=B;do{f[j>>2]=1124007936;y=x;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[G>>2]=U;f[D>>2]=H;f[H>>2]=0;f[F>>2]=0;W=N;f[W>>2]=0;f[W+4>>2]=0;f[m>>2]=33619968;f[M>>2]=j;NQ(I+(J*48|0)|0,m);W=f[w>>2]|0;if((W|0)==(f[S>>2]|0))Bxa(t,j);else{f[W>>2]=f[j>>2];V=W+4|0;f[V>>2]=f[x>>2];X=W+8|0;f[X>>2]=f[U>>2];f[W+12>>2]=f[P>>2];f[W+16>>2]=f[Q>>2];f[W+20>>2]=f[O>>2];f[W+24>>2]=f[E>>2];f[W+28>>2]=f[L>>2];f[W+32>>2]=f[K>>2];Z=f[R>>2]|0;f[W+36>>2]=Z;f[W+40>>2]=X;X=W+48|0;_=W+44|0;f[_>>2]=X;f[X>>2]=0;f[W+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[x>>2]|0)<3){X=f[D>>2]|0;Z=f[_>>2]|0;f[Z>>2]=f[X>>2];f[Z+4>>2]=f[X+4>>2]}else{f[V>>2]=0;ZS(W,j)}f[w>>2]=(f[w>>2]|0)+56}W=f[R>>2]|0;if(W|0?(V=W+12|0,W=f[V>>2]|0,f[V>>2]=W+-1,(W|0)==1):0)_S(j);f[R>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[x>>2]|0)>0){W=f[G>>2]|0;V=0;do{f[W+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[x>>2]|0))}V=f[D>>2]|0;if((V|0)!=(H|0))g0(V);J=J+1|0;ca=f[A>>2]|0;V=f[T>>2]|0;I=V}while((J|0)<((ca-V|0)/48|0|0));da=ca;ea=I}else{da=C;ea=B}if((da|0)!=(ea|0)){J=da;do{T=J+-48|0;f[A>>2]=T;GQ(T);J=f[A>>2]|0}while((J|0)!=(ea|0))}}J=l+8|0;A=f[J>>2]|0;B=d+4|0;C=f[B>>2]|0;I=f[d>>2]|0;T=(C-I|0)/12|0;H=I;I=C;if(A>>>0<=T>>>0){if(A>>>0<T>>>0?(C=H+(A*12|0)|0,(I|0)!=(C|0)):0){H=I;while(1){I=H+-12|0;f[B>>2]=I;D=f[I>>2]|0;if(!D)fa=I;else{I=H+-8|0;x=f[I>>2]|0;if((x|0)!=(D|0))f[I>>2]=x+(~((x+-16-D|0)>>>4)<<4);YDc(D);fa=f[B>>2]|0}if((fa|0)==(C|0))break;else H=fa}}}else XKb(d,A-T|0);f[m>>2]=1124007936;H=m+4|0;C=m+8|0;B=m+40|0;y=H;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[B>>2]=C;T=m+48|0;A=m+44|0;f[A>>2]=T;f[T>>2]=0;f[m+52>>2]=0;f[o>>2]=1124007936;D=o+4|0;x=o+8|0;I=o+40|0;y=D;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[I>>2]=x;G=o+48|0;Q=o+44|0;f[Q>>2]=G;f[G>>2]=0;f[o+52>>2]=0;R=f[t>>2]|0;K=(f[w>>2]|0)-R|0;L=(K|0)/56|0;E=a+28|0;O=R;switch(f[E>>2]|0){case 7:case 6:{ga=1;break}case 2:{ga=(f[l>>2]&4095|0)==0;break}default:ga=0}R=ga?4:5;a:do if((K|0)>0){P=j+8|0;U=j+12|0;S=j+4|0;M=p+8|0;N=p+12|0;F=p+4|0;V=q+8|0;W=q+4|0;X=s+4|0;Z=s+8|0;_=s+40|0;ha=s+48|0;ia=s+44|0;ja=s+52|0;ka=r+8|0;la=r+12|0;ma=r+4|0;na=s+36|0;oa=s+16|0;pa=j+8|0;qa=j+4|0;ra=o+16|0;sa=o+12|0;ta=j+4|0;ua=j+8|0;va=j+12|0;wa=m+36|0;xa=o+36|0;ya=m+12|0;za=m+16|0;Aa=m+20|0;Ba=o+20|0;Ca=m+24|0;Da=o+24|0;Ea=m+28|0;Fa=o+28|0;Ga=m+32|0;Ha=o+32|0;Ia=s+12|0;Ja=s+20|0;Ka=s+24|0;La=s+28|0;Ma=s+32|0;Na=0;Oa=O;while(1){f[P>>2]=0;f[U>>2]=0;f[j>>2]=16842752;f[S>>2]=l;f[M>>2]=0;f[N>>2]=0;f[p>>2]=16842752;f[F>>2]=Oa+(Na*56|0);Pa=V;f[Pa>>2]=0;f[Pa+4>>2]=0;f[q>>2]=33619968;f[W>>2]=m;Pa=e0()|0;Qa=f[E>>2]|0;Ra=f[k>>2]|0;do if((Ra|0)!=(f[v>>2]|0)){Sa=Ra+(Na*56|0)|0;f[s>>2]=f[Sa>>2];Ta=Ra+(Na*56|0)+4|0;f[X>>2]=f[Ta>>2];f[Z>>2]=f[Ra+(Na*56|0)+8>>2];f[Ia>>2]=f[Ra+(Na*56|0)+12>>2];f[oa>>2]=f[Ra+(Na*56|0)+16>>2];f[Ja>>2]=f[Ra+(Na*56|0)+20>>2];f[Ka>>2]=f[Ra+(Na*56|0)+24>>2];f[La>>2]=f[Ra+(Na*56|0)+28>>2];f[Ma>>2]=f[Ra+(Na*56|0)+32>>2];Ua=f[Ra+(Na*56|0)+36>>2]|0;f[na>>2]=Ua;f[_>>2]=Z;f[ia>>2]=ha;f[ha>>2]=0;f[ja>>2]=0;if(Ua|0){Va=Ua+12|0;f[Va>>2]=(f[Va>>2]|0)+1}if((f[Ta>>2]|0)<3){Ta=f[Ra+(Na*56|0)+44>>2]|0;Va=f[ia>>2]|0;f[Va>>2]=f[Ta>>2];f[Va+4>>2]=f[Ta+4>>2];break}else{f[X>>2]=0;ZS(s,Sa);break}}else{f[s>>2]=1124007936;y=X;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[_>>2]=Z;f[ia>>2]=ha;f[ha>>2]=0;f[ja>>2]=0}while(0);f[ka>>2]=0;f[la>>2]=0;f[r>>2]=16842752;f[ma>>2]=s;tmc(j,p,q,R,Pa,Qa,0,r,0,0);Ra=f[na>>2]|0;if(Ra|0?(Sa=Ra+12|0,Ra=f[Sa>>2]|0,f[Sa>>2]=Ra+-1,(Ra|0)==1):0)_S(s);f[na>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[X>>2]|0)>0){Ra=f[_>>2]|0;Sa=0;do{f[Ra+(Sa<<2)>>2]=0;Sa=Sa+1|0}while((Sa|0)<(f[X>>2]|0))}Sa=f[ia>>2]|0;if((Sa|0)!=(ha|0))g0(Sa);if(ga){Sa=pa;f[Sa>>2]=0;f[Sa+4>>2]=0;f[j>>2]=33619968;f[qa>>2]=o;LZ(m,j,5,1.0,0.0)}else{Sa=f[wa>>2]|0;if(Sa|0){Ra=Sa+12|0;f[Ra>>2]=(f[Ra>>2]|0)+1}Ra=f[xa>>2]|0;do if(Ra|0){Sa=Ra+12|0;Qa=f[Sa>>2]|0;f[Sa>>2]=Qa+-1;if((Qa|0)!=1)break;_S(o)}while(0);f[xa>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[D>>2]|0)>0){Ra=f[I>>2]|0;Qa=0;do{f[Ra+(Qa<<2)>>2]=0;Qa=Qa+1|0;Wa=f[D>>2]|0}while((Qa|0)<(Wa|0));f[o>>2]=f[m>>2];if((Wa|0)<3)Xa=115;else Xa=117}else{f[o>>2]=f[m>>2];Xa=115}do if((Xa|0)==115){Xa=0;Qa=f[H>>2]|0;if((Qa|0)>=3){Xa=117;break}f[D>>2]=Qa;f[x>>2]=f[C>>2];f[sa>>2]=f[ya>>2];Qa=f[A>>2]|0;Ra=f[Q>>2]|0;f[Ra>>2]=f[Qa>>2];f[Ra+4>>2]=f[Qa+4>>2]}while(0);if((Xa|0)==117){Xa=0;ZS(o,m)}f[ra>>2]=f[za>>2];f[Ba>>2]=f[Aa>>2];f[Da>>2]=f[Ca>>2];f[Fa>>2]=f[Ea>>2];f[Ha>>2]=f[Ga>>2];f[xa>>2]=f[wa>>2]}Qa=f[J>>2]|0;if((Qa|0)>0){Ra=0;Sa=f[sa>>2]|0;while(1){Pa=(f[ra>>2]|0)+(Y(f[f[Q>>2]>>2]|0,Ra)|0)|0;Ta=f[d>>2]|0;Va=Ta+(Ra*12|0)|0;if((Sa|0)>0){Ua=Ta+(Ra*12|0)+4|0;Ya=Ta+(Ra*12|0)+8|0;Ta=0;Za=Sa;while(1){_a=+n[Pa+(Ta<<2)>>2];if(!(_a<=e))$a=Za;else{f[j>>2]=Ra;f[ta>>2]=Ta;f[ua>>2]=Na;n[va>>2]=_a;ab=f[Ua>>2]|0;if((ab|0)==(f[Ya>>2]|0))W_(Va,j);else{f[ab>>2]=f[j>>2];f[ab+4>>2]=f[j+4>>2];f[ab+8>>2]=f[j+8>>2];f[ab+12>>2]=f[j+12>>2];f[Ua>>2]=(f[Ua>>2]|0)+16}$a=f[sa>>2]|0}Ta=Ta+1|0;if((Ta|0)>=($a|0)){bb=$a;break}else Za=$a}}else bb=Sa;Ra=Ra+1|0;Za=f[J>>2]|0;if((Ra|0)>=(Za|0)){cb=Za;break}else Sa=bb}}else cb=Qa;Sa=Na+1|0;if((Sa|0)>=(L|0)){db=cb;break a}Na=Sa;Oa=f[t>>2]|0}}else db=f[J>>2]|0;while(0);b:do if((db|0)>0){if(h){eb=0;fb=0;gb=db}else{L=0;while(1){C=f[d>>2]|0;YKb(f[C+(L*12|0)>>2]|0,f[C+(L*12|0)+4>>2]|0,j);L=L+1|0;if((L|0)>=(f[J>>2]|0))break b}}while(1){L=f[d>>2]|0;C=L+(eb*12|0)|0;x=f[C>>2]|0;R=L+(eb*12|0)+4|0;v=x;if((x|0)==(f[R>>2]|0)){hb=fb;ib=gb}else{if((fb|0)<(eb|0)){x=L+(fb*12|0)|0;f[C>>2]=f[x>>2];f[x>>2]=v;v=L+(fb*12|0)+4|0;x=f[R>>2]|0;f[R>>2]=f[v>>2];f[v>>2]=x;x=L+(eb*12|0)+8|0;v=L+(fb*12|0)+8|0;R=f[x>>2]|0;f[x>>2]=f[v>>2];f[v>>2]=R;jb=f[d>>2]|0}else jb=L;YKb(f[jb+(fb*12|0)>>2]|0,f[jb+(fb*12|0)+4>>2]|0,j);hb=fb+1|0;ib=f[J>>2]|0}eb=eb+1|0;if((eb|0)>=(ib|0))break;else{fb=hb;gb=ib}}}while(0);J=o+36|0;L=f[J>>2]|0;if(L|0?(R=L+12|0,L=f[R>>2]|0,f[R>>2]=L+-1,(L|0)==1):0)_S(o);f[J>>2]=0;J=o+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[D>>2]|0)>0){J=f[I>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[D>>2]|0))}D=f[Q>>2]|0;if((D|0)!=(G|0))g0(D);D=m+36|0;L=f[D>>2]|0;if(L|0?(J=L+12|0,L=f[J>>2]|0,f[J>>2]=L+-1,(L|0)==1):0)_S(m);f[D>>2]=0;D=m+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[H>>2]|0)>0){D=f[B>>2]|0;L=0;do{f[D+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[H>>2]|0))}H=f[A>>2]|0;if((H|0)!=(T|0))g0(H);H=l+36|0;L=f[H>>2]|0;if(L|0?(D=L+12|0,L=f[D>>2]|0,f[D>>2]=L+-1,(L|0)==1):0)_S(l);f[H>>2]=0;H=l+16|0;L=l+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[L>>2]|0)>0){H=f[l+40>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[L>>2]|0))}L=f[l+44>>2]|0;if((L|0)!=(l+48|0))g0(L);mx(k);u=i;return}while(0);k=f[d>>2]|0;l=d+4|0;d=f[l>>2]|0;if((d|0)==(k|0)){u=i;return}else kb=d;while(1){d=kb+-12|0;f[l>>2]=d;m=f[d>>2]|0;if(!m)lb=d;else{d=kb+-8|0;o=f[d>>2]|0;if((o|0)!=(m|0))f[d>>2]=o+(~((o+-16-m|0)>>>4)<<4);YDc(m);lb=f[l>>2]|0}if((lb|0)==(k|0))break;else kb=lb}u=i;return}function XKb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){XIc(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)mCc(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{n=VDc(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;XIc(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{g=g+-12|0;$Kb(j+-12|0,g);j=h+-12|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~((q+-16-d|0)>>>4)<<4);YDc(d)}}while((c|0)!=(k|0))}if(!p)return;YDc(p);return}function YKb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-16|0;i=a+-4|0;j=g;while(1){k=j;b:while(1){l=k;m=b-l|0;o=m>>4;switch(o|0){case 2:{p=5;break a;break}case 3:{p=7;break a;break}case 4:{p=15;break a;break}case 5:{p=16;break a;break}case 1:case 0:{p=84;break a;break}default:{}}if((m|0)<496){p=22;break a}q=(o|0)/2|0;r=k+(q<<4)|0;do if((m|0)>15984){s=(o|0)/4|0;t=k+(s<<4)|0;v=r+(s<<4)|0;w=ZKb(k,t,r,v,c)|0;x=v+12|0;if(!(+n[i>>2]<+n[x>>2])){y=w;z=k+(q<<4)+12|0;break};f[e>>2]=f[v>>2];f[e+4>>2]=f[v+4>>2];f[e+8>>2]=f[v+8>>2];f[e+12>>2]=f[v+12>>2];f[v>>2]=f[h>>2];f[v+4>>2]=f[h+4>>2];f[v+8>>2]=f[h+8>>2];f[v+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];A=w+1|0;B=k+(q<<4)+12|0;if(+n[x>>2]<+n[B>>2]){f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2];f[r+8>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];f[v>>2]=f[e>>2];f[v+4>>2]=f[e+4>>2];f[v+8>>2]=f[e+8>>2];f[v+12>>2]=f[e+12>>2];v=w+2|0;x=k+(s<<4)+12|0;if(+n[B>>2]<+n[x>>2]){f[e>>2]=f[t>>2];f[e+4>>2]=f[t+4>>2];f[e+8>>2]=f[t+8>>2];f[e+12>>2]=f[t+12>>2];f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];f[t+8>>2]=f[r+8>>2];f[t+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];if(+n[x>>2]<+n[k+12>>2]){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[t>>2]=f[e>>2];f[t+4>>2]=f[e+4>>2];f[t+8>>2]=f[e+8>>2];f[t+12>>2]=f[e+12>>2];y=w+4|0;z=B}else{y=w+3|0;z=B}}else{y=v;z=B}}else{y=A;z=B}}else{B=k+(q<<4)+12|0;C=+n[B>>2];A=k+12|0;v=+n[i>>2]<C;if(!(C<+n[A>>2])){if(!v){y=0;z=B;break};f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[B>>2]<+n[A>>2])){y=1;z=B;break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2];f[k+8>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];y=2;z=B;break}if(v){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];y=1;z=B;break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2];f[k+8>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];if(+n[i>>2]<+n[B>>2]){f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];y=2;z=B}else{y=1;z=B}}while(0);q=k+12|0;C=+n[q>>2];D=+n[z>>2];if(C<D){E=h;F=y;break}else G=h;while(1){o=G;G=G+-16|0;if((k|0)==(G|0))break;if(+n[o+-4>>2]<D){p=67;break b}}o=k+16|0;if(C<+n[i>>2])H=o;else{if((o|0)==(h|0)){p=84;break a}else I=o;while(1){if(C<+n[I+12>>2])break;o=I+16|0;if((o|0)==(h|0)){p=84;break a}else I=o}f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[I>>2]=f[h>>2];f[I+4>>2]=f[h+4>>2];f[I+8>>2]=f[h+8>>2];f[I+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];H=I+16|0}if((H|0)==(h|0)){p=84;break a}else{J=h;K=H}while(1){C=+n[q>>2];o=K;while(1){L=o+16|0;if(C<+n[o+12>>2]){M=J;break}else o=L}do{m=M;M=M+-16|0}while(C<+n[m+-4>>2]);if(o>>>0>=M>>>0){k=o;continue b};f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[M>>2];f[o+4>>2]=f[M+4>>2];f[o+8>>2]=f[M+8>>2];f[o+12>>2]=f[M+12>>2];f[M>>2]=f[e>>2];f[M+4>>2]=f[e+4>>2];f[M+8>>2]=f[e+8>>2];f[M+12>>2]=f[e+12>>2];J=M;K=L}}if((p|0)==67){p=0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[G>>2];f[k+4>>2]=f[G+4>>2];f[k+8>>2]=f[G+8>>2];f[k+12>>2]=f[G+12>>2];f[G>>2]=f[e>>2];f[G+4>>2]=f[e+4>>2];f[G+8>>2]=f[e+8>>2];f[G+12>>2]=f[e+12>>2];E=G;F=y+1|0}q=k+16|0;c:do if(q>>>0<E>>>0){m=r;B=E;v=q;A=F;while(1){C=+n[m+12>>2];w=v;while(1){N=w+16|0;if(+n[w+12>>2]<C)w=N;else{O=B;break}}do{o=O;O=O+-16|0}while(!(+n[o+-4>>2]<C));if(w>>>0>O>>>0){P=m;Q=A;R=w;break c};f[e>>2]=f[w>>2];f[e+4>>2]=f[w+4>>2];f[e+8>>2]=f[w+8>>2];f[e+12>>2]=f[w+12>>2];f[w>>2]=f[O>>2];f[w+4>>2]=f[O+4>>2];f[w+8>>2]=f[O+8>>2];f[w+12>>2]=f[O+12>>2];f[O>>2]=f[e>>2];f[O+4>>2]=f[e+4>>2];f[O+8>>2]=f[e+8>>2];f[O+12>>2]=f[e+12>>2];m=(m|0)==(w|0)?O:m;B=O;v=N;A=A+1|0}}else{P=r;Q=F;R=q}while(0);if((R|0)!=(P|0)?+n[P+12>>2]<+n[R+12>>2]:0){f[e>>2]=f[R>>2];f[e+4>>2]=f[R+4>>2];f[e+8>>2]=f[R+8>>2];f[e+12>>2]=f[R+12>>2];f[R>>2]=f[P>>2];f[R+4>>2]=f[P+4>>2];f[R+8>>2]=f[P+8>>2];f[R+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];S=Q+1|0}else S=Q;if(!S){T=_Kb(k,R,c)|0;q=R+16|0;if(_Kb(q,a,c)|0){p=83;break}if(T){j=q;continue}}q=R;if((q-l|0)>=(b-q|0)){p=82;break}YKb(k,R,c);j=R+16|0}if((p|0)==82){p=0;YKb(R+16|0,a,c);g=k;a=R;continue}else if((p|0)==83){p=0;if(T){p=84;break}else{g=k;a=R;continue}}}if((p|0)==5){if(!(+n[i>>2]<+n[k+12>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==7){R=k+16|0;g=k+28|0;C=+n[g>>2];T=k+12|0;l=+n[i>>2]<C;if(!(C<+n[T>>2])){if(!l){u=d;return};f[e>>2]=f[R>>2];f[e+4>>2]=f[R+4>>2];f[e+8>>2]=f[R+8>>2];f[e+12>>2]=f[R+12>>2];f[R>>2]=f[h>>2];f[R+4>>2]=f[h+4>>2];f[R+8>>2]=f[h+8>>2];f[R+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[g>>2]<+n[T>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[R>>2];f[k+4>>2]=f[R+4>>2];f[k+8>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2];u=d;return}if(l){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[R>>2];f[k+4>>2]=f[R+4>>2];f[k+8>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2];if(!(+n[i>>2]<+n[g>>2])){u=d;return};f[e>>2]=f[R>>2];f[e+4>>2]=f[R+4>>2];f[e+8>>2]=f[R+8>>2];f[e+12>>2]=f[R+12>>2];f[R>>2]=f[h>>2];f[R+4>>2]=f[h+4>>2];f[R+8>>2]=f[h+8>>2];f[R+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==15){ZKb(k,k+16|0,k+32|0,h,c)|0;u=d;return}else if((p|0)==16){R=k+16|0;g=k+32|0;l=k+48|0;ZKb(k,R,g,l,c)|0;c=k+60|0;if(!(+n[i>>2]<+n[c>>2])){u=d;return};f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];h=k+44|0;if(!(+n[c>>2]<+n[h>>2])){u=d;return};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];l=k+28|0;if(!(+n[h>>2]<+n[l>>2])){u=d;return};f[e>>2]=f[R>>2];f[e+4>>2]=f[R+4>>2];f[e+8>>2]=f[R+8>>2];f[e+12>>2]=f[R+12>>2];f[R>>2]=f[g>>2];f[R+4>>2]=f[g+4>>2];f[R+8>>2]=f[g+8>>2];f[R+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+n[l>>2]<+n[k+12>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[R>>2];f[k+4>>2]=f[R+4>>2];f[k+8>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==22){R=k+32|0;l=k+16|0;g=k+28|0;C=+n[g>>2];D=+n[k+12>>2];U=+n[k+44>>2];h=U<C;do if(C<D){if(h){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[R>>2];f[k+4>>2]=f[R+4>>2];f[k+8>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2];break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];if(U<+n[g>>2]){f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[l>>2]=f[R>>2];f[l+4>>2]=f[R+4>>2];f[l+8>>2]=f[R+8>>2];f[l+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2]}}else if(h?(f[e>>2]=f[l>>2],f[e+4>>2]=f[l+4>>2],f[e+8>>2]=f[l+8>>2],f[e+12>>2]=f[l+12>>2],f[l>>2]=f[R>>2],f[l+4>>2]=f[R+4>>2],f[l+8>>2]=f[R+8>>2],f[l+12>>2]=f[R+12>>2],f[R>>2]=f[e>>2],f[R+4>>2]=f[e+4>>2],f[R+8>>2]=f[e+8>>2],f[R+12>>2]=f[e+12>>2],+n[g>>2]<D):0){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2]}while(0);l=k+48|0;if((l|0)==(a|0)){u=d;return}g=l;l=R;while(1){D=+n[g+12>>2];if(D<+n[l+12>>2]){f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];R=l;h=g;while(1){f[h>>2]=f[R>>2];f[h+4>>2]=f[R+4>>2];f[h+8>>2]=f[R+8>>2];f[h+12>>2]=f[R+12>>2];if((R|0)==(k|0)){V=k;break}if(D<+n[R+-4>>2]){c=R;R=R+-16|0;h=c}else{V=R;break}}f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];n[V+12>>2]=D}h=g+16|0;if((h|0)==(a|0))break;else{c=g;g=h;l=c}}u=d;return}else if((p|0)==84){u=d;return}}function ZKb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,o=0;e=u;u=u+16|0;g=e;h=b+12|0;i=+n[h>>2];j=a+12|0;k=c+12|0;l=+n[k>>2]<i;do if(i<+n[j>>2]){if(l){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];m=1;break};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];if(+n[k>>2]<+n[h>>2]){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];m=2}else m=1}else if(l){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(+n[h>>2]<+n[j>>2]){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];m=2}else m=1}else m=0;while(0);if(!(+n[d+12>>2]<+n[k>>2])){o=m;u=e;return o|0};f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[g+8>>2]=f[c+8>>2];f[g+12>>2]=f[c+12>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];if(!(+n[k>>2]<+n[h>>2])){o=m+1|0;u=e;return o|0};f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(!(+n[h>>2]<+n[j>>2])){o=m+2|0;u=e;return o|0};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];o=m+3|0;u=e;return o|0}function _Kb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;switch(b-a>>4|0){case 2:{if(!(+n[b+-4>>2]<+n[a+12>>2])){g=1;u=d;return g|0}h=b+-16|0;f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 3:{h=a+16|0;i=b+-16|0;j=a+28|0;k=+n[j>>2];l=a+12|0;m=b+-4|0;o=+n[m>>2]<k;if(!(k<+n[l>>2])){if(!o){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];if(!(+n[j>>2]<+n[l>>2])){g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];g=1;u=d;return g|0}if(o){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[m>>2]<+n[j>>2])){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 4:{ZKb(a,a+16|0,a+32|0,b+-16|0,c)|0;g=1;u=d;return g|0}case 5:{i=a+16|0;h=a+32|0;j=a+48|0;ZKb(a,i,h,j,c)|0;c=a+60|0;if(!(+n[b+-4>>2]<+n[c>>2])){g=1;u=d;return g|0}m=b+-16|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[m>>2];f[j+4>>2]=f[m+4>>2];f[j+8>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];m=a+44|0;if(!(+n[c>>2]<+n[m>>2])){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];j=a+28|0;if(!(+n[m>>2]<+n[j>>2])){g=1;u=d;return g|0};f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[j>>2]<+n[a+12>>2])){g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 1:case 0:{g=1;u=d;return g|0}default:{i=a+32|0;j=a+16|0;h=a+28|0;k=+n[h>>2];p=+n[a+12>>2];q=+n[a+44>>2];m=q<k;do if(k<p){if(m){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];break};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[j>>2];f[a+4>>2]=f[j+4>>2];f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];if(q<+n[h>>2]){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2]}}else if(m?(f[e>>2]=f[j>>2],f[e+4>>2]=f[j+4>>2],f[e+8>>2]=f[j+8>>2],f[e+12>>2]=f[j+12>>2],f[j>>2]=f[i>>2],f[j+4>>2]=f[i+4>>2],f[j+8>>2]=f[i+8>>2],f[j+12>>2]=f[i+12>>2],f[i>>2]=f[e>>2],f[i+4>>2]=f[e+4>>2],f[i+8>>2]=f[e+8>>2],f[i+12>>2]=f[e+12>>2],+n[h>>2]<p):0){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[j>>2];f[a+4>>2]=f[j+4>>2];f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2]}while(0);j=a+48|0;a:do if((j|0)==(b|0)){r=1;s=0}else{h=j;m=0;c=i;while(1){p=+n[h+12>>2];if(p<+n[c+12>>2]){f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];o=c;l=h;while(1){f[l>>2]=f[o>>2];f[l+4>>2]=f[o+4>>2];f[l+8>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];if((o|0)==(a|0)){t=a;break}if(p<+n[o+-4>>2]){v=o;o=o+-16|0;l=v}else{t=o;break}}f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];f[o+8>>2]=f[e+8>>2];n[t+12>>2]=p;l=m+1|0;if((l|0)==8){r=0;s=(h+16|0)==(b|0);break a}else w=l}else w=m;l=h+16|0;if((l|0)==(b|0)){r=1;s=0;break}else{v=h;h=l;m=w;c=v}}}while(0);g=s|r;u=d;return g|0}}return 0}function $Kb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>4;if(!g)return;if(g>>>0>268435455)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<4);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;dJc(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>4<<4);return}function aLb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[a>>2]|0;e=d;if((((f[c>>2]|0)-d|0)/12|0)>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>357913941){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}h=f[g>>2]|0;i=VDc(b*12|0)|0;j=i+(((h-d|0)/12|0)*12|0)|0;d=j;k=i+(b*12|0)|0;b=h;if((b|0)==(e|0)){l=d;m=h;n=e}else{h=b;b=d;i=j;do{h=h+-12|0;$Kb(i+-12|0,h);i=b+-12|0;b=i}while((h|0)!=(e|0));l=b;m=f[a>>2]|0;n=f[g>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;k=m;if((n|0)!=(k|0)){c=n;do{n=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){g=n+-8|0;n=f[g>>2]|0;if((n|0)!=(d|0))f[g>>2]=n+(~((n+-16-d|0)>>>4)<<4);YDc(d)}}while((c|0)!=(k|0))}if(!m)return;YDc(m);return}function bLb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;$Kb(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-12|0;$Kb(e+-12|0,i);e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-16-b|0)>>>4)<<4);YDc(b)}}while((h|0)!=(g|0))}if(!m)return;YDc(m);return}function cLb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>4;i=VDc(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;YDc(d);return}function dLb(a){a=a|0;YDc(a);return}function eLb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fLb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+96|0;h=g+88|0;i=g+72|0;j=g+56|0;k=g;Ti[f[(f[a>>2]|0)+44>>2]&511](h,a,1);a=h+4|0;l=f[a>>2]|0;mi[f[(f[l>>2]|0)+32>>2]&2047](l,c);c=f[a>>2]|0;do if((d$(e)|0)==65536){a=f[e+4>>2]|0;f[k>>2]=f[a>>2];l=k+4|0;m=a+4|0;f[l>>2]=f[m>>2];n=k+8|0;f[n>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];o=f[a+36>>2]|0;f[k+36>>2]=o;f[k+40>>2]=n;n=k+48|0;p=k+44|0;f[p>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[a+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;ZS(k,a);break}}else a$(k,e,-1);while(0);qFa(j,1,k);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=j;gLb(c,b,d,i);mx(j);j=k+36|0;i=f[j>>2]|0;if(i|0?(d=i+12|0,i=f[d>>2]|0,f[d>>2]=i+-1,(i|0)==1):0)_S(k);f[j>>2]=0;j=k+16|0;i=k+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[k+40>>2]|0;d=0;do{f[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[i>>2]|0))}i=f[k+44>>2]|0;if((i|0)!=(k+48|0))g0(i);i=f[h>>2]|0;if(!i){u=g;return}h=i+4|0;k=f[h>>2]|0;f[h>>2]=k+-1;if((k|0)!=1){u=g;return}Yi[f[(f[i>>2]|0)+8>>2]&2047](i);u=g;return}function gLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=u;u=u+32|0;h=g+16|0;i=g;f[i>>2]=0;j=i+4|0;f[j>>2]=0;f[i+8>>2]=0;if(!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0)?!(r$(c)|0):0){b$(h,c,-1);hLb(a,e,f[h+4>>2]|0);Yi[f[(f[a>>2]|0)+40>>2]&2047](a);Fh[f[(f[a>>2]|0)+48>>2]&255](a,c,i,1,e,1)}e=f[d>>2]|0;c=d+4|0;a=f[c>>2]|0;if((a|0)!=(e|0))f[c>>2]=a+(~((a+-16-e|0)>>>4)<<4);cLb(d,((f[j>>2]|0)-(f[i>>2]|0)|0)/12|0);e=f[j>>2]|0;a=f[i>>2]|0;k=a;l=e;a:do if((e|0)==(a|0)){m=k;n=l}else{o=d+8|0;p=0;q=a;r=l;s=k;t=e;while(1){v=q;w=f[v+(p*12|0)+4>>2]|0;x=f[v+(p*12|0)>>2]|0;v=x;if(w-x>>4>>>0>=2)break;do if((v|0)!=(w|0)){y=f[c>>2]|0;if((y|0)==(f[o>>2]|0)){W_(d,v);z=f[j>>2]|0;A=f[i>>2]|0;B=A;C=z;D=z;E=A;break}else{A=x;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2];f[y+8>>2]=f[A+8>>2];f[y+12>>2]=f[A+12>>2];f[c>>2]=(f[c>>2]|0)+16;B=q;C=t;D=r;E=s;break}}else{B=q;C=t;D=r;E=s}while(0);p=p+1|0;if(p>>>0>=((C-B|0)/12|0)>>>0){m=E;n=D;break a}else{q=B;r=D;s=E;t=C}}f[h>>2]=0;f[h+4>>2]=0;t=tT(h,25)|0;s=464103;r=t+25|0;do{b[t>>0]=b[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(r|0));NKb(-215,h,464129,518)}while(0);if(!m){u=g;return}if((n|0)==(m|0))F=m;else{h=n;while(1){n=h+-12|0;f[j>>2]=n;C=f[n>>2]|0;if(!C)G=n;else{n=h+-8|0;E=f[n>>2]|0;if((E|0)!=(C|0))f[n>>2]=E+(~((E+-16-C|0)>>>4)<<4);YDc(C);G=f[j>>2]|0}if((G|0)==(m|0))break;else h=G}F=f[i>>2]|0}YDc(F);u=g;return}function hLb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+32|0;g=e+8|0;h=e;f[g>>2]=0;i=g+4|0;f[i>>2]=0;f[g+8>>2]=0;f$(c,g);if(!(_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0)){mx(g);u=e;return}c=f[g>>2]|0;j=f[i>>2]|0;if((c|0)==(j|0)){mx(g);u=e;return}i=f[a+4>>2]|0;k=((f[a+8>>2]|0)-i|0)/56|0;l=f[a+16>>2]|0;m=((f[a+20>>2]|0)-l|0)/48|0;a=k>>>0<m>>>0?m:k;k=i;i=l;if(((j-c|0)/56|0|0)!=(a|0)){f[h>>2]=0;f[h+4>>2]=0;n=tT(h,26)|0;o=464144;p=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));NKb(-215,h,464171,626)}if(!a){mx(g);u=e;return}else q=0;a:while(1){do if(f[c+(q*56|0)+16>>2]|0){j=f[c+(q*56|0)+4>>2]|0;if((j|0)<3)r=Y(f[c+(q*56|0)+12>>2]|0,f[c+(q*56|0)+8>>2]|0)|0;else{l=f[c+(q*56|0)+40>>2]|0;m=0;s=1;while(1){t=Y(f[l+(m<<2)>>2]|0,s)|0;m=m+1|0;if((m|0)==(j|0)){r=t;break}else s=t}}if(!((j|0)==0|(r|0)==0)){if(f[k+(q*56|0)+16>>2]|0){s=f[k+(q*56|0)+4>>2]|0;if((s|0)<3)v=Y(f[k+(q*56|0)+12>>2]|0,f[k+(q*56|0)+8>>2]|0)|0;else{m=f[k+(q*56|0)+40>>2]|0;l=0;t=1;while(1){w=Y(f[m+(l<<2)>>2]|0,t)|0;l=l+1|0;if((l|0)==(s|0)){v=w;break}else t=w}}if((s|0)==0|(v|0)==0)x=18}else x=18;if((x|0)==18){x=0;if(!(f[i+(q*48|0)+24>>2]|0))break;t=f[i+(q*48|0)+4>>2]|0;if((t|0)<3)y=Y(f[i+(q*48|0)+12>>2]|0,f[i+(q*48|0)+8>>2]|0)|0;else{l=f[i+(q*48|0)+32>>2]|0;m=0;j=1;while(1){w=Y(f[l+(m<<2)>>2]|0,j)|0;m=m+1|0;if((m|0)==(t|0)){y=w;break}else j=w}}if((t|0)==0|(y|0)==0)break}if(f[k+(q*56|0)+16>>2]|0){j=f[k+(q*56|0)+4>>2]|0;if((j|0)<3)z=Y(f[k+(q*56|0)+12>>2]|0,f[k+(q*56|0)+8>>2]|0)|0;else{m=f[k+(q*56|0)+40>>2]|0;l=0;s=1;while(1){w=Y(f[m+(l<<2)>>2]|0,s)|0;l=l+1|0;if((l|0)==(j|0)){z=w;break}else s=w}}if(!((j|0)==0|(z|0)==0))A=k+(q*56|0)+8|0;else x=30}else x=30;if((x|0)==30){x=0;A=i+(q*48|0)+8|0}if((f[c+(q*56|0)+8>>2]|0)!=(d|0)){x=35;break a}if((f[c+(q*56|0)+12>>2]|0)!=(f[A>>2]|0)){x=35;break a}if(f[c+(q*56|0)>>2]&4095|0){x=35;break a}}}while(0);q=q+1|0;if(q>>>0>=a>>>0){x=37;break}}if((x|0)==35){f[h>>2]=0;f[h+4>>2]=0;n=tT(h,93)|0;o=464182;p=n+93|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));NKb(-215,h,464171,633)}else if((x|0)==37){mx(g);u=e;return}}function iLb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+96|0;j=i+88|0;k=i+72|0;l=i+56|0;m=i;Ti[f[(f[a>>2]|0)+44>>2]&511](j,a,1);a=j+4|0;n=f[a>>2]|0;mi[f[(f[n>>2]|0)+32>>2]&2047](n,c);c=f[a>>2]|0;do if((d$(g)|0)==65536){a=f[g+4>>2]|0;f[m>>2]=f[a>>2];n=m+4|0;o=a+4|0;f[n>>2]=f[o>>2];p=m+8|0;f[p>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[m+36>>2]=q;f[m+40>>2]=p;p=m+48|0;r=m+44|0;f[r>>2]=p;f[p>>2]=0;f[m+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[a+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;ZS(m,a);break}}else a$(m,g,-1);while(0);qFa(l,1,m);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17104896;f[k+4>>2]=l;jLb(c,b,d,e,k,h);mx(l);l=m+36|0;h=f[l>>2]|0;if(h|0?(k=h+12|0,h=f[k>>2]|0,f[k>>2]=h+-1,(h|0)==1):0)_S(m);f[l>>2]=0;l=m+16|0;h=m+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[h>>2]|0)>0){l=f[m+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=f[m+44>>2]|0;if((h|0)!=(m+48|0))g0(h);h=f[j>>2]|0;if(!h){u=i;return}j=h+4|0;m=f[j>>2]|0;f[j>>2]=m+-1;if((m|0)!=1){u=i;return}Yi[f[(f[h>>2]|0)+8>>2]&2047](h);u=i;return}function jLb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i+8|0;k=i;if(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0){u=i;return}if(r$(c)|0){u=i;return}if((e|0)<=0){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,7)|0;b[l>>0]=b[464276]|0;b[l+1>>0]=b[464277]|0;b[l+2>>0]=b[464278]|0;b[l+3>>0]=b[464279]|0;b[l+4>>0]=b[464280]|0;b[l+5>>0]=b[464281]|0;b[l+6>>0]=b[464282]|0;NKb(-215,j,464284,647)}b$(k,c,-1);hLb(a,g,f[k+4>>2]|0);Yi[f[(f[a>>2]|0)+40>>2]&2047](a);Fh[f[(f[a>>2]|0)+48>>2]&255](a,c,d,e,g,h);u=i;return}function kLb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+96|0;j=i+88|0;k=i+72|0;l=i+56|0;m=i;Ti[f[(f[a>>2]|0)+44>>2]&511](j,a,1);a=j+4|0;n=f[a>>2]|0;mi[f[(f[n>>2]|0)+32>>2]&2047](n,c);c=f[a>>2]|0;do if((d$(g)|0)==65536){a=f[g+4>>2]|0;f[m>>2]=f[a>>2];n=m+4|0;o=a+4|0;f[n>>2]=f[o>>2];p=m+8|0;f[p>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[m+36>>2]=q;f[m+40>>2]=p;p=m+48|0;r=m+44|0;f[r>>2]=p;f[p>>2]=0;f[m+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[a+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;ZS(m,a);break}}else a$(m,g,-1);while(0);qFa(l,1,m);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17104896;f[k+4>>2]=l;lLb(c,b,d,e,k,h);mx(l);l=m+36|0;h=f[l>>2]|0;if(h|0?(k=h+12|0,h=f[k>>2]|0,f[k>>2]=h+-1,(h|0)==1):0)_S(m);f[l>>2]=0;l=m+16|0;h=m+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[h>>2]|0)>0){l=f[m+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=f[m+44>>2]|0;if((h|0)!=(m+48|0))g0(h);h=f[j>>2]|0;if(!h){u=i;return}j=h+4|0;m=f[j>>2]|0;f[j>>2]=m+-1;if((m|0)!=1){u=i;return}Yi[f[(f[h>>2]|0)+8>>2]&2047](h);u=i;return}function lLb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+16|0;j=i+8|0;k=i;l=f[d>>2]|0;m=d+4|0;n=f[m>>2]|0;if((n|0)!=(l|0)){o=n;while(1){n=o+-12|0;f[m>>2]=n;p=f[n>>2]|0;if(!p)q=n;else{n=o+-8|0;r=f[n>>2]|0;if((r|0)!=(p|0))f[n>>2]=r+(~((r+-16-p|0)>>>4)<<4);YDc(p);q=f[m>>2]|0}if((q|0)==(l|0))break;else o=q}}if(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0){u=i;return}if(r$(c)|0){u=i;return}if(!(e>1.1920928955078125e-07)){f[j>>2]=0;f[j+4>>2]=0;q=tT(j,51)|0;o=464293;l=q+51|0;do{b[q>>0]=b[o>>0]|0;q=q+1|0;o=o+1|0}while((q|0)<(l|0));NKb(-215,j,464345,664)}b$(k,c,-1);hLb(a,g,f[k+4>>2]|0);Yi[f[(f[a>>2]|0)+40>>2]&2047](a);tj[f[(f[a>>2]|0)+52>>2]&7](a,c,d,e,g,h);u=i;return}function mLb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=VDc(36)|0;r0(e);g=e+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[e>>2]=112780;f[e+28>>2]=c;b[e+32>>0]=d&1;d=VDc(16)|0;f[d+4>>2]=1;f[d>>2]=112844;f[d+8>>2]=e;f[a>>2]=d;f[a+4>>2]=e;return}function nLb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;h=f[c>>2]|0;if((h|0)!=464357?(c=(h|0)==0?1154740:h,Ioc(c,464357)|0):0){if((h|0)!=464368?Ioc(c,464368)|0:0){if((h|0)!=464383?Ioc(c,464383)|0:0){if(((h|0)!=464397?!((Ioc(c,464397)|0)==0|(h|0)==464416):0)?Ioc(c,464416)|0:0){if((h|0)!=464438?Ioc(c,464438)|0:0){f[e>>2]=0;f[e+4>>2]=0;c=tT(e,20)|0;h=464460;i=c+20|0;do{b[c>>0]=b[h>>0]|0;c=c+1|0;h=h+1|0}while((c|0)<(i|0));NKb(-5,e,464481,1046)}e=VDc(36)|0;r0(e);h=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[e>>2]=112780;f[e+28>>2]=7;b[e+32>>0]=0;h=VDc(16)|0;c=h+4|0;f[c>>2]=1;f[h>>2]=112844;f[h+8>>2]=e;f[c>>2]=(f[c>>2]|0)+1;i=f[a>>2]|0;f[a>>2]=h;f[g>>2]=e;if(i|0?(e=i+4|0,j=f[e>>2]|0,f[e>>2]=j+-1,(j|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[c>>2]|0;f[c>>2]=i+-1;if((i|0)!=1){u=d;return}Yi[f[(f[h>>2]|0)+8>>2]&2047](h);u=d;return}h=VDc(36)|0;r0(h);i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[h>>2]=112780;f[h+28>>2]=6;b[h+32>>0]=0;i=VDc(16)|0;c=i+4|0;f[c>>2]=1;f[i>>2]=112844;f[i+8>>2]=h;f[c>>2]=(f[c>>2]|0)+1;j=f[a>>2]|0;f[a>>2]=i;f[g>>2]=h;if(j|0?(h=j+4|0,e=f[h>>2]|0,f[h>>2]=e+-1,(e|0)==1):0)Yi[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[c>>2]|0;f[c>>2]=j+-1;if((j|0)!=1){u=d;return}Yi[f[(f[i>>2]|0)+8>>2]&2047](i);u=d;return}i=VDc(36)|0;r0(i);j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[i>>2]=112780;f[i+28>>2]=2;b[i+32>>0]=0;j=VDc(16)|0;c=j+4|0;f[c>>2]=1;f[j>>2]=112844;f[j+8>>2]=i;f[c>>2]=(f[c>>2]|0)+1;e=f[a>>2]|0;f[a>>2]=j;f[g>>2]=i;if(e|0?(i=e+4|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)Yi[f[(f[e>>2]|0)+8>>2]&2047](e);e=f[c>>2]|0;f[c>>2]=e+-1;if((e|0)!=1){u=d;return}Yi[f[(f[j>>2]|0)+8>>2]&2047](j);u=d;return}j=VDc(36)|0;r0(j);e=j+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[j>>2]=112780;f[j+28>>2]=5;b[j+32>>0]=0;e=VDc(16)|0;c=e+4|0;f[c>>2]=1;f[e>>2]=112844;f[e+8>>2]=j;f[c>>2]=(f[c>>2]|0)+1;h=f[a>>2]|0;f[a>>2]=e;f[g>>2]=j;if(h|0?(j=h+4|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)Yi[f[(f[h>>2]|0)+8>>2]&2047](h);h=f[c>>2]|0;f[c>>2]=h+-1;if((h|0)!=1){u=d;return}Yi[f[(f[e>>2]|0)+8>>2]&2047](e);u=d;return}e=VDc(36)|0;r0(e);h=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[e>>2]=112780;f[e+28>>2]=4;b[e+32>>0]=0;h=VDc(16)|0;c=h+4|0;f[c>>2]=1;f[h>>2]=112844;f[h+8>>2]=e;f[c>>2]=(f[c>>2]|0)+1;i=f[a>>2]|0;f[a>>2]=h;f[g>>2]=e;if(i|0?(e=i+4|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[c>>2]|0;f[c>>2]=i+-1;if((i|0)!=1){u=d;return}Yi[f[(f[h>>2]|0)+8>>2]&2047](h);u=d;return}function oLb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;switch(d|0){case 3:{h=16;i=112920;break}case 1:{h=12;i=113144;break}case 2:{h=12;i=113048;break}default:{j=(d|0)==0;h=(d+-1|0)>>>0<2?12:j?8:0;i=j?112856:0}}if(!((a|0)!=0&(i|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,16)|0;d=465067;k=j+16|0;do{b[j>>0]=b[d>>0]|0;j=j+1|0;d=d+1|0}while((j|0)<(k|0));z5(-215,g,464488,464505,86)}if((h|0)>0)l=0;else{u=e;return}do{g=(Y(f[i+(l<<3)+4>>2]|0,c)|0)+(f[i+(l<<3)>>2]|0)|0;f[a+(l<<2)>>2]=g;l=l+1|0}while((l|0)!=(h|0));u=e;return}function pLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0;e=h[c>>0]|0;g=e+d|0;i=e-d|0;d=f[a>>2]|0;if(d>>>0>65535)j=d;else{k=d;l=k&255;return l|0}while(1){d=h[c+(f[b+(j>>>28<<2)>>2]|0)>>0]|0;e=f[a+(((((j&4096|0)==0?(d|0)>(g|0):(d|0)<(i|0))?j>>>16:j)&4095)<<2)>>2]|0;if(e>>>0>65535)j=e;else{k=e;break}}l=k&255;return l|0}function qLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=h[a>>0]|0;e=c;g=c+255|0;c=255;while(1){i=(g|0)/2|0;j=i+d|0;k=d-i|0;l=65574;while(1){m=h[a+(f[b+(l>>>28<<2)>>2]|0)>>0]|0;n=((l&4096|0)==0?(m|0)>(j|0):(m|0)<(k|0))?l>>>16:l;o=n&4095;if((n&4094|0)==108)break;else l=f[113240+(o<<2)>>2]|0}l=(o|0)==108;k=l?i:c;p=l?e:i;if((p|0)==(k|0)|(p|0)==(k+-1|0))break;else{e=p;g=p+k|0;c=k}}return p|0}function rLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=h[a>>0]|0;e=c;g=c+255|0;c=255;while(1){i=(g|0)/2|0;j=i+d|0;k=d-i|0;l=65717;while(1){m=h[a+(f[b+(l>>>28<<2)>>2]|0)>>0]|0;n=((l&4096|0)==0?(m|0)>(j|0):(m|0)<(k|0))?l>>>16:l;o=n&4095;if((n&4094|0)==390)break;else l=f[113680+(o<<2)>>2]|0}l=(o|0)==390;k=l?i:c;p=l?e:i;if((p|0)==(k|0)|(p|0)==(k+-1|0))break;else{e=p;g=p+k|0;c=k}}return p|0}function sLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;d=h[a>>0]|0;e=c;g=c+255|0;c=255;while(1){i=(g|0)/2|0;j=i+d|0;k=d-i|0;l=66347;do{m=h[a+(f[b+(l>>>28<<2)>>2]|0)>>0]|0;l=f[115248+(((((l&4096|0)==0?(m|0)>(j|0):(m|0)<(k|0))?l>>>16:l)&4095)<<2)>>2]|0}while(l>>>0>65535);k=(l&255|0)==254;j=k?i:c;n=k?e:i;if((n|0)==(j|0)|(n|0)==(j+-1|0))break;else{e=n;g=n+j|0;c=j}}return n|0}function tLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=h[a>>0]|0;e=c;g=c+255|0;c=255;while(1){i=(g|0)/2|0;j=i+d|0;k=d-i|0;l=65848;while(1){m=h[a+(f[b+(l>>>28<<2)>>2]|0)>>0]|0;n=((l&4096|0)==0?(m|0)>(j|0):(m|0)<(k|0))?l>>>16:l;o=n&4095;if((n&4094|0)==684)break;else l=f[122712+(o<<2)>>2]|0}l=(o|0)==502|(o|0)==684;k=l?i:c;p=l?e:i;if((p|0)==(k|0)|(p|0)==(k+-1|0))break;else{e=p;g=p+k|0;c=k}}return p|0}function uLb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;XHb(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;tT(a,(f[c>>2]|0)+21|0)|0;g=f[c>>2]|0;if(!g)h=0;else{dJc(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;h=464581;a=c+21|0;do{b[c>>0]=b[h>>0]|0;c=c+1|0;h=h+1|0}while((c|0)<(a|0));uT(e);u=d;return}function vLb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0;g=u;u=u+160|0;h=g+136|0;i=g+80|0;j=g+16|0;k=g;f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;switch(e|0){case 0:{wLb(a,h,c,0);break}case 1:{wLb(a,h,c,1);break}case 2:{wLb(a,h,c,2);break}case 3:{wLb(a,h,c,3);break}default:{}}do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[i>>2]=f[m>>2];o=i+4|0;p=m+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[m+8>>2];f[i+12>>2]=f[m+12>>2];f[i+16>>2]=f[m+16>>2];f[i+20>>2]=f[m+20>>2];f[i+24>>2]=f[m+24>>2];f[i+28>>2]=f[m+28>>2];f[i+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;s=i+44|0;f[s>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){t=r+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[p>>2]|0)<3){p=f[m+44>>2]|0;t=f[s>>2]|0;f[t>>2]=f[p>>2];f[t+4>>2]=f[p+4>>2];v=q;break}else{f[o>>2]=0;ZS(i,m);v=q;break}}else{a$(i,a,-1);v=i+48|0}while(0);oLb(j,f[v>>2]|0,e);a=f[h>>2]|0;q=f[l>>2]|0;m=q;a:do if((a|0)==(q|0)){w=a;x=m}else{o=i+16|0;p=i+44|0;if(!e){t=a;do{y=+(qLb((f[o>>2]|0)+(Y(f[f[p>>2]>>2]|0,~~+n[t+4>>2])|0)+~~+n[t>>2]|0,j,c)|0);n[t+16>>2]=y;t=t+28|0;z=f[l>>2]|0}while((t|0)!=(z|0));w=t;x=z;break}else{A=a;B=m;C=q}while(1){switch(e|0){case 3:{D=tLb((f[o>>2]|0)+(Y(f[f[p>>2]>>2]|0,~~+n[A+4>>2])|0)+~~+n[A>>2]|0,j,c)|0;E=20;break}case 1:{D=rLb((f[o>>2]|0)+(Y(f[f[p>>2]>>2]|0,~~+n[A+4>>2])|0)+~~+n[A>>2]|0,j,c)|0;E=20;break}case 2:{D=sLb((f[o>>2]|0)+(Y(f[f[p>>2]>>2]|0,~~+n[A+4>>2])|0)+~~+n[A>>2]|0,j,c)|0;E=20;break}default:{F=C;G=B}}if((E|0)==20){E=0;n[A+16>>2]=+(D|0);s=f[l>>2]|0;F=s;G=s}A=A+28|0;if((A|0)==(F|0)){w=F;x=G;break a}else{B=G;C=F}}}while(0);if(d){d=f[h>>2]|0;F=x-d|0;x=(F|0)/28|0;f[k>>2]=0;C=k+4|0;f[C>>2]=0;f[k+8>>2]=0;if(F|0){lN(k,x);XIc(f[k>>2]|0,-1,(x>>>0>1?x:1)<<2|0)|0;F=f[h>>2]|0;G=f[k>>2]|0;B=0;A=0;D=0;E=0;c=0;j=d;while(1){d=j;y=+n[d+4>>2];e=+((E+1|0)>>>0)<y;E=e?D:E;q=e?B:A;e=+(D>>>0)!=y;D=e?~~y>>>0:D;B=e?c:B;if(+((E+1|0)>>>0)==y){H=+n[F+(q*28|0)>>2];I=+n[d>>2];b:do if(H<I){J=+(E>>>0);e=q;K=H;while(1){if(!(+n[F+(e*28|0)+4>>2]==J)){L=e;M=K;break b}m=e+1|0;N=+n[F+(m*28|0)>>2];if(N<I){e=m;K=N}else{L=m;M=N;break}}}else{L=q;M=H}while(0);if((L|0)==(c|0)|M!=I)O=L;else{e=L;while(1){m=f[G+(e<<2)>>2]|0;if((m|0)==-1)break;else e=m}m=+n[F+(c*28|0)+16>>2]<+n[F+(e*28|0)+16>>2];f[G+((m?c:e)<<2)>>2]=m?e:c;O=L}}else O=q;m=c+-1|0;do if((c|0?+n[F+(m*28|0)+4>>2]==y:0)?+n[F+(m*28|0)>>2]+1.0==+n[d>>2]:0){a=G+(c<<2)|0;z=f[a>>2]|0;p=m;while(1){P=G+(p<<2)|0;o=f[P>>2]|0;if((o|0)==-1)break;else p=o}if((z|0)==-1){if((p|0)==(c|0))break;if(+n[F+(c*28|0)+16>>2]<+n[F+(p*28|0)+16>>2]){f[a>>2]=p;break}else{f[P>>2]=c;break}}else{if((p|0)==(z|0))break;if(+n[F+(z*28|0)+16>>2]<+n[F+(p*28|0)+16>>2]){f[G+(z<<2)>>2]=p;f[a>>2]=p;break}else{f[P>>2]=z;f[a>>2]=z;break}}}while(0);c=c+1|0;if(c>>>0>=x>>>0)break;else{A=O;j=d+28|0}}j=b+4|0;O=b+8|0;A=0;do{do if((f[(f[k>>2]|0)+(A<<2)>>2]|0)==-1){c=f[h>>2]|0;P=c+(A*28|0)|0;G=f[j>>2]|0;if((G|0)==(f[O>>2]|0)){V_(b,P);break}else{f[G>>2]=f[P>>2];f[G+4>>2]=f[c+(A*28|0)+4>>2];P=G+8|0;G=c+(A*28|0)+8|0;f[P>>2]=f[G>>2];f[P+4>>2]=f[G+4>>2];f[P+8>>2]=f[G+8>>2];f[P+12>>2]=f[G+12>>2];f[P+16>>2]=f[G+16>>2];f[j>>2]=(f[j>>2]|0)+28;break}}while(0);A=A+1|0}while(A>>>0<x>>>0)}x=f[k>>2]|0;if(x|0){k=f[C>>2]|0;if((k|0)!=(x|0))f[C>>2]=k+(~((k+-4-x|0)>>>2)<<2);YDc(x)}}else if((h|0)!=(b|0))xLb(b,f[h>>2]|0,w);w=i+36|0;b=f[w>>2]|0;if(b|0?(x=b+12|0,b=f[x>>2]|0,f[x>>2]=b+-1,(b|0)==1):0)_S(i);f[w>>2]=0;w=i+16|0;b=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[b>>2]|0)>0){w=f[i+40>>2]|0;x=0;do{f[w+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[b>>2]|0))}b=f[i+44>>2]|0;if((b|0)!=(v|0))g0(b);b=f[h>>2]|0;if(!b){u=g;return}h=f[l>>2]|0;if((h|0)!=(b|0))f[l>>2]=h+(~(((h+-28-b|0)>>>0)/28|0)*28|0);YDc(b);u=g;return}function wLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0;e=u;u=u+288|0;g=e+224|0;h=e+168|0;i=e+56|0;j=e+112|0;k=e;f[h>>2]=1124007936;l=h+4|0;m=h+8|0;o=h+40|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=h+48|0;s=h+44|0;f[s>>2]=r;f[r>>2]=0;f[h+52>>2]=0;do if((d$(a)|0)==65536){t=f[a+4>>2]|0;f[i>>2]=f[t>>2];v=i+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=i+8|0;f[x>>2]=f[t+8>>2];f[i+12>>2]=f[t+12>>2];f[i+16>>2]=f[t+16>>2];f[i+20>>2]=f[t+20>>2];f[i+24>>2]=f[t+24>>2];f[i+28>>2]=f[t+28>>2];f[i+32>>2]=f[t+32>>2];y=i+36|0;z=f[t+36>>2]|0;f[y>>2]=z;f[i+40>>2]=x;x=i+48|0;A=i+44|0;f[A>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(z|0){x=z+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];B=y;C=i;break}else{f[v>>2]=0;ZS(i,t);B=y;C=i;break}}else{a$(i,a,-1);B=i+36|0;C=i}while(0);y=(f[C>>2]&16384|0)==0;C=f[B>>2]|0;if(C|0?(t=C+12|0,C=f[t>>2]|0,f[t>>2]=C+-1,(C|0)==1):0)_S(i);f[B>>2]=0;B=i+16|0;C=i+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){B=f[i+40>>2]|0;t=0;do{f[B+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[C>>2]|0))}C=f[i+44>>2]|0;if((C|0)!=(i+48|0))g0(C);if(y){do if((d$(a)|0)==65536){y=f[a+4>>2]|0;f[k>>2]=f[y>>2];C=k+4|0;i=y+4|0;f[C>>2]=f[i>>2];t=k+8|0;f[t>>2]=f[y+8>>2];f[k+12>>2]=f[y+12>>2];f[k+16>>2]=f[y+16>>2];f[k+20>>2]=f[y+20>>2];f[k+24>>2]=f[y+24>>2];f[k+28>>2]=f[y+28>>2];f[k+32>>2]=f[y+32>>2];B=f[y+36>>2]|0;f[k+36>>2]=B;f[k+40>>2]=t;t=k+48|0;v=k+44|0;f[v>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(B|0){t=B+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[i>>2]|0)<3){i=f[y+44>>2]|0;t=f[v>>2]|0;f[t>>2]=f[i>>2];f[t+4>>2]=f[i+4>>2];break}else{f[C>>2]=0;ZS(k,y);break}}else a$(k,a,-1);while(0);f[j>>2]=1124007936;y=j+4|0;C=j+8|0;i=j+40|0;p=y;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[i>>2]=C;p=j+48|0;q=j+44|0;f[q>>2]=p;f[p>>2]=0;f[j+52>>2]=0;t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(k,g);t=j+36|0;v=f[t>>2]|0;if(v|0){B=v+12|0;f[B>>2]=(f[B>>2]|0)+1}B=h+36|0;v=f[B>>2]|0;if(v|0?(w=v+12|0,v=f[w>>2]|0,f[w>>2]=v+-1,(v|0)==1):0)_S(h);f[B>>2]=0;v=h+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){w=f[o>>2]|0;x=0;do{f[w+(x<<2)>>2]=0;x=x+1|0;D=f[l>>2]|0}while((x|0)<(D|0));f[h>>2]=f[j>>2];if((D|0)<3)E=34;else E=36}else{f[h>>2]=f[j>>2];E=34}if((E|0)==34){D=f[y>>2]|0;if((D|0)<3){f[l>>2]=D;f[m>>2]=f[C>>2];f[h+12>>2]=f[j+12>>2];C=f[q>>2]|0;D=f[s>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2]}else E=36}if((E|0)==36)ZS(h,j);C=j+16|0;f[v>>2]=f[C>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];v=f[t>>2]|0;f[B>>2]=v;if(v|0?(B=v+12|0,v=f[B>>2]|0,f[B>>2]=v+-1,(v|0)==1):0)_S(j);f[t>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[y>>2]|0)>0){C=f[i>>2]|0;i=0;do{f[C+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[y>>2]|0))}y=f[q>>2]|0;if((y|0)!=(p|0))g0(y);y=k+36|0;p=f[y>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)_S(k);f[y>>2]=0;y=k+16|0;p=k+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[p>>2]|0)>0){y=f[k+40>>2]|0;q=0;do{f[y+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[p>>2]|0))}p=f[k+44>>2]|0;if((p|0)!=(k+48|0))g0(p)}else{do if((d$(a)|0)==65536){p=f[a+4>>2]|0;f[g>>2]=f[p>>2];k=g+4|0;q=p+4|0;f[k>>2]=f[q>>2];y=g+8|0;f[y>>2]=f[p+8>>2];f[g+12>>2]=f[p+12>>2];f[g+16>>2]=f[p+16>>2];f[g+20>>2]=f[p+20>>2];f[g+24>>2]=f[p+24>>2];f[g+28>>2]=f[p+28>>2];f[g+32>>2]=f[p+32>>2];i=g+36|0;C=f[p+36>>2]|0;f[i>>2]=C;f[g+40>>2]=y;y=g+48|0;t=g+44|0;f[t>>2]=y;f[y>>2]=0;f[g+52>>2]=0;if(C|0){y=C+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[q>>2]|0)<3){q=f[p+44>>2]|0;y=f[t>>2]|0;f[y>>2]=f[q>>2];f[y+4>>2]=f[q+4>>2];F=i;break}else{f[k>>2]=0;ZS(g,p);F=i;break}}else{a$(g,a,-1);F=g+36|0}while(0);a=f[F>>2]|0;if(a|0){i=a+12|0;f[i>>2]=(f[i>>2]|0)+1}i=h+36|0;a=f[i>>2]|0;if(a|0?(p=a+12|0,a=f[p>>2]|0,f[p>>2]=a+-1,(a|0)==1):0)_S(h);f[i>>2]=0;a=h+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[l>>2]|0)>0){p=f[o>>2]|0;k=0;do{f[p+(k<<2)>>2]=0;k=k+1|0;G=f[l>>2]|0}while((k|0)<(G|0));f[h>>2]=f[g>>2];if((G|0)<3)E=71;else E=73}else{f[h>>2]=f[g>>2];E=71}if((E|0)==71){G=f[g+4>>2]|0;if((G|0)<3){f[l>>2]=G;f[m>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];G=f[g+44>>2]|0;k=f[s>>2]|0;f[k>>2]=f[G>>2];f[k+4>>2]=f[G+4>>2]}else E=73}if((E|0)==73)ZS(h,g);G=g+16|0;f[a>>2]=f[G>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];a=f[F>>2]|0;f[i>>2]=a;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(g);f[F>>2]=0;F=g+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[F>>2]|0)>0){G=f[g+40>>2]|0;a=0;do{f[G+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[F>>2]|0))}F=f[g+44>>2]|0;if((F|0)!=(g+48|0))g0(F)}switch(d|0){case 0:{H=0;I=134492;J=131068;break}case 1:{H=2;I=132916;J=129492;break}case 2:{H=1;I=131532;J=128208;break}default:{H=2;I=125456;J=125456}}F=f[h+12>>2]|0;a=b+8|0;G=f[b>>2]|0;i=((f[a>>2]|0)-G|0)/28|0;k=-2-H+F|0;p=H+1|0;q=(f[m>>2]|0)-p|0;m=b+4|0;y=f[m>>2]|0;t=y;if(!((y|0)==(G|0)|(t|0)==(G|0)))f[m>>2]=t+(~(((t+-28-G|0)>>>0)/28|0)*28|0);oLb(g,f[r>>2]|0,d);a:do if((p|0)<(q|0)){d=h+16|0;G=j+4|0;t=j+8|0;y=j+12|0;C=j+16|0;v=j+20|0;B=j+24|0;D=j+4|0;x=j+8|0;w=j+12|0;A=j+16|0;z=j+20|0;K=j+24|0;L=p;M=i;N=0;b:while(1){O=Y(L,F)|0;P=+(L|0);Q=H;R=M;S=N;c:while(1){T=Q;d:while(1){U=T+1|0;if((T|0)>=(k|0)){V=S;W=R;break c}X=(pLb(I,g,(f[d>>2]|0)+O+U|0,c)|0)+-252|0;if(X>>>0>=4){Z=U;_=R;$=S;E=96;break}switch((-13400&65535)>>>((X&65535)<<2&65535)&7){case 0:{T=U;break}case 4:{aa=U;ba=S;ca=R;E=113;break d;break}case 3:{Z=U;_=R;$=S;E=96;break d;break}case 2:{da=U;ea=R;fa=S;E=100;break d;break}default:{E=136;break b}}}e:while(1)if((E|0)==96){E=0;T=Z;while(1){U=T+1|0;if((T|0)>=(k|0)){V=$;W=_;break c}X=(pLb(J,g,(f[d>>2]|0)+O+U|0,c)|0)+-252|0;if(X>>>0>=4){da=U;ea=_;fa=$;E=100;continue e}switch((-13400&65535)>>>((X&65535)<<2&65535)&7){case 0:{Q=U;R=_;S=$;continue c;break}case 4:{aa=U;ba=$;ca=_;E=113;continue e;break}case 2:{da=U;ea=_;fa=$;E=100;continue e;break}case 3:{T=U;break}default:{E=136;break b}}}}else if((E|0)==100){E=0;if((fa|0)==(ea|0)){E=101;break}else{ga=ea;break}}else if((E|0)==113){E=0;do if((ba|0)==(ca|0)){if(ba|0){T=ba<<1;pHb(b,T);ha=T;break}T=f[b>>2]|0;U=T;if((((f[a>>2]|0)-T|0)/28|0)>>>0<512){X=f[m>>2]|0;ia=VDc(14336)|0;ja=ia+(((X-T|0)/28|0)*28|0)|0;T=ja;ka=ia+14336|0;ia=X;if((ia|0)==(U|0)){la=T;ma=X}else{X=ia;ia=T;na=ja;do{ja=X;X=X+-28|0;f[na+-28>>2]=f[X>>2];f[na+-24>>2]=f[ja+-24>>2];oa=na+-20|0;pa=ja+-20|0;f[oa>>2]=f[pa>>2];f[oa+4>>2]=f[pa+4>>2];f[oa+8>>2]=f[pa+8>>2];f[oa+12>>2]=f[pa+12>>2];f[oa+16>>2]=f[pa+16>>2];na=ia+-28|0;ia=na}while((X|0)!=(U|0));la=ia;ma=f[b>>2]|0}f[b>>2]=la;f[m>>2]=T;f[a>>2]=ka;if(ma){YDc(ma);ha=512}else ha=512}else ha=512}else ha=ca;while(0);qa=+(aa|0);n[j>>2]=qa;n[G>>2]=P;n[t>>2]=7.0;n[y>>2]=-1.0;n[C>>2]=0.0;f[v>>2]=0;f[B>>2]=-1;U=f[m>>2]|0;if((U|0)==(f[a>>2]|0))V_(b,j);else{n[U>>2]=qa;n[U+4>>2]=P;X=U+8|0;f[X>>2]=f[t>>2];f[X+4>>2]=f[t+4>>2];f[X+8>>2]=f[t+8>>2];f[X+12>>2]=f[t+12>>2];f[X+16>>2]=f[t+16>>2];f[m>>2]=(f[m>>2]|0)+28}Z=aa;_=ha;$=ba+1|0;E=96;continue}do if((E|0)==101){E=0;if(fa|0){X=fa<<1;pHb(b,X);ga=X;break}X=f[b>>2]|0;U=X;if((((f[a>>2]|0)-X|0)/28|0)>>>0<512){na=f[m>>2]|0;pa=VDc(14336)|0;oa=pa+(((na-X|0)/28|0)*28|0)|0;X=oa;ja=pa+14336|0;pa=na;if((pa|0)==(U|0)){ra=X;sa=na}else{na=pa;pa=X;ta=oa;do{oa=na;na=na+-28|0;f[ta+-28>>2]=f[na>>2];f[ta+-24>>2]=f[oa+-24>>2];ua=ta+-20|0;va=oa+-20|0;f[ua>>2]=f[va>>2];f[ua+4>>2]=f[va+4>>2];f[ua+8>>2]=f[va+8>>2];f[ua+12>>2]=f[va+12>>2];f[ua+16>>2]=f[va+16>>2];ta=pa+-28|0;pa=ta}while((na|0)!=(U|0));ra=pa;sa=f[b>>2]|0}f[b>>2]=ra;f[m>>2]=X;f[a>>2]=ja;if(sa){YDc(sa);ga=512}else ga=512}else ga=512}while(0);qa=+(da|0);n[j>>2]=qa;n[D>>2]=P;n[x>>2]=7.0;n[w>>2]=-1.0;n[A>>2]=0.0;f[z>>2]=0;f[K>>2]=-1;U=f[m>>2]|0;if((U|0)==(f[a>>2]|0))V_(b,j);else{n[U>>2]=qa;n[U+4>>2]=P;na=U+8|0;f[na>>2]=f[x>>2];f[na+4>>2]=f[x+4>>2];f[na+8>>2]=f[x+8>>2];f[na+12>>2]=f[x+12>>2];f[na+16>>2]=f[x+16>>2];f[m>>2]=(f[m>>2]|0)+28}Q=da;R=ga;S=fa+1|0}L=L+1|0;if((L|0)>=(q|0))break a;else{M=W;N=V}}}while(0);V=h+36|0;W=f[V>>2]|0;if(W|0?(q=W+12|0,W=f[q>>2]|0,f[q>>2]=W+-1,(W|0)==1):0)_S(h);f[V>>2]=0;V=h+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[l>>2]|0)>0){V=f[o>>2]|0;o=0;do{f[V+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[s>>2]|0;if((l|0)==(r|0)){u=e;return}g0(l);u=e;return}function xLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/28|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0<=((g-h|0)/28|0)>>>0){j=a+4|0;k=((f[j>>2]|0)-h|0)/28|0;l=d>>>0>k>>>0;m=b+(k*28|0)|0;k=l?m:c;if((k|0)==(b|0))n=i;else{o=b;p=i;while(1){f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];q=p+8|0;r=o+8|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];o=o+28|0;r=p+28|0;if((o|0)==(k|0)){n=r;break}else p=r}}if(!l){l=f[j>>2]|0;if((l|0)==(n|0))return;f[j>>2]=l+(~(((l+-28-n|0)>>>0)/28|0)*28|0);return}if((k|0)==(c|0))return;k=m;m=f[j>>2]|0;do{f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];n=m+8|0;l=k+8|0;f[n>>2]=f[l>>2];f[n+4>>2]=f[l+4>>2];f[n+8>>2]=f[l+8>>2];f[n+12>>2]=f[l+12>>2];f[n+16>>2]=f[l+16>>2];k=k+28|0;m=(f[j>>2]|0)+28|0;f[j>>2]=m}while((k|0)!=(c|0));return}k=h;if(!h)s=g;else{g=a+4|0;m=f[g>>2]|0;if((m|0)!=(i|0))f[g>>2]=m+(~(((m+-28-h|0)>>>0)/28|0)*28|0);YDc(k);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;s=0}if(d>>>0>153391689)mCc(a);g=(s|0)/28|0;s=g<<1;k=g>>>0<76695844?(s>>>0<d>>>0?d:s):153391689;if(k>>>0>153391689)mCc(a);s=VDc(k*28|0)|0;d=a+4|0;f[d>>2]=s;f[a>>2]=s;f[e>>2]=s+(k*28|0);if((b|0)==(c|0))return;k=b;b=s;do{f[b>>2]=f[k>>2];f[b+4>>2]=f[k+4>>2];s=b+8|0;e=k+8|0;f[s>>2]=f[e>>2];f[s+4>>2]=f[e+4>>2];f[s+8>>2]=f[e+8>>2];f[s+12>>2]=f[e+12>>2];f[s+16>>2]=f[e+16>>2];k=k+28|0;b=(f[d>>2]|0)+28|0;f[d>>2]=b}while((k|0)!=(c|0));return}function yLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;g=VDc(16)|0;r0(g);f[g>>2]=134948;f[g+4>>2]=c;b[g+8>>0]=d&1;f[g+12>>2]=e<<16>>16;e=VDc(16)|0;d=e+4|0;f[d>>2]=1;f[e>>2]=135044;f[e+8>>2]=g;f[a>>2]=e;f[a+4>>2]=g;f[d>>2]=(f[d>>2]|0)+1;g=f[d>>2]|0;f[d>>2]=g+-1;if((g|0)!=1)return;Yi[f[(f[e>>2]|0)+8>>2]&2047](e);return}function zLb(a){a=a|0;YDc(a);return}function ALb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function BLb(a){a=a|0;THb(a);YDc(a);return}function CLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+192|0;h=g+136|0;i=g+80|0;j=g+32|0;k=g+16|0;l=g;if(r$(c)|0){m=f[d>>2]|0;n=d+4|0;o=f[n>>2]|0;if((o|0)==(m|0)){u=g;return}f[n>>2]=o+(~(((o+-28-m|0)>>>0)/28|0)*28|0);u=g;return}do if((d$(e)|0)==65536){m=f[e+4>>2]|0;f[h>>2]=f[m>>2];o=h+4|0;n=m+4|0;f[o>>2]=f[n>>2];p=h+8|0;f[p>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[n>>2]|0)<3){n=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[n>>2];f[p+4>>2]=f[n+4>>2];break}else{f[o>>2]=0;ZS(h,m);break}}else a$(h,e,-1);while(0);f[i>>2]=1124007936;e=i+4|0;m=i+8|0;o=i+40|0;n=e;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[o>>2]=m;m=i+48|0;n=i+44|0;f[n>>2]=m;f[m>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;p=j+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[j+32>>2]=j+8;p=j+40|0;f[j+36>>2]=p;f[j+44>>2]=0;f[p>>2]=0;p=c;r=f[p+4>>2]|0;q=k;f[q>>2]=f[p>>2];f[q+4>>2]=r;r=k+8|0;f[r>>2]=f[c+8>>2];q=k+12|0;f[q>>2]=f[c+12>>2];if(c$(c,-1)|0){p=(d$(c)|0)==655360;s=l+8|0;f[s>>2]=0;f[s+4>>2]=0;if(p){f[l>>2]=34209792;f[l+4>>2]=j}else{f[l>>2]=33619968;f[l+4>>2]=i}Oga(c,l,6,0);c=l;p=f[c+4>>2]|0;s=k;f[s>>2]=f[c>>2];f[s+4>>2]=p;f[r>>2]=f[l+8>>2];f[q>>2]=f[l+12>>2]}l=f[d>>2]|0;q=d+4|0;r=f[q>>2]|0;if((r|0)!=(l|0))f[q>>2]=r+(~(((r+-28-l|0)>>>0)/28|0)*28|0);vLb(k,d,f[a+4>>2]|0,(b[a+8>>0]|0)!=0,f[a+12>>2]|0);SHb(d,h);GQ(j);j=i+36|0;d=f[j>>2]|0;if(d|0?(a=d+12|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)_S(i);f[j>>2]=0;j=i+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[e>>2]|0)>0){j=f[o>>2]|0;o=0;do{f[j+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[e>>2]|0))}e=f[n>>2]|0;if((e|0)!=(m|0))g0(e);e=h+36|0;m=f[e>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)_S(h);f[e>>2]=0;e=h+16|0;m=h+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[h+40>>2]|0;n=0;do{f[e+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[h+44>>2]|0;if((m|0)!=(h+48|0))g0(m);u=g;return}function DLb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function ELb(a){a=a|0;return f[a+4>>2]|0}function FLb(a,c){a=a|0;c=c|0;b[a+8>>0]=c&1;return}function GLb(a){a=a|0;return (b[a+8>>0]|0)!=0|0}function HLb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ILb(a){a=a|0;return f[a+12>>2]|0}function JLb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;XHb(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;tT(a,(f[c>>2]|0)+5|0)|0;g=f[c>>2]|0;if(!g)h=0;else{dJc(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;b[c>>0]=b[464749]|0;b[c+1>>0]=b[464750]|0;b[c+2>>0]=b[464751]|0;b[c+3>>0]=b[464752]|0;b[c+4>>0]=b[464753]|0;uT(e);u=d;return}function KLb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=135064;b=f[a+84>>2]|0;if(b|0){c=a+88|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-32-b|0)>>>5)<<5);YDc(b)}b=f[a+72>>2]|0;if(b|0){d=a+76|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0)){THb(a);return}g0(b);THb(a);return}function LLb(a){a=a|0;KLb(a);YDc(a);return}function MLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;g=u;u=u+192|0;h=g+172|0;i=g+160|0;j=g+104|0;k=g+84|0;l=g+56|0;m=g;f[h>>2]=0;o=h+4|0;f[o>>2]=0;f[h+8>>2]=0;f[i>>2]=0;p=i+4|0;f[p>>2]=0;f[i+8>>2]=0;do if((d$(e)|0)==65536){q=f[e+4>>2]|0;f[j>>2]=f[q>>2];r=j+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;ZS(j,q);break}}else a$(j,e,-1);while(0);ei[f[(f[a>>2]|0)+64>>2]&511](a,c,i,h);c=f[i>>2]|0;a=(f[p>>2]|0)-c|0;e=(a|0)/12|0;q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;if((s|0)!=(q|0))f[r>>2]=s+(~(((s+-28-q|0)>>>0)/28|0)*28|0);a:do if((a|0)>0){q=m+4|0;s=m+8|0;t=m+12|0;w=m+16|0;v=m+40|0;x=m+48|0;y=m+44|0;z=m+52|0;A=l+8|0;B=l+12|0;C=l+4|0;D=m+36|0;E=k+12|0;F=k+8|0;G=k+4|0;H=j+16|0;I=l+4|0;J=l+8|0;K=l+12|0;L=l+16|0;N=l+20|0;O=l+24|0;P=d+8|0;Q=j+4|0;R=j+8|0;S=j+12|0;T=j+44|0;U=j+40|0;V=m+28|0;W=m+24|0;X=m+20|0;Z=0;_=c;while(1){$=f[h>>2]|0;aa=f[$+(Z<<4)>>2]|0;ba=f[$+(Z<<4)+4>>2]|0;ca=f[$+(Z<<4)+8>>2]|0;da=f[$+(Z<<4)+12>>2]|0;f[m>>2]=1124024332;f[q>>2]=2;$=f[_+(Z*12|0)+4>>2]|0;ea=f[_+(Z*12|0)>>2]|0;fa=$-ea|0;f[s>>2]=fa>>3;f[t>>2]=1;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;f[v>>2]=s;f[y>>2]=x;f[x>>2]=0;f[z>>2]=0;ga=ea;if((ga|0)!=($|0)){f[z>>2]=8;f[x>>2]=8;f[w>>2]=ga;f[X>>2]=ga;ga=ea+fa|0;f[W>>2]=ga;f[V>>2]=ga}f[A>>2]=0;f[B>>2]=0;f[l>>2]=16842752;f[C>>2]=m;Pxa(k,l);ga=f[D>>2]|0;if(ga|0?(fa=ga+12|0,ga=f[fa>>2]|0,f[fa>>2]=ga+-1,(ga|0)==1):0)_S(m);f[D>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[q>>2]|0)>0){ga=f[v>>2]|0;fa=0;do{f[ga+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[q>>2]|0))}fa=f[y>>2]|0;if((fa|0)!=(x|0))g0(fa);ha=+M(+(+n[E>>2]*+n[F>>2]));do if((ha>1.1920928955078125e-07?(ia=+n[k>>2],fa=mrc(ia)|0,ja=+n[G>>2],ga=mrc(ja)|0,(aa|0)<=(fa|0)&(fa|0)<(ca+aa|0)):0)?!((ba|0)>(ga|0)|(ga|0)>=(da+ba|0)):0){ea=f[H>>2]|0;if(ea|0){$=f[Q>>2]|0;if(($|0)<3)ka=Y(f[S>>2]|0,f[R>>2]|0)|0;else{la=f[U>>2]|0;ma=0;na=1;while(1){oa=Y(f[la+(ma<<2)>>2]|0,na)|0;ma=ma+1|0;if((ma|0)==($|0)){ka=oa;break}else na=oa}}if(!(($|0)==0|(ka|0)==0)?(na=ea+(Y(f[f[T>>2]>>2]|0,ga)|0)+fa|0,(b[na>>0]|0)==0):0)break}n[l>>2]=ia;n[I>>2]=ja;n[J>>2]=ha;n[K>>2]=-1.0;n[L>>2]=0.0;f[N>>2]=0;f[O>>2]=-1;na=f[r>>2]|0;if((na|0)==(f[P>>2]|0))V_(d,l);else{n[na>>2]=ia;n[na+4>>2]=ja;ma=na+8|0;f[ma>>2]=f[J>>2];f[ma+4>>2]=f[J+4>>2];f[ma+8>>2]=f[J+8>>2];f[ma+12>>2]=f[J+12>>2];f[ma+16>>2]=f[J+16>>2];f[r>>2]=(f[r>>2]|0)+28}}while(0);ba=Z+1|0;if((ba|0)>=(e|0))break a;Z=ba;_=f[i>>2]|0}}while(0);e=j+36|0;r=f[e>>2]|0;if(r|0?(l=r+12|0,r=f[l>>2]|0,f[l>>2]=r+-1,(r|0)==1):0)_S(j);f[e>>2]=0;e=j+16|0;r=j+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[r>>2]|0)>0){e=f[j+40>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[r>>2]|0))}r=f[j+44>>2]|0;if((r|0)!=(j+48|0))g0(r);r=f[i>>2]|0;if(r|0){j=f[p>>2]|0;if((j|0)==(r|0))pa=r;else{l=j;while(1){j=l+-12|0;f[p>>2]=j;e=f[j>>2]|0;if(!e)qa=j;else{j=l+-8|0;d=f[j>>2]|0;if((d|0)!=(e|0))f[j>>2]=d+(~((d+-8-e|0)>>>3)<<3);YDc(e);qa=f[p>>2]|0}if((qa|0)==(r|0))break;else l=qa}pa=f[i>>2]|0}YDc(pa)}pa=f[h>>2]|0;if(!pa){u=g;return}h=f[o>>2]|0;if((h|0)!=(pa|0))f[o>>2]=h+(~((h+-16-pa|0)>>>4)<<4);YDc(pa);u=g;return}function NLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;g=u;u=u+1248|0;i=g;j=g+1224|0;k=g+1216|0;l=g+1208|0;m=g+1136|0;o=g+1080|0;q=g+1024|0;r=g+1200|0;s=g+1192|0;do if((d$(c)|0)==65536){t=f[c+4>>2]|0;f[q>>2]=f[t>>2];v=q+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=q+8|0;f[x>>2]=f[t+8>>2];f[q+12>>2]=f[t+12>>2];f[q+16>>2]=f[t+16>>2];f[q+20>>2]=f[t+20>>2];f[q+24>>2]=f[t+24>>2];f[q+28>>2]=f[t+28>>2];f[q+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[q+36>>2]=y;f[q+40>>2]=x;x=q+48|0;z=q+44|0;f[z>>2]=x;f[x>>2]=0;f[q+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;ZS(q,t);break}}else a$(q,c,-1);while(0);c=f[d>>2]|0;t=d+4|0;v=f[t>>2]|0;if((v|0)!=(c|0)){w=v;while(1){v=w+-12|0;f[t>>2]=v;x=f[v>>2]|0;if(!x)A=v;else{v=w+-8|0;z=f[v>>2]|0;if((z|0)!=(x|0))f[v>>2]=z+(~((z+-8-x|0)>>>3)<<3);YDc(x);A=f[t>>2]|0}if((A|0)==(c|0))break;else w=A}}A=f[e>>2]|0;w=e+4|0;c=f[w>>2]|0;if((c|0)==(A|0))B=A;else{x=c+(~((c+-16-A|0)>>>4)<<4)|0;f[w>>2]=x;B=x}x=q+8|0;c=f[x>>2]|0;if((c|0)<3){f[i>>2]=0;C=i+4|0;f[C>>2]=0;D=tT(i,47)|0;E=D;F=464766;G=E+47|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-5,i,464814,464828,1047)}z=q+12|0;v=f[z>>2]|0;if((v|0)<3){f[i>>2]=0;C=i+4|0;f[C>>2]=0;D=tT(i,47)|0;E=D;F=464766;G=E+47|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-5,i,464814,464828,1047)}D=q+40|0;C=f[D>>2]|0;y=f[C+4>>2]|0;H=f[C>>2]|0;C=f[q>>2]|0;switch(C&4095){case 0:{if((C&16384|0)==0?(C=a+4|0,I=j+8|0,f[I>>2]=0,f[I+4>>2]=0,f[j>>2]=33619968,f[j+4>>2]=C,h_(q,j),(q|0)!=(C|0)):0){I=a+40|0;J=f[I>>2]|0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}K=q+36|0;J=f[K>>2]|0;if(J|0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0)_S(q);f[K>>2]=0;J=q+16|0;L=q+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[L>>2]|0)>0){M=f[D>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0;O=f[L>>2]|0}while((N|0)<(O|0));f[q>>2]=f[C>>2];if((O|0)<3)P=32;else P=34}else{f[q>>2]=f[C>>2];P=32}if((P|0)==32){O=f[a+8>>2]|0;if((O|0)<3){f[L>>2]=O;f[x>>2]=f[a+12>>2];f[z>>2]=f[a+16>>2];O=f[a+48>>2]|0;L=f[q+44>>2]|0;f[L>>2]=f[O>>2];f[L+4>>2]=f[O+4>>2]}else P=34}if((P|0)==34)ZS(q,C);f[J>>2]=f[a+20>>2];f[q+20>>2]=f[a+24>>2];f[q+24>>2]=f[a+28>>2];f[q+28>>2]=f[a+32>>2];f[q+32>>2]=f[a+36>>2];f[K>>2]=f[I>>2]}WLb(a,q,i);I=a+128|0;if(!(b[I>>0]|0)){f[r>>2]=y;f[r+4>>2]=H;XLb(a,q,d,e,r,i,0);Q=0}else Q=0;do{r=i+(Q<<2)|0;K=i+(255-Q<<2)|0;J=f[r>>2]|0;f[r>>2]=f[K>>2];f[K>>2]=J;Q=Q+1|0}while((Q|0)!=128);if(((b[I>>0]|0)==0?(I=f[z>>2]|0,Q=f[x>>2]|0,(Q+-1|0)>1):0)?(J=f[a+60>>2]|0,(I+-1|0)>1):0){K=I+1|0;r=(I<<2)+-8|0;C=Q+-2|0;Q=0;do{XIc(J+(K+(Y(Q,I)|0)<<2)|0,0,r|0)|0;Q=Q+1|0}while((Q|0)!=(C|0))}f[s>>2]=y;f[s+4>>2]=H;XLb(a,q,d,e,s,i,255);break}case 24:case 16:{if((B|0)!=(A|0))f[w>>2]=B+(~((B+-16-A|0)>>>4)<<4);A=h0(Y(v<<6,c)|0)|0;c=f[z>>2]|0;v=f[x>>2]|0;B=(Y(c<<1,v)|0)-c-v|0;v=h0(B<<4)|0;c=h0(Y((f[z>>2]|0)*24|0,f[x>>2]|0)|0)|0;s=f[x>>2]|0;H=(f[z>>2]|0)+-1|0;f[m>>2]=1124007936;y=m+4|0;C=m+8|0;Q=m+40|0;E=y;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[Q>>2]=C;C=m+48|0;r=m+44|0;f[r>>2]=C;f[C>>2]=0;f[m+52>>2]=0;f[i>>2]=s;s=i+4|0;f[s>>2]=H;XS(m,2,i,6);H=(f[x>>2]|0)+-1|0;I=f[z>>2]|0;f[o>>2]=1124007936;K=o+4|0;J=o+8|0;P=o+40|0;E=K;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[P>>2]=J;J=o+48|0;O=o+44|0;f[O>>2]=J;f[J>>2]=0;f[o+52>>2]=0;f[i>>2]=H;f[s>>2]=I;XS(o,2,i,6);I=f[a+152>>2]|0;s=f[q+48>>2]|0;H=f[z>>2]|0;L=(Y(H,-3)|0)+s|0;N=f[q+16>>2]|0;M=m+16|0;R=f[x>>2]|0;if((R|0)>0){S=L+3|0;T=H+-1|0;if((H|0)>1){U=(H*3|0)+-3|0;V=0;W=f[M>>2]|0;X=N+3|0;Z=N;while(1){_=0;$=W;aa=X;ba=Z;while(1){ca=h[ba>>0]|0;da=h[aa>>0]|0;ea=ca-da|0;fa=h[ba+1>>0]|0;ga=h[aa+1>>0]|0;ha=fa-ga|0;ia=h[ba+2>>0]|0;ja=h[aa+2>>0]|0;ka=ia-ja|0;la=+(Y(ea,ea)|0)/(+(da+ca|0)+1.0e-10)+ +(Y(ha,ha)|0)/(+(ga+fa|0)+1.0e-10)+ +(Y(ka,ka)|0)/(+(ja+ia|0)+1.0e-10);p[$>>3]=la;_=_+1|0;if((_|0)==(T|0))break;else{$=$+8|0;aa=aa+3|0;ba=ba+3|0}}V=V+1|0;if((V|0)==(R|0))break;else{W=W+(T<<3)|0;X=X+U+S|0;Z=Z+U+S|0}}}S=o+16|0;U=f[S>>2]|0;if((R|0)>1?(Z=R+-1|0,(H|0)>0):0){R=H*3|0;X=0;T=U;W=N+s|0;s=N;while(1){N=0;V=T;ba=W;aa=s;while(1){$=h[aa>>0]|0;_=h[ba>>0]|0;ia=$-_|0;ja=h[aa+1>>0]|0;ka=h[ba+1>>0]|0;fa=ja-ka|0;ga=h[aa+2>>0]|0;ha=h[ba+2>>0]|0;ca=ga-ha|0;la=+(Y(ia,ia)|0)/(+(_+$|0)+1.0e-10)+ +(Y(fa,fa)|0)/(+(ka+ja|0)+1.0e-10)+ +(Y(ca,ca)|0)/(+(ha+ga|0)+1.0e-10);p[V>>3]=la;N=N+1|0;if((N|0)==(H|0))break;else{V=V+8|0;ba=ba+3|0;aa=aa+3|0}}X=X+1|0;if((X|0)==(Z|0)){ma=S;na=U;break}else{T=T+(H<<3)|0;W=W+R+L|0;s=s+R+L|0}}}else{ma=S;na=U}}else{U=o+16|0;ma=U;na=f[U>>2]|0}if((I|0)>0){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=m;U=j+8|0;f[U>>2]=0;f[U+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=m;f[k>>2]=I;f[k+4>>2]=I;Gfa(i,j,k,0.0,0.0,4);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;k=j+8|0;f[k>>2]=0;f[k+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=o;f[l>>2]=I;f[l+4>>2]=I;Gfa(i,j,l,0.0,0.0,4);oa=f[z>>2]|0;pa=f[ma>>2]|0}else{oa=H;pa=na}na=f[M>>2]|0;f[A+12>>2]=0;f[A+16>>2]=0;f[A+28>>2]=65535;f[A+24>>2]=0;f[A+32>>2]=1;f[A+36>>2]=1;f[A>>2]=A;f[A+8>>2]=A;f[A+4>>2]=A;f[A+20>>2]=0;la=+p[na>>3];p[v>>3]=la;qa=la+0.0;f[v+8>>2]=A;H=A+64|0;f[v+12>>2]=H;ma=na+8|0;l=v+16|0;j=oa+-1|0;I=(j|0)>1;f[A+76>>2]=0;f[A+80>>2]=0;f[A+92>>2]=65535;f[A+88>>2]=0;f[A+96>>2]=1;f[A+100>>2]=1;f[H>>2]=H;f[A+72>>2]=H;f[A+68>>2]=H;if(I){k=A+((oa<<6)+-64)|0;U=(oa<<4)+-16|0;S=1;L=H;R=l;s=ma;la=qa;W=v;while(1){f[L+20>>2]=S;ra=+p[s>>3];p[R>>3]=ra;la=la+ra;f[W+24>>2]=L;T=L;L=L+64|0;f[W+28>>2]=L;S=S+1|0;f[T+76>>2]=0;f[T+80>>2]=0;f[T+92>>2]=65535;f[T+88>>2]=0;f[T+96>>2]=1;f[T+100>>2]=1;f[L>>2]=L;f[T+72>>2]=L;f[T+68>>2]=L;if((S|0)==(j|0))break;else{T=R;R=R+16|0;s=s+8|0;W=T}}sa=k;ta=v+U|0;ua=la;va=na+(j<<3)|0}else{sa=H;ta=l;ua=qa;va=ma}f[sa+20>>2]=j;ma=sa+64|0;l=f[x>>2]|0;x=l+-1|0;f[sa+76>>2]=0;f[sa+80>>2]=0;f[sa+92>>2]=65535;f[sa+88>>2]=0;f[sa+96>>2]=1;f[sa+100>>2]=1;f[ma>>2]=ma;f[sa+72>>2]=ma;f[sa+68>>2]=ma;do if((x|0)>1){H=0-oa|0;na=f[z>>2]|0;U=0-na|0;k=na+-1|0;if(I){na=1;W=sa;s=ta;qa=ua;R=ma;S=pa;L=va;while(1){T=na<<16;f[W+84>>2]=T;la=+p[S>>3];p[s>>3]=la;f[s+8>>2]=R+(H<<6);f[s+12>>2]=R;ra=+p[L>>3];p[s+16>>3]=ra;f[s+24>>2]=R;Z=W+128|0;f[s+28>>2]=Z;f[W+140>>2]=0;f[W+144>>2]=0;f[W+156>>2]=65535;f[W+152>>2]=0;f[W+160>>2]=1;f[W+164>>2]=1;f[Z>>2]=Z;f[W+136>>2]=Z;f[W+132>>2]=Z;X=1;aa=s;ba=s+32|0;V=Z;wa=qa+la+ra;Z=S+8|0;N=L+8|0;while(1){f[V+20>>2]=X|T;ra=+p[Z>>3];p[ba>>3]=ra;f[aa+40>>2]=V+(U<<6);f[aa+44>>2]=V;la=+p[N>>3];p[aa+48>>3]=la;wa=wa+ra+la;f[aa+56>>2]=V;xa=V+64|0;f[aa+60>>2]=xa;X=X+1|0;ya=ba+32|0;za=Z+8|0;N=N+8|0;f[V+76>>2]=0;f[V+80>>2]=0;f[V+92>>2]=65535;f[V+88>>2]=0;f[V+96>>2]=1;f[V+100>>2]=1;f[xa>>2]=xa;f[V+72>>2]=xa;f[V+68>>2]=xa;if((X|0)>=(k|0))break;else{ga=ba;ba=ya;V=xa;Z=za;aa=ga}}f[V+84>>2]=T|j;la=+p[za>>3];p[ya>>3]=la;ra=wa+la;aa=Z+16|0;f[ba+40>>2]=xa+(H<<6);f[ba+44>>2]=xa;X=ba+48|0;na=na+1|0;ga=V+128|0;f[V+140>>2]=0;f[V+144>>2]=0;f[V+156>>2]=65535;f[V+152>>2]=0;f[V+160>>2]=1;f[V+164>>2]=1;f[ga>>2]=ga;f[V+136>>2]=ga;f[V+132>>2]=ga;if((na|0)==(x|0)){Aa=xa;Ba=ga;Ca=X;Da=aa;Ea=N;Fa=ra;break}else{W=xa;s=X;qa=ra;R=ga;S=aa;L=N}}}else{L=l<<1;S=l+-2|0;R=(l*3|0)+-6|0;s=1;W=sa;na=ta;k=ma;U=pa;aa=va;qa=ua;while(1){ga=s<<16;f[W+84>>2]=ga;ra=+p[U>>3];p[na>>3]=ra;f[na+8>>2]=k+(H<<6);f[na+12>>2]=k;la=+p[aa>>3];p[na+16>>3]=la;f[na+24>>2]=k;X=W;W=W+128|0;f[na+28>>2]=W;f[X+140>>2]=0;f[X+144>>2]=0;f[X+156>>2]=65535;f[X+152>>2]=0;f[X+160>>2]=1;f[X+164>>2]=1;f[W>>2]=W;f[X+136>>2]=W;f[X+132>>2]=W;f[X+148>>2]=ga|j;Ga=+p[U+8>>3];p[na+32>>3]=Ga;qa=qa+ra+la+Ga;f[na+40>>2]=W+(H<<6);f[na+44>>2]=W;s=s+1|0;k=X+192|0;f[X+204>>2]=0;f[X+208>>2]=0;f[X+220>>2]=65535;f[X+216>>2]=0;f[X+224>>2]=1;f[X+228>>2]=1;f[k>>2]=k;f[X+200>>2]=k;f[X+196>>2]=k;if((s|0)==(x|0))break;else{na=na+48|0;U=U+16|0;aa=aa+8|0}}aa=L+-4|0;Aa=sa+(aa<<6)|0;Ba=sa+(L+-3<<6)|0;Ca=ta+(R<<4)|0;Da=pa+(aa<<3)|0;Ea=va+(S<<3)|0;Fa=qa;break}}else{Aa=sa;Ba=ma;Ca=ta;Da=pa;Ea=va;Fa=ua}while(0);va=(l<<16)+-65536|0;f[Aa+84>>2]=va;ua=+p[Ea>>3];p[Ca>>3]=ua;f[Ca+8>>2]=Ba;l=Aa+128|0;f[Ca+12>>2]=l;Ga=+p[Da>>3];p[Ca+16>>3]=Ga;la=Fa+ua+Ga;pa=f[z>>2]|0;z=0-pa|0;f[Ca+24>>2]=Ba+(z<<6);f[Ca+28>>2]=Ba;Ba=Da+8|0;Da=pa+-1|0;f[Aa+140>>2]=0;f[Aa+144>>2]=0;f[Aa+156>>2]=65535;f[Aa+152>>2]=0;f[Aa+160>>2]=1;f[Aa+164>>2]=1;f[l>>2]=l;f[Aa+136>>2]=l;f[Aa+132>>2]=l;if((Da|0)>1){Aa=1;pa=Ca;ta=Ea;Ea=l;ma=Ba;Ga=la;while(1){sa=pa+32|0;ta=ta+8|0;f[Ea+20>>2]=Aa|va;ua=+p[ta>>3];p[sa>>3]=ua;f[pa+40>>2]=Ea;x=Ea+64|0;f[pa+44>>2]=x;Fa=+p[ma>>3];p[pa+48>>3]=Fa;ra=Ga+ua+Fa;f[pa+56>>2]=Ea+(z<<6);f[pa+60>>2]=Ea;Aa=Aa+1|0;j=ma+8|0;f[Ea+76>>2]=0;f[Ea+80>>2]=0;f[Ea+92>>2]=65535;f[Ea+88>>2]=0;f[Ea+96>>2]=1;f[Ea+100>>2]=1;f[x>>2]=x;f[Ea+72>>2]=x;f[Ea+68>>2]=x;if((Aa|0)>=(Da|0)){Ha=sa;Ia=x;Ja=j;Ka=ra;break}else{pa=sa;Ea=x;ma=j;Ga=ra}}}else{Ha=Ca;Ia=l;Ja=Ba;Ka=la}f[Ia+20>>2]=Da|va;la=+p[Ja>>3];p[Ha+32>>3]=la;f[Ha+40>>2]=Ia+(z<<6);f[Ha+44>>2]=Ia;Ga=(Ka+la)/+(B|0);Ia=v+(B<<4)|0;YLb(v,Ia,i);B=f[a+132>>2]|0;a:do if((B|0)>0){Ha=a+136|0;z=a+100|0;Ja=a+104|0;va=a+120|0;la=+(B|0);Da=v;Ba=c;l=0;while(1){Ka=+(l|0)/la*399.0;Ca=~~Ka;ma=Ca-(+(Ca|0)>Ka&1)|0;ra=Ka-+(ma|0);Ka=Ga*(+n[135164+(ma+1<<2)>>2]*ra+ +n[135164+(ma<<2)>>2]*(1.0-ra));if(Da>>>0<Ia>>>0){La=Da;Ma=Ba}else{Na=Ba;break a}while(1){ra=+p[La>>3];if(!(ra<Ka))break;ma=f[La+8>>2]|0;Ca=ma;Ea=ma;while(1){ma=f[Ca>>2]|0;f[Ca>>2]=Ea;if((ma|0)==(Ca|0))break;else{pa=Ca;Ca=ma;Ea=pa}}f[Ca>>2]=Ca;if((Ea|0)!=(Ca|0)){pa=Ea;do{ma=pa;pa=f[pa>>2]|0;f[ma>>2]=Ca}while((pa|0)!=(ma|0))}pa=f[La+12>>2]|0;Ea=pa;ma=pa;while(1){pa=f[Ea>>2]|0;f[Ea>>2]=ma;if((pa|0)==(Ea|0))break;else{Aa=Ea;Ea=pa;ma=Aa}}f[Ea>>2]=Ea;if((ma|0)!=(Ea|0)){Aa=ma;do{pa=Aa;Aa=f[Aa>>2]|0;f[pa>>2]=Ea}while((Aa|0)!=(pa|0))}do if((Ca|0)==(Ea|0))Oa=Ma;else{Aa=f[Ea+24>>2]|0;ma=f[Ca+24>>2]|0;do if((Aa|0)>(ma|0)){Pa=Ca;Qa=Ea}else{if((ma|0)!=(Aa|0)){Pa=Ea;Qa=Ca;break}pa=(f[Ca+32>>2]|0)>(f[Ea+32>>2]|0);ta=pa?Ea:Ca;j=ta+24|0;f[j>>2]=(f[j>>2]|0)+1;Pa=pa?Ca:Ea;Qa=ta}while(0);f[Pa>>2]=Qa;Aa=Pa+32|0;ma=Qa+32|0;ta=(f[ma>>2]|0)+(f[Aa>>2]|0)|0;f[ma>>2]=ta;ma=Qa+4|0;f[(f[ma>>2]|0)+8>>2]=Pa;pa=Pa+4|0;f[ma>>2]=f[pa>>2];f[(f[pa>>2]|0)+8>>2]=Qa;f[pa>>2]=Qa;Fa=+(ta|0);if(Fa>+p[Ha>>3]*+(ta-(f[Aa>>2]|0)|0)){f[Qa+36>>2]=ta;f[Qa+28>>2]=l;Aa=Qa+12|0;pa=f[Aa>>2]|0;if(!pa)Ra=Qa+48|0;else{j=Qa+48|0;p[pa+8>>3]=+p[Qa+40>>3]-+p[j>>3];f[Aa>>2]=0;Ra=j}p[Ra>>3]=ra;p[Qa+56>>3]=1.0e10;Sa=l}else Sa=f[Qa+28>>2]|0;p[Qa+40>>3]=ra;if((l|0)<=(Sa|0)){Oa=Ma;break}ua=+(ta-(f[Qa+36>>2]|0)|0)/(ra-+p[Qa+48>>3]);j=Qa+56|0;if(!(ua<+p[j>>3])){Oa=Ma;break}do if((l|0)>(Sa+1|0)){if(!((ta|0)>(f[z>>2]|0)?(ta|0)<(f[Ja>>2]|0):0)){Ta=Ma;break}Aa=Qa+16|0;pa=f[Aa>>2]|0;if(pa|0?!(+(ta-(f[pa+16>>2]|0)|0)/Fa>+p[va>>3]):0){Ta=Ma;break}pa=Qa+12|0;x=f[pa>>2]|0;if(!x){f[pa>>2]=Ma;f[Aa>>2]=Ma;Ua=Ma+24|0;Va=Ma}else{Ua=Ma;Va=x}f[Va+16>>2]=ta;f[Va>>2]=Qa;f[Va+4>>2]=f[ma>>2];p[Va+8>>3]=0.0;Ta=Ua}else Ta=Ma;while(0);p[j>>3]=ua;Oa=Ta}while(0);Ea=La+16|0;if(Ea>>>0<Ia>>>0){La=Ea;Ma=Oa}else{Na=Oa;break a}}l=l+1|0;if((l|0)>=(B|0)){Na=Ma;break}else{Da=La;Ba=Ma}}}else Na=c;while(0);if(c>>>0<Na>>>0){Ma=a+144|0;a=i+4|0;La=i+8|0;B=d+8|0;Oa=i+4|0;Ia=i+8|0;Ta=i+12|0;Ua=e+8|0;Va=i+4|0;Qa=c;do{if(+p[Qa+8>>3]>+p[Ma>>3]){Sa=f[Qa>>2]|0;f[i>>2]=0;f[a>>2]=0;f[La>>2]=0;Ra=f[t>>2]|0;if((Ra|0)==(f[B>>2]|0))_Lb(d,i);else{ZLb(Ra,i);f[t>>2]=(f[t>>2]|0)+12}Ra=f[i>>2]|0;if(Ra|0){Pa=f[a>>2]|0;if((Pa|0)!=(Ra|0))f[a>>2]=Pa+(~((Pa+-8-Ra|0)>>>3)<<3);YDc(Ra)}Ra=f[t>>2]|0;Pa=Ra+-12|0;Ba=Qa+16|0;Da=f[Ba>>2]|0;if((Da|0)>0){l=Ra+-8|0;va=Ra+-4|0;Ra=Sa;Sa=-2147483648;Ja=-2147483648;z=2147483647;Ha=2147483647;S=0;R=Da;while(1){Da=f[Ra+20>>2]|0;L=Da&65535;f[i>>2]=L;N=Da>>16;f[Va>>2]=N;Da=(L|0)<(Ha|0)?L:Ha;V=(Ja|0)<(L|0)?L:Ja;ba=(N|0)<(z|0)?N:z;Z=(Sa|0)<(N|0)?N:Sa;Ra=f[Ra+8>>2]|0;T=f[l>>2]|0;if((T|0)==(f[va>>2]|0)){fga(Pa,i);Wa=f[Ba>>2]|0}else{f[T>>2]=L;f[T+4>>2]=N;f[l>>2]=T+8;Wa=R}S=S+1|0;if((S|0)>=(Wa|0)){Xa=Z;Ya=V;Za=Da;_a=ba;break}else{Sa=Z;Ja=V;z=ba;Ha=Da;R=Wa}}}else{Xa=-2147483648;Ya=-2147483648;Za=2147483647;_a=2147483647}R=Ya+(1-Za)|0;Ha=Xa+(1-_a)|0;f[i>>2]=Za;f[Oa>>2]=_a;f[Ia>>2]=R;f[Ta>>2]=Ha;z=f[w>>2]|0;if((z|0)==(f[Ua>>2]|0))$Lb(e,i);else{f[z>>2]=Za;f[z+4>>2]=_a;f[z+8>>2]=R;f[z+12>>2]=Ha;f[w>>2]=z+16}}Qa=Qa+24|0}while(Qa>>>0<Na>>>0)}i0(c);i0(v);i0(A);A=o+36|0;v=f[A>>2]|0;if(v|0?(c=v+12|0,v=f[c>>2]|0,f[c>>2]=v+-1,(v|0)==1):0)_S(o);f[A>>2]=0;A=o+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[K>>2]|0)>0){A=f[P>>2]|0;P=0;do{f[A+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[K>>2]|0))}K=f[O>>2]|0;if((K|0)!=(J|0))g0(K);K=m+36|0;J=f[K>>2]|0;if(J|0?(O=J+12|0,J=f[O>>2]|0,f[O>>2]=J+-1,(J|0)==1):0)_S(m);f[K>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[y>>2]|0)>0){M=f[Q>>2]|0;Q=0;do{f[M+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[y>>2]|0))}y=f[r>>2]|0;if((y|0)!=(C|0))g0(y);break}default:{f[i>>2]=0;f[i+4>>2]=0;E=tT(i,46)|0;F=464897;G=E+46|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,i,464814,464828,1070)}}i=q+36|0;F=f[i>>2]|0;if(F|0?(E=F+12|0,F=f[E>>2]|0,f[E>>2]=F+-1,(F|0)==1):0)_S(q);f[i>>2]=0;i=q+16|0;F=q+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[F>>2]|0)>0){i=f[D>>2]|0;D=0;do{f[i+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[F>>2]|0))}F=f[q+44>>2]|0;if((F|0)==(q+48|0)){u=g;return}g0(F);u=g;return}function OLb(a,b){a=a|0;b=b|0;f[a+96>>2]=b;return}function PLb(a){a=a|0;return f[a+96>>2]|0}function QLb(a,b){a=a|0;b=b|0;f[a+100>>2]=b;return}function RLb(a){a=a|0;return f[a+100>>2]|0}function SLb(a,b){a=a|0;b=b|0;f[a+104>>2]=b;return}function TLb(a){a=a|0;return f[a+104>>2]|0}function ULb(a,c){a=a|0;c=c|0;b[a+128>>0]=c&1;return}function VLb(a){a=a|0;return (b[a+128>>0]|0)!=0|0}function WLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;XIc(c|0,0,1024)|0;d=f[b+12>>2]|0;e=f[b+8>>2]|0;g=a+60|0;i=Y(e,d)|0;j=a+64|0;k=f[j>>2]|0;l=f[g>>2]|0;m=k-l>>2;n=l;l=k;if(i>>>0<=m>>>0){if(i>>>0<m>>>0?(k=n+(i<<2)|0,(l|0)!=(k|0)):0)f[j>>2]=l+(~((l+-4-k|0)>>>2)<<2)}else gMb(g,i-m|0);m=a+72|0;k=i+256|0;l=a+76|0;j=f[l>>2]|0;n=f[m>>2]|0;o=j-n>>2;p=n;n=j;if(k>>>0<=o>>>0){if(k>>>0<o>>>0?(j=p+(k<<2)|0,(n|0)!=(j|0)):0)f[l>>2]=n+(~((n+-4-j|0)>>>2)<<2)}else hMb(m,k-o|0);o=a+84|0;k=a+88|0;a=f[k>>2]|0;m=f[o>>2]|0;j=a-m>>5;n=m;m=a;if(i>>>0<=j>>>0){if(i>>>0<j>>>0?(a=n+(i<<5)|0,(m|0)!=(a|0)):0)f[k>>2]=m+(~((m+-32-a|0)>>>5)<<5)}else iMb(o,i-j|0);j=e+-1|0;if((d|0)>0){e=Y(j,d)|0;i=f[g>>2]|0;o=0;do{f[i+(o+e<<2)>>2]=-1610612736;f[i+(o<<2)>>2]=-1610612736;o=o+1|0}while((o|0)!=(d|0))}if((j|0)<=1)return;o=d+-1|0;if((o|0)<=1){i=f[g>>2]|0;e=1;do{a=i+((Y(e,d)|0)<<2)|0;f[a+(o<<2)>>2]=-1610612736;f[a>>2]=-1610612736;e=e+1|0}while((e|0)!=(j|0));return}e=f[b+16>>2]|0;i=f[b+44>>2]|0;b=f[g>>2]|0;g=1;do{a=e+(Y(f[i>>2]|0,g)|0)|0;m=b+((Y(g,d)|0)<<2)|0;f[m+(o<<2)>>2]=-1610612736;f[m>>2]=-1610612736;k=1;do{n=c+((h[a+k>>0]|0)<<2)|0;f[n>>2]=(f[n>>2]|0)+1;f[m+(k<<2)>>2]=0;k=k+1|0}while((k|0)!=(o|0));g=g+1|0}while((g|0)!=(j|0));return}function XLb(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=u;u=u+6288|0;l=k+6272|0;m=k+5248|0;n=k+108|0;o=k;p=k+88|0;q=k+80|0;f[l>>2]=f[a+84>>2];r=f[g>>2]|0;g=f[a+60>>2]|0;s=r+1|0;t=f[c+16>>2]|0;XIc(n|0,0,5140)|0;c=g+(s<<2)|0;v=o;w=a+96|0;x=v+60|0;do{f[v>>2]=f[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));f[o+64>>2]=d;f[o+68>>2]=e;f[o+72>>2]=g;f[o+76>>2]=r;e=f[a+72>>2]|0;f[m>>2]=e;f[e>>2]=0;a=1;d=e;do{d=d+(f[i+(a+-1<<2)>>2]<<2)+4|0;f[m+(a<<2)>>2]=d;f[d>>2]=0;a=a+1|0}while((a|0)!=256);f[n+12>>2]=256;a=g;f[n+32>>2]=(h[t+(s<<2>>2)>>0]|0)^j;s=f[c>>2]&536870911|536870912;f[c>>2]=s;f[p>>2]=0;f[p+4>>2]=1;f[p+8>>2]=r;f[p+12>>2]=-1;f[p+16>>2]=0-r;r=c;c=n+20|0;n=s;a:while(1){s=(h[t+(r-a>>2)>>0]|0)^j;d=n>>>29;b:do if(n>>>0<2684354560){i=s;e=d;y=c;z=r;while(1){A=e;while(1){B=z+(f[p+(A<<2)>>2]<<2)|0;if((f[B>>2]|0)>>>0<=536870911){f[B>>2]=536870912;C=(h[t+(B-a>>2)>>0]|0)^j;if((C|0)<(i|0))break;D=m+(C<<2)|0;E=(f[D>>2]|0)+4|0;f[D>>2]=E;f[E>>2]=B}E=A+1|0;if((E|0)<5)A=E;else{F=i;G=E;H=z;I=y;break b}}E=m+(i<<2)|0;D=(f[E>>2]|0)+4|0;f[E>>2]=D;f[D>>2]=z;f[z>>2]=(A<<29)+536870912;D=y+20|0;f[y+24>>2]=0;f[D>>2]=0;f[y+28>>2]=0;f[y+36>>2]=0;f[y+32>>2]=C;i=C;e=1;y=D;z=B}}else{F=s;G=d;H=r;I=c}while(0);f[H>>2]=G<<29;d=H-a>>2;if(!d){J=12;break}s=I+4|0;z=f[s>>2]|0;if(!z)f[I>>2]=d;else{y=g+(z<<2)|0;f[y>>2]=f[y>>2]&-536870912|d}f[s>>2]=d;d=I+16|0;f[d>>2]=(f[d>>2]|0)+1;d=m+(F<<2)|0;s=f[d>>2]|0;y=f[s>>2]|0;do if(!y){z=F;while(1){K=z+1|0;if((K|0)>=256)break a;L=m+(K<<2)|0;M=f[L>>2]|0;N=f[M>>2]|0;if(!N)z=K;else break}if((z|0)>254)break a;f[L>>2]=M+-4;e=I+-20|0;if((K|0)<(f[I+-8>>2]|0)){cMb(I,l,o,K,0);O=N;P=I;break}else{dMb(e,e,I,l,o);O=N;P=e;break}}else{f[d>>2]=s+-4;O=y;P=I}while(0);r=O;c=P;n=f[O>>2]|0}if((J|0)==12){f[q>>2]=0;f[q+4>>2]=0;v=tT(q,11)|0;w=464944;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,q,464956,464828,490)}if((f[I+12>>2]|0)==256){u=k;return}else Q=I;while(1){cMb(Q,l,o,256,1);if((f[Q+-8>>2]|0)==256)break;else Q=Q+-20|0}u=k;return}function YLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-16|0;i=g;while(1){j=i;b:while(1){k=j;l=b-k|0;m=l>>4;switch(m|0){case 2:{n=5;break a;break}case 3:{n=7;break a;break}case 4:{n=15;break a;break}case 5:{n=16;break a;break}case 1:case 0:{n=83;break a;break}default:{}}if((l|0)<496){n=22;break a}o=j+(((m|0)/2|0)<<4)|0;do if((l|0)>15984){q=(m|0)/4|0;r=j+(q<<4)|0;s=o+(q<<4)|0;q=aMb(j,r,o,s,c)|0;if(!(+p[h>>3]<+p[s>>3])){t=q;v=o;break};f[e>>2]=f[s>>2];f[e+4>>2]=f[s+4>>2];f[e+8>>2]=f[s+8>>2];f[e+12>>2]=f[s+12>>2];f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[s+8>>2]=f[h+8>>2];f[s+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];w=q+1|0;if(+p[s>>3]<+p[o>>3]){f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[s>>2];f[o+4>>2]=f[s+4>>2];f[o+8>>2]=f[s+8>>2];f[o+12>>2]=f[s+12>>2];f[s>>2]=f[e>>2];f[s+4>>2]=f[e+4>>2];f[s+8>>2]=f[e+8>>2];f[s+12>>2]=f[e+12>>2];s=q+2|0;if(+p[o>>3]<+p[r>>3]){f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];f[o+8>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];if(+p[r>>3]<+p[j>>3]){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2];f[j+8>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];t=q+4|0;v=o}else{t=q+3|0;v=o}}else{t=s;v=o}}else{t=w;v=o}}else{x=+p[o>>3];w=+p[h>>3]<x;if(!(x<+p[j>>3])){if(!w){t=0;v=o;break};f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];f[o+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+p[o>>3]<+p[j>>3])){t=1;v=o;break};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];f[o+8>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];t=2;v=o;break}if(w){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];f[j+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];t=1;v=o;break};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];f[o+8>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];if(+p[h>>3]<+p[o>>3]){f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];f[o+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];t=2;v=o}else{t=1;v=o}}while(0);x=+p[j>>3];y=+p[v>>3];if(x<y){z=h;A=t;break}else B=h;while(1){B=B+-16|0;if((j|0)==(B|0))break;if(+p[B>>3]<y){n=66;break b}}m=j+16|0;if(x<+p[h>>3])C=m;else{if((m|0)==(h|0)){n=83;break a}else D=m;while(1){if(x<+p[D>>3])break;m=D+16|0;if((m|0)==(h|0)){n=83;break a}else D=m}f[e>>2]=f[D>>2];f[e+4>>2]=f[D+4>>2];f[e+8>>2]=f[D+8>>2];f[e+12>>2]=f[D+12>>2];f[D>>2]=f[h>>2];f[D+4>>2]=f[h+4>>2];f[D+8>>2]=f[h+8>>2];f[D+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];C=D+16|0}if((C|0)==(h|0)){n=83;break a}else{E=h;F=C}while(1){x=+p[j>>3];m=F;while(1){G=m+16|0;if(x<+p[m>>3]){H=E;break}else m=G}do H=H+-16|0;while(x<+p[H>>3]);if(m>>>0>=H>>>0){j=m;continue b};f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[m>>2]=f[H>>2];f[m+4>>2]=f[H+4>>2];f[m+8>>2]=f[H+8>>2];f[m+12>>2]=f[H+12>>2];f[H>>2]=f[e>>2];f[H+4>>2]=f[e+4>>2];f[H+8>>2]=f[e+8>>2];f[H+12>>2]=f[e+12>>2];E=H;F=G}}if((n|0)==66){n=0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[B>>2];f[j+4>>2]=f[B+4>>2];f[j+8>>2]=f[B+8>>2];f[j+12>>2]=f[B+12>>2];f[B>>2]=f[e>>2];f[B+4>>2]=f[e+4>>2];f[B+8>>2]=f[e+8>>2];f[B+12>>2]=f[e+12>>2];z=B;A=t+1|0}l=j+16|0;c:do if(l>>>0<z>>>0){w=o;s=z;q=l;r=A;while(1){x=+p[w>>3];I=q;while(1){J=I+16|0;if(+p[I>>3]<x)I=J;else{K=s;break}}do K=K+-16|0;while(!(+p[K>>3]<x));if(I>>>0>K>>>0){L=w;M=r;N=I;break c};f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[I>>2]=f[K>>2];f[I+4>>2]=f[K+4>>2];f[I+8>>2]=f[K+8>>2];f[I+12>>2]=f[K+12>>2];f[K>>2]=f[e>>2];f[K+4>>2]=f[e+4>>2];f[K+8>>2]=f[e+8>>2];f[K+12>>2]=f[e+12>>2];w=(w|0)==(I|0)?K:w;s=K;q=J;r=r+1|0}}else{L=o;M=A;N=l}while(0);if((N|0)!=(L|0)?+p[L>>3]<+p[N>>3]:0){f[e>>2]=f[N>>2];f[e+4>>2]=f[N+4>>2];f[e+8>>2]=f[N+8>>2];f[e+12>>2]=f[N+12>>2];f[N>>2]=f[L>>2];f[N+4>>2]=f[L+4>>2];f[N+8>>2]=f[L+8>>2];f[N+12>>2]=f[L+12>>2];f[L>>2]=f[e>>2];f[L+4>>2]=f[e+4>>2];f[L+8>>2]=f[e+8>>2];f[L+12>>2]=f[e+12>>2];O=M+1|0}else O=M;if(!O){P=bMb(j,N,c)|0;l=N+16|0;if(bMb(l,a,c)|0){n=82;break}if(P){i=l;continue}}l=N;if((l-k|0)>=(b-l|0)){n=81;break}YLb(j,N,c);i=N+16|0}if((n|0)==81){n=0;YLb(N+16|0,a,c);g=j;a=N;continue}else if((n|0)==82){n=0;if(P){n=83;break}else{g=j;a=N;continue}}}if((n|0)==5){if(!(+p[h>>3]<+p[j>>3])){u=d;return};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];f[j+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((n|0)==7){N=j+16|0;x=+p[N>>3];g=+p[h>>3]<x;if(!(x<+p[j>>3])){if(!g){u=d;return};f[e>>2]=f[N>>2];f[e+4>>2]=f[N+4>>2];f[e+8>>2]=f[N+8>>2];f[e+12>>2]=f[N+12>>2];f[N>>2]=f[h>>2];f[N+4>>2]=f[h+4>>2];f[N+8>>2]=f[h+8>>2];f[N+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+p[N>>3]<+p[j>>3])){u=d;return};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[j+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];u=d;return}if(g){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];f[j+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[j+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];if(!(+p[h>>3]<+p[N>>3])){u=d;return};f[e>>2]=f[N>>2];f[e+4>>2]=f[N+4>>2];f[e+8>>2]=f[N+8>>2];f[e+12>>2]=f[N+12>>2];f[N>>2]=f[h>>2];f[N+4>>2]=f[h+4>>2];f[N+8>>2]=f[h+8>>2];f[N+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((n|0)==15){aMb(j,j+16|0,j+32|0,h,c)|0;u=d;return}else if((n|0)==16){N=j+16|0;g=j+32|0;P=j+48|0;aMb(j,N,g,P,c)|0;if(!(+p[h>>3]<+p[P>>3])){u=d;return};f[e>>2]=f[P>>2];f[e+4>>2]=f[P+4>>2];f[e+8>>2]=f[P+8>>2];f[e+12>>2]=f[P+12>>2];f[P>>2]=f[h>>2];f[P+4>>2]=f[h+4>>2];f[P+8>>2]=f[h+8>>2];f[P+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+p[P>>3]<+p[g>>3])){u=d;return};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[P>>2];f[g+4>>2]=f[P+4>>2];f[g+8>>2]=f[P+8>>2];f[g+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];if(!(+p[g>>3]<+p[N>>3])){u=d;return};f[e>>2]=f[N>>2];f[e+4>>2]=f[N+4>>2];f[e+8>>2]=f[N+8>>2];f[e+12>>2]=f[N+12>>2];f[N>>2]=f[g>>2];f[N+4>>2]=f[g+4>>2];f[N+8>>2]=f[g+8>>2];f[N+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+p[N>>3]<+p[j>>3])){u=d;return};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[j+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];u=d;return}else if((n|0)==22){N=j+32|0;g=j+16|0;x=+p[g>>3];y=+p[j>>3];Q=+p[N>>3];P=Q<x;do if(x<y){if(P){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[j+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];break};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(Q<+p[g>>3]){f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[N>>2];f[g+4>>2]=f[N+4>>2];f[g+8>>2]=f[N+8>>2];f[g+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2]}}else if(P?(f[e>>2]=f[g>>2],f[e+4>>2]=f[g+4>>2],f[e+8>>2]=f[g+8>>2],f[e+12>>2]=f[g+12>>2],f[g>>2]=f[N>>2],f[g+4>>2]=f[N+4>>2],f[g+8>>2]=f[N+8>>2],f[g+12>>2]=f[N+12>>2],f[N>>2]=f[e>>2],f[N+4>>2]=f[e+4>>2],f[N+8>>2]=f[e+8>>2],f[N+12>>2]=f[e+12>>2],+p[g>>3]<y):0){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2]}while(0);e=j+48|0;if((e|0)==(a|0)){u=d;return}else{R=e;S=N}while(1){y=+p[R>>3];if(y<+p[S>>3]){N=R+8|0;e=f[N>>2]|0;g=f[N+4>>2]|0;N=S;P=R;while(1){f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];f[P+12>>2]=f[N+12>>2];if((N|0)==(j|0)){T=j;break}h=N+-16|0;if(y<+p[h>>3]){c=N;N=h;P=c}else{T=N;break}}p[T>>3]=y;N=T+8|0;f[N>>2]=e;f[N+4>>2]=g}N=R+16|0;if((N|0)==(a|0))break;else{P=R;R=N;S=P}}u=d;return}else if((n|0)==83){u=d;return}}function ZLb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=b+-8-g|0;a=g;g=h;while(1){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];a=a+8|0;if((a|0)==(b|0))break;else g=g+8|0}f[c>>2]=h+((d>>>3)+1<<3);return}function _Lb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;ZLb(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-12|0;ZLb(e+-12|0,i);e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-8-b|0)>>>3)<<3);YDc(b)}}while((h|0)!=(g|0))}if(!m)return;YDc(m);return}function $Lb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function aMb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=+p[b>>3];i=+p[c>>3]<h;do if(h<+p[a>>3]){if(i){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];j=1;break};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];if(+p[c>>3]<+p[b>>3]){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];j=2}else j=1}else if(i){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(+p[b>>3]<+p[a>>3]){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];j=2}else j=1}else j=0;while(0);if(!(+p[d>>3]<+p[c>>3])){k=j;u=e;return k|0};f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[g+8>>2]=f[c+8>>2];f[g+12>>2]=f[c+12>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];if(!(+p[c>>3]<+p[b>>3])){k=j+1|0;u=e;return k|0};f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(!(+p[b>>3]<+p[a>>3])){k=j+2|0;u=e;return k|0};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];k=j+3|0;u=e;return k|0}function bMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;switch(b-a>>4|0){case 2:{g=b+-16|0;if(!(+p[g>>3]<+p[a>>3])){h=1;u=d;return h|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];h=1;u=d;return h|0}case 3:{g=a+16|0;i=b+-16|0;j=+p[g>>3];k=+p[i>>3]<j;if(!(j<+p[a>>3])){if(!k){h=1;u=d;return h|0};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];if(!(+p[g>>3]<+p[a>>3])){h=1;u=d;return h|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];h=1;u=d;return h|0}if(k){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];h=1;u=d;return h|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+p[i>>3]<+p[g>>3])){h=1;u=d;return h|0};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];h=1;u=d;return h|0}case 4:{aMb(a,a+16|0,a+32|0,b+-16|0,c)|0;h=1;u=d;return h|0}case 5:{i=a+16|0;g=a+32|0;k=a+48|0;l=b+-16|0;aMb(a,i,g,k,c)|0;if(!(+p[l>>3]<+p[k>>3])){h=1;u=d;return h|0};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];if(!(+p[k>>3]<+p[g>>3])){h=1;u=d;return h|0};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[k+8>>2]=f[e+8>>2];f[k+12>>2]=f[e+12>>2];if(!(+p[g>>3]<+p[i>>3])){h=1;u=d;return h|0};f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+p[i>>3]<+p[a>>3])){h=1;u=d;return h|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{i=a+32|0;g=a+16|0;j=+p[g>>3];m=+p[a>>3];n=+p[i>>3];k=n<j;do if(j<m){if(k){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];break};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(n<+p[g>>3]){f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2]}}else if(k?(f[e>>2]=f[g>>2],f[e+4>>2]=f[g+4>>2],f[e+8>>2]=f[g+8>>2],f[e+12>>2]=f[g+12>>2],f[g>>2]=f[i>>2],f[g+4>>2]=f[i+4>>2],f[g+8>>2]=f[i+8>>2],f[g+12>>2]=f[i+12>>2],f[i>>2]=f[e>>2],f[i+4>>2]=f[e+4>>2],f[i+8>>2]=f[e+8>>2],f[i+12>>2]=f[e+12>>2],+p[g>>3]<m):0){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2]}while(0);g=a+48|0;a:do if((g|0)==(b|0)){o=1;q=0}else{k=g;l=0;c=i;while(1){m=+p[k>>3];if(m<+p[c>>3]){r=k+8|0;s=f[r+4>>2]|0;t=e;f[t>>2]=f[r>>2];f[t+4>>2]=s;s=c;t=k;while(1){f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];if((s|0)==(a|0)){v=a;break}r=s+-16|0;if(m<+p[r>>3]){w=s;s=r;t=w}else{v=s;break}}p[v>>3]=m;s=e;t=f[s+4>>2]|0;w=v+8|0;f[w>>2]=f[s>>2];f[w+4>>2]=t;t=l+1|0;if((t|0)==8){o=0;q=(k+16|0)==(b|0);break a}else x=t}else x=l;t=k+16|0;if((t|0)==(b|0)){o=1;q=0;break}else{w=k;k=t;l=x;c=w}}}while(0);h=q|o;u=d;return h|0}}return 0}function cMb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;i=h;j=a+12|0;k=f[j>>2]|0;l=(k|0)>(e|0)?k:e;m=a+8|0;o=f[m>>2]|0;if((o|0)!=0?(f[o+12>>2]|0)==(k|0):0)p=o;else{o=f[c>>2]|0;f[c>>2]=o+32;f[o+4>>2]=0;c=f[m>>2]|0;f[o>>2]=c;f[o+8>>2]=0;if(c|0)f[c+4>>2]=o;if(!o){f[i>>2]=0;f[i+4>>2]=0;c=tT(i,9)|0;q=464961;r=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(r|0));z5(-215,i,464971,464828,287)}else p=o}f[p+12>>2]=k;o=f[a+16>>2]|0;f[p+16>>2]=o;f[p+24>>2]=f[a>>2];a=p+20|0;n[a>>2]=3402823466385288598117041.0e14;i=p+28|0;b[i>>0]=1;if((o|0)>=(f[d+4>>2]|0)){n[a>>2]=-1.0;b[i>>0]=0}f[j>>2]=l;f[m>>2]=p;if((k|0)>=(e|0)){u=h;return}eMb(p,d,0,0,g);u=h;return}function dMb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=b;h=c;i=(f[b+12>>2]|0)<(f[c+12>>2]|0);c=i?h:g;b=f[c+12>>2]|0;j=a+12|0;f[j>>2]=b;cMb(c,d,e,b,0);b=i?g:h;cMb(b,d,e,f[j>>2]|0,0);j=f[c+16>>2]|0;if(!j)f[a>>2]=f[b>>2];else{f[a>>2]=f[c>>2];d=(f[e+72>>2]|0)+(f[c+4>>2]<<2)|0;f[d>>2]=f[d>>2]&-536870912|f[b>>2]}f[a+4>>2]=f[b+4>>2];f[a+16>>2]=(f[b+16>>2]|0)+j;j=f[c+8>>2]|0;f[a+8>>2]=j;a=f[j>>2]|0;c=f[b+8>>2]|0;b=j;if(!a){f[j>>2]=c;f[c+4>>2]=j;return}d=f[a+16>>2]|0;h=f[c+16>>2]|0;if((d|0)>(h|0)){if((h|0)<(f[e+4>>2]|0))return;h=a+8|0;f[c+8>>2]=f[h>>2];f[h>>2]=c;f[c+4>>2]=b;return}else{f[j>>2]=c;f[c+4>>2]=j;if((d|0)<(f[e+4>>2]|0))return;f[c+8>>2]=a;return}}function eMb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;h=g+4|0;i=g;j=a+20|0;if(+n[j>>2]>=0.0){u=g;return}k=f[b>>2]|0;f[h>>2]=0;f[i>>2]=0;l=f[a>>2]|0;m=a+16|0;a:do if(l|0?(f[m>>2]|0)>=(f[b+4>>2]|0):0){o=l;do{p=o+20|0;q=+n[p>>2];if(q<0.0){r=(o|0)==(f[a>>2]|0);eMb(o,b,r?h:0,r?i:0,e);s=+n[p>>2]}else s=q;if(s<0.0)break a;o=f[o+8>>2]|0}while((o|0)!=0);o=f[i>>2]|0;if(o){t=(f[o+16>>2]|0)>(f[m>>2]|0)?o:a;v=9}else{t=a;v=9}}else{t=a;v=9}while(0);do if((v|0)==9){i=f[h>>2]|0;b:do if(i){l=a+12|0;if((i|0)==(a|0)){w=a;x=l}else{o=(f[l>>2]|0)-k|0;p=i;while(1){if((f[p+12>>2]|0)>=(o|0)){w=p;x=l;break b}p=f[p+4>>2]|0;if((p|0)==(a|0)){w=a;x=l;break}}}}else{l=a+12|0;p=a;while(1){o=f[p>>2]|0;if(!o){w=p;x=l;break b}if((f[o+12>>2]|0)<((f[l>>2]|0)-k|0)){w=p;x=l;break}else p=o}}while(0);i=t;while(1){y=i+4|0;p=f[y>>2]|0;if(!p)break;if((f[p+12>>2]|0)>((f[x>>2]|0)+k|0))break;else i=p}if(c|0)f[c>>2]=w;if(d|0)f[d>>2]=i;if((!e?(f[y>>2]|0)==0:0)?(f[i+12>>2]|0)<((f[x>>2]|0)+k|0):0)break;n[j>>2]=+((f[i+16>>2]|0)-(f[w+16>>2]|0)|0)/+(f[m>>2]|0);p=f[a>>2]|0;if(p|0){l=p;do{fMb(l,b);l=f[l+8>>2]|0}while((l|0)!=0)}if(e?(f[a+4>>2]|0)==0:0)fMb(a,b)}while(0);u=g;return}function fMb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+28|0;if(b[g>>0]|0){u=d;return}b[g>>0]=1;g=a+16|0;h=f[g>>2]|0;if((h|0)<(f[c+4>>2]|0)){u=d;return}if((h|0)>(f[c+8>>2]|0)){u=d;return}i=+n[a+20>>2];if(i<0.0){u=d;return}if(i>+p[c+16>>3]){u=d;return}h=f[a>>2]|0;a:do if(h|0){j=h;while(1){k=+n[j+20>>2];if(k>=0.0&i>k)break;j=f[j+8>>2]|0;if(!j)break a}u=d;return}while(0);if((i>0.0?(h=f[a+4>>2]|0,h|0):0)?(k=+n[h+20>>2],!(!(k>=0.0)|!(i>=k))):0){u=d;return}h=c+64|0;j=f[h>>2]|0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;m=j+4|0;o=f[m>>2]|0;if((o|0)==(f[j+8>>2]|0))_Lb(j,e);else{ZLb(o,e);f[m>>2]=(f[m>>2]|0)+12}m=f[e>>2]|0;if(m|0){o=f[l>>2]|0;if((o|0)!=(m|0))f[l>>2]=o+(~((o+-8-m|0)>>>3)<<3);YDc(m)}m=f[(f[h>>2]|0)+4>>2]|0;h=m+-12|0;o=f[g>>2]|0;l=m+-8|0;m=f[l>>2]|0;j=f[h>>2]|0;q=m-j>>3;r=j;j=m;if(o>>>0<=q>>>0)if(o>>>0<q>>>0?(m=r+(o<<3)|0,(j|0)!=(m|0)):0){f[l>>2]=j+(~((j+-8-m|0)>>>3)<<3);s=o}else s=o;else{Jua(h,o-q|0);s=f[g>>2]|0}g=f[c+72>>2]|0;q=f[c+76>>2]|0;if((s|0)>0){o=f[h>>2]|0;h=2147483647;m=2147483647;j=-2147483648;l=-2147483648;r=f[a+24>>2]|0;a=0;while(1){t=(r|0)/(q|0)|0;v=r-(Y(t,q)|0)|0;h=(v|0)<(h|0)?v:h;j=(j|0)<(v|0)?v:j;m=(t|0)<(m|0)?t:m;l=(l|0)<(t|0)?t:l;f[o+(a<<3)>>2]=v;f[o+(a<<3)+4>>2]=t;a=a+1|0;if((a|0)>=(s|0))break;else r=f[g+(r<<2)>>2]&536870911}w=j+1|0;x=l+1|0;y=h;z=m}else{w=-2147483647;x=-2147483647;y=2147483647;z=2147483647}m=f[c+68>>2]|0;c=w-y|0;w=x-z|0;f[e>>2]=y;f[e+4>>2]=z;f[e+8>>2]=c;f[e+12>>2]=w;x=m+4|0;h=f[x>>2]|0;if((h|0)==(f[m+8>>2]|0))$Lb(m,e);else{f[h>>2]=y;f[h+4>>2]=z;f[h+8>>2]=c;f[h+12>>2]=w;f[x>>2]=h+16}u=d;return}function gMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){XIc(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)mCc(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;XIc(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;YDc(h);return}function hMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function iMb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>5>>>0>=c>>>0){i=c;j=h;do{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;n[j+20>>2]=-1.0;f[j+24>>2]=0;b[j+28>>0]=0;j=(f[g>>2]|0)+32|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>5;h=j+c|0;if(h>>>0>134217727)mCc(a);k=e-i|0;i=k>>4;e=k>>5>>>0<67108863?(i>>>0<h>>>0?h:i):134217727;do if(e)if(e>>>0>134217727){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{l=VDc(e<<5)|0;break}else l=0;while(0);i=l+(j<<5)|0;j=l+(e<<5)|0;e=c;c=i;l=i;do{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;n[l+20>>2]=-1.0;f[l+24>>2]=0;b[l+28>>0]=0;l=c+32|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(0-(l>>5)<<5)|0;if((l|0)>0)dJc(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;YDc(e);return}function jMb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m;o=VDc(160)|0;r0(o);f[o>>2]=135064;f[o+4>>2]=1124007936;q=o+12|0;r=o+44|0;s=o+8|0;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;q=o+52|0;f[o+48>>2]=q;s=q;t=s+44|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[o+96>>2]=c;f[o+100>>2]=d;f[o+104>>2]=e;p[o+112>>3]=g;p[o+120>>3]=h;b[o+128>>0]=0;e=o+129|0;b[e>>0]=b[n>>0]|0;b[e+1>>0]=b[n+1>>0]|0;b[e+2>>0]=b[n+2>>0]|0;f[o+132>>2]=i;p[o+136>>3]=j;p[o+144>>3]=k;f[o+152>>2]=l;l=VDc(16)|0;i=l+4|0;f[i>>2]=1;f[l>>2]=136772;f[l+8>>2]=o;f[a>>2]=l;f[a+4>>2]=o;f[i>>2]=(f[i>>2]|0)+1;o=f[i>>2]|0;f[i>>2]=o+-1;if((o|0)!=1){u=m;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=m;return}function kMb(a){a=a|0;YDc(a);return}function lMb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function mMb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;switch(d|0){case 16:{h=136848;break}case 12:{h=136976;break}default:h=(d|0)==8?136784:0}if(!((a|0)!=0&(h|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,16)|0;j=465067;k=i+16|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,g,465084,465096,74)}if((d|0)>0){g=0;do{j=(Y(f[h+(g<<3)+4>>2]|0,c)|0)+(f[h+(g<<3)>>2]|0)|0;f[a+(g<<2)>>2]=j;g=g+1|0}while((g|0)!=(d|0));if((d|0)<25)l=d;else{u=e;return}}else l=0;do{f[a+(l<<2)>>2]=f[a+(l-d<<2)>>2];l=l+1|0}while((l|0)!=25);u=e;return}function nMb(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e;i=h[a>>0]|0;j=0;do{d[g+(j<<1)>>1]=i-(h[a+(f[b+(j<<2)>>2]|0)>>0]|0);j=j+1|0}while((j|0)!=25);k=c;l=0;while(1){c=d[g+((l|1)<<1)>>1]|0;j=l;l=l+2|0;b=d[g+(l<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?c:a;if((b|0)>(k|0)){a=d[g+(j+4<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+5<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j+7<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+8<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j<<1)>>1]|0;b=(c|0)<(a|0)?c:a;c=(k|0)<(b|0)?b:k;b=d[g+(j+9<<1)>>1]|0;j=(b|0)<(a|0)?b:a;m=(c|0)<(j|0)?j:c}else m=k;if((l|0)>=16)break;else k=m}k=0-m|0;m=0;l=d[g+4>>1]|0;c=d[g+6>>1]|0;while(1){j=d[g+((m|1)<<1)>>1]|0;a=m;m=m+2|0;b=l<<16>>16;i=(j|0)<(b|0)?b:j;j=c<<16>>16;b=(i|0)<(j|0)?j:i;l=d[g+(a+4<<1)>>1]|0;i=l<<16>>16;j=(b|0)<(i|0)?i:b;c=d[g+(a+5<<1)>>1]|0;b=c<<16>>16;i=(j|0)<(b|0)?b:j;if((i|0)<(k|0)){j=d[g+(a+6<<1)>>1]|0;b=(i|0)<(j|0)?j:i;i=d[g+(a+7<<1)>>1]|0;j=(b|0)<(i|0)?i:b;b=d[g+(a+8<<1)>>1]|0;i=(j|0)<(b|0)?b:j;j=d[g+(a<<1)>>1]|0;b=(i|0)<(j|0)?j:i;j=(b|0)<(k|0)?b:k;b=d[g+(a+9<<1)>>1]|0;a=(i|0)<(b|0)?b:i;n=(a|0)<(j|0)?a:j}else n=k;if((m|0)>=16)break;else k=n}u=e;return ~n|0}function oMb(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e;i=h[a>>0]|0;j=0;do{d[g+(j<<1)>>1]=i-(h[a+(f[b+(j<<2)>>2]|0)>>0]|0);j=j+1|0}while((j|0)!=19);k=c;l=0;while(1){c=d[g+((l|1)<<1)>>1]|0;j=l;l=l+2|0;b=d[g+(l<<1)>>1]|0;a=(b|0)<(c|0)?b:c;if((a|0)>(k|0)){c=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j+4<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+5<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j<<1)>>1]|0;c=(a|0)<(b|0)?a:b;a=(k|0)<(c|0)?c:k;c=d[g+(j+7<<1)>>1]|0;j=(c|0)<(b|0)?c:b;m=(a|0)<(j|0)?j:a}else m=k;if((l|0)>=12)break;else k=m}k=0-m|0;m=0;l=d[g+4>>1]|0;while(1){a=d[g+((m|1)<<1)>>1]|0;j=m;m=m+2|0;b=l<<16>>16;c=(a|0)<(b|0)?b:a;a=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?a:c;l=d[g+(j+4<<1)>>1]|0;c=l<<16>>16;a=(b|0)<(c|0)?c:b;if((a|0)<(k|0)){b=d[g+(j+5<<1)>>1]|0;c=(a|0)<(b|0)?b:a;a=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?a:c;c=d[g+(j<<1)>>1]|0;a=(b|0)<(c|0)?c:b;c=(a|0)<(k|0)?a:k;a=d[g+(j+7<<1)>>1]|0;j=(b|0)<(a|0)?a:b;n=(j|0)<(c|0)?j:c}else n=k;if((m|0)>=12)break;else k=n}u=e;return ~n|0}function pMb(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;i=h[a>>0]|0;d[g>>1]=i-(h[a+(f[b>>2]|0)>>0]|0);d[g+2>>1]=i-(h[a+(f[b+4>>2]|0)>>0]|0);d[g+4>>1]=i-(h[a+(f[b+8>>2]|0)>>0]|0);d[g+6>>1]=i-(h[a+(f[b+12>>2]|0)>>0]|0);d[g+8>>1]=i-(h[a+(f[b+16>>2]|0)>>0]|0);d[g+10>>1]=i-(h[a+(f[b+20>>2]|0)>>0]|0);d[g+12>>1]=i-(h[a+(f[b+24>>2]|0)>>0]|0);d[g+14>>1]=i-(h[a+(f[b+28>>2]|0)>>0]|0);d[g+16>>1]=i-(h[a+(f[b+32>>2]|0)>>0]|0);d[g+18>>1]=i-(h[a+(f[b+36>>2]|0)>>0]|0);d[g+20>>1]=i-(h[a+(f[b+40>>2]|0)>>0]|0);d[g+22>>1]=i-(h[a+(f[b+44>>2]|0)>>0]|0);d[g+24>>1]=i-(h[a+(f[b+48>>2]|0)>>0]|0);b=d[g+2>>1]|0;a=d[g+4>>1]|0;i=(a|0)<(b|0)?a:b;if((i|0)>(c|0)){b=d[g+6>>1]|0;a=(b|0)<(i|0)?b:i;i=d[g+8>>1]|0;b=(i|0)<(a|0)?i:a;a=d[g>>1]|0;i=(a|0)<(b|0)?a:b;a=(i|0)>(c|0)?i:c;i=d[g+10>>1]|0;j=(i|0)<(b|0)?i:b;k=(a|0)<(j|0)?j:a}else k=c;c=d[g+6>>1]|0;a=d[g+8>>1]|0;j=(a|0)<(c|0)?a:c;if((j|0)>(k|0)){c=d[g+10>>1]|0;a=(c|0)<(j|0)?c:j;j=d[g+12>>1]|0;c=(j|0)<(a|0)?j:a;a=d[g+4>>1]|0;j=(a|0)<(c|0)?a:c;a=(k|0)<(j|0)?j:k;j=d[g+14>>1]|0;b=(j|0)<(c|0)?j:c;l=(a|0)<(b|0)?b:a}else l=k;k=d[g+10>>1]|0;a=d[g+12>>1]|0;b=(a|0)<(k|0)?a:k;if((b|0)>(l|0)){k=d[g+14>>1]|0;a=(k|0)<(b|0)?k:b;b=d[g+16>>1]|0;k=(b|0)<(a|0)?b:a;a=d[g+8>>1]|0;b=(a|0)<(k|0)?a:k;a=(l|0)<(b|0)?b:l;b=d[g+18>>1]|0;c=(b|0)<(k|0)?b:k;m=(a|0)<(c|0)?c:a}else m=l;l=d[g+14>>1]|0;a=d[g+16>>1]|0;c=(a|0)<(l|0)?a:l;if((c|0)>(m|0)){l=d[g+18>>1]|0;a=(l|0)<(c|0)?l:c;c=d[g+20>>1]|0;l=(c|0)<(a|0)?c:a;a=d[g+12>>1]|0;c=(a|0)<(l|0)?a:l;a=(m|0)<(c|0)?c:m;c=d[g+22>>1]|0;k=(c|0)<(l|0)?c:l;n=(a|0)<(k|0)?k:a}else n=m;m=0-n|0;n=d[g+2>>1]|0;a=d[g+4>>1]|0;k=(n|0)<(a|0)?a:n;n=d[g+6>>1]|0;a=(k|0)<(n|0)?n:k;if((a|0)<(m|0)){k=d[g+8>>1]|0;n=(a|0)<(k|0)?k:a;a=d[g>>1]|0;k=(n|0)<(a|0)?a:n;a=(k|0)<(m|0)?k:m;k=d[g+10>>1]|0;l=(n|0)<(k|0)?k:n;o=(l|0)<(a|0)?l:a}else o=m;m=d[g+6>>1]|0;a=d[g+8>>1]|0;l=(m|0)<(a|0)?a:m;m=d[g+10>>1]|0;a=(l|0)<(m|0)?m:l;if((a|0)<(o|0)){l=d[g+12>>1]|0;m=(a|0)<(l|0)?l:a;a=d[g+4>>1]|0;l=(m|0)<(a|0)?a:m;a=(l|0)<(o|0)?l:o;l=d[g+14>>1]|0;n=(m|0)<(l|0)?l:m;p=(n|0)<(a|0)?n:a}else p=o;o=d[g+10>>1]|0;a=d[g+12>>1]|0;n=(o|0)<(a|0)?a:o;o=d[g+14>>1]|0;a=(n|0)<(o|0)?o:n;if((a|0)<(p|0)){n=d[g+16>>1]|0;o=(a|0)<(n|0)?n:a;a=d[g+8>>1]|0;n=(o|0)<(a|0)?a:o;a=(n|0)<(p|0)?n:p;n=d[g+18>>1]|0;m=(o|0)<(n|0)?n:o;q=(m|0)<(a|0)?m:a}else q=p;p=d[g+14>>1]|0;a=d[g+16>>1]|0;m=(p|0)<(a|0)?a:p;p=d[g+18>>1]|0;a=(m|0)<(p|0)?p:m;if((a|0)>=(q|0)){r=q;s=~r;u=e;return s|0}m=d[g+20>>1]|0;p=(a|0)<(m|0)?m:a;a=d[g+12>>1]|0;m=(p|0)<(a|0)?a:p;a=(m|0)<(q|0)?m:q;q=d[g+22>>1]|0;g=(p|0)<(q|0)?q:p;r=(g|0)<(a|0)?g:a;s=~r;u=e;return s|0}function qMb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0.0,l=0.0;g=u;u=u+16|0;h=g+4|0;i=g;j=+n[a>>2]/+(f[b>>2]|0)*3.0;k=+n[c>>2];l=+M(+(j/k+.25))+-.5+-9.99999993922529e-09;b=~~l;a=(+(b|0)<l&1)+b|0;f[h>>2]=a;l=j/(k*+(Y(a+1|0,a)|0));n[i>>2]=l;a=rMb(h,i,c,d,e)|0;u=g;return a|0}function rMb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0;h=u;u=u+32|0;i=h+12|0;j=h;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;l=f[a>>2]|0;if((l|0)<1){m=0;u=h;return m|0}f[j>>2]=0;o=j+4|0;f[o>>2]=0;f[j+8>>2]=0;if(l>>>0>1073741823)mCc(j);p=l<<2;q=VDc(p)|0;f[j>>2]=q;r=q+(l<<2)|0;f[j+8>>2]=r;XIc(q|0,0,p|0)|0;f[o>>2]=r;if((j|0)!=(g|0)){DF(g,q,r);r=f[j>>2]|0;if(r|0){s=r;t=r;v=6}}else{s=q;t=q;v=6}if((v|0)==6){v=f[o>>2]|0;if((v|0)!=(s|0))f[o>>2]=v+(~((v+-4-s|0)>>>2)<<2);YDc(t)}if(b[e>>0]|0){t=f[a>>2]|0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;do if(t)if(t>>>0>1073741823)mCc(j);else{v=t<<2;o=VDc(v)|0;f[j>>2]=o;q=o+(t<<2)|0;f[j+8>>2]=q;XIc(o|0,0,v|0)|0;f[s>>2]=q;w=o;x=q;break}else{w=0;x=0}while(0);DF(i,w,x);x=f[j>>2]|0;if(x|0){j=f[s>>2]|0;if((j|0)!=(x|0))f[s>>2]=j+(~((j+-4-x|0)>>>2)<<2);YDc(x)}}x=f[a>>2]|0;y=1.0/(+(x|0)*4.0+2.0);z=+n[c>>2]*+n[d>>2]*.5;d=(x|0)>0;c=b[e>>0]|0;if(d){e=f[(c<<24>>24==0?g:i)>>2]|0;a=0;do{A=+O(+(y*((+(a|0)*2.0+1.0)*3.1415927410125732)));n[e+(a<<2)>>2]=z/(A*A);a=a+1|0}while((a|0)<(x|0))}if(c<<24>>24){c=(x|0)/2|0;a=x;while(1){e=a;a=a+1|0;if((a|0)<2){a=a;continue}j=e+-1|0;if(j>>>0<6?43>>>(j&255)&1:0)break;if(((a>>>0)%7|0|0)==0|(((a>>>0)%5|0|0)==0|((a&1|0)==0|((a>>>0)%3|0|0)==0))){a=a;continue}j=~~+M(+(+(a|0)+1.0));if((j|0)<11)break;else{B=1;C=11}do{B=B&((a|0)%(C|0)|0|0)!=0;C=C+2|0}while((C|0)<=(j|0));if(B)break}if(d){d=f[i>>2]|0;B=f[g>>2]|0;g=0;C=0;while(1){j=C;do{j=j+1|0;D=(Y(j,c)|0)%(a|0)|0}while((D|0)>(x|0));f[B+(g<<2)>>2]=f[d+(D+-1<<2)>>2];g=g+1|0;if((g|0)>=(x|0))break;else C=j}}}C=f[i>>2]|0;if(!C){m=x;u=h;return m|0}i=f[k>>2]|0;if((i|0)!=(C|0))f[k>>2]=i+(~((i+-4-C|0)>>>2)<<2);YDc(C);m=x;u=h;return m|0}function sMb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0.0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;if(!(+(c|0)<e)?!((d|0)==0|((c|0)==0|+(d|0)<e)):0)k=0;else{l=((e+-.800000011920929)/.30000001192092896+1.0)*2.0;d=~~l;k=(+(d|0)<l&1)+d|0}d=(k&1^1)+k|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=d;f[j+4>>2]=d;l=e;Gfa(h,i,j,l,l,1);u=g;return}function tMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0.0;e=u;u=u+208|0;g=e+144|0;h=e+152|0;i=e+88|0;j=e+32|0;k=e+16|0;l=e;b$(g,a,-1);v$(c,g,c$(a,-1)|0,-1,0,0);do if((d$(a)|0)==65536){g=f[a+4>>2]|0;f[h>>2]=f[g>>2];m=h+4|0;o=g+4|0;f[m>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];f[h+16>>2]=f[g+16>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];q=f[g+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[g+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;ZS(h,g);break}}else a$(h,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[i>>2]=f[a>>2];g=i+4|0;m=a+4|0;f[g>>2]=f[m>>2];o=i+8|0;f[o>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];p=f[a+36>>2]|0;f[i+36>>2]=p;f[i+40>>2]=o;o=i+48|0;r=i+44|0;f[r>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[a+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[g>>2]=0;ZS(i,a);break}}else a$(i,b,-1);while(0);do if((d$(c)|0)==65536){b=f[c+4>>2]|0;f[j>>2]=f[b>>2];a=j+4|0;g=b+4|0;f[a>>2]=f[g>>2];m=j+8|0;f[m>>2]=f[b+8>>2];f[j+12>>2]=f[b+12>>2];f[j+16>>2]=f[b+16>>2];f[j+20>>2]=f[b+20>>2];f[j+24>>2]=f[b+24>>2];f[j+28>>2]=f[b+28>>2];f[j+32>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+36>>2]=o;f[j+40>>2]=m;m=j+48|0;r=j+44|0;f[r>>2]=m;f[m>>2]=0;f[j+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){g=f[b+44>>2]|0;m=f[r>>2]|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];break}else{f[a>>2]=0;ZS(j,b);break}}else a$(j,c,-1);while(0);c=h+40|0;b=f[c>>2]|0;a=f[b+4>>2]|0;g=f[b>>2]|0;s=1.0/(d*d);if((g|0)>0?(b=f[h+16>>2]|0,m=f[f[h+44>>2]>>2]|0,r=f[i+16>>2]|0,o=f[f[i+44>>2]>>2]|0,p=f[j+16>>2]|0,q=f[f[j+44>>2]>>2]|0,(a|0)>0):0){t=0;do{v=b+(Y(m,t)|0)|0;w=r+(Y(o,t)|0)|0;x=p+(Y(q,t)|0)|0;y=0;do{d=+n[v+(y<<2)>>2];z=+n[w+(y<<2)>>2];n[x+(y<<2)>>2]=-(s*(d*d+z*z));y=y+1|0}while((y|0)!=(a|0));t=t+1|0}while((t|0)!=(g|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=j;g=l+8|0;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;b3(k,l);l=j+36|0;k=f[l>>2]|0;if(k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)_S(j);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[j+40>>2]|0;g=0;do{f[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))g0(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(g=j+12|0,j=f[g>>2]|0,f[g>>2]=j+-1,(j|0)==1):0)_S(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;g=0;do{f[k+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)_S(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[c>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=e;return}g0(i);u=e;return}function uMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0.0;e=u;u=u+192|0;g=e+176|0;h=e+112|0;i=e+120|0;j=e+56|0;k=e;b$(h,a,-1);v$(c,h,c$(a,-1)|0,-1,0,0);do if((d$(a)|0)==65536){h=f[a+4>>2]|0;f[i>>2]=f[h>>2];l=i+4|0;m=h+4|0;f[l>>2]=f[m>>2];o=i+8|0;f[o>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];f[i+16>>2]=f[h+16>>2];f[i+20>>2]=f[h+20>>2];f[i+24>>2]=f[h+24>>2];f[i+28>>2]=f[h+28>>2];f[i+32>>2]=f[h+32>>2];p=f[h+36>>2]|0;f[i+36>>2]=p;f[i+40>>2]=o;o=i+48|0;q=i+44|0;f[q>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[h+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;ZS(i,h);break}}else a$(i,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[j>>2]=f[a>>2];h=j+4|0;l=a+4|0;f[h>>2]=f[l>>2];m=j+8|0;f[m>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];o=f[a+36>>2]|0;f[j+36>>2]=o;f[j+40>>2]=m;m=j+48|0;q=j+44|0;f[q>>2]=m;f[m>>2]=0;f[j+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[h>>2]=0;ZS(j,a);break}}else a$(j,b,-1);while(0);do if((d$(c)|0)==65536){b=f[c+4>>2]|0;f[k>>2]=f[b>>2];a=k+4|0;h=b+4|0;f[a>>2]=f[h>>2];l=k+8|0;f[l>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];f[k+28>>2]=f[b+28>>2];f[k+32>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[k+36>>2]=m;f[k+40>>2]=l;l=k+48|0;q=k+44|0;f[q>>2]=l;f[l>>2]=0;f[k+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+44>>2]|0;l=f[q>>2]|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];r=a;break}else{f[a>>2]=0;ZS(k,b);r=a;break}}else{a$(k,c,-1);r=k+4|0}while(0);c=i+40|0;a=f[c>>2]|0;b=f[a+4>>2]|0;h=f[a>>2]|0;a=f[i>>2]&4095;if(!(((((f[r>>2]|0)<3?(f[k+8>>2]|0)==(h|0):0)?(f[k+12>>2]|0)==(b|0):0)?(f[k>>2]&4095|0)==(a|0):0)?(f[k+16>>2]|0)!=0:0)){f[g>>2]=h;f[g+4>>2]=b;XS(k,2,g,a)}s=1.0/(d*d);if((h|0)>0?(a=f[i+16>>2]|0,g=f[f[i+44>>2]>>2]|0,l=f[j+16>>2]|0,q=f[f[j+44>>2]>>2]|0,m=f[k+16>>2]|0,o=f[f[k+44>>2]>>2]|0,(b|0)>0):0){p=0;do{t=a+(Y(g,p)|0)|0;v=l+(Y(q,p)|0)|0;w=m+(Y(o,p)|0)|0;x=0;do{d=+n[t+(x<<2)>>2];y=+n[v+(x<<2)>>2];n[w+(x<<2)>>2]=1.0/(s*(d*d+y*y)+1.0);x=x+1|0}while((x|0)!=(b|0));p=p+1|0}while((p|0)!=(h|0))}h=k+36|0;p=f[h>>2]|0;if(p|0?(b=p+12|0,p=f[b>>2]|0,f[b>>2]=p+-1,(p|0)==1):0)_S(k);f[h>>2]=0;h=k+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[r>>2]|0)>0){h=f[k+40>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[r>>2]|0))}r=f[k+44>>2]|0;if((r|0)!=(k+48|0))g0(r);r=j+36|0;k=f[r>>2]|0;if(k|0?(p=k+12|0,k=f[p>>2]|0,f[p>>2]=k+-1,(k|0)==1):0)_S(j);f[r>>2]=0;r=j+16|0;k=j+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[k>>2]|0)>0){r=f[j+40>>2]|0;p=0;do{f[r+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))g0(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)_S(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[c>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=e;return}g0(j);u=e;return}function vMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0;e=u;u=u+432|0;g=e+368|0;h=e+376|0;i=e+312|0;j=e+256|0;k=e+32|0;l=e;b$(g,a,-1);v$(c,g,c$(a,-1)|0,-1,0,0);do if((d$(a)|0)==65536){g=f[a+4>>2]|0;f[h>>2]=f[g>>2];m=h+4|0;o=g+4|0;f[m>>2]=f[o>>2];q=h+8|0;f[q>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];f[h+16>>2]=f[g+16>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];r=f[g+36>>2]|0;f[h+36>>2]=r;f[h+40>>2]=q;q=h+48|0;s=h+44|0;f[s>>2]=q;f[q>>2]=0;f[h+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[o>>2]|0)<3){o=f[g+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;ZS(h,g);break}}else a$(h,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[i>>2]=f[a>>2];g=i+4|0;m=a+4|0;f[g>>2]=f[m>>2];o=i+8|0;f[o>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=o;o=i+48|0;s=i+44|0;f[s>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(q|0){o=q+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[a+44>>2]|0;o=f[s>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[g>>2]=0;ZS(i,a);break}}else a$(i,b,-1);while(0);do if((d$(c)|0)==65536){b=f[c+4>>2]|0;f[j>>2]=f[b>>2];a=j+4|0;g=b+4|0;f[a>>2]=f[g>>2];m=j+8|0;f[m>>2]=f[b+8>>2];f[j+12>>2]=f[b+12>>2];f[j+16>>2]=f[b+16>>2];f[j+20>>2]=f[b+20>>2];f[j+24>>2]=f[b+24>>2];f[j+28>>2]=f[b+28>>2];f[j+32>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+36>>2]=o;f[j+40>>2]=m;m=j+48|0;s=j+44|0;f[s>>2]=m;f[m>>2]=0;f[j+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){g=f[b+44>>2]|0;m=f[s>>2]|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];break}else{f[a>>2]=0;ZS(j,b);break}}else a$(j,c,-1);while(0);c=h+40|0;b=f[c>>2]|0;a=f[b+4>>2]|0;g=f[b>>2]|0;t=1.0/(d*d);if((g|0)>0?(b=f[h+16>>2]|0,m=f[f[h+44>>2]>>2]|0,s=f[i+16>>2]|0,o=f[f[i+44>>2]>>2]|0,q=f[j+16>>2]|0,r=f[f[j+44>>2]>>2]|0,(a|0)>0):0){v=0;do{w=b+(Y(m,v)|0)|0;x=s+(Y(o,v)|0)|0;y=q+(Y(r,v)|0)|0;z=0;do{d=+n[w+(z<<2)>>2];A=+n[x+(z<<2)>>2];B=t*(d*d+A*A);n[y+(z<<2)>>2]=-3.315000057220459/(B*(B*(B*B)));z=z+1|0}while((z|0)!=(a|0));v=v+1|0}while((v|0)!=(g|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=j;g=l+8|0;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;b3(k,l);p[l>>3]=1.0;g=l+8|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;gY(k,l,j);l=f[k>>2]|0;ei[f[(f[l>>2]|0)+12>>2]&511](l,k,j,-1);$j(k);k=j+36|0;l=f[k>>2]|0;if(l|0?(g=l+12|0,l=f[g>>2]|0,f[g>>2]=l+-1,(l|0)==1):0)_S(j);f[k>>2]=0;k=j+16|0;l=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[j+40>>2]|0;g=0;do{f[k+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))g0(l);l=i+36|0;j=f[l>>2]|0;if(j|0?(g=j+12|0,j=f[g>>2]|0,f[g>>2]=j+-1,(j|0)==1):0)_S(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[i+40>>2]|0;g=0;do{f[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)_S(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[c>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=e;return}g0(i);u=e;return}function wMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;e=u;u=u+176|0;g=e+112|0;h=e+120|0;i=e+56|0;j=e;b$(g,a,-1);v$(c,g,c$(a,-1)|0,-1,0,0);do if((d$(a)|0)==65536){g=f[a+4>>2]|0;f[h>>2]=f[g>>2];k=h+4|0;l=g+4|0;f[k>>2]=f[l>>2];m=h+8|0;f[m>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];f[h+16>>2]=f[g+16>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];o=f[g+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=m;m=h+48|0;p=h+44|0;f[p>>2]=m;f[m>>2]=0;f[h+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[g+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;ZS(h,g);break}}else a$(h,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[i>>2]=f[a>>2];g=i+4|0;k=a+4|0;f[g>>2]=f[k>>2];l=i+8|0;f[l>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];m=f[a+36>>2]|0;f[i+36>>2]=m;f[i+40>>2]=l;l=i+48|0;p=i+44|0;f[p>>2]=l;f[l>>2]=0;f[i+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+44>>2]|0;l=f[p>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[g>>2]=0;ZS(i,a);break}}else a$(i,b,-1);while(0);do if((d$(c)|0)==65536){b=f[c+4>>2]|0;f[j>>2]=f[b>>2];a=j+4|0;g=b+4|0;f[a>>2]=f[g>>2];k=j+8|0;f[k>>2]=f[b+8>>2];f[j+12>>2]=f[b+12>>2];f[j+16>>2]=f[b+16>>2];f[j+20>>2]=f[b+20>>2];f[j+24>>2]=f[b+24>>2];f[j+28>>2]=f[b+28>>2];f[j+32>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[j+36>>2]=l;f[j+40>>2]=k;k=j+48|0;p=j+44|0;f[p>>2]=k;f[k>>2]=0;f[j+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[g>>2]|0)<3){g=f[b+44>>2]|0;k=f[p>>2]|0;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];break}else{f[a>>2]=0;ZS(j,b);break}}else a$(j,c,-1);while(0);c=h+40|0;b=f[c>>2]|0;a=f[b+4>>2]|0;g=f[b>>2]|0;q=1.0/(d*d);if((g|0)>0?(b=f[h+16>>2]|0,k=f[f[h+44>>2]>>2]|0,p=f[i+16>>2]|0,l=f[f[i+44>>2]>>2]|0,m=f[j+16>>2]|0,o=f[f[j+44>>2]>>2]|0,(a|0)>0):0){r=0;do{s=b+(Y(k,r)|0)|0;t=p+(Y(l,r)|0)|0;v=m+(Y(o,r)|0)|0;w=0;do{d=+n[s+(w<<2)>>2];x=+n[t+(w<<2)>>2];y=1.0/+M(+(q*(d*d+x*x)+1.0));n[v+(w<<2)>>2]=y;w=w+1|0}while((w|0)!=(a|0));r=r+1|0}while((r|0)!=(g|0))}g=j+36|0;r=f[g>>2]|0;if(r|0?(a=r+12|0,r=f[a>>2]|0,f[a>>2]=r+-1,(r|0)==1):0)_S(j);f[g>>2]=0;g=j+16|0;r=j+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[r>>2]|0)>0){g=f[j+40>>2]|0;a=0;do{f[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[r>>2]|0))}r=f[j+44>>2]|0;if((r|0)!=(j+48|0))g0(r);r=i+36|0;j=f[r>>2]|0;if(j|0?(a=j+12|0,j=f[a>>2]|0,f[a>>2]=j+-1,(j|0)==1):0)_S(i);f[r>>2]=0;r=i+16|0;j=i+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[i+40>>2]|0;a=0;do{f[r+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(a=i+12|0,i=f[a>>2]|0,f[a>>2]=i+-1,(i|0)==1):0)_S(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[c>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=e;return}g0(i);u=e;return}function xMb(a,b,c,d,e,g){a=a|0;b=+b;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,L=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0,ea=0;h=u;u=u+896|0;i=h+880|0;j=h+864|0;k=h+856|0;l=h+840|0;m=h+784|0;o=h+448|0;p=h+728|0;q=h+224|0;r=h+672|0;s=h;f[l>>2]=0;t=l+4|0;f[t>>2]=0;f[l+8>>2]=0;do if(d|0)if(d>>>0>1073741823)mCc(l);else{v=d<<2;w=VDc(v)|0;f[l>>2]=w;x=w+(d<<2)|0;f[l+8>>2]=x;XIc(w|0,0,v|0)|0;f[t>>2]=x;break}while(0);x=a+8|0;v=a+12|0;AY(o,f[x>>2]|0,f[v>>2]|0,5);f[m>>2]=1124007936;w=m+4|0;y=m+8|0;z=m+40|0;A=w;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[z>>2]=y;C=m+48|0;D=m+44|0;f[D>>2]=C;f[C>>2]=0;f[m+52>>2]=0;E=f[o>>2]|0;ei[f[(f[E>>2]|0)+12>>2]&511](E,o,m,-1);$j(o);AY(q,f[x>>2]|0,f[v>>2]|0,5);f[p>>2]=1124007936;o=p+4|0;E=p+8|0;F=p+40|0;A=o;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[F>>2]=E;E=p+48|0;G=p+44|0;f[G>>2]=E;f[E>>2]=0;f[p+52>>2]=0;H=f[q>>2]|0;ei[f[(f[H>>2]|0)+12>>2]&511](H,q,p,-1);$j(q);AY(s,f[x>>2]|0,f[v>>2]|0,5);f[r>>2]=1124007936;v=r+4|0;x=r+8|0;q=r+40|0;A=v;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[q>>2]=x;x=r+48|0;A=r+44|0;f[A>>2]=x;f[x>>2]=0;f[r+52>>2]=0;B=f[s>>2]|0;ei[f[(f[B>>2]|0)+12>>2]&511](B,s,r,-1);$j(s);if(!(+(e|0)<c)?!((g|0)==0|((e|0)==0|+(g|0)<c)):0)I=0;else{J=((c+-.800000011920929)/.30000001192092896+1.0)*2.0;g=~~J;I=(+(g|0)<J&1)+g|0}g=(I&1^1)+I|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=m;f[k>>2]=g;f[k+4>>2]=g;J=c;Gfa(i,j,k,J,J,1);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=m;k=j+8|0;f[k>>2]=0;f[k+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=p;Ioa(i,j,5,1,0,1.0,0.0,4);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=m;k=j+8|0;f[k>>2]=0;f[k+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;Ioa(i,j,5,0,1,1.0,0.0,4);j=(f[y>>2]|0)+-1|0;i=(j|0)>1;do if(i){k=f[p+16>>2]|0;g=f[f[G>>2]>>2]|0;a=f[r+16>>2]|0;I=f[f[A>>2]>>2]|0;e=(f[m+12>>2]|0)+-1|0;if((e|0)>1){s=1;J=0.0;while(1){B=k+(Y(g,s)|0)|0;H=a+(Y(I,s)|0)|0;L=1;N=J;do{c=+n[B+(L<<2)>>2];O=+n[H+(L<<2)>>2];P=c*c+O*O;N=P>N?P:N;L=L+1|0}while((L|0)!=(e|0));s=s+1|0;if((s|0)>=(j|0))break;else J=N}J=+M(+N);if(i)Q=J;else{R=0.0;S=J;break}}else Q=0.0;s=f[p+16>>2]|0;e=f[G>>2]|0;I=f[r+16>>2]|0;a=f[A>>2]|0;g=m+12|0;J=+(d|0);k=f[l>>2]|0;L=1;P=0.0;H=f[g>>2]|0;while(1){B=s+(Y(f[e>>2]|0,L)|0)|0;T=I+(Y(f[a>>2]|0,L)|0)|0;if((H+-1|0)>1){U=1;O=P;V=H;while(1){c=+n[B+(U<<2)>>2];W=+n[T+(U<<2)>>2];X=c*c+W*W;if(X!=0.0){Z=~~+K(+(J*(+M(+X)/Q)));_=k+((((Z|0)==(d|0))<<31>>31)+Z<<2)|0;f[_>>2]=(f[_>>2]|0)+1;$=O+1.0;aa=f[g>>2]|0}else{$=O;aa=V}U=U+1|0;if((U|0)>=(aa+-1|0)){ba=$;ca=aa;break}else{O=$;V=aa}}}else{ba=P;ca=H}L=L+1|0;if((L|0)>=((f[y>>2]|0)+-1|0)){R=ba;S=Q;break}else{P=ba;H=ca}}}else{R=0.0;S=0.0}while(0);ca=~~(R*b);y=(ca|0)>0;if((d|0)>0&y){aa=f[l>>2]|0;i=0;j=0;while(1){i=(f[aa+(j<<2)>>2]|0)+i|0;H=j+1|0;L=(i|0)<(ca|0);if(!((H|0)<(d|0)&L)){da=H;ea=L;break}else j=H}}else{da=0;ea=y}b=ea?.029999999329447746:S*(+(da|0)/+(d|0));d=r+36|0;da=f[d>>2]|0;if(da|0?(ea=da+12|0,da=f[ea>>2]|0,f[ea>>2]=da+-1,(da|0)==1):0)_S(r);f[d>>2]=0;d=r+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[v>>2]|0)>0){d=f[q>>2]|0;q=0;do{f[d+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[v>>2]|0))}v=f[A>>2]|0;if((v|0)!=(x|0))g0(v);v=p+36|0;x=f[v>>2]|0;if(x|0?(A=x+12|0,x=f[A>>2]|0,f[A>>2]=x+-1,(x|0)==1):0)_S(p);f[v>>2]=0;v=p+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[o>>2]|0)>0){v=f[F>>2]|0;F=0;do{f[v+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[o>>2]|0))}o=f[G>>2]|0;if((o|0)!=(E|0))g0(o);o=m+36|0;E=f[o>>2]|0;if(E|0?(G=E+12|0,E=f[G>>2]|0,f[G>>2]=E+-1,(E|0)==1):0)_S(m);f[o>>2]=0;o=m+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[w>>2]|0)>0){o=f[z>>2]|0;z=0;do{f[o+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[w>>2]|0))}w=f[D>>2]|0;if((w|0)!=(C|0))g0(w);w=f[l>>2]|0;if(!w){u=h;return +b}l=f[t>>2]|0;if((l|0)!=(w|0))f[t>>2]=l+(~((l+-4-w|0)>>>2)<<2);YDc(w);u=h;return +b}function yMb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+192|0;h=g+128|0;i=g+72|0;j=g+56|0;k=g+40|0;l=g+16|0;m=g;n=g+32|0;f[h>>2]=1124007936;o=h+4|0;p=h+8|0;q=h+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;p=h+48|0;t=h+44|0;f[t>>2]=p;f[p>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;v=i+4|0;w=i+8|0;x=i+40|0;r=v;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[x>>2]=w;w=i+48|0;r=i+44|0;f[r>>2]=w;f[w>>2]=0;f[i+52>>2]=0;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=h;s=k+8|0;f[s>>2]=0;f[s+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;zMb(j,k,c,d,e);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;f[n>>2]=-1;f[n+4>>2]=-1;lwa(j,k,5,l,m,n,0.0,4);n=i+36|0;m=f[n>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)_S(i);f[n>>2]=0;n=i+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[v>>2]|0)>0){n=f[x>>2]|0;x=0;do{f[n+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[r>>2]|0;if((v|0)!=(w|0))g0(v);v=h+36|0;w=f[v>>2]|0;if(w|0?(r=w+12|0,w=f[r>>2]|0,f[r>>2]=w+-1,(w|0)==1):0)_S(h);f[v>>2]=0;v=h+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[o>>2]|0)>0){v=f[q>>2]|0;q=0;do{f[v+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[t>>2]|0;if((o|0)==(p|0)){u=g;return}g0(o);u=g;return}function zMb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0;g=u;u=u+208|0;h=g+144|0;i=g+88|0;j=g+72|0;k=g+16|0;l=g;m=e<<1|1;if((e|0)==1){Eoa(a,b,c,d,0,1,5);u=g;return}Y$(a,m,1,5,-1,1,0);Y$(b,m,1,5,-1,1,0);do if((d$(a)|0)==65536){o=f[a+4>>2]|0;f[h>>2]=f[o>>2];p=h+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=h+8|0;f[r>>2]=f[o+8>>2];f[h+12>>2]=f[o+12>>2];f[h+16>>2]=f[o+16>>2];f[h+20>>2]=f[o+20>>2];f[h+24>>2]=f[o+24>>2];f[h+28>>2]=f[o+28>>2];f[h+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=r;r=h+48|0;t=h+44|0;f[t>>2]=r;f[r>>2]=0;f[h+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;ZS(h,o);break}}else a$(h,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[i>>2]=f[a>>2];o=i+4|0;p=a+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];r=f[a+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;t=i+44|0;f[t>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[a+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;ZS(i,a);break}}else a$(i,b,-1);while(0);f[j>>2]=0;b=j+4|0;f[b>>2]=0;f[j+8>>2]=0;v=1.0/(+(e|0)*2.0*5.3333330154418945);e=l+8|0;a=l+4|0;o=k+36|0;p=k+16|0;q=k+4|0;t=k+40|0;r=k+44|0;s=k+48|0;w=v*3.3333332538604736;x=(m|0)/2|0;y=m+-1|0;n[k>>2]=0.0;eqb(j,m,k);switch(c|0){case 0:{z=v;A=v;B=w;C=23;break}case 1:{z=1.0;A=-1.0;B=0.0;C=23;break}default:D=f[j>>2]|0}if((C|0)==23){c=f[j>>2]|0;n[c>>2]=A;n[c+(x<<2)>>2]=B;n[c+(y<<2)>>2]=z;D=c}Vj(k,f[h+8>>2]|0,f[h+12>>2]|0,5,D,0);D=e;f[D>>2]=0;f[D+4>>2]=0;f[l>>2]=33619968;f[a>>2]=h;h_(k,l);D=f[o>>2]|0;if(D|0?(c=D+12|0,D=f[c>>2]|0,f[c>>2]=D+-1,(D|0)==1):0)_S(k);f[o>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){D=f[t>>2]|0;c=0;do{f[D+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[q>>2]|0))}c=f[r>>2]|0;if((c|0)!=(s|0))g0(c);n[k>>2]=0.0;eqb(j,m,k);switch(d|0){case 0:{E=v;F=v;G=w;C=53;break}case 1:{E=1.0;F=-1.0;G=0.0;C=53;break}default:H=f[j>>2]|0}if((C|0)==53){C=f[j>>2]|0;n[C>>2]=F;n[C+(x<<2)>>2]=G;n[C+(y<<2)>>2]=E;H=C}Vj(k,f[i+8>>2]|0,f[i+12>>2]|0,5,H,0);H=e;f[H>>2]=0;f[H+4>>2]=0;f[l>>2]=33619968;f[a>>2]=i;h_(k,l);l=f[o>>2]|0;if(l|0?(a=l+12|0,l=f[a>>2]|0,f[a>>2]=l+-1,(l|0)==1):0)_S(k);f[o>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[t>>2]|0;t=0;do{f[p+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[q>>2]|0))}q=f[r>>2]|0;if((q|0)!=(s|0))g0(q);q=f[j>>2]|0;if(q|0){j=f[b>>2]|0;if((j|0)!=(q|0))f[b>>2]=j+(~((j+-4-q|0)>>>2)<<2);YDc(q)}q=i+36|0;j=f[q>>2]|0;if(j|0?(b=j+12|0,j=f[b>>2]|0,f[b>>2]=j+-1,(j|0)==1):0)_S(i);f[q>>2]=0;q=i+16|0;j=i+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[i+40>>2]|0;b=0;do{f[q+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(b=i+12|0,i=f[b>>2]|0,f[b>>2]=i+-1,(i|0)==1):0)_S(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[h+40>>2]|0;b=0;do{f[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))g0(i);u=g;return}function AMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=u;u=u+64|0;g=e+40|0;h=e+16|0;i=e;j=c+8|0;k=(f[j>>2]|0)+-1|0;f[g>>2]=1;f[g+4>>2]=k;f[h>>2]=137080;f[h+4>>2]=a;f[h+8>>2]=b;f[h+12>>2]=c;n[h+16>>2]=d;k=f[a+4>>2]|0;if((k|0)<3)l=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{m=f[a+40>>2]|0;o=0;p=1;while(1){q=Y(f[m+(o<<2)>>2]|0,p)|0;o=o+1|0;if((o|0)==(k|0)){l=q;break}else p=q}}y8(g,h,+(l>>>0)*.0000152587890625);l=f[c+16>>2]|0;p=c+44|0;k=f[b+16>>2]|0;o=f[f[b+44>>2]>>2]|0;b=k+o|0;m=f[a+16>>2]|0;q=f[f[a+44>>2]>>2]|0;r=m+q|0;s=f[c+12>>2]|0;t=s+-1|0;v=(t|0)>1;if(v){w=d*.5;x=1;do{y=+n[k+(x<<2)>>2];z=x;x=x+1|0;A=+n[m+(z<<2)>>2];B=z+-1|0;n[l+(z<<2)>>2]=w*((y+ +n[k+(x<<2)>>2])*(+n[m+(x<<2)>>2]-A)-(y+ +n[k+(B<<2)>>2])*(A-+n[m+(B<<2)>>2])+(y+ +n[b+(z<<2)>>2])*(+n[r+(z<<2)>>2]-A))}while((x|0)<(t|0))}x=f[j>>2]|0;j=x+-1|0;z=f[f[p>>2]>>2]|0;p=l+(Y(z,j)|0)|0;B=k+(Y(o,j)|0)|0;C=x+-2|0;x=k+(Y(o,C)|0)|0;D=m+(Y(q,j)|0)|0;E=m+(Y(q,C)|0)|0;if(v){w=d*.5;v=1;do{A=+n[B+(v<<2)>>2];C=v;v=v+1|0;y=+n[D+(C<<2)>>2];F=C+-1|0;n[p+(C<<2)>>2]=w*((A+ +n[B+(v<<2)>>2])*(+n[D+(v<<2)>>2]-y)-(A+ +n[B+(F<<2)>>2])*(y-+n[D+(F<<2)>>2])-(A+ +n[x+(C<<2)>>2])*(y-+n[E+(C<<2)>>2]))}while((v|0)<(t|0))}v=s+-2|0;if((j|0)<=1){G=g+8|0;f[G>>2]=0;H=g+12|0;f[H>>2]=0;f[g>>2]=16842752;I=g+4|0;f[I>>2]=a;J=h+8|0;f[J>>2]=0;K=h+12|0;f[K>>2]=0;f[h>>2]=16842752;L=h+4|0;f[L>>2]=c;M=i+8|0;N=M;O=N;f[O>>2]=0;P=N+4|0;Q=P;f[Q>>2]=0;f[i>>2]=33619968;R=i+4|0;f[R>>2]=a;S=e0()|0;mL(g,h,i,S,-1);u=e;return}w=d*.5;s=r;r=m;E=b;b=k;x=1;while(1){D=x;x=x+1|0;B=k+(Y(o,x)|0)|0;p=m+(Y(q,x)|0)|0;C=l+(Y(z,D)|0)|0;d=+n[E>>2];y=+n[s>>2];n[C>>2]=w*((d+ +n[E+4>>2])*(+n[s+4>>2]-y)+(d+ +n[B>>2])*(+n[p>>2]-y)-(d+ +n[b>>2])*(y-+n[r>>2]));y=+n[E+(t<<2)>>2];d=+n[s+(t<<2)>>2];n[C+(t<<2)>>2]=w*((y+ +n[B+(t<<2)>>2])*(+n[p+(t<<2)>>2]-d)-(+n[E+(v<<2)>>2]+y)*(d-+n[s+(v<<2)>>2])-(y+ +n[b+(t<<2)>>2])*(d-+n[r+(t<<2)>>2]));if((x|0)>=(j|0))break;else{C=E;D=s;s=p;E=B;b=C;r=D}}G=g+8|0;f[G>>2]=0;H=g+12|0;f[H>>2]=0;f[g>>2]=16842752;I=g+4|0;f[I>>2]=a;J=h+8|0;f[J>>2]=0;K=h+12|0;f[K>>2]=0;f[h>>2]=16842752;L=h+4|0;f[L>>2]=c;M=i+8|0;N=M;O=N;f[O>>2]=0;P=N+4|0;Q=P;f[Q>>2]=0;f[i>>2]=33619968;R=i+4|0;f[R>>2]=a;S=e0()|0;mL(g,h,i,S,-1);u=e;return}function BMb(a){a=a|0;YDc(a);return}function CMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0;c=f[a+4>>2]|0;d=f[a+8>>2]|0;e=f[a+12>>2]|0;g=f[b>>2]|0;h=f[b+4>>2]|0;if((g|0)>=(h|0))return;b=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=f[c+16>>2]|0;j=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;k=f[f[e+44>>2]>>2]|0;l=(f[e+12>>2]|0)+-1|0;e=a+16|0;if((l|0)>1)m=g;else return;do{g=m+-1|0;a=b+(Y(i,g)|0)|0;o=b+(Y(i,m)|0)|0;p=m;m=m+1|0;q=b+(Y(i,m)|0)|0;r=d+(Y(j,g)|0)|0;g=d+(Y(j,p)|0)|0;s=d+(Y(j,m)|0)|0;t=c+(Y(k,p)|0)|0;p=1;do{u=+n[o+(p<<2)>>2];v=p;p=p+1|0;w=+n[g+(v<<2)>>2];x=v+-1|0;n[t+(v<<2)>>2]=+n[e>>2]*.5*((u+ +n[o+(p<<2)>>2])*(+n[g+(p<<2)>>2]-w)-(u+ +n[o+(x<<2)>>2])*(w-+n[g+(x<<2)>>2])+(u+ +n[q+(v<<2)>>2])*(+n[s+(v<<2)>>2]-w)-(u+ +n[a+(v<<2)>>2])*(w-+n[r+(v<<2)>>2]))}while((p|0)<(l|0))}while((m|0)<(h|0));return}function DMb(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;h=d-b|0;i=d+b|0;if((h|0)>(i|0)){j=1;return j|0}k=e-b|0;l=e+b|0;b=f[a+8>>2]|0;m=f[a+12>>2]|0;o=f[a+16>>2]|0;p=f[a+44>>2]|0;if((k|0)>(l|0)){j=1;return j|0}else q=h;a:while(1){h=(q|0)==(d|0);if((q|0)>-1&(q|0)<(b|0)){a=k;while(1){do if((a|0)>-1&(a|0)<(m|0)){if(!g){r=o+(Y(f[p>>2]|0,q)|0)+(a<<2)|0;if(+n[r>>2]>c){j=0;s=11;break a}else break}if(!(h&(a|0)==(e|0))?(r=o+(Y(f[p>>2]|0,q)|0)+(a<<2)|0,+n[r>>2]>c):0){j=0;s=11;break a}}while(0);if((a|0)<(l|0))a=a+1|0;else break}}if((q|0)<(i|0))q=q+1|0;else{j=1;s=11;break}}if((s|0)==11)return j|0;return 0}function EMb(a,c){a=a|0;c=c|0;var d=0,e=0;d=a;e=c;c=d+48|0;do{f[d>>2]=f[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(c|0));e=a+48|0;d=a+80|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;b[a+76>>0]=1;FMb(a);return}function FMb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;b=u;u=u+704|0;c=b+236|0;d=b;e=b+232|0;g=b+228|0;h=b+224|0;i=a+8|0;if((f[i>>2]|0)>0){j=a+12|0;k=c+4|0;l=c+8|0;m=c+40|0;o=c+48|0;p=c+44|0;q=c+52|0;r=c+56|0;s=c+60|0;t=c+64|0;v=c+96|0;w=c+104|0;x=c+100|0;y=c+108|0;z=c+112|0;A=c+116|0;B=c+120|0;C=c+152|0;D=c+160|0;E=c+156|0;F=c+164|0;G=c+168|0;H=c+172|0;I=c+176|0;J=c+208|0;K=c+216|0;L=c+212|0;M=c+220|0;N=c+224|0;O=c+228|0;P=c+232|0;Q=c+264|0;R=c+272|0;S=c+268|0;T=c+276|0;U=c+280|0;V=c+284|0;W=c+288|0;X=c+320|0;Y=c+328|0;Z=c+324|0;_=c+332|0;$=c+336|0;aa=c+340|0;ba=c+344|0;ca=c+376|0;da=c+384|0;ea=c+380|0;fa=c+388|0;ga=c+392|0;ha=c+396|0;ia=c+400|0;ja=c+432|0;ka=c+440|0;la=c+436|0;ma=a+20|0;na=a+16|0;oa=c+56|0;pa=c+112|0;qa=c+168|0;ra=c+224|0;sa=c+280|0;ta=c+336|0;ua=c+392|0;va=a+4|0;wa=c+452|0;xa=c+448|0;ya=c+464|0;za=c+456|0;Aa=c+460|0;Ba=a+52|0;Ca=a+56|0;Da=a+48|0;Ea=0;Fa=f[j>>2]|0;while(1){if((Fa|0)>0){Ga=+(Ea|0);Ha=0;do{f[c>>2]=1124007936;Ia=k;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[m>>2]=l;f[p>>2]=o;f[o>>2]=0;f[q>>2]=0;f[r>>2]=1124007936;Ia=s;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[v>>2]=t;f[x>>2]=w;f[w>>2]=0;f[y>>2]=0;f[z>>2]=1124007936;Ia=A;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[C>>2]=B;f[E>>2]=D;f[D>>2]=0;f[F>>2]=0;f[G>>2]=1124007936;Ia=H;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[J>>2]=I;f[L>>2]=K;f[K>>2]=0;f[M>>2]=0;f[N>>2]=1124007936;Ia=O;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[Q>>2]=P;f[S>>2]=R;f[R>>2]=0;f[T>>2]=0;f[U>>2]=1124007936;Ia=V;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[X>>2]=W;f[Z>>2]=Y;f[Y>>2]=0;f[_>>2]=0;f[$>>2]=1124007936;Ia=aa;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[ca>>2]=ba;f[ea>>2]=da;f[da>>2]=0;f[fa>>2]=0;f[ga>>2]=1124007936;Ia=ha;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[ja>>2]=ia;f[la>>2]=ka;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;f[ka+16>>2]=0;f[ka+20>>2]=0;f[ka+24>>2]=0;AY(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,c,-1);$j(d);AY(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,oa,-1);$j(d);AY(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,pa,-1);$j(d);AY(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,qa,-1);$j(d);AY(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,ra,-1);$j(d);AY(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,sa,-1);$j(d);AY(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,ta,-1);$j(d);AY(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,ua,-1);$j(d);Ka=+n[va>>2];La=Ka*+Me(+(Ga+ +(Ha|0)/+(f[j>>2]|0)));n[wa>>2]=La;n[xa>>2]=La*La*.5;Ia=mrc(La)|0;f[ya>>2]=Ia;f[za>>2]=Ea;f[Aa>>2]=Ha;Ia=f[Ba>>2]|0;if((Ia|0)==(f[Ca>>2]|0))HMb(Da,c);else{GMb(Ia,c);f[Ba>>2]=(f[Ba>>2]|0)+468}BKb(c);Ha=Ha+1|0;Ia=f[j>>2]|0}while((Ha|0)<(Ia|0));Ma=Ia}else Ma=Fa;Ea=Ea+1|0;if((Ea|0)>=(f[i>>2]|0)){Na=Ba;Oa=Da;break}else Fa=Ma}}else{Na=a+52|0;Oa=a+48|0}Ma=f[Oa>>2]|0;if((((f[Na>>2]|0)-Ma|0)/468|0)>>>0<=1){u=b;return}Fa=d+4|0;Da=d+8|0;Ba=a+76|0;i=a+96|0;Ea=a+100|0;j=a+92|0;Ca=a+84|0;Aa=a+88|0;za=a+80|0;ya=a+72|0;a=1;xa=Ma;while(1){Ma=xa;f[c>>2]=0;f[d>>2]=0;f[Fa>>2]=0;f[Da>>2]=0;n[e>>2]=+n[Ma+(a*468|0)+448>>2]-+n[Ma+((a+-1|0)*468|0)+448>>2];f[g>>2]=1;n[h>>2]=.25;Ma=qMb(e,g,h,Ba,d)|0;f[c>>2]=Ma;wa=f[i>>2]|0;if((wa|0)==(f[Ea>>2]|0))g6(j,c);else{f[wa>>2]=Ma;f[i>>2]=wa+4}Pa=f[Ca>>2]|0;if((Pa|0)==(f[Aa>>2]|0)){rJb(za,d);Qa=f[d>>2]|0}else{f[Pa>>2]=0;wa=Pa+4|0;f[wa>>2]=0;f[Pa+8>>2]=0;Ma=f[d>>2]|0;va=(f[Fa>>2]|0)-Ma|0;ua=va>>2;if(ua){if(ua>>>0>1073741823){Ra=20;break}na=VDc(va)|0;f[wa>>2]=na;f[Pa>>2]=na;f[Pa+8>>2]=na+(ua<<2);ua=f[d>>2]|0;va=(f[Fa>>2]|0)-ua|0;if((va|0)>0){dJc(na|0,ua|0,va|0)|0;f[wa>>2]=na+(va>>>2<<2);Sa=ua}else Sa=ua}else Sa=Ma;f[Ca>>2]=(f[Ca>>2]|0)+12;Qa=Sa}f[ya>>2]=(f[ya>>2]|0)+1;if(Qa|0){Ma=f[Fa>>2]|0;if((Ma|0)!=(Qa|0))f[Fa>>2]=Ma+(~((Ma+-4-Qa|0)>>>2)<<2);YDc(Qa)}a=a+1|0;xa=f[Oa>>2]|0;if(a>>>0>=(((f[Na>>2]|0)-xa|0)/468|0)>>>0){Ra=13;break}}if((Ra|0)==13){u=b;return}else if((Ra|0)==20)mCc(Pa)}function GMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=f[b>>2];c=a+4|0;d=b+4|0;f[c>>2]=f[d>>2];e=a+8|0;f[e>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];g=f[b+36>>2]|0;f[a+36>>2]=g;f[a+40>>2]=e;e=a+48|0;h=a+44|0;f[h>>2]=e;f[e>>2]=0;f[a+52>>2]=0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[d>>2]|0)<3){d=f[b+44>>2]|0;e=f[h>>2]|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2]}else{f[c>>2]=0;ZS(a,b)}c=a+56|0;d=b+56|0;f[c>>2]=f[d>>2];e=a+60|0;h=b+60|0;f[e>>2]=f[h>>2];g=a+64|0;f[g>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[a+80>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];i=f[b+92>>2]|0;f[a+92>>2]=i;f[a+96>>2]=g;g=a+104|0;j=a+100|0;f[j>>2]=g;f[g>>2]=0;f[a+108>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+100>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(c,d)}d=a+112|0;c=b+112|0;f[d>>2]=f[c>>2];e=a+116|0;h=b+116|0;f[e>>2]=f[h>>2];g=a+120|0;f[g>>2]=f[b+120>>2];f[a+124>>2]=f[b+124>>2];f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];f[a+136>>2]=f[b+136>>2];f[a+140>>2]=f[b+140>>2];f[a+144>>2]=f[b+144>>2];j=f[b+148>>2]|0;f[a+148>>2]=j;f[a+152>>2]=g;g=a+160|0;i=a+156|0;f[i>>2]=g;f[g>>2]=0;f[a+164>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+156>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(d,c)}c=a+168|0;d=b+168|0;f[c>>2]=f[d>>2];e=a+172|0;h=b+172|0;f[e>>2]=f[h>>2];g=a+176|0;f[g>>2]=f[b+176>>2];f[a+180>>2]=f[b+180>>2];f[a+184>>2]=f[b+184>>2];f[a+188>>2]=f[b+188>>2];f[a+192>>2]=f[b+192>>2];f[a+196>>2]=f[b+196>>2];f[a+200>>2]=f[b+200>>2];i=f[b+204>>2]|0;f[a+204>>2]=i;f[a+208>>2]=g;g=a+216|0;j=a+212|0;f[j>>2]=g;f[g>>2]=0;f[a+220>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+212>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(c,d)}d=a+224|0;c=b+224|0;f[d>>2]=f[c>>2];e=a+228|0;h=b+228|0;f[e>>2]=f[h>>2];g=a+232|0;f[g>>2]=f[b+232>>2];f[a+236>>2]=f[b+236>>2];f[a+240>>2]=f[b+240>>2];f[a+244>>2]=f[b+244>>2];f[a+248>>2]=f[b+248>>2];f[a+252>>2]=f[b+252>>2];f[a+256>>2]=f[b+256>>2];j=f[b+260>>2]|0;f[a+260>>2]=j;f[a+264>>2]=g;g=a+272|0;i=a+268|0;f[i>>2]=g;f[g>>2]=0;f[a+276>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+268>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(d,c)}c=a+280|0;d=b+280|0;f[c>>2]=f[d>>2];e=a+284|0;h=b+284|0;f[e>>2]=f[h>>2];g=a+288|0;f[g>>2]=f[b+288>>2];f[a+292>>2]=f[b+292>>2];f[a+296>>2]=f[b+296>>2];f[a+300>>2]=f[b+300>>2];f[a+304>>2]=f[b+304>>2];f[a+308>>2]=f[b+308>>2];f[a+312>>2]=f[b+312>>2];i=f[b+316>>2]|0;f[a+316>>2]=i;f[a+320>>2]=g;g=a+328|0;j=a+324|0;f[j>>2]=g;f[g>>2]=0;f[a+332>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+324>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(c,d)}d=a+336|0;c=b+336|0;f[d>>2]=f[c>>2];e=a+340|0;h=b+340|0;f[e>>2]=f[h>>2];g=a+344|0;f[g>>2]=f[b+344>>2];f[a+348>>2]=f[b+348>>2];f[a+352>>2]=f[b+352>>2];f[a+356>>2]=f[b+356>>2];f[a+360>>2]=f[b+360>>2];f[a+364>>2]=f[b+364>>2];f[a+368>>2]=f[b+368>>2];j=f[b+372>>2]|0;f[a+372>>2]=j;f[a+376>>2]=g;g=a+384|0;i=a+380|0;f[i>>2]=g;f[g>>2]=0;f[a+388>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+380>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;ZS(d,c)}c=a+392|0;d=b+392|0;f[c>>2]=f[d>>2];e=a+396|0;h=b+396|0;f[e>>2]=f[h>>2];g=a+400|0;f[g>>2]=f[b+400>>2];f[a+404>>2]=f[b+404>>2];f[a+408>>2]=f[b+408>>2];f[a+412>>2]=f[b+412>>2];f[a+416>>2]=f[b+416>>2];f[a+420>>2]=f[b+420>>2];f[a+424>>2]=f[b+424>>2];i=f[b+428>>2]|0;f[a+428>>2]=i;f[a+432>>2]=g;g=a+440|0;j=a+436|0;f[j>>2]=g;f[g>>2]=0;f[a+444>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+436>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];k=a+448|0;l=b+448|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];return}else{f[e>>2]=0;ZS(c,d);k=a+448|0;l=b+448|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];return}}function HMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/468|0;g=e+1|0;if(g>>>0>9177280)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/468|0;d=i<<1;j=i>>>0<4588640?(d>>>0<g>>>0?g:d):9177280;do if(j)if(j>>>0>9177280){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*468|0)|0;break}else k=0;while(0);d=k+(e*468|0)|0;e=d;g=k+(j*468|0)|0;GMb(d,b);b=d+468|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=k}else{i=k;k=e;e=d;do{i=i+-468|0;GMb(e+-468|0,i);e=k+-468|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;h=n;while(1){n=h;if((n|0)==(g|0))break;b=n+-468|0;BKb(b);h=b}if(!m)return;YDc(m);return}function IMb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;d=u;u=u+608|0;e=d+552|0;g=d+224|0;h=d+496|0;i=d;j=d+480|0;k=d+464|0;l=d+448|0;m=a+48|0;o=a+52|0;p=f[m>>2]|0;if((f[o>>2]|0)==(p|0)){f[e>>2]=0;f[e+4>>2]=0;q=tT(e,21)|0;r=465202;s=q+21|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));JMb(e,465224,100)}r=e+8|0;f[r>>2]=0;f[r+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=p+280;h_(c,e);c=(f[m>>2]|0)+280|0;sMb(c,c,0,0,+n[a+4>>2]);c=f[m>>2]|0;p=a+24|0;sMb(c+280|0,c+336|0,0,0,+n[p>>2]);t=+xMb((f[m>>2]|0)+280|0,+n[a+36>>2],+n[p>>2],f[a+40>>2]|0,0,0);c=a+32|0;n[c>>2]=t;r=f[m>>2]|0;AY(g,f[r+288>>2]|0,f[r+292>>2]|0,5);f[e>>2]=1124007936;r=e+4|0;v=e+8|0;w=e+40|0;q=r;s=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(s|0));f[w>>2]=v;v=e+48|0;x=e+44|0;f[x>>2]=v;f[v>>2]=0;f[e+52>>2]=0;y=f[g>>2]|0;ei[f[(f[y>>2]|0)+12>>2]&511](y,g,e,-1);$j(g);g=f[m>>2]|0;AY(i,f[g+288>>2]|0,f[g+292>>2]|0,5);f[h>>2]=1124007936;g=h+4|0;y=h+8|0;z=h+40|0;q=g;s=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(s|0));f[z>>2]=y;y=h+48|0;q=h+44|0;f[q>>2]=y;f[y>>2]=0;f[h+52>>2]=0;s=f[i>>2]|0;ei[f[(f[s>>2]|0)+12>>2]&511](s,i,h,-1);$j(i);i=f[m>>2]|0;a:do if((((f[o>>2]|0)-i|0)/468|0)>>>0>1){s=j+8|0;A=j+4|0;B=j+8|0;C=j+12|0;D=j+4|0;E=k+8|0;F=k+4|0;G=j+8|0;H=j+12|0;I=j+4|0;J=k+8|0;K=k+4|0;L=j+8|0;M=j+12|0;N=j+4|0;O=k+8|0;P=k+12|0;Q=k+4|0;R=l+8|0;S=l+4|0;T=j+8|0;U=j+12|0;V=j+4|0;W=k+8|0;X=k+12|0;Y=k+4|0;Z=l+8|0;_=l+4|0;$=j+8|0;aa=j+12|0;ba=j+4|0;ca=k+8|0;da=k+12|0;ea=k+4|0;fa=l+8|0;ga=l+4|0;ha=a+92|0;ia=a+80|0;ja=1;ka=i;while(1){la=ka;ma=ja+-1|0;na=s;f[na>>2]=0;f[na+4>>2]=0;f[j>>2]=33619968;f[A>>2]=la+(ja*468|0)+280;h_(la+(ma*468|0)+280|0,j);la=f[m>>2]|0;sMb(la+(ma*468|0)+280|0,la+(ja*468|0)+336|0,0,0,+n[p>>2]);la=f[m>>2]|0;f[B>>2]=0;f[C>>2]=0;f[j>>2]=16842752;f[D>>2]=la+(ja*468|0)+336;na=E;f[na>>2]=0;f[na+4>>2]=0;f[k>>2]=33619968;f[F>>2]=la+(ja*468|0);Ioa(j,k,5,1,0,1.0,0.0,4);la=f[m>>2]|0;f[G>>2]=0;f[H>>2]=0;f[j>>2]=16842752;f[I>>2]=la+(ja*468|0)+336;na=J;f[na>>2]=0;f[na+4>>2]=0;f[k>>2]=33619968;f[K>>2]=la+(ja*468|0)+56;Ioa(j,k,5,0,1,1.0,0.0,4);switch(f[a>>2]|0){case 0:{la=f[m>>2]|0;f[L>>2]=0;f[M>>2]=0;f[j>>2]=16842752;f[N>>2]=la+(ja*468|0);f[O>>2]=0;f[P>>2]=0;f[k>>2]=16842752;f[Q>>2]=la+(ja*468|0)+56;la=R;f[la>>2]=0;f[la+4>>2]=0;f[l>>2]=33619968;f[S>>2]=e;tMb(j,k,l,+n[c>>2]);break}case 1:{la=f[m>>2]|0;f[T>>2]=0;f[U>>2]=0;f[j>>2]=16842752;f[V>>2]=la+(ja*468|0);f[W>>2]=0;f[X>>2]=0;f[k>>2]=16842752;f[Y>>2]=la+(ja*468|0)+56;la=Z;f[la>>2]=0;f[la+4>>2]=0;f[l>>2]=33619968;f[_>>2]=e;uMb(j,k,l,+n[c>>2]);break}case 2:{la=f[m>>2]|0;f[$>>2]=0;f[aa>>2]=0;f[j>>2]=16842752;f[ba>>2]=la+(ja*468|0);f[ca>>2]=0;f[da>>2]=0;f[k>>2]=16842752;f[ea>>2]=la+(ja*468|0)+56;la=fa;f[la>>2]=0;f[la+4>>2]=0;f[l>>2]=33619968;f[ga>>2]=e;vMb(j,k,l,+n[c>>2]);break}default:{}}if((f[(f[ha>>2]|0)+(ma<<2)>>2]|0)>0){la=0;do{AMb((f[m>>2]|0)+(ja*468|0)+280|0,e,h,+n[(f[(f[ia>>2]|0)+(ma*12|0)>>2]|0)+(la<<2)>>2]);la=la+1|0}while((la|0)<(f[(f[ha>>2]|0)+(ma<<2)>>2]|0))}ja=ja+1|0;ka=f[m>>2]|0;if(ja>>>0>=(((f[o>>2]|0)-ka|0)/468|0)>>>0)break a}}while(0);o=h+36|0;m=f[o>>2]|0;if(m|0?(c=m+12|0,m=f[c>>2]|0,f[c>>2]=m+-1,(m|0)==1):0)_S(h);f[o>>2]=0;o=h+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[g>>2]|0)>0){o=f[z>>2]|0;z=0;do{f[o+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[g>>2]|0))}g=f[q>>2]|0;if((g|0)!=(y|0))g0(g);g=e+36|0;y=f[g>>2]|0;if(y|0?(q=y+12|0,y=f[q>>2]|0,f[q>>2]=y+-1,(y|0)==1):0)_S(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[r>>2]|0)>0){g=f[w>>2]|0;w=0;do{f[g+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[r>>2]|0))}r=f[x>>2]|0;if((r|0)==(v|0)){u=d;return 0}g0(r);u=d;return 0}function JMb(a,b,c){a=a|0;b=b|0;c=c|0;z5(-215,a,b,465253,c);return}function KMb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+48|0;g=a+52|0;h=((f[g>>2]|0)-(f[e>>2]|0)|0)/468|0;f[c>>2]=0;f[c+4>>2]=h;f[d>>2]=137100;f[d+4>>2]=e;y8(c,d,-1.0);d=f[g>>2]|0;g=f[e>>2]|0;e=g;if((d|0)==(g|0)){u=b;return}c=f[a+20>>2]|0;h=(c|0)>0;i=a+16|0;a=(d-g|0)/468|0;g=0;do{if(h?(d=f[i>>2]|0,(d|0)>0):0){j=f[e+(g*468|0)+128>>2]|0;k=f[f[e+(g*468|0)+156>>2]>>2]|0;l=f[e+(g*468|0)+184>>2]|0;m=f[f[e+(g*468|0)+212>>2]>>2]|0;o=f[e+(g*468|0)+240>>2]|0;p=f[f[e+(g*468|0)+268>>2]>>2]|0;q=f[e+(g*468|0)+408>>2]|0;r=f[f[e+(g*468|0)+436>>2]>>2]|0;s=0;do{t=j+(Y(k,s)|0)|0;v=l+(Y(m,s)|0)|0;w=o+(Y(p,s)|0)|0;x=q+(Y(r,s)|0)|0;y=0;do{z=+n[v+(y<<2)>>2];n[x+(y<<2)>>2]=+n[t+(y<<2)>>2]*+n[w+(y<<2)>>2]-z*z;y=y+1|0}while((y|0)<(d|0));s=s+1|0}while((s|0)<(c|0))}g=g+1|0}while(g>>>0<a>>>0);u=b;return}function LMb(a){a=a|0;YDc(a);return}function MMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+224|0;d=c;e=f[b>>2]|0;g=b+4|0;if((e|0)>=(f[g>>2]|0)){u=c;return}b=f[a+4>>2]|0;a=e;do{e=f[b>>2]|0;yMb(e+(a*468|0)+336|0,e+(a*468|0)|0,1,0,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;yMb(e+(a*468|0)+336|0,e+(a*468|0)+56|0,0,1,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;yMb(e+(a*468|0)|0,e+(a*468|0)+112|0,1,0,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;yMb(e+(a*468|0)+56|0,e+(a*468|0)+224|0,0,1,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;yMb(e+(a*468|0)|0,e+(a*468|0)+168|0,0,1,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;nY(d,e+(a*468|0)|0,+(f[e+(a*468|0)+464>>2]|0));e=f[d>>2]|0;ei[f[(f[e>>2]|0)+12>>2]&511](e,d,(f[b>>2]|0)+(a*468|0)|0,-1);$j(d);e=f[b>>2]|0;nY(d,e+(a*468|0)+56|0,+(f[e+(a*468|0)+464>>2]|0));e=f[d>>2]|0;ei[f[(f[e>>2]|0)+12>>2]&511](e,d,(f[b>>2]|0)+(a*468|0)+56|0,-1);$j(d);e=f[b>>2]|0;h=f[e+(a*468|0)+464>>2]|0;nY(d,e+(a*468|0)+112|0,+(Y(h,h)|0));h=f[d>>2]|0;ei[f[(f[h>>2]|0)+12>>2]&511](h,d,(f[b>>2]|0)+(a*468|0)+112|0,-1);$j(d);h=f[b>>2]|0;e=f[h+(a*468|0)+464>>2]|0;nY(d,h+(a*468|0)+168|0,+(Y(e,e)|0));e=f[d>>2]|0;ei[f[(f[e>>2]|0)+12>>2]&511](e,d,(f[b>>2]|0)+(a*468|0)+168|0,-1);$j(d);e=f[b>>2]|0;h=f[e+(a*468|0)+464>>2]|0;nY(d,e+(a*468|0)+224|0,+(Y(h,h)|0));h=f[d>>2]|0;ei[f[(f[h>>2]|0)+12>>2]&511](h,d,(f[b>>2]|0)+(a*468|0)+224|0,-1);$j(d);a=a+1|0}while((a|0)<(f[g>>2]|0));u=c;return}function NMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[b>>2]|0;d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~(((e+-28-c|0)>>>0)/28|0)*28|0);KMb(a);OMb(a,b);PMb(a,b);return}function OMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0;c=u;u=u+96|0;d=c+72|0;e=c+64|0;g=c;h=a+60|0;i=a+64|0;j=f[i>>2]|0;k=f[h>>2]|0;l=k;if((j|0)==(k|0)){m=l;o=j}else{j=0;k=l;while(1){l=k+(j*12|0)|0;p=f[l>>2]|0;f[l>>2]=0;f[k+(j*12|0)+4>>2]=0;f[k+(j*12|0)+8>>2]=0;if(p|0)YDc(p);j=j+1|0;p=f[i>>2]|0;l=f[h>>2]|0;q=l;if(j>>>0>=((p-l|0)/12|0)>>>0){m=q;o=p;break}else k=q}}k=o;if((k|0)==(m|0))r=k;else{o=k;while(1){k=o+-12|0;f[i>>2]=k;j=f[k>>2]|0;if(!j)s=k;else{k=o+-8|0;q=f[k>>2]|0;if((q|0)!=(j|0))f[k>>2]=q+(~(((q+-28-j|0)>>>0)/28|0)*28|0);YDc(j);s=f[i>>2]|0}if((s|0)==(m|0)){r=m;break}else o=s}}f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;o=a+48|0;m=a+52|0;j=f[m>>2]|0;q=f[o>>2]|0;a:do if((((j-q|0)/468|0)+-1|0)>>>0>1){k=a+68|0;p=1;l=r;while(1){if((l|0)==(f[k>>2]|0))QMb(h,d);else{gIb(l,d);f[i>>2]=(f[i>>2]|0)+12}t=p+1|0;v=f[m>>2]|0;w=f[o>>2]|0;if(t>>>0>=(((v-w|0)/468|0)+-1|0)>>>0){x=w;y=v;break a}p=t;l=f[i>>2]|0}}else{x=q;y=j}while(0);f[e>>2]=1;f[e+4>>2]=((y-x|0)/468|0)+-1;f[g>>2]=137120;f[g+4>>2]=o;f[g+8>>2]=h;x=g+12|0;y=a;a=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(a|0));y8(e,g,-1.0);g=f[i>>2]|0;e=f[h>>2]|0;if((g-e|0)>0){y=b+4|0;x=b+8|0;a=0;j=0;q=g;g=e;while(1){e=g;m=a;a=a+1|0;if(((f[e+(m*12|0)+4>>2]|0)-(f[e+(m*12|0)>>2]|0)|0)>0){r=m+2|0;l=0;p=j;k=e;while(1){e=f[y>>2]|0;t=f[b>>2]|0;v=e-t|0;w=t;t=e;b:do if((v|0)>0){z=(v>>>0)/28|0;A=k+(m*12|0)|0;B=0;while(1){C=f[w+(B*28|0)+24>>2]|0;if((C|0)==(m|0)|((C|0)==(a|0)|(C|0)==(r|0))?(D=f[A>>2]|0,E=+n[D+(l*28|0)>>2]-+n[w+(B*28|0)>>2],F=+n[D+(l*28|0)+4>>2]-+n[w+(B*28|0)+4>>2],C=f[(f[o>>2]|0)+(a*468|0)+464>>2]|0,E*E+F*F<+(Y(C,C)|0)):0)break;C=B+1|0;if((C|0)<(z|0))B=C;else{G=0;H=p;I=35;break b}}z=+n[D+(l*28|0)+16>>2]>+n[w+(B*28|0)+16>>2];if(z){G=z&1;H=B;I=35}else J=p}else{G=0;H=p;I=35}while(0);do if((I|0)==35){I=0;v=f[k+(m*12|0)>>2]|0;z=v+(l*28|0)|0;F=+n[z>>2];A=v+(l*28|0)+8|0;E=+n[A>>2]*3.0;C=mrc(F-E)|0;K=+n[v+(l*28|0)+4>>2];v=mrc(E+K)|0;if(((C|0)>=0?(C=mrc(K-E)|0,L=mrc(F+E)|0,M=f[o>>2]|0,!((C|0)<0?1:(L|0)>=(f[M+(a*468|0)+404>>2]|0))):0)?(v|0)<(f[M+(a*468|0)+400>>2]|0):0){if(G|0){n[w+(H*28|0)>>2]=F;n[w+(H*28|0)+4>>2]=K;M=w+(H*28|0)+8|0;f[M>>2]=f[A>>2];f[M+4>>2]=f[A+4>>2];f[M+8>>2]=f[A+8>>2];f[M+12>>2]=f[A+12>>2];f[M+16>>2]=f[A+16>>2];J=H;break}if((t|0)==(f[x>>2]|0)){V_(b,z);J=H;break}else{n[e>>2]=F;n[t+4>>2]=K;z=t+8|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[y>>2]=(f[y>>2]|0)+28;J=H;break}}else J=H}while(0);l=l+1|0;k=f[h>>2]|0;if((l|0)>=(((f[k+(m*12|0)+4>>2]|0)-(f[k+(m*12|0)>>2]|0)|0)/28|0|0))break;else p=J}N=J;O=k;P=f[i>>2]|0}else{N=j;O=g;P=q}if((a|0)>=((P-O|0)/12|0|0))break;else{j=N;q=P;g=O}}}O=f[d>>2]|0;if(!O){u=c;return}d=f[s>>2]|0;if((d|0)!=(O|0))f[s>>2]=d+(~(((d+-28-O|0)>>>0)/28|0)*28|0);YDc(O);u=c;return}function PMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;c=u;u=u+912|0;d=c+848|0;e=c+448|0;g=c+792|0;h=c+224|0;i=c+736|0;j=c;k=c+720|0;l=c+704|0;m=c+688|0;o=c+672|0;AY(e,3,3,5);f[d>>2]=1124007936;p=d+4|0;q=d+8|0;r=d+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;q=d+48|0;v=d+44|0;f[v>>2]=q;f[q>>2]=0;f[d+52>>2]=0;w=f[e>>2]|0;ei[f[(f[w>>2]|0)+12>>2]&511](w,e,d,-1);$j(e);AY(h,3,1,5);f[g>>2]=1124007936;e=g+4|0;w=g+8|0;x=g+40|0;s=e;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[x>>2]=w;w=g+48|0;y=g+44|0;f[y>>2]=w;f[w>>2]=0;f[g+52>>2]=0;z=f[h>>2]|0;ei[f[(f[z>>2]|0)+12>>2]&511](z,h,g,-1);$j(h);AY(j,3,1,5);f[i>>2]=1124007936;h=i+4|0;z=i+8|0;A=i+40|0;s=h;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[A>>2]=z;z=i+48|0;s=i+44|0;f[s>>2]=z;f[z>>2]=0;f[i+52>>2]=0;t=f[j>>2]|0;ei[f[(f[t>>2]|0)+12>>2]&511](t,j,i,-1);$j(j);gIb(k,b);j=k+4|0;t=f[j>>2]|0;B=f[k>>2]|0;if((t|0)==(B|0)){C=t;D=t}else{t=a+48|0;E=d+16|0;F=g+16|0;G=l+8|0;H=l+12|0;I=l+4|0;J=m+8|0;K=m+12|0;M=m+4|0;N=o+8|0;O=o+4|0;P=i+16|0;Q=a+12|0;R=a+4|0;a=0;S=B;while(1){B=S;T=~~+n[B+(a*28|0)>>2];U=~~+n[B+(a*28|0)+4>>2];V=f[B+(a*28|0)+24>>2]|0;B=f[t>>2]|0;W=f[B+(V*468|0)+408>>2]|0;X=f[f[B+(V*468|0)+436>>2]>>2]|0;Z=W+(Y(X,U)|0)+(T<<2)|0;_=+n[Z+4>>2];$=+n[Z+-4>>2];aa=U+1|0;ba=W+(Y(X,aa)|0)+(T<<2)|0;ca=+n[ba>>2];da=U+-1|0;ea=W+(Y(X,da)|0)+(T<<2)|0;fa=+n[ea>>2];X=V+1|0;W=f[B+(X*468|0)+408>>2]|0;ga=f[f[B+(X*468|0)+436>>2]>>2]|0;X=W+(Y(ga,U)|0)+(T<<2)|0;ha=+n[X>>2];ia=V+-1|0;V=f[B+(ia*468|0)+408>>2]|0;ja=f[f[B+(ia*468|0)+436>>2]>>2]|0;ia=V+(Y(ja,U)|0)+(T<<2)|0;ka=+n[ia>>2];la=+n[Z>>2]*2.0;ma=(+n[ba+4>>2]+ +n[ea+-4>>2])*.25-(+n[ea+4>>2]+ +n[ba+-4>>2])*.25;na=(+n[X+4>>2]+ +n[ia+-4>>2])*.25-(+n[X+-4>>2]+ +n[ia+4>>2])*.25;ia=W+(Y(ga,aa)|0)+(T<<2)|0;X=V+(Y(ja,da)|0)+(T<<2)|0;ba=W+(Y(ga,da)|0)+(T<<2)|0;da=V+(Y(ja,aa)|0)+(T<<2)|0;oa=(+n[ia>>2]+ +n[X>>2])*.25-(+n[ba>>2]+ +n[da>>2])*.25;da=f[E>>2]|0;n[da>>2]=_+$-la;ba=f[f[v>>2]>>2]|0;X=da+ba|0;n[X+4>>2]=ca+fa-la;ia=da+(ba<<1)|0;n[ia+8>>2]=ha+ka-la;n[X>>2]=ma;n[da+4>>2]=ma;n[ia>>2]=na;n[da+8>>2]=na;n[ia+4>>2]=oa;n[X+8>>2]=oa;X=f[F>>2]|0;n[X>>2]=-((_-$)*.5);ia=f[f[y>>2]>>2]|0;n[X+ia>>2]=-((ca-fa)*.5);n[X+(ia<<1)>>2]=-((ha-ka)*.5);f[G>>2]=0;f[H>>2]=0;f[l>>2]=16842752;f[I>>2]=d;f[J>>2]=0;f[K>>2]=0;f[m>>2]=16842752;f[M>>2]=g;ia=N;f[ia>>2]=0;f[ia+4>>2]=0;f[o>>2]=33619968;f[O>>2]=i;oQ(l,m,o,0)|0;ia=f[P>>2]|0;ka=+n[ia>>2];if((+L(+ka)<=1.0?(X=f[f[s>>2]>>2]|0,da=ia+X|0,+L(+(+n[da>>2]))<=1.0):0)?(ba=ia+(X<<1)|0,+L(+(+n[ba>>2]))<=1.0):0){X=f[k>>2]|0;ia=X+(a*28|0)|0;n[ia>>2]=ka+ +n[ia>>2];ia=X+(a*28|0)+4|0;n[ia>>2]=+n[da>>2]+ +n[ia>>2];ia=X+(a*28|0)+12|0;ka=+n[R>>2]*2.0;ha=ka*+Me(+(+(f[X+(a*28|0)+20>>2]|0)+(+n[ia>>2]+ +n[ba>>2])/+(f[Q>>2]|0)));n[X+(a*28|0)+8>>2]=ha;n[ia>>2]=0.0;pa=X}else{X=f[k>>2]|0;n[X+(a*28|0)+16>>2]=-1.0;pa=X}X=pa;a=a+1|0;ia=f[j>>2]|0;if(a>>>0>=((ia-X|0)/28|0)>>>0){C=ia;D=X;break}else S=X}}S=C;a=f[b>>2]|0;pa=b+4|0;Q=f[pa>>2]|0;if((Q|0)!=(a|0))f[pa>>2]=Q+(~(((Q+-28-a|0)>>>0)/28|0)*28|0);a=D;if((C|0)==(D|0)){qa=a;ra=S}else{Q=b+8|0;R=0;P=a;a=S;S=D;D=C;while(1){C=P+(R*28|0)|0;do if(+n[P+(R*28|0)+16>>2]!=-1.0){o=f[pa>>2]|0;if((o|0)==(f[Q>>2]|0)){V_(b,C);m=f[j>>2]|0;sa=f[k>>2]|0;ta=m;ua=m;break}else{f[o>>2]=f[C>>2];f[o+4>>2]=f[P+(R*28|0)+4>>2];m=o+8|0;o=P+(R*28|0)+8|0;f[m>>2]=f[o>>2];f[m+4>>2]=f[o+4>>2];f[m+8>>2]=f[o+8>>2];f[m+12>>2]=f[o+12>>2];f[m+16>>2]=f[o+16>>2];f[pa>>2]=(f[pa>>2]|0)+28;sa=S;ta=D;ua=a;break}}else{sa=S;ta=D;ua=a}while(0);R=R+1|0;C=sa;if(R>>>0>=((ta-sa|0)/28|0)>>>0){qa=C;ra=ua;break}else{P=C;a=ua;S=sa;D=ta}}}if(qa|0){if((ra|0)!=(qa|0))f[j>>2]=ra+(~(((ra+-28-qa|0)>>>0)/28|0)*28|0);YDc(qa)}qa=i+36|0;ra=f[qa>>2]|0;if(ra|0?(j=ra+12|0,ra=f[j>>2]|0,f[j>>2]=ra+-1,(ra|0)==1):0)_S(i);f[qa>>2]=0;qa=i+16|0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[h>>2]|0)>0){qa=f[A>>2]|0;A=0;do{f[qa+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[h>>2]|0))}h=f[s>>2]|0;if((h|0)!=(z|0))g0(h);h=g+36|0;z=f[h>>2]|0;if(z|0?(s=z+12|0,z=f[s>>2]|0,f[s>>2]=z+-1,(z|0)==1):0)_S(g);f[h>>2]=0;h=g+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[e>>2]|0)>0){h=f[x>>2]|0;x=0;do{f[h+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[e>>2]|0))}e=f[y>>2]|0;if((e|0)!=(w|0))g0(e);e=d+36|0;w=f[e>>2]|0;if(w|0?(y=w+12|0,w=f[y>>2]|0,f[y>>2]=w+-1,(w|0)==1):0)_S(d);f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[r>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[v>>2]|0;if((p|0)==(q|0)){u=c;return}g0(p);u=c;return}function QMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;gIb(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-12|0;gIb(e+-12|0,i);e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~(((n+-28-b|0)>>>0)/28|0)*28|0);YDc(b)}}while((h|0)!=(g|0))}if(!m)return;YDc(m);return}function RMb(a){a=a|0;YDc(a);return}function SMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0;c=u;u=u+32|0;d=c;e=f[b>>2]|0;g=b+4|0;if((e|0)>=(f[g>>2]|0)){u=c;return}b=f[a+8>>2]|0;h=f[a+4>>2]|0;i=a+32|0;j=a+28|0;k=a+40|0;a=d+4|0;l=d+8|0;m=d+12|0;o=d+16|0;p=d+20|0;q=d+24|0;r=e;e=f[i>>2]|0;while(1){if((e+-1|0)>1){s=r+-1|0;t=r+1|0;v=1;w=f[j>>2]|0;while(1){if((w+-1|0)>1){x=+(v|0);y=1;do{z=f[h>>2]|0;A=z+(r*468|0)+392|0;B=(f[z+(r*468|0)+408>>2]|0)+(Y(f[f[z+(r*468|0)+436>>2]>>2]|0,v)|0)+(y<<2)|0;C=+n[B>>2];if((((C>+n[k>>2]?C>=+n[B+-4>>2]:0)?DMb(A,1,C,v,y,1)|0:0)?DMb((f[h>>2]|0)+(s*468|0)+392|0,1,C,v,y,0)|0:0)?DMb((f[h>>2]|0)+(t*468|0)+392|0,1,C,v,y,0)|0:0){D=+(y|0);n[d>>2]=D;n[a>>2]=x;E=+L(+C);n[o>>2]=E;A=f[h>>2]|0;f[l>>2]=f[A+(r*468|0)+452>>2];f[p>>2]=f[A+(r*468|0)+456>>2];f[q>>2]=r;n[m>>2]=+(f[A+(r*468|0)+460>>2]|0);A=f[b>>2]|0;B=A+(s*12|0)+4|0;z=f[B>>2]|0;if((z|0)==(f[A+(s*12|0)+8>>2]|0))V_(A+(s*12|0)|0,d);else{n[z>>2]=D;n[z+4>>2]=x;A=z+8|0;f[A>>2]=f[l>>2];f[A+4>>2]=f[l+4>>2];f[A+8>>2]=f[l+8>>2];f[A+12>>2]=f[l+12>>2];f[A+16>>2]=f[l+16>>2];f[B>>2]=(f[B>>2]|0)+28}}y=y+1|0;B=f[j>>2]|0}while((y|0)<(B+-1|0));F=B}else F=w;v=v+1|0;y=f[i>>2]|0;if((v|0)>=(y+-1|0)){G=t;H=y;break}else w=F}}else{G=r+1|0;H=e}if((G|0)<(f[g>>2]|0)){r=G;e=H}else break}u=c;return}function TMb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+288|0;g=e;h=e+224|0;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;l=k;a:do if((j|0)!=(k|0)){m=a+48|0;n=a+52|0;o=(j-k|0)/28|0;p=0;while(1){q=f[l+(p*28|0)+24>>2]|0;if((q|0)<=-1){r=7;break}p=p+1|0;if((q|0)>=(((f[n>>2]|0)-(f[m>>2]|0)|0)/468|0|0)){r=7;break}if(p>>>0>=o>>>0)break a}if((r|0)==7){f[g>>2]=0;f[g+4>>2]=0;s=tT(g,79)|0;t=465406;v=s+79|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));JMb(g,465486,554)}}while(0);if(!(b[a+45>>0]|0)){AY(g,(j-k|0)/28|0,64,5);r=f[g>>2]|0;ei[f[(f[r>>2]|0)+12>>2]&511](r,g,d,-1);$j(g)}else{AY(g,(j-k|0)/28|0,128,5);k=f[g>>2]|0;ei[f[(f[k>>2]|0)+12>>2]&511](k,g,d,-1);$j(g)}k=((f[i>>2]|0)-(f[c>>2]|0)|0)/28|0;f[g>>2]=0;f[g+4>>2]=k;f[h>>2]=137140;f[h+4>>2]=c;f[h+8>>2]=d;f[h+12>>2]=a+48;s=h+16|0;t=a;v=s+48|0;do{f[s>>2]=f[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(v|0));y8(g,h,-1.0);u=e;return}function UMb(a){a=a|0;YDc(a);return}function VMb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;d=f[a+8>>2]|0;e=f[a+12>>2]|0;g=f[c>>2]|0;h=c+4|0;if((g|0)>=(f[h>>2]|0))return;c=f[a+4>>2]|0;i=a+60|0;j=a+16|0;k=a+61|0;l=d+16|0;m=d+44|0;d=g;do{g=f[c>>2]|0;o=g+(d*28|0)+12|0;n[o>>2]=0.0;do if(!(b[i>>0]|0)){YMb(g+(d*28|0)|0,e,j);p=(f[c>>2]|0)+(d*28|0)|0;q=(f[l>>2]|0)+(Y(f[f[m>>2]>>2]|0,d)|0)|0;if(!(b[k>>0]|0)){_Mb(a,p,q);break}else{ZMb(a,p,q);break}}else{n[o>>2]=0.0;q=g+(d*28|0)|0;p=(f[l>>2]|0)+(Y(f[f[m>>2]>>2]|0,d)|0)|0;if(!(b[k>>0]|0)){XMb(a,q,p);break}else{WMb(a,q,p);break}}while(0);d=d+1|0}while((d|0)<(f[h>>2]|0));return}function WMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,W=0,X=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0;d=f[a+12>>2]|0;e=+n[b+4>>2];g=+n[b>>2];h=mrc(+n[b+8>>2]*.5)|0;i=f[b+24>>2]|0;j=+(h|0)*2.5;k=j*(j*2.0);b=f[a+32>>2]|0;l=f[a+36>>2]|0;a=b+-1|0;m=l+-1|0;o=f[d>>2]|0;d=f[o+(i*468|0)+16>>2]|0;p=f[f[o+(i*468|0)+44>>2]>>2]|0;q=f[o+(i*468|0)+72>>2]|0;r=f[f[o+(i*468|0)+100>>2]>>2]|0;j=-.5;i=0;o=-8;s=0.0;while(1){t=o+-4|0;j=j+1.0;u=e+ +(Y(o+1|0,h)|0);v=j+-2.0;w=v*v;x=o+4|0;v=-.5;y=-8;z=i;A=s;while(1){B=y+-4|0;C=g+ +(Y(y+1|0,h)|0);y=y+5|0;D=t;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0;N=0.0;while(1){O=e+ +(Y(D,h)|0);P=u-O;Q=P*P;R=~~(O+-.5);S=(R|0)<0;T=S?0:R;R=(T|0)<(l|0)?T:m;T=~~(O+.5);U=(T|0)>0?T:0;T=(U|0)<(l|0)?U:m;P=O-+(R|0);U=d+(Y(p,R)|0)|0;W=d+(Y(p,T)|0)|0;O=1.0-P;X=q+(Y(r,R)|0)|0;R=q+(Y(r,T)|0)|0;if(S){S=B;Z=F;_=G;$=H;aa=I;ba=J;ca=K;da=N;ea=E;while(1){fa=g+ +(Y(S,h)|0);ga=C-fa;ha=+V(+(-(Q+ga*ga)/k));T=~~(fa+-.5);ia=(T|0)>0?T:0;T=(ia|0)<(b|0)?ia:a;ia=~~(fa+.5);ja=(ia|0)>0?ia:0;ia=(ja|0)<(b|0)?ja:a;ga=fa-+(T|0);fa=1.0-ga;ka=fa*O;la=ga*O;ma=fa*P;fa=ga*P;ga=ha*(ka*+n[U+(T<<2)>>2]+la*+n[U+(ia<<2)>>2]+ma*+n[W+(T<<2)>>2]+fa*+n[W+(ia<<2)>>2]);na=ha*(ka*+n[X+(T<<2)>>2]+la*+n[X+(ia<<2)>>2]+ma*+n[R+(T<<2)>>2]+fa*+n[R+(ia<<2)>>2]);if(!(na>=0.0)){oa=Z+ +L(+ga);pa=$+ga;qa=ba;ra=da}else{oa=Z;pa=$;qa=ba+ +L(+ga);ra=da+ga}if(!(ga>=0.0)){sa=ea+ +L(+na);ta=_+na;ua=aa;va=ca}else{sa=ea;ta=_;ua=aa+ +L(+na);va=ca+na}S=S+1|0;if((S|0)>=(y|0)){wa=sa;xa=oa;ya=ta;za=pa;Aa=ua;Ba=qa;Ca=va;Da=ra;break}else{Z=oa;_=ta;$=pa;aa=ua;ba=qa;ca=va;da=ra;ea=sa}}}else{S=B;ea=F;da=G;ca=H;ba=I;aa=J;$=K;_=N;Z=E;while(1){na=g+ +(Y(S,h)|0);ga=C-na;fa=+V(+(-(Q+ga*ga)/k));ia=~~(na+-.5);T=(ia|0)>0?ia:0;ia=(T|0)<(b|0)?T:a;T=~~(na+.5);ja=(T|0)>0?T:0;T=(ja|0)<(b|0)?ja:a;ga=na-+(ia|0);na=1.0-ga;ma=na*O;la=ga*O;ka=na*P;na=ga*P;ga=fa*(ma*+n[U+(ia<<2)>>2]+la*+n[U+(T<<2)>>2]+ka*+n[W+(ia<<2)>>2]+na*+n[W+(T<<2)>>2]);ha=fa*(ma*+n[X+(ia<<2)>>2]+la*+n[X+(T<<2)>>2]+ka*+n[R+(ia<<2)>>2]+na*+n[R+(T<<2)>>2]);if(!(ha>=0.0)){Ea=ea+ +L(+ga);Fa=ca+ga;Ga=aa;Ha=_}else{Ea=ea;Fa=ca;Ga=aa+ +L(+ga);Ha=_+ga}if(!(ga>=0.0)){Ia=Z+ +L(+ha);Ja=da+ha;Ka=ba;La=$}else{Ia=Z;Ja=da;Ka=ba+ +L(+ha);La=$+ha}S=S+1|0;if((S|0)>=(y|0)){wa=Ia;xa=Ea;ya=Ja;za=Fa;Aa=Ka;Ba=Ga;Ca=La;Da=Ha;break}else{ea=Ea;da=Ja;ca=Fa;ba=Ka;aa=Ga;$=La;_=Ha;Z=Ia}}}if((D|0)<(x|0)){D=D+1|0;E=wa;F=xa;G=ya;H=za;I=Aa;J=Ba;K=Ca;N=Da}else break}v=v+1.0;N=v+-2.0;K=+V(+(-(w+N*N)/4.5));n[c+(z<<2)>>2]=Da*K;n[c+((z|1)<<2)>>2]=za*K;n[c+((z|2)<<2)>>2]=Ba*K;n[c+((z|3)<<2)>>2]=xa*K;n[c+((z|4)<<2)>>2]=Ca*K;n[c+((z|5)<<2)>>2]=ya*K;n[c+((z|6)<<2)>>2]=Aa*K;n[c+((z|7)<<2)>>2]=wa*K;A=A+K*((wa*wa+(Aa*Aa+(ya*ya+(Ca*Ca+(Ba*Ba+(Da*Da+za*za)+xa*xa)))))*K);if((y|0)>=12)break;else z=z+8|0}o=o+5|0;if((o|0)>=12)break;else{i=i+32|0;s=A}}s=+M(+A);i=0;do{o=c+(i<<2)|0;n[o>>2]=+n[o>>2]/s;i=i+1|0}while((i|0)!=128);return}function XMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0;d=f[a+12>>2]|0;e=+n[b+4>>2];g=+n[b>>2];h=mrc(+n[b+8>>2]*.5)|0;i=f[b+24>>2]|0;j=+(h|0)*2.5;k=j*(j*2.0);b=f[a+32>>2]|0;l=f[a+36>>2]|0;a=b+-1|0;m=l+-1|0;o=f[d>>2]|0;d=f[o+(i*468|0)+16>>2]|0;p=f[f[o+(i*468|0)+44>>2]>>2]|0;q=f[o+(i*468|0)+72>>2]|0;r=f[f[o+(i*468|0)+100>>2]>>2]|0;j=-.5;i=0;o=-8;s=0.0;while(1){t=o+-4|0;j=j+1.0;u=e+ +(Y(o+1|0,h)|0);v=j+-2.0;w=v*v;x=o+4|0;v=-.5;y=-8;z=i;A=s;while(1){B=y+-4|0;C=g+ +(Y(y+1|0,h)|0);y=y+5|0;D=t;E=0.0;F=0.0;G=0.0;H=0.0;while(1){I=e+ +(Y(D,h)|0);J=u-I;K=J*J;N=~~(I+-.5);O=(N|0)<0;P=O?0:N;N=(P|0)<(l|0)?P:m;P=~~(I+.5);Q=(P|0)>0?P:0;P=(Q|0)<(l|0)?Q:m;J=I-+(N|0);Q=d+(Y(p,N)|0)|0;R=d+(Y(p,P)|0)|0;I=1.0-J;S=q+(Y(r,N)|0)|0;N=q+(Y(r,P)|0)|0;if(O){O=B;T=F;U=G;W=H;X=E;while(1){Z=g+ +(Y(O,h)|0);_=C-Z;$=+V(+(-(K+_*_)/k));P=~~(Z+-.5);aa=(P|0)>0?P:0;P=(aa|0)<(b|0)?aa:a;aa=~~(Z+.5);ba=(aa|0)>0?aa:0;aa=(ba|0)<(b|0)?ba:a;_=Z-+(P|0);Z=1.0-_;ca=Z*I;da=_*I;ea=Z*J;Z=_*J;_=$*(ca*+n[Q+(P<<2)>>2]+da*+n[Q+(aa<<2)>>2]+ea*+n[R+(P<<2)>>2]+Z*+n[R+(aa<<2)>>2]);fa=$*(ca*+n[S+(P<<2)>>2]+da*+n[S+(aa<<2)>>2]+ea*+n[N+(P<<2)>>2]+Z*+n[N+(aa<<2)>>2]);Z=X+_;ea=W+fa;da=U+ +L(+_);_=T+ +L(+fa);O=O+1|0;if((O|0)>=(y|0)){ga=Z;ha=_;ia=da;ja=ea;break}else{T=_;U=da;W=ea;X=Z}}}else{O=B;X=F;W=G;U=H;T=E;while(1){Z=g+ +(Y(O,h)|0);ea=C-Z;da=+V(+(-(K+ea*ea)/k));aa=~~(Z+-.5);P=(aa|0)>0?aa:0;aa=(P|0)<(b|0)?P:a;P=~~(Z+.5);ba=(P|0)>0?P:0;P=(ba|0)<(b|0)?ba:a;ea=Z-+(aa|0);Z=1.0-ea;_=Z*I;fa=ea*I;ca=Z*J;Z=ea*J;ea=da*(_*+n[Q+(aa<<2)>>2]+fa*+n[Q+(P<<2)>>2]+ca*+n[R+(aa<<2)>>2]+Z*+n[R+(P<<2)>>2]);$=da*(_*+n[S+(aa<<2)>>2]+fa*+n[S+(P<<2)>>2]+ca*+n[N+(aa<<2)>>2]+Z*+n[N+(P<<2)>>2]);Z=T+ea;ca=U+$;fa=W+ +L(+ea);ea=X+ +L(+$);O=O+1|0;if((O|0)>=(y|0)){ga=Z;ha=ea;ia=fa;ja=ca;break}else{X=ea;W=fa;U=ca;T=Z}}}if((D|0)<(x|0)){D=D+1|0;E=ga;F=ha;G=ia;H=ja}else break}v=v+1.0;H=v+-2.0;G=+V(+(-(w+H*H)/4.5));n[c+(z<<2)>>2]=ga*G;n[c+((z|1)<<2)>>2]=ja*G;n[c+((z|2)<<2)>>2]=ia*G;n[c+((z|3)<<2)>>2]=ha*G;A=A+G*((ha*ha+(ia*ia+(ja*ja+ga*ga)))*G);if((y|0)>=12)break;else z=z+4|0}o=o+5|0;if((o|0)>=12)break;else{i=i+16|0;s=A}}s=+M(+A);i=0;do{o=c+(i<<2)|0;n[o>>2]=+n[o>>2]/s;i=i+1|0}while((i|0)!=64);return}function YMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;d=VDc(436)|0;XIc(d|0,0,436)|0;e=VDc(436)|0;XIc(e|0,0,436)|0;g=VDc(436)|0;XIc(g|0,0,436)|0;h=+n[a>>2];i=+n[a+4>>2];j=f[a+24>>2]|0;k=mrc(+n[a+8>>2]*.5)|0;l=c+20|0;m=c+16|0;o=+(k|0)*2.5;p=o*(o*2.0);c=-6;q=0;while(1){r=Y(c,c)|0;o=h+ +(Y(c,k)|0);s=-6;t=q;while(1){if(((Y(s,s)|0)+r|0)>>>0<36){u=mrc(i+ +(Y(s,k)|0))|0;v=mrc(o)|0;if(((u|0)>-1?((v|0)>-1?(u|0)<(f[l>>2]|0):0):0)?(v|0)<(f[m>>2]|0):0){w=+(u|0)-i;x=+(v|0)-h;y=+V(+(-(w*w+x*x)/p));z=f[b>>2]|0;A=(f[z+(j*468|0)+16>>2]|0)+(Y(f[f[z+(j*468|0)+44>>2]>>2]|0,u)|0)+(v<<2)|0;x=y*+n[A>>2];n[d+(t<<2)>>2]=x;A=(f[z+(j*468|0)+72>>2]|0)+(Y(f[f[z+(j*468|0)+100>>2]>>2]|0,u)|0)+(v<<2)|0;B=y*+n[A>>2];C=x}else{n[d+(t<<2)>>2]=0.0;B=0.0;C=0.0}n[e+(t<<2)>>2]=B;x=+_6(B,C)*.01745329238474369;n[g+(t<<2)>>2]=x;D=t+1|0}else D=t;s=s+1|0;if((s|0)>=7)break;else t=D}c=c+1|0;if((c|0)>=7)break;else q=D}D=a+12|0;C=0.0;B=0.0;while(1){p=C+1.0471975803375244;h=p>6.2831854820251465?C+-5.235987663269043:p;a=h<C;if(!(C<h))if(a){p=0.0;i=0.0;q=0;while(1){o=+n[g+(q<<2)>>2];if(!(o>0.0&o<h)?!(o>C&o<6.2831854820251465):0){E=p;F=i}else{E=p+ +n[e+(q<<2)>>2];F=i+ +n[d+(q<<2)>>2]}q=q+1|0;if((q|0)==109){G=E;H=F;break}else{p=E;i=F}}}else{G=0.0;H=0.0}else{i=0.0;p=0.0;q=0;while(1){o=+n[g+(q<<2)>>2];c=C<o;j=o<h;if(!(c&j))if(a?o>0.0&j|c&o<6.2831854820251465:0){I=i+ +n[e+(q<<2)>>2];J=p+ +n[d+(q<<2)>>2]}else{I=i;J=p}else{I=i+ +n[e+(q<<2)>>2];J=p+ +n[d+(q<<2)>>2]}q=q+1|0;if((q|0)==109){G=I;H=J;break}else{i=I;p=J}}}p=H*H+G*G;if(p>B){i=+_6(G,H);n[D>>2]=i;K=p}else K=B;C=C+.15000000596046448;if(!(C<6.283185307179586))break;else B=K}YDc(g);YDc(e);YDc(d);return}function ZMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0,J=0,K=0.0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0;d=f[a+12>>2]|0;e=+n[b+4>>2];g=+n[b>>2];h=mrc(+n[b+8>>2]*.5)|0;i=+n[b+12>>2]*.01745329238474369;j=f[b+24>>2]|0;k=+O(+i);l=+P(+i);b=0-h|0;i=+(h|0)*2.5;m=i*(i*2.0);o=f[a+32>>2]|0;p=f[a+36>>2]|0;a=o+-1|0;q=p+-1|0;r=f[d>>2]|0;d=f[r+(j*468|0)+16>>2]|0;s=f[f[r+(j*468|0)+44>>2]>>2]|0;t=f[r+(j*468|0)+72>>2]|0;u=f[f[r+(j*468|0)+100>>2]>>2]|0;i=-.5;j=0;r=-8;v=0.0;while(1){w=r+-4|0;i=i+1.0;x=+(Y(r+1|0,h)|0);y=k*x;z=l*x;x=i+-2.0;A=x*x;B=r+4|0;x=-.5;C=-8;D=v;E=j;while(1){F=C+-4|0;G=g+(y+l*+(Y(h,~C)|0));H=e+(z+k*+(Y(C+1|0,h)|0));I=C+4|0;J=w;K=0.0;N=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;W=0.0;while(1){X=+(Y(J,h)|0);Z=l*X;_=k*X;$=F;X=K;aa=N;ba=Q;ca=R;da=S;ea=T;fa=U;ga=W;while(1){ha=e+(Z+k*+(Y($,h)|0));ia=g+(_+l*+(Y($,b)|0));ja=G-ia;ka=H-ha;la=+V(+(-(ja*ja+ka*ka)/m));ma=~~ha;na=ma-(+(ma|0)>ha&1)|0;ma=~~ia;oa=ma-(+(ma|0)>ia&1)|0;ma=(oa|0)>0?oa:0;oa=(na|0)>0?na:0;na=(ma|0)<(o|0)?ma:a;ma=(oa|0)<(p|0)?oa:q;oa=(na|0)<-1?0:na+1|0;pa=(ma|0)<-1?0:ma+1|0;qa=(oa|0)<(o|0)?oa:a;oa=(pa|0)<(p|0)?pa:q;ka=ia-+(na|0);ia=ha-+(ma|0);pa=d+(Y(s,ma)|0)|0;ra=d+(Y(s,oa)|0)|0;ha=1.0-ka;ja=1.0-ia;sa=ha*ja;ta=ka*ja;ja=ha*ia;ha=ka*ia;ia=sa*+n[pa+(na<<2)>>2]+ta*+n[pa+(qa<<2)>>2]+ja*+n[ra+(na<<2)>>2]+ha*+n[ra+(qa<<2)>>2];ra=t+(Y(u,ma)|0)|0;ma=t+(Y(u,oa)|0)|0;ka=sa*+n[ra+(na<<2)>>2]+ta*+n[ra+(qa<<2)>>2]+ja*+n[ma+(na<<2)>>2]+ha*+n[ma+(qa<<2)>>2];ha=la*(k*ia+l*ka);ja=la*(k*ka-l*ia);if(!(ha>=0.0)){ua=aa+ +L(+ja);va=ca+ja;wa=ea;xa=ga}else{ua=aa;va=ca;wa=ea+ +L(+ja);xa=ga+ja}if(!(ja>=0.0)){ya=X+ +L(+ha);za=ba+ha;Aa=da;Ba=fa}else{ya=X;za=ba;Aa=da+ +L(+ha);Ba=fa+ha}if(($|0)<(I|0)){$=$+1|0;X=ya;aa=ua;ba=za;ca=va;da=Aa;ea=wa;fa=Ba;ga=xa}else break}if((J|0)<(B|0)){J=J+1|0;K=ya;N=ua;Q=za;R=va;S=Aa;T=wa;U=Ba;W=xa}else break}x=x+1.0;W=x+-2.0;U=+V(+(-(A+W*W)/4.5));n[c+(E<<2)>>2]=xa*U;n[c+((E|1)<<2)>>2]=va*U;n[c+((E|2)<<2)>>2]=wa*U;n[c+((E|3)<<2)>>2]=ua*U;n[c+((E|4)<<2)>>2]=Ba*U;n[c+((E|5)<<2)>>2]=za*U;n[c+((E|6)<<2)>>2]=Aa*U;n[c+((E|7)<<2)>>2]=ya*U;D=D+U*((ya*ya+(Aa*Aa+(za*za+(Ba*Ba+(wa*wa+(xa*xa+va*va)+ua*ua)))))*U);C=C+5|0;if((C|0)>=12)break;else E=E+8|0}r=r+5|0;if((r|0)>=12)break;else{j=j+32|0;v=D}}v=+M(+D);j=0;do{r=c+(j<<2)|0;n[r>>2]=+n[r>>2]/v;j=j+1|0}while((j|0)!=128);return}function _Mb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0,J=0,K=0.0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0;d=f[a+12>>2]|0;e=+n[b+4>>2];g=+n[b>>2];h=mrc(+n[b+8>>2]*.5)|0;i=+n[b+12>>2]*.01745329238474369;j=f[b+24>>2]|0;k=+O(+i);l=+P(+i);b=0-h|0;i=+(h|0)*2.5;m=i*(i*2.0);o=f[a+32>>2]|0;p=f[a+36>>2]|0;a=o+-1|0;q=p+-1|0;r=f[d>>2]|0;d=f[r+(j*468|0)+16>>2]|0;s=f[f[r+(j*468|0)+44>>2]>>2]|0;t=f[r+(j*468|0)+72>>2]|0;u=f[f[r+(j*468|0)+100>>2]>>2]|0;i=-.5;j=0;r=-8;v=0.0;while(1){w=r+-4|0;i=i+1.0;x=+(Y(r+1|0,h)|0);y=k*x;z=l*x;x=i+-2.0;A=x*x;B=r+4|0;x=-.5;C=-8;D=j;E=v;while(1){F=C+-4|0;G=g+(y+l*+(Y(h,~C)|0));H=e+(z+k*+(Y(C+1|0,h)|0));I=C+4|0;J=w;K=0.0;N=0.0;Q=0.0;R=0.0;while(1){S=+(Y(J,h)|0);T=l*S;U=k*S;W=F;X=N;Z=Q;_=R;$=K;while(1){S=e+(T+k*+(Y(W,h)|0));aa=g+(U+l*+(Y(W,b)|0));ba=G-aa;ca=H-S;da=+V(+(-(ba*ba+ca*ca)/m));ea=~~S;fa=ea-(+(ea|0)>S&1)|0;ea=~~aa;ga=ea-(+(ea|0)>aa&1)|0;ea=(ga|0)>0?ga:0;ga=(fa|0)>0?fa:0;fa=(ea|0)<(o|0)?ea:a;ea=(ga|0)<(p|0)?ga:q;ga=(fa|0)<-1?0:fa+1|0;ha=(ea|0)<-1?0:ea+1|0;ia=(ga|0)<(o|0)?ga:a;ga=(ha|0)<(p|0)?ha:q;ca=aa-+(fa|0);aa=S-+(ea|0);ha=d+(Y(s,ea)|0)|0;ja=d+(Y(s,ga)|0)|0;S=1.0-ca;ba=1.0-aa;ka=S*ba;la=ca*ba;ba=S*aa;S=ca*aa;aa=ka*+n[ha+(fa<<2)>>2]+la*+n[ha+(ia<<2)>>2]+ba*+n[ja+(fa<<2)>>2]+S*+n[ja+(ia<<2)>>2];ja=t+(Y(u,ea)|0)|0;ea=t+(Y(u,ga)|0)|0;ca=ka*+n[ja+(fa<<2)>>2]+la*+n[ja+(ia<<2)>>2]+ba*+n[ea+(fa<<2)>>2]+S*+n[ea+(ia<<2)>>2];S=da*(k*aa+l*ca);ba=da*(k*ca-l*aa);$=$+ba;X=X+S;_=_+ +L(+ba);Z=Z+ +L(+S);if((W|0)>=(I|0))break;else W=W+1|0}if((J|0)<(B|0)){J=J+1|0;K=$;N=X;Q=Z;R=_}else break}x=x+1.0;R=x+-2.0;Q=+V(+(-(A+R*R)/4.5));n[c+(D<<2)>>2]=$*Q;n[c+((D|1)<<2)>>2]=X*Q;n[c+((D|2)<<2)>>2]=_*Q;n[c+((D|3)<<2)>>2]=Z*Q;E=E+Q*((Z*Z+(_*_+(X*X+$*$)))*Q);C=C+5|0;if((C|0)>=12)break;else D=D+4|0}r=r+5|0;if((r|0)>=12)break;else{j=j+16|0;v=E}}v=+M(+E);j=0;do{r=c+(j<<2)|0;n[r>>2]=+n[r>>2]/v;j=j+1|0}while((j|0)!=64);return}function $Mb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137160;b=a+348|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+352>>2]=0;GQ(a+300|0);GQ(a+252|0);GQ(a+204|0);GQ(a+156|0);b=a+100|0;c=a+136|0;e=f[c>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)_S(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))g0(b);b=a+44|0;e=a+80|0;c=f[e>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)_S(b);f[e>>2]=0;e=a+60|0;b=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[a+84>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0))return;g0(b);return}function aNb(a){a=a|0;$Mb(a);YDc(a);return}function bNb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;f[a+8>>2]=f[c>>2];f[a+12>>2]=f[c+4>>2];c=a+24|0;b=a+348|0;d=a+352|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;c=f[d>>2]|0;if(c|0){a=f[c>>2]|0;e=c+4|0;c=f[e>>2]|0;if((c|0)==(a|0))return 1;f[e>>2]=c+(~(((c+-20-a|0)>>>0)/20|0)*20|0);return 1}a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=VDc(16)|0;e=c+4|0;f[e>>2]=1;f[c>>2]=137220;f[c+8>>2]=a;f[e>>2]=(f[e>>2]|0)+1;g=f[b>>2]|0;f[b>>2]=c;f[d>>2]=a;if(g|0?(a=g+4|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)!=1)return 1;Yi[f[(f[c>>2]|0)+8>>2]&2047](c);return 1}function cNb(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;return}function dNb(a){a=a|0;return -1}function eNb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0;d=u;u=u+176|0;e=d+120|0;g=d+112|0;h=d+104|0;i=d+48|0;j=d+40|0;k=d+16|0;l=d;m=d+32|0;b$(g,b,-1);f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];g=nNb(a,h,c)|0;c=a+352|0;h=f[c>>2]|0;o=f[h>>2]|0;p=(f[h+4>>2]|0)-o|0;h=(p|0)/20|0;if(!p){q=0;u=d;return q|0}p=o;o=f[p+8>>2]|0;r=a+100|0;s=a+112|0;t=(f[p+4>>2]|0)+15&-16;p=f[s>>2]|0;v=(p|0)<(t|0)?t:p;p=a+108|0;t=f[p>>2]|0;w=(t|0)<(o|0)?o:t;if(g){Yi[f[(f[a>>2]|0)+48>>2]&2047](a);oNb(f[c>>2]|0,a+300|0)}if(((d$(b)|0)==655360?(f[a+24>>2]|0)>=1:0)?(f[a+28>>2]|0)>=1:0){g=a+204|0;t=Y(f[a+40>>2]|0,f[a+20>>2]|0)|0;o=f[a+16>>2]|0;if(!(((((f[a+208>>2]|0)<3?(f[a+212>>2]|0)==(t|0):0)?(f[a+216>>2]|0)==(o|0):0)?(f[g>>2]&4095|0)==4:0)?(f[a+228>>2]|0)!=0:0)){f[e>>2]=t;f[e+4>>2]=o;DQ(g,2,e,4,0)}g=a+156|0;if(!(((((f[a+160>>2]|0)<3?(f[a+164>>2]|0)==(w|0):0)?(f[a+168>>2]|0)==(v|0):0)?(f[g>>2]&4095|0)==0:0)?(f[a+180>>2]|0)!=0:0)){f[e>>2]=w;f[e+4>>2]=v;DQ(g,2,e,0,0)}o=i+4|0;t=i+8|0;x=i+12|0;y=i+8|0;z=i+4|0;A=e+32|0;B=j+4|0;C=i+8|0;D=i+12|0;E=i+4|0;F=0;do{G=f[c>>2]|0;H=f[G>>2]|0;if((((f[G+4>>2]|0)-H|0)/20|0)>>>0<=F>>>0){I=21;break}J=H;H=(f[J+(F*20|0)+4>>2]|0)+-1|0;K=(f[J+(F*20|0)+8>>2]|0)+-1|0;f[i>>2]=0;f[o>>2]=0;f[t>>2]=H;f[x>>2]=K;CQ(e,g,i);K=y;f[K>>2]=0;f[K+4>>2]=0;f[i>>2]=34209792;f[z>>2]=e;K=f[A>>2]|0;H=f[K>>2]|0;f[j>>2]=f[K+4>>2];f[B>>2]=H;L=1.0/+n[J+(F*20|0)>>2];nfa(b,i,j,L,L,5);J=f[(f[a>>2]|0)+44>>2]|0;f[C>>2]=0;f[D>>2]=0;f[i>>2]=17432576;f[E>>2]=e;Ti[J&511](a,F,i);GQ(e);F=F+1|0}while(F>>>0<h>>>0);if((I|0)==21)nCc(G);f[a+4>>2]=2;q=1;u=d;return q|0}do if((d$(b)|0)==65536){G=f[b+4>>2]|0;f[i>>2]=f[G>>2];F=i+4|0;E=G+4|0;f[F>>2]=f[E>>2];D=i+8|0;f[D>>2]=f[G+8>>2];f[i+12>>2]=f[G+12>>2];f[i+16>>2]=f[G+16>>2];f[i+20>>2]=f[G+20>>2];f[i+24>>2]=f[G+24>>2];f[i+28>>2]=f[G+28>>2];f[i+32>>2]=f[G+32>>2];C=f[G+36>>2]|0;f[i+36>>2]=C;f[i+40>>2]=D;D=i+48|0;j=i+44|0;f[j>>2]=D;f[D>>2]=0;f[i+52>>2]=0;if(C|0){D=C+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[E>>2]|0)<3){E=f[G+44>>2]|0;D=f[j>>2]|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2];break}else{f[F>>2]=0;ZS(i,G);break}}else a$(i,b,-1);while(0);b=a+44|0;G=Y(f[a+40>>2]|0,f[a+20>>2]|0)|0;F=f[a+16>>2]|0;if(!(((((f[a+48>>2]|0)<3?(f[a+52>>2]|0)==(G|0):0)?(f[a+56>>2]|0)==(F|0):0)?(f[b>>2]&4095|0)==4:0)?(f[a+60>>2]|0)!=0:0)){f[e>>2]=G;f[e+4>>2]=F;XS(b,2,e,4)}if(!(((((f[a+104>>2]|0)<3?(f[p>>2]|0)==(w|0):0)?(f[s>>2]|0)==(v|0):0)?(f[r>>2]&4095|0)==0:0)?(f[a+116>>2]|0)!=0:0)){f[e>>2]=w;f[e+4>>2]=v;XS(r,2,e,0)}r=a+116|0;v=k+8|0;w=k+12|0;s=k+4|0;p=l+8|0;b=l+4|0;F=e+40|0;G=m+4|0;E=k+8|0;D=k+12|0;j=k+4|0;C=e+36|0;B=e+16|0;A=e+4|0;z=e+44|0;y=e+48|0;g=0;do{M=f[c>>2]|0;x=f[M>>2]|0;if((((f[M+4>>2]|0)-x|0)/20|0)>>>0<=g>>>0){I=45;break}t=x;Vj(e,(f[t+(g*20|0)+8>>2]|0)+-1|0,(f[t+(g*20|0)+4>>2]|0)+-1|0,0,f[r>>2]|0,0);f[v>>2]=0;f[w>>2]=0;f[k>>2]=16842752;f[s>>2]=i;x=p;f[x>>2]=0;f[x+4>>2]=0;f[l>>2]=33619968;f[b>>2]=e;x=f[F>>2]|0;o=f[x>>2]|0;f[m>>2]=f[x+4>>2];f[G>>2]=o;L=1.0/+n[t+(g*20|0)>>2];nfa(k,l,m,L,L,5);t=f[(f[a>>2]|0)+44>>2]|0;f[E>>2]=0;f[D>>2]=0;f[k>>2]=16842752;f[j>>2]=e;Ti[t&511](a,g,k);t=f[C>>2]|0;if(t|0?(o=t+12|0,t=f[o>>2]|0,f[o>>2]=t+-1,(t|0)==1):0)_S(e);f[C>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[A>>2]|0)>0){t=f[F>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[A>>2]|0))}o=f[z>>2]|0;if((o|0)!=(y|0))g0(o);g=g+1|0}while(g>>>0<h>>>0);if((I|0)==45)nCc(M);f[a+4>>2]=1;a=i+36|0;M=f[a>>2]|0;if(M|0?(I=M+12|0,M=f[I>>2]|0,f[I>>2]=M+-1,(M|0)==1):0)_S(i);f[a>>2]=0;a=i+16|0;M=i+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[M>>2]|0)>0){a=f[i+40>>2]|0;I=0;do{f[a+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[M>>2]|0))}M=f[i+44>>2]|0;if((M|0)!=(i+48|0))g0(M);q=1;u=d;return q|0}function fNb(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function gNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+4|0;if(!(f[e>>2]&2)){g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=34209792;f[d+4>>2]=a+204;h_(a+44|0,d);f[e>>2]=f[e>>2]|2}e=f[b>>2]|0;d=b+4|0;while(1){g=f[d>>2]|0;if((g|0)==(e|0))break;h=g+-48|0;f[d>>2]=h;GQ(h)}h=a+300|0;g=b+8|0;if((e|0)==(f[g>>2]|0)){mNb(b,h);i=f[d>>2]|0}else{f[e>>2]=f[h>>2];j=e+4|0;k=a+304|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[a+308>>2];f[e+12>>2]=f[a+312>>2];f[e+16>>2]=f[a+316>>2];f[e+20>>2]=f[a+320>>2];m=f[a+324>>2]|0;f[e+24>>2]=m;f[e+28>>2]=f[a+328>>2];f[e+32>>2]=l;l=e+40|0;n=e+36|0;f[n>>2]=l;f[e+44>>2]=0;f[l>>2]=0;if(m|0){l=m+8|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+336>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;FQ(e,h)}h=(f[d>>2]|0)+48|0;f[d>>2]=h;i=h}h=a+204|0;if((i|0)==(f[g>>2]|0)){mNb(b,h);o=f[d>>2]|0}else{f[i>>2]=f[h>>2];e=i+4|0;j=a+208|0;f[e>>2]=f[j>>2];k=i+8|0;f[k>>2]=f[a+212>>2];f[i+12>>2]=f[a+216>>2];f[i+16>>2]=f[a+220>>2];f[i+20>>2]=f[a+224>>2];l=f[a+228>>2]|0;f[i+24>>2]=l;f[i+28>>2]=f[a+232>>2];f[i+32>>2]=k;k=i+40|0;n=i+36|0;f[n>>2]=k;f[i+44>>2]=0;f[k>>2]=0;if(l|0){k=l+8|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[a+240>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[e>>2]=0;FQ(i,h)}h=(f[d>>2]|0)+48|0;f[d>>2]=h;o=h}h=a+252|0;if((o|0)==(f[g>>2]|0)){mNb(b,h);u=c;return}f[o>>2]=f[h>>2];b=o+4|0;g=a+256|0;f[b>>2]=f[g>>2];i=o+8|0;f[i>>2]=f[a+260>>2];f[o+12>>2]=f[a+264>>2];f[o+16>>2]=f[a+268>>2];f[o+20>>2]=f[a+272>>2];e=f[a+276>>2]|0;f[o+24>>2]=e;f[o+28>>2]=f[a+280>>2];f[o+32>>2]=i;i=o+40|0;j=o+36|0;f[j>>2]=i;f[o+44>>2]=0;f[i>>2]=0;if(e|0){i=e+8|0;f[i>>2]=(f[i>>2]|0)+1}if((f[g>>2]|0)<3){g=f[a+288>>2]|0;a=f[j>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2]}else{f[b>>2]=0;FQ(o,h)}f[d>>2]=(f[d>>2]|0)+48;u=c;return}function hNb(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;d=a+4|0;if(f[d>>2]&1|0){u=b;return}e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=33619968;f[c+4>>2]=a+44;NQ(a+204|0,c);f[d>>2]=f[d>>2]|1;u=b;return}function iNb(a,b){a=a|0;b=b|0;return 0.0}function jNb(a,b){a=a|0;b=b|0;return 0}function kNb(a,b,c){a=a|0;b=b|0;c=c|0;return}function lNb(a){a=a|0;return}function mNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/48|0;g=e+1|0;if(g>>>0>89478485)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/48|0;d=i<<1;j=i>>>0<44739242?(d>>>0<g>>>0?g:d):89478485;do if(j)if(j>>>0>89478485){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*48|0)|0;break}else k=0;while(0);d=k+(e*48|0)|0;g=d;i=k+(j*48|0)|0;f[d>>2]=f[b>>2];j=k+(e*48|0)+4|0;l=b+4|0;m=f[l>>2]|0;f[j>>2]=m;n=k+(e*48|0)+8|0;f[n>>2]=f[b+8>>2];f[k+(e*48|0)+12>>2]=f[b+12>>2];f[k+(e*48|0)+16>>2]=f[b+16>>2];f[k+(e*48|0)+20>>2]=f[b+20>>2];o=f[b+24>>2]|0;f[k+(e*48|0)+24>>2]=o;f[k+(e*48|0)+28>>2]=f[b+28>>2];f[k+(e*48|0)+32>>2]=n;n=k+(e*48|0)+40|0;p=k+(e*48|0)+36|0;f[p>>2]=n;f[k+(e*48|0)+44>>2]=0;f[n>>2]=0;if(!o)q=m;else{m=o+8|0;f[m>>2]=(f[m>>2]|0)+1;q=f[l>>2]|0}if((q|0)<3){q=f[b+36>>2]|0;l=f[p>>2]|0;f[l>>2]=f[q>>2];f[l+4>>2]=f[q+4>>2]}else{f[j>>2]=0;FQ(d,b)}b=d+48|0;j=f[a>>2]|0;q=f[c>>2]|0;if((q|0)==(j|0)){r=g;s=j;t=q}else{l=q;q=g;g=d;do{d=g+-48|0;p=l;l=l+-48|0;f[d>>2]=f[l>>2];m=g+-44|0;o=p+-44|0;f[m>>2]=f[o>>2];n=g+-40|0;f[n>>2]=f[p+-40>>2];f[g+-36>>2]=f[p+-36>>2];f[g+-32>>2]=f[p+-32>>2];f[g+-28>>2]=f[p+-28>>2];e=f[p+-24>>2]|0;f[g+-24>>2]=e;f[g+-20>>2]=f[p+-20>>2];f[g+-16>>2]=n;n=g+-8|0;k=g+-12|0;f[k>>2]=n;f[g+-4>>2]=0;f[n>>2]=0;if(e|0){n=e+8|0;f[n>>2]=(f[n>>2]|0)+1}if((f[o>>2]|0)<3){o=f[p+-12>>2]|0;p=f[k>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2]}else{f[m>>2]=0;FQ(d,l)}g=q+-48|0;q=g}while((l|0)!=(j|0));r=q;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=b;f[h>>2]=i;i=s;h=t;while(1){t=h;if((t|0)==(i|0))break;b=t+-48|0;GQ(b);h=b}if(!s)return;YDc(s);return}function nNb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;d=a+348|0;e=a+352|0;if(!(f[e>>2]|0)){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=VDc(16)|0;i=h+4|0;f[i>>2]=1;f[h>>2]=137220;f[h+8>>2]=g;f[i>>2]=(f[i>>2]|0)+1;j=f[d>>2]|0;f[d>>2]=h;f[e>>2]=g;if(j|0?(g=j+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)Yi[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[i>>2]|0;f[i>>2]=j+-1;if((j|0)==1)Yi[f[(f[h>>2]|0)+8>>2]&2047](h)}h=f[c>>2]|0;j=(f[c+4>>2]|0)-h>>2;i=f[e>>2]|0;d=i+4|0;g=f[d>>2]|0;k=f[i>>2]|0;l=(g-k|0)/20|0;m=k;k=g;g=h;if(j>>>0<=l>>>0)if(j>>>0<l>>>0?(h=m+(j*20|0)|0,(k|0)!=(h|0)):0){f[d>>2]=k+(~(((k+-20-h|0)>>>0)/20|0)*20|0);o=g}else o=g;else{pNb(i,j-l|0);o=f[c>>2]|0}i=a+16|0;g=f[i>>2]|0;h=a+20|0;a=f[h>>2]|0;k=(mrc(+(f[b>>2]|0)/+n[o>>2])|0)+62&-32;o=(g|0)<(k|0);f[i>>2]=o?k:g;g=(j|0)!=(l|0)|o;if(!j){p=g;q=0;r=0;s=a;t=q+r|0;u=(s|0)<(t|0);v=u?t:s;f[h>>2]=v;w=(v|0)!=(a|0);x=p|w;return x|0}o=f[e>>2]|0;e=f[o>>2]|0;l=((f[o+4>>2]|0)-e|0)/20|0;k=e;e=f[c>>2]|0;c=b+4|0;d=0;m=g;g=0;y=0;z=0;while(1){if(l>>>0<=d>>>0){A=15;break}B=k+(d*20|0)|0;if(!m){C=+n[e+(d<<2)>>2];if(+L(+(+n[B>>2]-C))>C*1.1920928955078125e-05){D=1;E=B;F=C}else{D=0;E=B;F=C}}else{D=1;E=B;F=+n[e+(d<<2)>>2]}B=mrc(+(f[b>>2]|0)/F)|0;G=mrc(+(f[c>>2]|0)/F)|0;f[k+(d*20|0)+16>>2]=F>=2.0?1:2;n[E>>2]=F;H=B+1|0;B=G+1|0;f[k+(d*20|0)+4>>2]=H;f[k+(d*20|0)+8>>2]=B;G=(d|0)==0?B:g;I=f[i>>2]|0;J=(H+y|0)>(I|0);K=J?0:y;z=(J?G:0)+z|0;g=J?B:G;G=(Y(z,I)|0)+K|0;f[k+(d*20|0)+12>>2]=G;d=d+1|0;if(d>>>0>=j>>>0)break;else{m=D;y=K+H|0}}if((A|0)==15)nCc(o);p=D;q=g;r=z;s=f[h>>2]|0;t=q+r|0;u=(s|0)<(t|0);v=u?t:s;f[h>>2]=v;w=(v|0)!=(a|0);x=p|w;return x|0}function oNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+80|0;d=c;e=c+56|0;g=f[a>>2]|0;h=a+4|0;i=f[h>>2]|0;if((g|0)==(i|0)){j=b+24|0;k=f[j>>2]|0;if(k|0?(l=k+8|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)HQ(b);k=b+4|0;if((f[k>>2]|0)>0){l=f[b+32>>2]|0;m=0;do{f[l+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}f[j>>2]=0;n=f[a>>2]|0;o=f[h>>2]|0}else{n=g;o=i}Vj(d,1,o-n|0,0,n,0);n=e+8|0;f[n>>2]=0;f[n+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=b;h_(d,e);e=d+36|0;b=f[e>>2]|0;if(b|0?(n=b+12|0,b=f[n>>2]|0,f[n>>2]=b+-1,(b|0)==1):0)_S(d);f[e>>2]=0;e=d+16|0;b=d+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[d+40>>2]|0;n=0;do{f[e+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[b>>2]|0))}b=f[d+44>>2]|0;if((b|0)==(d+48|0)){u=c;return}g0(b);u=c;return}function pNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)mCc(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=h;g=k+(d*20|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{j=b;b=i;i=h;do{h=j;j=j+-20|0;f[i+-20>>2]=f[j>>2];f[i+-16>>2]=f[h+-16>>2];f[i+-12>>2]=f[h+-12>>2];n=h+-8|0;h=f[n+4>>2]|0;o=i+-8|0;f[o>>2]=f[n>>2];f[o+4>>2]=h;i=b+-20|0;b=i}while((j|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function qNb(a){a=a|0;YDc(a);return}function rNb(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~(((e+-20-c|0)>>>0)/20|0)*20|0);YDc(c)}YDc(b)}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function sNb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=137240;b=a+372|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+376>>2]=0;b=a+364|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+368>>2]=0;b=a+356|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;g=a+360|0;f[g>>2]=0;$Mb(a);return}d=c+4|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1){f[b>>2]=0;g=a+360|0;f[g>>2]=0;$Mb(a);return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;g=a+360|0;f[g>>2]=0;$Mb(a);return}function tNb(a){a=a|0;sNb(a);YDc(a);return}function uNb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e+8|0;h=e+16|0;i=e;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];bNb(a,0,g)|0;g=M_(c)|0;if(!g){f[h>>2]=0;f[h+4>>2]=0;d=tT(h,5)|0;b[d>>0]=b[466053]|0;b[d+1>>0]=b[466054]|0;b[d+2>>0]=b[466055]|0;b[d+3>>0]=b[466056]|0;b[d+4>>0]=b[466057]|0;z5(-215,h,471667,465762,585)}d=a+356|0;j=a+360|0;if(!(f[j>>2]|0)){k=VDc(12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;l=VDc(16)|0;m=l+4|0;f[m>>2]=1;f[l>>2]=137320;f[l+8>>2]=k;f[m>>2]=(f[m>>2]|0)+1;n=f[d>>2]|0;f[d>>2]=l;f[j>>2]=k;if(n|0?(k=n+4|0,d=f[k>>2]|0,f[k>>2]=d+-1,(d|0)==1):0)Yi[f[(f[n>>2]|0)+8>>2]&2047](n);n=f[m>>2]|0;f[m>>2]=n+-1;if((n|0)==1)Yi[f[(f[l>>2]|0)+8>>2]&2047](l)}l=a+364|0;n=a+368|0;if(!(f[n>>2]|0)){m=VDc(12)|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;d=VDc(16)|0;k=d+4|0;f[k>>2]=1;f[d>>2]=137340;f[d+8>>2]=m;f[k>>2]=(f[k>>2]|0)+1;o=f[l>>2]|0;f[l>>2]=d;f[n>>2]=m;if(o|0?(m=o+4|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)Yi[f[(f[o>>2]|0)+8>>2]&2047](o);o=f[k>>2]|0;f[k>>2]=o+-1;if((o|0)==1)Yi[f[(f[d>>2]|0)+8>>2]&2047](d)}d=a+372|0;o=a+376|0;if(!(f[o>>2]|0)){k=VDc(12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;n=VDc(16)|0;m=n+4|0;f[m>>2]=1;f[n>>2]=137340;f[n+8>>2]=k;f[m>>2]=(f[m>>2]|0)+1;l=f[d>>2]|0;f[d>>2]=n;f[o>>2]=k;if(l|0?(k=l+4|0,o=f[k>>2]|0,f[k>>2]=o+-1,(o|0)==1):0)Yi[f[(f[l>>2]|0)+8>>2]&2047](l);l=f[m>>2]|0;f[m>>2]=l+-1;if((l|0)==1)Yi[f[(f[n>>2]|0)+8>>2]&2047](n)}n=f[j>>2]|0;l=n+4|0;m=f[l>>2]|0;o=f[n>>2]|0;k=m-o>>6;d=o;o=m;if(g>>>0<=k>>>0){if(g>>>0<k>>>0?(m=d+(g<<6)|0,(o|0)!=(m|0)):0)f[l>>2]=o+(~((o+-64-m|0)>>>6)<<6)}else JNb(n,g-k|0);K_(h,f[c>>2]|0,f[c+4>>2]|0,0);c=a+380|0;b[c>>0]=0;k=f[j>>2]|0;f[a+16>>2]=0;f[a+20>>2]=0;j=a+252|0;n=a+276|0;m=f[n>>2]|0;if(m|0?(o=m+8|0,m=f[o>>2]|0,f[o>>2]=m+-1,(m|0)==1):0)HQ(j);j=a+256|0;if((f[j>>2]|0)>0){m=f[a+284>>2]|0;o=0;do{f[m+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[j>>2]|0))}f[n>>2]=0;n=h+20|0;j=i+4|0;o=0;do{m=(f[k>>2]|0)+(o<<6)|0;l=f[n>>2]|0;f[i>>2]=f[h>>2];f[j>>2]=l;KNb(m,i)|0;if(b[(f[k>>2]|0)+(o<<6)>>0]|0)b[c>>0]=1;o=o+1|0;N_(h)|0}while((o|0)!=(g|0));f[a+40>>2]=b[c>>0]|0?3:2;c=(f[a+8>>2]|0)+-2|0;g=(f[a+12>>2]|0)+-2|0;f[a+408>>2]=1;f[a+412>>2]=1;f[a+416>>2]=c;f[a+420>>2]=g;g=a+24|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;u=e;return 1}function vNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;d=VDc(436)|0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d+44>>2]=1124007936;e=d+52|0;g=d+84|0;h=d+48|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=d+92|0;f[d+88>>2]=e;f[e>>2]=0;f[d+96>>2]=0;f[d+100>>2]=1124007936;e=d+108|0;g=d+140|0;h=d+104|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=d+148|0;f[d+144>>2]=e;f[e>>2]=0;f[d+152>>2]=0;f[d+156>>2]=1124007936;e=d+160|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+188>>2]=d+164;e=d+196|0;f[d+192>>2]=e;f[d+200>>2]=0;f[e>>2]=0;f[d+204>>2]=1124007936;e=d+208|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+236>>2]=d+212;e=d+244|0;f[d+240>>2]=e;f[d+248>>2]=0;f[e>>2]=0;f[d+252>>2]=1124007936;e=d+256|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+284>>2]=d+260;e=d+292|0;f[d+288>>2]=e;f[d+296>>2]=0;f[e>>2]=0;f[d+300>>2]=1124007936;e=d+304|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+332>>2]=d+308;e=d+340|0;f[d+336>>2]=e;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d>>2]=137240;e=d+356|0;g=d+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;h=d+392|0;i=h+40|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=4;f[d+28>>2]=2;f[d+32>>2]=0;f[d+36>>2]=0;f[d+40>>2]=0;f[d+384>>2]=0;f[d+388>>2]=0;n[d+432>>2]=0.0;g=d+380|0;b[g>>0]=0;h=VDc(16)|0;i=h+4|0;f[i>>2]=1;f[h>>2]=137300;f[h+8>>2]=d;j=h;k=d;GNb(d,c)|0;l=f[c+356>>2]|0;m=f[c+360>>2]|0;if(l|0){o=l+4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[e>>2]|0;f[e>>2]=l;f[d+360>>2]=m;if(o|0?(m=o+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)Yi[f[(f[o>>2]|0)+8>>2]&2047](o);o=d+364|0;l=f[c+364>>2]|0;m=f[c+368>>2]|0;if(l|0){e=l+4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[o>>2]|0;f[o>>2]=l;f[d+368>>2]=m;if(e|0?(m=e+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)Yi[f[(f[e>>2]|0)+8>>2]&2047](e);e=d+372|0;l=f[c+372>>2]|0;m=f[c+376>>2]|0;if(l|0){o=l+4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[e>>2]|0;f[e>>2]=l;f[d+376>>2]=m;if(o|0?(m=o+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)Yi[f[(f[o>>2]|0)+8>>2]&2047](o);o=c+380|0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];f[g+8>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[d+408>>2]=f[c+408>>2];f[d+412>>2]=f[c+412>>2];f[d+416>>2]=f[c+416>>2];f[d+420>>2]=f[c+420>>2];o=d+424|0;d=c+424|0;f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];f[o+8>>2]=f[d+8>>2];f[a>>2]=j;f[a+4>>2]=k;f[i>>2]=(f[i>>2]|0)+1;k=f[i>>2]|0;f[i>>2]=k+-1;if((k|0)!=1)return;Yi[f[(f[h>>2]|0)+8>>2]&2047](h);return}function wNb(a){a=a|0;return 0}function xNb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0;d=FNb(a,c)|0;c=f[b>>2]|0;if((c|0)<0){e=0;return e|0}g=f[b+4>>2]|0;if((g|0)<0){e=0;return e|0}if(((f[a+8>>2]|0)+c|0)>=(f[d+4>>2]|0)){e=0;return e|0}if(((f[a+12>>2]|0)+g|0)>=(f[d+8>>2]|0)){e=0;return e|0}b=(f[a+60>>2]|0)+(Y(f[f[a+88>>2]>>2]|0,g)|0)+(c<<2)|0;c=b+(f[d+12>>2]<<2)|0;f[a+424>>2]=c;d=c+(f[a+388>>2]<<2)|0;b=f[a+392>>2]|0;g=f[a+396>>2]|0;h=f[a+400>>2]|0;i=f[a+404>>2]|0;j=+(Y(f[a+420>>2]|0,f[a+416>>2]|0)|0);k=+((f[c+(b<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)+(f[c+(i<<2)>>2]|0)|0);l=+(((f[d+(b<<2)>>2]|0)-(f[d+(g<<2)>>2]|0)-(f[d+(h<<2)>>2]|0)+(f[d+(i<<2)>>2]|0)|0)>>>0)*j-k*k;if(l>0.0){k=1.0/+M(+l);n[a+432>>2]=k;e=j*k<.1;return e|0}else{n[a+432>>2]=1.0;e=0;return e|0}return 0}function yNb(a,b){a=a|0;b=b|0;return +(+ENb(a,b))}function zNb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+240|0;g=e+184|0;i=e+128|0;j=e+72|0;k=e+56|0;l=e+24|0;m=e;n=e+48|0;o=e+40|0;p=e+16|0;q=f[a+352>>2]|0;r=f[q>>2]|0;if((((f[q+4>>2]|0)-r|0)/20|0)>>>0<=c>>>0)nCc(q);q=r;r=a+380|0;s=a+16|0;t=(Y(f[a+20>>2]|0,f[s>>2]|0)|0)<<h[r>>0];v=a+388|0;f[v>>2]=t;if((d$(d)|0)==655360){t=f[q+(c*20|0)+12>>2]|0;w=f[s>>2]|0;x=(t|0)%(w|0)|0;y=(t|0)/(w|0)|0;t=((f[v>>2]|0)/(w|0)|0)+y|0;w=a+204|0;z=q+(c*20|0)+4|0;A=f[z>>2]|0;B=q+(c*20|0)+8|0;C=f[B>>2]|0;f[i>>2]=x;f[i+4>>2]=y;f[i+8>>2]=A;f[i+12>>2]=C;CQ(g,w,i);C=f[z>>2]|0;A=f[B>>2]|0;f[j>>2]=x;f[j+4>>2]=t;f[j+8>>2]=C;f[j+12>>2]=A;CQ(i,w,j);f[i>>2]=f[i>>2]&-8|4;if(!(b[r>>0]|0)){A=i+24|0;C=f[A>>2]|0;t=j+8|0;f[t>>2]=0;f[t+4>>2]=0;f[j>>2]=34209792;f[j+4>>2]=g;t=k+8|0;f[t>>2]=0;f[t+4>>2]=0;f[k>>2]=34209792;f[k+4>>2]=i;iqa(d,j,k,e0()|0,4,4);if((f[A>>2]|0)!=(C|0)){f[j>>2]=0;D=j+4|0;f[D>>2]=0;E=tT(j,61)|0;F=E;G=465684;H=F+61|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,j,465746,465762,659)}C=f[i+32>>2]|0;if(!((f[C>>2]|0)==(f[B>>2]|0)?(f[C+4>>2]|0)==(f[z>>2]|0):0)){f[j>>2]=0;D=j+4|0;f[D>>2]=0;E=tT(j,61)|0;F=E;G=465684;H=F+61|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,j,465746,465762,659)}if((f[i>>2]&4095|0)!=4){f[j>>2]=0;D=j+4|0;f[D>>2]=0;E=tT(j,61)|0;F=E;G=465684;H=F+61|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,j,465746,465762,659)}}else{G=((f[a+384>>2]|0)/(f[s>>2]|0)|0)+y|0;y=f[z>>2]|0;z=f[B>>2]|0;f[k>>2]=x;f[k+4>>2]=G;f[k+8>>2]=y;f[k+12>>2]=z;CQ(j,w,k);w=k+8|0;f[w>>2]=0;f[w+4>>2]=0;f[k>>2]=34209792;f[k+4>>2]=g;w=l+8|0;f[w>>2]=0;f[w+4>>2]=0;f[l>>2]=34209792;f[l+4>>2]=i;w=m+8|0;f[w>>2]=0;f[w+4>>2]=0;f[m>>2]=34209792;f[m+4>>2]=j;iqa(d,k,l,m,4,4);GQ(j)}GQ(i);GQ(g);u=e;return}w=q+(c*20|0)+4|0;f[n>>2]=f[w>>2];z=q+(c*20|0)+8|0;f[n+4>>2]=f[z>>2];y=a+92|0;CY(g,n,4,(f[a+60>>2]|0)+(f[q+(c*20|0)+12>>2]<<2)|0,f[y>>2]|0);f[o>>2]=f[w>>2];f[o+4>>2]=f[z>>2];c=g+16|0;q=g+44|0;CY(i,o,4,(f[c>>2]|0)+(f[v>>2]<<2)|0,f[y>>2]|0);if(b[r>>0]|0){f[p>>2]=f[w>>2];f[p+4>>2]=f[z>>2];CY(j,p,4,(f[c>>2]|0)+(f[a+384>>2]<<2)|0,f[y>>2]|0);y=k+8|0;f[y>>2]=0;f[y+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=g;y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=i;y=m+8|0;f[y>>2]=0;f[y+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;iqa(d,k,l,m,4,4);m=j+36|0;l=f[m>>2]|0;if(l|0?(y=l+12|0,l=f[y>>2]|0,f[y>>2]=l+-1,(l|0)==1):0)_S(j);f[m>>2]=0;m=j+16|0;l=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[j+40>>2]|0;y=0;do{f[m+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))g0(l)}else{l=j+8|0;f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=g;l=k+8|0;f[l>>2]=0;f[l+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;iqa(d,j,k,e0()|0,4,4)}k=i+36|0;j=f[k>>2]|0;if(j|0?(d=j+12|0,j=f[d>>2]|0,f[d>>2]=j+-1,(j|0)==1):0)_S(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;d=0;do{f[k+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))g0(j);j=g+36|0;i=f[j>>2]|0;if(i|0?(d=i+12|0,i=f[d>>2]|0,f[d>>2]=i+-1,(i|0)==1):0)_S(g);f[j>>2]=0;j=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[j>>2]|0)>0){c=f[g+40>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(g+48|0))g0(j);u=e;return}function ANb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+16>>2]|0;if(b[a+380>>0]|0){d=Y(f[a+20>>2]|0,c)|0;f[a+384>>2]=d}d=f[a+408>>2]|0;e=f[a+412>>2]|0;g=Y(e,c)|0;f[a+392>>2]=g+d;h=(f[a+416>>2]|0)+d|0;f[a+396>>2]=h+g;g=Y((f[a+420>>2]|0)+e|0,c)|0;f[a+400>>2]=g+d;f[a+404>>2]=h+g;g=f[a+360>>2]|0;h=(f[g+4>>2]|0)-(f[g>>2]|0)>>6;d=a+368|0;e=f[d>>2]|0;i=e+4|0;j=f[i>>2]|0;k=f[e>>2]|0;l=j-k>>6;m=k;k=j;if(h>>>0<=l>>>0){if(h>>>0<l>>>0?(j=m+(h<<6)|0,(k|0)!=(j|0)):0)f[i>>2]=k+(~((k+-64-j|0)>>>6)<<6);j=f[e>>2]|0;k=a+428|0;f[k>>2]=j;if(!h)n=1;else{o=j;p=k;q=9}}else{BNb(e,h-l|0);l=f[f[d>>2]>>2]|0;d=a+428|0;f[d>>2]=l;o=l;p=d;q=9}if((q|0)==9){d=a+384|0;CNb(o,f[g>>2]|0,c,f[d>>2]|0);if((h|0)==1)n=0;else{o=1;do{CNb((f[p>>2]|0)+(o<<6)|0,(f[g>>2]|0)+(o<<6)|0,c,f[d>>2]|0);o=o+1|0}while((o|0)!=(h|0));n=0}}o=a+376|0;d=f[o>>2]|0;p=d+4|0;l=f[p>>2]|0;e=f[d>>2]|0;k=l-e>>6;j=e;e=l;if(h>>>0<=k>>>0)if(h>>>0<k>>>0?(l=j+(h<<6)|0,(e|0)!=(l|0)):0){f[p>>2]=e+(~((e+-64-l|0)>>>6)<<6);r=d}else r=d;else{BNb(d,h-k|0);r=f[o>>2]|0}if(n){s=r;t=a+252|0;DNb(s,t);return}n=a+32|0;k=a+384|0;d=0;l=r;while(1){r=f[l>>2]|0;if((f[l+4>>2]|0)-r>>6>>>0<=d>>>0){q=19;break}e=f[n>>2]|0;CNb(r+(d<<6)|0,(f[g>>2]|0)+(d<<6)|0,(e|0)>0?e:c,f[k>>2]|0);d=d+1|0;e=f[o>>2]|0;if(d>>>0>=h>>>0){s=e;q=21;break}else l=e}if((q|0)==19)nCc(l);else if((q|0)==21){t=a+252|0;DNb(s,t);return}}function BNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)mCc(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=m+(d<<6)|0;d=b;b=h;m=h;do{j=b;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(0-(b>>6)<<6)|0;if((b|0)>0)dJc(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;YDc(d);return}function CNb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f[a+48>>2]=f[c+20>>2];g=c+24|0;f[a+52>>2]=f[c+40>>2];h=c+44|0;f[a+56>>2]=f[c+60>>2];i=c+4|0;j=f[i>>2]|0;if(!(b[c>>0]|0)){k=c+8|0;l=(Y(f[k>>2]|0,d)|0)+j|0;f[a>>2]=l;l=c+12|0;m=(f[l>>2]|0)+(f[i>>2]|0)+(Y(f[k>>2]|0,d)|0)|0;f[a+4>>2]=m;m=c+16|0;n=(Y((f[m>>2]|0)+(f[k>>2]|0)|0,d)|0)+(f[i>>2]|0)|0;f[a+8>>2]=n;n=(f[l>>2]|0)+(f[i>>2]|0)+(Y((f[m>>2]|0)+(f[k>>2]|0)|0,d)|0)|0;f[a+12>>2]=n;n=c+28|0;k=(Y(f[n>>2]|0,d)|0)+(f[g>>2]|0)|0;f[a+16>>2]=k;k=c+32|0;m=(f[k>>2]|0)+(f[g>>2]|0)+(Y(f[n>>2]|0,d)|0)|0;f[a+20>>2]=m;m=c+36|0;l=(Y((f[m>>2]|0)+(f[n>>2]|0)|0,d)|0)+(f[g>>2]|0)|0;f[a+24>>2]=l;l=(f[k>>2]|0)+(f[g>>2]|0)+(Y((f[m>>2]|0)+(f[n>>2]|0)|0,d)|0)|0;f[a+28>>2]=l;l=c+48|0;n=(Y(f[l>>2]|0,d)|0)+(f[h>>2]|0)|0;f[a+32>>2]=n;n=c+52|0;m=(f[n>>2]|0)+(f[h>>2]|0)+(Y(f[l>>2]|0,d)|0)|0;f[a+36>>2]=m;m=c+56|0;k=(Y((f[m>>2]|0)+(f[l>>2]|0)|0,d)|0)+(f[h>>2]|0)|0;f[a+40>>2]=k;o=(f[n>>2]|0)+(f[h>>2]|0)|0;p=f[l>>2]|0;q=f[m>>2]|0;r=q+p|0;s=Y(r,d)|0;t=s+o|0;u=a+44|0;f[u>>2]=t;return}else{m=c+8|0;l=j+e+(Y(f[m>>2]|0,d)|0)|0;f[a>>2]=l;l=c+16|0;j=f[l>>2]|0;n=(f[i>>2]|0)+e-j+(Y((f[m>>2]|0)+j|0,d)|0)|0;f[a+4>>2]=n;n=c+12|0;j=f[n>>2]|0;k=(f[i>>2]|0)+e+j+(Y((f[m>>2]|0)+j|0,d)|0)|0;f[a+8>>2]=k;k=f[n>>2]|0;n=f[l>>2]|0;l=(f[i>>2]|0)+e+k-n+(Y(n+k+(f[m>>2]|0)|0,d)|0)|0;f[a+12>>2]=l;l=c+28|0;m=(f[g>>2]|0)+e+(Y(f[l>>2]|0,d)|0)|0;f[a+16>>2]=m;m=c+36|0;k=f[m>>2]|0;n=(f[g>>2]|0)+e-k+(Y((f[l>>2]|0)+k|0,d)|0)|0;f[a+20>>2]=n;n=c+32|0;k=f[n>>2]|0;i=(f[g>>2]|0)+e+k+(Y((f[l>>2]|0)+k|0,d)|0)|0;f[a+24>>2]=i;i=f[n>>2]|0;n=f[m>>2]|0;m=(f[g>>2]|0)+e+i-n+(Y(n+i+(f[l>>2]|0)|0,d)|0)|0;f[a+28>>2]=m;m=c+48|0;l=(f[h>>2]|0)+e+(Y(f[m>>2]|0,d)|0)|0;f[a+32>>2]=l;l=c+56|0;i=f[l>>2]|0;n=(f[h>>2]|0)+e-i+(Y((f[m>>2]|0)+i|0,d)|0)|0;f[a+36>>2]=n;n=c+52|0;c=f[n>>2]|0;i=(f[h>>2]|0)+e+c+(Y((f[m>>2]|0)+c|0,d)|0)|0;f[a+40>>2]=i;i=f[n>>2]|0;n=f[l>>2]|0;o=(f[h>>2]|0)+e+i-n|0;p=(f[m>>2]|0)+i|0;q=n;r=q+p|0;s=Y(r,d)|0;t=s+o|0;u=a+44|0;f[u>>2]=t;return}}function DNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+80|0;d=c;e=c+56|0;g=f[a>>2]|0;h=a+4|0;i=f[h>>2]|0;if((g|0)==(i|0)){j=b+24|0;k=f[j>>2]|0;if(k|0?(l=k+8|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)HQ(b);k=b+4|0;if((f[k>>2]|0)>0){l=f[b+32>>2]|0;m=0;do{f[l+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}f[j>>2]=0;n=f[a>>2]|0;o=f[h>>2]|0}else{n=g;o=i}Vj(d,1,o-n|0,0,n,0);n=e+8|0;f[n>>2]=0;f[n+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=b;h_(d,e);e=d+36|0;b=f[e>>2]|0;if(b|0?(n=b+12|0,b=f[n>>2]|0,f[n>>2]=b+-1,(b|0)==1):0)_S(d);f[e>>2]=0;e=d+16|0;b=d+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[d+40>>2]|0;n=0;do{f[e+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[b>>2]|0))}b=f[d+44>>2]|0;if((b|0)==(d+48|0)){u=c;return}g0(b);u=c;return}function ENb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,g=0.0,h=0.0,i=0,j=0.0,k=0.0;c=f[a+428>>2]|0;d=f[a+424>>2]|0;e=+n[c+(b<<6)+48>>2]*+((f[d+(f[c+(b<<6)>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+4>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+8>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+12>>2]<<2)>>2]|0)|0)+ +n[c+(b<<6)+52>>2]*+((f[d+(f[c+(b<<6)+16>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+20>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+24>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+28>>2]<<2)>>2]|0)|0);g=+n[c+(b<<6)+56>>2];if(!(g!=0.0)){h=e;i=a+432|0;j=+n[i>>2];k=h*j;return +k}h=e+g*+((f[d+(f[c+(b<<6)+32>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+36>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+40>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+44>>2]<<2)>>2]|0)|0);i=a+432|0;j=+n[i>>2];k=h*j;return +k}function FNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;if((c|0)>-1?(g=f[a+352>>2]|0,a=f[g>>2]|0,h=((f[g+4>>2]|0)-a|0)/20|0,(h|0)>(c|0)):0)if(h>>>0>c>>>0){u=d;return a+(c*20|0)|0}else nCc(g);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,50)|0;c=465839;a=g+50|0;do{b[g>>0]=b[c>>0]|0;g=g+1|0;c=c+1|0}while((g|0)<(a|0));z5(-215,e,465890,465903,46);return 0}function GNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];f[a+40>>2]=f[b+40>>2];c=a+44|0;d=b+44|0;e=(a|0)==(b|0);do if(!e){g=b+80|0;h=f[g>>2]|0;if(h|0){i=h+12|0;f[i>>2]=(f[i>>2]|0)+1}i=a+80|0;h=f[i>>2]|0;if(h|0?(j=h+12|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)_S(c);f[i>>2]=0;h=a+60|0;j=a+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){k=f[a+84>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;m=f[j>>2]|0}while((l|0)<(m|0));f[c>>2]=f[d>>2];if((m|0)<3)n=12;else n=14}else{f[c>>2]=f[d>>2];n=12}if((n|0)==12){l=f[b+48>>2]|0;if((l|0)<3){f[j>>2]=l;f[a+52>>2]=f[b+52>>2];f[a+56>>2]=f[b+56>>2];l=f[b+88>>2]|0;k=f[a+88>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2]}else n=14}if((n|0)==14)ZS(c,d);f[h>>2]=f[b+60>>2];f[a+64>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[i>>2]=f[g>>2];l=a+100|0;k=b+100|0;if(!e){o=b+136|0;p=f[o>>2]|0;if(p|0){q=p+12|0;f[q>>2]=(f[q>>2]|0)+1}q=a+136|0;p=f[q>>2]|0;if(p|0?(r=p+12|0,p=f[r>>2]|0,f[r>>2]=p+-1,(p|0)==1):0)_S(l);f[q>>2]=0;p=a+116|0;r=a+104|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[r>>2]|0)>0){s=f[a+140>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0;u=f[r>>2]|0}while((t|0)<(u|0));f[l>>2]=f[k>>2];if((u|0)<3)n=26;else n=28}else{f[l>>2]=f[k>>2];n=26}if((n|0)==26){t=f[b+104>>2]|0;if((t|0)<3){f[r>>2]=t;f[a+108>>2]=f[b+108>>2];f[a+112>>2]=f[b+112>>2];t=f[b+144>>2]|0;s=f[a+144>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else n=28}if((n|0)==28)ZS(l,k);f[p>>2]=f[b+116>>2];f[a+120>>2]=f[b+120>>2];f[a+124>>2]=f[b+124>>2];f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];f[q>>2]=f[o>>2];t=a+156|0;s=b+156|0;if(!e){g=b+180|0;i=f[g>>2]|0;if(i|0){h=i+8|0;f[h>>2]=(f[h>>2]|0)+1}h=a+180|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)HQ(t);i=a+160|0;if((f[i>>2]|0)>0){j=f[a+188>>2]|0;v=0;do{f[j+(v<<2)>>2]=0;v=v+1|0;w=f[i>>2]|0}while((v|0)<(w|0));f[h>>2]=0;f[t>>2]=f[s>>2];if((w|0)<3)n=40;else n=42}else{f[h>>2]=0;f[t>>2]=f[s>>2];n=40}if((n|0)==40){v=f[b+160>>2]|0;if((v|0)<3){f[i>>2]=v;f[a+164>>2]=f[b+164>>2];f[a+168>>2]=f[b+168>>2];v=f[b+192>>2]|0;j=f[a+192>>2]|0;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2]}else n=42}if((n|0)==42)FQ(t,s);f[a+172>>2]=f[b+172>>2];v=a+176|0;if(!(f[v>>2]|0))f[v>>2]=f[b+176>>2];f[h>>2]=f[g>>2];f[a+184>>2]=f[b+184>>2];v=a+204|0;j=b+204|0;if(!e){o=b+228|0;q=f[o>>2]|0;if(q|0){p=q+8|0;f[p>>2]=(f[p>>2]|0)+1}p=a+228|0;q=f[p>>2]|0;if(q|0?(k=q+8|0,q=f[k>>2]|0,f[k>>2]=q+-1,(q|0)==1):0)HQ(v);q=a+208|0;if((f[q>>2]|0)>0){k=f[a+236>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;x=f[q>>2]|0}while((l|0)<(x|0));f[p>>2]=0;f[v>>2]=f[j>>2];if((x|0)<3)n=56;else n=58}else{f[p>>2]=0;f[v>>2]=f[j>>2];n=56}if((n|0)==56){l=f[b+208>>2]|0;if((l|0)<3){f[q>>2]=l;f[a+212>>2]=f[b+212>>2];f[a+216>>2]=f[b+216>>2];l=f[b+240>>2]|0;k=f[a+240>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2]}else n=58}if((n|0)==58)FQ(v,j);f[a+220>>2]=f[b+220>>2];l=a+224|0;if(!(f[l>>2]|0))f[l>>2]=f[b+224>>2];f[p>>2]=f[o>>2];f[a+232>>2]=f[b+232>>2];l=a+252|0;k=b+252|0;if(!e){g=b+276|0;h=f[g>>2]|0;if(h|0){s=h+8|0;f[s>>2]=(f[s>>2]|0)+1}s=a+276|0;h=f[s>>2]|0;do if(h|0){t=h+8|0;i=f[t>>2]|0;f[t>>2]=i+-1;if((i|0)!=1)break;HQ(l)}while(0);h=a+256|0;if((f[h>>2]|0)>0){o=f[a+284>>2]|0;p=0;do{f[o+(p<<2)>>2]=0;p=p+1|0;y=f[h>>2]|0}while((p|0)<(y|0));f[s>>2]=0;f[l>>2]=f[k>>2];if((y|0)<3)n=72;else n=74}else{f[s>>2]=0;f[l>>2]=f[k>>2];n=72}do if((n|0)==72){p=f[b+256>>2]|0;if((p|0)>=3){n=74;break}f[h>>2]=p;f[a+260>>2]=f[b+260>>2];f[a+264>>2]=f[b+264>>2];p=f[b+288>>2]|0;o=f[a+288>>2]|0;f[o>>2]=f[p>>2];f[o+4>>2]=f[p+4>>2]}while(0);if((n|0)==74)FQ(l,k);f[a+268>>2]=f[b+268>>2];h=a+272|0;if(!(f[h>>2]|0))f[h>>2]=f[b+272>>2];f[s>>2]=f[g>>2];f[a+280>>2]=f[b+280>>2];h=a+300|0;p=b+300|0;if(e)break;o=b+324|0;j=f[o>>2]|0;if(j|0){v=j+8|0;f[v>>2]=(f[v>>2]|0)+1}v=a+324|0;j=f[v>>2]|0;do if(j|0){q=j+8|0;i=f[q>>2]|0;f[q>>2]=i+-1;if((i|0)!=1)break;HQ(h)}while(0);j=a+304|0;if((f[j>>2]|0)>0){g=f[a+332>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0;z=f[j>>2]|0}while((s|0)<(z|0));f[v>>2]=0;f[h>>2]=f[p>>2];if((z|0)<3)n=88;else n=90}else{f[v>>2]=0;f[h>>2]=f[p>>2];n=88}do if((n|0)==88){s=f[b+304>>2]|0;if((s|0)>=3){n=90;break}f[j>>2]=s;f[a+308>>2]=f[b+308>>2];f[a+312>>2]=f[b+312>>2];s=f[b+336>>2]|0;g=f[a+336>>2]|0;f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2]}while(0);if((n|0)==90)FQ(h,p);f[a+316>>2]=f[b+316>>2];j=a+320|0;if(!(f[j>>2]|0))f[j>>2]=f[b+320>>2];f[v>>2]=f[o>>2];f[a+328>>2]=f[b+328>>2]}}}}}while(0);n=a+348|0;z=f[b+348>>2]|0;e=f[b+352>>2]|0;if(z|0){b=z+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[n>>2]|0;f[n>>2]=z;f[a+352>>2]=e;if(!b)return a|0;e=b+4|0;z=f[e>>2]|0;f[e>>2]=z+-1;if((z|0)!=1)return a|0;Yi[f[(f[b>>2]|0)+8>>2]&2047](b);return a|0}function HNb(a){a=a|0;YDc(a);return}function INb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function JNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>6>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;k=j+4|0;l=k+60|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));j=(f[g>>2]|0)+64|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>6;h=j+c|0;if(h>>>0>67108863)mCc(a);m=e-i|0;i=m>>5;e=m>>6>>>0<33554431?(i>>>0<h>>>0?h:i):67108863;do if(e)if(e>>>0>67108863){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{n=VDc(e<<6)|0;break}else n=0;while(0);i=n+(j<<6)|0;j=i;h=n+(e<<6)|0;e=c;c=j;n=i;do{b[n>>0]=0;k=n+4|0;l=k+60|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));n=c+64|0;c=n;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;n=f[g>>2]|0;k=h;if((n|0)==(h|0)){o=j;p=k}else{j=n+-64-k|0;k=n;n=i;while(1){l=k;k=k+-64|0;b[n+-64>>0]=b[k>>0]|0;f[n+-60>>2]=f[l+-60>>2];f[n+-56>>2]=f[l+-56>>2];f[n+-52>>2]=f[l+-52>>2];f[n+-48>>2]=f[l+-48>>2];f[n+-44>>2]=f[l+-44>>2];f[n+-40>>2]=f[l+-40>>2];f[n+-36>>2]=f[l+-36>>2];f[n+-32>>2]=f[l+-32>>2];f[n+-28>>2]=f[l+-28>>2];f[n+-24>>2]=f[l+-24>>2];f[n+-20>>2]=f[l+-20>>2];f[n+-16>>2]=f[l+-16>>2];f[n+-12>>2]=f[l+-12>>2];f[n+-8>>2]=f[l+-8>>2];f[n+-4>>2]=f[l+-4>>2];if((k|0)==(h|0))break;else n=n+-64|0}o=i+(~(j>>>6)<<6)|0;p=f[a>>2]|0}f[a>>2]=o;f[g>>2]=c;f[d>>2]=e;if(!p)return;YDc(p);return}function KNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+160|0;e=d+152|0;g=d+136|0;h=d+88|0;i=d+44|0;j=d;k=d+144|0;I_(g,c,467824);l=g+4|0;K_(h,f[g>>2]|0,f[l>>2]|0,0);m=f[g>>2]|0;n=f[l>>2]|0;K_(i,m,n,M_(g)|0);g=a+4|0;n=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(n|0));g=h+40|0;n=h+4|0;m=i+4|0;l=h+20|0;o=i+20|0;p=i+40|0;q=j+20|0;r=e+4|0;s=e+4|0;t=e+4|0;v=e+4|0;w=e+4|0;x=0;while(1){y=f[h>>2]|0;if((((y|0)==(f[i>>2]|0)?(f[n>>2]|0)==(f[m>>2]|0):0)?(f[l>>2]|0)==(f[o>>2]|0):0)?(f[g>>2]|0)==(f[p>>2]|0):0)break;K_(j,y,f[l>>2]|0,0);y=f[q>>2]|0;f[e>>2]=f[j>>2];f[r>>2]=y;Y_(e,a+4+(x*20|0)|0,0);y=N_(j)|0;z=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[s>>2]=z;Y_(e,a+4+(x*20|0)+4|0,0);z=N_(y)|0;y=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[t>>2]=y;Y_(e,a+4+(x*20|0)+8|0,0);y=N_(z)|0;z=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[v>>2]=z;Y_(e,a+4+(x*20|0)+12|0,0);z=N_(y)|0;y=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[w>>2]=y;Z_(e,a+4+(x*20|0)+16|0,0.0);N_(z)|0;N_(h)|0;x=x+1|0}I_(k,c,467830);Y_(k,e,0);b[a>>0]=(f[e>>2]|0)!=0&1;u=d;return 1}function LNb(a){a=a|0;YDc(a);return}function MNb(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);YDc(c)}YDc(b)}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function NNb(a){a=a|0;YDc(a);return}function ONb(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);YDc(c)}YDc(b)}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function PNb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=137360;b=a+372|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+376>>2]=0;b=a+364|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+368>>2]=0;b=a+356|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;g=a+360|0;f[g>>2]=0;$Mb(a);return}d=c+4|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1){f[b>>2]=0;g=a+360|0;f[g>>2]=0;$Mb(a);return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;g=a+360|0;f[g>>2]=0;$Mb(a);return}function QNb(a){a=a|0;PNb(a);YDc(a);return}function RNb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+112|0;e=d+56|0;g=d+64|0;h=d+8|0;i=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];bNb(a,0,e)|0;e=a+356|0;c=a+360|0;if(!(f[c>>2]|0)){j=VDc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=VDc(16)|0;l=k+4|0;f[l>>2]=1;f[k>>2]=137440;f[k+8>>2]=j;f[l>>2]=(f[l>>2]|0)+1;m=f[e>>2]|0;f[e>>2]=k;f[c>>2]=j;if(m|0?(j=m+4|0,e=f[j>>2]|0,f[j>>2]=e+-1,(e|0)==1):0)Yi[f[(f[m>>2]|0)+8>>2]&2047](m);m=f[l>>2]|0;f[l>>2]=m+-1;if((m|0)==1)Yi[f[(f[k>>2]|0)+8>>2]&2047](k)}k=a+364|0;m=a+368|0;if(!(f[m>>2]|0)){l=VDc(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=VDc(16)|0;j=e+4|0;f[j>>2]=1;f[e>>2]=137460;f[e+8>>2]=l;f[j>>2]=(f[j>>2]|0)+1;n=f[k>>2]|0;f[k>>2]=e;f[m>>2]=l;if(n|0?(l=n+4|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)Yi[f[(f[n>>2]|0)+8>>2]&2047](n);n=f[j>>2]|0;f[j>>2]=n+-1;if((n|0)==1)Yi[f[(f[e>>2]|0)+8>>2]&2047](e)}e=a+372|0;n=a+376|0;if(!(f[n>>2]|0)){j=VDc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;m=VDc(16)|0;l=m+4|0;f[l>>2]=1;f[m>>2]=137460;f[m+8>>2]=j;f[l>>2]=(f[l>>2]|0)+1;k=f[e>>2]|0;f[e>>2]=m;f[n>>2]=j;if(k|0?(j=k+4|0,n=f[j>>2]|0,f[j>>2]=n+-1,(n|0)==1):0)Yi[f[(f[k>>2]|0)+8>>2]&2047](k);k=f[l>>2]|0;f[l>>2]=k+-1;if((k|0)==1)Yi[f[(f[m>>2]|0)+8>>2]&2047](m)}m=f[c>>2]|0;k=M_(b)|0;l=m+4|0;n=f[l>>2]|0;j=f[m>>2]|0;e=n-j>>4;o=j;j=n;if(k>>>0<=e>>>0){if(k>>>0<e>>>0?(n=o+(k<<4)|0,(j|0)!=(n|0)):0)f[l>>2]=j+(~((j+-16-n|0)>>>4)<<4)}else fOb(m,k-e|0);f[a+380>>2]=0;e=b+4|0;K_(g,f[b>>2]|0,f[e>>2]|0,0);k=f[b>>2]|0;m=f[e>>2]|0;K_(h,k,m,M_(b)|0);b=f[c>>2]|0;c=g+40|0;m=g+4|0;k=h+4|0;e=g+20|0;n=h+20|0;j=h+40|0;l=i+4|0;o=0;while(1){p=f[g>>2]|0;q=p;if((((p|0)==(f[h>>2]|0)?(f[m>>2]|0)==(f[k>>2]|0):0)?(f[e>>2]|0)==(f[n>>2]|0):0)?(f[c>>2]|0)==(f[j>>2]|0):0)break;p=(f[b>>2]|0)+(o<<4)|0;r=f[e>>2]|0;f[i>>2]=q;f[l>>2]=r;gOb(p,i)|0;N_(g)|0;o=o+1|0}f[a+40>>2]=1;o=a+24|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;u=d;return 1}function SNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=VDc(388)|0;_Nb(c);d=VDc(16)|0;e=d+4|0;f[e>>2]=1;f[d>>2]=137420;f[d+8>>2]=c;g=d;h=c;GNb(c,b)|0;i=c+356|0;j=f[b+356>>2]|0;k=f[b+360>>2]|0;if(j|0){l=j+4|0;f[l>>2]=(f[l>>2]|0)+1}l=f[i>>2]|0;f[i>>2]=j;f[c+360>>2]=k;if(l|0?(k=l+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)Yi[f[(f[l>>2]|0)+8>>2]&2047](l);l=c+364|0;j=f[b+364>>2]|0;k=f[b+368>>2]|0;if(j|0){i=j+4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[l>>2]|0;f[l>>2]=j;f[c+368>>2]=k;if(i|0?(k=i+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);i=c+372|0;j=f[b+372>>2]|0;k=f[b+376>>2]|0;if(j|0){l=j+4|0;f[l>>2]=(f[l>>2]|0)+1}l=f[i>>2]|0;f[i>>2]=j;f[c+376>>2]=k;if(l|0?(k=l+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)Yi[f[(f[l>>2]|0)+8>>2]&2047](l);l=b+380|0;b=f[l+4>>2]|0;j=c+380|0;f[j>>2]=f[l>>2];f[j+4>>2]=b;f[a>>2]=g;f[a+4>>2]=h;f[e>>2]=(f[e>>2]|0)+1;h=f[e>>2]|0;f[e>>2]=h+-1;if((h|0)!=1)return;Yi[f[(f[d>>2]|0)+8>>2]&2047](d);return}function TNb(a){a=a|0;return 1}function UNb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;if((d|0)>-1?(h=f[a+352>>2]|0,i=f[h>>2]|0,j=((f[h+4>>2]|0)-i|0)/20|0,(j|0)>(d|0)):0){if(j>>>0<=d>>>0)nCc(h);h=i;i=f[c>>2]|0;if((i|0)<0){k=0;u=e;return k|0}j=f[c+4>>2]|0;if((j|0)<0){k=0;u=e;return k|0}if(((f[a+8>>2]|0)+i|0)>=(f[h+(d*20|0)+4>>2]|0)){k=0;u=e;return k|0}if(((f[a+12>>2]|0)+j|0)>=(f[h+(d*20|0)+8>>2]|0)){k=0;u=e;return k|0}c=(f[a+60>>2]|0)+(Y(f[f[a+88>>2]>>2]|0,j)|0)+(i<<2)|0;f[a+384>>2]=c+(f[h+(d*20|0)+12>>2]<<2);k=1;u=e;return k|0}f[g>>2]=0;f[g+4>>2]=0;k=tT(g,50)|0;e=465839;d=k+50|0;do{b[k>>0]=b[e>>0]|0;k=k+1|0;e=e+1|0}while((k|0)<(d|0));z5(-215,g,466320,465762,868);return 0}function VNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+380>>2]|0;d=f[a+384>>2]|0;a=f[d+(f[c+(b<<6)+20>>2]<<2)>>2]|0;e=f[d+(f[c+(b<<6)+24>>2]<<2)>>2]|0;g=f[d+(f[c+(b<<6)+36>>2]<<2)>>2]|0;h=f[d+(f[c+(b<<6)+40>>2]<<2)>>2]|0;i=a-e-g+h|0;j=f[d+(f[c+(b<<6)+4>>2]<<2)>>2]|0;k=f[d+(f[c+(b<<6)+16>>2]<<2)>>2]|0;l=f[d+(f[c+(b<<6)+8>>2]<<2)>>2]|0;m=f[d+(f[c+(b<<6)+28>>2]<<2)>>2]|0;n=f[d+(f[c+(b<<6)+44>>2]<<2)>>2]|0;o=f[d+(f[c+(b<<6)+56>>2]<<2)>>2]|0;p=f[d+(f[c+(b<<6)+52>>2]<<2)>>2]|0;q=f[d+(f[c+(b<<6)+32>>2]<<2)>>2]|0;return ((e-a+j-l|0)>=(i|0)?64:0)|(((f[d+(f[c+(b<<6)>>2]<<2)>>2]|0)+a-j-k|0)>=(i|0)?128:0)|((l-e-(f[d+(f[c+(b<<6)+12>>2]<<2)>>2]|0)+m|0)>=(i|0)?32:0)|((e-h-m+n|0)>=(i|0)?16:0)|((h-n-o+(f[d+(f[c+(b<<6)+60>>2]<<2)>>2]|0)|0)>=(i|0)?8:0)|((g-h+o-p|0)>=(i|0)?4:0)|(g-a+k-q|0)>=(i|0)|((p-g+q-(f[d+(f[c+(b<<6)+48>>2]<<2)>>2]|0)|0)>=(i|0)?2:0)|0}function WNb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+80|0;e=d+24|0;g=d+8|0;h=d;i=f[a+352>>2]|0;j=f[i>>2]|0;if((((f[i+4>>2]|0)-j|0)/20|0)>>>0<=b>>>0)nCc(i);i=j;if((d$(c)|0)==655360){j=f[i+(b*20|0)+12>>2]|0;k=f[a+16>>2]|0;l=f[i+(b*20|0)+4>>2]|0;m=f[i+(b*20|0)+8>>2]|0;f[g>>2]=(j|0)%(k|0)|0;f[g+4>>2]=(j|0)/(k|0)|0;f[g+8>>2]=l;f[g+12>>2]=m;CQ(e,a+204|0,g);m=g+8|0;f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=34209792;f[g+4>>2]=e;m=e0()|0;iqa(c,g,m,e0()|0,4,-1);GQ(e);u=d;return}f[h>>2]=f[i+(b*20|0)+4>>2];f[h+4>>2]=f[i+(b*20|0)+8>>2];CY(e,h,4,(f[a+60>>2]|0)+(f[i+(b*20|0)+12>>2]<<2)|0,f[a+92>>2]|0);a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;a=e0()|0;iqa(c,g,a,e0()|0,4,-1);a=e+36|0;g=f[a>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)_S(e);f[a>>2]=0;a=e+16|0;g=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[g>>2]|0)>0){a=f[e+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))g0(g);u=d;return}function XNb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=f[a+16>>2]|0;c=f[a+360>>2]|0;d=(f[c+4>>2]|0)-(f[c>>2]|0)>>4;e=a+368|0;g=f[e>>2]|0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;k=i-j>>6;l=j;j=i;if(d>>>0<=k>>>0){if(d>>>0<k>>>0?(i=l+(d<<6)|0,(j|0)!=(i|0)):0)f[h>>2]=j+(~((j+-64-i|0)>>>6)<<6);i=f[g>>2]|0;f[a+380>>2]=i;if(!d){m=g;n=a+252|0;ZNb(m,n);return}else{o=i;p=g}}else{YNb(g,d-k|0);k=f[e>>2]|0;e=f[k>>2]|0;f[a+380>>2]=e;o=e;p=k}k=o;o=f[c>>2]|0;c=0;do{e=f[o+(c<<4)>>2]|0;g=f[o+(c<<4)+4>>2]|0;i=f[o+(c<<4)+8>>2]|0;j=f[o+(c<<4)+12>>2]|0;h=Y(g,b)|0;f[k+(c<<6)>>2]=h+e;l=i+e|0;f[k+(c<<6)+4>>2]=l+h;q=Y(j+g|0,b)|0;f[k+(c<<6)+16>>2]=q+e;f[k+(c<<6)+20>>2]=q+l;r=(i<<1)+e|0;f[k+(c<<6)+8>>2]=r+h;s=r+i|0;f[k+(c<<6)+12>>2]=s+h;f[k+(c<<6)+24>>2]=q+r;f[k+(c<<6)+28>>2]=s+q;q=(j<<1)+g|0;g=Y(q,b)|0;f[k+(c<<6)+40>>2]=g+r;f[k+(c<<6)+44>>2]=g+s;h=Y(q+j|0,b)|0;f[k+(c<<6)+56>>2]=h+r;f[k+(c<<6)+60>>2]=h+s;f[k+(c<<6)+32>>2]=g+e;f[k+(c<<6)+36>>2]=g+l;f[k+(c<<6)+48>>2]=h+e;f[k+(c<<6)+52>>2]=h+l;c=c+1|0}while((c|0)!=(d|0));m=p;n=a+252|0;ZNb(m,n);return}function YNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)mCc(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=m+(d<<6)|0;d=b;b=h;m=h;do{j=b;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(0-(b>>6)<<6)|0;if((b|0)>0)dJc(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;YDc(d);return}function ZNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+80|0;d=c;e=c+56|0;g=f[a>>2]|0;h=a+4|0;i=f[h>>2]|0;if((g|0)==(i|0)){j=b+24|0;k=f[j>>2]|0;if(k|0?(l=k+8|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)HQ(b);k=b+4|0;if((f[k>>2]|0)>0){l=f[b+32>>2]|0;m=0;do{f[l+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}f[j>>2]=0;n=f[a>>2]|0;o=f[h>>2]|0}else{n=g;o=i}Vj(d,1,o-n|0,0,n,0);n=e+8|0;f[n>>2]=0;f[n+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=b;h_(d,e);e=d+36|0;b=f[e>>2]|0;if(b|0?(n=b+12|0,b=f[n>>2]|0,f[n>>2]=b+-1,(b|0)==1):0)_S(d);f[e>>2]=0;e=d+16|0;b=d+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[d+40>>2]|0;n=0;do{f[e+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[b>>2]|0))}b=f[d+44>>2]|0;if((b|0)==(d+48|0)){u=c;return}g0(b);u=c;return}function _Nb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[a+44>>2]=1124007936;b=a+52|0;c=a+84|0;d=a+48|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+92|0;f[a+88>>2]=b;f[b>>2]=0;f[a+96>>2]=0;f[a+100>>2]=1124007936;b=a+108|0;c=a+140|0;d=a+104|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+148|0;f[a+144>>2]=b;f[b>>2]=0;f[a+152>>2]=0;f[a+156>>2]=1124007936;b=a+160|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+188>>2]=a+164;b=a+196|0;f[a+192>>2]=b;f[a+200>>2]=0;f[b>>2]=0;f[a+204>>2]=1124007936;b=a+208|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+236>>2]=a+212;b=a+244|0;f[a+240>>2]=b;f[a+248>>2]=0;f[b>>2]=0;f[a+252>>2]=1124007936;b=a+256|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+284>>2]=a+260;b=a+292|0;f[a+288>>2]=b;f[a+296>>2]=0;f[b>>2]=0;f[a+300>>2]=1124007936;b=a+304|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+332>>2]=a+308;b=a+340|0;f[a+336>>2]=b;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[a>>2]=137360;b=a+356|0;c=a+364|0;d=a+368|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;e=VDc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=VDc(16)|0;h=g+4|0;f[h>>2]=1;f[g>>2]=137440;f[g+8>>2]=e;f[h>>2]=(f[h>>2]|0)+1;i=f[b>>2]|0;f[b>>2]=g;f[a+360>>2]=e;if(i|0?(e=i+4|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)==1)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=VDc(16)|0;h=i+4|0;f[h>>2]=1;f[i>>2]=137460;f[i+8>>2]=g;f[h>>2]=(f[h>>2]|0)+1;b=f[c>>2]|0;f[c>>2]=i;f[d>>2]=g;if(b|0?(g=b+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);b=f[h>>2]|0;f[h>>2]=b+-1;if((b|0)==1)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);i=VDc(12)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b=VDc(16)|0;h=b+4|0;f[h>>2]=1;f[b>>2]=137220;f[b+8>>2]=i;d=a+348|0;f[h>>2]=(f[h>>2]|0)+1;g=f[d>>2]|0;f[d>>2]=b;f[a+352>>2]=i;if(g|0?(i=g+4|0,d=f[i>>2]|0,f[i>>2]=d+-1,(d|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[h>>2]|0;f[h>>2]=g+-1;if((g|0)!=1){j=a+380|0;f[j>>2]=0;k=a+384|0;f[k>>2]=0;return}Yi[f[(f[b>>2]|0)+8>>2]&2047](b);j=a+380|0;f[j>>2]=0;k=a+384|0;f[k>>2]=0;return}function $Nb(a){a=a|0;YDc(a);return}function aOb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bOb(a){a=a|0;YDc(a);return}function cOb(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);YDc(c)}YDc(b)}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dOb(a){a=a|0;YDc(a);return}function eOb(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);YDc(c)}YDc(b)}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)mCc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function gOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+64|0;d=c+56|0;e=c+48|0;g=c;I_(e,b,466640);K_(g,f[e>>2]|0,f[e+4>>2]|0,0);e=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=e;Y_(d,a,0);e=N_(g)|0;b=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=b;Y_(d,a+4|0,0);b=N_(e)|0;e=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=e;Y_(d,a+8|0,0);e=N_(b)|0;b=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=b;Y_(d,a+12|0,0);N_(e)|0;u=c;return 1}function hOb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137480;l6(a+416|0);GQ(a+368|0);GQ(a+320|0);GQ(a+272|0);GQ(a+224|0);GQ(a+176|0);GQ(a+128|0);b=a+120|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+124>>2]=0;b=a+112|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+116>>2]=0;b=a+104|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+108>>2]=0;OOb(a+4|0);j0(a);return}function iOb(a){a=a|0;hOb(a);YDc(a);return}function jOb(a,b){a=a|0;b=b|0;POb(a,b)|0;return}function kOb(a){a=a|0;var b=0;if(f[a+116>>2]|0){b=0;return b|0}b=(f[a+32>>2]|0)==(f[a+36>>2]|0);return b|0}function lOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+240|0;d=c+132|0;e=c+88|0;g=c+44|0;h=c+8|0;i=c;j=a+112|0;k=f[j>>2]|0;if(k|0?(l=k+4|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)Yi[f[(f[k>>2]|0)+8>>2]&2047](k);f[j>>2]=0;k=a+116|0;f[k>>2]=0;m=d;l=m+100|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(l|0));m=a+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;if((m|0)!=(d|0)){KOb(a+32|0,0,0);LOb(a+44|0,f[d+40>>2]|0,f[d+44>>2]|0);MOb(a+56|0,f[d+52>>2]|0,f[d+56>>2]|0);DF(a+68|0,f[d+64>>2]|0,f[d+68>>2]|0);xxa(a+80|0,f[d+76>>2]|0,f[d+80>>2]|0);NOb(a+92|0,f[d+88>>2]|0,f[d+92>>2]|0)}OOb(d);m=a+104|0;l=f[m>>2]|0;if(l|0?(n=l+4|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)Yi[f[(f[l>>2]|0)+8>>2]&2047](l);f[m>>2]=0;f[a+108>>2]=0;f[d>>2]=0;f[d+4>>2]=0;B_(h,b,0,d);uT(d);if(!(w_(h)|0)){p=0;t_(h);u=c;return p|0}D_(d,h,0);m=d+4|0;K_(e,f[d>>2]|0,f[m>>2]|0,0);l=f[d>>2]|0;o=f[m>>2]|0;K_(g,l,o,M_(d)|0);d=f[e>>2]|0;o=d;if((((d|0)==(f[g>>2]|0)?(f[e+4>>2]|0)==(f[g+4>>2]|0):0)?(f[e+20>>2]|0)==(f[g+20>>2]|0):0)?(f[e+40>>2]|0)==(f[g+40>>2]|0):0){f[i>>2]=0;f[i+4>>2]=0}else{g=f[e+20>>2]|0;f[i>>2]=o;f[i+4>>2]=g}if(POb(a,i)|0){p=1;t_(h);u=c;return p|0}x_(h);i=f[b>>2]|0;b=i1((i|0)==0?1154740:i,0,0,0)|0;if(!b)q=0;else{i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=137580;f[i+8>>2]=b;q=i}i=f[j>>2]|0;f[j>>2]=q;f[k>>2]=b;if(i|0?(b=i+4|0,q=f[b>>2]|0,f[b>>2]=q+-1,(q|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);p=(f[k>>2]|0)!=0;t_(h);u=c;return p|0}function mOb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=u;u=u+48|0;k=j+28|0;l=j+16|0;m=j+8|0;n=j;f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;f[l>>2]=0;p=l+4|0;f[p>>2]=0;f[l+8>>2]=0;q=f[(f[a>>2]|0)+44>>2]|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];ih[q&3](a,b,c,k,l,d,e,g,m,n,0);n=f[l>>2]|0;if(n|0){l=f[p>>2]|0;if((l|0)!=(n|0))f[p>>2]=l+(~((l+-8-n|0)>>>3)<<3);YDc(n)}n=f[k>>2]|0;if(!n){u=j;return}k=f[o>>2]|0;if((k|0)!=(n|0))f[o>>2]=k+(~((k+-4-n|0)>>>2)<<2);YDc(n);u=j;return}function nOb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;l=u;u=u+144|0;m=l+80|0;n=l+68|0;o=l+56|0;p=l+32|0;q=l+48|0;r=l+24|0;s=l+16|0;t=l+8|0;v=l;do if((d$(c)|0)==65536){w=f[c+4>>2]|0;f[m>>2]=f[w>>2];x=m+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[w+8>>2];f[m+12>>2]=f[w+12>>2];f[m+16>>2]=f[w+16>>2];f[m+20>>2]=f[w+20>>2];f[m+24>>2]=f[w+24>>2];f[m+28>>2]=f[w+28>>2];f[m+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(m,w);break}}else a$(m,c,-1);while(0);if(!(g>1.0)){f[n>>2]=0;C=n+4|0;f[C>>2]=0;D=tT(n,41)|0;E=D;F=467074;G=E+41|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,n,466708,465762,1424)}if(f[m>>2]&7|0){f[n>>2]=0;C=n+4|0;f[C>>2]=0;D=tT(n,41)|0;E=D;F=467074;G=E+41|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,n,466708,465762,1424)}if(!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){f[n>>2]=0;F=n+4|0;f[F>>2]=0;f[n+8>>2]=0;f[o>>2]=0;E=o+4|0;f[E>>2]=0;f[o+8>>2]=0;if(_i[f[(f[a>>2]|0)+48>>2]&1023](a)|0){f[p>>2]=0;G=p+4|0;f[G>>2]=0;f[p+8>>2]=0;D=f[a+112>>2]|0;f[q>>2]=D;C=q+4|0;f[C>>2]=f[a+116>>2];if(D|0){c=D+4|0;f[c>>2]=(f[c>>2]|0)+1}f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[s>>2]=f[k>>2];f[s+4>>2]=f[k+4>>2];vOb(m,q,d,n,o,p,g,h,i,r,s,0);s=f[q>>2]|0;if(s|0?(r=s+4|0,i=f[r>>2]|0,f[r>>2]=i+-1,(i|0)==1):0)Yi[f[(f[s>>2]|0)+8>>2]&2047](s);f[q>>2]=0;f[C>>2]=0;C=f[G>>2]|0;q=f[p>>2]|0;s=(C-q|0)/20|0;i=e+4|0;r=f[i>>2]|0;c=f[e>>2]|0;D=r-c>>2;w=c;c=r;r=q;q=C;if(s>>>0<=D>>>0)if(s>>>0<D>>>0?(C=w+(s<<2)|0,(c|0)!=(C|0)):0){f[i>>2]=c+(~((c+-4-C|0)>>>2)<<2);H=r;I=q;J=w}else{H=r;I=q;J=w}else{lN(e,s-D|0);H=f[p>>2]|0;I=f[G>>2]|0;J=f[e>>2]|0}if((H|0)!=(I|0)){D=H;s=J;while(1){f[s>>2]=f[D+16>>2];D=D+20|0;if((D|0)==(I|0))break;else s=s+4|0}}if(H|0){if((I|0)!=(H|0))f[G>>2]=I+(~(((I+-20-H|0)>>>0)/20|0)*20|0);YDc(H)}}else{f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=m;f[t>>2]=f[j>>2];f[t+4>>2]=f[j+4>>2];f[v>>2]=f[k>>2];f[v+4>>2]=f[k+4>>2];wOb(a,p,d,n,o,g,t,v,0);xOb(d,h,.2,e,0)}e=f[o>>2]|0;if(e|0){o=f[E>>2]|0;if((o|0)!=(e|0))f[E>>2]=o+(~((o+-8-e|0)>>>3)<<3);YDc(e)}e=f[n>>2]|0;if(e|0){n=f[F>>2]|0;if((n|0)!=(e|0))f[F>>2]=n+(~((n+-4-e|0)>>>2)<<2);YDc(e)}}e=m+36|0;n=f[e>>2]|0;if(n|0?(F=n+12|0,n=f[F>>2]|0,f[F>>2]=n+-1,(n|0)==1):0)_S(m);f[e>>2]=0;e=m+16|0;n=m+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[n>>2]|0)>0){e=f[m+40>>2]|0;F=0;do{f[e+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)==(m+48|0)){u=l;return}g0(n);u=l;return}function oOb(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;n=u;u=u+112|0;o=n+56|0;p=n+32|0;q=n+48|0;r=n+24|0;s=n+16|0;t=n+8|0;v=n;if(!(h>1.0)){f[o>>2]=0;w=o+4|0;f[w>>2]=0;x=tT(o,42)|0;y=x;z=466665;A=y+42|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,o,466708,465762,1376)}if(p$(c,-1)|0){f[o>>2]=0;w=o+4|0;f[w>>2]=0;x=tT(o,42)|0;y=x;z=466665;A=y+42|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,o,466708,465762,1376)}if(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0){u=n;return}if(!(_i[f[(f[a>>2]|0)+48>>2]&1023](a)|0)){f[t>>2]=f[k>>2];f[t+4>>2]=f[k+4>>2];f[v>>2]=f[l>>2];f[v+4>>2]=f[l+4>>2];wOb(a,c,d,e,g,h,t,v,m);if(m){xOb(d,i,.2,e,g);u=n;return}else{xOb(d,i,.2,0,0);u=n;return}}do if((d$(c)|0)==65536){v=f[c+4>>2]|0;f[o>>2]=f[v>>2];t=o+4|0;z=v+4|0;f[t>>2]=f[z>>2];y=o+8|0;f[y>>2]=f[v+8>>2];f[o+12>>2]=f[v+12>>2];f[o+16>>2]=f[v+16>>2];f[o+20>>2]=f[v+20>>2];f[o+24>>2]=f[v+24>>2];f[o+28>>2]=f[v+28>>2];f[o+32>>2]=f[v+32>>2];A=f[v+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=y;y=o+48|0;x=o+44|0;f[x>>2]=y;f[y>>2]=0;f[o+52>>2]=0;if(A|0){y=A+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[z>>2]|0)<3){z=f[v+44>>2]|0;y=f[x>>2]|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];break}else{f[t>>2]=0;ZS(o,v);break}}else a$(o,c,-1);while(0);f[p>>2]=0;c=p+4|0;f[c>>2]=0;f[p+8>>2]=0;v=f[a+112>>2]|0;f[q>>2]=v;t=q+4|0;f[t>>2]=f[a+116>>2];if(v|0){a=v+4|0;f[a>>2]=(f[a>>2]|0)+1}f[r>>2]=f[k>>2];f[r+4>>2]=f[k+4>>2];f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];vOb(o,q,d,e,g,p,h,i,j,r,s,m);m=f[q>>2]|0;if(m|0?(s=m+4|0,r=f[s>>2]|0,f[s>>2]=r+-1,(r|0)==1):0)Yi[f[(f[m>>2]|0)+8>>2]&2047](m);f[q>>2]=0;f[t>>2]=0;t=f[p>>2]|0;if(t|0){p=f[c>>2]|0;if((p|0)!=(t|0))f[c>>2]=p+(~(((p+-20-t|0)>>>0)/20|0)*20|0);YDc(t)}t=o+36|0;p=f[t>>2]|0;if(p|0?(c=p+12|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)_S(o);f[t>>2]=0;t=o+16|0;p=o+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[p>>2]|0)>0){t=f[o+40>>2]|0;c=0;do{f[t+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[p>>2]|0))}p=f[o+44>>2]|0;if((p|0)!=(o+48|0))g0(p);u=n;return}function pOb(a){a=a|0;return (f[a+116>>2]|0)!=0|0}function qOb(a,b){a=a|0;b=b|0;f[a>>2]=f[b+24>>2];f[a+4>>2]=f[b+28>>2];return}function rOb(a){a=a|0;var b=0;b=f[a+108>>2]|0;return _i[f[(f[b>>2]|0)+16>>2]&1023](b)|0}function sOb(a){a=a|0;return f[a+116>>2]|0}function tOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+120|0;d=f[b>>2]|0;e=f[b+4>>2]|0;if(d|0){b=d+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=d;f[a+124>>2]=e;if(!b)return;e=b+4|0;a=f[e>>2]|0;f[e>>2]=a+-1;if((a|0)!=1)return;Yi[f[(f[b>>2]|0)+8>>2]&2047](b);return}function uOb(a,b){a=a|0;b=b|0;var c=0;c=f[b+120>>2]|0;f[a>>2]=c;f[a+4>>2]=f[b+124>>2];if(!c)return;b=c+4|0;f[b>>2]=(f[b>>2]|0)+1;return}function vOb(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;o=u;u=u+64|0;p=o+56|0;q=o+48|0;r=o;s=o+40|0;t=o+32|0;v=c7(0)|0;if(!v)w=0;else{x=VDc(16)|0;f[x+4>>2]=1;f[x>>2]=47876;f[x+8>>2]=v;w=x}x=f[a+8>>2]|0;y=(f[a+4>>2]|0)==1?1:f[a+12>>2]|0;z=f[a>>2]|0;A=f[a+16>>2]|0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=A;f[r+20>>2]=x;f[r+24>>2]=y;f[r+4>>2]=f[f[a+44>>2]>>2];f[r>>2]=z&20479|1111621632;z=f[c+4>>2]|0;c=f[l+4>>2]|0;f[s>>2]=f[l>>2];f[s+4>>2]=c;c=f[m+4>>2]|0;f[t>>2]=f[m>>2];f[t+4>>2]=c;f[q>>2]=f[s>>2];f[q+4>>2]=f[s+4>>2];f[p>>2]=f[t>>2];f[p+4>>2]=f[t+4>>2];t=HPb(r,z,v,e,g,i,j,k,q,p,n)|0;do if(t)if((f[t+28>>2]|0)==20){B=q;C=f[t+24>>2]|0;break}else{f[p>>2]=0;f[p+4>>2]=0;n=tT(p,39)|0;k=466950;j=n+39|0;do{b[n>>0]=b[k>>0]|0;n=n+1|0;k=k+1|0}while((n|0)<(j|0));z5(-215,p,466990,466994,2965)}else{B=q;C=0}while(0);B=h+4|0;k=f[B>>2]|0;n=f[h>>2]|0;j=(k-n|0)/20|0;g=n;n=k;if(C>>>0<=j>>>0){if(C>>>0<j>>>0?(k=g+(C*20|0)|0,(n|0)!=(k|0)):0)f[B>>2]=n+(~(((n+-20-k|0)>>>0)/20|0)*20|0)}else IOb(h,C-j|0);if((t|0)!=0&(C|0)!=0){C=f[h>>2]|0;f[q>>2]=0;f[q+4>>2]=1073741823;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];p7(t,C,p)|0}p=f[B>>2]|0;C=f[h>>2]|0;t=(p-C|0)/20|0;q=d+4|0;j=f[q>>2]|0;k=f[d>>2]|0;n=j-k>>4;g=k;k=j;j=C;C=p;if(t>>>0<=n>>>0)if(t>>>0<n>>>0?(p=g+(t<<4)|0,(k|0)!=(p|0)):0){f[q>>2]=k+(~((k+-16-p|0)>>>4)<<4);D=g;E=j;F=C}else{D=g;E=j;F=C}else{JOb(d,t-n|0);D=f[d>>2]|0;E=f[h>>2]|0;F=f[B>>2]|0}if((E|0)!=(F|0)){B=D;D=E;while(1){E=f[D+4>>2]|0;h=f[D+8>>2]|0;d=f[D+12>>2]|0;f[B>>2]=f[D>>2];f[B+4>>2]=E;f[B+8>>2]=h;f[B+12>>2]=d;D=D+20|0;if((D|0)==(F|0))break;else B=B+16|0}}if(!w){u=o;return}B=w+4|0;F=f[B>>2]|0;f[B>>2]=F+-1;if((F|0)!=1){u=o;return}Yi[f[(f[w>>2]|0)+8>>2]&2047](w);u=o;return}function wOb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;l=u;u=u+1360|0;m=l+1240|0;o=l+1232|0;q=l+1224|0;r=l+1212|0;s=l+1200|0;t=l;v=l+1184|0;w=l+1128|0;x=l+64|0;y=l+56|0;b$(o,c,-1);mi[f[(f[a>>2]|0)+52>>2]&2047](q,a);z=j+4|0;if((f[z>>2]|0)!=0?(f[j>>2]|0)!=0:0){A=o+4|0;B=A;C=f[A>>2]|0}else{f[j>>2]=f[o>>2];A=o+4|0;D=f[A>>2]|0;f[z>>2]=D;B=A;C=D}D=q+4|0;A=f[D>>2]|0;if((C|0)<(A|0)){u=l;return}E=f[o>>2]|0;F=f[q>>2]|0;if((E|0)<(F|0)){u=l;return}f[r>>2]=0;G=r+4|0;f[G>>2]=0;f[r+8>>2]=0;f[s>>2]=0;H=s+4|0;f[H>>2]=0;f[s+8>>2]=0;I=r+8|0;J=VDc(4096)|0;K=J;L=J+4096|0;f[r>>2]=K;f[G>>2]=K;f[I>>2]=L;M=s+8|0;N=VDc(4096)|0;O=N;f[s>>2]=O;f[H>>2]=O;f[M>>2]=N+4096;N=nrc(+(F|0))|0;a:do if(!((N|0)>(E|0)|(nrc(+(A|0))|0)>(C|0))){P=1.0;O=E;Q=A;R=F;S=J;T=L;while(1){U=P;n[m>>2]=U;if((S|0)==(T|0)){osb(r,m);V=f[q>>2]|0;W=f[D>>2]|0;X=f[o>>2]|0}else{n[S>>2]=U;f[G>>2]=S+4;V=R;W=Q;X=O}U=P*h;Z=nrc(U*+(V|0))|0;_=nrc(U*+(W|0))|0;if((Z|0)>(X|0)?1:(_|0)>(f[B>>2]|0))break;P=U;O=X;Q=W;R=V;S=f[G>>2]|0;T=f[I>>2]|0}T=f[G>>2]|0;S=f[r>>2]|0;R=S;Q=T;if((T|0)!=(S|0)){O=i+4|0;P=+n[R>>2];_=mrc(+(V|0)*P)|0;if((_|0)>(f[j>>2]|0)){$=G;aa=R;ba=Q;ca=T;da=S;ea=R;fa=R}else{Z=0;ga=R;ha=T;T=S;ia=R;ja=Q;ka=R;la=R;ma=mrc(P*+(W|0))|0;na=_;U=P;while(1){if((ma|0)>(f[z>>2]|0)){$=G;aa=ia;ba=ja;ca=ha;da=T;ea=la;fa=ka;break a}do if((na|0)>=(f[i>>2]|0)?(ma|0)>=(f[O>>2]|0):0){_=f[H>>2]|0;if((_|0)==(f[M>>2]|0)){osb(s,ga);oa=f[G>>2]|0;pa=f[r>>2]|0;qa=pa;ra=pa;sa=oa;ta=qa;ua=qa;va=oa;wa=qa;break}else{n[_>>2]=U;f[H>>2]=_+4;ra=T;sa=ha;ta=la;ua=ka;va=ja;wa=ia;break}}else{ra=T;sa=ha;ta=la;ua=ka;va=ja;wa=ia}while(0);Z=Z+1|0;if(Z>>>0>=sa-ra>>2>>>0){$=G;aa=wa;ba=va;ca=sa;da=ra;ea=ta;fa=ua;break a}_=f[D>>2]|0;ga=ra+(Z<<2)|0;U=+n[ga>>2];na=mrc(+(f[q>>2]|0)*U)|0;ma=mrc(U*+(_|0))|0;if((na|0)>(f[j>>2]|0)){$=G;aa=wa;ba=va;ca=sa;da=ra;ea=ta;fa=ua;break}else{ha=sa;T=ra;ia=wa;ja=va;ka=ua;la=ta}}}}else{$=G;aa=R;ba=Q;ca=S;da=S;ea=R;fa=R}}else{$=G;aa=J;ba=J;ca=K;da=K;ea=J;fa=J}while(0);if(!((aa|0)==(ba|0)?1:(f[s>>2]|0)!=(f[H>>2]|0))){f[m>>2]=0;ba=m+4|0;f[ba>>2]=0;f[m+8>>2]=0;if((ca|0)!=(da|0)){aa=i+4|0;J=m+8|0;K=0;ta=fa;fa=0;ua=0;va=ea;wa=da;da=ca;while(1){h=+n[ta+(K<<2)>>2];ca=mrc(+(f[q>>2]|0)*h)|0;ra=mrc(h*+(f[D>>2]|0))|0;sa=(f[i>>2]|0)-ca|0;ca=Y(sa,sa)|0;sa=(f[aa>>2]|0)-ra|0;h=+((Y(sa,sa)|0)+ca|0);p[t>>3]=h;if((fa|0)==(ua|0)){zOb(m,t);ca=f[r>>2]|0;xa=ca;ya=f[$>>2]|0;za=ca}else{p[fa>>3]=h;f[ba>>2]=fa+8;xa=wa;ya=da;za=va}ca=K+1|0;if(ca>>>0>=ya-xa>>2>>>0)break;K=ca;ta=xa;fa=f[ba>>2]|0;ua=f[J>>2]|0;va=za;wa=xa;da=ya}ya=f[m>>2]|0;da=ya;if((f[ba>>2]|0)==(ya|0)){Aa=0;Ba=za;Ca=da}else{xa=(f[ba>>2]|0)-ya>>3;ya=0;wa=0;while(1){va=+p[da+(wa<<3)>>3]>+p[da+(ya<<3)>>3]?ya:wa;ya=ya+1|0;if(ya>>>0>=xa>>>0){Aa=va;Ba=za;Ca=da;break}else wa=va}}}else{Aa=0;Ba=ea;Ca=0}ea=Ba+(Aa<<2)|0;Aa=f[H>>2]|0;if((Aa|0)==(f[M>>2]|0)){osb(s,ea);Da=f[m>>2]|0}else{f[Aa>>2]=f[ea>>2];f[H>>2]=Aa+4;Da=Ca}if(Da|0){Ca=f[ba>>2]|0;if((Ca|0)!=(Da|0))f[ba>>2]=Ca+(~((Ca+-8-Da|0)>>>3)<<3);YDc(Da)}}Da=f[d>>2]|0;Ca=d+4|0;ba=f[Ca>>2]|0;if((ba|0)!=(Da|0))f[Ca>>2]=ba+(~((ba+-16-Da|0)>>>4)<<4);Da=f[e>>2]|0;ba=e+4|0;Ca=f[ba>>2]|0;if((Ca|0)!=(Da|0))f[ba>>2]=Ca+(~((Ca+-4-Da|0)>>>2)<<2);Da=f[g>>2]|0;Ca=g+4|0;ba=f[Ca>>2]|0;if((ba|0)!=(Da|0))f[Ca>>2]=ba+(~((ba+-8-Da|0)>>>3)<<3);f[t>>2]=1124007936;Da=t+4|0;ba=t+8|0;Ca=t+40|0;Aa=Da;ea=Aa+36|0;do{f[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(ea|0));f[Ca>>2]=ba;M=t+48|0;Ba=t+44|0;f[Ba>>2]=M;f[M>>2]=0;f[t+52>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;do if((q$(c,-1)|0)<=1){if((d$(c)|0)!=65536){wa=m+8|0;f[wa>>2]=0;f[wa+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=t;t$(c,m);break}do if((d$(c)|0)==65536){wa=f[c+4>>2]|0;f[m>>2]=f[wa>>2];da=m+4|0;za=wa+4|0;f[da>>2]=f[za>>2];xa=m+8|0;f[xa>>2]=f[wa+8>>2];f[m+12>>2]=f[wa+12>>2];f[m+16>>2]=f[wa+16>>2];f[m+20>>2]=f[wa+20>>2];f[m+24>>2]=f[wa+24>>2];f[m+28>>2]=f[wa+28>>2];f[m+32>>2]=f[wa+32>>2];ya=m+36|0;va=f[wa+36>>2]|0;f[ya>>2]=va;f[m+40>>2]=xa;xa=m+48|0;J=m+44|0;f[J>>2]=xa;f[xa>>2]=0;f[m+52>>2]=0;if(va|0){xa=va+12|0;f[xa>>2]=(f[xa>>2]|0)+1}if((f[za>>2]|0)<3){za=f[wa+44>>2]|0;xa=f[J>>2]|0;f[xa>>2]=f[za>>2];f[xa+4>>2]=f[za+4>>2];Ea=ya;break}else{f[da>>2]=0;ZS(m,wa);Ea=ya;break}}else{a$(m,c,-1);Ea=m+36|0}while(0);R=f[Ea>>2]|0;if(R|0){S=R+12|0;f[S>>2]=(f[S>>2]|0)+1}S=t+36|0;R=f[S>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)_S(t);f[S>>2]=0;R=t+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Da>>2]|0)>0){Q=f[Ca>>2]|0;ya=0;do{f[Q+(ya<<2)>>2]=0;ya=ya+1|0;Fa=f[Da>>2]|0}while((ya|0)<(Fa|0));f[t>>2]=f[m>>2];if((Fa|0)<3)Ga=71;else Ga=73}else{f[t>>2]=f[m>>2];Ga=71}if((Ga|0)==71){ya=f[m+4>>2]|0;if((ya|0)<3){f[Da>>2]=ya;f[ba>>2]=f[m+8>>2];f[t+12>>2]=f[m+12>>2];ya=f[m+44>>2]|0;Q=f[Ba>>2]|0;f[Q>>2]=f[ya>>2];f[Q+4>>2]=f[ya+4>>2]}else Ga=73}if((Ga|0)==73)ZS(t,m);ya=m+16|0;f[R>>2]=f[ya>>2];f[t+20>>2]=f[m+20>>2];f[t+24>>2]=f[m+24>>2];f[t+28>>2]=f[m+28>>2];f[t+32>>2]=f[m+32>>2];Q=f[Ea>>2]|0;f[S>>2]=Q;if(Q|0?(wa=Q+12|0,Q=f[wa>>2]|0,f[wa>>2]=Q+-1,(Q|0)==1):0)_S(m);f[Ea>>2]=0;Q=m+4|0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[Q>>2]|0)>0){ya=f[m+40>>2]|0;wa=0;do{f[ya+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[Q>>2]|0))}Q=f[m+44>>2]|0;if((Q|0)!=(m+48|0))g0(Q)}else{Q=m+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=t;Oga(c,m,6,0)}while(0);f[v>>2]=16842752;c=v+4|0;f[c>>2]=t;f[v+8>>2]=0;f[v+12>>2]=0;Ea=a+108|0;ba=f[Ea>>2]|0;if(hj[f[(f[ba>>2]|0)+20>>2]&511](ba,v,s)|0){ba=f[Ea>>2]|0;Yi[f[(f[ba>>2]|0)+32>>2]&2047](ba);f[w>>2]=1124007936;ba=w+4|0;Fa=w+8|0;Q=w+40|0;Aa=ba;ea=Aa+36|0;do{f[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(ea|0));f[Q>>2]=Fa;wa=w+48|0;ya=w+44|0;f[ya>>2]=wa;f[wa>>2]=0;f[w+52>>2]=0;S=f[a+124>>2]|0;if(S|0){R=f[(f[S>>2]|0)+8>>2]|0;do if((d$(v)|0)==65536){da=f[c>>2]|0;f[x>>2]=f[da>>2];za=x+4|0;xa=da+4|0;f[za>>2]=f[xa>>2];J=x+8|0;f[J>>2]=f[da+8>>2];f[x+12>>2]=f[da+12>>2];f[x+16>>2]=f[da+16>>2];f[x+20>>2]=f[da+20>>2];f[x+24>>2]=f[da+24>>2];f[x+28>>2]=f[da+28>>2];f[x+32>>2]=f[da+32>>2];va=f[da+36>>2]|0;f[x+36>>2]=va;f[x+40>>2]=J;J=x+48|0;ua=x+44|0;f[ua>>2]=J;f[J>>2]=0;f[x+52>>2]=0;if(va|0){J=va+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[xa>>2]|0)<3){xa=f[da+44>>2]|0;J=f[ua>>2]|0;f[J>>2]=f[xa>>2];f[J+4>>2]=f[xa+4>>2];break}else{f[za>>2]=0;ZS(x,da);break}}else a$(x,v,-1);while(0);Ti[R&511](m,S,x);S=m+36|0;R=f[S>>2]|0;if(R|0){v=R+12|0;f[v>>2]=(f[v>>2]|0)+1}v=w+36|0;R=f[v>>2]|0;if(R|0?(c=R+12|0,R=f[c>>2]|0,f[c>>2]=R+-1,(R|0)==1):0)_S(w);f[v>>2]=0;R=w+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[ba>>2]|0)>0){c=f[Q>>2]|0;da=0;do{f[c+(da<<2)>>2]=0;da=da+1|0;Ha=f[ba>>2]|0}while((da|0)<(Ha|0));f[w>>2]=f[m>>2];if((Ha|0)<3)Ga=103;else Ga=105}else{f[w>>2]=f[m>>2];Ga=103}if((Ga|0)==103){Ha=f[m+4>>2]|0;if((Ha|0)<3){f[ba>>2]=Ha;f[Fa>>2]=f[m+8>>2];f[w+12>>2]=f[m+12>>2];Fa=f[m+44>>2]|0;Ha=f[ya>>2]|0;f[Ha>>2]=f[Fa>>2];f[Ha+4>>2]=f[Fa+4>>2]}else Ga=105}if((Ga|0)==105)ZS(w,m);Ga=m+16|0;f[R>>2]=f[Ga>>2];f[w+20>>2]=f[m+20>>2];f[w+24>>2]=f[m+24>>2];f[w+28>>2]=f[m+28>>2];f[w+32>>2]=f[m+32>>2];R=f[S>>2]|0;f[v>>2]=R;if(R|0?(v=R+12|0,R=f[v>>2]|0,f[v>>2]=R+-1,(R|0)==1):0)_S(m);f[S>>2]=0;S=m+4|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[S>>2]|0)>0){Ga=f[m+40>>2]|0;R=0;do{f[Ga+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[S>>2]|0))}S=f[m+44>>2]|0;if((S|0)!=(m+48|0))g0(S);S=x+36|0;R=f[S>>2]|0;do if(R|0){Ga=R+12|0;v=f[Ga>>2]|0;f[Ga>>2]=v+-1;if((v|0)!=1)break;_S(x)}while(0);f[S>>2]=0;S=x+16|0;R=x+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[R>>2]|0)>0){S=f[x+40>>2]|0;v=0;do{f[S+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[R>>2]|0))}R=f[x+44>>2]|0;if((R|0)!=(x+48|0))g0(R)}R=(f[H>>2]|0)-(f[s>>2]|0)>>2;v=x+8|0;f[x>>2]=v;S=x+4|0;f[S>>2]=R;if(R>>>0>264){Ga=XDc(R>>>0>1073741823?-1:R<<2)|0;f[x>>2]=Ga;Ia=Ga}else Ia=v;Ga=f[(f[Ea>>2]|0)+352>>2]|0;Ea=f[Ga>>2]|0;if(((f[Ga+4>>2]|0)-Ea|0)<=0){f[m>>2]=0;f[m+4>>2]=0;Aa=tT(m,50)|0;Ga=465839;ea=Aa+50|0;do{b[Aa>>0]=b[Ga>>0]|0;Aa=Aa+1|0;Ga=Ga+1|0}while((Aa|0)<(ea|0));z5(-215,m,465890,465903,46)}Ga=Ea;Ea=a+28|0;Aa=(f[Ga+4>>2]|0)-(f[a+24>>2]|0)|0;h=+(((Aa|0)>0?Aa:0)|0)*.03125;Aa=~~h;ea=(+(Aa|0)<h&1)+Aa|0;if(R|0){Aa=ea+-1|0;Fa=0;do{Ha=(f[Ga+(Fa*20|0)+8>>2]|0)-(f[Ea>>2]|0)|0;da=f[Ga+(Fa*20|0)+16>>2]|0;c=(Aa+((((Ha|0)>0?Ha:0)|0)/(da|0)|0)|0)/(ea|0)|0;Ha=Y((c|0)>1?c:1,da)|0;f[Ia+(Fa<<2)>>2]=Ha;Fa=Fa+1|0}while((Fa|0)!=(R|0))}AOb(m,a,R,ea,Ga,Ia,d,e,g,k,w,a+416|0);f[y>>2]=0;f[y+4>>2]=ea;y8(y,m,-1.0);BOb(m);m=f[x>>2]|0;if((m|0)!=(v|0)){if(m|0)ZDc(m);f[x>>2]=v;f[S>>2]=264}S=w+36|0;v=f[S>>2]|0;if(v|0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0)_S(w);f[S>>2]=0;S=w+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[ba>>2]|0)>0){S=f[Q>>2]|0;Q=0;do{f[S+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[ba>>2]|0))}ba=f[ya>>2]|0;if((ba|0)!=(wa|0))g0(ba)}ba=t+36|0;wa=f[ba>>2]|0;if(wa|0?(ya=wa+12|0,wa=f[ya>>2]|0,f[ya>>2]=wa+-1,(wa|0)==1):0)_S(t);f[ba>>2]=0;ba=t+16|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[Da>>2]|0)>0){ba=f[Ca>>2]|0;Ca=0;do{f[ba+(Ca<<2)>>2]=0;Ca=Ca+1|0}while((Ca|0)<(f[Da>>2]|0))}Da=f[Ba>>2]|0;if((Da|0)!=(M|0))g0(Da);Da=f[s>>2]|0;if(Da|0){s=f[H>>2]|0;if((s|0)!=(Da|0))f[H>>2]=s+(~((s+-4-Da|0)>>>2)<<2);YDc(Da)}Da=f[r>>2]|0;if(Da|0){r=f[G>>2]|0;if((r|0)!=(Da|0))f[G>>2]=r+(~((r+-4-Da|0)>>>2)<<2);YDc(Da)}u=l;return}function xOb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;g=u;u=u+112|0;h=g+16|0;i=g+92|0;j=g+8|0;k=g+80|0;l=g+68|0;m=g+56|0;n=g+40|0;o=g+32|0;q=g;r=g+28|0;if((b|0)>=1?(s=a+4|0,(f[a>>2]|0)!=(f[s>>2]|0)):0){f[i>>2]=0;t=i+4|0;f[t>>2]=0;f[i+8>>2]=0;p[j>>3]=c;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];j=yOb(a,i,h)|0;f[h>>2]=0;v=h+4|0;f[v>>2]=0;f[h+8>>2]=0;w=(j|0)==0;do if(!w)if(j>>>0>268435455)mCc(h);else{x=j<<4;y=VDc(x)|0;f[h>>2]=y;f[h+8>>2]=y+(j<<4);XIc(y|0,0,x|0)|0;f[v>>2]=y+x;z=y;break}else z=0;while(0);f[k>>2]=0;y=k+4|0;f[y>>2]=0;f[k+8>>2]=0;if(w)A=0;else{x=j<<2;B=VDc(x)|0;f[k>>2]=B;C=B+(j<<2)|0;f[k+8>>2]=C;XIc(B|0,0,x|0)|0;f[y>>2]=C;A=B}f[l>>2]=0;B=l+4|0;f[B>>2]=0;f[l+8>>2]=0;if(w)D=0;else{C=j<<2;x=VDc(C)|0;f[l>>2]=x;E=x+(j<<2)|0;f[l+8>>2]=E;XIc(x|0,0,C|0)|0;f[B>>2]=E;D=x}f[m>>2]=0;x=m+4|0;f[x>>2]=0;f[m+8>>2]=0;if(w)F=0;else{w=VDc(j<<3)|0;f[x>>2]=w;f[m>>2]=w;E=w+(j<<3)|0;f[m+8>>2]=E;C=j;G=w;while(1){p[G>>3]=2.2250738585072014e-308;C=C+-1|0;if(!C)break;else G=G+8|0}f[x>>2]=E;F=w}w=f[i>>2]|0;E=(f[t>>2]|0)-w|0;G=E>>2;C=(E|0)>0;E=w;if(C){w=f[a>>2]|0;H=0;do{I=f[E+(H<<2)>>2]|0;J=z+(I<<4)|0;f[J>>2]=(f[J>>2]|0)+(f[w+(H<<4)>>2]|0);J=z+(I<<4)+4|0;f[J>>2]=(f[J>>2]|0)+(f[w+(H<<4)+4>>2]|0);J=z+(I<<4)+8|0;f[J>>2]=(f[J>>2]|0)+(f[w+(H<<4)+8>>2]|0);J=z+(I<<4)+12|0;f[J>>2]=(f[J>>2]|0)+(f[w+(H<<4)+12>>2]|0);J=A+(I<<2)|0;f[J>>2]=(f[J>>2]|0)+1;H=H+1|0}while((H|0)<(G|0))}H=(e|0)!=0;w=(d|0)!=0;if(w&H?(J=f[d>>2]|0,(J|0)!=(f[d+4>>2]|0)):0){I=f[e>>2]|0;K=(I|0)==(f[e+4>>2]|0);if(K|C^1){L=K;M=F}else{K=f[m>>2]|0;C=0;do{N=f[E+(C<<2)>>2]|0;O=f[J+(C<<2)>>2]|0;P=D+(N<<2)|0;Q=f[P>>2]|0;if((O|0)<=(Q|0)){if((O|0)==(Q|0)?(R=+p[I+(C<<3)>>3],Q=K+(N<<3)|0,R>+p[Q>>3]):0)p[Q>>3]=R}else{f[P>>2]=O;p[K+(N<<3)>>3]=+p[I+(C<<3)>>3]}C=C+1|0}while((C|0)<(G|0));L=0;M=K}}else{L=1;M=F}F=(j|0)>0;if(F){K=0;do{G=z+(K<<4)|0;C=z+(K<<4)+4|0;I=f[C>>2]|0;J=z+(K<<4)+8|0;E=f[J>>2]|0;N=z+(K<<4)+12|0;O=f[N>>2]|0;R=1.0/+(f[A+(K<<2)>>2]|0);P=mrc(+(f[G>>2]|0)*R)|0;Q=mrc(+(I|0)*R)|0;I=mrc(+(E|0)*R)|0;E=mrc(+(O|0)*R)|0;f[G>>2]=P;f[C>>2]=Q;f[J>>2]=I;f[N>>2]=E;K=K+1|0}while((K|0)!=(j|0))}K=f[a>>2]|0;E=f[s>>2]|0;if((E|0)!=(K|0))f[s>>2]=E+(~((E+-16-K|0)>>>4)<<4);if(w?(K=f[d>>2]|0,E=d+4|0,N=f[E>>2]|0,(N|0)!=(K|0)):0)f[E>>2]=N+(~((N+-4-K|0)>>>2)<<2);if(H?(K=f[e>>2]|0,N=e+4|0,E=f[N>>2]|0,(E|0)!=(K|0)):0)f[N>>2]=E+(~((E+-8-K|0)>>>3)<<3);if(F){F=n+4|0;K=n+8|0;E=n+12|0;N=a+8|0;I=L?o:r;L=d+4|0;J=d+8|0;Q=e+4|0;C=e+8|0;P=f[m>>2]|0;G=f[k>>2]|0;O=f[l>>2]|0;S=0;T=z;z=A;A=D;while(1){D=f[T+(S<<4)>>2]|0;f[n>>2]=D;U=f[T+(S<<4)+4>>2]|0;f[F>>2]=U;V=f[T+(S<<4)+8>>2]|0;f[K>>2]=V;W=f[T+(S<<4)+12>>2]|0;f[E>>2]=W;X=f[z+(S<<2)>>2]|0;f[o>>2]=X;p[q>>3]=+p[P+(S<<3)>>3];f[r>>2]=f[A+(S<<2)>>2];do if((X|0)>(b|0)){Y=f[h>>2]|0;Z=V+D|0;_=W+U|0;$=(X|0)>3?X:3;a:do if((X|0)<3){aa=0;while(1){do if((aa|0)!=(S|0)?(f[z+(aa<<2)>>2]|0)>(b|0):0){ba=f[Y+(aa<<4)>>2]|0;ca=f[Y+(aa<<4)+4>>2]|0;da=f[Y+(aa<<4)+8>>2]|0;ea=f[Y+(aa<<4)+12>>2]|0;fa=nrc(+(da|0)*c)|0;ga=nrc(+(ea|0)*c)|0;if((D|0)<(ba-fa|0)|(U|0)<(ca-ga|0))break;if((Z|0)>(da+ba+fa|0))break;if((_|0)<=(ea+ca+ga|0)){ha=aa;break a}}while(0);ga=aa+1|0;if((ga|0)<(j|0))aa=ga;else{ha=ga;break}}}else{aa=0;while(1){ga=f[z+(aa<<2)>>2]|0;do if((aa|0)!=(S|0)&(ga|0)>(b|0)){ca=f[Y+(aa<<4)>>2]|0;ea=f[Y+(aa<<4)+4>>2]|0;fa=f[Y+(aa<<4)+8>>2]|0;ba=f[Y+(aa<<4)+12>>2]|0;da=nrc(+(fa|0)*c)|0;ia=nrc(+(ba|0)*c)|0;if((D|0)<(ca-da|0)|(U|0)<(ea-ia|0))break;if((Z|0)>(fa+ca+da|0))break;if((ga|0)>($|0)?(_|0)<=(ba+ea+ia|0):0){ha=aa;break a}}while(0);ga=aa+1|0;if((ga|0)<(j|0))aa=ga;else{ha=ga;break}}}while(0);if((ha|0)==(j|0)){_=f[s>>2]|0;if((_|0)==(f[N>>2]|0))$Lb(a,n);else{f[_>>2]=D;f[_+4>>2]=U;f[_+8>>2]=V;f[_+12>>2]=W;f[s>>2]=_+16}do if(w){_=f[L>>2]|0;if((_|0)==(f[J>>2]|0)){g6(d,I);break}else{f[_>>2]=f[I>>2];f[L>>2]=_+4;break}}while(0);if(!H)break;_=f[Q>>2]|0;if((_|0)==(f[C>>2]|0)){zOb(e,q);break}else{p[_>>3]=+p[q>>3];f[Q>>2]=_+8;break}}}while(0);W=S+1|0;if((W|0)>=(j|0))break;S=W;T=f[h>>2]|0;z=G;A=O}ja=f[m>>2]|0}else ja=M;if(ja|0){M=f[x>>2]|0;if((M|0)!=(ja|0))f[x>>2]=M+(~((M+-8-ja|0)>>>3)<<3);YDc(ja)}ja=f[l>>2]|0;if(ja|0){l=f[B>>2]|0;if((l|0)!=(ja|0))f[B>>2]=l+(~((l+-4-ja|0)>>>2)<<2);YDc(ja)}ja=f[k>>2]|0;if(ja|0){k=f[y>>2]|0;if((k|0)!=(ja|0))f[y>>2]=k+(~((k+-4-ja|0)>>>2)<<2);YDc(ja)}ja=f[h>>2]|0;if(ja|0){h=f[v>>2]|0;if((h|0)!=(ja|0))f[v>>2]=h+(~((h+-16-ja|0)>>>4)<<4);YDc(ja)}ja=f[i>>2]|0;if(ja|0){i=f[t>>2]|0;if((i|0)!=(ja|0))f[t>>2]=i+(~((i+-4-ja|0)>>>2)<<2);YDc(ja)}u=g;return}if((d|0)==0|(e|0)!=0){u=g;return}e=(f[a+4>>2]|0)-(f[a>>2]|0)>>4;a=d+4|0;ja=f[a>>2]|0;i=f[d>>2]|0;t=ja-i>>2;h=i;i=ja;if(e>>>0<=t>>>0){if(e>>>0<t>>>0?(ja=h+(e<<2)|0,(i|0)!=(ja|0)):0)f[a>>2]=i+(~((i+-4-ja|0)>>>2)<<2);if(!e){u=g;return}}else lN(d,e-t|0);t=f[d>>2]|0;d=0;do{f[t+(d<<2)>>2]=1;d=d+1|0}while((d|0)!=(e|0));u=g;return}function yOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+32|0;g=e+8|0;h=e;i=f[a>>2]|0;j=(f[a+4>>2]|0)-i|0;a=j>>4;k=i;i=j>>3;f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;do if(i)if(i>>>0>1073741823)mCc(g);else{m=j>>1;n=VDc(m)|0;f[g>>2]=n;o=n+(i<<2)|0;f[g+8>>2]=o;XIc(n|0,0,m|0)|0;f[l>>2]=o;q=n;break}else q=0;while(0);i=(j|0)>0;a:do if(i){j=0;do{f[q+(j<<3)>>2]=-1;f[q+(j<<3)+4>>2]=0;j=j+1|0}while((j|0)<(a|0));if(i){j=0;b:while(1){n=j;while(1){o=f[q+(n<<3)>>2]|0;if((o|0)>-1)n=o;else break}o=k+(j<<4)+8|0;m=k+(j<<4)+12|0;r=k+(j<<4)|0;s=k+(j<<4)+4|0;t=q+(j<<3)|0;v=0;w=n;while(1){if(((((j|0)!=(v|0)?(x=f[k+(v<<4)+8>>2]|0,y=f[o>>2]|0,z=f[k+(v<<4)+12>>2]|0,A=f[m>>2]|0,B=+p[d>>3]*+(((A|0)>(z|0)?z:A)+((y|0)>(x|0)?x:y)|0)*.5,C=f[r>>2]|0,D=f[k+(v<<4)>>2]|0,E=C-D|0,+(((E|0)>-1?E:0-E|0)|0)<=B):0)?(E=f[s>>2]|0,F=f[k+(v<<4)+4>>2]|0,G=E-F|0,+(((G|0)>-1?G:0-G|0)|0)<=B):0)?(G=y-x+C-D|0,+(((G|0)>-1?G:0-G|0)|0)<=B):0)?(G=A-z+E-F|0,+(((G|0)>-1?G:0-G|0)|0)<=B):0){G=v;while(1){H=q+(G<<3)|0;F=f[H>>2]|0;if((F|0)>-1)G=F;else break}if((G|0)!=(w|0)){F=f[q+(w<<3)+4>>2]|0;E=q+(G<<3)+4|0;z=f[E>>2]|0;if((F|0)>(z|0)){f[H>>2]=w;I=w}else{f[q+(w<<3)>>2]=G;f[E>>2]=((F|0)==(z|0)&1)+z;I=G}if((f[q+(I<<3)>>2]|0)>=0)break b;z=q+(v<<3)|0;F=f[z>>2]|0;if((F|0)>-1){E=F;F=z;do{f[F>>2]=I;F=q+(E<<3)|0;E=f[F>>2]|0}while((E|0)>-1)}E=f[t>>2]|0;if((E|0)>-1){F=t;G=E;do{f[F>>2]=I;F=q+(G<<3)|0;G=f[F>>2]|0}while((G|0)>-1);J=I}else J=I}else J=w}else J=w;v=v+1|0;if((v|0)>=(a|0))break;else w=J}j=j+1|0;if((j|0)>=(a|0))break a}f[h>>2]=0;f[h+4>>2]=0;j=tT(h,23)|0;w=466725;v=j+23|0;do{b[j>>0]=b[w>>0]|0;j=j+1|0;w=w+1|0}while((j|0)<(v|0));z5(-215,h,466749,466759,512)}}while(0);h=c+4|0;J=f[h>>2]|0;I=f[c>>2]|0;H=J-I>>2;k=I;I=J;if(a>>>0<=H>>>0){if(a>>>0<H>>>0?(J=k+(a<<2)|0,(I|0)!=(J|0)):0)f[h>>2]=I+(~((I+-4-J|0)>>>2)<<2)}else lN(c,a-H|0);if(i){i=f[c>>2]|0;c=0;H=0;while(1){J=H;while(1){I=f[q+(J<<3)>>2]|0;if((I|0)>-1)J=I;else break}I=q+(J<<3)+4|0;h=f[I>>2]|0;if((h|0)>-1){k=~c;f[I>>2]=k;K=c+1|0;L=k}else{K=c;L=h}f[i+(H<<2)>>2]=~L;H=H+1|0;if((H|0)>=(a|0)){M=K;break}else c=K}}else M=0;K=f[g>>2]|0;if(!K){u=e;return M|0}g=f[l>>2]|0;if((g|0)!=(K|0))f[l>>2]=g+(~((g+-4-K|0)>>>2)<<2);YDc(K);u=e;return M|0}function zOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;p[k>>3]=+p[b>>3];b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function AOb(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f[a>>2]=137560;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;n=a+48|0;f[n>>2]=1124007936;o=a+52|0;p=a+56|0;q=a+88|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=a+96|0;s=a+92|0;f[s>>2]=r;f[r>>2]=0;f[a+100>>2]=0;f[a+4>>2]=b;f[a+12>>2]=c;f[a+16>>2]=d;f[a+20>>2]=e;f[a+24>>2]=g;f[a+8>>2]=h;f[a+28>>2]=k?i:0;f[a+32>>2]=k?j:0;if((n|0)==(l|0)){t=a+104|0;f[t>>2]=m;return}j=l+36|0;k=f[j>>2]|0;if(k){i=k+12|0;f[i>>2]=(f[i>>2]|0)+1;i=a+84|0;k=f[i>>2]|0;if((k|0)!=0?(h=k+12|0,k=f[h>>2]|0,f[h>>2]=k+-1,(k|0)==1):0){_S(n);u=i}else u=i}else u=a+84|0;f[u>>2]=0;i=a+64|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[o>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0;v=f[o>>2]|0}while((q|0)<(v|0));f[n>>2]=f[l>>2];if((v|0)<3)w=12;else w=14}else{f[n>>2]=f[l>>2];w=12}if((w|0)==12){v=f[l+4>>2]|0;if((v|0)<3){f[o>>2]=v;f[p>>2]=f[l+8>>2];f[a+60>>2]=f[l+12>>2];p=f[l+44>>2]|0;v=f[s>>2]|0;f[v>>2]=f[p>>2];f[v+4>>2]=f[p+4>>2]}else w=14}if((w|0)==14)ZS(n,l);f[i>>2]=f[l+16>>2];f[a+68>>2]=f[l+20>>2];f[a+72>>2]=f[l+24>>2];f[a+76>>2]=f[l+28>>2];f[a+80>>2]=f[l+32>>2];f[u>>2]=f[j>>2];t=a+104|0;f[t>>2]=m;return}function BOb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137560;b=a+48|0;c=a+84|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+64|0;b=a+52|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+88>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+92>>2]|0;if((b|0)!=(a+96|0))g0(b);b=f[a+36>>2]|0;if(!b)return;d=a+40|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function COb(a){a=a|0;BOb(a);YDc(a);return}function DOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;c=u;u=u+48|0;d=c+32|0;e=c;g=c+8|0;h=c+16|0;i=a+4|0;j=f[(f[i>>2]|0)+108>>2]|0;mi[f[(f[j>>2]|0)+12>>2]&2047](d,j);p[e>>3]=0.0;j=f[i>>2]|0;k=f[j+24>>2]|0;l=f[j+28>>2]|0;j=a+12|0;m=f[j>>2]|0;if((m|0)>0){o=a+20|0;q=a+24|0;r=b+4|0;s=+(k|0);t=+(l|0);v=g+4|0;w=a+28|0;x=a+104|0;y=a+8|0;z=h+4|0;A=h+8|0;B=h+12|0;C=h+4|0;D=h+8|0;E=h+12|0;F=a+32|0;a=0;G=m;while(1){m=f[o>>2]|0;H=+n[m+(a*20|0)>>2];I=f[m+(a*20|0)+16>>2]|0;J=f[(f[q>>2]|0)+(a<<2)>>2]|0;K=Y(f[b>>2]|0,J)|0;L=(f[m+(a*20|0)+4>>2]|0)-k|0;M=(L|0)>0;N=M?L:0;L=(f[m+(a*20|0)+8>>2]|0)-l|0;m=(L|0)>0?L:0;L=Y(f[r>>2]|0,J)|0;J=(m|0)<(L|0)?m:L;L=mrc(s*H)|0;m=mrc(t*H)|0;if((K|0)<(J|0)){O=K;do{if(M){P=H*+(O|0);K=0;do{Q=f[i>>2]|0;f[g>>2]=K;f[v>>2]=O;R=EOb(Q,d,g,a,e)|0;if(!(f[w>>2]|0))if((R|0)>0){m6(f[x>>2]|0);Q=f[y>>2]|0;S=mrc(H*+(K|0))|0;T=mrc(P)|0;f[h>>2]=S;f[z>>2]=T;f[A>>2]=L;f[B>>2]=m;U=Q+4|0;V=f[U>>2]|0;if((V|0)==(f[Q+8>>2]|0))$Lb(Q,h);else{f[V>>2]=S;f[V+4>>2]=T;f[V+8>>2]=L;f[V+12>>2]=m;f[U>>2]=V+16}n6(f[x>>2]|0);W=R}else W=R;else{V=f[i>>2]|0;if((R|0)==1){U=f[V+36>>2]|0;T=f[V+32>>2]|0;X=(U-T|0)/-12|0;Z=T;_=U}else{X=R;Z=f[V+32>>2]|0;_=f[V+36>>2]|0}V=(_-Z|0)/12|0;if((V|0)==(0-X|0)){m6(f[x>>2]|0);R=f[y>>2]|0;U=mrc(H*+(K|0))|0;T=mrc(P)|0;f[h>>2]=U;f[C>>2]=T;f[D>>2]=L;f[E>>2]=m;S=R+4|0;Q=f[S>>2]|0;if((Q|0)==(f[R+8>>2]|0))$Lb(R,h);else{f[Q>>2]=U;f[Q+4>>2]=T;f[Q+8>>2]=L;f[Q+12>>2]=m;f[S>>2]=Q+16}Q=f[w>>2]|0;f[h>>2]=V;S=Q+4|0;T=f[S>>2]|0;if((T|0)==(f[Q+8>>2]|0))g6(Q,h);else{f[T>>2]=V;f[S>>2]=T+4}T=f[F>>2]|0;S=T+4|0;V=f[S>>2]|0;if((V|0)==(f[T+8>>2]|0))zOb(T,e);else{p[V>>3]=+p[e>>3];f[S>>2]=V+8}n6(f[x>>2]|0);W=X}else W=X}K=K+I+((W|0)==0?I:0)|0}while((K|0)<(N|0))}O=O+I|0}while((O|0)<(J|0));$=f[j>>2]|0}else $=G;a=a+1|0;if((a|0)>=($|0))break;else G=$}}$=f[d>>2]|0;if(!$){u=c;return}d=$+4|0;G=f[d>>2]|0;f[d>>2]=G+-1;if((G|0)!=1){u=c;return}Yi[f[(f[$>>2]|0)+8>>2]&2047]($);u=c;return}function EOb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0.0,E=0;g=u;u=u+16|0;h=g;i=b+4|0;j=f[i>>2]|0;k=f[(f[j>>2]|0)+24>>2]|0;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];if(!(hj[k&511](j,h,d)|0)){l=-1;u=g;return l|0}d=f[a+8>>2]|0;h=(d|0)==0;if((f[a+20>>2]|0)==1){if(h){l=FOb(a,b,e)|0;u=g;return l|0}if((d|0)!=1){l=-2;u=g;return l|0}l=GOb(a,b,e)|0;u=g;return l|0}if(!h){if((d|0)!=1){l=-2;u=g;return l|0}l=HOb(a,b,e)|0;u=g;return l|0}b=f[a+32>>2]|0;d=(f[a+36>>2]|0)-b|0;h=(d|0)/12|0;j=f[i>>2]|0;i=f[a+68>>2]|0;k=f[a+56>>2]|0;c=f[a+44>>2]|0;a=b;if((d|0)>0){m=0;o=0;q=0}else{l=1;u=g;return l|0}while(1){d=f[a+(q*12|0)+4>>2]|0;p[e>>3]=0.0;if((d|0)>0){b=a+(q*12|0)|0;r=0;s=m;t=o;while(1){v=f[b>>2]|0;w=0;do{x=w+s|0;y=+ENb(j,f[k+(x<<4)>>2]|0);w=f[(y<+n[k+(x<<4)+4>>2]?k+(x<<4)+8|0:k+(x<<4)+12|0)>>2]|0}while((w|0)>0);y=+p[e>>3]+ +n[i+(t-w<<2)>>2];p[e>>3]=y;x=f[c+(v+r<<2)>>2]|0;z=x+s|0;A=t+1+x|0;r=r+1|0;if((r|0)==(d|0)){B=z;C=A;D=y;break}else{s=z;t=A}}}else{B=m;C=o;D=0.0}if(D<+n[a+(q*12|0)+8>>2]){l=0-q|0;E=18;break}q=q+1|0;if((q|0)>=(h|0)){l=1;E=18;break}else{m=B;o=C}}if((E|0)==18){u=g;return l|0}return 0}function FOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0;e=u;u=u+16|0;g=e;h=f[a+92>>2]|0;if((h|0)==(f[a+96>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,28)|0;j=466845;k=i+28|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,g,466898,465903,575)}g=f[c+4>>2]|0;c=f[a+32>>2]|0;j=(f[a+36>>2]|0)-c|0;a=(j|0)/12|0;a:do if((j|0)>0){i=h;k=0;while(1){l=f[c+(k*12|0)+4>>2]|0;if((l|0)>0){m=0;o=0.0;while(1){q=+ENb(g,f[i+(m<<4)>>2]|0);r=o+ +n[(q<+n[i+(m<<4)+4>>2]?i+(m<<4)+8|0:i+(m<<4)+12|0)>>2];m=m+1|0;if((m|0)==(l|0)){s=r;break}else o=r}}else s=0.0;if(s<+n[c+(k*12|0)+8>>2])break;m=k+1|0;if((m|0)<(a|0)){i=i+(l<<4)|0;k=m}else{t=s;break a}}p[d>>3]=s;v=0-k|0;u=e;return v|0}else t=0.0;while(0);p[d>>3]=t;v=1;u=e;return v|0}function GOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0;e=u;u=u+16|0;g=e;h=f[a+92>>2]|0;if((h|0)==(f[a+96>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,28)|0;j=466845;k=i+28|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,g,466874,465903,614)}g=f[a+32>>2]|0;j=(f[a+36>>2]|0)-g|0;i=(j|0)/12|0;k=f[c+4>>2]|0;c=((f[a+12>>2]|0)+31|0)/32|0;l=g;a:do if((j|0)>0){g=k+380|0;m=k+384|0;o=f[a+80>>2]|0;q=h;r=0;while(1){s=f[l+(r*12|0)+4>>2]|0;if((s|0)>0){t=f[g>>2]|0;v=f[m>>2]|0;w=0;x=0.0;while(1){y=f[q+(w<<4)>>2]|0;z=f[v+(f[t+(y<<6)+20>>2]<<2)>>2]|0;A=f[v+(f[t+(y<<6)+24>>2]<<2)>>2]|0;B=f[v+(f[t+(y<<6)+36>>2]<<2)>>2]|0;C=f[v+(f[t+(y<<6)+40>>2]<<2)>>2]|0;D=z-A-B+C|0;E=f[v+(f[t+(y<<6)+4>>2]<<2)>>2]|0;F=f[v+(f[t+(y<<6)+16>>2]<<2)>>2]|0;G=f[v+(f[t+(y<<6)+8>>2]<<2)>>2]|0;H=f[v+(f[t+(y<<6)+28>>2]<<2)>>2]|0;I=f[v+(f[t+(y<<6)+44>>2]<<2)>>2]|0;J=f[v+(f[t+(y<<6)+56>>2]<<2)>>2]|0;K=f[v+(f[t+(y<<6)+52>>2]<<2)>>2]|0;L=f[v+(f[t+(y<<6)+32>>2]<<2)>>2]|0;M=o+((Y(w,c)|0)<<2)+((((A-z+E-G|0)>=(D|0)?2:0)|(((f[v+(f[t+(y<<6)>>2]<<2)>>2]|0)+z-E-F|0)>=(D|0)?4:0)|(G-A-(f[v+(f[t+(y<<6)+12>>2]<<2)>>2]|0)+H|0)>=(D|0))<<2)|0;N=x+ +n[(1<<(((C-I-J+(f[v+(f[t+(y<<6)+60>>2]<<2)>>2]|0)|0)>=(D|0)?8:0)|((A-C-H+I|0)>=(D|0)?16:0)|((B-C+J-K|0)>=(D|0)?4:0)|(B-z+F-L|0)>=(D|0)|((K-B+L-(f[v+(f[t+(y<<6)+48>>2]<<2)>>2]|0)|0)>=(D|0)?2:0))&f[M>>2]|0?q+(w<<4)+8|0:q+(w<<4)+12|0)>>2];w=w+1|0;if((w|0)==(s|0)){O=N;break}else x=N}}else O=0.0;if(O<+n[l+(r*12|0)+8>>2])break;o=o+((Y(s,c)|0)<<2)|0;w=r+1|0;if((w|0)>=(i|0)){P=O;break a}else{q=q+(s<<4)|0;r=w}}p[d>>3]=O;Q=0-r|0;u=e;return Q|0}else P=0.0;while(0);p[d>>3]=P;Q=1;u=e;return Q|0}function HOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0.0,U=0;d=f[a+32>>2]|0;e=(f[a+36>>2]|0)-d|0;g=(e|0)/12|0;h=f[b+4>>2]|0;b=((f[a+12>>2]|0)+31|0)/32|0;i=f[a+80>>2]|0;j=f[a+68>>2]|0;k=f[a+56>>2]|0;l=f[a+44>>2]|0;a=d;if((e|0)<=0){m=1;return m|0}e=h+380|0;d=h+384|0;h=0;o=0;q=0;while(1){r=f[a+(q*12|0)+4>>2]|0;if((r|0)>0){s=f[a+(q*12|0)>>2]|0;t=f[e>>2]|0;u=f[d>>2]|0;v=0;w=h;x=o;y=0.0;while(1){z=0;do{A=z+w|0;B=f[k+(A<<4)>>2]|0;C=f[u+(f[t+(B<<6)+20>>2]<<2)>>2]|0;D=f[u+(f[t+(B<<6)+24>>2]<<2)>>2]|0;E=f[u+(f[t+(B<<6)+36>>2]<<2)>>2]|0;F=f[u+(f[t+(B<<6)+40>>2]<<2)>>2]|0;G=C-D-E+F|0;H=f[u+(f[t+(B<<6)+4>>2]<<2)>>2]|0;I=f[u+(f[t+(B<<6)+16>>2]<<2)>>2]|0;J=f[u+(f[t+(B<<6)+8>>2]<<2)>>2]|0;K=f[u+(f[t+(B<<6)+28>>2]<<2)>>2]|0;L=f[u+(f[t+(B<<6)+44>>2]<<2)>>2]|0;M=f[u+(f[t+(B<<6)+56>>2]<<2)>>2]|0;N=f[u+(f[t+(B<<6)+52>>2]<<2)>>2]|0;O=f[u+(f[t+(B<<6)+32>>2]<<2)>>2]|0;P=i+((Y(A,b)|0)<<2)+((((D-C+H-J|0)>=(G|0)?2:0)|(((f[u+(f[t+(B<<6)>>2]<<2)>>2]|0)+C-H-I|0)>=(G|0)?4:0)|(J-D-(f[u+(f[t+(B<<6)+12>>2]<<2)>>2]|0)+K|0)>=(G|0))<<2)|0;z=f[(1<<(((F-L-M+(f[u+(f[t+(B<<6)+60>>2]<<2)>>2]|0)|0)>=(G|0)?8:0)|((D-F-K+L|0)>=(G|0)?16:0)|((E-F+M-N|0)>=(G|0)?4:0)|(E-C+I-O|0)>=(G|0)|((N-E+O-(f[u+(f[t+(B<<6)+48>>2]<<2)>>2]|0)|0)>=(G|0)?2:0))&f[P>>2]|0?k+(A<<4)+8|0:k+(A<<4)+12|0)>>2]|0}while((z|0)>0);Q=y+ +n[j+(x-z<<2)>>2];A=f[l+(s+v<<2)>>2]|0;P=A+w|0;G=x+1+A|0;v=v+1|0;if((v|0)==(r|0)){R=P;S=G;T=Q;break}else{w=P;x=G;y=Q}}}else{R=h;S=o;T=0.0}if(T<+n[a+(q*12|0)+8>>2]){U=0-q|0;break}q=q+1|0;if((q|0)>=(g|0)){U=1;break}else{h=R;o=S}}p[c>>3]=T;m=U;return m|0}function IOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)mCc(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=k+(d*20|0)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(((b|0)/-20|0)*20|0)|0;if((b|0)>0)dJc(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;YDc(d);return}function JOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)mCc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function KOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=(g|0)/12|0;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=((j-k|0)/12|0)>>>0){m=a+4|0;n=((f[m>>2]|0)-k|0)/12|0;o=h>>>0>n>>>0;p=o?b+(n*12|0)|0:c;c=p;n=c-e|0;if(n|0)fJc(k|0,b|0,n|0)|0;e=l+(((n|0)/12|0)*12|0)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(((o>>>0)/12|0)*12|0);return}else{o=f[m>>2]|0;if((o|0)==(e|0))return;f[m>>2]=o+(~(((o+-12-e|0)>>>0)/12|0)*12|0);return}}e=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~(((o+-12-k|0)>>>0)/12|0)*12|0);YDc(e);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>357913941)mCc(a);j=(q|0)/12|0;q=j<<1;e=j>>>0<178956970?(q>>>0<h>>>0?h:q):357913941;if(e>>>0>357913941)mCc(a);q=VDc(e*12|0)|0;h=a+4|0;f[h>>2]=q;f[a>>2]=q;f[i>>2]=q+(e*12|0);if((g|0)<=0)return;dJc(q|0,b|0,g|0)|0;f[h>>2]=q+(((g>>>0)/12|0)*12|0);return}function LOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)fJc(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);YDc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)mCc(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)mCc(a);j=VDc(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;dJc(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function MOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>4;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>4>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>4;o=h>>>0>n>>>0;p=o?b+(n<<4)|0:c;c=p;n=c-e|0;e=n>>4;if(e|0)fJc(k|0,b|0,n|0)|0;n=l+(e<<4)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>4<<4);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-16-n|0)>>>4)<<4);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-16-k|0)>>>4)<<4);YDc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>268435455)mCc(a);j=q>>3;n=q>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;if(n>>>0>268435455)mCc(a);j=VDc(n<<4)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<4);if((g|0)<=0)return;dJc(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>4<<4);return}function NOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>4;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>4>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>4;o=h>>>0>n>>>0;p=o?b+(n<<4)|0:c;c=p;n=c-e|0;e=n>>4;if(e|0)fJc(k|0,b|0,n|0)|0;n=l+(e<<4)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>4<<4);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-16-n|0)>>>4)<<4);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-16-k|0)>>>4)<<4);YDc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>268435455)mCc(a);j=q>>3;n=q>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;if(n>>>0>268435455)mCc(a);j=VDc(n<<4)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<4);if((g|0)<=0)return;dJc(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>4<<4);return}function OOb(a){a=a|0;var b=0,c=0,d=0;b=f[a+88>>2]|0;if(b|0){c=a+92|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);YDc(b)}b=f[a+76>>2]|0;if(b|0){d=a+80|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+64>>2]|0;if(b|0){c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+52>>2]|0;if(b|0){d=a+56|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-16-b|0)>>>4)<<4);YDc(b)}b=f[a+40>>2]|0;if(b|0){c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+28>>2]|0;if(!b)return;d=a+32|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~(((a+-12-b|0)>>>0)/12|0)*12|0);YDc(b);return}function POb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c+8|0;e=c;g=a+224|0;h=a+248|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)HQ(g);g=a+228|0;if((f[g>>2]|0)>0){i=f[a+256>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[h>>2]=0;h=a+272|0;g=a+296|0;j=f[g>>2]|0;if(j|0?(i=j+8|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)HQ(h);h=a+276|0;if((f[h>>2]|0)>0){j=f[a+304>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}f[g>>2]=0;g=a+320|0;h=a+344|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)HQ(g);g=a+324|0;if((f[g>>2]|0)>0){i=f[a+352>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[h>>2]=0;if(!(SOb(a+4|0,b)|0)){k=0;u=c;return k|0}TOb(d,f[a+8>>2]|0);h=a+104|0;g=f[d>>2]|0;j=f[d+4>>2]|0;if(g|0){i=g+4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[h>>2]|0;f[h>>2]=g;g=a+108|0;f[g>>2]=j;if(i|0?(j=i+4|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[d>>2]|0;if(i|0?(h=i+4|0,j=f[h>>2]|0,f[h>>2]=j+-1,(j|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);I_(d,b,467195);if(!(f[d+4>>2]|0))l=0;else{b=f[g>>2]|0;g=f[(f[b>>2]|0)+8>>2]|0;f[e>>2]=f[a+24>>2];f[e+4>>2]=f[a+28>>2];l=hj[g&511](b,d,e)|0}k=l;u=c;return k|0}function QOb(a){a=a|0;YDc(a);return}function ROb(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=f[a+8>>2];yPb(c);if(!a){u=b;return}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);u=b;return}function SOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;d=u;u=u+512|0;e=d+16|0;g=d+480|0;h=d+464|0;i=d+504|0;j=d+496|0;k=d+8|0;l=d+488|0;m=d+420|0;o=d+376|0;p=d;q=d+352|0;r=d+472|0;s=d+292|0;t=d+248|0;v=d+232|0;w=d+216|0;x=d+200|0;y=d+196|0;z=d+152|0;A=d+108|0;B=d+64|0;C=d+368|0;D=d+344|0;E=d+336|0;F=d+60|0;G=d+240|0;H=d+224|0;I=d+208|0;I_(e,c,467204);f[g>>2]=0;f[g+4>>2]=0;$_(e,g,g);J=f[g>>2]|0;if((J|0)!=467214?Ioc((J|0)==0?1154740:J,467214)|0:0){K=0;uT(g);u=d;return K|0}f[a>>2]=0;I_(e,c,467220);f[h>>2]=0;f[h+4>>2]=0;$_(e,h,h);J=f[h>>2]|0;if((J|0)!=467232?(L=(J|0)==0?1154740:J,(Ioc(L,467232)|0)!=0):0)if((J|0)!=467237?(Ioc(L,467237)|0)!=0:0){if((J|0)==467241){M=a+4|0;f[M>>2]=2;f[e>>2]=0;N=e+4|0;f[N>>2]=0;O=tT(e,35)|0;P=O;Q=467245;R=P+35|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));z5(-213,e,471667,465762,1472)}if(!(Ioc(L,467241)|0)){M=a+4|0;f[M>>2]=2;f[e>>2]=0;N=e+4|0;f[N>>2]=0;O=tT(e,35)|0;P=O;Q=467245;R=P+35|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));z5(-213,e,471667,465762,1472)}else S=0}else{T=1;U=10}else{T=0;U=10}if((U|0)==10){f[a+4>>2]=T;I_(i,c,467281);Y_(i,e,0);i=a+20|0;f[i>>2]=f[e>>2];I_(j,c,467287);Y_(j,e,0);j=f[e>>2]|0;f[a+24>>2]=j;if((j|0)<=0){f[e>>2]=0;V=e+4|0;f[V>>2]=0;W=tT(e,47)|0;P=W;Q=467294;R=P+47|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));z5(-215,e,471667,465762,1479)}if((f[i>>2]|0)<=0){f[e>>2]=0;V=e+4|0;f[V>>2]=0;W=tT(e,47)|0;P=W;Q=467294;R=P+47|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));z5(-215,e,471667,465762,1479)}I_(k,c,467342);W=k+4|0;if((f[W>>2]|0)!=0?(I_(l,k,467356),Y_(l,e,0),l=f[e>>2]|0,f[a+8>>2]=l,V=(l+31|0)/32|0,i=(l|0)>0,l=i?V+3|0:4,I_(e,c,467768),c=e,j=f[c>>2]|0,T=f[c+4>>2]|0,c=k,f[c>>2]=j,f[c+4>>2]=T,!(T>>>0<1|(T|0)==1&j>>>0<0)):0){j=a+28|0;UOb(j,M_(k)|0);T=a+40|0;c=f[T>>2]|0;O=a+44|0;N=f[O>>2]|0;if((N|0)!=(c|0))f[O>>2]=N+(~((N+-4-c|0)>>>2)<<2);c=a+52|0;N=f[c>>2]|0;M=a+56|0;L=f[M>>2]|0;if((L|0)!=(N|0))f[M>>2]=L+(~((L+-16-N|0)>>>4)<<4);N=a+88|0;L=f[N>>2]|0;J=a+92|0;X=f[J>>2]|0;if((X|0)!=(L|0))f[J>>2]=X+(~((X+-16-L|0)>>>4)<<4);K_(m,f[k>>2]|0,f[W>>2]|0,0);L=f[k>>2]|0;X=f[W>>2]|0;K_(o,L,X,M_(k)|0);k=a+12|0;f[k>>2]=2147483647;X=a+16|0;f[X>>2]=0;L=m+4|0;W=o+4|0;Z=m+20|0;_=o+20|0;$=m+40|0;aa=o+40|0;ba=p+4|0;ca=q+8|0;da=q+4|0;ea=a+32|0;fa=a+36|0;ga=s+4|0;ha=t+4|0;ia=s+20|0;ja=t+20|0;ka=s+40|0;la=t+40|0;ma=v+4|0;na=w+4|0;oa=x+4|0;pa=a+48|0;qa=a+64|0;ra=a+68|0;sa=a+76|0;ta=a+80|0;ua=z+4|0;va=A+4|0;wa=z+20|0;xa=A+20|0;ya=z+40|0;za=A+40|0;Aa=C+4|0;Ba=B+8|0;Ca=D+4|0;Da=B+12|0;Ea=E+4|0;Fa=a+60|0;Ga=H+4|0;Ha=B+4|0;Ia=G+4|0;Ja=a+84|0;Ka=I+4|0;La=a+72|0;Ma=0;a:while(1){Na=f[m>>2]|0;Oa=Na;if((((Na|0)==(f[o>>2]|0)?(f[L>>2]|0)==(f[W>>2]|0):0)?(f[Z>>2]|0)==(f[_>>2]|0):0)?(f[$>>2]|0)==(f[aa>>2]|0):0){U=71;break}Na=f[Z>>2]|0;f[p>>2]=Oa;f[ba>>2]=Na;I_(r,p,467368);Z_(r,e,0.0);n[ca>>2]=+n[e>>2]+-9.999999747378752e-06;I_(e,p,467383);Na=e;Oa=f[Na>>2]|0;Pa=f[Na+4>>2]|0;Na=p;f[Na>>2]=Oa;f[Na+4>>2]=Pa;if(Pa>>>0<1|(Pa|0)==1&Oa>>>0<0){U=27;break}Oa=M_(p)|0;f[da>>2]=Oa;f[q>>2]=(f[O>>2]|0)-(f[T>>2]|0)>>2;Oa=f[ea>>2]|0;if((Oa|0)==(f[fa>>2]|0))VOb(j,q);else{f[Oa>>2]=f[q>>2];f[Oa+4>>2]=f[q+4>>2];f[Oa+8>>2]=f[q+8>>2];f[ea>>2]=(f[ea>>2]|0)+12}Oa=f[j>>2]|0;WOb(T,(f[Oa+(Ma*12|0)+4>>2]|0)+(f[Oa+(Ma*12|0)>>2]|0)|0);K_(s,f[p>>2]|0,f[ba>>2]|0,0);Oa=f[p>>2]|0;Pa=f[ba>>2]|0;K_(t,Oa,Pa,M_(p)|0);while(1){Pa=f[s>>2]|0;Oa=Pa;if((((Pa|0)==(f[t>>2]|0)?(f[ga>>2]|0)==(f[ha>>2]|0):0)?(f[ia>>2]|0)==(f[ja>>2]|0):0)?(f[ka>>2]|0)==(f[la>>2]|0):0)break;Pa=f[ia>>2]|0;f[v>>2]=Oa;f[ma>>2]=Pa;I_(w,v,467399);I_(x,v,467413);if((f[na>>2]|0)==0|(f[oa>>2]|0)==0){U=69;break a}Pa=(M_(w)|0)/(l|0)|0;f[y>>2]=Pa;Oa=f[k>>2]|0;f[k>>2]=(Pa|0)<(Oa|0)?Pa:Oa;Oa=f[X>>2]|0;f[X>>2]=(Oa|0)<(Pa|0)?Pa:Oa;Oa=f[O>>2]|0;if((Oa|0)==(f[pa>>2]|0))XOb(T,y);else{f[Oa>>2]=Pa;f[O>>2]=Oa+4}YOb(c,((f[M>>2]|0)-(f[c>>2]|0)>>4)+(f[y>>2]|0)|0);Oa=f[ra>>2]|0;Pa=f[qa>>2]|0;nsb(qa,(Oa-Pa>>2)+(M_(x)|0)|0);if(i)aIa(sa,((f[ta>>2]|0)-(f[sa>>2]|0)>>2)+(Y(f[y>>2]|0,V)|0)|0);K_(z,f[w>>2]|0,f[na>>2]|0,0);Pa=f[w>>2]|0;Oa=f[na>>2]|0;K_(A,Pa,Oa,M_(w)|0);b:while(1){Oa=f[z>>2]|0;Pa=Oa;do if((Oa|0)==(f[A>>2]|0)){if((f[ua>>2]|0)!=(f[va>>2]|0))break;if((f[wa>>2]|0)!=(f[xa>>2]|0))break;if((f[ya>>2]|0)==(f[za>>2]|0))break b}while(0);Oa=f[wa>>2]|0;f[C>>2]=Pa;f[Aa>>2]=Oa;Y_(C,e,0);f[Ba>>2]=f[e>>2];N_(z)|0;Oa=f[wa>>2]|0;f[D>>2]=f[z>>2];f[Ca>>2]=Oa;Y_(D,e,0);f[Da>>2]=f[e>>2];N_(z)|0;Oa=f[wa>>2]|0;f[E>>2]=f[z>>2];f[Ea>>2]=Oa;Y_(E,e,0);f[B>>2]=f[e>>2];N_(z)|0;if(i){Oa=0;while(1){if((Oa|0)>=(V|0))break;Na=f[wa>>2]|0;f[G>>2]=f[z>>2];f[Ia>>2]=Na;Y_(G,e,0);Na=f[e>>2]|0;f[F>>2]=Na;Qa=f[ta>>2]|0;if((Qa|0)==(f[Ja>>2]|0))g6(sa,F);else{f[Qa>>2]=Na;f[ta>>2]=Qa+4}N_(z)|0;Oa=Oa+1|0}n[Ha>>2]=0.0}else{Oa=f[wa>>2]|0;f[H>>2]=f[z>>2];f[Ga>>2]=Oa;Z_(H,e,0.0);f[Ha>>2]=f[e>>2];N_(z)|0}Oa=f[M>>2]|0;if((Oa|0)==(f[Fa>>2]|0))ZOb(c,B);else{f[Oa>>2]=f[B>>2];f[Oa+4>>2]=f[B+4>>2];f[Oa+8>>2]=f[B+8>>2];f[Oa+12>>2]=f[B+12>>2];f[M>>2]=(f[M>>2]|0)+16}}K_(e,f[x>>2]|0,f[oa>>2]|0,0);P=z;Q=e;R=P+44|0;do{f[P>>2]=f[Q>>2];P=P+4|0;Q=Q+4|0}while((P|0)<(R|0));Oa=f[x>>2]|0;Pa=f[oa>>2]|0;K_(B,Oa,Pa,M_(x)|0);P=A;Q=B;R=P+44|0;do{f[P>>2]=f[Q>>2];P=P+4|0;Q=Q+4|0}while((P|0)<(R|0));c:while(1){Pa=f[z>>2]|0;Oa=Pa;do if((Pa|0)==(f[A>>2]|0)){if((f[ua>>2]|0)!=(f[va>>2]|0))break;if((f[wa>>2]|0)!=(f[xa>>2]|0))break;if((f[ya>>2]|0)==(f[za>>2]|0))break c}while(0);Pa=f[wa>>2]|0;f[I>>2]=Oa;f[Ka>>2]=Pa;Z_(I,e,0.0);Pa=f[e>>2]|0;f[B>>2]=Pa;Qa=f[ra>>2]|0;if((Qa|0)==(f[La>>2]|0))osb(qa,B);else{f[Qa>>2]=Pa;f[ra>>2]=Qa+4}N_(z)|0}N_(s)|0}N_(m)|0;Ma=Ma+1|0}d:do if((U|0)==27)Ra=0;else if((U|0)==69)Ra=0;else if((U|0)==71)if((f[X>>2]|0)==1?(Ma=f[j>>2]|0,m=(f[ea>>2]|0)-Ma|0,s=(m|0)/12|0,(m|0)!=0):0){m=a+64|0;z=e+4|0;ra=e+8|0;B=e+12|0;qa=a+96|0;La=0;I=0;Ka=0;wa=Ma;while(1){Ma=f[wa+(La*12|0)+4>>2]|0;if((Ma|0)>0){za=0;ya=I;xa=Ka;while(1){va=f[c>>2]|0;ua=f[va+(xa<<4)+4>>2]|0;A=f[m>>2]|0;Q=f[A+(ya<<2)>>2]|0;P=f[A+(ya+1<<2)>>2]|0;f[e>>2]=f[va+(xa<<4)>>2];f[z>>2]=ua;f[ra>>2]=Q;f[B>>2]=P;P=f[J>>2]|0;if((P|0)==(f[qa>>2]|0))_Ob(N,e);else{f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];f[J>>2]=(f[J>>2]|0)+16}za=za+1|0;P=xa+1|0;Q=ya+2|0;if((za|0)>=(Ma|0)){Sa=Q;Ta=P;break}else{ya=Q;xa=P}}}else{Sa=I;Ta=Ka}xa=La+1|0;if(xa>>>0>=s>>>0){Ra=1;break d}La=xa;I=Sa;Ka=Ta;wa=f[j>>2]|0}}else Ra=1;while(0);Ua=Ra}else Ua=0;S=Ua}uT(h);K=S;uT(g);u=d;return K|0}function TOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;switch(c|0){case 0:{c=VDc(436)|0;d=c+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[c+44>>2]=1124007936;d=c+52|0;e=c+84|0;g=c+48|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=c+92|0;f[c+88>>2]=d;f[d>>2]=0;f[c+96>>2]=0;f[c+100>>2]=1124007936;d=c+108|0;e=c+140|0;g=c+104|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=c+148|0;f[c+144>>2]=d;f[d>>2]=0;f[c+152>>2]=0;f[c+156>>2]=1124007936;d=c+160|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+188>>2]=c+164;d=c+196|0;f[c+192>>2]=d;f[c+200>>2]=0;f[d>>2]=0;f[c+204>>2]=1124007936;d=c+208|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+236>>2]=c+212;d=c+244|0;f[c+240>>2]=d;f[c+248>>2]=0;f[d>>2]=0;f[c+252>>2]=1124007936;d=c+256|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+284>>2]=c+260;d=c+292|0;f[c+288>>2]=d;f[c+296>>2]=0;f[d>>2]=0;f[c+300>>2]=1124007936;d=c+304|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+332>>2]=c+308;d=c+340|0;f[c+336>>2]=d;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[c>>2]=137240;d=c+356|0;e=c+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;g=c+392|0;h=g+40|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=4;f[c+28>>2]=2;f[c+32>>2]=0;f[c+36>>2]=0;f[c+40>>2]=0;f[c+384>>2]=0;f[c+388>>2]=0;n[c+432>>2]=0.0;b[c+380>>0]=0;e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=137300;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;return}case 1:{c=VDc(388)|0;_Nb(c);e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=137420;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;return}default:{f[a>>2]=0;f[a+4>>2]=0;return}}}function UOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[a>>2]|0;if((((f[c>>2]|0)-d|0)/12|0)>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>357913941){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=VDc(b*12|0)|0;i=h+(((g|0)/12|0)*12|0)|0;j=i+(((g|0)/-12|0)*12|0)|0;if((g|0)>0)dJc(j|0,d|0,g|0)|0;f[a>>2]=j;f[e>>2]=i;f[c>>2]=h+(b*12|0);if(!d)return;YDc(d);return}function VOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)mCc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;YDc(d);return}function WOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>2;i=VDc(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;YDc(d);return}function XOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function YOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>4;i=VDc(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;YDc(d);return}function ZOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;YDc(d);return}function _Ob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;YDc(d);return}function $Ob(a,b,c){a=a|0;b=b|0;c=+c;xOb(a,b,c,0,0);return}function aPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;xOb(a,c,d,b,0);return}function bPb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;xOb(a,d,e,b,c);return}function cPb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0;g=u;u=u+176|0;h=g+164|0;i=g+152|0;j=g+140|0;k=g+128|0;l=g+88|0;m=g;n=g+112|0;o=f[e>>2]|0;q=f[e+4>>2]|0;e=a+4|0;r=f[e>>2]|0;s=f[a>>2]|0;t=r-s|0;v=t>>4;f[h>>2]=0;w=h+4|0;f[w>>2]=0;f[h+8>>2]=0;x=(v|0)==0;y=s;z=r;do if(!x)if(v>>>0>178956970)mCc(h);else{r=v*24|0;A=VDc(r)|0;f[h>>2]=A;f[h+8>>2]=A+(v*24|0);XIc(A|0,0,r|0)|0;f[w>>2]=A+r;B=A;break}else B=0;while(0);f[i>>2]=0;A=i+4|0;f[A>>2]=0;f[i+8>>2]=0;f[j>>2]=0;r=j+4|0;f[r>>2]=0;f[j+8>>2]=0;if(x)C=0;else{x=t>>1;D=VDc(x)|0;f[j>>2]=D;E=D+(v<<3)|0;f[j+8>>2]=E;XIc(D|0,0,x|0)|0;f[r>>2]=E;C=D}f[k>>2]=0;D=k+4|0;f[D>>2]=0;f[k+8>>2]=0;if((t|0)>0){t=f[b>>2]|0;E=f[c>>2]|0;c=0;do{p[C+(c<<3)>>3]=+p[t+(c<<3)>>3];x=(f[y+(c<<4)+12>>2]|0)+(f[y+(c<<4)+4>>2]<<1)|0;F=nrc(+((f[y+(c<<4)+8>>2]|0)+(f[y+(c<<4)>>2]<<1)|0)*.5)|0;G=+(nrc(+(x|0)*.5)|0);H=+W(+(+p[E+(c<<3)>>3]));p[B+(c*24|0)>>3]=+(F|0);p[B+(c*24|0)+8>>3]=G;p[B+(c*24|0)+16>>3]=H;c=c+1|0}while((c|0)<(v|0))}if((z|0)!=(y|0))f[e>>2]=z+(~((z+-16-s|0)>>>4)<<4);s=f[b>>2]|0;z=b+4|0;y=f[z>>2]|0;if((y|0)!=(s|0))f[z>>2]=y+(~((y+-8-s|0)>>>3)<<3);p[l>>3]=8.0;p[l+8>>3]=16.0;p[l+16>>3]=.26236426446749106;dPb(m,l,h,j,1.0e-05,100);ePb(m,i,k,1.0);l=f[i>>2]|0;if((f[A>>2]|0)!=(l|0)){s=n+4|0;y=n+8|0;v=n+12|0;c=a+8|0;B=b+8|0;H=+(o|0);G=+(q|0);q=0;o=l;do{l=o;I=+V(+(+p[l+(q*24|0)+16>>3]));E=~~(H*I);t=~~(G*I);C=~~(+p[l+(q*24|0)>>3]-+((E|0)/2|0|0));F=~~(+p[l+(q*24|0)+8>>3]-+((t|0)/2|0|0));f[n>>2]=C;f[s>>2]=F;f[y>>2]=E;f[v>>2]=t;l=f[k>>2]|0;do if(+p[l+(q<<3)>>3]>d){x=f[e>>2]|0;if((x|0)==(f[c>>2]|0)){$Lb(a,n);J=f[k>>2]|0}else{f[x>>2]=C;f[x+4>>2]=F;f[x+8>>2]=E;f[x+12>>2]=t;f[e>>2]=x+16;J=l}x=J+(q<<3)|0;K=f[z>>2]|0;if((K|0)==(f[B>>2]|0)){zOb(b,x);break}else{p[K>>3]=+p[x>>3];f[z>>2]=K+8;break}}while(0);q=q+1|0;o=f[i>>2]|0}while(q>>>0<(((f[A>>2]|0)-o|0)/24|0)>>>0)}o=f[m+64>>2]|0;if(o|0){q=m+68|0;z=f[q>>2]|0;if((z|0)!=(o|0))f[q>>2]=z+(~(((z+-24-o|0)>>>0)/24|0)*24|0);YDc(o)}o=f[m+52>>2]|0;if(o|0){z=m+56|0;q=f[z>>2]|0;if((q|0)!=(o|0))f[z>>2]=q+(~(((q+-24-o|0)>>>0)/24|0)*24|0);YDc(o)}o=f[m+12>>2]|0;if(o|0){q=m+16|0;z=f[q>>2]|0;if((z|0)!=(o|0))f[q>>2]=z+(~((z+-8-o|0)>>>3)<<3);YDc(o)}o=f[m>>2]|0;if(o|0){z=m+4|0;m=f[z>>2]|0;if((m|0)!=(o|0))f[z>>2]=m+(~(((m+-24-o|0)>>>0)/24|0)*24|0);YDc(o)}o=f[k>>2]|0;if(o|0){k=f[D>>2]|0;if((k|0)!=(o|0))f[D>>2]=k+(~((k+-8-o|0)>>>3)<<3);YDc(o)}o=f[j>>2]|0;if(o|0){j=f[r>>2]|0;if((j|0)!=(o|0))f[r>>2]=j+(~((j+-8-o|0)>>>3)<<3);YDc(o)}o=f[i>>2]|0;if(o|0){i=f[A>>2]|0;if((i|0)!=(o|0))f[A>>2]=i+(~(((i+-24-o|0)>>>0)/24|0)*24|0);YDc(o)}o=f[h>>2]|0;if(!o){u=g;return}h=f[w>>2]|0;if((h|0)!=(o|0))f[w>>2]=h+(~(((h+-24-o|0)>>>0)/24|0)*24|0);YDc(o);u=g;return}function dPb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0;h=u;u=u+48|0;i=h+24|0;j=h;k=a+4|0;l=a+12|0;m=a+52|0;n=a+56|0;o=a+64|0;q=a+68|0;r=a;s=r+48|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;p[a+24>>3]=+p[b>>3];r=a+32|0;p[r>>3]=+p[b+8>>3];s=a+40|0;p[s>>3]=+p[b+16>>3];if((l|0)!=(d|0))IHa(l,f[d>>2]|0,f[d+4>>2]|0);if((a|0)==(c|0))t=c+4|0;else{d=c+4|0;hPb(a,f[c>>2]|0,f[d>>2]|0);t=d}d=((f[t>>2]|0)-(f[c>>2]|0)|0)/24|0;c=a+48|0;f[c>>2]=d;t=f[n>>2]|0;l=f[m>>2]|0;b=(t-l|0)/24|0;v=l;l=t;if(d>>>0<=b>>>0)if(d>>>0<b>>>0?(t=v+(d*24|0)|0,(l|0)!=(t|0)):0){f[n>>2]=l+(~(((l+-24-t|0)>>>0)/24|0)*24|0);w=d}else w=d;else{iPb(m,d-b|0);w=f[c>>2]|0}c=f[q>>2]|0;b=f[o>>2]|0;d=(c-b|0)/24|0;t=b;b=c;if(w>>>0<=d>>>0){if(w>>>0<d>>>0?(c=t+(w*24|0)|0,(b|0)!=(c|0)):0)f[q>>2]=b+(~(((b+-24-c|0)>>>0)/24|0)*24|0)}else iPb(o,w-d|0);d=a+76|0;f[d>>2]=g;g=a+80|0;p[g>>3]=e;w=f[a>>2]|0;if((f[k>>2]|0)==(w|0)){u=h;return}c=i+8|0;b=i+16|0;q=i+8|0;t=i+16|0;l=j+8|0;n=j+16|0;v=a+24|0;x=0;y=w;do{jPb(i,a,y+(x*24|0)|0);w=f[m>>2]|0;z=w+(x*24|0)|0;p[z>>3]=+p[i>>3];A=w+(x*24|0)+8|0;p[A>>3]=+p[c>>3];B=w+(x*24|0)+16|0;p[B>>3]=+p[b>>3];e=+p[z>>3];C=+p[A>>3];D=+p[B>>3];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;if((f[d>>2]|0)>0){B=0;E=D;F=e;G=C;do{p[i>>3]=F;p[q>>3]=G;p[t>>3]=E;jPb(j,a,i);F=+p[j>>3];G=+p[l>>3];E=+p[n>>3];H=+p[t>>3];I=+V(+H);J=(+p[i>>3]-F)/(+p[v>>3]*I);K=(+p[q>>3]-G)/(+p[r>>3]*I);I=(H-E)/+p[s>>3];B=B+1|0;if(I*I+(K*K+J*J)<=+p[g>>3])break}while((B|0)<(f[d>>2]|0));L=F;M=G;N=E;O=f[m>>2]|0}else{L=e;M=C;N=D;O=w}B=f[o>>2]|0;p[B+(x*24|0)>>3]=L;p[B+(x*24|0)+8>>3]=M;p[B+(x*24|0)+16>>3]=N;y=f[a>>2]|0;J=+p[y+(x*24|0)+8>>3];K=+p[y+(x*24|0)+16>>3];B=O+(x*24|0)|0;p[B>>3]=+p[B>>3]-+p[y+(x*24|0)>>3];B=O+(x*24|0)+8|0;p[B>>3]=+p[B>>3]-J;B=O+(x*24|0)+16|0;p[B>>3]=+p[B>>3]-K;x=x+1|0}while(x>>>0<(((f[k>>2]|0)-y|0)/24|0)>>>0);u=h;return}function ePb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0;e=a+64|0;g=a+68|0;h=f[e>>2]|0;i=b+4|0;if((f[g>>2]|0)!=(h|0)){j=b+8|0;k=a+24|0;l=a+32|0;m=a+40|0;n=0;o=h;while(1){h=o;q=f[i>>2]|0;r=f[b>>2]|0;s=r;t=q;a:do if((q|0)==(r|0))u=14;else{v=+p[k>>3];w=+p[l>>3];x=+p[m>>3];y=(q-r|0)/24|0;z=+p[h+(n*24|0)>>3];A=+p[h+(n*24|0)+8>>3];B=+p[h+(n*24|0)+16>>3];C=0;while(1){D=+p[s+(C*24|0)+16>>3];E=+V(+D);F=(+p[s+(C*24|0)>>3]-z)/(v*E);G=(+p[s+(C*24|0)+8>>3]-A)/(w*E);E=(D-B)/x;C=C+1|0;if(E*E+(G*G+F*F)<d){H=o;break a}if(C>>>0>=y>>>0){u=14;break}}}while(0);do if((u|0)==14){u=0;s=h+(n*24|0)|0;if((t|0)==(f[j>>2]|0)){fPb(b,s);H=f[e>>2]|0;break}else{p[t>>3]=+p[s>>3];p[t+8>>3]=+p[h+(n*24|0)+8>>3];p[t+16>>3]=+p[h+(n*24|0)+16>>3];f[i>>2]=t+24;H=o;break}}while(0);n=n+1|0;if(n>>>0>=(((f[g>>2]|0)-H|0)/24|0)>>>0)break;else o=H}}H=f[i>>2]|0;o=f[b>>2]|0;g=(H-o|0)/24|0;n=c+4|0;e=f[n>>2]|0;j=f[c>>2]|0;u=e-j>>3;m=j;j=e;e=o;if(g>>>0<=u>>>0)if(g>>>0<u>>>0?(l=m+(g<<3)|0,(j|0)!=(l|0)):0){f[n>>2]=j+(~((j+-8-l|0)>>>3)<<3);I=e;J=H;K=o}else{I=e;J=H;K=o}else{cha(c,g-u|0);u=f[b>>2]|0;I=u;J=f[i>>2]|0;K=u}if((J|0)==(K|0))return;K=0;J=I;do{d=+gPb(a,J+(K*24|0)|0);p[(f[c>>2]|0)+(K<<3)>>3]=d;K=K+1|0;J=f[b>>2]|0}while(K>>>0<(((f[i>>2]|0)-J|0)/24|0)>>>0);return}function fPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/24|0;h=g+1|0;i=e;j=d;if(h>>>0>178956970)mCc(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/24|0;l=k<<1;m=k>>>0<89478485?(l>>>0<h>>>0?h:l):178956970;do if(m)if(m>>>0>178956970){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m*24|0)|0;break}else n=0;while(0);l=n+(g*24|0)|0;h=n+(m*24|0)|0;p[l>>3]=+p[b>>3];p[n+(g*24|0)+8>>3]=+p[b+8>>3];p[n+(g*24|0)+16>>3]=+p[b+16>>3];b=l+24|0;if((j|0)==(i|0))o=l;else{g=j;j=l;while(1){l=g;g=g+-24|0;p[j+-24>>3]=+p[g>>3];p[j+-16>>3]=+p[l+-16>>3];p[j+-8>>3]=+p[l+-8>>3];l=j+-24|0;if((g|0)==(i|0)){o=l;break}else j=l}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function gPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0;c=f[a+4>>2]|0;d=f[a>>2]|0;e=d;if((c|0)==(d|0)){g=0.0;return +g}h=+p[a+24>>3];i=+p[a+32>>3];j=+p[a+40>>3];k=+p[b>>3];l=+p[b+8>>3];m=+p[b+16>>3];b=f[a+12>>2]|0;a=(c-d|0)/24|0;n=0.0;d=0;while(1){o=+p[e+(d*24|0)+16>>3];q=+V(+o);r=h*q;s=i*q;q=(+p[e+(d*24|0)>>3]-k)/r;t=(+p[e+(d*24|0)+8>>3]-l)/s;u=(o-m)/j;o=n+ +p[b+(d<<3)>>3]*+V(+((q*q+t*t+u*u)*-.5))/+M(+(j+(r+s)));d=d+1|0;if(d>>>0>=a>>>0){g=o;break}else n=o}return +g}function hPb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=(c-b|0)/24|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0<=((g-h|0)/24|0)>>>0){j=a+4|0;k=f[j>>2]|0;l=(k-h|0)/24|0;m=d>>>0>l>>>0;n=b+(l*24|0)|0;l=m?n:c;o=k;if((l|0)==(b|0))q=i;else{k=b;r=i;while(1){p[r>>3]=+p[k>>3];p[r+8>>3]=+p[k+8>>3];p[r+16>>3]=+p[k+16>>3];k=k+24|0;s=r+24|0;if((k|0)==(l|0)){q=s;break}else r=s}}if(!m){if((o|0)==(q|0))return;f[j>>2]=o+(~(((o+-24-q|0)>>>0)/24|0)*24|0);return}if((l|0)==(c|0))return;l=n;n=f[j>>2]|0;do{p[n>>3]=+p[l>>3];p[n+8>>3]=+p[l+8>>3];p[n+16>>3]=+p[l+16>>3];l=l+24|0;n=n+24|0}while((l|0)!=(c|0));f[j>>2]=n;return}n=h;if(!h)t=g;else{g=a+4|0;j=f[g>>2]|0;if((j|0)!=(i|0))f[g>>2]=j+(~(((j+-24-h|0)>>>0)/24|0)*24|0);YDc(n);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;t=0}if(d>>>0>178956970)mCc(a);g=(t|0)/24|0;t=g<<1;n=g>>>0<89478485?(t>>>0<d>>>0?d:t):178956970;if(n>>>0>178956970)mCc(a);t=VDc(n*24|0)|0;d=a+4|0;f[d>>2]=t;f[a>>2]=t;f[e>>2]=t+(n*24|0);if((b|0)==(c|0))return;n=b;b=t;do{p[b>>3]=+p[n>>3];p[b+8>>3]=+p[n+8>>3];p[b+16>>3]=+p[n+16>>3];n=n+24|0;b=b+24|0}while((n|0)!=(c|0));f[d>>2]=b;return}function iPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=(f[e>>2]|0)+24|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/24|0;g=i+b|0;if(g>>>0>178956970)mCc(a);j=(d-h|0)/24|0;h=j<<1;d=j>>>0<89478485?(h>>>0<g>>>0?g:h):178956970;do if(d)if(d>>>0>178956970){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*24|0)|0;break}else k=0;while(0);h=k+(i*24|0)|0;i=h;g=k+(d*24|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;b=k+24|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-24|0;p[b+-24>>3]=+p[i>>3];p[b+-16>>3]=+p[h+-16>>3];p[b+-8>>3]=+p[h+-8>>3];b=b+-24|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function jPb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0.0;d=a+8|0;e=a+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=f[b+4>>2]|0;h=f[b>>2]|0;i=h;if((g|0)==(h|0)){j=0.0;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;q=m/j;p[a>>3]=q;r=n/l;p[d>>3]=r;s=o/k;p[e>>3]=s;return}t=+p[c>>3];u=+p[c+8>>3];v=+p[b+24>>3];w=+p[b+32>>3];x=+p[b+40>>3];y=+p[c+16>>3]/x;c=f[b+12>>2]|0;b=(g-h|0)/24|0;h=0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;do{F=+p[i+(h*24|0)+16>>3];G=+V(+F);H=v*G;I=w*G;G=+p[i+(h*24|0)>>3]/H;J=+p[i+(h*24|0)+8>>3]/I;K=F/x;F=G-t/H;L=J-u/I;N=K-y;O=+p[c+(h<<3)>>3]*+V(+((N*N+(F*F+L*L))*-.5))/+M(+(x+(H+I)));C=C+G*O;D=J*O+D;E=K*O+E;z=z+O/H;B=B+O/I;A=A+O/x;h=h+1|0}while(h>>>0<b>>>0);p[a>>3]=C;p[d>>3]=D;p[e>>3]=E;j=z;k=A;l=B;m=C;n=D;o=E;q=m/j;p[a>>3]=q;r=n/l;p[d>>3]=r;s=o/k;p[e>>3]=s;return}function kPb(a){a=a|0;var b=0,c=0,d=0;r0(a);f[a>>2]=137480;b=a+128|0;c=a+4|0;d=c+124|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[b>>2]=1124007936;b=a+132|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+160>>2]=a+136;b=a+168|0;f[a+164>>2]=b;f[a+172>>2]=0;f[b>>2]=0;f[a+176>>2]=1124007936;b=a+180|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+208>>2]=a+184;b=a+216|0;f[a+212>>2]=b;f[a+220>>2]=0;f[b>>2]=0;f[a+224>>2]=1124007936;b=a+228|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+256>>2]=a+232;b=a+264|0;f[a+260>>2]=b;f[a+268>>2]=0;f[b>>2]=0;f[a+272>>2]=1124007936;b=a+276|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+304>>2]=a+280;b=a+312|0;f[a+308>>2]=b;f[a+316>>2]=0;f[b>>2]=0;f[a+320>>2]=1124007936;b=a+324|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+352>>2]=a+328;b=a+360|0;f[a+356>>2]=b;f[a+364>>2]=0;f[b>>2]=0;f[a+368>>2]=1124007936;b=a+372|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+400>>2]=a+376;b=a+408|0;f[a+404>>2]=b;f[a+412>>2]=0;f[b>>2]=0;k6(a+416|0);return}function lPb(a){a=a|0;f[a>>2]=0;f[a+4>>2]=0;return}function mPb(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;nPb(a,b)|0;return}function nPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=VDc(420)|0;kPb(c);d=VDc(16)|0;e=d+4|0;f[e>>2]=1;f[d>>2]=137600;f[d+8>>2]=c;f[e>>2]=(f[e>>2]|0)+1;g=f[a>>2]|0;f[a>>2]=d;h=a+4|0;f[h>>2]=c;if(g|0?(c=g+4|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)==1)Yi[f[(f[d>>2]|0)+8>>2]&2047](d);d=f[h>>2]|0;if(Mi[f[(f[d>>2]|0)+32>>2]&1023](d,b)|0){b=f[h>>2]|0;if(!b){j=0;return j|0}j=(_i[f[(f[b>>2]|0)+20>>2]&1023](b)|0)^1;return j|0}b=f[a>>2]|0;if(b|0?(d=b+4|0,g=f[d>>2]|0,f[d>>2]=g+-1,(g|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[h>>2]=0;j=0;return j|0}function oPb(a){a=a|0;YDc(a);return}function pPb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function qPb(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[a+4>>2]=0;return}function rPb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!b){c=1;return c|0}c=_i[f[(f[b>>2]|0)+20>>2]&1023](b)|0;return c|0}function sPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;c=j-k>>4;l=f[a>>2]|0;m=f[a+4>>2]|0;a=(d|0)!=0;n=k;if(a?((f[d+4>>2]|0)-(f[d>>2]|0)>>2|0)!=(c|0):0){f[h>>2]=0;f[h+4>>2]=0;o=tT(h,14)|0;q=467563;r=o+14|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));z5(-215,h,467578,465762,1659)}k=(e|0)!=0;if(k?((f[e+4>>2]|0)-(f[e>>2]|0)>>3|0)!=(c|0):0){f[h>>2]=0;f[h+4>>2]=0;o=tT(h,14)|0;q=467590;r=o+14|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));z5(-215,h,467578,465762,1663)}a:do if(c){h=d+4|0;q=e+4|0;if(!a){o=k^1;r=0;s=0;while(1){t=f[n+(r<<4)>>2]|0;v=(t|0)>0?t:0;w=f[n+(r<<4)+4>>2]|0;x=(w|0)>0?w:0;y=(f[n+(r<<4)+8>>2]|0)+t|0;t=((y|0)<(l|0)?y:l)-v|0;y=(f[n+(r<<4)+12>>2]|0)+w|0;w=((y|0)<(m|0)?y:m)-x|0;y=(t|0)<1|(w|0)<1;z=y?0:w;w=y?0:t;if((w|0)<1|(z|0)<1)A=s;else{f[n+(s<<4)>>2]=y?0:v;f[n+(s<<4)+4>>2]=y?0:x;f[n+(s<<4)+8>>2]=w;f[n+(s<<4)+12>>2]=z;if(!(r>>>0<=s>>>0|o)){z=f[e>>2]|0;w=(f[q>>2]|0)-z>>3;if(w>>>0<=r>>>0){B=25;break}x=z;if(w>>>0<=s>>>0){B=27;break}p[x+(s<<3)>>3]=+p[x+(r<<3)>>3]}A=s+1|0}r=r+1|0;if(r>>>0>=c>>>0){C=A;break a}else s=A}if((B|0)==25)nCc(e);else if((B|0)==27)nCc(e)}else{D=0;E=0}while(1){s=f[n+(D<<4)>>2]|0;r=(s|0)>0?s:0;o=f[n+(D<<4)+4>>2]|0;x=(o|0)>0?o:0;w=(f[n+(D<<4)+8>>2]|0)+s|0;s=((w|0)<(l|0)?w:l)-r|0;w=(f[n+(D<<4)+12>>2]|0)+o|0;o=((w|0)<(m|0)?w:m)-x|0;w=(s|0)<1|(o|0)<1;z=w?0:o;o=w?0:s;if((o|0)<1|(z|0)<1)F=E;else{f[n+(E<<4)>>2]=w?0:r;f[n+(E<<4)+4>>2]=w?0:x;f[n+(E<<4)+8>>2]=o;f[n+(E<<4)+12>>2]=z;if(D>>>0>E>>>0){z=f[d>>2]|0;o=(f[h>>2]|0)-z>>2;if(o>>>0<=D>>>0){B=22;break}x=z;if(o>>>0<=E>>>0){B=23;break}f[x+(E<<2)>>2]=f[x+(D<<2)>>2];if(k){x=f[e>>2]|0;o=(f[q>>2]|0)-x>>3;if(o>>>0<=D>>>0){B=25;break}z=x;if(o>>>0<=E>>>0){B=27;break}p[z+(E<<3)>>3]=+p[z+(D<<3)>>3]}}F=E+1|0}D=D+1|0;if(D>>>0>=c>>>0){C=F;break a}else E=F}if((B|0)==22)nCc(d);else if((B|0)==23)nCc(d);else if((B|0)==25)nCc(e);else if((B|0)==27)nCc(e)}else C=0;while(0);if(C>>>0>=c>>>0){u=g;return}c=j;j=n+(C<<4)|0;if((c|0)!=(j|0))f[i>>2]=c+(~((c+-16-j|0)>>>4)<<4);do if(a){j=d+4|0;c=f[j>>2]|0;i=f[d>>2]|0;n=c-i>>2;B=c;if(C>>>0>n>>>0){lN(d,C-n|0);break}if(C>>>0<n>>>0?(n=i+(C<<2)|0,(B|0)!=(n|0)):0)f[j>>2]=B+(~((B+-4-n|0)>>>2)<<2)}while(0);if(!k){u=g;return}k=e+4|0;d=f[k>>2]|0;a=f[e>>2]|0;n=d-a>>3;B=d;if(C>>>0>n>>>0){cha(e,C-n|0);u=g;return}if(C>>>0>=n>>>0){u=g;return}n=a+(C<<3)|0;if((B|0)==(n|0)){u=g;return}f[k>>2]=B+(~((B+-8-n|0)>>>3)<<3);u=g;return}function tPb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+32|0;l=k+24|0;m=k+16|0;n=k+8|0;o=k;p=a+4|0;a=f[p>>2]|0;if(a|0?!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0):0){a=f[p>>2]|0;p=f[(f[a>>2]|0)+36>>2]|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];Gh[p&3](a,c,d,e,g,h,m,n);b$(o,c,-1);sPb(o,d,0,0);u=k;return}f[l>>2]=0;f[l+4>>2]=0;k=tT(l,8)|0;d=k;b[d>>0]=33;b[d+1>>0]=101;b[d+2>>0]=109;b[d+3>>0]=112;d=k+4|0;b[d>>0]=116;b[d+1>>0]=121;b[d+2>>0]=40;b[d+3>>0]=41;z5(-215,l,466708,465762,1698)}function uPb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=u;u=u+32|0;m=l+24|0;n=l+16|0;o=l+8|0;p=l;q=a+4|0;a=f[q>>2]|0;if(a|0?!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0):0){a=f[q>>2]|0;q=f[(f[a>>2]|0)+40>>2]|0;f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];uh[q&7](a,c,d,e,g,h,i,n,o);b$(p,c,-1);sPb(p,d,e,0);u=l;return}f[m>>2]=0;f[m+4>>2]=0;l=tT(m,8)|0;e=l;b[e>>0]=33;b[e+1>>0]=101;b[e+2>>0]=109;b[e+3>>0]=112;e=l+4|0;b[e>>0]=116;b[e+1>>0]=121;b[e+2>>0]=40;b[e+3>>0]=41;z5(-215,m,466708,465762,1712)}function vPb(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=u;u=u+32|0;o=n+24|0;p=n+16|0;q=n+8|0;r=n;s=a+4|0;a=f[s>>2]|0;if(a|0?!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0):0){a=f[s>>2]|0;s=f[(f[a>>2]|0)+44>>2]|0;f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];f[q>>2]=f[l>>2];f[q+4>>2]=f[l+4>>2];ih[s&3](a,c,d,e,g,h,i,j,p,q,m);b$(r,c,-1);sPb(r,d,e,g);u=n;return}f[o>>2]=0;f[o+4>>2]=0;n=tT(o,8)|0;g=n;b[g>>0]=33;b[g+1>>0]=101;b[g+2>>0]=109;b[g+3>>0]=112;g=n+4|0;b[g>>0]=116;b[g+1>>0]=121;b[g+2>>0]=40;b[g+3>>0]=41;z5(-215,o,466708,465762,1729)}function wPb(){s5(883208,467605,957,1771,544,279,958);be(1715,883208,x|0)|0;return}function xPb(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1112539136;return b&1|0}function yPb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(!a)return;b=f[a>>2]|0;if(!b)return;c=b+4|0;if((f[c>>2]|0)>0){d=b+32|0;e=0;do{g=f[d>>2]|0;h=f[g+(e*24|0)+8>>2]|0;if((f[g+(e*24|0)>>2]|0)>0){g=0;i=h;while(1){i0(f[i+(g*24|0)+4>>2]|0);f[(f[(f[d>>2]|0)+(e*24|0)+8>>2]|0)+(g*24|0)+4>>2]=0;g=g+1|0;j=f[d>>2]|0;k=f[j+(e*24|0)+8>>2]|0;if((g|0)>=(f[j+(e*24|0)>>2]|0)){l=k;break}else i=k}}else l=h;i0(l);f[(f[d>>2]|0)+(e*24|0)+8>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=b+36|0;b=f[c>>2]|0;if(b|0){i0(b);f[c>>2]=0}i0(f[a>>2]|0);f[a>>2]=0;return}function zPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;d=u;u=u+752|0;e=d+352|0;g=d+344|0;h=d+336|0;i=d+328|0;j=d+312|0;k=d+296|0;l=d+280|0;m=d+264|0;o=d+248|0;q=d+232|0;r=d+216|0;s=d+200|0;t=d+184|0;v=d+168|0;w=d+152|0;x=d+136|0;y=d+120|0;z=d+104|0;A=d+88|0;B=d+72|0;C=d+56|0;D=d+40|0;E=d+24|0;F=d+16|0;G=d+8|0;H=d;I=d+456|0;J=d+488|0;K=d+424|0;L=d+392|0;M=d+360|0;N=j1(a,c,467768)|0;if(!N){f[I>>2]=0;O=I+4|0;f[O>>2]=0;P=tT(I,19)|0;Q=P;R=467915;S=Q+19|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1624)}if((f[N>>2]&7|0)!=5){f[I>>2]=0;O=I+4|0;f[O>>2]=0;P=tT(I,19)|0;Q=P;R=467915;S=Q+19|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1624)}P=N+8|0;N=f[(f[P>>2]|0)+24>>2]|0;O=(N*24|0)+40|0;if((N|0)<1){f[I>>2]=0;f[I+4>>2]=0;Q=tT(I,35)|0;R=467628;S=Q+35|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-211,I,467664,113)}T=h0(O)|0;XIc(T|0,0,O|0)|0;O=T+32|0;f[O>>2]=T+40;f[T>>2]=1112539136;U=T+4|0;f[U>>2]=N;V=j1(a,c,467763)|0;if(!V){f[I>>2]=0;W=I+4|0;f[W>>2]=0;X=tT(I,34)|0;Q=X;R=467957;S=Q+34|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1632)}if((f[V>>2]&7|0)!=5){f[I>>2]=0;W=I+4|0;f[W>>2]=0;X=tT(I,34)|0;Q=X;R=467957;S=Q+34|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1632)}c=V+8|0;V=f[c>>2]|0;if((f[V+24>>2]|0)!=2){f[I>>2]=0;W=I+4|0;f[W>>2]=0;X=tT(I,34)|0;Q=X;R=467957;S=Q+34|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1632)}X=o7(V,0)|0;if((f[X>>2]&7|0)!=1){f[I>>2]=0;Y=I+4|0;f[Y>>2]=0;Z=tT(I,49)|0;Q=Z;R=467992;S=Q+49|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1635)}V=f[X+8>>2]|0;if((V|0)<1){f[I>>2]=0;Y=I+4|0;f[Y>>2]=0;Z=tT(I,49)|0;Q=Z;R=467992;S=Q+49|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1635)}Z=T+8|0;f[Z>>2]=V;V=o7(f[c>>2]|0,1)|0;if((f[V>>2]&7|0)!=1){f[I>>2]=0;_=I+4|0;f[_>>2]=0;$=tT(I,50)|0;Q=$;R=468042;S=Q+50|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1639)}c=f[V+8>>2]|0;if((c|0)<1){f[I>>2]=0;_=I+4|0;f[_>>2]=0;$=tT(I,50)|0;Q=$;R=468042;S=Q+50|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));CPb(-2,I,467935,1639)}R=T+12|0;f[R>>2]=c;r7(f[P>>2]|0,K,0);P=K+12|0;c=K+20|0;Q=I+12|0;S=I+20|0;$=L+12|0;_=L+20|0;V=M+12|0;Y=M+20|0;X=0;a:while(1){W=f[P>>2]|0;if((f[W>>2]&7|0)!=6){aa=18;break}ba=j1(a,W,467784)|0;if(!ba){aa=24;break}if((f[ba>>2]&7|0)!=5){aa=24;break}ca=ba+8|0;ba=f[(f[ca>>2]|0)+24>>2]|0;if((ba|0)<1){aa=24;break}da=h0(ba*24|0)|0;ba=f[O>>2]|0;f[ba+(X*24|0)+8>>2]=da;ea=f[ca>>2]|0;fa=f[ea+24>>2]|0;if((fa|0)>0){ga=0;do{f[da+(ga*24|0)+4>>2]=0;ga=ga+1|0;ha=f[ca>>2]|0;ia=f[ha+24>>2]|0}while((ga|0)<(ia|0));ja=ia;ka=ha}else{ja=fa;ka=ea}f[ba+(X*24|0)>>2]=ja;r7(ka,I,0);if((f[(f[ca>>2]|0)+24>>2]|0)>0){la=0;while(1){ga=f[(f[O>>2]|0)+(X*24|0)+8>>2]|0;da=f[Q>>2]|0;if((f[da>>2]&7|0)!=5){aa=32;break a}ha=da+8|0;da=f[(f[ha>>2]|0)+24>>2]|0;if((da|0)<1){aa=32;break a}ia=ga+(la*24|0)|0;f[ia>>2]=da;ma=h0(da*80|4)|0;da=ga+(la*24|0)+4|0;f[da>>2]=ma;na=f[ia>>2]|0;oa=ma+(na<<6)|0;ma=ga+(la*24|0)+8|0;f[ma>>2]=oa;pa=oa+(na<<2)|0;oa=ga+(la*24|0)+12|0;f[oa>>2]=pa;qa=pa+(na<<2)|0;pa=ga+(la*24|0)+16|0;f[pa>>2]=qa;ra=ga+(la*24|0)+20|0;f[ra>>2]=qa+(na<<2);r7(f[ha>>2]|0,L,0);if((f[(f[ha>>2]|0)+24>>2]|0)>0){sa=0;na=0;while(1){qa=f[$>>2]|0;if((f[qa>>2]&7|0)!=6){aa=37;break a}ga=j1(a,qa,467816)|0;if(!ga){aa=42;break a}if((f[ga>>2]&7|0)!=6){aa=42;break a}ta=j1(a,ga,467824)|0;if(!ta){aa=48;break a}if((f[ta>>2]&7|0)!=5){aa=48;break a}ua=ta+8|0;ta=f[ua>>2]|0;if(((f[ta+24>>2]|0)+-1|0)>>>0>2){aa=48;break a}r7(ta,M,0);ta=f[(f[ua>>2]|0)+24>>2]|0;if((ta|0)>0){va=0;while(1){wa=f[V>>2]|0;if((f[wa>>2]&7|0)!=5){aa=55;break a}xa=wa+8|0;wa=f[xa>>2]|0;if((f[wa+24>>2]|0)!=5){aa=55;break a}ya=f[wa+52>>2]|0;do if(!ya)aa=61;else{if(!(f[ya+12>>2]|0)){aa=61;break}za=f[ya+16>>2]|0}while(0);if((aa|0)==61){aa=0;za=o7(wa,0)|0}if((f[za>>2]&7|0)!=1){aa=64;break a}ya=f[za+8>>2]|0;if((ya|0)<0){aa=64;break a}Aa=f[xa>>2]|0;Ba=f[Aa+52>>2]|0;do if(!Ba)aa=70;else{if((f[Ba+12>>2]|0)>>>0<=1){aa=70;break}Ca=(f[Ba+16>>2]|0)+16|0}while(0);if((aa|0)==70){aa=0;Ca=o7(Aa,1)|0}if((f[Ca>>2]&7|0)!=1){aa=73;break a}Ba=f[Ca+8>>2]|0;if((Ba|0)<0){aa=73;break a}wa=f[xa>>2]|0;Da=f[wa+52>>2]|0;do if(!Da)aa=79;else{if((f[Da+12>>2]|0)>>>0<=2){aa=79;break}Ea=(f[Da+16>>2]|0)+32|0}while(0);if((aa|0)==79){aa=0;Ea=o7(wa,2)|0}if((f[Ea>>2]&7|0)!=1){aa=83;break a}Da=f[Ea+8>>2]|0;if((Da|0)<1){aa=83;break a}if((Da+ya|0)>(f[Z>>2]|0)){aa=83;break a}Aa=f[xa>>2]|0;Fa=f[Aa+52>>2]|0;do if(!Fa)aa=89;else{if((f[Fa+12>>2]|0)>>>0<=3){aa=89;break}Ga=(f[Fa+16>>2]|0)+48|0}while(0);if((aa|0)==89){aa=0;Ga=o7(Aa,3)|0}if((f[Ga>>2]&7|0)!=1){aa=93;break a}Fa=f[Ga+8>>2]|0;if((Fa|0)<1){aa=93;break a}if((Fa+Ba|0)>(f[R>>2]|0)){aa=93;break a}wa=f[xa>>2]|0;Ha=f[wa+52>>2]|0;do if(!Ha)aa=99;else{if((f[Ha+12>>2]|0)>>>0<=4){aa=99;break}Ia=(f[Ha+16>>2]|0)+64|0}while(0);if((aa|0)==99){aa=0;Ia=o7(wa,4)|0}if((f[Ia>>2]&7|0)!=2){aa=101;break a}Ha=f[da>>2]|0;n[Ha+(sa<<6)+4+(va*20|0)+16>>2]=+p[Ia+8>>3];f[Ha+(sa<<6)+4+(va*20|0)>>2]=ya;f[Ha+(sa<<6)+4+(va*20|0)+4>>2]=Ba;f[Ha+(sa<<6)+4+(va*20|0)+8>>2]=Da;f[Ha+(sa<<6)+4+(va*20|0)+12>>2]=Fa;Ha=(f[V>>2]|0)+16|0;f[V>>2]=Ha;if(Ha>>>0>=(f[Y>>2]|0)>>>0)z7(M,1);Ha=va+1|0;Ja=f[(f[ua>>2]|0)+24>>2]|0;if((Ha|0)<(Ja|0))va=Ha;else break}if((Ja|0)<3){Ka=Ja;aa=107}}else{Ka=ta;aa=107}if((aa|0)==107)while(1){aa=0;ua=(f[da>>2]|0)+(sa<<6)+4+(Ka*20|0)|0;Ka=Ka+1|0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;f[ua+16>>2]=0;if((Ka|0)==3)break;else aa=107}ta=j1(a,ga,467830)|0;if(!ta){aa=110;break a}if((f[ta>>2]&7|0)!=1){aa=110;break a}f[(f[da>>2]|0)+(sa<<6)>>2]=(f[ta+8>>2]|0)!=0&1;ta=j1(a,qa,467837)|0;if(!ta){aa=115;break a}if((f[ta>>2]&7|0)!=2){aa=115;break a}n[(f[ma>>2]|0)+(sa<<2)>>2]=+p[ta+8>>3];ta=j1(a,qa,467847)|0;if(!ta){ua=j1(a,qa,467857)|0;if(!ua){aa=127;break a}if((f[ua>>2]&7|0)!=2){aa=131;break a}if((na|0)>(f[ia>>2]|0)){aa=135;break a}f[(f[oa>>2]|0)+(sa<<2)>>2]=0-na;n[(f[ra>>2]|0)+(na<<2)>>2]=+p[ua+8>>3];La=na+1|0}else{if((f[ta>>2]&7|0)!=1){aa=122;break a}ua=f[ta+8>>2]|0;if((ua|0)<=(sa|0)){aa=122;break a}if((ua|0)>=(f[(f[ha>>2]|0)+24>>2]|0)){aa=122;break a}f[(f[oa>>2]|0)+(sa<<2)>>2]=ua;La=na}ua=j1(a,qa,467866)|0;if(!ua){ta=j1(a,qa,467877)|0;if(!ta){aa=148;break a}if((f[ta>>2]&7|0)!=2){aa=152;break a}if((La|0)>(f[ia>>2]|0)){aa=156;break a}f[(f[pa>>2]|0)+(sa<<2)>>2]=0-La;n[(f[ra>>2]|0)+(La<<2)>>2]=+p[ta+8>>3];Ma=La+1|0}else{if((f[ua>>2]&7|0)!=1){aa=143;break a}ta=f[ua+8>>2]|0;if((ta|0)<=(sa|0)){aa=143;break a}if((ta|0)>=(f[(f[ha>>2]|0)+24>>2]|0)){aa=143;break a}f[(f[pa>>2]|0)+(sa<<2)>>2]=ta;Ma=La}ta=(f[$>>2]|0)+16|0;f[$>>2]=ta;if(ta>>>0>=(f[_>>2]|0)>>>0)z7(L,1);ta=sa+1|0;if((ta|0)<(f[(f[ha>>2]|0)+24>>2]|0)){sa=ta;na=Ma}else{Na=Ma;break}}}else Na=0;if((Na|0)!=((f[ia>>2]|0)+1|0)){aa=164;break a}na=(f[Q>>2]|0)+16|0;f[Q>>2]=na;if(na>>>0>=(f[S>>2]|0)>>>0)z7(I,1);na=la+1|0;if((na|0)<(f[(f[ca>>2]|0)+24>>2]|0))la=na;else break}}ca=j1(a,W,467887)|0;if(!ca){aa=172;break}if((f[ca>>2]&7|0)!=2){aa=172;break}n[(f[O>>2]|0)+(X*24|0)+4>>2]=+p[ca+8>>3];ca=j1(a,W,467903)|0;if(!ca){aa=179;break}if((f[ca>>2]&7|0)!=1){aa=179;break}ba=f[ca+8>>2]|0;if((ba|0)<-1){aa=179;break}if((ba|0)>=(f[U>>2]|0)){aa=179;break}ca=j1(a,W,467910)|0;if(!ca){aa=186;break}if((f[ca>>2]&7|0)!=1){aa=186;break}ea=f[ca+8>>2]|0;if((ea|0)<-1){aa=186;break}if((ea|0)>=(f[U>>2]|0)){aa=186;break}ca=f[O>>2]|0;f[ca+(X*24|0)+20>>2]=ba;f[ca+(X*24|0)+12>>2]=ea;f[ca+(X*24|0)+16>>2]=-1;do if((ba|0)!=-1){ea=ca+(ba*24|0)+16|0;if((f[ea>>2]|0)!=-1)break;f[ea>>2]=X}while(0);ba=(f[P>>2]|0)+16|0;f[P>>2]=ba;if(ba>>>0>=(f[c>>2]|0)>>>0)z7(K,1);ba=X+1|0;if((ba|0)<(N|0))X=ba;else{aa=195;break}}switch(aa|0){case 18:{f[H>>2]=X;Aqc(J,468093,H)|0;f[H>>2]=0;f[H+4>>2]=0;aa=Mpc(J)|0;if(!aa)CPb(-2,H,467935,1653);dJc(tT(H,aa)|0,J|0,aa|0)|0;CPb(-2,H,467935,1653);break}case 24:{f[G>>2]=X;Aqc(J,468110,G)|0;f[G>>2]=0;f[G+4>>2]=0;H=Mpc(J)|0;if(!H)CPb(-2,G,467935,1661);dJc(tT(G,H)|0,J|0,H|0)|0;CPb(-2,G,467935,1661);break}case 32:{f[F>>2]=X;f[F+4>>2]=la;Aqc(J,468157,F)|0;f[F>>2]=0;f[F+4>>2]=0;G=Mpc(J)|0;if(!G)CPb(-2,F,467935,1687);dJc(tT(F,G)|0,J|0,G|0)|0;CPb(-2,F,467935,1687);break}case 37:{f[E>>2]=sa;f[E+4>>2]=X;f[E+8>>2]=la;Aqc(J,468212,E)|0;f[E>>2]=0;f[E+4>>2]=0;F=Mpc(J)|0;if(!F)CPb(-2,E,467935,1715);dJc(tT(E,F)|0,J|0,F|0)|0;CPb(-2,E,467935,1715);break}case 42:{f[D>>2]=X;f[D+4>>2]=la;f[D+8>>2]=sa;Aqc(J,468265,D)|0;f[D>>2]=0;f[D+4>>2]=0;E=Mpc(J)|0;if(!E)CPb(-2,D,467935,1722);dJc(tT(D,E)|0,J|0,E|0)|0;CPb(-2,D,467935,1722);break}case 48:{f[C>>2]=X;f[C+4>>2]=la;f[C+8>>2]=sa;Aqc(J,468327,C)|0;f[C>>2]=0;f[C+4>>2]=0;D=Mpc(J)|0;if(!D)CPb(-2,C,467935,1731);dJc(tT(C,D)|0,J|0,D|0)|0;CPb(-2,C,467935,1731);break}case 55:{f[B>>2]=va;f[B+4>>2]=X;f[B+8>>2]=la;f[B+12>>2]=sa;Aqc(J,468392,B)|0;f[B>>2]=0;f[B+4>>2]=0;C=Mpc(J)|0;if(!C)CPb(-2,B,467935,1744);dJc(tT(B,C)|0,J|0,C|0)|0;CPb(-2,B,467935,1744);break}case 64:{f[A>>2]=X;f[A+4>>2]=la;f[A+8>>2]=sa;f[A+12>>2]=va;Aqc(J,468454,A)|0;f[A>>2]=0;f[A+4>>2]=0;B=Mpc(J)|0;if(!B)CPb(-2,A,467935,1752);dJc(tT(A,B)|0,J|0,B|0)|0;CPb(-2,A,467935,1752);break}case 73:{f[z>>2]=X;f[z+4>>2]=la;f[z+8>>2]=sa;f[z+12>>2]=va;Aqc(J,468535,z)|0;f[z>>2]=0;f[z+4>>2]=0;A=Mpc(J)|0;if(!A)CPb(-2,z,467935,1760);dJc(tT(z,A)|0,J|0,A|0)|0;CPb(-2,z,467935,1760);break}case 83:{f[y>>2]=X;f[y+4>>2]=la;f[y+8>>2]=sa;f[y+12>>2]=va;Aqc(J,468616,y)|0;f[y>>2]=0;f[y+4>>2]=0;z=Mpc(J)|0;if(!z)CPb(-2,y,467935,1770);dJc(tT(y,z)|0,J|0,z|0)|0;CPb(-2,y,467935,1770);break}case 93:{f[x>>2]=X;f[x+4>>2]=la;f[x+8>>2]=sa;f[x+12>>2]=va;Aqc(J,468731,x)|0;f[x>>2]=0;f[x+4>>2]=0;y=Mpc(J)|0;if(!y)CPb(-2,x,467935,1780);dJc(tT(x,y)|0,J|0,y|0)|0;CPb(-2,x,467935,1780);break}case 101:{f[w>>2]=X;f[w+4>>2]=la;f[w+8>>2]=sa;f[w+12>>2]=va;Aqc(J,468849,w)|0;f[w>>2]=0;f[w+4>>2]=0;va=Mpc(J)|0;if(!va)CPb(-2,w,467935,1788);dJc(tT(w,va)|0,J|0,va|0)|0;CPb(-2,w,467935,1788);break}case 110:{f[v>>2]=X;f[v+4>>2]=la;f[v+8>>2]=sa;Aqc(J,468915,v)|0;f[v>>2]=0;f[v+4>>2]=0;w=Mpc(J)|0;if(!w)CPb(-2,v,467935,1807);dJc(tT(v,w)|0,J|0,w|0)|0;CPb(-2,v,467935,1807);break}case 115:{f[t>>2]=X;f[t+4>>2]=la;f[t+8>>2]=sa;Aqc(J,468967,t)|0;f[t>>2]=0;f[t+4>>2]=0;v=Mpc(J)|0;if(!v)CPb(-2,t,467935,1815);dJc(tT(t,v)|0,J|0,v|0)|0;CPb(-2,t,467935,1815);break}case 122:{f[s>>2]=X;f[s+4>>2]=la;f[s+8>>2]=sa;Aqc(J,469027,s)|0;f[s>>2]=0;f[s+4>>2]=0;t=Mpc(J)|0;if(!t)CPb(-2,s,467935,1826);dJc(tT(s,t)|0,J|0,t|0)|0;CPb(-2,s,467935,1826);break}case 127:{f[r>>2]=X;f[r+4>>2]=la;f[r+8>>2]=sa;Aqc(J,469093,r)|0;f[r>>2]=0;f[r+4>>2]=0;s=Mpc(J)|0;if(!s)CPb(-2,r,467935,1838);dJc(tT(r,s)|0,J|0,s|0)|0;CPb(-2,r,467935,1838);break}case 131:{f[q>>2]=X;f[q+4>>2]=la;f[q+8>>2]=sa;Aqc(J,469165,q)|0;f[q>>2]=0;f[q+4>>2]=0;r=Mpc(J)|0;if(!r)CPb(-2,q,467935,1844);dJc(tT(q,r)|0,J|0,r|0)|0;CPb(-2,q,467935,1844);break}case 135:{f[o>>2]=X;f[o+4>>2]=la;f[o+8>>2]=sa;Aqc(J,469226,o)|0;f[o>>2]=0;f[o+4>>2]=0;q=Mpc(J)|0;if(!q)CPb(-2,o,467935,1851);dJc(tT(o,q)|0,J|0,q|0)|0;CPb(-2,o,467935,1851);break}case 143:{f[m>>2]=X;f[m+4>>2]=la;f[m+8>>2]=sa;Aqc(J,469298,m)|0;f[m>>2]=0;f[m+4>>2]=0;o=Mpc(J)|0;if(!o)CPb(-2,m,467935,1864);dJc(tT(m,o)|0,J|0,o|0)|0;CPb(-2,m,467935,1864);break}case 148:{f[l>>2]=X;f[l+4>>2]=la;f[l+8>>2]=sa;Aqc(J,469365,l)|0;f[l>>2]=0;f[l+4>>2]=0;m=Mpc(J)|0;if(!m)CPb(-2,l,467935,1876);dJc(tT(l,m)|0,J|0,m|0)|0;CPb(-2,l,467935,1876);break}case 152:{f[k>>2]=X;f[k+4>>2]=la;f[k+8>>2]=sa;Aqc(J,469439,k)|0;f[k>>2]=0;f[k+4>>2]=0;l=Mpc(J)|0;if(!l)CPb(-2,k,467935,1882);dJc(tT(k,l)|0,J|0,l|0)|0;CPb(-2,k,467935,1882);break}case 156:{f[j>>2]=X;f[j+4>>2]=la;f[j+8>>2]=sa;Aqc(J,469226,j)|0;f[j>>2]=0;f[j+4>>2]=0;sa=Mpc(J)|0;if(!sa)CPb(-2,j,467935,1889);dJc(tT(j,sa)|0,J|0,sa|0)|0;CPb(-2,j,467935,1889);break}case 164:{f[i>>2]=X;f[i+4>>2]=la;Aqc(J,469501,i)|0;f[i>>2]=0;f[i+4>>2]=0;la=Mpc(J)|0;if(!la)CPb(-2,i,467935,1901);dJc(tT(i,la)|0,J|0,la|0)|0;CPb(-2,i,467935,1901);break}case 172:{f[h>>2]=X;Aqc(J,469563,h)|0;f[h>>2]=0;f[h+4>>2]=0;i=Mpc(J)|0;if(!i)CPb(-2,h,467935,1911);dJc(tT(h,i)|0,J|0,i|0)|0;CPb(-2,h,467935,1911);break}case 179:{f[g>>2]=X;Aqc(J,469611,g)|0;f[g>>2]=0;f[g+4>>2]=0;h=Mpc(J)|0;if(!h)CPb(-2,g,467935,1923);dJc(tT(g,h)|0,J|0,h|0)|0;CPb(-2,g,467935,1923);break}case 186:{f[e>>2]=X;Aqc(J,469653,e)|0;f[e>>2]=0;f[e+4>>2]=0;X=Mpc(J)|0;if(!X)CPb(-2,e,467935,1931);dJc(tT(e,X)|0,J|0,X|0)|0;CPb(-2,e,467935,1931);break}case 195:{u=d;return T|0}}return 0}function APb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+368|0;h=g+104|0;i=g+16|0;j=g+8|0;k=g;l=g+112|0;m=g+24|0;o=g+96|0;p=g+88|0;q=g+80|0;r=g+72|0;s=g+64|0;t=g+56|0;v=g+48|0;w=g+40|0;x=g+32|0;y=e;e=f[y+4>>2]|0;z=m;f[z>>2]=f[y>>2];f[z+4>>2]=e;f[h>>2]=f[m>>2];f[h+4>>2]=f[m+4>>2];q1(a,c,6,467605,h);f[o>>2]=0;f[o+4>>2]=0;f[h>>2]=f[o>>2];f[h+4>>2]=f[o+4>>2];q1(a,467763,13,0,h);s1(a,0,f[d+8>>2]|0);s1(a,0,f[d+12>>2]|0);r1(a);f[p>>2]=0;f[p+4>>2]=0;f[h>>2]=f[p>>2];f[h+4>>2]=f[p+4>>2];q1(a,467768,5,0,h);p=d+4|0;if((f[p>>2]|0)<=0){r1(a);r1(a);u=g;return}o=q+4|0;c=r+4|0;m=d+32|0;d=s+4|0;e=t+4|0;z=v+4|0;y=w+4|0;A=x+4|0;B=0;do{f[q>>2]=0;f[o>>2]=0;f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2];q1(a,0,6,0,h);f[k>>2]=B;Aqc(l,467775,k)|0;v1(a,l,1);f[r>>2]=0;f[c>>2]=0;f[h>>2]=f[r>>2];f[h+4>>2]=f[r+4>>2];q1(a,467784,5,0,h);C=f[m>>2]|0;if((f[C+(B*24|0)>>2]|0)>0){D=0;E=C;do{C=f[E+(B*24|0)+8>>2]|0;f[s>>2]=0;f[d>>2]=0;f[h>>2]=f[s>>2];f[h+4>>2]=f[s+4>>2];q1(a,0,5,0,h);f[j>>2]=D;Aqc(l,467790,j)|0;v1(a,l,1);F=C+(D*24|0)|0;if((f[F>>2]|0)>0){G=C+(D*24|0)+4|0;H=C+(D*24|0)+8|0;I=C+(D*24|0)+12|0;J=C+(D*24|0)+16|0;K=C+(D*24|0)+20|0;C=0;do{L=f[G>>2]|0;f[t>>2]=0;f[e>>2]=0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];q1(a,0,6,0,h);if(!C){M=l;N=467806;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0))}else{f[i>>2]=C;Aqc(l,467798,i)|0}v1(a,l,1);f[v>>2]=0;f[z>>2]=0;f[h>>2]=f[v>>2];f[h+4>>2]=f[v+4>>2];q1(a,467816,6,0,h);f[w>>2]=0;f[y>>2]=0;f[h>>2]=f[w>>2];f[h+4>>2]=f[w+4>>2];q1(a,467824,5,0,h);N=L+(C<<6)+12|0;if((f[N>>2]|0?(f[x>>2]=0,f[A>>2]=0,f[h>>2]=f[x>>2],f[h+4>>2]=f[x+4>>2],q1(a,0,13,0,h),s1(a,0,f[L+(C<<6)+4>>2]|0),s1(a,0,f[L+(C<<6)+8>>2]|0),s1(a,0,f[N>>2]|0),s1(a,0,f[L+(C<<6)+16>>2]|0),t1(a,0,+n[L+(C<<6)+20>>2]),r1(a),N=L+(C<<6)+32|0,f[N>>2]|0):0)?(f[x>>2]=0,f[A>>2]=0,f[h>>2]=f[x>>2],f[h+4>>2]=f[x+4>>2],q1(a,0,13,0,h),s1(a,0,f[L+(C<<6)+24>>2]|0),s1(a,0,f[L+(C<<6)+28>>2]|0),s1(a,0,f[N>>2]|0),s1(a,0,f[L+(C<<6)+36>>2]|0),t1(a,0,+n[L+(C<<6)+40>>2]),r1(a),N=L+(C<<6)+52|0,f[N>>2]|0):0){f[x>>2]=0;f[A>>2]=0;f[h>>2]=f[x>>2];f[h+4>>2]=f[x+4>>2];q1(a,0,13,0,h);s1(a,0,f[L+(C<<6)+44>>2]|0);s1(a,0,f[L+(C<<6)+48>>2]|0);s1(a,0,f[N>>2]|0);s1(a,0,f[L+(C<<6)+56>>2]|0);t1(a,0,+n[L+(C<<6)+60>>2]);r1(a)}r1(a);s1(a,467830,f[L+(C<<6)>>2]|0);r1(a);t1(a,467837,+n[(f[H>>2]|0)+(C<<2)>>2]);N=f[(f[I>>2]|0)+(C<<2)>>2]|0;if((N|0)>0)s1(a,467847,N);else t1(a,467857,+n[(f[K>>2]|0)+(0-N<<2)>>2]);N=f[(f[J>>2]|0)+(C<<2)>>2]|0;if((N|0)>0)s1(a,467866,N);else t1(a,467877,+n[(f[K>>2]|0)+(0-N<<2)>>2]);r1(a);C=C+1|0}while((C|0)<(f[F>>2]|0))}r1(a);D=D+1|0;E=f[m>>2]|0}while((D|0)<(f[E+(B*24|0)>>2]|0))}r1(a);t1(a,467887,+n[(f[m>>2]|0)+(B*24|0)+4>>2]);s1(a,467903,f[(f[m>>2]|0)+(B*24|0)+20>>2]|0);s1(a,467910,f[(f[m>>2]|0)+(B*24|0)+12>>2]|0);r1(a);B=B+1|0}while((B|0)<(f[p>>2]|0));r1(a);r1(a);u=g;return}function BPb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;g=(e*24|0)+40|0;if((e|0)<1){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,35)|0;i=467628;j=h+35|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));CPb(-211,d,467664,113)}d=h0(g)|0;XIc(d|0,0,g|0)|0;g=d+40|0;k=d+32|0;f[k>>2]=g;f[d>>2]=1112539136;f[d+4>>2]=e;l=a+8|0;m=f[l+4>>2]|0;n=d+8|0;f[n>>2]=f[l>>2];f[n+4>>2]=m;m=a+32|0;a=0;n=g;while(1){g=f[m>>2]|0;f[n+(a*24|0)+20>>2]=f[g+(a*24|0)+20>>2];f[n+(a*24|0)+12>>2]=f[g+(a*24|0)+12>>2];f[n+(a*24|0)+16>>2]=f[g+(a*24|0)+16>>2];f[n+(a*24|0)+4>>2]=f[g+(a*24|0)+4>>2];f[n+(a*24|0)>>2]=0;l=h0((f[g+(a*24|0)>>2]|0)*24|0)|0;g=f[k>>2]|0;f[g+(a*24|0)+8>>2]=l;o=f[m>>2]|0;p=f[o+(a*24|0)>>2]|0;f[g+(a*24|0)>>2]=p;q=(p|0)>0;a:do if(q){r=0;do{f[l+(r*24|0)+4>>2]=0;r=r+1|0}while((r|0)<(p|0));if(q){r=0;s=o;t=l;while(1){v=f[s+(a*24|0)+8>>2]|0;w=f[v+(r*24|0)>>2]|0;x=t+(r*24|0)|0;f[x>>2]=w;y=h0(w*80|4)|0;w=t+(r*24|0)+4|0;f[w>>2]=y;z=f[x>>2]|0;A=y+(z<<6)|0;B=t+(r*24|0)+8|0;f[B>>2]=A;C=A+(z<<2)|0;A=t+(r*24|0)+12|0;f[A>>2]=C;D=C+(z<<2)|0;C=t+(r*24|0)+16|0;f[C>>2]=D;E=D+(z<<2)|0;D=t+(r*24|0)+20|0;f[D>>2]=E;b:do if((z|0)>0){F=v+(r*24|0)+4|0;G=v+(r*24|0)+8|0;H=v+(r*24|0)+12|0;I=v+(r*24|0)+16|0;J=v+(r*24|0)+20|0;K=0;L=y;while(1){h=L+(K<<6)|0;i=(f[F>>2]|0)+(K<<6)|0;j=h+64|0;do{f[h>>2]=f[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));f[(f[B>>2]|0)+(K<<2)>>2]=f[(f[G>>2]|0)+(K<<2)>>2];f[(f[A>>2]|0)+(K<<2)>>2]=f[(f[H>>2]|0)+(K<<2)>>2];f[(f[C>>2]|0)+(K<<2)>>2]=f[(f[I>>2]|0)+(K<<2)>>2];M=f[J>>2]|0;N=f[D>>2]|0;f[N+(K<<2)>>2]=f[M+(K<<2)>>2];O=K+1|0;P=f[x>>2]|0;if((O|0)>=(P|0)){Q=P;R=M;S=N;break b}K=O;L=f[w>>2]|0}}else{Q=z;R=f[v+(r*24|0)+20>>2]|0;S=E}while(0);f[S+(Q<<2)>>2]=f[R+(Q<<2)>>2];E=r+1|0;v=f[k>>2]|0;if((E|0)>=(f[v+(a*24|0)>>2]|0)){T=v;break a}r=E;s=f[m>>2]|0;t=f[v+(a*24|0)+8>>2]|0}}else T=g}else T=g;while(0);a=a+1|0;if((a|0)==(e|0))break;else n=T}u=c;return d|0}function CPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,467695,d);return}function DPb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0.0,za=0.0,Aa=0.0,Ba=0,Ca=0;h=u;u=u+160|0;i=h+120|0;j=h+92|0;k=h+64|0;l=h+60|0;m=h+56|0;o=h+8|0;q=h;f[l>>2]=0;f[m>>2]=0;r=(a|0)!=0;if(!r){s=r?-5:-27;f[o>>2]=0;t=o+4|0;f[t>>2]=0;v=tT(o,26)|0;w=v;x=469693;y=w+26|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(s,o,469720,326)}if((f[a>>2]&-65536|0)!=1112539136){s=r?-5:-27;f[o>>2]=0;t=o+4|0;f[t>>2]=0;v=tT(o,26)|0;w=v;x=469693;y=w+26|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(s,o,469720,326)}if(g<=0.0){f[o>>2]=0;f[o+4>>2]=0;w=tT(o,22)|0;x=469756;y=w+22|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-211,o,469720,329)}s=G0(c,i,l,0)|0;i=G0(d,j,m,0)|0;if(f[m>>2]|f[l>>2]|0){f[o>>2]=0;f[o+4>>2]=0;w=tT(o,20)|0;x=469779;y=w+20|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-24,o,469720,335)}l=s+20|0;if((f[l>>2]|0)!=(f[i+20>>2]|0)){f[o>>2]=0;z=o+4|0;f[z>>2]=0;A=tT(o,43)|0;w=A;x=469800;y=w+43|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-209,o,469720,338)}j=s+24|0;if((f[j>>2]|0)!=(f[i+24>>2]|0)){f[o>>2]=0;z=o+4|0;f[z>>2]=0;A=tT(o,43)|0;w=A;x=469800;y=w+43|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-209,o,469720,338)}if((f[i>>2]&4095|0)!=6){f[o>>2]=0;B=o+4|0;f[B>>2]=0;C=tT(o,77)|0;w=C;x=469844;y=w+77|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-210,o,469720,343)}if((f[s>>2]&4095|0)!=4){f[o>>2]=0;B=o+4|0;f[B>>2]=0;C=tT(o,77)|0;w=C;x=469844;y=w+77|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-210,o,469720,343)}C=a+36|0;B=f[C>>2]|0;if(!B){EPb(a);D=f[C>>2]|0}else D=B;do if(f[D+4>>2]|0){B=G0(e,k,m,0)|0;if((f[B>>2]&4095|0)!=4){f[o>>2]=0;f[o+4>>2]=0;w=tT(o,77)|0;x=469844;y=w+77|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-210,o,469720,356)}C=s+4|0;if((f[C>>2]|0)!=(f[B+4>>2]|0)){f[o>>2]=0;f[o+4>>2]=0;w=tT(o,62)|0;x=469922;y=w+62|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-209,o,469720,360)}if((f[l>>2]|0)!=(f[B+20>>2]|0)){f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,43)|0;w=F;x=469800;y=w+43|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-209,o,469720,363)}if((f[j>>2]|0)==(f[B+24>>2]|0)){A=D+72|0;f[A>>2]=f[B>>2];f[A+4>>2]=f[B+4>>2];f[A+8>>2]=f[B+8>>2];f[A+12>>2]=f[B+12>>2];f[A+16>>2]=f[B+16>>2];f[A+20>>2]=f[B+20>>2];f[A+24>>2]=f[B+24>>2];G=B;H=C;break}else{f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,43)|0;w=F;x=469800;y=w+43|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-209,o,469720,363)}}else{G=e;H=s+4|0}while(0);p[a+24>>3]=g;e=a+8|0;F=nrc(+(f[e>>2]|0)*g)|0;f[a+16>>2]=F;F=a+12|0;E=nrc(+(f[F>>2]|0)*g)|0;f[a+20>>2]=E;E=D+16|0;f[E>>2]=f[s>>2];f[E+4>>2]=f[s+4>>2];f[E+8>>2]=f[s+8>>2];f[E+12>>2]=f[s+12>>2];f[E+16>>2]=f[s+16>>2];f[E+20>>2]=f[s+20>>2];f[E+24>>2]=f[s+24>>2];E=D+44|0;f[E>>2]=f[i>>2];f[E+4>>2]=f[i+4>>2];f[E+8>>2]=f[i+8>>2];f[E+12>>2]=f[i+12>>2];f[E+16>>2]=f[i+16>>2];f[E+20>>2]=f[i+20>>2];f[E+24>>2]=f[i+24>>2];E=nrc(g)|0;j=nrc(+((f[e>>2]|0)+-2|0)*g)|0;e=nrc(+((f[F>>2]|0)+-2|0)*g)|0;I=1.0/+(Y(e,j)|0);p[D+8>>3]=I;F=s+16|0;s=f[H>>2]|0;l=Y(s,E)|0;m=E<<2;f[D+120>>2]=(f[F>>2]|0)+l+m;k=j+E|0;j=k<<2;f[D+124>>2]=(f[F>>2]|0)+l+j;l=e+E|0;e=Y(s,l)|0;f[D+128>>2]=(f[F>>2]|0)+e+m;f[D+132>>2]=(f[F>>2]|0)+e+j;j=i+16|0;e=f[i+4>>2]|0;i=Y(e,E)|0;m=E<<3;f[D+104>>2]=(f[j>>2]|0)+i+m;E=k<<3;f[D+108>>2]=(f[j>>2]|0)+i+E;i=Y(e,l)|0;f[D+112>>2]=(f[j>>2]|0)+i+m;f[D+116>>2]=(f[j>>2]|0)+i+E;E=f[a+4>>2]|0;if((E|0)<=0){u=h;return}i=D+100|0;D=a+32|0;a=o+4|0;j=o+8|0;m=o+12|0;l=G+16|0;e=G+4|0;G=o+16|0;k=o+20|0;s=o+24|0;C=o+28|0;B=o+32|0;A=o+36|0;z=o+40|0;d=o+44|0;c=0;v=f[i>>2]|0;a:while(1){if((f[v+(c*28|0)>>2]|0)>0){t=0;r=v;while(1){J=f[r+(c*28|0)+8>>2]|0;if((f[J+(t*12|0)>>2]|0)>0){K=0;L=J;while(1){J=f[(f[(f[D>>2]|0)+(c*24|0)+8>>2]|0)+(t*24|0)+4>>2]|0;M=f[L+(t*12|0)+4>>2]|0;w=o;y=w+48|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));do if(!(f[M+(K*72|0)>>2]|0)){N=-1;O=-1;P=0;Q=0;R=0;S=0;T=0}else{U=f[J+(K<<6)+4>>2]|0;V=f[J+(K<<6)+8>>2]|0;W=f[J+(K<<6)+12>>2]|0;X=f[J+(K<<6)+16>>2]|0;f[o>>2]=U;f[a>>2]=V;f[j>>2]=W;f[m>>2]=X;Z=W+-1|0;_=X+-1|0;if(!(f[M+(K*72|0)+20>>2]|0)){N=_;O=Z;P=1;Q=W;R=X;S=U;T=V;break}$=f[J+(K<<6)+24>>2]|0;aa=f[J+(K<<6)+28>>2]|0;ba=f[J+(K<<6)+32>>2]|0;ca=f[J+(K<<6)+36>>2]|0;f[G>>2]=$;f[k>>2]=aa;f[s>>2]=ba;f[C>>2]=ca;da=ba+-1|0;ba=(Z>>>0>=da>>>0?da^Z:0)^Z;Z=$-U+-1|0;$=(ba>>>0>=Z>>>0?Z^ba:0)^ba;ba=ca+-1|0;ca=(_>>>0>=ba>>>0?ba^_:0)^_;_=aa-V+-1|0;aa=(ca>>>0>=_>>>0?ca^_:0)^ca;if(!(f[M+(K*72|0)+40>>2]|0)){N=aa;O=$;P=2;Q=W;R=X;S=U;T=V;break}ca=f[J+(K<<6)+44>>2]|0;_=f[J+(K<<6)+48>>2]|0;ba=f[J+(K<<6)+52>>2]|0;Z=f[J+(K<<6)+56>>2]|0;f[B>>2]=ca;f[A>>2]=_;f[z>>2]=ba;f[d>>2]=Z;da=ba+-1|0;ba=($>>>0>=da>>>0?da^$:0)^$;$=ca-U+-1|0;ca=Z+-1|0;Z=(aa>>>0>=ca>>>0?ca^aa:0)^aa;aa=_-V+-1|0;N=(Z>>>0>=aa>>>0?Z^aa:0)^Z;O=(ba>>>0>=$>>>0?$^ba:0)^ba;P=3;Q=W;R=X;S=U;T=V}while(0);V=O+1|0;U=N+1|0;X=(Q|0)/(V|0)|0;W=(R|0)/(U|0)|0;if((X|0)<1){ba=(nrc(+(Q|0)*g)|0)/(X|0)|0;ea=nrc(+(S|0)*g)|0;fa=1;ga=ba}else{ea=0;fa=0;ga=0}if((W|0)<1){ba=(nrc(+(R|0)*g)|0)/(W|0)|0;ha=nrc(+(T|0)*g)|0;ia=1;ja=ba}else{ha=0;ia=0;ja=0}if(!P){ka=53;break a}ba=(fa|0)==0;W=(ia|0)==0;X=(f[J+(K<<6)>>2]|0)!=0;la=I*(X?.5:1.0);ma=0.0;na=0.0;$=0;Z=S;aa=Q;while(1){if(ba){_=nrc(+(Z|0)*g)|0;oa=nrc(+(aa|0)*g)|0;pa=_}else{oa=(Y(aa,ga)|0)/(V|0)|0;pa=((Y(Z-S|0,ga)|0)/(V|0)|0)+ea|0}_=f[o+($<<4)+4>>2]|0;ca=f[o+($<<4)+12>>2]|0;if(W){da=nrc(+(_|0)*g)|0;qa=nrc(+(ca|0)*g)|0;ra=da}else{qa=(Y(ca,ja)|0)/(U|0)|0;ra=((Y(_-T|0,ja)|0)/(U|0)|0)+ha|0}_=pa<<2;ca=qa+ra|0;da=oa+pa|0;sa=da<<2;if(X){ta=f[e>>2]|0;ua=ra+oa|0;va=(f[l>>2]|0)+(Y(ta,ua)|0)+sa|0;f[M+(K*72|0)+($*20|0)+8>>2]=va;va=(f[l>>2]|0)+(Y(ta,ua+qa|0)|0)+(da-qa<<2)|0;f[M+(K*72|0)+($*20|0)+12>>2]=va;va=(f[l>>2]|0)+(Y(ta,ra)|0)+_|0;f[M+(K*72|0)+($*20|0)>>2]=va;wa=(f[l>>2]|0)+(Y(ta,ca)|0)+(pa-qa<<2)|0;xa=M+(K*72|0)+($*20|0)+4|0}else{ta=f[H>>2]|0;va=Y(ta,ra)|0;f[M+(K*72|0)+($*20|0)>>2]=(f[F>>2]|0)+va+_;f[M+(K*72|0)+($*20|0)+4>>2]=(f[F>>2]|0)+va+sa;va=Y(ta,ca)|0;f[M+(K*72|0)+($*20|0)+8>>2]=(f[F>>2]|0)+va+_;wa=(f[F>>2]|0)+va+sa|0;xa=M+(K*72|0)+($*20|0)+12|0}f[xa>>2]=wa;ya=la*+n[J+(K<<6)+4+($*20|0)+16>>2];n[M+(K*72|0)+($*20|0)+16>>2]=ya;if(!$){za=+(Y(qa,oa)|0);Aa=na}else{za=ma;Aa=na+ +(qa|0)*(+(oa|0)*ya)}sa=$+1|0;if((sa|0)==(P|0))break;ma=za;na=Aa;$=sa;Z=f[o+(sa<<4)>>2]|0;aa=f[o+(sa<<4)+8>>2]|0}if(!(za>0.0)){ka=53;break a}n[M+(K*72|0)+16>>2]=-Aa/za;K=K+1|0;aa=f[i>>2]|0;L=f[aa+(c*28|0)+8>>2]|0;if((K|0)>=(f[L+(t*12|0)>>2]|0)){Ba=aa;break}}}else Ba=r;t=t+1|0;if((t|0)>=(f[Ba+(c*28|0)>>2]|0)){Ca=Ba;break}else r=Ba}}else Ca=v;c=c+1|0;if((c|0)>=(E|0)){ka=57;break}else v=Ca}if((ka|0)==53){f[q>>2]=0;f[q+4>>2]=0;w=tT(q,9)|0;x=469985;y=w+9|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));CPb(-215,q,469720,517)}else if((ka|0)==57){u=h;return}}function EPb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;c=u;u=u+1040|0;d=c+8|0;e=c;g=c+32|0;h=c+24|0;i=(a|0)!=0;if(!i){j=i?-5:-27;f[h>>2]=0;k=h+4|0;f[k>>2]=0;l=tT(h,26)|0;m=l;o=469693;p=m+26|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));CPb(j,h,469995,152)}if((f[a>>2]&-65536|0)!=1112539136){j=i?-5:-27;f[h>>2]=0;k=h+4|0;f[k>>2]=0;l=tT(h,26)|0;m=l;o=469693;p=m+26|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));CPb(j,h,469995,152)}j=a+36|0;if(f[j>>2]|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,36)|0;o=470029;p=m+36|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));CPb(-2,h,469995,155)}l=a+32|0;k=f[l>>2]|0;if(!k){f[h>>2]=0;f[h+4>>2]=0;CPb(-27,h,469995,158)}i=a+4|0;q=f[i>>2]|0;if((q|0)<1){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,33)|0;o=470066;p=m+33|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));CPb(-211,h,469995,161)}h=f[a+8>>2]|0;o=f[a+12>>2]|0;a=0;r=0;s=0;t=0;a:while(1){v=f[k+(t*24|0)+8>>2]|0;if(!v){w=13;break}x=f[k+(t*24|0)>>2]|0;if((x|0)<1){w=13;break}a=x+a|0;y=0;z=r;A=s;while(1){B=f[v+(y*24|0)>>2]|0;z=B+z|0;if((B|0)>0){C=f[v+(y*24|0)+4>>2]|0;D=0;E=A;while(1){F=C+(D<<6)|0;G=f[C+(D<<6)+12>>2]|0;do if(G){H=f[C+(D<<6)+4>>2]|0;I=f[C+(D<<6)+8>>2]|0;J=f[C+(D<<6)+16>>2]|0;K=(f[F>>2]|0)!=0;M=E|K;if((H+G|0)>(h|0)|(I|G|J|0)<0){N=0;w=25;break a}if(!K)if((H|0)<0|(J+I|0)>(o|0)){N=0;w=25;break a}else{O=M;break}if((H|0)<(J|0)){N=0;w=25;break a}if((I+G+J|0)>(o|0)){N=0;w=25;break a}else O=M}else O=E;while(0);G=f[C+(D<<6)+32>>2]|0;do if(G){M=f[C+(D<<6)+24>>2]|0;J=f[C+(D<<6)+28>>2]|0;I=f[C+(D<<6)+36>>2]|0;H=(f[F>>2]|0)!=0;K=O|H;if((M+G|0)>(h|0)|(J|G|I|0)<0){N=1;w=25;break a}if(!H)if((M|0)<0|(I+J|0)>(o|0)){N=1;w=25;break a}else{P=K;break}if((M|0)<(I|0)){N=1;w=25;break a}if((J+G+I|0)>(o|0)){N=1;w=25;break a}else P=K}else P=O;while(0);G=f[C+(D<<6)+52>>2]|0;do if(G){K=f[C+(D<<6)+44>>2]|0;I=f[C+(D<<6)+48>>2]|0;J=f[C+(D<<6)+56>>2]|0;M=(f[F>>2]|0)!=0;H=P|M;if((K+G|0)>(h|0)|(I|G|J|0)<0){N=2;w=25;break a}if(!M)if((K|0)<0|(J+I|0)>(o|0)){N=2;w=25;break a}else{Q=H;break}if((K|0)<(J|0)){N=2;w=25;break a}if((I+G+J|0)>(o|0)){N=2;w=25;break a}else Q=H}else Q=P;while(0);D=D+1|0;if((D|0)>=(B|0)){R=Q;break}else E=Q}}else R=A;E=y+1|0;if((E|0)>=(x|0))break;else{y=E;A=R}}A=t+1|0;if((A|0)>=(q|0)){w=31;break}else{r=z;s=R;t=A}}if((w|0)==13){f[e>>2]=t;Aqc(g,470100,e)|0;f[e>>2]=0;f[e+4>>2]=0;s=Mpc(g)|0;if(!s)CPb(-2,e,469995,176);dJc(tT(e,s)|0,g|0,s|0)|0;CPb(-2,e,469995,176)}else if((w|0)==25){f[d>>2]=N;f[d+4>>2]=y;f[d+8>>2]=t;Aqc(g,470198,d)|0;f[d>>2]=0;f[d+4>>2]=0;t=Mpc(g)|0;if(!t)CPb(-27,d,469995,208);dJc(tT(d,t)|0,g|0,t|0)|0;CPb(-27,d,469995,208)}else if((w|0)==31){w=h0((z*72|0)+144+(a*12|0)+(a+z<<2)+(q*28|0)|0)|0;XIc(w+8|0,0,136)|0;q=f[i>>2]|0;f[w>>2]=q;z=w+144|0;d=w+100|0;f[d>>2]=z;t=z+(q*28|0)|0;g=w+137|0;b[g>>0]=1;f[w+4>>2]=R&1;R=w+136|0;b[R>>0]=0;if((q|0)<=0){f[j>>2]=w;u=c;return}y=t;N=t+(a*12|0)|0;a=0;t=z;z=q;while(1){q=f[l>>2]|0;e=q+(a*24|0)|0;s=f[e>>2]|0;f[t+(a*28|0)>>2]=s;n[t+(a*28|0)+4>>2]=+n[q+(a*24|0)+4>>2]+-9.999999747378752e-05;r=t+(a*28|0)+8|0;f[r>>2]=y;Q=t+(a*28|0)+12|0;f[Q>>2]=1;P=y+(s*12|0)|0;o=f[q+(a*24|0)+20>>2]|0;f[t+(a*28|0)+24>>2]=(o|0)==-1?0:t+(o*28|0)|0;o=f[q+(a*24|0)+12>>2]|0;h=(o|0)==-1?0:t+(o*28|0)|0;f[t+(a*28|0)+16>>2]=h;o=f[q+(a*24|0)+16>>2]|0;f[t+(a*28|0)+20>>2]=(o|0)==-1?0:t+(o*28|0)|0;b[R>>0]=(h|0)!=0|b[R>>0];if((s|0)>0){s=q+(a*24|0)+8|0;q=0;h=N;o=y;while(1){O=f[s>>2]|0;k=f[O+(q*24|0)>>2]|0;A=h+(k*72|0)|0;f[o+(q*12|0)>>2]=k;x=o+(q*12|0)+4|0;f[x>>2]=h;f[o+(q*12|0)+8>>2]=A;b:do if((k|0)>0){v=O+(q*24|0)+4|0;E=O+(q*24|0)+8|0;B=O+(q*24|0)+12|0;D=O+(q*24|0)+16|0;C=0;G=h;while(1){F=f[v>>2]|0;m=G+(C*72|0)|0;p=m+72|0;do{f[m>>2]=-1;m=m+4|0}while((m|0)<(p|0));f[G+(C*72|0)+60>>2]=f[(f[E>>2]|0)+(C<<2)>>2];f[G+(C*72|0)+64>>2]=f[(f[B>>2]|0)+(C<<2)>>2];f[G+(C*72|0)+68>>2]=f[(f[D>>2]|0)+(C<<2)>>2];if((!(+L(+(+n[F+(C<<6)+60>>2]))<2.220446049250313e-16)?(f[F+(C<<6)+52>>2]|0)!=0:0)?(f[F+(C<<6)+56>>2]|0)!=0:0)f[Q>>2]=0;else{H=G+(C*72|0)+40|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;f[H+16>>2]=0}H=C+1|0;if((H|0)==(k|0))break b;C=H;G=f[x>>2]|0}}while(0);dJc(A|0,f[O+(q*24|0)+20>>2]|0,(k<<2)+4|0)|0;S=A+(k<<2)+4+3&-4;b[g>>0]=(k|0)==1&(b[g>>0]|0)!=0&1;x=q+1|0;if((x|0)>=(f[e>>2]|0))break;q=x;h=S;o=f[r>>2]|0}T=S;U=f[i>>2]|0}else{T=N;U=z}r=a+1|0;if((r|0)>=(U|0))break;y=P;N=T;a=r;t=f[d>>2]|0;z=U}f[j>>2]=w;u=c;return}}function FPb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0.0;h=u;u=u+16|0;i=h;j=(a|0)!=0;if(!j){k=j?-5:-27;f[i>>2]=0;l=i+4|0;f[l>>2]=0;m=tT(i,23)|0;o=m;q=470316;r=o+23|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));CPb(k,i,470340,599)}if((f[a>>2]&-65536|0)!=1112539136){k=j?-5:-27;f[i>>2]=0;l=i+4|0;f[l>>2]=0;m=tT(i,23)|0;o=m;q=470316;r=o+23|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));CPb(k,i,470340,599)}k=f[a+36>>2]|0;if(!k){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,76)|0;q=470370;r=o+76|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));CPb(-27,i,470340,604)}if((d|c|0)<0){s=-1;u=h;return s|0}if(((f[a+16>>2]|0)+c|0)>=(f[k+40>>2]|0)){s=-1;u=h;return s|0}if(((f[a+20>>2]|0)+d|0)>=(f[k+36>>2]|0)){s=-1;u=h;return s|0}a=(Y((f[k+20>>2]|0)>>>2,d)|0)+c|0;i=(Y((f[k+48>>2]|0)>>>3,d)|0)+c|0;t=+p[k+8>>3];v=t*+((f[(f[k+120>>2]|0)+(a<<2)>>2]|0)-(f[(f[k+124>>2]|0)+(a<<2)>>2]|0)-(f[(f[k+128>>2]|0)+(a<<2)>>2]|0)+(f[(f[k+132>>2]|0)+(a<<2)>>2]|0)|0);w=t*(+p[(f[k+104>>2]|0)+(i<<3)>>3]-+p[(f[k+108>>2]|0)+(i<<3)>>3]-+p[(f[k+112>>2]|0)+(i<<3)>>3]+ +p[(f[k+116>>2]|0)+(i<<3)>>3])-v*v;if(!(w>=0.0))x=1.0;else x=+M(+w);if(b[k+136>>0]|0){i=f[k+100>>2]|0;if(!i){s=1;u=h;return s|0}else y=i;a:while(1){p[e>>3]=0.0;i=f[y>>2]|0;if((i|0)>0){c=f[y+8>>2]|0;d=0;w=0.0;while(1){v=+GPb(c+(d*12|0)|0,x,a)+w;p[e>>3]=v;d=d+1|0;if((d|0)>=(i|0)){z=v;break}else w=v}}else z=0.0;if(z>=+n[y+4>>2]){i=f[y+20>>2]|0;if(!i){s=1;A=43;break}else{y=i;continue}}else B=y;while(1){i=f[B+16>>2]|0;if(i|0){y=i;continue a}B=f[B+24>>2]|0;if(!B){s=0;A=43;break a}}}if((A|0)==43){u=h;return s|0}}B=f[k>>2]|0;y=(B|0)>(g|0);if(!(b[k+137>>0]|0)){if(!y){s=1;u=h;return s|0}i=f[k+100>>2]|0;d=g;while(1){p[e>>3]=0.0;c=f[i+(d*28|0)>>2]|0;if((c|0)>0){q=f[i+(d*28|0)+8>>2]|0;o=0;z=0.0;while(1){w=+GPb(q+(o*12|0)|0,x,a)+z;p[e>>3]=w;o=o+1|0;if((o|0)>=(c|0)){C=w;break}else z=w}}else C=0.0;if(C<+n[i+(d*28|0)+4>>2]){s=0-d|0;A=43;break}d=d+1|0;if((d|0)>=(B|0)){s=1;A=43;break}}if((A|0)==43){u=h;return s|0}}if(!y){s=1;u=h;return s|0}y=f[k+100>>2]|0;k=g;while(1){g=f[y+(k*28|0)>>2]|0;d=(g|0)>0;if(!(f[y+(k*28|0)+12>>2]|0))if(d){i=f[y+(k*28|0)+8>>2]|0;c=0;C=0.0;while(1){o=f[i+(c*12|0)+4>>2]|0;z=+n[o+16>>2]*+((f[(f[o>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+4>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+8>>2]|0)+(a<<2)>>2]|0)+(f[(f[o+12>>2]|0)+(a<<2)>>2]|0)|0)+ +n[o+36>>2]*+((f[(f[o+20>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+24>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+28>>2]|0)+(a<<2)>>2]|0)+(f[(f[o+32>>2]|0)+(a<<2)>>2]|0)|0);q=f[o+40>>2]|0;if(!q)D=z;else D=z+ +n[o+56>>2]*+((f[q+(a<<2)>>2]|0)-(f[(f[o+44>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+48>>2]|0)+(a<<2)>>2]|0)+(f[(f[o+52>>2]|0)+(a<<2)>>2]|0)|0);z=C+ +n[(f[i+(c*12|0)+8>>2]|0)+((D>=x*+n[o+60>>2]&1)<<2)>>2];c=c+1|0;if((c|0)>=(g|0)){E=z;break}else C=z}}else E=0.0;else if(d){c=f[y+(k*28|0)+8>>2]|0;i=0;C=0.0;while(1){o=f[c+(i*12|0)+4>>2]|0;z=C+ +n[(f[c+(i*12|0)+8>>2]|0)+((+n[o+16>>2]*+((f[(f[o>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+4>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+8>>2]|0)+(a<<2)>>2]|0)+(f[(f[o+12>>2]|0)+(a<<2)>>2]|0)|0)+ +n[o+36>>2]*+((f[(f[o+20>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+24>>2]|0)+(a<<2)>>2]|0)-(f[(f[o+28>>2]|0)+(a<<2)>>2]|0)+(f[(f[o+32>>2]|0)+(a<<2)>>2]|0)|0)>=x*+n[o+60>>2]&1)<<2)>>2];i=i+1|0;if((i|0)>=(g|0)){E=z;break}else C=z}}else E=0.0;if(E<+n[y+(k*28|0)+4>>2]){A=35;break}g=k+1|0;if((g|0)<(B|0))k=g;else{A=42;break}}if((A|0)==35){p[e>>3]=E;s=0-k|0;u=h;return s|0}else if((A|0)==42){p[e>>3]=E;s=1;u=h;return s|0}return 0}function GPb(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0.0,h=0,i=0.0;d=f[a+4>>2]|0;e=0;do{g=+n[d+(e*72|0)+16>>2]*+((f[(f[d+(e*72|0)>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+4>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+8>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+12>>2]|0)+(c<<2)>>2]|0)|0)+ +n[d+(e*72|0)+36>>2]*+((f[(f[d+(e*72|0)+20>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+24>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+28>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+32>>2]|0)+(c<<2)>>2]|0)|0);h=f[d+(e*72|0)+40>>2]|0;if(!h)i=g;else i=g+ +n[d+(e*72|0)+56>>2]*+((f[h+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+44>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+48>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+52>>2]|0)+(c<<2)>>2]|0)|0);e=f[(i<+n[d+(e*72|0)+60>>2]*b?d+(e*72|0)+64|0:d+(e*72|0)+68|0)>>2]|0}while((e|0)>0);return +(+n[(f[a+8>>2]|0)+(0-e<<2)>>2])}function HPb(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0.0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0;n=u;u=u+704|0;o=n+664|0;q=n+652|0;r=n+640|0;s=n+628|0;t=n+624|0;v=n+620|0;w=n+592|0;x=n+564|0;y=n+536|0;z=n+176|0;A=n+508|0;B=n+480|0;C=n+424|0;D=n+352|0;E=n+344|0;F=n;G=n+288|0;H=n+232|0;I=n+408|0;f[q>>2]=0;J=q+4|0;f[J>>2]=0;f[q+8>>2]=0;f[r>>2]=0;K=r+4|0;f[K>>2]=0;f[r+8>>2]=0;f[s>>2]=0;L=s+4|0;f[L>>2]=0;f[s+8>>2]=0;M=(j&1|0)!=0;N=j&4;O=(N|0)!=0;P=(j&8|0)!=0;k6(v);Q=(c|0)!=0;if(!Q){f[w>>2]=0;R=w+4|0;f[R>>2]=0;S=tT(w,26)|0;T=S;U=470447;V=T+26|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));W=Q?-5:-27;CPb(W,w,470474,1087)}if((f[c>>2]&-65536|0)!=1112539136){f[w>>2]=0;R=w+4|0;f[R>>2]=0;S=tT(w,26)|0;T=S;U=470447;V=T+26|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));W=Q?-5:-27;CPb(W,w,470474,1087)}if(!d){f[w>>2]=0;f[w+4>>2]=0;T=tT(w,20)|0;U=470500;V=T+20|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));CPb(-27,w,470474,1090)}W=G0(a,o,t,0)|0;if(f[t>>2]|0){f[w>>2]=0;f[w+4>>2]=0;T=tT(w,20)|0;U=469779;V=T+20|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));CPb(-24,w,470474,1094)}if(f[W>>2]&7|0){f[w>>2]=0;f[w+4>>2]=0;T=tT(w,31)|0;U=470521;V=T+31|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));CPb(-210,w,470474,1097)}if(h<=1.0){f[w>>2]=0;f[w+4>>2]=0;T=tT(w,24)|0;U=470553;V=T+24|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));CPb(-211,w,470474,1100)}U=l+4|0;T=f[U>>2]|0;if((T|0)!=0?(V=f[l>>2]|0,(V|0)!=0):0){t=W+20|0;o=W+24|0;X=o;Z=t;_=V;$=T;aa=f[t>>2]|0;ba=f[o>>2]|0}else{o=W+20|0;t=f[o>>2]|0;f[U>>2]=t;T=W+24|0;V=f[T>>2]|0;f[l>>2]=V;X=T;Z=o;_=V;$=t;aa=t;ba=V}V=u0(aa,ba,0)|0;if(!V)ca=0;else{ba=VDc(16)|0;f[ba+4>>2]=1;f[ba>>2]=137620;f[ba+8>>2]=V;ca=ba}ba=u0((f[Z>>2]|0)+1|0,(f[X>>2]|0)+1|0,4)|0;if(!ba)da=0;else{aa=VDc(16)|0;f[aa+4>>2]=1;f[aa>>2]=137620;f[aa+8>>2]=ba;da=aa}aa=u0((f[Z>>2]|0)+1|0,(f[X>>2]|0)+1|0,6)|0;if(!aa)ea=0;else{t=VDc(16)|0;f[t+4>>2]=1;f[t>>2]=137620;f[t+8>>2]=aa;ea=t}t=c+36|0;o=f[t>>2]|0;if(!o){EPb(c);fa=f[t>>2]|0}else fa=o;if(!(f[fa+4>>2]|0)){ga=0;ha=0}else{fa=u0((f[Z>>2]|0)+1|0,(f[X>>2]|0)+1|0,4)|0;if(!fa)ia=0;else{X=VDc(16)|0;f[X+4>>2]=1;f[X>>2]=137620;f[X+8>>2]=fa;ia=X}ga=ia;ha=fa}fa=m7(0,56,20,d)|0;if(!(f[W>>2]&4088))ja=W;else{Pga(W,V,6);ja=V}a:do if((j&6|0)==2){W=f[c+8>>2]|0;d=f[c+12>>2]|0;ia=ja+20|0;X=ja+24|0;Z=u0((f[ia>>2]|0)+1|0,(f[X>>2]|0)+1|0,0)|0;if(!Z)ka=0;else{o=VDc(16)|0;f[o+4>>2]=1;f[o>>2]=137620;f[o+8>>2]=Z;ka=o}la=+(W|0);ma=+(d|0);o=W+-2|0;t=d+-2|0;T=k+4|0;a=Z+16|0;Z=w+4|0;Q=w+8|0;S=w+12|0;R=w+16|0;na=w+20|0;oa=w+24|0;pa=ba+16|0;qa=x+4|0;ra=x+8|0;sa=x+12|0;ta=x+16|0;ua=x+20|0;va=x+24|0;wa=aa+16|0;xa=y+4|0;ya=y+8|0;za=y+12|0;Aa=y+16|0;Ba=y+20|0;Ca=y+24|0;Da=(ha|0)==0;Ea=z+4|0;Fa=z+8|0;Ga=z+12|0;Ha=z+16|0;Ia=z+20|0;Ja=z+24|0;Ka=V+16|0;La=B+4|0;Ma=B+8|0;Na=B+12|0;Oa=B+16|0;Pa=B+20|0;Qa=B+24|0;Ra=E+4|0;Sa=I+4|0;Ta=I+8|0;Ua=I+12|0;Va=H+36|0;Wa=H+16|0;Xa=H+4|0;Ya=H+40|0;Za=H+44|0;_a=H+48|0;$a=G+36|0;ab=G+16|0;bb=G+4|0;cb=G+40|0;db=G+44|0;eb=G+48|0;fb=D+36|0;gb=D+16|0;hb=D+4|0;ib=D+40|0;jb=D+44|0;kb=D+48|0;lb=C+36|0;mb=C+16|0;nb=C+4|0;ob=C+40|0;pb=C+44|0;qb=C+48|0;rb=ha+16|0;sb=A+4|0;tb=A+8|0;ub=A+12|0;vb=A+16|0;wb=A+20|0;xb=A+24|0;yb=1.0;while(1){zb=nrc(la*yb)|0;Ab=nrc(ma*yb)|0;Bb=nrc(+(f[X>>2]|0)/yb)|0;Cb=nrc(+(f[ia>>2]|0)/yb)|0;Db=Bb-W|0;Eb=Db+1|0;Fb=Cb-d|0;Gb=Fb+1|0;if((Fb|Db|0)<0){Hb=76;break}if((zb|0)>(f[l>>2]|0)){Hb=78;break}if((Ab|0)>(f[U>>2]|0)){Hb=77;break}do if((zb|0)>=(f[k>>2]|0)){if((Ab|0)<(f[T>>2]|0)){Hb=74;break}Db=f[a>>2]|0;f[w>>2]=1111638016;f[Z>>2]=Bb;f[Q>>2]=0;f[S>>2]=0;f[R>>2]=Db;f[na>>2]=Cb;f[oa>>2]=Bb;Db=Cb+1|0;Ib=Bb+1|0;Jb=f[pa>>2]|0;Kb=Ib<<2;f[x>>2]=1111638020;f[qa>>2]=Kb;f[ra>>2]=0;f[sa>>2]=0;f[ta>>2]=Jb;f[ua>>2]=Db;f[va>>2]=Ib;Jb=f[wa>>2]|0;f[y>>2]=1111638022;f[xa>>2]=Ib<<3;f[ya>>2]=0;f[za>>2]=0;f[Aa>>2]=Jb;f[Ba>>2]=Db;f[Ca>>2]=Ib;if(Da)Lb=0;else{Jb=f[rb>>2]|0;f[A>>2]=1111638020;f[sb>>2]=Kb;f[tb>>2]=0;f[ub>>2]=0;f[vb>>2]=Jb;f[wb>>2]=Db;f[xb>>2]=Ib;Lb=A}f[z>>2]=1111638021;f[Ea>>2]=Eb<<2;f[Fa>>2]=0;f[Ga>>2]=0;f[Ha>>2]=0;f[Ia>>2]=Gb;f[Ja>>2]=Eb;Ib=f[Ka>>2]|0;f[B>>2]=1111638016;f[La>>2]=Eb;f[Ma>>2]=0;f[Na>>2]=0;f[Oa>>2]=Ib;f[Pa>>2]=Gb;f[Qa>>2]=Eb;ofa(ja,w,5);lqa(w,x,y,Lb);Ib=yb>2.0?1:2;Db=((Y((Eb|0)/(Ib|0)|0,Fb+Ib|0)|0)/(Ib|0)|0)+500|0;Jb=(Db|0)<1e3?1:(Db|0)/1e3|0;Db=(Jb|0)<100?Jb:100;DPb(c,x,y,Lb,1.0);O4(C,z,0,1,0,0);O4(D,B,0,1,0,0);f[E>>2]=0;f[Ra>>2]=Db;Jb=Ib+-1+((Db+Fb|0)/(Db|0)|0)|0;O4(G,x,0,1,0,0);O4(H,y,0,1,0,0);f[I>>2]=1;f[Sa>>2]=1;f[Ta>>2]=o;f[Ua>>2]=t;IPb(F,c,Jb-((Jb|0)%(Ib|0)|0)|0,yb,G,H,C,D,I,q,e,g,m,v);y8(E,F,-1.0);JPb(F);Ib=f[Va>>2]|0;do if(Ib|0){Jb=Ib+12|0;Db=f[Jb>>2]|0;f[Jb>>2]=Db+-1;if((Db|0)!=1)break;_S(H)}while(0);f[Va>>2]=0;f[Wa>>2]=0;f[Wa+4>>2]=0;f[Wa+8>>2]=0;f[Wa+12>>2]=0;if((f[Xa>>2]|0)>0){Ib=f[Ya>>2]|0;Db=0;do{f[Ib+(Db<<2)>>2]=0;Db=Db+1|0}while((Db|0)<(f[Xa>>2]|0))}Db=f[Za>>2]|0;if((Db|0)!=(_a|0))g0(Db);Db=f[$a>>2]|0;do if(Db|0){Ib=Db+12|0;Jb=f[Ib>>2]|0;f[Ib>>2]=Jb+-1;if((Jb|0)!=1)break;_S(G)}while(0);f[$a>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[bb>>2]|0)>0){Db=f[cb>>2]|0;Jb=0;do{f[Db+(Jb<<2)>>2]=0;Jb=Jb+1|0}while((Jb|0)<(f[bb>>2]|0))}Jb=f[db>>2]|0;if((Jb|0)!=(eb|0))g0(Jb);Jb=f[fb>>2]|0;do if(Jb|0){Db=Jb+12|0;Ib=f[Db>>2]|0;f[Db>>2]=Ib+-1;if((Ib|0)!=1)break;_S(D)}while(0);f[fb>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[hb>>2]|0)>0){Jb=f[ib>>2]|0;Ib=0;do{f[Jb+(Ib<<2)>>2]=0;Ib=Ib+1|0}while((Ib|0)<(f[hb>>2]|0))}Ib=f[jb>>2]|0;if((Ib|0)!=(kb|0))g0(Ib);Ib=f[lb>>2]|0;do if(Ib|0){Jb=Ib+12|0;Db=f[Jb>>2]|0;f[Jb>>2]=Db+-1;if((Db|0)!=1)break;_S(C)}while(0);f[lb>>2]=0;f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;f[mb+12>>2]=0;if((f[nb>>2]|0)>0){Ib=f[ob>>2]|0;Db=0;do{f[Ib+(Db<<2)>>2]=0;Db=Db+1|0}while((Db|0)<(f[nb>>2]|0))}Db=f[pb>>2]|0;if((Db|0)!=(qb|0))g0(Db)}else Hb=74;while(0);if((Hb|0)==74)Hb=0;yb=yb*h}if((Hb|0)==76){Mb=ka;Nb=0;break}else if((Hb|0)==77){Mb=ka;Nb=0;break}else if((Hb|0)==78){Mb=ka;Nb=0;break}}else{qb=ha;lqa(ja,ba,aa,qb);if(M){pb=ja+24|0;nb=u0((f[ja+20>>2]|0)+1|0,(f[pb>>2]|0)+1|0,4)|0;if(!nb)Ob=0;else{ob=VDc(16)|0;f[ob+4>>2]=1;f[ob>>2]=137620;f[ob+8>>2]=nb;Ob=ob}eoa(ja,V,0.0,50.0,3);lqa(V,nb,0,0);Pb=pb;Qb=Ob;Rb=nb}else{Pb=ja+24|0;Qb=0;Rb=0}nb=c+8|0;pb=f[nb>>2]|0;yb=+(pb|0);ob=f[Pb>>2]|0;ma=+(ob+-10|0);if(yb<ma){la=+(f[c+12>>2]|0);Sb=+((f[ja+20>>2]|0)+-10|0);mb=0;Tb=1.0;while(1){if(!(Tb*la<Sb)){Ub=mb;Vb=Tb;break}lb=mb+1|0;Wb=Tb*h;if(Wb*yb<ma){mb=lb;Tb=Wb}else{Ub=lb;Vb=Wb;break}}Tb=1.0/h;ma=O?Tb:h;if((Ub|0)>0){mb=c+12|0;lb=ja+20|0;kb=k+4|0;jb=Rb;hb=jb+16|0;ib=jb+4|0;jb=w+4|0;gb=w+8|0;fb=w+12|0;eb=ba+16|0;db=ba+4|0;bb=x+4|0;cb=x+8|0;ab=x+12|0;$a=y+4|0;_a=z+20|0;Za=z+24|0;Xa=z+28|0;Ya=z+4|0;Wa=z+8|0;Va=z+16|0;t=z+36|0;Ua=z+40|0;o=z+44|0;Ta=z+48|0;Sa=(i|0)>1?i:1;Ra=q+8|0;Qa=y+4|0;Pa=y+8|0;Oa=y+12|0;yb=P?.6:.4;Sb=O?Tb*Vb:1.0;Na=Ub;Ma=0;La=0;Ka=0;Ja=0;Ia=pb;Ha=ob;Ga=f[k>>2]|0;while(1){Fa=Na+-1|0;Tb=Sb>2.0?Sb:2.0;Ea=nrc(Sb*+(Ia|0))|0;xb=nrc(Sb*+(f[mb>>2]|0))|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;wb=nrc(+(Ha-Ea|0)/Tb)|0;vb=nrc(+((f[lb>>2]|0)-xb|0)/Tb)|0;do if((Ea|0)<(Ga|0))Hb=92;else{if((xb|0)<(f[kb>>2]|0)){Hb=92;break}if((Ea|0)>(_|0)|(xb|0)>($|0))if(O){Xb=Ma;Yb=La;Zb=Ka;_b=Ja;$b=Ga;break}else{Mb=0;Nb=Qb;break a}DPb(c,ba,aa,qb,Sb);s_(V);if(M){la=+(Ea|0);ub=nrc(la*.15)|0;Wb=+(xb|0);tb=nrc(Wb*.15)|0;sb=nrc(la*.7)|0;rb=nrc(Wb*.7)|0;Da=f[hb>>2]|0;Ca=f[ib>>2]|0;Ba=Da+(Y(Ca,tb)|0)+(ub<<2)|0;f[w>>2]=Ba;f[jb>>2]=Ba+(sb<<2);Ba=rb+tb|0;rb=Da+(Y(Ca,Ba)|0)+(ub<<2)|0;f[gb>>2]=rb;f[fb>>2]=rb+(sb<<2);rb=f[eb>>2]|0;Ca=f[db>>2]|0;Da=rb+(Y(Ca,tb)|0)+(ub<<2)|0;f[x>>2]=Da;f[bb>>2]=Da+(sb<<2);Da=rb+(Y(Ca,Ba)|0)+(ub<<2)|0;f[cb>>2]=Da;f[ab>>2]=Da+(sb<<2)}sb=(Ka|0)<1|(Ja|0)<1;if(sb){ac=vb;bc=wb;cc=0;dc=0}else{Da=nrc(+(La|0)/Tb)|0;ub=nrc(+(Ja+La-xb|0)/Tb)|0;Ba=nrc(+(Ma|0)/Tb)|0;ac=ub;bc=nrc(+(Ka+Ma-Ea|0)/Tb)|0;cc=Da;dc=Ba}f[y>>2]=cc;f[$a>>2]=ac;Ba=f[db>>2]|0;f[z>>2]=137640;f[Ya>>2]=c;f[_a>>2]=Ea;f[Za>>2]=xb;Da=Xa;f[Da>>2]=dc;f[Da+4>>2]=bc;p[Wa>>3]=Tb;f[Va>>2]=Ba;f[t>>2]=w;f[Ua>>2]=x;f[o>>2]=q;f[Ta>>2]=v;y8(y,z,-1.0);if(!O){Xb=Ma;Yb=La;Zb=Ka;_b=Ja;$b=Ga;break}Ba=f[q>>2]|0;Da=f[J>>2]|0;if((Ba|0)==(Da|0)){Xb=Ma;Yb=La;Zb=Ka;_b=Ja;$b=Ga;break}if(!sb){Xb=Ma;Yb=La;Zb=Ka;_b=Ja;$b=Ga;break}sb=Da-Ba>>4;ub=f[K>>2]|0;Ca=f[r>>2]|0;rb=ub-Ca>>4;tb=Ca;Ca=ub;do if(sb>>>0>rb>>>0){JOb(r,sb-rb|0);ec=f[q>>2]|0;fc=f[J>>2]|0}else{if(sb>>>0>=rb>>>0){ec=Ba;fc=Da;break}ub=tb+(sb<<4)|0;if((Ca|0)==(ub|0)){ec=Ba;fc=Da;break}f[K>>2]=Ca+(~((Ca+-16-ub|0)>>>4)<<4);ec=Ba;fc=Da}while(0);if((ec|0)!=(fc|0)){Da=ec;Ba=f[r>>2]|0;while(1){f[Ba>>2]=f[Da>>2];f[Ba+4>>2]=f[Da+4>>2];f[Ba+8>>2]=f[Da+8>>2];f[Ba+12>>2]=f[Da+12>>2];Da=Da+16|0;if((Da|0)==(fc|0))break;else Ba=Ba+16|0}}$Ob(r,Sa,.2);Ba=f[r>>2]|0;Da=f[K>>2]|0;if((Ba|0)==(Da|0)){Xb=Ma;Yb=La;Zb=Ka;_b=Ja;$b=Ga;break}Ca=Da-Ba>>4;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if(!Ca){gc=0;hc=0;ic=0;jc=0}else{Da=0;sb=0;tb=0;rb=0;ub=0;while(1){Aa=f[Ba+(Da<<4)+8>>2]|0;za=f[Ba+(Da<<4)+12>>2]|0;if((Y(za,Aa)|0)>(Y(tb,sb)|0)){ya=f[Ba+(Da<<4)>>2]|0;f[y>>2]=ya;xa=f[Ba+(Da<<4)+4>>2]|0;f[Qa>>2]=xa;f[Pa>>2]=Aa;f[Oa>>2]=za;kc=xa;lc=ya;mc=za;nc=Aa}else{kc=rb;lc=ub;mc=tb;nc=sb}Da=Da+1|0;if((Da|0)==(Ca|0)){gc=lc;hc=kc;ic=nc;jc=mc;break}else{sb=nc;tb=mc;rb=kc;ub=lc}}}ub=f[J>>2]|0;if((ub|0)==(f[Ra>>2]|0))$Lb(q,y);else{f[ub>>2]=gc;f[ub+4>>2]=hc;f[ub+8>>2]=ic;f[ub+12>>2]=jc;f[J>>2]=ub+16}ub=f[y>>2]|0;rb=f[Qa>>2]|0;tb=f[Pa>>2]|0;sb=f[Oa>>2]|0;Wb=+(tb|0);Ca=nrc(Wb*.2)|0;la=+(sb|0);Da=nrc(la*.2)|0;Ba=ub-Ca|0;ub=(Ba|0)>0?Ba:0;Ba=rb-Da|0;rb=(Ba|0)>0?Ba:0;Ba=(Ca<<1)+tb|0;tb=(f[Pb>>2]|0)+-1-ub|0;Ca=(Da<<1)+sb|0;sb=(f[lb>>2]|0)+-1-rb|0;Da=nrc(yb*Wb)|0;f[k>>2]=Da;Aa=nrc(yb*la)|0;f[kb>>2]=Aa;Xb=ub;Yb=rb;Zb=(tb|0)<(Ba|0)?tb:Ba;_b=(sb|0)<(Ca|0)?sb:Ca;$b=Da}while(0);if((Hb|0)==92){Hb=0;if(O){Mb=0;Nb=Qb;break a}else{Xb=Ma;Yb=La;Zb=Ka;_b=Ja;$b=Ga}}if((Na|0)<=1){Mb=0;Nb=Qb;break a}Sb=ma*Sb;Na=Fa;Ma=Xb;La=Yb;Ka=Zb;Ja=_b;Ia=f[nb>>2]|0;Ha=f[Pb>>2]|0;Ga=$b}}else{Mb=0;Nb=Qb}}else{Mb=0;Nb=Qb}}while(0);Qb=f[J>>2]|0;$b=f[q>>2]|0;Pb=Qb-$b>>4;_b=f[K>>2]|0;Zb=f[r>>2]|0;Yb=_b-Zb>>4;Xb=Zb;Zb=_b;_b=$b;$b=Qb;if(Pb>>>0<=Yb>>>0)if(Pb>>>0<Yb>>>0?(Qb=Xb+(Pb<<4)|0,(Zb|0)!=(Qb|0)):0){f[K>>2]=Zb+(~((Zb+-16-Qb|0)>>>4)<<4);oc=_b;pc=$b}else{oc=_b;pc=$b}else{JOb(r,Pb-Yb|0);oc=f[q>>2]|0;pc=f[J>>2]|0}if((oc|0)!=(pc|0)){Yb=oc;oc=f[r>>2]|0;while(1){f[oc>>2]=f[Yb>>2];f[oc+4>>2]=f[Yb+4>>2];f[oc+8>>2]=f[Yb+8>>2];f[oc+12>>2]=f[Yb+12>>2];Yb=Yb+16|0;if((Yb|0)==(pc|0))break;else oc=oc+16|0}}do if(N|i)if(m){bPb(r,e,g,i,.2);break}else{aPb(r,s,(i|0)>1?i:1,.2);break}else{oc=(f[K>>2]|0)-(f[r>>2]|0)>>4;f[w>>2]=0;pc=f[L>>2]|0;Yb=f[s>>2]|0;Pb=pc-Yb>>2;$b=Yb;Yb=pc;do if(oc>>>0>Pb>>>0)Zv(s,oc-Pb|0,w);else{if(oc>>>0>=Pb>>>0)break;pc=$b+(oc<<2)|0;if((Yb|0)==(pc|0))break;f[L>>2]=Yb+(~((Yb+-4-pc|0)>>>2)<<2)}while(0)}while(0);i=f[K>>2]|0;g=f[r>>2]|0;e=(i|0)==(g|0);if(O){O=g;if(!e){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;m=w+8|0;N=w+12|0;Yb=w+4|0;oc=f[s>>2]|0;$b=w+16|0;Pb=i-g>>4;i=0;pc=0;_b=0;while(1){Qb=f[O+(i<<4)+8>>2]|0;Zb=f[O+(i<<4)+12>>2]|0;if((Y(Zb,Qb)|0)>(Y(_b,pc)|0)){Xb=f[O+(i<<4)+4>>2]|0;f[w>>2]=f[O+(i<<4)>>2];f[Yb>>2]=Xb;f[m>>2]=Qb;f[N>>2]=Zb;f[$b>>2]=f[oc+(i<<2)>>2];qc=Zb;rc=Qb}else{qc=_b;rc=pc}i=i+1|0;if(i>>>0>=Pb>>>0)break;else{pc=rc;_b=qc}}A7(fa,w)|0}}else if(!e){e=w+4|0;qc=w+8|0;_b=w+12|0;rc=w+16|0;pc=0;Pb=g;do{g=Pb;i=f[g+(pc<<4)+4>>2]|0;oc=f[g+(pc<<4)+8>>2]|0;$b=f[g+(pc<<4)+12>>2]|0;f[w>>2]=f[g+(pc<<4)>>2];f[e>>2]=i;f[qc>>2]=oc;f[_b>>2]=$b;$b=f[s>>2]|0;if(($b|0)==(f[L>>2]|0))sc=0;else sc=f[$b+(pc<<2)>>2]|0;f[rc>>2]=sc;A7(fa,w)|0;pc=pc+1|0;Pb=f[r>>2]|0}while(pc>>>0<(f[K>>2]|0)-Pb>>4>>>0)}l6(v);v=f[s>>2]|0;if(v|0){s=f[L>>2]|0;if((s|0)!=(v|0))f[L>>2]=s+(~((s+-4-v|0)>>>2)<<2);YDc(v)}v=f[r>>2]|0;if(v|0){r=f[K>>2]|0;if((r|0)!=(v|0))f[K>>2]=r+(~((r+-16-v|0)>>>4)<<4);YDc(v)}v=f[q>>2]|0;if(v|0){q=f[J>>2]|0;if((q|0)!=(v|0))f[J>>2]=q+(~((q+-16-v|0)>>>4)<<4);YDc(v)}v=Mb;do if(Mb|0){q=v+4|0;J=f[q>>2]|0;f[q>>2]=J+-1;if((J|0)!=1)break;Yi[f[(f[Mb>>2]|0)+8>>2]&2047](v)}while(0);v=Nb;do if(Nb|0){Mb=v+4|0;J=f[Mb>>2]|0;f[Mb>>2]=J+-1;if((J|0)!=1)break;Yi[f[(f[Nb>>2]|0)+8>>2]&2047](v)}while(0);v=ea;do if(ea|0){Nb=v+4|0;J=f[Nb>>2]|0;f[Nb>>2]=J+-1;if((J|0)!=1)break;Yi[f[(f[ea>>2]|0)+8>>2]&2047](v)}while(0);v=ga;do if(ga|0){ea=v+4|0;J=f[ea>>2]|0;f[ea>>2]=J+-1;if((J|0)!=1)break;Yi[f[(f[ga>>2]|0)+8>>2]&2047](v)}while(0);v=da;do if(da|0){ga=v+4|0;J=f[ga>>2]|0;f[ga>>2]=J+-1;if((J|0)!=1)break;Yi[f[(f[da>>2]|0)+8>>2]&2047](v)}while(0);v=ca;if(!ca){u=n;return fa|0}da=v+4|0;J=f[da>>2]|0;f[da>>2]=J+-1;if((J|0)!=1){u=n;return fa|0}Yi[f[(f[ca>>2]|0)+8>>2]&2047](v);u=n;return fa|0}function IPb(a,b,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f[a>>2]=137660;q=a+24|0;f[q>>2]=1124007936;r=a+28|0;s=a+32|0;t=a+64|0;u=r;v=u+36|0;do{f[u>>2]=0;u=u+4|0}while((u|0)<(v|0));f[t>>2]=s;w=a+72|0;x=a+68|0;f[x>>2]=w;f[w>>2]=0;f[a+76>>2]=0;w=a+80|0;f[w>>2]=1124007936;y=a+84|0;z=a+88|0;A=a+120|0;u=y;v=u+36|0;do{f[u>>2]=0;u=u+4|0}while((u|0)<(v|0));f[A>>2]=z;u=a+128|0;v=a+124|0;f[v>>2]=u;f[u>>2]=0;f[a+132>>2]=0;u=a+144|0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=0;f[u+12>>2]=0;f[a+4>>2]=b;f[a+8>>2]=c;p[a+16>>3]=d;if((q|0)!=(e|0)){c=e+36|0;b=f[c>>2]|0;if(b){B=b+12|0;f[B>>2]=(f[B>>2]|0)+1;B=a+60|0;b=f[B>>2]|0;if((b|0)!=0?(C=b+12|0,b=f[C>>2]|0,f[C>>2]=b+-1,(b|0)==1):0){_S(q);D=B}else D=B}else D=a+60|0;f[D>>2]=0;B=a+40|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[r>>2]|0)>0){b=f[t>>2]|0;t=0;do{f[b+(t<<2)>>2]=0;t=t+1|0;E=f[r>>2]|0}while((t|0)<(E|0));f[q>>2]=f[e>>2];if((E|0)<3)F=12;else F=14}else{f[q>>2]=f[e>>2];F=12}if((F|0)==12){E=f[e+4>>2]|0;if((E|0)<3){f[r>>2]=E;f[s>>2]=f[e+8>>2];f[a+36>>2]=f[e+12>>2];s=f[e+44>>2]|0;E=f[x>>2]|0;f[E>>2]=f[s>>2];f[E+4>>2]=f[s+4>>2]}else F=14}if((F|0)==14)ZS(q,e);f[B>>2]=f[e+16>>2];f[a+44>>2]=f[e+20>>2];f[a+48>>2]=f[e+24>>2];f[a+52>>2]=f[e+28>>2];f[a+56>>2]=f[e+32>>2];f[D>>2]=f[c>>2]}if((w|0)==(g|0)){G=a+136|0;f[G>>2]=h;H=a+140|0;f[H>>2]=i;I=f[j>>2]|0;f[u>>2]=I;J=j+4|0;K=f[J>>2]|0;L=a+148|0;f[L>>2]=K;M=j+8|0;N=f[M>>2]|0;O=a+152|0;f[O>>2]=N;P=j+12|0;Q=f[P>>2]|0;R=a+156|0;f[R>>2]=Q;S=a+160|0;f[S>>2]=k;T=n?l:0;U=a+164|0;f[U>>2]=T;V=n?m:0;W=a+168|0;f[W>>2]=V;X=a+172|0;f[X>>2]=o;return}c=g+36|0;D=f[c>>2]|0;if(D|0){e=D+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+116|0;D=f[e>>2]|0;if(D|0?(B=D+12|0,D=f[B>>2]|0,f[B>>2]=D+-1,(D|0)==1):0)_S(w);f[e>>2]=0;D=a+96|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[y>>2]|0)>0){B=f[A>>2]|0;A=0;do{f[B+(A<<2)>>2]=0;A=A+1|0;Y=f[y>>2]|0}while((A|0)<(Y|0));f[w>>2]=f[g>>2];if((Y|0)<3)F=27;else F=29}else{f[w>>2]=f[g>>2];F=27}if((F|0)==27){Y=f[g+4>>2]|0;if((Y|0)<3){f[y>>2]=Y;f[z>>2]=f[g+8>>2];f[a+92>>2]=f[g+12>>2];z=f[g+44>>2]|0;Y=f[v>>2]|0;f[Y>>2]=f[z>>2];f[Y+4>>2]=f[z+4>>2]}else F=29}if((F|0)==29)ZS(w,g);f[D>>2]=f[g+16>>2];f[a+100>>2]=f[g+20>>2];f[a+104>>2]=f[g+24>>2];f[a+108>>2]=f[g+28>>2];f[a+112>>2]=f[g+32>>2];f[e>>2]=f[c>>2];G=a+136|0;f[G>>2]=h;H=a+140|0;f[H>>2]=i;I=f[j>>2]|0;f[u>>2]=I;J=j+4|0;K=f[J>>2]|0;L=a+148|0;f[L>>2]=K;M=j+8|0;N=f[M>>2]|0;O=a+152|0;f[O>>2]=N;P=j+12|0;Q=f[P>>2]|0;R=a+156|0;f[R>>2]=Q;S=a+160|0;f[S>>2]=k;T=n?l:0;U=a+164|0;f[U>>2]=T;V=n?m:0;W=a+168|0;f[W>>2]=V;X=a+172|0;f[X>>2]=o;return}function JPb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137660;b=a+80|0;c=a+116|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+96|0;b=a+84|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+120>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+124>>2]|0;if((b|0)!=(a+128|0))g0(b);b=a+24|0;d=a+60|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+40|0;b=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+64>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0))return;g0(b);return}function KPb(a){a=a|0;YDc(a);return}function LPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;c=u;u=u+64|0;d=c;e=c+56|0;g=c+52|0;h=c+24|0;i=c+48|0;j=c+44|0;k=c+40|0;l=c+36|0;m=c+20|0;n=c+16|0;o=f[b>>2]|0;q=f[b+4>>2]|0;b=f[a+36>>2]|0;r=f[b>>2]|0;s=f[b+4>>2]|0;t=f[b+8>>2]|0;v=f[b+12>>2]|0;b=f[a+40>>2]|0;w=f[b>>2]|0;x=f[b+4>>2]|0;y=f[b+8>>2]|0;z=f[b+12>>2]|0;b=(r|0)==0;A=(f[a+16>>2]|0)>>>2;f[h>>2]=0;B=h+4|0;f[B>>2]=0;f[h+8>>2]=0;if((o|0)>=(q|0)){u=c;return}C=a+8|0;D=a+28|0;E=a+32|0;F=a+4|0;G=a+20|0;H=a+24|0;I=d+4|0;J=d+8|0;K=d+12|0;L=h+8|0;M=a+48|0;N=a+44|0;O=o;o=f[E>>2]|0;while(1){P=+p[C>>3];Q=nrc(+(O|0)*P)|0;R=f[D>>2]|0;a:do if((R|0)<(o|0)){S=Y(Q,A)|0;T=R;U=o;V=P;while(1){W=nrc(+(T|0)*V)|0;if(!b?(X=W+S|0,((f[r+(X<<2)>>2]|0)-(f[s+(X<<2)>>2]|0)-(f[t+(X<<2)>>2]|0)+(f[v+(X<<2)>>2]|0)|0)<100?1:((f[w+(X<<2)>>2]|0)-(f[x+(X<<2)>>2]|0)-(f[y+(X<<2)>>2]|0)+(f[z+(X<<2)>>2]|0)|0)<20):0){Z=2;_=U}else{X=FPb(f[F>>2]|0,W,Q,d,0)|0;if((X|0)>0){$=f[G>>2]|0;aa=f[H>>2]|0;f[d>>2]=W;f[I>>2]=Q;f[J>>2]=$;f[K>>2]=aa;ba=f[B>>2]|0;if((ba|0)==(f[L>>2]|0)){$Lb(h,d);ca=f[B>>2]|0}else{f[ba>>2]=W;f[ba+4>>2]=Q;f[ba+8>>2]=$;f[ba+12>>2]=aa;aa=ba+16|0;f[B>>2]=aa;ca=aa}if(ca-(f[h>>2]|0)>>4>>>0>99?(m6(f[M>>2]|0),aa=f[N>>2]|0,f[i>>2]=f[aa+4>>2],f[j>>2]=f[h>>2],f[k>>2]=f[B>>2],f[g>>2]=f[i>>2],f[e>>2]=f[j>>2],f[d>>2]=f[k>>2],MPb(aa,g,e,d)|0,n6(f[M>>2]|0),aa=f[h>>2]|0,ba=f[B>>2]|0,(ba|0)!=(aa|0)):0)f[B>>2]=ba+(~((ba+-16-aa|0)>>>4)<<4)}Z=X|0?1:2;_=f[E>>2]|0}X=Z+T|0;if((X|0)>=(_|0)){da=_;break a}T=X;U=_;V=+p[C>>3]}}else da=o;while(0);O=O+1|0;if((O|0)>=(q|0))break;else o=da}da=f[h>>2]|0;if((f[B>>2]|0)==(da|0))ea=da;else{da=a+48|0;m6(f[da>>2]|0);o=f[a+44>>2]|0;f[l>>2]=f[o+4>>2];f[m>>2]=f[h>>2];f[n>>2]=f[B>>2];f[g>>2]=f[l>>2];f[e>>2]=f[m>>2];f[d>>2]=f[n>>2];MPb(o,g,e,d)|0;n6(f[da>>2]|0);ea=f[h>>2]|0}if(!ea){u=c;return}h=f[B>>2]|0;if((h|0)!=(ea|0))f[B>>2]=h+(~((h+-16-ea|0)>>>4)<<4);YDc(ea);u=c;return}function MPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=h>>4;i=e+(b<<4)|0;j=f[c>>2]|0;c=f[d>>2]|0;d=c-j|0;k=d>>4;l=j;m=c;if((d|0)<=0){n=i;return n|0}d=a+8|0;o=f[d>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((k|0)<=(o-r>>4|0)){s=i;t=r-s|0;u=t>>4;if((k|0)>(u|0)){v=l+(u<<4)|0;u=v;if((v|0)==(m|0))w=q;else{x=m+-16-u|0;y=v;v=q;while(1){f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2];f[v+8>>2]=f[y+8>>2];f[v+12>>2]=f[y+12>>2];y=y+16|0;if((y|0)==(m|0))break;else v=v+16|0}v=q+((x>>>4)+1<<4)|0;f[p>>2]=v;w=v}if((t|0)>0){z=u;A=w}else{n=i;return n|0}}else{z=c;A=q}c=A-(i+(k<<4))>>4;w=i+(c<<4)|0;if(w>>>0<q>>>0){u=(q+(0-c<<4)+~s|0)>>>4;s=w;t=A;while(1){f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=s+16|0;if(s>>>0>=q>>>0)break;else t=t+16|0}f[p>>2]=A+(u+1<<4)}if(c|0){c=w;w=A;do{A=c;c=c+-16|0;u=w;w=w+-16|0;f[w>>2]=f[c>>2];f[u+-12>>2]=f[A+-12>>2];f[u+-8>>2]=f[A+-8>>2];f[u+-4>>2]=f[A+-4>>2]}while((c|0)!=(i|0))}c=z;if((l|0)==(c|0)){n=i;return n|0}else{B=i;C=l}while(1){f[B>>2]=f[C>>2];f[B+4>>2]=f[C+4>>2];f[B+8>>2]=f[C+8>>2];f[B+12>>2]=f[C+12>>2];C=C+16|0;if((C|0)==(c|0)){n=i;break}else B=B+16|0}return n|0}B=(r-g>>4)+k|0;if(B>>>0>268435455)mCc(a);k=o-g|0;o=k>>3;r=k>>4>>>0<134217727?(o>>>0<B>>>0?B:o):268435455;o=i;B=h>>4;do if(r)if(r>>>0>268435455){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{D=VDc(r<<4)|0;break}else D=0;while(0);h=D+(B<<4)|0;B=D+(r<<4)|0;if((l|0)==(m|0))E=h;else{r=((m+-16-j|0)>>>4)+1|0;j=l;l=h;while(1){f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];f[l+12>>2]=f[j+12>>2];j=j+16|0;if((j|0)==(m|0))break;else l=l+16|0}E=h+(r<<4)|0}if(!b)F=h;else{b=i+-16-g|0;g=i;r=h;while(1){l=g;g=g+-16|0;f[r+-16>>2]=f[g>>2];f[r+-12>>2]=f[l+-12>>2];f[r+-8>>2]=f[l+-8>>2];f[r+-4>>2]=f[l+-4>>2];if((g|0)==(e|0))break;else r=r+-16|0}F=h+(~(b>>>4)<<4)|0}b=F;if((q|0)==(i|0))G=E;else{F=q+-16-o|0;o=i;i=E;while(1){f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];f[i+12>>2]=f[o+12>>2];o=o+16|0;if((o|0)==(q|0))break;else i=i+16|0}G=E+((F>>>4)+1<<4)|0}f[a>>2]=b;f[p>>2]=G;f[d>>2]=B;if(!e){n=h;return n|0}YDc(e);n=h;return n|0}function NPb(a){a=a|0;JPb(a);YDc(a);return}function OPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0;c=u;u=u+176|0;d=c+152|0;e=c+144|0;g=c+140|0;h=c+56|0;i=c+40|0;j=c+24|0;k=c;l=c+136|0;m=c+132|0;n=c+128|0;o=c+124|0;q=c+120|0;r=c+116|0;s=c+112|0;t=c+108|0;v=c+104|0;w=c+100|0;x=c+96|0;y=c+92|0;z=c+88|0;A=c+84|0;B=c+80|0;C=c+76|0;D=c+72|0;E=c+68|0;F=c+52|0;G=c+36|0;H=c+20|0;I=c+16|0;J=c+12|0;K=c+8|0;L=a+4|0;M=f[L>>2]|0;N=f[M+8>>2]|0;O=f[M+12>>2]|0;M=a+16|0;P=+p[M>>3];Q=nrc(+(N|0)*P)|0;R=nrc(+(O|0)*P)|0;S=f[a+8>>2]|0;T=Y(S,f[b>>2]|0)|0;U=Y(f[b+4>>2]|0,S)|0;S=(f[a+32>>2]|0)+~O|0;O=(S|0)<(U|0)?S:U;if((O|0)<=(T|0)){u=c;return}U=f[a+36>>2]|0;if((U|0)<=(N+1|0)){u=c;return}S=U+~N|0;N=P>2.0?1:2;f[h>>2]=0;U=h+4|0;f[U>>2]=0;f[h+8>>2]=0;f[i>>2]=0;b=i+4|0;f[b>>2]=0;f[i+8>>2]=0;f[j>>2]=0;V=j+4|0;f[V>>2]=0;f[j+8>>2]=0;W=(S|0)>0;X=a+164|0;Z=d+4|0;_=d+8|0;$=d+12|0;aa=h+8|0;ba=a+172|0;ca=a+160|0;da=d+4|0;ea=d+8|0;fa=d+12|0;ga=i+8|0;ha=j+8|0;ia=a+168|0;ja=T;do{if(W){P=+(ja|0);T=0;do{ka=FPb(f[L>>2]|0,T,ja,k,0)|0;if(!(f[X>>2]|0)){if((ka|0)>0){la=+p[M>>3];ma=nrc(+(T|0)*la)|0;na=nrc(P*la)|0;f[d>>2]=ma;f[Z>>2]=na;f[_>>2]=Q;f[$>>2]=R;oa=f[U>>2]|0;if((oa|0)==(f[aa>>2]|0)){$Lb(h,d);pa=f[U>>2]|0}else{f[oa>>2]=ma;f[oa+4>>2]=na;f[oa+8>>2]=Q;f[oa+12>>2]=R;na=oa+16|0;f[U>>2]=na;pa=na}if(pa-(f[h>>2]|0)>>4>>>0>99?(m6(f[ba>>2]|0),na=f[ca>>2]|0,f[w>>2]=f[na+4>>2],f[x>>2]=f[h>>2],f[y>>2]=f[U>>2],f[g>>2]=f[w>>2],f[e>>2]=f[x>>2],f[d>>2]=f[y>>2],MPb(na,g,e,d)|0,n6(f[ba>>2]|0),na=f[h>>2]|0,oa=f[U>>2]|0,(oa|0)!=(na|0)):0)f[U>>2]=oa+(~((oa+-16-na|0)>>>4)<<4)}}else{na=f[(f[L>>2]|0)+4>>2]|0;oa=(ka|0)==1?0-na|0:ka;if((oa+na|0)<4){la=+p[M>>3];na=nrc(+(T|0)*la)|0;ka=nrc(P*la)|0;f[d>>2]=na;f[da>>2]=ka;f[ea>>2]=Q;f[fa>>2]=R;ma=f[U>>2]|0;if((ma|0)==(f[aa>>2]|0))$Lb(h,d);else{f[ma>>2]=na;f[ma+4>>2]=ka;f[ma+8>>2]=Q;f[ma+12>>2]=R;f[U>>2]=ma+16}ma=0-oa|0;f[d>>2]=ma;oa=f[b>>2]|0;if((oa|0)==(f[ga>>2]|0))g6(i,d);else{f[oa>>2]=ma;f[b>>2]=oa+4}oa=f[V>>2]|0;if((oa|0)==(f[ha>>2]|0))zOb(j,k);else{p[oa>>3]=+p[k>>3];f[V>>2]=oa+8}if((f[U>>2]|0)-(f[h>>2]|0)>>4>>>0>99){m6(f[ba>>2]|0);oa=f[ca>>2]|0;f[l>>2]=f[oa+4>>2];f[m>>2]=f[h>>2];f[n>>2]=f[U>>2];f[g>>2]=f[l>>2];f[e>>2]=f[m>>2];f[d>>2]=f[n>>2];MPb(oa,g,e,d)|0;oa=f[X>>2]|0;f[o>>2]=f[oa+4>>2];f[q>>2]=f[i>>2];f[r>>2]=f[b>>2];f[g>>2]=f[o>>2];f[e>>2]=f[q>>2];f[d>>2]=f[r>>2];yxa(oa,g,e,d)|0;oa=f[ia>>2]|0;f[s>>2]=f[oa+4>>2];f[t>>2]=f[j>>2];f[v>>2]=f[V>>2];f[g>>2]=f[s>>2];f[e>>2]=f[t>>2];f[d>>2]=f[v>>2];PPb(oa,g,e,d)|0;n6(f[ba>>2]|0);oa=f[h>>2]|0;ma=f[U>>2]|0;if((ma|0)!=(oa|0))f[U>>2]=ma+(~((ma+-16-oa|0)>>>4)<<4);oa=f[i>>2]|0;ma=f[b>>2]|0;if((ma|0)!=(oa|0))f[b>>2]=ma+(~((ma+-4-oa|0)>>>2)<<2);oa=f[j>>2]|0;ma=f[V>>2]|0;if((ma|0)!=(oa|0))f[V>>2]=ma+(~((ma+-8-oa|0)>>>3)<<3)}}}T=T+N|0}while((T|0)<(S|0))}ja=ja+N|0}while((ja|0)<(O|0));if((f[b>>2]|0)==(f[i>>2]|0)){if((f[U>>2]|0)!=(f[h>>2]|0)){O=a+172|0;m6(f[O>>2]|0);ja=f[a+160>>2]|0;f[I>>2]=f[ja+4>>2];f[J>>2]=f[h>>2];f[K>>2]=f[U>>2];f[g>>2]=f[I>>2];f[e>>2]=f[J>>2];f[d>>2]=f[K>>2];MPb(ja,g,e,d)|0;n6(f[O>>2]|0)}}else{O=a+172|0;m6(f[O>>2]|0);ja=f[a+160>>2]|0;f[z>>2]=f[ja+4>>2];f[A>>2]=f[h>>2];f[B>>2]=f[U>>2];f[g>>2]=f[z>>2];f[e>>2]=f[A>>2];f[d>>2]=f[B>>2];MPb(ja,g,e,d)|0;ja=f[a+164>>2]|0;f[C>>2]=f[ja+4>>2];f[D>>2]=f[i>>2];f[E>>2]=f[b>>2];f[g>>2]=f[C>>2];f[e>>2]=f[D>>2];f[d>>2]=f[E>>2];yxa(ja,g,e,d)|0;ja=f[a+168>>2]|0;f[F>>2]=f[ja+4>>2];f[G>>2]=f[j>>2];f[H>>2]=f[V>>2];f[g>>2]=f[F>>2];f[e>>2]=f[G>>2];f[d>>2]=f[H>>2];PPb(ja,g,e,d)|0;n6(f[O>>2]|0)}O=f[j>>2]|0;if(O|0){j=f[V>>2]|0;if((j|0)!=(O|0))f[V>>2]=j+(~((j+-8-O|0)>>>3)<<3);YDc(O)}O=f[i>>2]|0;if(O|0){i=f[b>>2]|0;if((i|0)!=(O|0))f[b>>2]=i+(~((i+-4-O|0)>>>2)<<2);YDc(O)}O=f[h>>2]|0;if(O|0){h=f[U>>2]|0;if((h|0)!=(O|0))f[U>>2]=h+(~((h+-16-O|0)>>>4)<<4);YDc(O)}u=c;return}function PPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(h>>3<<3)|0;i=f[c>>2]|0;j=f[d>>2]|0;d=j-i|0;k=d>>3;l=j;if((d|0)<=0){m=b;return m|0}d=a+8|0;n=f[d>>2]|0;o=a+4|0;q=f[o>>2]|0;r=q;if((k|0)<=(n-r>>3|0)){s=b;t=r-s|0;u=t>>3;if((k|0)>(u|0)){v=i+(u<<3)|0;u=v;if((v|0)==(l|0))w=q;else{x=l+-8-u|0;y=v;v=q;while(1){p[v>>3]=+p[y>>3];y=y+8|0;if((y|0)==(l|0))break;else v=v+8|0}v=q+((x>>>3)+1<<3)|0;f[o>>2]=v;w=v}if((t|0)>0){z=u;A=w}else{m=b;return m|0}}else{z=j;A=q}j=A-(b+(k<<3))|0;w=j>>3;u=b+(w<<3)|0;if(u>>>0<q>>>0){t=(q+(0-w<<3)+~s|0)>>>3;s=u;u=A;while(1){p[u>>3]=+p[s>>3];s=s+8|0;if(s>>>0>=q>>>0)break;else u=u+8|0}f[o>>2]=A+(t+1<<3)}if(!w)B=i;else{fJc(A+(0-w<<3)|0,b|0,j|0)|0;B=f[c>>2]|0}c=z-B|0;if(!c){m=b;return m|0}fJc(b|0,B|0,c|0)|0;m=b;return m|0}c=(r-g>>3)+k|0;if(c>>>0>536870911)mCc(a);k=n-g|0;g=k>>2;n=k>>3>>>0<268435455?(g>>>0<c>>>0?c:g):536870911;g=b;c=h>>3;do if(n)if(n>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{C=VDc(n<<3)|0;break}else C=0;while(0);k=C+(c<<3)|0;B=C+(n<<3)|0;n=i;if((n|0)==(l|0))D=k;else{C=((l+-8-i|0)>>>3)+1|0;i=n;n=k;while(1){p[n>>3]=+p[i>>3];i=i+8|0;if((i|0)==(l|0))break;else n=n+8|0}D=k+(C<<3)|0}C=k+(0-c<<3)|0;if((h|0)>0)dJc(C|0,e|0,h|0)|0;h=r-g|0;if((h|0)>0){dJc(D|0,b|0,h|0)|0;E=D+(h>>>3<<3)|0}else E=D;f[a>>2]=C;f[o>>2]=E;f[d>>2]=B;if(!e){m=k;return m|0}YDc(e);m=k;return m|0}function QPb(a){a=a|0;YDc(a);return}function RPb(a){a=a|0;$0(a+12|0,f[a+8>>2]|0);if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function SPb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137680;b=a+268|0;c=a+304|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+284|0;b=a+272|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+308>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+312>>2]|0;if((b|0)!=(a+316|0))g0(b);b=a+212|0;d=a+248|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+228|0;b=a+216|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+252>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+256>>2]|0;if((b|0)!=(a+260|0))g0(b);b=a+156|0;c=a+192|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+172|0;b=a+160|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+196>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+200>>2]|0;if((b|0)!=(a+204|0))g0(b);b=a+100|0;d=a+136|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+116|0;b=a+104|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+140>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))g0(b);b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+16>>2]|0;if(b|0){d=a+20|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~(((c+-12-b|0)>>>0)/12|0)*12|0);YDc(b)}b=f[a+4>>2]|0;if(!b)return;c=a+8|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~(((a+-44-b|0)>>>0)/44|0)*44|0);YDc(b);return}function TPb(a){a=a|0;SPb(a);YDc(a);return}function UPb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;j=u;u=u+2208|0;k=j+1136|0;l=j+1072|0;m=j+1064|0;o=j+1080|0;q=j;r=a+324|0;f[r>>2]=c;s=a+52|0;f[s>>2]=f[i>>2];t=a+56|0;f[t>>2]=f[i+4>>2];i=a+28|0;b[i>>0]=h&1;h=f[(f[c>>2]|0)+52>>2]|0;f[l>>2]=f[e>>2];v=e+4|0;f[l+4>>2]=f[v>>2];f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];Fh[h&255](c,d,a+212|0,a+268|0,l,m);m=f[v>>2]|0;f[a+92>>2]=f[e>>2];f[a+96>>2]=m;m=f[r>>2]|0;e=f[m+4>>2]|0;f[a+44>>2]=e;v=f[m+8>>2]|0;f[a+48>>2]=v;l=f[m+12>>2]|0;d=f[m+16>>2]|0;c=f[m+20>>2]|0;h=f[m+24>>2]|0;g=f[m+28>>2]|0;w=f[m+32>>2]|0;x=f[m+36>>2]|0;m=Y(d,l)|0;y=a+60|0;f[y>>2]=((e-l|0)/(c|0)|0)+1;e=a+64|0;f[e>>2]=((v-d|0)/(h|0)|0)+1;z=(l|0)/(g|0)|0;A=(d|0)/(w|0)|0;B=a+68|0;f[B>>2]=z;C=a+72|0;f[C>>2]=A;D=Y(Y(z,x)|0,A)|0;A=a+76|0;f[A>>2]=D;do if(b[i>>0]|0){z=(((f[a+224>>2]|0)-l|0)/(f[s>>2]|0)|0)+1|0;E=((v|0)/(f[t>>2]|0)|0)+1|0;F=a+100|0;G=Y(z,D)|0;if(!(((((f[a+104>>2]|0)<3?(f[a+108>>2]|0)==(E|0):0)?(f[a+112>>2]|0)==(G|0):0)?(f[F>>2]&4095|0)==5:0)?(f[a+116>>2]|0)!=0:0)){f[k>>2]=E;f[k+4>>2]=G;XS(F,2,k,5)}F=a+156|0;if(!(((((f[a+160>>2]|0)<3?(f[a+164>>2]|0)==(E|0):0)?(f[a+168>>2]|0)==(z|0):0)?(f[F>>2]&4095|0)==0:0)?(f[a+172>>2]|0)!=0:0)){f[k>>2]=E;f[k+4>>2]=z;XS(F,2,k,0)}F=f[a+108>>2]|0;z=a+32|0;E=a+36|0;G=f[E>>2]|0;H=f[z>>2]|0;I=G-H>>2;J=H;H=G;if(F>>>0<=I>>>0){if(F>>>0<I>>>0?(G=J+(F<<2)|0,(H|0)!=(G|0)):0)f[E>>2]=H+(~((H+-4-G|0)>>>2)<<2);if(!F)break}else lN(z,F-I|0);XIc(f[z>>2]|0,-1,F<<2|0)|0}while(0);f[o>>2]=1124007936;D=o+4|0;t=o+8|0;v=o+40|0;s=D;i=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(i|0));f[v>>2]=t;t=o+48|0;F=o+44|0;f[F>>2]=t;f[t>>2]=0;f[o+52>>2]=0;f[k>>2]=d;f[k+4>>2]=l;XS(o,2,k,5);z=f[r>>2]|0;K=+p[z+48>>3];if(K>0.0)L=K;else L=+((f[z+16>>2]|0)+(f[z+12>>2]|0)|0)*.125;K=L;L=1.0/(K*K*2.0);z=k+8|0;f[k>>2]=z;r=k+4|0;f[r>>2]=d;if(d>>>0>264){I=XDc(d>>>0>1073741823?-1:d<<2)|0;f[k>>2]=I;M=I}else M=z;I=q+8|0;f[q>>2]=I;G=q+4|0;f[G>>2]=l;if(l>>>0>264){H=XDc(l>>>0>1073741823?-1:l<<2)|0;f[q>>2]=H;N=H}else N=I;K=+(d|0)*.5;O=+(l|0)*.5;H=(d|0)>0;if(H){E=0;do{P=+(E|0)-K;n[M+(E<<2)>>2]=P*P;E=E+1|0}while((E|0)!=(d|0))}E=(l|0)>0;if(E){J=0;do{K=+(J|0)-O;n[N+(J<<2)>>2]=K*K;J=J+1|0}while((J|0)!=(l|0))}if(H?(J=f[o+16>>2]|0,E):0){Q=f[f[F>>2]>>2]|0;R=0;do{S=M+(R<<2)|0;T=J+(Y(Q,R)|0)|0;U=0;do{O=+V(+-(L*(+n[S>>2]+ +n[N+(U<<2)>>2])));n[T+(U<<2)>>2]=O;U=U+1|0}while((U|0)!=(l|0));R=R+1|0}while((R|0)!=(d|0))}if((N|0)==(I|0))W=M;else{ZDc(N);N=f[k>>2]|0;f[q>>2]=I;f[G>>2]=264;W=N}if((W|0)!=(z|0)){if(W|0)ZDc(W);f[k>>2]=z;f[r>>2]=264}r=a+16|0;z=Y(f[e>>2]|0,f[y>>2]|0)|0;k=a+20|0;W=f[k>>2]|0;N=f[r>>2]|0;G=(W-N|0)/12|0;I=N;N=W;if(z>>>0<=G>>>0){if(z>>>0<G>>>0?(W=I+(z*12|0)|0,(N|0)!=(W|0)):0)f[k>>2]=N+(~(((N+-12-W|0)>>>0)/12|0)*12|0)}else WPb(r,z-G|0);G=a+4|0;z=m*3|0;W=a+8|0;N=f[W>>2]|0;k=f[G>>2]|0;I=(N-k|0)/44|0;q=k;k=N;if(z>>>0<=I>>>0){if(z>>>0<I>>>0?(N=q+(z*44|0)|0,(k|0)!=(N|0)):0)f[W>>2]=k+(~(((k+-44-N|0)>>>0)/44|0)*44|0)}else XPb(G,z-I|0);I=a+88|0;f[I>>2]=0;z=a+84|0;f[z>>2]=0;N=a+80|0;f[N>>2]=0;if(E){L=+(g|0);O=+(w|0);w=m<<1;g=a+224|0;E=a+280|0;a=f[o+16>>2]|0;k=f[F>>2]|0;W=0;do{if(H){K=(+(W|0)+.5)/L+-.5;q=~~K;M=q-(+(q|0)>K&1)|0;q=M+1|0;P=K-+(M|0);K=1.0-P;R=0;do{X=(+(R|0)+.5)/O+-.5;Q=~~X;J=Q-(+(Q|0)>X&1)|0;Q=J+1|0;Z=X-+(J|0);U=f[B>>2]|0;T=M>>>0<U>>>0;do if(T&q>>>0<U>>>0){S=f[C>>2]|0;_=J>>>0<S>>>0;if(_&Q>>>0<S>>>0){$=f[I>>2]|0;f[I>>2]=$+1;aa=$+w|0;$=f[G>>2]|0;ba=Y((Y(S,M)|0)+J|0,x)|0;f[$+(aa*44|0)+8>>2]=ba;X=1.0-Z;n[$+(aa*44|0)+24>>2]=K*X;ba=Y((Y(f[C>>2]|0,q)|0)+J|0,x)|0;f[$+(aa*44|0)+12>>2]=ba;n[$+(aa*44|0)+28>>2]=P*X;ba=Y((Y(f[C>>2]|0,M)|0)+Q|0,x)|0;f[$+(aa*44|0)+16>>2]=ba;n[$+(aa*44|0)+32>>2]=K*Z;ba=Y((Y(f[C>>2]|0,q)|0)+Q|0,x)|0;f[$+(aa*44|0)+20>>2]=ba;ca=$+(aa*44|0)|0;da=3;ea=P*Z;break}else{aa=f[z>>2]|0;f[z>>2]=aa+1;$=aa+m|0;aa=f[G>>2]|0;X=_?1.0-Z:Z;ba=_?J:Q;_=Y(ba+(Y(S,M)|0)|0,x)|0;f[aa+($*44|0)+8>>2]=_;n[aa+($*44|0)+24>>2]=K*X;_=Y((Y(f[C>>2]|0,q)|0)+ba|0,x)|0;f[aa+($*44|0)+12>>2]=_;n[aa+($*44|0)+28>>2]=P*X;f[aa+($*44|0)+20>>2]=0;f[aa+($*44|0)+16>>2]=0;n[aa+($*44|0)+36>>2]=0.0;ca=aa+($*44|0)|0;da=2;ea=0.0;break}}else{X=T?K:P;$=T?M:q;aa=f[C>>2]|0;_=J>>>0<aa>>>0;if(_&Q>>>0<aa>>>0){ba=f[z>>2]|0;f[z>>2]=ba+1;S=ba+m|0;ba=f[G>>2]|0;fa=Y((Y(aa,$)|0)+J|0,x)|0;f[ba+(S*44|0)+8>>2]=fa;n[ba+(S*44|0)+24>>2]=(1.0-Z)*X;fa=Y((Y(f[C>>2]|0,$)|0)+Q|0,x)|0;f[ba+(S*44|0)+12>>2]=fa;n[ba+(S*44|0)+28>>2]=Z*X;f[ba+(S*44|0)+20>>2]=0;f[ba+(S*44|0)+16>>2]=0;n[ba+(S*44|0)+36>>2]=0.0;ca=ba+(S*44|0)|0;da=2;ea=0.0;break}else{S=f[N>>2]|0;f[N>>2]=S+1;ba=f[G>>2]|0;fa=Y((_?J:Q)+(Y(aa,$)|0)|0,x)|0;f[ba+(S*44|0)+8>>2]=fa;n[ba+(S*44|0)+24>>2]=X*(_?1.0-Z:Z);f[ba+(S*44|0)+20>>2]=0;f[ba+(S*44|0)+16>>2]=0;f[ba+(S*44|0)+12>>2]=0;n[ba+(S*44|0)+36>>2]=0.0;n[ba+(S*44|0)+32>>2]=0.0;ca=ba+(S*44|0)|0;da=1;ea=0.0;break}}while(0);n[ca+24+(da<<2)>>2]=ea;Q=(Y(f[g>>2]|0,R)|0)+W<<1;f[ca>>2]=Q;Q=(Y(f[E>>2]|0,R)|0)+W<<1;f[ca+4>>2]=Q;Q=a+(Y(f[k>>2]|0,R)|0)+(W<<2)|0;f[ca+40>>2]=f[Q>>2];R=R+1|0}while((R|0)!=(d|0))}W=W+1|0}while((W|0)!=(l|0));l=f[z>>2]|0;if((l|0)>0){W=0;do{d=f[G>>2]|0;s=d+(((f[N>>2]|0)+W|0)*44|0)|0;ga=d+((W+m|0)*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));W=W+1|0;d=f[z>>2]|0}while((W|0)<(d|0));ha=d}else ha=l}else ha=0;l=f[I>>2]|0;if((l|0)>0){W=m<<1;m=f[G>>2]|0;s=m+(((f[N>>2]|0)+ha|0)*44|0)|0;ga=m+(W*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));m=f[I>>2]|0;if((m|0)>1){d=1;do{ca=f[G>>2]|0;s=ca+(((f[N>>2]|0)+d+(f[z>>2]|0)|0)*44|0)|0;ga=ca+((d+W|0)*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));d=d+1|0;ca=f[I>>2]|0}while((d|0)<(ca|0));ia=ca}else ia=m;ja=ia;ka=f[z>>2]|0}else{ja=l;ka=ha}ha=ka+(f[N>>2]|0)|0;f[z>>2]=ha;f[I>>2]=ha+ja;ja=f[y>>2]|0;if((ja|0)>0?(y=f[e>>2]|0,(y|0)>0):0){e=f[r>>2]|0;r=f[A>>2]|0;A=0;do{ha=Y(A,c)|0;I=Y(y,A)|0;z=0;do{N=I+z|0;ka=Y(r,N)|0;f[e+(N*12|0)>>2]=ka;ka=Y(z,h)|0;f[e+(N*12|0)+4>>2]=ha;f[e+(N*12|0)+8>>2]=ka;z=z+1|0}while((z|0)<(y|0));A=A+1|0}while((A|0)<(ja|0))}ja=o+36|0;A=f[ja>>2]|0;if(A|0?(y=A+12|0,A=f[y>>2]|0,f[y>>2]=A+-1,(A|0)==1):0)_S(o);f[ja>>2]=0;ja=o+16|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[D>>2]|0)>0){ja=f[v>>2]|0;v=0;do{f[ja+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[D>>2]|0))}D=f[F>>2]|0;if((D|0)==(t|0)){u=j;return}g0(D);u=j;return}function VPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,q=0,r=0.0,t=0.0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+16|0;d=c+4|0;e=c;g=f[a+76>>2]|0;h=g+-4|0;i=0;j=0.0;k=0.0;l=0.0;m=0.0;do{o=+n[b+(i<<2)>>2];j=j+o*o;o=+n[b+((i|1)<<2)>>2];k=k+o*o;o=+n[b+((i|2)<<2)>>2];l=l+o*o;o=+n[b+((i|3)<<2)>>2];m=m+o*o;i=i+4|0}while(i>>>0<=h>>>0);o=m+l+(k+j);if(i>>>0<g>>>0){j=o;q=i;while(1){k=+n[b+(q<<2)>>2];l=j+k*k;q=q+1|0;if((q|0)==(g|0)){r=l;break}else j=l}}else r=o;o=1.0/(+(g>>>0)*.10000000149011612+ +M(+r));r=+p[(f[a+324>>2]|0)+64>>3];n[d>>2]=r;a=0;j=0.0;l=0.0;k=0.0;m=0.0;do{q=b+(a<<2)|0;t=o*+n[q>>2];n[e>>2]=t;i=f[(r<t?d:e)>>2]|0;f[q>>2]=i;q=b+((a|1)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;v=f[(r<t?d:e)>>2]|0;f[q>>2]=v;q=b+((a|2)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;w=f[(r<t?d:e)>>2]|0;f[q>>2]=w;q=b+((a|3)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;x=f[(r<t?d:e)>>2]|0;f[q>>2]=x;t=(f[s>>2]=i,+n[s>>2]);j=j+t*t;t=(f[s>>2]=v,+n[s>>2]);l=l+t*t;t=(f[s>>2]=w,+n[s>>2]);k=k+t*t;t=(f[s>>2]=x,+n[s>>2]);m=m+t*t;a=a+4|0}while(a>>>0<=h>>>0);t=m+k+(l+j);if(a>>>0<g>>>0){j=t;h=a;while(1){a=b+(h<<2)|0;l=o*+n[a>>2];n[e>>2]=l;x=f[(r<l?d:e)>>2]|0;f[a>>2]=x;l=(f[s>>2]=x,+n[s>>2]);k=j+l*l;h=h+1|0;if((h|0)==(g|0)){y=k;break}else j=k}}else y=t;t=1.0/(+M(+y)+1.0000000474974513e-03);if(!g){u=c;return}else z=0;do{h=b+(z<<2)|0;n[h>>2]=t*+n[h>>2];z=z+1|0}while((z|0)!=(g|0));u=c;return}function WPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){XIc(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)mCc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{n=VDc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=n+(m*12|0)|0;XIc(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=d;p=i}else{i=h;h=d;do{d=i;i=i+-12|0;f[h+-12>>2]=f[i>>2];f[h+-8>>2]=f[d+-8>>2];f[h+-4>>2]=f[d+-4>>2];h=h+-12|0}while((i|0)!=(k|0));o=h;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;YDc(p);return}function XPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/44|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+44|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/44|0;g=i+b|0;if(g>>>0>97612893)mCc(a);l=(d-h|0)/44|0;h=l<<1;d=l>>>0<48806446?(h>>>0<g>>>0?g:h):97612893;do if(d)if(d>>>0>97612893){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*44|0)|0;break}else m=0;while(0);h=m+(i*44|0)|0;i=m+(d*44|0)|0;d=b;b=h;m=h;do{j=b;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+44|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(((b|0)/-44|0)*44|0)|0;if((b|0)>0)dJc(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;YDc(d);return}function YPb(a){a=a|0;var b=0,c=0;f[a>>2]=137704;GQ(a+88|0);b=f[a+76>>2]|0;if(!b)return;c=a+80|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function ZPb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=137704;GQ(a+88|0);b=f[a+76>>2]|0;if(!b){YDc(a);return}c=a+80|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function _Pb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=u;u=u+128|0;e=d+112|0;g=d+56|0;h=d;do if((d$(c)|0)==65536){i=f[c+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;ZS(g,i);break}}else a$(g,c,-1);while(0);c=a+76|0;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=-2113732603;f[e+4>>2]=c;LZ(g,e,5,1.0,0.0);i=g+36|0;j=f[i>>2]|0;if(j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)_S(g);f[i>>2]=0;i=g+16|0;j=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){i=f[g+40>>2]|0;k=0;do{f[i+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))g0(j);j=a+80|0;g=(f[j>>2]|0)-(f[c>>2]|0)>>2;k=rQb(a)|0;if(!((g|0)==(k+1|0)|((g|0)==0|(g|0)==(k|0)))){f[e>>2]=0;f[e+4>>2]=0;p=tT(e,19)|0;k=471690;q=p+19|0;do{b[p>>0]=b[k>>0]|0;p=p+1|0;k=k+1|0}while((p|0)<(q|0));z5(-215,e,471710,470838,117)}k=(f[j>>2]|0)-(f[c>>2]|0)>>2;f[h>>2]=1124007936;g=h+4|0;i=h+8|0;l=h+40|0;p=g;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[l>>2]=i;i=h+48|0;p=h+44|0;f[p>>2]=i;f[i>>2]=0;f[h+52>>2]=0;f[e>>2]=1;f[e+4>>2]=k;XS(h,2,e,5);k=f[a+12>>2]|0;q=f[a+16>>2]|0;o=Y(Y((k|0)/(f[a+28>>2]|0)|0,f[a+36>>2]|0)|0,(q|0)/(f[a+32>>2]|0)|0)|0;m=f[a+20>>2]|0;r=f[a+24>>2]|0;s=((f[a+4>>2]|0)-k+m|0)/(m|0)|0;m=((f[a+8>>2]|0)-q+r|0)/(r|0)|0;if((m|0)>0?(r=f[h+16>>2]|0,q=(o|0)==0,(s|0)>0):0){k=f[c>>2]|0;t=0;do{v=Y(t,s)|0;if(!q){w=0;do{x=k+((Y((Y(w,m)|0)+t|0,o)|0)<<2)|0;y=r+((Y(w+v|0,o)|0)<<2)|0;z=0;do{f[y+(z<<2)>>2]=f[x+(z<<2)>>2];z=z+1|0}while((z|0)!=(o|0));w=w+1|0}while((w|0)!=(s|0))}t=t+1|0}while((t|0)!=(m|0))}m=rQb(a)|0;t=f[c>>2]|0;if((f[j>>2]|0)-t>>2>>>0>m>>>0)A=+n[t+(m<<2)>>2];else A=0.0;n[a+136>>2]=A;m=e+8|0;f[m>>2]=0;f[m+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=a+88;h_(h,e);e=h+36|0;a=f[e>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)_S(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[l>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[p>>2]|0;if((g|0)==(i|0)){u=d;return}g0(g);u=d;return}function $Pb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+208|0;e=d+164|0;g=d+120|0;h=d+112|0;i=d+24|0;j=d+104|0;k=d+96|0;l=d+88|0;m=d+80|0;n=d+72|0;o=d+16|0;p=d;I_(h,c,471391);if(!(f[h+4>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;q=tT(e,23)|0;r=471643;s=q+23|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,e,471667,470838,141)}if((X_(c)|0)!=6){t=0;u=d;return t|0}I_(j,c,471391);K_(i,f[j>>2]|0,f[j+4>>2]|0,0);j=i+20|0;h=f[j>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=h;Y_(e,a+4|0,0);h=N_(i)|0;v=f[i+20>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=v;Y_(e,a+8|0,0);N_(h)|0;I_(k,c,471399);K_(e,f[k>>2]|0,f[k+4>>2]|0,0);q=i;r=e;s=q+44|0;do{f[q>>2]=f[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));k=f[j>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=k;Y_(e,a+12|0,0);k=N_(i)|0;h=f[i+20>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=h;Y_(e,a+16|0,0);N_(k)|0;I_(l,c,471409);K_(e,f[l>>2]|0,f[l+4>>2]|0,0);q=i;r=e;s=q+44|0;do{f[q>>2]=f[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));l=f[j>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=l;Y_(e,a+20|0,0);l=N_(i)|0;k=f[i+20>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=k;Y_(e,a+24|0,0);N_(l)|0;I_(m,c,471672);K_(e,f[m>>2]|0,f[m+4>>2]|0,0);q=i;r=e;s=q+44|0;do{f[q>>2]=f[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));r=f[j>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=r;Y_(e,a+28|0,0);r=N_(i)|0;j=f[i+20>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=j;Y_(e,a+32|0,0);N_(r)|0;I_(e,c,471421);Y_(e,a+36|0,0);I_(e,c,471545);Y_(e,a+40|0,0);I_(e,c,471681);__(e,a+48|0,0.0);I_(e,c,471559);Y_(e,a+56|0,0);I_(e,c,471577);__(e,a+64|0,0.0);I_(g,c,471592);Y_(g,e,0);b[a+72>>0]=(f[e>>2]|0)!=0&1;I_(e,c,471608);Y_(e,a+140|0,0);I_(n,c,471616);if(!(f[n+4>>2]|0))b[a+144>>0]=0;else{I_(g,c,471616);Y_(g,e,0);b[a+144>>0]=(f[e>>2]|0)!=0&1}I_(o,c,471631);if((X_(o)|0)==5?(f[p>>2]=0,c=p+4|0,f[c>>2]=0,f[p+8>>2]=0,K_(g,f[o>>2]|0,f[o+4>>2]|0,0),f[e>>2]=g,AQb(e,p,2147483647),g=f[(f[a>>2]|0)+8>>2]|0,f[e+8>>2]=0,f[e+12>>2]=0,f[e>>2]=-2130509819,f[e+4>>2]=p,mi[g&2047](a,e),e=f[p>>2]|0,e|0):0){p=f[c>>2]|0;if((p|0)!=(e|0))f[c>>2]=p+(~((p+-4-e|0)>>>2)<<2);YDc(e)}t=1;u=d;return t|0}function aQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0;e=u;u=u+16|0;g=e+8|0;i=e;if(f[d+4>>2]|0)E_(c,d)|0;f[g>>2]=0;f[g+4>>2]=0;d=tT(g,27)|0;j=471363;k=d+27|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=E_(c,g)|0;uT(g);f[g>>2]=0;f[g+4>>2]=0;m=tT(g,7)|0;b[m>>0]=b[471391]|0;b[m+1>>0]=b[471392]|0;b[m+2>>0]=b[471393]|0;b[m+3>>0]=b[471394]|0;b[m+4>>0]=b[471395]|0;b[m+5>>0]=b[471396]|0;b[m+6>>0]=b[471397]|0;m=E_(l,g)|0;uT(g);l=yQb(m,a+4|0)|0;f[g>>2]=0;f[g+4>>2]=0;d=tT(g,9)|0;j=471399;k=d+9|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=E_(l,g)|0;uT(g);l=yQb(m,a+12|0)|0;f[g>>2]=0;f[g+4>>2]=0;d=tT(g,11)|0;j=471409;k=d+11|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=E_(l,g)|0;uT(g);l=yQb(m,a+20|0)|0;f[g>>2]=0;f[g+4>>2]=0;m=tT(g,8)|0;n=m;b[n>>0]=99;b[n+1>>0]=101;b[n+2>>0]=108;b[n+3>>0]=108;n=m+4|0;b[n>>0]=83;b[n+1>>0]=105;b[n+2>>0]=122;b[n+3>>0]=101;n=E_(l,g)|0;uT(g);l=yQb(n,a+28|0)|0;f[g>>2]=0;f[g+4>>2]=0;n=tT(g,5)|0;b[n>>0]=b[471421]|0;b[n+1>>0]=b[471422]|0;b[n+2>>0]=b[471423]|0;b[n+3>>0]=b[471424]|0;b[n+4>>0]=b[471425]|0;n=E_(l,g)|0;uT(g);l=a+36|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}P_(n,c+12|0,f[l>>2]|0);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=tT(g,13)|0;j=471545;k=d+13|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=E_(n,g)|0;uT(g);n=a+40|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}P_(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;l=tT(g,8)|0;n=l;b[n>>0]=119;b[n+1>>0]=105;b[n+2>>0]=110;b[n+3>>0]=83;n=l+4|0;b[n>>0]=105;b[n+1>>0]=103;b[n+2>>0]=109;b[n+3>>0]=97;n=E_(m,g)|0;uT(g);o=+p[a+48>>3];if(o>0.0)q=o;else q=+((f[a+16>>2]|0)+(f[a+12>>2]|0)|0)*.125;if(_i[f[(f[c>>2]|0)+12>>2]&1023](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}R_(n,c+12|0,q);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=tT(g,17)|0;j=471559;k=d+17|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=E_(n,g)|0;uT(g);n=a+56|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}P_(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=tT(g,14)|0;j=471577;k=d+14|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=E_(m,g)|0;uT(g);m=a+64|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](l)|0){n=c+32|0;if((f[n>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}R_(l,c+12|0,+p[m>>3]);if(f[n>>2]&4|0)f[n>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=tT(g,15)|0;j=471592;k=d+15|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));n=E_(l,g)|0;uT(g);l=a+72|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}P_(n,c+12|0,h[l>>0]|0);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;m=tT(g,7)|0;b[m>>0]=b[471608]|0;b[m+1>>0]=b[471609]|0;b[m+2>>0]=b[471610]|0;b[m+3>>0]=b[471611]|0;b[m+4>>0]=b[471612]|0;b[m+5>>0]=b[471613]|0;b[m+6>>0]=b[471614]|0;m=E_(n,g)|0;uT(g);n=a+140|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}P_(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=tT(g,14)|0;j=471616;k=d+14|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=E_(m,g)|0;uT(g);m=a+144|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](l)|0){n=c+32|0;if((f[n>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}P_(l,c+12|0,h[m>>0]|0);if(f[n>>2]&4|0)f[n>>2]=6}n=a+76|0;if((f[n>>2]|0)==(f[a+80>>2]|0)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=tT(g,1)|0;b[s>>0]=125;E_(c,g)|0;uT(g);u=e;return}f[g>>2]=0;f[g+4>>2]=0;d=tT(g,11)|0;j=471631;k=d+11|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));a=E_(c,g)|0;uT(g);if(!(_i[f[(f[c>>2]|0)+12>>2]&1023](a)|0)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=tT(g,1)|0;b[s>>0]=125;E_(c,g)|0;uT(g);u=e;return}m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=tT(g,30)|0;j=471427;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));z5(-2,g,518366,471458,1188)}f[g>>2]=0;f[g+4>>2]=0;T_(i,a,c+12|0,13,g);uT(g);f[g>>2]=a;zQb(g,n);U_(i);if(!(f[m>>2]&4)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=tT(g,1)|0;b[s>>0]=125;E_(c,g)|0;uT(g);u=e;return}f[m>>2]=6;f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=tT(g,1)|0;b[s>>0]=125;E_(c,g)|0;uT(g);u=e;return}function bQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+144|0;e=d+136|0;g=d+88|0;h=d+44|0;i=d+8|0;j=d;f[e>>2]=0;f[e+4>>2]=0;B_(i,b,0,e);uT(e);if(f[c+4>>2]|0){H_(j,i,c);k=f[a>>2]|0;l=k+12|0;m=f[l>>2]|0;n=Mi[m&1023](a,j)|0;t_(i);u=d;return n|0}D_(e,i,0);c=e+4|0;K_(g,f[e>>2]|0,f[c>>2]|0,0);b=f[e>>2]|0;o=f[c>>2]|0;K_(h,b,o,M_(e)|0);e=f[g>>2]|0;o=e;if((((e|0)==(f[h>>2]|0)?(f[g+4>>2]|0)==(f[h+4>>2]|0):0)?(f[g+20>>2]|0)==(f[h+20>>2]|0):0)?(f[g+40>>2]|0)==(f[h+40>>2]|0):0){f[j>>2]=0;f[j+4>>2]=0}else{h=f[g+20>>2]|0;f[j>>2]=o;f[j+4>>2]=h}k=f[a>>2]|0;l=k+12|0;m=f[l>>2]|0;n=Mi[m&1023](a,j)|0;t_(i);u=d;return n|0}function cQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+8|0;g=d;f[g>>2]=0;f[g+4>>2]=0;B_(e,b,1,g);uT(g);h=f[(f[a>>2]|0)+16>>2]|0;i=f[c+4>>2]|0;if(i){j=f[c>>2]|0;f[g>>2]=j;f[g+4>>2]=i;if(j|0){i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1}}else G_(g,b);Ti[h&511](a,e,g);uT(g);t_(e);u=d;return}function dQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];f[c+16>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];f[c+36>>2]=f[a+36>>2];f[c+40>>2]=f[a+40>>2];p[c+48>>3]=+p[a+48>>3];f[c+56>>2]=f[a+56>>2];p[c+64>>3]=+p[a+64>>3];b[c+72>>0]=b[a+72>>0]|0;g=f[(f[c>>2]|0)+8>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=-2130509819;f[e+4>>2]=a+76;mi[g&2047](c,e);f[c+140>>2]=f[a+140>>2];b[c+144>>0]=b[a+144>>0]|0;u=d;return}function eQb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+416|0;i=h+400|0;j=h+392|0;k=h+336|0;l=h+8|0;m=h;n=f[d>>2]|0;o=d+4|0;p=f[o>>2]|0;if(!(p|n)){q=f[a+28>>2]|0;f[d>>2]=q;r=f[a+32>>2]|0;f[o>>2]=r;s=q;t=r}else{s=n;t=p}p=f[a+20>>2]|0;n=(s|0)<(p|0);r=n?p:s;q=n?s:p;if((q|0)>0){p=r;s=q;while(1){q=(p|0)%(s|0)|0;if((q|0)>0){n=s;s=q;p=n}else{v=s;break}}}else v=r;r=f[a+24>>2]|0;s=(t|0)<(r|0);p=s?r:t;n=s?t:r;if((n|0)>0){r=p;t=n;while(1){n=(r|0)%(t|0)|0;if((n|0)>0){s=t;t=n;r=s}else{w=t;break}}}else w=p;f[i>>2]=v;v=i+4|0;f[v>>2]=w;b$(j,b,-1);w=g+4|0;p=(f[w>>2]|0)-(f[g>>2]|0)>>3;t=f[e>>2]|0;r=f[i>>2]|0;s=r+-1+((t|0)>0?t:0)&0-r;f[e>>2]=s;r=e+4|0;t=f[r>>2]|0;n=f[v>>2]|0;v=n+-1+((t|0)>0?t:0)&0-n;f[r>>2]=v;n=(s<<1)+(f[j>>2]|0)|0;s=(v<<1)+(f[j+4>>2]|0)|0;do if((d$(b)|0)==65536){j=f[b+4>>2]|0;f[k>>2]=f[j>>2];v=k+4|0;t=j+4|0;f[v>>2]=f[t>>2];q=k+8|0;f[q>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];x=f[j+36>>2]|0;f[k+36>>2]=x;f[k+40>>2]=q;q=k+48|0;y=k+44|0;f[y>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(x|0){q=x+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[t>>2]|0)<3){t=f[j+44>>2]|0;q=f[y>>2]|0;f[q>>2]=f[t>>2];f[q+4>>2]=f[t+4>>2];break}else{f[v>>2]=0;ZS(k,j);break}}else a$(k,b,-1);while(0);b=(p|0)==0;qQb(l,a,k,e,e,b,i);if(b)z=Y(((s-(f[l+48>>2]|0)|0)/(f[o>>2]|0)|0)+1|0,((n-(f[l+44>>2]|0)|0)/(f[d>>2]|0)|0)+1|0)|0;else z=p;p=f[l+16>>2]|0;s=Y(f[l+64>>2]|0,f[l+60>>2]|0)|0;b=f[l+76>>2]|0;i=rQb(a)|0;j=Y(i,z)|0;v=c+4|0;t=f[v>>2]|0;q=f[c>>2]|0;y=t-q>>2;x=q;q=t;if(j>>>0<=y>>>0){if(j>>>0<y>>>0?(t=x+(j<<2)|0,(q|0)!=(t|0)):0)f[v>>2]=q+(~((q+-4-t|0)>>>2)<<2)}else fqb(c,j-y|0);if(z|0?(y=l+44|0,j=k+12|0,t=a+4|0,q=k+8|0,v=a+8|0,a=m+4|0,x=b<<2,(s|0)>0):0){b=0;do{A=Y(b,i)|0;B=(f[c>>2]|0)+(A<<2)|0;A=f[g>>2]|0;if((A|0)!=(f[w>>2]|0)){C=f[A+(b<<3)>>2]|0;D=f[A+(b<<3)+4>>2]|0;A=f[e>>2]|0;if((((C|0)>=(0-A|0)?(C|0)<=((f[j>>2]|0)+A-(f[t>>2]|0)|0):0)?(A=f[r>>2]|0,(D|0)>=(0-A|0)):0)?(D|0)<=((f[q>>2]|0)+A-(f[v>>2]|0)|0):0){E=C;F=D;G=33}}else{D=f[d>>2]|0;C=((n-(f[y>>2]|0)|0)/(D|0)|0)+1|0;A=(b|0)/(C|0)|0;H=Y(b-(Y(C,A)|0)|0,D)|0;D=Y(f[o>>2]|0,A)|0;E=H-(f[e>>2]|0)|0;F=D-(f[r>>2]|0)|0;G=33}if((G|0)==33){G=0;D=0;do{H=(f[p+(D*12|0)+8>>2]|0)+F|0;A=B+(f[p+(D*12|0)>>2]<<2)|0;f[m>>2]=(f[p+(D*12|0)+4>>2]|0)+E;f[a>>2]=H;H=sQb(l,m,A)|0;if((H|0)!=(A|0))dJc(A|0,H|0,x|0)|0;D=D+1|0}while((D|0)<(s|0))}b=b+1|0}while(b>>>0<z>>>0)}SPb(l);l=k+36|0;z=f[l>>2]|0;if(z|0?(b=z+12|0,z=f[b>>2]|0,f[b>>2]=z+-1,(z|0)==1):0)_S(k);f[l>>2]=0;l=k+16|0;z=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[z>>2]|0)>0){l=f[k+40>>2]|0;b=0;do{f[l+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[z>>2]|0))}z=f[k+44>>2]|0;if((z|0)==(k+48|0)){u=h;return}g0(z);u=h;return}function fQb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0;k=u;u=u+384|0;l=k+368|0;m=k+40|0;o=k+24|0;q=k+16|0;r=k;s=k+8|0;t=f[d>>2]|0;v=d+4|0;w=f[v>>2]|0;if((w|0)!=(t|0))f[v>>2]=w+(~((w+-8-t|0)>>>3)<<3);t=f[e>>2]|0;w=e+4|0;x=f[w>>2]|0;if((x|0)!=(t|0))f[w>>2]=x+(~((x+-8-t|0)>>>3)<<3);t=a+76|0;x=a+80|0;if((f[t>>2]|0)==(f[x>>2]|0)){u=k;return}y=f[h>>2]|0;z=h+4|0;A=f[z>>2]|0;if(!(A|y)){B=f[a+28>>2]|0;f[h>>2]=B;C=f[a+32>>2]|0;f[z>>2]=C;D=B;E=C}else{D=y;E=A}A=f[a+20>>2]|0;y=(D|0)<(A|0);C=y?A:D;B=y?D:A;if((B|0)>0){A=C;D=B;while(1){B=(A|0)%(D|0)|0;if((B|0)>0){y=D;D=B;A=y}else{F=D;break}}}else F=C;C=f[a+24>>2]|0;D=(E|0)<(C|0);A=D?C:E;y=D?E:C;if((y|0)>0){C=A;E=y;while(1){y=(C|0)%(E|0)|0;if((y|0)>0){D=E;E=y;C=D}else{G=E;break}}}else G=A;f[l>>2]=F;A=l+4|0;f[A>>2]=G;E=j+4|0;C=(f[E>>2]|0)-(f[j>>2]|0)>>3;D=f[i>>2]|0;y=F+-1+((D|0)>0?D:0)&0-F;f[i>>2]=y;F=i+4|0;D=f[F>>2]|0;B=G+-1+((D|0)>0?D:0)&0-G;f[F>>2]=B;G=c+12|0;D=(y<<1)+(f[G>>2]|0)|0;y=c+8|0;H=f[y>>2]|0;I=(C|0)==0;qQb(m,a,c,i,i,I,l);if(I)J=Y((((B<<1)+H-(f[m+48>>2]|0)|0)/(f[z>>2]|0)|0)+1|0,((D-(f[m+44>>2]|0)|0)/(f[h>>2]|0)|0)+1|0)|0;else J=C;C=f[m+16>>2]|0;H=Y(f[m+64>>2]|0,f[m+60>>2]|0)|0;B=f[m+76>>2]|0;I=rQb(a)|0;c=f[t>>2]|0;if((f[x>>2]|0)-c>>2>>>0>I>>>0)K=+n[c+(I<<2)>>2];else K=0.0;L=K;f[o>>2]=0;I=o+4|0;f[I>>2]=0;f[o+8>>2]=0;do if(B)if(B>>>0>1073741823)mCc(o);else{c=B<<2;x=VDc(c)|0;f[o>>2]=x;M=x+(B<<2)|0;f[o+8>>2]=M;XIc(x|0,0,c|0)|0;f[I>>2]=M;N=x;O=x;break}else{N=0;O=0}while(0);do if(J){x=q+4|0;M=m+44|0;c=(H|0)>0;P=s+4|0;Q=B+-4|0;R=(B|0)<4;S=d+8|0;T=e+8|0;U=a+4|0;V=a+8|0;W=B&-4;X=(B|0)>0;Z=(W|0)<(B|0);_=0;while(1){f[q>>2]=0;f[x>>2]=0;$=f[j>>2]|0;if(($|0)==(f[E>>2]|0)){aa=f[h>>2]|0;ba=((D-(f[M>>2]|0)|0)/(aa|0)|0)+1|0;ca=(_|0)/(ba|0)|0;da=Y(_-(Y(ba,ca)|0)|0,aa)|0;aa=Y(f[z>>2]|0,ca)|0;ca=da-(f[i>>2]|0)|0;da=aa-(f[F>>2]|0)|0;f[q>>2]=ca;f[x>>2]=da;if((ca|0)%(f[l>>2]|0)|0|0){ea=34;break}if(!((da|0)%(f[A>>2]|0)|0)){fa=ca;ga=da;ea=35}else{ea=34;break}}else{da=f[$+(_<<3)>>2]|0;f[q>>2]=da;ca=f[$+(_<<3)+4>>2]|0;f[x>>2]=ca;$=f[i>>2]|0;if((((da|0)>=(0-$|0)?(da|0)<=((f[G>>2]|0)+$-(f[U>>2]|0)|0):0)?($=f[F>>2]|0,(ca|0)>=(0-$|0)):0)?(ca|0)<=((f[y>>2]|0)+$-(f[V>>2]|0)|0):0){fa=da;ga=ca;ea=35}}if((ea|0)==35){ea=0;p[r>>3]=L;ca=f[t>>2]|0;a:do if(c)if(R){da=0;$=ca;aa=fa;ba=ga;while(1){ha=(f[C+(da*12|0)+8>>2]|0)+ba|0;f[s>>2]=(f[C+(da*12|0)+4>>2]|0)+aa;f[P>>2]=ha;ha=sQb(m,s,f[o>>2]|0)|0;if(X){ia=0;K=+p[r>>3];do{K=K+ +n[ha+(ia<<2)>>2]*+n[$+(ia<<2)>>2];ia=ia+1|0}while((ia|0)!=(B|0));p[r>>3]=K}ia=da+1|0;if((ia|0)>=(H|0))break;da=ia;$=$+(B<<2)|0;aa=f[q>>2]|0;ba=f[x>>2]|0}ja=+p[r>>3];break}else{ba=0;aa=ca;$=fa;da=ga;while(1){ia=(f[C+(ba*12|0)+8>>2]|0)+da|0;f[s>>2]=(f[C+(ba*12|0)+4>>2]|0)+$;f[P>>2]=ia;ia=sQb(m,s,f[o>>2]|0)|0;ha=0;ka=+p[r>>3];do{la=ha|1;ma=ha|2;na=ha|3;ka=ka+(+n[ia+(ha<<2)>>2]*+n[aa+(ha<<2)>>2]+ +n[ia+(la<<2)>>2]*+n[aa+(la<<2)>>2]+ +n[ia+(ma<<2)>>2]*+n[aa+(ma<<2)>>2]+ +n[ia+(na<<2)>>2]*+n[aa+(na<<2)>>2]);ha=ha+4|0}while((ha|0)<=(Q|0));p[r>>3]=ka;if(Z){ha=W;K=ka;do{K=K+ +n[ia+(ha<<2)>>2]*+n[aa+(ha<<2)>>2];ha=ha+1|0}while((ha|0)!=(B|0));p[r>>3]=K;oa=K}else oa=ka;ha=ba+1|0;if((ha|0)>=(H|0)){ja=oa;break a}ba=ha;aa=aa+(B<<2)|0;$=f[q>>2]|0;da=f[x>>2]|0}}else ja=L;while(0);do if(ja>=g){ca=f[v>>2]|0;if((ca|0)==(f[S>>2]|0))fga(d,q);else{f[ca>>2]=f[q>>2];f[ca+4>>2]=f[x>>2];f[v>>2]=ca+8}ca=f[w>>2]|0;if((ca|0)==(f[T>>2]|0)){zOb(e,r);break}else{p[ca>>3]=+p[r>>3];f[w>>2]=ca+8;break}}while(0)}_=_+1|0;if(_>>>0>=J>>>0){ea=22;break}}if((ea|0)==22){_=f[o>>2]|0;pa=_;qa=_;break}else if((ea|0)==34){f[r>>2]=0;f[r+4>>2]=0;_=tT(r,65)|0;T=471290;x=_+65|0;do{b[_>>0]=b[T>>0]|0;_=_+1|0;T=T+1|0}while((_|0)<(x|0));z5(-215,r,471356,470838,1707)}}else{pa=O;qa=N}while(0);if(pa|0){N=f[I>>2]|0;if((N|0)!=(pa|0))f[I>>2]=N+(~((N+-4-pa|0)>>>2)<<2);YDc(qa)}SPb(m);u=k;return}function gQb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;n=f[(f[a>>2]|0)+36>>2]|0;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];tg[n&7](a,b,c,j,d,k,l,h);h=f[j>>2]|0;if(!h){u=i;return}j=f[m>>2]|0;if((j|0)!=(h|0))f[m>>2]=j+(~((j+-8-h|0)>>>3)<<3);YDc(h);u=i;return}function hQb(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;l=u;u=u+272|0;m=l+112|0;n=l+264|0;o=l+252|0;q=l+240|0;r=l+228|0;s=l+216|0;t=l+204|0;v=l+200|0;w=l+144|0;x=l+136|0;y=l;z=l+128|0;A=l+120|0;p[m>>3]=1.0;b$(n,b,-1);f[o>>2]=0;B=o+4|0;f[B>>2]=0;f[o+8>>2]=0;C=a+140|0;a:do if((f[C>>2]|0)>0){D=o+8|0;E=a+4|0;F=n+4|0;G=a+8|0;if(!(i<=1.0)){H=0;I=0;J=1.0;K=0}else{zOb(o,m);L=0;break}while(1){if((H|0)==(I|0))zOb(o,m);else{p[H>>3]=J;f[B>>2]=H+8}M=+p[m>>3];N=nrc(+(f[n>>2]|0)/M)|0;if((N|0)<(f[E>>2]|0)){L=K;break a}N=nrc(+(f[F>>2]|0)/M)|0;if((N|0)<(f[G>>2]|0)){L=K;break a}O=M*i;p[m>>3]=O;N=K+1|0;if((N|0)>=(f[C>>2]|0)){L=N;break a}H=f[B>>2]|0;I=f[D>>2]|0;J=O;K=N}}else L=0;while(0);K=(L|0)>1?L:1;L=f[B>>2]|0;I=f[o>>2]|0;H=L-I>>3;C=I;I=L;if(K>>>0<=H>>>0){if(K>>>0<H>>>0?(L=C+(K<<3)|0,(I|0)!=(L|0)):0)f[B>>2]=I+(~((I+-8-L|0)>>>3)<<3)}else cha(o,K-H|0);H=g+4|0;if(!(f[H>>2]|f[g>>2])){f[g>>2]=f[a+20>>2];f[H>>2]=f[a+24>>2]}f[q>>2]=0;H=q+4|0;f[H>>2]=0;f[q+8>>2]=0;f[r>>2]=0;K=r+4|0;f[K>>2]=0;f[r+8>>2]=0;f[s>>2]=0;L=s+4|0;f[L>>2]=0;f[s+8>>2]=0;f[t>>2]=0;I=t+4|0;f[I>>2]=0;f[t+8>>2]=0;k6(v);do if((d$(b)|0)==65536){C=f[b+4>>2]|0;f[w>>2]=f[C>>2];m=w+4|0;D=C+4|0;f[m>>2]=f[D>>2];G=w+8|0;f[G>>2]=f[C+8>>2];f[w+12>>2]=f[C+12>>2];f[w+16>>2]=f[C+16>>2];f[w+20>>2]=f[C+20>>2];f[w+24>>2]=f[C+24>>2];f[w+28>>2]=f[C+28>>2];f[w+32>>2]=f[C+32>>2];F=f[C+36>>2]|0;f[w+36>>2]=F;f[w+40>>2]=G;G=w+48|0;E=w+44|0;f[E>>2]=G;f[G>>2]=0;f[w+52>>2]=0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[D>>2]|0)<3){D=f[C+44>>2]|0;G=f[E>>2]|0;f[G>>2]=f[D>>2];f[G+4>>2]=f[D+4>>2];break}else{f[m>>2]=0;ZS(w,C);break}}else a$(w,b,-1);while(0);b=f[o>>2]|0;C=(f[B>>2]|0)-b>>3;f[x>>2]=0;f[x+4>>2]=C;tQb(y,a,w,e,g,h,b,q,v,s,r);y8(x,y,-1.0);x=f[r>>2]|0;b=f[K>>2]|0;if((x|0)!=(b|0)){h=t+8|0;g=x;do{x=f[I>>2]|0;if((x|0)==(f[h>>2]|0))zOb(t,g);else{p[x>>3]=+p[g>>3];f[I>>2]=x+8}g=g+8|0}while((g|0)!=(b|0))}b=f[c>>2]|0;g=c+4|0;h=f[g>>2]|0;if((h|0)==(b|0))P=b;else{x=h+(~((h+-16-b|0)>>>4)<<4)|0;f[g>>2]=x;P=x}x=f[q>>2]|0;b=f[H>>2]|0;b:do if((x|0)!=(b|0)){h=c+8|0;C=P;m=x;while(1){if((C|0)==(f[h>>2]|0))$Lb(c,m);else{f[C>>2]=f[m>>2];f[C+4>>2]=f[m+4>>2];f[C+8>>2]=f[m+8>>2];f[C+12>>2]=f[m+12>>2];f[g>>2]=C+16}D=m+16|0;if((D|0)==(b|0))break b;C=f[g>>2]|0;m=D}}while(0);g=f[d>>2]|0;b=d+4|0;x=f[b>>2]|0;if((x|0)==(g|0))Q=g;else{P=x+(~((x+-8-g|0)>>>3)<<3)|0;f[b>>2]=P;Q=P}P=f[s>>2]|0;g=f[L>>2]|0;c:do if((P|0)!=(g|0)){x=d+8|0;m=P;C=Q;while(1){if((C|0)==(f[x>>2]|0))zOb(d,m);else{p[C>>3]=+p[m>>3];f[b>>2]=C+8}h=m+8|0;if((h|0)==(g|0))break c;m=h;C=f[b>>2]|0}}while(0);if(k){f[z>>2]=f[a+4>>2];f[z+4>>2]=f[a+8>>2];cPb(c,d,t,j,z)}else uQb(0,c,d,~~j,.2);f[A>>2]=f[n>>2];f[A+4>>2]=f[n+4>>2];sPb(A,c,0,d);f[y>>2]=137796;d=y+8|0;c=y+44|0;A=f[c>>2]|0;if(A|0?(n=A+12|0,A=f[n>>2]|0,f[n>>2]=A+-1,(A|0)==1):0)_S(d);f[c>>2]=0;c=y+24|0;d=y+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[y+48>>2]|0;A=0;do{f[c+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[d>>2]|0))}d=f[y+52>>2]|0;if((d|0)!=(y+56|0))g0(d);d=w+36|0;y=f[d>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)_S(w);f[d>>2]=0;d=w+16|0;y=w+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[y>>2]|0)>0){d=f[w+40>>2]|0;A=0;do{f[d+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[y>>2]|0))}y=f[w+44>>2]|0;if((y|0)!=(w+48|0))g0(y);l6(v);v=f[t>>2]|0;if(v|0){t=f[I>>2]|0;if((t|0)!=(v|0))f[I>>2]=t+(~((t+-8-v|0)>>>3)<<3);YDc(v)}v=f[s>>2]|0;if(v|0){s=f[L>>2]|0;if((s|0)!=(v|0))f[L>>2]=s+(~((s+-8-v|0)>>>3)<<3);YDc(v)}v=f[r>>2]|0;if(v|0){r=f[K>>2]|0;if((r|0)!=(v|0))f[K>>2]=r+(~((r+-8-v|0)>>>3)<<3);YDc(v)}v=f[q>>2]|0;if(v|0){q=f[H>>2]|0;if((q|0)!=(v|0))f[H>>2]=q+(~((q+-16-v|0)>>>4)<<4);YDc(v)}v=f[o>>2]|0;if(!v){u=l;return}o=f[B>>2]|0;if((o|0)!=(v|0))f[B>>2]=o+(~((o+-8-v|0)>>>3)<<3);YDc(v);u=l;return}function iQb(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l>>2]=0;o=l+4|0;f[o>>2]=0;f[l+8>>2]=0;p=f[(f[a>>2]|0)+44>>2]|0;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];Yg[p&3](a,b,c,l,d,m,n,h,i,j);j=f[l>>2]|0;if(!j){u=k;return}l=f[o>>2]|0;if((l|0)!=(j|0))f[o>>2]=l+(~((l+-8-j|0)>>>3)<<3);YDc(j);u=k;return}function jQb(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0;j=u;u=u+2496|0;k=j+1424|0;l=j+1416|0;m=j+1408|0;o=j+1352|0;p=j+288|0;q=j+232|0;r=j+176|0;s=j+120|0;t=j+64|0;v=j+48|0;w=j+32|0;x=j+16|0;y=j;switch(f[c>>2]&4095){case 16:case 0:break;default:{f[k>>2]=0;f[k+4>>2]=0;z=tT(k,44)|0;A=471128;B=z+44|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,471173,470838,244)}}C=f[c+12>>2]|0;D=f[g>>2]|0;E=f[i>>2]|0;F=D+C+E|0;G=g+4|0;H=(f[G>>2]|0)+(f[c+8>>2]|0)+(f[i+4>>2]|0)|0;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(H|0):0)?(f[d+12>>2]|0)==(F|0):0)?(f[d>>2]&4095|0)==13:0)?(f[d+16>>2]|0)!=0:0)){f[k>>2]=H;f[k+4>>2]=F;XS(d,2,k,13)}if(((((f[e+4>>2]|0)<3?(f[e+8>>2]|0)==(H|0):0)?(f[e+12>>2]|0)==(F|0):0)?(f[e>>2]&4095|0)==8:0)?(f[e+16>>2]|0)!=0:0){I=k;J=k+4|0;K=k}else{f[k>>2]=H;i=k+4|0;f[i>>2]=F;XS(e,2,k,8);I=k;J=i;K=k}f[l>>2]=0;K=l+4|0;f[K>>2]=0;f[m>>2]=0;i=m+4|0;f[i>>2]=0;jT(c,l,m);L=(f[c>>2]|0)>>>3&511;f[o>>2]=1124007936;N=o+4|0;O=o+8|0;P=o+40|0;z=N;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[P>>2]=O;O=o+48|0;Q=o+44|0;f[Q>>2]=O;f[O>>2]=0;f[o+52>>2]=0;f[I>>2]=1;f[J>>2]=256;XS(o,2,I,5);I=o+16|0;J=f[I>>2]|0;if(!(b[a+72>>0]|0)){R=0;do{n[J+(R<<2)>>2]=+(R|0);R=R+1|0}while((R|0)!=256)}else{R=0;do{S=+M(+(+(R|0)));n[J+(R<<2)>>2]=S;R=R+1|0}while((R|0)!=256)}R=F+4+H|0;T=k+8|0;f[k>>2]=T;U=k+4|0;f[U>>2]=R;if(R>>>0>264){V=XDc(R>>>0>1073741823?-1:R<<2)|0;f[k>>2]=V;W=V}else W=T;V=W+4|0;R=V+(F<<2)+8|0;if((F|0)>=-1){X=-1;while(1){Z=p_(X-(f[g>>2]|0)+(f[m>>2]|0)|0,f[l>>2]|0,4)|0;f[V+(X<<2)>>2]=Z-(f[m>>2]|0);if((X|0)<(F|0))X=X+1|0;else break}}if((H|0)>=-1){X=-1;while(1){m=p_(X-(f[G>>2]|0)+(f[i>>2]|0)|0,f[K>>2]|0,4)|0;f[R+(X<<2)>>2]=m-(f[i>>2]|0);if((X|0)<(H|0))X=X+1|0;else break}}X=F<<2;i=p+8|0;f[p>>2]=i;K=p+4|0;f[K>>2]=X;if(X>>>0>264){G=XDc(X>>>0>1073741823?-1:X<<2)|0;f[p>>2]=G;_=G}else _=i;Vj(q,1,F,5,_,0);Vj(r,1,F,5,_+(F<<2)|0,0);G=F<<1;Vj(s,1,F,5,_+(G<<2)|0,0);X=F*3|0;Vj(t,1,F,5,_+(X<<2)|0,0);if((L|0)==2&(F|0)>-2){m=E+D+C+1|0;C=0;while(1){D=W+(C<<2)|0;f[D>>2]=(f[D>>2]|0)*3;if((C|0)==(m|0))break;else C=C+1|0}}C=a+36|0;S=+(f[C>>2]|0)/(b[a+144>>0]|0?6.283185307179586:3.141592653589793);a:do if((H|0)>0){a=c+16|0;m=c+44|0;W=c+48|0;D=d+16|0;E=d+44|0;l=e+16|0;g=e+44|0;Z=(L|0)==0;$=v+8|0;aa=v+12|0;ba=v+4|0;ca=w+8|0;da=w+12|0;ea=w+4|0;fa=x+8|0;ga=x+4|0;ha=y+8|0;ia=y+4|0;ja=(F|0)>0;ka=0;b:while(1){la=f[a>>2]|0;ma=la+(Y(f[f[m>>2]>>2]|0,f[R+(ka<<2)>>2]|0)|0)|0;na=f[W>>2]|0;oa=la+(Y(f[R+(ka+-1<<2)>>2]|0,na)|0)|0;pa=ka;ka=ka+1|0;qa=la+(Y(f[R+(ka<<2)>>2]|0,na)|0)|0;na=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,pa)|0)|0;la=(f[l>>2]|0)+(Y(f[f[g>>2]>>2]|0,pa)|0)|0;if(Z){if(ja){pa=0;ra=f[V>>2]|0;do{sa=pa;pa=pa+1|0;ta=ra;ra=f[V+(pa<<2)>>2]|0;n[_+(sa<<2)>>2]=+n[J+(h[ma+ra>>0]<<2)>>2]-+n[J+(h[ma+(f[V+(sa+-1<<2)>>2]|0)>>0]<<2)>>2];n[_+(sa+F<<2)>>2]=+n[J+(h[qa+ta>>0]<<2)>>2]-+n[J+(h[oa+ta>>0]<<2)>>2]}while((pa|0)!=(F|0))}}else if(ja){pa=0;ra=f[V>>2]|0;do{ta=pa;pa=pa+1|0;sa=ra;ra=f[V+(pa<<2)>>2]|0;ua=ma+ra|0;va=ma+(f[V+(ta+-1<<2)>>2]|0)|0;wa=+n[J+(h[ua+2>>0]<<2)>>2]-+n[J+(h[va+2>>0]<<2)>>2];xa=sa+2|0;ya=+n[J+(h[qa+xa>>0]<<2)>>2]-+n[J+(h[oa+xa>>0]<<2)>>2];za=wa*wa+ya*ya;Aa=+n[J+(h[ua+1>>0]<<2)>>2]-+n[J+(h[va+1>>0]<<2)>>2];xa=sa+1|0;Ba=+n[J+(h[qa+xa>>0]<<2)>>2]-+n[J+(h[oa+xa>>0]<<2)>>2];Ca=Aa*Aa+Ba*Ba;xa=za<Ca;Da=+n[J+(h[ua>>0]<<2)>>2]-+n[J+(h[va>>0]<<2)>>2];Ea=+n[J+(h[qa+sa>>0]<<2)>>2]-+n[J+(h[oa+sa>>0]<<2)>>2];sa=(xa?Ca:za)<Da*Da+Ea*Ea;n[_+(ta<<2)>>2]=sa?Da:xa?Aa:wa;n[_+(ta+F<<2)>>2]=sa?Ea:xa?Ba:ya}while((pa|0)!=(F|0))}f[$>>2]=0;f[aa>>2]=0;f[v>>2]=16842752;f[ba>>2]=q;f[ca>>2]=0;f[da>>2]=0;f[w>>2]=16842752;f[ea>>2]=r;pa=fa;f[pa>>2]=0;f[pa+4>>2]=0;f[x>>2]=33619968;f[ga>>2]=s;pa=ha;f[pa>>2]=0;f[pa+4>>2]=0;f[y>>2]=33619968;f[ia>>2]=t;$2(v,w,x,y,0);if(ja){pa=0;do{ya=+n[_+(pa+G<<2)>>2];Ba=S*+n[_+(pa+X<<2)>>2]+-.5;oa=~~Ba;qa=oa-(+(oa|0)>Ba&1)|0;Ea=Ba-+(qa|0);oa=pa<<1;n[na+(oa<<2)>>2]=ya*(1.0-Ea);ma=oa|1;n[na+(ma<<2)>>2]=ya*Ea;ra=f[C>>2]|0;if((qa|0)<0)Fa=qa+ra|0;else Fa=qa-((qa|0)<(ra|0)?0:ra)|0;if(Fa>>>0>=ra>>>0)break b;b[la+oa>>0]=Fa;oa=Fa+1|0;b[la+ma>>0]=(oa|0)<(f[C>>2]|0)?oa&255:0;pa=pa+1|0}while((pa|0)<(F|0))}if((ka|0)>=(H|0))break a}f[v>>2]=0;f[v+4>>2]=0;z=tT(v,32)|0;A=471189;B=z+32|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,v,471173,470838,542)}while(0);v=t+36|0;A=f[v>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)_S(t);f[v>>2]=0;v=t+16|0;A=t+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){v=f[t+40>>2]|0;z=0;do{f[v+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[A>>2]|0))}A=f[t+44>>2]|0;if((A|0)!=(t+48|0))g0(A);A=s+36|0;t=f[A>>2]|0;if(t|0?(z=t+12|0,t=f[z>>2]|0,f[z>>2]=t+-1,(t|0)==1):0)_S(s);f[A>>2]=0;A=s+16|0;t=s+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[t>>2]|0)>0){A=f[s+40>>2]|0;z=0;do{f[A+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))g0(t);t=r+36|0;s=f[t>>2]|0;if(s|0?(z=s+12|0,s=f[z>>2]|0,f[z>>2]=s+-1,(s|0)==1):0)_S(r);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;z=0;do{f[t+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))g0(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){z=r+12|0;t=f[z>>2]|0;f[z>>2]=t+-1;if((t|0)!=1)break;_S(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))g0(r);r=f[p>>2]|0;if((r|0)!=(i|0)){if(r|0)ZDc(r);f[p>>2]=i;f[K>>2]=264}K=f[k>>2]|0;if((K|0)!=(T|0)){if(K|0)ZDc(K);f[k>>2]=T;f[U>>2]=264}U=o+36|0;T=f[U>>2]|0;do if(T|0){k=T+12|0;K=f[k>>2]|0;f[k>>2]=K+-1;if((K|0)!=1)break;_S(o)}while(0);f[U>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[N>>2]|0)>0){I=f[P>>2]|0;P=0;do{f[I+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[N>>2]|0))}N=f[Q>>2]|0;if((N|0)==(O|0)){u=j;return}g0(N);u=j;return}function kQb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0;j=u;u=u+384|0;k=j+368|0;l=j+40|0;m=j+24|0;o=j+16|0;q=j;r=j+8|0;s=f[d>>2]|0;t=d+4|0;v=f[t>>2]|0;if((v|0)!=(s|0))f[t>>2]=v+(~((v+-8-s|0)>>>3)<<3);s=f[e>>2]|0;v=e+4|0;w=f[v>>2]|0;if((w|0)!=(s|0))f[v>>2]=w+(~((w+-8-s|0)>>>3)<<3);s=a+76|0;w=a+80|0;if((f[s>>2]|0)==(f[w>>2]|0)){u=j;return}x=f[c>>2]|0;y=f[c+4>>2]|0;z=y;A=x;if((x|0)==(y|0)){u=j;return}y=f[h>>2]|0;x=h+4|0;B=f[x>>2]|0;if(!(B|y)){C=f[a+28>>2]|0;f[h>>2]=C;D=f[a+32>>2]|0;f[x>>2]=D;E=C;F=D}else{E=y;F=B}B=f[a+20>>2]|0;y=(E|0)<(B|0);D=y?B:E;C=y?E:B;if((C|0)>0){B=D;E=C;while(1){C=(B|0)%(E|0)|0;if((C|0)>0){y=E;E=C;B=y}else{G=E;break}}}else G=D;D=f[a+24>>2]|0;E=(F|0)<(D|0);B=E?D:F;y=E?F:D;if((y|0)>0){D=B;F=y;while(1){y=(D|0)%(F|0)|0;if((y|0)>0){E=F;F=y;D=E}else{H=F;break}}}else H=B;f[k>>2]=G;f[k+4>>2]=H;B=z-A>>3;A=f[i>>2]|0;z=G+-1+((A|0)>0?A:0)&0-G;f[i>>2]=z;G=i+4|0;A=f[G>>2]|0;F=H+-1+((A|0)>0?A:0)&0-H;f[G>>2]=F;H=b+12|0;A=f[H>>2]|0;D=b+8|0;E=f[D>>2]|0;qQb(l,a,b,i,i,1,k);if(!B)I=Y((((F<<1)+E-(f[l+48>>2]|0)|0)/(f[x>>2]|0)|0)+1|0,(((z<<1)+A-(f[l+44>>2]|0)|0)/(f[h>>2]|0)|0)+1|0)|0;else I=B;B=f[l+16>>2]|0;h=Y(f[l+64>>2]|0,f[l+60>>2]|0)|0;A=f[l+76>>2]|0;z=rQb(a)|0;x=f[s>>2]|0;if((f[w>>2]|0)-x>>2>>>0>z>>>0)J=+n[x+(z<<2)>>2];else J=0.0;K=J;f[m>>2]=0;z=m+4|0;f[z>>2]=0;f[m+8>>2]=0;do if(A)if(A>>>0>1073741823)mCc(m);else{x=A<<2;w=VDc(x)|0;f[m>>2]=w;E=w+(A<<2)|0;f[m+8>>2]=E;XIc(w|0,0,x|0)|0;f[z>>2]=E;L=w;M=w;break}else{L=0;M=0}while(0);if(!I){N=M;O=L}else{L=o+4|0;M=e+8|0;w=a+4|0;E=a+8|0;a=(h|0)>0;x=r+4|0;F=A+-4|0;k=(A|0)<4;b=d+8|0;y=A&-4;C=(A|0)>0;P=(y|0)<(A|0);Q=0;do{f[o>>2]=0;f[L>>2]=0;R=f[c>>2]|0;S=f[R+(Q<<3)>>2]|0;f[o>>2]=S;T=f[R+(Q<<3)+4>>2]|0;f[L>>2]=T;R=f[i>>2]|0;if((((S|0)>=(0-R|0)?(S|0)<=((f[H>>2]|0)+R-(f[w>>2]|0)|0):0)?(R=f[G>>2]|0,(T|0)>=(0-R|0)):0)?(T|0)<=((f[D>>2]|0)+R-(f[E>>2]|0)|0):0){p[q>>3]=K;R=f[s>>2]|0;a:do if(a){if(k){U=0;V=R;W=S;X=T;while(1){Z=(f[B+(U*12|0)+8>>2]|0)+X|0;f[r>>2]=(f[B+(U*12|0)+4>>2]|0)+W;f[x>>2]=Z;Z=sQb(l,r,f[m>>2]|0)|0;if(C){_=0;J=+p[q>>3];do{J=J+ +n[Z+(_<<2)>>2]*+n[V+(_<<2)>>2];_=_+1|0}while((_|0)!=(A|0));p[q>>3]=J}_=U+1|0;if((_|0)>=(h|0))break a;U=_;V=V+(A<<2)|0;W=f[o>>2]|0;X=f[L>>2]|0}}else{$=0;aa=R;ba=S;ca=T}while(1){X=(f[B+($*12|0)+8>>2]|0)+ca|0;f[r>>2]=(f[B+($*12|0)+4>>2]|0)+ba;f[x>>2]=X;X=sQb(l,r,f[m>>2]|0)|0;W=0;da=+p[q>>3];do{V=W|1;U=W|2;_=W|3;da=da+(+n[X+(W<<2)>>2]*+n[aa+(W<<2)>>2]+ +n[X+(V<<2)>>2]*+n[aa+(V<<2)>>2]+ +n[X+(U<<2)>>2]*+n[aa+(U<<2)>>2]+ +n[X+(_<<2)>>2]*+n[aa+(_<<2)>>2]);W=W+4|0}while((W|0)<=(F|0));p[q>>3]=da;if(P){W=y;J=da;do{J=J+ +n[X+(W<<2)>>2]*+n[aa+(W<<2)>>2];W=W+1|0}while((W|0)!=(A|0));p[q>>3]=J}W=$+1|0;if((W|0)>=(h|0))break a;$=W;aa=aa+(A<<2)|0;ba=f[o>>2]|0;ca=f[L>>2]|0}}while(0);T=f[v>>2]|0;if((T|0)==(f[M>>2]|0))zOb(e,q);else{p[T>>3]=+p[q>>3];f[v>>2]=T+8}do if(+p[q>>3]>=g){T=f[t>>2]|0;if((T|0)==(f[b>>2]|0)){fga(d,o);break}else{f[T>>2]=f[o>>2];f[T+4>>2]=f[L>>2];f[t>>2]=T+8;break}}while(0)}else{p[q>>3]=-10.0;T=f[v>>2]|0;if((T|0)==(f[M>>2]|0))zOb(e,q);else{p[T>>3]=-10.0;f[v>>2]=T+8}}Q=Q+1|0}while(Q>>>0<I>>>0);I=f[m>>2]|0;N=I;O=I}if(N|0){I=f[z>>2]|0;if((I|0)!=(N|0))f[z>>2]=I+(~((I+-4-N|0)>>>2)<<2);YDc(O)}SPb(l);u=j;return}function lQb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+128|0;i=h+116|0;j=h+112|0;k=h+104|0;l=h;m=h+96|0;f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;k6(j);o=(f[d+4>>2]|0)-(f[d>>2]|0)>>5;f[k>>2]=0;f[k+4>>2]=o;f[m>>2]=8;f[m+4>>2]=8;mQb(l,a,b,e,m,d,i,j);y8(k,l,-1.0);f[l>>2]=137776;k=l+8|0;d=l+44|0;m=f[d>>2]|0;if(m|0?(b=m+12|0,m=f[b>>2]|0,f[b>>2]=m+-1,(m|0)==1):0)_S(k);f[d>>2]=0;d=l+24|0;k=l+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[l+48>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[l+52>>2]|0;if((k|0)!=(l+56|0))g0(k);k=f[n>>2]|0;l=f[i>>2]|0;m=k-l>>4;d=c+4|0;b=f[d>>2]|0;a=f[c>>2]|0;o=b-a>>4;p=a;a=b;b=l;l=k;if(m>>>0<=o>>>0)if(m>>>0<o>>>0?(k=p+(m<<4)|0,(a|0)!=(k|0)):0){f[d>>2]=a+(~((a+-16-k|0)>>>4)<<4);q=b;r=l}else{q=b;r=l}else{JOb(c,m-o|0);q=f[i>>2]|0;r=f[n>>2]|0}if((q|0)!=(r|0)){o=q;q=f[c>>2]|0;while(1){f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];f[q+8>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2];o=o+16|0;if((o|0)==(r|0))break;else q=q+16|0}}$Ob(c,g,.2);l6(j);j=f[i>>2]|0;if(!j){u=h;return}i=f[n>>2]|0;if((i|0)!=(j|0))f[n>>2]=i+(~((i+-16-j|0)>>>4)<<4);YDc(j);u=h;return}function mQb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f[a>>2]=137776;j=a+8|0;f[j>>2]=1124007936;k=a+12|0;l=a+16|0;m=a+48|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;n=a+56|0;o=a+52|0;f[o>>2]=n;f[n>>2]=0;f[a+60>>2]=0;n=a+76|0;f[n>>2]=0;q=a+80|0;f[q>>2]=0;f[a+4>>2]=b;if((j|0)==(c|0)){r=a+64|0;p[r>>3]=d;s=f[e>>2]|0;f[n>>2]=s;t=e+4|0;u=f[t>>2]|0;f[q>>2]=u;v=a+72|0;f[v>>2]=g;w=a+84|0;f[w>>2]=h;x=a+88|0;f[x>>2]=i;return}b=c+36|0;y=f[b>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=a+44|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){_S(j);B=z}else B=z}else B=a+44|0;f[B>>2]=0;z=a+24|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[k>>2]|0)>0){y=f[m>>2]|0;m=0;do{f[y+(m<<2)>>2]=0;m=m+1|0;C=f[k>>2]|0}while((m|0)<(C|0));f[j>>2]=f[c>>2];if((C|0)<3)D=12;else D=14}else{f[j>>2]=f[c>>2];D=12}if((D|0)==12){C=f[c+4>>2]|0;if((C|0)<3){f[k>>2]=C;f[l>>2]=f[c+8>>2];f[a+20>>2]=f[c+12>>2];l=f[c+44>>2]|0;C=f[o>>2]|0;f[C>>2]=f[l>>2];f[C+4>>2]=f[l+4>>2]}else D=14}if((D|0)==14)ZS(j,c);f[z>>2]=f[c+16>>2];f[a+28>>2]=f[c+20>>2];f[a+32>>2]=f[c+24>>2];f[a+36>>2]=f[c+28>>2];f[a+40>>2]=f[c+32>>2];f[B>>2]=f[b>>2];r=a+64|0;p[r>>3]=d;s=f[e>>2]|0;f[n>>2]=s;t=e+4|0;u=f[t>>2]|0;f[q>>2]=u;v=a+72|0;f[v>>2]=g;w=a+84|0;f[w>>2]=h;x=a+88|0;f[x>>2]=i;return}function nQb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137776;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;g0(b);return}function oQb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137776;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0)){YDc(a);return}g0(b);YDc(a);return}function pQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;c=u;u=u+240|0;d=c+224|0;e=c+168|0;g=c+104|0;h=c+160|0;i=c+48|0;j=c+40|0;k=c+24|0;l=c+16|0;m=c+8|0;n=c;o=f[b>>2]|0;q=f[b+4>>2]|0;b=a+8|0;r=a+20|0;s=a+72|0;t=+p[f[f[s>>2]>>2]>>3];v=+(f[r>>2]|0)/t;w=~~v;x=(+(w|0)<v&1)+w|0;w=a+16|0;v=+(f[w>>2]|0)/t;y=~~v;z=(+(y|0)<v&1)+y|0;y=f[b>>2]&4095;f[e>>2]=1124007936;A=e+4|0;B=e+8|0;C=e+40|0;D=A;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[C>>2]=B;B=e+48|0;D=e+44|0;f[D>>2]=B;f[B>>2]=0;f[e+52>>2]=0;f[d>>2]=z;f[d+4>>2]=x;XS(e,2,d,y);f[d>>2]=0;y=d+4|0;f[y>>2]=0;f[d+8>>2]=0;if((o|0)<(q|0)){x=h+4|0;z=e+16|0;E=a+48|0;F=j+4|0;G=a+24|0;H=a+56|0;I=i+36|0;J=g+36|0;K=g+16|0;L=g+4|0;M=g+40|0;N=i+4|0;O=i+8|0;P=g+8|0;Q=i+12|0;R=g+12|0;S=i+44|0;T=g+44|0;U=i+16|0;V=i+20|0;W=g+20|0;X=i+24|0;Y=g+24|0;Z=i+28|0;_=g+28|0;$=i+32|0;aa=g+32|0;ba=i+40|0;ca=i+48|0;da=a+4|0;ea=a+64|0;fa=m+4|0;ga=a+76|0;ha=n+4|0;ia=a+80|0;ja=a+88|0;ka=g+48|0;la=a+84|0;a=i+4|0;ma=i+8|0;na=i+12|0;oa=i+8|0;pa=i+12|0;qa=i+4|0;ra=k+8|0;sa=k+4|0;ta=l+4|0;ua=o;do{v=+p[(f[f[s>>2]>>2]|0)+(ua<<5)>>3];o=nrc(+(f[r>>2]|0)/v)|0;va=nrc(+(f[w>>2]|0)/v)|0;f[h>>2]=o;f[x>>2]=va;CY(g,h,f[b>>2]&4095,f[z>>2]|0,0);wa=f[E>>2]|0;if((va|0)==(f[wa>>2]|0)?(o|0)==(f[wa+4>>2]|0):0){f[j>>2]=o;f[F>>2]=va;CY(i,j,f[b>>2]&4095,f[G>>2]|0,f[H>>2]|0);wa=f[I>>2]|0;if(wa|0){xa=wa+12|0;f[xa>>2]=(f[xa>>2]|0)+1}xa=f[J>>2]|0;if(xa|0?(wa=xa+12|0,xa=f[wa>>2]|0,f[wa>>2]=xa+-1,(xa|0)==1):0)_S(g);f[J>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[L>>2]|0)>0){xa=f[M>>2]|0;wa=0;do{f[xa+(wa<<2)>>2]=0;wa=wa+1|0;ya=f[L>>2]|0}while((wa|0)<(ya|0));f[g>>2]=f[i>>2];if((ya|0)<3)za=14;else za=16}else{f[g>>2]=f[i>>2];za=14}if((za|0)==14){za=0;wa=f[N>>2]|0;if((wa|0)<3){f[L>>2]=wa;f[P>>2]=f[O>>2];f[R>>2]=f[Q>>2];wa=f[S>>2]|0;xa=f[T>>2]|0;f[xa>>2]=f[wa>>2];f[xa+4>>2]=f[wa+4>>2]}else za=16}if((za|0)==16){za=0;ZS(g,i)}f[K>>2]=f[U>>2];f[W>>2]=f[V>>2];f[Y>>2]=f[X>>2];f[_>>2]=f[Z>>2];f[aa>>2]=f[$>>2];wa=f[I>>2]|0;f[J>>2]=wa;if(wa|0?(xa=wa+12|0,wa=f[xa>>2]|0,f[xa>>2]=wa+-1,(wa|0)==1):0)_S(i);f[I>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[N>>2]|0)>0){wa=f[ba>>2]|0;xa=0;do{f[wa+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[N>>2]|0))}xa=f[S>>2]|0;if((xa|0)!=(ca|0))g0(xa)}else{f[oa>>2]=0;f[pa>>2]=0;f[i>>2]=16842752;f[qa>>2]=b;xa=ra;f[xa>>2]=0;f[xa+4>>2]=0;f[k>>2]=33619968;f[sa>>2]=g;f[l>>2]=o;f[ta>>2]=va;nfa(i,k,l,0.0,0.0,5)}xa=f[da>>2]|0;wa=f[(f[xa>>2]|0)+56>>2]|0;Aa=f[f[s>>2]>>2]|0;t=+p[ea>>3];f[m>>2]=0;f[fa>>2]=0;f[n>>2]=f[ga>>2];f[ha>>2]=f[ia>>2];Ei[wa&7](xa,g,Aa+(ua<<5)+8|0,d,Aa+(ua<<5)+20|0,t,m,n);Aa=f[da>>2]|0;xa=nrc(v*+(f[Aa+4>>2]|0))|0;wa=nrc(v*+(f[Aa+8>>2]|0))|0;m6(f[ja>>2]|0);Aa=f[y>>2]|0;Ba=f[d>>2]|0;if((Aa|0)!=(Ba|0)){Ca=0;Da=Ba;Ba=Aa;while(1){Aa=Da;Ea=f[la>>2]|0;Fa=nrc(v*+(f[Aa+(Ca<<3)>>2]|0))|0;Ga=nrc(v*+(f[Aa+(Ca<<3)+4>>2]|0))|0;f[i>>2]=Fa;f[a>>2]=Ga;f[ma>>2]=xa;f[na>>2]=wa;Aa=Ea+4|0;Ha=f[Aa>>2]|0;if((Ha|0)==(f[Ea+8>>2]|0)){$Lb(Ea,i);Ia=f[d>>2]|0;Ja=f[y>>2]|0}else{f[Ha>>2]=Fa;f[Ha+4>>2]=Ga;f[Ha+8>>2]=xa;f[Ha+12>>2]=wa;f[Aa>>2]=Ha+16;Ia=Da;Ja=Ba}Ca=Ca+1|0;if(Ca>>>0>=Ja-Ia>>3>>>0)break;else{Da=Ia;Ba=Ja}}}n6(f[ja>>2]|0);Ba=f[J>>2]|0;if(Ba|0?(Da=Ba+12|0,Ba=f[Da>>2]|0,f[Da>>2]=Ba+-1,(Ba|0)==1):0)_S(g);f[J>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[L>>2]|0)>0){Ba=f[M>>2]|0;Da=0;do{f[Ba+(Da<<2)>>2]=0;Da=Da+1|0}while((Da|0)<(f[L>>2]|0))}Da=f[T>>2]|0;if((Da|0)!=(ka|0))g0(Da);ua=ua+1|0}while((ua|0)<(q|0));q=f[d>>2]|0;if(q|0){d=f[y>>2]|0;if((d|0)!=(q|0))f[y>>2]=d+(~((d+-8-q|0)>>>3)<<3);YDc(q)}}q=e+36|0;d=f[q>>2]|0;if(d|0?(y=d+12|0,d=f[y>>2]|0,f[y>>2]=d+-1,(d|0)==1):0)_S(e);f[q>>2]=0;q=e+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[A>>2]|0)>0){q=f[C>>2]|0;C=0;do{f[q+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[D>>2]|0;if((A|0)==(B|0)){u=c;return}g0(A);u=c;return}function qQb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;f[a>>2]=137680;i=a+4|0;j=a+32|0;f[a+92>>2]=0;f[a+96>>2]=0;k=a+100|0;l=a+108|0;m=a+140|0;n=a+104|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;n=j;o=n+44|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+148|0;f[a+144>>2]=l;f[l>>2]=0;f[a+152>>2]=0;f[k>>2]=1124007941;k=a+156|0;l=a+164|0;m=a+196|0;n=a+160|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+204|0;f[a+200>>2]=l;f[l>>2]=0;f[a+208>>2]=0;f[k>>2]=1124007936;f[a+212>>2]=1124007936;k=a+220|0;l=a+252|0;n=a+216|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[l>>2]=k;k=a+260|0;f[a+256>>2]=k;f[k>>2]=0;f[a+264>>2]=0;f[a+268>>2]=1124007936;k=a+276|0;l=a+308|0;n=a+272|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[l>>2]=k;k=a+316|0;f[a+312>>2]=k;f[k>>2]=0;f[a+320>>2]=0;Ii[f[(f[a>>2]|0)+8>>2]&127](a,b,c,d,e,g,h);return}function rQb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c;e=f[a+12>>2]|0;g=f[a+28>>2]|0;if((e|0)%(g|0)|0|0){f[d>>2]=0;h=d+4|0;f[h>>2]=0;i=tT(d,80)|0;j=i;k=470905;l=j+80|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,470986,470838,90)}m=f[a+16>>2]|0;n=f[a+32>>2]|0;if((m|0)%(n|0)|0|0){f[d>>2]=0;h=d+4|0;f[h>>2]=0;i=tT(d,80)|0;j=i;k=470905;l=j+80|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,470986,470838,90)}i=(f[a+4>>2]|0)-e|0;h=f[a+20>>2]|0;if((i|0)%(h|0)|0|0){f[d>>2]=0;o=d+4|0;f[o>>2]=0;p=tT(d,123)|0;j=p;k=471004;l=j+123|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,470986,470838,92)}q=(f[a+8>>2]|0)-m|0;r=f[a+24>>2]|0;if(!((q|0)%(r|0)|0)){s=Y(Y(Y(Y((e|0)/(g|0)|0,f[a+36>>2]|0)|0,(m|0)/(n|0)|0)|0,((i|0)/(h|0)|0)+1|0)|0,((q|0)/(r|0)|0)+1|0)|0;u=c;return s|0}else{f[d>>2]=0;o=d+4|0;f[o>>2]=0;p=tT(d,123)|0;j=p;k=471004;l=j+123|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,d,470986,470838,92)}return 0}function sQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0;e=u;u=u+96|0;g=e;i=e+88|0;j=e+32|0;k=f[a+96>>2]|0;l=(f[c>>2]|0)+(f[a+92>>2]|0)|0;f[c>>2]=l;m=c+4|0;o=(f[m>>2]|0)+k|0;f[m>>2]=o;do if(b[a+28>>0]|0){k=f[a+52>>2]|0;if((l|0)%(k|0)|0|0){f[g>>2]=0;p=g+4|0;f[p>>2]=0;q=tT(g,63)|0;r=q;s=470765;t=r+63|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,g,470829,470838,874)}v=f[a+56>>2]|0;if((o|0)%(v|0)|0|0){f[g>>2]=0;p=g+4|0;f[p>>2]=0;q=tT(g,63)|0;r=q;s=470765;t=r+63|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,g,470829,470838,874)}w=(l|0)/(k|0)|0;x=((o|0)/(v|0)|0|0)%(f[a+108>>2]|0)|0;y=a+32|0;if((o|0)!=(f[(f[y>>2]|0)+(x<<2)>>2]|0)){f[g>>2]=x;f[g+4>>2]=x+1;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;$S(j,a+156|0,g,i);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;k_(j,g)|0;f[(f[y>>2]|0)+(x<<2)>>2]=f[m>>2];y=j+36|0;z=f[y>>2]|0;if(z|0?(A=z+12|0,z=f[A>>2]|0,f[A>>2]=z+-1,(z|0)==1):0)_S(j);f[y>>2]=0;y=j+16|0;z=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[z>>2]|0)>0){y=f[j+40>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[z>>2]|0))}z=f[j+44>>2]|0;if((z|0)!=(j+48|0))g0(z)}z=(f[a+116>>2]|0)+(Y(f[f[a+144>>2]>>2]|0,x)|0)|0;A=a+76|0;y=z+((Y(f[A>>2]|0,w)|0)<<2)|0;z=(f[a+172>>2]|0)+(Y(f[f[a+200>>2]>>2]|0,x)|0)+w|0;if(!(b[z>>0]|0)){b[z>>0]=1;B=y;C=A;D=f[m>>2]|0;E=f[c>>2]|0;break}else{F=y;u=e;return F|0}}else{B=d;C=a+76|0;D=o;E=l}while(0);l=f[a+80>>2]|0;o=f[a+84>>2]|0;d=f[a+88>>2]|0;c=E<<1;E=(f[a+228>>2]|0)+(Y(f[f[a+256>>2]>>2]|0,D)|0)+(c<<2)|0;m=(f[a+284>>2]|0)+(Y(f[f[a+312>>2]>>2]|0,D)|0)+c|0;XIc(B|0,0,f[C>>2]<<2|0)|0;C=f[a+4>>2]|0;if((l|0)>0){c=0;do{D=E+(f[C+(c*44|0)>>2]<<2)|0;G=+n[C+(c*44|0)+40>>2]*+n[C+(c*44|0)+24>>2];j=m+(f[C+(c*44|0)+4>>2]|0)|0;g=B+(f[C+(c*44|0)+8>>2]<<2)|0;i=g+(h[j>>0]<<2)|0;s=g+(h[j+1>>0]<<2)|0;H=+n[s>>2]+G*+n[D+4>>2];n[i>>2]=+n[i>>2]+G*+n[D>>2];n[s>>2]=H;c=c+1|0}while((c|0)!=(l|0));I=l}else I=0;if((I|0)<(o|0)){l=I;do{c=E+(f[C+(l*44|0)>>2]<<2)|0;H=+n[c>>2];G=+n[c+4>>2];c=m+(f[C+(l*44|0)+4>>2]|0)|0;s=h[c>>0]|0;D=h[c+1>>0]|0;c=B+(f[C+(l*44|0)+8>>2]<<2)|0;i=C+(l*44|0)+40|0;J=+n[i>>2]*+n[C+(l*44|0)+24>>2];j=c+(s<<2)|0;g=c+(D<<2)|0;K=+n[g>>2]+G*J;n[j>>2]=+n[j>>2]+H*J;n[g>>2]=K;g=B+(f[C+(l*44|0)+12>>2]<<2)|0;K=+n[i>>2]*+n[C+(l*44|0)+28>>2];i=g+(s<<2)|0;s=g+(D<<2)|0;J=+n[s>>2]+G*K;n[i>>2]=+n[i>>2]+H*K;n[s>>2]=J;l=l+1|0}while((l|0)!=(o|0));L=o}else L=I;if((L|0)<(d|0)){I=L;do{L=E+(f[C+(I*44|0)>>2]<<2)|0;J=+n[L>>2];K=+n[L+4>>2];L=m+(f[C+(I*44|0)+4>>2]|0)|0;o=h[L>>0]|0;l=h[L+1>>0]|0;L=B+(f[C+(I*44|0)+8>>2]<<2)|0;s=C+(I*44|0)+40|0;H=+n[s>>2]*+n[C+(I*44|0)+24>>2];i=L+(o<<2)|0;D=L+(l<<2)|0;G=+n[D>>2]+K*H;n[i>>2]=+n[i>>2]+J*H;n[D>>2]=G;D=B+(f[C+(I*44|0)+12>>2]<<2)|0;G=+n[s>>2]*+n[C+(I*44|0)+28>>2];i=D+(o<<2)|0;L=D+(l<<2)|0;H=+n[L>>2]+K*G;n[i>>2]=+n[i>>2]+J*G;n[L>>2]=H;L=B+(f[C+(I*44|0)+16>>2]<<2)|0;H=+n[s>>2]*+n[C+(I*44|0)+32>>2];i=L+(o<<2)|0;D=L+(l<<2)|0;G=+n[D>>2]+K*H;n[i>>2]=+n[i>>2]+J*H;n[D>>2]=G;D=B+(f[C+(I*44|0)+20>>2]<<2)|0;G=+n[s>>2]*+n[C+(I*44|0)+36>>2];s=D+(o<<2)|0;o=D+(l<<2)|0;H=+n[o>>2]+K*G;n[s>>2]=+n[s>>2]+J*G;n[o>>2]=H;I=I+1|0}while((I|0)!=(d|0))}mi[f[(f[a>>2]|0)+12>>2]&2047](a,B);F=B;u=e;return F|0}function tQb(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f[a>>2]=137796;m=a+8|0;f[m>>2]=1124007936;n=a+12|0;o=a+16|0;q=a+48|0;r=n;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;r=a+56|0;s=a+52|0;f[s>>2]=r;f[r>>2]=0;f[a+60>>2]=0;r=a+72|0;t=a+76|0;u=a+80|0;v=a+84|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[a+4>>2]=b;if((m|0)==(c|0)){w=a+64|0;p[w>>3]=d;x=f[e>>2]|0;f[r>>2]=x;y=e+4|0;z=f[y>>2]|0;f[t>>2]=z;A=f[g>>2]|0;f[u>>2]=A;B=g+4|0;C=f[B>>2]|0;f[v>>2]=C;D=a+88|0;f[D>>2]=h;E=a+92|0;f[E>>2]=i;F=a+96|0;f[F>>2]=k;G=a+100|0;f[G>>2]=l;H=a+104|0;f[H>>2]=j;return}b=c+36|0;I=f[b>>2]|0;if(I){J=I+12|0;f[J>>2]=(f[J>>2]|0)+1;J=a+44|0;I=f[J>>2]|0;if((I|0)!=0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0){_S(m);L=J}else L=J}else L=a+44|0;f[L>>2]=0;J=a+24|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[n>>2]|0)>0){I=f[q>>2]|0;q=0;do{f[I+(q<<2)>>2]=0;q=q+1|0;M=f[n>>2]|0}while((q|0)<(M|0));f[m>>2]=f[c>>2];if((M|0)<3)N=12;else N=14}else{f[m>>2]=f[c>>2];N=12}if((N|0)==12){M=f[c+4>>2]|0;if((M|0)<3){f[n>>2]=M;f[o>>2]=f[c+8>>2];f[a+20>>2]=f[c+12>>2];o=f[c+44>>2]|0;M=f[s>>2]|0;f[M>>2]=f[o>>2];f[M+4>>2]=f[o+4>>2]}else N=14}if((N|0)==14)ZS(m,c);f[J>>2]=f[c+16>>2];f[a+28>>2]=f[c+20>>2];f[a+32>>2]=f[c+24>>2];f[a+36>>2]=f[c+28>>2];f[a+40>>2]=f[c+32>>2];f[L>>2]=f[b>>2];w=a+64|0;p[w>>3]=d;x=f[e>>2]|0;f[r>>2]=x;y=e+4|0;z=f[y>>2]|0;f[t>>2]=z;A=f[g>>2]|0;f[u>>2]=A;B=g+4|0;C=f[B>>2]|0;f[v>>2]=C;D=a+88|0;f[D>>2]=h;E=a+92|0;f[E>>2]=i;F=a+96|0;f[F>>2]=k;G=a+100|0;f[G>>2]=l;H=a+104|0;f[H>>2]=j;return}function uQb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;a=u;u=u+96|0;h=a+16|0;i=a+72|0;j=a+8|0;k=a+60|0;l=a+48|0;m=a+32|0;n=a;if((e|0)<1){u=a;return}o=f[c>>2]|0;q=c+4|0;r=f[q>>2]|0;if((o|0)==(r|0)){u=a;return}s=d+4|0;if((r-o>>4|0)!=((f[s>>2]|0)-(f[d>>2]|0)>>3|0)){f[h>>2]=0;f[h+4>>2]=0;o=tT(h,33)|0;r=471222;t=o+33|0;do{b[o>>0]=b[r>>0]|0;o=o+1|0;r=r+1|0}while((o|0)<(t|0));z5(-215,h,471256,470838,3792)}f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;p[j>>3]=g;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];j=yOb(c,i,h)|0;f[h>>2]=0;o=h+4|0;f[o>>2]=0;f[h+8>>2]=0;t=(j|0)==0;do if(!t)if(j>>>0>134217727)mCc(h);else{v=j<<5;w=VDc(v)|0;f[h>>2]=w;f[h+8>>2]=w+(j<<5);XIc(w|0,0,v|0)|0;f[o>>2]=w+v;x=w;break}else x=0;while(0);f[k>>2]=0;w=k+4|0;f[w>>2]=0;f[k+8>>2]=0;if(t)y=0;else{v=j<<2;z=VDc(v)|0;f[k>>2]=z;A=z+(j<<2)|0;f[k+8>>2]=A;XIc(z|0,0,v|0)|0;f[w>>2]=A;y=z}f[l>>2]=0;z=l+4|0;f[z>>2]=0;f[l+8>>2]=0;if(t){B=0;C=0}else{t=VDc(j<<3)|0;f[z>>2]=t;f[l>>2]=t;A=t+(j<<3)|0;f[l+8>>2]=A;v=j;D=t;while(1){p[D>>3]=-1797693134862315708145274.0e284;v=v+-1|0;if(!v)break;else D=D+8|0}f[z>>2]=A;B=t;C=t}t=f[i>>2]|0;A=(f[r>>2]|0)-t|0;D=A>>2;v=t;if((A|0)>0){A=0;do{t=f[v+(A<<2)>>2]|0;E=f[c>>2]|0;F=x+(t<<5)|0;p[F>>3]=+(f[E+(A<<4)>>2]|0)+ +p[F>>3];F=x+(t<<5)+8|0;p[F>>3]=+(f[E+(A<<4)+4>>2]|0)+ +p[F>>3];F=x+(t<<5)+16|0;p[F>>3]=+(f[E+(A<<4)+8>>2]|0)+ +p[F>>3];F=x+(t<<5)+24|0;p[F>>3]=+(f[E+(A<<4)+12>>2]|0)+ +p[F>>3];F=C+(t<<3)|0;G=+p[F>>3];H=+p[(f[d>>2]|0)+(A<<3)>>3];p[F>>3]=G<H?H:G;F=y+(t<<2)|0;f[F>>2]=(f[F>>2]|0)+1;A=A+1|0}while((A|0)<(D|0))}D=(j|0)>0;if(D){A=0;do{v=x+(A<<5)|0;F=x+(A<<5)+8|0;t=x+(A<<5)+16|0;E=x+(A<<5)+24|0;G=1.0/+(f[y+(A<<2)>>2]|0);H=+p[F>>3]*G;I=+p[t>>3]*G;J=+p[E>>3]*G;p[v>>3]=+p[v>>3]*G;p[F>>3]=H;p[t>>3]=I;p[E>>3]=J;A=A+1|0}while((A|0)!=(j|0))}A=f[c>>2]|0;E=f[q>>2]|0;if((E|0)!=(A|0))f[q>>2]=E+(~((E+-16-A|0)>>>4)<<4);A=f[d>>2]|0;E=f[s>>2]|0;if((E|0)!=(A|0))f[s>>2]=E+(~((E+-8-A|0)>>>3)<<3);if(D){D=m+4|0;A=m+8|0;E=m+12|0;t=c+8|0;F=d+8|0;v=f[k>>2]|0;K=f[l>>2]|0;L=0;M=x;x=y;y=C;while(1){N=nrc(+p[M+(L<<5)>>3])|0;O=nrc(+p[M+(L<<5)+8>>3])|0;P=nrc(+p[M+(L<<5)+16>>3])|0;Q=nrc(+p[M+(L<<5)+24>>3])|0;f[m>>2]=N;f[D>>2]=O;f[A>>2]=P;f[E>>2]=Q;R=f[x+(L<<2)>>2]|0;p[n>>3]=+p[y+(L<<3)>>3];do if((R|0)>(e|0)){S=f[h>>2]|0;T=P+N|0;U=Q+O|0;V=(R|0)>3?R:3;a:do if((R|0)<3){W=0;while(1){do if((W|0)!=(L|0)?(f[x+(W<<2)>>2]|0)>(e|0):0){X=nrc(+p[S+(W<<5)>>3])|0;Y=nrc(+p[S+(W<<5)+8>>3])|0;Z=nrc(+p[S+(W<<5)+16>>3])|0;_=nrc(+p[S+(W<<5)+24>>3])|0;$=nrc(+(Z|0)*g)|0;aa=nrc(+(_|0)*g)|0;if((N|0)<(X-$|0)|(O|0)<(Y-aa|0))break;if((T|0)>(Z+X+$|0))break;if((U|0)<=(_+Y+aa|0)){ba=W;break a}}while(0);aa=W+1|0;if((aa|0)<(j|0))W=aa;else{ba=aa;break}}}else{W=0;while(1){aa=f[x+(W<<2)>>2]|0;do if((W|0)!=(L|0)&(aa|0)>(e|0)){Y=nrc(+p[S+(W<<5)>>3])|0;_=nrc(+p[S+(W<<5)+8>>3])|0;$=nrc(+p[S+(W<<5)+16>>3])|0;X=nrc(+p[S+(W<<5)+24>>3])|0;Z=nrc(+($|0)*g)|0;ca=nrc(+(X|0)*g)|0;if((N|0)<(Y-Z|0)|(O|0)<(_-ca|0))break;if((T|0)>($+Y+Z|0))break;if((aa|0)>(V|0)?(U|0)<=(X+_+ca|0):0){ba=W;break a}}while(0);aa=W+1|0;if((aa|0)<(j|0))W=aa;else{ba=aa;break}}}while(0);if((ba|0)==(j|0)){U=f[q>>2]|0;if((U|0)==(f[t>>2]|0))$Lb(c,m);else{f[U>>2]=N;f[U+4>>2]=O;f[U+8>>2]=P;f[U+12>>2]=Q;f[q>>2]=U+16}U=f[s>>2]|0;if((U|0)==(f[F>>2]|0)){zOb(d,n);break}else{p[U>>3]=+p[n>>3];f[s>>2]=U+8;break}}}while(0);Q=L+1|0;if((Q|0)>=(j|0))break;L=Q;M=f[h>>2]|0;x=v;y=K}K=f[l>>2]|0;da=K;ea=K}else{da=C;ea=B}if(da|0){B=f[z>>2]|0;if((B|0)!=(da|0))f[z>>2]=B+(~((B+-8-da|0)>>>3)<<3);YDc(ea)}ea=f[k>>2]|0;if(ea|0){k=f[w>>2]|0;if((k|0)!=(ea|0))f[w>>2]=k+(~((k+-4-ea|0)>>>2)<<2);YDc(ea)}ea=f[h>>2]|0;if(ea|0){h=f[o>>2]|0;if((h|0)!=(ea|0))f[o>>2]=h+(~((h+-32-ea|0)>>>5)<<5);YDc(ea)}ea=f[i>>2]|0;if(ea|0){i=f[r>>2]|0;if((i|0)!=(ea|0))f[r>>2]=i+(~((i+-4-ea|0)>>>2)<<2);YDc(ea)}u=a;return}function vQb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137796;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;g0(b);return}function wQb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=137796;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0)){YDc(a);return}g0(b);YDc(a);return}function xQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;c=u;u=u+272|0;d=c+248|0;e=c+192|0;g=c+176|0;h=c;i=c+112|0;j=c+168|0;k=c+56|0;l=c+48|0;m=c+32|0;n=c+24|0;o=c+16|0;q=c+8|0;r=f[b>>2]|0;s=f[b+4>>2]|0;do if((r|0)<=0)if((s|0)>1){t=+p[(f[a+88>>2]|0)+(r+1<<3)>>3];break}else{b=f[a+20>>2]|0;v=f[a+16>>2]|0;t=+(((b|0)<(v|0)?v:b)|0);break}else t=+p[(f[a+88>>2]|0)+(r<<3)>>3];while(0);b=a+8|0;v=a+20|0;w=+(f[v>>2]|0)/t;x=~~w;y=(+(x|0)<w&1)+x|0;x=a+16|0;w=+(f[x>>2]|0)/t;z=~~w;A=(+(z|0)<w&1)+z|0;z=f[b>>2]&4095;f[e>>2]=1124007936;B=e+4|0;C=e+8|0;D=e+40|0;E=B;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[D>>2]=C;C=e+48|0;E=e+44|0;f[E>>2]=C;f[C>>2]=0;f[e+52>>2]=0;f[d>>2]=A;f[d+4>>2]=y;XS(e,2,d,z);f[d>>2]=0;z=d+4|0;f[z>>2]=0;f[d+8>>2]=0;f[g>>2]=0;y=g+4|0;f[y>>2]=0;f[g+8>>2]=0;if((r|0)<(s|0)){A=a+88|0;F=j+4|0;G=e+16|0;H=a+48|0;I=l+4|0;J=a+24|0;K=a+56|0;L=k+36|0;M=i+36|0;N=i+16|0;O=i+4|0;P=i+40|0;Q=k+4|0;R=k+8|0;S=i+8|0;T=k+12|0;U=i+12|0;V=k+44|0;W=i+44|0;X=k+16|0;Y=k+20|0;Z=i+20|0;_=k+24|0;$=i+24|0;aa=k+28|0;ba=i+28|0;ca=k+32|0;da=i+32|0;ea=k+40|0;fa=k+48|0;ga=a+4|0;ha=a+64|0;ia=a+72|0;ja=o+4|0;ka=a+76|0;la=a+80|0;ma=q+4|0;na=a+84|0;oa=k+4|0;pa=k+8|0;qa=a+104|0;ra=a+96|0;sa=i+48|0;ta=a+92|0;ua=k+4|0;va=k+8|0;wa=k+12|0;xa=a+100|0;a=k+8|0;ya=k+12|0;za=k+4|0;Aa=m+8|0;Ba=m+4|0;Ca=n+4|0;Da=r;do{w=+p[(f[A>>2]|0)+(Da<<3)>>3];p[h>>3]=w;r=nrc(+(f[v>>2]|0)/w)|0;Ea=nrc(+(f[x>>2]|0)/w)|0;f[j>>2]=r;f[F>>2]=Ea;CY(i,j,f[b>>2]&4095,f[G>>2]|0,0);Fa=f[H>>2]|0;if((Ea|0)==(f[Fa>>2]|0)?(r|0)==(f[Fa+4>>2]|0):0){f[l>>2]=r;f[I>>2]=Ea;CY(k,l,f[b>>2]&4095,f[J>>2]|0,f[K>>2]|0);Fa=f[L>>2]|0;if(Fa|0){Ga=Fa+12|0;f[Ga>>2]=(f[Ga>>2]|0)+1}Ga=f[M>>2]|0;if(Ga|0?(Fa=Ga+12|0,Ga=f[Fa>>2]|0,f[Fa>>2]=Ga+-1,(Ga|0)==1):0)_S(i);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[O>>2]|0)>0){Ga=f[P>>2]|0;Fa=0;do{f[Ga+(Fa<<2)>>2]=0;Fa=Fa+1|0;Ha=f[O>>2]|0}while((Fa|0)<(Ha|0));f[i>>2]=f[k>>2];if((Ha|0)<3)Ia=19;else Ia=21}else{f[i>>2]=f[k>>2];Ia=19}if((Ia|0)==19){Ia=0;Fa=f[Q>>2]|0;if((Fa|0)<3){f[O>>2]=Fa;f[S>>2]=f[R>>2];f[U>>2]=f[T>>2];Fa=f[V>>2]|0;Ga=f[W>>2]|0;f[Ga>>2]=f[Fa>>2];f[Ga+4>>2]=f[Fa+4>>2]}else Ia=21}if((Ia|0)==21){Ia=0;ZS(i,k)}f[N>>2]=f[X>>2];f[Z>>2]=f[Y>>2];f[$>>2]=f[_>>2];f[ba>>2]=f[aa>>2];f[da>>2]=f[ca>>2];Fa=f[L>>2]|0;f[M>>2]=Fa;if(Fa|0?(Ga=Fa+12|0,Fa=f[Ga>>2]|0,f[Ga>>2]=Fa+-1,(Fa|0)==1):0)_S(k);f[L>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Q>>2]|0)>0){Fa=f[ea>>2]|0;Ga=0;do{f[Fa+(Ga<<2)>>2]=0;Ga=Ga+1|0}while((Ga|0)<(f[Q>>2]|0))}Ga=f[V>>2]|0;if((Ga|0)!=(fa|0))g0(Ga)}else{f[a>>2]=0;f[ya>>2]=0;f[k>>2]=16842752;f[za>>2]=b;Ga=Aa;f[Ga>>2]=0;f[Ga+4>>2]=0;f[m>>2]=33619968;f[Ba>>2]=i;f[n>>2]=r;f[Ca>>2]=Ea;nfa(k,m,n,0.0,0.0,5)}Ga=f[ga>>2]|0;Fa=f[(f[Ga>>2]|0)+36>>2]|0;w=+p[ha>>3];f[o>>2]=f[ia>>2];f[ja>>2]=f[ka>>2];f[q>>2]=f[la>>2];f[ma>>2]=f[na>>2];f[k>>2]=0;f[oa>>2]=0;f[pa>>2]=0;tg[Fa&7](Ga,i,d,g,w,o,q,k);Ga=f[k>>2]|0;if(Ga|0){Fa=f[oa>>2]|0;if((Fa|0)!=(Ga|0))f[oa>>2]=Fa+(~((Fa+-8-Ga|0)>>>3)<<3);YDc(Ga)}Ga=f[ga>>2]|0;w=+p[h>>3];Fa=nrc(+(f[Ga+4>>2]|0)*w)|0;Ja=nrc(w*+(f[Ga+8>>2]|0))|0;m6(f[qa>>2]|0);Ga=f[d>>2]|0;if((f[z>>2]|0)!=(Ga|0)){Ka=0;La=Ga;do{Ga=La;Ma=f[ta>>2]|0;w=+p[h>>3];Na=nrc(+(f[Ga+(Ka<<3)>>2]|0)*w)|0;Oa=nrc(w*+(f[Ga+(Ka<<3)+4>>2]|0))|0;f[k>>2]=Na;f[ua>>2]=Oa;f[va>>2]=Fa;f[wa>>2]=Ja;Ga=Ma+4|0;Pa=f[Ga>>2]|0;if((Pa|0)==(f[Ma+8>>2]|0))$Lb(Ma,k);else{f[Pa>>2]=Na;f[Pa+4>>2]=Oa;f[Pa+8>>2]=Fa;f[Pa+12>>2]=Ja;f[Ga>>2]=Pa+16}Pa=f[xa>>2]|0;do if(Pa|0){Ga=Pa+4|0;Oa=f[Ga>>2]|0;if((Oa|0)==(f[Pa+8>>2]|0)){zOb(Pa,h);break}else{p[Oa>>3]=+p[h>>3];f[Ga>>2]=Oa+8;break}}while(0);Ka=Ka+1|0;La=f[d>>2]|0}while(Ka>>>0<(f[z>>2]|0)-La>>3>>>0)}n6(f[qa>>2]|0);if(f[ra>>2]|0?(f[g>>2]|0)!=(f[y>>2]|0):0){m6(f[qa>>2]|0);La=f[z>>2]|0;Ka=f[d>>2]|0;if((La|0)!=(Ka|0)){Ja=0;Fa=Ka;Ka=La;while(1){La=f[ra>>2]|0;Ea=(f[g>>2]|0)+(Ja<<3)|0;r=La+4|0;Pa=f[r>>2]|0;if((Pa|0)==(f[La+8>>2]|0)){zOb(La,Ea);Qa=f[d>>2]|0;Ra=f[z>>2]|0}else{p[Pa>>3]=+p[Ea>>3];f[r>>2]=Pa+8;Qa=Fa;Ra=Ka}Ja=Ja+1|0;if(Ja>>>0>=Ra-Qa>>3>>>0)break;else{Fa=Qa;Ka=Ra}}}n6(f[qa>>2]|0)}Ka=f[M>>2]|0;if(Ka|0?(Fa=Ka+12|0,Ka=f[Fa>>2]|0,f[Fa>>2]=Ka+-1,(Ka|0)==1):0)_S(i);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[O>>2]|0)>0){Ka=f[P>>2]|0;Fa=0;do{f[Ka+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[O>>2]|0))}Fa=f[W>>2]|0;if((Fa|0)!=(sa|0))g0(Fa);Da=Da+1|0}while((Da|0)<(s|0));s=f[g>>2]|0;if(s|0){g=f[y>>2]|0;if((g|0)!=(s|0))f[y>>2]=g+(~((g+-8-s|0)>>>3)<<3);YDc(s)}}s=f[d>>2]|0;if(s|0){d=f[z>>2]|0;if((d|0)!=(s|0))f[z>>2]=d+(~((d+-8-s|0)>>>3)<<3);YDc(s)}s=e+36|0;d=f[s>>2]|0;if(d|0?(z=d+12|0,d=f[z>>2]|0,f[z>>2]=d+-1,(d|0)==1):0)_S(e);f[s>>2]=0;s=e+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[B>>2]|0)>0){s=f[D>>2]|0;D=0;do{f[s+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[E>>2]|0;if((B|0)==(C|0)){u=c;return}g0(B);u=c;return}function yQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;if(!(_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0)){u=d;return a|0}h=a+32|0;if((f[h>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,30)|0;j=471427;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-2,e,518366,471458,1188)}f[g>>2]=0;f[g+4>>2]=0;T_(e,a,a+12|0,13,g);uT(g);S_(a,f[c>>2]|0);S_(a,f[c+4>>2]|0);U_(e);if(!(f[h>>2]&4)){u=d;return a|0}f[h>>2]=6;u=d;return a|0}function zQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d+8|0;g=d;b[e>>0]=49;b[e+1>>0]=102;b[e+2>>0]=0;h=f[a>>2]|0;f[g>>2]=0;f[g+4>>2]=0;a=Mpc(e)|0;if(a|0)dJc(tT(g,a)|0,e|0,a|0)|0;a=f[c>>2]|0;e=f[c+4>>2]|0;F_(h,g,(a|0)==(e|0)?0:a,e-a|0);uT(g);u=d;return}function AQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e+8|0;h=e;i=f[a>>2]|0;j=f[i+40>>2]|0;b[g>>0]=49;b[g+1>>0]=102;b[g+2>>0]=0;k=j>>>0>d>>>0?d:j;j=c+4|0;d=f[j>>2]|0;l=f[c>>2]|0;m=d-l>>2;n=l;l=d;if(k>>>0<=m>>>0)if(k>>>0<m>>>0?(d=n+(k<<2)|0,(l|0)!=(d|0)):0){f[j>>2]=l+(~((l+-4-d|0)>>>2)<<2);o=i}else o=i;else{fqb(c,k-m|0);o=f[a>>2]|0}f[h>>2]=0;f[h+4>>2]=0;a=Mpc(g)|0;if(!a){p=f[c>>2]|0;q=f[j>>2]|0;r=(p|0)==(q|0);s=r?0:p;t=k<<2;O_(o,h,s,t)|0;uT(h);u=e;return}dJc(tT(h,a)|0,g|0,a|0)|0;p=f[c>>2]|0;q=f[j>>2]|0;r=(p|0)==(q|0);s=r?0:p;t=k<<2;O_(o,h,s,t)|0;uT(h);u=e;return}function BQb(){s5(883212,471746,959,1772,545,280,960);be(1715,883212,x|0)|0;return}function CQb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;if(b[527160]|0){c=f[34452]|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d|0)==(e|0);h=g&1;return h|0}if(!(MIc(527160)|0)){c=f[34452]|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d|0)==(e|0);h=g&1;return h|0}f[131792]=137704;f[131793]=64;f[131794]=128;f[131795]=16;f[131796]=16;f[131797]=8;f[131798]=8;f[131799]=8;f[131800]=8;f[131801]=9;f[131802]=1;p[65902]=-1.0;f[131806]=0;p[65904]=.2;b[527240]=1;f[131811]=0;f[131812]=0;f[131813]=0;f[131814]=1124007936;f[131815]=0;f[131816]=0;f[131817]=0;f[131818]=0;f[131819]=0;f[131820]=0;f[131821]=0;f[131822]=527264;f[131823]=527296;f[131825]=0;f[131824]=0;n[131826]=-1.0;f[131827]=64;b[527312]=0;be(1385,527168,x|0)|0;c=f[34452]|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d|0)==(e|0);h=g&1;return h|0}function DQb(a){a=a|0;var b=0;if(!a)return;b=f[a>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&2047](b);f[a>>2]=0;return}function EQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=c;c=VDc(152)|0;f[c>>2]=137704;f[c+4>>2]=64;f[c+8>>2]=128;f[c+12>>2]=16;f[c+16>>2]=16;f[c+20>>2]=8;f[c+24>>2]=8;f[c+28>>2]=8;f[c+32>>2]=8;f[c+36>>2]=9;f[c+40>>2]=1;p[c+48>>3]=-1.0;f[c+56>>2]=0;p[c+64>>3]=.2;b[c+72>>0]=1;f[c+76>>2]=0;f[c+80>>2]=0;f[c+84>>2]=0;f[c+88>>2]=1124007936;a=c+92|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[c+120>>2]=c+96;a=c+128|0;f[c+124>>2]=a;f[c+132>>2]=0;f[a>>2]=0;n[c+136>>2]=-1.0;f[c+140>>2]=64;b[c+144>>0]=0;if($Pb(c,e)|0){g=c;u=d;return g|0}Yi[f[(f[c>>2]|0)+4>>2]&2047](c);g=0;u=d;return g|0}function FQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;d=u;u=u+48|0;e=d+8|0;g=d;if(!((a|0)!=0&(c|0)!=0)){u=d;return}C_(e,a,0);a=f[(f[c>>2]|0)+16>>2]|0;f[g>>2]=0;f[g+4>>2]=0;if(b|0?(h=Mpc(b)|0,h|0):0)dJc(tT(g,h)|0,b|0,h|0)|0;Ti[a&511](c,e,g);uT(g);t_(e);u=d;return}function GQb(a){a=a|0;var b=0,c=0,d=0;if(!a){b=0;return b|0}c=VDc(152)|0;f[c>>2]=137704;d=c+4|0;f[c+76>>2]=0;f[c+80>>2]=0;f[c+84>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[c+88>>2]=1124007936;d=c+92|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+120>>2]=c+96;d=c+128|0;f[c+124>>2]=d;f[c+132>>2]=0;f[d>>2]=0;mi[f[(f[a>>2]|0)+28>>2]&2047](a,c);b=c;return b|0}function HQb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;c=VDc(15124)|0;f[b>>2]=c;f[a>>2]=c;d=c+15124|0;f[a+8>>2]=d;a=137812;e=c;while(1){f[e>>2]=f[a>>2];a=a+4|0;if((a|0)==152936)break;else e=e+4|0}f[b>>2]=d;return}function IQb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;c=VDc(7924)|0;f[b>>2]=c;f[a>>2]=c;d=c+7924|0;f[a+8>>2]=d;a=152936;e=c;while(1){f[e>>2]=f[a>>2];a=a+4|0;if((a|0)==160860)break;else e=e+4|0}f[b>>2]=d;return}function JQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e;if(!c)h=f[a+24>>2]|0;else{i=f[c+16>>2]<<1;c=f[a+28>>2]|0;h=c>>>0<i>>>0?c:i}if(d>>>0>4294967271){rTb(g,3,471773,116);oTb(e+24|0,mTb(g,471857)|0);sTb(g)}g=d+24|0;d=h>>>0<g>>>0?g:h;h=_i[f[a+40>>2]&1023](d)|0;f[h+12>>2]=24;f[h+16>>2]=d;f[h>>2]=b;f[h+8>>2]=0;b=a+8|0;f[b>>2]=(f[b>>2]|0)+d;u=e;return h|0}function KQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;a:do if(!c){e=f[a>>2]|0;b:do if(e|0){g=e;while(1){if((f[g>>2]|0)==(b|0))break;h=f[g+12>>2]|0;if(!h)break b;else g=h}if(g|0){i=g;break a}}while(0);e=JQb(a,b,0,d+16|0)|0;h=e+12|0;j=f[h>>2]|0;f[h>>2]=j+16;h=e+j|0;f[e+4>>2]=h;f[h>>2]=f[e>>2];f[h+4>>2]=e;f[h+8>>2]=0;e=h+12|0;j=h;do{k=f[a>>2]|0;f[e>>2]=k;l=f[a>>2]|0;if((l|0)==(k|0))f[a>>2]=j}while((((l|0)==(k|0)?k:l)|0)!=(k|0));i=h}else i=f[c+4>>2]|0;while(0);c=i+4|0;j=f[c>>2]|0;if(((f[j+16>>2]|0)-(f[j+12>>2]|0)|0)>>>0>=d>>>0){m=j;f[5028]=m;n=a+16|0;o=n;p=o;q=f[p>>2]|0;r=o+4|0;s=r;t=f[s>>2]|0;u=20104;v=u;f[v>>2]=q;w=u+4|0;x=w;f[x>>2]=t;y=a+4|0;z=m;f[y>>2]=z;return m|0}e=JQb(a,b,j,d)|0;f[e+4>>2]=i;f[e+8>>2]=j;f[c>>2]=e;m=e;f[5028]=m;n=a+16|0;o=n;p=o;q=f[p>>2]|0;r=o+4|0;s=r;t=f[s>>2]|0;u=20104;v=u;f[v>>2]=q;w=u+4|0;x=w;f[x>>2]=t;y=a+4|0;z=m;f[y>>2]=z;return m|0}function LQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=20104;e=a+16|0;g=e;do if((f[d>>2]|0)==(f[g>>2]|0)?(f[d+4>>2]|0)==(f[g+4>>2]|0):0)h=f[5028]|0;else{i=f[a+4>>2]|0;j=i;if(i|0?(f[j>>2]|0)==20104:0){h=j;break}h=KQb(a,20104,0,0)|0}while(0);g=f[(f[h+4>>2]|0)+8>>2]|0;do if(g){d=f[g>>2]|0;if((d|0)==(f[g+4>>2]|0)){k=d<<1;break}else{l=g;m=d;n=m+1|0;f[l>>2]=n;o=l+12+(m<<3)|0;f[o>>2]=b;p=l+12+(m<<3)+4|0;f[p>>2]=c;return}}else k=8;while(0);g=k>>>0<64?k:64;k=(g<<3|12)+7&2032;d=f[h+12>>2]|0;do if(((f[h+16>>2]|0)-d|0)>>>0<k>>>0){j=20104;i=e;if((f[j>>2]|0)==(f[i>>2]|0)?(f[j+4>>2]|0)==(f[i+4>>2]|0):0){i=f[5028]|0;j=f[i+12>>2]|0;if(((f[i+16>>2]|0)-j|0)>>>0<k>>>0)q=i;else{r=i;s=j;break}}else q=0;j=f[a+4>>2]|0;i=j;if((j|0)!=0?(f[i>>2]|0)==20104:0){j=f[i+12>>2]|0;if(((f[i+16>>2]|0)-j|0)>>>0<k>>>0)t=i;else{r=i;s=j;break}}else t=q;j=KQb(a,20104,t,k)|0;r=j;s=f[j+12>>2]|0}else{r=h;s=d}while(0);f[r+12>>2]=s+k;k=r+s|0;s=r+4|0;f[k+8>>2]=f[(f[s>>2]|0)+8>>2];f[k+4>>2]=g;f[k>>2]=0;f[(f[s>>2]|0)+8>>2]=k;l=k;m=0;n=m+1|0;f[l>>2]=n;o=l+12+(m<<3)|0;f[o>>2]=b;p=l+12+(m<<3)+4|0;f[p>>2]=c;return}function MQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=20104;d=a+16|0;if((f[c>>2]|0)==(f[d>>2]|0)?(f[c+4>>2]|0)==(f[d+4>>2]|0):0){d=f[5028]|0;c=f[d+12>>2]|0;if(((f[d+16>>2]|0)-c|0)>>>0<b>>>0){e=d;g=3}else{h=d;i=c}}else{e=0;g=3}do if((g|0)==3){c=f[a+4>>2]|0;d=c;if((c|0)!=0?(f[d>>2]|0)==20104:0){c=f[d+12>>2]|0;if(((f[d+16>>2]|0)-c|0)>>>0<b>>>0)j=d;else{h=d;i=c;break}}else j=e;c=KQb(a,20104,j,b)|0;h=c;i=f[c+12>>2]|0}while(0);f[h+12>>2]=i+b;return h+i|0}function NQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=20104;e=a+16|0;g=e;if((f[d>>2]|0)==(f[g>>2]|0)?(f[d+4>>2]|0)==(f[g+4>>2]|0):0){g=f[5028]|0;d=f[g+12>>2]|0;if(((f[g+16>>2]|0)-d|0)>>>0<b>>>0){h=g;i=3}else{j=g;k=d}}else{h=0;i=3}do if((i|0)==3){d=f[a+4>>2]|0;g=d;if((d|0)!=0?(f[g>>2]|0)==20104:0){d=f[g+12>>2]|0;if(((f[g+16>>2]|0)-d|0)>>>0<b>>>0)l=g;else{j=g;k=d;break}}else l=h;d=KQb(a,20104,l,b)|0;j=d;k=f[d+12>>2]|0}while(0);l=k+b|0;f[j+12>>2]=l;b=j+k|0;k=f[(f[j+4>>2]|0)+8>>2]|0;do if(k){h=f[k>>2]|0;if((h|0)==(f[k+4>>2]|0)){m=h<<1;break}else{n=k;o=h;p=o+1|0;f[n>>2]=p;q=n+12+(o<<3)|0;f[q>>2]=b;r=n+12+(o<<3)+4|0;f[r>>2]=c;return b|0}}else m=8;while(0);k=m>>>0<64?m:64;m=(k<<3|12)+7&2032;do if(((f[j+16>>2]|0)-l|0)>>>0<m>>>0){h=20104;i=e;if((f[h>>2]|0)==(f[i>>2]|0)?(f[h+4>>2]|0)==(f[i+4>>2]|0):0){i=f[5028]|0;h=f[i+12>>2]|0;if(((f[i+16>>2]|0)-h|0)>>>0<m>>>0)s=i;else{t=i;u=h;break}}else s=0;h=f[a+4>>2]|0;i=h;if((h|0)!=0?(f[i>>2]|0)==20104:0){h=f[i+12>>2]|0;if(((f[i+16>>2]|0)-h|0)>>>0<m>>>0)v=i;else{t=i;u=h;break}}else v=s;h=KQb(a,20104,v,m)|0;t=h;u=f[h+12>>2]|0}else{t=j;u=l}while(0);f[t+12>>2]=u+m;m=t+u|0;u=t+4|0;f[m+8>>2]=f[(f[u>>2]|0)+8>>2];f[m+4>>2]=k;f[m>>2]=0;f[(f[u>>2]|0)+8>>2]=m;n=m;o=0;p=o+1|0;f[n>>2]=p;q=n+12+(o<<3)|0;f[q>>2]=b;r=n+12+(o<<3)+4|0;f[r>>2]=c;return b|0}function OQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a+52>>2]|0;if(!d)return;ei[d&511](b,c,0,f[a+64>>2]|0);return}function PQb(){if((b[527331]|0)>=0)return;YDc(f[131830]|0);return}function QQb(){f[131830]=0;f[131831]=0;f[131832]=0;iTb(124);return}function RQb(a){a=a|0;var c=0,d=0,e=0;c=(b[a+11>>0]|0)<0;d=f[a>>2]|0;if(a>>>0>(c?d:a)>>>0){if(!c){e=10;return e|0}}else{if(!c){e=0;return e|0}if(d>>>0<(a+12|0)>>>0){e=0;return e|0}}e=(f[a+8>>2]&2147483647)+-1|0;return e|0}function SQb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220804]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=125;b[c+8>>0]=0;DTb(883216,c);ZSb(c);u=a;return}function TQb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;if((d|0)<=0)return;g=e+8|0;h=e+4|0;i=0;do{j=c+(i*20|0)|0;k=f[j>>2]|0;l=a+k|0;m=f[c+(i*20|0)+12>>2]|0;a:do switch(m|0){case 0:{o=f[c+(i*20|0)+8>>2]|0;if(1<<(o&31)&f[a+(o>>>5<<2)>>2]|0){o=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){q=f[h>>2]|0;if(o>>>0>127){r=o;s=q;while(1){b[s>>0]=r|128;t=r>>>7;u=s+1|0;if(r>>>0>16383){r=t;s=u}else{v=u;w=t;break}}}else{v=q;w=o}b[v>>0]=w;s=v+1-q|0;f[h>>2]=(f[h>>2]|0)+s;f[g>>2]=(f[g>>2]|0)-s}else bSb(e,o);s=l;aSb(e,f[s>>2]|0,f[s+4>>2]|0)}break}case 20:{if(!(+p[l>>3]==0.0)){s=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){r=f[h>>2]|0;if(s>>>0>127){t=s;u=r;while(1){b[u>>0]=t|128;x=t>>>7;y=u+1|0;if(t>>>0>16383){t=x;u=y}else{z=y;A=x;break}}}else{z=r;A=s}b[z>>0]=A;u=z+1-r|0;f[h>>2]=(f[h>>2]|0)+u;f[g>>2]=(f[g>>2]|0)-u}else bSb(e,s);u=l;aSb(e,f[u>>2]|0,f[u+4>>2]|0)}break}case 40:{if((f[l>>2]|0)>0){u=c+(i*20|0)+4|0;t=l+8|0;o=0;do{q=f[u>>2]|0;if((f[g>>2]|0)>4){x=f[h>>2]|0;if(q>>>0>127){y=q;B=x;while(1){b[B>>0]=y|128;C=y>>>7;D=B+1|0;if(y>>>0>16383){y=C;B=D}else{E=D;F=C;break}}}else{E=x;F=q}b[E>>0]=F;B=E+1-x|0;f[h>>2]=(f[h>>2]|0)+B;f[g>>2]=(f[g>>2]|0)-B}else bSb(e,q);B=(f[t>>2]|0)+8+(o<<3)|0;aSb(e,f[B>>2]|0,f[B+4>>2]|0);o=o+1|0}while((o|0)<(f[l>>2]|0))}break}case 60:{UQb(l,j,e);break}case 80:{o=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(o>>>3|0)){if((f[g>>2]|0)>4){t=f[h>>2]|0;if(o>>>0>127){u=o;s=t;while(1){b[s>>0]=u|128;r=u>>>7;B=s+1|0;if(u>>>0>16383){u=r;s=B}else{G=B;H=r;break}}}else{G=t;H=o}b[G>>0]=H;s=G+1-t|0;f[h>>2]=(f[h>>2]|0)+s;f[g>>2]=(f[g>>2]|0)-s}else bSb(e,o);s=l;aSb(e,f[s>>2]|0,f[s+4>>2]|0)}break}case 1:{s=f[c+(i*20|0)+8>>2]|0;if(1<<(s&31)&f[a+(s>>>5<<2)>>2]|0){s=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){u=f[h>>2]|0;if(s>>>0>127){r=s;B=u;while(1){b[B>>0]=r|128;y=r>>>7;C=B+1|0;if(r>>>0>16383){r=y;B=C}else{I=C;J=y;break}}}else{I=u;J=s}b[I>>0]=J;B=I+1-u|0;f[h>>2]=(f[h>>2]|0)+B;f[g>>2]=(f[g>>2]|0)-B}else bSb(e,s);$Rb(e,f[l>>2]|0)}break}case 21:{if(!(+n[l>>2]==0.0)){B=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){r=f[h>>2]|0;if(B>>>0>127){o=B;t=r;while(1){b[t>>0]=o|128;y=o>>>7;C=t+1|0;if(o>>>0>16383){o=y;t=C}else{K=C;L=y;break}}}else{K=r;L=B}b[K>>0]=L;t=K+1-r|0;f[h>>2]=(f[h>>2]|0)+t;f[g>>2]=(f[g>>2]|0)-t}else bSb(e,B);$Rb(e,f[l>>2]|0)}break}case 41:{if((f[l>>2]|0)>0){t=c+(i*20|0)+4|0;o=l+8|0;s=0;do{u=f[t>>2]|0;if((f[g>>2]|0)>4){y=f[h>>2]|0;if(u>>>0>127){C=u;D=y;while(1){b[D>>0]=C|128;M=C>>>7;N=D+1|0;if(C>>>0>16383){C=M;D=N}else{O=N;P=M;break}}}else{O=y;P=u}b[O>>0]=P;D=O+1-y|0;f[h>>2]=(f[h>>2]|0)+D;f[g>>2]=(f[g>>2]|0)-D}else bSb(e,u);$Rb(e,f[(f[o>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[l>>2]|0))}break}case 61:{VQb(l,j,e);break}case 81:{s=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(s>>>3|0)){if((f[g>>2]|0)>4){o=f[h>>2]|0;if(s>>>0>127){t=s;B=o;while(1){b[B>>0]=t|128;r=t>>>7;D=B+1|0;if(t>>>0>16383){t=r;B=D}else{Q=D;R=r;break}}}else{Q=o;R=s}b[Q>>0]=R;B=Q+1-o|0;f[h>>2]=(f[h>>2]|0)+B;f[g>>2]=(f[g>>2]|0)-B}else bSb(e,s);$Rb(e,f[l>>2]|0)}break}case 2:{B=f[c+(i*20|0)+8>>2]|0;if(1<<(B&31)&f[a+(B>>>5<<2)>>2]|0)WQb(l,j,e);break}case 22:{B=l;if(!((f[B>>2]|0)==0&(f[B+4>>2]|0)==0))WQb(l,j,e);break}case 42:{XQb(l,j,e);break}case 62:{YQb(l,j,e);break}case 82:{if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==((f[c+(i*20|0)+4>>2]|0)>>>3|0))WQb(l,j,e);break}case 3:{B=f[c+(i*20|0)+8>>2]|0;if(1<<(B&31)&f[a+(B>>>5<<2)>>2]|0)ZQb(l,j,e);break}case 23:{B=l;if(!((f[B>>2]|0)==0&(f[B+4>>2]|0)==0))ZQb(l,j,e);break}case 43:{_Qb(l,j,e);break}case 63:{$Qb(l,j,e);break}case 83:{if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==((f[c+(i*20|0)+4>>2]|0)>>>3|0))ZQb(l,j,e);break}case 4:{B=f[c+(i*20|0)+8>>2]|0;if(1<<(B&31)&f[a+(B>>>5<<2)>>2]|0)aRb(l,j,e);break}case 24:{if(f[l>>2]|0)aRb(l,j,e);break}case 44:{bRb(l,j,e);break}case 64:{cRb(l,j,e);break}case 84:{if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==((f[c+(i*20|0)+4>>2]|0)>>>3|0))aRb(l,j,e);break}case 5:{B=f[c+(i*20|0)+8>>2]|0;if(1<<(B&31)&f[a+(B>>>5<<2)>>2]|0){B=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){t=f[h>>2]|0;if(B>>>0>127){r=B;D=t;while(1){b[D>>0]=r|128;C=r>>>7;q=D+1|0;if(r>>>0>16383){r=C;D=q}else{S=q;T=C;break}}}else{S=t;T=B}b[S>>0]=T;D=S+1-t|0;f[h>>2]=(f[h>>2]|0)+D;f[g>>2]=(f[g>>2]|0)-D}else bSb(e,B);D=l;aSb(e,f[D>>2]|0,f[D+4>>2]|0)}break}case 25:{D=l;if(!((f[D>>2]|0)==0&(f[D+4>>2]|0)==0)){D=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){r=f[h>>2]|0;if(D>>>0>127){s=D;o=r;while(1){b[o>>0]=s|128;C=s>>>7;q=o+1|0;if(s>>>0>16383){s=C;o=q}else{U=q;V=C;break}}}else{U=r;V=D}b[U>>0]=V;o=U+1-r|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else bSb(e,D);o=l;aSb(e,f[o>>2]|0,f[o+4>>2]|0)}break}case 45:{if((f[l>>2]|0)>0){o=c+(i*20|0)+4|0;s=l+8|0;B=0;do{t=f[o>>2]|0;if((f[g>>2]|0)>4){C=f[h>>2]|0;if(t>>>0>127){q=t;x=C;while(1){b[x>>0]=q|128;M=q>>>7;N=x+1|0;if(q>>>0>16383){q=M;x=N}else{W=N;X=M;break}}}else{W=C;X=t}b[W>>0]=X;x=W+1-C|0;f[h>>2]=(f[h>>2]|0)+x;f[g>>2]=(f[g>>2]|0)-x}else bSb(e,t);x=(f[s>>2]|0)+8+(B<<3)|0;aSb(e,f[x>>2]|0,f[x+4>>2]|0);B=B+1|0}while((B|0)<(f[l>>2]|0))}break}case 65:{dRb(l,j,e);break}case 85:{B=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(B>>>3|0)){if((f[g>>2]|0)>4){s=f[h>>2]|0;if(B>>>0>127){o=B;D=s;while(1){b[D>>0]=o|128;r=o>>>7;x=D+1|0;if(o>>>0>16383){o=r;D=x}else{Y=x;Z=r;break}}}else{Y=s;Z=B}b[Y>>0]=Z;D=Y+1-s|0;f[h>>2]=(f[h>>2]|0)+D;f[g>>2]=(f[g>>2]|0)-D}else bSb(e,B);D=l;aSb(e,f[D>>2]|0,f[D+4>>2]|0)}break}case 6:{D=f[c+(i*20|0)+8>>2]|0;if(1<<(D&31)&f[a+(D>>>5<<2)>>2]|0){D=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){o=f[h>>2]|0;if(D>>>0>127){r=D;x=o;while(1){b[x>>0]=r|128;q=r>>>7;u=x+1|0;if(r>>>0>16383){r=q;x=u}else{_=u;$=q;break}}}else{_=o;$=D}b[_>>0]=$;x=_+1-o|0;f[h>>2]=(f[h>>2]|0)+x;f[g>>2]=(f[g>>2]|0)-x}else bSb(e,D);$Rb(e,f[l>>2]|0)}break}case 26:{if(f[l>>2]|0){x=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){r=f[h>>2]|0;if(x>>>0>127){B=x;s=r;while(1){b[s>>0]=B|128;q=B>>>7;u=s+1|0;if(B>>>0>16383){B=q;s=u}else{aa=u;ba=q;break}}}else{aa=r;ba=x}b[aa>>0]=ba;s=aa+1-r|0;f[h>>2]=(f[h>>2]|0)+s;f[g>>2]=(f[g>>2]|0)-s}else bSb(e,x);$Rb(e,f[l>>2]|0)}break}case 46:{if((f[l>>2]|0)>0){s=c+(i*20|0)+4|0;B=l+8|0;D=0;do{o=f[s>>2]|0;if((f[g>>2]|0)>4){q=f[h>>2]|0;if(o>>>0>127){u=o;y=q;while(1){b[y>>0]=u|128;M=u>>>7;N=y+1|0;if(u>>>0>16383){u=M;y=N}else{ca=N;da=M;break}}}else{ca=q;da=o}b[ca>>0]=da;y=ca+1-q|0;f[h>>2]=(f[h>>2]|0)+y;f[g>>2]=(f[g>>2]|0)-y}else bSb(e,o);$Rb(e,f[(f[B>>2]|0)+4+(D<<2)>>2]|0);D=D+1|0}while((D|0)<(f[l>>2]|0))}break}case 66:{eRb(l,j,e);break}case 86:{D=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(D>>>3|0)){if((f[g>>2]|0)>4){B=f[h>>2]|0;if(D>>>0>127){s=D;x=B;while(1){b[x>>0]=s|128;r=s>>>7;y=x+1|0;if(s>>>0>16383){s=r;x=y}else{ea=y;fa=r;break}}}else{ea=B;fa=D}b[ea>>0]=fa;x=ea+1-B|0;f[h>>2]=(f[h>>2]|0)+x;f[g>>2]=(f[g>>2]|0)-x}else bSb(e,D);$Rb(e,f[l>>2]|0)}break}case 7:{x=f[c+(i*20|0)+8>>2]|0;if(1<<(x&31)&f[a+(x>>>5<<2)>>2]|0){x=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){s=f[h>>2]|0;if(x>>>0>127){r=x;y=s;while(1){b[y>>0]=r|128;u=r>>>7;t=y+1|0;if(r>>>0>16383){r=u;y=t}else{ga=t;ha=u;break}}}else{ga=s;ha=x}b[ga>>0]=ha;y=ga+1-s|0;f[h>>2]=(f[h>>2]|0)+y;r=(f[g>>2]|0)-y|0;f[g>>2]=r;ia=r}else{bSb(e,x);ia=f[g>>2]|0}r=b[l>>0]|0;if((ia|0)>4){b[f[h>>2]>>0]=r;f[h>>2]=(f[h>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1;break a}else{bSb(e,r&255);break a}}break}case 27:{if(b[l>>0]|0){r=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){y=f[h>>2]|0;if(r>>>0>127){D=r;B=y;while(1){b[B>>0]=D|128;u=D>>>7;t=B+1|0;if(D>>>0>16383){D=u;B=t}else{ja=t;ka=u;break}}}else{ja=y;ka=r}b[ja>>0]=ka;B=ja+1-y|0;f[h>>2]=(f[h>>2]|0)+B;D=(f[g>>2]|0)-B|0;f[g>>2]=D;la=D}else{bSb(e,r);la=f[g>>2]|0}D=b[l>>0]|0;if((la|0)>4){b[f[h>>2]>>0]=D;f[h>>2]=(f[h>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1;break a}else{bSb(e,D&255);break a}}break}case 47:{fRb(l,j,e);break}case 67:{gRb(l,j,e);break}case 87:{D=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(D>>>3|0)){if((f[g>>2]|0)>4){B=f[h>>2]|0;if(D>>>0>127){x=D;s=B;while(1){b[s>>0]=x|128;u=x>>>7;t=s+1|0;if(x>>>0>16383){x=u;s=t}else{ma=t;na=u;break}}}else{ma=B;na=D}b[ma>>0]=na;s=ma+1-B|0;f[h>>2]=(f[h>>2]|0)+s;x=(f[g>>2]|0)-s|0;f[g>>2]=x;oa=x}else{bSb(e,D);oa=f[g>>2]|0}x=b[l>>0]|0;if((oa|0)>4){b[f[h>>2]>>0]=x;f[h>>2]=(f[h>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1;break a}else{bSb(e,x&255);break a}}break}case 8:{x=f[c+(i*20|0)+8>>2]|0;if(1<<(x&31)&f[a+(x>>>5<<2)>>2]|0){x=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){s=f[h>>2]|0;if(x>>>0>127){r=x;y=s;while(1){b[y>>0]=r|128;u=r>>>7;t=y+1|0;if(r>>>0>16383){r=u;y=t}else{pa=t;qa=u;break}}}else{pa=s;qa=x}b[pa>>0]=qa;y=pa+1-s|0;f[h>>2]=(f[h>>2]|0)+y;f[g>>2]=(f[g>>2]|0)-y}else bSb(e,x);hRb(f[l>>2]|0,e)}break}case 28:{y=f[l>>2]|0;r=b[y+11>>0]|0;if(r<<24>>24<0)ra=f[y+4>>2]|0;else ra=r&255;if(ra|0){r=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){y=f[h>>2]|0;if(r>>>0>127){D=r;B=y;while(1){b[B>>0]=D|128;u=D>>>7;t=B+1|0;if(D>>>0>16383){D=u;B=t}else{sa=t;ta=u;break}}}else{sa=y;ta=r}b[sa>>0]=ta;B=sa+1-y|0;f[h>>2]=(f[h>>2]|0)+B;f[g>>2]=(f[g>>2]|0)-B}else bSb(e,r);hRb(f[l>>2]|0,e)}break}case 48:{B=l+4|0;if((f[B>>2]|0)>0){D=c+(i*20|0)+4|0;x=l+12|0;s=0;do{u=f[D>>2]|0;if((f[g>>2]|0)>4){t=f[h>>2]|0;if(u>>>0>127){C=u;M=t;while(1){b[M>>0]=C|128;N=C>>>7;ua=M+1|0;if(C>>>0>16383){C=N;M=ua}else{va=ua;wa=N;break}}}else{va=t;wa=u}b[va>>0]=wa;M=va+1-t|0;f[h>>2]=(f[h>>2]|0)+M;f[g>>2]=(f[g>>2]|0)-M}else bSb(e,u);M=f[x>>2]|0;hRb(f[((M|0)==0?0:M+4|0)+(s<<2)>>2]|0,e);s=s+1|0}while((s|0)<(f[B>>2]|0))}break}case 68:{iRb(l,j,e);break}case 88:{B=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(B>>>3|0)){if((f[g>>2]|0)>4){s=f[h>>2]|0;if(B>>>0>127){x=B;D=s;while(1){b[D>>0]=x|128;r=x>>>7;y=D+1|0;if(x>>>0>16383){x=r;D=y}else{xa=y;ya=r;break}}}else{xa=s;ya=B}b[xa>>0]=ya;D=xa+1-s|0;f[h>>2]=(f[h>>2]|0)+D;f[g>>2]=(f[g>>2]|0)-D}else bSb(e,B);hRb(f[l>>2]|0,e)}break}case 9:{D=f[c+(i*20|0)+8>>2]|0;if(1<<(D&31)&f[a+(D>>>5<<2)>>2]|0)jRb(l,j,e);break}case 29:{if(f[l>>2]|0)jRb(l,j,e);break}case 49:{kRb(l,j,e);break}case 69:{iRb(l,j,e);break}case 89:{if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==((f[c+(i*20|0)+4>>2]|0)>>>3|0))jRb(l,j,e);break}case 10:{D=f[c+(i*20|0)+8>>2]|0;if(1<<(D&31)&f[a+(D>>>5<<2)>>2]|0){D=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){x=f[h>>2]|0;if(D>>>0>127){r=D;y=x;while(1){b[y>>0]=r|128;M=r>>>7;C=y+1|0;if(r>>>0>16383){r=M;y=C}else{za=C;Aa=M;break}}}else{za=x;Aa=D}b[za>>0]=Aa;y=za+1-x|0;f[h>>2]=(f[h>>2]|0)+y;f[g>>2]=(f[g>>2]|0)-y}else bSb(e,D);lRb(f[l>>2]|0,f[c+(i*20|0)+16>>2]|0,e)}break}case 30:{if(f[l>>2]|0){y=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){r=f[h>>2]|0;if(y>>>0>127){B=y;s=r;while(1){b[s>>0]=B|128;M=B>>>7;C=s+1|0;if(B>>>0>16383){B=M;s=C}else{Ba=C;Ca=M;break}}}else{Ba=r;Ca=y}b[Ba>>0]=Ca;s=Ba+1-r|0;f[h>>2]=(f[h>>2]|0)+s;f[g>>2]=(f[g>>2]|0)-s}else bSb(e,y);lRb(f[l>>2]|0,f[c+(i*20|0)+16>>2]|0,e)}break}case 50:{s=l+4|0;if((f[s>>2]|0)>0){B=c+(i*20|0)+4|0;D=l+12|0;x=c+(i*20|0)+16|0;M=0;do{C=f[B>>2]|0;if((f[g>>2]|0)>4){o=f[h>>2]|0;if(C>>>0>127){q=C;N=o;while(1){b[N>>0]=q|128;ua=q>>>7;Da=N+1|0;if(q>>>0>16383){q=ua;N=Da}else{Ea=Da;Fa=ua;break}}}else{Ea=o;Fa=C}b[Ea>>0]=Fa;N=Ea+1-o|0;f[h>>2]=(f[h>>2]|0)+N;f[g>>2]=(f[g>>2]|0)-N}else bSb(e,C);N=f[D>>2]|0;lRb(f[((N|0)==0?0:N+4|0)+(M<<2)>>2]|0,f[x>>2]|0,e);M=M+1|0}while((M|0)<(f[s>>2]|0))}break}case 70:{iRb(l,j,e);break}case 90:{s=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(s>>>3|0)){if((f[g>>2]|0)>4){M=f[h>>2]|0;if(s>>>0>127){x=s;D=M;while(1){b[D>>0]=x|128;B=x>>>7;y=D+1|0;if(x>>>0>16383){x=B;D=y}else{Ga=y;Ha=B;break}}}else{Ga=M;Ha=s}b[Ga>>0]=Ha;D=Ga+1-M|0;f[h>>2]=(f[h>>2]|0)+D;f[g>>2]=(f[g>>2]|0)-D}else bSb(e,s);lRb(f[l>>2]|0,f[c+(i*20|0)+16>>2]|0,e)}break}case 11:{D=f[c+(i*20|0)+8>>2]|0;if(1<<(D&31)&f[a+(D>>>5<<2)>>2]|0){D=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){x=f[h>>2]|0;if(D>>>0>127){B=D;y=x;while(1){b[y>>0]=B|128;r=B>>>7;N=y+1|0;if(B>>>0>16383){B=r;y=N}else{Ia=N;Ja=r;break}}}else{Ia=x;Ja=D}b[Ia>>0]=Ja;y=Ia+1-x|0;f[h>>2]=(f[h>>2]|0)+y;f[g>>2]=(f[g>>2]|0)-y}else bSb(e,D);hRb(f[l>>2]|0,e)}break}case 31:{y=f[l>>2]|0;B=b[y+11>>0]|0;if(B<<24>>24<0)Ka=f[y+4>>2]|0;else Ka=B&255;if(Ka|0){B=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){y=f[h>>2]|0;if(B>>>0>127){s=B;M=y;while(1){b[M>>0]=s|128;r=s>>>7;N=M+1|0;if(s>>>0>16383){s=r;M=N}else{La=N;Ma=r;break}}}else{La=y;Ma=B}b[La>>0]=Ma;M=La+1-y|0;f[h>>2]=(f[h>>2]|0)+M;f[g>>2]=(f[g>>2]|0)-M}else bSb(e,B);hRb(f[l>>2]|0,e)}break}case 51:{M=l+4|0;if((f[M>>2]|0)>0){s=c+(i*20|0)+4|0;D=l+12|0;x=0;do{r=f[s>>2]|0;if((f[g>>2]|0)>4){N=f[h>>2]|0;if(r>>>0>127){q=r;u=N;while(1){b[u>>0]=q|128;t=q>>>7;ua=u+1|0;if(q>>>0>16383){q=t;u=ua}else{Na=ua;Oa=t;break}}}else{Na=N;Oa=r}b[Na>>0]=Oa;u=Na+1-N|0;f[h>>2]=(f[h>>2]|0)+u;f[g>>2]=(f[g>>2]|0)-u}else bSb(e,r);u=f[D>>2]|0;hRb(f[((u|0)==0?0:u+4|0)+(x<<2)>>2]|0,e);x=x+1|0}while((x|0)<(f[M>>2]|0))}break}case 71:{iRb(l,j,e);break}case 91:{M=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(M>>>3|0)){if((f[g>>2]|0)>4){x=f[h>>2]|0;if(M>>>0>127){D=M;s=x;while(1){b[s>>0]=D|128;B=D>>>7;y=s+1|0;if(D>>>0>16383){D=B;s=y}else{Pa=y;Qa=B;break}}}else{Pa=x;Qa=M}b[Pa>>0]=Qa;s=Pa+1-x|0;f[h>>2]=(f[h>>2]|0)+s;f[g>>2]=(f[g>>2]|0)-s}else bSb(e,M);hRb(f[l>>2]|0,e)}break}case 12:{s=f[c+(i*20|0)+8>>2]|0;if(1<<(s&31)&f[a+(s>>>5<<2)>>2]|0)mRb(l,j,e);break}case 32:{if(f[l>>2]|0)mRb(l,j,e);break}case 52:{nRb(l,j,e);break}case 72:{oRb(l,j,e);break}case 92:{if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==((f[c+(i*20|0)+4>>2]|0)>>>3|0))mRb(l,j,e);break}case 13:{s=f[c+(i*20|0)+8>>2]|0;if(1<<(s&31)&f[a+(s>>>5<<2)>>2]|0)pRb(l,j,e);break}case 33:{if(f[l>>2]|0)pRb(l,j,e);break}case 53:{qRb(l,j,e);break}case 73:{rRb(l,j,e);break}case 93:{if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==((f[c+(i*20|0)+4>>2]|0)>>>3|0))pRb(l,j,e);break}case 14:{s=f[c+(i*20|0)+8>>2]|0;if(1<<(s&31)&f[a+(s>>>5<<2)>>2]|0){s=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){D=f[h>>2]|0;if(s>>>0>127){B=s;y=D;while(1){b[y>>0]=B|128;u=B>>>7;q=y+1|0;if(B>>>0>16383){B=u;y=q}else{Ra=q;Sa=u;break}}}else{Ra=D;Sa=s}b[Ra>>0]=Sa;y=Ra+1-D|0;f[h>>2]=(f[h>>2]|0)+y;f[g>>2]=(f[g>>2]|0)-y}else bSb(e,s);$Rb(e,f[l>>2]|0)}break}case 34:{if(f[l>>2]|0){y=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){B=f[h>>2]|0;if(y>>>0>127){M=y;x=B;while(1){b[x>>0]=M|128;u=M>>>7;q=x+1|0;if(M>>>0>16383){M=u;x=q}else{Ta=q;Ua=u;break}}}else{Ta=B;Ua=y}b[Ta>>0]=Ua;x=Ta+1-B|0;f[h>>2]=(f[h>>2]|0)+x;f[g>>2]=(f[g>>2]|0)-x}else bSb(e,y);$Rb(e,f[l>>2]|0)}break}case 54:{if((f[l>>2]|0)>0){x=c+(i*20|0)+4|0;M=l+8|0;s=0;do{D=f[x>>2]|0;if((f[g>>2]|0)>4){u=f[h>>2]|0;if(D>>>0>127){q=D;C=u;while(1){b[C>>0]=q|128;o=q>>>7;t=C+1|0;if(q>>>0>16383){q=o;C=t}else{Va=t;Wa=o;break}}}else{Va=u;Wa=D}b[Va>>0]=Wa;C=Va+1-u|0;f[h>>2]=(f[h>>2]|0)+C;f[g>>2]=(f[g>>2]|0)-C}else bSb(e,D);$Rb(e,f[(f[M>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[l>>2]|0))}break}case 74:{sRb(l,j,e);break}case 94:{s=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(s>>>3|0)){if((f[g>>2]|0)>4){M=f[h>>2]|0;if(s>>>0>127){x=s;y=M;while(1){b[y>>0]=x|128;B=x>>>7;C=y+1|0;if(x>>>0>16383){x=B;y=C}else{Xa=C;Ya=B;break}}}else{Xa=M;Ya=s}b[Xa>>0]=Ya;y=Xa+1-M|0;f[h>>2]=(f[h>>2]|0)+y;f[g>>2]=(f[g>>2]|0)-y}else bSb(e,s);$Rb(e,f[l>>2]|0)}break}case 15:{y=f[c+(i*20|0)+8>>2]|0;if(1<<(y&31)&f[a+(y>>>5<<2)>>2]|0){y=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){x=f[h>>2]|0;if(y>>>0>127){B=y;C=x;while(1){b[C>>0]=B|128;q=B>>>7;r=C+1|0;if(B>>>0>16383){B=q;C=r}else{Za=r;_a=q;break}}}else{Za=x;_a=y}b[Za>>0]=_a;C=Za+1-x|0;f[h>>2]=(f[h>>2]|0)+C;f[g>>2]=(f[g>>2]|0)-C}else bSb(e,y);C=l;aSb(e,f[C>>2]|0,f[C+4>>2]|0)}break}case 35:{C=l;if(!((f[C>>2]|0)==0&(f[C+4>>2]|0)==0)){C=f[c+(i*20|0)+4>>2]|0;if((f[g>>2]|0)>4){B=f[h>>2]|0;if(C>>>0>127){s=C;M=B;while(1){b[M>>0]=s|128;q=s>>>7;r=M+1|0;if(s>>>0>16383){s=q;M=r}else{$a=r;ab=q;break}}}else{$a=B;ab=C}b[$a>>0]=ab;M=$a+1-B|0;f[h>>2]=(f[h>>2]|0)+M;f[g>>2]=(f[g>>2]|0)-M}else bSb(e,C);M=l;aSb(e,f[M>>2]|0,f[M+4>>2]|0)}break}case 55:{if((f[l>>2]|0)>0){M=c+(i*20|0)+4|0;s=l+8|0;y=0;do{x=f[M>>2]|0;if((f[g>>2]|0)>4){q=f[h>>2]|0;if(x>>>0>127){r=x;N=q;while(1){b[N>>0]=r|128;o=r>>>7;t=N+1|0;if(r>>>0>16383){r=o;N=t}else{bb=t;cb=o;break}}}else{bb=q;cb=x}b[bb>>0]=cb;N=bb+1-q|0;f[h>>2]=(f[h>>2]|0)+N;f[g>>2]=(f[g>>2]|0)-N}else bSb(e,x);N=(f[s>>2]|0)+8+(y<<3)|0;aSb(e,f[N>>2]|0,f[N+4>>2]|0);y=y+1|0}while((y|0)<(f[l>>2]|0))}break}case 75:{tRb(l,j,e);break}case 95:{y=f[c+(i*20|0)+4>>2]|0;if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==(y>>>3|0)){if((f[g>>2]|0)>4){s=f[h>>2]|0;if(y>>>0>127){M=y;C=s;while(1){b[C>>0]=M|128;B=M>>>7;N=C+1|0;if(M>>>0>16383){M=B;C=N}else{db=N;eb=B;break}}}else{db=s;eb=y}b[db>>0]=eb;C=db+1-s|0;f[h>>2]=(f[h>>2]|0)+C;f[g>>2]=(f[g>>2]|0)-C}else bSb(e,y);C=l;aSb(e,f[C>>2]|0,f[C+4>>2]|0)}break}case 16:{C=f[c+(i*20|0)+8>>2]|0;if(1<<(C&31)&f[a+(C>>>5<<2)>>2]|0)uRb(l,j,e);break}case 36:{if(f[l>>2]|0)uRb(l,j,e);break}case 56:{vRb(l,j,e);break}case 76:{wRb(l,j,e);break}case 96:{if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==((f[c+(i*20|0)+4>>2]|0)>>>3|0))uRb(l,j,e);break}case 17:{C=f[c+(i*20|0)+8>>2]|0;if(1<<(C&31)&f[a+(C>>>5<<2)>>2]|0)xRb(l,j,e);break}case 37:{C=l;if(!((f[C>>2]|0)==0&(f[C+4>>2]|0)==0))xRb(l,j,e);break}case 57:{yRb(l,j,e);break}case 77:{zRb(l,j,e);break}case 97:{if((f[a+(f[c+(i*20|0)+8>>2]|0)>>2]|0)==((f[c+(i*20|0)+4>>2]|0)>>>3|0))xRb(l,j,e);break}case 100:{gi[f[c+(i*20|0)+16>>2]&255](a,k,f[c+(i*20|0)+4>>2]|0,f[c+(i*20|0)+8>>2]|0,e);break}default:ARb(m)}while(0);i=i+1|0}while((i|0)!=(d|0));return}function UQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{c=(f[e>>2]|0)+8+(q<<3)|0;aSb(d,f[c>>2]|0,f[c+4>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function VQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{$Rb(d,f[(f[e>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function WQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=a;a=f[e>>2]|0;g=f[e+4>>2]|0;if((o|0)<=9){cSb(d,a,g);return}o=d+4|0;d=f[o>>2]|0;e=a&255;if(g>>>0>0|(g|0)==0&a>>>0>127){n=d;h=e;m=a;a=g;while(1){b[n>>0]=h|-128;g=m;m=aJc(m|0,a|0,7)|0;j=n+1|0;i=m&255;if(!(a>>>0>0|(a|0)==0&g>>>0>16383)){p=j;q=i;break}else{n=j;h=i;a=J}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function XQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{bSb(d,j);r=f[c>>2]|0}l=(f[h>>2]|0)+8+(i<<3)|0;m=f[l>>2]|0;n=f[l+4>>2]|0;if((r|0)>9){l=f[g>>2]|0;o=m&255;if(n>>>0>0|(n|0)==0&m>>>0>127){s=l;t=o;u=m;v=n;while(1){b[s>>0]=t|-128;w=u;u=aJc(u|0,v|0,7)|0;x=s+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{s=x;t=y;v=J}}}else{z=l;A=o}b[z>>0]=A;v=z+1-l|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else cSb(d,m,n);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function YQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=(f[e>>2]|0)+8+(o<<3)|0;p=f[g>>2]|0;h=f[g+4>>2]|0;if((f[c>>2]|0)>9){g=f[q>>2]|0;n=p&255;if(h>>>0>0|(h|0)==0&p>>>0>127){m=g;j=n;i=p;k=h;while(1){b[m>>0]=j|-128;l=i;i=aJc(i|0,k|0,7)|0;r=m+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{m=r;j=s;k=J}}}else{t=g;u=n}b[t>>0]=u;k=t+1-g|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else cSb(d,p,h);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function ZQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=a;a=f[e>>2]|0;g=f[e+4>>2]|0;if((o|0)<=9){cSb(d,a,g);return}o=d+4|0;d=f[o>>2]|0;e=a&255;if(g>>>0>0|(g|0)==0&a>>>0>127){n=d;h=e;m=a;a=g;while(1){b[n>>0]=h|-128;g=m;m=aJc(m|0,a|0,7)|0;j=n+1|0;i=m&255;if(!(a>>>0>0|(a|0)==0&g>>>0>16383)){p=j;q=i;break}else{n=j;h=i;a=J}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function _Qb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{bSb(d,j);r=f[c>>2]|0}l=(f[h>>2]|0)+8+(i<<3)|0;m=f[l>>2]|0;n=f[l+4>>2]|0;if((r|0)>9){l=f[g>>2]|0;o=m&255;if(n>>>0>0|(n|0)==0&m>>>0>127){s=l;t=o;u=m;v=n;while(1){b[s>>0]=t|-128;w=u;u=aJc(u|0,v|0,7)|0;x=s+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{s=x;t=y;v=J}}}else{z=l;A=o}b[z>>0]=A;v=z+1-l|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else cSb(d,m,n);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function $Qb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=(f[e>>2]|0)+8+(o<<3)|0;p=f[g>>2]|0;h=f[g+4>>2]|0;if((f[c>>2]|0)>9){g=f[q>>2]|0;n=p&255;if(h>>>0>0|(h|0)==0&p>>>0>127){m=g;j=n;i=p;k=h;while(1){b[m>>0]=j|-128;l=i;i=aJc(i|0,k|0,7)|0;r=m+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{m=r;j=s;k=J}}}else{t=g;u=n}b[t>>0]=u;k=t+1-g|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else cSb(d,p,h);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function aRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a>>2]|0;a=((e|0)<0)<<31>>31;if((o|0)<=9){cSb(d,e,a);return}o=d+4|0;d=f[o>>2]|0;g=e&255;if(e>>>0>127){n=d;h=g;m=e;e=a;while(1){b[n>>0]=h|-128;a=m;m=aJc(m|0,e|0,7)|0;j=n+1|0;i=m&255;if(!(e>>>0>0|(e|0)==0&a>>>0>16383)){p=j;q=i;break}else{n=j;h=i;e=J}}}else{p=d;q=g}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function bRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{bSb(d,j);r=f[c>>2]|0}l=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;m=((l|0)<0)<<31>>31;if((r|0)>9){n=f[g>>2]|0;o=l&255;if(l>>>0>127){s=n;t=o;u=l;v=m;while(1){b[s>>0]=t|-128;w=u;u=aJc(u|0,v|0,7)|0;x=s+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{s=x;t=y;v=J}}}else{z=n;A=o}b[z>>0]=A;v=z+1-n|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else cSb(d,l,m);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function cRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=f[(f[e>>2]|0)+4+(o<<2)>>2]|0;p=((g|0)<0)<<31>>31;if((f[c>>2]|0)>9){h=f[q>>2]|0;n=g&255;if(g>>>0>127){m=h;j=n;i=g;k=p;while(1){b[m>>0]=j|-128;l=i;i=aJc(i|0,k|0,7)|0;r=m+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{m=r;j=s;k=J}}}else{t=h;u=n}b[t>>0]=u;k=t+1-h|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else cSb(d,g,p);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function dRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{c=(f[e>>2]|0)+8+(q<<3)|0;aSb(d,f[c>>2]|0,f[c+4>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function eRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{$Rb(d,f[(f[e>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function fRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{bSb(d,j);r=f[c>>2]|0}l=b[(f[h>>2]|0)+4+i>>0]|0;if((r|0)>4){b[f[g>>2]>>0]=l;f[g>>2]=(f[g>>2]|0)+1;f[c>>2]=(f[c>>2]|0)+-1}else bSb(d,l&255);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function gRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=b[(f[e>>2]|0)+4+o>>0]|0;if((f[c>>2]|0)>4){b[f[q>>2]>>0]=g;f[q>>2]=(f[q>>2]|0)+1;f[c>>2]=(f[c>>2]|0)+-1}else bSb(d,g&255);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function hRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+11|0;e=b[d>>0]|0;if(e<<24>>24<0)g=f[a+4>>2]|0;else g=e&255;e=c+8|0;if((f[e>>2]|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else bSb(c,g);g=b[d>>0]|0;if(g<<24>>24<0){p=f[a>>2]|0;q=f[a+4>>2]|0}else{p=a;q=g&255}if(!(b[c+17>>0]|0)){ZRb(c,p,q);return}else{_Rb(c,p,q);return}}function iRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=u;u=u+32|0;a=c;rTb(a,3,471939,512);d=mTb(a,472040)|0;e=mTb(qTb(d,f[b+4>>2]|0)|0,472070)|0;oTb(c+24|0,qTb(e,f[b+12>>2]|0)|0);sTb(a);u=c;return}function jRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=c+4|0;g=f[e>>2]|0;h=d+8|0;if((f[h>>2]|0)>4){i=d+4|0;j=f[i>>2]|0;if(g>>>0>127){k=g;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=g}b[o>>0]=p;p=o+1-j|0;f[i>>2]=(f[i>>2]|0)+p;f[h>>2]=(f[h>>2]|0)-p}else bSb(d,g);g=f[a>>2]|0;a=f[c+16>>2]|0;do if(!a)mi[f[(f[g>>2]|0)+52>>2]&2047](g,d);else{c=f[a+4>>2]|0;p=f[g+(f[c>>2]|0)>>2]|0;i=(f[a>>2]|0)+-1|0;j=c+20|0;c=f[h>>2]|0;o=d+4|0;if((c|0)>=(p|0)?(l=f[o>>2]|0,f[o>>2]=l+p,f[h>>2]=c-p,l|0):0){if(!(b[d+18>>0]|0))q=(f[220805]|0)!=0;else q=(b[d+19>>0]|0)!=0;hj[f[(f[g>>2]|0)+64>>2]&511](g,q,l)|0;break}TQb(g,j,i,d)}while(0);g=(f[e>>2]|0)+1|0;if((f[h>>2]|0)<=4){bSb(d,g);return}e=d+4|0;d=f[e>>2]|0;if(g>>>0>127){q=g;a=d;while(1){b[a>>0]=q|128;i=q>>>7;j=a+1|0;if(q>>>0>16383){q=i;a=j}else{r=j;s=i;break}}}else{r=d;s=g}b[r>>0]=s;s=r+1-d|0;f[e>>2]=(f[e>>2]|0)+s;f[h>>2]=(f[h>>2]|0)-s;return}function kRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=a+4|0;if((f[e>>2]|0)<=0)return;g=c+4|0;h=d+8|0;i=d+4|0;j=a+12|0;a=c+16|0;c=d+18|0;k=d+19|0;l=0;do{m=f[g>>2]|0;if((f[h>>2]|0)>4){n=f[i>>2]|0;if(m>>>0>127){o=m;p=n;while(1){b[p>>0]=o|128;q=o>>>7;r=p+1|0;if(o>>>0>16383){o=q;p=r}else{s=r;t=q;break}}}else{s=n;t=m}b[s>>0]=t;p=s+1-n|0;f[i>>2]=(f[i>>2]|0)+p;f[h>>2]=(f[h>>2]|0)-p}else bSb(d,m);p=f[j>>2]|0;o=f[((p|0)==0?0:p+4|0)+(l<<2)>>2]|0;p=f[a>>2]|0;do if(!p)mi[f[(f[o>>2]|0)+52>>2]&2047](o,d);else{q=f[p+4>>2]|0;r=f[o+(f[q>>2]|0)>>2]|0;u=(f[p>>2]|0)+-1|0;v=q+20|0;q=f[h>>2]|0;if((q|0)>=(r|0)?(w=f[i>>2]|0,f[i>>2]=w+r,f[h>>2]=q-r,w|0):0){if(!(b[c>>0]|0))x=(f[220805]|0)!=0;else x=(b[k>>0]|0)!=0;hj[f[(f[o>>2]|0)+64>>2]&511](o,x,w)|0;break}TQb(o,v,u,d)}while(0);o=(f[g>>2]|0)+1|0;if((f[h>>2]|0)>4){p=f[i>>2]|0;if(o>>>0>127){m=o;n=p;while(1){b[n>>0]=m|128;u=m>>>7;v=n+1|0;if(m>>>0>16383){m=u;n=v}else{y=v;z=u;break}}}else{y=p;z=o}b[y>>0]=z;n=y+1-p|0;f[i>>2]=(f[i>>2]|0)+n;f[h>>2]=(f[h>>2]|0)-n}else bSb(d,o);l=l+1|0}while((l|0)<(f[e>>2]|0));return}function lRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!c){e=_i[f[(f[a>>2]|0)+60>>2]&1023](a)|0;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=e}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else bSb(d,e);mi[f[(f[a>>2]|0)+52>>2]&2047](a,d);return}e=f[c+4>>2]|0;o=f[a+(f[e>>2]|0)>>2]|0;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;i=f[h>>2]|0;if(o>>>0>127){n=o;k=i;while(1){b[k>>0]=n|128;j=n>>>7;l=k+1|0;if(n>>>0>16383){n=j;k=l}else{p=l;q=j;break}}}else{p=i;q=o}b[p>>0]=q;q=p+1-i|0;f[h>>2]=(f[h>>2]|0)+q;i=(f[g>>2]|0)-q|0;f[g>>2]=i;r=h;s=i}else{bSb(d,o);r=d+4|0;s=f[g>>2]|0}i=(f[c>>2]|0)+-1|0;c=e+20|0;if((s|0)>=(o|0)?(e=f[r>>2]|0,f[r>>2]=e+o,f[g>>2]=s-o,e|0):0){if(!(b[d+18>>0]|0))t=(f[220805]|0)!=0;else t=(b[d+19>>0]|0)!=0;hj[f[(f[a>>2]|0)+64>>2]&511](a,t,e)|0;return}TQb(a,c,i,d);return}function mRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a>>2]|0;if((o|0)<=4){bSb(d,e);return}o=d+4|0;d=f[o>>2]|0;if(e>>>0>127){a=e;g=d;while(1){b[g>>0]=a|128;n=a>>>7;h=g+1|0;if(a>>>0>16383){a=n;g=h}else{p=h;q=n;break}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function nRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{bSb(d,j);r=f[c>>2]|0}l=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;if((r|0)>4){m=f[g>>2]|0;if(l>>>0>127){n=l;o=m;while(1){b[o>>0]=n|128;s=n>>>7;t=o+1|0;if(n>>>0>16383){n=s;o=t}else{u=t;v=s;break}}}else{u=m;v=l}b[u>>0]=v;o=u+1-m|0;f[g>>2]=(f[g>>2]|0)+o;f[c>>2]=(f[c>>2]|0)-o}else bSb(d,l);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function oRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=f[(f[e>>2]|0)+4+(o<<2)>>2]|0;if((f[c>>2]|0)>4){p=f[q>>2]|0;if(g>>>0>127){h=g;n=p;while(1){b[n>>0]=h|128;m=h>>>7;j=n+1|0;if(h>>>0>16383){h=m;n=j}else{r=j;s=m;break}}}else{r=p;s=g}b[r>>0]=s;n=r+1-p|0;f[q>>2]=(f[q>>2]|0)+n;f[c>>2]=(f[c>>2]|0)-n}else bSb(d,g);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function pRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a>>2]|0;a=((e|0)<0)<<31>>31;if((o|0)<=9){cSb(d,e,a);return}o=d+4|0;d=f[o>>2]|0;g=e&255;if(e>>>0>127){n=d;h=g;m=e;e=a;while(1){b[n>>0]=h|-128;a=m;m=aJc(m|0,e|0,7)|0;j=n+1|0;i=m&255;if(!(e>>>0>0|(e|0)==0&a>>>0>16383)){p=j;q=i;break}else{n=j;h=i;e=J}}}else{p=d;q=g}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function qRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{bSb(d,j);r=f[c>>2]|0}l=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;m=((l|0)<0)<<31>>31;if((r|0)>9){n=f[g>>2]|0;o=l&255;if(l>>>0>127){s=n;t=o;u=l;v=m;while(1){b[s>>0]=t|-128;w=u;u=aJc(u|0,v|0,7)|0;x=s+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{s=x;t=y;v=J}}}else{z=n;A=o}b[z>>0]=A;v=z+1-n|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else cSb(d,l,m);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function rRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=f[(f[e>>2]|0)+4+(o<<2)>>2]|0;p=((g|0)<0)<<31>>31;if((f[c>>2]|0)>9){h=f[q>>2]|0;n=g&255;if(g>>>0>127){m=h;j=n;i=g;k=p;while(1){b[m>>0]=j|-128;l=i;i=aJc(i|0,k|0,7)|0;r=m+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{m=r;j=s;k=J}}}else{t=h;u=n}b[t>>0]=u;k=t+1-h|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else cSb(d,g,p);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function sRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{$Rb(d,f[(f[e>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function tRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{c=(f[e>>2]|0)+8+(q<<3)|0;aSb(d,f[c>>2]|0,f[c+4>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function uRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a>>2]|0;a=e<<1^e>>31;if((o|0)<=4){bSb(d,a);return}o=d+4|0;d=f[o>>2]|0;if(a>>>0>127){e=a;g=d;while(1){b[g>>0]=e|128;n=e>>>7;h=g+1|0;if(e>>>0>16383){e=n;g=h}else{p=h;q=n;break}}}else{p=d;q=a}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function vRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{bSb(d,j);r=f[c>>2]|0}l=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;m=l<<1^l>>31;if((r|0)>4){l=f[g>>2]|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;s=n>>>7;t=o+1|0;if(n>>>0>16383){n=s;o=t}else{u=t;v=s;break}}}else{u=l;v=m}b[u>>0]=v;o=u+1-l|0;f[g>>2]=(f[g>>2]|0)+o;f[c>>2]=(f[c>>2]|0)-o}else bSb(d,m);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function wRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=f[(f[e>>2]|0)+4+(o<<2)>>2]|0;p=g<<1^g>>31;if((f[c>>2]|0)>4){g=f[q>>2]|0;if(p>>>0>127){h=p;n=g;while(1){b[n>>0]=h|128;m=h>>>7;j=n+1|0;if(h>>>0>16383){h=m;n=j}else{r=j;s=m;break}}}else{r=g;s=p}b[r>>0]=s;n=r+1-g|0;f[q>>2]=(f[q>>2]|0)+n;f[c>>2]=(f[c>>2]|0)-n}else bSb(d,p);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function xRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=a;a=f[e>>2]|0;g=f[e+4>>2]|0;e=jJc(a|0,g|0,1)|0;n=J;h=$Ic(a|0,g|0,63)|0;g=e^h;h=n^J;if((o|0)<=9){cSb(d,g,h);return}o=d+4|0;d=f[o>>2]|0;n=g&255;if(h>>>0>0|(h|0)==0&g>>>0>127){e=d;a=n;m=g;g=h;while(1){b[e>>0]=a|-128;h=m;m=aJc(m|0,g|0,7)|0;j=e+1|0;i=m&255;if(!(g>>>0>0|(g|0)==0&h>>>0>16383)){p=j;q=i;break}else{e=j;a=i;g=J}}}else{p=d;q=n}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function yRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{bSb(d,j);r=f[c>>2]|0}l=(f[h>>2]|0)+8+(i<<3)|0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=jJc(m|0,n|0,1)|0;o=J;s=$Ic(m|0,n|0,63)|0;n=l^s;s=o^J;if((r|0)>9){o=f[g>>2]|0;l=n&255;if(s>>>0>0|(s|0)==0&n>>>0>127){m=o;t=l;u=n;v=s;while(1){b[m>>0]=t|-128;w=u;u=aJc(u|0,v|0,7)|0;x=m+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{m=x;t=y;v=J}}}else{z=o;A=l}b[z>>0]=A;v=z+1-o|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else cSb(d,n,s);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function zRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{bSb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else bSb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=(f[e>>2]|0)+8+(o<<3)|0;p=f[g>>2]|0;h=f[g+4>>2]|0;g=jJc(p|0,h|0,1)|0;n=J;m=$Ic(p|0,h|0,63)|0;h=g^m;m=n^J;if((f[c>>2]|0)>9){n=f[q>>2]|0;g=h&255;if(m>>>0>0|(m|0)==0&h>>>0>127){p=n;j=g;i=h;k=m;while(1){b[p>>0]=j|-128;l=i;i=aJc(i|0,k|0,7)|0;r=p+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{p=r;j=s;k=J}}}else{t=n;u=g}b[t>>0]=u;k=t+1-n|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else cSb(d,h,m);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function ARb(a){a=a|0;var b=0,c=0;b=u;u=u+32|0;c=b;rTb(c,3,471939,537);oTb(b+24|0,pTb(mTb(c,472040)|0,a)|0);sTb(c);u=b;return}function BRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0;h=u;u=u+64|0;i=h+48|0;j=h+24|0;k=h;l=e&1;f[i>>2]=g;g=i+4|0;b[g>>0]=l;if((d|0)<=0){m=f[i>>2]|0;u=h;return m|0}e=k+18|0;o=k+19|0;q=k+12|0;r=k+8|0;s=0;do{t=c+(s*20|0)|0;v=a+(f[t>>2]|0)|0;w=f[c+(s*20|0)+12>>2]|0;a:do switch(w|0){case 0:{x=f[c+(s*20|0)+8>>2]|0;if(1<<(x&31)&f[a+(x>>>5<<2)>>2]|0){x=f[c+(s*20|0)+4>>2]|0;y=f[i>>2]|0;if(x>>>0>127){z=x;A=y;while(1){b[A>>0]=z|128;B=z>>>7;C=A+1|0;if(z>>>0>16383){z=B;A=C}else{D=C;E=B;break}}}else{D=y;E=x}b[D>>0]=E;A=v;z=f[A>>2]|0;B=f[A+4>>2]|0;A=D+1|0;C=A;b[C>>0]=z;b[C+1>>0]=z>>8;b[C+2>>0]=z>>16;b[C+3>>0]=z>>24;z=A+4|0;b[z>>0]=B;b[z+1>>0]=B>>8;b[z+2>>0]=B>>16;b[z+3>>0]=B>>24;f[i>>2]=D+9}break}case 20:{if(!(+p[v>>3]==0.0)){B=f[c+(s*20|0)+4>>2]|0;z=f[i>>2]|0;if(B>>>0>127){A=B;C=z;while(1){b[C>>0]=A|128;F=A>>>7;G=C+1|0;if(A>>>0>16383){A=F;C=G}else{H=G;I=F;break}}}else{H=z;I=B}b[H>>0]=I;C=v;A=f[C>>2]|0;x=f[C+4>>2]|0;C=H+1|0;y=C;b[y>>0]=A;b[y+1>>0]=A>>8;b[y+2>>0]=A>>16;b[y+3>>0]=A>>24;A=C+4|0;b[A>>0]=x;b[A+1>>0]=x>>8;b[A+2>>0]=x>>16;b[A+3>>0]=x>>24;f[i>>2]=H+9}break}case 40:{if((f[v>>2]|0)>0){x=c+(s*20|0)+4|0;A=v+8|0;C=0;y=f[i>>2]|0;do{F=f[x>>2]|0;if(F>>>0>127){G=F;K=y;while(1){b[K>>0]=G|128;L=G>>>7;M=K+1|0;if(G>>>0>16383){G=L;K=M}else{N=M;O=L;break}}}else{N=y;O=F}b[N>>0]=O;K=(f[A>>2]|0)+8+(C<<3)|0;G=f[K>>2]|0;L=f[K+4>>2]|0;K=N+1|0;M=K;b[M>>0]=G;b[M+1>>0]=G>>8;b[M+2>>0]=G>>16;b[M+3>>0]=G>>24;G=K+4|0;b[G>>0]=L;b[G+1>>0]=L>>8;b[G+2>>0]=L>>16;b[G+3>>0]=L>>24;y=N+9|0;f[i>>2]=y;C=C+1|0}while((C|0)<(f[v>>2]|0))}break}case 60:{if(f[v>>2]|0){C=f[c+(s*20|0)+4>>2]|0;y=f[i>>2]|0;if(C>>>0>127){A=C;x=y;while(1){b[x>>0]=A|128;B=A>>>7;z=x+1|0;if(A>>>0>16383){A=B;x=z}else{P=z;Q=B;break}}}else{P=y;Q=C}b[P>>0]=Q;x=P+1|0;f[i>>2]=x;A=f[v+12>>2]|0;if(A>>>0>127){B=A;z=x;while(1){b[z>>0]=B|128;L=B>>>7;G=z+1|0;if(B>>>0>16383){B=L;z=G}else{R=G;S=L;break}}}else{R=x;S=A}b[R>>0]=S;z=R+1|0;f[i>>2]=z;if((f[v>>2]|0)>0){B=v+8|0;C=0;y=z;do{z=(f[B>>2]|0)+8+(C<<3)|0;L=f[z>>2]|0;G=f[z+4>>2]|0;z=y;K=z;b[K>>0]=L;b[K+1>>0]=L>>8;b[K+2>>0]=L>>16;b[K+3>>0]=L>>24;L=z+4|0;b[L>>0]=G;b[L+1>>0]=G>>8;b[L+2>>0]=G>>16;b[L+3>>0]=G>>24;y=y+8|0;f[i>>2]=y;C=C+1|0}while((C|0)<(f[v>>2]|0))}}break}case 80:{C=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(C>>>3|0)){y=f[i>>2]|0;if(C>>>0>127){B=C;A=y;while(1){b[A>>0]=B|128;x=B>>>7;G=A+1|0;if(B>>>0>16383){B=x;A=G}else{T=G;U=x;break}}}else{T=y;U=C}b[T>>0]=U;A=v;B=f[A>>2]|0;x=f[A+4>>2]|0;A=T+1|0;G=A;b[G>>0]=B;b[G+1>>0]=B>>8;b[G+2>>0]=B>>16;b[G+3>>0]=B>>24;B=A+4|0;b[B>>0]=x;b[B+1>>0]=x>>8;b[B+2>>0]=x>>16;b[B+3>>0]=x>>24;f[i>>2]=T+9}break}case 1:{x=f[c+(s*20|0)+8>>2]|0;if(1<<(x&31)&f[a+(x>>>5<<2)>>2]|0){x=f[c+(s*20|0)+4>>2]|0;B=f[i>>2]|0;if(x>>>0>127){A=x;G=B;while(1){b[G>>0]=A|128;L=A>>>7;z=G+1|0;if(A>>>0>16383){A=L;G=z}else{V=z;W=L;break}}}else{V=B;W=x}b[V>>0]=W;G=V+1|0;A=f[v>>2]|0;b[G>>0]=A;b[G+1>>0]=A>>8;b[G+2>>0]=A>>16;b[G+3>>0]=A>>24;f[i>>2]=V+5}break}case 21:{if(!(+n[v>>2]==0.0)){A=f[c+(s*20|0)+4>>2]|0;G=f[i>>2]|0;if(A>>>0>127){C=A;y=G;while(1){b[y>>0]=C|128;L=C>>>7;z=y+1|0;if(C>>>0>16383){C=L;y=z}else{X=z;Y=L;break}}}else{X=G;Y=A}b[X>>0]=Y;y=X+1|0;C=f[v>>2]|0;b[y>>0]=C;b[y+1>>0]=C>>8;b[y+2>>0]=C>>16;b[y+3>>0]=C>>24;f[i>>2]=X+5}break}case 41:{if((f[v>>2]|0)>0){C=c+(s*20|0)+4|0;y=v+8|0;x=0;B=f[i>>2]|0;do{L=f[C>>2]|0;if(L>>>0>127){z=L;K=B;while(1){b[K>>0]=z|128;M=z>>>7;Z=K+1|0;if(z>>>0>16383){z=M;K=Z}else{_=Z;$=M;break}}}else{_=B;$=L}b[_>>0]=$;K=_+1|0;z=f[(f[y>>2]|0)+4+(x<<2)>>2]|0;b[K>>0]=z;b[K+1>>0]=z>>8;b[K+2>>0]=z>>16;b[K+3>>0]=z>>24;B=_+5|0;f[i>>2]=B;x=x+1|0}while((x|0)<(f[v>>2]|0))}break}case 61:{if(f[v>>2]|0){x=f[c+(s*20|0)+4>>2]|0;B=f[i>>2]|0;if(x>>>0>127){y=x;C=B;while(1){b[C>>0]=y|128;A=y>>>7;G=C+1|0;if(y>>>0>16383){y=A;C=G}else{aa=G;ba=A;break}}}else{aa=B;ba=x}b[aa>>0]=ba;C=aa+1|0;f[i>>2]=C;y=f[v+12>>2]|0;if(y>>>0>127){A=y;G=C;while(1){b[G>>0]=A|128;z=A>>>7;K=G+1|0;if(A>>>0>16383){A=z;G=K}else{ca=K;da=z;break}}}else{ca=C;da=y}b[ca>>0]=da;G=ca+1|0;f[i>>2]=G;if((f[v>>2]|0)>0){A=v+8|0;x=0;B=G;do{G=f[(f[A>>2]|0)+4+(x<<2)>>2]|0;b[B>>0]=G;b[B+1>>0]=G>>8;b[B+2>>0]=G>>16;b[B+3>>0]=G>>24;B=B+4|0;f[i>>2]=B;x=x+1|0}while((x|0)<(f[v>>2]|0))}}break}case 81:{x=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(x>>>3|0)){B=f[i>>2]|0;if(x>>>0>127){A=x;y=B;while(1){b[y>>0]=A|128;C=A>>>7;G=y+1|0;if(A>>>0>16383){A=C;y=G}else{ea=G;fa=C;break}}}else{ea=B;fa=x}b[ea>>0]=fa;y=ea+1|0;A=f[v>>2]|0;b[y>>0]=A;b[y+1>>0]=A>>8;b[y+2>>0]=A>>16;b[y+3>>0]=A>>24;f[i>>2]=ea+5}break}case 2:{A=f[c+(s*20|0)+8>>2]|0;if(1<<(A&31)&f[a+(A>>>5<<2)>>2]|0){A=f[c+(s*20|0)+4>>2]|0;y=f[i>>2]|0;if(A>>>0>127){C=A;G=y;while(1){b[G>>0]=C|128;z=C>>>7;K=G+1|0;if(C>>>0>16383){C=z;G=K}else{ga=K;ha=z;break}}}else{ga=y;ha=A}b[ga>>0]=ha;G=ga+1|0;f[i>>2]=G;C=v;x=f[C>>2]|0;B=f[C+4>>2]|0;C=x&255;if(B>>>0>0|(B|0)==0&x>>>0>127){z=G;K=C;F=x;x=B;while(1){b[z>>0]=K|-128;B=F;F=aJc(F|0,x|0,7)|0;M=z+1|0;Z=F&255;if(!(x>>>0>0|(x|0)==0&B>>>0>16383)){ia=M;ja=Z;break}else{z=M;K=Z;x=J}}}else{ia=G;ja=C}b[ia>>0]=ja;f[i>>2]=ia+1}break}case 22:{x=v;if(!((f[x>>2]|0)==0&(f[x+4>>2]|0)==0)){x=f[c+(s*20|0)+4>>2]|0;K=f[i>>2]|0;if(x>>>0>127){z=x;F=K;while(1){b[F>>0]=z|128;A=z>>>7;y=F+1|0;if(z>>>0>16383){z=A;F=y}else{ka=y;la=A;break}}}else{ka=K;la=x}b[ka>>0]=la;F=ka+1|0;f[i>>2]=F;z=v;C=f[z>>2]|0;G=f[z+4>>2]|0;z=C&255;if(G>>>0>0|(G|0)==0&C>>>0>127){A=F;y=z;Z=C;C=G;while(1){b[A>>0]=y|-128;G=Z;Z=aJc(Z|0,C|0,7)|0;M=A+1|0;B=Z&255;if(!(C>>>0>0|(C|0)==0&G>>>0>16383)){ma=M;na=B;break}else{A=M;y=B;C=J}}}else{ma=F;na=z}b[ma>>0]=na;f[i>>2]=ma+1}break}case 42:{if((f[v>>2]|0)>0){C=c+(s*20|0)+4|0;y=v+8|0;A=0;Z=f[i>>2]|0;do{x=f[C>>2]|0;if(x>>>0>127){K=x;B=Z;while(1){b[B>>0]=K|128;M=K>>>7;G=B+1|0;if(K>>>0>16383){K=M;B=G}else{oa=G;pa=M;break}}}else{oa=Z;pa=x}b[oa>>0]=pa;B=oa+1|0;f[i>>2]=B;K=(f[y>>2]|0)+8+(A<<3)|0;L=f[K>>2]|0;M=f[K+4>>2]|0;K=L&255;if(M>>>0>0|(M|0)==0&L>>>0>127){G=B;qa=K;ra=L;L=M;while(1){b[G>>0]=qa|-128;M=ra;ra=aJc(ra|0,L|0,7)|0;sa=G+1|0;ta=ra&255;if(!(L>>>0>0|(L|0)==0&M>>>0>16383)){ua=sa;va=ta;break}else{G=sa;qa=ta;L=J}}}else{ua=B;va=K}b[ua>>0]=va;Z=ua+1|0;f[i>>2]=Z;A=A+1|0}while((A|0)<(f[v>>2]|0))}break}case 62:{if(f[v>>2]|0){A=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(A>>>0>127){y=A;C=Z;while(1){b[C>>0]=y|128;z=y>>>7;F=C+1|0;if(y>>>0>16383){y=z;C=F}else{wa=F;xa=z;break}}}else{wa=Z;xa=A}b[wa>>0]=xa;C=wa+1|0;f[i>>2]=C;y=f[v+12>>2]|0;if(y>>>0>127){z=y;F=C;while(1){b[F>>0]=z|128;L=z>>>7;qa=F+1|0;if(z>>>0>16383){z=L;F=qa}else{ya=qa;za=L;break}}}else{ya=C;za=y}b[ya>>0]=za;F=ya+1|0;f[i>>2]=F;if((f[v>>2]|0)>0){z=v+8|0;A=0;Z=F;do{F=(f[z>>2]|0)+8+(A<<3)|0;L=f[F>>2]|0;qa=f[F+4>>2]|0;F=L&255;if(qa>>>0>0|(qa|0)==0&L>>>0>127){G=Z;ra=F;x=L;L=qa;while(1){b[G>>0]=ra|-128;qa=x;x=aJc(x|0,L|0,7)|0;ta=G+1|0;sa=x&255;if(!(L>>>0>0|(L|0)==0&qa>>>0>16383)){Aa=ta;Ba=sa;break}else{G=ta;ra=sa;L=J}}}else{Aa=Z;Ba=F}b[Aa>>0]=Ba;Z=Aa+1|0;f[i>>2]=Z;A=A+1|0}while((A|0)<(f[v>>2]|0))}}break}case 82:{A=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(A>>>3|0)){Z=f[i>>2]|0;if(A>>>0>127){z=A;y=Z;while(1){b[y>>0]=z|128;C=z>>>7;L=y+1|0;if(z>>>0>16383){z=C;y=L}else{Ca=L;Da=C;break}}}else{Ca=Z;Da=A}b[Ca>>0]=Da;y=Ca+1|0;f[i>>2]=y;z=v;C=f[z>>2]|0;L=f[z+4>>2]|0;z=C&255;if(L>>>0>0|(L|0)==0&C>>>0>127){ra=y;G=z;x=C;C=L;while(1){b[ra>>0]=G|-128;L=x;x=aJc(x|0,C|0,7)|0;K=ra+1|0;B=x&255;if(!(C>>>0>0|(C|0)==0&L>>>0>16383)){Ea=K;Fa=B;break}else{ra=K;G=B;C=J}}}else{Ea=y;Fa=z}b[Ea>>0]=Fa;f[i>>2]=Ea+1}break}case 3:{C=f[c+(s*20|0)+8>>2]|0;if(1<<(C&31)&f[a+(C>>>5<<2)>>2]|0){C=f[c+(s*20|0)+4>>2]|0;G=f[i>>2]|0;if(C>>>0>127){ra=C;x=G;while(1){b[x>>0]=ra|128;A=ra>>>7;Z=x+1|0;if(ra>>>0>16383){ra=A;x=Z}else{Ga=Z;Ha=A;break}}}else{Ga=G;Ha=C}b[Ga>>0]=Ha;x=Ga+1|0;f[i>>2]=x;ra=v;z=f[ra>>2]|0;y=f[ra+4>>2]|0;ra=z&255;if(y>>>0>0|(y|0)==0&z>>>0>127){A=x;Z=ra;B=z;z=y;while(1){b[A>>0]=Z|-128;y=B;B=aJc(B|0,z|0,7)|0;K=A+1|0;L=B&255;if(!(z>>>0>0|(z|0)==0&y>>>0>16383)){Ia=K;Ja=L;break}else{A=K;Z=L;z=J}}}else{Ia=x;Ja=ra}b[Ia>>0]=Ja;f[i>>2]=Ia+1}break}case 23:{z=v;if(!((f[z>>2]|0)==0&(f[z+4>>2]|0)==0)){z=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(z>>>0>127){A=z;B=Z;while(1){b[B>>0]=A|128;C=A>>>7;G=B+1|0;if(A>>>0>16383){A=C;B=G}else{Ka=G;La=C;break}}}else{Ka=Z;La=z}b[Ka>>0]=La;B=Ka+1|0;f[i>>2]=B;A=v;ra=f[A>>2]|0;x=f[A+4>>2]|0;A=ra&255;if(x>>>0>0|(x|0)==0&ra>>>0>127){C=B;G=A;L=ra;ra=x;while(1){b[C>>0]=G|-128;x=L;L=aJc(L|0,ra|0,7)|0;K=C+1|0;y=L&255;if(!(ra>>>0>0|(ra|0)==0&x>>>0>16383)){Ma=K;Na=y;break}else{C=K;G=y;ra=J}}}else{Ma=B;Na=A}b[Ma>>0]=Na;f[i>>2]=Ma+1}break}case 43:{if((f[v>>2]|0)>0){ra=c+(s*20|0)+4|0;G=v+8|0;C=0;L=f[i>>2]|0;do{z=f[ra>>2]|0;if(z>>>0>127){Z=z;y=L;while(1){b[y>>0]=Z|128;K=Z>>>7;x=y+1|0;if(Z>>>0>16383){Z=K;y=x}else{Oa=x;Pa=K;break}}}else{Oa=L;Pa=z}b[Oa>>0]=Pa;y=Oa+1|0;f[i>>2]=y;Z=(f[G>>2]|0)+8+(C<<3)|0;F=f[Z>>2]|0;K=f[Z+4>>2]|0;Z=F&255;if(K>>>0>0|(K|0)==0&F>>>0>127){x=y;sa=Z;ta=F;F=K;while(1){b[x>>0]=sa|-128;K=ta;ta=aJc(ta|0,F|0,7)|0;qa=x+1|0;M=ta&255;if(!(F>>>0>0|(F|0)==0&K>>>0>16383)){Qa=qa;Ra=M;break}else{x=qa;sa=M;F=J}}}else{Qa=y;Ra=Z}b[Qa>>0]=Ra;L=Qa+1|0;f[i>>2]=L;C=C+1|0}while((C|0)<(f[v>>2]|0))}break}case 63:{if(f[v>>2]|0){C=f[c+(s*20|0)+4>>2]|0;L=f[i>>2]|0;if(C>>>0>127){G=C;ra=L;while(1){b[ra>>0]=G|128;A=G>>>7;B=ra+1|0;if(G>>>0>16383){G=A;ra=B}else{Sa=B;Ta=A;break}}}else{Sa=L;Ta=C}b[Sa>>0]=Ta;ra=Sa+1|0;f[i>>2]=ra;G=f[v+12>>2]|0;if(G>>>0>127){A=G;B=ra;while(1){b[B>>0]=A|128;F=A>>>7;sa=B+1|0;if(A>>>0>16383){A=F;B=sa}else{Ua=sa;Va=F;break}}}else{Ua=ra;Va=G}b[Ua>>0]=Va;B=Ua+1|0;f[i>>2]=B;if((f[v>>2]|0)>0){A=v+8|0;C=0;L=B;do{B=(f[A>>2]|0)+8+(C<<3)|0;F=f[B>>2]|0;sa=f[B+4>>2]|0;B=F&255;if(sa>>>0>0|(sa|0)==0&F>>>0>127){x=L;ta=B;z=F;F=sa;while(1){b[x>>0]=ta|-128;sa=z;z=aJc(z|0,F|0,7)|0;M=x+1|0;qa=z&255;if(!(F>>>0>0|(F|0)==0&sa>>>0>16383)){Wa=M;Xa=qa;break}else{x=M;ta=qa;F=J}}}else{Wa=L;Xa=B}b[Wa>>0]=Xa;L=Wa+1|0;f[i>>2]=L;C=C+1|0}while((C|0)<(f[v>>2]|0))}}break}case 83:{C=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(C>>>3|0)){L=f[i>>2]|0;if(C>>>0>127){A=C;G=L;while(1){b[G>>0]=A|128;ra=A>>>7;F=G+1|0;if(A>>>0>16383){A=ra;G=F}else{Ya=F;Za=ra;break}}}else{Ya=L;Za=C}b[Ya>>0]=Za;G=Ya+1|0;f[i>>2]=G;A=v;ra=f[A>>2]|0;F=f[A+4>>2]|0;A=ra&255;if(F>>>0>0|(F|0)==0&ra>>>0>127){ta=G;x=A;z=ra;ra=F;while(1){b[ta>>0]=x|-128;F=z;z=aJc(z|0,ra|0,7)|0;Z=ta+1|0;y=z&255;if(!(ra>>>0>0|(ra|0)==0&F>>>0>16383)){_a=Z;$a=y;break}else{ta=Z;x=y;ra=J}}}else{_a=G;$a=A}b[_a>>0]=$a;f[i>>2]=_a+1}break}case 4:{ra=f[c+(s*20|0)+8>>2]|0;if(1<<(ra&31)&f[a+(ra>>>5<<2)>>2]|0){ra=f[c+(s*20|0)+4>>2]|0;x=f[i>>2]|0;if(ra>>>0>127){ta=ra;z=x;while(1){b[z>>0]=ta|128;C=ta>>>7;L=z+1|0;if(ta>>>0>16383){ta=C;z=L}else{ab=L;bb=C;break}}}else{ab=x;bb=ra}b[ab>>0]=bb;z=ab+1|0;f[i>>2]=z;ta=f[v>>2]|0;A=ta&255;if(ta>>>0>127){G=z;C=A;L=ta;y=((ta|0)<0)<<31>>31;while(1){b[G>>0]=C|-128;ta=L;L=aJc(L|0,y|0,7)|0;Z=G+1|0;F=L&255;if(!(y>>>0>0|(y|0)==0&ta>>>0>16383)){cb=Z;db=F;break}else{G=Z;C=F;y=J}}}else{cb=z;db=A}b[cb>>0]=db;f[i>>2]=cb+1}break}case 24:{if(f[v>>2]|0){y=f[c+(s*20|0)+4>>2]|0;C=f[i>>2]|0;if(y>>>0>127){G=y;L=C;while(1){b[L>>0]=G|128;ra=G>>>7;x=L+1|0;if(G>>>0>16383){G=ra;L=x}else{eb=x;fb=ra;break}}}else{eb=C;fb=y}b[eb>>0]=fb;L=eb+1|0;f[i>>2]=L;G=f[v>>2]|0;A=G&255;if(G>>>0>127){z=L;ra=A;x=G;F=((G|0)<0)<<31>>31;while(1){b[z>>0]=ra|-128;G=x;x=aJc(x|0,F|0,7)|0;Z=z+1|0;ta=x&255;if(!(F>>>0>0|(F|0)==0&G>>>0>16383)){gb=Z;hb=ta;break}else{z=Z;ra=ta;F=J}}}else{gb=L;hb=A}b[gb>>0]=hb;f[i>>2]=gb+1}break}case 44:{if((f[v>>2]|0)>0){F=c+(s*20|0)+4|0;ra=v+8|0;z=0;x=f[i>>2]|0;do{y=f[F>>2]|0;if(y>>>0>127){C=y;ta=x;while(1){b[ta>>0]=C|128;Z=C>>>7;G=ta+1|0;if(C>>>0>16383){C=Z;ta=G}else{ib=G;jb=Z;break}}}else{ib=x;jb=y}b[ib>>0]=jb;ta=ib+1|0;f[i>>2]=ta;C=f[(f[ra>>2]|0)+4+(z<<2)>>2]|0;B=C&255;if(C>>>0>127){Z=ta;G=B;qa=C;M=((C|0)<0)<<31>>31;while(1){b[Z>>0]=G|-128;C=qa;qa=aJc(qa|0,M|0,7)|0;sa=Z+1|0;K=qa&255;if(!(M>>>0>0|(M|0)==0&C>>>0>16383)){kb=sa;lb=K;break}else{Z=sa;G=K;M=J}}}else{kb=ta;lb=B}b[kb>>0]=lb;x=kb+1|0;f[i>>2]=x;z=z+1|0}while((z|0)<(f[v>>2]|0))}break}case 64:{if(f[v>>2]|0){z=f[c+(s*20|0)+4>>2]|0;x=f[i>>2]|0;if(z>>>0>127){ra=z;F=x;while(1){b[F>>0]=ra|128;A=ra>>>7;L=F+1|0;if(ra>>>0>16383){ra=A;F=L}else{mb=L;nb=A;break}}}else{mb=x;nb=z}b[mb>>0]=nb;F=mb+1|0;f[i>>2]=F;ra=f[v+12>>2]|0;if(ra>>>0>127){A=ra;L=F;while(1){b[L>>0]=A|128;M=A>>>7;G=L+1|0;if(A>>>0>16383){A=M;L=G}else{ob=G;pb=M;break}}}else{ob=F;pb=ra}b[ob>>0]=pb;L=ob+1|0;f[i>>2]=L;if((f[v>>2]|0)>0){A=v+8|0;z=0;x=L;do{L=f[(f[A>>2]|0)+4+(z<<2)>>2]|0;M=L&255;if(L>>>0>127){G=x;Z=M;qa=L;y=((L|0)<0)<<31>>31;while(1){b[G>>0]=Z|-128;L=qa;qa=aJc(qa|0,y|0,7)|0;K=G+1|0;sa=qa&255;if(!(y>>>0>0|(y|0)==0&L>>>0>16383)){qb=K;rb=sa;break}else{G=K;Z=sa;y=J}}}else{qb=x;rb=M}b[qb>>0]=rb;x=qb+1|0;f[i>>2]=x;z=z+1|0}while((z|0)<(f[v>>2]|0))}}break}case 84:{z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(z>>>3|0)){x=f[i>>2]|0;if(z>>>0>127){A=z;ra=x;while(1){b[ra>>0]=A|128;F=A>>>7;y=ra+1|0;if(A>>>0>16383){A=F;ra=y}else{sb=y;tb=F;break}}}else{sb=x;tb=z}b[sb>>0]=tb;ra=sb+1|0;f[i>>2]=ra;A=f[v>>2]|0;F=A&255;if(A>>>0>127){y=ra;Z=F;G=A;qa=((A|0)<0)<<31>>31;while(1){b[y>>0]=Z|-128;A=G;G=aJc(G|0,qa|0,7)|0;B=y+1|0;ta=G&255;if(!(qa>>>0>0|(qa|0)==0&A>>>0>16383)){ub=B;vb=ta;break}else{y=B;Z=ta;qa=J}}}else{ub=ra;vb=F}b[ub>>0]=vb;f[i>>2]=ub+1}break}case 5:{qa=f[c+(s*20|0)+8>>2]|0;if(1<<(qa&31)&f[a+(qa>>>5<<2)>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(qa>>>0>127){y=qa;G=Z;while(1){b[G>>0]=y|128;z=y>>>7;x=G+1|0;if(y>>>0>16383){y=z;G=x}else{wb=x;xb=z;break}}}else{wb=Z;xb=qa}b[wb>>0]=xb;G=v;y=f[G>>2]|0;F=f[G+4>>2]|0;G=wb+1|0;ra=G;b[ra>>0]=y;b[ra+1>>0]=y>>8;b[ra+2>>0]=y>>16;b[ra+3>>0]=y>>24;y=G+4|0;b[y>>0]=F;b[y+1>>0]=F>>8;b[y+2>>0]=F>>16;b[y+3>>0]=F>>24;f[i>>2]=wb+9}break}case 25:{F=v;if(!((f[F>>2]|0)==0&(f[F+4>>2]|0)==0)){F=f[c+(s*20|0)+4>>2]|0;y=f[i>>2]|0;if(F>>>0>127){G=F;ra=y;while(1){b[ra>>0]=G|128;z=G>>>7;x=ra+1|0;if(G>>>0>16383){G=z;ra=x}else{yb=x;zb=z;break}}}else{yb=y;zb=F}b[yb>>0]=zb;ra=v;G=f[ra>>2]|0;qa=f[ra+4>>2]|0;ra=yb+1|0;Z=ra;b[Z>>0]=G;b[Z+1>>0]=G>>8;b[Z+2>>0]=G>>16;b[Z+3>>0]=G>>24;G=ra+4|0;b[G>>0]=qa;b[G+1>>0]=qa>>8;b[G+2>>0]=qa>>16;b[G+3>>0]=qa>>24;f[i>>2]=yb+9}break}case 45:{if((f[v>>2]|0)>0){qa=c+(s*20|0)+4|0;G=v+8|0;ra=0;Z=f[i>>2]|0;do{z=f[qa>>2]|0;if(z>>>0>127){x=z;ta=Z;while(1){b[ta>>0]=x|128;B=x>>>7;A=ta+1|0;if(x>>>0>16383){x=B;ta=A}else{Ab=A;Bb=B;break}}}else{Ab=Z;Bb=z}b[Ab>>0]=Bb;ta=(f[G>>2]|0)+8+(ra<<3)|0;x=f[ta>>2]|0;M=f[ta+4>>2]|0;ta=Ab+1|0;B=ta;b[B>>0]=x;b[B+1>>0]=x>>8;b[B+2>>0]=x>>16;b[B+3>>0]=x>>24;x=ta+4|0;b[x>>0]=M;b[x+1>>0]=M>>8;b[x+2>>0]=M>>16;b[x+3>>0]=M>>24;Z=Ab+9|0;f[i>>2]=Z;ra=ra+1|0}while((ra|0)<(f[v>>2]|0))}break}case 65:{if(f[v>>2]|0){ra=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(ra>>>0>127){G=ra;qa=Z;while(1){b[qa>>0]=G|128;F=G>>>7;y=qa+1|0;if(G>>>0>16383){G=F;qa=y}else{Cb=y;Db=F;break}}}else{Cb=Z;Db=ra}b[Cb>>0]=Db;qa=Cb+1|0;f[i>>2]=qa;G=f[v+12>>2]|0;if(G>>>0>127){F=G;y=qa;while(1){b[y>>0]=F|128;M=F>>>7;x=y+1|0;if(F>>>0>16383){F=M;y=x}else{Eb=x;Fb=M;break}}}else{Eb=qa;Fb=G}b[Eb>>0]=Fb;y=Eb+1|0;f[i>>2]=y;if((f[v>>2]|0)>0){F=v+8|0;ra=0;Z=y;do{y=(f[F>>2]|0)+8+(ra<<3)|0;M=f[y>>2]|0;x=f[y+4>>2]|0;y=Z;ta=y;b[ta>>0]=M;b[ta+1>>0]=M>>8;b[ta+2>>0]=M>>16;b[ta+3>>0]=M>>24;M=y+4|0;b[M>>0]=x;b[M+1>>0]=x>>8;b[M+2>>0]=x>>16;b[M+3>>0]=x>>24;Z=Z+8|0;f[i>>2]=Z;ra=ra+1|0}while((ra|0)<(f[v>>2]|0))}}break}case 85:{ra=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(ra>>>3|0)){Z=f[i>>2]|0;if(ra>>>0>127){F=ra;G=Z;while(1){b[G>>0]=F|128;qa=F>>>7;x=G+1|0;if(F>>>0>16383){F=qa;G=x}else{Gb=x;Hb=qa;break}}}else{Gb=Z;Hb=ra}b[Gb>>0]=Hb;G=v;F=f[G>>2]|0;qa=f[G+4>>2]|0;G=Gb+1|0;x=G;b[x>>0]=F;b[x+1>>0]=F>>8;b[x+2>>0]=F>>16;b[x+3>>0]=F>>24;F=G+4|0;b[F>>0]=qa;b[F+1>>0]=qa>>8;b[F+2>>0]=qa>>16;b[F+3>>0]=qa>>24;f[i>>2]=Gb+9}break}case 6:{qa=f[c+(s*20|0)+8>>2]|0;if(1<<(qa&31)&f[a+(qa>>>5<<2)>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;F=f[i>>2]|0;if(qa>>>0>127){G=qa;x=F;while(1){b[x>>0]=G|128;M=G>>>7;y=x+1|0;if(G>>>0>16383){G=M;x=y}else{Ib=y;Jb=M;break}}}else{Ib=F;Jb=qa}b[Ib>>0]=Jb;x=Ib+1|0;G=f[v>>2]|0;b[x>>0]=G;b[x+1>>0]=G>>8;b[x+2>>0]=G>>16;b[x+3>>0]=G>>24;f[i>>2]=Ib+5}break}case 26:{if(f[v>>2]|0){G=f[c+(s*20|0)+4>>2]|0;x=f[i>>2]|0;if(G>>>0>127){ra=G;Z=x;while(1){b[Z>>0]=ra|128;M=ra>>>7;y=Z+1|0;if(ra>>>0>16383){ra=M;Z=y}else{Kb=y;Lb=M;break}}}else{Kb=x;Lb=G}b[Kb>>0]=Lb;Z=Kb+1|0;ra=f[v>>2]|0;b[Z>>0]=ra;b[Z+1>>0]=ra>>8;b[Z+2>>0]=ra>>16;b[Z+3>>0]=ra>>24;f[i>>2]=Kb+5}break}case 46:{if((f[v>>2]|0)>0){ra=c+(s*20|0)+4|0;Z=v+8|0;qa=0;F=f[i>>2]|0;do{M=f[ra>>2]|0;if(M>>>0>127){y=M;ta=F;while(1){b[ta>>0]=y|128;B=y>>>7;A=ta+1|0;if(y>>>0>16383){y=B;ta=A}else{Mb=A;Nb=B;break}}}else{Mb=F;Nb=M}b[Mb>>0]=Nb;ta=Mb+1|0;y=f[(f[Z>>2]|0)+4+(qa<<2)>>2]|0;b[ta>>0]=y;b[ta+1>>0]=y>>8;b[ta+2>>0]=y>>16;b[ta+3>>0]=y>>24;F=Mb+5|0;f[i>>2]=F;qa=qa+1|0}while((qa|0)<(f[v>>2]|0))}break}case 66:{if(f[v>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;F=f[i>>2]|0;if(qa>>>0>127){Z=qa;ra=F;while(1){b[ra>>0]=Z|128;G=Z>>>7;x=ra+1|0;if(Z>>>0>16383){Z=G;ra=x}else{Ob=x;Pb=G;break}}}else{Ob=F;Pb=qa}b[Ob>>0]=Pb;ra=Ob+1|0;f[i>>2]=ra;Z=f[v+12>>2]|0;if(Z>>>0>127){G=Z;x=ra;while(1){b[x>>0]=G|128;y=G>>>7;ta=x+1|0;if(G>>>0>16383){G=y;x=ta}else{Qb=ta;Rb=y;break}}}else{Qb=ra;Rb=Z}b[Qb>>0]=Rb;x=Qb+1|0;f[i>>2]=x;if((f[v>>2]|0)>0){G=v+8|0;qa=0;F=x;do{x=f[(f[G>>2]|0)+4+(qa<<2)>>2]|0;b[F>>0]=x;b[F+1>>0]=x>>8;b[F+2>>0]=x>>16;b[F+3>>0]=x>>24;F=F+4|0;f[i>>2]=F;qa=qa+1|0}while((qa|0)<(f[v>>2]|0))}}break}case 86:{qa=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(qa>>>3|0)){F=f[i>>2]|0;if(qa>>>0>127){G=qa;Z=F;while(1){b[Z>>0]=G|128;ra=G>>>7;x=Z+1|0;if(G>>>0>16383){G=ra;Z=x}else{Sb=x;Tb=ra;break}}}else{Sb=F;Tb=qa}b[Sb>>0]=Tb;Z=Sb+1|0;G=f[v>>2]|0;b[Z>>0]=G;b[Z+1>>0]=G>>8;b[Z+2>>0]=G>>16;b[Z+3>>0]=G>>24;f[i>>2]=Sb+5}break}case 7:{G=f[c+(s*20|0)+8>>2]|0;if(1<<(G&31)&f[a+(G>>>5<<2)>>2]|0){G=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(G>>>0>127){ra=G;x=Z;while(1){b[x>>0]=ra|128;y=ra>>>7;ta=x+1|0;if(ra>>>0>16383){ra=y;x=ta}else{Ub=ta;Vb=y;break}}}else{Ub=Z;Vb=G}b[Ub>>0]=Vb;b[Ub+1>>0]=b[v>>0]|0;f[i>>2]=Ub+2}break}case 27:{if(b[v>>0]|0){x=f[c+(s*20|0)+4>>2]|0;ra=f[i>>2]|0;if(x>>>0>127){qa=x;F=ra;while(1){b[F>>0]=qa|128;y=qa>>>7;ta=F+1|0;if(qa>>>0>16383){qa=y;F=ta}else{Wb=ta;Xb=y;break}}}else{Wb=ra;Xb=x}b[Wb>>0]=Xb;b[Wb+1>>0]=b[v>>0]|0;f[i>>2]=Wb+2}break}case 47:{if((f[v>>2]|0)>0){F=c+(s*20|0)+4|0;qa=v+8|0;G=0;Z=f[i>>2]|0;do{y=f[F>>2]|0;if(y>>>0>127){ta=y;z=Z;while(1){b[z>>0]=ta|128;B=ta>>>7;A=z+1|0;if(ta>>>0>16383){ta=B;z=A}else{Yb=A;Zb=B;break}}}else{Yb=Z;Zb=y}b[Yb>>0]=Zb;b[Yb+1>>0]=b[(f[qa>>2]|0)+4+G>>0]|0;Z=Yb+2|0;f[i>>2]=Z;G=G+1|0}while((G|0)<(f[v>>2]|0))}break}case 67:{if(f[v>>2]|0){G=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(G>>>0>127){qa=G;F=Z;while(1){b[F>>0]=qa|128;x=qa>>>7;ra=F+1|0;if(qa>>>0>16383){qa=x;F=ra}else{_b=ra;$b=x;break}}}else{_b=Z;$b=G}b[_b>>0]=$b;F=_b+1|0;f[i>>2]=F;qa=f[v+12>>2]|0;if(qa>>>0>127){x=qa;ra=F;while(1){b[ra>>0]=x|128;z=x>>>7;ta=ra+1|0;if(x>>>0>16383){x=z;ra=ta}else{ac=ta;bc=z;break}}}else{ac=F;bc=qa}b[ac>>0]=bc;ra=ac+1|0;f[i>>2]=ra;if((f[v>>2]|0)>0){x=v+8|0;G=0;Z=ra;do{b[Z>>0]=b[(f[x>>2]|0)+4+G>>0]|0;Z=Z+1|0;f[i>>2]=Z;G=G+1|0}while((G|0)<(f[v>>2]|0))}}break}case 87:{G=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(G>>>3|0)){Z=f[i>>2]|0;if(G>>>0>127){x=G;qa=Z;while(1){b[qa>>0]=x|128;F=x>>>7;ra=qa+1|0;if(x>>>0>16383){x=F;qa=ra}else{cc=ra;dc=F;break}}}else{cc=Z;dc=G}b[cc>>0]=dc;b[cc+1>>0]=b[v>>0]|0;f[i>>2]=cc+2}break}case 8:{qa=f[c+(s*20|0)+8>>2]|0;if(1<<(qa&31)&f[a+(qa>>>5<<2)>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;x=f[i>>2]|0;if(qa>>>0>127){F=qa;ra=x;while(1){b[ra>>0]=F|128;z=F>>>7;ta=ra+1|0;if(F>>>0>16383){F=z;ra=ta}else{ec=ta;fc=z;break}}}else{ec=x;fc=qa}b[ec>>0]=fc;ra=ec+1|0;f[i>>2]=ra;F=dSb(f[v>>2]|0,ra)|0;f[i>>2]=F}break}case 28:{F=f[v>>2]|0;ra=b[F+11>>0]|0;if(ra<<24>>24<0)gc=f[F+4>>2]|0;else gc=ra&255;if(gc|0){ra=f[c+(s*20|0)+4>>2]|0;F=f[i>>2]|0;if(ra>>>0>127){G=ra;Z=F;while(1){b[Z>>0]=G|128;z=G>>>7;ta=Z+1|0;if(G>>>0>16383){G=z;Z=ta}else{hc=ta;ic=z;break}}}else{hc=F;ic=ra}b[hc>>0]=ic;Z=hc+1|0;f[i>>2]=Z;G=dSb(f[v>>2]|0,Z)|0;f[i>>2]=G}break}case 48:{G=v+4|0;if((f[G>>2]|0)>0){Z=c+(s*20|0)+4|0;qa=v+12|0;x=0;z=f[i>>2]|0;do{ta=f[Z>>2]|0;if(ta>>>0>127){M=ta;B=z;while(1){b[B>>0]=M|128;A=M>>>7;sa=B+1|0;if(M>>>0>16383){M=A;B=sa}else{jc=sa;kc=A;break}}}else{jc=z;kc=ta}b[jc>>0]=kc;B=jc+1|0;f[i>>2]=B;M=f[qa>>2]|0;z=dSb(f[((M|0)==0?0:M+4|0)+(x<<2)>>2]|0,B)|0;f[i>>2]=z;x=x+1|0}while((x|0)<(f[G>>2]|0))}break}case 68:{CRb(v,t,i);break}case 88:{G=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(G>>>3|0)){x=f[i>>2]|0;if(G>>>0>127){z=G;qa=x;while(1){b[qa>>0]=z|128;Z=z>>>7;ra=qa+1|0;if(z>>>0>16383){z=Z;qa=ra}else{lc=ra;mc=Z;break}}}else{lc=x;mc=G}b[lc>>0]=mc;qa=lc+1|0;f[i>>2]=qa;z=dSb(f[v>>2]|0,qa)|0;f[i>>2]=z}break}case 9:{z=f[c+(s*20|0)+8>>2]|0;if(1<<(z&31)&f[a+(z>>>5<<2)>>2]|0){z=c+(s*20|0)+4|0;qa=f[z>>2]|0;Z=f[i>>2]|0;if(qa>>>0>127){ra=qa;F=Z;while(1){b[F>>0]=ra|128;B=ra>>>7;M=F+1|0;if(ra>>>0>16383){ra=B;F=M}else{nc=M;oc=B;break}}}else{nc=Z;oc=qa}b[nc>>0]=oc;F=nc+1|0;f[i>>2]=F;ra=f[v>>2]|0;G=f[c+(s*20|0)+16>>2]|0;if(!G)pc=hj[f[(f[ra>>2]|0)+64>>2]&511](ra,(b[g>>0]|0)!=0,F)|0;else pc=BRb(ra,(f[G+4>>2]|0)+20|0,(f[G>>2]|0)+-1|0,(b[g>>0]|0)!=0,F)|0;f[i>>2]=pc;F=(f[z>>2]|0)+1|0;if(F>>>0>127){G=F;ra=pc;while(1){b[ra>>0]=G|128;x=G>>>7;B=ra+1|0;if(G>>>0>16383){G=x;ra=B}else{qc=B;rc=x;break}}}else{qc=pc;rc=F}b[qc>>0]=rc;f[i>>2]=qc+1}break}case 29:{if(f[v>>2]|0){ra=c+(s*20|0)+4|0;G=f[ra>>2]|0;z=f[i>>2]|0;if(G>>>0>127){qa=G;Z=z;while(1){b[Z>>0]=qa|128;x=qa>>>7;B=Z+1|0;if(qa>>>0>16383){qa=x;Z=B}else{sc=B;tc=x;break}}}else{sc=z;tc=G}b[sc>>0]=tc;Z=sc+1|0;f[i>>2]=Z;qa=f[v>>2]|0;F=f[c+(s*20|0)+16>>2]|0;if(!F)uc=hj[f[(f[qa>>2]|0)+64>>2]&511](qa,(b[g>>0]|0)!=0,Z)|0;else uc=BRb(qa,(f[F+4>>2]|0)+20|0,(f[F>>2]|0)+-1|0,(b[g>>0]|0)!=0,Z)|0;f[i>>2]=uc;Z=(f[ra>>2]|0)+1|0;if(Z>>>0>127){F=Z;qa=uc;while(1){b[qa>>0]=F|128;x=F>>>7;B=qa+1|0;if(F>>>0>16383){F=x;qa=B}else{vc=B;wc=x;break}}}else{vc=uc;wc=Z}b[vc>>0]=wc;f[i>>2]=vc+1}break}case 49:{qa=v+4|0;if((f[qa>>2]|0)>0){F=c+(s*20|0)+4|0;ra=v+12|0;G=c+(s*20|0)+16|0;z=0;do{x=f[F>>2]|0;B=f[i>>2]|0;if(x>>>0>127){M=x;y=B;while(1){b[y>>0]=M|128;A=M>>>7;sa=y+1|0;if(M>>>0>16383){M=A;y=sa}else{xc=sa;yc=A;break}}}else{xc=B;yc=x}b[xc>>0]=yc;y=xc+1|0;f[i>>2]=y;M=f[ra>>2]|0;ta=f[((M|0)==0?0:M+4|0)+(z<<2)>>2]|0;M=f[G>>2]|0;if(!M)zc=hj[f[(f[ta>>2]|0)+64>>2]&511](ta,(b[g>>0]|0)!=0,y)|0;else zc=BRb(ta,(f[M+4>>2]|0)+20|0,(f[M>>2]|0)+-1|0,(b[g>>0]|0)!=0,y)|0;f[i>>2]=zc;y=(f[F>>2]|0)+1|0;if(y>>>0>127){M=y;ta=zc;while(1){b[ta>>0]=M|128;A=M>>>7;sa=ta+1|0;if(M>>>0>16383){M=A;ta=sa}else{Ac=sa;Bc=A;break}}}else{Ac=zc;Bc=y}b[Ac>>0]=Bc;f[i>>2]=Ac+1;z=z+1|0}while((z|0)<(f[qa>>2]|0))}break}case 69:{CRb(v,t,i);break}case 89:{qa=c+(s*20|0)+4|0;z=f[qa>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(z>>>3|0)){F=f[i>>2]|0;if(z>>>0>127){G=z;ra=F;while(1){b[ra>>0]=G|128;Z=G>>>7;ta=ra+1|0;if(G>>>0>16383){G=Z;ra=ta}else{Cc=ta;Dc=Z;break}}}else{Cc=F;Dc=z}b[Cc>>0]=Dc;ra=Cc+1|0;f[i>>2]=ra;G=f[v>>2]|0;Z=f[c+(s*20|0)+16>>2]|0;if(!Z)Ec=hj[f[(f[G>>2]|0)+64>>2]&511](G,(b[g>>0]|0)!=0,ra)|0;else Ec=BRb(G,(f[Z+4>>2]|0)+20|0,(f[Z>>2]|0)+-1|0,(b[g>>0]|0)!=0,ra)|0;f[i>>2]=Ec;ra=(f[qa>>2]|0)+1|0;if(ra>>>0>127){Z=ra;G=Ec;while(1){b[G>>0]=Z|128;ta=Z>>>7;M=G+1|0;if(Z>>>0>16383){Z=ta;G=M}else{Fc=M;Gc=ta;break}}}else{Fc=Ec;Gc=ra}b[Fc>>0]=Gc;f[i>>2]=Fc+1}break}case 10:{G=f[c+(s*20|0)+8>>2]|0;if(1<<(G&31)&f[a+(G>>>5<<2)>>2]|0){G=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(G>>>0>127){qa=G;z=Z;while(1){b[z>>0]=qa|128;F=qa>>>7;ta=z+1|0;if(qa>>>0>16383){qa=F;z=ta}else{Hc=ta;Ic=F;break}}}else{Hc=Z;Ic=G}b[Hc>>0]=Ic;z=Hc+1|0;f[i>>2]=z;qa=f[v>>2]|0;ra=f[c+(s*20|0)+16>>2]|0;if(!ra){F=_i[f[(f[qa>>2]|0)+60>>2]&1023](qa)|0;ta=f[i>>2]|0;if(F>>>0>127){M=F;x=ta;while(1){b[x>>0]=M|128;B=M>>>7;A=x+1|0;if(M>>>0>16383){M=B;x=A}else{Jc=A;Kc=B;break}}}else{Jc=ta;Kc=F}b[Jc>>0]=Kc;x=Jc+1|0;f[i>>2]=x;M=hj[f[(f[qa>>2]|0)+64>>2]&511](qa,(b[g>>0]|0)!=0,x)|0;f[i>>2]=M;break a}else{M=f[ra+4>>2]|0;x=f[qa+(f[M>>2]|0)>>2]|0;if(x>>>0>127){G=x;Z=z;while(1){b[Z>>0]=G|128;B=G>>>7;A=Z+1|0;if(G>>>0>16383){G=B;Z=A}else{Lc=A;Mc=B;break}}}else{Lc=z;Mc=x}b[Lc>>0]=Mc;Z=Lc+1|0;f[i>>2]=Z;G=BRb(qa,M+20|0,(f[ra>>2]|0)+-1|0,(b[g>>0]|0)!=0,Z)|0;f[i>>2]=G;break a}}break}case 30:{if(f[v>>2]|0){G=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(G>>>0>127){F=G;ta=Z;while(1){b[ta>>0]=F|128;B=F>>>7;A=ta+1|0;if(F>>>0>16383){F=B;ta=A}else{Nc=A;Oc=B;break}}}else{Nc=Z;Oc=G}b[Nc>>0]=Oc;ta=Nc+1|0;f[i>>2]=ta;F=f[v>>2]|0;ra=f[c+(s*20|0)+16>>2]|0;if(!ra){M=_i[f[(f[F>>2]|0)+60>>2]&1023](F)|0;qa=f[i>>2]|0;if(M>>>0>127){x=M;z=qa;while(1){b[z>>0]=x|128;B=x>>>7;A=z+1|0;if(x>>>0>16383){x=B;z=A}else{Pc=A;Qc=B;break}}}else{Pc=qa;Qc=M}b[Pc>>0]=Qc;z=Pc+1|0;f[i>>2]=z;x=hj[f[(f[F>>2]|0)+64>>2]&511](F,(b[g>>0]|0)!=0,z)|0;f[i>>2]=x;break a}else{x=f[ra+4>>2]|0;z=f[F+(f[x>>2]|0)>>2]|0;if(z>>>0>127){G=z;Z=ta;while(1){b[Z>>0]=G|128;B=G>>>7;A=Z+1|0;if(G>>>0>16383){G=B;Z=A}else{Rc=A;Sc=B;break}}}else{Rc=ta;Sc=z}b[Rc>>0]=Sc;Z=Rc+1|0;f[i>>2]=Z;G=BRb(F,x+20|0,(f[ra>>2]|0)+-1|0,(b[g>>0]|0)!=0,Z)|0;f[i>>2]=G;break a}}break}case 50:{G=v+4|0;if((f[G>>2]|0)>0){Z=c+(s*20|0)+4|0;M=v+12|0;qa=c+(s*20|0)+16|0;B=0;do{A=f[Z>>2]|0;sa=f[i>>2]|0;if(A>>>0>127){K=A;L=sa;while(1){b[L>>0]=K|128;C=K>>>7;Tc=L+1|0;if(K>>>0>16383){K=C;L=Tc}else{Uc=Tc;Vc=C;break}}}else{Uc=sa;Vc=A}b[Uc>>0]=Vc;L=Uc+1|0;f[i>>2]=L;K=f[M>>2]|0;y=f[((K|0)==0?0:K+4|0)+(B<<2)>>2]|0;K=f[qa>>2]|0;if(!K){C=_i[f[(f[y>>2]|0)+60>>2]&1023](y)|0;Tc=f[i>>2]|0;if(C>>>0>127){Wc=C;Xc=Tc;while(1){b[Xc>>0]=Wc|128;Yc=Wc>>>7;Zc=Xc+1|0;if(Wc>>>0>16383){Wc=Yc;Xc=Zc}else{_c=Zc;$c=Yc;break}}}else{_c=Tc;$c=C}b[_c>>0]=$c;Xc=_c+1|0;f[i>>2]=Xc;ad=hj[f[(f[y>>2]|0)+64>>2]&511](y,(b[g>>0]|0)!=0,Xc)|0}else{Xc=f[K+4>>2]|0;Wc=f[y+(f[Xc>>2]|0)>>2]|0;if(Wc>>>0>127){A=Wc;sa=L;while(1){b[sa>>0]=A|128;Yc=A>>>7;Zc=sa+1|0;if(A>>>0>16383){A=Yc;sa=Zc}else{bd=Zc;cd=Yc;break}}}else{bd=L;cd=Wc}b[bd>>0]=cd;sa=bd+1|0;f[i>>2]=sa;ad=BRb(y,Xc+20|0,(f[K>>2]|0)+-1|0,(b[g>>0]|0)!=0,sa)|0}f[i>>2]=ad;B=B+1|0}while((B|0)<(f[G>>2]|0))}break}case 70:{CRb(v,t,i);break}case 90:{G=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(G>>>3|0)){B=f[i>>2]|0;if(G>>>0>127){qa=G;M=B;while(1){b[M>>0]=qa|128;Z=qa>>>7;ra=M+1|0;if(qa>>>0>16383){qa=Z;M=ra}else{dd=ra;ed=Z;break}}}else{dd=B;ed=G}b[dd>>0]=ed;M=dd+1|0;f[i>>2]=M;qa=f[v>>2]|0;Z=f[c+(s*20|0)+16>>2]|0;if(!Z){ra=_i[f[(f[qa>>2]|0)+60>>2]&1023](qa)|0;x=f[i>>2]|0;if(ra>>>0>127){F=ra;z=x;while(1){b[z>>0]=F|128;ta=F>>>7;sa=z+1|0;if(F>>>0>16383){F=ta;z=sa}else{fd=sa;gd=ta;break}}}else{fd=x;gd=ra}b[fd>>0]=gd;z=fd+1|0;f[i>>2]=z;F=hj[f[(f[qa>>2]|0)+64>>2]&511](qa,(b[g>>0]|0)!=0,z)|0;f[i>>2]=F;break a}else{F=f[Z+4>>2]|0;z=f[qa+(f[F>>2]|0)>>2]|0;if(z>>>0>127){G=z;B=M;while(1){b[B>>0]=G|128;ta=G>>>7;sa=B+1|0;if(G>>>0>16383){G=ta;B=sa}else{hd=sa;id=ta;break}}}else{hd=M;id=z}b[hd>>0]=id;B=hd+1|0;f[i>>2]=B;G=BRb(qa,F+20|0,(f[Z>>2]|0)+-1|0,(b[g>>0]|0)!=0,B)|0;f[i>>2]=G;break a}}break}case 11:{G=f[c+(s*20|0)+8>>2]|0;if(1<<(G&31)&f[a+(G>>>5<<2)>>2]|0){G=f[c+(s*20|0)+4>>2]|0;B=f[i>>2]|0;if(G>>>0>127){ra=G;x=B;while(1){b[x>>0]=ra|128;ta=ra>>>7;sa=x+1|0;if(ra>>>0>16383){ra=ta;x=sa}else{jd=sa;kd=ta;break}}}else{jd=B;kd=G}b[jd>>0]=kd;x=jd+1|0;f[i>>2]=x;ra=dSb(f[v>>2]|0,x)|0;f[i>>2]=ra}break}case 31:{ra=f[v>>2]|0;x=b[ra+11>>0]|0;if(x<<24>>24<0)ld=f[ra+4>>2]|0;else ld=x&255;if(ld|0){x=f[c+(s*20|0)+4>>2]|0;ra=f[i>>2]|0;if(x>>>0>127){Z=x;F=ra;while(1){b[F>>0]=Z|128;qa=Z>>>7;z=F+1|0;if(Z>>>0>16383){Z=qa;F=z}else{md=z;nd=qa;break}}}else{md=ra;nd=x}b[md>>0]=nd;F=md+1|0;f[i>>2]=F;Z=dSb(f[v>>2]|0,F)|0;f[i>>2]=Z}break}case 51:{Z=v+4|0;if((f[Z>>2]|0)>0){F=c+(s*20|0)+4|0;G=v+12|0;B=0;qa=f[i>>2]|0;do{z=f[F>>2]|0;if(z>>>0>127){M=z;ta=qa;while(1){b[ta>>0]=M|128;sa=M>>>7;A=ta+1|0;if(M>>>0>16383){M=sa;ta=A}else{od=A;pd=sa;break}}}else{od=qa;pd=z}b[od>>0]=pd;ta=od+1|0;f[i>>2]=ta;M=f[G>>2]|0;qa=dSb(f[((M|0)==0?0:M+4|0)+(B<<2)>>2]|0,ta)|0;f[i>>2]=qa;B=B+1|0}while((B|0)<(f[Z>>2]|0))}break}case 71:{CRb(v,t,i);break}case 91:{Z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(Z>>>3|0)){B=f[i>>2]|0;if(Z>>>0>127){qa=Z;G=B;while(1){b[G>>0]=qa|128;F=qa>>>7;x=G+1|0;if(qa>>>0>16383){qa=F;G=x}else{qd=x;rd=F;break}}}else{qd=B;rd=Z}b[qd>>0]=rd;G=qd+1|0;f[i>>2]=G;qa=dSb(f[v>>2]|0,G)|0;f[i>>2]=qa}break}case 12:{qa=f[c+(s*20|0)+8>>2]|0;if(1<<(qa&31)&f[a+(qa>>>5<<2)>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;G=f[i>>2]|0;if(qa>>>0>127){F=qa;x=G;while(1){b[x>>0]=F|128;ra=F>>>7;ta=x+1|0;if(F>>>0>16383){F=ra;x=ta}else{sd=ta;td=ra;break}}}else{sd=G;td=qa}b[sd>>0]=td;x=sd+1|0;f[i>>2]=x;F=f[v>>2]|0;if(F>>>0>127){Z=F;B=x;while(1){b[B>>0]=Z|128;ra=Z>>>7;ta=B+1|0;if(Z>>>0>16383){Z=ra;B=ta}else{ud=ta;vd=ra;break}}}else{ud=x;vd=F}b[ud>>0]=vd;f[i>>2]=ud+1}break}case 32:{if(f[v>>2]|0){B=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(B>>>0>127){qa=B;G=Z;while(1){b[G>>0]=qa|128;ra=qa>>>7;ta=G+1|0;if(qa>>>0>16383){qa=ra;G=ta}else{wd=ta;xd=ra;break}}}else{wd=Z;xd=B}b[wd>>0]=xd;G=wd+1|0;f[i>>2]=G;qa=f[v>>2]|0;if(qa>>>0>127){F=qa;x=G;while(1){b[x>>0]=F|128;ra=F>>>7;ta=x+1|0;if(F>>>0>16383){F=ra;x=ta}else{yd=ta;zd=ra;break}}}else{yd=G;zd=qa}b[yd>>0]=zd;f[i>>2]=yd+1}break}case 52:{if((f[v>>2]|0)>0){x=c+(s*20|0)+4|0;F=v+8|0;B=0;Z=f[i>>2]|0;do{ra=f[x>>2]|0;if(ra>>>0>127){ta=ra;M=Z;while(1){b[M>>0]=ta|128;K=ta>>>7;Xc=M+1|0;if(ta>>>0>16383){ta=K;M=Xc}else{Ad=Xc;Bd=K;break}}}else{Ad=Z;Bd=ra}b[Ad>>0]=Bd;M=Ad+1|0;f[i>>2]=M;ta=f[(f[F>>2]|0)+4+(B<<2)>>2]|0;if(ta>>>0>127){z=ta;K=M;while(1){b[K>>0]=z|128;Xc=z>>>7;y=K+1|0;if(z>>>0>16383){z=Xc;K=y}else{Cd=y;Dd=Xc;break}}}else{Cd=M;Dd=ta}b[Cd>>0]=Dd;Z=Cd+1|0;f[i>>2]=Z;B=B+1|0}while((B|0)<(f[v>>2]|0))}break}case 72:{if(f[v>>2]|0){B=f[c+(s*20|0)+4>>2]|0;Z=f[i>>2]|0;if(B>>>0>127){F=B;x=Z;while(1){b[x>>0]=F|128;qa=F>>>7;G=x+1|0;if(F>>>0>16383){F=qa;x=G}else{Ed=G;Fd=qa;break}}}else{Ed=Z;Fd=B}b[Ed>>0]=Fd;x=Ed+1|0;f[i>>2]=x;F=f[v+12>>2]|0;if(F>>>0>127){qa=F;G=x;while(1){b[G>>0]=qa|128;K=qa>>>7;z=G+1|0;if(qa>>>0>16383){qa=K;G=z}else{Gd=z;Hd=K;break}}}else{Gd=x;Hd=F}b[Gd>>0]=Hd;G=Gd+1|0;f[i>>2]=G;if((f[v>>2]|0)>0){qa=v+8|0;B=0;Z=G;do{G=f[(f[qa>>2]|0)+4+(B<<2)>>2]|0;if(G>>>0>127){K=G;z=Z;while(1){b[z>>0]=K|128;ra=K>>>7;Xc=z+1|0;if(K>>>0>16383){K=ra;z=Xc}else{Id=Xc;Jd=ra;break}}}else{Id=Z;Jd=G}b[Id>>0]=Jd;Z=Id+1|0;f[i>>2]=Z;B=B+1|0}while((B|0)<(f[v>>2]|0))}}break}case 92:{B=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(B>>>3|0)){Z=f[i>>2]|0;if(B>>>0>127){qa=B;F=Z;while(1){b[F>>0]=qa|128;x=qa>>>7;z=F+1|0;if(qa>>>0>16383){qa=x;F=z}else{Kd=z;Ld=x;break}}}else{Kd=Z;Ld=B}b[Kd>>0]=Ld;F=Kd+1|0;f[i>>2]=F;qa=f[v>>2]|0;if(qa>>>0>127){x=qa;z=F;while(1){b[z>>0]=x|128;K=x>>>7;ta=z+1|0;if(x>>>0>16383){x=K;z=ta}else{Md=ta;Nd=K;break}}}else{Md=F;Nd=qa}b[Md>>0]=Nd;f[i>>2]=Md+1}break}case 13:{z=f[c+(s*20|0)+8>>2]|0;if(1<<(z&31)&f[a+(z>>>5<<2)>>2]|0){z=f[c+(s*20|0)+4>>2]|0;x=f[i>>2]|0;if(z>>>0>127){B=z;Z=x;while(1){b[Z>>0]=B|128;K=B>>>7;ta=Z+1|0;if(B>>>0>16383){B=K;Z=ta}else{Od=ta;Pd=K;break}}}else{Od=x;Pd=z}b[Od>>0]=Pd;Z=Od+1|0;f[i>>2]=Z;B=f[v>>2]|0;qa=B&255;if(B>>>0>127){F=Z;K=qa;ta=B;M=((B|0)<0)<<31>>31;while(1){b[F>>0]=K|-128;B=ta;ta=aJc(ta|0,M|0,7)|0;ra=F+1|0;Xc=ta&255;if(!(M>>>0>0|(M|0)==0&B>>>0>16383)){Qd=ra;Rd=Xc;break}else{F=ra;K=Xc;M=J}}}else{Qd=Z;Rd=qa}b[Qd>>0]=Rd;f[i>>2]=Qd+1}break}case 33:{if(f[v>>2]|0){M=f[c+(s*20|0)+4>>2]|0;K=f[i>>2]|0;if(M>>>0>127){F=M;ta=K;while(1){b[ta>>0]=F|128;z=F>>>7;x=ta+1|0;if(F>>>0>16383){F=z;ta=x}else{Sd=x;Td=z;break}}}else{Sd=K;Td=M}b[Sd>>0]=Td;ta=Sd+1|0;f[i>>2]=ta;F=f[v>>2]|0;qa=F&255;if(F>>>0>127){Z=ta;z=qa;x=F;Xc=((F|0)<0)<<31>>31;while(1){b[Z>>0]=z|-128;F=x;x=aJc(x|0,Xc|0,7)|0;ra=Z+1|0;B=x&255;if(!(Xc>>>0>0|(Xc|0)==0&F>>>0>16383)){Ud=ra;Vd=B;break}else{Z=ra;z=B;Xc=J}}}else{Ud=ta;Vd=qa}b[Ud>>0]=Vd;f[i>>2]=Ud+1}break}case 53:{if((f[v>>2]|0)>0){Xc=c+(s*20|0)+4|0;z=v+8|0;Z=0;x=f[i>>2]|0;do{M=f[Xc>>2]|0;if(M>>>0>127){K=M;B=x;while(1){b[B>>0]=K|128;ra=K>>>7;F=B+1|0;if(K>>>0>16383){K=ra;B=F}else{Wd=F;Xd=ra;break}}}else{Wd=x;Xd=M}b[Wd>>0]=Xd;B=Wd+1|0;f[i>>2]=B;K=f[(f[z>>2]|0)+4+(Z<<2)>>2]|0;G=K&255;if(K>>>0>127){ra=B;F=G;y=K;Wc=((K|0)<0)<<31>>31;while(1){b[ra>>0]=F|-128;K=y;y=aJc(y|0,Wc|0,7)|0;L=ra+1|0;sa=y&255;if(!(Wc>>>0>0|(Wc|0)==0&K>>>0>16383)){Yd=L;Zd=sa;break}else{ra=L;F=sa;Wc=J}}}else{Yd=B;Zd=G}b[Yd>>0]=Zd;x=Yd+1|0;f[i>>2]=x;Z=Z+1|0}while((Z|0)<(f[v>>2]|0))}break}case 73:{if(f[v>>2]|0){Z=f[c+(s*20|0)+4>>2]|0;x=f[i>>2]|0;if(Z>>>0>127){z=Z;Xc=x;while(1){b[Xc>>0]=z|128;qa=z>>>7;ta=Xc+1|0;if(z>>>0>16383){z=qa;Xc=ta}else{_d=ta;$d=qa;break}}}else{_d=x;$d=Z}b[_d>>0]=$d;Xc=_d+1|0;f[i>>2]=Xc;z=f[v+12>>2]|0;if(z>>>0>127){qa=z;ta=Xc;while(1){b[ta>>0]=qa|128;Wc=qa>>>7;F=ta+1|0;if(qa>>>0>16383){qa=Wc;ta=F}else{ae=F;be=Wc;break}}}else{ae=Xc;be=z}b[ae>>0]=be;ta=ae+1|0;f[i>>2]=ta;if((f[v>>2]|0)>0){qa=v+8|0;Z=0;x=ta;do{ta=f[(f[qa>>2]|0)+4+(Z<<2)>>2]|0;Wc=ta&255;if(ta>>>0>127){F=x;ra=Wc;y=ta;M=((ta|0)<0)<<31>>31;while(1){b[F>>0]=ra|-128;ta=y;y=aJc(y|0,M|0,7)|0;sa=F+1|0;L=y&255;if(!(M>>>0>0|(M|0)==0&ta>>>0>16383)){ce=sa;de=L;break}else{F=sa;ra=L;M=J}}}else{ce=x;de=Wc}b[ce>>0]=de;x=ce+1|0;f[i>>2]=x;Z=Z+1|0}while((Z|0)<(f[v>>2]|0))}}break}case 93:{Z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(Z>>>3|0)){x=f[i>>2]|0;if(Z>>>0>127){qa=Z;z=x;while(1){b[z>>0]=qa|128;Xc=qa>>>7;M=z+1|0;if(qa>>>0>16383){qa=Xc;z=M}else{ee=M;fe=Xc;break}}}else{ee=x;fe=Z}b[ee>>0]=fe;z=ee+1|0;f[i>>2]=z;qa=f[v>>2]|0;Xc=qa&255;if(qa>>>0>127){M=z;ra=Xc;F=qa;y=((qa|0)<0)<<31>>31;while(1){b[M>>0]=ra|-128;qa=F;F=aJc(F|0,y|0,7)|0;G=M+1|0;B=F&255;if(!(y>>>0>0|(y|0)==0&qa>>>0>16383)){ge=G;he=B;break}else{M=G;ra=B;y=J}}}else{ge=z;he=Xc}b[ge>>0]=he;f[i>>2]=ge+1}break}case 14:{y=f[c+(s*20|0)+8>>2]|0;if(1<<(y&31)&f[a+(y>>>5<<2)>>2]|0){y=f[c+(s*20|0)+4>>2]|0;ra=f[i>>2]|0;if(y>>>0>127){M=y;F=ra;while(1){b[F>>0]=M|128;Z=M>>>7;x=F+1|0;if(M>>>0>16383){M=Z;F=x}else{ie=x;je=Z;break}}}else{ie=ra;je=y}b[ie>>0]=je;F=ie+1|0;M=f[v>>2]|0;b[F>>0]=M;b[F+1>>0]=M>>8;b[F+2>>0]=M>>16;b[F+3>>0]=M>>24;f[i>>2]=ie+5}break}case 34:{if(f[v>>2]|0){M=f[c+(s*20|0)+4>>2]|0;F=f[i>>2]|0;if(M>>>0>127){Xc=M;z=F;while(1){b[z>>0]=Xc|128;Z=Xc>>>7;x=z+1|0;if(Xc>>>0>16383){Xc=Z;z=x}else{ke=x;le=Z;break}}}else{ke=F;le=M}b[ke>>0]=le;z=ke+1|0;Xc=f[v>>2]|0;b[z>>0]=Xc;b[z+1>>0]=Xc>>8;b[z+2>>0]=Xc>>16;b[z+3>>0]=Xc>>24;f[i>>2]=ke+5}break}case 54:{if((f[v>>2]|0)>0){Xc=c+(s*20|0)+4|0;z=v+8|0;y=0;ra=f[i>>2]|0;do{Z=f[Xc>>2]|0;if(Z>>>0>127){x=Z;B=ra;while(1){b[B>>0]=x|128;G=x>>>7;qa=B+1|0;if(x>>>0>16383){x=G;B=qa}else{me=qa;ne=G;break}}}else{me=ra;ne=Z}b[me>>0]=ne;B=me+1|0;x=f[(f[z>>2]|0)+4+(y<<2)>>2]|0;b[B>>0]=x;b[B+1>>0]=x>>8;b[B+2>>0]=x>>16;b[B+3>>0]=x>>24;ra=me+5|0;f[i>>2]=ra;y=y+1|0}while((y|0)<(f[v>>2]|0))}break}case 74:{if(f[v>>2]|0){y=f[c+(s*20|0)+4>>2]|0;ra=f[i>>2]|0;if(y>>>0>127){z=y;Xc=ra;while(1){b[Xc>>0]=z|128;M=z>>>7;F=Xc+1|0;if(z>>>0>16383){z=M;Xc=F}else{oe=F;pe=M;break}}}else{oe=ra;pe=y}b[oe>>0]=pe;Xc=oe+1|0;f[i>>2]=Xc;z=f[v+12>>2]|0;if(z>>>0>127){M=z;F=Xc;while(1){b[F>>0]=M|128;x=M>>>7;B=F+1|0;if(M>>>0>16383){M=x;F=B}else{qe=B;re=x;break}}}else{qe=Xc;re=z}b[qe>>0]=re;F=qe+1|0;f[i>>2]=F;if((f[v>>2]|0)>0){M=v+8|0;y=0;ra=F;do{F=f[(f[M>>2]|0)+4+(y<<2)>>2]|0;b[ra>>0]=F;b[ra+1>>0]=F>>8;b[ra+2>>0]=F>>16;b[ra+3>>0]=F>>24;ra=ra+4|0;f[i>>2]=ra;y=y+1|0}while((y|0)<(f[v>>2]|0))}}break}case 94:{y=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(y>>>3|0)){ra=f[i>>2]|0;if(y>>>0>127){M=y;z=ra;while(1){b[z>>0]=M|128;Xc=M>>>7;F=z+1|0;if(M>>>0>16383){M=Xc;z=F}else{se=F;te=Xc;break}}}else{se=ra;te=y}b[se>>0]=te;z=se+1|0;M=f[v>>2]|0;b[z>>0]=M;b[z+1>>0]=M>>8;b[z+2>>0]=M>>16;b[z+3>>0]=M>>24;f[i>>2]=se+5}break}case 15:{M=f[c+(s*20|0)+8>>2]|0;if(1<<(M&31)&f[a+(M>>>5<<2)>>2]|0){M=f[c+(s*20|0)+4>>2]|0;z=f[i>>2]|0;if(M>>>0>127){Xc=M;F=z;while(1){b[F>>0]=Xc|128;x=Xc>>>7;B=F+1|0;if(Xc>>>0>16383){Xc=x;F=B}else{ue=B;ve=x;break}}}else{ue=z;ve=M}b[ue>>0]=ve;F=v;Xc=f[F>>2]|0;y=f[F+4>>2]|0;F=ue+1|0;ra=F;b[ra>>0]=Xc;b[ra+1>>0]=Xc>>8;b[ra+2>>0]=Xc>>16;b[ra+3>>0]=Xc>>24;Xc=F+4|0;b[Xc>>0]=y;b[Xc+1>>0]=y>>8;b[Xc+2>>0]=y>>16;b[Xc+3>>0]=y>>24;f[i>>2]=ue+9}break}case 35:{y=v;if(!((f[y>>2]|0)==0&(f[y+4>>2]|0)==0)){y=f[c+(s*20|0)+4>>2]|0;Xc=f[i>>2]|0;if(y>>>0>127){F=y;ra=Xc;while(1){b[ra>>0]=F|128;x=F>>>7;B=ra+1|0;if(F>>>0>16383){F=x;ra=B}else{we=B;xe=x;break}}}else{we=Xc;xe=y}b[we>>0]=xe;ra=v;F=f[ra>>2]|0;M=f[ra+4>>2]|0;ra=we+1|0;z=ra;b[z>>0]=F;b[z+1>>0]=F>>8;b[z+2>>0]=F>>16;b[z+3>>0]=F>>24;F=ra+4|0;b[F>>0]=M;b[F+1>>0]=M>>8;b[F+2>>0]=M>>16;b[F+3>>0]=M>>24;f[i>>2]=we+9}break}case 55:{if((f[v>>2]|0)>0){M=c+(s*20|0)+4|0;F=v+8|0;ra=0;z=f[i>>2]|0;do{x=f[M>>2]|0;if(x>>>0>127){B=x;Wc=z;while(1){b[Wc>>0]=B|128;G=B>>>7;qa=Wc+1|0;if(B>>>0>16383){B=G;Wc=qa}else{ye=qa;ze=G;break}}}else{ye=z;ze=x}b[ye>>0]=ze;Wc=(f[F>>2]|0)+8+(ra<<3)|0;B=f[Wc>>2]|0;Z=f[Wc+4>>2]|0;Wc=ye+1|0;G=Wc;b[G>>0]=B;b[G+1>>0]=B>>8;b[G+2>>0]=B>>16;b[G+3>>0]=B>>24;B=Wc+4|0;b[B>>0]=Z;b[B+1>>0]=Z>>8;b[B+2>>0]=Z>>16;b[B+3>>0]=Z>>24;z=ye+9|0;f[i>>2]=z;ra=ra+1|0}while((ra|0)<(f[v>>2]|0))}break}case 75:{if(f[v>>2]|0){ra=f[c+(s*20|0)+4>>2]|0;z=f[i>>2]|0;if(ra>>>0>127){F=ra;M=z;while(1){b[M>>0]=F|128;y=F>>>7;Xc=M+1|0;if(F>>>0>16383){F=y;M=Xc}else{Ae=Xc;Be=y;break}}}else{Ae=z;Be=ra}b[Ae>>0]=Be;M=Ae+1|0;f[i>>2]=M;F=f[v+12>>2]|0;if(F>>>0>127){y=F;Xc=M;while(1){b[Xc>>0]=y|128;Z=y>>>7;B=Xc+1|0;if(y>>>0>16383){y=Z;Xc=B}else{Ce=B;De=Z;break}}}else{Ce=M;De=F}b[Ce>>0]=De;Xc=Ce+1|0;f[i>>2]=Xc;if((f[v>>2]|0)>0){y=v+8|0;ra=0;z=Xc;do{Xc=(f[y>>2]|0)+8+(ra<<3)|0;Z=f[Xc>>2]|0;B=f[Xc+4>>2]|0;Xc=z;Wc=Xc;b[Wc>>0]=Z;b[Wc+1>>0]=Z>>8;b[Wc+2>>0]=Z>>16;b[Wc+3>>0]=Z>>24;Z=Xc+4|0;b[Z>>0]=B;b[Z+1>>0]=B>>8;b[Z+2>>0]=B>>16;b[Z+3>>0]=B>>24;z=z+8|0;f[i>>2]=z;ra=ra+1|0}while((ra|0)<(f[v>>2]|0))}}break}case 95:{ra=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(ra>>>3|0)){z=f[i>>2]|0;if(ra>>>0>127){y=ra;F=z;while(1){b[F>>0]=y|128;M=y>>>7;B=F+1|0;if(y>>>0>16383){y=M;F=B}else{Ee=B;Fe=M;break}}}else{Ee=z;Fe=ra}b[Ee>>0]=Fe;F=v;y=f[F>>2]|0;M=f[F+4>>2]|0;F=Ee+1|0;B=F;b[B>>0]=y;b[B+1>>0]=y>>8;b[B+2>>0]=y>>16;b[B+3>>0]=y>>24;y=F+4|0;b[y>>0]=M;b[y+1>>0]=M>>8;b[y+2>>0]=M>>16;b[y+3>>0]=M>>24;f[i>>2]=Ee+9}break}case 16:{M=f[c+(s*20|0)+8>>2]|0;if(1<<(M&31)&f[a+(M>>>5<<2)>>2]|0){M=f[c+(s*20|0)+4>>2]|0;y=f[i>>2]|0;if(M>>>0>127){F=M;B=y;while(1){b[B>>0]=F|128;Z=F>>>7;Xc=B+1|0;if(F>>>0>16383){F=Z;B=Xc}else{Ge=Xc;He=Z;break}}}else{Ge=y;He=M}b[Ge>>0]=He;B=Ge+1|0;f[i>>2]=B;F=f[v>>2]|0;ra=F<<1^F>>31;if(ra>>>0>127){F=ra;z=B;while(1){b[z>>0]=F|128;Z=F>>>7;Xc=z+1|0;if(F>>>0>16383){F=Z;z=Xc}else{Ie=Xc;Je=Z;break}}}else{Ie=B;Je=ra}b[Ie>>0]=Je;f[i>>2]=Ie+1}break}case 36:{if(f[v>>2]|0){z=f[c+(s*20|0)+4>>2]|0;F=f[i>>2]|0;if(z>>>0>127){M=z;y=F;while(1){b[y>>0]=M|128;Z=M>>>7;Xc=y+1|0;if(M>>>0>16383){M=Z;y=Xc}else{Ke=Xc;Le=Z;break}}}else{Ke=F;Le=z}b[Ke>>0]=Le;y=Ke+1|0;f[i>>2]=y;M=f[v>>2]|0;ra=M<<1^M>>31;if(ra>>>0>127){M=ra;B=y;while(1){b[B>>0]=M|128;Z=M>>>7;Xc=B+1|0;if(M>>>0>16383){M=Z;B=Xc}else{Me=Xc;Ne=Z;break}}}else{Me=y;Ne=ra}b[Me>>0]=Ne;f[i>>2]=Me+1}break}case 56:{if((f[v>>2]|0)>0){B=c+(s*20|0)+4|0;M=v+8|0;z=0;F=f[i>>2]|0;do{Z=f[B>>2]|0;if(Z>>>0>127){Xc=Z;Wc=F;while(1){b[Wc>>0]=Xc|128;G=Xc>>>7;qa=Wc+1|0;if(Xc>>>0>16383){Xc=G;Wc=qa}else{Oe=qa;Pe=G;break}}}else{Oe=F;Pe=Z}b[Oe>>0]=Pe;Wc=Oe+1|0;f[i>>2]=Wc;Xc=f[(f[M>>2]|0)+4+(z<<2)>>2]|0;x=Xc<<1^Xc>>31;if(x>>>0>127){Xc=x;G=Wc;while(1){b[G>>0]=Xc|128;qa=Xc>>>7;L=G+1|0;if(Xc>>>0>16383){Xc=qa;G=L}else{Qe=L;Re=qa;break}}}else{Qe=Wc;Re=x}b[Qe>>0]=Re;F=Qe+1|0;f[i>>2]=F;z=z+1|0}while((z|0)<(f[v>>2]|0))}break}case 76:{if(f[v>>2]|0){z=f[c+(s*20|0)+4>>2]|0;F=f[i>>2]|0;if(z>>>0>127){M=z;B=F;while(1){b[B>>0]=M|128;ra=M>>>7;y=B+1|0;if(M>>>0>16383){M=ra;B=y}else{Se=y;Te=ra;break}}}else{Se=F;Te=z}b[Se>>0]=Te;B=Se+1|0;f[i>>2]=B;M=f[v+12>>2]|0;if(M>>>0>127){ra=M;y=B;while(1){b[y>>0]=ra|128;G=ra>>>7;Xc=y+1|0;if(ra>>>0>16383){ra=G;y=Xc}else{Ue=Xc;Ve=G;break}}}else{Ue=B;Ve=M}b[Ue>>0]=Ve;y=Ue+1|0;f[i>>2]=y;if((f[v>>2]|0)>0){ra=v+8|0;z=0;F=y;do{y=f[(f[ra>>2]|0)+4+(z<<2)>>2]|0;G=y<<1^y>>31;if(G>>>0>127){y=G;Xc=F;while(1){b[Xc>>0]=y|128;Z=y>>>7;qa=Xc+1|0;if(y>>>0>16383){y=Z;Xc=qa}else{We=qa;Xe=Z;break}}}else{We=F;Xe=G}b[We>>0]=Xe;F=We+1|0;f[i>>2]=F;z=z+1|0}while((z|0)<(f[v>>2]|0))}}break}case 96:{z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(z>>>3|0)){F=f[i>>2]|0;if(z>>>0>127){ra=z;M=F;while(1){b[M>>0]=ra|128;B=ra>>>7;Xc=M+1|0;if(ra>>>0>16383){ra=B;M=Xc}else{Ye=Xc;Ze=B;break}}}else{Ye=F;Ze=z}b[Ye>>0]=Ze;M=Ye+1|0;f[i>>2]=M;ra=f[v>>2]|0;B=ra<<1^ra>>31;if(B>>>0>127){ra=B;Xc=M;while(1){b[Xc>>0]=ra|128;y=ra>>>7;x=Xc+1|0;if(ra>>>0>16383){ra=y;Xc=x}else{_e=x;$e=y;break}}}else{_e=M;$e=B}b[_e>>0]=$e;f[i>>2]=_e+1}break}case 17:{Xc=f[c+(s*20|0)+8>>2]|0;if(1<<(Xc&31)&f[a+(Xc>>>5<<2)>>2]|0){Xc=f[c+(s*20|0)+4>>2]|0;ra=f[i>>2]|0;if(Xc>>>0>127){z=Xc;F=ra;while(1){b[F>>0]=z|128;y=z>>>7;x=F+1|0;if(z>>>0>16383){z=y;F=x}else{af=x;bf=y;break}}}else{af=ra;bf=Xc}b[af>>0]=bf;F=af+1|0;f[i>>2]=F;z=v;B=f[z>>2]|0;M=f[z+4>>2]|0;z=jJc(B|0,M|0,1)|0;y=J;x=$Ic(B|0,M|0,63)|0;M=z^x;x=y^J;y=M&255;if(x>>>0>0|(x|0)==0&M>>>0>127){z=F;B=y;Wc=M;M=x;while(1){b[z>>0]=B|-128;x=Wc;Wc=aJc(Wc|0,M|0,7)|0;Z=z+1|0;qa=Wc&255;if(!(M>>>0>0|(M|0)==0&x>>>0>16383)){cf=Z;df=qa;break}else{z=Z;B=qa;M=J}}}else{cf=F;df=y}b[cf>>0]=df;f[i>>2]=cf+1}break}case 37:{M=v;if(!((f[M>>2]|0)==0&(f[M+4>>2]|0)==0)){M=f[c+(s*20|0)+4>>2]|0;B=f[i>>2]|0;if(M>>>0>127){z=M;Wc=B;while(1){b[Wc>>0]=z|128;Xc=z>>>7;ra=Wc+1|0;if(z>>>0>16383){z=Xc;Wc=ra}else{ef=ra;ff=Xc;break}}}else{ef=B;ff=M}b[ef>>0]=ff;Wc=ef+1|0;f[i>>2]=Wc;z=v;y=f[z>>2]|0;F=f[z+4>>2]|0;z=jJc(y|0,F|0,1)|0;Xc=J;ra=$Ic(y|0,F|0,63)|0;F=z^ra;ra=Xc^J;Xc=F&255;if(ra>>>0>0|(ra|0)==0&F>>>0>127){z=Wc;y=Xc;qa=F;F=ra;while(1){b[z>>0]=y|-128;ra=qa;qa=aJc(qa|0,F|0,7)|0;Z=z+1|0;x=qa&255;if(!(F>>>0>0|(F|0)==0&ra>>>0>16383)){gf=Z;hf=x;break}else{z=Z;y=x;F=J}}}else{gf=Wc;hf=Xc}b[gf>>0]=hf;f[i>>2]=gf+1}break}case 57:{if((f[v>>2]|0)>0){F=c+(s*20|0)+4|0;y=v+8|0;z=0;qa=f[i>>2]|0;do{M=f[F>>2]|0;if(M>>>0>127){B=M;x=qa;while(1){b[x>>0]=B|128;Z=B>>>7;ra=x+1|0;if(B>>>0>16383){B=Z;x=ra}else{jf=ra;kf=Z;break}}}else{jf=qa;kf=M}b[jf>>0]=kf;x=jf+1|0;f[i>>2]=x;B=(f[y>>2]|0)+8+(z<<3)|0;G=f[B>>2]|0;Z=f[B+4>>2]|0;B=jJc(G|0,Z|0,1)|0;ra=J;L=$Ic(G|0,Z|0,63)|0;Z=B^L;L=ra^J;ra=Z&255;if(L>>>0>0|(L|0)==0&Z>>>0>127){B=x;G=ra;sa=Z;Z=L;while(1){b[B>>0]=G|-128;L=sa;sa=aJc(sa|0,Z|0,7)|0;ta=B+1|0;K=sa&255;if(!(Z>>>0>0|(Z|0)==0&L>>>0>16383)){lf=ta;mf=K;break}else{B=ta;G=K;Z=J}}}else{lf=x;mf=ra}b[lf>>0]=mf;qa=lf+1|0;f[i>>2]=qa;z=z+1|0}while((z|0)<(f[v>>2]|0))}break}case 77:{if(f[v>>2]|0){z=f[c+(s*20|0)+4>>2]|0;qa=f[i>>2]|0;if(z>>>0>127){y=z;F=qa;while(1){b[F>>0]=y|128;Xc=y>>>7;Wc=F+1|0;if(y>>>0>16383){y=Xc;F=Wc}else{nf=Wc;of=Xc;break}}}else{nf=qa;of=z}b[nf>>0]=of;F=nf+1|0;f[i>>2]=F;y=f[v+12>>2]|0;if(y>>>0>127){Xc=y;Wc=F;while(1){b[Wc>>0]=Xc|128;Z=Xc>>>7;G=Wc+1|0;if(Xc>>>0>16383){Xc=Z;Wc=G}else{pf=G;qf=Z;break}}}else{pf=F;qf=y}b[pf>>0]=qf;Wc=pf+1|0;f[i>>2]=Wc;if((f[v>>2]|0)>0){Xc=v+8|0;z=0;qa=Wc;do{Wc=(f[Xc>>2]|0)+8+(z<<3)|0;Z=f[Wc>>2]|0;G=f[Wc+4>>2]|0;Wc=jJc(Z|0,G|0,1)|0;B=J;sa=$Ic(Z|0,G|0,63)|0;G=Wc^sa;sa=B^J;B=G&255;if(sa>>>0>0|(sa|0)==0&G>>>0>127){Wc=qa;Z=B;M=G;G=sa;while(1){b[Wc>>0]=Z|-128;sa=M;M=aJc(M|0,G|0,7)|0;K=Wc+1|0;ta=M&255;if(!(G>>>0>0|(G|0)==0&sa>>>0>16383)){rf=K;sf=ta;break}else{Wc=K;Z=ta;G=J}}}else{rf=qa;sf=B}b[rf>>0]=sf;qa=rf+1|0;f[i>>2]=qa;z=z+1|0}while((z|0)<(f[v>>2]|0))}}break}case 97:{z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(z>>>3|0)){qa=f[i>>2]|0;if(z>>>0>127){Xc=z;y=qa;while(1){b[y>>0]=Xc|128;F=Xc>>>7;G=y+1|0;if(Xc>>>0>16383){Xc=F;y=G}else{tf=G;uf=F;break}}}else{tf=qa;uf=z}b[tf>>0]=uf;y=tf+1|0;f[i>>2]=y;Xc=v;F=f[Xc>>2]|0;G=f[Xc+4>>2]|0;Xc=jJc(F|0,G|0,1)|0;Z=J;Wc=$Ic(F|0,G|0,63)|0;G=Xc^Wc;Wc=Z^J;Z=G&255;if(Wc>>>0>0|(Wc|0)==0&G>>>0>127){Xc=y;F=Z;M=G;G=Wc;while(1){b[Xc>>0]=F|-128;Wc=M;M=aJc(M|0,G|0,7)|0;ra=Xc+1|0;x=M&255;if(!(G>>>0>0|(G|0)==0&Wc>>>0>16383)){vf=ra;wf=x;break}else{Xc=ra;F=x;G=J}}}else{vf=y;wf=Z}b[vf>>0]=wf;f[i>>2]=vf+1}break}case 100:{DSb(j,f[i>>2]|0,2147483647,-1);XRb(k,j);b[e>>0]=1;b[o>>0]=l;gi[f[c+(s*20|0)+16>>2]&255](a,f[t>>2]|0,f[c+(s*20|0)+4>>2]|0,f[c+(s*20|0)+8>>2]|0,k);f[i>>2]=(f[i>>2]|0)+((f[q>>2]|0)-(f[r>>2]|0));YRb(k);break}default:ARb(w)}while(0);s=s+1|0}while((s|0)<(d|0));m=f[i>>2]|0;u=h;return m|0}function CRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=u;u=u+32|0;a=c;rTb(a,3,471939,512);d=mTb(a,472040)|0;e=mTb(qTb(d,f[b+4>>2]|0)|0,472070)|0;oTb(c+24|0,qTb(e,f[b+12>>2]|0)|0);sTb(a);u=c;return}function DRb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+8>>2]|0;if(!b)return;c=a+4|0;d=a+32|0;e=a+16|0;g=(f[c>>2]|0)-(f[a>>2]|0)+(f[d>>2]|0)+(f[e>>2]|0)|0;if((g|0)<=0)return;mi[f[(f[b>>2]|0)+12>>2]&2047](b,g);g=f[a>>2]|0;b=a+12|0;f[b>>2]=g-(f[c>>2]|0)-(f[d>>2]|0)+(f[b>>2]|0);f[c>>2]=g;f[d>>2]=0;f[e>>2]=0;return}function ERb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;g=a+32|0;h=f[g>>2]|0;i=c-e+(f[a>>2]|0)-h|0;j=a+28|0;k=f[j>>2]|0;if(!((k-i|0)>(b|0)&((b|0)>-1&(2147483647-i|0)>=(b|0))))return k|0;l=i+b|0;f[j>>2]=l;j=e+h|0;f[d>>2]=j;h=f[a+36>>2]|0;a=(h|0)<(l|0)?h:l;if((c|0)>(a|0)){l=c-a|0;f[g>>2]=l;f[d>>2]=j+(0-l);return k|0}else{f[g>>2]=0;return k|0}return 0}function FRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;f[a+28>>2]=c;d=a+32|0;e=a+4|0;g=(f[e>>2]|0)+(f[d>>2]|0)|0;f[e>>2]=g;h=f[a+36>>2]|0;i=(h|0)<(c|0)?h:c;c=f[a+12>>2]|0;if((c|0)>(i|0)){h=c-i|0;f[d>>2]=h;f[e>>2]=g+(0-h);j=a+24|0;b[j>>0]=0;return}else{f[d>>2]=0;j=a+24|0;b[j>>0]=0;return}}function GRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[b+12>>2]|0;e=b+4|0;g=f[e>>2]|0;h=b+32|0;i=f[h>>2]|0;j=d-g+(f[b>>2]|0)-i|0;k=b+28|0;l=f[k>>2]|0;do if((l-j|0)>(c|0)&((c|0)>-1&(2147483647-j|0)>=(c|0))){m=j+c|0;f[k>>2]=m;n=g+i|0;f[e>>2]=n;o=f[b+36>>2]|0;p=(o|0)<(m|0)?o:m;if((d|0)>(p|0)){m=d-p|0;f[h>>2]=m;f[e>>2]=n+(0-m);break}else{f[h>>2]=0;break}}while(0);h=b+40|0;b=(f[h>>2]|0)+-1|0;f[h>>2]=b;f[a>>2]=l;f[a+4>>2]=b;return}function HRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=f[a+4>>2]|0;i=f[a>>2]|0;j=g;k=i;do if((g-i|0)<=9){if(j>>>0>k>>>0?(b[j+-1>>0]|0)>=0:0)break;IRb(e,a);l=(b[e+8>>0]|0)!=0;m=l?0:-1;n=l?f[e>>2]|0:-1;J=m;u=d;return n|0}while(0);e=k+2|0;j=h[k+1>>0]|0;i=c+-128+(j<<7)|0;if(j&128){j=k+3|0;c=h[e>>0]|0;g=i+-16384+(c<<14)|0;if(c&128){c=k+4|0;l=h[j>>0]|0;o=g+-2097152+(l<<21)|0;if(l&128){l=k+5|0;p=h[c>>0]|0;q=o+-268435456+(p<<28)|0;if(p&128){p=k+6|0;if((b[l>>0]|0)<0){r=k+7|0;if((b[p>>0]|0)<0){s=k+8|0;if((b[r>>0]|0)<0){t=k+9|0;if((b[s>>0]|0)<0)if((b[t>>0]|0)<0){m=-1;n=-1;J=m;u=d;return n|0}else{v=q;w=k+10|0}else{v=q;w=t}}else{v=q;w=s}}else{v=q;w=r}}else{v=q;w=p}}else{v=q;w=l}}else{v=o;w=c}}else{v=g;w=j}}else{v=i;w=e}f[a>>2]=w;m=0;n=v;J=m;u=d;return n|0}function IRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=c+4|0;e=f[d>>2]|0;g=f[c>>2]|0;i=e;j=g;a:do if((e-g|0)>9)k=4;else{if(i>>>0>j>>>0?(b[i+-1>>0]|0)>=0:0){k=4;break}else{l=0;m=0;n=0;o=j;p=i}while(1){if((l|0)==10){q=0;r=0;s=0;break a}if((o|0)==(p|0))while(1){if(!(JRb(c)|0)){q=0;r=0;s=0;break a}t=f[c>>2]|0;u=f[d>>2]|0;if((t|0)!=(u|0)){v=t;w=u;break}}else{v=o;w=p}u=h[v>>0]|0;t=jJc(u&127|0,0,l*7|0)|0;x=t|m;t=J|n;o=v+1|0;f[c>>2]=o;if(!(u&128)){q=1;r=x;s=t;break}else{l=l+1|0;m=x;n=t;p=w}}}while(0);do if((k|0)==4){w=j+1|0;p=h[j>>0]|0;if(p&128){n=j+2|0;m=h[w>>0]|0;l=p+-128+(m<<7)|0;if(m&128){m=j+3|0;o=h[n>>0]|0;v=l+-16384+(o<<14)|0;if(o&128){o=j+4|0;d=h[m>>0]|0;i=v+-2097152+(d<<21)|0;if(d&128){d=i+-268435456|0;g=j+5|0;e=h[o>>0]|0;if(e&128){t=j+6|0;x=h[g>>0]|0;u=e+-128+(x<<7)|0;if(x&128){x=j+7|0;y=h[t>>0]|0;z=u+-16384+(y<<14)|0;if(y&128){y=j+8|0;A=h[x>>0]|0;B=z+-2097152+(A<<21)|0;if(A&128){A=B+-268435456|0;C=j+9|0;D=h[y>>0]|0;if(D&128){E=h[C>>0]|0;if(!(E&128)){F=D+-128+(E<<7)|0;G=A;H=d;I=j+10|0}else{q=0;r=0;s=0;break}}else{F=D;G=A;H=d;I=C}}else{F=0;G=B;H=d;I=y}}else{F=0;G=z;H=d;I=x}}else{F=0;G=u;H=d;I=t}}else{F=0;G=e;H=d;I=g}}else{F=0;G=0;H=i;I=o}}else{F=0;G=0;H=v;I=m}}else{F=0;G=0;H=l;I=n}}else{F=0;G=0;H=p;I=w}w=jJc(G|0,0,28)|0;p=J;n=jJc(F|0,0,56)|0;f[c>>2]=I;q=1;r=w|H|n;s=p|J}while(0);H=a;f[H>>2]=r;f[H+4>>2]=s;b[a+8>>0]=q;return}function JRb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;b=u;u=u+48|0;c=b+28|0;d=b+24|0;e=b;g=b+32|0;h=a+32|0;i=f[h>>2]|0;if(((i|0)<=0?(j=a+16|0,(f[j>>2]|0)<=0):0)?(k=a+12|0,l=a+28|0,(f[k>>2]|0)!=(f[l>>2]|0)):0){m=f[a+8>>2]|0;while(1){if(!(hj[f[(f[m>>2]|0)+8>>2]&511](m,c,d)|0)){n=18;break}o=f[d>>2]|0;if(o|0){n=10;break}}do if((n|0)==10){m=f[c>>2]|0;f[a>>2]=m;p=a+4|0;f[p>>2]=m+o;if((o|0)>-1)q=o;else{rTb(e,3,472082,590);oTb(g,mTb(e,472176)|0);sTb(e);q=f[d>>2]|0}m=f[k>>2]|0;r=2147483647-q|0;if((m|0)>(r|0)){s=m-r|0;f[j>>2]=s;r=(f[p>>2]|0)+(0-s)|0;f[p>>2]=r;t=r;v=2147483647}else{t=f[p>>2]|0;v=q+m|0}f[k>>2]=v;m=t+(f[h>>2]|0)|0;f[p>>2]=m;r=f[a+36>>2]|0;s=f[l>>2]|0;w=(r|0)<(s|0)?r:s;if((v|0)>(w|0)){s=v-w|0;f[h>>2]=s;f[p>>2]=m+(0-s);x=1;break}else{f[h>>2]=0;x=1;break}}else if((n|0)==18){f[a>>2]=0;f[a+4>>2]=0;x=0}while(0);y=x;u=b;return y|0}x=f[a+36>>2]|0;if(((f[a+12>>2]|0)-i|0)<(x|0)){y=0;u=b;return y|0}if((x|0)==(f[a+28>>2]|0)){y=0;u=b;return y|0}KRb(a);y=0;u=b;return y|0}function KRb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+32|0;c=b;rTb(c,2,472082,193);d=mTb(c,472213)|0;oTb(b+24|0,mTb(pTb(d,f[a+36>>2]|0)|0,472280)|0);sTb(c);u=b;return}function LRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+24|0;e=(b[d>>0]|0)!=0;f[a+28>>2]=c;g=a+32|0;h=a+4|0;i=(f[h>>2]|0)+(f[g>>2]|0)|0;f[h>>2]=i;j=f[a+36>>2]|0;k=(j|0)<(c|0)?j:c;c=f[a+12>>2]|0;if((c|0)>(k|0)){j=c-k|0;f[g>>2]=j;f[h>>2]=i+(0-j);b[d>>0]=0;l=a+40|0;m=f[l>>2]|0;n=m+1|0;f[l>>2]=n;return e|0}else{f[g>>2]=0;b[d>>0]=0;l=a+40|0;m=f[l>>2]|0;n=m+1|0;f[l>>2]=n;return e|0}return 0}function MRb(a){a=a|0;var b=0,c=0;b=f[a+28>>2]|0;if((b|0)==2147483647){c=-1;return c|0}c=b-(f[a+12>>2]|0)+(f[a+4>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;return c|0}function NRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;g=a+32|0;h=f[g>>2]|0;i=c-e+(f[a>>2]|0)-h|0;j=(i|0)<(b|0)?b:i;f[a+36>>2]=j;i=e+h|0;f[d>>2]=i;h=f[a+28>>2]|0;a=(j|0)<(h|0)?j:h;if((c|0)>(a|0)){h=c-a|0;f[g>>2]=h;f[d>>2]=i+(0-h);return}else{f[g>>2]=0;return}}function ORb(a){a=a|0;var b=0,c=0;b=f[a+36>>2]|0;if((b|0)==2147483647){c=-1;return c|0}c=b-(f[a+12>>2]|0)+(f[a+4>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;return c|0}function PRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;if((f[a+32>>2]|0)>0){f[a>>2]=(f[a>>2]|0)+c;d=0;return d|0}e=b-c|0;f[a>>2]=0;f[a+4>>2]=0;c=f[a+36>>2]|0;b=f[a+28>>2]|0;g=(c|0)<(b|0)?c:b;b=a+12|0;c=f[b>>2]|0;h=g-c|0;if((h|0)>=(e|0)){f[b>>2]=c+e;c=f[a+8>>2]|0;d=Mi[f[(f[c>>2]|0)+16>>2]&1023](c,e)|0;return d|0}if((h|0)<=0){d=0;return d|0}f[b>>2]=g;g=f[a+8>>2]|0;Mi[f[(f[g>>2]|0)+16>>2]&1023](g,h)|0;d=0;return d|0}function QRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=c;c=b;while(1){b=f[a>>2]|0;g=(f[d>>2]|0)-b|0;h=b;if((e|0)<=(g|0))break;dJc(c|0,h|0,g|0)|0;f[a>>2]=(f[a>>2]|0)+g;if(JRb(a)|0){e=e-g|0;c=c+g|0}else{i=0;j=5;break}}if((j|0)==5)return i|0;dJc(c|0,h|0,e|0)|0;f[a>>2]=(f[a>>2]|0)+e;i=1;return i|0}function RRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;if((d|0)<0){e=0;return e|0}if(((f[a+4>>2]|0)-(f[a>>2]|0)|0)<(d|0)){e=SRb(a,c,d)|0;return e|0}oEc(c,d,0);g=b[c+11>>0]|0;h=g<<24>>24<0;if(h)i=f[c+4>>2]|0;else i=g&255;if(!i){e=1;return e|0}if(h)j=f[c>>2]|0;else j=c;if(!j){e=1;return e|0}dJc(j|0,f[a>>2]|0,d|0)|0;f[a>>2]=(f[a>>2]|0)+d;e=1;return e|0}function SRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=c+11|0;g=b[e>>0]|0;h=g<<24>>24<0;if(h)i=f[c+4>>2]|0;else i=g&255;do if(i|0)if(h){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[e>>0]=0;break}while(0);e=f[a+36>>2]|0;h=f[a+28>>2]|0;i=(e|0)<(h|0)?e:h;if((i|0)!=2147483647){h=a+4|0;e=i-(f[a+12>>2]|0)+(f[h>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;if((e|0)<(d|0)|((d|0)<1|(e|0)<1)){j=h;k=a}else{mEc(c,d);j=h;k=a}}else{j=a+4|0;k=a}h=d;while(1){d=f[k>>2]|0;e=(f[j>>2]|0)-d|0;l=d;if((h|0)<=(e|0))break;if(!e)m=l;else{tEc(c,l,e)|0;m=f[a>>2]|0}f[a>>2]=m+e;if(JRb(a)|0)h=h-e|0;else{n=0;o=18;break}}if((o|0)==18)return n|0;tEc(c,l,h)|0;f[a>>2]=(f[a>>2]|0)+h;n=1;return n|0}function TRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=j;if((i-j|0)>>>0>3){l=k;m=k+4|0}else{k=i-j|0;i=j;a:do if((k|0)<4){j=4;n=e;o=i;p=k;while(1){dJc(n|0,o|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;if(!(JRb(a)|0)){q=0;break}r=j-p|0;s=n+p|0;t=f[a>>2]|0;p=(f[g>>2]|0)-t|0;v=t;if((r|0)<=(p|0)){w=r;x=s;y=v;break a}else{j=r;n=s;o=v}}u=d;return q|0}else{w=4;x=e;y=i}while(0);dJc(x|0,y|0,w|0)|0;l=e;m=(f[a>>2]|0)+w|0}f[a>>2]=m;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;b[c>>0]=m;b[c+1>>0]=m>>8;b[c+2>>0]=m>>16;b[c+3>>0]=m>>24;q=1;u=d;return q|0}function URb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=j;if((i-j|0)>>>0>7){l=k;m=k+8|0}else{k=i-j|0;i=j;a:do if((k|0)<8){j=8;n=e;o=i;p=k;while(1){dJc(n|0,o|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;if(!(JRb(a)|0)){q=0;break}r=j-p|0;s=n+p|0;t=f[a>>2]|0;p=(f[g>>2]|0)-t|0;v=t;if((r|0)<=(p|0)){w=r;x=s;y=v;break a}else{j=r;n=s;o=v}}u=d;return q|0}else{w=8;x=e;y=i}while(0);dJc(x|0,y|0,w|0)|0;l=e;m=(f[a>>2]|0)+w|0}f[a>>2]=m;m=l;l=m;a=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=m+4|0;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=c;c=l;b[c>>0]=a;b[c+1>>0]=a>>8;b[c+2>>0]=a>>16;b[c+3>>0]=a>>24;a=l+4|0;b[a>>0]=m;b[a+1>>0]=m>>8;b[a+2>>0]=m>>16;b[a+3>>0]=m>>24;q=1;u=d;return q|0}function VRb(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;g=f[a>>2]|0;i=e;j=g;do if((e-g|0)<=9){if(i>>>0>j>>>0?(b[i+-1>>0]|0)>=0:0)break;IRb(d,a);if(!(b[d+8>>0]|0))k=-1;else{l=d;m=f[l>>2]|0;n=f[l+4>>2]|0;k=n>>>0>0|(n|0)==0&m>>>0>2147483647?-1:m}o=k;u=c;return o|0}while(0);k=j+1|0;d=h[j>>0]|0;if(d&128){i=j+2|0;g=h[k>>0]|0;e=d+-128+(g<<7)|0;if(g&128){g=j+3|0;m=h[i>>0]|0;n=e+-16384+(m<<14)|0;if(m&128){m=j+4|0;l=h[g>>0]|0;p=n+-2097152+(l<<21)|0;if(l&128){l=p+-268435456|0;q=j+5|0;r=h[m>>0]|0;if(r&128){s=j+6|0;t=h[q>>0]|0;v=r+-128+(t<<7)|0;if(t&128){t=j+7|0;w=h[s>>0]|0;x=v+-16384+(w<<14)|0;if(w&128){w=j+8|0;y=h[t>>0]|0;z=x+-2097152+(y<<21)|0;if(y&128){y=z+-268435456|0;A=j+9|0;B=h[w>>0]|0;if(B&128){C=h[A>>0]|0;if(!(C&128)){D=B+-128+(C<<7)|0;E=y;F=l;G=j+10|0}else{o=-1;u=c;return o|0}}else{D=B;E=y;F=l;G=A}}else{D=0;E=z;F=l;G=w}}else{D=0;E=x;F=l;G=t}}else{D=0;E=v;F=l;G=s}}else{D=0;E=r;F=l;G=q}}else{D=0;E=0;F=p;G=m}}else{D=0;E=0;F=n;G=g}}else{D=0;E=0;F=e;G=i}}else{D=0;E=0;F=d;G=k}k=jJc(E|0,0,28)|0;E=J;d=k|F;F=jJc(D|0,0,56)|0;D=E|J;if(D>>>0>0|(D|0)==0&(d|F)>>>0>2147483647){o=-1;u=c;return o|0}f[a>>2]=G;o=d;u=c;return o|0}function WRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=i-j|0;l=i;i=j;a:do if((k|0)<=9){do if((k|0)>0){if((b[l+-1>>0]|0)>=0)break a}else if(!k){j=f[a+32>>2]|0;m=f[a+12>>2]|0;if((j|0)<=0?(m|0)!=(f[a+28>>2]|0):0)break;if((m-j|0)<(f[a+36>>2]|0)){b[a+24>>0]=1;n=0;u=d;return n|0}}while(0);do if((i|0)==(l|0)){if(JRb(a)|0){o=f[a>>2]|0;p=f[g>>2]|0;break}j=f[a+36>>2]|0;if(((f[a+12>>2]|0)-(f[a+32>>2]|0)|0)<(j|0)){b[a+24>>0]=1;n=0;u=d;return n|0}else{b[a+24>>0]=(f[a+28>>2]|0)==(j|0)&1;n=0;u=d;return n|0}}else{o=i;p=l}while(0);if(o>>>0<p>>>0?(j=b[o>>0]|0,j<<24>>24>-1):0){f[a>>2]=o+1;q=j&255}else{IRb(e,a);if(!(b[e+8>>0]|0)){n=0;u=d;return n|0}else q=f[e>>2]|0}n=q;u=d;return n|0}while(0);if(!c){f[a>>2]=i+1;n=0;u=d;return n|0}q=i+2|0;e=h[i+1>>0]|0;o=c+-128+(e<<7)|0;if(e&128){e=i+3|0;c=h[q>>0]|0;p=o+-16384+(c<<14)|0;if(c&128){c=i+4|0;l=h[e>>0]|0;g=p+-2097152+(l<<21)|0;if(l&128){l=i+5|0;k=h[c>>0]|0;j=g+-268435456+(k<<28)|0;if(k&128){k=i+6|0;if((b[l>>0]|0)<0){m=i+7|0;if((b[k>>0]|0)<0){r=i+8|0;if((b[m>>0]|0)<0){s=i+9|0;if((b[r>>0]|0)<0)if((b[s>>0]|0)<0){n=0;u=d;return n|0}else{t=j;v=i+10|0}else{t=j;v=s}}else{t=j;v=r}}else{t=j;v=m}}else{t=j;v=k}}else{t=j;v=l}}else{t=g;v=c}}else{t=p;v=e}}else{t=o;v=q}f[a>>2]=v;n=t;u=d;return n|0}function XRb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=c;h=a+4|0;i=a+8|0;j=a+12|0;k=a+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d[h+12>>1]=0;b[h+14>>0]=0;if(hj[f[(f[c>>2]|0)+8>>2]&511](c,g,i)|0){f[h>>2]=f[g>>2];f[j>>2]=(f[j>>2]|0)+(f[i>>2]|0);b[k>>0]=0;u=e;return}else{f[h>>2]=0;f[i>>2]=0;b[k>>0]=1;b[k>>0]=0;u=e;return}}function YRb(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;c=f[b>>2]|0;if((c|0)<=0)return;d=f[a>>2]|0;mi[f[(f[d>>2]|0)+12>>2]&2047](d,c);c=a+12|0;f[c>>2]=(f[c>>2]|0)-(f[b>>2]|0);f[b>>2]=0;f[a+4>>2]=0;return}function ZRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;i=f[h>>2]|0;j=a+4|0;k=f[j>>2]|0;a:do if((i|0)<(d|0)){l=a+12|0;m=d;n=c;o=k;p=i;while(1){dJc(o|0,n|0,p|0)|0;q=f[h>>2]|0;r=f[a>>2]|0;if(!(hj[f[(f[r>>2]|0)+8>>2]&511](r,g,h)|0))break;r=n+q|0;s=m-q|0;q=f[g>>2]|0;f[j>>2]=q;p=f[h>>2]|0;f[l>>2]=(f[l>>2]|0)+p;t=q;if((p|0)>=(s|0)){v=s;w=r;x=t;break a}else{m=s;n=r;o=t}}f[j>>2]=0;f[h>>2]=0;b[a+16>>0]=1;u=e;return}else{v=d;w=c;x=k}while(0);dJc(x|0,w|0,v|0)|0;f[j>>2]=(f[j>>2]|0)+v;f[h>>2]=(f[h>>2]|0)-v;u=e;return}function _Rb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0;e=a+8|0;g=f[e>>2]|0;if((g|0)>(d|0)){i=a+4|0;dJc(f[i>>2]|0,c|0,d|0)|0;f[i>>2]=(f[i>>2]|0)+d;f[e>>2]=(f[e>>2]|0)-d;return}if((g|0)>0){i=f[a>>2]|0;mi[f[(f[i>>2]|0)+12>>2]&2047](i,g);g=a+12|0;i=(f[g>>2]|0)-(f[e>>2]|0)|0;f[g>>2]=i;f[e>>2]=0;f[a+4>>2]=0;j=a;k=g;l=i}else{i=a+12|0;j=a;k=i;l=f[i>>2]|0}f[k>>2]=l+d;l=f[j>>2]|0;j=((hj[f[(f[l>>2]|0)+20>>2]&511](l,c,d)|0)^1)&1;d=a+16|0;b[d>>0]=h[d>>0]|0|j;return}function $Rb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;h=a+8|0;i=f[h>>2]|0;if(i>>>0>3){j=a+4|0;k=f[j>>2]|0;b[k>>0]=c;b[k+1>>0]=c>>8;b[k+2>>0]=c>>16;b[k+3>>0]=c>>24;f[j>>2]=(f[j>>2]|0)+4;f[h>>2]=(f[h>>2]|0)+-4;u=d;return}f[g>>2]=c;c=a+4|0;j=a+12|0;k=4;l=g;g=f[c>>2]|0;m=i;while(1){dJc(g|0,l|0,m|0)|0;i=f[h>>2]|0;n=f[a>>2]|0;if(!(hj[f[(f[n>>2]|0)+8>>2]&511](n,e,h)|0)){o=6;break}l=l+i|0;k=k-i|0;i=f[e>>2]|0;f[c>>2]=i;m=f[h>>2]|0;f[j>>2]=(f[j>>2]|0)+m;g=i;if((m|0)>=(k|0)){o=7;break}}if((o|0)==6){f[c>>2]=0;f[h>>2]=0;b[a+16>>0]=1;u=d;return}else if((o|0)==7){dJc(g|0,l|0,k|0)|0;f[c>>2]=(f[c>>2]|0)+k;f[h>>2]=(f[h>>2]|0)-k;u=d;return}}function aSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e+8|0;h=e;i=a+8|0;j=f[i>>2]|0;if(j>>>0>7){k=a+4|0;l=f[k>>2]|0;m=l;b[m>>0]=c;b[m+1>>0]=c>>8;b[m+2>>0]=c>>16;b[m+3>>0]=c>>24;m=l+4|0;b[m>>0]=d;b[m+1>>0]=d>>8;b[m+2>>0]=d>>16;b[m+3>>0]=d>>24;f[k>>2]=(f[k>>2]|0)+8;f[i>>2]=(f[i>>2]|0)+-8;u=e;return}k=h;f[k>>2]=c;f[k+4>>2]=d;d=a+4|0;k=a+12|0;c=8;m=h;h=f[d>>2]|0;l=j;while(1){dJc(h|0,m|0,l|0)|0;j=f[i>>2]|0;n=f[a>>2]|0;if(!(hj[f[(f[n>>2]|0)+8>>2]&511](n,g,i)|0)){o=6;break}m=m+j|0;c=c-j|0;j=f[g>>2]|0;f[d>>2]=j;l=f[i>>2]|0;f[k>>2]=(f[k>>2]|0)+l;h=j;if((l|0)>=(c|0)){o=7;break}}if((o|0)==6){f[d>>2]=0;f[i>>2]=0;b[a+16>>0]=1;u=e;return}else if((o|0)==7){dJc(h|0,m|0,c|0)|0;f[d>>2]=(f[d>>2]|0)+c;f[i>>2]=(f[i>>2]|0)-c;u=e;return}}function bSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=d+4|0;if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;m=l+1-g|0;l=a+8|0;c=f[l>>2]|0;i=a+4|0;h=f[i>>2]|0;a:do if((c|0)<(m|0)){j=a+12|0;k=m;n=g;o=h;p=c;while(1){dJc(o|0,n|0,p|0)|0;q=f[l>>2]|0;r=f[a>>2]|0;if(!(hj[f[(f[r>>2]|0)+8>>2]&511](r,e,l)|0))break;r=n+q|0;s=k-q|0;q=f[e>>2]|0;f[i>>2]=q;p=f[l>>2]|0;f[j>>2]=(f[j>>2]|0)+p;t=q;if((p|0)>=(s|0)){v=s;w=r;x=t;break a}else{k=s;n=r;o=t}}f[i>>2]=0;f[l>>2]=0;b[a+16>>0]=1;u=d;return}else{v=m;w=g;x=h}while(0);dJc(x|0,w|0,v|0)|0;f[i>>2]=(f[i>>2]|0)+v;f[l>>2]=(f[l>>2]|0)-v;u=d;return}function cSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=e+4|0;i=c&255;if(d>>>0>0|(d|0)==0&c>>>0>127){j=h;k=i;l=c;c=d;while(1){b[j>>0]=k|-128;d=l;l=aJc(l|0,c|0,7)|0;m=j+1|0;n=l&255;if(!(c>>>0>0|(c|0)==0&d>>>0>16383)){o=m;p=n;break}else{j=m;k=n;c=J}}}else{o=h;p=i}b[o>>0]=p;p=o+1-h|0;o=a+8|0;i=f[o>>2]|0;c=a+4|0;k=f[c>>2]|0;a:do if((i|0)<(p|0)){j=a+12|0;l=p;n=h;m=k;d=i;while(1){dJc(m|0,n|0,d|0)|0;q=f[o>>2]|0;r=f[a>>2]|0;if(!(hj[f[(f[r>>2]|0)+8>>2]&511](r,g,o)|0))break;r=n+q|0;s=l-q|0;q=f[g>>2]|0;f[c>>2]=q;d=f[o>>2]|0;f[j>>2]=(f[j>>2]|0)+d;t=q;if((d|0)>=(s|0)){v=s;w=r;x=t;break a}else{l=s;n=r;m=t}}f[c>>2]=0;f[o>>2]=0;b[a+16>>0]=1;u=e;return}else{v=p;w=h;x=k}while(0);dJc(x|0,w|0,v|0)|0;f[c>>2]=(f[c>>2]|0)+v;f[o>>2]=(f[o>>2]|0)-v;u=e;return}function dSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+11|0;e=b[d>>0]|0;if(e<<24>>24<0){g=a+4|0;h=f[g>>2]|0;if(h>>>0>127){i=h;j=c;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;o=g;break}}}else{m=c;n=h;o=g}}else{m=c;n=e&255;o=a+4|0}b[m>>0]=n;n=m+1|0;m=b[d>>0]|0;d=m<<24>>24<0;e=d?f[o>>2]|0:m&255;dJc(n|0,(d?f[a>>2]|0:a)|0,e|0)|0;return n+e|0}function eSb(a){a=a|0;return}function fSb(a){a=a|0;YDc(a);return}function gSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+16|0;e=f[d>>2]|0;g=f[a+8>>2]|0;if((g|0)>(e|0)){h=g-e|0;g=f[a+12>>2]|0;i=(h|0)<(g|0)?h:g;g=a+20|0;f[g>>2]=i;f[b>>2]=(f[a+4>>2]|0)+e;f[c>>2]=i;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);j=1;return j|0}else{f[a+20>>2]=0;j=0;return j|0}return 0}function hSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;h=a+20|0;i=f[h>>2]|0;if((i|0)>0)j=i;else{rTb(d,3,472425,82);oTb(c+74|0,mTb(mTb(d,472564)|0,472608)|0);sTb(d);j=f[h>>2]|0}if((j|0)<(b|0)){rTb(e,3,472425,84);oTb(c+73|0,mTb(e,472663)|0);sTb(e)}if((b|0)>-1){k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}rTb(g,3,472425,85);oTb(c+72|0,mTb(g,472533)|0);sTb(g);k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}function iSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+32|0;d=c;if((b|0)<=-1){rTb(d,3,472425,91);oTb(c+24|0,mTb(d,472533)|0);sTb(d)}f[a+20>>2]=0;d=f[a+8>>2]|0;e=a+16|0;a=f[e>>2]|0;g=(d-a|0)<(b|0);f[e>>2]=g?d:a+b|0;u=c;return g^1|0}function jSb(a){a=a|0;var b=0;b=f[a+16>>2]|0;J=((b|0)<0)<<31>>31;return b|0}function kSb(a){a=a|0;return}function lSb(a){a=a|0;YDc(a);return}function mSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+16|0;e=f[d>>2]|0;g=f[a+8>>2]|0;if((g|0)>(e|0)){h=g-e|0;g=f[a+12>>2]|0;i=(h|0)<(g|0)?h:g;g=a+20|0;f[g>>2]=i;f[b>>2]=(f[a+4>>2]|0)+e;f[c>>2]=i;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);j=1;return j|0}else{f[a+20>>2]=0;j=0;return j|0}return 0}function nSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;h=a+20|0;i=f[h>>2]|0;if((i|0)>0)j=i;else{rTb(d,3,472425,132);oTb(c+74|0,mTb(mTb(d,472564)|0,472608)|0);sTb(d);j=f[h>>2]|0}if((j|0)<(b|0)){rTb(e,3,472425,134);oTb(c+73|0,mTb(e,472663)|0);sTb(e)}if((b|0)>-1){k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}rTb(g,3,472425,135);oTb(c+72|0,mTb(g,472533)|0);sTb(g);k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}function oSb(a){a=a|0;var b=0;b=f[a+16>>2]|0;J=((b|0)<0)<<31>>31;return b|0}function pSb(a){a=a|0;return 0}function qSb(a){a=a|0;YDc(a);return}function rSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+64|0;g=e+24|0;h=e;i=e+48|0;j=a+4|0;a=f[j>>2]|0;if(!a){rTb(g,3,472425,151);oTb(e+49|0,mTb(g,472836)|0);sTb(g);k=f[j>>2]|0}else k=a;a=b[k+11>>0]|0;g=a<<24>>24<0;if(g){l=f[k+4>>2]|0;m=(f[k+8>>2]&2147483647)+-1|0}else{l=a&255;m=10}do if(l>>>0<m>>>0){if(g)n=(f[k+8>>2]&2147483647)+-1|0;else n=10;oEc(k,n,0)}else{if((l|0)<=1073741823){a=l<<1;oEc(k,(a|0)>16?a:16,0);break}rTb(h,2,472425,164);oTb(i,mTb(mTb(h,472913)|0,472963)|0);sTb(h);o=0;u=e;return o|0}while(0);h=f[j>>2]|0;i=b[h+11>>0]|0;k=i<<24>>24<0;if(k)p=f[h+4>>2]|0;else p=i&255;do if(p)if(k){q=f[h>>2]|0;break}else{q=h;break}else q=0;while(0);f[c>>2]=q+l;q=f[j>>2]|0;j=b[q+11>>0]|0;if(j<<24>>24<0)r=f[q+4>>2]|0;else r=j&255;f[d>>2]=r-l;o=1;u=e;return o|0}function sSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d;if((c|0)<=-1){rTb(e,3,472425,182);oTb(d+74|0,mTb(e,472533)|0);sTb(e)}e=a+4|0;a=f[e>>2]|0;if(!a){rTb(g,3,472425,183);oTb(d+73|0,mTb(g,472836)|0);sTb(g);i=f[e>>2]|0}else i=a;a=b[i+11>>0]|0;if(a<<24>>24<0)j=f[i+4>>2]|0;else j=a&255;if(j>>>0<c>>>0){rTb(h,3,472425,184);oTb(d+72|0,mTb(h,472868)|0);sTb(h);h=f[e>>2]|0;k=b[h+11>>0]|0;l=h}else{k=a;l=i}if(k<<24>>24<0){m=f[l+4>>2]|0;n=m-c|0;oEc(l,n,0);u=d;return}else{m=k&255;n=m-c|0;oEc(l,n,0);u=d;return}}function tSb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c;e=a+4|0;a=f[e>>2]|0;if(!a){rTb(d,3,472425,189);oTb(c+24|0,mTb(d,472836)|0);sTb(d);g=f[e>>2]|0}else g=a;a=b[g+11>>0]|0;if(a<<24>>24<0){h=f[g+4>>2]|0;J=0;u=c;return h|0}else{h=a&255;J=0;u=c;return h|0}return 0}function uSb(a){a=a|0;var c=0;f[a>>2]=160976;if(b[a+8>>0]|0?(c=f[a+4>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+24>>2]|0;if(!c)return;ZDc(c);return}function vSb(a){a=a|0;var c=0;f[a>>2]=160976;if(b[a+8>>0]|0?(c=f[a+4>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+24>>2]|0;if(!c){YDc(a);return}ZDc(c);YDc(a);return}function wSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+9|0;if(b[e>>0]|0){g=0;return g|0}h=a+24|0;i=f[h>>2]|0;if(!i){j=f[a+28>>2]|0;k=XDc((j|0)>-1?j:-1)|0;f[h>>2]=k;l=k}else l=i;i=a+36|0;k=f[i>>2]|0;if((k|0)>0){f[c>>2]=l+(f[a+32>>2]|0)+(0-k);f[d>>2]=k;f[i>>2]=0;g=1;return g|0}i=f[a+4>>2]|0;k=hj[f[(f[i>>2]|0)+8>>2]&511](i,l,f[a+28>>2]|0)|0;f[a+32>>2]=k;if((k|0)>=1){l=a+16|0;i=l;j=UIc(f[i>>2]|0,f[i+4>>2]|0,k|0,((k|0)<0)<<31>>31|0)|0;i=l;f[i>>2]=j;f[i+4>>2]=J;f[d>>2]=k;f[c>>2]=f[h>>2];g=1;return g|0}if((k|0)<0)b[e>>0]=1;ASb(a);g=0;return g|0}function xSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+80|0;d=c+48|0;e=c+74|0;g=c+24|0;h=c+73|0;i=c;j=c+72|0;k=a+36|0;if(!((f[k>>2]|0)==0?(f[a+24>>2]|0)!=0:0)){rTb(d,3,472425,266);oTb(e,mTb(mTb(d,473025)|0,473085)|0);sTb(d)}if((f[a+32>>2]|0)<(b|0)){rTb(g,3,472425,268);oTb(h,mTb(mTb(g,473128)|0,473170)|0);sTb(g)}if((b|0)>-1){f[k>>2]=b;u=c;return}rTb(i,3,472425,271);oTb(j,mTb(mTb(i,472533)|0,473248)|0);sTb(i);f[k>>2]=b;u=c;return}function ySb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;if((c|0)<=-1){rTb(e,3,472425,278);oTb(d+24|0,mTb(e,472533)|0);sTb(e)}if(b[a+9>>0]|0){g=0;u=d;return g|0}e=a+36|0;h=f[e>>2]|0;if((h|0)<(c|0)){i=c-h|0;f[e>>2]=0;j=f[a+4>>2]|0;k=Mi[f[(f[j>>2]|0)+12>>2]&1023](j,i)|0;j=a+16|0;a=j;l=UIc(f[a>>2]|0,f[a+4>>2]|0,k|0,((k|0)<0)<<31>>31|0)|0;a=j;f[a>>2]=l;f[a+4>>2]=J;g=(k|0)==(i|0);u=d;return g|0}else{f[e>>2]=h-c;g=1;u=d;return g|0}return 0}function zSb(a){a=a|0;var b=0,c=0;b=a+16|0;c=f[a+36>>2]|0;a=TIc(f[b>>2]|0,f[b+4>>2]|0,c|0,((c|0)<0)<<31>>31|0)|0;return a|0}function ASb(a){a=a|0;var b=0,c=0;b=u;u=u+32|0;c=b;if(f[a+36>>2]|0){rTb(c,3,472425,311);oTb(b+24|0,mTb(c,473290)|0);sTb(c)}f[a+32>>2]=0;c=a+24|0;a=f[c>>2]|0;if(!a){u=b;return}ZDc(a);f[c>>2]=0;u=b;return}function BSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+4096|0;d=c;e=0;while(1){if((e|0)>=(b|0)){g=4;break}h=b-e|0;i=hj[f[(f[a>>2]|0)+8>>2]&511](a,d,(h|0)<4096?h:4096)|0;h=(i|0)<1;if(h){g=4;break}else e=(h?0:i)+e|0}if((g|0)==4){u=c;return e|0}return 0}function CSb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=160872;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=(d|0)>0?d:c;f[a+16>>2]=0;f[a+20>>2]=0;return}function DSb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=160904;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=(d|0)>0?d:c;f[a+16>>2]=0;f[a+20>>2]=0;return}function ESb(a,b){a=a|0;b=b|0;f[a>>2]=160940;f[a+4>>2]=b;return}function FSb(a,c,d){a=a|0;c=c|0;d=d|0;f[a>>2]=160976;f[a+4>>2]=c;b[a+8>>0]=0;b[a+9>>0]=0;c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=0;f[a+28>>2]=(d|0)>0?d:8192;f[a+32>>2]=0;f[a+36>>2]=0;return}function GSb(a,b){a=a|0;b=b|0;return hj[f[(f[a>>2]|0)+64>>2]&511](a,(f[220805]|0)!=0,b)|0}function HSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+80|0;g=e+48|0;h=e+24|0;i=e;j=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;if(j|0){k=BRb(a,(f[j+4>>2]|0)+20|0,(f[j>>2]|0)+-1|0,c,d)|0;u=e;return k|0}j=_i[f[(f[a>>2]|0)+60>>2]&1023](a)|0;DSb(g,d,j,-1);XRb(h,g);b[h+18>>0]=1;b[h+19>>0]=c&1;mi[f[(f[a>>2]|0)+52>>2]&2047](a,h);if(b[h+16>>0]|0){rTb(i,3,473421,373);oTb(e+72|0,mTb(i,473512)|0);sTb(i)}YRb(h);k=d+j|0;u=e;return k|0}function ISb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d+40|0;g=d+16|0;h=d;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){i=0;u=d;return i|0}if(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0){i=1;u=d;return i|0}rTb(g,2,473421,121);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;uEc(h,473582)|0;uEc(h,473589)|0;uEc(h,473595)|0;mi[f[(f[a>>2]|0)+8>>2]&2047](e,a);c=e+11|0;j=b[c>>0]|0;k=j<<24>>24<0;tEc(h,k?f[e>>2]|0:e,k?f[e+4>>2]|0:j&255)|0;if((b[c>>0]|0)<0)YDc(f[e>>2]|0);uEc(h,473614)|0;mi[f[(f[a>>2]|0)+36>>2]&2047](e,a);a=e+11|0;c=b[a>>0]|0;j=c<<24>>24<0;tEc(h,j?f[e>>2]|0:e,j?f[e+4>>2]|0:c&255)|0;if((b[a>>0]|0)<0)YDc(f[e>>2]|0);oTb(d+52|0,nTb(g,h)|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);sTb(g);i=0;u=d;return i|0}function JSb(a,c){a=a|0;c=c|0;var e=0,g=0;e=u;u=u+64|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=c;c=g+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d[c+12>>1]=0;f[g+28>>2]=2147483647;f[g+32>>2]=0;f[g+36>>2]=2147483647;c=f[40215]|0;f[g+40>>2]=c;f[g+44>>2]=c;b[g+48>>0]=1;f[g+52>>2]=0;f[g+56>>2]=0;JRb(g)|0;c=ISb(a,g)|0;a=c&(b[g+24>>0]|0)!=0;DRb(g);u=e;return a|0}function KSb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+60|0;j=e+108|0;k=e;l=b[c+11>>0]|0;m=l<<24>>24<0;n=m?f[c>>2]|0:c;o=m?f[c+4>>2]|0:l&255;f[k>>2]=n;f[k+4>>2]=n+o;f[k+8>>2]=0;f[k+12>>2]=o;n=k+16|0;f[n>>2]=0;f[n+4>>2]=0;d[n+8>>1]=0;f[k+28>>2]=o;f[k+32>>2]=0;f[k+36>>2]=2147483647;o=f[40215]|0;f[k+40>>2]=o;f[k+44>>2]=o;b[k+48>>0]=1;f[k+52>>2]=0;f[k+56>>2]=0;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);if(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,k)|0){if(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0){p=(b[k+24>>0]|0)!=0;DRb(k);u=e;return p|0}rTb(h,2,473421,121);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;uEc(i,473582)|0;uEc(i,473589)|0;uEc(i,473595)|0;mi[f[(f[a>>2]|0)+8>>2]&2047](g,a);o=g+11|0;n=b[o>>0]|0;l=n<<24>>24<0;tEc(i,l?f[g>>2]|0:g,l?f[g+4>>2]|0:n&255)|0;if((b[o>>0]|0)<0)YDc(f[g>>2]|0);uEc(i,473614)|0;mi[f[(f[a>>2]|0)+36>>2]&2047](g,a);a=g+11|0;o=b[a>>0]|0;n=o<<24>>24<0;tEc(i,n?f[g>>2]|0:g,n?f[g+4>>2]|0:o&255)|0;if((b[a>>0]|0)<0)YDc(f[g>>2]|0);oTb(j,nTb(h,i)|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);sTb(h)}p=0;DRb(k);u=e;return p|0}function LSb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+64|0;g=e;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c>>2]|0:c;k=i?f[c+4>>2]|0:h&255;f[g>>2]=j;f[g+4>>2]=j+k;f[g+8>>2]=0;f[g+12>>2]=k;j=g+16|0;f[j>>2]=0;f[j+4>>2]=0;d[j+8>>1]=0;f[g+28>>2]=k;f[g+32>>2]=0;f[g+36>>2]=2147483647;k=f[40215]|0;f[g+40>>2]=k;f[g+44>>2]=k;b[g+48>>0]=1;f[g+52>>2]=0;f[g+56>>2]=0;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);k=Mi[f[(f[a>>2]|0)+44>>2]&1023](a,g)|0;a=k&(b[g+24>>0]|0)!=0;DRb(g);u=e;return a|0}function MSb(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+112|0;h=g+96|0;i=g+72|0;j=g+60|0;k=g+108|0;l=g;f[l>>2]=c;f[l+4>>2]=c+e;f[l+8>>2]=0;f[l+12>>2]=e;c=l+16|0;f[c>>2]=0;f[c+4>>2]=0;d[c+8>>1]=0;f[l+28>>2]=e;f[l+32>>2]=0;f[l+36>>2]=2147483647;e=f[40215]|0;f[l+40>>2]=e;f[l+44>>2]=e;b[l+48>>0]=1;f[l+52>>2]=0;f[l+56>>2]=0;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);if(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,l)|0){if(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0){m=(b[l+24>>0]|0)!=0;DRb(l);u=g;return m|0}rTb(i,2,473421,121);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;uEc(j,473582)|0;uEc(j,473589)|0;uEc(j,473595)|0;mi[f[(f[a>>2]|0)+8>>2]&2047](h,a);e=h+11|0;c=b[e>>0]|0;n=c<<24>>24<0;tEc(j,n?f[h>>2]|0:h,n?f[h+4>>2]|0:c&255)|0;if((b[e>>0]|0)<0)YDc(f[h>>2]|0);uEc(j,473614)|0;mi[f[(f[a>>2]|0)+36>>2]&2047](h,a);a=h+11|0;e=b[a>>0]|0;c=e<<24>>24<0;tEc(j,c?f[h>>2]|0:h,c?f[h+4>>2]|0:e&255)|0;if((b[a>>0]|0)<0)YDc(f[h>>2]|0);oTb(k,nTb(i,j)|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);sTb(i)}m=0;DRb(l);u=g;return m|0}function NSb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+96|0;h=g+48|0;i=g+72|0;j=g+24|0;k=g+85|0;l=g;m=g+84|0;if((a|0)!=(c|0)){rTb(h,3,473421,68);c=mTb(h,473696)|0;mi[f[(f[e>>2]|0)+8>>2]&2047](i,e);oTb(g+86|0,mTb(nTb(c,i)|0,473780)|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);sTb(h)}if((d|0)==(a|0)){rTb(l,3,473421,75);n=mTb(l,474070)|0;oTb(m,n);sTb(l);u=g;return}rTb(j,3,473421,71);a=mTb(mTb(j,473829)|0,473915)|0;mi[f[(f[e>>2]|0)+8>>2]&2047](i,e);oTb(k,mTb(nTb(a,i)|0,518136)|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);sTb(j);rTb(l,3,473421,75);n=mTb(l,474070)|0;oTb(m,n);sTb(l);u=g;return}function OSb(a,b){a=a|0;b=b|0;return PSb(a,b)|0}function PSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;g=c+11|0;h=b[g>>0]|0;if(h<<24>>24<0)i=f[c+4>>2]|0;else i=h&255;h=_i[f[(f[a>>2]|0)+48>>2]&1023](a)|0;if((h|0)<0){rTb(e,2,473421,289);oTb(d+24|0,qTb(mTb(e,473656)|0,h)|0);sTb(e);j=0;u=d;return j|0}oEc(c,h+i|0,0);e=b[g>>0]|0;g=e<<24>>24<0;if(g)k=f[c+4>>2]|0;else k=e&255;do if(k)if(g){l=f[c>>2]|0;break}else{l=c;break}else l=0;while(0);c=l+i|0;i=(Mi[f[(f[a>>2]|0)+56>>2]&1023](a,c)|0)-c|0;if((i|0)==(h|0)){j=1;u=d;return j|0}NSb(h,_i[f[(f[a>>2]|0)+48>>2]&1023](a)|0,i,a);j=1;u=d;return j|0}function QSb(a,c){a=a|0;c=c|0;var d=0;d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[d>>0]=0}return PSb(a,c)|0}function RSb(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(PSb(c,a)|0)return;c=a+11|0;if((b[c>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0;return}else{b[a>>0]=0;b[c>>0]=0;return}}function SSb(a,b){a=a|0;b=b|0;iEc(b,a)|0;return}function TSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;h=g+b|0;b=a+8|0;i=f[b>>2]|0;j=a+12|0;k=f[j>>2]|0;if((i|0)>=(h|0)){l=k;m=g;n=l+4+(m<<2)|0;u=c;return n|0}g=f[a>>2]|0;a=i<<1;i=(a|0)<(h|0)?h:a;a=(i|0)>4?i:4;if(a>>>0>1073741822){rTb(d,3,474123,59);oTb(c+24|0,mTb(mTb(d,474216)|0,474333)|0);sTb(d)}d=a<<2;i=(g|0)==0;if(i)o=VDc(d+4|0)|0;else{h=d+11&-8;if(f[g+64>>2]|0)OQb(g,23816,h);o=MQb(g,h)|0}f[j>>2]=o;f[b>>2]=a;if((k|0)!=0?(a=f[k>>2]|0,(a|0)>0):0){dJc(o+4|0,k+4|0,a<<2|0)|0;p=f[k>>2]|0;q=f[j>>2]|0}else{p=0;q=o}f[q>>2]=p;if(i){YDc(k);r=f[j>>2]|0}else r=q;l=r;m=f[e>>2]|0;n=l+4+(m<<2)|0;u=c;return n|0}function USb(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;if((c|0)>=(b|0))return;TSb(a,b-c|0)|0;return}function VSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+12|0;e=f[d>>2]|0;if(!e)return;g=c+b|0;b=f[e>>2]|0;if((g|0)<(b|0)){h=g;g=e;while(1){f[g+4+(h-c<<2)>>2]=f[g+4+(h<<2)>>2];h=h+1|0;i=f[d>>2]|0;j=f[i>>2]|0;if((h|0)>=(j|0)){k=j;l=i;break}else g=i}}else{k=b;l=e}e=a+4|0;f[e>>2]=(f[e>>2]|0)-c;f[l>>2]=k-c;return}function WSb(a){a=a|0;var c=0;f[a>>2]=161008;c=a+12|0;if((b[c+11>>0]|0)>=0)return;YDc(f[c>>2]|0);return}function XSb(a){a=a|0;var c=0;f[a>>2]=161008;c=a+12|0;if((b[c+11>>0]|0)>=0){YDc(a);return}YDc(f[c>>2]|0);YDc(a);return}function YSb(a){a=a|0;var c=0,d=0;c=a+12|0;if((b[c+11>>0]|0)<0){d=f[c>>2]|0;return d|0}else{d=c;return d|0}return 0}function ZSb(a){a=a|0;return}function _Sb(a){a=a|0;YDc(a);return}function $Sb(a){a=a|0;var c=0;c=b[a+8>>0]|0;Ui[f[a+4>>2]&255]();if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function aTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+256|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;k=e+128|0;l=e+88|0;m=e+112|0;n=e+64|0;if((c|0)>3005001){f[l>>2]=3;f[l+4>>2]=474489;f[l+8>>2]=68;o=l+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;uEc(o,474580)|0;f[j>>2]=(c>>>0)/1e6|0;f[j+4>>2]=(((c>>>0)/1e3|0)>>>0)%1e3|0;f[j+8>>2]=(c>>>0)%1e3|0;gqc(k,128,474611,j)|0;c=k+127|0;b[c>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=Mpc(k)|0;if(p>>>0>4294967279)dEc(m);if(p>>>0<11){q=m+11|0;b[q>>0]=p;if(!p){r=m;s=q}else{t=m;v=q;w=7}}else{q=p+16&-16;x=VDc(q)|0;f[m>>2]=x;f[m+8>>2]=q|-2147483648;f[m+4>>2]=p;t=x;v=m+11|0;w=7}if((w|0)==7){dJc(t|0,k|0,p|0)|0;r=t;s=v}b[r+p>>0]=0;p=b[s>>0]|0;r=p<<24>>24<0;tEc(o,r?f[m>>2]|0:m,r?f[m+4>>2]|0:p&255)|0;uEc(o,474620)|0;f[i>>2]=3;f[i+4>>2]=5;f[i+8>>2]=1;gqc(k,128,474611,i)|0;b[c>>0]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=Mpc(k)|0;if(c>>>0>4294967279)dEc(j);if(c>>>0<11){i=j+11|0;b[i>>0]=c;if(!c){y=j;z=i}else{A=j;B=i;w=13}}else{i=c+16&-16;p=VDc(i)|0;f[j>>2]=p;f[j+8>>2]=i|-2147483648;f[j+4>>2]=c;A=p;B=j+11|0;w=13}if((w|0)==13){dJc(A|0,k|0,c|0)|0;y=A;z=B}b[y+c>>0]=0;c=b[z>>0]|0;y=c<<24>>24<0;tEc(o,y?f[j>>2]|0:j,y?f[j+4>>2]|0:c&255)|0;uEc(o,474691)|0;uEc(o,d)|0;uEc(o,474897)|0;bTb(l);if((b[z>>0]|0)<0)YDc(f[j>>2]|0);if((b[s>>0]|0)<0)YDc(f[m>>2]|0);if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0)}if((a|0)>=3005e3){u=e;return}f[n>>2]=3;f[n+4>>2]=474489;f[n+8>>2]=79;o=n+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;uEc(o,474901)|0;f[h>>2]=(a|0)/1e6|0;f[h+4>>2]=((a|0)/1e3|0|0)%1e3|0;f[h+8>>2]=(a|0)%1e3|0;gqc(k,128,474611,h)|0;a=k+127|0;b[a>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;s=Mpc(k)|0;if(s>>>0>4294967279)dEc(m);if(s>>>0<11){j=m+11|0;b[j>>0]=s;if(!s){C=m;D=j}else{E=m;F=j;w=26}}else{j=s+16&-16;z=VDc(j)|0;f[m>>2]=z;f[m+8>>2]=j|-2147483648;f[m+4>>2]=s;E=z;F=m+11|0;w=26}if((w|0)==26){dJc(E|0,k|0,s|0)|0;C=E;D=F}b[C+s>>0]=0;s=b[D>>0]|0;C=s<<24>>24<0;tEc(o,C?f[m>>2]|0:m,C?f[m+4>>2]|0:s&255)|0;uEc(o,474944)|0;f[g>>2]=3;f[g+4>>2]=5;f[g+8>>2]=1;gqc(k,128,474611,g)|0;b[a>>0]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=Mpc(k)|0;if(a>>>0>4294967279)dEc(h);if(a>>>0<11){g=h+11|0;b[g>>0]=a;if(!a){G=h;H=g}else{I=h;J=g;w=32}}else{g=a+16&-16;s=VDc(g)|0;f[h>>2]=s;f[h+8>>2]=g|-2147483648;f[h+4>>2]=a;I=s;J=h+11|0;w=32}if((w|0)==32){dJc(I|0,k|0,a|0)|0;G=I;H=J}b[G+a>>0]=0;a=b[H>>0]|0;G=a<<24>>24<0;tEc(o,G?f[h>>2]|0:h,G?f[h+4>>2]|0:a&255)|0;uEc(o,475038)|0;uEc(o,d)|0;uEc(o,474897)|0;bTb(n);if((b[H>>0]|0)<0)YDc(f[h>>2]|0);if((b[D>>0]|0)<0)YDc(f[m>>2]|0);if((b[o+11>>0]|0)>=0){u=e;return}YDc(f[o>>2]|0);u=e;return}function bTb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if((f[a>>2]|0)!=3){if((f[220806]|0)!=2){f[d>>2]=161028;f[d+4>>2]=126;b[d+8>>0]=0;DTb(883224,d)}d=f[220809]|0;dTb(d);e=(f[220810]|0)>0;eTb(d);if(!e){g=f[a>>2]|0;h=6}}else{g=3;h=6}if((h|0)==6)ei[f[40260]&511](g,f[a+4>>2]|0,f[a+8>>2]|0,a+12|0);if((f[a>>2]|0)==3){g=af(24)|0;fTb(g,f[a+4>>2]|0,f[a+8>>2]|0,a+12|0);ig(g|0,20208,1398)}else{u=c;return}}function cTb(){var a=0,b=0;a=VDc(4)|0;b=VDc(28)|0;f[a>>2]=b;ng(b|0,0)|0;f[220809]=a;iTb(127);return}function dTb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c;e=WIc(f[a>>2]|0)|0;if(!e){u=c;return}f[d>>2]=3;f[d+4>>2]=474489;f[d+8>>2]=378;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;uEc(a,475309)|0;uEc(a,Yoc(e)|0)|0;bTb(d);if((b[a+11>>0]|0)>=0){u=c;return}YDc(f[a>>2]|0);u=c;return}function eTb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c;e=VIc(f[a>>2]|0)|0;if(!e){u=c;return}f[d>>2]=3;f[d+4>>2]=474489;f[d+8>>2]=385;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;uEc(a,475286)|0;uEc(a,Yoc(e)|0)|0;bTb(d);if((b[a+11>>0]|0)>=0){u=c;return}YDc(f[a>>2]|0);u=c;return}function fTb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=161008;f[a+4>>2]=b;f[a+8>>2]=c;fEc(a+12|0,d);return}function gTb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;if((a|0)<0){u=g;return}i=f[44350]|0;j=(b[e+11>>0]|0)<0?f[e>>2]|0:e;f[h>>2]=f[161044+(a<<2)>>2];f[h+4>>2]=c;f[h+8>>2]=d;f[h+12>>2]=j;eqc(i,475259,h)|0;aqc(i)|0;u=g;return}function hTb(){var a=0,b=0;a=f[220809]|0;if(!a){f[220809]=0;return}Zf(f[a>>2]|0)|0;b=f[a>>2]|0;if(b|0)YDc(b);YDc(a);f[220809]=0;return}function iTb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c+4|0;e=c;f[e>>2]=a;if((f[220808]|0)!=2){f[d>>2]=161028;f[d+4>>2]=128;b[d+8>>0]=0;DTb(883232,d)}d=(f[220807]|0)+36|0;dTb(d);a=f[220807]|0;g=a+4|0;h=f[g>>2]|0;if((h|0)==(f[a+8>>2]|0)){kTb(a,e);eTb(d);u=c;return}else{f[h>>2]=f[e>>2];f[g>>2]=(f[g>>2]|0)+4;eTb(d);u=c;return}}function jTb(){var a=0;a=VDc(40)|0;lTb(a);f[220807]=a;return}function kTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function lTb(a){a=a|0;var b=0,c=0;b=a;c=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(c|0));b=VDc(28)|0;f[a+36>>2]=b;ng(b|0,0)|0;return}function mTb(a,b){a=a|0;b=b|0;uEc(a+12|0,b)|0;return a|0}function nTb(a,c){a=a|0;c=c|0;var d=0,e=0;d=b[c+11>>0]|0;e=d<<24>>24<0;tEc(a+12|0,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)|0;return a|0}function oTb(a,b){a=a|0;b=b|0;bTb(b);return}function pTb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+144|0;e=d;g=d+8|0;f[e>>2]=c;gqc(g,128,502165,e)|0;b[g+127>>0]=0;uEc(a+12|0,g)|0;u=d;return a|0}function qTb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+144|0;e=d;g=d+8|0;f[e>>2]=c;gqc(g,128,475330,e)|0;b[g+127>>0]=0;uEc(a+12|0,g)|0;u=d;return a|0}function rTb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=b;f[a+4>>2]=c;f[a+8>>2]=d;d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;return}function sTb(a){a=a|0;var c=0;c=a+12|0;if((b[c+11>>0]|0)>=0)return;YDc(f[c>>2]|0);return}function tTb(a){a=a|0;var b=0;b=VDc(28)|0;f[a>>2]=b;ng(b|0,0)|0;return}function uTb(a){a=a|0;var b=0;Zf(f[a>>2]|0)|0;b=f[a>>2]|0;if(!b)return;YDc(b);return}function vTb(a){a=a|0;return}function wTb(a){a=a|0;return hJc(a|0)|0}function xTb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c+4|0;e=c;f[e>>2]=a;if((f[220808]|0)!=2){f[d>>2]=161028;f[d+4>>2]=128;b[d+8>>0]=0;DTb(883232,d)}d=(f[220807]|0)+36|0;dTb(d);a=f[220807]|0;g=a+16|0;h=f[g>>2]|0;if((h|0)==(f[a+20>>2]|0)){yTb(a+12|0,e);eTb(d);u=c;return}else{f[h>>2]=f[e>>2];f[g>>2]=(f[g>>2]|0)+4;eTb(d);u=c;return}}function yTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function zTb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if((f[220808]|0)!=2){f[d>>2]=161028;f[d+4>>2]=128;b[d+8>>0]=0;DTb(883232,d)}e=(f[220807]|0)+36|0;dTb(e);g=f[220807]|0;f[d>>2]=a;h=g+28|0;i=f[h>>2]|0;if((i|0)==(f[g+32>>2]|0)){ATb(g+24|0,d);eTb(e);u=c;return}else{f[i>>2]=a;f[h>>2]=(f[h>>2]|0)+4;eTb(e);u=c;return}}function ATb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function BTb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220808]|0)!=2){f[c>>2]=161028;f[c+4>>2]=128;b[c+8>>0]=0;DTb(883232,c)}c=f[220807]|0;if(!c){u=a;return}CTb(c);YDc(c);f[220807]=0;u=a;return}function CTb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+4|0;d=f[a>>2]|0;if((f[c>>2]|0)!=(d|0)){e=0;g=d;do{Ui[f[g+(e<<2)>>2]&255]();e=e+1|0;g=f[a>>2]|0}while(e>>>0<(f[c>>2]|0)-g>>2>>>0)}g=a+12|0;e=a+16|0;d=f[e>>2]|0;h=f[g>>2]|0;if((d|0)!=(h|0)){i=0;j=h;h=d;while(1){d=f[j+(i<<2)>>2]|0;if((b[d+11>>0]|0)<0){YDc(f[d>>2]|0);k=f[g>>2]|0;l=f[e>>2]|0}else{k=j;l=h}i=i+1|0;if(i>>>0>=l-k>>2>>>0)break;else{j=k;h=l}}}l=a+24|0;h=a+28|0;k=f[l>>2]|0;if((f[h>>2]|0)!=(k|0)){j=0;i=k;do{k=f[i+(j<<2)>>2]|0;Yi[f[f[k>>2]>>2]&2047](k);j=j+1|0;i=f[l>>2]|0}while(j>>>0<(f[h>>2]|0)-i>>2>>>0)}i=a+36|0;Zf(f[i>>2]|0)|0;j=f[i>>2]|0;if(j|0)YDc(j);j=f[l>>2]|0;if(j|0){l=f[h>>2]|0;if((l|0)!=(j|0))f[h>>2]=l+(~((l+-4-j|0)>>>2)<<2);YDc(j)}j=f[g>>2]|0;if(j|0){g=f[e>>2]|0;if((g|0)!=(j|0))f[e>>2]=g+(~((g+-4-j|0)>>>2)<<2);YDc(j)}j=f[a>>2]|0;if(!j)return;a=f[c>>2]|0;if((a|0)!=(j|0))f[c>>2]=a+(~((a+-4-j|0)>>>2)<<2);YDc(j);return}function DTb(a,b){a=a|0;b=b|0;var c=0;if((f[a>>2]|0)==2)return;c=f[a>>2]|0;if(!c)f[a>>2]=1;switch(((c|0)==0?0:c)|0){case 0:{Yi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=2;return}case 1:{do Ye()|0;while((f[a>>2]|0)==1);return}default:return}}function ETb(){var a=0,b=0,c=0;a=u;u=u+16|0;b=a+8|0;c=a;f[220811]=0;f[220812]=0;f[220813]=0;f[220814]=0;be(1773,883244,x|0)|0;f[c>>2]=1154740;f[c+4>>2]=0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];GTb(883260,1,b);be(1773,883260,x|0)|0;f[c>>2]=1154740;f[c+4>>2]=0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];GTb(883276,2,b);be(1773,883276,x|0)|0;u=a;return}function FTb(a){a=a|0;var c=0;c=a+4|0;if((b[c+11>>0]|0)>=0)return;YDc(f[c>>2]|0);return}function GTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;f[a>>2]=c;h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(!c){u=e;return}c=f[d>>2]|0;if(!c){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0}else{a=f[d+4>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(a>>>0>4294967279)dEc(g);if(a>>>0<11){b[g+11>>0]=a;if(!a)i=g;else{j=g;k=9}}else{d=a+16&-16;l=VDc(d)|0;f[g>>2]=l;f[g+8>>2]=d|-2147483648;f[g+4>>2]=a;j=l;k=9}if((k|0)==9){dJc(j|0,c|0,a|0)|0;i=j}b[i+a>>0]=0}iEc(h,g)|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);u=e;return}function HTb(a){a=a|0;return}function ITb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=c>>>3;if(!g){i=0;u=d;return i|0}switch(c&7){case 0:{c=f[a>>2]|0;if(c>>>0<(f[a+4>>2]|0)>>>0?(b[c>>0]|0)>-1:0)f[a>>2]=c+1;else j=6;if((j|0)==6?(IRb(e,a),(b[e+8>>0]|0)==0):0){i=0;u=d;return i|0}i=1;u=d;return i|0}case 1:{c=f[a>>2]|0;if(((f[a+4>>2]|0)-c|0)<=7)if(URb(a,e)|0)j=11;else k=0;else{l=c;m=l;n=l+4|0;l=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;n=e;f[n>>2]=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;f[n+4>>2]=l;f[a>>2]=c+8;j=11}if((j|0)==11)k=1;i=k;u=d;return i|0}case 2:{k=f[a>>2]|0;c=a+4|0;l=f[c>>2]|0;n=l;if(k>>>0<l>>>0){l=b[k>>0]|0;m=l&255;if(l<<24>>24>-1){l=k+1|0;f[a>>2]=l;o=m;p=l;q=n}else{r=m;j=16}}else{r=0;j=16}do if((j|0)==16){m=HRb(a,r)|0;if((J|0)<0|(m|0)<0){i=0;u=d;return i|0}else{o=m;p=f[a>>2]|0;q=f[c>>2]|0;break}}while(0);c=q-p|0;if((c|0)<(o|0)){if(!(PRb(a,o,c)|0)){i=0;u=d;return i|0}}else f[a>>2]=p+o;i=1;u=d;return i|0}case 3:{o=a+40|0;p=f[o>>2]|0;f[o>>2]=p+-1;if((p|0)<=0){i=0;u=d;return i|0}p=a+4|0;c=a+20|0;while(1){q=f[a>>2]|0;if(q>>>0<(f[p>>2]|0)>>>0){r=b[q>>0]|0;m=r&255;if(r<<24>>24>-1){f[a>>2]=q+1;s=m}else{t=m;j=27}}else{t=0;j=27}if((j|0)==27){j=0;s=WRb(a,t)|0}f[c>>2]=s;if((s|0)==0|(s&7|0)==4)break;if(!(ITb(a,s)|0)){i=0;j=38;break}}if((j|0)==38){u=d;return i|0}c=f[o>>2]|0;if((c|0)<(f[a+44>>2]|0))f[o>>2]=c+1;i=(s|0)==(g<<3|4|0);u=d;return i|0}case 5:{g=f[a>>2]|0;if(((f[a+4>>2]|0)-g|0)<=3)if(TRb(a,e)|0)j=36;else v=0;else{s=g;f[e>>2]=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[a>>2]=g+4;j=36}if((j|0)==36)v=1;i=v;u=d;return i|0}default:{i=0;u=d;return i|0}}return 0}function JTb(a,b,c){a=a|0;b=b|0;c=c|0;ZRb(c,a,b<<2);return}function KTb(a,b,c){a=a|0;b=b|0;c=c|0;ZRb(c,a,b<<3);return}function LTb(a,b,c){a=a|0;b=b|0;c=c|0;ZRb(c,a,b);return}function MTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{bSb(d,e);o=f[a>>2]|0}e=((c|0)<0)<<31>>31;if((o|0)<=9){cSb(d,c,e);return}o=d+4|0;d=f[o>>2]|0;g=c&255;if(c>>>0>127){n=d;h=g;m=c;c=e;while(1){b[n>>0]=h|-128;e=m;m=aJc(m|0,c|0,7)|0;j=n+1|0;i=m&255;if(!(c>>>0>0|(c|0)==0&e>>>0>16383)){p=j;q=i;break}else{n=j;h=i;c=J}}}else{p=d;q=g}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function NTb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)>4){h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;h=(f[a>>2]|0)-o|0;f[a>>2]=h;p=h}else{bSb(e,g);p=f[a>>2]|0}if((p|0)<=9){cSb(e,c,d);return}p=e+4|0;e=f[p>>2]|0;g=c&255;if(d>>>0>0|(d|0)==0&c>>>0>127){h=e;o=g;i=c;c=d;while(1){b[h>>0]=o|-128;d=i;i=aJc(i|0,c|0,7)|0;n=h+1|0;k=i&255;if(!(c>>>0>0|(c|0)==0&d>>>0>16383)){q=n;r=k;break}else{h=n;o=k;c=J}}}else{q=e;r=g}b[q>>0]=r;r=q+1-e|0;f[p>>2]=(f[p>>2]|0)+r;f[a>>2]=(f[a>>2]|0)-r;return}function OTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{bSb(d,e);o=f[a>>2]|0}if((o|0)<=4){bSb(d,c);return}o=d+4|0;d=f[o>>2]|0;if(c>>>0>127){e=c;g=d;while(1){b[g>>0]=e|128;n=e>>>7;h=g+1|0;if(e>>>0>16383){e=n;g=h}else{p=h;q=n;break}}}else{p=d;q=c}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function PTb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)>4){h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;h=(f[a>>2]|0)-o|0;f[a>>2]=h;p=h}else{bSb(e,g);p=f[a>>2]|0}if((p|0)<=9){cSb(e,c,d);return}p=e+4|0;e=f[p>>2]|0;g=c&255;if(d>>>0>0|(d|0)==0&c>>>0>127){h=e;o=g;i=c;c=d;while(1){b[h>>0]=o|-128;d=i;i=aJc(i|0,c|0,7)|0;n=h+1|0;k=i&255;if(!(c>>>0>0|(c|0)==0&d>>>0>16383)){q=n;r=k;break}else{h=n;o=k;c=J}}}else{q=e;r=g}b[q>>0]=r;r=q+1-e|0;f[p>>2]=(f[p>>2]|0)+r;f[a>>2]=(f[a>>2]|0)-r;return}function QTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{bSb(d,e);o=f[a>>2]|0}e=c<<1^c>>31;if((o|0)<=4){bSb(d,e);return}o=d+4|0;d=f[o>>2]|0;if(e>>>0>127){c=e;g=d;while(1){b[g>>0]=c|128;n=c>>>7;h=g+1|0;if(c>>>0>16383){c=n;g=h}else{p=h;q=n;break}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function RTb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)>4){h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;h=(f[a>>2]|0)-o|0;f[a>>2]=h;p=h}else{bSb(e,g);p=f[a>>2]|0}g=jJc(c|0,d|0,1)|0;h=J;o=$Ic(c|0,d|0,63)|0;d=g^o;o=h^J;if((p|0)<=9){cSb(e,d,o);return}p=e+4|0;e=f[p>>2]|0;h=d&255;if(o>>>0>0|(o|0)==0&d>>>0>127){g=e;c=h;i=d;d=o;while(1){b[g>>0]=c|-128;o=i;i=aJc(i|0,d|0,7)|0;n=g+1|0;k=i&255;if(!(d>>>0>0|(d|0)==0&o>>>0>16383)){q=n;r=k;break}else{g=n;c=k;d=J}}}else{q=e;r=h}b[q>>0]=r;r=q+1-e|0;f[p>>2]=(f[p>>2]|0)+r;f[a>>2]=(f[a>>2]|0)-r;return}function STb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){bSb(d,e);$Rb(d,c);return}g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n;$Rb(d,c);return}function TTb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3|1;a=e+8|0;if((f[a>>2]|0)<=4){bSb(e,g);aSb(e,c,d);return}h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o;aSb(e,c,d);return}function UTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){bSb(d,e);$Rb(d,c);return}g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n;$Rb(d,c);return}function VTb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3|1;a=e+8|0;if((f[a>>2]|0)<=4){bSb(e,g);aSb(e,c,d);return}h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o;aSb(e,c,d);return}function WTb(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){bSb(d,e);g=(n[s>>2]=c,f[s>>2]|0);$Rb(d,g);return}h=d+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{o=m;p=l;break}}}else{o=i;p=e}b[o>>0]=p;p=o+1-i|0;f[h>>2]=(f[h>>2]|0)+p;f[a>>2]=(f[a>>2]|0)-p;g=(n[s>>2]=c,f[s>>2]|0);$Rb(d,g);return}function XTb(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|1;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else bSb(d,e);p[s>>3]=c;aSb(d,f[s>>2]|0,f[s+4>>2]|0);return}function YTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{bSb(d,e);o=f[a>>2]|0}if((o|0)>4){o=d+4|0;b[f[o>>2]>>0]=c&1;f[o>>2]=(f[o>>2]|0)+1;f[a>>2]=(f[a>>2]|0)+-1;return}else{bSb(d,c&1);return}}function ZTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{bSb(d,e);o=f[a>>2]|0}e=((c|0)<0)<<31>>31;if((o|0)<=9){cSb(d,c,e);return}o=d+4|0;d=f[o>>2]|0;g=c&255;if(c>>>0>127){n=d;h=g;m=c;c=e;while(1){b[n>>0]=h|-128;e=m;m=aJc(m|0,c|0,7)|0;j=n+1|0;i=m&255;if(!(c>>>0>0|(c|0)==0&e>>>0>16383)){p=j;q=i;break}else{n=j;h=i;c=J}}}else{p=d;q=g}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function _Tb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else bSb(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(rTb(g,3,475375,510),oTb(h,mTb(g,475470)|0),sTb(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)<=4){bSb(d,t);v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;ZRb(d,y,C);u=e;return}r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{D=j;E=h;break}}}else{D=s;E=t}b[D>>0]=E;E=D+1-s|0;f[r>>2]=(f[r>>2]|0)+E;f[a>>2]=(f[a>>2]|0)-E;v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;ZRb(d,y,C);u=e;return}function $Tb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else bSb(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(rTb(g,3,475375,519),oTb(h,mTb(g,475470)|0),sTb(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)>4){r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{v=j;w=h;break}}}else{v=s;w=t}b[v>>0]=w;w=v+1-s|0;f[r>>2]=(f[r>>2]|0)+w;f[a>>2]=(f[a>>2]|0)-w}else bSb(d,t);t=b[i>>0]|0;i=t<<24>>24<0;w=i?f[c>>2]|0:c;a=i?f[c+4>>2]|0:t&255;if(!(b[d+17>>0]|0)){ZRb(d,w,a);u=e;return}else{_Rb(d,w,a);u=e;return}}function aUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else bSb(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(rTb(g,3,475375,526),oTb(h,mTb(g,475470)|0),sTb(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)<=4){bSb(d,t);v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;ZRb(d,y,C);u=e;return}r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{D=j;E=h;break}}}else{D=s;E=t}b[D>>0]=E;E=D+1-s|0;f[r>>2]=(f[r>>2]|0)+E;f[a>>2]=(f[a>>2]|0)-E;v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;ZRb(d,y,C);u=e;return}function bUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else bSb(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(rTb(g,3,475375,534),oTb(h,mTb(g,475470)|0),sTb(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)>4){r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{v=j;w=h;break}}}else{v=s;w=t}b[v>>0]=w;w=v+1-s|0;f[r>>2]=(f[r>>2]|0)+w;f[a>>2]=(f[a>>2]|0)-w}else bSb(d,t);t=b[i>>0]|0;i=t<<24>>24<0;w=i?f[c>>2]|0:c;a=i?f[c+4>>2]|0:t&255;if(!(b[d+17>>0]|0)){ZRb(d,w,a);u=e;return}else{_Rb(d,w,a);u=e;return}}function cUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=e|3;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;i=f[h>>2]|0;if(a>>>0>127){j=a;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=a}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else bSb(d,a);mi[f[(f[c>>2]|0)+52>>2]&2047](c,d);c=e|4;if((f[g>>2]|0)<=4){bSb(d,c);return}e=d+4|0;d=f[e>>2]|0;if(c>>>0>127){a=c;o=d;while(1){b[o>>0]=a|128;h=a>>>7;i=o+1|0;if(a>>>0>16383){a=h;o=i}else{p=i;q=h;break}}}else{p=d;q=c}b[p>>0]=q;q=p+1-d|0;f[e>>2]=(f[e>>2]|0)+q;f[g>>2]=(f[g>>2]|0)-q;return}function dUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else bSb(d,e);e=_i[f[(f[c>>2]|0)+60>>2]&1023](c)|0;if((f[a>>2]|0)<=4){bSb(d,e);o=f[c>>2]|0;p=o+52|0;q=f[p>>2]|0;mi[q&2047](c,d);return}n=d+4|0;g=f[n>>2]|0;if(e>>>0>127){h=e;m=g;while(1){b[m>>0]=h|128;j=h>>>7;i=m+1|0;if(h>>>0>16383){h=j;m=i}else{r=i;s=j;break}}}else{r=g;s=e}b[r>>0]=s;s=r+1-g|0;f[n>>2]=(f[n>>2]|0)+s;f[a>>2]=(f[a>>2]|0)-s;o=f[c>>2]|0;p=o+52|0;q=f[p>>2]|0;mi[q&2047](c,d);return}function eUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else bSb(d,e);e=_i[f[(f[c>>2]|0)+60>>2]&1023](c)|0;if((f[a>>2]|0)>4){n=d+4|0;g=f[n>>2]|0;if(e>>>0>127){h=e;m=g;while(1){b[m>>0]=h|128;j=h>>>7;i=m+1|0;if(h>>>0>16383){h=j;m=i}else{o=i;p=j;break}}}else{o=g;p=e}b[o>>0]=p;p=o+1-g|0;f[n>>2]=(f[n>>2]|0)+p;g=(f[a>>2]|0)-p|0;f[a>>2]=g;q=n;r=g}else{bSb(d,e);q=d+4|0;r=f[a>>2]|0}if((r|0)>=(e|0)?(g=f[q>>2]|0,f[q>>2]=g+e,f[a>>2]=r-e,g|0):0){if(!(b[d+18>>0]|0))s=(f[220805]|0)!=0;else s=(b[d+19>>0]|0)!=0;hj[f[(f[c>>2]|0)+64>>2]&511](c,s,g)|0;return}mi[f[(f[c>>2]|0)+52>>2]&2047](c,d);return}function fUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d>>>0<g>>>0){g=b[d>>0]|0;i=g&255;if(g<<24>>24>-1){g=d+1|0;f[a>>2]=g;j=i;k=g;l=h}else{m=i;n=4}}else{m=0;n=4}do if((n|0)==4){i=HRb(a,m)|0;if((J|0)<0|(i|0)<0){o=0;return o|0}else{j=i;k=f[a>>2]|0;l=f[e>>2]|0;break}}while(0);if((l-k|0)<(j|0)){o=SRb(a,c,j)|0;return o|0}oEc(c,j,0);k=b[c+11>>0]|0;l=k<<24>>24<0;if(l)p=f[c+4>>2]|0;else p=k&255;if(!p){o=1;return o|0}if(l)q=f[c>>2]|0;else q=c;if(!q){o=1;return o|0}dJc(q|0,f[a>>2]|0,j|0)|0;f[a>>2]=(f[a>>2]|0)+j;o=1;return o|0}function gUb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+64|0;h=g;i=g+44|0;j=g+32|0;k=g+8|0;l=g+56|0;if(Ulc(a,c)|0){m=1;u=g;return m|0}c=(d|0)==0?475528:(d|0)==1?475516:0;d=i+11|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(e|0?(f[h>>2]=e,Rlc(j,475536,h),iEc(i,j)|0,(b[j+11>>0]|0)<0):0)YDc(f[j>>2]|0);rTb(k,2,475375,629);oTb(l,mTb(mTb(mTb(mTb(mTb(mTb(nTb(mTb(k,475542)|0,i)|0,475555)|0,475574)|0,c)|0,475591)|0,475604)|0,475660)|0);sTb(k);if((b[d>>0]|0)<0)YDc(f[i>>2]|0);m=0;u=g;return m|0}function hUb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a>>2]|0;if((b|0)<=0){c=0;return c|0}d=f[a+8>>2]|0;a=0;e=0;while(1){g=f[d+4+(e<<2)>>2]|0;if((g|0)<0)h=10;else h=(((($(g|1|0)|0)^31)*9|0)+73|0)>>>6;g=h+a|0;e=e+1|0;if((e|0)==(b|0)){c=g;break}else a=g}return c|0}function iUb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a>>2]|0;if((b|0)<=0){c=0;return c|0}d=f[a+8>>2]|0;a=0;e=0;while(1){g=((((($(f[d+4+(e<<2)>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+a|0;e=e+1|0;if((e|0)==(b|0)){c=g;break}else a=g}return c|0}function jUb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+32|0;c=b;switch(a|0){case 2:{d=475905;break}case 3:{d=475898;break}case 0:{d=475890;break}default:{rTb(c,3,475801,228);oTb(b+24|0,mTb(c,504694)|0);sTb(c);d=0}}u=b;return d|0}function kUb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;n[a+28>>2]=1.0;b=a+32|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+48>>2]=1.0;b=a+52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+68>>2]=1.0;b=a+132|0;c=a+148|0;d=a+72|0;e=d+76|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));n[c>>2]=1.0;lUb(b,3);b=a+152|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+168>>2]=1.0;mUb(b,3);f[a+176>>2]=0;f[a+180>>2]=0;f[a+172>>2]=a+176;d=a+184|0;e=d+48|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}function lUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){oUb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;oUb(a,d);return}function mUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){nUb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;nUb(a,d);return}function nUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(Ioc(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(Ioc(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function oUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(Ioc(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(Ioc(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function pUb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+84|0;d=f[c>>2]|0;e=a+88|0;g=f[e>>2]|0;if((d|0)!=(g|0)){h=d;do{d=f[h>>2]|0;h=h+4|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d)}while((h|0)!=(g|0));g=f[c>>2]|0;h=f[e>>2]|0;if((h|0)!=(g|0))f[e>>2]=h+(~((h+-4-g|0)>>>2)<<2)}g=a+120|0;h=a+124|0;d=f[g>>2]|0;if((f[h>>2]|0)!=(d|0)){i=0;j=d;do{YDc(f[j+(i<<2)>>2]|0);i=i+1|0;j=f[g>>2]|0}while(i>>>0<(f[h>>2]|0)-j>>2>>>0)}j=a+72|0;i=f[j>>2]|0;d=a+76|0;k=f[d>>2]|0;if((i|0)!=(k|0)){l=i;do{i=f[l>>2]|0;l=l+4|0;if(i|0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}}while((l|0)!=(k|0));k=f[j>>2]|0;l=f[d>>2]|0;if((l|0)!=(k|0))f[d>>2]=l+(~((l+-4-k|0)>>>2)<<2)}k=a+108|0;l=f[k>>2]|0;i=a+112|0;m=f[i>>2]|0;if((l|0)!=(m|0)){n=l;do{l=f[n>>2]|0;n=n+4|0;if(l|0){qUb(l);YDc(l)}}while((n|0)!=(m|0));m=f[k>>2]|0;n=f[i>>2]|0;if((n|0)!=(m|0))f[i>>2]=n+(~((n+-4-m|0)>>>2)<<2)}m=a+96|0;n=f[m>>2]|0;l=a+100|0;o=f[l>>2]|0;if((n|0)!=(o|0)){p=n;do{n=f[p>>2]|0;p=p+4|0;if(n|0)YDc(n)}while((p|0)!=(o|0));o=f[m>>2]|0;p=f[l>>2]|0;if((p|0)!=(o|0))f[l>>2]=p+(~((p+-4-o|0)>>>2)<<2)}o=f[a+220>>2]|0;if(o|0){p=a+224|0;n=f[p>>2]|0;if((n|0)!=(o|0))f[p>>2]=n+(~((n+-8-o|0)>>>3)<<3);YDc(o)}o=f[a+208>>2]|0;if(o|0){n=a+212|0;p=f[n>>2]|0;if((p|0)!=(o|0))f[n>>2]=p+(~((p+-4-o|0)>>>2)<<2);YDc(o)}o=f[a+196>>2]|0;if(o|0){p=a+200|0;n=f[p>>2]|0;if((n|0)!=(o|0))f[p>>2]=n+(~((n+-4-o|0)>>>2)<<2);YDc(o)}o=f[a+184>>2]|0;if(o|0){n=a+188|0;p=f[n>>2]|0;if((p|0)!=(o|0))f[n>>2]=p+(~((p+-32-o|0)>>>5)<<5);YDc(o)}rUb(a+172|0,f[a+176>>2]|0);o=f[a+160>>2]|0;if(o|0){p=o;do{o=p;p=f[p>>2]|0;YDc(o)}while((p|0)!=0)}p=a+152|0;o=f[p>>2]|0;f[p>>2]=0;if(o|0)YDc(o);o=f[a+140>>2]|0;if(o|0){p=o;do{o=p;p=f[p>>2]|0;YDc(o)}while((p|0)!=0)}p=a+132|0;o=f[p>>2]|0;f[p>>2]=0;if(o|0)YDc(o);o=f[g>>2]|0;if(o|0){g=f[h>>2]|0;if((g|0)!=(o|0))f[h>>2]=g+(~((g+-4-o|0)>>>2)<<2);YDc(o)}o=f[k>>2]|0;if(o|0){k=f[i>>2]|0;if((k|0)!=(o|0))f[i>>2]=k+(~((k+-4-o|0)>>>2)<<2);YDc(o)}o=f[m>>2]|0;if(o|0){m=f[l>>2]|0;if((m|0)!=(o|0))f[l>>2]=m+(~((m+-4-o|0)>>>2)<<2);YDc(o)}o=f[c>>2]|0;if(o|0){c=f[e>>2]|0;if((c|0)!=(o|0))f[e>>2]=c+(~((c+-4-o|0)>>>2)<<2);YDc(o)}o=f[j>>2]|0;if(o|0){j=f[d>>2]|0;if((j|0)!=(o|0))f[d>>2]=j+(~((j+-4-o|0)>>>2)<<2);YDc(o)}o=f[a+60>>2]|0;if(o|0){j=o;do{o=j;j=f[j>>2]|0;YDc(o)}while((j|0)!=0)}j=a+52|0;o=f[j>>2]|0;f[j>>2]=0;if(o|0)YDc(o);o=f[a+40>>2]|0;if(o|0){j=o;do{o=j;j=f[j>>2]|0;d=o+8|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);YDc(o)}while((j|0)!=0)}j=a+32|0;o=f[j>>2]|0;f[j>>2]=0;if(o|0)YDc(o);o=f[a+20>>2]|0;if(o|0){j=o;do{o=j;j=f[j>>2]|0;d=o+8|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);YDc(o)}while((j|0)!=0)}j=a+12|0;o=f[j>>2]|0;f[j>>2]=0;if(o|0)YDc(o);o=f[a>>2]|0;if(!o)return;j=a+4|0;d=f[j>>2]|0;if((d|0)==(o|0))q=o;else{c=d;while(1){d=c+-12|0;f[j>>2]=d;if((b[d+11>>0]|0)<0){YDc(f[d>>2]|0);r=f[j>>2]|0}else r=d;if((r|0)==(o|0))break;else c=r}q=f[a>>2]|0}YDc(q);return}function qUb(a){a=a|0;var c=0,d=0,e=0;uTb(a+160|0);c=f[a+148>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;e=c+8|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(c)}while((d|0)!=0)}d=a+140|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)YDc(c);c=f[a+124>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;YDc(c)}while((d|0)!=0)}d=a+116|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)YDc(c);c=f[a+104>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;YDc(c)}while((d|0)!=0)}d=a+96|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)YDc(c);c=f[a+84>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;YDc(c)}while((d|0)!=0)}d=a+76|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)YDc(c);c=f[a+56>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;YDc(c)}while((d|0)!=0)}d=a+48|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)YDc(c);c=f[a+28>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;YDc(c)}while((d|0)!=0)}d=a+20|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)YDc(c);c=f[a+8>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;YDc(c)}while((d|0)!=0)}d=f[a>>2]|0;f[a>>2]=0;if(!d)return;YDc(d);return}function rUb(a,b){a=a|0;b=b|0;if(!b)return;else{rUb(a,f[b>>2]|0);rUb(a,f[b+4>>2]|0);YDc(b);return}}function sUb(a){a=a|0;var b=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;n[a+16>>2]=1.0;tUb(a,3);b=a+20|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+36>>2]=1.0;uUb(b,3);b=VDc(20)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[b+16>>2]=1.0;f[a+40>>2]=b;b=a+44|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;n[a+64>>2]=1.0;uUb(a+48|0,3);b=VDc(20)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[b+16>>2]=1.0;f[a+68>>2]=b;b=a+72|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;n[a+92>>2]=1.0;vUb(a+76|0,3);b=a+96|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+112>>2]=1.0;wUb(b,3);b=a+116|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+132>>2]=1.0;wUb(b,3);b=a+136|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;n[a+156>>2]=1.0;xUb(a+140|0,3);tTb(a+160|0);return}function tUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){CUb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;CUb(a,d);return}function uUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){BUb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;BUb(a,d);return}function vUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){AUb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;AUb(a,d);return}function wUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){zUb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;zUb(a,d);return}function xUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){yUb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;yUb(a,d);return}function yUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=(c|0)!=0;do if(d)if(c>>>0>1073741823){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{g=VDc(c<<2)|0;break}else g=0;while(0);e=f[a>>2]|0;f[a>>2]=g;if(e|0)YDc(e);f[a+4>>2]=c;if(d)h=0;else return;do{f[(f[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(c|0));h=a+8|0;d=f[h>>2]|0;if(!d)return;e=f[d+4>>2]|0;g=c+-1|0;i=(g&c|0)==0;if(!i)if(e>>>0<c>>>0)j=e;else j=(e>>>0)%(c>>>0)|0;else j=e&g;f[(f[a>>2]|0)+(j<<2)>>2]=h;h=f[d>>2]|0;if(!h)return;else{k=j;l=d;m=h;n=d}a:while(1){d=l;h=m;j=n;b:while(1){o=h;while(1){e=f[o+4>>2]|0;if(!i)if(e>>>0<c>>>0)p=e;else p=(e>>>0)%(c>>>0)|0;else p=e&g;if((p|0)==(k|0))break;q=(f[a>>2]|0)+(p<<2)|0;if(!(f[q>>2]|0))break b;e=f[o>>2]|0;c:do if(!e)r=o;else{s=o+8|0;t=b[s+11>>0]|0;u=t<<24>>24<0;v=t&255;t=u?f[o+12>>2]|0:v;w=(t|0)==0;if(u){u=o;x=e;while(1){y=x+8|0;z=b[y+11>>0]|0;A=z<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:z&255)|0)){r=u;break c}if(!w?Arc(f[s>>2]|0,A?f[y>>2]|0:y,t)|0:0){r=u;break c}y=f[x>>2]|0;if(!y){r=x;break c}else{A=x;x=y;u=A}}}if(w){u=o;x=e;while(1){A=b[x+8+11>>0]|0;if((A<<24>>24<0?f[x+12>>2]|0:A&255)|0){r=u;break c}A=f[x>>2]|0;if(!A){r=x;break c}else{y=x;x=A;u=y}}}u=o;x=e;while(1){w=x+8|0;y=b[w+11>>0]|0;A=y<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:y&255)|0)){r=u;break c}y=A?f[w>>2]|0:w;if((f[s>>2]&255)<<24>>24==(b[y>>0]|0)){B=s;C=v;D=y}else{r=u;break c}while(1){C=C+-1|0;B=B+1|0;if(!C)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){r=u;break c}}y=f[x>>2]|0;if(!y){r=x;break}else{w=x;x=y;u=w}}}while(0);f[j>>2]=f[r>>2];f[r>>2]=f[f[(f[a>>2]|0)+(p<<2)>>2]>>2];f[f[(f[a>>2]|0)+(p<<2)>>2]>>2]=o;e=f[d>>2]|0;if(!e){E=41;break a}else o=e}h=f[o>>2]|0;if(!h){E=41;break a}else{d=o;j=o}}f[q>>2]=j;m=f[o>>2]|0;if(!m){E=41;break}else{k=p;l=o;n=o}}if((E|0)==41)return}function zUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){c=k;g=l;i=m;b:while(1){c:do if(h){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=d+12|0;t=f[d>>2]|0;d:do if(!t)u=d;else{v=f[d+8>>2]|0;w=d;x=t;while(1){if((v|0)!=(f[x+8>>2]|0)){u=w;break d}if((f[p>>2]|0)!=(f[x+12>>2]|0)){u=w;break d}y=f[x>>2]|0;if(!y){u=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[u>>2];f[u>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}else{d=g;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=d+12|0;t=f[d>>2]|0;e:do if(!t)C=d;else{w=f[d+8>>2]|0;x=d;v=t;while(1){if((w|0)!=(f[v+8>>2]|0)){C=x;break e}if((f[p>>2]|0)!=(f[v+12>>2]|0)){C=x;break e}z=f[v>>2]|0;if(!z){C=v;break}else{y=v;v=z;x=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}while(0);g=f[o>>2]|0;if(!g){A=37;break a}else{c=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=37;break}else{j=s;k=q;m=q}}if((A|0)==37)return}function AUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){c=k;g=l;i=m;b:while(1){c:do if(h){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=d+12|0;t=f[d>>2]|0;d:do if(!t)u=d;else{v=f[d+8>>2]|0;w=d;x=t;while(1){if((v|0)!=(f[x+8>>2]|0)){u=w;break d}if((f[p>>2]|0)!=(f[x+12>>2]|0)){u=w;break d}y=f[x>>2]|0;if(!y){u=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[u>>2];f[u>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}else{d=g;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=d+12|0;t=f[d>>2]|0;e:do if(!t)C=d;else{w=f[d+8>>2]|0;x=d;v=t;while(1){if((w|0)!=(f[v+8>>2]|0)){C=x;break e}if((f[p>>2]|0)!=(f[v+12>>2]|0)){C=x;break e}z=f[v>>2]|0;if(!z){C=v;break}else{y=v;v=z;x=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}while(0);g=f[o>>2]|0;if(!g){A=37;break a}else{c=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=37;break}else{j=s;k=q;m=q}}if((A|0)==37)return}function BUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){c=k;g=l;i=m;b:while(1){c:do if(h){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=f[d>>2]|0;d:do if(!p)t=d;else{u=f[d+8>>2]|0;v=d+12|0;w=d;x=p;while(1){if((u|0)!=(f[x+8>>2]|0)){t=w;break d}if(Ioc(f[v>>2]|0,f[x+12>>2]|0)|0){t=w;break d}y=f[x>>2]|0;if(!y){t=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[t>>2];f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}else{d=g;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=f[d>>2]|0;e:do if(!p)C=d;else{w=f[d+8>>2]|0;x=d+12|0;v=d;u=p;while(1){if((w|0)!=(f[u+8>>2]|0)){C=v;break e}if(Ioc(f[x>>2]|0,f[u+12>>2]|0)|0){C=v;break e}z=f[u>>2]|0;if(!z){C=u;break}else{y=u;u=z;v=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}while(0);g=f[o>>2]|0;if(!g){A=37;break a}else{c=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=37;break}else{j=s;k=q;m=q}}if((A|0)==37)return}function CUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){c=k;g=l;i=m;b:while(1){c:do if(h){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=f[d>>2]|0;d:do if(!p)t=d;else{u=f[d+8>>2]|0;v=d+12|0;w=d;x=p;while(1){if((u|0)!=(f[x+8>>2]|0)){t=w;break d}if(Ioc(f[v>>2]|0,f[x+12>>2]|0)|0){t=w;break d}y=f[x>>2]|0;if(!y){t=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[t>>2];f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}else{d=g;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=f[d>>2]|0;e:do if(!p)C=d;else{w=f[d+8>>2]|0;x=d+12|0;v=d;u=p;while(1){if((w|0)!=(f[u+8>>2]|0)){C=v;break e}if(Ioc(f[x>>2]|0,f[u+12>>2]|0)|0){C=v;break e}z=f[u>>2]|0;if(!z){C=u;break}else{y=u;u=z;v=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}while(0);g=f[o>>2]|0;if(!g){A=37;break a}else{c=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=37;break}else{j=s;k=q;m=q}}if((A|0)==37)return}function DUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>5;h=g+1|0;if(h>>>0>134217727)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>4;l=j>>5>>>0<67108863?(k>>>0<h>>>0?h:k):134217727;do if(l)if(l>>>0>134217727){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<5)|0;break}else m=0;while(0);k=m+(g<<5)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];f[k+28>>2]=f[b+28>>2];b=k+(0-g<<5)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+32;f[i>>2]=m+(l<<5);if(!d)return;YDc(d);return}function EUb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+32|0;d=c+16|0;e=c+4|0;g=c;h=a+188|0;i=f[h>>2]|0;j=i+-12|0;k=f[j>>2]|0;l=a+196|0;m=a+200|0;n=f[l>>2]|0;if(k>>>0<(f[m>>2]|0)-n>>2>>>0){o=a+132|0;p=k;k=n;do{n=FUb(o,k+(p<<2)|0)|0;if(n|0?(f[g>>2]=n,f[d>>2]=f[g>>2],GUb(e,o,d),n=f[e>>2]|0,f[e>>2]=0,n|0):0)YDc(n);p=p+1|0;k=f[l>>2]|0}while(p>>>0<(f[m>>2]|0)-k>>2>>>0)}k=i+-8|0;p=f[k>>2]|0;o=a+208|0;n=a+212|0;q=f[o>>2]|0;if(p>>>0<(f[n>>2]|0)-q>>2>>>0){r=a+152|0;s=p;p=q;do{q=HUb(r,p+(s<<2)|0)|0;if(q|0?(f[g>>2]=q,f[d>>2]=f[g>>2],IUb(e,r,d),q=f[e>>2]|0,f[e>>2]=0,q|0):0)YDc(q);s=s+1|0;p=f[o>>2]|0}while(s>>>0<(f[n>>2]|0)-p>>2>>>0)}p=i+-4|0;s=f[p>>2]|0;e=a+220|0;d=a+224|0;r=f[e>>2]|0;if(s>>>0<(f[d>>2]|0)-r>>3>>>0){g=a+172|0;q=s;s=r;do{LUb(g,s+(q<<3)|0)|0;q=q+1|0;s=f[e>>2]|0}while(q>>>0<(f[d>>2]|0)-s>>3>>>0)}s=f[j>>2]|0;j=f[m>>2]|0;q=f[l>>2]|0;g=j-q>>2;r=q;q=j;if(s>>>0<=g>>>0){if(s>>>0<g>>>0?(j=r+(s<<2)|0,(q|0)!=(j|0)):0)f[m>>2]=q+(~((q+-4-j|0)>>>2)<<2)}else JUb(l,s-g|0);g=f[k>>2]|0;k=f[n>>2]|0;s=f[o>>2]|0;l=k-s>>2;j=s;s=k;if(g>>>0<=l>>>0){if(g>>>0<l>>>0?(k=j+(g<<2)|0,(s|0)!=(k|0)):0)f[n>>2]=s+(~((s+-4-k|0)>>>2)<<2)}else JUb(o,g-l|0);l=f[p>>2]|0;p=f[d>>2]|0;g=f[e>>2]|0;o=p-g>>3;k=g;g=p;if(l>>>0<=o>>>0){if(l>>>0<o>>>0?(p=k+(l<<3)|0,(g|0)!=(p|0)):0)f[d>>2]=g+(~((g+-8-p|0)>>>3)<<3)}else KUb(e,l-o|0);o=a+72|0;l=i+-32|0;e=(f[o>>2]|0)+(f[l>>2]<<2)|0;p=a+76|0;g=f[p>>2]|0;if((e|0)!=(g|0)){d=e;do{e=f[d>>2]|0;d=d+4|0;if(e|0){if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(e)}}while((d|0)!=(g|0))}g=a+84|0;d=i+-28|0;e=(f[g>>2]|0)+(f[d>>2]<<2)|0;k=a+88|0;s=f[k>>2]|0;if((e|0)!=(s|0)){n=e;do{e=f[n>>2]|0;n=n+4|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e)}while((n|0)!=(s|0))}s=a+96|0;n=i+-24|0;e=(f[s>>2]|0)+(f[n>>2]<<2)|0;j=a+100|0;q=f[j>>2]|0;if((e|0)!=(q|0)){m=e;do{e=f[m>>2]|0;m=m+4|0;if(e|0)YDc(e)}while((m|0)!=(q|0))}q=a+108|0;m=i+-20|0;e=(f[q>>2]|0)+(f[m>>2]<<2)|0;r=a+112|0;t=f[r>>2]|0;if((e|0)!=(t|0)){v=e;do{e=f[v>>2]|0;v=v+4|0;if(e|0){qUb(e);YDc(e)}}while((v|0)!=(t|0))}t=i+-16|0;i=f[t>>2]|0;v=a+120|0;e=a+124|0;a=f[v>>2]|0;if(i>>>0<(f[e>>2]|0)-a>>2>>>0){w=i;i=a;do{YDc(f[i+(w<<2)>>2]|0);w=w+1|0;i=f[v>>2]|0}while(w>>>0<(f[e>>2]|0)-i>>2>>>0)}i=f[l>>2]|0;l=f[p>>2]|0;w=f[o>>2]|0;a=l-w>>2;x=w;w=l;if(i>>>0<=a>>>0){if(i>>>0<a>>>0?(l=x+(i<<2)|0,(w|0)!=(l|0)):0)f[p>>2]=w+(~((w+-4-l|0)>>>2)<<2)}else MUb(o,i-a|0);a=f[d>>2]|0;d=f[k>>2]|0;i=f[g>>2]|0;o=d-i>>2;l=i;i=d;if(a>>>0<=o>>>0){if(a>>>0<o>>>0?(d=l+(a<<2)|0,(i|0)!=(d|0)):0)f[k>>2]=i+(~((i+-4-d|0)>>>2)<<2)}else NUb(g,a-o|0);o=f[n>>2]|0;n=f[j>>2]|0;a=f[s>>2]|0;g=n-a>>2;d=a;a=n;if(o>>>0<=g>>>0){if(o>>>0<g>>>0?(n=d+(o<<2)|0,(a|0)!=(n|0)):0)f[j>>2]=a+(~((a+-4-n|0)>>>2)<<2)}else OUb(s,o-g|0);g=f[m>>2]|0;m=f[r>>2]|0;o=f[q>>2]|0;s=m-o>>2;n=o;o=m;if(g>>>0<=s>>>0){if(g>>>0<s>>>0?(m=n+(g<<2)|0,(o|0)!=(m|0)):0)f[r>>2]=o+(~((o+-4-m|0)>>>2)<<2)}else PUb(q,g-s|0);s=f[t>>2]|0;t=f[e>>2]|0;g=f[v>>2]|0;q=t-g>>2;m=t;if(s>>>0>q>>>0){QUb(v,s-q|0);y=f[h>>2]|0;z=y+-32|0;f[h>>2]=z;u=c;return}if(s>>>0>=q>>>0){y=f[h>>2]|0;z=y+-32|0;f[h>>2]=z;u=c;return}q=g+(s<<2)|0;if((m|0)==(q|0)){y=f[h>>2]|0;z=y+-32|0;f[h>>2]=z;u=c;return}f[e>>2]=m+(~((m+-4-q|0)>>>2)<<2);y=f[h>>2]|0;z=y+-32|0;f[h>>2]=z;u=c;return}function FUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(c|0)==(e|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(Ioc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(a|0)==(e|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(Ioc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function GUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=f[c>>2]|0;c=f[b+4>>2]|0;e=f[d+4>>2]|0;g=c+-1|0;h=(g&c|0)==0;if(!h)if(e>>>0<c>>>0)i=e;else i=(e>>>0)%(c>>>0)|0;else i=g&e;e=(f[b>>2]|0)+(i<<2)|0;j=f[e>>2]|0;while(1){k=f[j>>2]|0;if((k|0)==(d|0))break;else j=k}k=b+8|0;if((j|0)!=(k|0)){l=f[j+4>>2]|0;if(!h)if(l>>>0<c>>>0)m=l;else m=(l>>>0)%(c>>>0)|0;else m=l&g;if((m|0)==(i|0))n=d;else o=14}else o=14;do if((o|0)==14){m=f[d>>2]|0;if(m|0){l=f[m+4>>2]|0;if(!h)if(l>>>0<c>>>0)p=l;else p=(l>>>0)%(c>>>0)|0;else p=l&g;if((p|0)==(i|0)){n=d;break}}f[e>>2]=0;n=d}while(0);e=f[n>>2]|0;p=e;if(e){o=f[e+4>>2]|0;if(!h)if(o>>>0<c>>>0)q=o;else q=(o>>>0)%(c>>>0)|0;else q=o&g;if((q|0)!=(i|0)){f[(f[b>>2]|0)+(q<<2)>>2]=j;r=f[d>>2]|0}else r=p}else r=p;f[j>>2]=r;f[n>>2]=0;n=b+12|0;f[n>>2]=(f[n>>2]|0)+-1;f[a>>2]=d;d=a+4|0;f[d>>2]=k;f[d+4>>2]=1;return}function HUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(c|0)==(e|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(Ioc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(a|0)==(e|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(Ioc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function IUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=f[c>>2]|0;c=f[b+4>>2]|0;e=f[d+4>>2]|0;g=c+-1|0;h=(g&c|0)==0;if(!h)if(e>>>0<c>>>0)i=e;else i=(e>>>0)%(c>>>0)|0;else i=g&e;e=(f[b>>2]|0)+(i<<2)|0;j=f[e>>2]|0;while(1){k=f[j>>2]|0;if((k|0)==(d|0))break;else j=k}k=b+8|0;if((j|0)!=(k|0)){l=f[j+4>>2]|0;if(!h)if(l>>>0<c>>>0)m=l;else m=(l>>>0)%(c>>>0)|0;else m=l&g;if((m|0)==(i|0))n=d;else o=14}else o=14;do if((o|0)==14){m=f[d>>2]|0;if(m|0){l=f[m+4>>2]|0;if(!h)if(l>>>0<c>>>0)p=l;else p=(l>>>0)%(c>>>0)|0;else p=l&g;if((p|0)==(i|0)){n=d;break}}f[e>>2]=0;n=d}while(0);e=f[n>>2]|0;p=e;if(e){o=f[e+4>>2]|0;if(!h)if(o>>>0<c>>>0)q=o;else q=(o>>>0)%(c>>>0)|0;else q=o&g;if((q|0)!=(i|0)){f[(f[b>>2]|0)+(q<<2)>>2]=j;r=f[d>>2]|0}else r=p}else r=p;f[j>>2]=r;f[n>>2]=0;n=b+12|0;f[n>>2]=(f[n>>2]|0)+-1;f[a>>2]=d;d=a+4|0;f[d>>2]=k;f[d+4>>2]=1;return}function JUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function KUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){XIc(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)mCc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;XIc(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;YDc(h);return}function LUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[c>>2]|0;if(!d){e=0;return e|0}g=f[b>>2]|0;h=f[b+4>>2]|0;b=c;i=d;a:while(1){j=i;while(1){k=f[j+16>>2]|0;if(k>>>0>=g>>>0){if(g>>>0<k>>>0)break;if((f[j+20>>2]|0)>=(h|0))break}k=f[j+4>>2]|0;if(!k){l=b;break a}else j=k}i=f[j>>2]|0;if(!i){l=j;break}else b=j}if((l|0)==(c|0)){e=0;return e|0}c=f[l+16>>2]|0;if(g>>>0<c>>>0){e=0;return e|0}if(c>>>0>=g>>>0?(h|0)<(f[l+20>>2]|0):0){e=0;return e|0}h=f[l+4>>2]|0;if(!h){g=l+8|0;c=f[g>>2]|0;if((f[c>>2]|0)==(l|0))m=c;else{c=g;do{g=f[c>>2]|0;c=g+8|0;b=f[c>>2]|0}while((f[b>>2]|0)!=(g|0));m=b}}else{c=h;while(1){h=f[c>>2]|0;if(!h)break;else c=h}m=c}if((f[a>>2]|0)==(l|0))f[a>>2]=m;m=a+8|0;f[m>>2]=(f[m>>2]|0)+-1;uHa(d,l);YDc(l);e=1;return e|0}function MUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function NUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function OUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function PUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function QUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function RUb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g;i=f[d>>2]|0;j=(i|0)==0;if(!j)dTb(i);k=c+44|0;if(f[k>>2]|0){l=c+40|0;m=f[l>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;o=m+8|0;if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);YDc(m)}while((n|0)!=0)}f[l>>2]=0;l=f[c+36>>2]|0;if(l|0){n=c+32|0;m=0;do{f[(f[n>>2]|0)+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(l|0))}f[k>>2]=0}k=c+24|0;if(f[k>>2]|0){l=c+20|0;m=f[l>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;o=m+8|0;if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);YDc(m)}while((n|0)!=0)}f[l>>2]=0;l=f[c+16>>2]|0;if(l|0){n=c+12|0;m=0;do{f[(f[n>>2]|0)+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(l|0))}f[k>>2]=0}k=e+11|0;f[h>>2]=(b[k>>0]|0)<0?f[e>>2]|0:e;l=c+132|0;c=SUb(l,h)|0;if(c){m=c+12|0;c=f[m>>2]|0;n=f[m+4>>2]|0;m=a;f[m>>2]=c;f[m+4>>2]=n;if(!c)p=24}else{c=a;f[c>>2]=0;f[c+4>>2]=0;p=24}do if((p|0)==24){c=f[d+12>>2]|0;if(c|0?(RUb(h,f[c+16>>2]|0,c,e),c=h,n=f[c>>2]|0,m=f[c+4>>2]|0,c=a,f[c>>2]=n,f[c+4>>2]=m,n|0):0)break;if(TUb(d,e)|0){f[h>>2]=(b[k>>0]|0)<0?f[e>>2]|0:e;n=SUb(l,h)|0;if(!n){q=0;r=0}else{m=n+12|0;q=f[m>>2]|0;r=f[m+4>>2]|0}m=a;f[m>>2]=q;f[m+4>>2]=r}}while(0);if(j){u=g;return}eTb(i);u=g;return}function SUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(e|0)==(c|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(Ioc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(e|0)==(a|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(Ioc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function TUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0;d=u;u=u+144|0;e=d+140|0;g=d;h=a+4|0;if(!(f[h>>2]|0)){i=0;u=d;return i|0}j=a+16|0;if(UUb((f[j>>2]|0)+32|0,c)|0){i=0;u=d;return i|0}N7b(g);do if(!(VUb(a,c)|0)?(k=f[h>>2]|0,hj[f[(f[k>>2]|0)+12>>2]&511](k,c,g)|0):0){k=f[j>>2]|0;l=f[g+120>>2]|0;f[e>>2]=(b[l+11>>0]|0)<0?f[l>>2]|0:l;l=WUb(k+152|0,e)|0;if(l)if(f[l+12>>2]|0){m=9;break}if(XUb(a,g)|0)o=1;else m=9}else m=9;while(0);a:do if((m|0)==9){a=f[j>>2]|0;e=a+32|0;h=b[c+11>>0]|0;l=h<<24>>24<0;k=l?f[c>>2]|0:c;p=b[k>>0]|0;if(!(p<<24>>24))q=0;else{r=k;s=0;t=p;while(1){v=(s*5|0)+(t<<24>>24)|0;r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24)){q=v;break}else s=v}}s=a+36|0;t=f[s>>2]|0;r=(t|0)==0;b:do if(!r){v=t+-1|0;w=(v&t|0)==0;if(!w)if(q>>>0<t>>>0)x=q;else x=(q>>>0)%(t>>>0)|0;else x=v&q;y=f[(f[e>>2]|0)+(x<<2)>>2]|0;if((y|0)!=0?(z=f[y>>2]|0,(z|0)!=0):0){y=l?f[c+4>>2]|0:h&255;A=(y|0)==0;if(w){if(A){w=z;while(1){B=f[w+4>>2]|0;if(!((B|0)==(q|0)|(B&v|0)==(x|0))){C=x;break b}B=b[w+8+11>>0]|0;if(!((B<<24>>24<0?f[w+12>>2]|0:B&255)|0)){o=0;break a}w=f[w>>2]|0;if(!w){C=x;break b}}}else D=z;while(1){w=f[D+4>>2]|0;if(!((w|0)==(q|0)|(w&v|0)==(x|0))){C=x;break b}w=D+8|0;B=b[w+11>>0]|0;E=B<<24>>24<0;F=B&255;do if(((E?f[D+12>>2]|0:F)|0)==(y|0)){B=f[w>>2]|0;if(E)if(!(Arc(B,k,y)|0)){o=0;break a}else break;if((B&255)<<24>>24==p<<24>>24){B=w;G=F;H=k;do{G=G+-1|0;B=B+1|0;if(!G){o=0;break a}H=H+1|0}while((b[B>>0]|0)==(b[H>>0]|0))}}while(0);D=f[D>>2]|0;if(!D){C=x;break b}}}if(A){v=z;while(1){F=f[v+4>>2]|0;if((F|0)!=(q|0)){if(F>>>0<t>>>0)I=F;else I=(F>>>0)%(t>>>0)|0;if((I|0)!=(x|0)){C=x;break b}}F=b[v+8+11>>0]|0;if(!((F<<24>>24<0?f[v+12>>2]|0:F&255)|0)){o=0;break a}v=f[v>>2]|0;if(!v){C=x;break b}}}else J=z;while(1){v=f[J+4>>2]|0;if((v|0)!=(q|0)){if(v>>>0<t>>>0)K=v;else K=(v>>>0)%(t>>>0)|0;if((K|0)!=(x|0)){C=x;break b}}v=J+8|0;A=b[v+11>>0]|0;F=A<<24>>24<0;w=A&255;do if(((F?f[J+12>>2]|0:w)|0)==(y|0)){A=f[v>>2]|0;if(F)if(!(Arc(A,k,y)|0)){o=0;break a}else break;if((A&255)<<24>>24==p<<24>>24){A=v;E=w;H=k;do{E=E+-1|0;A=A+1|0;if(!E){o=0;break a}H=H+1|0}while((b[A>>0]|0)==(b[H>>0]|0))}}while(0);J=f[J>>2]|0;if(!J){C=x;break}}}else C=x}else C=0;while(0);k=VDc(20)|0;fEc(k+8|0,c);f[k+4>>2]=q;f[k>>2]=0;p=a+44|0;L=+(((f[p>>2]|0)+1|0)>>>0);M=+n[a+48>>2];do if(r|L>+(t>>>0)*M){h=(t>>>0<3|(t+-1&t|0)!=0)&1|t<<1;l=~~+X(+(L/M))>>>0;YUb(e,h>>>0<l>>>0?l:h);h=f[s>>2]|0;l=h+-1|0;if(!(l&h)){N=h;O=l&q;break}if(q>>>0<h>>>0){N=h;O=q}else{N=h;O=(q>>>0)%(h>>>0)|0}}else{N=t;O=C}while(0);t=(f[e>>2]|0)+(O<<2)|0;s=f[t>>2]|0;if(!s){r=a+40|0;f[k>>2]=f[r>>2];f[r>>2]=k;f[t>>2]=r;r=f[k>>2]|0;if(r|0){t=f[r+4>>2]|0;r=N+-1|0;if(r&N)if(t>>>0<N>>>0)P=t;else P=(t>>>0)%(N>>>0)|0;else P=t&r;Q=(f[e>>2]|0)+(P<<2)|0;m=64}}else{f[k>>2]=f[s>>2];Q=s;m=64}if((m|0)==64)f[Q>>2]=k;f[p>>2]=(f[p>>2]|0)+1;o=0}while(0);r7b(g);i=o;u=d;return i|0}function UUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(i|0)==(c|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(Arc(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(i|0)==(a|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(Arc(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function VUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+32|0;e=d+12|0;g=d;fEc(g,c);h=DEc(g,46,-1)|0;a:do if((h|0)==-1)i=8;else{j=e+11|0;k=a+16|0;l=g+11|0;m=h;while(1){gEc(e,g,0,m,g);iEc(g,e)|0;if((b[j>>0]|0)<0)YDc(f[e>>2]|0);n=f[k>>2]|0;f[e>>2]=(b[l>>0]|0)<0?f[g>>2]|0:g;o=SUb(n+132|0,e)|0;if(o|0)switch(f[o+12>>2]|0){case 8:case 0:break;default:{p=1;break a}}m=DEc(g,46,-1)|0;if((m|0)==-1){i=8;break}}}while(0);if((i|0)==8){i=f[a+12>>2]|0;if(!i)p=0;else p=VUb(i,c)|0}if((b[g+11>>0]|0)>=0){u=d;return p|0}YDc(f[g>>2]|0);u=d;return p|0}function WUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(e|0)==(c|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(Ioc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(e|0)==(a|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(Ioc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function XUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0;d=u;u=u+112|0;e=d;g=a+16|0;h=c+120|0;if(UUb((f[g>>2]|0)+12|0,f[h>>2]|0)|0){i=0;u=d;return i|0}j=f[g>>2]|0;k=f[a+8>>2]|0;f[e>>2]=a;f[e+4>>2]=j;f[e+8>>2]=k;k=e+12|0;j=e+28|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[e+52>>2]=0;f[e+56>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+12>>0]=0;f[e+48>>2]=e+52;f[e+64>>2]=0;f[e+68>>2]=0;f[e+60>>2]=e+64;k=e+72|0;j=e+88|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;b[j+11>>0]=0;b[j>>0]=0;j=_Ub(e,c)|0;$Ub(e);if(j|0){i=j;u=d;return i|0}j=f[g>>2]|0;g=j+12|0;e=f[h>>2]|0;h=b[e+11>>0]|0;c=h<<24>>24<0;k=c?f[e>>2]|0:e;a=b[k>>0]|0;if(!(a<<24>>24))l=0;else{m=k;o=0;p=a;while(1){q=(o*5|0)+(p<<24>>24)|0;m=m+1|0;p=b[m>>0]|0;if(!(p<<24>>24)){l=q;break}else o=q}}o=j+16|0;p=f[o>>2]|0;m=(p|0)==0;a:do if(!m){q=p+-1|0;r=(q&p|0)==0;if(!r)if(l>>>0<p>>>0)s=l;else s=(l>>>0)%(p>>>0)|0;else s=q&l;t=f[(f[g>>2]|0)+(s<<2)>>2]|0;if((t|0)!=0?(v=f[t>>2]|0,(v|0)!=0):0){t=c?f[e+4>>2]|0:h&255;w=(t|0)==0;if(r){if(w){r=v;while(1){x=f[r+4>>2]|0;if(!((x|0)==(l|0)|(x&q|0)==(s|0))){y=s;break a}x=b[r+8+11>>0]|0;if(!((x<<24>>24<0?f[r+12>>2]|0:x&255)|0)){i=0;break}r=f[r>>2]|0;if(!r){y=s;break a}}u=d;return i|0}else z=v;b:while(1){r=f[z+4>>2]|0;if(!((r|0)==(l|0)|(r&q|0)==(s|0))){y=s;break a}r=z+8|0;x=b[r+11>>0]|0;A=x<<24>>24<0;B=x&255;do if(((A?f[z+12>>2]|0:B)|0)==(t|0)){x=f[r>>2]|0;if(A)if(!(Arc(x,k,t)|0)){i=0;C=60;break b}else break;if((x&255)<<24>>24==a<<24>>24){x=r;D=B;E=k;do{D=D+-1|0;x=x+1|0;if(!D){i=0;C=60;break b}E=E+1|0}while((b[x>>0]|0)==(b[E>>0]|0))}}while(0);z=f[z>>2]|0;if(!z){y=s;break a}}if((C|0)==60){u=d;return i|0}}if(w){q=v;while(1){B=f[q+4>>2]|0;if((B|0)!=(l|0)){if(B>>>0<p>>>0)F=B;else F=(B>>>0)%(p>>>0)|0;if((F|0)!=(s|0)){y=s;break a}}B=b[q+8+11>>0]|0;if(!((B<<24>>24<0?f[q+12>>2]|0:B&255)|0)){i=0;break}q=f[q>>2]|0;if(!q){y=s;break a}}u=d;return i|0}else G=v;c:while(1){q=f[G+4>>2]|0;if((q|0)!=(l|0)){if(q>>>0<p>>>0)H=q;else H=(q>>>0)%(p>>>0)|0;if((H|0)!=(s|0)){y=s;break a}}q=G+8|0;w=b[q+11>>0]|0;B=w<<24>>24<0;r=w&255;do if(((B?f[G+12>>2]|0:r)|0)==(t|0)){w=f[q>>2]|0;if(B)if(!(Arc(w,k,t)|0)){i=0;C=60;break c}else break;if((w&255)<<24>>24==a<<24>>24){w=q;A=r;E=k;do{A=A+-1|0;w=w+1|0;if(!A){i=0;C=60;break c}E=E+1|0}while((b[w>>0]|0)==(b[E>>0]|0))}}while(0);G=f[G>>2]|0;if(!G){y=s;break a}}if((C|0)==60){u=d;return i|0}}else y=s}else y=0;while(0);s=VDc(20)|0;fEc(s+8|0,e);f[s+4>>2]=l;f[s>>2]=0;e=j+24|0;I=+(((f[e>>2]|0)+1|0)>>>0);J=+n[j+28>>2];do if(m|I>+(p>>>0)*J){G=(p>>>0<3|(p+-1&p|0)!=0)&1|p<<1;k=~~+X(+(I/J))>>>0;YUb(g,G>>>0<k>>>0?k:G);G=f[o>>2]|0;k=G+-1|0;if(!(k&G)){K=G;L=k&l;break}if(l>>>0<G>>>0){K=G;L=l}else{K=G;L=(l>>>0)%(G>>>0)|0}}else{K=p;L=y}while(0);y=(f[g>>2]|0)+(L<<2)|0;L=f[y>>2]|0;if(!L){p=j+20|0;f[s>>2]=f[p>>2];f[p>>2]=s;f[y>>2]=p;p=f[s>>2]|0;if(p|0){y=f[p+4>>2]|0;p=K+-1|0;if(p&K)if(y>>>0<K>>>0)M=y;else M=(y>>>0)%(K>>>0)|0;else M=y&p;N=(f[g>>2]|0)+(M<<2)|0;C=58}}else{f[s>>2]=f[L>>2];N=L;C=58}if((C|0)==58)f[N>>2]=s;f[e>>2]=(f[e>>2]|0)+1;i=0;u=d;return i|0}function YUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){ZUb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;ZUb(a,d);return}function ZUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=(c|0)!=0;do if(d)if(c>>>0>1073741823){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{g=VDc(c<<2)|0;break}else g=0;while(0);e=f[a>>2]|0;f[a>>2]=g;if(e|0)YDc(e);f[a+4>>2]=c;if(d)h=0;else return;do{f[(f[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(c|0));h=a+8|0;d=f[h>>2]|0;if(!d)return;e=f[d+4>>2]|0;g=c+-1|0;i=(g&c|0)==0;if(!i)if(e>>>0<c>>>0)j=e;else j=(e>>>0)%(c>>>0)|0;else j=e&g;f[(f[a>>2]|0)+(j<<2)>>2]=h;h=f[d>>2]|0;if(!h)return;else{k=j;l=d;m=h;n=d}a:while(1){d=l;h=m;j=n;b:while(1){o=h;while(1){e=f[o+4>>2]|0;if(!i)if(e>>>0<c>>>0)p=e;else p=(e>>>0)%(c>>>0)|0;else p=e&g;if((p|0)==(k|0))break;q=(f[a>>2]|0)+(p<<2)|0;if(!(f[q>>2]|0))break b;e=f[o>>2]|0;c:do if(!e)r=o;else{s=o+8|0;t=b[s+11>>0]|0;u=t<<24>>24<0;v=t&255;t=u?f[o+12>>2]|0:v;w=(t|0)==0;if(u){u=o;x=e;while(1){y=x+8|0;z=b[y+11>>0]|0;A=z<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:z&255)|0)){r=u;break c}if(!w?Arc(f[s>>2]|0,A?f[y>>2]|0:y,t)|0:0){r=u;break c}y=f[x>>2]|0;if(!y){r=x;break c}else{A=x;x=y;u=A}}}if(w){u=o;x=e;while(1){A=b[x+8+11>>0]|0;if((A<<24>>24<0?f[x+12>>2]|0:A&255)|0){r=u;break c}A=f[x>>2]|0;if(!A){r=x;break c}else{y=x;x=A;u=y}}}u=o;x=e;while(1){w=x+8|0;y=b[w+11>>0]|0;A=y<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:y&255)|0)){r=u;break c}y=A?f[w>>2]|0:w;if((f[s>>2]&255)<<24>>24==(b[y>>0]|0)){B=s;C=v;D=y}else{r=u;break c}while(1){C=C+-1|0;B=B+1|0;if(!C)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){r=u;break c}}y=f[x>>2]|0;if(!y){r=x;break}else{w=x;x=y;u=w}}}while(0);f[j>>2]=f[r>>2];f[r>>2]=f[f[(f[a>>2]|0)+(p<<2)>>2]>>2];f[f[(f[a>>2]|0)+(p<<2)>>2]>>2]=o;e=f[d>>2]|0;if(!e){E=41;break a}else o=e}h=f[o>>2]|0;if(!h){E=41;break a}else{d=o;j=o}}f[q>>2]=j;m=f[o>>2]|0;if(!m){E=41;break}else{k=p;l=o;n=o}}if((E|0)==41)return}function _Ub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+176|0;e=d+24|0;g=d+12|0;h=d;i=c+120|0;j=a+28|0;iEc(j,f[i>>2]|0)|0;k=a+4|0;l=f[k>>2]|0;f[e>>2]=(b[j+11>>0]|0)<0?f[j>>2]|0:j;j=WUb(l+152|0,e)|0;if(j){l=f[j+12>>2]|0;if(l|0){N7b(e);bVb(l,e);if((f[l+44>>2]|0)==2?f[c+8>>2]&4|0:0)cVb(e,475905);RSb(g,e);RSb(h,c);j=g+11|0;m=b[j>>0]|0;n=m<<24>>24<0;o=m&255;p=n?f[g+4>>2]|0:o;q=b[h+11>>0]|0;r=q<<24>>24<0;a:do if((p|0)==((r?f[h+4>>2]|0:q&255)|0)){s=f[g>>2]|0;t=n?s:g;v=r?f[h>>2]|0:h;w=(p|0)==0;if(n){if(w){x=1;break}x=(Arc(t,v,p)|0)==0;break}if(!w)if((s&255)<<24>>24==(b[v>>0]|0)){s=g;w=o;t=v;while(1){w=w+-1|0;s=s+1|0;if(!w){x=1;break a}t=t+1|0;if((b[s>>0]|0)!=(b[t>>0]|0)){x=0;break}}}else x=0;else x=1}else x=0;while(0);if(r){YDc(f[h>>2]|0);y=b[j>>0]|0}else y=m;if(y<<24>>24<0)YDc(f[g>>2]|0);r7b(e);if(x){z=l;u=d;return z|0}}}l=f[k>>2]|0;x=l+4|0;g=f[x>>2]|0;y=f[l>>2]|0;m=g;j=y;b:do if((g|0)!=(y|0)){h=f[i>>2]|0;r=b[h+11>>0]|0;o=r<<24>>24<0;p=o?f[h+4>>2]|0:r&255;r=(p|0)==0;n=(g-y|0)/12|0;c:do if(o){q=0;while(1){t=j+(q*12|0)|0;s=b[t+11>>0]|0;w=s<<24>>24<0;v=s&255;do if(((w?f[j+(q*12|0)+4>>2]|0:v)|0)==(p|0)){s=f[t>>2]|0;A=w?s:t;B=f[h>>2]|0;if(w){if(r){C=q;break c}if(!(Arc(A,B,p)|0)){C=q;break c}else break}if(r){C=q;break c}if((s&255)<<24>>24==(b[B>>0]|0)){s=t;A=v;D=B;do{A=A+-1|0;s=s+1|0;if(!A){C=q;break c}D=D+1|0}while((b[s>>0]|0)==(b[D>>0]|0))}}while(0);q=q+1|0;if(q>>>0>=n>>>0)break b}}else{q=0;while(1){v=j+(q*12|0)|0;t=b[v+11>>0]|0;w=t<<24>>24<0;D=t&255;do if(((w?f[j+(q*12|0)+4>>2]|0:D)|0)==(p|0)){t=f[v>>2]|0;s=w?t:v;if(w){if(r){C=q;break c}if(!(Arc(s,h,p)|0)){C=q;break c}else break}if(r){C=q;break c}if((t&255)<<24>>24==(b[h>>0]|0)){t=v;s=D;A=h;do{s=s+-1|0;t=t+1|0;if(!s){C=q;break c}A=A+1|0}while((b[t>>0]|0)==(b[A>>0]|0))}}while(0);q=q+1|0;if(q>>>0>=n>>>0)break b}}while(0);dVb(a,c,C);z=0;u=d;return z|0}while(0);C=f[a>>2]|0;if((b[C+21>>0]|0)==0?(f[C+4>>2]|0)!=0:0){C=f[i>>2]|0;if((m|0)==(f[l+8>>2]|0))e1(l,C);else{fEc(m,C);f[x>>2]=(f[x>>2]|0)+12}x=c+20|0;C=f[k>>2]|0;if((f[x>>2]|0)>0){m=c+28|0;i=0;j=C;while(1){y=f[(f[m>>2]|0)+4+(i<<2)>>2]|0;f[e>>2]=(b[y+11>>0]|0)<0?f[y>>2]|0:y;y=WUb(j+152|0,e)|0;if(!((y|0)!=0?(f[y+12>>2]|0)!=0:0))E=55;do if((E|0)==55){E=0;y=f[a>>2]|0;g=f[y+12>>2]|0;if(!g)F=y;else{if(eVb(g,f[(f[m>>2]|0)+4+(i<<2)>>2]|0)|0)break;F=f[a>>2]|0}fVb(F,f[(f[m>>2]|0)+4+(i<<2)>>2]|0)|0}while(0);i=i+1|0;g=f[k>>2]|0;if((i|0)>=(f[x>>2]|0)){G=g;break}else j=g}}else G=C;C=G+4|0;G=f[C>>2]|0;j=G+-12|0;x=G;while(1){G=x+-12|0;f[C>>2]=G;if((b[G+11>>0]|0)<0){YDc(f[G>>2]|0);H=f[C>>2]|0}else H=G;if((H|0)==(j|0))break;else x=H}I=f[k>>2]|0}else I=l;f[e>>2]=(f[I+76>>2]|0)-(f[I+72>>2]|0)>>2;f[e+4>>2]=(f[I+88>>2]|0)-(f[I+84>>2]|0)>>2;f[e+8>>2]=(f[I+100>>2]|0)-(f[I+96>>2]|0)>>2;f[e+12>>2]=(f[I+112>>2]|0)-(f[I+108>>2]|0)>>2;f[e+16>>2]=(f[I+124>>2]|0)-(f[I+120>>2]|0)>>2;f[e+20>>2]=(f[I+200>>2]|0)-(f[I+196>>2]|0)>>2;f[e+24>>2]=(f[I+212>>2]|0)-(f[I+208>>2]|0)>>2;f[e+28>>2]=(f[I+224>>2]|0)-(f[I+220>>2]|0)>>3;l=I+188|0;H=f[l>>2]|0;if((H|0)==(f[I+192>>2]|0))DUb(I+184|0,e);else{f[H>>2]=f[e>>2];f[H+4>>2]=f[e+4>>2];f[H+8>>2]=f[e+8>>2];f[H+12>>2]=f[e+12>>2];f[H+16>>2]=f[e+16>>2];f[H+20>>2]=f[e+20>>2];f[H+24>>2]=f[e+24>>2];f[H+28>>2]=f[e+28>>2];f[l>>2]=(f[l>>2]|0)+32}l=gVb(a,c)|0;hVb(f[a+44>>2]|0);a=f[k>>2]|0;if(!l){EUb(a);z=0;u=d;return z|0}k=a+188|0;c=(f[k>>2]|0)+-32|0;f[k>>2]=c;if((f[a+184>>2]|0)==(c|0)){c=f[a+196>>2]|0;k=a+200|0;e=f[k>>2]|0;if((e|0)!=(c|0))f[k>>2]=e+(~((e+-4-c|0)>>>2)<<2);c=f[a+208>>2]|0;e=a+212|0;k=f[e>>2]|0;if((k|0)!=(c|0))f[e>>2]=k+(~((k+-4-c|0)>>>2)<<2);c=f[a+220>>2]|0;k=a+224|0;a=f[k>>2]|0;if((a|0)!=(c|0))f[k>>2]=a+(~((a+-8-c|0)>>>3)<<3)}b[l+49>>0]=1;z=l;u=d;return z|0}function $Ub(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+88|0;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);c=a+76|0;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);aVb(a+60|0,f[a+64>>2]|0);aVb(a+48|0,f[a+52>>2]|0);c=a+28|0;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);c=a+12|0;d=f[c>>2]|0;if(!d)return;e=a+16|0;a=f[e>>2]|0;if((a|0)==(d|0))g=d;else{h=a;do{a=h+-32|0;f[e>>2]=a;i=h+-20|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);h=f[e>>2]|0}while((h|0)!=(d|0));g=f[c>>2]|0}YDc(g);return}function aVb(a,b){a=a|0;b=b|0;if(!b)return;else{aVb(a,f[b>>2]|0);aVb(a,f[b+4>>2]|0);YDc(b);return}}function bVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;i=c+120|0;j=c+4|0;k=f[j>>2]|0;l=k&-2;if(!(k&1))m=l;else m=f[l+4>>2]|0;l=f[i>>2]|0;if((l|0)==527320)WJa(i,m,g);else iEc(l,g)|0;g=f[a+4>>2]|0;l=b[g+11>>0]|0;if(l<<24>>24<0)n=f[g+4>>2]|0;else n=l&255;do if(n|0){f[h>>2]=f[h>>2]|2;l=c+124|0;m=f[j>>2]|0;i=m&-2;if(!(m&1))o=i;else o=f[i+4>>2]|0;i=f[l>>2]|0;if((i|0)==527320){WJa(l,o,g);break}else{iEc(i,g)|0;break}}while(0);if((f[a+44>>2]|0)==3)cVb(c,jUb(3)|0);g=a+16|0;if((f[g>>2]|0)>0){o=a+12|0;j=a+52|0;n=c+16|0;i=e+4|0;l=e+8|0;m=e+12|0;k=0;do{p=f[o>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[e>>2]=161436;f[i>>2]=1774;b[l>>0]=0;f[m>>2]=a;DTb(p,e)}p=f[f[(f[j>>2]|0)+(k<<2)>>2]>>2]|0;iEc(JLa(n)|0,p)|0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=a+20|0;if((f[g>>2]|0)>0){k=a+60|0;n=c+96|0;j=c+100|0;e=c+104|0;m=0;do{l=f[(f[k>>2]|0)+(m<<2)>>2]|0;i=f[n>>2]|0;if((i|0)==(f[j>>2]|0)){KLa(n,i+1|0);q=f[n>>2]|0}else q=i;i=f[e>>2]|0;f[n>>2]=q+1;f[i+4+(q<<2)>>2]=l;m=m+1|0}while((m|0)<(f[g>>2]|0))}g=a+24|0;if((f[g>>2]|0)>0){m=a+64|0;q=c+108|0;n=c+112|0;e=c+116|0;j=0;do{k=f[(f[m>>2]|0)+(j<<2)>>2]|0;l=f[q>>2]|0;if((l|0)==(f[n>>2]|0)){KLa(q,l+1|0);r=f[q>>2]|0}else r=l;l=f[e>>2]|0;f[q>>2]=r+1;f[l+4+(r<<2)>>2]=k;j=j+1|0}while((j|0)<(f[g>>2]|0))}g=a+28|0;if((f[g>>2]|0)>0){j=a+68|0;r=c+32|0;q=0;do{e=(f[j>>2]|0)+(q*88|0)|0;UXb(e,TXb(r)|0);q=q+1|0}while((q|0)<(f[g>>2]|0))}g=a+32|0;if((f[g>>2]|0)>0){q=a+72|0;r=c+48|0;j=0;do{e=(f[q>>2]|0)+(j*48|0)|0;WXb(e,VXb(r)|0);j=j+1|0}while((j|0)<(f[g>>2]|0))}g=a+36|0;if((f[g>>2]|0)>0){j=a+76|0;r=c+64|0;q=c+76|0;e=c+72|0;n=c+68|0;m=0;do{k=(f[j>>2]|0)+(m*24|0)|0;l=f[q>>2]|0;do if(l){i=f[n>>2]|0;o=f[l>>2]|0;if((i|0)>=(o|0))if((o|0)==(f[e>>2]|0)){s=o;t=50;break}else{v=o;w=l;t=51;break}else{f[n>>2]=i+1;x=f[l+4+(i<<2)>>2]|0;break}}else{s=f[e>>2]|0;t=50}while(0);if((t|0)==50){t=0;USb(r,s+1|0);l=f[q>>2]|0;v=f[l>>2]|0;w=l;t=51}if((t|0)==51){t=0;f[w>>2]=v+1;l=f[r>>2]|0;if(!l){i=VDc(40)|0;F3b(i);y=i}else{if(f[l+64>>2]|0)OQb(l,20608,40);i=MQb(l,40)|0;G3b(i,l);y=i}i=f[q>>2]|0;l=f[n>>2]|0;f[n>>2]=l+1;f[i+4+(l<<2)>>2]=y;x=y}XXb(k,x);m=m+1|0}while((m|0)<(f[g>>2]|0))}g=a+40|0;if((f[g>>2]|0)>0){m=a+80|0;x=c+80|0;y=0;do{n=(f[m>>2]|0)+(y*88|0)|0;ZXb(n,YXb(x)|0);y=y+1|0}while((y|0)<(f[g>>2]|0))}g=a+84|0;a=f[g>>2]|0;if((a|0)==(Y7b()|0)){u=d;return}f[h>>2]=f[h>>2]|8;h=c+132|0;a=f[h>>2]|0;if(!a){K7b(c);z=f[h>>2]|0}else z=a;Z7b(z,f[g>>2]|0);u=d;return}function cVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|4;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=Mpc(c)|0;if(g>>>0>4294967279)dEc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=VDc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){dJc(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+128|0;a=f[h>>2]|0;if((a|0)==527320)WJa(h,m,e);else iEc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function dVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=VDc(48)|0;f[g>>2]=h;f[g+8>>2]=-2147483600;f[g+4>>2]=33;i=h;j=485208;k=i+33|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+33>>0]=0;h=a+4|0;j=f[h>>2]|0;if((((f[j+4>>2]|0)-(f[j>>2]|0)|0)/12|0)>>>0>d>>>0){i=d;d=j;do{j=f[d>>2]|0;k=j+(i*12|0)|0;l=b[k+11>>0]|0;m=l<<24>>24<0;tEc(g,m?f[k>>2]|0:k,m?f[j+(i*12|0)+4>>2]|0:l&255)|0;uEc(g,485242)|0;i=i+1|0;d=f[h>>2]|0}while(i>>>0<(((f[d+4>>2]|0)-(f[d>>2]|0)|0)/12|0)>>>0)}d=c+120|0;i=f[d>>2]|0;h=b[i+11>>0]|0;l=h<<24>>24<0;tEc(g,l?f[i>>2]|0:i,l?f[i+4>>2]|0:h&255)|0;lVb(a,f[d>>2]|0,c,9,g);if((b[g+11>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function eVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=(g|0)==0;if(!h)dTb(g);i=a+16|0;j=f[i>>2]|0;k=j+44|0;if(!(f[k>>2]|0))l=j;else{m=j+40|0;n=f[m>>2]|0;if(n|0){o=n;do{n=o;o=f[o>>2]|0;p=n+8|0;if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);YDc(n)}while((o|0)!=0)}f[m>>2]=0;m=f[j+36>>2]|0;if(m|0){o=j+32|0;j=0;do{f[(f[o>>2]|0)+(j<<2)>>2]=0;j=j+1|0}while((j|0)!=(m|0))}f[k>>2]=0;l=f[i>>2]|0}k=l+24|0;if(!(f[k>>2]|0))q=l;else{m=l+20|0;j=f[m>>2]|0;if(j|0){o=j;do{j=o;o=f[o>>2]|0;n=j+8|0;if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);YDc(j)}while((o|0)!=0)}f[m>>2]=0;m=f[l+16>>2]|0;if(m|0){o=l+12|0;l=0;do{f[(f[o>>2]|0)+(l<<2)>>2]=0;l=l+1|0}while((l|0)!=(m|0))}f[k>>2]=0;q=f[i>>2]|0}k=c+11|0;f[e>>2]=(b[k>>0]|0)<0?f[c>>2]|0:c;m=WUb(q+152|0,e)|0;if((m|0)!=0?(q=f[m+12>>2]|0,(q|0)!=0):0)r=q;else s=24;a:do if((s|0)==24){q=f[a+12>>2]|0;if(q|0?(m=eVb(q,c)|0,m|0):0){r=m;break}do if(fVb(a,c)|0){m=f[i>>2]|0;f[e>>2]=(b[k>>0]|0)<0?f[c>>2]|0:c;q=WUb(m+152|0,e)|0;if((q|0)!=0?(m=f[q+12>>2]|0,(m|0)!=0):0){r=m;break a}else break}while(0);r=0}while(0);if(h){u=d;return r|0}eTb(g);u=d;return r|0}function fVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0;d=u;u=u+144|0;e=d;g=a+4|0;if(!(f[g>>2]|0)){h=0;u=d;return h|0}i=a+16|0;if(UUb((f[i>>2]|0)+12|0,c)|0){h=0;u=d;return h|0}N7b(e);j=f[g>>2]|0;if(hj[f[(f[j>>2]|0)+8>>2]&511](j,c,e)|0?(XUb(a,e)|0)!=0:0)k=1;else l=5;a:do if((l|0)==5){a=f[i>>2]|0;j=a+12|0;g=b[c+11>>0]|0;m=g<<24>>24<0;o=m?f[c>>2]|0:c;p=b[o>>0]|0;if(!(p<<24>>24))q=0;else{r=o;s=0;t=p;while(1){v=(s*5|0)+(t<<24>>24)|0;r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24)){q=v;break}else s=v}}s=a+16|0;t=f[s>>2]|0;r=(t|0)==0;b:do if(!r){v=t+-1|0;w=(v&t|0)==0;if(!w)if(q>>>0<t>>>0)x=q;else x=(q>>>0)%(t>>>0)|0;else x=v&q;y=f[(f[j>>2]|0)+(x<<2)>>2]|0;if((y|0)!=0?(z=f[y>>2]|0,(z|0)!=0):0){y=m?f[c+4>>2]|0:g&255;A=(y|0)==0;if(w){if(A){w=z;while(1){B=f[w+4>>2]|0;if(!((B|0)==(q|0)|(B&v|0)==(x|0))){C=x;break b}B=b[w+8+11>>0]|0;if(!((B<<24>>24<0?f[w+12>>2]|0:B&255)|0)){k=0;break a}w=f[w>>2]|0;if(!w){C=x;break b}}}else D=z;while(1){w=f[D+4>>2]|0;if(!((w|0)==(q|0)|(w&v|0)==(x|0))){C=x;break b}w=D+8|0;B=b[w+11>>0]|0;E=B<<24>>24<0;F=B&255;do if(((E?f[D+12>>2]|0:F)|0)==(y|0)){B=f[w>>2]|0;if(E)if(!(Arc(B,o,y)|0)){k=0;break a}else break;if((B&255)<<24>>24==p<<24>>24){B=w;G=F;H=o;do{G=G+-1|0;B=B+1|0;if(!G){k=0;break a}H=H+1|0}while((b[B>>0]|0)==(b[H>>0]|0))}}while(0);D=f[D>>2]|0;if(!D){C=x;break b}}}if(A){v=z;while(1){F=f[v+4>>2]|0;if((F|0)!=(q|0)){if(F>>>0<t>>>0)I=F;else I=(F>>>0)%(t>>>0)|0;if((I|0)!=(x|0)){C=x;break b}}F=b[v+8+11>>0]|0;if(!((F<<24>>24<0?f[v+12>>2]|0:F&255)|0)){k=0;break a}v=f[v>>2]|0;if(!v){C=x;break b}}}else J=z;while(1){v=f[J+4>>2]|0;if((v|0)!=(q|0)){if(v>>>0<t>>>0)K=v;else K=(v>>>0)%(t>>>0)|0;if((K|0)!=(x|0)){C=x;break b}}v=J+8|0;A=b[v+11>>0]|0;F=A<<24>>24<0;w=A&255;do if(((F?f[J+12>>2]|0:w)|0)==(y|0)){A=f[v>>2]|0;if(F)if(!(Arc(A,o,y)|0)){k=0;break a}else break;if((A&255)<<24>>24==p<<24>>24){A=v;E=w;H=o;do{E=E+-1|0;A=A+1|0;if(!E){k=0;break a}H=H+1|0}while((b[A>>0]|0)==(b[H>>0]|0))}}while(0);J=f[J>>2]|0;if(!J){C=x;break}}}else C=x}else C=0;while(0);o=VDc(20)|0;fEc(o+8|0,c);f[o+4>>2]=q;f[o>>2]=0;p=a+24|0;L=+(((f[p>>2]|0)+1|0)>>>0);M=+n[a+28>>2];do if(r|L>+(t>>>0)*M){g=(t>>>0<3|(t+-1&t|0)!=0)&1|t<<1;m=~~+X(+(L/M))>>>0;YUb(j,g>>>0<m>>>0?m:g);g=f[s>>2]|0;m=g+-1|0;if(!(m&g)){N=g;O=m&q;break}if(q>>>0<g>>>0){N=g;O=q}else{N=g;O=(q>>>0)%(g>>>0)|0}}else{N=t;O=C}while(0);t=(f[j>>2]|0)+(O<<2)|0;s=f[t>>2]|0;if(!s){r=a+20|0;f[o>>2]=f[r>>2];f[r>>2]=o;f[t>>2]=r;r=f[o>>2]|0;if(r|0){t=f[r+4>>2]|0;r=N+-1|0;if(r&N)if(t>>>0<N>>>0)P=t;else P=(t>>>0)%(N>>>0)|0;else P=t&r;Q=(f[j>>2]|0)+(P<<2)|0;l=60}}else{f[o>>2]=f[s>>2];Q=s;l=60}if((l|0)==60)f[Q>>2]=o;f[p>>2]=(f[p>>2]|0)+1;k=0}while(0);r7b(e);h=k;u=d;return h|0}function gVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;d=u;u=u+208|0;e=d;g=d+184|0;h=d+160|0;i=d+199|0;j=d+136|0;k=d+198|0;l=d+112|0;m=d+197|0;n=d+88|0;o=d+196|0;p=d+72|0;q=d+60|0;r=d+48|0;s=d+16|0;t=a+4|0;v=f[t>>2]|0;w=VDc(96)|0;f[e>>2]=w;x=v+124|0;y=f[x>>2]|0;if((y|0)==(f[v+128>>2]|0))f6(v+120|0,e);else{f[y>>2]=w;f[x>>2]=(f[x>>2]|0)+4}x=f[e>>2]|0;w=a+40|0;f[w>>2]=x;b[x+48>>0]=0;b[x+49>>0]=0;y=c+8|0;if(!(f[y>>2]&16))z=m8b()|0;else{v=f[t>>2]|0;A=VDc(32)|0;__b(A);f[e>>2]=A;B=v+88|0;C=f[B>>2]|0;if((C|0)==(f[v+92>>2]|0))iVb(v+84|0,e);else{f[C>>2]=A;f[B>>2]=(f[B>>2]|0)+4}B=f[c+136>>2]|0;n8b(A,B|0?B:528712);z=A}f[x+92>>2]=z;z=f[t>>2]|0;A=VDc(164)|0;sUb(A);f[e>>2]=A;B=z+112|0;C=f[B>>2]|0;if((C|0)==(f[z+116>>2]|0))jVb(z+108|0,e);else{f[C>>2]=A;f[B>>2]=(f[B>>2]|0)+4}B=f[e>>2]|0;f[a+44>>2]=B;f[(f[w>>2]|0)+88>>2]=B;if((f[y>>2]&1|0)==0?(f[e>>2]=0,f[e+4>>2]=0,f[e+8>>2]=0,kVb(a,e,c,9,475912),(b[e+11>>0]|0)<0):0)YDc(f[e>>2]|0);B=c+128|0;A=f[B>>2]|0;C=b[A+11>>0]|0;z=C<<24>>24<0;if(z)D=f[A+4>>2]|0;else D=C&255;a:do if(D){v=f[A+4>>2]|0;if(((z?v:C&255)|0)==6){if(!(EEc(A,0,-1,475905,6)|0)){E=24;break}F=f[B>>2]|0;G=F;H=b[F+11>>0]|0;I=f[F+4>>2]|0}else{G=A;H=C;I=v}do if(((H<<24>>24<0?I:H&255)|0)==6){v=(EEc(G,0,-1,475898,6)|0)==0;F=(f[w>>2]|0)+44|0;if(v){f[F>>2]=3;break a}else{J=F;K=f[B>>2]|0;break}}else{J=(f[w>>2]|0)+44|0;K=G}while(0);f[J>>2]=0;F=f[c+120>>2]|0;VHa(e,475953,K);lVb(a,F,c,9,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0)}else E=24;while(0);if((E|0)==24)f[(f[w>>2]|0)+44>>2]=2;w=f[t>>2]|0;K=c+120|0;J=f[K>>2]|0;G=VDc(12)|0;fEc(G,J);f[e>>2]=G;J=w+76|0;B=f[J>>2]|0;if((B|0)==(f[w+80>>2]|0))mVb(w+72|0,e);else{f[B>>2]=G;f[J>>2]=(f[J>>2]|0)+4}f[x>>2]=f[e>>2];J=f[t>>2]|0;if(!(f[y>>2]&2)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;G=VDc(12)|0;fEc(G,g);f[e>>2]=G;B=J+76|0;w=f[B>>2]|0;if((w|0)==(f[J+80>>2]|0))mVb(J+72|0,e);else{f[w>>2]=G;f[B>>2]=(f[B>>2]|0)+4}f[x+4>>2]=f[e>>2];if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0)}else{B=f[c+124>>2]|0;G=VDc(12)|0;fEc(G,B);f[e>>2]=G;B=J+76|0;w=f[B>>2]|0;if((w|0)==(f[J+80>>2]|0))mVb(J+72|0,e);else{f[w>>2]=G;f[B>>2]=(f[B>>2]|0)+4}f[x+4>>2]=f[e>>2]}f[x+8>>2]=f[a>>2];B=f[t>>2]|0;G=f[x>>2]|0;if((b[G+11>>0]|0)<0)L=f[G>>2]|0;else L=G;f[e>>2]=L;f[e+4>>2]=x;if(!(nVb(B+152|0,e)|0)){kVb(a,f[K>>2]|0,c,9,475975);M=0;u=d;return M|0}L=f[x>>2]|0;if((b[L+11>>0]|0)<0)N=f[L>>2]|0;else N=L;f[e>>2]=N;L=B+212|0;G=f[L>>2]|0;if((G|0)==(f[B+216>>2]|0))oVb(B+208|0,e);else{f[G>>2]=N;f[L>>2]=(f[L>>2]|0)+4}L=x+4|0;N=f[L>>2]|0;G=b[N+11>>0]|0;if(G<<24>>24<0)O=f[N+4>>2]|0;else O=G&255;if(O|0)pVb(a,N,c,x);N=q+4|0;f[N>>2]=0;O=q+8|0;f[O>>2]=0;G=q+4|0;f[q>>2]=G;B=c+20|0;w=f[B>>2]|0;J=x+16|0;f[J>>2]=w;H=f[t>>2]|0;I=w<<2;if(!I)P=0;else{w=VDc(I)|0;f[e>>2]=w;I=H+124|0;C=f[I>>2]|0;if((C|0)==(f[H+128>>2]|0))f6(H+120|0,e);else{f[C>>2]=w;f[I>>2]=(f[I>>2]|0)+4}P=f[e>>2]|0}I=x+52|0;f[I>>2]=P;if(b[(f[a>>2]|0)+21>>0]|0){P=f[t>>2]|0;w=VDc(4)|0;f[w>>2]=0;f[e>>2]=w;C=P+100|0;H=f[C>>2]|0;if((H|0)==(f[P+104>>2]|0))qVb(P+96|0,e);else{f[H>>2]=w;f[C>>2]=(f[C>>2]|0)+4}f[x+12>>2]=f[e>>2];C=f[t>>2]|0;w=f[B>>2]|0;H=w<<2;if(!H){Q=0;R=w}else{w=VDc(H)|0;f[e>>2]=w;H=C+124|0;P=f[H>>2]|0;if((P|0)==(f[C+128>>2]|0))f6(C+120|0,e);else{f[P>>2]=w;f[H>>2]=(f[H>>2]|0)+4}Q=f[e>>2]|0;R=f[B>>2]|0}f[x+56>>2]=Q;if((R|0)>0)XIc(Q|0,0,R<<2|0)|0}else{f[x+12>>2]=0;f[x+56>>2]=0}R=a+60|0;Q=a+64|0;aVb(R,f[Q>>2]|0);H=a+68|0;f[H>>2]=0;f[R>>2]=Q;f[Q>>2]=0;w=r+4|0;f[w>>2]=0;P=r+8|0;f[P>>2]=0;C=r+4|0;f[r>>2]=C;A=c+108|0;z=f[A>>2]|0;b:do if((z|0)>0){D=c+116|0;F=0;v=0;S=z;while(1){T=f[(f[D>>2]|0)+4+(F<<2)>>2]|0;do if(v){U=w;V=v;while(1){W=f[V+16>>2]|0;if((T|0)<(W|0)){X=f[V>>2]|0;if(!X){E=88;break}else{Y=V;Z=X}}else{if((W|0)>=(T|0)){E=92;break}_=V+4|0;W=f[_>>2]|0;if(!W){E=91;break}else{Y=_;Z=W}}U=Y;V=Z}if((E|0)==88){E=0;$=V;aa=V;break}else if((E|0)==91){E=0;$=_;aa=V;break}else if((E|0)==92){E=0;$=U;aa=V;break}}else{$=C;aa=C}while(0);if(!(f[$>>2]|0)){W=VDc(20)|0;f[W+16>>2]=T;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=aa;f[$>>2]=W;X=f[f[r>>2]>>2]|0;if(!X)ba=W;else{f[r>>2]=X;ba=f[$>>2]|0}laa(f[w>>2]|0,ba);f[P>>2]=(f[P>>2]|0)+1;ca=f[A>>2]|0}else ca=S;X=F+1|0;if((X|0)>=(ca|0))break b;F=X;v=f[C>>2]|0;S=ca}}while(0);c:do if((f[B>>2]|0)>0){ca=c+28|0;P=x+56|0;ba=a+64|0;w=0;while(1){$=f[(f[ca>>2]|0)+4+(w<<2)>>2]|0;aa=kaa(q,e,$)|0;if(!(f[aa>>2]|0)){_=VDc(28)|0;fEc(_+16|0,$);$=f[e>>2]|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=$;f[aa>>2]=_;$=f[f[q>>2]>>2]|0;if(!$)da=_;else{f[q>>2]=$;da=f[aa>>2]|0}laa(f[N>>2]|0,da);f[O>>2]=(f[O>>2]|0)+1}else rVb(a,c,w);aa=f[t>>2]|0;$=f[(f[ca>>2]|0)+4+(w<<2)>>2]|0;f[e>>2]=(b[$+11>>0]|0)<0?f[$>>2]|0:$;$=WUb(aa+152|0,e)|0;if($){aa=f[$+12>>2]|0;$=aa;if(!aa){ea=$;E=107}else fa=$}else{ea=0;E=107}do if((E|0)==107){E=0;$=f[(f[a>>2]|0)+12>>2]|0;if(!$){fa=ea;break}fa=eVb($,f[(f[ca>>2]|0)+4+(w<<2)>>2]|0)|0}while(0);T=fa;if((T|0)==(x|0)){ga=0;ha=q;ia=C;break c}$=f[a>>2]|0;d:do if(!fa){if(b[$+21>>0]|0){ja=0;break}e:do if(!(b[$+22>>0]|0)){do if(!(b[$+23>>0]|0)){aa=f[C>>2]|0;if(!aa)break;else{ka=C;la=aa}f:while(1){aa=la;while(1){if((f[aa+16>>2]|0)>=(w|0))break;_=f[aa+4>>2]|0;if(!_){ma=ka;break f}else aa=_}la=f[aa>>2]|0;if(!la){ma=aa;break}else ka=aa}if((ma|0)==(C|0))break;if((w|0)>=(f[ma+16>>2]|0))break e}while(0);tVb(a,c,w);ja=0;break d}while(0);ja=sVb($,f[(f[ca>>2]|0)+4+(w<<2)>>2]|0)|0}else{if(!(b[$+20>>0]|0)){ja=fa;break}V=uVb($+28|0,f[K>>2]|0)|0;if((V|0)==((f[a>>2]|0)+32|0)){ja=fa;break}if(f[T+20>>2]|0){ja=fa;break}V=f[Q>>2]|0;do if(V){U=ba;_=V;while(1){Z=f[_+16>>2]|0;if(T>>>0<Z>>>0){Y=f[_>>2]|0;if(!Y){E=130;break}else{na=_;oa=Y}}else{if(Z>>>0>=T>>>0){E=134;break}pa=_+4|0;Z=f[pa>>2]|0;if(!Z){E=133;break}else{na=pa;oa=Z}}U=na;_=oa}if((E|0)==130){E=0;qa=_;ra=_;break}else if((E|0)==133){E=0;qa=pa;ra=_;break}else if((E|0)==134){E=0;qa=U;ra=_;break}}else{qa=Q;ra=Q}while(0);if(f[qa>>2]|0){ja=fa;break}V=VDc(20)|0;f[V+16>>2]=fa;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=ra;f[qa>>2]=V;Z=f[f[R>>2]>>2]|0;if(!Z)sa=V;else{f[R>>2]=Z;sa=f[qa>>2]|0}laa(f[ba>>2]|0,sa);f[H>>2]=(f[H>>2]|0)+1;ja=fa}while(0);f[(f[I>>2]|0)+(w<<2)>>2]=ja;if(!(ja|0?1:(b[(f[a>>2]|0)+21>>0]|0)==0)){T=f[t>>2]|0;$=f[(f[ca>>2]|0)+4+(w<<2)>>2]|0;Z=VDc(12)|0;fEc(Z,$);f[e>>2]=Z;$=T+76|0;V=f[$>>2]|0;if((V|0)==(f[T+80>>2]|0))mVb(T+72|0,e);else{f[V>>2]=Z;f[$>>2]=(f[$>>2]|0)+4}f[(f[P>>2]|0)+(w<<2)>>2]=f[e>>2]}w=w+1|0;if((w|0)>=(f[B>>2]|0)){E=145;break}}}else E=145;while(0);if((E|0)==145){ja=f[t>>2]|0;fa=c+96|0;sa=f[fa>>2]|0;qa=sa<<2;if(!qa){ta=0;ua=sa}else{sa=VDc(qa)|0;f[e>>2]=sa;qa=ja+124|0;ra=f[qa>>2]|0;if((ra|0)==(f[ja+128>>2]|0))f6(ja+120|0,e);else{f[ra>>2]=sa;f[qa>>2]=(f[qa>>2]|0)+4}ta=f[e>>2]|0;ua=f[fa>>2]|0}qa=x+60|0;f[qa>>2]=ta;if((ua|0)>0){ua=c+104|0;ta=x+12|0;sa=e+4|0;ra=e+8|0;ja=e+12|0;pa=0;oa=0;while(1){na=f[(f[ua>>2]|0)+4+(pa<<2)>>2]|0;do if((na|0)>-1?(na|0)<(f[B>>2]|0):0){ma=oa+1|0;f[(f[qa>>2]|0)+(oa<<2)>>2]=na;if(b[(f[a>>2]|0)+21>>0]|0){va=ma;break}ka=f[ta>>2]|0;do if(ka|0){if((f[ka>>2]|0)==2)break;f[e>>2]=161436;f[sa>>2]=1774;b[ra>>0]=0;f[ja>>2]=x;DTb(ka,e)}while(0);ka=f[(f[I>>2]|0)+(na<<2)>>2]|0;la=f[Q>>2]|0;if(!la){va=ma;break}else{wa=Q;xa=la}g:while(1){ea=xa;while(1){if((f[ea+16>>2]|0)>>>0>=ka>>>0)break;O=f[ea+4>>2]|0;if(!O){ya=wa;break g}else ea=O}xa=f[ea>>2]|0;if(!xa){ya=ea;break}else wa=ea}if((ya|0)==(Q|0)){va=ma;break}if(ka>>>0<(f[ya+16>>2]|0)>>>0){va=ma;break}O=f[ya+4>>2]|0;do if(!O){da=ya+8|0;N=f[da>>2]|0;if((f[N>>2]|0)==(ya|0)){za=N;break}else Aa=da;do{da=f[Aa>>2]|0;Aa=da+8|0;N=f[Aa>>2]|0}while((f[N>>2]|0)!=(da|0));za=N}else{ea=O;while(1){N=f[ea>>2]|0;if(!N)break;else ea=N}za=ea}while(0);if((f[R>>2]|0)==(ya|0))f[R>>2]=za;f[H>>2]=(f[H>>2]|0)+-1;uHa(la,ya);YDc(ya);va=ma}else{kVb(a,f[K>>2]|0,c,9,476021);va=oa}while(0);pa=pa+1|0;if((pa|0)>=(f[fa>>2]|0)){Ba=va;break}else oa=va}}else Ba=0;f[x+20>>2]=Ba;Ba=a+48|0;va=a+52|0;aVb(Ba,f[va>>2]|0);f[a+56>>2]=0;f[Ba>>2]=va;f[va>>2]=0;do if(!(b[(f[a>>2]|0)+21>>0]|0)){if((f[J>>2]|0)<=0)break;va=x+12|0;Ba=e+4|0;oa=e+8|0;fa=e+12|0;pa=0;do{ya=f[va>>2]|0;do if(ya|0){if((f[ya>>2]|0)==2)break;f[e>>2]=161436;f[Ba>>2]=1774;b[oa>>0]=0;f[fa>>2]=x;DTb(ya,e)}while(0);wVb(a,f[(f[I>>2]|0)+(pa<<2)>>2]|0);pa=pa+1|0}while((pa|0)<(f[J>>2]|0))}while(0);J=f[t>>2]|0;I=f[A>>2]|0;pa=I<<2;if(!pa){Ca=0;Da=I}else{I=VDc(pa)|0;f[e>>2]=I;pa=J+124|0;fa=f[pa>>2]|0;if((fa|0)==(f[J+128>>2]|0))f6(J+120|0,e);else{f[fa>>2]=I;f[pa>>2]=(f[pa>>2]|0)+4}Ca=f[e>>2]|0;Da=f[A>>2]|0}pa=x+64|0;f[pa>>2]=Ca;if((Da|0)>0){Da=c+116|0;Ca=0;I=0;while(1){fa=f[(f[Da>>2]|0)+4+(Ca<<2)>>2]|0;if((fa|0)>-1?(fa|0)<(f[B>>2]|0):0){f[(f[pa>>2]|0)+(I<<2)>>2]=fa;Ea=I+1|0}else{kVb(a,f[K>>2]|0,c,9,476054);Ea=I}Ca=Ca+1|0;if((Ca|0)>=(f[A>>2]|0)){Fa=Ea;break}else I=Ea}}else Fa=0;f[x+24>>2]=Fa;Fa=c+36|0;Ea=f[Fa>>2]|0;f[x+28>>2]=Ea;I=x+68|0;A=f[t>>2]|0;Ca=Ea*88|0;if(!Ca){Ga=0;Ha=Ea}else{Ea=VDc(Ca)|0;f[e>>2]=Ea;Ca=A+124|0;K=f[Ca>>2]|0;if((K|0)==(f[A+128>>2]|0))f6(A+120|0,e);else{f[K>>2]=Ea;f[Ca>>2]=(f[Ca>>2]|0)+4}Ga=f[e>>2]|0;Ha=f[Fa>>2]|0}f[I>>2]=Ga;h:do if((Ha|0)>0){Ca=c+44|0;Ea=0;K=Ga;while(1){xVb(a,f[(f[Ca>>2]|0)+4+(Ea<<2)>>2]|0,0,K+(Ea*88|0)|0);A=Ea+1|0;if((A|0)>=(f[Fa>>2]|0))break h;Ea=A;K=f[I>>2]|0}}while(0);Ga=c+52|0;Ha=f[Ga>>2]|0;f[x+32>>2]=Ha;K=x+72|0;Ea=f[t>>2]|0;Ca=Ha*48|0;if(!Ca){Ia=0;Ja=Ha}else{Ha=VDc(Ca)|0;f[e>>2]=Ha;Ca=Ea+124|0;A=f[Ca>>2]|0;if((A|0)==(f[Ea+128>>2]|0))f6(Ea+120|0,e);else{f[A>>2]=Ha;f[Ca>>2]=(f[Ca>>2]|0)+4}Ia=f[e>>2]|0;Ja=f[Ga>>2]|0}f[K>>2]=Ia;i:do if((Ja|0)>0){Ca=c+60|0;Ha=0;A=Ia;while(1){yVb(a,f[(f[Ca>>2]|0)+4+(Ha<<2)>>2]|0,0,A+(Ha*48|0)|0);Ea=Ha+1|0;if((Ea|0)>=(f[Ga>>2]|0))break i;Ha=Ea;A=f[K>>2]|0}}while(0);K=c+68|0;Ga=f[K>>2]|0;f[x+36>>2]=Ga;Ia=x+76|0;Ja=f[t>>2]|0;A=Ga*24|0;if(!A){Ka=0;La=Ga}else{Ga=VDc(A)|0;f[e>>2]=Ga;A=Ja+124|0;Ha=f[A>>2]|0;if((Ha|0)==(f[Ja+128>>2]|0))f6(Ja+120|0,e);else{f[Ha>>2]=Ga;f[A>>2]=(f[A>>2]|0)+4}Ka=f[e>>2]|0;La=f[K>>2]|0}f[Ia>>2]=Ka;j:do if((La|0)>0){A=c+76|0;Ga=0;Ha=Ka;while(1){zVb(a,f[(f[A>>2]|0)+4+(Ga<<2)>>2]|0,0,Ha+(Ga*24|0)|0);Ja=Ga+1|0;if((Ja|0)>=(f[K>>2]|0))break j;Ga=Ja;Ha=f[Ia>>2]|0}}while(0);Ia=c+84|0;K=f[Ia>>2]|0;f[x+40>>2]=K;Ka=x+80|0;La=f[t>>2]|0;t=K*88|0;if(!t){Ma=0;Na=K}else{K=VDc(t)|0;f[e>>2]=K;t=La+124|0;Ha=f[t>>2]|0;if((Ha|0)==(f[La+128>>2]|0))f6(La+120|0,e);else{f[Ha>>2]=K;f[t>>2]=(f[t>>2]|0)+4}Ma=f[e>>2]|0;Na=f[Ia>>2]|0}f[Ka>>2]=Ma;k:do if((Na|0)>0){t=c+92|0;K=0;Ha=Ma;while(1){AVb(a,f[(f[t>>2]|0)+4+(K<<2)>>2]|0,0,Ha+(K*88|0)|0,1);La=K+1|0;if((La|0)>=(f[Ia>>2]|0))break k;K=La;Ha=f[Ka>>2]|0}}while(0);if(f[y>>2]&8){y=f[c+132>>2]|0;jIa(e,f[L>>2]|0,476085);BVb(a,e,f[x>>2]|0,y|0?y:528056,x);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0)}else f[x+84>>2]=0;CVb(a,x,c);y=a+24|0;do if(!(b[y>>0]|0)){DVb(s,a);L=a+12|0;Ka=f[L>>2]|0;Ia=a+16|0;do if((Ka|0)!=(f[Ia>>2]|0)){Ma=s+4|0;Na=g+8|0;Ha=g+4|0;K=g+11|0;t=g+8|0;La=g+4|0;Ga=g+11|0;A=s+8|0;Ja=e+11|0;Ca=g+11|0;Ea=p+11|0;pa=Ka;do{B=f[pa+28>>2]|0;Da=f[pa+24>>2]|0;f[Ma>>2]=pa;mi[f[(f[B>>2]|0)+96>>2]&2047](e,B);fa=f[e>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;J=VDc(32)|0;f[g>>2]=J;f[Na>>2]=-2147483616;f[Ha>>2]=20;oa=J;Ba=476092;va=oa+20|0;do{b[oa>>0]=b[Ba>>0]|0;oa=oa+1|0;Ba=Ba+1|0}while((oa|0)<(va|0));b[J+20>>0]=0;EVb(e,f[(f[fa+8>>2]|0)+88>>2]|0,fa,g);ea=(f[e>>2]|0)==2;ya=e;ma=ea?f[ya+4>>2]|0:0;if(!((ea?f[ya>>2]|0:0)|0))Oa=0;else Oa=b[ma+38>>0]|0?0:ma;if((b[K>>0]|0)<0)YDc(f[g>>2]|0);if(!Oa){rTb(h,3,475801,6243);oTb(i,mTb(mTb(h,476113)|0,476165)|0);sTb(h)}ma=_i[f[(f[B>>2]|0)+92>>2]&1023](B)|0;Ti[f[(f[ma>>2]|0)+28>>2]&511](ma,B,Oa);mi[f[(f[Da>>2]|0)+96>>2]&2047](e,Da);ma=f[e>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ya=VDc(32)|0;f[g>>2]=ya;f[t>>2]=-2147483616;f[La>>2]=20;oa=ya;Ba=476092;va=oa+20|0;do{b[oa>>0]=b[Ba>>0]|0;oa=oa+1|0;Ba=Ba+1|0}while((oa|0)<(va|0));b[ya+20>>0]=0;EVb(e,f[(f[ma+8>>2]|0)+88>>2]|0,ma,g);Ba=(f[e>>2]|0)==2;oa=e;va=Ba?f[oa+4>>2]|0:0;if(!((Ba?f[oa>>2]|0:0)|0))Pa=0;else Pa=b[va+38>>0]|0?0:va;if((b[Ga>>0]|0)<0)YDc(f[g>>2]|0);if(!Pa){rTb(j,3,475801,6251);oTb(k,mTb(mTb(j,476225)|0,476165)|0);sTb(j)}va=_i[f[(f[Da>>2]|0)+92>>2]&1023](Da)|0;oa=hj[f[(f[va>>2]|0)+24>>2]&511](va,Da,Pa)|0;l:do if((oa|0)>0){va=0;while(1){Ba=_i[f[(f[Da>>2]|0)+92>>2]&1023](Da)|0;fa=hh[f[(f[Ba>>2]|0)+208>>2]&127](Ba,Da,Pa,va)|0;f[A>>2]=fa;va=va+1|0;if(!(FVb(s,B)|0))break;if((va|0)>=(oa|0)){E=259;break l}}f[A>>2]=0;f[Ma>>2]=0}else E=259;while(0);if((E|0)==259){E=0;f[A>>2]=0;f[Ma>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(!(PSb(B,e)|0)){rTb(l,3,475801,6280);oTb(m,mTb(mTb(l,476286)|0,476339)|0);sTb(l)}if(!(LSb(B,e)|0)){rTb(n,3,475801,6282);oTb(o,mTb(mTb(n,476381)|0,476434)|0);sTb(n)}if(!(_i[f[(f[B>>2]|0)+32>>2]&1023](B)|0)){oa=f[s>>2]|0;mi[f[(f[B>>2]|0)+36>>2]&2047](p,B);VHa(g,476489,p);GVb(oa,pa+12|0,Da,9,g);if((b[Ca>>0]|0)<0)YDc(f[g>>2]|0);if((b[Ea>>0]|0)<0)YDc(f[p>>2]|0)}if((b[Ja>>0]|0)<0)YDc(f[e>>2]|0)}pa=pa+32|0}while((pa|0)!=(f[Ia>>2]|0));Ja=f[L>>2]|0;if((pa|0)==(Ja|0))break;else Qa=pa;do{Ea=Qa+-32|0;f[Ia>>2]=Ea;Ca=Qa+-20|0;if((b[Ca+11>>0]|0)<0)YDc(f[Ca>>2]|0);if((b[Ea+11>>0]|0)<0)YDc(f[Ea>>2]|0);Qa=f[Ia>>2]|0}while((Qa|0)!=(Ja|0))}while(0);f9b(s+12|0);if(b[y>>0]|0){E=275;break}if(b[(f[a>>2]|0)+21>>0]|0)break;HVb(a,x,c);if((b[y>>0]|0)!=0&(f[Fa>>2]|0)>0)E=276}else E=275;while(0);if((E|0)==275?(f[Fa>>2]|0)>0:0)E=276;if((E|0)==276){E=c+44|0;s=0;do{IVb(a,(f[I>>2]|0)+(s*88|0)|0,f[(f[E>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[Fa>>2]|0))}do if(f[H>>2]|0){if(b[(f[a>>2]|0)+21>>0]|0)break;JVb(a,c,0)}while(0);ga=(b[y>>0]|0)==0?x:0;ha=q;ia=C}GFa(r,f[ia>>2]|0);jaa(ha,f[G>>2]|0);M=ga;u=d;return M|0}function hVb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+40|0;c=f[b>>2]|0;if(c|0){d=f[c+8>>2]|0;if(d|0){e=d;do{d=e;e=f[e>>2]|0;YDc(d)}while((e|0)!=0)}e=f[c>>2]|0;f[c>>2]=0;if(e|0)YDc(e);YDc(c)}f[b>>2]=0;b=a+68|0;a=f[b>>2]|0;if(!a){f[b>>2]=0;return}c=f[a+8>>2]|0;if(c|0){e=c;do{c=e;e=f[e>>2]|0;YDc(c)}while((e|0)!=0)}e=f[a>>2]|0;f[a>>2]=0;if(e|0)YDc(e);YDc(a);f[b>>2]=0;return}function iVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function jVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function kVb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;j=Mpc(g)|0;if(j>>>0>4294967279)dEc(i);if(j>>>0<11){b[i+11>>0]=j;if(!j)k=i;else{l=i;m=6}}else{n=j+16&-16;o=VDc(n)|0;f[i>>2]=o;f[i+8>>2]=n|-2147483648;f[i+4>>2]=j;l=o;m=6}if((m|0)==6){dJc(l|0,g|0,j|0)|0;k=l}b[k+j>>0]=0;lVb(a,c,d,e,i);if((b[i+11>>0]|0)>=0){u=h;return}YDc(f[i>>2]|0);u=h;return}function lVb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+24|0;j=h;k=f[a+8>>2]|0;if(k|0){Fh[f[(f[k>>2]|0)+8>>2]&255](k,a+28|0,c,d,e,g);l=a+24|0;b[l>>0]=1;u=h;return}e=a+24|0;if(!(b[e>>0]|0)){rTb(i,2,475801,3592);oTb(h+49|0,mTb(nTb(mTb(i,485166)|0,a+28|0)|0,485202)|0);sTb(i)}rTb(j,2,475801,3595);oTb(h+48|0,nTb(mTb(nTb(mTb(j,485205)|0,c)|0,509015)|0,g)|0);sTb(j);l=e;b[l>>0]=1;u=h;return}function mVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function nVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]|0;e=b[d>>0]|0;if(!(e<<24>>24))g=0;else{h=d;i=0;j=e;while(1){e=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=e;break}else i=e}}i=a+4|0;j=f[i>>2]|0;h=(j|0)==0;a:do if(!h){e=j+-1|0;k=(e&j|0)==0;if(!k)if(g>>>0<j>>>0)l=g;else l=(g>>>0)%(j>>>0)|0;else l=e&g;m=f[(f[a>>2]|0)+(l<<2)>>2]|0;if(!m)o=l;else{if(k){k=m;while(1){k=f[k>>2]|0;if(!k){o=l;break a}p=f[k+4>>2]|0;if(!((p|0)==(g|0)|(p&e|0)==(l|0))){o=l;break a}if(!(Ioc(f[k+8>>2]|0,d)|0)){q=0;break}}return q|0}else r=m;while(1){r=f[r>>2]|0;if(!r){o=l;break a}k=f[r+4>>2]|0;if((k|0)!=(g|0)){if(k>>>0<j>>>0)s=k;else s=(k>>>0)%(j>>>0)|0;if((s|0)!=(l|0)){o=l;break a}}if(!(Ioc(f[r+8>>2]|0,d)|0)){q=0;break}}return q|0}}else o=0;while(0);d=VDc(16)|0;r=c;c=f[r+4>>2]|0;l=d+8|0;f[l>>2]=f[r>>2];f[l+4>>2]=c;f[d+4>>2]=g;f[d>>2]=0;c=a+12|0;t=+(((f[c>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(h|t>+(j>>>0)*u){l=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;r=~~+X(+(t/u))>>>0;mUb(a,l>>>0<r>>>0?r:l);l=f[i>>2]|0;r=l+-1|0;if(!(r&l)){v=l;w=r&g;break}if(g>>>0<l>>>0){v=l;w=g}else{v=l;w=(g>>>0)%(l>>>0)|0}}else{v=j;w=o}while(0);o=(f[a>>2]|0)+(w<<2)|0;w=f[o>>2]|0;if(!w){j=a+8|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[o>>2]=j;j=f[d>>2]|0;if(j|0){o=f[j+4>>2]|0;j=v+-1|0;if(j&v)if(o>>>0<v>>>0)x=o;else x=(o>>>0)%(v>>>0)|0;else x=o&j;y=(f[a>>2]|0)+(x<<2)|0;z=32}}else{f[d>>2]=f[w>>2];y=w;z=32}if((z|0)==32)f[y>>2]=d;f[c>>2]=(f[c>>2]|0)+1;q=1;return q|0}function oVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function pVb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+48|0;h=g+36|0;i=g+24|0;j=g+12|0;k=g;l=a+4|0;m=f[l>>2]|0;n=c+11|0;f[h>>2]=(b[n>>0]|0)<0?f[c>>2]|0:c;f[h+4>>2]=8;f[h+8>>2]=e;if(wXb(m+132|0,h)|0){o=(b[n>>0]|0)<0?f[c>>2]|0:c;f[h>>2]=o;p=m+200|0;q=f[p>>2]|0;if((q|0)==(f[m+204>>2]|0))oVb(m+196|0,h);else{f[q>>2]=o;f[p>>2]=(f[p>>2]|0)+4}p=DEc(c,46,-1)|0;if((p|0)==-1){tXb(a,c,c,d);u=g;return}o=f[l>>2]|0;gEc(i,c,0,p,c);q=VDc(12)|0;fEc(q,i);f[h>>2]=q;m=o+76|0;r=f[m>>2]|0;if((r|0)==(f[o+80>>2]|0))mVb(o+72|0,h);else{f[r>>2]=q;f[m>>2]=(f[m>>2]|0)+4}m=f[h>>2]|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);pVb(a,m,d,e);gEc(h,c,p+1|0,-1,c);tXb(a,h,c,d);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);u=g;return}p=f[l>>2]|0;f[h>>2]=(b[n>>0]|0)<0?f[c>>2]|0:c;n=SUb(p+132|0,h)|0;if(n){p=f[n+12>>2]|0;if((p|0)==8){u=g;return}else{s=p;t=f[n+16>>2]|0}}else{s=0;t=0}VHa(k,501908,c);jIa(j,k,485099);switch(s|0){case 7:{v=(f[t+8>>2]|0)+8|0;w=25;break}case 1:{v=t+8|0;w=25;break}case 2:{v=t+20|0;w=25;break}case 3:{v=(f[t+8>>2]|0)+8|0;w=25;break}case 4:{v=t+8|0;w=25;break}case 5:{v=(f[t+12>>2]|0)+8|0;w=25;break}case 6:{v=t+8|0;w=25;break}default:x=0}if((w|0)==25)x=f[v>>2]|0;QJa(i,j,f[x>>2]|0);jIa(h,i,502535);lVb(a,c,d,0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);u=g;return}function qVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function rVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+12|0;h=e;i=f[c+120>>2]|0;VHa(h,485016,f[(f[c+28>>2]|0)+4+(d<<2)>>2]|0);jIa(g,h,485079);lVb(a,i,c,9,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)>=0){u=e;return}YDc(f[h>>2]|0);u=e;return}function sVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;i=VDc(96)|0;f[e>>2]=i;j=h+124|0;k=f[j>>2]|0;if((k|0)==(f[h+128>>2]|0))f6(h+120|0,e);else{f[k>>2]=i;f[j>>2]=(f[j>>2]|0)+4}j=f[e>>2]|0;i=j;k=i+96|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(k|0));i=f[g>>2]|0;g=VDc(12)|0;fEc(g,c);f[e>>2]=g;c=i+76|0;k=f[c>>2]|0;if((k|0)==(f[i+80>>2]|0))mVb(i+72|0,e);else{f[k>>2]=g;f[c>>2]=(f[c>>2]|0)+4}f[j>>2]=f[e>>2];if((f[220804]|0)!=2){f[e>>2]=161028;f[e+4>>2]=125;b[e+8>>0]=0;DTb(883216,e);ZSb(e)}f[j+4>>2]=527320;f[j+8>>2]=a;a=Y7b()|0;f[j+84>>2]=a;if((f[220828]|0)==2){l=f[220829]|0;m=j+88|0;f[m>>2]=l;n=m8b()|0;o=j+92|0;f[o>>2]=n;p=j+48|0;b[p>>0]=1;q=j+44|0;f[q>>2]=2;r=j+49|0;b[r>>0]=1;u=d;return j|0}f[e>>2]=161028;f[e+4>>2]=129;b[e+8>>0]=0;DTb(883312,e);ZSb(e);l=f[220829]|0;m=j+88|0;f[m>>2]=l;n=m8b()|0;o=j+92|0;f[o>>2]=n;p=j+48|0;b[p>>0]=1;q=j+44|0;f[q>>2]=2;r=j+49|0;b[r>>0]=1;u=d;return j|0}function tVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(!(f[(f[a>>2]|0)+4>>2]|0)){VHa(i,485016,f[(f[c+28>>2]|0)+4+(d<<2)>>2]|0);jIa(h,i,485025);iEc(g,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0)}else{VHa(i,485016,f[(f[c+28>>2]|0)+4+(d<<2)>>2]|0);jIa(h,i,485048);iEc(g,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0)}lVb(a,f[c+120>>2]|0,c,9,g);if((b[g+11>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function uVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function vVb(a){a=a|0;OXb(a);return}function wVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=c;if(!c){u=d;return}h=a+48|0;i=a+52|0;j=f[i>>2]|0;do if(j){k=a+52|0;l=j;while(1){m=f[l+16>>2]|0;if(m>>>0>c>>>0){n=f[l>>2]|0;if(!n){o=7;break}else{p=l;q=n}}else{if(m>>>0>=c>>>0){o=11;break}r=l+4|0;m=f[r>>2]|0;if(!m){o=10;break}else{p=r;q=m}}k=p;l=q}if((o|0)==7){s=l;t=l;break}else if((o|0)==10){s=r;t=l;break}else if((o|0)==11){s=k;t=l;break}}else{s=i;t=i}while(0);if(f[s>>2]|0){u=d;return}i=VDc(20)|0;f[i+16>>2]=g;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=t;f[s>>2]=i;t=f[f[h>>2]>>2]|0;if(!t)v=i;else{f[h>>2]=t;v=f[s>>2]|0}laa(f[a+52>>2]|0,v);v=a+56|0;f[v>>2]=(f[v>>2]|0)+1;v=c+20|0;if((f[v>>2]|0)<=0){u=d;return}s=c+60|0;t=c+12|0;h=c+52|0;i=e+4|0;g=e+8|0;o=e+12|0;r=0;do{q=f[(f[s>>2]|0)+(r<<2)>>2]|0;p=f[t>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[e>>2]=161436;f[i>>2]=1774;b[g>>0]=0;f[o>>2]=c;DTb(p,e)}wVb(a,f[(f[h>>2]|0)+(q<<2)>>2]|0);r=r+1|0}while((r|0)<(f[v>>2]|0));u=d;return}
function dic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;d=a;a=c;a:while(1){c=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=c-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=17;break a;break}case 4:{l=18;break a;break}case 5:{l=19;break a;break}case 1:case 0:{l=207;break a;break}default:{}}if((j|0)<124){l=21;break a}m=h+(((k|0)/2|0)<<2)|0;if((j|0)>3996){j=(k|0)/4|0;n=tic(h,h+(j<<2)|0,m,m+(j<<2)|0,e)|0}else n=ric(h,m,e)|0;j=f[h>>2]|0;k=f[m>>2]|0;o=(b[j+38>>0]|0)==0;p=j;do if(!o){q=f[j+56>>2]|0;if(!q){r=(f[j+20>>2]|0)+80|0;break}else{r=q+40|0;break}}else r=(f[j+48>>2]|0)+20|0;while(0);q=p-(f[r>>2]|0)|0;s=(b[k+38>>0]|0)==0;do if(!s){t=f[k+56>>2]|0;u=k;if(!t){v=u-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{v=u-(f[t+40>>2]|0)|0;break}}else v=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);if((q|0)<(v|0)){w=e;x=n;break}t=k+48|0;u=k;y=k+56|0;z=k;A=k+20|0;B=e;while(1){B=B+-4|0;if((h|0)==(B|0))break;C=f[B>>2]|0;D=C;do if(b[C+38>>0]|0){E=f[C+56>>2]|0;if(!E){F=(f[C+20>>2]|0)+80|0;break}else{F=E+40|0;break}}else F=(f[C+48>>2]|0)+20|0;while(0);C=D-(f[F>>2]|0)|0;do if(!s){E=f[y>>2]|0;if(!E){G=z;H=(f[A>>2]|0)+80|0;break}else{G=z;H=E+40|0;break}}else{G=u;H=(f[t>>2]|0)+20|0}while(0);if((C|0)<(G-(f[H>>2]|0)|0)){l=149;break b}}t=h+4|0;u=f[e>>2]|0;z=u;do if(!o){A=f[j+56>>2]|0;if(!A){I=(f[j+20>>2]|0)+80|0;break}else{I=A+40|0;break}}else I=(f[j+48>>2]|0)+20|0;while(0);A=p-(f[I>>2]|0)|0;do if(b[u+38>>0]|0){y=f[u+56>>2]|0;if(!y){J=(f[u+20>>2]|0)+80|0;break}else{J=y+40|0;break}}else J=(f[u+48>>2]|0)+20|0;while(0);if((A|0)<(z-(f[J>>2]|0)|0))K=t;else{if((t|0)==(e|0)){l=207;break a}u=j+20|0;c:do if(o){y=p-(f[(f[j+48>>2]|0)+20>>2]|0)|0;s=t;while(1){k=f[s>>2]|0;do if(b[k+38>>0]|0){q=f[k+56>>2]|0;E=k;if(!q){L=E-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{L=E-(f[q+40>>2]|0)|0;break}}else L=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);if((y|0)<(L|0)){M=s;break c}s=s+4|0;if((s|0)==(e|0)){l=207;break a}}}else{s=f[j+56>>2]|0;y=(s|0)==0;C=s+40|0;s=t;while(1){k=f[s>>2]|0;if(y)N=(f[u>>2]|0)+80|0;else N=C;q=p-(f[N>>2]|0)|0;do if(b[k+38>>0]|0){E=f[k+56>>2]|0;O=k;if(!E){P=O-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{P=O-(f[E+40>>2]|0)|0;break}}else P=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);if((q|0)<(P|0)){M=s;break c}s=s+4|0;if((s|0)==(e|0)){l=207;break a}}}while(0);u=f[M>>2]|0;f[M>>2]=z;f[e>>2]=u;K=M+4|0}if((K|0)==(e|0)){l=207;break a}else{Q=e;R=K}while(1){u=f[h>>2]|0;t=(b[u+38>>0]|0)==0;j=u+48|0;o=u;A=u+56|0;s=u+20|0;if(t){u=o-(f[(f[j>>2]|0)+20>>2]|0)|0;C=R;while(1){y=f[C>>2]|0;do if(b[y+38>>0]|0){k=f[y+56>>2]|0;E=y;if(!k){S=E-(f[(f[y+20>>2]|0)+80>>2]|0)|0;break}else{S=E-(f[k+40>>2]|0)|0;break}}else S=y-(f[(f[y+48>>2]|0)+20>>2]|0)|0;while(0);if((u|0)<(S|0)){T=C;break}else C=C+4|0}}else{C=f[A>>2]|0;u=(C|0)==0;y=C+40|0;C=R;while(1){q=f[C>>2]|0;if(u)U=(f[s>>2]|0)+80|0;else U=y;k=o-(f[U>>2]|0)|0;do if(b[q+38>>0]|0){E=f[q+56>>2]|0;O=q;if(!E){V=O-(f[(f[q+20>>2]|0)+80>>2]|0)|0;break}else{V=O-(f[E+40>>2]|0)|0;break}}else V=q-(f[(f[q+48>>2]|0)+20>>2]|0)|0;while(0);if((k|0)<(V|0)){T=C;break}else C=C+4|0}}if(t){C=o-(f[(f[j>>2]|0)+20>>2]|0)|0;y=Q;while(1){u=y+-4|0;q=f[u>>2]|0;do if(b[q+38>>0]|0){E=f[q+56>>2]|0;O=q;if(!E){W=O-(f[(f[q+20>>2]|0)+80>>2]|0)|0;break}else{W=O-(f[E+40>>2]|0)|0;break}}else W=q-(f[(f[q+48>>2]|0)+20>>2]|0)|0;while(0);if((C|0)<(W|0))y=u;else{X=u;break}}}else{y=f[A>>2]|0;C=(y|0)==0;j=y+40|0;y=Q;while(1){t=y+-4|0;q=f[t>>2]|0;if(C)Y=(f[s>>2]|0)+80|0;else Y=j;k=o-(f[Y>>2]|0)|0;do if(b[q+38>>0]|0){E=f[q+56>>2]|0;O=q;if(!E){Z=O-(f[(f[q+20>>2]|0)+80>>2]|0)|0;break}else{Z=O-(f[E+40>>2]|0)|0;break}}else Z=q-(f[(f[q+48>>2]|0)+20>>2]|0)|0;while(0);if((k|0)<(Z|0))y=t;else{X=t;break}}}if(T>>>0>=X>>>0){h=T;continue b}y=f[T>>2]|0;f[T>>2]=f[X>>2];f[X>>2]=y;Q=X;R=T+4|0}}if((l|0)==149){l=0;f[h>>2]=D;f[B>>2]=p;w=B;x=n+1|0}z=h+4|0;d:do if(z>>>0<w>>>0){y=m;o=w;j=z;s=x;while(1){C=f[y>>2]|0;A=(b[C+38>>0]|0)==0;q=C+48|0;u=C;E=C+56|0;O=C+20|0;if(A){C=u-(f[(f[q>>2]|0)+20>>2]|0)|0;_=j;while(1){$=f[_>>2]|0;do if(b[$+38>>0]|0){aa=f[$+56>>2]|0;ba=$;if(!aa){ca=ba-(f[(f[$+20>>2]|0)+80>>2]|0)|0;break}else{ca=ba-(f[aa+40>>2]|0)|0;break}}else ca=$-(f[(f[$+48>>2]|0)+20>>2]|0)|0;while(0);if((ca|0)<(C|0))_=_+4|0;else{da=_;break}}}else{_=f[E>>2]|0;C=(_|0)==0;$=_+40|0;_=j;while(1){t=f[_>>2]|0;do if(b[t+38>>0]|0){k=f[t+56>>2]|0;aa=t;if(!k){ea=aa-(f[(f[t+20>>2]|0)+80>>2]|0)|0;break}else{ea=aa-(f[k+40>>2]|0)|0;break}}else ea=t-(f[(f[t+48>>2]|0)+20>>2]|0)|0;while(0);if(C)fa=(f[O>>2]|0)+80|0;else fa=$;if((ea|0)<(u-(f[fa>>2]|0)|0))_=_+4|0;else{da=_;break}}}if(A){_=u-(f[(f[q>>2]|0)+20>>2]|0)|0;$=o;while(1){C=$+-4|0;t=f[C>>2]|0;do if(b[t+38>>0]|0){k=f[t+56>>2]|0;aa=t;if(!k){ga=aa-(f[(f[t+20>>2]|0)+80>>2]|0)|0;break}else{ga=aa-(f[k+40>>2]|0)|0;break}}else ga=t-(f[(f[t+48>>2]|0)+20>>2]|0)|0;while(0);if((ga|0)<(_|0)){ha=C;break}else $=C}}else{$=f[E>>2]|0;_=($|0)==0;q=$+40|0;$=o;while(1){A=$+-4|0;t=f[A>>2]|0;do if(b[t+38>>0]|0){k=f[t+56>>2]|0;aa=t;if(!k){ia=aa-(f[(f[t+20>>2]|0)+80>>2]|0)|0;break}else{ia=aa-(f[k+40>>2]|0)|0;break}}else ia=t-(f[(f[t+48>>2]|0)+20>>2]|0)|0;while(0);if(_)ja=(f[O>>2]|0)+80|0;else ja=q;if((ia|0)<(u-(f[ja>>2]|0)|0)){ha=A;break}else $=A}}if(da>>>0>ha>>>0){ka=y;la=s;ma=da;break d}$=f[da>>2]|0;f[da>>2]=f[ha>>2];f[ha>>2]=$;y=(y|0)==(da|0)?ha:y;o=ha;j=da+4|0;s=s+1|0}}else{ka=m;la=x;ma=z}while(0);if((ma|0)!=(ka|0)){z=f[ka>>2]|0;s=f[ma>>2]|0;j=s;o=z;do if(b[z+38>>0]|0){y=f[z+56>>2]|0;if(!y){na=(f[z+20>>2]|0)+80|0;break}else{na=y+40|0;break}}else na=(f[z+48>>2]|0)+20|0;while(0);z=o-(f[na>>2]|0)|0;do if(b[s+38>>0]|0){y=f[s+56>>2]|0;if(!y){oa=(f[s+20>>2]|0)+80|0;break}else{oa=y+40|0;break}}else oa=(f[s+48>>2]|0)+20|0;while(0);if((z|0)<(j-(f[oa>>2]|0)|0)){f[ma>>2]=o;f[ka>>2]=j;pa=la+1|0}else pa=la}else pa=la;if(!pa){qa=uic(h,ma)|0;s=ma+4|0;if(uic(s,a)|0){l=206;break}if(qa){g=s;continue}}s=ma;if((s-i|0)>=(c-s|0)){l=205;break}dic(h,ma);g=ma+4|0}if((l|0)==205){l=0;dic(ma+4|0,a);d=h;a=ma;continue}else if((l|0)==206){l=0;if(qa){l=207;break}else{d=h;a=ma;continue}}}if((l|0)==5){ma=f[e>>2]|0;d=f[h>>2]|0;qa=d;i=ma;do if(b[ma+38>>0]|0){pa=f[ma+56>>2]|0;if(!pa){ra=(f[ma+20>>2]|0)+80|0;break}else{ra=pa+40|0;break}}else ra=(f[ma+48>>2]|0)+20|0;while(0);ma=i-(f[ra>>2]|0)|0;do if(b[d+38>>0]|0){ra=f[d+56>>2]|0;if(!ra){sa=(f[d+20>>2]|0)+80|0;break}else{sa=ra+40|0;break}}else sa=(f[d+48>>2]|0)+20|0;while(0);if((ma|0)>=(qa-(f[sa>>2]|0)|0))return;f[h>>2]=i;f[e>>2]=qa;return}else if((l|0)==17){ric(h,h+4|0,e)|0;return}else if((l|0)==18){sic(h,h+4|0,h+8|0,e)|0;return}else if((l|0)==19){tic(h,h+4|0,h+8|0,h+12|0,e)|0;return}else if((l|0)==21){e=h+8|0;ric(h,h+4|0,e)|0;qa=h+12|0;if((qa|0)==(a|0))return;else{ta=qa;ua=e}while(1){e=f[ta>>2]|0;qa=f[ua>>2]|0;i=(b[e+38>>0]|0)==0;sa=e;do if(!i){ma=f[e+56>>2]|0;if(!ma){va=(f[e+20>>2]|0)+80|0;break}else{va=ma+40|0;break}}else va=(f[e+48>>2]|0)+20|0;while(0);ma=sa-(f[va>>2]|0)|0;do if(b[qa+38>>0]|0){d=f[qa+56>>2]|0;ra=qa;if(!d){wa=ra-(f[(f[qa+20>>2]|0)+80>>2]|0)|0;break}else{wa=ra-(f[d+40>>2]|0)|0;break}}else wa=qa-(f[(f[qa+48>>2]|0)+20>>2]|0)|0;while(0);if((ma|0)<(wa|0)){qa=e+48|0;d=e+56|0;ra=e+20|0;e:do if(i){pa=ua;la=ta;while(1){f[la>>2]=f[pa>>2];if((pa|0)==(h|0)){xa=pa;break e}ka=pa+-4|0;oa=f[ka>>2]|0;na=sa-(f[(f[qa>>2]|0)+20>>2]|0)|0;do if(b[oa+38>>0]|0){x=f[oa+56>>2]|0;m=oa;if(!x){ya=m-(f[(f[oa+20>>2]|0)+80>>2]|0)|0;break}else{ya=m-(f[x+40>>2]|0)|0;break}}else ya=oa-(f[(f[oa+48>>2]|0)+20>>2]|0)|0;while(0);if((na|0)<(ya|0)){oa=pa;pa=ka;la=oa}else{xa=pa;break}}}else{pa=ua;la=ta;while(1){f[la>>2]=f[pa>>2];if((pa|0)==(h|0)){xa=pa;break e}j=pa+-4|0;o=f[j>>2]|0;z=f[d>>2]|0;if(!z)za=(f[ra>>2]|0)+80|0;else za=z+40|0;z=sa-(f[za>>2]|0)|0;do if(b[o+38>>0]|0){oa=f[o+56>>2]|0;x=o;if(!oa){Aa=x-(f[(f[o+20>>2]|0)+80>>2]|0)|0;break}else{Aa=x-(f[oa+40>>2]|0)|0;break}}else Aa=o-(f[(f[o+48>>2]|0)+20>>2]|0)|0;while(0);if((z|0)<(Aa|0)){o=pa;pa=j;la=o}else{xa=pa;break}}}while(0);f[xa>>2]=sa}ra=ta+4|0;if((ra|0)==(a|0))break;else{d=ta;ta=ra;ua=d}}return}else if((l|0)==207)return}function eic(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+32|0;i=h+16|0;j=h;k=e+32|0;if(b[a+6>>0]|0?(f[k>>2]|0)==3:0){l=e+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=e;DTb(m,i)}m=e+28|0;if((f[161216+(f[m>>2]<<2)>>2]|0)!=9){n=f[l>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=e;DTb(n,i)}if((f[161216+(f[m>>2]<<2)>>2]|0)!=10){hic(a,c,d,e,g);u=h;return}}}if((f[k>>2]|0)==3)o=hj[f[(f[d>>2]|0)+24>>2]&511](d,c,e)|0;else o=(hj[f[(f[d>>2]|0)+20>>2]&511](d,c,e)|0)&1;f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;n=e+24|0;l=f[n>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=e;DTb(l,i)}l=e+28|0;if((f[l>>2]|0)==11?BYb(e)|0:0){iic(i,c,o,d,e);p=i+4|0;jic(j,f[i>>2]|0,f[p>>2]|0);q=f[i>>2]|0;if(q|0){r=f[p>>2]|0;if((r|0)!=(q|0))f[p>>2]=r+(~((r+-4-q|0)>>>2)<<2);YDc(q)}s=1}else s=0;if((o|0)>0){q=a+24|0;r=a+32|0;p=a+4|0;t=g+20|0;v=i+4|0;w=i+8|0;x=i+12|0;y=0;do{z=(f[k>>2]|0)==3?y:-1;kic(a,c,d,e,g);A=f[n>>2]|0;if(A|0?(f[A>>2]|0)!=2:0){f[i>>2]=78728;f[v>>2]=1737;b[w>>0]=0;f[x>>2]=e;DTb(A,i)}do if((f[161216+(f[l>>2]<<2)>>2]|0)!=10){Ti[f[(f[g>>2]|0)+8>>2]&511](g,509015,2);lic(a,c,d,e,z,g);A=f[(f[g>>2]|0)+8>>2]|0;if(!(b[p>>0]|0)){Ti[A&511](g,502002,1);break}else{Ti[A&511](g,517879,1);break}}else{A=f[q>>2]|0;B=f[r>>2]|0;if(B){C=r;D=B;a:while(1){B=D;while(1){if((f[B+16>>2]|0)>>>0>=e>>>0)break;E=f[B+4>>2]|0;if(!E){F=C;break a}else B=E}D=f[B>>2]|0;if(!D){F=B;break}else C=B}if((F|0)!=(r|0)?(f[F+16>>2]|0)>>>0<=e>>>0:0)G=f[F+20>>2]|0;else G=A}else G=A;do if((f[k>>2]|0)==3)if(s){H=f[(f[j>>2]|0)+(y<<2)>>2]|0;break}else{H=hh[f[(f[d>>2]|0)+208>>2]&127](d,c,e,y)|0;break}else H=hh[f[(f[d>>2]|0)+108>>2]&127](d,c,e,0)|0;while(0);Fh[f[(f[G>>2]|0)+52>>2]&255](G,H,z,o,(b[p>>0]|0)!=0,g);f[t>>2]=(f[t>>2]|0)+1;bic(a,H,g);gic(g);Fh[f[(f[G>>2]|0)+56>>2]&255](G,H,z,o,(b[p>>0]|0)!=0,g)}while(0);y=y+1|0}while((y|0)<(o|0))}o=f[j>>2]|0;if(o|0){j=f[m>>2]|0;if((j|0)!=(o|0))f[m>>2]=j+(~((j+-4-o|0)>>>2)<<2);YDc(o)}u=h;return}function fic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+112|0;g=e+32|0;h=e+100|0;i=e+88|0;j=e+48|0;k=e+16|0;l=e;m=h+11|0;n=h+4|0;o=g+11|0;p=g+4|0;q=a+4|0;r=k+8|0;s=j+4|0;t=i+11|0;v=i+4|0;w=i+8|0;x=l+8|0;y=j+4|0;z=i+11|0;A=i+4|0;B=i+8|0;C=i+11|0;D=i+4|0;E=d+20|0;F=0;a:while(1){G=f[c>>2]|0;if(!G)H=0;else H=(f[G+4>>2]|0)-(f[G>>2]|0)>>4;if((F|0)>=(H|0)){I=5;break}J=f[G>>2]|0;emc(h,f[J+(F<<4)>>2]|0);b:do switch(f[J+(F<<4)+4>>2]|0){case 0:{G=b[m>>0]|0;K=G<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,K?f[h>>2]|0:h,K?f[n>>2]|0:G&255);Ti[f[(f[d>>2]|0)+8>>2]&511](d,509015,2);G=J+(F<<4)+8|0;hmc(g,f[G>>2]|0,f[G+4>>2]|0);G=b[o>>0]|0;K=G<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,K?f[g>>2]|0:g,K?f[p>>2]|0:G&255);if((b[o>>0]|0)<0)YDc(f[g>>2]|0);G=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[G&511](d,502002,1);break b}else{Ti[G&511](d,517879,1);break b}break}case 1:{G=b[m>>0]|0;K=G<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,K?f[h>>2]|0:h,K?f[n>>2]|0:G&255);Ti[f[(f[d>>2]|0)+8>>2]&511](d,502004,4);G=f[J+(F<<4)+8>>2]|0;f[r>>2]=8;K=k;f[K>>2]=G;f[K+4>>2]=0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];pmc(j,g);K=f[j>>2]|0;G=f[s>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(G>>>0>4294967279){I=13;break a}if(G>>>0<11){b[t>>0]=G;if(!G)L=i;else{M=i;I=17}}else{N=G+16&-16;O=VDc(N)|0;f[i>>2]=O;f[w>>2]=N|-2147483648;f[v>>2]=G;M=O;I=17}if((I|0)==17){I=0;dJc(M|0,K|0,G|0)|0;L=M}b[L+G>>0]=0;G=b[t>>0]|0;K=G<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,K?f[i>>2]|0:i,K?f[v>>2]|0:G&255);if((b[t>>0]|0)<0)YDc(f[i>>2]|0);G=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[G&511](d,502002,1);break b}else{Ti[G&511](d,517879,1);break b}break}case 2:{G=b[m>>0]|0;K=G<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,K?f[h>>2]|0:h,K?f[n>>2]|0:G&255);Ti[f[(f[d>>2]|0)+8>>2]&511](d,502004,4);G=J+(F<<4)+8|0;K=f[G>>2]|0;O=f[G+4>>2]|0;f[x>>2]=16;G=l;f[G>>2]=K;f[G+4>>2]=O;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];pmc(j,g);O=f[j>>2]|0;G=f[y>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(G>>>0>4294967279){I=24;break a}if(G>>>0<11){b[z>>0]=G;if(!G)P=i;else{Q=i;I=28}}else{K=G+16&-16;N=VDc(K)|0;f[i>>2]=N;f[B>>2]=K|-2147483648;f[A>>2]=G;Q=N;I=28}if((I|0)==28){I=0;dJc(Q|0,O|0,G|0)|0;P=Q}b[P+G>>0]=0;G=b[z>>0]|0;O=G<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,O?f[i>>2]|0:i,O?f[A>>2]|0:G&255);if((b[z>>0]|0)<0)YDc(f[i>>2]|0);G=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[G&511](d,502002,1);break b}else{Ti[G&511](d,517879,1);break b}break}case 3:{G=b[m>>0]|0;O=G<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,O?f[h>>2]|0:h,O?f[n>>2]|0:G&255);G=f[J+(F<<4)+8>>2]|0;f[g>>2]=0;O=b[G+11>>0]|0;N=O<<24>>24<0;if(N)R=f[G+4>>2]|0;else R=O&255;do if((R|0)!=0?xjc(g,N?f[G>>2]|0:G,N?f[G+4>>2]|0:O&255)|0:0){K=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[K&511](d,501902,3);f[E>>2]=(f[E>>2]|0)+1}else Ti[K&511](d,501898,3);fic(a,g,d);if(!(b[q>>0]|0)){gic(d);Ti[f[(f[d>>2]|0)+8>>2]&511](d,501845,2);break}else{Ti[f[(f[d>>2]|0)+8>>2]&511](d,501842,2);break}}else I=45;while(0);do if((I|0)==45){I=0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,502009,3);_lc(i,G);O=b[C>>0]|0;N=O<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,N?f[i>>2]|0:i,N?f[D>>2]|0:O&255);if((b[C>>0]|0)<0)YDc(f[i>>2]|0);O=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[O&511](d,502016,2);break}else{Ti[O&511](d,502013,2);break}}while(0);if(f[g>>2]|0)ljc(g);break}case 4:{G=b[m>>0]|0;O=G<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,O?f[h>>2]|0:h,O?f[n>>2]|0:G&255);G=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[G&511](d,501902,3);f[E>>2]=(f[E>>2]|0)+1}else Ti[G&511](d,501898,3);fic(a,f[J+(F<<4)+8>>2]|0,d);if(!(b[q>>0]|0)){gic(d);Ti[f[(f[d>>2]|0)+8>>2]&511](d,501845,2);break b}else{Ti[f[(f[d>>2]|0)+8>>2]&511](d,501842,2);break b}break}default:{}}while(0);if((b[m>>0]|0)<0)YDc(f[h>>2]|0);F=F+1|0}if((I|0)==5){u=e;return}else if((I|0)==13)dEc(i);else if((I|0)==24)dEc(i)}function gic(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;d=b+24|0;e=a+20|0;g=f[e>>2]|0;if(g|0?(g|0)>=(f[a+24>>2]|0):0){f[e>>2]=g+-1;u=b;return}rTb(c,2,502019,1200);oTb(d,mTb(c,502109)|0);sTb(c);u=b;return}function hic(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;kic(a,c,d,e,g);h=hj[f[(f[d>>2]|0)+24>>2]&511](d,c,e)|0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,502261,3);if((h|0)>0){i=0;do{if((i|0)>0)Ti[f[(f[g>>2]|0)+8>>2]&511](g,518069,2);lic(a,c,d,e,i,g);i=i+1|0}while((i|0)!=(h|0))}h=f[(f[g>>2]|0)+8>>2]|0;if(!(b[a+4>>0]|0)){Ti[h&511](g,502265,2);return}else{Ti[h&511](g,508714,2);return}}function iic(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;f[a>>2]=0;m=a+4|0;f[m>>2]=0;f[a+8>>2]=0;if(c|0){if(c>>>0>1073741823)mCc(a);n=VDc(c<<2)|0;f[m>>2]=n;f[a>>2]=n;f[a+8>>2]=n+(c<<2);o=c;c=n;do{f[c>>2]=0;c=(f[m>>2]|0)+4|0;f[m>>2]=c;o=o+-1|0}while((o|0)!=0)}o=xg[f[(f[d>>2]|0)+328>>2]&127](d,b,e,10,-1,0)|0;b=o+12|0;d=f[b>>2]|0;c=f[o+4>>2]|0;if(c|0){o=0;n=(d|0)==0?0:d+4|0;while(1){f[(f[a>>2]|0)+(o<<2)>>2]=f[n>>2];n=n+4|0;d=f[b>>2]|0;if((n|0)==(((d|0)==0?0:d+4|0)+(c<<2)|0))break;else o=o+1|0}}o=(DYb(e)|0)+20|0;e=f[a>>2]|0;a=f[m>>2]|0;f[l>>2]=f[o>>2];o=a-e|0;m=o>>2;if((o|0)>512){o=(m|0)<536870911?m:536870911;while(1){c=WDc(o<<2,1154739)|0;if(c|0){p=c;q=o;break}o=o>>>1;if(!o){p=0;q=0;break}}r=p;s=q;t=p}else{r=0;s=0;t=0}f[j>>2]=e;f[k>>2]=a;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];mic(i,h,l,m,r,s);if(!r){u=g;return}YDc(t);u=g;return}function jic(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)fJc(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);YDc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)mCc(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)mCc(a);j=VDc(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;dJc(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function kic(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(b[a+5>>0]|0){emc(i,f[e+40>>2]|0);j=i+11|0;k=b[j>>0]|0;l=k<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,l?f[i>>2]|0:i,l?f[i+4>>2]|0:k&255);if((b[j>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}i=f[a+24>>2]|0;j=a+32|0;a=f[j>>2]|0;if(a){k=j;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>>>0>=e>>>0)break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(j|0)?(f[n+16>>2]|0)>>>0<=e>>>0:0)o=f[n+20>>2]|0;else o=i}else o=i;gi[f[(f[o>>2]|0)+48>>2]&255](o,c,d,e,g);u=h;return}function lic(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,K=0,L=0;i=u;u=u+64|0;j=i;k=i+40|0;l=i+28|0;m=i+16|0;n=i+4|0;o=f[a+24>>2]|0;p=a+32|0;q=f[p>>2]|0;if(q){r=p;s=q;a:while(1){q=s;while(1){if((f[q+16>>2]|0)>>>0>=e>>>0)break;t=f[q+4>>2]|0;if(!t){v=r;break a}else q=t}s=f[q>>2]|0;if(!s){v=q;break}else r=q}if((v|0)!=(p|0)?(f[v+16>>2]|0)>>>0<=e>>>0:0)w=f[v+20>>2]|0;else w=o}else w=o;o=e+24|0;v=f[o>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[k>>2]=78728;f[k+4>>2]=1737;b[k+8>>0]=0;f[k+12>>2]=e;DTb(v,k)}v=e+28|0;do switch(f[161216+(f[v>>2]<<2)>>2]|0){case 1:{p=f[(f[w>>2]|0)+12>>2]|0;if((f[e+32>>2]|0)==3)x=hh[f[(f[d>>2]|0)+168>>2]&127](d,c,e,g)|0;else x=hj[f[(f[d>>2]|0)+68>>2]&511](d,c,e)|0;Ti[p&511](w,x,h);u=i;return}case 2:{p=f[(f[w>>2]|0)+20>>2]|0;if((f[e+32>>2]|0)==3){r=hh[f[(f[d>>2]|0)+172>>2]&127](d,c,e,g)|0;y=r;z=J}else{r=hj[f[(f[d>>2]|0)+72>>2]&511](d,c,e)|0;y=r;z=J}ei[p&511](w,y,z,h);u=i;return}case 3:{p=f[(f[w>>2]|0)+16>>2]|0;if((f[e+32>>2]|0)==3)A=hh[f[(f[d>>2]|0)+176>>2]&127](d,c,e,g)|0;else A=hj[f[(f[d>>2]|0)+76>>2]&511](d,c,e)|0;Ti[p&511](w,A,h);u=i;return}case 4:{p=f[(f[w>>2]|0)+24>>2]|0;if((f[e+32>>2]|0)==3){r=hh[f[(f[d>>2]|0)+180>>2]&127](d,c,e,g)|0;B=r;C=J}else{r=hj[f[(f[d>>2]|0)+80>>2]&511](d,c,e)|0;B=r;C=J}ei[p&511](w,B,C,h);u=i;return}case 6:{p=f[(f[w>>2]|0)+28>>2]|0;if((f[e+32>>2]|0)==3)D=+Ai[f[(f[d>>2]|0)+184>>2]&15](d,c,e,g);else D=+Sh[f[(f[d>>2]|0)+84>>2]&31](d,c,e);Hg[p&7](w,D,h);u=i;return}case 5:{p=f[(f[w>>2]|0)+32>>2]|0;if((f[e+32>>2]|0)==3)E=+Ai[f[(f[d>>2]|0)+188>>2]&15](d,c,e,g);else E=+Sh[f[(f[d>>2]|0)+88>>2]&31](d,c,e);Hg[p&7](w,E,h);u=i;return}case 7:{p=f[(f[w>>2]|0)+8>>2]|0;if((f[e+32>>2]|0)==3)F=hh[f[(f[d>>2]|0)+192>>2]&127](d,c,e,g)|0;else F=hj[f[(f[d>>2]|0)+92>>2]&511](d,c,e)|0;Ti[p&511](w,F,h);u=i;return}case 9:{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if((f[e+32>>2]|0)==3)G=_h[f[(f[d>>2]|0)+212>>2]&127](d,c,e,g,l)|0;else G=hh[f[(f[d>>2]|0)+112>>2]&127](d,c,e,l)|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=a+16|0;r=f[p>>2]|0;s=f[p+4>>2]|0;if((s|0)>0|(s|0)==0&r>>>0>0){p=b[G+11>>0]|0;if(p<<24>>24<0)H=f[G+4>>2]|0;else H=p&255;if((s|0)<0|(s|0)==0&r>>>0<H>>>0){gEc(n,G,0,r,G);jIa(k,n,502147);iEc(m,k)|0;if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);I=m}else I=G}else I=G;r=f[o>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[k>>2]=78728;f[k+4>>2]=1737;b[k+8>>0]=0;f[k+12>>2]=e;DTb(r,k)}r=f[w>>2]|0;if((f[v>>2]|0)==9)Ti[f[r+36>>2]&511](w,I,h);else Ti[f[r+40>>2]&511](w,I,h);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);u=i;return}case 8:{if((f[e+32>>2]|0)==3)K=hh[f[(f[d>>2]|0)+204>>2]&127](d,c,e,g)|0;else K=hj[f[(f[d>>2]|0)+104>>2]&511](d,c,e)|0;r=wYb(EYb(e)|0,K)|0;s=f[(f[w>>2]|0)+44>>2]|0;if(r|0){ei[s&511](w,K,f[r>>2]|0,h);u=i;return}f[j>>2]=K;Rlc(k,502165,j);ei[s&511](w,K,k,h);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);u=i;return}case 10:{if((f[e+32>>2]|0)==3)L=hh[f[(f[d>>2]|0)+208>>2]&127](d,c,e,g)|0;else L=hh[f[(f[d>>2]|0)+108>>2]&127](d,c,e,0)|0;bic(a,L,h);u=i;return}default:{u=i;return}}while(0)}function mic(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=u;u=u+64|0;i=h+52|0;j=h+48|0;k=h+44|0;l=h+40|0;m=h+36|0;n=h+32|0;o=h+28|0;p=h+24|0;q=h+20|0;r=h+16|0;s=h+12|0;t=h+8|0;v=h+4|0;w=h;switch(d|0){case 2:{x=(f[b>>2]|0)+-4|0;f[b>>2]=x;y=f[a>>2]|0;if(!(nic(c,f[x>>2]|0,f[y>>2]|0)|0)){u=h;return}z=f[y>>2]|0;f[y>>2]=f[x>>2];f[x>>2]=z;u=h;return}case 1:case 0:{u=h;return}default:{if((d|0)<129){z=f[a>>2]|0;x=f[b>>2]|0;if((z|0)==(x|0)){u=h;return}y=z+4|0;if((y|0)==(x|0)){u=h;return}else A=y;do{y=A;B=f[A>>2]|0;a:do if((A|0)==(z|0))C=y;else{D=B;E=y;F=A;while(1){F=F+-4|0;if(!(nic(c,D,f[F>>2]|0)|0)){C=E;break a}f[E>>2]=f[F>>2];G=E+-4|0;if((F|0)==(z|0)){C=G;break}else E=G}}while(0);f[C>>2]=B;A=A+4|0}while((A|0)!=(x|0));u=h;return}x=d>>>1;A=f[a>>2]|0;a=A+(x<<2)|0;C=A;if((d|0)>(g|0)){f[p>>2]=C;f[q>>2]=a;f[j>>2]=f[p>>2];f[i>>2]=f[q>>2];mic(j,i,c,x,e,g);f[r>>2]=a;q=f[b>>2]|0;f[s>>2]=q;p=d-x|0;f[j>>2]=f[r>>2];f[i>>2]=f[s>>2];mic(j,i,c,p,e,g);f[t>>2]=C;f[v>>2]=a;f[w>>2]=q;f[k>>2]=f[t>>2];f[j>>2]=f[v>>2];f[i>>2]=f[w>>2];pic(k,j,i,c,x,p,e,g);u=h;return}f[l>>2]=C;f[m>>2]=a;f[j>>2]=f[l>>2];f[i>>2]=f[m>>2];oic(j,i,c,x,e);f[n>>2]=a;f[o>>2]=f[b>>2];b=e+(x<<2)|0;f[j>>2]=f[n>>2];f[i>>2]=f[o>>2];oic(j,i,c,d-x|0,b);x=e+(d<<2)|0;d=b;i=e;e=C;while(1){if((d|0)==(x|0))break;if(nic(c,f[d>>2]|0,f[i>>2]|0)|0){C=e;f[C>>2]=f[d>>2];H=d+4|0;I=i;J=C}else{C=e;f[C>>2]=f[i>>2];H=d;I=i+4|0;J=C}K=J+4|0;if((I|0)==(b|0)){L=14;break}else{d=H;i=I;e=K}}if((L|0)==14){if((H|0)==(x|0)){u=h;return}else{M=H;N=K}while(1){f[N>>2]=f[M>>2];M=M+4|0;if((M|0)==(x|0))break;else N=N+4|0}u=h;return}if((i|0)==(b|0)){u=h;return}N=i;i=e;while(1){f[i>>2]=f[N>>2];N=N+4|0;if((N|0)==(b|0))break;else i=i+4|0}u=h;return}}}function nic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+64|0;g=e+40|0;h=e;i=e+16|0;j=e+56|0;k=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;l=f[a>>2]|0;m=f[l+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=l;DTb(m,g)}switch(f[161216+(f[l+28>>2]<<2)>>2]|0){case 7:{l=hj[f[(f[k>>2]|0)+92>>2]&511](k,c,f[a>>2]|0)|0;n=(hj[f[(f[k>>2]|0)+92>>2]&511](k,d,f[a>>2]|0)|0)&(l^1);u=e;return n|0}case 1:{n=(hj[f[(f[k>>2]|0)+68>>2]&511](k,c,f[a>>2]|0)|0)<(hj[f[(f[k>>2]|0)+68>>2]&511](k,d,f[a>>2]|0)|0);u=e;return n|0}case 2:{l=hj[f[(f[k>>2]|0)+72>>2]&511](k,c,f[a>>2]|0)|0;m=J;o=hj[f[(f[k>>2]|0)+72>>2]&511](k,d,f[a>>2]|0)|0;p=J;n=(m|0)<(p|0)|(m|0)==(p|0)&l>>>0<o>>>0;u=e;return n|0}case 3:{n=(hj[f[(f[k>>2]|0)+76>>2]&511](k,c,f[a>>2]|0)|0)>>>0<(hj[f[(f[k>>2]|0)+76>>2]&511](k,d,f[a>>2]|0)|0)>>>0;u=e;return n|0}case 4:{o=hj[f[(f[k>>2]|0)+80>>2]&511](k,c,f[a>>2]|0)|0;l=J;p=hj[f[(f[k>>2]|0)+80>>2]&511](k,d,f[a>>2]|0)|0;m=J;n=l>>>0<m>>>0|(l|0)==(m|0)&o>>>0<p>>>0;u=e;return n|0}case 9:{ei[f[(f[k>>2]|0)+96>>2]&511](g,k,c,f[a>>2]|0);ei[f[(f[k>>2]|0)+96>>2]&511](h,k,d,f[a>>2]|0);a=b[h+11>>0]|0;d=a<<24>>24<0;k=d?f[h+4>>2]|0:a&255;a=g+11|0;c=b[a>>0]|0;p=c<<24>>24<0;o=p?f[g+4>>2]|0:c&255;m=k>>>0<o>>>0;l=m?k:o;if((l|0)!=0?(q=Arc(p?f[g>>2]|0:g,d?f[h>>2]|0:h,l)|0,(q|0)!=0):0)r=q;else r=o>>>0<k>>>0?-1:m&1;if(d){YDc(f[h>>2]|0);s=b[a>>0]|0}else s=c;if(s<<24>>24<0)YDc(f[g>>2]|0);n=(r|0)<0;u=e;return n|0}default:{rTb(i,2,502168,223);oTb(j,mTb(i,503950)|0);sTb(i);n=1;u=e;return n|0}}return 0}function oic(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+32|0;h=g+8|0;i=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;switch(d|0){case 1:{f[e>>2]=f[f[a>>2]>>2];u=g;return}case 2:{n=(f[b>>2]|0)+-4|0;f[b>>2]=n;o=nic(c,f[n>>2]|0,f[f[a>>2]>>2]|0)|0;f[e>>2]=f[f[(o?b:a)>>2]>>2];f[e+4>>2]=f[f[(o?a:b)>>2]>>2];u=g;return}case 0:{u=g;return}default:{if((d|0)>=9){o=d>>>1;n=f[a>>2]|0;p=n+(o<<2)|0;q=n;f[j>>2]=q;f[k>>2]=p;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];mic(i,h,c,o,e,o);f[l>>2]=p;k=f[b>>2]|0;f[m>>2]=k;j=d-o|0;f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];mic(i,h,c,j,e+(o<<2)|0,j);f[h>>2]=p;f[i>>2]=q;q=k;a:do if(o){if((p|0)==(q|0)){r=e;s=n}else{k=e;j=p;m=n;while(1){l=nic(c,f[j>>2]|0,f[m>>2]|0)|0;d=l?h:i;l=f[d>>2]|0;f[k>>2]=f[l>>2];f[d>>2]=l+4;l=k+4|0;d=f[i>>2]|0;j=f[h>>2]|0;if((d|0)==(p|0)){t=l;v=j;w=16;break a}if((j|0)==(q|0)){r=l;s=d;break}else{k=l;m=d}}}if((s|0)!=(p|0)){m=r;k=s;while(1){f[m>>2]=f[k>>2];k=(f[i>>2]|0)+4|0;f[i>>2]=k;if((k|0)==(p|0))break;else m=m+4|0}}}else{t=e;v=n;w=16}while(0);if((w|0)==16?(v|0)!=(q|0):0){w=t;t=v;while(1){f[w>>2]=f[t>>2];t=(f[h>>2]|0)+4|0;f[h>>2]=t;if((t|0)==(q|0))break;else w=w+4|0}}u=g;return}w=f[a>>2]|0;a=f[b>>2]|0;if((w|0)==(a|0)){u=g;return}b=f[w>>2]|0;f[e>>2]=b;q=w+4|0;if((q|0)==(a|0)){u=g;return}w=e;t=q;q=b;while(1){b=w+4|0;b:do if(nic(c,f[t>>2]|0,q)|0){f[b>>2]=f[w>>2];if((w|0)==(e|0))x=e;else{h=w;while(1){v=h;h=h+-4|0;if(!(nic(c,f[t>>2]|0,f[h>>2]|0)|0)){x=v;break b}f[v>>2]=f[h>>2];if((h|0)==(e|0)){x=e;break}}}}else x=b;while(0);f[x>>2]=f[t>>2];h=t+4|0;if((h|0)==(a|0))break;w=b;t=h;q=f[b>>2]|0}u=g;return}}}function pic(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;j=u;u=u+64|0;k=j+52|0;l=j+48|0;m=j+44|0;n=j+40|0;o=j+36|0;p=j+32|0;q=j+20|0;r=j+12|0;s=j+28|0;t=j+24|0;v=j+16|0;w=j+8|0;x=j+4|0;y=j;if(!g){u=j;return}z=e;e=g;a:while(1){if(!((e|0)>(i|0)&(z|0)>(i|0))){A=6;break}if(!z){A=42;break}B=f[b>>2]|0;g=B;C=z;D=f[a>>2]|0;while(1){if(nic(d,f[B>>2]|0,f[D>>2]|0)|0)break;E=D+4|0;f[a>>2]=E;F=C+-1|0;if(!F){A=42;break a}else{C=F;D=E}}E=D;if((C|0)<(e|0)){F=(e|0)/2|0;G=B+(F<<2)|0;H=G;f[r>>2]=H;I=g-E>>2;if(!I)J=D;else{K=I;I=D;L=D;while(1){M=(K|0)/2|0;N=L+(M<<2)|0;O=nic(d,f[G>>2]|0,f[N>>2]|0)|0;P=N+4|0;N=O?I:P;K=O?M:K+-1-M|0;if(!K){J=N;break}else{I=N;L=O?L:P}}}L=J;f[q>>2]=L;Q=L-E>>2;R=F;S=H;T=L}else{if((C|0)==1){A=14;break}L=(C|0)/2|0;I=D+(L<<2)|0;K=I;f[q>>2]=K;G=(f[c>>2]|0)-g>>2;if(!G)U=B;else{P=G;G=B;O=B;while(1){N=(P|0)/2|0;M=O+(N<<2)|0;V=nic(d,f[M>>2]|0,f[I>>2]|0)|0;W=M+4|0;M=V?W:G;P=V?P+-1-N|0:N;if(!P){U=M;break}else{G=M;O=V?W:O}}}O=U;f[r>>2]=O;Q=L;R=O-g>>2;S=O;T=K}O=C-Q|0;G=e-R|0;P=T;I=S;b:do if((P|0)!=(B|0))if((B|0)==(I|0))X=P;else{if((P+4|0)==(B|0)){H=f[T>>2]|0;F=S-g|0;E=F>>2;if(E|0)fJc(T|0,B|0,F|0)|0;F=P+(E<<2)|0;f[F>>2]=H;X=F;break}if((B+4|0)==(I|0)){F=f[B>>2]|0;H=g-T|0;E=H>>2;W=I+(0-E<<2)|0;if(!E)Y=I;else{fJc(W|0,T|0,H|0)|0;Y=W}f[T>>2]=F;X=Y;break}F=g-T>>2;W=S-g>>2;if((F|0)==(W|0)){H=P;E=B;while(1){V=f[H>>2]|0;f[H>>2]=f[E>>2];f[E>>2]=V;H=H+4|0;if((H|0)==(B|0)){X=B;break b}else E=E+4|0}}else{Z=F;_=W}while(1){E=(Z|0)%(_|0)|0;if(!E)break;else{H=_;_=E;Z=H}}if(!_)$=P;else{H=(_<<2)+-4|0;E=P+(_<<2)|0;do{E=E+-4|0;V=f[E>>2]|0;M=E+(F<<2)|0;N=E;while(1){f[N>>2]=f[M>>2];N=M;aa=S-N>>2;ba=(F|0)<(aa|0)?M+(F<<2)|0:P+(F-aa<<2)|0;if((ba|0)==(E|0))break;else M=ba}f[M>>2]=V}while((E|0)!=(P|0));$=P+(_+-1-(H>>>2)<<2)|0}X=$+(W<<2)|0}else X=I;while(0);f[b>>2]=X;I=X;if((Q+R|0)<(O+G|0)){f[s>>2]=f[a>>2];f[t>>2]=f[q>>2];f[v>>2]=I;f[m>>2]=f[s>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];pic(m,l,k,d,Q,R,h,i);ca=G;da=O;ea=r;fa=a}else{f[w>>2]=I;f[x>>2]=f[r>>2];f[y>>2]=f[c>>2];f[m>>2]=f[w>>2];f[l>>2]=f[x>>2];f[k>>2]=f[y>>2];pic(m,l,k,d,O,G,h,i);ca=R;da=Q;ea=q;fa=c}f[fa>>2]=I;f[b>>2]=f[ea>>2];if(!ca){A=42;break}else{z=da;e=ca}}if((A|0)==6){f[n>>2]=f[a>>2];f[o>>2]=f[b>>2];f[p>>2]=f[c>>2];f[m>>2]=f[n>>2];f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];qic(m,l,k,d,z,e,h);u=j;return}else if((A|0)==14){h=f[D>>2]|0;f[D>>2]=f[B>>2];f[B>>2]=h;u=j;return}else if((A|0)==42){u=j;return}}function qic(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+16|0;j=i;k=i+4|0;if((e|0)>(g|0)){g=f[b>>2]|0;e=g;l=f[c>>2]|0;if((e|0)==(l|0)){m=h;n=l;o=g}else{l=h;p=g;g=e;while(1){f[l>>2]=f[p>>2];e=g+4|0;q=l+4|0;r=f[c>>2]|0;if((e|0)==(r|0))break;else{l=q;p=e;g=e}}m=q;n=r;o=f[b>>2]|0}r=f[a>>2]|0;f[j>>2]=o;f[k>>2]=m;a:do if((m|0)!=(h|0)){q=o;if((q|0)==(r|0)){s=m;t=n}else{g=q;q=m;p=n;while(1){l=nic(d,f[g+-4>>2]|0,f[q+-4>>2]|0)|0;e=l?k:j;l=(f[e>>2]|0)+-4|0;v=p+-4|0;f[v>>2]=f[l>>2];f[e>>2]=l;l=f[k>>2]|0;if((l|0)==(h|0))break a;g=f[j>>2]|0;if((g|0)==(r|0)){s=l;t=v;break}else{q=l;p=v}}}if((s|0)!=(h|0)){p=s;q=t;do{p=p+-4|0;q=q+-4|0;f[q>>2]=f[p>>2]}while((p|0)!=(h|0))}}while(0);u=i;return}t=f[a>>2]|0;s=t;if((s|0)==(f[b>>2]|0)){w=h;x=t;y=s}else{r=h;k=t;t=s;while(1){f[r>>2]=f[k>>2];z=t+4|0;A=r+4|0;if((z|0)==(f[b>>2]|0))break;else{r=A;k=z;t=z}}w=A;x=f[a>>2]|0;y=z}z=f[c>>2]|0;f[j>>2]=f[d>>2];b:do if((w|0)!=(h|0)){d=h;c=x;a=y;A=y;while(1){if((a|0)==(z|0))break;if(nic(j,f[a>>2]|0,f[d>>2]|0)|0){t=c;f[t>>2]=f[A>>2];k=A+4|0;B=d;C=t;D=k;E=k}else{k=c;f[k>>2]=f[d>>2];B=d+4|0;C=k;D=A;E=a}if((B|0)==(w|0))break b;else{d=B;c=C+4|0;a=E;A=D}}A=w-d|0;if(A|0)fJc(c|0,d|0,A|0)|0}while(0);u=i;return}function ric(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[c>>2]|0;g=f[a>>2]|0;h=(b[e+38>>0]|0)==0;i=e;j=g;do if(!h){k=f[e+56>>2]|0;if(!k){l=(f[e+20>>2]|0)+80|0;break}else{l=k+40|0;break}}else l=(f[e+48>>2]|0)+20|0;while(0);k=i-(f[l>>2]|0)|0;l=(b[g+38>>0]|0)==0;do if(!l){m=f[g+56>>2]|0;if(!m){n=(f[g+20>>2]|0)+80|0;break}else{n=m+40|0;break}}else n=(f[g+48>>2]|0)+20|0;while(0);m=(k|0)<(j-(f[n>>2]|0)|0);n=f[d>>2]|0;k=n;do if(b[n+38>>0]|0){o=f[n+56>>2]|0;if(!o){p=(f[n+20>>2]|0)+80|0;break}else{p=o+40|0;break}}else p=(f[n+48>>2]|0)+20|0;while(0);n=k-(f[p>>2]|0)|0;do if(!h){p=f[e+56>>2]|0;if(!p){q=(f[e+20>>2]|0)+80|0;break}else{q=p+40|0;break}}else q=(f[e+48>>2]|0)+20|0;while(0);e=(n|0)<(i-(f[q>>2]|0)|0);if(!m){if(!e){r=0;return r|0}f[c>>2]=k;f[d>>2]=i;m=f[c>>2]|0;q=f[a>>2]|0;n=q;h=m;do if(b[m+38>>0]|0){p=f[m+56>>2]|0;if(!p){s=(f[m+20>>2]|0)+80|0;break}else{s=p+40|0;break}}else s=(f[m+48>>2]|0)+20|0;while(0);m=h-(f[s>>2]|0)|0;do if(b[q+38>>0]|0){s=f[q+56>>2]|0;if(!s){t=(f[q+20>>2]|0)+80|0;break}else{t=s+40|0;break}}else t=(f[q+48>>2]|0)+20|0;while(0);if((m|0)>=(n-(f[t>>2]|0)|0)){r=1;return r|0}f[a>>2]=h;f[c>>2]=n;r=2;return r|0}if(e){f[a>>2]=k;f[d>>2]=j;r=1;return r|0}f[a>>2]=i;f[c>>2]=j;i=f[d>>2]|0;a=i;do if(b[i+38>>0]|0){k=f[i+56>>2]|0;if(!k){u=(f[i+20>>2]|0)+80|0;break}else{u=k+40|0;break}}else u=(f[i+48>>2]|0)+20|0;while(0);i=a-(f[u>>2]|0)|0;do if(!l){u=f[g+56>>2]|0;if(!u){v=(f[g+20>>2]|0)+80|0;break}else{v=u+40|0;break}}else v=(f[g+48>>2]|0)+20|0;while(0);if((i|0)>=(j-(f[v>>2]|0)|0)){r=1;return r|0}f[c>>2]=a;f[d>>2]=j;r=2;return r|0}function sic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=ric(a,c,d)|0;h=f[e>>2]|0;i=f[d>>2]|0;j=i;k=h;do if(b[h+38>>0]|0){l=f[h+56>>2]|0;if(!l){m=(f[h+20>>2]|0)+80|0;break}else{m=l+40|0;break}}else m=(f[h+48>>2]|0)+20|0;while(0);h=k-(f[m>>2]|0)|0;do if(b[i+38>>0]|0){m=f[i+56>>2]|0;if(!m){n=(f[i+20>>2]|0)+80|0;break}else{n=m+40|0;break}}else n=(f[i+48>>2]|0)+20|0;while(0);if((h|0)>=(j-(f[n>>2]|0)|0)){o=g;return o|0}f[d>>2]=k;f[e>>2]=j;j=g+1|0;e=f[d>>2]|0;k=f[c>>2]|0;n=k;h=e;do if(b[e+38>>0]|0){i=f[e+56>>2]|0;if(!i){p=(f[e+20>>2]|0)+80|0;break}else{p=i+40|0;break}}else p=(f[e+48>>2]|0)+20|0;while(0);e=h-(f[p>>2]|0)|0;do if(b[k+38>>0]|0){p=f[k+56>>2]|0;if(!p){q=(f[k+20>>2]|0)+80|0;break}else{q=p+40|0;break}}else q=(f[k+48>>2]|0)+20|0;while(0);if((e|0)>=(n-(f[q>>2]|0)|0)){o=j;return o|0}f[c>>2]=h;f[d>>2]=n;n=g+2|0;d=f[c>>2]|0;h=f[a>>2]|0;j=h;q=d;do if(b[d+38>>0]|0){e=f[d+56>>2]|0;if(!e){r=(f[d+20>>2]|0)+80|0;break}else{r=e+40|0;break}}else r=(f[d+48>>2]|0)+20|0;while(0);d=q-(f[r>>2]|0)|0;do if(b[h+38>>0]|0){r=f[h+56>>2]|0;if(!r){s=(f[h+20>>2]|0)+80|0;break}else{s=r+40|0;break}}else s=(f[h+48>>2]|0)+20|0;while(0);if((d|0)>=(j-(f[s>>2]|0)|0)){o=n;return o|0}f[a>>2]=q;f[c>>2]=j;o=g+3|0;return o|0}function tic(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=sic(a,c,d,e)|0;i=f[g>>2]|0;j=f[e>>2]|0;k=j;l=i;do if(b[i+38>>0]|0){m=f[i+56>>2]|0;if(!m){n=(f[i+20>>2]|0)+80|0;break}else{n=m+40|0;break}}else n=(f[i+48>>2]|0)+20|0;while(0);i=l-(f[n>>2]|0)|0;do if(b[j+38>>0]|0){n=f[j+56>>2]|0;if(!n){o=(f[j+20>>2]|0)+80|0;break}else{o=n+40|0;break}}else o=(f[j+48>>2]|0)+20|0;while(0);if((i|0)>=(k-(f[o>>2]|0)|0)){p=h;return p|0}f[e>>2]=l;f[g>>2]=k;k=h+1|0;g=f[e>>2]|0;l=f[d>>2]|0;o=l;i=g;do if(b[g+38>>0]|0){j=f[g+56>>2]|0;if(!j){q=(f[g+20>>2]|0)+80|0;break}else{q=j+40|0;break}}else q=(f[g+48>>2]|0)+20|0;while(0);g=i-(f[q>>2]|0)|0;do if(b[l+38>>0]|0){q=f[l+56>>2]|0;if(!q){r=(f[l+20>>2]|0)+80|0;break}else{r=q+40|0;break}}else r=(f[l+48>>2]|0)+20|0;while(0);if((g|0)>=(o-(f[r>>2]|0)|0)){p=k;return p|0}f[d>>2]=i;f[e>>2]=o;o=h+2|0;e=f[d>>2]|0;i=f[c>>2]|0;k=i;r=e;do if(b[e+38>>0]|0){g=f[e+56>>2]|0;if(!g){s=(f[e+20>>2]|0)+80|0;break}else{s=g+40|0;break}}else s=(f[e+48>>2]|0)+20|0;while(0);e=r-(f[s>>2]|0)|0;do if(b[i+38>>0]|0){s=f[i+56>>2]|0;if(!s){t=(f[i+20>>2]|0)+80|0;break}else{t=s+40|0;break}}else t=(f[i+48>>2]|0)+20|0;while(0);if((e|0)>=(k-(f[t>>2]|0)|0)){p=o;return p|0}f[c>>2]=r;f[d>>2]=k;k=h+3|0;d=f[c>>2]|0;r=f[a>>2]|0;o=r;t=d;do if(b[d+38>>0]|0){e=f[d+56>>2]|0;if(!e){u=(f[d+20>>2]|0)+80|0;break}else{u=e+40|0;break}}else u=(f[d+48>>2]|0)+20|0;while(0);d=t-(f[u>>2]|0)|0;do if(b[r+38>>0]|0){u=f[r+56>>2]|0;if(!u){v=(f[r+20>>2]|0)+80|0;break}else{v=u+40|0;break}}else v=(f[r+48>>2]|0)+20|0;while(0);if((d|0)>=(o-(f[v>>2]|0)|0)){p=k;return p|0}f[a>>2]=t;f[c>>2]=o;p=h+4|0;return p|0}function uic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;switch(c-a>>2|0){case 2:{d=c+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;i=e;do if(b[e+38>>0]|0){j=f[e+56>>2]|0;if(!j){k=(f[e+20>>2]|0)+80|0;break}else{k=j+40|0;break}}else k=(f[e+48>>2]|0)+20|0;while(0);e=i-(f[k>>2]|0)|0;do if(b[g+38>>0]|0){k=f[g+56>>2]|0;if(!k){l=(f[g+20>>2]|0)+80|0;break}else{l=k+40|0;break}}else l=(f[g+48>>2]|0)+20|0;while(0);if((e|0)>=(h-(f[l>>2]|0)|0)){m=1;return m|0}f[a>>2]=i;f[d>>2]=h;m=1;return m|0}case 3:{ric(a,a+4|0,c+-4|0)|0;m=1;return m|0}case 4:{sic(a,a+4|0,a+8|0,c+-4|0)|0;m=1;return m|0}case 5:{tic(a,a+4|0,a+8|0,a+12|0,c+-4|0)|0;m=1;return m|0}case 1:case 0:{m=1;return m|0}default:{h=a+8|0;ric(a,a+4|0,h)|0;d=a+12|0;a:do if((d|0)==(c|0)){n=1;o=0}else{i=d;l=0;e=h;while(1){g=f[i>>2]|0;k=f[e>>2]|0;j=(b[g+38>>0]|0)==0;p=g;do if(!j){q=f[g+56>>2]|0;if(!q){r=(f[g+20>>2]|0)+80|0;break}else{r=q+40|0;break}}else r=(f[g+48>>2]|0)+20|0;while(0);q=p-(f[r>>2]|0)|0;do if(b[k+38>>0]|0){s=f[k+56>>2]|0;t=k;if(!s){u=t-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{u=t-(f[s+40>>2]|0)|0;break}}else u=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);if((q|0)<(u|0)){k=g+48|0;s=g+56|0;t=g+20|0;v=e;w=i;while(1){f[w>>2]=f[v>>2];if((v|0)==(a|0))break;x=v+-4|0;y=f[x>>2]|0;do if(!j){z=f[s>>2]|0;if(!z){A=(f[t>>2]|0)+80|0;break}else{A=z+40|0;break}}else A=(f[k>>2]|0)+20|0;while(0);z=p-(f[A>>2]|0)|0;do if(b[y+38>>0]|0){B=f[y+56>>2]|0;C=y;if(!B){D=C-(f[(f[y+20>>2]|0)+80>>2]|0)|0;break}else{D=C-(f[B+40>>2]|0)|0;break}}else D=y-(f[(f[y+48>>2]|0)+20>>2]|0)|0;while(0);if((z|0)<(D|0)){y=v;v=x;w=y}else break}f[v>>2]=p;w=l+1|0;if((w|0)==8){n=0;o=(i+4|0)==(c|0);break a}else E=w}else E=l;w=i+4|0;if((w|0)==(c|0)){n=1;o=0;break}else{k=i;i=w;l=E;e=k}}}while(0);m=o|n;return m|0}}return 0}function vic(a){a=a|0;var c=0,d=0;f[a>>2]=168288;if(b[a+17>>0]|0)return;c=f[a+12>>2]|0;if((c|0)<=0)return;d=f[a+4>>2]|0;mi[f[(f[d>>2]|0)+12>>2]&2047](d,c);return}function wic(a){a=a|0;var c=0,d=0;f[a>>2]=168288;if(b[a+17>>0]|0){YDc(a);return}c=f[a+12>>2]|0;if((c|0)<=0){YDc(a);return}d=f[a+4>>2]|0;mi[f[(f[d>>2]|0)+12>>2]&2047](d,c);YDc(a);return}function xic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;if((f[a+20>>2]|0)<=0){yic(a,c,d);if(!d)return;if((b[c+(d+-1)>>0]|0)!=10)return;b[a+16>>0]=1;return}if(!d)e=0;else{g=a+16|0;h=0;i=0;while(1){j=i;i=i+1|0;if((b[c+j>>0]|0)==10){yic(a,c+h|0,1-h+j|0);b[g>>0]=1;k=i}else k=h;if((i|0)==(d|0)){e=k;break}else h=k}}yic(a,c+e|0,d-e|0);return}function yic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e;h=a+17|0;if((d|0)==0|(b[h>>0]|0)!=0){u=e;return}i=a+16|0;if(b[i>>0]|0?(b[i>>0]=0,i=f[a+20>>2]|0,i|0):0){j=i<<1;i=a+12|0;k=f[i>>2]|0;l=a+8|0;m=f[l>>2]|0;a:do if((j|0)>(k|0)){n=a+4|0;o=j;p=m;q=k;while(1){XIc(p|0,32,q|0)|0;r=f[i>>2]|0;s=f[n>>2]|0;t=hj[f[(f[s>>2]|0)+8>>2]&511](s,g,i)|0;v=(t^1)&1;b[h>>0]=v;if(!t)break;t=o-r|0;r=f[g>>2]|0;f[l>>2]=r;q=f[i>>2]|0;s=r;if((t|0)<=(q|0)){w=t;x=s;y=9;break a}else{o=t;p=s}}z=v}else{w=j;x=m;y=9}while(0);if((y|0)==9){XIc(x|0,32,w|0)|0;f[l>>2]=(f[l>>2]|0)+w;f[i>>2]=(f[i>>2]|0)-w;z=b[h>>0]|0}if(z<<24>>24){u=e;return}}z=a+12|0;w=f[z>>2]|0;i=a+8|0;do if(w>>>0<d>>>0){l=a+4|0;x=d;m=c;j=w;while(1){if((j|0)>0){dJc(f[i>>2]|0,m|0,j|0)|0;v=f[z>>2]|0;A=x-v|0;B=m+v|0}else{A=x;B=m}f[g>>2]=0;v=f[l>>2]|0;k=hj[f[(f[v>>2]|0)+8>>2]&511](v,g,z)|0;b[h>>0]=(k^1)&1;if(!k)break;C=f[g>>2]|0;f[i>>2]=C;j=f[z>>2]|0;if(A>>>0<=j>>>0){y=19;break}else{x=A;m=B}}if((y|0)==19){D=A;E=B;F=C;break}u=e;return}else{D=d;E=c;F=f[i>>2]|0}while(0);dJc(F|0,E|0,D|0)|0;f[i>>2]=(f[i>>2]|0)+D;f[z>>2]=(f[z>>2]|0)-D;u=e;return}function zic(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=b;e=a+4|0;g=f[e>>2]|0;do if(g){h=a+4|0;i=g;j=g;while(1){k=f[i+16>>2]|0;if(k>>>0>b>>>0){l=f[i>>2]|0;if(!l){m=6;break}else{n=i;o=l}}else{if(k>>>0>=b>>>0){m=10;break}p=i+4|0;k=f[p>>2]|0;if(!k){m=9;break}else{n=p;o=k}}h=n;i=o;j=o}if((m|0)==6){q=i;r=i;m=13;break}else if((m|0)==9){q=p;r=i;m=13;break}else if((m|0)==10){s=h;t=i;u=j;m=12;break}}else{s=e;t=e;u=g;m=12}while(0);if((m|0)==12)if(!u){q=s;r=t;m=13}else v=u;if((m|0)==13){m=VDc(32)|0;f[m+16>>2]=d;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=r;f[q>>2]=m;r=f[f[a>>2]>>2]|0;if(!r)w=m;else{f[a>>2]=r;w=f[q>>2]|0}laa(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;v=m}m=v+24|0;w=f[m>>2]|0;if((w|0)==(f[v+28>>2]|0)){Aic(v+20|0,c);return}else{v=c;c=f[v+4>>2]|0;a=w;f[a>>2]=f[v>>2];f[a+4>>2]=c;f[m>>2]=(f[m>>2]|0)+8;return}}function Aic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function Bic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+16|0;d=c;e=b;g=VDc(24)|0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;f[g>>2]=h;h=g+16|0;f[h>>2]=0;f[g+20>>2]=0;f[g+12>>2]=h;f[d>>2]=g;g=a+12|0;h=a+16|0;i=f[h>>2]|0;do if(i){j=a+16|0;k=i;l=i;while(1){m=f[k+16>>2]|0;if(m>>>0>b>>>0){n=f[k>>2]|0;if(!n){o=6;break}else{p=k;q=n}}else{if(m>>>0>=b>>>0){o=10;break}r=k+4|0;m=f[r>>2]|0;if(!m){o=9;break}else{p=r;q=m}}j=p;k=q;l=q}if((o|0)==6){s=k;t=k;o=13;break}else if((o|0)==9){s=r;t=k;o=13;break}else if((o|0)==10){v=j;w=k;x=l;o=12;break}}else{v=h;w=h;x=i;o=12}while(0);if((o|0)==12)if(!x){s=v;t=w;o=13}else y=x;if((o|0)==13){o=VDc(32)|0;f[o+16>>2]=e;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=t;f[s>>2]=o;t=f[f[g>>2]>>2]|0;if(!t)z=o;else{f[g>>2]=t;z=f[s>>2]|0}laa(f[a+16>>2]|0,z);z=a+20|0;f[z>>2]=(f[z>>2]|0)+1;y=o}o=y+24|0;z=f[o>>2]|0;if((z|0)==(f[y+28>>2]|0)){Cic(y+20|0,d);A=f[d>>2]|0;u=c;return A|0}else{f[z>>2]=f[d>>2];f[o>>2]=(f[o>>2]|0)+4;A=f[d>>2]|0;u=c;return A|0}return 0}function Cic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function Dic(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;d[a+12>>1]=0;b[a+14>>0]=c&1;c=a+15|0;b[c>>0]=0;b[c+1>>0]=0;b[c+2>>0]=0;b[c+3>>0]=0;return}function Eic(a){a=a|0;return}function Fic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+160|0;g=e+152|0;h=e;Yi[f[(f[d>>2]|0)+28>>2]&2047](d);i=(b[a+18>>0]^1)&255;mi[f[(f[d>>2]|0)+96>>2]&2047](g,d);Gic(h,f[g>>2]|0,c,f[a>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0,i,(b[a+13>>0]|0)!=0,(b[a+14>>0]|0)!=0,(b[a+15>>0]|0)!=0,(b[a+16>>0]|0)!=0,(b[a+17>>0]|0)!=0,(b[a+12>>0]|0)!=0);i=Hic(a,0,d,h)|0;gcc(h+20|0);u=e;return i|0}function Gic(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;f[a>>2]=e;f[a+4>>2]=g;f[a+8>>2]=h;h=a+12|0;f[h>>2]=168308;f[a+16>>2]=a;g=a+20|0;fcc(g,d,h);f[a+132>>2]=c;f[a+136>>2]=i;b[a+140>>0]=j&1;b[a+141>>0]=k&1;b[a+142>>0]=l&1;b[a+143>>0]=m&1;b[a+144>>0]=o&1;b[a+145>>0]=0;b[a+120>>0]=1;f[a+124>>2]=1;if(!n){mcc(g)|0;return}b[a+128>>0]=0;b[a+129>>0]=1;mcc(g)|0;return}function Hic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+80|0;g=c+40|0;h=c+24|0;i=c+12|0;j=c;k=e+20|0;while(1){if((f[k>>2]|0)==1)break;if(!(Iic(e,d)|0)){l=0;m=24;break}}if((m|0)==24){u=c;return l|0}if(b[e+145>>0]|0){l=0;u=c;return l|0}if(b[a+12>>0]|0){l=1;u=c;return l|0}if(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0){l=1;u=c;return l|0}f[h>>2]=0;a=h+4|0;f[a>>2]=0;f[h+8>>2]=0;ahc(d,h);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=f[h>>2]|0;m=f[a>>2]|0;if((d|0)!=(m|0)){k=g+4|0;n=d;do{if((n|0)!=(d|0))uEc(j,518069)|0;o=b[n+11>>0]|0;p=o<<24>>24<0;f[g>>2]=p?f[n>>2]|0:n;f[k>>2]=p?f[n+4>>2]|0:o&255;qmc(j,g);n=n+12|0}while((n|0)!=(m|0))}VHa(i,502372,j);Jic(e,-1,0,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);j=f[h>>2]|0;if(j|0){i=f[a>>2]|0;if((i|0)==(j|0))q=j;else{e=i;while(1){i=e+-12|0;f[a>>2]=i;if((b[i+11>>0]|0)<0){YDc(f[i>>2]|0);r=f[a>>2]|0}else r=i;if((r|0)==(j|0))break;else e=r}q=f[h>>2]|0}YDc(q)}l=0;u=c;return l|0}function Iic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;d=u;u=u+128|0;e=d+104|0;g=d;h=d+68|0;i=d+64|0;j=d+60|0;k=d+48|0;l=d+36|0;m=d+24|0;n=d+80|0;o=d+120|0;p=d+12|0;q=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);r=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=a+20|0;t=a+36|0;v=f[t>>2]|0;w=a+40|0;x=f[w>>2]|0;a:do if(smc(c,i,j)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;y=a+24|0;z=y+11|0;A=b[z>>0]|0;B=A<<24>>24<0;C=a+28|0;D=A&255;b:do if(((B?f[C>>2]|0:D)|0)==1){A=f[y>>2]|0;c:do if(B){if((b[A>>0]|0)!=(b[e>>0]|0))break b}else{if((A&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break b;E=y;F=D;G=e;while(1){F=F+-1|0;E=E+1|0;if(!F)break c;G=G+1|0;if((b[E>>0]|0)!=(b[G>>0]|0))break b}}while(0);mcc(s)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(Kic(a,g,k)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;A=e+11|0;b[A>>0]=1;b[e>>0]=93;b[e+1>>0]=0;G=Lic(a,e)|0;if((b[A>>0]|0)<0)YDc(f[e>>2]|0);if(G){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;G=b[z>>0]|0;A=G<<24>>24<0;E=G&255;d:do if(((A?f[C>>2]|0:E)|0)==1){G=f[y>>2]|0;e:do if(A){if((b[G>>0]|0)!=(b[e>>0]|0))break d}else{if((G&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break d;F=y;H=E;I=e;while(1){H=H+-1|0;F=F+1|0;if(!H)break e;I=I+1|0;if((b[F>>0]|0)!=(b[I>>0]|0))break d}}while(0);mcc(s)|0}while(0);E=f[(f[c>>2]|0)+96>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;mi[E&2047](e,c);f:do if(Mic(a,g,f[(f[(f[e>>2]|0)+8>>2]|0)+8>>2]|0,l)|0){do if((f[a+136>>2]|0)==1){E=f[i>>2]|0;if(!((f[E+32>>2]|0)!=3?hj[f[(f[q>>2]|0)+20>>2]&511](q,c,E)|0:0))J=27;if((J|0)==27){E=f[j>>2]|0;if((f[E+32>>2]|0)==3)break;if(!(hj[f[(f[q>>2]|0)+20>>2]&511](q,c,E)|0))break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;E=VDc(48)|0;f[e>>2]=E;f[e+8>>2]=-2147483600;f[e+4>>2]=42;A=E;G=502435;I=A+42|0;do{b[A>>0]=b[G>>0]|0;A=A+1|0;G=G+1|0}while((A|0)<(I|0));b[E+42>>0]=0;Jic(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);K=0;break f}while(0);G=f[(f[q>>2]|0)+144>>2]|0;A=f[i>>2]|0;QJa(e,k,g);ei[G&511](q,c,A,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);ei[f[(f[q>>2]|0)+144>>2]&511](q,c,f[j>>2]|0,l);K=1}else K=0;while(0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);L=K}else L=0}else L=0;if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);M=L;break a}while(0);N=y;O=z;P=C;J=43}else{D=a+24|0;N=D;O=D+11|0;P=a+28|0;J=43}while(0);g:do if((J|0)==43){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;L=b[O>>0]|0;K=L<<24>>24<0;j=L&255;h:do if(((K?f[P>>2]|0:j)|0)==1){L=f[a+24>>2]|0;i:do if(K){if((b[L>>0]|0)!=(b[e>>0]|0)){J=77;break h}}else{if((L&255)<<24>>24!=(f[e>>2]&255)<<24>>24){J=77;break h}i=N;D=j;B=e;while(1){D=D+-1|0;i=i+1|0;if(!D)break i;B=B+1|0;if((b[i>>0]|0)!=(b[B>>0]|0)){J=77;break h}}}while(0);mcc(s)|0;if(!(Nic(a,h)|0)){M=0;break g};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;L=e+11|0;b[L>>0]=1;b[e>>0]=93;b[e+1>>0]=0;B=Lic(a,e)|0;if((b[L>>0]|0)<0)YDc(f[e>>2]|0);if(!B){M=0;break g}B=f[a+4>>2]|0;if(!B)Q=Mi[f[(f[q>>2]|0)+308>>2]&1023](q,h)|0;else Q=hj[f[(f[B>>2]|0)+8>>2]&511](B,c,h)|0;if(!Q)if(!(b[a+141>>0]|0)){VHa(l,502478,h);jIa(k,l,502490);QJa(g,k,f[r+4>>2]|0);jIa(e,g,502535);Jic(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);M=0;break g}else{VHa(l,502478,h);jIa(k,l,502490);QJa(g,k,f[r+4>>2]|0);jIa(e,g,502535);Oic(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);R=0;J=133;break}else S=Q}else J=77;while(0);j:do if((J|0)==77){if(!(Pic(a,h)|0)){M=0;break g}do if((b[a+143>>0]|0)!=0?mmc(h,g)|0:0){j=(zYb(r,f[g>>2]|0)|0)==0;K=f[g>>2]|0;if(!j){T=0;U=Mi[f[(f[q>>2]|0)+312>>2]&1023](q,K)|0;J=119;break}if(!(AYb(r,K)|0)){T=0;U=qYb(r,f[g>>2]|0)|0;J=119}else V=1}else J=84;while(0);k:do if((J|0)==84){K=uYb(r,h)|0;if(!K){fEc(k,h);j=k+11|0;C=b[j>>0]|0;z=C<<24>>24<0;y=f[k>>2]|0;B=z?y+(f[k+4>>2]|0)|0:k+(C&255)|0;C=z?y:k;if((C|0)!=(B|0)){y=C;do{C=b[y>>0]|0;if((C+-65&255)<26)b[y>>0]=(C&255)+32;y=y+1|0}while((y|0)!=(B|0))}B=uYb(r,k)|0;if(!B)W=0;else{y=f[B+24>>2]|0;if(y|0?(f[y>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=B;DTb(y,e)}W=(f[B+28>>2]|0)==10?B:0}if((b[j>>0]|0)<0)YDc(f[k>>2]|0);if(!W)J=110;else{X=W;J=97}}else{X=K;J=97}l:do if((J|0)==97){B=f[X+24>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=X;DTb(B,e)}if((f[X+28>>2]|0)==10){B=DYb(X)|0;y=f[B>>2]|0;B=b[y+11>>0]|0;C=B<<24>>24<0;z=B&255;B=C?f[y+4>>2]|0:z;L=b[h+11>>0]|0;i=L<<24>>24<0;if((B|0)==((i?f[h+4>>2]|0:L&255)|0)){L=f[y>>2]|0;D=C?L:y;A=i?f[h>>2]|0:h;i=(B|0)==0;if(C){if(i){Y=X;break}if(!(Arc(D,A,B)|0)){Y=X;break}else{J=110;break}}if(!i)if((L&255)<<24>>24==(b[A>>0]|0)){L=y;y=z;z=A;while(1){y=y+-1|0;L=L+1|0;if(!y)break;z=z+1|0;if((b[L>>0]|0)!=(b[z>>0]|0)){J=110;break l}}if(X)Y=X;else J=110}else J=110;else Y=X}else J=110}else Y=X}while(0);do if((J|0)==110){if(b[a+140>>0]|0){fEc(e,h);K=e+11|0;j=b[K>>0]|0;z=j<<24>>24<0;L=f[e>>2]|0;y=z?L+(f[e+4>>2]|0)|0:e+(j&255)|0;j=z?L:e;if((j|0)!=(y|0)){L=j;do{j=b[L>>0]|0;if((j+-65&255)<26)b[L>>0]=(j&255)+32;L=L+1|0}while((L|0)!=(y|0))}y=rYb(r,e)|0;if((b[K>>0]|0)<0)YDc(f[e>>2]|0);if(y|0){Y=y;break}}T=Qic(r,h)|0;U=0;J=119;break k}while(0);S=Y;break j}while(0);if((J|0)==119){if((U|0)!=0|T)if(!U){R=T;J=133;break}else{S=U;break}if(!(b[a+141>>0]|0)){VHa(m,502538,f[r+4>>2]|0);jIa(l,m,502553);QJa(k,l,h);jIa(e,k,502535);Jic(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);M=0;break g}else V=0}R=V;J=133}while(0);if((J|0)==133){if(!(R|(b[a+141>>0]|0)!=0)){rTb(n,3,502019,481);oTb(o,mTb(n,502576)|0);sTb(n)}y=Mi[f[(f[q>>2]|0)+12>>2]&1023](q,c)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;L=b[O>>0]|0;j=L<<24>>24<0;z=L&255;m:do if(((j?f[P>>2]|0:z)|0)==1){L=a+24|0;E=f[L>>2]|0;n:do if(j){if((b[E>>0]|0)!=(b[e>>0]|0)){J=153;break m}}else{if((E&255)<<24>>24==(f[e>>2]&255)<<24>>24){Z=N;_=z;$=e}else{J=153;break m}while(1){_=_+-1|0;Z=Z+1|0;if(!_)break n;$=$+1|0;if((b[Z>>0]|0)!=(b[$>>0]|0)){J=153;break m}}}while(0);mcc(s)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=123;b[g+1>>0]=0;E=b[O>>0]|0;A=E<<24>>24<0;i=E&255;E=((A?f[P>>2]|0:i)|0)==1;o:do if(E){B=f[L>>2]|0;p:do if(A){if((b[B>>0]|0)!=(b[g>>0]|0))break o}else{if((B&255)<<24>>24==(f[g>>2]&255)<<24>>24){aa=N;ba=i;ca=g}else break o;while(1){ba=ba+-1|0;aa=aa+1|0;if(!ba)break p;ca=ca+1|0;if((b[aa>>0]|0)!=(b[ca>>0]|0))break o}}while(0);break m}while(0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=1;b[k>>0]=60;b[k+1>>0]=0;q:do if(E){B=f[L>>2]|0;if(A)if((b[B>>0]|0)==(b[k>>0]|0))break m;else break;if((B&255)<<24>>24==(f[k>>2]&255)<<24>>24){B=N;K=i;D=k;while(1){K=K+-1|0;B=B+1|0;if(!K)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){J=155;break q}}break m}else J=155}else J=155;while(0);i=f[y>>2]|0;if(!i)da=0;else da=(f[i+4>>2]|0)-(f[i>>2]|0)>>4;i=vjc(y,da)|0;iEc(ujc(i,0)|0,h)|0;M=Ric(a,i)|0;break g}else J=153;while(0);M=Sic(a,y)|0;break}if((f[a+136>>2]|0)==1){if((f[S+32>>2]|0)!=3?hj[f[(f[q>>2]|0)+20>>2]&511](q,c,S)|0:0){VHa(g,502631,h);jIa(e,g,502652);Jic(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);M=0;break}z=f[S+52>>2]|0;if(z|0?hj[f[(f[q>>2]|0)+32>>2]&511](q,c,z)|0:0){j=hj[f[(f[q>>2]|0)+40>>2]&511](q,c,z)|0;VHa(p,502683,h);jIa(m,p,502691);QJa(l,m,f[j>>2]|0);jIa(k,l,502725);QJa(g,k,f[z>>2]|0);jIa(e,g,502535);Jic(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);M=0;break}}z=S+24|0;j=f[z>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=S;DTb(j,e)}j=S+28|0;r:do if((f[161216+(f[j>>2]<<2)>>2]|0)!=10){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=1;b[e>>0]=58;b[e+1>>0]=0;A=Lic(a,e)|0;if((b[i>>0]|0)<0)YDc(f[e>>2]|0);if(A)J=206;else{M=0;break g}}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;A=b[O>>0]|0;i=A<<24>>24<0;L=A&255;s:do if(((i?f[P>>2]|0:L)|0)==1){A=f[a+24>>2]|0;t:do if(i){if((b[A>>0]|0)!=(b[e>>0]|0))break s}else{if((A&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break s;E=N;D=L;B=e;while(1){D=D+-1|0;E=E+1|0;if(!D)break t;B=B+1|0;if((b[E>>0]|0)!=(b[B>>0]|0))break s}}while(0);mcc(s)|0;if(!(b[(f[S+68>>2]|0)+55>>0]|0)){J=206;break r}if((f[a+20>>2]|0)!=5){J=206;break r};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(Tic(a,e)|0){KSb(hh[f[(f[q>>2]|0)+156>>2]&127](q,c,S,0)|0,e)|0;ea=2}else ea=1;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((ea&3)==2)break r;else{M=0;break g}}while(0);J=206}while(0);u:do if((J|0)==206){if((f[S+32>>2]|0)==3){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;y=b[O>>0]|0;L=y<<24>>24<0;i=y&255;v:do if(((L?f[P>>2]|0:i)|0)==1){y=f[a+24>>2]|0;w:do if(L){if((b[y>>0]|0)!=(b[e>>0]|0))break v}else{if((y&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break v;A=N;B=i;E=e;while(1){B=B+-1|0;A=A+1|0;if(!B)break w;E=E+1|0;if((b[A>>0]|0)!=(b[E>>0]|0))break v}}while(0);mcc(s)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=93;b[e+1>>0]=0;y=b[O>>0]|0;E=y<<24>>24<0;A=y&255;x:do if(((E?f[P>>2]|0:A)|0)==1){y=f[a+24>>2]|0;y:do if(E){if((b[y>>0]|0)!=(b[e>>0]|0))break x}else{if((y&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break x;B=N;D=A;K=e;while(1){D=D+-1|0;B=B+1|0;if(!D)break y;K=K+1|0;if((b[B>>0]|0)!=(b[K>>0]|0))break x}}while(0);mcc(s)|0;break u}while(0);A=e+11|0;E=e+1|0;y=a+24|0;K=e+11|0;B=e+1|0;D=e+4|0;C=e+8|0;G=e+12|0;z:while(1){I=f[z>>2]|0;if(I|0?(f[I>>2]|0)!=2:0){f[e>>2]=78728;f[D>>2]=1737;b[C>>0]=0;f[G>>2]=S;DTb(I,e)}if((f[161216+(f[j>>2]<<2)>>2]|0)==10){if(!(Uic(a,c,q,S)|0)){M=0;break g}}else if(!(Vic(a,c,q,S)|0)){M=0;break g};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[A>>0]=1;b[e>>0]=93;b[E>>0]=0;I=b[O>>0]|0;F=I<<24>>24<0;H=I&255;do if(((F?f[P>>2]|0:H)|0)==1){I=f[y>>2]|0;if(F)if((b[I>>0]|0)==(b[e>>0]|0))break z;else break;if((I&255)<<24>>24==(f[e>>2]&255)<<24>>24){I=N;fa=H;ga=e;do{fa=fa+-1|0;I=I+1|0;if(!fa)break z;ga=ga+1|0}while((b[I>>0]|0)==(b[ga>>0]|0))}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[K>>0]=1;b[e>>0]=44;b[B>>0]=0;H=Lic(a,e)|0;if((b[K>>0]|0)<0)YDc(f[e>>2]|0);if(!H){M=0;break g}}mcc(s)|0;break u}while(0)}i=f[z>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=S;DTb(i,e)}if((f[161216+(f[j>>2]<<2)>>2]|0)==10)if(Uic(a,c,q,S)|0)break;else{M=0;break g}else if(Vic(a,c,q,S)|0)break;else{M=0;break g}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=59;b[e+1>>0]=0;j=b[O>>0]|0;z=j<<24>>24<0;i=j&255;j=((z?f[P>>2]|0:i)|0)==1;A:do if(j){L=f[a+24>>2]|0;B:do if(z){if((b[L>>0]|0)!=(b[e>>0]|0)){J=254;break A}}else{if((L&255)<<24>>24!=(f[e>>2]&255)<<24>>24){J=254;break A}K=N;B=i;y=e;while(1){B=B+-1|0;K=K+1|0;if(!B)break B;y=y+1|0;if((b[K>>0]|0)!=(b[y>>0]|0)){J=254;break A}}}while(0);mcc(s)|0}else J=254;while(0);if((J|0)==254){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=44;b[g+1>>0]=0;C:do if(j){L=f[a+24>>2]|0;D:do if(z){if((b[L>>0]|0)!=(b[g>>0]|0))break C}else{if((L&255)<<24>>24!=(f[g>>2]&255)<<24>>24)break C;y=N;K=i;B=g;while(1){K=K+-1|0;y=y+1|0;if(!K)break D;B=B+1|0;if((b[y>>0]|0)!=(b[B>>0]|0))break C}}while(0);mcc(s)|0}while(0)}if(b[(f[S+68>>2]|0)+54>>0]|0){VHa(g,502754,h);jIa(e,g,501908);Oic(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0)}i=f[a+8>>2]|0;if(!i)M=1;else{z=g;f[z>>2]=v;f[z+4>>2]=x;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];zic(i,S,e);M=1}}while(0);if((b[h+11>>0]|0)>=0){u=d;return M|0}YDc(f[h>>2]|0);u=d;return M|0}function Jic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+64|0;h=g+24|0;i=g;b[a+145>>0]=1;j=f[a>>2]|0;if(j|0){ei[f[(f[j>>2]|0)+8>>2]&511](j,c,d,e);u=g;return}if((c|0)>-1){rTb(h,2,502019,288);j=mTb(h,502406)|0;oTb(g+49|0,nTb(mTb(pTb(mTb(pTb(mTb(nTb(j,f[(f[a+132>>2]|0)+4>>2]|0)|0,509015)|0,c+1|0)|0,502433)|0,d+1|0)|0,509015)|0,e)|0);sTb(h);u=g;return}else{rTb(i,2,502019,293);h=mTb(i,502406)|0;oTb(g+48|0,nTb(mTb(nTb(h,f[(f[a+132>>2]|0)+4>>2]|0)|0,509015)|0,e)|0);sTb(i);u=g;return}}function Kic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+96|0;g=e+84|0;h=e+72|0;i=e+60|0;j=e+48|0;k=e+36|0;l=e+24|0;m=e+12|0;n=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;do if(Pic(a,g)|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;o=j+11|0;b[o>>0]=1;b[j>>0]=46;b[j+1>>0]=0;p=Lic(a,j)|0;if((b[o>>0]|0)<0)YDc(f[j>>2]|0);if(p?Pic(a,h)|0:0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;p=j+11|0;b[p>>0]=1;b[j>>0]=46;b[j+1>>0]=0;o=Lic(a,j)|0;if((b[p>>0]|0)<0)YDc(f[j>>2]|0);if(o?Pic(a,i)|0:0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;o=j+11|0;b[o>>0]=1;b[j>>0]=47;b[j+1>>0]=0;p=Lic(a,j)|0;if((b[o>>0]|0)<0)YDc(f[j>>2]|0);if(p?Nic(a,c)|0:0){jIa(n,g,518136);QJa(m,n,h);jIa(l,m,518136);QJa(k,l,i);jIa(j,k,517940);iEc(d,j)|0;if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);p=Mpc(508077)|0;o=d+11|0;q=b[o>>0]|0;r=d+4|0;s=f[r>>2]|0;if((p|0)==((q<<24>>24<0?s:q&255)|0)){if(!(EEc(d,0,-1,508077,p)|0)){t=1;break}v=b[o>>0]|0;w=f[r>>2]|0}else{v=q;w=s}s=Mpc(508098)|0;if((s|0)==((v<<24>>24<0?w:v&255)|0)?(EEc(d,0,-1,508098,s)|0)==0:0){t=1;break}VHa(k,503341,d);jIa(j,k,501908);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,j);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);t=0}else t=0}else t=0}else t=0}else t=0;while(0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[g+11>>0]|0)>=0){u=e;return t|0}YDc(f[g>>2]|0);u=e;return t|0}function Lic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+48|0;e=d+36|0;g=d+24|0;h=d+12|0;i=d;j=a+20|0;k=a+24|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=l&255;l=m?f[a+28>>2]|0:n;o=b[c+11>>0]|0;p=o<<24>>24<0;a:do if((l|0)==((p?f[c+4>>2]|0:o&255)|0)){q=f[k>>2]|0;r=m?q:k;s=p?f[c>>2]|0:c;t=(l|0)==0;b:do if(m){if(!t?Arc(r,s,l)|0:0)break a}else if(!t){if((q&255)<<24>>24==(b[s>>0]|0)){v=k;w=n;x=s}else break a;while(1){w=w+-1|0;v=v+1|0;if(!w)break b;x=x+1|0;if((b[v>>0]|0)!=(b[x>>0]|0))break a}}while(0);mcc(j)|0;y=1;u=d;return y|0}while(0);VHa(i,503319,c);jIa(h,i,503330);QJa(g,h,k);jIa(e,g,502535);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);y=0;u=d;return y|0}function Mic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+80|0;h=g+48|0;i=g+36|0;j=g+24|0;k=g+12|0;l=g;m=mYb(d,c)|0;if(!m){VHa(i,503188,c);jIa(h,i,503210);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);n=0;u=g;return n|0}k9b(h);d=h9b(h,m)|0;if(d){m=_i[f[(f[d>>2]|0)+12>>2]&1023](d)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;do if(Zic(a,i)|0){fEc(j,i);d=_ic(a,m,j)|0;if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if(d){if(b[a+144>>0]|0){PSb(m,e)|0;o=1;break}if(_i[f[(f[m>>2]|0)+32>>2]&1023](m)|0){OSb(m,e)|0;o=1;break}VHa(l,503243,c);jIa(k,l,503259);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,k);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);o=0}else o=0}else o=0;while(0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if(!m)p=o;else{Yi[f[(f[m>>2]|0)+4>>2]&2047](m);p=o}}else p=0;f9b(h);n=p;u=g;return n|0}function Nic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;if(!(Pic(a,c)|0)){g=0;u=d;return g|0}h=e+11|0;i=e+1|0;j=a+20|0;k=a+24|0;l=k+11|0;m=a+28|0;n=e+11|0;o=e+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[h>>0]=1;b[e>>0]=46;b[i>>0]=0;p=b[l>>0]|0;q=p<<24>>24<0;r=p&255;a:do if(((q?f[m>>2]|0:r)|0)==1){p=r;s=q;while(1){t=f[k>>2]|0;b:do if(s){if((b[t>>0]|0)!=(b[e>>0]|0))break a}else{if((t&255)<<24>>24==(f[e>>2]&255)<<24>>24){v=k;w=p;x=e}else break a;while(1){w=w+-1|0;v=v+1|0;if(!w)break b;x=x+1|0;if((b[v>>0]|0)!=(b[x>>0]|0))break a}}while(0);mcc(j)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(!(Pic(a,e)|0))break;uEc(c,518136)|0;t=b[n>>0]|0;y=t<<24>>24<0;tEc(c,y?f[e>>2]|0:e,y?f[o>>2]|0:t&255)|0;if((b[n>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[h>>0]=1;b[e>>0]=46;b[i>>0]=0;t=b[l>>0]|0;s=t<<24>>24<0;p=t&255;if(((s?f[m>>2]|0:p)|0)!=1)break a}if((b[n>>0]|0)<0)YDc(f[e>>2]|0);g=0;u=d;return g|0}while(0);g=1;u=d;return g|0}function Oic(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+64|0;g=e+24|0;h=e;i=f[a>>2]|0;if(i|0){ei[f[(f[i>>2]|0)+12>>2]&511](i,b,c,d);u=e;return}if((b|0)>-1){rTb(g,1,502019,305);i=mTb(g,503159)|0;oTb(e+49|0,nTb(mTb(pTb(mTb(pTb(mTb(nTb(i,f[(f[a+132>>2]|0)+4>>2]|0)|0,509015)|0,b+1|0)|0,502433)|0,c+1|0)|0,509015)|0,d)|0);sTb(g);u=e;return}else{rTb(h,1,502019,310);g=mTb(h,503159)|0;oTb(e+48|0,nTb(mTb(nTb(g,f[(f[a+132>>2]|0)+4>>2]|0)|0,509015)|0,d)|0);sTb(h);u=e;return}}function Pic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a+20>>2]|0;if((g|0)==2){iEc(c,a+24|0)|0;mcc(a+20|0)|0;h=1;u=d;return h|0}if(!(b[a+143>>0]|0)){if((b[a+141>>0]|0)!=0&(g|0)==3)i=6}else if((g|0)==3)i=6;if((i|0)==6){iEc(c,a+24|0)|0;mcc(a+20|0)|0;h=1;u=d;return h|0}VHa(e,503132,a+24|0);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);h=0;u=d;return h|0}function Qic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a+80>>2]|0;if((d|0)<=0){e=0;return e|0}g=f[a+48>>2]|0;a=b[c+11>>0]|0;h=a<<24>>24<0;i=a&255;a=h?f[c+4>>2]|0:i;j=h?f[c>>2]|0:c;k=(a|0)==0;if(h){if(k){h=0;while(1){l=f[g+(h<<2)>>2]|0;m=b[l+11>>0]|0;if(!((m<<24>>24<0?f[l+4>>2]|0:m&255)|0)){e=1;n=17;break}h=h+1|0;if((h|0)>=(d|0)){e=0;n=17;break}}if((n|0)==17)return e|0}else o=0;while(1){h=f[g+(o<<2)>>2]|0;m=b[h+11>>0]|0;l=m<<24>>24<0;if((a|0)==((l?f[h+4>>2]|0:m&255)|0)?(Arc(j,l?f[h>>2]|0:h,a)|0)==0:0){e=1;n=17;break}o=o+1|0;if((o|0)>=(d|0)){e=0;n=17;break}}if((n|0)==17)return e|0}if(k){k=0;while(1){o=f[g+(k<<2)>>2]|0;j=b[o+11>>0]|0;if(!((j<<24>>24<0?f[o+4>>2]|0:j&255)|0)){e=1;n=17;break}k=k+1|0;if((k|0)>=(d|0)){e=0;n=17;break}}if((n|0)==17)return e|0}else p=0;a:while(1){k=f[g+(p<<2)>>2]|0;j=b[k+11>>0]|0;o=j<<24>>24<0;b:do if((a|0)==((o?f[k+4>>2]|0:j&255)|0)){h=c;l=i;m=o?f[k>>2]|0:k;while(1){if((b[h>>0]|0)!=(b[m>>0]|0))break b;l=l+-1|0;if(!l){e=1;n=17;break a}else{h=h+1|0;m=m+1|0}}}while(0);p=p+1|0;if((p|0)>=(d|0)){e=0;n=17;break}}if((n|0)==17)return e|0;return 0}function Ric(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+32|0;e=d+12|0;g=d;h=a+20|0;if((f[h>>2]|0)==5){i=a+20|0;do mcc(i)|0;while((f[h>>2]|0)==5);j=1;u=d;return j|0};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;i=a+20|0;k=a+24|0;l=k+11|0;m=b[l>>0]|0;n=m<<24>>24<0;o=a+28|0;p=m&255;a:do if(((n?f[o>>2]|0:p)|0)==1){m=f[k>>2]|0;b:do if(n){if((b[m>>0]|0)!=(b[e>>0]|0))break a}else{if((m&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break a;q=k;r=p;s=e;while(1){r=r+-1|0;q=q+1|0;if(!r)break b;s=s+1|0;if((b[q>>0]|0)!=(b[s>>0]|0))break a}}while(0);mcc(i)|0;m=e+11|0;s=e+1|0;q=e+11|0;r=e+1|0;t=e+11|0;v=e+1|0;w=g+11|0;x=g+1|0;c:while(1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[m>>0]=1;b[e>>0]=123;b[s>>0]=0;y=b[l>>0]|0;z=y<<24>>24<0;A=y&255;y=((z?f[o>>2]|0:A)|0)==1;d:do if(y){B=f[k>>2]|0;e:do if(z)if((b[B>>0]|0)==(b[e>>0]|0))C=24;else C=18;else if((B&255)<<24>>24==(f[e>>2]&255)<<24>>24){D=k;E=A;F=e;while(1){E=E+-1|0;D=D+1|0;if(!E){C=24;break e}F=F+1|0;if((b[D>>0]|0)!=(b[F>>0]|0)){C=18;break}}}else C=18;while(0);do if((C|0)==18){C=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[w>>0]=1;b[g>>0]=60;b[x>>0]=0;if(!y){C=26;break d}B=f[k>>2]|0;if(z)if((b[B>>0]|0)==(b[g>>0]|0))break;else{C=28;break d}if((B&255)<<24>>24==(f[g>>2]&255)<<24>>24){G=k;H=A;I=g}else{C=26;break d}while(1){H=H+-1|0;G=G+1|0;if(!H)break;I=I+1|0;if((b[G>>0]|0)!=(b[I>>0]|0)){C=26;break d}}}else if((C|0)==24)C=0;while(0);if(!(Sic(a,c)|0)){j=0;C=72;break c}}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[w>>0]=1;b[g>>0]=60;b[x>>0]=0;C=26}while(0);if((C|0)==26){C=0;C=28}if((C|0)==28?(C=0,!(Ric(a,c)|0)):0){j=0;C=72;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[q>>0]=1;b[e>>0]=93;b[r>>0]=0;A=b[l>>0]|0;z=A<<24>>24<0;y=A&255;do if(((z?f[o>>2]|0:y)|0)==1){A=f[k>>2]|0;if(z)if((b[A>>0]|0)==(b[e>>0]|0)){C=36;break c}else break;if((A&255)<<24>>24==(f[e>>2]&255)<<24>>24){A=k;B=y;F=e;do{B=B+-1|0;A=A+1|0;if(!B){C=36;break c}F=F+1|0}while((b[A>>0]|0)==(b[F>>0]|0))}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[t>>0]=1;b[e>>0]=44;b[v>>0]=0;y=Lic(a,e)|0;if((b[t>>0]|0)<0)YDc(f[e>>2]|0);if(!y){j=0;C=72;break}}if((C|0)==36){mcc(i)|0;j=1;u=d;return j|0}else if((C|0)==72){u=d;return j|0}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=45;b[e+1>>0]=0;I=b[l>>0]|0;l=I<<24>>24<0;G=I&255;f:do if(((l?f[o>>2]|0:G)|0)==1){I=f[k>>2]|0;g:do if(l){if((b[I>>0]|0)!=(b[e>>0]|0)){J=0;break f}}else{if((I&255)<<24>>24!=(f[e>>2]&255)<<24>>24){J=0;break f}H=k;p=G;n=e;while(1){p=p+-1|0;H=H+1|0;if(!p)break g;n=n+1|0;if((b[H>>0]|0)!=(b[n>>0]|0)){J=0;break f}}}while(0);mcc(i)|0;J=1}else J=0;while(0);G=f[h>>2]|0;if((G+-2|0)>>>0>=3){j=0;u=d;return j|0}if(J&(G|0)==2){fEc(e,k);G=e+11|0;J=b[G>>0]|0;h=J<<24>>24<0;l=f[e>>2]|0;o=e+4|0;I=f[o>>2]|0;n=h?l+I|0:e+(J&255)|0;H=h?l:e;if((H|0)==(n|0)){K=J;L=I}else{I=H;do{H=b[I>>0]|0;if((H+-65&255)<26)b[I>>0]=(H&255)+32;I=I+1|0}while((I|0)!=(n|0));K=b[G>>0]|0;L=f[o>>2]|0}if(((K<<24>>24<0?L:K&255)|0)==3){if(EEc(e,0,-1,511981,3)|0){M=b[G>>0]|0;N=f[o>>2]|0;C=58}}else{M=K;N=L;C=58}do if((C|0)==58){if(((M<<24>>24<0?N:M&255)|0)==8){if(!(EEc(e,0,-1,513901,8)|0))break;O=b[G>>0]|0;P=f[o>>2]|0}else{O=M;P=N}if(((O<<24>>24<0?P:O&255)|0)==3?(EEc(e,0,-1,513910,3)|0)==0:0)break;VHa(g,503109,e);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[G>>0]|0)<0)YDc(f[e>>2]|0);j=0;u=d;return j|0}while(0);if((b[G>>0]|0)<0)YDc(f[e>>2]|0)}iEc(ujc(c,1)|0,k)|0;mcc(i)|0;j=1;u=d;return j|0}function Sic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a:do if(Zic(a,e)|0){i=g+11|0;j=g+1|0;k=a+24|0;l=k+11|0;m=a+28|0;n=h+11|0;o=h+1|0;b:while(1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[i>>0]=1;b[g>>0]=62;b[j>>0]=0;p=b[l>>0]|0;q=p<<24>>24<0;r=p&255;p=((q?f[m>>2]|0:r)|0)==1;do if(p){s=f[k>>2]|0;if(q){if((b[s>>0]|0)==(b[g>>0]|0)){t=15;break b}}else if((s&255)<<24>>24==(f[g>>2]&255)<<24>>24){s=k;v=r;w=g;do{v=v+-1|0;s=s+1|0;if(!v){t=15;break b}w=w+1|0}while((b[s>>0]|0)==(b[w>>0]|0))};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;if(p){w=f[k>>2]|0;if(q)if((b[w>>0]|0)==(b[h>>0]|0))break b;else break;if((w&255)<<24>>24==(f[h>>2]&255)<<24>>24){w=k;s=r;v=h;while(1){s=s+-1|0;w=w+1|0;if(!s){t=13;break b}v=v+1|0;if((b[w>>0]|0)!=(b[v>>0]|0)){t=17;break}}}else t=17}else t=17}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;t=17}while(0);if((t|0)==17)t=0;if(!($ic(a,c)|0)){x=0;break a}}x=Lic(a,e)|0}else x=0;while(0);if((b[e+11>>0]|0)>=0){u=d;return x|0}YDc(f[e>>2]|0);u=d;return x|0}function Tic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+20|0;if((f[g>>2]|0)!=5){VHa(e,503086,a+24|0);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);h=0;u=d;return h|0}e=c+11|0;if((b[e>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[e>>0]=0}if((f[g>>2]|0)!=5){h=1;u=d;return h|0}e=a+20|0;i=a+24|0;do{pcc(i,c);mcc(e)|0}while((f[g>>2]|0)==5);h=1;u=d;return h|0}function Uic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+48|0;h=g+24|0;i=g+12|0;j=g;k=a+8|0;l=f[k>>2]|0;if(l|0){m=Bic(l,e)|0;f[k>>2]=m};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;do if(Zic(a,h)|0){m=f[d>>2]|0;if((f[e+32>>2]|0)==3){n=hh[f[m+300>>2]&127](d,c,e,0)|0;fEc(i,h);o=_ic(a,n,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if(!o){p=0;break}}else{o=hh[f[m+156>>2]&127](d,c,e,0)|0;fEc(j,h);m=_ic(a,o,j)|0;if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if(!m){p=0;break}}f[k>>2]=l;p=1}else p=0;while(0);if((b[h+11>>0]|0)>=0){u=g;return p|0}YDc(f[h>>2]|0);u=g;return p|0}function Vic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+96|0;h=g;i=g+52|0;j=g+40|0;k=g+28|0;l=g+16|0;m=g+64|0;n=g+88|0;o=f[e+24>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(o,h)}a:do switch(f[161216+(f[e+28>>2]<<2)>>2]|0){case 1:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;o=a+20|0;q=a+24|0;r=b[q+11>>0]|0;s=r<<24>>24<0;t=r&255;b:do if(((s?f[a+28>>2]|0:t)|0)==1){r=f[q>>2]|0;c:do if(s){if((b[r>>0]|0)!=45){v=0;break b}}else{if((r&255)<<24>>24!=(f[h>>2]&255)<<24>>24){v=0;break b}w=q;x=t;y=h;while(1){x=x+-1|0;w=w+1|0;if(!x)break c;y=y+1|0;if((b[w>>0]|0)!=(b[y>>0]|0)){v=0;break b}}}while(0);mcc(o)|0;v=1}else v=0;while(0);if(!(Wic(a,h,v?-2147483648:2147483647,v?0:0)|0)){z=0;u=g;return z|0}o=h;t=f[o>>2]|0;q=f[o+4>>2]|0;o=(t|0)==0&(q|0)==-2147483648;s=TIc(0,0,t|0,q|0)|0;q=v?(o?0:s):t;t=f[d>>2]|0;if((f[e+32>>2]|0)==3){ei[f[t+260>>2]&511](d,c,e,q);break a}else{ei[f[t+116>>2]&511](d,c,e,q);break a}break}case 3:{if(!(Wic(a,h,-1,0)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;t=f[h>>2]|0;if((f[e+32>>2]|0)==3)ei[f[q+268>>2]&511](d,c,e,t);else ei[f[q+124>>2]&511](d,c,e,t);break}case 2:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;t=a+20|0;q=a+24|0;s=b[q+11>>0]|0;o=s<<24>>24<0;r=s&255;d:do if(((o?f[a+28>>2]|0:r)|0)==1){s=f[q>>2]|0;e:do if(o){if((b[s>>0]|0)!=45){A=0;break d}}else{if((s&255)<<24>>24!=(f[h>>2]&255)<<24>>24){A=0;break d}y=q;w=r;x=h;while(1){w=w+-1|0;y=y+1|0;if(!w)break e;x=x+1|0;if((b[y>>0]|0)!=(b[x>>0]|0)){A=0;break d}}}while(0);mcc(t)|0;A=1}else A=0;while(0);if(!(Wic(a,h,A?0:-1,A?-2147483648:2147483647)|0)){z=0;u=g;return z|0}t=h;r=f[t>>2]|0;q=f[t+4>>2]|0;t=(r|0)==0&(q|0)==-2147483648;o=TIc(0,0,r|0,q|0)|0;s=A?(t?0:o):r;r=A?(t?-2147483648:J):q;q=f[d>>2]|0;if((f[e+32>>2]|0)==3){gi[f[q+264>>2]&255](d,c,e,s,r);break a}else{gi[f[q+120>>2]&255](d,c,e,s,r);break a}break}case 4:{if(!(Wic(a,h,-1,-1)|0)){z=0;u=g;return z|0}r=f[d>>2]|0;s=h;q=f[s>>2]|0;t=f[s+4>>2]|0;if((f[e+32>>2]|0)==3)gi[f[r+272>>2]&255](d,c,e,q,t);else gi[f[r+128>>2]&255](d,c,e,q,t);break}case 6:{if(!(Xic(a,h)|0)){z=0;u=g;return z|0}t=f[d>>2]|0;B=+p[h>>3];if((f[e+32>>2]|0)==3){q=f[t+276>>2]|0;C=+dcc(B);$h[q&63](d,c,e,C)}else{q=f[t+132>>2]|0;C=+dcc(B);$h[q&63](d,c,e,C)}break}case 5:{if(!(Xic(a,h)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;C=+p[h>>3];if((f[e+32>>2]|0)==3)$h[f[q+280>>2]&63](d,c,e,C);else $h[f[q+136>>2]&63](d,c,e,C);break}case 9:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(!(Tic(a,h)|0)){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);z=0;u=g;return z|0}q=f[d>>2]|0;if((f[e+32>>2]|0)==3)ei[f[q+288>>2]&511](d,c,e,h);else ei[f[q+144>>2]&511](d,c,e,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);break}case 7:{if((f[a+20>>2]|0)==3){if(!(Wic(a,h,1,0)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;t=h;r=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0;if((f[e+32>>2]|0)==3)ei[f[q+284>>2]&511](d,c,e,r);else ei[f[q+140>>2]&511](d,c,e,r);break a};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Pic(a,h)|0;q=h+11|0;t=b[q>>0]|0;s=t<<24>>24<0;if(!r){if(s)YDc(f[h>>2]|0);z=0;u=g;return z|0}r=h+4|0;o=f[r>>2]|0;if(((s?o:t&255)|0)==4)if(!(EEc(h,0,-1,519053,4)|0))D=72;else{E=b[q>>0]|0;F=f[r>>2]|0;D=66}else{E=t;F=o;D=66}do if((D|0)==66){if(((E<<24>>24<0?F:E&255)|0)==4){if(!(EEc(h,0,-1,502794,4)|0)){D=72;break}G=b[q>>0]|0;H=f[r>>2]|0}else{G=E;H=F}if(((G<<24>>24<0?H:G&255)|0)==1){if(!(EEc(h,0,-1,502799,1)|0)){D=72;break}I=b[q>>0]|0;K=f[r>>2]|0}else{I=G;K=H}if(((I<<24>>24<0?K:I&255)|0)==5){if(EEc(h,0,-1,519047,5)|0){L=b[q>>0]|0;M=f[r>>2]|0;D=78}}else{L=I;M=K;D=78}do if((D|0)==78){if(((L<<24>>24<0?M:L&255)|0)==5){if(!(EEc(h,0,-1,502801,5)|0))break;N=b[q>>0]|0;O=f[r>>2]|0}else{N=L;O=M}if(((N<<24>>24<0?O:N&255)|0)==1?(EEc(h,0,-1,502807,1)|0)==0:0)break;VHa(l,502809,f[e>>2]|0);jIa(k,l,502843);QJa(j,k,h);jIa(i,j,502535);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[q>>0]|0)<0)YDc(f[h>>2]|0);z=0;u=g;return z|0}while(0);o=f[d>>2]|0;if((f[e+32>>2]|0)==3){ei[f[o+284>>2]&511](d,c,e,0);break}else{ei[f[o+140>>2]&511](d,c,e,0);break}}while(0);do if((D|0)==72){r=f[d>>2]|0;if((f[e+32>>2]|0)==3){ei[f[r+284>>2]&511](d,c,e,1);break}else{ei[f[r+140>>2]&511](d,c,e,1);break}}while(0);if((b[q>>0]|0)<0)YDc(f[h>>2]|0);break}case 8:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;r=EYb(e)|0;o=f[a+20>>2]|0;do if((o|0)==2)if(Pic(a,i)|0){P=vYb(r,i)|0;D=128}else{Q=1;R=0}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;t=a+24|0;s=b[t+11>>0]|0;x=s<<24>>24<0;y=s&255;s=((x?f[a+28>>2]|0:y)|0)==1;f:do if(s){w=f[t>>2]|0;g:do if(x){if((b[w>>0]|0)!=(b[h>>0]|0)){D=110;break f}}else{if((w&255)<<24>>24!=(f[h>>2]&255)<<24>>24){D=110;break f}S=t;T=y;U=h;while(1){T=T+-1|0;S=S+1|0;if(!T)break g;U=U+1|0;if((b[S>>0]|0)!=(b[U>>0]|0)){D=110;break f}}}while(0)}else D=110;while(0);if((D|0)==110?(o|0)!=3:0){VHa(h,502855,t);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);Q=1;R=0;break};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;w=a+20|0;h:do if(s){U=f[t>>2]|0;i:do if(x){if((b[U>>0]|0)!=45){V=0;break h}}else{if((U&255)<<24>>24!=(f[h>>2]&255)<<24>>24){V=0;break h}S=t;T=y;W=h;while(1){T=T+-1|0;S=S+1|0;if(!T)break i;W=W+1|0;if((b[S>>0]|0)!=(b[W>>0]|0)){V=0;break h}}}while(0);mcc(w)|0;V=1}else V=0;while(0);if(!(Wic(a,h,V?-2147483648:2147483647,V?0:0)|0)){Q=1;R=0;break}w=h;y=f[w>>2]|0;t=f[w+4>>2]|0;w=(y|0)==0&(t|0)==-2147483648;x=TIc(0,0,y|0,t|0)|0;s=V?(w?0:x):y;gmc(h,s,V?(w?-2147483648:J):t);iEc(i,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);P=wYb(r,s)|0;D=128}while(0);do if((D|0)==128){if(P|0){r=f[d>>2]|0;if((f[e+32>>2]|0)==3){ei[f[r+292>>2]&511](d,c,e,P);Q=2;R=0;break}else{ei[f[r+148>>2]&511](d,c,e,P);Q=2;R=0;break}}if(!(b[a+142>>0]|0)){VHa(l,502893,i);jIa(k,l,502924);QJa(j,k,f[e>>2]|0);jIa(h,j,502535);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);Q=1;R=0;break}else{VHa(l,502893,i);jIa(k,l,502924);QJa(j,k,f[e>>2]|0);jIa(h,j,502535);Oic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);Q=1;R=1;break}}while(0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((Q|0)==1){z=R;u=g;return z|0}break}case 10:{rTb(m,3,502019,770);oTb(n,mTb(m,502938)|0);sTb(m);break}default:{}}while(0);z=1;u=g;return z|0}function Wic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+12|0;i=g;if((f[a+20>>2]|0)!=3){VHa(h,503006,a+24|0);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);j=0;u=g;return j|0}k=a+24|0;if(ncc(k,d,e,c)|0){mcc(a+20|0)|0;j=1;u=g;return j|0}VHa(i,503061,k);jIa(h,i,517845);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);j=0;u=g;return j|0}function Xic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0;d=u;u=u+32|0;e=d;g=d+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=45;b[e+1>>0]=0;h=a+20|0;i=a+24|0;j=b[i+11>>0]|0;k=j<<24>>24<0;l=j&255;a:do if(((k?f[a+28>>2]|0:l)|0)==1){j=f[i>>2]|0;b:do if(k){if((b[j>>0]|0)!=(b[e>>0]|0)){m=0;break a}}else{if((j&255)<<24>>24!=(f[e>>2]&255)<<24>>24){m=0;break a}n=i;o=l;q=e;while(1){o=o+-1|0;n=n+1|0;if(!o)break b;q=q+1|0;if((b[n>>0]|0)!=(b[q>>0]|0)){m=0;break a}}}while(0);mcc(h)|0;m=1}else m=0;while(0);c:do switch(f[a+20>>2]|0){case 3:{if(Yic(a,e,-1,-1)|0){l=e;p[c>>3]=+((f[l>>2]|0)>>>0)+4294967296.0*+((f[l+4>>2]|0)>>>0);break c}r=0;u=d;return r|0}case 4:{s=+occ(i);p[c>>3]=s;mcc(h)|0;break}case 2:{fEc(e,i);l=e+11|0;k=b[l>>0]|0;j=k<<24>>24<0;q=f[e>>2]|0;n=e+4|0;o=f[n>>2]|0;t=j?q+o|0:e+(k&255)|0;v=j?q:e;if((v|0)==(t|0)){w=k;x=o}else{o=v;do{v=b[o>>0]|0;if((v+-65&255)<26)b[o>>0]=(v&255)+32;o=o+1|0}while((o|0)!=(t|0));w=b[l>>0]|0;x=f[n>>2]|0}if(((w<<24>>24<0?x:w&255)|0)==3)if(!(EEc(e,0,-1,511981,3)|0))y=25;else{z=b[l>>0]|0;A=f[n>>2]|0;y=22}else{z=w;A=x;y=22}do if((y|0)==22){if(((z<<24>>24<0?A:z&255)|0)==8){if(!(EEc(e,0,-1,513901,8)|0)){y=25;break}B=b[l>>0]|0;E=f[n>>2]|0}else{B=z;E=A}if(((B<<24>>24<0?E:B&255)|0)==3?(EEc(e,0,-1,513910,3)|0)==0:0){p[c>>3]=C;mcc(h)|0;break}VHa(g,502983,e);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[l>>0]|0)<0)YDc(f[e>>2]|0);r=0;u=d;return r|0}while(0);if((y|0)==25){p[c>>3]=D;mcc(h)|0}if((b[l>>0]|0)<0)YDc(f[e>>2]|0);break}default:{VHa(e,502983,i);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);r=0;u=d;return r|0}}while(0);if(!m){r=1;u=d;return r|0}p[c>>3]=-+p[c>>3];r=1;u=d;return r|0}function Yic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+32|0;h=g+12|0;i=g;if((f[a+20>>2]|0)!=3){VHa(h,503006,a+24|0);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);j=0;u=g;return j|0}k=a+20|0;l=a+24|0;m=b[l+11>>0]|0;n=m<<24>>24<0;do if((n?f[a+28>>2]|0:m&255)>>>0>1){o=n?f[l>>2]|0:l;if(!((b[o>>0]|0)==48?(b[o+1>>0]|32)<<24>>24==120:0)){o=n?f[l>>2]|0:l;if((b[o>>0]|0)!=48)break;if((b[o+1>>0]&-8)<<24>>24!=48)break}VHa(h,503030,l);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);j=0;u=g;return j|0}while(0);if(ncc(l,d,e,c)|0){mcc(k)|0;j=1;u=g;return j|0}VHa(i,503061,l);jIa(h,i,517845);Jic(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);j=0;u=g;return j|0}function Zic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=60;b[e+1>>0]=0;g=a+20|0;h=a+24|0;i=b[h+11>>0]|0;j=i<<24>>24<0;k=i&255;a:do if(((j?f[a+28>>2]|0:k)|0)==1){i=f[h>>2]|0;b:do if(j){if((b[i>>0]|0)!=(b[e>>0]|0))break a}else{if((i&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break a;l=h;m=k;n=e;while(1){m=m+-1|0;l=l+1|0;if(!m)break b;n=n+1|0;if((b[l>>0]|0)!=(b[n>>0]|0))break a}}while(0);mcc(g)|0;nEc(c,517883)|0;o=1;u=d;return o|0}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=1;b[e>>0]=123;b[e+1>>0]=0;k=Lic(a,e)|0;if((b[g>>0]|0)<0)YDc(f[e>>2]|0);if(!k){o=0;u=d;return o|0}nEc(c,503084)|0;o=1;u=d;return o|0}function _ic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+32|0;g=e+12|0;h=e;i=g+11|0;j=g+1|0;k=a+24|0;l=k+11|0;m=a+28|0;n=h+11|0;o=h+1|0;a:while(1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[i>>0]=1;b[g>>0]=62;b[j>>0]=0;p=b[l>>0]|0;q=p<<24>>24<0;r=p&255;p=((q?f[m>>2]|0:r)|0)==1;do if(p){s=f[k>>2]|0;if(q){if((b[s>>0]|0)==(b[g>>0]|0)){t=14;break a}}else if((s&255)<<24>>24==(f[g>>2]&255)<<24>>24){s=k;v=r;w=g;do{v=v+-1|0;s=s+1|0;if(!v){t=14;break a}w=w+1|0}while((b[s>>0]|0)==(b[w>>0]|0))};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;if(p){w=f[k>>2]|0;if(q)if((b[w>>0]|0)==(b[h>>0]|0))break a;else break;if((w&255)<<24>>24==(f[h>>2]&255)<<24>>24){w=k;s=r;v=h;while(1){s=s+-1|0;w=w+1|0;if(!s){t=12;break a}v=v+1|0;if((b[w>>0]|0)!=(b[v>>0]|0)){t=16;break}}}else t=16}else t=16}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;t=16}while(0);if((t|0)==16)t=0;if(!(Iic(a,c)|0)){x=0;t=20;break}}if((t|0)!=12)if((t|0)!=14)if((t|0)==20){u=e;return x|0}x=Lic(a,d)|0;u=e;return x|0}function $ic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+48|0;e=d+36|0;g=d+24|0;h=d+12|0;i=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=91;b[g+1>>0]=0;j=a+20|0;k=a+24|0;l=k+11|0;m=b[l>>0]|0;n=m<<24>>24<0;o=a+28|0;p=m&255;a:do if(((n?f[o>>2]|0:p)|0)==1){m=f[k>>2]|0;b:do if(n){if((b[m>>0]|0)!=(b[g>>0]|0)){q=12;break a}}else{if((m&255)<<24>>24!=(f[g>>2]&255)<<24>>24){q=12;break a}r=k;s=p;t=g;while(1){s=s+-1|0;r=r+1|0;if(!s)break b;t=t+1|0;if((b[r>>0]|0)!=(b[t>>0]|0)){q=12;break a}}}while(0);mcc(j)|0;if(Nic(a,e)|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=g+11|0;b[m>>0]=1;b[g>>0]=93;b[g+1>>0]=0;t=Lic(a,g)|0;if((b[m>>0]|0)<0)YDc(f[g>>2]|0);if(t)q=13;else v=0}else v=0}else q=12;while(0);if((q|0)==12)if(Pic(a,e)|0)q=13;else v=0;c:do if((q|0)==13){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=58;b[g+1>>0]=0;p=b[l>>0]|0;n=p<<24>>24<0;t=p&255;d:do if(((n?f[o>>2]|0:t)|0)==1){p=f[k>>2]|0;e:do if(n){if((b[p>>0]|0)!=(b[g>>0]|0)){q=31;break d}}else{if((p&255)<<24>>24==(f[g>>2]&255)<<24>>24){w=k;x=t;y=g}else{q=31;break d}while(1){x=x+-1|0;w=w+1|0;if(!x)break e;y=y+1|0;if((b[w>>0]|0)!=(b[y>>0]|0)){q=31;break d}}}while(0);mcc(j)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=123;b[h+1>>0]=0;p=b[l>>0]|0;m=p<<24>>24<0;r=p&255;p=((m?f[o>>2]|0:r)|0)==1;f:do if(p){s=f[k>>2]|0;g:do if(m){if((b[s>>0]|0)!=(b[h>>0]|0))break f}else{if((s&255)<<24>>24==(f[h>>2]&255)<<24>>24){z=k;A=r;B=h}else break f;while(1){A=A+-1|0;z=z+1|0;if(!A)break g;B=B+1|0;if((b[z>>0]|0)!=(b[B>>0]|0))break f}}while(0);q=40;break d}while(0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=1;b[i>>0]=60;b[i+1>>0]=0;do if(p){s=f[k>>2]|0;if(m)if((b[s>>0]|0)==(b[i>>0]|0)){q=40;break d}else break;if((s&255)<<24>>24==(f[i>>2]&255)<<24>>24){C=k;D=r;E=i}else break;while(1){D=D+-1|0;C=C+1|0;if(!D){q=39;break}E=E+1|0;if((b[C>>0]|0)!=(b[E>>0]|0)){q=35;break}}if((q|0)==35)break;else if((q|0)==39){q=40;break d}}while(0);r=f[c>>2]|0;if(!r)F=0;else F=(f[r+4>>2]|0)-(f[r>>2]|0)>>4;r=vjc(c,F)|0;iEc(ujc(r,0)|0,e)|0;if(!(Ric(a,r)|0)){v=0;break c}}else q=31;while(0);if((q|0)==31)q=40;if((q|0)==40?!(Sic(a,c)|0):0){v=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=59;b[g+1>>0]=0;t=b[l>>0]|0;n=t<<24>>24<0;r=t&255;t=((n?f[o>>2]|0:r)|0)==1;h:do if(t){m=f[k>>2]|0;i:do if(n){if((b[m>>0]|0)!=(b[g>>0]|0)){q=49;break h}}else{if((m&255)<<24>>24!=(f[g>>2]&255)<<24>>24){q=49;break h}p=k;s=r;G=g;while(1){s=s+-1|0;p=p+1|0;if(!s)break i;G=G+1|0;if((b[p>>0]|0)!=(b[G>>0]|0)){q=49;break h}}}while(0);mcc(j)|0}else q=49;while(0);if((q|0)==49){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=44;b[h+1>>0]=0;j:do if(t){m=f[k>>2]|0;k:do if(n){if((b[m>>0]|0)!=(b[h>>0]|0))break j}else{if((m&255)<<24>>24!=(f[h>>2]&255)<<24>>24)break j;G=k;p=r;s=h;while(1){p=p+-1|0;G=G+1|0;if(!p)break k;s=s+1|0;if((b[G>>0]|0)!=(b[s>>0]|0))break j}}while(0);mcc(j)|0}while(0)}v=1}while(0);if((b[e+11>>0]|0)>=0){u=d;return v|0}YDc(f[e>>2]|0);u=d;return v|0}function ajc(a){a=a|0;YDc(a);return}function bjc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Jic(f[a+4>>2]|0,b,c,d);return}function cjc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Oic(f[a+4>>2]|0,b,c,d);return}function djc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e;h=b[c+11>>0]|0;i=h<<24>>24<0;CSb(g,i?f[c>>2]|0:c,i?f[c+4>>2]|0:h&255,-1);h=Fic(a,g,d)|0;u=e;return h|0}function ejc(a,c){a=a|0;c=c|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;d[g+16>>1]=0;b[g+18>>0]=0;h=Fic(g,a,c)|0;u=e;return h|0}function fjc(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;b=a+24|0;f[b>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a>>2]=0;f[a+4>>2]=0;d[a+8>>1]=0;f[a+28>>2]=a+32;a=VDc(4)|0;f[a>>2]=168220;f[b>>2]=a;return}function gjc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+32|0;j=h;k=g+11|0;if((b[k>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0}else{b[g>>0]=0;b[k>>0]=0}ESb(i,g);g=f[a>>2]|0;f[j>>2]=168288;k=j+4|0;f[k>>2]=i;f[j+8>>2]=0;i=j+12|0;f[i>>2]=0;b[j+16>>0]=1;l=j+17|0;b[l>>0]=0;f[j+20>>2]=g;f[j+24>>2]=g;lic(a,c,_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0,d,e,j);f[j>>2]=168288;if(b[l>>0]|0){u=h;return}l=f[i>>2]|0;if((l|0)<=0){u=h;return}i=f[k>>2]|0;mi[f[(f[i>>2]|0)+12>>2]&2047](i,l);u=h;return}function hjc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;i=h+24|0;f[i>>2]=0;f[h+32>>2]=0;f[h+36>>2]=0;f[h>>2]=0;f[h+4>>2]=0;d[h+8>>1]=0;f[h+28>>2]=h+32;j=VDc(4)|0;f[j>>2]=168220;f[i>>2]=j;gjc(h,a,b,c,e);$hc(h);u=g;return}function ijc(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[220888]|0)==2){d=f[220889]|0;u=a;return d|0}f[c>>2]=161028;f[c+4>>2]=178;b[c+8>>0]=0;DTb(883552,c);ZSb(c);d=f[220889]|0;u=a;return d|0}function jjc(){var a=0;a=VDc(4)|0;f[a>>2]=0;f[220889]=a;iTb(179);return}function kjc(){var a=0;a=f[220889]|0;if(!a)return;if(f[a>>2]|0)ljc(a);YDc(a);return}function ljc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=(f[c+4>>2]|0)-(f[c>>2]|0)>>4;e=c;do{c=d;d=d+-1|0;g=f[e>>2]|0;switch(f[g+(d<<4)+4>>2]|0){case 3:{h=f[g+(d<<4)+8>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}break}case 4:{h=f[g+(d<<4)+8>>2]|0;if(h|0){if(f[h>>2]|0)ljc(h);YDc(h)}break}default:{}}e=f[a>>2]|0}while((c|0)>1);if(!e){f[a>>2]=0;return}d=f[e>>2]|0;if(d|0){c=e+4|0;h=f[c>>2]|0;if((h|0)!=(d|0))f[c>>2]=h+(~((h+-16-d|0)>>>4)<<4);YDc(d)}YDc(e);f[a>>2]=0;return}function mjc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;if(!c)return;d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;if((d|0)<=0)return;d=VDc(12)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[a>>2]=d;e=0;g=d;while(1){d=(f[f[b>>2]>>2]|0)+(e<<4)|0;h=g+4|0;i=f[h>>2]|0;if((i|0)==(f[g+8>>2]|0))njc(g,d);else{f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[h>>2]=(f[h>>2]|0)+16}h=f[(f[a>>2]|0)+4>>2]|0;switch(f[h+-12>>2]|0){case 3:{d=VDc(12)|0;i=h+-8|0;fEc(d,f[i>>2]|0);j=d;k=i;l=10;break}case 4:{i=VDc(4)|0;f[i>>2]=0;d=h+-8|0;mjc(i,f[d>>2]|0);j=i;k=d;l=10;break}default:{}}if((l|0)==10){l=0;f[k>>2]=j}d=e+1|0;if((d|0)>=(c|0))break;e=d;g=f[a>>2]|0}return}function njc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;YDc(d);return}function ojc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;if(!c)return;d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;if((d|0)<=0)return;d=f[a>>2]|0;if(!d){e=VDc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[a>>2]=e;g=0;h=e}else{g=0;h=d}while(1){d=(f[f[b>>2]>>2]|0)+(g<<4)|0;e=h+4|0;i=f[e>>2]|0;if((i|0)==(f[h+8>>2]|0))njc(h,d);else{f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[e>>2]=(f[e>>2]|0)+16}e=f[(f[a>>2]|0)+4>>2]|0;switch(f[e+-12>>2]|0){case 3:{d=VDc(12)|0;i=e+-8|0;fEc(d,f[i>>2]|0);j=d;k=i;l=11;break}case 4:{i=VDc(4)|0;f[i>>2]=0;d=e+-8|0;mjc(i,f[d>>2]|0);j=i;k=d;l=11;break}default:{}}if((l|0)==11){l=0;f[k>>2]=j}d=g+1|0;if((d|0)>=(c|0))break;g=d;h=f[a>>2]|0}return}function pjc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;a:do if((d|0)>0){e=f[a>>2]|0;if(!e){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=0;i=g}else{h=0;i=e}while(1){e=(f[f[b>>2]>>2]|0)+(h<<4)|0;g=i+4|0;j=f[g>>2]|0;if((j|0)==(f[i+8>>2]|0))njc(i,e);else{f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];f[g>>2]=(f[g>>2]|0)+16}g=f[f[b>>2]>>2]|0;switch(f[g+(h<<4)+4>>2]|0){case 3:{f[g+(h<<4)+8>>2]=0;break}case 4:{f[g+(h<<4)+8>>2]=0;break}default:{}}g=h+1|0;if((g|0)>=(c|0))break a;h=g;i=f[a>>2]|0}}while(0);a=f[b>>2]|0;if(!a){f[b>>2]=0;return}i=f[a>>2]|0;if(i|0){h=a+4|0;c=f[h>>2]|0;if((c|0)!=(i|0))f[h>>2]=c+(~((c+-16-i|0)>>>4)<<4);YDc(i)}YDc(a);f[b>>2]=0;return}function qjc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a>>2]|0;if(!b){c=0;return c|0}d=f[b+4>>2]|0;e=f[b>>2]|0;g=d-e|12;if((d|0)==(e|0)){c=g;return c|0}else{h=0;i=g;j=b}while(1){b=f[j>>2]|0;switch(f[b+(h<<4)+4>>2]|0){case 3:{k=i+12+(RQb(f[b+(h<<4)+8>>2]|0)|0)|0;break}case 4:{k=i+4+(qjc(f[b+(h<<4)+8>>2]|0)|0)|0;break}default:k=i}h=h+1|0;j=f[a>>2]|0;if(h>>>0>=(f[j+4>>2]|0)-(f[j>>2]|0)>>4>>>0){c=k;break}else i=k}return c|0}function rjc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;f[g>>2]=b;f[g+4>>2]=0;b=g+8|0;f[b>>2]=c;f[b+4>>2]=d;d=f[a>>2]|0;if(!d){b=VDc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;h=b}else h=d;d=h+4|0;b=f[d>>2]|0;if((b|0)==(f[h+8>>2]|0)){njc(h,g);u=e;return}else{f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[d>>2]=(f[d>>2]|0)+16;u=e;return}}function sjc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=b;f[e+4>>2]=1;f[e+8>>2]=c;c=f[a>>2]|0;if(!c){b=VDc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;g=b}else g=c;c=g+4|0;b=f[c>>2]|0;if((b|0)==(f[g+8>>2]|0)){njc(g,e);u=d;return}else{f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[c>>2]=(f[c>>2]|0)+16;u=d;return}}function tjc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;f[g>>2]=b;f[g+4>>2]=2;b=g+8|0;f[b>>2]=c;f[b+4>>2]=d;d=f[a>>2]|0;if(!d){b=VDc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;h=b}else h=d;d=h+4|0;b=f[d>>2]|0;if((b|0)==(f[h+8>>2]|0)){njc(h,g);u=e;return}else{f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[d>>2]=(f[d>>2]|0)+16;u=e;return}}function ujc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[d>>2]=b;f[d+4>>2]=3;b=VDc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;e=d+8|0;f[e>>2]=b;b=f[a>>2]|0;if(!b){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=g}else h=b;b=h+4|0;g=f[b>>2]|0;if((g|0)==(f[h+8>>2]|0)){njc(h,d);i=f[e>>2]|0;u=c;return i|0}else{f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[b>>2]=(f[b>>2]|0)+16;i=f[e>>2]|0;u=c;return i|0}return 0}function vjc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[d>>2]=b;f[d+4>>2]=4;b=VDc(4)|0;f[b>>2]=0;e=d+8|0;f[e>>2]=b;b=f[a>>2]|0;if(!b){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=g}else h=b;b=h+4|0;g=f[b>>2]|0;if((g|0)==(f[h+8>>2]|0)){njc(h,d);i=f[e>>2]|0;u=c;return i|0}else{f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[b>>2]=(f[b>>2]|0)+16;i=f[e>>2]|0;u=c;return i|0}return 0}function wjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if(f[a>>2]|0)ljc(a);f[e>>2]=0;if(Ejc(c,e)|0?(b[c+24>>0]|0)!=0:0){pjc(a,e);g=1}else g=0;if(!(f[e>>2]|0)){u=d;return g|0}ljc(e);u=d;return g|0}function xjc(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+96|0;h=g+24|0;i=g;CSb(i,c,e,-1);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=i;i=h+12|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d[i+12>>1]=0;f[h+28>>2]=2147483647;f[h+32>>2]=0;f[h+36>>2]=2147483647;i=f[40215]|0;f[h+40>>2]=i;f[h+44>>2]=i;b[h+48>>0]=1;f[h+52>>2]=0;f[h+56>>2]=0;JRb(h)|0;i=wjc(a,h)|0;a=b[h+24>>0]|0;DRb(h);u=g;return i&a<<24>>24!=0|0}function yjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+8>>2]|0;a=d+11|0;e=b[a>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;e=c+8|0;if((f[e>>2]|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else bSb(c,g);g=b[a>>0]|0;if(g<<24>>24<0){p=f[d>>2]|0;q=f[d+4>>2]|0}else{p=d;q=g&255}if(!(b[c+17>>0]|0)){ZRb(c,p,q);return}else{_Rb(c,p,q);return}}function zjc(a){a=a|0;YDc(a);return}function Ajc(a,b,c){a=a|0;b=b|0;c=c|0;return Djc(b,c,f[a+4>>2]|0)|0}function Bjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[a+4>>2]|0;a=c+4|0;e=c+20|0;while(1){g=f[c>>2]|0;if(g>>>0<(f[a>>2]|0)>>>0){h=b[g>>0]|0;i=h&255;if(h<<24>>24>-1){f[c>>2]=g+1;j=i}else{k=i;l=5}}else{k=0;l=5}if((l|0)==5){l=0;j=WRb(c,k)|0}f[e>>2]=j;if((j|0)==0|(j&7|0)==4){m=1;l=8;break}if(!(Djc(c,j,d)|0)){m=0;l=8;break}}if((l|0)==8)return m|0;return 0}function Cjc(a,b,c){a=a|0;b=b|0;c=c|0;rjc(f[a+4>>2]|0,b,c,((c|0)<0)<<31>>31);return}function Djc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;i=c>>>3;if(!i){j=0;u=e;return j|0}switch(c&7){case 0:{c=f[a>>2]|0;if(c>>>0<(f[a+4>>2]|0)>>>0?(k=b[c>>0]|0,k<<24>>24>-1):0){f[a>>2]=c+1;l=k&255;m=0}else{IRb(g,a);k=g;if(!(b[g+8>>0]|0)){j=0;u=e;return j|0}else{l=f[k>>2]|0;m=f[k+4>>2]|0}}if(!d){j=1;u=e;return j|0}rjc(d,i,l,m);j=1;u=e;return j|0}case 1:{m=f[a>>2]|0;if(((f[a+4>>2]|0)-m|0)<=7)if(URb(a,g)|0)n=12;else o=0;else{l=m;k=l;c=l+4|0;l=h[c>>0]|h[c+1>>0]<<8|h[c+2>>0]<<16|h[c+3>>0]<<24;c=g;f[c>>2]=h[k>>0]|h[k+1>>0]<<8|h[k+2>>0]<<16|h[k+3>>0]<<24;f[c+4>>2]=l;f[a>>2]=m+8;n=12}if((n|0)==12)if(!d)o=1;else{m=g;tjc(d,i,f[m>>2]|0,f[m+4>>2]|0);o=1}j=o;u=e;return j|0}case 2:{o=f[a>>2]|0;m=a+4|0;if(o>>>0<(f[m>>2]|0)>>>0){l=b[o>>0]|0;c=l&255;if(l<<24>>24>-1){f[a>>2]=o+1;p=c}else{q=c;n=18}}else{q=0;n=18}if((n|0)==18){c=HRb(a,q)|0;q=J;if((q|0)>-1|(q|0)==-1&c>>>0>4294967295)p=c;else{j=0;u=e;return j|0}}do if(!d){if((p|0)<0){j=0;u=e;return j|0}c=f[a>>2]|0;q=(f[m>>2]|0)-c|0;if((q|0)>=(p|0)){f[a>>2]=c+p;break}if(!(PRb(a,p,q)|0)){j=0;u=e;return j|0}}else if(!(RRb(a,ujc(d,i)|0,p)|0)){j=0;u=e;return j|0}while(0);j=1;u=e;return j|0}case 3:{p=a+40|0;m=f[p>>2]|0;f[p>>2]=m+-1;if((m|0)<=0){j=0;u=e;return j|0}if(!d)r=0;else r=vjc(d,i)|0;m=a+4|0;q=a+20|0;while(1){c=f[a>>2]|0;if(c>>>0<(f[m>>2]|0)>>>0){o=b[c>>0]|0;l=o&255;if(o<<24>>24>-1){f[a>>2]=c+1;s=l}else{t=l;n=33}}else{t=0;n=33}if((n|0)==33){n=0;s=WRb(a,t)|0}f[q>>2]=s;if((s|0)==0|(s&7|0)==4)break;if(!(Djc(a,s,r)|0)){j=0;n=45;break}}if((n|0)==45){u=e;return j|0}r=f[p>>2]|0;if((r|0)<(f[a+44>>2]|0))f[p>>2]=r+1;j=(s|0)==(i<<3|4|0);u=e;return j|0}case 5:{s=f[a>>2]|0;if(((f[a+4>>2]|0)-s|0)<=3)if(TRb(a,g)|0)n=42;else v=0;else{r=s;f[g>>2]=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[a>>2]=s+4;n=42}if((n|0)==42)if(!d)v=1;else{sjc(d,i,f[g>>2]|0);v=1}j=v;u=e;return j|0}default:{j=0;u=e;return j|0}}return 0}function Ejc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=a+20|0;while(1){g=f[a>>2]|0;if(g>>>0<(f[d>>2]|0)>>>0){h=b[g>>0]|0;i=h&255;if(h<<24>>24>-1){f[a>>2]=g+1;j=i}else{k=i;l=5}}else{k=0;l=5}if((l|0)==5){l=0;j=WRb(a,k)|0}f[e>>2]=j;if((j|0)==0|(j&7|0)==4){m=1;l=8;break}if(!(Djc(a,j,c)|0)){m=0;l=8;break}}if((l|0)==8)return m|0;return 0}function Fjc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=f[a>>2]|0;i=a+4|0;if(h>>>0<(f[i>>2]|0)>>>0){j=b[h>>0]|0;k=j&255;if(j<<24>>24>-1){f[a>>2]=h+1;l=k}else{m=k;n=4}}else{m=0;n=4}if((n|0)==4){k=HRb(a,m)|0;m=J;if((m|0)>-1|(m|0)==-1&k>>>0>4294967295)l=k;else{o=0;return o|0}}k=ERb(a,l)|0;a:do if((MRb(a)|0)>0){l=g+4|0;m=g+8|0;if(!d){while(1){h=f[a>>2]|0;if(h>>>0<(f[i>>2]|0)>>>0){j=b[h>>0]|0;p=j&255;if(j<<24>>24>-1){f[a>>2]=h+1;q=p}else{r=p;n=9}}else{r=0;n=9}if((n|0)==9){n=0;p=HRb(a,r)|0;h=J;if((h|0)>-1|(h|0)==-1&p>>>0>4294967295)q=p;else{o=0;break}}p=f[g>>2]|0;if((p|0)==(f[l>>2]|0)){KLa(g,p+1|0);s=f[g>>2]|0}else s=p;p=f[m>>2]|0;f[g>>2]=s+1;f[p+4+(s<<2)>>2]=q;if((MRb(a)|0)<=0)break a}return o|0}while(1){p=f[a>>2]|0;if(p>>>0<(f[i>>2]|0)>>>0){h=b[p>>0]|0;j=h&255;if(h<<24>>24>-1){f[a>>2]=p+1;t=j}else{u=j;n=17}}else{u=0;n=17}if((n|0)==17){n=0;j=HRb(a,u)|0;p=J;if((p|0)>-1|(p|0)==-1&j>>>0>4294967295)t=j;else{o=0;break}}if(_i[d&1023](t)|0){j=f[g>>2]|0;if((j|0)==(f[l>>2]|0)){KLa(g,j+1|0);v=f[g>>2]|0}else v=j;j=f[m>>2]|0;f[g>>2]=v+1;f[j+4+(v<<2)>>2]=t}else rjc(e,c,t,((t|0)<0)<<31>>31);if((MRb(a)|0)<=0)break a}return o|0}while(0);FRb(a,k);o=1;return o|0}function Gjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=c+8|0;e=c+4|0;g=c+17|0;h=0;while(1){i=f[a>>2]|0;if(!i)j=0;else j=(f[i+4>>2]|0)-(f[i>>2]|0)>>4;if((h|0)>=(j|0))break;k=f[i>>2]|0;i=k+(h<<4)|0;a:do switch(f[k+(h<<4)+4>>2]|0){case 0:{l=f[i>>2]<<3;if((f[d>>2]|0)>4){m=f[e>>2]|0;if(l>>>0>127){n=l;o=m;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=m;s=l}b[r>>0]=s;o=r+1-m|0;f[e>>2]=(f[e>>2]|0)+o;n=(f[d>>2]|0)-o|0;f[d>>2]=n;t=n}else{bSb(c,l);t=f[d>>2]|0}n=k+(h<<4)+8|0;o=f[n>>2]|0;p=f[n+4>>2]|0;if((t|0)<=9){cSb(c,o,p);break a}n=f[e>>2]|0;q=o&255;if(p>>>0>0|(p|0)==0&o>>>0>127){u=n;v=q;w=o;o=p;while(1){b[u>>0]=v|-128;p=w;w=aJc(w|0,o|0,7)|0;x=u+1|0;y=w&255;if(!(o>>>0>0|(o|0)==0&p>>>0>16383)){z=x;A=y;break}else{u=x;v=y;o=J}}}else{z=n;A=q}b[z>>0]=A;o=z+1-n|0;f[e>>2]=(f[e>>2]|0)+o;f[d>>2]=(f[d>>2]|0)-o;break}case 1:{o=f[i>>2]<<3|5;if((f[d>>2]|0)>4){v=f[e>>2]|0;if(o>>>0>127){u=o;w=v;while(1){b[w>>0]=u|128;l=u>>>7;m=w+1|0;if(u>>>0>16383){u=l;w=m}else{B=m;C=l;break}}}else{B=v;C=o}b[B>>0]=C;w=B+1-v|0;f[e>>2]=(f[e>>2]|0)+w;f[d>>2]=(f[d>>2]|0)-w}else bSb(c,o);$Rb(c,f[k+(h<<4)+8>>2]|0);break}case 2:{w=f[i>>2]<<3|1;if((f[d>>2]|0)>4){u=f[e>>2]|0;if(w>>>0>127){n=w;q=u;while(1){b[q>>0]=n|128;l=n>>>7;m=q+1|0;if(n>>>0>16383){n=l;q=m}else{D=m;E=l;break}}}else{D=u;E=w}b[D>>0]=E;q=D+1-u|0;f[e>>2]=(f[e>>2]|0)+q;f[d>>2]=(f[d>>2]|0)-q}else bSb(c,w);q=k+(h<<4)+8|0;aSb(c,f[q>>2]|0,f[q+4>>2]|0);break}case 3:{q=f[i>>2]<<3|2;if((f[d>>2]|0)>4){n=f[e>>2]|0;if(q>>>0>127){o=q;v=n;while(1){b[v>>0]=o|128;l=o>>>7;m=v+1|0;if(o>>>0>16383){o=l;v=m}else{F=m;G=l;break}}}else{F=n;G=q}b[F>>0]=G;v=F+1-n|0;f[e>>2]=(f[e>>2]|0)+v;f[d>>2]=(f[d>>2]|0)-v}else bSb(c,q);v=k+(h<<4)+8|0;o=f[v>>2]|0;w=b[o+11>>0]|0;if(w<<24>>24<0)H=f[o+4>>2]|0;else H=w&255;if((f[d>>2]|0)>4){w=f[e>>2]|0;if(H>>>0>127){o=H;u=w;while(1){b[u>>0]=o|128;l=o>>>7;m=u+1|0;if(o>>>0>16383){o=l;u=m}else{I=m;K=l;break}}}else{I=w;K=H}b[I>>0]=K;u=I+1-w|0;f[e>>2]=(f[e>>2]|0)+u;f[d>>2]=(f[d>>2]|0)-u}else bSb(c,H);u=f[v>>2]|0;o=b[u+11>>0]|0;if(o<<24>>24<0){L=f[u>>2]|0;M=f[u+4>>2]|0}else{L=u;M=o&255}if(!(b[g>>0]|0)){ZRb(c,L,M);break a}else{_Rb(c,L,M);break a}break}case 4:{o=f[i>>2]<<3|3;if((f[d>>2]|0)>4){u=f[e>>2]|0;if(o>>>0>127){q=o;n=u;while(1){b[n>>0]=q|128;l=q>>>7;m=n+1|0;if(q>>>0>16383){q=l;n=m}else{N=m;O=l;break}}}else{N=u;O=o}b[N>>0]=O;n=N+1-u|0;f[e>>2]=(f[e>>2]|0)+n;f[d>>2]=(f[d>>2]|0)-n}else bSb(c,o);Gjc(f[k+(h<<4)+8>>2]|0,c);n=f[i>>2]<<3|4;if((f[d>>2]|0)<=4){bSb(c,n);break a}q=f[e>>2]|0;if(n>>>0>127){v=n;w=q;while(1){b[w>>0]=v|128;l=v>>>7;m=w+1|0;if(v>>>0>16383){v=l;w=m}else{P=m;Q=l;break}}}else{P=q;Q=n}b[P>>0]=Q;w=P+1-q|0;f[e>>2]=(f[e>>2]|0)+w;f[d>>2]=(f[d>>2]|0)-w;break}default:{}}while(0);h=h+1|0}return}function Hjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=c;c=0;while(1){e=f[a>>2]|0;if(!e)g=0;else g=(f[e+4>>2]|0)-(f[e>>2]|0)>>4;if((c|0)>=(g|0))break;h=f[e>>2]|0;e=h+(c<<4)|0;switch(f[h+(c<<4)+4>>2]|0){case 0:{i=h+(c<<4)+8|0;j=f[i>>2]|0;k=f[i+4>>2]|0;i=f[e>>2]<<3;if(i>>>0>127){l=i;m=d;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=d;q=i}b[p>>0]=q;m=p+1|0;l=j&255;if(k>>>0>0|(k|0)==0&j>>>0>127){n=m;o=l;r=j;s=k;while(1){b[n>>0]=o|-128;t=r;r=aJc(r|0,s|0,7)|0;u=n+1|0;v=r&255;if(!(s>>>0>0|(s|0)==0&t>>>0>16383)){w=u;x=v;break}else{n=u;o=v;s=J}}}else{w=m;x=l}b[w>>0]=x;y=w+1|0;break}case 1:{s=f[h+(c<<4)+8>>2]|0;o=f[e>>2]<<3|5;if(o>>>0>127){n=o;r=d;while(1){b[r>>0]=n|128;k=n>>>7;j=r+1|0;if(n>>>0>16383){n=k;r=j}else{z=j;A=k;break}}}else{z=d;A=o}b[z>>0]=A;r=z+1|0;b[r>>0]=s;b[r+1>>0]=s>>8;b[r+2>>0]=s>>16;b[r+3>>0]=s>>24;y=z+5|0;break}case 2:{r=h+(c<<4)+8|0;n=f[r>>2]|0;l=f[r+4>>2]|0;r=f[e>>2]<<3|1;if(r>>>0>127){m=r;k=d;while(1){b[k>>0]=m|128;j=m>>>7;i=k+1|0;if(m>>>0>16383){m=j;k=i}else{B=i;C=j;break}}}else{B=d;C=r}b[B>>0]=C;k=B+1|0;m=k;b[m>>0]=n;b[m+1>>0]=n>>8;b[m+2>>0]=n>>16;b[m+3>>0]=n>>24;m=k+4|0;b[m>>0]=l;b[m+1>>0]=l>>8;b[m+2>>0]=l>>16;b[m+3>>0]=l>>24;y=B+9|0;break}case 3:{m=f[h+(c<<4)+8>>2]|0;k=f[e>>2]<<3|2;if(k>>>0>127){s=k;o=d;while(1){b[o>>0]=s|128;j=s>>>7;i=o+1|0;if(s>>>0>16383){s=j;o=i}else{D=i;E=j;break}}}else{D=d;E=k}b[D>>0]=E;y=dSb(m,D+1|0)|0;break}case 4:{o=f[e>>2]<<3|3;if(o>>>0>127){s=o;l=d;while(1){b[l>>0]=s|128;n=s>>>7;r=l+1|0;if(s>>>0>16383){s=n;l=r}else{F=r;G=n;break}}}else{F=d;G=o}b[F>>0]=G;l=Hjc(f[h+(c<<4)+8>>2]|0,F+1|0)|0;s=f[e>>2]<<3|4;if(s>>>0>127){m=s;k=l;while(1){b[k>>0]=m|128;n=m>>>7;r=k+1|0;if(m>>>0>16383){m=n;k=r}else{H=r;I=n;break}}}else{H=l;I=s}b[H>>0]=I;y=H+1|0;break}default:y=d}d=y;c=c+1|0}return d|0}function Ijc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+8|0;e=c+4|0;g=0;while(1){h=f[a>>2]|0;if(!h)i=0;else i=(f[h+4>>2]|0)-(f[h>>2]|0)>>4;if((g|0)>=(i|0))break;j=f[h>>2]|0;h=j+(g<<4)|0;do if((f[j+(g<<4)+4>>2]|0)==3){if((f[d>>2]|0)>4){b[f[e>>2]>>0]=11;f[e>>2]=(f[e>>2]|0)+1;k=(f[d>>2]|0)+-1|0;f[d>>2]=k;l=k}else{bSb(c,11);l=f[d>>2]|0}if((l|0)>4){b[f[e>>2]>>0]=16;f[e>>2]=(f[e>>2]|0)+1;k=(f[d>>2]|0)+-1|0;f[d>>2]=k;m=k}else{bSb(c,16);m=f[d>>2]|0}k=f[h>>2]|0;if((m|0)>4){n=f[e>>2]|0;if(k>>>0>127){o=k;p=n;while(1){b[p>>0]=o|128;q=o>>>7;r=p+1|0;if(o>>>0>16383){o=q;p=r}else{s=r;t=q;break}}}else{s=n;t=k}b[s>>0]=t;p=s+1-n|0;f[e>>2]=(f[e>>2]|0)+p;o=(f[d>>2]|0)-p|0;f[d>>2]=o;u=o}else{bSb(c,k);u=f[d>>2]|0}if((u|0)>4){b[f[e>>2]>>0]=26;f[e>>2]=(f[e>>2]|0)+1;f[d>>2]=(f[d>>2]|0)+-1}else bSb(c,26);yjc(h,c);if((f[d>>2]|0)>4){b[f[e>>2]>>0]=12;f[e>>2]=(f[e>>2]|0)+1;f[d>>2]=(f[d>>2]|0)+-1;break}else{bSb(c,12);break}}while(0);g=g+1|0}return}function Jjc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a>>2]|0;a=(c|0)==0;d=c+4|0;e=0;g=0;while(1){if(a)h=0;else h=(f[d>>2]|0)-(f[c>>2]|0)>>4;if((g|0)>=(h|0))break;i=f[c>>2]|0;j=i+(g<<4)|0;switch(f[i+(g<<4)+4>>2]|0){case 0:{k=((((($(f[j>>2]<<3|1|0)|0)^31)*9|0)+73|0)>>>6)+e|0;l=i+(g<<4)+8|0;m=k+(((((iJc(f[l>>2]|1|0,f[l+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)|0;break}case 1:{m=e+4+((((($(f[j>>2]<<3|5|0)|0)^31)*9|0)+73|0)>>>6)|0;break}case 2:{m=e+8+((((($(f[j>>2]<<3|1|0)|0)^31)*9|0)+73|0)>>>6)|0;break}case 3:{l=((((($(f[j>>2]<<3|3|0)|0)^31)*9|0)+73|0)>>>6)+e|0;k=f[i+(g<<4)+8>>2]|0;n=b[k+11>>0]|0;o=n<<24>>24<0;if(o)p=f[k+4>>2]|0;else p=n&255;q=l+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(o)r=f[k+4>>2]|0;else r=n&255;m=q+r|0;break}case 4:{q=f[j>>2]<<3;m=((((($(q|3|0)|0)^31)*9|0)+73|0)>>>6)+((Jjc(f[i+(g<<4)+8>>2]|0)|0)+e)+((((($(q|5|0)|0)^31)*9|0)+73|0)>>>6)|0;break}default:m=e}e=m;g=g+1|0}return e|0}function Kjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);g=f[e>>2]|0;e=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;h=a+4|0;i=a+20|0;j=g+16|0;k=a+52|0;if(!g){l=0;while(1){m=f[a>>2]|0;if(m>>>0<(f[h>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>-1){f[a>>2]=m+1;p=o}else{q=o;r=4}}else{q=0;r=4}if((r|0)==4){r=0;p=WRb(a,q)|0}f[i>>2]=p;if((p|0)==0|(p&7|0)==4){s=1;r=23;break}o=Ljc(p,0,c,a)|0;m=l&o;if(o)l=m;else{s=m;r=23;break}}if((r|0)==23){u=d;return s|0}}else t=0;a:while(1){l=f[a>>2]|0;if(l>>>0<(f[h>>2]|0)>>>0){p=b[l>>0]|0;q=p&255;if(p<<24>>24>-1){f[a>>2]=l+1;v=q}else{w=q;r=11}}else{w=0;r=11}if((r|0)==11){r=0;v=WRb(a,w)|0}f[i>>2]=v;if((v|0)==0|(v&7|0)==4){s=1;r=23;break}q=v>>>3;l=qYb(g,q)|0;do if(!l){if(zYb(g,q)|0){p=f[k>>2]|0;if(!p)x=Mi[f[(f[e>>2]|0)+312>>2]&1023](e,q)|0;else x=oYb(p,g,q)|0;if(x|0){y=x;r=21;break}}if((v|0)==11?(b[(f[j>>2]|0)+48>>0]|0)!=0:0){p=Mjc(a,c)|0;z=p?2:1;A=p}else{y=0;r=21}}else{y=l;r=21}while(0);if((r|0)==21){r=0;l=Ljc(v,y,c,a)|0;z=(l^1)&1;A=l}l=t&A;switch(z&3){case 2:case 0:{t=l;break}default:{s=l;r=23;break a}}}if((r|0)==23){u=d;return s|0}return 0}function Ljc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;g=u;u=u+16|0;i=g;j=_i[f[(f[d>>2]|0)+92>>2]&1023](d)|0;do if(c|0){k=a&7;l=c+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=c;DTb(m,i)}m=c+28|0;if((k|0)!=(f[161140+(f[m>>2]<<2)>>2]|0)){if((f[c+32>>2]|0)!=3)break;o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=c;DTb(o,i)}if(!((k|0)==2?((f[m>>2]|0)+-9|0)>>>0>3:0))break;k=f[e>>2]|0;o=e+4|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;r=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;t=r}else{v=r;w=15}}else{v=0;w=15}if((w|0)==15){r=HRb(e,v)|0;k=J;if((k|0)>-1|(k|0)==-1&r>>>0>4294967295)t=r;else{x=0;u=g;return x|0}}r=ERb(e,t)|0;k=f[l>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=c;DTb(k,i)}a:do switch(f[m>>2]|0){case 5:{if((MRb(e)|0)>0){while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;y=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;z=y}else{A=y;w=51}}else{A=0;w=51}if((w|0)==51){w=0;y=HRb(e,A)|0;k=J;if((k|0)>-1|(k|0)==-1&y>>>0>4294967295)z=y;else{x=0;break}}ei[f[(f[j>>2]|0)+260>>2]&511](j,d,c,z);if((MRb(e)|0)<=0)break a}u=g;return x|0}break}case 3:{if((MRb(e)|0)>0){y=i+8|0;while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0?(q=b[k>>0]|0,q<<24>>24>-1):0){f[e>>2]=k+1;B=q&255;C=0}else{IRb(i,e);q=i;if(!(b[y>>0]|0)){x=0;break}else{B=f[q>>2]|0;C=f[q+4>>2]|0}}gi[f[(f[j>>2]|0)+264>>2]&255](j,d,c,B,C);if((MRb(e)|0)<=0)break a}u=g;return x|0}break}case 17:{if((MRb(e)|0)>0){while(1){y=f[e>>2]|0;if(y>>>0<(f[o>>2]|0)>>>0){q=b[y>>0]|0;k=q&255;if(q<<24>>24>-1){f[e>>2]=y+1;D=k>>>1^0-(k&1)}else{E=k;w=61}}else{E=0;w=61}if((w|0)==61){w=0;k=HRb(e,E)|0;y=J;if((y|0)>-1|(y|0)==-1&k>>>0>4294967295)D=k>>>1^0-(k&1);else{x=0;break}}ei[f[(f[j>>2]|0)+260>>2]&511](j,d,c,D);if((MRb(e)|0)<=0)break a}u=g;return x|0}break}case 18:{if((MRb(e)|0)>0){k=i+8|0;while(1){y=f[e>>2]|0;if(y>>>0<(f[o>>2]|0)>>>0?(q=b[y>>0]|0,q<<24>>24>-1):0){F=q&255;f[e>>2]=y+1;y=aJc(F|0,0,1)|0;q=J;G=TIc(0,0,F&1|0,0)|0;H=y^G;I=q^J}else{IRb(i,e);q=i;G=f[q>>2]|0;y=(b[k>>0]|0)==0;F=aJc(G|0,f[q+4>>2]|0,1)|0;q=J;K=TIc(0,0,G&1|0,0)|0;if(y){x=0;break}else{H=F^K;I=q^J}}gi[f[(f[j>>2]|0)+264>>2]&255](j,d,c,H,I);if((MRb(e)|0)<=0)break a}u=g;return x|0}break}case 13:{if((MRb(e)|0)>0){while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;K=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;L=K}else{M=K;w=71}}else{M=0;w=71}if((w|0)==71){w=0;K=HRb(e,M)|0;k=J;if((k|0)>-1|(k|0)==-1&K>>>0>4294967295)L=K;else{x=0;break}}ei[f[(f[j>>2]|0)+268>>2]&511](j,d,c,L);if((MRb(e)|0)<=0)break a}u=g;return x|0}break}case 4:{if((MRb(e)|0)>0){K=i+8|0;while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0?(q=b[k>>0]|0,q<<24>>24>-1):0){f[e>>2]=k+1;N=q&255;O=0}else{IRb(i,e);q=i;if(!(b[K>>0]|0)){x=0;break}else{N=f[q>>2]|0;O=f[q+4>>2]|0}}gi[f[(f[j>>2]|0)+272>>2]&255](j,d,c,N,O);if((MRb(e)|0)<=0)break a}u=g;return x|0}break}case 7:{if((MRb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){q=K;k=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;P=k}else{if(!(TRb(e,i)|0))break;P=f[i>>2]|0}ei[f[(f[j>>2]|0)+268>>2]&511](j,d,c,P);if((MRb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 6:{if((MRb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;q=K;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=K+4|0;K=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=i;f[q>>2]=F;f[q+4>>2]=K;f[e>>2]=k+8;Q=F;R=K}else{if(!(URb(e,i)|0))break;K=i;Q=f[K>>2]|0;R=f[K+4>>2]|0}gi[f[(f[j>>2]|0)+272>>2]&255](j,d,c,Q,R);if((MRb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 15:{if((MRb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){F=K;k=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;S=k}else{if(!(TRb(e,i)|0))break;S=f[i>>2]|0}ei[f[(f[j>>2]|0)+260>>2]&511](j,d,c,S);if((MRb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 16:{if((MRb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;F=K;q=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=K+4|0;K=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=i;f[F>>2]=q;f[F+4>>2]=K;f[e>>2]=k+8;T=q;U=K}else{if(!(URb(e,i)|0))break;K=i;T=f[K>>2]|0;U=f[K+4>>2]|0}gi[f[(f[j>>2]|0)+264>>2]&255](j,d,c,T,U);if((MRb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 2:{if((MRb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){q=K;k=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;V=k}else{if(!(TRb(e,i)|0))break;V=f[i>>2]|0}$h[f[(f[j>>2]|0)+276>>2]&63](j,d,c,(f[s>>2]=V,+n[s>>2]));if((MRb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 1:{if((MRb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;q=K;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=K+4|0;K=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=i;f[q>>2]=F;f[q+4>>2]=K;f[e>>2]=k+8;f[s>>2]=F;f[s+4>>2]=K;W=+p[s>>3]}else{if(!(URb(e,i)|0))break;W=+p[i>>3]}$h[f[(f[j>>2]|0)+280>>2]&63](j,d,c,W);if((MRb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 8:{if((MRb(e)|0)>0){K=i+8|0;while(1){F=f[e>>2]|0;if(F>>>0<(f[o>>2]|0)>>>0?(k=b[F>>0]|0,k<<24>>24>-1):0){f[e>>2]=F+1;X=k<<24>>24!=0}else{IRb(i,e);k=i;if(!(b[K>>0]|0)){x=0;break}else X=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0}ei[f[(f[j>>2]|0)+284>>2]&511](j,d,c,X);if((MRb(e)|0)<=0)break a}u=g;return x|0}break}case 14:{if((MRb(e)|0)>0){K=a>>>3;while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0){F=b[k>>0]|0;q=F&255;if(F<<24>>24>-1){f[e>>2]=k+1;Y=q}else{Z=q;w=122}}else{Z=0;w=122}if((w|0)==122){w=0;q=HRb(e,Z)|0;k=J;if((k|0)>-1|(k|0)==-1&q>>>0>4294967295)Y=q;else{x=0;break}}mi[f[(f[d>>2]|0)+96>>2]&2047](i,d);do if((f[(f[(f[i>>2]|0)+8>>2]|0)+44>>2]|0)!=3){q=wYb(EYb(c)|0,Y)|0;if(!q){rjc(Mi[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0,K,Y,((Y|0)<0)<<31>>31);break}else{ei[f[(f[j>>2]|0)+292>>2]&511](j,d,c,q);break}}else ei[f[(f[j>>2]|0)+296>>2]&511](j,d,c,Y);while(0);if((MRb(e)|0)<=0)break a}u=g;return x|0}break}case 12:case 11:case 10:case 9:{x=0;u=g;return x|0}default:{}}while(0);FRb(e,r);x=1;u=g;return x|0}o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=c;DTb(o,i)}do switch(f[m>>2]|0){case 5:{o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0){K=b[o>>0]|0;q=K&255;if(K<<24>>24>-1){f[e>>2]=o+1;_=q}else{$=q;w=137}}else{$=0;w=137}if((w|0)==137){q=HRb(e,$)|0;o=J;if((o|0)>-1|(o|0)==-1&q>>>0>4294967295)_=q;else{x=0;u=g;return x|0}}q=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[q+260>>2]&511](j,d,c,_);x=1;u=g;return x|0}else{ei[f[q+116>>2]&511](j,d,c,_);x=1;u=g;return x|0}break}case 3:{q=f[e>>2]|0;if(q>>>0<(f[e+4>>2]|0)>>>0?(o=b[q>>0]|0,o<<24>>24>-1):0){f[e>>2]=q+1;aa=o&255;ba=0}else{IRb(i,e);o=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else{aa=f[o>>2]|0;ba=f[o+4>>2]|0}}o=f[j>>2]|0;if((f[c+32>>2]|0)==3){gi[f[o+264>>2]&255](j,d,c,aa,ba);x=1;u=g;return x|0}else{gi[f[o+120>>2]&255](j,d,c,aa,ba);x=1;u=g;return x|0}break}case 17:{o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0){q=b[o>>0]|0;K=q&255;if(q<<24>>24>-1){f[e>>2]=o+1;ca=K>>>1^0-(K&1)}else{da=K;w=151}}else{da=0;w=151}if((w|0)==151){K=HRb(e,da)|0;o=J;if((o|0)>-1|(o|0)==-1&K>>>0>4294967295)ca=K>>>1^0-(K&1);else{x=0;u=g;return x|0}}K=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[K+260>>2]&511](j,d,c,ca);x=1;u=g;return x|0}else{ei[f[K+116>>2]&511](j,d,c,ca);x=1;u=g;return x|0}break}case 18:{K=f[e>>2]|0;if(K>>>0<(f[e+4>>2]|0)>>>0?(o=b[K>>0]|0,o<<24>>24>-1):0){q=o&255;f[e>>2]=K+1;K=aJc(q|0,0,1)|0;o=J;k=TIc(0,0,q&1|0,0)|0;ea=K^k;fa=o^J}else{IRb(i,e);o=i;k=f[o>>2]|0;K=(b[i+8>>0]|0)==0;q=aJc(k|0,f[o+4>>2]|0,1)|0;o=J;F=TIc(0,0,k&1|0,0)|0;k=o^J;if(K){x=0;u=g;return x|0}else{ea=q^F;fa=k}}k=f[j>>2]|0;if((f[c+32>>2]|0)==3){gi[f[k+264>>2]&255](j,d,c,ea,fa);x=1;u=g;return x|0}else{gi[f[k+120>>2]&255](j,d,c,ea,fa);x=1;u=g;return x|0}break}case 13:{k=f[e>>2]|0;if(k>>>0<(f[e+4>>2]|0)>>>0){F=b[k>>0]|0;q=F&255;if(F<<24>>24>-1){f[e>>2]=k+1;ga=q}else{ha=q;w=165}}else{ha=0;w=165}if((w|0)==165){q=HRb(e,ha)|0;k=J;if((k|0)>-1|(k|0)==-1&q>>>0>4294967295)ga=q;else{x=0;u=g;return x|0}}q=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[q+268>>2]&511](j,d,c,ga);x=1;u=g;return x|0}else{ei[f[q+124>>2]&511](j,d,c,ga);x=1;u=g;return x|0}break}case 4:{q=f[e>>2]|0;if(q>>>0<(f[e+4>>2]|0)>>>0?(k=b[q>>0]|0,k<<24>>24>-1):0){f[e>>2]=q+1;ia=k&255;ja=0}else{IRb(i,e);k=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else{ia=f[k>>2]|0;ja=f[k+4>>2]|0}}k=f[j>>2]|0;if((f[c+32>>2]|0)==3){gi[f[k+272>>2]&255](j,d,c,ia,ja);x=1;u=g;return x|0}else{gi[f[k+128>>2]&255](j,d,c,ia,ja);x=1;u=g;return x|0}break}case 7:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>3){q=k;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[i>>2]=F;f[e>>2]=k+4;ka=F}else{if(TRb(e,i)|0){ka=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3)ei[f[k+268>>2]&511](j,d,c,ka);else ei[f[k+124>>2]&511](j,d,c,ka);x=1;u=g;return x|0}case 6:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>7){F=k;q=F;K=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=F+4|0;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=i;f[q>>2]=K;f[q+4>>2]=F;f[e>>2]=k+8;la=K;ma=F}else{if(URb(e,i)|0){F=i;la=f[F>>2]|0;ma=f[F+4>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3)gi[f[k+272>>2]&255](j,d,c,la,ma);else gi[f[k+128>>2]&255](j,d,c,la,ma);x=1;u=g;return x|0}case 15:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>3){F=k;K=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;f[i>>2]=K;f[e>>2]=k+4;na=K}else{if(TRb(e,i)|0){na=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[k+260>>2]&511](j,d,c,na);x=1;u=g;return x|0}else{ei[f[k+116>>2]&511](j,d,c,na);x=1;u=g;return x|0}break}case 16:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>7){K=k;F=K;q=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=K+4|0;K=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=i;f[F>>2]=q;f[F+4>>2]=K;f[e>>2]=k+8;oa=q;pa=K}else{if(URb(e,i)|0){K=i;oa=f[K>>2]|0;pa=f[K+4>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3){gi[f[k+264>>2]&255](j,d,c,oa,pa);x=1;u=g;return x|0}else{gi[f[k+120>>2]&255](j,d,c,oa,pa);x=1;u=g;return x|0}break}case 2:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>3){K=k;q=h[K>>0]|h[K+1>>0]<<8|h[K+2>>0]<<16|h[K+3>>0]<<24;f[i>>2]=q;f[e>>2]=k+4;qa=q}else{if(TRb(e,i)|0){qa=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;ra=(f[s>>2]=qa,+n[s>>2]);if((f[c+32>>2]|0)==3){$h[f[k+276>>2]&63](j,d,c,ra);x=1;u=g;return x|0}else{$h[f[k+132>>2]&63](j,d,c,ra);x=1;u=g;return x|0}break}case 1:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>7){q=k;K=q;F=h[K>>0]|h[K+1>>0]<<8|h[K+2>>0]<<16|h[K+3>>0]<<24;K=q+4|0;q=h[K>>0]|h[K+1>>0]<<8|h[K+2>>0]<<16|h[K+3>>0]<<24;K=i;f[K>>2]=F;f[K+4>>2]=q;f[e>>2]=k+8;f[s>>2]=F;f[s+4>>2]=q;sa=+p[s>>3]}else{if(URb(e,i)|0){sa=+p[i>>3];break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3){$h[f[k+280>>2]&63](j,d,c,sa);x=1;u=g;return x|0}else{$h[f[k+136>>2]&63](j,d,c,sa);x=1;u=g;return x|0}break}case 8:{k=f[e>>2]|0;if(k>>>0<(f[e+4>>2]|0)>>>0?(q=b[k>>0]|0,q<<24>>24>-1):0){f[e>>2]=k+1;ta=q<<24>>24!=0}else{IRb(i,e);q=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else ta=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0}q=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[q+284>>2]&511](j,d,c,ta);x=1;u=g;return x|0}else{ei[f[q+140>>2]&511](j,d,c,ta);x=1;u=g;return x|0}break}case 14:{q=f[e>>2]|0;if(q>>>0<(f[e+4>>2]|0)>>>0){k=b[q>>0]|0;F=k&255;if(k<<24>>24>-1){f[e>>2]=q+1;ua=F}else{va=F;w=230}}else{va=0;w=230}if((w|0)==230){F=HRb(e,va)|0;q=J;if((q|0)>-1|(q|0)==-1&F>>>0>4294967295)ua=F;else{x=0;u=g;return x|0}}mi[f[(f[d>>2]|0)+96>>2]&2047](i,d);if((f[(f[(f[i>>2]|0)+8>>2]|0)+44>>2]|0)==3){F=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[F+296>>2]&511](j,d,c,ua);x=1;u=g;return x|0}else{ei[f[F+152>>2]&511](j,d,c,ua);x=1;u=g;return x|0}}F=wYb(EYb(c)|0,ua)|0;if(!F){rjc(Mi[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0,a>>>3,ua,((ua|0)<0)<<31>>31);x=1;u=g;return x|0}q=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[q+292>>2]&511](j,d,c,F);x=1;u=g;return x|0}else{ei[f[q+148>>2]&511](j,d,c,F);x=1;u=g;return x|0}break}case 9:{F=(f[(f[c+20>>2]|0)+44>>2]|0)==3;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=fUb(e,i)|0;k=i+11|0;K=b[k>>0]|0;o=K<<24>>24<0;if(!q){if(o)YDc(f[i>>2]|0);x=0;u=g;return x|0}q=f[c+4>>2]|0;if((b[q+11>>0]|0)<0)wa=f[q>>2]|0;else wa=q;if(F?!(gUb(o?f[i>>2]|0:i,o?f[i+4>>2]|0:K&255,0,wa)|0):0){if((b[k>>0]|0)<0)YDc(f[i>>2]|0);x=0;u=g;return x|0}K=f[j>>2]|0;if((f[c+32>>2]|0)==3)ei[f[K+288>>2]&511](j,d,c,i);else ei[f[K+144>>2]&511](j,d,c,i);if((b[k>>0]|0)<0)YDc(f[i>>2]|0);x=1;u=g;return x|0}case 12:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(!(fUb(e,i)|0)){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);x=0;u=g;return x|0}k=f[j>>2]|0;if((f[c+32>>2]|0)==3)ei[f[k+288>>2]&511](j,d,c,i);else ei[f[k+144>>2]&511](j,d,c,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);x=1;u=g;return x|0}case 10:{k=f[j>>2]|0;K=f[e+56>>2]|0;if((f[c+32>>2]|0)==3)xa=hh[f[k+300>>2]&127](j,d,c,K)|0;else xa=hh[f[k+156>>2]&127](j,d,c,K)|0;K=a&-8;k=e+40|0;o=f[k>>2]|0;f[k>>2]=o+-1;if((o|0)>0?Mi[f[(f[xa>>2]|0)+44>>2]&1023](xa,e)|0:0){o=f[k>>2]|0;if((o|0)<(f[e+44>>2]|0))f[k>>2]=o+1;if((f[e+20>>2]|0)==(K|4|0)){x=1;u=g;return x|0}}x=0;u=g;return x|0}case 11:{K=f[j>>2]|0;o=f[e+56>>2]|0;if((f[c+32>>2]|0)==3)ya=hh[f[K+300>>2]&127](j,d,c,o)|0;else ya=hh[f[K+156>>2]&127](j,d,c,o)|0;o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0?(K=b[o>>0]|0,K<<24>>24>-1):0){f[e>>2]=o+1;za=K&255;w=275}else w=274;if((w|0)==274?(K=VRb(e)|0,(K|0)>-1):0){za=K;w=275}do if(((w|0)==275?(GRb(i,e,za),(f[i+4>>2]|0)>=0):0)?Mi[f[(f[ya>>2]|0)+44>>2]&1023](ya,e)|0:0){if(LRb(e,f[i>>2]|0)|0)x=1;else break;u=g;return x|0}while(0);x=0;u=g;return x|0}default:{x=1;u=g;return x|0}}while(0)}while(0);x=Djc(e,a,Mi[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0)|0;u=g;return x|0}function Mjc(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=u;u=u+128|0;g=e+104|0;h=e+80|0;i=e+20|0;j=e;k=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=a+4|0;m=a+20|0;n=j+8|0;o=j+4|0;p=h+11|0;q=h+4|0;r=g+11|0;s=g+4|0;t=i+4|0;v=i+8|0;w=i+12|0;x=i+28|0;y=i+32|0;z=i+36|0;A=i+40|0;B=i+44|0;C=i+48|0;D=i+52|0;E=i+56|0;F=0;G=0;a:while(1){H=(G|0)==0;b:while(1){if(!H){I=10;break}c:while(1){K=f[a>>2]|0;if(K>>>0<(f[l>>2]|0)>>>0){L=b[K>>0]|0;M=L&255;if(L<<24>>24>-1){f[a>>2]=K+1;N=M}else{O=M;I=6}}else{O=0;I=6}if((I|0)==6){I=0;N=WRb(a,O)|0}f[m>>2]=N;switch(N|0){case 12:{P=1;break a;break}case 0:{I=41;break a;break}case 16:{break b;break}case 26:{break c;break}default:{}}if(!(Djc(a,N,0)|0)){I=41;break a}}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=f[a>>2]|0;if(M>>>0<(f[l>>2]|0)>>>0){K=b[M>>0]|0;L=K&255;if(K<<24>>24>-1){f[a>>2]=M+1;Q=L;I=29}else{R=L;I=28}}else{R=0;I=28}if((I|0)==28){I=0;L=HRb(a,R)|0;M=J;if((M|0)>-1|(M|0)==-1&L>>>0>4294967295){Q=L;I=29}else S=1}if((I|0)==29){I=0;if(RRb(a,h,Q)|0){ESb(i,g);XRb(j,i);if((f[n>>2]|0)>4){L=f[o>>2]|0;if(Q>>>0>127){M=Q;K=L;while(1){b[K>>0]=M|128;T=M>>>7;U=K+1|0;if(M>>>0>16383){M=T;K=U}else{V=U;W=T;break}}}else{V=L;W=Q}b[V>>0]=W;K=V+1-L|0;f[o>>2]=(f[o>>2]|0)+K;f[n>>2]=(f[n>>2]|0)-K}else bSb(j,Q);K=b[p>>0]|0;M=K<<24>>24<0;ZRb(j,M?f[h>>2]|0:h,M?f[q>>2]|0:K&255);YRb(j);S=0}else S=1}if((b[p>>0]|0)<0)YDc(f[h>>2]|0);if(S|0){P=0;break a}}d:do if((I|0)==10)e:while(1){I=0;H=f[a>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){K=b[H>>0]|0;M=K&255;if(K<<24>>24>-1){f[a>>2]=H+1;X=M}else{Y=M;I=13}}else{Y=0;I=13}if((I|0)==13){I=0;X=WRb(a,Y)|0}f[m>>2]=X;switch(X|0){case 12:{P=1;break a;break}case 0:{I=42;break a;break}case 16:{break d;break}case 26:{if(Njc(G,F,c,a)|0){I=10;continue e}else{I=42;break a}break}default:if(Djc(a,X,0)|0){I=10;continue e}else{I=42;break a}}}while(0);L=f[a>>2]|0;if(L>>>0<(f[l>>2]|0)>>>0){M=b[L>>0]|0;H=M&255;if(M<<24>>24>-1){f[a>>2]=L+1;Z=H}else{_=H;I=18}}else{_=0;I=18}if((I|0)==18){I=0;H=HRb(a,_)|0;L=J;if((L|0)>-1|(L|0)==-1&H>>>0>4294967295)Z=H;else{P=0;break}}H=F;F=Mi[f[(f[k>>2]|0)+312>>2]&1023](k,Z)|0;H=b[r>>0]|0;L=H<<24>>24<0;M=f[s>>2]|0;K=H&255;if(!((L?M:K)|0)){F=F;G=Z;continue}CSb(h,L?f[g>>2]|0:g,L?M:K,-1);f[i>>2]=0;f[t>>2]=0;f[v>>2]=h;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;d[w+12>>1]=0;f[x>>2]=2147483647;f[y>>2]=0;f[z>>2]=2147483647;K=f[40215]|0;f[A>>2]=K;f[B>>2]=K;b[C>>0]=1;f[D>>2]=0;f[E>>2]=0;JRb(i)|0;do if(Njc(Z,F,c,i)|0)if((b[r>>0]|0)<0){b[f[g>>2]>>0]=0;f[s>>2]=0;$=0;break}else{b[g>>0]=0;b[r>>0]=0;$=0;break}else $=1;while(0);DRb(i);if($|0){P=0;break}else G=Z}if((I|0)==41)P=0;else if((I|0)==42)P=0;if((b[r>>0]|0)>=0){u=e;return P|0}YDc(f[g>>2]|0);u=e;return P|0}function Njc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;k=_i[f[(f[d>>2]|0)+92>>2]&1023](d)|0;if(!c){l=Mi[f[(f[k>>2]|0)+12>>2]&1023](k,d)|0;m=f[e>>2]|0;if(m>>>0<(f[e+4>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>-1){f[e>>2]=m+1;p=o}else{q=o;r=5}}else{q=0;r=5}if((r|0)==5){r=HRb(e,q)|0;q=J;if((q|0)>-1|(q|0)==-1&r>>>0>4294967295)p=r;else{s=0;u=g;return s|0}}s=RRb(e,ujc(l,a)|0,p)|0;u=g;return s|0}if((f[c+32>>2]|0)!=3){p=f[c+24>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=c;DTb(p,h)}if((f[c+28>>2]|0)==11){p=hh[f[(f[k>>2]|0)+156>>2]&127](k,d,c,f[e+56>>2]|0)|0;c=f[e>>2]|0;if(c>>>0<(f[e+4>>2]|0)>>>0?(d=b[c>>0]|0,d<<24>>24>-1):0){f[e>>2]=c+1;t=d&255}else{d=VRb(e)|0;if((d|0)>-1)t=d;else{s=0;u=g;return s|0}}GRb(h,e,t);if((f[h+4>>2]|0)>=0?Mi[f[(f[p>>2]|0)+44>>2]&1023](p,e)|0:0)v=LRb(e,f[h>>2]|0)|0;else v=0;s=v;u=g;return s|0}}rTb(i,2,503568,467);oTb(j,mTb(i,503658)|0);sTb(i);s=0;u=g;return s|0}function Ojc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+48|0;g=e+32|0;h=e;i=e+8|0;j=e+44|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);k=f[g>>2]|0;l=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;m=d+12|0;n=d+8|0;o=(f[m>>2]|0)+c-(f[n>>2]|0)|0;f[g>>2]=0;c=g+4|0;f[c>>2]=0;f[g+8>>2]=0;p=k+16|0;a:do if(b[(f[p>>2]|0)+51>>0]|0){q=k+52|0;r=f[q>>2]|0;if((r|0)>0){s=k+20|0;t=g+8|0;v=0;w=0;x=0;y=r;while(1){r=(f[s>>2]|0)+(v*88|0)|0;f[h>>2]=r;if((w|0)==(x|0)){jWb(g,h);z=f[q>>2]|0}else{f[w>>2]=r;f[c>>2]=(f[c>>2]|0)+4;z=y}r=v+1|0;if((r|0)>=(z|0))break a;v=r;w=f[c>>2]|0;x=f[t>>2]|0;y=z}}}else Ti[f[(f[l>>2]|0)+64>>2]&511](l,a,g);while(0);z=f[g>>2]|0;if((f[c>>2]|0)!=(z|0)){h=0;k=z;do{Pjc(f[k+(h<<2)>>2]|0,a,d);h=h+1|0;k=f[g>>2]|0}while(h>>>0<(f[c>>2]|0)-k>>2>>>0)}k=(b[(f[p>>2]|0)+48>>0]|0)==0;p=Mi[f[(f[l>>2]|0)+8>>2]&1023](l,a)|0;if(k)Gjc(p,d);else Ijc(p,d);if(((f[m>>2]|0)-(f[n>>2]|0)|0)!=(o|0)){rTb(i,3,503568,830);oTb(j,mTb(mTb(i,503711)|0,503772)|0);sTb(i)}i=f[g>>2]|0;if(!i){u=e;return}g=f[c>>2]|0;if((g|0)!=(i|0))f[c>>2]=g+(~((g+-4-i|0)>>>2)<<2);YDc(i);u=e;return}function Pjc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;e=u;u=u+64|0;g=e+32|0;h=e;i=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;if(b[a+38>>0]|0?b[(f[(f[a+48>>2]|0)+16>>2]|0)+48>>0]|0:0){j=f[a+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=a;DTb(j,g)}if((f[161216+(f[a+28>>2]<<2)>>2]|0)==10?(f[a+32>>2]|0)!=3:0){Qjc(a,c,d);u=e;return}}j=a+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=a;DTb(k,g)}k=a+28|0;if(((f[k>>2]|0)==11?BYb(a)|0:0)?Udc(hj[f[(f[i>>2]|0)+364>>2]&511](i,c,a)|0)|0:0){if(!(b[d+18>>0]|0)){if(!(f[220805]|0))l=33}else if(!(b[d+19>>0]|0))l=33;if((l|0)==33){ei[f[(f[i>>2]|0)+352>>2]&511](g,i,c,a);l=g+4|0;m=h+4|0;o=h+16|0;q=h+8|0;r=g+8|0;t=g+24|0;while(1){ei[f[(f[i>>2]|0)+356>>2]&511](h,i,c,a);v=f[l>>2]|0;w=hj[f[(f[v>>2]|0)+20>>2]&511](v,g,h)|0;v=f[m>>2]|0;mi[f[(f[v>>2]|0)+52>>2]&2047](v,h);if((f[o>>2]|0)==9?(v=f[q>>2]|0,v|0):0){if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);YDc(v)}if(w)break;Sjc(a,r,t,d);w=f[l>>2]|0;mi[f[(f[w>>2]|0)+60>>2]&2047](w,g)}t=f[l>>2]|0;mi[f[(f[t>>2]|0)+52>>2]&2047](t,g);if((f[g+16>>2]|0)==9?(t=f[r>>2]|0,t|0):0){if((b[t+11>>0]|0)<0)YDc(f[t>>2]|0);YDc(t)}u=e;return}Rjc(g,c,i,a);t=f[g>>2]|0;r=g+4|0;if((t|0)==(f[r>>2]|0)){x=t;y=t}else{l=h+4|0;q=t;do{f[h>>2]=0;f[l>>2]=0;_h[f[(f[i>>2]|0)+344>>2]&127](i,c,a,q,h)|0;Sjc(a,q,h,d);q=q+16|0}while((q|0)!=(f[r>>2]|0));x=f[g>>2]|0;y=q}if(x|0){if((y|0)==(x|0))z=x;else{q=y;while(1){y=q+-16|0;f[r>>2]=y;if((f[q+-8>>2]|0)==9?(l=f[y>>2]|0,(l|0)!=0):0){if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);YDc(l);A=f[r>>2]|0}else A=y;if((A|0)==(x|0))break;else q=A}z=f[g>>2]|0}YDc(z)}u=e;return}z=a+32|0;if((f[z>>2]|0)!=3)if(!(b[(f[(f[a+48>>2]|0)+16>>2]|0)+51>>0]|0))B=(hj[f[(f[i>>2]|0)+20>>2]&511](i,c,a)|0)&1;else B=1;else B=hj[f[(f[i>>2]|0)+24>>2]&511](i,c,a)|0;f[h>>2]=0;A=h+4|0;f[A>>2]=0;f[h+8>>2]=0;do if((B|0)>1){q=f[j>>2]|0;if(q|0?(f[q>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=a;DTb(q,g)}if((f[k>>2]|0)==11?BYb(a)|0:0){if(!(b[d+18>>0]|0)){if(!(f[220805]|0))break}else if(!(b[d+19>>0]|0))break;iic(g,c,B,i,a);q=g+4|0;jic(h,f[g>>2]|0,f[q>>2]|0);x=f[g>>2]|0;if(x|0){r=f[q>>2]|0;if((r|0)!=(x|0))f[q>>2]=r+(~((r+-4-x|0)>>>2)<<2);YDc(x)}}}while(0);x=FYb(a)|0;r=(B|0)>0;do if(r&x){q=f[a+40>>2]<<3|2;y=d+8|0;if((f[y>>2]|0)>4){l=d+4|0;t=f[l>>2]|0;if(q>>>0>127){o=q;m=t;while(1){b[m>>0]=o|128;w=o>>>7;v=m+1|0;if(o>>>0>16383){o=w;m=v}else{C=v;D=w;break}}}else{C=t;D=q}b[C>>0]=D;m=C+1-t|0;f[l>>2]=(f[l>>2]|0)+m;f[y>>2]=(f[y>>2]|0)-m}else bSb(d,q);m=Tjc(a,c)|0;if((f[y>>2]|0)<=4){bSb(d,m);break}o=d+4|0;w=f[o>>2]|0;if(m>>>0>127){v=m;E=w;while(1){b[E>>0]=v|128;F=v>>>7;G=E+1|0;if(v>>>0>16383){v=F;E=G}else{H=G;I=F;break}}}else{H=w;I=m}b[H>>0]=I;E=H+1-w|0;f[o>>2]=(f[o>>2]|0)+E;f[y>>2]=(f[y>>2]|0)-E}while(0);a:do if(r){H=d+8|0;I=d+4|0;C=a+40|0;D=a+20|0;E=a+4|0;v=g+11|0;q=g+11|0;l=g+4|0;t=g+8|0;F=g+12|0;G=0;while(1){K=f[j>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[g>>2]=78728;f[l>>2]=1737;b[t>>0]=0;f[F>>2]=a;DTb(K,g)}b:do switch(f[k>>2]|0){case 5:{if((f[z>>2]|0)==3)L=hh[f[(f[i>>2]|0)+168>>2]&127](i,c,a,G)|0;else L=hj[f[(f[i>>2]|0)+68>>2]&511](i,c,a)|0;if(!x){MTb(f[C>>2]|0,L,d);break b}K=((L|0)<0)<<31>>31;if((f[H>>2]|0)<=9){cSb(d,L,K);break b}M=f[I>>2]|0;N=L&255;if(L>>>0>127){O=M;P=N;Q=L;R=K;while(1){b[O>>0]=P|-128;K=Q;Q=aJc(Q|0,R|0,7)|0;S=O+1|0;T=Q&255;if(!(R>>>0>0|(R|0)==0&K>>>0>16383)){U=S;V=T;break}else{O=S;P=T;R=J}}}else{U=M;V=N}b[U>>0]=V;R=U+1-M|0;f[I>>2]=(f[I>>2]|0)+R;f[H>>2]=(f[H>>2]|0)-R;break}case 3:{if((f[z>>2]|0)==3){R=hh[f[(f[i>>2]|0)+172>>2]&127](i,c,a,G)|0;W=J;X=R}else{R=hj[f[(f[i>>2]|0)+72>>2]&511](i,c,a)|0;W=J;X=R}if(!x){NTb(f[C>>2]|0,X,W,d);break b}if((f[H>>2]|0)<=9){cSb(d,X,W);break b}R=f[I>>2]|0;P=X&255;if(W>>>0>0|(W|0)==0&X>>>0>127){O=R;Q=P;T=X;S=W;while(1){b[O>>0]=Q|-128;K=T;T=aJc(T|0,S|0,7)|0;Y=O+1|0;Z=T&255;if(!(S>>>0>0|(S|0)==0&K>>>0>16383)){_=Y;$=Z;break}else{O=Y;Q=Z;S=J}}}else{_=R;$=P}b[_>>0]=$;S=_+1-R|0;f[I>>2]=(f[I>>2]|0)+S;f[H>>2]=(f[H>>2]|0)-S;break}case 17:{if((f[z>>2]|0)==3)aa=hh[f[(f[i>>2]|0)+168>>2]&127](i,c,a,G)|0;else aa=hj[f[(f[i>>2]|0)+68>>2]&511](i,c,a)|0;if(!x){QTb(f[C>>2]|0,aa,d);break b}S=aa<<1^aa>>31;if((f[H>>2]|0)<=4){bSb(d,S);break b}Q=f[I>>2]|0;if(S>>>0>127){O=S;T=Q;while(1){b[T>>0]=O|128;M=O>>>7;N=T+1|0;if(O>>>0>16383){O=M;T=N}else{ba=N;ca=M;break}}}else{ba=Q;ca=S}b[ba>>0]=ca;T=ba+1-Q|0;f[I>>2]=(f[I>>2]|0)+T;f[H>>2]=(f[H>>2]|0)-T;break}case 18:{if((f[z>>2]|0)==3){T=hh[f[(f[i>>2]|0)+172>>2]&127](i,c,a,G)|0;da=T;ea=J}else{T=hj[f[(f[i>>2]|0)+72>>2]&511](i,c,a)|0;da=T;ea=J}if(!x){RTb(f[C>>2]|0,da,ea,d);break b}T=jJc(da|0,ea|0,1)|0;O=J;R=$Ic(da|0,ea|0,63)|0;P=T^R;R=O^J;if((f[H>>2]|0)<=9){cSb(d,P,R);break b}O=f[I>>2]|0;T=P&255;if(R>>>0>0|(R|0)==0&P>>>0>127){M=O;N=T;Z=P;P=R;while(1){b[M>>0]=N|-128;R=Z;Z=aJc(Z|0,P|0,7)|0;Y=M+1|0;K=Z&255;if(!(P>>>0>0|(P|0)==0&R>>>0>16383)){fa=Y;ga=K;break}else{M=Y;N=K;P=J}}}else{fa=O;ga=T}b[fa>>0]=ga;P=fa+1-O|0;f[I>>2]=(f[I>>2]|0)+P;f[H>>2]=(f[H>>2]|0)-P;break}case 13:{if((f[z>>2]|0)==3)ha=hh[f[(f[i>>2]|0)+176>>2]&127](i,c,a,G)|0;else ha=hj[f[(f[i>>2]|0)+76>>2]&511](i,c,a)|0;if(!x){OTb(f[C>>2]|0,ha,d);break b}if((f[H>>2]|0)<=4){bSb(d,ha);break b}P=f[I>>2]|0;if(ha>>>0>127){N=ha;M=P;while(1){b[M>>0]=N|128;Z=N>>>7;Q=M+1|0;if(N>>>0>16383){N=Z;M=Q}else{ia=Q;ja=Z;break}}}else{ia=P;ja=ha}b[ia>>0]=ja;M=ia+1-P|0;f[I>>2]=(f[I>>2]|0)+M;f[H>>2]=(f[H>>2]|0)-M;break}case 4:{if((f[z>>2]|0)==3){M=hh[f[(f[i>>2]|0)+180>>2]&127](i,c,a,G)|0;ka=J;la=M}else{M=hj[f[(f[i>>2]|0)+80>>2]&511](i,c,a)|0;ka=J;la=M}if(!x){PTb(f[C>>2]|0,la,ka,d);break b}if((f[H>>2]|0)<=9){cSb(d,la,ka);break b}M=f[I>>2]|0;N=la&255;if(ka>>>0>0|(ka|0)==0&la>>>0>127){O=M;T=N;Z=la;Q=ka;while(1){b[O>>0]=T|-128;S=Z;Z=aJc(Z|0,Q|0,7)|0;K=O+1|0;Y=Z&255;if(!(Q>>>0>0|(Q|0)==0&S>>>0>16383)){ma=K;na=Y;break}else{O=K;T=Y;Q=J}}}else{ma=M;na=N}b[ma>>0]=na;Q=ma+1-M|0;f[I>>2]=(f[I>>2]|0)+Q;f[H>>2]=(f[H>>2]|0)-Q;break}case 7:{if((f[z>>2]|0)==3)oa=hh[f[(f[i>>2]|0)+176>>2]&127](i,c,a,G)|0;else oa=hj[f[(f[i>>2]|0)+76>>2]&511](i,c,a)|0;if(x){$Rb(d,oa);break b}else{STb(f[C>>2]|0,oa,d);break b}break}case 6:{if((f[z>>2]|0)==3){Q=hh[f[(f[i>>2]|0)+180>>2]&127](i,c,a,G)|0;pa=Q;qa=J}else{Q=hj[f[(f[i>>2]|0)+80>>2]&511](i,c,a)|0;pa=Q;qa=J}if(x){aSb(d,pa,qa);break b}else{TTb(f[C>>2]|0,pa,qa,d);break b}break}case 15:{if((f[z>>2]|0)==3)ra=hh[f[(f[i>>2]|0)+168>>2]&127](i,c,a,G)|0;else ra=hj[f[(f[i>>2]|0)+68>>2]&511](i,c,a)|0;if(x){$Rb(d,ra);break b}else{UTb(f[C>>2]|0,ra,d);break b}break}case 16:{if((f[z>>2]|0)==3){Q=hh[f[(f[i>>2]|0)+172>>2]&127](i,c,a,G)|0;sa=Q;ta=J}else{Q=hj[f[(f[i>>2]|0)+72>>2]&511](i,c,a)|0;sa=Q;ta=J}if(x){aSb(d,sa,ta);break b}else{VTb(f[C>>2]|0,sa,ta,d);break b}break}case 2:{if((f[z>>2]|0)==3)ua=+Ai[f[(f[i>>2]|0)+184>>2]&15](i,c,a,G);else ua=+Sh[f[(f[i>>2]|0)+84>>2]&31](i,c,a);if(x){$Rb(d,(n[s>>2]=ua,f[s>>2]|0));break b}else{WTb(f[C>>2]|0,ua,d);break b}break}case 1:{if((f[z>>2]|0)==3)va=+Ai[f[(f[i>>2]|0)+188>>2]&15](i,c,a,G);else va=+Sh[f[(f[i>>2]|0)+88>>2]&31](i,c,a);if(x){p[s>>3]=va;aSb(d,f[s>>2]|0,f[s+4>>2]|0);break b}else{XTb(f[C>>2]|0,va,d);break b}break}case 8:{if((f[z>>2]|0)==3)wa=hh[f[(f[i>>2]|0)+192>>2]&127](i,c,a,G)|0;else wa=hj[f[(f[i>>2]|0)+92>>2]&511](i,c,a)|0;if(!x){YTb(f[C>>2]|0,wa,d);break b}if((f[H>>2]|0)>4){b[f[I>>2]>>0]=wa&1;f[I>>2]=(f[I>>2]|0)+1;f[H>>2]=(f[H>>2]|0)+-1;break b}else{bSb(d,wa&1);break b}break}case 10:{Q=f[C>>2]|0;do if((f[z>>2]|0)==3){T=f[h>>2]|0;if((T|0)==(f[A>>2]|0)){xa=hh[f[(f[i>>2]|0)+208>>2]&127](i,c,a,G)|0;break}else{xa=f[T+(G<<2)>>2]|0;break}}else xa=hh[f[(f[i>>2]|0)+108>>2]&127](i,c,a,0)|0;while(0);cUb(Q,xa,d);break}case 11:{M=f[C>>2]|0;do if((f[z>>2]|0)==3){N=f[h>>2]|0;if((N|0)==(f[A>>2]|0)){ya=hh[f[(f[i>>2]|0)+208>>2]&127](i,c,a,G)|0;break}else{ya=f[N+(G<<2)>>2]|0;break}}else ya=hh[f[(f[i>>2]|0)+108>>2]&127](i,c,a,0)|0;while(0);dUb(M,ya,d);break}case 14:{if((f[z>>2]|0)==3)za=hh[f[(f[i>>2]|0)+200>>2]&127](i,c,a,G)|0;else za=hj[f[(f[i>>2]|0)+100>>2]&511](i,c,a)|0;if(!x){ZTb(f[C>>2]|0,f[za+8>>2]|0,d);break b}Q=f[za+8>>2]|0;N=((Q|0)<0)<<31>>31;if((f[H>>2]|0)<=9){cSb(d,Q,N);break b}T=f[I>>2]|0;O=Q&255;if(Q>>>0>127){Z=T;P=O;Y=Q;Q=N;while(1){b[Z>>0]=P|-128;N=Y;Y=aJc(Y|0,Q|0,7)|0;K=Z+1|0;S=Y&255;if(!(Q>>>0>0|(Q|0)==0&N>>>0>16383)){Aa=K;Ba=S;break}else{Z=K;P=S;Q=J}}}else{Aa=T;Ba=O}b[Aa>>0]=Ba;Q=Aa+1-T|0;f[I>>2]=(f[I>>2]|0)+Q;f[H>>2]=(f[H>>2]|0)-Q;break}case 9:{Q=(f[(f[D>>2]|0)+44>>2]|0)==3;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if((f[z>>2]|0)==3)Ca=_h[f[(f[i>>2]|0)+212>>2]&127](i,c,a,G,g)|0;else Ca=hh[f[(f[i>>2]|0)+112>>2]&127](i,c,a,g)|0;P=b[Ca+11>>0]|0;if(P<<24>>24<0){Da=f[Ca>>2]|0;Ea=f[Ca+4>>2]|0}else{Da=Ca;Ea=P&255}P=f[E>>2]|0;if((b[P+11>>0]|0)<0)Fa=f[P>>2]|0;else Fa=P;if(Q)gUb(Da,Ea,1,Fa)|0;_Tb(f[C>>2]|0,Ca,d);if((b[v>>0]|0)<0)YDc(f[g>>2]|0);break}case 12:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if((f[z>>2]|0)==3)Ga=_h[f[(f[i>>2]|0)+212>>2]&127](i,c,a,G,g)|0;else Ga=hh[f[(f[i>>2]|0)+112>>2]&127](i,c,a,g)|0;aUb(f[C>>2]|0,Ga,d);if((b[q>>0]|0)<0)YDc(f[g>>2]|0);break}default:{}}while(0);G=G+1|0;if((G|0)>=(B|0))break a}}while(0);B=f[h>>2]|0;if(B|0){h=f[A>>2]|0;if((h|0)!=(B|0))f[A>>2]=h+(~((h+-4-B|0)>>>2)<<2);YDc(B)}u=e;return}function Qjc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;b[f[h>>2]>>0]=11;f[h>>2]=(f[h>>2]|0)+1;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;i=h}else{bSb(d,11);i=f[g>>2]|0}if((i|0)>4){i=d+4|0;b[f[i>>2]>>0]=16;f[i>>2]=(f[i>>2]|0)+1;i=(f[g>>2]|0)+-1|0;f[g>>2]=i;j=i}else{bSb(d,16);j=f[g>>2]|0}i=f[a+40>>2]|0;if((j|0)>4){j=d+4|0;h=f[j>>2]|0;if(i>>>0>127){k=i;l=h;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=h;p=i}b[o>>0]=p;p=o+1-h|0;f[j>>2]=(f[j>>2]|0)+p;j=(f[g>>2]|0)-p|0;f[g>>2]=j;q=j}else{bSb(d,i);q=f[g>>2]|0}if((q|0)>4){q=d+4|0;b[f[q>>2]>>0]=26;f[q>>2]=(f[q>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1}else bSb(d,26);q=hh[f[(f[e>>2]|0)+108>>2]&127](e,c,a,0)|0;a=_i[f[(f[q>>2]|0)+60>>2]&1023](q)|0;if((f[g>>2]|0)>4){c=d+4|0;e=f[c>>2]|0;if(a>>>0>127){i=a;j=e;while(1){b[j>>0]=i|128;p=i>>>7;h=j+1|0;if(i>>>0>16383){i=p;j=h}else{r=h;s=p;break}}}else{r=e;s=a}b[r>>0]=s;s=r+1-e|0;f[c>>2]=(f[c>>2]|0)+s;f[g>>2]=(f[g>>2]|0)-s}else bSb(d,a);mi[f[(f[q>>2]|0)+52>>2]&2047](q,d);if((f[g>>2]|0)>4){q=d+4|0;b[f[q>>2]>>0]=12;f[q>>2]=(f[q>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1;return}else{bSb(d,12);return}}function Rjc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+64|0;h=g+32|0;i=g;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;ei[f[(f[d>>2]|0)+352>>2]&511](h,d,c,e);k=h+4|0;l=i+4|0;m=i+16|0;n=i+8|0;o=h+8|0;p=a+8|0;while(1){ei[f[(f[d>>2]|0)+356>>2]&511](i,d,c,e);q=f[k>>2]|0;r=hj[f[(f[q>>2]|0)+20>>2]&511](q,h,i)|0;q=f[l>>2]|0;mi[f[(f[q>>2]|0)+52>>2]&2047](q,i);if((f[m>>2]|0)==9?(q=f[n>>2]|0,q|0):0){if((b[q+11>>0]|0)<0)YDc(f[q>>2]|0);YDc(q)}if(r)break;r=f[j>>2]|0;if((r|0)==(f[p>>2]|0))Wjc(a,o);else{f[r+8>>2]=0;Zcc(r,o);f[j>>2]=(f[j>>2]|0)+16}r=f[k>>2]|0;mi[f[(f[r>>2]|0)+60>>2]&2047](r,h)}p=f[k>>2]|0;mi[f[(f[p>>2]|0)+52>>2]&2047](p,h);if((f[h+16>>2]|0)!=9){s=f[a>>2]|0;t=f[j>>2]|0;Xjc(s,t,h);u=g;return}p=f[o>>2]|0;if(!p){s=f[a>>2]|0;t=f[j>>2]|0;Xjc(s,t,h);u=g;return}if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);YDc(p);s=f[a>>2]|0;t=f[j>>2]|0;Xjc(s,t,h);u=g;return}function Sjc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;k=(DYb(a)|0)+20|0;l=f[k>>2]|0;k=(DYb(a)|0)+20|0;m=f[k>>2]|0;k=m+88|0;n=f[a+40>>2]<<3|2;a=e+8|0;if((f[a>>2]|0)>4){o=e+4|0;p=f[o>>2]|0;if(n>>>0>127){q=n;r=p;while(1){b[r>>0]=q|128;s=q>>>7;t=r+1|0;if(q>>>0>16383){q=s;r=t}else{v=t;w=s;break}}}else{v=p;w=n}b[v>>0]=w;w=v+1-p|0;f[o>>2]=(f[o>>2]|0)+w;f[a>>2]=(f[a>>2]|0)-w}else bSb(e,n);n=(Ujc(l,c)|0)+2|0;w=n+(Vjc(k,d)|0)|0;if((f[a>>2]|0)>4){n=e+4|0;o=f[n>>2]|0;if(w>>>0>127){p=w;v=o;while(1){b[v>>0]=p|128;r=p>>>7;q=v+1|0;if(p>>>0>16383){p=r;v=q}else{x=q;y=r;break}}}else{x=o;y=w}b[x>>0]=y;y=x+1-o|0;f[n>>2]=(f[n>>2]|0)+y;f[a>>2]=(f[a>>2]|0)-y}else bSb(e,w);w=f[l+24>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=l;DTb(w,h)}do switch(f[l+28>>2]|0){case 14:case 12:case 11:case 10:case 2:case 1:{rTb(i,3,503568,846);oTb(j,mTb(i,503922)|0);sTb(i);break}case 3:{NTb(1,ddc(c)|0,J,e);break}case 4:{PTb(1,fdc(c)|0,J,e);break}case 5:{MTb(1,edc(c)|0,e);break}case 6:{TTb(1,fdc(c)|0,J,e);break}case 7:{STb(1,gdc(c)|0,e);break}case 8:{YTb(1,hdc(c)|0,e);break}case 13:{OTb(1,gdc(c)|0,e);break}case 15:{UTb(1,edc(c)|0,e);break}case 16:{VTb(1,ddc(c)|0,J,e);break}case 17:{QTb(1,edc(c)|0,e);break}case 18:{RTb(1,ddc(c)|0,J,e);break}case 9:{_Tb(1,PNa(c)|0,e);break}default:{}}while(0);c=f[m+112>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=k;DTb(c,h)}do switch(f[m+116>>2]|0){case 3:{NTb(2,Gdc(d)|0,J,e);u=g;return}case 4:{PTb(2,Idc(d)|0,J,e);u=g;return}case 5:{MTb(2,Hdc(d)|0,e);u=g;return}case 6:{TTb(2,Idc(d)|0,J,e);u=g;return}case 7:{STb(2,Jdc(d)|0,e);u=g;return}case 8:{YTb(2,Kdc(d)|0,e);u=g;return}case 13:{OTb(2,Jdc(d)|0,e);u=g;return}case 15:{UTb(2,Hdc(d)|0,e);u=g;return}case 16:{VTb(2,Gdc(d)|0,J,e);u=g;return}case 17:{QTb(2,Hdc(d)|0,e);u=g;return}case 18:{RTb(2,Gdc(d)|0,J,e);u=g;return}case 14:{ZTb(2,Ndc(d)|0,e);u=g;return}case 1:{XTb(2,+Ldc(d),e);u=g;return}case 2:{WTb(2,+Mdc(d),e);u=g;return}case 9:{_Tb(2,Fdc(d)|0,e);u=g;return}case 12:{aUb(2,Fdc(d)|0,e);u=g;return}case 11:{dUb(2,Odc(d)|0,e);u=g;return}case 10:{cUb(2,Odc(d)|0,e);u=g;return}default:{u=g;return}}while(0)}function Tjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+64|0;e=d+32|0;g=d;h=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;i=a+24|0;j=f[i>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(j,e)}j=a+28|0;if(((f[j>>2]|0)==11?BYb(a)|0:0)?(k=hj[f[(f[h>>2]|0)+364>>2]&511](h,c,a)|0,Udc(k)|0):0){mbc(e,c,a);mbc(g,c,a);l=(DYb(a)|0)+20|0;m=f[l>>2]|0;l=(DYb(a)|0)+20|0;n=(f[l>>2]|0)+88|0;mi[f[(f[k>>2]|0)+24>>2]&2047](k,e);mi[f[(f[k>>2]|0)+28>>2]&2047](k,g);k=e+4|0;l=e+8|0;o=e+24|0;p=0;while(1){q=f[k>>2]|0;if(hj[f[(f[q>>2]|0)+20>>2]&511](q,e,g)|0)break;q=Ujc(m,l)|0;r=q+2+(Vjc(n,o)|0)|0;q=r+p+((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=f[k>>2]|0;mi[f[(f[r>>2]|0)+60>>2]&2047](r,e);p=q}o=f[g+4>>2]|0;mi[f[(f[o>>2]|0)+52>>2]&2047](o,g);if((f[g+16>>2]|0)==9?(o=f[g+8>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);YDc(o)}o=f[k>>2]|0;mi[f[(f[o>>2]|0)+52>>2]&2047](o,e);if((f[e+16>>2]|0)==9?(o=f[l>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);YDc(o)}s=p;u=d;return s|0}p=a+32|0;if((f[p>>2]|0)!=3)if(!(b[(f[(f[a+48>>2]|0)+16>>2]|0)+51>>0]|0))t=(hj[f[(f[h>>2]|0)+20>>2]&511](h,c,a)|0)&1;else t=1;else t=hj[f[(f[h>>2]|0)+24>>2]&511](h,c,a)|0;o=f[i>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(o,e)}do switch(f[j>>2]|0){case 5:{if((f[p>>2]|0)!=3){o=hj[f[(f[h>>2]|0)+68>>2]&511](h,c,a)|0;if((o|0)<0){s=10;u=d;return s|0}s=(((($(o|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}o=0;i=0;while(1){l=hh[f[(f[h>>2]|0)+168>>2]&127](h,c,a,o)|0;if((l|0)<0)v=10;else v=(((($(l|1|0)|0)^31)*9|0)+73|0)>>>6;l=v+i|0;o=o+1|0;if((o|0)==(t|0)){s=l;break}else i=l}u=d;return s|0}case 3:{if((f[p>>2]|0)!=3){i=hj[f[(f[h>>2]|0)+72>>2]&511](h,c,a)|0;o=iJc(i|1|0,J|0,1)|0;s=(((o^63)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}o=0;i=0;while(1){l=hh[f[(f[h>>2]|0)+172>>2]&127](h,c,a,o)|0;k=iJc(l|1|0,J|0,1)|0;l=((((k^63)*9|0)+73|0)>>>6)+i|0;o=o+1|0;if((o|0)==(t|0)){s=l;break}else i=l}u=d;return s|0}case 17:{if((f[p>>2]|0)!=3){i=hj[f[(f[h>>2]|0)+68>>2]&511](h,c,a)|0;s=(((($(i<<1^i>>31|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;o=0;while(1){l=hh[f[(f[h>>2]|0)+168>>2]&127](h,c,a,i)|0;k=((((($(l<<1^l>>31|1|0)|0)^31)*9|0)+73|0)>>>6)+o|0;i=i+1|0;if((i|0)==(t|0)){s=k;break}else o=k}u=d;return s|0}case 18:{if((f[p>>2]|0)!=3){o=hj[f[(f[h>>2]|0)+72>>2]&511](h,c,a)|0;i=J;k=jJc(o|0,i|0,1)|0;l=J;g=$Ic(o|0,i|0,63)|0;i=iJc(k^g|1|0,l^J|0,1)|0;s=(((i^63)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;l=0;while(1){g=hh[f[(f[h>>2]|0)+172>>2]&127](h,c,a,i)|0;k=J;o=jJc(g|0,k|0,1)|0;n=J;m=$Ic(g|0,k|0,63)|0;k=iJc(o^m|1|0,n^J|0,1)|0;n=((((k^63)*9|0)+73|0)>>>6)+l|0;i=i+1|0;if((i|0)==(t|0)){s=n;break}else l=n}u=d;return s|0}case 13:{if((f[p>>2]|0)!=3){s=(((($(hj[f[(f[h>>2]|0)+76>>2]&511](h,c,a)|0|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}l=0;i=0;while(1){n=((((($(hh[f[(f[h>>2]|0)+176>>2]&127](h,c,a,l)|0|1|0)|0)^31)*9|0)+73|0)>>>6)+i|0;l=l+1|0;if((l|0)==(t|0)){s=n;break}else i=n}u=d;return s|0}case 4:{if((f[p>>2]|0)!=3){i=hj[f[(f[h>>2]|0)+80>>2]&511](h,c,a)|0;l=iJc(i|1|0,J|0,1)|0;s=(((l^63)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}l=0;i=0;while(1){n=hh[f[(f[h>>2]|0)+180>>2]&127](h,c,a,l)|0;k=iJc(n|1|0,J|0,1)|0;n=((((k^63)*9|0)+73|0)>>>6)+i|0;l=l+1|0;if((l|0)==(t|0)){s=n;break}else i=n}u=d;return s|0}case 7:{s=t<<2;u=d;return s|0}case 6:{s=t<<3;u=d;return s|0}case 15:{s=t<<2;u=d;return s|0}case 16:{s=t<<3;u=d;return s|0}case 2:{s=t<<2;u=d;return s|0}case 1:{s=t<<3;u=d;return s|0}case 8:{s=t;u=d;return s|0}case 10:{if((f[p>>2]|0)!=3){i=hh[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;s=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;l=0;while(1){n=hh[f[(f[h>>2]|0)+208>>2]&127](h,c,a,i)|0;k=(_i[f[(f[n>>2]|0)+48>>2]&1023](n)|0)+l|0;i=i+1|0;if((i|0)==(t|0)){s=k;break}else l=k}u=d;return s|0}case 11:{if((f[p>>2]|0)!=3){l=hh[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;i=_i[f[(f[l>>2]|0)+48>>2]&1023](l)|0;s=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+i|0;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;l=0;while(1){k=hh[f[(f[h>>2]|0)+208>>2]&127](h,c,a,i)|0;n=_i[f[(f[k>>2]|0)+48>>2]&1023](k)|0;k=n+l+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(t|0)){s=k;break}else l=k}u=d;return s|0}case 14:{if((f[p>>2]|0)!=3){l=(hj[f[(f[h>>2]|0)+100>>2]&511](h,c,a)|0)+8|0;i=f[l>>2]|0;if((i|0)<0){s=10;u=d;return s|0}s=(((($(i|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;l=0;while(1){k=(hh[f[(f[h>>2]|0)+200>>2]&127](h,c,a,i)|0)+8|0;n=f[k>>2]|0;if((n|0)<0)w=10;else w=(((($(n|1|0)|0)^31)*9|0)+73|0)>>>6;n=w+l|0;i=i+1|0;if((i|0)==(t|0)){s=n;break}else l=n}u=d;return s|0}case 12:case 9:{if(!t){s=0;u=d;return s|0}l=e+11|0;i=0;n=0;while(1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if((f[p>>2]|0)==3)x=_h[f[(f[h>>2]|0)+212>>2]&127](h,c,a,i,e)|0;else x=hh[f[(f[h>>2]|0)+112>>2]&127](h,c,a,e)|0;k=b[x+11>>0]|0;m=k<<24>>24<0?f[x+4>>2]|0:k&255;k=m+n+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if((b[l>>0]|0)<0)YDc(f[e>>2]|0);i=i+1|0;if(i>>>0>=t>>>0){s=k;break}else n=k}u=d;return s|0}default:{s=0;u=d;return s|0}}while(0);return 0}function Ujc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d+65|0;i=d;j=d+64|0;k=f[a+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(k,e)}do switch(f[a+28>>2]|0){case 14:case 12:case 11:case 10:case 2:case 1:{rTb(g,3,503568,1245);oTb(h,mTb(g,503922)|0);sTb(g);l=0;u=d;return l|0}case 5:{e=edc(c)|0;if((e|0)<0){l=10;u=d;return l|0}l=(((($(e|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 3:{l=((((iJc(ddc(c)|0|1|0,J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 13:{l=(((($(gdc(c)|0|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 4:{l=((((iJc(fdc(c)|0|1|0,J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 17:{e=edc(c)|0;l=(((($(e<<1^e>>31|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 18:{e=ddc(c)|0;k=J;m=jJc(e|0,k|0,1)|0;n=J;l=((((iJc(m^($Ic(e|0,k|0,63)|0)|1|0,n^J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 9:{n=PNa(c)|0;k=b[n+11>>0]|0;e=k<<24>>24<0?f[n+4>>2]|0:k&255;l=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+e|0;u=d;return l|0}case 6:{l=8;u=d;return l|0}case 16:{l=8;u=d;return l|0}case 8:{l=1;u=d;return l|0}case 15:case 7:{l=4;u=d;return l|0}default:{rTb(i,3,503568,1272);oTb(j,mTb(i,503934)|0);sTb(i);l=0;u=d;return l|0}}while(0);return 0}function Vjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d+65|0;i=d;j=d+64|0;k=f[a+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(k,e)}do switch(f[a+28>>2]|0){case 10:{rTb(g,3,503568,1280);oTb(h,mTb(g,503922)|0);sTb(g);l=0;u=d;return l|0}case 5:{e=Hdc(c)|0;if((e|0)<0){l=10;u=d;return l|0}l=(((($(e|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 3:{l=((((iJc(Gdc(c)|0|1|0,J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 13:{l=(((($(Jdc(c)|0|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 4:{l=((((iJc(Idc(c)|0|1|0,J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 17:{e=Hdc(c)|0;l=(((($(e<<1^e>>31|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 18:{e=Gdc(c)|0;k=J;m=jJc(e|0,k|0,1)|0;n=J;l=((((iJc(m^($Ic(e|0,k|0,63)|0)|1|0,n^J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 9:{n=Fdc(c)|0;k=b[n+11>>0]|0;e=k<<24>>24<0?f[n+4>>2]|0:k&255;l=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+e|0;u=d;return l|0}case 12:{e=Fdc(c)|0;k=b[e+11>>0]|0;n=k<<24>>24<0?f[e+4>>2]|0:k&255;l=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+n|0;u=d;return l|0}case 14:{n=Ndc(c)|0;if((n|0)<0){l=10;u=d;return l|0}l=(((($(n|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 11:{n=Odc(c)|0;k=_i[f[(f[n>>2]|0)+48>>2]&1023](n)|0;l=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+k|0;u=d;return l|0}case 6:{l=8;u=d;return l|0}case 16:{l=8;u=d;return l|0}case 1:{l=8;u=d;return l|0}case 8:{l=1;u=d;return l|0}case 2:case 15:case 7:{l=4;u=d;return l|0}default:{rTb(i,3,503568,1312);oTb(j,mTb(i,503934)|0);sTb(i);l=0;u=d;return l|0}}while(0);return 0}function Wjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[a>>2]|0;g=(f[d>>2]|0)-e>>4;h=g+1|0;if(h>>>0>268435455)mCc(a);i=a+8|0;j=(f[i>>2]|0)-e|0;e=j>>3;k=j>>4>>>0<134217727?(e>>>0<h>>>0?h:e):268435455;if(k>>>0>268435455){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}e=VDc(k<<4)|0;h=e+(g<<4)|0;j=h;l=e+(k<<4)|0;f[e+(g<<4)+8>>2]=0;Zcc(h,c);c=h+16|0;g=f[a>>2]|0;e=f[d>>2]|0;if((e|0)==(g|0)){m=j;n=g;o=g}else{k=e;e=j;j=h;do{k=k+-16|0;f[j+-8>>2]=0;Zcc(j+-16|0,k);j=e+-16|0;e=j}while((k|0)!=(g|0));m=e;n=f[a>>2]|0;o=f[d>>2]|0}f[a>>2]=m;f[d>>2]=c;f[i>>2]=l;l=n;if((o|0)!=(l|0)){i=o;do{o=i;i=i+-16|0;if((f[o+-8>>2]|0)==9?(o=f[i>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);YDc(o)}}while((i|0)!=(l|0))}if(!n)return;YDc(n);return}function Xjc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+16|0;g=e;h=g+8|0;i=g+8|0;j=g+8|0;k=g+8|0;l=g+8|0;m=a;a=c;a:while(1){c=a;n=a+-16|0;o=m;while(1){p=o;b:while(1){q=p;r=c-q|0;s=r>>4;switch(s|0){case 2:{t=5;break a;break}case 3:{t=12;break a;break}case 4:{t=13;break a;break}case 5:{t=14;break a;break}case 1:case 0:{t=76;break a;break}default:{}}if((r|0)<112){t=16;break a}v=p+(((s|0)/2|0)<<4)|0;if((r|0)>15984){r=(s|0)/4|0;w=$jc(p,p+(r<<4)|0,v,v+(r<<4)|0,n,d)|0}else w=Zjc(p,v,n,d)|0;if(Yjc(d,p,v)|0){x=n;y=w;break}else z=n;while(1){z=z+-16|0;if((p|0)==(z|0))break;if(Yjc(d,z,v)|0){t=44;break b}}r=p+16|0;if(Yjc(d,p,n)|0)A=r;else{if((r|0)==(n|0)){t=76;break a}else B=r;while(1){if(Yjc(d,p,B)|0)break;r=B+16|0;if((r|0)==(n|0)){t=76;break a}else B=r}f[i>>2]=0;Zcc(g,B);Zcc(B,n);Zcc(n,g);if((f[i>>2]|0)==9?(r=f[g>>2]|0,r|0):0){if((b[r+11>>0]|0)<0)YDc(f[r>>2]|0);YDc(r)}A=B+16|0}if((A|0)==(n|0)){t=76;break a}else{C=n;D=A}while(1){r=D;while(1){E=r+16|0;if(Yjc(d,p,r)|0){F=C;break}else r=E}do F=F+-16|0;while(Yjc(d,p,F)|0);if(r>>>0>=F>>>0){p=r;continue b}f[h>>2]=0;Zcc(g,r);Zcc(r,F);Zcc(F,g);if((f[h>>2]|0)==9?(s=f[g>>2]|0,s|0):0){if((b[s+11>>0]|0)<0)YDc(f[s>>2]|0);YDc(s)}C=F;D=E}}if((t|0)==44){t=0;f[l>>2]=0;Zcc(g,p);Zcc(p,z);Zcc(z,g);if((f[l>>2]|0)==9?(s=f[g>>2]|0,s|0):0){if((b[s+11>>0]|0)<0)YDc(f[s>>2]|0);YDc(s)}x=z;y=w+1|0}s=p+16|0;c:do if(s>>>0<x>>>0){G=v;H=x;I=s;J=y;while(1){K=I;while(1){L=K+16|0;if(Yjc(d,K,G)|0)K=L;else{M=H;break}}do M=M+-16|0;while(!(Yjc(d,M,G)|0));if(K>>>0>M>>>0){N=G;O=J;P=K;break c}f[k>>2]=0;Zcc(g,K);Zcc(K,M);Zcc(M,g);if((f[k>>2]|0)==9?(r=f[g>>2]|0,r|0):0){if((b[r+11>>0]|0)<0)YDc(f[r>>2]|0);YDc(r)}G=(G|0)==(K|0)?M:G;H=M;I=L;J=J+1|0}}else{N=v;O=y;P=s}while(0);if((P|0)!=(N|0)?Yjc(d,N,P)|0:0){f[j>>2]=0;Zcc(g,P);Zcc(P,N);Zcc(N,g);if((f[j>>2]|0)==9?(s=f[g>>2]|0,s|0):0){if((b[s+11>>0]|0)<0)YDc(f[s>>2]|0);YDc(s)}Q=O+1|0}else Q=O;if(!Q){R=bkc(p,P,d)|0;s=P+16|0;if(bkc(s,a,d)|0){t=75;break}if(R){o=s;continue}}s=P;if((s-q|0)>=(c-s|0)){t=74;break}Xjc(p,P,d);o=P+16|0}if((t|0)==74){t=0;Xjc(P+16|0,a,d);m=p;a=P;continue}else if((t|0)==75){t=0;if(R){t=76;break}else{m=p;a=P;continue}}}if((t|0)==5){if(!(Yjc(d,n,p)|0)){u=e;return}P=g+8|0;f[P>>2]=0;Zcc(g,p);Zcc(p,n);Zcc(n,g);if((f[P>>2]|0)==9?(P=f[g>>2]|0,P|0):0){if((b[P+11>>0]|0)<0)YDc(f[P>>2]|0);YDc(P)}u=e;return}else if((t|0)==12){Zjc(p,p+16|0,n,d)|0;u=e;return}else if((t|0)==13){_jc(p,p+16|0,p+32|0,n,d)|0;u=e;return}else if((t|0)==14){$jc(p,p+16|0,p+32|0,p+48|0,n,d)|0;u=e;return}else if((t|0)==16){akc(p,a,d);u=e;return}else if((t|0)==76){u=e;return}}function Yjc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=u;u=u+32|0;e=a;g=a+24|0;switch(kNa(c)|0){case 9:{h=PNa(c)|0;i=PNa(d)|0;j=b[i+11>>0]|0;k=j<<24>>24<0;l=k?f[i+4>>2]|0:j&255;j=b[h+11>>0]|0;m=j<<24>>24<0;n=m?f[h+4>>2]|0:j&255;j=l>>>0<n>>>0;o=j?l:n;if((o|0)!=0?(p=Arc(m?f[h>>2]|0:h,k?f[i>>2]|0:i,o)|0,(p|0)!=0):0)q=p;else q=n>>>0<l>>>0?-1:j&1;r=(q|0)<0;u=a;return r|0}case 2:{q=ddc(c)|0;j=J;l=ddc(d)|0;n=J;r=(j|0)<(n|0)|(j|0)==(n|0)&q>>>0<l>>>0;u=a;return r|0}case 1:{r=(edc(c)|0)<(edc(d)|0);u=a;return r|0}case 4:{l=fdc(c)|0;q=J;n=fdc(d)|0;j=J;r=q>>>0<j>>>0|(q|0)==(j|0)&l>>>0<n>>>0;u=a;return r|0}case 3:{r=(gdc(c)|0)>>>0<(gdc(d)|0)>>>0;u=a;return r|0}case 7:{n=hdc(c)|0;r=(hdc(d)|0)&(n^1);u=a;return r|0}default:{rTb(e,2,503568,936);oTb(g,mTb(e,503950)|0);sTb(e);r=1;u=a;return r|0}}return 0}function Zjc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;i=Yjc(e,c,a)|0;j=Yjc(e,d,c)|0;if(!i){if(!j){k=0;u=g;return k|0}i=h+8|0;f[i>>2]=0;Zcc(h,c);Zcc(c,d);Zcc(d,h);if((f[i>>2]|0)==9?(i=f[h>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}if(!(Yjc(e,c,a)|0)){k=1;u=g;return k|0}i=h+8|0;f[i>>2]=0;Zcc(h,a);Zcc(a,c);Zcc(c,h);if((f[i>>2]|0)==9?(i=f[h>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}k=2;u=g;return k|0}if(j){j=h+8|0;f[j>>2]=0;Zcc(h,a);Zcc(a,d);Zcc(d,h);if((f[j>>2]|0)==9?(j=f[h>>2]|0,j|0):0){if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);YDc(j)}k=1;u=g;return k|0}j=h+8|0;f[j>>2]=0;Zcc(h,a);Zcc(a,c);Zcc(c,h);if((f[j>>2]|0)==9?(j=f[h>>2]|0,j|0):0){if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);YDc(j)}if(!(Yjc(e,d,c)|0)){k=1;u=g;return k|0}e=h+8|0;f[e>>2]=0;Zcc(h,c);Zcc(c,d);Zcc(d,h);if((f[e>>2]|0)==9?(e=f[h>>2]|0,e|0):0){if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(e)}k=2;u=g;return k|0}function _jc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;j=Zjc(a,c,d,g)|0;if(!(Yjc(g,e,d)|0)){k=j;u=h;return k|0}l=i+8|0;f[l>>2]=0;Zcc(i,d);Zcc(d,e);Zcc(e,i);if((f[l>>2]|0)==9?(l=f[i>>2]|0,l|0):0){if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);YDc(l)}if(!(Yjc(g,d,c)|0)){k=j+1|0;u=h;return k|0}l=i+8|0;f[l>>2]=0;Zcc(i,c);Zcc(c,d);Zcc(d,i);if((f[l>>2]|0)==9?(l=f[i>>2]|0,l|0):0){if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);YDc(l)}if(!(Yjc(g,c,a)|0)){k=j+2|0;u=h;return k|0}g=i+8|0;f[g>>2]=0;Zcc(i,a);Zcc(a,c);Zcc(c,i);if((f[g>>2]|0)==9?(g=f[i>>2]|0,g|0):0){if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);YDc(g)}k=j+3|0;u=h;return k|0}function $jc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+16|0;j=i;k=_jc(a,c,d,e,h)|0;if(!(Yjc(h,g,e)|0)){l=k;u=i;return l|0}m=j+8|0;f[m>>2]=0;Zcc(j,e);Zcc(e,g);Zcc(g,j);if((f[m>>2]|0)==9?(m=f[j>>2]|0,m|0):0){if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);YDc(m)}if(!(Yjc(h,e,d)|0)){l=k+1|0;u=i;return l|0}m=j+8|0;f[m>>2]=0;Zcc(j,d);Zcc(d,e);Zcc(e,j);if((f[m>>2]|0)==9?(m=f[j>>2]|0,m|0):0){if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);YDc(m)}if(!(Yjc(h,d,c)|0)){l=k+2|0;u=i;return l|0}m=j+8|0;f[m>>2]=0;Zcc(j,c);Zcc(c,d);Zcc(d,j);if((f[m>>2]|0)==9?(m=f[j>>2]|0,m|0):0){if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);YDc(m)}if(!(Yjc(h,c,a)|0)){l=k+3|0;u=i;return l|0}h=j+8|0;f[h>>2]=0;Zcc(j,a);Zcc(a,c);Zcc(c,j);if((f[h>>2]|0)==9?(h=f[j>>2]|0,h|0):0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}l=k+4|0;u=i;return l|0}function akc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;h=a+32|0;Zjc(a,a+16|0,h,d)|0;i=a+48|0;if((i|0)==(c|0)){u=e;return}j=g+8|0;k=i;i=h;while(1){if(Yjc(d,k,i)|0){f[j>>2]=0;Zcc(g,k);h=i;l=k;while(1){Zcc(l,h);if((h|0)==(a|0)){m=a;break}n=h+-16|0;if(Yjc(d,g,n)|0){o=h;h=n;l=o}else{m=h;break}}Zcc(m,g);if((f[j>>2]|0)==9?(h=f[g>>2]|0,h|0):0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}}h=k+16|0;if((h|0)==(c|0))break;else{l=k;k=h;i=l}}u=e;return}function bkc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e;switch(c-a>>4|0){case 2:{h=c+-16|0;if(!(Yjc(d,h,a)|0)){i=1;u=e;return i|0}j=g+8|0;f[j>>2]=0;Zcc(g,a);Zcc(a,h);Zcc(h,g);if((f[j>>2]|0)==9?(j=f[g>>2]|0,j|0):0){if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);YDc(j)}i=1;u=e;return i|0}case 3:{Zjc(a,a+16|0,c+-16|0,d)|0;i=1;u=e;return i|0}case 4:{_jc(a,a+16|0,a+32|0,c+-16|0,d)|0;i=1;u=e;return i|0}case 5:{$jc(a,a+16|0,a+32|0,a+48|0,c+-16|0,d)|0;i=1;u=e;return i|0}case 1:case 0:{i=1;u=e;return i|0}default:{j=a+32|0;Zjc(a,a+16|0,j,d)|0;h=a+48|0;a:do if((h|0)==(c|0)){k=1;l=0}else{m=g+8|0;n=h;o=0;p=j;while(1){if(Yjc(d,n,p)|0){f[m>>2]=0;Zcc(g,n);q=p;r=n;while(1){Zcc(r,q);if((q|0)==(a|0)){s=a;break}t=q+-16|0;if(Yjc(d,g,t)|0){v=q;q=t;r=v}else{s=q;break}}Zcc(s,g);q=o+1|0;r=(q|0)==8;v=(n+16|0)==(c|0);if((f[m>>2]|0)==9?(t=f[g>>2]|0,t|0):0){if((b[t+11>>0]|0)<0)YDc(f[t>>2]|0);YDc(t)}if(r){k=0;l=v;break a}else w=q}else w=o;q=n+16|0;if((q|0)==(c|0)){k=1;l=0;break}else{v=n;n=q;o=w;p=v}}}while(0);i=k|l;u=e;return i|0}}return 0}function ckc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c+4|0;e=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d>>2]|0;h=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;f[d>>2]=0;i=d+4|0;f[i>>2]=0;f[d+8>>2]=0;j=g+16|0;a:do if(b[(f[j>>2]|0)+51>>0]|0){k=g+52|0;l=f[k>>2]|0;if((l|0)>0){m=g+20|0;n=d+8|0;o=0;p=l;l=0;q=0;while(1){r=(f[m>>2]|0)+(o*88|0)|0;f[e>>2]=r;if((l|0)==(q|0)){jWb(d,e);s=f[k>>2]|0}else{f[l>>2]=r;f[i>>2]=(f[i>>2]|0)+4;s=p}r=o+1|0;if((r|0)>=(s|0))break a;o=r;p=s;l=f[i>>2]|0;q=f[n>>2]|0}}}else Ti[f[(f[h>>2]|0)+64>>2]&511](h,a,d);while(0);s=f[d>>2]|0;if((f[i>>2]|0)==(s|0))t=0;else{e=0;g=0;n=s;while(1){s=(dkc(f[n+(g<<2)>>2]|0,a)|0)+e|0;g=g+1|0;n=f[d>>2]|0;if(g>>>0>=(f[i>>2]|0)-n>>2>>>0){t=s;break}else e=s}}e=(b[(f[j>>2]|0)+48>>0]|0)==0;j=Mi[f[(f[h>>2]|0)+8>>2]&1023](h,a)|0;if(!e){e=f[j>>2]|0;a=f[40265]|0;if((e|0)!=0?(h=f[e>>2]|0,n=h,g=(f[e+4>>2]|0)-h|0,h=g>>4,(g|0)>0):0){g=0;e=0;while(1){if((f[n+(e<<4)+4>>2]|0)==3){s=g+a+((((($(f[n+(e<<4)>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;q=f[n+(e<<4)+8>>2]|0;l=b[q+11>>0]|0;if(l<<24>>24<0)v=f[q+4>>2]|0;else v=l&255;w=s+v+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else w=g;e=e+1|0;if((e|0)>=(h|0)){x=w;break}else g=w}}else x=0}else x=Jjc(j)|0;j=x+t|0;t=f[d>>2]|0;if(!t){u=c;return j|0}d=f[i>>2]|0;if((d|0)!=(t|0))f[i>>2]=d+(~((d+-4-t|0)>>>2)<<2);YDc(t);u=c;return j|0}function dkc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;if(b[a+38>>0]|0?b[(f[(f[a+48>>2]|0)+16>>2]|0)+48>>0]|0:0){h=f[a+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(h,e)}if((f[161216+(f[a+28>>2]<<2)>>2]|0)==10?(f[a+32>>2]|0)!=3:0){h=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;i=((((($(f[a+40>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+(f[40265]|0)|0;j=hh[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;h=_i[f[(f[j>>2]|0)+48>>2]&1023](j)|0;k=i+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return k|0}}if((f[a+32>>2]|0)!=3)if(!(b[(f[(f[a+48>>2]|0)+16>>2]|0)+51>>0]|0))l=(hj[f[(f[g>>2]|0)+20>>2]&511](g,c,a)|0)&1;else l=1;else l=hj[f[(f[g>>2]|0)+24>>2]&511](g,c,a)|0;g=Tjc(a,c)|0;if(FYb(a)|0){if(!g){k=0;u=d;return k|0}k=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+g+((((($(f[a+40>>2]<<3|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return k|0}c=f[a+40>>2]|0;h=f[a+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(h,e)}k=(Y((((($(c<<3|1|0)|0)^31)*9|0)+73|0)>>>6<<((f[a+28>>2]|0)==10&1),l)|0)+g|0;u=d;return k|0}function ekc(a){a=a|0;return}function fkc(a){a=a|0;YDc(a);return}function gkc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+4>>2]|0;a=f[220890]|0;if(!a){e=0;return e|0}g=(d*65535|0)+b|0;h=f[a+4>>2]|0;if(!h){e=0;return e|0}i=h+-1|0;j=(i&h|0)==0;if(!j)if(g>>>0<h>>>0)k=g;else k=(g>>>0)%(h>>>0)|0;else k=i&g;l=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!l){e=0;return e|0}a=f[l>>2]|0;if(!a){e=0;return e|0}a:do if(j){l=a;while(1){m=f[l+4>>2]|0;n=(m|0)==(g|0);if(!(n|(m&i|0)==(k|0))){e=0;o=23;break}if((n?(f[l+8>>2]|0)==(d|0):0)?(f[l+12>>2]|0)==(b|0):0){p=l;break a}l=f[l>>2]|0;if(!l){e=0;o=23;break}}if((o|0)==23)return e|0}else{l=a;while(1){n=f[l+4>>2]|0;if((n|0)==(g|0)){if((f[l+8>>2]|0)==(d|0)?(f[l+12>>2]|0)==(b|0):0){p=l;break a}}else{if(n>>>0<h>>>0)q=n;else q=(n>>>0)%(h>>>0)|0;if((q|0)!=(k|0)){e=0;o=23;break}}l=f[l>>2]|0;if(!l){e=0;o=23;break}}if((o|0)==23)return e|0}while(0);o=p+16|0;f[c>>2]=f[o>>2];f[c+4>>2]=f[o+4>>2];f[c+8>>2]=f[o+8>>2];f[c+12>>2]=f[o+12>>2];e=1;return e|0}function hkc(a,b){a=a|0;b=b|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;f[a+12>>2]=b;if(!b)return;ikc(b,a);return}function ikc(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1783);return}function jkc(a,b){a=a|0;b=b|0;if(!b)return;else{jkc(a,f[b>>2]|0);jkc(a,f[b+4>>2]|0);YDc(b);return}}function kkc(a){a=a|0;jkc(a,f[a+4>>2]|0);return}function lkc(a){a=a|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;f[a+12>>2]=0;return}function mkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+12>>2]|0)){b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0))d=c;else{e=b;while(1){nkc(e+24|0);b=f[e+4>>2]|0;if(!b){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))i=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;j=f[h>>2]|0}while((f[j>>2]|0)!=(g|0));i=j}}else{h=b;while(1){j=f[h>>2]|0;if(!j)break;else h=j}i=h}if((i|0)==(c|0)){d=c;break}else e=i}}}else d=a+4|0;jkc(a,f[d>>2]|0);return}function nkc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[161064+(h[a+8>>0]<<2)>>2]|0;if(!(b[a+9>>0]|0))switch(c|0){case 9:{d=f[a>>2]|0;if(!d)return;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);YDc(d);return}case 10:{d=f[a>>2]|0;e=(d|0)==0;if(!(b[a+10>>0]&16)){if(e)return;Yi[f[(f[d>>2]|0)+4>>2]&2047](d);return}else{if(e)return;Yi[f[(f[d>>2]|0)+4>>2]&2047](d);return}break}default:return}do switch(c|0){case 1:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)YDc(e);YDc(d);return}case 2:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)YDc(e);YDc(d);return}case 3:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)YDc(e);YDc(d);return}case 4:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)YDc(e);YDc(d);return}case 6:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)YDc(e);YDc(d);return}case 5:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)YDc(e);YDc(d);return}case 7:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)YDc(e);YDc(d);return}case 8:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)YDc(e);YDc(d);return}case 9:{d=f[a>>2]|0;if(!d)return;e=d+12|0;g=f[e>>2]|0;if(g|0?(f[d>>2]|0)==0:0){i=f[g>>2]|0;if((i|0)>0){j=0;do{k=f[g+4+(j<<2)>>2]|0;if(k|0){if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);YDc(k)}j=j+1|0}while((j|0)!=(i|0));l=f[e>>2]|0}else l=g;YDc(l)}YDc(d);return}case 10:{i=f[a>>2]|0;if(!i)return;j=i+12|0;k=f[j>>2]|0;if(k|0?(f[i>>2]|0)==0:0){m=f[k>>2]|0;if((m|0)>0){n=0;do{o=f[k+4+(n<<2)>>2]|0;if(o|0)Yi[f[(f[o>>2]|0)+4>>2]&2047](o);n=n+1|0}while((n|0)!=(m|0));p=f[j>>2]|0}else p=k;YDc(p)}YDc(i);return}default:return}while(0)}function okc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;a=f[d>>2]|0;if(!a){e=0;return e|0}else{g=d;h=a}a:while(1){a=h;while(1){if((f[a+16>>2]|0)>=(c|0))break;i=f[a+4>>2]|0;if(!i){j=g;break a}else a=i}h=f[a>>2]|0;if(!h){j=a;break}else g=a}if((j|0)==(d|0)){e=0;return e|0}d=j+16|0;if((f[d>>2]|0)>(c|0)){e=0;return e|0}e=(b[d+18>>0]&1)==0;return e|0}function pkc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;a=f[c>>2]|0;if(!a){d=0;return d|0}else{e=c;g=a}a:while(1){a=g;while(1){if((f[a+16>>2]|0)>=(b|0))break;h=f[a+4>>2]|0;if(!h){i=e;break a}else a=h}g=f[a>>2]|0;if(!g){i=a;break}else e=a}if((i|0)==(c|0)){d=0;return d|0}if((f[i+16>>2]|0)>(b|0)){d=0;return d|0}d=qkc(i+24|0)|0;return d|0}function qkc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+32|0;c=b;do switch(f[161064+((h[a+8>>0]|0)<<2)>>2]|0){case 1:{d=f[f[a>>2]>>2]|0;break}case 2:{d=f[f[a>>2]>>2]|0;break}case 3:{d=f[f[a>>2]>>2]|0;break}case 4:{d=f[f[a>>2]>>2]|0;break}case 6:{d=f[f[a>>2]>>2]|0;break}case 5:{d=f[f[a>>2]>>2]|0;break}case 7:{d=f[f[a>>2]>>2]|0;break}case 8:{d=f[f[a>>2]>>2]|0;break}case 9:{d=f[(f[a>>2]|0)+4>>2]|0;break}case 10:{d=f[(f[a>>2]|0)+4>>2]|0;break}default:{rTb(c,3,504144,1703);oTb(b+24|0,mTb(c,504236)|0);sTb(c);d=0}}while(0);u=b;return d|0}function rkc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;a=f[c>>2]|0;if(!a)return;else{d=c;e=a}a:while(1){a=e;while(1){if((f[a+16>>2]|0)>=(b|0))break;g=f[a+4>>2]|0;if(!g){h=d;break a}else a=g}e=f[a>>2]|0;if(!e){h=a;break}else d=a}if((h|0)==(c|0))return;if((f[h+16>>2]|0)>(b|0))return;skc(h+24|0);return}function skc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0;if(!(b[a+9>>0]|0)){c=a+10|0;d=b[c>>0]|0;if(d&1)return;a:do switch(f[161064+(h[a+8>>0]<<2)>>2]|0){case 9:{e=f[a>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break a}else{b[e>>0]=0;b[g>>0]=0;break a}break}case 10:{g=f[a>>2]|0;e=f[g>>2]|0;if(!(d&16)){Yi[f[e+28>>2]&2047](g);break a}else{Yi[f[e+52>>2]&2047](g);break a}break}default:{}}while(0);b[c>>0]=b[c>>0]&-16|1;return}do switch(f[161064+(h[a+8>>0]<<2)>>2]|0){case 1:{f[f[a>>2]>>2]=0;return}case 2:{f[f[a>>2]>>2]=0;return}case 3:{f[f[a>>2]>>2]=0;return}case 4:{f[f[a>>2]>>2]=0;return}case 6:{f[f[a>>2]>>2]=0;return}case 5:{f[f[a>>2]>>2]=0;return}case 7:{f[f[a>>2]>>2]=0;return}case 8:{f[f[a>>2]>>2]=0;return}case 9:{c=f[a>>2]|0;d=c+4|0;g=f[d>>2]|0;if((g|0)<=0)return;e=f[c+12>>2]|0;c=0;do{i=f[e+4+(c<<2)>>2]|0;c=c+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((c|0)!=(g|0));f[d>>2]=0;return}case 10:{g=f[a>>2]|0;c=g+4|0;e=f[c>>2]|0;if((e|0)<=0)return;j=f[g+12>>2]|0;g=0;do{i=f[j+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((g|0)!=(e|0));f[c>>2]=0;return}default:return}while(0)}function tkc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function ukc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=VDc(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)A=j;else{f[a>>2]=v;A=f[t>>2]|0}laa(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function vkc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+32|0;g=e;h=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;h=a+4|0;i=f[h>>2]|0;do if(i){j=a+4|0;k=i;while(1){l=f[k+16>>2]|0;if((l|0)>(b|0)){m=f[k>>2]|0;if(!m){n=5;break}else{o=k;p=m}}else{if((l|0)>=(b|0)){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==5){r=k;s=k;break}else if((n|0)==9){r=q;s=k;break}else if((n|0)==10){r=j;s=k;break}}else{r=h;s=h}while(0);h=f[r>>2]|0;if(h|0){t=h;v=0;w=t+24|0;f[d>>2]=w;x=t+40|0;f[x>>2]=c;u=e;return v|0}h=VDc(48)|0;f[h+16>>2]=b;b=h+20|0;f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[b+16>>2]=f[g+16>>2];f[b+20>>2]=f[g+20>>2];f[b+24>>2]=f[g+24>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=s;f[r>>2]=h;s=f[f[a>>2]>>2]|0;if(!s)y=h;else{f[a>>2]=s;y=f[r>>2]|0}laa(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;t=h;v=1;w=t+24|0;f[d>>2]=w;x=t+40|0;f[x>>2]=c;u=e;return v|0}function wkc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,326);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function xkc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}rTb(g,3,504144,326);oTb(h,mTb(mTb(g,504252)|0,504294)|0);sTb(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function ykc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=k;w=k}while(0);k=f[v>>2]|0;if(!k){q=VDc(48)|0;f[q+16>>2]=c;c=q+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=w;f[v>>2]=q;w=f[f[a>>2]>>2]|0;if(!w)x=q;else{f[a>>2]=w;x=f[v>>2]|0}laa(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;x=q+24|0;f[q+40>>2]=h;b[q+32>>0]=d;b[q+33>>0]=1;b[q+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;y=a}else{a=e+64|0;if(f[a>>2]|0)OQb(e,21472,16);q=NQb(e,16,1784)|0;f[q>>2]=0;f[q+4>>2]=0;d=q+8|0;f[d>>2]=0;if(f[a>>2]|0)OQb(e,23816,8);a=MQb(e,8)|0;f[d>>2]=a;f[a>>2]=e;y=q}f[x>>2]=y;z=x}else{f[k+40>>2]=h;z=k+24|0}k=f[z>>2]|0;z=f[k>>2]|0;if((z|0)!=(f[k+4>>2]|0)){A=z;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}KLa(k,z+1|0);A=f[k>>2]|0;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}function zkc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;YDc(b);return}function Akc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(b[g+18>>0]&1)==0:0){g=k+24|0;l=f[g+4>>2]|0;m=f[g>>2]|0}else{l=e;m=d}}else{l=e;m=d}J=l;return m|0}function Bkc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=k;w=k}while(0);k=f[v>>2]|0;if(k|0){f[k+40>>2]=h;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}k=VDc(48)|0;f[k+16>>2]=c;c=k+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=w;f[v>>2]=k;w=f[f[a>>2]>>2]|0;if(!w)F=k;else{f[a>>2]=w;F=f[v>>2]|0}laa(f[a+4>>2]|0,F);F=a+8|0;f[F>>2]=(f[F>>2]|0)+1;f[k+40>>2]=h;b[k+32>>0]=d;b[k+33>>0]=0;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}function Ckc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,327);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}h=(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;J=f[h+4>>2]|0;u=d;return f[h>>2]|0}function Dkc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g;i=g+24|0;j=a+4|0;a=f[j>>2]|0;if(a){k=j;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(b|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(j|0)?(f[n+16>>2]|0)<=(b|0):0)o=n;else p=8}else p=8;if((p|0)==8){rTb(h,3,504144,327);oTb(i,mTb(mTb(h,504252)|0,504294)|0);sTb(h);o=j}j=(f[(f[o+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;f[j>>2]=d;f[j+4>>2]=e;u=g;return}function Ekc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=u;u=u+32|0;k=j;l=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){n=a+4|0;o=m;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}n=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=v;x=o;break}else if((r|0)==10){w=n;x=o;break}}else{w=l;x=l}while(0);l=f[w>>2]|0;if(!l){r=VDc(48)|0;f[r+16>>2]=c;c=r+20|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;x=f[f[a>>2]>>2]|0;if(!x)y=r;else{f[a>>2]=x;y=f[w>>2]|0}laa(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=r+24|0;f[r+40>>2]=i;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;z=a}else{a=e+64|0;if(f[a>>2]|0)OQb(e,21480,16);r=NQb(e,16,1785)|0;f[r>>2]=0;f[r+4>>2]=0;d=r+8|0;f[d>>2]=0;if(f[a>>2]|0)OQb(e,23816,8);a=MQb(e,8)|0;f[d>>2]=a;f[a>>2]=e;z=r}f[y>>2]=z;A=y}else{f[l+40>>2]=i;A=l+24|0}l=f[A>>2]|0;A=f[l>>2]|0;if((A|0)!=(f[l+4>>2]|0)){B=A;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+8+(B<<3)|0;G=F;H=G;f[H>>2]=g;I=G+4|0;J=I;f[J>>2]=h;u=j;return}UHa(l,A+1|0);B=f[l>>2]|0;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+8+(B<<3)|0;G=F;H=G;f[H>>2]=g;I=G+4|0;J=I;f[J>>2]=h;u=j;return}function Fkc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;YDc(b);return}function Gkc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function Hkc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=VDc(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)A=j;else{f[a>>2]=v;A=f[t>>2]|0}laa(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function Ikc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,328);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function Jkc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}rTb(g,3,504144,328);oTb(h,mTb(mTb(g,504252)|0,504294)|0);sTb(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function Kkc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=k;w=k}while(0);k=f[v>>2]|0;if(!k){q=VDc(48)|0;f[q+16>>2]=c;c=q+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=w;f[v>>2]=q;w=f[f[a>>2]>>2]|0;if(!w)x=q;else{f[a>>2]=w;x=f[v>>2]|0}laa(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;x=q+24|0;f[q+40>>2]=h;b[q+32>>0]=d;b[q+33>>0]=1;b[q+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;y=a}else{a=e+64|0;if(f[a>>2]|0)OQb(e,21488,16);q=NQb(e,16,1786)|0;f[q>>2]=0;f[q+4>>2]=0;d=q+8|0;f[d>>2]=0;if(f[a>>2]|0)OQb(e,23816,8);a=MQb(e,8)|0;f[d>>2]=a;f[a>>2]=e;y=q}f[x>>2]=y;z=x}else{f[k+40>>2]=h;z=k+24|0}k=f[z>>2]|0;z=f[k>>2]|0;if((z|0)!=(f[k+4>>2]|0)){A=z;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}OLa(k,z+1|0);A=f[k>>2]|0;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}function Lkc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;YDc(b);return}function Mkc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(b[g+18>>0]&1)==0:0){g=k+24|0;l=f[g+4>>2]|0;m=f[g>>2]|0}else{l=e;m=d}}else{l=e;m=d}J=l;return m|0}function Nkc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=k;w=k}while(0);k=f[v>>2]|0;if(k|0){f[k+40>>2]=h;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}k=VDc(48)|0;f[k+16>>2]=c;c=k+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=w;f[v>>2]=k;w=f[f[a>>2]>>2]|0;if(!w)F=k;else{f[a>>2]=w;F=f[v>>2]|0}laa(f[a+4>>2]|0,F);F=a+8|0;f[F>>2]=(f[F>>2]|0)+1;f[k+40>>2]=h;b[k+32>>0]=d;b[k+33>>0]=0;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}function Okc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,329);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}h=(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;J=f[h+4>>2]|0;u=d;return f[h>>2]|0}function Pkc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g;i=g+24|0;j=a+4|0;a=f[j>>2]|0;if(a){k=j;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(b|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(j|0)?(f[n+16>>2]|0)<=(b|0):0)o=n;else p=8}else p=8;if((p|0)==8){rTb(h,3,504144,329);oTb(i,mTb(mTb(h,504252)|0,504294)|0);sTb(h);o=j}j=(f[(f[o+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;f[j>>2]=d;f[j+4>>2]=e;u=g;return}function Qkc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=u;u=u+32|0;k=j;l=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){n=a+4|0;o=m;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}n=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=v;x=o;break}else if((r|0)==10){w=n;x=o;break}}else{w=l;x=l}while(0);l=f[w>>2]|0;if(!l){r=VDc(48)|0;f[r+16>>2]=c;c=r+20|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;x=f[f[a>>2]>>2]|0;if(!x)y=r;else{f[a>>2]=x;y=f[w>>2]|0}laa(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=r+24|0;f[r+40>>2]=i;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;z=a}else{a=e+64|0;if(f[a>>2]|0)OQb(e,21496,16);r=NQb(e,16,1787)|0;f[r>>2]=0;f[r+4>>2]=0;d=r+8|0;f[d>>2]=0;if(f[a>>2]|0)OQb(e,23816,8);a=MQb(e,8)|0;f[d>>2]=a;f[a>>2]=e;z=r}f[y>>2]=z;A=y}else{f[l+40>>2]=i;A=l+24|0}l=f[A>>2]|0;A=f[l>>2]|0;if((A|0)!=(f[l+4>>2]|0)){B=A;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+8+(B<<3)|0;G=F;H=G;f[H>>2]=g;I=G+4|0;J=I;f[J>>2]=h;u=j;return}Hjb(l,A+1|0);B=f[l>>2]|0;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+8+(B<<3)|0;G=F;H=G;f[H>>2]=g;I=G+4|0;J=I;f[J>>2]=h;u=j;return}function Rkc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;YDc(b);return}function Skc(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0.0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return +g}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return +g}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return +g}if(b[e+18>>0]&1){g=d;return +g}g=+n[k+24>>2];return +g}function Tkc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){o=f[m+16>>2]|0;if((o|0)>(c|0)){p=f[m>>2]|0;if(!p){q=5;break}else{r=m;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=m+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}l=r;m=s}if((q|0)==5){v=m;w=m;break}else if((q|0)==9){v=t;w=m;break}else if((q|0)==10){v=l;w=m;break}}else{v=j;w=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;n[x>>2]=e;u=h;return}j=VDc(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=w;f[v>>2]=j;w=f[f[a>>2]>>2]|0;if(!w)B=j;else{f[a>>2]=w;B=f[v>>2]|0}laa(f[a+4>>2]|0,B);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;n[x>>2]=e;u=h;return}function Ukc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else o=8}else o=8;if((o|0)==8){rTb(e,3,504144,330);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return +(+n[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2])}function Vkc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){o=m;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+(c<<2)|0;n[t>>2]=d;u=e;return}}rTb(g,3,504144,330);oTb(h,mTb(mTb(g,504252)|0,504294)|0);sTb(g);o=i;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+(c<<2)|0;n[t>>2]=d;u=e;return}function Wkc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;o=l;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}m=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=v;x=o;break}else if((r|0)==10){w=m;x=o;break}}else{w=k;x=k}while(0);k=f[w>>2]|0;if(!k){r=VDc(48)|0;f[r+16>>2]=c;c=r+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;x=f[f[a>>2]>>2]|0;if(!x)y=r;else{f[a>>2]=x;y=f[w>>2]|0}laa(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=r+24|0;f[r+40>>2]=h;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;z=a}else{a=e+64|0;if(f[a>>2]|0)OQb(e,21504,16);r=NQb(e,16,1788)|0;f[r>>2]=0;f[r+4>>2]=0;d=r+8|0;f[d>>2]=0;if(f[a>>2]|0)OQb(e,23816,8);a=MQb(e,8)|0;f[d>>2]=a;f[a>>2]=e;z=r}f[y>>2]=z;A=y}else{f[k+40>>2]=h;A=k+24|0}k=f[A>>2]|0;A=f[k>>2]|0;if((A|0)!=(f[k+4>>2]|0)){B=A;C=k+8|0;D=f[C>>2]|0;E=B+1|0;f[k>>2]=E;F=D+4+(B<<2)|0;n[F>>2]=g;u=i;return}SHa(k,A+1|0);B=f[k>>2]|0;C=k+8|0;D=f[C>>2]|0;E=B+1|0;f[k>>2]=E;F=D+4+(B<<2)|0;n[F>>2]=g;u=i;return}function Xkc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;YDc(b);return}function Ykc(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0.0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return +g}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return +g}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return +g}if(b[e+18>>0]&1){g=d;return +g}g=+p[k+24>>3];return +g}function Zkc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){q=5;break}else{r=m;s=o}}else{if((n|0)>=(c|0)){q=10;break}t=m+4|0;n=f[t>>2]|0;if(!n){q=9;break}else{r=t;s=n}}l=r;m=s}if((q|0)==5){v=m;w=m;break}else if((q|0)==9){v=t;w=m;break}else if((q|0)==10){v=l;w=m;break}}else{v=j;w=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;p[x>>3]=e;u=h;return}j=VDc(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=w;f[v>>2]=j;w=f[f[a>>2]>>2]|0;if(!w)B=j;else{f[a>>2]=w;B=f[v>>2]|0}laa(f[a+4>>2]|0,B);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;p[x>>3]=e;u=h;return}function _kc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,331);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return +(+p[(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)>>3])}function $kc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;q=f[o>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+8+(c<<3)|0;p[t>>3]=d;u=e;return}}rTb(g,3,504144,331);oTb(h,mTb(mTb(g,504252)|0,504294)|0);sTb(g);n=i;o=n+24|0;q=f[o>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+8+(c<<3)|0;p[t>>3]=d;u=e;return}function alc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){q=f[n>>2]|0;if(!q){r=5;break}else{s=n;t=q}}else{if((o|0)>=(c|0)){r=10;break}v=n+4|0;o=f[v>>2]|0;if(!o){r=9;break}else{s=v;t=o}}m=s;n=t}if((r|0)==5){w=n;x=n;break}else if((r|0)==9){w=v;x=n;break}else if((r|0)==10){w=m;x=n;break}}else{w=k;x=k}while(0);k=f[w>>2]|0;if(!k){r=VDc(48)|0;f[r+16>>2]=c;c=r+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;x=f[f[a>>2]>>2]|0;if(!x)y=r;else{f[a>>2]=x;y=f[w>>2]|0}laa(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=r+24|0;f[r+40>>2]=h;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;z=a}else{a=e+64|0;if(f[a>>2]|0)OQb(e,21512,16);r=NQb(e,16,1789)|0;f[r>>2]=0;f[r+4>>2]=0;d=r+8|0;f[d>>2]=0;if(f[a>>2]|0)OQb(e,23816,8);a=MQb(e,8)|0;f[d>>2]=a;f[a>>2]=e;z=r}f[y>>2]=z;A=y}else{f[k+40>>2]=h;A=k+24|0}k=f[A>>2]|0;A=f[k>>2]|0;if((A|0)!=(f[k+4>>2]|0)){B=A;C=k+8|0;D=f[C>>2]|0;E=B+1|0;f[k>>2]=E;F=D+8+(B<<3)|0;p[F>>3]=g;u=i;return}THa(k,A+1|0);B=f[k>>2]|0;C=k+8|0;D=f[C>>2]|0;E=B+1|0;f[k>>2]=E;F=D+8+(B<<3)|0;p[F>>3]=g;u=i;return}function blc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;YDc(b);return}function clc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=(b[k+24>>0]|0)!=0;return g|0}function dlc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=e&1;e=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;e=a+4|0;k=f[e>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=e;v=e}while(0);e=f[t>>2]|0;if(e|0){f[e+40>>2]=g;w=e+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;b[w>>0]=j;u=h;return}e=VDc(48)|0;f[e+16>>2]=c;c=e+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=v;f[t>>2]=e;v=f[f[a>>2]>>2]|0;if(!v)A=e;else{f[a>>2]=v;A=f[t>>2]|0}laa(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[e+40>>2]=g;b[e+32>>0]=d;b[e+33>>0]=0;w=e+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;b[w>>0]=j;u=h;return}function elc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(c|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(c|0):0)n=m;else o=8}else o=8;if((o|0)==8){rTb(g,3,504144,332);oTb(h,mTb(mTb(g,504252)|0,504294)|0);sTb(g);n=i}u=e;return (b[(f[(f[n+24>>2]|0)+8>>2]|0)+4+d>>0]|0)!=0|0}function flc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+32|0;h=g;i=g+24|0;j=e&1;e=a+4|0;a=f[e>>2]|0;if(a|0){k=e;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(c|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(e|0)?(f[n+16>>2]|0)<=(c|0):0){o=n;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+d|0;b[t>>0]=j;u=g;return}}rTb(h,3,504144,332);oTb(i,mTb(mTb(h,504252)|0,504294)|0);sTb(h);o=e;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+d|0;b[t>>0]=j;u=g;return}function glc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i;k=g&1;g=j+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;g=a+4|0;l=f[g>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=g;w=g}while(0);g=f[v>>2]|0;if(!g){q=VDc(48)|0;f[q+16>>2]=c;c=q+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=w;f[v>>2]=q;w=f[f[a>>2]>>2]|0;if(!w)x=q;else{f[a>>2]=w;x=f[v>>2]|0}laa(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;x=q+24|0;f[q+40>>2]=h;b[q+32>>0]=d;b[q+33>>0]=1;b[q+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;y=a}else{a=e+64|0;if(f[a>>2]|0)OQb(e,21520,16);q=NQb(e,16,1790)|0;f[q>>2]=0;f[q+4>>2]=0;d=q+8|0;f[d>>2]=0;if(f[a>>2]|0)OQb(e,23816,8);a=MQb(e,8)|0;f[d>>2]=a;f[a>>2]=e;y=q}f[x>>2]=y;z=x}else{f[g+40>>2]=h;z=g+24|0}g=f[z>>2]|0;z=f[g>>2]|0;if((z|0)!=(f[g+4>>2]|0)){A=z;B=g+8|0;C=f[B>>2]|0;D=A+1|0;f[g>>2]=D;E=C+4+A|0;b[E>>0]=k;u=i;return}zNa(g,z+1|0);A=f[g>>2]|0;B=g+8|0;C=f[B>>2]|0;D=A+1|0;f[g>>2]=D;E=C+4+A|0;b[E>>0]=k;u=i;return}function hlc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;YDc(b);return}function ilc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=f[w>>2]|0;u=h;return x|0}j=VDc(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)y=j;else{f[a>>2]=v;y=f[t>>2]|0}laa(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=j+24|0;f[j+40>>2]=g;b[j+33>>0]=1;b[j+32>>0]=d;b[j+35>>0]=e&1;do switch(f[161064+((d&255)<<2)>>2]|0){case 1:{e=f[a+12>>2]|0;if(!e){j=VDc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;z=j}else{j=e+64|0;if(f[j>>2]|0)OQb(e,21472,16);g=NQb(e,16,1784)|0;f[g>>2]=0;f[g+4>>2]=0;t=g+8|0;f[t>>2]=0;if(f[j>>2]|0)OQb(e,23816,8);j=MQb(e,8)|0;f[t>>2]=j;f[j>>2]=e;z=g}f[y>>2]=z;w=y;x=f[w>>2]|0;u=h;return x|0}case 2:{g=f[a+12>>2]|0;if(!g){e=VDc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;A=e}else{e=g+64|0;if(f[e>>2]|0)OQb(g,21480,16);j=NQb(g,16,1785)|0;f[j>>2]=0;f[j+4>>2]=0;t=j+8|0;f[t>>2]=0;if(f[e>>2]|0)OQb(g,23816,8);e=MQb(g,8)|0;f[t>>2]=e;f[e>>2]=g;A=j}f[y>>2]=A;w=y;x=f[w>>2]|0;u=h;return x|0}case 3:{j=f[a+12>>2]|0;if(!j){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;B=g}else{g=j+64|0;if(f[g>>2]|0)OQb(j,21488,16);e=NQb(j,16,1786)|0;f[e>>2]=0;f[e+4>>2]=0;t=e+8|0;f[t>>2]=0;if(f[g>>2]|0)OQb(j,23816,8);g=MQb(j,8)|0;f[t>>2]=g;f[g>>2]=j;B=e}f[y>>2]=B;w=y;x=f[w>>2]|0;u=h;return x|0}case 4:{e=f[a+12>>2]|0;if(!e){j=VDc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;C=j}else{j=e+64|0;if(f[j>>2]|0)OQb(e,21496,16);g=NQb(e,16,1787)|0;f[g>>2]=0;f[g+4>>2]=0;t=g+8|0;f[t>>2]=0;if(f[j>>2]|0)OQb(e,23816,8);j=MQb(e,8)|0;f[t>>2]=j;f[j>>2]=e;C=g}f[y>>2]=C;w=y;x=f[w>>2]|0;u=h;return x|0}case 5:{g=f[a+12>>2]|0;if(!g){e=VDc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;D=e}else{e=g+64|0;if(f[e>>2]|0)OQb(g,21512,16);j=NQb(g,16,1789)|0;f[j>>2]=0;f[j+4>>2]=0;t=j+8|0;f[t>>2]=0;if(f[e>>2]|0)OQb(g,23816,8);e=MQb(g,8)|0;f[t>>2]=e;f[e>>2]=g;D=j}f[y>>2]=D;w=y;x=f[w>>2]|0;u=h;return x|0}case 6:{j=f[a+12>>2]|0;if(!j){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;E=g}else{g=j+64|0;if(f[g>>2]|0)OQb(j,21504,16);e=NQb(j,16,1788)|0;f[e>>2]=0;f[e+4>>2]=0;t=e+8|0;f[t>>2]=0;if(f[g>>2]|0)OQb(j,23816,8);g=MQb(j,8)|0;f[t>>2]=g;f[g>>2]=j;E=e}f[y>>2]=E;w=y;x=f[w>>2]|0;u=h;return x|0}case 7:{e=f[a+12>>2]|0;if(!e){j=VDc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;F=j}else{j=e+64|0;if(f[j>>2]|0)OQb(e,21520,16);g=NQb(e,16,1790)|0;f[g>>2]=0;f[g+4>>2]=0;t=g+8|0;f[t>>2]=0;if(f[j>>2]|0)OQb(e,23816,8);j=MQb(e,8)|0;f[t>>2]=j;f[j>>2]=e;F=g}f[y>>2]=F;w=y;x=f[w>>2]|0;u=h;return x|0}case 8:{g=f[a+12>>2]|0;if(!g){e=VDc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G=e}else{e=g+64|0;if(f[e>>2]|0)OQb(g,21472,16);j=NQb(g,16,1784)|0;f[j>>2]=0;f[j+4>>2]=0;t=j+8|0;f[t>>2]=0;if(f[e>>2]|0)OQb(g,23816,8);e=MQb(g,8)|0;f[t>>2]=e;f[e>>2]=g;G=j}f[y>>2]=G;w=y;x=f[w>>2]|0;u=h;return x|0}case 9:{j=f[a+12>>2]|0;if(!j){g=VDc(16)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;H=g}else{if(f[j+64>>2]|0)OQb(j,21528,16);g=NQb(j,16,1791)|0;f[g>>2]=j;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;H=g}f[y>>2]=H;w=y;x=f[w>>2]|0;u=h;return x|0}case 10:{g=f[a+12>>2]|0;if(!g){j=VDc(16)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;I=j}else{if(f[g+64>>2]|0)OQb(g,20856,16);j=NQb(g,16,1779)|0;f[j>>2]=g;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;I=j}f[y>>2]=I;w=y;x=f[w>>2]|0;u=h;return x|0}default:{w=y;x=f[w>>2]|0;u=h;return x|0}}while(0);return 0}function jlc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+12|0;d=f[c>>2]|0;if(!d){f[c>>2]=0;return}if(f[a>>2]|0){f[c>>2]=0;return}a=f[d>>2]|0;if((a|0)>0){e=0;do{g=f[d+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);YDc(g)}e=e+1|0}while((e|0)!=(a|0));h=f[c>>2]|0}else h=d;YDc(h);f[c>>2]=0;return}function klc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function llc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=VDc(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)A=j;else{f[a>>2]=v;A=f[t>>2]|0}laa(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function mlc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,450);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function nlc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}rTb(g,3,504144,457);oTb(h,mTb(mTb(g,504252)|0,504294)|0);sTb(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function olc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=k;w=k}while(0);k=f[v>>2]|0;if(!k){q=VDc(48)|0;f[q+16>>2]=c;c=q+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=w;f[v>>2]=q;w=f[f[a>>2]>>2]|0;if(!w)x=q;else{f[a>>2]=w;x=f[v>>2]|0}laa(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;x=q+24|0;f[q+40>>2]=h;b[q+32>>0]=d;b[q+33>>0]=1;b[q+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;y=a}else{a=e+64|0;if(f[a>>2]|0)OQb(e,21472,16);q=NQb(e,16,1784)|0;f[q>>2]=0;f[q+4>>2]=0;d=q+8|0;f[d>>2]=0;if(f[a>>2]|0)OQb(e,23816,8);a=MQb(e,8)|0;f[d>>2]=a;f[a>>2]=e;y=q}f[x>>2]=y;z=x}else{f[k+40>>2]=h;z=k+24|0}k=f[z>>2]|0;z=f[k>>2]|0;if((z|0)!=(f[k+4>>2]|0)){A=z;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}KLa(k,z+1|0);A=f[k>>2]|0;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}function plc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function qlc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+32|0;h=g;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=a+4|0;j=f[i>>2]|0;do if(j){k=a+4|0;l=j;while(1){m=f[l+16>>2]|0;if((m|0)>(c|0)){n=f[l>>2]|0;if(!n){o=5;break}else{p=l;q=n}}else{if((m|0)>=(c|0)){o=10;break}r=l+4|0;m=f[r>>2]|0;if(!m){o=9;break}else{p=r;q=m}}k=p;l=q}if((o|0)==5){s=l;t=l;break}else if((o|0)==9){s=r;t=l;break}else if((o|0)==10){s=k;t=l;break}}else{s=i;t=i}while(0);i=f[s>>2]|0;if(i|0){f[i+40>>2]=e;v=i+24|0;w=v+10|0;x=b[w>>0]|0;y=x&-16;b[w>>0]=y;z=f[v>>2]|0;u=g;return z|0}i=VDc(48)|0;f[i+16>>2]=c;c=i+20|0;f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=t;f[s>>2]=i;t=f[f[a>>2]>>2]|0;if(!t)A=i;else{f[a>>2]=t;A=f[s>>2]|0}laa(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;A=i+24|0;f[i+40>>2]=e;b[i+32>>0]=d;b[i+33>>0]=0;i=f[a+12>>2]|0;if(!i){a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;B=a}else{if(f[i+64>>2]|0)OQb(i,4984,16);a=NQb(i,16,1733)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;B=a}f[A>>2]=B;v=A;w=v+10|0;x=b[w>>0]|0;y=x&-16;b[w>>0]=y;z=f[v>>2]|0;u=g;return z|0}function rlc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,512);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function slc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,519);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function tlc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+32|0;h=g;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=a+4|0;j=f[i>>2]|0;do if(j){k=a+4|0;l=j;while(1){m=f[l+16>>2]|0;if((m|0)>(c|0)){n=f[l>>2]|0;if(!n){o=5;break}else{p=l;q=n}}else{if((m|0)>=(c|0)){o=10;break}r=l+4|0;m=f[r>>2]|0;if(!m){o=9;break}else{p=r;q=m}}k=p;l=q}if((o|0)==5){s=l;t=l;break}else if((o|0)==9){s=r;t=l;break}else if((o|0)==10){s=k;t=l;break}}else{s=i;t=i}while(0);i=f[s>>2]|0;if(i|0){f[i+40>>2]=e;v=i+24|0;w=f[v>>2]|0;x=JLa(w)|0;u=g;return x|0}i=VDc(48)|0;f[i+16>>2]=c;c=i+20|0;f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=t;f[s>>2]=i;t=f[f[a>>2]>>2]|0;if(!t)y=i;else{f[a>>2]=t;y=f[s>>2]|0}laa(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=i+24|0;f[i+40>>2]=e;b[i+32>>0]=d;b[i+33>>0]=1;b[i+35>>0]=0;i=f[a+12>>2]|0;if(!i){a=VDc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;z=a}else{if(f[i+64>>2]|0)OQb(i,21528,16);a=NQb(i,16,1791)|0;f[a>>2]=i;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;z=a}f[y>>2]=z;v=y;w=f[v>>2]|0;x=JLa(w)|0;u=g;return x|0}function ulc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(!j){p=VDc(48)|0;f[p+16>>2]=c;c=p+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=v;f[t>>2]=p;v=f[f[a>>2]>>2]|0;if(!v)w=p;else{f[a>>2]=v;w=f[t>>2]|0}laa(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;f[p+40>>2]=g;b[p+32>>0]=d;b[p+33>>0]=0;d=p+34|0;b[d>>0]=b[d>>0]&15;w=Mi[f[(f[e>>2]|0)+16>>2]&1023](e,f[a+12>>2]|0)|0;f[p+24>>2]=w;b[d>>0]=b[d>>0]&-16;x=w;u=h;return x|0}else{f[j+40>>2]=g;g=j+34|0;w=b[g>>0]|0;b[g>>0]=w&-16;g=f[j+24>>2]|0;if(!(w&16)){x=g;u=h;return x|0}x=Mi[f[(f[g>>2]|0)+16>>2]&1023](g,e)|0;u=h;return x|0}return 0}function vlc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+32|0;i=h;if(!g){j=a+4|0;k=f[j>>2]|0;if(!k){u=h;return}else{l=j;m=k}a:while(1){k=m;while(1){if((f[k+16>>2]|0)>=(c|0))break;n=f[k+4>>2]|0;if(!n){o=l;break a}else k=n}m=f[k>>2]|0;if(!m){o=k;break}else l=k}if((o|0)==(j|0)){u=h;return}if((f[o+16>>2]|0)>(c|0)){u=h;return}skc(o+24|0);u=h;return}o=i+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;o=a+4|0;j=f[o>>2]|0;do if(j){l=a+4|0;m=j;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){p=f[m>>2]|0;if(!p){q=14;break}else{r=m;s=p}}else{if((n|0)>=(c|0)){q=19;break}t=m+4|0;n=f[t>>2]|0;if(!n){q=18;break}else{r=t;s=n}}l=r;m=s}if((q|0)==14){v=m;w=m;break}else if((q|0)==18){v=t;w=m;break}else if((q|0)==19){v=l;w=m;break}}else{v=o;w=o}while(0);o=f[v>>2]|0;do if(!o){q=VDc(48)|0;f[q+16>>2]=c;t=q+20|0;f[t>>2]=f[i>>2];f[t+4>>2]=f[i+4>>2];f[t+8>>2]=f[i+8>>2];f[t+12>>2]=f[i+12>>2];f[t+16>>2]=f[i+16>>2];f[t+20>>2]=f[i+20>>2];f[t+24>>2]=f[i+24>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=w;f[v>>2]=q;t=f[f[a>>2]>>2]|0;if(!t)x=q;else{f[a>>2]=t;x=f[v>>2]|0}laa(f[a+4>>2]|0,x);t=a+8|0;f[t>>2]=(f[t>>2]|0)+1;f[q+40>>2]=e;b[q+32>>0]=d;b[q+33>>0]=0;t=q+34|0;b[t>>0]=b[t>>0]&15;f[q+24>>2]=g;y=q}else{q=o+24|0;f[o+40>>2]=e;if(b[o+34>>0]&16){t=f[q>>2]|0;mi[f[(f[t>>2]|0)+24>>2]&2047](t,g);y=o;break}if((f[a+12>>2]|0)==0?(t=f[q>>2]|0,t|0):0)Yi[f[(f[t>>2]|0)+4>>2]&2047](t);f[q>>2]=g;y=o}while(0);o=y+34|0;b[o>>0]=b[o>>0]&-16;u=h;return}function wlc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,725);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function xlc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){rTb(e,3,504144,732);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function ylc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(!j){p=VDc(48)|0;f[p+16>>2]=c;c=p+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=v;f[t>>2]=p;v=f[f[a>>2]>>2]|0;if(!v)w=p;else{f[a>>2]=v;w=f[t>>2]|0}laa(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;w=p+24|0;f[p+40>>2]=g;b[p+32>>0]=d;b[p+33>>0]=1;p=f[a+12>>2]|0;if(!p){d=VDc(16)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;x=d}else{if(f[p+64>>2]|0)OQb(p,20856,16);d=NQb(p,16,1779)|0;f[d>>2]=p;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;x=d}f[w>>2]=x;y=w}else{f[j+40>>2]=g;y=j+24|0}j=f[y>>2]|0;g=f[j+12>>2]|0;if((g|0?(w=j+4|0,j=f[w>>2]|0,(j|0)<(f[g>>2]|0)):0)?(f[w>>2]=j+1,w=f[g+4+(j<<2)>>2]|0,w|0):0){z=w;u=h;return z|0}w=Mi[f[(f[e>>2]|0)+16>>2]&1023](e,f[a+12>>2]|0)|0;v9b(f[y>>2]|0,w);z=w;u=h;return z|0}function zlc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d;g=d+24|0;i=a+4|0;a=f[i>>2]|0;if(a){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(c|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(c|0):0)n=m;else o=8}else o=8;if((o|0)==8){rTb(e,3,504144,771);oTb(g,mTb(mTb(e,504252)|0,504294)|0);sTb(e);n=i}i=n+24|0;do switch(f[161064+(h[n+32>>0]<<2)>>2]|0){case 1:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 2:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 3:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 4:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 6:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 5:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 7:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 8:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 9:{e=f[i>>2]|0;g=f[e+12>>2]|0;o=e+4|0;e=(f[o>>2]|0)+-1|0;f[o>>2]=e;o=f[g+4+(e<<2)>>2]|0;e=o+11|0;if((b[e>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0;u=d;return}else{b[o>>0]=0;b[e>>0]=0;u=d;return}break}case 10:{e=f[i>>2]|0;o=f[e+12>>2]|0;g=e+4|0;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;g=f[o+4+(e<<2)>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g);u=d;return}default:{u=d;return}}while(0)}function Alc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=c+24|0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(b|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)!=(g|0)?(f[k+16>>2]|0)<=(b|0):0)l=k;else m=8}else m=8;if((m|0)==8){rTb(d,3,504144,812);oTb(e,mTb(mTb(d,504252)|0,504294)|0);sTb(d);l=g}g=f[l+24>>2]|0;l=f[g+12>>2]|0;d=g+4|0;g=f[d>>2]|0;e=g+-1|0;f[d>>2]=e;d=l+4+(e<<2)|0;e=f[d>>2]|0;m=f[l>>2]|0;k=m+-1|0;f[l>>2]=k;if((g|0)>=(m|0)){u=c;return e|0}f[d>>2]=f[l+4+(k<<2)>>2];u=c;return e|0}function Blc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0;g=u;u=u+32|0;i=g;j=g+24|0;k=a+4|0;a=f[k>>2]|0;if(a){l=k;m=a;a:while(1){a=m;while(1){if((f[a+16>>2]|0)>=(c|0))break;n=f[a+4>>2]|0;if(!n){o=l;break a}else a=n}m=f[a>>2]|0;if(!m){o=a;break}else l=a}if((o|0)!=(k|0)?(f[o+16>>2]|0)<=(c|0):0)q=o;else r=8}else r=8;if((r|0)==8){rTb(i,3,504144,822);oTb(j,mTb(mTb(i,504252)|0,504294)|0);sTb(i);q=k}k=q+24|0;do switch(f[161064+((h[q+32>>0]|0)<<2)>>2]|0){case 1:{i=f[(f[k>>2]|0)+8>>2]|0;j=i+4+(d<<2)|0;r=i+4+(e<<2)|0;i=f[j>>2]|0;f[j>>2]=f[r>>2];f[r>>2]=i;u=g;return}case 2:{i=f[(f[k>>2]|0)+8>>2]|0;r=i+8+(d<<3)|0;j=i+8+(e<<3)|0;i=r;o=f[i>>2]|0;c=f[i+4>>2]|0;i=j;l=f[i+4>>2]|0;m=r;f[m>>2]=f[i>>2];f[m+4>>2]=l;l=j;f[l>>2]=o;f[l+4>>2]=c;u=g;return}case 3:{c=f[(f[k>>2]|0)+8>>2]|0;l=c+4+(d<<2)|0;o=c+4+(e<<2)|0;c=f[l>>2]|0;f[l>>2]=f[o>>2];f[o>>2]=c;u=g;return}case 4:{c=f[(f[k>>2]|0)+8>>2]|0;o=c+8+(d<<3)|0;l=c+8+(e<<3)|0;c=o;j=f[c>>2]|0;m=f[c+4>>2]|0;c=l;i=f[c+4>>2]|0;r=o;f[r>>2]=f[c>>2];f[r+4>>2]=i;i=l;f[i>>2]=j;f[i+4>>2]=m;u=g;return}case 6:{m=f[(f[k>>2]|0)+8>>2]|0;i=m+4+(d<<2)|0;j=m+4+(e<<2)|0;m=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=m;u=g;return}case 5:{m=f[(f[k>>2]|0)+8>>2]|0;j=m+8+(d<<3)|0;i=m+8+(e<<3)|0;s=+p[j>>3];p[j>>3]=+p[i>>3];p[i>>3]=s;u=g;return}case 7:{i=f[(f[k>>2]|0)+8>>2]|0;j=i+4+d|0;m=i+4+e|0;i=b[j>>0]|0;b[j>>0]=b[m>>0]|0;b[m>>0]=i;u=g;return}case 8:{i=f[(f[k>>2]|0)+8>>2]|0;m=i+4+(d<<2)|0;j=i+4+(e<<2)|0;i=f[m>>2]|0;f[m>>2]=f[j>>2];f[j>>2]=i;u=g;return}case 9:{i=f[(f[k>>2]|0)+12>>2]|0;j=i+4+(d<<2)|0;m=i+4+(e<<2)|0;i=f[j>>2]|0;f[j>>2]=f[m>>2];f[m>>2]=i;u=g;return}case 10:{i=f[(f[k>>2]|0)+12>>2]|0;m=i+4+(d<<2)|0;j=i+4+(e<<2)|0;i=f[m>>2]|0;f[m>>2]=f[j>>2];f[j>>2]=i;u=g;return}default:{u=g;return}}while(0)}function Clc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0))return;else d=b;while(1){skc(d+24|0);b=f[d+4>>2]|0;if(!b){a=d+8|0;e=f[a>>2]|0;if((f[e>>2]|0)==(d|0))g=e;else{e=a;do{a=f[e>>2]|0;e=a+8|0;h=f[e>>2]|0}while((f[h>>2]|0)!=(a|0));g=h}}else{e=b;while(1){h=f[e>>2]|0;if(!h)break;else e=h}g=e}if((g|0)==(c|0))break;else d=g}return}function Dlc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[b>>2]|0;d=b+4|0;if((c|0)==(d|0))return;else e=c;while(1){Elc(a,f[e+16>>2]|0,e+24|0);c=f[e+4>>2]|0;if(!c){b=e+8|0;g=f[b>>2]|0;if((f[g>>2]|0)==(e|0))h=g;else{g=b;do{b=f[g>>2]|0;g=b+8|0;i=f[g>>2]|0}while((f[i>>2]|0)!=(b|0));h=i}}else{g=c;while(1){i=f[g>>2]|0;if(!i)break;else g=i}h=g}if((h|0)==(d|0))break;else e=h}return}function Elc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0;e=u;u=u+32|0;g=e;if(b[d+9>>0]|0){h=f[d+16>>2]|0;i=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=a+4|0;j=f[i>>2]|0;do if(j){k=a+4|0;l=j;while(1){m=f[l+16>>2]|0;if((m|0)>(c|0)){n=f[l>>2]|0;if(!n){o=6;break}else{q=l;r=n}}else{if((m|0)>=(c|0)){o=11;break}s=l+4|0;m=f[s>>2]|0;if(!m){o=10;break}else{q=s;r=m}}k=q;l=r}if((o|0)==6){t=l;v=l;break}else if((o|0)==10){t=s;v=l;break}else if((o|0)==11){t=k;v=l;break}}else{t=i;v=i}while(0);i=f[t>>2]|0;if(!i){s=VDc(48)|0;f[s+16>>2]=c;r=s+20|0;f[r>>2]=f[g>>2];f[r+4>>2]=f[g+4>>2];f[r+8>>2]=f[g+8>>2];f[r+12>>2]=f[g+12>>2];f[r+16>>2]=f[g+16>>2];f[r+20>>2]=f[g+20>>2];f[r+24>>2]=f[g+24>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=v;f[t>>2]=s;v=f[f[a>>2]>>2]|0;if(!v)w=s;else{f[a>>2]=v;w=f[t>>2]|0}laa(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;f[s+40>>2]=h;w=b[d+8>>0]|0;b[s+32>>0]=w;b[s+35>>0]=b[d+11>>0]|0;b[s+33>>0]=1;x=1;y=w;z=s+24|0}else{f[i+40>>2]=h;x=0;y=b[d+8>>0]|0;z=i+24|0}do switch(f[161064+((y&255)<<2)>>2]|0){case 1:{if(x){i=f[a+12>>2]|0;if(!i){h=VDc(12)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;A=h}else{h=i+64|0;if(f[h>>2]|0)OQb(i,21472,16);s=NQb(i,16,1784)|0;f[s>>2]=0;f[s+4>>2]=0;w=s+8|0;f[w>>2]=0;if(f[h>>2]|0)OQb(i,23816,8);h=MQb(i,8)|0;f[w>>2]=h;f[h>>2]=i;A=s}f[z>>2]=A;B=A}else B=f[z>>2]|0;s=f[d>>2]|0;i=f[s>>2]|0;if(!i){u=e;return}KLa(B,(f[B>>2]|0)+i|0);dJc((f[B+8>>2]|0)+4+(f[B>>2]<<2)|0,(f[s+8>>2]|0)+4|0,f[s>>2]<<2|0)|0;f[B>>2]=(f[B>>2]|0)+(f[s>>2]|0);u=e;return}case 2:{if(x){s=f[a+12>>2]|0;if(!s){i=VDc(12)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;C=i}else{i=s+64|0;if(f[i>>2]|0)OQb(s,21480,16);h=NQb(s,16,1785)|0;f[h>>2]=0;f[h+4>>2]=0;w=h+8|0;f[w>>2]=0;if(f[i>>2]|0)OQb(s,23816,8);i=MQb(s,8)|0;f[w>>2]=i;f[i>>2]=s;C=h}f[z>>2]=C;D=C}else D=f[z>>2]|0;h=f[d>>2]|0;s=f[h>>2]|0;if(!s){u=e;return}UHa(D,(f[D>>2]|0)+s|0);dJc((f[D+8>>2]|0)+8+(f[D>>2]<<3)|0,(f[h+8>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[D>>2]=(f[D>>2]|0)+(f[h>>2]|0);u=e;return}case 3:{if(x){h=f[a+12>>2]|0;if(!h){s=VDc(12)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;E=s}else{s=h+64|0;if(f[s>>2]|0)OQb(h,21488,16);i=NQb(h,16,1786)|0;f[i>>2]=0;f[i+4>>2]=0;w=i+8|0;f[w>>2]=0;if(f[s>>2]|0)OQb(h,23816,8);s=MQb(h,8)|0;f[w>>2]=s;f[s>>2]=h;E=i}f[z>>2]=E;F=E}else F=f[z>>2]|0;i=f[d>>2]|0;h=f[i>>2]|0;if(!h){u=e;return}OLa(F,(f[F>>2]|0)+h|0);dJc((f[F+8>>2]|0)+4+(f[F>>2]<<2)|0,(f[i+8>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[F>>2]=(f[F>>2]|0)+(f[i>>2]|0);u=e;return}case 4:{if(x){i=f[a+12>>2]|0;if(!i){h=VDc(12)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=h}else{h=i+64|0;if(f[h>>2]|0)OQb(i,21496,16);s=NQb(i,16,1787)|0;f[s>>2]=0;f[s+4>>2]=0;w=s+8|0;f[w>>2]=0;if(f[h>>2]|0)OQb(i,23816,8);h=MQb(i,8)|0;f[w>>2]=h;f[h>>2]=i;G=s}f[z>>2]=G;H=G}else H=f[z>>2]|0;s=f[d>>2]|0;i=f[s>>2]|0;if(!i){u=e;return}Hjb(H,(f[H>>2]|0)+i|0);dJc((f[H+8>>2]|0)+8+(f[H>>2]<<3)|0,(f[s+8>>2]|0)+8|0,f[s>>2]<<3|0)|0;f[H>>2]=(f[H>>2]|0)+(f[s>>2]|0);u=e;return}case 6:{if(x){s=f[a+12>>2]|0;if(!s){i=VDc(12)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;I=i}else{i=s+64|0;if(f[i>>2]|0)OQb(s,21504,16);h=NQb(s,16,1788)|0;f[h>>2]=0;f[h+4>>2]=0;w=h+8|0;f[w>>2]=0;if(f[i>>2]|0)OQb(s,23816,8);i=MQb(s,8)|0;f[w>>2]=i;f[i>>2]=s;I=h}f[z>>2]=I;J=I}else J=f[z>>2]|0;h=f[d>>2]|0;s=f[h>>2]|0;if(!s){u=e;return}SHa(J,(f[J>>2]|0)+s|0);dJc((f[J+8>>2]|0)+4+(f[J>>2]<<2)|0,(f[h+8>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[J>>2]=(f[J>>2]|0)+(f[h>>2]|0);u=e;return}case 5:{if(x){h=f[a+12>>2]|0;if(!h){s=VDc(12)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;K=s}else{s=h+64|0;if(f[s>>2]|0)OQb(h,21512,16);i=NQb(h,16,1789)|0;f[i>>2]=0;f[i+4>>2]=0;w=i+8|0;f[w>>2]=0;if(f[s>>2]|0)OQb(h,23816,8);s=MQb(h,8)|0;f[w>>2]=s;f[s>>2]=h;K=i}f[z>>2]=K;L=K}else L=f[z>>2]|0;i=f[d>>2]|0;h=f[i>>2]|0;if(!h){u=e;return}THa(L,(f[L>>2]|0)+h|0);dJc((f[L+8>>2]|0)+8+(f[L>>2]<<3)|0,(f[i+8>>2]|0)+8|0,f[i>>2]<<3|0)|0;f[L>>2]=(f[L>>2]|0)+(f[i>>2]|0);u=e;return}case 7:{if(x){i=f[a+12>>2]|0;if(!i){h=VDc(12)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=h}else{h=i+64|0;if(f[h>>2]|0)OQb(i,21520,16);s=NQb(i,16,1790)|0;f[s>>2]=0;f[s+4>>2]=0;w=s+8|0;f[w>>2]=0;if(f[h>>2]|0)OQb(i,23816,8);h=MQb(i,8)|0;f[w>>2]=h;f[h>>2]=i;M=s}f[z>>2]=M;N=M}else N=f[z>>2]|0;s=f[d>>2]|0;i=f[s>>2]|0;if(!i){u=e;return}zNa(N,(f[N>>2]|0)+i|0);dJc((f[N>>2]|0)+((f[N+8>>2]|0)+4)|0,(f[s+8>>2]|0)+4|0,f[s>>2]|0)|0;f[N>>2]=(f[N>>2]|0)+(f[s>>2]|0);u=e;return}case 8:{if(x){s=f[a+12>>2]|0;if(!s){i=VDc(12)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;O=i}else{i=s+64|0;if(f[i>>2]|0)OQb(s,21472,16);h=NQb(s,16,1784)|0;f[h>>2]=0;f[h+4>>2]=0;w=h+8|0;f[w>>2]=0;if(f[i>>2]|0)OQb(s,23816,8);i=MQb(s,8)|0;f[w>>2]=i;f[i>>2]=s;O=h}f[z>>2]=O;P=O}else P=f[z>>2]|0;h=f[d>>2]|0;s=f[h>>2]|0;if(!s){u=e;return}KLa(P,(f[P>>2]|0)+s|0);dJc((f[P+8>>2]|0)+4+(f[P>>2]<<2)|0,(f[h+8>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[P>>2]=(f[P>>2]|0)+(f[h>>2]|0);u=e;return}case 9:{if(x){h=f[a+12>>2]|0;if(!h){s=VDc(16)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;Q=s}else{if(f[h+64>>2]|0)OQb(h,21528,16);s=NQb(h,16,1791)|0;f[s>>2]=h;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;Q=s}f[z>>2]=Q;R=Q}else R=f[z>>2]|0;yNa(R,f[d>>2]|0);u=e;return}case 10:{if(x){s=f[a+12>>2]|0;if(!s){h=VDc(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;S=h}else{if(f[s+64>>2]|0)OQb(s,20856,16);h=NQb(s,16,1779)|0;f[h>>2]=s;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;S=h}f[z>>2]=S}h=f[d>>2]|0;s=h+4|0;if((f[s>>2]|0)<=0){u=e;return}i=h+12|0;h=a+12|0;w=0;do{t=f[(f[i>>2]|0)+4+(w<<2)>>2]|0;v=f[z>>2]|0;r=f[v+12>>2]|0;if(((r|0)!=0?(q=v+4|0,v=f[q>>2]|0,(v|0)<(f[r>>2]|0)):0)?(f[q>>2]=v+1,q=f[r+4+(v<<2)>>2]|0,(q|0)!=0):0)T=q;else{q=Mi[f[(f[t>>2]|0)+16>>2]&1023](t,f[h>>2]|0)|0;v9b(f[z>>2]|0,q);T=q}mi[f[(f[T>>2]|0)+40>>2]&2047](T,t);w=w+1|0}while((w|0)<(f[s>>2]|0));u=e;return}default:{u=e;return}}while(0)}T=d+10|0;if(b[T>>0]&1){u=e;return}z=d+8|0;S=b[z>>0]|0;do switch(f[161064+((S&255)<<2)>>2]|0){case 1:{x=f[d>>2]|0;R=f[d+16>>2]|0;Q=g+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;f[Q+16>>2]=0;f[Q+20>>2]=0;Q=a+4|0;P=f[Q>>2]|0;do if(P){O=a+4|0;N=P;while(1){M=f[N+16>>2]|0;if((M|0)>(c|0)){L=f[N>>2]|0;if(!L){o=144;break}else{U=N;V=L}}else{if((M|0)>=(c|0)){o=149;break}W=N+4|0;M=f[W>>2]|0;if(!M){o=148;break}else{U=W;V=M}}O=U;N=V}if((o|0)==144){X=N;Y=N;break}else if((o|0)==148){X=W;Y=N;break}else if((o|0)==149){X=O;Y=N;break}}else{X=Q;Y=Q}while(0);Q=f[X>>2]|0;if(!Q){P=VDc(48)|0;f[P+16>>2]=c;M=P+20|0;f[M>>2]=f[g>>2];f[M+4>>2]=f[g+4>>2];f[M+8>>2]=f[g+8>>2];f[M+12>>2]=f[g+12>>2];f[M+16>>2]=f[g+16>>2];f[M+20>>2]=f[g+20>>2];f[M+24>>2]=f[g+24>>2];f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=Y;f[X>>2]=P;M=f[f[a>>2]>>2]|0;if(!M)Z=P;else{f[a>>2]=M;Z=f[X>>2]|0}laa(f[a+4>>2]|0,Z);M=a+8|0;f[M>>2]=(f[M>>2]|0)+1;f[P+40>>2]=R;b[P+32>>0]=S;b[P+33>>0]=0;_=P+24|0}else{f[Q+40>>2]=R;_=Q+24|0}Q=_+10|0;b[Q>>0]=b[Q>>0]&-16;f[_>>2]=x;u=e;return}case 2:{Q=d;P=f[Q>>2]|0;M=f[Q+4>>2]|0;Q=f[d+16>>2]|0;L=g+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;L=a+4|0;K=f[L>>2]|0;do if(K){J=a+4|0;I=K;while(1){H=f[I+16>>2]|0;if((H|0)>(c|0)){G=f[I>>2]|0;if(!G){o=161;break}else{$=I;aa=G}}else{if((H|0)>=(c|0)){o=166;break}ba=I+4|0;H=f[ba>>2]|0;if(!H){o=165;break}else{$=ba;aa=H}}J=$;I=aa}if((o|0)==161){ca=I;da=I;break}else if((o|0)==165){ca=ba;da=I;break}else if((o|0)==166){ca=J;da=I;break}}else{ca=L;da=L}while(0);L=f[ca>>2]|0;if(!L){K=VDc(48)|0;f[K+16>>2]=c;x=K+20|0;f[x>>2]=f[g>>2];f[x+4>>2]=f[g+4>>2];f[x+8>>2]=f[g+8>>2];f[x+12>>2]=f[g+12>>2];f[x+16>>2]=f[g+16>>2];f[x+20>>2]=f[g+20>>2];f[x+24>>2]=f[g+24>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=da;f[ca>>2]=K;x=f[f[a>>2]>>2]|0;if(!x)ea=K;else{f[a>>2]=x;ea=f[ca>>2]|0}laa(f[a+4>>2]|0,ea);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;f[K+40>>2]=Q;b[K+32>>0]=S;b[K+33>>0]=0;fa=K+24|0}else{f[L+40>>2]=Q;fa=L+24|0}L=fa+10|0;b[L>>0]=b[L>>0]&-16;L=fa;f[L>>2]=P;f[L+4>>2]=M;u=e;return}case 3:{L=f[d>>2]|0;K=f[d+16>>2]|0;x=g+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;x=a+4|0;R=f[x>>2]|0;do if(R){N=a+4|0;O=R;while(1){H=f[O+16>>2]|0;if((H|0)>(c|0)){G=f[O>>2]|0;if(!G){o=178;break}else{ga=O;ha=G}}else{if((H|0)>=(c|0)){o=183;break}ia=O+4|0;H=f[ia>>2]|0;if(!H){o=182;break}else{ga=ia;ha=H}}N=ga;O=ha}if((o|0)==178){ja=O;ka=O;break}else if((o|0)==182){ja=ia;ka=O;break}else if((o|0)==183){ja=N;ka=O;break}}else{ja=x;ka=x}while(0);x=f[ja>>2]|0;if(!x){R=VDc(48)|0;f[R+16>>2]=c;M=R+20|0;f[M>>2]=f[g>>2];f[M+4>>2]=f[g+4>>2];f[M+8>>2]=f[g+8>>2];f[M+12>>2]=f[g+12>>2];f[M+16>>2]=f[g+16>>2];f[M+20>>2]=f[g+20>>2];f[M+24>>2]=f[g+24>>2];f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=ka;f[ja>>2]=R;M=f[f[a>>2]>>2]|0;if(!M)la=R;else{f[a>>2]=M;la=f[ja>>2]|0}laa(f[a+4>>2]|0,la);M=a+8|0;f[M>>2]=(f[M>>2]|0)+1;f[R+40>>2]=K;b[R+32>>0]=S;b[R+33>>0]=0;ma=R+24|0}else{f[x+40>>2]=K;ma=x+24|0}x=ma+10|0;b[x>>0]=b[x>>0]&-16;f[ma>>2]=L;u=e;return}case 4:{x=d;R=f[x>>2]|0;M=f[x+4>>2]|0;x=f[d+16>>2]|0;P=g+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;P=a+4|0;Q=f[P>>2]|0;do if(Q){I=a+4|0;J=Q;while(1){H=f[J+16>>2]|0;if((H|0)>(c|0)){G=f[J>>2]|0;if(!G){o=195;break}else{na=J;oa=G}}else{if((H|0)>=(c|0)){o=200;break}pa=J+4|0;H=f[pa>>2]|0;if(!H){o=199;break}else{na=pa;oa=H}}I=na;J=oa}if((o|0)==195){qa=J;ra=J;break}else if((o|0)==199){qa=pa;ra=J;break}else if((o|0)==200){qa=I;ra=J;break}}else{qa=P;ra=P}while(0);P=f[qa>>2]|0;if(!P){Q=VDc(48)|0;f[Q+16>>2]=c;L=Q+20|0;f[L>>2]=f[g>>2];f[L+4>>2]=f[g+4>>2];f[L+8>>2]=f[g+8>>2];f[L+12>>2]=f[g+12>>2];f[L+16>>2]=f[g+16>>2];f[L+20>>2]=f[g+20>>2];f[L+24>>2]=f[g+24>>2];f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=ra;f[qa>>2]=Q;L=f[f[a>>2]>>2]|0;if(!L)sa=Q;else{f[a>>2]=L;sa=f[qa>>2]|0}laa(f[a+4>>2]|0,sa);L=a+8|0;f[L>>2]=(f[L>>2]|0)+1;f[Q+40>>2]=x;b[Q+32>>0]=S;b[Q+33>>0]=0;ta=Q+24|0}else{f[P+40>>2]=x;ta=P+24|0}P=ta+10|0;b[P>>0]=b[P>>0]&-16;P=ta;f[P>>2]=R;f[P+4>>2]=M;u=e;return}case 6:{P=f[d>>2]|0;Q=f[d+16>>2]|0;L=g+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;L=a+4|0;K=f[L>>2]|0;do if(K){O=a+4|0;N=K;while(1){H=f[N+16>>2]|0;if((H|0)>(c|0)){G=f[N>>2]|0;if(!G){o=212;break}else{ua=N;va=G}}else{if((H|0)>=(c|0)){o=217;break}wa=N+4|0;H=f[wa>>2]|0;if(!H){o=216;break}else{ua=wa;va=H}}O=ua;N=va}if((o|0)==212){xa=N;ya=N;break}else if((o|0)==216){xa=wa;ya=N;break}else if((o|0)==217){xa=O;ya=N;break}}else{xa=L;ya=L}while(0);L=f[xa>>2]|0;if(!L){K=VDc(48)|0;f[K+16>>2]=c;M=K+20|0;f[M>>2]=f[g>>2];f[M+4>>2]=f[g+4>>2];f[M+8>>2]=f[g+8>>2];f[M+12>>2]=f[g+12>>2];f[M+16>>2]=f[g+16>>2];f[M+20>>2]=f[g+20>>2];f[M+24>>2]=f[g+24>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=ya;f[xa>>2]=K;M=f[f[a>>2]>>2]|0;if(!M)za=K;else{f[a>>2]=M;za=f[xa>>2]|0}laa(f[a+4>>2]|0,za);M=a+8|0;f[M>>2]=(f[M>>2]|0)+1;f[K+40>>2]=Q;b[K+32>>0]=S;b[K+33>>0]=0;Aa=K+24|0}else{f[L+40>>2]=Q;Aa=L+24|0}L=Aa+10|0;b[L>>0]=b[L>>0]&-16;f[Aa>>2]=P;u=e;return}case 5:{Ba=+p[d>>3];L=f[d+16>>2]|0;K=g+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;f[K+16>>2]=0;f[K+20>>2]=0;K=a+4|0;M=f[K>>2]|0;do if(M){R=a+4|0;x=M;while(1){J=f[x+16>>2]|0;if((J|0)>(c|0)){I=f[x>>2]|0;if(!I){o=229;break}else{Ca=x;Da=I}}else{if((J|0)>=(c|0)){o=234;break}Ea=x+4|0;J=f[Ea>>2]|0;if(!J){o=233;break}else{Ca=Ea;Da=J}}R=Ca;x=Da}if((o|0)==229){Fa=x;Ga=x;break}else if((o|0)==233){Fa=Ea;Ga=x;break}else if((o|0)==234){Fa=R;Ga=x;break}}else{Fa=K;Ga=K}while(0);K=f[Fa>>2]|0;if(!K){M=VDc(48)|0;f[M+16>>2]=c;P=M+20|0;f[P>>2]=f[g>>2];f[P+4>>2]=f[g+4>>2];f[P+8>>2]=f[g+8>>2];f[P+12>>2]=f[g+12>>2];f[P+16>>2]=f[g+16>>2];f[P+20>>2]=f[g+20>>2];f[P+24>>2]=f[g+24>>2];f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=Ga;f[Fa>>2]=M;P=f[f[a>>2]>>2]|0;if(!P)Ha=M;else{f[a>>2]=P;Ha=f[Fa>>2]|0}laa(f[a+4>>2]|0,Ha);P=a+8|0;f[P>>2]=(f[P>>2]|0)+1;f[M+40>>2]=L;b[M+32>>0]=S;b[M+33>>0]=0;Ia=M+24|0}else{f[K+40>>2]=L;Ia=K+24|0}K=Ia+10|0;b[K>>0]=b[K>>0]&-16;p[Ia>>3]=Ba;u=e;return}case 7:{K=b[d>>0]|0;M=f[d+16>>2]|0;P=g+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;P=a+4|0;Q=f[P>>2]|0;do if(Q){N=a+4|0;O=Q;while(1){J=f[O+16>>2]|0;if((J|0)>(c|0)){I=f[O>>2]|0;if(!I){o=246;break}else{Ja=O;Ka=I}}else{if((J|0)>=(c|0)){o=251;break}La=O+4|0;J=f[La>>2]|0;if(!J){o=250;break}else{Ja=La;Ka=J}}N=Ja;O=Ka}if((o|0)==246){Ma=O;Na=O;break}else if((o|0)==250){Ma=La;Na=O;break}else if((o|0)==251){Ma=N;Na=O;break}}else{Ma=P;Na=P}while(0);P=f[Ma>>2]|0;if(!P){Q=VDc(48)|0;f[Q+16>>2]=c;L=Q+20|0;f[L>>2]=f[g>>2];f[L+4>>2]=f[g+4>>2];f[L+8>>2]=f[g+8>>2];f[L+12>>2]=f[g+12>>2];f[L+16>>2]=f[g+16>>2];f[L+20>>2]=f[g+20>>2];f[L+24>>2]=f[g+24>>2];f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=Na;f[Ma>>2]=Q;L=f[f[a>>2]>>2]|0;if(!L)Oa=Q;else{f[a>>2]=L;Oa=f[Ma>>2]|0}laa(f[a+4>>2]|0,Oa);L=a+8|0;f[L>>2]=(f[L>>2]|0)+1;f[Q+40>>2]=M;b[Q+32>>0]=S;b[Q+33>>0]=0;Pa=Q+24|0}else{f[P+40>>2]=M;Pa=P+24|0}P=Pa+10|0;b[P>>0]=b[P>>0]&-16;b[Pa>>0]=K;u=e;return}case 8:{P=f[d>>2]|0;Q=f[d+16>>2]|0;L=g+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;L=a+4|0;x=f[L>>2]|0;do if(x){R=a+4|0;J=x;while(1){I=f[J+16>>2]|0;if((I|0)>(c|0)){H=f[J>>2]|0;if(!H){o=263;break}else{Qa=J;Ra=H}}else{if((I|0)>=(c|0)){o=268;break}Sa=J+4|0;I=f[Sa>>2]|0;if(!I){o=267;break}else{Qa=Sa;Ra=I}}R=Qa;J=Ra}if((o|0)==263){Ta=J;Ua=J;break}else if((o|0)==267){Ta=Sa;Ua=J;break}else if((o|0)==268){Ta=R;Ua=J;break}}else{Ta=L;Ua=L}while(0);L=f[Ta>>2]|0;if(!L){x=VDc(48)|0;f[x+16>>2]=c;K=x+20|0;f[K>>2]=f[g>>2];f[K+4>>2]=f[g+4>>2];f[K+8>>2]=f[g+8>>2];f[K+12>>2]=f[g+12>>2];f[K+16>>2]=f[g+16>>2];f[K+20>>2]=f[g+20>>2];f[K+24>>2]=f[g+24>>2];f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=Ua;f[Ta>>2]=x;K=f[f[a>>2]>>2]|0;if(!K)Va=x;else{f[a>>2]=K;Va=f[Ta>>2]|0}laa(f[a+4>>2]|0,Va);K=a+8|0;f[K>>2]=(f[K>>2]|0)+1;f[x+40>>2]=Q;b[x+32>>0]=S;b[x+33>>0]=0;Wa=x+24|0}else{f[L+40>>2]=Q;Wa=L+24|0}L=Wa+10|0;b[L>>0]=b[L>>0]&-16;f[Wa>>2]=P;u=e;return}case 9:{L=f[d>>2]|0;iEc(qlc(a,c,S,f[d+16>>2]|0)|0,L)|0;u=e;return}case 10:{L=f[d+16>>2]|0;x=g+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;x=a+4|0;K=f[x>>2]|0;do if(K){M=a+4|0;O=K;while(1){N=f[O+16>>2]|0;if((N|0)>(c|0)){I=f[O>>2]|0;if(!I){o=281;break}else{Xa=O;Ya=I}}else{if((N|0)>=(c|0)){o=286;break}Za=O+4|0;N=f[Za>>2]|0;if(!N){o=285;break}else{Xa=Za;Ya=N}}M=Xa;O=Ya}if((o|0)==281){_a=O;$a=O;break}else if((o|0)==285){_a=Za;$a=O;break}else if((o|0)==286){_a=M;$a=O;break}}else{_a=x;$a=x}while(0);x=f[_a>>2]|0;do if(!x){K=VDc(48)|0;f[K+16>>2]=c;P=K+20|0;f[P>>2]=f[g>>2];f[P+4>>2]=f[g+4>>2];f[P+8>>2]=f[g+8>>2];f[P+12>>2]=f[g+12>>2];f[P+16>>2]=f[g+16>>2];f[P+20>>2]=f[g+20>>2];f[P+24>>2]=f[g+24>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=$a;f[_a>>2]=K;P=f[f[a>>2]>>2]|0;if(!P)ab=K;else{f[a>>2]=P;ab=f[_a>>2]|0}laa(f[a+4>>2]|0,ab);P=a+8|0;f[P>>2]=(f[P>>2]|0)+1;P=K+24|0;f[K+40>>2]=L;b[K+32>>0]=b[z>>0]|0;b[K+35>>0]=b[d+11>>0]|0;b[K+33>>0]=0;Q=K+34|0;K=b[Q>>0]&15;J=f[a+12>>2]|0;if(!(b[T>>0]&16)){b[Q>>0]=K;R=f[d>>2]|0;N=Mi[f[(f[R>>2]|0)+16>>2]&1023](R,J)|0;f[P>>2]=N;mi[f[(f[N>>2]|0)+40>>2]&2047](N,f[d>>2]|0);bb=P;break}else{b[Q>>0]=K|16;K=f[d>>2]|0;Q=Mi[f[(f[K>>2]|0)+8>>2]&1023](K,J)|0;f[P>>2]=Q;mi[f[(f[Q>>2]|0)+48>>2]&2047](Q,f[d>>2]|0);bb=P;break}}else{P=x+24|0;f[x+40>>2]=L;Q=(b[x+34>>0]&16)!=0;J=f[P>>2]|0;if(!(b[T>>0]&16))if(Q){K=Mi[f[(f[J>>2]|0)+16>>2]&1023](J,f[d>>2]|0)|0;mi[f[(f[K>>2]|0)+40>>2]&2047](K,f[d>>2]|0);bb=P;break}else{mi[f[(f[J>>2]|0)+40>>2]&2047](J,f[d>>2]|0);bb=P;break}else{K=f[J>>2]|0;if(Q){mi[f[K+48>>2]&2047](J,f[d>>2]|0);bb=P;break}else{Q=f[K+40>>2]|0;K=f[d>>2]|0;N=Mi[f[(f[K>>2]|0)+12>>2]&1023](K,J)|0;mi[Q&2047](J,N);bb=P;break}}}while(0);x=bb+10|0;b[x>>0]=b[x>>0]&-16;u=e;return}default:{u=e;return}}while(0)}function Flc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;if((f[a+12>>2]|0)==(f[b+12>>2]|0)){e=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;g=b+4|0;h=f[e>>2]|0;f[e>>2]=f[g>>2];f[g>>2]=h;h=a+8|0;i=b+8|0;j=f[h>>2]|0;f[h>>2]=f[i>>2];f[i>>2]=j;if(!(f[h>>2]|0))k=a;else k=(f[e>>2]|0)+8|0;f[k>>2]=e;f[((j|0)==0?b:(f[g>>2]|0)+8|0)>>2]=g;u=c;return}f[d+4>>2]=0;f[d+8>>2]=0;g=d+4|0;f[d>>2]=g;j=d+12|0;f[j>>2]=0;e=f[b>>2]|0;k=b+4|0;if((e|0)==(k|0))l=e;else{h=e;while(1){Elc(d,f[h+16>>2]|0,h+24|0);e=f[h+4>>2]|0;if(!e){i=h+8|0;m=f[i>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=i;do{i=f[m>>2]|0;m=i+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(i|0));n=o}}else{m=e;while(1){o=f[m>>2]|0;if(!o)break;else m=o}n=m}if((n|0)==(k|0))break;else h=n}l=f[b>>2]|0}if((l|0)!=(k|0)){n=l;while(1){skc(n+24|0);l=f[n+4>>2]|0;if(!l){h=n+8|0;e=f[h>>2]|0;if((f[e>>2]|0)==(n|0))p=e;else{e=h;do{h=f[e>>2]|0;e=h+8|0;o=f[e>>2]|0}while((f[o>>2]|0)!=(h|0));p=o}}else{e=l;while(1){m=f[e>>2]|0;if(!m)break;else e=m}p=e}if((p|0)==(k|0))break;else n=p}}p=f[a>>2]|0;n=a+4|0;if((p|0)==(n|0))q=p;else{k=p;while(1){Elc(b,f[k+16>>2]|0,k+24|0);p=f[k+4>>2]|0;if(!p){l=k+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(k|0))r=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));r=o}}else{m=p;while(1){e=f[m>>2]|0;if(!e)break;else m=e}r=m}if((r|0)==(n|0))break;else k=r}q=f[a>>2]|0}if((q|0)!=(n|0)){r=q;while(1){skc(r+24|0);q=f[r+4>>2]|0;if(!q){k=r+8|0;b=f[k>>2]|0;if((f[b>>2]|0)==(r|0))s=b;else{b=k;do{k=f[b>>2]|0;b=k+8|0;p=f[b>>2]|0}while((f[p>>2]|0)!=(k|0));s=p}}else{b=q;while(1){m=f[b>>2]|0;if(!m)break;else b=m}s=b}if((s|0)==(n|0))break;else r=s}}s=f[d>>2]|0;if((s|0)!=(g|0)){r=s;while(1){Elc(a,f[r+16>>2]|0,r+24|0);s=f[r+4>>2]|0;if(!s){n=r+8|0;q=f[n>>2]|0;if((f[q>>2]|0)==(r|0))t=q;else{q=n;do{n=f[q>>2]|0;q=n+8|0;m=f[q>>2]|0}while((f[m>>2]|0)!=(n|0));t=m}}else{q=s;while(1){b=f[q>>2]|0;if(!b)break;else q=b}t=q}if((t|0)==(g|0))break;else r=t}}if((f[j>>2]|0)==0?(j=f[d>>2]|0,(j|0)!=(g|0)):0){t=j;while(1){nkc(t+24|0);j=f[t+4>>2]|0;if(!j){r=t+8|0;a=f[r>>2]|0;if((f[a>>2]|0)==(t|0))v=a;else{a=r;do{r=f[a>>2]|0;a=r+8|0;s=f[a>>2]|0}while((f[s>>2]|0)!=(r|0));v=s}}else{a=j;while(1){q=f[a>>2]|0;if(!q)break;else a=q}v=a}if((v|0)==(g|0))break;else t=v}}jkc(d,f[g>>2]|0);u=c;return}function Glc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+64|0;e=d;g=d+28|0;if((a|0)==(b|0)){u=d;return}h=a+4|0;i=f[h>>2]|0;j=(i|0)==0;if(!j){k=h;l=i;a:while(1){m=l;while(1){if((f[m+16>>2]|0)>=(c|0))break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(h|0)?(f[o+16>>2]|0)<=(c|0):0)p=o;else q=9}else q=9;if((q|0)==9)p=h;o=b+4|0;k=f[o>>2]|0;l=(k|0)==0;if(!l){n=o;r=k;b:while(1){s=r;while(1){if((f[s+16>>2]|0)>=(c|0))break;t=f[s+4>>2]|0;if(!t){v=n;break b}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else n=s}if((v|0)!=(o|0)?(f[v+16>>2]|0)<=(c|0):0)w=v;else q=17}else q=17;if((q|0)==17)w=o;v=(p|0)==(h|0);if(!((w|0)!=(o|0)|v^1)){u=d;return}n=(w|0)==(o|0);if(!(v|n)){if((f[a+12>>2]|0)==(f[b+12>>2]|0)){r=p+24|0;m=w+24|0;f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[e+16>>2]=f[r+16>>2];f[e+20>>2]=f[r+20>>2];f[r>>2]=f[m>>2];f[r+4>>2]=f[m+4>>2];f[r+8>>2]=f[m+8>>2];f[r+12>>2]=f[m+12>>2];f[r+16>>2]=f[m+16>>2];f[r+20>>2]=f[m+20>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];f[m+16>>2]=f[e+16>>2];f[m+20>>2]=f[e+20>>2];u=d;return}f[e+4>>2]=0;f[e+8>>2]=0;m=e+4|0;f[e>>2]=m;r=e+12|0;f[r>>2]=0;t=w+24|0;Elc(e,c,t);x=f[m>>2]|0;if(x){y=m;z=x;c:while(1){x=z;while(1){if((f[x+16>>2]|0)>=(c|0))break;A=f[x+4>>2]|0;if(!A){B=y;break c}else x=A}z=f[x>>2]|0;if(!z){B=x;break}else y=x}if((B|0)!=(m|0)?(f[B+16>>2]|0)<=(c|0):0)C=B;else q=29}else q=29;if((q|0)==29)C=m;skc(t);t=p+24|0;Elc(b,c,t);skc(t);Elc(a,c,C+24|0);if((f[r>>2]|0)==0?(r=f[e>>2]|0,(r|0)!=(m|0)):0){C=r;while(1){nkc(C+24|0);r=f[C+4>>2]|0;if(!r){t=C+8|0;B=f[t>>2]|0;if((f[B>>2]|0)==(C|0))D=B;else{B=t;do{t=f[B>>2]|0;B=t+8|0;y=f[B>>2]|0}while((f[y>>2]|0)!=(t|0));D=y}}else{B=r;while(1){x=f[B>>2]|0;if(!x)break;else B=x}D=B}if((D|0)==(m|0))break;else C=D}}jkc(e,f[m>>2]|0);u=d;return}if(v){if((f[a+12>>2]|0)==(f[b+12>>2]|0)){v=g+4|0;fJc(v|0,w+24|0,24)|0;m=e+4|0;f[m>>2]=f[v>>2];f[m+4>>2]=f[v+4>>2];f[m+8>>2]=f[v+8>>2];f[m+12>>2]=f[v+12>>2];f[m+16>>2]=f[v+16>>2];f[m+20>>2]=f[v+20>>2];do if(!j){v=a+4|0;m=i;while(1){D=f[m+16>>2]|0;if((D|0)>(c|0)){C=f[m>>2]|0;if(!C){q=45;break}else{E=m;F=C}}else{if((D|0)>=(c|0)){q=50;break}G=m+4|0;D=f[G>>2]|0;if(!D){q=49;break}else{E=G;F=D}}v=E;m=F}if((q|0)==45){H=m;I=m;break}else if((q|0)==49){H=G;I=m;break}else if((q|0)==50){H=v;I=m;break}}else{H=h;I=h}while(0);if(!(f[H>>2]|0)){G=VDc(48)|0;f[G+16>>2]=c;F=G+20|0;f[F>>2]=f[e>>2];f[F+4>>2]=f[e+4>>2];f[F+8>>2]=f[e+8>>2];f[F+12>>2]=f[e+12>>2];f[F+16>>2]=f[e+16>>2];f[F+20>>2]=f[e+20>>2];f[F+24>>2]=f[e+24>>2];f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=I;f[H>>2]=G;I=f[f[a>>2]>>2]|0;if(!I)J=G;else{f[a>>2]=I;J=f[H>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}}else Elc(a,c,w+24|0);w=f[o>>2]|0;if(!w){u=d;return}else{K=o;L=w}d:while(1){J=L;while(1){if((f[J+16>>2]|0)>=(c|0))break;H=f[J+4>>2]|0;if(!H){M=K;break d}else J=H}L=f[J>>2]|0;if(!L){M=J;break}else K=J}if((M|0)==(o|0)){u=d;return}if((f[M+16>>2]|0)>(c|0)){u=d;return}K=f[M+4>>2]|0;if(!K){L=M+8|0;m=f[L>>2]|0;if((f[m>>2]|0)==(M|0))N=m;else{m=L;do{L=f[m>>2]|0;m=L+8|0;v=f[m>>2]|0}while((f[v>>2]|0)!=(L|0));N=v}}else{m=K;while(1){K=f[m>>2]|0;if(!K)break;else m=K}N=m}if((f[b>>2]|0)==(M|0))f[b>>2]=N;N=b+8|0;f[N>>2]=(f[N>>2]|0)+-1;uHa(w,M);YDc(M);u=d;return}if(!n){u=d;return}if((f[a+12>>2]|0)==(f[b+12>>2]|0)){n=g+4|0;fJc(n|0,p+24|0,24)|0;g=e+4|0;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];f[g+8>>2]=f[n+8>>2];f[g+12>>2]=f[n+12>>2];f[g+16>>2]=f[n+16>>2];f[g+20>>2]=f[n+20>>2];do if(!l){n=b+4|0;g=k;while(1){M=f[g+16>>2]|0;if((M|0)>(c|0)){w=f[g>>2]|0;if(!w){q=79;break}else{O=g;P=w}}else{if((M|0)>=(c|0)){q=84;break}Q=g+4|0;M=f[Q>>2]|0;if(!M){q=83;break}else{O=Q;P=M}}n=O;g=P}if((q|0)==79){R=g;S=g;break}else if((q|0)==83){R=Q;S=g;break}else if((q|0)==84){R=n;S=g;break}}else{R=o;S=o}while(0);if(!(f[R>>2]|0)){o=VDc(48)|0;f[o+16>>2]=c;q=o+20|0;f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];f[q+8>>2]=f[e+8>>2];f[q+12>>2]=f[e+12>>2];f[q+16>>2]=f[e+16>>2];f[q+20>>2]=f[e+20>>2];f[q+24>>2]=f[e+24>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=S;f[R>>2]=o;S=f[f[b>>2]>>2]|0;if(!S)T=o;else{f[b>>2]=S;T=f[R>>2]|0}laa(f[b+4>>2]|0,T);T=b+8|0;f[T>>2]=(f[T>>2]|0)+1}}else Elc(b,c,p+24|0);p=f[h>>2]|0;if(!p){u=d;return}else{U=h;V=p}e:while(1){b=V;while(1){if((f[b+16>>2]|0)>=(c|0))break;T=f[b+4>>2]|0;if(!T){W=U;break e}else b=T}V=f[b>>2]|0;if(!V){W=b;break}else U=b}if((W|0)==(h|0)){u=d;return}if((f[W+16>>2]|0)>(c|0)){u=d;return}c=f[W+4>>2]|0;if(!c){h=W+8|0;U=f[h>>2]|0;if((f[U>>2]|0)==(W|0))X=U;else{U=h;do{h=f[U>>2]|0;U=h+8|0;V=f[U>>2]|0}while((f[V>>2]|0)!=(h|0));X=V}}else{U=c;while(1){c=f[U>>2]|0;if(!c)break;else U=c}X=U}if((f[a>>2]|0)==(W|0))f[a>>2]=X;X=a+8|0;f[X>>2]=(f[X>>2]|0)+-1;uHa(p,W);YDc(W);u=d;return}function Hlc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a>>2]|0;d=a+4|0;if((c|0)==(d|0)){e=1;return e|0}else g=c;a:while(1){c=g+16|0;a=g+24|0;b:do if((f[161064+(h[g+32>>0]<<2)>>2]|0)==10){if(b[c+17>>0]|0){i=f[a>>2]|0;if((f[i+4>>2]|0)>0){j=0;k=i}else break;while(1){i=f[(f[k+12>>2]|0)+4+(j<<2)>>2]|0;j=j+1|0;if(!(_i[f[(f[i>>2]|0)+32>>2]&1023](i)|0)){e=0;l=17;break a}k=f[a>>2]|0;if((j|0)>=(f[k+4>>2]|0))break b}}i=b[c+18>>0]|0;if(!(i&1)){m=f[a>>2]|0;n=f[m>>2]|0;if(!(i&16))if(_i[f[n+32>>2]&1023](m)|0)break;else{e=0;l=17;break a}else if(_i[f[n+36>>2]&1023](m)|0)break;else{e=0;l=17;break a}}}while(0);a=f[g+4>>2]|0;if(!a){c=g+8|0;m=f[c>>2]|0;if((f[m>>2]|0)==(g|0))o=m;else{m=c;do{c=f[m>>2]|0;m=c+8|0;n=f[m>>2]|0}while((f[n>>2]|0)!=(c|0));o=n}}else{m=a;while(1){n=f[m>>2]|0;if(!n)break;else m=n}o=m}if((o|0)==(d|0)){e=1;l=17;break}else g=o}if((l|0)==17)return e|0;return 0}function Ilc(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0;a=u;u=u+32|0;j=a;k=a+24|0;if(!(hj[f[(f[e>>2]|0)+8>>2]&511](e,d,g)|0)){l=0;u=a;return l|0}d=f[161140+(h[g>>0]<<2)>>2]|0;b[i>>0]=0;do if((c|0)==2&(b[g+1>>0]|0)!=0){if(d>>>0>=6){rTb(j,3,504144,74);oTb(k,mTb(j,504694)|0);sTb(j);break}if(35>>>(d&63)&1){b[i>>0]=1;l=1;u=a;return l|0}}while(0);l=(d|0)==(c|0);u=a;return l|0}function Jlc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h;k=c>>>3;if(Ilc(0,c&7,k,e,j,i)|0){l=Klc(a,k,(b[i>>0]|0)!=0,j,d,g)|0;u=h;return l|0}else{l=hj[f[(f[g>>2]|0)+8>>2]&511](g,d,c)|0;u=h;return l|0}return 0}function Klc(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0.0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0;j=u;u=u+80|0;k=j+8|0;l=j+40|0;m=j+64|0;o=j;a:do if(d){q=f[g>>2]|0;r=g+4|0;if(q>>>0<(f[r>>2]|0)>>>0){t=b[q>>0]|0;v=t&255;if(t<<24>>24>-1){f[g>>2]=q+1;w=v}else{x=v;y=5}}else{x=0;y=5}if((y|0)==5){v=HRb(g,x)|0;q=J;if((q|0)>-1|(q|0)==-1&v>>>0>4294967295)w=v;else{z=0;u=j;return z|0}}v=ERb(g,w)|0;b:do switch(b[e>>0]|0){case 5:{if((MRb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0){B=b[A>>0]|0;C=B&255;if(B<<24>>24>-1){f[g>>2]=A+1;D=C}else{E=C;y=38}}else{E=0;y=38}if((y|0)==38){y=0;C=HRb(g,E)|0;A=J;if((A|0)>-1|(A|0)==-1&C>>>0>4294967295)D=C;else{z=0;break}}ykc(a,c,5,(b[q>>0]|0)!=0,D,f[t>>2]|0);if((MRb(g)|0)<=0)break b}u=j;return z|0}break}case 3:{if((MRb(g)|0)>0){t=e+2|0;q=e+12|0;C=k+8|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){f[g>>2]=A+1;F=B&255;G=0}else{IRb(k,g);B=k;if(!(b[C>>0]|0)){z=0;break}else{F=f[B>>2]|0;G=f[B+4>>2]|0}}Ekc(a,c,3,(b[t>>0]|0)!=0,F,G,f[q>>2]|0);if((MRb(g)|0)<=0)break b}u=j;return z|0}break}case 13:{if((MRb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(C>>>0<(f[r>>2]|0)>>>0){B=b[C>>0]|0;A=B&255;if(B<<24>>24>-1){f[g>>2]=C+1;H=A}else{I=A;y=48}}else{I=0;y=48}if((y|0)==48){y=0;A=HRb(g,I)|0;C=J;if((C|0)>-1|(C|0)==-1&A>>>0>4294967295)H=A;else{z=0;break}}Kkc(a,c,13,(b[q>>0]|0)!=0,H,f[t>>2]|0);if((MRb(g)|0)<=0)break b}u=j;return z|0}break}case 4:{if((MRb(g)|0)>0){t=e+2|0;q=e+12|0;A=k+8|0;while(1){C=f[g>>2]|0;if(C>>>0<(f[r>>2]|0)>>>0?(B=b[C>>0]|0,B<<24>>24>-1):0){f[g>>2]=C+1;K=B&255;L=0}else{IRb(k,g);B=k;if(!(b[A>>0]|0)){z=0;break}else{K=f[B>>2]|0;L=f[B+4>>2]|0}}Qkc(a,c,4,(b[t>>0]|0)!=0,K,L,f[q>>2]|0);if((MRb(g)|0)<=0)break b}u=j;return z|0}break}case 17:{if((MRb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0){B=b[A>>0]|0;C=B&255;if(B<<24>>24>-1){f[g>>2]=A+1;M=C>>>1^0-(C&1)}else{N=C;y=58}}else{N=0;y=58}if((y|0)==58){y=0;C=HRb(g,N)|0;A=J;if((A|0)>-1|(A|0)==-1&C>>>0>4294967295)M=C>>>1^0-(C&1);else{z=0;break}}ykc(a,c,17,(b[q>>0]|0)!=0,M,f[t>>2]|0);if((MRb(g)|0)<=0)break b}u=j;return z|0}break}case 18:{if((MRb(g)|0)>0){t=e+2|0;q=e+12|0;C=k+8|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){O=B&255;f[g>>2]=A+1;A=aJc(O|0,0,1)|0;B=J;P=TIc(0,0,O&1|0,0)|0;Q=A^P;R=B^J}else{IRb(k,g);B=k;P=f[B>>2]|0;A=(b[C>>0]|0)==0;O=aJc(P|0,f[B+4>>2]|0,1)|0;B=J;S=TIc(0,0,P&1|0,0)|0;if(A){z=0;break}else{Q=O^S;R=B^J}}Ekc(a,c,18,(b[t>>0]|0)!=0,Q,R,f[q>>2]|0);if((MRb(g)|0)<=0)break b}u=j;return z|0}break}case 7:{if((MRb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){B=C;S=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;T=S}else{if(!(TRb(g,k)|0))break;T=f[k>>2]|0}Kkc(a,c,7,(b[q>>0]|0)!=0,T,f[t>>2]|0);if((MRb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 6:{if((MRb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;B=C;O=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=C+4|0;C=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=k;f[B>>2]=O;f[B+4>>2]=C;f[g>>2]=S+8;U=O;V=C}else{if(!(URb(g,k)|0))break;C=k;U=f[C>>2]|0;V=f[C+4>>2]|0}Qkc(a,c,6,(b[t>>0]|0)!=0,U,V,f[q>>2]|0);if((MRb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 15:{if((MRb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){O=C;S=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;W=S}else{if(!(TRb(g,k)|0))break;W=f[k>>2]|0}ykc(a,c,15,(b[q>>0]|0)!=0,W,f[t>>2]|0);if((MRb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 16:{if((MRb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;O=C;B=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;O=C+4|0;C=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;O=k;f[O>>2]=B;f[O+4>>2]=C;f[g>>2]=S+8;X=B;Y=C}else{if(!(URb(g,k)|0))break;C=k;X=f[C>>2]|0;Y=f[C+4>>2]|0}Ekc(a,c,16,(b[t>>0]|0)!=0,X,Y,f[q>>2]|0);if((MRb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 2:{if((MRb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){B=C;S=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;Z=S}else{if(!(TRb(g,k)|0))break;Z=f[k>>2]|0}Wkc(a,c,2,(b[q>>0]|0)!=0,(f[s>>2]=Z,+n[s>>2]),f[t>>2]|0);if((MRb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 1:{if((MRb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;B=C;O=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=C+4|0;C=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=k;f[B>>2]=O;f[B+4>>2]=C;f[g>>2]=S+8;f[s>>2]=O;f[s+4>>2]=C;_=+p[s>>3]}else{if(!(URb(g,k)|0))break;_=+p[k>>3]}alc(a,c,1,(b[t>>0]|0)!=0,_,f[q>>2]|0);if((MRb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 8:{if((MRb(g)|0)>0){q=e+2|0;t=e+12|0;C=k+8|0;while(1){O=f[g>>2]|0;if(O>>>0<(f[r>>2]|0)>>>0?(S=b[O>>0]|0,S<<24>>24>-1):0){f[g>>2]=O+1;$=S<<24>>24!=0}else{IRb(k,g);S=k;if(!(b[C>>0]|0)){z=0;break}else $=(f[S>>2]|0)!=0|(f[S+4>>2]|0)!=0}glc(a,c,8,(b[q>>0]|0)!=0,$,f[t>>2]|0);if((MRb(g)|0)<=0)break b}u=j;return z|0}break}case 14:{if((MRb(g)|0)>0){t=e+4|0;q=e+8|0;C=e+2|0;S=e+12|0;while(1){O=f[g>>2]|0;if(O>>>0<(f[r>>2]|0)>>>0){B=b[O>>0]|0;A=B&255;if(B<<24>>24>-1){f[g>>2]=O+1;aa=A}else{ba=A;y=109}}else{ba=0;y=109}if((y|0)==109){y=0;A=HRb(g,ba)|0;O=J;if((O|0)>-1|(O|0)==-1&A>>>0>4294967295)aa=A;else{z=0;break}}if(Mi[f[t>>2]&1023](f[q>>2]|0,aa)|0)olc(a,c,14,(b[C>>0]|0)!=0,aa,f[S>>2]|0);else Ti[f[(f[i>>2]|0)+16>>2]&511](i,c,aa);if((MRb(g)|0)<=0)break b}u=j;return z|0}break}case 11:case 10:case 12:case 9:{rTb(l,3,504144,1221);oTb(m,mTb(l,504712)|0);sTb(l);break}default:{}}while(0);FRb(g,v)}else do switch(b[e>>0]|0){case 5:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){S=b[r>>0]|0;C=S&255;if(S<<24>>24>-1){f[g>>2]=r+1;ca=C}else{da=C;y=120}}else{da=0;y=120}if((y|0)==120){C=HRb(g,da)|0;r=J;if((r|0)>-1|(r|0)==-1&C>>>0>4294967295)ca=C;else{z=0;u=j;return z|0}}C=f[e+12>>2]|0;if(b[e+1>>0]|0){ykc(a,c,5,(b[e+2>>0]|0)!=0,ca,C);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;S=f[r>>2]|0;do if(S){q=a+4|0;t=S;while(1){A=f[t+16>>2]|0;if((A|0)>(c|0)){O=f[t>>2]|0;if(!O){y=127;break}else{ea=t;fa=O}}else{if((A|0)>=(c|0)){y=132;break}ga=t+4|0;A=f[ga>>2]|0;if(!A){y=131;break}else{ea=ga;fa=A}}q=ea;t=fa}if((y|0)==127){ha=t;ia=t;break}else if((y|0)==131){ha=ga;ia=t;break}else if((y|0)==132){ha=q;ia=t;break}}else{ha=r;ia=r}while(0);r=f[ha>>2]|0;if(!r){S=VDc(48)|0;f[S+16>>2]=c;A=S+20|0;f[A>>2]=f[k>>2];f[A+4>>2]=f[k+4>>2];f[A+8>>2]=f[k+8>>2];f[A+12>>2]=f[k+12>>2];f[A+16>>2]=f[k+16>>2];f[A+20>>2]=f[k+20>>2];f[A+24>>2]=f[k+24>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=ia;f[ha>>2]=S;A=f[f[a>>2]>>2]|0;if(!A)ja=S;else{f[a>>2]=A;ja=f[ha>>2]|0}laa(f[a+4>>2]|0,ja);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[S+40>>2]=C;b[S+32>>0]=5;b[S+33>>0]=0;ka=S+24|0}else{f[r+40>>2]=C;ka=r+24|0}r=ka+10|0;b[r>>0]=b[r>>0]&-16;f[ka>>2]=ca;break a;break}case 3:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0?(S=b[r>>0]|0,S<<24>>24>-1):0){f[g>>2]=r+1;la=S&255;ma=0}else{IRb(k,g);S=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else{la=f[S>>2]|0;ma=f[S+4>>2]|0}}S=f[e+12>>2]|0;if(b[e+1>>0]|0){Ekc(a,c,3,(b[e+2>>0]|0)!=0,la,ma,S);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;A=f[r>>2]|0;do if(A){O=a+4|0;B=A;while(1){P=f[B+16>>2]|0;if((P|0)>(c|0)){na=f[B>>2]|0;if(!na){y=150;break}else{oa=B;pa=na}}else{if((P|0)>=(c|0)){y=155;break}qa=B+4|0;P=f[qa>>2]|0;if(!P){y=154;break}else{oa=qa;pa=P}}O=oa;B=pa}if((y|0)==150){ra=B;sa=B;break}else if((y|0)==154){ra=qa;sa=B;break}else if((y|0)==155){ra=O;sa=B;break}}else{ra=r;sa=r}while(0);r=f[ra>>2]|0;if(!r){A=VDc(48)|0;f[A+16>>2]=c;C=A+20|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2];f[C+8>>2]=f[k+8>>2];f[C+12>>2]=f[k+12>>2];f[C+16>>2]=f[k+16>>2];f[C+20>>2]=f[k+20>>2];f[C+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=sa;f[ra>>2]=A;C=f[f[a>>2]>>2]|0;if(!C)ta=A;else{f[a>>2]=C;ta=f[ra>>2]|0}laa(f[a+4>>2]|0,ta);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[A+40>>2]=S;b[A+32>>0]=3;b[A+33>>0]=0;ua=A+24|0}else{f[r+40>>2]=S;ua=r+24|0}r=ua+10|0;b[r>>0]=b[r>>0]&-16;r=ua;f[r>>2]=la;f[r+4>>2]=ma;break a;break}case 13:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){A=b[r>>0]|0;C=A&255;if(A<<24>>24>-1){f[g>>2]=r+1;va=C}else{wa=C;y=166}}else{wa=0;y=166}if((y|0)==166){C=HRb(g,wa)|0;r=J;if((r|0)>-1|(r|0)==-1&C>>>0>4294967295)va=C;else{z=0;u=j;return z|0}}C=f[e+12>>2]|0;if(b[e+1>>0]|0){Kkc(a,c,13,(b[e+2>>0]|0)!=0,va,C);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;A=f[r>>2]|0;do if(A){t=a+4|0;q=A;while(1){P=f[q+16>>2]|0;if((P|0)>(c|0)){na=f[q>>2]|0;if(!na){y=173;break}else{xa=q;ya=na}}else{if((P|0)>=(c|0)){y=178;break}za=q+4|0;P=f[za>>2]|0;if(!P){y=177;break}else{xa=za;ya=P}}t=xa;q=ya}if((y|0)==173){Aa=q;Ba=q;break}else if((y|0)==177){Aa=za;Ba=q;break}else if((y|0)==178){Aa=t;Ba=q;break}}else{Aa=r;Ba=r}while(0);r=f[Aa>>2]|0;if(!r){A=VDc(48)|0;f[A+16>>2]=c;S=A+20|0;f[S>>2]=f[k>>2];f[S+4>>2]=f[k+4>>2];f[S+8>>2]=f[k+8>>2];f[S+12>>2]=f[k+12>>2];f[S+16>>2]=f[k+16>>2];f[S+20>>2]=f[k+20>>2];f[S+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Ba;f[Aa>>2]=A;S=f[f[a>>2]>>2]|0;if(!S)Ca=A;else{f[a>>2]=S;Ca=f[Aa>>2]|0}laa(f[a+4>>2]|0,Ca);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[A+40>>2]=C;b[A+32>>0]=13;b[A+33>>0]=0;Da=A+24|0}else{f[r+40>>2]=C;Da=r+24|0}r=Da+10|0;b[r>>0]=b[r>>0]&-16;f[Da>>2]=va;break a;break}case 4:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0?(A=b[r>>0]|0,A<<24>>24>-1):0){f[g>>2]=r+1;Ea=A&255;Fa=0}else{IRb(k,g);A=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else{Ea=f[A>>2]|0;Fa=f[A+4>>2]|0}}A=f[e+12>>2]|0;if(b[e+1>>0]|0){Qkc(a,c,4,(b[e+2>>0]|0)!=0,Ea,Fa,A);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;S=f[r>>2]|0;do if(S){B=a+4|0;O=S;while(1){P=f[O+16>>2]|0;if((P|0)>(c|0)){na=f[O>>2]|0;if(!na){y=196;break}else{Ga=O;Ha=na}}else{if((P|0)>=(c|0)){y=201;break}Ia=O+4|0;P=f[Ia>>2]|0;if(!P){y=200;break}else{Ga=Ia;Ha=P}}B=Ga;O=Ha}if((y|0)==196){Ja=O;Ka=O;break}else if((y|0)==200){Ja=Ia;Ka=O;break}else if((y|0)==201){Ja=B;Ka=O;break}}else{Ja=r;Ka=r}while(0);r=f[Ja>>2]|0;if(!r){S=VDc(48)|0;f[S+16>>2]=c;C=S+20|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2];f[C+8>>2]=f[k+8>>2];f[C+12>>2]=f[k+12>>2];f[C+16>>2]=f[k+16>>2];f[C+20>>2]=f[k+20>>2];f[C+24>>2]=f[k+24>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=Ka;f[Ja>>2]=S;C=f[f[a>>2]>>2]|0;if(!C)La=S;else{f[a>>2]=C;La=f[Ja>>2]|0}laa(f[a+4>>2]|0,La);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[S+40>>2]=A;b[S+32>>0]=4;b[S+33>>0]=0;Ma=S+24|0}else{f[r+40>>2]=A;Ma=r+24|0}r=Ma+10|0;b[r>>0]=b[r>>0]&-16;r=Ma;f[r>>2]=Ea;f[r+4>>2]=Fa;break a;break}case 17:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){S=b[r>>0]|0;C=S&255;if(S<<24>>24>-1){f[g>>2]=r+1;Na=C>>>1^0-(C&1)}else{Oa=C;y=212}}else{Oa=0;y=212}if((y|0)==212){C=HRb(g,Oa)|0;r=J;if((r|0)>-1|(r|0)==-1&C>>>0>4294967295)Na=C>>>1^0-(C&1);else{z=0;u=j;return z|0}}C=f[e+12>>2]|0;if(b[e+1>>0]|0){ykc(a,c,17,(b[e+2>>0]|0)!=0,Na,C);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;S=f[r>>2]|0;do if(S){q=a+4|0;t=S;while(1){P=f[t+16>>2]|0;if((P|0)>(c|0)){na=f[t>>2]|0;if(!na){y=219;break}else{Pa=t;Qa=na}}else{if((P|0)>=(c|0)){y=224;break}Ra=t+4|0;P=f[Ra>>2]|0;if(!P){y=223;break}else{Pa=Ra;Qa=P}}q=Pa;t=Qa}if((y|0)==219){Sa=t;Ta=t;break}else if((y|0)==223){Sa=Ra;Ta=t;break}else if((y|0)==224){Sa=q;Ta=t;break}}else{Sa=r;Ta=r}while(0);r=f[Sa>>2]|0;if(!r){S=VDc(48)|0;f[S+16>>2]=c;A=S+20|0;f[A>>2]=f[k>>2];f[A+4>>2]=f[k+4>>2];f[A+8>>2]=f[k+8>>2];f[A+12>>2]=f[k+12>>2];f[A+16>>2]=f[k+16>>2];f[A+20>>2]=f[k+20>>2];f[A+24>>2]=f[k+24>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=Ta;f[Sa>>2]=S;A=f[f[a>>2]>>2]|0;if(!A)Ua=S;else{f[a>>2]=A;Ua=f[Sa>>2]|0}laa(f[a+4>>2]|0,Ua);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[S+40>>2]=C;b[S+32>>0]=17;b[S+33>>0]=0;Va=S+24|0}else{f[r+40>>2]=C;Va=r+24|0}r=Va+10|0;b[r>>0]=b[r>>0]&-16;f[Va>>2]=Na;break a;break}case 18:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0?(S=b[r>>0]|0,S<<24>>24>-1):0){A=S&255;f[g>>2]=r+1;r=aJc(A|0,0,1)|0;S=J;O=TIc(0,0,A&1|0,0)|0;Wa=r^O;Xa=S^J}else{IRb(k,g);S=k;O=f[S>>2]|0;r=(b[k+8>>0]|0)==0;A=aJc(O|0,f[S+4>>2]|0,1)|0;S=J;B=TIc(0,0,O&1|0,0)|0;O=S^J;if(r){z=0;u=j;return z|0}else{Wa=A^B;Xa=O}}O=f[e+12>>2]|0;if(b[e+1>>0]|0){Ekc(a,c,18,(b[e+2>>0]|0)!=0,Wa,Xa,O);break a}B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;B=a+4|0;A=f[B>>2]|0;do if(A){r=a+4|0;S=A;while(1){P=f[S+16>>2]|0;if((P|0)>(c|0)){na=f[S>>2]|0;if(!na){y=242;break}else{Ya=S;Za=na}}else{if((P|0)>=(c|0)){y=247;break}_a=S+4|0;P=f[_a>>2]|0;if(!P){y=246;break}else{Ya=_a;Za=P}}r=Ya;S=Za}if((y|0)==242){$a=S;ab=S;break}else if((y|0)==246){$a=_a;ab=S;break}else if((y|0)==247){$a=r;ab=S;break}}else{$a=B;ab=B}while(0);B=f[$a>>2]|0;if(!B){A=VDc(48)|0;f[A+16>>2]=c;C=A+20|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2];f[C+8>>2]=f[k+8>>2];f[C+12>>2]=f[k+12>>2];f[C+16>>2]=f[k+16>>2];f[C+20>>2]=f[k+20>>2];f[C+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=ab;f[$a>>2]=A;C=f[f[a>>2]>>2]|0;if(!C)bb=A;else{f[a>>2]=C;bb=f[$a>>2]|0}laa(f[a+4>>2]|0,bb);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[A+40>>2]=O;b[A+32>>0]=18;b[A+33>>0]=0;cb=A+24|0}else{f[B+40>>2]=O;cb=B+24|0}B=cb+10|0;b[B>>0]=b[B>>0]&-16;B=cb;f[B>>2]=Wa;f[B+4>>2]=Xa;break a;break}case 7:{B=f[g>>2]|0;do if(((f[g+4>>2]|0)-B|0)>3){A=B;C=h[A>>0]|h[A+1>>0]<<8|h[A+2>>0]<<16|h[A+3>>0]<<24;f[o>>2]=C;f[g>>2]=B+4;db=C}else{if(TRb(g,o)|0){db=f[o>>2]|0;break}z=0;u=j;return z|0}while(0);B=f[e+12>>2]|0;if(!(b[e+1>>0]|0)){O=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;O=a+4|0;C=f[O>>2]|0;do if(C){A=a+4|0;t=C;while(1){q=f[t+16>>2]|0;if((q|0)>(c|0)){P=f[t>>2]|0;if(!P){y=265;break}else{eb=t;fb=P}}else{if((q|0)>=(c|0)){y=270;break}gb=t+4|0;q=f[gb>>2]|0;if(!q){y=269;break}else{eb=gb;fb=q}}A=eb;t=fb}if((y|0)==265){hb=t;ib=t;break}else if((y|0)==269){hb=gb;ib=t;break}else if((y|0)==270){hb=A;ib=t;break}}else{hb=O;ib=O}while(0);O=f[hb>>2]|0;if(!O){C=VDc(48)|0;f[C+16>>2]=c;S=C+20|0;f[S>>2]=f[k>>2];f[S+4>>2]=f[k+4>>2];f[S+8>>2]=f[k+8>>2];f[S+12>>2]=f[k+12>>2];f[S+16>>2]=f[k+16>>2];f[S+20>>2]=f[k+20>>2];f[S+24>>2]=f[k+24>>2];f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=ib;f[hb>>2]=C;S=f[f[a>>2]>>2]|0;if(!S)jb=C;else{f[a>>2]=S;jb=f[hb>>2]|0}laa(f[a+4>>2]|0,jb);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[C+40>>2]=B;b[C+32>>0]=7;b[C+33>>0]=0;kb=C+24|0}else{f[O+40>>2]=B;kb=O+24|0}O=kb+10|0;b[O>>0]=b[O>>0]&-16;f[kb>>2]=db}else Kkc(a,c,7,(b[e+2>>0]|0)!=0,db,B);break a;break}case 6:{O=f[g>>2]|0;do if(((f[g+4>>2]|0)-O|0)>7){C=O;S=C;r=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=C+4|0;C=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=o;f[S>>2]=r;f[S+4>>2]=C;f[g>>2]=O+8;lb=r;mb=C}else{if(URb(g,o)|0){C=o;lb=f[C>>2]|0;mb=f[C+4>>2]|0;break}z=0;u=j;return z|0}while(0);O=f[e+12>>2]|0;if(!(b[e+1>>0]|0)){B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;B=a+4|0;C=f[B>>2]|0;do if(C){r=a+4|0;S=C;while(1){q=f[S+16>>2]|0;if((q|0)>(c|0)){P=f[S>>2]|0;if(!P){y=289;break}else{nb=S;ob=P}}else{if((q|0)>=(c|0)){y=294;break}pb=S+4|0;q=f[pb>>2]|0;if(!q){y=293;break}else{nb=pb;ob=q}}r=nb;S=ob}if((y|0)==289){qb=S;rb=S;break}else if((y|0)==293){qb=pb;rb=S;break}else if((y|0)==294){qb=r;rb=S;break}}else{qb=B;rb=B}while(0);B=f[qb>>2]|0;if(!B){C=VDc(48)|0;f[C+16>>2]=c;t=C+20|0;f[t>>2]=f[k>>2];f[t+4>>2]=f[k+4>>2];f[t+8>>2]=f[k+8>>2];f[t+12>>2]=f[k+12>>2];f[t+16>>2]=f[k+16>>2];f[t+20>>2]=f[k+20>>2];f[t+24>>2]=f[k+24>>2];f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=rb;f[qb>>2]=C;t=f[f[a>>2]>>2]|0;if(!t)sb=C;else{f[a>>2]=t;sb=f[qb>>2]|0}laa(f[a+4>>2]|0,sb);t=a+8|0;f[t>>2]=(f[t>>2]|0)+1;f[C+40>>2]=O;b[C+32>>0]=6;b[C+33>>0]=0;tb=C+24|0}else{f[B+40>>2]=O;tb=B+24|0}B=tb+10|0;b[B>>0]=b[B>>0]&-16;B=tb;f[B>>2]=lb;f[B+4>>2]=mb}else Qkc(a,c,6,(b[e+2>>0]|0)!=0,lb,mb,O);break a;break}case 15:{B=f[g>>2]|0;do if(((f[g+4>>2]|0)-B|0)>3){C=B;t=h[C>>0]|h[C+1>>0]<<8|h[C+2>>0]<<16|h[C+3>>0]<<24;f[k>>2]=t;f[g>>2]=B+4;ub=t}else{if(TRb(g,k)|0){ub=f[k>>2]|0;break}z=0;u=j;return z|0}while(0);B=f[e+12>>2]|0;if(b[e+1>>0]|0){ykc(a,c,15,(b[e+2>>0]|0)!=0,ub,B);break a}O=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;O=a+4|0;t=f[O>>2]|0;do if(t){C=a+4|0;A=t;while(1){q=f[A+16>>2]|0;if((q|0)>(c|0)){P=f[A>>2]|0;if(!P){y=313;break}else{vb=A;wb=P}}else{if((q|0)>=(c|0)){y=318;break}xb=A+4|0;q=f[xb>>2]|0;if(!q){y=317;break}else{vb=xb;wb=q}}C=vb;A=wb}if((y|0)==313){yb=A;zb=A;break}else if((y|0)==317){yb=xb;zb=A;break}else if((y|0)==318){yb=C;zb=A;break}}else{yb=O;zb=O}while(0);O=f[yb>>2]|0;if(!O){t=VDc(48)|0;f[t+16>>2]=c;S=t+20|0;f[S>>2]=f[k>>2];f[S+4>>2]=f[k+4>>2];f[S+8>>2]=f[k+8>>2];f[S+12>>2]=f[k+12>>2];f[S+16>>2]=f[k+16>>2];f[S+20>>2]=f[k+20>>2];f[S+24>>2]=f[k+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=zb;f[yb>>2]=t;S=f[f[a>>2]>>2]|0;if(!S)Ab=t;else{f[a>>2]=S;Ab=f[yb>>2]|0}laa(f[a+4>>2]|0,Ab);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[t+40>>2]=B;b[t+32>>0]=15;b[t+33>>0]=0;Bb=t+24|0}else{f[O+40>>2]=B;Bb=O+24|0}O=Bb+10|0;b[O>>0]=b[O>>0]&-16;f[Bb>>2]=ub;break a;break}case 16:{O=f[g>>2]|0;do if(((f[g+4>>2]|0)-O|0)>7){t=O;S=t;r=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=t+4|0;t=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=k;f[S>>2]=r;f[S+4>>2]=t;f[g>>2]=O+8;Cb=r;Db=t}else{if(URb(g,k)|0){t=k;Cb=f[t>>2]|0;Db=f[t+4>>2]|0;break}z=0;u=j;return z|0}while(0);O=f[e+12>>2]|0;if(b[e+1>>0]|0){Ekc(a,c,16,(b[e+2>>0]|0)!=0,Cb,Db,O);break a}B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;B=a+4|0;t=f[B>>2]|0;do if(t){r=a+4|0;S=t;while(1){q=f[S+16>>2]|0;if((q|0)>(c|0)){P=f[S>>2]|0;if(!P){y=336;break}else{Eb=S;Fb=P}}else{if((q|0)>=(c|0)){y=341;break}Gb=S+4|0;q=f[Gb>>2]|0;if(!q){y=340;break}else{Eb=Gb;Fb=q}}r=Eb;S=Fb}if((y|0)==336){Hb=S;Ib=S;break}else if((y|0)==340){Hb=Gb;Ib=S;break}else if((y|0)==341){Hb=r;Ib=S;break}}else{Hb=B;Ib=B}while(0);B=f[Hb>>2]|0;if(!B){t=VDc(48)|0;f[t+16>>2]=c;A=t+20|0;f[A>>2]=f[k>>2];f[A+4>>2]=f[k+4>>2];f[A+8>>2]=f[k+8>>2];f[A+12>>2]=f[k+12>>2];f[A+16>>2]=f[k+16>>2];f[A+20>>2]=f[k+20>>2];f[A+24>>2]=f[k+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=Ib;f[Hb>>2]=t;A=f[f[a>>2]>>2]|0;if(!A)Jb=t;else{f[a>>2]=A;Jb=f[Hb>>2]|0}laa(f[a+4>>2]|0,Jb);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[t+40>>2]=O;b[t+32>>0]=16;b[t+33>>0]=0;Kb=t+24|0}else{f[B+40>>2]=O;Kb=B+24|0}B=Kb+10|0;b[B>>0]=b[B>>0]&-16;B=Kb;f[B>>2]=Cb;f[B+4>>2]=Db;break a;break}case 2:{B=f[g>>2]|0;do if(((f[g+4>>2]|0)-B|0)>3){t=B;A=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[k>>2]=A;f[g>>2]=B+4;Lb=A}else{if(TRb(g,k)|0){Lb=f[k>>2]|0;break}z=0;u=j;return z|0}while(0);B=f[e+12>>2]|0;if(b[e+1>>0]|0){Wkc(a,c,2,(b[e+2>>0]|0)!=0,(f[s>>2]=Lb,+n[s>>2]),B);break a}O=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;O=a+4|0;A=f[O>>2]|0;do if(A){t=a+4|0;C=A;while(1){q=f[C+16>>2]|0;if((q|0)>(c|0)){P=f[C>>2]|0;if(!P){y=359;break}else{Mb=C;Nb=P}}else{if((q|0)>=(c|0)){y=364;break}Ob=C+4|0;q=f[Ob>>2]|0;if(!q){y=363;break}else{Mb=Ob;Nb=q}}t=Mb;C=Nb}if((y|0)==359){Pb=C;Qb=C;break}else if((y|0)==363){Pb=Ob;Qb=C;break}else if((y|0)==364){Pb=t;Qb=C;break}}else{Pb=O;Qb=O}while(0);O=f[Pb>>2]|0;if(!O){A=VDc(48)|0;f[A+16>>2]=c;S=A+20|0;f[S>>2]=f[k>>2];f[S+4>>2]=f[k+4>>2];f[S+8>>2]=f[k+8>>2];f[S+12>>2]=f[k+12>>2];f[S+16>>2]=f[k+16>>2];f[S+20>>2]=f[k+20>>2];f[S+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Qb;f[Pb>>2]=A;S=f[f[a>>2]>>2]|0;if(!S)Rb=A;else{f[a>>2]=S;Rb=f[Pb>>2]|0}laa(f[a+4>>2]|0,Rb);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[A+40>>2]=B;b[A+32>>0]=2;b[A+33>>0]=0;Sb=A+24|0}else{f[O+40>>2]=B;Sb=O+24|0}O=Sb+10|0;b[O>>0]=b[O>>0]&-16;f[Sb>>2]=Lb;break a;break}case 1:{O=f[g>>2]|0;do if(((f[g+4>>2]|0)-O|0)>7){A=O;S=A;r=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=A+4|0;A=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=k;f[S>>2]=r;f[S+4>>2]=A;f[g>>2]=O+8;f[s>>2]=r;f[s+4>>2]=A;Tb=+p[s>>3]}else{if(URb(g,k)|0){Tb=+p[k>>3];break}z=0;u=j;return z|0}while(0);O=f[e+12>>2]|0;if(b[e+1>>0]|0){alc(a,c,1,(b[e+2>>0]|0)!=0,Tb,O);break a}B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;B=a+4|0;A=f[B>>2]|0;do if(A){r=a+4|0;S=A;while(1){q=f[S+16>>2]|0;if((q|0)>(c|0)){P=f[S>>2]|0;if(!P){y=382;break}else{Ub=S;Vb=P}}else{if((q|0)>=(c|0)){y=387;break}Wb=S+4|0;q=f[Wb>>2]|0;if(!q){y=386;break}else{Ub=Wb;Vb=q}}r=Ub;S=Vb}if((y|0)==382){Xb=S;Yb=S;break}else if((y|0)==386){Xb=Wb;Yb=S;break}else if((y|0)==387){Xb=r;Yb=S;break}}else{Xb=B;Yb=B}while(0);B=f[Xb>>2]|0;if(!B){A=VDc(48)|0;f[A+16>>2]=c;C=A+20|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2];f[C+8>>2]=f[k+8>>2];f[C+12>>2]=f[k+12>>2];f[C+16>>2]=f[k+16>>2];f[C+20>>2]=f[k+20>>2];f[C+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Yb;f[Xb>>2]=A;C=f[f[a>>2]>>2]|0;if(!C)Zb=A;else{f[a>>2]=C;Zb=f[Xb>>2]|0}laa(f[a+4>>2]|0,Zb);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[A+40>>2]=O;b[A+32>>0]=1;b[A+33>>0]=0;_b=A+24|0}else{f[B+40>>2]=O;_b=B+24|0}B=_b+10|0;b[B>>0]=b[B>>0]&-16;p[_b>>3]=Tb;break a;break}case 8:{B=f[g>>2]|0;if(B>>>0<(f[g+4>>2]|0)>>>0?(A=b[B>>0]|0,A<<24>>24>-1):0){f[g>>2]=B+1;$b=A<<24>>24!=0}else{IRb(k,g);A=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else $b=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0}A=f[e+12>>2]|0;if(b[e+1>>0]|0){glc(a,c,8,(b[e+2>>0]|0)!=0,$b,A);break a}B=$b&1;C=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;C=a+4|0;t=f[C>>2]|0;do if(t){q=a+4|0;P=t;while(1){na=f[P+16>>2]|0;if((na|0)>(c|0)){ac=f[P>>2]|0;if(!ac){y=405;break}else{bc=P;cc=ac}}else{if((na|0)>=(c|0)){y=410;break}dc=P+4|0;na=f[dc>>2]|0;if(!na){y=409;break}else{bc=dc;cc=na}}q=bc;P=cc}if((y|0)==405){ec=P;fc=P;break}else if((y|0)==409){ec=dc;fc=P;break}else if((y|0)==410){ec=q;fc=P;break}}else{ec=C;fc=C}while(0);C=f[ec>>2]|0;if(!C){t=VDc(48)|0;f[t+16>>2]=c;O=t+20|0;f[O>>2]=f[k>>2];f[O+4>>2]=f[k+4>>2];f[O+8>>2]=f[k+8>>2];f[O+12>>2]=f[k+12>>2];f[O+16>>2]=f[k+16>>2];f[O+20>>2]=f[k+20>>2];f[O+24>>2]=f[k+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=fc;f[ec>>2]=t;O=f[f[a>>2]>>2]|0;if(!O)gc=t;else{f[a>>2]=O;gc=f[ec>>2]|0}laa(f[a+4>>2]|0,gc);O=a+8|0;f[O>>2]=(f[O>>2]|0)+1;f[t+40>>2]=A;b[t+32>>0]=8;b[t+33>>0]=0;hc=t+24|0}else{f[C+40>>2]=A;hc=C+24|0}C=hc+10|0;b[C>>0]=b[C>>0]&-16;b[hc>>0]=B;break a;break}case 14:{C=f[g>>2]|0;if(C>>>0<(f[g+4>>2]|0)>>>0){t=b[C>>0]|0;O=t&255;if(t<<24>>24>-1){f[g>>2]=C+1;ic=O}else{jc=O;y=421}}else{jc=0;y=421}if((y|0)==421){O=HRb(g,jc)|0;C=J;if((C|0)>-1|(C|0)==-1&O>>>0>4294967295)ic=O;else{z=0;u=j;return z|0}}if(!(Mi[f[e+4>>2]&1023](f[e+8>>2]|0,ic)|0)){Ti[f[(f[i>>2]|0)+16>>2]&511](i,c,ic);break a}O=f[e+12>>2]|0;if(b[e+1>>0]|0){olc(a,c,14,(b[e+2>>0]|0)!=0,ic,O);break a}C=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;C=a+4|0;t=f[C>>2]|0;do if(t){S=a+4|0;r=t;while(1){na=f[r+16>>2]|0;if((na|0)>(c|0)){ac=f[r>>2]|0;if(!ac){y=430;break}else{kc=r;lc=ac}}else{if((na|0)>=(c|0)){y=435;break}mc=r+4|0;na=f[mc>>2]|0;if(!na){y=434;break}else{kc=mc;lc=na}}S=kc;r=lc}if((y|0)==430){nc=r;oc=r;break}else if((y|0)==434){nc=mc;oc=r;break}else if((y|0)==435){nc=S;oc=r;break}}else{nc=C;oc=C}while(0);C=f[nc>>2]|0;if(!C){t=VDc(48)|0;f[t+16>>2]=c;B=t+20|0;f[B>>2]=f[k>>2];f[B+4>>2]=f[k+4>>2];f[B+8>>2]=f[k+8>>2];f[B+12>>2]=f[k+12>>2];f[B+16>>2]=f[k+16>>2];f[B+20>>2]=f[k+20>>2];f[B+24>>2]=f[k+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=oc;f[nc>>2]=t;B=f[f[a>>2]>>2]|0;if(!B)pc=t;else{f[a>>2]=B;pc=f[nc>>2]|0}laa(f[a+4>>2]|0,pc);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[t+40>>2]=O;b[t+32>>0]=14;b[t+33>>0]=0;qc=t+24|0}else{f[C+40>>2]=O;qc=C+24|0}C=qc+10|0;b[C>>0]=b[C>>0]&-16;f[qc>>2]=ic;break a;break}case 9:{C=f[e+12>>2]|0;if(!(b[e+1>>0]|0))rc=qlc(a,c,9,C)|0;else rc=tlc(a,c,9,C)|0;if(fUb(g,rc)|0)break a;else z=0;u=j;return z|0}case 12:{C=f[e+12>>2]|0;if(!(b[e+1>>0]|0))sc=qlc(a,c,12,C)|0;else sc=tlc(a,c,12,C)|0;if(fUb(g,sc)|0)break a;else z=0;u=j;return z|0}case 10:{C=f[e+4>>2]|0;t=f[e+12>>2]|0;if(!(b[e+1>>0]|0))tc=ulc(a,c,10,C,t)|0;else tc=ylc(a,c,10,C,t)|0;t=g+40|0;C=f[t>>2]|0;f[t>>2]=C+-1;if((C|0)<=0){z=0;u=j;return z|0}if(!(Mi[f[(f[tc>>2]|0)+44>>2]&1023](tc,g)|0)){z=0;u=j;return z|0}C=f[t>>2]|0;if((C|0)<(f[g+44>>2]|0))f[t>>2]=C+1;if((f[g+20>>2]|0)==(c<<3|4|0))break a;else z=0;u=j;return z|0}case 11:{C=f[e+4>>2]|0;t=f[e+12>>2]|0;if(!(b[e+1>>0]|0))uc=ulc(a,c,11,C,t)|0;else uc=ylc(a,c,11,C,t)|0;t=f[g>>2]|0;if(t>>>0<(f[g+4>>2]|0)>>>0?(C=b[t>>0]|0,C<<24>>24>-1):0){f[g>>2]=t+1;vc=C&255}else{C=VRb(g)|0;if((C|0)>-1)vc=C;else{z=0;u=j;return z|0}}GRb(k,g,vc);if((f[k+4>>2]|0)>=0?Mi[f[(f[uc>>2]|0)+44>>2]&1023](uc,g)|0:0){if(LRb(g,f[k>>2]|0)|0)break a;else z=0;u=j;return z|0}z=0;u=j;return z|0}default:break a}while(0);while(0);z=1;u=j;return z|0}function Llc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=a+4|0;a=f[e>>2]|0;if(!a)return;else{g=e;h=a}a:while(1){a=h;while(1){if((f[a+16>>2]|0)>=(b|0))break;i=f[a+4>>2]|0;if(!i){j=g;break a}else a=i}h=f[a>>2]|0;if(!h){j=a;break}else g=a}if((j|0)==(e|0))return;else k=j;while(1){j=f[k+16>>2]|0;if((j|0)>=(c|0)){l=14;break}Mlc(k+24|0,j,d);j=f[k+4>>2]|0;if(!j){g=k+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(k|0))m=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;b=f[h>>2]|0}while((f[b>>2]|0)!=(g|0));m=b}}else{h=j;while(1){a=f[h>>2]|0;if(!a)break;else h=a}m=h}if((m|0)==(e|0)){l=14;break}else k=m}if((l|0)==14)return}function Mlc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;e=u;u=u+32|0;g=e;h=e+24|0;if(!(b[a+9>>0]|0)){i=b[a+10>>0]|0;if(i&1){u=e;return}do switch(b[a+8>>0]|0){case 5:{MTb(c,f[a>>2]|0,d);u=e;return}case 3:{j=a;NTb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 13:{OTb(c,f[a>>2]|0,d);u=e;return}case 4:{j=a;PTb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 17:{QTb(c,f[a>>2]|0,d);u=e;return}case 18:{j=a;RTb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 7:{STb(c,f[a>>2]|0,d);u=e;return}case 6:{j=a;TTb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 15:{UTb(c,f[a>>2]|0,d);u=e;return}case 16:{j=a;VTb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 2:{WTb(c,+n[a>>2],d);u=e;return}case 1:{XTb(c,+p[a>>3],d);u=e;return}case 8:{YTb(c,(b[a>>0]|0)!=0,d);u=e;return}case 9:{_Tb(c,f[a>>2]|0,d);u=e;return}case 12:{aUb(c,f[a>>2]|0,d);u=e;return}case 14:{ZTb(c,f[a>>2]|0,d);u=e;return}case 10:{cUb(c,f[a>>2]|0,d);u=e;return}case 11:{j=f[a>>2]|0;if(!(i&16)){dUb(c,j,d);u=e;return}else{Ti[f[(f[j>>2]|0)+60>>2]&511](j,c,d);u=e;return}break}default:{u=e;return}}while(0)}if(!(b[a+11>>0]|0))do switch(b[a+8>>0]|0){case 5:{i=f[a>>2]|0;if((f[i>>2]|0)>0){k=0;l=i}else{u=e;return}do{MTb(c,f[(f[l+8>>2]|0)+4+(k<<2)>>2]|0,d);k=k+1|0;l=f[a>>2]|0}while((k|0)<(f[l>>2]|0));u=e;return}case 3:{i=f[a>>2]|0;if((f[i>>2]|0)>0){m=0;o=i}else{u=e;return}do{i=(f[o+8>>2]|0)+8+(m<<3)|0;NTb(c,f[i>>2]|0,f[i+4>>2]|0,d);m=m+1|0;o=f[a>>2]|0}while((m|0)<(f[o>>2]|0));u=e;return}case 13:{i=f[a>>2]|0;if((f[i>>2]|0)>0){q=0;r=i}else{u=e;return}do{OTb(c,f[(f[r+8>>2]|0)+4+(q<<2)>>2]|0,d);q=q+1|0;r=f[a>>2]|0}while((q|0)<(f[r>>2]|0));u=e;return}case 4:{i=f[a>>2]|0;if((f[i>>2]|0)>0){s=0;t=i}else{u=e;return}do{i=(f[t+8>>2]|0)+8+(s<<3)|0;PTb(c,f[i>>2]|0,f[i+4>>2]|0,d);s=s+1|0;t=f[a>>2]|0}while((s|0)<(f[t>>2]|0));u=e;return}case 17:{i=f[a>>2]|0;if((f[i>>2]|0)>0){v=0;w=i}else{u=e;return}do{QTb(c,f[(f[w+8>>2]|0)+4+(v<<2)>>2]|0,d);v=v+1|0;w=f[a>>2]|0}while((v|0)<(f[w>>2]|0));u=e;return}case 18:{i=f[a>>2]|0;if((f[i>>2]|0)>0){x=0;y=i}else{u=e;return}do{i=(f[y+8>>2]|0)+8+(x<<3)|0;RTb(c,f[i>>2]|0,f[i+4>>2]|0,d);x=x+1|0;y=f[a>>2]|0}while((x|0)<(f[y>>2]|0));u=e;return}case 7:{i=f[a>>2]|0;if((f[i>>2]|0)>0){z=0;A=i}else{u=e;return}do{STb(c,f[(f[A+8>>2]|0)+4+(z<<2)>>2]|0,d);z=z+1|0;A=f[a>>2]|0}while((z|0)<(f[A>>2]|0));u=e;return}case 6:{i=f[a>>2]|0;if((f[i>>2]|0)>0){B=0;C=i}else{u=e;return}do{i=(f[C+8>>2]|0)+8+(B<<3)|0;TTb(c,f[i>>2]|0,f[i+4>>2]|0,d);B=B+1|0;C=f[a>>2]|0}while((B|0)<(f[C>>2]|0));u=e;return}case 15:{i=f[a>>2]|0;if((f[i>>2]|0)>0){D=0;E=i}else{u=e;return}do{UTb(c,f[(f[E+8>>2]|0)+4+(D<<2)>>2]|0,d);D=D+1|0;E=f[a>>2]|0}while((D|0)<(f[E>>2]|0));u=e;return}case 16:{i=f[a>>2]|0;if((f[i>>2]|0)>0){F=0;G=i}else{u=e;return}do{i=(f[G+8>>2]|0)+8+(F<<3)|0;VTb(c,f[i>>2]|0,f[i+4>>2]|0,d);F=F+1|0;G=f[a>>2]|0}while((F|0)<(f[G>>2]|0));u=e;return}case 2:{i=f[a>>2]|0;if((f[i>>2]|0)>0){H=0;I=i}else{u=e;return}do{WTb(c,+n[(f[I+8>>2]|0)+4+(H<<2)>>2],d);H=H+1|0;I=f[a>>2]|0}while((H|0)<(f[I>>2]|0));u=e;return}case 1:{i=f[a>>2]|0;if((f[i>>2]|0)>0){K=0;L=i}else{u=e;return}do{XTb(c,+p[(f[L+8>>2]|0)+8+(K<<3)>>3],d);K=K+1|0;L=f[a>>2]|0}while((K|0)<(f[L>>2]|0));u=e;return}case 8:{i=f[a>>2]|0;if((f[i>>2]|0)>0){M=0;N=i}else{u=e;return}do{YTb(c,(b[(f[N+8>>2]|0)+4+M>>0]|0)!=0,d);M=M+1|0;N=f[a>>2]|0}while((M|0)<(f[N>>2]|0));u=e;return}case 9:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){O=0;P=i}else{u=e;return}do{_Tb(c,f[(f[P+12>>2]|0)+4+(O<<2)>>2]|0,d);O=O+1|0;P=f[a>>2]|0}while((O|0)<(f[P+4>>2]|0));u=e;return}case 12:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){Q=0;R=i}else{u=e;return}do{aUb(c,f[(f[R+12>>2]|0)+4+(Q<<2)>>2]|0,d);Q=Q+1|0;R=f[a>>2]|0}while((Q|0)<(f[R+4>>2]|0));u=e;return}case 14:{i=f[a>>2]|0;if((f[i>>2]|0)>0){S=0;T=i}else{u=e;return}do{ZTb(c,f[(f[T+8>>2]|0)+4+(S<<2)>>2]|0,d);S=S+1|0;T=f[a>>2]|0}while((S|0)<(f[T>>2]|0));u=e;return}case 10:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){U=0;V=i}else{u=e;return}do{cUb(c,f[(f[V+12>>2]|0)+4+(U<<2)>>2]|0,d);U=U+1|0;V=f[a>>2]|0}while((U|0)<(f[V+4>>2]|0));u=e;return}case 11:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){W=0;X=i}else{u=e;return}do{dUb(c,f[(f[X+12>>2]|0)+4+(W<<2)>>2]|0,d);W=W+1|0;X=f[a>>2]|0}while((W|0)<(f[X+4>>2]|0));u=e;return}default:{u=e;return}}while(0);X=a+12|0;if(!(f[X>>2]|0)){u=e;return}W=c<<3|2;c=d+8|0;if((f[c>>2]|0)>4){V=d+4|0;U=f[V>>2]|0;if(W>>>0>127){T=W;S=U;while(1){b[S>>0]=T|128;R=T>>>7;Q=S+1|0;if(T>>>0>16383){T=R;S=Q}else{Y=Q;Z=R;break}}}else{Y=U;Z=W}b[Y>>0]=Z;Z=Y+1-U|0;f[V>>2]=(f[V>>2]|0)+Z;V=(f[c>>2]|0)-Z|0;f[c>>2]=V;_=V}else{bSb(d,W);_=f[c>>2]|0}W=f[X>>2]|0;if((_|0)>4){_=d+4|0;X=f[_>>2]|0;if(W>>>0>127){V=W;Z=X;while(1){b[Z>>0]=V|128;U=V>>>7;Y=Z+1|0;if(V>>>0>16383){V=U;Z=Y}else{$=Y;aa=U;break}}}else{$=X;aa=W}b[$>>0]=aa;aa=$+1-X|0;f[_>>2]=(f[_>>2]|0)+aa;f[c>>2]=(f[c>>2]|0)-aa}else bSb(d,W);do switch(b[a+8>>0]|0){case 5:{W=f[a>>2]|0;if((f[W>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;X=W;do{W=f[(f[X+8>>2]|0)+4+(_<<2)>>2]|0;$=((W|0)<0)<<31>>31;if((f[c>>2]|0)>9){Z=f[aa>>2]|0;V=W&255;if(W>>>0>127){U=Z;Y=V;S=W;T=$;while(1){b[U>>0]=Y|-128;R=S;S=aJc(S|0,T|0,7)|0;Q=U+1|0;P=S&255;if(!(T>>>0>0|(T|0)==0&R>>>0>16383)){ba=Q;ca=P;break}else{U=Q;Y=P;T=J}}}else{ba=Z;ca=V}b[ba>>0]=ca;T=ba+1-Z|0;f[aa>>2]=(f[aa>>2]|0)+T;f[c>>2]=(f[c>>2]|0)-T}else cSb(d,W,$);_=_+1|0;X=f[a>>2]|0}while((_|0)<(f[X>>2]|0));u=e;return}case 3:{X=f[a>>2]|0;if((f[X>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;T=X;do{X=(f[T+8>>2]|0)+8+(aa<<3)|0;Y=f[X>>2]|0;U=f[X+4>>2]|0;if((f[c>>2]|0)>9){X=f[_>>2]|0;S=Y&255;if(U>>>0>0|(U|0)==0&Y>>>0>127){P=X;Q=S;R=Y;O=U;while(1){b[P>>0]=Q|-128;N=R;R=aJc(R|0,O|0,7)|0;M=P+1|0;L=R&255;if(!(O>>>0>0|(O|0)==0&N>>>0>16383)){da=M;ea=L;break}else{P=M;Q=L;O=J}}}else{da=X;ea=S}b[da>>0]=ea;O=da+1-X|0;f[_>>2]=(f[_>>2]|0)+O;f[c>>2]=(f[c>>2]|0)-O}else cSb(d,Y,U);aa=aa+1|0;T=f[a>>2]|0}while((aa|0)<(f[T>>2]|0));u=e;return}case 13:{T=f[a>>2]|0;if((f[T>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;O=T;do{T=f[(f[O+8>>2]|0)+4+(_<<2)>>2]|0;if((f[c>>2]|0)>4){Q=f[aa>>2]|0;if(T>>>0>127){P=T;R=Q;while(1){b[R>>0]=P|128;$=P>>>7;W=R+1|0;if(P>>>0>16383){P=$;R=W}else{fa=W;ga=$;break}}}else{fa=Q;ga=T}b[fa>>0]=ga;R=fa+1-Q|0;f[aa>>2]=(f[aa>>2]|0)+R;f[c>>2]=(f[c>>2]|0)-R}else bSb(d,T);_=_+1|0;O=f[a>>2]|0}while((_|0)<(f[O>>2]|0));u=e;return}case 4:{O=f[a>>2]|0;if((f[O>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;R=O;do{O=(f[R+8>>2]|0)+8+(aa<<3)|0;P=f[O>>2]|0;U=f[O+4>>2]|0;if((f[c>>2]|0)>9){O=f[_>>2]|0;Y=P&255;if(U>>>0>0|(U|0)==0&P>>>0>127){X=O;S=Y;$=P;W=U;while(1){b[X>>0]=S|-128;Z=$;$=aJc($|0,W|0,7)|0;V=X+1|0;L=$&255;if(!(W>>>0>0|(W|0)==0&Z>>>0>16383)){ha=V;ia=L;break}else{X=V;S=L;W=J}}}else{ha=O;ia=Y}b[ha>>0]=ia;W=ha+1-O|0;f[_>>2]=(f[_>>2]|0)+W;f[c>>2]=(f[c>>2]|0)-W}else cSb(d,P,U);aa=aa+1|0;R=f[a>>2]|0}while((aa|0)<(f[R>>2]|0));u=e;return}case 17:{R=f[a>>2]|0;if((f[R>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;W=R;do{R=f[(f[W+8>>2]|0)+4+(_<<2)>>2]|0;S=R<<1^R>>31;if((f[c>>2]|0)>4){R=f[aa>>2]|0;if(S>>>0>127){X=S;$=R;while(1){b[$>>0]=X|128;T=X>>>7;Q=$+1|0;if(X>>>0>16383){X=T;$=Q}else{ja=Q;ka=T;break}}}else{ja=R;ka=S}b[ja>>0]=ka;$=ja+1-R|0;f[aa>>2]=(f[aa>>2]|0)+$;f[c>>2]=(f[c>>2]|0)-$}else bSb(d,S);_=_+1|0;W=f[a>>2]|0}while((_|0)<(f[W>>2]|0));u=e;return}case 18:{W=f[a>>2]|0;if((f[W>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;$=W;do{W=(f[$+8>>2]|0)+8+(aa<<3)|0;X=f[W>>2]|0;U=f[W+4>>2]|0;W=jJc(X|0,U|0,1)|0;P=J;O=$Ic(X|0,U|0,63)|0;U=W^O;O=P^J;if((f[c>>2]|0)>9){P=f[_>>2]|0;W=U&255;if(O>>>0>0|(O|0)==0&U>>>0>127){X=P;Y=W;T=U;Q=O;while(1){b[X>>0]=Y|-128;L=T;T=aJc(T|0,Q|0,7)|0;V=X+1|0;Z=T&255;if(!(Q>>>0>0|(Q|0)==0&L>>>0>16383)){la=V;ma=Z;break}else{X=V;Y=Z;Q=J}}}else{la=P;ma=W}b[la>>0]=ma;Q=la+1-P|0;f[_>>2]=(f[_>>2]|0)+Q;f[c>>2]=(f[c>>2]|0)-Q}else cSb(d,U,O);aa=aa+1|0;$=f[a>>2]|0}while((aa|0)<(f[$>>2]|0));u=e;return}case 7:{$=f[a>>2]|0;if((f[$>>2]|0)>0){na=0;oa=$}else{u=e;return}do{$Rb(d,f[(f[oa+8>>2]|0)+4+(na<<2)>>2]|0);na=na+1|0;oa=f[a>>2]|0}while((na|0)<(f[oa>>2]|0));u=e;return}case 6:{$=f[a>>2]|0;if((f[$>>2]|0)>0){pa=0;qa=$}else{u=e;return}do{$=(f[qa+8>>2]|0)+8+(pa<<3)|0;aSb(d,f[$>>2]|0,f[$+4>>2]|0);pa=pa+1|0;qa=f[a>>2]|0}while((pa|0)<(f[qa>>2]|0));u=e;return}case 15:{$=f[a>>2]|0;if((f[$>>2]|0)>0){ra=0;sa=$}else{u=e;return}do{$Rb(d,f[(f[sa+8>>2]|0)+4+(ra<<2)>>2]|0);ra=ra+1|0;sa=f[a>>2]|0}while((ra|0)<(f[sa>>2]|0));u=e;return}case 16:{$=f[a>>2]|0;if((f[$>>2]|0)>0){ta=0;ua=$}else{u=e;return}do{$=(f[ua+8>>2]|0)+8+(ta<<3)|0;aSb(d,f[$>>2]|0,f[$+4>>2]|0);ta=ta+1|0;ua=f[a>>2]|0}while((ta|0)<(f[ua>>2]|0));u=e;return}case 2:{$=f[a>>2]|0;if((f[$>>2]|0)>0){va=0;wa=$}else{u=e;return}do{$Rb(d,f[(f[wa+8>>2]|0)+4+(va<<2)>>2]|0);va=va+1|0;wa=f[a>>2]|0}while((va|0)<(f[wa>>2]|0));u=e;return}case 1:{$=f[a>>2]|0;if((f[$>>2]|0)>0){xa=0;ya=$}else{u=e;return}do{$=(f[ya+8>>2]|0)+8+(xa<<3)|0;aSb(d,f[$>>2]|0,f[$+4>>2]|0);xa=xa+1|0;ya=f[a>>2]|0}while((xa|0)<(f[ya>>2]|0));u=e;return}case 8:{$=f[a>>2]|0;if((f[$>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;Q=$;do{$=b[(f[Q+8>>2]|0)+4+_>>0]|0;if((f[c>>2]|0)>4){b[f[aa>>2]>>0]=$;f[aa>>2]=(f[aa>>2]|0)+1;f[c>>2]=(f[c>>2]|0)+-1}else bSb(d,$&255);_=_+1|0;Q=f[a>>2]|0}while((_|0)<(f[Q>>2]|0));u=e;return}case 14:{Q=f[a>>2]|0;if((f[Q>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;$=Q;do{Q=f[(f[$+8>>2]|0)+4+(aa<<2)>>2]|0;Y=((Q|0)<0)<<31>>31;if((f[c>>2]|0)>9){X=f[_>>2]|0;T=Q&255;if(Q>>>0>127){S=X;R=T;Z=Q;V=Y;while(1){b[S>>0]=R|-128;L=Z;Z=aJc(Z|0,V|0,7)|0;M=S+1|0;N=Z&255;if(!(V>>>0>0|(V|0)==0&L>>>0>16383)){za=M;Aa=N;break}else{S=M;R=N;V=J}}}else{za=X;Aa=T}b[za>>0]=Aa;V=za+1-X|0;f[_>>2]=(f[_>>2]|0)+V;f[c>>2]=(f[c>>2]|0)-V}else cSb(d,Q,Y);aa=aa+1|0;$=f[a>>2]|0}while((aa|0)<(f[$>>2]|0));u=e;return}case 11:case 10:case 12:case 9:{rTb(g,3,504144,1469);oTb(h,mTb(g,504712)|0);sTb(g);u=e;return}default:{u=e;return}}while(0)}function Nlc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0)){d=0;return d|0}else{e=0;g=b}while(1){b=(Olc(g+24|0,f[g+16>>2]|0)|0)+e|0;a=f[g+4>>2]|0;if(!a){h=g+8|0;i=f[h>>2]|0;if((f[i>>2]|0)==(g|0))j=i;else{i=h;do{h=f[i>>2]|0;i=h+8|0;k=f[i>>2]|0}while((f[k>>2]|0)!=(h|0));j=k}}else{i=a;while(1){k=f[i>>2]|0;if(!k)break;else i=k}j=i}if((j|0)==(c|0)){d=b;break}else{e=b;g=j}}return d|0}function Olc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+32|0;e=d;g=d+24|0;if(!(b[a+9>>0]|0)){h=b[a+10>>0]|0;if(h&1){i=0;u=d;return i|0}j=b[a+8>>0]|0;k=(((($(c<<3|1|0)|0)^31)*9|0)+73|0)>>>6<<(j<<24>>24==10&1);do switch(j<<24>>24){case 5:{l=f[a>>2]|0;if((l|0)<0)m=10;else m=(((($(l|1|0)|0)^31)*9|0)+73|0)>>>6;i=m+k|0;u=d;return i|0}case 3:{l=a;i=(((((iJc(f[l>>2]|1|0,f[l+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 13:{i=((((($(f[a>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 4:{l=a;i=(((((iJc(f[l>>2]|1|0,f[l+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 17:{l=f[a>>2]|0;i=((((($(l<<1^l>>31|1|0)|0)^31)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 18:{l=a;n=f[l>>2]|0;o=f[l+4>>2]|0;l=jJc(n|0,o|0,1)|0;p=J;i=(((((iJc(l^($Ic(n|0,o|0,63)|0)|1|0,p^J|0,1)|0)^63)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 9:{p=f[a>>2]|0;o=b[p+11>>0]|0;n=o<<24>>24<0?f[p+4>>2]|0:o&255;i=n+k+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}case 12:{n=f[a>>2]|0;o=b[n+11>>0]|0;p=o<<24>>24<0?f[n+4>>2]|0:o&255;i=p+k+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}case 14:{p=f[a>>2]|0;if((p|0)<0)q=10;else q=(((($(p|1|0)|0)^31)*9|0)+73|0)>>>6;i=q+k|0;u=d;return i|0}case 10:{p=f[a>>2]|0;i=(_i[f[(f[p>>2]|0)+48>>2]&1023](p)|0)+k|0;u=d;return i|0}case 11:{p=f[a>>2]|0;o=f[p>>2]|0;if(!(h&16)){n=_i[f[o+48>>2]&1023](p)|0;i=n+k+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}else{n=_i[f[o+40>>2]&1023](p)|0;i=n+k+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}break}case 7:{i=k+4|0;u=d;return i|0}case 6:{i=k+8|0;u=d;return i|0}case 15:{i=k+4|0;u=d;return i|0}case 16:{i=k+8|0;u=d;return i|0}case 2:{i=k+4|0;u=d;return i|0}case 1:{i=k+8|0;u=d;return i|0}case 8:{i=k+1|0;u=d;return i|0}default:{i=k;u=d;return i|0}}while(0)}k=b[a+8>>0]|0;if(b[a+11>>0]|0){do switch(k<<24>>24){case 5:{h=f[a>>2]|0;q=f[h>>2]|0;if((q|0)>0){m=f[h+8>>2]|0;h=0;j=0;while(1){n=f[m+4+(h<<2)>>2]|0;if((n|0)<0)r=10;else r=(((($(n|1|0)|0)^31)*9|0)+73|0)>>>6;n=r+j|0;h=h+1|0;if((h|0)>=(q|0)){s=n;t=39;break}else j=n}}else t=38;break}case 3:{j=f[a>>2]|0;q=f[j>>2]|0;if((q|0)>0){h=f[j+8>>2]|0;j=0;m=0;while(1){n=h+8+(j<<3)|0;p=iJc(f[n>>2]|1|0,f[n+4>>2]|0,1)|0;n=((((p^63)*9|0)+73|0)>>>6)+m|0;j=j+1|0;if((j|0)>=(q|0)){s=n;t=39;break}else m=n}}else t=38;break}case 13:{m=f[a>>2]|0;q=f[m>>2]|0;if((q|0)>0){j=f[m+8>>2]|0;m=0;h=0;while(1){n=((((($(f[j+4+(m<<2)>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+h|0;m=m+1|0;if((m|0)>=(q|0)){s=n;t=39;break}else h=n}}else t=38;break}case 4:{h=f[a>>2]|0;q=f[h>>2]|0;if((q|0)>0){m=f[h+8>>2]|0;h=0;j=0;while(1){n=m+8+(h<<3)|0;p=iJc(f[n>>2]|1|0,f[n+4>>2]|0,1)|0;n=((((p^63)*9|0)+73|0)>>>6)+j|0;h=h+1|0;if((h|0)>=(q|0)){s=n;t=39;break}else j=n}}else t=38;break}case 17:{j=f[a>>2]|0;q=f[j>>2]|0;if((q|0)>0){h=f[j+8>>2]|0;j=0;m=0;while(1){n=f[h+4+(j<<2)>>2]|0;p=((((($(n<<1^n>>31|1|0)|0)^31)*9|0)+73|0)>>>6)+m|0;j=j+1|0;if((j|0)>=(q|0)){s=p;t=39;break}else m=p}}else t=38;break}case 18:{m=f[a>>2]|0;q=f[m>>2]|0;if((q|0)>0){j=f[m+8>>2]|0;m=0;h=0;while(1){p=j+8+(m<<3)|0;n=f[p>>2]|0;o=f[p+4>>2]|0;p=jJc(n|0,o|0,1)|0;l=J;v=$Ic(n|0,o|0,63)|0;o=iJc(p^v|1|0,l^J|0,1)|0;l=((((o^63)*9|0)+73|0)>>>6)+h|0;m=m+1|0;if((m|0)>=(q|0)){s=l;t=39;break}else h=l}}else t=38;break}case 14:{h=f[a>>2]|0;q=f[h>>2]|0;if((q|0)>0){m=f[h+8>>2]|0;h=0;j=0;while(1){l=f[m+4+(h<<2)>>2]|0;if((l|0)<0)w=10;else w=(((($(l|1|0)|0)^31)*9|0)+73|0)>>>6;l=w+j|0;h=h+1|0;if((h|0)>=(q|0)){s=l;t=39;break}else j=l}}else t=38;break}case 7:{s=f[f[a>>2]>>2]<<2;t=39;break}case 6:{s=f[f[a>>2]>>2]<<3;t=39;break}case 15:{s=f[f[a>>2]>>2]<<2;t=39;break}case 16:{s=f[f[a>>2]>>2]<<3;t=39;break}case 2:{s=f[f[a>>2]>>2]<<2;t=39;break}case 1:{s=f[f[a>>2]>>2]<<3;t=39;break}case 8:{s=f[f[a>>2]>>2]|0;t=39;break}case 11:case 10:case 12:case 9:{rTb(e,3,504144,1581);oTb(g,mTb(e,504712)|0);sTb(e);t=37;break}default:t=37}while(0);if((t|0)==37){f[a+12>>2]=0;i=0;u=d;return i|0}else if((t|0)==38){f[a+12>>2]=0;i=0;u=d;return i|0}else if((t|0)==39){f[a+12>>2]=s;if(!s){i=0;u=d;return i|0}i=s+((((($(c<<3|3|0)|0)^31)*9|0)+73|0)>>>6)+((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}}s=(((($(c<<3|1|0)|0)^31)*9|0)+73|0)>>>6<<(k<<24>>24==10&1);do switch(k<<24>>24){case 5:{c=f[a>>2]|0;t=f[c>>2]|0;e=Y(t,s)|0;if((t|0)<=0){i=e;u=d;return i|0}g=f[c+8>>2]|0;c=0;w=e;while(1){e=f[g+4+(c<<2)>>2]|0;if((e|0)<0)x=10;else x=(((($(e|1|0)|0)^31)*9|0)+73|0)>>>6;e=x+w|0;c=c+1|0;if((c|0)>=(t|0)){i=e;break}else w=e}u=d;return i|0}case 3:{w=f[a>>2]|0;t=f[w>>2]|0;c=Y(t,s)|0;if((t|0)<=0){i=c;u=d;return i|0}g=f[w+8>>2]|0;w=0;e=c;while(1){c=g+8+(w<<3)|0;r=iJc(f[c>>2]|1|0,f[c+4>>2]|0,1)|0;c=((((r^63)*9|0)+73|0)>>>6)+e|0;w=w+1|0;if((w|0)>=(t|0)){i=c;break}else e=c}u=d;return i|0}case 13:{e=f[a>>2]|0;t=f[e>>2]|0;w=Y(t,s)|0;if((t|0)<=0){i=w;u=d;return i|0}g=f[e+8>>2]|0;e=0;c=w;while(1){w=((((($(f[g+4+(e<<2)>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+c|0;e=e+1|0;if((e|0)>=(t|0)){i=w;break}else c=w}u=d;return i|0}case 4:{c=f[a>>2]|0;t=f[c>>2]|0;e=Y(t,s)|0;if((t|0)<=0){i=e;u=d;return i|0}g=f[c+8>>2]|0;c=0;w=e;while(1){e=g+8+(c<<3)|0;r=iJc(f[e>>2]|1|0,f[e+4>>2]|0,1)|0;e=((((r^63)*9|0)+73|0)>>>6)+w|0;c=c+1|0;if((c|0)>=(t|0)){i=e;break}else w=e}u=d;return i|0}case 17:{w=f[a>>2]|0;t=f[w>>2]|0;c=Y(t,s)|0;if((t|0)<=0){i=c;u=d;return i|0}g=f[w+8>>2]|0;w=0;e=c;while(1){c=f[g+4+(w<<2)>>2]|0;r=((((($(c<<1^c>>31|1|0)|0)^31)*9|0)+73|0)>>>6)+e|0;w=w+1|0;if((w|0)>=(t|0)){i=r;break}else e=r}u=d;return i|0}case 18:{e=f[a>>2]|0;t=f[e>>2]|0;w=Y(t,s)|0;if((t|0)<=0){i=w;u=d;return i|0}g=f[e+8>>2]|0;e=0;r=w;while(1){w=g+8+(e<<3)|0;c=f[w>>2]|0;j=f[w+4>>2]|0;w=jJc(c|0,j|0,1)|0;q=J;h=$Ic(c|0,j|0,63)|0;j=iJc(w^h|1|0,q^J|0,1)|0;q=((((j^63)*9|0)+73|0)>>>6)+r|0;e=e+1|0;if((e|0)>=(t|0)){i=q;break}else r=q}u=d;return i|0}case 9:{r=f[a>>2]|0;t=f[r+4>>2]|0;e=Y(t,s)|0;if((t|0)<=0){i=e;u=d;return i|0}g=f[r+12>>2]|0;r=0;q=e;while(1){e=f[g+4+(r<<2)>>2]|0;j=b[e+11>>0]|0;h=j<<24>>24<0?f[e+4>>2]|0:j&255;j=h+q+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=r+1|0;if((r|0)>=(t|0)){i=j;break}else q=j}u=d;return i|0}case 12:{q=f[a>>2]|0;t=f[q+4>>2]|0;r=Y(t,s)|0;if((t|0)<=0){i=r;u=d;return i|0}g=f[q+12>>2]|0;q=0;j=r;while(1){r=f[g+4+(q<<2)>>2]|0;h=b[r+11>>0]|0;e=h<<24>>24<0?f[r+4>>2]|0:h&255;h=e+j+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;q=q+1|0;if((q|0)>=(t|0)){i=h;break}else j=h}u=d;return i|0}case 14:{j=f[a>>2]|0;t=f[j>>2]|0;q=Y(t,s)|0;if((t|0)<=0){i=q;u=d;return i|0}g=f[j+8>>2]|0;j=0;h=q;while(1){q=f[g+4+(j<<2)>>2]|0;if((q|0)<0)y=10;else y=(((($(q|1|0)|0)^31)*9|0)+73|0)>>>6;q=y+h|0;j=j+1|0;if((j|0)>=(t|0)){i=q;break}else h=q}u=d;return i|0}case 10:{h=f[a>>2]|0;t=f[h+4>>2]|0;j=Y(t,s)|0;if((t|0)>0){z=0;A=j;B=h}else{i=j;u=d;return i|0}while(1){j=f[(f[B+12>>2]|0)+4+(z<<2)>>2]|0;h=(_i[f[(f[j>>2]|0)+48>>2]&1023](j)|0)+A|0;z=z+1|0;B=f[a>>2]|0;if((z|0)>=(f[B+4>>2]|0)){i=h;break}else A=h}u=d;return i|0}case 11:{h=f[a>>2]|0;j=f[h+4>>2]|0;t=Y(j,s)|0;if((j|0)>0){C=0;D=t;E=h}else{i=t;u=d;return i|0}while(1){t=f[(f[E+12>>2]|0)+4+(C<<2)>>2]|0;h=_i[f[(f[t>>2]|0)+48>>2]&1023](t)|0;t=h+D+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;C=C+1|0;E=f[a>>2]|0;if((C|0)>=(f[E+4>>2]|0)){i=t;break}else D=t}u=d;return i|0}case 7:{i=Y(f[f[a>>2]>>2]|0,s+4|0)|0;u=d;return i|0}case 6:{i=Y(f[f[a>>2]>>2]|0,s+8|0)|0;u=d;return i|0}case 15:{i=Y(f[f[a>>2]>>2]|0,s+4|0)|0;u=d;return i|0}case 16:{i=Y(f[f[a>>2]>>2]|0,s+8|0)|0;u=d;return i|0}case 2:{i=Y(f[f[a>>2]>>2]|0,s+4|0)|0;u=d;return i|0}case 1:{i=Y(f[f[a>>2]>>2]|0,s+8|0)|0;u=d;return i|0}case 8:{i=Y(f[f[a>>2]>>2]|0,s+1|0)|0;u=d;return i|0}default:{i=0;u=d;return i|0}}while(0);return 0}function Plc(a,b,c){a=a|0;b=b|0;c=c|0;c=u;u=u+32|0;b=c;rTb(b,3,504749,47);oTb(c+24|0,mTb(b,504847)|0);sTb(b);u=c;return 0}function Qlc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+1040|0;e=d+16|0;g=d;f[g>>2]=f[c>>2];h=Opc(e,1024,b,g)|0;if((h|0)<1024){if((h|0)<=-1){u=d;return}tEc(a,e,h)|0;u=d;return}else{e=h+1|0;i=XDc(e)|0;f[g>>2]=f[c>>2];c=Opc(i,e,b,g)|0;if(!((c|0)<0|(c|0)>(h|0)))tEc(a,i,c)|0;ZDc(i);u=d;return}}function Rlc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;Qlc(a,b,e);u=d;return}function Slc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;Qlc(a,b,e);u=d;return}function Tlc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f[e>>2]=0;if(!d){g=241;return g|0}i=f[a+16>>2]|0;j=c+d|0;d=j+-7|0;k=(f[a+32>>2]|0)+(f[a>>2]|0)|0;l=f[a+44>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=a+4|0;a=k;p=c;while(1){q=p&7;a:do if(p>>>0<j>>>0&(q|0)!=0){r=p;while(1){if(b[l+(h[r>>0]|0)>>0]|0){s=r;break a}t=r+1|0;u=t&7;if(t>>>0<j>>>0&(u|0)!=0)r=t;else{v=t;w=u;x=6;break}}}else{v=p;w=q;x=6}while(0);b:do if((x|0)==6){x=0;if((w|0)==0&v>>>0<d>>>0){q=v;while(1){r=f[q>>2]|0;u=q+4|0;t=f[u>>2]|0;y=q+8|0;if((r-m|r+n|t-m|t+n)&-2139062144|0){if((b[l+(h[q+1>>0]|0)>>0]|b[l+(r&255)>>0]|b[l+(h[q+2>>0]|0)>>0]|b[l+(h[q+3>>0]|0)>>0])<<24>>24){s=q;break b}if((b[l+(h[q+5>>0]|0)>>0]|b[l+(t&255)>>0]|b[l+(h[q+6>>0]|0)>>0]|b[l+(h[q+7>>0]|0)>>0])<<24>>24){s=u;break b}}if(y>>>0<d>>>0)q=y;else{s=y;break}}}else s=v}while(0);if(s>>>0<j>>>0){z=k;A=s}else{B=k;C=s;x=18;break}while(1){D=b[z+(h[A>>0]|0)>>0]|0;E=D&255;F=A+1|0;if((D&255)>239){G=z;break}q=k+(E<<i)|0;if(F>>>0<j>>>0){z=q;A=F}else{G=q;break}}if((D&255)<=239){B=G;C=F;x=18;break}c:do if((G-a|0)>>>0<(f[o>>2]|0)>>>0)H=A;else{q=A;while(1){y=q+-1|0;if(y>>>0<=c>>>0){H=y;break c}if((b[y>>0]&-64)<<24>>24==-128)q=y;else{H=y;break}}}while(0);if(D<<24>>24==-3)p=H;else{I=H;J=E;break}}d:do if((x|0)==18)if((B-k|0)>>>0<(f[o>>2]|0)>>>0){I=C;J=241}else{E=C;while(1){H=E+-1|0;if(H>>>0<=c>>>0){I=H;J=240;break d}if((b[H>>0]&-64)<<24>>24==-128)E=H;else{I=H;J=240;break}}}while(0);f[e>>2]=I-c;g=J;return g|0}function Ulc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!c){g=0;h=(g|0)==(c|0);u=d;return h|0}i=a+c|0;j=i+-7|0;k=a;l=k+c|0;m=a;do{a=m&7;a:do if(m>>>0<i>>>0&(a|0)!=0){n=m;while(1){if((b[n>>0]|0)<=-1){o=n;break a}p=n+1|0;q=p&7;if(p>>>0<i>>>0&(q|0)!=0)n=p;else{r=p;s=q;t=7;break}}}else{r=m;s=a;t=7}while(0);b:do if((t|0)==7){t=0;if(r>>>0<j>>>0&(s|0)==0){a=r;while(1){if((f[a+4>>2]|f[a>>2])&-2139062144|0){o=a;break b}n=a+8|0;if(n>>>0<j>>>0)a=n;else{o=n;break}}}else o=r}while(0);c:do if(o>>>0<i>>>0){a=o;while(1){if((b[a>>0]|0)<=-1){v=a;break c}n=a+1|0;if(n>>>0<i>>>0)a=n;else{v=n;break}}}else v=o;while(0);a=Tlc(168372,v,l-v|0,e)|0;m=v+(f[e>>2]|0)|0}while((a|0)==253);g=m-k|0;h=(g|0)==(c|0);u=d;return h|0}function Vlc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+11|0;d=b[c>>0]|0;if(d<<24>>24<0)e=f[a+4>>2]|0;else e=d&255;a:do if((e|0)>0){d=0;while(1){g=sEc(a,d)|0;h=(b[g>>0]|0)+-9<<24>>24;if((h&255)>23|(8388639>>>(h&255)&1|0)==0){i=d;break a}h=d+1|0;if((e|0)>(h|0))d=h;else{i=h;break}}}else i=0;while(0);if((e|0)==(i|0))if((b[c>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0;return}else{b[a>>0]=0;b[c>>0]=0;return}if((i|0)>0){yEc(a,0,i)|0;j=e-i|0}else j=e;e=j+-1|0;if((j|0)>0)k=e;else return;while(1){j=sEc(a,k)|0;i=(b[j>>0]|0)+-9<<24>>24;if((i&255)>23|(8388639>>>(i&255)&1|0)==0)break;if((k|0)>0)k=k+-1|0;else{l=18;break}}if((l|0)==18)return;if((k|0)==(e|0))return;yEc(a,k+1|0,-1)|0;return}function Wlc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+16|0;g=e;i=b[c>>0]|0;if(i<<24>>24?(b[c+1>>0]|0)==0:0){j=b[a+11>>0]|0;k=j<<24>>24<0;l=k?f[a>>2]|0:a;m=k?f[a+4>>2]|0:j&255;j=l+m|0;if(!m){u=e;return}m=g+11|0;k=g+8|0;n=g+4|0;o=d+4|0;p=d+8|0;q=l;while(1){if((b[q>>0]|0)==i<<24>>24)r=q+1|0;else{l=q;while(1){s=l+1|0;if((s|0)==(j|0)){t=j;break}if((b[s>>0]|0)==i<<24>>24){t=s;break}else l=s}l=t-q|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(l>>>0>4294967279){v=12;break}if(l>>>0<11){b[m>>0]=l;if(!l)w=g;else{x=g;v=16}}else{s=l+16&-16;y=VDc(s)|0;f[g>>2]=y;f[k>>2]=s|-2147483648;f[n>>2]=l;x=y;v=16}if((v|0)==16){v=0;dJc(x|0,q|0,l|0)|0;w=x}b[w+l>>0]=0;l=f[o>>2]|0;if((l|0)==(f[p>>2]|0))e1(d,g);else{fEc(l,g);f[o>>2]=(f[o>>2]|0)+12}if((b[m>>0]|0)<0)YDc(f[g>>2]|0);r=t}if((r|0)==(j|0)){v=47;break}else q=r}if((v|0)==12)dEc(g);else if((v|0)==47){u=e;return}}r=a+11|0;q=b[r>>0]|0;j=q<<24>>24<0;t=a+4|0;m=f[t>>2]|0;o=j?m:q&255;if(!o){u=e;return}p=Mpc(c)|0;w=f[a>>2]|0;x=g+11|0;n=d+4|0;k=d+8|0;i=0;l=j?w:a;j=o;o=p;p=q;q=w;w=m;a:while(1){m=l+j|0;y=l+i|0;b:do if(!o)z=y;else{s=y;while(1){if(!(Zoc(c,h[s>>0]|0,o)|0)){z=s;break b}s=s+1|0;if((s|0)==(m|0)){v=47;break a}}}while(0);A=z-l|0;if((A|0)==-1){v=47;break}m=p<<24>>24<0;y=m?q:a;s=m?w:p&255;m=Mpc(c)|0;if(s>>>0<=A>>>0|(m|0)==0){v=35;break}B=y+A|0;C=y+s|0;D=c+m|0;c:do if((s|0)==(A|0))E=B;else{m=B;while(1){F=b[m>>0]|0;G=c;do{if(F<<24>>24==(b[G>>0]|0)){E=m;break c}G=G+1|0}while((G|0)!=(D|0));m=m+1|0;if((m|0)==(C|0)){v=35;break a}}}while(0);i=E-y|0;if((E|0)==(C|0)|(i|0)==-1){v=35;break}gEc(g,a,A,i-A|0,a);D=f[n>>2]|0;if((D|0)==(f[k>>2]|0))e1(d,g);else{fEc(D,g);f[n>>2]=(f[n>>2]|0)+12}if((b[x>>0]|0)<0)YDc(f[g>>2]|0);p=b[r>>0]|0;D=p<<24>>24<0;B=f[a>>2]|0;w=f[t>>2]|0;j=D?w:p&255;o=Mpc(c)|0;if(j>>>0<=i>>>0){v=47;break}else{l=D?B:a;q=B}}if((v|0)==35){gEc(g,a,A,-1,a);a=f[n>>2]|0;if((a|0)==(f[k>>2]|0))e1(d,g);else{fEc(a,g);f[n>>2]=(f[n>>2]|0)+12}if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);u=e;return}else if((v|0)==47){u=e;return}}function Xlc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;a:do if((a|0)==(c|0)){d=a;e=a;while(1){switch(b[d>>0]|0){case 92:case 0:{f=d;g=e;break a;break}default:{}}h=d+1|0;i=e+1|0;if((d|0)==(e|0)){d=h;e=i}else{f=h;g=i;break a}}}else{f=a;g=c}while(0);a=b[f>>0]|0;if(!(a<<24>>24)){j=g;b[j>>0]=0;k=j;l=c;m=k-l|0;return m|0}else{n=f;o=g;p=a}b:while(1){a=n+1|0;if(p<<24>>24==92){g=b[a>>0]|0;c:do switch(g|0){case 0:{j=o;q=28;break b;break}case 97:{b[o>>0]=7;r=o+1|0;s=a;break}case 98:{b[o>>0]=8;r=o+1|0;s=a;break}case 102:{b[o>>0]=12;r=o+1|0;s=a;break}case 110:{b[o>>0]=10;r=o+1|0;s=a;break}case 114:{b[o>>0]=13;r=o+1|0;s=a;break}case 116:{b[o>>0]=9;r=o+1|0;s=a;break}case 118:{b[o>>0]=11;r=o+1|0;s=a;break}case 92:{b[o>>0]=92;r=o+1|0;s=a;break}case 63:{b[o>>0]=63;r=o+1|0;s=a;break}case 39:{b[o>>0]=39;r=o+1|0;s=a;break}case 34:{b[o>>0]=34;r=o+1|0;s=a;break}case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{f=g+208|0;e=n+2|0;d=b[e>>0]|0;i=(d&-8)<<24>>24==48;h=i?e:a;e=i?(f<<3)+208+(d&255)|0:f;f=h+1|0;d=b[f>>0]|0;i=(d&-8)<<24>>24==48;b[o>>0]=i?(d&255)+208+(e<<3)|0:e;r=o+1|0;s=i?f:h;break}case 88:case 120:{h=b[n+2>>0]|0;if((h+-48&255)<10){t=0;u=a}else switch(h<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{t=0;u=a;break}default:{r=o;s=a;break c}}d:while(1){h=u+1|0;f=b[h>>0]|0;if((f+-48&255)>=10)switch(f<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}i=f&255;t=((f&255)>57?i+9|0:i)&15|t<<4;u=h}b[o>>0]=t;r=o+1|0;s=u;break}default:{r=o;s=a}}while(0);v=s+1|0;w=r}else{b[o>>0]=p;v=a;w=o+1|0}p=b[v>>0]|0;if(!(p<<24>>24)){j=w;q=28;break}else{n=v;o=w}}if((q|0)==28){b[j>>0]=0;k=j;l=c;m=k-l|0;return m|0}return 0}function Ylc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=XDc((e?f[c+4>>2]|0:d&255)+1|0)|0;d=Xlc(e?f[c>>2]|0:c,g,0)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(d>>>0>4294967279)dEc(a);if(d>>>0<11){b[a+11>>0]=d;if(!d){h=a;i=h+d|0;b[i>>0]=0;ZDc(g);return}else j=a}else{c=d+16&-16;e=VDc(c)|0;f[a>>2]=e;f[a+8>>2]=c|-2147483648;f[a+4>>2]=d;j=e}dJc(j|0,g|0,d|0)|0;h=j;i=h+d|0;b[i>>0]=0;ZDc(g);return}function Zlc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;g=f[e>>2]|0;i=(g|0)>0;if(i){j=0;k=0;while(1){l=(b[507574+(h[d+k>>0]|0)>>0]|0)+j|0;k=k+1|0;if((k|0)==(g|0)){m=l;break}else j=l}}else m=0;if((m|0)==(g|0)){tEc(c,d,g)|0;return}g=c+11|0;j=b[g>>0]|0;if(j<<24>>24<0)n=f[c+4>>2]|0;else n=j&255;oEc(c,n+m|0,0);if((b[g>>0]|0)<0)o=f[c>>2]|0;else o=c;if(!i)return;i=o+n|0;n=0;o=d;while(1){d=b[o+n>>0]|0;a:do switch(d<<24>>24){case 10:{b[i>>0]=92;b[i+1>>0]=110;p=i+2|0;break}case 13:{b[i>>0]=92;b[i+1>>0]=114;p=i+2|0;break}case 9:{b[i>>0]=92;b[i+1>>0]=116;p=i+2|0;break}case 34:{b[i>>0]=92;b[i+1>>0]=34;p=i+2|0;break}case 39:{b[i>>0]=92;b[i+1>>0]=39;p=i+2|0;break}case 92:{b[i>>0]=92;b[i+1>>0]=92;p=i+2|0;break}default:{c=i+1|0;if(d<<24>>24>31&d<<24>>24!=127){b[i>>0]=d;p=c;break a}else{b[i>>0]=92;b[c>>0]=(d&255)>>>6|48;b[i+2>>0]=(d&255)>>>3&7|48;b[i+3>>0]=d&7|48;p=i+4|0;break a}}}while(0);d=n+1|0;if((d|0)>=(f[e>>2]|0))break;i=p;n=d;o=f[a>>2]|0}return}function _lc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d+8|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=b[c+11>>0]|0;i=h<<24>>24<0;f[g>>2]=i?f[c>>2]|0:c;f[g+4>>2]=i?f[c+4>>2]|0:h&255;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];Zlc(e,a);u=d;return}function $lc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=d+20|0;b[d+21>>0]=0;if((c|0)>-1|(c|0)==-1&a>>>0>4294967295){f=e;g=a;h=c;while(1){i=_Ic(g|0,h|0,10,0)|0;j=UIc(i|0,J|0,48,0)|0;b[f>>0]=j;j=g;g=kJc(g|0,h|0,10,0)|0;if(!((h|0)>0|(h|0)==0&j>>>0>9)){k=f;break}else{f=f+-1|0;h=J}}return k|0}if((c|0)>-1|(c|0)==-1&a>>>0>4294967286){h=TIc(48,0,a|0,c|0)|0;b[e>>0]=h;l=d+19|0}else{h=TIc(-10,-1,a|0,c|0)|0;c=J;a=_Ic(h|0,c|0,10,0)|0;f=UIc(a|0,J|0,48,0)|0;b[e>>0]=f;f=kJc(h|0,c|0,10,0)|0;c=UIc(f|0,J|0,1,0)|0;f=d+19|0;d=c;c=J;while(1){h=_Ic(d|0,c|0,10,0)|0;e=UIc(h|0,J|0,48,0)|0;h=f+-1|0;b[f>>0]=e;e=d;d=kJc(d|0,c|0,10,0)|0;if(!((c|0)>0|(c|0)==0&e>>>0>9)){l=h;break}else{f=h;c=J}}}b[l>>0]=45;k=l;return k|0}function amc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=c+10|0;b[c+11>>0]=0;if((a|0)>-1){e=d;f=a;while(1){b[e>>0]=((f|0)%10|0)+48;if((f|0)>9){e=e+-1|0;f=(f|0)/10|0}else{g=e;break}}return g|0}if((a|0)>-10){b[d>>0]=48-a;h=c+9|0}else{e=-10-a|0;b[d>>0]=((e|0)%10|0)+48;d=c+9|0;c=((e|0)/10|0)+1|0;while(1){e=d+-1|0;b[d>>0]=((c|0)%10|0)+48;if((c|0)>9){d=e;c=(c|0)/10|0}else{h=e;break}}}b[h>>0]=45;g=h;return g|0}function bmc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;do if(a>>>0<=999999999){if(a>>>0<100){if(a>>>0>9){d=a;e=c;break}b[c>>0]=a+48;f=c+1|0;b[f>>0]=0;return f|0}if(a>>>0<1e4){if(a>>>0>999){g=a;h=c;i=8;break}j=(a>>>0)/100|0;b[c>>0]=j+48;k=j;l=a;m=c+1|0;i=9;break}if(a>>>0<1e6){if(a>>>0>99999){n=a;o=c;i=6;break}j=(a>>>0)/1e4|0;b[c>>0]=j+48;p=j;q=a;r=c+1|0;i=7;break}if(a>>>0>=1e8){j=(a>>>0)/1e8|0;b[c>>0]=j+48;s=j;t=c+1|0;i=3;break}if(a>>>0>9999999){u=a;v=c;i=4}else{j=(a>>>0)/1e6|0;b[c>>0]=j+48;w=j;x=a;y=c+1|0;i=5}}else{j=(a>>>0)/1e8|0;b[c>>0]=b[507847+(j<<1)>>0]|0;b[c+1>>0]=b[507847+(j<<1)+1>>0]|0;s=j;t=c+2|0;i=3}while(0);if((i|0)==3){u=(Y(s,-1e8)|0)+a|0;v=t;i=4}if((i|0)==4){t=(u>>>0)/1e6|0;b[v>>0]=b[507847+(t<<1)>>0]|0;b[v+1>>0]=b[507847+(t<<1)+1>>0]|0;w=t;x=u;y=v+2|0;i=5}if((i|0)==5){n=(Y(w,-1e6)|0)+x|0;o=y;i=6}if((i|0)==6){y=(n>>>0)/1e4|0;b[o>>0]=b[507847+(y<<1)>>0]|0;b[o+1>>0]=b[507847+(y<<1)+1>>0]|0;p=y;q=n;r=o+2|0;i=7}if((i|0)==7){g=(Y(p,-1e4)|0)+q|0;h=r;i=8}if((i|0)==8){r=(g>>>0)/100|0;b[h>>0]=b[507847+(r<<1)>>0]|0;b[h+1>>0]=b[507847+(r<<1)+1>>0]|0;k=r;l=g;m=h+2|0;i=9}if((i|0)==9){d=(Y(k,-100)|0)+l|0;e=m}b[e>>0]=b[507847+(d<<1)>>0]|0;b[e+1>>0]=b[507847+(d<<1)+1>>0]|0;f=e+2|0;b[f>>0]=0;return f|0}function cmc(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)<0){b[c>>0]=45;d=0-a|0;e=c+1|0}else{d=a;e=c}return bmc(d,e)|0}function dmc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;if((a|0)==(a|0)&0==(c|0))return bmc(a,d)|0;else{e=cJc(a|0,c|0,1e9,0)|0;f=J;g=dmc(e,f,d)|0;d=mJc(e|0,f|0,-1e9,-1)|0;f=UIc(d|0,J|0,a|0,c|0)|0;c=(f>>>0)/1e7|0;b[g>>0]=b[507847+(c<<1)>>0]|0;b[g+1>>0]=b[507847+(c<<1)+1>>0]|0;a=(Y(c,-1e7)|0)+f|0;f=(a>>>0)/1e5|0;b[g+2>>0]=b[507847+(f<<1)>>0]|0;b[g+3>>0]=b[507847+(f<<1)+1>>0]|0;c=(Y(f,-1e5)|0)+a|0;a=(c>>>0)/1e3|0;b[g+4>>0]=b[507847+(a<<1)>>0]|0;b[g+5>>0]=b[507847+(a<<1)+1>>0]|0;f=(Y(a,-1e3)|0)+c|0;c=(f>>>0)/10|0;b[g+6>>0]=b[507847+(c<<1)>>0]|0;b[g+7>>0]=b[507847+(c<<1)+1>>0]|0;a=f+48+(Y(c,-10)|0)&255;c=g+9|0;b[g+8>>0]=a;b[c>>0]=0;return c|0}return 0}function emc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=e+10|0;b[e+11>>0]=0;if((c|0)>-1){h=g;i=c;while(1){b[h>>0]=((i|0)%10|0)+48;if((i|0)>9){h=h+-1|0;i=(i|0)/10|0}else{j=h;break}}}else{if((c|0)>-10){b[g>>0]=48-c;k=e+9|0}else{h=-10-c|0;b[g>>0]=((h|0)%10|0)+48;g=e+9|0;e=((h|0)/10|0)+1|0;while(1){h=g+-1|0;b[g>>0]=((e|0)%10|0)+48;if((e|0)>9){g=h;e=(e|0)/10|0}else{k=h;break}}}b[k>>0]=45;j=k};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;k=Mpc(j)|0;if(k>>>0>4294967279)dEc(a);if(k>>>0<11){b[a+11>>0]=k;if(!k){l=a;m=l+k|0;b[m>>0]=0;u=d;return}else n=a}else{e=k+16&-16;g=VDc(e)|0;f[a>>2]=g;f[a+8>>2]=e|-2147483648;f[a+4>>2]=k;n=g}dJc(n|0,j|0,k|0)|0;l=n;m=l+k|0;b[m>>0]=0;u=d;return}function fmc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d;g=bmc(c,e)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=g-e|0;if(c>>>0>4294967279)dEc(a);if(c>>>0<11){b[a+11>>0]=c;h=a}else{i=c+16&-16;j=VDc(i)|0;f[a>>2]=j;f[a+8>>2]=i|-2147483648;f[a+4>>2]=c;h=j}if((e|0)==(g|0)){k=h;b[k>>0]=0;u=d;return}else{l=h;m=e}while(1){b[l>>0]=b[m>>0]|0;m=m+1|0;if((m|0)==(g|0))break;else l=l+1|0}k=h+c|0;b[k>>0]=0;u=d;return}function gmc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e;h=g+20|0;b[g+21>>0]=0;if((d|0)>-1|(d|0)==-1&c>>>0>4294967295){i=h;j=c;k=d;while(1){l=_Ic(j|0,k|0,10,0)|0;m=UIc(l|0,J|0,48,0)|0;b[i>>0]=m;m=j;j=kJc(j|0,k|0,10,0)|0;if(!((k|0)>0|(k|0)==0&m>>>0>9)){n=i;break}else{i=i+-1|0;k=J}}}else{if((d|0)>-1|(d|0)==-1&c>>>0>4294967286){k=TIc(48,0,c|0,d|0)|0;b[h>>0]=k;o=g+19|0}else{k=TIc(-10,-1,c|0,d|0)|0;d=J;c=_Ic(k|0,d|0,10,0)|0;i=UIc(c|0,J|0,48,0)|0;b[h>>0]=i;i=kJc(k|0,d|0,10,0)|0;d=UIc(i|0,J|0,1,0)|0;i=g+19|0;g=d;d=J;while(1){k=_Ic(g|0,d|0,10,0)|0;h=UIc(k|0,J|0,48,0)|0;k=i+-1|0;b[i>>0]=h;h=g;g=kJc(g|0,d|0,10,0)|0;if(!((d|0)>0|(d|0)==0&h>>>0>9)){o=k;break}else{i=k;d=J}}}b[o>>0]=45;n=o};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;o=Mpc(n)|0;if(o>>>0>4294967279)dEc(a);if(o>>>0<11){b[a+11>>0]=o;if(!o){p=a;q=p+o|0;b[q>>0]=0;u=e;return}else r=a}else{d=o+16&-16;i=VDc(d)|0;f[a>>2]=i;f[a+8>>2]=d|-2147483648;f[a+4>>2]=o;r=i}dJc(r|0,n|0,o|0)|0;p=r;q=p+o|0;b[q>>0]=0;u=e;return}function hmc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;h=dmc(c,d,g)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;d=h-g|0;if(d>>>0>4294967279)dEc(a);if(d>>>0<11){b[a+11>>0]=d;i=a}else{c=d+16&-16;j=VDc(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=d;i=j}if((g|0)==(h|0)){k=i;b[k>>0]=0;u=e;return}else{l=i;m=g}while(1){b[l>>0]=b[m>>0]|0;m=m+1|0;if((m|0)==(h|0))break;else l=l+1|0}k=i+d|0;b[k>>0]=0;u=e;return}function imc(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=jmc(c,d)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=Mpc(e)|0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,e|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;u=d;return}function jmc(a,c){a=+a;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0,k=0;d=u;u=u+32|0;e=d+16|0;g=d;if(a==D){b[c>>0]=105;b[c+1>>0]=110;b[c+2>>0]=102;b[c+3>>0]=0;u=d;return c|0}if(a==-D){b[c>>0]=b[508047]|0;b[c+1>>0]=b[508048]|0;b[c+2>>0]=b[508049]|0;b[c+3>>0]=b[508050]|0;b[c+4>>0]=b[508051]|0;u=d;return c|0}p[s>>3]=a;h=f[s+4>>2]&2147483647;if(h>>>0>2146435072|(h|0)==2146435072&(f[s>>2]|0)>>>0>0){b[c>>0]=110;b[c+1>>0]=97;b[c+2>>0]=110;b[c+3>>0]=0;u=d;return c|0}f[g>>2]=15;p[g+8>>3]=a;gqc(c,32,508052,g)|0;i=+qrc(c,0);p[g>>3]=i;if(+p[g>>3]!=a){f[e>>2]=17;p[e+8>>3]=a;gqc(c,32,508052,e)|0}a:do if(!(Wpc(c,46)|0)){e=c;b:while(1){g=b[e>>0]|0;if((g+-48&255)>=10)switch(g<<24>>24){case 0:{break a;break}case 45:case 43:case 69:case 101:break;default:break b}e=e+1|0}b[e>>0]=46;g=e+1|0;h=b[g>>0]|0;if((h+-48&255)>=10){switch(h<<24>>24){case 0:case 45:case 43:case 69:case 101:{break a;break}default:j=g}c:while(1){k=j+1|0;h=b[k>>0]|0;if((h+-48&255)<10)break;switch(h<<24>>24){case 0:case 45:case 43:case 69:case 101:{break c;break}default:j=k}}fJc(g|0,k|0,(Mpc(k)|0)+1|0)|0}}while(0);u=d;return c|0}function kmc(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=lmc(c,d)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=Mpc(e)|0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;u=d;return}else j=a}else{k=g+16&-16;l=VDc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}dJc(j|0,e|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;u=d;return}function lmc(a,c){a=+a;c=c|0;var d=0,e=0,g=0,h=0.0,i=0,j=0.0,k=0,l=0,m=0,o=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a;if(a==D){b[c>>0]=105;b[c+1>>0]=110;b[c+2>>0]=102;b[c+3>>0]=0;u=d;return c|0}if(a==-D){b[c>>0]=b[508047]|0;b[c+1>>0]=b[508048]|0;b[c+2>>0]=b[508049]|0;b[c+3>>0]=b[508050]|0;b[c+4>>0]=b[508051]|0;u=d;return c|0}if(((n[s>>2]=a,f[s>>2]|0)&2147483647)>>>0>2139095040){b[c>>0]=110;b[c+1>>0]=97;b[c+2>>0]=110;b[c+3>>0]=0;u=d;return c|0}f[g>>2]=6;p[g+8>>3]=h;gqc(c,24,508052,g)|0;i=zoc()|0;f[i>>2]=0;j=+orc(c,g);if((b[c>>0]|0)!=0?(b[f[g>>2]>>0]|0)==0:0){g=zoc()|0;if(j!=a|(f[g>>2]|0)!=0)k=11}else k=11;if((k|0)==11){f[e>>2]=9;p[e+8>>3]=h;gqc(c,24,508052,e)|0}if(!(Wpc(c,46)|0))l=c;else{u=d;return c|0}a:while(1){e=b[l>>0]|0;if((e+-48&255)>=10)switch(e<<24>>24){case 0:{k=21;break a;break}case 45:case 43:case 69:case 101:break;default:break a}l=l+1|0}if((k|0)==21){u=d;return c|0}b[l>>0]=46;k=l+1|0;l=b[k>>0]|0;if((l+-48&255)<10){u=d;return c|0}switch(l<<24>>24){case 0:case 45:case 43:case 69:case 101:{u=d;return c|0}default:m=k}b:while(1){o=m+1|0;l=b[o>>0]|0;if((l+-48&255)<10)break;switch(l<<24>>24){case 0:case 45:case 43:case 69:case 101:{break b;break}default:m=o}}fJc(k|0,o|0,(Mpc(o)|0)+1|0)|0;u=d;return c|0}function mmc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fEc(e,a);a=nmc(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return a|0}YDc(f[e>>2]|0);u=d;return a|0}function nmc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d+12|0;g=d;f[c>>2]=0;if(!(omc(a,e)|0)){h=0;u=d;return h|0}if(b[e>>0]|0){e=b[a+11>>0]|0;i=e<<24>>24<0;j=i?f[a>>2]|0:a;k=i?f[a+4>>2]|0:e&255;e=j+k|0;a:do if((k|0)>0){i=0;l=j;while(1){m=b[l>>0]|0;n=m&255;o=n+-48|0;if((m&255)<48|(o|0)>9){p=0;q=i;break a}if((i|0)<-214748364){p=0;q=-2147483648;break a}m=i*10|0;if((m|0)<(n+2147483600|0)){p=0;q=-2147483648;break a}n=m-o|0;l=l+1|0;if(l>>>0>=e>>>0){p=1;q=n;break}else i=n}}else{p=1;q=0}while(0);f[c>>2]=q;h=p;u=d;return h|0}fEc(g,a);a=b[g+11>>0]|0;p=a<<24>>24<0;q=f[g>>2]|0;e=p?q:g;j=p?f[g+4>>2]|0:a&255;a=e+j|0;b:do if((j|0)>0){g=0;k=e;while(1){i=b[k>>0]|0;l=i&255;n=l+-48|0;if((i&255)<48|(n|0)>9){r=0;s=g;break b}if((g|0)>214748364){r=0;s=2147483647;break b}i=g*10|0;if((i|0)>(-2147483601-l|0)){r=0;s=2147483647;break b}l=n+i|0;k=k+1|0;if(k>>>0>=a>>>0){r=1;s=l;break}else g=l}}else{r=1;s=0}while(0);f[c>>2]=s;if(!p){h=r;u=d;return h|0}YDc(q);h=r;u=d;return h|0}function omc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=b[a+11>>0]|0;h=g<<24>>24<0;if(h){i=f[a>>2]|0;j=f[a+4>>2]|0}else{i=a;j=g&255}g=i+j|0;a:do if((j|0)>0){k=i;while(1){if((b[k>>0]|0)!=32){l=k;break a}m=k+1|0;if(m>>>0<g>>>0)k=m;else{l=m;break}}}else l=i;while(0);i=g;while(1){if(l>>>0>=i>>>0){n=0;o=19;break}g=i+-1|0;if((b[g>>0]|0)==32)i=g;else break}if((o|0)==19){u=d;return n|0}o=(b[l>>0]|0)==45;b[c>>0]=o&1;if(!o?(b[l>>0]|0)!=43:0)p=l;else{o=l+1|0;if(o>>>0<i>>>0)p=o;else{n=0;u=d;return n|0}}if(h)q=f[a>>2]|0;else q=a;h=p;gEc(e,a,h-q|0,i-h|0,a);iEc(a,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);n=1;u=d;return n|0}function pmc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+40|0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=jJc(f[c+8>>2]|0,0,2)|0;c=UIc(e|0,J|0,-4,-1)|0;e=jJc(1,0,c|0)|0;c=d;i=g;j=h;k=e|g;g=J|h;do{c=c+-1|0;b[c>>0]=b[507830+(i&15)>>0]|0;i=aJc(i|0,j|0,4)|0;j=J;k=aJc(k|0,g|0,4)|0;g=J}while(!((k|0)==0&(g|0)==0));f[a>>2]=c;f[a+4>>2]=d-c;return}function qmc(a,b){a=a|0;b=b|0;tEc(a,f[b>>2]|0,f[b+4>>2]|0)|0;return}function rmc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=b[a+11>>0]|0;i=g<<24>>24<0;j=i?f[a>>2]|0:a;k=i?f[a+4>>2]|0:g&255;g=j;i=j+k|0;do{if((i|0)==(j|0)){l=0;m=9;break}i=i+-1|0}while(!(Zoc(517940,h[i>>0]|0,1)|0));if((m|0)==9){u=d;return l|0}m=i-g|0;if((m|0)==-1){l=0;u=d;return l|0}g=m+1|0;if((g|0)==(k|0)){l=0;u=d;return l|0}gEc(e,a,g,-1,a);iEc(c,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);l=1;u=d;return l|0}function smc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);a=f[g>>2]|0;h=f[a+4>>2]|0;i=b[h+11>>0]|0;if(((i<<24>>24<0?f[h+4>>2]|0:i&255)|0)!=19){j=0;u=e;return j|0}if(EEc(h,0,-1,508057,19)|0){j=0;u=e;return j|0}h=qYb(a,1)|0;f[c>>2]=h;h=qYb(a,2)|0;f[d>>2]=h;h=f[c>>2]|0;if(!h){j=0;u=e;return j|0}c=f[h+24>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=h;DTb(c,g)}if((f[h+28>>2]|0)!=9){j=0;u=e;return j|0}h=f[d>>2]|0;if(!h){j=0;u=e;return j|0}d=f[h+24>>2]|0;if(d|0?(f[d>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=h;DTb(d,g)}j=(f[h+28>>2]|0)==12;u=e;return j|0}function tmc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;m=u;u=u+608|0;o=m+56|0;q=m+552|0;r=m+496|0;s=m+440|0;t=m+384|0;v=m+320|0;w=m+376|0;x=m;y=m+264|0;z=m+208|0;A=m+152|0;B=m+136|0;C=m+120|0;D=m+104|0;E=m+88|0;F=m+72|0;do if((d$(a)|0)==65536){G=f[a+4>>2]|0;f[q>>2]=f[G>>2];H=q+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=q+8|0;f[J>>2]=f[G+8>>2];f[q+12>>2]=f[G+12>>2];f[q+16>>2]=f[G+16>>2];f[q+20>>2]=f[G+20>>2];f[q+24>>2]=f[G+24>>2];f[q+28>>2]=f[G+28>>2];f[q+32>>2]=f[G+32>>2];K=f[G+36>>2]|0;f[q+36>>2]=K;f[q+40>>2]=J;J=q+48|0;L=q+44|0;f[L>>2]=J;f[J>>2]=0;f[q+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;ZS(q,G);break}}else a$(q,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[r>>2]=f[a>>2];G=r+4|0;H=a+4|0;f[G>>2]=f[H>>2];I=r+8|0;f[I>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];J=f[a+36>>2]|0;f[r+36>>2]=J;f[r+40>>2]=I;I=r+48|0;L=r+44|0;f[L>>2]=I;f[I>>2]=0;f[r+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[a+44>>2]|0;I=f[L>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;ZS(r,a);break}}else a$(r,c,-1);while(0);do if((d$(j)|0)==65536){c=f[j+4>>2]|0;f[s>>2]=f[c>>2];a=s+4|0;G=c+4|0;f[a>>2]=f[G>>2];H=s+8|0;f[H>>2]=f[c+8>>2];f[s+12>>2]=f[c+12>>2];f[s+16>>2]=f[c+16>>2];f[s+20>>2]=f[c+20>>2];f[s+24>>2]=f[c+24>>2];f[s+28>>2]=f[c+28>>2];f[s+32>>2]=f[c+32>>2];I=f[c+36>>2]|0;f[s+36>>2]=I;f[s+40>>2]=H;H=s+48|0;L=s+44|0;f[L>>2]=H;f[H>>2]=0;f[s+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[c+44>>2]|0;H=f[L>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[a>>2]=0;ZS(s,c);break}}else a$(s,j,-1);while(0);j=f[q>>2]|0;c=j&4095;if((c|0)!=(f[r>>2]&4095|0)){f[t>>2]=0;M=t+4|0;f[M>>2]=0;N=tT(t,82)|0;O=N;P=508119;Q=O+82|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,t,275)}if((f[q+12>>2]|0)!=(f[r+12>>2]|0)){f[t>>2]=0;M=t+4|0;f[M>>2]=0;N=tT(t,82)|0;O=N;P=508119;Q=O+82|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,t,275)}a=(c|0)==5;G=(c|0)==0;switch(j&4095){case 0:case 5:break;default:{f[t>>2]=0;M=t+4|0;f[M>>2]=0;N=tT(t,82)|0;O=N;P=508119;Q=O+82|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,t,275)}}if((i|0)>0^($$(g)|0)){f[t>>2]=0;f[t+4>>2]=0;O=tT(t,25)|0;P=508202;Q=O+25|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,t,276)}N=(e|0)==-1?((h|1|0)==7?4:5):e;e=(N|0)==4;M=(N|0)==5;if(!(M|e&G)){f[t>>2]=0;f[t+4>>2]=0;O=tT(t,53)|0;P=508228;Q=O+53|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,t,282)}j=f[r+8>>2]|0;H=(j|0)<(i|0)?j:i;i=q+8|0;L=(H|0)>0;Y$(d,f[i>>2]|0,L?H:j,N,-1,0,0);do if((d$(d)|0)==65536){j=f[d+4>>2]|0;f[t>>2]=f[j>>2];I=t+4|0;J=j+4|0;f[I>>2]=f[J>>2];K=t+8|0;f[K>>2]=f[j+8>>2];f[t+12>>2]=f[j+12>>2];f[t+16>>2]=f[j+16>>2];f[t+20>>2]=f[j+20>>2];f[t+24>>2]=f[j+24>>2];f[t+28>>2]=f[j+28>>2];f[t+32>>2]=f[j+32>>2];R=f[j+36>>2]|0;f[t+36>>2]=R;f[t+40>>2]=K;K=t+48|0;S=t+44|0;f[S>>2]=K;f[K>>2]=0;f[t+52>>2]=0;if(R|0){K=R+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[J>>2]|0)<3){J=f[j+44>>2]|0;K=f[S>>2]|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2];break}else{f[I>>2]=0;ZS(t,j);break}}else a$(t,d,-1);while(0);f[v>>2]=1124007936;d=v+4|0;j=v+8|0;I=v+40|0;O=d;Q=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(Q|0));f[I>>2]=j;J=v+48|0;K=v+44|0;f[K>>2]=J;f[J>>2]=0;f[v+52>>2]=0;if($$(g)|0){S=f[t+40>>2]|0;R=f[S>>2]|0;f[w>>2]=f[S+4>>2];f[w+4>>2]=R;v$(g,w,4,-1,0,0);do if((d$(g)|0)==65536){w=f[g+4>>2]|0;f[x>>2]=f[w>>2];R=x+4|0;S=w+4|0;f[R>>2]=f[S>>2];T=x+8|0;f[T>>2]=f[w+8>>2];f[x+12>>2]=f[w+12>>2];f[x+16>>2]=f[w+16>>2];f[x+20>>2]=f[w+20>>2];f[x+24>>2]=f[w+24>>2];f[x+28>>2]=f[w+28>>2];f[x+32>>2]=f[w+32>>2];U=x+36|0;V=f[w+36>>2]|0;f[U>>2]=V;f[x+40>>2]=T;T=x+48|0;W=x+44|0;f[W>>2]=T;f[T>>2]=0;f[x+52>>2]=0;if(V|0){T=V+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[w+44>>2]|0;T=f[W>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];X=U;break}else{f[R>>2]=0;ZS(x,w);X=U;break}}else{a$(x,g,-1);X=x+36|0}while(0);g=f[X>>2]|0;if(g|0){U=g+12|0;f[U>>2]=(f[U>>2]|0)+1}U=v+36|0;g=f[U>>2]|0;if(g|0?(w=g+12|0,g=f[w>>2]|0,f[w>>2]=g+-1,(g|0)==1):0)_S(v);f[U>>2]=0;g=v+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){w=f[I>>2]|0;R=0;do{f[w+(R<<2)>>2]=0;R=R+1|0;Z=f[d>>2]|0}while((R|0)<(Z|0));f[v>>2]=f[x>>2];if((Z|0)<3)_=55;else _=57}else{f[v>>2]=f[x>>2];_=55}if((_|0)==55){Z=f[x+4>>2]|0;if((Z|0)<3){f[d>>2]=Z;f[j>>2]=f[x+8>>2];f[v+12>>2]=f[x+12>>2];Z=f[x+44>>2]|0;R=f[K>>2]|0;f[R>>2]=f[Z>>2];f[R+4>>2]=f[Z+4>>2]}else _=57}if((_|0)==57)ZS(v,x);Z=x+16|0;f[g>>2]=f[Z>>2];f[v+20>>2]=f[x+20>>2];f[v+24>>2]=f[x+24>>2];f[v+28>>2]=f[x+28>>2];f[v+32>>2]=f[x+32>>2];g=f[X>>2]|0;f[U>>2]=g;if(g|0?(U=g+12|0,g=f[U>>2]|0,f[U>>2]=g+-1,(g|0)==1):0)_S(x);f[X>>2]=0;X=x+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[X>>2]|0)>0){Z=f[x+40>>2]|0;g=0;do{f[Z+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[X>>2]|0))}X=f[x+44>>2]|0;if((X|0)!=(x+48|0))g0(X)}X=(k|0)==0;if(X&L){$=e?2147483647.0:3402823466385288598117041.0e14;p[x>>3]=$;p[x+8>>3]=$;p[x+16>>3]=$;p[x+24>>3]=$;k_(t,x)|0;p[x>>3]=-1.0;p[x+8>>3]=-1.0;p[x+16>>3]=-1.0;p[x+24>>3]=-1.0;k_(v,x)|0}if(l){if(!(X&(H|0)==1)){f[x>>2]=0;aa=x+4|0;f[aa>>2]=0;ba=tT(x,37)|0;O=ba;P=508282;Q=O+37|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,x,303)}if(f[s+16>>2]|0){X=f[s+4>>2]|0;if((X|0)<3)ca=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{l=f[s+40>>2]|0;L=0;g=1;while(1){Z=Y(f[l+(L<<2)>>2]|0,g)|0;L=L+1|0;if((L|0)==(X|0)){ca=Z;break}else g=Z}}if(!((X|0)==0|(ca|0)==0)){f[x>>2]=0;aa=x+4|0;f[aa>>2]=0;ba=tT(x,37)|0;O=ba;P=508282;Q=O+37|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,x,303)}}ba=v+16|0;if(!(f[ba>>2]|0)){f[x>>2]=0;da=x+4|0;f[da>>2]=0;ea=tT(x,13)|0;O=ea;P=508320;Q=O+13|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,x,304)}aa=f[d>>2]|0;if((aa|0)<3)fa=Y(f[v+12>>2]|0,f[j>>2]|0)|0;else{j=f[I>>2]|0;ca=0;X=1;while(1){g=Y(f[j+(ca<<2)>>2]|0,X)|0;ca=ca+1|0;if((ca|0)==(aa|0)){fa=g;break}else X=g}}if((aa|0)==0|(fa|0)==0){f[x>>2]=0;da=x+4|0;f[da>>2]=0;ea=tT(x,13)|0;O=ea;P=508320;Q=O+13|0;do{b[O>>0]=b[P>>0]|0;O=O+1|0;P=P+1|0}while((O|0)<(Q|0));umc(-215,x,304)}f[x>>2]=1124007936;P=x+4|0;ea=x+8|0;da=x+40|0;O=P;Q=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(Q|0));f[da>>2]=ea;fa=x+48|0;aa=x+44|0;f[aa>>2]=fa;f[fa>>2]=0;f[x+52>>2]=0;f[y>>2]=1124007936;X=y+4|0;ca=y+8|0;j=y+40|0;O=X;Q=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(Q|0));f[j>>2]=ca;ca=y+48|0;g=y+44|0;f[g>>2]=ca;f[ca>>2]=0;f[y+52>>2]=0;f[z>>2]=1124007936;L=z+4|0;l=z+8|0;Z=z+40|0;O=L;Q=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(Q|0));f[Z>>2]=l;U=z+48|0;R=z+44|0;f[R>>2]=U;f[U>>2]=0;f[z+52>>2]=0;f[A>>2]=1124007936;w=A+4|0;S=A+8|0;T=A+40|0;O=w;Q=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(Q|0));f[T>>2]=S;S=A+48|0;O=A+44|0;f[O>>2]=S;f[S>>2]=0;f[A+52>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=r;f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=q;Q=D+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[D>>2]=33619968;f[D+4>>2]=x;Q=E+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[E>>2]=33619968;f[E+4>>2]=y;f[F+8>>2]=0;f[F+12>>2]=0;f[F>>2]=16842752;f[F+4>>2]=s;tmc(B,C,D,N,E,h,1,F,0,0);f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=q;f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=r;Q=D+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[D>>2]=33619968;f[D+4>>2]=z;Q=E+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[E>>2]=33619968;f[E+4>>2]=A;f[F+8>>2]=0;f[F+12>>2]=0;f[F>>2]=16842752;f[F+4>>2]=s;tmc(B,C,D,N,E,h,1,F,0,0);F=f[ea>>2]|0;E=(F|0)>0;if(e){if(E){D=f[y+16>>2]|0;C=f[j>>2]|0;B=C+4|0;Q=f[g>>2]|0;W=y+12|0;V=f[x+16>>2]|0;ga=f[da>>2]|0;ha=ga+4|0;ia=f[aa>>2]|0;ja=x+12|0;ka=f[t+16>>2]|0;la=f[t+40>>2]|0;ma=la+4|0;na=f[t+44>>2]|0;oa=t+12|0;pa=f[ba>>2]|0;qa=f[I>>2]|0;ra=qa+4|0;sa=f[K>>2]|0;ta=v+12|0;ua=0;va=F;while(1){do if(!(f[y>>2]&16384)){if((f[C>>2]|0)==1){_=94;break}wa=f[Q>>2]|0;if((f[B>>2]|0)==1){xa=D+(Y(wa,ua)|0)|0;break}else{ya=f[W>>2]|0;za=(ua|0)/(ya|0)|0;xa=D+(Y(za,wa)|0)+(ua-(Y(za,ya)|0)<<2)|0;break}}else _=94;while(0);if((_|0)==94){_=0;xa=D+(ua<<2)|0}ya=f[xa>>2]|0;do if(!(f[x>>2]&16384)){if((f[ga>>2]|0)==1){_=100;break}za=f[ia>>2]|0;if((f[ha>>2]|0)==1){Aa=V+(Y(za,ua)|0)|0;break}else{wa=f[ja>>2]|0;Ba=(ua|0)/(wa|0)|0;Aa=V+(Y(Ba,za)|0)+(ua-(Y(Ba,wa)|0)<<2)|0;break}}else _=100;while(0);if((_|0)==100){_=0;Aa=V+(ua<<2)|0}wa=f[Aa>>2]|0;Ba=(f[t>>2]&16384|0)==0;do if(Ba){if((f[la>>2]|0)==1){_=106;break}za=f[na>>2]|0;if((f[ma>>2]|0)==1){Ca=ka+(Y(za,ya)|0)|0;break}else{Da=f[oa>>2]|0;Ea=(ya|0)/(Da|0)|0;Ca=ka+(Y(Ea,za)|0)+(ya-(Y(Ea,Da)|0)<<2)|0;break}}else _=106;while(0);if((_|0)==106){_=0;Ca=ka+(ya<<2)|0}if((wa|0)<(f[Ca>>2]|0)){do if(Ba){if((f[la>>2]|0)==1){_=113;break}Da=f[na>>2]|0;if((f[ma>>2]|0)==1){Fa=ka+(Y(Da,ya)|0)|0;break}else{Ea=f[oa>>2]|0;za=(ya|0)/(Ea|0)|0;Fa=ka+(Y(za,Da)|0)+(ya-(Y(za,Ea)|0)<<2)|0;break}}else _=113;while(0);if((_|0)==113){_=0;Fa=ka+(ya<<2)|0}f[Fa>>2]=wa;do if(!(f[v>>2]&16384)){if((f[qa>>2]|0)==1){_=119;break}Ba=f[sa>>2]|0;if((f[ra>>2]|0)==1){Ga=pa+(Y(Ba,ya)|0)|0;break}else{Ea=f[ta>>2]|0;za=(ya|0)/(Ea|0)|0;Ga=pa+(Y(za,Ba)|0)+(ya-(Y(za,Ea)|0)<<2)|0;break}}else _=119;while(0);if((_|0)==119){_=0;Ga=pa+(ya<<2)|0}f[Ga>>2]=ua;Ha=f[ea>>2]|0}else Ha=va;ua=ua+1|0;if((ua|0)>=(Ha|0))break;else va=Ha}}}else if(E){E=f[y+16>>2]|0;Ha=f[j>>2]|0;va=Ha+4|0;ua=f[g>>2]|0;Ga=y+12|0;pa=f[x+16>>2]|0;ta=f[da>>2]|0;ra=ta+4|0;sa=f[aa>>2]|0;qa=x+12|0;Fa=f[t+16>>2]|0;ka=f[t+40>>2]|0;oa=ka+4|0;ma=f[t+44>>2]|0;na=t+12|0;la=f[ba>>2]|0;Ca=f[I>>2]|0;Aa=Ca+4|0;V=f[K>>2]|0;ja=v+12|0;ha=0;ia=F;while(1){do if(!(f[y>>2]&16384)){if((f[Ha>>2]|0)==1){_=127;break}F=f[ua>>2]|0;if((f[va>>2]|0)==1){Ia=E+(Y(F,ha)|0)|0;break}else{ga=f[Ga>>2]|0;xa=(ha|0)/(ga|0)|0;Ia=E+(Y(xa,F)|0)+(ha-(Y(xa,ga)|0)<<2)|0;break}}else _=127;while(0);if((_|0)==127){_=0;Ia=E+(ha<<2)|0}ya=f[Ia>>2]|0;do if(!(f[x>>2]&16384)){if((f[ta>>2]|0)==1){_=133;break}ga=f[sa>>2]|0;if((f[ra>>2]|0)==1){Ja=pa+(Y(ga,ha)|0)|0;break}else{xa=f[qa>>2]|0;F=(ha|0)/(xa|0)|0;Ja=pa+(Y(F,ga)|0)+(ha-(Y(F,xa)|0)<<2)|0;break}}else _=133;while(0);if((_|0)==133){_=0;Ja=pa+(ha<<2)|0}$=+n[Ja>>2];xa=(f[t>>2]&16384|0)==0;do if(xa){if((f[ka>>2]|0)==1){_=139;break}F=f[ma>>2]|0;if((f[oa>>2]|0)==1){Ka=Fa+(Y(F,ya)|0)|0;break}else{ga=f[na>>2]|0;D=(ya|0)/(ga|0)|0;Ka=Fa+(Y(D,F)|0)+(ya-(Y(D,ga)|0)<<2)|0;break}}else _=139;while(0);if((_|0)==139){_=0;Ka=Fa+(ya<<2)|0}if($<+n[Ka>>2]){do if(xa){if((f[ka>>2]|0)==1){_=146;break}ga=f[ma>>2]|0;if((f[oa>>2]|0)==1){La=Fa+(Y(ga,ya)|0)|0;break}else{D=f[na>>2]|0;F=(ya|0)/(D|0)|0;La=Fa+(Y(F,ga)|0)+(ya-(Y(F,D)|0)<<2)|0;break}}else _=146;while(0);if((_|0)==146){_=0;La=Fa+(ya<<2)|0}n[La>>2]=$;do if(!(f[v>>2]&16384)){if((f[Ca>>2]|0)==1){_=152;break}xa=f[V>>2]|0;if((f[Aa>>2]|0)==1){Ma=la+(Y(xa,ya)|0)|0;break}else{D=f[ja>>2]|0;F=(ya|0)/(D|0)|0;Ma=la+(Y(F,xa)|0)+(ya-(Y(F,D)|0)<<2)|0;break}}else _=152;while(0);if((_|0)==152){_=0;Ma=la+(ya<<2)|0}f[Ma>>2]=ha;Na=f[ea>>2]|0}else Na=ia;ha=ha+1|0;if((ha|0)>=(Na|0))break;else ia=Na}}Na=f[l>>2]|0;if((Na|0)>0){ia=f[A+16>>2]|0;ha=f[T>>2]|0;ea=ha+4|0;Ma=f[O>>2]|0;la=A+12|0;ja=f[y+16>>2]|0;Aa=f[j>>2]|0;V=Aa+4|0;Ca=f[g>>2]|0;La=y+12|0;Fa=f[ba>>2]|0;ba=f[I>>2]|0;na=ba+4|0;oa=f[K>>2]|0;ma=v+12|0;ka=0;Ka=Na;while(1){do if(!(f[A>>2]&16384)){if((f[ha>>2]|0)==1){_=168;break}Na=f[Ma>>2]|0;if((f[ea>>2]|0)==1){Oa=ia+(Y(Na,ka)|0)|0;break}else{Ja=f[la>>2]|0;pa=(ka|0)/(Ja|0)|0;Oa=ia+(Y(pa,Na)|0)+(ka-(Y(pa,Ja)|0)<<2)|0;break}}else _=168;while(0);if((_|0)==168){_=0;Oa=ia+(ka<<2)|0}ya=f[Oa>>2]|0;do if(!(f[y>>2]&16384)){if((f[Aa>>2]|0)==1){_=174;break}Ja=f[Ca>>2]|0;if((f[V>>2]|0)==1){Pa=ja+(Y(Ja,ya)|0)|0;break}else{pa=f[La>>2]|0;Na=(ya|0)/(pa|0)|0;Pa=ja+(Y(Na,Ja)|0)+(ya-(Y(Na,pa)|0)<<2)|0;break}}else _=174;while(0);if((_|0)==174){_=0;Pa=ja+(ya<<2)|0}if((f[Pa>>2]|0)==(ka|0))Qa=Ka;else{do if(!(f[v>>2]&16384)){if((f[ba>>2]|0)==1){_=181;break}pa=f[oa>>2]|0;if((f[na>>2]|0)==1){Ra=Fa+(Y(pa,ka)|0)|0;break}else{Na=f[ma>>2]|0;Ja=(ka|0)/(Na|0)|0;Ra=Fa+(Y(Ja,pa)|0)+(ka-(Y(Ja,Na)|0)<<2)|0;break}}else _=181;while(0);if((_|0)==181){_=0;Ra=Fa+(ka<<2)|0}f[Ra>>2]=-1;Qa=f[l>>2]|0}ka=ka+1|0;if((ka|0)>=(Qa|0))break;else Ka=Qa}}Qa=A+36|0;Ka=f[Qa>>2]|0;do if(Ka|0){ka=Ka+12|0;l=f[ka>>2]|0;f[ka>>2]=l+-1;if((l|0)!=1)break;_S(A)}while(0);f[Qa>>2]=0;Qa=A+16|0;f[Qa>>2]=0;f[Qa+4>>2]=0;f[Qa+8>>2]=0;f[Qa+12>>2]=0;if((f[w>>2]|0)>0){Qa=f[T>>2]|0;T=0;do{f[Qa+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[w>>2]|0))}w=f[O>>2]|0;if((w|0)!=(S|0))g0(w);w=z+36|0;S=f[w>>2]|0;do if(S|0){O=S+12|0;T=f[O>>2]|0;f[O>>2]=T+-1;if((T|0)!=1)break;_S(z)}while(0);f[w>>2]=0;w=z+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[L>>2]|0)>0){w=f[Z>>2]|0;Z=0;do{f[w+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[L>>2]|0))}L=f[R>>2]|0;if((L|0)!=(U|0))g0(L);L=y+36|0;U=f[L>>2]|0;do if(U|0){R=U+12|0;Z=f[R>>2]|0;f[R>>2]=Z+-1;if((Z|0)!=1)break;_S(y)}while(0);f[L>>2]=0;L=y+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[X>>2]|0)>0){L=f[j>>2]|0;j=0;do{f[L+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[X>>2]|0))}X=f[g>>2]|0;if((X|0)!=(ca|0))g0(X);X=x+36|0;ca=f[X>>2]|0;do if(ca|0){g=ca+12|0;j=f[g>>2]|0;f[g>>2]=j+-1;if((j|0)!=1)break;_S(x)}while(0);f[X>>2]=0;X=x+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[P>>2]|0)>0){X=f[da>>2]|0;da=0;do{f[X+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[P>>2]|0))}P=f[aa>>2]|0;if((P|0)!=(fa|0))g0(P)}else{a:do if(G){P=(h|0)==2;if(!(P&e))if(!(P&M)){P=(h|0)==5;if(!(P&e))if(!(P&M))if(!((h|0)==4&M))if((h|0)==6&e)Sa=115;else{if((h|0)==7&e){Sa=119;break}f[o>>2]=c;Ta=o+4|0;f[Ta>>2]=N;Ua=o+8|0;f[Ua>>2]=h;F5(x,508334,o);umc(-210,x,382)}else Sa=114;else Sa=113;else Sa=112}else Sa=111;else Sa=110}else{if(!(M&a)){f[o>>2]=c;Ta=o+4|0;f[Ta>>2]=N;Ua=o+8|0;f[Ua>>2]=h;F5(x,508334,o);umc(-210,x,382)}switch(h|0){case 2:{Sa=116;break a;break}case 5:{Sa=117;break a;break}case 4:{Sa=118;break a;break}default:{f[o>>2]=c;Ta=o+4|0;f[Ta>>2]=N;Ua=o+8|0;f[Ua>>2]=h;F5(x,508334,o);umc(-210,x,382)}}}while(0);o=f[i>>2]|0;f[x>>2]=0;f[x+4>>2]=o;f[y>>2]=168428;f[y+4>>2]=q;f[y+8>>2]=r;f[y+12>>2]=t;f[y+16>>2]=v;f[y+24>>2]=H;f[y+20>>2]=s;f[y+28>>2]=k;f[y+32>>2]=Sa;y8(x,y,-1.0)}y=v+36|0;x=f[y>>2]|0;if(x|0?(Sa=x+12|0,x=f[Sa>>2]|0,f[Sa>>2]=x+-1,(x|0)==1):0)_S(v);f[y>>2]=0;y=v+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[d>>2]|0)>0){y=f[I>>2]|0;I=0;do{f[y+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[d>>2]|0))}d=f[K>>2]|0;if((d|0)!=(J|0))g0(d);d=t+36|0;J=f[d>>2]|0;if(J|0?(K=J+12|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0)_S(t);f[d>>2]=0;d=t+16|0;J=t+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[J>>2]|0)>0){d=f[t+40>>2]|0;K=0;do{f[d+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[J>>2]|0))}J=f[t+44>>2]|0;if((J|0)!=(t+48|0))g0(J);J=s+36|0;t=f[J>>2]|0;if(t|0?(K=t+12|0,t=f[K>>2]|0,f[K>>2]=t+-1,(t|0)==1):0)_S(s);f[J>>2]=0;J=s+16|0;t=s+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[t>>2]|0)>0){J=f[s+40>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))g0(t);t=r+36|0;s=f[t>>2]|0;do if(s|0){K=s+12|0;J=f[K>>2]|0;f[K>>2]=J+-1;if((J|0)!=1)break;_S(r)}while(0);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;J=0;do{f[t+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))g0(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){J=r+12|0;t=f[J>>2]|0;f[J>>2]=t+-1;if((t|0)!=1)break;_S(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)==(q+48|0)){u=m;return}g0(r);u=m;return}function umc(a,b,c){a=a|0;b=b|0;c=c|0;z5(a,b,508428,508442,c);return}function vmc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=(e|0)>0;if(!i){if(j)k=0;else return;do{l=NO(a,c+(Y(k,d)|0)|0,g,2)|0;f[h+(k<<2)>>2]=l;k=k+1|0}while((k|0)!=(e|0));return}if(j)m=0;else return;do{if(!(b[i+m>>0]|0))n=2147483647;else n=NO(a,c+(Y(m,d)|0)|0,g,2)|0;f[h+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(e|0));return}function wmc(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(!d)return;j=f+-4|0;k=f&-4;if((f|0)<4){l=(f|0)>0;m=0;do{o=c+((Y(m,i)|0)<<2)|0;if(l){p=0;q=0.0;while(1){r=q+ +L(+(+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2]));p=p+1|0;if((p|0)==(f|0)){s=r;break}else q=r}}else s=0.0;n[g+(m<<2)>>2]=s;m=m+1|0}while((m|0)!=(e|0));return}m=(k|0)<(f|0);l=0;do{p=c+((Y(l,i)|0)<<2)|0;o=0;s=0.0;do{t=o|1;u=o|2;v=o|3;s=s+(+L(+(+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2]))+ +L(+(+n[a+(t<<2)>>2]-+n[p+(t<<2)>>2]))+ +L(+(+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2]))+ +L(+(+n[a+(v<<2)>>2]-+n[p+(v<<2)>>2])));o=o+4|0}while((o|0)<=(j|0));if(m){o=k;q=s;while(1){r=q+ +L(+(+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2]));o=o+1|0;if((o|0)==(f|0)){w=r;break}else q=r}}else w=s;n[g+(l<<2)>>2]=w;l=l+1|0}while((l|0)!=(e|0));return}if(!d)return;d=f+-4|0;l=f&-4;if((f|0)<4){k=(f|0)>0;m=0;do{if(b[h+m>>0]|0){j=c+((Y(m,i)|0)<<2)|0;if(k){o=0;w=0.0;while(1){q=w+ +L(+(+n[a+(o<<2)>>2]-+n[j+(o<<2)>>2]));o=o+1|0;if((o|0)==(f|0)){x=q;break}else w=q}}else x=0.0}else x=3402823466385288598117041.0e14;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}m=(l|0)<(f|0);k=0;do{if(b[h+k>>0]|0){o=c+((Y(k,i)|0)<<2)|0;j=0;x=0.0;do{p=j|1;v=j|2;u=j|3;x=x+(+L(+(+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2]))+ +L(+(+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2]))+ +L(+(+n[a+(v<<2)>>2]-+n[o+(v<<2)>>2]))+ +L(+(+n[a+(u<<2)>>2]-+n[o+(u<<2)>>2])));j=j+4|0}while((j|0)<=(d|0));if(m){j=l;w=x;while(1){s=w+ +L(+(+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2]));j=j+1|0;if((j|0)==(f|0)){y=s;break}else w=s}}else y=x}else y=3402823466385288598117041.0e14;n[g+(k<<2)>>2]=y;k=k+1|0}while((k|0)!=(e|0));return}function xmc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=(e|0)>0;if(!i){if(j)k=0;else return;do{l=KY(a,c+(Y(k,d)|0)|0,g)|0;f[h+(k<<2)>>2]=l;k=k+1|0}while((k|0)!=(e|0));return}if(j)m=0;else return;do{if(!(b[i+m>>0]|0))n=2147483647;else n=KY(a,c+(Y(m,d)|0)|0,g)|0;f[h+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(e|0));return}function ymc(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(f|0)){u=t;break}else r=t}}else u=0.0;r=+M(+u);n[g+(o<<2)>>2]=r;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;u=0.0;do{r=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);v=p|1;t=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|2;s=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|3;w=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);u=u+(r*r+t*t+s*s+w*w);p=p+4|0}while((p|0)<=(k|0));if(o){p=l;w=u;while(1){s=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);t=w+s*s;p=p+1|0;if((p|0)==(f|0)){x=t;break}else w=t}}else x=u;w=+M(+x);n[g+(m<<2)>>2]=w;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(!(b[i+o>>0]|0))y=3402823466385288598117041.0e14;else{k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){w=+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0);t=x+w*w;p=p+1|0;if((p|0)==(f|0)){z=t;break}else x=t}}else z=0.0;y=+M(+z)}n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(!(b[i+l>>0]|0))A=3402823466385288598117041.0e14;else{p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{z=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);q=k|1;x=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|2;u=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|3;t=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);y=y+(z*z+x*x+u*u+t*t);k=k+4|0}while((k|0)<=(j|0));if(o){k=m;t=y;while(1){u=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);x=t+u*u;k=k+1|0;if((k|0)==(f|0)){B=x;break}else t=x}}else B=y;A=+M(+B)}n[g+(l<<2)>>2]=A;l=l+1|0}while((l|0)!=(e|0));return}function zmc(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(f|0)){u=t;break}else r=t}}else u=0.0;n[g+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;u=0.0;do{r=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);v=p|1;t=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|2;s=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|3;w=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);u=u+(r*r+t*t+s*s+w*w);p=p+4|0}while((p|0)<=(k|0));if(o){p=l;w=u;while(1){s=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);t=w+s*s;p=p+1|0;if((p|0)==(f|0)){x=t;break}else w=t}}else x=u;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(b[i+o>>0]|0){k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){w=+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0);t=x+w*w;p=p+1|0;if((p|0)==(f|0)){y=t;break}else x=t}}else y=0.0}else y=3402823466385288598117041.0e14;n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(b[i+l>>0]|0){p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{x=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);q=k|1;u=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|2;t=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|3;w=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);y=y+(x*x+u*u+t*t+w*w);k=k+4|0}while((k|0)<=(j|0));if(o){k=m;w=y;while(1){t=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);u=w+t*t;k=k+1|0;if((k|0)==(f|0)){z=u;break}else w=u}}else z=y}else z=3402823466385288598117041.0e14;n[g+(l<<2)>>2]=z;l=l+1|0}while((l|0)!=(e|0));return}function Amc(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=(e|0)>0;if(!j){if(!k)return;l=g+-4|0;m=g&-4;if((g|0)<4){n=(g|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(n){q=0;r=0;while(1){s=(h[a+q>>0]|0)-(h[p+q>>0]|0)|0;t=(Y(s,s)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){u=t;break}else r=t}}else u=0;f[i+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(g|0);u=0;do{n=c+(Y(u,d)|0)|0;r=0;q=0;do{p=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;t=r|1;s=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|2;v=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|3;w=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;q=(Y(p,p)|0)+q+(Y(s,s)|0)+(Y(v,v)|0)+(Y(w,w)|0)|0;r=r+4|0}while((r|0)<=(l|0));if(o){r=m;w=q;while(1){v=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;s=(Y(v,v)|0)+w|0;r=r+1|0;if((r|0)==(g|0)){x=s;break}else w=s}}else x=q;f[i+(u<<2)>>2]=x;u=u+1|0}while((u|0)!=(e|0));return}if(!k)return;k=g+-4|0;u=g&-4;if((g|0)<4){x=(g|0)>0;m=0;do{if(b[j+m>>0]|0){o=c+(Y(m,d)|0)|0;if(x){l=0;w=0;while(1){r=(h[a+l>>0]|0)-(h[o+l>>0]|0)|0;n=(Y(r,r)|0)+w|0;l=l+1|0;if((l|0)==(g|0)){y=n;break}else w=n}}else y=0}else y=2147483647;f[i+(m<<2)>>2]=y;m=m+1|0}while((m|0)!=(e|0));return}m=(u|0)<(g|0);y=0;do{if(b[j+y>>0]|0){x=c+(Y(y,d)|0)|0;w=0;l=0;do{o=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;q=w|1;n=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|2;r=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|3;s=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;l=(Y(o,o)|0)+l+(Y(n,n)|0)+(Y(r,r)|0)+(Y(s,s)|0)|0;w=w+4|0}while((w|0)<=(k|0));if(m){w=u;s=l;while(1){r=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;n=(Y(r,r)|0)+s|0;w=w+1|0;if((w|0)==(g|0)){z=n;break}else s=n}}else z=l}else z=2147483647;f[i+(y<<2)>>2]=z;y=y+1|0}while((y|0)!=(e|0));return}function Bmc(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=r+ +L(+(+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0)));q=q+1|0;if((q|0)==(f|0)){t=s;break}else r=s}}else t=0.0;n[g+(o<<2)>>2]=t;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;t=0.0;do{u=p|1;v=p|2;w=p|3;t=t+(+L(+(+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0)))+ +L(+(+((h[a+u>>0]|0)-(h[q+u>>0]|0)|0)))+ +L(+(+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0)))+ +L(+(+((h[a+w>>0]|0)-(h[q+w>>0]|0)|0))));p=p+4|0}while((p|0)<=(k|0));if(o){p=l;r=t;while(1){s=r+ +L(+(+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0)));p=p+1|0;if((p|0)==(f|0)){x=s;break}else r=s}}else x=t;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(b[i+o>>0]|0){k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){r=x+ +L(+(+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0)));p=p+1|0;if((p|0)==(f|0)){y=r;break}else x=r}}else y=0.0}else y=3402823466385288598117041.0e14;n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(b[i+l>>0]|0){p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{q=k|1;w=k|2;v=k|3;y=y+(+L(+(+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0)))+ +L(+(+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0)))+ +L(+(+((h[a+w>>0]|0)-(h[p+w>>0]|0)|0)))+ +L(+(+((h[a+v>>0]|0)-(h[p+v>>0]|0)|0))));k=k+4|0}while((k|0)<=(j|0));if(o){k=m;x=y;while(1){t=x+ +L(+(+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0)));k=k+1|0;if((k|0)==(f|0)){z=t;break}else x=t}}else z=y}else z=3402823466385288598117041.0e14;n[g+(l<<2)>>2]=z;l=l+1|0}while((l|0)!=(e|0));return}function Cmc(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=(e|0)>0;if(!j){if(!k)return;l=g+-4|0;m=g&-4;if((g|0)<4){n=(g|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(n){q=0;r=0;while(1){s=(h[a+q>>0]|0)-(h[p+q>>0]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(g|0)){u=t;break}else r=t}}else u=0;f[i+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(g|0);u=0;do{n=c+(Y(u,d)|0)|0;r=0;q=0;do{p=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;t=r|1;s=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|2;v=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|3;w=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;q=((p|0)>-1?p:0-p|0)+q+((s|0)>-1?s:0-s|0)+((v|0)>-1?v:0-v|0)+((w|0)>-1?w:0-w|0)|0;r=r+4|0}while((r|0)<=(l|0));if(o){r=m;w=q;while(1){v=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;s=((v|0)>-1?v:0-v|0)+w|0;r=r+1|0;if((r|0)==(g|0)){x=s;break}else w=s}}else x=q;f[i+(u<<2)>>2]=x;u=u+1|0}while((u|0)!=(e|0));return}if(!k)return;k=g+-4|0;u=g&-4;if((g|0)<4){x=(g|0)>0;m=0;do{if(b[j+m>>0]|0){o=c+(Y(m,d)|0)|0;if(x){l=0;w=0;while(1){r=(h[a+l>>0]|0)-(h[o+l>>0]|0)|0;n=((r|0)>-1?r:0-r|0)+w|0;l=l+1|0;if((l|0)==(g|0)){y=n;break}else w=n}}else y=0}else y=2147483647;f[i+(m<<2)>>2]=y;m=m+1|0}while((m|0)!=(e|0));return}m=(u|0)<(g|0);y=0;do{if(b[j+y>>0]|0){x=c+(Y(y,d)|0)|0;w=0;l=0;do{o=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;q=w|1;n=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|2;r=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|3;s=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;l=((o|0)>-1?o:0-o|0)+l+((n|0)>-1?n:0-n|0)+((r|0)>-1?r:0-r|0)+((s|0)>-1?s:0-s|0)|0;w=w+4|0}while((w|0)<=(k|0));if(m){w=u;s=l;while(1){r=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;n=((r|0)>-1?r:0-r|0)+s|0;w=w+1|0;if((w|0)==(g|0)){z=n;break}else s=n}}else z=l}else z=2147483647;f[i+(y<<2)>>2]=z;y=y+1|0}while((y|0)!=(e|0));return}function Dmc(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(d)j=0;else return;do{k=+M(+(+OO(a,c+((Y(j,i)|0)<<2)|0,f)));n[g+(j<<2)>>2]=k;j=j+1|0}while((j|0)!=(e|0));return}if(d)l=0;else return;do{if(!(b[h+l>>0]|0))m=3402823466385288598117041.0e14;else m=+M(+(+OO(a,c+((Y(l,i)|0)<<2)|0,f)));n[g+(l<<2)>>2]=m;l=l+1|0}while((l|0)!=(e|0));return}function Emc(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(d)j=0;else return;do{k=+OO(a,c+((Y(j,i)|0)<<2)|0,f);n[g+(j<<2)>>2]=k;j=j+1|0}while((j|0)!=(e|0));return}if(d)l=0;else return;do{if(!(b[h+l>>0]|0))m=3402823466385288598117041.0e14;else m=+OO(a,c+((Y(l,i)|0)<<2)|0,f);n[g+(l<<2)>>2]=m;l=l+1|0}while((l|0)!=(e|0));return}function Fmc(a){a=a|0;YDc(a);return}function Gmc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=u;u=u+1072|0;d=c;e=a+8|0;g=f[e>>2]|0;h=f[g+8>>2]|0;i=d+8|0;f[d>>2]=i;j=d+4|0;f[j>>2]=h;if(h>>>0>264){k=XDc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=k;l=k}else l=i;k=f[b>>2]|0;h=b+4|0;if((k|0)<(f[h>>2]|0)){b=a+32|0;m=a+4|0;n=a+24|0;o=a+20|0;p=a+16|0;q=a+12|0;r=a+28|0;a=k;k=g;while(1){g=f[m>>2]|0;s=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0;if((f[n>>2]|0)>0)t=l;else{g=f[q>>2]|0;t=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0}g=f[o>>2]|0;v=f[g+16>>2]|0;if(!v)w=0;else w=v+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0;Ii[f[b>>2]&127](s,f[k+16>>2]|0,f[k+48>>2]|0,f[k+8>>2]|0,f[k+12>>2]|0,t,w);s=f[n>>2]|0;a:do if((s|0)>0?(g=f[p>>2]|0,v=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0,g=f[q>>2]|0,x=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0,g=(f[e>>2]|0)+8|0,y=f[g>>2]|0,(y|0)>0):0){z=0;A=y;y=s;while(1){B=f[l+(z<<2)>>2]|0;C=y+-1|0;if((B|0)<(f[x+(C<<2)>>2]|0)){D=y+-2|0;b:do if((D|0)>-1){E=D;F=C;while(1){G=x+(E<<2)|0;if((f[G>>2]|0)<=(B|0)){H=F;break b}f[v+(F<<2)>>2]=f[v+(E<<2)>>2];f[x+(F<<2)>>2]=f[G>>2];if((E|0)>0){G=E;E=E+-1|0;F=G}else{H=E;break}}}else H=C;while(0);f[v+(H<<2)>>2]=(f[r>>2]|0)+z;f[x+(H<<2)>>2]=B;I=f[g>>2]|0}else I=A;C=z+1|0;if((C|0)>=(I|0))break a;z=C;A=I;y=f[n>>2]|0}}while(0);s=a+1|0;if((s|0)>=(f[h>>2]|0))break;a=s;k=f[e>>2]|0}J=f[d>>2]|0}else J=l;if((J|0)==(i|0)){u=c;return}if(J|0)ZDc(J);f[d>>2]=i;f[j>>2]=264;u=c;return}function Hmc(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0;a=u;u=u+16|0;c=a;if(b[529048]|0){u=a;return}if(!(MIc(529048)|0)){u=a;return}if((b[529056]|0)==0?MIc(529056)|0:0){x6(883568,508515,508532);be(1713,883568,x|0)|0}d=f[220892]|0;do if((((((d|0)!=508540?(e=(d|0)==0?1154740:d,!((d|0)==508549|(Ioc(e,508540)|0)==0)):0)?!((d|0)==508558|(Ioc(e,508549)|0)==0):0)?!((d|0)==508560|(Ioc(e,508558)|0)==0):0)?!((d|0)==508564|(Ioc(e,508560)|0)==0):0)?(Ioc(e,508564)|0)!=0:0)if(((d|0)!=508568?!((d|0)==508574|(Ioc(e,508568)|0)==0):0)?(Ioc(e,508574)|0)!=0:0)if(((d|0)!=508580?!((d|0)==508586|(Ioc(e,508580)|0)==0):0)?(Ioc(e,508586)|0)!=0:0)if((((d|0)!=508532?!((d|0)==508592|(Ioc(e,508532)|0)==0):0)?!((d|0)==508600|(Ioc(e,508592)|0)==0):0)?!((d|0)==508609|(Ioc(e,508600)|0)==0):0){if((d|0)==508618|(Ioc(e,508609)|0)==0){g=3;break}if((d|0)==508623|(Ioc(e,508618)|0)==0){g=3;break}if(!(Ioc(e,508623)|0)){g=3;break}if((d|0)==508628){g=4;break}if((d|0)==508633|(Ioc(e,508628)|0)==0){g=4;break}if(!(Ioc(e,508633)|0)){g=4;break}if((d|0)==508638){g=5;break}if((d|0)==508644|(Ioc(e,508638)|0)==0){g=5;break}if(!(Ioc(e,508644)|0)){g=5;break}if((d|0)==508650){g=6;break}if((d|0)==508658|(Ioc(e,508650)|0)==0){g=6;break}if(!(Ioc(e,508658)|0)){g=6;break}e=H1(884536,508666,39)|0;h=f[220892]|0;i=(h|0)==0?1154740:h;h=H1(e,i,Mpc(i)|0)|0;cuc(c,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);i=Hvc(c,885240)|0;e=Mi[f[(f[i>>2]|0)+28>>2]&1023](i,10)|0;Ivc(c);wuc(h,e)|0;iuc(h)|0;g=4}else g=3;else g=2;else g=1;else g=0;while(0);f[220891]=g;u=a;return}function Imc(){Hmc();return f[220891]|0}function Jmc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+160|0;e=d+136|0;g=d;h=p6()|0;i=g+56|0;j=g+4|0;f[g>>2]=7676;f[i>>2]=7696;auc(g+56|0,j);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=46080;f[i>>2]=46100;fuc(j);f[j>>2]=45740;i=g+36|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G1(j,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);switch(a|0){case 1:{i=H1(H1(suc(H1(g,508706,7)|0,h)|0,508714,2)|0,c,Mpc(c)|0)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);k=Hvc(e,885240)|0;l=Mi[f[(f[k>>2]|0)+28>>2]&1023](k,10)|0;Ivc(e);wuc(i,l)|0;iuc(i)|0;break}case 2:{i=H1(H1(suc(H1(g,508717,7)|0,h)|0,508714,2)|0,c,Mpc(c)|0)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);l=Hvc(e,885240)|0;k=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,10)|0;Ivc(e);wuc(i,k)|0;iuc(i)|0;break}case 3:{i=H1(H1(suc(H1(g,508725,7)|0,h)|0,508714,2)|0,c,Mpc(c)|0)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);k=Hvc(e,885240)|0;l=Mi[f[(f[k>>2]|0)+28>>2]&1023](k,10)|0;Ivc(e);wuc(i,l)|0;iuc(i)|0;break}case 4:{i=H1(H1(suc(H1(g,508733,7)|0,h)|0,508714,2)|0,c,Mpc(c)|0)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);l=Hvc(e,885240)|0;k=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,10)|0;Ivc(e);wuc(i,k)|0;iuc(i)|0;break}case 5:{i=H1(H1(suc(H1(g,508741,7)|0,h)|0,508714,2)|0,c,Mpc(c)|0)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);h=Hvc(e,885240)|0;k=Mi[f[(f[h>>2]|0)+28>>2]&1023](h,10)|0;Ivc(e);wuc(i,k)|0;iuc(i)|0;break}case 6:{i=H1(g,c,Mpc(c)|0)|0;cuc(e,i+(f[(f[i>>2]|0)+-12>>2]|0)|0);c=Hvc(e,885240)|0;k=Mi[f[(f[c>>2]|0)+28>>2]&1023](c,10)|0;Ivc(e);wuc(i,k)|0;iuc(i)|0;break}default:{D3(g);u=d;return}}i=(a|0)<4;a=i?884536:884368;I1(e,j);j=e+11|0;k=b[j>>0]|0;c=k<<24>>24<0;H1(a,c?f[e>>2]|0:e,c?f[e+4>>2]|0:k&255)|0;if((b[j>>0]|0)<0)YDc(f[e>>2]|0);if(!i){D3(g);u=d;return}iuc(a)|0;D3(g);u=d;return}function Kmc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!(b&2147483647)){c=b>>31&-822083584;f[a>>2]=c;return}d=(b|0)<0?0-b|0:b;e=d>>>0<65536;g=e?d<<16:d;i=e?16:0;e=g>>>0<16777216;j=((h[508749+((e?g<<8:g)>>>24)>>0]|0)+((e?i|8:i)&255)<<24)+-16777216|0;i=j>>24;e=156-i|0;if((j|0)>100663296&e>>>0<253){c=(d<<i+-7)+(b&-2147483648)+(b|0?e<<23:0)|0;f[a>>2]=c;return}j=d<<i;i=j&127;do if(e>>>0>252){if((e|0)>=0){if(!((e|0)>253|(j+64|0)<0)){k=e;l=i;m=j;break}c=b&-2147483648|2139095040;f[a>>2]=c;return}d=0-e|0;if(d>>>0<31)n=(j<<(e&31)|0)!=0|j>>>d;else n=(j|0)!=0&1;k=0;l=n&127;m=n}else{k=e;l=i;m=j}while(0);j=(m+64|0)>>>7&~(l<<24>>24==64);c=((j|0)==0?0:k<<23)+(j|b&-2147483648)|0;f[a>>2]=c;return}function Lmc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[b>>2]|0;b=c>>>23;d=c&8388607;a:do switch((b&255)<<24>>24){case -1:{e=c>>>31;if(!d){g=jJc(e|0,0,63)|0;i=g;j=J|2146435072;break a}else{g=jJc(e|0,0,63)|0;e=J;k=jJc(c|0,0,29)|0;i=k|g;j=J|e|2146959360;break a}break}case 0:{if(!d){e=jJc(c>>>31|0,0,63)|0;i=e;j=J;break a}else{e=d>>>0<65536;g=e?c<<16:d;k=e?16:0;e=g>>>0<16777216;l=((h[508749+((e?g<<8:g)>>>24)>>0]|0)+((e?k|8:k)&255)<<24)+-134217728>>24;m=0-l|0;n=d<<l;o=8;break a}break}default:{m=b&255;n=d;o=8}}while(0);if((o|0)==8){o=jJc(c>>>31|0,0,63)|0;c=J;d=jJc(m+896|0,0,52)|0;m=J;b=jJc(n|0,0,29)|0;n=UIc(d|0,m|0,b|o|0,J|c|0)|0;i=n;j=J}n=a;f[n>>2]=i;f[n+4>>2]=j;return}function Mmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;b=f[c>>2]|0;if((b^d|0)<0){Nmc(a,d,b);return}else{Omc(a,d,b);return}}function Nmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=b>>>23&255;e=b&8388607;g=c>>>23&255;i=c&8388607;j=d-g|0;a:do if(!j){if((d|0)==255){if(!(i|e))k=-4194304;else break;f[a>>2]=k;return}l=e-i|0;if(!l){k=0;f[a>>2]=k;return}m=(d|0)==0?0:d+-1|0;n=(l|0)<0;o=n?0-l|0:l;l=o>>>0<65536;p=l?o<<16:o;q=l?16:0;l=p>>>0<16777216;r=((h[508749+((l?p<<8:p)>>>24)>>0]|0)+((l?q|8:q)&255)&255)+248|0;q=m-(r<<24>>24)|0;l=(q|0)<0;k=(l?0:q<<23)+(((n?(b|0)>-1:(b|0)<0)&1)<<31)+(o<<((l?m:r)<<24>>24))|0;f[a>>2]=k;return}else{r=e<<7;m=i<<7;do if((j|0)<0){if((g|0)!=255){s=(d|0?1073741824:r)+r|0;t=m;u=0-j|0;v=g;w=(b|0)>-1;break}if(i|0)break a;k=(b&-2147483648)+-8388608|0;f[a>>2]=k;return}else{if((d|0)!=255){s=(g|0?1073741824:m)+m|0;t=r;u=j;v=d;w=(b|0)<0;break}if(!e)k=b;else break a;f[a>>2]=k;return}while(0);if(u>>>0<31)x=(s<<(0-u&31)|0)!=0|s>>>u;else x=(s|0)!=0&1;r=(t|1073741824)-x|0;m=r>>>0<65536;l=m?r<<16:r;o=m?16:0;m=l>>>0<16777216;n=(((m?o|8:o)&255)+(h[508749+((m?l<<8:l)>>>24)>>0]|0)<<24)+-16777216|0;l=n>>24;m=v+-1-l|0;if((n|0)>100663296&m>>>0<253){k=(r<<l+-7)+((w&1)<<31)+(r|0?m<<23:0)|0;f[a>>2]=k;return}n=r<<l;l=n&127;do if(m>>>0>252){if((m|0)>=0){if(!((m|0)>253|(n+64|0)<0)){y=m;z=l;A=n;break}k=(w&1)<<31|2139095040;f[a>>2]=k;return}r=0-m|0;if(r>>>0<31)B=(n<<(m&31)|0)!=0|n>>>r;else B=(n|0)!=0&1;y=0;z=B&127;A=B}else{y=m;z=l;A=n}while(0);n=(A+64|0)>>>7&~(z<<24>>24==64);k=((n|0)==0?0:y<<23)+(n|(w&1)<<31)|0;f[a>>2]=k;return}while(0);k=((b&2143289344|0)==2139095040&(b&4194303|0)!=0?b:(b&2139095040|0)!=2139095040|(e|0)==0?c:b)|4194304;f[a>>2]=k;return}function Omc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=b>>>23;e=d&255;g=b&8388607;h=c>>>23;i=h&255;j=c&8388607;k=e-i|0;a:do if(!k)switch((d&255)<<24>>24){case 0:{l=j+b|0;f[a>>2]=l;return}case -1:{if(!(j|g))l=b;else{m=30;break a}f[a>>2]=l;return}default:{n=(g|16777216)+j|0;if(!(e>>>0<254&(c+b&1|0)==0)){o=n<<6;p=e;break a}l=(e<<23|b&-2147483648)+(n>>>1)|0;f[a>>2]=l;return}}else{n=g<<6;q=j<<6;do if((k|0)<0)if((i|0)!=255){r=(e|0?536870912:n)+n|0;s=0-k|0;if(s>>>0<31){t=i;u=(r<<(d-h&31)|0)!=0|r>>>s;v=q;break}else{t=i;u=(r|0)!=0&1;v=q;break}}else{if(j|0){m=30;break a}l=b&-2147483648|2139095040;f[a>>2]=l;return}else{if((e|0)==255){if(!g)l=b;else{m=30;break a}f[a>>2]=l;return}r=(i|0?536870912:q)+q|0;if(k>>>0<31){t=e;u=n;v=(r<<(0-k&31)|0)!=0|r>>>k;break}else{t=e;u=n;v=(r|0)!=0&1;break}}while(0);n=v+536870912+u|0;q=n>>>0<1073741824;o=n<<(q&1);p=(q<<31>>31)+t|0}while(0);if((m|0)==30){l=((b&2143289344|0)==2139095040&(b&4194303|0)!=0?b:(b&2139095040|0)!=2139095040|(g|0)==0?c:b)|4194304;f[a>>2]=l;return}c=o&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(o+64|0)<0)){w=p;x=c;y=o;break}l=b&-2147483648|2139095040;f[a>>2]=l;return}g=0-p|0;if(g>>>0<31)z=(o<<(p&31)|0)!=0|o>>>g;else z=(o|0)!=0&1;w=0;x=z&127;y=z}else{w=p;x=c;y=o}while(0);o=(y+64|0)>>>7&~(x<<24>>24==64);l=((o|0)==0?0:w<<23)+(o|b&-2147483648)|0;f[a>>2]=l;return}function Pmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;b=f[c>>2]|0;if((b^d|0)<0){Omc(a,d,b);return}else{Nmc(a,d,b);return}}function Qmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=f[b>>2]|0;b=f[c>>2]|0;c=d>>>23&255;e=d&8388607;g=b>>>23&255;i=b&8388607;j=b^d;do if((c|0)==255)if((e|0)==0?!((i|0)!=0&(g|0)==255):0){k=g|i;l=24}else l=23;else{if((g|0)==255){if(i|0){l=23;break}k=c|e;l=24;break}if(!c){if(e|0){m=e>>>0<65536;n=m?d<<16:e;o=m?16:0;m=n>>>0<16777216;p=((h[508749+((m?n<<8:n)>>>24)>>0]|0)+((m?o|8:o)&255)<<24)+-134217728>>24;q=1-p|0;r=e<<p;l=11}}else{q=c;r=e;l=11}do if((l|0)==11){if(!g){if(!i)break;p=i>>>0<65536;o=p?b<<16:i;m=p?16:0;p=o>>>0<16777216;n=((h[508749+((p?o<<8:o)>>>24)>>0]|0)+((p?m|8:m)&255)<<24)+-134217728>>24;s=i<<n;t=1-n|0}else{s=i;t=g}n=mJc(s<<8|-2147483648|0,0,r<<7|1073741824|0,0)|0;m=((n&-32768|0)!=0|0!=0)&1|J;n=m>>>0<1073741824;p=t+q+(n?-128:-127)|0;o=m<<(n&1);n=o&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(o+64|0)<0)){u=p;v=n;w=o;break}x=j&-2147483648|2139095040;f[a>>2]=x;return}m=0-p|0;if(m>>>0<31)y=(o<<(p&31)|0)!=0|o>>>m;else y=(o|0)!=0&1;u=0;v=y&127;w=y}else{u=p;v=n;w=o}while(0);o=(w+64|0)>>>7&~(v<<24>>24==64);x=((o|0)==0?0:u<<23)+(o|j&-2147483648)|0;f[a>>2]=x;return}while(0);x=j&-2147483648;f[a>>2]=x;return}while(0);if((l|0)==23){x=((d&2143289344|0)==2139095040&(d&4194303|0)!=0?d:(d&2139095040|0)!=2139095040|(e|0)==0?b:d)|4194304;f[a>>2]=x;return}else if((l|0)==24){x=(k|0)==0?-4194304:j&-2147483648|2139095040;f[a>>2]=x;return}}function Rmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[b>>2]|0;b=f[c>>2]|0;c=d>>>23&255;e=d&8388607;g=b>>>23;i=g&255;j=b&8388607;k=b^d;a:do if((c|0)==255)if(!e)if((i|0)==255)if(!j){l=-4194304;f[a>>2]=l;return}else m=22;else m=23;else m=22;else{b:do switch((g&255)<<24>>24){case -1:{if(j|0){m=22;break a}break}case 0:{if(j|0){n=j>>>0<65536;o=n?b<<16:j;p=n?16:0;n=o>>>0<16777216;q=((h[508749+((n?o<<8:o)>>>24)>>0]|0)+((n?p|8:p)&255)<<24)+-134217728>>24;r=j<<q;s=1-q|0;m=10;break b}if(!(c|e))l=-4194304;else{m=23;break a}f[a>>2]=l;return}default:{r=j;s=i;m=10}}while(0);do if((m|0)==10){if(!c){if(!e)break;q=e>>>0<65536;p=q?d<<16:e;n=q?16:0;q=p>>>0<16777216;o=((h[508749+((q?p<<8:p)>>>24)>>0]|0)+((q?n|8:n)&255)<<24)+-134217728>>24;t=1-o|0;u=e<<o}else{t=c;u=e}o=u|8388608;n=r|8388608;q=o>>>0<n>>>0;p=(q?125:126)+(t-s)|0;v=jJc(o|0,0,(q?31:30)|0)|0;q=J;o=cJc(v|0,q|0,n|0,0)|0;w=mJc(o|0,0,n|0,0)|0;n=(o&63|0)==0&((w|0)!=(v|0)|(J|0)!=(q|0))&1|o;o=n&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(n+64|0)<0)){x=p;y=o;z=n;break}l=k&-2147483648|2139095040;f[a>>2]=l;return}q=0-p|0;if(q>>>0<31)A=(n<<(p&31)|0)!=0|n>>>q;else A=(n|0)!=0&1;x=0;y=A&127;z=A}else{x=p;y=o;z=n}while(0);n=(z+64|0)>>>7&~(y<<24>>24==64);l=((n|0)==0?0:x<<23)+(n|k&-2147483648)|0;f[a>>2]=l;return}while(0);l=k&-2147483648;f[a>>2]=l;return}while(0);if((m|0)==22){l=((d&2143289344|0)==2139095040&(d&4194303|0)!=0?d:(d&2139095040|0)!=2139095040|(e|0)==0?b:d)|4194304;f[a>>2]=l;return}else if((m|0)==23){l=k&-2147483648|2139095040;f[a>>2]=l;return}}function Smc(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[b>>2]|0;b=f[a>>2]|0;if(!((c&2139095040|0)!=2139095040|(c&8388607|0)==0)){d=0;return d|0}if(!((b&2139095040|0)!=2139095040|(b&8388607|0)==0)){d=0;return d|0}a=c>>>31;if((a|0)==(b>>>31|0)){d=(c|0)!=(b|0)&(a|0)!=(c>>>0<b>>>0|0);return d|0}else{d=(c|0)<0&((b|c)&2147483647|0)!=0;return d|0}return 0}function Tmc(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a>>2]|0;a=f[b>>2]|0;if(!((c&2139095040|0)!=2139095040|(c&8388607|0)==0)){d=0;return d|0}if(!((a&2139095040|0)!=2139095040|(a&8388607|0)==0)){d=0;return d|0}b=c>>>31;if((b|0)==(a>>>31|0)){d=(c|0)!=(a|0)&(b|0)!=(c>>>0<a>>>0|0);return d|0}else{d=(c|0)<0&((a|c)&2147483647|0)!=0;return d|0}return 0}function Umc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=(e|0)==0;i=g?32:0;j=g?d:e;g=j>>>0<65536;k=g?i|16:i;i=g?j<<16:j;j=i>>>0<16777216;g=((h[508749+((j?i<<8:i)>>>24)>>0]|0)+((j?k|8:k)&255)<<24)+-16777216|0;k=g>>24;j=c-k|0;if((g|0)>150994944&j>>>0<2045){g=jJc(b&1|0,0,63)|0;c=J;i=(d|0)!=0|(e|0)!=0;l=jJc(j|0,0,52)|0;m=i?J:0;n=jJc(d|0,e|0,k+-10|0)|0;o=UIc(n|0,J|0,g|0,c|0)|0;c=UIc(o|0,J|0,(i?l:0)|0,m|0)|0;p=J;q=c;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}c=jJc(d|0,e|0,k|0)|0;k=J;e=c&1023;do if((j&65535)>>>0>2044){if((j|0)>=0){UIc(c|0,k|0,512,0)|0;if(!((j|0)>2045|(J|0)<0)){v=j;w=e;x=c;y=k;break}d=jJc(b&1|0,0,63)|0;p=J|2146435072;q=d;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}d=0-j|0;if(d>>>0<63){m=aJc(c|0,k|0,d|0)|0;d=J;l=jJc(c|0,k|0,j&63|0)|0;z=d;A=((l|0)!=0|(J|0)!=0)&1|m}else{z=0;A=((c|0)!=0|(k|0)!=0)&1}v=0;w=A&1023;x=A;y=z}else{v=j;w=e;x=c;y=k}while(0);k=UIc(x|0,y|0,512,0)|0;y=aJc(k|0,J|0,10)|0;k=J;x=y&~((w|0)==512);w=(x|0)==0&(k|0)==0;y=jJc(b&1|0,0,63)|0;b=J;c=jJc(v|0,0,52)|0;v=UIc((w?0:c)|0,(w?0:J)|0,x|y|0,k|b|0)|0;p=J;q=v;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}function Vmc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!b){c=0;d=0;e=a;g=e;f[g>>2]=c;i=e+4|0;j=i;f[j>>2]=d;return}k=(b|0)<0?0-b|0:b;l=k>>>0<65536;m=l?k<<16:k;n=l?16:0;l=m>>>0<16777216;o=(h[508749+((l?m<<8:m)>>>24)>>0]|0)+((l?n|8:n)&255)|0;n=jJc(b>>>31|0,0,63)|0;b=J;l=(o<<24)+352321536>>24;o=jJc(1074-l|0,0,52)|0;m=J;p=jJc(k|0,0,l|0)|0;l=UIc(p|0,J|0,n|0,b|0)|0;b=UIc(l|0,J|0,o|0,m|0)|0;c=b;d=J;e=a;g=e;f[g>>2]=c;i=e+4|0;j=i;f[j>>2]=d;return}function Wmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=(c|0)<0;if((b|0)==0&(c&2147483647|0)==0){$Ic(b|0,c|0,63)|0;h=e;f[h>>2]=0;f[h+4>>2]=J&-1008730112}else{h=TIc(0,0,b|0,c|0)|0;Umc(e,g,1084,g?h:b,g?J:c)}if((e|0)==(a|0)){u=d;return}c=e;e=f[c+4>>2]|0;g=a;f[g>>2]=f[c>>2];f[g+4>>2]=e;u=d;return}function Xmc(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;a=b>>>23&255;c=158-a|0;if((c|0)>31){d=0;return d|0}if((c|0)<1){d=(b|0)==-822083584?-2147483648:(b&8388607|0)!=0&(a|0)==255?2147483647:(b>>>31)+2147483647|0;return d|0}else{a=(b<<8|-2147483648)>>>c;d=(b|0)<0?0-a|0:a;return d|0}return 0}function Ymc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;a=b>>>23&255;c=b&8388607;d=(b|0)<0&((c|0)==0|(a|0)!=255);b=(a|0)==0?c:c|8388608;c=170-a|0;do if((c|0)>0)if(c>>>0<63){a=aJc(0,b|0,c|0)|0;e=J;g=jJc(0,b|0,0-c&63|0)|0;h=((g|0)!=0|(J|0)!=0)&1|a;i=e;break}else{h=(b|0)!=0&1;i=0;break}else{h=0;i=b}while(0);b=UIc(h|0,i|0,2048,0)|0;i=J;if(!(i>>>0>4095|(i|0)==4095&b>>>0>4294967295)){c=aJc(b|0,i|0,12)|0;i=(h&4095|0)==2048&0==0&1;h=d?(i|~c)+1|0:c&~i;if(!h){j=0;return j|0}if((h>>>31|0)==(d&1|0)){j=h;return j|0}}j=d?-2147483648:2147483647;return j|0}function Zmc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=aJc(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1063-d|0;do if((b|0)>0)if(b>>>0<63){d=aJc(g|0,a|0,b|0)|0;c=J;h=jJc(g|0,a|0,0-b&63|0)|0;i=((h|0)!=0|(J|0)!=0)&1|d;j=c;break}else{i=((g|0)!=0|(a|0)!=0)&1;j=0;break}else{i=g;j=a}while(0);a=UIc(i|0,j|0,2048,0)|0;j=J;if(!(j>>>0>4095|(j|0)==4095&a>>>0>4294967295)){g=aJc(a|0,j|0,12)|0;j=(i&4095|0)==2048&0==0&1;i=e?(j|~g)+1|0:g&~j;if(!i){k=0;return k|0}if((i>>>31|0)==(e&1|0)){k=i;return k|0}}k=e?-2147483648:2147483647;return k|0}function _mc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=aJc(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1063-d|0;do if((b|0)>0)if(b>>>0<63){d=aJc(g|0,a|0,b|0)|0;c=J;h=jJc(g|0,a|0,0-b&63|0)|0;i=((h|0)!=0|(J|0)!=0)&1|d;j=c;break}else{i=((g|0)!=0|(a|0)!=0)&1;j=0;break}else{i=g;j=a}while(0);a=UIc(i|0,j|0,(e?4095:0)|0,(e?0:0)|0)|0;j=J;if(!(j>>>0>4095|(j|0)==4095&a>>>0>4294967295)){i=aJc(a|0,j|0,12)|0;j=e?0-i|0:i;if(!j){k=0;return k|0}if((j>>>31|0)==(e&1|0)){k=j;return k|0}}k=e?-2147483648:2147483647;return k|0}function $mc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=aJc(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1075-d|0;if((b|0)<1){d=jJc(g|0,a|0,0-b|0)|0;c=J;if((b|0)<-11|(c|0)<0){h=e?-2147483648:2147483647;i=e?0:-1;J=h;return i|0}else{j=TIc(0,0,d|0,c|0)|0;h=e?J:c;i=e?j:d;J=h;return i|0}}if((b|0)>=64){h=0;i=0;J=h;return i|0}d=aJc(g|0,a|0,b|0)|0;j=J;c=jJc(g|0,a|0,0-b&63|0)|0;b=J;if((b|0)<0){a=UIc(d|0,j|0,1,0)|0;g=J;if(!((a|0)==0&(g|0)==0)){k=a&~((c|0)==0&(b&2147483647|0)==0&1);l=g;m=9}}else{k=d;l=j;m=9}if((m|0)==9){m=TIc(0,0,k|0,l|0)|0;j=e?m:k;m=e?J:l;if((k|0)==0&(l|0)==0){h=m;i=j;J=h;return i|0}l=aJc(j|0,m|0,63)|0;if((l|0)==(e&1|0)){h=m;i=j;J=h;return i|0}}h=e?-2147483648:2147483647;i=e?0:-1;J=h;return i|0}function anc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=b;b=f[c>>2]|0;d=f[c+4>>2]|0;c=aJc(b|0,d|0,52)|0;e=c&2047;g=d&1048575;if((e|0)==2047){h=d&-2147483648;if((b|0)==0&(g|0)==0){i=h|2139095040;f[a>>2]=i;return}else{j=aJc(b|0,d|0,29)|0;i=h|2143289344|j&8388607;f[a>>2]=i;return}}j=aJc(b|0,g|0,22)|0;g=((b&4194303|0)!=0|0!=0)&1|j;if(!(g|e)){i=d&-2147483648;f[a>>2]=i;return}j=e+-897|0;b=g|1073741824;h=g&127;do if(j>>>0>252){if(e>>>0<897){g=897-e|0;k=g>>>0<31?(b<<(c+31&31)|0)!=0|b>>>g:1;l=0;m=k&127;n=k;break}if((j|0)>253|(b+64|0)<0){i=d&-2147483648|2139095040;f[a>>2]=i;return}else{l=j;m=h;n=b}}else{l=j;m=h;n=b}while(0);b=(n+64|0)>>>7&~(m<<24>>24==64);i=((b|0)==0?0:l<<23)+(b|d&-2147483648)|0;f[a>>2]=i;return}function bnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=(e|0)<0;h=aJc(b|0,e|0,63)|0;i=aJc(c|0,g|0,63)|0;if((h|0)==(i|0)){cnc(a,b,e,c,g,d);return}else{dnc(a,b,e,c,g,d);return}}function cnc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=aJc(b|0,c|0,52)|0;i=h&2047;j=c&1048575;k=aJc(d|0,e|0,52)|0;l=k&2047;m=e&1048575;n=i-l|0;a:do if(!n)switch(h&2047){case 0:{o=UIc(d|0,m|0,b|0,c|0)|0;p=J;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}case 2047:{if((d|b|0)==0&(m|j|0)==0){o=b;p=c}else{u=28;break a}q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}default:{v=i;w=jJc(UIc(b|0,j|2097152|0,d|0,m|0)|0,J|0,9)|0;x=J;break a}}else{y=jJc(b|0,j|0,9)|0;z=J;A=jJc(d|0,m|0,9)|0;B=J;do if((n|0)<0)if((l|0)!=2047){C=(i|0)==0;D=jJc(b|0,j|0,10)|0;E=C?D:y;D=C?J:z|536870912;C=0-n|0;if(C>>>0<63){F=aJc(E|0,D|0,C|0)|0;C=J;G=jJc(E|0,D|0,h-k&63|0)|0;H=l;I=A;K=B;L=((G|0)!=0|(J|0)!=0)&1|F;M=C;break}else{H=l;I=A;K=B;L=((E|0)!=0|(D|0)!=0)&1;M=0;break}}else{if(!((d|0)==0&(m|0)==0)){u=28;break a}D=jJc(g&1|0,0,63)|0;o=D;p=J|2146435072;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}else{if((i|0)==2047){if((b|0)==0&(j|0)==0){o=b;p=c}else{u=28;break a}q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}D=(l|0)==0;E=jJc(d|0,m|0,10)|0;C=D?E:A;E=D?J:B|536870912;if(n>>>0<63){D=aJc(C|0,E|0,n|0)|0;F=J;G=jJc(C|0,E|0,0-n&63|0)|0;H=i;I=((G|0)!=0|(J|0)!=0)&1|D;K=F;L=y;M=z;break}else{H=i;I=((C|0)!=0|(E|0)!=0)&1;K=0;L=y;M=z;break}}while(0);z=UIc(I|0,K|0,0,536870912)|0;y=UIc(z|0,J|0,L|0,M|0)|0;z=J;B=z>>>0<1073741824|(z|0)==1073741824&y>>>0<0;A=jJc(y|0,z|0,B&1|0)|0;v=(B<<31>>31)+H|0;w=A;x=J}while(0);if((u|0)==28){u=0==0&(c&2146959360|0)==2146435072&((b|0)!=0|(c&524287|0)!=0);H=0!=0|(c&2146435072|0)!=2146435072|(b|0)==0&(j|0)==0;o=u?b:H?d:b;p=(u?c:H?e:c)|524288;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}c=w&1023;do if((v&65535)>>>0>2044){if((v|0)>=0){UIc(w|0,x|0,512,0)|0;if(!((v|0)>2045|(J|0)<0)){N=v;O=c;P=w;Q=x;break}e=jJc(g&1|0,0,63)|0;o=e;p=J|2146435072;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}e=0-v|0;if(e>>>0<63){H=aJc(w|0,x|0,e|0)|0;e=J;u=jJc(w|0,x|0,v&63|0)|0;R=((u|0)!=0|(J|0)!=0)&1|H;S=e}else{R=((w|0)!=0|(x|0)!=0)&1;S=0}N=0;O=R&1023;P=R;Q=S}else{N=v;O=c;P=w;Q=x}while(0);x=UIc(P|0,Q|0,512,0)|0;Q=aJc(x|0,J|0,10)|0;x=J;P=Q&~((O|0)==512);O=(P|0)==0&(x|0)==0;Q=jJc(g&1|0,0,63)|0;g=J;w=jJc(N|0,0,52)|0;N=UIc((O?0:w)|0,(O?0:J)|0,P|Q|0,x|g|0)|0;o=N;p=J;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}function dnc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=aJc(b|0,c|0,52)|0;j=i&2047;k=c&1048575;l=aJc(d|0,e|0,52)|0;m=l&2047;n=e&1048575;o=j-m|0;a:do if(!o){if((j|0)==2047)if((d|b|0)==0&(n|k|0)==0){p=0;q=-524288;break}else{r=19;break}s=TIc(b|0,k|0,d|0,n|0)|0;t=J;if((s|0)==0&(t|0)==0){p=0;q=0}else{u=(j|0)==0?0:j+-1|0;v=(t|0)<0;w=TIc(0,0,s|0,t|0)|0;x=v?w:s;s=v?J:t;t=(s|0)==0;w=t?32:0;y=t?x:s;t=y>>>0<65536;z=t?w|16:w;w=t?y<<16:y;y=w>>>0<16777216;t=((h[508749+((y?w<<8:w)>>>24)>>0]|0)+((y?z|8:z)&255)&255)+245|0;z=u-(t<<24>>24)|0;y=(z|0)<0;w=jJc((v^g)&1|0,0,63)|0;v=J;A=jJc(z|0,0,52)|0;z=UIc((y?0:A)|0,(y?0:J)|0,w|0,v|0)|0;v=J;w=jJc(x|0,s|0,(y?u:t)<<24>>24|0)|0;t=UIc(z|0,v|0,w|0,J|0)|0;p=t;q=J}}else{t=jJc(b|0,k|0,10)|0;w=J;v=jJc(d|0,n|0,10)|0;z=J;do if((o|0)<0){u=g^1;if((m|0)==2047){if(!((d|0)==0&(n|0)==0)){r=19;break a}y=jJc(u&1|0,0,63)|0;p=y;q=J|2146435072;break a}y=(j|0)!=0;s=UIc((y?0:t)|0,(y?1073741824:w)|0,t|0,w|0)|0;y=J;x=0-o|0;if(x>>>0<63){A=aJc(s|0,y|0,x|0)|0;x=J;B=jJc(s|0,y|0,i-l&63|0)|0;C=m;D=u;E=z;F=v;G=((B|0)!=0|(J|0)!=0)&1|A;H=x;break}else{C=m;D=u;E=z;F=v;G=((s|0)!=0|(y|0)!=0)&1;H=0;break}}else{if((j|0)==2047)if((b|0)==0&(k|0)==0){p=b;q=c;break a}else{r=19;break a}y=(m|0)!=0;s=UIc((y?0:v)|0,(y?1073741824:z)|0,v|0,z|0)|0;y=J;if(o>>>0<63){u=aJc(s|0,y|0,o|0)|0;x=J;A=jJc(s|0,y|0,0-o&63|0)|0;C=j;D=g;E=w;F=t;G=((A|0)!=0|(J|0)!=0)&1|u;H=x;break}else{C=j;D=g;E=w;F=t;G=((s|0)!=0|(y|0)!=0)&1;H=0;break}}while(0);t=TIc(F|0,E|1073741824|0,G|0,H|0)|0;Umc(a,D,C+-1|0,t,J);return}while(0);if((r|0)==19){r=0==0&(c&2146959360|0)==2146435072&((b|0)!=0|(c&524287|0)!=0);C=0!=0|(c&2146435072|0)!=2146435072|(b|0)==0&(k|0)==0;p=r?b:C?d:b;q=(r?c:C?e:c)|524288}c=a;f[c>>2]=p;f[c+4>>2]=q;return}function enc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=(e|0)<0;h=aJc(b|0,e|0,63)|0;i=aJc(c|0,g|0,63)|0;if((h|0)==(i|0)){dnc(a,b,e,c,g,d);return}else{cnc(a,b,e,c,g,d);return}}function fnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=aJc(b|0,e|0,52)|0;i=d&2047;d=e&1048575;j=aJc(c|0,g|0,52)|0;k=j&2047;j=g&1048575;l=g^e;do if((i|0)==2047)if((b|0)==0&(d|0)==0?!(((c|0)!=0|(j|0)!=0)&(k|0)==2047):0){m=k;n=c;o=j;p=22}else p=21;else{if((k|0)==2047)if((c|0)==0&(j|0)==0){m=i;n=b;o=d;p=22;break}else{p=21;break}if(!i){if(!((b|0)==0&(d|0)==0)){q=(d|0)==0;r=q?32:0;s=q?b:d;q=s>>>0<65536;t=q?r|16:r;r=q?s<<16:s;s=r>>>0<16777216;q=((h[508749+((s?r<<8:r)>>>24)>>0]|0)+((s?t|8:t)&255)<<24)+-184549376>>24;t=jJc(b|0,d|0,q|0)|0;u=1-q|0;v=t;w=J;p=9}}else{u=i;v=b;w=d;p=9}do if((p|0)==9){if(!k){if((c|0)==0&(j|0)==0)break;t=(j|0)==0;q=t?32:0;s=t?c:j;t=s>>>0<65536;r=t?q|16:q;q=t?s<<16:s;s=q>>>0<16777216;t=((h[508749+((s?q<<8:q)>>>24)>>0]|0)+((s?r|8:r)&255)<<24)+-184549376>>24;r=jJc(c|0,j|0,t|0)|0;x=1-t|0;y=r;z=J}else{x=k;y=c;z=j}r=jJc(v|0,w|0,10)|0;t=jJc(y|0,z|0,11)|0;s=aJc(v|0,w|0,22)|0;q=s&-1073741825|1073741824;s=aJc(y|0,z|0,21)|0;A=s&2147483647|-2147483648;s=r&-1024;r=t&-2048;t=mJc(r|0,0,s|0,0)|0;B=J;C=mJc(r|0,0,q|0,0)|0;r=J;D=mJc(A|0,0,s|0,0)|0;s=UIc(D|0,J|0,C|0,r|0)|0;D=J;E=mJc(A|0,0,q|0,0)|0;q=UIc(D|0,(D>>>0<r>>>0|(D|0)==(r|0)&s>>>0<C>>>0)&1|0,E|0,J|0)|0;E=J;C=UIc(0,s|0,t|0,B|0)|0;B=J;t=UIc(q|0,E|0,(B>>>0<s>>>0|(B|0)==(s|0)&C>>>0<0)&1|0,0)|0;s=J;E=t|((C|0)!=0|(B|0)!=0)&1;B=s>>>0<1073741824|(s|0)==1073741824&E>>>0<0;C=x+u+(B?-1024:-1023)|0;t=jJc(E|0,s|0,B&1|0)|0;B=J;s=t&1023;do if((C&65535)>>>0>2044){if((C|0)>=0){UIc(t|0,B|0,512,0)|0;if(!((C|0)>2045|(J|0)<0)){F=C;G=s;H=t;I=B;break}K=0;L=l&-2147483648|2146435072;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}E=0-C|0;if(E>>>0<63){q=aJc(t|0,B|0,E|0)|0;E=J;r=jJc(t|0,B|0,C&63|0)|0;Q=((r|0)!=0|(J|0)!=0)&1|q;R=E}else{Q=((t|0)!=0|(B|0)!=0)&1;R=0}F=0;G=Q&1023;H=Q;I=R}else{F=C;G=s;H=t;I=B}while(0);B=UIc(H|0,I|0,512,0)|0;t=aJc(B|0,J|0,10)|0;B=J;s=t&~((G|0)==512);t=(s|0)==0&(B|0)==0;C=jJc(F|0,0,52)|0;E=UIc((t?0:C)|0,(t?0:J)|0,s|0,B|l&-2147483648|0)|0;K=E;L=J;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}while(0);K=0;L=l&-2147483648;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}while(0);if((p|0)==21){F=0==0&(e&2146959360|0)==2146435072&((b|0)!=0|(e&524287|0)!=0);G=0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(d|0)==0;K=F?b:G?c:b;L=(F?e:G?g:e)|524288;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}else if((p|0)==22){p=(m|n|0)==0&(o|0)==0;K=p?0:0;L=p?-524288:l&-2147483648|2146435072;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}}function gnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=aJc(b|0,e|0,52)|0;i=d&2047;d=e&1048575;j=aJc(c|0,g|0,52)|0;k=j&2047;l=g&1048575;m=g^e;a:do if((i|0)==2047)if((b|0)==0&(d|0)==0)if((k|0)==2047)if((c|0)==0&(l|0)==0){n=0;o=-524288;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}else t=26;else t=27;else t=26;else{b:do switch(j&2047){case 2047:{if(!((c|0)==0&(l|0)==0)){t=26;break a}break}case 0:{if(!((c|0)==0&(l|0)==0)){u=(l|0)==0;v=u?32:0;w=u?c:l;u=w>>>0<65536;x=u?v|16:v;v=u?w<<16:w;w=v>>>0<16777216;u=((h[508749+((w?v<<8:v)>>>24)>>0]|0)+((w?x|8:x)&255)<<24)+-184549376>>24;x=jJc(c|0,l|0,u|0)|0;y=1-u|0;z=J;A=x;t=10;break b}if((i|b|0)==0&(d|0)==0){n=0;o=-524288}else{t=27;break a}p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}default:{y=k;z=l;A=c;t=10}}while(0);do if((t|0)==10){if(!i){if((b|0)==0&(d|0)==0)break;x=(d|0)==0;u=x?32:0;w=x?b:d;x=w>>>0<65536;v=x?u|16:u;u=x?w<<16:w;w=u>>>0<16777216;x=((h[508749+((w?u<<8:u)>>>24)>>0]|0)+((w?v|8:v)&255)<<24)+-184549376>>24;v=jJc(b|0,d|0,x|0)|0;B=1-x|0;C=J;D=v}else{B=i;C=d;D=b}v=C|1048576;x=z|1048576;w=v>>>0<x>>>0|(v|0)==(x|0)&D>>>0<A>>>0;u=(w?1021:1022)+(B-y)|0;E=jJc(D|0,v|0,(w?11:10)|0)|0;w=J;v=aJc(A|0,x|0,21)|0;x=cJc(-1,2147483647,v|0,0)|0;F=x+-2|0;mJc(w|0,0,F|0,0)|0;x=J;G=jJc(x|0,0,1)|0;H=G&-2;G=mJc(H|0,0,v|0,0)|0;I=TIc(E|0,w|0,G|0,J|0)|0;G=jJc(I|0,J|0,28)|0;I=J;w=A<<7&268435328;E=mJc(H|0,0,w|0,0)|0;H=TIc(G|0,I|0,E|0,J|0)|0;E=J;mJc(E|0,0,F|0,0)|0;F=UIc(J|0,0,4,0)|0;I=jJc(F|0,J|0,4)|0;G=UIc(I&-16|0,J&15|0,0,x|0)|0;x=J;do if(0<0|0==0&(G&448)>>>0<64){I=G&-128;K=F<<1&-16;L=mJc(K|0,0,v|0,0)|0;M=TIc(H|0,E|0,L|0,J|0)|0;L=jJc(M|0,J|0,28)|0;M=J;N=mJc(K|0,0,w|0,0)|0;K=TIc(L|0,M|0,N|0,J|0)|0;N=J;if((N|0)<0){M=UIc(I|0,x|0,-128,-1)|0;O=M;P=J;break}else{O=((K|0)!=0|(N|0)!=0)&1|I;P=x;break}}else{O=G;P=x}while(0);x=O&1023;do if((u&65535)>>>0>2044){if((u|0)>=0){UIc(O|0,P|0,512,0)|0;if(!((u|0)>2045|(J|0)<0)){Q=u;R=x;S=O;T=P;break}n=0;o=m&-2147483648|2146435072;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}G=0-u|0;if(G>>>0<63){w=aJc(O|0,P|0,G|0)|0;G=J;E=jJc(O|0,P|0,u&63|0)|0;U=((E|0)!=0|(J|0)!=0)&1|w;V=G}else{U=((O|0)!=0|(P|0)!=0)&1;V=0}Q=0;R=U&1023;S=U;T=V}else{Q=u;R=x;S=O;T=P}while(0);x=UIc(S|0,T|0,512,0)|0;u=aJc(x|0,J|0,10)|0;x=J;G=u&~((R|0)==512);u=(G|0)==0&(x|0)==0;w=jJc(Q|0,0,52)|0;E=UIc((u?0:w)|0,(u?0:J)|0,G|0,x|m&-2147483648|0)|0;n=E;o=J;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}while(0);n=0;o=m&-2147483648;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}while(0);if((t|0)==26){Q=0==0&(e&2146959360|0)==2146435072&((b|0)!=0|(e&524287|0)!=0);R=0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(d|0)==0;n=Q?b:R?c:b;o=(Q?e:R?g:e)|524288;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}else if((t|0)==27){n=0;o=m&-2147483648|2146435072;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}}function hnc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a;a=f[c>>2]|0;d=f[c+4>>2]|0;c=b;b=f[c>>2]|0;e=f[c+4>>2]|0;if(!(0!=0|(d&2146435072|0)!=2146435072|(a|0)==0&(d&1048575|0)==0)){g=0;return g|0}if(!(0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(e&1048575|0)==0)){g=0;return g|0}g=(a|0)==(b|0)&(d|0)==(e|0)|(b|a|0)==0&((e|d)&2147483647|0)==0;return g|0}function inc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a;a=f[c>>2]|0;d=f[c+4>>2]|0;c=b;b=f[c>>2]|0;e=f[c+4>>2]|0;if(!(0!=0|(d&2146435072|0)!=2146435072|(a|0)==0&(d&1048575|0)==0)){g=0;return g|0}if(!(0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(e&1048575|0)==0)){g=0;return g|0}c=aJc(a|0,d|0,63)|0;h=aJc(b|0,e|0,63)|0;if((c|0)==(h|0)){g=(a|0)==(b|0)&(d|0)==(e|0)|(c|0)!=((d>>>0<e>>>0|(d|0)==(e|0)&a>>>0<b>>>0)&1|0);return g|0}else{g=(d|0)<0|(b|a|0)==0&((e|d)&2147483647|0)==0;return g|0}return 0}function jnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=f[b>>2]|0;b=f[c>>2]|0;c=f[d>>2]|0;d=e>>>23&255;g=e&8388607;i=b>>>23&255;j=b&8388607;k=c>>>31;l=k&255;m=c>>>23&255;n=c&8388607;o=b^e;p=o>>>31;q=p&255;do if((d|0)==255)if((g|0)==0?!((j|0)!=0&(i|0)==255):0){r=i|j;s=54}else s=53;else{if((i|0)==255){if(j|0){s=53;break}r=d|g;s=54;break}if((m|0)==255){if(!n)t=c;else{u=0;break}f[a>>2]=t;return}if(!d)if(!g)s=59;else{v=g>>>0<65536;w=v?e<<16:g;x=v?16:0;v=w>>>0<16777216;y=((h[508749+((v?w<<8:w)>>>24)>>0]|0)+((v?x|8:x)&255)<<24)+-134217728>>24;z=1-y|0;A=g<<y;s=13}else{z=d;A=g;s=13}a:do if((s|0)==13){if(!i){if(!j){s=59;break}y=j>>>0<65536;x=y?b<<16:j;v=y?16:0;y=x>>>0<16777216;w=((h[508749+((y?x<<8:x)>>>24)>>0]|0)+((y?v|8:v)&255)<<24)+-134217728>>24;B=1-w|0;C=j<<w}else{B=i;C=j}w=mJc(C<<7|1073741824|0,0,A<<7|1073741824|0,0)|0;v=J;y=v>>>0<536870912|(v|0)==536870912&w>>>0<0;x=B+z+(y?-127:-126)|0;D=jJc(w|0,v|0,y&1|0)|0;y=J;do if(!m)if(!n){v=aJc(D|0,y|0,31)|0;E=((D&2147467264|0)!=0|0!=0)&1|v;F=(p|0)!=0;G=x+-1|0;break}else{v=n>>>0<65536;w=v?c<<16:n;H=v?16:0;v=w>>>0<16777216;I=((h[508749+((v?w<<8:w)>>>24)>>0]|0)+((v?H|8:H)&255)<<24)+-134217728>>24;K=n<<I;L=1-I|0;s=20;break}else{K=n;L=m;s=20}while(0);do if((s|0)==20){I=K<<6|536870912;H=x-L|0;if((o^c|0)>-1){if((H|0)<1){v=32-H|0;if(v>>>0<63){w=aJc(D|0,y|0,v|0)|0;M=jJc(D|0,y|0,0-v&63|0)|0;N=((M|0)!=0|(J|0)!=0)&1|w}else N=((D|0)!=0|(y|0)!=0)&1;O=N+I|0;P=L}else{if(H>>>0<63){w=aJc(0,I|0,H|0)|0;M=J;v=jJc(0,I|0,0-H&63|0)|0;Q=((v|0)!=0|(J|0)!=0)&1|w;R=M}else{Q=1;R=0}M=UIc(Q|0,R|0,D|0,y|0)|0;O=((M|0)!=0|0!=0)&1|J;P=x}M=O>>>0<1073741824;E=O<<(M&1);F=(p|0)!=0;G=(M<<31>>31)+P|0;break}do if((H|0)<0){M=0-H|0;if(M>>>0<63){w=aJc(D|0,y|0,M|0)|0;M=J;v=jJc(D|0,y|0,H&63|0)|0;S=((v|0)!=0|(J|0)!=0)&1|w;T=M}else{S=((D|0)!=0|(y|0)!=0)&1;T=0}M=TIc(0,I|0,S|0,T|0)|0;U=l;V=L;W=J;X=M}else{if(!H){M=TIc(D|0,y|0,0,I|0)|0;w=J;if((M|0)==0&(w|0)==0)break a;v=(w|0)<0;Y=TIc(0,0,M|0,w|0)|0;Z=J;_=aJc(M|0,w|0,63)|0;U=_&255^q;V=x;W=v?Z:w;X=v?Y:M;break}if(H>>>0<63){M=aJc(0,I|0,H|0)|0;Y=J;v=jJc(0,I|0,0-H&63|0)|0;$=((v|0)!=0|(J|0)!=0)&1|M;aa=Y}else{$=1;aa=0}Y=TIc(D|0,y|0,$|0,aa|0)|0;U=q;V=x;W=J;X=Y}while(0);H=(W|0)==0;I=H?32:0;Y=H?X:W;H=Y>>>0<65536;M=H?I|16:I;I=H?Y<<16:Y;Y=I>>>0<16777216;H=((Y?M|8:M)&255)+(h[508749+((Y?I<<8:I)>>>24)>>0]|0)<<24;I=V-(H+-16777216>>24)|0;Y=H+-553648128|0;H=Y>>24;if((Y|0)<0){Y=0-H&255;M=aJc(X|0,W|0,Y|0)|0;v=jJc(1,0,Y|0)|0;Y=UIc(v|0,J|0,-1,-1)|0;E=((Y&X|0)!=0|(J&W|0)!=0)&1|M;F=(U&1)!=0;G=I;break}else{E=X<<H;F=(U&1)!=0;G=I;break}}while(0);x=E&127;do if(G>>>0>252){if((G|0)>=0){if(!((G|0)>253|(E+64|0)<0)){ba=G;ca=x;da=E;break}t=(F&1)<<31|2139095040;f[a>>2]=t;return}y=0-G|0;if(y>>>0<31)ea=(E<<(G&31)|0)!=0|E>>>y;else ea=(E|0)!=0&1;ba=0;ca=ea&127;da=ea}else{ba=G;ca=x;da=E}while(0);x=(da+64|0)>>>7&~(ca<<24>>24==64);t=((x|0)==0?0:ba<<23)+(x|(F&1)<<31)|0;f[a>>2]=t;return}while(0);if((s|0)==59?!((o^c|0)<0&(m|n|0)==0):0){t=c;f[a>>2]=t;return}t=0;f[a>>2]=t;return}while(0);if((s|0)==53)u=((e&2143289344|0)==2139095040&(e&4194303|0)!=0?e:(e&2139095040|0)!=2139095040|(g|0)==0?b:e)|4194304;else if((s|0)==54)if(r){r=p<<31|2139095040;if((m|0)!=255){t=r;f[a>>2]=t;return}if(!n)if((p|0)==(k|0)){t=r;f[a>>2]=t;return}else u=-4194304;else u=r}else u=-4194304;t=((u&2143289344|0)==2139095040&(u&4194303|0)!=0?u:(u&2139095040|0)!=2139095040|(u&8388607|0)==0?c:u)|4194304;f[a>>2]=t;return}function knc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;e=b;b=f[e>>2]|0;g=f[e+4>>2]|0;e=c;c=f[e>>2]|0;i=f[e+4>>2]|0;e=d;d=f[e>>2]|0;j=f[e+4>>2]|0;e=aJc(b|0,g|0,52)|0;k=e&2047;e=g&1048575;l=aJc(c|0,i|0,52)|0;m=l&2047;l=i&1048575;n=aJc(d|0,j|0,63)|0;o=n&255;p=aJc(d|0,j|0,52)|0;q=p&2047;p=j&1048575;r=i^g;s=aJc(c^b|0,r|0,63)|0;t=J;u=s&255;do if((k|0)==2047)if((b|0)==0&(e|0)==0?!(((c|0)!=0|(l|0)!=0)&(m|0)==2047):0){v=m;w=c;x=l;y=54}else y=53;else{if((m|0)==2047)if((c|0)==0&(l|0)==0){v=k;w=b;x=e;y=54;break}else{y=53;break}if((q|0)==2047){if((d|0)==0&(p|0)==0){z=d;A=j}else{B=0;C=0;break}D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}if(!k)if((b|0)==0&(e|0)==0)y=59;else{H=(e|0)==0;I=H?32:0;K=H?b:e;H=K>>>0<65536;L=H?I|16:I;I=H?K<<16:K;K=I>>>0<16777216;H=((h[508749+((K?I<<8:I)>>>24)>>0]|0)+((K?L|8:L)&255)<<24)+-184549376>>24;L=jJc(b|0,e|0,H|0)|0;M=1-H|0;N=L;O=J;y=11}else{M=k;N=b;O=e;y=11}a:do if((y|0)==11){if(!m){if((c|0)==0&(l|0)==0){y=59;break}L=(l|0)==0;H=L?32:0;K=L?c:l;L=K>>>0<65536;I=L?H|16:H;H=L?K<<16:K;K=H>>>0<16777216;L=((h[508749+((K?H<<8:H)>>>24)>>0]|0)+((K?I|8:I)&255)<<24)+-184549376>>24;I=jJc(c|0,l|0,L|0)|0;P=1-L|0;Q=I;R=J}else{P=m;Q=c;R=l}I=jJc(N|0,O|0,10)|0;L=jJc(Q|0,R|0,10)|0;K=aJc(N|0,O|0,22)|0;H=K&-1073741825|1073741824;K=aJc(Q|0,R|0,22)|0;S=K&-1073741825|1073741824;K=I&-1024;I=L&-1024;L=mJc(I|0,0,K|0,0)|0;T=J;U=mJc(I|0,0,H|0,0)|0;I=J;V=mJc(S|0,0,K|0,0)|0;K=UIc(V|0,J|0,U|0,I|0)|0;V=J;W=mJc(S|0,0,H|0,0)|0;H=UIc(V|0,(V>>>0<I>>>0|(V|0)==(I|0)&K>>>0<U>>>0)&1|0,W|0,J|0)|0;W=J;U=UIc(0,K|0,L|0,T|0)|0;T=J;L=UIc(H|0,W|0,(T>>>0<K>>>0|(T|0)==(K|0)&U>>>0<0)&1|0,0)|0;K=J;W=K>>>0<536870912|(K|0)==536870912&L>>>0<0;H=jJc(U|0,T|0,1)|0;I=J;V=jJc(L|0,K|0,1)|0;S=P+M+(W?-1023:-1022)|0;X=W?V|(I>>>0<T>>>0|(I|0)==(T|0)&H>>>0<U>>>0)&1:L;L=W?J:K;K=W?H:U;U=W?I:T;do if(!q)if((d|0)==0&(p|0)==0){T=jJc(X|0,L|0,1)|0;Y=(s|0)!=0|(t|0)!=0;Z=S+-1|0;_=T|((K|0)!=0|(U|0)!=0)&1;$=J;break}else{T=(p|0)==0;I=T?32:0;W=T?d:p;T=W>>>0<65536;H=T?I|16:I;I=T?W<<16:W;W=I>>>0<16777216;T=((h[508749+((W?I<<8:I)>>>24)>>0]|0)+((W?H|8:H)&255)<<24)+-184549376>>24;H=jJc(d|0,p|0,T|0)|0;aa=1-T|0;ba=H;ca=J;y=18;break}else{aa=q;ba=d;ca=p;y=18}while(0);do if((y|0)==18){H=jJc(ba|0,ca|0,9)|0;T=J|536870912;W=S-aa|0;I=(W|0)<0;do if(I){if(!((s|0)==(n|0)|(W|0)!=-1)){V=aJc(X|0,L|0,1)|0;da=J;ea=jJc(X|0,L|0,63)|0;fa=J;ga=aJc(K|0,U|0,1)|0;ha=aa;ia=V;ja=da;ka=0;la=0;ma=ea|ga;na=fa|J;oa=0;pa=0;break}fa=0-W|0;if(fa>>>0<63){ga=aJc(X|0,L|0,fa|0)|0;fa=J;ea=jJc(X|0,L|0,W&63|0)|0;ha=aa;ia=((ea|0)!=0|(J|0)!=0)&1|ga;ja=fa;ka=0;la=0;ma=K;na=U;oa=0;pa=0;break}else{ha=aa;ia=((X|0)!=0|(L|0)!=0)&1;ja=0;ka=0;la=0;ma=K;na=U;oa=0;pa=0;break}}else if(W){if(W>>>0<64){fa=aJc(H|0,T|0,W|0)|0;ga=J;ea=jJc(H|0,T|0,0-W&63|0)|0;ha=S;ia=X;ja=L;ka=ea;la=J;ma=K;na=U;oa=fa;pa=ga;break}if(W>>>0<127){ga=W&63;fa=aJc(H|0,T|0,ga|0)|0;ea=J;da=jJc(1,0,ga|0)|0;ga=UIc(da|0,J|0,-1,-1)|0;ha=S;ia=X;ja=L;ka=((ga&H|0)!=0|(J&T|0)!=0)&1|fa;la=ea;ma=K;na=U;oa=0;pa=0}else{ha=S;ia=X;ja=L;ka=1;la=0;ma=K;na=U;oa=0;pa=0}}else{ha=S;ia=X;ja=L;ka=0;la=0;ma=K;na=U;oa=0;pa=0}while(0);if((s|0)==(n|0)){if((W|0)<1){ea=UIc(ia|0,ja|0,H|0,T|0)|0;qa=ma;ra=na;sa=ea;ta=J}else{ea=UIc(ka|0,la|0,ma|0,na|0)|0;fa=J;ga=UIc(oa|0,pa|0,ia|0,ja|0)|0;da=UIc(ga|0,J|0,(fa>>>0<na>>>0|(fa|0)==(na|0)&ea>>>0<ma>>>0)&1|0,0)|0;qa=ea;ra=fa;sa=da;ta=J}da=((qa|0)!=0|(ra|0)!=0)&1|sa;fa=ta>>>0<1073741824|(ta|0)==1073741824&da>>>0<0;ea=jJc(da|0,ta|0,fa&1|0)|0;Y=(s|0)!=0|(t|0)!=0;Z=(fa<<31>>31)+ha|0;_=ea;$=J;break}do if(I){ea=TIc(0,0,ma|0,na|0)|0;fa=J;da=TIc(H|0,T|0,ia|0,ja|0)|0;ga=((ma|0)!=0|(na|0)!=0)<<31>>31;V=UIc(da|0,J|0,ga|0,((ga|0)<0)<<31>>31|0)|0;ua=o;va=V;wa=J;xa=ea;ya=fa}else{if(W|0){fa=TIc(ma|0,na|0,ka|0,la|0)|0;ea=J;V=TIc(ia|0,ja|0,oa|0,pa|0)|0;ga=(na>>>0<la>>>0|(na|0)==(la|0)&ma>>>0<ka>>>0)<<31>>31;da=UIc(V|0,J|0,ga|0,((ga|0)<0)<<31>>31|0)|0;ua=u;va=da;wa=J;xa=fa;ya=ea;break}ea=TIc(ia|0,ja|0,H|0,T|0)|0;fa=J;if((ea|ma|0)==0&(fa|na|0)==0)break a;da=(fa|0)<0;ga=TIc(0,0,ma|0,na|0)|0;V=J;za=((ma|0)!=0|(na|0)!=0)<<31>>31;Aa=TIc(za|0,((za|0)<0)<<31>>31|0,ea|0,fa|0)|0;za=J;Ba=aJc(ea|0,fa|0,63)|0;ua=(Ba^s)&255;va=da?Aa:ea;wa=da?za:fa;xa=da?ga:ma;ya=da?V:na}while(0);T=(va|0)==0&(wa|0)==0;H=T?xa:va;W=T?ya:wa;I=T?0:xa;V=T?0:ya;da=(W|0)==0;ga=da?32:0;fa=da?H:W;da=fa>>>0<65536;za=da?ga|16:ga;ga=da?fa<<16:fa;fa=ga>>>0<16777216;da=((fa?za|8:za)&255)+(h[508749+((fa?ga<<8:ga)>>>24)>>0]|0)|0;ga=(da<<24)+-16777216|0;fa=ga>>24;if((ga|0)<0){ga=0-fa&255;za=aJc(H|0,W|0,ga|0)|0;ea=J;Aa=jJc(1,0,ga|0)|0;ga=UIc(Aa|0,J|0,-1,-1)|0;Ca=I;Da=V;Ea=((ga&H|0)!=0|(J&W|0)!=0)&1|za;Fa=ea}else{ea=da+255&255;za=jJc(H|0,W|0,ea|0)|0;W=J;H=aJc(I|0,V|0,-63-da&63|0)|0;da=J|W;W=jJc(I|0,V|0,ea|0)|0;Ca=W;Da=J;Ea=H|za;Fa=da}Y=(ua&1)!=0;Z=(T?ha+-64|0:ha)-fa|0;_=((Ca|0)!=0|(Da|0)!=0)&1|Ea;$=Fa}while(0);U=_&1023;do if((Z&65535)>>>0>2044){if((Z|0)>=0){UIc(_|0,$|0,512,0)|0;if(!((Z|0)>2045|(J|0)<0)){Ga=Z;Ha=U;Ia=_;Ja=$;break}K=jJc(Y&1|0,0,63)|0;z=K;A=J|2146435072;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}K=0-Z|0;if(K>>>0<63){L=aJc(_|0,$|0,K|0)|0;K=J;X=jJc(_|0,$|0,Z&63|0)|0;Ka=((X|0)!=0|(J|0)!=0)&1|L;La=K}else{Ka=((_|0)!=0|($|0)!=0)&1;La=0}Ga=0;Ha=Ka&1023;Ia=Ka;Ja=La}else{Ga=Z;Ha=U;Ia=_;Ja=$}while(0);U=UIc(Ia|0,Ja|0,512,0)|0;K=aJc(U|0,J|0,10)|0;U=J;L=K&~((Ha|0)==512);K=(L|0)==0&(U|0)==0;X=jJc(Y&1|0,0,63)|0;S=J;fa=jJc(Ga|0,0,52)|0;T=UIc((K?0:fa)|0,(K?0:J)|0,L|X|0,U|S|0)|0;z=T;A=J;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}while(0);if((y|0)==59){if(!((q|d|0)==0&(p|0)==0)){z=d;A=j;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}if((s|0)==(n|0)){z=d;A=j;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}}z=0;A=0;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}while(0);if((y|0)==53){Ga=0==0&(g&2146959360|0)==2146435072&((b|0)!=0|(g&524287|0)!=0);Y=0!=0|(g&2146435072|0)!=2146435072|(b|0)==0&(e|0)==0;B=(Ga?g:Y?i:g)|524288;C=Ga?b:Y?c:b}else if((y|0)==54)if(!((v|w|0)==0&(x|0)==0)){x=r&-2147483648|2146435072;if((q|0)!=2047){z=0;A=x;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}if((d|0)==0&(p|0)==0)if((s|0)==(n|0)){z=0;A=x;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}else{B=-524288;C=0}else{B=x;C=0}}else{B=-524288;C=0}x=0==0&(B&2146959360|0)==2146435072&((C|0)!=0|(B&524287|0)!=0);n=0!=0|(B&2146435072|0)!=2146435072|(C|0)==0&(B&1048575|0)==0;z=x?C:n?d:C;A=(x?B:n?j:B)|524288;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}function lnc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;e=b;b=f[e+4>>2]|0;g=d;f[g>>2]=f[e>>2];f[g+4>>2]=b;mnc(a,d);u=c;return}function mnc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+176|0;e=d+160|0;g=d+144|0;h=d+136|0;i=d+120|0;j=d+104|0;k=d+96|0;l=d+168|0;m=d+152|0;n=d+88|0;o=d+80|0;p=d+128|0;q=d+72|0;r=d+112|0;s=d+64|0;t=d+56|0;v=d+48|0;w=d+40|0;x=d+32|0;y=d+24|0;z=d+16|0;A=d+8|0;B=d;C=c;D=f[C>>2]|0;E=f[C+4>>2]|0;C=E&2147483647;if(C>>>0>2146435072|(C|0)==2146435072&D>>>0>0){F=a;f[F>>2]=-1;f[F+4>>2]=2147483647;u=d;return}if((D|0)==0&(C|0)==2146435072)if((D|0)==0&(E|0)==2146435072&(0!=0|(E&2146435072|0)!=2146435072|(D|0)==0&(E&1048575|0)==0)){E=a;f[E>>2]=0;f[E+4>>2]=2146435072;u=d;return}else{E=a;f[E>>2]=0;f[E+4>>2]=0;u=d;return}if((b[529064]|0)==0?MIc(529064)|0:0){E=e;f[E>>2]=0;f[E+4>>2]=1072693248;gnc(529072,e,21568)}if((b[529080]|0)==0?MIc(529080)|0:0){e=g;f[e>>2]=-17155599;f[e+4>>2]=1072049730;gnc(529088,g,21568)}if((b[529096]|0)==0?MIc(529096)|0:0){g=h;f[g>>2]=-8215462;f[g+4>>2]=1070514109;gnc(529104,h,21568)}if((b[529112]|0)==0?MIc(529112)|0:0){h=i;f[h>>2]=-668996491;f[h+4>>2]=1068264200;gnc(529120,i,21568)}if((b[529128]|0)==0?MIc(529128)|0:0){i=j;f[i>>2]=726613203;f[i+4>>2]=1065595559;gnc(529136,j,21568)}if((b[529144]|0)==0?MIc(529144)|0:0){j=k;f[j>>2]=359056036;f[j+4>>2]=1062594474;gnc(529152,k,21568)}k=l;f[k>>2]=0;f[k+4>>2]=0;k=f[c+4>>2]|0;j=k&2145386496;if(j>>>0>1083179008|(j|0)==1083179008&0>0){j=k&-2147483648|1091006464;k=l;f[k>>2]=0;f[k+4>>2]=j;G=0;H=j}else{fnc(m,c,21576);c=m;j=f[c>>2]|0;k=f[c+4>>2]|0;c=l;f[c>>2]=j;f[c+4>>2]=k;G=j;H=k}k=aJc(G|0,H|0,52)|0;j=k&2047;k=H&1048575;c=(H|0)<0;i=(G|0)==0&(k|0)==0|(j|0)!=2047;h=c&i;g=(j|0)==0;e=g?G:G;E=g?k:k|1048576;g=1063-j|0;do if((g|0)>0)if(g>>>0<63){D=aJc(e|0,E|0,g|0)|0;C=J;F=jJc(e|0,E|0,0-g&63|0)|0;I=((F|0)!=0|(J|0)!=0)&1|D;K=C;break}else{I=((e|0)!=0|(E|0)!=0)&1;K=0;break}else{I=e;K=E}while(0);E=UIc(I|0,K|0,2048,0)|0;K=J;if(!(K>>>0>4095|(K|0)==4095&E>>>0>4294967295)){e=aJc(E|0,K|0,12)|0;K=(I&4095|0)==2048&0==0&1;I=h?(K|~e)+1|0:e&~K;if(I)if((I>>>31|0)==(h&1|0))L=I;else M=35;else L=0}else M=35;if((M|0)==35)L=h?-2147483648:2147483647;h=L>>6;M=h+1023|0;I=(h|0)<-1023;h=jJc(((M|0)<2047?M:2047)|0,0,52)|0;M=m;f[M>>2]=I?0:h;f[M+4>>2]=I?0:J;do if(j>>>0>=1023){if(j>>>0<=1074){I=jJc(1,0,1075-j|0)|0;M=J;h=UIc(I|0,M|0,-1,-1)|0;K=J;e=aJc(I|0,M|0,1)|0;E=UIc(e|0,J|0,G|0,H|0)|0;e=J;g=(E&h|0)==0&(e&K|0)==0;K=TIc(0,0,I|0,M|0)|0;N=E&K&(g?~I:-1);O=e&J&(g?~M:-1);break}if(i){N=G;O=H}else{M=0==0&(H&2146959360|0)==2146435072&((G|0)!=0|(H&524287|0)!=0);g=0!=0|(H&2146435072|0)!=2146435072;N=M?G:g?0:G;O=(M?H:g?0:H)|524288}}else{g=(G|0)==0&(H&2147483647|0)==0;M=H&-2147483648;e=((G|0)!=0|(k|0)!=0)&(j|0)==1022;N=g?G:e?0:0;O=g?H:e?M|1072693248:M}while(0);j=aJc(G|0,H|0,63)|0;k=aJc(N|0,O|0,63)|0;if((j|0)==(k|0))dnc(n,G,H,N,O,c);else cnc(n,G,H,N,O,c);fnc(l,n,21584);fnc(o,m,21568);m=21592+((L&63)<<3)|0;L=f[m+4>>2]|0;n=p;f[n>>2]=f[m>>2];f[n+4>>2]=L;fnc(q,o,p);fnc(s,529152,l);p=s;s=f[p>>2]|0;o=f[p+4>>2]|0;p=529136;L=f[p>>2]|0;n=f[p+4>>2]|0;p=(o|0)<0;m=aJc(s|0,o|0,63)|0;c=aJc(L|0,n|0,63)|0;if((m|0)==(c|0))cnc(t,s,o,L,n,p);else dnc(t,s,o,L,n,p);fnc(v,t,l);t=v;v=f[t>>2]|0;p=f[t+4>>2]|0;t=529120;n=f[t>>2]|0;L=f[t+4>>2]|0;t=(p|0)<0;o=aJc(v|0,p|0,63)|0;s=aJc(n|0,L|0,63)|0;if((o|0)==(s|0))cnc(w,v,p,n,L,t);else dnc(w,v,p,n,L,t);fnc(x,w,l);w=x;x=f[w>>2]|0;t=f[w+4>>2]|0;w=529104;L=f[w>>2]|0;n=f[w+4>>2]|0;w=(t|0)<0;p=aJc(x|0,t|0,63)|0;v=aJc(L|0,n|0,63)|0;if((p|0)==(v|0))cnc(y,x,t,L,n,w);else dnc(y,x,t,L,n,w);fnc(z,y,l);y=z;z=f[y>>2]|0;w=f[y+4>>2]|0;y=529088;n=f[y>>2]|0;L=f[y+4>>2]|0;y=(w|0)<0;t=aJc(z|0,w|0,63)|0;x=aJc(n|0,L|0,63)|0;if((t|0)==(x|0))cnc(A,z,w,n,L,y);else dnc(A,z,w,n,L,y);fnc(B,A,l);l=B;B=f[l>>2]|0;A=f[l+4>>2]|0;l=529072;y=f[l>>2]|0;L=f[l+4>>2]|0;l=(A|0)<0;n=aJc(B|0,A|0,63)|0;w=aJc(y|0,L|0,63)|0;if((n|0)==(w|0))cnc(r,B,A,y,L,l);else dnc(r,B,A,y,L,l);fnc(a,q,r);u=d;return}function nnc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+240|0;e=d+232|0;g=d+224|0;i=d+216|0;j=d+208|0;k=d+200|0;l=d+192|0;m=d+184|0;n=d+176|0;o=d+168|0;p=d+160|0;q=d+152|0;r=d+144|0;s=d+128|0;t=d+136|0;v=d+120|0;w=d+112|0;x=d+96|0;y=d+88|0;z=d+80|0;A=d+72|0;B=d+64|0;C=d+56|0;D=d+48|0;E=d+104|0;F=d+40|0;G=d+32|0;H=d+24|0;I=d+16|0;K=d+8|0;L=d;M=c;N=f[M>>2]|0;O=f[M+4>>2]|0;M=O&2147483647;if(!(M>>>0>2146435072|(M|0)==2146435072&N>>>0>0)?(P=O&2146435072,Q=O&1048575,(N|0)==0&(M|0)==0|((O|0)>-1|(O|0)==-1&N>>>0>4294967295|((N|0)!=0|(Q|0)!=0)&(0==0&(P|0)==2146435072))):0){a:do if(0!=0|(P|0)!=2146435072|(N|0)==0&(Q|0)==0?(N|0)==0:0){if((O|0)<0)switch(O|0){case -2147483648:break;default:break a}else switch(O|0){case 0:break;default:break a}M=a;f[M>>2]=0;f[M+4>>2]=-1048576;u=d;return}while(0);if((b[529160]|0)==0?MIc(529160)|0:0){O=529168;f[O>>2]=0;f[O+4>>2]=1072693248}if((b[529176]|0)==0?MIc(529176)|0:0){O=g;f[O>>2]=0;f[O+4>>2]=-1074790400;O=e;f[O>>2]=0;f[O+4>>2]=1073741824;gnc(529184,g,e)}if((b[529192]|0)==0?MIc(529192)|0:0){g=i;f[g>>2]=0;f[g+4>>2]=1072693248;g=e;f[g>>2]=0;f[g+4>>2]=1074266112;gnc(529200,i,e)}if((b[529208]|0)==0?MIc(529208)|0:0){i=j;f[i>>2]=0;f[i+4>>2]=-1074790400;i=e;f[i>>2]=0;f[i+4>>2]=1074790400;gnc(529216,j,e)}if((b[529224]|0)==0?MIc(529224)|0:0){j=k;f[j>>2]=0;f[j+4>>2]=1072693248;j=e;f[j>>2]=0;f[j+4>>2]=1075052544;gnc(529232,k,e)}if((b[529240]|0)==0?MIc(529240)|0:0){k=l;f[k>>2]=0;f[k+4>>2]=-1074790400;k=e;f[k>>2]=0;f[k+4>>2]=1075314688;gnc(529248,l,e)}if((b[529256]|0)==0?MIc(529256)|0:0){l=m;f[l>>2]=0;f[l+4>>2]=1072693248;l=e;f[l>>2]=0;f[l+4>>2]=1075576832;gnc(529264,m,e)}if((b[529272]|0)==0?MIc(529272)|0:0){m=n;f[m>>2]=0;f[m+4>>2]=-1074790400;m=e;f[m>>2]=0;f[m+4>>2]=1075838976;gnc(529280,n,e)}n=c;m=f[n>>2]|0;l=f[n+4>>2]|0;n=aJc(m|0,l|0,44)|0;k=n&255;n=l&4095|1072693248;l=o;f[l>>2]=m;f[l+4>>2]=n;dnc(o,m,n,0,1072693248,0);n=k<<1;m=16+(n<<3)|0;l=f[m>>2]|0;j=f[m+4>>2]|0;m=16+((n|1)<<3)|0;n=f[m+4>>2]|0;i=p;f[i>>2]=f[m>>2];f[i+4>>2]=n;fnc(q,o,p);if((k|0)==255){k=s;f[k>>2]=0;f[k+4>>2]=-1074790400;k=t;f[k>>2]=0;f[k+4>>2]=1082130432;gnc(r,s,t);s=q;k=f[s>>2]|0;p=f[s+4>>2]|0;s=r;o=f[s>>2]|0;n=f[s+4>>2]|0;s=(p|0)<0;i=aJc(k|0,p|0,63)|0;m=aJc(o|0,n|0,63)|0;if((i|0)==(m|0))cnc(e,k,p,o,n,s);else dnc(e,k,p,o,n,s);s=e;n=f[s+4>>2]|0;o=q;f[o>>2]=f[s>>2];f[o+4>>2]=n}fnc(e,q,q);n=c;c=aJc(f[n>>2]|0,f[n+4>>2]|0,52)|0;n=c&2047;c=n+-1023|0;if(!c){R=0;S=0}else{o=n>>>0<1023?1023-n|0:c;n=o>>>0<65536;s=n?o<<16:o;p=n?16:0;n=s>>>0<16777216;k=(h[508749+((n?s<<8:s)>>>24)>>0]|0)+((n?p|8:p)&255)|0;p=jJc(c>>>31|0,0,63)|0;c=J;n=(k<<24)+352321536>>24;k=jJc(1074-n|0,0,52)|0;s=J;m=jJc(o|0,0,n|0)|0;n=UIc(m|0,J|0,p|0,c|0)|0;c=UIc(n|0,J|0,k|0,s|0)|0;R=c;S=J}c=r;f[c>>2]=R;f[c+4>>2]=S;fnc(v,22104,r);r=v;v=f[r>>2]|0;S=f[r+4>>2]|0;r=(S|0)<0;c=aJc(v|0,S|0,63)|0;R=aJc(l|0,j|0,63)|0;if((c|0)==(R|0))cnc(w,v,S,l,j,r);else dnc(w,v,S,l,j,r);fnc(x,529280,e);r=x;x=f[r>>2]|0;j=f[r+4>>2]|0;r=529248;l=f[r>>2]|0;S=f[r+4>>2]|0;r=(j|0)<0;v=aJc(x|0,j|0,63)|0;R=aJc(l|0,S|0,63)|0;if((v|0)==(R|0))cnc(y,x,j,l,S,r);else dnc(y,x,j,l,S,r);fnc(z,y,e);y=z;z=f[y>>2]|0;r=f[y+4>>2]|0;y=529216;S=f[y>>2]|0;l=f[y+4>>2]|0;y=(r|0)<0;j=aJc(z|0,r|0,63)|0;x=aJc(S|0,l|0,63)|0;if((j|0)==(x|0))cnc(A,z,r,S,l,y);else dnc(A,z,r,S,l,y);fnc(B,A,e);A=B;B=f[A>>2]|0;y=f[A+4>>2]|0;A=529184;l=f[A>>2]|0;S=f[A+4>>2]|0;A=(y|0)<0;r=aJc(B|0,y|0,63)|0;z=aJc(l|0,S|0,63)|0;if((r|0)==(z|0))cnc(C,B,y,l,S,A);else dnc(C,B,y,l,S,A);fnc(t,C,e);C=w;w=f[C>>2]|0;A=f[C+4>>2]|0;C=t;t=f[C>>2]|0;S=f[C+4>>2]|0;C=(A|0)<0;l=aJc(w|0,A|0,63)|0;y=aJc(t|0,S|0,63)|0;if((l|0)==(y|0))cnc(D,w,A,t,S,C);else dnc(D,w,A,t,S,C);fnc(F,529264,e);C=F;F=f[C>>2]|0;S=f[C+4>>2]|0;C=529232;t=f[C>>2]|0;A=f[C+4>>2]|0;C=(S|0)<0;w=aJc(F|0,S|0,63)|0;y=aJc(t|0,A|0,63)|0;if((w|0)==(y|0))cnc(G,F,S,t,A,C);else dnc(G,F,S,t,A,C);fnc(H,G,e);G=H;H=f[G>>2]|0;C=f[G+4>>2]|0;G=529200;A=f[G>>2]|0;t=f[G+4>>2]|0;G=(C|0)<0;S=aJc(H|0,C|0,63)|0;F=aJc(A|0,t|0,63)|0;if((S|0)==(F|0))cnc(I,H,C,A,t,G);else dnc(I,H,C,A,t,G);fnc(K,I,e);e=K;K=f[e>>2]|0;I=f[e+4>>2]|0;e=529168;G=f[e>>2]|0;t=f[e+4>>2]|0;e=(I|0)<0;A=aJc(K|0,I|0,63)|0;C=aJc(G|0,t|0,63)|0;if((A|0)==(C|0))cnc(L,K,I,G,t,e);else dnc(L,K,I,G,t,e);fnc(E,L,q);q=D;D=f[q>>2]|0;L=f[q+4>>2]|0;q=E;E=f[q>>2]|0;e=f[q+4>>2]|0;q=(L|0)<0;t=aJc(D|0,L|0,63)|0;G=aJc(E|0,e|0,63)|0;if((t|0)==(G|0))cnc(a,D,L,E,e,q);else dnc(a,D,L,E,e,q);u=d;return}q=a;f[q>>2]=-1;f[q+4>>2]=2147483647;u=d;return}function onc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+64|0;g=e+56|0;h=e+48|0;i=e+40|0;j=e+32|0;k=e+8|0;l=e;m=e+24|0;n=e+16|0;o=c;c=f[o+4>>2]|0;p=m;f[p>>2]=f[o>>2];f[p+4>>2]=c;c=d;d=f[c+4>>2]|0;p=n;f[p>>2]=f[c>>2];f[p+4>>2]=d;if((b[529288]|0)==0?MIc(529288)|0:0){d=529296;f[d>>2]=0;f[d+4>>2]=0}if((b[529304]|0)==0?MIc(529304)|0:0){d=529312;f[d>>2]=0;f[d+4>>2]=1072693248}if((b[529320]|0)==0?MIc(529320)|0:0){d=529328;f[d>>2]=0;f[d+4>>2]=2146435072}if((b[529336]|0)==0?MIc(529336)|0:0){d=529344;f[d>>2]=-1;f[d+4>>2]=2147483647}d=m;m=f[d>>2]|0;p=f[d+4>>2]|0;d=p&2147483647;c=(m|0)==0&(d|0)==2146435072;o=n;q=f[o>>2]|0;r=f[o+4>>2]|0;o=r&2147483647;s=(q|0)==0&(o|0)==2146435072;t=d>>>0>2146435072|(d|0)==2146435072&m>>>0>0;v=o>>>0>2146435072|(o|0)==2146435072&q>>>0>0;w=529296;x=f[w>>2]|0;y=f[w+4>>2]|0;w=y&2146435072;z=y&1048575;A=0!=0|(w|0)!=2146435072|(x|0)==0&(z|0)==0;do if(A?0!=0|(r&2146435072|0)!=2146435072|(q|0)==0&(r&1048575|0)==0:0){B=aJc(x|0,y|0,63)|0;C=aJc(q|0,r|0,63)|0;if((B|0)==(C|0)){D=((x|0)!=(q|0)|(y|0)!=(r|0))&(B|0)!=((y>>>0<r>>>0|(y|0)==(r|0)&x>>>0<q>>>0)&1|0);break}else{D=(y|0)<0&((x|q|0)!=0|((y|r)&2147483647|0)!=0);break}}else D=0;while(0);B=529312;C=f[B>>2]|0;E=f[B+4>>2]|0;B=E&2146435072;F=0!=0|(B|0)!=2146435072;G=E&1048575;H=(C|0)==0&(G|0)==0;do if(F|H?0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0:0)if((E|0)>-1|(E|0)==-1&C>>>0>4294967295){I=E>>>0<d>>>0|(E|0)==(d|0)&C>>>0<m>>>0;break}else{I=(C|m|0)!=0|((E|p)&2147483647|0)!=0;break}else I=0;while(0);K=D^I;I=a;f[I>>2]=0;f[I+4>>2]=0;if(v){if((a|0)==529344){u=e;return}v=529344;I=f[v+4>>2]|0;D=a;f[D>>2]=f[v>>2];f[D+4>>2]=I;u=e;return}if(s){if(((m|0)!=0|(p&1048575|0)!=0)&(0==0&(p&2146435072|0)==2146435072)|(F|H)^1){L=t;M=K?529296:529328}else{L=(m|0)==(C|0)&(d|0)==(E|0)|(C|m|0)==0&((E|p)&2147483647|0)==0;M=t?529344:K?529296:529328}K=L?529344:M;if((K|0)==(a|0)){u=e;return}M=K;K=f[M+4>>2]|0;L=a;f[L>>2]=f[M>>2];f[L+4>>2]=K;u=e;return}K=0!=0|(r&2146435072|0)!=2146435072;L=r&1048575;M=(q|0)==0&(L|0)==0;d=K|M;do if(d){if(((x|0)!=0|(z|0)!=0)&(0==0&(w|0)==2146435072)|((q|0)!=(x|0)|(r|0)!=(y|0))&((x|q|0)!=0|((y|r)&2147483647|0)!=0)){if(((C|0)!=0|(G|0)!=0)&(0==0&(B|0)==2146435072)|((q|0)!=(C|0)|(r|0)!=(E|0))&((C|q|0)!=0|((E|r)&2147483647|0)!=0))break;H=a;f[H>>2]=m;f[H+4>>2]=p;u=e;return}if((a|0)==529312){u=e;return}H=a;f[H>>2]=C;f[H+4>>2]=E;u=e;return}while(0);if(t){if((a|0)==529344){u=e;return}t=529344;E=f[t+4>>2]|0;C=a;f[C>>2]=f[t>>2];f[C+4>>2]=E;u=e;return}if(c){do if(d&A){c=aJc(q|0,r|0,63)|0;E=aJc(x|0,y|0,63)|0;if((c|0)==(E|0)){if(!(((q|0)!=(x|0)|(r|0)!=(y|0))&(E|0)!=((r>>>0<y>>>0|(r|0)==(y|0)&q>>>0<x>>>0)&1|0))){N=529328;break}}else if(!((r|0)<0&((x|q|0)!=0|((y|r)&2147483647|0)!=0))){N=529328;break}N=529296}else N=529328;while(0);if((N|0)==(a|0)){u=e;return}E=N;N=f[E+4>>2]|0;c=a;f[c>>2]=f[E>>2];f[c+4>>2]=N;u=e;return}N=aJc(q|0,r|0,52)|0;c=N&2047;do if(c>>>0>=1023){if(c>>>0<=1074){N=jJc(1,0,1075-c|0)|0;E=J;C=UIc(N|0,E|0,-1,-1)|0;t=J;B=aJc(N|0,E|0,1)|0;G=UIc(B|0,J|0,q|0,r|0)|0;B=J;H=(G&C|0)==0&(B&t|0)==0;t=TIc(0,0,N|0,E|0)|0;O=B&J&(H?~E:-1);P=G&t&(H?~N:-1);break}if(M|(c|0)!=2047){O=r;P=q}else{N=0==0&(r&2146959360|0)==2146435072&((q|0)!=0|(r&524287|0)!=0);O=(N?r:K?0:r)|524288;P=N?q:K?0:q}}else{N=(q|0)==0&(o|0)==0;H=r&-2147483648;t=((q|0)!=0|(L|0)!=0)&(c|0)==1022;O=N?r:t?H|1072693248:H;P=N?q:t?0:0}while(0);if(d?!(((P|0)!=0|(O&1048575|0)!=0)&(0==0&(O&2146435072|0)==2146435072)|((q|0)!=(P|0)|(r|0)!=(O|0))&((P|q|0)!=0|((O|r)&2147483647|0)!=0)):0){O=(r|0)<0&(M|(c|0)!=2047);M=(c|0)==0;P=M?q:q;o=M?L:L|1048576;L=1063-c|0;do if((L|0)>0)if(L>>>0<63){c=aJc(P|0,o|0,L|0)|0;M=J;K=jJc(P|0,o|0,0-L&63|0)|0;Q=((K|0)!=0|(J|0)!=0)&1|c;R=M;break}else{Q=((P|0)!=0|(o|0)!=0)&1;R=0;break}else{Q=P;R=o}while(0);o=UIc(Q|0,R|0,2048,0)|0;R=J;if(!(R>>>0>4095|(R|0)==4095&o>>>0>4294967295)){P=aJc(o|0,R|0,12)|0;R=(Q&4095|0)==2048&0==0&1;Q=O?(R|~P)+1|0:P&~R;if(Q)if((Q>>>31|0)==(O&1|0))S=Q;else T=64;else S=0}else T=64;if((T|0)==64)S=O?-2147483648:2147483647;a:do if(0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0?(m|0)==0:0){if((p|0)<0)switch(p|0){case -2147483648:break;default:{T=69;break a}}else switch(p|0){case 0:break;default:{T=69;break a}}O=(S|0)<0;Q=(S|0)==0;U=O?0:Q?0:0;V=O?2146435072:Q?1072693248:0}else T=69;while(0);if((T|0)==69){T=h;f[T>>2]=0;f[T+4>>2]=1072693248;T=i;f[T>>2]=m;f[T+4>>2]=p;T=(S|0)>-1?S:0-S|0;if((S|0)<0){S=j;f[S>>2]=0;f[S+4>>2]=1072693248;gnc(g,j,i);j=g;S=f[j+4>>2]|0;Q=i;f[Q>>2]=f[j>>2];f[Q+4>>2]=S}if((T|0)>1){S=T;while(1){if(S&1|0){fnc(g,h,i);T=g;Q=f[T+4>>2]|0;j=h;f[j>>2]=f[T>>2];f[j+4>>2]=Q}fnc(g,i,i);Q=g;j=f[Q+4>>2]|0;T=i;f[T>>2]=f[Q>>2];f[T+4>>2]=j;if(S>>>0>3)S=S>>>1;else break}}fnc(g,h,i);i=g;U=f[i>>2]|0;V=f[i+4>>2]|0}i=a;f[i>>2]=U;f[i+4>>2]=V;u=e;return}if(0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0){do if(A){V=aJc(m|0,p|0,63)|0;i=aJc(x|0,y|0,63)|0;if((V|0)==(i|0)){if(!(((m|0)!=(x|0)|(p|0)!=(y|0))&(i|0)!=((p>>>0<y>>>0|(p|0)==(y|0)&m>>>0<x>>>0)&1|0)))break}else if(!((p|0)<0&((x|m|0)!=0|((y|p)&2147483647|0)!=0)))break;if((a|0)==529344){u=e;return}i=529344;V=f[i+4>>2]|0;U=a;f[U>>2]=f[i>>2];f[U+4>>2]=V;u=e;return}while(0);if(!(((x|0)!=0|(z|0)!=0)&(0==0&(w|0)==2146435072)|((m|0)!=(x|0)|(p|0)!=(y|0))&((x|m|0)!=0|((y|p)&2147483647|0)!=0))){do if(d&A){w=aJc(q|0,r|0,63)|0;z=aJc(x|0,y|0,63)|0;if((w|0)!=(z|0)){w=x|q;V=(y|r)&2147483647;if((r|0)<0&((w|0)!=0|(V|0)!=0)){W=529328;break}else{X=w;Y=V}}else{if(((q|0)!=(x|0)|(r|0)!=(y|0))&(z|0)!=((r>>>0<y>>>0|(r|0)==(y|0)&q>>>0<x>>>0)&1|0)){W=529328;break}X=x|q;Y=(y|r)&2147483647}W=(q|0)==(x|0)&(r|0)==(y|0)|(X|0)==0&(Y|0)==0?529312:529296}else W=529296;while(0);if((W|0)==(a|0)){u=e;return}Y=W;W=f[Y+4>>2]|0;X=a;f[X>>2]=f[Y>>2];f[X+4>>2]=W;u=e;return}}W=l;f[W>>2]=m;f[W+4>>2]=p;nnc(h,l);fnc(k,n,h);mnc(g,k);if((g|0)!=(a|0)){k=g;g=f[k+4>>2]|0;h=a;f[h>>2]=f[k>>2];f[h+4>>2]=g}u=e;return}function pnc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=u;u=u+160|0;d=c+152|0;e=c+144|0;g=c+136|0;h=c+128|0;i=c+120|0;j=c+112|0;k=c+104|0;l=c+96|0;m=c+88|0;n=c+80|0;o=c+72|0;p=c+64|0;q=c+56|0;r=c+48|0;s=c+40|0;t=c+32|0;v=c+24|0;w=c+16|0;x=c+8|0;y=c;z=f[b>>2]|0;b=z&2147483647;if(b>>>0>2139095040){f[a>>2]=2147483647;u=c;return}if((b|0)==2139095040){f[a>>2]=z;u=c;return}A=(z>>>23&255)+-127|0;B=(A|0)%3|0;C=B+-3-(B>>31&-3)|0;B=jJc(C+1023|0,0,52)|0;D=J;E=jJc(z&8388607|0,0,29)|0;F=d;f[F>>2]=B|E;f[F+4>>2]=D|J;D=e;f[D>>2]=1716763248;f[D+4>>2]=1078370462;D=g;f[D>>2]=1712249633;f[D+4>>2]=1076731424;fnc(i,e,d);e=i;i=f[e>>2]|0;D=f[e+4>>2]|0;e=(D|0)<0;if((D|0)>-1|(D|0)==-1&i>>>0>4294967295)cnc(j,i,D,1818302176,1080559860,e);else dnc(j,i,D,1818302176,1080559860,e);fnc(k,j,d);j=k;k=f[j>>2]|0;e=f[j+4>>2]|0;j=(e|0)<0;if((e|0)>-1|(e|0)==-1&k>>>0>4294967295)cnc(l,k,e,1134341652,1079888535,j);else dnc(l,k,e,1134341652,1079888535,j);fnc(m,l,d);l=m;m=f[l>>2]|0;j=f[l+4>>2]|0;l=(j|0)<0;if((j|0)>-1|(j|0)==-1&m>>>0>4294967295)cnc(n,m,j,-763202304,1076551024,l);else dnc(n,m,j,-763202304,1076551024,l);fnc(o,n,d);n=o;o=f[n>>2]|0;l=f[n+4>>2]|0;n=(l|0)<0;if((l|0)>-1|(l|0)==-1&o>>>0>4294967295)cnc(p,o,l,-2081071827,1069871455,n);else dnc(p,o,l,-2081071827,1069871455,n);fnc(r,g,d);g=r;r=f[g>>2]|0;n=f[g+4>>2]|0;g=(n|0)<0;if((n|0)>-1|(n|0)==-1&r>>>0>4294967295)cnc(s,r,n,-1071097835,1080229653,g);else dnc(s,r,n,-1071097835,1080229653,g);fnc(t,s,d);s=t;t=f[s>>2]|0;g=f[s+4>>2]|0;s=(g|0)<0;if((g|0)>-1|(g|0)==-1&t>>>0>4294967295)cnc(v,t,g,1786843854,1080365264,s);else dnc(v,t,g,1786843854,1080365264,s);fnc(w,v,d);v=w;w=f[v>>2]|0;s=f[v+4>>2]|0;v=(s|0)<0;if((s|0)>-1|(s|0)==-1&w>>>0>4294967295)cnc(x,w,s,-907885707,1078001355,v);else dnc(x,w,s,-907885707,1078001355,v);fnc(y,x,d);x=y;y=f[x>>2]|0;v=f[x+4>>2]|0;x=(v|0)<0;if((v|0)>-1|(v|0)==-1&y>>>0>4294967295)cnc(q,y,v,0,1072693248,x);else dnc(q,y,v,0,1072693248,x);gnc(h,p,q);q=h;h=f[q>>2]|0;p=f[q+4>>2]|0;q=d;f[q>>2]=h;f[q+4>>2]=p;if(!b)G=0;else{b=aJc(h|0,p|0,29)|0;G=b&8388607|(((A-C|0)/3|0)<<23)+(z&-2147483648|1056964608)}f[a>>2]=G;u=c;return}function qnc(a){a=a|0;var b=0;do if(a)if((f[a+12>>2]|0)==7247){b=Anc(a)|0;break}else{b=Fnc(a)|0;break}else b=-2;while(0);return b|0}function rnc(a,b){a=a|0;b=b|0;return snc(a,-1,b)|0}function snc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e+8|0;h=e;if(!a){i=0;u=e;return i|0}j=ooc(140)|0;if(!j){i=0;u=e;return i|0}f[j+24>>2]=0;f[j+28>>2]=8192;k=j+80|0;f[k>>2]=0;l=j+12|0;f[l>>2]=0;m=j+60|0;f[m>>2]=-1;n=j+64|0;f[n>>2]=0;o=j+40|0;f[o>>2]=0;p=b[d>>0]|0;a:do if(p<<24>>24){q=0;r=d;s=0;t=p;v=0;w=0;b:while(1){x=t<<24>>24;c:do if((t+-48&255)<10){f[m>>2]=x+-48;y=s;z=q;A=w;B=v}else do switch(x|0){case 43:{C=10;break b;break}case 114:{f[l>>2]=7247;y=s;z=q;A=7247;B=v;break c;break}case 119:{f[l>>2]=31153;y=s;z=q;A=31153;B=v;break c;break}case 97:{f[l>>2]=1;y=s;z=q;A=1;B=v;break c;break}case 84:{f[o>>2]=1;y=s;z=q;A=w;B=1;break c;break}case 101:{y=s;z=1;A=w;B=v;break c;break}case 120:{y=1;z=q;A=w;B=v;break c;break}case 102:{f[n>>2]=1;y=s;z=q;A=w;B=v;break c;break}case 104:{f[n>>2]=2;y=s;z=q;A=w;B=v;break c;break}case 82:{f[n>>2]=3;y=s;z=q;A=w;B=v;break c;break}case 70:{f[n>>2]=4;y=s;z=q;A=w;B=v;break c;break}default:{y=s;z=q;A=w;B=v;break c}}while(0);while(0);r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24))break;else{q=z;s=y;v=B;w=A}}if((C|0)==10){poc(j);i=0;u=e;return i|0}d:do if((A|0)<7247)switch(A|0){case 0:{break a;break}default:{}}else{switch(A|0){case 7247:break;default:break d}if(!B){f[o>>2]=1;break}poc(j);i=0;u=e;return i|0}while(0);w=(Mpc(a)|0)+1|0;v=ooc(w)|0;s=j+20|0;f[s>>2]=v;if(!v){poc(j);i=0;u=e;return i|0}f[h>>2]=a;gqc(v,w,509005,h)|0;w=f[l>>2]|0;do if((c|0)>-1){f[j+16>>2]=c;D=w;E=c}else{f[g>>2]=438;v=Hoc(a,((w|0)==7247?0:((w|0)==31153?512:1024)|(y|0?193:65))|(z|0?557056:32768),g)|0;f[j+16>>2]=v;if((v|0)!=-1){D=f[l>>2]|0;E=v;break}poc(f[s>>2]|0);poc(j);i=0;u=e;return i|0}while(0);e:do if((D|0)>=7247){switch(D|0){case 7247:break;default:{F=j;C=35;break e}}s=Joc(E,0,1)|0;f[j+48>>2]=(s|0)==-1?0:s;s=f[l>>2]|0;f[j>>2]=0;if((s|0)==7247){f[j+52>>2]=0;f[j+56>>2]=0;F=j+44|0;C=35}}else{switch(D|0){case 1:break;default:{F=j;C=35;break e}}Joc(E,0,2)|0;f[l>>2]=31153;F=j;C=35}while(0);if((C|0)==35)f[F>>2]=0;f[j+72>>2]=0;s=f[k>>2]|0;w=j+76|0;if(s|0){if((f[w>>2]|0)!=-4)poc(s);f[k>>2]=0}f[w>>2]=0;f[j+8>>2]=0;f[j+88>>2]=0;i=j;u=e;return i|0}while(0);poc(j);i=0;u=e;return i|0}function tnc(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a){b=-1;return b|0}c=a+12|0;if((f[c>>2]|0)!=7247){b=-1;return b|0}d=a+76|0;switch(f[d>>2]|0){case -5:case 0:break;default:{b=-1;return b|0}}if((Joc(f[a+16>>2]|0,f[a+48>>2]|0,0)|0)==-1){b=-1;return b|0}f[a>>2]=0;if((f[c>>2]|0)==7247){f[a+52>>2]=0;f[a+56>>2]=0;f[a+44>>2]=0}f[a+72>>2]=0;c=a+80|0;e=f[c>>2]|0;if(e|0){if((f[d>>2]|0)!=-4)poc(e);f[c>>2]=0}f[d>>2]=0;f[a+8>>2]=0;f[a+88>>2]=0;b=0;return b|0}function unc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+80|0;h=f[g>>2]|0;if(h|0){if((f[a+76>>2]|0)!=-4)poc(h);f[g>>2]=0}switch(b|0){case 0:case -5:break;default:f[a>>2]=0}h=a+76|0;f[h>>2]=b;if((b|0)==-4|(c|0)==0){u=d;return}b=f[a+20>>2]|0;a=Mpc(b)|0;i=ooc(a+3+(Mpc(c)|0)|0)|0;f[g>>2]=i;if(!i){f[h>>2]=-4;u=d;return}else{h=Mpc(b)|0;g=h+3+(Mpc(c)|0)|0;f[e>>2]=b;f[e+4>>2]=509015;f[e+8>>2]=c;gqc(i,g,509008,e)|0;u=d;return}}function vnc(a){a=a|0;var b=0;if((a|0)!=0?(f[a+12>>2]|0)==7247:0)b=f[a+56>>2]|0;else b=0;return b|0}function wnc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+44|0;c=a+52|0;d=a+88|0;e=a+24|0;g=a+100|0;h=a+36|0;i=a+96|0;a:while(1){switch(f[b>>2]|0){case 1:{j=5;break a;break}case 0:{if((ync(a)|0)==-1){k=-1;j=16;break a}if(!(f[b>>2]|0)){k=0;j=16;break a}break}case 2:{f[g>>2]=f[e>>2]<<1;f[i>>2]=f[h>>2];if((xnc(a)|0)==-1){k=-1;j=16;break a}break}default:{}}if(f[a>>2]|0){k=0;j=16;break}if(!(f[c>>2]|0))continue;if(!(f[d>>2]|0)){k=0;j=16;break}}if((j|0)==5){d=f[h>>2]|0;i=f[e>>2]<<1;f[a>>2]=0;e=a+16|0;g=0;do{b=i-g|0;l=Nrc(f[e>>2]|0,d+g|0,b>>>0<1073741824?b:1073741824)|0;if((l|0)<1){j=8;break}g=(f[a>>2]|0)+l|0;f[a>>2]=g}while(g>>>0<i>>>0);do if((j|0)==8){if((l|0)>=0){f[c>>2]=1;break}i=zoc()|0;unc(a,-1,Yoc(f[i>>2]|0)|0);k=-1;return k|0}while(0);f[a+4>>2]=f[h>>2];k=0;return k|0}else if((j|0)==16)return k|0;return 0}function xnc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=a+84|0;c=a+100|0;d=f[c>>2]|0;e=a+88|0;g=a+76|0;h=a+52|0;i=a+32|0;j=a+24|0;k=a+16|0;l=0;a:while(1){if(!(f[e>>2]|0)){switch(f[g>>2]|0){case -5:case 0:break;default:{m=-1;n=20;break a}}if(f[h>>2]|0){n=12;break}o=f[i>>2]|0;p=f[j>>2]|0;q=0;while(1){r=p-q|0;s=Nrc(f[k>>2]|0,o+q|0,r>>>0<1073741824?r:1073741824)|0;if((s|0)<1){n=8;break}r=s+q|0;if(r>>>0<p>>>0)q=r;else{t=r;break}}if((n|0)==8){n=0;if((s|0)<0){n=10;break}f[h>>2]=1;t=q}p=(f[e>>2]|0)+t|0;f[e>>2]=p;f[b>>2]=f[i>>2];if(!p){n=12;break}}p=Jnc(b,0)|0;switch(p|0){case 2:case -2:{n=14;break a;break}case -4:{n=15;break a;break}case -3:{n=16;break a;break}default:{}}o=f[c>>2]|0;if((p|0)!=1&(o|0)!=0)l=p;else{u=p;v=o;break}}if((n|0)==10){b=zoc()|0;unc(a,-1,Yoc(f[b>>2]|0)|0);m=-1;return m|0}else if((n|0)==12){unc(a,-5,509018);u=l;v=f[c>>2]|0}else if((n|0)==14){unc(a,-2,509041);m=-1;return m|0}else if((n|0)==15){unc(a,-4,509141);m=-1;return m|0}else if((n|0)==16){c=f[a+108>>2]|0;unc(a,-3,(c|0)==0?509080:c);m=-1;return m|0}else if((n|0)==20)return m|0;n=d-v|0;f[a>>2]=n;f[a+4>>2]=(f[a+96>>2]|0)+(0-n);if((u|0)!=1){m=0;return m|0}f[a+44>>2]=0;m=0;return m|0}function ync(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+84|0;d=a+24|0;if(!(f[d>>2]|0)){e=f[a+28>>2]|0;g=ooc(e)|0;h=a+32|0;f[h>>2]=g;i=ooc(e<<1)|0;j=a+36|0;f[j>>2]=i;if((g|0)==0|(i|0)==0){poc(i);poc(f[h>>2]|0);unc(a,-4,509141);k=-1;return k|0}f[d>>2]=e;f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;e=a+88|0;f[e>>2]=0;f[c>>2]=0;if(!(Inc(c,31,509155,56)|0))l=e;else{poc(f[j>>2]|0);poc(f[h>>2]|0);f[d>>2]=0;unc(a,-4,509141);k=-1;return k|0}}else l=a+88|0;h=f[l>>2]|0;a:do if(h>>>0<2){switch(f[a+76>>2]|0){case -5:case 0:break;default:{k=-1;return k|0}}j=a+52|0;if(!(f[j>>2]|0)){e=a+32|0;if(!h)m=0;else{b[f[e>>2]>>0]=b[f[c>>2]>>0]|0;m=f[l>>2]|0}i=(f[e>>2]|0)+m|0;g=(f[d>>2]|0)-m|0;n=a+16|0;o=0;while(1){p=g-o|0;q=Nrc(f[n>>2]|0,i+o|0,p>>>0<1073741824?p:1073741824)|0;if((q|0)<1){r=15;break}p=q+o|0;if(p>>>0<g>>>0)o=p;else{s=p;break}}do if((r|0)==15){if((q|0)>=0){f[j>>2]=1;s=o;break}g=zoc()|0;unc(a,-1,Yoc(f[g>>2]|0)|0);k=-1;return k|0}while(0);o=(f[l>>2]|0)+s|0;f[l>>2]=o;f[c>>2]=f[e>>2];t=o}else t=h;switch(t|0){case 1:{u=1;break a;break}case 0:{k=0;break}default:{v=t;r=20;break a}}return k|0}else{v=h;r=20}while(0);if((r|0)==20){r=f[c>>2]|0;if((b[r>>0]|0)==31?(b[r+1>>0]|0)==-117:0){Gnc(c)|0;f[a+44>>2]=2;f[a+40>>2]=0;k=0;return k|0}else u=v}v=a+40|0;if(!(f[v>>2]|0)){f[l>>2]=0;f[a+52>>2]=1;f[a>>2]=0;k=0;return k|0}else{r=f[a+36>>2]|0;f[a+4>>2]=r;dJc(r|0,f[c>>2]|0,u|0)|0;f[a>>2]=f[l>>2];f[l>>2]=0;f[a+44>>2]=1;f[v>>2]=1;k=0;return k|0}return 0}function znc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((a|0)==0|(c|0)==0|(d|0)<1){e=0;return e|0}if((f[a+12>>2]|0)!=7247){e=0;return e|0}switch(f[a+76>>2]|0){case -5:case 0:break;default:{e=0;return e|0}}g=a+72|0;a:do if(f[g>>2]|0?(f[g>>2]=0,h=f[a+68>>2]|0,i=a+88|0,j=a+52|0,k=a+4|0,l=a+8|0,h|0):0){m=h;b:while(1){while(1){n=f[a>>2]|0;if(n|0)break;if(f[j>>2]|0?(f[i>>2]|0)==0:0)break a;if((wnc(a)|0)==-1){e=0;break b}}h=(n|0)<0|(n|0)>(m|0)?m:n;f[a>>2]=n-h;f[k>>2]=(f[k>>2]|0)+h;f[l>>2]=(f[l>>2]|0)+h;m=m-h|0;if(!m)break a}return e|0}while(0);n=d+-1|0;if(!n){e=0;return e|0}d=a+4|0;g=a+8|0;m=c;l=n;n=f[a>>2]|0;while(1){if(!n){if((wnc(a)|0)==-1){e=0;o=21;break}k=f[a>>2]|0;if(!k){o=17;break}else p=k}else p=n;k=p>>>0>l>>>0?l:p;i=f[d>>2]|0;j=Zoc(i,10,k)|0;h=(j|0)==0;q=h?k:1-i+j|0;dJc(m|0,i|0,q|0)|0;n=(f[a>>2]|0)-q|0;f[a>>2]=n;f[d>>2]=(f[d>>2]|0)+q;f[g>>2]=(f[g>>2]|0)+q;l=l-q|0;i=m+q|0;if(!(h&(l|0)!=0)){r=i;break}else m=i}if((o|0)==17){f[a+56>>2]=1;r=m}else if((o|0)==21)return e|0;if((r|0)==(c|0)){e=0;return e|0}b[r>>0]=0;e=c;return e|0}function Anc(a){a=a|0;var b=0,c=0,d=0;if(!a){b=-2;return b|0}if((f[a+12>>2]|0)!=7247){b=-2;return b|0}if(f[a+24>>2]|0){Lnc(a+84|0)|0;poc(f[a+36>>2]|0);poc(f[a+32>>2]|0)}c=(f[a+76>>2]|0)==-5?-5:0;unc(a,0,0);poc(f[a+20>>2]|0);d=Goc(f[a+16>>2]|0)|0;poc(a);b=d|0?-1:c;return b|0}function Bnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if(!c){d=0;return d|0}e=a+24|0;if((f[e>>2]|0)==0?(Cnc(a)|0)==-1:0){d=0;return d|0}g=a+72|0;a:do if(f[g>>2]|0){f[g>>2]=0;h=f[a+68>>2]|0;i=a+84|0;j=a+88|0;if(f[j>>2]|0?(Dnc(a,0)|0)==-1:0){d=0;return d|0}if(h|0){k=a+32|0;l=a+8|0;m=h;h=0;while(1){n=f[e>>2]|0;o=(n|0)<0|(n|0)>(m|0)?m:n;if(!h)XIc(f[k>>2]|0,0,o|0)|0;f[j>>2]=o;f[i>>2]=f[k>>2];f[l>>2]=(f[l>>2]|0)+o;m=m-o|0;if((Dnc(a,0)|0)==-1){d=0;break}if(!m)break a;else h=1}return d|0}}while(0);g=a+88|0;if((f[e>>2]|0)>>>0<=c>>>0){if(!(f[g>>2]|0)){p=a+84|0;f[p>>2]=b;q=a+8|0;f[g>>2]=c;r=f[q>>2]|0;s=r+c|0;f[q>>2]=s;t=Dnc(a,0)|0;u=(t|0)==-1;v=u?0:c;return v|0}if((Dnc(a,0)|0)==-1){d=0;return d|0}else{p=a+84|0;f[p>>2]=b;q=a+8|0;f[g>>2]=c;r=f[q>>2]|0;s=r+c|0;f[q>>2]=s;t=Dnc(a,0)|0;u=(t|0)==-1;v=u?0:c;return v|0}}v=a+32|0;u=a+84|0;t=a+8|0;s=b;b=c;while(1){q=f[g>>2]|0;r=f[v>>2]|0;if(!q){f[u>>2]=r;w=r}else w=f[u>>2]|0;p=w+q|0;q=r-p+(f[e>>2]|0)|0;r=q>>>0>b>>>0?b:q;dJc(p|0,s|0,r|0)|0;f[g>>2]=r+(f[g>>2]|0);f[t>>2]=r+(f[t>>2]|0);b=b-r|0;if(!b){d=c;x=23;break}if((Dnc(a,0)|0)==-1){d=0;x=23;break}else s=s+r|0}if((x|0)==23)return d|0;return 0}function Cnc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+84|0;c=a+28|0;d=f[c>>2]|0;e=ooc(d<<1)|0;g=a+32|0;f[g>>2]=e;if(!e){unc(a,-4,509141);h=-1;return h|0}i=a+40|0;if(f[i>>2]|0){f[a+24>>2]=d;h=0;return h|0}j=ooc(d)|0;d=a+36|0;f[d>>2]=j;if(!j){poc(e);unc(a,-4,509141);h=-1;return h|0}f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;if(Unc(b,f[a+60>>2]|0,8,31,8,f[a+64>>2]|0,509155,56)|0){poc(f[d>>2]|0);poc(f[g>>2]|0);unc(a,-4,509141);h=-1;return h|0}f[b>>2]=0;b=f[c>>2]|0;c=f[i>>2]|0;f[a+24>>2]=b;if(c|0){h=0;return h|0}f[a+100>>2]=b;b=f[a+36>>2]|0;f[a+96>>2]=b;f[a+4>>2]=b;h=0;return h|0}function Dnc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+84|0;d=a+24|0;if((f[d>>2]|0)==0?(Cnc(a)|0)==-1:0){e=-1;return e|0}if(f[a+40>>2]|0){g=a+88|0;h=f[g>>2]|0;if(!h){e=0;return e|0}i=a+16|0;j=h;h=f[c>>2]|0;while(1){k=Mrc(f[i>>2]|0,h,j>>>0<1073741824?j:1073741824)|0;if((k|0)<0)break;j=(f[g>>2]|0)-k|0;f[g>>2]=j;h=(f[c>>2]|0)+k|0;f[c>>2]=h;if(!j){e=0;l=41;break}}if((l|0)==41)return e|0;j=zoc()|0;unc(a,-1,Yoc(f[j>>2]|0)|0);e=-1;return e|0}j=a+100|0;h=a+96|0;g=a+4|0;i=a+36|0;k=a+16|0;a:do switch(b|0){case 0:{m=f[j>>2]|0;while(1){do if(!m){n=f[h>>2]|0;o=f[g>>2]|0;if(n>>>0>o>>>0){p=n;n=o;do{o=p-n|0;q=Mrc(f[k>>2]|0,n,(o|0)<1073741824?o:1073741824)|0;if((q|0)<0){l=31;break a}n=(f[g>>2]|0)+q|0;f[g>>2]=n;p=f[h>>2]|0}while(p>>>0>n>>>0);n=f[j>>2]|0;if(n|0){r=n;break}}n=f[d>>2]|0;f[j>>2]=n;p=f[i>>2]|0;f[h>>2]=p;f[g>>2]=p;r=n}else r=m;while(0);if((boc(c,0)|0)==-2){l=37;break a}m=f[j>>2]|0;if((r|0)==(m|0)){l=39;break}}break}case 4:{m=0;n=f[j>>2]|0;while(1){if((n|0)==0|(m|0)==1){p=f[h>>2]|0;q=f[g>>2]|0;if(p>>>0>q>>>0){o=p;p=q;do{q=o-p|0;s=Mrc(f[k>>2]|0,p,(q|0)<1073741824?q:1073741824)|0;if((s|0)<0){l=31;break a}p=(f[g>>2]|0)+s|0;f[g>>2]=p;o=f[h>>2]|0}while(o>>>0>p>>>0);t=f[j>>2]|0}else t=n;if(!t){p=f[d>>2]|0;f[j>>2]=p;o=f[i>>2]|0;f[h>>2]=o;f[g>>2]=o;u=p}else u=t}else u=n;m=boc(c,4)|0;if((m|0)==-2){l=37;break a}n=f[j>>2]|0;if((u|0)==(n|0)){l=39;break}}break}default:while(1){n=f[h>>2]|0;m=f[g>>2]|0;if(n>>>0>m>>>0){p=n;n=m;do{m=p-n|0;o=Mrc(f[k>>2]|0,n,(m|0)<1073741824?m:1073741824)|0;if((o|0)<0){l=31;break a}n=(f[g>>2]|0)+o|0;f[g>>2]=n;p=f[h>>2]|0}while(p>>>0>n>>>0)}n=f[j>>2]|0;if(!n){p=f[d>>2]|0;f[j>>2]=p;o=f[i>>2]|0;f[h>>2]=o;f[g>>2]=o;v=p}else v=n;if((boc(c,b)|0)==-2){l=37;break a}if((v|0)==(f[j>>2]|0)){l=39;break}}}while(0);if((l|0)==31){j=zoc()|0;unc(a,-1,Yoc(f[j>>2]|0)|0);e=-1;return e|0}else if((l|0)==37){unc(a,-2,509102);e=-1;return e|0}else if((l|0)==39){if((b|0)!=4){e=0;return e|0}aoc(c)|0;e=0;return e|0}return 0}function Enc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!a){c=-1;return c|0}if((f[a+12>>2]|0)!=31153){c=-1;return c|0}if(f[a+76>>2]|0){c=-1;return c|0}d=Mpc(b)|0;e=Bnc(a,b,d)|0;c=(d|0)!=0&(e|0)==0?-1:e;return c|0}function Fnc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!a){b=-2;return b|0}if((f[a+12>>2]|0)!=31153){b=-2;return b|0}c=a+72|0;a:do if(!(f[c>>2]|0))d=0;else{f[c>>2]=0;e=f[a+68>>2]|0;g=a+88|0;if(!((f[g>>2]|0)!=0?(Dnc(a,0)|0)==-1:0))h=6;b:do if((h|0)==6){if(!e){d=0;break a}i=a+24|0;j=a+32|0;k=a+84|0;l=a+8|0;m=e;n=0;while(1){o=f[i>>2]|0;p=(o|0)<0|(o|0)>(m|0)?m:o;if(!n)XIc(f[j>>2]|0,0,p|0)|0;f[g>>2]=p;f[k>>2]=f[j>>2];f[l>>2]=(f[l>>2]|0)+p;m=m-p|0;if((Dnc(a,0)|0)==-1)break b;if(!m){d=0;break a}else n=1}}while(0);d=f[a+76>>2]|0}while(0);if((Dnc(a,4)|0)==-1)q=f[a+76>>2]|0;else q=d;if(f[a+24>>2]|0){if(!(f[a+40>>2]|0)){Vnc(a+84|0)|0;poc(f[a+36>>2]|0)}poc(f[a+32>>2]|0)}unc(a,0,0);poc(f[a+20>>2]|0);d=(Goc(f[a+16>>2]|0)|0)==-1;poc(a);b=d?-1:q;return b|0}function Gnc(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}if(!(f[a+36>>2]|0)){b=-2;return b|0}c=f[a+28>>2]|0;if(!c){b=-2;return b|0}if((f[c>>2]|0)!=(a|0)){b=-2;return b|0}d=c+4|0;if(((f[d>>2]|0)+-16180|0)>>>0>31){b=-2;return b|0}f[c+44>>2]=0;f[c+48>>2]=0;f[c+52>>2]=0;f[c+32>>2]=0;f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;e=f[c+12>>2]|0;if(e|0)f[a+48>>2]=e&1;f[d>>2]=16180;f[c+8>>2]=0;f[c+16>>2]=0;f[c+24>>2]=32768;f[c+36>>2]=0;f[c+60>>2]=0;f[c+64>>2]=0;d=c+1332|0;f[c+112>>2]=d;f[c+84>>2]=d;f[c+80>>2]=d;f[c+7108>>2]=1;f[c+7112>>2]=-1;b=0;return b|0}function Hnc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(!a){c=-2;return c|0}d=a+32|0;if(!(f[d>>2]|0)){c=-2;return c|0}e=a+36|0;g=f[e>>2]|0;if(!g){c=-2;return c|0}h=a+28|0;i=f[h>>2]|0;if(!i){c=-2;return c|0}if((f[i>>2]|0)!=(a|0)){c=-2;return c|0}if(((f[i+4>>2]|0)+-16180|0)>>>0>31){c=-2;return c|0}if((b|0)<0){j=0;k=0-b|0}else{j=(b>>>4)+5|0;k=(b|0)<48?b&15:b}if(!((k|0)==0|(k&-8|0)==8)){c=-2;return c|0}b=i+56|0;l=f[b>>2]|0;m=i+40|0;if((l|0)!=0?(f[m>>2]|0)!=(k|0):0){mi[g&2047](f[a+40>>2]|0,l);f[b>>2]=0;b=f[d>>2]|0;f[i+12>>2]=j;f[m>>2]=k;if(!b){c=-2;return c|0}}else{f[i+12>>2]=j;f[m>>2]=k}if(!(f[e>>2]|0)){c=-2;return c|0}e=f[h>>2]|0;if(!e){c=-2;return c|0}if((f[e>>2]|0)!=(a|0)){c=-2;return c|0}h=e+4|0;if(((f[h>>2]|0)+-16180|0)>>>0>31){c=-2;return c|0}f[e+44>>2]=0;f[e+48>>2]=0;f[e+52>>2]=0;f[e+32>>2]=0;f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;k=f[e+12>>2]|0;if(k|0)f[a+48>>2]=k&1;f[h>>2]=16180;f[e+8>>2]=0;f[e+16>>2]=0;f[e+24>>2]=32768;f[e+36>>2]=0;f[e+60>>2]=0;f[e+64>>2]=0;h=e+1332|0;f[e+112>>2]=h;f[e+84>>2]=h;f[e+80>>2]=h;f[e+7108>>2]=1;f[e+7112>>2]=-1;c=0;return c|0}function Inc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;if(!d){g=-6;return g|0}if((e|0)!=56|(b[d>>0]|0)!=49){g=-6;return g|0}if(!a){g=-2;return g|0}f[a+24>>2]=0;d=a+32|0;e=f[d>>2]|0;if(!e){f[d>>2]=308;f[a+40>>2]=0;h=308}else h=e;e=a+36|0;if(!(f[e>>2]|0))f[e>>2]=1240;d=a+40|0;i=hj[h&511](f[d>>2]|0,1,7120)|0;if(!i){g=-4;return g|0}h=a+28|0;f[h>>2]=i;f[i>>2]=a;f[i+56>>2]=0;f[i+4>>2]=16180;j=Hnc(a,c)|0;if(!j){g=0;return g|0}mi[f[e>>2]&2047](f[d>>2]|0,i);f[h>>2]=0;g=j;return g|0}function Jnc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0;e=u;u=u+16|0;g=e;if(!a){i=-2;u=e;return i|0}if(!(f[a+32>>2]|0)){i=-2;u=e;return i|0}if(!(f[a+36>>2]|0)){i=-2;u=e;return i|0}k=f[a+28>>2]|0;if(!k){i=-2;u=e;return i|0}if((f[k>>2]|0)!=(a|0)){i=-2;u=e;return i|0}l=k+4|0;m=f[l>>2]|0;if((m+-16180|0)>>>0>31){i=-2;u=e;return i|0}n=a+12|0;o=f[n>>2]|0;if(!o){i=-2;u=e;return i|0}p=f[a>>2]|0;if((p|0)==0?f[a+4>>2]|0:0){i=-2;u=e;return i|0}if((m|0)==16191){f[l>>2]=16192;q=16192}else q=m;m=a+16|0;r=f[m>>2]|0;s=a+4|0;t=f[s>>2]|0;v=k+60|0;w=k+64|0;x=k+12|0;y=k+40|0;z=k+28|0;A=g+1|0;B=k+20|0;C=k+36|0;D=a+24|0;E=k+24|0;F=a+48|0;G=k+68|0;H=k+16|0;I=(c+-5|0)>>>0<2;J=k+8|0;K=k+80|0;L=k+88|0;M=k+84|0;N=k+92|0;O=(c|0)==6;P=k+7112|0;Q=k+76|0;R=k+7116|0;S=k+72|0;T=k+48|0;U=k+7108|0;V=k+52|0;W=k+56|0;X=k+44|0;Y=a+20|0;Z=k+32|0;_=g+2|0;$=g+3|0;aa=k+108|0;ba=k+100|0;ca=k+104|0;da=k+628|0;ea=k+1332|0;fa=k+112|0;ga=k+116|0;ha=k+756|0;ia=k+96|0;ja=0;ka=r;la=t;ma=p;p=r;r=f[w>>2]|0;na=f[v>>2]|0;oa=o;o=q;a:while(1){b:do switch(o|0){case 16208:{pa=r;qa=na;ra=la;sa=ma;ta=1;ua=ka;va=296;break a;break}case 16209:{wa=p;xa=r;ya=na;za=la;Aa=ma;Ba=-3;Ca=ka;break a;break}case 16210:{va=310;break a;break}case 16180:{q=f[x>>2]|0;if(!q){f[l>>2]=16192;Da=ja;Ea=ka;Fa=la;Ga=oa;Ha=ma;Ia=p;Ja=r;Ka=na;break b}if(r>>>0<16){La=la;Ma=ma;Na=r;Oa=na;while(1){if(!La){wa=p;xa=Na;ya=Oa;za=0;Aa=Ma;Ba=ja;Ca=ka;break a}Pa=La+-1|0;Qa=Ma+1|0;Ra=(h[Ma>>0]<<Na)+Oa|0;Sa=Na+8|0;if(Sa>>>0<16){La=Pa;Ma=Qa;Na=Sa;Oa=Ra}else{Ta=Pa;Ua=Qa;Va=Sa;Wa=Ra;break}}}else{Ta=la;Ua=ma;Va=r;Wa=na}if((Wa|0)==35615&(q&2|0)!=0){if(!(f[y>>2]|0))f[y>>2]=15;Oa=Tnc(0,0,0)|0;f[z>>2]=Oa;b[g>>0]=31;b[A>>0]=-117;Na=Tnc(Oa,g,2)|0;f[z>>2]=Na;f[l>>2]=16181;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=0;Ka=0;break b}f[B>>2]=0;Na=f[C>>2]|0;if(Na|0)f[Na+48>>2]=-1;if(q&1|0?((((Wa<<8&65280)+(Wa>>>8)|0)>>>0)%31|0|0)==0:0){if((Wa&15|0)!=8){f[D>>2]=509185;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va;Ka=Wa;break b}Na=Wa>>>4;Oa=Na&15;Ma=Oa+8|0;La=f[y>>2]|0;if(!La){f[y>>2]=Ma;Xa=Ma}else Xa=La;if(Ma>>>0>15|Ma>>>0>Xa>>>0){f[D>>2]=509212;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va+-4|0;Ka=Na;break b}else{f[E>>2]=256<<Oa;Oa=Rnc(0,0,0)|0;f[z>>2]=Oa;f[F>>2]=Oa;f[l>>2]=Wa>>>12&2^16191;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=0;Ka=0;break b}}f[D>>2]=509162;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va;Ka=Wa;break}case 16181:{if(r>>>0<16){Oa=la;Na=ma;Ma=r;La=na;while(1){if(!Oa){wa=p;xa=Ma;ya=La;za=0;Aa=Na;Ba=ja;Ca=ka;break a}Ra=Oa+-1|0;Sa=Na+1|0;Qa=(h[Na>>0]<<Ma)+La|0;Pa=Ma+8|0;if(Pa>>>0<16){Oa=Ra;Na=Sa;Ma=Pa;La=Qa}else{Ya=Ra;Za=Sa;_a=Pa;$a=Qa;break}}}else{Ya=la;Za=ma;_a=r;$a=na}f[B>>2]=$a;if(($a&255|0)!=8){f[D>>2]=509185;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ya;Ga=oa;Ha=Za;Ia=p;Ja=_a;Ka=$a;break b}if($a&57344|0){f[D>>2]=509232;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ya;Ga=oa;Ha=Za;Ia=p;Ja=_a;Ka=$a;break b}La=f[C>>2]|0;if(La|0)f[La>>2]=$a>>>8&1;if($a&512|0?f[x>>2]&4|0:0){b[g>>0]=$a;b[A>>0]=$a>>>8;La=Tnc(f[z>>2]|0,g,2)|0;f[z>>2]=La}f[l>>2]=16182;ab=Ya;bb=Za;cb=0;db=0;va=55;break}case 16182:{if(r>>>0<32){ab=la;bb=ma;cb=r;db=na;va=55}else{eb=la;fb=ma;gb=na;va=57}break}case 16183:{if(r>>>0<16){hb=la;ib=ma;jb=r;kb=na;va=64}else{lb=la;mb=ma;nb=na;va=66}break}case 16184:{ob=la;pb=ma;qb=r;rb=na;va=72;break}case 16185:{sb=la;tb=ma;ub=r;vb=na;va=84;break}case 16186:{wb=la;xb=ma;yb=r;zb=na;va=95;break}case 16187:{Ab=r;Bb=na;Cb=la;Db=ma;va=109;break}case 16188:{Eb=r;Fb=na;Gb=la;Hb=ma;va=123;break}case 16189:{if(r>>>0<32){La=r;Ma=na;Na=la;Oa=ma;while(1){if(!Na){wa=p;xa=La;ya=Ma;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}q=Na+-1|0;Qa=Oa+1|0;Pa=(h[Oa>>0]<<La)+Ma|0;La=La+8|0;if(La>>>0>=32){Ib=Pa;Jb=q;Kb=Qa;break}else{Ma=Pa;Na=q;Oa=Qa}}}else{Ib=na;Jb=la;Kb=ma}Oa=hJc(Ib|0)|0;f[z>>2]=Oa;f[F>>2]=Oa;f[l>>2]=16190;Lb=0;Mb=0;Nb=Jb;Ob=Kb;va=136;break}case 16190:{Lb=r;Mb=na;Nb=la;Ob=ma;va=136;break}case 16191:{Pb=r;Qb=na;Rb=la;Sb=ma;va=139;break}case 16192:{Tb=r;Ub=na;Vb=la;Wb=ma;va=140;break}case 16193:{Oa=r&7;Na=na>>>Oa;Ma=r-Oa|0;if(Ma>>>0<32){Oa=Ma;La=Na;Qa=la;q=ma;while(1){if(!Qa){wa=p;xa=Oa;ya=La;za=0;Aa=q;Ba=ja;Ca=ka;break a}Pa=Qa+-1|0;Sa=q+1|0;Ra=(h[q>>0]<<Oa)+La|0;Xb=Oa+8|0;if(Xb>>>0<32){Oa=Xb;La=Ra;Qa=Pa;q=Sa}else{Yb=Xb;Zb=Ra;_b=Pa;$b=Sa;break}}}else{Yb=Ma;Zb=Na;_b=la;$b=ma}q=Zb&65535;if((q|0)==(Zb>>>16^65535|0)){f[G>>2]=q;f[l>>2]=16194;if(O){pa=0;qa=0;ra=_b;sa=$b;ta=ja;ua=ka;va=296;break a}else{ac=0;bc=0;cc=_b;dc=$b;va=159;break b}}else{f[D>>2]=509296;f[l>>2]=16209;Da=ja;Ea=ka;Fa=_b;Ga=oa;Ha=$b;Ia=p;Ja=Yb;Ka=Zb;break b}break}case 16194:{ac=r;bc=na;cc=la;dc=ma;va=159;break}case 16195:{ec=r;fc=na;gc=la;hc=ma;va=160;break}case 16196:{if(r>>>0<14){q=r;Qa=na;La=la;Oa=ma;while(1){if(!La){wa=p;xa=q;ya=Qa;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}Sa=La+-1|0;Pa=Oa+1|0;Ra=(h[Oa>>0]<<q)+Qa|0;Xb=q+8|0;if(Xb>>>0<14){q=Xb;Qa=Ra;La=Sa;Oa=Pa}else{ic=Xb;jc=Ra;kc=Sa;lc=Pa;break}}}else{ic=r;jc=na;kc=la;lc=ma}Oa=(jc&31)+257|0;f[ba>>2]=Oa;La=(jc>>>5&31)+1|0;f[ca>>2]=La;Qa=(jc>>>10&15)+4|0;f[ia>>2]=Qa;q=jc>>>14;Na=ic+-14|0;if(Oa>>>0>286|La>>>0>30){f[D>>2]=509325;f[l>>2]=16209;Da=ja;Ea=ka;Fa=kc;Ga=oa;Ha=lc;Ia=p;Ja=Na;Ka=q;break b}else{f[aa>>2]=0;f[l>>2]=16197;mc=Na;nc=q;oc=kc;pc=lc;qc=Qa;rc=0;va=170;break b}break}case 16197:{Qa=f[aa>>2]|0;q=f[ia>>2]|0;if(Qa>>>0<q>>>0){mc=r;nc=na;oc=la;pc=ma;qc=q;rc=Qa;va=170}else{sc=r;tc=na;uc=la;vc=ma;wc=Qa;va=171}break}case 16198:{xc=ja;yc=r;zc=na;Ac=la;Bc=ma;Cc=f[aa>>2]|0;va=181;break}case 16199:{Dc=ja;Ec=r;Fc=na;Gc=la;Hc=ma;va=214;break}case 16200:{Ic=ja;Jc=r;Kc=na;Lc=la;Mc=ma;va=215;break}case 16201:{Nc=r;Oc=na;Pc=ja;Qc=la;Rc=ma;Sc=f[Q>>2]|0;va=233;break}case 16202:{Tc=r;Uc=na;Vc=la;Wc=ma;Xc=ja;va=240;break}case 16203:{Yc=r;Zc=na;_c=la;$c=ma;ad=ja;bd=f[Q>>2]|0;va=252;break}case 16204:{cd=r;dd=na;ed=la;fd=ma;gd=ja;va=258;break}case 16205:{if(!ka){pa=r;qa=na;ra=la;sa=ma;ta=ja;ua=0;va=296;break a}b[oa>>0]=f[G>>2];f[l>>2]=16200;Da=ja;Ea=ka+-1|0;Fa=la;Ga=oa+1|0;Ha=ma;Ia=p;Ja=r;Ka=na;break}case 16206:{Qa=f[x>>2]|0;if(Qa){if(r>>>0<32){q=na;Na=r;La=la;Oa=ma;while(1){if(!La){wa=p;xa=Na;ya=q;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}Ma=La+-1|0;Pa=Oa+1|0;Sa=(h[Oa>>0]<<Na)+q|0;Ra=Na+8|0;if(Ra>>>0<32){q=Sa;Na=Ra;La=Ma;Oa=Pa}else{hd=Ra;id=Sa;jd=Ma;kd=Pa;break}}}else{hd=r;id=na;jd=la;kd=ma}Oa=p-ka|0;f[Y>>2]=(f[Y>>2]|0)+Oa;f[Z>>2]=(f[Z>>2]|0)+Oa;if((Oa|0)!=0&(Qa&4|0)!=0){La=f[z>>2]|0;Na=oa+(0-Oa)|0;if(!(f[B>>2]|0))ld=Rnc(La,Na,Oa)|0;else ld=Tnc(La,Na,Oa)|0;f[z>>2]=ld;f[F>>2]=ld;md=f[x>>2]|0}else md=Qa;if((md&4|0)!=0?(Oa=(f[B>>2]|0)==0,Na=hJc(id|0)|0,((Oa?Na:id)|0)!=(f[z>>2]|0)):0){f[D>>2]=509499;f[l>>2]=16209;Da=ja;Ea=ka;Fa=jd;Ga=oa;Ha=kd;Ia=ka;Ja=hd;Ka=id;break b}else{nd=ka;od=0;pd=0;qd=jd;rd=kd;sd=md}}else{nd=p;od=r;pd=na;qd=la;rd=ma;sd=0}f[l>>2]=16207;td=nd;ud=od;vd=pd;wd=qd;xd=rd;yd=sd;va=288;break}case 16207:{td=p;ud=r;vd=na;wd=la;xd=ma;yd=f[x>>2]|0;va=288;break}default:{i=-2;va=311;break a}}while(0);if((va|0)==55)while(1){va=0;if(!ab){wa=p;xa=cb;ya=db;za=0;Aa=bb;Ba=ja;Ca=ka;break a}Na=ab+-1|0;Oa=bb+1|0;La=(h[bb>>0]<<cb)+db|0;cb=cb+8|0;if(cb>>>0>=32){eb=Na;fb=Oa;gb=La;va=57;break}else{ab=Na;bb=Oa;db=La;va=55}}else if((va|0)==136){va=0;if(!(f[H>>2]|0)){va=137;break}La=Rnc(0,0,0)|0;f[z>>2]=La;f[F>>2]=La;f[l>>2]=16191;Pb=Lb;Qb=Mb;Rb=Nb;Sb=Ob;va=139}else if((va|0)==159){va=0;f[l>>2]=16195;ec=ac;fc=bc;gc=cc;hc=dc;va=160}else if((va|0)==170){va=0;La=mc;Oa=nc;Na=oc;q=pc;Pa=rc;while(1){if(La>>>0<3){if(!Na){wa=p;xa=La;ya=Oa;za=0;Aa=q;Ba=ja;Ca=ka;break a}zd=La+8|0;Ad=(h[q>>0]<<La)+Oa|0;Bd=Na+-1|0;Cd=q+1|0}else{zd=La;Ad=Oa;Bd=Na;Cd=q}Ma=Pa+1|0;f[aa>>2]=Ma;d[k+116+(j[187856+(Pa<<1)>>1]<<1)>>1]=Ad&7;Sa=Ad>>>3;Ra=zd+-3|0;if(Ma>>>0<qc>>>0){La=Ra;Oa=Sa;Na=Bd;q=Cd;Pa=Ma}else{sc=Ra;tc=Sa;uc=Bd;vc=Cd;wc=Ma;va=171;break}}}else if((va|0)==288){va=0;if(!yd){Dd=ud;Ed=vd;Fd=wd;Gd=xd;va=295;break}if(!(f[B>>2]|0)){Dd=ud;Ed=vd;Fd=wd;Gd=xd;va=295;break}if(ud>>>0<32){Pa=vd;q=ud;Na=xd;Oa=wd;while(1){if(!Oa){wa=td;xa=q;ya=Pa;za=0;Aa=Na;Ba=ja;Ca=ka;break a}La=Oa+-1|0;Ma=Na+1|0;Sa=(h[Na>>0]<<q)+Pa|0;Ra=q+8|0;if(Ra>>>0<32){Pa=Sa;q=Ra;Na=Ma;Oa=La}else{Hd=Ra;Id=Sa;Jd=La;Kd=Ma;break}}}else{Hd=ud;Id=vd;Jd=wd;Kd=xd}if((Id|0)==(f[Z>>2]|0)){Dd=0;Ed=0;Fd=Jd;Gd=Kd;va=295;break}f[D>>2]=509520;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Jd;Ga=oa;Ha=Kd;Ia=td;Ja=Hd;Ka=Id}do if((va|0)==57){va=0;Oa=f[C>>2]|0;if(Oa|0)f[Oa+4>>2]=gb;if(f[B>>2]&512|0?f[x>>2]&4|0:0){b[g>>0]=gb;b[A>>0]=gb>>>8;b[_>>0]=gb>>>16;b[$>>0]=gb>>>24;Oa=Tnc(f[z>>2]|0,g,4)|0;f[z>>2]=Oa}f[l>>2]=16183;hb=eb;ib=fb;jb=0;kb=0;va=64}else if((va|0)==139){va=0;if(I){pa=Pb;qa=Qb;ra=Rb;sa=Sb;ta=ja;ua=ka;va=296;break a}else{Tb=Pb;Ub=Qb;Vb=Rb;Wb=Sb;va=140}}else if((va|0)==160){va=0;Oa=f[G>>2]|0;if(!Oa){f[l>>2]=16191;Da=ja;Ea=ka;Fa=gc;Ga=oa;Ha=hc;Ia=p;Ja=ec;Ka=fc;break}Na=Oa>>>0>gc>>>0?gc:Oa;Oa=Na>>>0>ka>>>0?ka:Na;if(!Oa){pa=ec;qa=fc;ra=gc;sa=hc;ta=ja;ua=ka;va=296;break a}dJc(oa|0,hc|0,Oa|0)|0;f[G>>2]=(f[G>>2]|0)-Oa;Da=ja;Ea=ka-Oa|0;Fa=gc-Oa|0;Ga=oa+Oa|0;Ha=hc+Oa|0;Ia=p;Ja=ec;Ka=fc}else if((va|0)==171){va=0;if(wc>>>0<19){Oa=wc;do{d[k+116+(j[187856+(Oa<<1)>>1]<<1)>>1]=0;Oa=Oa+1|0}while((Oa|0)!=19);f[aa>>2]=19}f[fa>>2]=ea;f[K>>2]=ea;f[L>>2]=7;Oa=Mnc(0,ga,19,fa,L,ha)|0;if(!Oa){f[aa>>2]=0;f[l>>2]=16198;xc=0;yc=sc;zc=tc;Ac=uc;Bc=vc;Cc=0;va=181;break}else{f[D>>2]=509361;f[l>>2]=16209;Da=Oa;Ea=ka;Fa=uc;Ga=oa;Ha=vc;Ia=p;Ja=sc;Ka=tc;break}}while(0);c:do if((va|0)==64)while(1){va=0;if(!hb){wa=p;xa=jb;ya=kb;za=0;Aa=ib;Ba=ja;Ca=ka;break a}Oa=hb+-1|0;Qa=ib+1|0;Na=(h[ib>>0]<<jb)+kb|0;jb=jb+8|0;if(jb>>>0>=16){lb=Oa;mb=Qa;nb=Na;va=66;break}else{hb=Oa;ib=Qa;kb=Na;va=64}}else if((va|0)==140){va=0;if(f[J>>2]|0){Na=Tb&7;f[l>>2]=16206;Da=ja;Ea=ka;Fa=Vb;Ga=oa;Ha=Wb;Ia=p;Ja=Tb-Na|0;Ka=Ub>>>Na;break}if(Tb>>>0<3){if(!Vb){pa=Tb;qa=Ub;ra=0;sa=Wb;ta=ja;ua=ka;va=296;break a}Ld=Tb+8|0;Md=(h[Wb>>0]<<Tb)+Ub|0;Nd=Vb+-1|0;Od=Wb+1|0}else{Ld=Tb;Md=Ub;Nd=Vb;Od=Wb}f[J>>2]=Md&1;switch(Md>>>1&3){case 0:{Pd=16193;va=151;break}case 1:{f[K>>2]=185680;f[L>>2]=9;f[M>>2]=187728;f[N>>2]=5;f[l>>2]=16199;if(O){va=147;break a}break}case 2:{Pd=16196;va=151;break}case 3:{f[D>>2]=509277;Pd=16209;va=151;break}default:{va=150;break a}}if((va|0)==151){va=0;f[l>>2]=Pd}Da=ja;Ea=ka;Fa=Nd;Ga=oa;Ha=Od;Ia=p;Ja=Ld+-3|0;Ka=Md>>>3}else if((va|0)==181){va=0;Na=f[ba>>2]|0;Qa=f[ca>>2]|0;do if(Cc>>>0<(Qa+Na|0)>>>0){Oa=yc;q=zc;Pa=Ac;Ma=Bc;La=Cc;Sa=Na;Ra=Qa;d:while(1){Xb=f[K>>2]|0;Qd=(1<<f[L>>2])+-1|0;Rd=Qd&q;Sd=h[Xb+(Rd<<2)+1>>0]|0;if(Oa>>>0<Sd>>>0){Td=Oa;Ud=q;Vd=Pa;Wd=Ma;while(1){if(!Vd){wa=p;xa=Td;ya=Ud;za=0;Aa=Wd;Ba=xc;Ca=ka;break a}Xd=Vd+-1|0;Yd=Wd+1|0;Zd=(h[Wd>>0]<<Td)+Ud|0;_d=Td+8|0;$d=Qd&Zd;ae=h[Xb+($d<<2)+1>>0]|0;if(_d>>>0<ae>>>0){Td=_d;Ud=Zd;Vd=Xd;Wd=Yd}else{be=_d;ce=Zd;de=Xd;ee=Yd;fe=ae;ge=$d;break}}}else{be=Oa;ce=q;de=Pa;ee=Ma;fe=Sd;ge=Rd}Wd=d[Xb+(ge<<2)+2>>1]|0;if((Wd&65535)>=16){switch(Wd<<16>>16){case 16:{Vd=fe+2|0;if(be>>>0<Vd>>>0){Ud=be;Td=ce;Qd=de;$d=ee;while(1){if(!Qd){wa=p;xa=Ud;ya=Td;za=0;Aa=$d;Ba=xc;Ca=ka;break a}ae=Qd+-1|0;Yd=$d+1|0;Xd=(h[$d>>0]<<Ud)+Td|0;Zd=Ud+8|0;if(Zd>>>0<Vd>>>0){Ud=Zd;Td=Xd;Qd=ae;$d=Yd}else{he=Zd;ie=Xd;je=ae;ke=Yd;break}}}else{he=be;ie=ce;je=de;ke=ee}$d=ie>>>fe;Qd=he-fe|0;if(!La){le=Qd;me=$d;ne=je;oe=ke;va=205;break d}pe=j[k+116+(La+-1<<1)>>1]|0;qe=Qd+-2|0;re=$d>>>2;se=je;te=ke;ue=($d&3)+3|0;break}case 17:{$d=fe+3|0;if(be>>>0<$d>>>0){Qd=be;Td=ce;Ud=de;Vd=ee;while(1){if(!Ud){wa=p;xa=Qd;ya=Td;za=0;Aa=Vd;Ba=xc;Ca=ka;break a}Xb=Ud+-1|0;Rd=Vd+1|0;Sd=(h[Vd>>0]<<Qd)+Td|0;Yd=Qd+8|0;if(Yd>>>0<$d>>>0){Qd=Yd;Td=Sd;Ud=Xb;Vd=Rd}else{ve=Yd;we=Sd;xe=Xb;ye=Rd;break}}}else{ve=be;we=ce;xe=de;ye=ee}Vd=we>>>fe;pe=0;qe=-3-fe+ve|0;re=Vd>>>3;se=xe;te=ye;ue=(Vd&7)+3|0;break}default:{Vd=fe+7|0;if(be>>>0<Vd>>>0){Ud=be;Td=ce;Qd=de;$d=ee;while(1){if(!Qd){wa=p;xa=Ud;ya=Td;za=0;Aa=$d;Ba=xc;Ca=ka;break a}Rd=Qd+-1|0;Xb=$d+1|0;Sd=(h[$d>>0]<<Ud)+Td|0;Yd=Ud+8|0;if(Yd>>>0<Vd>>>0){Ud=Yd;Td=Sd;Qd=Rd;$d=Xb}else{ze=Yd;Ae=Sd;Be=Rd;Ce=Xb;break}}}else{ze=be;Ae=ce;Be=de;Ce=ee}$d=Ae>>>fe;pe=0;qe=-7-fe+ze|0;re=$d>>>7;se=Be;te=Ce;ue=($d&127)+11|0}}if((La+ue|0)>>>0>(Ra+Sa|0)>>>0){le=qe;me=re;ne=se;oe=te;va=205;break}$d=pe&65535;Qd=ue+-1|0;f[aa>>2]=La+1;d[k+116+(La<<1)>>1]=$d;if(!Qd){De=qe;Ee=re;Fe=se;Ge=te}else{Td=Qd;do{Qd=f[aa>>2]|0;Td=Td+-1|0;f[aa>>2]=Qd+1;d[k+116+(Qd<<1)>>1]=$d}while((Td|0)!=0);De=qe;Ee=re;Fe=se;Ge=te}}else{f[aa>>2]=La+1;d[k+116+(La<<1)>>1]=Wd;De=be-fe|0;Ee=ce>>>fe;Fe=de;Ge=ee}La=f[aa>>2]|0;Sa=f[ba>>2]|0;Ra=f[ca>>2]|0;if(La>>>0>=(Ra+Sa|0)>>>0){va=206;break}else{Oa=De;q=Ee;Pa=Fe;Ma=Ge}}if((va|0)==205){va=0;f[D>>2]=509386;f[l>>2]=16209;Da=xc;Ea=ka;Fa=ne;Ga=oa;Ha=oe;Ia=p;Ja=le;Ka=me;break c}else if((va|0)==206){va=0;if((f[l>>2]|0)==16209){Da=xc;Ea=ka;Fa=Fe;Ga=oa;Ha=Ge;Ia=p;Ja=De;Ka=Ee;break c}else{He=De;Ie=Ee;Je=Fe;Ke=Ge;Le=Sa;break}}}else{He=yc;Ie=zc;Je=Ac;Ke=Bc;Le=Na}while(0);if(!(d[da>>1]|0)){f[D>>2]=509412;f[l>>2]=16209;Da=xc;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}f[fa>>2]=ea;f[K>>2]=ea;f[L>>2]=9;Na=Mnc(1,ga,Le,fa,L,ha)|0;if(Na|0){f[D>>2]=509449;f[l>>2]=16209;Da=Na;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}f[M>>2]=f[fa>>2];f[N>>2]=6;Na=Mnc(2,k+116+(f[ba>>2]<<1)|0,f[ca>>2]|0,fa,N,ha)|0;if(!Na){f[l>>2]=16199;if(O){pa=He;qa=Ie;ra=Je;sa=Ke;ta=0;ua=ka;va=296;break a}else{Dc=0;Ec=He;Fc=Ie;Gc=Je;Hc=Ke;va=214;break}}else{f[D>>2]=509477;f[l>>2]=16209;Da=Na;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}}while(0);if((va|0)==66){va=0;Na=f[C>>2]|0;if(Na|0){f[Na+8>>2]=nb&255;f[Na+12>>2]=nb>>>8}if(f[B>>2]&512|0?f[x>>2]&4|0:0){b[g>>0]=nb;b[A>>0]=nb>>>8;Na=Tnc(f[z>>2]|0,g,2)|0;f[z>>2]=Na}f[l>>2]=16184;ob=lb;pb=mb;qb=0;rb=0;va=72}else if((va|0)==214){va=0;f[l>>2]=16200;Ic=Dc;Jc=Ec;Kc=Fc;Lc=Gc;Mc=Hc;va=215}do if((va|0)==72){va=0;Na=f[B>>2]|0;if(!(Na&1024)){Qa=f[C>>2]|0;if(!Qa){Me=ob;Ne=pb;Oe=qb;Pe=rb}else{f[Qa+16>>2]=0;Me=ob;Ne=pb;Oe=qb;Pe=rb}}else{if(qb>>>0<16){Qa=ob;Ma=pb;Pa=qb;q=rb;while(1){if(!Qa){wa=p;xa=Pa;ya=q;za=0;Aa=Ma;Ba=ja;Ca=ka;break a}Oa=Qa+-1|0;Ra=Ma+1|0;La=(h[Ma>>0]<<Pa)+q|0;Pa=Pa+8|0;if(Pa>>>0>=16){Qe=Oa;Re=Ra;Se=La;break}else{Qa=Oa;Ma=Ra;q=La}}}else{Qe=ob;Re=pb;Se=rb}f[G>>2]=Se;q=f[C>>2]|0;if(q|0)f[q+20>>2]=Se;if((Na&512|0)!=0?(f[x>>2]&4|0)!=0:0){b[g>>0]=Se;b[A>>0]=Se>>>8;q=Tnc(f[z>>2]|0,g,2)|0;f[z>>2]=q;Me=Qe;Ne=Re;Oe=0;Pe=0}else{Me=Qe;Ne=Re;Oe=0;Pe=0}}f[l>>2]=16185;sb=Me;tb=Ne;ub=Oe;vb=Pe;va=84}else if((va|0)==215){va=0;if(ka>>>0>257&Lc>>>0>5){f[n>>2]=oa;f[m>>2]=ka;f[a>>2]=Mc;f[s>>2]=Lc;f[v>>2]=Kc;f[w>>2]=Jc;Nnc(a,p);q=f[n>>2]|0;Ma=f[m>>2]|0;Qa=f[a>>2]|0;Pa=f[s>>2]|0;La=f[v>>2]|0;Ra=f[w>>2]|0;if((f[l>>2]|0)!=16191){Da=Ic;Ea=Ma;Fa=Pa;Ga=q;Ha=Qa;Ia=p;Ja=Ra;Ka=La;break}f[P>>2]=-1;Da=Ic;Ea=Ma;Fa=Pa;Ga=q;Ha=Qa;Ia=p;Ja=Ra;Ka=La;break}f[P>>2]=0;La=f[K>>2]|0;Ra=(1<<f[L>>2])+-1|0;Qa=Ra&Kc;q=b[La+(Qa<<2)+1>>0]|0;Pa=q&255;if(Pa>>>0>Jc>>>0){Ma=Jc;Oa=Kc;Td=Lc;$d=Mc;while(1){if(!Td){wa=p;xa=Ma;ya=Oa;za=0;Aa=$d;Ba=Ic;Ca=ka;break a}Qd=Td+-1|0;Ud=$d+1|0;Vd=(h[$d>>0]<<Ma)+Oa|0;Xb=Ma+8|0;Rd=Ra&Vd;Sd=b[La+(Rd<<2)+1>>0]|0;Yd=Sd&255;if(Yd>>>0>Xb>>>0){Ma=Xb;Oa=Vd;Td=Qd;$d=Ud}else{Te=Xb;Ue=Vd;Ve=Qd;We=Ud;Xe=Yd;Ye=Rd;Ze=Sd;break}}}else{Te=Jc;Ue=Kc;Ve=Lc;We=Mc;Xe=Pa;Ye=Qa;Ze=q}$d=d[La+(Ye<<2)+2>>1]|0;Td=b[La+(Ye<<2)>>0]|0;Oa=Td&255;if(Td<<24>>24!=0&(Oa&240|0)==0){Ma=$d&65535;Ra=(1<<Xe+Oa)+-1|0;Oa=((Ue&Ra)>>>Xe)+Ma|0;Na=b[La+(Oa<<2)+1>>0]|0;if(((Na&255)+Xe|0)>>>0>Te>>>0){Sd=Te;Rd=Ue;Yd=Ve;Ud=We;while(1){if(!Yd){wa=p;xa=Sd;ya=Rd;za=0;Aa=Ud;Ba=Ic;Ca=ka;break a}Qd=Yd+-1|0;Vd=Ud+1|0;Xb=(h[Ud>>0]<<Sd)+Rd|0;ae=Sd+8|0;Xd=((Xb&Ra)>>>Xe)+Ma|0;Zd=b[La+(Xd<<2)+1>>0]|0;if(((Zd&255)+Xe|0)>>>0>ae>>>0){Sd=ae;Rd=Xb;Yd=Qd;Ud=Vd}else{_e=ae;$e=Xb;af=Qd;bf=Vd;cf=Xd;df=Zd;break}}}else{_e=Te;$e=Ue;af=Ve;bf=We;cf=Oa;df=Na}Ud=d[La+(cf<<2)+2>>1]|0;Yd=b[La+(cf<<2)>>0]|0;f[P>>2]=Xe;ef=_e-Xe|0;ff=$e>>>Xe;gf=af;hf=bf;jf=Yd;kf=df;lf=Ud;mf=Xe}else{ef=Te;ff=Ue;gf=Ve;hf=We;jf=Td;kf=Ze;lf=$d;mf=0}Ud=kf&255;Yd=ff>>>Ud;Rd=ef-Ud|0;f[P>>2]=mf+Ud;f[G>>2]=lf&65535;Ud=jf&255;if(!(jf<<24>>24)){f[l>>2]=16205;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}if(Ud&32|0){f[P>>2]=-1;f[l>>2]=16191;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}if(!(Ud&64)){Sd=Ud&15;f[Q>>2]=Sd;f[l>>2]=16201;Nc=Rd;Oc=Yd;Pc=Ic;Qc=gf;Rc=hf;Sc=Sd;va=233;break}else{f[D>>2]=509543;f[l>>2]=16209;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}}while(0);if((va|0)==84){va=0;Yd=f[B>>2]|0;if(Yd&1024){Rd=f[G>>2]|0;Sd=Rd>>>0>sb>>>0?sb:Rd;if(!Sd){nf=sb;of=tb;pf=Rd}else{Ud=f[C>>2]|0;if((Ud|0)!=0?(Ma=f[Ud+16>>2]|0,(Ma|0)!=0):0){Ra=(f[Ud+20>>2]|0)-Rd|0;Rd=f[Ud+24>>2]|0;dJc(Ma+Ra|0,tb|0,((Ra+Sd|0)>>>0>Rd>>>0?Rd-Ra|0:Sd)|0)|0;qf=f[B>>2]|0}else qf=Yd;if(qf&512|0?f[x>>2]&4|0:0){Yd=Tnc(f[z>>2]|0,tb,Sd)|0;f[z>>2]=Yd}Yd=(f[G>>2]|0)-Sd|0;f[G>>2]=Yd;nf=sb-Sd|0;of=tb+Sd|0;pf=Yd}if(!pf){rf=nf;sf=of}else{pa=ub;qa=vb;ra=nf;sa=of;ta=ja;ua=ka;va=296;break}}else{rf=sb;sf=tb}f[G>>2]=0;f[l>>2]=16186;wb=rf;xb=sf;yb=ub;zb=vb;va=95}else if((va|0)==233){va=0;if(!Sc){tf=Nc;uf=Oc;vf=Qc;wf=Rc;xf=f[G>>2]|0}else{if(Nc>>>0<Sc>>>0){Yd=Nc;Sd=Oc;Ra=Qc;Rd=Rc;while(1){if(!Ra){wa=p;xa=Yd;ya=Sd;za=0;Aa=Rd;Ba=Pc;Ca=ka;break a}Ma=Ra+-1|0;Ud=Rd+1|0;q=(h[Rd>>0]<<Yd)+Sd|0;Qa=Yd+8|0;if(Qa>>>0<Sc>>>0){Yd=Qa;Sd=q;Ra=Ma;Rd=Ud}else{yf=Qa;zf=q;Af=Ma;Bf=Ud;break}}}else{yf=Nc;zf=Oc;Af=Qc;Bf=Rc}Rd=(f[G>>2]|0)+(zf&(1<<Sc)+-1)|0;f[G>>2]=Rd;f[P>>2]=(f[P>>2]|0)+Sc;tf=yf-Sc|0;uf=zf>>>Sc;vf=Af;wf=Bf;xf=Rd}f[R>>2]=xf;f[l>>2]=16202;Tc=tf;Uc=uf;Vc=vf;Wc=wf;Xc=Pc;va=240}do if((va|0)==95){va=0;if(!(f[B>>2]&2048)){Rd=f[C>>2]|0;if(!Rd){Cf=wb;Df=xb}else{f[Rd+28>>2]=0;Cf=wb;Df=xb}}else{if(!wb){pa=yb;qa=zb;ra=0;sa=xb;ta=ja;ua=ka;va=296;break a}else Ef=0;do{Rd=Ef;Ef=Ef+1|0;Ra=b[xb+Rd>>0]|0;Rd=f[C>>2]|0;if((Rd|0?(Sd=f[Rd+28>>2]|0,Sd|0):0)?(Yd=f[G>>2]|0,Yd>>>0<(f[Rd+32>>2]|0)>>>0):0){f[G>>2]=Yd+1;b[Sd+Yd>>0]=Ra}Ff=Ra<<24>>24!=0}while(Ff&wb>>>0>Ef>>>0);if(f[B>>2]&512|0?f[x>>2]&4|0:0){$d=Tnc(f[z>>2]|0,xb,Ef)|0;f[z>>2]=$d}$d=wb-Ef|0;Td=xb+Ef|0;if(Ff){pa=yb;qa=zb;ra=$d;sa=Td;ta=ja;ua=ka;va=296;break a}else{Cf=$d;Df=Td}}f[G>>2]=0;f[l>>2]=16187;Ab=yb;Bb=zb;Cb=Cf;Db=Df;va=109}else if((va|0)==240){va=0;Td=f[M>>2]|0;$d=(1<<f[N>>2])+-1|0;La=$d&Uc;Na=b[Td+(La<<2)+1>>0]|0;Oa=Na&255;if(Oa>>>0>Tc>>>0){Ra=Tc;Yd=Uc;Sd=Vc;Rd=Wc;while(1){if(!Sd){wa=p;xa=Ra;ya=Yd;za=0;Aa=Rd;Ba=Xc;Ca=ka;break a}Ud=Sd+-1|0;Ma=Rd+1|0;q=(h[Rd>>0]<<Ra)+Yd|0;Qa=Ra+8|0;Pa=$d&q;Zd=b[Td+(Pa<<2)+1>>0]|0;Xd=Zd&255;if(Xd>>>0>Qa>>>0){Ra=Qa;Yd=q;Sd=Ud;Rd=Ma}else{Gf=Qa;Hf=q;If=Ud;Jf=Ma;Kf=Xd;Lf=Pa;Mf=Zd;break}}}else{Gf=Tc;Hf=Uc;If=Vc;Jf=Wc;Kf=Oa;Lf=La;Mf=Na}Rd=d[Td+(Lf<<2)+2>>1]|0;Sd=b[Td+(Lf<<2)>>0]|0;Yd=Sd&255;if(!(Yd&240)){Ra=Rd&65535;$d=(1<<Kf+Yd)+-1|0;Yd=((Hf&$d)>>>Kf)+Ra|0;Zd=b[Td+(Yd<<2)+1>>0]|0;if(((Zd&255)+Kf|0)>>>0>Gf>>>0){Pa=Gf;Xd=Hf;Ma=If;Ud=Jf;while(1){if(!Ma){wa=p;xa=Pa;ya=Xd;za=0;Aa=Ud;Ba=Xc;Ca=ka;break a}q=Ma+-1|0;Qa=Ud+1|0;Vd=(h[Ud>>0]<<Pa)+Xd|0;Qd=Pa+8|0;Xb=((Vd&$d)>>>Kf)+Ra|0;ae=b[Td+(Xb<<2)+1>>0]|0;if(((ae&255)+Kf|0)>>>0>Qd>>>0){Pa=Qd;Xd=Vd;Ma=q;Ud=Qa}else{Nf=Qd;Of=Vd;Pf=q;Qf=Qa;Rf=Xb;Sf=ae;break}}}else{Nf=Gf;Of=Hf;Pf=If;Qf=Jf;Rf=Yd;Sf=Zd}Ud=d[Td+(Rf<<2)+2>>1]|0;Ma=b[Td+(Rf<<2)>>0]|0;Xd=(f[P>>2]|0)+Kf|0;f[P>>2]=Xd;Tf=Nf-Kf|0;Uf=Of>>>Kf;Vf=Pf;Wf=Qf;Xf=Ma;Yf=Sf;Zf=Ud;_f=Xd}else{Tf=Gf;Uf=Hf;Vf=If;Wf=Jf;Xf=Sd;Yf=Mf;Zf=Rd;_f=f[P>>2]|0}Xd=Yf&255;Ud=Uf>>>Xd;Ma=Tf-Xd|0;f[P>>2]=_f+Xd;Xd=Xf&255;if(!(Xd&64)){f[S>>2]=Zf&65535;Pa=Xd&15;f[Q>>2]=Pa;f[l>>2]=16203;Yc=Ma;Zc=Ud;_c=Vf;$c=Wf;ad=Xc;bd=Pa;va=252;break}else{f[D>>2]=509571;f[l>>2]=16209;Da=Xc;Ea=ka;Fa=Vf;Ga=oa;Ha=Wf;Ia=p;Ja=Ma;Ka=Ud;break}}while(0);if((va|0)==109){va=0;if(!(f[B>>2]&4096)){Ud=f[C>>2]|0;if(!Ud){$f=Cb;ag=Db}else{f[Ud+36>>2]=0;$f=Cb;ag=Db}}else{if(!Cb){pa=Ab;qa=Bb;ra=0;sa=Db;ta=ja;ua=ka;va=296;break}else bg=0;do{Ud=bg;bg=bg+1|0;Ma=b[Db+Ud>>0]|0;Ud=f[C>>2]|0;if((Ud|0?(Pa=f[Ud+36>>2]|0,Pa|0):0)?(Xd=f[G>>2]|0,Xd>>>0<(f[Ud+40>>2]|0)>>>0):0){f[G>>2]=Xd+1;b[Pa+Xd>>0]=Ma}cg=Ma<<24>>24!=0}while(cg&Cb>>>0>bg>>>0);if(f[B>>2]&512|0?f[x>>2]&4|0:0){Ma=Tnc(f[z>>2]|0,Db,bg)|0;f[z>>2]=Ma}Ma=Cb-bg|0;Xd=Db+bg|0;if(cg){pa=Ab;qa=Bb;ra=Ma;sa=Xd;ta=ja;ua=ka;va=296;break}else{$f=Ma;ag=Xd}}f[l>>2]=16188;Eb=Ab;Fb=Bb;Gb=$f;Hb=ag;va=123}else if((va|0)==252){va=0;if(!bd){dg=Yc;eg=Zc;fg=_c;gg=$c}else{if(Yc>>>0<bd>>>0){Xd=Yc;Ma=Zc;Pa=_c;Ud=$c;while(1){if(!Pa){wa=p;xa=Xd;ya=Ma;za=0;Aa=Ud;Ba=ad;Ca=ka;break a}Ra=Pa+-1|0;$d=Ud+1|0;Na=(h[Ud>>0]<<Xd)+Ma|0;La=Xd+8|0;if(La>>>0<bd>>>0){Xd=La;Ma=Na;Pa=Ra;Ud=$d}else{hg=La;ig=Na;jg=Ra;kg=$d;break}}}else{hg=Yc;ig=Zc;jg=_c;kg=$c}f[S>>2]=(f[S>>2]|0)+(ig&(1<<bd)+-1);f[P>>2]=(f[P>>2]|0)+bd;dg=hg-bd|0;eg=ig>>>bd;fg=jg;gg=kg}f[l>>2]=16204;cd=dg;dd=eg;ed=fg;fd=gg;gd=ad;va=258}do if((va|0)==123){va=0;Ud=f[B>>2]|0;if(Ud&512){if(Eb>>>0<16){Pa=Eb;Ma=Fb;Xd=Gb;$d=Hb;while(1){if(!Xd){wa=p;xa=Pa;ya=Ma;za=0;Aa=$d;Ba=ja;Ca=ka;break a}Ra=Xd+-1|0;Na=$d+1|0;La=(h[$d>>0]<<Pa)+Ma|0;Oa=Pa+8|0;if(Oa>>>0<16){Pa=Oa;Ma=La;Xd=Ra;$d=Na}else{lg=Oa;mg=La;ng=Ra;og=Na;break}}}else{lg=Eb;mg=Fb;ng=Gb;og=Hb}if((f[x>>2]&4|0)!=0?(mg|0)!=(f[z>>2]&65535|0):0){f[D>>2]=509257;f[l>>2]=16209;Da=ja;Ea=ka;Fa=ng;Ga=oa;Ha=og;Ia=p;Ja=lg;Ka=mg;break}else{pg=0;qg=0;rg=ng;sg=og}}else{pg=Eb;qg=Fb;rg=Gb;sg=Hb}$d=f[C>>2]|0;if($d|0){f[$d+44>>2]=Ud>>>9&1;f[$d+48>>2]=1}$d=Tnc(0,0,0)|0;f[z>>2]=$d;f[F>>2]=$d;f[l>>2]=16191;Da=ja;Ea=ka;Fa=rg;Ga=oa;Ha=sg;Ia=p;Ja=pg;Ka=qg}else if((va|0)==258){va=0;if(!ka){pa=cd;qa=dd;ra=ed;sa=fd;ta=gd;ua=0;va=296;break a}$d=p-ka|0;Xd=f[S>>2]|0;if(Xd>>>0>$d>>>0){Ma=Xd-$d|0;if(Ma>>>0>(f[T>>2]|0)>>>0?f[U>>2]|0:0){f[D>>2]=509593;f[l>>2]=16209;Da=gd;Ea=ka;Fa=ed;Ga=oa;Ha=fd;Ia=p;Ja=cd;Ka=dd;break}$d=f[V>>2]|0;if(Ma>>>0>$d>>>0){Pa=Ma-$d|0;tg=Pa;ug=(f[X>>2]|0)-Pa|0}else{tg=Ma;ug=$d-Ma|0}Ma=f[G>>2]|0;vg=(f[W>>2]|0)+ug|0;wg=tg>>>0>Ma>>>0?Ma:tg;xg=Ma}else{Ma=f[G>>2]|0;vg=oa+(0-Xd)|0;wg=Ma;xg=Ma}Ma=wg>>>0>ka>>>0?ka:wg;f[G>>2]=xg-Ma;Xd=Ma+1|0;$d=Ma;Pa=oa;Rd=vg;while(1){b[Pa>>0]=b[Rd>>0]|0;$d=$d+-1|0;if(!$d)break;else{Pa=Pa+1|0;Rd=Rd+1|0}}Rd=ka-Ma|0;Pa=oa+-1+Xd|0;if(!(f[G>>2]|0)){f[l>>2]=16200;Da=gd;Ea=Rd;Fa=ed;Ga=Pa;Ha=fd;Ia=p;Ja=cd;Ka=dd}else{Da=gd;Ea=Rd;Fa=ed;Ga=Pa;Ha=fd;Ia=p;Ja=cd;Ka=dd}}while(0);ja=Da;ka=Ea;la=Fa;ma=Ha;p=Ia;r=Ja;na=Ka;oa=Ga;o=f[l>>2]|0}if((va|0)==137){f[n>>2]=oa;f[m>>2]=ka;f[a>>2]=Ob;f[s>>2]=Nb;f[v>>2]=Mb;f[w>>2]=Lb;i=2;u=e;return i|0}else if((va|0)==147){wa=p;xa=Ld+-3|0;ya=Md>>>3;za=Nd;Aa=Od;Ba=ja;Ca=ka}else if((va|0)!=150)if((va|0)==295){f[l>>2]=16208;wa=td;xa=Dd;ya=Ed;za=Fd;Aa=Gd;Ba=1;Ca=ka}else if((va|0)==296){wa=p;xa=pa;ya=qa;za=ra;Aa=sa;Ba=ta;Ca=ua}else if((va|0)==310){i=-4;u=e;return i|0}else if((va|0)==311){u=e;return i|0}f[n>>2]=oa;f[m>>2]=Ca;f[a>>2]=Aa;f[s>>2]=za;f[v>>2]=ya;f[w>>2]=xa;if(!(f[X>>2]|0))if(((wa|0)!=(Ca|0)?(X=f[l>>2]|0,X>>>0<16209):0)?(c|0)!=4|X>>>0<16206:0)va=301;else{yg=za;zg=Ca}else va=301;do if((va|0)==301){if(!(Knc(a,oa,wa-Ca|0)|0)){yg=f[s>>2]|0;zg=f[m>>2]|0;break}f[l>>2]=16210;i=-4;u=e;return i|0}while(0);m=t-yg|0;yg=wa-zg|0;zg=a+8|0;f[zg>>2]=(f[zg>>2]|0)+m;f[Y>>2]=(f[Y>>2]|0)+yg;f[Z>>2]=(f[Z>>2]|0)+yg;if((yg|0)!=0&(f[x>>2]&4|0)!=0){x=f[z>>2]|0;Z=(f[n>>2]|0)+(0-yg)|0;if(!(f[B>>2]|0))Ag=Rnc(x,Z,yg)|0;else Ag=Tnc(x,Z,yg)|0;f[z>>2]=Ag;f[F>>2]=Ag}Ag=f[l>>2]|0;f[a+44>>2]=(f[J>>2]|0?64:0)+(f[w>>2]|0)+((Ag|0)==16191?128:0)+((Ag|0)==16199|(Ag|0)==16194?256:0);i=(Ba|0)==0&((c|0)==4|(yg|m|0)==0)?-5:Ba;u=e;return i|0}function Knc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=f[a+28>>2]|0;e=d+56|0;g=f[e>>2]|0;if(!g){h=hj[f[a+32>>2]&511](f[a+40>>2]|0,1<<f[d+40>>2],1)|0;f[e>>2]=h;if(!h){i=1;return i|0}else j=h}else j=g;g=d+44|0;h=f[g>>2]|0;if(!h){a=1<<f[d+40>>2];f[g>>2]=a;f[d+52>>2]=0;f[d+48>>2]=0;k=a}else k=h;if(k>>>0<=c>>>0){dJc(j|0,b+(0-k)|0,k|0)|0;f[d+52>>2]=0;f[d+48>>2]=f[g>>2];i=0;return i|0}h=d+52|0;a=f[h>>2]|0;l=k-a|0;k=l>>>0>c>>>0?c:l;dJc(j+a|0,b+(0-c)|0,k|0)|0;a=c-k|0;if(a|0){dJc(f[e>>2]|0,b+(0-a)|0,a|0)|0;f[h>>2]=a;f[d+48>>2]=f[g>>2];i=0;return i|0}a=(f[h>>2]|0)+k|0;b=f[g>>2]|0;f[h>>2]=(a|0)==(b|0)?0:a;a=d+48|0;d=f[a>>2]|0;if(d>>>0>=b>>>0){i=0;return i|0}f[a>>2]=d+k;i=0;return i|0}function Lnc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}c=a+36|0;d=f[c>>2]|0;if(!d){b=-2;return b|0}e=a+28|0;g=f[e>>2]|0;if(!g){b=-2;return b|0}if((f[g>>2]|0)!=(a|0)){b=-2;return b|0}if(((f[g+4>>2]|0)+-16180|0)>>>0>31){b=-2;return b|0}h=f[g+56>>2]|0;i=a+40|0;if(!h){j=d;k=g}else{mi[d&2047](f[i>>2]|0,h);j=f[c>>2]|0;k=f[e>>2]|0}mi[j&2047](f[i>>2]|0,k);f[e>>2]=0;b=0;return b|0}function Mnc(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;k=u;u=u+64|0;l=k+32|0;m=k;n=l;o=n+32|0;do{d[n>>1]=0;n=n+2|0}while((n|0)<(o|0));n=(e|0)==0;if(!n){o=0;do{p=l+(j[c+(o<<1)>>1]<<1)|0;d[p>>1]=(d[p>>1]|0)+1<<16>>16;o=o+1|0}while((o|0)!=(e|0));o=d[l+30>>1]|0;p=f[h>>2]|0;if(!(o<<16>>16)){q=p;r=5}else{s=15;t=p;v=o;r=7}}else{q=f[h>>2]|0;r=5}do if((r|0)==5)if(!(d[l+28>>1]|0))if(!(d[l+26>>1]|0))if(!(d[l+24>>1]|0))if(!(d[l+22>>1]|0))if(!(d[l+20>>1]|0))if(!(d[l+18>>1]|0))if(!(d[l+16>>1]|0))if(!(d[l+14>>1]|0))if(!(d[l+12>>1]|0))if(!(d[l+10>>1]|0))if(!(d[l+8>>1]|0))if(!(d[l+6>>1]|0))if(!(d[l+4>>1]|0)){if(d[l+2>>1]|0){w=(q|0)!=0&1;x=1;y=1;z=0;break}o=f[g>>2]|0;f[g>>2]=o+4;b[o>>0]=64;b[o+1>>0]=1;d[o+2>>1]=0;o=f[g>>2]|0;f[g>>2]=o+4;b[o>>0]=64;b[o+1>>0]=1;d[o+2>>1]=0;f[h>>2]=1;A=0;u=k;return A|0}else{s=2;t=q;v=0;r=7}else{s=3;t=q;v=0;r=7}else{s=4;t=q;v=0;r=7}else{s=5;t=q;v=0;r=7}else{s=6;t=q;v=0;r=7}else{s=7;t=q;v=0;r=7}else{s=8;t=q;v=0;r=7}else{s=9;t=q;v=0;r=7}else{s=10;t=q;v=0;r=7}else{s=11;t=q;v=0;r=7}else{s=12;t=q;v=0;r=7}else{s=13;t=q;v=0;r=7}else{s=14;t=q;v=0;r=7}while(0);a:do if((r|0)==7){q=t>>>0>s>>>0?s:t;o=1;while(1){if(d[l+(o<<1)>>1]|0){w=q;x=s;y=o;z=v;break a}p=o+1|0;if(p>>>0<s>>>0)o=p;else{w=q;x=s;y=p;z=v;break}}}while(0);v=w>>>0<y>>>0?y:w;w=d[l+2>>1]|0;s=w&65535;t=2-s|0;if((t|0)<0){A=-1;u=k;return A|0}q=j[l+4>>1]|0;o=(t<<1)-q|0;if((o|0)<0){A=-1;u=k;return A|0}t=j[l+6>>1]|0;p=(o<<1)-t|0;if((p|0)<0){A=-1;u=k;return A|0}o=j[l+8>>1]|0;B=(p<<1)-o|0;if((B|0)<0){A=-1;u=k;return A|0}p=j[l+10>>1]|0;C=(B<<1)-p|0;if((C|0)<0){A=-1;u=k;return A|0}B=j[l+12>>1]|0;D=(C<<1)-B|0;if((D|0)<0){A=-1;u=k;return A|0}C=j[l+14>>1]|0;E=(D<<1)-C|0;if((E|0)<0){A=-1;u=k;return A|0}D=j[l+16>>1]|0;F=(E<<1)-D|0;if((F|0)<0){A=-1;u=k;return A|0}E=j[l+18>>1]|0;G=(F<<1)-E|0;if((G|0)<0){A=-1;u=k;return A|0}F=j[l+20>>1]|0;H=(G<<1)-F|0;if((H|0)<0){A=-1;u=k;return A|0}G=j[l+22>>1]|0;I=(H<<1)-G|0;if((I|0)<0){A=-1;u=k;return A|0}H=j[l+24>>1]|0;J=(I<<1)-H|0;if((J|0)<0){A=-1;u=k;return A|0}I=j[l+26>>1]|0;K=(J<<1)-I|0;if((K|0)<0){A=-1;u=k;return A|0}J=j[l+28>>1]|0;L=(K<<1)-J|0;if((L|0)<0){A=-1;u=k;return A|0}K=(L<<1)-(z&65535)|0;if((K|0)<0){A=-1;u=k;return A|0}if(K|0?(a|0)==0|(x|0)!=1:0){A=-1;u=k;return A|0}d[m+2>>1]=0;d[m+4>>1]=w;w=q+s|0;d[m+6>>1]=w;d[m+8>>1]=t+w;s=w+t|0;d[m+10>>1]=o+s;t=s+o|0;d[m+12>>1]=p+t;o=t+p|0;d[m+14>>1]=B+o;p=o+B|0;d[m+16>>1]=C+p;B=p+C|0;d[m+18>>1]=D+B;C=B+D|0;d[m+20>>1]=E+C;D=C+E|0;d[m+22>>1]=F+D;E=D+F|0;d[m+24>>1]=G+E;F=E+G|0;d[m+26>>1]=H+F;G=F+H|0;d[m+28>>1]=I+G;d[m+30>>1]=J+(G+I);if(!n){n=0;do{I=d[c+(n<<1)>>1]|0;if(I<<16>>16){G=m+((I&65535)<<1)|0;I=d[G>>1]|0;d[G>>1]=I+1<<16>>16;d[i+((I&65535)<<1)>>1]=n}n=n+1|0}while((n|0)!=(e|0))}switch(a|0){case 0:{M=i;N=i;O=20;P=0;Q=0;break}case 1:{if(v>>>0>9){A=1;u=k;return A|0}else{M=188084;N=187958;O=257;P=0;Q=1}break}default:{e=(a|0)==2;if(e&v>>>0>9){A=1;u=k;return A|0}else{M=188020;N=187894;O=0;P=e;Q=0}}}e=1<<v;a=e+-1|0;n=v&255;m=f[g>>2]|0;I=-1;G=0;J=e;e=0;H=v;F=0;E=y;b:while(1){y=1<<H;R=G;D=F;C=E;while(1){B=C-e|0;S=B&255;p=d[i+(D<<1)>>1]|0;o=p&65535;do if((o+1|0)>>>0<O>>>0){T=p;U=0}else{t=o-O|0;if(o>>>0<O>>>0){T=0;U=96;break}T=d[N+(t<<1)>>1]|0;U=d[M+(t<<1)>>1]&255}while(0);o=1<<B;p=R>>>e;t=y;do{t=t-o|0;s=t+p|0;b[m+(s<<2)>>0]=U;b[m+(s<<2)+1>>0]=S;d[m+(s<<2)+2>>1]=T}while((t|0)!=0);t=1<<C+-1;while(1)if(!(t&R))break;else t=t>>>1;p=R;R=(t|0)==0?0:(t+-1&R)+t|0;p=D;D=D+1|0;p=l+(C<<1)|0;o=(d[p>>1]|0)+-1<<16>>16;d[p>>1]=o;if(!(o<<16>>16)){if((C|0)==(x|0))break b;V=j[c+(j[i+(D<<1)>>1]<<1)>>1]|0}else V=C;if(V>>>0<=v>>>0){R=R;D=D;C=V;continue}W=R&a;if((W|0)!=(I|0))break;else C=V}C=(e|0)==0?v:e;o=m+(y<<2)|0;p=V-C|0;c:do if(V>>>0<x>>>0){B=1<<p;s=p;w=V;while(1){q=B-(j[l+(w<<1)>>1]|0)|0;if((q|0)<1){X=s;break c}K=s+1|0;w=K+C|0;if(w>>>0>=x>>>0){X=K;break}else{B=q<<1;s=K}}}else X=p;while(0);p=(1<<X)+J|0;if(Q&p>>>0>852|P&p>>>0>592){A=1;r=43;break}y=f[g>>2]|0;b[y+(W<<2)>>0]=X;b[y+(W<<2)+1>>0]=n;d[y+(W<<2)+2>>1]=(o-y|0)>>>2;m=o;I=W;G=R;J=p;e=C;H=X;F=D;E=V}if((r|0)==43){u=k;return A|0}if(R|0){b[m+(R<<2)>>0]=64;b[m+(R<<2)+1>>0]=S;d[m+(R<<2)+2>>1]=0}f[g>>2]=(f[g>>2]|0)+(J<<2);f[h>>2]=v;A=0;u=k;return A|0}function Nnc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0;e=f[a+28>>2]|0;g=f[a>>2]|0;i=a+4|0;j=g+((f[i>>2]|0)+-5)|0;k=a+12|0;l=f[k>>2]|0;m=a+16|0;n=f[m>>2]|0;o=l+(n+-257)|0;p=f[e+44>>2]|0;q=f[e+48>>2]|0;r=f[e+52>>2]|0;s=f[e+56>>2]|0;t=e+60|0;u=e+64|0;v=f[e+80>>2]|0;w=f[e+84>>2]|0;x=(1<<f[e+88>>2])+-1|0;y=(1<<f[e+92>>2])+-1|0;z=l+(n-c)|0;c=e+7108|0;n=(r|0)==0;A=r+p|0;B=z-r|0;C=g;g=l;l=f[t>>2]|0;D=f[u>>2]|0;a:while(1){if(D>>>0<15){E=C+2|0;F=((h[C>>0]|0)<<D)+l+((h[C+1>>0]|0)<<D+8)|0;G=D+16|0}else{E=C;F=l;G=D}H=F&x;I=b[v+(H<<2)>>0]|0;J=d[v+(H<<2)+2>>1]|0;K=h[v+(H<<2)+1>>0]|0;H=F>>>K;L=G-K|0;do if(I<<24>>24){K=J;M=I&255;N=L;O=H;while(1){if(M&16|0)break;if(M&64|0){P=53;break a}Q=(O&(1<<M)+-1)+(K&65535)|0;R=b[v+(Q<<2)>>0]|0;S=d[v+(Q<<2)+2>>1]|0;T=h[v+(Q<<2)+1>>0]|0;U=O>>>T;V=N-T|0;if(!(R<<24>>24)){P=6;break}else{K=S;M=R&255;N=V;O=U}}if((P|0)==6){P=0;W=V;X=U;Y=S&255;P=7;break}R=K&65535;T=M&15;if(!T){Z=R;_=E;$=O;aa=N}else{if(N>>>0<T>>>0){ba=E+1|0;ca=((h[E>>0]|0)<<N)+O|0;da=N+8|0}else{ba=E;ca=O;da=N}Z=(ca&(1<<T)+-1)+R|0;_=ba;$=ca>>>T;aa=da-T|0}if(aa>>>0<15){ea=_+2|0;fa=((h[_>>0]|0)<<aa)+$+((h[_+1>>0]|0)<<aa+8)|0;ga=aa+16|0}else{ea=_;fa=$;ga=aa}T=fa&y;R=d[w+(T<<2)+2>>1]|0;Q=h[w+(T<<2)+1>>0]|0;ha=fa>>>Q;ia=ga-Q|0;Q=h[w+(T<<2)>>0]|0;if(!(Q&16)){T=R;ja=Q;ka=ha;la=ia;while(1){if(ja&64|0){ma=ea;na=ka;oa=la;pa=509571;P=55;break a}qa=(ka&(1<<ja)+-1)+(T&65535)|0;ra=d[w+(qa<<2)+2>>1]|0;sa=h[w+(qa<<2)+1>>0]|0;ta=ka>>>sa;ua=la-sa|0;sa=h[w+(qa<<2)>>0]|0;if(!(sa&16)){T=ra;ja=sa;ka=ta;la=ua}else{va=sa;wa=ua;xa=ta;ya=ra;break}}}else{va=Q;wa=ia;xa=ha;ya=R}la=ya&65535;ka=va&15;if(wa>>>0<ka>>>0){ja=ea+1|0;T=((h[ea>>0]|0)<<wa)+xa|0;K=wa+8|0;if(K>>>0<ka>>>0){za=ea+2|0;Aa=((h[ja>>0]|0)<<K)+T|0;Ba=wa+16|0}else{za=ja;Aa=T;Ba=K}}else{za=ea;Aa=xa;Ba=wa}K=(Aa&(1<<ka)+-1)+la|0;la=Aa>>>ka;T=Ba-ka|0;ka=g;ja=ka-z|0;if(K>>>0<=ja>>>0){ra=Z;ta=g+(0-K)|0;ua=g;while(1){b[ua>>0]=b[ta>>0]|0;b[ua+1>>0]=b[ta+1>>0]|0;Ca=ta+3|0;Da=ua+3|0;b[ua+2>>0]=b[ta+2>>0]|0;ra=ra+-3|0;if(ra>>>0<=2)break;else{ta=Ca;ua=Da}}if(!ra){Ea=za;Fa=Da;Ga=la;Ha=T;break}R=ua+4|0;b[Da>>0]=b[Ca>>0]|0;if((ra|0)==1){Ea=za;Fa=R;Ga=la;Ha=T;break}b[R>>0]=b[ta+4>>0]|0;Ea=za;Fa=ua+5|0;Ga=la;Ha=T;break}R=K-ja|0;if(R>>>0>q>>>0?f[c>>2]|0:0){ma=za;na=la;oa=T;pa=509593;P=55;break a}do if(n){ha=s+(p-R)|0;if(Z>>>0>R>>>0){ia=Z-R|0;Q=K-ka|0;sa=ha;qa=R;Ia=g;while(1){b[Ia>>0]=b[sa>>0]|0;qa=qa+-1|0;if(!qa)break;else{sa=sa+1|0;Ia=Ia+1|0}}Ia=g+z+Q|0;Ja=ia;Ka=Ia+(0-K)|0;La=Ia}else{Ja=Z;Ka=ha;La=g}}else{if(r>>>0>=R>>>0){Ia=s+(r-R)|0;if(Z>>>0<=R>>>0){Ja=Z;Ka=Ia;La=g;break}sa=Z-R|0;qa=K-ka|0;Ma=Ia;Ia=R;Na=g;while(1){b[Na>>0]=b[Ma>>0]|0;Ia=Ia+-1|0;if(!Ia)break;else{Ma=Ma+1|0;Na=Na+1|0}}Na=g+z+qa|0;Ja=sa;Ka=Na+(0-K)|0;La=Na;break}Na=s+(A-R)|0;Ma=R-r|0;if(Z>>>0>Ma>>>0){Ia=Z-Ma|0;ha=K-ka|0;ia=Na;Q=Ma;Ma=g;while(1){b[Ma>>0]=b[ia>>0]|0;Q=Q+-1|0;if(!Q)break;else{ia=ia+1|0;Ma=Ma+1|0}}Ma=g+B+ha|0;if(Ia>>>0>r>>>0){ia=g+z|0;Q=s;sa=r;qa=Ma;while(1){b[qa>>0]=b[Q>>0]|0;sa=sa+-1|0;if(!sa)break;else{Q=Q+1|0;qa=qa+1|0}}qa=ia+ha|0;Ja=Ia-r|0;Ka=qa+(0-K)|0;La=qa}else{Ja=Ia;Ka=s;La=Ma}}else{Ja=Z;Ka=Na;La=g}}while(0);if(Ja>>>0>2){K=Ja;ka=Ka;R=La;while(1){b[R>>0]=b[ka>>0]|0;b[R+1>>0]=b[ka+1>>0]|0;ja=ka+3|0;ua=R+3|0;b[R+2>>0]=b[ka+2>>0]|0;ta=K+-3|0;if(ta>>>0>2){K=ta;ka=ja;R=ua}else{Oa=ta;Pa=ja;Qa=ua;break}}}else{Oa=Ja;Pa=Ka;Qa=La}if(Oa){R=Qa+1|0;b[Qa>>0]=b[Pa>>0]|0;if((Oa|0)==1){Ea=za;Fa=R;Ga=la;Ha=T}else{b[R>>0]=b[Pa+1>>0]|0;Ea=za;Fa=Qa+2|0;Ga=la;Ha=T}}else{Ea=za;Fa=Qa;Ga=la;Ha=T}}else{W=L;X=H;Y=J&255;P=7}while(0);if((P|0)==7){P=0;b[g>>0]=Y;Ea=E;Fa=g+1|0;Ga=X;Ha=W}if(Fa>>>0<o>>>0&Ea>>>0<j>>>0){C=Ea;g=Fa;l=Ga;D=Ha}else{Ra=Ga;Sa=Ha;Ta=Ea;Ua=Fa;P=57;break}}if((P|0)==53)if(!(M&32)){ma=E;na=O;oa=N;pa=509543;P=55}else{Va=E;Wa=O;Xa=N;Ya=16191}else if((P|0)==57){Za=Sa>>>3;_a=0-Za|0;$a=Ta+_a|0;ab=Za<<3;bb=Sa-ab|0;cb=1<<bb;db=cb+-1|0;eb=db&Ra;f[a>>2]=$a;f[k>>2]=Ua;fb=j;gb=$a;hb=fb+5|0;ib=hb-gb|0;f[i>>2]=ib;jb=o;kb=Ua;lb=jb+257|0;mb=lb-kb|0;f[m>>2]=mb;f[t>>2]=eb;f[u>>2]=bb;return}if((P|0)==55){f[a+24>>2]=pa;Va=ma;Wa=na;Xa=oa;Ya=16209}f[e+4>>2]=Ya;Ra=Wa;Sa=Xa;Ta=Va;Ua=g;Za=Sa>>>3;_a=0-Za|0;$a=Ta+_a|0;ab=Za<<3;bb=Sa-ab|0;cb=1<<bb;db=cb+-1|0;eb=db&Ra;f[a>>2]=$a;f[k>>2]=Ua;fb=j;gb=$a;hb=fb+5|0;ib=hb-gb|0;f[i>>2]=ib;jb=o;kb=Ua;lb=jb+257|0;mb=lb-kb|0;f[m>>2]=mb;f[t>>2]=eb;f[u>>2]=bb;return}function Onc(a,b,c){a=a|0;b=b|0;c=c|0;return ooc(Y(c,b)|0)|0}function Pnc(a,b){a=a|0;b=b|0;poc(b);return}function Qnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=a>>>16;e=a&65535;if((c|0)==1){a=(h[b>>0]|0)+e|0;f=a>>>0>65520?a+-65521|0:a;a=f+d|0;g=(a>>>0>65520?a+15|0:a)<<16|f;return g|0}if(!b){g=1;return g|0}if(c>>>0<16){if(!c){i=d;j=e}else{f=c;a=b;k=e;l=d;while(1){f=f+-1|0;m=(h[a>>0]|0)+k|0;n=m+l|0;if(!f){i=n;j=m;break}else{a=a+1|0;k=m;l=n}}}g=((i>>>0)%65521|0)<<16|(j>>>0>65520?j+-65521|0:j);return g|0}if(c>>>0>5551){j=c;i=b;l=d;k=e;do{j=j+-5552|0;a=347;f=i;n=l;m=k;while(1){o=(h[f>>0]|0)+m|0;p=o+(h[f+1>>0]|0)|0;q=p+(h[f+2>>0]|0)|0;r=q+(h[f+3>>0]|0)|0;s=r+(h[f+4>>0]|0)|0;t=s+(h[f+5>>0]|0)|0;u=t+(h[f+6>>0]|0)|0;v=u+(h[f+7>>0]|0)|0;w=v+(h[f+8>>0]|0)|0;x=w+(h[f+9>>0]|0)|0;y=x+(h[f+10>>0]|0)|0;z=y+(h[f+11>>0]|0)|0;A=z+(h[f+12>>0]|0)|0;B=A+(h[f+13>>0]|0)|0;C=B+(h[f+14>>0]|0)|0;m=C+(h[f+15>>0]|0)|0;n=o+n+p+q+r+s+t+u+v+w+x+y+z+A+B+C+m|0;a=a+-1|0;if(!a)break;else f=f+16|0}i=i+5552|0;k=(m>>>0)%65521|0;l=(n>>>0)%65521|0}while(j>>>0>5551);if(j)if(j>>>0>15){D=j;E=i;F=l;G=k;H=14}else{I=j;J=i;K=l;L=k;H=17}else{M=l;N=k}}else{D=c;E=b;F=d;G=e;H=14}if((H|0)==14){e=D+-16|0;d=e&-16;b=d+16|0;c=D;D=E;k=F;F=G;while(1){c=c+-16|0;G=(h[D>>0]|0)+F|0;l=G+(h[D+1>>0]|0)|0;i=l+(h[D+2>>0]|0)|0;j=i+(h[D+3>>0]|0)|0;f=j+(h[D+4>>0]|0)|0;a=f+(h[D+5>>0]|0)|0;C=a+(h[D+6>>0]|0)|0;B=C+(h[D+7>>0]|0)|0;A=B+(h[D+8>>0]|0)|0;z=A+(h[D+9>>0]|0)|0;y=z+(h[D+10>>0]|0)|0;x=y+(h[D+11>>0]|0)|0;w=x+(h[D+12>>0]|0)|0;v=w+(h[D+13>>0]|0)|0;u=v+(h[D+14>>0]|0)|0;F=u+(h[D+15>>0]|0)|0;k=G+k+l+i+j+f+a+C+B+A+z+y+x+w+v+u+F|0;if(c>>>0<=15)break;else D=D+16|0}D=e-d|0;if(!D){O=k;P=F;H=18}else{I=D;J=E+b|0;K=k;L=F;H=17}}if((H|0)==17)while(1){H=0;I=I+-1|0;F=(h[J>>0]|0)+L|0;k=F+K|0;if(!I){O=k;P=F;H=18;break}else{J=J+1|0;K=k;L=F;H=17}}if((H|0)==18){M=(O>>>0)%65521|0;N=(P>>>0)%65521|0}g=M<<16|N;return g|0}function Rnc(a,b,c){a=a|0;b=b|0;c=c|0;return Qnc(a,b,c)|0}function Snc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if(!b){d=0;return d|0}e=~a;a:do if(c){a=e;g=c;i=b;while(1){if(!(i&3))break;j=f[168480+(((h[i>>0]|0)^a&255)<<2)>>2]^a>>>8;k=g+-1|0;if(!k){l=j;break a}else{a=j;g=k;i=i+1|0}}if(g>>>0>31){k=g+-32|0;j=k&-32;m=i+(j+32)|0;n=i;o=a;p=g;while(1){q=f[n>>2]^o;r=f[170528+((q>>>8&255)<<2)>>2]^f[171552+((q&255)<<2)>>2]^f[169504+((q>>>16&255)<<2)>>2]^f[168480+(q>>>24<<2)>>2]^f[n+4>>2];q=f[170528+((r>>>8&255)<<2)>>2]^f[171552+((r&255)<<2)>>2]^f[169504+((r>>>16&255)<<2)>>2]^f[168480+(r>>>24<<2)>>2]^f[n+8>>2];r=f[170528+((q>>>8&255)<<2)>>2]^f[171552+((q&255)<<2)>>2]^f[169504+((q>>>16&255)<<2)>>2]^f[168480+(q>>>24<<2)>>2]^f[n+12>>2];q=f[170528+((r>>>8&255)<<2)>>2]^f[171552+((r&255)<<2)>>2]^f[169504+((r>>>16&255)<<2)>>2]^f[168480+(r>>>24<<2)>>2]^f[n+16>>2];r=f[170528+((q>>>8&255)<<2)>>2]^f[171552+((q&255)<<2)>>2]^f[169504+((q>>>16&255)<<2)>>2]^f[168480+(q>>>24<<2)>>2]^f[n+20>>2];q=f[170528+((r>>>8&255)<<2)>>2]^f[171552+((r&255)<<2)>>2]^f[169504+((r>>>16&255)<<2)>>2]^f[168480+(r>>>24<<2)>>2]^f[n+24>>2];r=f[170528+((q>>>8&255)<<2)>>2]^f[171552+((q&255)<<2)>>2]^f[169504+((q>>>16&255)<<2)>>2]^f[168480+(q>>>24<<2)>>2]^f[n+28>>2];o=f[170528+((r>>>8&255)<<2)>>2]^f[171552+((r&255)<<2)>>2]^f[169504+((r>>>16&255)<<2)>>2]^f[168480+(r>>>24<<2)>>2];p=p+-32|0;if(p>>>0<=31)break;else n=n+32|0}s=m;t=o;u=k-j|0}else{s=i;t=a;u=g}if(u>>>0>3){n=u+-4|0;p=n>>>2;r=p+1|0;q=s;v=u;w=t;while(1){x=f[q>>2]^w;w=f[170528+((x>>>8&255)<<2)>>2]^f[171552+((x&255)<<2)>>2]^f[169504+((x>>>16&255)<<2)>>2]^f[168480+(x>>>24<<2)>>2];v=v+-4|0;if(v>>>0<=3)break;else q=q+4|0}y=s+(r<<2)|0;z=w;A=n-(p<<2)|0}else{y=s;z=t;A=u}if(!A)l=z;else{q=y;v=z;g=A;while(1){a=f[168480+(((h[q>>0]|0)^v&255)<<2)>>2]^v>>>8;g=g+-1|0;if(!g){l=a;break}else{q=q+1|0;v=a}}}}else l=e;while(0);d=~l;return d|0}function Tnc(a,b,c){a=a|0;b=b|0;c=c|0;return Snc(a,b,c)|0}function Unc(a,c,e,g,h,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!k){m=-6;return m|0}if((l|0)!=56|(b[k>>0]|0)!=49){m=-6;return m|0}if(!a){m=-2;return m|0}k=a+24|0;f[k>>2]=0;l=a+32|0;n=f[l>>2]|0;if(!n){f[l>>2]=308;f[a+40>>2]=0;o=308}else o=n;n=a+36|0;if(!(f[n>>2]|0))f[n>>2]=1240;n=(c|0)==-1?6:c;if((g|0)<0){p=0;q=0-g|0}else{c=(g|0)>15;p=c?2:1;q=c?g+-16|0:g}if(i>>>0>4|(n>>>0>9|((e|0)!=8|(h+-1|0)>>>0>8|(q&-8|0)!=8))){m=-2;return m|0}e=(q|0)==8;if(e&(p|0)!=1){m=-2;return m|0}g=e?9:q;q=a+40|0;e=hj[o&511](f[q>>2]|0,1,5828)|0;if(!e){m=-4;return m|0}o=a+28|0;f[o>>2]=e;f[e>>2]=a;c=e+4|0;f[c>>2]=42;f[e+24>>2]=p;f[e+28>>2]=0;f[e+48>>2]=g;p=1<<g;g=e+44|0;f[g>>2]=p;f[e+52>>2]=p+-1;r=h+7|0;f[e+80>>2]=r;s=1<<r;r=e+76|0;f[r>>2]=s;f[e+84>>2]=s+-1;f[e+88>>2]=((h+9|0)>>>0)/3|0;s=hj[f[l>>2]&511](f[q>>2]|0,p,2)|0;p=e+56|0;f[p>>2]=s;s=hj[f[l>>2]&511](f[q>>2]|0,f[g>>2]|0,2)|0;g=e+64|0;f[g>>2]=s;s=hj[f[l>>2]&511](f[q>>2]|0,f[r>>2]|0,2)|0;r=e+68|0;f[r>>2]=s;f[e+5824>>2]=0;s=1<<h+6;h=e+5788|0;f[h>>2]=s;t=hj[f[l>>2]&511](f[q>>2]|0,s,4)|0;f[e+8>>2]=t;s=f[h>>2]|0;f[e+12>>2]=s<<2;if((f[p>>2]|0?f[g>>2]|0:0)?!((f[r>>2]|0)==0|(t|0)==0):0){f[e+5796>>2]=t+(s>>>1<<1);f[e+5784>>2]=t+(s*3|0);f[e+132>>2]=n;f[e+136>>2]=i;b[e+36>>0]=8;e=Wnc(a)|0;if(e|0){m=e;return m|0}e=f[o>>2]|0;f[e+60>>2]=f[e+44>>2]<<1;o=f[e+68>>2]|0;i=(f[e+76>>2]|0)+-1|0;d[o+(i<<1)>>1]=0;XIc(o|0,0,i<<1|0)|0;i=f[e+132>>2]|0;f[e+128>>2]=j[176672+(i*12|0)+2>>1];f[e+140>>2]=j[176672+(i*12|0)>>1];f[e+144>>2]=j[176672+(i*12|0)+4>>1];f[e+124>>2]=j[176672+(i*12|0)+6>>1];f[e+108>>2]=0;f[e+92>>2]=0;f[e+116>>2]=0;f[e+5812>>2]=0;f[e+120>>2]=2;f[e+96>>2]=2;f[e+104>>2]=0;f[e+72>>2]=0;m=0;return m|0}f[c>>2]=666;f[k>>2]=f[42116];Vnc(a)|0;m=-4;return m|0}function Vnc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}c=a+36|0;d=f[c>>2]|0;if(!d){b=-2;return b|0}e=a+28|0;g=f[e>>2]|0;if(!g){b=-2;return b|0}if((f[g>>2]|0)!=(a|0)){b=-2;return b|0}h=f[g+4>>2]|0;switch(h|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{b=-2;return b|0}}i=f[g+8>>2]|0;if(!i)j=g;else{mi[d&2047](f[a+40>>2]|0,i);j=f[e>>2]|0}i=f[j+68>>2]|0;if(!i)k=j;else{mi[f[c>>2]&2047](f[a+40>>2]|0,i);k=f[e>>2]|0}i=f[k+64>>2]|0;if(!i)l=k;else{mi[f[c>>2]&2047](f[a+40>>2]|0,i);l=f[e>>2]|0}i=f[l+56>>2]|0;if(!i){m=a+40|0;n=l}else{l=a+40|0;mi[f[c>>2]&2047](f[l>>2]|0,i);m=l;n=f[e>>2]|0}mi[f[c>>2]&2047](f[m>>2]|0,n);f[e>>2]=0;b=(h|0)==113?-3:0;return b|0}function Wnc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}if(!(f[a+36>>2]|0)){b=-2;return b|0}c=f[a+28>>2]|0;if(!c){b=-2;return b|0}if((f[c>>2]|0)!=(a|0)){b=-2;return b|0}d=c+4|0;switch(f[d>>2]|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{b=-2;return b|0}}f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;f[a+44>>2]=2;f[c+20>>2]=0;f[c+16>>2]=f[c+8>>2];e=c+24|0;g=f[e>>2]|0;h=0-g|0;if((g|0)<0){f[e>>2]=h;i=h}else i=g;g=(i|0)==2;f[d>>2]=g?57:i|0?42:113;if(g)j=Tnc(0,0,0)|0;else j=Rnc(0,0,0)|0;f[a+48>>2]=j;f[c+40>>2]=0;coc(c);b=0;return b|0}function Xnc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;d=a+12|0;e=(f[d>>2]|0)+-5|0;g=a+44|0;h=f[g>>2]|0;i=e>>>0>h>>>0?h:e;e=f[a>>2]|0;h=f[e+4>>2]|0;j=a+5820|0;k=a+108|0;l=a+92|0;m=(c|0)!=4;n=(c|0)==0;o=(c|0)==4;p=a+8|0;q=a+20|0;r=a+56|0;s=(f[j>>2]|0)+42>>3;t=f[e+16>>2]|0;a:do if(t>>>0<s>>>0){u=0;v=e}else{w=0;x=s;y=t;z=e;while(1){A=y-x|0;B=(f[k>>2]|0)-(f[l>>2]|0)|0;C=B+(f[z+4>>2]|0)|0;D=C>>>0<65535?C:65535;E=D>>>0>A>>>0?A:D;if(E>>>0<i>>>0?!((E|0)==(C|0)&((n|m&(E|0)==0)^1)):0){u=w;v=z;break a}D=o&(E|0)==(C|0);C=D&1;eoc(a,0,0,C);b[(f[p>>2]|0)+((f[q>>2]|0)+-4)>>0]=E;b[(f[p>>2]|0)+((f[q>>2]|0)+-3)>>0]=E>>>8;A=~E;b[(f[p>>2]|0)+((f[q>>2]|0)+-2)>>0]=A;b[(f[p>>2]|0)+((f[q>>2]|0)+-1)>>0]=A>>>8;A=f[a>>2]|0;F=f[A+28>>2]|0;foc(F);G=F+20|0;H=f[G>>2]|0;I=A+16|0;J=f[I>>2]|0;K=H>>>0>J>>>0?J:H;if(K|0?(H=A+12|0,J=F+16|0,dJc(f[H>>2]|0,f[J>>2]|0,K|0)|0,f[H>>2]=(f[H>>2]|0)+K,f[J>>2]=(f[J>>2]|0)+K,H=A+20|0,f[H>>2]=(f[H>>2]|0)+K,f[I>>2]=(f[I>>2]|0)-K,I=(f[G>>2]|0)-K|0,f[G>>2]=I,(I|0)==0):0)f[J>>2]=f[F+8>>2];if(!B)L=E;else{F=B>>>0>E>>>0?E:B;dJc(f[(f[a>>2]|0)+12>>2]|0,(f[r>>2]|0)+(f[l>>2]|0)|0,F|0)|0;B=f[a>>2]|0;J=B+12|0;f[J>>2]=(f[J>>2]|0)+F;J=B+16|0;f[J>>2]=(f[J>>2]|0)-F;J=B+20|0;f[J>>2]=(f[J>>2]|0)+F;f[l>>2]=(f[l>>2]|0)+F;L=E-F|0}if(L|0){F=f[a>>2]|0;E=f[F+12>>2]|0;J=F+4|0;B=f[J>>2]|0;I=B>>>0>L>>>0?L:B;if(!I){M=F;N=E}else{f[J>>2]=B-I;dJc(E|0,f[F>>2]|0,I|0)|0;switch(f[(f[F+28>>2]|0)+24>>2]|0){case 1:{B=F+48|0;O=B;P=Rnc(f[B>>2]|0,E,I)|0;Q=14;break}case 2:{B=F+48|0;O=B;P=Tnc(f[B>>2]|0,E,I)|0;Q=14;break}default:{}}if((Q|0)==14){Q=0;f[O>>2]=P}f[F>>2]=(f[F>>2]|0)+I;E=F+8|0;f[E>>2]=(f[E>>2]|0)+I;I=f[a>>2]|0;M=I;N=f[I+12>>2]|0}f[M+12>>2]=N+L;I=M+16|0;f[I>>2]=(f[I>>2]|0)-L;I=M+20|0;f[I>>2]=(f[I>>2]|0)+L}I=f[a>>2]|0;if(D){u=C;v=I;break a}x=(f[j>>2]|0)+42>>3;y=f[I+16>>2]|0;if(y>>>0<x>>>0){u=C;v=I;break}else{w=C;z=I}}}while(0);L=h-(f[v+4>>2]|0)|0;if(!L)R=f[k>>2]|0;else{h=f[g>>2]|0;if(L>>>0<h>>>0){M=f[k>>2]|0;if(((f[a+60>>2]|0)-M|0)>>>0<=L>>>0?(N=M-h|0,f[k>>2]=N,M=f[r>>2]|0,dJc(M|0,M+h|0,N|0)|0,N=a+5808|0,M=f[N>>2]|0,M>>>0<2):0)f[N>>2]=M+1;dJc((f[r>>2]|0)+(f[k>>2]|0)|0,(f[f[a>>2]>>2]|0)+(0-L)|0,L|0)|0;M=(f[k>>2]|0)+L|0;f[k>>2]=M;S=M;T=f[g>>2]|0}else{f[a+5808>>2]=2;dJc(f[r>>2]|0,(f[v>>2]|0)+(0-h)|0,h|0)|0;h=f[g>>2]|0;f[k>>2]=h;S=h;T=h}f[l>>2]=S;h=a+5812|0;v=f[h>>2]|0;M=T-v|0;f[h>>2]=(L>>>0>M>>>0?M:L)+v;R=S}S=a+5824|0;if((f[S>>2]|0)>>>0<R>>>0)f[S>>2]=R;if(u|0){U=3;return U|0}u=(c|0)!=0;v=f[a>>2]|0;L=f[v+4>>2]|0;switch(c|0){case 0:case 4:break;default:if((L|0)==0?(R|0)==(f[l>>2]|0):0){U=1;return U|0}}c=(f[a+60>>2]|0)-R+-1|0;if(L>>>0>c>>>0?(M=f[l>>2]|0,h=f[g>>2]|0,(M|0)>=(h|0)):0){f[l>>2]=M-h;M=R-h|0;f[k>>2]=M;R=f[r>>2]|0;dJc(R|0,R+h|0,M|0)|0;M=a+5808|0;h=f[M>>2]|0;if(h>>>0<2)f[M>>2]=h+1;h=f[a>>2]|0;V=(f[g>>2]|0)+c|0;W=f[h+4>>2]|0;X=h}else{V=c;W=L;X=v}v=V>>>0>W>>>0?W:V;if(!v)Y=f[k>>2]|0;else{V=(f[r>>2]|0)+(f[k>>2]|0)|0;f[X+4>>2]=W-v;dJc(V|0,f[X>>2]|0,v|0)|0;switch(f[(f[X+28>>2]|0)+24>>2]|0){case 1:{W=X+48|0;Z=W;_=Rnc(f[W>>2]|0,V,v)|0;Q=44;break}case 2:{W=X+48|0;Z=W;_=Tnc(f[W>>2]|0,V,v)|0;Q=44;break}default:{}}if((Q|0)==44)f[Z>>2]=_;f[X>>2]=(f[X>>2]|0)+v;_=X+8|0;f[_>>2]=(f[_>>2]|0)+v;_=(f[k>>2]|0)+v|0;f[k>>2]=_;Y=_}if((f[S>>2]|0)>>>0<Y>>>0)f[S>>2]=Y;S=(f[d>>2]|0)-((f[j>>2]|0)+42>>3)|0;j=S>>>0<65535?S:65535;S=f[g>>2]|0;g=f[l>>2]|0;d=Y-g|0;if(d>>>0<(j>>>0>S>>>0?S:j)>>>0)if(u&(o|(d|0)!=0)?!(d>>>0>j>>>0?1:(f[(f[a>>2]|0)+4>>2]|0)!=0):0)Q=51;else $=0;else Q=51;if((Q|0)==51){Q=d>>>0>j>>>0?j:d;if(o)aa=d>>>0<=j>>>0?(f[(f[a>>2]|0)+4>>2]|0)==0:0;else aa=0;j=aa&1;eoc(a,(f[r>>2]|0)+g|0,Q,j);f[l>>2]=(f[l>>2]|0)+Q;Q=f[a>>2]|0;a=f[Q+28>>2]|0;foc(a);l=a+20|0;g=f[l>>2]|0;r=Q+16|0;aa=f[r>>2]|0;d=g>>>0>aa>>>0?aa:g;if((d|0)!=0?(g=Q+12|0,aa=a+16|0,dJc(f[g>>2]|0,f[aa>>2]|0,d|0)|0,f[g>>2]=(f[g>>2]|0)+d,f[aa>>2]=(f[aa>>2]|0)+d,g=Q+20|0,f[g>>2]=(f[g>>2]|0)+d,f[r>>2]=(f[r>>2]|0)-d,r=(f[l>>2]|0)-d|0,f[l>>2]=r,(r|0)==0):0){f[aa>>2]=f[a+8>>2];$=j}else $=j}U=$|0?2:0;return U|0}function Ync(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=a+116|0;g=(c|0)==0;i=a+72|0;j=a+88|0;k=a+56|0;l=a+108|0;m=a+84|0;n=a+68|0;o=a+64|0;p=a+52|0;q=a+44|0;r=a+96|0;s=a+5784|0;t=a+5796|0;u=a+112|0;v=a+5792|0;w=a+5788|0;x=a+128|0;y=a+92|0;while(1){if((f[e>>2]|0)>>>0<262){_nc(a);z=f[e>>2]|0;if(g&z>>>0<262){A=0;B=39;break}if(!z){B=24;break}if(z>>>0<=2)B=9;else B=6}else B=6;if((B|0)==6){B=0;z=f[l>>2]|0;C=((h[(f[k>>2]|0)+(z+2)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=C;D=(f[n>>2]|0)+(C<<1)|0;C=d[D>>1]|0;d[(f[o>>2]|0)+((f[p>>2]&z)<<1)>>1]=C;E=C&65535;d[D>>1]=z;if(C<<16>>16!=0?(z-E|0)>>>0<=((f[q>>2]|0)+-262|0)>>>0:0){z=$nc(a,E)|0;f[r>>2]=z;F=z}else B=9}if((B|0)==9){B=0;F=f[r>>2]|0}z=f[s>>2]|0;E=f[t>>2]|0;do if(F>>>0>2){C=F+253|0;D=(f[l>>2]|0)-(f[u>>2]|0)|0;G=f[v>>2]|0;d[E+(G<<1)>>1]=D;f[v>>2]=G+1;b[z+G>>0]=C;G=a+148+((h[510251+(C&255)>>0]|0|256)+1<<2)|0;d[G>>1]=(d[G>>1]|0)+1<<16>>16;G=D+65535&65535;D=a+2440+((h[509739+(G>>>0<256?G:(G>>>7)+256|0)>>0]|0)<<2)|0;d[D>>1]=(d[D>>1]|0)+1<<16>>16;D=(f[v>>2]|0)==((f[w>>2]|0)+-1|0)&1;G=f[r>>2]|0;C=(f[e>>2]|0)-G|0;f[e>>2]=C;if(!(C>>>0>2?G>>>0<=(f[x>>2]|0)>>>0:0)){C=(f[l>>2]|0)+G|0;f[l>>2]=C;f[r>>2]=0;H=f[k>>2]|0;I=h[H+C>>0]|0;f[i>>2]=I;f[i>>2]=((h[H+(C+1)>>0]|0)^I<<f[j>>2])&f[m>>2];J=D;K=C;break}C=G+-1|0;f[r>>2]=C;G=f[j>>2]|0;I=f[k>>2]|0;H=f[m>>2]|0;L=f[n>>2]|0;M=f[o>>2]|0;N=f[p>>2]|0;O=f[l>>2]|0;P=f[i>>2]|0;Q=C;while(1){C=O+1|0;f[l>>2]=C;P=((h[I+(O+3)>>0]|0)^P<<G)&H;f[i>>2]=P;R=L+(P<<1)|0;d[M+((N&C)<<1)>>1]=d[R>>1]|0;d[R>>1]=C;Q=Q+-1|0;f[r>>2]=Q;if(!Q)break;else O=C}Q=O+2|0;f[l>>2]=Q;J=D;K=Q}else{Q=b[(f[k>>2]|0)+(f[l>>2]|0)>>0]|0;N=f[v>>2]|0;d[E+(N<<1)>>1]=0;f[v>>2]=N+1;b[z+N>>0]=Q;N=a+148+((Q&255)<<2)|0;d[N>>1]=(d[N>>1]|0)+1<<16>>16;N=(f[v>>2]|0)==((f[w>>2]|0)+-1|0)&1;f[e>>2]=(f[e>>2]|0)+-1;Q=(f[l>>2]|0)+1|0;f[l>>2]=Q;J=N;K=Q}while(0);if(!J)continue;z=f[y>>2]|0;if((z|0)>-1)S=(f[k>>2]|0)+z|0;else S=0;hoc(a,S,K-z|0,0);f[y>>2]=f[l>>2];z=f[a>>2]|0;E=f[z+28>>2]|0;foc(E);Q=E+20|0;N=f[Q>>2]|0;M=z+16|0;P=f[M>>2]|0;L=N>>>0>P>>>0?P:N;if(L|0?(N=z+12|0,P=E+16|0,dJc(f[N>>2]|0,f[P>>2]|0,L|0)|0,f[N>>2]=(f[N>>2]|0)+L,f[P>>2]=(f[P>>2]|0)+L,N=z+20|0,f[N>>2]=(f[N>>2]|0)+L,f[M>>2]=(f[M>>2]|0)-L,M=(f[Q>>2]|0)-L|0,f[Q>>2]=M,(M|0)==0):0)f[P>>2]=f[E+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){A=0;B=39;break}}if((B|0)==24){K=f[l>>2]|0;f[a+5812>>2]=K>>>0<2?K:2;if((c|0)==4){c=f[y>>2]|0;if((c|0)>-1)T=(f[k>>2]|0)+c|0;else T=0;hoc(a,T,K-c|0,1);f[y>>2]=f[l>>2];c=f[a>>2]|0;T=f[c+28>>2]|0;foc(T);S=T+20|0;J=f[S>>2]|0;e=c+16|0;w=f[e>>2]|0;r=J>>>0>w>>>0?w:J;if(r|0?(J=c+12|0,w=T+16|0,dJc(f[J>>2]|0,f[w>>2]|0,r|0)|0,f[J>>2]=(f[J>>2]|0)+r,f[w>>2]=(f[w>>2]|0)+r,J=c+20|0,f[J>>2]=(f[J>>2]|0)+r,f[e>>2]=(f[e>>2]|0)-r,e=(f[S>>2]|0)-r|0,f[S>>2]=e,(e|0)==0):0)f[w>>2]=f[T+8>>2];A=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return A|0}if(f[v>>2]|0){v=f[y>>2]|0;if((v|0)>-1)U=(f[k>>2]|0)+v|0;else U=0;hoc(a,U,K-v|0,0);f[y>>2]=f[l>>2];l=f[a>>2]|0;y=f[l+28>>2]|0;foc(y);v=y+20|0;K=f[v>>2]|0;U=l+16|0;k=f[U>>2]|0;T=K>>>0>k>>>0?k:K;if(T|0?(K=l+12|0,k=y+16|0,dJc(f[K>>2]|0,f[k>>2]|0,T|0)|0,f[K>>2]=(f[K>>2]|0)+T,f[k>>2]=(f[k>>2]|0)+T,K=l+20|0,f[K>>2]=(f[K>>2]|0)+T,f[U>>2]=(f[U>>2]|0)-T,U=(f[v>>2]|0)-T|0,f[v>>2]=U,(U|0)==0):0)f[k>>2]=f[y+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){A=0;return A|0}}A=1;return A|0}else if((B|0)==39)return A|0;return 0}function Znc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=a+116|0;g=(c|0)==0;i=a+72|0;j=a+88|0;k=a+56|0;l=a+108|0;m=a+84|0;n=a+68|0;o=a+64|0;p=a+52|0;q=a+96|0;r=a+120|0;s=a+112|0;t=a+100|0;u=a+5796|0;v=a+5792|0;w=a+5784|0;x=a+5788|0;y=a+104|0;z=a+92|0;A=a+128|0;B=a+44|0;C=a+136|0;a:while(1){D=f[e>>2]|0;while(1){if(D>>>0<262){_nc(a);E=f[e>>2]|0;if(g&E>>>0<262){F=0;G=55;break a}if(!E){G=38;break a}if(E>>>0<=2){f[r>>2]=f[q>>2];f[t>>2]=f[s>>2];f[q>>2]=2;H=2;G=16}else G=8}else G=8;do if((G|0)==8){G=0;E=f[l>>2]|0;I=((h[(f[k>>2]|0)+(E+2)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=I;J=(f[n>>2]|0)+(I<<1)|0;I=d[J>>1]|0;d[(f[o>>2]|0)+((f[p>>2]&E)<<1)>>1]=I;K=I&65535;d[J>>1]=E;E=f[q>>2]|0;f[r>>2]=E;f[t>>2]=f[s>>2];f[q>>2]=2;if(I<<16>>16)if(E>>>0<(f[A>>2]|0)>>>0)if(((f[l>>2]|0)-K|0)>>>0<=((f[B>>2]|0)+-262|0)>>>0){I=$nc(a,K)|0;f[q>>2]=I;if(I>>>0<6){if((f[C>>2]|0)!=1){if((I|0)!=3){H=I;G=16;break}if(((f[l>>2]|0)-(f[s>>2]|0)|0)>>>0<=4096){H=3;G=16;break}}f[q>>2]=2;H=2;G=16}else{H=I;G=16}}else{H=2;G=16}else{L=E;M=2}else{H=2;G=16}}while(0);if((G|0)==16){G=0;L=f[r>>2]|0;M=H}if(!(L>>>0<3|M>>>0>L>>>0))break;if(!(f[y>>2]|0)){f[y>>2]=1;f[l>>2]=(f[l>>2]|0)+1;E=(f[e>>2]|0)+-1|0;f[e>>2]=E;D=E;continue}E=b[(f[k>>2]|0)+((f[l>>2]|0)+-1)>>0]|0;I=f[v>>2]|0;d[(f[u>>2]|0)+(I<<1)>>1]=0;K=f[w>>2]|0;f[v>>2]=I+1;b[K+I>>0]=E;I=a+148+((E&255)<<2)|0;d[I>>1]=(d[I>>1]|0)+1<<16>>16;if((f[v>>2]|0)==((f[x>>2]|0)+-1|0)){I=f[z>>2]|0;if((I|0)>-1)N=(f[k>>2]|0)+I|0;else N=0;hoc(a,N,(f[l>>2]|0)-I|0,0);f[z>>2]=f[l>>2];I=f[a>>2]|0;E=f[I+28>>2]|0;foc(E);K=E+20|0;J=f[K>>2]|0;O=I+16|0;P=f[O>>2]|0;Q=J>>>0>P>>>0?P:J;if(Q|0?(J=I+12|0,P=E+16|0,dJc(f[J>>2]|0,f[P>>2]|0,Q|0)|0,f[J>>2]=(f[J>>2]|0)+Q,f[P>>2]=(f[P>>2]|0)+Q,J=I+20|0,f[J>>2]=(f[J>>2]|0)+Q,f[O>>2]=(f[O>>2]|0)-Q,O=(f[K>>2]|0)-Q|0,f[K>>2]=O,(O|0)==0):0)f[P>>2]=f[E+8>>2]}f[l>>2]=(f[l>>2]|0)+1;D=(f[e>>2]|0)+-1|0;f[e>>2]=D;if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;G=55;break a}}D=f[l>>2]|0;E=D+-3+(f[e>>2]|0)|0;P=L+253|0;O=D+65535-(f[t>>2]|0)|0;D=f[v>>2]|0;d[(f[u>>2]|0)+(D<<1)>>1]=O;K=f[w>>2]|0;f[v>>2]=D+1;b[K+D>>0]=P;D=a+148+((h[510251+(P&255)>>0]|0|256)+1<<2)|0;d[D>>1]=(d[D>>1]|0)+1<<16>>16;D=O+65535&65535;O=a+2440+((h[509739+(D>>>0<256?D:(D>>>7)+256|0)>>0]|0)<<2)|0;d[O>>1]=(d[O>>1]|0)+1<<16>>16;O=f[v>>2]|0;D=(f[x>>2]|0)+-1|0;P=f[r>>2]|0;f[e>>2]=1-P+(f[e>>2]|0);K=P+-2|0;f[r>>2]=K;P=f[l>>2]|0;Q=K;while(1){K=P+1|0;f[l>>2]=K;if(K>>>0<=E>>>0){J=((h[(f[k>>2]|0)+(P+3)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=J;I=(f[n>>2]|0)+(J<<1)|0;d[(f[o>>2]|0)+((f[p>>2]&K)<<1)>>1]=d[I>>1]|0;d[I>>1]=K}Q=Q+-1|0;f[r>>2]=Q;if(!Q)break;else P=K}f[y>>2]=0;f[q>>2]=2;Q=P+2|0;f[l>>2]=Q;if((O|0)!=(D|0))continue;E=f[z>>2]|0;if((E|0)>-1)R=(f[k>>2]|0)+E|0;else R=0;hoc(a,R,Q-E|0,0);f[z>>2]=f[l>>2];E=f[a>>2]|0;Q=f[E+28>>2]|0;foc(Q);K=Q+20|0;I=f[K>>2]|0;J=E+16|0;S=f[J>>2]|0;T=I>>>0>S>>>0?S:I;if(T|0?(I=E+12|0,S=Q+16|0,dJc(f[I>>2]|0,f[S>>2]|0,T|0)|0,f[I>>2]=(f[I>>2]|0)+T,f[S>>2]=(f[S>>2]|0)+T,I=E+20|0,f[I>>2]=(f[I>>2]|0)+T,f[J>>2]=(f[J>>2]|0)-T,J=(f[K>>2]|0)-T|0,f[K>>2]=J,(J|0)==0):0)f[S>>2]=f[Q+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;G=55;break}}if((G|0)==38){if(f[y>>2]|0){R=b[(f[k>>2]|0)+((f[l>>2]|0)+-1)>>0]|0;q=f[v>>2]|0;d[(f[u>>2]|0)+(q<<1)>>1]=0;u=f[w>>2]|0;f[v>>2]=q+1;b[u+q>>0]=R;q=a+148+((R&255)<<2)|0;d[q>>1]=(d[q>>1]|0)+1<<16>>16;f[y>>2]=0}y=f[l>>2]|0;f[a+5812>>2]=y>>>0<2?y:2;if((c|0)==4){c=f[z>>2]|0;if((c|0)>-1)U=(f[k>>2]|0)+c|0;else U=0;hoc(a,U,y-c|0,1);f[z>>2]=f[l>>2];c=f[a>>2]|0;U=f[c+28>>2]|0;foc(U);q=U+20|0;R=f[q>>2]|0;u=c+16|0;w=f[u>>2]|0;r=R>>>0>w>>>0?w:R;if(r|0?(R=c+12|0,w=U+16|0,dJc(f[R>>2]|0,f[w>>2]|0,r|0)|0,f[R>>2]=(f[R>>2]|0)+r,f[w>>2]=(f[w>>2]|0)+r,R=c+20|0,f[R>>2]=(f[R>>2]|0)+r,f[u>>2]=(f[u>>2]|0)-r,u=(f[q>>2]|0)-r|0,f[q>>2]=u,(u|0)==0):0)f[w>>2]=f[U+8>>2];F=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return F|0}if(f[v>>2]|0){v=f[z>>2]|0;if((v|0)>-1)V=(f[k>>2]|0)+v|0;else V=0;hoc(a,V,y-v|0,0);f[z>>2]=f[l>>2];l=f[a>>2]|0;z=f[l+28>>2]|0;foc(z);v=z+20|0;y=f[v>>2]|0;V=l+16|0;k=f[V>>2]|0;U=y>>>0>k>>>0?k:y;if(U|0?(y=l+12|0,k=z+16|0,dJc(f[y>>2]|0,f[k>>2]|0,U|0)|0,f[y>>2]=(f[y>>2]|0)+U,f[k>>2]=(f[k>>2]|0)+U,y=l+20|0,f[y>>2]=(f[y>>2]|0)+U,f[V>>2]=(f[V>>2]|0)-U,V=(f[v>>2]|0)-U|0,f[v>>2]=V,(V|0)==0):0)f[k>>2]=f[z+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;return F|0}}F=1;return F|0}else if((G|0)==55)return F|0;return 0}function _nc(a){a=a|0;var b=0,c=0,e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=a+44|0;c=f[b>>2]|0;e=a+60|0;g=a+116|0;i=a+108|0;k=c+-262|0;l=a+56|0;m=a+5812|0;n=a+72|0;o=a+88|0;p=a+84|0;q=a+68|0;r=a+64|0;s=a+52|0;t=a+112|0;u=a+92|0;v=a+76|0;w=f[g>>2]|0;x=c;while(1){y=f[i>>2]|0;z=(f[e>>2]|0)-w-y|0;if(y>>>0<(k+x|0)>>>0){A=z;B=y}else{y=f[l>>2]|0;dJc(y|0,y+c|0,c-z|0)|0;f[t>>2]=(f[t>>2]|0)-c;y=(f[i>>2]|0)-c|0;f[i>>2]=y;f[u>>2]=(f[u>>2]|0)-c;C=f[b>>2]|0;D=f[v>>2]|0;E=D;F=(f[q>>2]|0)+(D<<1)|0;do{F=F+-2|0;D=j[F>>1]|0;d[F>>1]=D>>>0<C>>>0?0:D-C&65535;E=E+-1|0}while((E|0)!=0);E=C;F=(f[r>>2]|0)+(C<<1)|0;do{F=F+-2|0;D=j[F>>1]|0;d[F>>1]=D>>>0<C>>>0?0:D-C&65535;E=E+-1|0}while((E|0)!=0);A=z+c|0;B=y}E=f[a>>2]|0;C=E+4|0;F=f[C>>2]|0;if(!F)break;D=f[g>>2]|0;G=(f[l>>2]|0)+B+D|0;H=F>>>0>A>>>0?A:F;if(!H){I=0;J=D}else{f[C>>2]=F-H;dJc(G|0,f[E>>2]|0,H|0)|0;switch(f[(f[E+28>>2]|0)+24>>2]|0){case 1:{F=E+48|0;K=F;L=Rnc(f[F>>2]|0,G,H)|0;M=13;break}case 2:{F=E+48|0;K=F;L=Tnc(f[F>>2]|0,G,H)|0;M=13;break}default:{}}if((M|0)==13){M=0;f[K>>2]=L}f[E>>2]=(f[E>>2]|0)+H;G=E+8|0;f[G>>2]=(f[G>>2]|0)+H;I=H;J=f[g>>2]|0}H=J+I|0;f[g>>2]=H;G=f[m>>2]|0;a:do if((G+H|0)>>>0>2){E=(f[i>>2]|0)-G|0;F=f[l>>2]|0;C=h[F+E>>0]|0;f[n>>2]=C;D=f[o>>2]|0;N=f[p>>2]|0;O=((h[F+(E+1)>>0]|0)^C<<D)&N;f[n>>2]=O;C=E;E=G;P=O;while(1){if(!E)break a;P=((h[F+(C+2)>>0]|0)^P<<D)&N;f[n>>2]=P;O=(f[q>>2]|0)+(P<<1)|0;d[(f[r>>2]|0)+((f[s>>2]&C)<<1)>>1]=d[O>>1]|0;d[O>>1]=C;E=E+-1|0;f[m>>2]=E;if((H+E|0)>>>0<3)break;else C=C+1|0}}while(0);if(H>>>0>=262)break;if(!(f[(f[a>>2]|0)+4>>2]|0))break;w=H;x=f[b>>2]|0}b=a+5824|0;a=f[b>>2]|0;x=f[e>>2]|0;if(x>>>0<=a>>>0)return;e=(f[g>>2]|0)+(f[i>>2]|0)|0;do if(a>>>0>=e>>>0){i=e+258|0;if(i>>>0>a>>>0){g=i-a|0;i=x-a|0;w=g>>>0>i>>>0?i:g;XIc((f[l>>2]|0)+a|0,0,w|0)|0;Q=(f[b>>2]|0)+w|0;break}else return}else{w=x-e|0;g=w>>>0<258?w:258;XIc((f[l>>2]|0)+e|0,0,g|0)|0;Q=g+e|0}while(0);f[b>>2]=Q;return}function $nc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=f[a+124>>2]|0;e=f[a+56>>2]|0;g=f[a+108>>2]|0;h=e+g|0;i=f[a+120>>2]|0;k=f[a+144>>2]|0;l=(f[a+44>>2]|0)+-262|0;m=g>>>0>l>>>0?g-l|0:0;l=f[a+64>>2]|0;g=f[a+52>>2]|0;n=f[a+116>>2]|0;o=k>>>0>n>>>0?n:k;k=a+112|0;p=h+1|0;q=h+258|0;r=b[h+i>>0]|0;s=b[h+(i+-1)>>0]|0;t=c;c=i;u=i>>>0<(f[a+140>>2]|0)>>>0?d:d>>>2;while(1){d=e+t|0;if((((b[d+c>>0]|0)==r<<24>>24?(b[d+(c+-1)>>0]|0)==s<<24>>24:0)?(b[d>>0]|0)==(b[h>>0]|0):0)?(a=d+1|0,(b[a>>0]|0)==(b[p>>0]|0)):0){d=2;i=a;while(1){a=h+d|0;v=a+1|0;if((b[v>>0]|0)!=(b[i+2>>0]|0)){w=v;break}v=a+2|0;if((b[v>>0]|0)!=(b[i+3>>0]|0)){w=v;break}v=a+3|0;if((b[v>>0]|0)!=(b[i+4>>0]|0)){w=v;break}v=a+4|0;if((b[v>>0]|0)!=(b[i+5>>0]|0)){w=v;break}v=a+5|0;if((b[v>>0]|0)!=(b[i+6>>0]|0)){w=v;break}v=a+6|0;if((b[v>>0]|0)!=(b[i+7>>0]|0)){w=v;break}v=a+7|0;a=i;i=i+8|0;if((b[v>>0]|0)!=(b[i>>0]|0)){w=v;break}d=d+8|0;v=h+d|0;if(!((d|0)<258?(b[v>>0]|0)==(b[a+9>>0]|0):0)){w=v;break}}d=w-q|0;i=d+258|0;if((i|0)>(c|0)){f[k>>2]=t;if((i|0)>=(o|0)){x=i;y=19;break}z=b[h+i>>0]|0;A=b[h+(d+257)>>0]|0;B=i}else{z=r;A=s;B=c}}else{z=r;A=s;B=c}t=j[l+((t&g)<<1)>>1]|0;if(t>>>0<=m>>>0){x=B;y=19;break}u=u+-1|0;if(!u){x=B;y=19;break}else{r=z;s=A;c=B}}if((y|0)==19)return (x>>>0>n>>>0?n:x)|0;return 0}function aoc(a){a=a|0;var b=0,c=0,e=0;b=Wnc(a)|0;if(b|0)return b|0;c=f[a+28>>2]|0;f[c+60>>2]=f[c+44>>2]<<1;a=f[c+68>>2]|0;e=(f[c+76>>2]|0)+-1|0;d[a+(e<<1)>>1]=0;XIc(a|0,0,e<<1|0)|0;e=f[c+132>>2]|0;f[c+128>>2]=j[176672+(e*12|0)+2>>1];f[c+140>>2]=j[176672+(e*12|0)>>1];f[c+144>>2]=j[176672+(e*12|0)+4>>1];f[c+124>>2]=j[176672+(e*12|0)+6>>1];f[c+108>>2]=0;f[c+92>>2]=0;f[c+116>>2]=0;f[c+5812>>2]=0;f[c+120>>2]=2;f[c+96>>2]=2;f[c+104>>2]=0;f[c+72>>2]=0;return b|0}function boc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;if(!a){e=-2;return e|0}if(!(f[a+32>>2]|0)){e=-2;return e|0}if(!(f[a+36>>2]|0)){e=-2;return e|0}g=a+28|0;i=f[g>>2]|0;if(!i){e=-2;return e|0}if((f[i>>2]|0)!=(a|0)){e=-2;return e|0}j=i+4|0;k=f[j>>2]|0;switch(k|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{e=-2;return e|0}}if(c>>>0>5){e=-2;return e|0}l=a+12|0;do if(f[l>>2]|0){m=a+4|0;n=(f[m>>2]|0)==0;if(!n?(f[a>>2]|0)==0:0)break;o=(c|0)!=4;if(!(o&(k|0)==666)){p=a+16|0;if(!(f[p>>2]|0)){f[a+24>>2]=f[42117];e=-5;return e|0}q=i+40|0;r=f[q>>2]|0;f[q>>2]=c;s=i+20|0;do if(!(f[s>>2]|0))if(n?o&((c<<1)-((c|0)>4?9:0)|0)<=((r<<1)-((r|0)>4?9:0)|0):0){f[a+24>>2]=f[42117];e=-5;return e|0}else{t=0;u=k}else{foc(i);v=f[s>>2]|0;w=f[p>>2]|0;x=v>>>0>w>>>0?w:v;if(x){y=i+16|0;dJc(f[l>>2]|0,f[y>>2]|0,x|0)|0;f[l>>2]=(f[l>>2]|0)+x;f[y>>2]=(f[y>>2]|0)+x;z=a+20|0;f[z>>2]=(f[z>>2]|0)+x;z=(f[p>>2]|0)-x|0;f[p>>2]=z;A=(f[s>>2]|0)-x|0;f[s>>2]=A;if(!A){f[y>>2]=f[i+8>>2];B=0;C=z}else{B=A;C=z}}else{B=v;C=w}if(C|0){t=B;u=f[j>>2]|0;break}f[q>>2]=-1;e=0;return e|0}while(0);a:do switch(u|0){case 666:{if(!(f[m>>2]|0))D=123;else{f[a+24>>2]=f[42117];e=-5;return e|0}break}case 42:{r=(f[i+48>>2]<<12)+-30720|0;if((f[i+136>>2]|0)<=1?(n=f[i+132>>2]|0,(n|0)>=2):0)E=(n|0)<6?64:(n|0)==6?128:192;else E=0;n=E|r;r=i+108|0;w=(f[r>>2]|0)==0?n:n|32;n=(((w>>>0)%31|0)^31)+w|0;w=i+8|0;v=f[w>>2]|0;f[s>>2]=t+1;b[v+t>>0]=n>>>8;v=f[w>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[v+z>>0]=n;n=a+48|0;if(f[r>>2]|0){r=f[n>>2]|0;z=f[w>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=r>>>24;v=f[w>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[v+z>>0]=r>>>16;r=f[n>>2]|0;z=f[w>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=r>>>8;v=f[w>>2]|0;w=f[s>>2]|0;f[s>>2]=w+1;b[v+w>>0]=r}r=Rnc(0,0,0)|0;f[n>>2]=r;f[j>>2]=113;r=f[g>>2]|0;foc(r);n=r+20|0;w=f[n>>2]|0;v=f[p>>2]|0;z=w>>>0>v>>>0?v:w;if(z|0?(w=r+16|0,dJc(f[l>>2]|0,f[w>>2]|0,z|0)|0,f[l>>2]=(f[l>>2]|0)+z,f[w>>2]=(f[w>>2]|0)+z,v=a+20|0,f[v>>2]=(f[v>>2]|0)+z,f[p>>2]=(f[p>>2]|0)-z,v=(f[n>>2]|0)-z|0,f[n>>2]=v,(v|0)==0):0)f[w>>2]=f[r+8>>2];if(!(f[s>>2]|0)){F=f[j>>2]|0;D=39;break a}f[q>>2]=-1;e=0;return e|0}default:{F=u;D=39}}while(0);if((D|0)==39){do if((F|0)==57){r=Tnc(0,0,0)|0;w=a+48|0;f[w>>2]=r;r=i+8|0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=31;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=-117;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=8;n=i+28|0;v=f[n>>2]|0;if(v|0){z=((f[v+44>>2]|0?2:0)|(f[v>>2]|0)!=0|((f[v+16>>2]|0)==0?0:4)|((f[v+28>>2]|0)==0?0:8)|((f[v+36>>2]|0)==0?0:16))&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=f[(f[n>>2]|0)+4>>2]&255;A=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>8&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>16&255;A=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>24&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=f[i+132>>2]|0;if((z|0)==9)G=2;else G=((z|0)<2?1:(f[i+136>>2]|0)>1)?4:0;z=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[z+A>>0]=G;A=f[(f[n>>2]|0)+12>>2]&255;z=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=A;A=f[n>>2]|0;if(!(f[A+16>>2]|0))H=A;else{v=f[A+20>>2]&255;A=f[r>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[A+z>>0]=v;v=(f[(f[n>>2]|0)+20>>2]|0)>>>8&255;z=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[z+A>>0]=v;H=f[n>>2]|0}if(f[H+44>>2]|0){v=Tnc(f[w>>2]|0,f[r>>2]|0,f[s>>2]|0)|0;f[w>>2]=v}f[i+32>>2]=0;f[j>>2]=69;I=n;D=59;break}n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=0;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=0;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[i+132>>2]|0;if((v|0)==9)J=2;else J=((v|0)<2?1:(f[i+136>>2]|0)>1)?4:0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=J;n=f[r>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[n+r>>0]=3;f[j>>2]=113;r=f[g>>2]|0;foc(r);n=r+20|0;v=f[n>>2]|0;w=f[p>>2]|0;A=v>>>0>w>>>0?w:v;if(A|0?(v=r+16|0,dJc(f[l>>2]|0,f[v>>2]|0,A|0)|0,f[l>>2]=(f[l>>2]|0)+A,f[v>>2]=(f[v>>2]|0)+A,w=a+20|0,f[w>>2]=(f[w>>2]|0)+A,f[p>>2]=(f[p>>2]|0)-A,w=(f[n>>2]|0)-A|0,f[n>>2]=w,(w|0)==0):0)f[v>>2]=f[r+8>>2];if(!(f[s>>2]|0)){K=f[j>>2]|0;D=56;break}f[q>>2]=-1;e=0;return e|0}else{K=F;D=56}while(0);b:do if((D|0)==56)switch(K|0){case 69:{I=i+28|0;D=59;break b;break}case 73:{L=i+28|0;D=74;break b;break}case 91:{M=i+28|0;D=93;break b;break}case 103:{N=i+28|0;D=109;break b;break}default:break b}while(0);if((D|0)==59){r=f[I>>2]|0;v=f[r+16>>2]|0;if(v|0){w=f[s>>2]|0;n=i+32|0;A=f[n>>2]|0;z=(f[r+20>>2]&65535)-A|0;r=i+12|0;y=f[r>>2]|0;x=i+8|0;c:do if((w+z|0)>>>0>y>>>0){O=a+48|0;P=a+20|0;Q=z;R=w;S=y;T=v;U=A;while(1){V=S-R|0;dJc((f[x>>2]|0)+R|0,T+U|0,V|0)|0;W=f[r>>2]|0;f[s>>2]=W;if(W>>>0>R>>>0?(f[(f[I>>2]|0)+44>>2]|0)!=0:0){X=Tnc(f[O>>2]|0,(f[x>>2]|0)+R|0,W-R|0)|0;f[O>>2]=X}f[n>>2]=(f[n>>2]|0)+V;X=f[g>>2]|0;foc(X);W=X+20|0;Y=f[W>>2]|0;Z=f[p>>2]|0;_=Y>>>0>Z>>>0?Z:Y;do if(_|0){Y=X+16|0;dJc(f[l>>2]|0,f[Y>>2]|0,_|0)|0;f[l>>2]=(f[l>>2]|0)+_;f[Y>>2]=(f[Y>>2]|0)+_;f[P>>2]=(f[P>>2]|0)+_;f[p>>2]=(f[p>>2]|0)-_;Z=(f[W>>2]|0)-_|0;f[W>>2]=Z;if(Z|0)break;f[Y>>2]=f[X+8>>2]}while(0);if(f[s>>2]|0)break;X=Q-V|0;S=f[r>>2]|0;W=f[(f[I>>2]|0)+16>>2]|0;_=f[n>>2]|0;if(X>>>0<=S>>>0){$=X;aa=0;ba=W;ca=_;break c}else{Q=X;R=0;T=W;U=_}}f[q>>2]=-1;e=0;return e|0}else{$=z;aa=w;ba=v;ca=A}while(0);dJc((f[x>>2]|0)+aa|0,ba+ca|0,$|0)|0;A=(f[s>>2]|0)+$|0;f[s>>2]=A;if(A>>>0>aa>>>0?(f[(f[I>>2]|0)+44>>2]|0)!=0:0){v=a+48|0;w=Tnc(f[v>>2]|0,(f[x>>2]|0)+aa|0,A-aa|0)|0;f[v>>2]=w}f[n>>2]=0}f[j>>2]=73;L=I;D=74}if((D|0)==74){if(f[(f[L>>2]|0)+28>>2]|0){w=f[s>>2]|0;v=i+12|0;A=a+48|0;z=i+8|0;r=a+20|0;y=i+32|0;U=w;T=w;while(1){if((T|0)==(f[v>>2]|0)){if(T>>>0>U>>>0?(f[(f[L>>2]|0)+44>>2]|0)!=0:0){w=Tnc(f[A>>2]|0,(f[z>>2]|0)+U|0,T-U|0)|0;f[A>>2]=w}w=f[g>>2]|0;foc(w);R=w+20|0;Q=f[R>>2]|0;S=f[p>>2]|0;P=Q>>>0>S>>>0?S:Q;do if(P|0){Q=w+16|0;dJc(f[l>>2]|0,f[Q>>2]|0,P|0)|0;f[l>>2]=(f[l>>2]|0)+P;f[Q>>2]=(f[Q>>2]|0)+P;f[r>>2]=(f[r>>2]|0)+P;f[p>>2]=(f[p>>2]|0)-P;S=(f[R>>2]|0)-P|0;f[R>>2]=S;if(S|0)break;f[Q>>2]=f[w+8>>2]}while(0);if(!(f[s>>2]|0)){da=0;ea=0}else{D=83;break}}else{da=U;ea=T}w=f[(f[L>>2]|0)+28>>2]|0;R=f[y>>2]|0;f[y>>2]=R+1;P=b[w+R>>0]|0;R=f[z>>2]|0;f[s>>2]=ea+1;b[R+ea>>0]=P;if(!(P<<24>>24))break;U=da;T=f[s>>2]|0}if((D|0)==83){f[q>>2]=-1;e=0;return e|0}if(f[(f[L>>2]|0)+44>>2]|0?(T=f[s>>2]|0,T>>>0>da>>>0):0){U=Tnc(f[A>>2]|0,(f[z>>2]|0)+da|0,T-da|0)|0;f[A>>2]=U}f[y>>2]=0}f[j>>2]=91;M=L;D=93}if((D|0)==93){if(f[(f[M>>2]|0)+36>>2]|0){U=f[s>>2]|0;T=i+12|0;r=a+48|0;v=i+8|0;n=a+20|0;x=i+32|0;P=U;R=U;while(1){if((R|0)==(f[T>>2]|0)){if(R>>>0>P>>>0?(f[(f[M>>2]|0)+44>>2]|0)!=0:0){U=Tnc(f[r>>2]|0,(f[v>>2]|0)+P|0,R-P|0)|0;f[r>>2]=U}U=f[g>>2]|0;foc(U);w=U+20|0;Q=f[w>>2]|0;S=f[p>>2]|0;O=Q>>>0>S>>>0?S:Q;do if(O|0){Q=U+16|0;dJc(f[l>>2]|0,f[Q>>2]|0,O|0)|0;f[l>>2]=(f[l>>2]|0)+O;f[Q>>2]=(f[Q>>2]|0)+O;f[n>>2]=(f[n>>2]|0)+O;f[p>>2]=(f[p>>2]|0)-O;S=(f[w>>2]|0)-O|0;f[w>>2]=S;if(S|0)break;f[Q>>2]=f[U+8>>2]}while(0);if(!(f[s>>2]|0)){fa=0;ga=0}else{D=102;break}}else{fa=P;ga=R}U=f[(f[M>>2]|0)+36>>2]|0;w=f[x>>2]|0;f[x>>2]=w+1;O=b[U+w>>0]|0;w=f[v>>2]|0;f[s>>2]=ga+1;b[w+ga>>0]=O;if(!(O<<24>>24))break;P=fa;R=f[s>>2]|0}if((D|0)==102){f[q>>2]=-1;e=0;return e|0}if(f[(f[M>>2]|0)+44>>2]|0?(R=f[s>>2]|0,R>>>0>fa>>>0):0){P=Tnc(f[r>>2]|0,(f[v>>2]|0)+fa|0,R-fa|0)|0;f[r>>2]=P}}f[j>>2]=103;N=M;D=109}if((D|0)==109){if(f[(f[N>>2]|0)+44>>2]|0){P=f[s>>2]|0;do if((P+2|0)>>>0>(f[i+12>>2]|0)>>>0){R=f[g>>2]|0;foc(R);x=R+20|0;n=f[x>>2]|0;T=f[p>>2]|0;y=n>>>0>T>>>0?T:n;do if(y|0){n=R+16|0;dJc(f[l>>2]|0,f[n>>2]|0,y|0)|0;f[l>>2]=(f[l>>2]|0)+y;f[n>>2]=(f[n>>2]|0)+y;T=a+20|0;f[T>>2]=(f[T>>2]|0)+y;f[p>>2]=(f[p>>2]|0)-y;T=(f[x>>2]|0)-y|0;f[x>>2]=T;if(T|0)break;f[n>>2]=f[R+8>>2]}while(0);if(!(f[s>>2]|0)){ha=0;break}f[q>>2]=-1;e=0;return e|0}else ha=P;while(0);P=a+48|0;r=f[P>>2]&255;v=i+8|0;R=f[v>>2]|0;f[s>>2]=ha+1;b[R+ha>>0]=r;r=(f[P>>2]|0)>>>8&255;R=f[v>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[R+v>>0]=r;r=Tnc(0,0,0)|0;f[P>>2]=r}f[j>>2]=113;r=f[g>>2]|0;foc(r);P=r+20|0;v=f[P>>2]|0;R=f[p>>2]|0;x=v>>>0>R>>>0?R:v;if(x|0?(v=r+16|0,dJc(f[l>>2]|0,f[v>>2]|0,x|0)|0,f[l>>2]=(f[l>>2]|0)+x,f[v>>2]=(f[v>>2]|0)+x,R=a+20|0,f[R>>2]=(f[R>>2]|0)+x,f[p>>2]=(f[p>>2]|0)-x,R=(f[P>>2]|0)-x|0,f[P>>2]=R,(R|0)==0):0)f[v>>2]=f[r+8>>2];if(f[s>>2]|0){f[q>>2]=-1;e=0;return e|0}}if(!(f[m>>2]|0))D=123;else D=126}if((D|0)==123)if(!(f[i+116>>2]|0)){if(c|0?(f[j>>2]|0)!=666:0)D=126}else D=126;do if((D|0)==126){r=f[i+132>>2]|0;d:do if(!r){ia=Xnc(i,c)|0;D=200}else switch(f[i+136>>2]|0){case 2:{v=i+116|0;R=i+96|0;P=i+56|0;x=i+108|0;y=i+5796|0;n=i+5792|0;T=i+5784|0;A=i+5788|0;z=i+92|0;while(1){if((f[v>>2]|0)==0?(_nc(i),(f[v>>2]|0)==0):0)break;f[R>>2]=0;O=b[(f[P>>2]|0)+(f[x>>2]|0)>>0]|0;w=f[n>>2]|0;d[(f[y>>2]|0)+(w<<1)>>1]=0;U=f[T>>2]|0;f[n>>2]=w+1;b[U+w>>0]=O;w=i+148+((O&255)<<2)|0;d[w>>1]=(d[w>>1]|0)+1<<16>>16;w=(f[n>>2]|0)==((f[A>>2]|0)+-1|0);f[v>>2]=(f[v>>2]|0)+-1;O=(f[x>>2]|0)+1|0;f[x>>2]=O;if(!w)continue;w=f[z>>2]|0;if((w|0)>-1)ja=(f[P>>2]|0)+w|0;else ja=0;hoc(i,ja,O-w|0,0);f[z>>2]=f[x>>2];w=f[i>>2]|0;O=f[w+28>>2]|0;foc(O);U=O+20|0;Q=f[U>>2]|0;S=w+16|0;_=f[S>>2]|0;W=Q>>>0>_>>>0?_:Q;do if(W|0){Q=w+12|0;_=O+16|0;dJc(f[Q>>2]|0,f[_>>2]|0,W|0)|0;f[Q>>2]=(f[Q>>2]|0)+W;f[_>>2]=(f[_>>2]|0)+W;Q=w+20|0;f[Q>>2]=(f[Q>>2]|0)+W;f[S>>2]=(f[S>>2]|0)-W;Q=(f[U>>2]|0)-W|0;f[U>>2]=Q;if(Q|0)break;f[_>>2]=f[O+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}}if(!c){D=203;break d}f[i+5812>>2]=0;if((c|0)==4){v=f[z>>2]|0;if((v|0)>-1)ka=(f[P>>2]|0)+v|0;else ka=0;hoc(i,ka,(f[x>>2]|0)-v|0,1);f[z>>2]=f[x>>2];v=f[i>>2]|0;A=f[v+28>>2]|0;foc(A);T=A+20|0;y=f[T>>2]|0;R=v+16|0;V=f[R>>2]|0;O=y>>>0>V>>>0?V:y;do if(O|0){y=v+12|0;V=A+16|0;dJc(f[y>>2]|0,f[V>>2]|0,O|0)|0;f[y>>2]=(f[y>>2]|0)+O;f[V>>2]=(f[V>>2]|0)+O;y=v+20|0;f[y>>2]=(f[y>>2]|0)+O;f[R>>2]=(f[R>>2]|0)-O;y=(f[T>>2]|0)-O|0;f[T>>2]=y;if(y|0)break;f[V>>2]=f[A+8>>2]}while(0);ia=(f[(f[i>>2]|0)+16>>2]|0)==0?2:3;D=200;break d}if(!(f[n>>2]|0))break d;A=f[z>>2]|0;if((A|0)>-1)la=(f[P>>2]|0)+A|0;else la=0;hoc(i,la,(f[x>>2]|0)-A|0,0);f[z>>2]=f[x>>2];A=f[i>>2]|0;T=f[A+28>>2]|0;foc(T);O=T+20|0;R=f[O>>2]|0;v=A+16|0;V=f[v>>2]|0;y=R>>>0>V>>>0?V:R;do if(y|0){R=A+12|0;V=T+16|0;dJc(f[R>>2]|0,f[V>>2]|0,y|0)|0;f[R>>2]=(f[R>>2]|0)+y;f[V>>2]=(f[V>>2]|0)+y;R=A+20|0;f[R>>2]=(f[R>>2]|0)+y;f[v>>2]=(f[v>>2]|0)-y;R=(f[O>>2]|0)-y|0;f[O>>2]=R;if(R|0)break;f[V>>2]=f[T+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}else break d;break}case 3:{T=i+116|0;O=(c|0)==0;y=i+96|0;v=i+108|0;A=i+5784|0;x=i+5796|0;z=i+5792|0;P=i+5788|0;n=i+56|0;V=i+92|0;e:while(1){R=f[T>>2]|0;do if(R>>>0<259){_nc(i);U=f[T>>2]|0;if(O&U>>>0<259){D=203;break d}if(!U)break e;f[y>>2]=0;if(U>>>0>2){ma=U;D=161;break}na=f[v>>2]|0;oa=f[x>>2]|0;pa=f[A>>2]|0;D=177}else{f[y>>2]=0;ma=R;D=161}while(0);f:do if((D|0)==161){D=0;R=f[v>>2]|0;do if(R|0){U=(f[n>>2]|0)+R|0;W=b[U+-1>>0]|0;if(W<<24>>24!=(b[U>>0]|0))break;S=U+1|0;if(W<<24>>24!=(b[S>>0]|0))break;if(W<<24>>24!=(b[S+1>>0]|0))break;S=U+258|0;w=1;while(1){_=U+w|0;Q=_+2|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+3|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+4|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+5|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+6|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+7|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=w;w=w+8|0;_=U+w|0;if(W<<24>>24!=(b[_>>0]|0)){qa=_;break}_=Q+9|0;Q=U+_|0;if(!((_|0)<258?W<<24>>24==(b[Q>>0]|0):0)){qa=Q;break}}W=qa-S+258|0;U=W>>>0>ma>>>0?ma:W;f[y>>2]=U;W=f[A>>2]|0;w=f[x>>2]|0;if(U>>>0<=2){na=R;oa=w;pa=W;D=177;break f}Q=U+253|0;U=f[z>>2]|0;d[w+(U<<1)>>1]=1;f[z>>2]=U+1;b[W+U>>0]=Q;U=i+148+((h[510251+(Q&255)>>0]|256)+1<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=i+2440+(h[509739]<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=(f[z>>2]|0)==((f[P>>2]|0)+-1|0)&1;Q=f[y>>2]|0;f[T>>2]=(f[T>>2]|0)-Q;W=(f[v>>2]|0)+Q|0;f[v>>2]=W;f[y>>2]=0;ra=U;sa=W;break f}while(0);na=R;oa=f[x>>2]|0;pa=f[A>>2]|0;D=177}while(0);if((D|0)==177){D=0;W=b[(f[n>>2]|0)+na>>0]|0;U=f[z>>2]|0;d[oa+(U<<1)>>1]=0;f[z>>2]=U+1;b[pa+U>>0]=W;U=i+148+((W&255)<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=(f[z>>2]|0)==((f[P>>2]|0)+-1|0)&1;f[T>>2]=(f[T>>2]|0)+-1;W=(f[v>>2]|0)+1|0;f[v>>2]=W;ra=U;sa=W}if(!ra)continue;W=f[V>>2]|0;if((W|0)>-1)ta=(f[n>>2]|0)+W|0;else ta=0;hoc(i,ta,sa-W|0,0);f[V>>2]=f[v>>2];W=f[i>>2]|0;U=f[W+28>>2]|0;foc(U);Q=U+20|0;w=f[Q>>2]|0;_=W+16|0;X=f[_>>2]|0;Y=w>>>0>X>>>0?X:w;do if(Y|0){w=W+12|0;X=U+16|0;dJc(f[w>>2]|0,f[X>>2]|0,Y|0)|0;f[w>>2]=(f[w>>2]|0)+Y;f[X>>2]=(f[X>>2]|0)+Y;w=W+20|0;f[w>>2]=(f[w>>2]|0)+Y;f[_>>2]=(f[_>>2]|0)-Y;w=(f[Q>>2]|0)-Y|0;f[Q>>2]=w;if(w|0)break;f[X>>2]=f[U+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}}f[i+5812>>2]=0;if((c|0)==4){T=f[V>>2]|0;if((T|0)>-1)ua=(f[n>>2]|0)+T|0;else ua=0;hoc(i,ua,(f[v>>2]|0)-T|0,1);f[V>>2]=f[v>>2];T=f[i>>2]|0;P=f[T+28>>2]|0;foc(P);A=P+20|0;x=f[A>>2]|0;y=T+16|0;O=f[y>>2]|0;U=x>>>0>O>>>0?O:x;do if(U|0){x=T+12|0;O=P+16|0;dJc(f[x>>2]|0,f[O>>2]|0,U|0)|0;f[x>>2]=(f[x>>2]|0)+U;f[O>>2]=(f[O>>2]|0)+U;x=T+20|0;f[x>>2]=(f[x>>2]|0)+U;f[y>>2]=(f[y>>2]|0)-U;x=(f[A>>2]|0)-U|0;f[A>>2]=x;if(x|0)break;f[O>>2]=f[P+8>>2]}while(0);ia=(f[(f[i>>2]|0)+16>>2]|0)==0?2:3;D=200;break d}if(!(f[z>>2]|0))break d;P=f[V>>2]|0;if((P|0)>-1)va=(f[n>>2]|0)+P|0;else va=0;hoc(i,va,(f[v>>2]|0)-P|0,0);f[V>>2]=f[v>>2];P=f[i>>2]|0;A=f[P+28>>2]|0;foc(A);U=A+20|0;y=f[U>>2]|0;T=P+16|0;O=f[T>>2]|0;x=y>>>0>O>>>0?O:y;do if(x|0){y=P+12|0;O=A+16|0;dJc(f[y>>2]|0,f[O>>2]|0,x|0)|0;f[y>>2]=(f[y>>2]|0)+x;f[O>>2]=(f[O>>2]|0)+x;y=P+20|0;f[y>>2]=(f[y>>2]|0)+x;f[T>>2]=(f[T>>2]|0)-x;y=(f[U>>2]|0)-x|0;f[U>>2]=y;if(y|0)break;f[O>>2]=f[A+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}else break d;break}default:{ia=Mi[f[176672+(r*12|0)+8>>2]&1023](i,c)|0;D=200;break d}}while(0);if((D|0)==200){if((ia|1|0)==3)f[j>>2]=666;if((ia|2|0)!=2){if((ia|0)!=1)break}else D=203}if((D|0)==203){if(f[p>>2]|0){e=0;return e|0}f[q>>2]=-1;e=0;return e|0}switch(c|0){case 1:{goc(i);break}case 5:break;default:{eoc(i,0,0,0);if((c|0)==3?(r=f[i+68>>2]|0,A=(f[i+76>>2]|0)+-1|0,d[r+(A<<1)>>1]=0,XIc(r|0,0,A<<1|0)|0,(f[i+116>>2]|0)==0):0){f[i+108>>2]=0;f[i+92>>2]=0;f[i+5812>>2]=0}}}A=f[g>>2]|0;foc(A);r=A+20|0;U=f[r>>2]|0;x=f[p>>2]|0;T=U>>>0>x>>>0?x:U;if(T){U=A+16|0;dJc(f[l>>2]|0,f[U>>2]|0,T|0)|0;f[l>>2]=(f[l>>2]|0)+T;f[U>>2]=(f[U>>2]|0)+T;P=a+20|0;f[P>>2]=(f[P>>2]|0)+T;P=(f[p>>2]|0)-T|0;f[p>>2]=P;v=(f[r>>2]|0)-T|0;f[r>>2]=v;if(!v){f[U>>2]=f[A+8>>2];wa=P}else wa=P}else wa=x;if(!wa){f[q>>2]=-1;e=0;return e|0}}while(0);if(o){e=0;return e|0}q=i+24|0;m=f[q>>2]|0;if((m|0)<1){e=1;return e|0}x=a+48|0;P=f[x>>2]|0;if((m|0)==2){m=i+8|0;A=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[A+U>>0]=P;U=(f[x>>2]|0)>>>8&255;A=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=U;U=(f[x>>2]|0)>>>16&255;v=f[m>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=U;U=(f[x>>2]|0)>>>24&255;A=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=U;U=a+8|0;v=f[U>>2]&255;A=f[m>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[A+r>>0]=v;v=(f[U>>2]|0)>>>8&255;r=f[m>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[r+A>>0]=v;v=(f[U>>2]|0)>>>16&255;A=f[m>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[A+r>>0]=v;v=(f[U>>2]|0)>>>24;U=f[m>>2]|0;m=f[s>>2]|0;f[s>>2]=m+1;xa=v;ya=U+m|0}else{m=i+8|0;U=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[U+v>>0]=P>>>24;v=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[v+U>>0]=P>>>16;P=f[x>>2]|0;x=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[x+U>>0]=P>>>8;U=f[m>>2]|0;m=f[s>>2]|0;f[s>>2]=m+1;xa=P;ya=U+m|0}b[ya>>0]=xa;m=f[g>>2]|0;foc(m);U=m+20|0;P=f[U>>2]|0;x=f[p>>2]|0;v=P>>>0>x>>>0?x:P;if(v|0?(P=m+16|0,dJc(f[l>>2]|0,f[P>>2]|0,v|0)|0,f[l>>2]=(f[l>>2]|0)+v,f[P>>2]=(f[P>>2]|0)+v,x=a+20|0,f[x>>2]=(f[x>>2]|0)+v,f[p>>2]=(f[p>>2]|0)-v,x=(f[U>>2]|0)-v|0,f[U>>2]=x,(x|0)==0):0)f[P>>2]=f[m+8>>2];m=f[q>>2]|0;if((m|0)>0)f[q>>2]=0-m;e=(f[s>>2]|0)==0&1;return e|0}}while(0);f[a+24>>2]=f[42114];e=-2;return e|0}function coc(a){a=a|0;f[a+2840>>2]=a+148;f[a+2848>>2]=176792;f[a+2852>>2]=a+2440;f[a+2860>>2]=176812;f[a+2864>>2]=a+2684;f[a+2872>>2]=176832;d[a+5816>>1]=0;f[a+5820>>2]=0;doc(a);return}function doc(a){a=a|0;var b=0;b=0;do{d[a+148+(b<<2)>>1]=0;b=b+1|0}while((b|0)!=286);d[a+2440>>1]=0;d[a+2444>>1]=0;d[a+2448>>1]=0;d[a+2452>>1]=0;d[a+2456>>1]=0;d[a+2460>>1]=0;d[a+2464>>1]=0;d[a+2468>>1]=0;d[a+2472>>1]=0;d[a+2476>>1]=0;d[a+2480>>1]=0;d[a+2484>>1]=0;d[a+2488>>1]=0;d[a+2492>>1]=0;d[a+2496>>1]=0;d[a+2500>>1]=0;d[a+2504>>1]=0;d[a+2508>>1]=0;d[a+2512>>1]=0;d[a+2516>>1]=0;d[a+2520>>1]=0;d[a+2524>>1]=0;d[a+2528>>1]=0;d[a+2532>>1]=0;d[a+2536>>1]=0;d[a+2540>>1]=0;d[a+2544>>1]=0;d[a+2548>>1]=0;d[a+2552>>1]=0;d[a+2556>>1]=0;d[a+2684>>1]=0;d[a+2688>>1]=0;d[a+2692>>1]=0;d[a+2696>>1]=0;d[a+2700>>1]=0;d[a+2704>>1]=0;d[a+2708>>1]=0;d[a+2712>>1]=0;d[a+2716>>1]=0;d[a+2720>>1]=0;d[a+2724>>1]=0;d[a+2728>>1]=0;d[a+2732>>1]=0;d[a+2736>>1]=0;d[a+2740>>1]=0;d[a+2744>>1]=0;d[a+2748>>1]=0;d[a+2752>>1]=0;d[a+2756>>1]=0;d[a+1172>>1]=1;f[a+5804>>2]=0;f[a+5800>>2]=0;f[a+5808>>2]=0;f[a+5792>>2]=0;return}function eoc(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=a+5820|0;i=f[h>>2]|0;k=g&65535;g=a+5816|0;l=j[g>>1]|0|k<<i;d[g>>1]=l;if((i|0)>13){m=a+8|0;n=f[m>>2]|0;o=a+20|0;p=f[o>>2]|0;f[o>>2]=p+1;b[n+p>>0]=l;p=(j[g>>1]|0)>>>8&255;n=f[m>>2]|0;m=f[o>>2]|0;f[o>>2]=m+1;b[n+m>>0]=p;p=f[h>>2]|0;m=k>>>(16-p|0);d[g>>1]=m;q=m;r=p+-13|0}else{q=l;r=i+3|0}i=q&255;f[h>>2]=r;if((r|0)<=8){if((r|0)>0){r=f[a+8>>2]|0;q=a+20|0;l=f[q>>2]|0;f[q>>2]=l+1;s=i;t=r+l|0;u=8}}else{l=a+8|0;r=f[l>>2]|0;q=a+20|0;p=f[q>>2]|0;f[q>>2]=p+1;b[r+p>>0]=i;i=(j[g>>1]|0)>>>8&255;p=f[l>>2]|0;l=f[q>>2]|0;f[q>>2]=l+1;s=i;t=p+l|0;u=8}if((u|0)==8)b[t>>0]=s;d[g>>1]=0;f[h>>2]=0;h=a+8|0;g=f[h>>2]|0;s=a+20|0;a=f[s>>2]|0;f[s>>2]=a+1;b[g+a>>0]=e;a=f[h>>2]|0;g=f[s>>2]|0;f[s>>2]=g+1;b[a+g>>0]=e>>>8;g=e&65535^65535;a=f[h>>2]|0;t=f[s>>2]|0;f[s>>2]=t+1;b[a+t>>0]=g;t=f[h>>2]|0;a=f[s>>2]|0;f[s>>2]=a+1;b[t+a>>0]=g>>>8;dJc((f[h>>2]|0)+(f[s>>2]|0)|0,c|0,e|0)|0;f[s>>2]=(f[s>>2]|0)+e;return}function foc(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;c=a+5820|0;e=f[c>>2]|0;do if((e|0)!=16)if((e|0)>7){g=a+5816|0;h=d[g>>1]&255;i=f[a+8>>2]|0;k=a+20|0;l=f[k>>2]|0;f[k>>2]=l+1;b[i+l>>0]=h;d[g>>1]=(j[g>>1]|0)>>>8;m=(f[c>>2]|0)+-8|0;break}else return;else{g=a+5816|0;h=d[g>>1]&255;l=a+8|0;i=f[l>>2]|0;k=a+20|0;n=f[k>>2]|0;f[k>>2]=n+1;b[i+n>>0]=h;h=(j[g>>1]|0)>>>8&255;n=f[l>>2]|0;l=f[k>>2]|0;f[k>>2]=l+1;b[n+l>>0]=h;d[g>>1]=0;m=0}while(0);f[c>>2]=m;return}function goc(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+5820|0;e=f[c>>2]|0;g=a+5816|0;h=j[g>>1]|0|2<<e;d[g>>1]=h;if((e|0)>13){i=a+8|0;k=f[i>>2]|0;l=a+20|0;m=f[l>>2]|0;f[l>>2]=m+1;b[k+m>>0]=h;m=(j[g>>1]|0)>>>8&255;k=f[i>>2]|0;i=f[l>>2]|0;f[l>>2]=i+1;b[k+i>>0]=m;m=f[c>>2]|0;i=2>>>(16-m|0);d[g>>1]=i;n=i;o=m+-13|0}else{n=h;o=e+3|0}e=n&255;f[c>>2]=o;if((o|0)>9){n=a+8|0;h=f[n>>2]|0;m=a+20|0;i=f[m>>2]|0;f[m>>2]=i+1;b[h+i>>0]=e;i=(j[g>>1]|0)>>>8&255;h=f[n>>2]|0;n=f[m>>2]|0;f[m>>2]=n+1;b[h+n>>0]=i;i=f[c>>2]|0;d[g>>1]=0;p=0;q=i+-9|0}else{p=e;q=o+7|0}f[c>>2]=q;do if((q|0)!=16)if((q|0)>7){o=f[a+8>>2]|0;e=a+20|0;i=f[e>>2]|0;f[e>>2]=i+1;b[o+i>>0]=p;d[g>>1]=(j[g>>1]|0)>>>8;r=(f[c>>2]|0)+-8|0;break}else return;else{i=a+8|0;o=f[i>>2]|0;e=a+20|0;n=f[e>>2]|0;f[e>>2]=n+1;b[o+n>>0]=p;n=(j[g>>1]|0)>>>8&255;o=f[i>>2]|0;i=f[e>>2]|0;f[e>>2]=i+1;b[o+i>>0]=n;d[g>>1]=0;r=0}while(0);f[c>>2]=r;return}function hoc(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;if((f[a+132>>2]|0)>0){i=(f[a>>2]|0)+44|0;if((f[i>>2]|0)==2){k=-201342849;l=0;while(1){if(k&1|0?d[a+148+(l<<2)>>1]|0:0){m=0;break}l=l+1|0;if((l|0)>=32){n=6;break}else k=k>>>1}a:do if((n|0)==6)if(((d[a+184>>1]|0)==0?(d[a+188>>1]|0)==0:0)?(d[a+200>>1]|0)==0:0){k=32;while(1){if(d[a+148+(k<<2)>>1]|0){m=1;break a}k=k+1|0;if((k|0)>=256){m=0;break}}}else m=1;while(0);f[i>>2]=m}ioc(a,a+2840|0);ioc(a,a+2852|0);m=f[a+2844>>2]|0;i=d[a+150>>1]|0;k=i<<16>>16==0;d[a+148+(m+1<<2)+2>>1]=-1;l=a+2756|0;o=a+2752|0;p=a+2748|0;q=i&65535;i=0;r=-1;s=k?3:4;t=k?138:7;b:while(1){k=0;u=i;do{if((u|0)>(m|0))break b;u=u+1|0;v=d[a+148+(u<<2)+2>>1]|0;w=v&65535;k=k+1|0;x=(q|0)==(w|0)}while((k|0)<(t|0)&x);if((k|0)<(s|0)){y=a+2684+(q<<2)|0;d[y>>1]=(j[y>>1]|0)+k}else{if(q){y=a+2684+(q<<2)|0;if((q|0)==(r|0))z=p;else{d[y>>1]=(d[y>>1]|0)+1<<16>>16;z=p}}else z=(k|0)<11?o:l;d[z>>1]=(d[z>>1]|0)+1<<16>>16}y=v<<16>>16==0;A=q;q=w;i=u;s=y|x?3:4;t=y?138:x?6:7;r=A}r=f[a+2856>>2]|0;x=d[a+2442>>1]|0;t=x<<16>>16==0;d[a+2440+(r+1<<2)+2>>1]=-1;s=x&65535;x=0;i=-1;w=t?3:4;q=t?138:7;c:while(1){t=0;v=x;do{if((v|0)>(r|0))break c;v=v+1|0;B=d[a+2440+(v<<2)+2>>1]|0;C=B&65535;t=t+1|0;D=(s|0)==(C|0)}while((t|0)<(q|0)&D);if((t|0)<(w|0)){u=a+2684+(s<<2)|0;d[u>>1]=(j[u>>1]|0)+t}else{if(s){u=a+2684+(s<<2)|0;if((s|0)==(i|0))E=p;else{d[u>>1]=(d[u>>1]|0)+1<<16>>16;E=p}}else E=(t|0)<11?o:l;d[E>>1]=(d[E>>1]|0)+1<<16>>16}u=B<<16>>16==0;k=s;s=C;x=v;w=u|D?3:4;q=u?138:D?6:7;i=k}ioc(a,a+2864|0);if(!(d[a+2746>>1]|0))if(!(d[a+2690>>1]|0))if(!(d[a+2742>>1]|0))if(!(d[a+2694>>1]|0))if(!(d[a+2738>>1]|0))if(!(d[a+2698>>1]|0))if(!(d[a+2734>>1]|0))if(!(d[a+2702>>1]|0))if(!(d[a+2730>>1]|0))if(!(d[a+2706>>1]|0))if(!(d[a+2726>>1]|0))if(!(d[a+2710>>1]|0))if(!(d[a+2722>>1]|0))if(!(d[a+2714>>1]|0))if(!(d[a+2718>>1]|0))F=(d[a+2686>>1]|0)==0?2:3;else F=4;else F=5;else F=6;else F=7;else F=8;else F=9;else F=10;else F=11;else F=12;else F=13;else F=14;else F=15;else F=16;else F=17;else F=18;i=a+5800|0;D=(F*3|0)+17+(f[i>>2]|0)|0;f[i>>2]=D;i=(D+10|0)>>>3;D=((f[a+5804>>2]|0)+10|0)>>>3;G=D>>>0>i>>>0?i:D;H=D;I=F}else{F=e+5|0;G=F;H=F;I=0}do if((c|0)!=0&(e+4|0)>>>0<=G>>>0)eoc(a,c,e,g);else{F=a+5820|0;D=f[F>>2]|0;i=(D|0)>13;if((H|0)==(G|0)?1:(f[a+136>>2]|0)==4){q=g+2&65535;w=a+5816|0;x=j[w>>1]|q<<D;d[w>>1]=x;if(i){C=a+8|0;s=f[C>>2]|0;B=a+20|0;E=f[B>>2]|0;f[B>>2]=E+1;b[s+E>>0]=x;x=(j[w>>1]|0)>>>8&255;E=f[C>>2]|0;C=f[B>>2]|0;f[B>>2]=C+1;b[E+C>>0]=x;x=f[F>>2]|0;d[w>>1]=q>>>(16-x|0);J=x+-13|0}else J=D+3|0;f[F>>2]=J;joc(a,188266,188146);break}x=g+4&65535;q=a+5816|0;w=j[q>>1]|x<<D;d[q>>1]=w;if(i){i=a+8|0;C=f[i>>2]|0;E=a+20|0;B=f[E>>2]|0;f[E>>2]=B+1;b[C+B>>0]=w;B=(j[q>>1]|0)>>>8&255;C=f[i>>2]|0;i=f[E>>2]|0;f[E>>2]=i+1;b[C+i>>0]=B;B=f[F>>2]|0;i=x>>>(16-B|0);d[q>>1]=i;K=i;L=B+-13|0}else{K=w;L=D+3|0}f[F>>2]=L;D=f[a+2844>>2]|0;w=f[a+2856>>2]|0;B=D+65280&65535;i=K&65535|B<<L;d[q>>1]=i;if((L|0)>11){x=a+8|0;C=f[x>>2]|0;E=a+20|0;s=f[E>>2]|0;f[E>>2]=s+1;b[C+s>>0]=i;s=(j[q>>1]|0)>>>8&255;C=f[x>>2]|0;x=f[E>>2]|0;f[E>>2]=x+1;b[C+x>>0]=s;s=f[F>>2]|0;x=B>>>(16-s|0);d[q>>1]=x;M=s+-11|0;N=x}else{M=L+5|0;N=i}f[F>>2]=M;i=w&65535;x=i<<M|N&65535;d[q>>1]=x;if((M|0)>11){s=a+8|0;B=f[s>>2]|0;C=a+20|0;E=f[C>>2]|0;f[C>>2]=E+1;b[B+E>>0]=x;E=(j[q>>1]|0)>>>8&255;B=f[s>>2]|0;s=f[C>>2]|0;f[C>>2]=s+1;b[B+s>>0]=E;E=f[F>>2]|0;s=i>>>(16-E|0);d[q>>1]=s;O=E+-11|0;P=s}else{O=M+5|0;P=x}f[F>>2]=O;x=I+65533&65535;s=x<<O|P&65535;d[q>>1]=s;if((O|0)>12){E=a+8|0;i=f[E>>2]|0;B=a+20|0;C=f[B>>2]|0;f[B>>2]=C+1;b[i+C>>0]=s;C=(j[q>>1]|0)>>>8&255;i=f[E>>2]|0;l=f[B>>2]|0;f[B>>2]=l+1;b[i+l>>0]=C;C=f[F>>2]|0;l=x>>>(16-C|0);d[q>>1]=l;Q=B;R=E;S=l;T=C+-12|0}else{Q=a+20|0;R=a+8|0;S=s;T=O+4|0}f[F>>2]=T;s=0;C=T;l=S;while(1){E=j[a+2684+(h[510507+s>>0]<<2)+2>>1]|0;B=E<<C|l&65535;d[q>>1]=B;if((C|0)>13){x=f[R>>2]|0;i=f[Q>>2]|0;f[Q>>2]=i+1;b[x+i>>0]=B;i=(j[q>>1]|0)>>>8&255;x=f[R>>2]|0;o=f[Q>>2]|0;f[Q>>2]=o+1;b[x+o>>0]=i;i=f[F>>2]|0;o=E>>>(16-i|0);d[q>>1]=o;U=o;V=i+-13|0}else{U=B;V=C+3|0}f[F>>2]=V;if((s|0)==(I|0))break;else{s=s+1|0;C=V;l=U}}l=a+148|0;koc(a,l,D);C=a+2440|0;koc(a,C,w);joc(a,l,C)}while(0);doc(a);if(!g)return;g=a+5820|0;U=f[g>>2]|0;if((U|0)<=8){if((U|0)>0){U=d[a+5816>>1]&255;V=f[a+8>>2]|0;I=a+20|0;Q=f[I>>2]|0;f[I>>2]=Q+1;W=U;X=V+Q|0;n=84}}else{Q=a+5816|0;V=d[Q>>1]&255;U=a+8|0;I=f[U>>2]|0;R=a+20|0;S=f[R>>2]|0;f[R>>2]=S+1;b[I+S>>0]=V;V=(j[Q>>1]|0)>>>8&255;Q=f[U>>2]|0;U=f[R>>2]|0;f[R>>2]=U+1;W=V;X=Q+U|0;n=84}if((n|0)==84)b[X>>0]=W;d[a+5816>>1]=0;f[g>>2]=0;return}function ioc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=u;u=u+32|0;g=e;i=f[c>>2]|0;k=c+8|0;l=f[k>>2]|0;m=f[l>>2]|0;n=f[l+12>>2]|0;l=a+5200|0;f[l>>2]=0;o=a+5204|0;f[o>>2]=573;if((n|0)>0){p=-1;q=0;while(1){if(!(d[i+(q<<2)>>1]|0)){d[i+(q<<2)+2>>1]=0;r=p}else{s=(f[l>>2]|0)+1|0;f[l>>2]=s;f[a+2908+(s<<2)>>2]=q;b[a+5208+q>>0]=0;r=q}q=q+1|0;if((q|0)==(n|0))break;else p=r}p=f[l>>2]|0;if((p|0)<2){t=r;v=p;w=3}else{x=r;y=p}}else{t=-1;v=0;w=3}if((w|0)==3){w=a+5800|0;p=a+5804|0;if(!m){r=t;q=v;while(1){s=(r|0)<2;z=r+1|0;A=s?z:r;B=s?z:0;z=q+1|0;f[l>>2]=z;f[a+2908+(z<<2)>>2]=B;d[i+(B<<2)>>1]=1;b[a+5208+B>>0]=0;f[w>>2]=(f[w>>2]|0)+-1;B=f[l>>2]|0;if((B|0)<2){r=A;q=B}else{x=A;y=B;break}}}else{q=t;t=v;while(1){v=(q|0)<2;r=q+1|0;B=v?r:q;A=v?r:0;r=t+1|0;f[l>>2]=r;f[a+2908+(r<<2)>>2]=A;d[i+(A<<2)>>1]=1;b[a+5208+A>>0]=0;f[w>>2]=(f[w>>2]|0)+-1;f[p>>2]=(f[p>>2]|0)-(j[m+(A<<2)+2>>1]|0);A=f[l>>2]|0;if((A|0)<2){q=B;t=A}else{x=B;y=A;break}}}}t=c+4|0;f[t>>2]=x;q=y>>>1;if(!q)C=y;else{m=q;q=y;while(1){y=f[a+2908+(m<<2)>>2]|0;p=a+5208+y|0;w=m<<1;a:do if((w|0)>(q|0))D=m;else{A=i+(y<<2)|0;B=m;r=w;v=q;while(1){do if((r|0)<(v|0)){z=r|1;s=f[a+2908+(z<<2)>>2]|0;E=d[i+(s<<2)>>1]|0;F=f[a+2908+(r<<2)>>2]|0;G=d[i+(F<<2)>>1]|0;if((E&65535)>=(G&65535)){if(E<<16>>16!=G<<16>>16){H=r;break}if((h[a+5208+s>>0]|0)>(h[a+5208+F>>0]|0)){H=r;break}}H=z}else H=r;while(0);z=d[A>>1]|0;F=f[a+2908+(H<<2)>>2]|0;s=d[i+(F<<2)>>1]|0;if((z&65535)<(s&65535)){D=B;break a}if(z<<16>>16==s<<16>>16?(h[p>>0]|0)<=(h[a+5208+F>>0]|0):0){D=B;break a}f[a+2908+(B<<2)>>2]=F;r=H<<1;v=f[l>>2]|0;if((r|0)>(v|0)){D=H;break}else B=H}}while(0);f[a+2908+(D<<2)>>2]=y;if((m|0)<=1)break;m=m+-1|0;q=f[l>>2]|0}C=f[l>>2]|0}q=a+2912|0;m=n;n=C;do{C=f[q>>2]|0;D=n+-1|0;f[l>>2]=D;H=f[a+2908+(n<<2)>>2]|0;f[q>>2]=H;p=a+5208+H|0;b:do if((n|0)<3)I=1;else{w=i+(H<<2)|0;B=1;v=2;r=D;while(1){do if((v|0)<(r|0)){A=v|1;F=f[a+2908+(A<<2)>>2]|0;s=d[i+(F<<2)>>1]|0;z=f[a+2908+(v<<2)>>2]|0;G=d[i+(z<<2)>>1]|0;if((s&65535)>=(G&65535)){if(s<<16>>16!=G<<16>>16){J=v;break}if((h[a+5208+F>>0]|0)>(h[a+5208+z>>0]|0)){J=v;break}}J=A}else J=v;while(0);A=d[w>>1]|0;z=f[a+2908+(J<<2)>>2]|0;F=d[i+(z<<2)>>1]|0;if((A&65535)<(F&65535)){I=B;break b}if(A<<16>>16==F<<16>>16?(h[p>>0]|0)<=(h[a+5208+z>>0]|0):0){I=B;break b}f[a+2908+(B<<2)>>2]=z;v=J<<1;r=f[l>>2]|0;if((v|0)>(r|0)){I=J;break}else B=J}}while(0);f[a+2908+(I<<2)>>2]=H;p=f[q>>2]|0;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;f[a+2908+(D<<2)>>2]=C;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;f[a+2908+(D<<2)>>2]=p;D=i+(m<<2)|0;d[D>>1]=(j[i+(p<<2)>>1]|0)+(j[i+(C<<2)>>1]|0);y=a+5208+m|0;b[y>>0]=(h[((h[a+5208+C>>0]|0)>=(h[a+5208+p>>0]|0)?C:p)+(a+5208)>>0]|0)+1;B=m&65535;d[i+(p<<2)+2>>1]=B;d[i+(C<<2)+2>>1]=B;f[q>>2]=m;B=f[l>>2]|0;c:do if((B|0)<2)K=1;else{p=1;r=2;v=B;while(1){do if((r|0)<(v|0)){w=r|1;z=f[a+2908+(w<<2)>>2]|0;F=d[i+(z<<2)>>1]|0;A=f[a+2908+(r<<2)>>2]|0;G=d[i+(A<<2)>>1]|0;if((F&65535)>=(G&65535)){if(F<<16>>16!=G<<16>>16){L=r;break}if((h[a+5208+z>>0]|0)>(h[a+5208+A>>0]|0)){L=r;break}}L=w}else L=r;while(0);w=d[D>>1]|0;A=f[a+2908+(L<<2)>>2]|0;z=d[i+(A<<2)>>1]|0;if((w&65535)<(z&65535)){K=p;break c}if(w<<16>>16==z<<16>>16?(h[y>>0]|0)<=(h[a+5208+A>>0]|0):0){K=p;break c}f[a+2908+(p<<2)>>2]=A;r=L<<1;v=f[l>>2]|0;if((r|0)>(v|0)){K=L;break}else p=L}}while(0);f[a+2908+(K<<2)>>2]=m;m=m+1|0;n=f[l>>2]|0}while((n|0)>1);n=f[q>>2]|0;q=(f[o>>2]|0)+-1|0;f[o>>2]=q;f[a+2908+(q<<2)>>2]=n;n=f[c>>2]|0;c=f[t>>2]|0;t=f[k>>2]|0;k=f[t>>2]|0;q=f[t+4>>2]|0;l=f[t+8>>2]|0;m=f[t+16>>2]|0;t=a+2876|0;K=t+32|0;do{d[t>>1]=0;t=t+2|0}while((t|0)<(K|0));t=f[o>>2]|0;d[n+(f[a+2908+(t<<2)>>2]<<2)+2>>1]=0;o=t+1|0;d:do if((o|0)<573){t=a+5800|0;K=a+5804|0;if(!k){L=o;I=0;while(1){J=f[a+2908+(L<<2)>>2]|0;y=n+(J<<2)+2|0;D=j[n+(j[y>>1]<<2)+2>>1]|0;B=(D|0)<(m|0);C=B?D+1|0:m;D=((B^1)&1)+I|0;d[y>>1]=C;if((J|0)<=(c|0)){y=a+2876+(C<<1)|0;d[y>>1]=(d[y>>1]|0)+1<<16>>16;if((J|0)<(l|0))M=0;else M=f[q+(J-l<<2)>>2]|0;y=Y(j[n+(J<<2)>>1]|0,M+C|0)|0;f[t>>2]=y+(f[t>>2]|0)}L=L+1|0;if((L|0)==573){N=D;break}else I=D}}else{I=o;L=0;while(1){D=f[a+2908+(I<<2)>>2]|0;y=n+(D<<2)+2|0;C=j[n+(j[y>>1]<<2)+2>>1]|0;J=(C|0)<(m|0);B=J?C+1|0:m;C=((J^1)&1)+L|0;d[y>>1]=B;if((D|0)<=(c|0)){y=a+2876+(B<<1)|0;d[y>>1]=(d[y>>1]|0)+1<<16>>16;if((D|0)<(l|0))O=0;else O=f[q+(D-l<<2)>>2]|0;y=j[n+(D<<2)>>1]|0;J=Y(y,O+B|0)|0;f[t>>2]=J+(f[t>>2]|0);J=Y((j[k+(D<<2)+2>>1]|0)+O|0,y)|0;f[K>>2]=J+(f[K>>2]|0)}I=I+1|0;if((I|0)==573){N=C;break}else L=C}}if(N|0){L=a+2876+(m<<1)|0;I=N;while(1){K=m;while(1){C=K+-1|0;P=a+2876+(C<<1)|0;Q=d[P>>1]|0;if(!(Q<<16>>16))K=C;else break}d[P>>1]=Q+-1<<16>>16;C=a+2876+(K<<1)|0;d[C>>1]=(j[C>>1]|0)+2;R=(d[L>>1]|0)+-1<<16>>16;d[L>>1]=R;if((I|0)>2)I=I+-2|0;else break}if(m|0){I=573;L=m;C=R;while(1){J=L&65535;if(!(C<<16>>16))S=I;else{y=C&65535;D=I;while(1){B=D;do{B=B+-1|0;T=f[a+2908+(B<<2)>>2]|0}while((T|0)>(c|0));H=n+(T<<2)+2|0;p=j[H>>1]|0;if((L|0)!=(p|0)){v=Y(j[n+(T<<2)>>1]|0,L-p|0)|0;f[t>>2]=v+(f[t>>2]|0);d[H>>1]=J}y=y+-1|0;if(!y){S=B;break}else D=B}}D=L+-1|0;if(!D)break d;I=S;L=D;C=d[a+2876+(D<<1)>>1]|0}}}}while(0);S=0;T=1;do{S=(j[a+2876+(T+-1<<1)>>1]|0)+S<<1;d[g+(T<<1)>>1]=S;T=T+1|0}while((T|0)!=16);if((x|0)<0){u=e;return}else U=0;while(1){T=d[i+(U<<2)+2>>1]|0;S=T&65535;if(T<<16>>16){T=g+(S<<1)|0;a=d[T>>1]|0;d[T>>1]=a+1<<16>>16;T=0;n=S;S=a&65535;while(1){V=T|S&1;if((n|0)>1){T=V<<1;n=n+-1|0;S=S>>>1}else break}d[i+(U<<2)>>1]=V}if((U|0)==(x|0))break;else U=U+1|0}u=e;return}function joc(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=a+5792|0;if(!(f[g>>2]|0)){i=a+5820|0;k=a+5816|0;l=k;m=i;n=f[i>>2]|0;o=d[k>>1]|0}else{k=a+5796|0;i=a+5784|0;p=a+5820|0;q=a+5816|0;r=a+8|0;s=a+20|0;t=0;do{u=d[(f[k>>2]|0)+(t<<1)>>1]|0;v=u&65535;w=h[(f[i>>2]|0)+t>>0]|0;t=t+1|0;do if(!(u<<16>>16)){x=j[c+(w<<2)+2>>1]|0;y=f[p>>2]|0;z=j[c+(w<<2)>>1]|0;A=j[q>>1]|0|z<<y;B=A&65535;d[q>>1]=B;if((y|0)>(16-x|0)){C=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[C+D>>0]=A;A=(j[q>>1]|0)>>>8&255;D=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[D+C>>0]=A;A=f[p>>2]|0;C=z>>>(16-A|0)&65535;d[q>>1]=C;E=C;F=x+-16+A|0;G=23;break}else{E=B;F=y+x|0;G=23;break}}else{x=h[510251+w>>0]|0;y=(x|256)+1|0;B=j[c+(y<<2)+2>>1]|0;A=f[p>>2]|0;C=j[c+(y<<2)>>1]|0;y=j[q>>1]|0|C<<A;z=y&65535;d[q>>1]=z;if((A|0)>(16-B|0)){D=f[r>>2]|0;H=f[s>>2]|0;f[s>>2]=H+1;b[D+H>>0]=y;y=(j[q>>1]|0)>>>8&255;H=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[H+D>>0]=y;y=f[p>>2]|0;D=C>>>(16-y|0)&65535;d[q>>1]=D;I=D;J=B+-16+y|0}else{I=z;J=A+B|0}f[p>>2]=J;B=f[177048+(x<<2)>>2]|0;if((x+-8|0)>>>0<20){A=w-(f[177164+(x<<2)>>2]|0)&65535;x=A<<J|I&65535;z=x&65535;d[q>>1]=z;if((J|0)>(16-B|0)){y=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[y+D>>0]=x;x=(j[q>>1]|0)>>>8&255;D=f[r>>2]|0;y=f[s>>2]|0;f[s>>2]=y+1;b[D+y>>0]=x;x=f[p>>2]|0;y=A>>>(16-x|0)&65535;d[q>>1]=y;K=y;L=B+-16+x|0}else{K=z;L=J+B|0}f[p>>2]=L;M=L;N=K}else{M=J;N=I}B=v+-1|0;z=h[509739+(B>>>0<256?B:(B>>>7)+256|0)>>0]|0;x=j[e+(z<<2)+2>>1]|0;y=j[e+(z<<2)>>1]|0;A=N&65535|y<<M;D=A&65535;d[q>>1]=D;if((M|0)>(16-x|0)){C=f[r>>2]|0;H=f[s>>2]|0;f[s>>2]=H+1;b[C+H>>0]=A;A=(j[q>>1]|0)>>>8&255;H=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[H+C>>0]=A;A=f[p>>2]|0;C=y>>>(16-A|0)&65535;d[q>>1]=C;O=x+-16+A|0;P=C}else{O=M+x|0;P=D}f[p>>2]=O;D=f[176928+(z<<2)>>2]|0;if((z+-4|0)>>>0<26){x=B-(f[177280+(z<<2)>>2]|0)&65535;z=x<<O|P&65535;B=z&65535;d[q>>1]=B;if((O|0)>(16-D|0)){C=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[C+A>>0]=z;z=(j[q>>1]|0)>>>8&255;A=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[A+C>>0]=z;z=f[p>>2]|0;C=x>>>(16-z|0)&65535;d[q>>1]=C;E=C;F=D+-16+z|0;G=23;break}else{E=B;F=O+D|0;G=23;break}}else{Q=P;R=O}}while(0);if((G|0)==23){G=0;f[p>>2]=F;Q=E;R=F}}while(t>>>0<(f[g>>2]|0)>>>0);l=q;m=p;n=R;o=Q}Q=j[c+1026>>1]|0;R=j[c+1024>>1]|0;c=o&65535|R<<n;d[l>>1]=c;if((n|0)>(16-Q|0)){o=a+8|0;p=f[o>>2]|0;q=a+20|0;a=f[q>>2]|0;f[q>>2]=a+1;b[p+a>>0]=c;c=(j[l>>1]|0)>>>8&255;a=f[o>>2]|0;o=f[q>>2]|0;f[q>>2]=o+1;b[a+o>>0]=c;c=f[m>>2]|0;d[l>>1]=R>>>(16-c|0);S=Q+-16+c|0;f[m>>2]=S;return}else{S=n+Q|0;f[m>>2]=S;return}}function koc(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;g=d[c+2>>1]|0;h=g<<16>>16==0;i=a+2754|0;k=a+5820|0;l=a+2752|0;m=a+5816|0;n=a+8|0;o=a+20|0;p=a+2758|0;q=a+2756|0;r=a+2750|0;s=a+2748|0;t=0;u=-1;v=g&65535;g=h?138:7;w=h?3:4;a:while(1){h=t;x=0;while(1){if((h|0)>(e|0))break a;h=h+1|0;y=d[c+(h<<2)+2>>1]|0;z=y&65535;A=x+1|0;B=(v|0)==(z|0);if(!((A|0)<(g|0)&B))break;else x=A}if((A|0)<(w|0)){C=a+2684+(v<<2)+2|0;D=a+2684+(v<<2)|0;E=A;F=f[k>>2]|0;G=d[m>>1]|0;while(1){H=j[C>>1]|0;I=j[D>>1]|0;J=G&65535|I<<F;K=J&65535;d[m>>1]=K;if((F|0)>(16-H|0)){L=f[n>>2]|0;M=f[o>>2]|0;f[o>>2]=M+1;b[L+M>>0]=J;J=(j[m>>1]|0)>>>8&255;M=f[n>>2]|0;L=f[o>>2]|0;f[o>>2]=L+1;b[M+L>>0]=J;J=f[k>>2]|0;L=I>>>(16-J|0)&65535;d[m>>1]=L;N=L;O=H+-16+J|0}else{N=K;O=F+H|0}f[k>>2]=O;E=E+-1|0;if(!E)break;else{F=O;G=N}}}else{do if(!v)if((A|0)<11){G=j[i>>1]|0;F=f[k>>2]|0;E=j[l>>1]|0;D=j[m>>1]|0|E<<F;d[m>>1]=D;if((F|0)>(16-G|0)){C=f[n>>2]|0;H=f[o>>2]|0;f[o>>2]=H+1;b[C+H>>0]=D;H=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;K=f[o>>2]|0;f[o>>2]=K+1;b[C+K>>0]=H;H=f[k>>2]|0;K=E>>>(16-H|0);d[m>>1]=K;P=G+-16+H|0;Q=K}else{P=F+G|0;Q=D}f[k>>2]=P;D=x+65534&65535;G=Q&65535|D<<P;d[m>>1]=G;if((P|0)>13){F=f[n>>2]|0;K=f[o>>2]|0;f[o>>2]=K+1;b[F+K>>0]=G;G=(j[m>>1]|0)>>>8&255;K=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[K+F>>0]=G;G=f[k>>2]|0;d[m>>1]=D>>>(16-G|0);R=G+-13|0;break}else{R=P+3|0;break}}else{G=j[p>>1]|0;D=f[k>>2]|0;F=j[q>>1]|0;K=j[m>>1]|0|F<<D;d[m>>1]=K;if((D|0)>(16-G|0)){H=f[n>>2]|0;E=f[o>>2]|0;f[o>>2]=E+1;b[H+E>>0]=K;E=(j[m>>1]|0)>>>8&255;H=f[n>>2]|0;C=f[o>>2]|0;f[o>>2]=C+1;b[H+C>>0]=E;E=f[k>>2]|0;C=F>>>(16-E|0);d[m>>1]=C;S=G+-16+E|0;T=C}else{S=D+G|0;T=K}f[k>>2]=S;K=x+65526&65535;G=T&65535|K<<S;d[m>>1]=G;if((S|0)>9){D=f[n>>2]|0;C=f[o>>2]|0;f[o>>2]=C+1;b[D+C>>0]=G;G=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[C+D>>0]=G;G=f[k>>2]|0;d[m>>1]=K>>>(16-G|0);R=G+-9|0;break}else{R=S+7|0;break}}else{if((v|0)==(u|0)){U=A;V=d[m>>1]|0;W=f[k>>2]|0}else{G=j[a+2684+(v<<2)+2>>1]|0;K=f[k>>2]|0;D=j[a+2684+(v<<2)>>1]|0;C=j[m>>1]|0|D<<K;E=C&65535;d[m>>1]=E;if((K|0)>(16-G|0)){F=f[n>>2]|0;H=f[o>>2]|0;f[o>>2]=H+1;b[F+H>>0]=C;C=(j[m>>1]|0)>>>8&255;H=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[H+F>>0]=C;C=f[k>>2]|0;F=D>>>(16-C|0)&65535;d[m>>1]=F;X=F;Y=G+-16+C|0}else{X=E;Y=K+G|0}f[k>>2]=Y;U=x;V=X;W=Y}G=j[r>>1]|0;K=j[s>>1]|0;E=V&65535|K<<W;d[m>>1]=E;if((W|0)>(16-G|0)){C=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[C+F>>0]=E;F=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[C+D>>0]=F;F=f[k>>2]|0;D=K>>>(16-F|0);d[m>>1]=D;Z=G+-16+F|0;_=D}else{Z=W+G|0;_=E}f[k>>2]=Z;E=U+65533&65535;G=_&65535|E<<Z;d[m>>1]=G;if((Z|0)>14){D=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[D+F>>0]=G;G=(j[m>>1]|0)>>>8&255;F=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[F+D>>0]=G;G=f[k>>2]|0;d[m>>1]=E>>>(16-G|0);R=G+-14|0;break}else{R=Z+2|0;break}}while(0);f[k>>2]=R}x=y<<16>>16==0;G=v;t=h;v=z;g=x?138:B?6:7;w=x|B?3:4;u=G}return}function loc(){moc(0);return}function moc(a){a=a|0;Mf(23792,519284);te(23808,519289,1,1,0);$e(23816,519058,1,-128,127);$e(23832,519063,1,-128,127);$e(23824,519075,1,0,255);$e(23840,519089,2,-32768,32767);$e(23848,519095,2,0,65535);$e(23856,519294,4,-2147483648,2147483647);$e(23864,519298,4,0,-1);$e(23872,519311,4,-2147483648,2147483647);$e(23880,519316,4,0,-1);ag(23888,519340,4);ag(23896,519452,8);Vd(4984,518667);Vd(22112,510526);Tf(22136,4,510559);xe(4272,510572);Ff(4872,0,510588);Ff(22160,0,510618);Ff(4864,1,510655);Ff(4888,2,510694);Ff(4880,3,510725);Ff(4896,4,510765);Ff(22168,5,510794);Ff(22176,4,510832);Ff(22184,5,510862);Ff(22160,0,510901);Ff(4864,1,510933);Ff(4888,2,510966);Ff(4880,3,510999);Ff(4896,4,511033);Ff(22168,5,511066);Ff(4904,6,511100);Ff(4912,7,511131);Ff(22192,7,511163);return}function noc(a){a=a|0;return wqc(f[a+4>>2]|0)|0}function ooc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;b=u;u=u+16|0;c=b;do if(a>>>0<245){d=a>>>0<11?16:a+11&-8;e=d>>>3;g=f[220894]|0;h=g>>>e;if(h&3|0){i=(h&1^1)+e|0;j=883616+(i<<1<<2)|0;k=j+8|0;l=f[k>>2]|0;m=l+8|0;n=f[m>>2]|0;if((j|0)==(n|0))f[220894]=g&~(1<<i);else{f[n+12>>2]=j;f[k>>2]=n}n=i<<3;f[l+4>>2]=n|3;i=l+n+4|0;f[i>>2]=f[i>>2]|1;o=m;u=b;return o|0}m=f[220896]|0;if(d>>>0>m>>>0){if(h|0){i=2<<e;n=h<<e&(i|0-i);i=(n&0-n)+-1|0;n=i>>>12&16;e=i>>>n;i=e>>>5&8;h=e>>>i;e=h>>>2&4;l=h>>>e;h=l>>>1&2;k=l>>>h;l=k>>>1&1;j=(i|n|e|h|l)+(k>>>l)|0;l=883616+(j<<1<<2)|0;k=l+8|0;h=f[k>>2]|0;e=h+8|0;n=f[e>>2]|0;if((l|0)==(n|0)){i=g&~(1<<j);f[220894]=i;p=i}else{f[n+12>>2]=l;f[k>>2]=n;p=g}n=(j<<3)-d|0;f[h+4>>2]=d|3;j=h+d|0;f[j+4>>2]=n|1;f[j+n>>2]=n;if(m|0){h=f[220899]|0;k=m>>>3;l=883616+(k<<1<<2)|0;i=1<<k;if(!(p&i)){f[220894]=p|i;q=l;r=l+8|0}else{i=l+8|0;q=f[i>>2]|0;r=i}f[r>>2]=h;f[q+12>>2]=h;f[h+8>>2]=q;f[h+12>>2]=l}f[220896]=n;f[220899]=j;o=e;u=b;return o|0}e=f[220895]|0;if(e){j=(e&0-e)+-1|0;n=j>>>12&16;l=j>>>n;j=l>>>5&8;h=l>>>j;l=h>>>2&4;i=h>>>l;h=i>>>1&2;k=i>>>h;i=k>>>1&1;s=f[883880+((j|n|l|h|i)+(k>>>i)<<2)>>2]|0;i=(f[s+4>>2]&-8)-d|0;k=f[s+16+(((f[s+16>>2]|0)==0&1)<<2)>>2]|0;if(!k){t=s;v=i}else{h=s;s=i;i=k;while(1){k=(f[i+4>>2]&-8)-d|0;l=k>>>0<s>>>0;n=l?k:s;k=l?i:h;i=f[i+16+(((f[i+16>>2]|0)==0&1)<<2)>>2]|0;if(!i){t=k;v=n;break}else{h=k;s=n}}}s=t+d|0;if(t>>>0<s>>>0){h=f[t+24>>2]|0;i=f[t+12>>2]|0;do if((i|0)==(t|0)){n=t+20|0;k=f[n>>2]|0;if(!k){l=t+16|0;j=f[l>>2]|0;if(!j){w=0;break}else{x=j;y=l}}else{x=k;y=n}while(1){n=x+20|0;k=f[n>>2]|0;if(k|0){x=k;y=n;continue}n=x+16|0;k=f[n>>2]|0;if(!k)break;else{x=k;y=n}}f[y>>2]=0;w=x}else{n=f[t+8>>2]|0;f[n+12>>2]=i;f[i+8>>2]=n;w=i}while(0);do if(h|0){i=f[t+28>>2]|0;n=883880+(i<<2)|0;if((t|0)==(f[n>>2]|0)){f[n>>2]=w;if(!w){f[220895]=e&~(1<<i);break}}else{f[h+16+(((f[h+16>>2]|0)!=(t|0)&1)<<2)>>2]=w;if(!w)break}f[w+24>>2]=h;i=f[t+16>>2]|0;if(i|0){f[w+16>>2]=i;f[i+24>>2]=w}i=f[t+20>>2]|0;if(i|0){f[w+20>>2]=i;f[i+24>>2]=w}}while(0);if(v>>>0<16){h=v+d|0;f[t+4>>2]=h|3;e=t+h+4|0;f[e>>2]=f[e>>2]|1}else{f[t+4>>2]=d|3;f[s+4>>2]=v|1;f[s+v>>2]=v;if(m|0){e=f[220899]|0;h=m>>>3;i=883616+(h<<1<<2)|0;n=1<<h;if(!(g&n)){f[220894]=g|n;z=i;A=i+8|0}else{n=i+8|0;z=f[n>>2]|0;A=n}f[A>>2]=e;f[z+12>>2]=e;f[e+8>>2]=z;f[e+12>>2]=i}f[220896]=v;f[220899]=s}o=t+8|0;u=b;return o|0}else B=d}else B=d}else B=d}else if(a>>>0<=4294967231){i=a+11|0;e=i&-8;n=f[220895]|0;if(n){h=0-e|0;k=i>>>8;if(k)if(e>>>0>16777215)C=31;else{i=(k+1048320|0)>>>16&8;l=k<<i;k=(l+520192|0)>>>16&4;j=l<<k;l=(j+245760|0)>>>16&2;D=14-(k|i|l)+(j<<l>>>15)|0;C=e>>>(D+7|0)&1|D<<1}else C=0;D=f[883880+(C<<2)>>2]|0;a:do if(!D){E=0;F=0;G=h;H=57}else{l=0;j=h;i=D;k=e<<((C|0)==31?0:25-(C>>>1)|0);I=0;while(1){J=(f[i+4>>2]&-8)-e|0;if(J>>>0<j>>>0)if(!J){K=i;L=0;M=i;H=61;break a}else{N=i;O=J}else{N=l;O=j}J=f[i+20>>2]|0;i=f[i+16+(k>>>31<<2)>>2]|0;P=(J|0)==0|(J|0)==(i|0)?I:J;J=(i|0)==0;if(J){E=P;F=N;G=O;H=57;break}else{l=N;j=O;k=k<<((J^1)&1);I=P}}}while(0);if((H|0)==57){if((E|0)==0&(F|0)==0){D=2<<C;h=n&(D|0-D);if(!h){B=e;break}D=(h&0-h)+-1|0;h=D>>>12&16;d=D>>>h;D=d>>>5&8;s=d>>>D;d=s>>>2&4;g=s>>>d;s=g>>>1&2;m=g>>>s;g=m>>>1&1;Q=0;R=f[883880+((D|h|d|s|g)+(m>>>g)<<2)>>2]|0}else{Q=F;R=E}if(!R){S=Q;T=G}else{K=Q;L=G;M=R;H=61}}if((H|0)==61)while(1){H=0;g=(f[M+4>>2]&-8)-e|0;m=g>>>0<L>>>0;s=m?g:L;g=m?M:K;M=f[M+16+(((f[M+16>>2]|0)==0&1)<<2)>>2]|0;if(!M){S=g;T=s;break}else{K=g;L=s;H=61}}if((S|0)!=0?T>>>0<((f[220896]|0)-e|0)>>>0:0){s=S+e|0;if(S>>>0>=s>>>0){o=0;u=b;return o|0}g=f[S+24>>2]|0;m=f[S+12>>2]|0;do if((m|0)==(S|0)){d=S+20|0;h=f[d>>2]|0;if(!h){D=S+16|0;I=f[D>>2]|0;if(!I){U=0;break}else{V=I;W=D}}else{V=h;W=d}while(1){d=V+20|0;h=f[d>>2]|0;if(h|0){V=h;W=d;continue}d=V+16|0;h=f[d>>2]|0;if(!h)break;else{V=h;W=d}}f[W>>2]=0;U=V}else{d=f[S+8>>2]|0;f[d+12>>2]=m;f[m+8>>2]=d;U=m}while(0);do if(g){m=f[S+28>>2]|0;d=883880+(m<<2)|0;if((S|0)==(f[d>>2]|0)){f[d>>2]=U;if(!U){d=n&~(1<<m);f[220895]=d;X=d;break}}else{f[g+16+(((f[g+16>>2]|0)!=(S|0)&1)<<2)>>2]=U;if(!U){X=n;break}}f[U+24>>2]=g;d=f[S+16>>2]|0;if(d|0){f[U+16>>2]=d;f[d+24>>2]=U}d=f[S+20>>2]|0;if(d){f[U+20>>2]=d;f[d+24>>2]=U;X=n}else X=n}else X=n;while(0);do if(T>>>0>=16){f[S+4>>2]=e|3;f[s+4>>2]=T|1;f[s+T>>2]=T;n=T>>>3;if(T>>>0<256){g=883616+(n<<1<<2)|0;d=f[220894]|0;m=1<<n;if(!(d&m)){f[220894]=d|m;Y=g;Z=g+8|0}else{m=g+8|0;Y=f[m>>2]|0;Z=m}f[Z>>2]=s;f[Y+12>>2]=s;f[s+8>>2]=Y;f[s+12>>2]=g;break}g=T>>>8;if(g)if(T>>>0>16777215)_=31;else{m=(g+1048320|0)>>>16&8;d=g<<m;g=(d+520192|0)>>>16&4;n=d<<g;d=(n+245760|0)>>>16&2;h=14-(g|m|d)+(n<<d>>>15)|0;_=T>>>(h+7|0)&1|h<<1}else _=0;h=883880+(_<<2)|0;f[s+28>>2]=_;d=s+16|0;f[d+4>>2]=0;f[d>>2]=0;d=1<<_;if(!(X&d)){f[220895]=X|d;f[h>>2]=s;f[s+24>>2]=h;f[s+12>>2]=s;f[s+8>>2]=s;break}d=T<<((_|0)==31?0:25-(_>>>1)|0);n=f[h>>2]|0;while(1){if((f[n+4>>2]&-8|0)==(T|0)){H=97;break}$=n+16+(d>>>31<<2)|0;h=f[$>>2]|0;if(!h){H=96;break}else{d=d<<1;n=h}}if((H|0)==96){f[$>>2]=s;f[s+24>>2]=n;f[s+12>>2]=s;f[s+8>>2]=s;break}else if((H|0)==97){d=n+8|0;h=f[d>>2]|0;f[h+12>>2]=s;f[d>>2]=s;f[s+8>>2]=h;f[s+12>>2]=n;f[s+24>>2]=0;break}}else{h=T+e|0;f[S+4>>2]=h|3;d=S+h+4|0;f[d>>2]=f[d>>2]|1}while(0);o=S+8|0;u=b;return o|0}else B=e}else B=e}else B=-1;while(0);S=f[220896]|0;if(S>>>0>=B>>>0){T=S-B|0;$=f[220899]|0;if(T>>>0>15){_=$+B|0;f[220899]=_;f[220896]=T;f[_+4>>2]=T|1;f[_+T>>2]=T;f[$+4>>2]=B|3}else{f[220896]=0;f[220899]=0;f[$+4>>2]=S|3;T=$+S+4|0;f[T>>2]=f[T>>2]|1}o=$+8|0;u=b;return o|0}$=f[220897]|0;if($>>>0>B>>>0){T=$-B|0;f[220897]=T;S=f[220900]|0;_=S+B|0;f[220900]=_;f[_+4>>2]=T|1;f[S+4>>2]=B|3;o=S+8|0;u=b;return o|0}if(!(f[221012]|0)){f[221014]=4096;f[221013]=4096;f[221015]=-1;f[221016]=-1;f[221017]=0;f[221005]=0;S=c&-16^1431655768;f[c>>2]=S;f[221012]=S;aa=4096}else aa=f[221014]|0;S=B+48|0;c=B+47|0;T=aa+c|0;_=0-aa|0;aa=T&_;if(aa>>>0<=B>>>0){o=0;u=b;return o|0}X=f[221004]|0;if(X|0?(Y=f[221002]|0,Z=Y+aa|0,Z>>>0<=Y>>>0|Z>>>0>X>>>0):0){o=0;u=b;return o|0}b:do if(!(f[221005]&4)){X=f[220900]|0;c:do if(X){Z=884024;while(1){Y=f[Z>>2]|0;if(Y>>>0<=X>>>0?(ba=Z+4|0,(Y+(f[ba>>2]|0)|0)>>>0>X>>>0):0)break;Y=f[Z+8>>2]|0;if(!Y){H=118;break c}else Z=Y}n=T-$&_;if(n>>>0<2147483647){Y=eJc(n|0)|0;if((Y|0)==((f[Z>>2]|0)+(f[ba>>2]|0)|0))if((Y|0)==(-1|0))ca=n;else{da=n;ea=Y;H=135;break b}else{fa=Y;ga=n;H=126}}else ca=0}else H=118;while(0);do if((H|0)==118){X=eJc(0)|0;if((X|0)!=(-1|0)?(e=X,n=f[221013]|0,Y=n+-1|0,U=((Y&e|0)==0?0:(Y+e&0-n)-e|0)+aa|0,e=f[221002]|0,n=U+e|0,U>>>0>B>>>0&U>>>0<2147483647):0){Y=f[221004]|0;if(Y|0?n>>>0<=e>>>0|n>>>0>Y>>>0:0){ca=0;break}Y=eJc(U|0)|0;if((Y|0)==(X|0)){da=U;ea=X;H=135;break b}else{fa=Y;ga=U;H=126}}else ca=0}while(0);do if((H|0)==126){U=0-ga|0;if(!(S>>>0>ga>>>0&(ga>>>0<2147483647&(fa|0)!=(-1|0))))if((fa|0)==(-1|0)){ca=0;break}else{da=ga;ea=fa;H=135;break b}Y=f[221014]|0;X=c-ga+Y&0-Y;if(X>>>0>=2147483647){da=ga;ea=fa;H=135;break b}if((eJc(X|0)|0)==(-1|0)){eJc(U|0)|0;ca=0;break}else{da=X+ga|0;ea=fa;H=135;break b}}while(0);f[221005]=f[221005]|4;ha=ca;H=133}else{ha=0;H=133}while(0);if(((H|0)==133?aa>>>0<2147483647:0)?(ca=eJc(aa|0)|0,aa=eJc(0)|0,fa=aa-ca|0,ga=fa>>>0>(B+40|0)>>>0,!((ca|0)==(-1|0)|ga^1|ca>>>0<aa>>>0&((ca|0)!=(-1|0)&(aa|0)!=(-1|0))^1)):0){da=ga?fa:ha;ea=ca;H=135}if((H|0)==135){ca=(f[221002]|0)+da|0;f[221002]=ca;if(ca>>>0>(f[221003]|0)>>>0)f[221003]=ca;ca=f[220900]|0;do if(ca){ha=884024;while(1){ia=f[ha>>2]|0;ja=ha+4|0;ka=f[ja>>2]|0;if((ea|0)==(ia+ka|0)){H=145;break}fa=f[ha+8>>2]|0;if(!fa)break;else ha=fa}if(((H|0)==145?(f[ha+12>>2]&8|0)==0:0)?ca>>>0<ea>>>0&ca>>>0>=ia>>>0:0){f[ja>>2]=ka+da;fa=ca+8|0;ga=(fa&7|0)==0?0:0-fa&7;fa=ca+ga|0;aa=(f[220897]|0)+(da-ga)|0;f[220900]=fa;f[220897]=aa;f[fa+4>>2]=aa|1;f[fa+aa+4>>2]=40;f[220901]=f[221016];break}if(ea>>>0<(f[220898]|0)>>>0)f[220898]=ea;aa=ea+da|0;fa=884024;while(1){if((f[fa>>2]|0)==(aa|0)){H=153;break}ga=f[fa+8>>2]|0;if(!ga)break;else fa=ga}if((H|0)==153?(f[fa+12>>2]&8|0)==0:0){f[fa>>2]=ea;ha=fa+4|0;f[ha>>2]=(f[ha>>2]|0)+da;ha=ea+8|0;ga=ea+((ha&7|0)==0?0:0-ha&7)|0;ha=aa+8|0;c=aa+((ha&7|0)==0?0:0-ha&7)|0;ha=ga+B|0;S=c-ga-B|0;f[ga+4>>2]=B|3;do if((c|0)!=(ca|0)){if((c|0)==(f[220899]|0)){ba=(f[220896]|0)+S|0;f[220896]=ba;f[220899]=ha;f[ha+4>>2]=ba|1;f[ha+ba>>2]=ba;break}ba=f[c+4>>2]|0;if((ba&3|0)==1){_=ba&-8;$=ba>>>3;d:do if(ba>>>0<256){T=f[c+8>>2]|0;X=f[c+12>>2]|0;if((X|0)==(T|0)){f[220894]=f[220894]&~(1<<$);break}else{f[T+12>>2]=X;f[X+8>>2]=T;break}}else{T=f[c+24>>2]|0;X=f[c+12>>2]|0;do if((X|0)==(c|0)){U=c+16|0;Y=U+4|0;n=f[Y>>2]|0;if(!n){e=f[U>>2]|0;if(!e){la=0;break}else{ma=e;na=U}}else{ma=n;na=Y}while(1){Y=ma+20|0;n=f[Y>>2]|0;if(n|0){ma=n;na=Y;continue}Y=ma+16|0;n=f[Y>>2]|0;if(!n)break;else{ma=n;na=Y}}f[na>>2]=0;la=ma}else{Y=f[c+8>>2]|0;f[Y+12>>2]=X;f[X+8>>2]=Y;la=X}while(0);if(!T)break;X=f[c+28>>2]|0;Y=883880+(X<<2)|0;do if((c|0)!=(f[Y>>2]|0)){f[T+16+(((f[T+16>>2]|0)!=(c|0)&1)<<2)>>2]=la;if(!la)break d}else{f[Y>>2]=la;if(la|0)break;f[220895]=f[220895]&~(1<<X);break d}while(0);f[la+24>>2]=T;X=c+16|0;Y=f[X>>2]|0;if(Y|0){f[la+16>>2]=Y;f[Y+24>>2]=la}Y=f[X+4>>2]|0;if(!Y)break;f[la+20>>2]=Y;f[Y+24>>2]=la}while(0);oa=c+_|0;pa=_+S|0}else{oa=c;pa=S}$=oa+4|0;f[$>>2]=f[$>>2]&-2;f[ha+4>>2]=pa|1;f[ha+pa>>2]=pa;$=pa>>>3;if(pa>>>0<256){ba=883616+($<<1<<2)|0;Z=f[220894]|0;Y=1<<$;if(!(Z&Y)){f[220894]=Z|Y;qa=ba;ra=ba+8|0}else{Y=ba+8|0;qa=f[Y>>2]|0;ra=Y}f[ra>>2]=ha;f[qa+12>>2]=ha;f[ha+8>>2]=qa;f[ha+12>>2]=ba;break}ba=pa>>>8;do if(!ba)sa=0;else{if(pa>>>0>16777215){sa=31;break}Y=(ba+1048320|0)>>>16&8;Z=ba<<Y;$=(Z+520192|0)>>>16&4;X=Z<<$;Z=(X+245760|0)>>>16&2;n=14-($|Y|Z)+(X<<Z>>>15)|0;sa=pa>>>(n+7|0)&1|n<<1}while(0);ba=883880+(sa<<2)|0;f[ha+28>>2]=sa;_=ha+16|0;f[_+4>>2]=0;f[_>>2]=0;_=f[220895]|0;n=1<<sa;if(!(_&n)){f[220895]=_|n;f[ba>>2]=ha;f[ha+24>>2]=ba;f[ha+12>>2]=ha;f[ha+8>>2]=ha;break}n=pa<<((sa|0)==31?0:25-(sa>>>1)|0);_=f[ba>>2]|0;while(1){if((f[_+4>>2]&-8|0)==(pa|0)){H=194;break}ta=_+16+(n>>>31<<2)|0;ba=f[ta>>2]|0;if(!ba){H=193;break}else{n=n<<1;_=ba}}if((H|0)==193){f[ta>>2]=ha;f[ha+24>>2]=_;f[ha+12>>2]=ha;f[ha+8>>2]=ha;break}else if((H|0)==194){n=_+8|0;ba=f[n>>2]|0;f[ba+12>>2]=ha;f[n>>2]=ha;f[ha+8>>2]=ba;f[ha+12>>2]=_;f[ha+24>>2]=0;break}}else{ba=(f[220897]|0)+S|0;f[220897]=ba;f[220900]=ha;f[ha+4>>2]=ba|1}while(0);o=ga+8|0;u=b;return o|0}ha=884024;while(1){S=f[ha>>2]|0;if(S>>>0<=ca>>>0?(ua=S+(f[ha+4>>2]|0)|0,ua>>>0>ca>>>0):0)break;ha=f[ha+8>>2]|0}ha=ua+-47|0;ga=ha+8|0;S=ha+((ga&7|0)==0?0:0-ga&7)|0;ga=ca+16|0;ha=S>>>0<ga>>>0?ca:S;S=ha+8|0;c=ea+8|0;aa=(c&7|0)==0?0:0-c&7;c=ea+aa|0;fa=da+-40-aa|0;f[220900]=c;f[220897]=fa;f[c+4>>2]=fa|1;f[c+fa+4>>2]=40;f[220901]=f[221016];fa=ha+4|0;f[fa>>2]=27;f[S>>2]=f[221006];f[S+4>>2]=f[221007];f[S+8>>2]=f[221008];f[S+12>>2]=f[221009];f[221006]=ea;f[221007]=da;f[221009]=0;f[221008]=S;S=ha+24|0;do{c=S;S=S+4|0;f[S>>2]=7}while((c+8|0)>>>0<ua>>>0);if((ha|0)!=(ca|0)){S=ha-ca|0;f[fa>>2]=f[fa>>2]&-2;f[ca+4>>2]=S|1;f[ha>>2]=S;c=S>>>3;if(S>>>0<256){aa=883616+(c<<1<<2)|0;ba=f[220894]|0;n=1<<c;if(!(ba&n)){f[220894]=ba|n;va=aa;wa=aa+8|0}else{n=aa+8|0;va=f[n>>2]|0;wa=n}f[wa>>2]=ca;f[va+12>>2]=ca;f[ca+8>>2]=va;f[ca+12>>2]=aa;break}aa=S>>>8;if(aa)if(S>>>0>16777215)xa=31;else{n=(aa+1048320|0)>>>16&8;ba=aa<<n;aa=(ba+520192|0)>>>16&4;c=ba<<aa;ba=(c+245760|0)>>>16&2;Z=14-(aa|n|ba)+(c<<ba>>>15)|0;xa=S>>>(Z+7|0)&1|Z<<1}else xa=0;Z=883880+(xa<<2)|0;f[ca+28>>2]=xa;f[ca+20>>2]=0;f[ga>>2]=0;ba=f[220895]|0;c=1<<xa;if(!(ba&c)){f[220895]=ba|c;f[Z>>2]=ca;f[ca+24>>2]=Z;f[ca+12>>2]=ca;f[ca+8>>2]=ca;break}c=S<<((xa|0)==31?0:25-(xa>>>1)|0);ba=f[Z>>2]|0;while(1){if((f[ba+4>>2]&-8|0)==(S|0)){H=216;break}ya=ba+16+(c>>>31<<2)|0;Z=f[ya>>2]|0;if(!Z){H=215;break}else{c=c<<1;ba=Z}}if((H|0)==215){f[ya>>2]=ca;f[ca+24>>2]=ba;f[ca+12>>2]=ca;f[ca+8>>2]=ca;break}else if((H|0)==216){c=ba+8|0;S=f[c>>2]|0;f[S+12>>2]=ca;f[c>>2]=ca;f[ca+8>>2]=S;f[ca+12>>2]=ba;f[ca+24>>2]=0;break}}}else{S=f[220898]|0;if((S|0)==0|ea>>>0<S>>>0)f[220898]=ea;f[221006]=ea;f[221007]=da;f[221009]=0;f[220903]=f[221012];f[220902]=-1;S=0;do{c=883616+(S<<1<<2)|0;f[c+12>>2]=c;f[c+8>>2]=c;S=S+1|0}while((S|0)!=32);S=ea+8|0;ba=(S&7|0)==0?0:0-S&7;S=ea+ba|0;c=da+-40-ba|0;f[220900]=S;f[220897]=c;f[S+4>>2]=c|1;f[S+c+4>>2]=40;f[220901]=f[221016]}while(0);da=f[220897]|0;if(da>>>0>B>>>0){ea=da-B|0;f[220897]=ea;da=f[220900]|0;ca=da+B|0;f[220900]=ca;f[ca+4>>2]=ea|1;f[da+4>>2]=B|3;o=da+8|0;u=b;return o|0}}da=zoc()|0;f[da>>2]=12;o=0;u=b;return o|0}function poc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;if(!a)return;b=a+-8|0;c=f[220898]|0;d=f[a+-4>>2]|0;a=d&-8;e=b+a|0;do if(!(d&1)){g=f[b>>2]|0;if(!(d&3))return;h=b+(0-g)|0;i=g+a|0;if(h>>>0<c>>>0)return;if((h|0)==(f[220899]|0)){j=e+4|0;k=f[j>>2]|0;if((k&3|0)!=3){l=h;m=i;n=h;break}f[220896]=i;f[j>>2]=k&-2;f[h+4>>2]=i|1;f[h+i>>2]=i;return}k=g>>>3;if(g>>>0<256){g=f[h+8>>2]|0;j=f[h+12>>2]|0;if((j|0)==(g|0)){f[220894]=f[220894]&~(1<<k);l=h;m=i;n=h;break}else{f[g+12>>2]=j;f[j+8>>2]=g;l=h;m=i;n=h;break}}g=f[h+24>>2]|0;j=f[h+12>>2]|0;do if((j|0)==(h|0)){k=h+16|0;o=k+4|0;p=f[o>>2]|0;if(!p){q=f[k>>2]|0;if(!q){r=0;break}else{s=q;t=k}}else{s=p;t=o}while(1){o=s+20|0;p=f[o>>2]|0;if(p|0){s=p;t=o;continue}o=s+16|0;p=f[o>>2]|0;if(!p)break;else{s=p;t=o}}f[t>>2]=0;r=s}else{o=f[h+8>>2]|0;f[o+12>>2]=j;f[j+8>>2]=o;r=j}while(0);if(g){j=f[h+28>>2]|0;o=883880+(j<<2)|0;if((h|0)==(f[o>>2]|0)){f[o>>2]=r;if(!r){f[220895]=f[220895]&~(1<<j);l=h;m=i;n=h;break}}else{f[g+16+(((f[g+16>>2]|0)!=(h|0)&1)<<2)>>2]=r;if(!r){l=h;m=i;n=h;break}}f[r+24>>2]=g;j=h+16|0;o=f[j>>2]|0;if(o|0){f[r+16>>2]=o;f[o+24>>2]=r}o=f[j+4>>2]|0;if(o){f[r+20>>2]=o;f[o+24>>2]=r;l=h;m=i;n=h}else{l=h;m=i;n=h}}else{l=h;m=i;n=h}}else{l=b;m=a;n=b}while(0);if(n>>>0>=e>>>0)return;b=e+4|0;a=f[b>>2]|0;if(!(a&1))return;if(!(a&2)){r=f[220899]|0;if((e|0)==(f[220900]|0)){s=(f[220897]|0)+m|0;f[220897]=s;f[220900]=l;f[l+4>>2]=s|1;if((l|0)!=(r|0))return;f[220899]=0;f[220896]=0;return}if((e|0)==(r|0)){r=(f[220896]|0)+m|0;f[220896]=r;f[220899]=n;f[l+4>>2]=r|1;f[n+r>>2]=r;return}r=(a&-8)+m|0;s=a>>>3;do if(a>>>0<256){t=f[e+8>>2]|0;c=f[e+12>>2]|0;if((c|0)==(t|0)){f[220894]=f[220894]&~(1<<s);break}else{f[t+12>>2]=c;f[c+8>>2]=t;break}}else{t=f[e+24>>2]|0;c=f[e+12>>2]|0;do if((c|0)==(e|0)){d=e+16|0;o=d+4|0;j=f[o>>2]|0;if(!j){p=f[d>>2]|0;if(!p){u=0;break}else{v=p;w=d}}else{v=j;w=o}while(1){o=v+20|0;j=f[o>>2]|0;if(j|0){v=j;w=o;continue}o=v+16|0;j=f[o>>2]|0;if(!j)break;else{v=j;w=o}}f[w>>2]=0;u=v}else{o=f[e+8>>2]|0;f[o+12>>2]=c;f[c+8>>2]=o;u=c}while(0);if(t|0){c=f[e+28>>2]|0;h=883880+(c<<2)|0;if((e|0)==(f[h>>2]|0)){f[h>>2]=u;if(!u){f[220895]=f[220895]&~(1<<c);break}}else{f[t+16+(((f[t+16>>2]|0)!=(e|0)&1)<<2)>>2]=u;if(!u)break}f[u+24>>2]=t;c=e+16|0;h=f[c>>2]|0;if(h|0){f[u+16>>2]=h;f[h+24>>2]=u}h=f[c+4>>2]|0;if(h|0){f[u+20>>2]=h;f[h+24>>2]=u}}}while(0);f[l+4>>2]=r|1;f[n+r>>2]=r;if((l|0)==(f[220899]|0)){f[220896]=r;return}else x=r}else{f[b>>2]=a&-2;f[l+4>>2]=m|1;f[n+m>>2]=m;x=m}m=x>>>3;if(x>>>0<256){n=883616+(m<<1<<2)|0;a=f[220894]|0;b=1<<m;if(!(a&b)){f[220894]=a|b;y=n;z=n+8|0}else{b=n+8|0;y=f[b>>2]|0;z=b}f[z>>2]=l;f[y+12>>2]=l;f[l+8>>2]=y;f[l+12>>2]=n;return}n=x>>>8;if(n)if(x>>>0>16777215)A=31;else{y=(n+1048320|0)>>>16&8;z=n<<y;n=(z+520192|0)>>>16&4;b=z<<n;z=(b+245760|0)>>>16&2;a=14-(n|y|z)+(b<<z>>>15)|0;A=x>>>(a+7|0)&1|a<<1}else A=0;a=883880+(A<<2)|0;f[l+28>>2]=A;f[l+20>>2]=0;f[l+16>>2]=0;z=f[220895]|0;b=1<<A;do if(z&b){y=x<<((A|0)==31?0:25-(A>>>1)|0);n=f[a>>2]|0;while(1){if((f[n+4>>2]&-8|0)==(x|0)){B=73;break}C=n+16+(y>>>31<<2)|0;m=f[C>>2]|0;if(!m){B=72;break}else{y=y<<1;n=m}}if((B|0)==72){f[C>>2]=l;f[l+24>>2]=n;f[l+12>>2]=l;f[l+8>>2]=l;break}else if((B|0)==73){y=n+8|0;t=f[y>>2]|0;f[t+12>>2]=l;f[y>>2]=l;f[l+8>>2]=t;f[l+12>>2]=n;f[l+24>>2]=0;break}}else{f[220895]=z|b;f[a>>2]=l;f[l+24>>2]=a;f[l+12>>2]=l;f[l+8>>2]=l}while(0);l=(f[220902]|0)+-1|0;f[220902]=l;if(!l)D=884032;else return;while(1){l=f[D>>2]|0;if(!l)break;else D=l+8|0}f[220902]=-1;return}function qoc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if(!a){c=ooc(b)|0;return c|0}if(b>>>0>4294967231){d=zoc()|0;f[d>>2]=12;c=0;return c|0}d=roc(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(d|0){c=d+8|0;return c|0}d=ooc(b)|0;if(!d){c=0;return c|0}e=f[a+-4>>2]|0;g=(e&-8)-((e&3|0)==0?8:4)|0;dJc(d|0,a|0,(g>>>0<b>>>0?g:b)|0)|0;poc(a);c=d;return c|0}function roc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=d&-8;g=a+e|0;if(!(d&3)){if(b>>>0<256){h=0;return h|0}if(e>>>0>=(b+4|0)>>>0?(e-b|0)>>>0<=f[221014]<<1>>>0:0){h=a;return h|0}h=0;return h|0}if(e>>>0>=b>>>0){i=e-b|0;if(i>>>0<=15){h=a;return h|0}j=a+b|0;f[c>>2]=d&1|b|2;f[j+4>>2]=i|3;k=j+i+4|0;f[k>>2]=f[k>>2]|1;soc(j,i);h=a;return h|0}if((g|0)==(f[220900]|0)){i=(f[220897]|0)+e|0;j=i-b|0;k=a+b|0;if(i>>>0<=b>>>0){h=0;return h|0}f[c>>2]=d&1|b|2;f[k+4>>2]=j|1;f[220900]=k;f[220897]=j;h=a;return h|0}if((g|0)==(f[220899]|0)){j=(f[220896]|0)+e|0;if(j>>>0<b>>>0){h=0;return h|0}k=j-b|0;i=d&1;if(k>>>0>15){l=a+b|0;m=l+k|0;f[c>>2]=i|b|2;f[l+4>>2]=k|1;f[m>>2]=k;n=m+4|0;f[n>>2]=f[n>>2]&-2;o=l;p=k}else{f[c>>2]=i|j|2;i=a+j+4|0;f[i>>2]=f[i>>2]|1;o=0;p=0}f[220896]=p;f[220899]=o;h=a;return h|0}o=f[g+4>>2]|0;if(o&2|0){h=0;return h|0}p=(o&-8)+e|0;if(p>>>0<b>>>0){h=0;return h|0}e=p-b|0;i=o>>>3;do if(o>>>0<256){j=f[g+8>>2]|0;k=f[g+12>>2]|0;if((k|0)==(j|0)){f[220894]=f[220894]&~(1<<i);break}else{f[j+12>>2]=k;f[k+8>>2]=j;break}}else{j=f[g+24>>2]|0;k=f[g+12>>2]|0;do if((k|0)==(g|0)){l=g+16|0;n=l+4|0;m=f[n>>2]|0;if(!m){q=f[l>>2]|0;if(!q){r=0;break}else{s=q;t=l}}else{s=m;t=n}while(1){n=s+20|0;m=f[n>>2]|0;if(m|0){s=m;t=n;continue}n=s+16|0;m=f[n>>2]|0;if(!m)break;else{s=m;t=n}}f[t>>2]=0;r=s}else{n=f[g+8>>2]|0;f[n+12>>2]=k;f[k+8>>2]=n;r=k}while(0);if(j|0){k=f[g+28>>2]|0;n=883880+(k<<2)|0;if((g|0)==(f[n>>2]|0)){f[n>>2]=r;if(!r){f[220895]=f[220895]&~(1<<k);break}}else{f[j+16+(((f[j+16>>2]|0)!=(g|0)&1)<<2)>>2]=r;if(!r)break}f[r+24>>2]=j;k=g+16|0;n=f[k>>2]|0;if(n|0){f[r+16>>2]=n;f[n+24>>2]=r}n=f[k+4>>2]|0;if(n|0){f[r+20>>2]=n;f[n+24>>2]=r}}}while(0);r=d&1;if(e>>>0<16){f[c>>2]=p|r|2;d=a+p+4|0;f[d>>2]=f[d>>2]|1;h=a;return h|0}else{d=a+b|0;f[c>>2]=r|b|2;f[d+4>>2]=e|3;b=d+e+4|0;f[b>>2]=f[b>>2]|1;soc(d,e);h=a;return h|0}return 0}function soc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+b|0;d=f[a+4>>2]|0;do if(!(d&1)){e=f[a>>2]|0;if(!(d&3))return;g=a+(0-e)|0;h=e+b|0;if((g|0)==(f[220899]|0)){i=c+4|0;j=f[i>>2]|0;if((j&3|0)!=3){k=g;l=h;break}f[220896]=h;f[i>>2]=j&-2;f[g+4>>2]=h|1;f[g+h>>2]=h;return}j=e>>>3;if(e>>>0<256){e=f[g+8>>2]|0;i=f[g+12>>2]|0;if((i|0)==(e|0)){f[220894]=f[220894]&~(1<<j);k=g;l=h;break}else{f[e+12>>2]=i;f[i+8>>2]=e;k=g;l=h;break}}e=f[g+24>>2]|0;i=f[g+12>>2]|0;do if((i|0)==(g|0)){j=g+16|0;m=j+4|0;n=f[m>>2]|0;if(!n){o=f[j>>2]|0;if(!o){p=0;break}else{q=o;r=j}}else{q=n;r=m}while(1){m=q+20|0;n=f[m>>2]|0;if(n|0){q=n;r=m;continue}m=q+16|0;n=f[m>>2]|0;if(!n)break;else{q=n;r=m}}f[r>>2]=0;p=q}else{m=f[g+8>>2]|0;f[m+12>>2]=i;f[i+8>>2]=m;p=i}while(0);if(e){i=f[g+28>>2]|0;m=883880+(i<<2)|0;if((g|0)==(f[m>>2]|0)){f[m>>2]=p;if(!p){f[220895]=f[220895]&~(1<<i);k=g;l=h;break}}else{f[e+16+(((f[e+16>>2]|0)!=(g|0)&1)<<2)>>2]=p;if(!p){k=g;l=h;break}}f[p+24>>2]=e;i=g+16|0;m=f[i>>2]|0;if(m|0){f[p+16>>2]=m;f[m+24>>2]=p}m=f[i+4>>2]|0;if(m){f[p+20>>2]=m;f[m+24>>2]=p;k=g;l=h}else{k=g;l=h}}else{k=g;l=h}}else{k=a;l=b}while(0);b=c+4|0;a=f[b>>2]|0;if(!(a&2)){p=f[220899]|0;if((c|0)==(f[220900]|0)){q=(f[220897]|0)+l|0;f[220897]=q;f[220900]=k;f[k+4>>2]=q|1;if((k|0)!=(p|0))return;f[220899]=0;f[220896]=0;return}if((c|0)==(p|0)){p=(f[220896]|0)+l|0;f[220896]=p;f[220899]=k;f[k+4>>2]=p|1;f[k+p>>2]=p;return}p=(a&-8)+l|0;q=a>>>3;do if(a>>>0<256){r=f[c+8>>2]|0;d=f[c+12>>2]|0;if((d|0)==(r|0)){f[220894]=f[220894]&~(1<<q);break}else{f[r+12>>2]=d;f[d+8>>2]=r;break}}else{r=f[c+24>>2]|0;d=f[c+12>>2]|0;do if((d|0)==(c|0)){m=c+16|0;i=m+4|0;n=f[i>>2]|0;if(!n){j=f[m>>2]|0;if(!j){s=0;break}else{t=j;u=m}}else{t=n;u=i}while(1){i=t+20|0;n=f[i>>2]|0;if(n|0){t=n;u=i;continue}i=t+16|0;n=f[i>>2]|0;if(!n)break;else{t=n;u=i}}f[u>>2]=0;s=t}else{i=f[c+8>>2]|0;f[i+12>>2]=d;f[d+8>>2]=i;s=d}while(0);if(r|0){d=f[c+28>>2]|0;h=883880+(d<<2)|0;if((c|0)==(f[h>>2]|0)){f[h>>2]=s;if(!s){f[220895]=f[220895]&~(1<<d);break}}else{f[r+16+(((f[r+16>>2]|0)!=(c|0)&1)<<2)>>2]=s;if(!s)break}f[s+24>>2]=r;d=c+16|0;h=f[d>>2]|0;if(h|0){f[s+16>>2]=h;f[h+24>>2]=s}h=f[d+4>>2]|0;if(h|0){f[s+20>>2]=h;f[h+24>>2]=s}}}while(0);f[k+4>>2]=p|1;f[k+p>>2]=p;if((k|0)==(f[220899]|0)){f[220896]=p;return}else v=p}else{f[b>>2]=a&-2;f[k+4>>2]=l|1;f[k+l>>2]=l;v=l}l=v>>>3;if(v>>>0<256){a=883616+(l<<1<<2)|0;b=f[220894]|0;p=1<<l;if(!(b&p)){f[220894]=b|p;w=a;x=a+8|0}else{p=a+8|0;w=f[p>>2]|0;x=p}f[x>>2]=k;f[w+12>>2]=k;f[k+8>>2]=w;f[k+12>>2]=a;return}a=v>>>8;if(a)if(v>>>0>16777215)y=31;else{w=(a+1048320|0)>>>16&8;x=a<<w;a=(x+520192|0)>>>16&4;p=x<<a;x=(p+245760|0)>>>16&2;b=14-(a|w|x)+(p<<x>>>15)|0;y=v>>>(b+7|0)&1|b<<1}else y=0;b=883880+(y<<2)|0;f[k+28>>2]=y;f[k+20>>2]=0;f[k+16>>2]=0;x=f[220895]|0;p=1<<y;if(!(x&p)){f[220895]=x|p;f[b>>2]=k;f[k+24>>2]=b;f[k+12>>2]=k;f[k+8>>2]=k;return}p=v<<((y|0)==31?0:25-(y>>>1)|0);y=f[b>>2]|0;while(1){if((f[y+4>>2]&-8|0)==(v|0)){z=69;break}A=y+16+(p>>>31<<2)|0;b=f[A>>2]|0;if(!b){z=68;break}else{p=p<<1;y=b}}if((z|0)==68){f[A>>2]=k;f[k+24>>2]=y;f[k+12>>2]=k;f[k+8>>2]=k;return}else if((z|0)==69){z=y+8|0;A=f[z>>2]|0;f[A+12>>2]=k;f[z>>2]=k;f[k+8>>2]=A;f[k+12>>2]=y;f[k+24>>2]=0;return}}function toc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a>>>0>16?a:16;if(!(c+-1&c))d=c;else{a=16;while(1)if(a>>>0<c>>>0)a=a<<1;else{d=a;break}}if((-64-d|0)>>>0<=b>>>0){a=zoc()|0;f[a>>2]=12;e=0;return e|0}a=b>>>0<11?16:b+11&-8;b=ooc(a+12+d|0)|0;if(!b){e=0;return e|0}c=b+-8|0;do if(b&d+-1){g=(b+d+-1&0-d)+-8|0;h=c;i=(g-h|0)>>>0>15?g:g+d|0;g=i-h|0;h=b+-4|0;j=f[h>>2]|0;k=(j&-8)-g|0;if(!(j&3)){f[i>>2]=(f[c>>2]|0)+g;f[i+4>>2]=k;l=i;m=i;break}else{j=i+4|0;f[j>>2]=k|f[j>>2]&1|2;n=i+k+4|0;f[n>>2]=f[n>>2]|1;f[h>>2]=g|f[h>>2]&1|2;f[j>>2]=f[j>>2]|1;soc(c,g);l=i;m=i;break}}else{l=c;m=c}while(0);c=l+4|0;l=f[c>>2]|0;if(l&3|0?(b=l&-8,b>>>0>(a+16|0)>>>0):0){d=b-a|0;b=m+a|0;f[c>>2]=a|l&1|2;f[b+4>>2]=d|3;l=b+d+4|0;f[l>>2]=f[l>>2]|1;soc(b,d)}e=m+8|0;return e|0}function uoc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;do if((b|0)!=8){d=b>>>2;if((b&3|0)!=0|(d|0)==0){e=22;return e|0}if(d+1073741823&d|0){e=22;return e|0}if((-64-b|0)>>>0<c>>>0){e=12;return e|0}else{g=toc(b>>>0>16?b:16,c)|0;break}}else g=ooc(c)|0;while(0);if(!g){e=12;return e|0}f[a>>2]=g;e=0;return e|0}function voc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=Coc(f[a+60>>2]|0)|0;f[c>>2]=d;d=yoc(Ne(6,c|0)|0)|0;u=b;return d|0}function woc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;i=a+28|0;j=f[i>>2]|0;f[h>>2]=j;k=a+20|0;l=(f[k>>2]|0)-j|0;f[h+4>>2]=l;f[h+8>>2]=b;f[h+12>>2]=c;b=l+c|0;l=a+60|0;f[g>>2]=f[l>>2];f[g+4>>2]=h;f[g+8>>2]=2;j=yoc(je(146,g|0)|0)|0;a:do if((b|0)!=(j|0)){g=2;m=b;n=h;o=j;while(1){if((o|0)<0)break;m=m-o|0;p=f[n+4>>2]|0;q=o>>>0>p>>>0;r=q?n+8|0:n;s=(q<<31>>31)+g|0;t=o-(q?p:0)|0;f[r>>2]=(f[r>>2]|0)+t;p=r+4|0;f[p>>2]=(f[p>>2]|0)-t;f[e>>2]=f[l>>2];f[e+4>>2]=r;f[e+8>>2]=s;o=yoc(je(146,e|0)|0)|0;if((m|0)==(o|0)){v=3;break a}else{g=s;n=r}}f[a+16>>2]=0;f[i>>2]=0;f[k>>2]=0;f[a>>2]=f[a>>2]|32;if((g|0)==2)w=0;else w=c-(f[n+4>>2]|0)|0}else v=3;while(0);if((v|0)==3){v=f[a+44>>2]|0;f[a+16>>2]=v+(f[a+48>>2]|0);f[i>>2]=v;f[k>>2]=v;w=c}u=d;return w|0}function xoc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d;g=d+20|0;f[e>>2]=f[a+60>>2];f[e+4>>2]=0;f[e+8>>2]=b;f[e+12>>2]=g;f[e+16>>2]=c;if((yoc(ge(140,e|0)|0)|0)<0){f[g>>2]=-1;h=-1}else h=f[g>>2]|0;u=d;return h|0}function yoc(a){a=a|0;var b=0,c=0;if(a>>>0>4294963200){b=zoc()|0;f[b>>2]=0-a;c=-1}else c=a;return c|0}function zoc(){return (Aoc()|0)+64|0}function Aoc(){return Boc()|0}function Boc(){return 177528}function Coc(a){a=a|0;return a|0}function Doc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;h=e+16|0;f[h>>2]=c;i=h+4|0;j=a+48|0;k=f[j>>2]|0;f[i>>2]=d-((k|0)!=0&1);l=a+44|0;f[h+8>>2]=f[l>>2];f[h+12>>2]=k;f[g>>2]=f[a+60>>2];f[g+4>>2]=h;f[g+8>>2]=2;h=yoc(ie(145,g|0)|0)|0;if((h|0)>=1){g=f[i>>2]|0;if(h>>>0>g>>>0){i=f[l>>2]|0;l=a+4|0;f[l>>2]=i;f[a+8>>2]=i+(h-g);if(!(f[j>>2]|0))m=d;else{f[l>>2]=i+1;b[c+(d+-1)>>0]=b[i>>0]|0;m=d}}else m=h}else{f[a>>2]=f[a>>2]|h&48^16;m=h}u=e;return m|0}function Eoc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;f[a+36>>2]=223;if((f[a>>2]&64|0)==0?(f[g>>2]=f[a+60>>2],f[g+4>>2]=21523,f[g+8>>2]=e+16,Xe(54,g|0)|0):0)b[a+75>>0]=-1;g=woc(a,c,d)|0;u=e;return g|0}function Foc(){return 884072}function Goc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=Coc(a)|0;f[c>>2]=d;d=Ne(6,c|0)|0;c=yoc((d|0)==-4?0:d)|0;u=b;return c|0}function Hoc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;if(!(b&4194368))i=0;else{f[h>>2]=c;c=(f[h>>2]|0)+(4-1)&~(4-1);j=f[c>>2]|0;f[h>>2]=c+4;i=j}f[g>>2]=a;f[g+4>>2]=b|32768;f[g+8>>2]=i;i=Oe(5,g|0)|0;if(!((b&524288|0)==0|(i|0)<0)){f[e>>2]=i;f[e+4>>2]=2;f[e+8>>2]=1;Bd(221,e|0)|0}e=yoc(i)|0;u=d;return e|0}function Ioc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=b[a>>0]|0;e=b[c>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=e<<24>>24){f=e;g=d}else{d=c;c=a;do{c=c+1|0;d=d+1|0;a=b[c>>0]|0;e=b[d>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=e<<24>>24));f=e;g=a}return (g&255)-(f&255)|0}function Joc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d;g=d+20|0;f[e>>2]=a;f[e+4>>2]=0;f[e+8>>2]=b;f[e+12>>2]=g;f[e+16>>2]=c;c=(yoc(ge(140,e|0)|0)|0)!=0;u=d;return (c?-1:f[g>>2]|0)|0}function Koc(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(Loc(a)|0)==0;c=(f[a>>2]|0)>>>4&1;if(b)d=c;else d=c}else d=(f[a>>2]|0)>>>4&1;return d|0}function Loc(a){a=a|0;return 0}function Moc(a){a=a|0;return}function Noc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if((f[a+76>>2]|0)>=0?(Loc(a)|0)!=0:0){b=a+4|0;c=f[b>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[b>>2]=c+1;d=h[c>>0]|0}else d=Ooc(a)|0;e=d}else g=3;do if((g|0)==3){d=a+4|0;c=f[d>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[d>>2]=c+1;e=h[c>>0]|0;break}else{e=Ooc(a)|0;break}}while(0);return e|0}function Ooc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if((Poc(a)|0)==0?(hj[f[a+32>>2]&511](a,c,1)|0)==1:0)d=h[c>>0]|0;else d=-1;u=b;return d|0}function Poc(a){a=a|0;var c=0,d=0,e=0;c=a+74|0;d=b[c>>0]|0;b[c>>0]=d+255|d;d=a+20|0;c=a+28|0;if((f[d>>2]|0)>>>0>(f[c>>2]|0)>>>0)hj[f[a+36>>2]&511](a,0,0)|0;f[a+16>>2]=0;f[c>>2]=0;f[d>>2]=0;d=f[a>>2]|0;if(!(d&4)){c=(f[a+44>>2]|0)+(f[a+48>>2]|0)|0;f[a+8>>2]=c;f[a+4>>2]=c;e=d<<27>>31}else{f[a>>2]=d|32;e=-1}return e|0}function Qoc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+224|0;g=e+120|0;h=e+80|0;i=e;j=e+136|0;k=h;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[g>>2]=f[d>>2];if((Roc(0,c,g,i,h)|0)<0)m=-1;else{if((f[a+76>>2]|0)>-1)n=Loc(a)|0;else n=0;d=f[a>>2]|0;k=d&32;if((b[a+74>>0]|0)<1)f[a>>2]=d&-33;d=a+48|0;if(!(f[d>>2]|0)){l=a+44|0;o=f[l>>2]|0;f[l>>2]=j;p=a+28|0;f[p>>2]=j;q=a+20|0;f[q>>2]=j;f[d>>2]=80;r=a+16|0;f[r>>2]=j+80;j=Roc(a,c,g,i,h)|0;if(!o)s=j;else{hj[f[a+36>>2]&511](a,0,0)|0;t=(f[q>>2]|0)==0?-1:j;f[l>>2]=o;f[d>>2]=0;f[r>>2]=0;f[p>>2]=0;f[q>>2]=0;s=t}}else s=Roc(a,c,g,i,h)|0;h=f[a>>2]|0;f[a>>2]=h|k;if(n|0)Moc(a);m=(h&32|0)==0?s:-1}u=e;return m|0}function Roc(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;i=u;u=u+64|0;j=i+16|0;k=i;l=i+24|0;m=i+8|0;n=i+20|0;f[j>>2]=c;o=(a|0)!=0;q=l+40|0;r=q;s=l+39|0;l=m+4|0;t=0;v=0;w=0;x=c;a:while(1){do if((v|0)>-1)if((t|0)>(2147483647-v|0)){c=zoc()|0;f[c>>2]=75;y=-1;break}else{y=t+v|0;break}else y=v;while(0);c=b[x>>0]|0;if(!(c<<24>>24)){z=87;break}else{A=c;B=x}b:while(1){switch(A<<24>>24){case 37:{C=B;D=B;z=9;break b;break}case 0:{E=B;F=B;break b;break}default:{}}c=B+1|0;f[j>>2]=c;A=b[c>>0]|0;B=c}c:do if((z|0)==9)while(1){z=0;if((b[D+1>>0]|0)!=37){E=C;F=D;break c}c=C+1|0;G=D+2|0;f[j>>2]=G;if((b[G>>0]|0)==37){C=c;D=G;z=9}else{E=c;F=G;break}}while(0);G=E-x|0;if(o)Soc(a,x,G);if(G|0){t=G;v=y;x=F;continue}G=F+1|0;c=(b[G>>0]|0)+-48|0;if(c>>>0<10){H=(b[F+2>>0]|0)==36;I=H?c:-1;K=H?1:w;L=H?F+3|0:G}else{I=-1;K=w;L=G}f[j>>2]=L;G=b[L>>0]|0;H=(G<<24>>24)+-32|0;d:do if(H>>>0<32){c=0;M=G;N=H;O=L;while(1){P=1<<N;if(!(P&75913)){Q=c;R=M;S=O;break d}T=P|c;P=O+1|0;f[j>>2]=P;U=b[P>>0]|0;N=(U<<24>>24)+-32|0;if(N>>>0>=32){Q=T;R=U;S=P;break}else{c=T;M=U;O=P}}}else{Q=0;R=G;S=L}while(0);if(R<<24>>24==42){G=S+1|0;H=(b[G>>0]|0)+-48|0;if(H>>>0<10?(b[S+2>>0]|0)==36:0){f[h+(H<<2)>>2]=10;V=f[g+((b[G>>0]|0)+-48<<3)>>2]|0;W=1;X=S+3|0}else{if(K|0){Y=-1;break}if(o){H=(f[e>>2]|0)+(4-1)&~(4-1);O=f[H>>2]|0;f[e>>2]=H+4;V=O;W=0;X=G}else{V=0;W=0;X=G}}f[j>>2]=X;G=(V|0)<0;Z=G?0-V|0:V;_=G?Q|8192:Q;$=W;aa=X}else{G=Toc(j)|0;if((G|0)<0){Y=-1;break}Z=G;_=Q;$=K;aa=f[j>>2]|0}do if((b[aa>>0]|0)==46){if((b[aa+1>>0]|0)!=42){f[j>>2]=aa+1;G=Toc(j)|0;ba=G;ca=f[j>>2]|0;break}G=aa+2|0;O=(b[G>>0]|0)+-48|0;if(O>>>0<10?(b[aa+3>>0]|0)==36:0){f[h+(O<<2)>>2]=10;O=f[g+((b[G>>0]|0)+-48<<3)>>2]|0;H=aa+4|0;f[j>>2]=H;ba=O;ca=H;break}if($|0){Y=-1;break a}if(o){H=(f[e>>2]|0)+(4-1)&~(4-1);O=f[H>>2]|0;f[e>>2]=H+4;da=O}else da=0;f[j>>2]=G;ba=da;ca=G}else{ba=-1;ca=aa}while(0);G=0;O=ca;while(1){if(((b[O>>0]|0)+-65|0)>>>0>57){Y=-1;break a}ea=O+1|0;f[j>>2]=ea;fa=b[(b[O>>0]|0)+-65+(511481+(G*58|0))>>0]|0;ga=fa&255;if((ga+-1|0)>>>0<8){G=ga;O=ea}else break}if(!(fa<<24>>24)){Y=-1;break}H=(I|0)>-1;do if(fa<<24>>24==19)if(H){Y=-1;break a}else z=49;else{if(H){f[h+(I<<2)>>2]=ga;M=g+(I<<3)|0;c=f[M+4>>2]|0;N=k;f[N>>2]=f[M>>2];f[N+4>>2]=c;z=49;break}if(!o){Y=0;break a}Uoc(k,ga,e)}while(0);if((z|0)==49?(z=0,!o):0){t=0;v=y;w=$;x=ea;continue}H=b[O>>0]|0;c=(G|0)!=0&(H&15|0)==3?H&-33:H;H=_&-65537;N=(_&8192|0)==0?_:H;e:do switch(c|0){case 110:{switch((G&255)<<24>>24){case 0:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 1:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 2:{M=f[k>>2]|0;f[M>>2]=y;f[M+4>>2]=((y|0)<0)<<31>>31;t=0;v=y;w=$;x=ea;continue a;break}case 3:{d[f[k>>2]>>1]=y;t=0;v=y;w=$;x=ea;continue a;break}case 4:{b[f[k>>2]>>0]=y;t=0;v=y;w=$;x=ea;continue a;break}case 6:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 7:{M=f[k>>2]|0;f[M>>2]=y;f[M+4>>2]=((y|0)<0)<<31>>31;t=0;v=y;w=$;x=ea;continue a;break}default:{t=0;v=y;w=$;x=ea;continue a}}break}case 112:{ha=120;ia=ba>>>0>8?ba:8;ja=N|8;z=61;break}case 88:case 120:{ha=c;ia=ba;ja=N;z=61;break}case 111:{M=k;P=f[M>>2]|0;U=f[M+4>>2]|0;M=Woc(P,U,q)|0;T=r-M|0;ka=M;la=0;ma=511945;na=(N&8|0)==0|(ba|0)>(T|0)?ba:T+1|0;oa=N;pa=P;qa=U;z=67;break}case 105:case 100:{U=k;P=f[U>>2]|0;T=f[U+4>>2]|0;if((T|0)<0){U=TIc(0,0,P|0,T|0)|0;M=J;ra=k;f[ra>>2]=U;f[ra+4>>2]=M;sa=1;ta=511945;ua=U;va=M;z=66;break e}else{sa=(N&2049|0)!=0&1;ta=(N&2048|0)==0?((N&1|0)==0?511945:511947):511946;ua=P;va=T;z=66;break e}break}case 117:{T=k;sa=0;ta=511945;ua=f[T>>2]|0;va=f[T+4>>2]|0;z=66;break}case 99:{b[s>>0]=f[k>>2];wa=s;xa=0;ya=511945;za=q;Aa=1;Ba=H;break}case 109:{T=zoc()|0;Ca=Yoc(f[T>>2]|0)|0;z=71;break}case 115:{T=f[k>>2]|0;Ca=T|0?T:511955;z=71;break}case 67:{f[m>>2]=f[k>>2];f[l>>2]=0;f[k>>2]=m;Da=-1;Ea=m;z=75;break}case 83:{T=f[k>>2]|0;if(!ba){_oc(a,32,Z,0,N);Fa=0;z=84}else{Da=ba;Ea=T;z=75}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{t=apc(a,+p[k>>3],Z,ba,N,c)|0;v=y;w=$;x=ea;continue a;break}default:{wa=x;xa=0;ya=511945;za=q;Aa=ba;Ba=N}}while(0);f:do if((z|0)==61){z=0;c=k;G=f[c>>2]|0;O=f[c+4>>2]|0;c=Voc(G,O,q,ha&32)|0;T=(ja&8|0)==0|(G|0)==0&(O|0)==0;ka=c;la=T?0:2;ma=T?511945:511945+(ha>>4)|0;na=ia;oa=ja;pa=G;qa=O;z=67}else if((z|0)==66){z=0;ka=Xoc(ua,va,q)|0;la=sa;ma=ta;na=ba;oa=N;pa=ua;qa=va;z=67}else if((z|0)==71){z=0;O=Zoc(Ca,0,ba)|0;G=(O|0)==0;wa=Ca;xa=0;ya=511945;za=G?Ca+ba|0:O;Aa=G?ba:O-Ca|0;Ba=H}else if((z|0)==75){z=0;O=Ea;G=0;T=0;while(1){c=f[O>>2]|0;if(!c){Ga=G;Ha=T;break}P=$oc(n,c)|0;if((P|0)<0|P>>>0>(Da-G|0)>>>0){Ga=G;Ha=P;break}c=P+G|0;if(Da>>>0>c>>>0){O=O+4|0;G=c;T=P}else{Ga=c;Ha=P;break}}if((Ha|0)<0){Y=-1;break a}_oc(a,32,Z,Ga,N);if(!Ga){Fa=0;z=84}else{T=Ea;G=0;while(1){O=f[T>>2]|0;if(!O){Fa=Ga;z=84;break f}P=$oc(n,O)|0;G=P+G|0;if((G|0)>(Ga|0)){Fa=Ga;z=84;break f}Soc(a,n,P);if(G>>>0>=Ga>>>0){Fa=Ga;z=84;break}else T=T+4|0}}}while(0);if((z|0)==67){z=0;H=(pa|0)!=0|(qa|0)!=0;T=(na|0)!=0|H;G=((H^1)&1)+(r-ka)|0;wa=T?ka:q;xa=la;ya=ma;za=q;Aa=T?((na|0)>(G|0)?na:G):na;Ba=(na|0)>-1?oa&-65537:oa}else if((z|0)==84){z=0;_oc(a,32,Z,Fa,N^8192);t=(Z|0)>(Fa|0)?Z:Fa;v=y;w=$;x=ea;continue}G=za-wa|0;T=(Aa|0)<(G|0)?G:Aa;H=T+xa|0;P=(Z|0)<(H|0)?H:Z;_oc(a,32,P,H,Ba);Soc(a,ya,xa);_oc(a,48,P,H,Ba^65536);_oc(a,48,T,G,0);Soc(a,wa,G);_oc(a,32,P,H,Ba^8192);t=P;v=y;w=$;x=ea}g:do if((z|0)==87)if(!a)if(!w)Y=0;else{ea=1;while(1){x=f[h+(ea<<2)>>2]|0;if(!x){Ia=ea;break}Uoc(g+(ea<<3)|0,x,e);ea=ea+1|0;if((ea|0)>=10){Y=1;break g}}while(1){if(f[h+(Ia<<2)>>2]|0){Y=-1;break g}Ia=Ia+1|0;if((Ia|0)>=10){Y=1;break}}}else Y=y;while(0);u=i;return Y|0}function Soc(a,b,c){a=a|0;b=b|0;c=c|0;if(!(f[a>>2]&32))mpc(b,c,a)|0;return}function Toc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=(b[c>>0]|0)+-48|0;if(d>>>0<10){e=0;g=c;c=d;while(1){d=c+(e*10|0)|0;g=g+1|0;f[a>>2]=g;c=(b[g>>0]|0)+-48|0;if(c>>>0>=10){h=d;break}else e=d}}else h=0;return h|0}function Uoc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{d=(f[c>>2]|0)+(4-1)&~(4-1);e=f[d>>2]|0;f[c>>2]=d+4;f[a>>2]=e;break a;break}case 10:{e=(f[c>>2]|0)+(4-1)&~(4-1);d=f[e>>2]|0;f[c>>2]=e+4;e=a;f[e>>2]=d;f[e+4>>2]=((d|0)<0)<<31>>31;break a;break}case 11:{d=(f[c>>2]|0)+(4-1)&~(4-1);e=f[d>>2]|0;f[c>>2]=d+4;d=a;f[d>>2]=e;f[d+4>>2]=0;break a;break}case 12:{d=(f[c>>2]|0)+(8-1)&~(8-1);e=d;g=f[e>>2]|0;h=f[e+4>>2]|0;f[c>>2]=d+8;d=a;f[d>>2]=g;f[d+4>>2]=h;break a;break}case 13:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=(d&65535)<<16>>16;d=a;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;break a;break}case 14:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=a;f[h>>2]=d&65535;f[h+4>>2]=0;break a;break}case 15:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=(d&255)<<24>>24;d=a;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;break a;break}case 16:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=a;f[h>>2]=d&255;f[h+4>>2]=0;break a;break}case 17:{h=(f[c>>2]|0)+(8-1)&~(8-1);i=+p[h>>3];f[c>>2]=h+8;p[a>>3]=i;break a;break}case 18:{h=(f[c>>2]|0)+(8-1)&~(8-1);i=+p[h>>3];f[c>>2]=h+8;p[a>>3]=i;break a;break}default:break a}while(0);while(0);return}function Voc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;if((a|0)==0&(c|0)==0)f=d;else{g=d;d=c;c=a;while(1){a=g+-1|0;b[a>>0]=h[511993+(c&15)>>0]|0|e;c=aJc(c|0,d|0,4)|0;d=J;if((c|0)==0&(d|0)==0){f=a;break}else g=a}}return f|0}function Woc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;if((a|0)==0&(c|0)==0)e=d;else{f=d;d=c;c=a;while(1){a=f+-1|0;b[a>>0]=c&7|48;c=aJc(c|0,d|0,3)|0;d=J;if((c|0)==0&(d|0)==0){e=a;break}else f=a}}return e|0}function Xoc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;if(c>>>0>0|(c|0)==0&a>>>0>4294967295){e=d;f=a;g=c;while(1){c=gJc(f|0,g|0,10,0)|0;e=e+-1|0;b[e>>0]=c&255|48;c=f;f=cJc(f|0,g|0,10,0)|0;if(!(g>>>0>9|(g|0)==9&c>>>0>4294967295))break;else g=J}h=f;i=e}else{h=a;i=d}if(!h)j=i;else{d=h;h=i;while(1){i=h+-1|0;b[i>>0]=(d>>>0)%10|0|48;if(d>>>0<10){j=i;break}else{d=(d>>>0)/10|0;h=i}}}return j|0}function Yoc(a){a=a|0;var b=0;b=(gpc()|0)+188|0;return hpc(a,f[b>>2]|0)|0}function Zoc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c&255;g=(d|0)!=0;a:do if(g&(a&3|0)!=0){h=c&255;i=a;j=d;while(1){if((b[i>>0]|0)==h<<24>>24){k=i;l=j;m=6;break a}n=i+1|0;o=j+-1|0;p=(o|0)!=0;if(p&(n&3|0)!=0){i=n;j=o}else{q=n;r=o;s=p;m=5;break}}}else{q=a;r=d;s=g;m=5}while(0);if((m|0)==5)if(s){k=q;l=r;m=6}else{t=q;u=0}b:do if((m|0)==6){q=c&255;if((b[k>>0]|0)==q<<24>>24){t=k;u=l}else{r=Y(e,16843009)|0;c:do if(l>>>0>3){s=k;g=l;while(1){d=f[s>>2]^r;if((d&-2139062144^-2139062144)&d+-16843009|0)break;d=s+4|0;a=g+-4|0;if(a>>>0>3){s=d;g=a}else{v=d;w=a;m=11;break c}}x=s;y=g}else{v=k;w=l;m=11}while(0);if((m|0)==11)if(!w){t=v;u=0;break}else{x=v;y=w}while(1){if((b[x>>0]|0)==q<<24>>24){t=x;u=y;break b}r=x+1|0;y=y+-1|0;if(!y){t=r;u=0;break}else x=r}}}while(0);return (u|0?t:0)|0}function _oc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=u;u=u+256|0;g=f;if((c|0)>(d|0)&(e&73728|0)==0){e=c-d|0;XIc(g|0,b|0,(e>>>0<256?e:256)|0)|0;if(e>>>0>255){b=c-d|0;d=e;do{Soc(a,g,256);d=d+-256|0}while(d>>>0>255);h=b&255}else h=e;Soc(a,g,h)}u=f;return}function $oc(a,b){a=a|0;b=b|0;var c=0;if(!a)c=0;else c=epc(a,b,0)|0;return c|0}function apc(a,c,d,e,g,i){a=a|0;c=+c;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;j=u;u=u+560|0;k=j+8|0;l=j;m=j+524|0;n=m;o=j+512|0;f[l>>2]=0;p=o+12|0;bpc(c)|0;if((J|0)<0){q=-c;r=1;s=511962}else{q=c;r=(g&2049|0)!=0&1;s=(g&2048|0)==0?((g&1|0)==0?511963:511968):511965}bpc(q)|0;t=J&2146435072;do if(t>>>0<2146435072|(t|0)==2146435072&0<0){c=+cpc(q,l)*2.0;v=c!=0.0;if(v)f[l>>2]=(f[l>>2]|0)+-1;w=i|32;if((w|0)==97){x=i&32;y=(x|0)==0?s:s+9|0;z=r|2;A=12-e|0;do if(!(e>>>0>11|(A|0)==0)){B=8.0;C=A;do{C=C+-1|0;B=B*16.0}while((C|0)!=0);if((b[y>>0]|0)==45){D=-(B+(-c-B));break}else{D=c+B-B;break}}else D=c;while(0);A=f[l>>2]|0;C=(A|0)<0?0-A|0:A;E=Xoc(C,((C|0)<0)<<31>>31,p)|0;if((E|0)==(p|0)){C=o+11|0;b[C>>0]=48;F=C}else F=E;b[F+-1>>0]=(A>>31&2)+43;A=F+-2|0;b[A>>0]=i+15;E=(e|0)<1;C=(g&8|0)==0;G=m;H=D;while(1){I=~~H;K=G+1|0;b[G>>0]=h[511993+I>>0]|x;H=(H-+(I|0))*16.0;if((K-n|0)==1?!(C&(E&H==0.0)):0){b[K>>0]=46;L=G+2|0}else L=K;if(!(H!=0.0))break;else G=L}G=L-n|0;E=p-A|0;C=(e|0)!=0&(G+-2|0)<(e|0)?e+2|0:G;x=E+z+C|0;_oc(a,32,d,x,g);Soc(a,y,z);_oc(a,48,d,x,g^65536);Soc(a,m,G);_oc(a,48,C-G|0,0,0);Soc(a,A,E);_oc(a,32,d,x,g^8192);M=x;break}x=(e|0)<0?6:e;if(v){E=(f[l>>2]|0)+-28|0;f[l>>2]=E;N=c*268435456.0;O=E}else{N=c;O=f[l>>2]|0}E=(O|0)<0?k:k+288|0;G=E;H=N;do{C=~~H>>>0;f[G>>2]=C;G=G+4|0;H=(H-+(C>>>0))*1.0e9}while(H!=0.0);if((O|0)>0){v=E;A=G;z=O;while(1){y=(z|0)<29?z:29;C=A+-4|0;if(C>>>0>=v>>>0){K=C;C=0;do{I=jJc(f[K>>2]|0,0,y|0)|0;P=UIc(I|0,J|0,C|0,0)|0;I=J;Q=gJc(P|0,I|0,1e9,0)|0;f[K>>2]=Q;C=cJc(P|0,I|0,1e9,0)|0;K=K+-4|0}while(K>>>0>=v>>>0);if(C){K=v+-4|0;f[K>>2]=C;R=K}else R=v}else R=v;K=A;while(1){if(K>>>0<=R>>>0)break;I=K+-4|0;if(!(f[I>>2]|0))K=I;else break}C=(f[l>>2]|0)-y|0;f[l>>2]=C;if((C|0)>0){v=R;A=K;z=C}else{S=R;T=K;U=C;break}}}else{S=E;T=G;U=O}if((U|0)<0){z=((x+25|0)/9|0)+1|0;A=(w|0)==102;v=S;C=T;I=U;while(1){P=0-I|0;Q=(P|0)<9?P:9;if(v>>>0<C>>>0){P=(1<<Q)+-1|0;V=1e9>>>Q;W=0;X=v;do{Z=f[X>>2]|0;f[X>>2]=(Z>>>Q)+W;W=Y(Z&P,V)|0;X=X+4|0}while(X>>>0<C>>>0);X=(f[v>>2]|0)==0?v+4|0:v;if(!W){_=X;$=C}else{f[C>>2]=W;_=X;$=C+4|0}}else{_=(f[v>>2]|0)==0?v+4|0:v;$=C}X=A?E:_;V=($-X>>2|0)>(z|0)?X+(z<<2)|0:$;I=(f[l>>2]|0)+Q|0;f[l>>2]=I;if((I|0)>=0){aa=_;ba=V;break}else{v=_;C=V}}}else{aa=S;ba=T}C=E;if(aa>>>0<ba>>>0){v=(C-aa>>2)*9|0;I=f[aa>>2]|0;if(I>>>0<10)ca=v;else{z=v;v=10;while(1){v=v*10|0;A=z+1|0;if(I>>>0<v>>>0){ca=A;break}else z=A}}}else ca=0;z=(w|0)==103;v=(x|0)!=0;I=x-((w|0)!=102?ca:0)+((v&z)<<31>>31)|0;if((I|0)<(((ba-C>>2)*9|0)+-9|0)){A=I+9216|0;I=E+4+(((A|0)/9|0)+-1024<<2)|0;G=((A|0)%9|0)+1|0;if((G|0)<9){A=G;G=10;while(1){V=G*10|0;A=A+1|0;if((A|0)==9){da=V;break}else G=V}}else da=10;G=f[I>>2]|0;A=(G>>>0)%(da>>>0)|0;w=(I+4|0)==(ba|0);if(!(w&(A|0)==0)){B=(((G>>>0)/(da>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;V=(da|0)/2|0;H=A>>>0<V>>>0?.5:w&(A|0)==(V|0)?1.0:1.5;if(!r){ea=H;fa=B}else{V=(b[s>>0]|0)==45;ea=V?-H:H;fa=V?-B:B}V=G-A|0;f[I>>2]=V;if(fa+ea!=fa){A=V+da|0;f[I>>2]=A;if(A>>>0>999999999){A=aa;V=I;while(1){G=V+-4|0;f[V>>2]=0;if(G>>>0<A>>>0){w=A+-4|0;f[w>>2]=0;ga=w}else ga=A;w=(f[G>>2]|0)+1|0;f[G>>2]=w;if(w>>>0>999999999){A=ga;V=G}else{ha=ga;ia=G;break}}}else{ha=aa;ia=I}V=(C-ha>>2)*9|0;A=f[ha>>2]|0;if(A>>>0<10){ja=ia;ka=V;la=ha}else{G=V;V=10;while(1){V=V*10|0;w=G+1|0;if(A>>>0<V>>>0){ja=ia;ka=w;la=ha;break}else G=w}}}else{ja=I;ka=ca;la=aa}}else{ja=I;ka=ca;la=aa}G=ja+4|0;ma=ka;na=ba>>>0>G>>>0?G:ba;oa=la}else{ma=ca;na=ba;oa=aa}G=na;while(1){if(G>>>0<=oa>>>0){pa=0;break}V=G+-4|0;if(!(f[V>>2]|0))G=V;else{pa=1;break}}I=0-ma|0;do if(z){V=((v^1)&1)+x|0;if((V|0)>(ma|0)&(ma|0)>-5){qa=i+-1|0;ra=V+-1-ma|0}else{qa=i+-2|0;ra=V+-1|0}V=g&8;if(!V){if(pa?(A=f[G+-4>>2]|0,(A|0)!=0):0)if(!((A>>>0)%10|0)){w=0;X=10;while(1){X=X*10|0;P=w+1|0;if((A>>>0)%(X>>>0)|0|0){sa=P;break}else w=P}}else sa=0;else sa=9;w=((G-C>>2)*9|0)+-9|0;if((qa|32|0)==102){X=w-sa|0;A=(X|0)>0?X:0;ta=qa;ua=(ra|0)<(A|0)?ra:A;va=0;break}else{A=w+ma-sa|0;w=(A|0)>0?A:0;ta=qa;ua=(ra|0)<(w|0)?ra:w;va=0;break}}else{ta=qa;ua=ra;va=V}}else{ta=i;ua=x;va=g&8}while(0);x=ua|va;C=(x|0)!=0&1;v=(ta|32|0)==102;if(v){wa=0;xa=(ma|0)>0?ma:0}else{z=(ma|0)<0?I:ma;w=Xoc(z,((z|0)<0)<<31>>31,p)|0;z=p;if((z-w|0)<2){A=w;while(1){X=A+-1|0;b[X>>0]=48;if((z-X|0)<2)A=X;else{ya=X;break}}}else ya=w;b[ya+-1>>0]=(ma>>31&2)+43;A=ya+-2|0;b[A>>0]=ta;wa=A;xa=z-A|0}A=r+1+ua+C+xa|0;_oc(a,32,d,A,g);Soc(a,s,r);_oc(a,48,d,A,g^65536);if(v){I=oa>>>0>E>>>0?E:oa;X=m+9|0;Q=X;W=m+8|0;P=I;do{K=Xoc(f[P>>2]|0,0,X)|0;if((P|0)==(I|0))if((K|0)==(X|0)){b[W>>0]=48;za=W}else za=K;else if(K>>>0>m>>>0){XIc(m|0,48,K-n|0)|0;y=K;while(1){Z=y+-1|0;if(Z>>>0>m>>>0)y=Z;else{za=Z;break}}}else za=K;Soc(a,za,Q-za|0);P=P+4|0}while(P>>>0<=E>>>0);if(x|0)Soc(a,518136,1);if(P>>>0<G>>>0&(ua|0)>0){E=ua;Q=P;while(1){W=Xoc(f[Q>>2]|0,0,X)|0;if(W>>>0>m>>>0){XIc(m|0,48,W-n|0)|0;I=W;while(1){v=I+-1|0;if(v>>>0>m>>>0)I=v;else{Aa=v;break}}}else Aa=W;Soc(a,Aa,(E|0)<9?E:9);Q=Q+4|0;I=E+-9|0;if(!(Q>>>0<G>>>0&(E|0)>9)){Ba=I;break}else E=I}}else Ba=ua;_oc(a,48,Ba+9|0,9,0)}else{E=pa?G:oa+4|0;if((ua|0)>-1){Q=m+9|0;X=(va|0)==0;P=Q;x=0-n|0;I=m+8|0;K=ua;v=oa;while(1){C=Xoc(f[v>>2]|0,0,Q)|0;if((C|0)==(Q|0)){b[I>>0]=48;Ca=I}else Ca=C;do if((v|0)==(oa|0)){C=Ca+1|0;Soc(a,Ca,1);if(X&(K|0)<1){Da=C;break}Soc(a,518136,1);Da=C}else{if(Ca>>>0<=m>>>0){Da=Ca;break}XIc(m|0,48,Ca+x|0)|0;C=Ca;while(1){z=C+-1|0;if(z>>>0>m>>>0)C=z;else{Da=z;break}}}while(0);W=P-Da|0;Soc(a,Da,(K|0)>(W|0)?W:K);C=K-W|0;v=v+4|0;if(!(v>>>0<E>>>0&(C|0)>-1)){Ea=C;break}else K=C}}else Ea=ua;_oc(a,48,Ea+18|0,18,0);Soc(a,wa,p-wa|0)}_oc(a,32,d,A,g^8192);M=A}else{K=(i&32|0)!=0;E=r+3|0;_oc(a,32,d,E,g&-65537);Soc(a,s,r);Soc(a,q!=q|0.0!=0.0?(K?513910:511989):K?511981:511985,3);_oc(a,32,d,E,g^8192);M=E}while(0);u=j;return ((M|0)<(d|0)?d:M)|0}function bpc(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function cpc(a,b){a=+a;b=b|0;return +(+dpc(a,b))}function dpc(a,b){a=+a;b=b|0;var c=0,d=0,e=0,g=0.0,h=0.0,i=0,j=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;e=aJc(c|0,d|0,52)|0;switch(e&2047){case 0:{if(a!=0.0){g=+dpc(a*18446744073709551616.0,b);h=g;i=(f[b>>2]|0)+-64|0}else{h=a;i=0}f[b>>2]=i;j=h;break}case 2047:{j=a;break}default:{f[b>>2]=(e&2047)+-1022;f[s>>2]=c;f[s+4>>2]=d&-2146435073|1071644672;j=+p[s>>3]}}return +j}function epc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;do if(a){if(c>>>0<128){b[a>>0]=c;e=1;break}d=(fpc()|0)+188|0;if(!(f[f[d>>2]>>2]|0))if((c&-128|0)==57216){b[a>>0]=c;e=1;break}else{d=zoc()|0;f[d>>2]=84;e=-1;break}if(c>>>0<2048){b[a>>0]=c>>>6|192;b[a+1>>0]=c&63|128;e=2;break}if(c>>>0<55296|(c&-8192|0)==57344){b[a>>0]=c>>>12|224;b[a+1>>0]=c>>>6&63|128;b[a+2>>0]=c&63|128;e=3;break}if((c+-65536|0)>>>0<1048576){b[a>>0]=c>>>18|240;b[a+1>>0]=c>>>12&63|128;b[a+2>>0]=c>>>6&63|128;b[a+3>>0]=c&63|128;e=4;break}else{d=zoc()|0;f[d>>2]=84;e=-1;break}}else e=1;while(0);return e|0}function fpc(){return Boc()|0}function gpc(){return Boc()|0}function hpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0;d=0;while(1){if((h[512009+d>>0]|0)==(a|0)){e=2;break}g=d+1|0;if((g|0)==87){i=512097;j=87;e=5;break}else d=g}if((e|0)==2)if(!d)k=512097;else{i=512097;j=d;e=5}if((e|0)==5)while(1){e=0;d=i;do{a=d;d=d+1|0}while((b[a>>0]|0)!=0);j=j+-1|0;if(!j){k=d;break}else{i=d;e=5}}return ipc(k,f[c+20>>2]|0)|0}function ipc(a,b){a=a|0;b=b|0;return jpc(a,b)|0}function jpc(a,b){a=a|0;b=b|0;var c=0;if(!b)c=0;else c=kpc(f[b>>2]|0,f[b+4>>2]|0,a)|0;return (c|0?c:a)|0}function kpc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=(f[a>>2]|0)+1794895138|0;g=lpc(f[a+8>>2]|0,e)|0;h=lpc(f[a+12>>2]|0,e)|0;i=lpc(f[a+16>>2]|0,e)|0;a:do if((g>>>0<c>>>2>>>0?(j=c-(g<<2)|0,h>>>0<j>>>0&i>>>0<j>>>0):0)?((i|h)&3|0)==0:0){j=h>>>2;k=i>>>2;l=0;m=g;while(1){n=m>>>1;o=l+n|0;p=o<<1;q=p+j|0;r=lpc(f[a+(q<<2)>>2]|0,e)|0;s=lpc(f[a+(q+1<<2)>>2]|0,e)|0;if(!(s>>>0<c>>>0&r>>>0<(c-s|0)>>>0)){t=0;break a}if(b[a+(s+r)>>0]|0){t=0;break a}r=Ioc(d,a+s|0)|0;if(!r)break;s=(r|0)<0;if((m|0)==1){t=0;break a}else{l=s?l:o;m=s?n:m-n|0}}m=p+k|0;l=lpc(f[a+(m<<2)>>2]|0,e)|0;j=lpc(f[a+(m+1<<2)>>2]|0,e)|0;if(j>>>0<c>>>0&l>>>0<(c-j|0)>>>0)t=(b[a+(j+l)>>0]|0)==0?a+j|0:0;else t=0}else t=0;while(0);return t|0}function lpc(a,b){a=a|0;b=b|0;var c=0;c=hJc(a|0)|0;return ((b|0)==0?a:c)|0}function mpc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+16|0;g=f[e>>2]|0;if(!g)if(!(npc(d)|0)){h=f[e>>2]|0;i=5}else j=0;else{h=g;i=5}a:do if((i|0)==5){g=d+20|0;e=f[g>>2]|0;k=e;if((h-e|0)>>>0<c>>>0){j=hj[f[d+36>>2]&511](d,a,c)|0;break}b:do if((b[d+75>>0]|0)>-1){e=c;while(1){if(!e){l=0;m=a;n=c;o=k;break b}p=e+-1|0;if((b[a+p>>0]|0)==10)break;else e=p}p=hj[f[d+36>>2]&511](d,a,e)|0;if(p>>>0<e>>>0){j=p;break a}l=e;m=a+e|0;n=c-e|0;o=f[g>>2]|0}else{l=0;m=a;n=c;o=k}while(0);dJc(o|0,m|0,n|0)|0;f[g>>2]=(f[g>>2]|0)+n;j=l+n|0}while(0);return j|0}function npc(a){a=a|0;var c=0,d=0,e=0;c=a+74|0;d=b[c>>0]|0;b[c>>0]=d+255|d;d=f[a>>2]|0;if(!(d&8)){f[a+8>>2]=0;f[a+4>>2]=0;c=f[a+44>>2]|0;f[a+28>>2]=c;f[a+20>>2]=c;f[a+16>>2]=c+(f[a+48>>2]|0);e=0}else{f[a>>2]=d|32;e=-1}return e|0}function opc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=ppc(a,b,e)|0;u=d;return c|0}function ppc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0;e=u;u=u+288|0;g=e+8|0;i=e+17|0;j=e;k=e+16|0;if((f[a+76>>2]|0)>-1)l=Loc(a)|0;else l=0;m=b[c>>0]|0;a:do if(m<<24>>24){o=a+4|0;q=a+100|0;r=a+108|0;s=a+8|0;t=i+10|0;v=i+33|0;w=g+4|0;x=i+46|0;y=i+94|0;z=i+1|0;A=i+1|0;B=c;C=0;D=0;E=0;F=0;G=m;b:while(1){c:do if(!(qpc(G&255)|0)){H=G<<24>>24==37;d:do if(H){I=B+1|0;K=b[I>>0]|0;e:do switch(K<<24>>24){case 37:{break d;break}case 42:{L=0;M=B+2|0;break}default:{N=(K&255)+-48|0;if(N>>>0<10?(b[B+2>>0]|0)==36:0){L=tpc(d,N)|0;M=B+3|0;break e}N=(f[d>>2]|0)+(4-1)&~(4-1);O=f[N>>2]|0;f[d>>2]=N+4;L=O;M=I}}while(0);I=b[M>>0]|0;K=I&255;if((K+-48|0)>>>0<10){O=0;N=M;P=K;while(1){K=(O*10|0)+-48+P|0;Q=N+1|0;R=b[Q>>0]|0;P=R&255;if((P+-48|0)>>>0>=10){S=K;T=Q;U=R;break}else{O=K;N=Q}}}else{S=0;T=M;U=I}N=U<<24>>24==109;O=(L|0)!=0;P=N?0:E;Q=N?0:F;K=N?T+1|0:T;V=O&N;N=K+1|0;switch(b[K>>0]|0){case 104:{R=(b[N>>0]|0)==104;W=R?-2:-1;X=R?K+2|0:N;break}case 108:{R=(b[N>>0]|0)==108;W=R?3:1;X=R?K+2|0:N;break}case 106:{W=3;X=N;break}case 116:case 122:{W=1;X=N;break}case 76:{W=2;X=N;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{W=0;X=K;break}default:{Y=P;Z=Q;_=V;$=137;break b}}K=h[X>>0]|0;N=(K&47|0)==3;R=N?K|32:K;K=N?1:W;N=R&255;switch(N<<24>>24){case 99:{aa=(S|0)>1?S:1;ba=C;break}case 91:{aa=S;ba=C;break}case 110:{upc(L,K,C,((C|0)<0)<<31>>31);ca=X;da=D;ea=C;fa=P;ga=Q;break c;break}default:{rpc(a,0);do{ha=f[o>>2]|0;if(ha>>>0<(f[q>>2]|0)>>>0){f[o>>2]=ha+1;ia=h[ha>>0]|0}else ia=spc(a)|0}while((qpc(ia)|0)!=0);if(!(f[q>>2]|0))ja=f[o>>2]|0;else{I=(f[o>>2]|0)+-1|0;f[o>>2]=I;ja=I}aa=S;ba=(f[r>>2]|0)+C+ja-(f[s>>2]|0)|0}}rpc(a,aa);I=f[o>>2]|0;ha=f[q>>2]|0;if(I>>>0<ha>>>0){f[o>>2]=I+1;ka=ha}else{if((spc(a)|0)<0){Y=P;Z=Q;_=V;$=137;break b}ka=f[q>>2]|0}if(ka|0)f[o>>2]=(f[o>>2]|0)+-1;f:do switch(N<<24>>24){case 91:case 99:case 115:{ha=(R|0)==99;g:do if((R|16|0)==115){XIc(z|0,-1,256)|0;b[i>>0]=0;if((R|0)==115){b[v>>0]=0;b[t>>0]=0;b[t+1>>0]=0;b[t+2>>0]=0;b[t+3>>0]=0;b[t+4>>0]=0;la=X}else la=X}else{I=X+1|0;ma=(b[I>>0]|0)==94;na=ma&1;oa=ma?X+2|0:I;XIc(A|0,ma&1|0,256)|0;b[i>>0]=0;switch(b[oa>>0]|0){case 45:{pa=x;$=64;break}case 93:{pa=y;$=64;break}default:{qa=oa;ra=(na^1)&255}}if(($|0)==64){$=0;ma=(na^1)&255;b[pa>>0]=ma;qa=oa+1|0;ra=ma}ma=qa;while(1){oa=b[ma>>0]|0;h:do switch(oa<<24>>24){case 0:{Y=P;Z=Q;_=V;$=137;break b;break}case 93:{la=ma;break g;break}case 45:{na=ma+1|0;I=b[na>>0]|0;switch(I<<24>>24){case 93:case 0:{sa=ma;ta=45;break h;break}default:{}}ua=b[ma+-1>>0]|0;if((ua&255)<(I&255)){va=ua&255;do{va=va+1|0;b[i+va>>0]=ra;ua=b[na>>0]|0}while((va|0)<(ua&255|0));sa=na;ta=ua}else{sa=na;ta=I}break}default:{sa=ma;ta=oa}}while(0);b[i+((ta&255)+1)>>0]=ra;ma=sa+1|0}}while(0);ma=ha?aa+1|0:31;oa=(K|0)==1;i:do if(oa){if(V){va=ooc(ma<<2)|0;if(!va){Y=0;Z=0;_=1;$=137;break b}else wa=va}else wa=L;f[g>>2]=0;f[w>>2]=0;va=ma;ua=0;xa=wa;j:while(1){ya=(xa|0)==0;za=ua;while(1){k:while(1){Aa=f[o>>2]|0;if(Aa>>>0<(f[q>>2]|0)>>>0){f[o>>2]=Aa+1;Ba=h[Aa>>0]|0}else Ba=spc(a)|0;if(!(b[i+(Ba+1)>>0]|0))break j;b[k>>0]=Ba;switch(vpc(j,k,1,g)|0){case -1:{Y=0;Z=xa;_=V;$=137;break b;break}case -2:break;default:break k}}if(ya)Ca=za;else{f[xa+(za<<2)>>2]=f[j>>2];Ca=za+1|0}if(V&(Ca|0)==(va|0))break;else za=Ca}ya=va<<1|1;I=qoc(xa,ya<<2)|0;if(!I){Y=0;Z=xa;_=1;$=137;break b}else{na=va;va=ya;xa=I;ua=na}}if(!(wpc(g)|0)){Y=0;Z=xa;_=V;$=137;break b}else{Da=za;Ea=0;Fa=xa;Ga=xa}}else{if(V){ua=ooc(ma)|0;if(!ua){Y=0;Z=0;_=1;$=137;break b}else{Ha=ma;Ia=0;Ja=ua}while(1){ua=Ia;do{va=f[o>>2]|0;if(va>>>0<(f[q>>2]|0)>>>0){f[o>>2]=va+1;Ka=h[va>>0]|0}else Ka=spc(a)|0;if(!(b[i+(Ka+1)>>0]|0)){Da=ua;Ea=Ja;Fa=0;Ga=0;break i}b[Ja+ua>>0]=Ka;ua=ua+1|0}while((ua|0)!=(Ha|0));ua=Ha<<1|1;va=qoc(Ja,ua)|0;if(!va){Y=Ja;Z=0;_=1;$=137;break b}else{na=Ha;Ha=ua;Ja=va;Ia=na}}}if(!L){xa=ka;while(1){na=f[o>>2]|0;if(na>>>0<xa>>>0){f[o>>2]=na+1;La=h[na>>0]|0}else La=spc(a)|0;if(!(b[i+(La+1)>>0]|0)){Da=0;Ea=0;Fa=0;Ga=0;break i}xa=f[q>>2]|0}}else{xa=0;na=ka;while(1){va=f[o>>2]|0;if(va>>>0<na>>>0){f[o>>2]=va+1;Ma=h[va>>0]|0}else Ma=spc(a)|0;if(!(b[i+(Ma+1)>>0]|0)){Da=xa;Ea=L;Fa=0;Ga=0;break i}b[L+xa>>0]=Ma;xa=xa+1|0;na=f[q>>2]|0}}}while(0);if(!(f[q>>2]|0))Na=f[o>>2]|0;else{ma=(f[o>>2]|0)+-1|0;f[o>>2]=ma;Na=ma}ma=Na-(f[s>>2]|0)+(f[r>>2]|0)|0;if(!ma){Oa=Ea;Pa=Ga;$=139;break b}if(!((ma|0)==(aa|0)|ha^1)){Oa=Ea;Pa=Ga;$=139;break b}do if(V)if(oa){f[L>>2]=Fa;break}else{f[L>>2]=Ea;break}while(0);if(ha){Qa=la;Ra=Ea;Sa=Ga}else{if(Fa|0)f[Fa+(Da<<2)>>2]=0;if(!Ea){Qa=la;Ra=0;Sa=Ga;break f}b[Ea+Da>>0]=0;Qa=la;Ra=Ea;Sa=Ga}break}case 120:case 88:case 112:{Ta=16;$=125;break}case 111:{Ta=8;$=125;break}case 117:case 100:{Ta=10;$=125;break}case 105:{Ta=0;$=125;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{Ua=+ypc(a,K,0);if((f[r>>2]|0)==((f[s>>2]|0)-(f[o>>2]|0)|0)){Oa=P;Pa=Q;$=139;break b}if(!L){Qa=X;Ra=P;Sa=Q}else switch(K|0){case 0:{n[L>>2]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}case 1:{p[L>>3]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}case 2:{p[L>>3]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}default:{Qa=X;Ra=P;Sa=Q;break f}}break}default:{Qa=X;Ra=P;Sa=Q}}while(0);do if(($|0)==125){$=0;N=xpc(a,Ta,0,-1,-1)|0;if((f[r>>2]|0)==((f[s>>2]|0)-(f[o>>2]|0)|0)){Oa=P;Pa=Q;$=139;break b}if(O&(R|0)==112){f[L>>2]=N;Qa=X;Ra=P;Sa=Q;break}else{upc(L,K,N,J);Qa=X;Ra=P;Sa=Q;break}}while(0);ca=Qa;da=(O&1)+D|0;ea=(f[r>>2]|0)+ba+(f[o>>2]|0)-(f[s>>2]|0)|0;fa=Ra;ga=Sa;break c}while(0);Q=B+(H&1)|0;rpc(a,0);P=f[o>>2]|0;if(P>>>0<(f[q>>2]|0)>>>0){f[o>>2]=P+1;Va=h[P>>0]|0}else Va=spc(a)|0;if((Va|0)!=(h[Q>>0]|0)){$=22;break b}ca=Q;da=D;ea=C+1|0;fa=E;ga=F}else{Q=B;while(1){P=Q+1|0;if(!(qpc(h[P>>0]|0)|0))break;else Q=P}rpc(a,0);do{H=f[o>>2]|0;if(H>>>0<(f[q>>2]|0)>>>0){f[o>>2]=H+1;Wa=h[H>>0]|0}else Wa=spc(a)|0}while((qpc(Wa)|0)!=0);if(!(f[q>>2]|0))Xa=f[o>>2]|0;else{H=(f[o>>2]|0)+-1|0;f[o>>2]=H;Xa=H}ca=Q;da=D;ea=(f[r>>2]|0)+C+Xa-(f[s>>2]|0)|0;fa=E;ga=F}while(0);B=ca+1|0;G=b[B>>0]|0;if(!(G<<24>>24)){Ya=da;break a}else{C=ea;D=da;E=fa;F=ga}}if(($|0)==22){if(f[q>>2]|0)f[o>>2]=(f[o>>2]|0)+-1;if((D|0)!=0|(Va|0)>-1){Ya=D;break}else{Za=0;_a=E;$a=F;$=138}}else if(($|0)==137){C=_&1;if(!D){Za=C;_a=Y;$a=Z;$=138}else{ab=C;bb=D;cb=Y;db=Z}}else if(($|0)==139){ab=V&1;bb=D;cb=Oa;db=Pa}if(($|0)==138){ab=Za;bb=-1;cb=_a;db=$a}if(!ab)Ya=bb;else{poc(cb);poc(db);Ya=bb}}else Ya=0;while(0);if(l|0)Moc(a);u=e;return Ya|0}function qpc(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function rpc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;f[a+104>>2]=b;c=f[a+8>>2]|0;d=f[a+4>>2]|0;e=c-d|0;f[a+108>>2]=e;f[a+100>>2]=(b|0)!=0&(e|0)>(b|0)?d+b|0:c;return}function spc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+104|0;d=f[c>>2]|0;if((d|0)!=0?(f[a+108>>2]|0)>=(d|0):0)e=4;else{d=Ooc(a)|0;if((d|0)>=0){g=f[c>>2]|0;c=a+8|0;if(g){i=f[c>>2]|0;j=f[a+4>>2]|0;k=a+108|0;l=g-(f[k>>2]|0)|0;g=i;if((i-j|0)<(l|0)){m=k;n=g;o=g;p=j}else{m=k;n=j+(l+-1)|0;o=g;p=j}}else{j=f[c>>2]|0;m=a+108|0;n=j;o=j;p=f[a+4>>2]|0}f[a+100>>2]=n;if(o|0)f[m>>2]=o+1-p+(f[m>>2]|0);m=p+-1|0;if((h[m>>0]|0|0)==(d|0))q=d;else{b[m>>0]=d;q=d}}else e=4}if((e|0)==4){f[a+100>>2]=0;q=-1}return q|0}function tpc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[d>>2]=f[a>>2];a=b;while(1){b=(f[d>>2]|0)+(4-1)&~(4-1);e=f[b>>2]|0;f[d>>2]=b+4;if(a>>>0>1)a=a+-1|0;else break}u=c;return e|0}function upc(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0;a:do if(a|0)switch(c|0){case -2:{b[a>>0]=e;break a;break}case -1:{d[a>>1]=e;break a;break}case 0:{f[a>>2]=e;break a;break}case 1:{f[a>>2]=e;break a;break}case 3:{h=a;f[h>>2]=e;f[h+4>>2]=g;break a;break}default:break a}while(0);return}function vpc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=(e|0)==0?884160:e;e=f[i>>2]|0;a:do if(!c)if(!e)j=0;else k=17;else{l=(a|0)==0?h:a;if(!d)j=-2;else{if(!e){m=b[c>>0]|0;if(m<<24>>24>-1){f[l>>2]=m&255;j=m<<24>>24!=0&1;break}m=(Jpc()|0)+188|0;n=b[c>>0]|0;if(!(f[f[m>>2]>>2]|0)){f[l>>2]=n<<24>>24&57343;j=1;break}m=(n&255)+-194|0;if(m>>>0>50){k=17;break}n=f[178104+(m<<2)>>2]|0;m=d+-1|0;if(!m)o=n;else{p=c+1|0;q=n;r=m;k=11}}else{p=c;q=e;r=d;k=11}b:do if((k|0)==11){m=b[p>>0]|0;n=(m&255)>>>3;if((n+-16|n+(q>>26))>>>0>7){k=17;break a}else{s=p;t=q;v=r;w=m}while(1){s=s+1|0;t=(w&255)+-128|t<<6;v=v+-1|0;if((t|0)>=0)break;if(!v){o=t;break b}w=b[s>>0]|0;if((w&-64)<<24>>24!=-128){k=17;break a}}f[i>>2]=0;f[l>>2]=t;j=d-v|0;break a}while(0);f[i>>2]=o;j=-2}}while(0);if((k|0)==17){f[i>>2]=0;i=zoc()|0;f[i>>2]=84;j=-1}u=g;return j|0}function wpc(a){a=a|0;var b=0;if(!a)b=1;else b=(f[a>>2]|0)==0;return b&1|0}function xpc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;a:do if(c>>>0>36){i=zoc()|0;f[i>>2]=22;j=0;k=0}else{i=a+4|0;l=a+100|0;do{m=f[i>>2]|0;if(m>>>0<(f[l>>2]|0)>>>0){f[i>>2]=m+1;n=h[m>>0]|0}else n=spc(a)|0}while((qpc(n)|0)!=0);b:do switch(n|0){case 43:case 45:{m=((n|0)==45)<<31>>31;o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;p=m;q=h[o>>0]|0;break b}else{p=m;q=spc(a)|0;break b}break}default:{p=0;q=n}}while(0);m=(c|0)==0;do if((c|16|0)==16&(q|0)==48){o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;r=h[o>>0]|0}else r=spc(a)|0;if((r|32|0)!=120)if(m){s=r;t=8;u=46;break}else{v=r;w=c;u=32;break}o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;x=h[o>>0]|0}else x=spc(a)|0;if((h[513915+x>>0]|0)>15){o=(f[l>>2]|0)!=0;if(o)f[i>>2]=(f[i>>2]|0)+-1;if(!d){rpc(a,0);j=0;k=0;break a}if(!o){j=0;k=0;break a}f[i>>2]=(f[i>>2]|0)+-1;j=0;k=0;break a}else{s=x;t=16;u=46}}else{o=m?10:c;if((h[513915+q>>0]|0)>>>0<o>>>0){v=q;w=o;u=32}else{if(f[l>>2]|0)f[i>>2]=(f[i>>2]|0)+-1;rpc(a,0);o=zoc()|0;f[o>>2]=22;j=0;k=0;break a}}while(0);c:do if((u|0)==32)if((w|0)==10){m=v+-48|0;if(m>>>0<10){o=0;y=m;do{o=(o*10|0)+y|0;m=f[i>>2]|0;if(m>>>0<(f[l>>2]|0)>>>0){f[i>>2]=m+1;z=h[m>>0]|0}else z=spc(a)|0;y=z+-48|0}while(y>>>0<10&o>>>0<429496729);A=z;B=o;C=0}else{A=v;B=0;C=0}y=A+-48|0;if(y>>>0<10){m=A;D=B;E=C;F=y;while(1){y=mJc(D|0,E|0,10,0)|0;G=J;H=((F|0)<0)<<31>>31;I=~H;if(G>>>0>I>>>0|(G|0)==(I|0)&y>>>0>~F>>>0){K=10;L=m;M=D;N=E;u=72;break c}D=UIc(y|0,G|0,F|0,H|0)|0;E=J;H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;O=h[H>>0]|0}else O=spc(a)|0;F=O+-48|0;if(!(F>>>0<10&(E>>>0<429496729|(E|0)==429496729&D>>>0<2576980378)))break;else m=O}if(F>>>0>9){P=p;Q=E;R=D}else{K=10;L=O;M=D;N=E;u=72}}else{P=p;Q=C;R=B}}else{s=v;t=w;u=46}while(0);d:do if((u|0)==46){if(!(t+-1&t)){m=b[514171+((t*23|0)>>>5&7)>>0]|0;o=b[513915+s>>0]|0;H=o&255;if(H>>>0<t>>>0){G=0;y=H;do{G=y|G<<m;H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;S=h[H>>0]|0}else S=spc(a)|0;T=b[513915+S>>0]|0;y=T&255}while(G>>>0<134217728&y>>>0<t>>>0);U=S;V=T;W=0;X=G}else{U=s;V=o;W=0;X=0}y=aJc(-1,-1,m|0)|0;E=J;if((V&255)>>>0>=t>>>0|(W>>>0>E>>>0|(W|0)==(E|0)&X>>>0>y>>>0)){K=t;L=U;M=X;N=W;u=72;break}else{Z=X;_=W;$=V}while(1){D=jJc(Z|0,_|0,m|0)|0;F=J;H=$&255|D;D=f[i>>2]|0;if(D>>>0<(f[l>>2]|0)>>>0){f[i>>2]=D+1;aa=h[D>>0]|0}else aa=spc(a)|0;$=b[513915+aa>>0]|0;if(($&255)>>>0>=t>>>0|(F>>>0>E>>>0|(F|0)==(E|0)&H>>>0>y>>>0)){K=t;L=aa;M=H;N=F;u=72;break d}else{Z=H;_=F}}}y=b[513915+s>>0]|0;E=y&255;if(E>>>0<t>>>0){m=0;o=E;do{m=o+(Y(m,t)|0)|0;E=f[i>>2]|0;if(E>>>0<(f[l>>2]|0)>>>0){f[i>>2]=E+1;ba=h[E>>0]|0}else ba=spc(a)|0;ca=b[513915+ba>>0]|0;o=ca&255}while(m>>>0<119304647&o>>>0<t>>>0);da=ba;ea=ca;fa=m;ga=0}else{da=s;ea=y;fa=0;ga=0}if((ea&255)>>>0<t>>>0){o=cJc(-1,-1,t|0,0)|0;E=J;G=da;F=ga;H=fa;D=ea;while(1){if(F>>>0>E>>>0|(F|0)==(E|0)&H>>>0>o>>>0){K=t;L=G;M=H;N=F;u=72;break d}I=mJc(H|0,F|0,t|0,0)|0;ha=J;ia=D&255;if(ha>>>0>4294967295|(ha|0)==-1&I>>>0>~ia>>>0){K=t;L=G;M=H;N=F;u=72;break d}ja=UIc(ia|0,0,I|0,ha|0)|0;ha=J;I=f[i>>2]|0;if(I>>>0<(f[l>>2]|0)>>>0){f[i>>2]=I+1;ka=h[I>>0]|0}else ka=spc(a)|0;D=b[513915+ka>>0]|0;if((D&255)>>>0>=t>>>0){K=t;L=ka;M=ja;N=ha;u=72;break}else{G=ka;F=ha;H=ja}}}else{K=t;L=da;M=fa;N=ga;u=72}}while(0);if((u|0)==72)if((h[513915+L>>0]|0)>>>0<K>>>0){do{H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;la=h[H>>0]|0}else la=spc(a)|0}while((h[513915+la>>0]|0)>>>0<K>>>0);H=zoc()|0;f[H>>2]=34;P=(e&1|0)==0&0==0?p:0;Q=g;R=e}else{P=p;Q=N;R=M}if(f[l>>2]|0)f[i>>2]=(f[i>>2]|0)+-1;if(!(Q>>>0<g>>>0|(Q|0)==(g|0)&R>>>0<e>>>0)){if(!((e&1|0)!=0|0!=0|(P|0)!=0)){H=zoc()|0;f[H>>2]=34;H=UIc(e|0,g|0,-1,-1)|0;j=J;k=H;break}if(Q>>>0>g>>>0|(Q|0)==(g|0)&R>>>0>e>>>0){H=zoc()|0;f[H>>2]=34;j=g;k=e;break}}H=((P|0)<0)<<31>>31;F=TIc(R^P|0,Q^H|0,P|0,H|0)|0;j=J;k=F}while(0);J=j;return k|0}function ypc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0;switch(c|0){case 0:{e=-149;g=24;i=4;break}case 1:{e=-1074;g=53;i=4;break}case 2:{e=-1074;g=53;i=4;break}default:j=0.0}a:do if((i|0)==4){c=a+4|0;k=a+100|0;do{l=f[c>>2]|0;if(l>>>0<(f[k>>2]|0)>>>0){f[c>>2]=l+1;m=h[l>>0]|0}else m=spc(a)|0}while((qpc(m)|0)!=0);b:do switch(m|0){case 43:case 45:{l=1-(((m|0)==45&1)<<1)|0;n=f[c>>2]|0;if(n>>>0<(f[k>>2]|0)>>>0){f[c>>2]=n+1;o=h[n>>0]|0;p=l;break b}else{o=spc(a)|0;p=l;break b}break}default:{o=m;p=1}}while(0);l=0;n=o;while(1){if((n|32|0)!=(b[513901+l>>0]|0)){q=l;r=n;break}do if(l>>>0<7){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;t=h[s>>0]|0;break}else{t=spc(a)|0;break}}else t=n;while(0);s=l+1|0;if(s>>>0<8){l=s;n=t}else{q=s;r=t;break}}c:do switch(q|0){case 8:break;case 3:{i=23;break}default:{n=(d|0)!=0;if(n&q>>>0>3)if((q|0)==8)break c;else{i=23;break c}d:do if(!q){l=0;s=r;while(1){if((s|32|0)!=(b[513910+l>>0]|0)){u=l;v=s;break d}do if(l>>>0<2){w=f[c>>2]|0;if(w>>>0<(f[k>>2]|0)>>>0){f[c>>2]=w+1;x=h[w>>0]|0;break}else{x=spc(a)|0;break}}else x=s;while(0);w=l+1|0;if(w>>>0<3){l=w;s=x}else{u=w;v=x;break}}}else{u=q;v=r}while(0);switch(u|0){case 3:{s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;y=h[s>>0]|0}else y=spc(a)|0;if((y|0)==40)z=1;else{if(!(f[k>>2]|0)){j=C;break a}f[c>>2]=(f[c>>2]|0)+-1;j=C;break a}while(1){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;A=h[s>>0]|0}else A=spc(a)|0;if(!((A+-48|0)>>>0<10|(A+-65|0)>>>0<26)?!((A|0)==95|(A+-97|0)>>>0<26):0)break;z=z+1|0}if((A|0)==41){j=C;break a}s=(f[k>>2]|0)==0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if(!n){l=zoc()|0;f[l>>2]=22;rpc(a,0);j=0.0;break a}if(!z){j=C;break a}else B=z;while(1){B=B+-1|0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if(!B){j=C;break a}}break}case 0:{if((v|0)==48){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;E=h[s>>0]|0}else E=spc(a)|0;if((E|32|0)==120){j=+zpc(a,g,e,p,d);break a}if(!(f[k>>2]|0))F=48;else{f[c>>2]=(f[c>>2]|0)+-1;F=48}}else F=v;j=+Apc(a,F,g,e,p,d);break a;break}default:{if(f[k>>2]|0)f[c>>2]=(f[c>>2]|0)+-1;s=zoc()|0;f[s>>2]=22;rpc(a,0);j=0.0;break a}}}}while(0);if((i|0)==23){s=(f[k>>2]|0)==0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if((d|0)!=0&q>>>0>3){n=q;do{if(!s)f[c>>2]=(f[c>>2]|0)+-1;n=n+-1|0}while(n>>>0>3)}}j=+(p|0)*D}while(0);return +j}function zpc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0.0,S=0,T=0.0,U=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0.0;g=a+4|0;i=f[g>>2]|0;j=a+100|0;if(i>>>0<(f[j>>2]|0)>>>0){f[g>>2]=i+1;k=h[i>>0]|0;l=0}else{k=spc(a)|0;l=0}a:while(1){switch(k|0){case 46:{m=8;break a;break}case 48:break;default:{n=0;o=0;p=1.0;q=0.0;r=0;s=k;t=l;u=0;v=0;w=0;x=0;break a}}i=f[g>>2]|0;if(i>>>0<(f[j>>2]|0)>>>0){f[g>>2]=i+1;k=h[i>>0]|0;l=1;continue}else{k=spc(a)|0;l=1;continue}}if((m|0)==8){k=f[g>>2]|0;if(k>>>0<(f[j>>2]|0)>>>0){f[g>>2]=k+1;y=h[k>>0]|0}else y=spc(a)|0;if((y|0)==48){k=0;i=0;while(1){z=f[g>>2]|0;if(z>>>0<(f[j>>2]|0)>>>0){f[g>>2]=z+1;A=h[z>>0]|0}else A=spc(a)|0;z=UIc(k|0,i|0,-1,-1)|0;B=J;if((A|0)==48){k=z;i=B}else{n=1;o=0;p=1.0;q=0.0;r=0;s=A;t=1;u=B;v=0;w=0;x=z;break}}}else{n=1;o=0;p=1.0;q=0.0;r=0;s=y;t=l;u=0;v=0;w=0;x=0}}while(1){l=s+-48|0;y=(s|0)==46;if(l>>>0>=10?!(y|((s|32)+-97|0)>>>0<6):0){C=s;break}if(y)if(!n){D=1;E=o;F=p;G=q;H=r;I=t;K=w;L=v;M=w;N=v}else{C=46;break}else{y=(s|0)>57?(s|32)+-87|0:l;do if(!((v|0)<0|(v|0)==0&w>>>0<8))if((v|0)<0|(v|0)==0&w>>>0<14){O=p*.0625;P=o;Q=O;R=q+O*+(y|0);S=r;break}else{l=(o|0)!=0|(y|0)==0;P=l?o:1;Q=p;R=l?q:q+p*.5;S=r;break}else{P=o;Q=p;R=q;S=y+(r<<4)|0}while(0);y=UIc(w|0,v|0,1,0)|0;D=n;E=P;F=Q;G=R;H=S;I=1;K=x;L=u;M=y;N=J}y=f[g>>2]|0;if(y>>>0<(f[j>>2]|0)>>>0){f[g>>2]=y+1;n=D;o=E;p=F;q=G;r=H;s=h[y>>0]|0;t=I;u=L;v=N;w=M;x=K;continue}else{n=D;o=E;p=F;q=G;r=H;s=spc(a)|0;t=I;u=L;v=N;w=M;x=K;continue}}do if(!t){K=f[j>>2]|0;M=(K|0)!=0;if(M)f[g>>2]=(f[g>>2]|0)+-1;if(e){if(M)f[g>>2]=(f[g>>2]|0)+-1;if(!((n|0)==0|(K|0)==0))f[g>>2]=(f[g>>2]|0)+-1}else rpc(a,0);T=+(d|0)*0.0}else{K=(n|0)==0;M=K?w:x;N=K?v:u;if((v|0)<0|(v|0)==0&w>>>0<8){K=r;L=w;I=v;while(1){s=K<<4;L=UIc(L|0,I|0,1,0)|0;I=J;if(!((I|0)<0|(I|0)==0&L>>>0<8)){U=s;break}else K=s}}else U=r;if((C|32|0)==112){K=Bpc(a,e)|0;L=J;if((K|0)==0&(L|0)==-2147483648){if(!e){rpc(a,0);T=0.0;break}if(!(f[j>>2]|0)){V=0;W=0}else{f[g>>2]=(f[g>>2]|0)+-1;V=0;W=0}}else{V=K;W=L}}else if(!(f[j>>2]|0)){V=0;W=0}else{f[g>>2]=(f[g>>2]|0)+-1;V=0;W=0}L=jJc(M|0,N|0,2)|0;K=UIc(L|0,J|0,-32,-1)|0;L=UIc(K|0,J|0,V|0,W|0)|0;K=J;if(!U){T=+(d|0)*0.0;break}I=0-c|0;s=((I|0)<0)<<31>>31;if((K|0)>(s|0)|(K|0)==(s|0)&L>>>0>I>>>0){I=zoc()|0;f[I>>2]=34;T=+(d|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}I=c+-106|0;s=((I|0)<0)<<31>>31;if((K|0)<(s|0)|(K|0)==(s|0)&L>>>0<I>>>0){I=zoc()|0;f[I>>2]=34;T=+(d|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if((U|0)>-1){G=q;I=U;s=L;H=K;while(1){E=!(G>=.5);o=I<<1|(E^1)&1;F=G+(E?G:G+-1.0);E=UIc(s|0,H|0,-1,-1)|0;D=J;if((o|0)>-1){G=F;I=o;s=E;H=D}else{X=F;Y=o;Z=E;_=D;break}}}else{X=q;Y=U;Z=L;_=K}H=((b|0)<0)<<31>>31;s=TIc(32,0,c|0,((c|0)<0)<<31>>31|0)|0;I=UIc(s|0,J|0,Z|0,_|0)|0;s=J;if((H|0)>(s|0)|(H|0)==(s|0)&b>>>0>I>>>0)if((I|0)>0){$=I;m=59}else{aa=0;ba=84;m=61}else{$=b;m=59}if((m|0)==59)if(($|0)<53){aa=$;ba=84-$|0;m=61}else{ca=0.0;da=$;ea=+(d|0)}if((m|0)==61){G=+(d|0);ca=+Dpc(+Cpc(1.0,ba),G);da=aa;ea=G}I=(Y&1|0)==0&(X!=0.0&(da|0)<32);G=ea*(I?0.0:X)+(ca+ea*+(((I&1)+Y|0)>>>0))-ca;if(!(G!=0.0)){I=zoc()|0;f[I>>2]=34}T=+Fpc(G,Z)}while(0);return +T}function Apc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0;i=u;u=u+512|0;j=i;k=d+c|0;l=0-k|0;m=a+4|0;n=a+100|0;o=b;b=0;a:while(1){switch(o|0){case 46:{p=6;break a;break}case 48:break;default:{q=0;r=o;s=b;t=0;v=0;break a}}w=f[m>>2]|0;if(w>>>0<(f[n>>2]|0)>>>0){f[m>>2]=w+1;o=h[w>>0]|0;b=1;continue}else{o=spc(a)|0;b=1;continue}}if((p|0)==6){o=f[m>>2]|0;if(o>>>0<(f[n>>2]|0)>>>0){f[m>>2]=o+1;x=h[o>>0]|0}else x=spc(a)|0;if((x|0)==48){o=0;w=0;while(1){y=UIc(o|0,w|0,-1,-1)|0;z=J;A=f[m>>2]|0;if(A>>>0<(f[n>>2]|0)>>>0){f[m>>2]=A+1;B=h[A>>0]|0}else B=spc(a)|0;if((B|0)==48){o=y;w=z}else{q=1;r=B;s=1;t=y;v=z;break}}}else{q=1;r=x;s=b;t=0;v=0}}f[j>>2]=0;b=r+-48|0;x=(r|0)==46;b:do if(x|b>>>0<10){B=j+496|0;w=0;o=0;z=0;y=q;A=s;C=r;D=x;E=b;F=t;G=v;H=0;I=0;c:while(1){do if(D)if(!y){K=w;M=o;N=1;O=z;P=A;Q=H;R=I;S=H;T=I}else break c;else{U=UIc(H|0,I|0,1,0)|0;V=J;W=(C|0)!=48;if((o|0)>=125){if(!W){K=w;M=o;N=y;O=z;P=A;Q=F;R=G;S=U;T=V;break}f[B>>2]=f[B>>2]|1;K=w;M=o;N=y;O=z;P=A;Q=F;R=G;S=U;T=V;break}X=j+(o<<2)|0;if(!w)Z=E;else Z=C+-48+((f[X>>2]|0)*10|0)|0;f[X>>2]=Z;X=w+1|0;_=(X|0)==9;K=_?0:X;M=(_&1)+o|0;N=y;O=W?U:z;P=1;Q=F;R=G;S=U;T=V}while(0);V=f[m>>2]|0;if(V>>>0<(f[n>>2]|0)>>>0){f[m>>2]=V+1;$=h[V>>0]|0}else $=spc(a)|0;E=$+-48|0;D=($|0)==46;if(!(D|E>>>0<10)){aa=K;ba=M;ca=O;da=N;ea=$;fa=P;ga=Q;ha=S;ia=R;ja=T;p=29;break b}else{w=K;o=M;z=O;y=N;A=P;C=$;F=Q;G=R;H=S;I=T}}ka=w;la=o;ma=z;na=H;oa=I;pa=F;qa=G;ra=(A|0)!=0;p=37}else{aa=0;ba=0;ca=0;da=q;ea=r;fa=s;ga=t;ha=0;ia=v;ja=0;p=29}while(0);do if((p|0)==29){v=(da|0)==0;t=v?ha:ga;s=v?ja:ia;v=(fa|0)!=0;if(!(v&(ea|32|0)==101))if((ea|0)>-1){ka=aa;la=ba;ma=ca;na=ha;oa=ja;pa=t;qa=s;ra=v;p=37;break}else{sa=aa;ta=ba;ua=ca;va=ha;wa=ja;xa=v;ya=t;za=s;p=39;break}v=Bpc(a,g)|0;r=J;if((v|0)==0&(r|0)==-2147483648){if(!g){rpc(a,0);Aa=0.0;break}if(!(f[n>>2]|0)){Ba=0;Ca=0}else{f[m>>2]=(f[m>>2]|0)+-1;Ba=0;Ca=0}}else{Ba=v;Ca=r}r=UIc(Ba|0,Ca|0,t|0,s|0)|0;Da=aa;Ea=ba;Fa=ca;Ga=r;Ha=ha;Ia=J;Ja=ja;p=41}while(0);if((p|0)==37)if(f[n>>2]|0){f[m>>2]=(f[m>>2]|0)+-1;if(ra){Da=ka;Ea=la;Fa=ma;Ga=pa;Ha=na;Ia=qa;Ja=oa;p=41}else p=40}else{sa=ka;ta=la;ua=ma;va=na;wa=oa;xa=ra;ya=pa;za=qa;p=39}if((p|0)==39)if(xa){Da=sa;Ea=ta;Fa=ua;Ga=ya;Ha=va;Ia=za;Ja=wa;p=41}else p=40;do if((p|0)==40){wa=zoc()|0;f[wa>>2]=22;rpc(a,0);Aa=0.0}else if((p|0)==41){wa=f[j>>2]|0;if(!wa){Aa=+(e|0)*0.0;break}if(((Ja|0)<0|(Ja|0)==0&Ha>>>0<10)&((Ga|0)==(Ha|0)&(Ia|0)==(Ja|0))?(c|0)>30|(wa>>>c|0)==0:0){Aa=+(e|0)*+(wa>>>0);break}wa=(d|0)/-2|0;za=((wa|0)<0)<<31>>31;if((Ia|0)>(za|0)|(Ia|0)==(za|0)&Ga>>>0>wa>>>0){wa=zoc()|0;f[wa>>2]=34;Aa=+(e|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}wa=d+-106|0;za=((wa|0)<0)<<31>>31;if((Ia|0)<(za|0)|(Ia|0)==(za|0)&Ga>>>0<wa>>>0){wa=zoc()|0;f[wa>>2]=34;Aa=+(e|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(!Da)Ka=Ea;else{if((Da|0)<9){wa=j+(Ea<<2)|0;za=Da;va=f[wa>>2]|0;do{va=va*10|0;za=za+1|0}while((za|0)!=9);f[wa>>2]=va}Ka=Ea+1|0}if((Fa|0)<9?(Fa|0)<=(Ga|0)&(Ga|0)<18:0){za=f[j>>2]|0;if((Ga|0)==9){Aa=+(e|0)*+(za>>>0);break}if((Ga|0)<9){Aa=+(e|0)*+(za>>>0)/+(f[178308+(8-Ga<<2)>>2]|0);break}A=c+27+(Y(Ga,-3)|0)|0;if((A|0)>30|(za>>>A|0)==0){Aa=+(e|0)*+(za>>>0)*+(f[178308+(Ga+-10<<2)>>2]|0);break}}za=(Ga|0)%9|0;if(!za){La=0;Ma=Ka;Na=0;Oa=Ga}else{A=(Ga|0)>-1?za:za+9|0;za=f[178308+(8-A<<2)>>2]|0;if(Ka){G=1e9/(za|0)|0;F=0;I=0;H=Ga;z=0;do{o=j+(z<<2)|0;w=f[o>>2]|0;ya=((w>>>0)/(za>>>0)|0)+F|0;f[o>>2]=ya;F=Y(G,(w>>>0)%(za>>>0)|0)|0;w=(z|0)==(I|0)&(ya|0)==0;H=w?H+-9|0:H;I=w?I+1&127:I;z=z+1|0}while((z|0)!=(Ka|0));if(!F){Pa=I;Qa=Ka;Ra=H}else{f[j+(Ka<<2)>>2]=F;Pa=I;Qa=Ka+1|0;Ra=H}}else{Pa=0;Qa=0;Ra=Ga}La=0;Ma=Qa;Na=Pa;Oa=9-A+Ra|0}d:while(1){z=(Oa|0)<18;za=(Oa|0)==18;G=j+(Na<<2)|0;va=La;wa=Ma;while(1){if(!z){if(!za){Sa=va;Ta=Na;Ua=Oa;Va=wa;break d}if((f[G>>2]|0)>>>0>=9007199){Sa=va;Ta=Na;Ua=18;Va=wa;break d}}w=0;Wa=wa;ya=wa+127|0;while(1){o=ya&127;ua=j+(o<<2)|0;ta=jJc(f[ua>>2]|0,0,29)|0;sa=UIc(ta|0,J|0,w|0,0)|0;ta=J;if(ta>>>0>0|(ta|0)==0&sa>>>0>1e9){xa=cJc(sa|0,ta|0,1e9,0)|0;qa=gJc(sa|0,ta|0,1e9,0)|0;Xa=xa;Ya=qa}else{Xa=0;Ya=sa}f[ua>>2]=Ya;ua=(o|0)==(Na|0);Wa=(Ya|0)==0&(((o|0)!=(Wa+127&127|0)|ua)^1)?o:Wa;if(ua)break;else{w=Xa;ya=o+-1|0}}va=va+-29|0;if(Xa|0)break;else wa=Wa}wa=Na+127&127;G=Wa+127&127;za=j+((Wa+126&127)<<2)|0;if((wa|0)==(Wa|0)){f[za>>2]=f[za>>2]|f[j+(G<<2)>>2];Za=G}else Za=Wa;f[j+(wa<<2)>>2]=Xa;La=va;Ma=Za;Na=wa;Oa=Oa+9|0}e:while(1){A=Va+1&127;H=j+((Va+127&127)<<2)|0;I=Sa;F=Ta;wa=Ua;while(1){G=(wa|0)==18;za=(wa|0)>27?9:1;_a=I;$a=F;while(1){z=0;while(1){ya=z+$a&127;if((ya|0)==(Va|0)){ab=2;p=88;break}w=f[j+(ya<<2)>>2]|0;ya=f[178340+(z<<2)>>2]|0;if(w>>>0<ya>>>0){ab=2;p=88;break}if(w>>>0>ya>>>0)break;ya=z+1|0;if((ya|0)<2)z=ya;else{ab=ya;p=88;break}}if((p|0)==88?(p=0,G&(ab|0)==2):0){bb=0.0;cb=0;db=Va;break e}eb=za+_a|0;if(($a|0)==(Va|0)){_a=eb;$a=Va}else break}G=(1<<za)+-1|0;z=1e9>>>za;fb=0;gb=$a;hb=wa;ya=$a;do{w=j+(ya<<2)|0;o=f[w>>2]|0;ua=(o>>>za)+fb|0;f[w>>2]=ua;fb=Y(o&G,z)|0;o=(ya|0)==(gb|0)&(ua|0)==0;hb=o?hb+-9|0:hb;gb=o?gb+1&127:gb;ya=ya+1&127}while((ya|0)!=(Va|0));if(!fb){I=eb;F=gb;wa=hb;continue}if((A|0)!=(gb|0))break;f[H>>2]=f[H>>2]|1;I=eb;F=gb;wa=hb}f[j+(Va<<2)>>2]=fb;Sa=eb;Ta=gb;Ua=hb;Va=A}while(1){wa=cb+$a&127;F=db+1&127;if((wa|0)==(db|0)){f[j+(F+-1<<2)>>2]=0;ib=F}else ib=db;bb=bb*1.0e9+ +((f[j+(wa<<2)>>2]|0)>>>0);cb=cb+1|0;if((cb|0)==2)break;else db=ib}jb=+(e|0);kb=jb*bb;wa=_a+53|0;F=wa-d|0;I=(F|0)<(c|0);H=I?((F|0)>0?F:0):c;if((H|0)<53){lb=+Dpc(+Cpc(1.0,105-H|0),kb);mb=+Epc(kb,+Cpc(1.0,53-H|0));nb=lb;ob=mb;pb=lb+(kb-mb)}else{nb=0.0;ob=0.0;pb=kb}va=$a+2&127;if((va|0)!=(ib|0)){ya=f[j+(va<<2)>>2]|0;do if(ya>>>0>=5e8){if((ya|0)!=5e8){qb=jb*.75+ob;break}if(($a+3&127|0)==(ib|0)){qb=jb*.5+ob;break}else{qb=jb*.75+ob;break}}else{if((ya|0)==0?($a+3&127|0)==(ib|0):0){qb=ob;break}qb=jb*.25+ob}while(0);if((53-H|0)>1?!(+Epc(qb,1.0)!=0.0):0)rb=qb+1.0;else rb=qb}else rb=ob;jb=pb+rb-nb;do if((wa&2147483647|0)>(-2-k|0)){ya=!(+L(+jb)>=9007199254740992.0);va=((ya^1)&1)+_a|0;kb=ya?jb:jb*.5;if((va+50|0)<=(l|0)?!(rb!=0.0&(I&((H|0)!=(F|0)|ya))):0){sb=kb;tb=va;break}ya=zoc()|0;f[ya>>2]=34;sb=kb;tb=va}else{sb=jb;tb=_a}while(0);Aa=+Fpc(sb,tb)}while(0);u=i;return +Aa}function Bpc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+4|0;d=f[c>>2]|0;e=a+100|0;if(d>>>0<(f[e>>2]|0)>>>0){f[c>>2]=d+1;g=h[d>>0]|0}else g=spc(a)|0;switch(g|0){case 43:case 45:{d=(g|0)==45&1;i=f[c>>2]|0;if(i>>>0<(f[e>>2]|0)>>>0){f[c>>2]=i+1;j=h[i>>0]|0}else j=spc(a)|0;if((b|0)!=0&(j+-48|0)>>>0>9?(f[e>>2]|0)!=0:0){f[c>>2]=(f[c>>2]|0)+-1;k=d;l=j}else{k=d;l=j}break}default:{k=0;l=g}}if((l+-48|0)>>>0>9)if(!(f[e>>2]|0)){m=-2147483648;n=0}else{f[c>>2]=(f[c>>2]|0)+-1;m=-2147483648;n=0}else{g=0;j=l;while(1){g=j+-48+(g*10|0)|0;l=f[c>>2]|0;if(l>>>0<(f[e>>2]|0)>>>0){f[c>>2]=l+1;o=h[l>>0]|0}else o=spc(a)|0;if(!((o+-48|0)>>>0<10&(g|0)<214748364))break;else j=o}j=((g|0)<0)<<31>>31;if((o+-48|0)>>>0<10){l=o;d=g;b=j;while(1){i=mJc(d|0,b|0,10,0)|0;p=J;q=UIc(l|0,((l|0)<0)<<31>>31|0,-48,-1)|0;r=UIc(q|0,J|0,i|0,p|0)|0;p=J;i=f[c>>2]|0;if(i>>>0<(f[e>>2]|0)>>>0){f[c>>2]=i+1;s=h[i>>0]|0}else s=spc(a)|0;if((s+-48|0)>>>0<10&((p|0)<21474836|(p|0)==21474836&r>>>0<2061584302)){l=s;d=r;b=p}else{t=s;u=r;v=p;break}}}else{t=o;u=g;v=j}j=f[e>>2]|0;if((t+-48|0)>>>0<10){t=j;while(1){g=f[c>>2]|0;if(g>>>0<t>>>0){f[c>>2]=g+1;w=h[g>>0]|0;x=t}else{g=spc(a)|0;w=g;x=f[e>>2]|0}if((w+-48|0)>>>0<10)t=x;else{y=x;break}}}else y=j;if(y|0)f[c>>2]=(f[c>>2]|0)+-1;c=(k|0)!=0;k=TIc(0,0,u|0,v|0)|0;m=c?J:v;n=c?k:u}J=m;return n|0}function Cpc(a,b){a=+a;b=b|0;var c=0.0,d=0,e=0,g=0,h=0.0,i=0;if((b|0)<=1023)if((b|0)<-1022){c=a*2.2250738585072014e-308;d=b+1022|0;e=(d|0)<-1022;g=b+2044|0;h=e?c*2.2250738585072014e-308:c;i=e?((g|0)>-1022?g:-1022):d}else{h=a;i=b}else{c=a*8988465674311579538646525.0e283;d=b+-1023|0;g=(d|0)>1023;e=b+-2046|0;h=g?c*8988465674311579538646525.0e283:c;i=g?((e|0)<1023?e:1023):d}d=jJc(i+1023|0,0,52)|0;i=J;f[s>>2]=d;f[s+4>>2]=i;return +(h*+p[s>>3])}function Dpc(a,b){a=+a;b=+b;return +(+Ipc(a,b))}function Epc(a,b){a=+a;b=+b;return +(+Gpc(a,b))}function Fpc(a,b){a=+a;b=b|0;return +(+Cpc(a,b))}function Gpc(a,b){a=+a;b=+b;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;p[s>>3]=b;e=f[s>>2]|0;g=f[s+4>>2]|0;h=aJc(c|0,d|0,52)|0;i=h&2047;h=aJc(e|0,g|0,52)|0;j=h&2047;h=d&-2147483648;k=jJc(e|0,g|0,1)|0;l=J;a:do if(!((k|0)==0&(l|0)==0)?(m=Hpc(b)|0,n=J&2147483647,!((i|0)==2047|(n>>>0>2146435072|(n|0)==2146435072&m>>>0>0))):0){m=jJc(c|0,d|0,1)|0;n=J;if(!(n>>>0>l>>>0|(n|0)==(l|0)&m>>>0>k>>>0))return +((m|0)==(k|0)&(n|0)==(l|0)?a*0.0:a);if(!i){n=jJc(c|0,d|0,12)|0;m=J;if((m|0)>-1|(m|0)==-1&n>>>0>4294967295){o=0;q=n;n=m;while(1){m=o+-1|0;q=jJc(q|0,n|0,1)|0;n=J;if(!((n|0)>-1|(n|0)==-1&q>>>0>4294967295)){r=m;break}else o=m}}else r=0;o=jJc(c|0,d|0,1-r|0)|0;t=r;u=o;v=J}else{t=i;u=c;v=d&1048575|1048576}if(!j){o=jJc(e|0,g|0,12)|0;q=J;if((q|0)>-1|(q|0)==-1&o>>>0>4294967295){n=0;m=o;o=q;while(1){q=n+-1|0;m=jJc(m|0,o|0,1)|0;o=J;if(!((o|0)>-1|(o|0)==-1&m>>>0>4294967295)){w=q;break}else n=q}}else w=0;n=jJc(e|0,g|0,1-w|0)|0;x=w;y=n;z=J}else{x=j;y=e;z=g&1048575|1048576}n=TIc(u|0,v|0,y|0,z|0)|0;m=J;o=(m|0)>-1|(m|0)==-1&n>>>0>4294967295;b:do if((t|0)>(x|0)){q=t;A=m;B=o;C=u;D=v;E=n;while(1){if(B)if((E|0)==0&(A|0)==0)break;else{F=E;G=A}else{F=C;G=D}H=jJc(F|0,G|0,1)|0;I=J;K=q+-1|0;L=TIc(H|0,I|0,y|0,z|0)|0;M=J;N=(M|0)>-1|(M|0)==-1&L>>>0>4294967295;if((K|0)>(x|0)){q=K;A=M;B=N;C=H;D=I;E=L}else{O=K;P=N;Q=L;R=M;S=H;T=I;break b}}U=a*0.0;break a}else{O=t;P=o;Q=n;R=m;S=u;T=v}while(0);if(P)if((Q|0)==0&(R|0)==0){U=a*0.0;break}else{V=R;W=Q}else{V=T;W=S}if(V>>>0<1048576|(V|0)==1048576&W>>>0<0){m=O;n=W;o=V;while(1){E=jJc(n|0,o|0,1)|0;D=J;C=m+-1|0;if(D>>>0<1048576|(D|0)==1048576&E>>>0<0){m=C;n=E;o=D}else{X=C;Y=E;Z=D;break}}}else{X=O;Y=W;Z=V}if((X|0)>0){o=UIc(Y|0,Z|0,0,-1048576)|0;n=J;m=jJc(X|0,0,52)|0;_=n|J;$=o|m}else{m=aJc(Y|0,Z|0,1-X|0)|0;_=J;$=m}f[s>>2]=$;f[s+4>>2]=_|h;U=+p[s>>3]}else aa=3;while(0);if((aa|0)==3){ba=a*b;U=ba/ba}return +U}function Hpc(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function Ipc(a,b){a=+a;b=+b;var c=0,d=0,e=0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;p[s>>3]=b;e=f[s+4>>2]&-2147483648|d&2147483647;f[s>>2]=c;f[s+4>>2]=e;return +(+p[s>>3])}function Jpc(){return Boc()|0}function Kpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;g=c&255;b[e>>0]=g;i=a+16|0;j=f[i>>2]|0;if(!j)if(!(npc(a)|0)){k=f[i>>2]|0;l=4}else m=-1;else{k=j;l=4}do if((l|0)==4){j=a+20|0;i=f[j>>2]|0;if(i>>>0<k>>>0?(n=c&255,(n|0)!=(b[a+75>>0]|0)):0){f[j>>2]=i+1;b[i>>0]=g;m=n;break}if((hj[f[a+36>>2]&511](a,e,1)|0)==1)m=h[e>>0]|0;else m=-1}while(0);u=d;return m|0}function Lpc(a,b){a=a|0;b=b|0;var c=0;c=Mpc(a)|0;return ((Npc(a,1,c,b)|0)!=(c|0))<<31>>31|0}function Mpc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a;a:do if(!(c&3)){d=a;e=4}else{g=a;h=c;while(1){if(!(b[g>>0]|0)){i=h;break a}j=g+1|0;h=j;if(!(h&3)){d=j;e=4;break}else g=j}}while(0);if((e|0)==4){e=d;while(1){k=f[e>>2]|0;if(!((k&-2139062144^-2139062144)&k+-16843009))e=e+4|0;else break}if(!((k&255)<<24>>24))l=e;else{k=e;while(1){e=k+1|0;if(!(b[e>>0]|0)){l=e;break}else k=e}}i=l}return i-c|0}function Npc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=Y(c,b)|0;g=(b|0)==0?0:c;if((f[d+76>>2]|0)>-1){c=(Loc(d)|0)==0;h=mpc(a,e,d)|0;if(c)i=h;else{Moc(d);i=h}}else i=mpc(a,e,d)|0;if((i|0)==(e|0))j=g;else j=(i>>>0)/(b>>>0)|0;return j|0}function Opc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+128|0;h=g+124|0;i=g;j=i;k=178348;l=j+124|0;do{f[j>>2]=f[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));if((c+-1|0)>>>0>2147483646)if(!c){m=h;n=1;o=4}else{h=zoc()|0;f[h>>2]=75;p=-1}else{m=a;n=c;o=4}if((o|0)==4){o=-2-m|0;c=n>>>0>o>>>0?o:n;f[i+48>>2]=c;n=i+20|0;f[n>>2]=m;f[i+44>>2]=m;o=m+c|0;m=i+16|0;f[m>>2]=o;f[i+28>>2]=o;o=Qoc(i,d,e)|0;if(!c)p=o;else{c=f[n>>2]|0;b[c+(((c|0)==(f[m>>2]|0))<<31>>31)>>0]=0;p=o}}u=g;return p|0}function Ppc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=a+20|0;e=f[d>>2]|0;g=(f[a+16>>2]|0)-e|0;a=g>>>0>c>>>0?c:g;dJc(e|0,b|0,a|0)|0;f[d>>2]=(f[d>>2]|0)+a;return c|0}function Qpc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=Y(d,c)|0;h=(c|0)==0?0:d;if((f[e+76>>2]|0)>-1)i=Loc(e)|0;else i=0;d=e+74|0;j=b[d>>0]|0;b[d>>0]=j+255|j;j=e+4|0;d=f[j>>2]|0;k=(f[e+8>>2]|0)-d|0;l=k>>>0<g>>>0?k:g;if((k|0)>0){dJc(a|0,d|0,l|0)|0;f[j>>2]=d+l;m=g-l|0;n=a+l|0}else{m=g;n=a}a:do if(!m)o=13;else{a=e+32|0;l=m;d=n;while(1){if(Poc(e)|0)break;j=hj[f[a>>2]&511](e,d,l)|0;if((j+1|0)>>>0<2)break;k=l-j|0;if(!k){o=13;break a}else{l=k;d=d+j|0}}if(i|0)Moc(e);p=((g-l|0)>>>0)/(c>>>0)|0}while(0);if((o|0)==13)if(!i)p=h;else{Moc(e);p=h}return p|0}function Rpc(a){a=a|0;var b=0,c=0,d=0;if(!(f[a>>2]&128))b=1;else b=(f[a+20>>2]|0)>>>0>(f[a+28>>2]|0)>>>0?2:1;c=hj[f[a+40>>2]&511](a,0,b)|0;if((c|0)<0)d=c;else d=c-(f[a+8>>2]|0)+(f[a+4>>2]|0)+(f[a+20>>2]|0)-(f[a+28>>2]|0)|0;return d|0}function Spc(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(Loc(a)|0)==0;c=Rpc(a)|0;if(b)d=c;else d=c}else d=Rpc(a)|0;return d|0}function Tpc(a){a=a|0;return Spc(a)|0}function Upc(){Df(884164);return 884172}function Vpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d+40|0;g=d+24|0;h=d+16|0;i=d;j=d+56|0;k=b[c>>0]|0;if(Zoc(514180,k<<24>>24,4)|0){l=ooc(1156)|0;if(!l)m=0;else{n=l;o=n+124|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));if(!(Wpc(c,43)|0))f[l>>2]=k<<24>>24==114?8:4;if(!(Wpc(c,101)|0))p=k;else{f[i>>2]=a;f[i+4>>2]=2;f[i+8>>2]=1;Bd(221,i|0)|0;p=b[c>>0]|0}if(p<<24>>24==97){f[h>>2]=a;f[h+4>>2]=3;p=Bd(221,h|0)|0;if(!(p&1024)){f[g>>2]=a;f[g+4>>2]=4;f[g+8>>2]=p|1024;Bd(221,g|0)|0}g=f[l>>2]|128;f[l>>2]=g;q=g}else q=f[l>>2]|0;f[l+60>>2]=a;f[l+44>>2]=l+132;f[l+48>>2]=1024;g=l+75|0;b[g>>0]=-1;if((q&8|0)==0?(f[e>>2]=a,f[e+4>>2]=21523,f[e+8>>2]=j,(Xe(54,e|0)|0)==0):0)b[g>>0]=10;f[l+32>>2]=225;f[l+36>>2]=223;f[l+40>>2]=224;f[l+12>>2]=760;if(!(f[221019]|0))f[l+76>>2]=-1;Xpc(l)|0;m=l}}else{l=zoc()|0;f[l>>2]=22;m=0}u=d;return m|0}function Wpc(a,c){a=a|0;c=c|0;var d=0;d=Zpc(a,c)|0;return ((b[d>>0]|0)==(c&255)<<24>>24?d:0)|0}function Xpc(a){a=a|0;var b=0,c=0;b=Upc()|0;f[a+56>>2]=f[b>>2];c=f[b>>2]|0;if(c|0)f[c+52>>2]=a;f[b>>2]=a;Ypc();return a|0}function Ypc(){cg(884164);return}function Zpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=c&255;a:do if(!d)e=a+(Mpc(a)|0)|0;else{if(!(a&3))g=a;else{h=c&255;i=a;while(1){j=b[i>>0]|0;if(j<<24>>24==0?1:j<<24>>24==h<<24>>24){e=i;break a}j=i+1|0;if(!(j&3)){g=j;break}else i=j}}i=Y(d,16843009)|0;h=f[g>>2]|0;b:do if(!((h&-2139062144^-2139062144)&h+-16843009)){j=g;k=h;while(1){l=k^i;if((l&-2139062144^-2139062144)&l+-16843009|0){m=j;break b}l=j+4|0;k=f[l>>2]|0;if((k&-2139062144^-2139062144)&k+-16843009|0){m=l;break}else j=l}}else m=g;while(0);i=c&255;h=m;while(1){j=b[h>>0]|0;if(j<<24>>24==0?1:j<<24>>24==i<<24>>24){e=h;break}else h=h+1|0}}while(0);return e|0}function _pc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;if((f[a+76>>2]|0)>-1)b=Loc(a)|0;else b=0;$pc(a);c=(f[a>>2]&1|0)!=0;if(!c){d=Upc()|0;e=f[a+52>>2]|0;g=a+56|0;if(e|0)f[e+56>>2]=f[g>>2];h=f[g>>2]|0;if(h|0)f[h+52>>2]=e;if((f[d>>2]|0)==(a|0))f[d>>2]=h;Ypc()}h=aqc(a)|0;d=_i[f[a+12>>2]&1023](a)|0|h;h=f[a+92>>2]|0;if(h|0)poc(h);if(c){if(b|0)Moc(a)}else poc(a);return d|0}function $pc(a){a=a|0;var b=0,c=0,d=0;if(f[a+68>>2]|0){b=f[a+116>>2]|0;c=a+112|0;if(b|0)f[b+112>>2]=f[c>>2];a=f[c>>2]|0;if(!a)d=(cqc()|0)+232|0;else d=a+116|0;f[d>>2]=b}return}function aqc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;do if(a){if((f[a+76>>2]|0)<=-1){b=bqc(a)|0;break}c=(Loc(a)|0)==0;d=bqc(a)|0;if(c)b=d;else{Moc(a);b=d}}else{if(!(f[44507]|0))e=0;else e=aqc(f[44507]|0)|0;d=Upc()|0;c=f[d>>2]|0;if(!c)g=e;else{d=c;c=e;while(1){if((f[d+76>>2]|0)>-1)h=Loc(d)|0;else h=0;if((f[d+20>>2]|0)>>>0>(f[d+28>>2]|0)>>>0)i=bqc(d)|0|c;else i=c;if(h|0)Moc(d);d=f[d+56>>2]|0;if(!d){g=i;break}else c=i}}Ypc();b=g}while(0);return b|0}function bqc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+20|0;c=a+28|0;if((f[b>>2]|0)>>>0>(f[c>>2]|0)>>>0?(hj[f[a+36>>2]&511](a,0,0)|0,(f[b>>2]|0)==0):0)d=-1;else{e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;if(g>>>0<i>>>0)hj[f[a+40>>2]&511](a,g-i|0,1)|0;f[a+16>>2]=0;f[c>>2]=0;f[b>>2]=0;f[h>>2]=0;f[e>>2]=0;d=0}return d|0}function cqc(){return Boc()|0}function dqc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if((f[a+76>>2]|0)>=0?(Loc(a)|0)!=0:0){b=a+4|0;c=f[b>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[b>>2]=c+1;d=h[c>>0]|0}else d=Ooc(a)|0;e=d}else g=3;do if((g|0)==3){d=a+4|0;c=f[d>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[d>>2]=c+1;e=h[c>>0]|0;break}else{e=Ooc(a)|0;break}}while(0);return e|0}function eqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=Qoc(a,b,e)|0;u=d;return c|0}function fqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;a:do if(!c)i=0;else{do if(d|0){j=(a|0)==0?g:a;k=b[c>>0]|0;if(k<<24>>24>-1){f[j>>2]=k&255;i=k<<24>>24!=0&1;break a}k=(hqc()|0)+188|0;l=b[c>>0]|0;if(!(f[f[k>>2]>>2]|0)){f[j>>2]=l<<24>>24&57343;i=1;break a}k=(l&255)+-194|0;if(k>>>0<=50){l=c+1|0;m=f[178104+(k<<2)>>2]|0;if(d>>>0<4?m&-2147483648>>>((d*6|0)+-6|0)|0:0)break;k=h[l>>0]|0;l=k>>>3;if((l+-16|l+(m>>26))>>>0<=7){l=k+-128|m<<6;if((l|0)>=0){f[j>>2]=l;i=2;break a}m=(h[c+2>>0]|0)+-128|0;if(m>>>0<=63){k=m|l<<6;if((k|0)>=0){f[j>>2]=k;i=3;break a}l=(h[c+3>>0]|0)+-128|0;if(l>>>0<=63){f[j>>2]=l|k<<6;i=4;break a}}}}}while(0);k=zoc()|0;f[k>>2]=84;i=-1}while(0);u=e;return i|0}function gqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=Opc(a,b,c,g)|0;u=e;return d|0}function hqc(){return Boc()|0}function iqc(a){a=a|0;var b=0;b=a;while(1)if(!(f[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function jqc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;a:do if(!a){h=f[c>>2]|0;i=f[h>>2]|0;if(!i)j=0;else{k=h;h=0;l=i;while(1){if(l>>>0>127){i=epc(g,l,0)|0;if((i|0)==-1){j=-1;break a}else m=i}else m=1;i=m+h|0;k=k+4|0;l=f[k>>2]|0;if(!l){j=i;break}else h=i}}}else{b:do if(d>>>0>3){h=a;l=d;k=f[c>>2]|0;while(1){i=f[k>>2]|0;if((i+-1|0)>>>0>126){if(!i)break;n=epc(h,i,0)|0;if((n|0)==-1){j=-1;break a}o=h+n|0;p=l-n|0;q=k}else{b[h>>0]=i;o=h+1|0;p=l+-1|0;q=f[c>>2]|0}k=q+4|0;f[c>>2]=k;if(p>>>0<=3){r=o;s=p;break b}else{h=o;l=p}}b[h>>0]=0;f[c>>2]=0;j=d-l|0;break a}else{r=a;s=d}while(0);if(s){k=r;i=s;n=f[c>>2]|0;while(1){t=f[n>>2]|0;if((t+-1|0)>>>0>126){if(!t){v=19;break}w=epc(g,t,0)|0;if((w|0)==-1){j=-1;break a}if(i>>>0<w>>>0){v=22;break}epc(k,f[n>>2]|0,0)|0;x=k+w|0;y=i-w|0;z=n}else{b[k>>0]=t;x=k+1|0;y=i+-1|0;z=f[c>>2]|0}n=z+4|0;f[c>>2]=n;if(!y){j=d;break a}else{k=x;i=y}}if((v|0)==19){b[k>>0]=0;f[c>>2]=0;j=d-i|0;break}else if((v|0)==22){j=d-i|0;break}}else j=d}while(0);u=e;return j|0}function kqc(a,b){a=a|0;b=b|0;lqc(a,b)|0;return a|0}function lqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=c;a:do if(!((d^a)&3)){if(!(d&3)){e=c;g=a}else{h=c;i=a;while(1){j=b[h>>0]|0;b[i>>0]=j;if(!(j<<24>>24)){k=i;break a}j=h+1|0;l=i+1|0;if(!(j&3)){e=j;g=l;break}else{h=j;i=l}}}i=f[e>>2]|0;if(!((i&-2139062144^-2139062144)&i+-16843009)){h=g;l=e;j=i;while(1){i=l+4|0;m=h+4|0;f[h>>2]=j;j=f[i>>2]|0;if((j&-2139062144^-2139062144)&j+-16843009|0){n=i;o=m;break}else{h=m;l=i}}}else{n=e;o=g}p=n;q=o;r=8}else{p=c;q=a;r=8}while(0);if((r|0)==8){r=b[p>>0]|0;b[q>>0]=r;if(!(r<<24>>24))k=q;else{r=q;q=p;while(1){q=q+1|0;p=r+1|0;a=b[q>>0]|0;b[p>>0]=a;if(!(a<<24>>24)){k=p;break}else r=p}}}return k|0}function mqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if((f[d+76>>2]|0)>-1)e=Loc(d)|0;else e=0;g=c+-1|0;i=(g|0)!=0;if((c|0)<2){c=d+74|0;j=b[c>>0]|0;b[c>>0]=j+255|j;if(e|0)Moc(d);if(i)k=0;else{b[a>>0]=0;k=a}}else{a:do if(i){j=d+4|0;c=d+8|0;l=g;m=a;while(1){n=f[j>>2]|0;o=n;p=(f[c>>2]|0)-o|0;q=Zoc(n,10,p)|0;r=(q|0)==0;s=r?p:1-o+q|0;q=s>>>0<l>>>0?s:l;dJc(m|0,n|0,q|0)|0;n=(f[j>>2]|0)+q|0;f[j>>2]=n;t=m+q|0;s=l-q|0;if(!(r&(s|0)!=0)){u=t;v=17;break a}if(n>>>0>=(f[c>>2]|0)>>>0){r=Ooc(d)|0;if((r|0)<0)break;else w=r}else{f[j>>2]=n+1;w=h[n>>0]|0}l=s+-1|0;s=t+1|0;b[t>>0]=w;if(!((l|0)!=0&(w&255|0)!=10)){u=s;v=17;break a}else m=s}if((t|0)!=(a|0)?(f[d>>2]&16|0)!=0:0){u=t;v=17}else x=0}else{u=a;v=17}while(0);if((v|0)==17)if(!a)x=0;else{b[u>>0]=0;x=a}if(!e)k=x;else{Moc(d);k=x}}return k|0}function nqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;do if((a|0)!=-1){if((f[c+76>>2]|0)>-1)d=Loc(c)|0;else d=0;e=c+4|0;g=f[e>>2]|0;if(!g){Poc(c)|0;h=f[e>>2]|0;i=(d|0)!=0;if(!h)j=i;else{k=h;l=i;m=7}}else{k=g;l=(d|0)!=0;m=7}if((m|0)==7)if(k>>>0>((f[c+44>>2]|0)+-8|0)>>>0){g=k+-1|0;f[e>>2]=g;b[g>>0]=a;f[c>>2]=f[c>>2]&-17;if(!l){n=a;break}Moc(c);n=a;break}else j=l;if(j){Moc(c);n=-1}else n=-1}else n=-1;while(0);return n|0}function oqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+128|0;e=d;g=e;h=g+124|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e+32>>2]=309;f[e+44>>2]=a;f[e+76>>2]=-1;f[e+84>>2]=a;a=ppc(e,b,c)|0;u=d;return a|0}function pqc(a,b,c){a=a|0;b=b|0;c=c|0;return qqc(a,b,c)|0}function qqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+84|0;e=f[d>>2]|0;g=c+256|0;h=Zoc(e,0,g)|0;i=(h|0)==0?g:h-e|0;h=i>>>0<c>>>0?i:c;dJc(b|0,e|0,h|0)|0;f[a+4>>2]=e+h;b=e+i|0;f[a+8>>2]=b;f[d>>2]=b;return h|0}function rqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=oqc(a,b,e)|0;u=d;return c|0}function sqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a&255;e=a&255;if((f[c+76>>2]|0)>=0?(Loc(c)|0)!=0:0){if((e|0)!=(b[c+75>>0]|0)?(g=c+20|0,h=f[g>>2]|0,h>>>0<(f[c+16>>2]|0)>>>0):0){f[g>>2]=h+1;b[h>>0]=d;i=e}else i=Kpc(c,a)|0;Moc(c);j=i}else k=3;do if((k|0)==3){if((e|0)!=(b[c+75>>0]|0)?(i=c+20|0,h=f[i>>2]|0,h>>>0<(f[c+16>>2]|0)>>>0):0){f[i>>2]=h+1;b[h>>0]=d;j=e;break}j=Kpc(c,a)|0}while(0);return j|0}function tqc(a,b,c){a=a|0;b=b|0;c=c|0;return Opc(a,2147483647,b,c)|0}function uqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((f[a+76>>2]|0)>-1){d=(Loc(a)|0)==0;e=vqc(a,b,c)|0;if(d)g=e;else{Moc(a);g=e}}else g=vqc(a,b,c)|0;return g|0}function vqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((c|0)==1)d=b-(f[a+8>>2]|0)+(f[a+4>>2]|0)|0;else d=b;b=a+20|0;e=a+28|0;if((f[b>>2]|0)>>>0>(f[e>>2]|0)>>>0?(hj[f[a+36>>2]&511](a,0,0)|0,(f[b>>2]|0)==0):0)g=-1;else{f[a+16>>2]=0;f[e>>2]=0;f[b>>2]=0;if((hj[f[a+40>>2]&511](a,d,c)|0)<0)g=-1;else{f[a+8>>2]=0;f[a+4>>2]=0;f[a>>2]=f[a>>2]&-17;g=0}}return g|0}function wqc(a){a=a|0;var b=0,c=0,d=0;b=(Mpc(a)|0)+1|0;c=ooc(b)|0;if(!c)d=0;else{dJc(c|0,a|0,b|0)|0;d=c}return d|0}function xqc(a){a=a|0;var c=0,d=0,e=0,f=0;c=(Wpc(a,43)|0)==0;d=b[a>>0]|0;e=c?d<<24>>24!=114&1:2;c=(Wpc(a,120)|0)==0;f=c?e:e|128;e=(Wpc(a,101)|0)==0;a=e?f:f|524288;f=d<<24>>24==114?a:a|64;a=d<<24>>24==119?f|512:f;return (d<<24>>24==97?a|1024:a)|0}function yqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;if(Zoc(514180,b[c>>0]|0,4)|0){i=xqc(c)|0;f[h>>2]=a;f[h+4>>2]=i|32768;f[h+8>>2]=438;a=yoc(Oe(5,h|0)|0)|0;if((a|0)>=0){if(i&524288|0){f[g>>2]=a;f[g+4>>2]=2;f[g+8>>2]=1;Bd(221,g|0)|0}g=Vpc(a,c)|0;if(!g){f[e>>2]=a;Ne(6,e|0)|0;j=0}else j=g}else j=0}else{g=zoc()|0;f[g>>2]=22;j=0}u=d;return j|0}function zqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=Opc(0,0,b,e)|0;if((g|0)>=0?(e=g+1|0,g=ooc(e)|0,f[a>>2]=g,(g|0)!=0):0)h=Opc(g,e,b,c)|0;else h=-1;u=d;return h|0}function Aqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=tqc(a,b,e)|0;u=d;return c|0}function Bqc(a,b){a=a|0;b=b|0;var c=0;c=Zoc(a,0,b)|0;return ((c|0)==0?b:c-a|0)|0}function Cqc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+1040|0;h=g+8|0;i=g;j=f[b>>2]|0;f[i>>2]=j;k=(a|0)!=0;l=k?d:256;d=k?a:h;a=j;a:do if((l|0)!=0&(j|0)!=0){m=0;n=c;o=l;p=d;q=a;while(1){r=n>>>2;s=r>>>0>=o>>>0;if(!(n>>>0>131|s)){t=p;v=m;w=n;x=o;y=q;break a}z=s?o:r;A=n-z|0;r=Dqc(p,i,z,e)|0;if((r|0)==-1)break;z=(p|0)==(h|0);s=o-(z?0:r)|0;B=z?p:p+(r<<2)|0;z=r+m|0;r=f[i>>2]|0;if((s|0)!=0&(r|0)!=0){m=z;n=A;o=s;p=B;q=r}else{t=B;v=z;w=A;x=s;y=r;break a}}t=p;v=-1;w=A;x=0;y=f[i>>2]|0}else{t=d;v=0;w=c;x=l;y=a}while(0);b:do if((y|0)!=0?(x|0)!=0&(w|0)!=0:0){a=v;l=w;c=t;d=x;A=y;while(1){C=vpc(c,A,l,e)|0;if((C+2|0)>>>0<3)break;A=(f[i>>2]|0)+C|0;f[i>>2]=A;l=l-C|0;d=d+-1|0;h=a+1|0;if(!((d|0)!=0&(l|0)!=0)){D=h;break b}else{a=h;c=c+4|0}}switch(C|0){case -1:{D=-1;break b;break}case 0:{f[i>>2]=0;D=a;break b;break}default:{f[e>>2]=0;D=a;break b}}}else D=v;while(0);if(k)f[b>>2]=f[i>>2];u=g;return D|0}function Dqc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;g=f[c>>2]|0;if((e|0)!=0?(i=f[e>>2]|0,(i|0)!=0):0)if(!a){j=i;k=g;l=d;m=25}else{f[e>>2]=0;n=i;o=a;p=d;q=g;m=43}else m=5;a:do if((m|0)==5){i=(Eqc()|0)+188|0;e=(a|0)!=0;if(f[f[i>>2]>>2]|0)if(e){r=a;s=d;t=g;m=15;break}else{u=g;v=d;m=14;break}if(!e){w=Mpc(g)|0;m=59;break}b:do if(!d)x=g;else{e=g;i=a;y=d;while(1){z=b[e>>0]|0;if(!(z<<24>>24))break;A=e+1|0;f[i>>2]=z<<24>>24&57343;z=y+-1|0;if(!z){x=A;break b}else{e=A;i=i+4|0;y=z}}f[i>>2]=0;f[c>>2]=0;w=d-y|0;m=59;break a}while(0);f[c>>2]=x;w=d;m=59}while(0);c:while(1){d:do if((m|0)==14){m=0;x=u;g=v;while(1){e=b[x>>0]|0;if(((e&255)+-1|0)>>>0<127?(x&3|0)==0:0){z=f[x>>2]|0;A=z&255;if(!((z+-16843009|z)&-2139062144)){z=x;B=g;do{z=z+4|0;B=B+-4|0;C=f[z>>2]|0}while(!((C+-16843009|C)&-2139062144|0));D=z;E=B;F=C&255}else{D=x;E=g;F=A}}else{D=x;E=g;F=e}G=F&255;if((G+-1|0)>>>0>=127)break;x=D+1|0;g=E+-1|0}g=G+-194|0;if(g>>>0>50){H=D;I=a;J=E;m=53}else{j=f[178104+(g<<2)>>2]|0;k=D+1|0;l=E;m=25;continue c}}else if((m|0)==15){m=0;e:do if(!s)K=t;else{g=r;x=s;y=t;while(1){i=b[y>>0]|0;do if(((i&255)+-1|0)>>>0<127?x>>>0>4&(y&3|0)==0:0){L=g;M=x;N=y;while(1){O=f[N>>2]|0;if((O+-16843009|O)&-2139062144|0){m=38;break}f[L>>2]=O&255;f[L+4>>2]=h[N+1>>0];f[L+8>>2]=h[N+2>>0];P=N+4|0;Q=L+16|0;f[L+12>>2]=h[N+3>>0];R=M+-4|0;if(R>>>0>4){L=Q;M=R;N=P}else{m=37;break}}if((m|0)==37){m=0;S=Q;T=R;U=P;V=b[P>>0]|0;break}else if((m|0)==38){m=0;S=L;T=M;U=N;V=O&255;break}}else{S=g;T=x;U=y;V=i}while(0);W=V&255;if((W+-1|0)>>>0>=127)break;i=U+1|0;f[S>>2]=W;x=T+-1|0;if(!x){K=i;break e}else{g=S+4|0;y=i}}y=W+-194|0;if(y>>>0>50){H=U;I=S;J=T;m=53;break d}n=f[178104+(y<<2)>>2]|0;o=S;p=T;q=U+1|0;m=43;continue c}while(0);f[c>>2]=K;w=d;m=59;continue c}else if((m|0)==25){m=0;y=(h[k>>0]|0)>>>3;if((y+-16|y+(j>>26))>>>0>7){X=a;Y=j;Z=k;_=l;m=52}else{y=k+1|0;if(j&33554432){if((b[y>>0]&-64)<<24>>24!=-128){X=a;Y=j;Z=k;_=l;m=52;break}g=k+2|0;if(!(j&524288))$=g;else{if((b[g>>0]&-64)<<24>>24!=-128){X=a;Y=j;Z=k;_=l;m=52;break}$=k+3|0}}else $=y;u=$;v=l+-1|0;m=14;continue c}}else if((m|0)==43){m=0;y=h[q>>0]|0;g=y>>>3;if((g+-16|g+(n>>26))>>>0>7){X=o;Y=n;Z=q;_=p;m=52}else{g=q+1|0;x=y+-128|n<<6;do if((x|0)<0){y=(h[g>>0]|0)+-128|0;if(y>>>0>63){aa=q+-1|0;ba=o;break d}e=q+2|0;A=y|x<<6;if((A|0)<0){y=(h[e>>0]|0)+-128|0;if(y>>>0>63){aa=q+-1|0;ba=o;break d}else{ca=q+3|0;da=y|A<<6;break}}else{ca=e;da=A}}else{ca=g;da=x}while(0);f[o>>2]=da;r=o+4|0;s=p+-1|0;t=ca;m=15;continue c}}else if((m|0)==59){m=0;return w|0}while(0);if((m|0)==52){m=0;x=Z+-1|0;if(!Y){H=x;I=X;J=_;m=53}else{aa=x;ba=X}}if((m|0)==53){m=0;if(!(b[H>>0]|0)){if(I|0){f[I>>2]=0;f[c>>2]=0}w=d-J|0;m=59;continue}else{aa=H;ba=I}}x=zoc()|0;f[x>>2]=84;if(!ba){w=-1;m=59;continue}f[c>>2]=aa;w=-1;m=59}return 0}function Eqc(){return Boc()|0}function Fqc(a){a=a|0;var b=0;if((f[a+76>>2]|0)>-1){b=(Loc(a)|0)==0;vqc(a,0,0)|0;f[a>>2]=f[a>>2]&-33;if(!b)Moc(a)}else{vqc(a,0,0)|0;f[a>>2]=f[a>>2]&-33}return}function Gqc(a,b,c){a=a|0;b=b|0;c=c|0;return uqc(a,b,c)|0}function Hqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Iqc(a,b,c,-1,0)|0;return d|0}function Iqc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+128|0;h=g;f[h>>2]=0;i=h+4|0;f[i>>2]=a;f[h+44>>2]=a;j=h+8|0;f[j>>2]=(a|0)<0?-1:a+2147483647|0;f[h+76>>2]=-1;rpc(h,0);k=xpc(h,c,1,d,e)|0;if(b|0)f[b>>2]=a+((f[i>>2]|0)+(f[h+108>>2]|0)-(f[j>>2]|0));u=g;return k|0}function Jqc(a){a=a|0;var b=0;b=(Kqc(a)|0)==0;return (b?a:a|32)|0}function Kqc(a){a=a|0;return (a+-65|0)>>>0<26|0}function Lqc(a){a=a|0;var b=0;b=(Mqc(a)|0)==0;return (b?a:a&95)|0}function Mqc(a){a=a|0;return (a+-97|0)>>>0<26|0}function Nqc(a,b){a=a|0;b=b|0;return (a+-48|0)>>>0<10|0}function Oqc(a){a=a|0;if(Pqc(a)|0)poc(a);return}function Pqc(a){a=a|0;return (a|0)!=178080&((a|0)!=0&(a|0)!=884136)&1|0}function Qqc(a,b){a=a|0;b=b|0;return -1|0}function Rqc(a){a=a|0;var b=0,c=0;b=(Sqc()|0)+188|0;c=f[b>>2]|0;if(a|0)f[b>>2]=(a|0)==(-1|0)?884112:a;return ((c|0)==884112?-1:c)|0}function Sqc(){return Boc()|0}function Tqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+272|0;e=d+8|0;g=d;do if(!(b[c>>0]|0)){h=jf(514184)|0;if(h|0?b[h>>0]|0:0){i=h;break}h=jf(514191+(a*12|0)|0)|0;if(h|0?b[h>>0]|0:0){i=h;break}h=jf(514263)|0;if(h|0?b[h>>0]|0:0){i=h;break}i=514268}else i=c;while(0);c=0;a:while(1){switch(b[i+c>>0]|0){case 47:case 0:{j=c;break a;break}default:{}}h=c+1|0;if(h>>>0<15)c=h;else{j=h;break}}c=b[i>>0]|0;if(c<<24>>24!=46?(b[i+j>>0]|0)==0:0)if(c<<24>>24==67){k=i;l=15}else{m=i;l=16}else{k=514268;l=15}if((l|0)==15)if(!(b[k+1>>0]|0)){n=k;l=18}else{m=k;l=16}b:do if((l|0)==16)if((Ioc(m,514268)|0)!=0?(Ioc(m,514276)|0)!=0:0){k=f[221044]|0;if(k|0){i=k;do{if(!(Ioc(m,i+8|0)|0)){o=i;break b}i=f[i+24>>2]|0}while((i|0)!=0)}Df(884180);i=f[221044]|0;c:do if(i|0){k=i;while(1){if(!(Ioc(m,k+8|0)|0))break;c=f[k+24>>2]|0;if(!c)break c;else k=c}cg(884180);o=k;break b}while(0);d:do if(((f[221020]|0)==0?(i=jf(514282)|0,(i|0)!=0):0)?(b[i>>0]|0)!=0:0){c=254-j|0;h=j+1|0;p=i;while(1){i=Zpc(p,58)|0;q=b[i>>0]|0;r=((q<<24>>24!=0)<<31>>31)+(i-p)|0;if(r>>>0<c>>>0){dJc(e|0,p|0,r|0)|0;s=e+r|0;b[s>>0]=47;dJc(s+1|0,m|0,j|0)|0;b[e+(h+r)>>0]=0;t=og(e|0,g|0)|0;if(t|0)break;v=b[i>>0]|0}else v=q;p=i+(v<<24>>24!=0&1)|0;if(!(b[p>>0]|0)){l=41;break d}}p=ooc(28)|0;h=f[g>>2]|0;if(!p){Uqc(t,h)|0;l=41;break}else{f[p>>2]=t;f[p+4>>2]=h;h=p+8|0;dJc(h|0,m|0,j|0)|0;b[h+j>>0]=0;f[p+24>>2]=f[221044];f[221044]=p;w=p;break}}else l=41;while(0);if((l|0)==41){p=ooc(28)|0;if(!p)w=p;else{f[p>>2]=f[44508];f[p+4>>2]=f[44509];h=p+8|0;dJc(h|0,m|0,j|0)|0;b[h+j>>0]=0;f[p+24>>2]=f[221044];f[221044]=p;w=p}}cg(884180);o=(a|0)==0&(w|0)==0?178032:w}else{n=m;l=18}while(0);do if((l|0)==18){if((a|0)==0?(b[n+1>>0]|0)==46:0){o=178032;break}o=0}while(0);u=d;return o|0}function Uqc(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Vqc();f[d>>2]=a;f[d+4>>2]=b;b=yoc(De(91,d|0)|0)|0;u=c;return b|0}function Vqc(){return}function Wqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!d)e=0;else{f=b[a>>0]|0;g=f&255;h=b[c>>0]|0;i=h&255;a:do if(!(f<<24>>24)){j=i;k=g}else{l=a;m=d;n=c;o=f;p=i;q=g;r=h;while(1){m=m+-1|0;if(!(o<<24>>24==r<<24>>24&((m|0)!=0&r<<24>>24!=0))){j=p;k=q;break a}l=l+1|0;n=n+1|0;o=b[l>>0]|0;s=o&255;r=b[n>>0]|0;t=r&255;if(!(o<<24>>24)){j=t;k=s;break}else{p=t;q=s}}}while(0);e=k-j|0}return e|0}function Xqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return d|0}function Yqc(a,b){a=a|0;b=b|0;return Zqc(a)|0}function Zqc(a){a=a|0;return ((a+-48|0)>>>0<10|((a|32)+-97|0)>>>0<6)&1|0}function _qc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c|0){d=c;c=b;b=a;while(1){d=d+-1|0;f[b>>2]=f[c>>2];if(!d)break;else{c=c+4|0;b=b+4|0}}}return a|0}function $qc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;a:do if(!(Pqc(c)|0)){g=(c|0)==0;h=0;i=0;do{j=(1<<i&a|0)!=0;if(g|j)k=Tqc(i,j?b:1154740)|0;else k=f[c+(i<<2)>>2]|0;h=((k|0)!=0&1)+h|0;f[e+(i<<2)>>2]=k;i=i+1|0}while((i|0)!=6);switch(h|0){case 0:{l=884136;break a;break}case 1:{if((f[e>>2]|0)==178032){l=178080;break a}break}default:{}}l=c}else{i=0;do{if(1<<i&a|0){g=Tqc(i,b)|0;f[c+(i<<2)>>2]=g}i=i+1|0}while((i|0)!=6);l=c}while(0);u=d;return l|0}function arc(a){a=a|0;return 0}function brc(a){a=+a;var b=0,c=0,d=0,e=0,g=0.0,h=0.0,i=0,j=0.0,k=0.0,l=0,m=0,n=0.0,o=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2147483647;d=aJc(f[s>>2]|0,b|0,63)|0;do if(c>>>0>1078159481){b=crc(a)|0;e=J&2147483647;if(!(e>>>0>2146435072|(e|0)==2146435072&b>>>0>0))if(!d)if(a>709.782712893384)g=a*8988465674311579538646525.0e283;else{h=.5;i=12}else g=-1.0;else g=a}else{if(c>>>0<=1071001154)if(c>>>0<1016070144){g=a;break}else{j=a;k=0.0;l=0;i=15;break}b=(d|0)!=0;if(c>>>0>=1072734898){h=b?-.5:.5;i=12;break}if(b){m=-1;n=a+.6931471803691238;o=-1.9082149292705877e-10;i=13;break}else{m=1;n=a+-.6931471803691238;o=1.9082149292705877e-10;i=13;break}}while(0);if((i|0)==12){c=~~(a*1.4426950408889634+h);h=+(c|0);m=c;n=a-h*.6931471803691238;o=h*1.9082149292705877e-10;i=13}if((i|0)==13){h=n-o;j=h;k=n-h-o;l=m;i=15}a:do if((i|0)==15){o=j*.5;h=j*o;n=h*(h*(h*(h*(4.008217827329362e-06-h*2.0109921818362437e-07)+-7.93650757867488e-05)+1.5873015872548146e-03)+-.03333333333333313)+1.0;a=3.0-o*n;o=h*((n-a)/(6.0-j*a));if(!l){g=j-(j*o-h);break}a=j*(o-k)-k-h;switch(l|0){case -1:{g=(j-a)*.5+-.5;break a;break}case 1:{if(j<-.25){g=(a-(j+.5))*-2.0;break a}else{g=(j-a)*2.0+1.0;break a}break}default:{m=jJc(l+1023|0,0,52)|0;c=J;f[s>>2]=m;f[s+4>>2]=c;h=+p[s>>3];if(l>>>0>56){o=j-a+1.0;g=((l|0)==1024?o*2.0*8988465674311579538646525.0e283:h*o)+-1.0;break a}else{c=jJc(1023-l|0,0,52)|0;m=J;d=(l|0)<20;f[s>>2]=c;f[s+4>>2]=m;o=+p[s>>3];g=h*((d?1.0-o:1.0)+(j-(d?a:o+a)));break a}}}}while(0);return +g}function crc(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function drc(a){a=a|0;return 0}function erc(a){a=a|0;return 0}function frc(a){a=+a;var b=0,c=0,d=0.0,e=0.0;b=(n[s>>2]=a,f[s>>2]|0);if((b&2130706432)>>>0<=1249902592){c=(b|0)<0;d=(c?8388608.0:-8388608.0)+((c?-8388608.0:8388608.0)+a);if(d==0.0)e=c?-0.0:0.0;else e=d}else e=a;return +e}function grc(a){a=+a;var b=0,c=0,d=0.0,e=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){c=(b|0)<0;d=(c?4503599627370496.0:-4503599627370496.0)+((c?-4503599627370496.0:4503599627370496.0)+a);if(d==0.0)e=c?-0.0:0.0;else e=d}else e=a;return +e}function hrc(a){a=+a;var b=0,c=0,d=0.0,e=0.0;b=(n[s>>2]=a,f[s>>2]|0);c=b&2147483647;a=(f[s>>2]=c,+n[s>>2]);do if(c>>>0>1057791828)if(c>>>0>1092616192){d=0.0/a+1.0;break}else{d=1.0-2.0/(+irc(a*2.0)+2.0);break}else{if(c>>>0>1048757624){e=+irc(a*2.0);d=e/(e+2.0);break}if(c>>>0>8388607){e=+irc(a*-2.0);d=-e/(e+2.0)}else d=a}while(0);return +((b|0)<0?-d:d)}function irc(a){a=+a;var b=0,c=0,d=0,e=0.0,g=0.0,h=0,i=0.0,j=0.0,k=0,l=0,m=0.0,o=0.0;b=(n[s>>2]=a,f[s>>2]|0);c=b&2147483647;d=b>>>31;do if(c>>>0>1100331075)if(c>>>0<=2139095040)if(!d)if(a>88.7216796875)e=a*1701411834604692317316873.0e14;else{g=.5;h=12}else e=-1.0;else e=a;else{if(c>>>0<=1051816472)if(c>>>0<855638016){e=a;break}else{i=a;j=0.0;k=0;h=15;break}b=(d|0)!=0;if(c>>>0>=1065686418){g=b?-.5:.5;h=12;break}if(b){l=-1;m=a+.6931381225585938;o=-9.05800061445916e-06;h=13;break}else{l=1;m=a+-.6931381225585938;o=9.05800061445916e-06;h=13;break}}while(0);if((h|0)==12){c=~~(a*1.4426950216293335+g);g=+(c|0);l=c;m=a-g*.6931381225585938;o=g*9.05800061445916e-06;h=13}if((h|0)==13){g=m-o;i=g;j=m-g-o;k=l;h=15}a:do if((h|0)==15){o=i*.5;g=i*o;m=g*(g*1.5807170420885086e-03+-.03333321213722229)+1.0;a=3.0-o*m;o=g*((m-a)/(6.0-i*a));if(!k){e=i-(i*o-g);break}a=i*(o-j)-j-g;switch(k|0){case -1:{e=(i-a)*.5+-.5;break a;break}case 1:{if(i<-.25){e=(a-(i+.5))*-2.0;break a}else{e=(i-a)*2.0+1.0;break a}break}default:{g=(f[s>>2]=(k<<23)+1065353216,+n[s>>2]);if(k>>>0>56){o=i-a+1.0;e=((k|0)==128?o*2.0*1701411834604692317316873.0e14:g*o)+-1.0;break a}else{l=(k|0)<23;o=(f[s>>2]=127-k<<23,+n[s>>2]);e=g*((l?1.0-o:1.0)+(i-(l?a:o+a)));break a}}}}while(0);return +e}function jrc(a,b){a=+a;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;e=aJc(c|0,d|0,52)|0;g=e&2047;e=g+-1023|0;if((e|0)>51){p[b>>3]=a;f[s>>2]=0;f[s+4>>2]=d&-2147483648;return +((c|0)==0&(d&1048575|0)==0|(e|0)!=1024?+p[s>>3]:a)}do if(g>>>0>=1023){h=aJc(-1,1048575,e|0)|0;i=J;if((h&c|0)==0&(i&d|0)==0){p[b>>3]=a;f[s>>2]=0;f[s+4>>2]=d&-2147483648;j=+p[s>>3];break}else{k=c&~h;h=d&~i;f[s>>2]=k;f[s+4>>2]=h;l=+p[s>>3];i=b;f[i>>2]=k;f[i+4>>2]=h;j=a-l;break}}else{h=b;f[h>>2]=0;f[h+4>>2]=d&-2147483648;j=a}while(0);return +j}function krc(a){a=+a;var b=0,c=0,d=0,e=0.0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,t=0.0;p[s>>3]=a;b=f[s>>2]|0;c=f[s+4>>2]|0;d=(c|0)<0;do if(d|c>>>0<1048576){if((b|0)==0&(c&2147483647|0)==0){e=-1.0/(a*a);break}if(d){e=(a-a)/0.0;break}else{p[s>>3]=a*18014398509481984.0;g=f[s+4>>2]|0;h=-1077;i=g;j=f[s>>2]|0;k=g;l=9;break}}else if(c>>>0<=2146435071)if((b|0)==0&0==0&(c|0)==1072693248)e=0.0;else{h=-1023;i=c;j=b;k=c;l=9}else e=a;while(0);if((l|0)==9){l=i+614242|0;f[s>>2]=j;f[s+4>>2]=(l&1048575)+1072079006;a=+p[s>>3]+-1.0;m=a*(a*.5);n=a/(a+2.0);o=n*n;q=o*o;p[s>>3]=a-m;j=f[s+4>>2]|0;f[s>>2]=0;f[s+4>>2]=j;r=+p[s>>3];t=a-r-m+n*(m+(q*(q*(q*.15313837699209373+.22222198432149784)+.3999999999940942)+o*(q*(q*(q*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)));q=r*.4342944818781689;o=+(h+(l>>>20)|0);m=o*.30102999566361177;n=m+q;e=n+(q+(m-n)+(t*.4342944818781689+(o*3.694239077158931e-13+(r+t)*2.5082946711645275e-11)))}return +e}function lrc(a){a=+a;var b=0,c=0,d=0.0,e=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2147483647;f[s>>2]=f[s>>2];f[s+4>>2]=c;a=+p[s>>3];do if(c>>>0>1071748074)if(c>>>0>1077149696){d=1.0-0.0/a;break}else{d=1.0-2.0/(+brc(a*2.0)+2.0);break}else{if(c>>>0>1070618798){e=+brc(a*2.0);d=e/(e+2.0);break}if(c>>>0>1048575){e=+brc(a*-2.0);d=-e/(e+2.0)}else d=a}while(0);return +((b|0)<0?-d:d)}function mrc(a){a=+a;return ~~+frc(a)|0}function nrc(a){a=+a;var b=0,c=0.0;b=drc(32)|0;c=+grc(a);return ~~c|0}function orc(a,b){a=a|0;b=b|0;return +(+prc(a,b,0))}function prc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0;d=u;u=u+128|0;e=d;g=e;h=g+124|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=e+4|0;f[g>>2]=a;h=e+8|0;f[h>>2]=-1;f[e+44>>2]=a;f[e+76>>2]=-1;rpc(e,0);i=+ypc(e,c,1);c=(f[g>>2]|0)-(f[h>>2]|0)+(f[e+108>>2]|0)|0;if(b|0)f[b>>2]=c|0?a+c|0:a;u=d;return +i}function qrc(a,b){a=a|0;b=b|0;return +(+prc(a,b,1))}function rrc(a,b){a=a|0;b=b|0;return +(+prc(a,b,2))}function src(a,b,c){a=a|0;b=b|0;c=c|0;return +(+orc(a,b))}function trc(a,b,c){a=a|0;b=b|0;c=c|0;return +(+qrc(a,b))}function urc(a,b,c){a=a|0;b=b|0;c=c|0;return +(+rrc(a,b))}function vrc(a){a=a|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a;while(1){d=b[c>>0]|0;e=d<<24>>24;f=c+1|0;if(!(qpc(e)|0))break;else c=f}switch(e|0){case 45:{g=1;h=5;break}case 43:{g=0;h=5;break}default:{i=0;j=c;k=d}}if((h|0)==5){i=g;j=f;k=b[f>>0]|0}f=(k<<24>>24)+-48|0;if(f>>>0<10){k=0;g=j;j=f;while(1){g=g+1|0;f=(k*10|0)-j|0;j=(b[g>>0]|0)+-48|0;if(j>>>0>=10){l=f;break}else k=f}}else l=0;return (i|0?l:0-l|0)|0}function wrc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Iqc(a,b,c,-1,-1)|0;return d|0}function xrc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Iqc(a,b,c,0,-2147483648)|0;return d|0}function yrc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Iqc(a,b,c,-2147483648,0)|0;return d|0}function zrc(a){a=a|0;return +(+qrc(a,0))}function Arc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;a:do if(!d)e=0;else{f=a;g=d;h=c;while(1){i=b[f>>0]|0;j=b[h>>0]|0;if(i<<24>>24!=j<<24>>24)break;g=g+-1|0;if(!g){e=0;break a}else{f=f+1|0;h=h+1|0}}e=(i&255)-(j&255)|0}while(0);return e|0}function Brc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;e=c&255;c=d;while(1){if(!c){f=0;break}c=c+-1|0;d=a+c|0;if((b[d>>0]|0)==e<<24>>24){f=d;break}}return f|0}function Crc(a,b){a=a|0;b=b|0;return Brc(a,b,(Mpc(a)|0)+1|0)|0}function Drc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c|0){d=c;c=a;while(1){d=d+-1|0;f[c>>2]=b;if(!d)break;else c=c+4|0}}return a|0}function Erc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;d=b[c>>0]|0;do if(d<<24>>24){e=Wpc(a,d<<24>>24)|0;if(e)if(b[c+1>>0]|0)if(b[e+1>>0]|0){if(!(b[c+2>>0]|0)){f=Frc(e,c)|0;break}if(b[e+2>>0]|0){if(!(b[c+3>>0]|0)){f=Grc(e,c)|0;break}if(b[e+3>>0]|0)if(!(b[c+4>>0]|0)){f=Hrc(e,c)|0;break}else{f=Irc(e,c)|0;break}else f=0}else f=0}else f=0;else f=e;else f=0}else f=a;while(0);return f|0}function Frc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=(h[c>>0]|0)<<8|(h[c+1>>0]|0);c=h[a>>0]|0;e=a;while(1){a=e+1|0;f=b[a>>0]|0;if(!(f<<24>>24)){g=0;break}c=f&255|c<<8&65280;if((c|0)==(d|0)){g=e;break}else e=a}return g|0}function Grc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0;d=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8;c=a+2|0;e=b[c>>0]|0;f=(h[a+1>>0]|0)<<16|(h[a>>0]|0)<<24|(e&255)<<8;a=e<<24>>24!=0;if((f|0)==(d|0)|a^1){g=c;i=a}else{a=c;c=f;while(1){f=a+1|0;e=b[f>>0]|0;c=(e&255|c)<<8;j=e<<24>>24!=0;if((c|0)==(d|0)|j^1){g=f;i=j;break}else a=f}}return (i?g+-2|0:0)|0}function Hrc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0;d=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8|(h[c+3>>0]|0);c=a+3|0;e=b[c>>0]|0;f=e&255|((h[a+1>>0]|0)<<16|(h[a>>0]|0)<<24|(h[a+2>>0]|0)<<8);a=e<<24>>24!=0;if((f|0)==(d|0)|a^1){g=a;i=c}else{a=c;c=f;while(1){f=a+1|0;e=b[f>>0]|0;c=e&255|c<<8;j=e<<24>>24!=0;if((c|0)==(d|0)|j^1){g=j;i=f;break}else a=f}}return (g?i+-3|0:0)|0}function Irc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+1056|0;e=d+1024|0;g=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;h=b[c>>0]|0;a:do if(h<<24>>24){i=0;j=h;k=h&255;while(1){if(!(b[a+i>>0]|0)){l=0;break a}m=e+(((j&255)>>>5&255)<<2)|0;f[m>>2]=f[m>>2]|1<<(j&31);i=i+1|0;f[g+(k<<2)>>2]=i;m=b[c+i>>0]|0;if(!(m<<24>>24))break;else{j=m;k=m&255}}k=i>>>0>1;if(k){j=0;m=-1;n=1;b:while(1){o=1;p=j;q=n;while(1){r=p;s=q;c:while(1){t=1;v=s;while(1){w=b[c+(t+m)>>0]|0;x=b[c+v>>0]|0;if(w<<24>>24!=x<<24>>24)break c;if((t|0)==(o|0))break;t=t+1|0;y=t+r|0;if(y>>>0>=i>>>0){z=o;A=m;break b}else v=y}t=o+r|0;s=t+1|0;if(s>>>0>=i>>>0){z=o;A=m;break b}else r=t}s=v-m|0;if((w&255)<=(x&255))break;q=v+1|0;if(q>>>0>=i>>>0){z=s;A=m;break b}else{o=s;p=v}}n=r+2|0;if(n>>>0>=i>>>0){z=1;A=r;break}else{j=r+1|0;m=r}}if(k){m=0;j=-1;n=1;while(1){p=1;o=m;q=n;while(1){B=o;s=q;d:while(1){t=1;C=s;while(1){D=b[c+(t+j)>>0]|0;E=b[c+C>>0]|0;if(D<<24>>24!=E<<24>>24)break d;if((t|0)==(p|0))break;t=t+1|0;y=t+B|0;if(y>>>0>=i>>>0){F=z;G=A;H=i;I=p;J=j;K=27;break a}else C=y}t=p+B|0;s=t+1|0;if(s>>>0>=i>>>0){F=z;G=A;H=i;I=p;J=j;K=27;break a}else B=t}s=C-j|0;if((D&255)>=(E&255))break;q=C+1|0;if(q>>>0>=i>>>0){F=z;G=A;H=i;I=s;J=j;K=27;break a}else{p=s;o=C}}n=B+2|0;if(n>>>0>=i>>>0){F=z;G=A;H=i;I=1;J=B;K=27;break}else{m=B+1|0;j=B}}}else{F=z;G=A;H=i;I=1;J=-1;K=27}}else{F=1;G=-1;H=i;I=1;J=-1;K=27}}else{F=1;G=-1;H=0;I=1;J=-1;K=27}while(0);e:do if((K|0)==27){A=(J+1|0)>>>0>(G+1|0)>>>0;z=A?I:F;B=A?J:G;A=B+1|0;if(!(Arc(c,c+z|0,A)|0)){L=H-z|0;M=z}else{z=H-B+-1|0;L=0;M=(B>>>0>z>>>0?B:z)+1|0}z=H|63;C=H+-1|0;E=(L|0)!=0;D=H-M|0;r=a;v=0;x=a;while(1){w=r;do if((x-w|0)>>>0<H>>>0){h=Zoc(x,0,z)|0;if(h)if((h-w|0)>>>0<H>>>0){l=0;break e}else{N=h;break}else{N=x+z|0;break}}else N=x;while(0);w=b[r+C>>0]|0;f:do if(!(1<<(w&31)&f[e+(((w&255)>>>5&255)<<2)>>2])){O=0;P=H}else{h=H-(f[g+((w&255)<<2)>>2]|0)|0;if(h|0){O=0;P=E&(v|0)!=0&h>>>0<M>>>0?D:h;break}h=A>>>0>v>>>0?A:v;j=b[c+h>>0]|0;g:do if(!(j<<24>>24))Q=A;else{m=h;n=j;while(1){if(n<<24>>24!=(b[r+m>>0]|0))break;k=m+1|0;n=b[c+k>>0]|0;if(!(n<<24>>24)){Q=A;break g}else m=k}O=0;P=m-B|0;break f}while(0);while(1){if(Q>>>0<=v>>>0){l=r;break e}Q=Q+-1|0;if((b[c+Q>>0]|0)!=(b[r+Q>>0]|0)){O=L;P=M;break}}}while(0);r=r+P|0;v=O;x=N}}while(0);u=d;return l|0}function Jrc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if(a-b>>2>>>0>=c>>>0){if(c|0){d=b;e=a;g=c;while(1){g=g+-1|0;f[e>>2]=f[d>>2];if(!g)break;else{d=d+4|0;e=e+4|0}}}}else{e=c;do{e=e+-1|0;f[a+(e<<2)>>2]=f[b+(e<<2)>>2]}while((e|0)!=0)}return a|0}function Krc(a,b,c){a=a|0;b=b|0;c=c|0;return vpc(0,a,b,c|0?c:884188)|0}function Lrc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+272|0;g=e+8|0;h=e;i=f[b>>2]|0;f[h>>2]=i;j=(a|0)!=0;k=j?d:256;d=j?a:g;a=i;a:do if((k|0)!=0&(i|0)!=0){l=0;m=c;n=k;o=d;p=a;while(1){q=m>>>0>=n>>>0;if(!(q|m>>>0>32)){r=o;s=l;t=m;v=n;w=p;break a}x=q?n:m;y=m-x|0;q=jqc(o,h,x,0)|0;if((q|0)==-1)break;x=(o|0)==(g|0);z=n-(x?0:q)|0;A=x?o:o+q|0;x=q+l|0;q=f[h>>2]|0;if((z|0)!=0&(q|0)!=0){l=x;m=y;n=z;o=A;p=q}else{r=A;s=x;t=y;v=z;w=q;break a}}r=o;s=-1;t=y;v=0;w=f[h>>2]|0}else{r=d;s=0;t=c;v=k;w=a}while(0);b:do if((w|0)!=0?(v|0)!=0&(t|0)!=0:0){a=s;k=t;c=r;d=v;y=w;while(1){B=epc(c,f[y>>2]|0,0)|0;if((B+1|0)>>>0<2)break;y=(f[h>>2]|0)+4|0;f[h>>2]=y;k=k+-1|0;d=d-B|0;g=B+a|0;if(!((d|0)!=0&(k|0)!=0)){C=g;break b}else{a=g;c=c+B|0}}if(!B){f[h>>2]=0;C=a}else C=-1}else C=s;while(0);if(j)f[b>>2]=f[h>>2];u=e;return C|0}function Mrc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=b;f[e+8>>2]=c;c=yoc(Kf(4,e|0)|0)|0;u=d;return c|0}function Nrc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=b;f[e+8>>2]=c;c=yoc(Ke(3,e|0)|0)|0;u=d;return c|0}function Orc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=wrc(a,b,c)|0;return d|0}function Prc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=xrc(a,b,c)|0;return d|0}function Qrc(){return 178472}function Rrc(){return 178476}function Src(){return 180016}function Trc(){var a=0;a=(Urc()|0)+188|0;return (f[f[a>>2]>>2]|0?4:1)|0}function Urc(){return Boc()|0}function Vrc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=a;a=c;a:while(1){c=a;f=a+-1|0;g=e;while(1){h=g;b:while(1){i=h;j=c-i|0;k=h+1|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((j|0)<31){l=11;break a}m=h+(j>>>1)|0;if((j|0)>999){n=j>>>2;o=Yrc(h,h+n|0,m,m+n|0,f,d)|0}else o=Wrc(h,m,f,d)|0;p=b[h>>0]|0;n=b[m>>0]|0;if(p<<24>>24<n<<24>>24){q=f;r=o;break}else s=f;while(1){s=s+-1|0;if((h|0)==(s|0))break;t=b[s>>0]|0;if(t<<24>>24<n<<24>>24){l=28;break b}}n=b[f>>0]|0;if(p<<24>>24<n<<24>>24)u=k;else{j=k;while(1){if((j|0)==(f|0))break a;v=b[j>>0]|0;w=j+1|0;if(p<<24>>24<v<<24>>24)break;else j=w}b[j>>0]=n;b[f>>0]=v;u=w}if((u|0)==(f|0))break a;else{x=f;y=u}while(1){z=b[h>>0]|0;A=y;while(1){B=b[A>>0]|0;C=A+1|0;if(z<<24>>24<B<<24>>24){D=x;break}else A=C}do{D=D+-1|0;E=b[D>>0]|0}while(z<<24>>24<E<<24>>24);if(A>>>0>=D>>>0){h=A;continue b}b[A>>0]=E;b[D>>0]=B;x=D;y=C}}if((l|0)==28){l=0;b[h>>0]=t;b[s>>0]=p;q=s;r=o+1|0}c:do if(k>>>0<q>>>0){n=m;j=q;z=k;F=r;while(1){G=b[n>>0]|0;H=z;while(1){I=b[H>>0]|0;J=H+1|0;if(I<<24>>24<G<<24>>24)H=J;else{K=j;break}}do{K=K+-1|0;L=b[K>>0]|0}while(L<<24>>24>=G<<24>>24);if(H>>>0>K>>>0){M=n;N=F;O=H;break c}b[H>>0]=L;b[K>>0]=I;n=(n|0)==(H|0)?K:n;j=K;z=J;F=F+1|0}}else{M=m;N=r;O=k}while(0);if((O|0)!=(M|0)?(F=b[M>>0]|0,z=b[O>>0]|0,F<<24>>24<z<<24>>24):0){b[O>>0]=F;b[M>>0]=z;P=N+1|0}else P=N;if(!P){Q=_rc(h,O,d)|0;z=O+1|0;if(_rc(z,a,d)|0){l=45;break}if(Q){g=z;continue}else R=z}else R=O+1|0;z=O;if((z-i|0)>=(c-z|0)){l=44;break}Vrc(h,O,d);g=R}if((l|0)==44){l=0;Vrc(R,a,d);e=h;a=O;continue}else if((l|0)==45){l=0;if(Q)break;else{e=h;a=O;continue}}}if((l|0)==5){O=b[f>>0]|0;e=b[h>>0]|0;if(O<<24>>24<e<<24>>24){b[h>>0]=O;b[f>>0]=e}}else if((l|0)==7)Wrc(h,k,f,d)|0;else if((l|0)==8)Xrc(h,k,h+2|0,f,d)|0;else if((l|0)==9)Yrc(h,k,h+2|0,h+3|0,f,d)|0;else if((l|0)==11)Zrc(h,a,d);return}function Wrc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=b[c>>0]|0;f=b[a>>0]|0;g=b[d>>0]|0;h=g<<24>>24<e<<24>>24;do if(e<<24>>24<f<<24>>24){if(h){b[a>>0]=g;b[d>>0]=f;i=1;break}b[a>>0]=e;b[c>>0]=f;j=b[d>>0]|0;if(j<<24>>24<f<<24>>24){b[c>>0]=j;b[d>>0]=f;i=2}else i=1}else if(h){b[c>>0]=g;b[d>>0]=e;j=b[c>>0]|0;k=b[a>>0]|0;if(j<<24>>24<k<<24>>24){b[a>>0]=j;b[c>>0]=k;i=2}else i=1}else i=0;while(0);return i|0}function Xrc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=Wrc(a,c,d,f)|0;f=b[e>>0]|0;h=b[d>>0]|0;if(f<<24>>24<h<<24>>24){b[d>>0]=f;b[e>>0]=h;h=g+1|0;e=b[d>>0]|0;f=b[c>>0]|0;if(e<<24>>24<f<<24>>24){b[c>>0]=e;b[d>>0]=f;f=b[c>>0]|0;d=b[a>>0]|0;if(f<<24>>24<d<<24>>24){b[a>>0]=f;b[c>>0]=d;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function Yrc(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=Xrc(a,c,d,e,g)|0;g=b[f>>0]|0;i=b[e>>0]|0;if(g<<24>>24<i<<24>>24){b[e>>0]=g;b[f>>0]=i;i=h+1|0;f=b[e>>0]|0;g=b[d>>0]|0;if(f<<24>>24<g<<24>>24){b[d>>0]=f;b[e>>0]=g;g=h+2|0;e=b[d>>0]|0;f=b[c>>0]|0;if(e<<24>>24<f<<24>>24){b[c>>0]=e;b[d>>0]=f;f=b[c>>0]|0;d=b[a>>0]|0;if(f<<24>>24<d<<24>>24){b[a>>0]=f;b[c>>0]=d;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function Zrc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+2|0;Wrc(a,a+1|0,e,d)|0;d=a+3|0;f=e;while(1){if((d|0)==(c|0))break;e=b[d>>0]|0;g=b[f>>0]|0;if(e<<24>>24<g<<24>>24){h=f;i=d;j=g;while(1){b[i>>0]=j;if((h|0)==(a|0)){k=a;break}g=h+-1|0;j=b[g>>0]|0;if(e<<24>>24>=j<<24>>24){k=h;break}else{l=h;h=g;i=l}}b[k>>0]=e}i=d;d=d+1|0;f=i}return}function _rc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a+2|0;f=c+-1|0;g=a+1|0;switch(c-a|0){case 1:case 0:{h=1;break}case 2:{i=b[f>>0]|0;j=b[a>>0]|0;if(i<<24>>24<j<<24>>24){b[a>>0]=i;b[f>>0]=j;h=1}else h=1;break}case 3:{Wrc(a,g,f,d)|0;h=1;break}case 4:{Xrc(a,g,e,f,d)|0;h=1;break}case 5:{Yrc(a,g,e,a+3|0,f,d)|0;h=1;break}default:{Wrc(a,g,e,d)|0;d=a+3|0;g=0;f=e;while(1){if((d|0)==(c|0)){k=1;l=0;break}e=b[d>>0]|0;j=b[f>>0]|0;if(e<<24>>24<j<<24>>24){i=f;m=d;n=j;while(1){b[m>>0]=n;if((i|0)==(a|0)){o=a;break}j=i+-1|0;n=b[j>>0]|0;if(e<<24>>24>=n<<24>>24){o=i;break}else{p=i;i=j;m=p}}b[o>>0]=e;m=g+1|0;if((m|0)==8){k=0;l=(d+1|0)==(c|0);break}else q=m}else q=g;m=d;d=d+1|0;g=q;f=m}h=l|k}}return h|0}function $rc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=a;a=c;a:while(1){c=a;f=a+-1|0;g=e;while(1){h=g;b:while(1){i=h;j=c-i|0;k=h+1|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((j|0)<31){l=11;break a}m=h+(j>>>1)|0;if((j|0)>999){n=j>>>2;o=csc(h,h+n|0,m,m+n|0,f,d)|0}else o=asc(h,m,f,d)|0;p=b[h>>0]|0;n=b[m>>0]|0;if((p&255)<(n&255)){q=f;r=o;break}else s=f;while(1){s=s+-1|0;if((h|0)==(s|0))break;t=b[s>>0]|0;if((t&255)<(n&255)){l=28;break b}}n=b[f>>0]|0;if((p&255)<(n&255))u=k;else{j=k;while(1){if((j|0)==(f|0))break a;v=b[j>>0]|0;w=j+1|0;if((p&255)<(v&255))break;else j=w}b[j>>0]=n;b[f>>0]=v;u=w}if((u|0)==(f|0))break a;else{x=f;y=u}while(1){z=b[h>>0]|0;A=y;while(1){B=b[A>>0]|0;C=A+1|0;if((z&255)<(B&255)){D=x;break}else A=C}do{D=D+-1|0;E=b[D>>0]|0}while((z&255)<(E&255));if(A>>>0>=D>>>0){h=A;continue b}b[A>>0]=E;b[D>>0]=B;x=D;y=C}}if((l|0)==28){l=0;b[h>>0]=t;b[s>>0]=p;q=s;r=o+1|0}c:do if(k>>>0<q>>>0){n=m;j=q;z=k;F=r;while(1){G=b[n>>0]|0;H=z;while(1){I=b[H>>0]|0;J=H+1|0;if((I&255)<(G&255))H=J;else{K=j;break}}do{K=K+-1|0;L=b[K>>0]|0}while((L&255)>=(G&255));if(H>>>0>K>>>0){M=n;N=F;O=H;break c}b[H>>0]=L;b[K>>0]=I;n=(n|0)==(H|0)?K:n;j=K;z=J;F=F+1|0}}else{M=m;N=r;O=k}while(0);if((O|0)!=(M|0)?(F=b[M>>0]|0,z=b[O>>0]|0,(F&255)<(z&255)):0){b[O>>0]=F;b[M>>0]=z;P=N+1|0}else P=N;if(!P){Q=esc(h,O,d)|0;z=O+1|0;if(esc(z,a,d)|0){l=45;break}if(Q){g=z;continue}else R=z}else R=O+1|0;z=O;if((z-i|0)>=(c-z|0)){l=44;break}$rc(h,O,d);g=R}if((l|0)==44){l=0;$rc(R,a,d);e=h;a=O;continue}else if((l|0)==45){l=0;if(Q)break;else{e=h;a=O;continue}}}if((l|0)==5){O=b[f>>0]|0;e=b[h>>0]|0;if((O&255)<(e&255)){b[h>>0]=O;b[f>>0]=e}}else if((l|0)==7)asc(h,k,f,d)|0;else if((l|0)==8)bsc(h,k,h+2|0,f,d)|0;else if((l|0)==9)csc(h,k,h+2|0,h+3|0,f,d)|0;else if((l|0)==11)dsc(h,a,d);return}function asc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=b[c>>0]|0;f=b[a>>0]|0;g=b[d>>0]|0;h=(g&255)<(e&255);do if((e&255)<(f&255)){if(h){b[a>>0]=g;b[d>>0]=f;i=1;break}b[a>>0]=e;b[c>>0]=f;j=b[d>>0]|0;if((j&255)<(f&255)){b[c>>0]=j;b[d>>0]=f;i=2}else i=1}else if(h){b[c>>0]=g;b[d>>0]=e;j=b[c>>0]|0;k=b[a>>0]|0;if((j&255)<(k&255)){b[a>>0]=j;b[c>>0]=k;i=2}else i=1}else i=0;while(0);return i|0}function bsc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=asc(a,c,d,f)|0;f=b[e>>0]|0;h=b[d>>0]|0;if((f&255)<(h&255)){b[d>>0]=f;b[e>>0]=h;h=g+1|0;e=b[d>>0]|0;f=b[c>>0]|0;if((e&255)<(f&255)){b[c>>0]=e;b[d>>0]=f;f=b[c>>0]|0;d=b[a>>0]|0;if((f&255)<(d&255)){b[a>>0]=f;b[c>>0]=d;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function csc(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=bsc(a,c,d,e,g)|0;g=b[f>>0]|0;i=b[e>>0]|0;if((g&255)<(i&255)){b[e>>0]=g;b[f>>0]=i;i=h+1|0;f=b[e>>0]|0;g=b[d>>0]|0;if((f&255)<(g&255)){b[d>>0]=f;b[e>>0]=g;g=h+2|0;e=b[d>>0]|0;f=b[c>>0]|0;if((e&255)<(f&255)){b[c>>0]=e;b[d>>0]=f;f=b[c>>0]|0;d=b[a>>0]|0;if((f&255)<(d&255)){b[a>>0]=f;b[c>>0]=d;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function dsc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+2|0;asc(a,a+1|0,e,d)|0;d=a+3|0;f=e;while(1){if((d|0)==(c|0))break;e=b[d>>0]|0;g=b[f>>0]|0;if((e&255)<(g&255)){h=f;i=d;j=g;while(1){b[i>>0]=j;if((h|0)==(a|0)){k=a;break}g=h+-1|0;j=b[g>>0]|0;if((e&255)>=(j&255)){k=h;break}else{l=h;h=g;i=l}}b[k>>0]=e}i=d;d=d+1|0;f=i}return}function esc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a+2|0;f=c+-1|0;g=a+1|0;switch(c-a|0){case 1:case 0:{h=1;break}case 2:{i=b[f>>0]|0;j=b[a>>0]|0;if((i&255)<(j&255)){b[a>>0]=i;b[f>>0]=j;h=1}else h=1;break}case 3:{asc(a,g,f,d)|0;h=1;break}case 4:{bsc(a,g,e,f,d)|0;h=1;break}case 5:{csc(a,g,e,a+3|0,f,d)|0;h=1;break}default:{asc(a,g,e,d)|0;d=a+3|0;g=0;f=e;while(1){if((d|0)==(c|0)){k=1;l=0;break}e=b[d>>0]|0;j=b[f>>0]|0;if((e&255)<(j&255)){i=f;m=d;n=j;while(1){b[m>>0]=n;if((i|0)==(a|0)){o=a;break}j=i+-1|0;n=b[j>>0]|0;if((e&255)>=(n&255)){o=i;break}else{p=i;i=j;m=p}}b[o>>0]=e;m=g+1|0;if((m|0)==8){k=0;l=(d+1|0)==(c|0);break}else q=m}else q=g;m=d;d=d+1|0;g=q;f=m}h=l|k}}return h|0}function fsc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=a;a=b;a:while(1){b=a;f=a+-2|0;g=e;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>1;l=h+2|0;switch(k|0){case 1:case 0:{break a;break}case 2:{m=5;break a;break}case 3:{m=7;break a;break}case 4:{m=8;break a;break}case 5:{m=9;break a;break}default:{}}if((j|0)<62){m=11;break a}n=h+(((k|0)/2|0)<<1)|0;if((j|0)>1998){j=(k|0)/4|0;o=isc(h,h+(j<<1)|0,n,n+(j<<1)|0,f,c)|0}else o=gsc(h,n,f,c)|0;p=d[h>>1]|0;j=d[n>>1]|0;if(p<<16>>16<j<<16>>16){q=f;r=o;break}else s=f;while(1){s=s+-2|0;if((h|0)==(s|0))break;t=d[s>>1]|0;if(t<<16>>16<j<<16>>16){m=28;break b}}j=d[f>>1]|0;if(p<<16>>16<j<<16>>16)u=l;else{k=l;while(1){if((k|0)==(f|0))break a;v=d[k>>1]|0;w=k+2|0;if(p<<16>>16<v<<16>>16)break;else k=w}d[k>>1]=j;d[f>>1]=v;u=w}if((u|0)==(f|0))break a;else{x=f;y=u}while(1){z=d[h>>1]|0;A=y;while(1){B=d[A>>1]|0;C=A+2|0;if(z<<16>>16<B<<16>>16){D=x;break}else A=C}do{D=D+-2|0;E=d[D>>1]|0}while(z<<16>>16<E<<16>>16);if(A>>>0>=D>>>0){h=A;continue b}d[A>>1]=E;d[D>>1]=B;x=D;y=C}}if((m|0)==28){m=0;d[h>>1]=t;d[s>>1]=p;q=s;r=o+1|0}c:do if(l>>>0<q>>>0){j=n;k=q;z=l;F=r;while(1){G=d[j>>1]|0;H=z;while(1){I=d[H>>1]|0;J=H+2|0;if(I<<16>>16<G<<16>>16)H=J;else{K=k;break}}do{K=K+-2|0;L=d[K>>1]|0}while(L<<16>>16>=G<<16>>16);if(H>>>0>K>>>0){M=j;N=F;O=H;break c}d[H>>1]=L;d[K>>1]=I;j=(j|0)==(H|0)?K:j;k=K;z=J;F=F+1|0}}else{M=n;N=r;O=l}while(0);if((O|0)!=(M|0)?(F=d[M>>1]|0,z=d[O>>1]|0,F<<16>>16<z<<16>>16):0){d[O>>1]=F;d[M>>1]=z;P=N+1|0}else P=N;if(!P){Q=ksc(h,O,c)|0;z=O+2|0;if(ksc(z,a,c)|0){m=45;break}if(Q){g=z;continue}else R=z}else R=O+2|0;z=O;if((z-i|0)>=(b-z|0)){m=44;break}fsc(h,O,c);g=R}if((m|0)==44){m=0;fsc(R,a,c);e=h;a=O;continue}else if((m|0)==45){m=0;if(Q)break;else{e=h;a=O;continue}}}if((m|0)==5){O=d[f>>1]|0;e=d[h>>1]|0;if(O<<16>>16<e<<16>>16){d[h>>1]=O;d[f>>1]=e}}else if((m|0)==7)gsc(h,l,f,c)|0;else if((m|0)==8)hsc(h,l,h+4|0,f,c)|0;else if((m|0)==9)isc(h,l,h+4|0,h+6|0,f,c)|0;else if((m|0)==11)jsc(h,a,c);return}function gsc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=d[b>>1]|0;f=d[a>>1]|0;g=d[c>>1]|0;h=g<<16>>16<e<<16>>16;do if(e<<16>>16<f<<16>>16){if(h){d[a>>1]=g;d[c>>1]=f;i=1;break}d[a>>1]=e;d[b>>1]=f;j=d[c>>1]|0;if(j<<16>>16<f<<16>>16){d[b>>1]=j;d[c>>1]=f;i=2}else i=1}else if(h){d[b>>1]=g;d[c>>1]=e;j=d[b>>1]|0;k=d[a>>1]|0;if(j<<16>>16<k<<16>>16){d[a>>1]=j;d[b>>1]=k;i=2}else i=1}else i=0;while(0);return i|0}function hsc(a,b,c,e,f){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=gsc(a,b,c,f)|0;f=d[e>>1]|0;h=d[c>>1]|0;if(f<<16>>16<h<<16>>16){d[c>>1]=f;d[e>>1]=h;h=g+1|0;e=d[c>>1]|0;f=d[b>>1]|0;if(e<<16>>16<f<<16>>16){d[b>>1]=e;d[c>>1]=f;f=d[b>>1]|0;c=d[a>>1]|0;if(f<<16>>16<c<<16>>16){d[a>>1]=f;d[b>>1]=c;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function isc(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=hsc(a,b,c,e,g)|0;g=d[f>>1]|0;i=d[e>>1]|0;if(g<<16>>16<i<<16>>16){d[e>>1]=g;d[f>>1]=i;i=h+1|0;f=d[e>>1]|0;g=d[c>>1]|0;if(f<<16>>16<g<<16>>16){d[c>>1]=f;d[e>>1]=g;g=h+2|0;e=d[c>>1]|0;f=d[b>>1]|0;if(e<<16>>16<f<<16>>16){d[b>>1]=e;d[c>>1]=f;f=d[b>>1]|0;c=d[a>>1]|0;if(f<<16>>16<c<<16>>16){d[a>>1]=f;d[b>>1]=c;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function jsc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+4|0;gsc(a,a+2|0,e,c)|0;c=a+6|0;f=e;while(1){if((c|0)==(b|0))break;e=d[c>>1]|0;g=d[f>>1]|0;if(e<<16>>16<g<<16>>16){h=f;i=c;j=g;while(1){d[i>>1]=j;if((h|0)==(a|0)){k=a;break}g=h+-2|0;j=d[g>>1]|0;if(e<<16>>16>=j<<16>>16){k=h;break}else{l=h;h=g;i=l}}d[k>>1]=e}i=c;c=c+2|0;f=i}return}function ksc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a+4|0;f=a+2|0;g=b+-2|0;switch(b-a>>1|0){case 1:case 0:{h=1;break}case 2:{i=d[g>>1]|0;j=d[a>>1]|0;if(i<<16>>16<j<<16>>16){d[a>>1]=i;d[g>>1]=j;h=1}else h=1;break}case 3:{gsc(a,f,g,c)|0;h=1;break}case 4:{hsc(a,f,e,g,c)|0;h=1;break}case 5:{isc(a,f,e,a+6|0,g,c)|0;h=1;break}default:{gsc(a,f,e,c)|0;c=a+6|0;f=0;g=e;while(1){if((c|0)==(b|0)){k=1;l=0;break}e=d[c>>1]|0;j=d[g>>1]|0;if(e<<16>>16<j<<16>>16){i=g;m=c;n=j;while(1){d[m>>1]=n;if((i|0)==(a|0)){o=a;break}j=i+-2|0;n=d[j>>1]|0;if(e<<16>>16>=n<<16>>16){o=i;break}else{p=i;i=j;m=p}}d[o>>1]=e;m=f+1|0;if((m|0)==8){k=0;l=(c+2|0)==(b|0);break}else q=m}else q=f;m=c;c=c+2|0;f=q;g=m}h=l|k}}return h|0}function lsc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=a;a=b;a:while(1){b=a;f=a+-2|0;g=e;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>1;l=h+2|0;switch(k|0){case 1:case 0:{break a;break}case 2:{m=5;break a;break}case 3:{m=7;break a;break}case 4:{m=8;break a;break}case 5:{m=9;break a;break}default:{}}if((j|0)<62){m=11;break a}n=h+(((k|0)/2|0)<<1)|0;if((j|0)>1998){j=(k|0)/4|0;o=osc(h,h+(j<<1)|0,n,n+(j<<1)|0,f,c)|0}else o=msc(h,n,f,c)|0;p=d[h>>1]|0;j=d[n>>1]|0;if((p&65535)<(j&65535)){q=f;r=o;break}else s=f;while(1){s=s+-2|0;if((h|0)==(s|0))break;t=d[s>>1]|0;if((t&65535)<(j&65535)){m=28;break b}}j=d[f>>1]|0;if((p&65535)<(j&65535))u=l;else{k=l;while(1){if((k|0)==(f|0))break a;v=d[k>>1]|0;w=k+2|0;if((p&65535)<(v&65535))break;else k=w}d[k>>1]=j;d[f>>1]=v;u=w}if((u|0)==(f|0))break a;else{x=f;y=u}while(1){z=d[h>>1]|0;A=y;while(1){B=d[A>>1]|0;C=A+2|0;if((z&65535)<(B&65535)){D=x;break}else A=C}do{D=D+-2|0;E=d[D>>1]|0}while((z&65535)<(E&65535));if(A>>>0>=D>>>0){h=A;continue b}d[A>>1]=E;d[D>>1]=B;x=D;y=C}}if((m|0)==28){m=0;d[h>>1]=t;d[s>>1]=p;q=s;r=o+1|0}c:do if(l>>>0<q>>>0){j=n;k=q;z=l;F=r;while(1){G=d[j>>1]|0;H=z;while(1){I=d[H>>1]|0;J=H+2|0;if((I&65535)<(G&65535))H=J;else{K=k;break}}do{K=K+-2|0;L=d[K>>1]|0}while((L&65535)>=(G&65535));if(H>>>0>K>>>0){M=j;N=F;O=H;break c}d[H>>1]=L;d[K>>1]=I;j=(j|0)==(H|0)?K:j;k=K;z=J;F=F+1|0}}else{M=n;N=r;O=l}while(0);if((O|0)!=(M|0)?(F=d[M>>1]|0,z=d[O>>1]|0,(F&65535)<(z&65535)):0){d[O>>1]=F;d[M>>1]=z;P=N+1|0}else P=N;if(!P){Q=qsc(h,O,c)|0;z=O+2|0;if(qsc(z,a,c)|0){m=45;break}if(Q){g=z;continue}else R=z}else R=O+2|0;z=O;if((z-i|0)>=(b-z|0)){m=44;break}lsc(h,O,c);g=R}if((m|0)==44){m=0;lsc(R,a,c);e=h;a=O;continue}else if((m|0)==45){m=0;if(Q)break;else{e=h;a=O;continue}}}if((m|0)==5){O=d[f>>1]|0;e=d[h>>1]|0;if((O&65535)<(e&65535)){d[h>>1]=O;d[f>>1]=e}}else if((m|0)==7)msc(h,l,f,c)|0;else if((m|0)==8)nsc(h,l,h+4|0,f,c)|0;else if((m|0)==9)osc(h,l,h+4|0,h+6|0,f,c)|0;else if((m|0)==11)psc(h,a,c);return}function msc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=d[b>>1]|0;f=d[a>>1]|0;g=d[c>>1]|0;h=(g&65535)<(e&65535);do if((e&65535)<(f&65535)){if(h){d[a>>1]=g;d[c>>1]=f;i=1;break}d[a>>1]=e;d[b>>1]=f;j=d[c>>1]|0;if((j&65535)<(f&65535)){d[b>>1]=j;d[c>>1]=f;i=2}else i=1}else if(h){d[b>>1]=g;d[c>>1]=e;j=d[b>>1]|0;k=d[a>>1]|0;if((j&65535)<(k&65535)){d[a>>1]=j;d[b>>1]=k;i=2}else i=1}else i=0;while(0);return i|0}function nsc(a,b,c,e,f){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=msc(a,b,c,f)|0;f=d[e>>1]|0;h=d[c>>1]|0;if((f&65535)<(h&65535)){d[c>>1]=f;d[e>>1]=h;h=g+1|0;e=d[c>>1]|0;f=d[b>>1]|0;if((e&65535)<(f&65535)){d[b>>1]=e;d[c>>1]=f;f=d[b>>1]|0;c=d[a>>1]|0;if((f&65535)<(c&65535)){d[a>>1]=f;d[b>>1]=c;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function osc(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=nsc(a,b,c,e,g)|0;g=d[f>>1]|0;i=d[e>>1]|0;if((g&65535)<(i&65535)){d[e>>1]=g;d[f>>1]=i;i=h+1|0;f=d[e>>1]|0;g=d[c>>1]|0;if((f&65535)<(g&65535)){d[c>>1]=f;d[e>>1]=g;g=h+2|0;e=d[c>>1]|0;f=d[b>>1]|0;if((e&65535)<(f&65535)){d[b>>1]=e;d[c>>1]=f;f=d[b>>1]|0;c=d[a>>1]|0;if((f&65535)<(c&65535)){d[a>>1]=f;d[b>>1]=c;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function psc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+4|0;msc(a,a+2|0,e,c)|0;c=a+6|0;f=e;while(1){if((c|0)==(b|0))break;e=d[c>>1]|0;g=d[f>>1]|0;if((e&65535)<(g&65535)){h=f;i=c;j=g;while(1){d[i>>1]=j;if((h|0)==(a|0)){k=a;break}g=h+-2|0;j=d[g>>1]|0;if((e&65535)>=(j&65535)){k=h;break}else{l=h;h=g;i=l}}d[k>>1]=e}i=c;c=c+2|0;f=i}return}function qsc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a+4|0;f=a+2|0;g=b+-2|0;switch(b-a>>1|0){case 1:case 0:{h=1;break}case 2:{i=d[g>>1]|0;j=d[a>>1]|0;if((i&65535)<(j&65535)){d[a>>1]=i;d[g>>1]=j;h=1}else h=1;break}case 3:{msc(a,f,g,c)|0;h=1;break}case 4:{nsc(a,f,e,g,c)|0;h=1;break}case 5:{osc(a,f,e,a+6|0,g,c)|0;h=1;break}default:{msc(a,f,e,c)|0;c=a+6|0;f=0;g=e;while(1){if((c|0)==(b|0)){k=1;l=0;break}e=d[c>>1]|0;j=d[g>>1]|0;if((e&65535)<(j&65535)){i=g;m=c;n=j;while(1){d[m>>1]=n;if((i|0)==(a|0)){o=a;break}j=i+-2|0;n=d[j>>1]|0;if((e&65535)>=(n&65535)){o=i;break}else{p=i;i=j;m=p}}d[o>>1]=e;m=f+1|0;if((m|0)==8){k=0;l=(c+2|0)==(b|0);break}else q=m}else q=f;m=c;c=c+2|0;f=q;g=m}h=l|k}}return h|0}function rsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;l=h+4|0;switch(k|0){case 1:case 0:{break a;break}case 2:{m=5;break a;break}case 3:{m=7;break a;break}case 4:{m=8;break a;break}case 5:{m=9;break a;break}default:{}}if((j|0)<124){m=11;break a}n=h+(((k|0)/2|0)<<2)|0;if((j|0)>3996){j=(k|0)/4|0;o=usc(h,h+(j<<2)|0,n,n+(j<<2)|0,e,c)|0}else o=ssc(h,n,e,c)|0;p=f[h>>2]|0;j=f[n>>2]|0;if((p|0)<(j|0)){q=e;r=o;break}else s=e;while(1){s=s+-4|0;if((h|0)==(s|0))break;t=f[s>>2]|0;if((t|0)<(j|0)){m=28;break b}}j=f[e>>2]|0;if((p|0)<(j|0))u=l;else{k=l;while(1){if((k|0)==(e|0))break a;v=f[k>>2]|0;w=k+4|0;if((p|0)<(v|0))break;else k=w}f[k>>2]=j;f[e>>2]=v;u=w}if((u|0)==(e|0))break a;else{x=e;y=u}while(1){z=f[h>>2]|0;A=y;while(1){B=f[A>>2]|0;C=A+4|0;if((z|0)<(B|0)){D=x;break}else A=C}do{D=D+-4|0;E=f[D>>2]|0}while((z|0)<(E|0));if(A>>>0>=D>>>0){h=A;continue b}f[A>>2]=E;f[D>>2]=B;x=D;y=C}}if((m|0)==28){m=0;f[h>>2]=t;f[s>>2]=p;q=s;r=o+1|0}c:do if(l>>>0<q>>>0){j=n;k=q;z=l;F=r;while(1){G=f[j>>2]|0;H=z;while(1){I=f[H>>2]|0;J=H+4|0;if((I|0)<(G|0))H=J;else{K=k;break}}do{K=K+-4|0;L=f[K>>2]|0}while((L|0)>=(G|0));if(H>>>0>K>>>0){M=j;N=F;O=H;break c}f[H>>2]=L;f[K>>2]=I;j=(j|0)==(H|0)?K:j;k=K;z=J;F=F+1|0}}else{M=n;N=r;O=l}while(0);if((O|0)!=(M|0)?(F=f[M>>2]|0,z=f[O>>2]|0,(F|0)<(z|0)):0){f[O>>2]=F;f[M>>2]=z;P=N+1|0}else P=N;if(!P){Q=wsc(h,O,c)|0;z=O+4|0;if(wsc(z,a,c)|0){m=45;break}if(Q){g=z;continue}else R=z}else R=O+4|0;z=O;if((z-i|0)>=(b-z|0)){m=44;break}rsc(h,O,c);g=R}if((m|0)==44){m=0;rsc(R,a,c);d=h;a=O;continue}else if((m|0)==45){m=0;if(Q)break;else{d=h;a=O;continue}}}if((m|0)==5){O=f[e>>2]|0;d=f[h>>2]|0;if((O|0)<(d|0)){f[h>>2]=O;f[e>>2]=d}}else if((m|0)==7)ssc(h,l,e,c)|0;else if((m|0)==8)tsc(h,l,h+8|0,e,c)|0;else if((m|0)==9)usc(h,l,h+8|0,h+12|0,e,c)|0;else if((m|0)==11)vsc(h,a,c);return}function ssc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;d=f[b>>2]|0;e=f[a>>2]|0;g=f[c>>2]|0;h=(g|0)<(d|0);do if((d|0)<(e|0)){if(h){f[a>>2]=g;f[c>>2]=e;i=1;break}f[a>>2]=d;f[b>>2]=e;j=f[c>>2]|0;if((j|0)<(e|0)){f[b>>2]=j;f[c>>2]=e;i=2}else i=1}else if(h){f[b>>2]=g;f[c>>2]=d;j=f[b>>2]|0;k=f[a>>2]|0;if((j|0)<(k|0)){f[a>>2]=j;f[b>>2]=k;i=2}else i=1}else i=0;while(0);return i|0}function tsc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=ssc(a,b,c,e)|0;e=f[d>>2]|0;h=f[c>>2]|0;if((e|0)<(h|0)){f[c>>2]=e;f[d>>2]=h;h=g+1|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)<(e|0)){f[b>>2]=d;f[c>>2]=e;e=f[b>>2]|0;c=f[a>>2]|0;if((e|0)<(c|0)){f[a>>2]=e;f[b>>2]=c;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function usc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=tsc(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;if((g|0)<(i|0)){f[d>>2]=g;f[e>>2]=i;i=h+1|0;e=f[d>>2]|0;g=f[c>>2]|0;if((e|0)<(g|0)){f[c>>2]=e;f[d>>2]=g;g=h+2|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)<(e|0)){f[b>>2]=d;f[c>>2]=e;e=f[b>>2]|0;c=f[a>>2]|0;if((e|0)<(c|0)){f[a>>2]=e;f[b>>2]=c;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function vsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;ssc(a,a+4|0,d,c)|0;c=a+12|0;e=d;while(1){if((c|0)==(b|0))break;d=f[c>>2]|0;g=f[e>>2]|0;if((d|0)<(g|0)){h=e;i=c;j=g;while(1){f[i>>2]=j;if((h|0)==(a|0)){k=a;break}g=h+-4|0;j=f[g>>2]|0;if((d|0)>=(j|0)){k=h;break}else{l=h;h=g;i=l}}f[k>>2]=d}i=c;c=c+4|0;e=i}return}function wsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+4|0;e=b+-4|0;g=a+8|0;switch(b-a>>2|0){case 1:case 0:{h=1;break}case 2:{i=f[e>>2]|0;j=f[a>>2]|0;if((i|0)<(j|0)){f[a>>2]=i;f[e>>2]=j;h=1}else h=1;break}case 3:{ssc(a,d,e,c)|0;h=1;break}case 4:{tsc(a,d,g,e,c)|0;h=1;break}case 5:{usc(a,d,g,a+12|0,e,c)|0;h=1;break}default:{ssc(a,d,g,c)|0;c=a+12|0;d=0;e=g;while(1){if((c|0)==(b|0)){k=1;l=0;break}g=f[c>>2]|0;j=f[e>>2]|0;if((g|0)<(j|0)){i=e;m=c;n=j;while(1){f[m>>2]=n;if((i|0)==(a|0)){o=a;break}j=i+-4|0;n=f[j>>2]|0;if((g|0)>=(n|0)){o=i;break}else{p=i;i=j;m=p}}f[o>>2]=g;m=d+1|0;if((m|0)==8){k=0;l=(c+4|0)==(b|0);break}else q=m}else q=d;m=c;c=c+4|0;d=q;e=m}h=l|k}}return h|0}function xsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;f=d;while(1){g=f;b:while(1){h=g;i=b-h|0;j=i>>2;k=g+4|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((i|0)<124){l=11;break a}m=g+(((j|0)/2|0)<<2)|0;if((i|0)>3996){i=(j|0)/4|0;o=Asc(g,g+(i<<2)|0,m,m+(i<<2)|0,e,c)|0}else o=ysc(g,m,e,c)|0;p=+n[g>>2];q=+n[m>>2];if(p<q){r=e;s=o;break}else t=e;while(1){t=t+-4|0;if((g|0)==(t|0))break;u=+n[t>>2];if(u<q){l=28;break b}}q=+n[e>>2];if(p<q)v=k;else{i=k;while(1){if((i|0)==(e|0))break a;w=+n[i>>2];x=i+4|0;if(p<w)break;else i=x}n[i>>2]=q;n[e>>2]=w;v=x}if((v|0)==(e|0))break a;else{y=e;z=v}while(1){A=+n[g>>2];j=z;while(1){B=+n[j>>2];C=j+4|0;if(A<B){D=y;break}else j=C}do{D=D+-4|0;E=+n[D>>2]}while(A<E);if(j>>>0>=D>>>0){g=j;continue b}n[j>>2]=E;n[D>>2]=B;y=D;z=C}}if((l|0)==28){l=0;n[g>>2]=u;n[t>>2]=p;r=t;s=o+1|0}c:do if(k>>>0<r>>>0){i=m;F=r;G=k;H=s;while(1){q=+n[i>>2];I=G;while(1){J=+n[I>>2];K=I+4|0;if(J<q)I=K;else{L=F;break}}do{L=L+-4|0;M=+n[L>>2]}while(!(M<q));if(I>>>0>L>>>0){N=i;O=H;P=I;break c}n[I>>2]=M;n[L>>2]=J;i=(i|0)==(I|0)?L:i;F=L;G=K;H=H+1|0}}else{N=m;O=s;P=k}while(0);if((P|0)!=(N|0)?(q=+n[N>>2],A=+n[P>>2],q<A):0){n[P>>2]=q;n[N>>2]=A;Q=O+1|0}else Q=O;if(!Q){R=Csc(g,P,c)|0;H=P+4|0;if(Csc(H,a,c)|0){l=45;break}if(R){f=H;continue}else S=H}else S=P+4|0;H=P;if((H-h|0)>=(b-H|0)){l=44;break}xsc(g,P,c);f=S}if((l|0)==44){l=0;xsc(S,a,c);d=g;a=P;continue}else if((l|0)==45){l=0;if(R)break;else{d=g;a=P;continue}}}if((l|0)==5){J=+n[e>>2];M=+n[g>>2];if(J<M){n[g>>2]=J;n[e>>2]=M}}else if((l|0)==7)ysc(g,k,e,c)|0;else if((l|0)==8)zsc(g,k,g+8|0,e,c)|0;else if((l|0)==9)Asc(g,k,g+8|0,g+12|0,e,c)|0;else if((l|0)==11)Bsc(g,a,c);return}function ysc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0,i=0.0,j=0.0;e=+n[b>>2];f=+n[a>>2];g=+n[c>>2];d=g<e;do if(e<f){if(d){n[a>>2]=g;n[c>>2]=f;h=1;break}n[a>>2]=e;n[b>>2]=f;i=+n[c>>2];if(i<f){n[b>>2]=i;n[c>>2]=f;h=2}else h=1}else if(d){n[b>>2]=g;n[c>>2]=e;i=+n[b>>2];j=+n[a>>2];if(i<j){n[a>>2]=i;n[b>>2]=j;h=2}else h=1}else h=0;while(0);return h|0}function zsc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0.0,i=0;f=ysc(a,b,c,e)|0;g=+n[d>>2];h=+n[c>>2];if(g<h){n[c>>2]=g;n[d>>2]=h;d=f+1|0;h=+n[c>>2];g=+n[b>>2];if(h<g){n[b>>2]=h;n[c>>2]=g;g=+n[b>>2];h=+n[a>>2];if(g<h){n[a>>2]=g;n[b>>2]=h;i=f+3|0}else i=f+2|0}else i=d}else i=f;return i|0}function Asc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0;g=zsc(a,b,c,d,f)|0;h=+n[e>>2];i=+n[d>>2];if(h<i){n[d>>2]=h;n[e>>2]=i;e=g+1|0;i=+n[d>>2];h=+n[c>>2];if(i<h){n[c>>2]=i;n[d>>2]=h;d=g+2|0;h=+n[c>>2];i=+n[b>>2];if(h<i){n[b>>2]=h;n[c>>2]=i;i=+n[b>>2];h=+n[a>>2];if(i<h){n[a>>2]=i;n[b>>2]=h;j=g+4|0}else j=g+3|0}else j=d}else j=e}else j=g;return j|0}function Bsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0;d=a+8|0;ysc(a,a+4|0,d,c)|0;c=a+12|0;e=d;while(1){if((c|0)==(b|0))break;g=+n[c>>2];if(g<+n[e>>2]){d=e;h=c;while(1){f[h>>2]=f[d>>2];if((d|0)==(a|0))break;i=d+-4|0;if(g<+n[i>>2]){j=d;d=i;h=j}else break}n[d>>2]=g}h=c;c=c+4|0;e=h}return}function Csc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0;d=a+4|0;e=b+-4|0;g=a+8|0;switch(b-a>>2|0){case 1:case 0:{h=1;break}case 2:{i=+n[e>>2];j=+n[a>>2];if(i<j){n[a>>2]=i;n[e>>2]=j;h=1}else h=1;break}case 3:{ysc(a,d,e,c)|0;h=1;break}case 4:{zsc(a,d,g,e,c)|0;h=1;break}case 5:{Asc(a,d,g,a+12|0,e,c)|0;h=1;break}default:{ysc(a,d,g,c)|0;c=a+12|0;d=0;e=g;while(1){if((c|0)==(b|0)){k=1;l=0;break}j=+n[c>>2];if(j<+n[e>>2]){g=e;m=c;while(1){f[m>>2]=f[g>>2];if((g|0)==(a|0))break;o=g+-4|0;if(j<+n[o>>2]){p=g;g=o;m=p}else break}n[g>>2]=j;m=d+1|0;if((m|0)==8){k=0;l=(c+4|0)==(b|0);break}else q=m}else q=d;m=c;c=c+4|0;d=q;e=m}h=l|k}}return h|0}function Dsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0;d=a;a=b;a:while(1){b=a;e=a+-8|0;f=d;while(1){g=f;b:while(1){h=g;i=b-h|0;j=i>>3;k=g+8|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((i|0)<248){l=11;break a}m=g+(((j|0)/2|0)<<3)|0;if((i|0)>7992){i=(j|0)/4|0;n=Gsc(g,g+(i<<3)|0,m,m+(i<<3)|0,e,c)|0}else n=Esc(g,m,e,c)|0;o=+p[g>>3];q=+p[m>>3];if(o<q){r=e;s=n;break}else t=e;while(1){t=t+-8|0;if((g|0)==(t|0))break;u=+p[t>>3];if(u<q){l=28;break b}}q=+p[e>>3];if(o<q)v=k;else{i=k;while(1){if((i|0)==(e|0))break a;w=+p[i>>3];x=i+8|0;if(o<w)break;else i=x}p[i>>3]=q;p[e>>3]=w;v=x}if((v|0)==(e|0))break a;else{y=e;z=v}while(1){A=+p[g>>3];j=z;while(1){B=+p[j>>3];C=j+8|0;if(A<B){D=y;break}else j=C}do{D=D+-8|0;E=+p[D>>3]}while(A<E);if(j>>>0>=D>>>0){g=j;continue b}p[j>>3]=E;p[D>>3]=B;y=D;z=C}}if((l|0)==28){l=0;p[g>>3]=u;p[t>>3]=o;r=t;s=n+1|0}c:do if(k>>>0<r>>>0){i=m;F=r;G=k;H=s;while(1){q=+p[i>>3];I=G;while(1){J=+p[I>>3];K=I+8|0;if(J<q)I=K;else{L=F;break}}do{L=L+-8|0;M=+p[L>>3]}while(!(M<q));if(I>>>0>L>>>0){N=i;O=H;P=I;break c}p[I>>3]=M;p[L>>3]=J;i=(i|0)==(I|0)?L:i;F=L;G=K;H=H+1|0}}else{N=m;O=s;P=k}while(0);if((P|0)!=(N|0)?(q=+p[N>>3],A=+p[P>>3],q<A):0){p[P>>3]=q;p[N>>3]=A;Q=O+1|0}else Q=O;if(!Q){R=Isc(g,P,c)|0;H=P+8|0;if(Isc(H,a,c)|0){l=45;break}if(R){f=H;continue}else S=H}else S=P+8|0;H=P;if((H-h|0)>=(b-H|0)){l=44;break}Dsc(g,P,c);f=S}if((l|0)==44){l=0;Dsc(S,a,c);d=g;a=P;continue}else if((l|0)==45){l=0;if(R)break;else{d=g;a=P;continue}}}if((l|0)==5){J=+p[e>>3];M=+p[g>>3];if(J<M){p[g>>3]=J;p[e>>3]=M}}else if((l|0)==7)Esc(g,k,e,c)|0;else if((l|0)==8)Fsc(g,k,g+16|0,e,c)|0;else if((l|0)==9)Gsc(g,k,g+16|0,g+24|0,e,c)|0;else if((l|0)==11)Hsc(g,a,c);return}function Esc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0,i=0.0,j=0.0;e=+p[b>>3];f=+p[a>>3];g=+p[c>>3];d=g<e;do if(e<f){if(d){p[a>>3]=g;p[c>>3]=f;h=1;break}p[a>>3]=e;p[b>>3]=f;i=+p[c>>3];if(i<f){p[b>>3]=i;p[c>>3]=f;h=2}else h=1}else if(d){p[b>>3]=g;p[c>>3]=e;i=+p[b>>3];j=+p[a>>3];if(i<j){p[a>>3]=i;p[b>>3]=j;h=2}else h=1}else h=0;while(0);return h|0}function Fsc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0.0,i=0;f=Esc(a,b,c,e)|0;g=+p[d>>3];h=+p[c>>3];if(g<h){p[c>>3]=g;p[d>>3]=h;d=f+1|0;h=+p[c>>3];g=+p[b>>3];if(h<g){p[b>>3]=h;p[c>>3]=g;g=+p[b>>3];h=+p[a>>3];if(g<h){p[a>>3]=g;p[b>>3]=h;i=f+3|0}else i=f+2|0}else i=d}else i=f;return i|0}function Gsc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0;g=Fsc(a,b,c,d,f)|0;h=+p[e>>3];i=+p[d>>3];if(h<i){p[d>>3]=h;p[e>>3]=i;e=g+1|0;i=+p[d>>3];h=+p[c>>3];if(i<h){p[c>>3]=i;p[d>>3]=h;d=g+2|0;h=+p[c>>3];i=+p[b>>3];if(h<i){p[b>>3]=h;p[c>>3]=i;i=+p[b>>3];h=+p[a>>3];if(i<h){p[a>>3]=i;p[b>>3]=h;j=g+4|0}else j=g+3|0}else j=d}else j=e}else j=g;return j|0}function Hsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0,i=0.0,j=0,k=0,l=0;d=a+16|0;Esc(a,a+8|0,d,c)|0;c=a+24|0;e=d;while(1){if((c|0)==(b|0))break;f=+p[c>>3];g=+p[e>>3];if(f<g){d=e;h=c;i=g;while(1){p[h>>3]=i;if((d|0)==(a|0)){j=a;break}k=d+-8|0;i=+p[k>>3];if(!(f<i)){j=d;break}else{l=d;d=k;h=l}}p[j>>3]=f}h=c;c=c+8|0;e=h}return}function Isc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0,r=0;d=b+-8|0;e=a+8|0;f=a+16|0;switch(b-a>>3|0){case 1:case 0:{g=1;break}case 2:{h=+p[d>>3];i=+p[a>>3];if(h<i){p[a>>3]=h;p[d>>3]=i;g=1}else g=1;break}case 3:{Esc(a,e,d,c)|0;g=1;break}case 4:{Fsc(a,e,f,d,c)|0;g=1;break}case 5:{Gsc(a,e,f,a+24|0,d,c)|0;g=1;break}default:{Esc(a,e,f,c)|0;c=a+24|0;e=0;d=f;while(1){if((c|0)==(b|0)){j=1;k=0;break}i=+p[c>>3];h=+p[d>>3];if(i<h){f=d;l=c;m=h;while(1){p[l>>3]=m;if((f|0)==(a|0)){n=a;break}o=f+-8|0;m=+p[o>>3];if(!(i<m)){n=f;break}else{q=f;f=o;l=q}}p[n>>3]=i;l=e+1|0;if((l|0)==8){j=0;k=(c+8|0)==(b|0);break}else r=l}else r=e;l=c;c=c+8|0;e=r;d=l}g=k|j}}return g|0}function Jsc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=u;u=u+16|0;c=b;d=b+8|0;e=b+4|0;f[d>>2]=a;do if(a>>>0>=212){g=(a>>>0)/210|0;h=g*210|0;f[e>>2]=a-h;i=0;j=g;g=(Ksc(181748,181940,e,c)|0)-181748>>2;k=h;a:while(1){l=(f[181748+(g<<2)>>2]|0)+k|0;h=5;while(1){if(h>>>0>=47){m=211;n=i;o=8;break}p=f[181556+(h<<2)>>2]|0;q=(l>>>0)/(p>>>0)|0;if(q>>>0<p>>>0){o=106;break a}if((l|0)==(Y(q,p)|0)){r=i;break}else h=h+1|0}b:do if((o|0)==8){c:while(1){o=0;h=(l>>>0)/(m>>>0)|0;do if(h>>>0>=m>>>0)if((l|0)!=(Y(h,m)|0)){p=m+10|0;q=(l>>>0)/(p>>>0)|0;if(q>>>0>=p>>>0)if((l|0)!=(Y(q,p)|0)){q=m+12|0;s=(l>>>0)/(q>>>0)|0;if(s>>>0>=q>>>0)if((l|0)!=(Y(s,q)|0)){s=m+16|0;t=(l>>>0)/(s>>>0)|0;if(t>>>0>=s>>>0)if((l|0)!=(Y(t,s)|0)){t=m+18|0;v=(l>>>0)/(t>>>0)|0;if(v>>>0>=t>>>0)if((l|0)!=(Y(v,t)|0)){v=m+22|0;w=(l>>>0)/(v>>>0)|0;if(w>>>0>=v>>>0)if((l|0)!=(Y(w,v)|0)){w=m+28|0;x=(l>>>0)/(w>>>0)|0;if(x>>>0>=w>>>0)if((l|0)==(Y(x,w)|0)){y=w;z=9;A=n}else{x=m+30|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+36|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+40|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+42|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+46|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+52|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+58|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+60|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+66|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+70|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+72|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+78|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+82|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+88|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+96|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+100|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+102|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+106|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+108|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+112|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+120|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+126|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+130|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+136|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+138|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+142|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+148|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+150|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+156|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+162|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+166|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+168|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+172|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+178|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+180|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+186|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+190|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+192|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+196|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+198|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+208|0;B=(l>>>0)/(x>>>0)|0;C=B>>>0<x>>>0;D=(l|0)==(Y(B,x)|0);y=C|D?x:m+210|0;z=C?1:D?9:0;A=C?l:n}else{y=w;z=1;A=l}}else{y=v;z=9;A=n}else{y=v;z=1;A=l}}else{y=t;z=9;A=n}else{y=t;z=1;A=l}}else{y=s;z=9;A=n}else{y=s;z=1;A=l}}else{y=q;z=9;A=n}else{y=q;z=1;A=l}}else{y=p;z=9;A=n}else{y=p;z=1;A=l}}else{y=m;z=9;A=n}else{y=m;z=1;A=l}while(0);switch(z&15){case 9:{r=A;break b;break}case 0:{m=y;n=A;o=8;break}default:break c}}if(!z)r=A;else{o=107;break a}}while(0);h=g+1|0;p=(h|0)==48;q=(p&1)+j|0;i=r;j=q;g=p?0:h;k=q*210|0}if((o|0)==106){f[d>>2]=l;E=l;break}else if((o|0)==107){f[d>>2]=l;E=A;break}}else{k=Ksc(181556,181748,d,c)|0;E=f[k>>2]|0}while(0);u=b;return E|0}function Ksc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;d=f[c>>2]|0;c=a;e=b-a>>2;while(1){if(!e)break;a=(e|0)/2|0;b=c+(a<<2)|0;g=(f[b>>2]|0)>>>0<d>>>0;c=g?b+4|0:c;e=g?e+-1-a|0:a}return c|0}function Lsc(a){a=a|0;Msc(a);return}function Msc(a){a=a|0;f[a>>2]=181948;Nsc(a,0);Ivc(a+28|0);poc(f[a+32>>2]|0);poc(f[a+36>>2]|0);poc(f[a+48>>2]|0);poc(f[a+60>>2]|0);return}function Nsc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+32|0;d=a+36|0;e=f[a+40>>2]|0;while(1){if(!e)break;g=e+-1|0;Ti[f[(f[c>>2]|0)+(g<<2)>>2]&511](b,a,f[(f[d>>2]|0)+(g<<2)>>2]|0);e=g}return}function Osc(a){a=a|0;Msc(a);YDc(a);return}function Psc(a){a=a|0;Msc(a);return}function Qsc(a){a=a|0;f[a>>2]=181964;Ivc(a+4|0);return}function Rsc(a){a=a|0;Qsc(a);YDc(a);return}function Ssc(a,b){a=a|0;b=b|0;return}function Tsc(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function Usc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=a;f[g>>2]=0;f[g+4>>2]=0;g=a+8|0;f[g>>2]=-1;f[g+4>>2]=-1;return}function Vsc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;f[d>>2]=0;f[d+4>>2]=0;d=a+8|0;f[d>>2]=-1;f[d+4>>2]=-1;return}function Wsc(a){a=a|0;return 0}function Xsc(a){a=a|0;return 0}function Ysc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;ctc()|0;e=a+12|0;g=a+16|0;h=c;c=0;while(1){if((c|0)>=(d|0))break;i=f[e>>2]|0;j=f[g>>2]|0;if(i>>>0<j>>>0){k=j-i|0;j=d-c|0;l=(j|0)<(k|0)?j:k;etc(h,i,l)|0;f[e>>2]=(f[e>>2]|0)+l;h=h+l|0;c=l+c|0;continue}l=_i[f[(f[a>>2]|0)+40>>2]&1023](a)|0;if((l|0)==-1)break;i=ftc(l)|0;b[h>>0]=i;h=h+1|0;c=c+1|0}return c|0}function Zsc(a){a=a|0;return ctc()|0}function _sc(a){a=a|0;var c=0,d=0;c=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0;if((c|0)==(ctc()|0))d=ctc()|0;else{c=a+12|0;a=f[c>>2]|0;f[c>>2]=a+1;d=dtc(b[a>>0]|0)|0}return d|0}function $sc(a,b){a=a|0;b=b|0;return ctc()|0}function atc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=ctc()|0;g=a+24|0;h=a+28|0;i=c;c=0;while(1){if((c|0)>=(d|0))break;j=f[g>>2]|0;k=f[h>>2]|0;if(j>>>0<k>>>0){l=k-j|0;k=d-c|0;m=(k|0)<(l|0)?k:l;etc(j,i,m)|0;f[g>>2]=(f[g>>2]|0)+m;i=i+m|0;c=m+c|0;continue}m=f[(f[a>>2]|0)+52>>2]|0;j=dtc(b[i>>0]|0)|0;if((Mi[m&1023](a,j)|0)==(e|0))break;i=i+1|0;c=c+1|0}return c|0}function btc(a,b){a=a|0;b=b|0;return ctc()|0}function ctc(){return -1}function dtc(a){a=a|0;return a&255|0}function etc(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)dJc(a|0,b|0,c|0)|0;return a|0}function ftc(a){a=a|0;return a&255|0}function gtc(a){a=a|0;f[a>>2]=182028;Ivc(a+4|0);return}function htc(a){a=a|0;gtc(a);YDc(a);return}function itc(a,b){a=a|0;b=b|0;return}function jtc(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function ktc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=a;f[g>>2]=0;f[g+4>>2]=0;g=a+8|0;f[g>>2]=-1;f[g+4>>2]=-1;return}function ltc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;f[d>>2]=0;f[d+4>>2]=0;d=a+8|0;f[d>>2]=-1;f[d+4>>2]=-1;return}function mtc(a){a=a|0;return 0}function ntc(a){a=a|0;return 0}function otc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;utc()|0;d=a+12|0;e=a+16|0;g=b;b=0;while(1){if((b|0)>=(c|0))break;h=f[d>>2]|0;i=f[e>>2]|0;if(h>>>0<i>>>0){j=i-h>>2;i=c-b|0;k=(i|0)<(j|0)?i:j;wtc(g,h,k)|0;f[d>>2]=(f[d>>2]|0)+(k<<2);g=g+(k<<2)|0;b=k+b|0;continue}k=_i[f[(f[a>>2]|0)+40>>2]&1023](a)|0;if((k|0)==-1)break;h=xtc(k)|0;f[g>>2]=h;g=g+4|0;b=b+1|0}return b|0}function ptc(a){a=a|0;return utc()|0}function qtc(a){a=a|0;var b=0,c=0;b=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0;if((b|0)==(utc()|0))c=utc()|0;else{b=a+12|0;a=f[b>>2]|0;f[b>>2]=a+4;c=vtc(f[a>>2]|0)|0}return c|0}function rtc(a,b){a=a|0;b=b|0;return utc()|0}function stc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=utc()|0;e=a+24|0;g=a+28|0;h=b;b=0;while(1){if((b|0)>=(c|0))break;i=f[e>>2]|0;j=f[g>>2]|0;if(i>>>0<j>>>0){k=j-i>>2;j=c-b|0;l=(j|0)<(k|0)?j:k;wtc(i,h,l)|0;f[e>>2]=(f[e>>2]|0)+(l<<2);h=h+(l<<2)|0;b=l+b|0;continue}l=f[(f[a>>2]|0)+52>>2]|0;i=vtc(f[h>>2]|0)|0;if((Mi[l&1023](a,i)|0)==(d|0))break;h=h+4|0;b=b+1|0}return b|0}function ttc(a,b){a=a|0;b=b|0;return utc()|0}function utc(){return -1}function vtc(a){a=a|0;return a|0}function wtc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=a;else{_qc(a,b,c)|0;d=a}return d|0}function xtc(a){a=a|0;return a|0}function ytc(a){a=a|0;Ctc(a,182124);Lsc(a+8|0);return}function ztc(a){a=a|0;ytc(a);YDc(a);return}function Atc(a){a=a|0;ytc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Btc(a){a=a|0;ztc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Ctc(a,b){a=a|0;b=b|0;return}function Dtc(a){a=a|0;Htc(a,182172);Psc(a+8|0);return}function Etc(a){a=a|0;Dtc(a);YDc(a);return}function Ftc(a){a=a|0;Dtc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Gtc(a){a=a|0;Etc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Htc(a,b){a=a|0;b=b|0;return}function Itc(a){a=a|0;Mtc(a,182180);Lsc(a+4|0);return}function Jtc(a){a=a|0;Itc(a);YDc(a);return}function Ktc(a){a=a|0;Itc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Ltc(a){a=a|0;Jtc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Mtc(a,b){a=a|0;b=b|0;return}function Ntc(a){a=a|0;Rtc(a,182228);Psc(a+4|0);return}function Otc(a){a=a|0;Ntc(a);YDc(a);return}function Ptc(a){a=a|0;Ntc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Qtc(a){a=a|0;Otc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Rtc(a,b){a=a|0;b=b|0;return}function Stc(a){a=a|0;Ytc(a,182296);Lsc(a+12|0);return}function Ttc(a){a=a|0;Stc(a);YDc(a);return}function Utc(a){a=a|0;Stc(a+-8|0);return}function Vtc(a){a=a|0;Ttc(a+-8|0);return}function Wtc(a){a=a|0;Stc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Xtc(a){a=a|0;Ttc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function Ytc(a,b){a=a|0;b=b|0;Mtc(a+8|0,b+12|0);Ctc(a,b+4|0);return}function Ztc(a){a=a|0;return Mpc(a)|0}function _tc(a,c){a=a|0;c=c|0;b[a>>0]=b[c>>0]|0;return}function $tc(a,b){a=a|0;b=b|0;f[a+16>>2]=(f[a+24>>2]|0)==0|b;return}function auc(a,b){a=a|0;b=b|0;var c=0;f[a+24>>2]=b;f[a+16>>2]=(b|0)==0&1;f[a+20>>2]=0;f[a+4>>2]=4098;f[a+12>>2]=0;f[a+8>>2]=6;b=a+28|0;c=a+32|0;a=c+40|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(a|0));LDc(b);return}function buc(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function cuc(a,b){a=a|0;b=b|0;JDc(a,b+28|0);return}function duc(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function euc(a,b){a=a|0;b=b|0;return a<<24>>24==b<<24>>24|0}function fuc(a){a=a|0;var b=0;f[a>>2]=181964;LDc(a+4|0);b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;return}function guc(a){a=a|0;var b=0;f[a>>2]=182028;LDc(a+4|0);b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;return}function huc(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g;b[a>>0]=0;i=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;j=f[i+16>>2]|0;if(!j){k=f[i+72>>2]|0;if(k|0)iuc(k)|0;do if(!e?(k=c+(f[(f[c>>2]|0)+-12>>2]|0)|0,f[k+4>>2]&4096|0):0){cuc(h,k);k=Hvc(h,885240)|0;Ivc(h);l=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0;m=k+8|0;k=l;n=(l|0)==0;o=k+12|0;p=k+16|0;q=l;while(1){if(n){r=0;s=0;break}t=f[o>>2]|0;if((t|0)==(f[p>>2]|0))v=_i[f[(f[q>>2]|0)+36>>2]&1023](k)|0;else v=dtc(b[t>>0]|0)|0;t=buc(v,ctc()|0)|0;w=t?0:l;if(t){r=0;s=0;break}t=w;x=t+12|0;y=f[x>>2]|0;z=t+16|0;if((y|0)==(f[z>>2]|0))A=_i[f[(f[w>>2]|0)+36>>2]&1023](t)|0;else A=dtc(b[y>>0]|0)|0;if((A&255)<<24>>24<=-1){r=t;s=l;break}if(!(d[(f[m>>2]|0)+(A<<24>>24<<1)>>1]&8192)){r=t;s=l;break}y=f[x>>2]|0;if((y|0)==(f[z>>2]|0)){_i[f[(f[w>>2]|0)+40>>2]&1023](t)|0;continue}else{f[x>>2]=y+1;dtc(b[y>>0]|0)|0;continue}}if(s|0){l=f[r+12>>2]|0;if((l|0)==(f[r+16>>2]|0))B=_i[f[(f[s>>2]|0)+36>>2]&1023](r)|0;else B=dtc(b[l>>0]|0)|0;if(!(buc(B,ctc()|0)|0))break}l=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;$tc(l,f[l+16>>2]|6)}while(0);b[a>>0]=(f[c+(f[(f[c>>2]|0)+-12>>2]|0)+16>>2]|0)==0&1}else $tc(i,j|4);u=g;return}function iuc(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0){juc(d,a);if(b[d>>0]|0?(e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,(_i[f[(f[e>>2]|0)+24>>2]&1023](e)|0)==-1):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(e,f[e+16>>2]|1)}kuc(d)}u=c;return a|0}function juc(a,c){a=a|0;c=c|0;var d=0;b[a>>0]=0;f[a+4>>2]=c;d=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;if(!(f[d+16>>2]|0)){c=f[d+72>>2]|0;if(c|0)iuc(c)|0;b[a>>0]=1}return}function kuc(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if((((f[c+24>>2]|0?(f[c+16>>2]|0)==0:0)?f[c+4>>2]&8192|0:0)?!(Kd()|0):0)?(c=f[b>>2]|0,a=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0,(_i[f[(f[a>>2]|0)+24>>2]&1023](a)|0)==-1):0){a=f[b>>2]|0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(b,f[b+16>>2]|1)}return}function luc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d+24|0;g=d+20|0;h=d+16|0;i=d+12|0;j=d+28|0;k=d+8|0;l=d+4|0;m=d;huc(j,a,0);if(b[j>>0]|0){f[k>>2]=0;cuc(m,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=Hvc(m,885264)|0;n=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;o=f[(f[j>>2]|0)+16>>2]|0;f[h>>2]=f[n+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];xg[o&127](j,g,e,n,k,l)|0;Ivc(m);f[c>>2]=f[l>>2];l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function muc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+20|0;g=d+16|0;h=d+12|0;i=d+8|0;j=d+24|0;k=d+4|0;l=d;huc(j,a,0);if(b[j>>0]|0){f[k>>2]=0;cuc(l,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=Hvc(l,885264)|0;m=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;n=f[(f[j>>2]|0)+28>>2]|0;f[h>>2]=f[m+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];xg[n&127](j,g,e,m,k,c)|0;Ivc(l);l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function nuc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+20|0;g=d+16|0;h=d+12|0;i=d+8|0;j=d+24|0;k=d+4|0;l=d;huc(j,a,0);if(b[j>>0]|0){f[k>>2]=0;cuc(l,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=Hvc(l,885264)|0;m=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;n=f[(f[j>>2]|0)+40>>2]|0;f[h>>2]=f[m+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];xg[n&127](j,g,e,m,k,c)|0;Ivc(l);l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function ouc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=a+4|0;f[h>>2]=0;huc(g,a,1);i=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if(b[g>>0]|0){g=f[i+24>>2]|0;j=hj[f[(f[g>>2]|0)+32>>2]&511](g,c,d)|0;f[h>>2]=j;if((j|0)!=(d|0)){d=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(d,f[d+16>>2]|6)}}else $tc(i,f[i+16>>2]|4);u=e;return a|0}function puc(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0){quc(d,a);if(b[d>>0]|0?(e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,(_i[f[(f[e>>2]|0)+24>>2]&1023](e)|0)==-1):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(e,f[e+16>>2]|1)}ruc(d)}u=c;return a|0}function quc(a,c){a=a|0;c=c|0;var d=0;b[a>>0]=0;f[a+4>>2]=c;d=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;if(!(f[d+16>>2]|0)){c=f[d+72>>2]|0;if(c|0)puc(c)|0;b[a>>0]=1}return}function ruc(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if((((f[c+24>>2]|0?(f[c+16>>2]|0)==0:0)?f[c+4>>2]&8192|0:0)?!(Kd()|0):0)?(c=f[b>>2]|0,a=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0,(_i[f[(f[a>>2]|0)+24>>2]&1023](a)|0)==-1):0){a=f[b>>2]|0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(b,f[b+16>>2]|1)}return}function suc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;juc(h,a);if(b[h>>0]|0){cuc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885296)|0;Ivc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ctc()|0;m=j+76|0;if(buc(l,f[m>>2]|0)|0){cuc(e,j);l=Hvc(e,885240)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;Ivc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+16>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(_h[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(c,f[c+16>>2]|5)}}kuc(h);u=d;return a|0}function tuc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;juc(h,a);if(b[h>>0]|0){cuc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885296)|0;Ivc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ctc()|0;m=j+76|0;if(buc(l,f[m>>2]|0)|0){cuc(e,j);l=Hvc(e,885240)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;Ivc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+24>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(_h[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(c,f[c+16>>2]|5)}}kuc(h);u=d;return a|0}function uuc(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;juc(h,a);if(b[h>>0]|0){cuc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885296)|0;Ivc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ctc()|0;m=j+76|0;if(buc(l,f[m>>2]|0)|0){cuc(e,j);l=Hvc(e,885240)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;Ivc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+32>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(ci[m&7](i,e,j,o&255,c)|0)){o=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(o,f[o+16>>2]|5)}}kuc(h);u=d;return a|0}function vuc(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;juc(h,a);if(b[h>>0]|0){cuc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=Hvc(e,885296)|0;Ivc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ctc()|0;m=j+76|0;if(buc(l,f[m>>2]|0)|0){cuc(e,j);l=Hvc(e,885240)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;Ivc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+32>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(ci[m&7](i,e,j,o&255,c)|0)){o=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(o,f[o+16>>2]|5)}}kuc(h);u=d;return a|0}function wuc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;juc(e,a);do if(b[e>>0]|0){g=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;h=g;if(g|0){i=h+24|0;j=f[i>>2]|0;if((j|0)==(f[h+28>>2]|0)){k=f[(f[g>>2]|0)+52>>2]|0;g=dtc(c)|0;l=Mi[k&1023](h,g)|0}else{f[i>>2]=j+1;b[j>>0]=c;l=dtc(c)|0}if(!(buc(l,ctc()|0)|0))break}j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;$tc(j,f[j+16>>2]|1)}while(0);kuc(e);u=d;return a|0}function xuc(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=f[b>>2]|1;return}function yuc(){Auc();return}function zuc(){return}function Auc(){Buc(0);be(1792,1154738,x|0)|0;return}function Buc(a){a=a|0;var b=0;a=f[44443]|0;Duc(884872,a,884928);f[221048]=182096;f[221050]=182116;f[221049]=0;auc(884200,884872);f[221068]=0;b=ctc()|0;f[221069]=b;Euc(884936,a,884992);f[221070]=182144;f[221072]=182164;f[221071]=0;auc(884288,884936);f[221090]=0;a=utc()|0;f[221091]=a;a=f[44475]|0;Fuc(885e3,a,885048);f[221092]=4124;f[221093]=4144;auc(884372,885e3);f[221111]=0;b=ctc()|0;f[221112]=b;Guc(885056,a,885104);f[221113]=182200;f[221114]=182220;auc(884456,885056);f[221132]=0;a=utc()|0;f[221133]=a;a=f[44350]|0;Fuc(885112,a,885160);f[221134]=4124;f[221135]=4144;auc(884540,885112);f[221153]=0;b=ctc()|0;f[221154]=b;b=f[884536+(f[(f[221134]|0)+-12>>2]|0)+24>>2]|0;f[221176]=4124;f[221177]=4144;auc(884708,b);f[221195]=0;b=ctc()|0;f[221196]=b;Guc(885168,a,885216);f[221155]=182200;f[221156]=182220;auc(884624,885168);f[221174]=0;a=utc()|0;f[221175]=a;a=f[884620+(f[(f[221155]|0)+-12>>2]|0)+24>>2]|0;f[221197]=182200;f[221198]=182220;auc(884792,a);f[221216]=0;a=utc()|0;f[221217]=a;f[884192+(f[(f[221048]|0)+-12>>2]|0)+72>>2]=884368;f[884280+(f[(f[221070]|0)+-12>>2]|0)+72>>2]=884452;a=884536+(f[(f[221134]|0)+-12>>2]|0)+4|0;f[a>>2]=f[a>>2]|8192;a=884620+(f[(f[221155]|0)+-12>>2]|0)+4|0;f[a>>2]=f[a>>2]|8192;f[884536+(f[(f[221134]|0)+-12>>2]|0)+72>>2]=884368;f[884620+(f[(f[221155]|0)+-12>>2]|0)+72>>2]=884452;return}function Cuc(a){a=a|0;iuc(884368)|0;puc(884452)|0;iuc(884704)|0;puc(884788)|0;return}function Duc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;fuc(a);f[a>>2]=182524;f[a+32>>2]=c;f[a+40>>2]=d;d=ctc()|0;f[a+48>>2]=d;b[a+52>>0]=0;d=f[(f[a>>2]|0)+8>>2]|0;JDc(g,a+4|0);mi[d&2047](a,g);Ivc(g);u=e;return}function Euc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;guc(a);f[a>>2]=182460;f[a+32>>2]=c;f[a+40>>2]=d;d=utc()|0;f[a+48>>2]=d;b[a+52>>0]=0;d=f[(f[a>>2]|0)+8>>2]|0;JDc(g,a+4|0);mi[d&2047](a,g);Ivc(g);u=e;return}function Fuc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;fuc(a);f[a>>2]=182396;f[a+32>>2]=c;JDc(g,a+4|0);c=Hvc(g,887032)|0;Ivc(g);f[a+36>>2]=c;f[a+40>>2]=d;d=(_i[f[(f[c>>2]|0)+28>>2]&1023](c)|0)&1;b[a+44>>0]=d;u=e;return}function Guc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;guc(a);f[a>>2]=182332;f[a+32>>2]=c;JDc(g,a+4|0);c=Hvc(g,887040)|0;Ivc(g);f[a+36>>2]=c;f[a+40>>2]=d;d=(_i[f[(f[c>>2]|0)+28>>2]&1023](c)|0)&1;b[a+44>>0]=d;u=e;return}function Huc(a){a=a|0;gtc(a);return}function Iuc(a){a=a|0;Huc(a);YDc(a);return}function Juc(a,c){a=a|0;c=c|0;var d=0;_i[f[(f[a>>2]|0)+24>>2]&1023](a)|0;d=Hvc(c,887040)|0;f[a+36>>2]=d;c=(_i[f[(f[d>>2]|0)+28>>2]&1023](d)|0)&1;b[a+44>>0]=c;return}function Kuc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+36|0;g=a+40|0;h=c+8|0;i=c;j=a+32|0;a:while(1){a=f[e>>2]|0;k=_h[f[(f[a>>2]|0)+20>>2]&127](a,f[g>>2]|0,c,h,d)|0;a=(f[d>>2]|0)-i|0;if((Npc(c,1,a,f[j>>2]|0)|0)!=(a|0)){l=-1;break}switch(k|0){case 1:break;case 2:{l=-1;break a;break}default:{m=4;break a}}}if((m|0)==4)l=((aqc(f[j>>2]|0)|0)!=0)<<31>>31;u=b;return l|0}function Luc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if(!(b[a+44>>0]|0)){e=0;g=c;while(1){if((e|0)>=(d|0)){h=e;break a}i=f[(f[a>>2]|0)+52>>2]|0;j=vtc(f[g>>2]|0)|0;k=Mi[i&1023](a,j)|0;if((k|0)==(utc()|0)){h=e;break a}e=e+1|0;g=g+4|0}}else h=Npc(c,4,d,f[a+32>>2]|0)|0;while(0);return h|0}function Muc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;do if(!(duc(c,utc()|0)|0)){j=xtc(c)|0;f[g>>2]=j;j=a+32|0;if(b[a+44>>0]|0){if((Npc(g,4,1,f[j>>2]|0)|0)==1){k=15;break}l=utc()|0;break}f[h>>2]=e;m=g+4|0;n=a+36|0;o=a+40|0;p=e+8|0;q=e;r=g;while(1){s=f[n>>2]|0;t=Ij[f[(f[s>>2]|0)+12>>2]&15](s,f[o>>2]|0,r,m,i,e,p,h)|0;s=(t|0)==1;if((f[i>>2]|0)==(r|0)){k=14;break}if((t|0)==3)if((Npc(r,1,1,f[j>>2]|0)|0)==1)v=r;else{k=14;break}else{if((t|1|0)!=1){k=14;break}t=(f[h>>2]|0)-q|0;if((Npc(e,1,t,f[j>>2]|0)|0)!=(t|0)){k=14;break}v=s?f[i>>2]|0:r}if(s)r=v;else{k=13;break}}if((k|0)==13){k=15;break}else if((k|0)==14){l=utc()|0;break}}else k=15;while(0);if((k|0)==15)l=Nuc(c)|0;u=d;return l|0}function Nuc(a){a=a|0;var b=0;if(duc(a,utc()|0)|0)b=~(utc()|0);else b=a;return b|0}function Ouc(a){a=a|0;Qsc(a);return}function Puc(a){a=a|0;Ouc(a);YDc(a);return}function Quc(a,c){a=a|0;c=c|0;var d=0;_i[f[(f[a>>2]|0)+24>>2]&1023](a)|0;d=Hvc(c,887032)|0;f[a+36>>2]=d;c=(_i[f[(f[d>>2]|0)+28>>2]&1023](d)|0)&1;b[a+44>>0]=c;return}function Ruc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+36|0;g=a+40|0;h=c+8|0;i=c;j=a+32|0;a:while(1){a=f[e>>2]|0;k=_h[f[(f[a>>2]|0)+20>>2]&127](a,f[g>>2]|0,c,h,d)|0;a=(f[d>>2]|0)-i|0;if((Npc(c,1,a,f[j>>2]|0)|0)!=(a|0)){l=-1;break}switch(k|0){case 1:break;case 2:{l=-1;break a;break}default:{m=4;break a}}}if((m|0)==4)l=((aqc(f[j>>2]|0)|0)!=0)<<31>>31;u=b;return l|0}function Suc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if(!(b[a+44>>0]|0)){e=0;g=c;while(1){if((e|0)>=(d|0)){h=e;break a}i=f[(f[a>>2]|0)+52>>2]|0;j=dtc(b[g>>0]|0)|0;k=Mi[i&1023](a,j)|0;if((k|0)==(ctc()|0)){h=e;break a}e=e+1|0;g=g+1|0}}else h=Npc(c,1,d,f[a+32>>2]|0)|0;while(0);return h|0}function Tuc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;do if(!(buc(c,ctc()|0)|0)){j=ftc(c)|0;b[g>>0]=j;j=a+32|0;if(b[a+44>>0]|0){if((Npc(g,1,1,f[j>>2]|0)|0)==1){k=15;break}l=ctc()|0;break}f[h>>2]=e;m=g+1|0;n=a+36|0;o=a+40|0;p=e+8|0;q=e;r=g;while(1){s=f[n>>2]|0;t=Ij[f[(f[s>>2]|0)+12>>2]&15](s,f[o>>2]|0,r,m,i,e,p,h)|0;s=(t|0)==1;if((f[i>>2]|0)==(r|0)){k=14;break}if((t|0)==3)if((Npc(r,1,1,f[j>>2]|0)|0)==1)v=r;else{k=14;break}else{if((t|1|0)!=1){k=14;break}t=(f[h>>2]|0)-q|0;if((Npc(e,1,t,f[j>>2]|0)|0)!=(t|0)){k=14;break}v=s?f[i>>2]|0:r}if(s)r=v;else{k=13;break}}if((k|0)==13){k=15;break}else if((k|0)==14){l=ctc()|0;break}}else k=15;while(0);if((k|0)==15)l=Uuc(c)|0;u=d;return l|0}function Uuc(a){a=a|0;var b=0;if(buc(a,ctc()|0)|0)b=~(ctc()|0);else b=a;return b|0}function Vuc(a){a=a|0;gtc(a);return}function Wuc(a){a=a|0;Vuc(a);YDc(a);return}function Xuc(a,c){a=a|0;c=c|0;var d=0,e=0;d=Hvc(c,887040)|0;c=a+36|0;f[c>>2]=d;e=_i[f[(f[d>>2]|0)+24>>2]&1023](d)|0;d=a+44|0;f[d>>2]=e;e=f[c>>2]|0;c=(_i[f[(f[e>>2]|0)+28>>2]&1023](e)|0)&1;b[a+53>>0]=c;if((f[d>>2]|0)>8)azc(514781);else return}function Yuc(a){a=a|0;return $uc(a,0)|0}function Zuc(a){a=a|0;return $uc(a,1)|0}function _uc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=duc(c,utc()|0)|0;k=a+52|0;l=(b[k>>0]|0)!=0;m=a+48|0;do if(j)if(l)n=c;else{o=f[m>>2]|0;p=((duc(o,utc()|0)|0)^1)&1;b[k>>0]=p;n=o}else{if(l){o=xtc(f[m>>2]|0)|0;f[h>>2]=o;o=f[a+36>>2]|0;switch(Ij[f[(f[o>>2]|0)+12>>2]&15](o,f[a+40>>2]|0,h,h+4|0,i,e,e+8|0,g)|0){case 1:case 2:{q=10;break}case 3:{b[e>>0]=f[m>>2];f[g>>2]=e+1;q=7;break}default:q=7}a:do if((q|0)==7){o=a+32|0;while(1){p=f[g>>2]|0;if(p>>>0<=e>>>0){r=1;s=0;break a}t=p+-1|0;f[g>>2]=t;if((nqc(b[t>>0]|0,f[o>>2]|0)|0)==-1){q=10;break}}}while(0);if((q|0)==10){r=0;s=utc()|0}if(!r){n=s;break}}f[m>>2]=c;b[k>>0]=1;n=c}while(0);u=d;return n|0}function $uc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=a+52|0;k=a+48|0;if(b[j>>0]|0){l=f[k>>2]|0;if(c){m=utc()|0;f[k>>2]=m;b[j>>0]=0;n=l}else n=l}else{l=f[a+44>>2]|0;j=(l|0)>1?l:1;l=a+32|0;m=0;while(1){if((m|0)>=(j|0)){o=9;break}p=dqc(f[l>>2]|0)|0;if((p|0)==-1){o=8;break}b[e+m>>0]=p;m=m+1|0}if((o|0)==8)q=utc()|0;else if((o|0)==9){do if(!(b[a+53>>0]|0)){m=a+40|0;p=a+36|0;r=g+4|0;s=j;a:while(1){t=f[m>>2]|0;v=t;w=f[v>>2]|0;x=f[v+4>>2]|0;v=f[p>>2]|0;y=e+s|0;switch(Ij[f[(f[v>>2]|0)+16>>2]&15](v,t,e,y,h,g,r,i)|0){case 3:{o=16;break a;break}case 2:{o=18;break a;break}case 1:break;default:break a}t=f[m>>2]|0;f[t>>2]=w;f[t+4>>2]=x;if((s|0)==8){o=18;break}x=dqc(f[l>>2]|0)|0;if((x|0)==-1){o=18;break}b[y>>0]=x;s=s+1|0}if((o|0)==16)f[g>>2]=b[e>>0];else if((o|0)==18){z=utc()|0;break}A=s;o=19}else{f[g>>2]=b[e>>0];A=j;o=19}while(0);b:do if((o|0)==19){c:do if(c){j=vtc(f[g>>2]|0)|0;f[k>>2]=j}else{j=A;do{if((j|0)<=0)break c;j=j+-1|0;i=vtc(b[e+j>>0]|0)|0}while((nqc(i,f[l>>2]|0)|0)!=-1);z=utc()|0;break b}while(0);z=vtc(f[g>>2]|0)|0}while(0);q=z}n=q}u=d;return n|0}function avc(a){a=a|0;Qsc(a);return}function bvc(a){a=a|0;avc(a);YDc(a);return}function cvc(a,c){a=a|0;c=c|0;var d=0,e=0;d=Hvc(c,887032)|0;c=a+36|0;f[c>>2]=d;e=_i[f[(f[d>>2]|0)+24>>2]&1023](d)|0;d=a+44|0;f[d>>2]=e;e=f[c>>2]|0;c=(_i[f[(f[e>>2]|0)+28>>2]&1023](e)|0)&1;b[a+53>>0]=c;if((f[d>>2]|0)>8)azc(514781);else return}function dvc(a){a=a|0;return gvc(a,0)|0}function evc(a){a=a|0;return gvc(a,1)|0}function fvc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d+4|0;h=d+8|0;i=d;j=buc(c,ctc()|0)|0;k=a+52|0;l=(b[k>>0]|0)!=0;m=a+48|0;do if(j)if(l)n=c;else{o=f[m>>2]|0;p=((buc(o,ctc()|0)|0)^1)&1;b[k>>0]=p;n=o}else{if(l){o=ftc(f[m>>2]|0)|0;b[h>>0]=o;o=f[a+36>>2]|0;switch(Ij[f[(f[o>>2]|0)+12>>2]&15](o,f[a+40>>2]|0,h,h+1|0,i,e,e+8|0,g)|0){case 1:case 2:{q=10;break}case 3:{b[e>>0]=f[m>>2];f[g>>2]=e+1;q=7;break}default:q=7}a:do if((q|0)==7){o=a+32|0;while(1){p=f[g>>2]|0;if(p>>>0<=e>>>0){r=1;s=0;break a}t=p+-1|0;f[g>>2]=t;if((nqc(b[t>>0]|0,f[o>>2]|0)|0)==-1){q=10;break}}}while(0);if((q|0)==10){r=0;s=ctc()|0}if(!r){n=s;break}}f[m>>2]=c;b[k>>0]=1;n=c}while(0);u=d;return n|0}function gvc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=a+52|0;k=a+48|0;if(b[j>>0]|0){l=f[k>>2]|0;if(c){m=ctc()|0;f[k>>2]=m;b[j>>0]=0;n=l}else n=l}else{l=f[a+44>>2]|0;j=(l|0)>1?l:1;l=a+32|0;m=0;while(1){if((m|0)>=(j|0)){o=9;break}p=dqc(f[l>>2]|0)|0;if((p|0)==-1){o=8;break}b[e+m>>0]=p;m=m+1|0}if((o|0)==8)q=ctc()|0;else if((o|0)==9){do if(!(b[a+53>>0]|0)){m=a+40|0;p=a+36|0;r=g+1|0;s=j;a:while(1){t=f[m>>2]|0;v=t;w=f[v>>2]|0;x=f[v+4>>2]|0;v=f[p>>2]|0;y=e+s|0;switch(Ij[f[(f[v>>2]|0)+16>>2]&15](v,t,e,y,h,g,r,i)|0){case 3:{o=16;break a;break}case 2:{o=18;break a;break}case 1:break;default:break a}t=f[m>>2]|0;f[t>>2]=w;f[t+4>>2]=x;if((s|0)==8){o=18;break}x=dqc(f[l>>2]|0)|0;if((x|0)==-1){o=18;break}b[y>>0]=x;s=s+1|0}if((o|0)==16)b[g>>0]=b[e>>0]|0;else if((o|0)==18){z=ctc()|0;break}A=s;o=19}else{b[g>>0]=b[e>>0]|0;A=j;o=19}while(0);b:do if((o|0)==19){c:do if(c){j=dtc(b[g>>0]|0)|0;f[k>>2]=j}else{j=A;do{if((j|0)<=0)break c;j=j+-1|0;i=dtc(b[e+j>>0]|0)|0}while((nqc(i,f[l>>2]|0)|0)!=-1);z=ctc()|0;break b}while(0);z=dtc(b[g>>0]|0)|0}while(0);q=z}n=q}u=d;return n|0}function hvc(a){a=a|0;nvc(a);return}function ivc(a){a=a|0;hvc(a);YDc(a);return}function jvc(a){a=a|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function kvc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=e;e=c;while(1){if((a|0)==(f|0)){g=7;break}if((e|0)==(d|0)){h=-1;break}c=b[e>>0]|0;i=b[a>>0]|0;if(c<<24>>24<i<<24>>24){h=-1;break}if(i<<24>>24<c<<24>>24){h=1;break}a=a+1|0;e=e+1|0}if((g|0)==7)h=(e|0)!=(d|0)&1;return h|0}function lvc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=e-d|0;if(h>>>0>4294967279)dEc(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=VDc(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}k=d;d=i;while(1){if((k|0)==(e|0))break;_tc(d,k);k=k+1|0;d=d+1|0}b[g>>0]=0;_tc(i+h|0,g);u=c;return}function mvc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;a=0;e=c;while(1){if((e|0)==(d|0))break;c=(b[e>>0]|0)+(a<<4)|0;f=c&-268435456;a=(f>>>24|f)^c;e=e+1|0}return a|0}function nvc(a){a=a|0;return}function ovc(a){a=a|0;nvc(a);return}function pvc(a){a=a|0;ovc(a);YDc(a);return}function qvc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a=d;d=b;while(1){if((a|0)==(e|0)){g=7;break}if((d|0)==(c|0)){h=-1;break}b=f[d>>2]|0;i=f[a>>2]|0;if((b|0)<(i|0)){h=-1;break}if((i|0)<(b|0)){h=1;break}a=a+4|0;d=d+4|0}if((g|0)==7)h=(d|0)!=(c|0)&1;return h|0}function rvc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=e-d>>2;if(h>>>0>1073741807)dEc(a);do if(h>>>0>=2){i=h+4&-4;if(i>>>0>1073741823)tf();else{j=VDc(i<<2)|0;f[a>>2]=j;f[a+8>>2]=i|-2147483648;f[a+4>>2]=h;k=d;l=j;break}}else{b[a+8+3>>0]=h;k=d;l=a}while(0);while(1){if((k|0)==(e|0))break;tvc(l,k);k=k+4|0;l=l+4|0}f[g>>2]=0;tvc(l,g);u=c;return}function svc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=0;d=b;while(1){if((d|0)==(c|0))break;b=(f[d>>2]|0)+(a<<4)|0;e=b&-268435456;a=(e>>>24|e)^b;d=d+4|0}return a|0}function tvc(a,b){a=a|0;b=b|0;f[a>>2]=f[b>>2];return}function uvc(a){a=a|0;nvc(a);return}function vvc(a){a=a|0;nvc(a);YDc(a);return}function wvc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+48|0;j=i+40|0;k=i+16|0;l=i+8|0;m=i+12|0;n=i+4|0;o=i;if(!(f[e+4>>2]&1)){f[l>>2]=-1;p=f[(f[a>>2]|0)+16>>2]|0;f[m>>2]=f[c>>2];f[n>>2]=f[d>>2];f[k>>2]=f[m>>2];f[j>>2]=f[n>>2];n=xg[p&127](a,k,j,e,g,l)|0;f[c>>2]=n;switch(f[l>>2]|0){case 0:{b[h>>0]=0;break}case 1:{b[h>>0]=1;break}default:{b[h>>0]=1;f[g>>2]=4}}q=f[c>>2]|0}else{cuc(j,e);l=Hvc(j,885240)|0;Ivc(j);cuc(j,e);e=Hvc(j,885256)|0;Ivc(j);mi[f[(f[e>>2]|0)+24>>2]&2047](k,e);mi[f[(f[e>>2]|0)+28>>2]&2047](k+12|0,e);f[o>>2]=f[d>>2];d=k+24|0;f[j>>2]=f[o>>2];o=(nwc(c,j,k,d,l,g,1)|0)==(k|0)&1;b[h>>0]=o;o=f[c>>2]|0;c=d;do{c=c+-12|0;hEc(c)}while((c|0)!=(k|0));q=o}u=i;return q|0}function xvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=lwc(a,j,i,d,e,g)|0;u=h;return l|0}function yvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=jwc(a,j,i,d,e,g)|0;u=h;return l|0}function zvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=hwc(a,j,i,d,e,g)|0;u=h;return l|0}function Avc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=fwc(a,j,i,d,e,g)|0;u=h;return l|0}function Bvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=dwc(a,j,i,d,e,g)|0;u=h;return l|0}function Cvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=$vc(a,j,i,d,e,g)|0;u=h;return l|0}function Dvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Zvc(a,j,i,d,e,g)|0;u=h;return l|0}function Evc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Xvc(a,j,i,d,e,g)|0;u=h;return l|0}function Fvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Svc(a,j,i,d,e,g)|0;u=h;return l|0}function Gvc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=u;u=u+240|0;i=a;j=a+204|0;k=a+192|0;l=a+180|0;m=a+176|0;n=a+16|0;o=a+8|0;p=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}cuc(l,e);e=Hvc(l,885240)|0;hh[f[(f[e>>2]|0)+32>>2]&127](e,514929,514955,j)|0;Ivc(l);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;q=l+8|0;if((b[e>>0]|0)<0)r=(f[q>>2]&2147483647)+-1|0;else r=10;oEc(l,r,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r;f[o>>2]=n;f[p>>2]=0;s=l+4|0;t=f[c>>2]|0;v=r;r=t;w=t;a:while(1){if(r){t=f[r+12>>2]|0;if((t|0)==(f[r+16>>2]|0))x=_i[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else x=dtc(b[t>>0]|0)|0;if(buc(x,ctc()|0)|0){f[c>>2]=0;y=0;z=0;A=1}else{y=r;z=w;A=0}}else{y=0;z=0;A=1}t=f[d>>2]|0;do if(t){B=f[t+12>>2]|0;if((B|0)==(f[t+16>>2]|0))C=_i[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else C=dtc(b[B>>0]|0)|0;if(!(buc(C,ctc()|0)|0))if(A){D=t;break}else{E=v;F=t;break a}else{f[d>>2]=0;G=22;break}}else G=22;while(0);if((G|0)==22){G=0;if(A){E=v;F=0;break}else D=0}t=b[e>>0]|0;B=t<<24>>24<0?f[s>>2]|0:t&255;if((f[m>>2]|0)==(v+B|0)){oEc(l,B<<1,0);if((b[e>>0]|0)<0)H=(f[q>>2]&2147483647)+-1|0;else H=10;oEc(l,H,0);t=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=t+B;I=t}else I=v;t=y+12|0;B=f[t>>2]|0;J=y+16|0;if((B|0)==(f[J>>2]|0))K=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else K=dtc(b[B>>0]|0)|0;if(Jvc(K&255,16,I,m,p,0,k,n,o,j)|0){E=I;F=D;break}B=f[t>>2]|0;if((B|0)==(f[J>>2]|0)){_i[f[(f[y>>2]|0)+40>>2]&1023](y)|0;v=I;r=y;w=z;continue}else{f[t>>2]=B+1;dtc(b[B>>0]|0)|0;v=I;r=y;w=z;continue}}oEc(l,(f[m>>2]|0)-E|0,0);E=(b[e>>0]|0)<0?f[l>>2]|0:l;e=Kvc()|0;f[i>>2]=h;if((Lvc(E,e,514962,i)|0)!=1)f[g>>2]=4;if(y){i=f[y+12>>2]|0;if((i|0)==(f[y+16>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&1023](y)|0;else L=dtc(b[i>>0]|0)|0;if(buc(L,ctc()|0)|0){f[c>>2]=0;M=1}else M=0}else M=1;do if(F){L=f[F+12>>2]|0;if((L|0)==(f[F+16>>2]|0))N=_i[f[(f[F>>2]|0)+36>>2]&1023](F)|0;else N=dtc(b[L>>0]|0)|0;if(!(buc(N,ctc()|0)|0))if(M)break;else{G=51;break}else{f[d>>2]=0;G=49;break}}else G=49;while(0);if((G|0)==49?M:0)G=51;if((G|0)==51)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function Hvc(a,b){a=a|0;b=b|0;var c=0;c=f[a>>2]|0;return Nvc(c,Mvc(b)|0)|0}function Ivc(a){a=a|0;SDc(f[a>>2]|0)|0;return}function Jvc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=f[e>>2]|0;n=(m|0)==(d|0);do if(n){o=(b[l+24>>0]|0)==a<<24>>24;if(!o?(b[l+25>>0]|0)!=a<<24>>24:0){p=5;break}f[e>>2]=d+1;b[d>>0]=o?43:45;f[g>>2]=0;q=0}else p=5;while(0);a:do if((p|0)==5){o=b[i+11>>0]|0;if(a<<24>>24==h<<24>>24?((o<<24>>24<0?f[i+4>>2]|0:o&255)|0)!=0:0){o=f[k>>2]|0;if((o-j|0)>=160){q=0;break}r=f[g>>2]|0;f[k>>2]=o+4;f[o>>2]=r;f[g>>2]=0;q=0;break}r=l+26|0;o=0;while(1){s=l+o|0;if((o|0)==26){t=r;break}if((b[s>>0]|0)==a<<24>>24){t=s;break}else o=o+1|0}o=t-l|0;if((o|0)>23)q=-1;else{r=514929+o|0;switch(c|0){case 10:case 8:{if((o|0)>=(c|0)){q=-1;break a}break}case 16:{if((o|0)>=22){if(n){q=-1;break a}if((m-d|0)>=3){q=-1;break a}if((b[m+-1>>0]|0)!=48){q=-1;break a}f[g>>2]=0;o=b[r>>0]|0;f[e>>2]=m+1;b[m>>0]=o;q=0;break a}break}default:{}}o=b[r>>0]|0;f[e>>2]=m+1;b[m>>0]=o;f[g>>2]=(f[g>>2]|0)+1;q=0}}while(0);return q|0}function Kvc(){var a=0;if((b[529352]|0)==0?MIc(529352)|0:0){a=$qc(2147483647,514965,0)|0;f[221312]=a}return f[221312]|0}function Lvc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=Rqc(b)|0;b=oqc(a,c,g)|0;if(d|0)Rqc(d)|0;u=e;return b|0}function Mvc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+48|0;c=b+32|0;d=b+24|0;e=b;g=b+16|0;f[g>>2]=1793;f[g+4>>2]=0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];Pvc(e,c,a);if((f[a>>2]|0)!=-1){f[c>>2]=e;f[d>>2]=c;UDc(a,d,1794)}u=b;return (f[a+4>>2]|0)+-1|0}function Nvc(a,b){a=a|0;b=b|0;return f[(f[a+8>>2]|0)+(b<<2)>>2]|0}function Ovc(a){a=a|0;var b=0;b=f[221313]|0;f[221313]=b+1;f[a+4>>2]=b+1;return}function Pvc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b>>2]|0;e=f[b+4>>2]|0;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;return}function Qvc(a){a=a|0;Rvc(f[f[a>>2]>>2]|0);return}function Rvc(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=f[a+8>>2]|0;d=(f[a>>2]|0)+(c>>1)|0;if(!(c&1))e=b;else e=f[(f[d>>2]|0)+b>>2]|0;Yi[e&2047](d);return}function Svc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;Tvc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;oEc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=dtc(b[y>>0]|0)|0;if(buc(B,ctc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=dtc(b[F>>0]|0)|0;if(!(buc(G,ctc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){oEc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;oEc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=dtc(b[F>>0]|0)|0;if(Uvc(O&255,s,t,M,n,b[j>>0]|0,b[k>>0]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;dtc(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+Vvc(I,f[n>>2]|0,g);p[h>>3]=P;Wvc(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=dtc(b[q>>0]|0)|0;if(buc(Q,ctc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=dtc(b[Q>>0]|0)|0;if(!(buc(S,ctc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(m);hEc(l);u=a;return g|0}function Tvc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;cuc(i,c);c=Hvc(i,885240)|0;hh[f[(f[c>>2]|0)+32>>2]&127](c,514929,514961,d)|0;d=Hvc(i,885256)|0;c=_i[f[(f[d>>2]|0)+12>>2]&1023](d)|0;b[e>>0]=c;c=_i[f[(f[d>>2]|0)+16>>2]&1023](d)|0;b[g>>0]=c;mi[f[(f[d>>2]|0)+20>>2]&2047](a,d);Ivc(i);u=h;return}function Uvc(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;o=k;a:do if(a<<24>>24==h<<24>>24)if(b[c>>0]|0){b[c>>0]=0;k=f[g>>2]|0;f[g>>2]=k+1;b[k>>0]=46;k=b[j+11>>0]|0;if(((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)!=0?(k=f[l>>2]|0,(k-o|0)<160):0){p=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=p;q=0}else q=0}else q=-1;else{if(a<<24>>24==i<<24>>24?(p=b[j+11>>0]|0,(p<<24>>24<0?f[j+4>>2]|0:p&255)|0):0){if(!(b[c>>0]|0)){q=-1;break}p=f[l>>2]|0;if((p-o|0)>=160){q=0;break}k=f[m>>2]|0;f[l>>2]=p+4;f[p>>2]=k;f[m>>2]=0;q=0;break}k=n+32|0;p=0;while(1){r=n+p|0;if((p|0)==32){s=k;break}if((b[r>>0]|0)==a<<24>>24){s=r;break}else p=p+1|0}p=s-n|0;if((p|0)>31)q=-1;else{k=b[514929+p>>0]|0;switch(p|0){case 24:case 25:{r=f[g>>2]|0;if((r|0)!=(e|0)?(b[r+-1>>0]&95)!=(b[d>>0]&127):0){q=-1;break a}f[g>>2]=r+1;b[r>>0]=k;q=0;break a;break}case 23:case 22:{b[d>>0]=80;r=f[g>>2]|0;f[g>>2]=r+1;b[r>>0]=k;q=0;break a;break}default:{r=k&95;if((((r|0)==(b[d>>0]|0)?(b[d>>0]=r|128,b[c>>0]|0):0)?(b[c>>0]=0,r=b[j+11>>0]|0,(r<<24>>24<0?f[j+4>>2]|0:r&255)|0):0)?(r=f[l>>2]|0,(r-o|0)<160):0){t=f[m>>2]|0;f[l>>2]=r+4;f[r>>2]=t}t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=k;if((p|0)>21){q=0;break a}f[m>>2]=(f[m>>2]|0)+1;q=0;break a}}}}while(0);return q|0}function Vvc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=zoc()|0;i=f[h>>2]|0;h=zoc()|0;f[h>>2]=0;j=+urc(a,e,Kvc()|0);a=zoc()|0;h=f[a>>2]|0;if(!h){a=zoc()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function Wvc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=b[a+11>>0]|0;h=g<<24>>24<0;i=a+4|0;j=f[i>>2]|0;k=g&255;do if((h?j:k)|0){if((c|0)==(d|0))l=j;else{g=d;m=c;while(1){n=g+-4|0;if(m>>>0>=n>>>0)break;o=f[m>>2]|0;f[m>>2]=f[n>>2];f[n>>2]=o;g=n;m=m+4|0}l=f[i>>2]|0}m=h?f[a>>2]|0:a;g=d+-4|0;n=m+(h?l:k)|0;o=c;p=m;while(1){q=b[p>>0]|0;r=q<<24>>24>0&q<<24>>24!=127;if(o>>>0>=g>>>0)break;if(r?(q<<24>>24|0)!=(f[o>>2]|0):0){s=10;break}o=o+4|0;p=(n-p|0)>1?p+1|0:p}if((s|0)==10){f[e>>2]=4;break}if(r?((f[g>>2]|0)+-1|0)>>>0>=q<<24>>24>>>0:0)f[e>>2]=4}while(0);return}function Xvc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;Tvc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;oEc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=dtc(b[y>>0]|0)|0;if(buc(B,ctc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=dtc(b[F>>0]|0)|0;if(!(buc(G,ctc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){oEc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;oEc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=dtc(b[F>>0]|0)|0;if(Uvc(O&255,s,t,M,n,b[j>>0]|0,b[k>>0]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;dtc(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+Yvc(I,f[n>>2]|0,g);p[h>>3]=P;Wvc(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=dtc(b[q>>0]|0)|0;if(buc(Q,ctc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=dtc(b[Q>>0]|0)|0;if(!(buc(S,ctc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(m);hEc(l);u=a;return g|0}function Yvc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=zoc()|0;i=f[h>>2]|0;h=zoc()|0;f[h>>2]=0;j=+trc(a,e,Kvc()|0);a=zoc()|0;h=f[a>>2]|0;if(!h){a=zoc()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function Zvc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;o=a+168|0;p=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;Tvc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;oEc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w;f[q>>2]=p;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=dtc(b[y>>0]|0)|0;if(buc(B,ctc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=dtc(b[F>>0]|0)|0;if(!(buc(G,ctc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[o>>2]|0)==(z+F|0)){oEc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;oEc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=dtc(b[F>>0]|0)|0;if(Uvc(O&255,s,t,M,o,b[j>>0]|0,b[k>>0]|0,l,p,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;dtc(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-p|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+_vc(I,f[o>>2]|0,g);n[h>>2]=P;Wvc(l,p,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=dtc(b[q>>0]|0)|0;if(buc(Q,ctc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=dtc(b[Q>>0]|0)|0;if(!(buc(S,ctc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(m);hEc(l);u=a;return g|0}function _vc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=zoc()|0;i=f[h>>2]|0;h=zoc()|0;f[h>>2]=0;j=+src(a,e,Kvc()|0);a=zoc()|0;h=f[a>>2]|0;if(!h){a=zoc()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function $vc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;bwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=dtc(b[v>>0]|0)|0;if(buc(y,ctc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=dtc(b[C>>0]|0)|0;if(!(buc(D,ctc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else M=dtc(b[C>>0]|0)|0;if(Jvc(M&255,q,K,m,p,b[j>>0]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+1;dtc(b[C>>0]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=cwc(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else N=dtc(b[o>>0]|0)|0;if(buc(N,ctc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else P=dtc(b[N>>0]|0)|0;if(!(buc(P,ctc()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function awc(a){a=a|0;var b=0;switch(f[a+4>>2]&74){case 64:{b=8;break}case 8:{b=16;break}case 0:{b=0;break}default:b=10}return b|0}function bwc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;cuc(h,c);c=Hvc(h,885240)|0;hh[f[(f[c>>2]|0)+32>>2]&127](c,514929,514955,d)|0;d=Hvc(h,885256)|0;c=_i[f[(f[d>>2]|0)+16>>2]&1023](d)|0;b[e>>0]=c;mi[f[(f[d>>2]|0)+20>>2]&2047](a,d);Ivc(h);u=g;return}function cwc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0;j=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;j=0;break}k=zoc()|0;l=f[k>>2]|0;k=zoc()|0;f[k>>2]=0;k=Orc(a,h,e,Kvc()|0)|0;m=J;n=zoc()|0;o=f[n>>2]|0;if(!o){n=zoc()|0;f[n>>2]=l}if((f[h>>2]|0)==(c|0))if((o|0)==34){p=-1;q=-1;r=8}else{s=k;t=m}else{p=0;q=0;r=8}if((r|0)==8){f[d>>2]=4;s=p;t=q}i=t;j=s}while(0);J=i;u=g;return j|0}function dwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;bwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=dtc(b[v>>0]|0)|0;if(buc(y,ctc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=dtc(b[C>>0]|0)|0;if(!(buc(D,ctc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=dtc(b[C>>0]|0)|0;if(Jvc(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;dtc(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=ewc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=dtc(b[o>>0]|0)|0;if(buc(M,ctc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=dtc(b[M>>0]|0)|0;if(!(buc(O,ctc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function ewc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=zoc()|0;k=f[j>>2]|0;j=zoc()|0;f[j>>2]=0;j=Orc(a,h,e,Kvc()|0)|0;l=J;m=zoc()|0;n=f[m>>2]|0;if(!n){m=zoc()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>4294967295|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function fwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;bwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=dtc(b[v>>0]|0)|0;if(buc(y,ctc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=dtc(b[C>>0]|0)|0;if(!(buc(D,ctc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=dtc(b[C>>0]|0)|0;if(Jvc(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;dtc(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=gwc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=dtc(b[o>>0]|0)|0;if(buc(M,ctc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=dtc(b[M>>0]|0)|0;if(!(buc(O,ctc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function gwc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=zoc()|0;k=f[j>>2]|0;j=zoc()|0;f[j>>2]=0;j=Orc(a,h,e,Kvc()|0)|0;l=J;m=zoc()|0;n=f[m>>2]|0;if(!n){m=zoc()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>4294967295|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function hwc(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;j=a+198|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;p=a+4|0;q=a;r=awc(g)|0;bwc(l,g,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[m+(g<<2)>>2]=0;g=g+1|0}g=m+11|0;s=m+8|0;if((b[g>>0]|0)<0)t=(f[s>>2]&2147483647)+-1|0;else t=10;oEc(m,t,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t;f[p>>2]=o;f[q>>2]=0;v=m+4|0;w=f[c>>2]|0;x=t;t=w;y=w;a:while(1){if(t){w=f[t+12>>2]|0;if((w|0)==(f[t+16>>2]|0))z=_i[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else z=dtc(b[w>>0]|0)|0;if(buc(z,ctc()|0)|0){f[c>>2]=0;A=0;B=0;C=1}else{A=t;B=y;C=0}}else{A=0;B=0;C=1}w=f[e>>2]|0;do if(w){D=f[w+12>>2]|0;if((D|0)==(f[w+16>>2]|0))E=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else E=dtc(b[D>>0]|0)|0;if(!(buc(E,ctc()|0)|0))if(C){F=w;break}else{G=x;H=w;break a}else{f[e>>2]=0;I=19;break}}else I=19;while(0);if((I|0)==19){I=0;if(C){G=x;H=0;break}else F=0}w=b[g>>0]|0;D=w<<24>>24<0?f[v>>2]|0:w&255;if((f[n>>2]|0)==(x+D|0)){oEc(m,D<<1,0);if((b[g>>0]|0)<0)J=(f[s>>2]&2147483647)+-1|0;else J=10;oEc(m,J,0);w=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+D;K=w}else K=x;w=A+12|0;D=f[w>>2]|0;L=A+16|0;if((D|0)==(f[L>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else M=dtc(b[D>>0]|0)|0;if(Jvc(M&255,r,K,n,q,b[k>>0]|0,l,o,p,j)|0){G=K;H=F;break}D=f[w>>2]|0;if((D|0)==(f[L>>2]|0)){_i[f[(f[A>>2]|0)+40>>2]&1023](A)|0;x=K;t=A;y=B;continue}else{f[w>>2]=D+1;dtc(b[D>>0]|0)|0;x=K;t=A;y=B;continue}}y=b[l+11>>0]|0;if((y<<24>>24<0?f[l+4>>2]|0:y&255)|0?(y=f[p>>2]|0,(y-o|0)<160):0){t=f[q>>2]|0;f[p>>2]=y+4;f[y>>2]=t}t=iwc(G,f[n>>2]|0,h,r)|0;d[i>>1]=t;Wvc(l,o,f[p>>2]|0,h);if(A){p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))N=_i[f[(f[B>>2]|0)+36>>2]&1023](A)|0;else N=dtc(b[p>>0]|0)|0;if(buc(N,ctc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(H){N=f[H+12>>2]|0;if((N|0)==(f[H+16>>2]|0))P=_i[f[(f[H>>2]|0)+36>>2]&1023](H)|0;else P=dtc(b[N>>0]|0)|0;if(!(buc(P,ctc()|0)|0))if(O)break;else{I=49;break}else{f[e>>2]=0;I=47;break}}else I=47;while(0);if((I|0)==47?O:0)I=49;if((I|0)==49)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;hEc(m);hEc(l);u=a;return h|0}function iwc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=zoc()|0;k=f[j>>2]|0;j=zoc()|0;f[j>>2]=0;j=Orc(a,h,e,Kvc()|0)|0;l=J;m=zoc()|0;n=f[m>>2]|0;if(!n){m=zoc()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>65535|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j&65535;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function jwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;bwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=dtc(b[v>>0]|0)|0;if(buc(y,ctc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=dtc(b[C>>0]|0)|0;if(!(buc(D,ctc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else M=dtc(b[C>>0]|0)|0;if(Jvc(M&255,q,K,m,p,b[j>>0]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+1;dtc(b[C>>0]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=kwc(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else N=dtc(b[o>>0]|0)|0;if(buc(N,ctc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else P=dtc(b[N>>0]|0)|0;if(!(buc(P,ctc()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function kwc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if((a|0)==(b|0)){f[c>>2]=4;h=0;i=0}else{j=zoc()|0;k=f[j>>2]|0;j=zoc()|0;f[j>>2]=0;j=Prc(a,g,d,Kvc()|0)|0;d=J;a=zoc()|0;l=f[a>>2]|0;if(!l){a=zoc()|0;f[a>>2]=k}if((f[g>>2]|0)==(b|0))if((l|0)==34){f[c>>2]=4;l=(d|0)>0|(d|0)==0&j>>>0>0;m=l?-1:0;n=l?2147483647:-2147483648}else{m=j;n=d}else{f[c>>2]=4;m=0;n=0}h=n;i=m}J=h;u=e;return i|0}function lwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;bwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=dtc(b[v>>0]|0)|0;if(buc(y,ctc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=dtc(b[C>>0]|0)|0;if(!(buc(D,ctc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=dtc(b[C>>0]|0)|0;if(Jvc(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;dtc(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=mwc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=dtc(b[o>>0]|0)|0;if(buc(M,ctc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=dtc(b[M>>0]|0)|0;if(!(buc(O,ctc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function mwc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if((a|0)==(b|0)){f[c>>2]=4;h=0}else{i=zoc()|0;j=f[i>>2]|0;i=zoc()|0;f[i>>2]=0;i=Prc(a,g,d,Kvc()|0)|0;d=J;a=zoc()|0;k=f[a>>2]|0;if(!k){a=zoc()|0;f[a>>2]=j}a:do if((f[g>>2]|0)==(b|0)){do if((k|0)==34){f[c>>2]=4;if((d|0)>0|(d|0)==0&i>>>0>0){l=2147483647;break a}}else{if((d|0)<-1|(d|0)==-1&i>>>0<2147483648){f[c>>2]=4;break}if((d|0)>0|(d|0)==0&i>>>0>2147483647){f[c>>2]=4;l=2147483647;break a}else{l=i;break a}}while(0);l=-2147483648}else{f[c>>2]=4;l=0}while(0);h=l}u=e;return h|0}function nwc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+112|0;k=j;l=(e-d|0)/12|0;if(l>>>0>100){m=ooc(l)|0;if(!m)_Dc();else{n=m;o=m}}else{n=k;o=0}k=l;l=d;m=n;p=0;while(1){if((l|0)==(e|0))break;q=b[l+11>>0]|0;if(q<<24>>24<0)r=f[l+4>>2]|0;else r=q&255;if(!r){b[m>>0]=2;s=k+-1|0;t=p+1|0}else{b[m>>0]=1;s=k;t=p}k=s;l=l+12|0;m=m+1|0;p=t}t=0;m=k;k=p;a:while(1){p=f[a>>2]|0;do if(p){l=f[p+12>>2]|0;if((l|0)==(f[p+16>>2]|0))v=_i[f[(f[p>>2]|0)+36>>2]&1023](p)|0;else v=dtc(b[l>>0]|0)|0;if(buc(v,ctc()|0)|0){f[a>>2]=0;w=1;break}else{w=(f[a>>2]|0)==0;break}}else w=1;while(0);p=f[c>>2]|0;if(p){l=f[p+12>>2]|0;if((l|0)==(f[p+16>>2]|0))x=_i[f[(f[p>>2]|0)+36>>2]&1023](p)|0;else x=dtc(b[l>>0]|0)|0;if(buc(x,ctc()|0)|0){f[c>>2]=0;y=0;z=1}else{y=p;z=0}}else{y=0;z=1}A=f[a>>2]|0;if(!((m|0)!=0&(w^z)))break;p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))B=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else B=dtc(b[p>>0]|0)|0;p=B&255;if(i)C=p;else C=Mi[f[(f[g>>2]|0)+12>>2]&1023](g,p)|0;p=t+1|0;l=d;s=0;r=n;q=k;D=m;while(1){if((l|0)==(e|0))break;do if((b[r>>0]|0)==1){E=l+11|0;if((b[E>>0]|0)<0)F=f[l>>2]|0;else F=l;G=b[F+t>>0]|0;if(i)H=G;else H=Mi[f[(f[g>>2]|0)+12>>2]&1023](g,G)|0;G=D+-1|0;if(C<<24>>24!=H<<24>>24){b[r>>0]=0;I=s;J=q;K=G;break}L=b[E>>0]|0;if(L<<24>>24<0)M=f[l+4>>2]|0;else M=L&255;if((M|0)==(p|0)){b[r>>0]=2;I=1;J=q+1|0;K=G}else{I=1;J=q;K=D}}else{I=s;J=q;K=D}while(0);l=l+12|0;s=I;r=r+1|0;q=J;D=K}if(!s){t=p;m=D;k=q;continue}r=f[a>>2]|0;l=r+12|0;G=f[l>>2]|0;if((G|0)==(f[r+16>>2]|0))_i[f[(f[r>>2]|0)+40>>2]&1023](r)|0;else{f[l>>2]=G+1;dtc(b[G>>0]|0)|0}if((q+D|0)>>>0>1){N=d;O=n;P=q}else{t=p;m=D;k=q;continue}while(1){if((N|0)==(e|0)){t=p;m=D;k=P;continue a}if((b[O>>0]|0)==2){G=b[N+11>>0]|0;if(G<<24>>24<0)Q=f[N+4>>2]|0;else Q=G&255;if((Q|0)!=(p|0)){b[O>>0]=0;R=P+-1|0}else R=P}else R=P;N=N+12|0;O=O+1|0;P=R}}do if(A){R=f[A+12>>2]|0;if((R|0)==(f[A+16>>2]|0))S=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else S=dtc(b[R>>0]|0)|0;if(buc(S,ctc()|0)|0){f[a>>2]=0;T=1;break}else{T=(f[a>>2]|0)==0;break}}else T=1;while(0);do if(y){a=f[y+12>>2]|0;if((a|0)==(f[y+16>>2]|0))U=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else U=dtc(b[a>>0]|0)|0;if(!(buc(U,ctc()|0)|0))if(T){V=d;W=n;break}else{X=77;break}else{f[c>>2]=0;X=41;break}}else X=41;while(0);if((X|0)==41)if(T)X=77;else{V=d;W=n}if((X|0)==77){f[h>>2]=f[h>>2]|2;V=d;W=n}while(1){if((V|0)==(e|0)){X=81;break}if((b[W>>0]|0)==2){Y=V;break}V=V+12|0;W=W+1|0}if((X|0)==81){f[h>>2]=f[h>>2]|4;Y=e}poc(o);u=j;return Y|0}function owc(a){a=a|0;nvc(a);return}function pwc(a){a=a|0;nvc(a);YDc(a);return}function qwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+48|0;j=i+40|0;k=i+16|0;l=i+8|0;m=i+12|0;n=i+4|0;o=i;if(!(f[e+4>>2]&1)){f[l>>2]=-1;p=f[(f[a>>2]|0)+16>>2]|0;f[m>>2]=f[c>>2];f[n>>2]=f[d>>2];f[k>>2]=f[m>>2];f[j>>2]=f[n>>2];n=xg[p&127](a,k,j,e,g,l)|0;f[c>>2]=n;switch(f[l>>2]|0){case 0:{b[h>>0]=0;break}case 1:{b[h>>0]=1;break}default:{b[h>>0]=1;f[g>>2]=4}}q=f[c>>2]|0}else{cuc(j,e);l=Hvc(j,885272)|0;Ivc(j);cuc(j,e);e=Hvc(j,885280)|0;Ivc(j);mi[f[(f[e>>2]|0)+24>>2]&2047](k,e);mi[f[(f[e>>2]|0)+28>>2]&2047](k+12|0,e);f[o>>2]=f[d>>2];d=k+24|0;f[j>>2]=f[o>>2];o=(Owc(c,j,k,d,l,g,1)|0)==(k|0)&1;b[h>>0]=o;o=f[c>>2]|0;c=d;do{c=c+-12|0;FEc(c)}while((c|0)!=(k|0));q=o}u=i;return q|0}function rwc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Nwc(a,j,i,d,e,g)|0;u=h;return l|0}function swc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Mwc(a,j,i,d,e,g)|0;u=h;return l|0}function twc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Lwc(a,j,i,d,e,g)|0;u=h;return l|0}function uwc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Kwc(a,j,i,d,e,g)|0;u=h;return l|0}function vwc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Jwc(a,j,i,d,e,g)|0;u=h;return l|0}function wwc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Hwc(a,j,i,d,e,g)|0;u=h;return l|0}function xwc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Gwc(a,j,i,d,e,g)|0;u=h;return l|0}function ywc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Fwc(a,j,i,d,e,g)|0;u=h;return l|0}function zwc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Cwc(a,j,i,d,e,g)|0;u=h;return l|0}function Awc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=u;u=u+320|0;i=a;j=a+208|0;k=a+192|0;l=a+180|0;m=a+176|0;n=a+16|0;o=a+8|0;p=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}cuc(l,e);e=Hvc(l,885272)|0;hh[f[(f[e>>2]|0)+48>>2]&127](e,514929,514955,j)|0;Ivc(l);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;q=l+8|0;if((b[e>>0]|0)<0)r=(f[q>>2]&2147483647)+-1|0;else r=10;oEc(l,r,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r;f[o>>2]=n;f[p>>2]=0;s=l+4|0;t=f[c>>2]|0;v=r;r=t;w=t;a:while(1){if(r){t=f[r+12>>2]|0;if((t|0)==(f[r+16>>2]|0))x=_i[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else x=vtc(f[t>>2]|0)|0;if(duc(x,utc()|0)|0){f[c>>2]=0;y=0;z=0;A=1}else{y=r;z=w;A=0}}else{y=0;z=0;A=1}t=f[d>>2]|0;do if(t){B=f[t+12>>2]|0;if((B|0)==(f[t+16>>2]|0))C=_i[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else C=vtc(f[B>>2]|0)|0;if(!(duc(C,utc()|0)|0))if(A){D=t;break}else{E=v;F=t;break a}else{f[d>>2]=0;G=22;break}}else G=22;while(0);if((G|0)==22){G=0;if(A){E=v;F=0;break}else D=0}t=b[e>>0]|0;B=t<<24>>24<0?f[s>>2]|0:t&255;if((f[m>>2]|0)==(v+B|0)){oEc(l,B<<1,0);if((b[e>>0]|0)<0)H=(f[q>>2]&2147483647)+-1|0;else H=10;oEc(l,H,0);t=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=t+B;I=t}else I=v;t=y+12|0;B=f[t>>2]|0;J=y+16|0;if((B|0)==(f[J>>2]|0))K=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else K=vtc(f[B>>2]|0)|0;if(Bwc(K,16,I,m,p,0,k,n,o,j)|0){E=I;F=D;break}B=f[t>>2]|0;if((B|0)==(f[J>>2]|0)){_i[f[(f[y>>2]|0)+40>>2]&1023](y)|0;v=I;r=y;w=z;continue}else{f[t>>2]=B+4;vtc(f[B>>2]|0)|0;v=I;r=y;w=z;continue}}oEc(l,(f[m>>2]|0)-E|0,0);E=(b[e>>0]|0)<0?f[l>>2]|0:l;e=Kvc()|0;f[i>>2]=h;if((Lvc(E,e,514962,i)|0)!=1)f[g>>2]=4;if(y){i=f[y+12>>2]|0;if((i|0)==(f[y+16>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&1023](y)|0;else L=vtc(f[i>>2]|0)|0;if(duc(L,utc()|0)|0){f[c>>2]=0;M=1}else M=0}else M=1;do if(F){L=f[F+12>>2]|0;if((L|0)==(f[F+16>>2]|0))N=_i[f[(f[F>>2]|0)+36>>2]&1023](F)|0;else N=vtc(f[L>>2]|0)|0;if(!(duc(N,utc()|0)|0))if(M)break;else{G=51;break}else{f[d>>2]=0;G=49;break}}else G=49;while(0);if((G|0)==49?M:0)G=51;if((G|0)==51)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function Bwc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=f[e>>2]|0;n=(m|0)==(d|0);do if(n){o=(f[l+96>>2]|0)==(a|0);if(!o?(f[l+100>>2]|0)!=(a|0):0){p=5;break}f[e>>2]=d+1;b[d>>0]=o?43:45;f[g>>2]=0;q=0}else p=5;while(0);a:do if((p|0)==5){o=b[i+11>>0]|0;if((a|0)==(h|0)?((o<<24>>24<0?f[i+4>>2]|0:o&255)|0)!=0:0){o=f[k>>2]|0;if((o-j|0)>=160){q=0;break}r=f[g>>2]|0;f[k>>2]=o+4;f[o>>2]=r;f[g>>2]=0;q=0;break}r=l+104|0;o=0;while(1){s=l+(o<<2)|0;if((o|0)==26){t=r;break}if((f[s>>2]|0)==(a|0)){t=s;break}else o=o+1|0}o=t-l|0;r=o>>2;if((o|0)>92)q=-1;else{s=514929+r|0;switch(c|0){case 10:case 8:{if((r|0)>=(c|0)){q=-1;break a}break}case 16:{if((o|0)>=88){if(n){q=-1;break a}if((m-d|0)>=3){q=-1;break a}if((b[m+-1>>0]|0)!=48){q=-1;break a}f[g>>2]=0;o=b[s>>0]|0;f[e>>2]=m+1;b[m>>0]=o;q=0;break a}break}default:{}}o=b[s>>0]|0;f[e>>2]=m+1;b[m>>0]=o;f[g>>2]=(f[g>>2]|0)+1;q=0}}while(0);return q|0}function Cwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;Dwc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;oEc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=vtc(f[y>>2]|0)|0;if(duc(B,utc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=vtc(f[F>>2]|0)|0;if(!(duc(G,utc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){oEc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;oEc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=vtc(f[F>>2]|0)|0;if(Ewc(O,s,t,M,n,f[j>>2]|0,f[k>>2]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;vtc(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+Vvc(I,f[n>>2]|0,g);p[h>>3]=P;Wvc(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=vtc(f[q>>2]|0)|0;if(duc(Q,utc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=vtc(f[Q>>2]|0)|0;if(!(duc(S,utc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(m);hEc(l);u=a;return g|0}function Dwc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;cuc(h,b);b=Hvc(h,885272)|0;hh[f[(f[b>>2]|0)+48>>2]&127](b,514929,514961,c)|0;c=Hvc(h,885280)|0;b=_i[f[(f[c>>2]|0)+12>>2]&1023](c)|0;f[d>>2]=b;b=_i[f[(f[c>>2]|0)+16>>2]&1023](c)|0;f[e>>2]=b;mi[f[(f[c>>2]|0)+20>>2]&2047](a,c);Ivc(h);u=g;return}function Ewc(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;o=k;a:do if((a|0)==(h|0))if(b[c>>0]|0){b[c>>0]=0;k=f[g>>2]|0;f[g>>2]=k+1;b[k>>0]=46;k=b[j+11>>0]|0;if(((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)!=0?(k=f[l>>2]|0,(k-o|0)<160):0){p=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=p;q=0}else q=0}else q=-1;else{if((a|0)==(i|0)?(p=b[j+11>>0]|0,(p<<24>>24<0?f[j+4>>2]|0:p&255)|0):0){if(!(b[c>>0]|0)){q=-1;break}p=f[l>>2]|0;if((p-o|0)>=160){q=0;break}k=f[m>>2]|0;f[l>>2]=p+4;f[p>>2]=k;f[m>>2]=0;q=0;break}k=n+128|0;p=0;while(1){r=n+(p<<2)|0;if((p|0)==32){s=k;break}if((f[r>>2]|0)==(a|0)){s=r;break}else p=p+1|0}p=s-n|0;k=p>>2;if((p|0)<=124){r=b[514929+k>>0]|0;switch(k|0){case 24:case 25:{k=f[g>>2]|0;if((k|0)!=(e|0)?(b[k+-1>>0]&95)!=(b[d>>0]&127):0){q=-1;break a}f[g>>2]=k+1;b[k>>0]=r;q=0;break a;break}case 23:case 22:{b[d>>0]=80;break}default:{k=r&95;if((((k|0)==(b[d>>0]|0)?(b[d>>0]=k|128,b[c>>0]|0):0)?(b[c>>0]=0,k=b[j+11>>0]|0,(k<<24>>24<0?f[j+4>>2]|0:k&255)|0):0)?(k=f[l>>2]|0,(k-o|0)<160):0){t=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=t}}}t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=r;if((p|0)>84)q=0;else{f[m>>2]=(f[m>>2]|0)+1;q=0}}else q=-1}while(0);return q|0}function Fwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;Dwc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;oEc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=vtc(f[y>>2]|0)|0;if(duc(B,utc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=vtc(f[F>>2]|0)|0;if(!(duc(G,utc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){oEc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;oEc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=vtc(f[F>>2]|0)|0;if(Ewc(O,s,t,M,n,f[j>>2]|0,f[k>>2]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;vtc(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+Yvc(I,f[n>>2]|0,g);p[h>>3]=P;Wvc(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=vtc(f[q>>2]|0)|0;if(duc(Q,utc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=vtc(f[Q>>2]|0)|0;if(!(duc(S,utc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(m);hEc(l);u=a;return g|0}function Gwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;o=a+168|0;p=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;Dwc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;oEc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w;f[q>>2]=p;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=vtc(f[y>>2]|0)|0;if(duc(B,utc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=vtc(f[F>>2]|0)|0;if(!(duc(G,utc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[o>>2]|0)==(z+F|0)){oEc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;oEc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=vtc(f[F>>2]|0)|0;if(Ewc(O,s,t,M,o,f[j>>2]|0,f[k>>2]|0,l,p,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;vtc(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-p|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+_vc(I,f[o>>2]|0,g);n[h>>2]=P;Wvc(l,p,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=vtc(f[q>>2]|0)|0;if(duc(Q,utc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=vtc(f[Q>>2]|0)|0;if(!(duc(S,utc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(m);hEc(l);u=a;return g|0}function Hwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;Iwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=vtc(f[v>>2]|0)|0;if(duc(y,utc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=vtc(f[C>>2]|0)|0;if(!(duc(D,utc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else M=vtc(f[C>>2]|0)|0;if(Bwc(M,q,K,m,p,f[j>>2]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+4;vtc(f[C>>2]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=cwc(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else N=vtc(f[o>>2]|0)|0;if(duc(N,utc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else P=vtc(f[N>>2]|0)|0;if(!(duc(P,utc()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function Iwc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;cuc(g,b);b=Hvc(g,885272)|0;hh[f[(f[b>>2]|0)+48>>2]&127](b,514929,514955,c)|0;c=Hvc(g,885280)|0;b=_i[f[(f[c>>2]|0)+16>>2]&1023](c)|0;f[d>>2]=b;mi[f[(f[c>>2]|0)+20>>2]&2047](a,c);Ivc(g);u=e;return}function Jwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;Iwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=vtc(f[v>>2]|0)|0;if(duc(y,utc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=vtc(f[C>>2]|0)|0;if(!(duc(D,utc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=vtc(f[C>>2]|0)|0;if(Bwc(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;vtc(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=ewc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=vtc(f[o>>2]|0)|0;if(duc(M,utc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=vtc(f[M>>2]|0)|0;if(!(duc(O,utc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function Kwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;Iwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=vtc(f[v>>2]|0)|0;if(duc(y,utc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=vtc(f[C>>2]|0)|0;if(!(duc(D,utc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=vtc(f[C>>2]|0)|0;if(Bwc(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;vtc(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=gwc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=vtc(f[o>>2]|0)|0;if(duc(M,utc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=vtc(f[M>>2]|0)|0;if(!(duc(O,utc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function Lwc(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;p=a+4|0;q=a;r=awc(g)|0;Iwc(l,g,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[m+(g<<2)>>2]=0;g=g+1|0}g=m+11|0;s=m+8|0;if((b[g>>0]|0)<0)t=(f[s>>2]&2147483647)+-1|0;else t=10;oEc(m,t,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t;f[p>>2]=o;f[q>>2]=0;v=m+4|0;w=f[c>>2]|0;x=t;t=w;y=w;a:while(1){if(t){w=f[t+12>>2]|0;if((w|0)==(f[t+16>>2]|0))z=_i[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else z=vtc(f[w>>2]|0)|0;if(duc(z,utc()|0)|0){f[c>>2]=0;A=0;B=0;C=1}else{A=t;B=y;C=0}}else{A=0;B=0;C=1}w=f[e>>2]|0;do if(w){D=f[w+12>>2]|0;if((D|0)==(f[w+16>>2]|0))E=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else E=vtc(f[D>>2]|0)|0;if(!(duc(E,utc()|0)|0))if(C){F=w;break}else{G=x;H=w;break a}else{f[e>>2]=0;I=19;break}}else I=19;while(0);if((I|0)==19){I=0;if(C){G=x;H=0;break}else F=0}w=b[g>>0]|0;D=w<<24>>24<0?f[v>>2]|0:w&255;if((f[n>>2]|0)==(x+D|0)){oEc(m,D<<1,0);if((b[g>>0]|0)<0)J=(f[s>>2]&2147483647)+-1|0;else J=10;oEc(m,J,0);w=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+D;K=w}else K=x;w=A+12|0;D=f[w>>2]|0;L=A+16|0;if((D|0)==(f[L>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else M=vtc(f[D>>2]|0)|0;if(Bwc(M,r,K,n,q,f[k>>2]|0,l,o,p,j)|0){G=K;H=F;break}D=f[w>>2]|0;if((D|0)==(f[L>>2]|0)){_i[f[(f[A>>2]|0)+40>>2]&1023](A)|0;x=K;t=A;y=B;continue}else{f[w>>2]=D+4;vtc(f[D>>2]|0)|0;x=K;t=A;y=B;continue}}y=b[l+11>>0]|0;if((y<<24>>24<0?f[l+4>>2]|0:y&255)|0?(y=f[p>>2]|0,(y-o|0)<160):0){t=f[q>>2]|0;f[p>>2]=y+4;f[y>>2]=t}t=iwc(G,f[n>>2]|0,h,r)|0;d[i>>1]=t;Wvc(l,o,f[p>>2]|0,h);if(A){p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))N=_i[f[(f[B>>2]|0)+36>>2]&1023](A)|0;else N=vtc(f[p>>2]|0)|0;if(duc(N,utc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(H){N=f[H+12>>2]|0;if((N|0)==(f[H+16>>2]|0))P=_i[f[(f[H>>2]|0)+36>>2]&1023](H)|0;else P=vtc(f[N>>2]|0)|0;if(!(duc(P,utc()|0)|0))if(O)break;else{I=49;break}else{f[e>>2]=0;I=47;break}}else I=47;while(0);if((I|0)==47?O:0)I=49;if((I|0)==49)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;hEc(m);hEc(l);u=a;return h|0}function Mwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;Iwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=vtc(f[v>>2]|0)|0;if(duc(y,utc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=vtc(f[C>>2]|0)|0;if(!(duc(D,utc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else M=vtc(f[C>>2]|0)|0;if(Bwc(M,q,K,m,p,f[j>>2]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+4;vtc(f[C>>2]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=kwc(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else N=vtc(f[o>>2]|0)|0;if(duc(N,utc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else P=vtc(f[N>>2]|0)|0;if(!(duc(P,utc()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function Nwc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=awc(e)|0;Iwc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;oEc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=vtc(f[v>>2]|0)|0;if(duc(y,utc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=vtc(f[C>>2]|0)|0;if(!(duc(D,utc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){oEc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;oEc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=vtc(f[C>>2]|0)|0;if(Bwc(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;vtc(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=mwc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;Wvc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=vtc(f[o>>2]|0)|0;if(duc(M,utc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=vtc(f[M>>2]|0)|0;if(!(duc(O,utc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;hEc(l);hEc(k);u=a;return g|0}function Owc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+112|0;k=j;l=(e-d|0)/12|0;if(l>>>0>100){m=ooc(l)|0;if(!m)_Dc();else{n=m;o=m}}else{n=k;o=0}k=0;m=l;l=d;p=n;while(1){if((l|0)==(e|0))break;q=b[l+8+3>>0]|0;if(q<<24>>24<0)r=f[l+4>>2]|0;else r=q&255;if(!r){b[p>>0]=2;s=k+1|0;t=m+-1|0}else{b[p>>0]=1;s=k;t=m}k=s;m=t;l=l+12|0;p=p+1|0}p=0;l=k;k=m;a:while(1){m=f[a>>2]|0;do if(m){t=f[m+12>>2]|0;if((t|0)==(f[m+16>>2]|0))v=_i[f[(f[m>>2]|0)+36>>2]&1023](m)|0;else v=vtc(f[t>>2]|0)|0;if(duc(v,utc()|0)|0){f[a>>2]=0;w=1;break}else{w=(f[a>>2]|0)==0;break}}else w=1;while(0);m=f[c>>2]|0;if(m){t=f[m+12>>2]|0;if((t|0)==(f[m+16>>2]|0))x=_i[f[(f[m>>2]|0)+36>>2]&1023](m)|0;else x=vtc(f[t>>2]|0)|0;if(duc(x,utc()|0)|0){f[c>>2]=0;y=0;z=1}else{y=m;z=0}}else{y=0;z=1}A=f[a>>2]|0;if(!((k|0)!=0&(w^z)))break;m=f[A+12>>2]|0;if((m|0)==(f[A+16>>2]|0))B=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else B=vtc(f[m>>2]|0)|0;if(i)C=B;else C=Mi[f[(f[g>>2]|0)+28>>2]&1023](g,B)|0;m=p+1|0;t=d;s=0;r=n;q=l;D=k;while(1){if((t|0)==(e|0))break;do if((b[r>>0]|0)==1){E=t+8+3|0;if((b[E>>0]|0)<0)F=f[t>>2]|0;else F=t;G=f[F+(p<<2)>>2]|0;if(i)H=G;else H=Mi[f[(f[g>>2]|0)+28>>2]&1023](g,G)|0;G=D+-1|0;if((C|0)!=(H|0)){b[r>>0]=0;I=s;J=q;K=G;break}L=b[E>>0]|0;if(L<<24>>24<0)M=f[t+4>>2]|0;else M=L&255;if((M|0)==(m|0)){b[r>>0]=2;I=1;J=q+1|0;K=G}else{I=1;J=q;K=D}}else{I=s;J=q;K=D}while(0);t=t+12|0;s=I;r=r+1|0;q=J;D=K}if(!s){p=m;l=q;k=D;continue}r=f[a>>2]|0;t=r+12|0;G=f[t>>2]|0;if((G|0)==(f[r+16>>2]|0))_i[f[(f[r>>2]|0)+40>>2]&1023](r)|0;else{f[t>>2]=G+4;vtc(f[G>>2]|0)|0}if((q+D|0)>>>0>1){N=d;O=n;P=q}else{p=m;l=q;k=D;continue}while(1){if((N|0)==(e|0)){p=m;l=P;k=D;continue a}if((b[O>>0]|0)==2){G=b[N+8+3>>0]|0;if(G<<24>>24<0)Q=f[N+4>>2]|0;else Q=G&255;if((Q|0)!=(m|0)){b[O>>0]=0;R=P+-1|0}else R=P}else R=P;N=N+12|0;O=O+1|0;P=R}}do if(A){R=f[A+12>>2]|0;if((R|0)==(f[A+16>>2]|0))S=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else S=vtc(f[R>>2]|0)|0;if(duc(S,utc()|0)|0){f[a>>2]=0;T=1;break}else{T=(f[a>>2]|0)==0;break}}else T=1;while(0);do if(y){a=f[y+12>>2]|0;if((a|0)==(f[y+16>>2]|0))U=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else U=vtc(f[a>>2]|0)|0;if(!(duc(U,utc()|0)|0))if(T){V=d;W=n;break}else{X=77;break}else{f[c>>2]=0;X=41;break}}else X=41;while(0);if((X|0)==41)if(T)X=77;else{V=d;W=n}if((X|0)==77){f[h>>2]=f[h>>2]|2;V=d;W=n}while(1){if((V|0)==(e|0)){X=81;break}if((b[W>>0]|0)==2){Y=V;break}V=V+12|0;W=W+1|0}if((X|0)==81){f[h>>2]=f[h>>2]|4;Y=e}poc(o);u=j;return Y|0}function Pwc(a){a=a|0;nvc(a);return}function Qwc(a){a=a|0;nvc(a);YDc(a);return}function Rwc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+16|0;i=h+4|0;j=h;if(!(f[d+4>>2]&1)){k=f[(f[a>>2]|0)+24>>2]|0;f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];l=_h[k&127](a,i,d,e,g&1)|0}else{cuc(i,d);d=Hvc(i,885256)|0;Ivc(i);e=f[d>>2]|0;if(g)mi[f[e+24>>2]&2047](i,d);else mi[f[e+28>>2]&2047](i,d);d=i+11|0;e=b[d>>0]|0;if(e<<24>>24<0){m=e;n=f[i>>2]|0;o=8}else{p=i;q=e}while(1){if((o|0)==8){o=0;p=n;q=m}e=q<<24>>24<0;if((p|0)==((e?f[i>>2]|0:i)+(e?f[i+4>>2]|0:q&255)|0))break;e=b[p>>0]|0;g=f[c>>2]|0;if(g|0){a=g+24|0;k=f[a>>2]|0;if((k|0)==(f[g+28>>2]|0)){j=f[(f[g>>2]|0)+52>>2]|0;r=dtc(e)|0;s=Mi[j&1023](g,r)|0}else{f[a>>2]=k+1;b[k>>0]=e;s=dtc(e)|0}if(buc(s,ctc()|0)|0)f[c>>2]=0}m=b[d>>0]|0;n=p+1|0;o=8}o=f[c>>2]|0;hEc(i);l=o}u=h;return l|0}function Swc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;h=a;i=a+52|0;j=a+39|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[515180]|0;b[i+1>>0]=b[515181]|0;b[i+2>>0]=b[515182]|0;b[i+3>>0]=b[515183]|0;b[i+4>>0]=b[515184]|0;b[i+5>>0]=b[515185]|0;cxc(i+1|0,519112,1,f[d+4>>2]|0);o=Kvc()|0;f[h>>2]=g;g=j+(Zwc(j,13,o,i,h)|0)|0;i=_wc(j,g,d)|0;cuc(h,d);dxc(j,i,g,k,l,m,h);Ivc(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=L1(h,k,c,l,d,e)|0;u=a;return n|0}function Twc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+96|0;h=a+8|0;i=a;j=a+71|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;cxc(i+1|0,519117,1,f[c+4>>2]|0);o=Kvc()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(Zwc(j,23,o,i,h)|0)|0;i=_wc(j,g,c)|0;cuc(h,c);dxc(j,i,g,k,l,m,h);Ivc(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=L1(h,k,b,l,c,d)|0;u=a;return n|0}function Uwc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;h=a;i=a+52|0;j=a+40|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[515180]|0;b[i+1>>0]=b[515181]|0;b[i+2>>0]=b[515182]|0;b[i+3>>0]=b[515183]|0;b[i+4>>0]=b[515184]|0;b[i+5>>0]=b[515185]|0;cxc(i+1|0,519112,0,f[d+4>>2]|0);o=Kvc()|0;f[h>>2]=g;g=j+(Zwc(j,12,o,i,h)|0)|0;i=_wc(j,g,d)|0;cuc(h,d);dxc(j,i,g,k,l,m,h);Ivc(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=L1(h,k,c,l,d,e)|0;u=a;return n|0}function Vwc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+96|0;h=a+8|0;i=a;j=a+71|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;cxc(i+1|0,519117,0,f[c+4>>2]|0);o=Kvc()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(Zwc(j,23,o,i,h)|0)|0;i=_wc(j,g,c)|0;cuc(h,c);dxc(j,i,g,k,l,m,h);Ivc(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=L1(h,k,b,l,c,d)|0;u=a;return n|0}function Wwc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=u;u=u+176|0;g=a+72|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+134|0;n=a+68|0;o=a+76|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=$wc(l+1|0,1154740,f[c+4>>2]|0)|0;f[n>>2]=m;v=Kvc()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=Zwc(m,30,v,l,k)|0}else{p[j>>3]=e;w=Zwc(m,30,v,l,j)|0}if((w|0)>29){j=Kvc()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=axc(n,j,l,i)|0}else{p[h>>3]=e;x=axc(n,j,l,h)|0}h=f[n>>2]|0;if(!h)_Dc();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=_wc(A,n,c)|0;if((A|0)!=(m|0)){m=ooc(y<<1)|0;if(!m)_Dc();else{B=m;C=m}}else{B=o;C=0}cuc(g,c);bxc(A,w,n,B,q,r,g);Ivc(g);f[s>>2]=f[b>>2];b=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=L1(g,B,b,q,c,d)|0;poc(C);poc(z);u=a;return s|0}function Xwc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=u;u=u+176|0;g=a+72|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+134|0;n=a+68|0;o=a+76|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=$wc(l+1|0,515178,f[c+4>>2]|0)|0;f[n>>2]=m;v=Kvc()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=Zwc(m,30,v,l,k)|0}else{p[j>>3]=e;w=Zwc(m,30,v,l,j)|0}if((w|0)>29){j=Kvc()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=axc(n,j,l,i)|0}else{p[h>>3]=e;x=axc(n,j,l,h)|0}h=f[n>>2]|0;if(!h)_Dc();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=_wc(A,n,c)|0;if((A|0)!=(m|0)){m=ooc(y<<1)|0;if(!m)_Dc();else{B=m;C=m}}else{B=o;C=0}cuc(g,c);bxc(A,w,n,B,q,r,g);Ivc(g);f[s>>2]=f[b>>2];b=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=L1(g,B,b,q,c,d)|0;poc(C);poc(z);u=a;return s|0}function Ywc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+80|0;h=a;i=a+68|0;j=a+48|0;k=a+8|0;l=a+4|0;b[i>>0]=b[515172]|0;b[i+1>>0]=b[515173]|0;b[i+2>>0]=b[515174]|0;b[i+3>>0]=b[515175]|0;b[i+4>>0]=b[515176]|0;b[i+5>>0]=b[515177]|0;m=Kvc()|0;f[h>>2]=g;g=Zwc(j,20,m,i,h)|0;i=j+g|0;m=_wc(j,i,d)|0;cuc(h,d);n=Hvc(h,885240)|0;Ivc(h);hh[f[(f[n>>2]|0)+32>>2]&127](n,j,i,k)|0;n=k+g|0;f[l>>2]=f[c>>2];f[h>>2]=f[l>>2];l=L1(h,k,(m|0)==(i|0)?n:k+(m-j)|0,n,d,e)|0;u=a;return l|0}function Zwc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=e;e=Rqc(c)|0;c=Opc(a,b,d,h)|0;if(e|0)Rqc(e)|0;u=g;return c|0}function _wc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;a:do switch((f[d+4>>2]&176)<<24>>24){case 16:{e=b[a>>0]|0;g=a+1|0;switch(e<<24>>24){case 43:case 45:{h=g;break a;break}default:{}}if((c-a|0)>1&e<<24>>24==48){switch(b[g>>0]|0){case 88:case 120:break;default:{i=6;break a}}h=a+2|0}else i=6;break}case 32:{h=c;break}default:i=6}while(0);if((i|0)==6)h=a;return h|0}function $wc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;if(!(d&2048))e=a;else{b[a>>0]=43;e=a+1|0}if(!(d&1024))f=e;else{b[e>>0]=35;f=e+1|0}e=d&260;a=(d&16384|0)!=0;d=(e|0)==260;if(d){g=0;h=f}else{b[f>>0]=46;b[f+1>>0]=42;g=1;h=f+2|0}f=c;c=h;while(1){h=b[f>>0]|0;if(!(h<<24>>24))break;b[c>>0]=h;f=f+1|0;c=c+1|0}a:do switch(e&511){case 4:{i=a?70:102;break}case 256:{i=a?69:101;break}default:if(d){i=a?65:97;break a}else{i=a?71:103;break a}}while(0);b[c>>0]=i;return g|0}function axc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=Rqc(b)|0;b=zqc(a,c,g)|0;if(d|0)Rqc(d)|0;u=e;return b|0}function bxc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=u;u=u+16|0;k=j;l=Hvc(i,885240)|0;m=Hvc(i,885256)|0;mi[f[(f[m>>2]|0)+20>>2]&2047](k,m);f[h>>2]=e;i=b[a>>0]|0;switch(i<<24>>24){case 43:case 45:{n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,i)|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=n;o=a+1|0;break}default:o=a}n=d;a:do if((n-o|0)>1?(b[o>>0]|0)==48:0){i=o+1|0;switch(b[i>>0]|0){case 88:case 120:break;default:{p=o;q=10;break a}}r=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,48)|0;s=f[h>>2]|0;f[h>>2]=s+1;b[s>>0]=r;r=o+2|0;s=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,b[i>>0]|0)|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=s;s=r;while(1){if(s>>>0>=d>>>0){t=r;v=s;break a}i=b[s>>0]|0;if(!(Yqc(i,Kvc()|0)|0)){t=r;v=s;break a}s=s+1|0}}else{p=o;q=10}while(0);b:do if((q|0)==10)while(1){q=0;if(p>>>0>=d>>>0){t=o;v=p;break b}s=b[p>>0]|0;if(!(Nqc(s,Kvc()|0)|0)){t=o;v=p;break b}p=p+1|0;q=10}while(0);p=k+11|0;o=b[p>>0]|0;s=k+4|0;r=t;i=a;c:do if((o<<24>>24<0?f[s>>2]|0:o&255)|0){d:do if((t|0)!=(v|0)){a=v;w=t;while(1){x=a+-1|0;if(w>>>0>=x>>>0)break d;y=b[w>>0]|0;b[w>>0]=b[x>>0]|0;b[x>>0]=y;a=x;w=w+1|0}}while(0);w=_i[f[(f[m>>2]|0)+16>>2]&1023](m)|0;a=t;x=0;y=0;while(1){if(a>>>0>=v>>>0)break;z=b[((b[p>>0]|0)<0?f[k>>2]|0:k)+y>>0]|0;if(z<<24>>24>0&(x|0)==(z<<24>>24|0)){z=f[h>>2]|0;f[h>>2]=z+1;b[z>>0]=w;z=b[p>>0]|0;A=(y>>>0<((z<<24>>24<0?f[s>>2]|0:z&255)+-1|0)>>>0&1)+y|0;B=0}else{A=y;B=x}z=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,b[a>>0]|0)|0;C=f[h>>2]|0;f[h>>2]=C+1;b[C>>0]=z;a=a+1|0;x=B+1|0;y=A}y=e+(r-i)|0;x=f[h>>2]|0;if((y|0)==(x|0))D=l;else{a=x;x=y;while(1){y=a+-1|0;if(x>>>0>=y>>>0){D=l;break c}w=b[x>>0]|0;b[x>>0]=b[y>>0]|0;b[y>>0]=w;a=y;x=x+1|0}}}else{hh[f[(f[l>>2]|0)+32>>2]&127](l,t,v,f[h>>2]|0)|0;f[h>>2]=(f[h>>2]|0)+(v-r);D=l}while(0);r=v;while(1){if(r>>>0>=d>>>0){E=r;break}v=b[r>>0]|0;F=r+1|0;if(v<<24>>24==46){q=29;break}t=Mi[f[(f[D>>2]|0)+28>>2]&1023](l,v)|0;v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=t;r=F}if((q|0)==29){q=_i[f[(f[m>>2]|0)+12>>2]&1023](m)|0;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=q;E=F}hh[f[(f[l>>2]|0)+32>>2]&127](l,E,d,f[h>>2]|0)|0;l=(f[h>>2]|0)+(n-E)|0;f[h>>2]=l;f[g>>2]=(c|0)==(d|0)?l:e+(c-i)|0;hEc(k);u=j;return}function cxc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(!(e&2048))f=a;else{b[a>>0]=43;f=a+1|0}if(!(e&512)){g=c;h=f}else{b[f>>0]=35;g=c;h=f+1|0}while(1){f=b[g>>0]|0;if(!(f<<24>>24))break;b[h>>0]=f;g=g+1|0;h=h+1|0}switch(e&74){case 64:{i=111;break}case 8:{i=e&16384|0?88:120;break}default:i=d?100:117}b[h>>0]=i;return}function dxc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;j=u;u=u+16|0;k=j;l=Hvc(i,885240)|0;m=Hvc(i,885256)|0;mi[f[(f[m>>2]|0)+20>>2]&2047](k,m);i=k+11|0;n=b[i>>0]|0;o=k+4|0;p=a;q=d;if((n<<24>>24<0?f[o>>2]|0:n&255)|0){f[h>>2]=e;n=b[a>>0]|0;switch(n<<24>>24){case 43:case 45:{r=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,n)|0;n=f[h>>2]|0;f[h>>2]=n+1;b[n>>0]=r;s=a+1|0;break}default:s=a}a:do if((q-s|0)>1?(b[s>>0]|0)==48:0){r=s+1|0;switch(b[r>>0]|0){case 88:case 120:break;default:{t=s;break a}}n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,48)|0;v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=n;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,b[r>>0]|0)|0;r=f[h>>2]|0;f[h>>2]=r+1;b[r>>0]=n;t=s+2|0}else t=s;while(0);b:do if((t|0)!=(d|0)){s=d;n=t;while(1){r=s+-1|0;if(n>>>0>=r>>>0)break b;v=b[n>>0]|0;b[n>>0]=b[r>>0]|0;b[r>>0]=v;s=r;n=n+1|0}}while(0);n=_i[f[(f[m>>2]|0)+16>>2]&1023](m)|0;m=t;s=0;r=0;while(1){if(m>>>0>=d>>>0)break;v=b[((b[i>>0]|0)<0?f[k>>2]|0:k)+s>>0]|0;if(v<<24>>24!=0&(r|0)==(v<<24>>24|0)){v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=n;v=b[i>>0]|0;w=(s>>>0<((v<<24>>24<0?f[o>>2]|0:v&255)+-1|0)>>>0&1)+s|0;x=0}else{w=s;x=r}v=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,b[m>>0]|0)|0;y=f[h>>2]|0;f[h>>2]=y+1;b[y>>0]=v;m=m+1|0;s=w;r=x+1|0}x=e+(t-p)|0;t=f[h>>2]|0;if((x|0)==(t|0))z=x;else{r=t;t=x;while(1){x=r+-1|0;if(t>>>0>=x>>>0)break;w=b[t>>0]|0;b[t>>0]=b[x>>0]|0;b[x>>0]=w;r=x;t=t+1|0}z=f[h>>2]|0}}else{hh[f[(f[l>>2]|0)+32>>2]&127](l,a,d,e)|0;a=e+(q-p)|0;f[h>>2]=a;z=a}f[g>>2]=(c|0)==(d|0)?z:e+(c-p)|0;hEc(k);u=j;return}function exc(a){a=a|0;nvc(a);return}function fxc(a){a=a|0;nvc(a);YDc(a);return}function gxc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;i=h+4|0;j=h;if(!(f[d+4>>2]&1)){k=f[(f[a>>2]|0)+24>>2]|0;f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];l=_h[k&127](a,i,d,e,g&1)|0}else{cuc(i,d);d=Hvc(i,885280)|0;Ivc(i);e=f[d>>2]|0;if(g)mi[f[e+24>>2]&2047](i,d);else mi[f[e+28>>2]&2047](i,d);d=i+8+3|0;e=b[d>>0]|0;g=f[i>>2]|0;a=i+4|0;k=e<<24>>24<0?g:i;j=e;e=g;while(1){g=j<<24>>24<0;if((k|0)==((g?e:i)+((g?f[a>>2]|0:j&255)<<2)|0))break;g=f[k>>2]|0;m=f[c>>2]|0;if(m|0){n=m+24|0;o=f[n>>2]|0;if((o|0)==(f[m+28>>2]|0)){p=f[(f[m>>2]|0)+52>>2]|0;q=vtc(g)|0;r=Mi[p&1023](m,q)|0}else{f[n>>2]=o+4;f[o>>2]=g;r=vtc(g)|0}if(duc(r,utc()|0)|0)f[c>>2]=0}k=k+4|0;j=b[d>>0]|0;e=f[i>>2]|0}e=f[c>>2]|0;FEc(i);l=e}u=h;return l|0}function hxc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+128|0;h=a;i=a+122|0;j=a+108|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[515180]|0;b[i+1>>0]=b[515181]|0;b[i+2>>0]=b[515182]|0;b[i+3>>0]=b[515183]|0;b[i+4>>0]=b[515184]|0;b[i+5>>0]=b[515185]|0;cxc(i+1|0,519112,1,f[d+4>>2]|0);o=Kvc()|0;f[h>>2]=g;g=j+(Zwc(j,13,o,i,h)|0)|0;i=_wc(j,g,d)|0;cuc(h,d);rxc(j,i,g,k,l,m,h);Ivc(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=oxc(h,k,c,l,d,e)|0;u=a;return n|0}function ixc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+224|0;h=a+8|0;i=a;j=a+200|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;cxc(i+1|0,519117,1,f[c+4>>2]|0);o=Kvc()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(Zwc(j,23,o,i,h)|0)|0;i=_wc(j,g,c)|0;cuc(h,c);rxc(j,i,g,k,l,m,h);Ivc(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=oxc(h,k,b,l,c,d)|0;u=a;return n|0}function jxc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+128|0;h=a;i=a+112|0;j=a+100|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[515180]|0;b[i+1>>0]=b[515181]|0;b[i+2>>0]=b[515182]|0;b[i+3>>0]=b[515183]|0;b[i+4>>0]=b[515184]|0;b[i+5>>0]=b[515185]|0;cxc(i+1|0,519112,0,f[d+4>>2]|0);o=Kvc()|0;f[h>>2]=g;g=j+(Zwc(j,12,o,i,h)|0)|0;i=_wc(j,g,d)|0;cuc(h,d);rxc(j,i,g,k,l,m,h);Ivc(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=oxc(h,k,c,l,d,e)|0;u=a;return n|0}function kxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+224|0;h=a+8|0;i=a;j=a+200|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;cxc(i+1|0,519117,0,f[c+4>>2]|0);o=Kvc()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(Zwc(j,23,o,i,h)|0)|0;i=_wc(j,g,c)|0;cuc(h,c);rxc(j,i,g,k,l,m,h);Ivc(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=oxc(h,k,b,l,c,d)|0;u=a;return n|0}function lxc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+336|0;g=a+300|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+304|0;n=a+296|0;o=a+68|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=$wc(l+1|0,1154740,f[c+4>>2]|0)|0;f[n>>2]=m;v=Kvc()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=Zwc(m,30,v,l,k)|0}else{p[j>>3]=e;w=Zwc(m,30,v,l,j)|0}if((w|0)>29){j=Kvc()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=axc(n,j,l,i)|0}else{p[h>>3]=e;x=axc(n,j,l,h)|0}h=f[n>>2]|0;if(!h)_Dc();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=_wc(A,n,c)|0;do if((A|0)!=(m|0)){h=ooc(y<<3)|0;if(!h)_Dc();else{B=h;C=0;D=h;break}}else{B=o;C=1;D=0}while(0);cuc(g,c);qxc(A,w,n,B,q,r,g);Ivc(g);f[s>>2]=f[b>>2];n=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=oxc(g,B,n,q,c,d)|0;f[b>>2]=s;if(!C)poc(D);poc(z);u=a;return s|0}function mxc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+336|0;g=a+300|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+304|0;n=a+296|0;o=a+68|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=$wc(l+1|0,515178,f[c+4>>2]|0)|0;f[n>>2]=m;v=Kvc()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=Zwc(m,30,v,l,k)|0}else{p[j>>3]=e;w=Zwc(m,30,v,l,j)|0}if((w|0)>29){j=Kvc()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=axc(n,j,l,i)|0}else{p[h>>3]=e;x=axc(n,j,l,h)|0}h=f[n>>2]|0;if(!h)_Dc();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=_wc(A,n,c)|0;do if((A|0)!=(m|0)){h=ooc(y<<3)|0;if(!h)_Dc();else{B=h;C=0;D=h;break}}else{B=o;C=1;D=0}while(0);cuc(g,c);qxc(A,w,n,B,q,r,g);Ivc(g);f[s>>2]=f[b>>2];n=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=oxc(g,B,n,q,c,d)|0;f[b>>2]=s;if(!C)poc(D);poc(z);u=a;return s|0}function nxc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+192|0;h=a;i=a+176|0;j=a+156|0;k=a+4|0;l=a+152|0;b[i>>0]=b[515172]|0;b[i+1>>0]=b[515173]|0;b[i+2>>0]=b[515174]|0;b[i+3>>0]=b[515175]|0;b[i+4>>0]=b[515176]|0;b[i+5>>0]=b[515177]|0;m=Kvc()|0;f[h>>2]=g;g=Zwc(j,20,m,i,h)|0;i=j+g|0;m=_wc(j,i,d)|0;cuc(h,d);n=Hvc(h,885272)|0;Ivc(h);hh[f[(f[n>>2]|0)+48>>2]&127](n,j,i,k)|0;n=k+(g<<2)|0;f[l>>2]=f[c>>2];f[h>>2]=f[l>>2];l=oxc(h,k,(m|0)==(i|0)?n:k+(m-j<<2)|0,n,d,e)|0;u=a;return l|0}function oxc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;i=u;u=u+16|0;j=i+12|0;k=i;l=f[a>>2]|0;a:do if(!l)m=0;else{n=e;o=c;p=n-o>>2;q=g+12|0;r=f[q>>2]|0;s=(r|0)>(p|0)?r-p|0:0;p=d;r=p-o|0;o=r>>2;if((r|0)>0?(hj[f[(f[l>>2]|0)+48>>2]&511](l,c,o)|0)!=(o|0):0){f[a>>2]=0;m=0;break}do if((s|0)>0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0>1073741807)dEc(k);do if(s>>>0>=2){o=s+4&2147483644;if(o>>>0>1073741823)tf();else{r=VDc(o<<2)|0;f[k>>2]=r;t=k+8|0;f[t>>2]=o|-2147483648;f[k+4>>2]=s;v=r;w=t+3|0;x=k;break}}else{t=k+8+3|0;b[t>>0]=s;v=k;w=t;x=k}while(0);pxc(v,s,h)|0;f[j>>2]=0;tvc(v+(s<<2)|0,j);if((hj[f[(f[l>>2]|0)+48>>2]&511](l,(b[w>>0]|0)<0?f[k>>2]|0:x,s)|0)==(s|0)){FEc(k);break}else{f[a>>2]=0;FEc(k);m=0;break a}}while(0);s=n-p|0;t=s>>2;if((s|0)>0?(hj[f[(f[l>>2]|0)+48>>2]&511](l,d,t)|0)!=(t|0):0){f[a>>2]=0;m=0;break}f[q>>2]=0;m=l}while(0);u=i;return m|0}function pxc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!b)d=a;else{Drc(a,c,b)|0;d=a}return d|0}function qxc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+16|0;k=j;l=Hvc(i,885272)|0;m=Hvc(i,885280)|0;mi[f[(f[m>>2]|0)+20>>2]&2047](k,m);f[h>>2]=e;i=b[a>>0]|0;switch(i<<24>>24){case 43:case 45:{n=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,i)|0;i=f[h>>2]|0;f[h>>2]=i+4;f[i>>2]=n;o=a+1|0;break}default:o=a}n=d;a:do if((n-o|0)>1?(b[o>>0]|0)==48:0){i=o+1|0;switch(b[i>>0]|0){case 88:case 120:break;default:{p=o;q=10;break a}}r=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,48)|0;s=f[h>>2]|0;f[h>>2]=s+4;f[s>>2]=r;r=o+2|0;s=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,b[i>>0]|0)|0;i=f[h>>2]|0;f[h>>2]=i+4;f[i>>2]=s;s=r;while(1){if(s>>>0>=d>>>0){t=r;v=s;break a}i=b[s>>0]|0;if(!(Yqc(i,Kvc()|0)|0)){t=r;v=s;break a}s=s+1|0}}else{p=o;q=10}while(0);b:do if((q|0)==10)while(1){q=0;if(p>>>0>=d>>>0){t=o;v=p;break b}s=b[p>>0]|0;if(!(Nqc(s,Kvc()|0)|0)){t=o;v=p;break b}p=p+1|0;q=10}while(0);p=k+11|0;o=b[p>>0]|0;s=k+4|0;r=t;i=a;c:do if((o<<24>>24<0?f[s>>2]|0:o&255)|0){d:do if((t|0)!=(v|0)){a=v;w=t;while(1){x=a+-1|0;if(w>>>0>=x>>>0)break d;y=b[w>>0]|0;b[w>>0]=b[x>>0]|0;b[x>>0]=y;a=x;w=w+1|0}}while(0);w=_i[f[(f[m>>2]|0)+16>>2]&1023](m)|0;a=t;x=0;y=0;while(1){if(a>>>0>=v>>>0)break;z=b[p>>0]|0;A=z<<24>>24<0;B=b[(A?f[k>>2]|0:k)+x>>0]|0;if(B<<24>>24>0&(y|0)==(B<<24>>24|0)){B=f[h>>2]|0;f[h>>2]=B+4;f[B>>2]=w;C=(x>>>0<((A?f[s>>2]|0:z&255)+-1|0)>>>0&1)+x|0;D=0}else{C=x;D=y}z=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,b[a>>0]|0)|0;A=f[h>>2]|0;f[h>>2]=A+4;f[A>>2]=z;a=a+1|0;x=C;y=D+1|0}y=e+(r-i<<2)|0;x=f[h>>2]|0;if((y|0)==(x|0)){E=l;F=y}else{a=x;w=y;while(1){y=a+-4|0;if(w>>>0>=y>>>0){E=l;F=x;break c}z=f[w>>2]|0;f[w>>2]=f[y>>2];f[y>>2]=z;a=y;w=w+4|0}}}else{hh[f[(f[l>>2]|0)+48>>2]&127](l,t,v,f[h>>2]|0)|0;w=(f[h>>2]|0)+(v-r<<2)|0;f[h>>2]=w;E=l;F=w}while(0);r=v;v=F;while(1){if(r>>>0>=d>>>0){G=r;H=v;break}F=b[r>>0]|0;I=r+1|0;if(F<<24>>24==46){q=29;break}t=Mi[f[(f[E>>2]|0)+44>>2]&1023](l,F)|0;F=f[h>>2]|0;D=F+4|0;f[h>>2]=D;f[F>>2]=t;r=I;v=D}if((q|0)==29){q=_i[f[(f[m>>2]|0)+12>>2]&1023](m)|0;m=f[h>>2]|0;v=m+4|0;f[h>>2]=v;f[m>>2]=q;G=I;H=v}hh[f[(f[l>>2]|0)+48>>2]&127](l,G,d,H)|0;H=(f[h>>2]|0)+(n-G<<2)|0;f[h>>2]=H;f[g>>2]=(c|0)==(d|0)?H:e+(c-i<<2)|0;hEc(k);u=j;return}function rxc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;j=u;u=u+16|0;k=j;l=Hvc(i,885272)|0;m=Hvc(i,885280)|0;mi[f[(f[m>>2]|0)+20>>2]&2047](k,m);i=k+11|0;n=b[i>>0]|0;o=k+4|0;p=a;q=d;if((n<<24>>24<0?f[o>>2]|0:n&255)|0){f[h>>2]=e;n=b[a>>0]|0;switch(n<<24>>24){case 43:case 45:{r=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,n)|0;n=f[h>>2]|0;f[h>>2]=n+4;f[n>>2]=r;s=a+1|0;break}default:s=a}a:do if((q-s|0)>1?(b[s>>0]|0)==48:0){r=s+1|0;switch(b[r>>0]|0){case 88:case 120:break;default:{t=s;break a}}n=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,48)|0;v=f[h>>2]|0;f[h>>2]=v+4;f[v>>2]=n;n=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,b[r>>0]|0)|0;r=f[h>>2]|0;f[h>>2]=r+4;f[r>>2]=n;t=s+2|0}else t=s;while(0);b:do if((t|0)!=(d|0)){s=d;n=t;while(1){r=s+-1|0;if(n>>>0>=r>>>0)break b;v=b[n>>0]|0;b[n>>0]=b[r>>0]|0;b[r>>0]=v;s=r;n=n+1|0}}while(0);n=_i[f[(f[m>>2]|0)+16>>2]&1023](m)|0;m=t;s=0;r=0;while(1){if(m>>>0>=d>>>0)break;v=b[i>>0]|0;w=v<<24>>24<0;x=b[(w?f[k>>2]|0:k)+s>>0]|0;if(x<<24>>24!=0&(r|0)==(x<<24>>24|0)){x=f[h>>2]|0;f[h>>2]=x+4;f[x>>2]=n;y=(s>>>0<((w?f[o>>2]|0:v&255)+-1|0)>>>0&1)+s|0;z=0}else{y=s;z=r}v=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,b[m>>0]|0)|0;w=f[h>>2]|0;f[h>>2]=w+4;f[w>>2]=v;m=m+1|0;s=y;r=z+1|0}z=e+(t-p<<2)|0;t=f[h>>2]|0;if((z|0)==(t|0))A=z;else{r=t;t=z;while(1){z=r+-4|0;if(t>>>0>=z>>>0)break;y=f[t>>2]|0;f[t>>2]=f[z>>2];f[z>>2]=y;r=z;t=t+4|0}A=f[h>>2]|0}}else{hh[f[(f[l>>2]|0)+48>>2]&127](l,a,d,e)|0;a=e+(q-p<<2)|0;f[h>>2]=a;A=a}f[g>>2]=(c|0)==(d|0)?A:e+(c-p<<2)|0;hEc(k);u=j;return}function sxc(a){a=a|0;nvc(a);return}function txc(a){a=a|0;nvc(a);YDc(a);return}function uxc(a){a=a|0;return 2}function vxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Qxc(a,j,i,d,e,g,515703,515711)|0;u=h;return l|0}function wxc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i+12|0;k=i+8|0;l=i+4|0;m=i;n=a+8|0;o=_i[f[(f[n>>2]|0)+20>>2]&1023](n)|0;f[l>>2]=f[c>>2];f[m>>2]=f[d>>2];d=b[o+11>>0]|0;c=d<<24>>24<0;n=c?f[o>>2]|0:o;p=n+(c?f[o+4>>2]|0:d&255)|0;f[k>>2]=f[l>>2];f[j>>2]=f[m>>2];m=Qxc(a,k,j,e,g,h,n,p)|0;u=i;return m|0}function xxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;cuc(i,d);d=Hvc(i,885240)|0;Ivc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];Oxc(a,g+24|0,b,i,e,d);u=h;return f[b>>2]|0}function yxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;cuc(i,d);d=Hvc(i,885240)|0;Ivc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];Pxc(a,g+16|0,b,i,e,d);u=h;return f[b>>2]|0}function zxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;cuc(i,d);d=Hvc(i,885240)|0;Ivc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];$xc(a,g+20|0,b,i,e,d);u=h;return f[b>>2]|0}function Axc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+144|0;k=j+128|0;l=j+112|0;m=j+124|0;n=j+120|0;o=j+116|0;p=j+108|0;q=j+104|0;r=j+100|0;s=j+96|0;t=j+92|0;v=j+88|0;w=j+84|0;x=j+80|0;y=j+76|0;z=j+72|0;A=j+68|0;B=j+64|0;C=j+60|0;D=j+56|0;E=j+52|0;F=j+48|0;G=j+44|0;H=j+40|0;I=j+36|0;J=j+32|0;K=j+28|0;L=j+24|0;M=j+20|0;N=j+16|0;O=j+12|0;P=j+8|0;Q=j+4|0;R=j;f[g>>2]=0;cuc(k,e);S=Hvc(k,885240)|0;Ivc(k);T=h+8|0;U=h+20|0;V=h+16|0;W=h+24|0;X=a+8|0;do switch(i<<24>>24|0){case 65:case 97:{f[m>>2]=f[d>>2];f[k>>2]=f[m>>2];Oxc(a,W,c,k,g,S);Y=26;break}case 104:case 66:case 98:{f[n>>2]=f[d>>2];f[k>>2]=f[n>>2];Pxc(a,V,c,k,g,S);Y=26;break}case 99:{Z=_i[f[(f[X>>2]|0)+12>>2]&1023](X)|0;f[o>>2]=f[c>>2];f[p>>2]=f[d>>2];_=b[Z+11>>0]|0;$=_<<24>>24<0;aa=$?f[Z>>2]|0:Z;ba=aa+($?f[Z+4>>2]|0:_&255)|0;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];_=Qxc(a,l,k,e,g,h,aa,ba)|0;f[c>>2]=_;Y=26;break}case 101:case 100:{f[q>>2]=f[d>>2];f[k>>2]=f[q>>2];Rxc(a,h+12|0,c,k,g,S);Y=26;break}case 68:{f[r>>2]=f[c>>2];f[s>>2]=f[d>>2];f[l>>2]=f[r>>2];f[k>>2]=f[s>>2];_=Qxc(a,l,k,e,g,h,515663,515671)|0;f[c>>2]=_;Y=26;break}case 70:{f[t>>2]=f[c>>2];f[v>>2]=f[d>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];_=Qxc(a,l,k,e,g,h,515671,515679)|0;f[c>>2]=_;Y=26;break}case 72:{f[w>>2]=f[d>>2];f[k>>2]=f[w>>2];Sxc(a,T,c,k,g,S);Y=26;break}case 73:{f[x>>2]=f[d>>2];f[k>>2]=f[x>>2];Txc(a,T,c,k,g,S);Y=26;break}case 106:{f[y>>2]=f[d>>2];f[k>>2]=f[y>>2];Uxc(a,h+28|0,c,k,g,S);Y=26;break}case 109:{f[z>>2]=f[d>>2];f[k>>2]=f[z>>2];Vxc(a,V,c,k,g,S);Y=26;break}case 77:{f[A>>2]=f[d>>2];f[k>>2]=f[A>>2];Wxc(a,h+4|0,c,k,g,S);Y=26;break}case 116:case 110:{f[B>>2]=f[d>>2];f[k>>2]=f[B>>2];Xxc(a,c,k,g,S);Y=26;break}case 112:{f[C>>2]=f[d>>2];f[k>>2]=f[C>>2];Yxc(a,T,c,k,g,S);Y=26;break}case 114:{f[D>>2]=f[c>>2];f[E>>2]=f[d>>2];f[l>>2]=f[D>>2];f[k>>2]=f[E>>2];_=Qxc(a,l,k,e,g,h,515679,515690)|0;f[c>>2]=_;Y=26;break}case 82:{f[F>>2]=f[c>>2];f[G>>2]=f[d>>2];f[l>>2]=f[F>>2];f[k>>2]=f[G>>2];_=Qxc(a,l,k,e,g,h,515690,515695)|0;f[c>>2]=_;Y=26;break}case 83:{f[H>>2]=f[d>>2];f[k>>2]=f[H>>2];Zxc(a,h,c,k,g,S);Y=26;break}case 84:{f[I>>2]=f[c>>2];f[J>>2]=f[d>>2];f[l>>2]=f[I>>2];f[k>>2]=f[J>>2];_=Qxc(a,l,k,e,g,h,515695,515703)|0;f[c>>2]=_;Y=26;break}case 119:{f[K>>2]=f[d>>2];f[k>>2]=f[K>>2];_xc(a,W,c,k,g,S);Y=26;break}case 120:{_=f[(f[a>>2]|0)+20>>2]|0;f[L>>2]=f[c>>2];f[M>>2]=f[d>>2];f[l>>2]=f[L>>2];f[k>>2]=f[M>>2];ca=xg[_&127](a,l,k,e,g,h)|0;break}case 88:{_=_i[f[(f[X>>2]|0)+24>>2]&1023](X)|0;f[N>>2]=f[c>>2];f[O>>2]=f[d>>2];ba=b[_+11>>0]|0;aa=ba<<24>>24<0;Z=aa?f[_>>2]|0:_;$=Z+(aa?f[_+4>>2]|0:ba&255)|0;f[l>>2]=f[N>>2];f[k>>2]=f[O>>2];ba=Qxc(a,l,k,e,g,h,Z,$)|0;f[c>>2]=ba;Y=26;break}case 121:{f[P>>2]=f[d>>2];f[k>>2]=f[P>>2];$xc(a,U,c,k,g,S);Y=26;break}case 89:{f[Q>>2]=f[d>>2];f[k>>2]=f[Q>>2];ayc(a,U,c,k,g,S);Y=26;break}case 37:{f[R>>2]=f[d>>2];f[k>>2]=f[R>>2];byc(a,c,k,g,S);Y=26;break}default:{f[g>>2]=f[g>>2]|4;Y=26}}while(0);if((Y|0)==26)ca=f[c>>2]|0;u=j;return ca|0}function Bxc(a){a=a|0;if((b[529424]|0)==0?MIc(529424)|0:0){Mxc();f[221528]=885944}return f[221528]|0}function Cxc(a){a=a|0;if((b[529408]|0)==0?MIc(529408)|0:0){Kxc();f[221485]=885652}return f[221485]|0}function Dxc(a){a=a|0;if((b[529392]|0)==0?MIc(529392)|0:0){Ixc();f[221412]=885360}return f[221412]|0}function Exc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[529384]|0)==0?MIc(529384)|0:0){f[221337]=0;f[221338]=0;f[221339]=0;d=Ztc(515421)|0;if(d>>>0>4294967279)dEc(885348);if(d>>>0<11){b[885359]=d;e=885348}else{g=d+16&-16;h=VDc(g)|0;f[221337]=h;f[221339]=g|-2147483648;f[221338]=d;e=h}etc(e,515421,d)|0;b[c>>0]=0;_tc(e+d|0,c);be(1736,885348,x|0)|0}u=a;return 885348}function Fxc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[529376]|0)==0?MIc(529376)|0:0){f[221334]=0;f[221335]=0;f[221336]=0;d=Ztc(515409)|0;if(d>>>0>4294967279)dEc(885336);if(d>>>0<11){b[885347]=d;e=885336}else{g=d+16&-16;h=VDc(g)|0;f[221334]=h;f[221336]=g|-2147483648;f[221335]=d;e=h}etc(e,515409,d)|0;b[c>>0]=0;_tc(e+d|0,c);be(1736,885336,x|0)|0}u=a;return 885336}function Gxc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[529368]|0)==0?MIc(529368)|0:0){f[221331]=0;f[221332]=0;f[221333]=0;d=Ztc(515400)|0;if(d>>>0>4294967279)dEc(885324);if(d>>>0<11){b[885335]=d;e=885324}else{g=d+16&-16;h=VDc(g)|0;f[221331]=h;f[221333]=g|-2147483648;f[221332]=d;e=h}etc(e,515400,d)|0;b[c>>0]=0;_tc(e+d|0,c);be(1736,885324,x|0)|0}u=a;return 885324}function Hxc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[529360]|0)==0?MIc(529360)|0:0){f[221328]=0;f[221329]=0;f[221330]=0;d=Ztc(515391)|0;if(d>>>0>4294967279)dEc(885312);if(d>>>0<11){b[885323]=d;e=885312}else{g=d+16&-16;h=VDc(g)|0;f[221328]=h;f[221330]=g|-2147483648;f[221329]=d;e=h}etc(e,515391,d)|0;b[c>>0]=0;_tc(e+d|0,c);be(1736,885312,x|0)|0}u=a;return 885312}function Ixc(){var a=0,c=0;if((b[529400]|0)==0?MIc(529400)|0:0){a=885360;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=885648);be(1795,0,x|0)|0}nEc(885360,515442)|0;nEc(885372,515445)|0;return}function Jxc(a){a=a|0;a=885648;do{a=a+-12|0;hEc(a)}while((a|0)!=885360);return}function Kxc(){var a=0,c=0;if((b[529416]|0)==0?MIc(529416)|0:0){a=885652;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=885940);be(1796,0,x|0)|0}nEc(885652,515448)|0;nEc(885664,515456)|0;nEc(885676,515465)|0;nEc(885688,515471)|0;nEc(885700,515477)|0;nEc(885712,515481)|0;nEc(885724,515486)|0;nEc(885736,515491)|0;nEc(885748,515498)|0;nEc(885760,515508)|0;nEc(885772,515516)|0;nEc(885784,515525)|0;nEc(885796,515534)|0;nEc(885808,515538)|0;nEc(885820,515542)|0;nEc(885832,515546)|0;nEc(885844,515477)|0;nEc(885856,515550)|0;nEc(885868,515554)|0;nEc(885880,515558)|0;nEc(885892,515562)|0;nEc(885904,515566)|0;nEc(885916,515570)|0;nEc(885928,515574)|0;return}function Lxc(a){a=a|0;a=885940;do{a=a+-12|0;hEc(a)}while((a|0)!=885652);return}function Mxc(){var a=0,c=0;if((b[529432]|0)==0?MIc(529432)|0:0){a=885944;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=886112);be(1797,0,x|0)|0}nEc(885944,515578)|0;nEc(885956,515585)|0;nEc(885968,515592)|0;nEc(885980,515600)|0;nEc(885992,515610)|0;nEc(886004,515619)|0;nEc(886016,515626)|0;nEc(886028,515635)|0;nEc(886040,515639)|0;nEc(886052,515643)|0;nEc(886064,515647)|0;nEc(886076,515651)|0;nEc(886088,515655)|0;nEc(886100,515659)|0;return}function Nxc(a){a=a|0;a=886112;do{a=a+-12|0;hEc(a)}while((a|0)!=885944);return}function Oxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=_i[f[f[k>>2]>>2]&1023](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(nwc(c,i,a,a+168|0,g,e,0)|0)-a|0;if((j|0)<168)f[b>>2]=((j|0)/12|0|0)%7|0;u=h;return}function Pxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=_i[f[(f[k>>2]|0)+4>>2]&1023](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(nwc(c,i,a,a+288|0,g,e,0)|0)-a|0;if((j|0)<288)f[b>>2]=((j|0)/12|0|0)%12|0;u=h;return}function Qxc(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;l=u;u=u+16|0;m=l+12|0;n=l+8|0;o=l+4|0;p=l;cuc(m,g);q=Hvc(m,885240)|0;Ivc(m);f[h>>2]=0;r=q+8|0;s=j;j=0;a:while(1){t=(s|0)!=(k|0);v=j;while(1){w=f[c>>2]|0;if(!(t&(v|0)==0)){x=w;break a}y=w;if(w){z=f[w+12>>2]|0;if((z|0)==(f[w+16>>2]|0))A=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else A=dtc(b[z>>0]|0)|0;if(buc(A,ctc()|0)|0){f[c>>2]=0;B=0;C=1;D=0}else{B=w;C=0;D=y}}else{B=0;C=1;D=y}y=f[e>>2]|0;w=y;do if(y){z=f[y+12>>2]|0;if((z|0)==(f[y+16>>2]|0))E=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else E=dtc(b[z>>0]|0)|0;if(!(buc(E,ctc()|0)|0))if(C){F=y;G=w;break}else{H=61;break a}else{f[e>>2]=0;I=0;H=16;break}}else{I=w;H=16}while(0);if((H|0)==16){H=0;if(C){H=61;break a}else{F=0;G=I}}if((hj[f[(f[q>>2]|0)+36>>2]&511](q,b[s>>0]|0,0)|0)<<24>>24==37){H=19;break}w=b[s>>0]|0;if(w<<24>>24>-1?(J=f[r>>2]|0,d[J+(w<<24>>24<<1)>>1]&8192):0){K=s;H=27;break}L=B+12|0;w=f[L>>2]|0;M=B+16|0;if((w|0)==(f[M>>2]|0))N=_i[f[(f[B>>2]|0)+36>>2]&1023](B)|0;else N=dtc(b[w>>0]|0)|0;w=Mi[f[(f[q>>2]|0)+12>>2]&1023](q,N&255)|0;if(w<<24>>24==(Mi[f[(f[q>>2]|0)+12>>2]&1023](q,b[s>>0]|0)|0)<<24>>24){H=57;break}f[h>>2]=4;v=4}b:do if((H|0)==19){H=0;v=s+1|0;if((v|0)==(k|0)){H=61;break a}t=hj[f[(f[q>>2]|0)+36>>2]&511](q,b[v>>0]|0,0)|0;switch(t<<24>>24){case 48:case 69:{w=s+2|0;if((w|0)==(k|0)){H=61;break a}O=t;P=hj[f[(f[q>>2]|0)+36>>2]&511](q,b[w>>0]|0,0)|0;Q=v;break}default:{O=0;P=t;Q=s}}t=f[(f[a>>2]|0)+36>>2]|0;f[o>>2]=D;f[p>>2]=G;f[n>>2]=f[o>>2];f[m>>2]=f[p>>2];v=Ij[t&15](a,n,m,g,h,i,P,O)|0;f[c>>2]=v;R=Q+2|0}else if((H|0)==27){while(1){H=0;v=K+1|0;if((v|0)==(k|0)){S=k;break}t=b[v>>0]|0;if(t<<24>>24<=-1){S=v;break}if(!(d[J+(t<<24>>24<<1)>>1]&8192)){S=v;break}else{K=v;H=27}}v=B;t=F;w=F;while(1){if(v){y=f[v+12>>2]|0;if((y|0)==(f[v+16>>2]|0))T=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else T=dtc(b[y>>0]|0)|0;if(buc(T,ctc()|0)|0){f[c>>2]=0;U=1;V=0}else{U=0;V=v}}else{U=1;V=0}do if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))W=_i[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else W=dtc(b[y>>0]|0)|0;if(!(buc(W,ctc()|0)|0))if(U^(t|0)==0){X=t;Y=t;break}else{R=S;break b}else{f[e>>2]=0;Z=0;H=43;break}}else{Z=t;H=43}while(0);if((H|0)==43){H=0;if(U){R=S;break b}else{X=Z;Y=0}}y=V+12|0;z=f[y>>2]|0;_=V+16|0;if((z|0)==(f[_>>2]|0))$=_i[f[(f[V>>2]|0)+36>>2]&1023](V)|0;else $=dtc(b[z>>0]|0)|0;if(($&255)<<24>>24<=-1){R=S;break b}if(!(d[(f[r>>2]|0)+($<<24>>24<<1)>>1]&8192)){R=S;break b}z=f[y>>2]|0;if((z|0)==(f[_>>2]|0)){_i[f[(f[V>>2]|0)+40>>2]&1023](V)|0;v=V;t=X;w=Y;continue}else{f[y>>2]=z+1;dtc(b[z>>0]|0)|0;v=V;t=X;w=Y;continue}}}else if((H|0)==57){H=0;w=s+1|0;t=f[L>>2]|0;if((t|0)==(f[M>>2]|0)){_i[f[(f[B>>2]|0)+40>>2]&1023](B)|0;R=w;break}else{f[L>>2]=t+1;dtc(b[t>>0]|0)|0;R=w;break}}while(0);s=R;j=f[h>>2]|0}if((H|0)==61){f[h>>2]=4;x=B}if(x){B=f[x+12>>2]|0;if((B|0)==(f[x+16>>2]|0))aa=_i[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else aa=dtc(b[B>>0]|0)|0;if(buc(aa,ctc()|0)|0){f[c>>2]=0;ba=0;ca=1}else{ba=x;ca=0}}else{ba=0;ca=1}x=f[e>>2]|0;do if(x){c=f[x+12>>2]|0;if((c|0)==(f[x+16>>2]|0))da=_i[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else da=dtc(b[c>>0]|0)|0;if(!(buc(da,ctc()|0)|0))if(ca)break;else{H=76;break}else{f[e>>2]=0;H=74;break}}else H=74;while(0);if((H|0)==74?ca:0)H=76;if((H|0)==76)f[h>>2]=f[h>>2]|2;u=l;return ba|0}function Rxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<31&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Sxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<24&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Txc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<12&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Uxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,3)|0;g=f[e>>2]|0;if((i|0)<366&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Vxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<13&(g&4|0)==0)f[b>>2]=i+-1;else f[e>>2]=g|4;u=a;return}function Wxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<60&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Xxc(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=h+8|0;a:while(1){h=f[c>>2]|0;do if(h){i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))j=_i[f[(f[h>>2]|0)+36>>2]&1023](h)|0;else j=dtc(b[i>>0]|0)|0;if(buc(j,ctc()|0)|0){f[c>>2]=0;k=1;break}else{k=(f[c>>2]|0)==0;break}}else k=1;while(0);h=f[e>>2]|0;do if(h){i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))l=_i[f[(f[h>>2]|0)+36>>2]&1023](h)|0;else l=dtc(b[i>>0]|0)|0;if(!(buc(l,ctc()|0)|0))if(k){m=h;break}else{n=h;break a}else{f[e>>2]=0;o=15;break}}else o=15;while(0);if((o|0)==15){o=0;if(k){n=0;break}else m=0}h=f[c>>2]|0;i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))p=_i[f[(f[h>>2]|0)+36>>2]&1023](h)|0;else p=dtc(b[i>>0]|0)|0;if((p&255)<<24>>24<=-1){n=m;break}if(!(d[(f[a>>2]|0)+(p<<24>>24<<1)>>1]&8192)){n=m;break}i=f[c>>2]|0;h=i+12|0;q=f[h>>2]|0;if((q|0)==(f[i+16>>2]|0)){_i[f[(f[i>>2]|0)+40>>2]&1023](i)|0;continue}else{f[h>>2]=q+1;dtc(b[q>>0]|0)|0;continue}}m=f[c>>2]|0;do if(m){p=f[m+12>>2]|0;if((p|0)==(f[m+16>>2]|0))r=_i[f[(f[m>>2]|0)+36>>2]&1023](m)|0;else r=dtc(b[p>>0]|0)|0;if(buc(r,ctc()|0)|0){f[c>>2]=0;s=1;break}else{s=(f[c>>2]|0)==0;break}}else s=1;while(0);do if(n){c=f[n+12>>2]|0;if((c|0)==(f[n+16>>2]|0))t=_i[f[(f[n>>2]|0)+36>>2]&1023](n)|0;else t=dtc(b[c>>0]|0)|0;if(!(buc(t,ctc()|0)|0))if(s)break;else{o=40;break}else{f[e>>2]=0;o=38;break}}else o=38;while(0);if((o|0)==38?s:0)o=40;if((o|0)==40)f[g>>2]=f[g>>2]|2;return}function Yxc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i+4|0;k=i;l=a+8|0;a=_i[f[(f[l>>2]|0)+8>>2]&1023](l)|0;l=b[a+11>>0]|0;if(l<<24>>24<0)m=f[a+4>>2]|0;else m=l&255;l=b[a+12+11>>0]|0;if(l<<24>>24<0)n=f[a+16>>2]|0;else n=l&255;do if((m|0)!=(0-n|0)){f[k>>2]=f[e>>2];f[j>>2]=f[k>>2];l=(nwc(d,j,a,a+24|0,h,g,0)|0)-a|0;o=f[c>>2]|0;if((o|0)==12&(l|0)==0){f[c>>2]=0;break}if((o|0)<12&(l|0)==12)f[c>>2]=o+12}else f[g>>2]=f[g>>2]|4;while(0);u=i;return}function Zxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<61&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function _xc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,1)|0;g=f[e>>2]|0;if((i|0)<7&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function $xc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,4)|0;if(!(f[e>>2]&4)){if((i|0)<69)j=i+2e3|0;else j=(i|0)<100?i+1900|0:i;f[b>>2]=j+-1900}u=a;return}function ayc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=cyc(c,h,e,g,4)|0;if(!(f[e>>2]&4))f[b>>2]=i+-1900;u=a;return}function byc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=f[c>>2]|0;do if(a){h=f[a+12>>2]|0;if((h|0)==(f[a+16>>2]|0))i=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else i=dtc(b[h>>0]|0)|0;if(buc(i,ctc()|0)|0){f[c>>2]=0;j=1;break}else{j=(f[c>>2]|0)==0;break}}else j=1;while(0);i=f[d>>2]|0;do if(i){a=f[i+12>>2]|0;if((a|0)==(f[i+16>>2]|0))k=_i[f[(f[i>>2]|0)+36>>2]&1023](i)|0;else k=dtc(b[a>>0]|0)|0;if(!(buc(k,ctc()|0)|0))if(j){l=i;m=16;break}else{n=6;m=38;break}else{f[d>>2]=0;m=14;break}}else m=14;while(0);if((m|0)==14)if(j){n=6;m=38}else{l=0;m=16}a:do if((m|0)==16){j=f[c>>2]|0;i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=_i[f[(f[j>>2]|0)+36>>2]&1023](j)|0;else o=dtc(b[i>>0]|0)|0;if((hj[f[(f[g>>2]|0)+36>>2]&511](g,o&255,0)|0)<<24>>24==37){i=f[c>>2]|0;j=i+12|0;k=f[j>>2]|0;if((k|0)==(f[i+16>>2]|0))_i[f[(f[i>>2]|0)+40>>2]&1023](i)|0;else{f[j>>2]=k+1;dtc(b[k>>0]|0)|0}k=f[c>>2]|0;do if(k){j=f[k+12>>2]|0;if((j|0)==(f[k+16>>2]|0))p=_i[f[(f[k>>2]|0)+36>>2]&1023](k)|0;else p=dtc(b[j>>0]|0)|0;if(buc(p,ctc()|0)|0){f[c>>2]=0;q=1;break}else{q=(f[c>>2]|0)==0;break}}else q=1;while(0);do if(l|0){k=f[l+12>>2]|0;if((k|0)==(f[l+16>>2]|0))r=_i[f[(f[l>>2]|0)+36>>2]&1023](l)|0;else r=dtc(b[k>>0]|0)|0;if(!(buc(r,ctc()|0)|0))if(q)break a;else{n=2;m=38;break a}else{f[d>>2]=0;break}}while(0);if(q){n=2;m=38}}else{n=4;m=38}}while(0);if((m|0)==38)f[e>>2]=f[e>>2]|n;return}function cyc(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=f[a>>2]|0;do if(i){j=f[i+12>>2]|0;if((j|0)==(f[i+16>>2]|0))k=_i[f[(f[i>>2]|0)+36>>2]&1023](i)|0;else k=dtc(b[j>>0]|0)|0;if(buc(k,ctc()|0)|0){f[a>>2]=0;l=1;break}else{l=(f[a>>2]|0)==0;break}}else l=1;while(0);k=f[c>>2]|0;do if(k){i=f[k+12>>2]|0;if((i|0)==(f[k+16>>2]|0))m=_i[f[(f[k>>2]|0)+36>>2]&1023](k)|0;else m=dtc(b[i>>0]|0)|0;if(!(buc(m,ctc()|0)|0))if(l){n=k;o=17;break}else{o=16;break}else{f[c>>2]=0;o=14;break}}else o=14;while(0);if((o|0)==14)if(l)o=16;else{n=0;o=17}a:do if((o|0)==16){f[e>>2]=f[e>>2]|6;p=0}else if((o|0)==17){l=f[a>>2]|0;k=f[l+12>>2]|0;if((k|0)==(f[l+16>>2]|0))q=_i[f[(f[l>>2]|0)+36>>2]&1023](l)|0;else q=dtc(b[k>>0]|0)|0;k=q&255;if(k<<24>>24>-1?(l=g+8|0,d[(f[l>>2]|0)+(q<<24>>24<<1)>>1]&2048):0){m=(hj[f[(f[g>>2]|0)+36>>2]&511](g,k,0)|0)<<24>>24;k=f[a>>2]|0;i=k+12|0;j=f[i>>2]|0;if((j|0)==(f[k+16>>2]|0)){_i[f[(f[k>>2]|0)+40>>2]&1023](k)|0;r=m;s=h;t=n;u=n}else{f[i>>2]=j+1;dtc(b[j>>0]|0)|0;r=m;s=h;t=n;u=n}while(1){v=r+-48|0;m=s+-1|0;j=f[a>>2]|0;do if(j){i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))w=_i[f[(f[j>>2]|0)+36>>2]&1023](j)|0;else w=dtc(b[i>>0]|0)|0;if(buc(w,ctc()|0)|0){f[a>>2]=0;x=1;break}else{x=(f[a>>2]|0)==0;break}}else x=1;while(0);do if(u){j=f[u+12>>2]|0;if((j|0)==(f[u+16>>2]|0))y=_i[f[(f[u>>2]|0)+36>>2]&1023](u)|0;else y=dtc(b[j>>0]|0)|0;if(buc(y,ctc()|0)|0){f[c>>2]=0;z=0;A=1;B=0;break}else{z=t;A=(t|0)==0;B=t;break}}else{z=t;A=1;B=0}while(0);C=f[a>>2]|0;if(!((s|0)>1&(x^A)))break;j=f[C+12>>2]|0;if((j|0)==(f[C+16>>2]|0))D=_i[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else D=dtc(b[j>>0]|0)|0;j=D&255;if(j<<24>>24<=-1){p=v;break a}if(!(d[(f[l>>2]|0)+(D<<24>>24<<1)>>1]&2048)){p=v;break a}i=((hj[f[(f[g>>2]|0)+36>>2]&511](g,j,0)|0)<<24>>24)+(v*10|0)|0;j=f[a>>2]|0;k=j+12|0;E=f[k>>2]|0;if((E|0)==(f[j+16>>2]|0)){_i[f[(f[j>>2]|0)+40>>2]&1023](j)|0;r=i;s=m;t=z;u=B;continue}else{f[k>>2]=E+1;dtc(b[E>>0]|0)|0;r=i;s=m;t=z;u=B;continue}}do if(C){l=f[C+12>>2]|0;if((l|0)==(f[C+16>>2]|0))F=_i[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else F=dtc(b[l>>0]|0)|0;if(buc(F,ctc()|0)|0){f[a>>2]=0;G=1;break}else{G=(f[a>>2]|0)==0;break}}else G=1;while(0);do if(z){l=f[z+12>>2]|0;if((l|0)==(f[z+16>>2]|0))H=_i[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else H=dtc(b[l>>0]|0)|0;if(!(buc(H,ctc()|0)|0))if(G){p=v;break a}else break;else{f[c>>2]=0;o=62;break}}else o=62;while(0);if((o|0)==62?!G:0){p=v;break}f[e>>2]=f[e>>2]|2;p=v;break}f[e>>2]=f[e>>2]|4;p=0}while(0);return p|0}function dyc(a){a=a|0;nvc(a);return}function eyc(a){a=a|0;nvc(a);YDc(a);return}function fyc(a){a=a|0;return 2}function gyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=Cyc(a,j,i,d,e,g,184292,184324)|0;u=h;return l|0}function hyc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i+12|0;k=i+8|0;l=i+4|0;m=i;n=a+8|0;o=_i[f[(f[n>>2]|0)+20>>2]&1023](n)|0;f[l>>2]=f[c>>2];f[m>>2]=f[d>>2];d=b[o+8+3>>0]|0;c=d<<24>>24<0;n=c?f[o>>2]|0:o;p=n+((c?f[o+4>>2]|0:d&255)<<2)|0;f[k>>2]=f[l>>2];f[j>>2]=f[m>>2];m=Cyc(a,k,j,e,g,h,n,p)|0;u=i;return m|0}function iyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;cuc(i,d);d=Hvc(i,885272)|0;Ivc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];Ayc(a,g+24|0,b,i,e,d);u=h;return f[b>>2]|0}function jyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;cuc(i,d);d=Hvc(i,885272)|0;Ivc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];Byc(a,g+16|0,b,i,e,d);u=h;return f[b>>2]|0}function kyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;cuc(i,d);d=Hvc(i,885272)|0;Ivc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];Nyc(a,g+20|0,b,i,e,d);u=h;return f[b>>2]|0}function lyc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+144|0;k=j+128|0;l=j+112|0;m=j+124|0;n=j+120|0;o=j+116|0;p=j+108|0;q=j+104|0;r=j+100|0;s=j+96|0;t=j+92|0;v=j+88|0;w=j+84|0;x=j+80|0;y=j+76|0;z=j+72|0;A=j+68|0;B=j+64|0;C=j+60|0;D=j+56|0;E=j+52|0;F=j+48|0;G=j+44|0;H=j+40|0;I=j+36|0;J=j+32|0;K=j+28|0;L=j+24|0;M=j+20|0;N=j+16|0;O=j+12|0;P=j+8|0;Q=j+4|0;R=j;f[g>>2]=0;cuc(k,e);S=Hvc(k,885272)|0;Ivc(k);T=h+8|0;U=h+20|0;V=h+16|0;W=h+24|0;X=a+8|0;do switch(i<<24>>24|0){case 65:case 97:{f[m>>2]=f[d>>2];f[k>>2]=f[m>>2];Ayc(a,W,c,k,g,S);Y=26;break}case 104:case 66:case 98:{f[n>>2]=f[d>>2];f[k>>2]=f[n>>2];Byc(a,V,c,k,g,S);Y=26;break}case 99:{Z=_i[f[(f[X>>2]|0)+12>>2]&1023](X)|0;f[o>>2]=f[c>>2];f[p>>2]=f[d>>2];_=b[Z+8+3>>0]|0;$=_<<24>>24<0;aa=$?f[Z>>2]|0:Z;ba=aa+(($?f[Z+4>>2]|0:_&255)<<2)|0;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];_=Cyc(a,l,k,e,g,h,aa,ba)|0;f[c>>2]=_;Y=26;break}case 101:case 100:{f[q>>2]=f[d>>2];f[k>>2]=f[q>>2];Dyc(a,h+12|0,c,k,g,S);Y=26;break}case 68:{f[r>>2]=f[c>>2];f[s>>2]=f[d>>2];f[l>>2]=f[r>>2];f[k>>2]=f[s>>2];_=Cyc(a,l,k,e,g,h,184132,184164)|0;f[c>>2]=_;Y=26;break}case 70:{f[t>>2]=f[c>>2];f[v>>2]=f[d>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];_=Cyc(a,l,k,e,g,h,184164,184196)|0;f[c>>2]=_;Y=26;break}case 72:{f[w>>2]=f[d>>2];f[k>>2]=f[w>>2];Eyc(a,T,c,k,g,S);Y=26;break}case 73:{f[x>>2]=f[d>>2];f[k>>2]=f[x>>2];Fyc(a,T,c,k,g,S);Y=26;break}case 106:{f[y>>2]=f[d>>2];f[k>>2]=f[y>>2];Gyc(a,h+28|0,c,k,g,S);Y=26;break}case 109:{f[z>>2]=f[d>>2];f[k>>2]=f[z>>2];Hyc(a,V,c,k,g,S);Y=26;break}case 77:{f[A>>2]=f[d>>2];f[k>>2]=f[A>>2];Iyc(a,h+4|0,c,k,g,S);Y=26;break}case 116:case 110:{f[B>>2]=f[d>>2];f[k>>2]=f[B>>2];Jyc(a,c,k,g,S);Y=26;break}case 112:{f[C>>2]=f[d>>2];f[k>>2]=f[C>>2];Kyc(a,T,c,k,g,S);Y=26;break}case 114:{f[D>>2]=f[c>>2];f[E>>2]=f[d>>2];f[l>>2]=f[D>>2];f[k>>2]=f[E>>2];_=Cyc(a,l,k,e,g,h,184196,184240)|0;f[c>>2]=_;Y=26;break}case 82:{f[F>>2]=f[c>>2];f[G>>2]=f[d>>2];f[l>>2]=f[F>>2];f[k>>2]=f[G>>2];_=Cyc(a,l,k,e,g,h,184240,184260)|0;f[c>>2]=_;Y=26;break}case 83:{f[H>>2]=f[d>>2];f[k>>2]=f[H>>2];Lyc(a,h,c,k,g,S);Y=26;break}case 84:{f[I>>2]=f[c>>2];f[J>>2]=f[d>>2];f[l>>2]=f[I>>2];f[k>>2]=f[J>>2];_=Cyc(a,l,k,e,g,h,184260,184292)|0;f[c>>2]=_;Y=26;break}case 119:{f[K>>2]=f[d>>2];f[k>>2]=f[K>>2];Myc(a,W,c,k,g,S);Y=26;break}case 120:{_=f[(f[a>>2]|0)+20>>2]|0;f[L>>2]=f[c>>2];f[M>>2]=f[d>>2];f[l>>2]=f[L>>2];f[k>>2]=f[M>>2];ca=xg[_&127](a,l,k,e,g,h)|0;break}case 88:{_=_i[f[(f[X>>2]|0)+24>>2]&1023](X)|0;f[N>>2]=f[c>>2];f[O>>2]=f[d>>2];ba=b[_+8+3>>0]|0;aa=ba<<24>>24<0;Z=aa?f[_>>2]|0:_;$=Z+((aa?f[_+4>>2]|0:ba&255)<<2)|0;f[l>>2]=f[N>>2];f[k>>2]=f[O>>2];ba=Cyc(a,l,k,e,g,h,Z,$)|0;f[c>>2]=ba;Y=26;break}case 121:{f[P>>2]=f[d>>2];f[k>>2]=f[P>>2];Nyc(a,U,c,k,g,S);Y=26;break}case 89:{f[Q>>2]=f[d>>2];f[k>>2]=f[Q>>2];Oyc(a,U,c,k,g,S);Y=26;break}case 37:{f[R>>2]=f[d>>2];f[k>>2]=f[R>>2];Pyc(a,c,k,g,S);Y=26;break}default:{f[g>>2]=f[g>>2]|4;Y=26}}while(0);if((Y|0)==26)ca=f[c>>2]|0;u=j;return ca|0}function myc(a){a=a|0;if((b[529504]|0)==0?MIc(529504)|0:0){yyc();f[221731]=886756}return f[221731]|0}function nyc(a){a=a|0;if((b[529488]|0)==0?MIc(529488)|0:0){wyc();f[221688]=886464}return f[221688]|0}function oyc(a){a=a|0;if((b[529472]|0)==0?MIc(529472)|0:0){uyc();f[221615]=886172}return f[221615]|0}function pyc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[529464]|0)==0?MIc(529464)|0:0){f[221540]=0;f[221541]=0;f[221542]=0;d=tyc(183164)|0;if(d>>>0>1073741807)dEc(886160);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)tf();else{g=VDc(e<<2)|0;f[221540]=g;f[221542]=e|-2147483648;f[221541]=d;h=g;break}}else{b[886171]=d;h=886160}while(0);wtc(h,183164,d)|0;f[c>>2]=0;tvc(h+(d<<2)|0,c);be(1798,886160,x|0)|0}u=a;return 886160}function qyc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[529456]|0)==0?MIc(529456)|0:0){f[221537]=0;f[221538]=0;f[221539]=0;d=tyc(183116)|0;if(d>>>0>1073741807)dEc(886148);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)tf();else{g=VDc(e<<2)|0;f[221537]=g;f[221539]=e|-2147483648;f[221538]=d;h=g;break}}else{b[886159]=d;h=886148}while(0);wtc(h,183116,d)|0;f[c>>2]=0;tvc(h+(d<<2)|0,c);be(1798,886148,x|0)|0}u=a;return 886148}function ryc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[529448]|0)==0?MIc(529448)|0:0){f[221534]=0;f[221535]=0;f[221536]=0;d=tyc(183080)|0;if(d>>>0>1073741807)dEc(886136);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)tf();else{g=VDc(e<<2)|0;f[221534]=g;f[221536]=e|-2147483648;f[221535]=d;h=g;break}}else{b[886147]=d;h=886136}while(0);wtc(h,183080,d)|0;f[c>>2]=0;tvc(h+(d<<2)|0,c);be(1798,886136,x|0)|0}u=a;return 886136}function syc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[529440]|0)==0?MIc(529440)|0:0){f[221531]=0;f[221532]=0;f[221533]=0;d=tyc(183044)|0;if(d>>>0>1073741807)dEc(886124);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)tf();else{g=VDc(e<<2)|0;f[221531]=g;f[221533]=e|-2147483648;f[221532]=d;h=g;break}}else{b[886135]=d;h=886124}while(0);wtc(h,183044,d)|0;f[c>>2]=0;tvc(h+(d<<2)|0,c);be(1798,886124,x|0)|0}u=a;return 886124}function tyc(a){a=a|0;return iqc(a)|0}function uyc(){var a=0,c=0;if((b[529480]|0)==0?MIc(529480)|0:0){a=886172;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=886460);be(1799,0,x|0)|0}KEc(886172,183248)|0;KEc(886184,183260)|0;return}function vyc(a){a=a|0;a=886460;do{a=a+-12|0;FEc(a)}while((a|0)!=886172);return}function wyc(){var a=0,c=0;if((b[529496]|0)==0?MIc(529496)|0:0){a=886464;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=886752);be(1800,0,x|0)|0}KEc(886464,183272)|0;KEc(886476,183304)|0;KEc(886488,183340)|0;KEc(886500,183364)|0;KEc(886512,183388)|0;KEc(886524,183404)|0;KEc(886536,183424)|0;KEc(886548,183444)|0;KEc(886560,183472)|0;KEc(886572,183512)|0;KEc(886584,183544)|0;KEc(886596,183580)|0;KEc(886608,183616)|0;KEc(886620,183632)|0;KEc(886632,183648)|0;KEc(886644,183664)|0;KEc(886656,183388)|0;KEc(886668,183680)|0;KEc(886680,183696)|0;KEc(886692,183712)|0;KEc(886704,183728)|0;KEc(886716,183744)|0;KEc(886728,183760)|0;KEc(886740,183776)|0;return}function xyc(a){a=a|0;a=886752;do{a=a+-12|0;FEc(a)}while((a|0)!=886464);return}function yyc(){var a=0,c=0;if((b[529512]|0)==0?MIc(529512)|0:0){a=886756;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=886924);be(1801,0,x|0)|0}KEc(886756,183792)|0;KEc(886768,183820)|0;KEc(886780,183848)|0;KEc(886792,183880)|0;KEc(886804,183920)|0;KEc(886816,183956)|0;KEc(886828,183984)|0;KEc(886840,184020)|0;KEc(886852,184036)|0;KEc(886864,184052)|0;KEc(886876,184068)|0;KEc(886888,184084)|0;KEc(886900,184100)|0;KEc(886912,184116)|0;return}function zyc(a){a=a|0;a=886924;do{a=a+-12|0;FEc(a)}while((a|0)!=886756);return}function Ayc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=_i[f[f[k>>2]>>2]&1023](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(Owc(c,i,a,a+168|0,g,e,0)|0)-a|0;if((j|0)<168)f[b>>2]=((j|0)/12|0|0)%7|0;u=h;return}function Byc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=_i[f[(f[k>>2]|0)+4>>2]&1023](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(Owc(c,i,a,a+288|0,g,e,0)|0)-a|0;if((j|0)<288)f[b>>2]=((j|0)/12|0|0)%12|0;u=h;return}function Cyc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;j=u;u=u+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;cuc(k,d);o=Hvc(k,885272)|0;Ivc(k);f[e>>2]=0;p=h;h=0;a:while(1){q=(p|0)!=(i|0);r=h;while(1){s=f[b>>2]|0;if(!(q&(r|0)==0)){t=s;break a}v=s;if(s){w=f[s+12>>2]|0;if((w|0)==(f[s+16>>2]|0))x=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else x=vtc(f[w>>2]|0)|0;if(duc(x,utc()|0)|0){f[b>>2]=0;y=0;z=1;A=0}else{y=s;z=0;A=v}}else{y=0;z=1;A=v}v=f[c>>2]|0;s=v;do if(v){w=f[v+12>>2]|0;if((w|0)==(f[v+16>>2]|0))B=_i[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else B=vtc(f[w>>2]|0)|0;if(!(duc(B,utc()|0)|0))if(z){C=v;D=s;break}else{E=58;break a}else{f[c>>2]=0;F=0;E=16;break}}else{F=s;E=16}while(0);if((E|0)==16){E=0;if(z){E=58;break a}else{C=0;D=F}}if((hj[f[(f[o>>2]|0)+52>>2]&511](o,f[p>>2]|0,0)|0)<<24>>24==37){E=19;break}if(hj[f[(f[o>>2]|0)+12>>2]&511](o,8192,f[p>>2]|0)|0){G=p;E=26;break}H=y+12|0;s=f[H>>2]|0;I=y+16|0;if((s|0)==(f[I>>2]|0))J=_i[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else J=vtc(f[s>>2]|0)|0;s=Mi[f[(f[o>>2]|0)+28>>2]&1023](o,J)|0;if((s|0)==(Mi[f[(f[o>>2]|0)+28>>2]&1023](o,f[p>>2]|0)|0)){E=54;break}f[e>>2]=4;r=4}b:do if((E|0)==19){E=0;r=p+4|0;if((r|0)==(i|0)){E=58;break a}q=hj[f[(f[o>>2]|0)+52>>2]&511](o,f[r>>2]|0,0)|0;switch(q<<24>>24){case 48:case 69:{s=p+8|0;if((s|0)==(i|0)){E=58;break a}K=q;L=hj[f[(f[o>>2]|0)+52>>2]&511](o,f[s>>2]|0,0)|0;M=r;break}default:{K=0;L=q;M=p}}q=f[(f[a>>2]|0)+36>>2]|0;f[m>>2]=A;f[n>>2]=D;f[l>>2]=f[m>>2];f[k>>2]=f[n>>2];r=Ij[q&15](a,l,k,d,e,g,L,K)|0;f[b>>2]=r;N=M+8|0}else if((E|0)==26){while(1){E=0;r=G+4|0;if((r|0)==(i|0)){O=i;break}if(hj[f[(f[o>>2]|0)+12>>2]&511](o,8192,f[r>>2]|0)|0){G=r;E=26}else{O=r;break}}r=y;q=C;s=C;while(1){if(r){v=f[r+12>>2]|0;if((v|0)==(f[r+16>>2]|0))P=_i[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else P=vtc(f[v>>2]|0)|0;if(duc(P,utc()|0)|0){f[b>>2]=0;Q=1;R=0}else{Q=0;R=r}}else{Q=1;R=0}do if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))S=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else S=vtc(f[v>>2]|0)|0;if(!(duc(S,utc()|0)|0))if(Q^(q|0)==0){T=q;U=q;break}else{N=O;break b}else{f[c>>2]=0;V=0;E=41;break}}else{V=q;E=41}while(0);if((E|0)==41){E=0;if(Q){N=O;break b}else{T=V;U=0}}v=R+12|0;w=f[v>>2]|0;W=R+16|0;if((w|0)==(f[W>>2]|0))X=_i[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else X=vtc(f[w>>2]|0)|0;if(!(hj[f[(f[o>>2]|0)+12>>2]&511](o,8192,X)|0)){N=O;break b}w=f[v>>2]|0;if((w|0)==(f[W>>2]|0)){_i[f[(f[R>>2]|0)+40>>2]&1023](R)|0;r=R;q=T;s=U;continue}else{f[v>>2]=w+4;vtc(f[w>>2]|0)|0;r=R;q=T;s=U;continue}}}else if((E|0)==54){E=0;s=p+4|0;q=f[H>>2]|0;if((q|0)==(f[I>>2]|0)){_i[f[(f[y>>2]|0)+40>>2]&1023](y)|0;N=s;break}else{f[H>>2]=q+4;vtc(f[q>>2]|0)|0;N=s;break}}while(0);p=N;h=f[e>>2]|0}if((E|0)==58){f[e>>2]=4;t=y}if(t){y=f[t+12>>2]|0;if((y|0)==(f[t+16>>2]|0))Y=_i[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else Y=vtc(f[y>>2]|0)|0;if(duc(Y,utc()|0)|0){f[b>>2]=0;Z=0;_=1}else{Z=t;_=0}}else{Z=0;_=1}t=f[c>>2]|0;do if(t){b=f[t+12>>2]|0;if((b|0)==(f[t+16>>2]|0))$=_i[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else $=vtc(f[b>>2]|0)|0;if(!(duc($,utc()|0)|0))if(_)break;else{E=73;break}else{f[c>>2]=0;E=71;break}}else E=71;while(0);if((E|0)==71?_:0)E=73;if((E|0)==73)f[e>>2]=f[e>>2]|2;u=j;return Z|0}function Dyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<31&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Eyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<24&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Fyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<12&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Gyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,3)|0;g=f[e>>2]|0;if((i|0)<366&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Hyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<13&(g&4|0)==0)f[b>>2]=i+-1;else f[e>>2]=g|4;u=a;return}function Iyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<60&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Jyc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a:while(1){a=f[b>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))h=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else h=vtc(f[g>>2]|0)|0;if(duc(h,utc()|0)|0){f[b>>2]=0;i=1;break}else{i=(f[b>>2]|0)==0;break}}else i=1;while(0);a=f[c>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))j=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else j=vtc(f[g>>2]|0)|0;if(!(duc(j,utc()|0)|0))if(i){k=a;break}else{l=a;break a}else{f[c>>2]=0;m=15;break}}else m=15;while(0);if((m|0)==15){m=0;if(i){l=0;break}else k=0}a=f[b>>2]|0;g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))n=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else n=vtc(f[g>>2]|0)|0;if(!(hj[f[(f[e>>2]|0)+12>>2]&511](e,8192,n)|0)){l=k;break}g=f[b>>2]|0;a=g+12|0;o=f[a>>2]|0;if((o|0)==(f[g+16>>2]|0)){_i[f[(f[g>>2]|0)+40>>2]&1023](g)|0;continue}else{f[a>>2]=o+4;vtc(f[o>>2]|0)|0;continue}}k=f[b>>2]|0;do if(k){n=f[k+12>>2]|0;if((n|0)==(f[k+16>>2]|0))p=_i[f[(f[k>>2]|0)+36>>2]&1023](k)|0;else p=vtc(f[n>>2]|0)|0;if(duc(p,utc()|0)|0){f[b>>2]=0;q=1;break}else{q=(f[b>>2]|0)==0;break}}else q=1;while(0);do if(l){b=f[l+12>>2]|0;if((b|0)==(f[l+16>>2]|0))r=_i[f[(f[l>>2]|0)+36>>2]&1023](l)|0;else r=vtc(f[b>>2]|0)|0;if(!(duc(r,utc()|0)|0))if(q)break;else{m=39;break}else{f[c>>2]=0;m=37;break}}else m=37;while(0);if((m|0)==37?q:0)m=39;if((m|0)==39)f[d>>2]=f[d>>2]|2;return}function Kyc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i+4|0;k=i;l=a+8|0;a=_i[f[(f[l>>2]|0)+8>>2]&1023](l)|0;l=b[a+8+3>>0]|0;if(l<<24>>24<0)m=f[a+4>>2]|0;else m=l&255;l=b[a+20+3>>0]|0;if(l<<24>>24<0)n=f[a+16>>2]|0;else n=l&255;do if((m|0)!=(0-n|0)){f[k>>2]=f[e>>2];f[j>>2]=f[k>>2];l=(Owc(d,j,a,a+24|0,h,g,0)|0)-a|0;o=f[c>>2]|0;if((o|0)==12&(l|0)==0){f[c>>2]=0;break}if((o|0)<12&(l|0)==12)f[c>>2]=o+12}else f[g>>2]=f[g>>2]|4;while(0);u=i;return}function Lyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<61&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Myc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,1)|0;g=f[e>>2]|0;if((i|0)<7&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Nyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,4)|0;if(!(f[e>>2]&4)){if((i|0)<69)j=i+2e3|0;else j=(i|0)<100?i+1900|0:i;f[b>>2]=j+-1900}u=a;return}function Oyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=Qyc(c,h,e,g,4)|0;if(!(f[e>>2]&4))f[b>>2]=i+-1900;u=a;return}function Pyc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=f[b>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))h=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else h=vtc(f[g>>2]|0)|0;if(duc(h,utc()|0)|0){f[b>>2]=0;i=1;break}else{i=(f[b>>2]|0)==0;break}}else i=1;while(0);h=f[c>>2]|0;do if(h){a=f[h+12>>2]|0;if((a|0)==(f[h+16>>2]|0))j=_i[f[(f[h>>2]|0)+36>>2]&1023](h)|0;else j=vtc(f[a>>2]|0)|0;if(!(duc(j,utc()|0)|0))if(i){k=h;l=16;break}else{m=6;l=38;break}else{f[c>>2]=0;l=14;break}}else l=14;while(0);if((l|0)==14)if(i){m=6;l=38}else{k=0;l=16}a:do if((l|0)==16){i=f[b>>2]|0;h=f[i+12>>2]|0;if((h|0)==(f[i+16>>2]|0))n=_i[f[(f[i>>2]|0)+36>>2]&1023](i)|0;else n=vtc(f[h>>2]|0)|0;if((hj[f[(f[e>>2]|0)+52>>2]&511](e,n,0)|0)<<24>>24==37){h=f[b>>2]|0;i=h+12|0;j=f[i>>2]|0;if((j|0)==(f[h+16>>2]|0))_i[f[(f[h>>2]|0)+40>>2]&1023](h)|0;else{f[i>>2]=j+4;vtc(f[j>>2]|0)|0}j=f[b>>2]|0;do if(j){i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=_i[f[(f[j>>2]|0)+36>>2]&1023](j)|0;else o=vtc(f[i>>2]|0)|0;if(duc(o,utc()|0)|0){f[b>>2]=0;p=1;break}else{p=(f[b>>2]|0)==0;break}}else p=1;while(0);do if(k|0){j=f[k+12>>2]|0;if((j|0)==(f[k+16>>2]|0))q=_i[f[(f[k>>2]|0)+36>>2]&1023](k)|0;else q=vtc(f[j>>2]|0)|0;if(!(duc(q,utc()|0)|0))if(p)break a;else{m=2;l=38;break a}else{f[c>>2]=0;break}}while(0);if(p){m=2;l=38}}else{m=4;l=38}}while(0);if((l|0)==38)f[d>>2]=f[d>>2]|m;return}function Qyc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[a>>2]|0;do if(g){h=f[g+12>>2]|0;if((h|0)==(f[g+16>>2]|0))i=_i[f[(f[g>>2]|0)+36>>2]&1023](g)|0;else i=vtc(f[h>>2]|0)|0;if(duc(i,utc()|0)|0){f[a>>2]=0;j=1;break}else{j=(f[a>>2]|0)==0;break}}else j=1;while(0);i=f[b>>2]|0;do if(i){g=f[i+12>>2]|0;if((g|0)==(f[i+16>>2]|0))k=_i[f[(f[i>>2]|0)+36>>2]&1023](i)|0;else k=vtc(f[g>>2]|0)|0;if(!(duc(k,utc()|0)|0))if(j){l=i;m=17;break}else{m=16;break}else{f[b>>2]=0;m=14;break}}else m=14;while(0);if((m|0)==14)if(j)m=16;else{l=0;m=17}a:do if((m|0)==16){f[c>>2]=f[c>>2]|6;n=0}else if((m|0)==17){j=f[a>>2]|0;i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=_i[f[(f[j>>2]|0)+36>>2]&1023](j)|0;else o=vtc(f[i>>2]|0)|0;if(!(hj[f[(f[d>>2]|0)+12>>2]&511](d,2048,o)|0)){f[c>>2]=f[c>>2]|4;n=0;break}i=(hj[f[(f[d>>2]|0)+52>>2]&511](d,o,0)|0)<<24>>24;j=f[a>>2]|0;k=j+12|0;g=f[k>>2]|0;if((g|0)==(f[j+16>>2]|0)){_i[f[(f[j>>2]|0)+40>>2]&1023](j)|0;p=i;q=e;r=l;s=l}else{f[k>>2]=g+4;vtc(f[g>>2]|0)|0;p=i;q=e;r=l;s=l}while(1){t=p+-48|0;i=q+-1|0;g=f[a>>2]|0;do if(g){k=f[g+12>>2]|0;if((k|0)==(f[g+16>>2]|0))u=_i[f[(f[g>>2]|0)+36>>2]&1023](g)|0;else u=vtc(f[k>>2]|0)|0;if(duc(u,utc()|0)|0){f[a>>2]=0;v=1;break}else{v=(f[a>>2]|0)==0;break}}else v=1;while(0);do if(s){g=f[s+12>>2]|0;if((g|0)==(f[s+16>>2]|0))w=_i[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else w=vtc(f[g>>2]|0)|0;if(duc(w,utc()|0)|0){f[b>>2]=0;x=0;y=1;z=0;break}else{x=r;y=(r|0)==0;z=r;break}}else{x=r;y=1;z=0}while(0);A=f[a>>2]|0;if(!((q|0)>1&(v^y)))break;g=f[A+12>>2]|0;if((g|0)==(f[A+16>>2]|0))B=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else B=vtc(f[g>>2]|0)|0;if(!(hj[f[(f[d>>2]|0)+12>>2]&511](d,2048,B)|0)){n=t;break a}g=((hj[f[(f[d>>2]|0)+52>>2]&511](d,B,0)|0)<<24>>24)+(t*10|0)|0;k=f[a>>2]|0;j=k+12|0;h=f[j>>2]|0;if((h|0)==(f[k+16>>2]|0)){_i[f[(f[k>>2]|0)+40>>2]&1023](k)|0;p=g;q=i;r=x;s=z;continue}else{f[j>>2]=h+4;vtc(f[h>>2]|0)|0;p=g;q=i;r=x;s=z;continue}}do if(A){g=f[A+12>>2]|0;if((g|0)==(f[A+16>>2]|0))C=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else C=vtc(f[g>>2]|0)|0;if(duc(C,utc()|0)|0){f[a>>2]=0;D=1;break}else{D=(f[a>>2]|0)==0;break}}else D=1;while(0);do if(x){g=f[x+12>>2]|0;if((g|0)==(f[x+16>>2]|0))E=_i[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else E=vtc(f[g>>2]|0)|0;if(!(duc(E,utc()|0)|0))if(D){n=t;break a}else break;else{f[b>>2]=0;m=60;break}}else m=60;while(0);if((m|0)==60?!D:0){n=t;break}f[c>>2]=f[c>>2]|2;n=t}while(0);return n|0}function Ryc(a){a=a|0;Wyc(a+8|0);nvc(a);return}function Syc(a){a=a|0;Wyc(a+8|0);nvc(a);YDc(a);return}function Tyc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;e=u;u=u+112|0;d=e+4|0;j=e;f[j>>2]=d+100;Uyc(a+8|0,d,j,g,h,i);i=f[j>>2]|0;j=d;d=f[c>>2]|0;while(1){if((j|0)==(i|0))break;c=b[j>>0]|0;if(!d)k=0;else{h=d+24|0;g=f[h>>2]|0;if((g|0)==(f[d+28>>2]|0)){a=f[(f[d>>2]|0)+52>>2]|0;l=dtc(c)|0;m=Mi[a&1023](d,l)|0}else{f[h>>2]=g+1;b[g>>0]=c;m=dtc(c)|0}c=buc(m,ctc()|0)|0;k=c?0:d}j=j+1|0;d=k}u=e;return d|0}function Uyc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i;b[j>>0]=37;k=j+1|0;b[k>>0]=g;l=j+2|0;b[l>>0]=h;b[j+3>>0]=0;if(h<<24>>24){b[k>>0]=h;b[l>>0]=g}g=Vyc(c,f[d>>2]|0)|0;l=c+(Qf(c|0,g|0,j|0,e|0,f[a>>2]|0)|0)|0;f[d>>2]=l;u=i;return}function Vyc(a,b){a=a|0;b=b|0;return b-a|0}function Wyc(a){a=a|0;var b=0;b=f[a>>2]|0;if((b|0)!=(Kvc()|0))Oqc(f[a>>2]|0);return}function Xyc(a){a=a|0;Wyc(a+8|0);nvc(a);return}function Yyc(a){a=a|0;Wyc(a+8|0);nvc(a);YDc(a);return}function Zyc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;d=u;u=u+416|0;c=d+8|0;i=d;f[i>>2]=c+400;_yc(a+8|0,c,i,e,g,h);h=f[i>>2]|0;i=c;c=f[b>>2]|0;while(1){if((i|0)==(h|0))break;b=f[i>>2]|0;if(!c)j=0;else{g=c+24|0;e=f[g>>2]|0;if((e|0)==(f[c+28>>2]|0)){a=f[(f[c>>2]|0)+52>>2]|0;k=vtc(b)|0;l=Mi[a&1023](c,k)|0}else{f[g>>2]=e+4;f[e>>2]=b;l=vtc(b)|0}b=duc(l,utc()|0)|0;j=b?0:c}i=i+4|0;c=j}u=d;return c|0}function _yc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+128|0;i=h+16|0;j=h+12|0;k=h;l=h+8|0;f[j>>2]=i+100;Uyc(a,i,j,d,e,g);g=k;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=i;i=$yc(b,f[c>>2]|0)|0;g=Rqc(f[a>>2]|0)|0;a=Dqc(b,l,i,k)|0;if(g|0)Rqc(g)|0;if((a|0)==-1)azc(0);else{f[c>>2]=b+(a<<2);u=h;return}}function $yc(a,b){a=a|0;b=b|0;return b-a>>2|0}function azc(a){a=a|0;tf()}function bzc(a){a=a|0;nvc(a);return}function czc(a){a=a|0;nvc(a);YDc(a);return}function dzc(a){a=a|0;return 127}function ezc(a){a=a|0;return 127}function fzc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function gzc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function hzc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function izc(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;mzc(a,1,45)|0;b[d>>0]=0;_tc(a+1|0,d);u=c;return}function jzc(a){a=a|0;return 0}function kzc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function lzc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function mzc(a,b,c){a=a|0;b=b|0;c=c|0;if(b|0)XIc(a|0,(dtc(c)|0)&255|0,b|0)|0;return a|0}function nzc(a){a=a|0;nvc(a);return}function ozc(a){a=a|0;nvc(a);YDc(a);return}function pzc(a){a=a|0;return 127}function qzc(a){a=a|0;return 127}function rzc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function szc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function tzc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function uzc(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;mzc(a,1,45)|0;b[d>>0]=0;_tc(a+1|0,d);u=c;return}function vzc(a){a=a|0;return 0}function wzc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function xzc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function yzc(a){a=a|0;nvc(a);return}function zzc(a){a=a|0;nvc(a);YDc(a);return}function Azc(a){a=a|0;return 2147483647}function Bzc(a){a=a|0;return 2147483647}function Czc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function Dzc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function Ezc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function Fzc(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+8+3>>0]=1;pxc(a,1,45)|0;f[d>>2]=0;tvc(a+4|0,d);u=c;return}function Gzc(a){a=a|0;return 0}function Hzc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function Izc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function Jzc(a){a=a|0;nvc(a);return}function Kzc(a){a=a|0;nvc(a);YDc(a);return}function Lzc(a){a=a|0;return 2147483647}function Mzc(a){a=a|0;return 2147483647}function Nzc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function Ozc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function Pzc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function Qzc(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+8+3>>0]=1;pxc(a,1,45)|0;f[d>>2]=0;tvc(a+4|0,d);u=c;return}function Rzc(a){a=a|0;return 0}function Szc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function Tzc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function Uzc(a){a=a|0;nvc(a);return}function Vzc(a){a=a|0;nvc(a);YDc(a);return}function Wzc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+240|0;j=a+24|0;k=a;l=a+140|0;m=a+16|0;n=a+12|0;o=a+8|0;p=a+136|0;q=a+4|0;r=a+36|0;f[m>>2]=l;s=m+4|0;f[s>>2]=1802;cuc(o,g);t=Hvc(o,885240)|0;b[p>>0]=0;f[q>>2]=f[d>>2];v=f[g+4>>2]|0;f[j>>2]=f[q>>2];if(Zzc(c,j,e,o,v,h,p,t,m,n,l+100|0)|0){hh[f[(f[t>>2]|0)+32>>2]&127](t,516228,516238,j)|0;t=f[n>>2]|0;l=f[m>>2]|0;v=t-l|0;e=l;l=t;if((v|0)>98){t=ooc(v+2|0)|0;if(!t)_Dc();else{w=t;x=t}}else{w=r;x=0}if(!(b[p>>0]|0))y=w;else{b[w>>0]=45;y=w+1|0}w=j+10|0;p=j;t=e;e=y;y=l;while(1){if(t>>>0>=y>>>0)break;l=b[t>>0]|0;v=j;while(1){if((v|0)==(w|0)){z=w;break}if((b[v>>0]|0)==l<<24>>24){z=v;break}v=v+1|0}b[e>>0]=b[516228+(z-p)>>0]|0;t=t+1|0;e=e+1|0;y=f[n>>2]|0}b[e>>0]=0;f[k>>2]=i;if((rqc(r,516239,k)|0)!=1)azc(0);if(x|0)poc(x)}x=f[c>>2]|0;do if(x){k=f[x+12>>2]|0;if((k|0)==(f[x+16>>2]|0))A=_i[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else A=dtc(b[k>>0]|0)|0;if(buc(A,ctc()|0)|0){f[c>>2]=0;B=1;break}else{B=(f[c>>2]|0)==0;break}}else B=1;while(0);A=f[d>>2]|0;do if(A){x=f[A+12>>2]|0;if((x|0)==(f[A+16>>2]|0))C=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else C=dtc(b[x>>0]|0)|0;if(!(buc(C,ctc()|0)|0))if(B)break;else{D=34;break}else{f[d>>2]=0;D=32;break}}else D=32;while(0);if((D|0)==32?B:0)D=34;if((D|0)==34)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;Ivc(o);o=f[m>>2]|0;f[m>>2]=0;if(o|0)Yi[f[s>>2]&2047](o);u=a;return h|0}function Xzc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+144|0;j=a+24|0;k=a+32|0;l=a+16|0;m=a+8|0;n=a;o=a+28|0;p=a+4|0;f[l>>2]=k;q=l+4|0;f[q>>2]=1802;cuc(n,g);r=Hvc(n,885240)|0;b[o>>0]=0;s=f[d>>2]|0;f[p>>2]=s;t=f[g+4>>2]|0;f[j>>2]=f[p>>2];p=s;if(Zzc(c,j,e,n,t,h,o,r,l,m,k+100|0)|0){k=i+11|0;if((b[k>>0]|0)<0){t=f[i>>2]|0;b[j>>0]=0;_tc(t,j);f[i+4>>2]=0}else{b[j>>0]=0;_tc(i,j);b[k>>0]=0}if(b[o>>0]|0)vEc(i,Mi[f[(f[r>>2]|0)+28>>2]&1023](r,45)|0);o=Mi[f[(f[r>>2]|0)+28>>2]&1023](r,48)|0;r=f[m>>2]|0;m=r+-1|0;k=f[l>>2]|0;while(1){if(k>>>0>=m>>>0)break;if((b[k>>0]|0)!=o<<24>>24)break;k=k+1|0}$7(i,k,r)|0}r=f[c>>2]|0;do if(r){k=f[r+12>>2]|0;if((k|0)==(f[r+16>>2]|0))v=_i[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else v=dtc(b[k>>0]|0)|0;if(buc(v,ctc()|0)|0){f[c>>2]=0;w=1;break}else{w=(f[c>>2]|0)==0;break}}else w=1;while(0);do if(s){v=f[p+12>>2]|0;if((v|0)==(f[p+16>>2]|0))x=_i[f[(f[s>>2]|0)+36>>2]&1023](p)|0;else x=dtc(b[v>>0]|0)|0;if(!(buc(x,ctc()|0)|0))if(w)break;else{y=27;break}else{f[d>>2]=0;y=25;break}}else y=25;while(0);if((y|0)==25?w:0)y=27;if((y|0)==27)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;Ivc(n);n=f[l>>2]|0;f[l>>2]=0;if(n|0)Yi[f[q>>2]&2047](n);u=a;return h|0}function Yzc(a){a=a|0;return}function Zzc(a,c,e,g,i,j,k,l,m,n,o){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;p=u;u=u+512|0;q=p+88|0;r=p+96|0;s=p+80|0;t=p+72|0;v=p+68|0;w=p+500|0;x=p+497|0;y=p+496|0;z=p+56|0;A=p+44|0;B=p+32|0;C=p+20|0;D=p+8|0;E=p+4|0;F=p;f[q>>2]=o;f[s>>2]=r;o=s+4|0;f[o>>2]=1802;f[t>>2]=r;f[v>>2]=r+400;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[z+(r<<2)>>2]=0;r=r+1|0}f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[A+(r<<2)>>2]=0;r=r+1|0}f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[B+(r<<2)>>2]=0;r=r+1|0}f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[C+(r<<2)>>2]=0;r=r+1|0}f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[D+(r<<2)>>2]=0;r=r+1|0}_zc(e,g,w,x,y,z,A,B,C,E);f[n>>2]=f[m>>2];g=l+8|0;l=B+11|0;e=B+4|0;r=C+11|0;G=C+4|0;H=(i&512|0)!=0;i=A+11|0;I=A+4|0;J=D+11|0;K=D+4|0;L=w+3|0;M=z+11|0;N=z+4|0;O=0;P=0;a:while(1){Q=(O|0)!=0;if(P>>>0>=4){R=234;break}S=f[a>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))U=_i[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else U=dtc(b[T>>0]|0)|0;if(buc(U,ctc()|0)|0){f[a>>2]=0;V=1;break}else{V=(f[a>>2]|0)==0;break}}else V=1;while(0);S=f[c>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))W=_i[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else W=dtc(b[T>>0]|0)|0;if(!(buc(W,ctc()|0)|0))if(V){X=S;break}else{R=234;break a}else{f[c>>2]=0;R=31;break}}else R=31;while(0);if((R|0)==31){R=0;if(V){R=234;break}else X=0}S=(P|0)!=3;b:do switch(b[w+P>>0]|0){case 1:{if(S){T=f[a>>2]|0;Y=f[T+12>>2]|0;if((Y|0)==(f[T+16>>2]|0))Z=_i[f[(f[T>>2]|0)+36>>2]&1023](T)|0;else Z=dtc(b[Y>>0]|0)|0;if((Z&255)<<24>>24<=-1){R=44;break a}if(!(d[(f[g>>2]|0)+(Z<<24>>24<<1)>>1]&8192)){R=44;break a}Y=f[a>>2]|0;T=Y+12|0;_=f[T>>2]|0;if((_|0)==(f[Y+16>>2]|0))$=_i[f[(f[Y>>2]|0)+40>>2]&1023](Y)|0;else{f[T>>2]=_+1;$=dtc(b[_>>0]|0)|0}vEc(D,$&255);aa=X;ba=X;R=46}else ca=O;break}case 0:{if(S){aa=X;ba=X;R=46}else ca=O;break}case 3:{_=b[l>>0]|0;T=_<<24>>24<0?f[e>>2]|0:_&255;_=b[r>>0]|0;Y=_<<24>>24<0?f[G>>2]|0:_&255;if((T|0)==(0-Y|0))ca=O;else{_=(T|0)==0;T=f[a>>2]|0;da=f[T+12>>2]|0;ea=(da|0)==(f[T+16>>2]|0);if(_|(Y|0)==0){if(ea)fa=_i[f[(f[T>>2]|0)+36>>2]&1023](T)|0;else fa=dtc(b[da>>0]|0)|0;Y=fa&255;if(_){if(Y<<24>>24!=(b[((b[r>>0]|0)<0?f[C>>2]|0:C)>>0]|0)){ca=O;break b}_=f[a>>2]|0;ga=_+12|0;ha=f[ga>>2]|0;if((ha|0)==(f[_+16>>2]|0))_i[f[(f[_>>2]|0)+40>>2]&1023](_)|0;else{f[ga>>2]=ha+1;dtc(b[ha>>0]|0)|0}b[k>>0]=1;ha=b[r>>0]|0;ca=(ha<<24>>24<0?f[G>>2]|0:ha&255)>>>0>1?C:O;break b}if(Y<<24>>24!=(b[((b[l>>0]|0)<0?f[B>>2]|0:B)>>0]|0)){b[k>>0]=1;ca=O;break b}Y=f[a>>2]|0;ha=Y+12|0;ga=f[ha>>2]|0;if((ga|0)==(f[Y+16>>2]|0))_i[f[(f[Y>>2]|0)+40>>2]&1023](Y)|0;else{f[ha>>2]=ga+1;dtc(b[ga>>0]|0)|0}ga=b[l>>0]|0;ca=(ga<<24>>24<0?f[e>>2]|0:ga&255)>>>0>1?B:O;break b}if(ea)ia=_i[f[(f[T>>2]|0)+36>>2]&1023](T)|0;else ia=dtc(b[da>>0]|0)|0;da=f[a>>2]|0;T=da+12|0;ea=f[T>>2]|0;ga=(ea|0)==(f[da+16>>2]|0);if((ia&255)<<24>>24==(b[((b[l>>0]|0)<0?f[B>>2]|0:B)>>0]|0)){if(ga)_i[f[(f[da>>2]|0)+40>>2]&1023](da)|0;else{f[T>>2]=ea+1;dtc(b[ea>>0]|0)|0}T=b[l>>0]|0;ca=(T<<24>>24<0?f[e>>2]|0:T&255)>>>0>1?B:O;break b}if(ga)ja=_i[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else ja=dtc(b[ea>>0]|0)|0;if((ja&255)<<24>>24!=(b[((b[r>>0]|0)<0?f[C>>2]|0:C)>>0]|0)){R=103;break a}ea=f[a>>2]|0;da=ea+12|0;ga=f[da>>2]|0;if((ga|0)==(f[ea+16>>2]|0))_i[f[(f[ea>>2]|0)+40>>2]&1023](ea)|0;else{f[da>>2]=ga+1;dtc(b[ga>>0]|0)|0}b[k>>0]=1;ga=b[r>>0]|0;ca=(ga<<24>>24<0?f[G>>2]|0:ga&255)>>>0>1?C:O}break}case 2:{if(!(P>>>0<2|Q)?!(H|(P|0)==2&(b[L>>0]|0)!=0):0){ca=0;break b}ga=b[i>>0]|0;da=ga<<24>>24<0;ea=f[A>>2]|0;T=da?ea:A;ha=T;c:do if((P|0)!=0?(h[w+(P+-1)>>0]|0)<2:0){Y=T+(da?f[I>>2]|0:ga&255)|0;_=ha;while(1){ka=_;if((ka|0)==(Y|0))break;la=b[ka>>0]|0;if(la<<24>>24<=-1)break;if(!(d[(f[g>>2]|0)+(la<<24>>24<<1)>>1]&8192))break;_=ka+1|0}Y=_-ha|0;ka=b[J>>0]|0;la=ka<<24>>24<0;ma=la?f[K>>2]|0:ka&255;if(Y>>>0<=ma>>>0){ka=(la?f[D>>2]|0:D)+ma|0;ma=T;la=ka+(0-Y)|0;while(1){if((la|0)==(ka|0)){na=X;oa=_;pa=ga;qa=ea;ra=X;break c}if((b[la>>0]|0)!=(b[ma>>0]|0)){na=X;oa=ha;pa=ga;qa=ea;ra=X;break c}ma=ma+1|0;la=la+1|0}}else{na=X;oa=ha;pa=ga;qa=ea;ra=X}}else{na=X;oa=ha;pa=ga;qa=ea;ra=X}while(0);d:while(1){ea=pa<<24>>24<0;ga=(ea?qa:A)+(ea?f[I>>2]|0:pa&255)|0;ea=oa;if((ea|0)==(ga|0)){sa=ga;break}ga=f[a>>2]|0;do if(ga){ha=f[ga+12>>2]|0;if((ha|0)==(f[ga+16>>2]|0))ta=_i[f[(f[ga>>2]|0)+36>>2]&1023](ga)|0;else ta=dtc(b[ha>>0]|0)|0;if(buc(ta,ctc()|0)|0){f[a>>2]=0;ua=1;break}else{ua=(f[a>>2]|0)==0;break}}else ua=1;while(0);do if(ra){ga=f[ra+12>>2]|0;if((ga|0)==(f[ra+16>>2]|0))va=_i[f[(f[ra>>2]|0)+36>>2]&1023](ra)|0;else va=dtc(b[ga>>0]|0)|0;if(!(buc(va,ctc()|0)|0))if(ua^(na|0)==0){wa=na;xa=na;break}else{sa=ea;break d}else{f[c>>2]=0;ya=0;R=132;break}}else{ya=na;R=132}while(0);if((R|0)==132){R=0;if(ua){sa=ea;break}else{wa=ya;xa=0}}ga=f[a>>2]|0;ha=f[ga+12>>2]|0;if((ha|0)==(f[ga+16>>2]|0))za=_i[f[(f[ga>>2]|0)+36>>2]&1023](ga)|0;else za=dtc(b[ha>>0]|0)|0;if((za&255)<<24>>24!=(b[ea>>0]|0)){sa=ea;break}ha=f[a>>2]|0;ga=ha+12|0;T=f[ga>>2]|0;if((T|0)==(f[ha+16>>2]|0))_i[f[(f[ha>>2]|0)+40>>2]&1023](ha)|0;else{f[ga>>2]=T+1;dtc(b[T>>0]|0)|0}na=wa;oa=ea+1|0;pa=b[i>>0]|0;qa=f[A>>2]|0;ra=xa}if(H?(T=b[i>>0]|0,ga=T<<24>>24<0,(sa|0)!=((ga?f[A>>2]|0:A)+(ga?f[I>>2]|0:T&255)|0)):0){R=144;break a}else ca=O;break}case 4:{T=0;ga=X;ha=X;e:while(1){da=f[a>>2]|0;do if(da){la=f[da+12>>2]|0;if((la|0)==(f[da+16>>2]|0))Aa=_i[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Aa=dtc(b[la>>0]|0)|0;if(buc(Aa,ctc()|0)|0){f[a>>2]=0;Ba=1;break}else{Ba=(f[a>>2]|0)==0;break}}else Ba=1;while(0);do if(ha){da=f[ha+12>>2]|0;if((da|0)==(f[ha+16>>2]|0))Ca=_i[f[(f[ha>>2]|0)+36>>2]&1023](ha)|0;else Ca=dtc(b[da>>0]|0)|0;if(!(buc(Ca,ctc()|0)|0))if(Ba^(ga|0)==0){Da=ga;Ea=ga;break}else{Fa=ga;break e}else{f[c>>2]=0;Ga=0;R=158;break}}else{Ga=ga;R=158}while(0);if((R|0)==158){R=0;if(Ba){Fa=Ga;break}else{Da=Ga;Ea=0}}da=f[a>>2]|0;ea=f[da+12>>2]|0;if((ea|0)==(f[da+16>>2]|0))Ha=_i[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Ha=dtc(b[ea>>0]|0)|0;ea=Ha&255;if(ea<<24>>24>-1?(d[(f[g>>2]|0)+(Ha<<24>>24<<1)>>1]&2048)!=0:0){da=f[n>>2]|0;if((da|0)==(f[q>>2]|0)){$zc(m,n,q);Ia=f[n>>2]|0}else Ia=da;f[n>>2]=Ia+1;b[Ia>>0]=ea;Ja=T+1|0}else{da=b[M>>0]|0;if(!(ea<<24>>24==(b[y>>0]|0)&(T|0?((da<<24>>24<0?f[N>>2]|0:da&255)|0)!=0:0))){Fa=Da;break}da=f[t>>2]|0;if((da|0)==(f[v>>2]|0)){aAc(s,t,v);Ka=f[t>>2]|0}else Ka=da;f[t>>2]=Ka+4;f[Ka>>2]=T;Ja=0}da=f[a>>2]|0;ea=da+12|0;la=f[ea>>2]|0;if((la|0)==(f[da+16>>2]|0)){_i[f[(f[da>>2]|0)+40>>2]&1023](da)|0;T=Ja;ga=Da;ha=Ea;continue}else{f[ea>>2]=la+1;dtc(b[la>>0]|0)|0;T=Ja;ga=Da;ha=Ea;continue}}ha=f[t>>2]|0;if(T|0?(f[s>>2]|0)!=(ha|0):0){if((ha|0)==(f[v>>2]|0)){aAc(s,t,v);La=f[t>>2]|0}else La=ha;f[t>>2]=La+4;f[La>>2]=T}f:do if((f[E>>2]|0)>0){ha=f[a>>2]|0;do if(ha){ga=f[ha+12>>2]|0;if((ga|0)==(f[ha+16>>2]|0))Ma=_i[f[(f[ha>>2]|0)+36>>2]&1023](ha)|0;else Ma=dtc(b[ga>>0]|0)|0;if(buc(Ma,ctc()|0)|0){f[a>>2]=0;Na=1;break}else{Na=(f[a>>2]|0)==0;break}}else Na=1;while(0);do if(Fa){ha=f[Fa+12>>2]|0;if((ha|0)==(f[Fa+16>>2]|0))Oa=_i[f[(f[Fa>>2]|0)+36>>2]&1023](Fa)|0;else Oa=dtc(b[ha>>0]|0)|0;if(!(buc(Oa,ctc()|0)|0))if(Na){Pa=Fa;break}else{R=232;break a}else{f[c>>2]=0;R=193;break}}else R=193;while(0);if((R|0)==193){R=0;if(Na){R=232;break a}else Pa=0}ha=f[a>>2]|0;ga=f[ha+12>>2]|0;if((ga|0)==(f[ha+16>>2]|0))Qa=_i[f[(f[ha>>2]|0)+36>>2]&1023](ha)|0;else Qa=dtc(b[ga>>0]|0)|0;if((Qa&255)<<24>>24!=(b[x>>0]|0)){R=232;break a}ga=f[a>>2]|0;ha=ga+12|0;la=f[ha>>2]|0;if((la|0)==(f[ga+16>>2]|0)){_i[f[(f[ga>>2]|0)+40>>2]&1023](ga)|0;Ra=Pa;Sa=Pa}else{f[ha>>2]=la+1;dtc(b[la>>0]|0)|0;Ra=Pa;Sa=Pa}while(1){if((f[E>>2]|0)<=0)break f;la=f[a>>2]|0;do if(la){ha=f[la+12>>2]|0;if((ha|0)==(f[la+16>>2]|0))Ta=_i[f[(f[la>>2]|0)+36>>2]&1023](la)|0;else Ta=dtc(b[ha>>0]|0)|0;if(buc(Ta,ctc()|0)|0){f[a>>2]=0;Ua=1;break}else{Ua=(f[a>>2]|0)==0;break}}else Ua=1;while(0);do if(Sa){la=f[Sa+12>>2]|0;if((la|0)==(f[Sa+16>>2]|0))Va=_i[f[(f[Sa>>2]|0)+36>>2]&1023](Sa)|0;else Va=dtc(b[la>>0]|0)|0;if(!(buc(Va,ctc()|0)|0))if(Ua^(Ra|0)==0){Wa=Ra;Xa=Ra;break}else{R=232;break a}else{f[c>>2]=0;Ya=0;R=216;break}}else{Ya=Ra;R=216}while(0);if((R|0)==216){R=0;if(Ua){R=232;break a}else{Wa=Ya;Xa=0}}la=f[a>>2]|0;ha=f[la+12>>2]|0;if((ha|0)==(f[la+16>>2]|0))Za=_i[f[(f[la>>2]|0)+36>>2]&1023](la)|0;else Za=dtc(b[ha>>0]|0)|0;if((Za&255)<<24>>24<=-1){R=232;break a}if(!(d[(f[g>>2]|0)+(Za<<24>>24<<1)>>1]&2048)){R=232;break a}if((f[n>>2]|0)==(f[q>>2]|0))$zc(m,n,q);ha=f[a>>2]|0;la=f[ha+12>>2]|0;if((la|0)==(f[ha+16>>2]|0))_a=_i[f[(f[ha>>2]|0)+36>>2]&1023](ha)|0;else _a=dtc(b[la>>0]|0)|0;la=f[n>>2]|0;f[n>>2]=la+1;b[la>>0]=_a;f[E>>2]=(f[E>>2]|0)+-1;la=f[a>>2]|0;ha=la+12|0;ga=f[ha>>2]|0;if((ga|0)==(f[la+16>>2]|0)){_i[f[(f[la>>2]|0)+40>>2]&1023](la)|0;Ra=Wa;Sa=Xa;continue}else{f[ha>>2]=ga+1;dtc(b[ga>>0]|0)|0;Ra=Wa;Sa=Xa;continue}}}while(0);if((f[n>>2]|0)==(f[m>>2]|0)){R=232;break a}else ca=O;break}default:ca=O}while(0);g:do if((R|0)==46)while(1){R=0;S=f[a>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))$a=_i[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else $a=dtc(b[T>>0]|0)|0;if(buc($a,ctc()|0)|0){f[a>>2]=0;ab=1;break}else{ab=(f[a>>2]|0)==0;break}}else ab=1;while(0);do if(ba){S=f[ba+12>>2]|0;if((S|0)==(f[ba+16>>2]|0))bb=_i[f[(f[ba>>2]|0)+36>>2]&1023](ba)|0;else bb=dtc(b[S>>0]|0)|0;if(!(buc(bb,ctc()|0)|0))if(ab^(aa|0)==0){cb=aa;db=aa;break}else{ca=O;break g}else{f[c>>2]=0;eb=0;R=59;break}}else{eb=aa;R=59}while(0);if((R|0)==59){R=0;if(ab){ca=O;break g}else{cb=eb;db=0}}S=f[a>>2]|0;T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))fb=_i[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else fb=dtc(b[T>>0]|0)|0;if((fb&255)<<24>>24<=-1){ca=O;break g}if(!(d[(f[g>>2]|0)+(fb<<24>>24<<1)>>1]&8192)){ca=O;break g}T=f[a>>2]|0;S=T+12|0;ga=f[S>>2]|0;if((ga|0)==(f[T+16>>2]|0))gb=_i[f[(f[T>>2]|0)+40>>2]&1023](T)|0;else{f[S>>2]=ga+1;gb=dtc(b[ga>>0]|0)|0}vEc(D,gb&255);aa=cb;ba=db;R=46}while(0);O=ca;P=P+1|0}h:do if((R|0)==44){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==103){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==144){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==232){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==234){i:do if(Q){P=O+11|0;ca=O+4|0;db=1;j:while(1){ba=b[P>>0]|0;if(ba<<24>>24<0)ib=f[ca>>2]|0;else ib=ba&255;if(db>>>0>=ib>>>0)break i;ba=f[a>>2]|0;do if(ba){cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))jb=_i[f[(f[ba>>2]|0)+36>>2]&1023](ba)|0;else jb=dtc(b[cb>>0]|0)|0;if(buc(jb,ctc()|0)|0){f[a>>2]=0;kb=1;break}else{kb=(f[a>>2]|0)==0;break}}else kb=1;while(0);ba=f[c>>2]|0;do if(ba){cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))lb=_i[f[(f[ba>>2]|0)+36>>2]&1023](ba)|0;else lb=dtc(b[cb>>0]|0)|0;if(!(buc(lb,ctc()|0)|0))if(kb)break;else break j;else{f[c>>2]=0;R=253;break}}else R=253;while(0);if((R|0)==253?(R=0,kb):0)break;ba=f[a>>2]|0;cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))mb=_i[f[(f[ba>>2]|0)+36>>2]&1023](ba)|0;else mb=dtc(b[cb>>0]|0)|0;if((b[P>>0]|0)<0)nb=f[O>>2]|0;else nb=O;if((mb&255)<<24>>24!=(b[nb+db>>0]|0))break;cb=db+1|0;ba=f[a>>2]|0;aa=ba+12|0;gb=f[aa>>2]|0;if((gb|0)==(f[ba+16>>2]|0)){_i[f[(f[ba>>2]|0)+40>>2]&1023](ba)|0;db=cb;continue}else{f[aa>>2]=gb+1;dtc(b[gb>>0]|0)|0;db=cb;continue}}f[j>>2]=f[j>>2]|4;hb=0;break h}while(0);db=f[s>>2]|0;P=f[t>>2]|0;if((db|0)!=(P|0)){f[F>>2]=0;Wvc(z,db,P,F);if(!(f[F>>2]|0)){hb=1;break}else{f[j>>2]=f[j>>2]|4;hb=0;break}}else hb=1}while(0);hEc(D);hEc(C);hEc(B);hEc(A);hEc(z);z=f[s>>2]|0;f[s>>2]=0;if(z|0)Yi[f[o>>2]&2047](z);u=p;return hb|0}function _zc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=Hvc(c,886960)|0;mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[d>>0]=p;b[d+1>>0]=p>>8;b[d+2>>0]=p>>16;b[d+3>>0]=p>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+11|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;b[n>>0]=0;_tc(q,n);f[k+4>>2]=0;r=k}else{b[n>>0]=0;_tc(k,n);b[p>>0]=0;r=k}mEc(k,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}hEc(o);mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);r=j+11|0;if((b[r>>0]|0)<0){p=f[j>>2]|0;b[n>>0]=0;_tc(p,n);f[j+4>>2]=0;s=j}else{b[n>>0]=0;_tc(j,n);b[r>>0]=0;s=j}mEc(j,0);f[s>>2]=f[o>>2];f[s+4>>2]=f[o+4>>2];f[s+8>>2]=f[o+8>>2];s=0;while(1){if((s|0)==3)break;f[o+(s<<2)>>2]=0;s=s+1|0}hEc(o);s=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;b[e>>0]=s;s=_i[f[(f[a>>2]|0)+16>>2]&1023](a)|0;b[g>>0]=s;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);s=h+11|0;if((b[s>>0]|0)<0){r=f[h>>2]|0;b[n>>0]=0;_tc(r,n);f[h+4>>2]=0;t=h}else{b[n>>0]=0;_tc(h,n);b[s>>0]=0;t=h}mEc(h,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}hEc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=i+11|0;if((b[t>>0]|0)<0){s=f[i>>2]|0;b[n>>0]=0;_tc(s,n);f[i+4>>2]=0;v=i}else{b[n>>0]=0;_tc(i,n);b[t>>0]=0;v=i}mEc(i,0);f[v>>2]=f[o>>2];f[v+4>>2]=f[o+4>>2];f[v+8>>2]=f[o+8>>2];v=0;while(1){if((v|0)==3)break;f[o+(v<<2)>>2]=0;v=v+1|0}hEc(o);w=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0}else{a=Hvc(c,886952)|0;mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[d>>0]=c;b[d+1>>0]=c>>8;b[d+2>>0]=c>>16;b[d+3>>0]=c>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+11|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;b[n>>0]=0;_tc(d,n);f[k+4>>2]=0;x=k}else{b[n>>0]=0;_tc(k,n);b[c>>0]=0;x=k}mEc(k,0);f[x>>2]=f[o>>2];f[x+4>>2]=f[o+4>>2];f[x+8>>2]=f[o+8>>2];x=0;while(1){if((x|0)==3)break;f[o+(x<<2)>>2]=0;x=x+1|0}hEc(o);mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);x=j+11|0;if((b[x>>0]|0)<0){k=f[j>>2]|0;b[n>>0]=0;_tc(k,n);f[j+4>>2]=0;y=j}else{b[n>>0]=0;_tc(j,n);b[x>>0]=0;y=j}mEc(j,0);f[y>>2]=f[o>>2];f[y+4>>2]=f[o+4>>2];f[y+8>>2]=f[o+8>>2];y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}hEc(o);y=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;b[e>>0]=y;y=_i[f[(f[a>>2]|0)+16>>2]&1023](a)|0;b[g>>0]=y;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);y=h+11|0;if((b[y>>0]|0)<0){g=f[h>>2]|0;b[n>>0]=0;_tc(g,n);f[h+4>>2]=0;z=h}else{b[n>>0]=0;_tc(h,n);b[y>>0]=0;z=h}mEc(h,0);f[z>>2]=f[o>>2];f[z+4>>2]=f[o+4>>2];f[z+8>>2]=f[o+8>>2];z=0;while(1){if((z|0)==3)break;f[o+(z<<2)>>2]=0;z=z+1|0}hEc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);z=i+11|0;if((b[z>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;_tc(h,n);f[i+4>>2]=0;A=i}else{b[n>>0]=0;_tc(i,n);b[z>>0]=0;A=i}mEc(i,0);f[A>>2]=f[o>>2];f[A+4>>2]=f[o+4>>2];f[A+8>>2]=f[o+8>>2];A=0;while(1){if((A|0)==3)break;f[o+(A<<2)>>2]=0;A=A+1|0}hEc(o);w=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0}f[l>>2]=w;u=m;return}function $zc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1802;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?1:i;i=(f[b>>2]|0)-g|0;j=qoc(e?g:0,h)|0;if(!j)_Dc();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{Yi[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1803;f[b>>2]=k+i;f[c>>2]=(f[a>>2]|0)+h;return}function aAc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1802;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?4:i;i=(f[b>>2]|0)-g>>2;j=qoc(e?g:0,h)|0;if(!j)_Dc();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{Yi[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1803;f[b>>2]=k+(i<<2);f[c>>2]=(f[a>>2]|0)+(h>>>2<<2);return}function bAc(a){a=a|0;nvc(a);return}function cAc(a){a=a|0;nvc(a);YDc(a);return}function dAc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+576|0;j=a+424|0;k=a;l=a+24|0;m=a+16|0;n=a+12|0;o=a+8|0;p=a+564|0;q=a+4|0;r=a+464|0;f[m>>2]=l;s=m+4|0;f[s>>2]=1802;cuc(o,g);t=Hvc(o,885272)|0;b[p>>0]=0;f[q>>2]=f[d>>2];v=f[g+4>>2]|0;f[j>>2]=f[q>>2];if(fAc(c,j,e,o,v,h,p,t,m,n,l+400|0)|0){hh[f[(f[t>>2]|0)+48>>2]&127](t,516338,516348,j)|0;t=f[n>>2]|0;l=f[m>>2]|0;v=t-l|0;e=l;l=t;if((v|0)>392){t=ooc((v>>>2)+2|0)|0;if(!t)_Dc();else{w=t;x=t}}else{w=r;x=0}if(!(b[p>>0]|0))y=w;else{b[w>>0]=45;y=w+1|0}w=j+40|0;p=j;t=e;e=y;y=l;while(1){if(t>>>0>=y>>>0)break;l=f[t>>2]|0;v=j;while(1){if((v|0)==(w|0)){z=w;break}if((f[v>>2]|0)==(l|0)){z=v;break}v=v+4|0}b[e>>0]=b[516338+(z-p>>2)>>0]|0;t=t+4|0;e=e+1|0;y=f[n>>2]|0}b[e>>0]=0;f[k>>2]=i;if((rqc(r,516239,k)|0)!=1)azc(0);if(x|0)poc(x)}x=f[c>>2]|0;do if(x){k=f[x+12>>2]|0;if((k|0)==(f[x+16>>2]|0))A=_i[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else A=vtc(f[k>>2]|0)|0;if(duc(A,utc()|0)|0){f[c>>2]=0;B=1;break}else{B=(f[c>>2]|0)==0;break}}else B=1;while(0);A=f[d>>2]|0;do if(A){x=f[A+12>>2]|0;if((x|0)==(f[A+16>>2]|0))C=_i[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else C=vtc(f[x>>2]|0)|0;if(!(duc(C,utc()|0)|0))if(B)break;else{D=34;break}else{f[d>>2]=0;D=32;break}}else D=32;while(0);if((D|0)==32?B:0)D=34;if((D|0)==34)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;Ivc(o);o=f[m>>2]|0;f[m>>2]=0;if(o|0)Yi[f[s>>2]&2047](o);u=a;return h|0}function eAc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+432|0;j=a+424|0;k=a+24|0;l=a+16|0;m=a+8|0;n=a;o=a+428|0;p=a+4|0;f[l>>2]=k;q=l+4|0;f[q>>2]=1802;cuc(n,g);r=Hvc(n,885272)|0;b[o>>0]=0;s=f[d>>2]|0;f[p>>2]=s;t=f[g+4>>2]|0;f[j>>2]=f[p>>2];p=s;if(fAc(c,j,e,n,t,h,o,r,l,m,k+400|0)|0){k=i+8+3|0;if((b[k>>0]|0)<0){t=f[i>>2]|0;f[j>>2]=0;tvc(t,j);f[i+4>>2]=0}else{f[j>>2]=0;tvc(i,j);b[k>>0]=0}if(b[o>>0]|0)NEc(i,Mi[f[(f[r>>2]|0)+44>>2]&1023](r,45)|0);o=Mi[f[(f[r>>2]|0)+44>>2]&1023](r,48)|0;r=f[m>>2]|0;m=r+-4|0;k=f[l>>2]|0;while(1){if(k>>>0>=m>>>0)break;if((f[k>>2]|0)!=(o|0))break;k=k+4|0}gAc(i,k,r)|0}r=f[c>>2]|0;do if(r){k=f[r+12>>2]|0;if((k|0)==(f[r+16>>2]|0))v=_i[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else v=vtc(f[k>>2]|0)|0;if(duc(v,utc()|0)|0){f[c>>2]=0;w=1;break}else{w=(f[c>>2]|0)==0;break}}else w=1;while(0);do if(s){v=f[p+12>>2]|0;if((v|0)==(f[p+16>>2]|0))x=_i[f[(f[s>>2]|0)+36>>2]&1023](p)|0;else x=vtc(f[v>>2]|0)|0;if(!(duc(x,utc()|0)|0))if(w)break;else{y=27;break}else{f[d>>2]=0;y=25;break}}else y=25;while(0);if((y|0)==25?w:0)y=27;if((y|0)==27)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;Ivc(n);n=f[l>>2]|0;f[l>>2]=0;if(n|0)Yi[f[q>>2]&2047](n);u=a;return h|0}function fAc(a,c,d,e,g,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0;o=u;u=u+512|0;p=o+96|0;q=o+104|0;r=o+88|0;s=o+80|0;t=o+76|0;v=o+504|0;w=o+72|0;x=o+68|0;y=o+56|0;z=o+44|0;A=o+32|0;B=o+20|0;C=o+8|0;D=o+4|0;E=o;f[p>>2]=n;f[r>>2]=q;n=r+4|0;f[n>>2]=1802;f[s>>2]=q;f[t>>2]=q+400;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[y+(q<<2)>>2]=0;q=q+1|0}f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[z+(q<<2)>>2]=0;q=q+1|0}f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[A+(q<<2)>>2]=0;q=q+1|0}f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[B+(q<<2)>>2]=0;q=q+1|0}f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[C+(q<<2)>>2]=0;q=q+1|0}iAc(d,e,v,w,x,y,z,A,B,D);f[m>>2]=f[l>>2];e=A+8+3|0;d=A+4|0;q=B+8+3|0;F=B+4|0;G=(g&512|0)!=0;g=z+8+3|0;H=z+4|0;I=C+8+3|0;J=C+4|0;K=v+3|0;L=y+11|0;M=y+4|0;N=0;O=0;a:while(1){P=(N|0)!=0;if(O>>>0>=4){Q=229;break}R=f[a>>2]|0;do if(R){S=f[R+12>>2]|0;if((S|0)==(f[R+16>>2]|0))T=_i[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else T=vtc(f[S>>2]|0)|0;if(duc(T,utc()|0)|0){f[a>>2]=0;U=1;break}else{U=(f[a>>2]|0)==0;break}}else U=1;while(0);R=f[c>>2]|0;do if(R){S=f[R+12>>2]|0;if((S|0)==(f[R+16>>2]|0))V=_i[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else V=vtc(f[S>>2]|0)|0;if(!(duc(V,utc()|0)|0))if(U){W=R;break}else{Q=229;break a}else{f[c>>2]=0;Q=31;break}}else Q=31;while(0);if((Q|0)==31){Q=0;if(U){Q=229;break}else W=0}R=(O|0)!=3;b:do switch(b[v+O>>0]|0){case 1:{if(R){S=f[a>>2]|0;X=f[S+12>>2]|0;if((X|0)==(f[S+16>>2]|0))Y=_i[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else Y=vtc(f[X>>2]|0)|0;if(!(hj[f[(f[k>>2]|0)+12>>2]&511](k,8192,Y)|0)){Q=43;break a}X=f[a>>2]|0;S=X+12|0;Z=f[S>>2]|0;if((Z|0)==(f[X+16>>2]|0))_=_i[f[(f[X>>2]|0)+40>>2]&1023](X)|0;else{f[S>>2]=Z+4;_=vtc(f[Z>>2]|0)|0}NEc(C,_);$=W;aa=W;Q=45}else ba=N;break}case 0:{if(R){$=W;aa=W;Q=45}else ba=N;break}case 3:{Z=b[e>>0]|0;S=Z<<24>>24<0?f[d>>2]|0:Z&255;Z=b[q>>0]|0;X=Z<<24>>24<0?f[F>>2]|0:Z&255;if((S|0)==(0-X|0))ba=N;else{Z=(S|0)==0;S=f[a>>2]|0;ca=f[S+12>>2]|0;da=(ca|0)==(f[S+16>>2]|0);if(Z|(X|0)==0){if(da)ea=_i[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else ea=vtc(f[ca>>2]|0)|0;if(Z){if((ea|0)!=(f[((b[q>>0]|0)<0?f[B>>2]|0:B)>>2]|0)){ba=N;break b}Z=f[a>>2]|0;X=Z+12|0;fa=f[X>>2]|0;if((fa|0)==(f[Z+16>>2]|0))_i[f[(f[Z>>2]|0)+40>>2]&1023](Z)|0;else{f[X>>2]=fa+4;vtc(f[fa>>2]|0)|0}b[j>>0]=1;fa=b[q>>0]|0;ba=(fa<<24>>24<0?f[F>>2]|0:fa&255)>>>0>1?B:N;break b}if((ea|0)!=(f[((b[e>>0]|0)<0?f[A>>2]|0:A)>>2]|0)){b[j>>0]=1;ba=N;break b}fa=f[a>>2]|0;X=fa+12|0;Z=f[X>>2]|0;if((Z|0)==(f[fa+16>>2]|0))_i[f[(f[fa>>2]|0)+40>>2]&1023](fa)|0;else{f[X>>2]=Z+4;vtc(f[Z>>2]|0)|0}Z=b[e>>0]|0;ba=(Z<<24>>24<0?f[d>>2]|0:Z&255)>>>0>1?A:N;break b}if(da)ga=_i[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else ga=vtc(f[ca>>2]|0)|0;ca=f[a>>2]|0;S=ca+12|0;da=f[S>>2]|0;Z=(da|0)==(f[ca+16>>2]|0);if((ga|0)==(f[((b[e>>0]|0)<0?f[A>>2]|0:A)>>2]|0)){if(Z)_i[f[(f[ca>>2]|0)+40>>2]&1023](ca)|0;else{f[S>>2]=da+4;vtc(f[da>>2]|0)|0}S=b[e>>0]|0;ba=(S<<24>>24<0?f[d>>2]|0:S&255)>>>0>1?A:N;break b}if(Z)ha=_i[f[(f[ca>>2]|0)+36>>2]&1023](ca)|0;else ha=vtc(f[da>>2]|0)|0;if((ha|0)!=(f[((b[q>>0]|0)<0?f[B>>2]|0:B)>>2]|0)){Q=101;break a}da=f[a>>2]|0;ca=da+12|0;Z=f[ca>>2]|0;if((Z|0)==(f[da+16>>2]|0))_i[f[(f[da>>2]|0)+40>>2]&1023](da)|0;else{f[ca>>2]=Z+4;vtc(f[Z>>2]|0)|0}b[j>>0]=1;Z=b[q>>0]|0;ba=(Z<<24>>24<0?f[F>>2]|0:Z&255)>>>0>1?B:N}break}case 2:{if(!(O>>>0<2|P)?!(G|(O|0)==2&(b[K>>0]|0)!=0):0){ba=0;break b}Z=b[g>>0]|0;ca=f[z>>2]|0;da=Z<<24>>24<0?ca:z;c:do if((O|0)!=0?(h[v+(O+-1)>>0]|0)<2:0){S=da;X=Z;fa=ca;while(1){ia=X<<24>>24<0;ja=S;if((ja|0)==((ia?fa:z)+((ia?f[H>>2]|0:X&255)<<2)|0)){ka=X;la=fa;break}if(!(hj[f[(f[k>>2]|0)+12>>2]&511](k,8192,f[ja>>2]|0)|0)){Q=108;break}S=ja+4|0;X=b[g>>0]|0;fa=f[z>>2]|0}if((Q|0)==108){Q=0;ka=b[g>>0]|0;la=f[z>>2]|0}fa=ka<<24>>24<0?la:z;X=fa;ja=S-X>>2;ia=b[I>>0]|0;ma=ia<<24>>24<0;na=ma?f[J>>2]|0:ia&255;if(ja>>>0>na>>>0){oa=W;pa=X;qa=ka;ra=la;sa=W}else{ia=(ma?f[C>>2]|0:C)+(na<<2)|0;na=fa;fa=ia+(0-ja<<2)|0;while(1){if((fa|0)==(ia|0)){oa=W;pa=S;qa=ka;ra=la;sa=W;break c}if((f[fa>>2]|0)!=(f[na>>2]|0)){oa=W;pa=X;qa=ka;ra=la;sa=W;break c}na=na+4|0;fa=fa+4|0}}}else{oa=W;pa=da;qa=Z;ra=ca;sa=W}while(0);d:while(1){ca=qa<<24>>24<0;Z=(ca?ra:z)+((ca?f[H>>2]|0:qa&255)<<2)|0;ca=pa;if((ca|0)==(Z|0)){ta=Z;break}Z=f[a>>2]|0;do if(Z){da=f[Z+12>>2]|0;if((da|0)==(f[Z+16>>2]|0))ua=_i[f[(f[Z>>2]|0)+36>>2]&1023](Z)|0;else ua=vtc(f[da>>2]|0)|0;if(duc(ua,utc()|0)|0){f[a>>2]=0;va=1;break}else{va=(f[a>>2]|0)==0;break}}else va=1;while(0);do if(sa){Z=f[sa+12>>2]|0;if((Z|0)==(f[sa+16>>2]|0))wa=_i[f[(f[sa>>2]|0)+36>>2]&1023](sa)|0;else wa=vtc(f[Z>>2]|0)|0;if(!(duc(wa,utc()|0)|0))if(va^(oa|0)==0){xa=oa;ya=oa;break}else{ta=ca;break d}else{f[c>>2]=0;za=0;Q=129;break}}else{za=oa;Q=129}while(0);if((Q|0)==129){Q=0;if(va){ta=ca;break}else{xa=za;ya=0}}Z=f[a>>2]|0;da=f[Z+12>>2]|0;if((da|0)==(f[Z+16>>2]|0))Aa=_i[f[(f[Z>>2]|0)+36>>2]&1023](Z)|0;else Aa=vtc(f[da>>2]|0)|0;if((Aa|0)!=(f[ca>>2]|0)){ta=ca;break}da=f[a>>2]|0;Z=da+12|0;fa=f[Z>>2]|0;if((fa|0)==(f[da+16>>2]|0))_i[f[(f[da>>2]|0)+40>>2]&1023](da)|0;else{f[Z>>2]=fa+4;vtc(f[fa>>2]|0)|0}oa=xa;pa=ca+4|0;qa=b[g>>0]|0;ra=f[z>>2]|0;sa=ya}if(G?(fa=b[g>>0]|0,Z=fa<<24>>24<0,(ta|0)!=((Z?f[z>>2]|0:z)+((Z?f[H>>2]|0:fa&255)<<2)|0)):0){Q=141;break a}else ba=N;break}case 4:{fa=0;Z=W;da=W;e:while(1){na=f[a>>2]|0;do if(na){X=f[na+12>>2]|0;if((X|0)==(f[na+16>>2]|0))Ba=_i[f[(f[na>>2]|0)+36>>2]&1023](na)|0;else Ba=vtc(f[X>>2]|0)|0;if(duc(Ba,utc()|0)|0){f[a>>2]=0;Ca=1;break}else{Ca=(f[a>>2]|0)==0;break}}else Ca=1;while(0);do if(da){na=f[da+12>>2]|0;if((na|0)==(f[da+16>>2]|0))Da=_i[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Da=vtc(f[na>>2]|0)|0;if(!(duc(Da,utc()|0)|0))if(Ca^(Z|0)==0){Ea=Z;Fa=Z;break}else{Ga=Z;break e}else{f[c>>2]=0;Ha=0;Q=155;break}}else{Ha=Z;Q=155}while(0);if((Q|0)==155){Q=0;if(Ca){Ga=Ha;break}else{Ea=Ha;Fa=0}}na=f[a>>2]|0;ca=f[na+12>>2]|0;if((ca|0)==(f[na+16>>2]|0))Ia=_i[f[(f[na>>2]|0)+36>>2]&1023](na)|0;else Ia=vtc(f[ca>>2]|0)|0;if(hj[f[(f[k>>2]|0)+12>>2]&511](k,2048,Ia)|0){ca=f[m>>2]|0;if((ca|0)==(f[p>>2]|0)){jAc(l,m,p);Ja=f[m>>2]|0}else Ja=ca;f[m>>2]=Ja+4;f[Ja>>2]=Ia;Ka=fa+1|0}else{ca=b[L>>0]|0;if(!((Ia|0)==(f[x>>2]|0)&(fa|0?((ca<<24>>24<0?f[M>>2]|0:ca&255)|0)!=0:0))){Ga=Ea;break}ca=f[s>>2]|0;if((ca|0)==(f[t>>2]|0)){aAc(r,s,t);La=f[s>>2]|0}else La=ca;f[s>>2]=La+4;f[La>>2]=fa;Ka=0}ca=f[a>>2]|0;na=ca+12|0;X=f[na>>2]|0;if((X|0)==(f[ca+16>>2]|0)){_i[f[(f[ca>>2]|0)+40>>2]&1023](ca)|0;fa=Ka;Z=Ea;da=Fa;continue}else{f[na>>2]=X+4;vtc(f[X>>2]|0)|0;fa=Ka;Z=Ea;da=Fa;continue}}da=f[s>>2]|0;if(fa|0?(f[r>>2]|0)!=(da|0):0){if((da|0)==(f[t>>2]|0)){aAc(r,s,t);Ma=f[s>>2]|0}else Ma=da;f[s>>2]=Ma+4;f[Ma>>2]=fa}f:do if((f[D>>2]|0)>0){da=f[a>>2]|0;do if(da){Z=f[da+12>>2]|0;if((Z|0)==(f[da+16>>2]|0))Na=_i[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Na=vtc(f[Z>>2]|0)|0;if(duc(Na,utc()|0)|0){f[a>>2]=0;Oa=1;break}else{Oa=(f[a>>2]|0)==0;break}}else Oa=1;while(0);do if(Ga){da=f[Ga+12>>2]|0;if((da|0)==(f[Ga+16>>2]|0))Pa=_i[f[(f[Ga>>2]|0)+36>>2]&1023](Ga)|0;else Pa=vtc(f[da>>2]|0)|0;if(!(duc(Pa,utc()|0)|0))if(Oa){Qa=Ga;break}else{Q=227;break a}else{f[c>>2]=0;Q=189;break}}else Q=189;while(0);if((Q|0)==189){Q=0;if(Oa){Q=227;break a}else Qa=0}da=f[a>>2]|0;Z=f[da+12>>2]|0;if((Z|0)==(f[da+16>>2]|0))Ra=_i[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Ra=vtc(f[Z>>2]|0)|0;if((Ra|0)!=(f[w>>2]|0)){Q=227;break a}Z=f[a>>2]|0;da=Z+12|0;X=f[da>>2]|0;if((X|0)==(f[Z+16>>2]|0)){_i[f[(f[Z>>2]|0)+40>>2]&1023](Z)|0;Sa=Qa;Ta=Qa}else{f[da>>2]=X+4;vtc(f[X>>2]|0)|0;Sa=Qa;Ta=Qa}while(1){if((f[D>>2]|0)<=0)break f;X=f[a>>2]|0;do if(X){da=f[X+12>>2]|0;if((da|0)==(f[X+16>>2]|0))Ua=_i[f[(f[X>>2]|0)+36>>2]&1023](X)|0;else Ua=vtc(f[da>>2]|0)|0;if(duc(Ua,utc()|0)|0){f[a>>2]=0;Va=1;break}else{Va=(f[a>>2]|0)==0;break}}else Va=1;while(0);do if(Ta){X=f[Ta+12>>2]|0;if((X|0)==(f[Ta+16>>2]|0))Wa=_i[f[(f[Ta>>2]|0)+36>>2]&1023](Ta)|0;else Wa=vtc(f[X>>2]|0)|0;if(!(duc(Wa,utc()|0)|0))if(Va^(Sa|0)==0){Xa=Sa;Ya=Sa;break}else{Q=227;break a}else{f[c>>2]=0;Za=0;Q=212;break}}else{Za=Sa;Q=212}while(0);if((Q|0)==212){Q=0;if(Va){Q=227;break a}else{Xa=Za;Ya=0}}X=f[a>>2]|0;da=f[X+12>>2]|0;if((da|0)==(f[X+16>>2]|0))_a=_i[f[(f[X>>2]|0)+36>>2]&1023](X)|0;else _a=vtc(f[da>>2]|0)|0;if(!(hj[f[(f[k>>2]|0)+12>>2]&511](k,2048,_a)|0)){Q=227;break a}if((f[m>>2]|0)==(f[p>>2]|0))jAc(l,m,p);da=f[a>>2]|0;X=f[da+12>>2]|0;if((X|0)==(f[da+16>>2]|0))$a=_i[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else $a=vtc(f[X>>2]|0)|0;X=f[m>>2]|0;f[m>>2]=X+4;f[X>>2]=$a;f[D>>2]=(f[D>>2]|0)+-1;X=f[a>>2]|0;da=X+12|0;Z=f[da>>2]|0;if((Z|0)==(f[X+16>>2]|0)){_i[f[(f[X>>2]|0)+40>>2]&1023](X)|0;Sa=Xa;Ta=Ya;continue}else{f[da>>2]=Z+4;vtc(f[Z>>2]|0)|0;Sa=Xa;Ta=Ya;continue}}}while(0);if((f[m>>2]|0)==(f[l>>2]|0)){Q=227;break a}else ba=N;break}default:ba=N}while(0);g:do if((Q|0)==45)while(1){Q=0;R=f[a>>2]|0;do if(R){fa=f[R+12>>2]|0;if((fa|0)==(f[R+16>>2]|0))ab=_i[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else ab=vtc(f[fa>>2]|0)|0;if(duc(ab,utc()|0)|0){f[a>>2]=0;bb=1;break}else{bb=(f[a>>2]|0)==0;break}}else bb=1;while(0);do if(aa){R=f[aa+12>>2]|0;if((R|0)==(f[aa+16>>2]|0))cb=_i[f[(f[aa>>2]|0)+36>>2]&1023](aa)|0;else cb=vtc(f[R>>2]|0)|0;if(!(duc(cb,utc()|0)|0))if(bb^($|0)==0){db=$;eb=$;break}else{ba=N;break g}else{f[c>>2]=0;fb=0;Q=58;break}}else{fb=$;Q=58}while(0);if((Q|0)==58){Q=0;if(bb){ba=N;break g}else{db=fb;eb=0}}R=f[a>>2]|0;fa=f[R+12>>2]|0;if((fa|0)==(f[R+16>>2]|0))gb=_i[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else gb=vtc(f[fa>>2]|0)|0;if(!(hj[f[(f[k>>2]|0)+12>>2]&511](k,8192,gb)|0)){ba=N;break g}fa=f[a>>2]|0;R=fa+12|0;Z=f[R>>2]|0;if((Z|0)==(f[fa+16>>2]|0))hb=_i[f[(f[fa>>2]|0)+40>>2]&1023](fa)|0;else{f[R>>2]=Z+4;hb=vtc(f[Z>>2]|0)|0}NEc(C,hb);$=db;aa=eb;Q=45}while(0);N=ba;O=O+1|0}h:do if((Q|0)==43){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==101){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==141){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==227){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==229){i:do if(P){O=N+8+3|0;ba=N+4|0;eb=1;j:while(1){aa=b[O>>0]|0;if(aa<<24>>24<0)jb=f[ba>>2]|0;else jb=aa&255;if(eb>>>0>=jb>>>0)break i;aa=f[a>>2]|0;do if(aa){db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))kb=_i[f[(f[aa>>2]|0)+36>>2]&1023](aa)|0;else kb=vtc(f[db>>2]|0)|0;if(duc(kb,utc()|0)|0){f[a>>2]=0;lb=1;break}else{lb=(f[a>>2]|0)==0;break}}else lb=1;while(0);aa=f[c>>2]|0;do if(aa){db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))mb=_i[f[(f[aa>>2]|0)+36>>2]&1023](aa)|0;else mb=vtc(f[db>>2]|0)|0;if(!(duc(mb,utc()|0)|0))if(lb)break;else break j;else{f[c>>2]=0;Q=248;break}}else Q=248;while(0);if((Q|0)==248?(Q=0,lb):0)break;aa=f[a>>2]|0;db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))nb=_i[f[(f[aa>>2]|0)+36>>2]&1023](aa)|0;else nb=vtc(f[db>>2]|0)|0;if((b[O>>0]|0)<0)ob=f[N>>2]|0;else ob=N;if((nb|0)!=(f[ob+(eb<<2)>>2]|0))break;db=eb+1|0;aa=f[a>>2]|0;$=aa+12|0;hb=f[$>>2]|0;if((hb|0)==(f[aa+16>>2]|0)){_i[f[(f[aa>>2]|0)+40>>2]&1023](aa)|0;eb=db;continue}else{f[$>>2]=hb+4;vtc(f[hb>>2]|0)|0;eb=db;continue}}f[i>>2]=f[i>>2]|4;ib=0;break h}while(0);eb=f[r>>2]|0;O=f[s>>2]|0;if((eb|0)!=(O|0)){f[E>>2]=0;Wvc(y,eb,O,E);if(!(f[E>>2]|0)){ib=1;break}else{f[i>>2]=f[i>>2]|4;ib=0;break}}else ib=1}while(0);FEc(C);FEc(B);FEc(A);FEc(z);hEc(y);y=f[r>>2]|0;f[r>>2]=0;if(y|0)Yi[f[n>>2]&2047](y);u=o;return ib|0}function gAc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e+12|0;h=e;i=a+8|0;j=i+3|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=f[a+4>>2]|0;n=(f[i>>2]&2147483647)+-1|0}else{m=k&255;n=1}i=d-c>>2;do if(i|0){if(l){o=f[a>>2]|0;p=o;q=f[a+4>>2]|0;r=o}else{p=a;q=k&255;r=a}if(hAc(c,r,p+(q<<2)|0)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(i>>>0>1073741807)dEc(h);do if(i>>>0>=2){o=i+4&-4;if(o>>>0>1073741823)tf();else{s=VDc(o<<2)|0;f[h>>2]=s;f[h+8>>2]=o|-2147483648;f[h+4>>2]=i;t=c;v=s;break}}else{b[h+8+3>>0]=i;t=c;v=h}while(0);while(1){if((t|0)==(d|0))break;tvc(v,t);t=t+4|0;v=v+4|0}f[g>>2]=0;tvc(v,g);s=b[h+8+3>>0]|0;o=s<<24>>24<0;MEc(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:s&255)|0;FEc(h);break}s=m+i|0;if((n-m|0)>>>0<i>>>0)LEc(a,n,s-n|0,m,m,0,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;o=w+(m<<2)|0;x=c;while(1){if((x|0)==(d|0))break;tvc(o,x);o=o+4|0;x=x+4|0}f[g>>2]=0;tvc(o,g);if((b[j>>0]|0)<0){f[a+4>>2]=s;break}else{b[j>>0]=s;break}}while(0);u=e;return a|0}function hAc(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function iAc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=Hvc(c,886976)|0;mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[d>>0]=p;b[d+1>>0]=p>>8;b[d+2>>0]=p>>16;b[d+3>>0]=p>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;tvc(q,n);f[k+4>>2]=0}else{f[n>>2]=0;tvc(k,n);b[p>>0]=0}JEc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}FEc(o);mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);p=j+8+3|0;if((b[p>>0]|0)<0){q=f[j>>2]|0;f[n>>2]=0;tvc(q,n);f[j+4>>2]=0}else{f[n>>2]=0;tvc(j,n);b[p>>0]=0}JEc(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}FEc(o);p=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[e>>2]=p;p=_i[f[(f[a>>2]|0)+16>>2]&1023](a)|0;f[g>>2]=p;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);p=h+11|0;if((b[p>>0]|0)<0){q=f[h>>2]|0;b[n>>0]=0;_tc(q,n);f[h+4>>2]=0;r=h}else{b[n>>0]=0;_tc(h,n);b[p>>0]=0;r=h}mEc(h,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}hEc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);r=i+8+3|0;if((b[r>>0]|0)<0){p=f[i>>2]|0;f[n>>2]=0;tvc(p,n);f[i+4>>2]=0}else{f[n>>2]=0;tvc(i,n);b[r>>0]=0}JEc(i,0);f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}FEc(o);s=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0}else{a=Hvc(c,886968)|0;mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[d>>0]=c;b[d+1>>0]=c>>8;b[d+2>>0]=c>>16;b[d+3>>0]=c>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;f[n>>2]=0;tvc(d,n);f[k+4>>2]=0}else{f[n>>2]=0;tvc(k,n);b[c>>0]=0}JEc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];k=0;while(1){if((k|0)==3)break;f[o+(k<<2)>>2]=0;k=k+1|0}FEc(o);mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);k=j+8+3|0;if((b[k>>0]|0)<0){c=f[j>>2]|0;f[n>>2]=0;tvc(c,n);f[j+4>>2]=0}else{f[n>>2]=0;tvc(j,n);b[k>>0]=0}JEc(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];j=0;while(1){if((j|0)==3)break;f[o+(j<<2)>>2]=0;j=j+1|0}FEc(o);j=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[e>>2]=j;j=_i[f[(f[a>>2]|0)+16>>2]&1023](a)|0;f[g>>2]=j;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);j=h+11|0;if((b[j>>0]|0)<0){g=f[h>>2]|0;b[n>>0]=0;_tc(g,n);f[h+4>>2]=0;t=h}else{b[n>>0]=0;_tc(h,n);b[j>>0]=0;t=h}mEc(h,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}hEc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=i+8+3|0;if((b[t>>0]|0)<0){h=f[i>>2]|0;f[n>>2]=0;tvc(h,n);f[i+4>>2]=0}else{f[n>>2]=0;tvc(i,n);b[t>>0]=0}JEc(i,0);f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];i=0;while(1){if((i|0)==3)break;f[o+(i<<2)>>2]=0;i=i+1|0}FEc(o);s=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0}f[l>>2]=s;u=m;return}function jAc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1802;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?4:i;i=(f[b>>2]|0)-g>>2;j=qoc(e?g:0,h)|0;if(!j)_Dc();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{Yi[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1803;f[b>>2]=k+(i<<2);f[c>>2]=(f[a>>2]|0)+(h>>>2<<2);return}function kAc(a){a=a|0;nvc(a);return}function lAc(a){a=a|0;nvc(a);YDc(a);return}function mAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;a=u;u=u+384|0;i=a+8|0;j=a;k=a+284|0;l=a+72|0;m=a+184|0;n=a+68|0;o=a+180|0;q=a+177|0;r=a+176|0;s=a+56|0;t=a+44|0;v=a+32|0;w=a+28|0;x=a+76|0;y=a+24|0;z=a+16|0;A=a+20|0;f[l>>2]=k;p[i>>3]=h;B=gqc(k,100,516444,i)|0;if(B>>>0>99){k=Kvc()|0;p[j>>3]=h;C=axc(l,k,516444,j)|0;j=f[l>>2]|0;if(!j)_Dc();k=ooc(C)|0;if(!k)_Dc();else{D=k;E=C;F=k;G=j}}else{D=m;E=B;F=0;G=0}cuc(n,e);B=Hvc(n,885240)|0;m=f[l>>2]|0;hh[f[(f[B>>2]|0)+32>>2]&127](B,m,m+E|0,D)|0;if(!E)H=0;else H=(b[f[l>>2]>>0]|0)==45;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[s+(l<<2)>>2]=0;l=l+1|0}f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[t+(l<<2)>>2]=0;l=l+1|0}f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[v+(l<<2)>>2]=0;l=l+1|0}oAc(d,H,n,o,q,r,s,t,v,w);d=f[w>>2]|0;if((E|0)>(d|0)){w=b[v+11>>0]|0;l=b[t+11>>0]|0;I=1;J=(w<<24>>24<0?f[v+4>>2]|0:w&255)+(E-d<<1)|0;K=l<<24>>24<0?f[t+4>>2]|0:l&255}else{l=b[v+11>>0]|0;w=b[t+11>>0]|0;I=2;J=w<<24>>24<0?f[t+4>>2]|0:w&255;K=l<<24>>24<0?f[v+4>>2]|0:l&255}l=K+d+J+I|0;if(l>>>0>100){I=ooc(l)|0;if(!I)_Dc();else{L=I;M=I}}else{L=x;M=0}pAc(L,y,z,f[e+4>>2]|0,D,D+E|0,B,H,o,b[q>>0]|0,b[r>>0]|0,s,t,v,d);f[A>>2]=f[c>>2];c=f[y>>2]|0;y=f[z>>2]|0;f[i>>2]=f[A>>2];A=L1(i,L,c,y,e,g)|0;if(M|0)poc(M);hEc(v);hEc(t);hEc(s);Ivc(n);if(F|0)poc(F);if(G|0)poc(G);u=a;return A|0}function nAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+176|0;i=a+56|0;j=a+52|0;k=a+164|0;l=a+161|0;m=a+160|0;n=a+40|0;o=a+28|0;p=a+16|0;q=a+12|0;r=a+60|0;s=a+8|0;t=a+4|0;v=a;cuc(j,e);w=Hvc(j,885240)|0;x=h+11|0;y=b[x>>0]|0;z=y<<24>>24<0;A=h+4|0;if(!((z?f[A>>2]|0:y&255)|0))B=0;else{y=b[(z?f[h>>2]|0:h)>>0]|0;B=y<<24>>24==(Mi[f[(f[w>>2]|0)+28>>2]&1023](w,45)|0)<<24>>24};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[n+(y<<2)>>2]=0;y=y+1|0}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[p+(y<<2)>>2]=0;y=y+1|0}oAc(d,B,j,k,l,m,n,o,p,q);d=b[x>>0]|0;x=d<<24>>24<0;y=x?f[A>>2]|0:d&255;d=f[q>>2]|0;if((y|0)>(d|0)){q=b[p+11>>0]|0;A=b[o+11>>0]|0;C=1;D=(q<<24>>24<0?f[p+4>>2]|0:q&255)+(y-d<<1)|0;E=A<<24>>24<0?f[o+4>>2]|0:A&255}else{A=b[p+11>>0]|0;q=b[o+11>>0]|0;C=2;D=q<<24>>24<0?f[o+4>>2]|0:q&255;E=A<<24>>24<0?f[p+4>>2]|0:A&255}A=E+d+D+C|0;if(A>>>0>100){C=ooc(A)|0;if(!C)_Dc();else{F=C;G=C}}else{F=r;G=0}r=x?f[h>>2]|0:h;pAc(F,s,t,f[e+4>>2]|0,r,r+y|0,w,B,k,b[l>>0]|0,b[m>>0]|0,n,o,p,d);f[v>>2]=f[c>>2];c=f[s>>2]|0;s=f[t>>2]|0;f[i>>2]=f[v>>2];v=L1(i,F,c,s,e,g)|0;if(G|0)poc(G);hEc(p);hEc(o);hEc(n);Ivc(j);u=a;return v|0}function oAc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=Hvc(d,886960)|0;if(c){mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+11|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;b[n>>0]=0;_tc(q,n);f[k+4>>2]=0;r=k}else{b[n>>0]=0;_tc(k,n);b[p>>0]=0;r=k}mEc(k,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}hEc(o);s=a}else{mi[f[(f[a>>2]|0)+40>>2]&2047](n,a);r=f[n>>2]|0;b[e>>0]=r;b[e+1>>0]=r>>8;b[e+2>>0]=r>>16;b[e+3>>0]=r>>24;mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);r=k+11|0;if((b[r>>0]|0)<0){p=f[k>>2]|0;b[n>>0]=0;_tc(p,n);f[k+4>>2]=0;t=k}else{b[n>>0]=0;_tc(k,n);b[r>>0]=0;t=k}mEc(k,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}hEc(o);s=a}t=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;b[g>>0]=t;t=_i[f[(f[a>>2]|0)+16>>2]&1023](a)|0;b[h>>0]=t;mi[f[(f[s>>2]|0)+20>>2]&2047](o,a);t=i+11|0;if((b[t>>0]|0)<0){r=f[i>>2]|0;b[n>>0]=0;_tc(r,n);f[i+4>>2]=0;v=i}else{b[n>>0]=0;_tc(i,n);b[t>>0]=0;v=i}mEc(i,0);f[v>>2]=f[o>>2];f[v+4>>2]=f[o+4>>2];f[v+8>>2]=f[o+8>>2];v=0;while(1){if((v|0)==3)break;f[o+(v<<2)>>2]=0;v=v+1|0}hEc(o);mi[f[(f[s>>2]|0)+24>>2]&2047](o,a);s=j+11|0;if((b[s>>0]|0)<0){v=f[j>>2]|0;b[n>>0]=0;_tc(v,n);f[j+4>>2]=0;w=j}else{b[n>>0]=0;_tc(j,n);b[s>>0]=0;w=j}mEc(j,0);f[w>>2]=f[o>>2];f[w+4>>2]=f[o+4>>2];f[w+8>>2]=f[o+8>>2];w=0;while(1){if((w|0)==3)break;f[o+(w<<2)>>2]=0;w=w+1|0}hEc(o);x=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0}else{a=Hvc(d,886952)|0;if(c){mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+11|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;b[n>>0]=0;_tc(d,n);f[k+4>>2]=0;y=k}else{b[n>>0]=0;_tc(k,n);b[c>>0]=0;y=k}mEc(k,0);f[y>>2]=f[o>>2];f[y+4>>2]=f[o+4>>2];f[y+8>>2]=f[o+8>>2];y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}hEc(o);z=a}else{mi[f[(f[a>>2]|0)+40>>2]&2047](n,a);y=f[n>>2]|0;b[e>>0]=y;b[e+1>>0]=y>>8;b[e+2>>0]=y>>16;b[e+3>>0]=y>>24;mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);y=k+11|0;if((b[y>>0]|0)<0){e=f[k>>2]|0;b[n>>0]=0;_tc(e,n);f[k+4>>2]=0;A=k}else{b[n>>0]=0;_tc(k,n);b[y>>0]=0;A=k}mEc(k,0);f[A>>2]=f[o>>2];f[A+4>>2]=f[o+4>>2];f[A+8>>2]=f[o+8>>2];A=0;while(1){if((A|0)==3)break;f[o+(A<<2)>>2]=0;A=A+1|0}hEc(o);z=a}A=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;b[g>>0]=A;A=_i[f[(f[a>>2]|0)+16>>2]&1023](a)|0;b[h>>0]=A;mi[f[(f[z>>2]|0)+20>>2]&2047](o,a);A=i+11|0;if((b[A>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;_tc(h,n);f[i+4>>2]=0;B=i}else{b[n>>0]=0;_tc(i,n);b[A>>0]=0;B=i}mEc(i,0);f[B>>2]=f[o>>2];f[B+4>>2]=f[o+4>>2];f[B+8>>2]=f[o+8>>2];B=0;while(1){if((B|0)==3)break;f[o+(B<<2)>>2]=0;B=B+1|0}hEc(o);mi[f[(f[z>>2]|0)+24>>2]&2047](o,a);z=j+11|0;if((b[z>>0]|0)<0){B=f[j>>2]|0;b[n>>0]=0;_tc(B,n);f[j+4>>2]=0;C=j}else{b[n>>0]=0;_tc(j,n);b[z>>0]=0;C=j}mEc(j,0);f[C>>2]=f[o>>2];f[C+4>>2]=f[o+4>>2];f[C+8>>2]=f[o+8>>2];C=0;while(1){if((C|0)==3)break;f[o+(C<<2)>>2]=0;C=C+1|0}hEc(o);x=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0}f[l>>2]=x;u=m;return}function pAc(a,c,e,g,h,i,j,k,l,m,n,o,p,q,r){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;f[e>>2]=a;s=q+11|0;t=q+4|0;u=p+11|0;v=p+4|0;w=(g&512|0)==0;x=j+8|0;y=(r|0)>0;z=o+11|0;A=o+4|0;B=0;C=h;while(1){if((B|0)==4)break;a:do switch(b[l+B>>0]|0){case 0:{f[c>>2]=f[e>>2];D=C;break}case 1:{f[c>>2]=f[e>>2];h=Mi[f[(f[j>>2]|0)+28>>2]&1023](j,32)|0;E=f[e>>2]|0;f[e>>2]=E+1;b[E>>0]=h;D=C;break}case 3:{h=b[s>>0]|0;E=h<<24>>24<0;if(!((E?f[t>>2]|0:h&255)|0))D=C;else{h=b[(E?f[q>>2]|0:q)>>0]|0;E=f[e>>2]|0;f[e>>2]=E+1;b[E>>0]=h;D=C}break}case 2:{h=b[u>>0]|0;E=h<<24>>24<0;F=E?f[v>>2]|0:h&255;if(w|(F|0)==0)D=C;else{h=E?f[p>>2]|0:p;E=h+F|0;F=f[e>>2]|0;G=h;while(1){if((G|0)==(E|0))break;b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}f[e>>2]=F;D=C}break}case 4:{G=f[e>>2]|0;E=k?C+1|0:C;h=E;while(1){if(h>>>0>=i>>>0)break;H=b[h>>0]|0;if(H<<24>>24<=-1)break;if(!(d[(f[x>>2]|0)+(H<<24>>24<<1)>>1]&2048))break;h=h+1|0}if(y){F=r;H=h;while(1){I=(F|0)>0;if(!(H>>>0>E>>>0&I))break;J=H+-1|0;K=b[J>>0]|0;L=f[e>>2]|0;f[e>>2]=L+1;b[L>>0]=K;F=F+-1|0;H=J}if(I)M=Mi[f[(f[j>>2]|0)+28>>2]&1023](j,48)|0;else M=0;J=F;while(1){N=f[e>>2]|0;f[e>>2]=N+1;if((J|0)<=0)break;b[N>>0]=M;J=J+-1|0}b[N>>0]=m;O=H}else O=h;b:do if((O|0)==(E|0)){J=Mi[f[(f[j>>2]|0)+28>>2]&1023](j,48)|0;F=f[e>>2]|0;f[e>>2]=F+1;b[F>>0]=J}else{J=b[z>>0]|0;F=J<<24>>24<0;if(!((F?f[A>>2]|0:J&255)|0)){P=-1;Q=0;R=0;S=O}else{P=b[(F?f[o>>2]|0:o)>>0]|0;Q=0;R=0;S=O}while(1){if((S|0)==(E|0))break b;if((R|0)==(P|0)){F=f[e>>2]|0;f[e>>2]=F+1;b[F>>0]=n;F=Q+1|0;J=b[z>>0]|0;K=J<<24>>24<0;if(F>>>0<(K?f[A>>2]|0:J&255)>>>0){J=b[(K?f[o>>2]|0:o)+F>>0]|0;T=J<<24>>24==127?-1:J<<24>>24;U=F;V=0}else{T=R;U=F;V=0}}else{T=P;U=Q;V=R}F=S+-1|0;J=b[F>>0]|0;K=f[e>>2]|0;f[e>>2]=K+1;b[K>>0]=J;P=T;Q=U;R=V+1|0;S=F}}while(0);h=f[e>>2]|0;if((G|0)==(h|0))D=E;else{H=h;h=G;while(1){F=H+-1|0;if(h>>>0>=F>>>0){D=E;break a}J=b[h>>0]|0;b[h>>0]=b[F>>0]|0;b[F>>0]=J;H=F;h=h+1|0}}break}default:D=C}while(0);B=B+1|0;C=D}D=b[s>>0]|0;s=D<<24>>24<0;C=s?f[t>>2]|0:D&255;if(C>>>0>1){D=s?f[q>>2]|0:q;q=D+C|0;C=f[e>>2]|0;s=D;while(1){D=s+1|0;if((D|0)==(q|0))break;b[C>>0]=b[D>>0]|0;C=C+1|0;s=D}f[e>>2]=C}switch((g&176)<<24>>24){case 32:{f[c>>2]=f[e>>2];break}case 16:break;default:f[c>>2]=a}return}function qAc(a){a=a|0;nvc(a);return}function rAc(a){a=a|0;nvc(a);YDc(a);return}function sAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;a=u;u=u+1008|0;i=a+8|0;j=a;k=a+896|0;l=a+888|0;m=a+488|0;n=a+480|0;o=a+892|0;q=a+476|0;r=a+472|0;s=a+460|0;t=a+448|0;v=a+436|0;w=a+432|0;x=a+32|0;y=a+24|0;z=a+16|0;A=a+20|0;f[l>>2]=k;p[i>>3]=h;B=gqc(k,100,516444,i)|0;if(B>>>0>99){k=Kvc()|0;p[j>>3]=h;C=axc(l,k,516444,j)|0;j=f[l>>2]|0;if(!j)_Dc();k=ooc(C<<2)|0;if(!k)_Dc();else{D=k;E=C;F=k;G=j}}else{D=m;E=B;F=0;G=0}cuc(n,e);B=Hvc(n,885272)|0;m=f[l>>2]|0;hh[f[(f[B>>2]|0)+48>>2]&127](B,m,m+E|0,D)|0;if(!E)H=0;else H=(b[f[l>>2]>>0]|0)==45;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[s+(l<<2)>>2]=0;l=l+1|0}f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[t+(l<<2)>>2]=0;l=l+1|0}f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[v+(l<<2)>>2]=0;l=l+1|0}uAc(d,H,n,o,q,r,s,t,v,w);d=f[w>>2]|0;if((E|0)>(d|0)){w=b[v+8+3>>0]|0;l=b[t+8+3>>0]|0;I=1;J=(w<<24>>24<0?f[v+4>>2]|0:w&255)+(E-d<<1)|0;K=l<<24>>24<0?f[t+4>>2]|0:l&255}else{l=b[v+8+3>>0]|0;w=b[t+8+3>>0]|0;I=2;J=w<<24>>24<0?f[t+4>>2]|0:w&255;K=l<<24>>24<0?f[v+4>>2]|0:l&255}l=K+d+J+I|0;if(l>>>0>100){I=ooc(l<<2)|0;if(!I)_Dc();else{L=I;M=I}}else{L=x;M=0}vAc(L,y,z,f[e+4>>2]|0,D,D+(E<<2)|0,B,H,o,f[q>>2]|0,f[r>>2]|0,s,t,v,d);f[A>>2]=f[c>>2];c=f[y>>2]|0;y=f[z>>2]|0;f[i>>2]=f[A>>2];A=oxc(i,L,c,y,e,g)|0;if(M|0)poc(M);FEc(v);FEc(t);hEc(s);Ivc(n);if(F|0)poc(F);if(G|0)poc(G);u=a;return A|0}function tAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+480|0;i=a+468|0;j=a+464|0;k=a+472|0;l=a+460|0;m=a+456|0;n=a+444|0;o=a+432|0;p=a+420|0;q=a+416|0;r=a+16|0;s=a+8|0;t=a+4|0;v=a;cuc(j,e);w=Hvc(j,885272)|0;x=h+8+3|0;y=b[x>>0]|0;z=y<<24>>24<0;A=h+4|0;if(!((z?f[A>>2]|0:y&255)|0))B=0;else{y=f[(z?f[h>>2]|0:h)>>2]|0;B=(y|0)==(Mi[f[(f[w>>2]|0)+44>>2]&1023](w,45)|0)};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[n+(y<<2)>>2]=0;y=y+1|0}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[p+(y<<2)>>2]=0;y=y+1|0}uAc(d,B,j,k,l,m,n,o,p,q);d=b[x>>0]|0;x=d<<24>>24<0;y=x?f[A>>2]|0:d&255;d=f[q>>2]|0;if((y|0)>(d|0)){q=b[p+8+3>>0]|0;A=b[o+8+3>>0]|0;C=1;D=(q<<24>>24<0?f[p+4>>2]|0:q&255)+(y-d<<1)|0;E=A<<24>>24<0?f[o+4>>2]|0:A&255}else{A=b[p+8+3>>0]|0;q=b[o+8+3>>0]|0;C=2;D=q<<24>>24<0?f[o+4>>2]|0:q&255;E=A<<24>>24<0?f[p+4>>2]|0:A&255}A=E+d+D+C|0;if(A>>>0>100){C=ooc(A<<2)|0;if(!C)_Dc();else{F=C;G=C}}else{F=r;G=0}r=x?f[h>>2]|0:h;vAc(F,s,t,f[e+4>>2]|0,r,r+(y<<2)|0,w,B,k,f[l>>2]|0,f[m>>2]|0,n,o,p,d);f[v>>2]=f[c>>2];c=f[s>>2]|0;s=f[t>>2]|0;f[i>>2]=f[v>>2];v=oxc(i,F,c,s,e,g)|0;if(G|0)poc(G);FEc(p);FEc(o);hEc(n);Ivc(j);u=a;return v|0}function uAc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=Hvc(d,886976)|0;if(c){mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;tvc(q,n);f[k+4>>2]=0}else{f[n>>2]=0;tvc(k,n);b[p>>0]=0}JEc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}FEc(o)}else{mi[f[(f[a>>2]|0)+40>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;tvc(q,n);f[k+4>>2]=0}else{f[n>>2]=0;tvc(k,n);b[p>>0]=0}JEc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}FEc(o)}p=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[g>>2]=p;p=_i[f[(f[a>>2]|0)+16>>2]&1023](a)|0;f[h>>2]=p;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);p=i+11|0;if((b[p>>0]|0)<0){q=f[i>>2]|0;b[n>>0]=0;_tc(q,n);f[i+4>>2]=0;r=i}else{b[n>>0]=0;_tc(i,n);b[p>>0]=0;r=i}mEc(i,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}hEc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);r=j+8+3|0;if((b[r>>0]|0)<0){p=f[j>>2]|0;f[n>>2]=0;tvc(p,n);f[j+4>>2]=0}else{f[n>>2]=0;tvc(j,n);b[r>>0]=0}JEc(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}FEc(o);s=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0}else{a=Hvc(d,886968)|0;if(c){mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;f[n>>2]=0;tvc(d,n);f[k+4>>2]=0}else{f[n>>2]=0;tvc(k,n);b[c>>0]=0}JEc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];c=0;while(1){if((c|0)==3)break;f[o+(c<<2)>>2]=0;c=c+1|0}FEc(o)}else{mi[f[(f[a>>2]|0)+40>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){e=f[k>>2]|0;f[n>>2]=0;tvc(e,n);f[k+4>>2]=0}else{f[n>>2]=0;tvc(k,n);b[c>>0]=0}JEc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];k=0;while(1){if((k|0)==3)break;f[o+(k<<2)>>2]=0;k=k+1|0}FEc(o)}k=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[g>>2]=k;k=_i[f[(f[a>>2]|0)+16>>2]&1023](a)|0;f[h>>2]=k;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);k=i+11|0;if((b[k>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;_tc(h,n);f[i+4>>2]=0;t=i}else{b[n>>0]=0;_tc(i,n);b[k>>0]=0;t=i}mEc(i,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}hEc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=j+8+3|0;if((b[t>>0]|0)<0){i=f[j>>2]|0;f[n>>2]=0;tvc(i,n);f[j+4>>2]=0}else{f[n>>2]=0;tvc(j,n);b[t>>0]=0}JEc(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];j=0;while(1){if((j|0)==3)break;f[o+(j<<2)>>2]=0;j=j+1|0}FEc(o);s=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0}f[l>>2]=s;u=m;return}function vAc(a,c,d,e,g,h,i,j,k,l,m,n,o,p,q){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f[d>>2]=a;r=p+8+3|0;s=p+4|0;t=o+8+3|0;u=o+4|0;v=(e&512|0)==0;w=(q|0)>0;x=n+11|0;y=n+4|0;z=0;A=g;while(1){if((z|0)==4)break;a:do switch(b[k+z>>0]|0){case 0:{f[c>>2]=f[d>>2];B=A;break}case 1:{f[c>>2]=f[d>>2];g=Mi[f[(f[i>>2]|0)+44>>2]&1023](i,32)|0;C=f[d>>2]|0;f[d>>2]=C+4;f[C>>2]=g;B=A;break}case 3:{g=b[r>>0]|0;C=g<<24>>24<0;if(!((C?f[s>>2]|0:g&255)|0))B=A;else{g=f[(C?f[p>>2]|0:p)>>2]|0;C=f[d>>2]|0;f[d>>2]=C+4;f[C>>2]=g;B=A}break}case 2:{g=b[t>>0]|0;C=g<<24>>24<0;D=C?f[u>>2]|0:g&255;if(v|(D|0)==0)B=A;else{g=C?f[o>>2]|0:o;C=g+(D<<2)|0;E=f[d>>2]|0;F=E;G=g;while(1){if((G|0)==(C|0))break;f[F>>2]=f[G>>2];F=F+4|0;G=G+4|0}f[d>>2]=E+(D<<2);B=A}break}case 4:{G=f[d>>2]|0;F=j?A+4|0:A;C=F;while(1){if(C>>>0>=h>>>0)break;if(!(hj[f[(f[i>>2]|0)+12>>2]&511](i,2048,f[C>>2]|0)|0))break;C=C+4|0}if(w){D=q;E=C;while(1){H=(D|0)>0;if(!(E>>>0>F>>>0&H))break;g=E+-4|0;I=f[g>>2]|0;J=f[d>>2]|0;f[d>>2]=J+4;f[J>>2]=I;D=D+-1|0;E=g}if(H)K=Mi[f[(f[i>>2]|0)+44>>2]&1023](i,48)|0;else K=0;g=D;I=f[d>>2]|0;while(1){L=I+4|0;if((g|0)<=0)break;f[I>>2]=K;g=g+-1|0;I=L}f[d>>2]=L;f[I>>2]=l;M=E}else M=C;if((M|0)==(F|0)){g=Mi[f[(f[i>>2]|0)+44>>2]&1023](i,48)|0;D=f[d>>2]|0;J=D+4|0;f[d>>2]=J;f[D>>2]=g;N=J}else{J=b[x>>0]|0;g=J<<24>>24<0;D=J&255;if(!((g?f[y>>2]|0:D)|0)){O=-1;P=0;Q=0;R=M}else{O=b[(g?f[n>>2]|0:n)>>0]|0;P=0;Q=0;R=M}while(1){if((R|0)==(F|0))break;J=f[d>>2]|0;if((Q|0)==(O|0)){S=J+4|0;f[d>>2]=S;f[J>>2]=m;T=P+1|0;if(T>>>0<(g?f[y>>2]|0:D)>>>0){U=b[(g?f[n>>2]|0:n)+T>>0]|0;V=U<<24>>24==127?-1:U<<24>>24;W=T;X=0;Y=S}else{V=Q;W=T;X=0;Y=S}}else{V=O;W=P;X=Q;Y=J}J=R+-4|0;S=f[J>>2]|0;f[d>>2]=Y+4;f[Y>>2]=S;O=V;P=W;Q=X+1|0;R=J}N=f[d>>2]|0}if((G|0)==(N|0))B=F;else{g=N;D=G;while(1){C=g+-4|0;if(D>>>0>=C>>>0){B=F;break a}E=f[D>>2]|0;f[D>>2]=f[C>>2];f[C>>2]=E;g=C;D=D+4|0}}break}default:B=A}while(0);z=z+1|0;A=B}B=b[r>>0]|0;r=B<<24>>24<0;A=r?f[s>>2]|0:B&255;if(A>>>0>1){B=r?f[p>>2]|0:p;p=B+4|0;r=B+(A<<2)|0;A=f[d>>2]|0;B=r-p|0;s=A;z=p;while(1){if((z|0)==(r|0))break;f[s>>2]=f[z>>2];s=s+4|0;z=z+4|0}f[d>>2]=A+(B>>>2<<2)}switch((e&176)<<24>>24){case 32:{f[c>>2]=f[d>>2];break}case 16:break;default:f[c>>2]=a}return}function wAc(a){a=a|0;nvc(a);return}function xAc(a){a=a|0;nvc(a);YDc(a);return}function yAc(a,c,d){a=a|0;c=c|0;d=d|0;d=Qqc((b[c+11>>0]|0)<0?f[c>>2]|0:c,1)|0;return d>>>((d|0)!=(-1|0)&1)|0}function zAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;i=c;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;j=0;while(1){if((j|0)==3)break;f[i+(j<<2)>>2]=0;j=j+1|0}j=b[h+11>>0]|0;k=j<<24>>24<0;l=k?f[h>>2]|0:h;m=l+(k?f[h+4>>2]|0:j&255)|0;j=l;while(1){if(j>>>0>=m>>>0)break;vEc(i,b[j>>0]|0);j=j+1|0}j=(b[i+11>>0]|0)<0?f[i>>2]|0:i;m=Xqc((d|0)==-1?-1:d<<1,e,g,j)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[a+(g<<2)>>2]=0;g=g+1|0}g=j+(Mpc(m)|0)|0;m=j;while(1){if(m>>>0>=g>>>0)break;vEc(a,b[m>>0]|0);m=m+1|0}hEc(i);u=c;return}function AAc(a,b){a=a|0;b=b|0;return}function BAc(a){a=a|0;nvc(a);return}function CAc(a){a=a|0;nvc(a);YDc(a);return}function DAc(a,c,d){a=a|0;c=c|0;d=d|0;d=Qqc((b[c+11>>0]|0)<0?f[c>>2]|0:c,1)|0;return d>>>((d|0)!=(-1|0)&1)|0}function EAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+176|0;i=c+168|0;j=c+40|0;k=c+36|0;l=c+32|0;m=c;n=c+24|0;o=c+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=0;while(1){if((p|0)==3)break;f[m+(p<<2)>>2]=0;p=p+1|0}f[n+4>>2]=0;f[n>>2]=184780;p=b[h+8+3>>0]|0;q=p<<24>>24<0;r=q?f[h>>2]|0:h;s=r+((q?f[h+4>>2]|0:p&255)<<2)|0;p=j+32|0;h=r;r=0;while(1){if(!((r|0)!=2&h>>>0<s>>>0))break;f[l>>2]=h;q=Ij[f[(f[n>>2]|0)+12>>2]&15](n,i,h,s,l,j,p,k)|0;if((q|0)==2?1:(f[l>>2]|0)==(h|0)){t=7;break}else v=j;while(1){if(v>>>0>=(f[k>>2]|0)>>>0)break;vEc(m,b[v>>0]|0);v=v+1|0}h=f[l>>2]|0;r=q}if((t|0)==7)azc(0);nvc(n);n=(b[m+11>>0]|0)<0?f[m>>2]|0:m;r=Xqc((d|0)==-1?-1:d<<1,e,g,n)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[a+(g<<2)>>2]=0;g=g+1|0}f[o+4>>2]=0;f[o>>2]=184828;g=n+(Mpc(r)|0)|0;r=g;e=j+128|0;d=n;n=0;while(1){if(!((n|0)!=2&d>>>0<g>>>0)){t=21;break}f[l>>2]=d;h=Ij[f[(f[o>>2]|0)+16>>2]&15](o,i,d,(r-d|0)>32?d+32|0:g,l,j,e,k)|0;if((h|0)==2?1:(f[l>>2]|0)==(d|0)){t=17;break}else w=j;while(1){if(w>>>0>=(f[k>>2]|0)>>>0)break;NEc(a,f[w>>2]|0);w=w+4|0}d=f[l>>2]|0;n=h}if((t|0)==17)azc(0);else if((t|0)==21){nvc(o);hEc(m);u=c;return}}function FAc(a,b){a=a|0;b=b|0;return}function GAc(a){a=a|0;nvc(a);YDc(a);return}function HAc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=QAc(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function IAc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=PAc(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function JAc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function KAc(a){a=a|0;return 0}function LAc(a){a=a|0;return 0}function MAc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return OAc(c,d,e,1114111,0)|0}function NAc(a){a=a|0;return 4}function OAc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=c;i=a;if(((g-i|0)>2&(f&4|0)!=0?(b[a>>0]|0)==-17:0)?(b[a+1>>0]|0)==-69:0){j=0;k=(b[a+2>>0]|0)==-65?a+3|0:a}else{j=0;k=a}a:while(1){if(!(j>>>0<d>>>0&k>>>0<c>>>0)){l=30;break}a=b[k>>0]|0;f=a&255;m=k+1|0;do if(a<<24>>24>-1)if(f>>>0>e>>>0){l=30;break a}else n=m;else{if((a&255)<194){l=30;break a}o=k+2|0;p=k;q=g-p|0;if((a&255)<224){if((q|0)<2){l=30;break a}r=h[m>>0]|0;if((r&192|0)!=128){l=30;break a}if((r&63|f<<6&1984)>>>0>e>>>0){l=30;break a}else{n=o;break}}r=k+3|0;if((a&255)<240){if((q|0)<3){l=30;break a}s=b[o>>0]|0;t=h[m>>0]|0;u=t&224;switch(a<<24>>24){case -32:{if((u|0)!=160){v=p;break a}break}case -19:{if((u|0)!=128){v=p;break a}break}default:if((t&192|0)!=128){v=p;break a}}u=s&255;if((u&192|0)!=128){l=30;break a}if((t<<6&4032|f<<12&61440|u&63)>>>0>e>>>0){l=30;break a}else{n=r;break}}if((q|0)<4|(a&255)>244){l=30;break a}q=b[m>>0]|0;u=b[o>>0]|0;o=b[r>>0]|0;r=q&255;switch(a<<24>>24){case -16:{if((q+112&255)>=48){v=p;break a}break}case -12:{if((r&240|0)!=128){v=p;break a}break}default:if((r&192|0)!=128){v=p;break a}}p=u&255;if((p&192|0)!=128){l=30;break a}u=o&255;if((u&192|0)!=128){l=30;break a}if((r<<12&258048|f<<18&1835008|p<<6&4032|u&63)>>>0>e>>>0){l=30;break a}else n=k+4|0}while(0);j=j+1|0;k=n}if((l|0)==30)v=k;return v-i|0}function PAc(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f[d>>2]=a;f[i>>2]=e;e=c;if((((k&4|0?(k=f[d>>2]|0,(e-k|0)>2):0)?(b[k>>0]|0)==-17:0)?(b[k+1>>0]|0)==-69:0)?(b[k+2>>0]|0)==-65:0)f[d>>2]=k+3;a:while(1){k=f[d>>2]|0;if(k>>>0>=c>>>0){l=0;break}a=f[i>>2]|0;if(a>>>0>=g>>>0){l=1;break}m=b[k>>0]|0;n=m&255;o=k+1|0;do if(m<<24>>24>-1){if(n>>>0>j>>>0){l=2;break a}f[a>>2]=n;p=o}else{if((m&255)<194){l=2;break a}q=k+2|0;r=e-k|0;if((m&255)<224){if((r|0)<2){l=1;break a}s=h[o>>0]|0;if((s&192|0)!=128){l=2;break a}t=s&63|n<<6&1984;if(t>>>0>j>>>0){l=2;break a}f[a>>2]=t;p=q;break}t=k+3|0;if((m&255)<240){if((r|0)<3){l=1;break a}s=b[q>>0]|0;u=h[o>>0]|0;v=u&224;switch(m<<24>>24){case -32:{if((v|0)!=160){l=2;break a}break}case -19:{if((v|0)!=128){l=2;break a}break}default:if((u&192|0)!=128){l=2;break a}}v=s&255;if((v&192|0)!=128){l=2;break a}s=u<<6&4032|n<<12&61440|v&63;if(s>>>0>j>>>0){l=2;break a}f[a>>2]=s;p=t;break}if((m&255)>=245){l=2;break a}if((r|0)<4){l=1;break a}r=b[o>>0]|0;s=b[q>>0]|0;q=b[t>>0]|0;t=r&255;switch(m<<24>>24){case -16:{if((r+112&255)>=48){l=2;break a}break}case -12:{if((t&240|0)!=128){l=2;break a}break}default:if((t&192|0)!=128){l=2;break a}}r=s&255;if((r&192|0)!=128){l=2;break a}s=q&255;if((s&192|0)!=128){l=2;break a}q=t<<12&258048|n<<18&1835008|r<<6&4032|s&63;if(q>>>0>j>>>0){l=2;break a}f[a>>2]=q;p=k+4|0}while(0);f[d>>2]=p;f[i>>2]=(f[i>>2]|0)+4}return l|0}function QAc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[d>>2]=a;f[h>>2]=e;a=g;if(j&2)if((a-e|0)<3)k=1;else{f[h>>2]=e+1;b[e>>0]=-17;e=f[h>>2]|0;f[h>>2]=e+1;b[e>>0]=-69;e=f[h>>2]|0;f[h>>2]=e+1;b[e>>0]=-65;l=4}else l=4;a:do if((l|0)==4){e=f[d>>2]|0;while(1){if(e>>>0>=c>>>0){k=0;break a}j=f[e>>2]|0;if(j>>>0>i>>>0|(j&-2048|0)==55296){k=2;break a}do if(j>>>0>=128){g=(j&63|128)&255;if(j>>>0<2048){m=f[h>>2]|0;if((a-m|0)<2){k=1;break a}f[h>>2]=m+1;b[m>>0]=j>>>6|192;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=g;break}m=f[h>>2]|0;n=a-m|0;o=m+1|0;p=(j>>>6&63|128)&255;if(j>>>0<65536){if((n|0)<3){k=1;break a}f[h>>2]=o;b[m>>0]=j>>>12|224;q=f[h>>2]|0;f[h>>2]=q+1;b[q>>0]=p;q=f[h>>2]|0;f[h>>2]=q+1;b[q>>0]=g;break}else{if((n|0)<4){k=1;break a}f[h>>2]=o;b[m>>0]=j>>>18|240;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=j>>>12&63|128;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=p;p=f[h>>2]|0;f[h>>2]=p+1;b[p>>0]=g;break}}else{g=f[h>>2]|0;if((a-g|0)<1){k=1;break a}f[h>>2]=g+1;b[g>>0]=j}while(0);j=(f[d>>2]|0)+4|0;f[d>>2]=j;e=j}}while(0);return k|0}function RAc(a){a=a|0;nvc(a);YDc(a);return}function SAc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;f[e>>2]=c;f[i>>2]=g;return 3}function TAc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;f[e>>2]=c;f[i>>2]=g;return 3}function UAc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function VAc(a){a=a|0;return 1}function WAc(a){a=a|0;return 1}function XAc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return (b>>>0<e>>>0?b:e)|0}function YAc(a){a=a|0;return 1}function ZAc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=u;u=u+16|0;l=k;m=k+8|0;n=d;while(1){if((n|0)==(e|0)){o=e;break}if(!(f[n>>2]|0)){o=n;break}n=n+4|0}f[j>>2]=h;f[g>>2]=d;n=i;p=a+8|0;a=d;d=h;h=o;a:while(1){if((d|0)==(i|0)|(a|0)==(e|0)){q=a;r=35;break}o=c;s=f[o+4>>2]|0;t=l;f[t>>2]=f[o>>2];f[t+4>>2]=s;s=Rqc(f[p>>2]|0)|0;t=Lrc(d,g,h-a>>2,n-d|0,c)|0;if(s|0)Rqc(s)|0;switch(t|0){case -1:{r=10;break a;break}case 0:{v=1;r=32;break a;break}default:{}}s=(f[j>>2]|0)+t|0;f[j>>2]=s;if((s|0)==(i|0)){r=33;break}if((h|0)==(e|0)){w=e;x=s;y=f[g>>2]|0}else{s=Rqc(f[p>>2]|0)|0;t=epc(m,0,c)|0;if(s|0)Rqc(s)|0;if((t|0)==-1){z=2;r=31;break}if(t>>>0>(n-(f[j>>2]|0)|0)>>>0){z=1;r=31;break}else{A=m;B=t}while(1){if(!B)break;t=b[A>>0]|0;s=f[j>>2]|0;f[j>>2]=s+1;b[s>>0]=t;A=A+1|0;B=B+-1|0}t=(f[g>>2]|0)+4|0;f[g>>2]=t;s=t;while(1){if((s|0)==(e|0)){C=e;break}if(!(f[s>>2]|0)){C=s;break}s=s+4|0}w=C;x=f[j>>2]|0;y=t}a=y;d=x;h=w}if((r|0)==10){f[j>>2]=d;w=a;a=d;while(1){if((w|0)==(f[g>>2]|0))break;d=f[w>>2]|0;h=Rqc(f[p>>2]|0)|0;x=epc(a,d,l)|0;if(h|0)Rqc(h)|0;if((x|0)==-1)break;h=(f[j>>2]|0)+x|0;f[j>>2]=h;w=w+4|0;a=h}f[g>>2]=w;v=2;r=32}else if((r|0)==31){v=z;r=32}else if((r|0)==33){q=f[g>>2]|0;r=35}if((r|0)==32)D=v;else if((r|0)==35)D=(q|0)!=(e|0)&1;u=k;return D|0}function _Ac(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=u;u=u+16|0;l=k;m=d;while(1){if((m|0)==(e|0)){n=e;break}if(!(b[m>>0]|0)){n=m;break}m=m+1|0}f[j>>2]=h;f[g>>2]=d;m=i;o=a+8|0;a=d;d=h;h=n;while(1){if((d|0)==(i|0)|(a|0)==(e|0)){p=a;q=32;break}n=c;r=f[n+4>>2]|0;s=l;f[s>>2]=f[n>>2];f[s+4>>2]=r;t=h;r=Rqc(f[o>>2]|0)|0;s=Cqc(d,g,t-a|0,m-d>>2,c)|0;if(r|0)Rqc(r)|0;if((s|0)==-1){v=a;w=d;q=10;break}r=(f[j>>2]|0)+(s<<2)|0;f[j>>2]=r;if((r|0)==(i|0)){q=29;break}s=f[g>>2]|0;if((h|0)==(e|0)){x=e;y=r;z=s}else{n=Rqc(f[o>>2]|0)|0;A=vpc(r,s,1,c)|0;if(n|0)Rqc(n)|0;if(A|0){B=2;q=28;break}f[j>>2]=(f[j>>2]|0)+4;A=(f[g>>2]|0)+1|0;f[g>>2]=A;n=A;while(1){if((n|0)==(e|0)){C=e;break}if(!(b[n>>0]|0)){C=n;break}n=n+1|0}x=C;y=f[j>>2]|0;z=A}a=z;d=y;h=x}do if((q|0)==10){a:while(1){q=0;f[j>>2]=w;if((v|0)==(f[g>>2]|0)){q=18;break}x=Rqc(f[o>>2]|0)|0;h=vpc(w,v,t-v|0,l)|0;if(x|0)Rqc(x)|0;switch(h|0){case -1:{q=15;break a;break}case -2:{q=16;break a;break}case 0:{D=1;break}default:D=h}v=v+D|0;w=(f[j>>2]|0)+4|0;q=10}if((q|0)==15){f[g>>2]=v;B=2;q=28;break}else if((q|0)==16){f[g>>2]=v;B=1;q=28;break}else if((q|0)==18){f[g>>2]=v;B=(v|0)!=(e|0)&1;q=28;break}}else if((q|0)==29){p=f[g>>2]|0;q=32}while(0);if((q|0)==28)E=B;else if((q|0)==32)E=(p|0)!=(e|0)&1;u=k;return E|0}function $Ac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;f[g>>2]=d;d=Rqc(f[a+8>>2]|0)|0;a=epc(i,0,c)|0;if(d|0)Rqc(d)|0;a:do switch(a|0){case 0:case -1:{j=2;break}default:{d=a+-1|0;if(d>>>0>(e-(f[g>>2]|0)|0)>>>0)j=1;else{c=i;k=d;while(1){if(!k){j=0;break a}d=b[c>>0]|0;l=f[g>>2]|0;f[g>>2]=l+1;b[l>>0]=d;c=c+1|0;k=k+-1|0}}}}while(0);u=h;return j|0}function aBc(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;a=Rqc(f[b>>2]|0)|0;c=fqc(0,0,4)|0;if(a|0)Rqc(a)|0;if(!c){c=f[b>>2]|0;if(!c)d=1;else{b=Rqc(c)|0;c=Trc()|0;if(b|0)Rqc(b)|0;return (c|0)==1|0}}else d=-1;return d|0}function bBc(a){a=a|0;return 0}function cBc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=d;h=a+8|0;a=0;i=0;j=c;a:while(1){if((j|0)==(d|0)|a>>>0>=e>>>0)break;c=Rqc(f[h>>2]|0)|0;k=Krc(j,g-j|0,b)|0;if(c|0)Rqc(c)|0;switch(k|0){case -2:case -1:{break a;break}case 0:{l=1;break}default:l=k}a=a+1|0;i=l+i|0;j=j+l|0}return i|0}function dBc(a){a=a|0;var b=0,c=0;b=f[a+8>>2]|0;if(b){a=Rqc(b)|0;b=Trc()|0;if(!a)c=b;else{Rqc(a)|0;c=b}}else c=1;return c|0}function eBc(a){a=a|0;var b=0,c=0;f[a>>2]=184876;b=a+8|0;c=f[b>>2]|0;if((c|0)!=(Kvc()|0))Oqc(f[b>>2]|0);nvc(a);return}function fBc(a){a=a|0;eBc(a);YDc(a);return}function gBc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=pBc(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function hBc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=oBc(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function iBc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function jBc(a){a=a|0;return 0}function kBc(a){a=a|0;return 0}function lBc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nBc(c,d,e,1114111,0)|0}function mBc(a){a=a|0;return 4}function nBc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=c;i=a;if(((g-i|0)>2&(f&4|0)!=0?(b[a>>0]|0)==-17:0)?(b[a+1>>0]|0)==-69:0){j=0;k=(b[a+2>>0]|0)==-65?a+3|0:a}else{j=0;k=a}a:while(1){if(!(j>>>0<d>>>0&k>>>0<c>>>0)){l=31;break}a=b[k>>0]|0;f=a&255;if(f>>>0>e>>>0){l=31;break}m=k+1|0;do if(a<<24>>24<=-1){if((a&255)<194){l=31;break a}n=k+2|0;o=k;p=g-o|0;if((a&255)<224){if((p|0)<2){l=31;break a}q=h[m>>0]|0;if((q&192|0)!=128){l=31;break a}if((q&63|f<<6&1984)>>>0>e>>>0){l=31;break a}else{r=j;s=n;break}}q=k+3|0;if((a&255)<240){if((p|0)<3){l=31;break a}t=b[n>>0]|0;u=h[m>>0]|0;v=u&224;switch(a<<24>>24){case -32:{if((v|0)!=160){w=o;break a}break}case -19:{if((v|0)!=128){w=o;break a}break}default:if((u&192|0)!=128){w=o;break a}}v=t&255;if((v&192|0)!=128){l=31;break a}if((u<<6&4032|f<<12&61440|v&63)>>>0>e>>>0){l=31;break a}else{r=j;s=q;break}}if((a&255)>=245){l=31;break a}if((d-j|0)>>>0<2|(p|0)<4){l=31;break a}p=b[m>>0]|0;v=b[n>>0]|0;n=b[q>>0]|0;q=p&255;switch(a<<24>>24){case -16:{if((p+112&255)>=48){w=o;break a}break}case -12:{if((q&240|0)!=128){w=o;break a}break}default:if((q&192|0)!=128){w=o;break a}}o=v&255;if((o&192|0)!=128){l=31;break a}v=n&255;if((v&192|0)!=128){l=31;break a}if((q<<12&258048|f<<18&1835008|o<<6&4032|v&63)>>>0>e>>>0){l=31;break a}else{r=j+1|0;s=k+4|0}}else{r=j;s=m}while(0);j=r+1|0;k=s}if((l|0)==31)w=k;return w-i|0}function oBc(a,c,e,g,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f[e>>2]=a;f[j>>2]=g;g=c;if((((l&4|0?(l=f[e>>2]|0,(g-l|0)>2):0)?(b[l>>0]|0)==-17:0)?(b[l+1>>0]|0)==-69:0)?(b[l+2>>0]|0)==-65:0)f[e>>2]=l+3;l=i;a:while(1){a=f[e>>2]|0;m=a>>>0<c>>>0;if(!m){n=40;break}o=f[j>>2]|0;if(o>>>0>=i>>>0){n=40;break}p=b[a>>0]|0;q=p&255;if(q>>>0>k>>>0){r=2;break}s=a+1|0;do if(p<<24>>24>-1){d[o>>1]=p&255;t=s}else{if((p&255)<194){r=2;break a}u=g-a|0;v=a+2|0;if((p&255)<224){if((u|0)<2){r=1;break a}w=h[s>>0]|0;if((w&192|0)!=128){r=2;break a}x=w&63|q<<6&1984;if(x>>>0>k>>>0){r=2;break a}d[o>>1]=x;t=v;break}x=a+3|0;if((p&255)<240){if((u|0)<3){r=1;break a}w=b[v>>0]|0;y=h[s>>0]|0;z=y&224;switch(p<<24>>24){case -32:{if((z|0)!=160){r=2;break a}break}case -19:{if((z|0)!=128){r=2;break a}break}default:if((y&192|0)!=128){r=2;break a}}z=w&255;if((z&192|0)!=128){r=2;break a}w=y<<6&4032|q<<12|z&63;if((w&65535)>>>0>k>>>0){r=2;break a}d[o>>1]=w;t=x;break}if((p&255)>=245){r=2;break a}if((u|0)<4){r=1;break a}u=b[s>>0]|0;w=b[v>>0]|0;v=b[x>>0]|0;x=u&255;switch(p<<24>>24){case -16:{if((u+112&255)>=48){r=2;break a}break}case -12:{if((x&240|0)!=128){r=2;break a}break}default:if((x&192|0)!=128){r=2;break a}}u=w&255;if((u&192|0)!=128){r=2;break a}w=v&255;if((w&192|0)!=128){r=2;break a}if((l-o|0)<4){r=1;break a}v=q&7;z=u<<6;y=w&63;if((x<<12&258048|v<<18|z&4032|y)>>>0>k>>>0){r=2;break a}d[o>>1]=x<<2&60|u>>>4&3|((x>>>4&3|v<<2)<<6)+16320|55296;v=o+2|0;f[j>>2]=v;d[v>>1]=y|z&960|56320;t=(f[e>>2]|0)+4|0}while(0);f[e>>2]=t;f[j>>2]=(f[j>>2]|0)+2}if((n|0)==40)r=m&1;return r|0}function pBc(a,c,e,g,h,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[e>>2]=a;f[i>>2]=g;a=h;if(l&2)if((a-g|0)<3)m=1;else{f[i>>2]=g+1;b[g>>0]=-17;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=-69;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=-65;n=4}else n=4;a:do if((n|0)==4){g=c;l=f[e>>2]|0;while(1){if(l>>>0>=c>>>0){m=0;break a}h=d[l>>1]|0;o=h&65535;if(o>>>0>k>>>0){m=2;break a}do if((h&65535)<128){p=f[i>>2]|0;if((a-p|0)<1){m=1;break a}f[i>>2]=p+1;b[p>>0]=h}else{p=o&63;q=(p|128)&255;if((h&65535)<2048){r=f[i>>2]|0;if((a-r|0)<2){m=1;break a}f[i>>2]=r+1;b[r>>0]=o>>>6|192;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=q;break}r=(o>>>12|224)&255;s=(o>>>6&63|128)&255;if((h&65535)<55296){t=f[i>>2]|0;if((a-t|0)<3){m=1;break a}f[i>>2]=t+1;b[t>>0]=r;t=f[i>>2]|0;f[i>>2]=t+1;b[t>>0]=s;t=f[i>>2]|0;f[i>>2]=t+1;b[t>>0]=q;break}if((h&65535)>=56320){if((h&65535)<57344){m=2;break a}t=f[i>>2]|0;if((a-t|0)<3){m=1;break a}f[i>>2]=t+1;b[t>>0]=r;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=s;s=f[i>>2]|0;f[i>>2]=s+1;b[s>>0]=q;break}if((g-l|0)<4){m=1;break a}q=l+2|0;s=j[q>>1]|0;if((s&64512|0)!=56320){m=2;break a}if((a-(f[i>>2]|0)|0)<4){m=1;break a}r=o&960;if(((r<<10)+65536|p<<10|s&1023)>>>0>k>>>0){m=2;break a}f[e>>2]=q;q=(r>>>6)+1|0;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=q>>>2|240;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=o>>>2&15|q<<4&48|128;q=f[i>>2]|0;f[i>>2]=q+1;b[q>>0]=o<<4&48|s>>>6&15|128;q=f[i>>2]|0;f[i>>2]=q+1;b[q>>0]=s&63|128}while(0);o=(f[e>>2]|0)+2|0;f[e>>2]=o;l=o}}while(0);return m|0}function qBc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=184924;b=a+8|0;c=a+12|0;d=0;while(1){e=f[b>>2]|0;if(d>>>0>=(f[c>>2]|0)-e>>2>>>0)break;g=f[e+(d<<2)>>2]|0;if(g|0)SDc(g)|0;d=d+1|0}hEc(a+144|0);sBc(b);nvc(a);return}function rBc(a){a=a|0;qBc(a);YDc(a);return}function sBc(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;do if(c|0){d=a+4|0;e=f[d>>2]|0;while(1){if((e|0)==(c|0))break;g=e+-4|0;f[d>>2]=g;e=g}if((a+16|0)==(c|0)){b[a+128>>0]=0;break}else{YDc(c);break}}while(0);return}function tBc(a){a=a|0;var c=0;f[a>>2]=184944;c=f[a+8>>2]|0;if(c|0?b[a+12>>0]|0:0)ZDc(c);nvc(a);return}function uBc(a){a=a|0;tBc(a);YDc(a);return}function vBc(a,b){a=a|0;b=b|0;var c=0;if(b<<24>>24>-1){a=(EBc()|0)+((b&255)<<2)|0;c=f[a>>2]&255}else c=b;return c|0}function wBc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;a=c;while(1){if((a|0)==(d|0))break;c=b[a>>0]|0;if(c<<24>>24>-1){e=EBc()|0;g=f[e+(b[a>>0]<<2)>>2]&255}else g=c;b[a>>0]=g;a=a+1|0}return d|0}function xBc(a,b){a=a|0;b=b|0;var c=0;if(b<<24>>24>-1){a=(DBc()|0)+(b<<24>>24<<2)|0;c=f[a>>2]&255}else c=b;return c|0}function yBc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;a=c;while(1){if((a|0)==(d|0))break;c=b[a>>0]|0;if(c<<24>>24>-1){e=DBc()|0;g=f[e+(b[a>>0]<<2)>>2]&255}else g=c;b[a>>0]=g;a=a+1|0}return d|0}function zBc(a,b){a=a|0;b=b|0;return b|0}function ABc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=e;e=c;while(1){if((e|0)==(d|0))break;b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}return d|0}function BBc(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function CBc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;a=f;f=c;while(1){if((f|0)==(d|0))break;c=b[f>>0]|0;b[a>>0]=c<<24>>24>-1?c:e;a=a+1|0;f=f+1|0}return d|0}function DBc(){var a=0;a=Src()|0;return f[a>>2]|0}function EBc(){var a=0;a=Rrc()|0;return f[a>>2]|0}function FBc(){var a=0;a=Qrc()|0;return f[a>>2]|0}function GBc(a){a=a|0;f[a>>2]=184996;hEc(a+12|0);nvc(a);return}function HBc(a){a=a|0;GBc(a);YDc(a);return}function IBc(a){a=a|0;return b[a+8>>0]|0}function JBc(a){a=a|0;return b[a+9>>0]|0}function KBc(a,b){a=a|0;b=b|0;fEc(a,b+12|0);return}function LBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=Ztc(519053)|0;if(e>>>0>4294967279)dEc(a);if(e>>>0<11){b[a+11>>0]=e;g=a}else{h=e+16&-16;i=VDc(h)|0;f[a>>2]=i;f[a+8>>2]=h|-2147483648;f[a+4>>2]=e;g=i}etc(g,519053,e)|0;b[d>>0]=0;_tc(g+e|0,d);u=c;return}function MBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=Ztc(519047)|0;if(e>>>0>4294967279)dEc(a);if(e>>>0<11){b[a+11>>0]=e;g=a}else{h=e+16&-16;i=VDc(h)|0;f[a>>2]=i;f[a+8>>2]=h|-2147483648;f[a+4>>2]=e;g=i}etc(g,519047,e)|0;b[d>>0]=0;_tc(g+e|0,d);u=c;return}function NBc(a){a=a|0;f[a>>2]=185036;hEc(a+16|0);nvc(a);return}function OBc(a){a=a|0;NBc(a);YDc(a);return}function PBc(a){a=a|0;return f[a+8>>2]|0}function QBc(a){a=a|0;return f[a+12>>2]|0}function RBc(a,b){a=a|0;b=b|0;fEc(a,b+16|0);return}function SBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=tyc(185092)|0;if(e>>>0>1073741807)dEc(a);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)tf();else{h=VDc(g<<2)|0;f[a>>2]=h;f[a+8>>2]=g|-2147483648;f[a+4>>2]=e;i=h;break}}else{b[a+8+3>>0]=e;i=a}while(0);wtc(i,185092,e)|0;f[d>>2]=0;tvc(i+(e<<2)|0,d);u=c;return}function TBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=tyc(185068)|0;if(e>>>0>1073741807)dEc(a);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)tf();else{h=VDc(g<<2)|0;f[a>>2]=h;f[a+8>>2]=g|-2147483648;f[a+4>>2]=e;i=h;break}}else{b[a+8+3>>0]=e;i=a}while(0);wtc(i,185068,e)|0;f[d>>2]=0;tvc(i+(e<<2)|0,d);u=c;return}function UBc(a){a=a|0;nvc(a);YDc(a);return}function VBc(a){a=a|0;nvc(a);YDc(a);return}function WBc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0;if(c>>>0<128){a=(FBc()|0)+(c<<1)|0;e=(d[a>>1]&b)<<16>>16!=0}else e=0;return e|0}function XBc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=e;e=b;while(1){if((e|0)==(c|0))break;if((f[e>>2]|0)>>>0<128){b=FBc()|0;g=j[b+(f[e>>2]<<1)>>1]|0}else g=0;d[a>>1]=g;a=a+2|0;e=e+4|0}return c|0}function YBc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=c;while(1){if((a|0)==(e|0)){g=e;break}if((f[a>>2]|0)>>>0<128?(c=FBc()|0,(d[c+(f[a>>2]<<1)>>1]&b)<<16>>16):0){g=a;break}a=a+4|0}return g|0}function ZBc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=c;while(1){if((a|0)==(e|0)){g=e;break}if((f[a>>2]|0)>>>0>=128){g=a;break}c=FBc()|0;if(!((d[c+(f[a>>2]<<1)>>1]&b)<<16>>16)){g=a;break}a=a+4|0}return g|0}function _Bc(a,b){a=a|0;b=b|0;var c=0;if(b>>>0<128){a=(EBc()|0)+(b<<2)|0;c=f[a>>2]|0}else c=b;return c|0}function $Bc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=b;while(1){if((a|0)==(c|0))break;b=f[a>>2]|0;if(b>>>0<128){d=EBc()|0;e=f[d+(f[a>>2]<<2)>>2]|0}else e=b;f[a>>2]=e;a=a+4|0}return c|0}function aCc(a,b){a=a|0;b=b|0;var c=0;if(b>>>0<128){a=(DBc()|0)+(b<<2)|0;c=f[a>>2]|0}else c=b;return c|0}function bCc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=b;while(1){if((a|0)==(c|0))break;b=f[a>>2]|0;if(b>>>0<128){d=DBc()|0;e=f[d+(f[a>>2]<<2)>>2]|0}else e=b;f[a>>2]=e;a=a+4|0}return c|0}function cCc(a,b){a=a|0;b=b|0;return b<<24>>24|0}function dCc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=e;e=c;while(1){if((e|0)==(d|0))break;f[a>>2]=b[e>>0];a=a+4|0;e=e+1|0}return d|0}function eCc(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function fCc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=(d-c|0)>>>2;h=g;g=c;while(1){if((g|0)==(d|0))break;i=f[g>>2]|0;b[h>>0]=i>>>0<128?i&255:e;h=h+1|0;g=g+4|0}return c+(a<<2)|0}function gCc(a){a=a|0;nvc(a);YDc(a);return}function hCc(a){a=a|0;nvc(a);YDc(a);return}function iCc(a){a=a|0;nvc(a);YDc(a);return}function jCc(a){a=a|0;f[a>>2]=185352;return}function kCc(a){a=a|0;f[a>>2]=185388;return}function lCc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;f[a+4>>2]=e+-1;f[a>>2]=184944;e=a+8|0;f[e>>2]=c;b[a+12>>0]=d&1;if(!c){c=FBc()|0;f[e>>2]=c}return}function mCc(a){a=a|0;tf()}function nCc(a){a=a|0;tf()}function oCc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a+4>>2]=c+-1;f[a>>2]=184924;c=a+8|0;pCc(c,28);g=a+144|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=Ztc(514965)|0;if(h>>>0>4294967279)dEc(g);if(h>>>0<11){b[g+11>>0]=h;i=g}else{j=h+16&-16;k=VDc(j)|0;f[g>>2]=k;f[a+152>>2]=j|-2147483648;f[a+148>>2]=h;i=k}etc(i,514965,h)|0;b[e>>0]=0;_tc(i+h|0,e);e=f[c>>2]|0;c=a+12|0;h=f[c>>2]|0;while(1){if((h|0)==(e|0))break;i=h+-4|0;f[c>>2]=i;h=i}qCc();rCc(a,529520);sCc();tCc(a,529528);uCc();vCc(a,529536);wCc();xCc(a,529552);yCc();zCc(a,529560);ACc();BCc(a,529568);CCc();DCc(a,529584);ECc();FCc(a,529592);GCc();HCc(a,529600);ICc();JCc(a,529624);KCc();LCc(a,529656);MCc();NCc(a,529664);OCc();PCc(a,529672);QCc();RCc(a,529680);SCc();TCc(a,529688);UCc();VCc(a,529696);WCc();XCc(a,529704);YCc();ZCc(a,529712);_Cc();$Cc(a,529720);aDc();bDc(a,529728);cDc();dDc(a,529736);eDc();fDc(a,529744);gDc();hDc(a,529752);iDc();jDc(a,529768);kDc();lDc(a,529784);mDc();nDc(a,529800);oDc();pDc(a,529816);qDc();rDc(a,529824);u=d;return}function pCc(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+128>>0]=0;if(c|0){EDc(a,c);vDc(a,c)}return}function qCc(){f[132381]=0;f[132380]=182588;return}function rCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885224)|0);return}function sCc(){f[132383]=0;f[132382]=182620;return}function tCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885232)|0);return}function uCc(){lCc(529536,0,0,1);return}function vCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885240)|0);return}function wCc(){f[132389]=0;f[132388]=185140;return}function xCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885272)|0);return}function yCc(){f[132391]=0;f[132390]=185208;return}function zCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(887032)|0);return}function ACc(){DDc(529568,1);return}function BCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(887040)|0);return}function CCc(){f[132397]=0;f[132396]=185256;return}function DCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(887048)|0);return}function ECc(){f[132399]=0;f[132398]=185304;return}function FCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(887056)|0);return}function GCc(){CDc(529600,1);return}function HCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885256)|0);return}function ICc(){BDc(529624,1);return}function JCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885280)|0);return}function KCc(){f[132415]=0;f[132414]=182652;return}function LCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885264)|0);return}function MCc(){f[132417]=0;f[132416]=182716;return}function NCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885288)|0);return}function OCc(){f[132419]=0;f[132418]=182780;return}function PCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885296)|0);return}function QCc(){f[132421]=0;f[132420]=182832;return}function RCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(885304)|0);return}function SCc(){f[132423]=0;f[132422]=184380;return}function TCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886952)|0);return}function UCc(){f[132425]=0;f[132424]=184436;return}function VCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886960)|0);return}function WCc(){f[132427]=0;f[132426]=184492;return}function XCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886968)|0);return}function YCc(){f[132429]=0;f[132428]=184548;return}function ZCc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886976)|0);return}function _Cc(){f[132431]=0;f[132430]=184604;return}function $Cc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886984)|0);return}function aDc(){f[132433]=0;f[132432]=184632;return}function bDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886992)|0);return}function cDc(){f[132435]=0;f[132434]=184660;return}function dDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(887e3)|0);return}function eDc(){f[132437]=0;f[132436]=184688;return}function fDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(887008)|0);return}function gDc(){f[132439]=0;f[132438]=185120;jCc(529760);f[132438]=182884;f[132440]=182932;return}function hDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886116)|0);return}function iDc(){f[132443]=0;f[132442]=185120;kCc(529776);f[132442]=182968;f[132444]=183016;return}function jDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886928)|0);return}function kDc(){var a=0;f[132447]=0;f[132446]=185120;a=Kvc()|0;f[132448]=a;f[132446]=184332;return}function lDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886936)|0);return}function mDc(){var a=0;f[132451]=0;f[132450]=185120;a=Kvc()|0;f[132452]=a;f[132450]=184356;return}function nDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(886944)|0);return}function oDc(){f[132455]=0;f[132454]=184716;return}function pDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(887016)|0);return}function qDc(){f[132457]=0;f[132456]=184748;return}function rDc(a,b){a=a|0;b=b|0;sDc(a,b,Mvc(887024)|0);return}function sDc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;QDc(b);d=a+8|0;e=f[d>>2]|0;if((f[a+12>>2]|0)-e>>2>>>0>c>>>0){g=d;h=e}else{tDc(d,c+1|0);g=d;h=f[d>>2]|0}d=f[h+(c<<2)>>2]|0;if(d|0)SDc(d)|0;f[(f[g>>2]|0)+(c<<2)>>2]=b;return}function tDc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>2;h=e;e=d;a:do if(g>>>0>=b>>>0){if(g>>>0>b>>>0){d=h+(b<<2)|0;i=e;while(1){if((i|0)==(d|0))break a;j=i+-4|0;f[c>>2]=j;i=j}}}else uDc(a,b-g|0);while(0);return}function uDc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+8|0;g=a+4|0;h=f[g>>2]|0;do if((f[e>>2]|0)-h>>2>>>0<b>>>0){i=(h-(f[a>>2]|0)>>2)+b|0;j=wDc(a)|0;if(j>>>0<i>>>0)mCc(a);else{k=f[a>>2]|0;l=(f[e>>2]|0)-k|0;m=l>>1;xDc(d,l>>2>>>0<j>>>1>>>0?(m>>>0<i>>>0?i:m):j,(f[g>>2]|0)-k>>2,a+16|0);yDc(d,b);zDc(a,d);ADc(d);break}}else vDc(a,b);while(0);u=c;return}function vDc(a,b){a=a|0;b=b|0;var c=0;c=a+4|0;a=b;b=f[c>>2]|0;do{f[b>>2]=0;b=(f[c>>2]|0)+4|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function wDc(a){a=a|0;return 1073741823}function xDc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;f[a+12>>2]=0;f[a+16>>2]=e;do if(c){g=e+112|0;if(c>>>0<29&(b[g>>0]|0)==0){b[g>>0]=1;h=e;break}else{h=VDc(c<<2)|0;break}}else h=0;while(0);f[a>>2]=h;e=h+(d<<2)|0;f[a+8>>2]=e;f[a+4>>2]=e;f[a+12>>2]=h+(c<<2);return}function yDc(a,b){a=a|0;b=b|0;var c=0;c=a+8|0;a=b;b=f[c>>2]|0;do{f[b>>2]=0;b=(f[c>>2]|0)+4|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function zDc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=(f[d>>2]|0)-c|0;h=(f[e>>2]|0)+(0-(g>>2)<<2)|0;f[e>>2]=h;if((g|0)>0){dJc(h|0,c|0,g|0)|0;i=e;j=f[e>>2]|0}else{i=e;j=h}h=f[a>>2]|0;f[a>>2]=j;f[i>>2]=h;h=b+8|0;j=f[d>>2]|0;f[d>>2]=f[h>>2];f[h>>2]=j;j=a+8|0;a=b+12|0;h=f[j>>2]|0;f[j>>2]=f[a>>2];f[a>>2]=h;f[b>>2]=f[i>>2];return}function ADc(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a+4>>2]|0;d=a+8|0;e=f[d>>2]|0;while(1){if((e|0)==(c|0))break;g=e+-4|0;f[d>>2]=g;e=g}e=f[a>>2]|0;do if(e|0){d=f[a+16>>2]|0;if((d|0)==(e|0)){b[d+112>>0]=0;break}else{YDc(e);break}}while(0);return}function BDc(a,b){a=a|0;b=b|0;f[a+4>>2]=b+-1;f[a>>2]=185036;f[a+8>>2]=46;f[a+12>>2]=44;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[b+(a<<2)>>2]=0;a=a+1|0}return}function CDc(a,c){a=a|0;c=c|0;f[a+4>>2]=c+-1;f[a>>2]=184996;b[a+8>>0]=46;b[a+9>>0]=44;c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function DDc(a,b){a=a|0;b=b|0;f[a+4>>2]=b+-1;f[a>>2]=184876;b=Kvc()|0;f[a+8>>2]=b;return}function EDc(a,c){a=a|0;c=c|0;var d=0,e=0;if((wDc(a)|0)>>>0<c>>>0)mCc(a);d=a+128|0;if(c>>>0<29&(b[d>>0]|0)==0){b[d>>0]=1;e=a+16|0}else e=VDc(c<<2)|0;f[a+4>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(c<<2);return}function FDc(){if((b[529832]|0)==0?MIc(529832)|0:0){GDc()|0;f[221767]=887064}return f[221767]|0}function GDc(){HDc();f[221766]=529840;return 887064}function HDc(){oCc(529840,1);return}function IDc(){JDc(887072,FDc()|0);return 887072}function JDc(a,b){a=a|0;b=b|0;var c=0;c=f[b>>2]|0;f[a>>2]=c;QDc(c);return}function KDc(){if((b[53e4]|0)==0?MIc(53e4)|0:0){IDc()|0;f[221769]=887072}return f[221769]|0}function LDc(a){a=a|0;var b=0,c=0;b=KDc()|0;c=f[b>>2]|0;f[a>>2]=c;QDc(c);return}function MDc(a,b){a=a|0;b=b|0;var c=0;c=f[a>>2]|0;return NDc(c,Mvc(b)|0)|0}function NDc(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a+8>>2]|0;if((f[a+12>>2]|0)-c>>2>>>0>b>>>0)d=(f[c+(b<<2)>>2]|0)!=0;else d=0;return d|0}function ODc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=0;else d=Arc(a,b,c)|0;return d|0}function PDc(a){a=a|0;return}function QDc(a){a=a|0;RDc(a+4|0);return}function RDc(a){a=a|0;f[a>>2]=(f[a>>2]|0)+1;return}function SDc(a){a=a|0;var b=0;if((TDc(a+4|0)|0)==-1){Yi[f[(f[a>>2]|0)+8>>2]&2047](a);b=1}else b=0;return b|0}function TDc(a){a=a|0;var b=0;b=f[a>>2]|0;f[a>>2]=b+-1;return b+-1|0}function UDc(a,b,c){a=a|0;b=b|0;c=c|0;WIc(887080)|0;while(1){if((f[a>>2]|0)!=1)break;Cf(887108,887080)|0}if(!(f[a>>2]|0)){f[a>>2]=1;VIc(887080)|0;Yi[c&2047](b);WIc(887080)|0;f[a>>2]=-1;VIc(887080)|0;bJc(887108)|0}else VIc(887080)|0;return}function VDc(a){a=a|0;var b=0,c=0;b=(a|0)==0?1:a;while(1){a=ooc(b)|0;if(a|0){c=a;break}a=PIc()|0;if(!a){c=0;break}Ui[a&255]()}return c|0}function WDc(a,b){a=a|0;b=b|0;return VDc(a)|0}function XDc(a){a=a|0;return VDc(a)|0}function YDc(a){a=a|0;poc(a);return}function ZDc(a){a=a|0;YDc(a);return}function _Dc(){tf()}function $Dc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Mpc(b)|0;d=VDc(c+13|0)|0;f[d>>2]=c;f[d+4>>2]=c;f[d+8>>2]=0;e=aEc(d)|0;dJc(e|0,b|0,c+1|0)|0;f[a>>2]=e;return}function aEc(a){a=a|0;return a+12|0}function bEc(a,b){a=a|0;b=b|0;f[a>>2]=185512;$Dc(a+4|0,b);return}function cEc(a){a=a|0;return 1}function dEc(a){a=a|0;tf()}function eEc(a){a=a|0;tf()}function fEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if((b[c+11>>0]|0)<0){g=f[c>>2]|0;h=f[c+4>>2]|0;if(h>>>0>4294967279)dEc(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=VDc(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}etc(i,g,h)|0;b[e>>0]=0;_tc(i+h|0,e)}else{f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2]}u=d;return}function gEc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;i=b[c+11>>0]|0;j=i<<24>>24<0;k=j?f[c+4>>2]|0:i&255;if(k>>>0<d>>>0)eEc(a);i=(j?f[c>>2]|0:c)+d|0;c=k-d|0;d=c>>>0<e>>>0?c:e;if(d>>>0>4294967279)dEc(a);if(d>>>0<11){b[a+11>>0]=d;l=a}else{e=d+16&-16;c=VDc(e)|0;f[a>>2]=c;f[a+8>>2]=e|-2147483648;f[a+4>>2]=d;l=c}etc(l,i,d)|0;b[h>>0]=0;_tc(l+d|0,h);u=g;return}function hEc(a){a=a|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);return}function iEc(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)!=(c|0)){d=b[c+11>>0]|0;e=d<<24>>24<0;jEc(a,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)|0}return a|0}function jEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=(f[a+8>>2]&2147483647)+-1|0;else k=10;do if(k>>>0>=d>>>0){if(j)l=f[a>>2]|0;else l=a;kEc(l,c,d)|0;b[g>>0]=0;_tc(l+d|0,g);if((b[h>>0]|0)<0){f[a+4>>2]=d;break}else{b[h>>0]=d;break}}else{if(j)m=f[a+4>>2]|0;else m=i&255;lEc(a,k,d-k|0,m,0,m,d,c)}while(0);u=e;return a|0}function kEc(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)fJc(a|0,b|0,c|0)|0;return a|0}function lEc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+16|0;l=k;if((-18-c|0)>>>0<d>>>0)dEc(a);if((b[a+11>>0]|0)<0)m=f[a>>2]|0;else m=a;if(c>>>0<2147483623){n=d+c|0;d=c<<1;o=n>>>0<d>>>0?d:n;p=o>>>0<11?11:o+16&-16}else p=-17;o=VDc(p)|0;if(g|0)etc(o,m,g)|0;if(i|0)etc(o+g|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)etc(o+g+i|0,m+g+h|0,e)|0;if((c|0)!=10)YDc(m);f[a>>2]=o;f[a+8>>2]=p|-2147483648;p=j+i|0;f[a+4>>2]=p;b[l>>0]=0;_tc(o+p|0,l);u=k;return}function mEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(c>>>0>4294967279)dEc(a);d=a+11|0;e=b[d>>0]|0;g=e<<24>>24<0;if(g){h=f[a+4>>2]|0;i=(f[a+8>>2]&2147483647)+-1|0}else{h=e&255;i=10}j=h>>>0>c>>>0?h:c;c=j>>>0<11;k=c?10:(j+16&-16)+-1|0;do if((k|0)!=(i|0)){do if(c){j=f[a>>2]|0;if(g){l=0;m=j;n=a;o=13}else{etc(a,j,(e&255)+1|0)|0;YDc(j);o=15}}else{j=VDc(k+1|0)|0;if(g){l=1;m=f[a>>2]|0;n=j;o=13;break}else{etc(j,a,(e&255)+1|0)|0;p=j;o=14;break}}while(0);if((o|0)==13){etc(n,m,(f[a+4>>2]|0)+1|0)|0;YDc(m);if(l){p=n;o=14}else o=15}if((o|0)==14){f[a+8>>2]=k+1|-2147483648;f[a+4>>2]=h;f[a>>2]=p;break}else if((o|0)==15){b[d>>0]=h;break}}while(0);return}function nEc(a,b){a=a|0;b=b|0;return jEc(a,b,Ztc(b)|0)|0}function oEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=f[a+4>>2]|0;else k=i&255;do if(k>>>0>=c>>>0)if(j){i=(f[a>>2]|0)+c|0;b[g>>0]=0;_tc(i,g);f[a+4>>2]=c;break}else{b[g>>0]=0;_tc(a+c|0,g);b[h>>0]=c;break}else pEc(a,c-k|0,d)|0;while(0);u=e;return}function pEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if(c|0){h=a+11|0;i=b[h>>0]|0;if(i<<24>>24<0){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=i&255;k=10}l=j+c|0;if((k-j|0)>>>0<c>>>0){qEc(a,k,l-k|0,j,j,0,0);m=b[h>>0]|0}else m=i;if(m<<24>>24<0)n=f[a>>2]|0;else n=a;mzc(n+j|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=l;else b[h>>0]=l;b[g>>0]=0;_tc(n+l|0,g)}u=e;return a|0}function qEc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;if((-17-c|0)>>>0<d>>>0)dEc(a);if((b[a+11>>0]|0)<0)j=f[a>>2]|0;else j=a;if(c>>>0<2147483623){k=d+c|0;d=c<<1;l=k>>>0<d>>>0?d:k;m=l>>>0<11?11:l+16&-16}else m=-17;l=VDc(m)|0;if(g|0)etc(l,j,g)|0;k=e-h-g|0;if(k|0)etc(l+g+i|0,j+g+h|0,k)|0;if((c|0)!=10)YDc(j);f[a>>2]=l;f[a+8>>2]=m|-2147483648;return}function rEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=b[a+11>>0]|0;e=d<<24>>24<0;if(e)g=f[a+4>>2]|0;else g=d&255;if(g>>>0<=c>>>0)eEc(a);if(e)h=f[a>>2]|0;else h=a;return h+c|0}function sEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=b[a+11>>0]|0;e=d<<24>>24<0;if(e)g=f[a+4>>2]|0;else g=d&255;if(g>>>0<=c>>>0)eEc(a);if(e)h=f[a>>2]|0;else h=a;return h+c|0}function tEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[a+8>>2]&2147483647)+-1|0}else{k=i&255;l=10}i=k+d|0;if((l-k|0)>>>0>=d>>>0){if(d|0){if(j)m=f[a>>2]|0;else m=a;etc(m+k|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=i;else b[h>>0]=i;b[g>>0]=0;_tc(m+i|0,g)}}else lEc(a,l,i-l|0,k,k,0,d,c);u=e;return a|0}function uEc(a,b){a=a|0;b=b|0;return tEc(a,b,Ztc(b)|0)|0}function vEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=d+1|0;b[e>>0]=c;c=a+11|0;h=b[c>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=10}if((j|0)==(k|0)){qEc(a,k,1,k,k,0,0);h=k+1|0;if((b[c>>0]|0)<0){l=h;m=8}else{n=h;m=7}}else{h=j+1|0;if(i){l=h;m=8}else{n=h;m=7}}if((m|0)==7){b[c>>0]=n;o=a}else if((m|0)==8){m=f[a>>2]|0;f[a+4>>2]=l;o=m}m=o+j|0;_tc(m,e);b[g>>0]=0;_tc(m+1|0,g);u=d;return}function wEc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=b[c+11>>0]|0;h=g<<24>>24<0;i=h?f[c+4>>2]|0:g&255;if(i>>>0<d>>>0)eEc(a);else{g=i-d|0;return tEc(a,(h?f[c>>2]|0:c)+d|0,g>>>0<e>>>0?g:e)|0}return 0}function xEc(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function yEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=f[a+4>>2]|0;else k=i&255;if(k>>>0<c>>>0)eEc(a);if(d|0){if(j)l=f[a>>2]|0;else l=a;j=k-c|0;m=j>>>0<d>>>0?j:d;d=j-m|0;if(!d)n=i;else{i=l+c|0;kEc(i,i+m|0,d)|0;n=b[h>>0]|0}d=k-m|0;if(n<<24>>24<0)f[a+4>>2]=d;else b[h>>0]=d;b[g>>0]=0;_tc(l+d|0,g)}u=e;return a|0}function zEc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+16|0;i=h;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l)m=f[a+4>>2]|0;else m=k&255;if(m>>>0<c>>>0)eEc(a);k=m-c|0;n=k>>>0<d>>>0?k:d;if(l)o=(f[a+8>>2]&2147483647)+-1|0;else o=10;if((n-m+o|0)>>>0<g>>>0)lEc(a,o,m+g-n-o|0,m,c,n,g,e);else{if(l)p=f[a>>2]|0;else p=a;do if((n|0)!=(g|0)){l=k-n|0;if(!l){q=n;r=c;s=e;t=g;v=21}else{o=p+c|0;if(n>>>0>g>>>0){kEc(o,e,g)|0;kEc(o+g|0,o+n|0,l)|0;w=n;x=g;break}do if(o>>>0<e>>>0&(p+m|0)>>>0>e>>>0)if((o+n|0)>>>0>e>>>0){kEc(o,e,n)|0;y=n+c|0;z=e+g|0;A=g-n|0;B=0;break}else{y=c;z=e+(g-n)|0;A=g;B=n;break}else{y=c;z=e;A=g;B=n}while(0);o=p+y|0;kEc(o+A|0,o+B|0,l)|0;q=B;r=y;s=z;t=A;v=21}}else{q=g;r=c;s=e;t=g;v=21}while(0);if((v|0)==21){kEc(p+r|0,s,t)|0;w=q;x=t}t=x-w+m|0;if((b[j>>0]|0)<0)f[a+4>>2]=t;else b[j>>0]=t;b[i>>0]=0;_tc(p+t|0,i)}u=h;return a|0}function AEc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return zEc(a,b,c,d,Ztc(d)|0)|0}function BEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;if(!c)e=0;else e=Zoc(a,dtc(b[d>>0]|0)|0,c)|0;return e|0}function CEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=b[a+11>>0]|0;if(h<<24>>24<0){i=f[a+4>>2]|0;j=f[a>>2]|0}else{i=h&255;j=a}b[g>>0]=c;if(i>>>0>d>>>0){c=BEc(j+d|0,i-d|0,g)|0;k=(c|0)==0?-1:c-j|0}else k=-1;u=e;return k|0}function DEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=b[a+11>>0]|0;if(e<<24>>24<0){g=f[a+4>>2]|0;h=f[a>>2]|0}else{g=e&255;h=a}a:do if(!g)i=-1;else{a=h+(g>>>0>d>>>0?d+1|0:g)|0;do{if((a|0)==(h|0)){i=-1;break a}a=a+-1|0}while(!(euc(b[a>>0]|0,c)|0));i=a-h|0}while(0);return i|0}function EEc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=b[a+11>>0]|0;i=h<<24>>24<0;if(i)j=f[a+4>>2]|0;else j=h&255;if((g|0)==-1|j>>>0<c>>>0)eEc(a);h=j-c|0;j=h>>>0<d>>>0?h:d;if(i)k=f[a>>2]|0;else k=a;a=j>>>0>g>>>0;i=ODc(k+c|0,e,a?g:j)|0;if(!i)return (j>>>0<g>>>0?-1:a&1)|0;else return i|0;return 0}function FEc(a){a=a|0;if((b[a+8+3>>0]|0)<0)YDc(f[a>>2]|0);return}function GEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;i=h+3|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=(f[h>>2]&2147483647)+-1|0;else l=1;do if(l>>>0>=d>>>0){if(k)m=f[a>>2]|0;else m=a;HEc(m,c,d)|0;f[g>>2]=0;tvc(m+(d<<2)|0,g);if((b[i>>0]|0)<0){f[a+4>>2]=d;break}else{b[i>>0]=d;break}}else{if(k)n=f[a+4>>2]|0;else n=j&255;IEc(a,l,d-l|0,n,0,n,d,c)}while(0);u=e;return a|0}function HEc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=a;else{Jrc(a,b,c)|0;d=a}return d|0}function IEc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=u;u=u+16|0;l=k;if((1073741806-c|0)>>>0<d>>>0)dEc(a);m=a+8|0;if((b[m+3>>0]|0)<0)n=f[a>>2]|0;else n=a;if(c>>>0<536870887){o=d+c|0;d=c<<1;p=o>>>0<d>>>0?d:o;o=p>>>0<2?2:p+4&-4;if(o>>>0>1073741823)tf();else q=o}else q=1073741807;o=VDc(q<<2)|0;if(g|0)wtc(o,n,g)|0;if(i|0)wtc(o+(g<<2)|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)wtc(o+(g<<2)+(i<<2)|0,n+(g<<2)+(h<<2)|0,e)|0;if((c|0)!=1)YDc(n);f[a>>2]=o;f[m>>2]=q|-2147483648;q=j+i|0;f[a+4>>2]=q;f[l>>2]=0;tvc(o+(q<<2)|0,l);u=k;return}function JEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(c>>>0>1073741807)dEc(a);d=a+8|0;e=d+3|0;g=b[e>>0]|0;h=g<<24>>24<0;if(h){i=f[a+4>>2]|0;j=(f[d>>2]&2147483647)+-1|0}else{i=g&255;j=1}k=i>>>0>c>>>0?i:c;c=k>>>0<2;l=c?1:(k+4&-4)+-1|0;do if((l|0)!=(j|0)){do if(c){k=f[a>>2]|0;if(h){m=0;n=k;o=a;p=15}else{wtc(a,k,(g&255)+1|0)|0;YDc(k);p=17}}else{k=l+1|0;if(k>>>0>1073741823)tf();q=VDc(k<<2)|0;if(h){m=1;n=f[a>>2]|0;o=q;p=15;break}else{wtc(q,a,(g&255)+1|0)|0;r=q;p=16;break}}while(0);if((p|0)==15){wtc(o,n,(f[a+4>>2]|0)+1|0)|0;YDc(n);if(m){r=o;p=16}else p=17}if((p|0)==16){f[d>>2]=l+1|-2147483648;f[a+4>>2]=i;f[a>>2]=r;break}else if((p|0)==17){b[e>>0]=i;break}}while(0);return}function KEc(a,b){a=a|0;b=b|0;return GEc(a,b,tyc(b)|0)|0}function LEc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;if((1073741807-c|0)>>>0<d>>>0)dEc(a);j=a+8|0;if((b[j+3>>0]|0)<0)k=f[a>>2]|0;else k=a;if(c>>>0<536870887){l=d+c|0;d=c<<1;m=l>>>0<d>>>0?d:l;l=m>>>0<2?2:m+4&-4;if(l>>>0>1073741823)tf();else n=l}else n=1073741807;l=VDc(n<<2)|0;if(g|0)wtc(l,k,g)|0;m=e-h-g|0;if(m|0)wtc(l+(g<<2)+(i<<2)|0,k+(g<<2)+(h<<2)|0,m)|0;if((c|0)!=1)YDc(k);f[a>>2]=l;f[j>>2]=n|-2147483648;return}function MEc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;i=h+3|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[h>>2]&2147483647)+-1|0}else{l=j&255;m=1}j=l+d|0;if((m-l|0)>>>0>=d>>>0){if(d|0){if(k)n=f[a>>2]|0;else n=a;wtc(n+(l<<2)|0,c,d)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;f[g>>2]=0;tvc(n+(j<<2)|0,g)}}else IEc(a,m,j-m|0,l,l,0,d,c);u=e;return a|0}function NEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=d+4|0;f[e>>2]=c;c=a+8|0;h=c+3|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[c>>2]&2147483647)+-1|0}else{k=i&255;l=1}if((k|0)==(l|0)){LEc(a,l,1,l,l,0,0);i=l+1|0;if((b[h>>0]|0)<0){m=i;n=8}else{o=i;n=7}}else{i=k+1|0;if(j){m=i;n=8}else{o=i;n=7}}if((n|0)==7){b[h>>0]=o;p=a}else if((n|0)==8){n=f[a>>2]|0;f[a+4>>2]=m;p=n}n=p+(k<<2)|0;tvc(n,e);f[g>>2]=0;tvc(n+4|0,g);u=d;return}function OEc(){var a=0,b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;b=a+32|0;c=a+24|0;d=a+16|0;e=a;g=a+36|0;a=PEc()|0;if(a|0?(h=f[a>>2]|0,h|0):0){a=h+48|0;i=f[a>>2]|0;j=f[a+4>>2]|0;if(!((i&-256|0)==1126902528&(j|0)==1129074247)){f[c>>2]=f[46355];QEc(517168,c)}if((i|0)==1126902529&(j|0)==1129074247)k=f[h+44>>2]|0;else k=h+80|0;f[g>>2]=k;k=f[h>>2]|0;h=f[k+4>>2]|0;j=hj[f[(f[5904]|0)+16>>2]&511](23616,k,g)|0;k=f[46355]|0;if(j){j=f[g>>2]|0;g=_i[f[(f[j>>2]|0)+8>>2]&1023](j)|0;f[e>>2]=k;f[e+4>>2]=h;f[e+8>>2]=g;QEc(517082,e)}else{f[d>>2]=k;f[d+4>>2]=h;QEc(517127,d)}}QEc(517206,b)}function PEc(){var a=0,b=0;a=u;u=u+16|0;if(!(Be(887156,180)|0)){b=Bf(f[221790]|0)|0;u=a;return b|0}else QEc(517357,a);return 0}function QEc(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=b;b=f[44350]|0;Qoc(b,a,d)|0;sqc(10,b)|0;tf()}function REc(a){a=a|0;return}function SEc(a){a=a|0;REc(a);YDc(a);return}function TEc(a){a=a|0;return}function UEc(a){a=a|0;return}function VEc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d;if(!(ZEc(a,b,0)|0))if((b|0)!=0?(g=bFc(b,23640,23624,0)|0,(g|0)!=0):0){b=e+4|0;h=b+52|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[e>>2]=g;f[e+8>>2]=a;f[e+12>>2]=-1;f[e+48>>2]=1;ei[f[(f[g>>2]|0)+28>>2]&511](g,e,f[c>>2]|0,1);if((f[e+24>>2]|0)==1){f[c>>2]=f[e+16>>2];i=1}else i=0;j=i}else j=0;else j=1;u=d;return j|0}function WEc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;if(ZEc(a,f[b+8>>2]|0,g)|0)aFc(0,b,c,d,e);return}function XEc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;do if(!(ZEc(a,f[c+8>>2]|0,g)|0)){if(ZEc(a,f[c>>2]|0,g)|0){h=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(i=c+20|0,(f[i>>2]|0)!=(d|0)):0){f[h>>2]=e;f[i>>2]=d;i=c+40|0;f[i>>2]=(f[i>>2]|0)+1;if((f[c+36>>2]|0)==1?(f[c+24>>2]|0)==2:0)b[c+54>>0]=1;f[c+44>>2]=4;break}if((e|0)==1)f[h>>2]=1}}else $Ec(0,c,d,e);while(0);return}function YEc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(ZEc(a,f[b+8>>2]|0,0)|0)_Ec(0,b,c,d);return}function ZEc(a,b,c){a=a|0;b=b|0;c=c|0;return (a|0)==(b|0)|0}function _Ec(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a=c+16|0;g=f[a>>2]|0;h=c+36|0;i=c+24|0;do if(g){if((g|0)!=(d|0)){f[h>>2]=(f[h>>2]|0)+1;f[i>>2]=2;b[c+54>>0]=1;break}if((f[i>>2]|0)==2)f[i>>2]=e}else{f[a>>2]=d;f[i>>2]=e;f[h>>2]=1}while(0);return}function $Ec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((f[b+4>>2]|0)==(c|0)?(c=b+28|0,(f[c>>2]|0)!=1):0)f[c>>2]=d;return}function aFc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;b[c+53>>0]=1;do if((f[c+4>>2]|0)==(e|0)){b[c+52>>0]=1;a=c+16|0;h=f[a>>2]|0;i=c+54|0;j=c+48|0;k=c+24|0;l=c+36|0;if(!h){f[a>>2]=d;f[k>>2]=g;f[l>>2]=1;if(!((f[j>>2]|0)==1&(g|0)==1))break;b[i>>0]=1;break}if((h|0)!=(d|0)){f[l>>2]=(f[l>>2]|0)+1;b[i>>0]=1;break}l=f[k>>2]|0;if((l|0)==2){f[k>>2]=g;m=g}else m=l;if((f[j>>2]|0)==1&(m|0)==1)b[i>>0]=1}while(0);return}function bFc(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+64|0;i=h;j=f[a>>2]|0;k=a+(f[j+-8>>2]|0)|0;l=f[j+-4>>2]|0;f[i>>2]=e;f[i+4>>2]=a;f[i+8>>2]=c;f[i+12>>2]=g;g=i+16|0;c=i+20|0;a=i+24|0;j=i+28|0;m=i+32|0;n=i+40|0;o=g;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));d[g+36>>1]=0;b[g+38>>0]=0;a:do if(ZEc(l,e,0)|0){f[i+48>>2]=1;Fh[f[(f[l>>2]|0)+20>>2]&255](l,i,k,k,1,0);q=(f[a>>2]|0)==1?k:0}else{gi[f[(f[l>>2]|0)+24>>2]&255](l,i,k,1,0);switch(f[i+36>>2]|0){case 0:{q=(f[n>>2]|0)==1&(f[j>>2]|0)==1&(f[m>>2]|0)==1?f[c>>2]|0:0;break a;break}case 1:break;default:{q=0;break a}}if((f[a>>2]|0)!=1?!((f[n>>2]|0)==0&(f[j>>2]|0)==1&(f[m>>2]|0)==1):0){q=0;break}q=f[g>>2]|0}while(0);u=h;return q|0}function cFc(a){a=a|0;REc(a);YDc(a);return}function dFc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;if(ZEc(a,f[b+8>>2]|0,g)|0)aFc(0,b,c,d,e);else{h=f[a+8>>2]|0;Fh[f[(f[h>>2]|0)+20>>2]&255](h,b,c,d,e,g)}return}function eFc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;do if(!(ZEc(a,f[c+8>>2]|0,g)|0)){h=a+8|0;if(!(ZEc(a,f[c>>2]|0,g)|0)){i=f[h>>2]|0;gi[f[(f[i>>2]|0)+24>>2]&255](i,c,d,e,g);break}i=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(j=c+20|0,(f[j>>2]|0)!=(d|0)):0){f[i>>2]=e;k=c+44|0;if((f[k>>2]|0)==4)break;l=c+52|0;b[l>>0]=0;m=c+53|0;b[m>>0]=0;n=f[h>>2]|0;Fh[f[(f[n>>2]|0)+20>>2]&255](n,c,d,d,1,g);if(b[m>>0]|0)if(!(b[l>>0]|0)){o=3;p=11}else q=3;else{o=4;p=11}if((p|0)==11){f[j>>2]=d;j=c+40|0;f[j>>2]=(f[j>>2]|0)+1;if((f[c+36>>2]|0)==1?(f[c+24>>2]|0)==2:0){b[c+54>>0]=1;q=o}else q=o}f[k>>2]=q;break}if((e|0)==1)f[i>>2]=1}else $Ec(0,c,d,e);while(0);return}function fFc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(ZEc(a,f[b+8>>2]|0,0)|0)_Ec(0,b,c,d);else{e=f[a+8>>2]|0;ei[f[(f[e>>2]|0)+28>>2]&511](e,b,c,d)}return}function gFc(a){a=a|0;return}function hFc(){var a=0;a=u;u=u+16|0;if(!(nf(887160,1804)|0)){u=a;return}else QEc(517406,a)}function iFc(a){a=a|0;var b=0;b=u;u=u+16|0;poc(a);if(!(fg(f[221790]|0,0)|0)){u=b;return}else QEc(517456,b)}function jFc(){var a=0,b=0;a=PEc()|0;if((a|0?(b=f[a>>2]|0,b|0):0)?(a=b+48|0,(f[a>>2]&-256|0)==1126902528?(f[a+4>>2]|0)==1129074247:0):0)kFc(f[b+12>>2]|0);kFc(lFc()|0)}function kFc(a){a=a|0;var b=0;b=u;u=u+16|0;Ui[a&255]();QEc(517509,b)}function lFc(){var a=0;a=f[46354]|0;f[46354]=a+0;return a|0}function mFc(a){a=a|0;return}function nFc(a){a=a|0;f[a>>2]=185512;rFc(a+4|0);return}function oFc(a){a=a|0;nFc(a);YDc(a);return}function pFc(a){a=a|0;return qFc(a+4|0)|0}function qFc(a){a=a|0;return f[a>>2]|0}function rFc(a){a=a|0;var b=0,c=0;if(cEc(a)|0?(b=sFc(f[a>>2]|0)|0,a=b+8|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c+-1|0)<0):0)YDc(b);return}function sFc(a){a=a|0;return a+-12|0}function tFc(a){a=a|0;nFc(a);YDc(a);return}function uFc(a){a=a|0;nFc(a);YDc(a);return}function vFc(a){a=a|0;return}function wFc(a){a=a|0;vFc(a);YDc(a);return}function xFc(a){a=a|0;return 517599}function yFc(a){a=a|0;REc(a);YDc(a);return}function zFc(a,b,c){a=a|0;b=b|0;c=c|0;return ZEc(a,b,0)|0}function AFc(a){a=a|0;REc(a);YDc(a);return}function BFc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d;f[c>>2]=f[f[c>>2]>>2];if(!(CFc(a,b,0)|0))if(((b|0)!=0?(g=bFc(b,23640,23760,0)|0,(g|0)!=0):0)?(f[g+8>>2]&~f[a+8>>2]|0)==0:0){b=a+12|0;a=g+12|0;if(!(ZEc(f[b>>2]|0,f[a>>2]|0,0)|0)?!(ZEc(f[b>>2]|0,23792,0)|0):0){g=f[b>>2]|0;if((((g|0)!=0?(b=bFc(g,23640,23624,0)|0,(b|0)!=0):0)?(g=f[a>>2]|0,(g|0)!=0):0)?(a=bFc(g,23640,23624,0)|0,(a|0)!=0):0){g=e+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=a;f[e+8>>2]=b;f[e+12>>2]=-1;f[e+48>>2]=1;ei[f[(f[a>>2]|0)+28>>2]&511](a,e,f[c>>2]|0,1);if((f[e+24>>2]|0)==1){f[c>>2]=f[e+16>>2];i=1}else i=0;j=i}else j=0}else j=1}else j=0;else j=1;u=d;return j|0}function CFc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(ZEc(a,b,0)|0)d=1;else d=ZEc(b,23800,0)|0;return d|0}function DFc(a){a=a|0;REc(a);YDc(a);return}function EFc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(ZEc(a,f[c+8>>2]|0,h)|0)aFc(0,c,d,e,g);else{i=c+52|0;j=b[i>>0]|0;k=c+53|0;l=b[k>>0]|0;m=f[a+12>>2]|0;n=a+16+(m<<3)|0;b[i>>0]=0;b[k>>0]=0;IFc(a+16|0,c,d,e,g,h);a:do if((m|0)>1){o=c+24|0;p=c+54|0;q=a+8|0;r=a+24|0;do{if(b[p>>0]|0)break a;if(!(b[i>>0]|0)){if(b[k>>0]|0?(f[q>>2]&1|0)==0:0)break a}else{if((f[o>>2]|0)==1)break a;if(!(f[q>>2]&2))break a}b[i>>0]=0;b[k>>0]=0;IFc(r,c,d,e,g,h);r=r+8|0}while(r>>>0<n>>>0)}while(0);b[i>>0]=j;b[k>>0]=l}return}function FFc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a:do if(!(ZEc(a,f[c+8>>2]|0,g)|0)){h=a+12|0;i=c+24|0;j=c+36|0;k=c+54|0;l=a+8|0;m=a+16|0;if(!(ZEc(a,f[c>>2]|0,g)|0)){n=f[h>>2]|0;o=a+16+(n<<3)|0;JFc(m,c,d,e,g);p=a+24|0;if((n|0)<=1)break;n=f[l>>2]|0;if((n&2|0)==0?(f[j>>2]|0)!=1:0){if(!(n&1)){n=p;while(1){if(b[k>>0]|0)break a;if((f[j>>2]|0)==1)break a;JFc(n,c,d,e,g);n=n+8|0;if(n>>>0>=o>>>0)break a}}else q=p;while(1){if(b[k>>0]|0)break a;if((f[j>>2]|0)==1?(f[i>>2]|0)==1:0)break a;JFc(q,c,d,e,g);q=q+8|0;if(q>>>0>=o>>>0)break a}}else r=p;while(1){if(b[k>>0]|0)break a;JFc(r,c,d,e,g);r=r+8|0;if(r>>>0>=o>>>0)break a}}o=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(p=c+20|0,(f[p>>2]|0)!=(d|0)):0){f[o>>2]=e;n=c+44|0;if((f[n>>2]|0)==4)break;s=a+16+(f[h>>2]<<3)|0;t=c+52|0;u=c+53|0;v=0;w=m;x=0;b:while(1){if(w>>>0>=s>>>0){y=v;z=18;break}b[t>>0]=0;b[u>>0]=0;IFc(w,c,d,d,1,g);if(b[k>>0]|0){y=v;z=18;break}do if(b[u>>0]|0){if(!(b[t>>0]|0))if(!(f[l>>2]&1)){y=1;z=18;break b}else{A=1;B=x;break}if((f[i>>2]|0)==1){z=23;break b}if(!(f[l>>2]&2)){z=23;break b}else{A=1;B=1}}else{A=v;B=x}while(0);v=A;w=w+8|0;x=B}do if((z|0)==18){if((!x?(f[p>>2]=d,w=c+40|0,f[w>>2]=(f[w>>2]|0)+1,(f[j>>2]|0)==1):0)?(f[i>>2]|0)==2:0){b[k>>0]=1;if(y){z=23;break}else{C=4;break}}if(y)z=23;else C=4}while(0);if((z|0)==23)C=3;f[n>>2]=C;break}if((e|0)==1)f[o>>2]=1}else $Ec(0,c,d,e);while(0);return}function GFc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a:do if(!(ZEc(a,f[c+8>>2]|0,0)|0)){g=f[a+12>>2]|0;h=a+16+(g<<3)|0;HFc(a+16|0,c,d,e);if((g|0)>1){g=c+54|0;i=a+24|0;do{HFc(i,c,d,e);if(b[g>>0]|0)break a;i=i+8|0}while(i>>>0<h>>>0)}}else _Ec(0,c,d,e);while(0);return}function HFc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a+4>>2]|0;g=e>>8;if(!(e&1))h=g;else h=f[(f[c>>2]|0)+g>>2]|0;g=f[a>>2]|0;ei[f[(f[g>>2]|0)+28>>2]&511](g,b,c+h|0,e&2|0?d:2);return}function IFc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a+4>>2]|0;i=h>>8;if(!(h&1))j=i;else j=f[(f[d>>2]|0)+i>>2]|0;i=f[a>>2]|0;Fh[f[(f[i>>2]|0)+20>>2]&255](i,b,c,d+j|0,h&2|0?e:2,g);return}function JFc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a+4>>2]|0;h=g>>8;if(!(g&1))i=h;else i=f[(f[c>>2]|0)+h>>2]|0;h=f[a>>2]|0;gi[f[(f[h>>2]|0)+24>>2]&255](h,b,c+i|0,g&2|0?d:2,e);return}function KFc(a){a=a|0;f[a>>2]=185572;return}function LFc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+4192|0;h=g+4176|0;i=g;j=g+4112|0;k=(e|0)!=0;if((a|0)!=0?(l=(c|0)!=0,m=(d|0)==0,!(l&m)):0){if(l)n=f[d>>2]|0;else n=0;MFc(i);NFc(j,i);l=j+48|0;o=j+61|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+12>>0]=0;b[o>>0]=1;l=j+32|0;p=j+36|0;q=f[p>>2]|0;if(q>>>0<(f[j+40>>2]|0)>>>0){OFc(h,i);f[q>>2]=0;f[q+4>>2]=0;r=f[h>>2]|0;f[q+8>>2]=0;f[q+12>>2]=r;f[p>>2]=(f[p>>2]|0)+16}else PFc(l,i);r=j+62|0;b[r>>0]=0;b[j+63>>0]=1;f[h>>2]=0;q=a+(Mpc(a)|0)|0;QFc(a,q,j,h);s=f[h>>2]|0;do if(!((s|0)!=0|(b[r>>0]|0)==0)){t=f[l>>2]|0;if((t|0)!=(f[p>>2]|0)?(f[t>>2]|0)!=(f[t+4>>2]|0):0){b[r>>0]=0;b[o>>0]=0;t=f[j>>2]|0;v=j+4|0;while(1){w=f[v>>2]|0;if((w|0)==(t|0))break;x=w+-24|0;f[v>>2]=x;RFc(x)}v=f[j+16>>2]|0;t=j+20|0;while(1){x=f[t>>2]|0;if((x|0)==(v|0))break;w=x+-16|0;f[t>>2]=w;SFc(w)}QFc(a,q,j,h);if(!(b[r>>0]|0)){y=f[h>>2]|0;z=22;break}else{f[h>>2]=-2;A=0;B=-2;break}}else z=23}else{y=s;z=22}while(0);if((z|0)==22)if(!y)z=23;else{A=0;B=y}do if((z|0)==23){y=j+4|0;s=TFc((f[y>>2]|0)+-24|0)|0;r=s+1|0;if(r>>>0>n>>>0){q=qoc(c,r)|0;if(!q){f[h>>2]=-1;A=0;B=-1;break}if(m)C=q;else{f[d>>2]=r;C=q}}else if(!c){A=0;B=0;break}else C=c;q=f[y>>2]|0;r=q+-12|0;a=b[r+11>>0]|0;o=a<<24>>24<0;UFc(q+-24|0,o?f[r>>2]|0:r,o?f[q+-8>>2]|0:a&255)|0;a=(f[y>>2]|0)+-24|0;if((b[a+11>>0]|0)<0)D=f[a>>2]|0;else D=a;dJc(C|0,D|0,s|0)|0;b[C+s>>0]=0;A=C;B=0}while(0);if(k)f[e>>2]=B;VFc(j);WFc(i);E=A}else if(k){f[e>>2]=-3;E=0}else E=0;u=g;return E|0}function MFc(a){a=a|0;f[a+4096>>2]=a;return}function NFc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;IIc(d,b);f[a>>2]=0;f[a+4>>2]=0;e=f[d>>2]|0;f[a+8>>2]=0;f[a+12>>2]=e;OFc(d,b);JIc(a+16|0,d);KIc(d,b);LIc(a+32|0,d);u=c;return}function OFc(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function PFc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+20|0;e=c;g=a+4|0;h=((f[g>>2]|0)-(f[a>>2]|0)>>4)+1|0;i=iIc(a)|0;if(i>>>0<h>>>0)mCc(a);else{j=f[a>>2]|0;k=(f[a+8>>2]|0)-j|0;l=k>>3;jIc(e,k>>4>>>0<i>>>1>>>0?(l>>>0<h>>>0?h:l):i,(f[g>>2]|0)-j>>4,a+12|0);j=e+8|0;g=f[j>>2]|0;OFc(d,b);f[g>>2]=0;f[g+4>>2]=0;b=f[d>>2]|0;f[g+8>>2]=0;f[g+12>>2]=b;f[j>>2]=g+16;kIc(a,e);lIc(e);u=c;return}}function QFc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a:do if(a>>>0<c>>>0){b:do if((b[a>>0]|0)!=95){if((kGc(a,c,d)|0)!=(c|0)){f[e>>2]=-2;break a}}else{if((c-a|0)<=3){f[e>>2]=-2;break a}g=a+2|0;switch(b[a+1>>0]|0){case 90:{h=hGc(g,c,d)|0;if(!((h|0)==(g|0)|(h|0)==(c|0))?(b[h>>0]|0)==46:0)i=iGc(h,c,d)|0;else i=h;if((i|0)==(c|0))break b;f[e>>2]=-2;break a;break}case 95:{if((b[g>>0]|0)==95?(b[a+3>>0]|0)==90:0){g=a+4|0;h=hGc(g,c,d)|0;if(!((h|0)==(g|0)|(h|0)==(c|0))?(jGc(h,c,d)|0)==(c|0):0)break b;f[e>>2]=-2;break a}break}default:{}}f[e>>2]=-2;break a}while(0);if((f[e>>2]|0)==0?(f[d>>2]|0)==(f[d+4>>2]|0):0)f[e>>2]=-2}else f[e>>2]=-2;while(0);return}function RFc(a){a=a|0;gGc(a+12|0);gGc(a);return}function SFc(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-24|0;f[c>>2]=e;RFc(e)}c=f[a>>2]|0;fGc(a+12|0,c,((f[a+8>>2]|0)-c|0)/24|0)}return}function TFc(a){a=a|0;var c=0,d=0,e=0;c=b[a+11>>0]|0;if(c<<24>>24<0)d=f[a+4>>2]|0;else d=c&255;c=b[a+12+11>>0]|0;if(c<<24>>24<0)e=f[a+16>>2]|0;else e=c&255;return e+d|0}function UFc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[a+8>>2]&2147483647)+-1|0}else{k=i&255;l=10}i=k+d|0;if((l-k|0)>>>0>=d>>>0){if(d|0){if(j)m=f[a>>2]|0;else m=a;etc(m+k|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=i;else b[h>>0]=i;b[g>>0]=0;_tc(m+i|0,g)}}else cGc(a,l,i-l|0,k,k,0,d,c);u=e;return a|0}function VFc(a){a=a|0;XFc(a+32|0);YFc(a+16|0);SFc(a);return}function WFc(a){a=a|0;f[a+4096>>2]=0;return}function XFc(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;YFc(e)}c=f[a>>2]|0;bGc(a+12|0,c,(f[a+8>>2]|0)-c>>4)}return}function YFc(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;SFc(e)}c=f[a>>2]|0;ZFc(a+12|0,c,(f[a+8>>2]|0)-c>>4)}return}function ZFc(a,b,c){a=a|0;b=b|0;c=c|0;_Fc(f[a>>2]|0,b,c<<4);return}function _Fc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if($Fc(a,b)|0){d=b+(aGc(c)|0)|0;c=a+4096|0;if((d|0)==(f[c>>2]|0))f[c>>2]=b}else poc(b);return}function $Fc(a,b){a=a|0;b=b|0;return a>>>0<=b>>>0&(a+4096|0)>>>0>=b>>>0|0}function aGc(a){a=a|0;return a+15&-16|0}function bGc(a,b,c){a=a|0;b=b|0;c=c|0;_Fc(f[a>>2]|0,b,c<<4);return}function cGc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+16|0;l=k;if((-18-c|0)>>>0<d>>>0)dEc(a);if((b[a+11>>0]|0)<0)m=f[a>>2]|0;else m=a;if(c>>>0<2147483623){n=d+c|0;d=c<<1;o=n>>>0<d>>>0?d:n;p=o>>>0<11?11:o+16&-16}else p=-17;o=dGc(p)|0;if(g|0)etc(o,m,g)|0;if(i|0)etc(o+g|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)etc(o+g+i|0,m+g+h|0,e)|0;if((c|0)!=10)eGc(m);f[a>>2]=o;f[a+8>>2]=p|-2147483648;p=j+i|0;f[a+4>>2]=p;b[l>>0]=0;_tc(o+p|0,l);u=k;return}function dGc(a){a=a|0;return ooc(a)|0}function eGc(a){a=a|0;poc(a);return}function fGc(a,b,c){a=a|0;b=b|0;c=c|0;_Fc(f[a>>2]|0,b,c*24|0);return}function gGc(a){a=a|0;if((b[a+11>>0]|0)<0)eGc(f[a>>2]|0);return}function hGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+12|0;l=e;if((a|0)!=(c|0)){m=d+56|0;CIc(h,m);f[m>>2]=(f[m>>2]|0)+1;n=d+61|0;DIc(i,n);if((f[m>>2]|0)>>>0>1)b[n>>0]=1;a:do switch(b[a>>0]|0){case 84:case 71:{o=EIc(a,c,d)|0;p=1;break}default:{m=JGc(a,c,d)|0;q=f[d+48>>2]|0;r=f[d+52>>2]|0;b:do if((m|0)!=(a|0))if((m|0)!=(c|0)){switch(b[m>>0]|0){case 46:case 69:{s=m;break b;break}default:{}}DIc(j,n);b[n>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;t=0;while(1){if((t|0)==3)break;f[k+(t<<2)>>2]=0;t=t+1|0}t=d+4|0;v=f[t>>2]|0;c:do if((f[d>>2]|0)!=(v|0)){w=v+-24|0;x=b[w+11>>0]|0;y=x<<24>>24<0;if(y)z=f[v+-20>>2]|0;else z=x&255;if(z){if(!(b[d+60>>0]|0)){if(y){A=f[w>>2]|0;B=f[v+-20>>2]|0}else{A=w;B=x&255}if((b[A+B+-1>>0]|0)==62){if(y){C=f[v+-20>>2]|0;D=f[w>>2]|0}else{C=x&255;D=w}if((b[D+(C+-2)>>0]|0)!=45){if(y){E=f[v+-20>>2]|0;F=f[w>>2]|0}else{E=x&255;F=w}if((b[F+(E+-2)>>0]|0)!=62){w=kGc(m,c,d)|0;if((w|0)==(m|0)){G=a;H=0;break}x=f[t>>2]|0;y=x;if(((x-(f[d>>2]|0)|0)/24|0)>>>0<2){G=a;H=0;break}x=y+-24|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2];f[l+8>>2]=f[x+8>>2];I=0;while(1){if((I|0)==3)break;f[x+(I<<2)>>2]=0;I=I+1|0}I=y+-12|0;x=k+11|0;if((b[x>>0]|0)<0){J=f[k>>2]|0;b[g>>0]=0;_tc(J,g);f[k+4>>2]=0}else{b[g>>0]=0;_tc(k,g);b[x>>0]=0}PGc(k);f[k>>2]=f[I>>2];f[k+4>>2]=f[I+4>>2];f[k+8>>2]=f[I+8>>2];J=0;while(1){if((J|0)==3)break;f[I+(J<<2)>>2]=0;J=J+1|0}J=b[x>>0]|0;if(!((J<<24>>24<0?f[k+4>>2]|0:J&255)|0))HHc(l,32);J=f[t>>2]|0;I=J+-24|0;y=J;while(1){if((y|0)==(I|0))break;K=y+-24|0;f[t>>2]=K;RFc(K);y=f[t>>2]|0}y=b[l+11>>0]|0;I=y<<24>>24<0;pIc(J+-48|0,0,I?f[l>>2]|0:l,I?f[l+4>>2]|0:y&255)|0;gGc(l);L=w;M=f[t>>2]|0}else{L=m;M=v}}else{L=m;M=v}}else{L=m;M=v}}else{L=m;M=v}HHc(M+-24|0,40);if((L|0)!=(c|0)?(b[L>>0]|0)==118:0){N=L+1|0;O=f[d>>2]|0;P=f[t>>2]|0}else Q=49;do if((Q|0)==49){y=g+11|0;I=g+4|0;x=l+11|0;K=l+4|0;R=1;S=L;d:while(1){T=S;U=f[d>>2]|0;V=f[t>>2]|0;while(1){W=(V-U|0)/24|0;X=kGc(T,c,d)|0;V=f[t>>2]|0;U=f[d>>2]|0;Y=(V-U|0)/24|0;if((X|0)==(T|0)){Q=72;break d}if(Y>>>0>W>>>0)break;else T=X}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Z=0;while(1){if((Z|0)==3){_=W;break}f[g+(Z<<2)>>2]=0;Z=Z+1|0}while(1){if(_>>>0>=Y>>>0){$=W;break}Z=b[y>>0]|0;if((Z<<24>>24<0?f[I>>2]|0:Z&255)|0)oGc(g,518069)|0;CGc(l,(f[d>>2]|0)+(_*24|0)|0);Z=b[x>>0]|0;aa=Z<<24>>24<0;UFc(g,aa?f[l>>2]|0:l,aa?f[K>>2]|0:Z&255)|0;gGc(l);_=_+1|0}while(1){if($>>>0>=Y>>>0)break;Z=f[t>>2]|0;aa=Z+-24|0;ba=Z;while(1){if((ba|0)==(aa|0))break;Z=ba+-24|0;f[t>>2]=Z;RFc(Z);ba=f[t>>2]|0}$=$+1|0}ba=b[y>>0]|0;aa=f[I>>2]|0;if(!((ba<<24>>24<0?aa:ba&255)|0))ca=R;else{Z=f[t>>2]|0;if((f[d>>2]|0)==(Z|0)){Q=84;break}if(R){da=Z;ea=ba;fa=aa}else{oGc(Z+-24|0,518069)|0;da=f[t>>2]|0;ea=b[y>>0]|0;fa=f[I>>2]|0}Z=ea<<24>>24<0;UFc(da+-24|0,Z?f[g>>2]|0:g,Z?fa:ea&255)|0;ca=0}gGc(g);R=ca;S=X}if((Q|0)==72){N=T;O=U;P=V;break}else if((Q|0)==84){gGc(g);G=a;H=0;break c}}while(0);if((O|0)!=(P|0)){HHc(P+-24|0,41);if(q&1|0)oGc((f[t>>2]|0)+-24|0,517792)|0;if(q&2|0)oGc((f[t>>2]|0)+-24|0,517799)|0;if(q&4|0)oGc((f[t>>2]|0)+-24|0,517809)|0;switch(r|0){case 1:{oGc((f[t>>2]|0)+-24|0,519273)|0;break}case 2:{oGc((f[t>>2]|0)+-24|0,519276)|0;break}default:{}}w=b[k+11>>0]|0;J=w<<24>>24<0;UFc((f[t>>2]|0)+-24|0,J?f[k>>2]|0:k,J?f[k+4>>2]|0:w&255)|0;G=N;H=1}else{G=a;H=0}}else{G=a;H=0}}else{G=a;H=0}while(0);gGc(k);FIc(j);if(H)s=G;else{o=G;p=0;break a}}else s=c;else s=a;while(0);o=s;p=1}}while(0);FIc(i);GIc(h);if(p){ga=o;Q=88}else ha=a}else{ga=a;Q=88}if((Q|0)==88)ha=ga;u=e;return ha|0}function iGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((a|0)!=(c|0)?(b[a>>0]|0)==46:0)?(k=d+4|0,(f[d>>2]|0)!=(f[k>>2]|0)):0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=c-a|0;if(d>>>0>4294967279)dEc(j);if(d>>>0<11){b[j+11>>0]=d;l=j}else{m=d+16&-16;n=dGc(m)|0;f[j>>2]=n;f[j+8>>2]=m|-2147483648;f[j+4>>2]=d;l=n}n=a;m=l;while(1){if((n|0)==(c|0))break;_tc(m,n);n=n+1|0;m=m+1|0}b[g>>0]=0;_tc(l+d|0,g);nGc(j,0,517842)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];g=0;while(1){if((g|0)==3)break;f[j+(g<<2)>>2]=0;g=g+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];g=0;while(1){if((g|0)==3)break;f[i+(g<<2)>>2]=0;g=g+1|0}g=b[h+11>>0]|0;d=g<<24>>24<0;UFc((f[k>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:g&255)|0;gGc(h);gGc(i);gGc(j);o=c}else o=a;u=e;return o|0}function jGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if((c-a|0)>12){e=0;g=a;while(1){h=g+1|0;if((e|0)>=13)break;if((b[g>>0]|0)==(b[519478+e>>0]|0)){e=e+1|0;g=h}else{i=a;break a}}b:do if((g|0)==(c|0))j=c;else{if((b[g>>0]|0)==95){if((h|0)==(c|0)){i=a;break a}if(((b[h>>0]|0)+-48|0)>>>0>=10){i=a;break a}k=g+2|0}else k=g;while(1){if((k|0)==(c|0)){j=c;break b}if(((b[k>>0]|0)+-48|0)>>>0>=10){j=k;break b}k=k+1|0}}while(0);g=f[d+4>>2]|0;if((f[d>>2]|0)!=(g|0)){nGc(g+-24|0,0,519492)|0;i=j}else i=a}else i=a;while(0);return i|0}function kGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+144|0;g=e+128|0;h=e+104|0;i=e+40|0;j=e+88|0;k=e+24|0;l=e+76|0;m=e+12|0;n=e;o=e+64|0;a:do if((a|0)!=(c|0)){p=d+16|0;switch(b[a>>0]|0){case 75:case 86:case 114:{f[g>>2]=0;q=lGc(a,c,g)|0;b:do if((q|0)!=(a|0)?(r=(b[q>>0]|0)==70,s=d+4|0,t=((f[s>>2]|0)-(f[d>>2]|0)|0)/24|0,v=kGc(q,c,d)|0,w=((f[s>>2]|0)-(f[d>>2]|0)|0)/24|0,(v|0)!=(q|0)):0){s=d+20|0;x=f[s>>2]|0;c:do if(r){y=x+-16|0;z=x;while(1){if((z|0)==(y|0)){A=y;break c}B=z+-16|0;f[s>>2]=B;SFc(B);z=f[s>>2]|0}}else A=x;while(0);f[h>>2]=f[d+12>>2];if(A>>>0<(f[d+24>>2]|0)>>>0){f[A>>2]=0;f[A+4>>2]=0;x=f[h>>2]|0;f[A+8>>2]=0;f[A+12>>2]=x;f[s>>2]=(f[s>>2]|0)+16}else mGc(p,h);x=f[g>>2]|0;z=(x&1|0)==0;y=(x&2|0)==0;B=(x&4|0)==0;x=t;while(1){if(x>>>0>=w>>>0){C=v;break b}if(r){D=f[d>>2]|0;E=D+(x*24|0)+12|0;F=b[E+11>>0]|0;G=F<<24>>24<0;if(G){H=f[D+(x*24|0)+16>>2]|0;I=f[E>>2]|0}else{H=F&255;I=E}J=H+-2|0;if((b[I+J>>0]|0)==38)K=H+-3|0;else{if(G){L=f[E>>2]|0;M=f[D+(x*24|0)+16>>2]|0}else{L=E;M=F&255}K=(b[L+M+-1>>0]|0)==38?J:H}if(z)N=K;else{nGc(E,K,517792)|0;N=K+6|0}if(y)O=N;else{nGc((f[d>>2]|0)+(x*24|0)+12|0,N,517799)|0;O=N+9|0}if(!B)nGc((f[d>>2]|0)+(x*24|0)+12|0,O,517809)|0}else{if(!z)oGc((f[d>>2]|0)+(x*24|0)|0,517792)|0;if(!y)oGc((f[d>>2]|0)+(x*24|0)|0,517799)|0;if(!B)oGc((f[d>>2]|0)+(x*24|0)|0,517809)|0}E=f[s>>2]|0;J=(f[d>>2]|0)+(x*24|0)|0;F=E+-12|0;D=f[F>>2]|0;if((D|0)==(f[E+-8>>2]|0))qGc(E+-16|0,J);else{pGc(D,J);f[F>>2]=(f[F>>2]|0)+24}x=x+1|0}}else C=a;while(0);P=C;break a;break}default:{}}q=rGc(a,c,d)|0;if((q|0)==(a|0)){x=a+1|0;s=(x|0)!=(c|0);d:do switch(b[a>>0]|0){case 65:{B=sGc(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}y=f[d+4>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}f[h>>2]=f[d+12>>2];tGc(g,y+-24|0,h);y=d+20|0;z=f[y>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;v=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=v;f[z>>2]=f[g>>2];v=g+4|0;f[r>>2]=f[v>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[v>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else uGc(p,g);SFc(g);P=B;break a;break}case 67:{B=kGc(x,c,d)|0;if((B|0)==(x|0)){P=a;break a}y=d+4|0;v=f[y>>2]|0;if((f[d>>2]|0)==(v|0)){P=a;break a}oGc(v+-24|0,517819)|0;v=(f[y>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];tGc(g,v,h);v=d+20|0;y=f[v>>2]|0;if(y>>>0<(f[d+24>>2]|0)>>>0){f[y>>2]=0;r=y+4|0;f[r>>2]=0;z=f[g+12>>2]|0;f[y+8>>2]=0;f[y+12>>2]=z;f[y>>2]=f[g>>2];z=g+4|0;f[r>>2]=f[z>>2];r=g+8|0;f[y+8>>2]=f[r>>2];f[r>>2]=0;f[z>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else uGc(p,g);SFc(g);P=B;break a;break}case 70:{B=vGc(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}v=f[d+4>>2]|0;if((f[d>>2]|0)==(v|0)){P=a;break a}f[h>>2]=f[d+12>>2];tGc(g,v+-24|0,h);v=d+20|0;z=f[v>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;y=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=y;f[z>>2]=f[g>>2];y=g+4|0;f[r>>2]=f[y>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[y>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else uGc(p,g);SFc(g);P=B;break a;break}case 71:{B=kGc(x,c,d)|0;if((B|0)==(x|0)){P=a;break a}v=d+4|0;y=f[v>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}oGc(y+-24|0,517828)|0;y=(f[v>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];tGc(g,y,h);y=d+20|0;v=f[y>>2]|0;if(v>>>0<(f[d+24>>2]|0)>>>0){f[v>>2]=0;r=v+4|0;f[r>>2]=0;z=f[g+12>>2]|0;f[v+8>>2]=0;f[v+12>>2]=z;f[v>>2]=f[g>>2];z=g+4|0;f[r>>2]=f[z>>2];r=g+8|0;f[v+8>>2]=f[r>>2];f[r>>2]=0;f[z>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else uGc(p,g);SFc(g);P=B;break a;break}case 77:{B=wGc(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}y=f[d+4>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}f[h>>2]=f[d+12>>2];tGc(g,y+-24|0,h);y=d+20|0;z=f[y>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;v=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=v;f[z>>2]=f[g>>2];v=g+4|0;f[r>>2]=f[v>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[v>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else uGc(p,g);SFc(g);P=B;break a;break}case 79:{B=d+4|0;y=((f[B>>2]|0)-(f[d>>2]|0)|0)/24|0;v=kGc(x,c,d)|0;r=((f[B>>2]|0)-(f[d>>2]|0)|0)/24|0;if((v|0)==(x|0)){P=a;break a}B=f[d+12>>2]|0;f[g>>2]=B;z=d+20|0;w=f[z>>2]|0;if(w>>>0<(f[d+24>>2]|0)>>>0){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=B;f[z>>2]=(f[z>>2]|0)+16}else mGc(p,g);B=g+11|0;w=g+4|0;t=y;while(1){if(t>>>0>=r>>>0){P=v;break a}xGc(g,(f[d>>2]|0)+(t*24|0)+12|0,2);y=Ztc(517839)|0;F=b[B>>0]|0;if((y|0)==((F<<24>>24<0?f[w>>2]|0:F&255)|0))Q=(yGc(g,517839,y)|0)==0;else Q=0;gGc(g);y=f[d>>2]|0;if(!Q){F=y+(t*24|0)+12|0;if((b[F+11>>0]|0)<0)R=f[F>>2]|0;else R=F;if((b[R>>0]|0)==40){oGc(y+(t*24|0)|0,517847)|0;nGc((f[d>>2]|0)+(t*24|0)+12|0,0,517845)|0}}else{oGc(y+(t*24|0)|0,517842)|0;nGc((f[d>>2]|0)+(t*24|0)+12|0,0,517845)|0}oGc((f[d>>2]|0)+(t*24|0)|0,517849)|0;y=f[z>>2]|0;F=(f[d>>2]|0)+(t*24|0)|0;J=y+-12|0;D=f[J>>2]|0;if((D|0)==(f[y+-8>>2]|0))qGc(y+-16|0,F);else{pGc(D,F);f[J>>2]=(f[J>>2]|0)+24}t=t+1|0}break}case 80:{t=d+4|0;z=((f[t>>2]|0)-(f[d>>2]|0)|0)/24|0;w=kGc(x,c,d)|0;B=((f[t>>2]|0)-(f[d>>2]|0)|0)/24|0;if((w|0)==(x|0)){P=a;break a}t=f[d+12>>2]|0;f[g>>2]=t;v=d+20|0;r=f[v>>2]|0;if(r>>>0<(f[d+24>>2]|0)>>>0){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=t;f[v>>2]=(f[v>>2]|0)+16}else mGc(p,g);t=g+11|0;r=g+4|0;J=g+11|0;F=g+4|0;D=z;while(1){if(D>>>0>=B>>>0){P=w;break a}xGc(g,(f[d>>2]|0)+(D*24|0)+12|0,2);z=Ztc(517839)|0;y=b[t>>0]|0;if((z|0)==((y<<24>>24<0?f[r>>2]|0:y&255)|0))S=(yGc(g,517839,z)|0)==0;else S=0;gGc(g);z=f[d>>2]|0;if(!S){y=z+(D*24|0)+12|0;if((b[y+11>>0]|0)<0)T=f[y>>2]|0;else T=y;if((b[T>>0]|0)==40){oGc(z+(D*24|0)|0,517847)|0;nGc((f[d>>2]|0)+(D*24|0)+12|0,0,517845)|0}}else{oGc(z+(D*24|0)|0,517842)|0;nGc((f[d>>2]|0)+(D*24|0)+12|0,0,517845)|0}if((b[x>>0]|0)==85){xGc(g,(f[d>>2]|0)+(D*24|0)|0,12);z=Ztc(517852)|0;y=b[J>>0]|0;if((z|0)==((y<<24>>24<0?f[F>>2]|0:y&255)|0))U=(yGc(g,517852,z)|0)!=0;else U=1;gGc(g);z=(f[d>>2]|0)+(D*24|0)|0;if(U){V=z;W=112}else zGc(z)}else{V=(f[d>>2]|0)+(D*24|0)|0;W=112}if((W|0)==112){W=0;oGc(V,517865)|0}z=f[v>>2]|0;y=(f[d>>2]|0)+(D*24|0)|0;E=z+-12|0;G=f[E>>2]|0;if((G|0)==(f[z+-8>>2]|0))qGc(z+-16|0,y);else{pGc(G,y);f[E>>2]=(f[E>>2]|0)+24}D=D+1|0}break}case 82:{D=d+4|0;v=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;F=kGc(x,c,d)|0;J=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;if((F|0)==(x|0)){P=a;break a}D=f[d+12>>2]|0;f[g>>2]=D;r=d+20|0;t=f[r>>2]|0;if(t>>>0<(f[d+24>>2]|0)>>>0){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=D;f[r>>2]=(f[r>>2]|0)+16}else mGc(p,g);D=g+11|0;t=g+4|0;w=v;while(1){if(w>>>0>=J>>>0){P=F;break a}xGc(g,(f[d>>2]|0)+(w*24|0)+12|0,2);v=Ztc(517839)|0;B=b[D>>0]|0;if((v|0)==((B<<24>>24<0?f[t>>2]|0:B&255)|0))X=(yGc(g,517839,v)|0)==0;else X=0;gGc(g);v=f[d>>2]|0;if(!X){B=v+(w*24|0)+12|0;if((b[B+11>>0]|0)<0)Y=f[B>>2]|0;else Y=B;if((b[Y>>0]|0)==40){oGc(v+(w*24|0)|0,517847)|0;nGc((f[d>>2]|0)+(w*24|0)+12|0,0,517845)|0}}else{oGc(v+(w*24|0)|0,517842)|0;nGc((f[d>>2]|0)+(w*24|0)+12|0,0,517845)|0}oGc((f[d>>2]|0)+(w*24|0)|0,517867)|0;v=f[r>>2]|0;B=(f[d>>2]|0)+(w*24|0)|0;E=v+-12|0;y=f[E>>2]|0;if((y|0)==(f[v+-8>>2]|0))qGc(v+-16|0,B);else{pGc(y,B);f[E>>2]=(f[E>>2]|0)+24}w=w+1|0}break}case 84:{w=d+4|0;r=((f[w>>2]|0)-(f[d>>2]|0)|0)/24|0;t=AGc(a,c,d)|0;D=((f[w>>2]|0)-(f[d>>2]|0)|0)/24|0;if((t|0)==(a|0)){P=a;break a}F=d+12|0;J=f[F>>2]|0;f[g>>2]=J;E=d+20|0;B=f[E>>2]|0;y=d+24|0;if(B>>>0<(f[y>>2]|0)>>>0){f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=J;f[E>>2]=(f[E>>2]|0)+16}else mGc(p,g);J=r;while(1){if(J>>>0>=D>>>0)break;B=f[E>>2]|0;v=(f[d>>2]|0)+(J*24|0)|0;G=B+-12|0;z=f[G>>2]|0;if((z|0)==(f[B+-8>>2]|0))qGc(B+-16|0,v);else{pGc(z,v);f[G>>2]=(f[G>>2]|0)+24}J=J+1|0}if(!((D|0)==(r+1|0)&(b[d+63>>0]|0)!=0)){P=t;break a}J=BGc(t,c,d)|0;if((J|0)==(t|0)){P=t;break a}CGc(g,(f[w>>2]|0)+-24|0);G=f[w>>2]|0;v=G+-24|0;z=G;while(1){if((z|0)==(v|0))break;B=z+-24|0;f[w>>2]=B;RFc(B);z=f[w>>2]|0}z=b[g+11>>0]|0;v=z<<24>>24<0;UFc(G+-48|0,v?f[g>>2]|0:g,v?f[g+4>>2]|0:z&255)|0;z=(f[w>>2]|0)+-24|0;f[i>>2]=f[F>>2];tGc(h,z,i);z=f[E>>2]|0;if(z>>>0<(f[y>>2]|0)>>>0){f[z>>2]=0;v=z+4|0;f[v>>2]=0;t=f[h+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=t;f[z>>2]=f[h>>2];t=h+4|0;f[v>>2]=f[t>>2];v=h+8|0;f[z+8>>2]=f[v>>2];f[v>>2]=0;f[t>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+16}else uGc(p,h);SFc(h);gGc(g);P=J;break a;break}case 85:{if(!s){P=a;break a}t=DGc(x,c,d)|0;if((t|0)==(x|0)){P=a;break a}v=kGc(t,c,d)|0;if((v|0)==(t|0)){P=a;break a}t=d+4|0;z=f[t>>2]|0;if(((z-(f[d>>2]|0)|0)/24|0)>>>0<2){P=a;break a}CGc(g,z+-24|0);z=f[t>>2]|0;r=z+-24|0;D=z;while(1){if((D|0)==(r|0))break;B=D+-24|0;f[t>>2]=B;RFc(B);D=f[t>>2]|0}xGc(h,z+-48|0,9);D=Ztc(517869)|0;r=b[h+11>>0]|0;if((D|0)==((r<<24>>24<0?f[h+4>>2]|0:r&255)|0)){r=(yGc(h,517869,D)|0)==0;gGc(h);if(r){CGc(h,(f[t>>2]|0)+-24|0);r=f[t>>2]|0;D=r+-24|0;J=r;while(1){if((J|0)==(D|0))break;r=J+-24|0;f[t>>2]=r;RFc(r);J=f[t>>2]|0}J=h+11|0;D=b[J>>0]|0;z=D<<24>>24<0;r=f[h>>2]|0;E=DGc(z?r+9|0:h+9|0,(z?r:h)+(z?f[h+4>>2]|0:D&255)|0,d)|0;if((E|0)==(((b[J>>0]|0)<0?f[h>>2]|0:h)+9|0)){EGc(k,g,517879);E=b[J>>0]|0;J=E<<24>>24<0;UFc(k,J?f[h>>2]|0:h,J?f[h+4>>2]|0:E&255)|0;f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];E=0;while(1){if((E|0)==3)break;f[k+(E<<2)>>2]=0;E=E+1|0}FGc(i,o);E=f[t>>2]|0;if(E>>>0<(f[d+8>>2]|0)>>>0){HGc(E,i);f[t>>2]=(f[t>>2]|0)+24}else IGc(d,i);RFc(i);gGc(o);gGc(k)}else{EGc(m,g,517881);CGc(n,(f[t>>2]|0)+-24|0);E=b[n+11>>0]|0;J=E<<24>>24<0;UFc(m,J?f[n>>2]|0:n,J?f[n+4>>2]|0:E&255)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];E=0;while(1){if((E|0)==3)break;f[m+(E<<2)>>2]=0;E=E+1|0}oGc(k,517883)|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];E=0;while(1){if((E|0)==3)break;f[k+(E<<2)>>2]=0;E=E+1|0}FGc(i,l);GGc((f[t>>2]|0)+-24|0,i);RFc(i);gGc(l);gGc(k);gGc(n);gGc(m)}gGc(h)}else W=166}else{gGc(h);W=166}if((W|0)==166){EGc(i,g,517879);CGc(k,(f[t>>2]|0)+-24|0);E=b[k+11>>0]|0;J=E<<24>>24<0;UFc(i,J?f[k>>2]|0:k,J?f[k+4>>2]|0:E&255)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];E=0;while(1){if((E|0)==3)break;f[i+(E<<2)>>2]=0;E=E+1|0}FGc(h,j);GGc((f[t>>2]|0)+-24|0,h);RFc(h);gGc(j);gGc(k);gGc(i)}E=(f[t>>2]|0)+-24|0;f[i>>2]=f[d+12>>2];tGc(h,E,i);E=d+20|0;J=f[E>>2]|0;if(J>>>0<(f[d+24>>2]|0)>>>0){f[J>>2]=0;D=J+4|0;f[D>>2]=0;z=f[h+12>>2]|0;f[J+8>>2]=0;f[J+12>>2]=z;f[J>>2]=f[h>>2];z=h+4|0;f[D>>2]=f[z>>2];D=h+8|0;f[J+8>>2]=f[D>>2];f[D>>2]=0;f[z>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+16}else uGc(p,h);SFc(h);gGc(g);P=v;break a;break}case 83:{if(s?(b[x>>0]|0)==116:0){E=JGc(a,c,d)|0;if((E|0)==(a|0)){P=a;break a}z=f[d+4>>2]|0;if((f[d>>2]|0)==(z|0)){P=a;break a}f[h>>2]=f[d+12>>2];tGc(g,z+-24|0,h);z=d+20|0;D=f[z>>2]|0;if(D>>>0<(f[d+24>>2]|0)>>>0){f[D>>2]=0;J=D+4|0;f[J>>2]=0;r=f[g+12>>2]|0;f[D+8>>2]=0;f[D+12>>2]=r;f[D>>2]=f[g>>2];r=g+4|0;f[J>>2]=f[r>>2];J=g+8|0;f[D+8>>2]=f[J>>2];f[J>>2]=0;f[r>>2]=0;f[g>>2]=0;f[z>>2]=(f[z>>2]|0)+16}else uGc(p,g);SFc(g);P=E;break a}E=KGc(a,c,d)|0;if((E|0)==(a|0)){P=a;break a}z=BGc(E,c,d)|0;if((z|0)==(E|0)){P=E;break a}r=d+4|0;J=f[r>>2]|0;if(((J-(f[d>>2]|0)|0)/24|0)>>>0<2){P=E;break a}CGc(g,J+-24|0);J=f[r>>2]|0;E=J+-24|0;D=J;while(1){if((D|0)==(E|0))break;y=D+-24|0;f[r>>2]=y;RFc(y);D=f[r>>2]|0}D=b[g+11>>0]|0;E=D<<24>>24<0;UFc(J+-48|0,E?f[g>>2]|0:g,E?f[g+4>>2]|0:D&255)|0;D=(f[r>>2]|0)+-24|0;f[i>>2]=f[d+12>>2];tGc(h,D,i);D=d+20|0;E=f[D>>2]|0;if(E>>>0<(f[d+24>>2]|0)>>>0){f[E>>2]=0;v=E+4|0;f[v>>2]=0;t=f[h+12>>2]|0;f[E+8>>2]=0;f[E+12>>2]=t;f[E>>2]=f[h>>2];t=h+4|0;f[v>>2]=f[t>>2];v=h+8|0;f[E+8>>2]=f[v>>2];f[v>>2]=0;f[t>>2]=0;f[h>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else uGc(p,h);SFc(h);gGc(g);P=z;break a;break}case 68:{if(s)switch(b[x>>0]|0){case 112:{D=d+4|0;t=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;v=a+2|0;E=kGc(v,c,d)|0;y=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;if((E|0)==(v|0))break d;v=f[d+12>>2]|0;f[g>>2]=v;D=d+20|0;F=f[D>>2]|0;if(F>>>0<(f[d+24>>2]|0)>>>0){f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=v;f[D>>2]=(f[D>>2]|0)+16}else mGc(p,g);v=t;while(1){if(v>>>0>=y>>>0){P=E;break a}t=f[D>>2]|0;F=(f[d>>2]|0)+(v*24|0)|0;w=t+-12|0;G=f[w>>2]|0;if((G|0)==(f[t+-8>>2]|0))qGc(t+-16|0,F);else{pGc(G,F);f[w>>2]=(f[w>>2]|0)+24}v=v+1|0}break}case 84:case 116:{v=LGc(a,c,d)|0;if((v|0)==(a|0))break d;D=f[d+4>>2]|0;if((f[d>>2]|0)==(D|0)){P=a;break a}f[h>>2]=f[d+12>>2];tGc(g,D+-24|0,h);D=d+20|0;E=f[D>>2]|0;if(E>>>0<(f[d+24>>2]|0)>>>0){f[E>>2]=0;y=E+4|0;f[y>>2]=0;z=f[g+12>>2]|0;f[E+8>>2]=0;f[E+12>>2]=z;f[E>>2]=f[g>>2];z=g+4|0;f[y>>2]=f[z>>2];y=g+8|0;f[E+8>>2]=f[y>>2];f[y>>2]=0;f[z>>2]=0;f[g>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else uGc(p,g);SFc(g);P=v;break a;break}case 118:{v=MGc(a,c,d)|0;if((v|0)==(a|0))break d;D=f[d+4>>2]|0;if((f[d>>2]|0)==(D|0)){P=a;break a}f[h>>2]=f[d+12>>2];tGc(g,D+-24|0,h);D=d+20|0;z=f[D>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;y=z+4|0;f[y>>2]=0;E=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=E;f[z>>2]=f[g>>2];E=g+4|0;f[y>>2]=f[E>>2];y=g+8|0;f[z+8>>2]=f[y>>2];f[y>>2]=0;f[E>>2]=0;f[g>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else uGc(p,g);SFc(g);P=v;break a;break}default:break d}break}default:{}}while(0);x=rGc(a,c,d)|0;if((x|0)==(a|0)){s=JGc(a,c,d)|0;if((s|0)!=(a|0)?(v=f[d+4>>2]|0,(f[d>>2]|0)!=(v|0)):0){f[h>>2]=f[d+12>>2];tGc(g,v+-24|0,h);v=d+20|0;D=f[v>>2]|0;if(D>>>0<(f[d+24>>2]|0)>>>0){f[D>>2]=0;E=D+4|0;f[E>>2]=0;y=f[g+12>>2]|0;f[D+8>>2]=0;f[D+12>>2]=y;f[D>>2]=f[g>>2];y=g+4|0;f[E>>2]=f[y>>2];E=g+8|0;f[D+8>>2]=f[E>>2];f[E>>2]=0;f[y>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else uGc(p,g);SFc(g);P=s}else P=a}else P=x}else P=q}else P=a;while(0);u=e;return P|0}function lGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[d>>2]=0;if((a|0)!=(c|0)){c=b[a>>0]|0;if(c<<24>>24==114){f[d>>2]=4;e=a+1|0;g=e;h=4;i=b[e>>0]|0}else{g=a;h=0;i=c}if(i<<24>>24==86){c=h|2;f[d>>2]=c;e=g+1|0;j=e;k=b[e>>0]|0;l=c}else{j=g;k=i;l=h}if(k<<24>>24==75){f[d>>2]=l|1;m=j+1|0}else m=j}else m=a;return m|0}function mGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=((f[e>>2]|0)-(f[a>>2]|0)>>4)+1|0;h=qIc(a)|0;if(h>>>0<g>>>0)mCc(a);else{i=f[a>>2]|0;j=(f[a+8>>2]|0)-i|0;k=j>>3;rIc(d,j>>4>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,(f[e>>2]|0)-i>>4,a+12|0);i=d+8|0;e=f[i>>2]|0;f[e>>2]=0;f[e+4>>2]=0;h=f[b>>2]|0;f[e+8>>2]=0;f[e+12>>2]=h;f[i>>2]=e+16;sIc(a,d);tIc(d);u=c;return}}function nGc(a,b,c){a=a|0;b=b|0;c=c|0;return pIc(a,b,c,Ztc(c)|0)|0}function oGc(a,b){a=a|0;b=b|0;return UFc(a,b,Ztc(b)|0)|0}function pGc(a,b){a=a|0;b=b|0;LHc(a,b);LHc(a+12|0,b+12|0);return}function qGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=(((f[e>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;h=PHc(a)|0;if(h>>>0<g>>>0)mCc(a);else{i=f[a>>2]|0;j=((f[a+8>>2]|0)-i|0)/24|0;k=j<<1;QHc(d,j>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,((f[e>>2]|0)-i|0)/24|0,a+12|0);i=d+8|0;e=f[i>>2]|0;pGc(e,b);f[i>>2]=e+24;RHc(a,d);SHc(d);u=c;return}}function rGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e;a:do if((a|0)==(c|0))h=a;else{i=a+1|0;do switch(b[a>>0]|0){case 118:{WHc(g,519284);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 119:{xIc(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 98:{WHc(g,519289);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 99:{WHc(g,519058);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 97:{DHc(g,519063);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 104:{_Hc(g,519075);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 115:{nHc(g,519089);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 116:{EHc(g,519095);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 105:{yIc(g,519294);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 106:{FHc(g,519298);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 108:{WHc(g,519311);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 109:{_Hc(g,519316);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 120:{AHc(g,519330);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 121:{zIc(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 110:{AIc(g,519124);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 111:{BHc(g,519133);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 102:{nHc(g,519340);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 100:{BIc(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 101:{DHc(g,519346);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 103:{zHc(g,519358);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 122:{yIc(g,519369);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);h=i;break a;break}case 117:{j=DGc(i,c,d)|0;h=(j|0)==(i|0)?a:j;break a;break}case 68:{if((i|0)==(c|0)){h=a;break a}j=a+2|0;switch(b[i>>0]|0){case 100:{AHc(g,519373);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);h=j;break a;break}case 101:{zHc(g,519383);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);h=j;break a;break}case 102:{AHc(g,519394);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);h=j;break a;break}case 104:{AHc(g,519404);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);h=j;break a;break}case 105:{AIc(g,519414);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);h=j;break a;break}case 115:{AIc(g,519423);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);h=j;break a;break}case 97:{WHc(g,519432);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);h=j;break a;break}case 110:{EHc(g,519437);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);h=j;break a;break}default:{h=a;break a}}break}default:{h=a;break a}}while(0)}while(0);u=e;return h|0}function sGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;do if(((a|0)!=(c|0)?(b[a>>0]|0)==65:0)?(n=a+1|0,(n|0)!=(c|0)):0){o=b[n>>0]|0;if(o<<24>>24==95){p=a+2|0;q=kGc(p,c,d)|0;if((q|0)==(p|0)){r=a;break}p=d+4|0;s=f[p>>2]|0;if((f[d>>2]|0)==(s|0)){r=a;break}xGc(g,s+-12|0,2);s=Ztc(517839)|0;t=b[g+11>>0]|0;if((s|0)==((t<<24>>24<0?f[g+4>>2]|0:t&255)|0)){t=(yGc(g,517839,s)|0)==0;gGc(g);if(t)wIc((f[p>>2]|0)+-12|0)}else gGc(g);nGc((f[p>>2]|0)+-12|0,0,519280)|0;r=q;break}if((o+-49&255)<9){o=NGc(n,c)|0;if((o|0)==(c|0)){r=a;break}if((b[o>>0]|0)!=95){r=a;break}q=o+1|0;p=kGc(q,c,d)|0;if((p|0)==(q|0)){r=a;break}q=d+4|0;t=f[q>>2]|0;if((f[d>>2]|0)==(t|0)){r=a;break}xGc(g,t+-12|0,2);t=Ztc(517839)|0;s=b[g+11>>0]|0;if((t|0)==((s<<24>>24<0?f[g+4>>2]|0:s&255)|0)){s=(yGc(g,517839,t)|0)==0;gGc(g);if(s)wIc((f[q>>2]|0)+-12|0)}else gGc(g);s=(f[q>>2]|0)+-12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;q=o-n|0;if(q>>>0>4294967279)dEc(j);if(q>>>0<11){b[j+11>>0]=q;v=j}else{t=q+16&-16;w=dGc(t)|0;f[j>>2]=w;f[j+8>>2]=t|-2147483648;f[j+4>>2]=q;v=w}w=n;t=v;while(1){if((w|0)==(o|0))break;_tc(t,w);w=w+1|0;t=t+1|0}b[g>>0]=0;_tc(v+q|0,g);nGc(j,0,517839)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];t=0;while(1){if((t|0)==3)break;f[j+(t<<2)>>2]=0;t=t+1|0}oGc(i,517894)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];t=0;while(1){if((t|0)==3)break;f[i+(t<<2)>>2]=0;t=t+1|0}t=b[h+11>>0]|0;q=t<<24>>24<0;pIc(s,0,q?f[h>>2]|0:h,q?f[h+4>>2]|0:t&255)|0;gGc(h);gGc(i);gGc(j);r=p;break}t=OGc(n,c,d)|0;if(((!((t|0)==(n|0)|(t|0)==(c|0))?(b[t>>0]|0)==95:0)?(q=t+1|0,t=kGc(q,c,d)|0,(t|0)!=(q|0)):0)?(q=d+4|0,w=f[q>>2]|0,((w-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){HGc(h,w+-24|0);w=f[q>>2]|0;o=w+-24|0;x=w;while(1){if((x|0)==(o|0))break;y=x+-24|0;f[q>>2]=y;RFc(y);x=f[q>>2]|0}HGc(i,w+-48|0);x=f[q>>2]|0;o=x+-24|0;n=o+11|0;if((b[n>>0]|0)<0){p=f[o>>2]|0;b[g>>0]=0;_tc(p,g);f[x+-20>>2]=0}else{b[g>>0]=0;_tc(o,g);b[n>>0]=0}PGc(o);f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];o=0;while(1){if((o|0)==3)break;f[h+(o<<2)>>2]=0;o=o+1|0}o=h+12|0;xGc(g,o,2);w=Ztc(517839)|0;n=b[g+11>>0]|0;if((w|0)==((n<<24>>24<0?f[g+4>>2]|0:n&255)|0)){n=(yGc(g,517839,w)|0)==0;gGc(g);if(n)wIc(o)}else gGc(g);CGc(m,i);nGc(m,0,517839)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];n=0;while(1){if((n|0)==3)break;f[m+(n<<2)>>2]=0;n=n+1|0}oGc(l,517894)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];n=0;while(1){if((n|0)==3)break;f[l+(n<<2)>>2]=0;n=n+1|0}n=b[o+11>>0]|0;w=n<<24>>24<0;UFc(k,w?f[o>>2]|0:o,w?f[h+16>>2]|0:n&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];n=0;while(1){if((n|0)==3)break;f[k+(n<<2)>>2]=0;n=n+1|0}n=f[q>>2]|0;o=n+-12|0;w=o+11|0;if((b[w>>0]|0)<0){x=f[o>>2]|0;b[g>>0]=0;_tc(x,g);f[n+-8>>2]=0}else{b[g>>0]=0;_tc(o,g);b[w>>0]=0}PGc(o);f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[o+8>>2]=f[j+8>>2];o=0;while(1){if((o|0)==3)break;f[j+(o<<2)>>2]=0;o=o+1|0}gGc(j);gGc(k);gGc(l);gGc(m);RFc(i);RFc(h);r=t}else r=a}else r=a;while(0);u=e;return r|0}function tGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;e=f[c>>2]|0;f[a+8>>2]=0;f[a+12>>2]=e;vIc(a);pGc(f[d>>2]|0,b);f[d>>2]=(f[d>>2]|0)+24;return}function uGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=((f[e>>2]|0)-(f[a>>2]|0)>>4)+1|0;h=qIc(a)|0;if(h>>>0<g>>>0)mCc(a);else{i=f[a>>2]|0;j=(f[a+8>>2]|0)-i|0;k=j>>3;rIc(d,j>>4>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,(f[e>>2]|0)-i>>4,a+12|0);i=d+8|0;e=f[i>>2]|0;f[e>>2]=0;h=e+4|0;f[h>>2]=0;k=f[b+12>>2]|0;f[e+8>>2]=0;f[e+12>>2]=k;f[e>>2]=f[b>>2];k=b+4|0;f[h>>2]=f[k>>2];h=b+8|0;f[e+8>>2]=f[h>>2];f[h>>2]=0;f[k>>2]=0;f[b>>2]=0;f[i>>2]=e+16;sIc(a,d);tIc(d);u=c;return}}function vGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+32|0;g=e+12|0;h=e;a:do if(((a|0)!=(c|0)?(b[a>>0]|0)==70:0)?(i=a+1|0,(i|0)!=(c|0)):0){if((b[i>>0]|0)==89){j=a+2|0;if((j|0)==(c|0)){k=a;break}else l=j}else l=i;i=kGc(l,c,d)|0;if((i|0)!=(l|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=Ztc(517847)|0;if(j>>>0>4294967279)dEc(h);if(j>>>0<11){m=h+11|0;b[m>>0]=j;n=h;o=m;p=h+4|0}else{m=j+16&-16;q=dGc(m)|0;f[h>>2]=q;f[h+8>>2]=m|-2147483648;m=h+4|0;f[m>>2]=j;n=q;o=h+11|0;p=m}etc(n,517847,j)|0;b[g>>0]=0;_tc(n+j|0,g);j=d+4|0;m=g+11|0;q=g+4|0;r=0;s=i;b:while(1){i=s;c:while(1){if((i|0)==(c|0)){t=15;break b}v=b[i>>0]|0;w=i+1|0;switch(v<<24>>24){case 69:{t=19;break b;break}case 118:{i=w;continue c;break}default:{}}x=(w|0)==(c|0);if(!(x|v<<24>>24!=82)?(b[w>>0]|0)==69:0){r=1;s=w;continue b}if(!(x|v<<24>>24!=79)?(b[w>>0]|0)==69:0){r=2;s=w;continue b}v=((f[j>>2]|0)-(f[d>>2]|0)|0)/24|0;x=kGc(i,c,d)|0;y=((f[j>>2]|0)-(f[d>>2]|0)|0)/24|0;if((x|0)==(i|0)|(x|0)==(c|0))break b;else z=v;while(1){if(z>>>0>=y>>>0){A=v;break}B=b[o>>0]|0;if((B<<24>>24<0?f[p>>2]|0:B&255)>>>0>1)oGc(h,518069)|0;CGc(g,(f[d>>2]|0)+(z*24|0)|0);B=b[m>>0]|0;C=B<<24>>24<0;UFc(h,C?f[g>>2]|0:g,C?f[q>>2]|0:B&255)|0;gGc(g);z=z+1|0}while(1){if(A>>>0>=y>>>0){i=x;continue c}v=f[j>>2]|0;B=v+-24|0;C=v;while(1){if((C|0)==(B|0))break;v=C+-24|0;f[j>>2]=v;RFc(v);C=f[j>>2]|0}A=A+1|0}}}d:do if((t|0)==15){q=f[j>>2]|0;m=q+-24|0;s=q;while(1){if((s|0)==(m|0))break d;q=s+-24|0;f[j>>2]=q;RFc(q);s=f[j>>2]|0}}else if((t|0)==19){oGc(h,517845)|0;switch(r&3){case 1:{oGc(h,519273)|0;break}case 2:{oGc(h,519276)|0;break}default:{}}s=f[j>>2]|0;if((f[d>>2]|0)!=(s|0)){oGc(s+-24|0,517879)|0;s=b[o>>0]|0;m=s<<24>>24<0;pIc((f[j>>2]|0)+-12|0,0,m?f[h>>2]|0:h,m?f[p>>2]|0:s&255)|0;gGc(h);k=w;break a}}while(0);gGc(h);k=a}else k=a}else k=a;while(0);u=e;return k|0}function wGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;if(((((a|0)!=(c|0)?(b[a>>0]|0)==77:0)?(n=a+1|0,o=kGc(n,c,d)|0,(o|0)!=(n|0)):0)?(n=kGc(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){HGc(h,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;RFc(q);p=f[o>>2]|0}HGc(i,c+-48|0);c=h+12|0;a:do if((b[((b[c+11>>0]|0)<0?f[c>>2]|0:c)>>0]|0)==40){oGc(h,517847)|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];p=0;while(1){if((p|0)==3)break;f[h+(p<<2)>>2]=0;p=p+1|0}CGc(m,i);p=b[m+11>>0]|0;d=p<<24>>24<0;UFc(l,d?f[m>>2]|0:m,d?f[m+4>>2]|0:p&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];p=0;while(1){if((p|0)==3)break;f[l+(p<<2)>>2]=0;p=p+1|0}oGc(k,519269)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];p=0;while(1){if((p|0)==3)break;f[k+(p<<2)>>2]=0;p=p+1|0}p=f[o>>2]|0;d=p+-24|0;q=d+11|0;if((b[q>>0]|0)<0){r=f[d>>2]|0;b[g>>0]=0;_tc(r,g);f[p+-20>>2]=0}else{b[g>>0]=0;_tc(d,g);b[q>>0]=0}PGc(d);f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];f[d+8>>2]=f[j+8>>2];d=0;while(1){if((d|0)==3)break;f[j+(d<<2)>>2]=0;d=d+1|0}gGc(j);gGc(k);gGc(m);gGc(l);nGc(c,0,517845)|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];d=0;while(1){if((d|0)==3)break;f[c+(d<<2)>>2]=0;d=d+1|0}d=f[o>>2]|0;q=d+-12|0;p=q+11|0;if((b[p>>0]|0)<0){r=f[q>>2]|0;b[g>>0]=0;_tc(r,g);f[d+-8>>2]=0}else{b[g>>0]=0;_tc(q,g);b[p>>0]=0}PGc(q);f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];q=0;while(1){if((q|0)==3)break;f[j+(q<<2)>>2]=0;q=q+1|0}gGc(j)}else{oGc(h,517879)|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];q=0;while(1){if((q|0)==3)break;f[h+(q<<2)>>2]=0;q=q+1|0}CGc(m,i);q=b[m+11>>0]|0;p=q<<24>>24<0;UFc(l,p?f[m>>2]|0:m,p?f[m+4>>2]|0:q&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];q=0;while(1){if((q|0)==3)break;f[l+(q<<2)>>2]=0;q=q+1|0}oGc(k,519269)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}q=f[o>>2]|0;p=q+-24|0;d=p+11|0;if((b[d>>0]|0)<0){r=f[p>>2]|0;b[g>>0]=0;_tc(r,g);f[q+-20>>2]=0}else{b[g>>0]=0;_tc(p,g);b[d>>0]=0}PGc(p);f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];p=0;while(1){if((p|0)==3)break;f[j+(p<<2)>>2]=0;p=p+1|0}gGc(j);gGc(k);gGc(m);gGc(l);p=f[o>>2]|0;d=p+-12|0;q=d+11|0;if((b[q>>0]|0)<0){r=f[d>>2]|0;b[g>>0]=0;_tc(r,g);f[p+-8>>2]=0}else{b[g>>0]=0;_tc(d,g);b[q>>0]=0}PGc(d);f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];f[d+8>>2]=f[c+8>>2];d=0;while(1){if((d|0)==3)break a;f[c+(d<<2)>>2]=0;d=d+1|0}}while(0);RFc(i);RFc(h);s=n}else s=a;u=e;return s|0}function xGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c+4>>2]|0:h&255;h=i?f[c>>2]|0:c;c=j>>>0<d>>>0?j:d;if(c>>>0>4294967279)dEc(a);if(c>>>0<11){b[a+11>>0]=c;k=a}else{d=c+16&-16;j=dGc(d)|0;f[a>>2]=j;f[a+8>>2]=d|-2147483648;f[a+4>>2]=c;k=j}etc(k,h,c)|0;b[g>>0]=0;_tc(k+c|0,g);u=e;return}function yGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=b[a+11>>0]|0;g=e<<24>>24<0;if(g)h=f[a+4>>2]|0;else h=e&255;if((d|0)==-1)eEc(a);if(g)i=f[a>>2]|0;else i=a;a=h>>>0>d>>>0;g=ODc(i,c,a?d:h)|0;if(!g)return (h>>>0<d>>>0?-1:a&1)|0;else return g|0;return 0}function zGc(a){a=a|0;oIc(a,Ztc(519266)|0);return}function AGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+64|0;g=e+40|0;h=e;i=e+24|0;j=a;a:do if((c-j|0)>1?(b[a>>0]|0)==84:0){k=b[a+1>>0]|0;l=d+62|0;m=d+32|0;if(k<<24>>24==95){n=f[d+36>>2]|0;if((f[m>>2]|0)==(n|0)){o=a;break}p=f[n+-16>>2]|0;q=a+2|0;if((p|0)==(f[n+-12>>2]|0)){nIc(g);n=d+4|0;r=f[n>>2]|0;if(r>>>0<(f[d+8>>2]|0)>>>0){HGc(r,g);f[n>>2]=(f[n>>2]|0)+24}else IGc(d,g);RFc(g);b[l>>0]=1;o=q;break}n=f[p+4>>2]|0;r=d+4|0;s=d+8|0;t=f[p>>2]|0;while(1){if((t|0)==(n|0)){o=q;break a}p=f[r>>2]|0;if((p|0)==(f[s>>2]|0))qGc(d,t);else{pGc(p,t);f[r>>2]=(f[r>>2]|0)+24}t=t+24|0}}t=(k<<24>>24)+-48|0;if(t>>>0<10){r=t;t=a+2|0;while(1){v=t+1|0;if((t|0)==(c|0)){o=a;break a}w=b[t>>0]|0;s=(w<<24>>24)+-48|0;if(s>>>0>=10)break;r=s+(r*10|0)|0;t=v}if(w<<24>>24==95?(t=f[d+36>>2]|0,(f[m>>2]|0)!=(t|0)):0){k=r+1|0;s=f[t+-16>>2]|0;q=s;if(k>>>0<(f[t+-12>>2]|0)-s>>4>>>0){s=f[q+(k<<4)+4>>2]|0;t=d+4|0;n=d+8|0;p=f[q+(k<<4)>>2]|0;while(1){if((p|0)==(s|0)){o=v;break a}k=f[t>>2]|0;if((k|0)==(f[n>>2]|0))qGc(d,p);else{pGc(k,p);f[t>>2]=(f[t>>2]|0)+24}p=p+24|0}};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=v-j|0;if(p>>>0>4294967279)dEc(i);if(p>>>0<11){b[i+11>>0]=p;x=i}else{t=p+16&-16;n=dGc(t)|0;f[i>>2]=n;f[i+8>>2]=t|-2147483648;f[i+4>>2]=p;x=n}n=a;t=x;while(1){if((n|0)==(v|0))break;_tc(t,n);n=n+1|0;t=t+1|0}b[g>>0]=0;_tc(x+p|0,g);FGc(h,i);t=d+4|0;n=f[t>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){HGc(n,h);f[t>>2]=(f[t>>2]|0)+24}else IGc(d,h);RFc(h);gGc(i);b[l>>0]=1;o=v}else o=a}else o=a}else o=a;while(0);u=e;return o|0}function BGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+64|0;g=e+32|0;h=e+16|0;i=e;j=e+4|0;do if((c-a|0)>1?(b[a>>0]|0)==73:0){k=d+61|0;l=d+32|0;a:do if(b[k>>0]|0){m=f[d+36>>2]|0;n=f[m+-16>>2]|0;o=m+-12|0;while(1){m=f[o>>2]|0;if((m|0)==(n|0))break a;p=m+-16|0;f[o>>2]=p;SFc(p)}}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=Ztc(517881)|0;if(o>>>0>4294967279)dEc(h);if(o>>>0<11){n=h+11|0;b[n>>0]=o;q=h;r=n;s=h+4|0}else{n=o+16&-16;p=dGc(n)|0;f[h>>2]=p;f[h+8>>2]=n|-2147483648;n=h+4|0;f[n>>2]=o;q=p;r=h+11|0;s=n}etc(q,517881,o)|0;b[g>>0]=0;_tc(q+o|0,g);o=d+4|0;n=d+36|0;p=d+12|0;m=g+11|0;t=g+4|0;v=d+40|0;w=a+1|0;b:while(1){if((b[w>>0]|0)==69)break;if(b[k>>0]|0){f[i>>2]=f[p>>2];x=f[n>>2]|0;if(x>>>0<(f[v>>2]|0)>>>0){fIc(g,i);f[x>>2]=0;f[x+4>>2]=0;y=f[g>>2]|0;f[x+8>>2]=0;f[x+12>>2]=y;f[n>>2]=(f[n>>2]|0)+16}else gIc(l,i)}y=((f[o>>2]|0)-(f[d>>2]|0)|0)/24|0;x=hIc(w,c,d)|0;z=((f[o>>2]|0)-(f[d>>2]|0)|0)/24|0;c:do if(b[k>>0]|0){A=f[n>>2]|0;B=A+-16|0;C=A;while(1){if((C|0)==(B|0))break c;A=C+-16|0;f[n>>2]=A;YFc(A);C=f[n>>2]|0}}while(0);if((x|0)==(w|0)|(x|0)==(c|0)){D=53;break}d:do if(!(b[k>>0]|0))E=y;else{C=f[n>>2]|0;B=f[p>>2]|0;f[g>>2]=B;A=C+-12|0;F=f[A>>2]|0;if(F>>>0<(f[C+-8>>2]|0)>>>0){f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=B;f[A>>2]=(f[A>>2]|0)+16}else mGc(C+-16|0,g);C=y;while(1){if(C>>>0>=z>>>0){E=y;break d}A=f[(f[n>>2]|0)+-12>>2]|0;B=(f[d>>2]|0)+(C*24|0)|0;F=A+-12|0;G=f[F>>2]|0;if((G|0)==(f[A+-8>>2]|0))qGc(A+-16|0,B);else{pGc(G,B);f[F>>2]=(f[F>>2]|0)+24}C=C+1|0}}while(0);while(1){if(E>>>0>=z>>>0){H=z;break}C=b[r>>0]|0;if((C<<24>>24<0?f[s>>2]|0:C&255)>>>0>1)oGc(h,518069)|0;CGc(g,(f[d>>2]|0)+(E*24|0)|0);C=b[m>>0]|0;F=C<<24>>24<0;UFc(h,F?f[g>>2]|0:g,F?f[t>>2]|0:C&255)|0;gGc(g);E=E+1|0}while(1){if((H|0)==(y|0)){w=x;continue b}z=f[o>>2]|0;C=z+-24|0;F=z;while(1){if((F|0)==(C|0))break;z=F+-24|0;f[o>>2]=z;RFc(z);F=f[o>>2]|0}H=H+-1|0}}if((D|0)==53){gGc(h);I=a;break}t=w+1|0;m=b[r>>0]|0;n=m<<24>>24<0;if((b[(n?f[h>>2]|0:h)+(n?f[s>>2]|0:m&255)+-1>>0]|0)==62)oGc(h,519260)|0;else oGc(h,517883)|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}FGc(g,j);m=f[o>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){HGc(m,g);f[o>>2]=(f[o>>2]|0)+24}else IGc(d,g);RFc(g);gGc(j);gGc(h);I=t}else I=a;while(0);u=e;return I|0}function CGc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=c+12|0;e=b[d+11>>0]|0;g=e<<24>>24<0;UFc(c,g?f[d>>2]|0:d,g?f[c+16>>2]|0:e&255)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function DGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;a:do if(((a|0)!=(c|0)?(j=(b[a>>0]|0)+-48|0,j>>>0<10):0)?(k=a+1|0,(k|0)!=(c|0)):0){l=j;j=k;while(1){k=(b[j>>0]|0)+-48|0;if(k>>>0>=10)break;m=j+1|0;if((m|0)==(c|0)){n=a;break a}l=k+(l*10|0)|0;j=m}if((c-j|0)>>>0>=l>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(l>>>0>4294967279)dEc(h);if(l>>>0<11){b[h+11>>0]=l;o=h}else{m=l+16&-16;k=dGc(m)|0;f[h>>2]=k;f[h+8>>2]=m|-2147483648;f[h+4>>2]=l;o=k}etc(o,j,l)|0;b[g>>0]=0;_tc(o+l|0,g);xGc(g,h,10);k=Ztc(519227)|0;m=b[g+11>>0]|0;if((k|0)==((m<<24>>24<0?f[g+4>>2]|0:m&255)|0))p=(yGc(g,519227,k)|0)==0;else p=0;gGc(g);if(p){eIc(g);k=d+4|0;m=f[k>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){HGc(m,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g)}else{f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}FGc(g,i);k=d+4|0;m=f[k>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){HGc(m,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);gGc(i)}gGc(h);n=j+l|0}else n=a}else n=a;while(0);u=e;return n|0}function EGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=0;while(1){if((h|0)==3)break;f[a+(h<<2)>>2]=0;h=h+1|0}h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;i=Ztc(d)|0;k=(b[h>>0]|0)<0?f[c>>2]|0:c;c=j+i|0;if(c>>>0>4294967279)dEc(a);if(c>>>0<11){b[a+11>>0]=j;l=a}else{h=c+16&-16;c=dGc(h)|0;f[a>>2]=c;f[a+8>>2]=h|-2147483648;f[a+4>>2]=j;l=c}etc(l,k,j)|0;b[g>>0]=0;_tc(l+j|0,g);UFc(a,d,i)|0;u=e;return}function FGc(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];c=0;while(1){if((c|0)==3)break;f[b+(c<<2)>>2]=0;c=c+1|0}c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function GGc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+11|0;if((b[g>>0]|0)<0){h=f[a>>2]|0;b[e>>0]=0;_tc(h,e);f[a+4>>2]=0}else{b[e>>0]=0;_tc(a,e);b[g>>0]=0}PGc(a);f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];g=0;while(1){if((g|0)==3)break;f[c+(g<<2)>>2]=0;g=g+1|0}g=a+12|0;h=c+12|0;c=g+11|0;if((b[c>>0]|0)<0){i=f[g>>2]|0;b[e>>0]=0;_tc(i,e);f[a+16>>2]=0}else{b[e>>0]=0;_tc(g,e);b[c>>0]=0}PGc(g);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];g=0;while(1){if((g|0)==3)break;f[h+(g<<2)>>2]=0;g=g+1|0}u=d;return}function HGc(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];c=0;while(1){if((c|0)==3)break;f[b+(c<<2)>>2]=0;c=c+1|0}c=a+12|0;a=b+12|0;f[c>>2]=f[a>>2];f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}return}function IGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=(((f[e>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;h=PHc(a)|0;if(h>>>0<g>>>0)mCc(a);else{i=f[a>>2]|0;j=((f[a+8>>2]|0)-i|0)/24|0;k=j<<1;QHc(d,j>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,((f[e>>2]|0)-i|0)/24|0,a+12|0);i=d+8|0;e=f[i>>2]|0;HGc(e,b);f[i>>2]=e+24;RHc(a,d);SHc(d);u=c;return}}
function uTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{bSb(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else bSb(c,g);g=f[d>>2]|0;if((g|0)>0){d=a+24|0;o=c+8|0;e=c+4|0;h=0;do{i=(f[d>>2]|0)+8+(h<<3)|0;n=f[i>>2]|0;k=f[i+4>>2]|0;if((f[o>>2]|0)>9){i=f[e>>2]|0;j=n&255;if(k>>>0>0|(k|0)==0&n>>>0>127){l=i;m=j;p=n;q=k;while(1){b[l>>0]=m|-128;r=p;p=aJc(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=i;v=j}b[u>>0]=v;q=u+1-i|0;f[e>>2]=(f[e>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else cSb(c,n,k);h=h+1|0}while((h|0)!=(g|0))}}g=f[a+4>>2]|0;if(!(g&1))return;Gjc(g&-2,c);return}function vTa(a){a=a|0;return f[a+12>>2]|0}function wTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=f[c>>2]|0;c=f[a+24>>2]|0;g=0;e=l+1|0;while(1){l=c+8+(g<<3)|0;i=f[l>>2]|0;h=f[l+4>>2]|0;l=i&255;if(h>>>0>0|(h|0)==0&i>>>0>127){j=e;k=l;n=i;i=h;while(1){b[j>>0]=k|-128;h=n;n=aJc(n|0,i|0,7)|0;o=j+1|0;p=n&255;if(!(i>>>0>0|(i|0)==0&h>>>0>16383)){q=o;r=p;break}else{j=o;k=p;i=J}}}else{q=e;r=l}b[q>>0]=r;i=q+1|0;g=g+1|0;if((g|0)>=(m|0)){s=i;break}else e=i}}else s=d;d=f[a+4>>2]|0;if(!(d&1)){t=s;return t|0}t=Hjc(d&-2,s)|0;return t|0}function xTa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function yTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,14952,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=c+16|0;e=f[g>>2]|0;if(!e)return;UHa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+8+(f[d>>2]<<3)|0,(f[c+24>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);return}function zTa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ATa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525080;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function BTa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220362]|0)!=2){f[c>>2]=161028;f[c+4>>2]=25;b[c+8>>0]=0;DTb(881448,c);ZSb(c)}d=VDc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=18;e=d;g=400995;h=e+18|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+18>>0]=0;Xbc(c,86872,87724,81432,0,525080,881336,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function CTa(){DTa();lYb(401014,18833);rhc(400995,1753);return}function DTa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220363]|0)!=2){f[c>>2]=161028;f[c+4>>2]=26;b[c+8>>0]=0;DTb(881452,c);ZSb(c)}if((f[220364]|0)!=2){f[c>>2]=161028;f[c+4>>2]=27;b[c+8>>0]=0;DTb(881456,c);ZSb(c)}if((f[220365]|0)!=2){f[c>>2]=161028;f[c+4>>2]=28;b[c+8>>0]=0;DTb(881460,c);ZSb(c)}if((f[220366]|0)!=2){f[c>>2]=161028;f[c+4>>2]=29;b[c+8>>0]=0;DTb(881464,c);ZSb(c)}if((f[220367]|0)!=2){f[c>>2]=161028;f[c+4>>2]=30;b[c+8>>0]=0;DTb(881468,c);ZSb(c)}if((f[220368]|0)!=2){f[c>>2]=161028;f[c+4>>2]=31;b[c+8>>0]=0;DTb(881472,c);ZSb(c)}if((f[220369]|0)!=2){f[c>>2]=161028;f[c+4>>2]=32;b[c+8>>0]=0;DTb(881476,c);ZSb(c)}if((f[220370]|0)!=2){f[c>>2]=161028;f[c+4>>2]=33;b[c+8>>0]=0;DTb(881480,c);ZSb(c)}if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}if((f[220372]|0)!=2){f[c>>2]=161028;f[c+4>>2]=35;b[c+8>>0]=0;DTb(881488,c);ZSb(c)}if((f[220373]|0)!=2){f[c>>2]=161028;f[c+4>>2]=36;b[c+8>>0]=0;DTb(881492,c);ZSb(c)}if((f[220374]|0)!=2){f[c>>2]=161028;f[c+4>>2]=37;b[c+8>>0]=0;DTb(881496,c);ZSb(c)}if((f[220375]|0)!=2){f[c>>2]=161028;f[c+4>>2]=38;b[c+8>>0]=0;DTb(881500,c);ZSb(c)}if((f[220376]|0)!=2){f[c>>2]=161028;f[c+4>>2]=39;b[c+8>>0]=0;DTb(881504,c);ZSb(c)}if((f[220377]|0)!=2){f[c>>2]=161028;f[c+4>>2]=40;b[c+8>>0]=0;DTb(881508,c);ZSb(c)}if((f[220378]|0)!=2){f[c>>2]=161028;f[c+4>>2]=41;b[c+8>>0]=0;DTb(881512,c);ZSb(c)}if((f[220379]|0)!=2){f[c>>2]=161028;f[c+4>>2]=42;b[c+8>>0]=0;DTb(881516,c);ZSb(c)}if((f[220380]|0)!=2){f[c>>2]=161028;f[c+4>>2]=43;b[c+8>>0]=0;DTb(881520,c);ZSb(c)}if((f[220381]|0)!=2){f[c>>2]=161028;f[c+4>>2]=44;b[c+8>>0]=0;DTb(881524,c);ZSb(c)}if((f[220382]|0)!=2){f[c>>2]=161028;f[c+4>>2]=45;b[c+8>>0]=0;DTb(881528,c);ZSb(c)}if((f[220383]|0)!=2){f[c>>2]=161028;f[c+4>>2]=46;b[c+8>>0]=0;DTb(881532,c);ZSb(c)}if((f[220384]|0)!=2){f[c>>2]=161028;f[c+4>>2]=47;b[c+8>>0]=0;DTb(881536,c);ZSb(c)}if((f[220385]|0)!=2){f[c>>2]=161028;f[c+4>>2]=48;b[c+8>>0]=0;DTb(881540,c);ZSb(c)}if((f[220386]|0)!=2){f[c>>2]=161028;f[c+4>>2]=49;b[c+8>>0]=0;DTb(881544,c);ZSb(c)}if((f[220387]|0)!=2){f[c>>2]=161028;f[c+4>>2]=50;b[c+8>>0]=0;DTb(881548,c);ZSb(c)}if((f[220388]|0)!=2){f[c>>2]=161028;f[c+4>>2]=51;b[c+8>>0]=0;DTb(881552,c);ZSb(c)}if((f[220389]|0)!=2){f[c>>2]=161028;f[c+4>>2]=52;b[c+8>>0]=0;DTb(881556,c);ZSb(c)}if((f[220390]|0)!=2){f[c>>2]=161028;f[c+4>>2]=53;b[c+8>>0]=0;DTb(881560,c);ZSb(c)}if((f[220391]|0)!=2){f[c>>2]=161028;f[c+4>>2]=54;b[c+8>>0]=0;DTb(881564,c);ZSb(c)}if((f[220392]|0)!=2){f[c>>2]=161028;f[c+4>>2]=55;b[c+8>>0]=0;DTb(881568,c);ZSb(c)}if((f[220393]|0)!=2){f[c>>2]=161028;f[c+4>>2]=56;b[c+8>>0]=0;DTb(881572,c);ZSb(c)}if((f[220394]|0)!=2){f[c>>2]=161028;f[c+4>>2]=57;b[c+8>>0]=0;DTb(881576,c);ZSb(c)}if((f[220395]|0)!=2){f[c>>2]=161028;f[c+4>>2]=58;b[c+8>>0]=0;DTb(881580,c);ZSb(c)}if((f[220396]|0)!=2){f[c>>2]=161028;f[c+4>>2]=59;b[c+8>>0]=0;DTb(881584,c);ZSb(c)}if((f[220397]|0)!=2){f[c>>2]=161028;f[c+4>>2]=60;b[c+8>>0]=0;DTb(881588,c);ZSb(c)}if((f[220398]|0)!=2){f[c>>2]=161028;f[c+4>>2]=61;b[c+8>>0]=0;DTb(881592,c);ZSb(c)}if((f[220399]|0)!=2){f[c>>2]=161028;f[c+4>>2]=62;b[c+8>>0]=0;DTb(881596,c);ZSb(c)}if((f[220400]|0)!=2){f[c>>2]=161028;f[c+4>>2]=63;b[c+8>>0]=0;DTb(881600,c);ZSb(c)}if((f[220401]|0)!=2){f[c>>2]=161028;f[c+4>>2]=64;b[c+8>>0]=0;DTb(881604,c);ZSb(c)}if((f[220402]|0)!=2){f[c>>2]=161028;f[c+4>>2]=65;b[c+8>>0]=0;DTb(881608,c);ZSb(c)}if((f[220403]|0)!=2){f[c>>2]=161028;f[c+4>>2]=66;b[c+8>>0]=0;DTb(881612,c);ZSb(c)}if((f[220404]|0)!=2){f[c>>2]=161028;f[c+4>>2]=67;b[c+8>>0]=0;DTb(881616,c);ZSb(c)}if((f[220405]|0)!=2){f[c>>2]=161028;f[c+4>>2]=68;b[c+8>>0]=0;DTb(881620,c);ZSb(c)}if((f[220406]|0)!=2){f[c>>2]=161028;f[c+4>>2]=69;b[c+8>>0]=0;DTb(881624,c);ZSb(c)}if((f[220407]|0)!=2){f[c>>2]=161028;f[c+4>>2]=70;b[c+8>>0]=0;DTb(881628,c);ZSb(c)}if((f[220408]|0)!=2){f[c>>2]=161028;f[c+4>>2]=71;b[c+8>>0]=0;DTb(881632,c);ZSb(c)}if((f[220409]|0)!=2){f[c>>2]=161028;f[c+4>>2]=72;b[c+8>>0]=0;DTb(881636,c);ZSb(c)}if((f[220410]|0)!=2){f[c>>2]=161028;f[c+4>>2]=73;b[c+8>>0]=0;DTb(881640,c);ZSb(c)}if((f[220411]|0)!=2){f[c>>2]=161028;f[c+4>>2]=74;b[c+8>>0]=0;DTb(881644,c);ZSb(c)}if((f[220412]|0)!=2){f[c>>2]=161028;f[c+4>>2]=75;b[c+8>>0]=0;DTb(881648,c);ZSb(c)}if((f[220413]|0)!=2){f[c>>2]=161028;f[c+4>>2]=76;b[c+8>>0]=0;DTb(881652,c);ZSb(c)}if((f[220414]|0)!=2){f[c>>2]=161028;f[c+4>>2]=77;b[c+8>>0]=0;DTb(881656,c);ZSb(c)}if((f[220415]|0)!=2){f[c>>2]=161028;f[c+4>>2]=78;b[c+8>>0]=0;DTb(881660,c);ZSb(c)}if((f[220416]|0)!=2){f[c>>2]=161028;f[c+4>>2]=79;b[c+8>>0]=0;DTb(881664,c);ZSb(c)}if((f[220417]|0)!=2){f[c>>2]=161028;f[c+4>>2]=80;b[c+8>>0]=0;DTb(881668,c);ZSb(c)}if((f[220418]|0)!=2){f[c>>2]=161028;f[c+4>>2]=81;b[c+8>>0]=0;DTb(881672,c);ZSb(c)}if((f[220419]|0)!=2){f[c>>2]=161028;f[c+4>>2]=82;b[c+8>>0]=0;DTb(881676,c);ZSb(c)}if((f[220420]|0)!=2){f[c>>2]=161028;f[c+4>>2]=83;b[c+8>>0]=0;DTb(881680,c);ZSb(c)}if((f[220421]|0)!=2){f[c>>2]=161028;f[c+4>>2]=84;b[c+8>>0]=0;DTb(881684,c);ZSb(c)}if((f[220422]|0)!=2){f[c>>2]=161028;f[c+4>>2]=85;b[c+8>>0]=0;DTb(881688,c);ZSb(c)}if((f[220423]|0)!=2){f[c>>2]=161028;f[c+4>>2]=86;b[c+8>>0]=0;DTb(881692,c);ZSb(c)}if((f[220424]|0)!=2){f[c>>2]=161028;f[c+4>>2]=87;b[c+8>>0]=0;DTb(881696,c);ZSb(c)}if((f[220425]|0)!=2){f[c>>2]=161028;f[c+4>>2]=88;b[c+8>>0]=0;DTb(881700,c);ZSb(c)}if((f[220426]|0)!=2){f[c>>2]=161028;f[c+4>>2]=89;b[c+8>>0]=0;DTb(881704,c);ZSb(c)}if((f[220427]|0)!=2){f[c>>2]=161028;f[c+4>>2]=90;b[c+8>>0]=0;DTb(881708,c);ZSb(c)}if((f[220428]|0)!=2){f[c>>2]=161028;f[c+4>>2]=91;b[c+8>>0]=0;DTb(881712,c);ZSb(c)}if((f[220429]|0)!=2){f[c>>2]=161028;f[c+4>>2]=92;b[c+8>>0]=0;DTb(881716,c);ZSb(c)}if((f[220430]|0)!=2){f[c>>2]=161028;f[c+4>>2]=93;b[c+8>>0]=0;DTb(881720,c);ZSb(c)}if((f[220431]|0)!=2){f[c>>2]=161028;f[c+4>>2]=94;b[c+8>>0]=0;DTb(881724,c);ZSb(c)}if((f[220432]|0)!=2){f[c>>2]=161028;f[c+4>>2]=95;b[c+8>>0]=0;DTb(881728,c);ZSb(c)}if((f[220433]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=96;b[c+8>>0]=0;DTb(881732,c);ZSb(c);u=a;return}function ETa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220361]|0)!=2){f[c>>2]=161028;f[c+4>>2]=24;b[c+8>>0]=0;DTb(881444,c);ZSb(c)}acc(525080,71);u=a;return}function FTa(){aTb(3005001,3005e3,419848);SQb();f[130282]=86772;f[130283]=0;f[130284]=0;f[130285]=0;f[130286]=0;f[130287]=0;f[130288]=0;zTb(521128);return}function GTa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220363]|0)!=2){f[c>>2]=161028;f[c+4>>2]=26;b[c+8>>0]=0;DTb(881452,c);ZSb(c)}f[130290]=88880;f[130291]=0;f[130298]=0;f[130299]=0;f[130300]=0;f[130302]=0;f[130303]=0;f[130304]=0;f[130306]=0;f[130307]=0;f[130308]=0;f[130292]=0;f[130293]=0;f[130294]=0;f[130295]=0;f[130296]=0;f[130310]=527320;f[130311]=0;f[130312]=0;f[130313]=0;f[130314]=0;f[130315]=0;f[130316]=0;zTb(521160);f[130311]=521128;u=a;return}function HTa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220364]|0)!=2){f[c>>2]=161028;f[c+4>>2]=27;b[c+8>>0]=0;DTb(881456,c);ZSb(c)}f[130318]=95468;f[130319]=0;f[130320]=0;f[130321]=0;f[130322]=0;f[130323]=0;f[130324]=0;f[130325]=0;zTb(521272);u=a;return}function ITa(){aTb(3005001,3005e3,419848);SQb();f[130326]=94604;f[130327]=0;f[130328]=0;f[130329]=0;f[130330]=0;f[130331]=0;f[130332]=0;zTb(521304);return}function JTa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}f[130334]=94496;f[130335]=0;f[130336]=0;f[130337]=0;f[130338]=0;b[521356]=1;b[521357]=1;n[130340]=1.000000013351432e-10;zTb(521336);f[130338]=521608;u=a;return}function KTa(){var a=0,c=0;aTb(3005001,3005e3,419848);SQb();f[130342]=94388;f[130343]=0;a=521376;c=a+112|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(c|0));b[521488]=1;b[521489]=1;n[130373]=.5;zTb(521368);return}function LTa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220390]|0)!=2){f[c>>2]=161028;f[c+4>>2]=53;b[c+8>>0]=0;DTb(881560,c);ZSb(c)}if((f[220391]|0)!=2){f[c>>2]=161028;f[c+4>>2]=54;b[c+8>>0]=0;DTb(881564,c);ZSb(c)}f[130374]=94712;f[130375]=0;f[130376]=0;f[130377]=0;f[130378]=0;f[130379]=0;f[130380]=0;f[130381]=0;f[130382]=0;f[130383]=0;f[130384]=-1;f[130385]=1;b[521544]=1;b[521545]=1;zTb(521496);f[130378]=523008;f[130379]=523040;u=a;return}function MTa(){aTb(3005001,3005e3,419848);SQb();f[130388]=95360;f[130389]=0;f[130390]=0;f[130391]=0;f[130392]=0;f[130393]=0;f[130394]=0;f[130395]=527320;f[130396]=0;f[130397]=0;f[130398]=0;f[130399]=0;b[521600]=0;zTb(521552);return}function NTa(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();f[131250]=0;f[131251]=0;f[131252]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=8;e=c;f[e>>2]=1936617315;f[e+4>>2]=1953390964;b[c+8>>0]=0;iEc(525e3,c)|0;if((b[d>>0]|0)<0)YDc(f[c>>2]|0);xTb(525e3);f[130402]=88556;f[130403]=0;f[130404]=0;f[130405]=0;f[130406]=525e3;f[130407]=0;f[130408]=0;f[130409]=0;f[130410]=0;f[130411]=-1;n[130412]=1.0;n[130413]=1.0;zTb(521608);u=a;return}function OTa(){var a=0,c=0,e=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220363]|0)!=2){f[c>>2]=161028;f[c+4>>2]=26;b[c+8>>0]=0;DTb(881452,c);ZSb(c)}if((f[220375]|0)!=2){f[c>>2]=161028;f[c+4>>2]=38;b[c+8>>0]=0;DTb(881500,c);ZSb(c)}if((f[220378]|0)!=2){f[c>>2]=161028;f[c+4>>2]=41;b[c+8>>0]=0;DTb(881512,c);ZSb(c)}if((f[220427]|0)!=2){f[c>>2]=161028;f[c+4>>2]=90;b[c+8>>0]=0;DTb(881708,c);ZSb(c)}f[130414]=95252;f[130415]=0;c=521664;e=c+84|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(e|0));f[130437]=527320;f[130438]=0;d[260878]=0;zTb(521656);f[130438]=522040;u=a;return}function PTa(){var a=0,c=0,e=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220372]|0)!=2){f[c>>2]=161028;f[c+4>>2]=35;b[c+8>>0]=0;DTb(881488,c);ZSb(c)}if((f[220375]|0)!=2){f[c>>2]=161028;f[c+4>>2]=38;b[c+8>>0]=0;DTb(881500,c);ZSb(c)};f[131254]=0;f[131255]=0;f[131256]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;e=c+11|0;b[e>>0]=2;d[c>>1]=12876;b[c+2>>0]=0;iEc(525016,c)|0;if((b[e>>0]|0)<0)YDc(f[c>>2]|0);xTb(525016);f[131258]=0;f[131259]=0;f[131260]=0;e=c+4|0;f[e>>2]=0;f[e+4>>2]=0;e=c+11|0;b[e>>0]=3;b[c>>0]=b[422235]|0;b[c+1>>0]=b[422236]|0;b[c+2>>0]=b[422237]|0;b[c+3>>0]=0;iEc(525032,c)|0;if((b[e>>0]|0)<0)YDc(f[c>>2]|0);xTb(525032);f[130440]=95144;c=521764;e=c+84|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(e|0));f[130462]=527320;f[130463]=527320;f[130464]=527320;f[130465]=527320;f[130466]=525016;f[130467]=525032;c=521872;e=c+64|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(e|0));n[130484]=.9990000128746033;c=521944;f[c>>2]=-1;f[c+4>>2]=-1;f[130488]=1;b[521956]=1;b[521957]=1;n[130490]=9.99999993922529e-09;f[130491]=1;n[130492]=-1.0;f[130493]=1;f[130494]=1;n[130495]=.9900000095367432;f[130496]=0;zTb(521760);f[130469]=521656;f[130468]=521656;f[130470]=522040;u=a;return}function QTa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220364]|0)!=2){f[c>>2]=161028;f[c+4>>2]=27;b[c+8>>0]=0;DTb(881456,c);ZSb(c)}f[130498]=95036;f[130499]=0;f[130500]=0;f[130501]=0;f[130502]=0;f[130503]=0;f[130504]=0;f[130505]=0;f[130506]=527320;c=522028;f[c>>2]=0;f[c+4>>2]=0;zTb(521992);u=a;return}function RTa(){aTb(3005001,3005e3,419848);SQb();f[130510]=94928;f[130511]=0;f[130512]=0;f[130513]=0;f[130514]=0;f[130515]=0;f[130516]=0;f[130517]=0;f[130518]=0;f[130519]=1;zTb(522040);return}function STa(){var a=0,b=0;aTb(3005001,3005e3,419848);SQb();f[130520]=92228;f[130521]=0;a=522088;b=a+52|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(b|0));zTb(522080);return}function TTa(){aTb(3005001,3005e3,419848);SQb();f[130536]=94820;f[130537]=0;f[130538]=0;f[130539]=0;f[130540]=527320;f[130541]=0;n[130542]=1.0;n[130543]=1.0;zTb(522144);return}function UTa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220377]|0)!=2){f[c>>2]=161028;f[c+4>>2]=40;b[c+8>>0]=0;DTb(881508,c);ZSb(c)}if((f[220364]|0)!=2){f[c>>2]=161028;f[c+4>>2]=27;b[c+8>>0]=0;DTb(881456,c);ZSb(c)}if((f[220376]|0)!=2){f[c>>2]=161028;f[c+4>>2]=39;b[c+8>>0]=0;DTb(881504,c);ZSb(c)}if((f[220379]|0)!=2){f[c>>2]=161028;f[c+4>>2]=42;b[c+8>>0]=0;DTb(881516,c);ZSb(c)}if((f[220380]|0)!=2){f[c>>2]=161028;f[c+4>>2]=43;b[c+8>>0]=0;DTb(881520,c);ZSb(c)}if((f[220381]|0)!=2){f[c>>2]=161028;f[c+4>>2]=44;b[c+8>>0]=0;DTb(881524,c);ZSb(c)}if((f[220382]|0)!=2){f[c>>2]=161028;f[c+4>>2]=45;b[c+8>>0]=0;DTb(881528,c);ZSb(c)}if((f[220384]|0)!=2){f[c>>2]=161028;f[c+4>>2]=47;b[c+8>>0]=0;DTb(881536,c);ZSb(c)}if((f[220385]|0)!=2){f[c>>2]=161028;f[c+4>>2]=48;b[c+8>>0]=0;DTb(881540,c);ZSb(c)}if((f[220383]|0)!=2){f[c>>2]=161028;f[c+4>>2]=46;b[c+8>>0]=0;DTb(881532,c);ZSb(c)}if((f[220386]|0)!=2){f[c>>2]=161028;f[c+4>>2]=49;b[c+8>>0]=0;DTb(881544,c);ZSb(c)}if((f[220387]|0)!=2){f[c>>2]=161028;f[c+4>>2]=50;b[c+8>>0]=0;DTb(881548,c);ZSb(c)}if((f[220388]|0)!=2){f[c>>2]=161028;f[c+4>>2]=51;b[c+8>>0]=0;DTb(881552,c);ZSb(c)}if((f[220389]|0)!=2){f[c>>2]=161028;f[c+4>>2]=52;b[c+8>>0]=0;DTb(881556,c);ZSb(c)}if((f[220369]|0)!=2){f[c>>2]=161028;f[c+4>>2]=32;b[c+8>>0]=0;DTb(881476,c);ZSb(c)}if((f[220392]|0)!=2){f[c>>2]=161028;f[c+4>>2]=55;b[c+8>>0]=0;DTb(881568,c);ZSb(c)}if((f[220393]|0)!=2){f[c>>2]=161028;f[c+4>>2]=56;b[c+8>>0]=0;DTb(881572,c);ZSb(c)}if((f[220394]|0)!=2){f[c>>2]=161028;f[c+4>>2]=57;b[c+8>>0]=0;DTb(881576,c);ZSb(c)}if((f[220395]|0)!=2){f[c>>2]=161028;f[c+4>>2]=58;b[c+8>>0]=0;DTb(881580,c);ZSb(c)}if((f[220396]|0)!=2){f[c>>2]=161028;f[c+4>>2]=59;b[c+8>>0]=0;DTb(881584,c);ZSb(c)}if((f[220397]|0)!=2){f[c>>2]=161028;f[c+4>>2]=60;b[c+8>>0]=0;DTb(881588,c);ZSb(c)}if((f[220398]|0)!=2){f[c>>2]=161028;f[c+4>>2]=61;b[c+8>>0]=0;DTb(881592,c);ZSb(c)}if((f[220399]|0)!=2){f[c>>2]=161028;f[c+4>>2]=62;b[c+8>>0]=0;DTb(881596,c);ZSb(c)}if((f[220400]|0)!=2){f[c>>2]=161028;f[c+4>>2]=63;b[c+8>>0]=0;DTb(881600,c);ZSb(c)}if((f[220401]|0)!=2){f[c>>2]=161028;f[c+4>>2]=64;b[c+8>>0]=0;DTb(881604,c);ZSb(c)}if((f[220402]|0)!=2){f[c>>2]=161028;f[c+4>>2]=65;b[c+8>>0]=0;DTb(881608,c);ZSb(c)}if((f[220403]|0)!=2){f[c>>2]=161028;f[c+4>>2]=66;b[c+8>>0]=0;DTb(881612,c);ZSb(c)}if((f[220404]|0)!=2){f[c>>2]=161028;f[c+4>>2]=67;b[c+8>>0]=0;DTb(881616,c);ZSb(c)}if((f[220405]|0)!=2){f[c>>2]=161028;f[c+4>>2]=68;b[c+8>>0]=0;DTb(881620,c);ZSb(c)}if((f[220406]|0)!=2){f[c>>2]=161028;f[c+4>>2]=69;b[c+8>>0]=0;DTb(881624,c);ZSb(c)}if((f[220407]|0)!=2){f[c>>2]=161028;f[c+4>>2]=70;b[c+8>>0]=0;DTb(881628,c);ZSb(c)}if((f[220408]|0)!=2){f[c>>2]=161028;f[c+4>>2]=71;b[c+8>>0]=0;DTb(881632,c);ZSb(c)}if((f[220409]|0)!=2){f[c>>2]=161028;f[c+4>>2]=72;b[c+8>>0]=0;DTb(881636,c);ZSb(c)}if((f[220367]|0)!=2){f[c>>2]=161028;f[c+4>>2]=30;b[c+8>>0]=0;DTb(881468,c);ZSb(c)}if((f[220366]|0)!=2){f[c>>2]=161028;f[c+4>>2]=29;b[c+8>>0]=0;DTb(881464,c);ZSb(c)}if((f[220410]|0)!=2){f[c>>2]=161028;f[c+4>>2]=73;b[c+8>>0]=0;DTb(881640,c);ZSb(c)}if((f[220411]|0)!=2){f[c>>2]=161028;f[c+4>>2]=74;b[c+8>>0]=0;DTb(881644,c);ZSb(c)}if((f[220412]|0)!=2){f[c>>2]=161028;f[c+4>>2]=75;b[c+8>>0]=0;DTb(881648,c);ZSb(c)}if((f[220429]|0)!=2){f[c>>2]=161028;f[c+4>>2]=92;b[c+8>>0]=0;DTb(881716,c);ZSb(c)}if((f[220368]|0)!=2){f[c>>2]=161028;f[c+4>>2]=31;b[c+8>>0]=0;DTb(881472,c);ZSb(c)}if((f[220432]|0)!=2){f[c>>2]=161028;f[c+4>>2]=95;b[c+8>>0]=0;DTb(881728,c);ZSb(c)}if((f[220433]|0)!=2){f[c>>2]=161028;f[c+4>>2]=96;b[c+8>>0]=0;DTb(881732,c);ZSb(c)}if((f[220413]|0)!=2){f[c>>2]=161028;f[c+4>>2]=76;b[c+8>>0]=0;DTb(881652,c);ZSb(c)}if((f[220414]|0)!=2){f[c>>2]=161028;f[c+4>>2]=77;b[c+8>>0]=0;DTb(881656,c);ZSb(c)}if((f[220415]|0)!=2){f[c>>2]=161028;f[c+4>>2]=78;b[c+8>>0]=0;DTb(881660,c);ZSb(c)}if((f[220416]|0)!=2){f[c>>2]=161028;f[c+4>>2]=79;b[c+8>>0]=0;DTb(881664,c);ZSb(c)}if((f[220417]|0)!=2){f[c>>2]=161028;f[c+4>>2]=80;b[c+8>>0]=0;DTb(881668,c);ZSb(c)}if((f[220431]|0)!=2){f[c>>2]=161028;f[c+4>>2]=94;b[c+8>>0]=0;DTb(881724,c);ZSb(c)}if((f[220418]|0)!=2){f[c>>2]=161028;f[c+4>>2]=81;b[c+8>>0]=0;DTb(881672,c);ZSb(c)}if((f[220419]|0)!=2){f[c>>2]=161028;f[c+4>>2]=82;b[c+8>>0]=0;DTb(881676,c);ZSb(c)}if((f[220421]|0)!=2){f[c>>2]=161028;f[c+4>>2]=84;b[c+8>>0]=0;DTb(881684,c);ZSb(c)}if((f[220426]|0)!=2){f[c>>2]=161028;f[c+4>>2]=89;b[c+8>>0]=0;DTb(881704,c);ZSb(c)}if((f[220420]|0)!=2){f[c>>2]=161028;f[c+4>>2]=83;b[c+8>>0]=0;DTb(881680,c);ZSb(c)}if((f[220422]|0)!=2){f[c>>2]=161028;f[c+4>>2]=85;b[c+8>>0]=0;DTb(881688,c);ZSb(c)}if((f[220424]|0)!=2){f[c>>2]=161028;f[c+4>>2]=87;b[c+8>>0]=0;DTb(881696,c);ZSb(c)}if((f[220423]|0)!=2){f[c>>2]=161028;f[c+4>>2]=86;b[c+8>>0]=0;DTb(881692,c);ZSb(c)}if((f[220425]|0)==2){f[130544]=94280;XIc(522180,0,132)|0;f[130578]=527320;f[130579]=527320;XIc(522320,0,224)|0;zTb(522176);f[130580]=522544;f[130581]=522592;f[130582]=522624;f[130583]=522656;f[130619]=522712;f[130621]=522744;f[130584]=522688;f[130585]=522776;f[130586]=522800;f[130624]=522920;f[130587]=522952;f[130627]=521496;f[130588]=523080;f[130589]=523104;f[130590]=523200;f[130620]=523240;f[130617]=523264;f[130591]=523304;f[130615]=523336;f[130592]=523360;f[130593]=523392;f[130594]=523416;f[130595]=523440;f[130596]=523504;f[130597]=523528;f[130623]=523568;f[130614]=523600;f[130598]=523632;f[130599]=523672;f[130600]=523704;f[130629]=521336;f[130628]=521304;f[130625]=523728;f[130601]=523752;f[130602]=523824;f[130611]=524800;f[130630]=521368;f[130631]=524904;f[130632]=524968;f[130610]=523856;f[130626]=523888;f[130616]=523920;f[130603]=523952;f[130613]=523976;f[130633]=524872;f[130622]=524008;f[130604]=524048;f[130605]=524112;f[130612]=524272;f[130606]=524072;f[130607]=524136;f[130608]=524184;f[130618]=524160;f[130609]=524208;u=a;return}f[c>>2]=161028;f[c+4>>2]=88;b[c+8>>0]=0;DTb(881700,c);ZSb(c);f[130544]=94280;XIc(522180,0,132)|0;f[130578]=527320;f[130579]=527320;XIc(522320,0,224)|0;zTb(522176);f[130580]=522544;f[130581]=522592;f[130582]=522624;f[130583]=522656;f[130619]=522712;f[130621]=522744;f[130584]=522688;f[130585]=522776;f[130586]=522800;f[130624]=522920;f[130587]=522952;f[130627]=521496;f[130588]=523080;f[130589]=523104;f[130590]=523200;f[130620]=523240;f[130617]=523264;f[130591]=523304;f[130615]=523336;f[130592]=523360;f[130593]=523392;f[130594]=523416;f[130595]=523440;f[130596]=523504;f[130597]=523528;f[130623]=523568;f[130614]=523600;f[130598]=523632;f[130599]=523672;f[130600]=523704;f[130629]=521336;f[130628]=521304;f[130625]=523728;f[130601]=523752;f[130602]=523824;f[130611]=524800;f[130630]=521368;f[130631]=524904;f[130632]=524968;f[130610]=523856;f[130626]=523888;f[130616]=523920;f[130603]=523952;f[130613]=523976;f[130633]=524872;f[130622]=524008;f[130604]=524048;f[130605]=524112;f[130612]=524272;f[130606]=524072;f[130607]=524136;f[130608]=524184;f[130618]=524160;f[130609]=524208;u=a;return}function VTa(){aTb(3005001,3005e3,419848);SQb();f[130636]=89744;f[130637]=0;f[130638]=0;f[130639]=0;f[130640]=0;f[130641]=0;f[130642]=0;f[130643]=527320;f[130644]=0;d[261290]=0;b[522582]=0;n[130646]=1.0;zTb(522544);return}function WTa(){aTb(3005001,3005e3,419848);SQb();f[130648]=89096;f[130649]=0;f[130650]=0;f[130651]=0;f[130652]=0;b[522612]=0;f[130654]=1;zTb(522592);return}function XTa(){aTb(3005001,3005e3,419848);SQb();f[130656]=90284;f[130657]=0;f[130658]=0;f[130659]=0;f[130660]=0;f[130661]=1;f[130662]=1;zTb(522624);return}function YTa(){aTb(3005001,3005e3,419848);SQb();f[130664]=90716;f[130665]=0;f[130666]=0;f[130667]=0;f[130668]=0;f[130669]=0;f[130670]=1;zTb(522656);return}function ZTa(){aTb(3005001,3005e3,419848);SQb();f[130672]=92120;f[130673]=0;f[130674]=0;f[130675]=0;f[130676]=1;f[130677]=1;zTb(522688);return}function _Ta(){aTb(3005001,3005e3,419848);SQb();f[130678]=94172;f[130679]=0;f[130680]=0;f[130681]=0;d[261364]=0;n[130683]=.9990000128746033;n[130684]=9.999999747378752e-06;zTb(522712);return}function $Ta(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}f[130686]=94064;f[130687]=0;f[130688]=0;f[130689]=0;f[130690]=0;f[130691]=1;f[130692]=1;zTb(522744);f[130690]=521608;u=a;return}function aUa(){aTb(3005001,3005e3,419848);SQb();f[130694]=89312;f[130695]=0;f[130696]=0;f[130697]=0;b[522792]=0;n[130699]=1.0;zTb(522776);return}function bUa(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}f[130700]=92012;f[130701]=0;c=522808;d=c+96|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));b[522904]=0;f[130727]=1;b[522912]=1;f[130729]=1;zTb(522800);f[130716]=521608;f[130717]=521608;u=a;return}function cUa(){aTb(3005001,3005e3,419848);SQb();f[130730]=93956;f[130731]=0;f[130732]=0;f[130733]=0;f[130734]=0;f[130735]=0;f[130736]=0;f[130737]=2;zTb(522920);return}function dUa(){aTb(3005001,3005e3,419848);SQb();f[130738]=91904;f[130739]=0;f[130740]=0;f[130741]=0;f[130742]=527320;f[130743]=527320;f[130744]=0;f[130745]=0;f[130746]=0;f[130747]=0;f[130748]=0;n[130749]=1.0;f[130750]=4;zTb(522952);return}function eUa(){aTb(3005001,3005e3,419848);SQb();f[130752]=93848;f[130753]=0;f[130754]=0;f[130755]=0;f[130756]=0;n[130757]=.30000001192092896;n[130758]=1.0;zTb(523008);return}function fUa(){aTb(3005001,3005e3,419848);SQb();f[130760]=93740;f[130761]=0;f[130762]=0;f[130763]=0;f[130764]=527320;f[130765]=527320;f[130766]=527320;f[130767]=527320;f[130768]=527320;f[130769]=0;zTb(523040);return}function gUa(){aTb(3005001,3005e3,419848);SQb();f[130770]=91796;f[130771]=0;f[130772]=0;f[130773]=0;n[130774]=.5;b[523100]=1;zTb(523080);return}function hUa(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}if((f[220363]|0)!=2){f[c>>2]=161028;f[c+4>>2]=26;b[c+8>>0]=0;DTb(881452,c);ZSb(c)}f[130776]=90392;f[130777]=0;c=523112;d=c+88|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));zTb(523104);u=a;return}function iUa(){aTb(3005001,3005e3,419848);SQb();f[130800]=90608;f[130801]=0;f[130802]=0;f[130803]=0;f[130804]=0;f[130805]=0;f[130806]=0;f[130807]=1;b[523232]=1;zTb(523200);return}function jUa(){aTb(3005001,3005e3,419848);SQb();f[130810]=93632;f[130811]=0;f[130812]=0;f[130813]=0;n[130814]=1.0;zTb(523240);return}function kUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}f[130816]=93524;f[130817]=0;f[130818]=0;f[130819]=0;f[130820]=0;f[130821]=0;f[130822]=0;f[130823]=0;b[523296]=1;zTb(523264);f[130820]=521608;f[130821]=521608;u=a;return}function lUa(){aTb(3005001,3005e3,419848);SQb();f[130826]=89204;f[130827]=0;f[130828]=0;f[130829]=0;n[130830]=0.0;n[130831]=-1.0;n[130832]=1.0;zTb(523304);return}function mUa(){aTb(3005001,3005e3,419848);SQb();f[130834]=93416;f[130835]=0;f[130836]=0;f[130837]=0;f[130838]=1;f[130839]=-1;zTb(523336);return}function nUa(){aTb(3005001,3005e3,419848);SQb();f[130840]=91688;f[130841]=0;f[130842]=0;f[130843]=0;f[130844]=527320;f[130845]=0;b[523384]=0;zTb(523360);return}function oUa(){aTb(3005001,3005e3,419848);SQb();f[130848]=88772;f[130849]=0;f[130850]=0;f[130851]=0;f[130852]=527320;zTb(523392);return}function pUa(){aTb(3005001,3005e3,419848);SQb();f[130854]=90176;f[130855]=0;f[130856]=0;f[130857]=0;f[130858]=1;zTb(523416);return}function qUa(){aTb(3005001,3005e3,419848);SQb();f[130860]=91580;f[130861]=0;f[130862]=0;f[130863]=0;f[130864]=527320;f[130865]=527320;f[130866]=527320;f[130867]=0;f[130868]=0;f[130869]=0;f[130870]=0;f[130871]=0;b[523488]=1;n[130873]=1.0;f[130874]=1;zTb(523440);return}function rUa(){aTb(3005001,3005e3,419848);SQb();f[130876]=91472;f[130877]=0;f[130878]=0;f[130879]=0;f[130880]=527320;zTb(523504);return}function sUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}f[130882]=91364;f[130883]=0;f[130884]=0;f[130885]=0;f[130886]=0;f[130887]=0;f[130888]=0;b[523556]=0;b[523557]=1;f[130890]=1;zTb(523528);f[130886]=521608;f[130887]=521608;u=a;return}function tUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220363]|0)!=2){f[c>>2]=161028;f[c+4>>2]=26;b[c+8>>0]=0;DTb(881452,c);ZSb(c)}f[130892]=93308;f[130893]=0;f[130894]=0;f[130895]=0;f[130896]=0;f[130897]=0;f[130898]=0;f[130899]=0;zTb(523568);u=a;return}function uUa(){aTb(3005001,3005e3,419848);SQb();f[130900]=93200;f[130901]=0;f[130902]=0;f[130903]=0;n[130904]=0.0;n[130905]=-1.0;n[130906]=1.0;zTb(523600);return}function vUa(){aTb(3005001,3005e3,419848);SQb();f[130908]=91256;f[130909]=0;f[130910]=0;f[130911]=0;f[130912]=0;f[130913]=0;f[130914]=5;n[130915]=1.0;n[130916]=.75;n[130917]=1.0;zTb(523632);return}function wUa(){aTb(3005001,3005e3,419848);SQb();f[130918]=90824;f[130919]=0;f[130920]=0;f[130921]=0;f[130922]=0;f[130923]=0;f[130924]=0;f[130925]=0;zTb(523672);return}function xUa(){aTb(3005001,3005e3,419848);SQb();f[130926]=89852;f[130927]=0;f[130928]=0;f[130929]=0;b[523720]=0;b[523721]=1;n[130931]=9.999999717180685e-10;zTb(523704);return}function yUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220363]|0)!=2){f[c>>2]=161028;f[c+4>>2]=26;b[c+8>>0]=0;DTb(881452,c);ZSb(c)}f[130932]=93092;f[130933]=0;f[130934]=0;f[130935]=0;f[130936]=0;zTb(523728);f[130936]=521128;u=a;return}function zUa(){var a=0,c=0;aTb(3005001,3005e3,419848);SQb();f[130938]=91148;f[130939]=0;a=523760;c=a+48|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(c|0));b[523808]=0;f[130953]=1;b[523816]=1;zTb(523752);return}function AUa(){aTb(3005001,3005e3,419848);SQb();f[130956]=90932;f[130957]=0;f[130958]=0;f[130959]=0;n[130960]=0.0;n[130961]=1.0;n[130962]=1.0;zTb(523824);return}function BUa(){aTb(3005001,3005e3,419848);SQb();f[130964]=92984;f[130965]=0;f[130966]=0;f[130967]=0;f[130968]=527320;f[130969]=527320;f[130970]=527320;b[523884]=0;zTb(523856);return}function CUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}f[130972]=92876;f[130973]=0;f[130974]=0;f[130975]=0;f[130976]=0;f[130977]=0;f[130978]=0;d[261958]=0;zTb(523888);f[130976]=521608;f[130977]=521608;u=a;return}function DUa(){aTb(3005001,3005e3,419848);SQb();f[130980]=92768;f[130981]=0;f[130982]=0;f[130983]=0;f[130984]=0;f[130985]=1;n[130986]=1.0;zTb(523920);return}function EUa(){aTb(3005001,3005e3,419848);SQb();f[130988]=90068;f[130989]=0;f[130990]=0;f[130991]=0;f[130992]=0;f[130993]=0;zTb(523952);return}function FUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220363]|0)!=2){f[c>>2]=161028;f[c+4>>2]=26;b[c+8>>0]=0;DTb(881452,c);ZSb(c)}f[130994]=92660;f[130995]=0;f[130996]=0;f[130997]=0;f[130998]=0;f[130999]=0;f[131e3]=-1;zTb(523976);f[130998]=521128;u=a;return}function GUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}f[131002]=92552;f[131003]=0;f[131004]=0;f[131005]=0;f[131006]=0;f[131007]=0;b[524032]=0;f[131009]=1;f[131010]=1;zTb(524008);f[131006]=521608;f[131007]=521608;u=a;return}function HUa(){aTb(3005001,3005e3,419848);SQb();f[131012]=89528;f[131013]=0;f[131014]=0;f[131015]=0;f[131016]=0;zTb(524048);return}function IUa(){aTb(3005001,3005e3,419848);SQb();f[131018]=89960;f[131019]=0;f[131020]=0;f[131021]=0;f[131022]=0;f[131023]=0;f[131024]=0;f[131025]=1;f[131026]=1;zTb(524072);return}function JUa(){aTb(3005001,3005e3,419848);SQb();f[131028]=89420;f[131029]=0;f[131030]=0;f[131031]=0;f[131032]=0;f[131033]=1;zTb(524112);return}function KUa(){aTb(3005001,3005e3,419848);SQb();f[131034]=89636;f[131035]=0;f[131036]=0;f[131037]=0;f[131038]=0;zTb(524136);return}function LUa(){aTb(3005001,3005e3,419848);SQb();f[131040]=92444;f[131041]=0;f[131042]=0;f[131043]=0;f[131044]=0;f[131045]=1;zTb(524160);return}function MUa(){aTb(3005001,3005e3,419848);SQb();f[131046]=90500;f[131047]=0;f[131048]=0;f[131049]=0;n[131050]=0.0;zTb(524184);return}function NUa(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();f[131262]=0;f[131263]=0;f[131264]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=4;f[c>>2]=1886544247;b[c+4>>0]=0;iEc(525048,c)|0;if((b[d>>0]|0)<0)YDc(f[c>>2]|0);xTb(525048);f[131052]=91040;f[131053]=0;f[131054]=0;f[131055]=0;f[131056]=527320;f[131057]=527320;f[131058]=525048;f[131059]=527320;f[131060]=0;f[131061]=0;f[131062]=0;f[131063]=0;n[131064]=1.0;n[131065]=.5;n[131066]=.5;n[131067]=.25;zTb(524208);u=a;return}function OUa(){aTb(3005001,3005e3,419848);SQb();f[131068]=92336;f[131069]=0;f[131070]=0;f[131071]=0;f[131072]=0;f[131073]=0;f[131074]=0;zTb(524272);return}function PUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220376]|0)!=2){f[c>>2]=161028;f[c+4>>2]=39;b[c+8>>0]=0;DTb(881504,c);ZSb(c)}if((f[220364]|0)!=2){f[c>>2]=161028;f[c+4>>2]=27;b[c+8>>0]=0;DTb(881456,c);ZSb(c)}if((f[220381]|0)!=2){f[c>>2]=161028;f[c+4>>2]=44;b[c+8>>0]=0;DTb(881524,c);ZSb(c)}if((f[220382]|0)!=2){f[c>>2]=161028;f[c+4>>2]=45;b[c+8>>0]=0;DTb(881528,c);ZSb(c)}if((f[220383]|0)!=2){f[c>>2]=161028;f[c+4>>2]=46;b[c+8>>0]=0;DTb(881532,c);ZSb(c)}if((f[220386]|0)!=2){f[c>>2]=161028;f[c+4>>2]=49;b[c+8>>0]=0;DTb(881544,c);ZSb(c)}if((f[220387]|0)!=2){f[c>>2]=161028;f[c+4>>2]=50;b[c+8>>0]=0;DTb(881548,c);ZSb(c)}if((f[220389]|0)!=2){f[c>>2]=161028;f[c+4>>2]=52;b[c+8>>0]=0;DTb(881556,c);ZSb(c)}if((f[220392]|0)!=2){f[c>>2]=161028;f[c+4>>2]=55;b[c+8>>0]=0;DTb(881568,c);ZSb(c)}if((f[220393]|0)!=2){f[c>>2]=161028;f[c+4>>2]=56;b[c+8>>0]=0;DTb(881572,c);ZSb(c)}if((f[220394]|0)!=2){f[c>>2]=161028;f[c+4>>2]=57;b[c+8>>0]=0;DTb(881576,c);ZSb(c)}if((f[220397]|0)!=2){f[c>>2]=161028;f[c+4>>2]=60;b[c+8>>0]=0;DTb(881588,c);ZSb(c)}if((f[220399]|0)!=2){f[c>>2]=161028;f[c+4>>2]=62;b[c+8>>0]=0;DTb(881596,c);ZSb(c)}if((f[220400]|0)!=2){f[c>>2]=161028;f[c+4>>2]=63;b[c+8>>0]=0;DTb(881600,c);ZSb(c)}if((f[220401]|0)!=2){f[c>>2]=161028;f[c+4>>2]=64;b[c+8>>0]=0;DTb(881604,c);ZSb(c)}if((f[220402]|0)!=2){f[c>>2]=161028;f[c+4>>2]=65;b[c+8>>0]=0;DTb(881608,c);ZSb(c)}if((f[220403]|0)!=2){f[c>>2]=161028;f[c+4>>2]=66;b[c+8>>0]=0;DTb(881612,c);ZSb(c)}if((f[220404]|0)!=2){f[c>>2]=161028;f[c+4>>2]=67;b[c+8>>0]=0;DTb(881616,c);ZSb(c)}if((f[220407]|0)!=2){f[c>>2]=161028;f[c+4>>2]=70;b[c+8>>0]=0;DTb(881628,c);ZSb(c)}if((f[220408]|0)!=2){f[c>>2]=161028;f[c+4>>2]=71;b[c+8>>0]=0;DTb(881632,c);ZSb(c)}if((f[220409]|0)!=2){f[c>>2]=161028;f[c+4>>2]=72;b[c+8>>0]=0;DTb(881636,c);ZSb(c)}if((f[220411]|0)!=2){f[c>>2]=161028;f[c+4>>2]=74;b[c+8>>0]=0;DTb(881644,c);ZSb(c)}if((f[220412]|0)!=2){f[c>>2]=161028;f[c+4>>2]=75;b[c+8>>0]=0;DTb(881648,c);ZSb(c)}if((f[220416]|0)!=2){f[c>>2]=161028;f[c+4>>2]=79;b[c+8>>0]=0;DTb(881664,c);ZSb(c)}if((f[220419]|0)!=2){f[c>>2]=161028;f[c+4>>2]=82;b[c+8>>0]=0;DTb(881676,c);ZSb(c)}if((f[220421]|0)!=2){f[c>>2]=161028;f[c+4>>2]=84;b[c+8>>0]=0;DTb(881684,c);ZSb(c)}if((f[220420]|0)!=2){f[c>>2]=161028;f[c+4>>2]=83;b[c+8>>0]=0;DTb(881680,c);ZSb(c)}if((f[220422]|0)!=2){f[c>>2]=161028;f[c+4>>2]=85;b[c+8>>0]=0;DTb(881688,c);ZSb(c)}if((f[220424]|0)!=2){f[c>>2]=161028;f[c+4>>2]=87;b[c+8>>0]=0;DTb(881696,c);ZSb(c)}if((f[220425]|0)!=2){f[c>>2]=161028;f[c+4>>2]=88;b[c+8>>0]=0;DTb(881700,c);ZSb(c)}if((f[220379]|0)!=2){f[c>>2]=161028;f[c+4>>2]=42;b[c+8>>0]=0;DTb(881516,c);ZSb(c)}if((f[220380]|0)!=2){f[c>>2]=161028;f[c+4>>2]=43;b[c+8>>0]=0;DTb(881520,c);ZSb(c)}if((f[220428]|0)==2){f[131076]=88988;XIc(524308,0,156)|0;f[131116]=527320;XIc(524468,0,132)|0;zTb(524304);f[131136]=522624;f[131132]=522656;f[131118]=522688;f[131145]=522776;f[131119]=522800;f[131120]=522952;f[131121]=523080;f[131135]=523104;f[131133]=523200;f[131146]=523304;f[131122]=523360;f[131123]=523392;f[131137]=523416;f[131124]=523440;f[131125]=523504;f[131126]=523528;f[131127]=523632;f[131131]=523672;f[131140]=523704;f[131128]=523752;f[131130]=523824;f[131138]=523952;f[131143]=524048;f[131144]=524112;f[131139]=524072;f[131142]=524136;f[131134]=524184;f[131129]=524208;f[131141]=522544;f[131147]=522592;f[131117]=524600;u=a;return}f[c>>2]=161028;f[c+4>>2]=91;b[c+8>>0]=0;DTb(881712,c);ZSb(c);f[131076]=88988;XIc(524308,0,156)|0;f[131116]=527320;XIc(524468,0,132)|0;zTb(524304);f[131136]=522624;f[131132]=522656;f[131118]=522688;f[131145]=522776;f[131119]=522800;f[131120]=522952;f[131121]=523080;f[131135]=523104;f[131133]=523200;f[131146]=523304;f[131122]=523360;f[131123]=523392;f[131137]=523416;f[131124]=523440;f[131125]=523504;f[131126]=523528;f[131127]=523632;f[131131]=523672;f[131140]=523704;f[131128]=523752;f[131130]=523824;f[131138]=523952;f[131143]=524048;f[131144]=524112;f[131139]=524072;f[131142]=524136;f[131134]=524184;f[131129]=524208;f[131141]=522544;f[131147]=522592;f[131117]=524600;u=a;return}function QUa(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}if((f[220364]|0)!=2){f[c>>2]=161028;f[c+4>>2]=27;b[c+8>>0]=0;DTb(881456,c);ZSb(c)}if((f[220400]|0)!=2){f[c>>2]=161028;f[c+4>>2]=63;b[c+8>>0]=0;DTb(881600,c);ZSb(c)};f[131266]=0;f[131267]=0;f[131268]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=4;f[c>>2]=1886544247;b[c+4>>0]=0;iEc(525064,c)|0;if((b[d>>0]|0)<0)YDc(f[c>>2]|0);xTb(525064);f[131150]=88664;c=524604;d=c+52|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131164]=527320;f[131165]=527320;f[131166]=527320;f[131167]=527320;f[131168]=525064;c=524676;d=c+64|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131185]=1;b[524744]=1;f[131187]=1;f[131188]=1;n[131189]=.5;f[131190]=5;n[131191]=1.0;n[131192]=.75;n[131193]=1.0;n[131194]=1.0;n[131195]=.5;n[131196]=.5;n[131197]=.25;f[131198]=0;zTb(524600);f[131169]=521608;f[131170]=521608;f[131171]=523392;u=a;return}function RUa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,419848);SQb();if((f[220371]|0)!=2){f[c>>2]=161028;f[c+4>>2]=34;b[c+8>>0]=0;DTb(881484,c);ZSb(c)}f[131200]=88448;f[131201]=0;f[131202]=0;f[131203]=0;f[131204]=0;b[524820]=0;zTb(524800);f[131204]=521608;u=a;return}function SUa(){var a=0,b=0;aTb(3005001,3005e3,419848);SQb();f[131206]=88340;f[131207]=0;a=524832;b=a+40|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(b|0));zTb(524824);return}function TUa(){aTb(3005001,3005e3,419848);SQb();f[131218]=88232;f[131219]=0;f[131220]=0;f[131221]=0;f[131222]=0;f[131223]=0;n[131224]=1.0;zTb(524872);return}function UUa(){aTb(3005001,3005e3,419848);SQb();f[131226]=88124;f[131227]=0;f[131228]=0;f[131229]=0;f[131230]=0;f[131231]=0;f[131232]=0;f[131233]=0;f[131234]=0;f[131235]=0;f[131236]=16;f[131237]=16;f[131238]=16;f[131239]=6e3;f[131240]=300;n[131241]=.699999988079071;zTb(524904);return}function VUa(){aTb(3005001,3005e3,419848);SQb();f[131242]=88016;f[131243]=0;f[131244]=0;f[131245]=0;f[131246]=0;f[131247]=0;f[131248]=0;zTb(524968);return}function WUa(a){a=a|0;var b=0,c=0;f[a>>2]=88016;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function XUa(a){a=a|0;var b=0,c=0;f[a>>2]=88016;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function YUa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function ZUa(a,b){a=a|0;b=b|0;a=VDc(28)|0;jVa(a);if(!b)return a|0;kVa(b,a);return a|0}function _Ua(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function $Ua(a){a=a|0;return (f[a+8>>2]&7|0)==7|0}function aVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|1;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(TRb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;a=o&255;if(o<<24>>24>-1){f[c>>2]=n+1;v=a}else{w=a;q=18}}else{w=0;q=18}if((q|0)==18){q=0;a=HRb(c,w)|0;n=J;if((n|0)>-1|(n|0)==-1&a>>>0>4294967295)v=a;else{x=0;q=31;break a}}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=24){s=p;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>-1){f[c>>2]=a+1;y=o}else{z=o;q=24}}else{z=0;q=24}if((q|0)==24){q=0;o=HRb(c,z)|0;a=J;if((a|0)>-1|(a|0)==-1&o>>>0>4294967295)y=o;else{x=0;q=31;break a}}f[l>>2]=y;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=31;break}o=f[m>>2]|0;if(!(o&1))A=mNa(m)|0;else A=o&-2;if(!(Djc(c,s,A)|0)){x=0;q=31;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==31){u=d;return x|0}return 0}function bVa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if((b&7|0)==7){d=f[a+20>>2]|0;if((d|0)<0)e=10;else e=(((($(d|1|0)|0)^31)*9|0)+73|0)>>>6;d=f[a+24>>2]|0;if((d|0)<0)g=10;else g=(((($(d|1|0)|0)^31)*9|0)+73|0)>>>6;h=c+7+e+g|0;i=a+12|0;f[i>>2]=h;return h|0}g=b&1|0?5:0;if(!(b&2))j=g;else{e=f[a+20>>2]|0;if((e|0)<0)k=11;else k=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=k+g|0}if(!(b&4))l=j;else{b=f[a+24>>2]|0;if((b|0)<0)m=11;else m=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+j|0}h=l+c|0;i=a+12|0;f[i>>2]=h;return h|0}function cVa(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)WTb(1,+n[a+16>>2],b);if(c&2|0)MTb(2,f[a+20>>2]|0,b);if(c&4|0)MTb(3,f[a+24>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function dVa(a){a=a|0;return f[a+12>>2]|0}function eVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{d=f[a+20>>2]|0;b[e>>0]=16;g=e+1|0;e=d&255;if(d>>>0>127){h=g;j=e;k=d;l=((d|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;d=k;k=aJc(k|0,l|0,7)|0;m=h+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&d>>>0>16383)){o=m;p=n;break}else{h=m;j=n;l=J}}}else{o=g;p=e}b[o>>0]=p;i=o+1|0}if(!(c&4))q=i;else{c=f[a+24>>2]|0;b[i>>0]=24;o=i+1|0;i=c&255;if(c>>>0>127){p=o;e=i;g=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=e|-128;c=g;g=aJc(g|0,l|0,7)|0;j=p+1|0;h=g&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=h;break}else{p=j;e=h;l=J}}}else{r=o;s=i}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function fVa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function gVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,14968,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function hVa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function iVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525640;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function jVa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=88016;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524968?(f[220433]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=96;b[d+8>>0]=0;DTb(881732,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function kVa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function lVa(a){a=a|0;var b=0,c=0;f[a>>2]=88124;b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function mVa(a){a=a|0;lVa(a);YDc(a);return}function nVa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function oVa(a,b){a=a|0;b=b|0;a=VDc(64)|0;CVa(a);if(!b)return a|0;DVa(b,a);return a|0}function pVa(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+28>>2]=0;b=a+8|0;if(f[b>>2]&63|0){f[a+40>>2]=16;f[a+44>>2]=16;f[a+48>>2]=16;f[a+52>>2]=6e3;f[a+56>>2]=300;n[a+60>>2]=.699999988079071}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function qVa(a){a=a|0;return 1}function rVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+40|0;k=a+44|0;l=a+48|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+32|0;r=a+36|0;s=a+52|0;t=a+56|0;v=a+60|0;w=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=WRb(c,B)|0;if((y+-1|0)>>>0<127){z=y;A=6}else C=y}b:do if((A|0)==6){A=0;switch(z>>>3&536870911|0){case 1:{if((z&255|0)!=8){C=z;break b}f[i>>2]=f[i>>2]|1;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){a=b[y>>0]|0;x=a&255;if(a<<24>>24>-1){f[j>>2]=x;f[c>>2]=y+1;continue a}else D=x}else D=0;x=HRb(c,D)|0;y=J;f[j>>2]=x;if((y|0)>-1|(y|0)==-1&x>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 2:{if((z&255|0)!=16){C=z;break b}f[i>>2]=f[i>>2]|2;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;a=y&255;if(y<<24>>24>-1){f[k>>2]=a;f[c>>2]=x+1;continue a}else F=a}else F=0;a=HRb(c,F)|0;x=J;f[k>>2]=a;if((x|0)>-1|(x|0)==-1&a>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 3:{if((z&255|0)!=24){C=z;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>-1){f[l>>2]=y;f[c>>2]=a+1;continue a}else G=y}else G=0;y=HRb(c,G)|0;a=J;f[l>>2]=y;if((a|0)>-1|(a|0)==-1&y>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 4:{switch((z&255)<<24>>24){case 37:break;case 34:{if(BVa(c,m)|0)continue a;else{E=0;A=78;break a}break}default:{C=z;break b}}y=f[c>>2]|0;if(((f[g>>2]|0)-y|0)>3){a=y;x=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=x;f[c>>2]=y+4;H=x}else{if(!(TRb(c,e)|0)){A=37;break a}H=f[e>>2]|0}x=f[m>>2]|0;if((x|0)==(f[n>>2]|0)){SHa(m,x+1|0);I=f[m>>2]|0}else I=x;x=f[o>>2]|0;y=I+1|0;f[m>>2]=y;f[x+4+(I<<2)>>2]=H;a=f[c>>2]|0;K=(f[g>>2]|0)-a|0;if((K|0)<=0)continue a;L=a;a=(f[n>>2]|0)-y|0;M=(K>>>0)/5|0;N=(M|0)<(a|0)?M:a;if((N|0)>0){O=0;P=L;Q=y}else continue a;while(1){if((b[P>>0]|0)!=37){R=O;break}y=P+1|0;a=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;y=Q;Q=Q+1|0;f[m>>2]=Q;f[x+4+(y<<2)>>2]=a;a=O+1|0;if((a|0)>=(N|0)){R=a;break}else{O=a;P=P+5|0}}N=R*5|0;if((R|0)<=0)continue a;if((K|0)<(N|0)){PRb(c,N,K)|0;continue a}else{f[c>>2]=L+N;continue a}break}case 5:{switch((z&255)<<24>>24){case 45:break;case 42:{if(BVa(c,p)|0)continue a;else{E=0;A=78;break a}break}default:{C=z;break b}}N=f[c>>2]|0;if(((f[g>>2]|0)-N|0)>3){x=N;a=h[x>>0]|h[x+1>>0]<<8|h[x+2>>0]<<16|h[x+3>>0]<<24;f[e>>2]=a;f[c>>2]=N+4;S=a}else{if(!(TRb(c,e)|0)){A=54;break a}S=f[e>>2]|0}a=f[p>>2]|0;if((a|0)==(f[q>>2]|0)){SHa(p,a+1|0);T=f[p>>2]|0}else T=a;a=f[r>>2]|0;N=T+1|0;f[p>>2]=N;f[a+4+(T<<2)>>2]=S;x=f[c>>2]|0;y=(f[g>>2]|0)-x|0;if((y|0)<=0)continue a;M=x;x=(f[q>>2]|0)-N|0;U=(y>>>0)/5|0;V=(U|0)<(x|0)?U:x;if((V|0)>0){W=0;X=M;Y=N}else continue a;while(1){if((b[X>>0]|0)!=45){Z=W;break}N=X+1|0;x=h[N>>0]|h[N+1>>0]<<8|h[N+2>>0]<<16|h[N+3>>0]<<24;N=Y;Y=Y+1|0;f[p>>2]=Y;f[a+4+(N<<2)>>2]=x;x=W+1|0;if((x|0)>=(V|0)){Z=x;break}else{W=x;X=X+5|0}}V=Z*5|0;if((Z|0)<=0)continue a;if((y|0)<(V|0)){PRb(c,V,y)|0;continue a}else{f[c>>2]=M+V;continue a}break}case 6:{if((z&255|0)!=48){C=z;break b}f[i>>2]=f[i>>2]|8;V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0){a=b[V>>0]|0;L=a&255;if(a<<24>>24>-1){f[s>>2]=L;f[c>>2]=V+1;continue a}else _=L}else _=0;L=HRb(c,_)|0;V=J;f[s>>2]=L;if((V|0)>-1|(V|0)==-1&L>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 7:{if((z&255|0)!=56){C=z;break b}f[i>>2]=f[i>>2]|16;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){V=b[L>>0]|0;a=V&255;if(V<<24>>24>-1){f[t>>2]=a;f[c>>2]=L+1;continue a}else $=a}else $=0;a=HRb(c,$)|0;L=J;f[t>>2]=a;if((L|0)>-1|(L|0)==-1&a>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 8:{if((z&255|0)!=69){C=z;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){L=a;V=h[L>>0]|h[L+1>>0]<<8|h[L+2>>0]<<16|h[L+3>>0]<<24;f[e>>2]=V;f[c>>2]=a+4;aa=V}else{if(!(TRb(c,e)|0)){A=72;break a}aa=f[e>>2]|0}f[v>>2]=aa;continue a;break}default:{C=z;break b}}}while(0);if(!C){E=1;A=78;break}V=f[w>>2]|0;if(!(V&1))ba=mNa(w)|0;else ba=V&-2;if(!(Djc(c,C,ba)|0)){E=0;A=78;break}}if((A|0)==37){E=0;u=d;return E|0}else if((A|0)==54){E=0;u=d;return E|0}else if((A|0)==72){E=0;u=d;return E|0}else if((A|0)==78){u=d;return E|0}return 0}function sVa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+16>>2]|0;d=f[a+28>>2]|0;e=b+c+(b<<2)+d+(d<<2)|0;d=f[a+8>>2]|0;if(!(d&63)){g=e;h=a+12|0;f[h>>2]=g;return g|0}if(!(d&1))i=e;else i=e+1+((((($(f[a+40>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(d&2))j=i;else j=i+1+((((($(f[a+44>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(d&4))k=j;else k=j+1+((((($(f[a+48>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(d&8))l=k;else l=k+1+((((($(f[a+52>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(d&16))m=l;else m=l+1+((((($(f[a+56>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=d&32|0?m+5|0:m;h=a+12|0;f[h>>2]=g;return g|0}function tVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)OTb(1,f[a+40>>2]|0,b);if(c&2|0)OTb(2,f[a+44>>2]|0,b);if(c&4|0)OTb(3,f[a+48>>2]|0,b);d=f[a+16>>2]|0;if((d|0)>0){e=a+24|0;g=0;do{WTb(4,+n[(f[e>>2]|0)+4+(g<<2)>>2],b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+28>>2]|0;if((d|0)>0){g=a+36|0;e=0;do{WTb(5,+n[(f[g>>2]|0)+4+(e<<2)>>2],b);e=e+1|0}while((e|0)!=(d|0))}if(c&8|0)OTb(6,f[a+52>>2]|0,b);if(c&16|0)OTb(7,f[a+56>>2]|0,b);if(c&32|0)WTb(8,+n[a+60>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function uVa(a){a=a|0;return f[a+12>>2]|0}function vVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+40>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{l=f[a+44>>2]|0;b[e>>0]=16;m=e+1|0;if(l>>>0>127){e=l;g=m;while(1){b[g>>0]=e|128;h=e>>>7;i=g+1|0;if(e>>>0>16383){e=h;g=i}else{o=i;p=h;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&4))q=n;else{o=f[a+48>>2]|0;b[n>>0]=24;p=n+1|0;if(o>>>0>127){n=o;l=p;while(1){b[l>>0]=n|128;m=n>>>7;g=l+1|0;if(n>>>0>16383){n=m;l=g}else{r=g;s=m;break}}}else{r=p;s=o}b[r>>0]=s;q=r+1|0}r=f[a+16>>2]|0;if(!r)t=q;else{s=f[a+24>>2]|0;o=0;p=q;while(1){q=f[s+4+(o<<2)>>2]|0;b[p>>0]=37;l=p+1|0;b[l>>0]=q;b[l+1>>0]=q>>8;b[l+2>>0]=q>>16;b[l+3>>0]=q>>24;q=p+5|0;o=o+1|0;if((o|0)>=(r|0)){t=q;break}else p=q}}p=f[a+28>>2]|0;if(!p)u=t;else{r=f[a+36>>2]|0;o=0;s=t;while(1){t=f[r+4+(o<<2)>>2]|0;b[s>>0]=45;q=s+1|0;b[q>>0]=t;b[q+1>>0]=t>>8;b[q+2>>0]=t>>16;b[q+3>>0]=t>>24;t=s+5|0;o=o+1|0;if((o|0)>=(p|0)){u=t;break}else s=t}}if(!(c&8))v=u;else{s=f[a+52>>2]|0;b[u>>0]=48;p=u+1|0;if(s>>>0>127){u=s;o=p;while(1){b[o>>0]=u|128;r=u>>>7;t=o+1|0;if(u>>>0>16383){u=r;o=t}else{w=t;x=r;break}}}else{w=p;x=s}b[w>>0]=x;v=w+1|0}if(!(c&16))y=v;else{w=f[a+56>>2]|0;b[v>>0]=56;x=v+1|0;if(w>>>0>127){v=w;s=x;while(1){b[s>>0]=v|128;p=v>>>7;o=s+1|0;if(v>>>0>16383){v=p;s=o}else{z=o;A=p;break}}}else{z=x;A=w}b[z>>0]=A;y=z+1|0}if(!(c&32))B=y;else{c=f[a+60>>2]|0;b[y>>0]=69;z=y+1|0;b[z>>0]=c;b[z+1>>0]=c>>8;b[z+2>>0]=c>>16;b[z+3>>0]=c>>24;B=y+5|0}y=f[a+4>>2]|0;if(!(y&1)){C=B;return C|0}C=Hjc(y&-2,B)|0;return C|0}function wVa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function xVa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,14984,0)|0;if(!c){Ehc(b,a);return}else{AVa(a,c);return}}function yVa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function zVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525632;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function AVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){SHa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+28|0;d=b+28|0;e=f[d>>2]|0;if(e|0){SHa(g,(f[g>>2]|0)+e|0);dJc((f[a+36>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+36>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=f[b+8>>2]|0;if(!(d&63))return;if(d&1|0)f[a+40>>2]=f[b+40>>2];if(d&2|0)f[a+44>>2]=f[b+44>>2];if(d&4|0)f[a+48>>2]=f[b+48>>2];if(d&8|0)f[a+52>>2]=f[b+52>>2];if(d&16|0)f[a+56>>2]=f[b+56>>2];if(d&32|0)f[a+60>>2]=f[b+60>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function BVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;i=a+4|0;if(g>>>0<(f[i>>2]|0)>>>0?(j=b[g>>0]|0,j<<24>>24>-1):0){f[a>>2]=g+1;k=j&255}else{j=VRb(a)|0;if((j|0)>-1)k=j;else{l=0;u=d;return l|0}}j=f[c>>2]|0;g=(k|0)/4|0;if((g<<2|0)!=(k|0)){l=0;u=d;return l|0}m=ORb(a)|0;n=MRb(a)|0;if((((m|0)==-1|(n|0)<(m|0)?n:m)|0)>=(k|0)){m=j+g|0;if((f[c>>2]|0)<(m|0)?(SHa(c,m),n=f[c>>2]|0,o=m-n|0,(o<<2|0)>0):0)XIc((f[c+8>>2]|0)+((n<<2)+4)|0,0,(((o|-1073741824|0)==-1073741824?1073741823:1073741822)+o<<2)+8|0)|0;f[c>>2]=m;m=f[c+8>>2]|0;if(QRb(a,((m|0)==0?0:m+4|0)+(j<<2)|0,k)|0){l=1;u=d;return l|0}if((f[c>>2]|0)<=0){l=0;u=d;return l|0}f[c>>2]=j;l=0;u=d;return l|0}if((k|0)<=3){l=1;u=d;return l|0}k=c+4|0;j=c+8|0;m=0;while(1){o=f[a>>2]|0;if(((f[i>>2]|0)-o|0)>3){n=o;p=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=p;f[a>>2]=o+4;q=p}else{if(!(TRb(a,e)|0))break;q=f[e>>2]|0}p=f[c>>2]|0;if((p|0)==(f[k>>2]|0)){SHa(c,p+1|0);r=f[c>>2]|0}else r=p;p=f[j>>2]|0;f[c>>2]=r+1;f[p+4+(r<<2)>>2]=q;m=m+1|0;if((m|0)>=(g|0)){l=1;s=23;break}}if((s|0)==23){u=d;return l|0}l=0;u=d;return l|0}function CVa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=88124;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;if((a|0)!=524904?(f[220432]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=95;b[d+8>>0]=0;DTb(881728,d);ZSb(d)}f[a+12>>2]=0;f[a+40>>2]=16;f[a+44>>2]=16;f[a+48>>2]=16;f[a+52>>2]=6e3;f[a+56>>2]=300;n[a+60>>2]=.699999988079071;u=c;return}function DVa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function EVa(a){a=a|0;var b=0,c=0;f[a>>2]=88232;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function FVa(a){a=a|0;var b=0,c=0;f[a>>2]=88232;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function GVa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function HVa(a,b){a=a|0;b=b|0;a=VDc(28)|0;TVa(a);if(!b)return a|0;UVa(b,a);return a|0}function IVa(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function JVa(a){a=a|0;return 1}function KVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break b}f[i>>2]=f[i>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[j>>2]=n;f[c>>2]=o+1;continue a}else t=n}else t=0;n=HRb(c,t)|0;o=J;f[j>>2]=n;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)continue a;else{v=0;q=29;break a}break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;a=o&255;if(o<<24>>24>-1){f[k>>2]=a;f[c>>2]=n+1;continue a}else w=a}else w=0;a=HRb(c,w)|0;n=J;f[k>>2]=a;if((n|0)>-1|(n|0)==-1&a>>>0>4294967295)continue a;else{v=0;q=29;break a}break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;x=o}else{if(!(TRb(c,e)|0)){q=23;break a}x=f[e>>2]|0}f[l>>2]=x;continue a;break}default:{s=p;break b}}}while(0);if(!s){v=1;q=29;break}o=f[m>>2]|0;if(!(o&1))y=mNa(m)|0;else y=o&-2;if(!(Djc(c,s,y)|0)){v=0;q=29;break}}if((q|0)==23){v=0;u=d;return v|0}else if((q|0)==29){u=d;return v|0}return 0}function LVa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else g=c+1+((((($(f[a+16>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&2))h=g;else h=g+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;d=b&4|0?h+5|0:h;e=a+12|0;f[e>>2]=d;return d|0}function MVa(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)OTb(1,f[a+16>>2]|0,b);if(c&2|0)OTb(2,f[a+20>>2]|0,b);if(c&4|0)WTb(3,+n[a+24>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function NVa(a){a=a|0;return f[a+12>>2]|0}function OVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{l=f[a+20>>2]|0;b[e>>0]=16;m=e+1|0;if(l>>>0>127){e=l;g=m;while(1){b[g>>0]=e|128;h=e>>>7;i=g+1|0;if(e>>>0>16383){e=h;g=i}else{o=i;p=h;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&4))q=n;else{c=f[a+24>>2]|0;b[n>>0]=29;o=n+1|0;b[o>>0]=c;b[o+1>>0]=c>>8;b[o+2>>0]=c>>16;b[o+3>>0]=c>>24;q=n+5|0}n=f[a+4>>2]|0;if(!(n&1)){r=q;return r|0}r=Hjc(n&-2,q)|0;return r|0}function PVa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function QVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15e3,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function RVa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function SVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525624;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function TVa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=88232;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524872?(f[220431]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=94;b[d+8>>0]=0;DTb(881724,d);ZSb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;n[a+24>>2]=1.0;u=c;return}function UVa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function VVa(a){a=a|0;var b=0,c=0;f[a>>2]=88340;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function WVa(a){a=a|0;var b=0,c=0;f[a>>2]=88340;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function XVa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function YVa(a,b){a=a|0;b=b|0;a=VDc(48)|0;jWa(a);if(!b)return a|0;kWa(b,a);return a|0}function ZVa(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&255|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function _Va(a){a=a|0;return 1}function $Va(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+28|0;n=a+32|0;o=a+36|0;p=e+8|0;q=a+40|0;r=a+44|0;s=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){t=b[a>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=a+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=WRb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=13){z=w;break b}f[i>>2]=f[i>>2]|1;v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){a=v;t=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=t;f[c>>2]=v+4;A=t}else{if(!(TRb(c,e)|0)){x=13;break a}A=f[e>>2]|0}f[j>>2]=A;continue a;break}case 2:{if((w&255|0)!=21){z=w;break b}f[i>>2]=f[i>>2]|2;t=f[c>>2]|0;if(((f[g>>2]|0)-t|0)>3){v=t;a=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;f[e>>2]=a;f[c>>2]=t+4;B=a}else{if(!(TRb(c,e)|0)){x=20;break a}B=f[e>>2]|0}f[k>>2]=B;continue a;break}case 3:{if((w&255|0)!=29){z=w;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){t=a;v=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=v;f[c>>2]=a+4;C=v}else{if(!(TRb(c,e)|0)){x=27;break a}C=f[e>>2]|0}f[l>>2]=C;continue a;break}case 4:{if((w&255|0)!=37){z=w;break b}f[i>>2]=f[i>>2]|8;v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){a=v;t=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=t;f[c>>2]=v+4;D=t}else{if(!(TRb(c,e)|0)){x=34;break a}D=f[e>>2]|0}f[m>>2]=D;continue a;break}case 5:{if((w&255|0)!=40){z=w;break b}f[i>>2]=f[i>>2]|16;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0){v=b[t>>0]|0;a=v&255;if(v<<24>>24>-1){f[c>>2]=t+1;E=a}else{F=a;x=39}}else{F=0;x=39}if((x|0)==39){x=0;a=HRb(c,F)|0;t=J;if((t|0)>-1|(t|0)==-1&a>>>0>4294967295)E=a;else{G=0;x=66;break a}}f[n>>2]=E;continue a;break}case 6:{if((w&255|0)!=48){z=w;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(t=b[a>>0]|0,t<<24>>24>-1):0){f[c>>2]=a+1;H=t<<24>>24!=0}else{IRb(e,c);t=e;if(!(b[p>>0]|0)){G=0;x=66;break a}else H=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0}b[o>>0]=H&1;continue a;break}case 7:{if((w&255|0)!=61){z=w;break b}f[i>>2]=f[i>>2]|64;t=f[c>>2]|0;if(((f[g>>2]|0)-t|0)>3){a=t;v=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=v;f[c>>2]=t+4;I=v}else{if(!(TRb(c,e)|0)){x=53;break a}I=f[e>>2]|0}f[q>>2]=I;continue a;break}case 8:{if((w&255|0)!=69){z=w;break b}f[i>>2]=f[i>>2]|128;v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){t=v;a=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=a;f[c>>2]=v+4;K=a}else{if(!(TRb(c,e)|0)){x=60;break a}K=f[e>>2]|0}f[r>>2]=K;continue a;break}default:{z=w;break b}}}while(0);if(!z){G=1;x=66;break}a=f[s>>2]|0;if(!(a&1))L=mNa(s)|0;else L=a&-2;if(!(Djc(c,z,L)|0)){G=0;x=66;break}}if((x|0)==13){G=0;u=d;return G|0}else if((x|0)==20){G=0;u=d;return G|0}else if((x|0)==27){G=0;u=d;return G|0}else if((x|0)==34){G=0;u=d;return G|0}else if((x|0)==53){G=0;u=d;return G|0}else if((x|0)==60){G=0;u=d;return G|0}else if((x|0)==66){u=d;return G|0}return 0}function aWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&255)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;c=b&2|0?g+5|0:g;g=b&4|0?c+5|0:c;c=b&8|0?g+5|0:g;if(!(b&16))h=c;else{g=f[a+32>>2]|0;if((g|0)<0)i=11;else i=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+c|0}c=b&32|0?h+2|0:h;h=b&64|0?c+5|0:c;d=b&128|0?h+5|0:h;e=a+12|0;f[e>>2]=d;return d|0}function bWa(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)WTb(1,+n[a+16>>2],c);if(d&2|0)WTb(2,+n[a+20>>2],c);if(d&4|0)WTb(3,+n[a+24>>2],c);if(d&8|0)WTb(4,+n[a+28>>2],c);if(d&16|0)MTb(5,f[a+32>>2]|0,c);if(d&32|0)YTb(6,(b[a+36>>0]|0)!=0,c);if(d&64|0)WTb(7,+n[a+40>>2],c);if(d&128|0)WTb(8,+n[a+44>>2],c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function cWa(a){a=a|0;return f[a+12>>2]|0}function dWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{d=f[a+20>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}if(!(c&4))j=i;else{e=f[a+24>>2]|0;b[i>>0]=29;d=i+1|0;b[d>>0]=e;b[d+1>>0]=e>>8;b[d+2>>0]=e>>16;b[d+3>>0]=e>>24;j=i+5|0}if(!(c&8))k=j;else{i=f[a+28>>2]|0;b[j>>0]=37;e=j+1|0;b[e>>0]=i;b[e+1>>0]=i>>8;b[e+2>>0]=i>>16;b[e+3>>0]=i>>24;k=j+5|0}if(!(c&16))l=k;else{j=f[a+32>>2]|0;b[k>>0]=40;i=k+1|0;k=j&255;if(j>>>0>127){e=i;d=k;g=j;h=((j|0)<0)<<31>>31;while(1){b[e>>0]=d|-128;j=g;g=aJc(g|0,h|0,7)|0;m=e+1|0;n=g&255;if(!(h>>>0>0|(h|0)==0&j>>>0>16383)){o=m;p=n;break}else{e=m;d=n;h=J}}}else{o=i;p=k}b[o>>0]=p;l=o+1|0}if(!(c&32))q=l;else{o=b[a+36>>0]|0;b[l>>0]=48;b[l+1>>0]=o;q=l+2|0}if(!(c&64))r=q;else{l=f[a+40>>2]|0;b[q>>0]=61;o=q+1|0;b[o>>0]=l;b[o+1>>0]=l>>8;b[o+2>>0]=l>>16;b[o+3>>0]=l>>24;r=q+5|0}if(!(c&128))s=r;else{c=f[a+44>>2]|0;b[r>>0]=69;q=r+1|0;b[q>>0]=c;b[q+1>>0]=c>>8;b[q+2>>0]=c>>16;b[q+3>>0]=c>>24;s=r+5|0}r=f[a+4>>2]|0;if(!(r&1)){t=s;return t|0}t=Hjc(r&-2,s)|0;return t|0}function eWa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function fWa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15016,0)|0;if(!c){Ehc(b,a);return}else{iWa(a,c);return}}function gWa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function hWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525616;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function iWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&255))return;if(e&1|0)f[a+16>>2]=f[c+16>>2];if(e&2|0)f[a+20>>2]=f[c+20>>2];if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)b[a+36>>0]=b[c+36>>0]|0;if(e&64|0)f[a+40>>2]=f[c+40>>2];if(e&128|0)f[a+44>>2]=f[c+44>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function jWa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=88340;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524824?(f[220430]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=93;b[d+8>>0]=0;DTb(881720,d);ZSb(d)}d=a+12|0;a=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(a|0));u=c;return}function kWa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function lWa(a){a=a|0;var b=0,c=0;f[a>>2]=88448;if((a|0)!=524800?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function mWa(a){a=a|0;lWa(a);YDc(a);return}function nWa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function oWa(a,b){a=a|0;b=b|0;a=VDc(24)|0;TWa(a);if(!b)return a|0;UWa(b,a);return a|0}function pWa(a){a=a|0;var c=0,d=0;c=a+8|0;if(f[c>>2]&1|0){d=f[a+16>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}b[a+20>>0]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function qWa(a){a=a|0;return 1}function rWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+4|0;k=a+20|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:break;case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;t=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[l>>0]|0)){v=0;q=29;break a}else t=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[k>>0]=t&1;continue a;break}default:{s=p;break b}}if((p&255|0)==10){f[h>>2]=f[h>>2]|1;a=f[i>>2]|0;if(!a){o=VDc(48)|0;BWa(o);f[i>>2]=o;w=o}else w=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(o=b[a>>0]|0,o<<24>>24>-1):0){f[c>>2]=a+1;x=o&255}else{o=VRb(c)|0;if((o|0)>-1)x=o;else{v=0;q=29;break a}}GRb(e,c,x);if((f[j>>2]|0)<0){q=16;break a}if(!(Mi[f[(f[w>>2]|0)+44>>2]&1023](w,c)|0)){q=16;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{v=0;q=29;break a}}else s=p}while(0);if(!s){v=1;q=29;break}o=f[m>>2]|0;if(!(o&1))y=mNa(m)|0;else y=o&-2;if(!(Djc(c,s,y)|0)){v=0;q=29;break}}if((q|0)==16){v=0;u=d;return v|0}else if((q|0)==29){u=d;return v|0}return 0}function sWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&3)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}e=i&2|0?h+2|0:h;g=a+12|0;f[g>>2]=e;return e|0}function tWa(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)eUb(1,f[a+16>>2]|0,c);if(d&2|0)YTb(2,(b[a+20>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function uWa(a){a=a|0;return f[a+12>>2]|0}function vWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;i=d+1|0;d=_i[f[(f[h>>2]|0)+60>>2]&1023](h)|0;if(d>>>0>127){j=d;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=d}b[n>>0]=o;g=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,n+1|0)|0}if(!(e&2))p=g;else{e=b[a+20>>0]|0;b[g>>0]=16;b[g+1>>0]=e;p=g+2|0}g=f[a+4>>2]|0;if(!(g&1)){q=p;return q|0}q=Hjc(g&-2,p)|0;return q|0}function wWa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function xWa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15032,0)|0;if(!c){Ehc(b,a);return}else{AWa(a,c);return}}function yWa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function zWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525608;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function AWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&3))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=VDc(48)|0;BWa(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;CWa(i,g|0?g:521608)}if(e&2|0)b[a+20>>0]=b[c+20>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function BWa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=88556;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=521608?(f[220371]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=34;b[d+8>>0]=0;DTb(881484,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=525e3;d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[a+36>>2]=-1;n[a+40>>2]=1.0;n[a+44>>2]=1.0;u=c;return}function CWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&255))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==525e3){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];if(d&8|0)f[a+28>>2]=f[b+28>>2];if(d&16|0)f[a+32>>2]=f[b+32>>2];if(d&32|0)f[a+36>>2]=f[b+36>>2];if(d&64|0)f[a+40>>2]=f[b+40>>2];if(d&128|0)f[a+44>>2]=f[b+44>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function DWa(a){a=a|0;var c=0,d=0;f[a>>2]=88556;c=f[a+16>>2]|0;if(!((c|0)==525e3|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function EWa(a){a=a|0;DWa(a);YDc(a);return}function FWa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function GWa(a,b){a=a|0;b=b|0;a=VDc(48)|0;BWa(a);if(!b)return a|0;SWa(b,a);return a|0}function HWa(a){a=a|0;var b=0,c=0;b=a+8|0;c=f[b>>2]|0;if(c&1|0)iEc(f[a+16>>2]|0,525e3)|0;if(c&254|0){c=a+20|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[a+36>>2]=-1;n[a+40>>2]=1.0;n[a+44>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function IWa(a){a=a|0;return 1}function JWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+40|0;n=a+28|0;o=a+44|0;p=a+36|0;q=a+32|0;r=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=a+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=WRb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=10){y=v;break b}f[i>>2]=f[i>>2]|1;t=f[j>>2]|0;if((t|0)==525e3){GLa(j,525e3);z=f[j>>2]|0}else z=t;if(fUb(c,z)|0)continue a;else{A=0;w=68;break a}break}case 2:{if((v&255|0)!=21){y=v;break b}f[i>>2]=f[i>>2]|2;t=f[c>>2]|0;if(((f[g>>2]|0)-t|0)>3){a=t;s=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=s;f[c>>2]=t+4;B=s}else{if(!(TRb(c,e)|0)){w=17;break a}B=f[e>>2]|0}f[k>>2]=B;continue a;break}case 3:{if((v&255|0)!=29){y=v;break b}f[i>>2]=f[i>>2]|4;s=f[c>>2]|0;if(((f[g>>2]|0)-s|0)>3){t=s;a=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=a;f[c>>2]=s+4;C=a}else{if(!(TRb(c,e)|0)){w=24;break a}C=f[e>>2]|0}f[l>>2]=C;continue a;break}case 4:{if((v&255|0)!=37){y=v;break b}f[i>>2]=f[i>>2]|64;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){s=a;t=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=t;f[c>>2]=a+4;D=t}else{if(!(TRb(c,e)|0)){w=31;break a}D=f[e>>2]|0}f[m>>2]=D;continue a;break}case 5:{if((v&255|0)!=45){y=v;break b}f[i>>2]=f[i>>2]|8;t=f[c>>2]|0;if(((f[g>>2]|0)-t|0)>3){a=t;s=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=s;f[c>>2]=t+4;E=s}else{if(!(TRb(c,e)|0)){w=38;break a}E=f[e>>2]|0}f[n>>2]=E;continue a;break}case 6:{if((v&255|0)!=53){y=v;break b}f[i>>2]=f[i>>2]|128;s=f[c>>2]|0;if(((f[g>>2]|0)-s|0)>3){t=s;a=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=a;f[c>>2]=s+4;F=a}else{if(!(TRb(c,e)|0)){w=45;break a}F=f[e>>2]|0}f[o>>2]=F;continue a;break}case 7:{if((v&255|0)!=56){y=v;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>-1){f[c>>2]=a+1;G=t}else{H=t;w=50}}else{H=0;w=50}if((w|0)==50){w=0;t=HRb(c,H)|0;a=J;if((a|0)>-1|(a|0)==-1&t>>>0>4294967295)G=t;else{A=0;w=68;break a}}f[p>>2]=G;continue a;break}case 8:{if((v&255|0)!=64){y=v;break b}t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0){a=b[t>>0]|0;s=a&255;if(a<<24>>24>-1){f[c>>2]=t+1;I=s}else{K=s;w=56}}else{K=0;w=56}if((w|0)==56){w=0;s=HRb(c,K)|0;t=J;if((t|0)>-1|(t|0)==-1&s>>>0>4294967295)I=s;else{A=0;w=68;break a}}if(I>>>0<3){f[i>>2]=f[i>>2]|16;f[q>>2]=I;continue a}s=f[r>>2]|0;if(!(s&1))L=mNa(r)|0;else L=s&-2;rjc(L,8,I,((I|0)<0)<<31>>31);continue a;break}default:{y=v;break b}}}while(0);if(!y){A=1;w=68;break}s=f[r>>2]|0;if(!(s&1))M=mNa(r)|0;else M=s&-2;if(!(Djc(c,y,M)|0)){A=0;w=68;break}}if((w|0)==17){A=0;u=d;return A|0}else if((w|0)==24){A=0;u=d;return A|0}else if((w|0)==31){A=0;u=d;return A|0}else if((w|0)==38){A=0;u=d;return A|0}else if((w|0)==45){A=0;u=d;return A|0}else if((w|0)==68){u=d;return A|0}return 0}function KWa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&255)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}k=c&2|0?h+5|0:h;h=c&4|0?k+5|0:k;k=c&8|0?h+5|0:h;if(!(c&16))l=k;else{h=f[a+32>>2]|0;if((h|0)<0)m=11;else m=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+k|0}if(!(c&32))n=l;else{k=f[a+36>>2]|0;if((k|0)<0)o=11;else o=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=o+l|0}l=c&64|0?n+5|0:n;e=c&128|0?l+5|0:l;g=a+12|0;f[g>>2]=e;return e|0}function LWa(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&2|0)WTb(2,+n[a+20>>2],b);if(c&4|0)WTb(3,+n[a+24>>2],b);if(c&64|0)WTb(4,+n[a+40>>2],b);if(c&8|0)WTb(5,+n[a+28>>2],b);if(c&128|0)WTb(6,+n[a+44>>2],b);if(c&32|0)MTb(7,f[a+36>>2]|0,b);if(c&16|0)ZTb(8,f[a+32>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function MWa(a){a=a|0;return f[a+12>>2]|0}function NWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&4))i=h;else{e=f[a+24>>2]|0;b[h>>0]=29;d=h+1|0;b[d>>0]=e;b[d+1>>0]=e>>8;b[d+2>>0]=e>>16;b[d+3>>0]=e>>24;i=h+5|0}if(!(c&64))j=i;else{h=f[a+40>>2]|0;b[i>>0]=37;e=i+1|0;b[e>>0]=h;b[e+1>>0]=h>>8;b[e+2>>0]=h>>16;b[e+3>>0]=h>>24;j=i+5|0}if(!(c&8))k=j;else{i=f[a+28>>2]|0;b[j>>0]=45;h=j+1|0;b[h>>0]=i;b[h+1>>0]=i>>8;b[h+2>>0]=i>>16;b[h+3>>0]=i>>24;k=j+5|0}if(!(c&128))l=k;else{j=f[a+44>>2]|0;b[k>>0]=53;i=k+1|0;b[i>>0]=j;b[i+1>>0]=j>>8;b[i+2>>0]=j>>16;b[i+3>>0]=j>>24;l=k+5|0}if(!(c&32))m=l;else{k=f[a+36>>2]|0;b[l>>0]=56;j=l+1|0;l=k&255;if(k>>>0>127){i=j;h=l;e=k;d=((k|0)<0)<<31>>31;while(1){b[i>>0]=h|-128;k=e;e=aJc(e|0,d|0,7)|0;g=i+1|0;n=e&255;if(!(d>>>0>0|(d|0)==0&k>>>0>16383)){o=g;p=n;break}else{i=g;h=n;d=J}}}else{o=j;p=l}b[o>>0]=p;m=o+1|0}if(!(c&16))q=m;else{c=f[a+32>>2]|0;b[m>>0]=64;o=m+1|0;m=c&255;if(c>>>0>127){p=o;l=m;j=c;d=((c|0)<0)<<31>>31;while(1){b[p>>0]=l|-128;c=j;j=aJc(j|0,d|0,7)|0;h=p+1|0;i=j&255;if(!(d>>>0>0|(d|0)==0&c>>>0>16383)){r=h;s=i;break}else{p=h;l=i;d=J}}}else{r=o;s=m}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function OWa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function PWa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15048,0)|0;if(!c){Ehc(b,a);return}else{CWa(a,c);return}}function QWa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function RWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525144;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function SWa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function TWa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=88448;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524800?(f[220429]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=92;b[d+8>>0]=0;DTb(881716,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;u=c;return}function UWa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function VWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=88664;WXa(a);b=f[a+52>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+40>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function WWa(a){a=a|0;VWa(a);YDc(a);return}function XWa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function YWa(a,b){a=a|0;b=b|0;a=VDc(196)|0;UXa(a);if(!b)return a|0;VXa(b,a);return a|0}function ZWa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}f[a+32>>2]=0;f[a+44>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){do if(d&1|0){g=f[a+56>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+60>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+64>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&8|0){e=f[a+68>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&16|0)iEc(f[a+72>>2]|0,525064)|0;if(d&32|0){g=f[a+76>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&64|0){g=f[a+80>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&128|0){g=f[a+84>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}}if(d&65280|0){g=a+88|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;b[g+28>>0]=0}if(d&16711680|0){g=a+117|0;e=g+23|0;do{b[g>>0]=0;g=g+1|0}while((g|0)<(e|0));f[a+140>>2]=1;b[a+144>>0]=1}if(d>>>0>16777215){f[a+148>>2]=1;f[a+152>>2]=1;n[a+156>>2]=.5;f[a+160>>2]=5;n[a+164>>2]=1.0;n[a+168>>2]=.75;n[a+172>>2]=1.0;n[a+176>>2]=1.0}if(f[a+12>>2]&7|0){n[a+180>>2]=.5;n[a+184>>2]=.5;n[a+188>>2]=.25}d=c;f[d>>2]=0;f[d+4>>2]=0;d=f[a+4>>2]|0;if(!(d&1))return;a=d&-2;if(!(f[a>>2]|0))return;ljc(a);return}function _Wa(a){a=a|0;return 1}function $Wa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+56|0;k=a+60|0;l=a+88|0;m=a+144|0;n=e+8|0;o=a+76|0;p=e+4|0;q=a+80|0;r=e+4|0;s=a+92|0;t=a+96|0;v=a+148|0;w=a+152|0;x=a+100|0;y=a+4|0;z=a+156|0;A=a+160|0;B=a+164|0;C=a+168|0;D=a+64|0;E=a+172|0;F=a+68|0;G=a+104|0;H=a+108|0;I=a+116|0;K=e+8|0;L=a+176|0;M=a+16|0;N=e+4|0;O=a+32|0;P=a+36|0;Q=a+40|0;R=a+44|0;S=a+48|0;T=a+52|0;U=a+120|0;V=a+12|0;W=a+180|0;X=a+184|0;Y=a+188|0;Z=a+124|0;_=a+72|0;$=a+128|0;aa=a+132|0;ba=a+136|0;ca=a+112|0;da=a+117|0;ea=e+8|0;fa=a+140|0;ga=a+84|0;a=e+4|0;a:while(1){ha=f[c>>2]|0;ia=f[g>>2]|0;do if(ha>>>0<ia>>>0){ja=b[ha>>0]|0;ka=ja&255;la=ha+1|0;if(ja<<24>>24>0){ma=la;na=ka}else{if(la>>>0>=ia>>>0){oa=ka;pa=7;break}ja=h[la>>0]|0;if(((ja^128)&ka)>>>0<=127){oa=ka;pa=7;break}ma=ha+2|0;na=ka+-128+(ja<<7)|0}f[c>>2]=ma;qa=na;pa=9}else{oa=0;pa=7}while(0);if((pa|0)==7){pa=0;ha=WRb(c,oa)|0;if((ha+-1|0)>>>0<16383){qa=ha;pa=9}else ra=ha}b:do if((pa|0)==9){pa=0;do switch(qa>>>3&536870911|0){case 1:{if((qa&255|0)!=10){ra=qa;break b}f[i>>2]=f[i>>2]|1;ha=f[j>>2]|0;if((ha|0)==527320){GLa(j,527320);sa=f[j>>2]|0}else sa=ha;if(fUb(c,sa)|0)continue a;else{ta=0;pa=277;break a}break}case 2:{if((qa&255|0)!=18){ra=qa;break b}f[i>>2]=f[i>>2]|2;ha=f[k>>2]|0;if((ha|0)==527320){GLa(k,527320);ua=f[k>>2]|0}else ua=ha;if(fUb(c,ua)|0)continue a;else{ta=0;pa=277;break a}break}case 3:{if((qa&255|0)!=24){ra=qa;break b}f[i>>2]=f[i>>2]|256;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){ia=b[ha>>0]|0;ja=ia&255;if(ia<<24>>24>-1){f[l>>2]=ja;f[c>>2]=ha+1;continue a}else va=ja}else va=0;ja=HRb(c,va)|0;ha=J;f[l>>2]=ja;if((ha|0)>-1|(ha|0)==-1&ja>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 4:{if((qa&255|0)!=32){ra=qa;break b}f[i>>2]=f[i>>2]|8388608;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(ha=b[ja>>0]|0,ha<<24>>24>-1):0){f[c>>2]=ja+1;wa=ha<<24>>24!=0}else{IRb(e,c);ha=e;if(!(b[n>>0]|0)){ta=0;pa=277;break a}else wa=(f[ha>>2]|0)!=0|(f[ha+4>>2]|0)!=0}b[m>>0]=wa&1;continue a;break}case 5:{if((qa&255|0)!=42){ra=qa;break b}f[i>>2]=f[i>>2]|32;ha=f[o>>2]|0;if(!ha){ja=VDc(48)|0;BWa(ja);f[o>>2]=ja;xa=ja}else xa=ha;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0?(ja=b[ha>>0]|0,ja<<24>>24>-1):0){f[c>>2]=ha+1;ya=ja&255}else{ja=VRb(c)|0;if((ja|0)>-1)ya=ja;else{ta=0;pa=277;break a}}GRb(e,c,ya);if((f[p>>2]|0)<0){pa=38;break a}if(!(Mi[f[(f[xa>>2]|0)+44>>2]&1023](xa,c)|0)){pa=38;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{ta=0;pa=277;break a}break}case 6:{if((qa&255|0)!=50){ra=qa;break b}f[i>>2]=f[i>>2]|64;ja=f[q>>2]|0;if(!ja){ha=VDc(48)|0;BWa(ha);f[q>>2]=ha;za=ha}else za=ja;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(ha=b[ja>>0]|0,ha<<24>>24>-1):0){f[c>>2]=ja+1;Aa=ha&255}else{ha=VRb(c)|0;if((ha|0)>-1)Aa=ha;else{ta=0;pa=277;break a}}GRb(e,c,Aa);if((f[r>>2]|0)<0){pa=49;break a}if(!(Mi[f[(f[za>>2]|0)+44>>2]&1023](za,c)|0)){pa=49;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{ta=0;pa=277;break a}break}case 7:{if((qa&255|0)!=56){ra=qa;break b}f[i>>2]=f[i>>2]|512;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){ja=b[ha>>0]|0;ia=ja&255;if(ja<<24>>24>-1){f[s>>2]=ia;f[c>>2]=ha+1;continue a}else Ba=ia}else Ba=0;ia=HRb(c,Ba)|0;ha=J;f[s>>2]=ia;if((ha|0)>-1|(ha|0)==-1&ia>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 8:{if((qa&255|0)!=64){ra=qa;break b}f[i>>2]=f[i>>2]|1024;ia=f[c>>2]|0;if(ia>>>0<(f[g>>2]|0)>>>0){ha=b[ia>>0]|0;ja=ha&255;if(ha<<24>>24>-1){f[t>>2]=ja;f[c>>2]=ia+1;continue a}else Ca=ja}else Ca=0;ja=HRb(c,Ca)|0;ia=J;f[t>>2]=ja;if((ia|0)>-1|(ia|0)==-1&ja>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 9:{if((qa&255|0)!=72){ra=qa;break b}f[i>>2]=f[i>>2]|16777216;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0){ia=b[ja>>0]|0;ha=ia&255;if(ia<<24>>24>-1){f[v>>2]=ha;f[c>>2]=ja+1;continue a}else Da=ha}else Da=0;ha=HRb(c,Da)|0;ja=J;f[v>>2]=ha;if((ja|0)>-1|(ja|0)==-1&ha>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 10:{if((qa&255|0)!=80){ra=qa;break b}f[i>>2]=f[i>>2]|33554432;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){ja=b[ha>>0]|0;ia=ja&255;if(ja<<24>>24>-1){f[w>>2]=ia;f[c>>2]=ha+1;continue a}else Ea=ia}else Ea=0;ia=HRb(c,Ea)|0;ha=J;f[w>>2]=ia;if((ha|0)>-1|(ha|0)==-1&ia>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 11:{if((qa&255|0)!=88){ra=qa;break b}ia=f[c>>2]|0;if(ia>>>0<(f[g>>2]|0)>>>0){ha=b[ia>>0]|0;ja=ha&255;if(ha<<24>>24>-1){f[c>>2]=ia+1;Fa=ja}else{Ga=ja;pa=75}}else{Ga=0;pa=75}if((pa|0)==75){pa=0;ja=HRb(c,Ga)|0;ia=J;if((ia|0)>-1|(ia|0)==-1&ja>>>0>4294967295)Fa=ja;else{ta=0;pa=277;break a}}if(Fa>>>0<3){f[i>>2]=f[i>>2]|2048;f[x>>2]=Fa;continue a}ja=f[y>>2]|0;if(!(ja&1))Ha=mNa(y)|0;else Ha=ja&-2;rjc(Ha,11,Fa,((Fa|0)<0)<<31>>31);continue a;break}case 12:{if((qa&255|0)!=101){ra=qa;break b}f[i>>2]=f[i>>2]|67108864;ja=f[c>>2]|0;if(((f[g>>2]|0)-ja|0)>3){ia=ja;ha=h[ia>>0]|h[ia+1>>0]<<8|h[ia+2>>0]<<16|h[ia+3>>0]<<24;f[e>>2]=ha;f[c>>2]=ja+4;Ia=ha}else{if(!(TRb(c,e)|0)){pa=88;break a}Ia=f[e>>2]|0}f[z>>2]=Ia;continue a;break}case 13:{if((qa&255|0)!=104){ra=qa;break b}f[i>>2]=f[i>>2]|134217728;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){ja=b[ha>>0]|0;ia=ja&255;if(ja<<24>>24>-1){f[A>>2]=ia;f[c>>2]=ha+1;continue a}else Ja=ia}else Ja=0;ia=HRb(c,Ja)|0;ha=J;f[A>>2]=ia;if((ha|0)>-1|(ha|0)==-1&ia>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 14:{if((qa&255|0)!=117){ra=qa;break b}f[i>>2]=f[i>>2]|268435456;ia=f[c>>2]|0;if(((f[g>>2]|0)-ia|0)>3){ha=ia;ja=h[ha>>0]|h[ha+1>>0]<<8|h[ha+2>>0]<<16|h[ha+3>>0]<<24;f[e>>2]=ja;f[c>>2]=ia+4;Ka=ja}else{if(!(TRb(c,e)|0)){pa=100;break a}Ka=f[e>>2]|0}f[B>>2]=Ka;continue a;break}case 15:{if((qa&255|0)!=125){ra=qa;break b}f[i>>2]=f[i>>2]|536870912;ja=f[c>>2]|0;if(((f[g>>2]|0)-ja|0)>3){ia=ja;ha=h[ia>>0]|h[ia+1>>0]<<8|h[ia+2>>0]<<16|h[ia+3>>0]<<24;f[e>>2]=ha;f[c>>2]=ja+4;La=ha}else{if(!(TRb(c,e)|0)){pa=107;break a}La=f[e>>2]|0}f[C>>2]=La;continue a;break}case 16:{if((qa&255|0)!=130){ra=qa;break b}f[i>>2]=f[i>>2]|4;ha=f[D>>2]|0;if((ha|0)==527320){GLa(D,527320);Ma=f[D>>2]|0}else Ma=ha;if(fUb(c,Ma)|0)continue a;else{ta=0;pa=277;break a}break}case 17:{if((qa&255|0)!=141){ra=qa;break b}f[i>>2]=f[i>>2]|1073741824;ha=f[c>>2]|0;if(((f[g>>2]|0)-ha|0)>3){ja=ha;ia=h[ja>>0]|h[ja+1>>0]<<8|h[ja+2>>0]<<16|h[ja+3>>0]<<24;f[e>>2]=ia;f[c>>2]=ha+4;Na=ia}else{if(!(TRb(c,e)|0)){pa=118;break a}Na=f[e>>2]|0}f[E>>2]=Na;continue a;break}case 18:{if((qa&255|0)!=146){ra=qa;break b}f[i>>2]=f[i>>2]|8;ia=f[F>>2]|0;if((ia|0)==527320){GLa(F,527320);Oa=f[F>>2]|0}else Oa=ia;if(fUb(c,Oa)|0)continue a;else{ta=0;pa=277;break a}break}case 19:{if((qa&255|0)!=152){ra=qa;break b}f[i>>2]=f[i>>2]|4096;ia=f[c>>2]|0;if(ia>>>0<(f[g>>2]|0)>>>0){ha=b[ia>>0]|0;ja=ha&255;if(ha<<24>>24>-1){f[G>>2]=ja;f[c>>2]=ia+1;continue a}else Pa=ja}else Pa=0;ja=HRb(c,Pa)|0;ia=J;f[G>>2]=ja;if((ia|0)>-1|(ia|0)==-1&ja>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 20:{if((qa&255|0)!=160){ra=qa;break b}f[i>>2]=f[i>>2]|8192;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0){ia=b[ja>>0]|0;ha=ia&255;if(ia<<24>>24>-1){f[H>>2]=ha;f[c>>2]=ja+1;continue a}else Qa=ha}else Qa=0;ha=HRb(c,Qa)|0;ja=J;f[H>>2]=ha;if((ja|0)>-1|(ja|0)==-1&ha>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 21:{if((qa&255|0)!=168){ra=qa;break b}f[i>>2]=f[i>>2]|32768;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0?(ja=b[ha>>0]|0,ja<<24>>24>-1):0){f[c>>2]=ha+1;Ra=ja<<24>>24!=0}else{IRb(e,c);ja=e;if(!(b[K>>0]|0)){ta=0;pa=277;break a}else Ra=(f[ja>>2]|0)!=0|(f[ja+4>>2]|0)!=0}b[I>>0]=Ra&1;continue a;break}case 22:{if((qa&255|0)!=181){ra=qa;break b}f[i>>2]=f[i>>2]|-2147483648;ja=f[c>>2]|0;if(((f[g>>2]|0)-ja|0)>3){ha=ja;ia=h[ha>>0]|h[ha+1>>0]<<8|h[ha+2>>0]<<16|h[ha+3>>0]<<24;f[e>>2]=ia;f[c>>2]=ja+4;Sa=ia}else{if(!(TRb(c,e)|0)){pa=145;break a}Sa=f[e>>2]|0}f[L>>2]=Sa;continue a;break}case 50:{if((qa&255|0)!=146){ra=qa;break b}ia=AXa(M)|0;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(ha=b[ja>>0]|0,ha<<24>>24>-1):0){f[c>>2]=ja+1;Ta=ha&255}else{ha=VRb(c)|0;if((ha|0)>-1)Ta=ha;else{ta=0;pa=277;break a}}GRb(e,c,Ta);if((f[N>>2]|0)<0){pa=153;break a}if(!(Mi[f[(f[ia>>2]|0)+44>>2]&1023](ia,c)|0)){pa=153;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{ta=0;pa=277;break a}break}case 51:{switch((qa&255)<<24>>24){case -99:break;case -102:{if(BVa(c,O)|0)continue a;else{ta=0;pa=277;break a}break}default:{ra=qa;break b}}ia=f[c>>2]|0;if(((f[g>>2]|0)-ia|0)>3){ha=ia;ja=h[ha>>0]|h[ha+1>>0]<<8|h[ha+2>>0]<<16|h[ha+3>>0]<<24;f[e>>2]=ja;f[c>>2]=ia+4;Ua=ja}else{if(!(TRb(c,e)|0)){pa=171;break a}Ua=f[e>>2]|0}ja=f[O>>2]|0;if((ja|0)==(f[P>>2]|0)){SHa(O,ja+1|0);Va=f[O>>2]|0}else Va=ja;ja=f[Q>>2]|0;ia=Va+1|0;f[O>>2]=ia;f[ja+4+(Va<<2)>>2]=Ua;ha=f[c>>2]|0;ka=(f[g>>2]|0)-ha|0;if((ka|0)<=0)continue a;la=ha;ha=(f[P>>2]|0)-ia|0;Wa=(ka>>>0)/6|0;Xa=(Wa|0)<(ha|0)?Wa:ha;if((Xa|0)>0){Ya=0;Za=la;_a=ia}else continue a;while(1){if((b[Za>>0]|0)!=-99){$a=Ya;break}if((b[Za+1>>0]|0)!=3){$a=Ya;break}ia=Za+2|0;ha=h[ia>>0]|h[ia+1>>0]<<8|h[ia+2>>0]<<16|h[ia+3>>0]<<24;ia=_a;_a=_a+1|0;f[O>>2]=_a;f[ja+4+(ia<<2)>>2]=ha;ha=Ya+1|0;if((ha|0)>=(Xa|0)){$a=ha;break}else{Ya=ha;Za=Za+6|0}}Xa=$a*6|0;if(($a|0)<=0)continue a;if((ka|0)<(Xa|0)){PRb(c,Xa,ka)|0;continue a}else{f[c>>2]=la+Xa;continue a}break}case 52:{switch((qa&255)<<24>>24){case -91:break;case -94:{if(BVa(c,R)|0)continue a;else{ta=0;pa=277;break a}break}default:{ra=qa;break b}}Xa=f[c>>2]|0;if(((f[g>>2]|0)-Xa|0)>3){ja=Xa;ha=h[ja>>0]|h[ja+1>>0]<<8|h[ja+2>>0]<<16|h[ja+3>>0]<<24;f[e>>2]=ha;f[c>>2]=Xa+4;ab=ha}else{if(!(TRb(c,e)|0)){pa=189;break a}ab=f[e>>2]|0}ha=f[R>>2]|0;if((ha|0)==(f[S>>2]|0)){SHa(R,ha+1|0);bb=f[R>>2]|0}else bb=ha;ha=f[T>>2]|0;Xa=bb+1|0;f[R>>2]=Xa;f[ha+4+(bb<<2)>>2]=ab;ja=f[c>>2]|0;ia=(f[g>>2]|0)-ja|0;if((ia|0)<=0)continue a;Wa=ja;ja=(f[S>>2]|0)-Xa|0;cb=(ia>>>0)/6|0;db=(cb|0)<(ja|0)?cb:ja;if((db|0)>0){eb=0;fb=Wa;gb=Xa}else continue a;while(1){if((b[fb>>0]|0)!=-91){hb=eb;break}if((b[fb+1>>0]|0)!=3){hb=eb;break}Xa=fb+2|0;ja=h[Xa>>0]|h[Xa+1>>0]<<8|h[Xa+2>>0]<<16|h[Xa+3>>0]<<24;Xa=gb;gb=gb+1|0;f[R>>2]=gb;f[ha+4+(Xa<<2)>>2]=ja;ja=eb+1|0;if((ja|0)>=(db|0)){hb=ja;break}else{eb=ja;fb=fb+6|0}}db=hb*6|0;if((hb|0)<=0)continue a;if((ia|0)<(db|0)){PRb(c,db,ia)|0;continue a}else{f[c>>2]=Wa+db;continue a}break}case 53:{if((qa&255|0)!=168){ra=qa;break b}f[i>>2]=f[i>>2]|131072;db=f[c>>2]|0;if(db>>>0<(f[g>>2]|0)>>>0){ha=b[db>>0]|0;la=ha&255;if(ha<<24>>24>-1){f[U>>2]=la;f[c>>2]=db+1;continue a}else ib=la}else ib=0;la=HRb(c,ib)|0;db=J;f[U>>2]=la;if((db|0)>-1|(db|0)==-1&la>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 54:{if((qa&255|0)!=181){ra=qa;break b}f[V>>2]=f[V>>2]|1;la=f[c>>2]|0;if(((f[g>>2]|0)-la|0)>3){db=la;ha=h[db>>0]|h[db+1>>0]<<8|h[db+2>>0]<<16|h[db+3>>0]<<24;f[e>>2]=ha;f[c>>2]=la+4;jb=ha}else{if(!(TRb(c,e)|0)){pa=202;break a}jb=f[e>>2]|0}f[W>>2]=jb;continue a;break}case 55:{if((qa&255|0)!=189){ra=qa;break b}f[V>>2]=f[V>>2]|2;ha=f[c>>2]|0;if(((f[g>>2]|0)-ha|0)>3){la=ha;db=h[la>>0]|h[la+1>>0]<<8|h[la+2>>0]<<16|h[la+3>>0]<<24;f[e>>2]=db;f[c>>2]=ha+4;kb=db}else{if(!(TRb(c,e)|0)){pa=209;break a}kb=f[e>>2]|0}f[X>>2]=kb;continue a;break}case 56:{if((qa&255|0)!=197){ra=qa;break b}f[V>>2]=f[V>>2]|4;db=f[c>>2]|0;if(((f[g>>2]|0)-db|0)>3){ha=db;la=h[ha>>0]|h[ha+1>>0]<<8|h[ha+2>>0]<<16|h[ha+3>>0]<<24;f[e>>2]=la;f[c>>2]=db+4;lb=la}else{if(!(TRb(c,e)|0)){pa=216;break a}lb=f[e>>2]|0}f[Y>>2]=lb;continue a;break}case 58:{if((qa&255|0)!=208){ra=qa;break b}f[i>>2]=f[i>>2]|262144;la=f[c>>2]|0;if(la>>>0<(f[g>>2]|0)>>>0){db=b[la>>0]|0;ha=db&255;if(db<<24>>24>-1){f[Z>>2]=ha;f[c>>2]=la+1;continue a}else mb=ha}else mb=0;ha=HRb(c,mb)|0;la=J;f[Z>>2]=ha;if((la|0)>-1|(la|0)==-1&ha>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 59:{if((qa&255|0)!=218){ra=qa;break b}f[i>>2]=f[i>>2]|16;ha=f[_>>2]|0;if((ha|0)==525064){GLa(_,525064);nb=f[_>>2]|0}else nb=ha;if(fUb(c,nb)|0)continue a;else{ta=0;pa=277;break a}break}case 60:{if((qa&255|0)!=224){ra=qa;break b}f[i>>2]=f[i>>2]|524288;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){la=b[ha>>0]|0;db=la&255;if(la<<24>>24>-1){f[c>>2]=ha+1;ob=db}else{pb=db;pa=230}}else{pb=0;pa=230}if((pa|0)==230){pa=0;db=HRb(c,pb)|0;ha=J;if((ha|0)>-1|(ha|0)==-1&db>>>0>4294967295)ob=db;else{ta=0;pa=277;break a}}f[$>>2]=ob;continue a;break}case 61:{if((qa&255|0)!=232){ra=qa;break b}f[i>>2]=f[i>>2]|1048576;db=f[c>>2]|0;if(db>>>0<(f[g>>2]|0)>>>0){ha=b[db>>0]|0;la=ha&255;if(ha<<24>>24>-1){f[c>>2]=db+1;qb=la}else{rb=la;pa=236}}else{rb=0;pa=236}if((pa|0)==236){pa=0;la=HRb(c,rb)|0;db=J;if((db|0)>-1|(db|0)==-1&la>>>0>4294967295)qb=la;else{ta=0;pa=277;break a}}f[aa>>2]=qb;continue a;break}case 62:{if((qa&255|0)!=240){ra=qa;break b}f[i>>2]=f[i>>2]|2097152;la=f[c>>2]|0;if(la>>>0<(f[g>>2]|0)>>>0){db=b[la>>0]|0;ha=db&255;if(db<<24>>24>-1){f[c>>2]=la+1;sb=ha}else{tb=ha;pa=242}}else{tb=0;pa=242}if((pa|0)==242){pa=0;ha=HRb(c,tb)|0;la=J;if((la|0)>-1|(la|0)==-1&ha>>>0>4294967295)sb=ha;else{ta=0;pa=277;break a}}f[ba>>2]=sb;continue a;break}case 63:{if((qa&255|0)!=248){ra=qa;break b}f[i>>2]=f[i>>2]|16384;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){la=b[ha>>0]|0;db=la&255;if(la<<24>>24>-1){f[c>>2]=ha+1;ub=db}else{vb=db;pa=248}}else{vb=0;pa=248}if((pa|0)==248){pa=0;db=HRb(c,vb)|0;ha=J;if((ha|0)>-1|(ha|0)==-1&db>>>0>4294967295)ub=db;else{ta=0;pa=277;break a}}f[ca>>2]=ub;continue a;break}case 64:{if(qa&255|0){ra=qa;break b}f[i>>2]=f[i>>2]|65536;db=f[c>>2]|0;if(db>>>0<(f[g>>2]|0)>>>0?(ha=b[db>>0]|0,ha<<24>>24>-1):0){f[c>>2]=db+1;wb=ha<<24>>24!=0}else{IRb(e,c);ha=e;if(!(b[ea>>0]|0)){ta=0;pa=277;break a}else wb=(f[ha>>2]|0)!=0|(f[ha+4>>2]|0)!=0}b[da>>0]=wb&1;continue a;break}case 65:{if((qa&255|0)!=8){ra=qa;break b}f[i>>2]=f[i>>2]|4194304;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){db=b[ha>>0]|0;la=db&255;if(db<<24>>24>-1){f[fa>>2]=la;f[c>>2]=ha+1;continue a}else xb=la}else xb=0;la=HRb(c,xb)|0;ha=J;f[fa>>2]=la;if((ha|0)>-1|(ha|0)==-1&la>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 1001:{if((qa&255|0)!=74){ra=qa;break b}f[i>>2]=f[i>>2]|128;la=f[ga>>2]|0;if(!la){ha=VDc(20)|0;jXa(ha);f[ga>>2]=ha;yb=ha}else yb=la;la=f[c>>2]|0;if(la>>>0<(f[g>>2]|0)>>>0?(ha=b[la>>0]|0,ha<<24>>24>-1):0){f[c>>2]=la+1;zb=ha&255}else{ha=VRb(c)|0;if((ha|0)>-1)zb=ha;else{ta=0;pa=277;break a}}GRb(e,c,zb);if((f[a>>2]|0)<0){pa=270;break a}if(!(Mi[f[(f[yb>>2]|0)+44>>2]&1023](yb,c)|0)){pa=270;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{ta=0;pa=277;break a}break}default:{ra=qa;break b}}while(0)}while(0);if(!ra){ta=1;pa=277;break}ha=f[y>>2]|0;if(!(ha&1))Ab=mNa(y)|0;else Ab=ha&-2;if(!(Djc(c,ra,Ab)|0)){ta=0;pa=277;break}}switch(pa|0){case 38:{ta=0;u=d;return ta|0}case 49:{ta=0;u=d;return ta|0}case 88:{ta=0;u=d;return ta|0}case 100:{ta=0;u=d;return ta|0}case 107:{ta=0;u=d;return ta|0}case 118:{ta=0;u=d;return ta|0}case 145:{ta=0;u=d;return ta|0}case 153:{ta=0;u=d;return ta|0}case 171:{ta=0;u=d;return ta|0}case 189:{ta=0;u=d;return ta|0}case 202:{ta=0;u=d;return ta|0}case 209:{ta=0;u=d;return ta|0}case 216:{ta=0;u=d;return ta|0}case 270:{ta=0;u=d;return ta|0}case 277:{u=d;return ta|0}}return 0}function aXa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=(c<<1)+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+32>>2]|0;c=f[a+44>>2]|0;h=(i<<2)+g+(c<<2)+(c+i<<1)|0;i=a+8|0;c=f[i>>2]|0;if(c&255){if(!(c&1))k=h;else{g=f[a+56>>2]|0;d=b[g+11>>0]|0;e=d<<24>>24<0?f[g+4>>2]|0:d&255;k=h+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=k;else{e=f[a+60>>2]|0;d=b[e+11>>0]|0;g=d<<24>>24<0?f[e+4>>2]|0:d&255;l=k+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))m=l;else{g=f[a+64>>2]|0;k=b[g+11>>0]|0;d=k<<24>>24<0?f[g+4>>2]|0:k&255;m=l+2+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8))n=m;else{d=f[a+68>>2]|0;l=b[d+11>>0]|0;k=l<<24>>24<0?f[d+4>>2]|0:l&255;n=m+2+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&16))o=n;else{k=f[a+72>>2]|0;m=b[k+11>>0]|0;l=m<<24>>24<0?f[k+4>>2]|0:m&255;o=n+2+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&32)){p=o;q=c}else{l=f[a+76>>2]|0;n=_i[f[(f[l>>2]|0)+48>>2]&1023](l)|0;l=o+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=l;q=f[i>>2]|0}if(!(q&64)){r=p;s=q}else{q=f[a+80>>2]|0;l=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=p+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=q;s=f[i>>2]|0}if(!(s&128)){t=r;u=s}else{s=f[a+84>>2]|0;q=_i[f[(f[s>>2]|0)+48>>2]&1023](s)|0;s=r+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;t=s;u=f[i>>2]|0}}else{t=h;u=c}if(!(u&65280))v=t;else{if(!(u&256))w=t;else w=t+1+((((($(f[a+88>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&512))x=w;else x=w+1+((((($(f[a+92>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&1024))y=x;else y=x+1+((((($(f[a+96>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&2048))z=y;else{x=f[a+100>>2]|0;if((x|0)<0)A=10;else A=(((($(x|1|0)|0)^31)*9|0)+73|0)>>>6;z=y+1+A|0}if(!(u&4096))B=z;else B=z+2+((((($(f[a+104>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&8192))C=B;else C=B+2+((((($(f[a+108>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&16384))D=C;else{B=f[a+112>>2]|0;if((B|0)<0)E=10;else E=(((($(B|1|0)|0)^31)*9|0)+73|0)>>>6;D=C+2+E|0}v=u&32768|0?D+3|0:D}if(!(u&16711680))F=v;else{D=u&65536|0?v+3|0:v;if(!(u&131072))G=D;else G=D+2+((((($(f[a+120>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&262144))H=G;else H=G+2+((((($(f[a+124>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&524288))I=H;else{G=f[a+128>>2]|0;if((G|0)<0)J=12;else J=((((($(G|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;I=J+H|0}if(!(u&1048576))K=I;else{H=f[a+132>>2]|0;if((H|0)<0)L=12;else L=((((($(H|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;K=L+I|0}if(!(u&2097152))M=K;else{I=f[a+136>>2]|0;if((I|0)<0)N=12;else N=((((($(I|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;M=N+K|0}if(!(u&4194304))O=M;else O=M+2+((((($(f[a+140>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;F=u&8388608|0?O+2|0:O}if(u>>>0>16777215){if(!(u&16777216))P=F;else P=F+1+((((($(f[a+148>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&33554432))Q=P;else Q=P+1+((((($(f[a+152>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;P=u&67108864|0?Q+5|0:Q;if(!(u&134217728))R=P;else R=P+1+((((($(f[a+160>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;P=u&268435456|0?R+5|0:R;R=u&536870912|0?P+5|0:P;P=u&1073741824|0?R+6|0:R;S=(u|0)<0?P+6|0:P}else S=F;F=f[a+12>>2]|0;if(!(F&7)){T=S;U=a+192|0;f[U>>2]=T;return T|0}P=F&1|0?S+6|0:S;S=F&2|0?P+6|0:P;T=F&4|0?S+6|0:S;U=a+192|0;f[U>>2]=T;return T|0}function bXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+8|0;e=f[d>>2]|0;if(e&1|0)$Tb(1,f[a+56>>2]|0,c);if(e&2|0)$Tb(2,f[a+60>>2]|0,c);if(e&256|0)OTb(3,f[a+88>>2]|0,c);if(e&8388608|0)YTb(4,(b[a+144>>0]|0)!=0,c);if(e&32|0)eUb(5,f[a+76>>2]|0,c);if(e&64|0)eUb(6,f[a+80>>2]|0,c);if(e&512|0)OTb(7,f[a+92>>2]|0,c);if(e&1024|0)OTb(8,f[a+96>>2]|0,c);if(e&16777216|0)OTb(9,f[a+148>>2]|0,c);if(e&33554432|0)OTb(10,f[a+152>>2]|0,c);if(e&2048|0)ZTb(11,f[a+100>>2]|0,c);if(e&67108864|0)WTb(12,+n[a+156>>2],c);if(e&134217728|0)OTb(13,f[a+160>>2]|0,c);if(e&268435456|0)WTb(14,+n[a+164>>2],c);if(e&536870912|0)WTb(15,+n[a+168>>2],c);if(e&4|0)$Tb(16,f[a+64>>2]|0,c);if(e&1073741824|0)WTb(17,+n[a+172>>2],c);if(e&8|0)$Tb(18,f[a+68>>2]|0,c);if(e&4096|0)OTb(19,f[a+104>>2]|0,c);if(e&8192|0)OTb(20,f[a+108>>2]|0,c);if(e&32768|0)YTb(21,(b[a+116>>0]|0)!=0,c);if((e|0)<0)WTb(22,+n[a+176>>2],c);g=f[a+20>>2]|0;if(g|0){h=a+28|0;i=0;do{eUb(50,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}g=f[a+32>>2]|0;if((g|0)>0){i=a+40|0;h=0;do{WTb(51,+n[(f[i>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(g|0))}g=f[a+44>>2]|0;if((g|0)>0){h=a+52|0;i=0;do{WTb(52,+n[(f[h>>2]|0)+4+(i<<2)>>2],c);i=i+1|0}while((i|0)!=(g|0))}if(e&131072|0)OTb(53,f[a+120>>2]|0,c);e=f[a+12>>2]|0;if(e&1|0)WTb(54,+n[a+180>>2],c);if(e&2|0)WTb(55,+n[a+184>>2],c);if(e&4|0)WTb(56,+n[a+188>>2],c);e=f[d>>2]|0;if(e&262144|0)OTb(58,f[a+124>>2]|0,c);if(e&16|0)$Tb(59,f[a+72>>2]|0,c);if(e&524288|0)MTb(60,f[a+128>>2]|0,c);if(e&1048576|0)MTb(61,f[a+132>>2]|0,c);if(e&2097152|0)MTb(62,f[a+136>>2]|0,c);if(e&16384|0)MTb(63,f[a+112>>2]|0,c);if(e&65536|0)YTb(64,(b[a+117>>0]|0)!=0,c);if(e&4194304|0)OTb(65,f[a+140>>2]|0,c);if(e&128|0)eUb(1001,f[a+84>>2]|0,c);e=f[a+4>>2]|0;if(!(e&1))return;Gjc(e&-2,c);return}function cXa(a){a=a|0;return f[a+192>>2]|0}function dXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;e=a+8|0;g=f[e>>2]|0;if(!(g&1))h=d;else{i=f[a+56>>2]|0;b[d>>0]=10;h=dSb(i,d+1|0)|0}if(!(g&2))j=h;else{d=f[a+60>>2]|0;b[h>>0]=18;j=dSb(d,h+1|0)|0}if(!(g&256))k=j;else{h=f[a+88>>2]|0;b[j>>0]=24;d=j+1|0;if(h>>>0>127){j=h;i=d;while(1){b[i>>0]=j|128;l=j>>>7;m=i+1|0;if(j>>>0>16383){j=l;i=m}else{n=m;o=l;break}}}else{n=d;o=h}b[n>>0]=o;k=n+1|0}if(!(g&8388608))p=k;else{n=b[a+144>>0]|0;b[k>>0]=32;b[k+1>>0]=n;p=k+2|0}if(!(g&32))q=p;else{k=f[a+76>>2]|0;b[p>>0]=42;n=p+1|0;p=_i[f[(f[k>>2]|0)+60>>2]&1023](k)|0;if(p>>>0>127){o=p;h=n;while(1){b[h>>0]=o|128;d=o>>>7;i=h+1|0;if(o>>>0>16383){o=d;h=i}else{r=i;s=d;break}}}else{r=n;s=p}b[r>>0]=s;q=hj[f[(f[k>>2]|0)+64>>2]&511](k,c,r+1|0)|0}if(!(g&64))t=q;else{r=f[a+80>>2]|0;b[q>>0]=50;k=q+1|0;q=_i[f[(f[r>>2]|0)+60>>2]&1023](r)|0;if(q>>>0>127){s=q;p=k;while(1){b[p>>0]=s|128;n=s>>>7;h=p+1|0;if(s>>>0>16383){s=n;p=h}else{u=h;v=n;break}}}else{u=k;v=q}b[u>>0]=v;t=hj[f[(f[r>>2]|0)+64>>2]&511](r,c,u+1|0)|0}if(!(g&512))w=t;else{u=f[a+92>>2]|0;b[t>>0]=56;r=t+1|0;if(u>>>0>127){t=u;v=r;while(1){b[v>>0]=t|128;q=t>>>7;k=v+1|0;if(t>>>0>16383){t=q;v=k}else{x=k;y=q;break}}}else{x=r;y=u}b[x>>0]=y;w=x+1|0}if(!(g&1024))z=w;else{x=f[a+96>>2]|0;b[w>>0]=64;y=w+1|0;if(x>>>0>127){w=x;u=y;while(1){b[u>>0]=w|128;r=w>>>7;v=u+1|0;if(w>>>0>16383){w=r;u=v}else{A=v;B=r;break}}}else{A=y;B=x}b[A>>0]=B;z=A+1|0}if(!(g&16777216))C=z;else{A=f[a+148>>2]|0;b[z>>0]=72;B=z+1|0;if(A>>>0>127){z=A;x=B;while(1){b[x>>0]=z|128;y=z>>>7;u=x+1|0;if(z>>>0>16383){z=y;x=u}else{D=u;E=y;break}}}else{D=B;E=A}b[D>>0]=E;C=D+1|0}if(!(g&33554432))F=C;else{D=f[a+152>>2]|0;b[C>>0]=80;E=C+1|0;if(D>>>0>127){C=D;A=E;while(1){b[A>>0]=C|128;B=C>>>7;x=A+1|0;if(C>>>0>16383){C=B;A=x}else{G=x;H=B;break}}}else{G=E;H=D}b[G>>0]=H;F=G+1|0}if(!(g&2048))I=F;else{G=f[a+100>>2]|0;b[F>>0]=88;H=F+1|0;F=G&255;if(G>>>0>127){D=H;E=F;A=G;C=((G|0)<0)<<31>>31;while(1){b[D>>0]=E|-128;G=A;A=aJc(A|0,C|0,7)|0;B=D+1|0;x=A&255;if(!(C>>>0>0|(C|0)==0&G>>>0>16383)){K=B;L=x;break}else{D=B;E=x;C=J}}}else{K=H;L=F}b[K>>0]=L;I=K+1|0}if(!(g&67108864))M=I;else{K=f[a+156>>2]|0;b[I>>0]=101;L=I+1|0;b[L>>0]=K;b[L+1>>0]=K>>8;b[L+2>>0]=K>>16;b[L+3>>0]=K>>24;M=I+5|0}if(!(g&134217728))N=M;else{I=f[a+160>>2]|0;b[M>>0]=104;K=M+1|0;if(I>>>0>127){M=I;L=K;while(1){b[L>>0]=M|128;F=M>>>7;H=L+1|0;if(M>>>0>16383){M=F;L=H}else{O=H;P=F;break}}}else{O=K;P=I}b[O>>0]=P;N=O+1|0}if(!(g&268435456))Q=N;else{O=f[a+164>>2]|0;b[N>>0]=117;P=N+1|0;b[P>>0]=O;b[P+1>>0]=O>>8;b[P+2>>0]=O>>16;b[P+3>>0]=O>>24;Q=N+5|0}if(!(g&536870912))R=Q;else{N=f[a+168>>2]|0;b[Q>>0]=125;O=Q+1|0;b[O>>0]=N;b[O+1>>0]=N>>8;b[O+2>>0]=N>>16;b[O+3>>0]=N>>24;R=Q+5|0}if(!(g&4))S=R;else{Q=f[a+64>>2]|0;b[R>>0]=-126;b[R+1>>0]=1;S=dSb(Q,R+2|0)|0}if(!(g&1073741824))T=S;else{R=f[a+172>>2]|0;b[S>>0]=-115;b[S+1>>0]=1;Q=S+2|0;b[Q>>0]=R;b[Q+1>>0]=R>>8;b[Q+2>>0]=R>>16;b[Q+3>>0]=R>>24;T=S+6|0}if(!(g&8))U=T;else{S=f[a+68>>2]|0;b[T>>0]=-110;b[T+1>>0]=1;U=dSb(S,T+2|0)|0}if(!(g&4096))V=U;else{T=f[a+104>>2]|0;b[U>>0]=-104;b[U+1>>0]=1;S=U+2|0;if(T>>>0>127){U=T;R=S;while(1){b[R>>0]=U|128;Q=U>>>7;N=R+1|0;if(U>>>0>16383){U=Q;R=N}else{W=N;X=Q;break}}}else{W=S;X=T}b[W>>0]=X;V=W+1|0}if(!(g&8192))Y=V;else{W=f[a+108>>2]|0;b[V>>0]=-96;b[V+1>>0]=1;X=V+2|0;if(W>>>0>127){V=W;T=X;while(1){b[T>>0]=V|128;S=V>>>7;R=T+1|0;if(V>>>0>16383){V=S;T=R}else{Z=R;_=S;break}}}else{Z=X;_=W}b[Z>>0]=_;Y=Z+1|0}if(!(g&32768))$=Y;else{Z=b[a+116>>0]|0;b[Y>>0]=-88;b[Y+1>>0]=1;b[Y+2>>0]=Z;$=Y+3|0}if((g|0)<0){Y=f[a+176>>2]|0;b[$>>0]=-75;b[$+1>>0]=1;Z=$+2|0;b[Z>>0]=Y;b[Z+1>>0]=Y>>8;b[Z+2>>0]=Y>>16;b[Z+3>>0]=Y>>24;aa=$+6|0}else aa=$;$=f[a+20>>2]|0;if(!$)ba=aa;else{Y=a+28|0;Z=0;_=aa;while(1){aa=f[(f[Y>>2]|0)+4+(Z<<2)>>2]|0;b[_>>0]=-110;b[_+1>>0]=3;W=_+2|0;X=_i[f[(f[aa>>2]|0)+60>>2]&1023](aa)|0;if(X>>>0>127){T=X;V=W;while(1){b[V>>0]=T|128;S=T>>>7;R=V+1|0;if(T>>>0>16383){T=S;V=R}else{ca=R;da=S;break}}}else{ca=W;da=X}b[ca>>0]=da;V=hj[f[(f[aa>>2]|0)+64>>2]&511](aa,c,ca+1|0)|0;Z=Z+1|0;if((Z|0)==($|0)){ba=V;break}else _=V}}_=f[a+32>>2]|0;if(!_)ea=ba;else{$=f[a+40>>2]|0;Z=0;ca=ba;while(1){ba=f[$+4+(Z<<2)>>2]|0;b[ca>>0]=-99;b[ca+1>>0]=3;da=ca+2|0;b[da>>0]=ba;b[da+1>>0]=ba>>8;b[da+2>>0]=ba>>16;b[da+3>>0]=ba>>24;ba=ca+6|0;Z=Z+1|0;if((Z|0)>=(_|0)){ea=ba;break}else ca=ba}}ca=f[a+44>>2]|0;if(!ca)fa=ea;else{_=f[a+52>>2]|0;Z=0;$=ea;while(1){ea=f[_+4+(Z<<2)>>2]|0;b[$>>0]=-91;b[$+1>>0]=3;ba=$+2|0;b[ba>>0]=ea;b[ba+1>>0]=ea>>8;b[ba+2>>0]=ea>>16;b[ba+3>>0]=ea>>24;ea=$+6|0;Z=Z+1|0;if((Z|0)>=(ca|0)){fa=ea;break}else $=ea}}if(!(g&131072))ga=fa;else{g=f[a+120>>2]|0;b[fa>>0]=-88;b[fa+1>>0]=3;$=fa+2|0;if(g>>>0>127){fa=g;ca=$;while(1){b[ca>>0]=fa|128;Z=fa>>>7;_=ca+1|0;if(fa>>>0>16383){fa=Z;ca=_}else{ha=_;ia=Z;break}}}else{ha=$;ia=g}b[ha>>0]=ia;ga=ha+1|0}ha=f[a+12>>2]|0;if(!(ha&1))ja=ga;else{ia=f[a+180>>2]|0;b[ga>>0]=-75;b[ga+1>>0]=3;g=ga+2|0;b[g>>0]=ia;b[g+1>>0]=ia>>8;b[g+2>>0]=ia>>16;b[g+3>>0]=ia>>24;ja=ga+6|0}if(!(ha&2))ka=ja;else{ga=f[a+184>>2]|0;b[ja>>0]=-67;b[ja+1>>0]=3;ia=ja+2|0;b[ia>>0]=ga;b[ia+1>>0]=ga>>8;b[ia+2>>0]=ga>>16;b[ia+3>>0]=ga>>24;ka=ja+6|0}if(!(ha&4))la=ka;else{ha=f[a+188>>2]|0;b[ka>>0]=-59;b[ka+1>>0]=3;ja=ka+2|0;b[ja>>0]=ha;b[ja+1>>0]=ha>>8;b[ja+2>>0]=ha>>16;b[ja+3>>0]=ha>>24;la=ka+6|0}ka=f[e>>2]|0;if(!(ka&262144))ma=la;else{e=f[a+124>>2]|0;b[la>>0]=-48;b[la+1>>0]=3;ha=la+2|0;if(e>>>0>127){la=e;ja=ha;while(1){b[ja>>0]=la|128;ga=la>>>7;ia=ja+1|0;if(la>>>0>16383){la=ga;ja=ia}else{na=ia;oa=ga;break}}}else{na=ha;oa=e}b[na>>0]=oa;ma=na+1|0}if(!(ka&16))pa=ma;else{na=f[a+72>>2]|0;b[ma>>0]=-38;b[ma+1>>0]=3;pa=dSb(na,ma+2|0)|0}if(!(ka&524288))qa=pa;else{ma=f[a+128>>2]|0;b[pa>>0]=-32;b[pa+1>>0]=3;na=pa+2|0;pa=ma&255;if(ma>>>0>127){oa=na;e=pa;ha=ma;ja=((ma|0)<0)<<31>>31;while(1){b[oa>>0]=e|-128;ma=ha;ha=aJc(ha|0,ja|0,7)|0;la=oa+1|0;ga=ha&255;if(!(ja>>>0>0|(ja|0)==0&ma>>>0>16383)){ra=la;sa=ga;break}else{oa=la;e=ga;ja=J}}}else{ra=na;sa=pa}b[ra>>0]=sa;qa=ra+1|0}if(!(ka&1048576))ta=qa;else{ra=f[a+132>>2]|0;b[qa>>0]=-24;b[qa+1>>0]=3;sa=qa+2|0;qa=ra&255;if(ra>>>0>127){pa=sa;na=qa;ja=ra;e=((ra|0)<0)<<31>>31;while(1){b[pa>>0]=na|-128;ra=ja;ja=aJc(ja|0,e|0,7)|0;oa=pa+1|0;ha=ja&255;if(!(e>>>0>0|(e|0)==0&ra>>>0>16383)){ua=oa;va=ha;break}else{pa=oa;na=ha;e=J}}}else{ua=sa;va=qa}b[ua>>0]=va;ta=ua+1|0}if(!(ka&2097152))wa=ta;else{ua=f[a+136>>2]|0;b[ta>>0]=-16;b[ta+1>>0]=3;va=ta+2|0;ta=ua&255;if(ua>>>0>127){qa=va;sa=ta;e=ua;na=((ua|0)<0)<<31>>31;while(1){b[qa>>0]=sa|-128;ua=e;e=aJc(e|0,na|0,7)|0;pa=qa+1|0;ja=e&255;if(!(na>>>0>0|(na|0)==0&ua>>>0>16383)){xa=pa;ya=ja;break}else{qa=pa;sa=ja;na=J}}}else{xa=va;ya=ta}b[xa>>0]=ya;wa=xa+1|0}if(!(ka&16384))za=wa;else{xa=f[a+112>>2]|0;b[wa>>0]=-8;b[wa+1>>0]=3;ya=wa+2|0;wa=xa&255;if(xa>>>0>127){ta=ya;va=wa;na=xa;sa=((xa|0)<0)<<31>>31;while(1){b[ta>>0]=va|-128;xa=na;na=aJc(na|0,sa|0,7)|0;qa=ta+1|0;e=na&255;if(!(sa>>>0>0|(sa|0)==0&xa>>>0>16383)){Aa=qa;Ba=e;break}else{ta=qa;va=e;sa=J}}}else{Aa=ya;Ba=wa}b[Aa>>0]=Ba;za=Aa+1|0}if(!(ka&65536))Ca=za;else{Aa=b[a+117>>0]|0;b[za>>0]=-128;b[za+1>>0]=4;b[za+2>>0]=Aa;Ca=za+3|0}if(!(ka&4194304))Da=Ca;else{za=f[a+140>>2]|0;b[Ca>>0]=-120;b[Ca+1>>0]=4;Aa=Ca+2|0;if(za>>>0>127){Ca=za;Ba=Aa;while(1){b[Ba>>0]=Ca|128;wa=Ca>>>7;ya=Ba+1|0;if(Ca>>>0>16383){Ca=wa;Ba=ya}else{Ea=ya;Fa=wa;break}}}else{Ea=Aa;Fa=za}b[Ea>>0]=Fa;Da=Ea+1|0}if(!(ka&128))Ga=Da;else{ka=f[a+84>>2]|0;b[Da>>0]=-54;b[Da+1>>0]=62;Ea=Da+2|0;Da=_i[f[(f[ka>>2]|0)+60>>2]&1023](ka)|0;if(Da>>>0>127){Fa=Da;za=Ea;while(1){b[za>>0]=Fa|128;Aa=Fa>>>7;Ba=za+1|0;if(Fa>>>0>16383){Fa=Aa;za=Ba}else{Ha=Ba;Ia=Aa;break}}}else{Ha=Ea;Ia=Da}b[Ha>>0]=Ia;Ga=hj[f[(f[ka>>2]|0)+64>>2]&511](ka,c,Ha+1|0)|0}Ha=f[a+4>>2]|0;if(!(Ha&1)){Ja=Ga;return Ja|0}Ja=Hjc(Ha&-2,Ga)|0;return Ja|0}function eXa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function fXa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15064,0)|0;if(!c){Ehc(b,a);return}else{iXa(a,c);return}}function gXa(a,b){a=a|0;b=b|0;f[a+192>>2]=b;return}function hXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525600;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function iXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}PLa(a+16|0,c+16|0);e=a+32|0;h=c+32|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+40>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+40>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+44|0;e=c+44|0;g=f[e>>2]|0;if(g|0){SHa(h,(f[h>>2]|0)+g|0);dJc((f[a+52>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+52>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;do if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+56|0,g=f[c+56>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+60|0,d=f[c+60>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==527320){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+64|0,h=f[c+64>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==527320){GLa(d,h);break}else{iEc(g,h)|0;break}while(0);do if(e&8|0?(h=a+8|0,f[h>>2]=f[h>>2]|8,h=a+68|0,g=f[c+68>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&16|0?(g=a+8|0,f[g>>2]=f[g>>2]|16,g=a+72|0,d=f[c+72>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==525064){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);if(e&32|0){d=a+8|0;f[d>>2]=f[d>>2]|32;d=a+76|0;h=f[d>>2]|0;if(!h){g=VDc(48)|0;BWa(g);f[d>>2]=g;i=g}else i=h;h=f[c+76>>2]|0;CWa(i,h|0?h:521608)}if(e&64|0){h=a+8|0;f[h>>2]=f[h>>2]|64;h=a+80|0;g=f[h>>2]|0;if(!g){d=VDc(48)|0;BWa(d);f[h>>2]=d;j=d}else j=g;g=f[c+80>>2]|0;CWa(j,g|0?g:521608)}if(e&128|0){g=a+8|0;f[g>>2]=f[g>>2]|128;g=a+84|0;d=f[g>>2]|0;if(!d){h=VDc(20)|0;jXa(h);f[g>>2]=h;k=h}else k=d;d=f[c+84>>2]|0;h=d|0?d:523392;d=k+4|0;g=f[h+4>>2]|0;if(g&1|0){l=f[d>>2]|0;if(!(l&1))m=mNa(d)|0;else m=l&-2;ojc(m,g&-2)}if(f[h+8>>2]&1|0?(g=k+8|0,f[g>>2]=f[g>>2]|1,g=k+16|0,l=f[h+16>>2]|0,h=f[g>>2]|0,(h|0)!=(l|0)):0)if((h|0)==527320){GLa(g,l);break}else{iEc(h,l)|0;break}}}while(0);if(e&65280|0){if(e&256|0)f[a+88>>2]=f[c+88>>2];if(e&512|0)f[a+92>>2]=f[c+92>>2];if(e&1024|0)f[a+96>>2]=f[c+96>>2];if(e&2048|0)f[a+100>>2]=f[c+100>>2];if(e&4096|0)f[a+104>>2]=f[c+104>>2];if(e&8192|0)f[a+108>>2]=f[c+108>>2];if(e&16384|0)f[a+112>>2]=f[c+112>>2];if(e&32768|0)b[a+116>>0]=b[c+116>>0]|0;k=a+8|0;f[k>>2]=f[k>>2]|e}if(e&16711680|0){if(e&65536|0)b[a+117>>0]=b[c+117>>0]|0;if(e&131072|0)f[a+120>>2]=f[c+120>>2];if(e&262144|0)f[a+124>>2]=f[c+124>>2];if(e&524288|0)f[a+128>>2]=f[c+128>>2];if(e&1048576|0)f[a+132>>2]=f[c+132>>2];if(e&2097152|0)f[a+136>>2]=f[c+136>>2];if(e&4194304|0)f[a+140>>2]=f[c+140>>2];if(e&8388608|0)b[a+144>>0]=b[c+144>>0]|0;k=a+8|0;f[k>>2]=f[k>>2]|e}if(e>>>0>16777215){if(e&16777216|0)f[a+148>>2]=f[c+148>>2];if(e&33554432|0)f[a+152>>2]=f[c+152>>2];if(e&67108864|0)f[a+156>>2]=f[c+156>>2];if(e&134217728|0)f[a+160>>2]=f[c+160>>2];if(e&268435456|0)f[a+164>>2]=f[c+164>>2];if(e&536870912|0)f[a+168>>2]=f[c+168>>2];if(e&1073741824|0)f[a+172>>2]=f[c+172>>2];if((e|0)<0)f[a+176>>2]=f[c+176>>2];k=a+8|0;f[k>>2]=f[k>>2]|e}e=f[c+12>>2]|0;if(!(e&7))return;if(e&1|0)f[a+180>>2]=f[c+180>>2];if(e&2|0)f[a+184>>2]=f[c+184>>2];if(e&4|0)f[a+188>>2]=f[c+188>>2];c=a+12|0;f[c>>2]=f[c>>2]|e;return}function jXa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=88772;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523392?(f[220400]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=63;b[d+8>>0]=0;DTb(881600,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;u=c;return}function kXa(a){a=a|0;var c=0,d=0;f[a>>2]=88772;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function lXa(a){a=a|0;kXa(a);YDc(a);return}function mXa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function nXa(a,b){a=a|0;b=b|0;a=VDc(20)|0;jXa(a);if(!b)return a|0;zXa(b,a);return a|0}function oXa(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function pXa(a){a=a|0;return 1}function qXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=WRb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==10){f[e>>2]=f[e>>2]|1;j=f[g>>2]|0;if((j|0)==527320){GLa(g,527320);o=f[g>>2]|0}else o=j;if(fUb(c,o)|0)continue;else{p=0;l=15;break}}else n=k}if(!n){p=1;l=15;break}j=f[h>>2]|0;if(!(j&1))q=mNa(h)|0;else q=j&-2;if(!(Djc(c,n,q)|0)){p=0;l=15;break}}if((l|0)==15)return p|0;return 0}function rXa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;if(!(f[a+8>>2]&1)){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+16>>2]|0;h=b[c+11>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;e=d+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function sXa(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)$Tb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function tXa(a){a=a|0;return f[a+12>>2]|0}function uXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=10;e=dSb(c,d+1|0)|0}d=f[a+4>>2]|0;if(!(d&1)){g=e;return g|0}g=Hjc(d&-2,e)|0;return g|0}function vXa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function wXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15080,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[c+16>>2]|0;c=f[d>>2]|0;if((c|0)==(a|0))return;if((c|0)==527320){GLa(d,a);return}else{iEc(c,a)|0;return}}function xXa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function yXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525376;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function zXa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function AXa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(108)|0;BXa(a);o=a}else{if(f[l+64>>2]|0)OQb(l,15096,112);a=NQb(l,112,1739)|0;BXa(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function BXa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=88880;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;f[a+56>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+72>>2]=0;if((a|0)!=521160?(f[220364]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=27;b[d+8>>0]=0;DTb(881456,d);ZSb(d)}f[a+12>>2]=0;f[a+80>>2]=527320;d=a+84|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function CXa(a){a=a|0;var c=0,d=0;f[a>>2]=88880;c=f[a+80>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=521160?(c=f[a+84>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+72>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+56>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function DXa(a){a=a|0;CXa(a);YDc(a);return}function EXa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function FXa(a,b){a=a|0;b=b|0;a=VDc(108)|0;BXa(a);if(!b)return a|0;TXa(b,a);return a|0}function GXa(a){a=a|0;var c=0,d=0,e=0,g=0;f[a+16>>2]=0;f[a+32>>2]=0;f[a+48>>2]=0;f[a+64>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0){e=f[a+80>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){g=f[a+84>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}}if(d&124|0){d=a+88|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function HXa(a){a=a|0;return 1}function IXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+88|0;k=a+92|0;l=a+96|0;m=a+100|0;n=a+16|0;o=a+20|0;q=a+24|0;r=a+32|0;t=a+36|0;v=a+40|0;w=a+84|0;x=e+4|0;y=a+48|0;z=a+52|0;A=a+56|0;B=a+64|0;C=a+68|0;D=a+72|0;E=a+104|0;F=a+4|0;G=a+80|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){H=b[a>>0]|0;I=H&255;if(H<<24>>24>0){f[c>>2]=a+1;K=I;L=6}else{M=I;L=5}}else{M=0;L=5}if((L|0)==5){L=0;I=WRb(c,M)|0;if((I+-1|0)>>>0<127){K=I;L=6}else N=I}b:do if((L|0)==6){L=0;do switch(K>>>3&536870911|0){case 1:{if((K&255|0)!=8){N=K;break b}f[i>>2]=f[i>>2]|4;I=f[c>>2]|0;if(I>>>0<(f[g>>2]|0)>>>0){a=b[I>>0]|0;H=a&255;if(a<<24>>24>-1){f[c>>2]=I+1;O=H}else{P=H;L=11}}else{P=0;L=11}if((L|0)==11){L=0;H=HRb(c,P)|0;I=J;if((I|0)>-1|(I|0)==-1&H>>>0>4294967295)O=H;else{Q=0;L=154;break a}}f[j>>2]=O;continue a;break}case 2:{if((K&255|0)!=16){N=K;break b}f[i>>2]=f[i>>2]|8;H=f[c>>2]|0;if(H>>>0<(f[g>>2]|0)>>>0){I=b[H>>0]|0;a=I&255;if(I<<24>>24>-1){f[c>>2]=H+1;R=a}else{S=a;L=17}}else{S=0;L=17}if((L|0)==17){L=0;a=HRb(c,S)|0;H=J;if((H|0)>-1|(H|0)==-1&a>>>0>4294967295)R=a;else{Q=0;L=154;break a}}f[k>>2]=R;continue a;break}case 3:{if((K&255|0)!=24){N=K;break b}f[i>>2]=f[i>>2]|16;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){H=b[a>>0]|0;I=H&255;if(H<<24>>24>-1){f[c>>2]=a+1;T=I}else{U=I;L=23}}else{U=0;L=23}if((L|0)==23){L=0;I=HRb(c,U)|0;a=J;if((a|0)>-1|(a|0)==-1&I>>>0>4294967295)T=I;else{Q=0;L=154;break a}}f[l>>2]=T;continue a;break}case 4:{if((K&255|0)!=32){N=K;break b}f[i>>2]=f[i>>2]|32;I=f[c>>2]|0;if(I>>>0<(f[g>>2]|0)>>>0){a=b[I>>0]|0;H=a&255;if(a<<24>>24>-1){f[c>>2]=I+1;V=H}else{W=H;L=29}}else{W=0;L=29}if((L|0)==29){L=0;H=HRb(c,W)|0;I=J;if((I|0)>-1|(I|0)==-1&H>>>0>4294967295)V=H;else{Q=0;L=154;break a}}f[m>>2]=V;continue a;break}case 5:{switch((K&255)<<24>>24){case 42:break;case 45:{if(fPa(1,42,c,n)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}H=f[c>>2]|0;if(H>>>0<(f[g>>2]|0)>>>0?(I=b[H>>0]|0,I<<24>>24>-1):0){f[c>>2]=H+1;X=I&255}else{I=VRb(c)|0;if((I|0)>-1)X=I;else{Q=0;L=154;break a}}Y=f[n>>2]|0;I=(X|0)/4|0;if((I<<2|0)!=(X|0)){Q=0;L=154;break a}H=ORb(c)|0;a=MRb(c)|0;if((((H|0)==-1|(a|0)<(H|0)?a:H)|0)>=(X|0)){H=Y+I|0;if((f[n>>2]|0)<(H|0)?(SHa(n,H),a=f[n>>2]|0,Z=H-a|0,(Z<<2|0)>0):0)XIc((f[q>>2]|0)+((a<<2)+4)|0,0,(((Z|-1073741824|0)==-1073741824?1073741823:1073741822)+Z<<2)+8|0)|0;f[n>>2]=H;H=f[q>>2]|0;if(QRb(c,((H|0)==0?0:H+4|0)+(Y<<2)|0,X)|0)continue a;else{L=43;break a}}if((X|0)>3)_=0;else continue a;while(1){H=f[c>>2]|0;if(((f[g>>2]|0)-H|0)>3){Z=H;a=h[Z>>0]|h[Z+1>>0]<<8|h[Z+2>>0]<<16|h[Z+3>>0]<<24;f[e>>2]=a;f[c>>2]=H+4;$=a}else{if(!(TRb(c,e)|0)){L=52;break a}$=f[e>>2]|0}a=f[n>>2]|0;if((a|0)==(f[o>>2]|0)){SHa(n,a+1|0);aa=f[n>>2]|0}else aa=a;a=f[q>>2]|0;f[n>>2]=aa+1;f[a+4+(aa<<2)>>2]=$;a=_+1|0;if((a|0)<(I|0))_=a;else continue a}break}case 6:{switch((K&255)<<24>>24){case 50:break;case 53:{if(fPa(1,50,c,r)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}I=f[c>>2]|0;if(I>>>0<(f[g>>2]|0)>>>0?(a=b[I>>0]|0,a<<24>>24>-1):0){f[c>>2]=I+1;ba=a&255}else{a=VRb(c)|0;if((a|0)>-1)ba=a;else{Q=0;L=154;break a}}ca=f[r>>2]|0;a=(ba|0)/4|0;if((a<<2|0)!=(ba|0)){Q=0;L=154;break a}I=ORb(c)|0;H=MRb(c)|0;if((((I|0)==-1|(H|0)<(I|0)?H:I)|0)>=(ba|0)){I=ca+a|0;if((f[r>>2]|0)<(I|0)?(SHa(r,I),H=f[r>>2]|0,Z=I-H|0,(Z<<2|0)>0):0)XIc((f[v>>2]|0)+((H<<2)+4)|0,0,(((Z|-1073741824|0)==-1073741824?1073741823:1073741822)+Z<<2)+8|0)|0;f[r>>2]=I;I=f[v>>2]|0;if(QRb(c,((I|0)==0?0:I+4|0)+(ca<<2)|0,ba)|0)continue a;else{L=66;break a}}if((ba|0)>3)da=0;else continue a;while(1){I=f[c>>2]|0;if(((f[g>>2]|0)-I|0)>3){Z=I;H=h[Z>>0]|h[Z+1>>0]<<8|h[Z+2>>0]<<16|h[Z+3>>0]<<24;f[e>>2]=H;f[c>>2]=I+4;ea=H}else{if(!(TRb(c,e)|0)){L=75;break a}ea=f[e>>2]|0}H=f[r>>2]|0;if((H|0)==(f[t>>2]|0)){SHa(r,H+1|0);fa=f[r>>2]|0}else fa=H;H=f[v>>2]|0;f[r>>2]=fa+1;f[H+4+(fa<<2)>>2]=ea;H=da+1|0;if((H|0)<(a|0))da=H;else continue a}break}case 7:{if((K&255|0)!=58){N=K;break b}f[i>>2]=f[i>>2]|2;a=f[w>>2]|0;if(!a){H=VDc(32)|0;SXa(H);f[w>>2]=H;ga=H}else ga=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(H=b[a>>0]|0,H<<24>>24>-1):0){f[c>>2]=a+1;ha=H&255}else{H=VRb(c)|0;if((H|0)>-1)ha=H;else{Q=0;L=154;break a}}GRb(e,c,ha);if((f[x>>2]|0)<0){L=86;break a}if(!(Mi[f[(f[ga>>2]|0)+44>>2]&1023](ga,c)|0)){L=86;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Q=0;L=154;break a}break}case 8:{switch((K&255)<<24>>24){case 66:break;case 65:{if(aTa(1,66,c,y)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}H=f[c>>2]|0;if(H>>>0<(f[g>>2]|0)>>>0?(a=b[H>>0]|0,a<<24>>24>-1):0){f[c>>2]=H+1;ia=a&255}else{a=VRb(c)|0;if((a|0)>-1)ia=a;else{Q=0;L=154;break a}}ja=f[y>>2]|0;a=(ia|0)/8|0;if((a<<3|0)!=(ia|0)){Q=0;L=154;break a}H=ORb(c)|0;I=MRb(c)|0;if((((H|0)==-1|(I|0)<(H|0)?I:H)|0)>=(ia|0)){H=ja+a|0;if((f[y>>2]|0)<(H|0)?(THa(y,H),I=f[y>>2]|0,Z=H-I|0,(Z<<3|0)>0):0)XIc((f[A>>2]|0)+((I<<3)+8)|0,0,(((Z|-536870912|0)==-536870912?536870911:536870910)+Z<<3)+16|0)|0;f[y>>2]=H;H=f[A>>2]|0;if(QRb(c,((H|0)==0?0:H+8|0)+(ja<<3)|0,ia)|0)continue a;else{L=100;break a}}if((ia|0)>7)ka=0;else continue a;while(1){H=f[c>>2]|0;if(((f[g>>2]|0)-H|0)>7){Z=H;I=Z;la=h[I>>0]|h[I+1>>0]<<8|h[I+2>>0]<<16|h[I+3>>0]<<24;I=Z+4|0;Z=h[I>>0]|h[I+1>>0]<<8|h[I+2>>0]<<16|h[I+3>>0]<<24;I=e;f[I>>2]=la;f[I+4>>2]=Z;f[c>>2]=H+8;f[s>>2]=la;f[s+4>>2]=Z;ma=+p[s>>3]}else{if(!(URb(c,e)|0)){L=109;break a}ma=+p[e>>3]}Z=f[y>>2]|0;if((Z|0)==(f[z>>2]|0)){THa(y,Z+1|0);na=f[y>>2]|0}else na=Z;Z=f[A>>2]|0;f[y>>2]=na+1;p[Z+8+(na<<3)>>3]=ma;Z=ka+1|0;if((Z|0)<(a|0))ka=Z;else continue a}break}case 9:{switch((K&255)<<24>>24){case 74:break;case 73:{if(aTa(1,74,c,B)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(Z=b[a>>0]|0,Z<<24>>24>-1):0){f[c>>2]=a+1;oa=Z&255}else{Z=VRb(c)|0;if((Z|0)>-1)oa=Z;else{Q=0;L=154;break a}}pa=f[B>>2]|0;Z=(oa|0)/8|0;if((Z<<3|0)!=(oa|0)){Q=0;L=154;break a}a=ORb(c)|0;la=MRb(c)|0;if((((a|0)==-1|(la|0)<(a|0)?la:a)|0)>=(oa|0)){a=pa+Z|0;if((f[B>>2]|0)<(a|0)?(THa(B,a),la=f[B>>2]|0,H=a-la|0,(H<<3|0)>0):0)XIc((f[D>>2]|0)+((la<<3)+8)|0,0,(((H|-536870912|0)==-536870912?536870911:536870910)+H<<3)+16|0)|0;f[B>>2]=a;a=f[D>>2]|0;if(QRb(c,((a|0)==0?0:a+8|0)+(pa<<3)|0,oa)|0)continue a;else{L=123;break a}}if((oa|0)>7)qa=0;else continue a;while(1){a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>7){H=a;la=H;I=h[la>>0]|h[la+1>>0]<<8|h[la+2>>0]<<16|h[la+3>>0]<<24;la=H+4|0;H=h[la>>0]|h[la+1>>0]<<8|h[la+2>>0]<<16|h[la+3>>0]<<24;la=e;f[la>>2]=I;f[la+4>>2]=H;f[c>>2]=a+8;f[s>>2]=I;f[s+4>>2]=H;ra=+p[s>>3]}else{if(!(URb(c,e)|0)){L=132;break a}ra=+p[e>>3]}H=f[B>>2]|0;if((H|0)==(f[C>>2]|0)){THa(B,H+1|0);sa=f[B>>2]|0}else sa=H;H=f[D>>2]|0;f[B>>2]=sa+1;p[H+8+(sa<<3)>>3]=ra;H=qa+1|0;if((H|0)<(Z|0))qa=H;else continue a}break}case 10:{if((K&255|0)!=80){N=K;break b}Z=f[c>>2]|0;if(Z>>>0<(f[g>>2]|0)>>>0){H=b[Z>>0]|0;I=H&255;if(H<<24>>24>-1){f[c>>2]=Z+1;ta=I}else{ua=I;L=138}}else{ua=0;L=138}if((L|0)==138){L=0;I=HRb(c,ua)|0;Z=J;if((Z|0)>-1|(Z|0)==-1&I>>>0>4294967295)ta=I;else{Q=0;L=154;break a}}if(ta>>>0<5){f[i>>2]=f[i>>2]|64;f[E>>2]=ta;continue a}I=f[F>>2]|0;if(!(I&1))va=mNa(F)|0;else va=I&-2;rjc(va,10,ta,((ta|0)<0)<<31>>31);continue a;break}case 12:{if((K&255|0)!=98){N=K;break b}f[i>>2]=f[i>>2]|1;I=f[G>>2]|0;if((I|0)==527320){GLa(G,527320);wa=f[G>>2]|0}else wa=I;if(fUb(c,wa)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}while(0)}while(0);if(!N){Q=1;L=154;break}I=f[F>>2]|0;if(!(I&1))xa=mNa(F)|0;else xa=I&-2;if(!(Djc(c,N,xa)|0)){Q=0;L=154;break}}switch(L|0){case 43:{if((f[n>>2]|0)<=0){Q=0;u=d;return Q|0}f[n>>2]=Y;Q=0;u=d;return Q|0}case 52:{Q=0;u=d;return Q|0}case 66:{if((f[r>>2]|0)<=0){Q=0;u=d;return Q|0}f[r>>2]=ca;Q=0;u=d;return Q|0}case 75:{Q=0;u=d;return Q|0}case 86:{Q=0;u=d;return Q|0}case 100:{if((f[y>>2]|0)<=0){Q=0;u=d;return Q|0}f[y>>2]=ja;Q=0;u=d;return Q|0}case 109:{Q=0;u=d;return Q|0}case 123:{if((f[B>>2]|0)<=0){Q=0;u=d;return Q|0}f[B>>2]=pa;Q=0;u=d;return Q|0}case 132:{Q=0;u=d;return Q|0}case 154:{u=d;return Q|0}}return 0}function JXa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+16>>2]<<2;if(!c)e=d;else{if((c|0)<0)g=10;else g=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;e=d+1+g|0}f[a+28>>2]=c;g=e+c|0;c=f[a+32>>2]<<2;if(!c)h=g;else{if((c|0)<0)i=10;else i=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;h=g+1+i|0}f[a+44>>2]=c;i=h+c|0;c=f[a+48>>2]<<3;if(!c)j=i;else{if((c|0)<0)k=11;else k=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=k+i|0}f[a+60>>2]=c;i=j+c|0;c=f[a+64>>2]<<3;if(!c)l=i;else{if((c|0)<0)m=11;else m=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+i|0}f[a+76>>2]=c;i=l+c|0;c=a+8|0;l=f[c>>2]|0;if(!(l&127)){n=i;o=a+12|0;f[o>>2]=n;return n|0}if(!(l&1))p=i;else{m=f[a+80>>2]|0;j=b[m+11>>0]|0;k=j<<24>>24<0?f[m+4>>2]|0:j&255;p=i+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&2)){q=p;r=l}else{l=f[a+84>>2]|0;k=_i[f[(f[l>>2]|0)+48>>2]&1023](l)|0;l=p+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;q=l;r=f[c>>2]|0}if(!(r&4))s=q;else{c=f[a+88>>2]|0;if((c|0)<0)t=11;else t=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;s=t+q|0}if(!(r&8))u=s;else{q=f[a+92>>2]|0;if((q|0)<0)v=11;else v=((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;u=v+s|0}if(!(r&16))w=u;else{s=f[a+96>>2]|0;if((s|0)<0)x=11;else x=((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;w=x+u|0}if(!(r&32))y=w;else{u=f[a+100>>2]|0;if((u|0)<0)z=11;else z=((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;y=z+w|0}if(!(r&64)){n=y;o=a+12|0;f[o>>2]=n;return n|0}r=f[a+104>>2]|0;if((r|0)<0)A=11;else A=((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=A+y|0;o=a+12|0;f[o>>2]=n;return n|0}function KXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=f[a+8>>2]|0;if(d&4|0)MTb(1,f[a+88>>2]|0,c);if(d&8|0)MTb(2,f[a+92>>2]|0,c);if(d&16|0)MTb(3,f[a+96>>2]|0,c);if(d&32|0)MTb(4,f[a+100>>2]|0,c);e=a+16|0;if((f[e>>2]|0)>0){g=c+8|0;if((f[g>>2]|0)>4){h=c+4|0;b[f[h>>2]>>0]=42;f[h>>2]=(f[h>>2]|0)+1;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;i=h}else{bSb(c,42);i=f[g>>2]|0}h=f[a+28>>2]|0;if((i|0)>4){i=c+4|0;j=f[i>>2]|0;if(h>>>0>127){k=h;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=h}b[o>>0]=p;p=o+1-j|0;f[i>>2]=(f[i>>2]|0)+p;f[g>>2]=(f[g>>2]|0)-p}else bSb(c,h);h=f[a+24>>2]|0;JTb((h|0)==0?0:h+4|0,f[e>>2]|0,c)}e=a+32|0;if((f[e>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){p=c+4|0;b[f[p>>2]>>0]=50;f[p>>2]=(f[p>>2]|0)+1;p=(f[h>>2]|0)+-1|0;f[h>>2]=p;q=p}else{bSb(c,50);q=f[h>>2]|0}p=f[a+44>>2]|0;if((q|0)>4){q=c+4|0;g=f[q>>2]|0;if(p>>>0>127){i=p;j=g;while(1){b[j>>0]=i|128;o=i>>>7;l=j+1|0;if(i>>>0>16383){i=o;j=l}else{r=l;s=o;break}}}else{r=g;s=p}b[r>>0]=s;s=r+1-g|0;f[q>>2]=(f[q>>2]|0)+s;f[h>>2]=(f[h>>2]|0)-s}else bSb(c,p);p=f[a+40>>2]|0;JTb((p|0)==0?0:p+4|0,f[e>>2]|0,c)}if(d&2|0)eUb(7,f[a+84>>2]|0,c);e=a+48|0;if((f[e>>2]|0)>0){p=c+8|0;if((f[p>>2]|0)>4){s=c+4|0;b[f[s>>2]>>0]=66;f[s>>2]=(f[s>>2]|0)+1;s=(f[p>>2]|0)+-1|0;f[p>>2]=s;t=s}else{bSb(c,66);t=f[p>>2]|0}s=f[a+60>>2]|0;if((t|0)>4){t=c+4|0;h=f[t>>2]|0;if(s>>>0>127){q=s;g=h;while(1){b[g>>0]=q|128;r=q>>>7;j=g+1|0;if(q>>>0>16383){q=r;g=j}else{u=j;v=r;break}}}else{u=h;v=s}b[u>>0]=v;v=u+1-h|0;f[t>>2]=(f[t>>2]|0)+v;f[p>>2]=(f[p>>2]|0)-v}else bSb(c,s);s=f[a+56>>2]|0;KTb((s|0)==0?0:s+8|0,f[e>>2]|0,c)}e=a+64|0;if((f[e>>2]|0)>0){s=c+8|0;if((f[s>>2]|0)>4){v=c+4|0;b[f[v>>2]>>0]=74;f[v>>2]=(f[v>>2]|0)+1;v=(f[s>>2]|0)+-1|0;f[s>>2]=v;w=v}else{bSb(c,74);w=f[s>>2]|0}v=f[a+76>>2]|0;if((w|0)>4){w=c+4|0;p=f[w>>2]|0;if(v>>>0>127){t=v;h=p;while(1){b[h>>0]=t|128;u=t>>>7;g=h+1|0;if(t>>>0>16383){t=u;h=g}else{x=g;y=u;break}}}else{x=p;y=v}b[x>>0]=y;y=x+1-p|0;f[w>>2]=(f[w>>2]|0)+y;f[s>>2]=(f[s>>2]|0)-y}else bSb(c,v);v=f[a+72>>2]|0;KTb((v|0)==0?0:v+8|0,f[e>>2]|0,c)}if(d&64|0)ZTb(10,f[a+104>>2]|0,c);if(d&1|0)bUb(12,f[a+80>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function LXa(a){a=a|0;return f[a+12>>2]|0}function MXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+88>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=aJc(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&8))r=g;else{p=f[a+92>>2]|0;b[g>>0]=16;q=g+1|0;g=p&255;if(p>>>0>127){d=q;i=g;m=p;k=((p|0)<0)<<31>>31;while(1){b[d>>0]=i|-128;p=m;m=aJc(m|0,k|0,7)|0;j=d+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=j;t=l;break}else{d=j;i=l;k=J}}}else{s=q;t=g}b[s>>0]=t;r=s+1|0}if(!(e&16))u=r;else{s=f[a+96>>2]|0;b[r>>0]=24;t=r+1|0;r=s&255;if(s>>>0>127){g=t;q=r;k=s;i=((s|0)<0)<<31>>31;while(1){b[g>>0]=q|-128;s=k;k=aJc(k|0,i|0,7)|0;d=g+1|0;m=k&255;if(!(i>>>0>0|(i|0)==0&s>>>0>16383)){v=d;w=m;break}else{g=d;q=m;i=J}}}else{v=t;w=r}b[v>>0]=w;u=v+1|0}if(!(e&32))x=u;else{v=f[a+100>>2]|0;b[u>>0]=32;w=u+1|0;u=v&255;if(v>>>0>127){r=w;t=u;i=v;q=((v|0)<0)<<31>>31;while(1){b[r>>0]=t|-128;v=i;i=aJc(i|0,q|0,7)|0;g=r+1|0;k=i&255;if(!(q>>>0>0|(q|0)==0&v>>>0>16383)){y=g;z=k;break}else{r=g;t=k;q=J}}}else{y=w;z=u}b[y>>0]=z;x=y+1|0}y=a+16|0;if((f[y>>2]|0)>0){b[x>>0]=42;z=x+1|0;u=f[a+28>>2]|0;if(u>>>0>127){w=u;q=z;while(1){b[q>>0]=w|128;t=w>>>7;r=q+1|0;if(w>>>0>16383){w=t;q=r}else{A=r;B=t;break}}}else{A=z;B=u}b[A>>0]=B;B=A+1|0;A=f[y>>2]<<2;dJc(B|0,(f[a+24>>2]|0)+4|0,A|0)|0;C=B+A|0}else C=x;x=a+32|0;if((f[x>>2]|0)>0){b[C>>0]=50;A=C+1|0;B=f[a+44>>2]|0;if(B>>>0>127){y=B;u=A;while(1){b[u>>0]=y|128;z=y>>>7;q=u+1|0;if(y>>>0>16383){y=z;u=q}else{D=q;E=z;break}}}else{D=A;E=B}b[D>>0]=E;E=D+1|0;D=f[x>>2]<<2;dJc(E|0,(f[a+40>>2]|0)+4|0,D|0)|0;F=E+D|0}else F=C;if(!(e&2))G=F;else{C=f[a+84>>2]|0;b[F>>0]=58;D=F+1|0;F=_i[f[(f[C>>2]|0)+60>>2]&1023](C)|0;if(F>>>0>127){E=F;x=D;while(1){b[x>>0]=E|128;B=E>>>7;A=x+1|0;if(E>>>0>16383){E=B;x=A}else{H=A;I=B;break}}}else{H=D;I=F}b[H>>0]=I;G=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,H+1|0)|0}H=a+48|0;if((f[H>>2]|0)>0){b[G>>0]=66;c=G+1|0;C=f[a+60>>2]|0;if(C>>>0>127){I=C;F=c;while(1){b[F>>0]=I|128;D=I>>>7;x=F+1|0;if(I>>>0>16383){I=D;F=x}else{K=x;L=D;break}}}else{K=c;L=C}b[K>>0]=L;L=K+1|0;K=f[H>>2]<<3;dJc(L|0,(f[a+56>>2]|0)+8|0,K|0)|0;M=L+K|0}else M=G;G=a+64|0;if((f[G>>2]|0)>0){b[M>>0]=74;K=M+1|0;L=f[a+76>>2]|0;if(L>>>0>127){H=L;C=K;while(1){b[C>>0]=H|128;c=H>>>7;F=C+1|0;if(H>>>0>16383){H=c;C=F}else{N=F;O=c;break}}}else{N=K;O=L}b[N>>0]=O;O=N+1|0;N=f[G>>2]<<3;dJc(O|0,(f[a+72>>2]|0)+8|0,N|0)|0;P=O+N|0}else P=M;if(!(e&64))Q=P;else{M=f[a+104>>2]|0;b[P>>0]=80;N=P+1|0;P=M&255;if(M>>>0>127){O=N;G=P;L=M;K=((M|0)<0)<<31>>31;while(1){b[O>>0]=G|-128;M=L;L=aJc(L|0,K|0,7)|0;C=O+1|0;H=L&255;if(!(K>>>0>0|(K|0)==0&M>>>0>16383)){R=C;S=H;break}else{O=C;G=H;K=J}}}else{R=N;S=P}b[R>>0]=S;Q=R+1|0}if(!(e&1))T=Q;else{e=f[a+80>>2]|0;b[Q>>0]=98;T=dSb(e,Q+1|0)|0}Q=f[a+4>>2]|0;if(!(Q&1)){U=T;return U|0}U=Hjc(Q&-2,T)|0;return U|0}function NXa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function OXa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15096,0)|0;if(!c){Ehc(b,a);return}else{RXa(a,c);return}}function PXa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function QXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525088;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function RXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){SHa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+32|0;d=b+32|0;e=f[d>>2]|0;if(e|0){SHa(g,(f[g>>2]|0)+e|0);dJc((f[a+40>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+48|0;g=b+48|0;e=f[g>>2]|0;if(e|0){THa(d,(f[d>>2]|0)+e|0);dJc((f[a+56>>2]|0)+8+(f[d>>2]<<3)|0,(f[b+56>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+64|0;d=b+64|0;e=f[d>>2]|0;if(e|0){THa(g,(f[g>>2]|0)+e|0);dJc((f[a+72>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+72>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=f[b+8>>2]|0;if(!(d&127))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+80|0,e=f[b+80>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(d&2|0){e=a+8|0;f[e>>2]=f[e>>2]|2;e=a+84|0;c=f[e>>2]|0;if(!c){g=VDc(32)|0;SXa(g);f[e>>2]=g;h=g}else h=c;c=f[b+84>>2]|0;g=c|0?c:521128;c=h+4|0;e=f[g+4>>2]|0;if(e&1|0){i=f[c>>2]|0;if(!(i&1))j=mNa(c)|0;else j=i&-2;ojc(j,e&-2)}e=h+16|0;j=g+16|0;i=f[j>>2]|0;if(i|0){UHa(e,(f[e>>2]|0)+i|0);dJc((f[h+24>>2]|0)+8+(f[e>>2]<<3)|0,(f[g+24>>2]|0)+8|0,f[j>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[j>>2]|0)}}if(d&4|0)f[a+88>>2]=f[b+88>>2];if(d&8|0)f[a+92>>2]=f[b+92>>2];if(d&16|0)f[a+96>>2]=f[b+96>>2];if(d&32|0)f[a+100>>2]=f[b+100>>2];if(d&64|0)f[a+104>>2]=f[b+104>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function SXa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=86772;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=521128?(f[220363]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=26;b[d+8>>0]=0;DTb(881452,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function TXa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function UXa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=88664;e=(a|0)==524600;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220428]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=91;b[d+8>>0]=0;DTb(881712,d);ZSb(d)}f[a+56>>2]=527320;f[a+60>>2]=527320;f[a+64>>2]=527320;f[a+68>>2]=527320;f[a+72>>2]=525064;g=a+76|0;h=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a+140>>2]=1;b[a+144>>0]=1;f[a+148>>2]=1;f[a+152>>2]=1;n[a+156>>2]=.5;f[a+160>>2]=5;n[a+164>>2]=1.0;n[a+168>>2]=.75;n[a+172>>2]=1.0;n[a+176>>2]=1.0;n[a+180>>2]=.5;n[a+184>>2]=.5;n[a+188>>2]=.25;f[a+192>>2]=0;u=c;return}function VXa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function WXa(a){a=a|0;var c=0;c=f[a+56>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+60>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+64>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+68>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+72>>2]|0;if(!((c|0)==525064|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==524600)return;c=f[a+76>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+80>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+84>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function XXa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=88988;j6a(a);c=f[a+156>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+144|0;d=f[c>>2]|0;if(d|0?(f[a+132>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=f[a+128>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+116|0;i=f[c>>2]|0;if(i|0?(f[a+104>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+100|0;j=f[c>>2]|0;if(j|0?(f[a+88>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=f[a+84>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+72>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+60|0;k=f[c>>2]|0;if(k|0?(f[a+48>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;YDc(l)}f[c>>2]=0;c=a+44|0;l=f[c>>2]|0;if(l|0?(f[a+32>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;YDc(m)}f[c>>2]=0;c=a+28|0;m=f[c>>2]|0;if(m|0?(f[a+16>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0){if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);YDc(j)}k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;YDc(n)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}n=a&-2;a=n;if((n|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(n);f[c>>2]=0;return}function YXa(a){a=a|0;XXa(a);YDc(a);return}function ZXa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function _Xa(a,b){a=a|0;b=b|0;a=VDc(296)|0;h6a(a);if(!b)return a|0;i6a(b,a);return a|0}function $Xa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}f[a+64>>2]=0;f[a+76>>2]=0;c=a+92|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+100>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+108|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+116>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}f[a+120>>2]=0;c=a+136|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+144>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}f[a+148>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){do if(d&1|0){e=f[a+160>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){g=f[a+164>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&4|0){g=f[a+168>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&8|0){g=f[a+172>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&16|0){g=f[a+176>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&32|0){g=f[a+180>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&64|0){g=f[a+184>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&128|0){g=f[a+188>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}}if(d&65280|0){if(d&256|0){g=f[a+192>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&512|0){g=f[a+196>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&1024|0){g=f[a+200>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&2048|0){g=f[a+204>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&4096|0){g=f[a+208>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&8192|0){g=f[a+212>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&16384|0){g=f[a+216>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&32768|0){g=f[a+220>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}}if(d&16711680|0){if(d&65536|0){g=f[a+224>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&131072|0){g=f[a+228>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&262144|0){g=f[a+232>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&524288|0){g=f[a+236>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&1048576|0){g=f[a+240>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&2097152|0){g=f[a+244>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&4194304|0){g=f[a+248>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&8388608|0){g=f[a+252>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}}if(d>>>0>16777215){if(d&16777216|0){g=f[a+256>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&33554432|0){g=f[a+260>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&67108864|0){g=f[a+264>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&134217728|0){g=f[a+268>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&268435456|0){g=f[a+272>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&536870912|0){g=f[a+276>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&1073741824|0){g=f[a+280>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if((d|0)<0){d=f[a+284>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[a+288>>2]=0;d=c;f[d>>2]=0;f[d+4>>2]=0;d=f[a+4>>2]|0;if(!(d&1))return;a=d&-2;if(!(f[a>>2]|0))return;ljc(a);return}function aYa(a){a=a|0;return 1}function bYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+164|0;k=e+4|0;l=a+16|0;m=a+32|0;n=a+160|0;o=a+12|0;p=a+288|0;q=a+4|0;r=a+48|0;s=e+4|0;t=a+64|0;v=a+68|0;w=a+72|0;x=a+76|0;y=a+80|0;z=a+84|0;A=a+168|0;B=e+4|0;C=a+172|0;D=e+4|0;E=a+176|0;F=e+4|0;G=a+180|0;H=e+4|0;I=a+184|0;K=e+4|0;L=a+188|0;M=e+4|0;N=a+192|0;O=e+4|0;P=a+196|0;Q=e+4|0;R=a+200|0;S=e+4|0;T=a+204|0;U=e+4|0;V=a+208|0;W=e+4|0;X=a+212|0;Y=e+4|0;Z=a+216|0;_=e+4|0;$=a+220|0;aa=e+4|0;ba=a+224|0;ca=e+4|0;da=a+228|0;ea=e+4|0;fa=a+232|0;ga=e+4|0;ha=a+236|0;ia=e+4|0;ja=a+240|0;ka=e+4|0;la=a+244|0;ma=e+4|0;na=a+248|0;oa=e+4|0;pa=a+252|0;qa=e+4|0;ra=a+88|0;sa=e+4|0;ta=a+104|0;ua=e+4|0;va=a+256|0;wa=e+4|0;xa=a+120|0;ya=a+124|0;za=a+128|0;Aa=a+260|0;Ba=e+4|0;Ca=a+264|0;Da=e+4|0;Ea=a+268|0;Fa=e+4|0;Ga=a+272|0;Ha=e+4|0;Ia=a+276|0;Ja=e+4|0;Ka=a+280|0;La=e+4|0;Ma=a+284|0;Na=e+4|0;Oa=a+132|0;Pa=a+148|0;Qa=a+152|0;Ra=a+156|0;a:while(1){a=f[c>>2]|0;Sa=f[g>>2]|0;do if(a>>>0<Sa>>>0){Ta=b[a>>0]|0;Ua=Ta&255;Va=a+1|0;if(Ta<<24>>24>0){Wa=Va;Xa=Ua}else{if(Va>>>0>=Sa>>>0){Ya=Ua;Za=7;break}Ta=h[Va>>0]|0;if(((Ta^128)&Ua)>>>0<=127){Ya=Ua;Za=7;break}Wa=a+2|0;Xa=Ua+-128+(Ta<<7)|0}f[c>>2]=Wa;_a=Xa;Za=9}else{Ya=0;Za=7}while(0);if((Za|0)==7){Za=0;a=WRb(c,Ya)|0;if((a+-1|0)>>>0<16383){_a=a;Za=9}else $a=a}b:do if((Za|0)==9){Za=0;do switch(_a>>>3&536870911|0){case 1:{if((_a&255|0)!=10){$a=_a;break b}f[i>>2]=f[i>>2]|2;a=f[j>>2]|0;if(!a){Sa=VDc(196)|0;UXa(Sa);f[j>>2]=Sa;ab=Sa}else ab=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(Sa=b[a>>0]|0,Sa<<24>>24>-1):0){f[c>>2]=a+1;bb=Sa&255}else{Sa=VRb(c)|0;if((Sa|0)>-1)bb=Sa;else{cb=0;Za=473;break a}}GRb(e,c,bb);if((f[k>>2]|0)<0){Za=19;break a}if(!(Mi[f[(f[ab>>2]|0)+44>>2]&1023](ab,c)|0)){Za=19;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 2:{if((_a&255|0)!=18){$a=_a;break b}if(fUb(c,JLa(l)|0)|0)continue a;else{cb=0;Za=473;break a}break}case 3:{if((_a&255|0)!=26){$a=_a;break b}if(fUb(c,JLa(m)|0)|0)continue a;else{cb=0;Za=473;break a}break}case 4:{if((_a&255|0)!=34){$a=_a;break b}f[i>>2]=f[i>>2]|1;Sa=f[n>>2]|0;if((Sa|0)==527320){GLa(n,527320);db=f[n>>2]|0}else db=Sa;if(fUb(c,db)|0)continue a;else{cb=0;Za=473;break a}break}case 5:{if((_a&255|0)!=40){$a=_a;break b}Sa=f[c>>2]|0;if(Sa>>>0<(f[g>>2]|0)>>>0){a=b[Sa>>0]|0;Ta=a&255;if(a<<24>>24>-1){f[c>>2]=Sa+1;eb=Ta}else{fb=Ta;Za=33}}else{fb=0;Za=33}if((Za|0)==33){Za=0;Ta=HRb(c,fb)|0;Sa=J;if((Sa|0)>-1|(Sa|0)==-1&Ta>>>0>4294967295)eb=Ta;else{cb=0;Za=473;break a}}if(eb>>>0<40){f[o>>2]=f[o>>2]|1;f[p>>2]=eb;continue a}Ta=f[q>>2]|0;if(!(Ta&1))gb=mNa(q)|0;else gb=Ta&-2;rjc(gb,5,eb,((eb|0)<0)<<31>>31);continue a;break}case 6:{if((_a&255|0)!=50){$a=_a;break b}Ta=AXa(r)|0;Sa=f[c>>2]|0;if(Sa>>>0<(f[g>>2]|0)>>>0?(a=b[Sa>>0]|0,a<<24>>24>-1):0){f[c>>2]=Sa+1;hb=a&255}else{a=VRb(c)|0;if((a|0)>-1)hb=a;else{cb=0;Za=473;break a}}GRb(e,c,hb);if((f[s>>2]|0)<0){Za=47;break a}if(!(Mi[f[(f[Ta>>2]|0)+44>>2]&1023](Ta,c)|0)){Za=47;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 7:{switch((_a&255)<<24>>24){case 61:break;case 58:{if(BVa(c,t)|0)continue a;else{cb=0;Za=473;break a}break}default:{$a=_a;break b}}Ta=f[c>>2]|0;if(((f[g>>2]|0)-Ta|0)>3){a=Ta;Sa=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=Sa;f[c>>2]=Ta+4;ib=Sa}else{if(!(TRb(c,e)|0)){Za=64;break a}ib=f[e>>2]|0}Sa=f[t>>2]|0;if((Sa|0)==(f[v>>2]|0)){SHa(t,Sa+1|0);jb=f[t>>2]|0}else jb=Sa;Sa=f[w>>2]|0;Ta=jb+1|0;f[t>>2]=Ta;f[Sa+4+(jb<<2)>>2]=ib;a=f[c>>2]|0;Ua=(f[g>>2]|0)-a|0;if((Ua|0)<=0)continue a;Va=a;a=(f[v>>2]|0)-Ta|0;kb=(Ua>>>0)/5|0;lb=(kb|0)<(a|0)?kb:a;if((lb|0)>0){mb=0;nb=Va;ob=Ta}else continue a;while(1){if((b[nb>>0]|0)!=61){pb=mb;break}Ta=nb+1|0;a=h[Ta>>0]|h[Ta+1>>0]<<8|h[Ta+2>>0]<<16|h[Ta+3>>0]<<24;Ta=ob;ob=ob+1|0;f[t>>2]=ob;f[Sa+4+(Ta<<2)>>2]=a;a=mb+1|0;if((a|0)>=(lb|0)){pb=a;break}else{mb=a;nb=nb+5|0}}lb=pb*5|0;if((pb|0)<=0)continue a;if((Ua|0)<(lb|0)){PRb(c,lb,Ua)|0;continue a}else{f[c>>2]=Va+lb;continue a}break}case 8:{switch((_a&255)<<24>>24){case 69:break;case 66:{if(BVa(c,x)|0)continue a;else{cb=0;Za=473;break a}break}default:{$a=_a;break b}}lb=f[c>>2]|0;if(((f[g>>2]|0)-lb|0)>3){Sa=lb;a=h[Sa>>0]|h[Sa+1>>0]<<8|h[Sa+2>>0]<<16|h[Sa+3>>0]<<24;f[e>>2]=a;f[c>>2]=lb+4;qb=a}else{if(!(TRb(c,e)|0)){Za=81;break a}qb=f[e>>2]|0}a=f[x>>2]|0;if((a|0)==(f[y>>2]|0)){SHa(x,a+1|0);rb=f[x>>2]|0}else rb=a;a=f[z>>2]|0;lb=rb+1|0;f[x>>2]=lb;f[a+4+(rb<<2)>>2]=qb;Sa=f[c>>2]|0;Ta=(f[g>>2]|0)-Sa|0;if((Ta|0)<=0)continue a;kb=Sa;Sa=(f[y>>2]|0)-lb|0;sb=(Ta>>>0)/5|0;tb=(sb|0)<(Sa|0)?sb:Sa;if((tb|0)>0){ub=0;vb=kb;wb=lb}else continue a;while(1){if((b[vb>>0]|0)!=69){xb=ub;break}lb=vb+1|0;Sa=h[lb>>0]|h[lb+1>>0]<<8|h[lb+2>>0]<<16|h[lb+3>>0]<<24;lb=wb;wb=wb+1|0;f[x>>2]=wb;f[a+4+(lb<<2)>>2]=Sa;Sa=ub+1|0;if((Sa|0)>=(tb|0)){xb=Sa;break}else{ub=Sa;vb=vb+5|0}}tb=xb*5|0;if((xb|0)<=0)continue a;if((Ta|0)<(tb|0)){PRb(c,tb,Ta)|0;continue a}else{f[c>>2]=kb+tb;continue a}break}case 9:{if((_a&255|0)!=74){$a=_a;break b}f[i>>2]=f[i>>2]|4;tb=f[A>>2]|0;if(!tb){a=VDc(24)|0;mYa(a);f[A>>2]=a;yb=a}else yb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;zb=a&255}else{a=VRb(c)|0;if((a|0)>-1)zb=a;else{cb=0;Za=473;break a}}GRb(e,c,zb);if((f[B>>2]|0)<0){Za=92;break a}if(!(Mi[f[(f[yb>>2]|0)+44>>2]&1023](yb,c)|0)){Za=92;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 10:{if((_a&255|0)!=82){$a=_a;break b}f[i>>2]=f[i>>2]|8;a=f[C>>2]|0;if(!a){tb=VDc(120)|0;nYa(tb);f[C>>2]=tb;Ab=tb}else Ab=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Bb=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)Bb=tb;else{cb=0;Za=473;break a}}GRb(e,c,Bb);if((f[D>>2]|0)<0){Za=103;break a}if(!(Mi[f[(f[Ab>>2]|0)+44>>2]&1023](Ab,c)|0)){Za=103;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 11:{if((_a&255|0)!=90){$a=_a;break b}f[i>>2]=f[i>>2]|16;tb=f[E>>2]|0;if(!tb){a=VDc(52)|0;pYa(a);f[E>>2]=a;Cb=a}else Cb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Db=a&255}else{a=VRb(c)|0;if((a|0)>-1)Db=a;else{cb=0;Za=473;break a}}GRb(e,c,Db);if((f[F>>2]|0)<0){Za=114;break a}if(!(Mi[f[(f[Cb>>2]|0)+44>>2]&1023](Cb,c)|0)){Za=114;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 12:{if((_a&255|0)!=98){$a=_a;break b}f[i>>2]=f[i>>2]|32;a=f[G>>2]|0;if(!a){tb=VDc(24)|0;rYa(tb);f[G>>2]=tb;Eb=tb}else Eb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Fb=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)Fb=tb;else{cb=0;Za=473;break a}}GRb(e,c,Fb);if((f[H>>2]|0)<0){Za=125;break a}if(!(Mi[f[(f[Eb>>2]|0)+44>>2]&1023](Eb,c)|0)){Za=125;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 13:{if((_a&255|0)!=106){$a=_a;break b}f[i>>2]=f[i>>2]|64;tb=f[I>>2]|0;if(!tb){a=VDc(28)|0;sYa(a);f[I>>2]=a;Gb=a}else Gb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Hb=a&255}else{a=VRb(c)|0;if((a|0)>-1)Hb=a;else{cb=0;Za=473;break a}}GRb(e,c,Hb);if((f[K>>2]|0)<0){Za=136;break a}if(!(Mi[f[(f[Gb>>2]|0)+44>>2]&1023](Gb,c)|0)){Za=136;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 14:{if((_a&255|0)!=114){$a=_a;break b}f[i>>2]=f[i>>2]|128;a=f[L>>2]|0;if(!a){tb=VDc(20)|0;jXa(tb);f[L>>2]=tb;Ib=tb}else Ib=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Jb=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)Jb=tb;else{cb=0;Za=473;break a}}GRb(e,c,Jb);if((f[M>>2]|0)<0){Za=147;break a}if(!(Mi[f[(f[Ib>>2]|0)+44>>2]&1023](Ib,c)|0)){Za=147;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 15:{if((_a&255|0)!=122){$a=_a;break b}f[i>>2]=f[i>>2]|256;tb=f[N>>2]|0;if(!tb){a=VDc(60)|0;uYa(a);f[N>>2]=a;Kb=a}else Kb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Lb=a&255}else{a=VRb(c)|0;if((a|0)>-1)Lb=a;else{cb=0;Za=473;break a}}GRb(e,c,Lb);if((f[O>>2]|0)<0){Za=158;break a}if(!(Mi[f[(f[Kb>>2]|0)+44>>2]&1023](Kb,c)|0)){Za=158;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 16:{if((_a&255|0)!=130){$a=_a;break b}f[i>>2]=f[i>>2]|512;a=f[P>>2]|0;if(!a){tb=VDc(20)|0;wYa(tb);f[P>>2]=tb;Mb=tb}else Mb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Nb=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)Nb=tb;else{cb=0;Za=473;break a}}GRb(e,c,Nb);if((f[Q>>2]|0)<0){Za=169;break a}if(!(Mi[f[(f[Mb>>2]|0)+44>>2]&1023](Mb,c)|0)){Za=169;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 17:{if((_a&255|0)!=138){$a=_a;break b}f[i>>2]=f[i>>2]|1024;tb=f[R>>2]|0;if(!tb){a=VDc(36)|0;xYa(a);f[R>>2]=a;Ob=a}else Ob=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Pb=a&255}else{a=VRb(c)|0;if((a|0)>-1)Pb=a;else{cb=0;Za=473;break a}}GRb(e,c,Pb);if((f[S>>2]|0)<0){Za=180;break a}if(!(Mi[f[(f[Ob>>2]|0)+44>>2]&1023](Ob,c)|0)){Za=180;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 18:{if((_a&255|0)!=146){$a=_a;break b}f[i>>2]=f[i>>2]|2048;a=f[T>>2]|0;if(!a){tb=VDc(40)|0;zYa(tb);f[T>>2]=tb;Qb=tb}else Qb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Rb=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)Rb=tb;else{cb=0;Za=473;break a}}GRb(e,c,Rb);if((f[U>>2]|0)<0){Za=191;break a}if(!(Mi[f[(f[Qb>>2]|0)+44>>2]&1023](Qb,c)|0)){Za=191;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 19:{if((_a&255|0)!=154){$a=_a;break b}f[i>>2]=f[i>>2]|4096;tb=f[V>>2]|0;if(!tb){a=VDc(68)|0;BYa(a);f[V>>2]=a;Sb=a}else Sb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Tb=a&255}else{a=VRb(c)|0;if((a|0)>-1)Tb=a;else{cb=0;Za=473;break a}}GRb(e,c,Tb);if((f[W>>2]|0)<0){Za=202;break a}if(!(Mi[f[(f[Sb>>2]|0)+44>>2]&1023](Sb,c)|0)){Za=202;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 20:{if((_a&255|0)!=162){$a=_a;break b}f[i>>2]=f[i>>2]|8192;a=f[X>>2]|0;if(!a){tb=VDc(64)|0;DYa(tb);f[X>>2]=tb;Ub=tb}else Ub=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Vb=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)Vb=tb;else{cb=0;Za=473;break a}}GRb(e,c,Vb);if((f[Y>>2]|0)<0){Za=213;break a}if(!(Mi[f[(f[Ub>>2]|0)+44>>2]&1023](Ub,c)|0)){Za=213;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 21:{if((_a&255|0)!=170){$a=_a;break b}f[i>>2]=f[i>>2]|16384;tb=f[Z>>2]|0;if(!tb){a=VDc(28)|0;FYa(a);f[Z>>2]=a;Wb=a}else Wb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Xb=a&255}else{a=VRb(c)|0;if((a|0)>-1)Xb=a;else{cb=0;Za=473;break a}}GRb(e,c,Xb);if((f[_>>2]|0)<0){Za=224;break a}if(!(Mi[f[(f[Wb>>2]|0)+44>>2]&1023](Wb,c)|0)){Za=224;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 22:{if((_a&255|0)!=178){$a=_a;break b}f[i>>2]=f[i>>2]|32768;a=f[$>>2]|0;if(!a){tb=VDc(32)|0;GYa(tb);f[$>>2]=tb;Yb=tb}else Yb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Zb=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)Zb=tb;else{cb=0;Za=473;break a}}GRb(e,c,Zb);if((f[aa>>2]|0)<0){Za=235;break a}if(!(Mi[f[(f[Yb>>2]|0)+44>>2]&1023](Yb,c)|0)){Za=235;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 23:{if((_a&255|0)!=186){$a=_a;break b}f[i>>2]=f[i>>2]|65536;tb=f[ba>>2]|0;if(!tb){a=VDc(28)|0;HYa(a);f[ba>>2]=a;_b=a}else _b=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;$b=a&255}else{a=VRb(c)|0;if((a|0)>-1)$b=a;else{cb=0;Za=473;break a}}GRb(e,c,$b);if((f[ca>>2]|0)<0){Za=246;break a}if(!(Mi[f[(f[_b>>2]|0)+44>>2]&1023](_b,c)|0)){Za=246;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 24:{if((_a&255|0)!=194){$a=_a;break b}f[i>>2]=f[i>>2]|131072;a=f[da>>2]|0;if(!a){tb=VDc(36)|0;IYa(tb);f[da>>2]=tb;ac=tb}else ac=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;bc=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)bc=tb;else{cb=0;Za=473;break a}}GRb(e,c,bc);if((f[ea>>2]|0)<0){Za=257;break a}if(!(Mi[f[(f[ac>>2]|0)+44>>2]&1023](ac,c)|0)){Za=257;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 25:{if((_a&255|0)!=202){$a=_a;break b}f[i>>2]=f[i>>2]|262144;tb=f[fa>>2]|0;if(!tb){a=VDc(20)|0;KYa(a);f[fa>>2]=a;cc=a}else cc=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;dc=a&255}else{a=VRb(c)|0;if((a|0)>-1)dc=a;else{cb=0;Za=473;break a}}GRb(e,c,dc);if((f[ga>>2]|0)<0){Za=268;break a}if(!(Mi[f[(f[cc>>2]|0)+44>>2]&1023](cc,c)|0)){Za=268;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 26:{if((_a&255|0)!=210){$a=_a;break b}f[i>>2]=f[i>>2]|524288;a=f[ha>>2]|0;if(!a){tb=VDc(96)|0;LYa(tb);f[ha>>2]=tb;ec=tb}else ec=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;fc=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)fc=tb;else{cb=0;Za=473;break a}}GRb(e,c,fc);if((f[ia>>2]|0)<0){Za=279;break a}if(!(Mi[f[(f[ec>>2]|0)+44>>2]&1023](ec,c)|0)){Za=279;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 27:{if((_a&255|0)!=218){$a=_a;break b}f[i>>2]=f[i>>2]|1048576;tb=f[ja>>2]|0;if(!tb){a=VDc(28)|0;NYa(a);f[ja>>2]=a;gc=a}else gc=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;hc=a&255}else{a=VRb(c)|0;if((a|0)>-1)hc=a;else{cb=0;Za=473;break a}}GRb(e,c,hc);if((f[ka>>2]|0)<0){Za=290;break a}if(!(Mi[f[(f[gc>>2]|0)+44>>2]&1023](gc,c)|0)){Za=290;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 29:{if((_a&255|0)!=234){$a=_a;break b}f[i>>2]=f[i>>2]|2097152;a=f[la>>2]|0;if(!a){tb=VDc(20)|0;OYa(tb);f[la>>2]=tb;ic=tb}else ic=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;jc=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)jc=tb;else{cb=0;Za=473;break a}}GRb(e,c,jc);if((f[ma>>2]|0)<0){Za=301;break a}if(!(Mi[f[(f[ic>>2]|0)+44>>2]&1023](ic,c)|0)){Za=301;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 30:{if((_a&255|0)!=242){$a=_a;break b}f[i>>2]=f[i>>2]|4194304;tb=f[na>>2]|0;if(!tb){a=VDc(24)|0;PYa(a);f[na>>2]=a;kc=a}else kc=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;lc=a&255}else{a=VRb(c)|0;if((a|0)>-1)lc=a;else{cb=0;Za=473;break a}}GRb(e,c,lc);if((f[oa>>2]|0)<0){Za=312;break a}if(!(Mi[f[(f[kc>>2]|0)+44>>2]&1023](kc,c)|0)){Za=312;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 31:{if((_a&255|0)!=250){$a=_a;break b}f[i>>2]=f[i>>2]|8388608;a=f[pa>>2]|0;if(!a){tb=VDc(36)|0;QYa(tb);f[pa>>2]=tb;mc=tb}else mc=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;nc=tb&255}else{tb=VRb(c)|0;if((tb|0)>-1)nc=tb;else{cb=0;Za=473;break a}}GRb(e,c,nc);if((f[qa>>2]|0)<0){Za=323;break a}if(!(Mi[f[(f[mc>>2]|0)+44>>2]&1023](mc,c)|0)){Za=323;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 32:{if((_a&255|0)!=2){$a=_a;break b}tb=cMa(ra)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(Va=b[a>>0]|0,Va<<24>>24>-1):0){f[c>>2]=a+1;oc=Va&255}else{Va=VRb(c)|0;if((Va|0)>-1)oc=Va;else{cb=0;Za=473;break a}}GRb(e,c,oc);if((f[sa>>2]|0)<0){Za=332;break a}if(!(Mi[f[(f[tb>>2]|0)+44>>2]&1023](tb,c)|0)){Za=332;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 33:{if((_a&255|0)!=10){$a=_a;break b}tb=cMa(ta)|0;Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0?(a=b[Va>>0]|0,a<<24>>24>-1):0){f[c>>2]=Va+1;pc=a&255}else{a=VRb(c)|0;if((a|0)>-1)pc=a;else{cb=0;Za=473;break a}}GRb(e,c,pc);if((f[ua>>2]|0)<0){Za=341;break a}if(!(Mi[f[(f[tb>>2]|0)+44>>2]&1023](tb,c)|0)){Za=341;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 34:{if((_a&255|0)!=18){$a=_a;break b}f[i>>2]=f[i>>2]|16777216;tb=f[va>>2]|0;if(!tb){a=VDc(24)|0;SYa(a);f[va>>2]=a;qc=a}else qc=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;rc=a&255}else{a=VRb(c)|0;if((a|0)>-1)rc=a;else{cb=0;Za=473;break a}}GRb(e,c,rc);if((f[wa>>2]|0)<0){Za=352;break a}if(!(Mi[f[(f[qc>>2]|0)+44>>2]&1023](qc,c)|0)){Za=352;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 35:{switch((_a&255)<<24>>24){case 29:break;case 26:{if(BVa(c,xa)|0)continue a;else{cb=0;Za=473;break a}break}default:{$a=_a;break b}}a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){tb=a;Va=h[tb>>0]|h[tb+1>>0]<<8|h[tb+2>>0]<<16|h[tb+3>>0]<<24;f[e>>2]=Va;f[c>>2]=a+4;sc=Va}else{if(!(TRb(c,e)|0)){Za=370;break a}sc=f[e>>2]|0}Va=f[xa>>2]|0;if((Va|0)==(f[ya>>2]|0)){SHa(xa,Va+1|0);tc=f[xa>>2]|0}else tc=Va;Va=f[za>>2]|0;a=tc+1|0;f[xa>>2]=a;f[Va+4+(tc<<2)>>2]=sc;tb=f[c>>2]|0;Ua=(f[g>>2]|0)-tb|0;if((Ua|0)<=0)continue a;Sa=tb;tb=(f[ya>>2]|0)-a|0;lb=(Ua>>>0)/6|0;sb=(lb|0)<(tb|0)?lb:tb;if((sb|0)>0){uc=0;vc=Sa;wc=a}else continue a;while(1){if((b[vc>>0]|0)!=-99){xc=uc;break}if((b[vc+1>>0]|0)!=2){xc=uc;break}a=vc+2|0;tb=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=wc;wc=wc+1|0;f[xa>>2]=wc;f[Va+4+(a<<2)>>2]=tb;tb=uc+1|0;if((tb|0)>=(sb|0)){xc=tb;break}else{uc=tb;vc=vc+6|0}}sb=xc*6|0;if((xc|0)<=0)continue a;if((Ua|0)<(sb|0)){PRb(c,sb,Ua)|0;continue a}else{f[c>>2]=Sa+sb;continue a}break}case 36:{if((_a&255|0)!=34){$a=_a;break b}f[i>>2]=f[i>>2]|33554432;sb=f[Aa>>2]|0;if(!sb){Va=VDc(44)|0;TYa(Va);f[Aa>>2]=Va;yc=Va}else yc=sb;sb=f[c>>2]|0;if(sb>>>0<(f[g>>2]|0)>>>0?(Va=b[sb>>0]|0,Va<<24>>24>-1):0){f[c>>2]=sb+1;zc=Va&255}else{Va=VRb(c)|0;if((Va|0)>-1)zc=Va;else{cb=0;Za=473;break a}}GRb(e,c,zc);if((f[Ba>>2]|0)<0){Za=381;break a}if(!(Mi[f[(f[yc>>2]|0)+44>>2]&1023](yc,c)|0)){Za=381;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 37:{if((_a&255|0)!=42){$a=_a;break b}f[i>>2]=f[i>>2]|67108864;Va=f[Ca>>2]|0;if(!Va){sb=VDc(20)|0;VYa(sb);f[Ca>>2]=sb;Ac=sb}else Ac=Va;Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0?(sb=b[Va>>0]|0,sb<<24>>24>-1):0){f[c>>2]=Va+1;Bc=sb&255}else{sb=VRb(c)|0;if((sb|0)>-1)Bc=sb;else{cb=0;Za=473;break a}}GRb(e,c,Bc);if((f[Da>>2]|0)<0){Za=392;break a}if(!(Mi[f[(f[Ac>>2]|0)+44>>2]&1023](Ac,c)|0)){Za=392;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 38:{if((_a&255|0)!=50){$a=_a;break b}f[i>>2]=f[i>>2]|134217728;sb=f[Ea>>2]|0;if(!sb){Va=VDc(20)|0;WYa(Va);f[Ea>>2]=Va;Cc=Va}else Cc=sb;sb=f[c>>2]|0;if(sb>>>0<(f[g>>2]|0)>>>0?(Va=b[sb>>0]|0,Va<<24>>24>-1):0){f[c>>2]=sb+1;Dc=Va&255}else{Va=VRb(c)|0;if((Va|0)>-1)Dc=Va;else{cb=0;Za=473;break a}}GRb(e,c,Dc);if((f[Fa>>2]|0)<0){Za=403;break a}if(!(Mi[f[(f[Cc>>2]|0)+44>>2]&1023](Cc,c)|0)){Za=403;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 39:{if((_a&255|0)!=58){$a=_a;break b}f[i>>2]=f[i>>2]|268435456;Va=f[Ga>>2]|0;if(!Va){sb=VDc(24)|0;XYa(sb);f[Ga>>2]=sb;Ec=sb}else Ec=Va;Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0?(sb=b[Va>>0]|0,sb<<24>>24>-1):0){f[c>>2]=Va+1;Fc=sb&255}else{sb=VRb(c)|0;if((sb|0)>-1)Fc=sb;else{cb=0;Za=473;break a}}GRb(e,c,Fc);if((f[Ha>>2]|0)<0){Za=414;break a}if(!(Mi[f[(f[Ec>>2]|0)+44>>2]&1023](Ec,c)|0)){Za=414;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 40:{if((_a&255|0)!=66){$a=_a;break b}f[i>>2]=f[i>>2]|536870912;sb=f[Ia>>2]|0;if(!sb){Va=VDc(24)|0;YYa(Va);f[Ia>>2]=Va;Gc=Va}else Gc=sb;sb=f[c>>2]|0;if(sb>>>0<(f[g>>2]|0)>>>0?(Va=b[sb>>0]|0,Va<<24>>24>-1):0){f[c>>2]=sb+1;Hc=Va&255}else{Va=VRb(c)|0;if((Va|0)>-1)Hc=Va;else{cb=0;Za=473;break a}}GRb(e,c,Hc);if((f[Ja>>2]|0)<0){Za=425;break a}if(!(Mi[f[(f[Gc>>2]|0)+44>>2]&1023](Gc,c)|0)){Za=425;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 41:{if((_a&255|0)!=74){$a=_a;break b}f[i>>2]=f[i>>2]|1073741824;Va=f[Ka>>2]|0;if(!Va){sb=VDc(28)|0;ZYa(sb);f[Ka>>2]=sb;Ic=sb}else Ic=Va;Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0?(sb=b[Va>>0]|0,sb<<24>>24>-1):0){f[c>>2]=Va+1;Jc=sb&255}else{sb=VRb(c)|0;if((sb|0)>-1)Jc=sb;else{cb=0;Za=473;break a}}GRb(e,c,Jc);if((f[La>>2]|0)<0){Za=436;break a}if(!(Mi[f[(f[Ic>>2]|0)+44>>2]&1023](Ic,c)|0)){Za=436;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 42:{if((_a&255|0)!=82){$a=_a;break b}f[i>>2]=f[i>>2]|-2147483648;sb=f[Ma>>2]|0;if(!sb){Va=VDc(28)|0;_Ya(Va);f[Ma>>2]=Va;Kc=Va}else Kc=sb;sb=f[c>>2]|0;if(sb>>>0<(f[g>>2]|0)>>>0?(Va=b[sb>>0]|0,Va<<24>>24>-1):0){f[c>>2]=sb+1;Lc=Va&255}else{Va=VRb(c)|0;if((Va|0)>-1)Lc=Va;else{cb=0;Za=473;break a}}GRb(e,c,Lc);if((f[Na>>2]|0)<0){Za=447;break a}if(!(Mi[f[(f[Kc>>2]|0)+44>>2]&1023](Kc,c)|0)){Za=447;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 1001:{if((_a&255|0)!=74){$a=_a;break b}if(fUb(c,JLa(Oa)|0)|0)continue a;else{cb=0;Za=473;break a}break}case 1002:{switch((_a&255)<<24>>24){case 80:break;case 82:{Va=f[q>>2]|0;if(!(Va&1))Mc=mNa(q)|0;else Mc=Va&-2;if(Fjc(c,1002,956,Mc,Pa)|0)continue a;else{cb=0;Za=473;break a}break}default:{$a=_a;break b}}Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0){sb=b[Va>>0]|0;kb=sb&255;if(sb<<24>>24>-1){f[c>>2]=Va+1;Nc=kb}else{Oc=kb;Za=455}}else{Oc=0;Za=455}if((Za|0)==455){Za=0;kb=HRb(c,Oc)|0;Va=J;if((Va|0)>-1|(Va|0)==-1&kb>>>0>4294967295)Nc=kb;else{cb=0;Za=473;break a}}if(Nc>>>0<2){kb=f[Pa>>2]|0;if((kb|0)==(f[Qa>>2]|0)){KLa(Pa,kb+1|0);Pc=f[Pa>>2]|0}else Pc=kb;kb=f[Ra>>2]|0;f[Pa>>2]=Pc+1;f[kb+4+(Pc<<2)>>2]=Nc;continue a}kb=f[q>>2]|0;if(!(kb&1))Qc=mNa(q)|0;else Qc=kb&-2;rjc(Qc,1002,Nc,((Nc|0)<0)<<31>>31);continue a;break}default:{$a=_a;break b}}while(0)}while(0);if(!$a){cb=1;Za=473;break}kb=f[q>>2]|0;if(!(kb&1))Rc=mNa(q)|0;else Rc=kb&-2;if(!(Djc(c,$a,Rc)|0)){cb=0;Za=473;break}}switch(Za|0){case 19:{cb=0;u=d;return cb|0}case 47:{cb=0;u=d;return cb|0}case 64:{cb=0;u=d;return cb|0}case 81:{cb=0;u=d;return cb|0}case 92:{cb=0;u=d;return cb|0}case 103:{cb=0;u=d;return cb|0}case 114:{cb=0;u=d;return cb|0}case 125:{cb=0;u=d;return cb|0}case 136:{cb=0;u=d;return cb|0}case 147:{cb=0;u=d;return cb|0}case 158:{cb=0;u=d;return cb|0}case 169:{cb=0;u=d;return cb|0}case 180:{cb=0;u=d;return cb|0}case 191:{cb=0;u=d;return cb|0}case 202:{cb=0;u=d;return cb|0}case 213:{cb=0;u=d;return cb|0}case 224:{cb=0;u=d;return cb|0}case 235:{cb=0;u=d;return cb|0}case 246:{cb=0;u=d;return cb|0}case 257:{cb=0;u=d;return cb|0}case 268:{cb=0;u=d;return cb|0}case 279:{cb=0;u=d;return cb|0}case 290:{cb=0;u=d;return cb|0}case 301:{cb=0;u=d;return cb|0}case 312:{cb=0;u=d;return cb|0}case 323:{cb=0;u=d;return cb|0}case 332:{cb=0;u=d;return cb|0}case 341:{cb=0;u=d;return cb|0}case 352:{cb=0;u=d;return cb|0}case 370:{cb=0;u=d;return cb|0}case 381:{cb=0;u=d;return cb|0}case 392:{cb=0;u=d;return cb|0}case 403:{cb=0;u=d;return cb|0}case 414:{cb=0;u=d;return cb|0}case 425:{cb=0;u=d;return cb|0}case 436:{cb=0;u=d;return cb|0}case 447:{cb=0;u=d;return cb|0}case 473:{u=d;return cb|0}}return 0}function cYa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if((e|0)>0){l=f[a+44>>2]|0;c=0;g=h;while(1){d=f[l+4+(c<<2)>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+g+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=j;break}else g=j}}else m=h;h=f[a+52>>2]|0;g=h+m|0;if(!h)n=g;else{m=a+60|0;e=0;c=g;while(1){g=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;l=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;g=l+c+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(h|0)){n=g;break}else c=g}}c=f[a+64>>2]|0;h=f[a+76>>2]|0;e=f[a+92>>2]|0;m=c+n+h+(e<<1)+(h+c<<2)|0;if(!e)o=m;else{c=a+100|0;h=0;n=m;while(1){m=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;g=_i[f[(f[m>>2]|0)+48>>2]&1023](m)|0;m=g+n+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(e|0)){o=m;break}else n=m}}n=f[a+108>>2]|0;e=(n<<1)+o|0;if(!n)p=e;else{o=a+116|0;h=0;c=e;while(1){e=f[(f[o>>2]|0)+4+(h<<2)>>2]|0;m=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=m+c+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(n|0)){p=e;break}else c=e}}c=f[a+120>>2]|0;n=f[a+136>>2]|0;h=(c<<2)+p+(n+c<<1)|0;if((n|0)>0){c=f[a+144>>2]|0;p=0;o=h;while(1){e=f[c+4+(p<<2)>>2]|0;m=b[e+11>>0]|0;g=m<<24>>24<0?f[e+4>>2]|0:m&255;m=g+o+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=p+1|0;if((p|0)==(n|0)){q=m;break}else o=m}}else q=h;h=f[a+148>>2]|0;if(!h)r=0;else{o=f[a+156>>2]|0;n=0;p=0;while(1){c=f[o+4+(n<<2)>>2]|0;if((c|0)<0)s=10;else s=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;c=s+p|0;n=n+1|0;if((n|0)==(h|0)){r=c;break}else p=c}}p=(h<<1)+q+r|0;r=a+8|0;q=f[r>>2]|0;if(q&255){if(!(q&1))t=p;else{h=f[a+160>>2]|0;n=b[h+11>>0]|0;s=n<<24>>24<0?f[h+4>>2]|0:n&255;t=p+1+s+((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(q&2)){u=t;v=q}else{s=f[a+164>>2]|0;n=_i[f[(f[s>>2]|0)+48>>2]&1023](s)|0;s=t+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=s;v=f[r>>2]|0}if(!(v&4)){w=u;x=v}else{v=f[a+168>>2]|0;s=_i[f[(f[v>>2]|0)+48>>2]&1023](v)|0;v=u+1+s+((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=v;x=f[r>>2]|0}if(!(x&8)){y=w;z=x}else{x=f[a+172>>2]|0;v=_i[f[(f[x>>2]|0)+48>>2]&1023](x)|0;x=w+1+v+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0;y=x;z=f[r>>2]|0}if(!(z&16)){A=y;B=z}else{z=f[a+176>>2]|0;x=_i[f[(f[z>>2]|0)+48>>2]&1023](z)|0;z=y+1+x+((((($(x|1|0)|0)^31)*9|0)+73|0)>>>6)|0;A=z;B=f[r>>2]|0}if(!(B&32)){C=A;D=B}else{B=f[a+180>>2]|0;z=_i[f[(f[B>>2]|0)+48>>2]&1023](B)|0;B=A+1+z+((((($(z|1|0)|0)^31)*9|0)+73|0)>>>6)|0;C=B;D=f[r>>2]|0}if(!(D&64)){E=C;F=D}else{D=f[a+184>>2]|0;B=_i[f[(f[D>>2]|0)+48>>2]&1023](D)|0;D=C+1+B+((((($(B|1|0)|0)^31)*9|0)+73|0)>>>6)|0;E=D;F=f[r>>2]|0}if(!(F&128)){G=E;H=F}else{F=f[a+188>>2]|0;D=_i[f[(f[F>>2]|0)+48>>2]&1023](F)|0;F=E+1+D+((((($(D|1|0)|0)^31)*9|0)+73|0)>>>6)|0;G=F;H=f[r>>2]|0}}else{G=p;H=q}if(H&65280){if(!(H&256)){I=G;J=H}else{q=f[a+192>>2]|0;p=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=G+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;I=q;J=f[r>>2]|0}if(!(J&512)){K=I;L=J}else{J=f[a+196>>2]|0;q=_i[f[(f[J>>2]|0)+48>>2]&1023](J)|0;J=I+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;K=J;L=f[r>>2]|0}if(!(L&1024)){M=K;N=L}else{L=f[a+200>>2]|0;J=_i[f[(f[L>>2]|0)+48>>2]&1023](L)|0;L=K+2+J+((((($(J|1|0)|0)^31)*9|0)+73|0)>>>6)|0;M=L;N=f[r>>2]|0}if(!(N&2048)){O=M;P=N}else{N=f[a+204>>2]|0;L=_i[f[(f[N>>2]|0)+48>>2]&1023](N)|0;N=M+2+L+((((($(L|1|0)|0)^31)*9|0)+73|0)>>>6)|0;O=N;P=f[r>>2]|0}if(!(P&4096)){Q=O;R=P}else{P=f[a+208>>2]|0;N=_i[f[(f[P>>2]|0)+48>>2]&1023](P)|0;P=O+2+N+((((($(N|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Q=P;R=f[r>>2]|0}if(!(R&8192)){S=Q;T=R}else{R=f[a+212>>2]|0;P=_i[f[(f[R>>2]|0)+48>>2]&1023](R)|0;R=Q+2+P+((((($(P|1|0)|0)^31)*9|0)+73|0)>>>6)|0;S=R;T=f[r>>2]|0}if(!(T&16384)){U=S;V=T}else{T=f[a+216>>2]|0;R=_i[f[(f[T>>2]|0)+48>>2]&1023](T)|0;T=S+2+R+((((($(R|1|0)|0)^31)*9|0)+73|0)>>>6)|0;U=T;V=f[r>>2]|0}if(!(V&32768)){W=U;X=V}else{V=f[a+220>>2]|0;T=_i[f[(f[V>>2]|0)+48>>2]&1023](V)|0;V=U+2+T+((((($(T|1|0)|0)^31)*9|0)+73|0)>>>6)|0;W=V;X=f[r>>2]|0}}else{W=G;X=H}if(X&16711680){if(!(X&65536)){Y=W;Z=X}else{H=f[a+224>>2]|0;G=_i[f[(f[H>>2]|0)+48>>2]&1023](H)|0;H=W+2+G+((((($(G|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Y=H;Z=f[r>>2]|0}if(!(Z&131072)){_=Y;aa=Z}else{Z=f[a+228>>2]|0;H=_i[f[(f[Z>>2]|0)+48>>2]&1023](Z)|0;Z=Y+2+H+((((($(H|1|0)|0)^31)*9|0)+73|0)>>>6)|0;_=Z;aa=f[r>>2]|0}if(!(aa&262144)){ba=_;ca=aa}else{aa=f[a+232>>2]|0;Z=_i[f[(f[aa>>2]|0)+48>>2]&1023](aa)|0;aa=_+2+Z+((((($(Z|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ba=aa;ca=f[r>>2]|0}if(!(ca&524288)){da=ba;ea=ca}else{ca=f[a+236>>2]|0;aa=_i[f[(f[ca>>2]|0)+48>>2]&1023](ca)|0;ca=ba+2+aa+((((($(aa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;da=ca;ea=f[r>>2]|0}if(!(ea&1048576)){fa=da;ga=ea}else{ea=f[a+240>>2]|0;ca=_i[f[(f[ea>>2]|0)+48>>2]&1023](ea)|0;ea=da+2+ca+((((($(ca|1|0)|0)^31)*9|0)+73|0)>>>6)|0;fa=ea;ga=f[r>>2]|0}if(!(ga&2097152)){ha=fa;ia=ga}else{ga=f[a+244>>2]|0;ea=_i[f[(f[ga>>2]|0)+48>>2]&1023](ga)|0;ga=fa+2+ea+((((($(ea|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ha=ga;ia=f[r>>2]|0}if(!(ia&4194304)){ja=ha;ka=ia}else{ia=f[a+248>>2]|0;ga=_i[f[(f[ia>>2]|0)+48>>2]&1023](ia)|0;ia=ha+2+ga+((((($(ga|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ja=ia;ka=f[r>>2]|0}if(!(ka&8388608)){la=ja;ma=ka}else{ka=f[a+252>>2]|0;ia=_i[f[(f[ka>>2]|0)+48>>2]&1023](ka)|0;ka=ja+2+ia+((((($(ia|1|0)|0)^31)*9|0)+73|0)>>>6)|0;la=ka;ma=f[r>>2]|0}}else{la=W;ma=X}do if(ma>>>0>16777215){if(!(ma&16777216)){na=la;oa=ma}else{X=f[a+256>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&1023](X)|0;X=la+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;na=X;oa=f[r>>2]|0}if(!(oa&33554432)){pa=na;qa=oa}else{X=f[a+260>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&1023](X)|0;X=na+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;pa=X;qa=f[r>>2]|0}if(!(qa&67108864)){ra=pa;sa=qa}else{X=f[a+264>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&1023](X)|0;X=pa+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ra=X;sa=f[r>>2]|0}if(!(sa&134217728)){ta=ra;ua=sa}else{X=f[a+268>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&1023](X)|0;X=ra+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ta=X;ua=f[r>>2]|0}if(!(ua&268435456)){va=ta;wa=ua}else{X=f[a+272>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&1023](X)|0;X=ta+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;va=X;wa=f[r>>2]|0}if(!(wa&536870912)){xa=va;ya=wa}else{X=f[a+276>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&1023](X)|0;X=va+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;xa=X;ya=f[r>>2]|0}if(!(ya&1073741824)){za=xa;Aa=ya}else{X=f[a+280>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&1023](X)|0;X=xa+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;za=X;Aa=f[r>>2]|0}if((Aa|0)>=0){Ba=za;break}X=f[a+284>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&1023](X)|0;Ba=za+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else Ba=la;while(0);if(!(f[a+12>>2]&1)){Ca=Ba;Da=a+292|0;f[Da>>2]=Ca;return Ca|0}la=f[a+288>>2]|0;if((la|0)<0)Ea=11;else Ea=((((($(la|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;Ca=Ea+Ba|0;Da=a+292|0;f[Da>>2]=Ca;return Ca|0}function dYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&2|0)eUb(1,f[a+164>>2]|0,b);e=f[a+20>>2]|0;if((e|0)>0){g=a+28|0;h=0;do{_Tb(2,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,b);h=h+1|0}while((h|0)!=(e|0))}e=f[a+36>>2]|0;if((e|0)>0){h=a+44|0;g=0;do{_Tb(3,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(e|0))}if(d&1|0)$Tb(4,f[a+160>>2]|0,b);if(f[a+12>>2]&1|0)ZTb(5,f[a+288>>2]|0,b);d=f[a+52>>2]|0;if(d|0){e=a+60|0;g=0;do{eUb(6,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+64>>2]|0;if((d|0)>0){g=a+72|0;e=0;do{WTb(7,+n[(f[g>>2]|0)+4+(e<<2)>>2],b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+76>>2]|0;if((d|0)>0){e=a+84|0;g=0;do{WTb(8,+n[(f[e>>2]|0)+4+(g<<2)>>2],b);g=g+1|0}while((g|0)!=(d|0))}d=f[c>>2]|0;if(d&4|0)eUb(9,f[a+168>>2]|0,b);if(d&8|0)eUb(10,f[a+172>>2]|0,b);if(d&16|0)eUb(11,f[a+176>>2]|0,b);if(d&32|0)eUb(12,f[a+180>>2]|0,b);if(d&64|0)eUb(13,f[a+184>>2]|0,b);if(d&128|0)eUb(14,f[a+188>>2]|0,b);if(d&256|0)eUb(15,f[a+192>>2]|0,b);if(d&512|0)eUb(16,f[a+196>>2]|0,b);if(d&1024|0)eUb(17,f[a+200>>2]|0,b);if(d&2048|0)eUb(18,f[a+204>>2]|0,b);if(d&4096|0)eUb(19,f[a+208>>2]|0,b);if(d&8192|0)eUb(20,f[a+212>>2]|0,b);if(d&16384|0)eUb(21,f[a+216>>2]|0,b);if(d&32768|0)eUb(22,f[a+220>>2]|0,b);if(d&65536|0)eUb(23,f[a+224>>2]|0,b);if(d&131072|0)eUb(24,f[a+228>>2]|0,b);if(d&262144|0)eUb(25,f[a+232>>2]|0,b);if(d&524288|0)eUb(26,f[a+236>>2]|0,b);if(d&1048576|0)eUb(27,f[a+240>>2]|0,b);if(d&2097152|0)eUb(29,f[a+244>>2]|0,b);if(d&4194304|0)eUb(30,f[a+248>>2]|0,b);if(d&8388608|0)eUb(31,f[a+252>>2]|0,b);c=f[a+92>>2]|0;if(c|0){g=a+100|0;e=0;do{eUb(32,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+108>>2]|0;if(c|0){e=a+116|0;g=0;do{eUb(33,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}if(d&16777216|0)eUb(34,f[a+256>>2]|0,b);c=f[a+120>>2]|0;if((c|0)>0){g=a+128|0;e=0;do{WTb(35,+n[(f[g>>2]|0)+4+(e<<2)>>2],b);e=e+1|0}while((e|0)!=(c|0))}if(d&33554432|0)eUb(36,f[a+260>>2]|0,b);if(d&67108864|0)eUb(37,f[a+264>>2]|0,b);if(d&134217728|0)eUb(38,f[a+268>>2]|0,b);if(d&268435456|0)eUb(39,f[a+272>>2]|0,b);if(d&536870912|0)eUb(40,f[a+276>>2]|0,b);if(d&1073741824|0)eUb(41,f[a+280>>2]|0,b);if((d|0)<0)eUb(42,f[a+284>>2]|0,b);d=f[a+136>>2]|0;if((d|0)>0){c=a+144|0;e=0;do{_Tb(1001,f[(f[c>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+148>>2]|0;if((d|0)>0){e=a+156|0;c=0;do{ZTb(1002,f[(f[e>>2]|0)+4+(c<<2)>>2]|0,b);c=c+1|0}while((c|0)!=(d|0))}d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,b);return}function eYa(a){a=a|0;return f[a+292>>2]|0}function fYa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;e=a+8|0;g=f[e>>2]|0;if(!(g&2))h=d;else{i=f[a+164>>2]|0;b[d>>0]=10;j=d+1|0;d=_i[f[(f[i>>2]|0)+60>>2]&1023](i)|0;if(d>>>0>127){k=d;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=d}b[o>>0]=p;h=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,o+1|0)|0}o=f[a+20>>2]|0;if((o|0)>0){i=a+28|0;p=0;d=h;while(1){j=f[(f[i>>2]|0)+4+(p<<2)>>2]|0;b[d>>0]=18;l=dSb(j,d+1|0)|0;p=p+1|0;if((p|0)==(o|0)){q=l;break}else d=l}}else q=h;h=f[a+36>>2]|0;if((h|0)>0){d=a+44|0;o=0;p=q;while(1){i=f[(f[d>>2]|0)+4+(o<<2)>>2]|0;b[p>>0]=26;l=dSb(i,p+1|0)|0;o=o+1|0;if((o|0)==(h|0)){r=l;break}else p=l}}else r=q;if(!(g&1))s=r;else{g=f[a+160>>2]|0;b[r>>0]=34;s=dSb(g,r+1|0)|0}if(!(f[a+12>>2]&1))t=s;else{r=f[a+288>>2]|0;b[s>>0]=40;g=s+1|0;s=r&255;if(r>>>0>127){q=g;p=s;h=r;o=((r|0)<0)<<31>>31;while(1){b[q>>0]=p|-128;r=h;h=aJc(h|0,o|0,7)|0;d=q+1|0;l=h&255;if(!(o>>>0>0|(o|0)==0&r>>>0>16383)){u=d;v=l;break}else{q=d;p=l;o=J}}}else{u=g;v=s}b[u>>0]=v;t=u+1|0}u=f[a+52>>2]|0;if(!u)w=t;else{v=a+60|0;s=0;g=t;while(1){t=f[(f[v>>2]|0)+4+(s<<2)>>2]|0;b[g>>0]=50;o=g+1|0;p=_i[f[(f[t>>2]|0)+60>>2]&1023](t)|0;if(p>>>0>127){q=p;h=o;while(1){b[h>>0]=q|128;l=q>>>7;d=h+1|0;if(q>>>0>16383){q=l;h=d}else{x=d;y=l;break}}}else{x=o;y=p}b[x>>0]=y;h=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;s=s+1|0;if((s|0)==(u|0)){w=h;break}else g=h}}g=f[a+64>>2]|0;if(!g)z=w;else{u=f[a+72>>2]|0;s=0;x=w;while(1){w=f[u+4+(s<<2)>>2]|0;b[x>>0]=61;y=x+1|0;b[y>>0]=w;b[y+1>>0]=w>>8;b[y+2>>0]=w>>16;b[y+3>>0]=w>>24;w=x+5|0;s=s+1|0;if((s|0)>=(g|0)){z=w;break}else x=w}}x=f[a+76>>2]|0;if(!x)A=z;else{g=f[a+84>>2]|0;s=0;u=z;while(1){z=f[g+4+(s<<2)>>2]|0;b[u>>0]=69;w=u+1|0;b[w>>0]=z;b[w+1>>0]=z>>8;b[w+2>>0]=z>>16;b[w+3>>0]=z>>24;z=u+5|0;s=s+1|0;if((s|0)>=(x|0)){A=z;break}else u=z}}u=f[e>>2]|0;if(!(u&4))B=A;else{e=f[a+168>>2]|0;b[A>>0]=74;x=A+1|0;A=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(A>>>0>127){s=A;g=x;while(1){b[g>>0]=s|128;z=s>>>7;w=g+1|0;if(s>>>0>16383){s=z;g=w}else{C=w;D=z;break}}}else{C=x;D=A}b[C>>0]=D;B=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,C+1|0)|0}if(!(u&8))E=B;else{C=f[a+172>>2]|0;b[B>>0]=82;e=B+1|0;B=_i[f[(f[C>>2]|0)+60>>2]&1023](C)|0;if(B>>>0>127){D=B;A=e;while(1){b[A>>0]=D|128;x=D>>>7;g=A+1|0;if(D>>>0>16383){D=x;A=g}else{F=g;G=x;break}}}else{F=e;G=B}b[F>>0]=G;E=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,F+1|0)|0}if(!(u&16))H=E;else{F=f[a+176>>2]|0;b[E>>0]=90;C=E+1|0;E=_i[f[(f[F>>2]|0)+60>>2]&1023](F)|0;if(E>>>0>127){G=E;B=C;while(1){b[B>>0]=G|128;e=G>>>7;A=B+1|0;if(G>>>0>16383){G=e;B=A}else{I=A;K=e;break}}}else{I=C;K=E}b[I>>0]=K;H=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,I+1|0)|0}if(!(u&32))L=H;else{I=f[a+180>>2]|0;b[H>>0]=98;F=H+1|0;H=_i[f[(f[I>>2]|0)+60>>2]&1023](I)|0;if(H>>>0>127){K=H;E=F;while(1){b[E>>0]=K|128;C=K>>>7;B=E+1|0;if(K>>>0>16383){K=C;E=B}else{M=B;N=C;break}}}else{M=F;N=H}b[M>>0]=N;L=hj[f[(f[I>>2]|0)+64>>2]&511](I,c,M+1|0)|0}if(!(u&64))O=L;else{M=f[a+184>>2]|0;b[L>>0]=106;I=L+1|0;L=_i[f[(f[M>>2]|0)+60>>2]&1023](M)|0;if(L>>>0>127){N=L;H=I;while(1){b[H>>0]=N|128;F=N>>>7;E=H+1|0;if(N>>>0>16383){N=F;H=E}else{P=E;Q=F;break}}}else{P=I;Q=L}b[P>>0]=Q;O=hj[f[(f[M>>2]|0)+64>>2]&511](M,c,P+1|0)|0}if(!(u&128))R=O;else{P=f[a+188>>2]|0;b[O>>0]=114;M=O+1|0;O=_i[f[(f[P>>2]|0)+60>>2]&1023](P)|0;if(O>>>0>127){Q=O;L=M;while(1){b[L>>0]=Q|128;I=Q>>>7;H=L+1|0;if(Q>>>0>16383){Q=I;L=H}else{S=H;T=I;break}}}else{S=M;T=O}b[S>>0]=T;R=hj[f[(f[P>>2]|0)+64>>2]&511](P,c,S+1|0)|0}if(!(u&256))U=R;else{S=f[a+192>>2]|0;b[R>>0]=122;P=R+1|0;R=_i[f[(f[S>>2]|0)+60>>2]&1023](S)|0;if(R>>>0>127){T=R;O=P;while(1){b[O>>0]=T|128;M=T>>>7;L=O+1|0;if(T>>>0>16383){T=M;O=L}else{V=L;W=M;break}}}else{V=P;W=R}b[V>>0]=W;U=hj[f[(f[S>>2]|0)+64>>2]&511](S,c,V+1|0)|0}if(!(u&512))X=U;else{V=f[a+196>>2]|0;b[U>>0]=-126;b[U+1>>0]=1;S=U+2|0;U=_i[f[(f[V>>2]|0)+60>>2]&1023](V)|0;if(U>>>0>127){W=U;R=S;while(1){b[R>>0]=W|128;P=W>>>7;O=R+1|0;if(W>>>0>16383){W=P;R=O}else{Y=O;Z=P;break}}}else{Y=S;Z=U}b[Y>>0]=Z;X=hj[f[(f[V>>2]|0)+64>>2]&511](V,c,Y+1|0)|0}if(!(u&1024))_=X;else{Y=f[a+200>>2]|0;b[X>>0]=-118;b[X+1>>0]=1;V=X+2|0;X=_i[f[(f[Y>>2]|0)+60>>2]&1023](Y)|0;if(X>>>0>127){Z=X;U=V;while(1){b[U>>0]=Z|128;S=Z>>>7;R=U+1|0;if(Z>>>0>16383){Z=S;U=R}else{$=R;aa=S;break}}}else{$=V;aa=X}b[$>>0]=aa;_=hj[f[(f[Y>>2]|0)+64>>2]&511](Y,c,$+1|0)|0}if(!(u&2048))ba=_;else{$=f[a+204>>2]|0;b[_>>0]=-110;b[_+1>>0]=1;Y=_+2|0;_=_i[f[(f[$>>2]|0)+60>>2]&1023]($)|0;if(_>>>0>127){aa=_;X=Y;while(1){b[X>>0]=aa|128;V=aa>>>7;U=X+1|0;if(aa>>>0>16383){aa=V;X=U}else{ca=U;da=V;break}}}else{ca=Y;da=_}b[ca>>0]=da;ba=hj[f[(f[$>>2]|0)+64>>2]&511]($,c,ca+1|0)|0}if(!(u&4096))ea=ba;else{ca=f[a+208>>2]|0;b[ba>>0]=-102;b[ba+1>>0]=1;$=ba+2|0;ba=_i[f[(f[ca>>2]|0)+60>>2]&1023](ca)|0;if(ba>>>0>127){da=ba;_=$;while(1){b[_>>0]=da|128;Y=da>>>7;X=_+1|0;if(da>>>0>16383){da=Y;_=X}else{fa=X;ga=Y;break}}}else{fa=$;ga=ba}b[fa>>0]=ga;ea=hj[f[(f[ca>>2]|0)+64>>2]&511](ca,c,fa+1|0)|0}if(!(u&8192))ha=ea;else{fa=f[a+212>>2]|0;b[ea>>0]=-94;b[ea+1>>0]=1;ca=ea+2|0;ea=_i[f[(f[fa>>2]|0)+60>>2]&1023](fa)|0;if(ea>>>0>127){ga=ea;ba=ca;while(1){b[ba>>0]=ga|128;$=ga>>>7;_=ba+1|0;if(ga>>>0>16383){ga=$;ba=_}else{ia=_;ja=$;break}}}else{ia=ca;ja=ea}b[ia>>0]=ja;ha=hj[f[(f[fa>>2]|0)+64>>2]&511](fa,c,ia+1|0)|0}if(!(u&16384))ka=ha;else{ia=f[a+216>>2]|0;b[ha>>0]=-86;b[ha+1>>0]=1;fa=ha+2|0;ha=_i[f[(f[ia>>2]|0)+60>>2]&1023](ia)|0;if(ha>>>0>127){ja=ha;ea=fa;while(1){b[ea>>0]=ja|128;ca=ja>>>7;ba=ea+1|0;if(ja>>>0>16383){ja=ca;ea=ba}else{la=ba;ma=ca;break}}}else{la=fa;ma=ha}b[la>>0]=ma;ka=hj[f[(f[ia>>2]|0)+64>>2]&511](ia,c,la+1|0)|0}if(!(u&32768))na=ka;else{la=f[a+220>>2]|0;b[ka>>0]=-78;b[ka+1>>0]=1;ia=ka+2|0;ka=_i[f[(f[la>>2]|0)+60>>2]&1023](la)|0;if(ka>>>0>127){ma=ka;ha=ia;while(1){b[ha>>0]=ma|128;fa=ma>>>7;ea=ha+1|0;if(ma>>>0>16383){ma=fa;ha=ea}else{oa=ea;pa=fa;break}}}else{oa=ia;pa=ka}b[oa>>0]=pa;na=hj[f[(f[la>>2]|0)+64>>2]&511](la,c,oa+1|0)|0}if(!(u&65536))qa=na;else{oa=f[a+224>>2]|0;b[na>>0]=-70;b[na+1>>0]=1;la=na+2|0;na=_i[f[(f[oa>>2]|0)+60>>2]&1023](oa)|0;if(na>>>0>127){pa=na;ka=la;while(1){b[ka>>0]=pa|128;ia=pa>>>7;ha=ka+1|0;if(pa>>>0>16383){pa=ia;ka=ha}else{ra=ha;sa=ia;break}}}else{ra=la;sa=na}b[ra>>0]=sa;qa=hj[f[(f[oa>>2]|0)+64>>2]&511](oa,c,ra+1|0)|0}if(!(u&131072))ta=qa;else{ra=f[a+228>>2]|0;b[qa>>0]=-62;b[qa+1>>0]=1;oa=qa+2|0;qa=_i[f[(f[ra>>2]|0)+60>>2]&1023](ra)|0;if(qa>>>0>127){sa=qa;na=oa;while(1){b[na>>0]=sa|128;la=sa>>>7;ka=na+1|0;if(sa>>>0>16383){sa=la;na=ka}else{ua=ka;va=la;break}}}else{ua=oa;va=qa}b[ua>>0]=va;ta=hj[f[(f[ra>>2]|0)+64>>2]&511](ra,c,ua+1|0)|0}if(!(u&262144))wa=ta;else{ua=f[a+232>>2]|0;b[ta>>0]=-54;b[ta+1>>0]=1;ra=ta+2|0;ta=_i[f[(f[ua>>2]|0)+60>>2]&1023](ua)|0;if(ta>>>0>127){va=ta;qa=ra;while(1){b[qa>>0]=va|128;oa=va>>>7;na=qa+1|0;if(va>>>0>16383){va=oa;qa=na}else{xa=na;ya=oa;break}}}else{xa=ra;ya=ta}b[xa>>0]=ya;wa=hj[f[(f[ua>>2]|0)+64>>2]&511](ua,c,xa+1|0)|0}if(!(u&524288))za=wa;else{xa=f[a+236>>2]|0;b[wa>>0]=-46;b[wa+1>>0]=1;ua=wa+2|0;wa=_i[f[(f[xa>>2]|0)+60>>2]&1023](xa)|0;if(wa>>>0>127){ya=wa;ta=ua;while(1){b[ta>>0]=ya|128;ra=ya>>>7;qa=ta+1|0;if(ya>>>0>16383){ya=ra;ta=qa}else{Aa=qa;Ba=ra;break}}}else{Aa=ua;Ba=wa}b[Aa>>0]=Ba;za=hj[f[(f[xa>>2]|0)+64>>2]&511](xa,c,Aa+1|0)|0}if(!(u&1048576))Ca=za;else{Aa=f[a+240>>2]|0;b[za>>0]=-38;b[za+1>>0]=1;xa=za+2|0;za=_i[f[(f[Aa>>2]|0)+60>>2]&1023](Aa)|0;if(za>>>0>127){Ba=za;wa=xa;while(1){b[wa>>0]=Ba|128;ua=Ba>>>7;ta=wa+1|0;if(Ba>>>0>16383){Ba=ua;wa=ta}else{Da=ta;Ea=ua;break}}}else{Da=xa;Ea=za}b[Da>>0]=Ea;Ca=hj[f[(f[Aa>>2]|0)+64>>2]&511](Aa,c,Da+1|0)|0}if(!(u&2097152))Fa=Ca;else{Da=f[a+244>>2]|0;b[Ca>>0]=-22;b[Ca+1>>0]=1;Aa=Ca+2|0;Ca=_i[f[(f[Da>>2]|0)+60>>2]&1023](Da)|0;if(Ca>>>0>127){Ea=Ca;za=Aa;while(1){b[za>>0]=Ea|128;xa=Ea>>>7;wa=za+1|0;if(Ea>>>0>16383){Ea=xa;za=wa}else{Ga=wa;Ha=xa;break}}}else{Ga=Aa;Ha=Ca}b[Ga>>0]=Ha;Fa=hj[f[(f[Da>>2]|0)+64>>2]&511](Da,c,Ga+1|0)|0}if(!(u&4194304))Ia=Fa;else{Ga=f[a+248>>2]|0;b[Fa>>0]=-14;b[Fa+1>>0]=1;Da=Fa+2|0;Fa=_i[f[(f[Ga>>2]|0)+60>>2]&1023](Ga)|0;if(Fa>>>0>127){Ha=Fa;Ca=Da;while(1){b[Ca>>0]=Ha|128;Aa=Ha>>>7;za=Ca+1|0;if(Ha>>>0>16383){Ha=Aa;Ca=za}else{Ja=za;Ka=Aa;break}}}else{Ja=Da;Ka=Fa}b[Ja>>0]=Ka;Ia=hj[f[(f[Ga>>2]|0)+64>>2]&511](Ga,c,Ja+1|0)|0}if(!(u&8388608))La=Ia;else{Ja=f[a+252>>2]|0;b[Ia>>0]=-6;b[Ia+1>>0]=1;Ga=Ia+2|0;Ia=_i[f[(f[Ja>>2]|0)+60>>2]&1023](Ja)|0;if(Ia>>>0>127){Ka=Ia;Fa=Ga;while(1){b[Fa>>0]=Ka|128;Da=Ka>>>7;Ca=Fa+1|0;if(Ka>>>0>16383){Ka=Da;Fa=Ca}else{Ma=Ca;Na=Da;break}}}else{Ma=Ga;Na=Ia}b[Ma>>0]=Na;La=hj[f[(f[Ja>>2]|0)+64>>2]&511](Ja,c,Ma+1|0)|0}Ma=f[a+92>>2]|0;if(!Ma)Oa=La;else{Ja=a+100|0;Na=0;Ia=La;while(1){La=f[(f[Ja>>2]|0)+4+(Na<<2)>>2]|0;b[Ia>>0]=-126;b[Ia+1>>0]=2;Ga=Ia+2|0;Fa=_i[f[(f[La>>2]|0)+60>>2]&1023](La)|0;if(Fa>>>0>127){Ka=Fa;Da=Ga;while(1){b[Da>>0]=Ka|128;Ca=Ka>>>7;Ha=Da+1|0;if(Ka>>>0>16383){Ka=Ca;Da=Ha}else{Pa=Ha;Qa=Ca;break}}}else{Pa=Ga;Qa=Fa}b[Pa>>0]=Qa;Da=hj[f[(f[La>>2]|0)+64>>2]&511](La,c,Pa+1|0)|0;Na=Na+1|0;if((Na|0)==(Ma|0)){Oa=Da;break}else Ia=Da}}Ia=f[a+108>>2]|0;if(!Ia)Ra=Oa;else{Ma=a+116|0;Na=0;Pa=Oa;while(1){Oa=f[(f[Ma>>2]|0)+4+(Na<<2)>>2]|0;b[Pa>>0]=-118;b[Pa+1>>0]=2;Qa=Pa+2|0;Ja=_i[f[(f[Oa>>2]|0)+60>>2]&1023](Oa)|0;if(Ja>>>0>127){Da=Ja;Ka=Qa;while(1){b[Ka>>0]=Da|128;t=Da>>>7;p=Ka+1|0;if(Da>>>0>16383){Da=t;Ka=p}else{Sa=p;Ta=t;break}}}else{Sa=Qa;Ta=Ja}b[Sa>>0]=Ta;Ka=hj[f[(f[Oa>>2]|0)+64>>2]&511](Oa,c,Sa+1|0)|0;Na=Na+1|0;if((Na|0)==(Ia|0)){Ra=Ka;break}else Pa=Ka}}if(!(u&16777216))Ua=Ra;else{Pa=f[a+256>>2]|0;b[Ra>>0]=-110;b[Ra+1>>0]=2;Ia=Ra+2|0;Ra=_i[f[(f[Pa>>2]|0)+60>>2]&1023](Pa)|0;if(Ra>>>0>127){Na=Ra;Sa=Ia;while(1){b[Sa>>0]=Na|128;Ta=Na>>>7;Ma=Sa+1|0;if(Na>>>0>16383){Na=Ta;Sa=Ma}else{Va=Ma;Wa=Ta;break}}}else{Va=Ia;Wa=Ra}b[Va>>0]=Wa;Ua=hj[f[(f[Pa>>2]|0)+64>>2]&511](Pa,c,Va+1|0)|0}Va=f[a+120>>2]|0;if(!Va)Xa=Ua;else{Pa=f[a+128>>2]|0;Wa=0;Ra=Ua;while(1){Ua=f[Pa+4+(Wa<<2)>>2]|0;b[Ra>>0]=-99;b[Ra+1>>0]=2;Ia=Ra+2|0;b[Ia>>0]=Ua;b[Ia+1>>0]=Ua>>8;b[Ia+2>>0]=Ua>>16;b[Ia+3>>0]=Ua>>24;Ua=Ra+6|0;Wa=Wa+1|0;if((Wa|0)>=(Va|0)){Xa=Ua;break}else Ra=Ua}}if(!(u&33554432))Ya=Xa;else{Ra=f[a+260>>2]|0;b[Xa>>0]=-94;b[Xa+1>>0]=2;Va=Xa+2|0;Xa=_i[f[(f[Ra>>2]|0)+60>>2]&1023](Ra)|0;if(Xa>>>0>127){Wa=Xa;Pa=Va;while(1){b[Pa>>0]=Wa|128;Ua=Wa>>>7;Ia=Pa+1|0;if(Wa>>>0>16383){Wa=Ua;Pa=Ia}else{Za=Ia;_a=Ua;break}}}else{Za=Va;_a=Xa}b[Za>>0]=_a;Ya=hj[f[(f[Ra>>2]|0)+64>>2]&511](Ra,c,Za+1|0)|0}if(!(u&67108864))$a=Ya;else{Za=f[a+264>>2]|0;b[Ya>>0]=-86;b[Ya+1>>0]=2;Ra=Ya+2|0;Ya=_i[f[(f[Za>>2]|0)+60>>2]&1023](Za)|0;if(Ya>>>0>127){_a=Ya;Xa=Ra;while(1){b[Xa>>0]=_a|128;Va=_a>>>7;Pa=Xa+1|0;if(_a>>>0>16383){_a=Va;Xa=Pa}else{ab=Pa;bb=Va;break}}}else{ab=Ra;bb=Ya}b[ab>>0]=bb;$a=hj[f[(f[Za>>2]|0)+64>>2]&511](Za,c,ab+1|0)|0}if(!(u&134217728))cb=$a;else{ab=f[a+268>>2]|0;b[$a>>0]=-78;b[$a+1>>0]=2;Za=$a+2|0;$a=_i[f[(f[ab>>2]|0)+60>>2]&1023](ab)|0;if($a>>>0>127){bb=$a;Ya=Za;while(1){b[Ya>>0]=bb|128;Ra=bb>>>7;Xa=Ya+1|0;if(bb>>>0>16383){bb=Ra;Ya=Xa}else{db=Xa;eb=Ra;break}}}else{db=Za;eb=$a}b[db>>0]=eb;cb=hj[f[(f[ab>>2]|0)+64>>2]&511](ab,c,db+1|0)|0}if(!(u&268435456))fb=cb;else{db=f[a+272>>2]|0;b[cb>>0]=-70;b[cb+1>>0]=2;ab=cb+2|0;cb=_i[f[(f[db>>2]|0)+60>>2]&1023](db)|0;if(cb>>>0>127){eb=cb;$a=ab;while(1){b[$a>>0]=eb|128;Za=eb>>>7;Ya=$a+1|0;if(eb>>>0>16383){eb=Za;$a=Ya}else{gb=Ya;hb=Za;break}}}else{gb=ab;hb=cb}b[gb>>0]=hb;fb=hj[f[(f[db>>2]|0)+64>>2]&511](db,c,gb+1|0)|0}if(!(u&536870912))ib=fb;else{gb=f[a+276>>2]|0;b[fb>>0]=-62;b[fb+1>>0]=2;db=fb+2|0;fb=_i[f[(f[gb>>2]|0)+60>>2]&1023](gb)|0;if(fb>>>0>127){hb=fb;cb=db;while(1){b[cb>>0]=hb|128;ab=hb>>>7;$a=cb+1|0;if(hb>>>0>16383){hb=ab;cb=$a}else{jb=$a;kb=ab;break}}}else{jb=db;kb=fb}b[jb>>0]=kb;ib=hj[f[(f[gb>>2]|0)+64>>2]&511](gb,c,jb+1|0)|0}if(!(u&1073741824))lb=ib;else{jb=f[a+280>>2]|0;b[ib>>0]=-54;b[ib+1>>0]=2;gb=ib+2|0;ib=_i[f[(f[jb>>2]|0)+60>>2]&1023](jb)|0;if(ib>>>0>127){kb=ib;fb=gb;while(1){b[fb>>0]=kb|128;db=kb>>>7;cb=fb+1|0;if(kb>>>0>16383){kb=db;fb=cb}else{mb=cb;nb=db;break}}}else{mb=gb;nb=ib}b[mb>>0]=nb;lb=hj[f[(f[jb>>2]|0)+64>>2]&511](jb,c,mb+1|0)|0}if((u|0)<0){u=f[a+284>>2]|0;b[lb>>0]=-46;b[lb+1>>0]=2;mb=lb+2|0;jb=_i[f[(f[u>>2]|0)+60>>2]&1023](u)|0;if(jb>>>0>127){nb=jb;ib=mb;while(1){b[ib>>0]=nb|128;gb=nb>>>7;fb=ib+1|0;if(nb>>>0>16383){nb=gb;ib=fb}else{ob=fb;pb=gb;break}}}else{ob=mb;pb=jb}b[ob>>0]=pb;qb=hj[f[(f[u>>2]|0)+64>>2]&511](u,c,ob+1|0)|0}else qb=lb;lb=f[a+136>>2]|0;if((lb|0)>0){ob=a+144|0;c=0;u=qb;while(1){pb=f[(f[ob>>2]|0)+4+(c<<2)>>2]|0;b[u>>0]=-54;b[u+1>>0]=62;jb=dSb(pb,u+2|0)|0;c=c+1|0;if((c|0)==(lb|0)){rb=jb;break}else u=jb}}else rb=qb;qb=f[a+148>>2]|0;if(!qb)sb=rb;else{u=f[a+156>>2]|0;lb=0;c=rb;while(1){rb=f[u+4+(lb<<2)>>2]|0;b[c>>0]=-48;b[c+1>>0]=62;ob=c+2|0;jb=rb&255;if(rb>>>0>127){pb=ob;mb=jb;ib=rb;nb=((rb|0)<0)<<31>>31;while(1){b[pb>>0]=mb|-128;rb=ib;ib=aJc(ib|0,nb|0,7)|0;gb=pb+1|0;fb=ib&255;if(!(nb>>>0>0|(nb|0)==0&rb>>>0>16383)){tb=gb;ub=fb;break}else{pb=gb;mb=fb;nb=J}}}else{tb=ob;ub=jb}b[tb>>0]=ub;nb=tb+1|0;lb=lb+1|0;if((lb|0)>=(qb|0)){sb=nb;break}else c=nb}}c=f[a+4>>2]|0;if(!(c&1)){vb=sb;return vb|0}vb=Hjc(c&-2,sb)|0;return vb|0}function gYa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function hYa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15112,0)|0;if(!c){Ehc(b,a);return}else{kYa(a,c);return}}function iYa(a,b){a=a|0;b=b|0;f[a+292>>2]=b;return}function jYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525592;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function kYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}yNa(a+16|0,c+16|0);yNa(a+32|0,c+32|0);PLa(a+48|0,c+48|0);e=a+64|0;h=c+64|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+72>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+72>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+76|0;e=c+76|0;g=f[e>>2]|0;if(g|0){SHa(h,(f[h>>2]|0)+g|0);dJc((f[a+84>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+84>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}lYa(a+88|0,c+88|0);lYa(a+104|0,c+104|0);e=a+120|0;h=c+120|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+128>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+128>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}yNa(a+132|0,c+132|0);h=a+148|0;e=c+148|0;g=f[e>>2]|0;if(g|0){KLa(h,(f[h>>2]|0)+g|0);dJc((f[a+156>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+156>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;do if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+160|0,g=f[c+160>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+164|0;d=f[g>>2]|0;if(!d){h=VDc(196)|0;UXa(h);f[g>>2]=h;i=h}else i=d;d=f[c+164>>2]|0;iXa(i,d|0?d:524600)}if(e&4|0){d=a+8|0;f[d>>2]=f[d>>2]|4;d=a+168|0;h=f[d>>2]|0;if(!h){g=VDc(24)|0;mYa(g);f[d>>2]=g;j=g}else j=h;h=f[c+168>>2]|0;g=h|0?h:522688;h=j+4|0;d=f[g+4>>2]|0;if(d&1|0){k=f[h>>2]|0;if(!(k&1))l=mNa(h)|0;else l=k&-2;ojc(l,d&-2)}d=f[g+8>>2]|0;if(d&3|0){if(d&1|0)f[j+16>>2]=f[g+16>>2];if(d&2|0)f[j+20>>2]=f[g+20>>2];g=j+8|0;f[g>>2]=f[g>>2]|d}}if(e&8|0){d=a+8|0;f[d>>2]=f[d>>2]|8;d=a+172|0;g=f[d>>2]|0;if(!g){k=VDc(120)|0;nYa(k);f[d>>2]=k;m=k}else m=g;g=f[c+172>>2]|0;oYa(m,g|0?g:522800)}if(e&16|0){g=a+8|0;f[g>>2]=f[g>>2]|16;g=a+176|0;k=f[g>>2]|0;if(!k){d=VDc(52)|0;pYa(d);f[g>>2]=d;n=d}else n=k;k=f[c+176>>2]|0;qYa(n,k|0?k:522952)}if(e&32|0){k=a+8|0;f[k>>2]=f[k>>2]|32;k=a+180|0;d=f[k>>2]|0;if(!d){g=VDc(24)|0;rYa(g);f[k>>2]=g;o=g}else o=d;d=f[c+180>>2]|0;g=d|0?d:523080;d=o+4|0;k=f[g+4>>2]|0;if(k&1|0){h=f[d>>2]|0;if(!(h&1))p=mNa(d)|0;else p=h&-2;ojc(p,k&-2)}k=f[g+8>>2]|0;if(k&3|0){if(k&1|0)f[o+16>>2]=f[g+16>>2];if(k&2|0)b[o+20>>0]=b[g+20>>0]|0;g=o+8|0;f[g>>2]=f[g>>2]|k}}if(e&64|0){k=a+8|0;f[k>>2]=f[k>>2]|64;k=a+184|0;g=f[k>>2]|0;if(!g){h=VDc(28)|0;sYa(h);f[k>>2]=h;q=h}else q=g;g=f[c+184>>2]|0;tYa(q,g|0?g:523360)}if(e&128|0){g=a+8|0;f[g>>2]=f[g>>2]|128;g=a+188|0;h=f[g>>2]|0;if(!h){k=VDc(20)|0;jXa(k);f[g>>2]=k;r=k}else r=h;h=f[c+188>>2]|0;k=h|0?h:523392;h=r+4|0;g=f[k+4>>2]|0;if(g&1|0){d=f[h>>2]|0;if(!(d&1))s=mNa(h)|0;else s=d&-2;ojc(s,g&-2)}if(f[k+8>>2]&1|0?(g=r+8|0,f[g>>2]=f[g>>2]|1,g=r+16|0,d=f[k+16>>2]|0,k=f[g>>2]|0,(k|0)!=(d|0)):0)if((k|0)==527320){GLa(g,d);break}else{iEc(k,d)|0;break}}}while(0);if(e&65280|0){if(e&256|0){r=a+8|0;f[r>>2]=f[r>>2]|256;r=a+192|0;s=f[r>>2]|0;if(!s){q=VDc(60)|0;uYa(q);f[r>>2]=q;t=q}else t=s;s=f[c+192>>2]|0;vYa(t,s|0?s:523440)}do if(e&512|0){s=a+8|0;f[s>>2]=f[s>>2]|512;s=a+196|0;t=f[s>>2]|0;if(!t){q=VDc(20)|0;wYa(q);f[s>>2]=q;u=q}else u=t;t=f[c+196>>2]|0;q=t|0?t:523504;t=u+4|0;s=f[q+4>>2]|0;if(s&1|0){r=f[t>>2]|0;if(!(r&1))v=mNa(t)|0;else v=r&-2;ojc(v,s&-2)}if(f[q+8>>2]&1|0?(s=u+8|0,f[s>>2]=f[s>>2]|1,s=u+16|0,r=f[q+16>>2]|0,q=f[s>>2]|0,(q|0)!=(r|0)):0)if((q|0)==527320){GLa(s,r);break}else{iEc(q,r)|0;break}}while(0);if(e&1024|0){u=a+8|0;f[u>>2]=f[u>>2]|1024;u=a+200|0;v=f[u>>2]|0;if(!v){r=VDc(36)|0;xYa(r);f[u>>2]=r;w=r}else w=v;v=f[c+200>>2]|0;yYa(w,v|0?v:523528)}if(e&2048|0){v=a+8|0;f[v>>2]=f[v>>2]|2048;v=a+204|0;w=f[v>>2]|0;if(!w){r=VDc(40)|0;zYa(r);f[v>>2]=r;x=r}else x=w;w=f[c+204>>2]|0;AYa(x,w|0?w:523632)}if(e&4096|0){w=a+8|0;f[w>>2]=f[w>>2]|4096;w=a+208|0;x=f[w>>2]|0;if(!x){r=VDc(68)|0;BYa(r);f[w>>2]=r;y=r}else y=x;x=f[c+208>>2]|0;CYa(y,x|0?x:523752)}if(e&8192|0){x=a+8|0;f[x>>2]=f[x>>2]|8192;x=a+212|0;y=f[x>>2]|0;if(!y){r=VDc(64)|0;DYa(r);f[x>>2]=r;z=r}else z=y;y=f[c+212>>2]|0;EYa(z,y|0?y:524208)}if(e&16384|0){y=a+8|0;f[y>>2]=f[y>>2]|16384;y=a+216|0;z=f[y>>2]|0;if(!z){r=VDc(28)|0;FYa(r);f[y>>2]=r;A=r}else A=z;z=f[c+216>>2]|0;r=z|0?z:523824;z=A+4|0;y=f[r+4>>2]|0;if(y&1|0){x=f[z>>2]|0;if(!(x&1))B=mNa(z)|0;else B=x&-2;ojc(B,y&-2)}y=f[r+8>>2]|0;if(y&7|0){if(y&1|0)f[A+16>>2]=f[r+16>>2];if(y&2|0)f[A+20>>2]=f[r+20>>2];if(y&4|0)f[A+24>>2]=f[r+24>>2];r=A+8|0;f[r>>2]=f[r>>2]|y}}if(e&32768|0){y=a+8|0;f[y>>2]=f[y>>2]|32768;y=a+220|0;r=f[y>>2]|0;if(!r){A=VDc(32)|0;GYa(A);f[y>>2]=A;C=A}else C=r;r=f[c+220>>2]|0;A=r|0?r:523672;r=C+4|0;y=f[A+4>>2]|0;if(y&1|0){B=f[r>>2]|0;if(!(B&1))D=mNa(r)|0;else D=B&-2;ojc(D,y&-2)}y=f[A+8>>2]|0;if(y&15|0){if(y&1|0)f[C+16>>2]=f[A+16>>2];if(y&2|0)f[C+20>>2]=f[A+20>>2];if(y&4|0)f[C+24>>2]=f[A+24>>2];if(y&8|0)f[C+28>>2]=f[A+28>>2];A=C+8|0;f[A>>2]=f[A>>2]|y}}}if(e&16711680|0){if(e&65536|0){y=a+8|0;f[y>>2]=f[y>>2]|65536;y=a+224|0;A=f[y>>2]|0;if(!A){C=VDc(28)|0;HYa(C);f[y>>2]=C;E=C}else E=A;A=f[c+224>>2]|0;C=A|0?A:522656;A=E+4|0;y=f[C+4>>2]|0;if(y&1|0){D=f[A>>2]|0;if(!(D&1))F=mNa(A)|0;else F=D&-2;ojc(F,y&-2)}y=f[C+8>>2]|0;if(y&7|0){if(y&1|0)b[E+16>>0]=b[C+16>>0]|0;if(y&2|0)f[E+20>>2]=f[C+20>>2];if(y&4|0)f[E+24>>2]=f[C+24>>2];C=E+8|0;f[C>>2]=f[C>>2]|y}}if(e&131072|0){y=a+8|0;f[y>>2]=f[y>>2]|131072;y=a+228|0;C=f[y>>2]|0;if(!C){E=VDc(36)|0;IYa(E);f[y>>2]=E;G=E}else G=C;C=f[c+228>>2]|0;JYa(G,C|0?C:523200)}if(e&262144|0){C=a+8|0;f[C>>2]=f[C>>2]|262144;C=a+232|0;G=f[C>>2]|0;if(!G){E=VDc(20)|0;KYa(E);f[C>>2]=E;H=E}else H=G;G=f[c+232>>2]|0;E=G|0?G:524184;G=H+4|0;C=f[E+4>>2]|0;if(C&1|0){y=f[G>>2]|0;if(!(y&1))I=mNa(G)|0;else I=y&-2;ojc(I,C&-2)}if(f[E+8>>2]&1|0){C=f[E+16>>2]|0;E=H+8|0;f[E>>2]=f[E>>2]|1;f[H+16>>2]=C}}if(e&524288|0){C=a+8|0;f[C>>2]=f[C>>2]|524288;C=a+236|0;H=f[C>>2]|0;if(!H){E=VDc(96)|0;LYa(E);f[C>>2]=E;J=E}else J=H;H=f[c+236>>2]|0;MYa(J,H|0?H:523104)}if(e&1048576|0){H=a+8|0;f[H>>2]=f[H>>2]|1048576;H=a+240|0;J=f[H>>2]|0;if(!J){E=VDc(28)|0;NYa(E);f[H>>2]=E;K=E}else K=J;J=f[c+240>>2]|0;E=J|0?J:522624;J=K+4|0;H=f[E+4>>2]|0;if(H&1|0){C=f[J>>2]|0;if(!(C&1))L=mNa(J)|0;else L=C&-2;ojc(L,H&-2)}H=f[E+8>>2]|0;if(H&7|0){if(H&1|0)f[K+16>>2]=f[E+16>>2];if(H&2|0)f[K+20>>2]=f[E+20>>2];if(H&4|0)f[K+24>>2]=f[E+24>>2];E=K+8|0;f[E>>2]=f[E>>2]|H}}if(e&2097152|0){H=a+8|0;f[H>>2]=f[H>>2]|2097152;H=a+244|0;E=f[H>>2]|0;if(!E){K=VDc(20)|0;OYa(K);f[H>>2]=K;M=K}else M=E;E=f[c+244>>2]|0;K=E|0?E:523416;E=M+4|0;H=f[K+4>>2]|0;if(H&1|0){L=f[E>>2]|0;if(!(L&1))N=mNa(E)|0;else N=L&-2;ojc(N,H&-2)}if(f[K+8>>2]&1|0){H=f[K+16>>2]|0;K=M+8|0;f[K>>2]=f[K>>2]|1;f[M+16>>2]=H}}if(e&4194304|0){H=a+8|0;f[H>>2]=f[H>>2]|4194304;H=a+248|0;M=f[H>>2]|0;if(!M){K=VDc(24)|0;PYa(K);f[H>>2]=K;O=K}else O=M;M=f[c+248>>2]|0;K=M|0?M:523952;M=O+4|0;H=f[K+4>>2]|0;if(H&1|0){N=f[M>>2]|0;if(!(N&1))P=mNa(M)|0;else P=N&-2;ojc(P,H&-2)}H=f[K+8>>2]|0;if(H&3|0){if(H&1|0)f[O+16>>2]=f[K+16>>2];if(H&2|0)f[O+20>>2]=f[K+20>>2];K=O+8|0;f[K>>2]=f[K>>2]|H}}if(e&8388608|0){H=a+8|0;f[H>>2]=f[H>>2]|8388608;H=a+252|0;K=f[H>>2]|0;if(!K){O=VDc(36)|0;QYa(O);f[H>>2]=O;Q=O}else Q=K;K=f[c+252>>2]|0;RYa(Q,K|0?K:524072)}}do if(e>>>0>16777215){if(e&16777216|0){K=a+8|0;f[K>>2]=f[K>>2]|16777216;K=a+256|0;Q=f[K>>2]|0;if(!Q){O=VDc(24)|0;SYa(O);f[K>>2]=O;R=O}else R=Q;Q=f[c+256>>2]|0;O=Q|0?Q:523704;Q=R+4|0;K=f[O+4>>2]|0;if(K&1|0){H=f[Q>>2]|0;if(!(H&1))S=mNa(Q)|0;else S=H&-2;ojc(S,K&-2)}K=f[O+8>>2]|0;if(K&7|0){if(K&1|0)b[R+16>>0]=b[O+16>>0]|0;if(K&2|0)b[R+17>>0]=b[O+17>>0]|0;if(K&4|0)f[R+20>>2]=f[O+20>>2];O=R+8|0;f[O>>2]=f[O>>2]|K}}if(e&33554432|0){K=a+8|0;f[K>>2]=f[K>>2]|33554432;K=a+260|0;O=f[K>>2]|0;if(!O){H=VDc(44)|0;TYa(H);f[K>>2]=H;T=H}else T=O;O=f[c+260>>2]|0;UYa(T,O|0?O:522544)}if(e&67108864|0){O=a+8|0;f[O>>2]=f[O>>2]|67108864;O=a+264|0;H=f[O>>2]|0;if(!H){K=VDc(20)|0;VYa(K);f[O>>2]=K;U=K}else U=H;H=f[c+264>>2]|0;K=H|0?H:524136;H=U+4|0;O=f[K+4>>2]|0;if(O&1|0){Q=f[H>>2]|0;if(!(Q&1))V=mNa(H)|0;else V=Q&-2;ojc(V,O&-2)}if(f[K+8>>2]&1|0){O=f[K+16>>2]|0;K=U+8|0;f[K>>2]=f[K>>2]|1;f[U+16>>2]=O}}if(e&134217728|0){O=a+8|0;f[O>>2]=f[O>>2]|134217728;O=a+268|0;K=f[O>>2]|0;if(!K){Q=VDc(20)|0;WYa(Q);f[O>>2]=Q;W=Q}else W=K;K=f[c+268>>2]|0;Q=K|0?K:524048;K=W+4|0;O=f[Q+4>>2]|0;if(O&1|0){H=f[K>>2]|0;if(!(H&1))X=mNa(K)|0;else X=H&-2;ojc(X,O&-2)}if(f[Q+8>>2]&1|0){O=f[Q+16>>2]|0;Q=W+8|0;f[Q>>2]=f[Q>>2]|1;f[W+16>>2]=O}}if(e&268435456|0){O=a+8|0;f[O>>2]=f[O>>2]|268435456;O=a+272|0;Q=f[O>>2]|0;if(!Q){H=VDc(24)|0;XYa(H);f[O>>2]=H;Y=H}else Y=Q;Q=f[c+272>>2]|0;H=Q|0?Q:524112;Q=Y+4|0;O=f[H+4>>2]|0;if(O&1|0){K=f[Q>>2]|0;if(!(K&1))Z=mNa(Q)|0;else Z=K&-2;ojc(Z,O&-2)}O=f[H+8>>2]|0;if(O&3|0){if(O&1|0)f[Y+16>>2]=f[H+16>>2];if(O&2|0)f[Y+20>>2]=f[H+20>>2];H=Y+8|0;f[H>>2]=f[H>>2]|O}}if(e&536870912|0){O=a+8|0;f[O>>2]=f[O>>2]|536870912;O=a+276|0;H=f[O>>2]|0;if(!H){K=VDc(24)|0;YYa(K);f[O>>2]=K;_=K}else _=H;H=f[c+276>>2]|0;K=H|0?H:522776;H=_+4|0;O=f[K+4>>2]|0;if(O&1|0){Q=f[H>>2]|0;if(!(Q&1))$=mNa(H)|0;else $=Q&-2;ojc($,O&-2)}O=f[K+8>>2]|0;if(O&3|0){if(O&1|0)b[_+16>>0]=b[K+16>>0]|0;if(O&2|0)f[_+20>>2]=f[K+20>>2];K=_+8|0;f[K>>2]=f[K>>2]|O}}do if(e&1073741824|0){O=a+8|0;f[O>>2]=f[O>>2]|1073741824;O=a+280|0;K=f[O>>2]|0;if(!K){Q=VDc(28)|0;ZYa(Q);f[O>>2]=Q;aa=Q}else aa=K;K=f[c+280>>2]|0;Q=K|0?K:523304;K=aa+4|0;O=f[Q+4>>2]|0;if(O&1|0){H=f[K>>2]|0;if(!(H&1))ba=mNa(K)|0;else ba=H&-2;ojc(ba,O&-2)}O=f[Q+8>>2]|0;if(!(O&7))break;if(O&1|0)f[aa+16>>2]=f[Q+16>>2];if(O&2|0)f[aa+20>>2]=f[Q+20>>2];if(O&4|0)f[aa+24>>2]=f[Q+24>>2];Q=aa+8|0;f[Q>>2]=f[Q>>2]|O}while(0);if((e|0)<0){O=a+8|0;f[O>>2]=f[O>>2]|-2147483648;O=a+284|0;Q=f[O>>2]|0;if(!Q){H=VDc(28)|0;_Ya(H);f[O>>2]=H;ca=H}else ca=Q;Q=f[c+284>>2]|0;H=Q|0?Q:522592;Q=ca+4|0;O=f[H+4>>2]|0;if(O&1|0){K=f[Q>>2]|0;if(!(K&1))da=mNa(Q)|0;else da=K&-2;ojc(da,O&-2)}O=f[H+8>>2]|0;if(!(O&7))break;if(O&1|0)f[ca+16>>2]=f[H+16>>2];if(O&2|0)b[ca+20>>0]=b[H+20>>0]|0;if(O&4|0)f[ca+24>>2]=f[H+24>>2];H=ca+8|0;f[H>>2]=f[H>>2]|O}}while(0);if(!(f[c+12>>2]&1))return;ca=f[c+288>>2]|0;c=a+12|0;f[c>>2]=f[c>>2]|1;f[a+288>>2]=ca;return}function lYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Q5a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(60)|0;P5a(l);Q5a(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,15592,64);l=NQb(i,64,1741)|0;P5a(l);Q5a(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function mYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92120;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522688?(f[220383]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=46;b[d+8>>0]=0;DTb(881532,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=1;f[a+20>>2]=1;u=c;return}function nYa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=92012;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==522800;g=a+16|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220387]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=50;b[d+8>>0]=0;DTb(881548,d);ZSb(d)}f[a+12>>2]=0;d=a+64|0;g=d;h=g+40|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));b[d+40>>0]=0;f[a+108>>2]=1;b[a+112>>0]=1;f[a+116>>2]=1;u=c;return}function oYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){OLa(e,(f[e>>2]|0)+g|0);dJc((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+28|0;e=c+28|0;g=f[e>>2]|0;if(g|0){OLa(h,(f[h>>2]|0)+g|0);dJc((f[a+36>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+36>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+40|0;h=c+40|0;g=f[h>>2]|0;if(g|0){OLa(e,(f[e>>2]|0)+g|0);dJc((f[a+48>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+48>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+52|0;e=c+52|0;g=f[e>>2]|0;if(g|0){OLa(h,(f[h>>2]|0)+g|0);dJc((f[a+60>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+60>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;if(e&255|0){if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+64|0;g=f[h>>2]|0;if(!g){d=VDc(48)|0;BWa(d);f[h>>2]=d;i=d}else i=g;g=f[c+64>>2]|0;CWa(i,g|0?g:521608)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+68|0;i=f[g>>2]|0;if(!i){d=VDc(48)|0;BWa(d);f[g>>2]=d;j=d}else j=i;i=f[c+68>>2]|0;CWa(j,i|0?i:521608)}if(e&4|0)f[a+72>>2]=f[c+72>>2];if(e&8|0)f[a+76>>2]=f[c+76>>2];if(e&16|0)f[a+80>>2]=f[c+80>>2];if(e&32|0)f[a+84>>2]=f[c+84>>2];if(e&64|0)f[a+88>>2]=f[c+88>>2];if(e&128|0)f[a+92>>2]=f[c+92>>2];i=a+8|0;f[i>>2]=f[i>>2]|e}if(!(e&16128))return;if(e&256|0)f[a+96>>2]=f[c+96>>2];if(e&512|0)f[a+100>>2]=f[c+100>>2];if(e&1024|0)b[a+104>>0]=b[c+104>>0]|0;if(e&2048|0)f[a+108>>2]=f[c+108>>2];if(e&4096|0)b[a+112>>0]=b[c+112>>0]|0;if(e&8192|0)f[a+116>>2]=f[c+116>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function pYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91904;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522952?(f[220389]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=52;b[d+8>>0]=0;DTb(881556,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;n[a+44>>2]=1.0;f[a+48>>2]=4;u=c;return}function qYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+20|0,d=f[c+20>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==527320){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)b[a+36>>0]=b[c+36>>0]|0;if(e&64|0)b[a+37>>0]=b[c+37>>0]|0;if(e&128|0)f[a+40>>2]=f[c+40>>2];d=a+8|0;f[d>>2]=f[d>>2]|e}if(!(e&768))return;if(e&256|0)f[a+44>>2]=f[c+44>>2];if(e&512|0)f[a+48>>2]=f[c+48>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function rYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91796;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523080?(f[220392]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=55;b[d+8>>0]=0;DTb(881568,d);ZSb(d)}f[a+12>>2]=0;n[a+16>>2]=.5;b[a+20>>0]=1;u=c;return}function sYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91688;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523360?(f[220399]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=62;b[d+8>>0]=0;DTb(881596,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;d=a+20|0;f[d>>2]=0;b[d+4>>0]=0;u=c;return}function tYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&7))return;do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);if(e&2|0)f[a+20>>2]=f[c+20>>2];if(e&4|0)b[a+24>>0]=b[c+24>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function uYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91580;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523440?(f[220402]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=65;b[d+8>>0]=0;DTb(881608,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;d=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;b[a+48>>0]=1;n[a+52>>2]=1.0;f[a+56>>2]=1;u=c;return}function vYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+20|0,d=f[c+20>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==527320){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+24|0,h=f[c+24>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==527320){GLa(d,h);break}else{iEc(g,h)|0;break}while(0);if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)b[a+36>>0]=b[c+36>>0]|0;if(e&64|0)b[a+37>>0]=b[c+37>>0]|0;if(e&128|0)f[a+40>>2]=f[c+40>>2];h=a+8|0;f[h>>2]=f[h>>2]|e}if(!(e&3840))return;if(e&256|0)f[a+44>>2]=f[c+44>>2];if(e&512|0)b[a+48>>0]=b[c+48>>0]|0;if(e&1024|0)f[a+52>>2]=f[c+52>>2];if(e&2048|0)f[a+56>>2]=f[c+56>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function wYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91472;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523504?(f[220403]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=66;b[d+8>>0]=0;DTb(881612,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;u=c;return}function xYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91364;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523528?(f[220404]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=67;b[d+8>>0]=0;DTb(881616,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;b[d+16>>0]=0;b[a+29>>0]=1;f[a+32>>2]=1;u=c;return}function yYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&63))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=VDc(48)|0;BWa(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;CWa(i,g|0?g:521608)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[g>>2]|0;if(!i){d=VDc(48)|0;BWa(d);f[g>>2]=d;j=d}else j=i;i=f[c+20>>2]|0;CWa(j,i|0?i:521608)}if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)b[a+28>>0]=b[c+28>>0]|0;if(e&16|0)b[a+29>>0]=b[c+29>>0]|0;if(e&32|0)f[a+32>>2]=f[c+32>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function zYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91256;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523632?(f[220407]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=70;b[d+8>>0]=0;DTb(881628,d);ZSb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=5;n[a+28>>2]=1.0;n[a+32>>2]=.75;n[a+36>>2]=1.0;u=c;return}function AYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&63))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];if(d&8|0)f[a+28>>2]=f[b+28>>2];if(d&16|0)f[a+32>>2]=f[b+32>>2];if(d&32|0)f[a+36>>2]=f[b+36>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function BYa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=91148;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523752?(f[220411]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=74;b[d+8>>0]=0;DTb(881644,d);ZSb(d)}d=a+12|0;e=a+60|0;g=d;h=g+44|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));b[d+44>>0]=0;f[e>>2]=1;b[a+64>>0]=1;u=c;return}function CYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){if(e&1|0)f[a+16>>2]=f[c+16>>2];if(e&2|0)f[a+20>>2]=f[c+20>>2];if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)f[a+36>>2]=f[c+36>>2];if(e&64|0)f[a+40>>2]=f[c+40>>2];if(e&128|0)f[a+44>>2]=f[c+44>>2];h=a+8|0;f[h>>2]=f[h>>2]|e}if(!(e&7936))return;if(e&256|0)f[a+48>>2]=f[c+48>>2];if(e&512|0)f[a+52>>2]=f[c+52>>2];if(e&1024|0)b[a+56>>0]=b[c+56>>0]|0;if(e&2048|0)f[a+60>>2]=f[c+60>>2];if(e&4096|0)b[a+64>>0]=b[c+64>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function DYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91040;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524208?(f[220425]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=88;b[d+8>>0]=0;DTb(881700,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=525048;f[a+28>>2]=527320;d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;n[a+48>>2]=1.0;n[a+52>>2]=.5;n[a+56>>2]=.5;n[a+60>>2]=.25;u=c;return}function EYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+20|0,d=f[c+20>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==527320){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+24|0,h=f[c+24>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==525048){GLa(d,h);break}else{iEc(g,h)|0;break}while(0);do if(e&8|0?(h=a+8|0,f[h>>2]=f[h>>2]|8,h=a+28|0,g=f[c+28>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)f[a+36>>2]=f[c+36>>2];if(e&64|0)b[a+40>>0]=b[c+40>>0]|0;if(e&128|0)b[a+41>>0]=b[c+41>>0]|0;g=a+8|0;f[g>>2]=f[g>>2]|e}if(!(e&7936))return;if(e&256|0)f[a+44>>2]=f[c+44>>2];if(e&512|0)f[a+48>>2]=f[c+48>>2];if(e&1024|0)f[a+52>>2]=f[c+52>>2];if(e&2048|0)f[a+56>>2]=f[c+56>>2];if(e&4096|0)f[a+60>>2]=f[c+60>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function FYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90932;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523824?(f[220412]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=75;b[d+8>>0]=0;DTb(881648,d);ZSb(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=1.0;n[a+24>>2]=1.0;u=c;return}function GYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90824;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523672?(f[220408]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=71;b[d+8>>0]=0;DTb(881632,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;u=c;return}function HYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90716;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522656?(f[220382]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=45;b[d+8>>0]=0;DTb(881528,d);ZSb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=1;u=c;return}function IYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90608;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=523200?(f[220394]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=57;b[d+8>>0]=0;DTb(881576,d);ZSb(d)}f[a+12>>2]=0;f[a+28>>2]=1;b[a+32>>0]=1;u=c;return}function JYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=f[c+8>>2]|0;if(!(h&3))return;if(h&1|0)f[a+28>>2]=f[c+28>>2];if(h&2|0)b[a+32>>0]=b[c+32>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|h;return}function KYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90500;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524184?(f[220424]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=87;b[d+8>>0]=0;DTb(881696,d);ZSb(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;u=c;return}function LYa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=90392;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==523104;g=a+16|0;h=g+80|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220393]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=56;b[d+8>>0]=0;DTb(881572,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function MYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}E0a(a+16|0,b+16|0);d=a+32|0;g=b+32|0;e=f[g>>2]|0;if(e|0){OLa(d,(f[d>>2]|0)+e|0);dJc((f[a+40>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+44|0;d=b+44|0;e=f[d>>2]|0;if(e|0){OLa(g,(f[g>>2]|0)+e|0);dJc((f[a+52>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+52>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+56|0;g=b+56|0;e=f[g>>2]|0;if(e|0){OLa(d,(f[d>>2]|0)+e|0);dJc((f[a+64>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+64>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+68|0;d=b+68|0;e=f[d>>2]|0;if(!e){h=a+80|0;i=b+80|0;F0a(h,i);return}OLa(g,(f[g>>2]|0)+e|0);dJc((f[a+76>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+76>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0);h=a+80|0;i=b+80|0;F0a(h,i);return}function NYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90284;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522624?(f[220381]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=44;b[d+8>>0]=0;DTb(881524,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1;u=c;return}function OYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90176;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523416?(f[220401]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=64;b[d+8>>0]=0;DTb(881604,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=1;u=c;return}function PYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90068;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523952?(f[220416]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=79;b[d+8>>0]=0;DTb(881664,d);ZSb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function QYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=89960;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=524072?(f[220420]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=83;b[d+8>>0]=0;DTb(881680,d);ZSb(d)}f[a+12>>2]=0;f[a+28>>2]=1;f[a+32>>2]=1;u=c;return}function RYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){OLa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=f[b+8>>2]|0;if(!(g&3))return;if(g&1|0)f[a+28>>2]=f[b+28>>2];if(g&2|0)f[a+32>>2]=f[b+32>>2];b=a+8|0;f[b>>2]=f[b>>2]|g;return}function SYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=89852;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523704?(f[220409]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=72;b[d+8>>0]=0;DTb(881636,d);ZSb(d)}f[a+12>>2]=0;b[a+16>>0]=0;b[a+17>>0]=1;n[a+20>>2]=9.999999717180685e-10;u=c;return}function TYa(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=89744;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=522544?(f[220379]|0)!=2:0){f[e>>2]=161028;f[e+4>>2]=42;b[e+8>>0]=0;DTb(881516,e);ZSb(e)}f[a+12>>2]=0;f[a+28>>2]=527320;e=a+32|0;f[e>>2]=0;d[e+4>>1]=0;b[e+6>>0]=0;n[a+40>>2]=1.0;u=c;return}function UYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=f[c+8>>2]|0;if(!(h&63))return;do if(h&1|0?(e=a+8|0,f[e>>2]=f[e>>2]|1,e=a+28|0,g=f[c+28>>2]|0,d=f[e>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(e,g);break}else{iEc(d,g)|0;break}while(0);if(h&2|0)f[a+32>>2]=f[c+32>>2];if(h&4|0)b[a+36>>0]=b[c+36>>0]|0;if(h&8|0)b[a+37>>0]=b[c+37>>0]|0;if(h&16|0)b[a+38>>0]=b[c+38>>0]|0;if(h&32|0)f[a+40>>2]=f[c+40>>2];c=a+8|0;f[c>>2]=f[c>>2]|h;return}function VYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=89636;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524136?(f[220422]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=85;b[d+8>>0]=0;DTb(881688,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function WYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=89528;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524048?(f[220419]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=82;b[d+8>>0]=0;DTb(881676,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function XYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=89420;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524112?(f[220421]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=84;b[d+8>>0]=0;DTb(881684,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;u=c;return}function YYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=89312;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522776?(f[220386]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=49;b[d+8>>0]=0;DTb(881544,d);ZSb(d)}f[a+12>>2]=0;b[a+16>>0]=0;n[a+20>>2]=1.0;u=c;return}function ZYa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=89204;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523304?(f[220397]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=60;b[d+8>>0]=0;DTb(881588,d);ZSb(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0;u=c;return}function _Ya(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=89096;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522592?(f[220380]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=43;b[d+8>>0]=0;DTb(881520,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+24>>2]=1;u=c;return}function $Ya(a){a=a|0;var b=0,c=0;f[a>>2]=89096;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function aZa(a){a=a|0;var b=0,c=0;f[a>>2]=89096;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function bZa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function cZa(a,b){a=a|0;b=b|0;a=VDc(28)|0;_Ya(a);if(!b)return a|0;oZa(b,a);return a|0}function dZa(a){a=a|0;var c=0,d=0;c=a+8|0;if(f[c>>2]&7|0){d=a+16|0;f[d>>2]=0;b[d+4>>0]=0;f[a+24>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function eZa(a){a=a|0;return 1}function fZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+20|0;k=e+8|0;l=a+4|0;m=a+24|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=7}else{r=o;q=6}}else{r=0;q=6}if((q|0)==6){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=7}else s=o}c:do if((q|0)==7){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break c}f[h>>2]=f[h>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[c>>2]=o+1;t=n}else{v=n;q=12}}else{v=0;q=12}if((q|0)==12){q=0;n=HRb(c,v)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)t=n;else{w=0;q=36;break a}}f[i>>2]=t;continue b;break}case 2:{if((p&255|0)!=16){s=p;break c}f[h>>2]=f[h>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;x=o<<24>>24!=0}else{IRb(e,c);o=e;if(!(b[k>>0]|0)){w=0;q=36;break a}else x=(f[o>>2]|0)!=0|(f[o+4>>2]|0)!=0}b[j>>0]=x&1;continue b;break}case 3:{if((p&255|0)==24)break b;else{s=p;break c}break}default:{s=p;break c}}}while(0);if(!s){w=1;q=36;break a}o=f[l>>2]|0;if(!(o&1))y=mNa(l)|0;else y=o&-2;if(!(Djc(c,s,y)|0)){w=0;q=36;break a}}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){n=b[o>>0]|0;a=n&255;if(n<<24>>24>-1){f[c>>2]=o+1;z=a}else{A=a;q=24}}else{A=0;q=24}if((q|0)==24){q=0;a=HRb(c,A)|0;o=J;if((o|0)>-1|(o|0)==-1&a>>>0>4294967295)z=a;else{w=0;q=36;break}}if(z>>>0<4){f[h>>2]=f[h>>2]|4;f[m>>2]=z;continue}a=f[l>>2]|0;if(!(a&1))B=mNa(l)|0;else B=a&-2;rjc(B,3,z,((z|0)<0)<<31>>31)}if((q|0)==36){u=d;return w|0}return 0}function gZa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}c=b&2|0?g+2|0:g;if(!(b&4)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+24>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+c|0;e=a+12|0;f[e>>2]=d;return d|0}function hZa(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)MTb(1,f[a+16>>2]|0,c);if(d&2|0)YTb(2,(b[a+20>>0]|0)!=0,c);if(d&4|0)ZTb(3,f[a+24>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function iZa(a){a=a|0;return f[a+12>>2]|0}function jZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{o=b[a+20>>0]|0;b[e>>0]=16;b[e+1>>0]=o;q=e+2|0}if(!(c&4))r=q;else{c=f[a+24>>2]|0;b[q>>0]=24;e=q+1|0;q=c&255;if(c>>>0>127){o=e;p=q;d=c;h=((c|0)<0)<<31>>31;while(1){b[o>>0]=p|-128;c=d;d=aJc(d|0,h|0,7)|0;l=o+1|0;j=d&255;if(!(h>>>0>0|(h|0)==0&c>>>0>16383)){s=l;t=j;break}else{o=l;p=j;h=J}}}else{s=e;t=q}b[s>>0]=t;r=s+1|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=Hjc(s&-2,r)|0;return u|0}function kZa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function lZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,15128,0)|0;if(!d){Ehc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&7))return;if(e&1|0)f[a+16>>2]=f[d+16>>2];if(e&2|0)b[a+20>>0]=b[d+20>>0]|0;if(e&4|0)f[a+24>>2]=f[d+24>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function mZa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function nZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525216;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function oZa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function pZa(a){a=a|0;var b=0,c=0;f[a>>2]=89204;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function qZa(a){a=a|0;var b=0,c=0;f[a>>2]=89204;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function rZa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function sZa(a,b){a=a|0;b=b|0;a=VDc(28)|0;ZYa(a);if(!b)return a|0;EZa(b,a);return a|0}function tZa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function uZa(a){a=a|0;return 1}function vZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+24|0;l=a+16|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(TRb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=21){s=p;break b}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){o=n;a=h[o>>0]|h[o+1>>0]<<8|h[o+2>>0]<<16|h[o+3>>0]<<24;f[e>>2]=a;f[c>>2]=n+4;v=a}else{if(!(TRb(c,e)|0)){q=20;break a}v=f[e>>2]|0}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;w=o}else{if(!(TRb(c,e)|0)){q=27;break a}w=f[e>>2]|0}f[l>>2]=w;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=33;break}o=f[m>>2]|0;if(!(o&1))y=mNa(m)|0;else y=o&-2;if(!(Djc(c,s,y)|0)){x=0;q=33;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==20){x=0;u=d;return x|0}else if((q|0)==27){x=0;u=d;return x|0}else if((q|0)==33){u=d;return x|0}return 0}function wZa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;c=b&2|0?g+5|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function xZa(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)WTb(1,+n[a+20>>2],b);if(c&4|0)WTb(2,+n[a+24>>2],b);if(c&1|0)WTb(3,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function yZa(a){a=a|0;return f[a+12>>2]|0}function zZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&4))i=e;else{d=f[a+24>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}if(!(c&1))j=i;else{c=f[a+16>>2]|0;b[i>>0]=29;e=i+1|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;j=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Hjc(i&-2,j)|0;return k|0}function AZa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function BZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15144,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function CZa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function DZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525352;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function EZa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function FZa(a){a=a|0;var b=0,c=0;f[a>>2]=89312;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function GZa(a){a=a|0;var b=0,c=0;f[a>>2]=89312;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function HZa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function IZa(a,b){a=a|0;b=b|0;a=VDc(24)|0;YYa(a);if(!b)return a|0;UZa(b,a);return a|0}function JZa(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&3|0){b[a+16>>0]=0;n[a+20>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function KZa(a){a=a|0;return 1}function LZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+16|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(TRb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|1;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;v=o<<24>>24!=0}else{IRb(e,c);o=e;if(!(b[l>>0]|0)){w=0;q=25;break a}else v=(f[o>>2]|0)!=0|(f[o+4>>2]|0)!=0}b[k>>0]=v&1;continue a;break}default:{s=p;break b}}}while(0);if(!s){w=1;q=25;break}o=f[m>>2]|0;if(!(o&1))x=mNa(m)|0;else x=o&-2;if(!(Djc(c,s,x)|0)){w=0;q=25;break}}if((q|0)==13){w=0;u=d;return w|0}else if((q|0)==25){u=d;return w|0}return 0}function MZa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+2|0:c;d=b&2|0?g+5|0:g;e=a+12|0;f[e>>2]=d;return d|0}function NZa(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&2|0)WTb(1,+n[a+20>>2],c);if(d&1|0)YTb(2,(b[a+16>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function OZa(a){a=a|0;return f[a+12>>2]|0}function PZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&1))i=e;else{c=b[a+16>>0]|0;b[e>>0]=16;b[e+1>>0]=c;i=e+2|0}e=f[a+4>>2]|0;if(!(e&1)){j=i;return j|0}j=Hjc(e&-2,i)|0;return j|0}function QZa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function RZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,15160,0)|0;if(!d){Ehc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&3))return;if(e&1|0)b[a+16>>0]=b[d+16>>0]|0;if(e&2|0)f[a+20>>2]=f[d+20>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function SZa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function TZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525264;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function UZa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function VZa(a){a=a|0;var b=0,c=0;f[a>>2]=89420;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function WZa(a){a=a|0;var b=0,c=0;f[a>>2]=89420;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function XZa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function YZa(a,b){a=a|0;b=b|0;a=VDc(24)|0;XYa(a);if(!b)return a|0;i_a(b,a);return a|0}function ZZa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=0;f[a+20>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function _Za(a){a=a|0;return 1}function $Za(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=c+4|0;e=a+8|0;g=a+20|0;h=a+4|0;i=a+16|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=7}else{n=k;m=6}}else{n=0;m=6}if((m|0)==6){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=7}else o=k}c:do if((m|0)==7){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)==8)break b;else{o=l;break c}break}case 2:break;default:{o=l;break c}}if((l&255|0)==16){f[e>>2]=f[e>>2]|2;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=23}}else{q=0;m=23}if((m|0)==23){m=0;j=HRb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=30;break a}}f[g>>2]=p;continue b}else o=l}while(0);if(!o){r=1;m=30;break a}j=f[h>>2]|0;if(!(j&1))s=mNa(h)|0;else s=j&-2;if(!(Djc(c,o,s)|0)){r=0;m=30;break a}}j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;t=a}else{u=a;m=12}}else{u=0;m=12}if((m|0)==12){m=0;a=HRb(c,u)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)t=a;else{r=0;m=30;break}}if(t>>>0<3){f[e>>2]=f[e>>2]|1;f[i>>2]=t;continue}a=f[h>>2]|0;if(!(a&1))v=mNa(h)|0;else v=a&-2;rjc(v,1,t,((t|0)<0)<<31>>31)}if((m|0)==30)return r|0;return 0}function a_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function b_a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)ZTb(1,f[a+16>>2]|0,b);if(c&2|0)MTb(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function c_a(a){a=a|0;return f[a+12>>2]|0}function d_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=f[a+20>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=aJc(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function e_a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function f_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15176,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function g_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function h_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525544;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function i_a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function j_a(a){a=a|0;var b=0,c=0;f[a>>2]=89528;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function k_a(a){a=a|0;var b=0,c=0;f[a>>2]=89528;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function l_a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function m_a(a,b){a=a|0;b=b|0;a=VDc(20)|0;WYa(a);if(!b)return a|0;y_a(b,a);return a|0}function n_a(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function o_a(a){a=a|0;return 1}function p_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=WRb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==8){j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){a=b[j>>0]|0;i=a&255;if(a<<24>>24>-1){f[c>>2]=j+1;o=i}else{p=i;l=10}}else{p=0;l=10}if((l|0)==10){l=0;i=HRb(c,p)|0;j=J;if((j|0)>-1|(j|0)==-1&i>>>0>4294967295)o=i;else{q=0;l=22;break}}if(o>>>0<3){f[e>>2]=f[e>>2]|1;f[g>>2]=o;continue}i=f[h>>2]|0;if(!(i&1))r=mNa(h)|0;else r=i&-2;rjc(r,1,o,((o|0)<0)<<31>>31);continue}else n=k}if(!n){q=1;l=22;break}i=f[h>>2]|0;if(!(i&1))s=mNa(h)|0;else s=i&-2;if(!(Djc(c,n,s)|0)){q=0;l=22;break}}if((l|0)==22)return q|0;return 0}function q_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;if(!(f[a+8>>2]&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+16>>2]|0;if((b|0)<0)g=11;else g=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=g+c|0;e=a+12|0;f[e>>2]=d;return d|0}function r_a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)ZTb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function s_a(a){a=a|0;return f[a+12>>2]|0}function t_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=aJc(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=e;return p|0}p=Hjc(n&-2,e)|0;return p|0}function u_a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function v_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15192,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function w_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function x_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525528;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function y_a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function z_a(a){a=a|0;var b=0,c=0;f[a>>2]=89636;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function A_a(a){a=a|0;var b=0,c=0;f[a>>2]=89636;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function B_a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function C_a(a,b){a=a|0;b=b|0;a=VDc(20)|0;VYa(a);if(!b)return a|0;O_a(b,a);return a|0}function D_a(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function E_a(a){a=a|0;return 1}function F_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=WRb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==8){j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){a=b[j>>0]|0;i=a&255;if(a<<24>>24>-1){f[c>>2]=j+1;o=i}else{p=i;l=10}}else{p=0;l=10}if((l|0)==10){l=0;i=HRb(c,p)|0;j=J;if((j|0)>-1|(j|0)==-1&i>>>0>4294967295)o=i;else{q=0;l=22;break}}if(o>>>0<3){f[e>>2]=f[e>>2]|1;f[g>>2]=o;continue}i=f[h>>2]|0;if(!(i&1))r=mNa(h)|0;else r=i&-2;rjc(r,1,o,((o|0)<0)<<31>>31);continue}else n=k}if(!n){q=1;l=22;break}i=f[h>>2]|0;if(!(i&1))s=mNa(h)|0;else s=i&-2;if(!(Djc(c,n,s)|0)){q=0;l=22;break}}if((l|0)==22)return q|0;return 0}function G_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;if(!(f[a+8>>2]&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+16>>2]|0;if((b|0)<0)g=11;else g=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=g+c|0;e=a+12|0;f[e>>2]=d;return d|0}function H_a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)ZTb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function I_a(a){a=a|0;return f[a+12>>2]|0}function J_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=aJc(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=e;return p|0}p=Hjc(n&-2,e)|0;return p|0}function K_a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function L_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15208,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function M_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function N_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525552;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function O_a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function P_a(a){a=a|0;var c=0,d=0;f[a>>2]=89744;c=f[a+28>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function Q_a(a){a=a|0;P_a(a);YDc(a);return}function R_a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function S_a(a,b){a=a|0;b=b|0;a=VDc(44)|0;TYa(a);if(!b)return a|0;c$a(b,a);return a|0}function T_a(a){a=a|0;var c=0,e=0,g=0,h=0;f[a+16>>2]=0;c=a+8|0;e=f[c>>2]|0;do if(e&1|0){g=f[a+28>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&62|0){e=a+32|0;f[e>>2]=0;d[e+4>>1]=0;b[e+6>>0]=0;n[a+40>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function U_a(a){a=a|0;return 1}function V_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+40|0;k=a+36|0;l=e+8|0;m=a+32|0;n=a+28|0;o=a+16|0;p=a+20|0;q=a+24|0;r=a+37|0;s=e+8|0;t=a+38|0;v=e+8|0;w=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=WRb(c,B)|0;if((y+-1|0)>>>0<127){z=y;A=6}else C=y}b:do if((A|0)==6){A=0;switch(z>>>3&536870911|0){case 1:{if((z&255|0)!=13){C=z;break b}f[i>>2]=f[i>>2]|32;y=f[c>>2]|0;if(((f[g>>2]|0)-y|0)>3){a=y;x=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=x;f[c>>2]=y+4;D=x}else{if(!(TRb(c,e)|0)){A=13;break a}D=f[e>>2]|0}f[j>>2]=D;continue a;break}case 2:{if((z&255|0)!=16){C=z;break b}f[i>>2]=f[i>>2]|4;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(y=b[x>>0]|0,y<<24>>24>-1):0){f[c>>2]=x+1;E=y<<24>>24!=0}else{IRb(e,c);y=e;if(!(b[l>>0]|0)){F=0;A=63;break a}else E=(f[y>>2]|0)!=0|(f[y+4>>2]|0)!=0}b[k>>0]=E&1;continue a;break}case 3:{if((z&255|0)!=24){C=z;break b}f[i>>2]=f[i>>2]|2;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){x=b[y>>0]|0;a=x&255;if(x<<24>>24>-1){f[m>>2]=a;f[c>>2]=y+1;continue a}else G=a}else G=0;a=HRb(c,G)|0;y=J;f[m>>2]=a;if((y|0)>-1|(y|0)==-1&a>>>0>4294967295)continue a;else{F=0;A=63;break a}break}case 4:{if((z&255|0)!=34){C=z;break b}f[i>>2]=f[i>>2]|1;a=f[n>>2]|0;if((a|0)==527320){GLa(n,527320);H=f[n>>2]|0}else H=a;if(fUb(c,H)|0)continue a;else{F=0;A=63;break a}break}case 5:{switch((z&255)<<24>>24){case 45:break;case 42:{if(BVa(c,o)|0)continue a;else{F=0;A=63;break a}break}default:{C=z;break b}}a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){y=a;x=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[e>>2]=x;f[c>>2]=a+4;I=x}else{if(!(TRb(c,e)|0)){A=44;break a}I=f[e>>2]|0}x=f[o>>2]|0;if((x|0)==(f[p>>2]|0)){SHa(o,x+1|0);K=f[o>>2]|0}else K=x;x=f[q>>2]|0;a=K+1|0;f[o>>2]=a;f[x+4+(K<<2)>>2]=I;y=f[c>>2]|0;L=(f[g>>2]|0)-y|0;if((L|0)<=0)continue a;M=y;y=(f[p>>2]|0)-a|0;N=(L>>>0)/5|0;O=(N|0)<(y|0)?N:y;if((O|0)>0){P=0;Q=M;R=a}else continue a;while(1){if((b[Q>>0]|0)!=45){S=P;break}a=Q+1|0;y=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=R;R=R+1|0;f[o>>2]=R;f[x+4+(a<<2)>>2]=y;y=P+1|0;if((y|0)>=(O|0)){S=y;break}else{P=y;Q=Q+5|0}}O=S*5|0;if((S|0)<=0)continue a;if((L|0)<(O|0)){PRb(c,O,L)|0;continue a}else{f[c>>2]=M+O;continue a}break}case 6:{if((z&255|0)!=48){C=z;break b}f[i>>2]=f[i>>2]|8;O=f[c>>2]|0;if(O>>>0<(f[g>>2]|0)>>>0?(x=b[O>>0]|0,x<<24>>24>-1):0){f[c>>2]=O+1;T=x<<24>>24!=0}else{IRb(e,c);x=e;if(!(b[s>>0]|0)){F=0;A=63;break a}else T=(f[x>>2]|0)!=0|(f[x+4>>2]|0)!=0}b[r>>0]=T&1;continue a;break}case 7:{if((z&255|0)!=56){C=z;break b}f[i>>2]=f[i>>2]|16;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(O=b[x>>0]|0,O<<24>>24>-1):0){f[c>>2]=x+1;U=O<<24>>24!=0}else{IRb(e,c);O=e;if(!(b[v>>0]|0)){F=0;A=63;break a}else U=(f[O>>2]|0)!=0|(f[O+4>>2]|0)!=0}b[t>>0]=U&1;continue a;break}default:{C=z;break b}}}while(0);if(!C){F=1;A=63;break}O=f[w>>2]|0;if(!(O&1))V=mNa(w)|0;else V=O&-2;if(!(Djc(c,C,V)|0)){F=0;A=63;break}}if((A|0)==13){F=0;u=d;return F|0}else if((A|0)==44){F=0;u=d;return F|0}else if((A|0)==63){u=d;return F|0}return 0}function W_a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+16>>2]|0;e=c+d+(c<<2)|0;c=f[a+8>>2]|0;if(!(c&63)){g=e;h=a+12|0;f[h>>2]=g;return g|0}if(!(c&1))i=e;else{d=f[a+28>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;i=e+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=i;else l=i+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=c&4|0?l+2|0:l;l=c&8|0?i+2|0:i;i=c&16|0?l+2|0:l;g=c&32|0?i+5|0:i;h=a+12|0;f[h>>2]=g;return g|0}function X_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&32|0)WTb(1,+n[a+40>>2],c);if(d&4|0)YTb(2,(b[a+36>>0]|0)!=0,c);if(d&2|0)OTb(3,f[a+32>>2]|0,c);if(d&1|0)$Tb(4,f[a+28>>2]|0,c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{WTb(5,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}if(d&8|0)YTb(6,(b[a+37>>0]|0)!=0,c);if(d&16|0)YTb(7,(b[a+38>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Y_a(a){a=a|0;return f[a+12>>2]|0}function Z_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+8>>2]|0;if(!(c&32))e=d;else{g=f[a+40>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&4))i=e;else{d=b[a+36>>0]|0;b[e>>0]=16;b[e+1>>0]=d;i=e+2|0}if(!(c&2))j=i;else{e=f[a+32>>2]|0;b[i>>0]=24;d=i+1|0;if(e>>>0>127){i=e;g=d;while(1){b[g>>0]=i|128;h=i>>>7;k=g+1|0;if(i>>>0>16383){i=h;g=k}else{l=k;m=h;break}}}else{l=d;m=e}b[l>>0]=m;j=l+1|0}if(!(c&1))n=j;else{l=f[a+28>>2]|0;b[j>>0]=34;n=dSb(l,j+1|0)|0}j=f[a+16>>2]|0;if(!j)o=n;else{l=f[a+24>>2]|0;m=0;e=n;while(1){n=f[l+4+(m<<2)>>2]|0;b[e>>0]=45;d=e+1|0;b[d>>0]=n;b[d+1>>0]=n>>8;b[d+2>>0]=n>>16;b[d+3>>0]=n>>24;n=e+5|0;m=m+1|0;if((m|0)>=(j|0)){o=n;break}else e=n}}if(!(c&8))p=o;else{e=b[a+37>>0]|0;b[o>>0]=48;b[o+1>>0]=e;p=o+2|0}if(!(c&16))q=p;else{c=b[a+38>>0]|0;b[p>>0]=56;b[p+1>>0]=c;q=p+2|0}p=f[a+4>>2]|0;if(!(p&1)){r=q;return r|0}r=Hjc(p&-2,q)|0;return r|0}function __a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function $_a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15224,0)|0;if(!c){Ehc(b,a);return}else{UYa(a,c);return}}function a$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function b$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525208;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function c$a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function d$a(a){a=a|0;var b=0,c=0;f[a>>2]=89852;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function e$a(a){a=a|0;var b=0,c=0;f[a>>2]=89852;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function f$a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function g$a(a,b){a=a|0;b=b|0;a=VDc(24)|0;SYa(a);if(!b)return a|0;s$a(b,a);return a|0}function h$a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&7|0){b[a+16>>0]=0;b[a+17>>0]=1;n[a+20>>2]=9.999999717180685e-10}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function i$a(a){a=a|0;return 1}function j$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+17|0;k=e+8|0;l=a+16|0;m=e+8|0;n=a+20|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=WRb(c,t)|0;if((q+-1|0)>>>0<127){r=q;s=6}else v=q}b:do if((s|0)==6){s=0;switch(r>>>3&536870911|0){case 1:{if((r&255|0)!=8){v=r;break b}f[i>>2]=f[i>>2]|2;q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0?(a=b[q>>0]|0,a<<24>>24>-1):0){f[c>>2]=q+1;w=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[k>>0]|0)){x=0;s=31;break a}else w=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[j>>0]=w&1;continue a;break}case 2:{if((r&255|0)!=16){v=r;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;y=q<<24>>24!=0}else{IRb(e,c);q=e;if(!(b[m>>0]|0)){x=0;s=31;break a}else y=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0}b[l>>0]=y&1;continue a;break}case 3:{if((r&255|0)!=29){v=r;break b}f[i>>2]=f[i>>2]|4;q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){a=q;p=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=p;f[c>>2]=q+4;z=p}else{if(!(TRb(c,e)|0)){s=25;break a}z=f[e>>2]|0}f[n>>2]=z;continue a;break}default:{v=r;break b}}}while(0);if(!v){x=1;s=31;break}p=f[o>>2]|0;if(!(p&1))A=mNa(o)|0;else A=p&-2;if(!(Djc(c,v,A)|0)){x=0;s=31;break}}if((s|0)==25){x=0;u=d;return x|0}else if((s|0)==31){u=d;return x|0}return 0}function k$a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+2|0:c;c=b&2|0?g+2|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function l$a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&2|0)YTb(1,(b[a+17>>0]|0)!=0,c);if(d&1|0)YTb(2,(b[a+16>>0]|0)!=0,c);if(d&4|0)WTb(3,+n[a+20>>2],c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function m$a(a){a=a|0;return f[a+12>>2]|0}function n$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=b[a+17>>0]|0;b[d>>0]=8;b[d+1>>0]=g;e=d+2|0}if(!(c&1))h=e;else{d=b[a+16>>0]|0;b[e>>0]=16;b[e+1>>0]=d;h=e+2|0}if(!(c&4))i=h;else{c=f[a+20>>2]|0;b[h>>0]=29;e=h+1|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;i=h+5|0}h=f[a+4>>2]|0;if(!(h&1)){j=i;return j|0}j=Hjc(h&-2,i)|0;return j|0}function o$a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function p$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,15240,0)|0;if(!d){Ehc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&7))return;if(e&1|0)b[a+16>>0]=b[d+16>>0]|0;if(e&2|0)b[a+17>>0]=b[d+17>>0]|0;if(e&4|0)f[a+20>>2]=f[d+20>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function q$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function r$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525448;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function s$a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function t$a(a){a=a|0;var b=0,c=0;f[a>>2]=89960;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function u$a(a){a=a|0;var b=0,c=0;f[a>>2]=89960;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function v$a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function w$a(a,b){a=a|0;b=b|0;a=VDc(36)|0;QYa(a);if(!b)return a|0;J$a(b,a);return a|0}function x$a(a){a=a|0;var b=0;f[a+16>>2]=0;b=a+8|0;if(f[b>>2]&3|0){f[a+28>>2]=1;f[a+32>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function y$a(a){a=a|0;return 1}function z$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=c+4|0;e=a+8|0;g=a+28|0;h=a+16|0;i=a+20|0;j=a+24|0;k=a+32|0;l=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=WRb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)!=8){r=o;break b}f[e>>2]=f[e>>2]|1;n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[g>>2]=m;f[c>>2]=n+1;continue a}else s=m}else s=0;m=HRb(c,s)|0;n=J;f[g>>2]=m;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)continue a;else{t=0;p=40;break a}break}case 2:{switch((o&255)<<24>>24){case 16:break;case 18:{if(I$a(c,h)|0)continue a;else{t=0;p=40;break a}break}default:{r=o;break b}}m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){n=b[m>>0]|0;a=n&255;if(n<<24>>24>-1){f[c>>2]=m+1;u=a}else{v=a;p=16}}else{v=0;p=16}if((p|0)==16){p=0;a=HRb(c,v)|0;m=J;if((m|0)>-1|(m|0)==-1&a>>>0>4294967295)u=a;else{t=0;p=40;break a}}a=f[h>>2]|0;if((a|0)==(f[i>>2]|0)){OLa(h,a+1|0);w=f[h>>2]|0}else w=a;a=f[j>>2]|0;f[h>>2]=w+1;f[a+4+(w<<2)>>2]=u;m=(f[i>>2]|0)-(f[h>>2]|0)|0;if((m|0)>0){x=m;y=a}else continue a;while(1){a=f[c>>2]|0;m=f[d>>2]|0;if(a>>>0>=m>>>0)continue a;if((b[a>>0]|0)!=16)continue a;n=a+1|0;f[c>>2]=n;if(n>>>0<m>>>0){m=b[n>>0]|0;n=m&255;if(m<<24>>24>-1){f[c>>2]=a+2;z=n;A=y}else{B=n;p=24}}else{B=0;p=24}if((p|0)==24){p=0;n=HRb(c,B)|0;a=J;if(!((a|0)>-1|(a|0)==-1&n>>>0>4294967295)){t=0;p=40;break a}z=n;A=f[j>>2]|0}n=f[h>>2]|0;f[h>>2]=n+1;f[A+4+(n<<2)>>2]=z;if((x|0)>1){x=x+-1|0;y=A}else continue a}break}case 3:{if((o&255|0)!=24){r=o;break b}f[e>>2]=f[e>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;C=m}else{D=m;p=33}}else{D=0;p=33}if((p|0)==33){p=0;m=HRb(c,D)|0;n=J;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)C=m;else{t=0;p=40;break a}}f[k>>2]=C;continue a;break}default:{r=o;break b}}}while(0);if(!r){t=1;p=40;break}m=f[l>>2]|0;if(!(m&1))E=mNa(l)|0;else E=m&-2;if(!(Djc(c,r,E)|0)){t=0;p=40;break}}if((p|0)==40)return t|0;return 0}function A$a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=iUb(a+16|0)|0;d=b+c+(f[a+16>>2]|0)|0;c=f[a+8>>2]|0;if(!(c&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else h=d+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+32>>2]|0;if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=i+h|0;g=a+12|0;f[g>>2]=e;return e|0}function B$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)OTb(1,f[a+28>>2]|0,b);d=f[a+16>>2]|0;if((d|0)>0){e=a+24|0;g=0;do{OTb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&2|0)MTb(3,f[a+32>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function C$a(a){a=a|0;return f[a+12>>2]|0}function D$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+28>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}l=f[a+16>>2]|0;if(!l)n=e;else{m=f[a+24>>2]|0;g=0;h=e;while(1){e=f[m+4+(g<<2)>>2]|0;b[h>>0]=16;i=h+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;o=j+1|0;if(d>>>0>16383){d=k;j=o}else{p=o;q=k;break}}}else{p=i;q=e}b[p>>0]=q;j=p+1|0;g=g+1|0;if((g|0)>=(l|0)){n=j;break}else h=j}}if(!(c&2))r=n;else{c=f[a+32>>2]|0;b[n>>0]=24;h=n+1|0;n=c&255;if(c>>>0>127){l=h;g=n;p=c;q=((c|0)<0)<<31>>31;while(1){b[l>>0]=g|-128;c=p;p=aJc(p|0,q|0,7)|0;m=l+1|0;j=p&255;if(!(q>>>0>0|(q|0)==0&c>>>0>16383)){s=m;t=j;break}else{l=m;g=j;q=J}}}else{s=h;t=n}b[s>>0]=t;r=s+1|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=Hjc(s&-2,r)|0;return u|0}function E$a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function F$a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15256,0)|0;if(!c){Ehc(b,a);return}else{RYa(a,c);return}}function G$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function H$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525536;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function I$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;if(d>>>0<(f[e>>2]|0)>>>0?(g=b[d>>0]|0,g<<24>>24>-1):0){f[a>>2]=d+1;h=g&255}else{g=VRb(a)|0;if((g|0)>-1)h=g;else{i=0;return i|0}}g=ERb(a,h)|0;a:do if((MRb(a)|0)>0){h=c+4|0;d=c+8|0;while(1){j=f[a>>2]|0;if(j>>>0<(f[e>>2]|0)>>>0){k=b[j>>0]|0;l=k&255;if(k<<24>>24>-1){f[a>>2]=j+1;m=l}else{n=l;o=10}}else{n=0;o=10}if((o|0)==10){o=0;l=HRb(a,n)|0;j=J;if((j|0)>-1|(j|0)==-1&l>>>0>4294967295)m=l;else{i=0;break}}l=f[c>>2]|0;if((l|0)==(f[h>>2]|0)){OLa(c,l+1|0);p=f[c>>2]|0}else p=l;l=f[d>>2]|0;f[c>>2]=p+1;f[l+4+(p<<2)>>2]=m;if((MRb(a)|0)<=0)break a}return i|0}while(0);FRb(a,g);i=1;return i|0}function J$a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function K$a(a){a=a|0;var b=0,c=0;f[a>>2]=90068;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function L$a(a){a=a|0;var b=0,c=0;f[a>>2]=90068;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function M$a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function N$a(a,b){a=a|0;b=b|0;a=VDc(24)|0;PYa(a);if(!b)return a|0;Z$a(b,a);return a|0}function O$a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&3|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function P$a(a){a=a|0;return 1}function Q$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+4|0;l=a+20|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=7}else{q=n;p=6}}else{q=0;p=6}if((p|0)==6){p=0;n=WRb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=7}else r=n}c:do if((p|0)==7){p=0;switch(o>>>3&536870911|0){case 1:break;case 2:{if((o&255|0)==16)break b;else{r=o;break c}break}default:{r=o;break c}}if((o&255|0)==13){f[i>>2]=f[i>>2]|1;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){a=n;m=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=m;f[c>>2]=n+4;s=m}else{if(!(TRb(c,e)|0)){p=14;break a}s=f[e>>2]|0}f[j>>2]=s;continue b}else r=o}while(0);if(!r){t=1;p=31;break a}m=f[k>>2]|0;if(!(m&1))v=mNa(k)|0;else v=m&-2;if(!(Djc(c,r,v)|0)){t=0;p=31;break a}}m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){n=b[m>>0]|0;a=n&255;if(n<<24>>24>-1){f[c>>2]=m+1;w=a}else{x=a;p=19}}else{x=0;p=19}if((p|0)==19){p=0;a=HRb(c,x)|0;m=J;if((m|0)>-1|(m|0)==-1&a>>>0>4294967295)w=a;else{t=0;p=31;break}}if(w>>>0<3){f[i>>2]=f[i>>2]|2;f[l>>2]=w;continue}a=f[k>>2]|0;if(!(a&1))y=mNa(k)|0;else y=a&-2;rjc(y,2,w,((w|0)<0)<<31>>31)}if((p|0)==14){t=0;u=d;return t|0}else if((p|0)==31){u=d;return t|0}return 0}function R$a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)h=11;else h=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=h+g|0;e=a+12|0;f[e>>2]=d;return d|0}function S$a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)WTb(1,+n[a+16>>2],b);if(c&2|0)ZTb(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function T$a(a){a=a|0;return f[a+12>>2]|0}function U$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{c=f[a+20>>2]|0;b[e>>0]=16;d=e+1|0;e=c&255;if(c>>>0>127){g=d;h=e;j=c;k=((c|0)<0)<<31>>31;while(1){b[g>>0]=h|-128;c=j;j=aJc(j|0,k|0,7)|0;l=g+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{g=l;h=m;k=J}}}else{n=d;o=e}b[n>>0]=o;i=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=i;return p|0}p=Hjc(n&-2,i)|0;return p|0}function V$a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function W$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15272,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function X$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525504;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z$a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function _$a(a){a=a|0;var b=0,c=0;f[a>>2]=90176;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function $$a(a){a=a|0;var b=0,c=0;f[a>>2]=90176;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function a0a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function b0a(a,b){a=a|0;b=b|0;a=VDc(20)|0;OYa(a);if(!b)return a|0;n0a(b,a);return a|0}function c0a(a){a=a|0;var b=0;f[a+16>>2]=1;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function d0a(a){a=a|0;return 1}function e0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=WRb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==8){j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){a=b[j>>0]|0;i=a&255;if(a<<24>>24>-1){f[c>>2]=j+1;o=i}else{p=i;l=10}}else{p=0;l=10}if((l|0)==10){l=0;i=HRb(c,p)|0;j=J;if((j|0)>-1|(j|0)==-1&i>>>0>4294967295)o=i;else{q=0;l=22;break}}if((o+-1|0)>>>0<2){f[e>>2]=f[e>>2]|1;f[g>>2]=o;continue}i=f[h>>2]|0;if(!(i&1))r=mNa(h)|0;else r=i&-2;rjc(r,1,o,((o|0)<0)<<31>>31);continue}else n=k}if(!n){q=1;l=22;break}i=f[h>>2]|0;if(!(i&1))s=mNa(h)|0;else s=i&-2;if(!(Djc(c,n,s)|0)){q=0;l=22;break}}if((l|0)==22)return q|0;return 0}function f0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;if(!(f[a+8>>2]&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+16>>2]|0;if((b|0)<0)g=11;else g=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=g+c|0;e=a+12|0;f[e>>2]=d;return d|0}function g0a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)ZTb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function h0a(a){a=a|0;return f[a+12>>2]|0}function i0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=aJc(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=e;return p|0}p=Hjc(n&-2,e)|0;return p|0}function j0a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function k0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15288,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function l0a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function m0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525384;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function n0a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function o0a(a){a=a|0;var b=0,c=0;f[a>>2]=90284;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function p0a(a){a=a|0;var b=0,c=0;f[a>>2]=90284;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function q0a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function r0a(a,b){a=a|0;b=b|0;a=VDc(28)|0;NYa(a);if(!b)return a|0;D0a(b,a);return a|0}function s0a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function t0a(a){a=a|0;return 1}function u0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=a+8|0;g=a+20|0;h=a+24|0;i=a+16|0;j=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=6}else{o=l;n=5}}else{o=0;n=5}if((n|0)==5){n=0;l=WRb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=6}else p=l}b:do if((n|0)==6){n=0;switch(m>>>3&536870911|0){case 1:{if((m&255|0)!=8){p=m;break b}f[e>>2]=f[e>>2]|2;l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){a=b[l>>0]|0;k=a&255;if(a<<24>>24>-1){f[g>>2]=k;f[c>>2]=l+1;continue a}else q=k}else q=0;k=HRb(c,q)|0;l=J;f[g>>2]=k;if((l|0)>-1|(l|0)==-1&k>>>0>4294967295)continue a;else{r=0;n=29;break a}break}case 2:{if((m&255|0)!=16){p=m;break b}f[e>>2]=f[e>>2]|4;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){l=b[k>>0]|0;a=l&255;if(l<<24>>24>-1){f[c>>2]=k+1;s=a}else{t=a;n=16}}else{t=0;n=16}if((n|0)==16){n=0;a=HRb(c,t)|0;k=J;if((k|0)>-1|(k|0)==-1&a>>>0>4294967295)s=a;else{r=0;n=29;break a}}f[h>>2]=s;continue a;break}case 3:{if((m&255|0)!=24){p=m;break b}f[e>>2]=f[e>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>-1){f[c>>2]=a+1;u=l}else{v=l;n=22}}else{v=0;n=22}if((n|0)==22){n=0;l=HRb(c,v)|0;a=J;if((a|0)>-1|(a|0)==-1&l>>>0>4294967295)u=l;else{r=0;n=29;break a}}f[i>>2]=u;continue a;break}default:{p=m;break b}}}while(0);if(!p){r=1;n=29;break}l=f[j>>2]|0;if(!(l&1))w=mNa(j)|0;else w=l&-2;if(!(Djc(c,p,w)|0)){r=0;n=29;break}}if((n|0)==29)return r|0;return 0}function v0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2))j=g;else j=g+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&4)){d=j;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+24>>2]|0;if((b|0)<0)k=11;else k=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=k+j|0;e=a+12|0;f[e>>2]=d;return d|0}function w0a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)OTb(1,f[a+20>>2]|0,b);if(c&4|0)MTb(2,f[a+24>>2]|0,b);if(c&1|0)MTb(3,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function x0a(a){a=a|0;return f[a+12>>2]|0}function y0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&4))n=e;else{l=f[a+24>>2]|0;b[e>>0]=16;m=e+1|0;e=l&255;if(l>>>0>127){g=m;h=e;i=l;d=((l|0)<0)<<31>>31;while(1){b[g>>0]=h|-128;l=i;i=aJc(i|0,d|0,7)|0;j=g+1|0;k=i&255;if(!(d>>>0>0|(d|0)==0&l>>>0>16383)){o=j;p=k;break}else{g=j;h=k;d=J}}}else{o=m;p=e}b[o>>0]=p;n=o+1|0}if(!(c&1))q=n;else{c=f[a+16>>2]|0;b[n>>0]=24;o=n+1|0;n=c&255;if(c>>>0>127){p=o;e=n;m=c;d=((c|0)<0)<<31>>31;while(1){b[p>>0]=e|-128;c=m;m=aJc(m|0,d|0,7)|0;h=p+1|0;g=m&255;if(!(d>>>0>0|(d|0)==0&c>>>0>16383)){r=h;s=g;break}else{p=h;e=g;d=J}}}else{r=o;s=n}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function z0a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function A0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15304,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function B0a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function C0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525224;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function D0a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function E0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{I0a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(48)|0;BWa(l);I0a(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,15048,48);l=NQb(i,48,1754)|0;BWa(l);I0a(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function F0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{G0a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(32)|0;SXa(l);G0a(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,14952,32);l=NQb(i,32,1755)|0;SXa(l);G0a(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function G0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=b+4|0;d=f[a+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=b+16|0;g=a+16|0;e=f[g>>2]|0;if(!e)return;UHa(d,(f[d>>2]|0)+e|0);dJc((f[b+24>>2]|0)+8+(f[d>>2]<<3)|0,(f[a+24>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);return}function H0a(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function I0a(a,b){a=a|0;b=b|0;CWa(b,a);return}function J0a(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function K0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=90392;b=a+92|0;c=f[b>>2]|0;if(c|0?(f[a+80>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=f[a+76>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+64>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+52>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+40>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+28|0;h=f[b>>2]|0;if(h|0?(f[a+16>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;YDc(i)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[b>>2]=0;return}function L0a(a){a=a|0;K0a(a);YDc(a);return}function M0a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function N0a(a,b){a=a|0;b=b|0;a=VDc(96)|0;LYa(a);if(!b)return a|0;_0a(b,a);return a|0}function O0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+32>>2]=0;f[a+44>>2]=0;f[a+56>>2]=0;f[a+68>>2]=0;b=a+84|0;c=f[b>>2]|0;if((c|0)>0){e=f[a+92>>2]|0;d=0;do{g=f[e+4+(d<<2)>>2]|0;d=d+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((d|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function P0a(a){a=a|0;return 1}function Q0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+32|0;n=a+36|0;o=a+40|0;p=a+44|0;q=a+48|0;r=a+52|0;s=a+56|0;t=a+60|0;v=a+64|0;w=a+68|0;x=a+72|0;y=a+76|0;z=a+80|0;A=e+4|0;B=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){C=b[a>>0]|0;D=C&255;if(C<<24>>24>0){f[c>>2]=a+1;E=D;F=6}else{G=D;F=5}}else{G=0;F=5}if((F|0)==5){F=0;D=WRb(c,G)|0;if((D+-1|0)>>>0<127){E=D;F=6}else H=D}b:do if((F|0)==6){F=0;switch(E>>>3&536870911|0){case 1:{if((E&255|0)!=10){H=E;break b}D=f[i>>2]|0;do if(D){a=f[k>>2]|0;C=f[D>>2]|0;if((a|0)>=(C|0))if((C|0)==(f[j>>2]|0)){I=C;F=13;break}else{K=C;L=D;F=14;break}else{f[k>>2]=a+1;M=f[D+4+(a<<2)>>2]|0;break}}else{I=f[j>>2]|0;F=13}while(0);if((F|0)==13){F=0;USb(h,I+1|0);D=f[i>>2]|0;K=f[D>>2]|0;L=D;F=14}if((F|0)==14){F=0;f[L>>2]=K+1;D=f[h>>2]|0;if(!D){a=VDc(48)|0;BWa(a);N=a}else{if(f[D+64>>2]|0)OQb(D,15048,48);a=NQb(D,48,1754)|0;BWa(a);N=a}a=f[i>>2]|0;D=f[k>>2]|0;f[k>>2]=D+1;f[a+4+(D<<2)>>2]=N;M=N}D=f[c>>2]|0;if(D>>>0<(f[g>>2]|0)>>>0?(a=b[D>>0]|0,a<<24>>24>-1):0){f[c>>2]=D+1;O=a&255}else{a=VRb(c)|0;if((a|0)>-1)O=a;else{P=0;F=110;break a}}GRb(e,c,O);if((f[l>>2]|0)<0){F=26;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){F=26;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{P=0;F=110;break a}break}case 2:{switch((E&255)<<24>>24){case 16:break;case 18:{if(I$a(c,m)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){D=b[a>>0]|0;C=D&255;if(D<<24>>24>-1){f[c>>2]=a+1;Q=C}else{R=C;F=32}}else{R=0;F=32}if((F|0)==32){F=0;C=HRb(c,R)|0;a=J;if((a|0)>-1|(a|0)==-1&C>>>0>4294967295)Q=C;else{P=0;F=110;break a}}C=f[m>>2]|0;if((C|0)==(f[n>>2]|0)){OLa(m,C+1|0);S=f[m>>2]|0}else S=C;C=f[o>>2]|0;f[m>>2]=S+1;f[C+4+(S<<2)>>2]=Q;a=(f[n>>2]|0)-(f[m>>2]|0)|0;if((a|0)>0){T=a;U=C}else continue a;while(1){C=f[c>>2]|0;a=f[g>>2]|0;if(C>>>0>=a>>>0)continue a;if((b[C>>0]|0)!=16)continue a;D=C+1|0;f[c>>2]=D;if(D>>>0<a>>>0){a=b[D>>0]|0;D=a&255;if(a<<24>>24>-1){f[c>>2]=C+2;V=D;W=U}else{X=D;F=40}}else{X=0;F=40}if((F|0)==40){F=0;D=HRb(c,X)|0;C=J;if(!((C|0)>-1|(C|0)==-1&D>>>0>4294967295)){P=0;F=110;break a}V=D;W=f[o>>2]|0}D=f[m>>2]|0;f[m>>2]=D+1;f[W+4+(D<<2)>>2]=V;if((T|0)>1){T=T+-1|0;U=W}else continue a}break}case 3:{switch((E&255)<<24>>24){case 24:break;case 26:{if(I$a(c,p)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}D=f[c>>2]|0;if(D>>>0<(f[g>>2]|0)>>>0){C=b[D>>0]|0;a=C&255;if(C<<24>>24>-1){f[c>>2]=D+1;Y=a}else{Z=a;F=49}}else{Z=0;F=49}if((F|0)==49){F=0;a=HRb(c,Z)|0;D=J;if((D|0)>-1|(D|0)==-1&a>>>0>4294967295)Y=a;else{P=0;F=110;break a}}a=f[p>>2]|0;if((a|0)==(f[q>>2]|0)){OLa(p,a+1|0);_=f[p>>2]|0}else _=a;a=f[r>>2]|0;f[p>>2]=_+1;f[a+4+(_<<2)>>2]=Y;D=(f[q>>2]|0)-(f[p>>2]|0)|0;if((D|0)>0){$=D;aa=a}else continue a;while(1){a=f[c>>2]|0;D=f[g>>2]|0;if(a>>>0>=D>>>0)continue a;if((b[a>>0]|0)!=24)continue a;C=a+1|0;f[c>>2]=C;if(C>>>0<D>>>0){D=b[C>>0]|0;C=D&255;if(D<<24>>24>-1){f[c>>2]=a+2;ba=C;ca=aa}else{da=C;F=57}}else{da=0;F=57}if((F|0)==57){F=0;C=HRb(c,da)|0;a=J;if(!((a|0)>-1|(a|0)==-1&C>>>0>4294967295)){P=0;F=110;break a}ba=C;ca=f[r>>2]|0}C=f[p>>2]|0;f[p>>2]=C+1;f[ca+4+(C<<2)>>2]=ba;if(($|0)>1){$=$+-1|0;aa=ca}else continue a}break}case 4:{switch((E&255)<<24>>24){case 32:break;case 34:{if(I$a(c,s)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}C=f[c>>2]|0;if(C>>>0<(f[g>>2]|0)>>>0){a=b[C>>0]|0;D=a&255;if(a<<24>>24>-1){f[c>>2]=C+1;ea=D}else{fa=D;F=66}}else{fa=0;F=66}if((F|0)==66){F=0;D=HRb(c,fa)|0;C=J;if((C|0)>-1|(C|0)==-1&D>>>0>4294967295)ea=D;else{P=0;F=110;break a}}D=f[s>>2]|0;if((D|0)==(f[t>>2]|0)){OLa(s,D+1|0);ga=f[s>>2]|0}else ga=D;D=f[v>>2]|0;f[s>>2]=ga+1;f[D+4+(ga<<2)>>2]=ea;C=(f[t>>2]|0)-(f[s>>2]|0)|0;if((C|0)>0){ha=C;ia=D}else continue a;while(1){D=f[c>>2]|0;C=f[g>>2]|0;if(D>>>0>=C>>>0)continue a;if((b[D>>0]|0)!=32)continue a;a=D+1|0;f[c>>2]=a;if(a>>>0<C>>>0){C=b[a>>0]|0;a=C&255;if(C<<24>>24>-1){f[c>>2]=D+2;ja=a;ka=ia}else{la=a;F=74}}else{la=0;F=74}if((F|0)==74){F=0;a=HRb(c,la)|0;D=J;if(!((D|0)>-1|(D|0)==-1&a>>>0>4294967295)){P=0;F=110;break a}ja=a;ka=f[v>>2]|0}a=f[s>>2]|0;f[s>>2]=a+1;f[ka+4+(a<<2)>>2]=ja;if((ha|0)>1){ha=ha+-1|0;ia=ka}else continue a}break}case 5:{switch((E&255)<<24>>24){case 40:break;case 42:{if(I$a(c,w)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){D=b[a>>0]|0;C=D&255;if(D<<24>>24>-1){f[c>>2]=a+1;ma=C}else{na=C;F=83}}else{na=0;F=83}if((F|0)==83){F=0;C=HRb(c,na)|0;a=J;if((a|0)>-1|(a|0)==-1&C>>>0>4294967295)ma=C;else{P=0;F=110;break a}}C=f[w>>2]|0;if((C|0)==(f[x>>2]|0)){OLa(w,C+1|0);oa=f[w>>2]|0}else oa=C;C=f[y>>2]|0;f[w>>2]=oa+1;f[C+4+(oa<<2)>>2]=ma;a=(f[x>>2]|0)-(f[w>>2]|0)|0;if((a|0)>0){pa=a;qa=C}else continue a;while(1){C=f[c>>2]|0;a=f[g>>2]|0;if(C>>>0>=a>>>0)continue a;if((b[C>>0]|0)!=40)continue a;D=C+1|0;f[c>>2]=D;if(D>>>0<a>>>0){a=b[D>>0]|0;D=a&255;if(a<<24>>24>-1){f[c>>2]=C+2;ra=D;sa=qa}else{ta=D;F=91}}else{ta=0;F=91}if((F|0)==91){F=0;D=HRb(c,ta)|0;C=J;if(!((C|0)>-1|(C|0)==-1&D>>>0>4294967295)){P=0;F=110;break a}ra=D;sa=f[y>>2]|0}D=f[w>>2]|0;f[w>>2]=D+1;f[sa+4+(D<<2)>>2]=ra;if((pa|0)>1){pa=pa+-1|0;qa=sa}else continue a}break}case 6:{if((E&255|0)!=50){H=E;break b}D=Z0a(z)|0;C=f[c>>2]|0;if(C>>>0<(f[g>>2]|0)>>>0?(a=b[C>>0]|0,a<<24>>24>-1):0){f[c>>2]=C+1;ua=a&255}else{a=VRb(c)|0;if((a|0)>-1)ua=a;else{P=0;F=110;break a}}GRb(e,c,ua);if((f[A>>2]|0)<0){F=103;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){F=103;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}}while(0);if(!H){P=1;F=110;break}D=f[B>>2]|0;if(!(D&1))va=mNa(B)|0;else va=D&-2;if(!(Djc(c,H,va)|0)){P=0;F=110;break}}if((F|0)==26){P=0;u=d;return P|0}else if((F|0)==103){P=0;u=d;return P|0}else if((F|0)==110){u=d;return P|0}return 0}function R0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b)e=d;else{c=a+28|0;g=0;h=d;while(1){d=f[(f[c>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=d;break}else h=d}}h=iUb(a+32|0)|0;b=f[a+32>>2]|0;g=iUb(a+44|0)|0;c=f[a+44>>2]|0;d=iUb(a+56|0)|0;i=f[a+56>>2]|0;j=iUb(a+68|0)|0;k=f[a+84>>2]|0;l=h+e+b+g+c+d+i+j+(f[a+68>>2]|0)+k|0;if(!k){m=l;n=a+12|0;f[n>>2]=m;return m|0}j=a+92|0;i=0;d=l;while(1){l=f[(f[j>>2]|0)+4+(i<<2)>>2]|0;c=_i[f[(f[l>>2]|0)+48>>2]&1023](l)|0;l=c+d+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(k|0)){m=l;break}else d=l}n=a+12|0;f[n>>2]=m;return m|0}function S0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+32>>2]|0;if((c|0)>0){e=a+40|0;d=0;do{OTb(2,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+44>>2]|0;if((c|0)>0){d=a+52|0;e=0;do{OTb(3,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+56>>2]|0;if((c|0)>0){e=a+64|0;d=0;do{OTb(4,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+68>>2]|0;if((c|0)>0){d=a+76|0;e=0;do{OTb(5,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+84>>2]|0;if(c|0){e=a+92|0;d=0;do{eUb(6,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function T0a(a){a=a|0;return f[a+12>>2]|0}function U0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+32>>2]|0;if(!j)s=g;else{e=f[a+40>>2]|0;i=0;q=g;while(1){g=f[e+4+(i<<2)>>2]|0;b[q>>0]=16;r=q+1|0;if(g>>>0>127){h=g;n=r;while(1){b[n>>0]=h|128;m=h>>>7;o=n+1|0;if(h>>>0>16383){h=m;n=o}else{t=o;u=m;break}}}else{t=r;u=g}b[t>>0]=u;n=t+1|0;i=i+1|0;if((i|0)>=(j|0)){s=n;break}else q=n}}q=f[a+44>>2]|0;if(!q)v=s;else{j=f[a+52>>2]|0;i=0;t=s;while(1){s=f[j+4+(i<<2)>>2]|0;b[t>>0]=24;u=t+1|0;if(s>>>0>127){e=s;n=u;while(1){b[n>>0]=e|128;h=e>>>7;d=n+1|0;if(e>>>0>16383){e=h;n=d}else{w=d;x=h;break}}}else{w=u;x=s}b[w>>0]=x;n=w+1|0;i=i+1|0;if((i|0)>=(q|0)){v=n;break}else t=n}}t=f[a+56>>2]|0;if(!t)y=v;else{q=f[a+64>>2]|0;i=0;w=v;while(1){v=f[q+4+(i<<2)>>2]|0;b[w>>0]=32;x=w+1|0;if(v>>>0>127){j=v;n=x;while(1){b[n>>0]=j|128;e=j>>>7;g=n+1|0;if(j>>>0>16383){j=e;n=g}else{z=g;A=e;break}}}else{z=x;A=v}b[z>>0]=A;n=z+1|0;i=i+1|0;if((i|0)>=(t|0)){y=n;break}else w=n}}w=f[a+68>>2]|0;if(!w)B=y;else{t=f[a+76>>2]|0;i=0;z=y;while(1){y=f[t+4+(i<<2)>>2]|0;b[z>>0]=40;A=z+1|0;if(y>>>0>127){q=y;n=A;while(1){b[n>>0]=q|128;j=q>>>7;s=n+1|0;if(q>>>0>16383){q=j;n=s}else{C=s;D=j;break}}}else{C=A;D=y}b[C>>0]=D;n=C+1|0;i=i+1|0;if((i|0)>=(w|0)){B=n;break}else z=n}}z=f[a+84>>2]|0;if(!z)E=B;else{w=a+92|0;i=0;C=B;while(1){B=f[(f[w>>2]|0)+4+(i<<2)>>2]|0;b[C>>0]=50;D=C+1|0;t=_i[f[(f[B>>2]|0)+60>>2]&1023](B)|0;if(t>>>0>127){n=t;q=D;while(1){b[q>>0]=n|128;v=n>>>7;x=q+1|0;if(n>>>0>16383){n=v;q=x}else{F=x;G=v;break}}}else{F=D;G=t}b[F>>0]=G;q=hj[f[(f[B>>2]|0)+64>>2]&511](B,c,F+1|0)|0;i=i+1|0;if((i|0)==(z|0)){E=q;break}else C=q}}C=f[a+4>>2]|0;if(!(C&1)){H=E;return H|0}H=Hjc(C&-2,E)|0;return H|0}function V0a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function W0a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15320,0)|0;if(!c){Ehc(b,a);return}else{MYa(a,c);return}}function X0a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525320;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(32)|0;SXa(a);o=a}else{if(f[l+64>>2]|0)OQb(l,14952,32);a=NQb(l,32,1755)|0;SXa(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function _0a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function $0a(a){a=a|0;var b=0,c=0;f[a>>2]=90500;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function a1a(a){a=a|0;var b=0,c=0;f[a>>2]=90500;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function b1a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function c1a(a,b){a=a|0;b=b|0;a=VDc(20)|0;KYa(a);if(!b)return a|0;o1a(b,a);return a|0}function d1a(a){a=a|0;var b=0;n[a+16>>2]=0.0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function e1a(a){a=a|0;return 1}function f1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=WRb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}if((o|0)==6){o=0;if((n|0)==13){f[i>>2]=f[i>>2]|1;m=f[c>>2]|0;if(((f[g>>2]|0)-m|0)>3){a=m;l=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=l;f[c>>2]=m+4;r=l}else{if(!(TRb(c,e)|0)){o=12;break}r=f[e>>2]|0}f[j>>2]=r;continue}else q=n}if(!q){s=1;o=18;break}l=f[k>>2]|0;if(!(l&1))t=mNa(k)|0;else t=l&-2;if(!(Djc(c,q,t)|0)){s=0;o=18;break}}if((o|0)==12){s=0;u=d;return s|0}else if((o|0)==18){u=d;return s|0}return 0}function g1a(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]&1|0?c+5|0:c;f[a+12>>2]=b;return b|0}function h1a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)WTb(1,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function i1a(a){a=a|0;return f[a+12>>2]|0}function j1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=13;g=d+1|0;b[g>>0]=c;b[g+1>>0]=c>>8;b[g+2>>0]=c>>16;b[g+3>>0]=c>>24;e=d+5|0}d=f[a+4>>2]|0;if(!(d&1)){h=e;return h|0}h=Hjc(d&-2,e)|0;return h|0}function k1a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function l1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15336,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function m1a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function n1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525568;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function o1a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function p1a(a){a=a|0;var b=0,c=0;f[a>>2]=90608;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function q1a(a){a=a|0;var b=0,c=0;f[a>>2]=90608;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function r1a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function s1a(a,b){a=a|0;b=b|0;a=VDc(36)|0;IYa(a);if(!b)return a|0;E1a(b,a);return a|0}function t1a(a){a=a|0;var c=0;f[a+16>>2]=0;c=a+8|0;if(f[c>>2]&3|0){f[a+28>>2]=1;b[a+32>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function u1a(a){a=a|0;return 1}function v1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+28|0;k=a+4|0;l=a+16|0;m=a+20|0;n=a+24|0;o=a+32|0;a=e+8|0;a:while(1){p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){q=b[p>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=p+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=WRb(c,v)|0;if((r+-1|0)>>>0<127){s=r;t=6}else w=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{if((s&255|0)!=8){w=s;break b}r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){p=b[r>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=r+1;x=q}else{y=q;t=11}}else{y=0;t=11}if((t|0)==11){t=0;q=HRb(c,y)|0;r=J;if((r|0)>-1|(r|0)==-1&q>>>0>4294967295)x=q;else{z=0;t=46;break a}}if(x>>>0<3){f[i>>2]=f[i>>2]|1;f[j>>2]=x;continue a}q=f[k>>2]|0;if(!(q&1))A=mNa(k)|0;else A=q&-2;rjc(A,1,x,((x|0)<0)<<31>>31);continue a;break}case 2:{switch((s&255)<<24>>24){case 21:break;case 18:{if(BVa(c,l)|0)continue a;else{z=0;t=46;break a}break}default:{w=s;break b}}q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){r=q;p=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=p;f[c>>2]=q+4;B=p}else{if(!(TRb(c,e)|0)){t=33;break a}B=f[e>>2]|0}p=f[l>>2]|0;if((p|0)==(f[m>>2]|0)){SHa(l,p+1|0);C=f[l>>2]|0}else C=p;p=f[n>>2]|0;q=C+1|0;f[l>>2]=q;f[p+4+(C<<2)>>2]=B;r=f[c>>2]|0;D=(f[g>>2]|0)-r|0;if((D|0)<=0)continue a;E=r;r=(f[m>>2]|0)-q|0;F=(D>>>0)/5|0;G=(F|0)<(r|0)?F:r;if((G|0)>0){H=0;I=E;K=q}else continue a;while(1){if((b[I>>0]|0)!=21){L=H;break}q=I+1|0;r=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=K;K=K+1|0;f[l>>2]=K;f[p+4+(q<<2)>>2]=r;r=H+1|0;if((r|0)>=(G|0)){L=r;break}else{H=r;I=I+5|0}}G=L*5|0;if((L|0)<=0)continue a;if((D|0)<(G|0)){PRb(c,G,D)|0;continue a}else{f[c>>2]=E+G;continue a}break}case 3:{if((s&255|0)!=24){w=s;break b}f[i>>2]=f[i>>2]|2;G=f[c>>2]|0;if(G>>>0<(f[g>>2]|0)>>>0?(p=b[G>>0]|0,p<<24>>24>-1):0){f[c>>2]=G+1;M=p<<24>>24!=0}else{IRb(e,c);p=e;if(!(b[a>>0]|0)){z=0;t=46;break a}else M=(f[p>>2]|0)!=0|(f[p+4>>2]|0)!=0}b[o>>0]=M&1;continue a;break}default:{w=s;break b}}}while(0);if(!w){z=1;t=46;break}p=f[k>>2]|0;if(!(p&1))N=mNa(k)|0;else N=p&-2;if(!(Djc(c,w,N)|0)){z=0;t=46;break}}if((t|0)==33){z=0;u=d;return z|0}else if((t|0)==46){u=d;return z|0}return 0}function w1a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+16>>2]|0;d=b+c+(b<<2)|0;b=f[a+8>>2]|0;if(!(b&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(b&1))h=d;else{c=f[a+28>>2]|0;if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+d|0}e=b&2|0?h+2|0:h;g=a+12|0;f[g>>2]=e;return e|0}function x1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&1|0)ZTb(1,f[a+28>>2]|0,c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{WTb(2,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}if(d&2|0)YTb(3,(b[a+32>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function y1a(a){a=a|0;return f[a+12>>2]|0}function z1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+28>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}o=f[a+16>>2]|0;if(!o)q=e;else{p=f[a+24>>2]|0;d=0;h=e;while(1){e=f[p+4+(d<<2)>>2]|0;b[h>>0]=21;l=h+1|0;b[l>>0]=e;b[l+1>>0]=e>>8;b[l+2>>0]=e>>16;b[l+3>>0]=e>>24;e=h+5|0;d=d+1|0;if((d|0)>=(o|0)){q=e;break}else h=e}}if(!(c&2))r=q;else{c=b[a+32>>0]|0;b[q>>0]=24;b[q+1>>0]=c;r=q+2|0}q=f[a+4>>2]|0;if(!(q&1)){s=r;return s|0}s=Hjc(q&-2,r)|0;return s|0}function A1a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function B1a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15352,0)|0;if(!c){Ehc(b,a);return}else{JYa(a,c);return}}function C1a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function D1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525328;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function E1a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function F1a(a){a=a|0;var b=0,c=0;f[a>>2]=90716;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function G1a(a){a=a|0;var b=0,c=0;f[a>>2]=90716;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function H1a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function I1a(a,b){a=a|0;b=b|0;a=VDc(28)|0;HYa(a);if(!b)return a|0;U1a(b,a);return a|0}function J1a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function K1a(a){a=a|0;return 1}function L1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+8|0;k=a+24|0;l=a+20|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;t=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[j>>0]|0)){v=0;q=29;break a}else t=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[i>>0]=t&1;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;n=o&255;if(o<<24>>24>-1){f[k>>2]=n;f[c>>2]=a+1;continue a}else w=n}else w=0;n=HRb(c,w)|0;a=J;f[k>>2]=n;if((a|0)>-1|(a|0)==-1&n>>>0>4294967295)continue a;else{v=0;q=29;break a}break}case 3:{if((p&255|0)!=24){s=p;break b}f[h>>2]=f[h>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){a=b[n>>0]|0;o=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;x=o}else{y=o;q=22}}else{y=0;q=22}if((q|0)==22){q=0;o=HRb(c,y)|0;n=J;if((n|0)>-1|(n|0)==-1&o>>>0>4294967295)x=o;else{v=0;q=29;break a}}f[l>>2]=x;continue a;break}default:{s=p;break b}}}while(0);if(!s){v=1;q=29;break}o=f[m>>2]|0;if(!(o&1))z=mNa(m)|0;else z=o&-2;if(!(Djc(c,s,z)|0)){v=0;q=29;break}}if((q|0)==29){u=d;return v|0}return 0}function M1a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+2|0:c;if(!(b&2))h=g;else{c=f[a+20>>2]|0;if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+g|0}if(!(b&4)){d=h;e=a+12|0;f[e>>2]=d;return d|0}d=h+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=a+12|0;f[e>>2]=d;return d|0}function N1a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)YTb(1,(b[a+16>>0]|0)!=0,c);if(d&4|0)OTb(2,f[a+24>>2]|0,c);if(d&2|0)MTb(3,f[a+20>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function O1a(a){a=a|0;return f[a+12>>2]|0}function P1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=b[a+16>>0]|0;b[d>>0]=8;b[d+1>>0]=g;e=d+2|0}if(!(c&4))h=e;else{d=f[a+24>>2]|0;b[e>>0]=16;g=e+1|0;if(d>>>0>127){e=d;i=g;while(1){b[i>>0]=e|128;j=e>>>7;k=i+1|0;if(e>>>0>16383){e=j;i=k}else{l=k;m=j;break}}}else{l=g;m=d}b[l>>0]=m;h=l+1|0}if(!(c&2))n=h;else{c=f[a+20>>2]|0;b[h>>0]=24;l=h+1|0;h=c&255;if(c>>>0>127){m=l;d=h;g=c;i=((c|0)<0)<<31>>31;while(1){b[m>>0]=d|-128;c=g;g=aJc(g|0,i|0,7)|0;e=m+1|0;j=g&255;if(!(i>>>0>0|(i|0)==0&c>>>0>16383)){o=e;p=j;break}else{m=e;d=j;i=J}}}else{o=l;p=h}b[o>>0]=p;n=o+1|0}o=f[a+4>>2]|0;if(!(o&1)){q=n;return q|0}q=Hjc(o&-2,n)|0;return q|0}function Q1a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function R1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,15368,0)|0;if(!d){Ehc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&7))return;if(e&1|0)b[a+16>>0]=b[d+16>>0]|0;if(e&2|0)f[a+20>>2]=f[d+20>>2];if(e&4|0)f[a+24>>2]=f[d+24>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function S1a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function T1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525232;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function U1a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function V1a(a){a=a|0;var b=0,c=0;f[a>>2]=90824;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function W1a(a){a=a|0;var b=0,c=0;f[a>>2]=90824;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function X1a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Y1a(a,b){a=a|0;b=b|0;a=VDc(32)|0;GYa(a);if(!b)return a|0;i2a(b,a);return a|0}function Z1a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&15|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function _1a(a){a=a|0;return 1}function $1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+24|0;j=a+28|0;k=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=WRb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}b:do if((o|0)==6){o=0;switch(n>>>3&536870911|0){case 1:{if((n&255|0)!=8){q=n;break b}f[e>>2]=f[e>>2]|1;m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){a=b[m>>0]|0;l=a&255;if(a<<24>>24>-1){f[g>>2]=l;f[c>>2]=m+1;continue a}else r=l}else r=0;l=HRb(c,r)|0;m=J;f[g>>2]=l;if((m|0)>-1|(m|0)==-1&l>>>0>4294967295)continue a;else{s=0;o=32;break a}break}case 2:{if((n&255|0)!=16){q=n;break b}f[e>>2]=f[e>>2]|2;l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){m=b[l>>0]|0;a=m&255;if(m<<24>>24>-1){f[h>>2]=a;f[c>>2]=l+1;continue a}else t=a}else t=0;a=HRb(c,t)|0;l=J;f[h>>2]=a;if((l|0)>-1|(l|0)==-1&a>>>0>4294967295)continue a;else{s=0;o=32;break a}break}case 3:{if((n&255|0)!=24){q=n;break b}f[e>>2]=f[e>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>-1){f[i>>2]=m;f[c>>2]=a+1;continue a}else u=m}else u=0;m=HRb(c,u)|0;a=J;f[i>>2]=m;if((a|0)>-1|(a|0)==-1&m>>>0>4294967295)continue a;else{s=0;o=32;break a}break}case 4:{if((n&255|0)!=32){q=n;break b}f[e>>2]=f[e>>2]|8;m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){a=b[m>>0]|0;l=a&255;if(a<<24>>24>-1){f[j>>2]=l;f[c>>2]=m+1;continue a}else v=l}else v=0;l=HRb(c,v)|0;m=J;f[j>>2]=l;if((m|0)>-1|(m|0)==-1&l>>>0>4294967295)continue a;else{s=0;o=32;break a}break}default:{q=n;break b}}}while(0);if(!q){s=1;o=32;break}l=f[k>>2]|0;if(!(l&1))w=mNa(k)|0;else w=l&-2;if(!(Djc(c,q,w)|0)){s=0;o=32;break}}if((o|0)==32)return s|0;return 0}function a2a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&15)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else g=c+1+((((($(f[a+16>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&2))h=g;else h=g+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&4))i=h;else i=h+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&8)){d=i;e=a+12|0;f[e>>2]=d;return d|0}d=i+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=a+12|0;f[e>>2]=d;return d|0}function b2a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)OTb(1,f[a+16>>2]|0,b);if(c&2|0)OTb(2,f[a+20>>2]|0,b);if(c&4|0)OTb(3,f[a+24>>2]|0,b);if(c&8|0)OTb(4,f[a+28>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function c2a(a){a=a|0;return f[a+12>>2]|0}function d2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{l=f[a+20>>2]|0;b[e>>0]=16;m=e+1|0;if(l>>>0>127){e=l;g=m;while(1){b[g>>0]=e|128;h=e>>>7;i=g+1|0;if(e>>>0>16383){e=h;g=i}else{o=i;p=h;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&4))q=n;else{o=f[a+24>>2]|0;b[n>>0]=24;p=n+1|0;if(o>>>0>127){n=o;l=p;while(1){b[l>>0]=n|128;m=n>>>7;g=l+1|0;if(n>>>0>16383){n=m;l=g}else{r=g;s=m;break}}}else{r=p;s=o}b[r>>0]=s;q=r+1|0}if(!(c&8))t=q;else{c=f[a+28>>2]|0;b[q>>0]=32;r=q+1|0;if(c>>>0>127){q=c;s=r;while(1){b[s>>0]=q|128;o=q>>>7;p=s+1|0;if(q>>>0>16383){q=o;s=p}else{u=p;v=o;break}}}else{u=r;v=c}b[u>>0]=v;t=u+1|0}u=f[a+4>>2]|0;if(!(u&1)){w=t;return w|0}w=Hjc(u&-2,t)|0;return w|0}function e2a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function f2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15384,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&15))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];if(d&8|0)f[a+28>>2]=f[c+28>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function g2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function h2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525440;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function i2a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function j2a(a){a=a|0;var b=0,c=0;f[a>>2]=90932;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function k2a(a){a=a|0;var b=0,c=0;f[a>>2]=90932;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function l2a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function m2a(a,b){a=a|0;b=b|0;a=VDc(28)|0;FYa(a);if(!b)return a|0;y2a(b,a);return a|0}function n2a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=1.0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function o2a(a){a=a|0;return 1}function p2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+24|0;l=a+16|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(TRb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=21){s=p;break b}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){o=n;a=h[o>>0]|h[o+1>>0]<<8|h[o+2>>0]<<16|h[o+3>>0]<<24;f[e>>2]=a;f[c>>2]=n+4;v=a}else{if(!(TRb(c,e)|0)){q=20;break a}v=f[e>>2]|0}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;w=o}else{if(!(TRb(c,e)|0)){q=27;break a}w=f[e>>2]|0}f[l>>2]=w;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=33;break}o=f[m>>2]|0;if(!(o&1))y=mNa(m)|0;else y=o&-2;if(!(Djc(c,s,y)|0)){x=0;q=33;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==20){x=0;u=d;return x|0}else if((q|0)==27){x=0;u=d;return x|0}else if((q|0)==33){u=d;return x|0}return 0}function q2a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;c=b&2|0?g+5|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function r2a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)WTb(1,+n[a+20>>2],b);if(c&4|0)WTb(2,+n[a+24>>2],b);if(c&1|0)WTb(3,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function s2a(a){a=a|0;return f[a+12>>2]|0}function t2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&4))i=e;else{d=f[a+24>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}if(!(c&1))j=i;else{c=f[a+16>>2]|0;b[i>>0]=29;e=i+1|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;j=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Hjc(i&-2,j)|0;return k|0}function u2a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function v2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15400,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function w2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function x2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525472;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function y2a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function z2a(a){a=a|0;var b=0,c=0;f[a>>2]=91040;P2a(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function A2a(a){a=a|0;z2a(a);YDc(a);return}function B2a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function C2a(a,b){a=a|0;b=b|0;a=VDc(64)|0;DYa(a);if(!b)return a|0;O2a(b,a);return a|0}function D2a(a){a=a|0;var c=0,e=0,g=0,h=0;c=a+8|0;e=f[c>>2]|0;do if(e&15|0){do if(e&1|0){g=f[a+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);do if(e&2|0){h=f[a+20>>2]|0;g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}while(0);if(e&4|0)iEc(f[a+24>>2]|0,525048)|0;if(e&8|0){g=f[a+28>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}}while(0);if(e&240|0){h=a+32|0;f[h>>2]=0;f[h+4>>2]=0;d[h+8>>1]=0}if(e&7936|0){f[a+44>>2]=0;n[a+48>>2]=1.0;n[a+52>>2]=.5;n[a+56>>2]=.5;n[a+60>>2]=.25}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function E2a(a){a=a|0;return 1}function F2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+48|0;l=a+20|0;m=a+32|0;n=a+36|0;o=a+40|0;p=e+8|0;q=a+52|0;r=a+56|0;s=a+60|0;t=a+44|0;v=a+24|0;w=a+41|0;x=e+8|0;y=a+28|0;z=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=a+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=WRb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;do switch(C>>>3&536870911|0){case 1:{if((C&255|0)!=10){F=C;break b}f[i>>2]=f[i>>2]|1;B=f[j>>2]|0;if((B|0)==527320){GLa(j,527320);G=f[j>>2]|0}else G=B;if(fUb(c,G)|0)continue a;else{H=0;D=83;break a}break}case 2:{if((C&255|0)!=21){F=C;break b}f[i>>2]=f[i>>2]|512;B=f[c>>2]|0;if(((f[g>>2]|0)-B|0)>3){a=B;A=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=A;f[c>>2]=B+4;I=A}else{if(!(TRb(c,e)|0)){D=17;break a}I=f[e>>2]|0}f[k>>2]=I;continue a;break}case 3:{if((C&255|0)!=26){F=C;break b}f[i>>2]=f[i>>2]|2;A=f[l>>2]|0;if((A|0)==527320){GLa(l,527320);K=f[l>>2]|0}else K=A;if(fUb(c,K)|0)continue a;else{H=0;D=83;break a}break}case 4:{if((C&255|0)!=32){F=C;break b}f[i>>2]=f[i>>2]|16;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){B=b[A>>0]|0;a=B&255;if(B<<24>>24>-1){f[m>>2]=a;f[c>>2]=A+1;continue a}else L=a}else L=0;a=HRb(c,L)|0;A=J;f[m>>2]=a;if((A|0)>-1|(A|0)==-1&a>>>0>4294967295)continue a;else{H=0;D=83;break a}break}case 5:{if((C&255|0)!=40){F=C;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>-1){f[n>>2]=B;f[c>>2]=a+1;continue a}else M=B}else M=0;B=HRb(c,M)|0;a=J;f[n>>2]=B;if((a|0)>-1|(a|0)==-1&B>>>0>4294967295)continue a;else{H=0;D=83;break a}break}case 6:{if((C&255|0)!=48){F=C;break b}f[i>>2]=f[i>>2]|64;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(a=b[B>>0]|0,a<<24>>24>-1):0){f[c>>2]=B+1;N=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[p>>0]|0)){H=0;D=83;break a}else N=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[o>>0]=N&1;continue a;break}case 7:{if((C&255|0)!=61){F=C;break b}f[i>>2]=f[i>>2]|1024;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){B=a;A=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[e>>2]=A;f[c>>2]=a+4;O=A}else{if(!(TRb(c,e)|0)){D=44;break a}O=f[e>>2]|0}f[q>>2]=O;continue a;break}case 8:{if((C&255|0)!=69){F=C;break b}f[i>>2]=f[i>>2]|2048;A=f[c>>2]|0;if(((f[g>>2]|0)-A|0)>3){a=A;B=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=B;f[c>>2]=A+4;P=B}else{if(!(TRb(c,e)|0)){D=51;break a}P=f[e>>2]|0}f[r>>2]=P;continue a;break}case 9:{if((C&255|0)!=77){F=C;break b}f[i>>2]=f[i>>2]|4096;B=f[c>>2]|0;if(((f[g>>2]|0)-B|0)>3){A=B;a=h[A>>0]|h[A+1>>0]<<8|h[A+2>>0]<<16|h[A+3>>0]<<24;f[e>>2]=a;f[c>>2]=B+4;Q=a}else{if(!(TRb(c,e)|0)){D=58;break a}Q=f[e>>2]|0}f[s>>2]=Q;continue a;break}case 10:{if((C&255|0)!=80){F=C;break b}f[i>>2]=f[i>>2]|256;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){B=b[a>>0]|0;A=B&255;if(B<<24>>24>-1){f[t>>2]=A;f[c>>2]=a+1;continue a}else R=A}else R=0;A=HRb(c,R)|0;a=J;f[t>>2]=A;if((a|0)>-1|(a|0)==-1&A>>>0>4294967295)continue a;else{H=0;D=83;break a}break}case 11:{if((C&255|0)!=90){F=C;break b}f[i>>2]=f[i>>2]|4;A=f[v>>2]|0;if((A|0)==525048){GLa(v,525048);S=f[v>>2]|0}else S=A;if(fUb(c,S)|0)continue a;else{H=0;D=83;break a}break}case 12:{if((C&255|0)!=96){F=C;break b}f[i>>2]=f[i>>2]|128;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){f[c>>2]=A+1;T=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[x>>0]|0)){H=0;D=83;break a}else T=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[w>>0]=T&1;continue a;break}case 13:{if((C&255|0)!=106){F=C;break b}f[i>>2]=f[i>>2]|8;a=f[y>>2]|0;if((a|0)==527320){GLa(y,527320);U=f[y>>2]|0}else U=a;if(fUb(c,U)|0)continue a;else{H=0;D=83;break a}break}default:{F=C;break b}}while(0)}while(0);if(!F){H=1;D=83;break}a=f[z>>2]|0;if(!(a&1))V=mNa(z)|0;else V=a&-2;if(!(Djc(c,F,V)|0)){H=0;D=83;break}}if((D|0)==17){H=0;u=d;return H|0}else if((D|0)==44){H=0;u=d;return H|0}else if((D|0)==51){H=0;u=d;return H|0}else if((D|0)==58){H=0;u=d;return H|0}else if((D|0)==83){u=d;return H|0}return 0}function G2a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&255))e=d;else{if(!(c&1))g=d;else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0?f[h+4>>2]|0:i&255;g=d+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))k=g;else{j=f[a+20>>2]|0;d=b[j+11>>0]|0;i=d<<24>>24<0?f[j+4>>2]|0:d&255;k=g+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))l=k;else{i=f[a+24>>2]|0;g=b[i+11>>0]|0;d=g<<24>>24<0?f[i+4>>2]|0:g&255;l=k+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8))m=l;else{d=f[a+28>>2]|0;k=b[d+11>>0]|0;g=k<<24>>24<0?f[d+4>>2]|0:k&255;m=l+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&16))n=m;else n=m+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&32))o=n;else o=n+1+((((($(f[a+36>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=c&64|0?o+2|0:o;e=c&128|0?n+2|0:n}if(!(c&7936)){p=e;q=a+12|0;f[q>>2]=p;return p|0}if(!(c&256))r=e;else r=e+1+((((($(f[a+44>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=c&512|0?r+5|0:r;r=c&1024|0?e+5|0:e;e=c&2048|0?r+5|0:r;p=c&4096|0?e+5|0:e;q=a+12|0;f[q>>2]=p;return p|0}function H2a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)$Tb(1,f[a+16>>2]|0,c);if(d&512|0)WTb(2,+n[a+48>>2],c);if(d&2|0)$Tb(3,f[a+20>>2]|0,c);if(d&16|0)OTb(4,f[a+32>>2]|0,c);if(d&32|0)OTb(5,f[a+36>>2]|0,c);if(d&64|0)YTb(6,(b[a+40>>0]|0)!=0,c);if(d&1024|0)WTb(7,+n[a+52>>2],c);if(d&2048|0)WTb(8,+n[a+56>>2],c);if(d&4096|0)WTb(9,+n[a+60>>2],c);if(d&256|0)OTb(10,f[a+44>>2]|0,c);if(d&4|0)$Tb(11,f[a+24>>2]|0,c);if(d&128|0)YTb(12,(b[a+41>>0]|0)!=0,c);if(d&8|0)$Tb(13,f[a+28>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function I2a(a){a=a|0;return f[a+12>>2]|0}function J2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&512))h=e;else{d=f[a+48>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&2))i=h;else{e=f[a+20>>2]|0;b[h>>0]=26;i=dSb(e,h+1|0)|0}if(!(c&16))j=i;else{h=f[a+32>>2]|0;b[i>>0]=32;e=i+1|0;if(h>>>0>127){i=h;d=e;while(1){b[d>>0]=i|128;g=i>>>7;k=d+1|0;if(i>>>0>16383){i=g;d=k}else{l=k;m=g;break}}}else{l=e;m=h}b[l>>0]=m;j=l+1|0}if(!(c&32))n=j;else{l=f[a+36>>2]|0;b[j>>0]=40;m=j+1|0;if(l>>>0>127){j=l;h=m;while(1){b[h>>0]=j|128;e=j>>>7;d=h+1|0;if(j>>>0>16383){j=e;h=d}else{o=d;p=e;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&64))q=n;else{o=b[a+40>>0]|0;b[n>>0]=48;b[n+1>>0]=o;q=n+2|0}if(!(c&1024))r=q;else{n=f[a+52>>2]|0;b[q>>0]=61;o=q+1|0;b[o>>0]=n;b[o+1>>0]=n>>8;b[o+2>>0]=n>>16;b[o+3>>0]=n>>24;r=q+5|0}if(!(c&2048))s=r;else{q=f[a+56>>2]|0;b[r>>0]=69;n=r+1|0;b[n>>0]=q;b[n+1>>0]=q>>8;b[n+2>>0]=q>>16;b[n+3>>0]=q>>24;s=r+5|0}if(!(c&4096))t=s;else{r=f[a+60>>2]|0;b[s>>0]=77;q=s+1|0;b[q>>0]=r;b[q+1>>0]=r>>8;b[q+2>>0]=r>>16;b[q+3>>0]=r>>24;t=s+5|0}if(!(c&256))u=t;else{s=f[a+44>>2]|0;b[t>>0]=80;r=t+1|0;if(s>>>0>127){t=s;q=r;while(1){b[q>>0]=t|128;n=t>>>7;o=q+1|0;if(t>>>0>16383){t=n;q=o}else{v=o;w=n;break}}}else{v=r;w=s}b[v>>0]=w;u=v+1|0}if(!(c&4))x=u;else{v=f[a+24>>2]|0;b[u>>0]=90;x=dSb(v,u+1|0)|0}if(!(c&128))y=x;else{u=b[a+41>>0]|0;b[x>>0]=96;b[x+1>>0]=u;y=x+2|0}if(!(c&8))z=y;else{c=f[a+28>>2]|0;b[y>>0]=106;z=dSb(c,y+1|0)|0}y=f[a+4>>2]|0;if(!(y&1)){A=z;return A|0}A=Hjc(y&-2,z)|0;return A|0}function K2a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function L2a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15416,0)|0;if(!c){Ehc(b,a);return}else{EYa(a,c);return}}function M2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function N2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525576;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function O2a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function P2a(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if(!((c|0)==525048|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+28>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function Q2a(a){a=a|0;var b=0,c=0;f[a>>2]=91148;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function R2a(a){a=a|0;var b=0,c=0;f[a>>2]=91148;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function S2a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function T2a(a,b){a=a|0;b=b|0;a=VDc(68)|0;BYa(a);if(!b)return a|0;d3a(b,a);return a|0}function U2a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0}if(d&7936|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+60>>2]=1;b[a+64>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function V2a(a){a=a|0;return 1}function W2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;l=a+60|0;m=a+24|0;n=a+28|0;o=a+32|0;p=a+36|0;q=a+40|0;r=a+44|0;s=a+48|0;t=a+52|0;v=a+56|0;w=e+8|0;x=a+64|0;a=e+8|0;a:while(1){y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>0){f[c>>2]=y+1;B=A;C=6}else{D=A;C=5}}else{D=0;C=5}if((C|0)==5){C=0;A=WRb(c,D)|0;if((A+-1|0)>>>0<127){B=A;C=6}else E=A}b:do if((C|0)==6){C=0;do switch(B>>>3&536870911|0){case 1:{if((B&255|0)!=8){E=B;break b}A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){y=b[A>>0]|0;z=y&255;if(y<<24>>24>-1){f[c>>2]=A+1;F=z}else{G=z;C=11}}else{G=0;C=11}if((C|0)==11){C=0;z=HRb(c,G)|0;A=J;if((A|0)>-1|(A|0)==-1&z>>>0>4294967295)F=z;else{H=0;C=91;break a}}if(F>>>0<3){f[h>>2]=f[h>>2]|1;f[i>>2]=F;continue a}z=f[j>>2]|0;if(!(z&1))I=mNa(j)|0;else I=z&-2;rjc(I,1,F,((F|0)<0)<<31>>31);continue a;break}case 2:{if((B&255|0)!=16){E=B;break b}f[h>>2]=f[h>>2]|2;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;y=A&255;if(A<<24>>24>-1){f[k>>2]=y;f[c>>2]=z+1;continue a}else K=y}else K=0;y=HRb(c,K)|0;z=J;f[k>>2]=y;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 3:{if((B&255|0)!=24){E=B;break b}f[h>>2]=f[h>>2]|2048;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>-1){f[l>>2]=A;f[c>>2]=y+1;continue a}else L=A}else L=0;A=HRb(c,L)|0;y=J;f[l>>2]=A;if((y|0)>-1|(y|0)==-1&A>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 4:{if((B&255|0)!=32){E=B;break b}f[h>>2]=f[h>>2]|4;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){y=b[A>>0]|0;z=y&255;if(y<<24>>24>-1){f[m>>2]=z;f[c>>2]=A+1;continue a}else M=z}else M=0;z=HRb(c,M)|0;A=J;f[m>>2]=z;if((A|0)>-1|(A|0)==-1&z>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 5:{if((B&255|0)!=40){E=B;break b}f[h>>2]=f[h>>2]|8;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;y=A&255;if(A<<24>>24>-1){f[n>>2]=y;f[c>>2]=z+1;continue a}else N=y}else N=0;y=HRb(c,N)|0;z=J;f[n>>2]=y;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 6:{if((B&255|0)!=48){E=B;break b}f[h>>2]=f[h>>2]|16;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>-1){f[o>>2]=A;f[c>>2]=y+1;continue a}else O=A}else O=0;A=HRb(c,O)|0;y=J;f[o>>2]=A;if((y|0)>-1|(y|0)==-1&A>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 7:{if((B&255|0)!=56){E=B;break b}f[h>>2]=f[h>>2]|32;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){y=b[A>>0]|0;z=y&255;if(y<<24>>24>-1){f[p>>2]=z;f[c>>2]=A+1;continue a}else P=z}else P=0;z=HRb(c,P)|0;A=J;f[p>>2]=z;if((A|0)>-1|(A|0)==-1&z>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 8:{if((B&255|0)!=64){E=B;break b}f[h>>2]=f[h>>2]|64;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;y=A&255;if(A<<24>>24>-1){f[q>>2]=y;f[c>>2]=z+1;continue a}else Q=y}else Q=0;y=HRb(c,Q)|0;z=J;f[q>>2]=y;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 9:{if((B&255|0)!=72){E=B;break b}f[h>>2]=f[h>>2]|128;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>-1){f[r>>2]=A;f[c>>2]=y+1;continue a}else R=A}else R=0;A=HRb(c,R)|0;y=J;f[r>>2]=A;if((y|0)>-1|(y|0)==-1&A>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 10:{if((B&255|0)!=80){E=B;break b}f[h>>2]=f[h>>2]|256;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){y=b[A>>0]|0;z=y&255;if(y<<24>>24>-1){f[s>>2]=z;f[c>>2]=A+1;continue a}else S=z}else S=0;z=HRb(c,S)|0;A=J;f[s>>2]=z;if((A|0)>-1|(A|0)==-1&z>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 11:{if((B&255|0)!=88){E=B;break b}z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;y=A&255;if(A<<24>>24>-1){f[c>>2]=z+1;T=y}else{U=y;C=67}}else{U=0;C=67}if((C|0)==67){C=0;y=HRb(c,U)|0;z=J;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)T=y;else{H=0;C=91;break a}}if(T>>>0<3){f[h>>2]=f[h>>2]|512;f[t>>2]=T;continue a}y=f[j>>2]|0;if(!(y&1))V=mNa(j)|0;else V=y&-2;rjc(V,11,T,((T|0)<0)<<31>>31);continue a;break}case 12:{if((B&255|0)!=96){E=B;break b}f[h>>2]=f[h>>2]|1024;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(z=b[y>>0]|0,z<<24>>24>-1):0){f[c>>2]=y+1;W=z<<24>>24!=0}else{IRb(e,c);z=e;if(!(b[w>>0]|0)){H=0;C=91;break a}else W=(f[z>>2]|0)!=0|(f[z+4>>2]|0)!=0}b[v>>0]=W&1;continue a;break}case 13:{if((B&255|0)!=104){E=B;break b}f[h>>2]=f[h>>2]|4096;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(y=b[z>>0]|0,y<<24>>24>-1):0){f[c>>2]=z+1;X=y<<24>>24!=0}else{IRb(e,c);y=e;if(!(b[a>>0]|0)){H=0;C=91;break a}else X=(f[y>>2]|0)!=0|(f[y+4>>2]|0)!=0}b[x>>0]=X&1;continue a;break}default:{E=B;break b}}while(0)}while(0);if(!E){H=1;C=91;break}y=f[j>>2]|0;if(!(y&1))Y=mNa(j)|0;else Y=y&-2;if(!(Djc(c,E,Y)|0)){H=0;C=91;break}}if((C|0)==91){u=d;return H|0}return 0}function X2a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(b&255){if(!(b&1))d=c;else{e=f[a+16>>2]|0;if((e|0)<0)g=11;else g=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=g+c|0}if(!(b&2))h=d;else h=d+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&4))i=h;else i=h+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&8))j=i;else j=i+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&16))k=j;else k=j+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&32))l=k;else l=k+1+((((($(f[a+36>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&64))m=l;else m=l+1+((((($(f[a+40>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&128))n=m;else n=m+1+((((($(f[a+44>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else n=c;if(!(b&7936)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(b&256))q=n;else q=n+1+((((($(f[a+48>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&512))r=q;else{n=f[a+52>>2]|0;if((n|0)<0)s=11;else s=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+q|0}q=b&1024|0?r+2|0:r;if(!(b&2048))t=q;else t=q+1+((((($(f[a+60>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;o=b&4096|0?t+2|0:t;p=a+12|0;f[p>>2]=o;return o|0}function Y2a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)ZTb(1,f[a+16>>2]|0,c);if(d&2|0)OTb(2,f[a+20>>2]|0,c);if(d&2048|0)OTb(3,f[a+60>>2]|0,c);if(d&4|0)OTb(4,f[a+24>>2]|0,c);if(d&8|0)OTb(5,f[a+28>>2]|0,c);if(d&16|0)OTb(6,f[a+32>>2]|0,c);if(d&32|0)OTb(7,f[a+36>>2]|0,c);if(d&64|0)OTb(8,f[a+40>>2]|0,c);if(d&128|0)OTb(9,f[a+44>>2]|0,c);if(d&256|0)OTb(10,f[a+48>>2]|0,c);if(d&512|0)ZTb(11,f[a+52>>2]|0,c);if(d&1024|0)YTb(12,(b[a+56>>0]|0)!=0,c);if(d&4096|0)YTb(13,(b[a+64>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Z2a(a){a=a|0;return f[a+12>>2]|0}function _2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{o=f[a+20>>2]|0;b[e>>0]=16;p=e+1|0;if(o>>>0>127){e=o;d=p;while(1){b[d>>0]=e|128;h=e>>>7;l=d+1|0;if(e>>>0>16383){e=h;d=l}else{r=l;s=h;break}}}else{r=p;s=o}b[r>>0]=s;q=r+1|0}if(!(c&2048))t=q;else{r=f[a+60>>2]|0;b[q>>0]=24;s=q+1|0;if(r>>>0>127){q=r;o=s;while(1){b[o>>0]=q|128;p=q>>>7;d=o+1|0;if(q>>>0>16383){q=p;o=d}else{u=d;v=p;break}}}else{u=s;v=r}b[u>>0]=v;t=u+1|0}if(!(c&4))w=t;else{u=f[a+24>>2]|0;b[t>>0]=32;v=t+1|0;if(u>>>0>127){t=u;r=v;while(1){b[r>>0]=t|128;s=t>>>7;o=r+1|0;if(t>>>0>16383){t=s;r=o}else{x=o;y=s;break}}}else{x=v;y=u}b[x>>0]=y;w=x+1|0}if(!(c&8))z=w;else{x=f[a+28>>2]|0;b[w>>0]=40;y=w+1|0;if(x>>>0>127){w=x;u=y;while(1){b[u>>0]=w|128;v=w>>>7;r=u+1|0;if(w>>>0>16383){w=v;u=r}else{A=r;B=v;break}}}else{A=y;B=x}b[A>>0]=B;z=A+1|0}if(!(c&16))C=z;else{A=f[a+32>>2]|0;b[z>>0]=48;B=z+1|0;if(A>>>0>127){z=A;x=B;while(1){b[x>>0]=z|128;y=z>>>7;u=x+1|0;if(z>>>0>16383){z=y;x=u}else{D=u;E=y;break}}}else{D=B;E=A}b[D>>0]=E;C=D+1|0}if(!(c&32))F=C;else{D=f[a+36>>2]|0;b[C>>0]=56;E=C+1|0;if(D>>>0>127){C=D;A=E;while(1){b[A>>0]=C|128;B=C>>>7;x=A+1|0;if(C>>>0>16383){C=B;A=x}else{G=x;H=B;break}}}else{G=E;H=D}b[G>>0]=H;F=G+1|0}if(!(c&64))I=F;else{G=f[a+40>>2]|0;b[F>>0]=64;H=F+1|0;if(G>>>0>127){F=G;D=H;while(1){b[D>>0]=F|128;E=F>>>7;A=D+1|0;if(F>>>0>16383){F=E;D=A}else{K=A;L=E;break}}}else{K=H;L=G}b[K>>0]=L;I=K+1|0}if(!(c&128))M=I;else{K=f[a+44>>2]|0;b[I>>0]=72;L=I+1|0;if(K>>>0>127){I=K;G=L;while(1){b[G>>0]=I|128;H=I>>>7;D=G+1|0;if(I>>>0>16383){I=H;G=D}else{N=D;O=H;break}}}else{N=L;O=K}b[N>>0]=O;M=N+1|0}if(!(c&256))P=M;else{N=f[a+48>>2]|0;b[M>>0]=80;O=M+1|0;if(N>>>0>127){M=N;K=O;while(1){b[K>>0]=M|128;L=M>>>7;G=K+1|0;if(M>>>0>16383){M=L;K=G}else{Q=G;R=L;break}}}else{Q=O;R=N}b[Q>>0]=R;P=Q+1|0}if(!(c&512))S=P;else{Q=f[a+52>>2]|0;b[P>>0]=88;R=P+1|0;P=Q&255;if(Q>>>0>127){N=R;O=P;K=Q;M=((Q|0)<0)<<31>>31;while(1){b[N>>0]=O|-128;Q=K;K=aJc(K|0,M|0,7)|0;L=N+1|0;G=K&255;if(!(M>>>0>0|(M|0)==0&Q>>>0>16383)){T=L;U=G;break}else{N=L;O=G;M=J}}}else{T=R;U=P}b[T>>0]=U;S=T+1|0}if(!(c&1024))V=S;else{T=b[a+56>>0]|0;b[S>>0]=96;b[S+1>>0]=T;V=S+2|0}if(!(c&4096))W=V;else{c=b[a+64>>0]|0;b[V>>0]=104;b[V+1>>0]=c;W=V+2|0}V=f[a+4>>2]|0;if(!(V&1)){X=W;return X|0}X=Hjc(V&-2,W)|0;return X|0}function $2a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function a3a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15432,0)|0;if(!c){Ehc(b,a);return}else{CYa(a,c);return}}function b3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function c3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525464;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function d3a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function e3a(a){a=a|0;var b=0,c=0;f[a>>2]=91256;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function f3a(a){a=a|0;var b=0,c=0;f[a>>2]=91256;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function g3a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function h3a(a,b){a=a|0;b=b|0;a=VDc(40)|0;zYa(a);if(!b)return a|0;t3a(b,a);return a|0}function i3a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&63|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=5;n[a+28>>2]=1.0;n[a+32>>2]=.75;n[a+36>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function j3a(a){a=a|0;return 1}function k3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+24|0;k=a+28|0;l=a+32|0;m=a+16|0;n=a+4|0;o=a+36|0;p=a+20|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=a+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=WRb(c,v)|0;if((r+-1|0)>>>0<127){s=r;t=6}else w=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{if((s&255|0)!=8){w=s;break b}f[i>>2]=f[i>>2]|4;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){a=b[r>>0]|0;q=a&255;if(a<<24>>24>-1){f[j>>2]=q;f[c>>2]=r+1;continue a}else x=q}else x=0;q=HRb(c,x)|0;r=J;f[j>>2]=q;if((r|0)>-1|(r|0)==-1&q>>>0>4294967295)continue a;else{y=0;t=60;break a}break}case 2:{if((s&255|0)!=21){w=s;break b}f[i>>2]=f[i>>2]|8;q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){r=q;a=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=a;f[c>>2]=q+4;z=a}else{if(!(TRb(c,e)|0)){t=18;break a}z=f[e>>2]|0}f[k>>2]=z;continue a;break}case 3:{if((s&255|0)!=29){w=s;break b}f[i>>2]=f[i>>2]|16;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){q=a;r=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[e>>2]=r;f[c>>2]=a+4;A=r}else{if(!(TRb(c,e)|0)){t=25;break a}A=f[e>>2]|0}f[l>>2]=A;continue a;break}case 4:{if((s&255|0)!=32){w=s;break b}r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){a=b[r>>0]|0;q=a&255;if(a<<24>>24>-1){f[c>>2]=r+1;B=q}else{C=q;t=30}}else{C=0;t=30}if((t|0)==30){t=0;q=HRb(c,C)|0;r=J;if((r|0)>-1|(r|0)==-1&q>>>0>4294967295)B=q;else{y=0;t=60;break a}}if(B>>>0<2){f[i>>2]=f[i>>2]|1;f[m>>2]=B;continue a}q=f[n>>2]|0;if(!(q&1))D=mNa(n)|0;else D=q&-2;rjc(D,4,B,((B|0)<0)<<31>>31);continue a;break}case 5:{if((s&255|0)!=45){w=s;break b}f[i>>2]=f[i>>2]|32;q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){r=q;a=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=a;f[c>>2]=q+4;E=a}else{if(!(TRb(c,e)|0)){t=43;break a}E=f[e>>2]|0}f[o>>2]=E;continue a;break}case 6:{if((s&255|0)!=48){w=s;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>-1){f[c>>2]=a+1;F=r}else{G=r;t=48}}else{G=0;t=48}if((t|0)==48){t=0;r=HRb(c,G)|0;a=J;if((a|0)>-1|(a|0)==-1&r>>>0>4294967295)F=r;else{y=0;t=60;break a}}if(F>>>0<3){f[i>>2]=f[i>>2]|2;f[p>>2]=F;continue a}r=f[n>>2]|0;if(!(r&1))H=mNa(n)|0;else H=r&-2;rjc(H,6,F,((F|0)<0)<<31>>31);continue a;break}default:{w=s;break b}}}while(0);if(!w){y=1;t=60;break}r=f[n>>2]|0;if(!(r&1))I=mNa(n)|0;else I=r&-2;if(!(Djc(c,w,I)|0)){y=0;t=60;break}}if((t|0)==18){y=0;u=d;return y|0}else if((t|0)==25){y=0;u=d;return y|0}else if((t|0)==43){y=0;u=d;return y|0}else if((t|0)==60){u=d;return y|0}return 0}function l3a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&63)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2))j=g;else{c=f[a+20>>2]|0;if((c|0)<0)k=11;else k=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=k+g|0}if(!(b&4))l=j;else l=j+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=b&8|0?l+5|0:l;l=b&16|0?j+5|0:j;d=b&32|0?l+5|0:l;e=a+12|0;f[e>>2]=d;return d|0}function m3a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&4|0)OTb(1,f[a+24>>2]|0,b);if(c&8|0)WTb(2,+n[a+28>>2],b);if(c&16|0)WTb(3,+n[a+32>>2],b);if(c&1|0)ZTb(4,f[a+16>>2]|0,b);if(c&32|0)WTb(5,+n[a+36>>2],b);if(c&2|0)ZTb(6,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function n3a(a){a=a|0;return f[a+12>>2]|0}function o3a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=f[a+8>>2]|0;if(!(c&4))e=d;else{g=f[a+24>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&8))n=e;else{l=f[a+28>>2]|0;b[e>>0]=21;m=e+1|0;b[m>>0]=l;b[m+1>>0]=l>>8;b[m+2>>0]=l>>16;b[m+3>>0]=l>>24;n=e+5|0}if(!(c&16))o=n;else{e=f[a+32>>2]|0;b[n>>0]=29;l=n+1|0;b[l>>0]=e;b[l+1>>0]=e>>8;b[l+2>>0]=e>>16;b[l+3>>0]=e>>24;o=n+5|0}if(!(c&1))p=o;else{n=f[a+16>>2]|0;b[o>>0]=32;e=o+1|0;o=n&255;if(n>>>0>127){l=e;m=o;g=n;h=((n|0)<0)<<31>>31;while(1){b[l>>0]=m|-128;n=g;g=aJc(g|0,h|0,7)|0;i=l+1|0;d=g&255;if(!(h>>>0>0|(h|0)==0&n>>>0>16383)){q=i;r=d;break}else{l=i;m=d;h=J}}}else{q=e;r=o}b[q>>0]=r;p=q+1|0}if(!(c&32))s=p;else{q=f[a+36>>2]|0;b[p>>0]=45;r=p+1|0;b[r>>0]=q;b[r+1>>0]=q>>8;b[r+2>>0]=q>>16;b[r+3>>0]=q>>24;s=p+5|0}if(!(c&2))t=s;else{c=f[a+20>>2]|0;b[s>>0]=48;p=s+1|0;s=c&255;if(c>>>0>127){q=p;r=s;o=c;e=((c|0)<0)<<31>>31;while(1){b[q>>0]=r|-128;c=o;o=aJc(o|0,e|0,7)|0;h=q+1|0;m=o&255;if(!(e>>>0>0|(e|0)==0&c>>>0>16383)){u=h;v=m;break}else{q=h;r=m;e=J}}}else{u=p;v=s}b[u>>0]=v;t=u+1|0}u=f[a+4>>2]|0;if(!(u&1)){w=t;return w|0}w=Hjc(u&-2,t)|0;return w|0}function p3a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function q3a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15448,0)|0;if(!c){Ehc(b,a);return}else{AYa(a,c);return}}function r3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function s3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525432;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function t3a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function u3a(a){a=a|0;var b=0,c=0;f[a>>2]=91364;if((a|0)!=523528){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function v3a(a){a=a|0;u3a(a);YDc(a);return}function w3a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function x3a(a,b){a=a|0;b=b|0;a=VDc(36)|0;xYa(a);if(!b)return a|0;J3a(b,a);return a|0}function y3a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+16>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2|0){e=f[a+20>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d&60|0){d=a+24|0;f[d>>2]=0;b[d+4>>0]=0;b[a+29>>0]=1;f[a+32>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function z3a(a){a=a|0;return 1}function A3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+24|0;j=a+29|0;k=e+8|0;l=a+16|0;m=e+4|0;n=a+20|0;o=e+4|0;p=a+32|0;q=a+28|0;r=e+8|0;s=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){t=b[a>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=a+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=WRb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=8){z=w;break b}f[h>>2]=f[h>>2]|4;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){a=b[v>>0]|0;t=a&255;if(a<<24>>24>-1){f[i>>2]=t;f[c>>2]=v+1;continue a}else A=t}else A=0;t=HRb(c,A)|0;v=J;f[i>>2]=t;if((v|0)>-1|(v|0)==-1&t>>>0>4294967295)continue a;else{B=0;x=57;break a}break}case 2:{if((w&255|0)!=16){z=w;break b}f[h>>2]=f[h>>2]|16;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(v=b[t>>0]|0,v<<24>>24>-1):0){f[c>>2]=t+1;C=v<<24>>24!=0}else{IRb(e,c);v=e;if(!(b[k>>0]|0)){B=0;x=57;break a}else C=(f[v>>2]|0)!=0|(f[v+4>>2]|0)!=0}b[j>>0]=C&1;continue a;break}case 3:{if((w&255|0)!=26){z=w;break b}f[h>>2]=f[h>>2]|1;v=f[l>>2]|0;if(!v){t=VDc(48)|0;BWa(t);f[l>>2]=t;D=t}else D=v;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(t=b[v>>0]|0,t<<24>>24>-1):0){f[c>>2]=v+1;E=t&255}else{t=VRb(c)|0;if((t|0)>-1)E=t;else{B=0;x=57;break a}}GRb(e,c,E);if((f[m>>2]|0)<0){x=27;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){x=27;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;x=57;break a}break}case 4:{if((w&255|0)!=34){z=w;break b}f[h>>2]=f[h>>2]|2;t=f[n>>2]|0;if(!t){v=VDc(48)|0;BWa(v);f[n>>2]=v;F=v}else F=t;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(v=b[t>>0]|0,v<<24>>24>-1):0){f[c>>2]=t+1;G=v&255}else{v=VRb(c)|0;if((v|0)>-1)G=v;else{B=0;x=57;break a}}GRb(e,c,G);if((f[o>>2]|0)<0){x=38;break a}if(!(Mi[f[(f[F>>2]|0)+44>>2]&1023](F,c)|0)){x=38;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;x=57;break a}break}case 5:{if((w&255|0)!=40){z=w;break b}f[h>>2]=f[h>>2]|32;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){t=b[v>>0]|0;a=t&255;if(t<<24>>24>-1){f[c>>2]=v+1;H=a}else{I=a;x=44}}else{I=0;x=44}if((x|0)==44){x=0;a=HRb(c,I)|0;v=J;if((v|0)>-1|(v|0)==-1&a>>>0>4294967295)H=a;else{B=0;x=57;break a}}f[p>>2]=H;continue a;break}case 6:{if((w&255|0)!=48){z=w;break b}f[h>>2]=f[h>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(v=b[a>>0]|0,v<<24>>24>-1):0){f[c>>2]=a+1;K=v<<24>>24!=0}else{IRb(e,c);v=e;if(!(b[r>>0]|0)){B=0;x=57;break a}else K=(f[v>>2]|0)!=0|(f[v+4>>2]|0)!=0}b[q>>0]=K&1;continue a;break}default:{z=w;break b}}}while(0);if(!z){B=1;x=57;break}v=f[s>>2]|0;if(!(v&1))L=mNa(s)|0;else L=v&-2;if(!(Djc(c,z,L)|0)){B=0;x=57;break}}if((x|0)==27){B=0;u=d;return B|0}else if((x|0)==38){B=0;u=d;return B|0}else if((x|0)==57){u=d;return B|0}return 0}function B3a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&63)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){k=h;l=i}else{i=f[a+20>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=i;l=f[b>>2]|0}if(!(l&4))m=k;else m=k+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=l&8|0?m+2|0:m;m=l&16|0?k+2|0:k;if(!(l&32)){e=m;g=a+12|0;f[g>>2]=e;return e|0}l=f[a+32>>2]|0;if((l|0)<0)n=11;else n=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=n+m|0;g=a+12|0;f[g>>2]=e;return e|0}function C3a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&4|0)OTb(1,f[a+24>>2]|0,c);if(d&16|0)YTb(2,(b[a+29>>0]|0)!=0,c);if(d&1|0)eUb(3,f[a+16>>2]|0,c);if(d&2|0)eUb(4,f[a+20>>2]|0,c);if(d&32|0)MTb(5,f[a+32>>2]|0,c);if(d&8|0)YTb(6,(b[a+28>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function D3a(a){a=a|0;return f[a+12>>2]|0}function E3a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&16))o=g;else{m=b[a+29>>0]|0;b[g>>0]=16;b[g+1>>0]=m;o=g+2|0}if(!(e&1))p=o;else{g=f[a+16>>2]|0;b[o>>0]=26;m=o+1|0;o=_i[f[(f[g>>2]|0)+60>>2]&1023](g)|0;if(o>>>0>127){n=o;h=m;while(1){b[h>>0]=n|128;i=n>>>7;j=h+1|0;if(n>>>0>16383){n=i;h=j}else{q=j;r=i;break}}}else{q=m;r=o}b[q>>0]=r;p=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,q+1|0)|0}if(!(e&2))s=p;else{q=f[a+20>>2]|0;b[p>>0]=34;g=p+1|0;p=_i[f[(f[q>>2]|0)+60>>2]&1023](q)|0;if(p>>>0>127){r=p;o=g;while(1){b[o>>0]=r|128;m=r>>>7;h=o+1|0;if(r>>>0>16383){r=m;o=h}else{t=h;u=m;break}}}else{t=g;u=p}b[t>>0]=u;s=hj[f[(f[q>>2]|0)+64>>2]&511](q,c,t+1|0)|0}if(!(e&32))v=s;else{t=f[a+32>>2]|0;b[s>>0]=40;c=s+1|0;s=t&255;if(t>>>0>127){q=c;u=s;p=t;g=((t|0)<0)<<31>>31;while(1){b[q>>0]=u|-128;t=p;p=aJc(p|0,g|0,7)|0;o=q+1|0;r=p&255;if(!(g>>>0>0|(g|0)==0&t>>>0>16383)){w=o;x=r;break}else{q=o;u=r;g=J}}}else{w=c;x=s}b[w>>0]=x;v=w+1|0}if(!(e&8))y=v;else{e=b[a+28>>0]|0;b[v>>0]=48;b[v+1>>0]=e;y=v+2|0}v=f[a+4>>2]|0;if(!(v&1)){z=y;return z|0}z=Hjc(v&-2,y)|0;return z|0}function F3a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function G3a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15464,0)|0;if(!c){Ehc(b,a);return}else{yYa(a,c);return}}function H3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function I3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525408;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function J3a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function K3a(a){a=a|0;var c=0,d=0;f[a>>2]=91472;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function L3a(a){a=a|0;K3a(a);YDc(a);return}function M3a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function N3a(a,b){a=a|0;b=b|0;a=VDc(20)|0;wYa(a);if(!b)return a|0;Z3a(b,a);return a|0}function O3a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function P3a(a){a=a|0;return 1}function Q3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=WRb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==10){f[e>>2]=f[e>>2]|1;j=f[g>>2]|0;if((j|0)==527320){GLa(g,527320);o=f[g>>2]|0}else o=j;if(fUb(c,o)|0)continue;else{p=0;l=15;break}}else n=k}if(!n){p=1;l=15;break}j=f[h>>2]|0;if(!(j&1))q=mNa(h)|0;else q=j&-2;if(!(Djc(c,n,q)|0)){p=0;l=15;break}}if((l|0)==15)return p|0;return 0}function R3a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;if(!(f[a+8>>2]&1)){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+16>>2]|0;h=b[c+11>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;e=d+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function S3a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)$Tb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function T3a(a){a=a|0;return f[a+12>>2]|0}function U3a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=10;e=dSb(c,d+1|0)|0}d=f[a+4>>2]|0;if(!(d&1)){g=e;return g|0}g=Hjc(d&-2,e)|0;return g|0}function V3a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function W3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15480,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[c+16>>2]|0;c=f[d>>2]|0;if((c|0)==(a|0))return;if((c|0)==527320){GLa(d,a);return}else{iEc(c,a)|0;return}}function X3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525400;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z3a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function _3a(a){a=a|0;var b=0,c=0;f[a>>2]=91580;o4a(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function $3a(a){a=a|0;_3a(a);YDc(a);return}function a4a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function b4a(a,b){a=a|0;b=b|0;a=VDc(60)|0;uYa(a);if(!b)return a|0;n4a(b,a);return a|0}function c4a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&7|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&4|0){e=f[a+24>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);if(d&248|0){g=a+28|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0}if(d&3840|0){f[a+44>>2]=0;b[a+48>>0]=1;n[a+52>>2]=1.0;f[a+56>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function d4a(a){a=a|0;return 1}function e4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+52|0;l=a+20|0;m=a+56|0;n=a+28|0;o=a+37|0;p=e+8|0;q=a+32|0;r=a+36|0;s=e+8|0;t=a+40|0;v=a+44|0;w=a+48|0;x=e+8|0;y=a+24|0;z=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=a+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=WRb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;do switch(C>>>3&536870911|0){case 1:{if((C&255|0)!=10){F=C;break b}f[i>>2]=f[i>>2]|1;B=f[j>>2]|0;if((B|0)==527320){GLa(j,527320);G=f[j>>2]|0}else G=B;if(fUb(c,G)|0)continue a;else{H=0;D=74;break a}break}case 2:{if((C&255|0)!=21){F=C;break b}f[i>>2]=f[i>>2]|1024;B=f[c>>2]|0;if(((f[g>>2]|0)-B|0)>3){a=B;A=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=A;f[c>>2]=B+4;I=A}else{if(!(TRb(c,e)|0)){D=17;break a}I=f[e>>2]|0}f[k>>2]=I;continue a;break}case 3:{if((C&255|0)!=26){F=C;break b}f[i>>2]=f[i>>2]|2;A=f[l>>2]|0;if((A|0)==527320){GLa(l,527320);K=f[l>>2]|0}else K=A;if(fUb(c,K)|0)continue a;else{H=0;D=74;break a}break}case 4:{if((C&255|0)!=32){F=C;break b}f[i>>2]=f[i>>2]|2048;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){B=b[A>>0]|0;a=B&255;if(B<<24>>24>-1){f[m>>2]=a;f[c>>2]=A+1;continue a}else L=a}else L=0;a=HRb(c,L)|0;A=J;f[m>>2]=a;if((A|0)>-1|(A|0)==-1&a>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 5:{if((C&255|0)!=40){F=C;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>-1){f[n>>2]=B;f[c>>2]=a+1;continue a}else M=B}else M=0;B=HRb(c,M)|0;a=J;f[n>>2]=B;if((a|0)>-1|(a|0)==-1&B>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 6:{if((C&255|0)!=48){F=C;break b}f[i>>2]=f[i>>2]|64;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(a=b[B>>0]|0,a<<24>>24>-1):0){f[c>>2]=B+1;N=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[p>>0]|0)){H=0;D=74;break a}else N=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[o>>0]=N&1;continue a;break}case 7:{if((C&255|0)!=56){F=C;break b}f[i>>2]=f[i>>2]|16;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){B=b[a>>0]|0;A=B&255;if(B<<24>>24>-1){f[q>>2]=A;f[c>>2]=a+1;continue a}else O=A}else O=0;A=HRb(c,O)|0;a=J;f[q>>2]=A;if((a|0)>-1|(a|0)==-1&A>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 8:{if((C&255|0)!=64){F=C;break b}f[i>>2]=f[i>>2]|32;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){f[c>>2]=A+1;P=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[s>>0]|0)){H=0;D=74;break a}else P=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[r>>0]=P&1;continue a;break}case 9:{if((C&255|0)!=72){F=C;break b}f[i>>2]=f[i>>2]|128;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>-1){f[t>>2]=B;f[c>>2]=a+1;continue a}else Q=B}else Q=0;B=HRb(c,Q)|0;a=J;f[t>>2]=B;if((a|0)>-1|(a|0)==-1&B>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 10:{if((C&255|0)!=80){F=C;break b}f[i>>2]=f[i>>2]|256;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0){a=b[B>>0]|0;A=a&255;if(a<<24>>24>-1){f[v>>2]=A;f[c>>2]=B+1;continue a}else R=A}else R=0;A=HRb(c,R)|0;B=J;f[v>>2]=A;if((B|0)>-1|(B|0)==-1&A>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 11:{if((C&255|0)!=88){F=C;break b}f[i>>2]=f[i>>2]|512;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){f[c>>2]=A+1;S=B<<24>>24!=0}else{IRb(e,c);B=e;if(!(b[x>>0]|0)){H=0;D=74;break a}else S=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0}b[w>>0]=S&1;continue a;break}case 12:{if((C&255|0)!=98){F=C;break b}f[i>>2]=f[i>>2]|4;B=f[y>>2]|0;if((B|0)==527320){GLa(y,527320);T=f[y>>2]|0}else T=B;if(fUb(c,T)|0)continue a;else{H=0;D=74;break a}break}default:{F=C;break b}}while(0)}while(0);if(!F){H=1;D=74;break}B=f[z>>2]|0;if(!(B&1))U=mNa(z)|0;else U=B&-2;if(!(Djc(c,F,U)|0)){H=0;D=74;break}}if((D|0)==17){H=0;u=d;return H|0}else if((D|0)==74){u=d;return H|0}return 0}function f4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(c&255){if(!(c&1))e=d;else{g=f[a+16>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0?f[g+4>>2]|0:h&255;e=d+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))j=e;else{i=f[a+20>>2]|0;h=b[i+11>>0]|0;g=h<<24>>24<0?f[i+4>>2]|0:h&255;j=e+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))k=j;else{g=f[a+24>>2]|0;e=b[g+11>>0]|0;h=e<<24>>24<0?f[g+4>>2]|0:e&255;k=j+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8))l=k;else l=k+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&16))m=l;else m=l+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=c&32|0?m+2|0:m;m=c&64|0?l+2|0:l;if(!(c&128))n=m;else n=m+1+((((($(f[a+40>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else n=d;if(!(c&3840)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(c&256))q=n;else q=n+1+((((($(f[a+44>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=c&512|0?q+2|0:q;q=c&1024|0?n+5|0:n;if(!(c&2048)){o=q;p=a+12|0;f[p>>2]=o;return o|0}o=q+1+((((($(f[a+56>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=a+12|0;f[p>>2]=o;return o|0}function g4a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)$Tb(1,f[a+16>>2]|0,c);if(d&1024|0)WTb(2,+n[a+52>>2],c);if(d&2|0)$Tb(3,f[a+20>>2]|0,c);if(d&2048|0)OTb(4,f[a+56>>2]|0,c);if(d&8|0)OTb(5,f[a+28>>2]|0,c);if(d&64|0)YTb(6,(b[a+37>>0]|0)!=0,c);if(d&16|0)OTb(7,f[a+32>>2]|0,c);if(d&32|0)YTb(8,(b[a+36>>0]|0)!=0,c);if(d&128|0)OTb(9,f[a+40>>2]|0,c);if(d&256|0)OTb(10,f[a+44>>2]|0,c);if(d&512|0)YTb(11,(b[a+48>>0]|0)!=0,c);if(d&4|0)$Tb(12,f[a+24>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function h4a(a){a=a|0;return f[a+12>>2]|0}function i4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&1024))h=e;else{d=f[a+52>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&2))i=h;else{e=f[a+20>>2]|0;b[h>>0]=26;i=dSb(e,h+1|0)|0}if(!(c&2048))j=i;else{h=f[a+56>>2]|0;b[i>>0]=32;e=i+1|0;if(h>>>0>127){i=h;d=e;while(1){b[d>>0]=i|128;g=i>>>7;k=d+1|0;if(i>>>0>16383){i=g;d=k}else{l=k;m=g;break}}}else{l=e;m=h}b[l>>0]=m;j=l+1|0}if(!(c&8))n=j;else{l=f[a+28>>2]|0;b[j>>0]=40;m=j+1|0;if(l>>>0>127){j=l;h=m;while(1){b[h>>0]=j|128;e=j>>>7;d=h+1|0;if(j>>>0>16383){j=e;h=d}else{o=d;p=e;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&64))q=n;else{o=b[a+37>>0]|0;b[n>>0]=48;b[n+1>>0]=o;q=n+2|0}if(!(c&16))r=q;else{n=f[a+32>>2]|0;b[q>>0]=56;o=q+1|0;if(n>>>0>127){q=n;p=o;while(1){b[p>>0]=q|128;l=q>>>7;m=p+1|0;if(q>>>0>16383){q=l;p=m}else{s=m;t=l;break}}}else{s=o;t=n}b[s>>0]=t;r=s+1|0}if(!(c&32))u=r;else{s=b[a+36>>0]|0;b[r>>0]=64;b[r+1>>0]=s;u=r+2|0}if(!(c&128))v=u;else{r=f[a+40>>2]|0;b[u>>0]=72;s=u+1|0;if(r>>>0>127){u=r;t=s;while(1){b[t>>0]=u|128;n=u>>>7;o=t+1|0;if(u>>>0>16383){u=n;t=o}else{w=o;x=n;break}}}else{w=s;x=r}b[w>>0]=x;v=w+1|0}if(!(c&256))y=v;else{w=f[a+44>>2]|0;b[v>>0]=80;x=v+1|0;if(w>>>0>127){v=w;r=x;while(1){b[r>>0]=v|128;s=v>>>7;t=r+1|0;if(v>>>0>16383){v=s;r=t}else{z=t;A=s;break}}}else{z=x;A=w}b[z>>0]=A;y=z+1|0}if(!(c&512))B=y;else{z=b[a+48>>0]|0;b[y>>0]=88;b[y+1>>0]=z;B=y+2|0}if(!(c&4))C=B;else{c=f[a+24>>2]|0;b[B>>0]=98;C=dSb(c,B+1|0)|0}B=f[a+4>>2]|0;if(!(B&1)){D=C;return D|0}D=Hjc(B&-2,C)|0;return D|0}function j4a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function k4a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15496,0)|0;if(!c){Ehc(b,a);return}else{vYa(a,c);return}}function l4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function m4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525392;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function n4a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function o4a(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function p4a(a){a=a|0;var c=0,d=0;f[a>>2]=91688;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function q4a(a){a=a|0;p4a(a);YDc(a);return}function r4a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function s4a(a,b){a=a|0;b=b|0;a=VDc(28)|0;sYa(a);if(!b)return a|0;E4a(b,a);return a|0}function t4a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&6|0){d=a+20|0;f[d>>2]=0;b[d+4>>0]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function u4a(a){a=a|0;return 1}function v4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+20|0;k=a+24|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[i>>2]|0;if((o|0)==527320){GLa(i,527320);t=f[i>>2]|0}else t=o;if(fUb(c,t)|0)continue a;else{v=0;q=27;break a}break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[j>>2]=n;f[c>>2]=o+1;continue a}else w=n}else w=0;n=HRb(c,w)|0;o=J;f[j>>2]=n;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)continue a;else{v=0;q=27;break a}break}case 3:{if((p&255|0)!=24){s=p;break b}f[h>>2]=f[h>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;x=o<<24>>24!=0}else{IRb(e,c);o=e;if(!(b[l>>0]|0)){v=0;q=27;break a}else x=(f[o>>2]|0)!=0|(f[o+4>>2]|0)!=0}b[k>>0]=x&1;continue a;break}default:{s=p;break b}}}while(0);if(!s){v=1;q=27;break}o=f[m>>2]|0;if(!(o&1))y=mNa(m)|0;else y=o&-2;if(!(Djc(c,s,y)|0)){v=0;q=27;break}}if((q|0)==27){u=d;return v|0}return 0}function w4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&7)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else l=h+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=c&4|0?l+2|0:l;g=a+12|0;f[g>>2]=e;return e|0}function x4a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)$Tb(1,f[a+16>>2]|0,c);if(d&2|0)OTb(2,f[a+20>>2]|0,c);if(d&4|0)YTb(3,(b[a+24>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function y4a(a){a=a|0;return f[a+12>>2]|0}function z4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=16;g=e+1|0;if(d>>>0>127){e=d;i=g;while(1){b[i>>0]=e|128;j=e>>>7;k=i+1|0;if(e>>>0>16383){e=j;i=k}else{l=k;m=j;break}}}else{l=g;m=d}b[l>>0]=m;h=l+1|0}if(!(c&4))n=h;else{c=b[a+24>>0]|0;b[h>>0]=24;b[h+1>>0]=c;n=h+2|0}h=f[a+4>>2]|0;if(!(h&1)){o=n;return o|0}o=Hjc(h&-2,n)|0;return o|0}function A4a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function B4a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15512,0)|0;if(!c){Ehc(b,a);return}else{tYa(a,c);return}}function C4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function D4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525368;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function E4a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function F4a(a){a=a|0;var b=0,c=0;f[a>>2]=91796;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function G4a(a){a=a|0;var b=0,c=0;f[a>>2]=91796;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function H4a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function I4a(a,b){a=a|0;b=b|0;a=VDc(24)|0;rYa(a);if(!b)return a|0;U4a(b,a);return a|0}function J4a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&3|0){n[a+16>>2]=.5;b[a+20>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function K4a(a){a=a|0;return 1}function L4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|1;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(TRb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;v=o<<24>>24!=0}else{IRb(e,c);o=e;if(!(b[l>>0]|0)){w=0;q=25;break a}else v=(f[o>>2]|0)!=0|(f[o+4>>2]|0)!=0}b[k>>0]=v&1;continue a;break}default:{s=p;break b}}}while(0);if(!s){w=1;q=25;break}o=f[m>>2]|0;if(!(o&1))x=mNa(m)|0;else x=o&-2;if(!(Djc(c,s,x)|0)){w=0;q=25;break}}if((q|0)==13){w=0;u=d;return w|0}else if((q|0)==25){u=d;return w|0}return 0}function M4a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;d=b&2|0?g+2|0:g;e=a+12|0;f[e>>2]=d;return d|0}function N4a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)WTb(1,+n[a+16>>2],c);if(d&2|0)YTb(2,(b[a+20>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function O4a(a){a=a|0;return f[a+12>>2]|0}function P4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{c=b[a+20>>0]|0;b[e>>0]=16;b[e+1>>0]=c;i=e+2|0}e=f[a+4>>2]|0;if(!(e&1)){j=i;return j|0}j=Hjc(e&-2,i)|0;return j|0}function Q4a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function R4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,15528,0)|0;if(!d){Ehc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&3))return;if(e&1|0)f[a+16>>2]=f[d+16>>2];if(e&2|0)b[a+20>>0]=b[d+20>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|e;return}function S4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function T4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525312;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function U4a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function V4a(a){a=a|0;var c=0,d=0;f[a>>2]=91904;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function W4a(a){a=a|0;V4a(a);YDc(a);return}function X4a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Y4a(a,b){a=a|0;b=b|0;a=VDc(52)|0;pYa(a);if(!b)return a|0;i5a(b,a);return a|0}function Z4a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);if(d&252|0){e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0}if(d&768|0){n[a+44>>2]=1.0;f[a+48>>2]=4}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function _4a(a){a=a|0;return 1}function $4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+44|0;l=a+20|0;m=a+24|0;n=a+28|0;o=a+36|0;p=e+8|0;q=a+32|0;r=a+40|0;s=a+4|0;t=a+37|0;v=e+8|0;w=a+48|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=WRb(c,B)|0;if((y+-1|0)>>>0<127){z=y;A=6}else C=y}b:do if((A|0)==6){A=0;do switch(z>>>3&536870911|0){case 1:{if((z&255|0)!=10){C=z;break b}f[i>>2]=f[i>>2]|1;y=f[j>>2]|0;if((y|0)==527320){GLa(j,527320);D=f[j>>2]|0}else D=y;if(fUb(c,D)|0)continue a;else{E=0;A=70;break a}break}case 2:{if((z&255|0)!=21){C=z;break b}f[i>>2]=f[i>>2]|256;y=f[c>>2]|0;if(((f[g>>2]|0)-y|0)>3){a=y;x=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=x;f[c>>2]=y+4;F=x}else{if(!(TRb(c,e)|0)){A=17;break a}F=f[e>>2]|0}f[k>>2]=F;continue a;break}case 3:{if((z&255|0)!=26){C=z;break b}f[i>>2]=f[i>>2]|2;x=f[l>>2]|0;if((x|0)==527320){GLa(l,527320);G=f[l>>2]|0}else G=x;if(fUb(c,G)|0)continue a;else{E=0;A=70;break a}break}case 4:{if((z&255|0)!=32){C=z;break b}f[i>>2]=f[i>>2]|4;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;a=y&255;if(y<<24>>24>-1){f[m>>2]=a;f[c>>2]=x+1;continue a}else H=a}else H=0;a=HRb(c,H)|0;x=J;f[m>>2]=a;if((x|0)>-1|(x|0)==-1&a>>>0>4294967295)continue a;else{E=0;A=70;break a}break}case 5:{if((z&255|0)!=40){C=z;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>-1){f[n>>2]=y;f[c>>2]=a+1;continue a}else I=y}else I=0;y=HRb(c,I)|0;a=J;f[n>>2]=y;if((a|0)>-1|(a|0)==-1&y>>>0>4294967295)continue a;else{E=0;A=70;break a}break}case 6:{if((z&255|0)!=48){C=z;break b}f[i>>2]=f[i>>2]|32;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(a=b[y>>0]|0,a<<24>>24>-1):0){f[c>>2]=y+1;K=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[p>>0]|0)){E=0;A=70;break a}else K=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[o>>0]=K&1;continue a;break}case 7:{if((z&255|0)!=56){C=z;break b}f[i>>2]=f[i>>2]|16;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){y=b[a>>0]|0;x=y&255;if(y<<24>>24>-1){f[q>>2]=x;f[c>>2]=a+1;continue a}else L=x}else L=0;x=HRb(c,L)|0;a=J;f[q>>2]=x;if((a|0)>-1|(a|0)==-1&x>>>0>4294967295)continue a;else{E=0;A=70;break a}break}case 8:{if((z&255|0)!=64){C=z;break b}x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){a=b[x>>0]|0;y=a&255;if(a<<24>>24>-1){f[c>>2]=x+1;M=y}else{N=y;A=47}}else{N=0;A=47}if((A|0)==47){A=0;y=HRb(c,N)|0;x=J;if((x|0)>-1|(x|0)==-1&y>>>0>4294967295)M=y;else{E=0;A=70;break a}}if(M>>>0<2){f[i>>2]=f[i>>2]|128;f[r>>2]=M;continue a}y=f[s>>2]|0;if(!(y&1))O=mNa(s)|0;else O=y&-2;rjc(O,8,M,((M|0)<0)<<31>>31);continue a;break}case 9:{if((z&255|0)!=72){C=z;break b}f[i>>2]=f[i>>2]|64;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(x=b[y>>0]|0,x<<24>>24>-1):0){f[c>>2]=y+1;P=x<<24>>24!=0}else{IRb(e,c);x=e;if(!(b[v>>0]|0)){E=0;A=70;break a}else P=(f[x>>2]|0)!=0|(f[x+4>>2]|0)!=0}b[t>>0]=P&1;continue a;break}case 10:{if((z&255|0)!=80){C=z;break b}f[i>>2]=f[i>>2]|512;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;a=y&255;if(y<<24>>24>-1){f[w>>2]=a;f[c>>2]=x+1;continue a}else Q=a}else Q=0;a=HRb(c,Q)|0;x=J;f[w>>2]=a;if((x|0)>-1|(x|0)==-1&a>>>0>4294967295)continue a;else{E=0;A=70;break a}break}default:{C=z;break b}}while(0)}while(0);if(!C){E=1;A=70;break}a=f[s>>2]|0;if(!(a&1))R=mNa(s)|0;else R=a&-2;if(!(Djc(c,C,R)|0)){E=0;A=70;break}}if((A|0)==17){E=0;u=d;return E|0}else if((A|0)==70){u=d;return E|0}return 0}function a5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(c&255){if(!(c&1))e=d;else{g=f[a+16>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0?f[g+4>>2]|0:h&255;e=d+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))j=e;else{i=f[a+20>>2]|0;h=b[i+11>>0]|0;g=h<<24>>24<0?f[i+4>>2]|0:h&255;j=e+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))k=j;else k=j+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&8))l=k;else l=k+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&16))m=l;else m=l+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=c&32|0?m+2|0:m;m=c&64|0?l+2|0:l;if(!(c&128))n=m;else{l=f[a+40>>2]|0;if((l|0)<0)o=11;else o=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=o+m|0}}else n=d;if(!(c&768)){p=n;q=a+12|0;f[q>>2]=p;return p|0}d=c&256|0?n+5|0:n;if(!(c&512)){p=d;q=a+12|0;f[q>>2]=p;return p|0}p=d+1+((((($(f[a+48>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;q=a+12|0;f[q>>2]=p;return p|0}function b5a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)$Tb(1,f[a+16>>2]|0,c);if(d&256|0)WTb(2,+n[a+44>>2],c);if(d&2|0)$Tb(3,f[a+20>>2]|0,c);if(d&4|0)OTb(4,f[a+24>>2]|0,c);if(d&8|0)OTb(5,f[a+28>>2]|0,c);if(d&32|0)YTb(6,(b[a+36>>0]|0)!=0,c);if(d&16|0)OTb(7,f[a+32>>2]|0,c);if(d&128|0)ZTb(8,f[a+40>>2]|0,c);if(d&64|0)YTb(9,(b[a+37>>0]|0)!=0,c);if(d&512|0)OTb(10,f[a+48>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function c5a(a){a=a|0;return f[a+12>>2]|0}function d5a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&256))h=e;else{d=f[a+44>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&2))i=h;else{e=f[a+20>>2]|0;b[h>>0]=26;i=dSb(e,h+1|0)|0}if(!(c&4))j=i;else{h=f[a+24>>2]|0;b[i>>0]=32;e=i+1|0;if(h>>>0>127){i=h;d=e;while(1){b[d>>0]=i|128;g=i>>>7;k=d+1|0;if(i>>>0>16383){i=g;d=k}else{l=k;m=g;break}}}else{l=e;m=h}b[l>>0]=m;j=l+1|0}if(!(c&8))n=j;else{l=f[a+28>>2]|0;b[j>>0]=40;m=j+1|0;if(l>>>0>127){j=l;h=m;while(1){b[h>>0]=j|128;e=j>>>7;d=h+1|0;if(j>>>0>16383){j=e;h=d}else{o=d;p=e;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&32))q=n;else{o=b[a+36>>0]|0;b[n>>0]=48;b[n+1>>0]=o;q=n+2|0}if(!(c&16))r=q;else{n=f[a+32>>2]|0;b[q>>0]=56;o=q+1|0;if(n>>>0>127){q=n;p=o;while(1){b[p>>0]=q|128;l=q>>>7;m=p+1|0;if(q>>>0>16383){q=l;p=m}else{s=m;t=l;break}}}else{s=o;t=n}b[s>>0]=t;r=s+1|0}if(!(c&128))u=r;else{s=f[a+40>>2]|0;b[r>>0]=64;t=r+1|0;r=s&255;if(s>>>0>127){n=t;o=r;p=s;q=((s|0)<0)<<31>>31;while(1){b[n>>0]=o|-128;s=p;p=aJc(p|0,q|0,7)|0;l=n+1|0;m=p&255;if(!(q>>>0>0|(q|0)==0&s>>>0>16383)){v=l;w=m;break}else{n=l;o=m;q=J}}}else{v=t;w=r}b[v>>0]=w;u=v+1|0}if(!(c&64))x=u;else{v=b[a+37>>0]|0;b[u>>0]=72;b[u+1>>0]=v;x=u+2|0}if(!(c&512))y=x;else{c=f[a+48>>2]|0;b[x>>0]=80;u=x+1|0;if(c>>>0>127){x=c;v=u;while(1){b[v>>0]=x|128;w=x>>>7;r=v+1|0;if(x>>>0>16383){x=w;v=r}else{z=r;A=w;break}}}else{z=u;A=c}b[z>>0]=A;y=z+1|0}z=f[a+4>>2]|0;if(!(z&1)){B=y;return B|0}B=Hjc(z&-2,y)|0;return B|0}function e5a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function f5a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15544,0)|0;if(!c){Ehc(b,a);return}else{qYa(a,c);return}}function g5a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function h5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525288;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function i5a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function j5a(a){a=a|0;var b=0,c=0;f[a>>2]=92012;if((a|0)!=522800){b=f[a+64>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+68>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=f[a+60>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+48>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function k5a(a){a=a|0;j5a(a);YDc(a);return}function l5a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function m5a(a,b){a=a|0;b=b|0;a=VDc(120)|0;nYa(a);if(!b)return a|0;y5a(b,a);return a|0}function n5a(a){a=a|0;var c=0,d=0,e=0;f[a+16>>2]=0;f[a+28>>2]=0;f[a+40>>2]=0;f[a+52>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+64>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2|0){e=f[a+68>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d&252|0){e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0}if(d&16128|0){d=a+96|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+108>>2]=1;b[a+112>>0]=1;f[a+116>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function o5a(a){a=a|0;return 1}function p5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+72|0;k=a+112|0;l=e+8|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+32|0;r=a+36|0;s=a+116|0;t=a+40|0;v=a+44|0;w=a+48|0;x=a+64|0;y=e+4|0;z=a+68|0;A=e+4|0;B=a+76|0;C=a+80|0;D=a+84|0;E=a+88|0;F=a+92|0;G=a+96|0;H=a+100|0;I=a+4|0;K=a+108|0;L=a+104|0;M=e+8|0;N=a+52|0;O=a+56|0;P=a+60|0;a:while(1){a=f[c>>2]|0;Q=f[g>>2]|0;do if(a>>>0<Q>>>0){R=b[a>>0]|0;S=R&255;T=a+1|0;if(R<<24>>24>0){U=T;V=S}else{if(T>>>0>=Q>>>0){W=S;X=7;break}R=h[T>>0]|0;if(((R^128)&S)>>>0<=127){W=S;X=7;break}U=a+2|0;V=S+-128+(R<<7)|0}f[c>>2]=U;Y=V;X=9}else{W=0;X=7}while(0);if((X|0)==7){X=0;a=WRb(c,W)|0;if((a+-1|0)>>>0<16383){Y=a;X=9}else Z=a}b:do if((X|0)==9){X=0;do switch(Y>>>3&536870911|0){case 1:{if((Y&255|0)!=8){Z=Y;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){Q=b[a>>0]|0;R=Q&255;if(Q<<24>>24>-1){f[j>>2]=R;f[c>>2]=a+1;continue a}else _=R}else _=0;R=HRb(c,_)|0;a=J;f[j>>2]=R;if((a|0)>-1|(a|0)==-1&R>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 2:{if((Y&255|0)!=16){Z=Y;break b}f[i>>2]=f[i>>2]|4096;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;aa=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[l>>0]|0)){$=0;X=175;break a}else aa=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[k>>0]=aa&1;continue a;break}case 3:{switch((Y&255)<<24>>24){case 24:break;case 26:{if(I$a(c,m)|0)continue a;else{$=0;X=175;break a}break}default:{Z=Y;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){R=b[a>>0]|0;Q=R&255;if(R<<24>>24>-1){f[c>>2]=a+1;ba=Q}else{ca=Q;X=25}}else{ca=0;X=25}if((X|0)==25){X=0;Q=HRb(c,ca)|0;a=J;if((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)ba=Q;else{$=0;X=175;break a}}Q=f[m>>2]|0;if((Q|0)==(f[n>>2]|0)){OLa(m,Q+1|0);da=f[m>>2]|0}else da=Q;Q=f[o>>2]|0;f[m>>2]=da+1;f[Q+4+(da<<2)>>2]=ba;a=(f[n>>2]|0)-(f[m>>2]|0)|0;if((a|0)>0){ea=a;fa=Q}else continue a;while(1){Q=f[c>>2]|0;a=f[g>>2]|0;if(Q>>>0>=a>>>0)continue a;if((b[Q>>0]|0)!=24)continue a;R=Q+1|0;f[c>>2]=R;if(R>>>0<a>>>0){a=b[R>>0]|0;R=a&255;if(a<<24>>24>-1){f[c>>2]=Q+2;ga=R;ha=fa}else{ia=R;X=33}}else{ia=0;X=33}if((X|0)==33){X=0;R=HRb(c,ia)|0;Q=J;if(!((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)){$=0;X=175;break a}ga=R;ha=f[o>>2]|0}R=f[m>>2]|0;f[m>>2]=R+1;f[ha+4+(R<<2)>>2]=ga;if((ea|0)>1){ea=ea+-1|0;fa=ha}else continue a}break}case 4:{switch((Y&255)<<24>>24){case 32:break;case 34:{if(I$a(c,p)|0)continue a;else{$=0;X=175;break a}break}default:{Z=Y;break b}}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[c>>2]=R+1;ja=a}else{ka=a;X=42}}else{ka=0;X=42}if((X|0)==42){X=0;a=HRb(c,ka)|0;R=J;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)ja=a;else{$=0;X=175;break a}}a=f[p>>2]|0;if((a|0)==(f[q>>2]|0)){OLa(p,a+1|0);la=f[p>>2]|0}else la=a;a=f[r>>2]|0;f[p>>2]=la+1;f[a+4+(la<<2)>>2]=ja;R=(f[q>>2]|0)-(f[p>>2]|0)|0;if((R|0)>0){ma=R;na=a}else continue a;while(1){a=f[c>>2]|0;R=f[g>>2]|0;if(a>>>0>=R>>>0)continue a;if((b[a>>0]|0)!=32)continue a;Q=a+1|0;f[c>>2]=Q;if(Q>>>0<R>>>0){R=b[Q>>0]|0;Q=R&255;if(R<<24>>24>-1){f[c>>2]=a+2;oa=Q;pa=na}else{qa=Q;X=50}}else{qa=0;X=50}if((X|0)==50){X=0;Q=HRb(c,qa)|0;a=J;if(!((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)){$=0;X=175;break a}oa=Q;pa=f[r>>2]|0}Q=f[p>>2]|0;f[p>>2]=Q+1;f[pa+4+(Q<<2)>>2]=oa;if((ma|0)>1){ma=ma+-1|0;na=pa}else continue a}break}case 5:{if((Y&255|0)!=40){Z=Y;break b}f[i>>2]=f[i>>2]|8192;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0){a=b[Q>>0]|0;R=a&255;if(a<<24>>24>-1){f[s>>2]=R;f[c>>2]=Q+1;continue a}else ra=R}else ra=0;R=HRb(c,ra)|0;Q=J;f[s>>2]=R;if((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 6:{switch((Y&255)<<24>>24){case 48:break;case 50:{if(I$a(c,t)|0)continue a;else{$=0;X=175;break a}break}default:{Z=Y;break b}}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[c>>2]=R+1;sa=a}else{ta=a;X=64}}else{ta=0;X=64}if((X|0)==64){X=0;a=HRb(c,ta)|0;R=J;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)sa=a;else{$=0;X=175;break a}}a=f[t>>2]|0;if((a|0)==(f[v>>2]|0)){OLa(t,a+1|0);ua=f[t>>2]|0}else ua=a;a=f[w>>2]|0;f[t>>2]=ua+1;f[a+4+(ua<<2)>>2]=sa;R=(f[v>>2]|0)-(f[t>>2]|0)|0;if((R|0)>0){va=R;wa=a}else continue a;while(1){a=f[c>>2]|0;R=f[g>>2]|0;if(a>>>0>=R>>>0)continue a;if((b[a>>0]|0)!=48)continue a;Q=a+1|0;f[c>>2]=Q;if(Q>>>0<R>>>0){R=b[Q>>0]|0;Q=R&255;if(R<<24>>24>-1){f[c>>2]=a+2;xa=Q;ya=wa}else{za=Q;X=72}}else{za=0;X=72}if((X|0)==72){X=0;Q=HRb(c,za)|0;a=J;if(!((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)){$=0;X=175;break a}xa=Q;ya=f[w>>2]|0}Q=f[t>>2]|0;f[t>>2]=Q+1;f[ya+4+(Q<<2)>>2]=xa;if((va|0)>1){va=va+-1|0;wa=ya}else continue a}break}case 7:{if((Y&255|0)!=58){Z=Y;break b}f[i>>2]=f[i>>2]|1;Q=f[x>>2]|0;if(!Q){a=VDc(48)|0;BWa(a);f[x>>2]=a;Aa=a}else Aa=Q;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0?(a=b[Q>>0]|0,a<<24>>24>-1):0){f[c>>2]=Q+1;Ba=a&255}else{a=VRb(c)|0;if((a|0)>-1)Ba=a;else{$=0;X=175;break a}}GRb(e,c,Ba);if((f[y>>2]|0)<0){X=86;break a}if(!(Mi[f[(f[Aa>>2]|0)+44>>2]&1023](Aa,c)|0)){X=86;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{$=0;X=175;break a}break}case 8:{if((Y&255|0)!=66){Z=Y;break b}f[i>>2]=f[i>>2]|2;a=f[z>>2]|0;if(!a){Q=VDc(48)|0;BWa(Q);f[z>>2]=Q;Ca=Q}else Ca=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(Q=b[a>>0]|0,Q<<24>>24>-1):0){f[c>>2]=a+1;Da=Q&255}else{Q=VRb(c)|0;if((Q|0)>-1)Da=Q;else{$=0;X=175;break a}}GRb(e,c,Da);if((f[A>>2]|0)<0){X=97;break a}if(!(Mi[f[(f[Ca>>2]|0)+44>>2]&1023](Ca,c)|0)){X=97;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{$=0;X=175;break a}break}case 9:{if((Y&255|0)!=72){Z=Y;break b}f[i>>2]=f[i>>2]|8;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0){a=b[Q>>0]|0;R=a&255;if(a<<24>>24>-1){f[B>>2]=R;f[c>>2]=Q+1;continue a}else Ea=R}else Ea=0;R=HRb(c,Ea)|0;Q=J;f[B>>2]=R;if((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 10:{if((Y&255|0)!=80){Z=Y;break b}f[i>>2]=f[i>>2]|16;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[C>>2]=a;f[c>>2]=R+1;continue a}else Fa=a}else Fa=0;a=HRb(c,Fa)|0;R=J;f[C>>2]=a;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 11:{if((Y&255|0)!=88){Z=Y;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){R=b[a>>0]|0;Q=R&255;if(R<<24>>24>-1){f[D>>2]=Q;f[c>>2]=a+1;continue a}else Ga=Q}else Ga=0;Q=HRb(c,Ga)|0;a=J;f[D>>2]=Q;if((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 12:{if((Y&255|0)!=96){Z=Y;break b}f[i>>2]=f[i>>2]|64;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0){a=b[Q>>0]|0;R=a&255;if(a<<24>>24>-1){f[E>>2]=R;f[c>>2]=Q+1;continue a}else Ha=R}else Ha=0;R=HRb(c,Ha)|0;Q=J;f[E>>2]=R;if((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 13:{if((Y&255|0)!=104){Z=Y;break b}f[i>>2]=f[i>>2]|128;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[F>>2]=a;f[c>>2]=R+1;continue a}else Ia=a}else Ia=0;a=HRb(c,Ia)|0;R=J;f[F>>2]=a;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 14:{if((Y&255|0)!=112){Z=Y;break b}f[i>>2]=f[i>>2]|256;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){R=b[a>>0]|0;Q=R&255;if(R<<24>>24>-1){f[G>>2]=Q;f[c>>2]=a+1;continue a}else Ja=Q}else Ja=0;Q=HRb(c,Ja)|0;a=J;f[G>>2]=Q;if((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 15:{if((Y&255|0)!=120){Z=Y;break b}Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0){a=b[Q>>0]|0;R=a&255;if(a<<24>>24>-1){f[c>>2]=Q+1;Ka=R}else{La=R;X=133}}else{La=0;X=133}if((X|0)==133){X=0;R=HRb(c,La)|0;Q=J;if((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)Ka=R;else{$=0;X=175;break a}}if(Ka>>>0<3){f[i>>2]=f[i>>2]|512;f[H>>2]=Ka;continue a}R=f[I>>2]|0;if(!(R&1))Ma=mNa(I)|0;else Ma=R&-2;rjc(Ma,15,Ka,((Ka|0)<0)<<31>>31);continue a;break}case 16:{if((Y&255|0)!=128){Z=Y;break b}f[i>>2]=f[i>>2]|2048;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[c>>2]=R+1;Na=a}else{Oa=a;X=144}}else{Oa=0;X=144}if((X|0)==144){X=0;a=HRb(c,Oa)|0;R=J;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)Na=a;else{$=0;X=175;break a}}f[K>>2]=Na;continue a;break}case 17:{if((Y&255|0)!=136){Z=Y;break b}f[i>>2]=f[i>>2]|1024;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;Pa=R<<24>>24!=0}else{IRb(e,c);R=e;if(!(b[M>>0]|0)){$=0;X=175;break a}else Pa=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0}b[L>>0]=Pa&1;continue a;break}case 18:{switch((Y&255)<<24>>24){case -112:break;case -110:{if(I$a(c,N)|0)continue a;else{$=0;X=175;break a}break}default:{Z=Y;break b}}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){a=b[R>>0]|0;Q=a&255;if(a<<24>>24>-1){f[c>>2]=R+1;Qa=Q}else{Ra=Q;X=156}}else{Ra=0;X=156}if((X|0)==156){X=0;Q=HRb(c,Ra)|0;R=J;if((R|0)>-1|(R|0)==-1&Q>>>0>4294967295)Qa=Q;else{$=0;X=175;break a}}Q=f[N>>2]|0;if((Q|0)==(f[O>>2]|0)){OLa(N,Q+1|0);Sa=f[N>>2]|0}else Sa=Q;Q=f[P>>2]|0;f[N>>2]=Sa+1;f[Q+4+(Sa<<2)>>2]=Qa;R=(f[O>>2]|0)-(f[N>>2]|0)|0;if((R|0)>0){Ta=R;Ua=Q}else continue a;while(1){Q=f[g>>2]|0;R=f[c>>2]|0;a=R;if((Q-R|0)<=1)continue a;if((b[a>>0]|0)!=-112)continue a;if((b[a+1>>0]|0)!=1)continue a;R=a+2|0;f[c>>2]=R;if(R>>>0<Q>>>0){Q=b[R>>0]|0;R=Q&255;if(Q<<24>>24>-1){f[c>>2]=a+3;Va=R;Wa=Ua}else{Xa=R;X=165}}else{Xa=0;X=165}if((X|0)==165){X=0;R=HRb(c,Xa)|0;a=J;if(!((a|0)>-1|(a|0)==-1&R>>>0>4294967295)){$=0;X=175;break a}Va=R;Wa=f[P>>2]|0}R=f[N>>2]|0;f[N>>2]=R+1;f[Wa+4+(R<<2)>>2]=Va;if((Ta|0)>1){Ta=Ta+-1|0;Ua=Wa}else continue a}break}default:{Z=Y;break b}}while(0)}while(0);if(!Z){$=1;X=175;break}R=f[I>>2]|0;if(!(R&1))Ya=mNa(I)|0;else Ya=R&-2;if(!(Djc(c,Z,Ya)|0)){$=0;X=175;break}}if((X|0)==86){$=0;u=d;return $|0}else if((X|0)==97){$=0;u=d;return $|0}else if((X|0)==175){u=d;return $|0}return 0}function q5a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=iUb(a+16|0)|0;d=f[a+16>>2]|0;e=iUb(a+28|0)|0;g=f[a+28>>2]|0;h=iUb(a+40|0)|0;i=f[a+40>>2]|0;j=iUb(a+52|0)|0;k=b+c+d+e+g+h+i+j+(f[a+52>>2]<<1)|0;j=a+8|0;i=f[j>>2]|0;if(i&255){if(!(i&1)){l=k;m=i}else{h=f[a+64>>2]|0;g=_i[f[(f[h>>2]|0)+48>>2]&1023](h)|0;h=k+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=h;m=f[j>>2]|0}if(!(m&2)){n=l;o=m}else{m=f[a+68>>2]|0;h=_i[f[(f[m>>2]|0)+48>>2]&1023](m)|0;m=l+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=m;o=f[j>>2]|0}if(!(o&4))p=n;else p=n+1+((((($(f[a+72>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&8))q=p;else q=p+1+((((($(f[a+76>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&16))r=q;else r=q+1+((((($(f[a+80>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&32))s=r;else s=r+1+((((($(f[a+84>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&64))t=s;else t=s+1+((((($(f[a+88>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&128)){u=t;v=o}else{u=t+1+((((($(f[a+92>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;v=o}}else{u=k;v=i}if(!(v&16128)){w=u;x=a+12|0;f[x>>2]=w;return w|0}if(!(v&256))y=u;else y=u+1+((((($(f[a+96>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(v&512))z=y;else{u=f[a+100>>2]|0;if((u|0)<0)A=11;else A=((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;z=A+y|0}y=v&1024|0?z+3|0:z;if(!(v&2048))B=y;else{z=f[a+108>>2]|0;if((z|0)<0)C=12;else C=((((($(z|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;B=C+y|0}y=v&4096|0?B+2|0:B;if(!(v&8192)){w=y;x=a+12|0;f[x>>2]=w;return w|0}w=y+1+((((($(f[a+116>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;x=a+12|0;f[x>>2]=w;return w|0}function r5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&4|0)OTb(1,f[a+72>>2]|0,c);if(d&4096|0)YTb(2,(b[a+112>>0]|0)!=0,c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{OTb(3,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+28>>2]|0;if((e|0)>0){h=a+36|0;g=0;do{OTb(4,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}if(d&8192|0)OTb(5,f[a+116>>2]|0,c);e=f[a+40>>2]|0;if((e|0)>0){g=a+48|0;h=0;do{OTb(6,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}if(d&1|0)eUb(7,f[a+64>>2]|0,c);if(d&2|0)eUb(8,f[a+68>>2]|0,c);if(d&8|0)OTb(9,f[a+76>>2]|0,c);if(d&16|0)OTb(10,f[a+80>>2]|0,c);if(d&32|0)OTb(11,f[a+84>>2]|0,c);if(d&64|0)OTb(12,f[a+88>>2]|0,c);if(d&128|0)OTb(13,f[a+92>>2]|0,c);if(d&256|0)OTb(14,f[a+96>>2]|0,c);if(d&512|0)ZTb(15,f[a+100>>2]|0,c);if(d&2048|0)MTb(16,f[a+108>>2]|0,c);if(d&1024|0)YTb(17,(b[a+104>>0]|0)!=0,c);d=f[a+52>>2]|0;if((d|0)>0){e=a+60|0;h=0;do{OTb(18,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(d|0))}d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function s5a(a){a=a|0;return f[a+12>>2]|0}function t5a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+72>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&4096))o=g;else{m=b[a+112>>0]|0;b[g>>0]=16;b[g+1>>0]=m;o=g+2|0}g=f[a+16>>2]|0;if(!g)p=o;else{m=f[a+24>>2]|0;n=0;h=o;while(1){o=f[m+4+(n<<2)>>2]|0;b[h>>0]=24;i=h+1|0;if(o>>>0>127){j=o;d=i;while(1){b[d>>0]=j|128;k=j>>>7;l=d+1|0;if(j>>>0>16383){j=k;d=l}else{q=l;r=k;break}}}else{q=i;r=o}b[q>>0]=r;d=q+1|0;n=n+1|0;if((n|0)>=(g|0)){p=d;break}else h=d}}h=f[a+28>>2]|0;if(!h)s=p;else{g=f[a+36>>2]|0;n=0;q=p;while(1){p=f[g+4+(n<<2)>>2]|0;b[q>>0]=32;r=q+1|0;if(p>>>0>127){m=p;d=r;while(1){b[d>>0]=m|128;j=m>>>7;k=d+1|0;if(m>>>0>16383){m=j;d=k}else{t=k;u=j;break}}}else{t=r;u=p}b[t>>0]=u;d=t+1|0;n=n+1|0;if((n|0)>=(h|0)){s=d;break}else q=d}}if(!(e&8192))v=s;else{q=f[a+116>>2]|0;b[s>>0]=40;h=s+1|0;if(q>>>0>127){s=q;n=h;while(1){b[n>>0]=s|128;t=s>>>7;u=n+1|0;if(s>>>0>16383){s=t;n=u}else{w=u;x=t;break}}}else{w=h;x=q}b[w>>0]=x;v=w+1|0}w=f[a+40>>2]|0;if(!w)y=v;else{x=f[a+48>>2]|0;q=0;h=v;while(1){v=f[x+4+(q<<2)>>2]|0;b[h>>0]=48;n=h+1|0;if(v>>>0>127){s=v;t=n;while(1){b[t>>0]=s|128;u=s>>>7;g=t+1|0;if(s>>>0>16383){s=u;t=g}else{z=g;A=u;break}}}else{z=n;A=v}b[z>>0]=A;t=z+1|0;q=q+1|0;if((q|0)>=(w|0)){y=t;break}else h=t}}if(!(e&1))B=y;else{h=f[a+64>>2]|0;b[y>>0]=58;w=y+1|0;y=_i[f[(f[h>>2]|0)+60>>2]&1023](h)|0;if(y>>>0>127){q=y;z=w;while(1){b[z>>0]=q|128;A=q>>>7;x=z+1|0;if(q>>>0>16383){q=A;z=x}else{C=x;D=A;break}}}else{C=w;D=y}b[C>>0]=D;B=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,C+1|0)|0}if(!(e&2))E=B;else{C=f[a+68>>2]|0;b[B>>0]=66;h=B+1|0;B=_i[f[(f[C>>2]|0)+60>>2]&1023](C)|0;if(B>>>0>127){D=B;y=h;while(1){b[y>>0]=D|128;w=D>>>7;z=y+1|0;if(D>>>0>16383){D=w;y=z}else{F=z;G=w;break}}}else{F=h;G=B}b[F>>0]=G;E=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,F+1|0)|0}if(!(e&8))H=E;else{F=f[a+76>>2]|0;b[E>>0]=72;c=E+1|0;if(F>>>0>127){E=F;C=c;while(1){b[C>>0]=E|128;G=E>>>7;B=C+1|0;if(E>>>0>16383){E=G;C=B}else{I=B;K=G;break}}}else{I=c;K=F}b[I>>0]=K;H=I+1|0}if(!(e&16))L=H;else{I=f[a+80>>2]|0;b[H>>0]=80;K=H+1|0;if(I>>>0>127){H=I;F=K;while(1){b[F>>0]=H|128;c=H>>>7;C=F+1|0;if(H>>>0>16383){H=c;F=C}else{M=C;N=c;break}}}else{M=K;N=I}b[M>>0]=N;L=M+1|0}if(!(e&32))O=L;else{M=f[a+84>>2]|0;b[L>>0]=88;N=L+1|0;if(M>>>0>127){L=M;I=N;while(1){b[I>>0]=L|128;K=L>>>7;F=I+1|0;if(L>>>0>16383){L=K;I=F}else{P=F;Q=K;break}}}else{P=N;Q=M}b[P>>0]=Q;O=P+1|0}if(!(e&64))R=O;else{P=f[a+88>>2]|0;b[O>>0]=96;Q=O+1|0;if(P>>>0>127){O=P;M=Q;while(1){b[M>>0]=O|128;N=O>>>7;I=M+1|0;if(O>>>0>16383){O=N;M=I}else{S=I;T=N;break}}}else{S=Q;T=P}b[S>>0]=T;R=S+1|0}if(!(e&128))U=R;else{S=f[a+92>>2]|0;b[R>>0]=104;T=R+1|0;if(S>>>0>127){R=S;P=T;while(1){b[P>>0]=R|128;Q=R>>>7;M=P+1|0;if(R>>>0>16383){R=Q;P=M}else{V=M;W=Q;break}}}else{V=T;W=S}b[V>>0]=W;U=V+1|0}if(!(e&256))X=U;else{V=f[a+96>>2]|0;b[U>>0]=112;W=U+1|0;if(V>>>0>127){U=V;S=W;while(1){b[S>>0]=U|128;T=U>>>7;P=S+1|0;if(U>>>0>16383){U=T;S=P}else{Y=P;Z=T;break}}}else{Y=W;Z=V}b[Y>>0]=Z;X=Y+1|0}if(!(e&512))_=X;else{Y=f[a+100>>2]|0;b[X>>0]=120;Z=X+1|0;X=Y&255;if(Y>>>0>127){V=Z;W=X;S=Y;U=((Y|0)<0)<<31>>31;while(1){b[V>>0]=W|-128;Y=S;S=aJc(S|0,U|0,7)|0;T=V+1|0;P=S&255;if(!(U>>>0>0|(U|0)==0&Y>>>0>16383)){$=T;aa=P;break}else{V=T;W=P;U=J}}}else{$=Z;aa=X}b[$>>0]=aa;_=$+1|0}if(!(e&2048))ba=_;else{$=f[a+108>>2]|0;b[_>>0]=-128;b[_+1>>0]=1;aa=_+2|0;_=$&255;if($>>>0>127){X=aa;Z=_;U=$;W=(($|0)<0)<<31>>31;while(1){b[X>>0]=Z|-128;$=U;U=aJc(U|0,W|0,7)|0;V=X+1|0;S=U&255;if(!(W>>>0>0|(W|0)==0&$>>>0>16383)){ca=V;da=S;break}else{X=V;Z=S;W=J}}}else{ca=aa;da=_}b[ca>>0]=da;ba=ca+1|0}if(!(e&1024))ea=ba;else{e=b[a+104>>0]|0;b[ba>>0]=-120;b[ba+1>>0]=1;b[ba+2>>0]=e;ea=ba+3|0}ba=f[a+52>>2]|0;if(!ba)fa=ea;else{e=f[a+60>>2]|0;ca=0;da=ea;while(1){ea=f[e+4+(ca<<2)>>2]|0;b[da>>0]=-112;b[da+1>>0]=1;_=da+2|0;if(ea>>>0>127){aa=ea;W=_;while(1){b[W>>0]=aa|128;Z=aa>>>7;X=W+1|0;if(aa>>>0>16383){aa=Z;W=X}else{ga=X;ha=Z;break}}}else{ga=_;ha=ea}b[ga>>0]=ha;W=ga+1|0;ca=ca+1|0;if((ca|0)>=(ba|0)){fa=W;break}else da=W}}da=f[a+4>>2]|0;if(!(da&1)){ia=fa;return ia|0}ia=Hjc(da&-2,fa)|0;return ia|0}function u5a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function v5a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15560,0)|0;if(!c){Ehc(b,a);return}else{oYa(a,c);return}}function w5a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function x5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525272;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function y5a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function z5a(a){a=a|0;var b=0,c=0;f[a>>2]=92120;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function A5a(a){a=a|0;var b=0,c=0;f[a>>2]=92120;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function B5a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function C5a(a,b){a=a|0;b=b|0;a=VDc(24)|0;mYa(a);if(!b)return a|0;O5a(b,a);return a|0}function D5a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function E5a(a){a=a|0;return 1}function F5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[g>>2]=j;f[c>>2]=k+1;continue a}else p=j}else p=0;j=HRb(c,p)|0;k=J;f[g>>2]=j;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)continue a;else{q=0;m=23;break a}break}case 2:break;default:{o=l;break b}}if((l&255|0)==16){f[e>>2]=f[e>>2]|2;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;r=a}else{s=a;m=16}}else{s=0;m=16}if((m|0)==16){m=0;a=HRb(c,s)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)r=a;else{q=0;m=23;break a}}f[h>>2]=r;continue a}else o=l}while(0);if(!o){q=1;m=23;break}a=f[i>>2]|0;if(!(a&1))t=mNa(i)|0;else t=a&-2;if(!(Djc(c,o,t)|0)){q=0;m=23;break}}if((m|0)==23)return q|0;return 0}function G5a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else g=c+1+((((($(f[a+16>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)h=11;else h=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=h+g|0;e=a+12|0;f[e>>2]=d;return d|0}function H5a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)OTb(1,f[a+16>>2]|0,b);if(c&2|0)MTb(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function I5a(a){a=a|0;return f[a+12>>2]|0}function J5a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{c=f[a+20>>2]|0;b[e>>0]=16;l=e+1|0;e=c&255;if(c>>>0>127){m=l;g=e;h=c;i=((c|0)<0)<<31>>31;while(1){b[m>>0]=g|-128;c=h;h=aJc(h|0,i|0,7)|0;d=m+1|0;j=h&255;if(!(i>>>0>0|(i|0)==0&c>>>0>16383)){o=d;p=j;break}else{m=d;g=j;i=J}}}else{o=l;p=e}b[o>>0]=p;n=o+1|0}o=f[a+4>>2]|0;if(!(o&1)){q=n;return q|0}q=Hjc(o&-2,n)|0;return q|0}function K5a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function L5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15576,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function M5a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function N5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525240;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function O5a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function P5a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=92228;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;if((a|0)!=522080?(f[220376]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=39;b[d+8>>0]=0;DTb(881504,d);ZSb(d)}f[a+12>>2]=0;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;u=c;return}function Q5a(a,b){a=a|0;b=b|0;R5a(b,a);return}function R5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}yNa(a+16|0,b+16|0);yNa(a+32|0,b+32|0);d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+48>>2]=f[b+48>>2];if(d&2|0)f[a+52>>2]=f[b+52>>2];if(d&4|0)f[a+56>>2]=f[b+56>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function S5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=92228;c=a+44|0;d=f[c>>2]|0;if(d|0?(f[a+32>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+28|0;i=f[c>>2]|0;if(i|0?(f[a+16>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);YDc(g)}e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}j=a&-2;a=j;if((j|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(j);f[c>>2]=0;return}function T5a(a){a=a|0;S5a(a);YDc(a);return}function U5a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function V5a(a,b){a=a|0;b=b|0;a=VDc(60)|0;P5a(a);if(!b)return a|0;f6a(b,a);return a|0}function W5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+8|0;if(f[c>>2]&7|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function X5a(a){a=a|0;return 1}function Y5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=c+4|0;e=a+8|0;g=a+52|0;h=a+56|0;i=a+16|0;j=a+32|0;k=a+4|0;l=a+48|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=7}else{q=n;p=6}}else{q=0;p=6}if((p|0)==6){p=0;n=WRb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=7}else r=n}c:do if((p|0)==7){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)==8)break b;else{r=o;break c}break}case 2:{if((o&255|0)!=16){r=o;break c}f[e>>2]=f[e>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;s=m}else{t=m;p=23}}else{t=0;p=23}if((p|0)==23){p=0;m=HRb(c,t)|0;n=J;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)s=m;else{u=0;p=40;break a}}f[g>>2]=s;continue b;break}case 3:{if((o&255|0)!=24){r=o;break c}f[e>>2]=f[e>>2]|4;m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){n=b[m>>0]|0;a=n&255;if(n<<24>>24>-1){f[c>>2]=m+1;v=a}else{w=a;p=29}}else{w=0;p=29}if((p|0)==29){p=0;a=HRb(c,w)|0;m=J;if((m|0)>-1|(m|0)==-1&a>>>0>4294967295)v=a;else{u=0;p=40;break a}}f[h>>2]=v;continue b;break}case 4:{if((o&255|0)!=34){r=o;break c}if(fUb(c,JLa(i)|0)|0)continue b;else{u=0;p=40;break a}break}case 5:{if((o&255|0)!=42){r=o;break c}if(fUb(c,JLa(j)|0)|0)continue b;else{u=0;p=40;break a}break}default:{r=o;break c}}}while(0);if(!r){u=1;p=40;break a}a=f[k>>2]|0;if(!(a&1))x=mNa(k)|0;else x=a&-2;if(!(Djc(c,r,x)|0)){u=0;p=40;break a}}a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>-1){f[c>>2]=a+1;y=n}else{z=n;p=12}}else{z=0;p=12}if((p|0)==12){p=0;n=HRb(c,z)|0;a=J;if((a|0)>-1|(a|0)==-1&n>>>0>4294967295)y=n;else{u=0;p=40;break}}if(y>>>0<2){f[e>>2]=f[e>>2]|1;f[l>>2]=y;continue}n=f[k>>2]|0;if(!(n&1))A=mNa(k)|0;else A=n&-2;rjc(A,1,y,((y|0)<0)<<31>>31)}if((p|0)==40)return u|0;return 0}function Z5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if((e|0)>0){l=f[a+44>>2]|0;c=0;g=h;while(1){d=f[l+4+(c<<2)>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+g+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=j;break}else g=j}}else m=h;h=f[a+8>>2]|0;if(!(h&7)){n=m;o=a+12|0;f[o>>2]=n;return n|0}if(!(h&1))p=m;else{g=f[a+48>>2]|0;if((g|0)<0)q=11;else q=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;p=q+m|0}if(!(h&2))r=p;else{m=f[a+52>>2]|0;if((m|0)<0)s=11;else s=((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+p|0}if(!(h&4)){n=r;o=a+12|0;f[o>>2]=n;return n|0}h=f[a+56>>2]|0;if((h|0)<0)t=11;else t=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=t+r|0;o=a+12|0;f[o>>2]=n;return n|0}function _5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+8>>2]|0;if(c&1|0)ZTb(1,f[a+48>>2]|0,b);if(c&2|0)MTb(2,f[a+52>>2]|0,b);if(c&4|0)MTb(3,f[a+56>>2]|0,b);c=f[a+20>>2]|0;if((c|0)>0){d=a+28|0;e=0;do{_Tb(4,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+36>>2]|0;if((c|0)>0){e=a+44|0;d=0;do{_Tb(5,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function $5a(a){a=a|0;return f[a+12>>2]|0}function a6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+48>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{o=f[a+52>>2]|0;b[e>>0]=16;p=e+1|0;e=o&255;if(o>>>0>127){d=p;h=e;l=o;j=((o|0)<0)<<31>>31;while(1){b[d>>0]=h|-128;o=l;l=aJc(l|0,j|0,7)|0;i=d+1|0;k=l&255;if(!(j>>>0>0|(j|0)==0&o>>>0>16383)){r=i;s=k;break}else{d=i;h=k;j=J}}}else{r=p;s=e}b[r>>0]=s;q=r+1|0}if(!(c&4))t=q;else{c=f[a+56>>2]|0;b[q>>0]=24;r=q+1|0;q=c&255;if(c>>>0>127){s=r;e=q;p=c;j=((c|0)<0)<<31>>31;while(1){b[s>>0]=e|-128;c=p;p=aJc(p|0,j|0,7)|0;h=s+1|0;d=p&255;if(!(j>>>0>0|(j|0)==0&c>>>0>16383)){u=h;v=d;break}else{s=h;e=d;j=J}}}else{u=r;v=q}b[u>>0]=v;t=u+1|0}u=f[a+20>>2]|0;if((u|0)>0){v=a+28|0;q=0;r=t;while(1){j=f[(f[v>>2]|0)+4+(q<<2)>>2]|0;b[r>>0]=34;e=dSb(j,r+1|0)|0;q=q+1|0;if((q|0)==(u|0)){w=e;break}else r=e}}else w=t;t=f[a+36>>2]|0;if((t|0)>0){r=a+44|0;u=0;q=w;while(1){v=f[(f[r>>2]|0)+4+(u<<2)>>2]|0;b[q>>0]=42;e=dSb(v,q+1|0)|0;u=u+1|0;if((u|0)==(t|0)){x=e;break}else q=e}}else x=w;w=f[a+4>>2]|0;if(!(w&1)){y=x;return y|0}y=Hjc(w&-2,x)|0;return y|0}function b6a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function c6a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15592,0)|0;if(!c){Ehc(b,a);return}else{R5a(a,c);return}}function d6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function e6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525184;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function f6a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function g6a(a){a=a|0;return a>>>0<2|0}function h6a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=88988;XIc(a+4|0,0,156)|0;if((a|0)!=524304?(f[220427]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=90;b[d+8>>0]=0;DTb(881708,d);ZSb(d)}f[a+160>>2]=527320;XIc(a+164|0,0,132)|0;u=c;return}function i6a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function j6a(a){a=a|0;var c=0;c=f[a+160>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==524304)return;c=f[a+164>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+168>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+172>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+176>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+180>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+184>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+188>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+192>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+196>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+200>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+204>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+208>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+212>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+216>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+220>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+224>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+228>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+232>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+236>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+240>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+244>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+248>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+252>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+256>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+260>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+264>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+268>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+272>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+276>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+280>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+284>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function k6a(a){a=a|0;var b=0,c=0;f[a>>2]=92336;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function l6a(a){a=a|0;var b=0,c=0;f[a>>2]=92336;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function m6a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function n6a(a,b){a=a|0;b=b|0;a=VDc(28)|0;z6a(a);if(!b)return a|0;A6a(b,a);return a|0}function o6a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function p6a(a){a=a|0;return 1}function q6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;i=a+24|0;j=a+20|0;a:while(1){b:while(1){c:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=8}else{o=l;n=7}}else{o=0;n=7}if((n|0)==7){n=0;l=WRb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=8}else p=l}d:do if((n|0)==8){n=0;switch(m>>>3&536870911|0){case 1:{if((m&255|0)!=8){p=m;break d}f[e>>2]=f[e>>2]|1;l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){a=b[l>>0]|0;k=a&255;if(a<<24>>24>-1){f[g>>2]=k;f[c>>2]=l+1;continue c}else q=k}else q=0;k=HRb(c,q)|0;l=J;f[g>>2]=k;if((l|0)>-1|(l|0)==-1&k>>>0>4294967295)continue c;else{r=0;n=41;break a}break}case 2:{if((m&255|0)==16)break b;else{p=m;break d}break}case 6:{if((m&255|0)==48)break c;else{p=m;break d}break}default:{p=m;break d}}}while(0);if(!p){r=1;n=41;break a}k=f[h>>2]|0;if(!(k&1))s=mNa(h)|0;else s=k&-2;if(!(Djc(c,p,s)|0)){r=0;n=41;break a}}k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){l=b[k>>0]|0;a=l&255;if(l<<24>>24>-1){f[c>>2]=k+1;t=a}else{u=a;n=29}}else{u=0;n=29}if((n|0)==29){n=0;a=HRb(c,u)|0;k=J;if((k|0)>-1|(k|0)==-1&a>>>0>4294967295)t=a;else{r=0;n=41;break a}}if(t>>>0<3){f[e>>2]=f[e>>2]|4;f[i>>2]=t;continue}a=f[h>>2]|0;if(!(a&1))v=mNa(h)|0;else v=a&-2;rjc(v,6,t,((t|0)<0)<<31>>31)}a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>-1){f[c>>2]=a+1;w=l}else{x=l;n=18}}else{x=0;n=18}if((n|0)==18){n=0;l=HRb(c,x)|0;a=J;if((a|0)>-1|(a|0)==-1&l>>>0>4294967295)w=l;else{r=0;n=41;break}}if(w>>>0<3){f[e>>2]=f[e>>2]|2;f[j>>2]=w;continue}l=f[h>>2]|0;if(!(l&1))y=mNa(h)|0;else y=l&-2;rjc(y,2,w,((w|0)<0)<<31>>31)}if((n|0)==41)return r|0;return 0}function r6a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else g=c+1+((((($(f[a+16>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&2))h=g;else{c=f[a+20>>2]|0;if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+g|0}if(!(b&4)){d=h;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+24>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+h|0;e=a+12|0;f[e>>2]=d;return d|0}function s6a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)OTb(1,f[a+16>>2]|0,b);if(c&2|0)ZTb(2,f[a+20>>2]|0,b);if(c&4|0)ZTb(6,f[a+24>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function t6a(a){a=a|0;return f[a+12>>2]|0}function u6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{l=f[a+20>>2]|0;b[e>>0]=16;m=e+1|0;e=l&255;if(l>>>0>127){g=m;h=e;i=l;d=((l|0)<0)<<31>>31;while(1){b[g>>0]=h|-128;l=i;i=aJc(i|0,d|0,7)|0;j=g+1|0;k=i&255;if(!(d>>>0>0|(d|0)==0&l>>>0>16383)){o=j;p=k;break}else{g=j;h=k;d=J}}}else{o=m;p=e}b[o>>0]=p;n=o+1|0}if(!(c&4))q=n;else{c=f[a+24>>2]|0;b[n>>0]=48;o=n+1|0;n=c&255;if(c>>>0>127){p=o;e=n;m=c;d=((c|0)<0)<<31>>31;while(1){b[p>>0]=e|-128;c=m;m=aJc(m|0,d|0,7)|0;h=p+1|0;g=m&255;if(!(d>>>0>0|(d|0)==0&c>>>0>16383)){r=h;s=g;break}else{p=h;e=g;d=J}}}else{r=o;s=n}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function v6a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function w6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15608,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function x6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function y6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525584;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function z6a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92336;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524272?(f[220426]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=89;b[d+8>>0]=0;DTb(881704,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function A6a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function B6a(a){a=a|0;var b=0,c=0;f[a>>2]=92444;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function C6a(a){a=a|0;var b=0,c=0;f[a>>2]=92444;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function D6a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function E6a(a,b){a=a|0;b=b|0;a=VDc(24)|0;Q6a(a);if(!b)return a|0;R6a(b,a);return a|0}function F6a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=0;f[a+20>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function G6a(a){a=a|0;return 1}function H6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=a+8|0;g=a+20|0;h=a+16|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|2;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=HRb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=24;break a}}f[g>>2]=p;continue a;break}case 2:{if((l&255|0)!=16){o=l;break b}f[e>>2]=f[e>>2]|1;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;s=a}else{t=a;m=17}}else{t=0;m=17}if((m|0)==17){m=0;a=HRb(c,t)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)s=a;else{r=0;m=24;break a}}f[h>>2]=s;continue a;break}default:{o=l;break b}}}while(0);if(!o){r=1;m=24;break}a=f[i>>2]|0;if(!(a&1))u=mNa(i)|0;else u=a&-2;if(!(Djc(c,o,u)|0)){r=0;m=24;break}}if((m|0)==24)return r|0;return 0}function I6a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function J6a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)MTb(1,f[a+20>>2]|0,b);if(c&1|0)MTb(2,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function K6a(a){a=a|0;return f[a+12>>2]|0}function L6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&1))q=e;else{c=f[a+16>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=aJc(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function M6a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function N6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15624,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function O6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function P6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525560;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Q6a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92444;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524160?(f[220423]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=86;b[d+8>>0]=0;DTb(881692,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;u=c;return}function R6a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function S6a(a){a=a|0;var b=0,c=0;f[a>>2]=92552;if((a|0)!=524008){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function T6a(a){a=a|0;S6a(a);YDc(a);return}function U6a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function V6a(a,b){a=a|0;b=b|0;a=VDc(36)|0;g7a(a);if(!b)return a|0;h7a(b,a);return a|0}function W6a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+16>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2|0){e=f[a+20>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d&28|0){b[a+24>>0]=0;f[a+28>>2]=1;f[a+32>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function X6a(a){a=a|0;return 1}function Y6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+28|0;j=a+32|0;k=a+16|0;l=e+4|0;m=a+24|0;n=e+8|0;o=a+20|0;p=e+4|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=WRb(c,w)|0;if((s+-1|0)>>>0<127){t=s;v=6}else x=s}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{if((t&255|0)!=8){x=t;break b}f[h>>2]=f[h>>2]|8;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){a=b[s>>0]|0;r=a&255;if(a<<24>>24>-1){f[c>>2]=s+1;y=r}else{z=r;v=11}}else{z=0;v=11}if((v|0)==11){v=0;r=HRb(c,z)|0;s=J;if((s|0)>-1|(s|0)==-1&r>>>0>4294967295)y=r;else{A=0;v=52;break a}}f[i>>2]=y;continue a;break}case 2:{if((t&255|0)!=16){x=t;break b}f[h>>2]=f[h>>2]|16;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){s=b[r>>0]|0;a=s&255;if(s<<24>>24>-1){f[c>>2]=r+1;B=a}else{C=a;v=17}}else{C=0;v=17}if((v|0)==17){v=0;a=HRb(c,C)|0;r=J;if((r|0)>-1|(r|0)==-1&a>>>0>4294967295)B=a;else{A=0;v=52;break a}}f[j>>2]=B;continue a;break}case 3:{if((t&255|0)!=26){x=t;break b}f[h>>2]=f[h>>2]|1;a=f[k>>2]|0;if(!a){r=VDc(48)|0;BWa(r);f[k>>2]=r;D=r}else D=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;E=r&255}else{r=VRb(c)|0;if((r|0)>-1)E=r;else{A=0;v=52;break a}}GRb(e,c,E);if((f[l>>2]|0)<0){v=28;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){v=28;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{A=0;v=52;break a}break}case 4:{if((t&255|0)!=32){x=t;break b}f[h>>2]=f[h>>2]|4;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;F=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[n>>0]|0)){A=0;v=52;break a}else F=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[m>>0]=F&1;continue a;break}case 5:{if((t&255|0)!=42){x=t;break b}f[h>>2]=f[h>>2]|2;a=f[o>>2]|0;if(!a){r=VDc(48)|0;BWa(r);f[o>>2]=r;G=r}else G=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;H=r&255}else{r=VRb(c)|0;if((r|0)>-1)H=r;else{A=0;v=52;break a}}GRb(e,c,H);if((f[p>>2]|0)<0){v=45;break a}if(!(Mi[f[(f[G>>2]|0)+44>>2]&1023](G,c)|0)){v=45;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{A=0;v=52;break a}break}default:{x=t;break b}}}while(0);if(!x){A=1;v=52;break}r=f[q>>2]|0;if(!(r&1))I=mNa(q)|0;else I=r&-2;if(!(Djc(c,x,I)|0)){A=0;v=52;break}}if((v|0)==28){A=0;u=d;return A|0}else if((v|0)==45){A=0;u=d;return A|0}else if((v|0)==52){u=d;return A|0}return 0}function Z6a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&31)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){k=h;l=i}else{i=f[a+20>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=i;l=f[b>>2]|0}b=l&4|0?k+2|0:k;if(!(l&8))m=b;else{k=f[a+28>>2]|0;if((k|0)<0)n=11;else n=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;m=n+b|0}if(!(l&16)){e=m;g=a+12|0;f[g>>2]=e;return e|0}l=f[a+32>>2]|0;if((l|0)<0)o=11;else o=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=o+m|0;g=a+12|0;f[g>>2]=e;return e|0}function _6a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&8|0)MTb(1,f[a+28>>2]|0,c);if(d&16|0)MTb(2,f[a+32>>2]|0,c);if(d&1|0)eUb(3,f[a+16>>2]|0,c);if(d&4|0)YTb(4,(b[a+24>>0]|0)!=0,c);if(d&2|0)eUb(5,f[a+20>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function $6a(a){a=a|0;return f[a+12>>2]|0}function a7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=f[a+8>>2]|0;if(!(e&8))g=d;else{h=f[a+28>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=aJc(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&16))r=g;else{p=f[a+32>>2]|0;b[g>>0]=16;q=g+1|0;g=p&255;if(p>>>0>127){d=q;i=g;m=p;k=((p|0)<0)<<31>>31;while(1){b[d>>0]=i|-128;p=m;m=aJc(m|0,k|0,7)|0;j=d+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=j;t=l;break}else{d=j;i=l;k=J}}}else{s=q;t=g}b[s>>0]=t;r=s+1|0}if(!(e&1))u=r;else{s=f[a+16>>2]|0;b[r>>0]=26;t=r+1|0;r=_i[f[(f[s>>2]|0)+60>>2]&1023](s)|0;if(r>>>0>127){g=r;q=t;while(1){b[q>>0]=g|128;k=g>>>7;i=q+1|0;if(g>>>0>16383){g=k;q=i}else{v=i;w=k;break}}}else{v=t;w=r}b[v>>0]=w;u=hj[f[(f[s>>2]|0)+64>>2]&511](s,c,v+1|0)|0}if(!(e&4))x=u;else{v=b[a+24>>0]|0;b[u>>0]=32;b[u+1>>0]=v;x=u+2|0}if(!(e&2))y=x;else{e=f[a+20>>2]|0;b[x>>0]=42;u=x+1|0;x=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(x>>>0>127){v=x;s=u;while(1){b[s>>0]=v|128;w=v>>>7;r=s+1|0;if(v>>>0>16383){v=w;s=r}else{z=r;A=w;break}}}else{z=u;A=x}b[z>>0]=A;y=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,z+1|0)|0}z=f[a+4>>2]|0;if(!(z&1)){B=y;return B|0}B=Hjc(z&-2,y)|0;return B|0}function b7a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function c7a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15640,0)|0;if(!c){Ehc(b,a);return}else{f7a(a,c);return}}function d7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function e7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525520;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function f7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&31))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=VDc(48)|0;BWa(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;CWa(i,g|0?g:521608)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[g>>2]|0;if(!i){d=VDc(48)|0;BWa(d);f[g>>2]=d;j=d}else j=i;i=f[c+20>>2]|0;CWa(j,i|0?i:521608)}if(e&4|0)b[a+24>>0]=b[c+24>>0]|0;if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function g7a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92552;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=524008?(f[220418]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=81;b[d+8>>0]=0;DTb(881672,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[d+12>>0]=0;f[a+28>>2]=1;f[a+32>>2]=1;u=c;return}function h7a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function i7a(a){a=a|0;var b=0,c=0;f[a>>2]=92660;if((a|0)!=523976?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function j7a(a){a=a|0;i7a(a);YDc(a);return}function k7a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function l7a(a,b){a=a|0;b=b|0;a=VDc(28)|0;y7a(a);if(!b)return a|0;z7a(b,a);return a|0}function m7a(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;c=f[b>>2]|0;if(c&1|0){d=f[a+16>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}if(c&6|0){f[a+20>>2]=0;f[a+24>>2]=-1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function n7a(a){a=a|0;return 1}function o7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+4|0;k=a+20|0;l=a+24|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[i>>2]|0;if(!o){a=VDc(32)|0;SXa(a);f[i>>2]=a;t=a}else t=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;v=a&255}else{a=VRb(c)|0;if((a|0)>-1)v=a;else{w=0;q=35;break a}}GRb(e,c,v);if((f[j>>2]|0)<0){q=16;break a}if(!(Mi[f[(f[t>>2]|0)+44>>2]&1023](t,c)|0)){q=16;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{w=0;q=35;break a}break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|2;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;n=o&255;if(o<<24>>24>-1){f[c>>2]=a+1;x=n}else{y=n;q=22}}else{y=0;q=22}if((q|0)==22){q=0;n=HRb(c,y)|0;a=J;if((a|0)>-1|(a|0)==-1&n>>>0>4294967295)x=n;else{w=0;q=35;break a}}f[k>>2]=x;continue a;break}case 3:{if((p&255|0)!=24){s=p;break b}f[h>>2]=f[h>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){a=b[n>>0]|0;o=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;z=o}else{A=o;q=28}}else{A=0;q=28}if((q|0)==28){q=0;o=HRb(c,A)|0;n=J;if((n|0)>-1|(n|0)==-1&o>>>0>4294967295)z=o;else{w=0;q=35;break a}}f[l>>2]=z;continue a;break}default:{s=p;break b}}}while(0);if(!s){w=1;q=35;break}o=f[m>>2]|0;if(!(o&1))B=mNa(m)|0;else B=o&-2;if(!(Djc(c,s,B)|0)){w=0;q=35;break}}if((q|0)==16){w=0;u=d;return w|0}else if((q|0)==35){u=d;return w|0}return 0}function p7a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&7)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2))k=h;else{b=f[a+20>>2]|0;if((b|0)<0)l=11;else l=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=l+h|0}if(!(i&4)){e=k;g=a+12|0;f[g>>2]=e;return e|0}i=f[a+24>>2]|0;if((i|0)<0)m=11;else m=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=m+k|0;g=a+12|0;f[g>>2]=e;return e|0}function q7a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)eUb(1,f[a+16>>2]|0,b);if(c&2|0)MTb(2,f[a+20>>2]|0,b);if(c&4|0)MTb(3,f[a+24>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function r7a(a){a=a|0;return f[a+12>>2]|0}function s7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;i=d+1|0;d=_i[f[(f[h>>2]|0)+60>>2]&1023](h)|0;if(d>>>0>127){j=d;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=d}b[n>>0]=o;g=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,n+1|0)|0}if(!(e&2))p=g;else{n=f[a+20>>2]|0;b[g>>0]=16;c=g+1|0;g=n&255;if(n>>>0>127){h=c;o=g;d=n;i=((n|0)<0)<<31>>31;while(1){b[h>>0]=o|-128;n=d;d=aJc(d|0,i|0,7)|0;k=h+1|0;j=d&255;if(!(i>>>0>0|(i|0)==0&n>>>0>16383)){q=k;r=j;break}else{h=k;o=j;i=J}}}else{q=c;r=g}b[q>>0]=r;p=q+1|0}if(!(e&4))s=p;else{e=f[a+24>>2]|0;b[p>>0]=24;q=p+1|0;p=e&255;if(e>>>0>127){r=q;g=p;c=e;i=((e|0)<0)<<31>>31;while(1){b[r>>0]=g|-128;e=c;c=aJc(c|0,i|0,7)|0;o=r+1|0;h=c&255;if(!(i>>>0>0|(i|0)==0&e>>>0>16383)){t=o;u=h;break}else{r=o;g=h;i=J}}}else{t=q;u=p}b[t>>0]=u;s=t+1|0}t=f[a+4>>2]|0;if(!(t&1)){v=s;return v|0}v=Hjc(t&-2,s)|0;return v|0}function t7a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function u7a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15656,0)|0;if(!c){Ehc(b,a);return}else{x7a(a,c);return}}function v7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function w7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525512;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function x7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;e=f[g>>2]|0;if(!e){c=VDc(32)|0;SXa(c);f[g>>2]=c;h=c}else h=e;e=f[b+16>>2]|0;c=e|0?e:521128;e=h+4|0;g=f[c+4>>2]|0;if(g&1|0){i=f[e>>2]|0;if(!(i&1))j=mNa(e)|0;else j=i&-2;ojc(j,g&-2)}g=h+16|0;j=c+16|0;i=f[j>>2]|0;if(i|0){UHa(g,(f[g>>2]|0)+i|0);dJc((f[h+24>>2]|0)+8+(f[g>>2]<<3)|0,(f[c+24>>2]|0)+8|0,f[j>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[j>>2]|0)}}if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function y7a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92660;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523976?(f[220417]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=80;b[d+8>>0]=0;DTb(881668,d);ZSb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=-1;u=c;return}function z7a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function A7a(a){a=a|0;var b=0,c=0;f[a>>2]=92768;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function B7a(a){a=a|0;var b=0,c=0;f[a>>2]=92768;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function C7a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function D7a(a,b){a=a|0;b=b|0;a=VDc(28)|0;P7a(a);if(!b)return a|0;Q7a(b,a);return a|0}function E7a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){f[a+16>>2]=0;f[a+20>>2]=1;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function F7a(a){a=a|0;return 1}function G7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+24|0;l=a+4|0;m=a+20|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=7}else{r=o;q=6}}else{r=0;q=6}if((q|0)==6){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=7}else s=o}c:do if((q|0)==7){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)==8)break b;else{s=p;break c}break}case 2:{if((p&255|0)!=16){s=p;break c}f[i>>2]=f[i>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[c>>2]=o+1;t=n}else{v=n;q=23}}else{v=0;q=23}if((q|0)==23){q=0;n=HRb(c,v)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)t=n;else{w=0;q=37;break a}}f[j>>2]=t;continue b;break}case 3:{if((p&255|0)!=29){s=p;break c}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){o=n;a=h[o>>0]|h[o+1>>0]<<8|h[o+2>>0]<<16|h[o+3>>0]<<24;f[e>>2]=a;f[c>>2]=n+4;x=a}else{if(!(TRb(c,e)|0)){q=31;break a}x=f[e>>2]|0}f[k>>2]=x;continue b;break}default:{s=p;break c}}}while(0);if(!s){w=1;q=37;break a}a=f[l>>2]|0;if(!(a&1))y=mNa(l)|0;else y=a&-2;if(!(Djc(c,s,y)|0)){w=0;q=37;break a}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>-1){f[c>>2]=a+1;z=o}else{A=o;q=12}}else{A=0;q=12}if((q|0)==12){q=0;o=HRb(c,A)|0;a=J;if((a|0)>-1|(a|0)==-1&o>>>0>4294967295)z=o;else{w=0;q=37;break}}if((z+-1|0)>>>0<4){f[i>>2]=f[i>>2]|2;f[m>>2]=z;continue}o=f[l>>2]|0;if(!(o&1))B=mNa(l)|0;else B=o&-2;rjc(B,1,z,((z|0)<0)<<31>>31)}if((q|0)==31){w=0;u=d;return w|0}else if((q|0)==37){u=d;return w|0}return 0}function H7a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2))j=g;else{c=f[a+20>>2]|0;if((c|0)<0)k=11;else k=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=k+g|0}d=b&4|0?j+5|0:j;e=a+12|0;f[e>>2]=d;return d|0}function I7a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)ZTb(1,f[a+20>>2]|0,b);if(c&1|0)MTb(2,f[a+16>>2]|0,b);if(c&4|0)WTb(3,+n[a+24>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function J7a(a){a=a|0;return f[a+12>>2]|0}function K7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&1))q=e;else{o=f[a+16>>2]|0;b[e>>0]=16;p=e+1|0;e=o&255;if(o>>>0>127){d=p;h=e;l=o;j=((o|0)<0)<<31>>31;while(1){b[d>>0]=h|-128;o=l;l=aJc(l|0,j|0,7)|0;i=d+1|0;k=l&255;if(!(j>>>0>0|(j|0)==0&o>>>0>16383)){r=i;s=k;break}else{d=i;h=k;j=J}}}else{r=p;s=e}b[r>>0]=s;q=r+1|0}if(!(c&4))t=q;else{c=f[a+24>>2]|0;b[q>>0]=29;r=q+1|0;b[r>>0]=c;b[r+1>>0]=c>>8;b[r+2>>0]=c>>16;b[r+3>>0]=c>>24;t=q+5|0}q=f[a+4>>2]|0;if(!(q&1)){u=t;return u|0}u=Hjc(q&-2,t)|0;return u|0}function L7a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function M7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15672,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function N7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function O7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525496;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function P7a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92768;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523920?(f[220415]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=78;b[d+8>>0]=0;DTb(881660,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;n[a+24>>2]=1.0;u=c;return}function Q7a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function R7a(a){a=a|0;var b=0,c=0;f[a>>2]=92876;if((a|0)!=523888){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function S7a(a){a=a|0;R7a(a);YDc(a);return}function T7a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function U7a(a,b){a=a|0;b=b|0;a=VDc(32)|0;f8a(a);if(!b)return a|0;g8a(b,a);return a|0}function V7a(a){a=a|0;var b=0,c=0,e=0;b=a+8|0;c=f[b>>2]|0;if(c&3|0){if(c&1|0){e=f[a+16>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(c&2|0){e=f[a+20>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(c&28|0){c=a+24|0;f[c>>2]=0;d[c+4>>1]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function W7a(a){a=a|0;return 1}function X7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+24|0;j=a+16|0;k=e+4|0;l=a+20|0;m=e+4|0;n=a+28|0;o=e+8|0;p=a+29|0;q=e+8|0;r=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=a+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=WRb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=8){y=v;break b}f[h>>2]=f[h>>2]|4;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0){a=b[t>>0]|0;s=a&255;if(a<<24>>24>-1){f[i>>2]=s;f[c>>2]=t+1;continue a}else z=s}else z=0;s=HRb(c,z)|0;t=J;f[i>>2]=s;if((t|0)>-1|(t|0)==-1&s>>>0>4294967295)continue a;else{A=0;w=51;break a}break}case 2:{if((v&255|0)!=18){y=v;break b}f[h>>2]=f[h>>2]|1;s=f[j>>2]|0;if(!s){t=VDc(48)|0;BWa(t);f[j>>2]=t;B=t}else B=s;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(t=b[s>>0]|0,t<<24>>24>-1):0){f[c>>2]=s+1;C=t&255}else{t=VRb(c)|0;if((t|0)>-1)C=t;else{A=0;w=51;break a}}GRb(e,c,C);if((f[k>>2]|0)<0){w=21;break a}if(!(Mi[f[(f[B>>2]|0)+44>>2]&1023](B,c)|0)){w=21;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{A=0;w=51;break a}break}case 3:{if((v&255|0)!=26){y=v;break b}f[h>>2]=f[h>>2]|2;t=f[l>>2]|0;if(!t){s=VDc(48)|0;BWa(s);f[l>>2]=s;D=s}else D=t;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(s=b[t>>0]|0,s<<24>>24>-1):0){f[c>>2]=t+1;E=s&255}else{s=VRb(c)|0;if((s|0)>-1)E=s;else{A=0;w=51;break a}}GRb(e,c,E);if((f[m>>2]|0)<0){w=32;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){w=32;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{A=0;w=51;break a}break}case 4:{if((v&255|0)!=32){y=v;break b}f[h>>2]=f[h>>2]|8;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(t=b[s>>0]|0,t<<24>>24>-1):0){f[c>>2]=s+1;F=t<<24>>24!=0}else{IRb(e,c);t=e;if(!(b[o>>0]|0)){A=0;w=51;break a}else F=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0}b[n>>0]=F&1;continue a;break}case 5:{if((v&255|0)!=40){y=v;break b}f[h>>2]=f[h>>2]|16;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(s=b[t>>0]|0,s<<24>>24>-1):0){f[c>>2]=t+1;G=s<<24>>24!=0}else{IRb(e,c);s=e;if(!(b[q>>0]|0)){A=0;w=51;break a}else G=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0}b[p>>0]=G&1;continue a;break}default:{y=v;break b}}}while(0);if(!y){A=1;w=51;break}s=f[r>>2]|0;if(!(s&1))H=mNa(r)|0;else H=s&-2;if(!(Djc(c,y,H)|0)){A=0;w=51;break}}if((w|0)==21){A=0;u=d;return A|0}else if((w|0)==32){A=0;u=d;return A|0}else if((w|0)==51){u=d;return A|0}return 0}function Y7a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&31)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){k=h;l=i}else{i=f[a+20>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=i;l=f[b>>2]|0}if(!(l&4))m=k;else m=k+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=l&8|0?m+2|0:m;e=l&16|0?k+2|0:k;g=a+12|0;f[g>>2]=e;return e|0}function Z7a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&4|0)OTb(1,f[a+24>>2]|0,c);if(d&1|0)eUb(2,f[a+16>>2]|0,c);if(d&2|0)eUb(3,f[a+20>>2]|0,c);if(d&8|0)YTb(4,(b[a+28>>0]|0)!=0,c);if(d&16|0)YTb(5,(b[a+29>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function _7a(a){a=a|0;return f[a+12>>2]|0}function $7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&1))o=g;else{m=f[a+16>>2]|0;b[g>>0]=18;n=g+1|0;g=_i[f[(f[m>>2]|0)+60>>2]&1023](m)|0;if(g>>>0>127){h=g;i=n;while(1){b[i>>0]=h|128;j=h>>>7;d=i+1|0;if(h>>>0>16383){h=j;i=d}else{p=d;q=j;break}}}else{p=n;q=g}b[p>>0]=q;o=hj[f[(f[m>>2]|0)+64>>2]&511](m,c,p+1|0)|0}if(!(e&2))r=o;else{p=f[a+20>>2]|0;b[o>>0]=26;m=o+1|0;o=_i[f[(f[p>>2]|0)+60>>2]&1023](p)|0;if(o>>>0>127){q=o;g=m;while(1){b[g>>0]=q|128;n=q>>>7;i=g+1|0;if(q>>>0>16383){q=n;g=i}else{s=i;t=n;break}}}else{s=m;t=o}b[s>>0]=t;r=hj[f[(f[p>>2]|0)+64>>2]&511](p,c,s+1|0)|0}if(!(e&8))u=r;else{s=b[a+28>>0]|0;b[r>>0]=32;b[r+1>>0]=s;u=r+2|0}if(!(e&16))v=u;else{e=b[a+29>>0]|0;b[u>>0]=40;b[u+1>>0]=e;v=u+2|0}u=f[a+4>>2]|0;if(!(u&1)){w=v;return w|0}w=Hjc(u&-2,v)|0;return w|0}function a8a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function b8a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15688,0)|0;if(!c){Ehc(b,a);return}else{e8a(a,c);return}}function c8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function d8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525488;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function e8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&31))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=VDc(48)|0;BWa(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;CWa(i,g|0?g:521608)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[g>>2]|0;if(!i){d=VDc(48)|0;BWa(d);f[g>>2]=d;j=d}else j=i;i=f[c+20>>2]|0;CWa(j,i|0?i:521608)}if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)b[a+28>>0]=b[c+28>>0]|0;if(e&16|0)b[a+29>>0]=b[c+29>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function f8a(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=92876;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523888?(f[220414]|0)!=2:0){f[e>>2]=161028;f[e+4>>2]=77;b[e+8>>0]=0;DTb(881656,e);ZSb(e)}e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;d[e+16>>1]=0;u=c;return}function g8a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function h8a(a){a=a|0;var b=0,c=0;f[a>>2]=92984;z8a(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function i8a(a){a=a|0;h8a(a);YDc(a);return}function j8a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function k8a(a,b){a=a|0;b=b|0;a=VDc(32)|0;x8a(a);if(!b)return a|0;y8a(b,a);return a|0}function l8a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&7|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&4|0){e=f[a+24>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);b[a+28>>0]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function m8a(a){a=a|0;return 1}function n8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+20|0;k=a+24|0;l=a+28|0;m=e+8|0;n=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=a+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=WRb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=10){t=q;break b}f[h>>2]=f[h>>2]|1;p=f[i>>2]|0;if((p|0)==527320){GLa(i,527320);v=f[i>>2]|0}else v=p;if(fUb(c,v)|0)continue a;else{w=0;r=30;break a}break}case 2:{if((q&255|0)!=18){t=q;break b}f[h>>2]=f[h>>2]|2;p=f[j>>2]|0;if((p|0)==527320){GLa(j,527320);x=f[j>>2]|0}else x=p;if(fUb(c,x)|0)continue a;else{w=0;r=30;break a}break}case 3:{if((q&255|0)!=26){t=q;break b}f[h>>2]=f[h>>2]|4;p=f[k>>2]|0;if((p|0)==527320){GLa(k,527320);y=f[k>>2]|0}else y=p;if(fUb(c,y)|0)continue a;else{w=0;r=30;break a}break}case 4:{if((q&255|0)!=32){t=q;break b}f[h>>2]=f[h>>2]|8;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(a=b[p>>0]|0,a<<24>>24>-1):0){f[c>>2]=p+1;z=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[m>>0]|0)){w=0;r=30;break a}else z=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[l>>0]=z&1;continue a;break}default:{t=q;break b}}}while(0);if(!t){w=1;r=30;break}a=f[n>>2]|0;if(!(a&1))A=mNa(n)|0;else A=a&-2;if(!(Djc(c,t,A)|0)){w=0;r=30;break}}if((r|0)==30){u=d;return w|0}return 0}function o8a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&15)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else{k=f[a+20>>2]|0;d=b[k+11>>0]|0;j=d<<24>>24<0?f[k+4>>2]|0:d&255;l=h+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))m=l;else{j=f[a+24>>2]|0;h=b[j+11>>0]|0;d=h<<24>>24<0?f[j+4>>2]|0:h&255;m=l+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}e=c&8|0?m+2|0:m;g=a+12|0;f[g>>2]=e;return e|0}function p8a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)$Tb(1,f[a+16>>2]|0,c);if(d&2|0)$Tb(2,f[a+20>>2]|0,c);if(d&4|0)$Tb(3,f[a+24>>2]|0,c);if(d&8|0)YTb(4,(b[a+28>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function q8a(a){a=a|0;return f[a+12>>2]|0}function r8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=18;h=dSb(d,e+1|0)|0}if(!(c&4))i=h;else{e=f[a+24>>2]|0;b[h>>0]=26;i=dSb(e,h+1|0)|0}if(!(c&8))j=i;else{c=b[a+28>>0]|0;b[i>>0]=32;b[i+1>>0]=c;j=i+2|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Hjc(i&-2,j)|0;return k|0}function s8a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function t8a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15704,0)|0;if(!c){Ehc(b,a);return}else{w8a(a,c);return}}function u8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function v8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525480;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function w8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&15))return;do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+20|0,d=f[c+20>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==527320){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+24|0,h=f[c+24>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==527320){GLa(d,h);break}else{iEc(g,h)|0;break}while(0);if(e&8|0)b[a+28>>0]=b[c+28>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function x8a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92984;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523856?(f[220413]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=76;b[d+8>>0]=0;DTb(881652,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;b[a+28>>0]=0;u=c;return}function y8a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function z8a(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function A8a(a){a=a|0;var b=0,c=0;f[a>>2]=93092;if((a|0)!=523728?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function B8a(a){a=a|0;A8a(a);YDc(a);return}function C8a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function D8a(a,b){a=a|0;b=b|0;a=VDc(20)|0;Q8a(a);if(!b)return a|0;R8a(b,a);return a|0}function E8a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&1|0){c=f[a+16>>2]|0;Yi[f[(f[c>>2]|0)+28>>2]&2047](c)}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function F8a(a){a=a|0;return 1}function G8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+4|0;k=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=WRb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}if((o|0)==6){o=0;if((n|0)==10){f[h>>2]=f[h>>2]|1;m=f[i>>2]|0;if(!m){a=VDc(32)|0;SXa(a);f[i>>2]=a;r=a}else r=m;m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0?(a=b[m>>0]|0,a<<24>>24>-1):0){f[c>>2]=m+1;s=a&255}else{a=VRb(c)|0;if((a|0)>-1)s=a;else{t=0;o=22;break}}GRb(e,c,s);if((f[j>>2]|0)<0){o=15;break}if(!(Mi[f[(f[r>>2]|0)+44>>2]&1023](r,c)|0)){o=15;break}if(LRb(c,f[e>>2]|0)|0)continue;else{t=0;o=22;break}}else q=n}if(!q){t=1;o=22;break}a=f[k>>2]|0;if(!(a&1))v=mNa(k)|0;else v=a&-2;if(!(Djc(c,q,v)|0)){t=0;o=22;break}}if((o|0)==15){t=0;u=d;return t|0}else if((o|0)==22){u=d;return t|0}return 0}function H8a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;if(!(f[a+8>>2]&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+16>>2]|0;g=_i[f[(f[b>>2]|0)+48>>2]&1023](b)|0;d=c+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=a+12|0;f[e>>2]=d;return d|0}function I8a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)eUb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function J8a(a){a=a|0;return f[a+12>>2]|0}function K8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!(f[a+8>>2]&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;h=d+1|0;d=_i[f[(f[g>>2]|0)+60>>2]&1023](g)|0;if(d>>>0>127){i=d;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=d}b[m>>0]=n;e=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,m+1|0)|0}m=f[a+4>>2]|0;if(!(m&1)){o=e;return o|0}o=Hjc(m&-2,e)|0;return o|0}function L8a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function M8a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15720,0)|0;if(!c){Ehc(b,a);return}else{P8a(a,c);return}}function N8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function O8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525456;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function P8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[b+8>>2]&1))return;d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[d>>2]|0;if(!a){g=VDc(32)|0;SXa(g);f[d>>2]=g;h=g}else h=a;a=f[b+16>>2]|0;b=a|0?a:521128;a=h+4|0;g=f[b+4>>2]|0;if(g&1|0){d=f[a>>2]|0;if(!(d&1))i=mNa(a)|0;else i=d&-2;ojc(i,g&-2)}g=h+16|0;i=b+16|0;d=f[i>>2]|0;if(!d)return;UHa(g,(f[g>>2]|0)+d|0);dJc((f[h+24>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+24>>2]|0)+8|0,f[i>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[i>>2]|0);return}function Q8a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93092;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523728?(f[220410]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=73;b[d+8>>0]=0;DTb(881640,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function R8a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function S8a(a){a=a|0;var b=0,c=0;f[a>>2]=93200;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function T8a(a){a=a|0;var b=0,c=0;f[a>>2]=93200;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function U8a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function V8a(a,b){a=a|0;b=b|0;a=VDc(28)|0;f9a(a);if(!b)return a|0;g9a(b,a);return a|0}function W8a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function X8a(a){a=a|0;return 1}function Y8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+24|0;l=a+16|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(TRb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=21){s=p;break b}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){o=n;a=h[o>>0]|h[o+1>>0]<<8|h[o+2>>0]<<16|h[o+3>>0]<<24;f[e>>2]=a;f[c>>2]=n+4;v=a}else{if(!(TRb(c,e)|0)){q=20;break a}v=f[e>>2]|0}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;w=o}else{if(!(TRb(c,e)|0)){q=27;break a}w=f[e>>2]|0}f[l>>2]=w;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=33;break}o=f[m>>2]|0;if(!(o&1))y=mNa(m)|0;else y=o&-2;if(!(Djc(c,s,y)|0)){x=0;q=33;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==20){x=0;u=d;return x|0}else if((q|0)==27){x=0;u=d;return x|0}else if((q|0)==33){u=d;return x|0}return 0}function Z8a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;c=b&2|0?g+5|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function _8a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)WTb(1,+n[a+20>>2],b);if(c&4|0)WTb(2,+n[a+24>>2],b);if(c&1|0)WTb(3,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function $8a(a){a=a|0;return f[a+12>>2]|0}function a9a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&4))i=e;else{d=f[a+24>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}if(!(c&1))j=i;else{c=f[a+16>>2]|0;b[i>>0]=29;e=i+1|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;j=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Hjc(i&-2,j)|0;return k|0}function b9a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function c9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15736,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function d9a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function e9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525424;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function f9a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93200;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523600?(f[220406]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=69;b[d+8>>0]=0;DTb(881624,d);ZSb(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0;u=c;return}function g9a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function h9a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=93308;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function i9a(a){a=a|0;h9a(a);YDc(a);return}function j9a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function k9a(a,b){a=a|0;b=b|0;a=VDc(32)|0;w9a(a);if(!b)return a|0;x9a(b,a);return a|0}function l9a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function m9a(a){a=a|0;return 1}function n9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=e+4|0;j=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=6}else{o=l;n=5}}else{o=0;n=5}if((n|0)==5){n=0;l=WRb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=6}else p=l}if((n|0)==6){n=0;if((m|0)==10){l=Z0a(h)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(k=b[a>>0]|0,k<<24>>24>-1):0){f[c>>2]=a+1;q=k&255}else{k=VRb(c)|0;if((k|0)>-1)q=k;else{r=0;n=20;break}}GRb(e,c,q);if((f[i>>2]|0)<0){n=13;break}if(!(Mi[f[(f[l>>2]|0)+44>>2]&1023](l,c)|0)){n=13;break}if(LRb(c,f[e>>2]|0)|0)continue;else{r=0;n=20;break}}else p=m}if(!p){r=1;n=20;break}l=f[j>>2]|0;if(!(l&1))s=mNa(j)|0;else s=l&-2;if(!(Djc(c,p,s)|0)){r=0;n=20;break}}if((n|0)==13){r=0;u=d;return r|0}else if((n|0)==20){u=d;return r|0}return 0}function o9a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function p9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function q9a(a){a=a|0;return f[a+12>>2]|0}function r9a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Hjc(j&-2,g)|0;return s|0}function s9a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function t9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15752,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}F0a(a+16|0,c+16|0);return}function u9a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function v9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525416;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function w9a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=93308;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=523568?(f[220405]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=68;b[d+8>>0]=0;DTb(881620,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function x9a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function y9a(a){a=a|0;var b=0,c=0;f[a>>2]=93416;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function z9a(a){a=a|0;var b=0,c=0;f[a>>2]=93416;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function A9a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function B9a(a,b){a=a|0;b=b|0;a=VDc(24)|0;N9a(a);if(!b)return a|0;O9a(b,a);return a|0}function C9a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=-1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function D9a(a){a=a|0;return 1}function E9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=HRb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=24;break a}}f[g>>2]=p;continue a;break}case 2:{if((l&255|0)!=16){o=l;break b}f[e>>2]=f[e>>2]|2;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;s=a}else{t=a;m=17}}else{t=0;m=17}if((m|0)==17){m=0;a=HRb(c,t)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)s=a;else{r=0;m=24;break a}}f[h>>2]=s;continue a;break}default:{o=l;break b}}}while(0);if(!o){r=1;m=24;break}a=f[i>>2]|0;if(!(a&1))u=mNa(i)|0;else u=a&-2;if(!(Djc(c,o,u)|0)){r=0;m=24;break}}if((m|0)==24)return r|0;return 0}function F9a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function G9a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)MTb(1,f[a+16>>2]|0,b);if(c&2|0)MTb(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function H9a(a){a=a|0;return f[a+12>>2]|0}function I9a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=f[a+20>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=aJc(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function J9a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function K9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15768,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function L9a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function M9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525360;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function N9a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93416;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523336?(f[220398]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=61;b[d+8>>0]=0;DTb(881592,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=1;f[a+20>>2]=-1;u=c;return}function O9a(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function P9a(a){a=a|0;var b=0,c=0;f[a>>2]=93524;if((a|0)!=523264){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function Q9a(a){a=a|0;P9a(a);YDc(a);return}function R9a(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function S9a(a,b){a=a|0;b=b|0;a=VDc(36)|0;dab(a);if(!b)return a|0;eab(b,a);return a|0}function T9a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+16>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2|0){e=f[a+20>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d&28|0){d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;b[a+32>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function U9a(a){a=a|0;return 1}function V9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+24|0;j=a+28|0;k=a+32|0;l=e+8|0;m=a+16|0;n=e+4|0;o=a+20|0;p=e+4|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=WRb(c,w)|0;if((s+-1|0)>>>0<127){t=s;v=6}else x=s}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{if((t&255|0)!=8){x=t;break b}f[h>>2]=f[h>>2]|4;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){a=b[s>>0]|0;r=a&255;if(a<<24>>24>-1){f[i>>2]=r;f[c>>2]=s+1;continue a}else y=r}else y=0;r=HRb(c,y)|0;s=J;f[i>>2]=r;if((s|0)>-1|(s|0)==-1&r>>>0>4294967295)continue a;else{z=0;v=50;break a}break}case 2:{if((t&255|0)!=16){x=t;break b}f[h>>2]=f[h>>2]|8;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){s=b[r>>0]|0;a=s&255;if(s<<24>>24>-1){f[j>>2]=a;f[c>>2]=r+1;continue a}else A=a}else A=0;a=HRb(c,A)|0;r=J;f[j>>2]=a;if((r|0)>-1|(r|0)==-1&a>>>0>4294967295)continue a;else{z=0;v=50;break a}break}case 3:{if((t&255|0)!=24){x=t;break b}f[h>>2]=f[h>>2]|16;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;B=r<<24>>24!=0}else{IRb(e,c);r=e;if(!(b[l>>0]|0)){z=0;v=50;break a}else B=(f[r>>2]|0)!=0|(f[r+4>>2]|0)!=0}b[k>>0]=B&1;continue a;break}case 4:{if((t&255|0)!=34){x=t;break b}f[h>>2]=f[h>>2]|1;r=f[m>>2]|0;if(!r){a=VDc(48)|0;BWa(a);f[m>>2]=a;C=a}else C=r;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;D=a&255}else{a=VRb(c)|0;if((a|0)>-1)D=a;else{z=0;v=50;break a}}GRb(e,c,D);if((f[n>>2]|0)<0){v=32;break a}if(!(Mi[f[(f[C>>2]|0)+44>>2]&1023](C,c)|0)){v=32;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{z=0;v=50;break a}break}case 5:{if((t&255|0)!=42){x=t;break b}f[h>>2]=f[h>>2]|2;a=f[o>>2]|0;if(!a){r=VDc(48)|0;BWa(r);f[o>>2]=r;E=r}else E=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;F=r&255}else{r=VRb(c)|0;if((r|0)>-1)F=r;else{z=0;v=50;break a}}GRb(e,c,F);if((f[p>>2]|0)<0){v=43;break a}if(!(Mi[f[(f[E>>2]|0)+44>>2]&1023](E,c)|0)){v=43;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{z=0;v=50;break a}break}default:{x=t;break b}}}while(0);if(!x){z=1;v=50;break}r=f[q>>2]|0;if(!(r&1))G=mNa(q)|0;else G=r&-2;if(!(Djc(c,x,G)|0)){z=0;v=50;break}}if((v|0)==32){z=0;u=d;return z|0}else if((v|0)==43){z=0;u=d;return z|0}else if((v|0)==50){u=d;return z|0}return 0}function W9a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&31)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){k=h;l=i}else{i=f[a+20>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=i;l=f[b>>2]|0}if(!(l&4))m=k;else m=k+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(l&8))n=m;else n=m+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=l&16|0?n+2|0:n;g=a+12|0;f[g>>2]=e;return e|0}function X9a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&4|0)OTb(1,f[a+24>>2]|0,c);if(d&8|0)OTb(2,f[a+28>>2]|0,c);if(d&16|0)YTb(3,(b[a+32>>0]|0)!=0,c);if(d&1|0)eUb(4,f[a+16>>2]|0,c);if(d&2|0)eUb(5,f[a+20>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Y9a(a){a=a|0;return f[a+12>>2]|0}function Z9a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&8))o=g;else{m=f[a+28>>2]|0;b[g>>0]=16;n=g+1|0;if(m>>>0>127){g=m;h=n;while(1){b[h>>0]=g|128;i=g>>>7;j=h+1|0;if(g>>>0>16383){g=i;h=j}else{p=j;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}if(!(e&16))r=o;else{p=b[a+32>>0]|0;b[o>>0]=24;b[o+1>>0]=p;r=o+2|0}if(!(e&1))s=r;else{o=f[a+16>>2]|0;b[r>>0]=34;p=r+1|0;r=_i[f[(f[o>>2]|0)+60>>2]&1023](o)|0;if(r>>>0>127){q=r;m=p;while(1){b[m>>0]=q|128;n=q>>>7;h=m+1|0;if(q>>>0>16383){q=n;m=h}else{t=h;u=n;break}}}else{t=p;u=r}b[t>>0]=u;s=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,t+1|0)|0}if(!(e&2))v=s;else{e=f[a+20>>2]|0;b[s>>0]=42;t=s+1|0;s=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(s>>>0>127){o=s;u=t;while(1){b[u>>0]=o|128;r=o>>>7;p=u+1|0;if(o>>>0>16383){o=r;u=p}else{w=p;x=r;break}}}else{w=t;x=s}b[w>>0]=x;v=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,w+1|0)|0}w=f[a+4>>2]|0;if(!(w&1)){y=v;return y|0}y=Hjc(w&-2,v)|0;return y|0}function _9a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function $9a(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15784,0)|0;if(!c){Ehc(b,a);return}else{cab(a,c);return}}function aab(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function bab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525344;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function cab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&31))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=VDc(48)|0;BWa(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;CWa(i,g|0?g:521608)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[g>>2]|0;if(!i){d=VDc(48)|0;BWa(d);f[g>>2]=d;j=d}else j=i;i=f[c+20>>2]|0;CWa(j,i|0?i:521608)}if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)b[a+32>>0]=b[c+32>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function dab(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93524;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523264?(f[220396]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=59;b[d+8>>0]=0;DTb(881584,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;b[a+32>>0]=1;u=c;return}function eab(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function fab(a){a=a|0;var b=0,c=0;f[a>>2]=93632;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function gab(a){a=a|0;var b=0,c=0;f[a>>2]=93632;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function hab(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function iab(a,b){a=a|0;b=b|0;a=VDc(20)|0;uab(a);if(!b)return a|0;vab(b,a);return a|0}function jab(a){a=a|0;var b=0;n[a+16>>2]=1.0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function kab(a){a=a|0;return 1}function lab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=WRb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}if((o|0)==6){o=0;if((n|0)==13){f[i>>2]=f[i>>2]|1;m=f[c>>2]|0;if(((f[g>>2]|0)-m|0)>3){a=m;l=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=l;f[c>>2]=m+4;r=l}else{if(!(TRb(c,e)|0)){o=12;break}r=f[e>>2]|0}f[j>>2]=r;continue}else q=n}if(!q){s=1;o=18;break}l=f[k>>2]|0;if(!(l&1))t=mNa(k)|0;else t=l&-2;if(!(Djc(c,q,t)|0)){s=0;o=18;break}}if((o|0)==12){s=0;u=d;return s|0}else if((o|0)==18){u=d;return s|0}return 0}function mab(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]&1|0?c+5|0:c;f[a+12>>2]=b;return b|0}function nab(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)WTb(1,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function oab(a){a=a|0;return f[a+12>>2]|0}function pab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=13;g=d+1|0;b[g>>0]=c;b[g+1>>0]=c>>8;b[g+2>>0]=c>>16;b[g+3>>0]=c>>24;e=d+5|0}d=f[a+4>>2]|0;if(!(d&1)){h=e;return h|0}h=Hjc(d&-2,e)|0;return h|0}function qab(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function rab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15800,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function sab(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function tab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525336;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function uab(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93632;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523240?(f[220395]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=58;b[d+8>>0]=0;DTb(881580,d);ZSb(d)}f[a+12>>2]=0;n[a+16>>2]=1.0;u=c;return}function vab(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function wab(a){a=a|0;var b=0,c=0;f[a>>2]=93740;Oab(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function xab(a){a=a|0;wab(a);YDc(a);return}function yab(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function zab(a,b){a=a|0;b=b|0;a=VDc(40)|0;Mab(a);if(!b)return a|0;Nab(b,a);return a|0}function Aab(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&31|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&4|0){e=f[a+24>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&8|0){g=f[a+28>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&16|0){e=f[a+32>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);f[a+36>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Bab(a){a=a|0;return 1}function Cab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+24|0;j=a+28|0;k=a+32|0;l=a+36|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[e>>2]=f[e>>2]|1;o=f[g>>2]|0;if((o|0)==527320){GLa(g,527320);t=f[g>>2]|0}else t=o;if(fUb(c,t)|0)continue a;else{u=0;q=37;break a}break}case 2:{if((p&255|0)!=18){s=p;break b}f[e>>2]=f[e>>2]|2;o=f[h>>2]|0;if((o|0)==527320){GLa(h,527320);v=f[h>>2]|0}else v=o;if(fUb(c,v)|0)continue a;else{u=0;q=37;break a}break}case 3:{if((p&255|0)!=26){s=p;break b}f[e>>2]=f[e>>2]|4;o=f[i>>2]|0;if((o|0)==527320){GLa(i,527320);w=f[i>>2]|0}else w=o;if(fUb(c,w)|0)continue a;else{u=0;q=37;break a}break}case 4:{if((p&255|0)!=34){s=p;break b}f[e>>2]=f[e>>2]|8;o=f[j>>2]|0;if((o|0)==527320){GLa(j,527320);x=f[j>>2]|0}else x=o;if(fUb(c,x)|0)continue a;else{u=0;q=37;break a}break}case 5:{if((p&255|0)!=42){s=p;break b}f[e>>2]=f[e>>2]|16;o=f[k>>2]|0;if((o|0)==527320){GLa(k,527320);y=f[k>>2]|0}else y=o;if(fUb(c,y)|0)continue a;else{u=0;q=37;break a}break}case 6:{if((p&255|0)!=48){s=p;break b}f[e>>2]=f[e>>2]|32;o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[l>>2]=n;f[c>>2]=o+1;continue a}else z=n}else z=0;n=HRb(c,z)|0;o=J;f[l>>2]=n;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)continue a;else{u=0;q=37;break a}break}default:{s=p;break b}}}while(0);if(!s){u=1;q=37;break}n=f[m>>2]|0;if(!(n&1))A=mNa(m)|0;else A=n&-2;if(!(Djc(c,s,A)|0)){u=0;q=37;break}}if((q|0)==37)return u|0;return 0}function Dab(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&63)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else{k=f[a+20>>2]|0;d=b[k+11>>0]|0;j=d<<24>>24<0?f[k+4>>2]|0:d&255;l=h+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))m=l;else{j=f[a+24>>2]|0;h=b[j+11>>0]|0;d=h<<24>>24<0?f[j+4>>2]|0:h&255;m=l+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8))n=m;else{d=f[a+28>>2]|0;l=b[d+11>>0]|0;h=l<<24>>24<0?f[d+4>>2]|0:l&255;n=m+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&16))o=n;else{h=f[a+32>>2]|0;m=b[h+11>>0]|0;l=m<<24>>24<0?f[h+4>>2]|0:m&255;o=n+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&32)){e=o;g=a+12|0;f[g>>2]=e;return e|0}e=o+1+((((($(f[a+36>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function Eab(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&2|0)$Tb(2,f[a+20>>2]|0,b);if(c&4|0)$Tb(3,f[a+24>>2]|0,b);if(c&8|0)$Tb(4,f[a+28>>2]|0,b);if(c&16|0)$Tb(5,f[a+32>>2]|0,b);if(c&32|0)OTb(6,f[a+36>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Fab(a){a=a|0;return f[a+12>>2]|0}function Gab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=18;h=dSb(d,e+1|0)|0}if(!(c&4))i=h;else{e=f[a+24>>2]|0;b[h>>0]=26;i=dSb(e,h+1|0)|0}if(!(c&8))j=i;else{h=f[a+28>>2]|0;b[i>>0]=34;j=dSb(h,i+1|0)|0}if(!(c&16))k=j;else{i=f[a+32>>2]|0;b[j>>0]=42;k=dSb(i,j+1|0)|0}if(!(c&32))l=k;else{c=f[a+36>>2]|0;b[k>>0]=48;j=k+1|0;if(c>>>0>127){k=c;i=j;while(1){b[i>>0]=k|128;h=k>>>7;e=i+1|0;if(k>>>0>16383){k=h;i=e}else{m=e;n=h;break}}}else{m=j;n=c}b[m>>0]=n;l=m+1|0}m=f[a+4>>2]|0;if(!(m&1)){o=l;return o|0}o=Hjc(m&-2,l)|0;return o|0}function Hab(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Iab(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15816,0)|0;if(!c){Ehc(b,a);return}else{Lab(a,c);return}}function Jab(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Kab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525304;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Lab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&63))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+20|0,c=f[b+20>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==527320){GLa(e,c);break}else{iEc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+24|0,g=f[b+24>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==527320){GLa(c,g);break}else{iEc(e,g)|0;break}while(0);do if(d&8|0?(g=a+8|0,f[g>>2]=f[g>>2]|8,g=a+28|0,e=f[b+28>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);do if(d&16|0?(e=a+8|0,f[e>>2]=f[e>>2]|16,e=a+32|0,c=f[b+32>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==527320){GLa(e,c);break}else{iEc(g,c)|0;break}while(0);if(d&32|0)f[a+36>>2]=f[b+36>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Mab(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93740;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523040?(f[220391]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=54;b[d+8>>0]=0;DTb(881564,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;f[a+28>>2]=527320;f[a+32>>2]=527320;f[a+36>>2]=0;u=c;return}function Nab(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Oab(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+28>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+32>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function Pab(a){a=a|0;var b=0,c=0;f[a>>2]=93848;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function Qab(a){a=a|0;var b=0,c=0;f[a>>2]=93848;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function Rab(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Sab(a,b){a=a|0;b=b|0;a=VDc(28)|0;cbb(a);if(!b)return a|0;dbb(b,a);return a|0}function Tab(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){f[a+16>>2]=0;n[a+20>>2]=.30000001192092896;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Uab(a){a=a|0;return 1}function Vab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+16|0;l=a+24|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(TRb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|1;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;a=o&255;if(o<<24>>24>-1){f[c>>2]=n+1;v=a}else{w=a;q=18}}else{w=0;q=18}if((q|0)==18){q=0;a=HRb(c,w)|0;n=J;if((n|0)>-1|(n|0)==-1&a>>>0>4294967295)v=a;else{x=0;q=32;break a}}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;y=o}else{if(!(TRb(c,e)|0)){q=26;break a}y=f[e>>2]|0}f[l>>2]=y;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=32;break}o=f[m>>2]|0;if(!(o&1))z=mNa(m)|0;else z=o&-2;if(!(Djc(c,s,z)|0)){x=0;q=32;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==26){x=0;u=d;return x|0}else if((q|0)==32){u=d;return x|0}return 0}function Wab(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}c=b&2|0?g+5|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function Xab(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)WTb(1,+n[a+20>>2],b);if(c&1|0)MTb(2,f[a+16>>2]|0,b);if(c&4|0)WTb(3,+n[a+24>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Yab(a){a=a|0;return f[a+12>>2]|0}function Zab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&1))i=e;else{d=f[a+16>>2]|0;b[e>>0]=16;g=e+1|0;e=d&255;if(d>>>0>127){h=g;j=e;k=d;l=((d|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;d=k;k=aJc(k|0,l|0,7)|0;m=h+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&d>>>0>16383)){o=m;p=n;break}else{h=m;j=n;l=J}}}else{o=g;p=e}b[o>>0]=p;i=o+1|0}if(!(c&4))q=i;else{c=f[a+24>>2]|0;b[i>>0]=29;o=i+1|0;b[o>>0]=c;b[o+1>>0]=c>>8;b[o+2>>0]=c>>16;b[o+3>>0]=c>>24;q=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){r=q;return r|0}r=Hjc(i&-2,q)|0;return r|0}function _ab(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function $ab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15832,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function abb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function bbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525296;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function cbb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93848;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=523008?(f[220390]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=53;b[d+8>>0]=0;DTb(881560,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;n[a+20>>2]=.30000001192092896;n[a+24>>2]=1.0;u=c;return}function dbb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function ebb(a){a=a|0;var b=0,c=0;f[a>>2]=93956;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function fbb(a){a=a|0;var b=0,c=0;f[a>>2]=93956;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function gbb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function hbb(a,b){a=a|0;b=b|0;a=VDc(32)|0;ubb(a);if(!b)return a|0;vbb(b,a);return a|0}function ibb(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+28>>2]=2;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function jbb(a){a=a|0;return 1}function kbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=c+4|0;e=a+8|0;g=a+28|0;h=a+16|0;i=a+20|0;j=a+24|0;k=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=WRb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}b:do if((o|0)==6){o=0;switch(n>>>3&536870911|0){case 1:{if((n&255|0)!=8){q=n;break b}f[e>>2]=f[e>>2]|1;m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){a=b[m>>0]|0;l=a&255;if(a<<24>>24>-1){f[c>>2]=m+1;r=l}else{s=l;o=11}}else{s=0;o=11}if((o|0)==11){o=0;l=HRb(c,s)|0;m=J;if((m|0)>-1|(m|0)==-1&l>>>0>4294967295)r=l;else{t=0;o=35;break a}}f[g>>2]=r;continue a;break}case 2:break;default:{q=n;break b}}switch((n&255)<<24>>24){case 16:break;case 18:{if(I$a(c,h)|0)continue a;else{t=0;o=35;break a}break}default:{q=n;break b}}l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){m=b[l>>0]|0;a=m&255;if(m<<24>>24>-1){f[c>>2]=l+1;u=a}else{v=a;o=17}}else{v=0;o=17}if((o|0)==17){o=0;a=HRb(c,v)|0;l=J;if((l|0)>-1|(l|0)==-1&a>>>0>4294967295)u=a;else{t=0;o=35;break a}}a=f[h>>2]|0;if((a|0)==(f[i>>2]|0)){OLa(h,a+1|0);w=f[h>>2]|0}else w=a;a=f[j>>2]|0;f[h>>2]=w+1;f[a+4+(w<<2)>>2]=u;l=(f[i>>2]|0)-(f[h>>2]|0)|0;if((l|0)>0){x=l;y=a}else continue a;while(1){a=f[c>>2]|0;l=f[d>>2]|0;if(a>>>0>=l>>>0)continue a;if((b[a>>0]|0)!=16)continue a;m=a+1|0;f[c>>2]=m;if(m>>>0<l>>>0){l=b[m>>0]|0;m=l&255;if(l<<24>>24>-1){f[c>>2]=a+2;z=m;A=y}else{B=m;o=25}}else{B=0;o=25}if((o|0)==25){o=0;m=HRb(c,B)|0;a=J;if(!((a|0)>-1|(a|0)==-1&m>>>0>4294967295)){t=0;o=35;break a}z=m;A=f[j>>2]|0}m=f[h>>2]|0;f[h>>2]=m+1;f[A+4+(m<<2)>>2]=z;if((x|0)>1){x=x+-1|0;y=A}else continue a}}while(0);if(!q){t=1;o=35;break}m=f[k>>2]|0;if(!(m&1))C=mNa(k)|0;else C=m&-2;if(!(Djc(c,q,C)|0)){t=0;o=35;break}}if((o|0)==35)return t|0;return 0}function lbb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=iUb(a+16|0)|0;d=b+c+(f[a+16>>2]|0)|0;if(!(f[a+8>>2]&1)){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+28>>2]|0;if((c|0)<0)h=11;else h=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=h+d|0;g=a+12|0;f[g>>2]=e;return e|0}function mbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(f[a+8>>2]&1|0)MTb(1,f[a+28>>2]|0,b);c=f[a+16>>2]|0;if((c|0)>0){d=a+24|0;e=0;do{OTb(2,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function nbb(a){a=a|0;return f[a+12>>2]|0}function obb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+28>>2]|0;b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=aJc(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+16>>2]|0;if(!n)p=e;else{o=f[a+24>>2]|0;d=0;g=e;while(1){e=f[o+4+(d<<2)>>2]|0;b[g>>0]=16;k=g+1|0;if(e>>>0>127){i=e;h=k;while(1){b[h>>0]=i|128;j=i>>>7;m=h+1|0;if(i>>>0>16383){i=j;h=m}else{q=m;r=j;break}}}else{q=k;r=e}b[q>>0]=r;h=q+1|0;d=d+1|0;if((d|0)>=(n|0)){p=h;break}else g=h}}g=f[a+4>>2]|0;if(!(g&1)){s=p;return s|0}s=Hjc(g&-2,p)|0;return s|0}function pbb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function qbb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15848,0)|0;if(!c){Ehc(b,a);return}else{tbb(a,c);return}}function rbb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function sbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525280;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function tbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){OLa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}if(!(f[b+8>>2]&1))return;g=f[b+28>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|1;f[a+28>>2]=g;return}function ubb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93956;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=522920?(f[220388]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=51;b[d+8>>0]=0;DTb(881552,d);ZSb(d)}f[a+12>>2]=0;f[a+28>>2]=2;u=c;return}function vbb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function wbb(a){a=a|0;var b=0,c=0;f[a>>2]=94064;if((a|0)!=522744?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function xbb(a){a=a|0;wbb(a);YDc(a);return}function ybb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function zbb(a,b){a=a|0;b=b|0;a=VDc(28)|0;Mbb(a);if(!b)return a|0;Nbb(b,a);return a|0}function Abb(a){a=a|0;var b=0,c=0;b=a+8|0;c=f[b>>2]|0;if(c&7|0){if(c&1|0){c=f[a+16>>2]|0;Yi[f[(f[c>>2]|0)+28>>2]&2047](c)}f[a+20>>2]=1;f[a+24>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Bbb(a){a=a|0;return 1}function Cbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+24|0;k=a+16|0;l=e+4|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break b}f[h>>2]=f[h>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[c>>2]=o+1;t=n}else{v=n;q=11}}else{v=0;q=11}if((q|0)==11){q=0;n=HRb(c,v)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)t=n;else{w=0;q=35;break a}}f[i>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;a=o&255;if(o<<24>>24>-1){f[c>>2]=n+1;x=a}else{y=a;q=17}}else{y=0;q=17}if((q|0)==17){q=0;a=HRb(c,y)|0;n=J;if((n|0)>-1|(n|0)==-1&a>>>0>4294967295)x=a;else{w=0;q=35;break a}}f[j>>2]=x;continue a;break}case 3:{if((p&255|0)!=26){s=p;break b}f[h>>2]=f[h>>2]|1;a=f[k>>2]|0;if(!a){n=VDc(48)|0;BWa(n);f[k>>2]=n;z=n}else z=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(n=b[a>>0]|0,n<<24>>24>-1):0){f[c>>2]=a+1;A=n&255}else{n=VRb(c)|0;if((n|0)>-1)A=n;else{w=0;q=35;break a}}GRb(e,c,A);if((f[l>>2]|0)<0){q=28;break a}if(!(Mi[f[(f[z>>2]|0)+44>>2]&1023](z,c)|0)){q=28;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{w=0;q=35;break a}break}default:{s=p;break b}}}while(0);if(!s){w=1;q=35;break}n=f[m>>2]|0;if(!(n&1))B=mNa(m)|0;else B=n&-2;if(!(Djc(c,s,B)|0)){w=0;q=35;break}}if((q|0)==28){w=0;u=d;return w|0}else if((q|0)==35){u=d;return w|0}return 0}function Dbb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&7)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2))k=h;else{b=f[a+20>>2]|0;if((b|0)<0)l=11;else l=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=l+h|0}if(!(i&4)){e=k;g=a+12|0;f[g>>2]=e;return e|0}i=f[a+24>>2]|0;if((i|0)<0)m=11;else m=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=m+k|0;g=a+12|0;f[g>>2]=e;return e|0}function Ebb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)MTb(1,f[a+20>>2]|0,b);if(c&4|0)MTb(2,f[a+24>>2]|0,b);if(c&1|0)eUb(3,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Fbb(a){a=a|0;return f[a+12>>2]|0}function Gbb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=f[a+20>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=aJc(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&4))r=g;else{p=f[a+24>>2]|0;b[g>>0]=16;q=g+1|0;g=p&255;if(p>>>0>127){d=q;i=g;m=p;k=((p|0)<0)<<31>>31;while(1){b[d>>0]=i|-128;p=m;m=aJc(m|0,k|0,7)|0;j=d+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=j;t=l;break}else{d=j;i=l;k=J}}}else{s=q;t=g}b[s>>0]=t;r=s+1|0}if(!(e&1))u=r;else{e=f[a+16>>2]|0;b[r>>0]=26;s=r+1|0;r=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(r>>>0>127){t=r;g=s;while(1){b[g>>0]=t|128;q=t>>>7;k=g+1|0;if(t>>>0>16383){t=q;g=k}else{v=k;w=q;break}}}else{v=s;w=r}b[v>>0]=w;u=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,v+1|0)|0}v=f[a+4>>2]|0;if(!(v&1)){x=u;return x|0}x=Hjc(v&-2,u)|0;return x|0}function Hbb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Ibb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15864,0)|0;if(!c){Ehc(b,a);return}else{Lbb(a,c);return}}function Jbb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Kbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525256;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Lbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;e=f[g>>2]|0;if(!e){c=VDc(48)|0;BWa(c);f[g>>2]=c;h=c}else h=e;e=f[b+16>>2]|0;CWa(h,e|0?e:521608)}if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Mbb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94064;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522744?(f[220385]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=48;b[d+8>>0]=0;DTb(881540,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1;u=c;return}function Nbb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Obb(a){a=a|0;var b=0,c=0;f[a>>2]=94172;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function Pbb(a){a=a|0;var b=0,c=0;f[a>>2]=94172;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function Qbb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Rbb(a,b){a=a|0;b=b|0;a=VDc(28)|0;bcb(a);if(!b)return a|0;ccb(b,a);return a|0}function Sbb(a){a=a|0;var b=0;d[a+16>>1]=0;b=a+8|0;if(f[b>>2]&12|0){n[a+20>>2]=.9990000128746033;n[a+24>>2]=9.999999747378752e-06}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Tbb(a){a=a|0;return 1}function Ubb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=e+8|0;l=a+20|0;m=a+24|0;n=a+17|0;o=e+8|0;p=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=a+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=WRb(c,v)|0;if((r+-1|0)>>>0<127){s=r;t=6}else w=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{if((s&255|0)!=8){w=s;break b}f[i>>2]=f[i>>2]|1;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;x=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[k>>0]|0)){y=0;t=38;break a}else x=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[j>>0]=x&1;continue a;break}case 2:{if((s&255|0)!=21){w=s;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){r=a;q=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=q;f[c>>2]=a+4;z=q}else{if(!(TRb(c,e)|0)){t=19;break a}z=f[e>>2]|0}f[l>>2]=z;continue a;break}case 3:{if((s&255|0)!=29){w=s;break b}f[i>>2]=f[i>>2]|8;q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){a=q;r=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=r;f[c>>2]=q+4;A=r}else{if(!(TRb(c,e)|0)){t=26;break a}A=f[e>>2]|0}f[m>>2]=A;continue a;break}case 7:{if((s&255|0)!=56){w=s;break b}f[i>>2]=f[i>>2]|2;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(q=b[r>>0]|0,q<<24>>24>-1):0){f[c>>2]=r+1;B=q<<24>>24!=0}else{IRb(e,c);q=e;if(!(b[o>>0]|0)){y=0;t=38;break a}else B=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0}b[n>>0]=B&1;continue a;break}default:{w=s;break b}}}while(0);if(!w){y=1;t=38;break}q=f[p>>2]|0;if(!(q&1))C=mNa(p)|0;else C=q&-2;if(!(Djc(c,w,C)|0)){y=0;t=38;break}}if((t|0)==19){y=0;u=d;return y|0}else if((t|0)==26){y=0;u=d;return y|0}else if((t|0)==38){u=d;return y|0}return 0}function Vbb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&15)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+2|0:c;c=b&2|0?g+2|0:g;g=b&4|0?c+5|0:c;d=b&8|0?g+5|0:g;e=a+12|0;f[e>>2]=d;return d|0}function Wbb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)YTb(1,(b[a+16>>0]|0)!=0,c);if(d&4|0)WTb(2,+n[a+20>>2],c);if(d&8|0)WTb(3,+n[a+24>>2],c);if(d&2|0)YTb(7,(b[a+17>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Xbb(a){a=a|0;return f[a+12>>2]|0}function Ybb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=b[a+16>>0]|0;b[d>>0]=8;b[d+1>>0]=g;e=d+2|0}if(!(c&4))h=e;else{d=f[a+20>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&8))i=h;else{e=f[a+24>>2]|0;b[h>>0]=29;d=h+1|0;b[d>>0]=e;b[d+1>>0]=e>>8;b[d+2>>0]=e>>16;b[d+3>>0]=e>>24;i=h+5|0}if(!(c&2))j=i;else{c=b[a+17>>0]|0;b[i>>0]=56;b[i+1>>0]=c;j=i+2|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Hjc(i&-2,j)|0;return k|0}function Zbb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function _bb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,15880,0)|0;if(!d){Ehc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&15))return;if(e&1|0)b[a+16>>0]=b[d+16>>0]|0;if(e&2|0)b[a+17>>0]=b[d+17>>0]|0;if(e&4|0)f[a+20>>2]=f[d+20>>2];if(e&8|0)f[a+24>>2]=f[d+24>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function $bb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function acb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525248;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function bcb(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=94172;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522712?(f[220384]|0)!=2:0){f[e>>2]=161028;f[e+4>>2]=47;b[e+8>>0]=0;DTb(881536,e);ZSb(e)}f[a+12>>2]=0;d[a+16>>1]=0;n[a+20>>2]=.9990000128746033;n[a+24>>2]=9.999999747378752e-06;u=c;return}function ccb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function dcb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=94280;feb(a);c=f[a+132>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+120|0;d=f[c>>2]|0;if(d|0?(f[a+108>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+104|0;i=f[c>>2]|0;if(i|0?(f[a+92>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+88|0;j=f[c>>2]|0;if(j|0?(f[a+76>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+72|0;k=f[c>>2]|0;if(k|0?(f[a+60>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;YDc(l)}f[c>>2]=0;c=f[a+56>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+44|0;l=f[c>>2]|0;if(l|0?(f[a+32>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;YDc(m)}f[c>>2]=0;c=a+28|0;m=f[c>>2]|0;if(m|0?(f[a+16>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0){if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);YDc(j)}k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;YDc(n)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}n=a&-2;a=n;if((n|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(n);f[c>>2]=0;return}function ecb(a){a=a|0;dcb(a);YDc(a);return}function fcb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function gcb(a,b){a=a|0;b=b|0;a=VDc(368)|0;deb(a);if(!b)return a|0;eeb(b,a);return a|0}function hcb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}f[a+48>>2]=0;c=a+64|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+72>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+80|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+88>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+96|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+104>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+112|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+120>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}f[a+124>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){do if(d&1|0){e=f[a+136>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+140>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&4|0){e=f[a+144>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&8|0){e=f[a+148>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&16|0){e=f[a+152>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&32|0){e=f[a+156>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&64|0){e=f[a+160>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&128|0){e=f[a+164>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d&65280|0){if(d&256|0){e=f[a+168>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&512|0){e=f[a+172>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&1024|0){e=f[a+176>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2048|0){e=f[a+180>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&4096|0){e=f[a+184>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&8192|0){e=f[a+188>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&16384|0){e=f[a+192>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&32768|0){e=f[a+196>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d&16711680|0){if(d&65536|0){e=f[a+200>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&131072|0){e=f[a+204>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&262144|0){e=f[a+208>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&524288|0){e=f[a+212>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&1048576|0){e=f[a+216>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2097152|0){e=f[a+220>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&4194304|0){e=f[a+224>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&8388608|0){e=f[a+228>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d>>>0>16777215){if(d&16777216|0){e=f[a+232>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&33554432|0){e=f[a+236>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&67108864|0){e=f[a+240>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&134217728|0){e=f[a+244>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&268435456|0){e=f[a+248>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&536870912|0){e=f[a+252>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&1073741824|0){e=f[a+256>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if((d|0)<0){d=f[a+260>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}d=f[a+12>>2]|0;if(d&255|0){if(d&1|0){e=f[a+264>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2|0){e=f[a+268>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&4|0){e=f[a+272>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&8|0){e=f[a+276>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&16|0){e=f[a+280>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&32|0){e=f[a+284>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&64|0){e=f[a+288>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&128|0){e=f[a+292>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}do if(d&65280|0){if(d&256|0){e=f[a+296>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&512|0){e=f[a+300>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&1024|0){e=f[a+304>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2048|0){e=f[a+308>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&4096|0){e=f[a+312>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&8192|0){e=f[a+316>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&16384|0){e=f[a+320>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(!(d&32768))break;e=f[a+324>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}while(0);do if(d&16711680|0){if(d&65536|0){e=f[a+328>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&131072|0){e=f[a+332>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&262144|0){e=f[a+336>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&524288|0){e=f[a+340>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&1048576|0){e=f[a+344>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2097152|0){e=f[a+348>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&4194304|0){e=f[a+352>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(!(d&8388608))break;e=f[a+356>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}while(0);f[a+360>>2]=0;d=c;f[d>>2]=0;f[d+4>>2]=0;d=f[a+4>>2]|0;if(!(d&1))return;a=d&-2;if(!(f[a>>2]|0))return;ljc(a);return}function icb(a){a=a|0;var b=0,c=0;if(f[a+12>>2]&4194304|0?(b=f[a+352>>2]|0,!(_i[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function jcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+136|0;k=a+140|0;l=a+16|0;m=a+32|0;n=a+48|0;o=a+52|0;p=a+56|0;q=a+60|0;r=a+72|0;s=a+68|0;t=a+64|0;v=e+4|0;w=a+76|0;x=e+4|0;y=a+92|0;z=e+4|0;A=a+108|0;B=e+4|0;C=a+12|0;D=a+360|0;E=a+4|0;F=a+124|0;G=a+128|0;H=a+132|0;I=e+8|0;K=e+8|0;L=a+144|0;M=e+4|0;N=a+148|0;O=e+4|0;P=a+152|0;Q=e+4|0;R=a+156|0;S=e+4|0;T=a+160|0;U=e+4|0;V=a+164|0;W=e+4|0;X=a+168|0;Y=e+4|0;Z=a+172|0;_=e+4|0;$=a+176|0;aa=e+4|0;ba=a+180|0;ca=e+4|0;da=a+184|0;ea=e+4|0;fa=a+188|0;ga=e+4|0;ha=a+192|0;ia=e+4|0;ja=a+196|0;ka=e+4|0;la=a+200|0;ma=e+4|0;na=a+204|0;oa=e+4|0;pa=a+208|0;qa=e+4|0;ra=a+212|0;sa=e+4|0;ta=a+216|0;ua=e+4|0;va=a+220|0;wa=e+4|0;xa=a+224|0;ya=e+4|0;za=a+228|0;Aa=e+4|0;Ba=a+232|0;Ca=e+4|0;Da=a+236|0;Ea=e+4|0;Fa=a+240|0;Ga=e+4|0;Ha=a+244|0;Ia=e+4|0;Ja=a+248|0;Ka=e+4|0;La=a+252|0;Ma=e+4|0;Na=a+256|0;Oa=e+4|0;Pa=a+260|0;Qa=e+4|0;Ra=a+264|0;Sa=e+4|0;Ta=a+268|0;Ua=e+4|0;Va=a+272|0;Wa=e+4|0;Xa=a+276|0;Ya=e+4|0;Za=a+280|0;_a=e+4|0;$a=a+284|0;ab=e+4|0;bb=a+288|0;cb=e+4|0;db=a+292|0;eb=e+4|0;fb=a+296|0;gb=e+4|0;hb=a+300|0;ib=e+4|0;jb=a+304|0;kb=e+4|0;lb=a+308|0;mb=e+4|0;nb=a+312|0;ob=e+4|0;pb=a+316|0;qb=e+4|0;rb=a+320|0;sb=e+4|0;tb=a+324|0;ub=e+4|0;vb=a+328|0;wb=e+4|0;xb=a+332|0;yb=e+4|0;zb=a+336|0;Ab=e+4|0;Bb=a+340|0;Cb=e+4|0;Db=a+344|0;Eb=e+4|0;Fb=a+348|0;Gb=e+4|0;Hb=a+352|0;Ib=e+4|0;Jb=a+356|0;a=e+4|0;a:while(1){Kb=f[c>>2]|0;Lb=f[g>>2]|0;do if(Kb>>>0<Lb>>>0){Mb=b[Kb>>0]|0;Nb=Mb&255;Ob=Kb+1|0;if(Mb<<24>>24>0){Pb=Ob;Qb=Nb}else{if(Ob>>>0>=Lb>>>0){Rb=Nb;Sb=7;break}Mb=h[Ob>>0]|0;if(((Mb^128)&Nb)>>>0<=127){Rb=Nb;Sb=7;break}Pb=Kb+2|0;Qb=Nb+-128+(Mb<<7)|0}f[c>>2]=Pb;Tb=Qb;Sb=9}else{Rb=0;Sb=7}while(0);if((Sb|0)==7){Sb=0;Kb=WRb(c,Rb)|0;if((Kb+-1|0)>>>0<66133690){Tb=Kb;Sb=9}else Ub=Kb}b:do if((Sb|0)==9){Sb=0;Kb=Tb>>>3&536870911;if((Kb|0)<121)do switch(Kb|0){case 1:{if((Tb&255|0)!=10){Ub=Tb;break b}f[i>>2]=f[i>>2]|1;Lb=f[j>>2]|0;if((Lb|0)==527320){GLa(j,527320);Vb=f[j>>2]|0}else Vb=Lb;if(fUb(c,Vb)|0)continue a;else{Wb=0;Sb=714;break a}break}case 2:{if((Tb&255|0)!=18){Ub=Tb;break b}f[i>>2]=f[i>>2]|2;Lb=f[k>>2]|0;if((Lb|0)==527320){GLa(k,527320);Xb=f[k>>2]|0}else Xb=Lb;if(fUb(c,Xb)|0)continue a;else{Wb=0;Sb=714;break a}break}case 3:{if((Tb&255|0)!=26){Ub=Tb;break b}if(fUb(c,JLa(l)|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 4:{if((Tb&255|0)!=34){Ub=Tb;break b}if(fUb(c,JLa(m)|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 5:{switch((Tb&255)<<24>>24){case 45:break;case 42:{if(BVa(c,n)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}Lb=f[c>>2]|0;if(((f[g>>2]|0)-Lb|0)>3){Mb=Lb;Nb=h[Mb>>0]|h[Mb+1>>0]<<8|h[Mb+2>>0]<<16|h[Mb+3>>0]<<24;f[e>>2]=Nb;f[c>>2]=Lb+4;Yb=Nb}else{if(!(TRb(c,e)|0)){Sb=37;break a}Yb=f[e>>2]|0}Nb=f[n>>2]|0;if((Nb|0)==(f[o>>2]|0)){SHa(n,Nb+1|0);Zb=f[n>>2]|0}else Zb=Nb;Nb=f[p>>2]|0;Lb=Zb+1|0;f[n>>2]=Lb;f[Nb+4+(Zb<<2)>>2]=Yb;Mb=f[c>>2]|0;Ob=(f[g>>2]|0)-Mb|0;if((Ob|0)<=0)continue a;_b=Mb;Mb=(f[o>>2]|0)-Lb|0;$b=(Ob>>>0)/5|0;ac=($b|0)<(Mb|0)?$b:Mb;if((ac|0)>0){bc=0;cc=_b;dc=Lb}else continue a;while(1){if((b[cc>>0]|0)!=45){ec=bc;break}Lb=cc+1|0;Mb=h[Lb>>0]|h[Lb+1>>0]<<8|h[Lb+2>>0]<<16|h[Lb+3>>0]<<24;Lb=dc;dc=dc+1|0;f[n>>2]=dc;f[Nb+4+(Lb<<2)>>2]=Mb;Mb=bc+1|0;if((Mb|0)>=(ac|0)){ec=Mb;break}else{bc=Mb;cc=cc+5|0}}ac=ec*5|0;if((ec|0)<=0)continue a;if((Ob|0)<(ac|0)){PRb(c,ac,Ob)|0;continue a}else{f[c>>2]=_b+ac;continue a}break}case 6:{if((Tb&255|0)!=50){Ub=Tb;break b}ac=f[r>>2]|0;do if(ac){Nb=f[t>>2]|0;Mb=f[ac>>2]|0;if((Nb|0)>=(Mb|0))if((Mb|0)==(f[s>>2]|0)){fc=Mb;Sb=45;break}else{gc=Mb;hc=ac;Sb=46;break}else{f[t>>2]=Nb+1;ic=f[ac+4+(Nb<<2)>>2]|0;break}}else{fc=f[s>>2]|0;Sb=45}while(0);if((Sb|0)==45){Sb=0;USb(q,fc+1|0);ac=f[r>>2]|0;gc=f[ac>>2]|0;hc=ac;Sb=46}if((Sb|0)==46){Sb=0;f[hc>>2]=gc+1;ac=f[q>>2]|0;if(!ac){_b=VDc(32)|0;Ldb(_b);jc=_b}else{if(f[ac+64>>2]|0)OQb(ac,15976,32);_b=NQb(ac,32,1742)|0;Ldb(_b);jc=_b}_b=f[r>>2]|0;ac=f[t>>2]|0;f[t>>2]=ac+1;f[_b+4+(ac<<2)>>2]=jc;ic=jc}ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;kc=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)kc=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,kc);if((f[v>>2]|0)<0){Sb=58;break a}if(!(Mi[f[(f[ic>>2]|0)+44>>2]&1023](ic,c)|0)){Sb=58;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 7:{if((Tb&255|0)!=58){Ub=Tb;break b}_b=AXa(w)|0;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(Ob=b[ac>>0]|0,Ob<<24>>24>-1):0){f[c>>2]=ac+1;lc=Ob&255}else{Ob=VRb(c)|0;if((Ob|0)>-1)lc=Ob;else{Wb=0;Sb=714;break a}}GRb(e,c,lc);if((f[x>>2]|0)<0){Sb=67;break a}if(!(Mi[f[(f[_b>>2]|0)+44>>2]&1023](_b,c)|0)){Sb=67;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 8:{if((Tb&255|0)!=66){Ub=Tb;break b}_b=cMa(y)|0;Ob=f[c>>2]|0;if(Ob>>>0<(f[g>>2]|0)>>>0?(ac=b[Ob>>0]|0,ac<<24>>24>-1):0){f[c>>2]=Ob+1;mc=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)mc=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,mc);if((f[z>>2]|0)<0){Sb=76;break a}if(!(Mi[f[(f[_b>>2]|0)+44>>2]&1023](_b,c)|0)){Sb=76;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 9:{if((Tb&255|0)!=74){Ub=Tb;break b}_b=cMa(A)|0;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(Ob=b[ac>>0]|0,Ob<<24>>24>-1):0){f[c>>2]=ac+1;nc=Ob&255}else{Ob=VRb(c)|0;if((Ob|0)>-1)nc=Ob;else{Wb=0;Sb=714;break a}}GRb(e,c,nc);if((f[B>>2]|0)<0){Sb=85;break a}if(!(Mi[f[(f[_b>>2]|0)+44>>2]&1023](_b,c)|0)){Sb=85;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 10:{if((Tb&255|0)!=80){Ub=Tb;break b}_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0){Ob=b[_b>>0]|0;ac=Ob&255;if(Ob<<24>>24>-1){f[c>>2]=_b+1;oc=ac}else{pc=ac;Sb=91}}else{pc=0;Sb=91}if((Sb|0)==91){Sb=0;ac=HRb(c,pc)|0;_b=J;if((_b|0)>-1|(_b|0)==-1&ac>>>0>4294967295)oc=ac;else{Wb=0;Sb=714;break a}}if(oc>>>0<2){f[C>>2]=f[C>>2]|16777216;f[D>>2]=oc;continue a}ac=f[E>>2]|0;if(!(ac&1))qc=mNa(E)|0;else qc=ac&-2;rjc(qc,10,oc,((oc|0)<0)<<31>>31);continue a;break}case 11:{switch((Tb&255)<<24>>24){case 88:break;case 90:{if(ceb(c,F)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;rc=_b<<24>>24!=0}else{IRb(e,c);_b=e;if(!(b[K>>0]|0)){Wb=0;Sb=714;break a}else rc=(f[_b>>2]|0)!=0|(f[_b+4>>2]|0)!=0}_b=f[F>>2]|0;ac=f[G>>2]|0;if((_b|0)==(ac|0)){zNa(F,_b+1|0);sc=f[F>>2]|0;tc=f[G>>2]|0}else{sc=_b;tc=ac}ac=f[H>>2]|0;_b=sc+1|0;f[F>>2]=_b;b[ac+4+sc>>0]=rc&1;Ob=tc-_b|0;if((Ob|0)>0){uc=Ob;vc=_b;wc=ac}else continue a;while(1){ac=f[c>>2]|0;_b=f[g>>2]|0;if(ac>>>0>=_b>>>0)continue a;if((b[ac>>0]|0)!=88)continue a;Ob=ac+1|0;f[c>>2]=Ob;if(Ob>>>0<_b>>>0?(_b=b[Ob>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+2;xc=_b<<24>>24!=0;yc=vc;zc=wc}else{IRb(e,c);_b=e;if(!(b[I>>0]|0)){Wb=0;Sb=714;break a}xc=(f[_b>>2]|0)!=0|(f[_b+4>>2]|0)!=0;yc=f[F>>2]|0;zc=f[H>>2]|0}_b=yc+1|0;f[F>>2]=_b;b[zc+4+yc>>0]=xc&1;if((uc|0)>1){uc=uc+-1|0;vc=_b;wc=zc}else continue a}break}case 100:{if((Tb&255|0)!=34){Ub=Tb;break b}f[i>>2]=f[i>>2]|4;_b=f[L>>2]|0;if(!_b){ac=VDc(44)|0;TYa(ac);f[L>>2]=ac;Ac=ac}else Ac=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Bc=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Bc=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Bc);if((f[M>>2]|0)<0){Sb=124;break a}if(!(Mi[f[(f[Ac>>2]|0)+44>>2]&1023](Ac,c)|0)){Sb=124;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 101:{if((Tb&255|0)!=42){Ub=Tb;break b}f[i>>2]=f[i>>2]|8;ac=f[N>>2]|0;if(!ac){_b=VDc(28)|0;_Ya(_b);f[N>>2]=_b;Cc=_b}else Cc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Dc=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Dc=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Dc);if((f[O>>2]|0)<0){Sb=135;break a}if(!(Mi[f[(f[Cc>>2]|0)+44>>2]&1023](Cc,c)|0)){Sb=135;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 102:{if((Tb&255|0)!=50){Ub=Tb;break b}f[i>>2]=f[i>>2]|16;_b=f[P>>2]|0;if(!_b){ac=VDc(28)|0;NYa(ac);f[P>>2]=ac;Ec=ac}else Ec=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Fc=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Fc=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Fc);if((f[Q>>2]|0)<0){Sb=146;break a}if(!(Mi[f[(f[Ec>>2]|0)+44>>2]&1023](Ec,c)|0)){Sb=146;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 103:{if((Tb&255|0)!=58){Ub=Tb;break b}f[i>>2]=f[i>>2]|32;ac=f[R>>2]|0;if(!ac){_b=VDc(28)|0;HYa(_b);f[R>>2]=_b;Gc=_b}else Gc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Hc=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Hc=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Hc);if((f[S>>2]|0)<0){Sb=157;break a}if(!(Mi[f[(f[Gc>>2]|0)+44>>2]&1023](Gc,c)|0)){Sb=157;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 104:{if((Tb&255|0)!=66){Ub=Tb;break b}f[i>>2]=f[i>>2]|64;_b=f[T>>2]|0;if(!_b){ac=VDc(24)|0;mYa(ac);f[T>>2]=ac;Ic=ac}else Ic=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Jc=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Jc=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Jc);if((f[U>>2]|0)<0){Sb=168;break a}if(!(Mi[f[(f[Ic>>2]|0)+44>>2]&1023](Ic,c)|0)){Sb=168;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 105:{if((Tb&255|0)!=74){Ub=Tb;break b}f[i>>2]=f[i>>2]|128;ac=f[V>>2]|0;if(!ac){_b=VDc(24)|0;YYa(_b);f[V>>2]=_b;Kc=_b}else Kc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Lc=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Lc=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Lc);if((f[W>>2]|0)<0){Sb=179;break a}if(!(Mi[f[(f[Kc>>2]|0)+44>>2]&1023](Kc,c)|0)){Sb=179;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 106:{if((Tb&255|0)!=82){Ub=Tb;break b}f[i>>2]=f[i>>2]|256;_b=f[X>>2]|0;if(!_b){ac=VDc(120)|0;nYa(ac);f[X>>2]=ac;Mc=ac}else Mc=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Nc=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Nc=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Nc);if((f[Y>>2]|0)<0){Sb=190;break a}if(!(Mi[f[(f[Mc>>2]|0)+44>>2]&1023](Mc,c)|0)){Sb=190;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 107:{if((Tb&255|0)!=90){Ub=Tb;break b}f[i>>2]=f[i>>2]|512;ac=f[Z>>2]|0;if(!ac){_b=VDc(52)|0;pYa(_b);f[Z>>2]=_b;Oc=_b}else Oc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Pc=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Pc=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Pc);if((f[_>>2]|0)<0){Sb=201;break a}if(!(Mi[f[(f[Oc>>2]|0)+44>>2]&1023](Oc,c)|0)){Sb=201;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 108:{if((Tb&255|0)!=98){Ub=Tb;break b}f[i>>2]=f[i>>2]|1024;_b=f[$>>2]|0;if(!_b){ac=VDc(24)|0;rYa(ac);f[$>>2]=ac;Qc=ac}else Qc=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Rc=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Rc=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Rc);if((f[aa>>2]|0)<0){Sb=212;break a}if(!(Mi[f[(f[Qc>>2]|0)+44>>2]&1023](Qc,c)|0)){Sb=212;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 109:{if((Tb&255|0)!=106){Ub=Tb;break b}f[i>>2]=f[i>>2]|2048;ac=f[ba>>2]|0;if(!ac){_b=VDc(96)|0;LYa(_b);f[ba>>2]=_b;Sc=_b}else Sc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Tc=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Tc=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Tc);if((f[ca>>2]|0)<0){Sb=223;break a}if(!(Mi[f[(f[Sc>>2]|0)+44>>2]&1023](Sc,c)|0)){Sb=223;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 110:{if((Tb&255|0)!=114){Ub=Tb;break b}f[i>>2]=f[i>>2]|4096;_b=f[da>>2]|0;if(!_b){ac=VDc(36)|0;IYa(ac);f[da>>2]=ac;Uc=ac}else Uc=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Vc=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Vc=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Vc);if((f[ea>>2]|0)<0){Sb=234;break a}if(!(Mi[f[(f[Uc>>2]|0)+44>>2]&1023](Uc,c)|0)){Sb=234;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 111:{if((Tb&255|0)!=122){Ub=Tb;break b}f[i>>2]=f[i>>2]|8192;ac=f[fa>>2]|0;if(!ac){_b=VDc(28)|0;ZYa(_b);f[fa>>2]=_b;Wc=_b}else Wc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Xc=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Xc=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Xc);if((f[ga>>2]|0)<0){Sb=245;break a}if(!(Mi[f[(f[Wc>>2]|0)+44>>2]&1023](Wc,c)|0)){Sb=245;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 112:{if((Tb&255|0)!=130){Ub=Tb;break b}f[i>>2]=f[i>>2]|16384;_b=f[ha>>2]|0;if(!_b){ac=VDc(28)|0;sYa(ac);f[ha>>2]=ac;Yc=ac}else Yc=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Zc=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Zc=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Zc);if((f[ia>>2]|0)<0){Sb=256;break a}if(!(Mi[f[(f[Yc>>2]|0)+44>>2]&1023](Yc,c)|0)){Sb=256;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 113:{if((Tb&255|0)!=138){Ub=Tb;break b}f[i>>2]=f[i>>2]|32768;ac=f[ja>>2]|0;if(!ac){_b=VDc(20)|0;jXa(_b);f[ja>>2]=_b;_c=_b}else _c=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;$c=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)$c=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,$c);if((f[ka>>2]|0)<0){Sb=267;break a}if(!(Mi[f[(f[_c>>2]|0)+44>>2]&1023](_c,c)|0)){Sb=267;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 114:{if((Tb&255|0)!=146){Ub=Tb;break b}f[i>>2]=f[i>>2]|65536;_b=f[la>>2]|0;if(!_b){ac=VDc(20)|0;OYa(ac);f[la>>2]=ac;ad=ac}else ad=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;bd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)bd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,bd);if((f[ma>>2]|0)<0){Sb=278;break a}if(!(Mi[f[(f[ad>>2]|0)+44>>2]&1023](ad,c)|0)){Sb=278;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 115:{if((Tb&255|0)!=154){Ub=Tb;break b}f[i>>2]=f[i>>2]|131072;ac=f[na>>2]|0;if(!ac){_b=VDc(60)|0;uYa(_b);f[na>>2]=_b;cd=_b}else cd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;dd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)dd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,dd);if((f[oa>>2]|0)<0){Sb=289;break a}if(!(Mi[f[(f[cd>>2]|0)+44>>2]&1023](cd,c)|0)){Sb=289;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 116:{if((Tb&255|0)!=162){Ub=Tb;break b}f[i>>2]=f[i>>2]|262144;_b=f[pa>>2]|0;if(!_b){ac=VDc(20)|0;wYa(ac);f[pa>>2]=ac;ed=ac}else ed=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;fd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)fd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,fd);if((f[qa>>2]|0)<0){Sb=300;break a}if(!(Mi[f[(f[ed>>2]|0)+44>>2]&1023](ed,c)|0)){Sb=300;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 117:{if((Tb&255|0)!=170){Ub=Tb;break b}f[i>>2]=f[i>>2]|524288;ac=f[ra>>2]|0;if(!ac){_b=VDc(36)|0;xYa(_b);f[ra>>2]=_b;gd=_b}else gd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;hd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)hd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,hd);if((f[sa>>2]|0)<0){Sb=311;break a}if(!(Mi[f[(f[gd>>2]|0)+44>>2]&1023](gd,c)|0)){Sb=311;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 118:{if((Tb&255|0)!=178){Ub=Tb;break b}f[i>>2]=f[i>>2]|1048576;_b=f[ta>>2]|0;if(!_b){ac=VDc(40)|0;zYa(ac);f[ta>>2]=ac;id=ac}else id=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;jd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)jd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,jd);if((f[ua>>2]|0)<0){Sb=322;break a}if(!(Mi[f[(f[id>>2]|0)+44>>2]&1023](id,c)|0)){Sb=322;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 119:{if((Tb&255|0)!=186){Ub=Tb;break b}f[i>>2]=f[i>>2]|2097152;ac=f[va>>2]|0;if(!ac){_b=VDc(32)|0;GYa(_b);f[va>>2]=_b;kd=_b}else kd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;ld=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)ld=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,ld);if((f[wa>>2]|0)<0){Sb=333;break a}if(!(Mi[f[(f[kd>>2]|0)+44>>2]&1023](kd,c)|0)){Sb=333;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 120:{if((Tb&255|0)!=194){Ub=Tb;break b}f[i>>2]=f[i>>2]|4194304;_b=f[xa>>2]|0;if(!_b){ac=VDc(24)|0;SYa(ac);f[xa>>2]=ac;md=ac}else md=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;nd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)nd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,nd);if((f[ya>>2]|0)<0){Sb=344;break a}if(!(Mi[f[(f[md>>2]|0)+44>>2]&1023](md,c)|0)){Sb=344;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}while(0);if((Kb|0)<137)do switch(Kb|0){case 121:{if((Tb&255|0)!=202){Ub=Tb;break b}f[i>>2]=f[i>>2]|8388608;ac=f[za>>2]|0;if(!ac){_b=VDc(68)|0;BYa(_b);f[za>>2]=_b;od=_b}else od=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;pd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)pd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,pd);if((f[Aa>>2]|0)<0){Sb=355;break a}if(!(Mi[f[(f[od>>2]|0)+44>>2]&1023](od,c)|0)){Sb=355;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 122:{if((Tb&255|0)!=210){Ub=Tb;break b}f[i>>2]=f[i>>2]|16777216;_b=f[Ba>>2]|0;if(!_b){ac=VDc(28)|0;FYa(ac);f[Ba>>2]=ac;qd=ac}else qd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;rd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)rd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,rd);if((f[Ca>>2]|0)<0){Sb=366;break a}if(!(Mi[f[(f[qd>>2]|0)+44>>2]&1023](qd,c)|0)){Sb=366;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 123:{if((Tb&255|0)!=218){Ub=Tb;break b}f[i>>2]=f[i>>2]|33554432;ac=f[Da>>2]|0;if(!ac){_b=VDc(24)|0;PYa(_b);f[Da>>2]=_b;sd=_b}else sd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;td=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)td=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,td);if((f[Ea>>2]|0)<0){Sb=377;break a}if(!(Mi[f[(f[sd>>2]|0)+44>>2]&1023](sd,c)|0)){Sb=377;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 124:{if((Tb&255|0)!=226){Ub=Tb;break b}f[i>>2]=f[i>>2]|67108864;_b=f[Fa>>2]|0;if(!_b){ac=VDc(20)|0;WYa(ac);f[Fa>>2]=ac;ud=ac}else ud=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;vd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)vd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,vd);if((f[Ga>>2]|0)<0){Sb=388;break a}if(!(Mi[f[(f[ud>>2]|0)+44>>2]&1023](ud,c)|0)){Sb=388;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 125:{if((Tb&255|0)!=234){Ub=Tb;break b}f[i>>2]=f[i>>2]|134217728;ac=f[Ha>>2]|0;if(!ac){_b=VDc(24)|0;XYa(_b);f[Ha>>2]=_b;wd=_b}else wd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;xd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)xd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,xd);if((f[Ia>>2]|0)<0){Sb=399;break a}if(!(Mi[f[(f[wd>>2]|0)+44>>2]&1023](wd,c)|0)){Sb=399;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 126:{if((Tb&255|0)!=242){Ub=Tb;break b}f[i>>2]=f[i>>2]|268435456;_b=f[Ja>>2]|0;if(!_b){ac=VDc(36)|0;QYa(ac);f[Ja>>2]=ac;yd=ac}else yd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;zd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)zd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,zd);if((f[Ka>>2]|0)<0){Sb=410;break a}if(!(Mi[f[(f[yd>>2]|0)+44>>2]&1023](yd,c)|0)){Sb=410;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 127:{if((Tb&255|0)!=250){Ub=Tb;break b}f[i>>2]=f[i>>2]|536870912;ac=f[La>>2]|0;if(!ac){_b=VDc(20)|0;VYa(_b);f[La>>2]=_b;Ad=_b}else Ad=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Bd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Bd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Bd);if((f[Ma>>2]|0)<0){Sb=421;break a}if(!(Mi[f[(f[Ad>>2]|0)+44>>2]&1023](Ad,c)|0)){Sb=421;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 128:{if((Tb&255|0)!=2){Ub=Tb;break b}f[i>>2]=f[i>>2]|1073741824;_b=f[Na>>2]|0;if(!_b){ac=VDc(20)|0;KYa(ac);f[Na>>2]=ac;Cd=ac}else Cd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Dd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Dd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Dd);if((f[Oa>>2]|0)<0){Sb=432;break a}if(!(Mi[f[(f[Cd>>2]|0)+44>>2]&1023](Cd,c)|0)){Sb=432;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 129:{if((Tb&255|0)!=10){Ub=Tb;break b}f[i>>2]=f[i>>2]|-2147483648;ac=f[Pa>>2]|0;if(!ac){_b=VDc(64)|0;DYa(_b);f[Pa>>2]=_b;Ed=_b}else Ed=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Fd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Fd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Fd);if((f[Qa>>2]|0)<0){Sb=443;break a}if(!(Mi[f[(f[Ed>>2]|0)+44>>2]&1023](Ed,c)|0)){Sb=443;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 130:{if((Tb&255|0)!=18){Ub=Tb;break b}f[C>>2]=f[C>>2]|1;_b=f[Ra>>2]|0;if(!_b){ac=VDc(32)|0;x8a(ac);f[Ra>>2]=ac;Gd=ac}else Gd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Hd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Hd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Hd);if((f[Sa>>2]|0)<0){Sb=454;break a}if(!(Mi[f[(f[Gd>>2]|0)+44>>2]&1023](Gd,c)|0)){Sb=454;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 131:{if((Tb&255|0)!=26){Ub=Tb;break b}f[C>>2]=f[C>>2]|2;ac=f[Ta>>2]|0;if(!ac){_b=VDc(24)|0;TWa(_b);f[Ta>>2]=_b;Id=_b}else Id=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Jd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Jd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Jd);if((f[Ua>>2]|0)<0){Sb=465;break a}if(!(Mi[f[(f[Id>>2]|0)+44>>2]&1023](Id,c)|0)){Sb=465;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 132:{if((Tb&255|0)!=34){Ub=Tb;break b}f[C>>2]=f[C>>2]|4;_b=f[Va>>2]|0;if(!_b){ac=VDc(28)|0;z6a(ac);f[Va>>2]=ac;Kd=ac}else Kd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Ld=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Ld=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Ld);if((f[Wa>>2]|0)<0){Sb=476;break a}if(!(Mi[f[(f[Kd>>2]|0)+44>>2]&1023](Kd,c)|0)){Sb=476;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 133:{if((Tb&255|0)!=42){Ub=Tb;break b}f[C>>2]=f[C>>2]|8;ac=f[Xa>>2]|0;if(!ac){_b=VDc(28)|0;y7a(_b);f[Xa>>2]=_b;Md=_b}else Md=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Nd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Nd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Nd);if((f[Ya>>2]|0)<0){Sb=487;break a}if(!(Mi[f[(f[Md>>2]|0)+44>>2]&1023](Md,c)|0)){Sb=487;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 134:{if((Tb&255|0)!=50){Ub=Tb;break b}f[C>>2]=f[C>>2]|16;_b=f[Za>>2]|0;if(!_b){ac=VDc(28)|0;f9a(ac);f[Za>>2]=ac;Od=ac}else Od=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Pd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Pd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Pd);if((f[_a>>2]|0)<0){Sb=498;break a}if(!(Mi[f[(f[Od>>2]|0)+44>>2]&1023](Od,c)|0)){Sb=498;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 135:{if((Tb&255|0)!=58){Ub=Tb;break b}f[C>>2]=f[C>>2]|32;ac=f[$a>>2]|0;if(!ac){_b=VDc(24)|0;N9a(_b);f[$a>>2]=_b;Qd=_b}else Qd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Rd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Rd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Rd);if((f[ab>>2]|0)<0){Sb=509;break a}if(!(Mi[f[(f[Qd>>2]|0)+44>>2]&1023](Qd,c)|0)){Sb=509;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 136:{if((Tb&255|0)!=66){Ub=Tb;break b}f[C>>2]=f[C>>2]|64;_b=f[bb>>2]|0;if(!_b){ac=VDc(28)|0;P7a(ac);f[bb>>2]=ac;Sd=ac}else Sd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Td=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Td=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Td);if((f[cb>>2]|0)<0){Sb=520;break a}if(!(Mi[f[(f[Sd>>2]|0)+44>>2]&1023](Sd,c)|0)){Sb=520;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}while(0);if((Kb|0)<145)switch(Kb|0){case 137:{if((Tb&255|0)!=74){Ub=Tb;break b}f[C>>2]=f[C>>2]|128;ac=f[db>>2]|0;if(!ac){_b=VDc(36)|0;dab(_b);f[db>>2]=_b;Ud=_b}else Ud=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Vd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Vd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Vd);if((f[eb>>2]|0)<0){Sb=531;break a}if(!(Mi[f[(f[Ud>>2]|0)+44>>2]&1023](Ud,c)|0)){Sb=531;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 138:{if((Tb&255|0)!=82){Ub=Tb;break b}f[C>>2]=f[C>>2]|256;_b=f[fb>>2]|0;if(!_b){ac=VDc(24)|0;Q6a(ac);f[fb>>2]=ac;Wd=ac}else Wd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Xd=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)Xd=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,Xd);if((f[gb>>2]|0)<0){Sb=542;break a}if(!(Mi[f[(f[Wd>>2]|0)+44>>2]&1023](Wd,c)|0)){Sb=542;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 139:{if((Tb&255|0)!=90){Ub=Tb;break b}f[C>>2]=f[C>>2]|512;ac=f[hb>>2]|0;if(!ac){_b=VDc(28)|0;bcb(_b);f[hb>>2]=_b;Yd=_b}else Yd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Zd=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)Zd=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,Zd);if((f[ib>>2]|0)<0){Sb=553;break a}if(!(Mi[f[(f[Yd>>2]|0)+44>>2]&1023](Yd,c)|0)){Sb=553;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 140:{if((Tb&255|0)!=98){Ub=Tb;break b}f[C>>2]=f[C>>2]|1024;_b=f[jb>>2]|0;if(!_b){ac=VDc(20)|0;uab(ac);f[jb>>2]=ac;_d=ac}else _d=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;$d=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)$d=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,$d);if((f[kb>>2]|0)<0){Sb=564;break a}if(!(Mi[f[(f[_d>>2]|0)+44>>2]&1023](_d,c)|0)){Sb=564;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 141:{if((Tb&255|0)!=106){Ub=Tb;break b}f[C>>2]=f[C>>2]|2048;ac=f[lb>>2]|0;if(!ac){_b=VDc(28)|0;Mbb(_b);f[lb>>2]=_b;ae=_b}else ae=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;be=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)be=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,be);if((f[mb>>2]|0)<0){Sb=575;break a}if(!(Mi[f[(f[ae>>2]|0)+44>>2]&1023](ae,c)|0)){Sb=575;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 142:{if((Tb&255|0)!=114){Ub=Tb;break b}f[C>>2]=f[C>>2]|4096;_b=f[nb>>2]|0;if(!_b){ac=VDc(36)|0;g7a(ac);f[nb>>2]=ac;ce=ac}else ce=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;de=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)de=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,de);if((f[ob>>2]|0)<0){Sb=586;break a}if(!(Mi[f[(f[ce>>2]|0)+44>>2]&1023](ce,c)|0)){Sb=586;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 143:{if((Tb&255|0)!=122){Ub=Tb;break b}f[C>>2]=f[C>>2]|8192;ac=f[pb>>2]|0;if(!ac){_b=VDc(32)|0;w9a(_b);f[pb>>2]=_b;ee=_b}else ee=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;fe=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)fe=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,fe);if((f[qb>>2]|0)<0){Sb=597;break a}if(!(Mi[f[(f[ee>>2]|0)+44>>2]&1023](ee,c)|0)){Sb=597;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 144:{if((Tb&255|0)!=130){Ub=Tb;break b}f[C>>2]=f[C>>2]|16384;_b=f[rb>>2]|0;if(!_b){ac=VDc(32)|0;ubb(ac);f[rb>>2]=ac;ge=ac}else ge=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;he=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)he=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,he);if((f[sb>>2]|0)<0){Sb=608;break a}if(!(Mi[f[(f[ge>>2]|0)+44>>2]&1023](ge,c)|0)){Sb=608;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}if((Kb|0)<149)switch(Kb|0){case 145:{if((Tb&255|0)!=138){Ub=Tb;break b}f[C>>2]=f[C>>2]|32768;ac=f[tb>>2]|0;if(!ac){_b=VDc(20)|0;Q8a(_b);f[tb>>2]=_b;ie=_b}else ie=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;je=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)je=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,je);if((f[ub>>2]|0)<0){Sb=619;break a}if(!(Mi[f[(f[ie>>2]|0)+44>>2]&1023](ie,c)|0)){Sb=619;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 146:{if((Tb&255|0)!=146){Ub=Tb;break b}f[C>>2]=f[C>>2]|65536;_b=f[vb>>2]|0;if(!_b){ac=VDc(32)|0;f8a(ac);f[vb>>2]=ac;ke=ac}else ke=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;le=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)le=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,le);if((f[wb>>2]|0)<0){Sb=630;break a}if(!(Mi[f[(f[ke>>2]|0)+44>>2]&1023](ke,c)|0)){Sb=630;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 147:{if((Tb&255|0)!=154){Ub=Tb;break b}f[C>>2]=f[C>>2]|131072;ac=f[xb>>2]|0;if(!ac){_b=VDc(52)|0;ucb(_b);f[xb>>2]=_b;me=_b}else me=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;ne=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)ne=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,ne);if((f[yb>>2]|0)<0){Sb=641;break a}if(!(Mi[f[(f[me>>2]|0)+44>>2]&1023](me,c)|0)){Sb=641;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 148:{if((Tb&255|0)!=162){Ub=Tb;break b}f[C>>2]=f[C>>2]|262144;_b=f[zb>>2]|0;if(!_b){ac=VDc(28)|0;wcb(ac);f[zb>>2]=ac;oe=ac}else oe=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;pe=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)pe=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,pe);if((f[Ab>>2]|0)<0){Sb=652;break a}if(!(Mi[f[(f[oe>>2]|0)+44>>2]&1023](oe,c)|0)){Sb=652;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}if((Kb|0)<201)switch(Kb|0){case 149:{if((Tb&255|0)!=170){Ub=Tb;break b}f[C>>2]=f[C>>2]|524288;ac=f[Bb>>2]|0;if(!ac){_b=VDc(28)|0;xcb(_b);f[Bb>>2]=_b;qe=_b}else qe=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;re=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)re=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,re);if((f[Cb>>2]|0)<0){Sb=663;break a}if(!(Mi[f[(f[qe>>2]|0)+44>>2]&1023](qe,c)|0)){Sb=663;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 150:{if((Tb&255|0)!=178){Ub=Tb;break b}f[C>>2]=f[C>>2]|1048576;_b=f[Db>>2]|0;if(!_b){ac=VDc(128)|0;zcb(ac);f[Db>>2]=ac;se=ac}else se=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;te=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)te=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,te);if((f[Eb>>2]|0)<0){Sb=674;break a}if(!(Mi[f[(f[se>>2]|0)+44>>2]&1023](se,c)|0)){Sb=674;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}if((Kb|0)<10002){switch(Kb|0){case 201:break;default:{Ub=Tb;break b}}if((Tb&255|0)!=74){Ub=Tb;break}f[C>>2]=f[C>>2]|2097152;ac=f[Fb>>2]|0;if(!ac){_b=VDc(64)|0;CVa(_b);f[Fb>>2]=_b;ue=_b}else ue=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;ve=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)ve=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,ve);if((f[Gb>>2]|0)<0){Sb=685;break a}if(!(Mi[f[(f[ue>>2]|0)+44>>2]&1023](ue,c)|0)){Sb=685;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}}if((Kb|0)<8266711){switch(Kb|0){case 10002:break;default:{Ub=Tb;break b}}if((Tb&255|0)!=146){Ub=Tb;break}f[C>>2]=f[C>>2]|4194304;_b=f[Hb>>2]|0;if(!_b){ac=VDc(28)|0;jVa(ac);f[Hb>>2]=ac;we=ac}else we=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;xe=ac&255}else{ac=VRb(c)|0;if((ac|0)>-1)xe=ac;else{Wb=0;Sb=714;break a}}GRb(e,c,xe);if((f[Ib>>2]|0)<0){Sb=696;break a}if(!(Mi[f[(f[we>>2]|0)+44>>2]&1023](we,c)|0)){Sb=696;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}}else{switch(Kb|0){case 8266711:break;default:{Ub=Tb;break b}}if((Tb&255|0)!=186){Ub=Tb;break}f[C>>2]=f[C>>2]|8388608;ac=f[Jb>>2]|0;if(!ac){_b=VDc(28)|0;TVa(_b);f[Jb>>2]=_b;ye=_b}else ye=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;ze=_b&255}else{_b=VRb(c)|0;if((_b|0)>-1)ze=_b;else{Wb=0;Sb=714;break a}}GRb(e,c,ze);if((f[a>>2]|0)<0){Sb=707;break a}if(!(Mi[f[(f[ye>>2]|0)+44>>2]&1023](ye,c)|0)){Sb=707;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}}}while(0);if(!Ub){Wb=1;Sb=714;break}_b=f[E>>2]|0;if(!(_b&1))Ae=mNa(E)|0;else Ae=_b&-2;if(!(Djc(c,Ub,Ae)|0)){Wb=0;Sb=714;break}}switch(Sb|0){case 37:{Wb=0;u=d;return Wb|0}case 58:{Wb=0;u=d;return Wb|0}case 67:{Wb=0;u=d;return Wb|0}case 76:{Wb=0;u=d;return Wb|0}case 85:{Wb=0;u=d;return Wb|0}case 124:{Wb=0;u=d;return Wb|0}case 135:{Wb=0;u=d;return Wb|0}case 146:{Wb=0;u=d;return Wb|0}case 157:{Wb=0;u=d;return Wb|0}case 168:{Wb=0;u=d;return Wb|0}case 179:{Wb=0;u=d;return Wb|0}case 190:{Wb=0;u=d;return Wb|0}case 201:{Wb=0;u=d;return Wb|0}case 212:{Wb=0;u=d;return Wb|0}case 223:{Wb=0;u=d;return Wb|0}case 234:{Wb=0;u=d;return Wb|0}case 245:{Wb=0;u=d;return Wb|0}case 256:{Wb=0;u=d;return Wb|0}case 267:{Wb=0;u=d;return Wb|0}case 278:{Wb=0;u=d;return Wb|0}case 289:{Wb=0;u=d;return Wb|0}case 300:{Wb=0;u=d;return Wb|0}case 311:{Wb=0;u=d;return Wb|0}case 322:{Wb=0;u=d;return Wb|0}case 333:{Wb=0;u=d;return Wb|0}case 344:{Wb=0;u=d;return Wb|0}case 355:{Wb=0;u=d;return Wb|0}case 366:{Wb=0;u=d;return Wb|0}case 377:{Wb=0;u=d;return Wb|0}case 388:{Wb=0;u=d;return Wb|0}case 399:{Wb=0;u=d;return Wb|0}case 410:{Wb=0;u=d;return Wb|0}case 421:{Wb=0;u=d;return Wb|0}case 432:{Wb=0;u=d;return Wb|0}case 443:{Wb=0;u=d;return Wb|0}case 454:{Wb=0;u=d;return Wb|0}case 465:{Wb=0;u=d;return Wb|0}case 476:{Wb=0;u=d;return Wb|0}case 487:{Wb=0;u=d;return Wb|0}case 498:{Wb=0;u=d;return Wb|0}case 509:{Wb=0;u=d;return Wb|0}case 520:{Wb=0;u=d;return Wb|0}case 531:{Wb=0;u=d;return Wb|0}case 542:{Wb=0;u=d;return Wb|0}case 553:{Wb=0;u=d;return Wb|0}case 564:{Wb=0;u=d;return Wb|0}case 575:{Wb=0;u=d;return Wb|0}case 586:{Wb=0;u=d;return Wb|0}case 597:{Wb=0;u=d;return Wb|0}case 608:{Wb=0;u=d;return Wb|0}case 619:{Wb=0;u=d;return Wb|0}case 630:{Wb=0;u=d;return Wb|0}case 641:{Wb=0;u=d;return Wb|0}case 652:{Wb=0;u=d;return Wb|0}case 663:{Wb=0;u=d;return Wb|0}case 674:{Wb=0;u=d;return Wb|0}case 685:{Wb=0;u=d;return Wb|0}case 696:{Wb=0;u=d;return Wb|0}case 707:{Wb=0;u=d;return Wb|0}case 714:{u=d;return Wb|0}}return 0}function kcb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if((e|0)>0){l=f[a+44>>2]|0;c=0;g=h;while(1){d=f[l+4+(c<<2)>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+g+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=j;break}else g=j}}else m=h;h=f[a+48>>2]|0;g=f[a+64>>2]|0;e=h+m+(h<<2)+g|0;if(!g)n=e;else{h=a+72|0;m=0;c=e;while(1){e=f[(f[h>>2]|0)+4+(m<<2)>>2]|0;l=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=l+c+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=m+1|0;if((m|0)==(g|0)){n=e;break}else c=e}}c=f[a+80>>2]|0;g=c+n|0;if(!c)o=g;else{n=a+88|0;m=0;h=g;while(1){g=f[(f[n>>2]|0)+4+(m<<2)>>2]|0;e=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;g=e+h+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=m+1|0;if((m|0)==(c|0)){o=g;break}else h=g}}h=f[a+96>>2]|0;c=h+o|0;if(!h)p=c;else{o=a+104|0;m=0;n=c;while(1){c=f[(f[o>>2]|0)+4+(m<<2)>>2]|0;g=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=g+n+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=m+1|0;if((m|0)==(h|0)){p=c;break}else n=c}}n=f[a+112>>2]|0;h=n+p|0;if(!n)q=h;else{p=a+120|0;m=0;o=h;while(1){h=f[(f[p>>2]|0)+4+(m<<2)>>2]|0;c=_i[f[(f[h>>2]|0)+48>>2]&1023](h)|0;h=c+o+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=m+1|0;if((m|0)==(n|0)){q=h;break}else o=h}}o=(f[a+124>>2]<<1)+q|0;q=a+8|0;n=f[q>>2]|0;if(n&255){if(!(n&1))r=o;else{m=f[a+136>>2]|0;p=b[m+11>>0]|0;h=p<<24>>24<0?f[m+4>>2]|0:p&255;r=o+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(n&2))s=r;else{h=f[a+140>>2]|0;p=b[h+11>>0]|0;m=p<<24>>24<0?f[h+4>>2]|0:p&255;s=r+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(n&4)){t=s;u=n}else{m=f[a+144>>2]|0;r=_i[f[(f[m>>2]|0)+48>>2]&1023](m)|0;m=s+2+r+((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)|0;t=m;u=f[q>>2]|0}if(!(u&8)){v=t;w=u}else{u=f[a+148>>2]|0;m=_i[f[(f[u>>2]|0)+48>>2]&1023](u)|0;u=t+2+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;v=u;w=f[q>>2]|0}if(!(w&16)){x=v;y=w}else{w=f[a+152>>2]|0;u=_i[f[(f[w>>2]|0)+48>>2]&1023](w)|0;w=v+2+u+((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)|0;x=w;y=f[q>>2]|0}if(!(y&32)){z=x;A=y}else{y=f[a+156>>2]|0;w=_i[f[(f[y>>2]|0)+48>>2]&1023](y)|0;y=x+2+w+((((($(w|1|0)|0)^31)*9|0)+73|0)>>>6)|0;z=y;A=f[q>>2]|0}if(!(A&64)){B=z;C=A}else{A=f[a+160>>2]|0;y=_i[f[(f[A>>2]|0)+48>>2]&1023](A)|0;A=z+2+y+((((($(y|1|0)|0)^31)*9|0)+73|0)>>>6)|0;B=A;C=f[q>>2]|0}if(!(C&128)){D=B;E=C}else{C=f[a+164>>2]|0;A=_i[f[(f[C>>2]|0)+48>>2]&1023](C)|0;C=B+2+A+((((($(A|1|0)|0)^31)*9|0)+73|0)>>>6)|0;D=C;E=f[q>>2]|0}}else{D=o;E=n}if(E&65280){if(!(E&256)){F=D;G=E}else{n=f[a+168>>2]|0;o=_i[f[(f[n>>2]|0)+48>>2]&1023](n)|0;n=D+2+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0;F=n;G=f[q>>2]|0}if(!(G&512)){H=F;I=G}else{G=f[a+172>>2]|0;n=_i[f[(f[G>>2]|0)+48>>2]&1023](G)|0;G=F+2+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;H=G;I=f[q>>2]|0}if(!(I&1024)){J=H;K=I}else{I=f[a+176>>2]|0;G=_i[f[(f[I>>2]|0)+48>>2]&1023](I)|0;I=H+2+G+((((($(G|1|0)|0)^31)*9|0)+73|0)>>>6)|0;J=I;K=f[q>>2]|0}if(!(K&2048)){L=J;M=K}else{K=f[a+180>>2]|0;I=_i[f[(f[K>>2]|0)+48>>2]&1023](K)|0;K=J+2+I+((((($(I|1|0)|0)^31)*9|0)+73|0)>>>6)|0;L=K;M=f[q>>2]|0}if(!(M&4096)){N=L;O=M}else{M=f[a+184>>2]|0;K=_i[f[(f[M>>2]|0)+48>>2]&1023](M)|0;M=L+2+K+((((($(K|1|0)|0)^31)*9|0)+73|0)>>>6)|0;N=M;O=f[q>>2]|0}if(!(O&8192)){P=N;Q=O}else{O=f[a+188>>2]|0;M=_i[f[(f[O>>2]|0)+48>>2]&1023](O)|0;O=N+2+M+((((($(M|1|0)|0)^31)*9|0)+73|0)>>>6)|0;P=O;Q=f[q>>2]|0}if(!(Q&16384)){R=P;S=Q}else{Q=f[a+192>>2]|0;O=_i[f[(f[Q>>2]|0)+48>>2]&1023](Q)|0;Q=P+2+O+((((($(O|1|0)|0)^31)*9|0)+73|0)>>>6)|0;R=Q;S=f[q>>2]|0}if(!(S&32768)){T=R;U=S}else{S=f[a+196>>2]|0;Q=_i[f[(f[S>>2]|0)+48>>2]&1023](S)|0;S=R+2+Q+((((($(Q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;T=S;U=f[q>>2]|0}}else{T=D;U=E}if(U&16711680){if(!(U&65536)){V=T;W=U}else{E=f[a+200>>2]|0;D=_i[f[(f[E>>2]|0)+48>>2]&1023](E)|0;E=T+2+D+((((($(D|1|0)|0)^31)*9|0)+73|0)>>>6)|0;V=E;W=f[q>>2]|0}if(!(W&131072)){X=V;Y=W}else{W=f[a+204>>2]|0;E=_i[f[(f[W>>2]|0)+48>>2]&1023](W)|0;W=V+2+E+((((($(E|1|0)|0)^31)*9|0)+73|0)>>>6)|0;X=W;Y=f[q>>2]|0}if(!(Y&262144)){Z=X;_=Y}else{Y=f[a+208>>2]|0;W=_i[f[(f[Y>>2]|0)+48>>2]&1023](Y)|0;Y=X+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Z=Y;_=f[q>>2]|0}if(!(_&524288)){aa=Z;ba=_}else{_=f[a+212>>2]|0;Y=_i[f[(f[_>>2]|0)+48>>2]&1023](_)|0;_=Z+2+Y+((((($(Y|1|0)|0)^31)*9|0)+73|0)>>>6)|0;aa=_;ba=f[q>>2]|0}if(!(ba&1048576)){ca=aa;da=ba}else{ba=f[a+216>>2]|0;_=_i[f[(f[ba>>2]|0)+48>>2]&1023](ba)|0;ba=aa+2+_+((((($(_|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ca=ba;da=f[q>>2]|0}if(!(da&2097152)){ea=ca;fa=da}else{da=f[a+220>>2]|0;ba=_i[f[(f[da>>2]|0)+48>>2]&1023](da)|0;da=ca+2+ba+((((($(ba|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ea=da;fa=f[q>>2]|0}if(!(fa&4194304)){ga=ea;ha=fa}else{fa=f[a+224>>2]|0;da=_i[f[(f[fa>>2]|0)+48>>2]&1023](fa)|0;fa=ea+2+da+((((($(da|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ga=fa;ha=f[q>>2]|0}if(!(ha&8388608)){ia=ga;ja=ha}else{ha=f[a+228>>2]|0;fa=_i[f[(f[ha>>2]|0)+48>>2]&1023](ha)|0;ha=ga+2+fa+((((($(fa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ia=ha;ja=f[q>>2]|0}}else{ia=T;ja=U}if(ja>>>0>16777215){if(!(ja&16777216)){ka=ia;la=ja}else{ja=f[a+232>>2]|0;U=_i[f[(f[ja>>2]|0)+48>>2]&1023](ja)|0;ja=ia+2+U+((((($(U|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ka=ja;la=f[q>>2]|0}if(!(la&33554432)){ma=ka;na=la}else{la=f[a+236>>2]|0;ja=_i[f[(f[la>>2]|0)+48>>2]&1023](la)|0;la=ka+2+ja+((((($(ja|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ma=la;na=f[q>>2]|0}if(!(na&67108864)){oa=ma;pa=na}else{na=f[a+240>>2]|0;la=_i[f[(f[na>>2]|0)+48>>2]&1023](na)|0;na=ma+2+la+((((($(la|1|0)|0)^31)*9|0)+73|0)>>>6)|0;oa=na;pa=f[q>>2]|0}if(!(pa&134217728)){qa=oa;ra=pa}else{pa=f[a+244>>2]|0;na=_i[f[(f[pa>>2]|0)+48>>2]&1023](pa)|0;pa=oa+2+na+((((($(na|1|0)|0)^31)*9|0)+73|0)>>>6)|0;qa=pa;ra=f[q>>2]|0}if(!(ra&268435456)){sa=qa;ta=ra}else{ra=f[a+248>>2]|0;pa=_i[f[(f[ra>>2]|0)+48>>2]&1023](ra)|0;ra=qa+2+pa+((((($(pa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;sa=ra;ta=f[q>>2]|0}if(!(ta&536870912)){ua=sa;va=ta}else{ta=f[a+252>>2]|0;ra=_i[f[(f[ta>>2]|0)+48>>2]&1023](ta)|0;ta=sa+2+ra+((((($(ra|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ua=ta;va=f[q>>2]|0}if(!(va&1073741824)){wa=ua;xa=va}else{va=f[a+256>>2]|0;ta=_i[f[(f[va>>2]|0)+48>>2]&1023](va)|0;va=ua+2+ta+((((($(ta|1|0)|0)^31)*9|0)+73|0)>>>6)|0;wa=va;xa=f[q>>2]|0}if((xa|0)<0){xa=f[a+260>>2]|0;q=_i[f[(f[xa>>2]|0)+48>>2]&1023](xa)|0;ya=wa+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else ya=wa}else ya=ia;ia=a+12|0;wa=f[ia>>2]|0;do if(!(wa&255)){za=ya;Aa=wa}else{if(!(wa&1)){Ba=ya;Ca=wa}else{q=f[a+264>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=ya+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ba=q;Ca=f[ia>>2]|0}if(!(Ca&2)){Da=Ba;Ea=Ca}else{q=f[a+268>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=Ba+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Da=q;Ea=f[ia>>2]|0}if(!(Ea&4)){Fa=Da;Ga=Ea}else{q=f[a+272>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=Da+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Fa=q;Ga=f[ia>>2]|0}if(!(Ga&8)){Ha=Fa;Ia=Ga}else{q=f[a+276>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=Fa+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ha=q;Ia=f[ia>>2]|0}if(!(Ia&16)){Ja=Ha;Ka=Ia}else{q=f[a+280>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=Ha+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ja=q;Ka=f[ia>>2]|0}if(!(Ka&32)){La=Ja;Ma=Ka}else{q=f[a+284>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=Ja+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;La=q;Ma=f[ia>>2]|0}if(!(Ma&64)){Na=La;Oa=Ma}else{q=f[a+288>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=La+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Na=q;Oa=f[ia>>2]|0}if(!(Oa&128)){za=Na;Aa=Oa;break}q=f[a+292>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=Na+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;za=q;Aa=f[ia>>2]|0}while(0);do if(!(Aa&65280)){Pa=za;Qa=Aa}else{if(!(Aa&256)){Ra=za;Sa=Aa}else{Na=f[a+296>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&1023](Na)|0;Na=za+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ra=Na;Sa=f[ia>>2]|0}if(!(Sa&512)){Ta=Ra;Ua=Sa}else{Na=f[a+300>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&1023](Na)|0;Na=Ra+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ta=Na;Ua=f[ia>>2]|0}if(!(Ua&1024)){Va=Ta;Wa=Ua}else{Na=f[a+304>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&1023](Na)|0;Na=Ta+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Va=Na;Wa=f[ia>>2]|0}if(!(Wa&2048)){Xa=Va;Ya=Wa}else{Na=f[a+308>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&1023](Na)|0;Na=Va+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Xa=Na;Ya=f[ia>>2]|0}if(!(Ya&4096)){Za=Xa;_a=Ya}else{Na=f[a+312>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&1023](Na)|0;Na=Xa+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Za=Na;_a=f[ia>>2]|0}if(!(_a&8192)){$a=Za;ab=_a}else{Na=f[a+316>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&1023](Na)|0;Na=Za+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;$a=Na;ab=f[ia>>2]|0}if(!(ab&16384)){bb=$a;cb=ab}else{Na=f[a+320>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&1023](Na)|0;Na=$a+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;bb=Na;cb=f[ia>>2]|0}if(!(cb&32768)){Pa=bb;Qa=cb;break}Na=f[a+324>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&1023](Na)|0;Na=bb+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Pa=Na;Qa=f[ia>>2]|0}while(0);do if(!(Qa&16711680)){db=Pa;eb=Qa}else{if(!(Qa&65536)){fb=Pa;gb=Qa}else{bb=f[a+328>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&1023](bb)|0;bb=Pa+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;fb=bb;gb=f[ia>>2]|0}if(!(gb&131072)){hb=fb;ib=gb}else{bb=f[a+332>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&1023](bb)|0;bb=fb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;hb=bb;ib=f[ia>>2]|0}if(!(ib&262144)){jb=hb;kb=ib}else{bb=f[a+336>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&1023](bb)|0;bb=hb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;jb=bb;kb=f[ia>>2]|0}if(!(kb&524288)){lb=jb;mb=kb}else{bb=f[a+340>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&1023](bb)|0;bb=jb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;lb=bb;mb=f[ia>>2]|0}if(!(mb&1048576)){nb=lb;ob=mb}else{bb=f[a+344>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&1023](bb)|0;bb=lb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;nb=bb;ob=f[ia>>2]|0}if(!(ob&2097152)){pb=nb;qb=ob}else{bb=f[a+348>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&1023](bb)|0;bb=nb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;pb=bb;qb=f[ia>>2]|0}if(!(qb&4194304)){rb=pb;sb=qb}else{bb=f[a+352>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&1023](bb)|0;bb=pb+3+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;rb=bb;sb=f[ia>>2]|0}if(!(sb&8388608)){db=rb;eb=sb;break}bb=f[a+356>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&1023](bb)|0;bb=rb+4+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;db=bb;eb=f[ia>>2]|0}while(0);if(!(eb&16777216)){tb=db;ub=a+364|0;f[ub>>2]=tb;return tb|0}eb=f[a+360>>2]|0;if((eb|0)<0)vb=11;else vb=((((($(eb|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;tb=vb+db|0;ub=a+364|0;f[ub>>2]=tb;return tb|0}function lcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+8|0;e=f[d>>2]|0;if(e&1|0)$Tb(1,f[a+136>>2]|0,c);if(e&2|0)$Tb(2,f[a+140>>2]|0,c);e=f[a+20>>2]|0;if((e|0)>0){g=a+28|0;h=0;do{_Tb(3,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+36>>2]|0;if((e|0)>0){h=a+44|0;g=0;do{_Tb(4,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}e=f[a+48>>2]|0;if((e|0)>0){g=a+56|0;h=0;do{WTb(5,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+64>>2]|0;if(e|0){h=a+72|0;g=0;do{eUb(6,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}e=f[a+80>>2]|0;if(e|0){g=a+88|0;h=0;do{eUb(7,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+96>>2]|0;if(e|0){h=a+104|0;g=0;do{eUb(8,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}e=f[a+112>>2]|0;if(e|0){g=a+120|0;h=0;do{eUb(9,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=a+12|0;if(f[e>>2]&16777216|0)ZTb(10,f[a+360>>2]|0,c);h=f[a+124>>2]|0;if((h|0)>0){g=a+132|0;i=0;do{YTb(11,(b[(f[g>>2]|0)+4+i>>0]|0)!=0,c);i=i+1|0}while((i|0)!=(h|0))}h=f[d>>2]|0;if(h&4|0)eUb(100,f[a+144>>2]|0,c);if(h&8|0)eUb(101,f[a+148>>2]|0,c);if(h&16|0)eUb(102,f[a+152>>2]|0,c);if(h&32|0)eUb(103,f[a+156>>2]|0,c);if(h&64|0)eUb(104,f[a+160>>2]|0,c);if(h&128|0)eUb(105,f[a+164>>2]|0,c);if(h&256|0)eUb(106,f[a+168>>2]|0,c);if(h&512|0)eUb(107,f[a+172>>2]|0,c);if(h&1024|0)eUb(108,f[a+176>>2]|0,c);if(h&2048|0)eUb(109,f[a+180>>2]|0,c);if(h&4096|0)eUb(110,f[a+184>>2]|0,c);if(h&8192|0)eUb(111,f[a+188>>2]|0,c);if(h&16384|0)eUb(112,f[a+192>>2]|0,c);if(h&32768|0)eUb(113,f[a+196>>2]|0,c);if(h&65536|0)eUb(114,f[a+200>>2]|0,c);if(h&131072|0)eUb(115,f[a+204>>2]|0,c);if(h&262144|0)eUb(116,f[a+208>>2]|0,c);if(h&524288|0)eUb(117,f[a+212>>2]|0,c);if(h&1048576|0)eUb(118,f[a+216>>2]|0,c);if(h&2097152|0)eUb(119,f[a+220>>2]|0,c);if(h&4194304|0)eUb(120,f[a+224>>2]|0,c);if(h&8388608|0)eUb(121,f[a+228>>2]|0,c);if(h&16777216|0)eUb(122,f[a+232>>2]|0,c);if(h&33554432|0)eUb(123,f[a+236>>2]|0,c);if(h&67108864|0)eUb(124,f[a+240>>2]|0,c);if(h&134217728|0)eUb(125,f[a+244>>2]|0,c);if(h&268435456|0)eUb(126,f[a+248>>2]|0,c);if(h&536870912|0)eUb(127,f[a+252>>2]|0,c);if(h&1073741824|0)eUb(128,f[a+256>>2]|0,c);if((h|0)<0)eUb(129,f[a+260>>2]|0,c);h=f[e>>2]|0;if(h&1|0)eUb(130,f[a+264>>2]|0,c);if(h&2|0)eUb(131,f[a+268>>2]|0,c);if(h&4|0)eUb(132,f[a+272>>2]|0,c);if(h&8|0)eUb(133,f[a+276>>2]|0,c);if(h&16|0)eUb(134,f[a+280>>2]|0,c);if(h&32|0)eUb(135,f[a+284>>2]|0,c);if(h&64|0)eUb(136,f[a+288>>2]|0,c);if(h&128|0)eUb(137,f[a+292>>2]|0,c);if(h&256|0)eUb(138,f[a+296>>2]|0,c);if(h&512|0)eUb(139,f[a+300>>2]|0,c);if(h&1024|0)eUb(140,f[a+304>>2]|0,c);if(h&2048|0)eUb(141,f[a+308>>2]|0,c);if(h&4096|0)eUb(142,f[a+312>>2]|0,c);if(h&8192|0)eUb(143,f[a+316>>2]|0,c);if(h&16384|0)eUb(144,f[a+320>>2]|0,c);if(h&32768|0)eUb(145,f[a+324>>2]|0,c);if(h&65536|0)eUb(146,f[a+328>>2]|0,c);if(h&131072|0)eUb(147,f[a+332>>2]|0,c);if(h&262144|0)eUb(148,f[a+336>>2]|0,c);if(h&524288|0)eUb(149,f[a+340>>2]|0,c);if(h&1048576|0)eUb(150,f[a+344>>2]|0,c);if(h&2097152|0)eUb(201,f[a+348>>2]|0,c);if(h&4194304|0)eUb(10002,f[a+352>>2]|0,c);if(h&8388608|0)eUb(8266711,f[a+356>>2]|0,c);h=f[a+4>>2]|0;if(!(h&1))return;Gjc(h&-2,c);return}function mcb(a){a=a|0;return f[a+364>>2]|0}function ncb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0;e=a+8|0;g=f[e>>2]|0;if(!(g&1))h=d;else{i=f[a+136>>2]|0;b[d>>0]=10;h=dSb(i,d+1|0)|0}if(!(g&2))j=h;else{g=f[a+140>>2]|0;b[h>>0]=18;j=dSb(g,h+1|0)|0}h=f[a+20>>2]|0;if((h|0)>0){g=a+28|0;d=0;i=j;while(1){k=f[(f[g>>2]|0)+4+(d<<2)>>2]|0;b[i>>0]=26;l=dSb(k,i+1|0)|0;d=d+1|0;if((d|0)==(h|0)){m=l;break}else i=l}}else m=j;j=f[a+36>>2]|0;if((j|0)>0){i=a+44|0;h=0;d=m;while(1){g=f[(f[i>>2]|0)+4+(h<<2)>>2]|0;b[d>>0]=34;l=dSb(g,d+1|0)|0;h=h+1|0;if((h|0)==(j|0)){n=l;break}else d=l}}else n=m;m=f[a+48>>2]|0;if(!m)o=n;else{d=f[a+56>>2]|0;j=0;h=n;while(1){n=f[d+4+(j<<2)>>2]|0;b[h>>0]=45;i=h+1|0;b[i>>0]=n;b[i+1>>0]=n>>8;b[i+2>>0]=n>>16;b[i+3>>0]=n>>24;n=h+5|0;j=j+1|0;if((j|0)>=(m|0)){o=n;break}else h=n}}h=f[a+64>>2]|0;if(!h)p=o;else{m=a+72|0;j=0;d=o;while(1){o=f[(f[m>>2]|0)+4+(j<<2)>>2]|0;b[d>>0]=50;n=d+1|0;i=_i[f[(f[o>>2]|0)+60>>2]&1023](o)|0;if(i>>>0>127){l=i;g=n;while(1){b[g>>0]=l|128;k=l>>>7;q=g+1|0;if(l>>>0>16383){l=k;g=q}else{r=q;s=k;break}}}else{r=n;s=i}b[r>>0]=s;g=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,r+1|0)|0;j=j+1|0;if((j|0)==(h|0)){p=g;break}else d=g}}d=f[a+80>>2]|0;if(!d)t=p;else{h=a+88|0;j=0;r=p;while(1){p=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[r>>0]=58;s=r+1|0;m=_i[f[(f[p>>2]|0)+60>>2]&1023](p)|0;if(m>>>0>127){g=m;l=s;while(1){b[l>>0]=g|128;k=g>>>7;q=l+1|0;if(g>>>0>16383){g=k;l=q}else{u=q;v=k;break}}}else{u=s;v=m}b[u>>0]=v;l=hj[f[(f[p>>2]|0)+64>>2]&511](p,c,u+1|0)|0;j=j+1|0;if((j|0)==(d|0)){t=l;break}else r=l}}r=f[a+96>>2]|0;if(!r)w=t;else{d=a+104|0;j=0;u=t;while(1){t=f[(f[d>>2]|0)+4+(j<<2)>>2]|0;b[u>>0]=66;v=u+1|0;h=_i[f[(f[t>>2]|0)+60>>2]&1023](t)|0;if(h>>>0>127){l=h;g=v;while(1){b[g>>0]=l|128;o=l>>>7;i=g+1|0;if(l>>>0>16383){l=o;g=i}else{x=i;y=o;break}}}else{x=v;y=h}b[x>>0]=y;g=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;j=j+1|0;if((j|0)==(r|0)){w=g;break}else u=g}}u=f[a+112>>2]|0;if(!u)z=w;else{r=a+120|0;j=0;x=w;while(1){w=f[(f[r>>2]|0)+4+(j<<2)>>2]|0;b[x>>0]=74;y=x+1|0;d=_i[f[(f[w>>2]|0)+60>>2]&1023](w)|0;if(d>>>0>127){g=d;l=y;while(1){b[l>>0]=g|128;p=g>>>7;m=l+1|0;if(g>>>0>16383){g=p;l=m}else{A=m;B=p;break}}}else{A=y;B=d}b[A>>0]=B;l=hj[f[(f[w>>2]|0)+64>>2]&511](w,c,A+1|0)|0;j=j+1|0;if((j|0)==(u|0)){z=l;break}else x=l}}x=a+12|0;if(!(f[x>>2]&16777216))C=z;else{u=f[a+360>>2]|0;b[z>>0]=80;j=z+1|0;z=u&255;if(u>>>0>127){A=j;B=z;r=u;l=((u|0)<0)<<31>>31;while(1){b[A>>0]=B|-128;u=r;r=aJc(r|0,l|0,7)|0;g=A+1|0;t=r&255;if(!(l>>>0>0|(l|0)==0&u>>>0>16383)){D=g;E=t;break}else{A=g;B=t;l=J}}}else{D=j;E=z}b[D>>0]=E;C=D+1|0}D=f[a+124>>2]|0;if(!D)F=C;else{E=f[a+132>>2]|0;z=0;j=C;while(1){C=b[E+4+z>>0]|0;b[j>>0]=88;b[j+1>>0]=C;C=j+2|0;z=z+1|0;if((z|0)>=(D|0)){F=C;break}else j=C}}j=f[e>>2]|0;if(!(j&4))G=F;else{e=f[a+144>>2]|0;b[F>>0]=-94;b[F+1>>0]=6;D=F+2|0;F=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(F>>>0>127){z=F;E=D;while(1){b[E>>0]=z|128;C=z>>>7;l=E+1|0;if(z>>>0>16383){z=C;E=l}else{H=l;I=C;break}}}else{H=D;I=F}b[H>>0]=I;G=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,H+1|0)|0}if(!(j&8))K=G;else{H=f[a+148>>2]|0;b[G>>0]=-86;b[G+1>>0]=6;e=G+2|0;G=_i[f[(f[H>>2]|0)+60>>2]&1023](H)|0;if(G>>>0>127){I=G;F=e;while(1){b[F>>0]=I|128;D=I>>>7;E=F+1|0;if(I>>>0>16383){I=D;F=E}else{L=E;M=D;break}}}else{L=e;M=G}b[L>>0]=M;K=hj[f[(f[H>>2]|0)+64>>2]&511](H,c,L+1|0)|0}if(!(j&16))N=K;else{L=f[a+152>>2]|0;b[K>>0]=-78;b[K+1>>0]=6;H=K+2|0;K=_i[f[(f[L>>2]|0)+60>>2]&1023](L)|0;if(K>>>0>127){M=K;G=H;while(1){b[G>>0]=M|128;e=M>>>7;F=G+1|0;if(M>>>0>16383){M=e;G=F}else{O=F;P=e;break}}}else{O=H;P=K}b[O>>0]=P;N=hj[f[(f[L>>2]|0)+64>>2]&511](L,c,O+1|0)|0}if(!(j&32))Q=N;else{O=f[a+156>>2]|0;b[N>>0]=-70;b[N+1>>0]=6;L=N+2|0;N=_i[f[(f[O>>2]|0)+60>>2]&1023](O)|0;if(N>>>0>127){P=N;K=L;while(1){b[K>>0]=P|128;H=P>>>7;G=K+1|0;if(P>>>0>16383){P=H;K=G}else{R=G;S=H;break}}}else{R=L;S=N}b[R>>0]=S;Q=hj[f[(f[O>>2]|0)+64>>2]&511](O,c,R+1|0)|0}if(!(j&64))T=Q;else{R=f[a+160>>2]|0;b[Q>>0]=-62;b[Q+1>>0]=6;O=Q+2|0;Q=_i[f[(f[R>>2]|0)+60>>2]&1023](R)|0;if(Q>>>0>127){S=Q;N=O;while(1){b[N>>0]=S|128;L=S>>>7;K=N+1|0;if(S>>>0>16383){S=L;N=K}else{U=K;V=L;break}}}else{U=O;V=Q}b[U>>0]=V;T=hj[f[(f[R>>2]|0)+64>>2]&511](R,c,U+1|0)|0}if(!(j&128))W=T;else{U=f[a+164>>2]|0;b[T>>0]=-54;b[T+1>>0]=6;R=T+2|0;T=_i[f[(f[U>>2]|0)+60>>2]&1023](U)|0;if(T>>>0>127){V=T;Q=R;while(1){b[Q>>0]=V|128;O=V>>>7;N=Q+1|0;if(V>>>0>16383){V=O;Q=N}else{X=N;Y=O;break}}}else{X=R;Y=T}b[X>>0]=Y;W=hj[f[(f[U>>2]|0)+64>>2]&511](U,c,X+1|0)|0}if(!(j&256))Z=W;else{X=f[a+168>>2]|0;b[W>>0]=-46;b[W+1>>0]=6;U=W+2|0;W=_i[f[(f[X>>2]|0)+60>>2]&1023](X)|0;if(W>>>0>127){Y=W;T=U;while(1){b[T>>0]=Y|128;R=Y>>>7;Q=T+1|0;if(Y>>>0>16383){Y=R;T=Q}else{_=Q;$=R;break}}}else{_=U;$=W}b[_>>0]=$;Z=hj[f[(f[X>>2]|0)+64>>2]&511](X,c,_+1|0)|0}if(!(j&512))aa=Z;else{_=f[a+172>>2]|0;b[Z>>0]=-38;b[Z+1>>0]=6;X=Z+2|0;Z=_i[f[(f[_>>2]|0)+60>>2]&1023](_)|0;if(Z>>>0>127){$=Z;W=X;while(1){b[W>>0]=$|128;U=$>>>7;T=W+1|0;if($>>>0>16383){$=U;W=T}else{ba=T;ca=U;break}}}else{ba=X;ca=Z}b[ba>>0]=ca;aa=hj[f[(f[_>>2]|0)+64>>2]&511](_,c,ba+1|0)|0}if(!(j&1024))da=aa;else{ba=f[a+176>>2]|0;b[aa>>0]=-30;b[aa+1>>0]=6;_=aa+2|0;aa=_i[f[(f[ba>>2]|0)+60>>2]&1023](ba)|0;if(aa>>>0>127){ca=aa;Z=_;while(1){b[Z>>0]=ca|128;X=ca>>>7;W=Z+1|0;if(ca>>>0>16383){ca=X;Z=W}else{ea=W;fa=X;break}}}else{ea=_;fa=aa}b[ea>>0]=fa;da=hj[f[(f[ba>>2]|0)+64>>2]&511](ba,c,ea+1|0)|0}if(!(j&2048))ga=da;else{ea=f[a+180>>2]|0;b[da>>0]=-22;b[da+1>>0]=6;ba=da+2|0;da=_i[f[(f[ea>>2]|0)+60>>2]&1023](ea)|0;if(da>>>0>127){fa=da;aa=ba;while(1){b[aa>>0]=fa|128;_=fa>>>7;Z=aa+1|0;if(fa>>>0>16383){fa=_;aa=Z}else{ha=Z;ia=_;break}}}else{ha=ba;ia=da}b[ha>>0]=ia;ga=hj[f[(f[ea>>2]|0)+64>>2]&511](ea,c,ha+1|0)|0}if(!(j&4096))ja=ga;else{ha=f[a+184>>2]|0;b[ga>>0]=-14;b[ga+1>>0]=6;ea=ga+2|0;ga=_i[f[(f[ha>>2]|0)+60>>2]&1023](ha)|0;if(ga>>>0>127){ia=ga;da=ea;while(1){b[da>>0]=ia|128;ba=ia>>>7;aa=da+1|0;if(ia>>>0>16383){ia=ba;da=aa}else{ka=aa;la=ba;break}}}else{ka=ea;la=ga}b[ka>>0]=la;ja=hj[f[(f[ha>>2]|0)+64>>2]&511](ha,c,ka+1|0)|0}if(!(j&8192))ma=ja;else{ka=f[a+188>>2]|0;b[ja>>0]=-6;b[ja+1>>0]=6;ha=ja+2|0;ja=_i[f[(f[ka>>2]|0)+60>>2]&1023](ka)|0;if(ja>>>0>127){la=ja;ga=ha;while(1){b[ga>>0]=la|128;ea=la>>>7;da=ga+1|0;if(la>>>0>16383){la=ea;ga=da}else{na=da;oa=ea;break}}}else{na=ha;oa=ja}b[na>>0]=oa;ma=hj[f[(f[ka>>2]|0)+64>>2]&511](ka,c,na+1|0)|0}if(!(j&16384))pa=ma;else{na=f[a+192>>2]|0;b[ma>>0]=-126;b[ma+1>>0]=7;ka=ma+2|0;ma=_i[f[(f[na>>2]|0)+60>>2]&1023](na)|0;if(ma>>>0>127){oa=ma;ja=ka;while(1){b[ja>>0]=oa|128;ha=oa>>>7;ga=ja+1|0;if(oa>>>0>16383){oa=ha;ja=ga}else{qa=ga;ra=ha;break}}}else{qa=ka;ra=ma}b[qa>>0]=ra;pa=hj[f[(f[na>>2]|0)+64>>2]&511](na,c,qa+1|0)|0}if(!(j&32768))sa=pa;else{qa=f[a+196>>2]|0;b[pa>>0]=-118;b[pa+1>>0]=7;na=pa+2|0;pa=_i[f[(f[qa>>2]|0)+60>>2]&1023](qa)|0;if(pa>>>0>127){ra=pa;ma=na;while(1){b[ma>>0]=ra|128;ka=ra>>>7;ja=ma+1|0;if(ra>>>0>16383){ra=ka;ma=ja}else{ta=ja;ua=ka;break}}}else{ta=na;ua=pa}b[ta>>0]=ua;sa=hj[f[(f[qa>>2]|0)+64>>2]&511](qa,c,ta+1|0)|0}if(!(j&65536))va=sa;else{ta=f[a+200>>2]|0;b[sa>>0]=-110;b[sa+1>>0]=7;qa=sa+2|0;sa=_i[f[(f[ta>>2]|0)+60>>2]&1023](ta)|0;if(sa>>>0>127){ua=sa;pa=qa;while(1){b[pa>>0]=ua|128;na=ua>>>7;ma=pa+1|0;if(ua>>>0>16383){ua=na;pa=ma}else{wa=ma;xa=na;break}}}else{wa=qa;xa=sa}b[wa>>0]=xa;va=hj[f[(f[ta>>2]|0)+64>>2]&511](ta,c,wa+1|0)|0}if(!(j&131072))ya=va;else{wa=f[a+204>>2]|0;b[va>>0]=-102;b[va+1>>0]=7;ta=va+2|0;va=_i[f[(f[wa>>2]|0)+60>>2]&1023](wa)|0;if(va>>>0>127){xa=va;sa=ta;while(1){b[sa>>0]=xa|128;qa=xa>>>7;pa=sa+1|0;if(xa>>>0>16383){xa=qa;sa=pa}else{za=pa;Aa=qa;break}}}else{za=ta;Aa=va}b[za>>0]=Aa;ya=hj[f[(f[wa>>2]|0)+64>>2]&511](wa,c,za+1|0)|0}if(!(j&262144))Ba=ya;else{za=f[a+208>>2]|0;b[ya>>0]=-94;b[ya+1>>0]=7;wa=ya+2|0;ya=_i[f[(f[za>>2]|0)+60>>2]&1023](za)|0;if(ya>>>0>127){Aa=ya;va=wa;while(1){b[va>>0]=Aa|128;ta=Aa>>>7;sa=va+1|0;if(Aa>>>0>16383){Aa=ta;va=sa}else{Ca=sa;Da=ta;break}}}else{Ca=wa;Da=ya}b[Ca>>0]=Da;Ba=hj[f[(f[za>>2]|0)+64>>2]&511](za,c,Ca+1|0)|0}if(!(j&524288))Ea=Ba;else{Ca=f[a+212>>2]|0;b[Ba>>0]=-86;b[Ba+1>>0]=7;za=Ba+2|0;Ba=_i[f[(f[Ca>>2]|0)+60>>2]&1023](Ca)|0;if(Ba>>>0>127){Da=Ba;ya=za;while(1){b[ya>>0]=Da|128;wa=Da>>>7;va=ya+1|0;if(Da>>>0>16383){Da=wa;ya=va}else{Fa=va;Ga=wa;break}}}else{Fa=za;Ga=Ba}b[Fa>>0]=Ga;Ea=hj[f[(f[Ca>>2]|0)+64>>2]&511](Ca,c,Fa+1|0)|0}if(!(j&1048576))Ha=Ea;else{Fa=f[a+216>>2]|0;b[Ea>>0]=-78;b[Ea+1>>0]=7;Ca=Ea+2|0;Ea=_i[f[(f[Fa>>2]|0)+60>>2]&1023](Fa)|0;if(Ea>>>0>127){Ga=Ea;Ba=Ca;while(1){b[Ba>>0]=Ga|128;za=Ga>>>7;ya=Ba+1|0;if(Ga>>>0>16383){Ga=za;Ba=ya}else{Ia=ya;Ja=za;break}}}else{Ia=Ca;Ja=Ea}b[Ia>>0]=Ja;Ha=hj[f[(f[Fa>>2]|0)+64>>2]&511](Fa,c,Ia+1|0)|0}if(!(j&2097152))Ka=Ha;else{Ia=f[a+220>>2]|0;b[Ha>>0]=-70;b[Ha+1>>0]=7;Fa=Ha+2|0;Ha=_i[f[(f[Ia>>2]|0)+60>>2]&1023](Ia)|0;if(Ha>>>0>127){Ja=Ha;Ea=Fa;while(1){b[Ea>>0]=Ja|128;Ca=Ja>>>7;Ba=Ea+1|0;if(Ja>>>0>16383){Ja=Ca;Ea=Ba}else{La=Ba;Ma=Ca;break}}}else{La=Fa;Ma=Ha}b[La>>0]=Ma;Ka=hj[f[(f[Ia>>2]|0)+64>>2]&511](Ia,c,La+1|0)|0}if(!(j&4194304))Na=Ka;else{La=f[a+224>>2]|0;b[Ka>>0]=-62;b[Ka+1>>0]=7;Ia=Ka+2|0;Ka=_i[f[(f[La>>2]|0)+60>>2]&1023](La)|0;if(Ka>>>0>127){Ma=Ka;Ha=Ia;while(1){b[Ha>>0]=Ma|128;Fa=Ma>>>7;Ea=Ha+1|0;if(Ma>>>0>16383){Ma=Fa;Ha=Ea}else{Oa=Ea;Pa=Fa;break}}}else{Oa=Ia;Pa=Ka}b[Oa>>0]=Pa;Na=hj[f[(f[La>>2]|0)+64>>2]&511](La,c,Oa+1|0)|0}if(!(j&8388608))Qa=Na;else{Oa=f[a+228>>2]|0;b[Na>>0]=-54;b[Na+1>>0]=7;La=Na+2|0;Na=_i[f[(f[Oa>>2]|0)+60>>2]&1023](Oa)|0;if(Na>>>0>127){Pa=Na;Ka=La;while(1){b[Ka>>0]=Pa|128;Ia=Pa>>>7;Ha=Ka+1|0;if(Pa>>>0>16383){Pa=Ia;Ka=Ha}else{Ra=Ha;Sa=Ia;break}}}else{Ra=La;Sa=Na}b[Ra>>0]=Sa;Qa=hj[f[(f[Oa>>2]|0)+64>>2]&511](Oa,c,Ra+1|0)|0}if(!(j&16777216))Ta=Qa;else{Ra=f[a+232>>2]|0;b[Qa>>0]=-46;b[Qa+1>>0]=7;Oa=Qa+2|0;Qa=_i[f[(f[Ra>>2]|0)+60>>2]&1023](Ra)|0;if(Qa>>>0>127){Sa=Qa;Na=Oa;while(1){b[Na>>0]=Sa|128;La=Sa>>>7;Ka=Na+1|0;if(Sa>>>0>16383){Sa=La;Na=Ka}else{Ua=Ka;Va=La;break}}}else{Ua=Oa;Va=Qa}b[Ua>>0]=Va;Ta=hj[f[(f[Ra>>2]|0)+64>>2]&511](Ra,c,Ua+1|0)|0}if(!(j&33554432))Wa=Ta;else{Ua=f[a+236>>2]|0;b[Ta>>0]=-38;b[Ta+1>>0]=7;Ra=Ta+2|0;Ta=_i[f[(f[Ua>>2]|0)+60>>2]&1023](Ua)|0;if(Ta>>>0>127){Va=Ta;Qa=Ra;while(1){b[Qa>>0]=Va|128;Oa=Va>>>7;Na=Qa+1|0;if(Va>>>0>16383){Va=Oa;Qa=Na}else{Xa=Na;Ya=Oa;break}}}else{Xa=Ra;Ya=Ta}b[Xa>>0]=Ya;Wa=hj[f[(f[Ua>>2]|0)+64>>2]&511](Ua,c,Xa+1|0)|0}if(!(j&67108864))Za=Wa;else{Xa=f[a+240>>2]|0;b[Wa>>0]=-30;b[Wa+1>>0]=7;Ua=Wa+2|0;Wa=_i[f[(f[Xa>>2]|0)+60>>2]&1023](Xa)|0;if(Wa>>>0>127){Ya=Wa;Ta=Ua;while(1){b[Ta>>0]=Ya|128;Ra=Ya>>>7;Qa=Ta+1|0;if(Ya>>>0>16383){Ya=Ra;Ta=Qa}else{_a=Qa;$a=Ra;break}}}else{_a=Ua;$a=Wa}b[_a>>0]=$a;Za=hj[f[(f[Xa>>2]|0)+64>>2]&511](Xa,c,_a+1|0)|0}if(!(j&134217728))ab=Za;else{_a=f[a+244>>2]|0;b[Za>>0]=-22;b[Za+1>>0]=7;Xa=Za+2|0;Za=_i[f[(f[_a>>2]|0)+60>>2]&1023](_a)|0;if(Za>>>0>127){$a=Za;Wa=Xa;while(1){b[Wa>>0]=$a|128;Ua=$a>>>7;Ta=Wa+1|0;if($a>>>0>16383){$a=Ua;Wa=Ta}else{bb=Ta;cb=Ua;break}}}else{bb=Xa;cb=Za}b[bb>>0]=cb;ab=hj[f[(f[_a>>2]|0)+64>>2]&511](_a,c,bb+1|0)|0}if(!(j&268435456))db=ab;else{bb=f[a+248>>2]|0;b[ab>>0]=-14;b[ab+1>>0]=7;_a=ab+2|0;ab=_i[f[(f[bb>>2]|0)+60>>2]&1023](bb)|0;if(ab>>>0>127){cb=ab;Za=_a;while(1){b[Za>>0]=cb|128;Xa=cb>>>7;Wa=Za+1|0;if(cb>>>0>16383){cb=Xa;Za=Wa}else{eb=Wa;fb=Xa;break}}}else{eb=_a;fb=ab}b[eb>>0]=fb;db=hj[f[(f[bb>>2]|0)+64>>2]&511](bb,c,eb+1|0)|0}if(!(j&536870912))gb=db;else{eb=f[a+252>>2]|0;b[db>>0]=-6;b[db+1>>0]=7;bb=db+2|0;db=_i[f[(f[eb>>2]|0)+60>>2]&1023](eb)|0;if(db>>>0>127){fb=db;ab=bb;while(1){b[ab>>0]=fb|128;_a=fb>>>7;Za=ab+1|0;if(fb>>>0>16383){fb=_a;ab=Za}else{hb=Za;ib=_a;break}}}else{hb=bb;ib=db}b[hb>>0]=ib;gb=hj[f[(f[eb>>2]|0)+64>>2]&511](eb,c,hb+1|0)|0}if(!(j&1073741824))jb=gb;else{hb=f[a+256>>2]|0;b[gb>>0]=-126;b[gb+1>>0]=8;eb=gb+2|0;gb=_i[f[(f[hb>>2]|0)+60>>2]&1023](hb)|0;if(gb>>>0>127){ib=gb;db=eb;while(1){b[db>>0]=ib|128;bb=ib>>>7;ab=db+1|0;if(ib>>>0>16383){ib=bb;db=ab}else{kb=ab;lb=bb;break}}}else{kb=eb;lb=gb}b[kb>>0]=lb;jb=hj[f[(f[hb>>2]|0)+64>>2]&511](hb,c,kb+1|0)|0}if((j|0)<0){j=f[a+260>>2]|0;b[jb>>0]=-118;b[jb+1>>0]=8;kb=jb+2|0;hb=_i[f[(f[j>>2]|0)+60>>2]&1023](j)|0;if(hb>>>0>127){lb=hb;gb=kb;while(1){b[gb>>0]=lb|128;eb=lb>>>7;db=gb+1|0;if(lb>>>0>16383){lb=eb;gb=db}else{mb=db;nb=eb;break}}}else{mb=kb;nb=hb}b[mb>>0]=nb;ob=hj[f[(f[j>>2]|0)+64>>2]&511](j,c,mb+1|0)|0}else ob=jb;jb=f[x>>2]|0;if(!(jb&1))pb=ob;else{x=f[a+264>>2]|0;b[ob>>0]=-110;b[ob+1>>0]=8;mb=ob+2|0;ob=_i[f[(f[x>>2]|0)+60>>2]&1023](x)|0;if(ob>>>0>127){j=ob;nb=mb;while(1){b[nb>>0]=j|128;hb=j>>>7;kb=nb+1|0;if(j>>>0>16383){j=hb;nb=kb}else{qb=kb;rb=hb;break}}}else{qb=mb;rb=ob}b[qb>>0]=rb;pb=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,qb+1|0)|0}if(!(jb&2))sb=pb;else{qb=f[a+268>>2]|0;b[pb>>0]=-102;b[pb+1>>0]=8;x=pb+2|0;pb=_i[f[(f[qb>>2]|0)+60>>2]&1023](qb)|0;if(pb>>>0>127){rb=pb;ob=x;while(1){b[ob>>0]=rb|128;mb=rb>>>7;nb=ob+1|0;if(rb>>>0>16383){rb=mb;ob=nb}else{tb=nb;ub=mb;break}}}else{tb=x;ub=pb}b[tb>>0]=ub;sb=hj[f[(f[qb>>2]|0)+64>>2]&511](qb,c,tb+1|0)|0}if(!(jb&4))vb=sb;else{tb=f[a+272>>2]|0;b[sb>>0]=-94;b[sb+1>>0]=8;qb=sb+2|0;sb=_i[f[(f[tb>>2]|0)+60>>2]&1023](tb)|0;if(sb>>>0>127){ub=sb;pb=qb;while(1){b[pb>>0]=ub|128;x=ub>>>7;ob=pb+1|0;if(ub>>>0>16383){ub=x;pb=ob}else{wb=ob;xb=x;break}}}else{wb=qb;xb=sb}b[wb>>0]=xb;vb=hj[f[(f[tb>>2]|0)+64>>2]&511](tb,c,wb+1|0)|0}if(!(jb&8))yb=vb;else{wb=f[a+276>>2]|0;b[vb>>0]=-86;b[vb+1>>0]=8;tb=vb+2|0;vb=_i[f[(f[wb>>2]|0)+60>>2]&1023](wb)|0;if(vb>>>0>127){xb=vb;sb=tb;while(1){b[sb>>0]=xb|128;qb=xb>>>7;pb=sb+1|0;if(xb>>>0>16383){xb=qb;sb=pb}else{zb=pb;Ab=qb;break}}}else{zb=tb;Ab=vb}b[zb>>0]=Ab;yb=hj[f[(f[wb>>2]|0)+64>>2]&511](wb,c,zb+1|0)|0}if(!(jb&16))Bb=yb;else{zb=f[a+280>>2]|0;b[yb>>0]=-78;b[yb+1>>0]=8;wb=yb+2|0;yb=_i[f[(f[zb>>2]|0)+60>>2]&1023](zb)|0;if(yb>>>0>127){Ab=yb;vb=wb;while(1){b[vb>>0]=Ab|128;tb=Ab>>>7;sb=vb+1|0;if(Ab>>>0>16383){Ab=tb;vb=sb}else{Cb=sb;Db=tb;break}}}else{Cb=wb;Db=yb}b[Cb>>0]=Db;Bb=hj[f[(f[zb>>2]|0)+64>>2]&511](zb,c,Cb+1|0)|0}if(!(jb&32))Eb=Bb;else{Cb=f[a+284>>2]|0;b[Bb>>0]=-70;b[Bb+1>>0]=8;zb=Bb+2|0;Bb=_i[f[(f[Cb>>2]|0)+60>>2]&1023](Cb)|0;if(Bb>>>0>127){Db=Bb;yb=zb;while(1){b[yb>>0]=Db|128;wb=Db>>>7;vb=yb+1|0;if(Db>>>0>16383){Db=wb;yb=vb}else{Fb=vb;Gb=wb;break}}}else{Fb=zb;Gb=Bb}b[Fb>>0]=Gb;Eb=hj[f[(f[Cb>>2]|0)+64>>2]&511](Cb,c,Fb+1|0)|0}if(!(jb&64))Hb=Eb;else{Fb=f[a+288>>2]|0;b[Eb>>0]=-62;b[Eb+1>>0]=8;Cb=Eb+2|0;Eb=_i[f[(f[Fb>>2]|0)+60>>2]&1023](Fb)|0;if(Eb>>>0>127){Gb=Eb;Bb=Cb;while(1){b[Bb>>0]=Gb|128;zb=Gb>>>7;yb=Bb+1|0;if(Gb>>>0>16383){Gb=zb;Bb=yb}else{Ib=yb;Jb=zb;break}}}else{Ib=Cb;Jb=Eb}b[Ib>>0]=Jb;Hb=hj[f[(f[Fb>>2]|0)+64>>2]&511](Fb,c,Ib+1|0)|0}if(!(jb&128))Kb=Hb;else{Ib=f[a+292>>2]|0;b[Hb>>0]=-54;b[Hb+1>>0]=8;Fb=Hb+2|0;Hb=_i[f[(f[Ib>>2]|0)+60>>2]&1023](Ib)|0;if(Hb>>>0>127){Jb=Hb;Eb=Fb;while(1){b[Eb>>0]=Jb|128;Cb=Jb>>>7;Bb=Eb+1|0;if(Jb>>>0>16383){Jb=Cb;Eb=Bb}else{Lb=Bb;Mb=Cb;break}}}else{Lb=Fb;Mb=Hb}b[Lb>>0]=Mb;Kb=hj[f[(f[Ib>>2]|0)+64>>2]&511](Ib,c,Lb+1|0)|0}if(!(jb&256))Nb=Kb;else{Lb=f[a+296>>2]|0;b[Kb>>0]=-46;b[Kb+1>>0]=8;Ib=Kb+2|0;Kb=_i[f[(f[Lb>>2]|0)+60>>2]&1023](Lb)|0;if(Kb>>>0>127){Mb=Kb;Hb=Ib;while(1){b[Hb>>0]=Mb|128;Fb=Mb>>>7;Eb=Hb+1|0;if(Mb>>>0>16383){Mb=Fb;Hb=Eb}else{Ob=Eb;Pb=Fb;break}}}else{Ob=Ib;Pb=Kb}b[Ob>>0]=Pb;Nb=hj[f[(f[Lb>>2]|0)+64>>2]&511](Lb,c,Ob+1|0)|0}if(!(jb&512))Qb=Nb;else{Ob=f[a+300>>2]|0;b[Nb>>0]=-38;b[Nb+1>>0]=8;Lb=Nb+2|0;Nb=_i[f[(f[Ob>>2]|0)+60>>2]&1023](Ob)|0;if(Nb>>>0>127){Pb=Nb;Kb=Lb;while(1){b[Kb>>0]=Pb|128;Ib=Pb>>>7;Hb=Kb+1|0;if(Pb>>>0>16383){Pb=Ib;Kb=Hb}else{Rb=Hb;Sb=Ib;break}}}else{Rb=Lb;Sb=Nb}b[Rb>>0]=Sb;Qb=hj[f[(f[Ob>>2]|0)+64>>2]&511](Ob,c,Rb+1|0)|0}if(!(jb&1024))Tb=Qb;else{Rb=f[a+304>>2]|0;b[Qb>>0]=-30;b[Qb+1>>0]=8;Ob=Qb+2|0;Qb=_i[f[(f[Rb>>2]|0)+60>>2]&1023](Rb)|0;if(Qb>>>0>127){Sb=Qb;Nb=Ob;while(1){b[Nb>>0]=Sb|128;Lb=Sb>>>7;Kb=Nb+1|0;if(Sb>>>0>16383){Sb=Lb;Nb=Kb}else{Ub=Kb;Vb=Lb;break}}}else{Ub=Ob;Vb=Qb}b[Ub>>0]=Vb;Tb=hj[f[(f[Rb>>2]|0)+64>>2]&511](Rb,c,Ub+1|0)|0}if(!(jb&2048))Wb=Tb;else{Ub=f[a+308>>2]|0;b[Tb>>0]=-22;b[Tb+1>>0]=8;Rb=Tb+2|0;Tb=_i[f[(f[Ub>>2]|0)+60>>2]&1023](Ub)|0;if(Tb>>>0>127){Vb=Tb;Qb=Rb;while(1){b[Qb>>0]=Vb|128;Ob=Vb>>>7;Nb=Qb+1|0;if(Vb>>>0>16383){Vb=Ob;Qb=Nb}else{Xb=Nb;Yb=Ob;break}}}else{Xb=Rb;Yb=Tb}b[Xb>>0]=Yb;Wb=hj[f[(f[Ub>>2]|0)+64>>2]&511](Ub,c,Xb+1|0)|0}if(!(jb&4096))Zb=Wb;else{Xb=f[a+312>>2]|0;b[Wb>>0]=-14;b[Wb+1>>0]=8;Ub=Wb+2|0;Wb=_i[f[(f[Xb>>2]|0)+60>>2]&1023](Xb)|0;if(Wb>>>0>127){Yb=Wb;Tb=Ub;while(1){b[Tb>>0]=Yb|128;Rb=Yb>>>7;Qb=Tb+1|0;if(Yb>>>0>16383){Yb=Rb;Tb=Qb}else{_b=Qb;$b=Rb;break}}}else{_b=Ub;$b=Wb}b[_b>>0]=$b;Zb=hj[f[(f[Xb>>2]|0)+64>>2]&511](Xb,c,_b+1|0)|0}if(!(jb&8192))ac=Zb;else{_b=f[a+316>>2]|0;b[Zb>>0]=-6;b[Zb+1>>0]=8;Xb=Zb+2|0;Zb=_i[f[(f[_b>>2]|0)+60>>2]&1023](_b)|0;if(Zb>>>0>127){$b=Zb;Wb=Xb;while(1){b[Wb>>0]=$b|128;Ub=$b>>>7;Tb=Wb+1|0;if($b>>>0>16383){$b=Ub;Wb=Tb}else{bc=Tb;cc=Ub;break}}}else{bc=Xb;cc=Zb}b[bc>>0]=cc;ac=hj[f[(f[_b>>2]|0)+64>>2]&511](_b,c,bc+1|0)|0}if(!(jb&16384))dc=ac;else{bc=f[a+320>>2]|0;b[ac>>0]=-126;b[ac+1>>0]=9;_b=ac+2|0;ac=_i[f[(f[bc>>2]|0)+60>>2]&1023](bc)|0;if(ac>>>0>127){cc=ac;Zb=_b;while(1){b[Zb>>0]=cc|128;Xb=cc>>>7;Wb=Zb+1|0;if(cc>>>0>16383){cc=Xb;Zb=Wb}else{ec=Wb;fc=Xb;break}}}else{ec=_b;fc=ac}b[ec>>0]=fc;dc=hj[f[(f[bc>>2]|0)+64>>2]&511](bc,c,ec+1|0)|0}if(!(jb&32768))gc=dc;else{ec=f[a+324>>2]|0;b[dc>>0]=-118;b[dc+1>>0]=9;bc=dc+2|0;dc=_i[f[(f[ec>>2]|0)+60>>2]&1023](ec)|0;if(dc>>>0>127){fc=dc;ac=bc;while(1){b[ac>>0]=fc|128;_b=fc>>>7;Zb=ac+1|0;if(fc>>>0>16383){fc=_b;ac=Zb}else{hc=Zb;ic=_b;break}}}else{hc=bc;ic=dc}b[hc>>0]=ic;gc=hj[f[(f[ec>>2]|0)+64>>2]&511](ec,c,hc+1|0)|0}if(!(jb&65536))jc=gc;else{hc=f[a+328>>2]|0;b[gc>>0]=-110;b[gc+1>>0]=9;ec=gc+2|0;gc=_i[f[(f[hc>>2]|0)+60>>2]&1023](hc)|0;if(gc>>>0>127){ic=gc;dc=ec;while(1){b[dc>>0]=ic|128;bc=ic>>>7;ac=dc+1|0;if(ic>>>0>16383){ic=bc;dc=ac}else{kc=ac;lc=bc;break}}}else{kc=ec;lc=gc}b[kc>>0]=lc;jc=hj[f[(f[hc>>2]|0)+64>>2]&511](hc,c,kc+1|0)|0}if(!(jb&131072))mc=jc;else{kc=f[a+332>>2]|0;b[jc>>0]=-102;b[jc+1>>0]=9;hc=jc+2|0;jc=_i[f[(f[kc>>2]|0)+60>>2]&1023](kc)|0;if(jc>>>0>127){lc=jc;gc=hc;while(1){b[gc>>0]=lc|128;ec=lc>>>7;dc=gc+1|0;if(lc>>>0>16383){lc=ec;gc=dc}else{nc=dc;oc=ec;break}}}else{nc=hc;oc=jc}b[nc>>0]=oc;mc=hj[f[(f[kc>>2]|0)+64>>2]&511](kc,c,nc+1|0)|0}if(!(jb&262144))pc=mc;else{nc=f[a+336>>2]|0;b[mc>>0]=-94;b[mc+1>>0]=9;kc=mc+2|0;mc=_i[f[(f[nc>>2]|0)+60>>2]&1023](nc)|0;if(mc>>>0>127){oc=mc;jc=kc;while(1){b[jc>>0]=oc|128;hc=oc>>>7;gc=jc+1|0;if(oc>>>0>16383){oc=hc;jc=gc}else{qc=gc;rc=hc;break}}}else{qc=kc;rc=mc}b[qc>>0]=rc;pc=hj[f[(f[nc>>2]|0)+64>>2]&511](nc,c,qc+1|0)|0}if(!(jb&524288))sc=pc;else{qc=f[a+340>>2]|0;b[pc>>0]=-86;b[pc+1>>0]=9;nc=pc+2|0;pc=_i[f[(f[qc>>2]|0)+60>>2]&1023](qc)|0;if(pc>>>0>127){rc=pc;mc=nc;while(1){b[mc>>0]=rc|128;kc=rc>>>7;jc=mc+1|0;if(rc>>>0>16383){rc=kc;mc=jc}else{tc=jc;uc=kc;break}}}else{tc=nc;uc=pc}b[tc>>0]=uc;sc=hj[f[(f[qc>>2]|0)+64>>2]&511](qc,c,tc+1|0)|0}if(!(jb&1048576))vc=sc;else{tc=f[a+344>>2]|0;b[sc>>0]=-78;b[sc+1>>0]=9;qc=sc+2|0;sc=_i[f[(f[tc>>2]|0)+60>>2]&1023](tc)|0;if(sc>>>0>127){uc=sc;pc=qc;while(1){b[pc>>0]=uc|128;nc=uc>>>7;mc=pc+1|0;if(uc>>>0>16383){uc=nc;pc=mc}else{wc=mc;xc=nc;break}}}else{wc=qc;xc=sc}b[wc>>0]=xc;vc=hj[f[(f[tc>>2]|0)+64>>2]&511](tc,c,wc+1|0)|0}if(!(jb&2097152))yc=vc;else{wc=f[a+348>>2]|0;b[vc>>0]=-54;b[vc+1>>0]=12;tc=vc+2|0;vc=_i[f[(f[wc>>2]|0)+60>>2]&1023](wc)|0;if(vc>>>0>127){xc=vc;sc=tc;while(1){b[sc>>0]=xc|128;qc=xc>>>7;pc=sc+1|0;if(xc>>>0>16383){xc=qc;sc=pc}else{zc=pc;Ac=qc;break}}}else{zc=tc;Ac=vc}b[zc>>0]=Ac;yc=hj[f[(f[wc>>2]|0)+64>>2]&511](wc,c,zc+1|0)|0}if(!(jb&4194304))Bc=yc;else{zc=f[a+352>>2]|0;b[yc>>0]=-110;b[yc+1>>0]=-15;b[yc+2>>0]=4;wc=yc+3|0;yc=_i[f[(f[zc>>2]|0)+60>>2]&1023](zc)|0;if(yc>>>0>127){Ac=yc;vc=wc;while(1){b[vc>>0]=Ac|128;tc=Ac>>>7;sc=vc+1|0;if(Ac>>>0>16383){Ac=tc;vc=sc}else{Cc=sc;Dc=tc;break}}}else{Cc=wc;Dc=yc}b[Cc>>0]=Dc;Bc=hj[f[(f[zc>>2]|0)+64>>2]&511](zc,c,Cc+1|0)|0}if(!(jb&8388608))Ec=Bc;else{jb=f[a+356>>2]|0;b[Bc>>0]=-70;b[Bc+1>>0]=-67;b[Bc+2>>0]=-60;b[Bc+3>>0]=31;Cc=Bc+4|0;Bc=_i[f[(f[jb>>2]|0)+60>>2]&1023](jb)|0;if(Bc>>>0>127){zc=Bc;Dc=Cc;while(1){b[Dc>>0]=zc|128;yc=zc>>>7;wc=Dc+1|0;if(zc>>>0>16383){zc=yc;Dc=wc}else{Fc=wc;Gc=yc;break}}}else{Fc=Cc;Gc=Bc}b[Fc>>0]=Gc;Ec=hj[f[(f[jb>>2]|0)+64>>2]&511](jb,c,Fc+1|0)|0}Fc=f[a+4>>2]|0;if(!(Fc&1)){Hc=Ec;return Hc|0}Hc=Hjc(Fc&-2,Ec)|0;return Hc|0}function ocb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function pcb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15896,0)|0;if(!c){Ehc(b,a);return}else{scb(a,c);return}}function qcb(a,b){a=a|0;b=b|0;f[a+364>>2]=b;return}function rcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525200;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function scb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}yNa(a+16|0,c+16|0);yNa(a+32|0,c+32|0);e=a+48|0;h=c+48|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+56>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+56>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}tcb(a+60|0,c+60|0);PLa(a+76|0,c+76|0);lYa(a+92|0,c+92|0);lYa(a+108|0,c+108|0);h=a+124|0;e=c+124|0;g=f[e>>2]|0;if(g|0){zNa(h,(f[h>>2]|0)+g|0);dJc((f[h>>2]|0)+((f[a+132>>2]|0)+4)|0,(f[c+132>>2]|0)+4|0,f[e>>2]|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+136|0,g=f[c+136>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+140|0,d=f[c+140>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==527320){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);if(e&4|0){d=a+8|0;f[d>>2]=f[d>>2]|4;d=a+144|0;h=f[d>>2]|0;if(!h){g=VDc(44)|0;TYa(g);f[d>>2]=g;i=g}else i=h;h=f[c+144>>2]|0;UYa(i,h|0?h:522544)}if(e&8|0){h=a+8|0;f[h>>2]=f[h>>2]|8;h=a+148|0;i=f[h>>2]|0;if(!i){g=VDc(28)|0;_Ya(g);f[h>>2]=g;j=g}else j=i;i=f[c+148>>2]|0;g=i|0?i:522592;i=j+4|0;h=f[g+4>>2]|0;if(h&1|0){d=f[i>>2]|0;if(!(d&1))k=mNa(i)|0;else k=d&-2;ojc(k,h&-2)}h=f[g+8>>2]|0;if(h&7|0){if(h&1|0)f[j+16>>2]=f[g+16>>2];if(h&2|0)b[j+20>>0]=b[g+20>>0]|0;if(h&4|0)f[j+24>>2]=f[g+24>>2];g=j+8|0;f[g>>2]=f[g>>2]|h}}if(e&16|0){h=a+8|0;f[h>>2]=f[h>>2]|16;h=a+152|0;g=f[h>>2]|0;if(!g){j=VDc(28)|0;NYa(j);f[h>>2]=j;l=j}else l=g;g=f[c+152>>2]|0;j=g|0?g:522624;g=l+4|0;h=f[j+4>>2]|0;if(h&1|0){k=f[g>>2]|0;if(!(k&1))m=mNa(g)|0;else m=k&-2;ojc(m,h&-2)}h=f[j+8>>2]|0;if(h&7|0){if(h&1|0)f[l+16>>2]=f[j+16>>2];if(h&2|0)f[l+20>>2]=f[j+20>>2];if(h&4|0)f[l+24>>2]=f[j+24>>2];j=l+8|0;f[j>>2]=f[j>>2]|h}}if(e&32|0){h=a+8|0;f[h>>2]=f[h>>2]|32;h=a+156|0;j=f[h>>2]|0;if(!j){l=VDc(28)|0;HYa(l);f[h>>2]=l;n=l}else n=j;j=f[c+156>>2]|0;l=j|0?j:522656;j=n+4|0;h=f[l+4>>2]|0;if(h&1|0){m=f[j>>2]|0;if(!(m&1))o=mNa(j)|0;else o=m&-2;ojc(o,h&-2)}h=f[l+8>>2]|0;if(h&7|0){if(h&1|0)b[n+16>>0]=b[l+16>>0]|0;if(h&2|0)f[n+20>>2]=f[l+20>>2];if(h&4|0)f[n+24>>2]=f[l+24>>2];l=n+8|0;f[l>>2]=f[l>>2]|h}}if(e&64|0){h=a+8|0;f[h>>2]=f[h>>2]|64;h=a+160|0;l=f[h>>2]|0;if(!l){n=VDc(24)|0;mYa(n);f[h>>2]=n;p=n}else p=l;l=f[c+160>>2]|0;n=l|0?l:522688;l=p+4|0;h=f[n+4>>2]|0;if(h&1|0){o=f[l>>2]|0;if(!(o&1))q=mNa(l)|0;else q=o&-2;ojc(q,h&-2)}h=f[n+8>>2]|0;if(h&3|0){if(h&1|0)f[p+16>>2]=f[n+16>>2];if(h&2|0)f[p+20>>2]=f[n+20>>2];n=p+8|0;f[n>>2]=f[n>>2]|h}}if(e&128|0){h=a+8|0;f[h>>2]=f[h>>2]|128;h=a+164|0;n=f[h>>2]|0;if(!n){p=VDc(24)|0;YYa(p);f[h>>2]=p;r=p}else r=n;n=f[c+164>>2]|0;p=n|0?n:522776;n=r+4|0;h=f[p+4>>2]|0;if(h&1|0){q=f[n>>2]|0;if(!(q&1))s=mNa(n)|0;else s=q&-2;ojc(s,h&-2)}h=f[p+8>>2]|0;if(h&3|0){if(h&1|0)b[r+16>>0]=b[p+16>>0]|0;if(h&2|0)f[r+20>>2]=f[p+20>>2];p=r+8|0;f[p>>2]=f[p>>2]|h}}}do if(e&65280|0){if(e&256|0){h=a+8|0;f[h>>2]=f[h>>2]|256;h=a+168|0;p=f[h>>2]|0;if(!p){r=VDc(120)|0;nYa(r);f[h>>2]=r;t=r}else t=p;p=f[c+168>>2]|0;oYa(t,p|0?p:522800)}if(e&512|0){p=a+8|0;f[p>>2]=f[p>>2]|512;p=a+172|0;r=f[p>>2]|0;if(!r){h=VDc(52)|0;pYa(h);f[p>>2]=h;u=h}else u=r;r=f[c+172>>2]|0;qYa(u,r|0?r:522952)}if(e&1024|0){r=a+8|0;f[r>>2]=f[r>>2]|1024;r=a+176|0;h=f[r>>2]|0;if(!h){p=VDc(24)|0;rYa(p);f[r>>2]=p;v=p}else v=h;h=f[c+176>>2]|0;p=h|0?h:523080;h=v+4|0;r=f[p+4>>2]|0;if(r&1|0){s=f[h>>2]|0;if(!(s&1))w=mNa(h)|0;else w=s&-2;ojc(w,r&-2)}r=f[p+8>>2]|0;if(r&3|0){if(r&1|0)f[v+16>>2]=f[p+16>>2];if(r&2|0)b[v+20>>0]=b[p+20>>0]|0;p=v+8|0;f[p>>2]=f[p>>2]|r}}if(e&2048|0){r=a+8|0;f[r>>2]=f[r>>2]|2048;r=a+180|0;p=f[r>>2]|0;if(!p){s=VDc(96)|0;LYa(s);f[r>>2]=s;x=s}else x=p;p=f[c+180>>2]|0;MYa(x,p|0?p:523104)}if(e&4096|0){p=a+8|0;f[p>>2]=f[p>>2]|4096;p=a+184|0;s=f[p>>2]|0;if(!s){r=VDc(36)|0;IYa(r);f[p>>2]=r;y=r}else y=s;s=f[c+184>>2]|0;JYa(y,s|0?s:523200)}if(e&8192|0){s=a+8|0;f[s>>2]=f[s>>2]|8192;s=a+188|0;r=f[s>>2]|0;if(!r){p=VDc(28)|0;ZYa(p);f[s>>2]=p;z=p}else z=r;r=f[c+188>>2]|0;p=r|0?r:523304;r=z+4|0;s=f[p+4>>2]|0;if(s&1|0){h=f[r>>2]|0;if(!(h&1))A=mNa(r)|0;else A=h&-2;ojc(A,s&-2)}s=f[p+8>>2]|0;if(s&7|0){if(s&1|0)f[z+16>>2]=f[p+16>>2];if(s&2|0)f[z+20>>2]=f[p+20>>2];if(s&4|0)f[z+24>>2]=f[p+24>>2];p=z+8|0;f[p>>2]=f[p>>2]|s}}if(e&16384|0){s=a+8|0;f[s>>2]=f[s>>2]|16384;s=a+192|0;p=f[s>>2]|0;if(!p){h=VDc(28)|0;sYa(h);f[s>>2]=h;B=h}else B=p;p=f[c+192>>2]|0;tYa(B,p|0?p:523360)}if(e&32768|0){p=a+8|0;f[p>>2]=f[p>>2]|32768;p=a+196|0;h=f[p>>2]|0;if(!h){s=VDc(20)|0;jXa(s);f[p>>2]=s;C=s}else C=h;h=f[c+196>>2]|0;s=h|0?h:523392;h=C+4|0;p=f[s+4>>2]|0;if(p&1|0){r=f[h>>2]|0;if(!(r&1))D=mNa(h)|0;else D=r&-2;ojc(D,p&-2)}if(f[s+8>>2]&1|0?(p=C+8|0,f[p>>2]=f[p>>2]|1,p=C+16|0,r=f[s+16>>2]|0,s=f[p>>2]|0,(s|0)!=(r|0)):0)if((s|0)==527320){GLa(p,r);break}else{iEc(s,r)|0;break}}}while(0);if(e&16711680|0){if(e&65536|0){C=a+8|0;f[C>>2]=f[C>>2]|65536;C=a+200|0;D=f[C>>2]|0;if(!D){B=VDc(20)|0;OYa(B);f[C>>2]=B;E=B}else E=D;D=f[c+200>>2]|0;B=D|0?D:523416;D=E+4|0;C=f[B+4>>2]|0;if(C&1|0){z=f[D>>2]|0;if(!(z&1))F=mNa(D)|0;else F=z&-2;ojc(F,C&-2)}if(f[B+8>>2]&1|0){C=f[B+16>>2]|0;B=E+8|0;f[B>>2]=f[B>>2]|1;f[E+16>>2]=C}}if(e&131072|0){C=a+8|0;f[C>>2]=f[C>>2]|131072;C=a+204|0;E=f[C>>2]|0;if(!E){B=VDc(60)|0;uYa(B);f[C>>2]=B;G=B}else G=E;E=f[c+204>>2]|0;vYa(G,E|0?E:523440)}do if(e&262144|0){E=a+8|0;f[E>>2]=f[E>>2]|262144;E=a+208|0;G=f[E>>2]|0;if(!G){B=VDc(20)|0;wYa(B);f[E>>2]=B;H=B}else H=G;G=f[c+208>>2]|0;B=G|0?G:523504;G=H+4|0;E=f[B+4>>2]|0;if(E&1|0){C=f[G>>2]|0;if(!(C&1))I=mNa(G)|0;else I=C&-2;ojc(I,E&-2)}if(f[B+8>>2]&1|0?(E=H+8|0,f[E>>2]=f[E>>2]|1,E=H+16|0,C=f[B+16>>2]|0,B=f[E>>2]|0,(B|0)!=(C|0)):0)if((B|0)==527320){GLa(E,C);break}else{iEc(B,C)|0;break}}while(0);if(e&524288|0){H=a+8|0;f[H>>2]=f[H>>2]|524288;H=a+212|0;I=f[H>>2]|0;if(!I){C=VDc(36)|0;xYa(C);f[H>>2]=C;J=C}else J=I;I=f[c+212>>2]|0;yYa(J,I|0?I:523528)}if(e&1048576|0){I=a+8|0;f[I>>2]=f[I>>2]|1048576;I=a+216|0;J=f[I>>2]|0;if(!J){C=VDc(40)|0;zYa(C);f[I>>2]=C;K=C}else K=J;J=f[c+216>>2]|0;AYa(K,J|0?J:523632)}if(e&2097152|0){J=a+8|0;f[J>>2]=f[J>>2]|2097152;J=a+220|0;K=f[J>>2]|0;if(!K){C=VDc(32)|0;GYa(C);f[J>>2]=C;L=C}else L=K;K=f[c+220>>2]|0;C=K|0?K:523672;K=L+4|0;J=f[C+4>>2]|0;if(J&1|0){I=f[K>>2]|0;if(!(I&1))M=mNa(K)|0;else M=I&-2;ojc(M,J&-2)}J=f[C+8>>2]|0;if(J&15|0){if(J&1|0)f[L+16>>2]=f[C+16>>2];if(J&2|0)f[L+20>>2]=f[C+20>>2];if(J&4|0)f[L+24>>2]=f[C+24>>2];if(J&8|0)f[L+28>>2]=f[C+28>>2];C=L+8|0;f[C>>2]=f[C>>2]|J}}if(e&4194304|0){J=a+8|0;f[J>>2]=f[J>>2]|4194304;J=a+224|0;C=f[J>>2]|0;if(!C){L=VDc(24)|0;SYa(L);f[J>>2]=L;N=L}else N=C;C=f[c+224>>2]|0;L=C|0?C:523704;C=N+4|0;J=f[L+4>>2]|0;if(J&1|0){M=f[C>>2]|0;if(!(M&1))O=mNa(C)|0;else O=M&-2;ojc(O,J&-2)}J=f[L+8>>2]|0;if(J&7|0){if(J&1|0)b[N+16>>0]=b[L+16>>0]|0;if(J&2|0)b[N+17>>0]=b[L+17>>0]|0;if(J&4|0)f[N+20>>2]=f[L+20>>2];L=N+8|0;f[L>>2]=f[L>>2]|J}}if(e&8388608|0){J=a+8|0;f[J>>2]=f[J>>2]|8388608;J=a+228|0;L=f[J>>2]|0;if(!L){N=VDc(68)|0;BYa(N);f[J>>2]=N;P=N}else P=L;L=f[c+228>>2]|0;CYa(P,L|0?L:523752)}}if(e>>>0>16777215){if(e&16777216|0){L=a+8|0;f[L>>2]=f[L>>2]|16777216;L=a+232|0;P=f[L>>2]|0;if(!P){N=VDc(28)|0;FYa(N);f[L>>2]=N;Q=N}else Q=P;P=f[c+232>>2]|0;N=P|0?P:523824;P=Q+4|0;L=f[N+4>>2]|0;if(L&1|0){J=f[P>>2]|0;if(!(J&1))R=mNa(P)|0;else R=J&-2;ojc(R,L&-2)}L=f[N+8>>2]|0;if(L&7|0){if(L&1|0)f[Q+16>>2]=f[N+16>>2];if(L&2|0)f[Q+20>>2]=f[N+20>>2];if(L&4|0)f[Q+24>>2]=f[N+24>>2];N=Q+8|0;f[N>>2]=f[N>>2]|L}}if(e&33554432|0){L=a+8|0;f[L>>2]=f[L>>2]|33554432;L=a+236|0;N=f[L>>2]|0;if(!N){Q=VDc(24)|0;PYa(Q);f[L>>2]=Q;S=Q}else S=N;N=f[c+236>>2]|0;Q=N|0?N:523952;N=S+4|0;L=f[Q+4>>2]|0;if(L&1|0){R=f[N>>2]|0;if(!(R&1))T=mNa(N)|0;else T=R&-2;ojc(T,L&-2)}L=f[Q+8>>2]|0;if(L&3|0){if(L&1|0)f[S+16>>2]=f[Q+16>>2];if(L&2|0)f[S+20>>2]=f[Q+20>>2];Q=S+8|0;f[Q>>2]=f[Q>>2]|L}}if(e&67108864|0){L=a+8|0;f[L>>2]=f[L>>2]|67108864;L=a+240|0;Q=f[L>>2]|0;if(!Q){S=VDc(20)|0;WYa(S);f[L>>2]=S;U=S}else U=Q;Q=f[c+240>>2]|0;S=Q|0?Q:524048;Q=U+4|0;L=f[S+4>>2]|0;if(L&1|0){T=f[Q>>2]|0;if(!(T&1))V=mNa(Q)|0;else V=T&-2;ojc(V,L&-2)}if(f[S+8>>2]&1|0){L=f[S+16>>2]|0;S=U+8|0;f[S>>2]=f[S>>2]|1;f[U+16>>2]=L}}if(e&134217728|0){L=a+8|0;f[L>>2]=f[L>>2]|134217728;L=a+244|0;U=f[L>>2]|0;if(!U){S=VDc(24)|0;XYa(S);f[L>>2]=S;W=S}else W=U;U=f[c+244>>2]|0;S=U|0?U:524112;U=W+4|0;L=f[S+4>>2]|0;if(L&1|0){V=f[U>>2]|0;if(!(V&1))X=mNa(U)|0;else X=V&-2;ojc(X,L&-2)}L=f[S+8>>2]|0;if(L&3|0){if(L&1|0)f[W+16>>2]=f[S+16>>2];if(L&2|0)f[W+20>>2]=f[S+20>>2];S=W+8|0;f[S>>2]=f[S>>2]|L}}if(e&268435456|0){L=a+8|0;f[L>>2]=f[L>>2]|268435456;L=a+248|0;S=f[L>>2]|0;if(!S){W=VDc(36)|0;QYa(W);f[L>>2]=W;Y=W}else Y=S;S=f[c+248>>2]|0;RYa(Y,S|0?S:524072)}if(e&536870912|0){S=a+8|0;f[S>>2]=f[S>>2]|536870912;S=a+252|0;Y=f[S>>2]|0;if(!Y){W=VDc(20)|0;VYa(W);f[S>>2]=W;Z=W}else Z=Y;Y=f[c+252>>2]|0;W=Y|0?Y:524136;Y=Z+4|0;S=f[W+4>>2]|0;if(S&1|0){L=f[Y>>2]|0;if(!(L&1))_=mNa(Y)|0;else _=L&-2;ojc(_,S&-2)}if(f[W+8>>2]&1|0){S=f[W+16>>2]|0;W=Z+8|0;f[W>>2]=f[W>>2]|1;f[Z+16>>2]=S}}if(e&1073741824|0){S=a+8|0;f[S>>2]=f[S>>2]|1073741824;S=a+256|0;Z=f[S>>2]|0;if(!Z){W=VDc(20)|0;KYa(W);f[S>>2]=W;$=W}else $=Z;Z=f[c+256>>2]|0;W=Z|0?Z:524184;Z=$+4|0;S=f[W+4>>2]|0;if(S&1|0){_=f[Z>>2]|0;if(!(_&1))aa=mNa(Z)|0;else aa=_&-2;ojc(aa,S&-2)}if(f[W+8>>2]&1|0){S=f[W+16>>2]|0;W=$+8|0;f[W>>2]=f[W>>2]|1;f[$+16>>2]=S}}if((e|0)<0){e=a+8|0;f[e>>2]=f[e>>2]|-2147483648;e=a+260|0;S=f[e>>2]|0;if(!S){$=VDc(64)|0;DYa($);f[e>>2]=$;ba=$}else ba=S;S=f[c+260>>2]|0;EYa(ba,S|0?S:524208)}}S=f[c+12>>2]|0;if(S&255|0){if(S&1|0){ba=a+12|0;f[ba>>2]=f[ba>>2]|1;ba=a+264|0;$=f[ba>>2]|0;if(!$){e=VDc(32)|0;x8a(e);f[ba>>2]=e;ca=e}else ca=$;$=f[c+264>>2]|0;w8a(ca,$|0?$:523856)}if(S&2|0){$=a+12|0;f[$>>2]=f[$>>2]|2;$=a+268|0;ca=f[$>>2]|0;if(!ca){e=VDc(24)|0;TWa(e);f[$>>2]=e;da=e}else da=ca;ca=f[c+268>>2]|0;AWa(da,ca|0?ca:524800)}if(S&4|0){ca=a+12|0;f[ca>>2]=f[ca>>2]|4;ca=a+272|0;da=f[ca>>2]|0;if(!da){e=VDc(28)|0;z6a(e);f[ca>>2]=e;ea=e}else ea=da;da=f[c+272>>2]|0;e=da|0?da:524272;da=ea+4|0;ca=f[e+4>>2]|0;if(ca&1|0){$=f[da>>2]|0;if(!($&1))fa=mNa(da)|0;else fa=$&-2;ojc(fa,ca&-2)}ca=f[e+8>>2]|0;if(ca&7|0){if(ca&1|0)f[ea+16>>2]=f[e+16>>2];if(ca&2|0)f[ea+20>>2]=f[e+20>>2];if(ca&4|0)f[ea+24>>2]=f[e+24>>2];e=ea+8|0;f[e>>2]=f[e>>2]|ca}}if(S&8|0){ca=a+12|0;f[ca>>2]=f[ca>>2]|8;ca=a+276|0;e=f[ca>>2]|0;if(!e){ea=VDc(28)|0;y7a(ea);f[ca>>2]=ea;ga=ea}else ga=e;e=f[c+276>>2]|0;x7a(ga,e|0?e:523976)}if(S&16|0){e=a+12|0;f[e>>2]=f[e>>2]|16;e=a+280|0;ga=f[e>>2]|0;if(!ga){ea=VDc(28)|0;f9a(ea);f[e>>2]=ea;ha=ea}else ha=ga;ga=f[c+280>>2]|0;ea=ga|0?ga:523600;ga=ha+4|0;e=f[ea+4>>2]|0;if(e&1|0){ca=f[ga>>2]|0;if(!(ca&1))ia=mNa(ga)|0;else ia=ca&-2;ojc(ia,e&-2)}e=f[ea+8>>2]|0;if(e&7|0){if(e&1|0)f[ha+16>>2]=f[ea+16>>2];if(e&2|0)f[ha+20>>2]=f[ea+20>>2];if(e&4|0)f[ha+24>>2]=f[ea+24>>2];ea=ha+8|0;f[ea>>2]=f[ea>>2]|e}}if(S&32|0){e=a+12|0;f[e>>2]=f[e>>2]|32;e=a+284|0;ea=f[e>>2]|0;if(!ea){ha=VDc(24)|0;N9a(ha);f[e>>2]=ha;ja=ha}else ja=ea;ea=f[c+284>>2]|0;ha=ea|0?ea:523336;ea=ja+4|0;e=f[ha+4>>2]|0;if(e&1|0){ia=f[ea>>2]|0;if(!(ia&1))ka=mNa(ea)|0;else ka=ia&-2;ojc(ka,e&-2)}e=f[ha+8>>2]|0;if(e&3|0){if(e&1|0)f[ja+16>>2]=f[ha+16>>2];if(e&2|0)f[ja+20>>2]=f[ha+20>>2];ha=ja+8|0;f[ha>>2]=f[ha>>2]|e}}if(S&64|0){e=a+12|0;f[e>>2]=f[e>>2]|64;e=a+288|0;ha=f[e>>2]|0;if(!ha){ja=VDc(28)|0;P7a(ja);f[e>>2]=ja;la=ja}else la=ha;ha=f[c+288>>2]|0;ja=ha|0?ha:523920;ha=la+4|0;e=f[ja+4>>2]|0;if(e&1|0){ka=f[ha>>2]|0;if(!(ka&1))ma=mNa(ha)|0;else ma=ka&-2;ojc(ma,e&-2)}e=f[ja+8>>2]|0;if(e&7|0){if(e&1|0)f[la+16>>2]=f[ja+16>>2];if(e&2|0)f[la+20>>2]=f[ja+20>>2];if(e&4|0)f[la+24>>2]=f[ja+24>>2];ja=la+8|0;f[ja>>2]=f[ja>>2]|e}}if(S&128|0){e=a+12|0;f[e>>2]=f[e>>2]|128;e=a+292|0;ja=f[e>>2]|0;if(!ja){la=VDc(36)|0;dab(la);f[e>>2]=la;na=la}else na=ja;ja=f[c+292>>2]|0;cab(na,ja|0?ja:523264)}}if(S&65280|0){if(S&256|0){ja=a+12|0;f[ja>>2]=f[ja>>2]|256;ja=a+296|0;na=f[ja>>2]|0;if(!na){la=VDc(24)|0;Q6a(la);f[ja>>2]=la;oa=la}else oa=na;na=f[c+296>>2]|0;la=na|0?na:524160;na=oa+4|0;ja=f[la+4>>2]|0;if(ja&1|0){e=f[na>>2]|0;if(!(e&1))pa=mNa(na)|0;else pa=e&-2;ojc(pa,ja&-2)}ja=f[la+8>>2]|0;if(ja&3|0){if(ja&1|0)f[oa+16>>2]=f[la+16>>2];if(ja&2|0)f[oa+20>>2]=f[la+20>>2];la=oa+8|0;f[la>>2]=f[la>>2]|ja}}if(S&512|0){ja=a+12|0;f[ja>>2]=f[ja>>2]|512;ja=a+300|0;la=f[ja>>2]|0;if(!la){oa=VDc(28)|0;bcb(oa);f[ja>>2]=oa;qa=oa}else qa=la;la=f[c+300>>2]|0;oa=la|0?la:522712;la=qa+4|0;ja=f[oa+4>>2]|0;if(ja&1|0){pa=f[la>>2]|0;if(!(pa&1))ra=mNa(la)|0;else ra=pa&-2;ojc(ra,ja&-2)}ja=f[oa+8>>2]|0;if(ja&15|0){if(ja&1|0)b[qa+16>>0]=b[oa+16>>0]|0;if(ja&2|0)b[qa+17>>0]=b[oa+17>>0]|0;if(ja&4|0)f[qa+20>>2]=f[oa+20>>2];if(ja&8|0)f[qa+24>>2]=f[oa+24>>2];oa=qa+8|0;f[oa>>2]=f[oa>>2]|ja}}if(S&1024|0){ja=a+12|0;f[ja>>2]=f[ja>>2]|1024;ja=a+304|0;oa=f[ja>>2]|0;if(!oa){qa=VDc(20)|0;uab(qa);f[ja>>2]=qa;sa=qa}else sa=oa;oa=f[c+304>>2]|0;qa=oa|0?oa:523240;oa=sa+4|0;ja=f[qa+4>>2]|0;if(ja&1|0){ra=f[oa>>2]|0;if(!(ra&1))ta=mNa(oa)|0;else ta=ra&-2;ojc(ta,ja&-2)}if(f[qa+8>>2]&1|0){ja=f[qa+16>>2]|0;qa=sa+8|0;f[qa>>2]=f[qa>>2]|1;f[sa+16>>2]=ja}}if(S&2048|0){ja=a+12|0;f[ja>>2]=f[ja>>2]|2048;ja=a+308|0;sa=f[ja>>2]|0;if(!sa){qa=VDc(28)|0;Mbb(qa);f[ja>>2]=qa;ua=qa}else ua=sa;sa=f[c+308>>2]|0;Lbb(ua,sa|0?sa:522744)}if(S&4096|0){sa=a+12|0;f[sa>>2]=f[sa>>2]|4096;sa=a+312|0;ua=f[sa>>2]|0;if(!ua){qa=VDc(36)|0;g7a(qa);f[sa>>2]=qa;va=qa}else va=ua;ua=f[c+312>>2]|0;f7a(va,ua|0?ua:524008)}if(S&8192|0){ua=a+12|0;f[ua>>2]=f[ua>>2]|8192;ua=a+316|0;va=f[ua>>2]|0;if(!va){qa=VDc(32)|0;w9a(qa);f[ua>>2]=qa;wa=qa}else wa=va;va=f[c+316>>2]|0;qa=va|0?va:523568;va=wa+4|0;ua=f[qa+4>>2]|0;if(ua&1|0){sa=f[va>>2]|0;if(!(sa&1))xa=mNa(va)|0;else xa=sa&-2;ojc(xa,ua&-2)}F0a(wa+16|0,qa+16|0)}if(S&16384|0){qa=a+12|0;f[qa>>2]=f[qa>>2]|16384;qa=a+320|0;wa=f[qa>>2]|0;if(!wa){ua=VDc(32)|0;ubb(ua);f[qa>>2]=ua;ya=ua}else ya=wa;wa=f[c+320>>2]|0;tbb(ya,wa|0?wa:522920)}if(S&32768|0){wa=a+12|0;f[wa>>2]=f[wa>>2]|32768;wa=a+324|0;ya=f[wa>>2]|0;if(!ya){ua=VDc(20)|0;Q8a(ua);f[wa>>2]=ua;za=ua}else za=ya;ya=f[c+324>>2]|0;P8a(za,ya|0?ya:523728)}}do if(S&16711680|0){if(S&65536|0){ya=a+12|0;f[ya>>2]=f[ya>>2]|65536;ya=a+328|0;za=f[ya>>2]|0;if(!za){ua=VDc(32)|0;f8a(ua);f[ya>>2]=ua;Aa=ua}else Aa=za;za=f[c+328>>2]|0;e8a(Aa,za|0?za:523888)}if(S&131072|0){za=a+12|0;f[za>>2]=f[za>>2]|131072;za=a+332|0;ua=f[za>>2]|0;if(!ua){ya=VDc(52)|0;ucb(ya);f[za>>2]=ya;Ba=ya}else Ba=ua;ua=f[c+332>>2]|0;vcb(Ba,ua|0?ua:521496)}if(S&262144|0){ua=a+12|0;f[ua>>2]=f[ua>>2]|262144;ua=a+336|0;ya=f[ua>>2]|0;if(!ya){za=VDc(28)|0;wcb(za);f[ua>>2]=za;Ca=za}else Ca=ya;ya=f[c+336>>2]|0;za=ya|0?ya:521304;ya=Ca+4|0;ua=f[za+4>>2]|0;if(ua&1|0){wa=f[ya>>2]|0;if(!(wa&1))Da=mNa(ya)|0;else Da=wa&-2;ojc(Da,ua&-2)}ua=Ca+16|0;wa=za+16|0;ya=f[wa>>2]|0;if(ya|0){OLa(ua,(f[ua>>2]|0)+ya|0);dJc((f[Ca+24>>2]|0)+4+(f[ua>>2]<<2)|0,(f[za+24>>2]|0)+4|0,f[wa>>2]<<2|0)|0;f[ua>>2]=(f[ua>>2]|0)+(f[wa>>2]|0)}}if(S&524288|0){wa=a+12|0;f[wa>>2]=f[wa>>2]|524288;wa=a+340|0;ua=f[wa>>2]|0;if(!ua){za=VDc(28)|0;xcb(za);f[wa>>2]=za;Ea=za}else Ea=ua;ua=f[c+340>>2]|0;ycb(Ea,ua|0?ua:521336)}if(S&1048576|0){ua=a+12|0;f[ua>>2]=f[ua>>2]|1048576;ua=a+344|0;za=f[ua>>2]|0;if(!za){wa=VDc(128)|0;zcb(wa);f[ua>>2]=wa;Fa=wa}else Fa=za;za=f[c+344>>2]|0;Acb(Fa,za|0?za:521368)}if(S&2097152|0){za=a+12|0;f[za>>2]=f[za>>2]|2097152;za=a+348|0;wa=f[za>>2]|0;if(!wa){ua=VDc(64)|0;CVa(ua);f[za>>2]=ua;Ga=ua}else Ga=wa;wa=f[c+348>>2]|0;AVa(Ga,wa|0?wa:524904)}do if(S&4194304|0){wa=a+12|0;f[wa>>2]=f[wa>>2]|4194304;wa=a+352|0;ua=f[wa>>2]|0;if(!ua){za=VDc(28)|0;jVa(za);f[wa>>2]=za;Ha=za}else Ha=ua;ua=f[c+352>>2]|0;za=ua|0?ua:524968;ua=Ha+4|0;wa=f[za+4>>2]|0;if(wa&1|0){ya=f[ua>>2]|0;if(!(ya&1))Ia=mNa(ua)|0;else Ia=ya&-2;ojc(Ia,wa&-2)}wa=f[za+8>>2]|0;if(!(wa&7))break;if(wa&1|0)f[Ha+16>>2]=f[za+16>>2];if(wa&2|0)f[Ha+20>>2]=f[za+20>>2];if(wa&4|0)f[Ha+24>>2]=f[za+24>>2];za=Ha+8|0;f[za>>2]=f[za>>2]|wa}while(0);if(S&8388608|0){wa=a+12|0;f[wa>>2]=f[wa>>2]|8388608;wa=a+356|0;za=f[wa>>2]|0;if(!za){ya=VDc(28)|0;TVa(ya);f[wa>>2]=ya;Ja=ya}else Ja=za;za=f[c+356>>2]|0;ya=za|0?za:524872;za=Ja+4|0;wa=f[ya+4>>2]|0;if(wa&1|0){ua=f[za>>2]|0;if(!(ua&1))Ka=mNa(za)|0;else Ka=ua&-2;ojc(Ka,wa&-2)}wa=f[ya+8>>2]|0;if(!(wa&7))break;if(wa&1|0)f[Ja+16>>2]=f[ya+16>>2];if(wa&2|0)f[Ja+20>>2]=f[ya+20>>2];if(wa&4|0)f[Ja+24>>2]=f[ya+24>>2];ya=Ja+8|0;f[ya>>2]=f[ya>>2]|wa}}while(0);if(!(S&16777216))return;S=f[c+360>>2]|0;c=a+12|0;f[c>>2]=f[c>>2]|16777216;f[a+360>>2]=S;return}function tcb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Mdb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(32)|0;Ldb(l);Mdb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,15976,32);l=NQb(i,32,1742)|0;Ldb(l);Mdb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function ucb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94712;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=521496?(f[220369]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=32;b[d+8>>0]=0;DTb(881476,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[a+40>>2]=-1;f[a+44>>2]=1;b[a+48>>0]=1;b[a+49>>0]=1;u=c;return}function vcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=VDc(28)|0;cbb(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;d=g|0?g:523008;g=i+4|0;h=f[d+4>>2]|0;if(h&1|0){j=f[g>>2]|0;if(!(j&1))k=mNa(g)|0;else k=j&-2;ojc(k,h&-2)}h=f[d+8>>2]|0;if(h&7|0){if(h&1|0)f[i+16>>2]=f[d+16>>2];if(h&2|0)f[i+20>>2]=f[d+20>>2];if(h&4|0)f[i+24>>2]=f[d+24>>2];d=i+8|0;f[d>>2]=f[d>>2]|h}}if(e&2|0){h=a+8|0;f[h>>2]=f[h>>2]|2;h=a+20|0;d=f[h>>2]|0;if(!d){i=VDc(40)|0;Mab(i);f[h>>2]=i;l=i}else l=d;d=f[c+20>>2]|0;Lab(l,d|0?d:523040)}if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)b[a+32>>0]=b[c+32>>0]|0;if(e&32|0)f[a+36>>2]=f[c+36>>2];if(e&64|0)f[a+40>>2]=f[c+40>>2];if(e&128|0)f[a+44>>2]=f[c+44>>2];d=a+8|0;f[d>>2]=f[d>>2]|e}if(!(e&768))return;if(e&256|0)b[a+48>>0]=b[c+48>>0]|0;if(e&512|0)b[a+49>>0]=b[c+49>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function wcb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94604;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=521304?(f[220366]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=29;b[d+8>>0]=0;DTb(881464,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function xcb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94496;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=521336?(f[220367]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=30;b[d+8>>0]=0;DTb(881468,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=0;b[a+20>>0]=1;b[a+21>>0]=1;n[a+24>>2]=1.000000013351432e-10;u=c;return}function ycb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&15))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=VDc(48)|0;BWa(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;CWa(i,g|0?g:521608)}if(e&2|0)b[a+20>>0]=b[c+20>>0]|0;if(e&4|0)b[a+21>>0]=b[c+21>>0]|0;if(e&8|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function zcb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=94388;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==521368;g=a+16|0;h=g+72|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220368]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=31;b[d+8>>0]=0;DTb(881472,d);ZSb(d)}f[a+12>>2]=0;d=a+88|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;b[a+120>>0]=1;b[a+121>>0]=1;n[a+124>>2]=.5;u=c;return}function Acb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+28|0;e=c+28|0;g=f[e>>2]|0;if(g|0){SHa(h,(f[h>>2]|0)+g|0);dJc((f[a+36>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+36>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+40|0;h=c+40|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+48>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+48>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+52|0;e=c+52|0;g=f[e>>2]|0;if(g|0){SHa(h,(f[h>>2]|0)+g|0);dJc((f[a+60>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+60>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+64|0;h=c+64|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+72>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+72>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+76|0;e=c+76|0;g=f[e>>2]|0;if(g|0){SHa(h,(f[h>>2]|0)+g|0);dJc((f[a+84>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+84>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;if(e&255|0){if(e&1|0)f[a+88>>2]=f[c+88>>2];if(e&2|0)f[a+92>>2]=f[c+92>>2];if(e&4|0)f[a+96>>2]=f[c+96>>2];if(e&8|0)f[a+100>>2]=f[c+100>>2];if(e&16|0)f[a+104>>2]=f[c+104>>2];if(e&32|0)f[a+108>>2]=f[c+108>>2];if(e&64|0)f[a+112>>2]=f[c+112>>2];if(e&128|0)f[a+116>>2]=f[c+116>>2];h=a+8|0;f[h>>2]=f[h>>2]|e}if(!(e&1792))return;if(e&256|0)b[a+120>>0]=b[c+120>>0]|0;if(e&512|0)b[a+121>>0]=b[c+121>>0]|0;if(e&1024|0)f[a+124>>2]=f[c+124>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Bcb(a){a=a|0;var b=0,c=0;f[a>>2]=94388;b=f[a+84>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+72>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+60>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+48>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function Ccb(a){a=a|0;Bcb(a);YDc(a);return}function Dcb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Ecb(a,b){a=a|0;b=b|0;a=VDc(128)|0;zcb(a);if(!b)return a|0;Qcb(b,a);return a|0}function Fcb(a){a=a|0;var c=0,d=0,e=0;f[a+16>>2]=0;f[a+28>>2]=0;f[a+40>>2]=0;f[a+52>>2]=0;f[a+64>>2]=0;f[a+76>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){e=a+88|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0}if(d&1792|0){b[a+120>>0]=1;b[a+121>>0]=1;n[a+124>>2]=.5}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Gcb(a){a=a|0;return 1}function Hcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+88|0;k=a+92|0;l=a+16|0;m=a+20|0;n=a+24|0;o=a+120|0;p=e+8|0;q=a+121|0;r=e+8|0;s=a+28|0;t=a+32|0;v=a+36|0;w=a+96|0;x=a+100|0;y=a+104|0;z=a+108|0;A=a+112|0;B=a+116|0;C=a+124|0;D=a+40|0;E=a+44|0;F=a+48|0;G=a+52|0;H=a+56|0;I=a+60|0;K=a+64|0;L=a+68|0;M=a+72|0;N=a+76|0;O=a+80|0;P=a+84|0;Q=a+4|0;a:while(1){a=f[c>>2]|0;R=f[g>>2]|0;do if(a>>>0<R>>>0){S=b[a>>0]|0;T=S&255;U=a+1|0;if(S<<24>>24>0){V=U;W=T}else{if(U>>>0>=R>>>0){X=T;Y=7;break}S=h[U>>0]|0;if(((S^128)&T)>>>0<=127){X=T;Y=7;break}V=a+2|0;W=T+-128+(S<<7)|0}f[c>>2]=V;Z=W;Y=9}else{X=0;Y=7}while(0);if((Y|0)==7){Y=0;a=WRb(c,X)|0;if((a+-1|0)>>>0<16383){Z=a;Y=9}else _=a}b:do if((Y|0)==9){Y=0;do switch(Z>>>3&536870911|0){case 1:{if((Z&255|0)!=13){_=Z;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){R=a;S=h[R>>0]|h[R+1>>0]<<8|h[R+2>>0]<<16|h[R+3>>0]<<24;f[e>>2]=S;f[c>>2]=a+4;$=S}else{if(!(TRb(c,e)|0)){Y=16;break a}$=f[e>>2]|0}f[j>>2]=$;continue a;break}case 2:{if((Z&255|0)!=21){_=Z;break b}f[i>>2]=f[i>>2]|2;S=f[c>>2]|0;if(((f[g>>2]|0)-S|0)>3){a=S;R=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=R;f[c>>2]=S+4;aa=R}else{if(!(TRb(c,e)|0)){Y=23;break a}aa=f[e>>2]|0}f[k>>2]=aa;continue a;break}case 3:{switch((Z&255)<<24>>24){case 29:break;case 26:{if(BVa(c,l)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}R=f[c>>2]|0;if(((f[g>>2]|0)-R|0)>3){S=R;a=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[e>>2]=a;f[c>>2]=R+4;ca=a}else{if(!(TRb(c,e)|0)){Y=39;break a}ca=f[e>>2]|0}a=f[l>>2]|0;if((a|0)==(f[m>>2]|0)){SHa(l,a+1|0);da=f[l>>2]|0}else da=a;a=f[n>>2]|0;R=da+1|0;f[l>>2]=R;f[a+4+(da<<2)>>2]=ca;S=f[c>>2]|0;T=(f[g>>2]|0)-S|0;if((T|0)<=0)continue a;U=S;S=(f[m>>2]|0)-R|0;ea=(T>>>0)/5|0;fa=(ea|0)<(S|0)?ea:S;if((fa|0)>0){ga=0;ha=U;ia=R}else continue a;while(1){if((b[ha>>0]|0)!=29){ja=ga;break}R=ha+1|0;S=h[R>>0]|h[R+1>>0]<<8|h[R+2>>0]<<16|h[R+3>>0]<<24;R=ia;ia=ia+1|0;f[l>>2]=ia;f[a+4+(R<<2)>>2]=S;S=ga+1|0;if((S|0)>=(fa|0)){ja=S;break}else{ga=S;ha=ha+5|0}}fa=ja*5|0;if((ja|0)<=0)continue a;if((T|0)<(fa|0)){PRb(c,fa,T)|0;continue a}else{f[c>>2]=U+fa;continue a}break}case 4:{if((Z&255|0)!=32){_=Z;break b}f[i>>2]=f[i>>2]|256;fa=f[c>>2]|0;if(fa>>>0<(f[g>>2]|0)>>>0?(a=b[fa>>0]|0,a<<24>>24>-1):0){f[c>>2]=fa+1;ka=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[p>>0]|0)){ba=0;Y=188;break a}else ka=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[o>>0]=ka&1;continue a;break}case 5:{if((Z&255|0)!=40){_=Z;break b}f[i>>2]=f[i>>2]|512;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(fa=b[a>>0]|0,fa<<24>>24>-1):0){f[c>>2]=a+1;la=fa<<24>>24!=0}else{IRb(e,c);fa=e;if(!(b[r>>0]|0)){ba=0;Y=188;break a}else la=(f[fa>>2]|0)!=0|(f[fa+4>>2]|0)!=0}b[q>>0]=la&1;continue a;break}case 6:{switch((Z&255)<<24>>24){case 53:break;case 50:{if(BVa(c,s)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}fa=f[c>>2]|0;if(((f[g>>2]|0)-fa|0)>3){a=fa;S=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=S;f[c>>2]=fa+4;ma=S}else{if(!(TRb(c,e)|0)){Y=68;break a}ma=f[e>>2]|0}S=f[s>>2]|0;if((S|0)==(f[t>>2]|0)){SHa(s,S+1|0);na=f[s>>2]|0}else na=S;S=f[v>>2]|0;fa=na+1|0;f[s>>2]=fa;f[S+4+(na<<2)>>2]=ma;a=f[c>>2]|0;R=(f[g>>2]|0)-a|0;if((R|0)<=0)continue a;ea=a;a=(f[t>>2]|0)-fa|0;oa=(R>>>0)/5|0;pa=(oa|0)<(a|0)?oa:a;if((pa|0)>0){qa=0;ra=ea;sa=fa}else continue a;while(1){if((b[ra>>0]|0)!=53){ta=qa;break}fa=ra+1|0;a=h[fa>>0]|h[fa+1>>0]<<8|h[fa+2>>0]<<16|h[fa+3>>0]<<24;fa=sa;sa=sa+1|0;f[s>>2]=sa;f[S+4+(fa<<2)>>2]=a;a=qa+1|0;if((a|0)>=(pa|0)){ta=a;break}else{qa=a;ra=ra+5|0}}pa=ta*5|0;if((ta|0)<=0)continue a;if((R|0)<(pa|0)){PRb(c,pa,R)|0;continue a}else{f[c>>2]=ea+pa;continue a}break}case 7:{if((Z&255|0)!=56){_=Z;break b}f[i>>2]=f[i>>2]|4;pa=f[c>>2]|0;if(pa>>>0<(f[g>>2]|0)>>>0){S=b[pa>>0]|0;U=S&255;if(S<<24>>24>-1){f[w>>2]=U;f[c>>2]=pa+1;continue a}else ua=U}else ua=0;U=HRb(c,ua)|0;pa=J;f[w>>2]=U;if((pa|0)>-1|(pa|0)==-1&U>>>0>4294967295)continue a;else{ba=0;Y=188;break a}break}case 8:{if((Z&255|0)!=64){_=Z;break b}f[i>>2]=f[i>>2]|8;U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0){pa=b[U>>0]|0;S=pa&255;if(pa<<24>>24>-1){f[x>>2]=S;f[c>>2]=U+1;continue a}else va=S}else va=0;S=HRb(c,va)|0;U=J;f[x>>2]=S;if((U|0)>-1|(U|0)==-1&S>>>0>4294967295)continue a;else{ba=0;Y=188;break a}break}case 9:{if((Z&255|0)!=72){_=Z;break b}f[i>>2]=f[i>>2]|16;S=f[c>>2]|0;if(S>>>0<(f[g>>2]|0)>>>0){U=b[S>>0]|0;pa=U&255;if(U<<24>>24>-1){f[y>>2]=pa;f[c>>2]=S+1;continue a}else wa=pa}else wa=0;pa=HRb(c,wa)|0;S=J;f[y>>2]=pa;if((S|0)>-1|(S|0)==-1&pa>>>0>4294967295)continue a;else{ba=0;Y=188;break a}break}case 10:{if((Z&255|0)!=85){_=Z;break b}f[i>>2]=f[i>>2]|32;pa=f[c>>2]|0;if(((f[g>>2]|0)-pa|0)>3){S=pa;U=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[e>>2]=U;f[c>>2]=pa+4;xa=U}else{if(!(TRb(c,e)|0)){Y=91;break a}xa=f[e>>2]|0}f[z>>2]=xa;continue a;break}case 11:{if((Z&255|0)!=93){_=Z;break b}f[i>>2]=f[i>>2]|64;U=f[c>>2]|0;if(((f[g>>2]|0)-U|0)>3){pa=U;S=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=S;f[c>>2]=U+4;ya=S}else{if(!(TRb(c,e)|0)){Y=98;break a}ya=f[e>>2]|0}f[A>>2]=ya;continue a;break}case 12:{if((Z&255|0)!=101){_=Z;break b}f[i>>2]=f[i>>2]|128;S=f[c>>2]|0;if(((f[g>>2]|0)-S|0)>3){U=S;pa=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;f[e>>2]=pa;f[c>>2]=S+4;za=pa}else{if(!(TRb(c,e)|0)){Y=105;break a}za=f[e>>2]|0}f[B>>2]=za;continue a;break}case 13:{if((Z&255|0)!=109){_=Z;break b}f[i>>2]=f[i>>2]|1024;pa=f[c>>2]|0;if(((f[g>>2]|0)-pa|0)>3){S=pa;U=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[e>>2]=U;f[c>>2]=pa+4;Aa=U}else{if(!(TRb(c,e)|0)){Y=112;break a}Aa=f[e>>2]|0}f[C>>2]=Aa;continue a;break}case 14:{switch((Z&255)<<24>>24){case 117:break;case 114:{if(BVa(c,D)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}U=f[c>>2]|0;if(((f[g>>2]|0)-U|0)>3){pa=U;S=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=S;f[c>>2]=U+4;Ba=S}else{if(!(TRb(c,e)|0)){Y=128;break a}Ba=f[e>>2]|0}S=f[D>>2]|0;if((S|0)==(f[E>>2]|0)){SHa(D,S+1|0);Ca=f[D>>2]|0}else Ca=S;S=f[F>>2]|0;U=Ca+1|0;f[D>>2]=U;f[S+4+(Ca<<2)>>2]=Ba;pa=f[c>>2]|0;T=(f[g>>2]|0)-pa|0;if((T|0)<=0)continue a;a=pa;pa=(f[E>>2]|0)-U|0;fa=(T>>>0)/5|0;oa=(fa|0)<(pa|0)?fa:pa;if((oa|0)>0){Da=0;Ea=a;Fa=U}else continue a;while(1){if((b[Ea>>0]|0)!=117){Ga=Da;break}U=Ea+1|0;pa=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;U=Fa;Fa=Fa+1|0;f[D>>2]=Fa;f[S+4+(U<<2)>>2]=pa;pa=Da+1|0;if((pa|0)>=(oa|0)){Ga=pa;break}else{Da=pa;Ea=Ea+5|0}}oa=Ga*5|0;if((Ga|0)<=0)continue a;if((T|0)<(oa|0)){PRb(c,oa,T)|0;continue a}else{f[c>>2]=a+oa;continue a}break}case 15:{switch((Z&255)<<24>>24){case 125:break;case 122:{if(BVa(c,G)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}oa=f[c>>2]|0;if(((f[g>>2]|0)-oa|0)>3){S=oa;ea=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[e>>2]=ea;f[c>>2]=oa+4;Ha=ea}else{if(!(TRb(c,e)|0)){Y=145;break a}Ha=f[e>>2]|0}ea=f[G>>2]|0;if((ea|0)==(f[H>>2]|0)){SHa(G,ea+1|0);Ia=f[G>>2]|0}else Ia=ea;ea=f[I>>2]|0;oa=Ia+1|0;f[G>>2]=oa;f[ea+4+(Ia<<2)>>2]=Ha;S=f[c>>2]|0;R=(f[g>>2]|0)-S|0;if((R|0)<=0)continue a;pa=S;S=(f[H>>2]|0)-oa|0;U=(R>>>0)/5|0;fa=(U|0)<(S|0)?U:S;if((fa|0)>0){Ja=0;Ka=pa;La=oa}else continue a;while(1){if((b[Ka>>0]|0)!=125){Ma=Ja;break}oa=Ka+1|0;S=h[oa>>0]|h[oa+1>>0]<<8|h[oa+2>>0]<<16|h[oa+3>>0]<<24;oa=La;La=La+1|0;f[G>>2]=La;f[ea+4+(oa<<2)>>2]=S;S=Ja+1|0;if((S|0)>=(fa|0)){Ma=S;break}else{Ja=S;Ka=Ka+5|0}}fa=Ma*5|0;if((Ma|0)<=0)continue a;if((R|0)<(fa|0)){PRb(c,fa,R)|0;continue a}else{f[c>>2]=pa+fa;continue a}break}case 16:{switch((Z&255)<<24>>24){case -123:break;case -126:{if(BVa(c,K)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}fa=f[c>>2]|0;if(((f[g>>2]|0)-fa|0)>3){ea=fa;a=h[ea>>0]|h[ea+1>>0]<<8|h[ea+2>>0]<<16|h[ea+3>>0]<<24;f[e>>2]=a;f[c>>2]=fa+4;Na=a}else{if(!(TRb(c,e)|0)){Y=163;break a}Na=f[e>>2]|0}a=f[K>>2]|0;if((a|0)==(f[L>>2]|0)){SHa(K,a+1|0);Oa=f[K>>2]|0}else Oa=a;a=f[M>>2]|0;fa=Oa+1|0;f[K>>2]=fa;f[a+4+(Oa<<2)>>2]=Na;ea=f[c>>2]|0;T=(f[g>>2]|0)-ea|0;if((T|0)<=0)continue a;S=ea;ea=(f[L>>2]|0)-fa|0;oa=(T>>>0)/6|0;U=(oa|0)<(ea|0)?oa:ea;if((U|0)>0){Pa=0;Qa=S;Ra=fa}else continue a;while(1){if((b[Qa>>0]|0)!=-123){Sa=Pa;break}if((b[Qa+1>>0]|0)!=1){Sa=Pa;break}fa=Qa+2|0;ea=h[fa>>0]|h[fa+1>>0]<<8|h[fa+2>>0]<<16|h[fa+3>>0]<<24;fa=Ra;Ra=Ra+1|0;f[K>>2]=Ra;f[a+4+(fa<<2)>>2]=ea;ea=Pa+1|0;if((ea|0)>=(U|0)){Sa=ea;break}else{Pa=ea;Qa=Qa+6|0}}U=Sa*6|0;if((Sa|0)<=0)continue a;if((T|0)<(U|0)){PRb(c,U,T)|0;continue a}else{f[c>>2]=S+U;continue a}break}case 17:{switch((Z&255)<<24>>24){case -115:break;case -118:{if(BVa(c,N)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}U=f[c>>2]|0;if(((f[g>>2]|0)-U|0)>3){a=U;pa=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=pa;f[c>>2]=U+4;Ta=pa}else{if(!(TRb(c,e)|0)){Y=181;break a}Ta=f[e>>2]|0}pa=f[N>>2]|0;if((pa|0)==(f[O>>2]|0)){SHa(N,pa+1|0);Ua=f[N>>2]|0}else Ua=pa;pa=f[P>>2]|0;U=Ua+1|0;f[N>>2]=U;f[pa+4+(Ua<<2)>>2]=Ta;a=f[c>>2]|0;R=(f[g>>2]|0)-a|0;if((R|0)<=0)continue a;ea=a;a=(f[O>>2]|0)-U|0;fa=(R>>>0)/6|0;oa=(fa|0)<(a|0)?fa:a;if((oa|0)>0){Va=0;Wa=ea;Xa=U}else continue a;while(1){if((b[Wa>>0]|0)!=-115){Ya=Va;break}if((b[Wa+1>>0]|0)!=1){Ya=Va;break}U=Wa+2|0;a=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;U=Xa;Xa=Xa+1|0;f[N>>2]=Xa;f[pa+4+(U<<2)>>2]=a;a=Va+1|0;if((a|0)>=(oa|0)){Ya=a;break}else{Va=a;Wa=Wa+6|0}}oa=Ya*6|0;if((Ya|0)<=0)continue a;if((R|0)<(oa|0)){PRb(c,oa,R)|0;continue a}else{f[c>>2]=ea+oa;continue a}break}default:{_=Z;break b}}while(0)}while(0);if(!_){ba=1;Y=188;break}oa=f[Q>>2]|0;if(!(oa&1))Za=mNa(Q)|0;else Za=oa&-2;if(!(Djc(c,_,Za)|0)){ba=0;Y=188;break}}switch(Y|0){case 16:{ba=0;u=d;return ba|0}case 23:{ba=0;u=d;return ba|0}case 39:{ba=0;u=d;return ba|0}case 68:{ba=0;u=d;return ba|0}case 91:{ba=0;u=d;return ba|0}case 98:{ba=0;u=d;return ba|0}case 105:{ba=0;u=d;return ba|0}case 112:{ba=0;u=d;return ba|0}case 128:{ba=0;u=d;return ba|0}case 145:{ba=0;u=d;return ba|0}case 163:{ba=0;u=d;return ba|0}case 181:{ba=0;u=d;return ba|0}case 188:{u=d;return ba|0}}return 0}function Icb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+16>>2]|0;d=f[a+28>>2]|0;e=f[a+40>>2]|0;g=f[a+52>>2]|0;h=f[a+64>>2]|0;i=f[a+76>>2]|0;j=b+c+d+e+g+(i<<2)+(i+h<<1)+(d+b+e+g+h<<2)|0;h=f[a+8>>2]|0;if(!(h&255))k=j;else{g=h&1|0?j+5|0:j;j=h&2|0?g+5|0:g;if(!(h&4))l=j;else l=j+1+((((($(f[a+96>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(h&8))m=l;else m=l+1+((((($(f[a+100>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(h&16))n=m;else n=m+1+((((($(f[a+104>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=h&32|0?n+5|0:n;n=h&64|0?m+5|0:m;k=h&128|0?n+5|0:n}if(!(h&1792)){o=k;p=a+12|0;f[p>>2]=o;return o|0}n=h&256|0?k+2|0:k;k=h&512|0?n+2|0:n;o=h&1024|0?k+5|0:k;p=a+12|0;f[p>>2]=o;return o|0}function Jcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&1|0)WTb(1,+n[a+88>>2],c);if(d&2|0)WTb(2,+n[a+92>>2],c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{WTb(3,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}if(d&256|0)YTb(4,(b[a+120>>0]|0)!=0,c);if(d&512|0)YTb(5,(b[a+121>>0]|0)!=0,c);e=f[a+28>>2]|0;if((e|0)>0){h=a+36|0;g=0;do{WTb(6,+n[(f[h>>2]|0)+4+(g<<2)>>2],c);g=g+1|0}while((g|0)!=(e|0))}if(d&4|0)OTb(7,f[a+96>>2]|0,c);if(d&8|0)OTb(8,f[a+100>>2]|0,c);if(d&16|0)OTb(9,f[a+104>>2]|0,c);if(d&32|0)WTb(10,+n[a+108>>2],c);if(d&64|0)WTb(11,+n[a+112>>2],c);if(d&128|0)WTb(12,+n[a+116>>2],c);if(d&1024|0)WTb(13,+n[a+124>>2],c);d=f[a+40>>2]|0;if((d|0)>0){e=a+48|0;g=0;do{WTb(14,+n[(f[e>>2]|0)+4+(g<<2)>>2],c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+52>>2]|0;if((d|0)>0){g=a+60|0;e=0;do{WTb(15,+n[(f[g>>2]|0)+4+(e<<2)>>2],c);e=e+1|0}while((e|0)!=(d|0))}d=f[a+64>>2]|0;if((d|0)>0){e=a+72|0;g=0;do{WTb(16,+n[(f[e>>2]|0)+4+(g<<2)>>2],c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+76>>2]|0;if((d|0)>0){g=a+84|0;e=0;do{WTb(17,+n[(f[g>>2]|0)+4+(e<<2)>>2],c);e=e+1|0}while((e|0)!=(d|0))}d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Kcb(a){a=a|0;return f[a+12>>2]|0}function Lcb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+88>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{d=f[a+92>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}e=f[a+16>>2]|0;if(!e)j=i;else{d=f[a+24>>2]|0;g=0;h=i;while(1){i=f[d+4+(g<<2)>>2]|0;b[h>>0]=29;k=h+1|0;b[k>>0]=i;b[k+1>>0]=i>>8;b[k+2>>0]=i>>16;b[k+3>>0]=i>>24;i=h+5|0;g=g+1|0;if((g|0)>=(e|0)){j=i;break}else h=i}}if(!(c&256))l=j;else{h=b[a+120>>0]|0;b[j>>0]=32;b[j+1>>0]=h;l=j+2|0}if(!(c&512))m=l;else{j=b[a+121>>0]|0;b[l>>0]=40;b[l+1>>0]=j;m=l+2|0}l=f[a+28>>2]|0;if(!l)n=m;else{j=f[a+36>>2]|0;h=0;e=m;while(1){m=f[j+4+(h<<2)>>2]|0;b[e>>0]=53;g=e+1|0;b[g>>0]=m;b[g+1>>0]=m>>8;b[g+2>>0]=m>>16;b[g+3>>0]=m>>24;m=e+5|0;h=h+1|0;if((h|0)>=(l|0)){n=m;break}else e=m}}if(!(c&4))o=n;else{e=f[a+96>>2]|0;b[n>>0]=56;l=n+1|0;if(e>>>0>127){n=e;h=l;while(1){b[h>>0]=n|128;j=n>>>7;m=h+1|0;if(n>>>0>16383){n=j;h=m}else{p=m;q=j;break}}}else{p=l;q=e}b[p>>0]=q;o=p+1|0}if(!(c&8))r=o;else{p=f[a+100>>2]|0;b[o>>0]=64;q=o+1|0;if(p>>>0>127){o=p;e=q;while(1){b[e>>0]=o|128;l=o>>>7;h=e+1|0;if(o>>>0>16383){o=l;e=h}else{s=h;t=l;break}}}else{s=q;t=p}b[s>>0]=t;r=s+1|0}if(!(c&16))u=r;else{s=f[a+104>>2]|0;b[r>>0]=72;t=r+1|0;if(s>>>0>127){r=s;p=t;while(1){b[p>>0]=r|128;q=r>>>7;e=p+1|0;if(r>>>0>16383){r=q;p=e}else{v=e;w=q;break}}}else{v=t;w=s}b[v>>0]=w;u=v+1|0}if(!(c&32))x=u;else{v=f[a+108>>2]|0;b[u>>0]=85;w=u+1|0;b[w>>0]=v;b[w+1>>0]=v>>8;b[w+2>>0]=v>>16;b[w+3>>0]=v>>24;x=u+5|0}if(!(c&64))y=x;else{u=f[a+112>>2]|0;b[x>>0]=93;v=x+1|0;b[v>>0]=u;b[v+1>>0]=u>>8;b[v+2>>0]=u>>16;b[v+3>>0]=u>>24;y=x+5|0}if(!(c&128))z=y;else{x=f[a+116>>2]|0;b[y>>0]=101;u=y+1|0;b[u>>0]=x;b[u+1>>0]=x>>8;b[u+2>>0]=x>>16;b[u+3>>0]=x>>24;z=y+5|0}if(!(c&1024))A=z;else{c=f[a+124>>2]|0;b[z>>0]=109;y=z+1|0;b[y>>0]=c;b[y+1>>0]=c>>8;b[y+2>>0]=c>>16;b[y+3>>0]=c>>24;A=z+5|0}z=f[a+40>>2]|0;if(!z)B=A;else{c=f[a+48>>2]|0;y=0;x=A;while(1){A=f[c+4+(y<<2)>>2]|0;b[x>>0]=117;u=x+1|0;b[u>>0]=A;b[u+1>>0]=A>>8;b[u+2>>0]=A>>16;b[u+3>>0]=A>>24;A=x+5|0;y=y+1|0;if((y|0)>=(z|0)){B=A;break}else x=A}}x=f[a+52>>2]|0;if(!x)C=B;else{z=f[a+60>>2]|0;y=0;c=B;while(1){B=f[z+4+(y<<2)>>2]|0;b[c>>0]=125;A=c+1|0;b[A>>0]=B;b[A+1>>0]=B>>8;b[A+2>>0]=B>>16;b[A+3>>0]=B>>24;B=c+5|0;y=y+1|0;if((y|0)>=(x|0)){C=B;break}else c=B}}c=f[a+64>>2]|0;if(!c)D=C;else{x=f[a+72>>2]|0;y=0;z=C;while(1){C=f[x+4+(y<<2)>>2]|0;b[z>>0]=-123;b[z+1>>0]=1;B=z+2|0;b[B>>0]=C;b[B+1>>0]=C>>8;b[B+2>>0]=C>>16;b[B+3>>0]=C>>24;C=z+6|0;y=y+1|0;if((y|0)>=(c|0)){D=C;break}else z=C}}z=f[a+76>>2]|0;if(!z)E=D;else{c=f[a+84>>2]|0;y=0;x=D;while(1){D=f[c+4+(y<<2)>>2]|0;b[x>>0]=-115;b[x+1>>0]=1;C=x+2|0;b[C>>0]=D;b[C+1>>0]=D>>8;b[C+2>>0]=D>>16;b[C+3>>0]=D>>24;D=x+6|0;y=y+1|0;if((y|0)>=(z|0)){E=D;break}else x=D}}x=f[a+4>>2]|0;if(!(x&1)){F=E;return F|0}F=Hjc(x&-2,E)|0;return F|0}function Mcb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Ncb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15912,0)|0;if(!c){Ehc(b,a);return}else{Acb(a,c);return}}function Ocb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Pcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525120;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Qcb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Rcb(a){a=a|0;var b=0,c=0;f[a>>2]=94496;if((a|0)!=521336?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function Scb(a){a=a|0;Rcb(a);YDc(a);return}function Tcb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Ucb(a,b){a=a|0;b=b|0;a=VDc(28)|0;xcb(a);if(!b)return a|0;edb(b,a);return a|0}function Vcb(a){a=a|0;var c=0,d=0;c=a+8|0;d=f[c>>2]|0;if(d&15|0){if(d&1|0){d=f[a+16>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}b[a+20>>0]=1;b[a+21>>0]=1;n[a+24>>2]=1.000000013351432e-10}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Wcb(a){a=a|0;return 1}function Xcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=e+8|0;l=a+16|0;m=e+4|0;n=a+21|0;o=e+8|0;p=a+24|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=WRb(c,w)|0;if((s+-1|0)>>>0<127){t=s;v=6}else x=s}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{if((t&255|0)!=8){x=t;break b}f[i>>2]=f[i>>2]|2;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(a=b[s>>0]|0,a<<24>>24>-1):0){f[c>>2]=s+1;y=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[k>>0]|0)){z=0;v=42;break a}else y=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[j>>0]=y&1;continue a;break}case 2:{if((t&255|0)!=18){x=t;break b}f[i>>2]=f[i>>2]|1;a=f[l>>2]|0;if(!a){s=VDc(48)|0;BWa(s);f[l>>2]=s;A=s}else A=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(s=b[a>>0]|0,s<<24>>24>-1):0){f[c>>2]=a+1;B=s&255}else{s=VRb(c)|0;if((s|0)>-1)B=s;else{z=0;v=42;break a}}GRb(e,c,B);if((f[m>>2]|0)<0){v=22;break a}if(!(Mi[f[(f[A>>2]|0)+44>>2]&1023](A,c)|0)){v=22;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{z=0;v=42;break a}break}case 3:{if((t&255|0)!=24){x=t;break b}f[i>>2]=f[i>>2]|4;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(a=b[s>>0]|0,a<<24>>24>-1):0){f[c>>2]=s+1;C=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[o>>0]|0)){z=0;v=42;break a}else C=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[n>>0]=C&1;continue a;break}case 4:{if((t&255|0)!=37){x=t;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){s=a;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;f[c>>2]=a+4;D=r}else{if(!(TRb(c,e)|0)){v=36;break a}D=f[e>>2]|0}f[p>>2]=D;continue a;break}default:{x=t;break b}}}while(0);if(!x){z=1;v=42;break}r=f[q>>2]|0;if(!(r&1))E=mNa(q)|0;else E=r&-2;if(!(Djc(c,x,E)|0)){z=0;v=42;break}}if((v|0)==22){z=0;u=d;return z|0}else if((v|0)==36){z=0;u=d;return z|0}else if((v|0)==42){u=d;return z|0}return 0}function Ycb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&15)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}b=i&2|0?h+2|0:h;h=i&4|0?b+2|0:b;e=i&8|0?h+5|0:h;g=a+12|0;f[g>>2]=e;return e|0}function Zcb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&2|0)YTb(1,(b[a+20>>0]|0)!=0,c);if(d&1|0)eUb(2,f[a+16>>2]|0,c);if(d&4|0)YTb(3,(b[a+21>>0]|0)!=0,c);if(d&8|0)WTb(4,+n[a+24>>2],c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function _cb(a){a=a|0;return f[a+12>>2]|0}function $cb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=b[a+20>>0]|0;b[d>>0]=8;b[d+1>>0]=h;g=d+2|0}if(!(e&1))i=g;else{d=f[a+16>>2]|0;b[g>>0]=18;h=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(g>>>0>127){j=g;k=h;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=h;o=g}b[n>>0]=o;i=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,n+1|0)|0}if(!(e&4))p=i;else{n=b[a+21>>0]|0;b[i>>0]=24;b[i+1>>0]=n;p=i+2|0}if(!(e&8))q=p;else{e=f[a+24>>2]|0;b[p>>0]=37;i=p+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;q=p+5|0}p=f[a+4>>2]|0;if(!(p&1)){r=q;return r|0}r=Hjc(p&-2,q)|0;return r|0}function adb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function bdb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15928,0)|0;if(!c){Ehc(b,a);return}else{ycb(a,c);return}}function cdb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ddb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525112;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function edb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function fdb(a){a=a|0;var b=0,c=0;f[a>>2]=94604;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function gdb(a){a=a|0;var b=0,c=0;f[a>>2]=94604;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function hdb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function idb(a,b){a=a|0;b=b|0;a=VDc(28)|0;wcb(a);if(!b)return a|0;udb(b,a);return a|0}function jdb(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function kdb(a){a=a|0;return 1}function ldb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=c+4|0;e=a+16|0;g=a+20|0;h=a+24|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;if((l&-8|0)==8){switch((l&255)<<24>>24){case 8:break;case 10:{if(I$a(c,e)|0)continue a;else{p=0;m=29;break a}break}default:{o=l;break b}}k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;q=j}else{r=j;m=11}}else{r=0;m=11}if((m|0)==11){m=0;j=HRb(c,r)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)q=j;else{p=0;m=29;break a}}j=f[e>>2]|0;if((j|0)==(f[g>>2]|0)){OLa(e,j+1|0);s=f[e>>2]|0}else s=j;j=f[h>>2]|0;f[e>>2]=s+1;f[j+4+(s<<2)>>2]=q;k=(f[g>>2]|0)-(f[e>>2]|0)|0;if((k|0)>0){t=k;u=j}else continue a;while(1){j=f[c>>2]|0;k=f[d>>2]|0;if(j>>>0>=k>>>0)continue a;if((b[j>>0]|0)!=8)continue a;a=j+1|0;f[c>>2]=a;if(a>>>0<k>>>0){k=b[a>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+2;v=a;w=u}else{x=a;m=19}}else{x=0;m=19}if((m|0)==19){m=0;a=HRb(c,x)|0;j=J;if(!((j|0)>-1|(j|0)==-1&a>>>0>4294967295)){p=0;m=29;break a}v=a;w=f[h>>2]|0}a=f[e>>2]|0;f[e>>2]=a+1;f[w+4+(a<<2)>>2]=v;if((t|0)>1){t=t+-1|0;u=w}else continue a}}else o=l}while(0);if(!o){p=1;m=29;break}a=f[i>>2]|0;if(!(a&1))y=mNa(i)|0;else y=a&-2;if(!(Djc(c,o,y)|0)){p=0;m=29;break}}if((m|0)==29)return p|0;return 0}function mdb(a){a=a|0;var b=0,c=0,d=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=iUb(a+16|0)|0;d=b+c+(f[a+16>>2]|0)|0;f[a+12>>2]=d;return d|0}function ndb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+16>>2]|0;if((c|0)>0){d=a+24|0;e=0;do{OTb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function odb(a){a=a|0;return f[a+12>>2]|0}function pdb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+16>>2]|0;if(!c)e=d;else{g=f[a+24>>2]|0;h=0;i=d;while(1){d=f[g+4+(h<<2)>>2]|0;b[i>>0]=8;j=i+1|0;if(d>>>0>127){k=d;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=d}b[o>>0]=p;l=o+1|0;h=h+1|0;if((h|0)>=(c|0)){e=l;break}else i=l}}i=f[a+4>>2]|0;if(!(i&1)){q=e;return q|0}q=Hjc(i&-2,e)|0;return q|0}function qdb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function rdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15944,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=c+16|0;e=f[g>>2]|0;if(!e)return;OLa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);return}function sdb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function tdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525104;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function udb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function vdb(a){a=a|0;var b=0,c=0;f[a>>2]=94712;if((a|0)!=521496){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function wdb(a){a=a|0;vdb(a);YDc(a);return}function xdb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function ydb(a,b){a=a|0;b=b|0;a=VDc(52)|0;ucb(a);if(!b)return a|0;Kdb(b,a);return a|0}function zdb(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+16>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&2|0){e=f[a+20>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d&252|0){e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[a+40>>2]=-1;f[a+44>>2]=1}if(d&768|0){b[a+48>>0]=1;b[a+49>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Adb(a){a=a|0;return 1}function Bdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+24|0;k=a+48|0;l=e+8|0;m=a+28|0;n=a+16|0;o=e+4|0;p=a+20|0;q=e+4|0;r=a+44|0;s=a+4|0;t=a+40|0;v=a+32|0;w=e+8|0;x=a+36|0;y=a+49|0;a=e+8|0;a:while(1){z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=z+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=WRb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;do switch(C>>>3&536870911|0){case 1:{if((C&255|0)!=8){F=C;break b}f[i>>2]=f[i>>2]|4;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0){z=b[B>>0]|0;A=z&255;if(z<<24>>24>-1){f[j>>2]=A;f[c>>2]=B+1;continue a}else G=A}else G=0;A=HRb(c,G)|0;B=J;f[j>>2]=A;if((B|0)>-1|(B|0)==-1&A>>>0>4294967295)continue a;else{H=0;D=87;break a}break}case 2:{if((C&255|0)!=16){F=C;break b}f[i>>2]=f[i>>2]|256;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){f[c>>2]=A+1;I=B<<24>>24!=0}else{IRb(e,c);B=e;if(!(b[l>>0]|0)){H=0;D=87;break a}else I=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0}b[k>>0]=I&1;continue a;break}case 3:{if((C&255|0)!=24){F=C;break b}f[i>>2]=f[i>>2]|8;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0){A=b[B>>0]|0;z=A&255;if(A<<24>>24>-1){f[c>>2]=B+1;K=z}else{L=z;D=22}}else{L=0;D=22}if((D|0)==22){D=0;z=HRb(c,L)|0;B=J;if((B|0)>-1|(B|0)==-1&z>>>0>4294967295)K=z;else{H=0;D=87;break a}}f[m>>2]=K;continue a;break}case 4:{if((C&255|0)!=34){F=C;break b}f[i>>2]=f[i>>2]|1;z=f[n>>2]|0;if(!z){B=VDc(28)|0;cbb(B);f[n>>2]=B;M=B}else M=z;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(B=b[z>>0]|0,B<<24>>24>-1):0){f[c>>2]=z+1;N=B&255}else{B=VRb(c)|0;if((B|0)>-1)N=B;else{H=0;D=87;break a}}GRb(e,c,N);if((f[o>>2]|0)<0){D=33;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){D=33;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{H=0;D=87;break a}break}case 5:{if((C&255|0)!=42){F=C;break b}f[i>>2]=f[i>>2]|2;B=f[p>>2]|0;if(!B){z=VDc(40)|0;Mab(z);f[p>>2]=z;O=z}else O=B;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(z=b[B>>0]|0,z<<24>>24>-1):0){f[c>>2]=B+1;P=z&255}else{z=VRb(c)|0;if((z|0)>-1)P=z;else{H=0;D=87;break a}}GRb(e,c,P);if((f[q>>2]|0)<0){D=44;break a}if(!(Mi[f[(f[O>>2]|0)+44>>2]&1023](O,c)|0)){D=44;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{H=0;D=87;break a}break}case 6:{if((C&255|0)!=48){F=C;break b}z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){B=b[z>>0]|0;A=B&255;if(B<<24>>24>-1){f[c>>2]=z+1;Q=A}else{R=A;D=50}}else{R=0;D=50}if((D|0)==50){D=0;A=HRb(c,R)|0;z=J;if((z|0)>-1|(z|0)==-1&A>>>0>4294967295)Q=A;else{H=0;D=87;break a}}if((Q+-1|0)>>>0<2){f[i>>2]=f[i>>2]|128;f[r>>2]=Q;continue a}A=f[s>>2]|0;if(!(A&1))S=mNa(s)|0;else S=A&-2;rjc(S,6,Q,((Q|0)<0)<<31>>31);continue a;break}case 7:{if((C&255|0)!=56){F=C;break b}f[i>>2]=f[i>>2]|64;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){z=b[A>>0]|0;B=z&255;if(z<<24>>24>-1){f[c>>2]=A+1;T=B}else{U=B;D=61}}else{U=0;D=61}if((D|0)==61){D=0;B=HRb(c,U)|0;A=J;if((A|0)>-1|(A|0)==-1&B>>>0>4294967295)T=B;else{H=0;D=87;break a}}f[t>>2]=T;continue a;break}case 8:{if((C&255|0)!=64){F=C;break b}f[i>>2]=f[i>>2]|16;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(A=b[B>>0]|0,A<<24>>24>-1):0){f[c>>2]=B+1;V=A<<24>>24!=0}else{IRb(e,c);A=e;if(!(b[w>>0]|0)){H=0;D=87;break a}else V=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0}b[v>>0]=V&1;continue a;break}case 9:{if((C&255|0)!=77){F=C;break b}f[i>>2]=f[i>>2]|32;A=f[c>>2]|0;if(((f[g>>2]|0)-A|0)>3){B=A;z=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[e>>2]=z;f[c>>2]=A+4;W=z}else{if(!(TRb(c,e)|0)){D=75;break a}W=f[e>>2]|0}f[x>>2]=W;continue a;break}case 10:{if((C&255|0)!=80){F=C;break b}f[i>>2]=f[i>>2]|512;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(A=b[z>>0]|0,A<<24>>24>-1):0){f[c>>2]=z+1;X=A<<24>>24!=0}else{IRb(e,c);A=e;if(!(b[a>>0]|0)){H=0;D=87;break a}else X=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0}b[y>>0]=X&1;continue a;break}default:{F=C;break b}}while(0)}while(0);if(!F){H=1;D=87;break}A=f[s>>2]|0;if(!(A&1))Y=mNa(s)|0;else Y=A&-2;if(!(Djc(c,F,Y)|0)){H=0;D=87;break}}if((D|0)==33){H=0;u=d;return H|0}else if((D|0)==44){H=0;u=d;return H|0}else if((D|0)==75){H=0;u=d;return H|0}else if((D|0)==87){u=d;return H|0}return 0}function Cdb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(d&255){if(!(d&1)){e=c;g=d}else{h=f[a+16>>2]|0;i=_i[f[(f[h>>2]|0)+48>>2]&1023](h)|0;h=c+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=h;g=f[b>>2]|0}if(!(g&2)){j=e;k=g}else{g=f[a+20>>2]|0;h=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;g=e+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=g;k=f[b>>2]|0}if(!(k&4))l=j;else l=j+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(k&8))m=l;else{j=f[a+28>>2]|0;if((j|0)<0)n=11;else n=((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;m=n+l|0}l=k&16|0?m+2|0:m;m=k&32|0?l+5|0:l;if(!(k&64))o=m;else{l=f[a+40>>2]|0;if((l|0)<0)p=11;else p=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;o=p+m|0}if(!(k&128)){q=o;r=k}else{m=f[a+44>>2]|0;if((m|0)<0)s=11;else s=((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;q=s+o|0;r=k}}else{q=c;r=d}if(!(r&768)){t=q;u=a+12|0;f[u>>2]=t;return t|0}d=r&256|0?q+2|0:q;t=r&512|0?d+2|0:d;u=a+12|0;f[u>>2]=t;return t|0}function Ddb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&4|0)OTb(1,f[a+24>>2]|0,c);if(d&256|0)YTb(2,(b[a+48>>0]|0)!=0,c);if(d&8|0)MTb(3,f[a+28>>2]|0,c);if(d&1|0)eUb(4,f[a+16>>2]|0,c);if(d&2|0)eUb(5,f[a+20>>2]|0,c);if(d&128|0)ZTb(6,f[a+44>>2]|0,c);if(d&64|0)MTb(7,f[a+40>>2]|0,c);if(d&16|0)YTb(8,(b[a+32>>0]|0)!=0,c);if(d&32|0)WTb(9,+n[a+36>>2],c);if(d&512|0)YTb(10,(b[a+49>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Edb(a){a=a|0;return f[a+12>>2]|0}function Fdb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&256))o=g;else{m=b[a+48>>0]|0;b[g>>0]=16;b[g+1>>0]=m;o=g+2|0}if(!(e&8))p=o;else{g=f[a+28>>2]|0;b[o>>0]=24;m=o+1|0;o=g&255;if(g>>>0>127){n=m;h=o;i=g;j=((g|0)<0)<<31>>31;while(1){b[n>>0]=h|-128;g=i;i=aJc(i|0,j|0,7)|0;d=n+1|0;k=i&255;if(!(j>>>0>0|(j|0)==0&g>>>0>16383)){q=d;r=k;break}else{n=d;h=k;j=J}}}else{q=m;r=o}b[q>>0]=r;p=q+1|0}if(!(e&1))s=p;else{q=f[a+16>>2]|0;b[p>>0]=34;r=p+1|0;p=_i[f[(f[q>>2]|0)+60>>2]&1023](q)|0;if(p>>>0>127){o=p;m=r;while(1){b[m>>0]=o|128;j=o>>>7;h=m+1|0;if(o>>>0>16383){o=j;m=h}else{t=h;u=j;break}}}else{t=r;u=p}b[t>>0]=u;s=hj[f[(f[q>>2]|0)+64>>2]&511](q,c,t+1|0)|0}if(!(e&2))v=s;else{t=f[a+20>>2]|0;b[s>>0]=42;q=s+1|0;s=_i[f[(f[t>>2]|0)+60>>2]&1023](t)|0;if(s>>>0>127){u=s;p=q;while(1){b[p>>0]=u|128;r=u>>>7;m=p+1|0;if(u>>>0>16383){u=r;p=m}else{w=m;x=r;break}}}else{w=q;x=s}b[w>>0]=x;v=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,w+1|0)|0}if(!(e&128))y=v;else{w=f[a+44>>2]|0;b[v>>0]=48;c=v+1|0;v=w&255;if(w>>>0>127){t=c;x=w;s=((w|0)<0)<<31>>31;w=v;while(1){b[t>>0]=w|-128;q=x;x=aJc(x|0,s|0,7)|0;p=t+1|0;u=x&255;if(!(s>>>0>0|(s|0)==0&q>>>0>16383)){z=p;A=u;break}else{t=p;s=J;w=u}}}else{z=c;A=v}b[z>>0]=A;y=z+1|0}if(!(e&64))B=y;else{z=f[a+40>>2]|0;b[y>>0]=56;A=y+1|0;y=z&255;if(z>>>0>127){v=A;c=y;w=z;s=((z|0)<0)<<31>>31;while(1){b[v>>0]=c|-128;z=w;w=aJc(w|0,s|0,7)|0;t=v+1|0;x=w&255;if(!(s>>>0>0|(s|0)==0&z>>>0>16383)){C=t;D=x;break}else{v=t;c=x;s=J}}}else{C=A;D=y}b[C>>0]=D;B=C+1|0}if(!(e&16))E=B;else{C=b[a+32>>0]|0;b[B>>0]=64;b[B+1>>0]=C;E=B+2|0}if(!(e&32))F=E;else{B=f[a+36>>2]|0;b[E>>0]=77;C=E+1|0;b[C>>0]=B;b[C+1>>0]=B>>8;b[C+2>>0]=B>>16;b[C+3>>0]=B>>24;F=E+5|0}if(!(e&512))G=F;else{e=b[a+49>>0]|0;b[F>>0]=80;b[F+1>>0]=e;G=F+2|0}F=f[a+4>>2]|0;if(!(F&1)){H=G;return H|0}H=Hjc(F&-2,G)|0;return H|0}function Gdb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Hdb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15960,0)|0;if(!c){Ehc(b,a);return}else{vcb(a,c);return}}function Idb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Jdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525128;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Kdb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Ldb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94820;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=522144?(f[220377]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=40;b[d+8>>0]=0;DTb(881508,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=0;n[a+24>>2]=1.0;n[a+28>>2]=1.0;u=c;return}function Mdb(a,b){a=a|0;b=b|0;Ndb(b,a);return}function Ndb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&15))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];if(d&8|0)f[a+28>>2]=f[b+28>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Odb(a){a=a|0;var c=0,d=0;f[a>>2]=94820;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function Pdb(a){a=a|0;Odb(a);YDc(a);return}function Qdb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Rdb(a,b){a=a|0;b=b|0;a=VDc(32)|0;Ldb(a);if(!b)return a|0;beb(b,a);return a|0}function Sdb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&14|0){f[a+20>>2]=0;n[a+24>>2]=1.0;n[a+28>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Tdb(a){a=a|0;return 1}function Udb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+24|0;l=a+28|0;m=a+4|0;n=a+20|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=a+1;q=p;r=7}else{s=p;r=6}}else{s=0;r=6}if((r|0)==6){r=0;p=WRb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=7}else t=p}c:do if((r|0)==7){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=10){t=q;break c}f[i>>2]=f[i>>2]|1;p=f[j>>2]|0;if((p|0)==527320){GLa(j,527320);v=f[j>>2]|0}else v=p;if(fUb(c,v)|0)continue b;else{w=0;r=42;break a}break}case 2:{if((q&255|0)==16)break b;else{t=q;break c}break}case 3:{if((q&255|0)!=29){t=q;break c}f[i>>2]=f[i>>2]|4;p=f[c>>2]|0;if(((f[g>>2]|0)-p|0)>3){a=p;o=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=o;f[c>>2]=p+4;x=o}else{if(!(TRb(c,e)|0)){r=29;break a}x=f[e>>2]|0}f[k>>2]=x;continue b;break}case 4:{if((q&255|0)!=37){t=q;break c}f[i>>2]=f[i>>2]|8;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){p=o;a=h[p>>0]|h[p+1>>0]<<8|h[p+2>>0]<<16|h[p+3>>0]<<24;f[e>>2]=a;f[c>>2]=o+4;y=a}else{if(!(TRb(c,e)|0)){r=36;break a}y=f[e>>2]|0}f[l>>2]=y;continue b;break}default:{t=q;break c}}}while(0);if(!t){w=1;r=42;break a}a=f[m>>2]|0;if(!(a&1))z=mNa(m)|0;else z=a&-2;if(!(Djc(c,t,z)|0)){w=0;r=42;break a}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>-1){f[c>>2]=a+1;A=p}else{B=p;r=16}}else{B=0;r=16}if((r|0)==16){r=0;p=HRb(c,B)|0;a=J;if((a|0)>-1|(a|0)==-1&p>>>0>4294967295)A=p;else{w=0;r=42;break}}if(A>>>0<2){f[i>>2]=f[i>>2]|2;f[n>>2]=A;continue}p=f[m>>2]|0;if(!(p&1))C=mNa(m)|0;else C=p&-2;rjc(C,2,A,((A|0)<0)<<31>>31)}if((r|0)==29){w=0;u=d;return w|0}else if((r|0)==36){w=0;u=d;return w|0}else if((r|0)==42){u=d;return w|0}return 0}function Vdb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&15)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else{k=f[a+20>>2]|0;if((k|0)<0)m=11;else m=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+h|0}h=c&4|0?l+5|0:l;e=c&8|0?h+5|0:h;g=a+12|0;f[g>>2]=e;return e|0}function Wdb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&2|0)ZTb(2,f[a+20>>2]|0,b);if(c&4|0)WTb(3,+n[a+24>>2],b);if(c&8|0)WTb(4,+n[a+28>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Xdb(a){a=a|0;return f[a+12>>2]|0}function Ydb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=16;g=e+1|0;e=d&255;if(d>>>0>127){i=g;j=e;k=d;l=((d|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;d=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&d>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=g;p=e}b[o>>0]=p;h=o+1|0}if(!(c&4))q=h;else{o=f[a+24>>2]|0;b[h>>0]=29;p=h+1|0;b[p>>0]=o;b[p+1>>0]=o>>8;b[p+2>>0]=o>>16;b[p+3>>0]=o>>24;q=h+5|0}if(!(c&8))r=q;else{c=f[a+28>>2]|0;b[q>>0]=37;h=q+1|0;b[h>>0]=c;b[h+1>>0]=c>>8;b[h+2>>0]=c>>16;b[h+3>>0]=c>>24;r=q+5|0}q=f[a+4>>2]|0;if(!(q&1)){s=r;return s|0}s=Hjc(q&-2,r)|0;return s|0}function Zdb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function _db(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,15976,0)|0;if(!c){Ehc(b,a);return}else{Ndb(a,c);return}}function $db(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function aeb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525192;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function beb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function ceb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=a+4|0;if(g>>>0<(f[h>>2]|0)>>>0?(i=b[g>>0]|0,i<<24>>24>-1):0){f[a>>2]=g+1;j=i&255}else{i=VRb(a)|0;if((i|0)>-1)j=i;else{k=0;u=d;return k|0}}i=ERb(a,j)|0;a:do if((MRb(a)|0)>0){j=c+4|0;g=c+8|0;l=e+8|0;while(1){m=f[a>>2]|0;if(m>>>0<(f[h>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[a>>2]=m+1;o=n<<24>>24!=0}else{IRb(e,a);n=e;if(!(b[l>>0]|0)){k=0;break}else o=(f[n>>2]|0)!=0|(f[n+4>>2]|0)!=0}n=f[c>>2]|0;if((n|0)==(f[j>>2]|0)){zNa(c,n+1|0);p=f[c>>2]|0}else p=n;n=f[g>>2]|0;f[c>>2]=p+1;b[n+4+p>>0]=o&1;if((MRb(a)|0)<=0)break a}u=d;return k|0}while(0);FRb(a,i);k=1;u=d;return k|0}function deb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94280;XIc(a+4|0,0,132)|0;if((a|0)!=522176?(f[220378]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=41;b[d+8>>0]=0;DTb(881512,d);ZSb(d)}f[a+136>>2]=527320;f[a+140>>2]=527320;XIc(a+144|0,0,224)|0;u=c;return}function eeb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function feb(a){a=a|0;var c=0;c=f[a+136>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+140>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==522176)return;c=f[a+144>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+148>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+152>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+156>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+160>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+164>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+168>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+172>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+176>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+180>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+184>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+188>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+192>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+196>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+200>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+204>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+208>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+212>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+216>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+220>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+224>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+228>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+232>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+236>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+240>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+244>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+248>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+252>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+256>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+260>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+264>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+268>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+272>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+276>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+280>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+284>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+288>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+292>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+296>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+300>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+304>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+308>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+312>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+316>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+320>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+324>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+328>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+332>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+336>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+340>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+344>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+348>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+352>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+356>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function geb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=94928;c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[c>>2]=0;return}function heb(a){a=a|0;geb(a);YDc(a);return}function ieb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function jeb(a,b){a=a|0;b=b|0;a=VDc(40)|0;veb(a);if(!b)return a|0;web(b,a);return a|0}function keb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;if(f[c>>2]&3|0){f[a+32>>2]=0;f[a+36>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function leb(a){a=a|0;return 1}function meb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=a+8|0;g=a+32|0;h=a+16|0;i=a+4|0;j=a+36|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=7}else{o=l;n=6}}else{o=0;n=6}if((n|0)==6){n=0;l=WRb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=7}else p=l}c:do if((n|0)==7){n=0;switch(m>>>3&536870911|0){case 1:{if((m&255|0)==8)break b;else{p=m;break c}break}case 2:{if((m&255|0)!=16){p=m;break c}f[e>>2]=f[e>>2]|1;l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){a=b[l>>0]|0;k=a&255;if(a<<24>>24>-1){f[c>>2]=l+1;q=k}else{r=k;n=23}}else{r=0;n=23}if((n|0)==23){n=0;k=HRb(c,r)|0;l=J;if((l|0)>-1|(l|0)==-1&k>>>0>4294967295)q=k;else{s=0;n=32;break a}}f[g>>2]=q;continue b;break}case 3:{if((m&255|0)!=26){p=m;break c}if(fUb(c,JLa(h)|0)|0)continue b;else{s=0;n=32;break a}break}default:{p=m;break c}}}while(0);if(!p){s=1;n=32;break a}k=f[i>>2]|0;if(!(k&1))t=mNa(i)|0;else t=k&-2;if(!(Djc(c,p,t)|0)){s=0;n=32;break a}}k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){l=b[k>>0]|0;a=l&255;if(l<<24>>24>-1){f[c>>2]=k+1;u=a}else{v=a;n=12}}else{v=0;n=12}if((n|0)==12){n=0;a=HRb(c,v)|0;k=J;if((k|0)>-1|(k|0)==-1&a>>>0>4294967295)u=a;else{s=0;n=32;break}}if(u>>>0<2){f[e>>2]=f[e>>2]|2;f[j>>2]=u;continue}a=f[i>>2]|0;if(!(a&1))w=mNa(i)|0;else w=a&-2;rjc(w,1,u,((u|0)<0)<<31>>31)}if((n|0)==32)return s|0;return 0}function neb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+8>>2]|0;if(!(e&3)){m=l;n=a+12|0;f[n>>2]=m;return m|0}if(!(e&1))o=l;else{h=f[a+32>>2]|0;if((h|0)<0)p=11;else p=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;o=p+l|0}if(!(e&2)){m=o;n=a+12|0;f[n>>2]=m;return m|0}e=f[a+36>>2]|0;if((e|0)<0)q=11;else q=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;m=q+o|0;n=a+12|0;f[n>>2]=m;return m|0}function oeb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+8>>2]|0;if(c&2|0)ZTb(1,f[a+36>>2]|0,b);if(c&1|0)MTb(2,f[a+32>>2]|0,b);c=f[a+20>>2]|0;if((c|0)>0){d=a+28|0;e=0;do{_Tb(3,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function peb(a){a=a|0;return f[a+12>>2]|0}function qeb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+36>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&1))q=e;else{c=f[a+32>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=aJc(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+20>>2]|0;if((r|0)>0){s=a+28|0;e=0;o=q;while(1){l=f[(f[s>>2]|0)+4+(e<<2)>>2]|0;b[o>>0]=26;d=dSb(l,o+1|0)|0;e=e+1|0;if((e|0)==(r|0)){t=d;break}else o=d}}else t=q;q=f[a+4>>2]|0;if(!(q&1)){u=t;return u|0}u=Hjc(q&-2,t)|0;return u|0}function reb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function seb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,15992,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}yNa(a+16|0,c+16|0);d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+32>>2]=f[c+32>>2];if(d&2|0)f[a+36>>2]=f[c+36>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function teb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ueb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525176;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function veb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=94928;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=522040?(f[220375]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=38;b[d+8>>0]=0;DTb(881500,d);ZSb(d)}f[a+12>>2]=0;f[a+32>>2]=0;f[a+36>>2]=1;u=c;return}function web(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function xeb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=95036;c=f[a+32>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[c>>2]=0;return}function yeb(a){a=a|0;xeb(a);YDc(a);return}function zeb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Aeb(a,b){a=a|0;b=b|0;a=VDc(44)|0;Neb(a);if(!b)return a|0;Oeb(b,a);return a|0}function Beb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&1|0){g=f[a+32>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&6|0){d=a+36|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Ceb(a){a=a|0;return 1}function Deb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+36|0;j=a+32|0;k=a+16|0;l=e+4|0;m=a+40|0;n=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=a+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=WRb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=8){t=q;break b}f[h>>2]=f[h>>2]|2;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){a=b[p>>0]|0;o=a&255;if(a<<24>>24>-1){f[c>>2]=p+1;v=o}else{w=o;r=11}}else{w=0;r=11}if((r|0)==11){r=0;o=HRb(c,w)|0;p=J;if((p|0)>-1|(p|0)==-1&o>>>0>4294967295)v=o;else{x=0;r=37;break a}}f[i>>2]=v;continue a;break}case 2:{if((q&255|0)!=18){t=q;break b}f[h>>2]=f[h>>2]|1;o=f[j>>2]|0;if((o|0)==527320){GLa(j,527320);y=f[j>>2]|0}else y=o;if(fUb(c,y)|0)continue a;else{x=0;r=37;break a}break}case 3:{if((q&255|0)!=26){t=q;break b}o=AXa(k)|0;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(a=b[p>>0]|0,a<<24>>24>-1):0){f[c>>2]=p+1;z=a&255}else{a=VRb(c)|0;if((a|0)>-1)z=a;else{x=0;r=37;break a}}GRb(e,c,z);if((f[l>>2]|0)<0){r=24;break a}if(!(Mi[f[(f[o>>2]|0)+44>>2]&1023](o,c)|0)){r=24;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{x=0;r=37;break a}break}case 4:{if((q&255|0)!=32){t=q;break b}f[h>>2]=f[h>>2]|4;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;p=a&255;if(a<<24>>24>-1){f[c>>2]=o+1;A=p}else{B=p;r=30}}else{B=0;r=30}if((r|0)==30){r=0;p=HRb(c,B)|0;o=J;if((o|0)>-1|(o|0)==-1&p>>>0>4294967295)A=p;else{x=0;r=37;break a}}f[m>>2]=A;continue a;break}default:{t=q;break b}}}while(0);if(!t){x=1;r=37;break}p=f[n>>2]|0;if(!(p&1))C=mNa(n)|0;else C=p&-2;if(!(Djc(c,t,C)|0)){x=0;r=37;break}}if((r|0)==24){x=0;u=d;return x|0}else if((r|0)==37){u=d;return x|0}return 0}function Eeb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+8>>2]|0;if(!(i&7)){k=g;l=a+12|0;f[l>>2]=k;return k|0}if(!(i&1))m=g;else{c=f[a+32>>2]|0;h=b[c+11>>0]|0;d=h<<24>>24<0?f[c+4>>2]|0:h&255;m=g+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2))n=m;else{d=f[a+36>>2]|0;if((d|0)<0)o=11;else o=((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=o+m|0}if(!(i&4)){k=n;l=a+12|0;f[l>>2]=k;return k|0}i=f[a+40>>2]|0;if((i|0)<0)p=11;else p=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=p+n|0;l=a+12|0;f[l>>2]=k;return k|0}function Feb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&2|0)MTb(1,f[a+36>>2]|0,b);if(c&1|0)$Tb(2,f[a+32>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{eUb(3,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&4|0)MTb(4,f[a+40>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Geb(a){a=a|0;return f[a+12>>2]|0}function Heb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=f[a+36>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=aJc(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&1))r=g;else{p=f[a+32>>2]|0;b[g>>0]=18;r=dSb(p,g+1|0)|0}g=f[a+20>>2]|0;if(!g)s=r;else{p=a+28|0;q=0;d=r;while(1){r=f[(f[p>>2]|0)+4+(q<<2)>>2]|0;b[d>>0]=26;i=d+1|0;m=_i[f[(f[r>>2]|0)+60>>2]&1023](r)|0;if(m>>>0>127){k=m;j=i;while(1){b[j>>0]=k|128;l=k>>>7;o=j+1|0;if(k>>>0>16383){k=l;j=o}else{t=o;u=l;break}}}else{t=i;u=m}b[t>>0]=u;j=hj[f[(f[r>>2]|0)+64>>2]&511](r,c,t+1|0)|0;q=q+1|0;if((q|0)==(g|0)){s=j;break}else d=j}}if(!(e&4))v=s;else{e=f[a+40>>2]|0;b[s>>0]=32;d=s+1|0;s=e&255;if(e>>>0>127){g=d;q=s;t=e;c=((e|0)<0)<<31>>31;while(1){b[g>>0]=q|-128;e=t;t=aJc(t|0,c|0,7)|0;u=g+1|0;p=t&255;if(!(c>>>0>0|(c|0)==0&e>>>0>16383)){w=u;x=p;break}else{g=u;q=p;c=J}}}else{w=d;x=s}b[w>>0]=x;v=w+1|0}w=f[a+4>>2]|0;if(!(w&1)){y=v;return y|0}y=Hjc(w&-2,v)|0;return y|0}function Ieb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Jeb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16008,0)|0;if(!c){Ehc(b,a);return}else{Meb(a,c);return}}function Keb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Leb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525168;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Meb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}PLa(a+16|0,b+16|0);d=f[b+8>>2]|0;if(!(d&7))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+32|0,e=f[b+32>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(d&2|0)f[a+36>>2]=f[b+36>>2];if(d&4|0)f[a+40>>2]=f[b+40>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Neb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=95036;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=521992?(f[220374]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=37;b[d+8>>0]=0;DTb(881496,d);ZSb(d)}f[a+12>>2]=0;f[a+32>>2]=527320;d=a+36|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function Oeb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Peb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=95144;Ifb(a);c=f[a+84>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+72|0;d=f[c>>2]|0;if(d|0?(f[a+60>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+56|0;i=f[c>>2]|0;if(i|0?(f[a+44>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+28|0;j=f[c>>2]|0;if(j|0?(f[a+16>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(k);f[c>>2]=0;return}function Qeb(a){a=a|0;Peb(a);YDc(a);return}function Reb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Seb(a,b){a=a|0;b=b|0;a=VDc(232)|0;Gfb(a);if(!b)return a|0;Hfb(b,a);return a|0}function Teb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+32>>2]=0;c=a+48|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+56>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((e|0)!=(d|0));f[c>>2]=0}c=a+64|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+72>>2]|0;g=0;do{i=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((g|0)!=(d|0));f[c>>2]=0}f[a+76>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){do if(d&1|0){g=f[a+88>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+92>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+96>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&8|0){e=f[a+100>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&16|0)iEc(f[a+104>>2]|0,525016)|0;if(d&32|0)iEc(f[a+108>>2]|0,525032)|0;if(d&64|0){g=f[a+112>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&128|0){g=f[a+116>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}}if(d&256|0){g=f[a+120>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&65024|0){g=a+124|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0}if(d&16711680|0){g=a+152|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0}if(d>>>0>16777215){n[a+176>>2]=.9990000128746033;d=a+184|0;f[d>>2]=-1;f[d+4>>2]=-1;f[a+192>>2]=1;b[a+196>>0]=1;b[a+197>>0]=1;n[a+200>>2]=9.99999993922529e-09;f[a+204>>2]=1;n[a+208>>2]=-1.0}if(f[a+12>>2]&7|0){f[a+212>>2]=1;f[a+216>>2]=1;n[a+220>>2]=.9900000095367432}d=c;f[d>>2]=0;f[d+4>>2]=0;d=f[a+4>>2]|0;if(!(d&1))return;a=d&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Ueb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=a+56|0;c=f[a+48>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=10;break}}if((g|0)==10)return e|0;g=a+8|0;c=f[g>>2]|0;do if(c&64){b=f[a+112>>2]|0;if(_i[f[(f[b>>2]|0)+32>>2]&1023](b)|0){h=f[g>>2]|0;break}else{e=0;return e|0}}else h=c;while(0);if(h&128|0?(h=f[a+116>>2]|0,!(_i[f[(f[h>>2]|0)+32>>2]&1023](h)|0)):0){e=0;return e|0}e=1;return e|0}function Veb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+88|0;k=a+16|0;l=a+32|0;m=a+36|0;n=a+40|0;o=a+124|0;p=a+128|0;q=a+132|0;r=a+136|0;s=a+92|0;t=a+140|0;v=a+144|0;w=a+148|0;x=a+152|0;y=a+156|0;z=a+160|0;A=a+96|0;B=a+169|0;C=e+8|0;D=a+192|0;E=a+4|0;F=a+164|0;G=a+168|0;H=e+8|0;I=a+184|0;K=e+8|0;L=a+112|0;M=e+4|0;N=a+44|0;O=a+56|0;P=a+52|0;Q=a+48|0;R=e+4|0;S=a+170|0;T=e+8|0;U=a+100|0;V=a+116|0;W=e+4|0;X=a+120|0;Y=e+4|0;Z=a+60|0;_=a+72|0;$=a+68|0;aa=a+64|0;ba=e+4|0;ca=a+197|0;da=e+8|0;ea=a+104|0;fa=a+172|0;ga=a+200|0;ha=a+196|0;ia=e+8|0;ja=a+204|0;ka=a+76|0;la=a+80|0;ma=a+84|0;na=a+208|0;oa=a+12|0;pa=a+212|0;qa=a+216|0;ra=a+220|0;sa=a+176|0;ta=a+108|0;a:while(1){a=f[c>>2]|0;ua=f[g>>2]|0;do if(a>>>0<ua>>>0){va=b[a>>0]|0;wa=va&255;xa=a+1|0;if(va<<24>>24>0){ya=xa;za=wa}else{if(xa>>>0>=ua>>>0){Aa=wa;Ba=7;break}va=h[xa>>0]|0;if(((va^128)&wa)>>>0<=127){Aa=wa;Ba=7;break}ya=a+2|0;za=wa+-128+(va<<7)|0}f[c>>2]=ya;Ca=za;Ba=9}else{Aa=0;Ba=7}while(0);if((Ba|0)==7){Ba=0;a=WRb(c,Aa)|0;if((a+-1|0)>>>0<16383){Ca=a;Ba=9}else Da=a}b:do if((Ba|0)==9){Ba=0;do switch(Ca>>>3&536870911|0){case 1:{if((Ca&255|0)!=10){Da=Ca;break b}f[i>>2]=f[i>>2]|1;a=f[j>>2]|0;if((a|0)==527320){GLa(j,527320);Ea=f[j>>2]|0}else Ea=a;if(fUb(c,Ea)|0)continue a;else{Fa=0;Ba=331;break a}break}case 2:{if((Ca&255|0)!=18){Da=Ca;break b}if(fUb(c,JLa(k)|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 3:{switch((Ca&255)<<24>>24){case 24:break;case 26:{if(Afb(c,l)|0)continue a;else{Fa=0;Ba=331;break a}break}default:{Da=Ca;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){ua=b[a>>0]|0;va=ua&255;if(ua<<24>>24>-1){f[c>>2]=a+1;Ga=va}else{Ha=va;Ba=20}}else{Ha=0;Ba=20}if((Ba|0)==20){Ba=0;va=HRb(c,Ha)|0;a=J;if((a|0)>-1|(a|0)==-1&va>>>0>4294967295)Ga=va;else{Fa=0;Ba=331;break a}}va=f[l>>2]|0;if((va|0)==(f[m>>2]|0)){KLa(l,va+1|0);Ia=f[l>>2]|0}else Ia=va;va=f[n>>2]|0;f[l>>2]=Ia+1;f[va+4+(Ia<<2)>>2]=Ga;a=(f[m>>2]|0)-(f[l>>2]|0)|0;if((a|0)>0){Ja=a;Ka=va}else continue a;while(1){va=f[c>>2]|0;a=f[g>>2]|0;if(va>>>0>=a>>>0)continue a;if((b[va>>0]|0)!=24)continue a;ua=va+1|0;f[c>>2]=ua;if(ua>>>0<a>>>0){a=b[ua>>0]|0;ua=a&255;if(a<<24>>24>-1){f[c>>2]=va+2;La=ua;Ma=Ka}else{Na=ua;Ba=28}}else{Na=0;Ba=28}if((Ba|0)==28){Ba=0;ua=HRb(c,Na)|0;va=J;if(!((va|0)>-1|(va|0)==-1&ua>>>0>4294967295)){Fa=0;Ba=331;break a}La=ua;Ma=f[n>>2]|0}ua=f[l>>2]|0;f[l>>2]=ua+1;f[Ma+4+(ua<<2)>>2]=La;if((Ja|0)>1){Ja=Ja+-1|0;Ka=Ma}else continue a}break}case 4:{if((Ca&255|0)!=32){Da=Ca;break b}f[i>>2]=f[i>>2]|512;ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){va=b[ua>>0]|0;a=va&255;if(va<<24>>24>-1){f[c>>2]=ua+1;Oa=a}else{Pa=a;Ba=37}}else{Pa=0;Ba=37}if((Ba|0)==37){Ba=0;a=HRb(c,Pa)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&a>>>0>4294967295)Oa=a;else{Fa=0;Ba=331;break a}}f[o>>2]=Oa;continue a;break}case 5:{if((Ca&255|0)!=45){Da=Ca;break b}f[i>>2]=f[i>>2]|1024;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){ua=a;va=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=va;f[c>>2]=a+4;Qa=va}else{if(!(TRb(c,e)|0)){Ba=45;break a}Qa=f[e>>2]|0}f[p>>2]=Qa;continue a;break}case 6:{if((Ca&255|0)!=48){Da=Ca;break b}f[i>>2]=f[i>>2]|2048;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){a=b[va>>0]|0;ua=a&255;if(a<<24>>24>-1){f[c>>2]=va+1;Ra=ua}else{Sa=ua;Ba=50}}else{Sa=0;Ba=50}if((Ba|0)==50){Ba=0;ua=HRb(c,Sa)|0;va=J;if((va|0)>-1|(va|0)==-1&ua>>>0>4294967295)Ra=ua;else{Fa=0;Ba=331;break a}}f[q>>2]=Ra;continue a;break}case 7:{if((Ca&255|0)!=56){Da=Ca;break b}f[i>>2]=f[i>>2]|4096;ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){va=b[ua>>0]|0;a=va&255;if(va<<24>>24>-1){f[c>>2]=ua+1;Ta=a}else{Ua=a;Ba=56}}else{Ua=0;Ba=56}if((Ba|0)==56){Ba=0;a=HRb(c,Ua)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&a>>>0>4294967295)Ta=a;else{Fa=0;Ba=331;break a}}f[r>>2]=Ta;continue a;break}case 8:{if((Ca&255|0)!=66){Da=Ca;break b}f[i>>2]=f[i>>2]|2;a=f[s>>2]|0;if((a|0)==527320){GLa(s,527320);Va=f[s>>2]|0}else Va=a;if(fUb(c,Va)|0)continue a;else{Fa=0;Ba=331;break a}break}case 9:{if((Ca&255|0)!=77){Da=Ca;break b}f[i>>2]=f[i>>2]|8192;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){ua=a;va=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=va;f[c>>2]=a+4;Wa=va}else{if(!(TRb(c,e)|0)){Ba=68;break a}Wa=f[e>>2]|0}f[t>>2]=Wa;continue a;break}case 10:{if((Ca&255|0)!=85){Da=Ca;break b}f[i>>2]=f[i>>2]|16384;va=f[c>>2]|0;if(((f[g>>2]|0)-va|0)>3){a=va;ua=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=ua;f[c>>2]=va+4;Xa=ua}else{if(!(TRb(c,e)|0)){Ba=75;break a}Xa=f[e>>2]|0}f[v>>2]=Xa;continue a;break}case 11:{if((Ca&255|0)!=93){Da=Ca;break b}f[i>>2]=f[i>>2]|32768;ua=f[c>>2]|0;if(((f[g>>2]|0)-ua|0)>3){va=ua;a=h[va>>0]|h[va+1>>0]<<8|h[va+2>>0]<<16|h[va+3>>0]<<24;f[e>>2]=a;f[c>>2]=ua+4;Ya=a}else{if(!(TRb(c,e)|0)){Ba=82;break a}Ya=f[e>>2]|0}f[w>>2]=Ya;continue a;break}case 12:{if((Ca&255|0)!=101){Da=Ca;break b}f[i>>2]=f[i>>2]|65536;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){ua=a;va=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=va;f[c>>2]=a+4;Za=va}else{if(!(TRb(c,e)|0)){Ba=89;break a}Za=f[e>>2]|0}f[x>>2]=Za;continue a;break}case 13:{if((Ca&255|0)!=104){Da=Ca;break b}f[i>>2]=f[i>>2]|131072;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){a=b[va>>0]|0;ua=a&255;if(a<<24>>24>-1){f[c>>2]=va+1;_a=ua}else{$a=ua;Ba=94}}else{$a=0;Ba=94}if((Ba|0)==94){Ba=0;ua=HRb(c,$a)|0;va=J;if((va|0)>-1|(va|0)==-1&ua>>>0>4294967295)_a=ua;else{Fa=0;Ba=331;break a}}f[y>>2]=_a;continue a;break}case 14:{if((Ca&255|0)!=112){Da=Ca;break b}f[i>>2]=f[i>>2]|262144;ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){va=b[ua>>0]|0;a=va&255;if(va<<24>>24>-1){f[c>>2]=ua+1;ab=a}else{bb=a;Ba=100}}else{bb=0;Ba=100}if((Ba|0)==100){Ba=0;a=HRb(c,bb)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&a>>>0>4294967295)ab=a;else{Fa=0;Ba=331;break a}}f[z>>2]=ab;continue a;break}case 15:{if((Ca&255|0)!=122){Da=Ca;break b}f[i>>2]=f[i>>2]|4;a=f[A>>2]|0;if((a|0)==527320){GLa(A,527320);cb=f[A>>2]|0}else cb=a;if(fUb(c,cb)|0)continue a;else{Fa=0;Ba=331;break a}break}case 16:{if((Ca&255|0)!=128){Da=Ca;break b}f[i>>2]=f[i>>2]|2097152;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(ua=b[a>>0]|0,ua<<24>>24>-1):0){f[c>>2]=a+1;db=ua<<24>>24!=0}else{IRb(e,c);ua=e;if(!(b[C>>0]|0)){Fa=0;Ba=331;break a}else db=(f[ua>>2]|0)!=0|(f[ua+4>>2]|0)!=0}b[B>>0]=db&1;continue a;break}case 17:{if((Ca&255|0)!=136){Da=Ca;break b}ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){a=b[ua>>0]|0;va=a&255;if(a<<24>>24>-1){f[c>>2]=ua+1;eb=va}else{fb=va;Ba=116}}else{fb=0;Ba=116}if((Ba|0)==116){Ba=0;va=HRb(c,fb)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&va>>>0>4294967295)eb=va;else{Fa=0;Ba=331;break a}}if(eb>>>0<2){f[i>>2]=f[i>>2]|67108864;f[D>>2]=eb;continue a}va=f[E>>2]|0;if(!(va&1))gb=mNa(E)|0;else gb=va&-2;rjc(gb,17,eb,((eb|0)<0)<<31>>31);continue a;break}case 18:{if((Ca&255|0)!=144){Da=Ca;break b}f[i>>2]=f[i>>2]|524288;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){ua=b[va>>0]|0;a=ua&255;if(ua<<24>>24>-1){f[c>>2]=va+1;hb=a}else{ib=a;Ba=127}}else{ib=0;Ba=127}if((Ba|0)==127){Ba=0;a=HRb(c,ib)|0;va=J;if((va|0)>-1|(va|0)==-1&a>>>0>4294967295)hb=a;else{Fa=0;Ba=331;break a}}f[F>>2]=hb;continue a;break}case 19:{if((Ca&255|0)!=152){Da=Ca;break b}f[i>>2]=f[i>>2]|1048576;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;jb=va<<24>>24!=0}else{IRb(e,c);va=e;if(!(b[H>>0]|0)){Fa=0;Ba=331;break a}else jb=(f[va>>2]|0)!=0|(f[va+4>>2]|0)!=0}b[G>>0]=jb&1;continue a;break}case 20:{if((Ca&255|0)!=160){Da=Ca;break b}f[i>>2]=f[i>>2]|33554432;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0?(a=b[va>>0]|0,a<<24>>24>-1):0){f[c>>2]=va+1;kb=a&255;lb=0}else{IRb(e,c);a=e;if(!(b[K>>0]|0)){Fa=0;Ba=331;break a}else{kb=f[a>>2]|0;lb=f[a+4>>2]|0}}a=I;f[a>>2]=kb;f[a+4>>2]=lb;continue a;break}case 21:{if((Ca&255|0)!=170){Da=Ca;break b}f[i>>2]=f[i>>2]|64;a=f[L>>2]|0;if(!a){va=VDc(104)|0;ffb(va);f[L>>2]=va;mb=va}else mb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;nb=va&255}else{va=VRb(c)|0;if((va|0)>-1)nb=va;else{Fa=0;Ba=331;break a}}GRb(e,c,nb);if((f[M>>2]|0)<0){Ba=150;break a}if(!(Mi[f[(f[mb>>2]|0)+44>>2]&1023](mb,c)|0)){Ba=150;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 22:{if((Ca&255|0)!=178){Da=Ca;break b}va=f[O>>2]|0;do if(va){a=f[Q>>2]|0;ua=f[va>>2]|0;if((a|0)>=(ua|0))if((ua|0)==(f[P>>2]|0)){ob=ua;Ba=158;break}else{pb=ua;qb=va;Ba=159;break}else{f[Q>>2]=a+1;rb=f[va+4+(a<<2)>>2]|0;break}}else{ob=f[P>>2]|0;Ba=158}while(0);if((Ba|0)==158){Ba=0;USb(N,ob+1|0);va=f[O>>2]|0;pb=f[va>>2]|0;qb=va;Ba=159}if((Ba|0)==159){Ba=0;f[qb>>2]=pb+1;va=f[N>>2]|0;if(!va){a=VDc(104)|0;ffb(a);sb=a}else{if(f[va+64>>2]|0)OQb(va,16040,104);a=NQb(va,104,1756)|0;ffb(a);sb=a}a=f[O>>2]|0;va=f[Q>>2]|0;f[Q>>2]=va+1;f[a+4+(va<<2)>>2]=sb;rb=sb}va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0?(a=b[va>>0]|0,a<<24>>24>-1):0){f[c>>2]=va+1;tb=a&255}else{a=VRb(c)|0;if((a|0)>-1)tb=a;else{Fa=0;Ba=331;break a}}GRb(e,c,tb);if((f[R>>2]|0)<0){Ba=171;break a}if(!(Mi[f[(f[rb>>2]|0)+44>>2]&1023](rb,c)|0)){Ba=171;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 23:{if((Ca&255|0)!=184){Da=Ca;break b}f[i>>2]=f[i>>2]|4194304;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;ub=va<<24>>24!=0}else{IRb(e,c);va=e;if(!(b[T>>0]|0)){Fa=0;Ba=331;break a}else ub=(f[va>>2]|0)!=0|(f[va+4>>2]|0)!=0}b[S>>0]=ub&1;continue a;break}case 24:{if((Ca&255|0)!=194){Da=Ca;break b}f[i>>2]=f[i>>2]|8;va=f[U>>2]|0;if((va|0)==527320){GLa(U,527320);vb=f[U>>2]|0}else vb=va;if(fUb(c,vb)|0)continue a;else{Fa=0;Ba=331;break a}break}case 25:{if((Ca&255|0)!=202){Da=Ca;break b}f[i>>2]=f[i>>2]|128;va=f[V>>2]|0;if(!va){a=VDc(104)|0;ffb(a);f[V>>2]=a;wb=a}else wb=va;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0?(a=b[va>>0]|0,a<<24>>24>-1):0){f[c>>2]=va+1;xb=a&255}else{a=VRb(c)|0;if((a|0)>-1)xb=a;else{Fa=0;Ba=331;break a}}GRb(e,c,xb);if((f[W>>2]|0)<0){Ba=192;break a}if(!(Mi[f[(f[wb>>2]|0)+44>>2]&1023](wb,c)|0)){Ba=192;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 26:{if((Ca&255|0)!=210){Da=Ca;break b}f[i>>2]=f[i>>2]|256;a=f[X>>2]|0;if(!a){va=VDc(40)|0;veb(va);f[X>>2]=va;yb=va}else yb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;zb=va&255}else{va=VRb(c)|0;if((va|0)>-1)zb=va;else{Fa=0;Ba=331;break a}}GRb(e,c,zb);if((f[Y>>2]|0)<0){Ba=203;break a}if(!(Mi[f[(f[yb>>2]|0)+44>>2]&1023](yb,c)|0)){Ba=203;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 27:{if((Ca&255|0)!=218){Da=Ca;break b}va=f[_>>2]|0;do if(va){a=f[aa>>2]|0;ua=f[va>>2]|0;if((a|0)>=(ua|0))if((ua|0)==(f[$>>2]|0)){Ab=ua;Ba=211;break}else{Bb=ua;Cb=va;Ba=212;break}else{f[aa>>2]=a+1;Db=f[va+4+(a<<2)>>2]|0;break}}else{Ab=f[$>>2]|0;Ba=211}while(0);if((Ba|0)==211){Ba=0;USb(Z,Ab+1|0);va=f[_>>2]|0;Bb=f[va>>2]|0;Cb=va;Ba=212}if((Ba|0)==212){Ba=0;f[Cb>>2]=Bb+1;va=f[Z>>2]|0;if(!va){a=VDc(40)|0;veb(a);Eb=a}else{if(f[va+64>>2]|0)OQb(va,15992,40);a=NQb(va,40,1757)|0;veb(a);Eb=a}a=f[_>>2]|0;va=f[aa>>2]|0;f[aa>>2]=va+1;f[a+4+(va<<2)>>2]=Eb;Db=Eb}va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0?(a=b[va>>0]|0,a<<24>>24>-1):0){f[c>>2]=va+1;Fb=a&255}else{a=VRb(c)|0;if((a|0)>-1)Fb=a;else{Fa=0;Ba=331;break a}}GRb(e,c,Fb);if((f[ba>>2]|0)<0){Ba=224;break a}if(!(Mi[f[(f[Db>>2]|0)+44>>2]&1023](Db,c)|0)){Ba=224;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 28:{if((Ca&255|0)!=224){Da=Ca;break b}f[i>>2]=f[i>>2]|268435456;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;Gb=va<<24>>24!=0}else{IRb(e,c);va=e;if(!(b[da>>0]|0)){Fa=0;Ba=331;break a}else Gb=(f[va>>2]|0)!=0|(f[va+4>>2]|0)!=0}b[ca>>0]=Gb&1;continue a;break}case 29:{if((Ca&255|0)!=234){Da=Ca;break b}f[i>>2]=f[i>>2]|16;va=f[ea>>2]|0;if((va|0)==525016){GLa(ea,525016);Hb=f[ea>>2]|0}else Hb=va;if(fUb(c,Hb)|0)continue a;else{Fa=0;Ba=331;break a}break}case 30:{if((Ca&255|0)!=240){Da=Ca;break b}va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){a=b[va>>0]|0;ua=a&255;if(a<<24>>24>-1){f[c>>2]=va+1;Ib=ua}else{Jb=ua;Ba=240}}else{Jb=0;Ba=240}if((Ba|0)==240){Ba=0;ua=HRb(c,Jb)|0;va=J;if((va|0)>-1|(va|0)==-1&ua>>>0>4294967295)Ib=ua;else{Fa=0;Ba=331;break a}}if(Ib>>>0<6){f[i>>2]=f[i>>2]|8388608;f[fa>>2]=Ib;continue a}ua=f[E>>2]|0;if(!(ua&1))Kb=mNa(E)|0;else Kb=ua&-2;rjc(Kb,30,Ib,((Ib|0)<0)<<31>>31);continue a;break}case 31:{if((Ca&255|0)!=253){Da=Ca;break b}f[i>>2]=f[i>>2]|536870912;ua=f[c>>2]|0;if(((f[g>>2]|0)-ua|0)>3){va=ua;a=h[va>>0]|h[va+1>>0]<<8|h[va+2>>0]<<16|h[va+3>>0]<<24;f[e>>2]=a;f[c>>2]=ua+4;Lb=a}else{if(!(TRb(c,e)|0)){Ba=253;break a}Lb=f[e>>2]|0}f[ga>>2]=Lb;continue a;break}case 32:{if(Ca&255|0){Da=Ca;break b}f[i>>2]=f[i>>2]|134217728;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(ua=b[a>>0]|0,ua<<24>>24>-1):0){f[c>>2]=a+1;Mb=ua<<24>>24!=0}else{IRb(e,c);ua=e;if(!(b[ia>>0]|0)){Fa=0;Ba=331;break a}else Mb=(f[ua>>2]|0)!=0|(f[ua+4>>2]|0)!=0}b[ha>>0]=Mb&1;continue a;break}case 33:{if((Ca&255|0)!=8){Da=Ca;break b}f[i>>2]=f[i>>2]|1073741824;ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){a=b[ua>>0]|0;va=a&255;if(a<<24>>24>-1){f[c>>2]=ua+1;Nb=va}else{Ob=va;Ba=264}}else{Ob=0;Ba=264}if((Ba|0)==264){Ba=0;va=HRb(c,Ob)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&va>>>0>4294967295)Nb=va;else{Fa=0;Ba=331;break a}}f[ja>>2]=Nb;continue a;break}case 34:{switch((Ca&255)<<24>>24){case 16:break;case 18:{if(Afb(c,ka)|0)continue a;else{Fa=0;Ba=331;break a}break}default:{Da=Ca;break b}}va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){ua=b[va>>0]|0;a=ua&255;if(ua<<24>>24>-1){f[c>>2]=va+1;Pb=a}else{Qb=a;Ba=270}}else{Qb=0;Ba=270}if((Ba|0)==270){Ba=0;a=HRb(c,Qb)|0;va=J;if((va|0)>-1|(va|0)==-1&a>>>0>4294967295)Pb=a;else{Fa=0;Ba=331;break a}}a=f[ka>>2]|0;if((a|0)==(f[la>>2]|0)){KLa(ka,a+1|0);Rb=f[ka>>2]|0}else Rb=a;a=f[ma>>2]|0;f[ka>>2]=Rb+1;f[a+4+(Rb<<2)>>2]=Pb;va=(f[la>>2]|0)-(f[ka>>2]|0)|0;if((va|0)>0){Sb=va;Tb=a}else continue a;while(1){a=f[g>>2]|0;va=f[c>>2]|0;ua=va;if((a-va|0)<=1)continue a;if((b[ua>>0]|0)!=-112)continue a;if((b[ua+1>>0]|0)!=2)continue a;va=ua+2|0;f[c>>2]=va;if(va>>>0<a>>>0){a=b[va>>0]|0;va=a&255;if(a<<24>>24>-1){f[c>>2]=ua+3;Ub=va;Vb=Tb}else{Wb=va;Ba=279}}else{Wb=0;Ba=279}if((Ba|0)==279){Ba=0;va=HRb(c,Wb)|0;ua=J;if(!((ua|0)>-1|(ua|0)==-1&va>>>0>4294967295)){Fa=0;Ba=331;break a}Ub=va;Vb=f[ma>>2]|0}va=f[ka>>2]|0;f[ka>>2]=va+1;f[Vb+4+(va<<2)>>2]=Ub;if((Sb|0)>1){Sb=Sb+-1|0;Tb=Vb}else continue a}break}case 35:{if((Ca&255|0)!=29){Da=Ca;break b}f[i>>2]=f[i>>2]|-2147483648;va=f[c>>2]|0;if(((f[g>>2]|0)-va|0)>3){ua=va;a=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=a;f[c>>2]=va+4;Xb=a}else{if(!(TRb(c,e)|0)){Ba=290;break a}Xb=f[e>>2]|0}f[na>>2]=Xb;continue a;break}case 36:{if((Ca&255|0)!=32){Da=Ca;break b}f[oa>>2]=f[oa>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){va=b[a>>0]|0;ua=va&255;if(va<<24>>24>-1){f[c>>2]=a+1;Yb=ua}else{Zb=ua;Ba=295}}else{Zb=0;Ba=295}if((Ba|0)==295){Ba=0;ua=HRb(c,Zb)|0;a=J;if((a|0)>-1|(a|0)==-1&ua>>>0>4294967295)Yb=ua;else{Fa=0;Ba=331;break a}}f[pa>>2]=Yb;continue a;break}case 37:{if((Ca&255|0)!=40){Da=Ca;break b}ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){a=b[ua>>0]|0;va=a&255;if(a<<24>>24>-1){f[c>>2]=ua+1;_b=va}else{$b=va;Ba=301}}else{$b=0;Ba=301}if((Ba|0)==301){Ba=0;va=HRb(c,$b)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&va>>>0>4294967295)_b=va;else{Fa=0;Ba=331;break a}}if(_b>>>0<2){f[oa>>2]=f[oa>>2]|2;f[qa>>2]=_b;continue a}va=f[E>>2]|0;if(!(va&1))ac=mNa(E)|0;else ac=va&-2;rjc(ac,37,_b,((_b|0)<0)<<31>>31);continue a;break}case 38:{if((Ca&255|0)!=53){Da=Ca;break b}f[oa>>2]=f[oa>>2]|4;va=f[c>>2]|0;if(((f[g>>2]|0)-va|0)>3){ua=va;a=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=a;f[c>>2]=va+4;bc=a}else{if(!(TRb(c,e)|0)){Ba=314;break a}bc=f[e>>2]|0}f[ra>>2]=bc;continue a;break}case 39:{if((Ca&255|0)!=61){Da=Ca;break b}f[i>>2]=f[i>>2]|16777216;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){va=a;ua=h[va>>0]|h[va+1>>0]<<8|h[va+2>>0]<<16|h[va+3>>0]<<24;f[e>>2]=ua;f[c>>2]=a+4;cc=ua}else{if(!(TRb(c,e)|0)){Ba=321;break a}cc=f[e>>2]|0}f[sa>>2]=cc;continue a;break}case 40:{if((Ca&255|0)!=66){Da=Ca;break b}f[i>>2]=f[i>>2]|32;ua=f[ta>>2]|0;if((ua|0)==525032){GLa(ta,525032);dc=f[ta>>2]|0}else dc=ua;if(fUb(c,dc)|0)continue a;else{Fa=0;Ba=331;break a}break}default:{Da=Ca;break b}}while(0)}while(0);if(!Da){Fa=1;Ba=331;break}ua=f[E>>2]|0;if(!(ua&1))ec=mNa(E)|0;else ec=ua&-2;if(!(Djc(c,Da,ec)|0)){Fa=0;Ba=331;break}}switch(Ba|0){case 45:{Fa=0;u=d;return Fa|0}case 68:{Fa=0;u=d;return Fa|0}case 75:{Fa=0;u=d;return Fa|0}case 82:{Fa=0;u=d;return Fa|0}case 89:{Fa=0;u=d;return Fa|0}case 150:{Fa=0;u=d;return Fa|0}case 171:{Fa=0;u=d;return Fa|0}case 192:{Fa=0;u=d;return Fa|0}case 203:{Fa=0;u=d;return Fa|0}case 224:{Fa=0;u=d;return Fa|0}case 253:{Fa=0;u=d;return Fa|0}case 290:{Fa=0;u=d;return Fa|0}case 314:{Fa=0;u=d;return Fa|0}case 321:{Fa=0;u=d;return Fa|0}case 331:{u=d;return Fa|0}}return 0}function Web(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=hUb(a+32|0)|0;h=f[a+48>>2]|0;c=e+l+(f[a+32>>2]|0)+(h<<1)|0;if(!h)m=c;else{l=a+56|0;e=0;g=c;while(1){c=f[(f[l>>2]|0)+4+(e<<2)>>2]|0;d=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=d+g+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(h|0)){m=c;break}else g=c}}g=f[a+64>>2]|0;h=(g<<1)+m|0;if(!g)n=h;else{m=a+72|0;e=0;l=h;while(1){h=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;c=_i[f[(f[h>>2]|0)+48>>2]&1023](h)|0;h=c+l+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(g|0)){n=h;break}else l=h}}l=hUb(a+76|0)|0;g=l+n+(f[a+76>>2]<<1)|0;n=a+8|0;l=f[n>>2]|0;if(l&255){if(!(l&1))o=g;else{e=f[a+88>>2]|0;m=b[e+11>>0]|0;h=m<<24>>24<0?f[e+4>>2]|0:m&255;o=g+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&2))p=o;else{h=f[a+92>>2]|0;m=b[h+11>>0]|0;e=m<<24>>24<0?f[h+4>>2]|0:m&255;p=o+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&4))q=p;else{e=f[a+96>>2]|0;o=b[e+11>>0]|0;m=o<<24>>24<0?f[e+4>>2]|0:o&255;q=p+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&8))r=q;else{m=f[a+100>>2]|0;p=b[m+11>>0]|0;o=p<<24>>24<0?f[m+4>>2]|0:p&255;r=q+2+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&16))s=r;else{o=f[a+104>>2]|0;q=b[o+11>>0]|0;p=q<<24>>24<0?f[o+4>>2]|0:q&255;s=r+2+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&32))t=s;else{p=f[a+108>>2]|0;r=b[p+11>>0]|0;q=r<<24>>24<0?f[p+4>>2]|0:r&255;t=s+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&64)){u=t;v=l}else{q=f[a+112>>2]|0;s=_i[f[(f[q>>2]|0)+48>>2]&1023](q)|0;q=t+2+s+((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=q;v=f[n>>2]|0}if(!(v&128)){w=u;x=v}else{v=f[a+116>>2]|0;q=_i[f[(f[v>>2]|0)+48>>2]&1023](v)|0;v=u+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=v;x=f[n>>2]|0}}else{w=g;x=l}if(!(x&65280)){y=w;z=x}else{if(!(x&256)){A=w;B=x}else{x=f[a+120>>2]|0;l=_i[f[(f[x>>2]|0)+48>>2]&1023](x)|0;x=w+2+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;A=x;B=f[n>>2]|0}if(!(B&512))C=A;else{n=f[a+124>>2]|0;if((n|0)<0)D=10;else D=(((($(n|1|0)|0)^31)*9|0)+73|0)>>>6;C=A+1+D|0}D=B&1024|0?C+5|0:C;if(!(B&2048))E=D;else{C=f[a+132>>2]|0;if((C|0)<0)F=10;else F=(((($(C|1|0)|0)^31)*9|0)+73|0)>>>6;E=D+1+F|0}if(!(B&4096))G=E;else{F=f[a+136>>2]|0;if((F|0)<0)H=10;else H=(((($(F|1|0)|0)^31)*9|0)+73|0)>>>6;G=E+1+H|0}H=B&8192|0?G+5|0:G;G=B&16384|0?H+5|0:H;y=B&32768|0?G+5|0:G;z=B}if(z&16711680){B=z&65536|0?y+5|0:y;if(!(z&131072))I=B;else{G=f[a+156>>2]|0;if((G|0)<0)J=10;else J=(((($(G|1|0)|0)^31)*9|0)+73|0)>>>6;I=B+1+J|0}if(!(z&262144))K=I;else{J=f[a+160>>2]|0;if((J|0)<0)L=10;else L=(((($(J|1|0)|0)^31)*9|0)+73|0)>>>6;K=I+1+L|0}if(!(z&524288))M=K;else{L=f[a+164>>2]|0;if((L|0)<0)N=12;else N=((((($(L|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;M=N+K|0}K=z&1048576|0?M+3|0:M;M=z&2097152|0?K+3|0:K;K=z&4194304|0?M+3|0:M;if(!(z&8388608))O=K;else{M=f[a+172>>2]|0;if((M|0)<0)P=12;else P=((((($(M|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;O=P+K|0}}else O=y;if(z>>>0>16777215){y=z&16777216|0?O+6|0:O;if(!(z&33554432))Q=y;else{K=a+184|0;P=iJc(f[K>>2]|1|0,f[K+4>>2]|0,1)|0;Q=y+2+((((P^63)*9|0)+73|0)>>>6)|0}if(!(z&67108864))R=Q;else{P=f[a+192>>2]|0;if((P|0)<0)S=12;else S=((((($(P|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;R=S+Q|0}Q=z&134217728|0?R+3|0:R;R=z&268435456|0?Q+3|0:Q;Q=z&536870912|0?R+6|0:R;if(!(z&1073741824))T=Q;else{R=f[a+204>>2]|0;if((R|0)<0)U=12;else U=((((($(R|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;T=U+Q|0}V=(z|0)<0?T+6|0:T}else V=O;O=f[a+12>>2]|0;if(!(O&7)){W=V;X=a+224|0;f[X>>2]=W;return W|0}if(!(O&1))Y=V;else{T=f[a+212>>2]|0;if((T|0)<0)Z=12;else Z=((((($(T|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;Y=Z+V|0}if(!(O&2))_=Y;else{V=f[a+216>>2]|0;if((V|0)<0)aa=12;else aa=((((($(V|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;_=aa+Y|0}W=O&4|0?_+6|0:_;X=a+224|0;f[X>>2]=W;return W|0}function Xeb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+8|0;e=f[d>>2]|0;if(e&1|0)$Tb(1,f[a+88>>2]|0,c);g=f[a+20>>2]|0;if((g|0)>0){h=a+28|0;i=0;do{_Tb(2,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}g=f[a+32>>2]|0;if((g|0)>0){i=a+40|0;h=0;do{MTb(3,f[(f[i>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(g|0))}if(e&512|0)MTb(4,f[a+124>>2]|0,c);if(e&1024|0)WTb(5,+n[a+128>>2],c);if(e&2048|0)MTb(6,f[a+132>>2]|0,c);if(e&4096|0)MTb(7,f[a+136>>2]|0,c);if(e&2|0)$Tb(8,f[a+92>>2]|0,c);if(e&8192|0)WTb(9,+n[a+140>>2],c);if(e&16384|0)WTb(10,+n[a+144>>2],c);if(e&32768|0)WTb(11,+n[a+148>>2],c);if(e&65536|0)WTb(12,+n[a+152>>2],c);if(e&131072|0)MTb(13,f[a+156>>2]|0,c);if(e&262144|0)MTb(14,f[a+160>>2]|0,c);if(e&4|0)$Tb(15,f[a+96>>2]|0,c);if(e&2097152|0)YTb(16,(b[a+169>>0]|0)!=0,c);if(e&67108864|0)ZTb(17,f[a+192>>2]|0,c);if(e&524288|0)MTb(18,f[a+164>>2]|0,c);if(e&1048576|0)YTb(19,(b[a+168>>0]|0)!=0,c);if(e&33554432|0){g=a+184|0;NTb(20,f[g>>2]|0,f[g+4>>2]|0,c)}if(e&64|0)eUb(21,f[a+112>>2]|0,c);g=f[a+48>>2]|0;if(g|0){h=a+56|0;i=0;do{eUb(22,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}if(e&4194304|0)YTb(23,(b[a+170>>0]|0)!=0,c);if(e&8|0)$Tb(24,f[a+100>>2]|0,c);if(e&128|0)eUb(25,f[a+116>>2]|0,c);if(e&256|0)eUb(26,f[a+120>>2]|0,c);g=f[a+64>>2]|0;if(g|0){i=a+72|0;h=0;do{eUb(27,f[(f[i>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(g|0))}if(e&268435456|0)YTb(28,(b[a+197>>0]|0)!=0,c);if(e&16|0)$Tb(29,f[a+104>>2]|0,c);if(e&8388608|0)ZTb(30,f[a+172>>2]|0,c);if(e&536870912|0)WTb(31,+n[a+200>>2],c);if(e&134217728|0)YTb(32,(b[a+196>>0]|0)!=0,c);if(e&1073741824|0)MTb(33,f[a+204>>2]|0,c);g=f[a+76>>2]|0;if((g|0)>0){h=a+84|0;i=0;do{MTb(34,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}if((e|0)<0)WTb(35,+n[a+208>>2],c);e=f[a+12>>2]|0;if(e&1|0)MTb(36,f[a+212>>2]|0,c);if(e&2|0)ZTb(37,f[a+216>>2]|0,c);if(e&4|0)WTb(38,+n[a+220>>2],c);e=f[d>>2]|0;if(e&16777216|0)WTb(39,+n[a+176>>2],c);if(e&32|0)$Tb(40,f[a+108>>2]|0,c);e=f[a+4>>2]|0;if(!(e&1))return;Gjc(e&-2,c);return}function Yeb(a){a=a|0;return f[a+224>>2]|0}function Zeb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;e=a+8|0;g=f[e>>2]|0;if(!(g&1))h=d;else{i=f[a+88>>2]|0;b[d>>0]=10;h=dSb(i,d+1|0)|0}d=f[a+20>>2]|0;if((d|0)>0){i=a+28|0;j=0;k=h;while(1){l=f[(f[i>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;m=dSb(l,k+1|0)|0;j=j+1|0;if((j|0)==(d|0)){n=m;break}else k=m}}else n=h;h=f[a+32>>2]|0;if(!h)o=n;else{k=f[a+40>>2]|0;d=0;j=n;while(1){n=f[k+4+(d<<2)>>2]|0;b[j>>0]=24;i=j+1|0;m=n&255;if(n>>>0>127){l=i;p=m;q=n;r=((n|0)<0)<<31>>31;while(1){b[l>>0]=p|-128;n=q;q=aJc(q|0,r|0,7)|0;s=l+1|0;t=q&255;if(!(r>>>0>0|(r|0)==0&n>>>0>16383)){u=s;v=t;break}else{l=s;p=t;r=J}}}else{u=i;v=m}b[u>>0]=v;r=u+1|0;d=d+1|0;if((d|0)>=(h|0)){o=r;break}else j=r}}if(!(g&512))w=o;else{j=f[a+124>>2]|0;b[o>>0]=32;h=o+1|0;o=j&255;if(j>>>0>127){d=h;u=o;v=j;k=((j|0)<0)<<31>>31;while(1){b[d>>0]=u|-128;j=v;v=aJc(v|0,k|0,7)|0;r=d+1|0;p=v&255;if(!(k>>>0>0|(k|0)==0&j>>>0>16383)){x=r;y=p;break}else{d=r;u=p;k=J}}}else{x=h;y=o}b[x>>0]=y;w=x+1|0}if(!(g&1024))z=w;else{x=f[a+128>>2]|0;b[w>>0]=45;y=w+1|0;b[y>>0]=x;b[y+1>>0]=x>>8;b[y+2>>0]=x>>16;b[y+3>>0]=x>>24;z=w+5|0}if(!(g&2048))A=z;else{w=f[a+132>>2]|0;b[z>>0]=48;x=z+1|0;z=w&255;if(w>>>0>127){y=x;o=z;h=w;k=((w|0)<0)<<31>>31;while(1){b[y>>0]=o|-128;w=h;h=aJc(h|0,k|0,7)|0;u=y+1|0;d=h&255;if(!(k>>>0>0|(k|0)==0&w>>>0>16383)){B=u;C=d;break}else{y=u;o=d;k=J}}}else{B=x;C=z}b[B>>0]=C;A=B+1|0}if(!(g&4096))D=A;else{B=f[a+136>>2]|0;b[A>>0]=56;C=A+1|0;A=B&255;if(B>>>0>127){z=C;x=A;k=B;o=((B|0)<0)<<31>>31;while(1){b[z>>0]=x|-128;B=k;k=aJc(k|0,o|0,7)|0;y=z+1|0;h=k&255;if(!(o>>>0>0|(o|0)==0&B>>>0>16383)){E=y;F=h;break}else{z=y;x=h;o=J}}}else{E=C;F=A}b[E>>0]=F;D=E+1|0}if(!(g&2))G=D;else{E=f[a+92>>2]|0;b[D>>0]=66;G=dSb(E,D+1|0)|0}if(!(g&8192))H=G;else{D=f[a+140>>2]|0;b[G>>0]=77;E=G+1|0;b[E>>0]=D;b[E+1>>0]=D>>8;b[E+2>>0]=D>>16;b[E+3>>0]=D>>24;H=G+5|0}if(!(g&16384))I=H;else{G=f[a+144>>2]|0;b[H>>0]=85;D=H+1|0;b[D>>0]=G;b[D+1>>0]=G>>8;b[D+2>>0]=G>>16;b[D+3>>0]=G>>24;I=H+5|0}if(!(g&32768))K=I;else{H=f[a+148>>2]|0;b[I>>0]=93;G=I+1|0;b[G>>0]=H;b[G+1>>0]=H>>8;b[G+2>>0]=H>>16;b[G+3>>0]=H>>24;K=I+5|0}if(!(g&65536))L=K;else{I=f[a+152>>2]|0;b[K>>0]=101;H=K+1|0;b[H>>0]=I;b[H+1>>0]=I>>8;b[H+2>>0]=I>>16;b[H+3>>0]=I>>24;L=K+5|0}if(!(g&131072))M=L;else{K=f[a+156>>2]|0;b[L>>0]=104;I=L+1|0;L=K&255;if(K>>>0>127){H=I;G=L;D=K;E=((K|0)<0)<<31>>31;while(1){b[H>>0]=G|-128;K=D;D=aJc(D|0,E|0,7)|0;F=H+1|0;A=D&255;if(!(E>>>0>0|(E|0)==0&K>>>0>16383)){N=F;O=A;break}else{H=F;G=A;E=J}}}else{N=I;O=L}b[N>>0]=O;M=N+1|0}if(!(g&262144))P=M;else{N=f[a+160>>2]|0;b[M>>0]=112;O=M+1|0;M=N&255;if(N>>>0>127){L=O;I=M;E=N;G=((N|0)<0)<<31>>31;while(1){b[L>>0]=I|-128;N=E;E=aJc(E|0,G|0,7)|0;H=L+1|0;D=E&255;if(!(G>>>0>0|(G|0)==0&N>>>0>16383)){Q=H;R=D;break}else{L=H;I=D;G=J}}}else{Q=O;R=M}b[Q>>0]=R;P=Q+1|0}if(!(g&4))S=P;else{Q=f[a+96>>2]|0;b[P>>0]=122;S=dSb(Q,P+1|0)|0}if(!(g&2097152))T=S;else{P=b[a+169>>0]|0;b[S>>0]=-128;b[S+1>>0]=1;b[S+2>>0]=P;T=S+3|0}if(!(g&67108864))U=T;else{S=f[a+192>>2]|0;b[T>>0]=-120;b[T+1>>0]=1;P=T+2|0;T=S&255;if(S>>>0>127){Q=P;R=T;M=S;O=((S|0)<0)<<31>>31;while(1){b[Q>>0]=R|-128;S=M;M=aJc(M|0,O|0,7)|0;G=Q+1|0;I=M&255;if(!(O>>>0>0|(O|0)==0&S>>>0>16383)){V=G;W=I;break}else{Q=G;R=I;O=J}}}else{V=P;W=T}b[V>>0]=W;U=V+1|0}if(!(g&524288))X=U;else{V=f[a+164>>2]|0;b[U>>0]=-112;b[U+1>>0]=1;W=U+2|0;U=V&255;if(V>>>0>127){T=W;P=U;O=V;R=((V|0)<0)<<31>>31;while(1){b[T>>0]=P|-128;V=O;O=aJc(O|0,R|0,7)|0;Q=T+1|0;M=O&255;if(!(R>>>0>0|(R|0)==0&V>>>0>16383)){Y=Q;Z=M;break}else{T=Q;P=M;R=J}}}else{Y=W;Z=U}b[Y>>0]=Z;X=Y+1|0}if(!(g&1048576))_=X;else{Y=b[a+168>>0]|0;b[X>>0]=-104;b[X+1>>0]=1;b[X+2>>0]=Y;_=X+3|0}if(!(g&33554432))$=_;else{X=a+184|0;Y=f[X>>2]|0;Z=f[X+4>>2]|0;b[_>>0]=-96;b[_+1>>0]=1;X=_+2|0;_=Y&255;if(Z>>>0>0|(Z|0)==0&Y>>>0>127){U=X;W=_;R=Y;Y=Z;while(1){b[U>>0]=W|-128;Z=R;R=aJc(R|0,Y|0,7)|0;P=U+1|0;T=R&255;if(!(Y>>>0>0|(Y|0)==0&Z>>>0>16383)){aa=P;ba=T;break}else{U=P;W=T;Y=J}}}else{aa=X;ba=_}b[aa>>0]=ba;$=aa+1|0}if(!(g&64))ca=$;else{aa=f[a+112>>2]|0;b[$>>0]=-86;b[$+1>>0]=1;ba=$+2|0;$=_i[f[(f[aa>>2]|0)+60>>2]&1023](aa)|0;if($>>>0>127){_=$;X=ba;while(1){b[X>>0]=_|128;Y=_>>>7;W=X+1|0;if(_>>>0>16383){_=Y;X=W}else{da=W;ea=Y;break}}}else{da=ba;ea=$}b[da>>0]=ea;ca=hj[f[(f[aa>>2]|0)+64>>2]&511](aa,c,da+1|0)|0}da=f[a+48>>2]|0;if(!da)fa=ca;else{aa=a+56|0;ea=0;$=ca;while(1){ca=f[(f[aa>>2]|0)+4+(ea<<2)>>2]|0;b[$>>0]=-78;b[$+1>>0]=1;ba=$+2|0;X=_i[f[(f[ca>>2]|0)+60>>2]&1023](ca)|0;if(X>>>0>127){_=X;Y=ba;while(1){b[Y>>0]=_|128;W=_>>>7;U=Y+1|0;if(_>>>0>16383){_=W;Y=U}else{ga=U;ha=W;break}}}else{ga=ba;ha=X}b[ga>>0]=ha;Y=hj[f[(f[ca>>2]|0)+64>>2]&511](ca,c,ga+1|0)|0;ea=ea+1|0;if((ea|0)==(da|0)){fa=Y;break}else $=Y}}if(!(g&4194304))ia=fa;else{$=b[a+170>>0]|0;b[fa>>0]=-72;b[fa+1>>0]=1;b[fa+2>>0]=$;ia=fa+3|0}if(!(g&8))ja=ia;else{fa=f[a+100>>2]|0;b[ia>>0]=-62;b[ia+1>>0]=1;ja=dSb(fa,ia+2|0)|0}if(!(g&128))ka=ja;else{ia=f[a+116>>2]|0;b[ja>>0]=-54;b[ja+1>>0]=1;fa=ja+2|0;ja=_i[f[(f[ia>>2]|0)+60>>2]&1023](ia)|0;if(ja>>>0>127){$=ja;da=fa;while(1){b[da>>0]=$|128;ea=$>>>7;ga=da+1|0;if($>>>0>16383){$=ea;da=ga}else{la=ga;ma=ea;break}}}else{la=fa;ma=ja}b[la>>0]=ma;ka=hj[f[(f[ia>>2]|0)+64>>2]&511](ia,c,la+1|0)|0}if(!(g&256))na=ka;else{la=f[a+120>>2]|0;b[ka>>0]=-46;b[ka+1>>0]=1;ia=ka+2|0;ka=_i[f[(f[la>>2]|0)+60>>2]&1023](la)|0;if(ka>>>0>127){ma=ka;ja=ia;while(1){b[ja>>0]=ma|128;fa=ma>>>7;da=ja+1|0;if(ma>>>0>16383){ma=fa;ja=da}else{oa=da;pa=fa;break}}}else{oa=ia;pa=ka}b[oa>>0]=pa;na=hj[f[(f[la>>2]|0)+64>>2]&511](la,c,oa+1|0)|0}oa=f[a+64>>2]|0;if(!oa)qa=na;else{la=a+72|0;pa=0;ka=na;while(1){na=f[(f[la>>2]|0)+4+(pa<<2)>>2]|0;b[ka>>0]=-38;b[ka+1>>0]=1;ia=ka+2|0;ja=_i[f[(f[na>>2]|0)+60>>2]&1023](na)|0;if(ja>>>0>127){ma=ja;fa=ia;while(1){b[fa>>0]=ma|128;da=ma>>>7;$=fa+1|0;if(ma>>>0>16383){ma=da;fa=$}else{ra=$;sa=da;break}}}else{ra=ia;sa=ja}b[ra>>0]=sa;fa=hj[f[(f[na>>2]|0)+64>>2]&511](na,c,ra+1|0)|0;pa=pa+1|0;if((pa|0)==(oa|0)){qa=fa;break}else ka=fa}}if(!(g&268435456))ta=qa;else{ka=b[a+197>>0]|0;b[qa>>0]=-32;b[qa+1>>0]=1;b[qa+2>>0]=ka;ta=qa+3|0}if(!(g&16))ua=ta;else{qa=f[a+104>>2]|0;b[ta>>0]=-22;b[ta+1>>0]=1;ua=dSb(qa,ta+2|0)|0}if(!(g&8388608))va=ua;else{ta=f[a+172>>2]|0;b[ua>>0]=-16;b[ua+1>>0]=1;qa=ua+2|0;ua=ta&255;if(ta>>>0>127){ka=qa;oa=ua;pa=ta;ra=((ta|0)<0)<<31>>31;while(1){b[ka>>0]=oa|-128;ta=pa;pa=aJc(pa|0,ra|0,7)|0;c=ka+1|0;sa=pa&255;if(!(ra>>>0>0|(ra|0)==0&ta>>>0>16383)){wa=c;xa=sa;break}else{ka=c;oa=sa;ra=J}}}else{wa=qa;xa=ua}b[wa>>0]=xa;va=wa+1|0}if(!(g&536870912))ya=va;else{wa=f[a+200>>2]|0;b[va>>0]=-3;b[va+1>>0]=1;xa=va+2|0;b[xa>>0]=wa;b[xa+1>>0]=wa>>8;b[xa+2>>0]=wa>>16;b[xa+3>>0]=wa>>24;ya=va+6|0}if(!(g&134217728))za=ya;else{va=b[a+196>>0]|0;b[ya>>0]=-128;b[ya+1>>0]=2;b[ya+2>>0]=va;za=ya+3|0}if(!(g&1073741824))Aa=za;else{ya=f[a+204>>2]|0;b[za>>0]=-120;b[za+1>>0]=2;va=za+2|0;za=ya&255;if(ya>>>0>127){wa=va;xa=za;ua=ya;qa=((ya|0)<0)<<31>>31;while(1){b[wa>>0]=xa|-128;ya=ua;ua=aJc(ua|0,qa|0,7)|0;ra=wa+1|0;oa=ua&255;if(!(qa>>>0>0|(qa|0)==0&ya>>>0>16383)){Ba=ra;Ca=oa;break}else{wa=ra;xa=oa;qa=J}}}else{Ba=va;Ca=za}b[Ba>>0]=Ca;Aa=Ba+1|0}Ba=f[a+76>>2]|0;if(!Ba)Da=Aa;else{Ca=f[a+84>>2]|0;za=0;va=Aa;while(1){Aa=f[Ca+4+(za<<2)>>2]|0;b[va>>0]=-112;b[va+1>>0]=2;qa=va+2|0;xa=Aa&255;if(Aa>>>0>127){wa=qa;ua=xa;oa=Aa;ra=((Aa|0)<0)<<31>>31;while(1){b[wa>>0]=ua|-128;Aa=oa;oa=aJc(oa|0,ra|0,7)|0;ya=wa+1|0;ka=oa&255;if(!(ra>>>0>0|(ra|0)==0&Aa>>>0>16383)){Ea=ya;Fa=ka;break}else{wa=ya;ua=ka;ra=J}}}else{Ea=qa;Fa=xa}b[Ea>>0]=Fa;ra=Ea+1|0;za=za+1|0;if((za|0)>=(Ba|0)){Da=ra;break}else va=ra}}if((g|0)<0){g=f[a+208>>2]|0;b[Da>>0]=-99;b[Da+1>>0]=2;va=Da+2|0;b[va>>0]=g;b[va+1>>0]=g>>8;b[va+2>>0]=g>>16;b[va+3>>0]=g>>24;Ga=Da+6|0}else Ga=Da;Da=f[a+12>>2]|0;if(!(Da&1))Ha=Ga;else{g=f[a+212>>2]|0;b[Ga>>0]=-96;b[Ga+1>>0]=2;va=Ga+2|0;Ga=g&255;if(g>>>0>127){Ba=va;za=Ga;Ea=g;Fa=((g|0)<0)<<31>>31;while(1){b[Ba>>0]=za|-128;g=Ea;Ea=aJc(Ea|0,Fa|0,7)|0;Ca=Ba+1|0;ra=Ea&255;if(!(Fa>>>0>0|(Fa|0)==0&g>>>0>16383)){Ia=Ca;Ja=ra;break}else{Ba=Ca;za=ra;Fa=J}}}else{Ia=va;Ja=Ga}b[Ia>>0]=Ja;Ha=Ia+1|0}if(!(Da&2))Ka=Ha;else{Ia=f[a+216>>2]|0;b[Ha>>0]=-88;b[Ha+1>>0]=2;Ja=Ha+2|0;Ha=Ia&255;if(Ia>>>0>127){Ga=Ja;va=Ha;Fa=Ia;za=((Ia|0)<0)<<31>>31;while(1){b[Ga>>0]=va|-128;Ia=Fa;Fa=aJc(Fa|0,za|0,7)|0;Ba=Ga+1|0;Ea=Fa&255;if(!(za>>>0>0|(za|0)==0&Ia>>>0>16383)){La=Ba;Ma=Ea;break}else{Ga=Ba;va=Ea;za=J}}}else{La=Ja;Ma=Ha}b[La>>0]=Ma;Ka=La+1|0}if(!(Da&4))Na=Ka;else{Da=f[a+220>>2]|0;b[Ka>>0]=-75;b[Ka+1>>0]=2;La=Ka+2|0;b[La>>0]=Da;b[La+1>>0]=Da>>8;b[La+2>>0]=Da>>16;b[La+3>>0]=Da>>24;Na=Ka+6|0}Ka=f[e>>2]|0;if(!(Ka&16777216))Oa=Na;else{e=f[a+176>>2]|0;b[Na>>0]=-67;b[Na+1>>0]=2;Da=Na+2|0;b[Da>>0]=e;b[Da+1>>0]=e>>8;b[Da+2>>0]=e>>16;b[Da+3>>0]=e>>24;Oa=Na+6|0}if(!(Ka&32))Pa=Oa;else{Ka=f[a+108>>2]|0;b[Oa>>0]=-62;b[Oa+1>>0]=2;Pa=dSb(Ka,Oa+2|0)|0}Oa=f[a+4>>2]|0;if(!(Oa&1)){Qa=Pa;return Qa|0}Qa=Hjc(Oa&-2,Pa)|0;return Qa|0}function _eb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function $eb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16024,0)|0;if(!c){Ehc(b,a);return}else{cfb(a,c);return}}function afb(a,b){a=a|0;b=b|0;f[a+224>>2]=b;return}function bfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525160;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function cfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}yNa(a+16|0,c+16|0);e=a+32|0;h=c+32|0;g=f[h>>2]|0;if(g|0){KLa(e,(f[e>>2]|0)+g|0);dJc((f[a+40>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+40>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}dfb(a+44|0,c+44|0);efb(a+60|0,c+60|0);h=a+76|0;e=c+76|0;g=f[e>>2]|0;if(g|0){KLa(h,(f[h>>2]|0)+g|0);dJc((f[a+84>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+84>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+88|0,g=f[c+88>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+92|0,d=f[c+92>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==527320){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+96|0,h=f[c+96>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==527320){GLa(d,h);break}else{iEc(g,h)|0;break}while(0);do if(e&8|0?(h=a+8|0,f[h>>2]=f[h>>2]|8,h=a+100|0,g=f[c+100>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(h,g);break}else{iEc(d,g)|0;break}while(0);do if(e&16|0?(g=a+8|0,f[g>>2]=f[g>>2]|16,g=a+104|0,d=f[c+104>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==525016){GLa(g,d);break}else{iEc(h,d)|0;break}while(0);do if(e&32|0?(d=a+8|0,f[d>>2]=f[d>>2]|32,d=a+108|0,h=f[c+108>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==525032){GLa(d,h);break}else{iEc(g,h)|0;break}while(0);if(e&64|0){h=a+8|0;f[h>>2]=f[h>>2]|64;h=a+112|0;g=f[h>>2]|0;if(!g){d=VDc(104)|0;ffb(d);f[h>>2]=d;i=d}else i=g;g=f[c+112>>2]|0;gfb(i,g|0?g:521656)}if(e&128|0){g=a+8|0;f[g>>2]=f[g>>2]|128;g=a+116|0;i=f[g>>2]|0;if(!i){d=VDc(104)|0;ffb(d);f[g>>2]=d;j=d}else j=i;i=f[c+116>>2]|0;gfb(j,i|0?i:521656)}}if(e&65280|0){if(e&256|0){i=a+8|0;f[i>>2]=f[i>>2]|256;i=a+120|0;j=f[i>>2]|0;if(!j){d=VDc(40)|0;veb(d);f[i>>2]=d;k=d}else k=j;j=f[c+120>>2]|0;d=j|0?j:522040;j=k+4|0;i=f[d+4>>2]|0;if(i&1|0){g=f[j>>2]|0;if(!(g&1))l=mNa(j)|0;else l=g&-2;ojc(l,i&-2)}yNa(k+16|0,d+16|0);i=f[d+8>>2]|0;if(i&3|0){if(i&1|0)f[k+32>>2]=f[d+32>>2];if(i&2|0)f[k+36>>2]=f[d+36>>2];d=k+8|0;f[d>>2]=f[d>>2]|i}}if(e&512|0)f[a+124>>2]=f[c+124>>2];if(e&1024|0)f[a+128>>2]=f[c+128>>2];if(e&2048|0)f[a+132>>2]=f[c+132>>2];if(e&4096|0)f[a+136>>2]=f[c+136>>2];if(e&8192|0)f[a+140>>2]=f[c+140>>2];if(e&16384|0)f[a+144>>2]=f[c+144>>2];if(e&32768|0)f[a+148>>2]=f[c+148>>2];i=a+8|0;f[i>>2]=f[i>>2]|e}if(e&16711680|0){if(e&65536|0)f[a+152>>2]=f[c+152>>2];if(e&131072|0)f[a+156>>2]=f[c+156>>2];if(e&262144|0)f[a+160>>2]=f[c+160>>2];if(e&524288|0)f[a+164>>2]=f[c+164>>2];if(e&1048576|0)b[a+168>>0]=b[c+168>>0]|0;if(e&2097152|0)b[a+169>>0]=b[c+169>>0]|0;if(e&4194304|0)b[a+170>>0]=b[c+170>>0]|0;if(e&8388608|0)f[a+172>>2]=f[c+172>>2];i=a+8|0;f[i>>2]=f[i>>2]|e}if(e>>>0>16777215){if(e&16777216|0)f[a+176>>2]=f[c+176>>2];if(e&33554432|0){i=c+184|0;d=f[i+4>>2]|0;k=a+184|0;f[k>>2]=f[i>>2];f[k+4>>2]=d}if(e&67108864|0)f[a+192>>2]=f[c+192>>2];if(e&134217728|0)b[a+196>>0]=b[c+196>>0]|0;if(e&268435456|0)b[a+197>>0]=b[c+197>>0]|0;if(e&536870912|0)f[a+200>>2]=f[c+200>>2];if(e&1073741824|0)f[a+204>>2]=f[c+204>>2];if((e|0)<0)f[a+208>>2]=f[c+208>>2];d=a+8|0;f[d>>2]=f[d>>2]|e}e=f[c+12>>2]|0;if(!(e&7))return;if(e&1|0)f[a+212>>2]=f[c+212>>2];if(e&2|0)f[a+216>>2]=f[c+216>>2];if(e&4|0)f[a+220>>2]=f[c+220>>2];c=a+12|0;f[c>>2]=f[c>>2]|e;return}function dfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Efb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(104)|0;ffb(l);Efb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16040,104);l=NQb(i,104,1756)|0;ffb(l);Efb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function efb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Cfb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(40)|0;veb(l);Cfb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,15992,40);l=NQb(i,40,1757)|0;veb(l);Cfb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function ffb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;e=c;f[a>>2]=95252;f[a+4>>2]=0;f[a+8>>2]=0;g=(a|0)==521656;h=a+16|0;i=h+76|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));if(!g?(f[220372]|0)!=2:0){f[e>>2]=161028;f[e+4>>2]=35;b[e+8>>0]=0;DTb(881488,e);ZSb(e)}f[a+12>>2]=0;f[a+92>>2]=527320;e=a+96|0;f[e>>2]=0;d[e+4>>1]=0;u=c;return}function gfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}hfb(a+16|0,c+16|0);yNa(a+32|0,c+32|0);e=a+48|0;h=c+48|0;g=f[h>>2]|0;if(g|0){KLa(e,(f[e>>2]|0)+g|0);dJc((f[a+56>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+56>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}F0a(a+60|0,c+60|0);ifb(a+76|0,c+76|0);h=f[c+8>>2]|0;if(!(h&15))return;do if(h&1|0?(e=a+8|0,f[e>>2]=f[e>>2]|1,e=a+92|0,g=f[c+92>>2]|0,d=f[e>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(e,g);break}else{iEc(d,g)|0;break}while(0);if(h&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+96|0;d=f[g>>2]|0;if(!d){e=VDc(40)|0;veb(e);f[g>>2]=e;i=e}else i=d;d=f[c+96>>2]|0;e=d|0?d:522040;d=i+4|0;g=f[e+4>>2]|0;if(g&1|0){j=f[d>>2]|0;if(!(j&1))k=mNa(d)|0;else k=j&-2;ojc(k,g&-2)}yNa(i+16|0,e+16|0);g=f[e+8>>2]|0;if(g&3|0){if(g&1|0)f[i+32>>2]=f[e+32>>2];if(g&2|0)f[i+36>>2]=f[e+36>>2];e=i+8|0;f[e>>2]=f[e>>2]|g}}if(h&4|0)b[a+100>>0]=b[c+100>>0]|0;if(h&8|0)b[a+101>>0]=b[c+101>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|h;return}function hfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{kfb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(296)|0;h6a(l);kfb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,15112,296);l=NQb(i,296,1738)|0;h6a(l);kfb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function ifb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{jfb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(368)|0;deb(l);jfb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,15896,368);l=NQb(i,368,1740)|0;deb(l);jfb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function jfb(a,b){a=a|0;b=b|0;scb(b,a);return}function kfb(a,b){a=a|0;b=b|0;kYa(b,a);return}function lfb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=95252;c=f[a+92>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=521656?(c=f[a+96>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+88|0;d=f[c>>2]|0;if(d|0?(f[a+76>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+72|0;i=f[c>>2]|0;if(i|0?(f[a+60>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=f[a+56>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+44|0;j=f[c>>2]|0;if(j|0?(f[a+32>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+28|0;k=f[c>>2]|0;if(k|0?(f[a+16>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;YDc(l)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}l=a&-2;a=l;if((l|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(l);f[c>>2]=0;return}function mfb(a){a=a|0;lfb(a);YDc(a);return}function nfb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function ofb(a,b){a=a|0;b=b|0;a=VDc(104)|0;ffb(a);if(!b)return a|0;Bfb(b,a);return a|0}function pfb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0;c=a+20|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+28>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((h|0)!=(e|0));f[c>>2]=0}c=a+36|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+44>>2]|0;g=0;do{i=f[h+4+(g<<2)>>2]|0;g=g+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((g|0)!=(e|0));f[c>>2]=0}f[a+48>>2]=0;c=a+64|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+72>>2]|0;h=0;do{j=f[g+4+(h<<2)>>2]|0;h=h+1|0;Yi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((h|0)!=(e|0));f[c>>2]=0}c=a+80|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+88>>2]|0;g=0;do{j=f[h+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((g|0)!=(e|0));f[c>>2]=0}c=a+8|0;e=f[c>>2]|0;if(e&3|0){do if(e&1|0){g=f[a+92>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&2|0){e=f[a+96>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}d[a+100>>1]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function qfb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+88|0;c=f[a+80>>2]|0;while(1){if((c|0)<=0){d=1;e=4;break}c=c+-1|0;a=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){d=0;e=4;break}}if((e|0)==4)return d|0;return 0}function rfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+92|0;k=a+16|0;l=a+28|0;m=a+24|0;n=a+20|0;o=e+4|0;p=a+32|0;q=a+48|0;r=a+52|0;s=a+56|0;t=a+100|0;v=e+8|0;w=a+96|0;x=e+4|0;y=a+101|0;z=e+8|0;A=a+60|0;B=e+4|0;C=a+76|0;D=a+88|0;E=a+84|0;F=a+80|0;G=e+4|0;H=a+4|0;a:while(1){a=f[c>>2]|0;I=f[g>>2]|0;do if(a>>>0<I>>>0){K=b[a>>0]|0;L=K&255;M=a+1|0;if(K<<24>>24>0){N=M;O=L}else{if(M>>>0>=I>>>0){P=L;Q=7;break}K=h[M>>0]|0;if(((K^128)&L)>>>0<=127){P=L;Q=7;break}N=a+2|0;O=L+-128+(K<<7)|0}f[c>>2]=N;R=O;Q=9}else{P=0;Q=7}while(0);if((Q|0)==7){Q=0;a=WRb(c,P)|0;if((a+-1|0)>>>0<16383){R=a;Q=9}else S=a}b:do if((Q|0)==9){Q=0;switch(R>>>3&536870911|0){case 1:{if((R&255|0)!=10){S=R;break b}f[i>>2]=f[i>>2]|1;a=f[j>>2]|0;if((a|0)==527320){GLa(j,527320);T=f[j>>2]|0}else T=a;if(fUb(c,T)|0)continue a;else{U=0;Q=112;break a}break}case 2:{if((R&255|0)!=18){S=R;break b}a=f[l>>2]|0;do if(a){I=f[n>>2]|0;K=f[a>>2]|0;if((I|0)>=(K|0))if((K|0)==(f[m>>2]|0)){V=K;Q=20;break}else{W=K;X=a;Q=21;break}else{f[n>>2]=I+1;Y=f[a+4+(I<<2)>>2]|0;break}}else{V=f[m>>2]|0;Q=20}while(0);if((Q|0)==20){Q=0;USb(k,V+1|0);a=f[l>>2]|0;W=f[a>>2]|0;X=a;Q=21}if((Q|0)==21){Q=0;f[X>>2]=W+1;a=f[k>>2]|0;if(!a){I=VDc(296)|0;h6a(I);Z=I}else{if(f[a+64>>2]|0)OQb(a,15112,296);I=NQb(a,296,1738)|0;h6a(I);Z=I}I=f[l>>2]|0;a=f[n>>2]|0;f[n>>2]=a+1;f[I+4+(a<<2)>>2]=Z;Y=Z}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(I=b[a>>0]|0,I<<24>>24>-1):0){f[c>>2]=a+1;_=I&255}else{I=VRb(c)|0;if((I|0)>-1)_=I;else{U=0;Q=112;break a}}GRb(e,c,_);if((f[o>>2]|0)<0){Q=33;break a}if(!(Mi[f[(f[Y>>2]|0)+44>>2]&1023](Y,c)|0)){Q=33;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;Q=112;break a}break}case 3:{if((R&255|0)!=26){S=R;break b}if(fUb(c,JLa(p)|0)|0)continue a;else{U=0;Q=112;break a}break}case 4:{switch((R&255)<<24>>24){case 32:break;case 34:{if(Afb(c,q)|0)continue a;else{U=0;Q=112;break a}break}default:{S=R;break b}}I=f[c>>2]|0;if(I>>>0<(f[g>>2]|0)>>>0){a=b[I>>0]|0;K=a&255;if(a<<24>>24>-1){f[c>>2]=I+1;$=K}else{aa=K;Q=41}}else{aa=0;Q=41}if((Q|0)==41){Q=0;K=HRb(c,aa)|0;I=J;if((I|0)>-1|(I|0)==-1&K>>>0>4294967295)$=K;else{U=0;Q=112;break a}}K=f[q>>2]|0;if((K|0)==(f[r>>2]|0)){KLa(q,K+1|0);ba=f[q>>2]|0}else ba=K;K=f[s>>2]|0;f[q>>2]=ba+1;f[K+4+(ba<<2)>>2]=$;I=(f[r>>2]|0)-(f[q>>2]|0)|0;if((I|0)>0){ca=I;da=K}else continue a;while(1){K=f[c>>2]|0;I=f[g>>2]|0;if(K>>>0>=I>>>0)continue a;if((b[K>>0]|0)!=32)continue a;a=K+1|0;f[c>>2]=a;if(a>>>0<I>>>0){I=b[a>>0]|0;a=I&255;if(I<<24>>24>-1){f[c>>2]=K+2;ea=a;fa=da}else{ga=a;Q=49}}else{ga=0;Q=49}if((Q|0)==49){Q=0;a=HRb(c,ga)|0;K=J;if(!((K|0)>-1|(K|0)==-1&a>>>0>4294967295)){U=0;Q=112;break a}ea=a;fa=f[s>>2]|0}a=f[q>>2]|0;f[q>>2]=a+1;f[fa+4+(a<<2)>>2]=ea;if((ca|0)>1){ca=ca+-1|0;da=fa}else continue a}break}case 5:{if((R&255|0)!=40){S=R;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(K=b[a>>0]|0,K<<24>>24>-1):0){f[c>>2]=a+1;ha=K<<24>>24!=0}else{IRb(e,c);K=e;if(!(b[v>>0]|0)){U=0;Q=112;break a}else ha=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0}b[t>>0]=ha&1;continue a;break}case 6:{if((R&255|0)!=50){S=R;break b}f[i>>2]=f[i>>2]|2;K=f[w>>2]|0;if(!K){a=VDc(40)|0;veb(a);f[w>>2]=a;ia=a}else ia=K;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(a=b[K>>0]|0,a<<24>>24>-1):0){f[c>>2]=K+1;ja=a&255}else{a=VRb(c)|0;if((a|0)>-1)ja=a;else{U=0;Q=112;break a}}GRb(e,c,ja);if((f[x>>2]|0)<0){Q=69;break a}if(!(Mi[f[(f[ia>>2]|0)+44>>2]&1023](ia,c)|0)){Q=69;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;Q=112;break a}break}case 7:{if((R&255|0)!=56){S=R;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(K=b[a>>0]|0,K<<24>>24>-1):0){f[c>>2]=a+1;ka=K<<24>>24!=0}else{IRb(e,c);K=e;if(!(b[z>>0]|0)){U=0;Q=112;break a}else ka=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0}b[y>>0]=ka&1;continue a;break}case 8:{if((R&255|0)!=66){S=R;break b}K=Z0a(A)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(I=b[a>>0]|0,I<<24>>24>-1):0){f[c>>2]=a+1;la=I&255}else{I=VRb(c)|0;if((I|0)>-1)la=I;else{U=0;Q=112;break a}}GRb(e,c,la);if((f[B>>2]|0)<0){Q=84;break a}if(!(Mi[f[(f[K>>2]|0)+44>>2]&1023](K,c)|0)){Q=84;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;Q=112;break a}break}case 100:{if((R&255|0)!=34){S=R;break b}K=f[D>>2]|0;do if(K){I=f[F>>2]|0;a=f[K>>2]|0;if((I|0)>=(a|0))if((a|0)==(f[E>>2]|0)){ma=a;Q=92;break}else{na=a;oa=K;Q=93;break}else{f[F>>2]=I+1;pa=f[K+4+(I<<2)>>2]|0;break}}else{ma=f[E>>2]|0;Q=92}while(0);if((Q|0)==92){Q=0;USb(C,ma+1|0);K=f[D>>2]|0;na=f[K>>2]|0;oa=K;Q=93}if((Q|0)==93){Q=0;f[oa>>2]=na+1;K=f[C>>2]|0;if(!K){I=VDc(368)|0;deb(I);qa=I}else{if(f[K+64>>2]|0)OQb(K,15896,368);I=NQb(K,368,1740)|0;deb(I);qa=I}I=f[D>>2]|0;K=f[F>>2]|0;f[F>>2]=K+1;f[I+4+(K<<2)>>2]=qa;pa=qa}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(I=b[K>>0]|0,I<<24>>24>-1):0){f[c>>2]=K+1;ra=I&255}else{I=VRb(c)|0;if((I|0)>-1)ra=I;else{U=0;Q=112;break a}}GRb(e,c,ra);if((f[G>>2]|0)<0){Q=105;break a}if(!(Mi[f[(f[pa>>2]|0)+44>>2]&1023](pa,c)|0)){Q=105;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;Q=112;break a}break}default:{S=R;break b}}}while(0);if(!S){U=1;Q=112;break}I=f[H>>2]|0;if(!(I&1))sa=mNa(H)|0;else sa=I&-2;if(!(Djc(c,S,sa)|0)){U=0;Q=112;break}}if((Q|0)==33){U=0;u=d;return U|0}else if((Q|0)==69){U=0;u=d;return U|0}else if((Q|0)==84){U=0;u=d;return U|0}else if((Q|0)==105){U=0;u=d;return U|0}else if((Q|0)==112){u=d;return U|0}return 0}function sfb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if((i|0)>0){g=f[a+44>>2]|0;h=0;d=c;while(1){e=f[g+4+(h<<2)>>2]|0;j=b[e+11>>0]|0;k=j<<24>>24<0?f[e+4>>2]|0:j&255;j=k+d+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){l=j;break}else d=j}}else l=c;c=hUb(a+48|0)|0;d=f[a+64>>2]|0;i=c+l+(f[a+48>>2]|0)+d|0;if(!d)m=i;else{l=a+72|0;c=0;h=i;while(1){i=f[(f[l>>2]|0)+4+(c<<2)>>2]|0;g=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=g+h+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(d|0)){m=i;break}else h=i}}h=f[a+80>>2]|0;d=(h<<1)+m|0;if(!h)n=d;else{m=a+88|0;c=0;l=d;while(1){d=f[(f[m>>2]|0)+4+(c<<2)>>2]|0;i=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=i+l+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(h|0)){n=d;break}else l=d}}l=a+8|0;h=f[l>>2]|0;if(!(h&15)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(h&1))q=n;else{c=f[a+92>>2]|0;m=b[c+11>>0]|0;d=m<<24>>24<0?f[c+4>>2]|0:m&255;q=n+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(h&2)){r=q;s=h}else{h=f[a+96>>2]|0;d=_i[f[(f[h>>2]|0)+48>>2]&1023](h)|0;h=q+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=h;s=f[l>>2]|0}l=s&4|0?r+2|0:r;o=s&8|0?l+2|0:l;p=a+12|0;f[p>>2]=o;return o|0}function tfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&1|0)$Tb(1,f[a+92>>2]|0,c);e=f[a+20>>2]|0;if(e|0){g=a+28|0;h=0;do{eUb(2,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+36>>2]|0;if((e|0)>0){h=a+44|0;g=0;do{_Tb(3,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}e=f[a+48>>2]|0;if((e|0)>0){g=a+56|0;h=0;do{MTb(4,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}if(d&4|0)YTb(5,(b[a+100>>0]|0)!=0,c);if(d&2|0)eUb(6,f[a+96>>2]|0,c);if(d&8|0)YTb(7,(b[a+101>>0]|0)!=0,c);d=f[a+64>>2]|0;if(d|0){e=a+72|0;h=0;do{eUb(8,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(d|0))}d=f[a+80>>2]|0;if(d|0){h=a+88|0;e=0;do{eUb(100,f[(f[h>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)!=(d|0))}d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function ufb(a){a=a|0;return f[a+12>>2]|0}function vfb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+92>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}d=f[a+20>>2]|0;if(!d)i=g;else{h=a+28|0;j=0;k=g;while(1){g=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;l=k+1|0;m=_i[f[(f[g>>2]|0)+60>>2]&1023](g)|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=l;s=m}b[r>>0]=s;o=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,r+1|0)|0;j=j+1|0;if((j|0)==(d|0)){i=o;break}else k=o}}k=f[a+36>>2]|0;if((k|0)>0){d=a+44|0;j=0;r=i;while(1){s=f[(f[d>>2]|0)+4+(j<<2)>>2]|0;b[r>>0]=26;h=dSb(s,r+1|0)|0;j=j+1|0;if((j|0)==(k|0)){t=h;break}else r=h}}else t=i;i=f[a+48>>2]|0;if(!i)u=t;else{r=f[a+56>>2]|0;k=0;j=t;while(1){t=f[r+4+(k<<2)>>2]|0;b[j>>0]=32;d=j+1|0;h=t&255;if(t>>>0>127){s=d;o=h;n=t;p=((t|0)<0)<<31>>31;while(1){b[s>>0]=o|-128;t=n;n=aJc(n|0,p|0,7)|0;q=s+1|0;v=n&255;if(!(p>>>0>0|(p|0)==0&t>>>0>16383)){w=q;x=v;break}else{s=q;o=v;p=J}}}else{w=d;x=h}b[w>>0]=x;p=w+1|0;k=k+1|0;if((k|0)>=(i|0)){u=p;break}else j=p}}if(!(e&4))y=u;else{j=b[a+100>>0]|0;b[u>>0]=40;b[u+1>>0]=j;y=u+2|0}if(!(e&2))z=y;else{u=f[a+96>>2]|0;b[y>>0]=50;j=y+1|0;y=_i[f[(f[u>>2]|0)+60>>2]&1023](u)|0;if(y>>>0>127){i=y;k=j;while(1){b[k>>0]=i|128;w=i>>>7;x=k+1|0;if(i>>>0>16383){i=w;k=x}else{A=x;B=w;break}}}else{A=j;B=y}b[A>>0]=B;z=hj[f[(f[u>>2]|0)+64>>2]&511](u,c,A+1|0)|0}if(!(e&8))C=z;else{e=b[a+101>>0]|0;b[z>>0]=56;b[z+1>>0]=e;C=z+2|0}z=f[a+64>>2]|0;if(!z)D=C;else{e=a+72|0;A=0;u=C;while(1){C=f[(f[e>>2]|0)+4+(A<<2)>>2]|0;b[u>>0]=66;B=u+1|0;y=_i[f[(f[C>>2]|0)+60>>2]&1023](C)|0;if(y>>>0>127){j=y;k=B;while(1){b[k>>0]=j|128;i=j>>>7;w=k+1|0;if(j>>>0>16383){j=i;k=w}else{E=w;F=i;break}}}else{E=B;F=y}b[E>>0]=F;k=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,E+1|0)|0;A=A+1|0;if((A|0)==(z|0)){D=k;break}else u=k}}u=f[a+80>>2]|0;if(!u)G=D;else{z=a+88|0;A=0;E=D;while(1){D=f[(f[z>>2]|0)+4+(A<<2)>>2]|0;b[E>>0]=-94;b[E+1>>0]=6;F=E+2|0;e=_i[f[(f[D>>2]|0)+60>>2]&1023](D)|0;if(e>>>0>127){k=e;j=F;while(1){b[j>>0]=k|128;h=k>>>7;d=j+1|0;if(k>>>0>16383){k=h;j=d}else{H=d;I=h;break}}}else{H=F;I=e}b[H>>0]=I;j=hj[f[(f[D>>2]|0)+64>>2]&511](D,c,H+1|0)|0;A=A+1|0;if((A|0)==(u|0)){G=j;break}else E=j}}E=f[a+4>>2]|0;if(!(E&1)){K=G;return K|0}K=Hjc(E&-2,G)|0;return K|0}function wfb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function xfb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16040,0)|0;if(!c){Ehc(b,a);return}else{gfb(a,c);return}}function yfb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function zfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525152;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Afb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;if(d>>>0<(f[e>>2]|0)>>>0?(g=b[d>>0]|0,g<<24>>24>-1):0){f[a>>2]=d+1;h=g&255}else{g=VRb(a)|0;if((g|0)>-1)h=g;else{i=0;return i|0}}g=ERb(a,h)|0;a:do if((MRb(a)|0)>0){h=c+4|0;d=c+8|0;while(1){j=f[a>>2]|0;if(j>>>0<(f[e>>2]|0)>>>0){k=b[j>>0]|0;l=k&255;if(k<<24>>24>-1){f[a>>2]=j+1;m=l}else{n=l;o=10}}else{n=0;o=10}if((o|0)==10){o=0;l=HRb(a,n)|0;j=J;if((j|0)>-1|(j|0)==-1&l>>>0>4294967295)m=l;else{i=0;break}}l=f[c>>2]|0;if((l|0)==(f[h>>2]|0)){KLa(c,l+1|0);p=f[c>>2]|0}else p=l;l=f[d>>2]|0;f[c>>2]=p+1;f[l+4+(p<<2)>>2]=m;if((MRb(a)|0)<=0)break a}return i|0}while(0);FRb(a,g);i=1;return i|0}function Bfb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Cfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=b+4|0;d=f[a+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}yNa(b+16|0,a+16|0);d=f[a+8>>2]|0;if(!(d&3))return;if(d&1|0)f[b+32>>2]=f[a+32>>2];if(d&2|0)f[b+36>>2]=f[a+36>>2];a=b+8|0;f[a>>2]=f[a>>2]|d;return}function Dfb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function Efb(a,b){a=a|0;b=b|0;gfb(b,a);return}function Ffb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function Gfb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=95144;e=(a|0)==521760;g=a+4|0;h=g+84|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220373]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=36;b[d+8>>0]=0;DTb(881492,d);ZSb(d)}f[a+88>>2]=527320;f[a+92>>2]=527320;f[a+96>>2]=527320;f[a+100>>2]=527320;f[a+104>>2]=525016;f[a+108>>2]=525032;g=a+112|0;h=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));n[a+176>>2]=.9990000128746033;g=a+184|0;f[g>>2]=-1;f[g+4>>2]=-1;f[a+192>>2]=1;b[a+196>>0]=1;b[a+197>>0]=1;n[a+200>>2]=9.99999993922529e-09;f[a+204>>2]=1;n[a+208>>2]=-1.0;f[a+212>>2]=1;f[a+216>>2]=1;n[a+220>>2]=.9900000095367432;f[a+224>>2]=0;u=c;return}function Hfb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Ifb(a){a=a|0;var c=0;c=f[a+88>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+92>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+96>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+100>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+104>>2]|0;if(!((c|0)==525016|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+108>>2]|0;if(!((c|0)==525032|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==521760)return;c=f[a+112>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+116>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+120>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function Jfb(a){a=a|0;var c=0,d=0;f[a>>2]=95360;c=f[a+28>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function Kfb(a){a=a|0;Jfb(a);YDc(a);return}function Lfb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Mfb(a,b){a=a|0;b=b|0;a=VDc(52)|0;Zfb(a);if(!b)return a|0;_fb(b,a);return a|0}function Nfb(a){a=a|0;var c=0,d=0,e=0,g=0;f[a+16>>2]=0;c=a+8|0;d=f[c>>2]|0;do if(d&1|0){e=f[a+28>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&62|0){d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;b[d+16>>0]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Ofb(a){a=a|0;return 1}function Pfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+32|0;k=a+36|0;l=a+40|0;m=a+28|0;n=a+44|0;o=a+16|0;p=a+20|0;q=a+24|0;r=a+48|0;s=e+8|0;t=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){v=b[a>>0]|0;w=v&255;if(v<<24>>24>0){f[c>>2]=a+1;x=w;y=6}else{z=w;y=5}}else{z=0;y=5}if((y|0)==5){y=0;w=WRb(c,z)|0;if((w+-1|0)>>>0<127){x=w;y=6}else A=w}b:do if((y|0)==6){y=0;switch(x>>>3&536870911|0){case 1:{if((x&255|0)!=8){A=x;break b}f[i>>2]=f[i>>2]|2;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){a=b[w>>0]|0;v=a&255;if(a<<24>>24>-1){f[c>>2]=w+1;B=v}else{C=v;y=11}}else{C=0;y=11}if((y|0)==11){y=0;v=HRb(c,C)|0;w=J;if((w|0)>-1|(w|0)==-1&v>>>0>4294967295)B=v;else{D=0;y=63;break a}}f[j>>2]=B;continue a;break}case 2:{if((x&255|0)!=16){A=x;break b}f[i>>2]=f[i>>2]|4;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){w=b[v>>0]|0;a=w&255;if(w<<24>>24>-1){f[c>>2]=v+1;E=a}else{F=a;y=17}}else{F=0;y=17}if((y|0)==17){y=0;a=HRb(c,F)|0;v=J;if((v|0)>-1|(v|0)==-1&a>>>0>4294967295)E=a;else{D=0;y=63;break a}}f[k>>2]=E;continue a;break}case 3:{if((x&255|0)!=24){A=x;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){v=b[a>>0]|0;w=v&255;if(v<<24>>24>-1){f[c>>2]=a+1;G=w}else{H=w;y=23}}else{H=0;y=23}if((y|0)==23){y=0;w=HRb(c,H)|0;a=J;if((a|0)>-1|(a|0)==-1&w>>>0>4294967295)G=w;else{D=0;y=63;break a}}f[l>>2]=G;continue a;break}case 4:{if((x&255|0)!=34){A=x;break b}f[i>>2]=f[i>>2]|1;w=f[m>>2]|0;if((w|0)==527320){GLa(m,527320);I=f[m>>2]|0}else I=w;if(fUb(c,I)|0)continue a;else{D=0;y=63;break a}break}case 5:{if((x&255|0)!=40){A=x;break b}f[i>>2]=f[i>>2]|16;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){a=b[w>>0]|0;v=a&255;if(a<<24>>24>-1){f[c>>2]=w+1;K=v}else{L=v;y=33}}else{L=0;y=33}if((y|0)==33){y=0;v=HRb(c,L)|0;w=J;if((w|0)>-1|(w|0)==-1&v>>>0>4294967295)K=v;else{D=0;y=63;break a}}f[n>>2]=K;continue a;break}case 6:{switch((x&255)<<24>>24){case 53:break;case 50:{if(BVa(c,o)|0)continue a;else{D=0;y=63;break a}break}default:{A=x;break b}}v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){w=v;a=h[w>>0]|h[w+1>>0]<<8|h[w+2>>0]<<16|h[w+3>>0]<<24;f[e>>2]=a;f[c>>2]=v+4;M=a}else{if(!(TRb(c,e)|0)){y=50;break a}M=f[e>>2]|0}a=f[o>>2]|0;if((a|0)==(f[p>>2]|0)){SHa(o,a+1|0);N=f[o>>2]|0}else N=a;a=f[q>>2]|0;v=N+1|0;f[o>>2]=v;f[a+4+(N<<2)>>2]=M;w=f[c>>2]|0;O=(f[g>>2]|0)-w|0;if((O|0)<=0)continue a;P=w;w=(f[p>>2]|0)-v|0;Q=(O>>>0)/5|0;R=(Q|0)<(w|0)?Q:w;if((R|0)>0){S=0;T=P;U=v}else continue a;while(1){if((b[T>>0]|0)!=53){V=S;break}v=T+1|0;w=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;v=U;U=U+1|0;f[o>>2]=U;f[a+4+(v<<2)>>2]=w;w=S+1|0;if((w|0)>=(R|0)){V=w;break}else{S=w;T=T+5|0}}R=V*5|0;if((V|0)<=0)continue a;if((O|0)<(R|0)){PRb(c,R,O)|0;continue a}else{f[c>>2]=P+R;continue a}break}case 7:{if((x&255|0)!=56){A=x;break b}f[i>>2]=f[i>>2]|32;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;W=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[s>>0]|0)){D=0;y=63;break a}else W=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[r>>0]=W&1;continue a;break}default:{A=x;break b}}}while(0);if(!A){D=1;y=63;break}a=f[t>>2]|0;if(!(a&1))X=mNa(t)|0;else X=a&-2;if(!(Djc(c,A,X)|0)){D=0;y=63;break}}if((y|0)==50){D=0;u=d;return D|0}else if((y|0)==63){u=d;return D|0}return 0}function Qfb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+16>>2]|0;e=c+d+(c<<2)|0;c=f[a+8>>2]|0;if(!(c&63)){g=e;h=a+12|0;f[h>>2]=g;return g|0}if(!(c&1))i=e;else{d=f[a+28>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;i=e+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=i;else{k=f[a+32>>2]|0;if((k|0)<0)m=11;else m=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+i|0}if(!(c&4))n=l;else{i=f[a+36>>2]|0;if((i|0)<0)o=11;else o=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=o+l|0}if(!(c&8))p=n;else{l=f[a+40>>2]|0;if((l|0)<0)q=11;else q=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;p=q+n|0}if(!(c&16))r=p;else{n=f[a+44>>2]|0;if((n|0)<0)s=11;else s=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+p|0}g=c&32|0?r+2|0:r;h=a+12|0;f[h>>2]=g;return g|0}function Rfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&2|0)MTb(1,f[a+32>>2]|0,c);if(d&4|0)MTb(2,f[a+36>>2]|0,c);if(d&8|0)MTb(3,f[a+40>>2]|0,c);if(d&1|0)bUb(4,f[a+28>>2]|0,c);if(d&16|0)MTb(5,f[a+44>>2]|0,c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{WTb(6,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}if(d&32|0)YTb(7,(b[a+48>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Sfb(a){a=a|0;return f[a+12>>2]|0}function Tfb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+32>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&4))q=e;else{o=f[a+36>>2]|0;b[e>>0]=16;p=e+1|0;e=o&255;if(o>>>0>127){d=p;h=e;l=o;j=((o|0)<0)<<31>>31;while(1){b[d>>0]=h|-128;o=l;l=aJc(l|0,j|0,7)|0;i=d+1|0;k=l&255;if(!(j>>>0>0|(j|0)==0&o>>>0>16383)){r=i;s=k;break}else{d=i;h=k;j=J}}}else{r=p;s=e}b[r>>0]=s;q=r+1|0}if(!(c&8))t=q;else{r=f[a+40>>2]|0;b[q>>0]=24;s=q+1|0;q=r&255;if(r>>>0>127){e=s;p=q;j=r;h=((r|0)<0)<<31>>31;while(1){b[e>>0]=p|-128;r=j;j=aJc(j|0,h|0,7)|0;d=e+1|0;l=j&255;if(!(h>>>0>0|(h|0)==0&r>>>0>16383)){u=d;v=l;break}else{e=d;p=l;h=J}}}else{u=s;v=q}b[u>>0]=v;t=u+1|0}if(!(c&1))w=t;else{u=f[a+28>>2]|0;b[t>>0]=34;w=dSb(u,t+1|0)|0}if(!(c&16))x=w;else{t=f[a+44>>2]|0;b[w>>0]=40;u=w+1|0;w=t&255;if(t>>>0>127){v=u;q=w;s=t;h=((t|0)<0)<<31>>31;while(1){b[v>>0]=q|-128;t=s;s=aJc(s|0,h|0,7)|0;p=v+1|0;e=s&255;if(!(h>>>0>0|(h|0)==0&t>>>0>16383)){y=p;z=e;break}else{v=p;q=e;h=J}}}else{y=u;z=w}b[y>>0]=z;x=y+1|0}y=f[a+16>>2]|0;if(!y)A=x;else{z=f[a+24>>2]|0;w=0;u=x;while(1){x=f[z+4+(w<<2)>>2]|0;b[u>>0]=53;h=u+1|0;b[h>>0]=x;b[h+1>>0]=x>>8;b[h+2>>0]=x>>16;b[h+3>>0]=x>>24;x=u+5|0;w=w+1|0;if((w|0)>=(y|0)){A=x;break}else u=x}}if(!(c&32))B=A;else{c=b[a+48>>0]|0;b[A>>0]=56;b[A+1>>0]=c;B=A+2|0}A=f[a+4>>2]|0;if(!(A&1)){C=B;return C|0}C=Hjc(A&-2,B)|0;return C|0}function Ufb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Vfb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16056,0)|0;if(!c){Ehc(b,a);return}else{Yfb(a,c);return}}function Wfb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Xfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525136;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Yfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=f[c+8>>2]|0;if(!(h&63))return;do if(h&1|0?(e=a+8|0,f[e>>2]=f[e>>2]|1,e=a+28|0,g=f[c+28>>2]|0,d=f[e>>2]|0,(d|0)!=(g|0)):0)if((d|0)==527320){GLa(e,g);break}else{iEc(d,g)|0;break}while(0);if(h&2|0)f[a+32>>2]=f[c+32>>2];if(h&4|0)f[a+36>>2]=f[c+36>>2];if(h&8|0)f[a+40>>2]=f[c+40>>2];if(h&16|0)f[a+44>>2]=f[c+44>>2];if(h&32|0)b[a+48>>0]=b[c+48>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|h;return}function Zfb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=95360;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=521552?(f[220370]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=33;b[d+8>>0]=0;DTb(881480,d);ZSb(d)}f[a+12>>2]=0;f[a+28>>2]=527320;d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;b[d+16>>0]=0;u=c;return}function _fb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function $fb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=95468;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function agb(a){a=a|0;$fb(a);YDc(a);return}function bgb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function cgb(a,b){a=a|0;b=b|0;a=VDc(32)|0;ogb(a);if(!b)return a|0;pgb(b,a);return a|0}function dgb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function egb(a){a=a|0;return 1}function fgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=e+4|0;j=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=6}else{o=l;n=5}}else{o=0;n=5}if((n|0)==5){n=0;l=WRb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=6}else p=l}if((n|0)==6){n=0;if((m|0)==10){l=AXa(h)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(k=b[a>>0]|0,k<<24>>24>-1):0){f[c>>2]=a+1;q=k&255}else{k=VRb(c)|0;if((k|0)>-1)q=k;else{r=0;n=20;break}}GRb(e,c,q);if((f[i>>2]|0)<0){n=13;break}if(!(Mi[f[(f[l>>2]|0)+44>>2]&1023](l,c)|0)){n=13;break}if(LRb(c,f[e>>2]|0)|0)continue;else{r=0;n=20;break}}else p=m}if(!p){r=1;n=20;break}l=f[j>>2]|0;if(!(l&1))s=mNa(j)|0;else s=l&-2;if(!(Djc(c,p,s)|0)){r=0;n=20;break}}if((n|0)==13){r=0;u=d;return r|0}else if((n|0)==20){u=d;return r|0}return 0}function ggb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function hgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function igb(a){a=a|0;return f[a+12>>2]|0}function jgb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Hjc(j&-2,g)|0;return s|0}function kgb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function lgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,16072,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}PLa(a+16|0,c+16|0);return}function mgb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ngb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220361]|0)!=2){f[d>>2]=161028;f[d+4>>2]=24;b[d+8>>0]=0;DTb(881444,d);ZSb(d)}d=525096;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function ogb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=95468;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=521272?(f[220365]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=28;b[d+8>>0]=0;DTb(881460,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function pgb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function qgb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function rgb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220362]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=25;b[c+8>>0]=0;DTb(881448,c);ZSb(c);u=a;return}function sgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);CWa(a,b);return}function tgb(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=95252;c=a+4|0;f[c>>2]=0;e=b+8|0;f[a+8>>2]=f[e>>2];g=a+12|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;hfb(a+16|0,b+16|0);g=a+32|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;yNa(g,b+32|0);g=a+48|0;f[g>>2]=0;f[a+52>>2]=0;h=a+56|0;f[h>>2]=0;i=b+48|0;j=f[i>>2]|0;if(j|0){KLa(g,j);dJc((f[h>>2]|0)+4|0,(f[b+56>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[g>>2]=f[i>>2]}i=a+60|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;F0a(i,b+60|0);i=a+76|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;ifb(i,b+76|0);i=f[b+4>>2]|0;if(i&1|0){g=f[c>>2]|0;if(!(g&1))k=mNa(c)|0;else k=g&-2;ojc(k,i&-2)}i=a+92|0;f[i>>2]=527320;k=f[e>>2]|0;if((k&1|0)!=0?(g=f[b+92>>2]|0,(g|0)!=527320):0){GLa(i,g);l=f[e>>2]|0}else l=k;if(!(l&2)){m=0;n=a+96|0;f[n>>2]=m;o=a+100|0;p=b+100|0;q=d[p>>1]|0;d[o>>1]=q;return}l=VDc(40)|0;ugb(l,f[b+96>>2]|0);m=l;n=a+96|0;f[n>>2]=m;o=a+100|0;p=b+100|0;q=d[p>>1]|0;d[o>>1]=q;return}function ugb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=94928;c=a+4|0;f[c>>2]=0;f[a+8>>2]=f[b+8>>2];d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;yNa(a+16|0,b+16|0);d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=b+32|0;b=f[d+4>>2]|0;g=a+32|0;f[g>>2]=f[d>>2];f[g+4>>2]=b;return}function vgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);gfb(a,b);return}function wgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);R5a(a,b);return}function xgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=91904;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];f[a+12>>2]=0;e=f[b+4>>2]|0;if(e&1|0)ojc(mNa(c)|0,e&-2);e=a+16|0;f[e>>2]=527320;c=f[d>>2]|0;if((c&1|0)!=0?(g=f[b+16>>2]|0,(g|0)!=527320):0){GLa(e,g);h=f[d>>2]|0}else h=c;c=a+20|0;f[c>>2]=527320;if(h&2|0?(h=f[b+20>>2]|0,(h|0)!=527320):0)GLa(c,h);h=a+24|0;a=b+24|0;f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];return}function ygb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=91580;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];f[a+12>>2]=0;e=f[b+4>>2]|0;if(e&1|0)ojc(mNa(c)|0,e&-2);e=a+16|0;f[e>>2]=527320;c=f[d>>2]|0;if((c&1|0)!=0?(g=f[b+16>>2]|0,(g|0)!=527320):0){GLa(e,g);h=f[d>>2]|0}else h=c;c=a+20|0;f[c>>2]=527320;if((h&2|0)!=0?(g=f[b+20>>2]|0,(g|0)!=527320):0){GLa(c,g);i=f[d>>2]|0}else i=h;h=a+24|0;f[h>>2]=527320;if(i&4|0?(i=f[b+24>>2]|0,(i|0)!=527320):0)GLa(h,i);i=a+28|0;a=b+28|0;f[i>>2]=f[a>>2];f[i+4>>2]=f[a+4>>2];f[i+8>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];return}function zgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=91040;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];f[a+12>>2]=0;e=f[b+4>>2]|0;if(e&1|0)ojc(mNa(c)|0,e&-2);e=a+16|0;f[e>>2]=527320;c=f[d>>2]|0;if((c&1|0)!=0?(g=f[b+16>>2]|0,(g|0)!=527320):0){GLa(e,g);h=f[d>>2]|0}else h=c;c=a+20|0;f[c>>2]=527320;if((h&2|0)!=0?(g=f[b+20>>2]|0,(g|0)!=527320):0){GLa(c,g);i=f[d>>2]|0}else i=h;h=a+24|0;f[h>>2]=525048;if((i&4|0)!=0?(g=f[b+24>>2]|0,(g|0)!=525048):0){GLa(h,g);j=f[d>>2]|0}else j=i;i=a+28|0;f[i>>2]=527320;if(j&8|0?(j=f[b+28>>2]|0,(j|0)!=527320):0)GLa(i,j);j=a+32|0;a=b+32|0;f[j>>2]=f[a>>2];f[j+4>>2]=f[a+4>>2];f[j+8>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];return}function Agb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);UYa(a,b);return}function Bgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&7))return;if(e&1|0)f[a+16>>2]=f[c+16>>2];if(e&2|0)b[a+20>>0]=b[c+20>>0]|0;if(e&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Cgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Dgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&7))return;if(e&1|0)b[a+16>>0]=b[c+16>>0]|0;if(e&2|0)f[a+20>>2]=f[c+20>>2];if(e&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Egb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Fgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&3))return;if(e&1|0)b[a+16>>0]=b[c+16>>0]|0;if(e&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Ggb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);oYa(a,b);return}function Hgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);qYa(a,b);return}function Igb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&3))return;if(e&1|0)f[a+16>>2]=f[c+16>>2];if(e&2|0)b[a+20>>0]=b[c+20>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Jgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);MYa(a,b);return}function Kgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);JYa(a,b);return}function Lgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Mgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);tYa(a,b);return}function Ngb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[b+8>>2]&1))return;d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[b+16>>2]|0;b=f[d>>2]|0;if((b|0)==(a|0))return;if((b|0)==527320){GLa(d,a);return}else{iEc(b,a)|0;return}}function Ogb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[b+8>>2]&1))return;d=f[b+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|1;f[a+16>>2]=d;return}function Pgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);vYa(a,b);return}function Qgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[b+8>>2]&1))return;d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[b+16>>2]|0;b=f[d>>2]|0;if((b|0)==(a|0))return;if((b|0)==527320){GLa(d,a);return}else{iEc(b,a)|0;return}}function Rgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);yYa(a,b);return}function Sgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);AYa(a,b);return}function Tgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&15))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];if(d&8|0)f[a+28>>2]=f[b+28>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Ugb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&7))return;if(e&1|0)b[a+16>>0]=b[c+16>>0]|0;if(e&2|0)b[a+17>>0]=b[c+17>>0]|0;if(e&4|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Vgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);CYa(a,b);return}function Wgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Xgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Ygb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[b+8>>2]&1))return;d=f[b+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|1;f[a+16>>2]=d;return}function Zgb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);RYa(a,b);return}function _gb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function $gb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[b+8>>2]&1))return;d=f[b+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|1;f[a+16>>2]=d;return}function ahb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}if(!(f[b+8>>2]&1))return;d=f[b+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|1;f[a+16>>2]=d;return}function bhb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);EYa(a,b);return}function chb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);kYa(a,b);return}function dhb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=96372;mmb(a);c=a+84|0;d=f[c>>2]|0;if(d|0?(f[a+72>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+68|0;i=f[c>>2]|0;if(i|0?(f[a+56>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+52|0;j=f[c>>2]|0;if(j|0?(f[a+40>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=f[a+36>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(k);f[c>>2]=0;return}function ehb(a){a=a|0;dhb(a);YDc(a);return}function fhb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function ghb(a,b){a=a|0;b=b|0;a=VDc(128)|0;qlb(a);if(!b)return a|0;lmb(b,a);return a|0}function hhb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a+16>>2]=0;f[a+28>>2]=0;c=a+44|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+52>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+60|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+68>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((e|0)!=(d|0));f[c>>2]=0}c=a+76|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+84>>2]|0;g=0;do{i=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&63|0){do if(d&1|0){g=f[a+88>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+92>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+96>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&8|0){e=f[a+100>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&16|0){g=f[a+104>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}if(d&32|0){g=f[a+108>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}}if(d&192|0){d=a+112|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}f[a+124>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function ihb(a){a=a|0;return 1}function jhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+88|0;k=a+120|0;l=a+112|0;m=e+8|0;n=a+92|0;o=a+104|0;p=e+4|0;q=a+108|0;r=e+4|0;s=a+16|0;t=a+20|0;v=a+24|0;w=a+28|0;x=a+32|0;y=a+36|0;z=e+8|0;A=e+8|0;B=a+40|0;C=a+56|0;D=e+4|0;E=a+72|0;F=a+84|0;G=a+80|0;H=a+76|0;I=e+4|0;K=a+96|0;L=a+124|0;M=a+4|0;N=a+100|0;a:while(1){a=f[c>>2]|0;O=f[g>>2]|0;do if(a>>>0<O>>>0){P=b[a>>0]|0;Q=P&255;R=a+1|0;if(P<<24>>24>0){S=R;T=Q}else{if(R>>>0>=O>>>0){U=Q;V=7;break}P=h[R>>0]|0;if(((P^128)&Q)>>>0<=127){U=Q;V=7;break}S=a+2|0;T=Q+-128+(P<<7)|0}f[c>>2]=S;W=T;V=9}else{U=0;V=7}while(0);if((V|0)==7){V=0;a=WRb(c,U)|0;if((a+-1|0)>>>0<16383){W=a;V=9}else X=a}b:do if((V|0)==9){V=0;do switch(W>>>3&536870911|0){case 1:{if((W&255|0)!=10){X=W;break b}f[i>>2]=f[i>>2]|1;a=f[j>>2]|0;if((a|0)==527320){GLa(j,527320);Y=f[j>>2]|0}else Y=a;if(fUb(c,Y)|0)continue a;else{Z=0;V=143;break a}break}case 2:{if((W&255|0)!=21){X=W;break b}f[i>>2]=f[i>>2]|128;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){O=a;P=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;f[e>>2]=P;f[c>>2]=a+4;_=P}else{if(!(TRb(c,e)|0)){V=20;break a}_=f[e>>2]|0}f[k>>2]=_;continue a;break}case 3:{if((W&255|0)!=24){X=W;break b}f[i>>2]=f[i>>2]|64;P=f[c>>2]|0;if(P>>>0<(f[g>>2]|0)>>>0?(a=b[P>>0]|0,a<<24>>24>-1):0){f[c>>2]=P+1;$=a&255;aa=0}else{IRb(e,c);a=e;if(!(b[m>>0]|0)){Z=0;V=143;break a}else{$=f[a>>2]|0;aa=f[a+4>>2]|0}}a=l;f[a>>2]=$;f[a+4>>2]=aa;continue a;break}case 4:{if((W&255|0)!=34){X=W;break b}f[i>>2]=f[i>>2]|2;a=f[n>>2]|0;if((a|0)==527320){GLa(n,527320);ba=f[n>>2]|0}else ba=a;if(fUb(c,ba)|0)continue a;else{Z=0;V=143;break a}break}case 5:{if((W&255|0)!=42){X=W;break b}f[i>>2]=f[i>>2]|16;a=f[o>>2]|0;if(!a){P=VDc(144)|0;$jb(P);f[o>>2]=P;ca=P}else ca=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(P=b[a>>0]|0,P<<24>>24>-1):0){f[c>>2]=a+1;da=P&255}else{P=VRb(c)|0;if((P|0)>-1)da=P;else{Z=0;V=143;break a}}GRb(e,c,da);if((f[p>>2]|0)<0){V=40;break a}if(!(Mi[f[(f[ca>>2]|0)+44>>2]&1023](ca,c)|0)){V=40;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Z=0;V=143;break a}break}case 6:{if((W&255|0)!=50){X=W;break b}f[i>>2]=f[i>>2]|32;P=f[q>>2]|0;if(!P){a=VDc(104)|0;Mkb(a);f[q>>2]=a;ea=a}else ea=P;P=f[c>>2]|0;if(P>>>0<(f[g>>2]|0)>>>0?(a=b[P>>0]|0,a<<24>>24>-1):0){f[c>>2]=P+1;fa=a&255}else{a=VRb(c)|0;if((a|0)>-1)fa=a;else{Z=0;V=143;break a}}GRb(e,c,fa);if((f[r>>2]|0)<0){V=51;break a}if(!(Mi[f[(f[ea>>2]|0)+44>>2]&1023](ea,c)|0)){V=51;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Z=0;V=143;break a}break}case 7:{switch((W&255)<<24>>24){case 61:break;case 58:{if(BVa(c,s)|0)continue a;else{Z=0;V=143;break a}break}default:{X=W;break b}}a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){P=a;O=h[P>>0]|h[P+1>>0]<<8|h[P+2>>0]<<16|h[P+3>>0]<<24;f[e>>2]=O;f[c>>2]=a+4;ga=O}else{if(!(TRb(c,e)|0)){V=68;break a}ga=f[e>>2]|0}O=f[s>>2]|0;if((O|0)==(f[t>>2]|0)){SHa(s,O+1|0);ha=f[s>>2]|0}else ha=O;O=f[v>>2]|0;a=ha+1|0;f[s>>2]=a;f[O+4+(ha<<2)>>2]=ga;P=f[c>>2]|0;Q=(f[g>>2]|0)-P|0;if((Q|0)<=0)continue a;R=P;P=(f[t>>2]|0)-a|0;ia=(Q>>>0)/5|0;ja=(ia|0)<(P|0)?ia:P;if((ja|0)>0){ka=0;la=R;ma=a}else continue a;while(1){if((b[la>>0]|0)!=61){na=ka;break}a=la+1|0;P=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=ma;ma=ma+1|0;f[s>>2]=ma;f[O+4+(a<<2)>>2]=P;P=ka+1|0;if((P|0)>=(ja|0)){na=P;break}else{ka=P;la=la+5|0}}ja=na*5|0;if((na|0)<=0)continue a;if((Q|0)<(ja|0)){PRb(c,ja,Q)|0;continue a}else{f[c>>2]=R+ja;continue a}break}case 8:{switch((W&255)<<24>>24){case 64:break;case 66:{if(Zjb(c,w)|0)continue a;else{Z=0;V=143;break a}break}default:{X=W;break b}}ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(O=b[ja>>0]|0,O<<24>>24>-1):0){f[c>>2]=ja+1;oa=O&255;pa=0}else{IRb(e,c);O=e;if(!(b[A>>0]|0)){Z=0;V=143;break a}else{oa=f[O>>2]|0;pa=f[O+4>>2]|0}}O=f[w>>2]|0;ja=f[x>>2]|0;if((O|0)==(ja|0)){UHa(w,O+1|0);qa=f[w>>2]|0;ra=f[x>>2]|0}else{qa=O;ra=ja}ja=f[y>>2]|0;O=qa+1|0;f[w>>2]=O;P=ja+8+(qa<<3)|0;f[P>>2]=oa;f[P+4>>2]=pa;P=ra-O|0;if((P|0)>0){sa=P;ta=O;ua=ja}else continue a;while(1){ja=f[c>>2]|0;O=f[g>>2]|0;if(ja>>>0>=O>>>0)continue a;if((b[ja>>0]|0)!=64)continue a;P=ja+1|0;f[c>>2]=P;if(P>>>0<O>>>0?(O=b[P>>0]|0,O<<24>>24>-1):0){f[c>>2]=ja+2;va=ta;wa=ua;xa=O&255;ya=0}else{IRb(e,c);O=e;if(!(b[z>>0]|0)){Z=0;V=143;break a}va=f[w>>2]|0;wa=f[y>>2]|0;xa=f[O>>2]|0;ya=f[O+4>>2]|0}O=va+1|0;f[w>>2]=O;ja=wa+8+(va<<3)|0;f[ja>>2]=xa;f[ja+4>>2]=ya;if((sa|0)>1){sa=sa+-1|0;ta=O;ua=wa}else continue a}break}case 9:{if((W&255|0)!=74){X=W;break b}if(fUb(c,JLa(B)|0)|0)continue a;else{Z=0;V=143;break a}break}case 10:{if((W&255|0)!=82){X=W;break b}R=bmb(C)|0;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0?(O=b[Q>>0]|0,O<<24>>24>-1):0){f[c>>2]=Q+1;za=O&255}else{O=VRb(c)|0;if((O|0)>-1)za=O;else{Z=0;V=143;break a}}GRb(e,c,za);if((f[D>>2]|0)<0){V=96;break a}if(!(Mi[f[(f[R>>2]|0)+44>>2]&1023](R,c)|0)){V=96;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Z=0;V=143;break a}break}case 11:{if((W&255|0)!=90){X=W;break b}R=f[F>>2]|0;do if(R){O=f[H>>2]|0;Q=f[R>>2]|0;if((O|0)>=(Q|0))if((Q|0)==(f[G>>2]|0)){Aa=Q;V=104;break}else{Ba=Q;Ca=R;V=105;break}else{f[H>>2]=O+1;Da=f[R+4+(O<<2)>>2]|0;break}}else{Aa=f[G>>2]|0;V=104}while(0);if((V|0)==104){V=0;USb(E,Aa+1|0);R=f[F>>2]|0;Ba=f[R>>2]|0;Ca=R;V=105}if((V|0)==105){V=0;f[Ca>>2]=Ba+1;R=f[E>>2]|0;if(!R){O=VDc(104)|0;Mkb(O);Ea=O}else{if(f[R+64>>2]|0)OQb(R,16280,104);O=NQb(R,104,1758)|0;Mkb(O);Ea=O}O=f[F>>2]|0;R=f[H>>2]|0;f[H>>2]=R+1;f[O+4+(R<<2)>>2]=Ea;Da=Ea}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(O=b[R>>0]|0,O<<24>>24>-1):0){f[c>>2]=R+1;Fa=O&255}else{O=VRb(c)|0;if((O|0)>-1)Fa=O;else{Z=0;V=143;break a}}GRb(e,c,Fa);if((f[I>>2]|0)<0){V=117;break a}if(!(Mi[f[(f[Da>>2]|0)+44>>2]&1023](Da,c)|0)){V=117;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Z=0;V=143;break a}break}case 13:{if((W&255|0)!=106){X=W;break b}f[i>>2]=f[i>>2]|4;O=f[K>>2]|0;if((O|0)==527320){GLa(K,527320);Ga=f[K>>2]|0}else Ga=O;if(fUb(c,Ga)|0)continue a;else{Z=0;V=143;break a}break}case 20:{if((W&255|0)!=160){X=W;break b}O=f[c>>2]|0;if(O>>>0<(f[g>>2]|0)>>>0){R=b[O>>0]|0;Q=R&255;if(R<<24>>24>-1){f[c>>2]=O+1;Ha=Q}else{Ia=Q;V=127}}else{Ia=0;V=127}if((V|0)==127){V=0;Q=HRb(c,Ia)|0;O=J;if((O|0)>-1|(O|0)==-1&Q>>>0>4294967295)Ha=Q;else{Z=0;V=143;break a}}if(Ha>>>0<11){f[i>>2]=f[i>>2]|256;f[L>>2]=Ha;continue a}Q=f[M>>2]|0;if(!(Q&1))Ja=mNa(M)|0;else Ja=Q&-2;rjc(Ja,20,Ha,((Ha|0)<0)<<31>>31);continue a;break}case 21:{if((W&255|0)!=170){X=W;break b}f[i>>2]=f[i>>2]|8;Q=f[N>>2]|0;if((Q|0)==527320){GLa(N,527320);Ka=f[N>>2]|0}else Ka=Q;if(fUb(c,Ka)|0)continue a;else{Z=0;V=143;break a}break}default:{X=W;break b}}while(0)}while(0);if(!X){Z=1;V=143;break}Q=f[M>>2]|0;if(!(Q&1))La=mNa(M)|0;else La=Q&-2;if(!(Djc(c,X,La)|0)){Z=0;V=143;break}}if((V|0)==20){Z=0;u=d;return Z|0}else if((V|0)==40){Z=0;u=d;return Z|0}else if((V|0)==51){Z=0;u=d;return Z|0}else if((V|0)==68){Z=0;u=d;return Z|0}else if((V|0)==96){Z=0;u=d;return Z|0}else if((V|0)==117){Z=0;u=d;return Z|0}else if((V|0)==143){u=d;return Z|0}return 0}function khb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+16>>2]|0;e=c+d+(c<<2)|0;c=f[a+28>>2]|0;if((c|0)>0){d=f[a+36>>2]|0;g=0;h=0;while(1){i=d+8+(h<<3)|0;j=iJc(f[i>>2]|1|0,f[i+4>>2]|0,1)|0;i=((((j^63)*9|0)+73|0)>>>6)+g|0;h=h+1|0;if((h|0)==(c|0)){k=i;break}else g=i}}else k=0;g=f[a+44>>2]|0;h=e+k+c+g|0;if((g|0)>0){c=f[a+52>>2]|0;k=0;e=h;while(1){d=f[c+4+(k<<2)>>2]|0;i=b[d+11>>0]|0;j=i<<24>>24<0?f[d+4>>2]|0:i&255;i=j+e+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=k+1|0;if((k|0)==(g|0)){l=i;break}else e=i}}else l=h;h=f[a+60>>2]|0;e=h+l|0;if(!h)m=e;else{l=a+68|0;g=0;k=e;while(1){e=f[(f[l>>2]|0)+4+(g<<2)>>2]|0;c=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=c+k+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(h|0)){m=e;break}else k=e}}k=f[a+76>>2]|0;h=k+m|0;if(!k)n=h;else{m=a+84|0;g=0;l=h;while(1){h=f[(f[m>>2]|0)+4+(g<<2)>>2]|0;e=_i[f[(f[h>>2]|0)+48>>2]&1023](h)|0;h=e+l+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(k|0)){n=h;break}else l=h}}l=a+8|0;k=f[l>>2]|0;if(!(k&255)){o=n;p=k}else{if(!(k&1))q=n;else{g=f[a+88>>2]|0;m=b[g+11>>0]|0;h=m<<24>>24<0?f[g+4>>2]|0:m&255;q=n+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(k&2))r=q;else{h=f[a+92>>2]|0;n=b[h+11>>0]|0;m=n<<24>>24<0?f[h+4>>2]|0:n&255;r=q+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(k&4))s=r;else{m=f[a+96>>2]|0;q=b[m+11>>0]|0;n=q<<24>>24<0?f[m+4>>2]|0:q&255;s=r+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(k&8))t=s;else{n=f[a+100>>2]|0;r=b[n+11>>0]|0;q=r<<24>>24<0?f[n+4>>2]|0:r&255;t=s+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(k&16)){u=t;v=k}else{k=f[a+104>>2]|0;q=_i[f[(f[k>>2]|0)+48>>2]&1023](k)|0;k=t+1+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=k;v=f[l>>2]|0}if(!(v&32)){w=u;x=v}else{v=f[a+108>>2]|0;k=_i[f[(f[v>>2]|0)+48>>2]&1023](v)|0;v=u+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=v;x=f[l>>2]|0}if(!(x&64))y=w;else{l=a+112|0;v=iJc(f[l>>2]|1|0,f[l+4>>2]|0,1)|0;y=w+1+((((v^63)*9|0)+73|0)>>>6)|0}o=x&128|0?y+5|0:y;p=x}if(!(p&256)){z=o;A=a+12|0;f[A>>2]=z;return z|0}p=f[a+124>>2]|0;if((p|0)<0)B=12;else B=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;z=B+o|0;A=a+12|0;f[A>>2]=z;return z|0}function lhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+88>>2]|0,b);if(c&128|0)WTb(2,+n[a+120>>2],b);if(c&64|0){d=a+112|0;NTb(3,f[d>>2]|0,f[d+4>>2]|0,b)}if(c&2|0)bUb(4,f[a+92>>2]|0,b);if(c&16|0)eUb(5,f[a+104>>2]|0,b);if(c&32|0)eUb(6,f[a+108>>2]|0,b);d=f[a+16>>2]|0;if((d|0)>0){e=a+24|0;g=0;do{WTb(7,+n[(f[e>>2]|0)+4+(g<<2)>>2],b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+28>>2]|0;if((d|0)>0){g=a+36|0;e=0;do{h=(f[g>>2]|0)+8+(e<<3)|0;NTb(8,f[h>>2]|0,f[h+4>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+44>>2]|0;if((d|0)>0){e=a+52|0;g=0;do{aUb(9,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+60>>2]|0;if(d|0){g=a+68|0;e=0;do{eUb(10,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+76>>2]|0;if(d|0){e=a+84|0;g=0;do{eUb(11,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&4|0)$Tb(13,f[a+96>>2]|0,b);if(c&256|0)ZTb(20,f[a+124>>2]|0,b);if(c&8|0)$Tb(21,f[a+100>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function mhb(a){a=a|0;return f[a+12>>2]|0}function nhb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+88>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}if(!(e&128))i=g;else{d=f[a+120>>2]|0;b[g>>0]=21;h=g+1|0;b[h>>0]=d;b[h+1>>0]=d>>8;b[h+2>>0]=d>>16;b[h+3>>0]=d>>24;i=g+5|0}if(!(e&64))j=i;else{g=a+112|0;d=f[g>>2]|0;h=f[g+4>>2]|0;b[i>>0]=24;g=i+1|0;i=d&255;if(h>>>0>0|(h|0)==0&d>>>0>127){k=g;l=i;m=d;d=h;while(1){b[k>>0]=l|-128;h=m;m=aJc(m|0,d|0,7)|0;n=k+1|0;o=m&255;if(!(d>>>0>0|(d|0)==0&h>>>0>16383)){p=n;q=o;break}else{k=n;l=o;d=J}}}else{p=g;q=i}b[p>>0]=q;j=p+1|0}if(!(e&2))r=j;else{p=f[a+92>>2]|0;b[j>>0]=34;r=dSb(p,j+1|0)|0}if(!(e&16))s=r;else{j=f[a+104>>2]|0;b[r>>0]=42;p=r+1|0;r=_i[f[(f[j>>2]|0)+60>>2]&1023](j)|0;if(r>>>0>127){q=r;i=p;while(1){b[i>>0]=q|128;g=q>>>7;d=i+1|0;if(q>>>0>16383){q=g;i=d}else{t=d;u=g;break}}}else{t=p;u=r}b[t>>0]=u;s=hj[f[(f[j>>2]|0)+64>>2]&511](j,c,t+1|0)|0}if(!(e&32))v=s;else{t=f[a+108>>2]|0;b[s>>0]=50;j=s+1|0;s=_i[f[(f[t>>2]|0)+60>>2]&1023](t)|0;if(s>>>0>127){u=s;r=j;while(1){b[r>>0]=u|128;p=u>>>7;i=r+1|0;if(u>>>0>16383){u=p;r=i}else{w=i;x=p;break}}}else{w=j;x=s}b[w>>0]=x;v=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,w+1|0)|0}w=f[a+16>>2]|0;if(!w)y=v;else{t=f[a+24>>2]|0;x=0;s=v;while(1){v=f[t+4+(x<<2)>>2]|0;b[s>>0]=61;j=s+1|0;b[j>>0]=v;b[j+1>>0]=v>>8;b[j+2>>0]=v>>16;b[j+3>>0]=v>>24;v=s+5|0;x=x+1|0;if((x|0)>=(w|0)){y=v;break}else s=v}}s=f[a+28>>2]|0;if(!s)z=y;else{w=f[a+36>>2]|0;x=0;t=y;while(1){y=w+8+(x<<3)|0;v=f[y>>2]|0;j=f[y+4>>2]|0;b[t>>0]=64;y=t+1|0;r=v&255;if(j>>>0>0|(j|0)==0&v>>>0>127){u=y;p=r;i=v;v=j;while(1){b[u>>0]=p|-128;j=i;i=aJc(i|0,v|0,7)|0;q=u+1|0;g=i&255;if(!(v>>>0>0|(v|0)==0&j>>>0>16383)){A=q;B=g;break}else{u=q;p=g;v=J}}}else{A=y;B=r}b[A>>0]=B;v=A+1|0;x=x+1|0;if((x|0)>=(s|0)){z=v;break}else t=v}}t=f[a+44>>2]|0;if((t|0)>0){s=a+52|0;x=0;A=z;while(1){B=f[(f[s>>2]|0)+4+(x<<2)>>2]|0;b[A>>0]=74;w=dSb(B,A+1|0)|0;x=x+1|0;if((x|0)==(t|0)){C=w;break}else A=w}}else C=z;z=f[a+60>>2]|0;if(!z)D=C;else{A=a+68|0;t=0;x=C;while(1){C=f[(f[A>>2]|0)+4+(t<<2)>>2]|0;b[x>>0]=82;s=x+1|0;w=_i[f[(f[C>>2]|0)+60>>2]&1023](C)|0;if(w>>>0>127){B=w;v=s;while(1){b[v>>0]=B|128;p=B>>>7;u=v+1|0;if(B>>>0>16383){B=p;v=u}else{E=u;F=p;break}}}else{E=s;F=w}b[E>>0]=F;v=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,E+1|0)|0;t=t+1|0;if((t|0)==(z|0)){D=v;break}else x=v}}x=f[a+76>>2]|0;if(!x)G=D;else{z=a+84|0;t=0;E=D;while(1){D=f[(f[z>>2]|0)+4+(t<<2)>>2]|0;b[E>>0]=90;F=E+1|0;A=_i[f[(f[D>>2]|0)+60>>2]&1023](D)|0;if(A>>>0>127){v=A;B=F;while(1){b[B>>0]=v|128;r=v>>>7;y=B+1|0;if(v>>>0>16383){v=r;B=y}else{H=y;I=r;break}}}else{H=F;I=A}b[H>>0]=I;B=hj[f[(f[D>>2]|0)+64>>2]&511](D,c,H+1|0)|0;t=t+1|0;if((t|0)==(x|0)){G=B;break}else E=B}}if(!(e&4))K=G;else{E=f[a+96>>2]|0;b[G>>0]=106;K=dSb(E,G+1|0)|0}if(!(e&256))L=K;else{G=f[a+124>>2]|0;b[K>>0]=-96;b[K+1>>0]=1;E=K+2|0;K=G&255;if(G>>>0>127){x=E;t=K;H=G;c=((G|0)<0)<<31>>31;while(1){b[x>>0]=t|-128;G=H;H=aJc(H|0,c|0,7)|0;I=x+1|0;z=H&255;if(!(c>>>0>0|(c|0)==0&G>>>0>16383)){M=I;N=z;break}else{x=I;t=z;c=J}}}else{M=E;N=K}b[M>>0]=N;L=M+1|0}if(!(e&8))O=L;else{e=f[a+100>>2]|0;b[L>>0]=-86;b[L+1>>0]=1;O=dSb(e,L+2|0)|0}L=f[a+4>>2]|0;if(!(L&1)){P=O;return P|0}P=Hjc(L&-2,O)|0;return P|0}function ohb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function phb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16088,0)|0;if(!c){Ehc(b,a);return}else{tlb(a,c);return}}function qhb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function rhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526464;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function shb(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220438]|0)!=2){f[c>>2]=161028;f[c+4>>2]=98;b[c+8>>0]=0;DTb(881752,c);ZSb(c)}d=VDc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=17;e=d;g=422388;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+17>>0]=0;Xbc(c,96472,96628,95568,0,526464,881736,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function thb(){uhb();lYb(422406,2523);rhc(422388,1759);return}function uhb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220439]|0)!=2){f[c>>2]=161028;f[c+4>>2]=99;b[c+8>>0]=0;DTb(881756,c);ZSb(c)}if((f[220440]|0)!=2){f[c>>2]=161028;f[c+4>>2]=100;b[c+8>>0]=0;DTb(881760,c);ZSb(c)}if((f[220441]|0)!=2){f[c>>2]=161028;f[c+4>>2]=101;b[c+8>>0]=0;DTb(881764,c);ZSb(c)}if((f[220442]|0)!=2){f[c>>2]=161028;f[c+4>>2]=102;b[c+8>>0]=0;DTb(881768,c);ZSb(c)}if((f[220443]|0)!=2){f[c>>2]=161028;f[c+4>>2]=103;b[c+8>>0]=0;DTb(881772,c);ZSb(c)}if((f[220444]|0)!=2){f[c>>2]=161028;f[c+4>>2]=104;b[c+8>>0]=0;DTb(881776,c);ZSb(c)}if((f[220445]|0)!=2){f[c>>2]=161028;f[c+4>>2]=105;b[c+8>>0]=0;DTb(881780,c);ZSb(c)}if((f[220446]|0)!=2){f[c>>2]=161028;f[c+4>>2]=106;b[c+8>>0]=0;DTb(881784,c);ZSb(c)}if((f[220447]|0)!=2){f[c>>2]=161028;f[c+4>>2]=107;b[c+8>>0]=0;DTb(881788,c);ZSb(c)}if((f[220448]|0)!=2){f[c>>2]=161028;f[c+4>>2]=108;b[c+8>>0]=0;DTb(881792,c);ZSb(c)}if((f[220449]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=109;b[c+8>>0]=0;DTb(881796,c);ZSb(c);u=a;return}function vhb(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220437]|0)!=2){f[c>>2]=161028;f[c+4>>2]=97;b[c+8>>0]=0;DTb(881748,c);ZSb(c)}acc(526464,13);u=a;return}function whb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,424930);SQb();if((f[220444]|0)!=2){f[c>>2]=161028;f[c+4>>2]=104;b[c+8>>0]=0;DTb(881776,c);ZSb(c)}if((f[220440]|0)!=2){f[c>>2]=161028;f[c+4>>2]=100;b[c+8>>0]=0;DTb(881760,c);ZSb(c)}f[131412]=96372;f[131413]=0;c=525656;d=c+80|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131434]=527320;f[131435]=527320;f[131436]=527320;f[131437]=527320;f[131438]=0;f[131439]=0;f[131440]=0;f[131441]=0;f[131442]=0;f[131443]=0;zTb(525648);f[131452]=97768;f[131453]=0;c=525816;d=c+56|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131468]=527320;f[131469]=527320;f[131470]=527320;f[131471]=527320;zTb(525808);f[131500]=97876;f[131501]=0;c=526008;d=c+88|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131524]=527320;f[131525]=527320;zTb(526e3);f[131438]=526136;f[131439]=526e3;u=a;return}function xhb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,424930);SQb();if((f[220448]|0)!=2){f[c>>2]=161028;f[c+4>>2]=108;b[c+8>>0]=0;DTb(881792,c);ZSb(c)}f[131444]=97660;f[131445]=0;f[131446]=0;f[131447]=0;f[131448]=527320;f[131449]=527320;f[131450]=0;zTb(525776);f[131450]=526392;u=a;return}function yhb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,424930);SQb();if((f[220449]|0)!=2){f[c>>2]=161028;f[c+4>>2]=109;b[c+8>>0]=0;DTb(881796,c);ZSb(c)}if((f[220439]|0)!=2){f[c>>2]=161028;f[c+4>>2]=99;b[c+8>>0]=0;DTb(881756,c);ZSb(c)}if((f[220442]|0)!=2){f[c>>2]=161028;f[c+4>>2]=102;b[c+8>>0]=0;DTb(881768,c);ZSb(c)}f[131472]=97552;f[131473]=0;c=525896;d=c+40|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131484]=527320;f[131485]=527320;f[131486]=527320;f[131487]=527320;f[131488]=0;f[131489]=0;f[131490]=0;f[131491]=0;f[131492]=0;f[131493]=0;zTb(525888);f[131488]=526e3;u=a;return}function zhb(){aTb(3005001,3005e3,424930);SQb();f[131494]=97444;f[131495]=0;f[131496]=0;f[131497]=0;f[131498]=527320;f[131499]=527320;zTb(525976);return}function Ahb(){aTb(3005001,3005e3,424930);SQb();f[131526]=97336;f[131527]=0;f[131528]=0;f[131529]=0;f[131530]=0;f[131531]=0;f[131532]=0;f[131533]=0;zTb(526104);return}function Bhb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,424930);SQb();if((f[220443]|0)!=2){f[c>>2]=161028;f[c+4>>2]=103;b[c+8>>0]=0;DTb(881772,c);ZSb(c)}f[131534]=97228;f[131535]=0;f[131545]=0;f[131546]=0;f[131547]=0;f[131557]=0;f[131558]=0;f[131559]=0;f[131561]=0;f[131562]=0;f[131563]=0;f[131549]=0;f[131550]=0;f[131551]=0;f[131552]=0;f[131553]=0;f[131554]=0;f[131555]=0;f[131536]=0;f[131537]=0;f[131538]=0;f[131539]=0;f[131540]=0;f[131541]=0;f[131542]=0;f[131543]=0;f[131565]=527320;f[131566]=527320;f[131567]=527320;c=526272;f[c>>2]=0;f[c+4>>2]=0;zTb(526136);f[131568]=526104;u=a;return}function Chb(){var a=0;aTb(3005001,3005e3,424930);SQb();f[131570]=96904;f[131571]=0;f[131572]=0;f[131573]=0;f[131574]=527320;f[131578]=0;zTb(526280);a=526320;f[a>>2]=0;f[a+4>>2]=0;f[131582]=527320;return}function Dhb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,424930);SQb();if((f[220445]|0)!=2){f[c>>2]=161028;f[c+4>>2]=105;b[c+8>>0]=0;DTb(881780,c);ZSb(c)}f[131584]=97012;f[131585]=0;f[131586]=0;f[131587]=0;f[131588]=0;f[131589]=0;f[131590]=0;f[131591]=0;zTb(526336);u=a;return}function Ehb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,424930);SQb();if((f[220446]|0)!=2){f[c>>2]=161028;f[c+4>>2]=106;b[c+8>>0]=0;DTb(881784,c);ZSb(c)}f[131592]=97120;f[131593]=0;f[131594]=0;f[131595]=0;f[131596]=0;f[131597]=0;zTb(526368);f[131596]=526336;u=a;return}function Fhb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,424930);SQb();if((f[220447]|0)!=2){f[c>>2]=161028;f[c+4>>2]=107;b[c+8>>0]=0;DTb(881788,c);ZSb(c)}f[131598]=96796;f[131599]=0;f[131600]=0;f[131601]=0;f[131602]=527320;f[131604]=0;zTb(526392);f[131606]=526368;u=a;return}function Ghb(){var a=0;aTb(3005001,3005e3,424930);SQb();f[131608]=96688;f[131609]=0;f[131610]=0;f[131611]=0;f[131612]=527320;a=526456;f[a>>2]=0;f[a+4>>2]=0;zTb(526432);return}function Hhb(a){a=a|0;var c=0,d=0;f[a>>2]=96688;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function Ihb(a){a=a|0;Hhb(a);YDc(a);return}function Jhb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Khb(a,b){a=a|0;b=b|0;a=VDc(32)|0;Xhb(a);if(!b)return a|0;Yhb(b,a);return a|0}function Lhb(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Mhb(a){a=a|0;return 1}function Nhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+24|0;k=e+8|0;l=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=WRb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)!=10){r=o;break b}f[h>>2]=f[h>>2]|1;n=f[i>>2]|0;if((n|0)==527320){GLa(i,527320);s=f[i>>2]|0}else s=n;if(fUb(c,s)|0)continue a;else{t=0;p=22;break a}break}case 2:break;default:{r=o;break b}}if((o&255|0)==16){f[h>>2]=f[h>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(a=b[n>>0]|0,a<<24>>24>-1):0){f[c>>2]=n+1;v=a&255;w=0}else{IRb(e,c);a=e;if(!(b[k>>0]|0)){t=0;p=22;break a}else{v=f[a>>2]|0;w=f[a+4>>2]|0}}a=j;f[a>>2]=v;f[a+4>>2]=w;continue a}else r=o}while(0);if(!r){t=1;p=22;break}a=f[l>>2]|0;if(!(a&1))x=mNa(l)|0;else x=a&-2;if(!(Djc(c,r,x)|0)){t=0;p=22;break}}if((p|0)==22){u=d;return t|0}return 0}function Ohb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}c=a+24|0;k=iJc(f[c>>2]|1|0,f[c+4>>2]|0,1)|0;e=h+1+((((k^63)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function Phb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&2|0){c=a+24|0;NTb(2,f[c>>2]|0,f[c+4>>2]|0,b)}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Qhb(a){a=a|0;return f[a+12>>2]|0}function Rhb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&2))h=e;else{c=a+24|0;d=f[c>>2]|0;g=f[c+4>>2]|0;b[e>>0]=16;c=e+1|0;e=d&255;if(g>>>0>0|(g|0)==0&d>>>0>127){i=c;j=e;k=d;d=g;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,d|0,7)|0;l=i+1|0;m=k&255;if(!(d>>>0>0|(d|0)==0&g>>>0>16383)){n=l;o=m;break}else{i=l;j=m;d=J}}}else{n=c;o=e}b[n>>0]=o;h=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=h;return p|0}p=Hjc(n&-2,h)|0;return p|0}function Shb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Thb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16104,0)|0;if(!c){Ehc(b,a);return}else{Whb(a,c);return}}function Uhb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Vhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526560;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Whb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(d&2|0){e=b+24|0;b=f[e+4>>2]|0;c=a+24|0;f[c>>2]=f[e>>2];f[c+4>>2]=b}b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Xhb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96688;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=526432?(f[220449]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=109;b[d+8>>0]=0;DTb(881796,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function Yhb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Zhb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=96796;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+24|0;switch(f[c>>2]|0){case 0:break;case 1:{d=f[a+20>>2]|0;if(!d)e=8;else{Yi[f[(f[d>>2]|0)+4>>2]&2047](d);e=8}break}default:e=8}if((e|0)==8)f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}e=a&-2;a=e;if((e|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(e);f[c>>2]=0;return}function _hb(a){a=a|0;Zhb(a);YDc(a);return}function $hb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function aib(a,b){a=a|0;b=b|0;a=VDc(28)|0;pjb(a);if(!b)return a|0;qjb(b,a);return a|0}function bib(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);e=a+24|0;if((f[e>>2]|0)==1?(d=f[a+20>>2]|0,d|0):0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);f[e>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function cib(a){a=a|0;return 1}function dib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+24|0;i=a+20|0;j=e+4|0;k=a+8|0;l=a+16|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:break;case 6:{if((p&255|0)!=50){s=p;break b}f[k>>2]=f[k>>2]|1;o=f[l>>2]|0;if((o|0)==527320){GLa(l,527320);t=f[l>>2]|0}else t=o;if(fUb(c,t)|0)continue a;else{v=0;q=28;break a}break}default:{s=p;break b}}if((p&255|0)==10){if((f[h>>2]|0)==1)w=f[i>>2]|0;else{f[h>>2]=1;o=VDc(24)|0;nib(o);f[i>>2]=o;w=o}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;x=a&255}else{a=VRb(c)|0;if((a|0)>-1)x=a;else{v=0;q=28;break a}}GRb(e,c,x);if((f[j>>2]|0)<0){q=17;break a}if(!(Mi[f[(f[w>>2]|0)+44>>2]&1023](w,c)|0)){q=17;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{v=0;q=28;break a}}else s=p}while(0);if(!s){v=1;q=28;break}a=f[m>>2]|0;if(!(a&1))y=mNa(m)|0;else y=a&-2;if(!(Djc(c,s,y)|0)){v=0;q=28;break}}if((q|0)==17){v=0;u=d;return v|0}else if((q|0)==28){u=d;return v|0}return 0}function eib(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;g=b[c+11>>0]|0;h=g<<24>>24<0?f[c+4>>2]|0:g&255;e=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if((f[a+24>>2]|0)!=1){i=e;j=a+12|0;f[j>>2]=i;return i|0}h=f[a+20>>2]|0;d=_i[f[(f[h>>2]|0)+48>>2]&1023](h)|0;i=e+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=a+12|0;f[j>>2]=i;return i|0}function fib(a,b){a=a|0;b=b|0;var c=0;if((f[a+24>>2]|0)==1)eUb(1,f[a+20>>2]|0,b);if(f[a+8>>2]&1|0)$Tb(6,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function gib(a){a=a|0;return f[a+12>>2]|0}function hib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((f[a+24>>2]|0)==1){e=f[a+20>>2]|0;b[d>>0]=10;g=d+1|0;h=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(h>>>0>127){i=h;j=g;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=g;n=h}b[m>>0]=n;o=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,m+1|0)|0}else o=d;if(!(f[a+8>>2]&1))p=o;else{d=f[a+16>>2]|0;b[o>>0]=50;p=dSb(d,o+1|0)|0}o=f[a+4>>2]|0;if(!(o&1)){q=p;return q|0}q=Hjc(o&-2,p)|0;return q|0}function iib(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function jib(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16120,0)|0;if(!c){Ehc(b,a);return}else{mib(a,c);return}}function kib(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function lib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526552;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function mib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}do if(f[b+8>>2]&1|0?(d=a+8|0,f[d>>2]=f[d>>2]|1,d=a+16|0,g=f[b+16>>2]|0,e=f[d>>2]|0,(e|0)!=(g|0)):0)if((e|0)==527320){GLa(d,g);break}else{iEc(e,g)|0;break}while(0);g=b+24|0;if((f[g>>2]|0)!=1)return;e=a+24|0;if((f[e>>2]|0)!=1){f[e>>2]=1;e=VDc(24)|0;nib(e);f[a+20>>2]=e;if((f[g>>2]|0)==1){h=e;i=15}else{j=e;k=526368}}else{h=f[a+20>>2]|0;i=15}if((i|0)==15){j=h;k=f[b+20>>2]|0}oib(j,k);return}function nib(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97120;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=526368?(f[220447]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=107;b[d+8>>0]=0;DTb(881788,d);ZSb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function oib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;if(d&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;e=f[g>>2]|0;if(!e){c=VDc(32)|0;pib(c);f[g>>2]=c;h=c}else h=e;e=f[b+16>>2]|0;c=e|0?e:526336;e=h+4|0;g=f[c+4>>2]|0;if(g&1|0){i=f[e>>2]|0;if(!(i&1))j=mNa(e)|0;else j=i&-2;ojc(j,g&-2)}qib(h+16|0,c+16|0)}if(d&2|0)f[a+20>>2]=f[b+20>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function pib(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=97012;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=526336?(f[220446]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=106;b[d+8>>0]=0;DTb(881784,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function qib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{sib(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(40)|0;rib(l);sib(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16136,40);l=NQb(i,40,1760)|0;rib(l);sib(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function rib(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96904;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=526280?(f[220445]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=105;b[d+8>>0]=0;DTb(881780,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+32>>2]=0;u=c;return}function sib(a,b){a=a|0;b=b|0;uib(b,a);return}function tib(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function uib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}do if(f[c+8>>2]&1|0?(e=a+8|0,f[e>>2]=f[e>>2]|1,e=a+16|0,h=f[c+16>>2]|0,g=f[e>>2]|0,(g|0)!=(h|0)):0)if((g|0)==527320){GLa(e,h);break}else{iEc(g,h)|0;break}while(0);switch(f[c+32>>2]|0){case 1:{h=c+24|0;g=f[h>>2]|0;e=f[h+4>>2]|0;h=a+32|0;switch(f[h>>2]|0){case 1:break;case 2:{d=f[a+24>>2]|0;if((d|0)==527320|(d|0)==0)i=17;else{if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);YDc(d);i=17}break}default:i=17}if((i|0)==17)f[h>>2]=1;h=a+24|0;f[h>>2]=g;f[h+4>>2]=e;return}case 2:{e=f[c+24>>2]|0;c=a+32|0;if((f[c>>2]|0)==2){h=a+24|0;g=f[h>>2]|0;if((g|0)==527320)j=h;else{iEc(g,e)|0;return}}else{f[c>>2]=2;c=a+24|0;f[c>>2]=527320;j=c}GLa(j,e);return}default:return}}function vib(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=96904;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+32|0;switch(f[c>>2]|0){case 0:break;case 2:{d=f[a+24>>2]|0;if((d|0)==527320|(d|0)==0)e=10;else{if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);YDc(d);e=10}break}default:e=10}if((e|0)==10)f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}e=a&-2;a=e;if((e|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(e);f[c>>2]=0;return}function wib(a){a=a|0;vib(a);YDc(a);return}function xib(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function yib(a,b){a=a|0;b=b|0;a=VDc(40)|0;rib(a);if(!b)return a|0;Kib(b,a);return a|0}function zib(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);e=a+32|0;if((f[e>>2]|0)==2?(d=f[a+24>>2]|0,!((d|0)==527320|(d|0)==0)):0){if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);YDc(d)}f[e>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Aib(a){a=a|0;return 1}function Bib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+32|0;i=a+24|0;j=a+24|0;k=e+8|0;l=a+8|0;m=a+16|0;n=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=a+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=WRb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=8){t=q;break b}if((f[h>>2]|0)==2?(p=f[i>>2]|0,!((p|0)==527320|(p|0)==0)):0){if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);YDc(p)}f[h>>2]=0;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(a=b[p>>0]|0,a<<24>>24>-1):0){f[c>>2]=p+1;v=a&255;w=0}else{IRb(e,c);a=e;if(!(b[k>>0]|0)){x=0;r=33;break a}else{v=f[a>>2]|0;w=f[a+4>>2]|0}}a=j;f[a>>2]=v;f[a+4>>2]=w;f[h>>2]=1;continue a;break}case 2:{if((q&255|0)!=18){t=q;break b}if((f[h>>2]|0)==2){a=f[i>>2]|0;if((a|0)==527320)r=22;else y=a}else{f[h>>2]=2;f[i>>2]=527320;r=22}if((r|0)==22){r=0;GLa(i,527320);y=f[i>>2]|0}if(fUb(c,y)|0)continue a;else{x=0;r=33;break a}break}case 3:{if((q&255|0)!=26){t=q;break b}f[l>>2]=f[l>>2]|1;a=f[m>>2]|0;if((a|0)==527320){GLa(m,527320);z=f[m>>2]|0}else z=a;if(fUb(c,z)|0)continue a;else{x=0;r=33;break a}break}default:{t=q;break b}}}while(0);if(!t){x=1;r=33;break}a=f[n>>2]|0;if(!(a&1))A=mNa(n)|0;else A=a&-2;if(!(Djc(c,t,A)|0)){x=0;r=33;break}}if((r|0)==33){u=d;return x|0}return 0}function Cib(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;g=b[c+11>>0]|0;h=g<<24>>24<0?f[c+4>>2]|0:g&255;e=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}switch(f[a+32>>2]|0){case 1:{h=a+24|0;i=e+1+(((((iJc(f[h>>2]|1|0,f[h+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)|0;j=a+12|0;f[j>>2]=i;return i|0}case 2:{h=f[a+24>>2]|0;d=b[h+11>>0]|0;g=d<<24>>24<0?f[h+4>>2]|0:d&255;i=e+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=a+12|0;f[j>>2]=i;return i|0}default:{i=e;j=a+12|0;f[j>>2]=i;return i|0}}return 0}function Dib(a,b){a=a|0;b=b|0;var c=0;switch(f[a+32>>2]|0){case 1:{c=a+24|0;NTb(1,f[c>>2]|0,f[c+4>>2]|0,b);break}case 2:{$Tb(2,f[a+24>>2]|0,b);break}default:{}}if(f[a+8>>2]&1|0)$Tb(3,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Eib(a){a=a|0;return f[a+12>>2]|0}function Fib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;switch(f[a+32>>2]|0){case 1:{c=a+24|0;e=f[c>>2]|0;g=f[c+4>>2]|0;b[d>>0]=8;c=d+1|0;h=e&255;if(g>>>0>0|(g|0)==0&e>>>0>127){i=c;j=h;k=e;e=g;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,e|0,7)|0;l=i+1|0;m=k&255;if(!(e>>>0>0|(e|0)==0&g>>>0>16383)){n=l;o=m;break}else{i=l;j=m;e=J}}}else{n=c;o=h}b[n>>0]=o;p=n+1|0;break}case 2:{n=f[a+24>>2]|0;b[d>>0]=18;p=dSb(n,d+1|0)|0;break}default:p=d}if(!(f[a+8>>2]&1))q=p;else{d=f[a+16>>2]|0;b[p>>0]=26;q=dSb(d,p+1|0)|0}p=f[a+4>>2]|0;if(!(p&1)){r=q;return r|0}r=Hjc(p&-2,q)|0;return r|0}function Gib(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Hib(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16136,0)|0;if(!c){Ehc(b,a);return}else{uib(a,c);return}}function Iib(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Jib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526528;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Kib(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Lib(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=97012;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function Mib(a){a=a|0;Lib(a);YDc(a);return}function Nib(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Oib(a,b){a=a|0;b=b|0;a=VDc(32)|0;pib(a);if(!b)return a|0;_ib(b,a);return a|0}function Pib(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Qib(a){a=a|0;return 1}function Rib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;USb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=VDc(40)|0;rib(a);y=a}else{if(f[o+64>>2]|0)OQb(o,16136,40);a=NQb(o,40,1760)|0;rib(a);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=VRb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}GRb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(LRb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=mNa(m)|0;else B=a&-2;if(!(Djc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function Sib(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function Tib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Uib(a){a=a|0;return f[a+12>>2]|0}function Vib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Hjc(j&-2,g)|0;return s|0}function Wib(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Xib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,16152,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}qib(a+16|0,c+16|0);return}function Yib(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Zib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526536;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function _ib(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function $ib(a){a=a|0;var b=0,c=0;f[a>>2]=97120;if((a|0)!=526368?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function ajb(a){a=a|0;$ib(a);YDc(a);return}function bjb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function cjb(a,b){a=a|0;b=b|0;a=VDc(24)|0;nib(a);if(!b)return a|0;ojb(b,a);return a|0}function djb(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&1|0){c=f[a+16>>2]|0;Yi[f[(f[c>>2]|0)+28>>2]&2047](c)}f[a+20>>2]=0;f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function ejb(a){a=a|0;return 1}function fjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+4|0;k=a+4|0;l=a+20|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=7}else{q=n;p=6}}else{q=0;p=6}if((p|0)==6){p=0;n=WRb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=7}else r=n}c:do if((p|0)==7){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)==8)break b;else{r=o;break c}break}case 2:break;default:{r=o;break c}}if((o&255|0)==18){f[h>>2]=f[h>>2]|1;n=f[i>>2]|0;if(!n){a=VDc(32)|0;pib(a);f[i>>2]=a;s=a}else s=n;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(a=b[n>>0]|0,a<<24>>24>-1):0){f[c>>2]=n+1;t=a&255}else{a=VRb(c)|0;if((a|0)>-1)t=a;else{v=0;p=35;break a}}GRb(e,c,t);if((f[j>>2]|0)<0){p=28;break a}if(!(Mi[f[(f[s>>2]|0)+44>>2]&1023](s,c)|0)){p=28;break a}if(LRb(c,f[e>>2]|0)|0)continue b;else{v=0;p=35;break a}}else r=o}while(0);if(!r){v=1;p=35;break a}a=f[k>>2]|0;if(!(a&1))w=mNa(k)|0;else w=a&-2;if(!(Djc(c,r,w)|0)){v=0;p=35;break a}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;m=n&255;if(n<<24>>24>-1){f[c>>2]=a+1;x=m}else{y=m;p=12}}else{y=0;p=12}if((p|0)==12){p=0;m=HRb(c,y)|0;a=J;if((a|0)>-1|(a|0)==-1&m>>>0>4294967295)x=m;else{v=0;p=35;break}}if(x>>>0<16){f[h>>2]=f[h>>2]|2;f[l>>2]=x;continue}m=f[k>>2]|0;if(!(m&1))z=mNa(k)|0;else z=m&-2;rjc(z,1,x,((x|0)<0)<<31>>31)}if((p|0)==28){v=0;u=d;return v|0}else if((p|0)==35){u=d;return v|0}return 0}function gjb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&3)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}i=f[a+20>>2]|0;if((i|0)<0)k=11;else k=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=k+h|0;g=a+12|0;f[g>>2]=e;return e|0}function hjb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)ZTb(1,f[a+20>>2]|0,b);if(c&1|0)eUb(2,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function ijb(a){a=a|0;return f[a+12>>2]|0}function jjb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=f[a+20>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=aJc(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&1))r=g;else{e=f[a+16>>2]|0;b[g>>0]=18;p=g+1|0;g=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(g>>>0>127){q=g;d=p;while(1){b[d>>0]=q|128;i=q>>>7;m=d+1|0;if(q>>>0>16383){q=i;d=m}else{s=m;t=i;break}}}else{s=p;t=g}b[s>>0]=t;r=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,s+1|0)|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=Hjc(s&-2,r)|0;return u|0}function kjb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function ljb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16168,0)|0;if(!c){Ehc(b,a);return}else{oib(a,c);return}}function mjb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function njb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526544;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function ojb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function pjb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96796;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=526392?(f[220448]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=108;b[d+8>>0]=0;DTb(881792,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+24>>2]=0;u=c;return}function qjb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function rjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=97228;bkb(a);c=f[a+116>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+100>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+84>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+72|0;d=f[c>>2]|0;if(d|0?(f[a+60>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=f[a+52>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+36>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[c>>2]=0;return}function sjb(a){a=a|0;rjb(a);YDc(a);return}function tjb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function ujb(a,b){a=a|0;b=b|0;a=VDc(144)|0;$jb(a);if(!b)return a|0;akb(b,a);return a|0}function vjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a+16>>2]=0;f[a+28>>2]=0;f[a+44>>2]=0;c=a+64|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+72>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+76>>2]=0;f[a+92>>2]=0;f[a+108>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&15|0){do if(d&1|0){g=f[a+124>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+128>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+132>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&8|0){d=f[a+136>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[a+140>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function wjb(a){a=a|0;return 1}function xjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+16|0;j=a+20|0;k=a+24|0;l=e+8|0;m=e+8|0;n=a+8|0;o=a+140|0;q=a+4|0;r=a+136|0;t=e+4|0;v=a+28|0;w=a+32|0;x=a+36|0;y=a+44|0;z=a+48|0;A=a+52|0;B=a+60|0;C=a+76|0;D=a+80|0;E=a+84|0;F=e+8|0;G=a+124|0;H=a+128|0;I=a+92|0;K=a+96|0;L=a+100|0;M=a+108|0;N=a+112|0;O=a+116|0;P=e+8|0;Q=a+132|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){R=b[a>>0]|0;S=R&255;if(R<<24>>24>0){f[c>>2]=a+1;T=S;U=6}else{V=S;U=5}}else{V=0;U=5}if((U|0)==5){U=0;S=WRb(c,V)|0;if((S+-1|0)>>>0<127){T=S;U=6}else W=S}b:do if((U|0)==6){U=0;do switch(T>>>3&536870911|0){case 1:{switch((T&255)<<24>>24){case 8:break;case 10:{if(Zjb(c,i)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}S=f[c>>2]|0;if(S>>>0<(f[g>>2]|0)>>>0?(a=b[S>>0]|0,a<<24>>24>-1):0){f[c>>2]=S+1;Y=a&255;Z=0}else{IRb(e,c);a=e;if(!(b[m>>0]|0)){X=0;U=156;break a}else{Y=f[a>>2]|0;Z=f[a+4>>2]|0}}a=f[i>>2]|0;S=f[j>>2]|0;if((a|0)==(S|0)){UHa(i,a+1|0);_=f[i>>2]|0;$=f[j>>2]|0}else{_=a;$=S}S=f[k>>2]|0;a=_+1|0;f[i>>2]=a;R=S+8+(_<<3)|0;f[R>>2]=Y;f[R+4>>2]=Z;R=$-a|0;if((R|0)>0){aa=R;ba=a;ca=S}else continue a;while(1){S=f[c>>2]|0;a=f[g>>2]|0;if(S>>>0>=a>>>0)continue a;if((b[S>>0]|0)!=8)continue a;R=S+1|0;f[c>>2]=R;if(R>>>0<a>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=S+2;da=a&255;ea=0;fa=ba;ga=ca}else{IRb(e,c);a=e;if(!(b[l>>0]|0)){X=0;U=156;break a}da=f[a>>2]|0;ea=f[a+4>>2]|0;fa=f[i>>2]|0;ga=f[k>>2]|0}a=fa+1|0;f[i>>2]=a;S=ga+8+(fa<<3)|0;f[S>>2]=da;f[S+4>>2]=ea;if((aa|0)>1){aa=aa+-1|0;ba=a;ca=ga}else continue a}break}case 2:{if((T&255|0)!=16){W=T;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){S=b[a>>0]|0;R=S&255;if(S<<24>>24>-1){f[c>>2]=a+1;ha=R}else{ia=R;U=28}}else{ia=0;U=28}if((U|0)==28){U=0;R=HRb(c,ia)|0;a=J;if((a|0)>-1|(a|0)==-1&R>>>0>4294967295)ha=R;else{X=0;U=156;break a}}if(ha>>>0<16){f[n>>2]=f[n>>2]|16;f[o>>2]=ha;continue a}R=f[q>>2]|0;if(!(R&1))ja=mNa(q)|0;else ja=R&-2;rjc(ja,2,ha,((ha|0)<0)<<31>>31);continue a;break}case 3:{if((T&255|0)!=26){W=T;break b}f[n>>2]=f[n>>2]|8;R=f[r>>2]|0;if(!R){a=VDc(32)|0;Ijb(a);f[r>>2]=a;ka=a}else ka=R;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;la=a&255}else{a=VRb(c)|0;if((a|0)>-1)la=a;else{X=0;U=156;break a}}GRb(e,c,la);if((f[t>>2]|0)<0){U=44;break a}if(!(Mi[f[(f[ka>>2]|0)+44>>2]&1023](ka,c)|0)){U=44;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{X=0;U=156;break a}break}case 4:{switch((T&255)<<24>>24){case 34:break;case 37:{if(fPa(1,34,c,v)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;ma=R&255}else{R=VRb(c)|0;if((R|0)>-1)ma=R;else{X=0;U=156;break a}}na=f[v>>2]|0;R=(ma|0)/4|0;if((R<<2|0)!=(ma|0)){X=0;U=156;break a}a=ORb(c)|0;S=MRb(c)|0;if((((a|0)==-1|(S|0)<(a|0)?S:a)|0)>=(ma|0)){a=na+R|0;if((f[v>>2]|0)<(a|0)?(SHa(v,a),S=f[v>>2]|0,oa=a-S|0,(oa<<2|0)>0):0)XIc((f[x>>2]|0)+((S<<2)+4)|0,0,(((oa|-1073741824|0)==-1073741824?1073741823:1073741822)+oa<<2)+8|0)|0;f[v>>2]=a;a=f[x>>2]|0;if(QRb(c,((a|0)==0?0:a+4|0)+(na<<2)|0,ma)|0)continue a;else{U=58;break a}}if((ma|0)>3)pa=0;else continue a;while(1){a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){oa=a;S=h[oa>>0]|h[oa+1>>0]<<8|h[oa+2>>0]<<16|h[oa+3>>0]<<24;f[e>>2]=S;f[c>>2]=a+4;qa=S}else{if(!(TRb(c,e)|0)){U=67;break a}qa=f[e>>2]|0}S=f[v>>2]|0;if((S|0)==(f[w>>2]|0)){SHa(v,S+1|0);ra=f[v>>2]|0}else ra=S;S=f[x>>2]|0;f[v>>2]=ra+1;f[S+4+(ra<<2)>>2]=qa;S=pa+1|0;if((S|0)<(R|0))pa=S;else continue a}break}case 5:{switch((T&255)<<24>>24){case 42:break;case 40:{if(ySa(1,42,c,y)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(S=b[R>>0]|0,S<<24>>24>-1):0){f[c>>2]=R+1;sa=S&255}else{S=VRb(c)|0;if((S|0)>-1)sa=S;else{X=0;U=156;break a}}S=ERb(c,sa)|0;if((MRb(c)|0)>0)do{R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){a=b[R>>0]|0;oa=a&255;if(a<<24>>24>-1){f[c>>2]=R+1;ta=oa}else{ua=oa;U=78}}else{ua=0;U=78}if((U|0)==78){U=0;oa=HRb(c,ua)|0;R=J;if((R|0)>-1|(R|0)==-1&oa>>>0>4294967295)ta=oa;else{X=0;U=156;break a}}oa=f[y>>2]|0;if((oa|0)==(f[z>>2]|0)){KLa(y,oa+1|0);va=f[y>>2]|0}else va=oa;oa=f[A>>2]|0;f[y>>2]=va+1;f[oa+4+(va<<2)>>2]=ta}while((MRb(c)|0)>0);FRb(c,S);continue a;break}case 6:{if((T&255|0)!=50){W=T;break b}if(fUb(c,JLa(B)|0)|0)continue a;else{X=0;U=156;break a}break}case 7:{switch((T&255)<<24>>24){case 58:break;case 56:{if(ePa(1,58,c,C)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}oa=f[c>>2]|0;if(oa>>>0<(f[g>>2]|0)>>>0?(R=b[oa>>0]|0,R<<24>>24>-1):0){f[c>>2]=oa+1;wa=R&255}else{R=VRb(c)|0;if((R|0)>-1)wa=R;else{X=0;U=156;break a}}R=ERb(c,wa)|0;if((MRb(c)|0)>0)do{oa=f[c>>2]|0;if(oa>>>0<(f[g>>2]|0)>>>0?(a=b[oa>>0]|0,a<<24>>24>-1):0){f[c>>2]=oa+1;xa=a&255;ya=0}else{IRb(e,c);a=e;if(!(b[F>>0]|0)){X=0;U=156;break a}else{xa=f[a>>2]|0;ya=f[a+4>>2]|0}}a=f[C>>2]|0;if((a|0)==(f[D>>2]|0)){UHa(C,a+1|0);za=f[C>>2]|0}else za=a;a=f[E>>2]|0;f[C>>2]=za+1;oa=a+8+(za<<3)|0;f[oa>>2]=xa;f[oa+4>>2]=ya}while((MRb(c)|0)>0);FRb(c,R);continue a;break}case 8:{if((T&255|0)!=66){W=T;break b}f[n>>2]=f[n>>2]|1;S=f[G>>2]|0;if((S|0)==527320){GLa(G,527320);Aa=f[G>>2]|0}else Aa=S;if(fUb(c,Aa)|0)continue a;else{X=0;U=156;break a}break}case 9:{if((T&255|0)!=74){W=T;break b}f[n>>2]=f[n>>2]|2;S=f[H>>2]|0;if((S|0)==527320){GLa(H,527320);Ba=f[H>>2]|0}else Ba=S;if(fUb(c,Ba)|0)continue a;else{X=0;U=156;break a}break}case 10:{switch((T&255)<<24>>24){case 82:break;case 81:{if(aTa(1,82,c,I)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}S=f[c>>2]|0;if(S>>>0<(f[g>>2]|0)>>>0?(oa=b[S>>0]|0,oa<<24>>24>-1):0){f[c>>2]=S+1;Ca=oa&255}else{oa=VRb(c)|0;if((oa|0)>-1)Ca=oa;else{X=0;U=156;break a}}Da=f[I>>2]|0;oa=(Ca|0)/8|0;if((oa<<3|0)!=(Ca|0)){X=0;U=156;break a}S=ORb(c)|0;a=MRb(c)|0;if((((S|0)==-1|(a|0)<(S|0)?a:S)|0)>=(Ca|0)){S=Da+oa|0;if((f[I>>2]|0)<(S|0)?(THa(I,S),a=f[I>>2]|0,Ea=S-a|0,(Ea<<3|0)>0):0)XIc((f[L>>2]|0)+((a<<3)+8)|0,0,(((Ea|-536870912|0)==-536870912?536870911:536870910)+Ea<<3)+16|0)|0;f[I>>2]=S;S=f[L>>2]|0;if(QRb(c,((S|0)==0?0:S+8|0)+(Da<<3)|0,Ca)|0)continue a;else{U=121;break a}}if((Ca|0)>7)Fa=0;else continue a;while(1){S=f[c>>2]|0;if(((f[g>>2]|0)-S|0)>7){Ea=S;a=Ea;Ga=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=Ea+4|0;Ea=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=e;f[a>>2]=Ga;f[a+4>>2]=Ea;f[c>>2]=S+8;f[s>>2]=Ga;f[s+4>>2]=Ea;Ha=+p[s>>3]}else{if(!(URb(c,e)|0)){U=130;break a}Ha=+p[e>>3]}Ea=f[I>>2]|0;if((Ea|0)==(f[K>>2]|0)){THa(I,Ea+1|0);Ia=f[I>>2]|0}else Ia=Ea;Ea=f[L>>2]|0;f[I>>2]=Ia+1;p[Ea+8+(Ia<<3)>>3]=Ha;Ea=Fa+1|0;if((Ea|0)<(oa|0))Fa=Ea;else continue a}break}case 11:{switch((T&255)<<24>>24){case 90:break;case 88:{if(_jb(1,90,c,M)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}oa=f[c>>2]|0;if(oa>>>0<(f[g>>2]|0)>>>0?(R=b[oa>>0]|0,R<<24>>24>-1):0){f[c>>2]=oa+1;Ja=R&255}else{R=VRb(c)|0;if((R|0)>-1)Ja=R;else{X=0;U=156;break a}}R=ERb(c,Ja)|0;if((MRb(c)|0)>0)do{oa=f[c>>2]|0;if(oa>>>0<(f[g>>2]|0)>>>0?(Ea=b[oa>>0]|0,Ea<<24>>24>-1):0){f[c>>2]=oa+1;Ka=Ea&255;La=0}else{IRb(e,c);Ea=e;if(!(b[P>>0]|0)){X=0;U=156;break a}else{Ka=f[Ea>>2]|0;La=f[Ea+4>>2]|0}}Ea=f[M>>2]|0;if((Ea|0)==(f[N>>2]|0)){Hjb(M,Ea+1|0);Ma=f[M>>2]|0}else Ma=Ea;Ea=f[O>>2]|0;f[M>>2]=Ma+1;oa=Ea+8+(Ma<<3)|0;f[oa>>2]=Ka;f[oa+4>>2]=La}while((MRb(c)|0)>0);FRb(c,R);continue a;break}case 12:{if((T&255|0)!=98){W=T;break b}f[n>>2]=f[n>>2]|4;oa=f[Q>>2]|0;if((oa|0)==527320){GLa(Q,527320);Na=f[Q>>2]|0}else Na=oa;if(fUb(c,Na)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}while(0)}while(0);if(!W){X=1;U=156;break}oa=f[q>>2]|0;if(!(oa&1))Oa=mNa(q)|0;else Oa=oa&-2;if(!(Djc(c,W,Oa)|0)){X=0;U=156;break}}if((U|0)==44){X=0;u=d;return X|0}else if((U|0)==58){if((f[v>>2]|0)<=0){X=0;u=d;return X|0}f[v>>2]=na;X=0;u=d;return X|0}else if((U|0)==67){X=0;u=d;return X|0}else if((U|0)==121){if((f[I>>2]|0)<=0){X=0;u=d;return X|0}f[I>>2]=Da;X=0;u=d;return X|0}else if((U|0)==130){X=0;u=d;return X|0}else if((U|0)==156){u=d;return X|0}return 0}function yjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+16>>2]|0;if((c|0)>0){e=f[a+24>>2]|0;g=0;h=0;while(1){i=e+8+(h<<3)|0;j=iJc(f[i>>2]|1|0,f[i+4>>2]|0,1)|0;i=((((j^63)*9|0)+73|0)>>>6)+g|0;h=h+1|0;if((h|0)==(c|0)){k=i;break}else g=i}}else k=0;g=k+d+c|0;c=f[a+28>>2]<<2;if(!c)l=g;else{if((c|0)<0)m=10;else m=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;l=g+1+m|0}f[a+40>>2]=c;m=l+c|0;c=hUb(a+44|0)|0;if(!c)n=m;else{if((c|0)<0)o=10;else o=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;n=m+1+o|0}f[a+56>>2]=c;o=f[a+64>>2]|0;m=n+c+o|0;if((o|0)>0){c=f[a+72>>2]|0;n=0;l=m;while(1){g=f[c+4+(n<<2)>>2]|0;d=b[g+11>>0]|0;k=d<<24>>24<0?f[g+4>>2]|0:d&255;d=k+l+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=n+1|0;if((n|0)==(o|0)){p=d;break}else l=d}}else p=m;m=f[a+76>>2]|0;if((m|0)>0){l=f[a+84>>2]|0;o=0;n=0;do{c=l+8+(n<<3)|0;d=iJc(f[c>>2]|1|0,f[c+4>>2]|0,1)|0;o=((((d^63)*9|0)+73|0)>>>6)+o|0;n=n+1|0}while((n|0)!=(m|0));if(o){if((o|0)<0)q=11;else q=((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=o;s=q+p|0}else{r=0;s=p}}else{r=0;s=p}f[a+88>>2]=r;p=s+r|0;r=f[a+92>>2]<<3;if(!r)t=p;else{if((r|0)<0)u=11;else u=((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;t=u+p|0}f[a+104>>2]=r;p=t+r|0;r=f[a+108>>2]|0;if((r|0)>0){t=f[a+116>>2]|0;u=0;s=0;do{q=t+8+(s<<3)|0;o=iJc(f[q>>2]|1|0,f[q+4>>2]|0,1)|0;u=((((o^63)*9|0)+73|0)>>>6)+u|0;s=s+1|0}while((s|0)!=(r|0));if(u){if((u|0)<0)v=11;else v=((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;w=u;x=v+p|0}else{w=0;x=p}}else{w=0;x=p}f[a+120>>2]=w;p=x+w|0;w=a+8|0;x=f[w>>2]|0;if(!(x&31)){y=p;z=a+12|0;f[z>>2]=y;return y|0}if(!(x&1))A=p;else{v=f[a+124>>2]|0;u=b[v+11>>0]|0;r=u<<24>>24<0?f[v+4>>2]|0:u&255;A=p+1+r+((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(x&2))B=A;else{r=f[a+128>>2]|0;p=b[r+11>>0]|0;u=p<<24>>24<0?f[r+4>>2]|0:p&255;B=A+1+u+((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(x&4))C=B;else{u=f[a+132>>2]|0;A=b[u+11>>0]|0;p=A<<24>>24<0?f[u+4>>2]|0:A&255;C=B+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(x&8)){D=C;E=x}else{x=f[a+136>>2]|0;p=_i[f[(f[x>>2]|0)+48>>2]&1023](x)|0;x=C+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;D=x;E=f[w>>2]|0}if(!(E&16)){y=D;z=a+12|0;f[z>>2]=y;return y|0}E=f[a+140>>2]|0;if((E|0)<0)F=11;else F=((((($(E|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;y=F+D|0;z=a+12|0;f[z>>2]=y;return y|0}function zjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;d=f[a+16>>2]|0;if((d|0)>0){e=a+24|0;g=0;do{h=(f[e>>2]|0)+8+(g<<3)|0;NTb(1,f[h>>2]|0,f[h+4>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+8>>2]|0;if(d&16|0)ZTb(2,f[a+140>>2]|0,c);if(d&8|0)eUb(3,f[a+136>>2]|0,c);g=a+28|0;if((f[g>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){h=c+4|0;b[f[h>>2]>>0]=34;f[h>>2]=(f[h>>2]|0)+1;h=(f[e>>2]|0)+-1|0;f[e>>2]=h;i=h}else{bSb(c,34);i=f[e>>2]|0}h=f[a+40>>2]|0;if((i|0)>4){i=c+4|0;j=f[i>>2]|0;if(h>>>0>127){k=h;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=h}b[o>>0]=p;p=o+1-j|0;f[i>>2]=(f[i>>2]|0)+p;f[e>>2]=(f[e>>2]|0)-p}else bSb(c,h);h=f[a+36>>2]|0;JTb((h|0)==0?0:h+4|0,f[g>>2]|0,c)}g=a+44|0;if((f[g>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){p=c+4|0;b[f[p>>2]>>0]=42;f[p>>2]=(f[p>>2]|0)+1;p=(f[h>>2]|0)+-1|0;f[h>>2]=p;q=p}else{bSb(c,42);q=f[h>>2]|0}p=f[a+56>>2]|0;if((q|0)>4){q=c+4|0;e=f[q>>2]|0;if(p>>>0>127){i=p;j=e;while(1){b[j>>0]=i|128;o=i>>>7;l=j+1|0;if(i>>>0>16383){i=o;j=l}else{r=l;s=o;break}}}else{r=e;s=p}b[r>>0]=s;s=r+1-e|0;f[q>>2]=(f[q>>2]|0)+s;f[h>>2]=(f[h>>2]|0)-s}else bSb(c,p);p=f[g>>2]|0;if((p|0)>0){g=a+52|0;s=c+8|0;h=c+4|0;q=0;do{e=f[(f[g>>2]|0)+4+(q<<2)>>2]|0;r=((e|0)<0)<<31>>31;if((f[s>>2]|0)>9){j=f[h>>2]|0;i=e&255;if(e>>>0>127){o=j;l=i;k=e;m=r;while(1){b[o>>0]=l|-128;n=k;k=aJc(k|0,m|0,7)|0;t=o+1|0;u=k&255;if(!(m>>>0>0|(m|0)==0&n>>>0>16383)){v=t;w=u;break}else{o=t;l=u;m=J}}}else{v=j;w=i}b[v>>0]=w;m=v+1-j|0;f[h>>2]=(f[h>>2]|0)+m;f[s>>2]=(f[s>>2]|0)-m}else cSb(c,e,r);q=q+1|0}while((q|0)!=(p|0))}}p=f[a+64>>2]|0;if((p|0)>0){q=a+72|0;s=0;do{aUb(6,f[(f[q>>2]|0)+4+(s<<2)>>2]|0,c);s=s+1|0}while((s|0)!=(p|0))}p=a+76|0;if((f[p>>2]|0)>0){s=c+8|0;if((f[s>>2]|0)>4){q=c+4|0;b[f[q>>2]>>0]=58;f[q>>2]=(f[q>>2]|0)+1;q=(f[s>>2]|0)+-1|0;f[s>>2]=q;x=q}else{bSb(c,58);x=f[s>>2]|0}q=f[a+88>>2]|0;if((x|0)>4){x=c+4|0;h=f[x>>2]|0;if(q>>>0>127){v=q;w=h;while(1){b[w>>0]=v|128;g=v>>>7;m=w+1|0;if(v>>>0>16383){v=g;w=m}else{y=m;z=g;break}}}else{y=h;z=q}b[y>>0]=z;z=y+1-h|0;f[x>>2]=(f[x>>2]|0)+z;f[s>>2]=(f[s>>2]|0)-z}else bSb(c,q);q=f[p>>2]|0;if((q|0)>0){p=a+84|0;z=c+8|0;s=c+4|0;x=0;do{h=(f[p>>2]|0)+8+(x<<3)|0;y=f[h>>2]|0;w=f[h+4>>2]|0;if((f[z>>2]|0)>9){h=f[s>>2]|0;v=y&255;if(w>>>0>0|(w|0)==0&y>>>0>127){g=h;m=v;l=y;o=w;while(1){b[g>>0]=m|-128;k=l;l=aJc(l|0,o|0,7)|0;u=g+1|0;t=l&255;if(!(o>>>0>0|(o|0)==0&k>>>0>16383)){A=u;B=t;break}else{g=u;m=t;o=J}}}else{A=h;B=v}b[A>>0]=B;o=A+1-h|0;f[s>>2]=(f[s>>2]|0)+o;f[z>>2]=(f[z>>2]|0)-o}else cSb(c,y,w);x=x+1|0}while((x|0)!=(q|0))}}if(d&1|0)$Tb(8,f[a+124>>2]|0,c);if(d&2|0)bUb(9,f[a+128>>2]|0,c);q=a+92|0;if((f[q>>2]|0)>0){x=c+8|0;if((f[x>>2]|0)>4){z=c+4|0;b[f[z>>2]>>0]=82;f[z>>2]=(f[z>>2]|0)+1;z=(f[x>>2]|0)+-1|0;f[x>>2]=z;C=z}else{bSb(c,82);C=f[x>>2]|0}z=f[a+104>>2]|0;if((C|0)>4){C=c+4|0;s=f[C>>2]|0;if(z>>>0>127){A=z;B=s;while(1){b[B>>0]=A|128;p=A>>>7;o=B+1|0;if(A>>>0>16383){A=p;B=o}else{D=o;E=p;break}}}else{D=s;E=z}b[D>>0]=E;E=D+1-s|0;f[C>>2]=(f[C>>2]|0)+E;f[x>>2]=(f[x>>2]|0)-E}else bSb(c,z);z=f[a+100>>2]|0;KTb((z|0)==0?0:z+8|0,f[q>>2]|0,c)}q=a+108|0;if((f[q>>2]|0)>0){z=c+8|0;if((f[z>>2]|0)>4){E=c+4|0;b[f[E>>2]>>0]=90;f[E>>2]=(f[E>>2]|0)+1;E=(f[z>>2]|0)+-1|0;f[z>>2]=E;F=E}else{bSb(c,90);F=f[z>>2]|0}E=f[a+120>>2]|0;if((F|0)>4){F=c+4|0;x=f[F>>2]|0;if(E>>>0>127){C=E;s=x;while(1){b[s>>0]=C|128;D=C>>>7;B=s+1|0;if(C>>>0>16383){C=D;s=B}else{G=B;H=D;break}}}else{G=x;H=E}b[G>>0]=H;H=G+1-x|0;f[F>>2]=(f[F>>2]|0)+H;f[z>>2]=(f[z>>2]|0)-H}else bSb(c,E);E=f[q>>2]|0;if((E|0)>0){q=a+116|0;H=c+8|0;z=c+4|0;F=0;do{x=(f[q>>2]|0)+8+(F<<3)|0;G=f[x>>2]|0;s=f[x+4>>2]|0;if((f[H>>2]|0)>9){x=f[z>>2]|0;C=G&255;if(s>>>0>0|(s|0)==0&G>>>0>127){D=x;B=C;A=G;p=s;while(1){b[D>>0]=B|-128;o=A;A=aJc(A|0,p|0,7)|0;m=D+1|0;g=A&255;if(!(p>>>0>0|(p|0)==0&o>>>0>16383)){I=m;K=g;break}else{D=m;B=g;p=J}}}else{I=x;K=C}b[I>>0]=K;p=I+1-x|0;f[z>>2]=(f[z>>2]|0)+p;f[H>>2]=(f[H>>2]|0)-p}else cSb(c,G,s);F=F+1|0}while((F|0)!=(E|0))}}if(d&4|0)$Tb(12,f[a+132>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Ajb(a){a=a|0;return f[a+12>>2]|0}function Bjb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=f[a+16>>2]|0;if(!e)g=d;else{h=f[a+24>>2]|0;i=0;j=d;while(1){d=h+8+(i<<3)|0;k=f[d>>2]|0;l=f[d+4>>2]|0;b[j>>0]=8;d=j+1|0;m=k&255;if(l>>>0>0|(l|0)==0&k>>>0>127){n=d;o=m;p=k;k=l;while(1){b[n>>0]=o|-128;l=p;p=aJc(p|0,k|0,7)|0;q=n+1|0;r=p&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){s=q;t=r;break}else{n=q;o=r;k=J}}}else{s=d;t=m}b[s>>0]=t;k=s+1|0;i=i+1|0;if((i|0)>=(e|0)){g=k;break}else j=k}}j=f[a+8>>2]|0;if(!(j&16))u=g;else{e=f[a+140>>2]|0;b[g>>0]=16;i=g+1|0;g=e&255;if(e>>>0>127){s=i;t=g;h=e;k=((e|0)<0)<<31>>31;while(1){b[s>>0]=t|-128;e=h;h=aJc(h|0,k|0,7)|0;o=s+1|0;n=h&255;if(!(k>>>0>0|(k|0)==0&e>>>0>16383)){v=o;w=n;break}else{s=o;t=n;k=J}}}else{v=i;w=g}b[v>>0]=w;u=v+1|0}if(!(j&8))x=u;else{v=f[a+136>>2]|0;b[u>>0]=26;w=u+1|0;u=_i[f[(f[v>>2]|0)+60>>2]&1023](v)|0;if(u>>>0>127){g=u;i=w;while(1){b[i>>0]=g|128;k=g>>>7;t=i+1|0;if(g>>>0>16383){g=k;i=t}else{y=t;z=k;break}}}else{y=w;z=u}b[y>>0]=z;x=hj[f[(f[v>>2]|0)+64>>2]&511](v,c,y+1|0)|0}y=a+28|0;if((f[y>>2]|0)>0){b[x>>0]=34;c=x+1|0;v=f[a+40>>2]|0;if(v>>>0>127){z=v;u=c;while(1){b[u>>0]=z|128;w=z>>>7;i=u+1|0;if(z>>>0>16383){z=w;u=i}else{A=i;B=w;break}}}else{A=c;B=v}b[A>>0]=B;B=A+1|0;A=f[y>>2]<<2;dJc(B|0,(f[a+36>>2]|0)+4|0,A|0)|0;C=B+A|0}else C=x;x=a+44|0;if((f[x>>2]|0)>0){b[C>>0]=42;A=C+1|0;B=f[a+56>>2]|0;if(B>>>0>127){y=B;v=A;while(1){b[v>>0]=y|128;c=y>>>7;u=v+1|0;if(y>>>0>16383){y=c;v=u}else{D=u;E=c;break}}}else{D=A;E=B}b[D>>0]=E;E=f[x>>2]|0;x=f[a+52>>2]|0;B=0;A=D+1|0;while(1){D=f[x+4+(B<<2)>>2]|0;v=D&255;if(D>>>0>127){y=A;c=v;u=D;z=((D|0)<0)<<31>>31;while(1){b[y>>0]=c|-128;D=u;u=aJc(u|0,z|0,7)|0;w=y+1|0;i=u&255;if(!(z>>>0>0|(z|0)==0&D>>>0>16383)){F=w;G=i;break}else{y=w;c=i;z=J}}}else{F=A;G=v}b[F>>0]=G;z=F+1|0;B=B+1|0;if((B|0)>=(E|0)){H=z;break}else A=z}}else H=C;C=f[a+64>>2]|0;if((C|0)>0){A=a+72|0;E=0;B=H;while(1){F=f[(f[A>>2]|0)+4+(E<<2)>>2]|0;b[B>>0]=50;G=dSb(F,B+1|0)|0;E=E+1|0;if((E|0)==(C|0)){I=G;break}else B=G}}else I=H;H=a+76|0;if((f[H>>2]|0)>0){b[I>>0]=58;B=I+1|0;C=f[a+88>>2]|0;if(C>>>0>127){E=C;A=B;while(1){b[A>>0]=E|128;G=E>>>7;F=A+1|0;if(E>>>0>16383){E=G;A=F}else{K=F;L=G;break}}}else{K=B;L=C}b[K>>0]=L;L=f[H>>2]|0;H=f[a+84>>2]|0;C=0;B=K+1|0;while(1){K=H+8+(C<<3)|0;A=f[K>>2]|0;E=f[K+4>>2]|0;K=A&255;if(E>>>0>0|(E|0)==0&A>>>0>127){G=B;F=K;x=A;A=E;while(1){b[G>>0]=F|-128;E=x;x=aJc(x|0,A|0,7)|0;z=G+1|0;c=x&255;if(!(A>>>0>0|(A|0)==0&E>>>0>16383)){M=z;N=c;break}else{G=z;F=c;A=J}}}else{M=B;N=K}b[M>>0]=N;A=M+1|0;C=C+1|0;if((C|0)>=(L|0)){O=A;break}else B=A}}else O=I;if(!(j&1))P=O;else{I=f[a+124>>2]|0;b[O>>0]=66;P=dSb(I,O+1|0)|0}if(!(j&2))Q=P;else{O=f[a+128>>2]|0;b[P>>0]=74;Q=dSb(O,P+1|0)|0}P=a+92|0;if((f[P>>2]|0)>0){b[Q>>0]=82;O=Q+1|0;I=f[a+104>>2]|0;if(I>>>0>127){B=I;L=O;while(1){b[L>>0]=B|128;C=B>>>7;M=L+1|0;if(B>>>0>16383){B=C;L=M}else{R=M;S=C;break}}}else{R=O;S=I}b[R>>0]=S;S=R+1|0;R=f[P>>2]<<3;dJc(S|0,(f[a+100>>2]|0)+8|0,R|0)|0;T=S+R|0}else T=Q;Q=a+108|0;if((f[Q>>2]|0)>0){b[T>>0]=90;R=T+1|0;S=f[a+120>>2]|0;if(S>>>0>127){P=S;I=R;while(1){b[I>>0]=P|128;O=P>>>7;L=I+1|0;if(P>>>0>16383){P=O;I=L}else{U=L;V=O;break}}}else{U=R;V=S}b[U>>0]=V;V=f[Q>>2]|0;Q=f[a+116>>2]|0;S=0;R=U+1|0;while(1){U=Q+8+(S<<3)|0;I=f[U>>2]|0;P=f[U+4>>2]|0;U=I&255;if(P>>>0>0|(P|0)==0&I>>>0>127){O=R;L=U;B=I;I=P;while(1){b[O>>0]=L|-128;P=B;B=aJc(B|0,I|0,7)|0;C=O+1|0;M=B&255;if(!(I>>>0>0|(I|0)==0&P>>>0>16383)){W=C;X=M;break}else{O=C;L=M;I=J}}}else{W=R;X=U}b[W>>0]=X;I=W+1|0;S=S+1|0;if((S|0)>=(V|0)){Y=I;break}else R=I}}else Y=T;if(!(j&4))Z=Y;else{j=f[a+132>>2]|0;b[Y>>0]=98;Z=dSb(j,Y+1|0)|0}Y=f[a+4>>2]|0;if(!(Y&1)){_=Z;return _|0}_=Hjc(Y&-2,Z)|0;return _|0}function Cjb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Djb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16184,0)|0;if(!c){Ehc(b,a);return}else{Gjb(a,c);return}}function Ejb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Fjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526520;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Gjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){UHa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+8+(f[d>>2]<<3)|0,(f[b+24>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+28|0;d=b+28|0;e=f[d>>2]|0;if(e|0){SHa(g,(f[g>>2]|0)+e|0);dJc((f[a+36>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+36>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+44|0;g=b+44|0;e=f[g>>2]|0;if(e|0){KLa(d,(f[d>>2]|0)+e|0);dJc((f[a+52>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+52>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}yNa(a+60|0,b+60|0);g=a+76|0;d=b+76|0;e=f[d>>2]|0;if(e|0){UHa(g,(f[g>>2]|0)+e|0);dJc((f[a+84>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+84>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+92|0;g=b+92|0;e=f[g>>2]|0;if(e|0){THa(d,(f[d>>2]|0)+e|0);dJc((f[a+100>>2]|0)+8+(f[d>>2]<<3)|0,(f[b+100>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+108|0;d=b+108|0;e=f[d>>2]|0;if(e|0){Hjb(g,(f[g>>2]|0)+e|0);dJc((f[a+116>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+116>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=f[b+8>>2]|0;if(!(d&31))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+124|0,e=f[b+124>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+128|0,c=f[b+128>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==527320){GLa(e,c);break}else{iEc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+132|0,g=f[b+132>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==527320){GLa(c,g);break}else{iEc(e,g)|0;break}while(0);if(d&8|0){g=a+8|0;f[g>>2]=f[g>>2]|8;g=a+136|0;e=f[g>>2]|0;if(!e){c=VDc(32)|0;Ijb(c);f[g>>2]=c;h=c}else h=e;e=f[b+136>>2]|0;c=e|0?e:526104;e=h+4|0;g=f[c+4>>2]|0;if(g&1|0){i=f[e>>2]|0;if(!(i&1))j=mNa(e)|0;else j=i&-2;ojc(j,g&-2)}g=f[c+8>>2]|0;if(g&3|0){if(g&1|0){j=c+16|0;i=f[j+4>>2]|0;e=h+16|0;f[e>>2]=f[j>>2];f[e+4>>2]=i}if(g&2|0){i=c+24|0;c=f[i+4>>2]|0;e=h+24|0;f[e>>2]=f[i>>2];f[e+4>>2]=c}c=h+8|0;f[c>>2]=f[c>>2]|g}}if(d&16|0)f[a+140>>2]=f[b+140>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Hjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<3;if(!i)k=VDc(d+8|0)|0;else{b=d+15&-8;if(f[i+64>>2]|0)OQb(i,23816,b);k=MQb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)dJc(k+8|0,g+8|0,j<<3|0)|0;if(h)return;if(f[g>>2]|0)return;YDc(g);return}function Ijb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97336;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=526104?(f[220443]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=103;b[d+8>>0]=0;DTb(881772,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;u=c;return}function Jjb(a){a=a|0;var b=0,c=0;f[a>>2]=97336;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function Kjb(a){a=a|0;var b=0,c=0;f[a>>2]=97336;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function Ljb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Mjb(a,b){a=a|0;b=b|0;a=VDc(32)|0;Ijb(a);if(!b)return a|0;Yjb(b,a);return a|0}function Njb(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&3|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Ojb(a){a=a|0;return 1}function Pjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+8|0;k=a+24|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;t=a&255;v=0}else{IRb(e,c);a=e;if(!(b[j>>0]|0)){w=0;q=24;break a}else{t=f[a>>2]|0;v=f[a+4>>2]|0}}a=i;f[a>>2]=t;f[a+4>>2]=v;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|2;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(o=b[a>>0]|0,o<<24>>24>-1):0){f[c>>2]=a+1;x=o&255;y=0}else{IRb(e,c);o=e;if(!(b[l>>0]|0)){w=0;q=24;break a}else{x=f[o>>2]|0;y=f[o+4>>2]|0}}o=k;f[o>>2]=x;f[o+4>>2]=y;continue a;break}default:{s=p;break b}}}while(0);if(!s){w=1;q=24;break}o=f[m>>2]|0;if(!(o&1))z=mNa(m)|0;else z=o&-2;if(!(Djc(c,s,z)|0)){w=0;q=24;break}}if((q|0)==24){u=d;return w|0}return 0}function Qjb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=a+16|0;i=iJc(f[h>>2]|1|0,f[h+4>>2]|0,1)|0;g=c+1+((((i^63)*9|0)+73|0)>>>6)|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=a+24|0;i=iJc(f[b>>2]|1|0,f[b+4>>2]|0,1)|0;d=g+1+((((i^63)*9|0)+73|0)>>>6)|0;e=a+12|0;f[e>>2]=d;return d|0}function Rjb(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a+8>>2]|0;if(c&1|0){d=a+16|0;NTb(1,f[d>>2]|0,f[d+4>>2]|0,b)}if(c&2|0){c=a+24|0;NTb(2,f[c>>2]|0,f[c+4>>2]|0,b)}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Sjb(a){a=a|0;return f[a+12>>2]|0}function Tjb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=a+16|0;h=f[g>>2]|0;i=f[g+4>>2]|0;b[d>>0]=8;g=d+1|0;d=h&255;if(i>>>0>0|(i|0)==0&h>>>0>127){j=g;k=d;l=h;h=i;while(1){b[j>>0]=k|-128;i=l;l=aJc(l|0,h|0,7)|0;m=j+1|0;n=l&255;if(!(h>>>0>0|(h|0)==0&i>>>0>16383)){o=m;p=n;break}else{j=m;k=n;h=J}}}else{o=g;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=a+24|0;o=f[c>>2]|0;p=f[c+4>>2]|0;b[e>>0]=16;c=e+1|0;e=o&255;if(p>>>0>0|(p|0)==0&o>>>0>127){d=c;g=e;h=o;o=p;while(1){b[d>>0]=g|-128;p=h;h=aJc(h|0,o|0,7)|0;k=d+1|0;j=h&255;if(!(o>>>0>0|(o|0)==0&p>>>0>16383)){r=k;s=j;break}else{d=k;g=j;o=J}}}else{r=c;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function Ujb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Vjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,16200,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0){g=c+16|0;e=f[g+4>>2]|0;b=a+16|0;f[b>>2]=f[g>>2];f[b+4>>2]=e}if(d&2|0){e=c+24|0;c=f[e+4>>2]|0;b=a+24|0;f[b>>2]=f[e>>2];f[b+4>>2]=c}c=a+8|0;f[c>>2]=f[c>>2]|d;return}function Wjb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Xjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526512;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Yjb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Zjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=a+4|0;if(g>>>0<(f[h>>2]|0)>>>0?(i=b[g>>0]|0,i<<24>>24>-1):0){f[a>>2]=g+1;j=i&255}else{i=VRb(a)|0;if((i|0)>-1)j=i;else{k=0;u=d;return k|0}}i=ERb(a,j)|0;a:do if((MRb(a)|0)>0){j=c+4|0;g=c+8|0;l=e+8|0;while(1){m=f[a>>2]|0;if(m>>>0<(f[h>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[a>>2]=m+1;o=n&255;p=0}else{IRb(e,a);n=e;if(!(b[l>>0]|0)){k=0;break}else{o=f[n>>2]|0;p=f[n+4>>2]|0}}n=f[c>>2]|0;if((n|0)==(f[j>>2]|0)){UHa(c,n+1|0);q=f[c>>2]|0}else q=n;n=f[g>>2]|0;f[c>>2]=q+1;m=n+8+(q<<3)|0;f[m>>2]=o;f[m+4>>2]=p;if((MRb(a)|0)<=0)break a}u=d;return k|0}while(0);FRb(a,i);k=1;u=d;return k|0}function _jb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;a=u;u=u+16|0;g=a;i=f[d>>2]|0;j=d+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=i+1;l=k&255;m=0}else{IRb(g,d);k=g;if(!(b[g+8>>0]|0)){n=0;u=a;return n|0}else{l=f[k>>2]|0;m=f[k+4>>2]|0}}k=f[e>>2]|0;i=e+4|0;o=f[i>>2]|0;if((k|0)==(o|0)){Hjb(e,k+1|0);p=f[e>>2]|0;q=f[i>>2]|0}else{p=k;q=o}o=e+8|0;k=f[o>>2]|0;i=p+1|0;f[e>>2]=i;r=k+8+(p<<3)|0;f[r>>2]=l;f[r+4>>2]=m;m=q-i|0;if((m|0)<=0){n=1;u=a;return n|0}q=g+8|0;r=c&127|128;l=c>>>7&255;if(c>>>0<128){p=m;s=i;t=k;while(1){v=f[d>>2]|0;w=f[j>>2]|0;if(v>>>0>=w>>>0){n=1;x=27;break}if((h[v>>0]|0)!=(c|0)){n=1;x=27;break}y=v+1|0;f[d>>2]=y;if(y>>>0<w>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[d>>2]=v+2;z=s;A=t;B=w&255;C=0}else{IRb(g,d);w=g;if(!(b[q>>0]|0)){n=0;x=27;break}z=f[e>>2]|0;A=f[o>>2]|0;B=f[w>>2]|0;C=f[w+4>>2]|0}s=z+1|0;f[e>>2]=s;w=A+8+(z<<3)|0;f[w>>2]=B;f[w+4>>2]=C;if((p|0)<=1){n=1;x=27;break}else{p=p+-1|0;t=A}}if((x|0)==27){u=a;return n|0}}if(c>>>0<16384){D=m;E=i;F=k}else{n=1;u=a;return n|0}while(1){k=f[j>>2]|0;i=f[d>>2]|0;m=i;if((k-i|0)<=1){n=1;x=27;break}if((h[m>>0]|0)!=(r|0)){n=1;x=27;break}if((b[m+1>>0]|0)!=l<<24>>24){n=1;x=27;break}i=m+2|0;f[d>>2]=i;if(i>>>0<k>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=m+3;G=E;H=F;I=k&255;J=0}else{IRb(g,d);k=g;if(!(b[q>>0]|0)){n=0;x=27;break}G=f[e>>2]|0;H=f[o>>2]|0;I=f[k>>2]|0;J=f[k+4>>2]|0}E=G+1|0;f[e>>2]=E;k=H+8+(G<<3)|0;f[k>>2]=I;f[k+4>>2]=J;if((D|0)<=1){n=1;x=27;break}else{D=D+-1|0;F=H}}if((x|0)==27){u=a;return n|0}return 0}function $jb(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=97228;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;g=a+60|0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+100>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+116>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;if((a|0)!=526136?(f[220444]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=104;b[d+8>>0]=0;DTb(881776,d);ZSb(d)}f[a+12>>2]=0;f[a+124>>2]=527320;f[a+128>>2]=527320;f[a+132>>2]=527320;d=a+136|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function akb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function bkb(a){a=a|0;var c=0;c=f[a+124>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+128>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+132>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==526136)return;c=f[a+136>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function ckb(a){a=a|0;var c=0,d=0;f[a>>2]=97444;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function dkb(a){a=a|0;ckb(a);YDc(a);return}function ekb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function fkb(a,b){a=a|0;b=b|0;a=VDc(24)|0;skb(a);if(!b)return a|0;tkb(b,a);return a|0}function gkb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function hkb(a){a=a|0;return 1}function ikb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=10){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[g>>2]|0;if((k|0)==527320){GLa(g,527320);p=f[g>>2]|0}else p=k;if(fUb(c,p)|0)continue a;else{q=0;m=20;break a}break}case 2:{if((l&255|0)!=18){o=l;break b}f[e>>2]=f[e>>2]|2;k=f[h>>2]|0;if((k|0)==527320){GLa(h,527320);r=f[h>>2]|0}else r=k;if(fUb(c,r)|0)continue a;else{q=0;m=20;break a}break}default:{o=l;break b}}}while(0);if(!o){q=1;m=20;break}k=f[i>>2]|0;if(!(k&1))s=mNa(i)|0;else s=k&-2;if(!(Djc(c,o,s)|0)){q=0;m=20;break}}if((m|0)==20)return q|0;return 0}function jkb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+20>>2]|0;k=b[c+11>>0]|0;d=k<<24>>24<0?f[c+4>>2]|0:k&255;e=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function kkb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&2|0)$Tb(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function lkb(a){a=a|0;return f[a+12>>2]|0}function mkb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&2))h=e;else{c=f[a+20>>2]|0;b[e>>0]=18;h=dSb(c,e+1|0)|0}e=f[a+4>>2]|0;if(!(e&1)){i=h;return i|0}i=Hjc(e&-2,h)|0;return i|0}function nkb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function okb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16216,0)|0;if(!c){Ehc(b,a);return}else{rkb(a,c);return}}function pkb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function qkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526496;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function rkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+20|0;a=f[b+20>>2]|0;b=f[d>>2]|0;if((b|0)==(a|0))return;if((b|0)==527320){GLa(d,a);return}else{iEc(b,a)|0;return}}function skb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97444;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=525976?(f[220442]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=102;b[d+8>>0]=0;DTb(881768,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;u=c;return}function tkb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function ukb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=97552;kmb(a);b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+28|0;h=f[b>>2]|0;if(h|0?(f[a+16>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;YDc(i)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[b>>2]=0;return}function vkb(a){a=a|0;ukb(a);YDc(a);return}function wkb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function xkb(a,b){a=a|0;b=b|0;a=VDc(88)|0;imb(a);if(!b)return a|0;jmb(b,a);return a|0}function ykb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&31|0){do if(d&1|0){e=f[a+48>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+52>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&4|0){e=f[a+56>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&8|0){g=f[a+60>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&16|0){e=f[a+64>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}if(d&96|0){d=a+72|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function zkb(a){a=a|0;return 1}function Akb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+72|0;j=e+8|0;k=a+48|0;l=a+52|0;m=a+56|0;n=a+80|0;o=e+8|0;p=a+60|0;q=a+64|0;r=e+4|0;s=a+16|0;t=a+28|0;v=a+24|0;w=a+20|0;x=e+4|0;y=a+32|0;z=a+44|0;A=a+40|0;B=a+36|0;C=e+4|0;D=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){E=b[a>>0]|0;F=E&255;if(E<<24>>24>0){f[c>>2]=a+1;G=F;H=6}else{I=F;H=5}}else{I=0;H=5}if((H|0)==5){H=0;F=WRb(c,I)|0;if((F+-1|0)>>>0<127){G=F;H=6}else J=F}b:do if((H|0)==6){H=0;switch(G>>>3&536870911|0){case 1:{if((G&255|0)!=8){J=G;break b}f[h>>2]=f[h>>2]|32;F=f[c>>2]|0;if(F>>>0<(f[g>>2]|0)>>>0?(a=b[F>>0]|0,a<<24>>24>-1):0){f[c>>2]=F+1;K=a&255;L=0}else{IRb(e,c);a=e;if(!(b[j>>0]|0)){M=0;H=93;break a}else{K=f[a>>2]|0;L=f[a+4>>2]|0}}a=i;f[a>>2]=K;f[a+4>>2]=L;continue a;break}case 2:{if((G&255|0)!=18){J=G;break b}f[h>>2]=f[h>>2]|1;a=f[k>>2]|0;if((a|0)==527320){GLa(k,527320);N=f[k>>2]|0}else N=a;if(fUb(c,N)|0)continue a;else{M=0;H=93;break a}break}case 3:{if((G&255|0)!=26){J=G;break b}f[h>>2]=f[h>>2]|2;a=f[l>>2]|0;if((a|0)==527320){GLa(l,527320);O=f[l>>2]|0}else O=a;if(fUb(c,O)|0)continue a;else{M=0;H=93;break a}break}case 4:{if((G&255|0)!=34){J=G;break b}f[h>>2]=f[h>>2]|4;a=f[m>>2]|0;if((a|0)==527320){GLa(m,527320);P=f[m>>2]|0}else P=a;if(fUb(c,P)|0)continue a;else{M=0;H=93;break a}break}case 5:{if((G&255|0)!=40){J=G;break b}f[h>>2]=f[h>>2]|64;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(F=b[a>>0]|0,F<<24>>24>-1):0){f[c>>2]=a+1;Q=F&255;R=0}else{IRb(e,c);F=e;if(!(b[o>>0]|0)){M=0;H=93;break a}else{Q=f[F>>2]|0;R=f[F+4>>2]|0}}F=n;f[F>>2]=Q;f[F+4>>2]=R;continue a;break}case 6:{if((G&255|0)!=50){J=G;break b}f[h>>2]=f[h>>2]|8;F=f[p>>2]|0;if((F|0)==527320){GLa(p,527320);S=f[p>>2]|0}else S=F;if(fUb(c,S)|0)continue a;else{M=0;H=93;break a}break}case 7:{if((G&255|0)!=58){J=G;break b}f[h>>2]=f[h>>2]|16;F=f[q>>2]|0;if(!F){a=VDc(104)|0;Mkb(a);f[q>>2]=a;T=a}else T=F;F=f[c>>2]|0;if(F>>>0<(f[g>>2]|0)>>>0?(a=b[F>>0]|0,a<<24>>24>-1):0){f[c>>2]=F+1;U=a&255}else{a=VRb(c)|0;if((a|0)>-1)U=a;else{M=0;H=93;break a}}GRb(e,c,U);if((f[r>>2]|0)<0){H=44;break a}if(!(Mi[f[(f[T>>2]|0)+44>>2]&1023](T,c)|0)){H=44;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{M=0;H=93;break a}break}case 8:{if((G&255|0)!=66){J=G;break b}a=f[t>>2]|0;do if(a){F=f[w>>2]|0;E=f[a>>2]|0;if((F|0)>=(E|0))if((E|0)==(f[v>>2]|0)){V=E;H=52;break}else{W=E;X=a;H=53;break}else{f[w>>2]=F+1;Y=f[a+4+(F<<2)>>2]|0;break}}else{V=f[v>>2]|0;H=52}while(0);if((H|0)==52){H=0;USb(s,V+1|0);a=f[t>>2]|0;W=f[a>>2]|0;X=a;H=53}if((H|0)==53){H=0;f[X>>2]=W+1;a=f[s>>2]|0;if(!a){F=VDc(32)|0;Xhb(F);Z=F}else{if(f[a+64>>2]|0)OQb(a,16104,32);F=NQb(a,32,1761)|0;Xhb(F);Z=F}F=f[t>>2]|0;a=f[w>>2]|0;f[w>>2]=a+1;f[F+4+(a<<2)>>2]=Z;Y=Z}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(F=b[a>>0]|0,F<<24>>24>-1):0){f[c>>2]=a+1;_=F&255}else{F=VRb(c)|0;if((F|0)>-1)_=F;else{M=0;H=93;break a}}GRb(e,c,_);if((f[x>>2]|0)<0){H=65;break a}if(!(Mi[f[(f[Y>>2]|0)+44>>2]&1023](Y,c)|0)){H=65;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{M=0;H=93;break a}break}case 14:{if((G&255|0)!=114){J=G;break b}F=f[z>>2]|0;do if(F){a=f[B>>2]|0;E=f[F>>2]|0;if((a|0)>=(E|0))if((E|0)==(f[A>>2]|0)){$=E;H=73;break}else{aa=E;ba=F;H=74;break}else{f[B>>2]=a+1;ca=f[F+4+(a<<2)>>2]|0;break}}else{$=f[A>>2]|0;H=73}while(0);if((H|0)==73){H=0;USb(y,$+1|0);F=f[z>>2]|0;aa=f[F>>2]|0;ba=F;H=74}if((H|0)==74){H=0;f[ba>>2]=aa+1;F=f[y>>2]|0;if(!F){a=VDc(24)|0;skb(a);da=a}else{if(f[F+64>>2]|0)OQb(F,16216,24);a=NQb(F,24,1762)|0;skb(a);da=a}a=f[z>>2]|0;F=f[B>>2]|0;f[B>>2]=F+1;f[a+4+(F<<2)>>2]=da;ca=da}F=f[c>>2]|0;if(F>>>0<(f[g>>2]|0)>>>0?(a=b[F>>0]|0,a<<24>>24>-1):0){f[c>>2]=F+1;ea=a&255}else{a=VRb(c)|0;if((a|0)>-1)ea=a;else{M=0;H=93;break a}}GRb(e,c,ea);if((f[C>>2]|0)<0){H=86;break a}if(!(Mi[f[(f[ca>>2]|0)+44>>2]&1023](ca,c)|0)){H=86;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{M=0;H=93;break a}break}default:{J=G;break b}}}while(0);if(!J){M=1;H=93;break}a=f[D>>2]|0;if(!(a&1))fa=mNa(D)|0;else fa=a&-2;if(!(Djc(c,J,fa)|0)){M=0;H=93;break}}if((H|0)==44){M=0;u=d;return M|0}else if((H|0)==65){M=0;u=d;return M|0}else if((H|0)==86){M=0;u=d;return M|0}else if((H|0)==93){u=d;return M|0}return 0}function Bkb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+44|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=a+8|0;i=f[d>>2]|0;if(!(i&127)){l=k;m=a+12|0;f[m>>2]=l;return l|0}if(!(i&1))n=k;else{h=f[a+48>>2]|0;g=b[h+11>>0]|0;c=g<<24>>24<0?f[h+4>>2]|0:g&255;n=k+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2))o=n;else{c=f[a+52>>2]|0;k=b[c+11>>0]|0;g=k<<24>>24<0?f[c+4>>2]|0:k&255;o=n+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&4))p=o;else{g=f[a+56>>2]|0;n=b[g+11>>0]|0;k=n<<24>>24<0?f[g+4>>2]|0:n&255;p=o+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&8))q=p;else{k=f[a+60>>2]|0;o=b[k+11>>0]|0;n=o<<24>>24<0?f[k+4>>2]|0:o&255;q=p+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&16)){r=q;s=i}else{i=f[a+64>>2]|0;n=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=q+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=i;s=f[d>>2]|0}if(!(s&32))t=r;else{d=a+72|0;i=iJc(f[d>>2]|1|0,f[d+4>>2]|0,1)|0;t=r+1+((((i^63)*9|0)+73|0)>>>6)|0}if(!(s&64)){l=t;m=a+12|0;f[m>>2]=l;return l|0}s=a+80|0;i=iJc(f[s>>2]|1|0,f[s+4>>2]|0,1)|0;l=t+1+((((i^63)*9|0)+73|0)>>>6)|0;m=a+12|0;f[m>>2]=l;return l|0}function Ckb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+8>>2]|0;if(c&32|0){d=a+72|0;NTb(1,f[d>>2]|0,f[d+4>>2]|0,b)}if(c&1|0)$Tb(2,f[a+48>>2]|0,b);if(c&2|0)$Tb(3,f[a+52>>2]|0,b);if(c&4|0)$Tb(4,f[a+56>>2]|0,b);if(c&64|0){d=a+80|0;NTb(5,f[d>>2]|0,f[d+4>>2]|0,b)}if(c&8|0)$Tb(6,f[a+60>>2]|0,b);if(c&16|0)eUb(7,f[a+64>>2]|0,b);c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(8,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+36>>2]|0;if(c|0){e=a+44|0;d=0;do{eUb(14,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Dkb(a){a=a|0;return f[a+12>>2]|0}function Ekb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=f[a+8>>2]|0;if(!(e&32))g=d;else{h=a+72|0;i=f[h>>2]|0;j=f[h+4>>2]|0;b[d>>0]=8;h=d+1|0;d=i&255;if(j>>>0>0|(j|0)==0&i>>>0>127){k=h;l=d;m=i;i=j;while(1){b[k>>0]=l|-128;j=m;m=aJc(m|0,i|0,7)|0;n=k+1|0;o=m&255;if(!(i>>>0>0|(i|0)==0&j>>>0>16383)){p=n;q=o;break}else{k=n;l=o;i=J}}}else{p=h;q=d}b[p>>0]=q;g=p+1|0}if(!(e&1))r=g;else{p=f[a+48>>2]|0;b[g>>0]=18;r=dSb(p,g+1|0)|0}if(!(e&2))s=r;else{g=f[a+52>>2]|0;b[r>>0]=26;s=dSb(g,r+1|0)|0}if(!(e&4))t=s;else{r=f[a+56>>2]|0;b[s>>0]=34;t=dSb(r,s+1|0)|0}if(!(e&64))u=t;else{s=a+80|0;r=f[s>>2]|0;g=f[s+4>>2]|0;b[t>>0]=40;s=t+1|0;t=r&255;if(g>>>0>0|(g|0)==0&r>>>0>127){p=s;q=t;d=r;r=g;while(1){b[p>>0]=q|-128;g=d;d=aJc(d|0,r|0,7)|0;h=p+1|0;i=d&255;if(!(r>>>0>0|(r|0)==0&g>>>0>16383)){v=h;w=i;break}else{p=h;q=i;r=J}}}else{v=s;w=t}b[v>>0]=w;u=v+1|0}if(!(e&8))x=u;else{v=f[a+60>>2]|0;b[u>>0]=50;x=dSb(v,u+1|0)|0}if(!(e&16))y=x;else{e=f[a+64>>2]|0;b[x>>0]=58;u=x+1|0;x=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(x>>>0>127){v=x;w=u;while(1){b[w>>0]=v|128;t=v>>>7;s=w+1|0;if(v>>>0>16383){v=t;w=s}else{z=s;A=t;break}}}else{z=u;A=x}b[z>>0]=A;y=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,z+1|0)|0}z=f[a+20>>2]|0;if(!z)B=y;else{e=a+28|0;A=0;x=y;while(1){y=f[(f[e>>2]|0)+4+(A<<2)>>2]|0;b[x>>0]=66;u=x+1|0;w=_i[f[(f[y>>2]|0)+60>>2]&1023](y)|0;if(w>>>0>127){v=w;t=u;while(1){b[t>>0]=v|128;s=v>>>7;r=t+1|0;if(v>>>0>16383){v=s;t=r}else{C=r;D=s;break}}}else{C=u;D=w}b[C>>0]=D;t=hj[f[(f[y>>2]|0)+64>>2]&511](y,c,C+1|0)|0;A=A+1|0;if((A|0)==(z|0)){B=t;break}else x=t}}x=f[a+36>>2]|0;if(!x)E=B;else{z=a+44|0;A=0;C=B;while(1){B=f[(f[z>>2]|0)+4+(A<<2)>>2]|0;b[C>>0]=114;D=C+1|0;e=_i[f[(f[B>>2]|0)+60>>2]&1023](B)|0;if(e>>>0>127){t=e;v=D;while(1){b[v>>0]=t|128;s=t>>>7;r=v+1|0;if(t>>>0>16383){t=s;v=r}else{F=r;G=s;break}}}else{F=D;G=e}b[F>>0]=G;v=hj[f[(f[B>>2]|0)+64>>2]&511](B,c,F+1|0)|0;A=A+1|0;if((A|0)==(x|0)){E=v;break}else C=v}}C=f[a+4>>2]|0;if(!(C&1)){H=E;return H|0}H=Hjc(C&-2,E)|0;return H|0}function Fkb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Gkb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16232,0)|0;if(!c){Ehc(b,a);return}else{Jkb(a,c);return}}function Hkb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Ikb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526488;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Jkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}Kkb(a+16|0,b+16|0);Lkb(a+32|0,b+32|0);d=f[b+8>>2]|0;if(!(d&127))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+48|0,e=f[b+48>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+52|0,c=f[b+52>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==527320){GLa(e,c);break}else{iEc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+56|0,g=f[b+56>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==527320){GLa(c,g);break}else{iEc(e,g)|0;break}while(0);do if(d&8|0?(g=a+8|0,f[g>>2]=f[g>>2]|8,g=a+60|0,e=f[b+60>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(d&16|0){e=a+8|0;f[e>>2]=f[e>>2]|16;e=a+64|0;c=f[e>>2]|0;if(!c){g=VDc(104)|0;Mkb(g);f[e>>2]=g;h=g}else h=c;c=f[b+64>>2]|0;Nkb(h,c|0?c:526e3)}if(d&32|0){c=b+72|0;h=f[c+4>>2]|0;g=a+72|0;f[g>>2]=f[c>>2];f[g+4>>2]=h}if(d&64|0){h=b+80|0;b=f[h+4>>2]|0;g=a+80|0;f[g>>2]=f[h>>2];f[g+4>>2]=b}b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Kkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{gmb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(32)|0;Xhb(l);gmb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16104,32);l=NQb(i,32,1761)|0;Xhb(l);gmb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Lkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{emb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(24)|0;skb(l);emb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16216,24);l=NQb(i,24,1762)|0;skb(l);emb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Mkb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=97876;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==526e3;g=a+16|0;h=g+80|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220439]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=99;b[d+8>>0]=0;DTb(881756,d);ZSb(d)}f[a+12>>2]=0;f[a+96>>2]=527320;f[a+100>>2]=527320;u=c;return}function Nkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}Okb(a+16|0,b+16|0);Pkb(a+32|0,b+32|0);Qkb(a+48|0,b+48|0);Qkb(a+64|0,b+64|0);Qkb(a+80|0,b+80|0);d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+96|0,e=f[b+96>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+100|0;a=f[b+100>>2]|0;b=f[d>>2]|0;if((b|0)==(a|0))return;if((b|0)==527320){GLa(d,a);return}else{iEc(b,a)|0;return}}function Okb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{mlb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(80)|0;llb(l);mlb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16264,80);l=NQb(i,80,1763)|0;llb(l);mlb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Pkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{jlb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(144)|0;$jb(l);jlb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16184,144);l=NQb(i,144,1764)|0;$jb(l);jlb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Qkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Skb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(28)|0;Rkb(l);Skb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16248,32);l=NQb(i,32,1765)|0;Rkb(l);Skb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Rkb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97660;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=525776?(f[220440]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=100;b[d+8>>0]=0;DTb(881760,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=0;u=c;return}function Skb(a,b){a=a|0;b=b|0;Ukb(b,a);return}function Tkb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function Ukb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+20|0,c=f[b+20>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==527320){GLa(e,c);break}else{iEc(g,c)|0;break}while(0);if(!(d&4))return;d=a+8|0;f[d>>2]=f[d>>2]|4;d=a+24|0;a=f[d>>2]|0;if(!a){c=VDc(28)|0;pjb(c);f[d>>2]=c;h=c}else h=a;a=f[b+24>>2]|0;mib(h,a|0?a:526392);return}function Vkb(a){a=a|0;var c=0,d=0;f[a>>2]=97660;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=525776?(c=f[a+24>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function Wkb(a){a=a|0;Vkb(a);YDc(a);return}function Xkb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Ykb(a,b){a=a|0;b=b|0;a=VDc(28)|0;Rkb(a);if(!b)return a|0;ilb(b,a);return a|0}function Zkb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&7|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&4|0){d=f[a+24>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function _kb(a){a=a|0;return 1}function $kb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+24|0;k=e+4|0;l=a+20|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[i>>2]|0;if((o|0)==527320){GLa(i,527320);t=f[i>>2]|0}else t=o;if(fUb(c,t)|0)continue a;else{v=0;q=31;break a}break}case 2:{if((p&255|0)!=18){s=p;break b}f[h>>2]=f[h>>2]|4;o=f[j>>2]|0;if(!o){a=VDc(28)|0;pjb(a);f[j>>2]=a;w=a}else w=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;x=a&255}else{a=VRb(c)|0;if((a|0)>-1)x=a;else{v=0;q=31;break a}}GRb(e,c,x);if((f[k>>2]|0)<0){q=20;break a}if(!(Mi[f[(f[w>>2]|0)+44>>2]&1023](w,c)|0)){q=20;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{v=0;q=31;break a}break}case 3:{if((p&255|0)!=26){s=p;break b}f[h>>2]=f[h>>2]|2;a=f[l>>2]|0;if((a|0)==527320){GLa(l,527320);y=f[l>>2]|0}else y=a;if(fUb(c,y)|0)continue a;else{v=0;q=31;break a}break}default:{s=p;break b}}}while(0);if(!s){v=1;q=31;break}a=f[m>>2]|0;if(!(a&1))z=mNa(m)|0;else z=a&-2;if(!(Djc(c,s,z)|0)){v=0;q=31;break}}if((q|0)==20){v=0;u=d;return v|0}else if((q|0)==31){u=d;return v|0}return 0}function alb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&7)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else{k=f[a+20>>2]|0;d=b[k+11>>0]|0;j=d<<24>>24<0?f[k+4>>2]|0:d&255;l=h+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4)){e=l;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+24>>2]|0;j=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;e=l+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function blb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&4|0)eUb(2,f[a+24>>2]|0,b);if(c&2|0)$Tb(3,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function clb(a){a=a|0;return f[a+12>>2]|0}function dlb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}if(!(e&4))i=g;else{d=f[a+24>>2]|0;b[g>>0]=18;h=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(g>>>0>127){j=g;k=h;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=h;o=g}b[n>>0]=o;i=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,n+1|0)|0}if(!(e&2))p=i;else{e=f[a+20>>2]|0;b[i>>0]=26;p=dSb(e,i+1|0)|0}i=f[a+4>>2]|0;if(!(i&1)){q=p;return q|0}q=Hjc(i&-2,p)|0;return q|0}function elb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function flb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16248,0)|0;if(!c){Ehc(b,a);return}else{Ukb(a,c);return}}function glb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function hlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526472;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function ilb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function jlb(a,b){a=a|0;b=b|0;Gjb(b,a);return}function klb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function llb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=97768;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==525808;g=a+16|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220439]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=99;b[d+8>>0]=0;DTb(881756,d);ZSb(d)}f[a+12>>2]=0;f[a+64>>2]=527320;f[a+68>>2]=527320;f[a+72>>2]=527320;f[a+76>>2]=527320;u=c;return}function mlb(a,b){a=a|0;b=b|0;olb(b,a);return}function nlb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function olb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}yNa(a+16|0,b+16|0);yNa(a+32|0,b+32|0);plb(a+48|0,b+48|0);d=f[b+8>>2]|0;if(!(d&15))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+64|0,e=f[b+64>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+68|0,c=f[b+68>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==527320){GLa(e,c);break}else{iEc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+72|0,g=f[b+72>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==527320){GLa(c,g);break}else{iEc(e,g)|0;break}while(0);if(!(d&8))return;d=a+8|0;f[d>>2]=f[d>>2]|8;d=a+76|0;a=f[b+76>>2]|0;b=f[d>>2]|0;if((b|0)==(a|0))return;if((b|0)==527320){GLa(d,a);return}else{iEc(b,a)|0;return}}function plb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{rlb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(128)|0;qlb(l);rlb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16088,128);l=NQb(i,128,1766)|0;qlb(l);rlb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function qlb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=96372;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==525648;g=a+16|0;h=g+72|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220439]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=99;b[d+8>>0]=0;DTb(881756,d);ZSb(d)}f[a+12>>2]=0;f[a+88>>2]=527320;f[a+92>>2]=527320;f[a+96>>2]=527320;f[a+100>>2]=527320;d=a+104|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function rlb(a,b){a=a|0;b=b|0;tlb(b,a);return}function slb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function tlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){SHa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+28|0;d=b+28|0;e=f[d>>2]|0;if(e|0){UHa(g,(f[g>>2]|0)+e|0);dJc((f[a+36>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+36>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}yNa(a+40|0,b+40|0);Pkb(a+56|0,b+56|0);ulb(a+72|0,b+72|0);d=f[b+8>>2]|0;if(d&255|0){do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+88|0,e=f[b+88>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+92|0,c=f[b+92>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==527320){GLa(e,c);break}else{iEc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+96|0,g=f[b+96>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==527320){GLa(c,g);break}else{iEc(e,g)|0;break}while(0);do if(d&8|0?(g=a+8|0,f[g>>2]=f[g>>2]|8,g=a+100|0,e=f[b+100>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==527320){GLa(g,e);break}else{iEc(c,e)|0;break}while(0);if(d&16|0){e=a+8|0;f[e>>2]=f[e>>2]|16;e=a+104|0;c=f[e>>2]|0;if(!c){g=VDc(144)|0;$jb(g);f[e>>2]=g;h=g}else h=c;c=f[b+104>>2]|0;Gjb(h,c|0?c:526136)}if(d&32|0){c=a+8|0;f[c>>2]=f[c>>2]|32;c=a+108|0;h=f[c>>2]|0;if(!h){g=VDc(104)|0;Mkb(g);f[c>>2]=g;i=g}else i=h;h=f[b+108>>2]|0;Nkb(i,h|0?h:526e3)}if(d&64|0){h=b+112|0;i=f[h+4>>2]|0;g=a+112|0;f[g>>2]=f[h>>2];f[g+4>>2]=i}if(d&128|0)f[a+120>>2]=f[b+120>>2];i=a+8|0;f[i>>2]=f[i>>2]|d}if(!(d&256))return;d=f[b+124>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|256;f[a+124>>2]=d;return}function ulb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{vlb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(104)|0;Mkb(l);vlb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,16280,104);l=NQb(i,104,1758)|0;Mkb(l);vlb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function vlb(a,b){a=a|0;b=b|0;Nkb(b,a);return}function wlb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function xlb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=97768;Nlb(a);c=a+60|0;d=f[c>>2]|0;if(d|0?(f[a+48>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+44|0;i=f[c>>2]|0;if(i|0?(f[a+32>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);YDc(g)}e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+28|0;j=f[c>>2]|0;if(j|0?(f[a+16>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(k);f[c>>2]=0;return}function ylb(a){a=a|0;xlb(a);YDc(a);return}function zlb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Alb(a,b){a=a|0;b=b|0;a=VDc(80)|0;llb(a);if(!b)return a|0;Mlb(b,a);return a|0}function Blb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&15|0){do if(d&1|0){g=f[a+64>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+68>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+72>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&8|0){e=f[a+76>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Clb(a){a=a|0;return 1}function Dlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+32|0;j=a+8|0;k=a+64|0;l=a+68|0;m=a+48|0;n=a+60|0;o=a+56|0;p=a+52|0;q=e+4|0;r=a+72|0;s=a+76|0;t=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){v=b[a>>0]|0;w=v&255;if(v<<24>>24>0){f[c>>2]=a+1;x=w;y=6}else{z=w;y=5}}else{z=0;y=5}if((y|0)==5){y=0;w=WRb(c,z)|0;if((w+-1|0)>>>0<127){x=w;y=6}else A=w}b:do if((y|0)==6){y=0;switch(x>>>3&536870911|0){case 1:{if((x&255|0)!=10){A=x;break b}if(fUb(c,JLa(h)|0)|0)continue a;else{B=0;y=53;break a}break}case 2:{if((x&255|0)!=18){A=x;break b}if(fUb(c,JLa(i)|0)|0)continue a;else{B=0;y=53;break a}break}case 3:{if((x&255|0)!=26){A=x;break b}f[j>>2]=f[j>>2]|1;w=f[k>>2]|0;if((w|0)==527320){GLa(k,527320);C=f[k>>2]|0}else C=w;if(fUb(c,C)|0)continue a;else{B=0;y=53;break a}break}case 4:{if((x&255|0)!=34){A=x;break b}f[j>>2]=f[j>>2]|2;w=f[l>>2]|0;if((w|0)==527320){GLa(l,527320);D=f[l>>2]|0}else D=w;if(fUb(c,D)|0)continue a;else{B=0;y=53;break a}break}case 5:{if((x&255|0)!=42){A=x;break b}w=f[n>>2]|0;do if(w){a=f[p>>2]|0;v=f[w>>2]|0;if((a|0)>=(v|0))if((v|0)==(f[o>>2]|0)){E=v;y=25;break}else{F=v;G=w;y=26;break}else{f[p>>2]=a+1;H=f[w+4+(a<<2)>>2]|0;break}}else{E=f[o>>2]|0;y=25}while(0);if((y|0)==25){y=0;USb(m,E+1|0);w=f[n>>2]|0;F=f[w>>2]|0;G=w;y=26}if((y|0)==26){y=0;f[G>>2]=F+1;w=f[m>>2]|0;if(!w){a=VDc(128)|0;qlb(a);I=a}else{if(f[w+64>>2]|0)OQb(w,16088,128);a=NQb(w,128,1766)|0;qlb(a);I=a}a=f[n>>2]|0;w=f[p>>2]|0;f[p>>2]=w+1;f[a+4+(w<<2)>>2]=I;H=I}w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(a=b[w>>0]|0,a<<24>>24>-1):0){f[c>>2]=w+1;J=a&255}else{a=VRb(c)|0;if((a|0)>-1)J=a;else{B=0;y=53;break a}}GRb(e,c,J);if((f[q>>2]|0)<0){y=38;break a}if(!(Mi[f[(f[H>>2]|0)+44>>2]&1023](H,c)|0)){y=38;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;y=53;break a}break}case 6:{if((x&255|0)!=50){A=x;break b}f[j>>2]=f[j>>2]|4;a=f[r>>2]|0;if((a|0)==527320){GLa(r,527320);K=f[r>>2]|0}else K=a;if(fUb(c,K)|0)continue a;else{B=0;y=53;break a}break}case 7:{if((x&255|0)!=58){A=x;break b}f[j>>2]=f[j>>2]|8;a=f[s>>2]|0;if((a|0)==527320){GLa(s,527320);L=f[s>>2]|0}else L=a;if(fUb(c,L)|0)continue a;else{B=0;y=53;break a}break}default:{A=x;break b}}}while(0);if(!A){B=1;y=53;break}a=f[t>>2]|0;if(!(a&1))M=mNa(t)|0;else M=a&-2;if(!(Djc(c,A,M)|0)){B=0;y=53;break}}if((y|0)==38){B=0;u=d;return B|0}else if((y|0)==53){u=d;return B|0}return 0}function Elb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if((e|0)>0){l=f[a+44>>2]|0;c=0;g=h;while(1){d=f[l+4+(c<<2)>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+g+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=j;break}else g=j}}else m=h;h=f[a+52>>2]|0;g=h+m|0;if(!h)n=g;else{m=a+60|0;e=0;c=g;while(1){g=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;l=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;g=l+c+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(h|0)){n=g;break}else c=g}}c=f[a+8>>2]|0;if(!(c&15)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(c&1))q=n;else{h=f[a+64>>2]|0;e=b[h+11>>0]|0;m=e<<24>>24<0?f[h+4>>2]|0:e&255;q=n+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))r=q;else{m=f[a+68>>2]|0;n=b[m+11>>0]|0;e=n<<24>>24<0?f[m+4>>2]|0:n&255;r=q+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))s=r;else{e=f[a+72>>2]|0;q=b[e+11>>0]|0;n=q<<24>>24<0?f[e+4>>2]|0:q&255;s=r+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8)){o=s;p=a+12|0;f[p>>2]=o;return o|0}c=f[a+76>>2]|0;n=b[c+11>>0]|0;r=n<<24>>24<0?f[c+4>>2]|0:n&255;o=s+1+r+((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=a+12|0;f[p>>2]=o;return o|0}function Flb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+20>>2]|0;if((c|0)>0){d=a+28|0;e=0;do{_Tb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+36>>2]|0;if((c|0)>0){e=a+44|0;d=0;do{_Tb(2,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+8>>2]|0;if(c&1|0)$Tb(3,f[a+64>>2]|0,b);if(c&2|0)$Tb(4,f[a+68>>2]|0,b);d=f[a+52>>2]|0;if(d|0){e=a+60|0;g=0;do{eUb(5,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&4|0)$Tb(6,f[a+72>>2]|0,b);if(c&8|0)$Tb(7,f[a+76>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Glb(a){a=a|0;return f[a+12>>2]|0}function Hlb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[a+20>>2]|0;if((e|0)>0){g=a+28|0;h=0;i=d;while(1){j=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;k=dSb(j,i+1|0)|0;h=h+1|0;if((h|0)==(e|0)){l=k;break}else i=k}}else l=d;d=f[a+36>>2]|0;if((d|0)>0){i=a+44|0;e=0;h=l;while(1){g=f[(f[i>>2]|0)+4+(e<<2)>>2]|0;b[h>>0]=18;k=dSb(g,h+1|0)|0;e=e+1|0;if((e|0)==(d|0)){m=k;break}else h=k}}else m=l;l=f[a+8>>2]|0;if(!(l&1))n=m;else{h=f[a+64>>2]|0;b[m>>0]=26;n=dSb(h,m+1|0)|0}if(!(l&2))o=n;else{m=f[a+68>>2]|0;b[n>>0]=34;o=dSb(m,n+1|0)|0}n=f[a+52>>2]|0;if(!n)p=o;else{m=a+60|0;h=0;d=o;while(1){o=f[(f[m>>2]|0)+4+(h<<2)>>2]|0;b[d>>0]=42;e=d+1|0;i=_i[f[(f[o>>2]|0)+60>>2]&1023](o)|0;if(i>>>0>127){k=i;g=e;while(1){b[g>>0]=k|128;j=k>>>7;q=g+1|0;if(k>>>0>16383){k=j;g=q}else{r=q;s=j;break}}}else{r=e;s=i}b[r>>0]=s;g=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,r+1|0)|0;h=h+1|0;if((h|0)==(n|0)){p=g;break}else d=g}}if(!(l&4))t=p;else{d=f[a+72>>2]|0;b[p>>0]=50;t=dSb(d,p+1|0)|0}if(!(l&8))u=t;else{l=f[a+76>>2]|0;b[t>>0]=58;u=dSb(l,t+1|0)|0}t=f[a+4>>2]|0;if(!(t&1)){v=u;return v|0}v=Hjc(t&-2,u)|0;return v|0}function Ilb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Jlb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16264,0)|0;if(!c){Ehc(b,a);return}else{olb(a,c);return}}function Klb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Llb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526480;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Mlb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Nlb(a){a=a|0;var c=0;c=f[a+64>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+68>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+72>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+76>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function Olb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[a>>2]=97876;c=f[a+96>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+100>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+92|0;d=f[c>>2]|0;if(d|0?(f[a+80>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+76|0;i=f[c>>2]|0;if(i|0?(f[a+64>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+60|0;j=f[c>>2]|0;if(j|0?(f[a+48>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+44|0;k=f[c>>2]|0;if(k|0?(f[a+32>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;YDc(l)}f[c>>2]=0;c=a+28|0;l=f[c>>2]|0;if(l|0?(f[a+16>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0)Yi[f[(f[i>>2]|0)+4>>2]&2047](i);j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;YDc(m)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}m=a&-2;a=m;if((m|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(m);f[c>>2]=0;return}function Plb(a){a=a|0;Olb(a);YDc(a);return}function Qlb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Rlb(a,b){a=a|0;b=b|0;a=VDc(104)|0;Mkb(a);if(!b)return a|0;dmb(b,a);return a|0}function Slb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+68|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+76>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+84|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+92>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0){g=f[a+96>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&2|0){e=f[a+100>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Tlb(a){a=a|0;return 1}function Ulb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+8|0;n=a+96|0;o=a+32|0;p=e+4|0;q=a+100|0;r=a+48|0;s=e+4|0;t=a+64|0;v=e+4|0;w=a+80|0;x=e+4|0;y=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){z=b[a>>0]|0;A=z&255;if(z<<24>>24>0){f[c>>2]=a+1;B=A;C=6}else{D=A;C=5}}else{D=0;C=5}if((C|0)==5){C=0;A=WRb(c,D)|0;if((A+-1|0)>>>0<127){B=A;C=6}else E=A}b:do if((C|0)==6){C=0;switch(B>>>3&536870911|0){case 1:{if((B&255|0)!=10){E=B;break b}A=f[i>>2]|0;do if(A){a=f[k>>2]|0;z=f[A>>2]|0;if((a|0)>=(z|0))if((z|0)==(f[j>>2]|0)){F=z;C=13;break}else{G=z;H=A;C=14;break}else{f[k>>2]=a+1;I=f[A+4+(a<<2)>>2]|0;break}}else{F=f[j>>2]|0;C=13}while(0);if((C|0)==13){C=0;USb(h,F+1|0);A=f[i>>2]|0;G=f[A>>2]|0;H=A;C=14}if((C|0)==14){C=0;f[H>>2]=G+1;A=f[h>>2]|0;if(!A){a=VDc(80)|0;llb(a);J=a}else{if(f[A+64>>2]|0)OQb(A,16264,80);a=NQb(A,80,1763)|0;llb(a);J=a}a=f[i>>2]|0;A=f[k>>2]|0;f[k>>2]=A+1;f[a+4+(A<<2)>>2]=J;I=J}A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){f[c>>2]=A+1;K=a&255}else{a=VRb(c)|0;if((a|0)>-1)K=a;else{L=0;C=77;break a}}GRb(e,c,K);if((f[l>>2]|0)<0){C=26;break a}if(!(Mi[f[(f[I>>2]|0)+44>>2]&1023](I,c)|0)){C=26;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}case 2:{if((B&255|0)!=18){E=B;break b}f[m>>2]=f[m>>2]|1;a=f[n>>2]|0;if((a|0)==527320){GLa(n,527320);M=f[n>>2]|0}else M=a;if(fUb(c,M)|0)continue a;else{L=0;C=77;break a}break}case 5:{if((B&255|0)!=42){E=B;break b}a=bmb(o)|0;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(z=b[A>>0]|0,z<<24>>24>-1):0){f[c>>2]=A+1;N=z&255}else{z=VRb(c)|0;if((z|0)>-1)N=z;else{L=0;C=77;break a}}GRb(e,c,N);if((f[p>>2]|0)<0){C=39;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){C=39;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}case 10:{if((B&255|0)!=82){E=B;break b}f[m>>2]=f[m>>2]|2;a=f[q>>2]|0;if((a|0)==527320){GLa(q,527320);O=f[q>>2]|0}else O=a;if(fUb(c,O)|0)continue a;else{L=0;C=77;break a}break}case 11:{if((B&255|0)!=90){E=B;break b}a=cmb(r)|0;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(A=b[z>>0]|0,A<<24>>24>-1):0){f[c>>2]=z+1;P=A&255}else{A=VRb(c)|0;if((A|0)>-1)P=A;else{L=0;C=77;break a}}GRb(e,c,P);if((f[s>>2]|0)<0){C=52;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){C=52;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}case 12:{if((B&255|0)!=98){E=B;break b}a=cmb(t)|0;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(z=b[A>>0]|0,z<<24>>24>-1):0){f[c>>2]=A+1;Q=z&255}else{z=VRb(c)|0;if((z|0)>-1)Q=z;else{L=0;C=77;break a}}GRb(e,c,Q);if((f[v>>2]|0)<0){C=61;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){C=61;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}case 13:{if((B&255|0)!=106){E=B;break b}a=cmb(w)|0;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(A=b[z>>0]|0,A<<24>>24>-1):0){f[c>>2]=z+1;R=A&255}else{A=VRb(c)|0;if((A|0)>-1)R=A;else{L=0;C=77;break a}}GRb(e,c,R);if((f[x>>2]|0)<0){C=70;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){C=70;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}default:{E=B;break b}}}while(0);if(!E){L=1;C=77;break}a=f[y>>2]|0;if(!(a&1))S=mNa(y)|0;else S=a&-2;if(!(Djc(c,E,S)|0)){L=0;C=77;break}}if((C|0)==26){L=0;u=d;return L|0}else if((C|0)==39){L=0;u=d;return L|0}else if((C|0)==52){L=0;u=d;return L|0}else if((C|0)==61){L=0;u=d;return L|0}else if((C|0)==70){L=0;u=d;return L|0}else if((C|0)==77){u=d;return L|0}return 0}function Vlb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+44|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=f[a+52>>2]|0;i=d+k|0;if(!d)l=i;else{k=a+60|0;h=0;g=i;while(1){i=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;c=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=c+g+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=i;break}else g=i}}g=f[a+68>>2]|0;d=g+l|0;if(!g)m=d;else{l=a+76|0;h=0;k=d;while(1){d=f[(f[l>>2]|0)+4+(h<<2)>>2]|0;i=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=i+k+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(g|0)){m=d;break}else k=d}}k=f[a+84>>2]|0;g=k+m|0;if(!k)n=g;else{m=a+92|0;h=0;l=g;while(1){g=f[(f[m>>2]|0)+4+(h<<2)>>2]|0;d=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;g=d+l+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(k|0)){n=g;break}else l=g}}l=f[a+8>>2]|0;if(!(l&3)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(l&1))q=n;else{k=f[a+96>>2]|0;h=b[k+11>>0]|0;m=h<<24>>24<0?f[k+4>>2]|0:h&255;q=n+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&2)){o=q;p=a+12|0;f[p>>2]=o;return o|0}l=f[a+100>>2]|0;m=b[l+11>>0]|0;n=m<<24>>24<0?f[l+4>>2]|0:m&255;o=q+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=a+12|0;f[p>>2]=o;return o|0}function Wlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+8>>2]|0;if(c&1|0)$Tb(2,f[a+96>>2]|0,b);e=f[a+36>>2]|0;if(e|0){d=a+44|0;g=0;do{eUb(5,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(e|0))}if(c&2|0)$Tb(10,f[a+100>>2]|0,b);c=f[a+52>>2]|0;if(c|0){e=a+60|0;g=0;do{eUb(11,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+68>>2]|0;if(c|0){g=a+76|0;e=0;do{eUb(12,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+84>>2]|0;if(c|0){e=a+92|0;g=0;do{eUb(13,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function Xlb(a){a=a|0;return f[a+12>>2]|0}function Ylb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=d;d=0;while(1){j=f[(f[h>>2]|0)+4+(d<<2)>>2]|0;b[i>>0]=10;k=i+1|0;l=_i[f[(f[j>>2]|0)+60>>2]&1023](j)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[j>>2]|0)+64>>2]&511](j,c,q+1|0)|0;d=d+1|0;if((d|0)==(e|0)){g=n;break}else i=n}}i=f[a+8>>2]|0;if(!(i&1))s=g;else{e=f[a+96>>2]|0;b[g>>0]=18;s=dSb(e,g+1|0)|0}g=f[a+36>>2]|0;if(!g)t=s;else{e=a+44|0;d=0;q=s;while(1){s=f[(f[e>>2]|0)+4+(d<<2)>>2]|0;b[q>>0]=42;r=q+1|0;h=_i[f[(f[s>>2]|0)+60>>2]&1023](s)|0;if(h>>>0>127){n=h;m=r;while(1){b[m>>0]=n|128;o=n>>>7;p=m+1|0;if(n>>>0>16383){n=o;m=p}else{u=p;v=o;break}}}else{u=r;v=h}b[u>>0]=v;m=hj[f[(f[s>>2]|0)+64>>2]&511](s,c,u+1|0)|0;d=d+1|0;if((d|0)==(g|0)){t=m;break}else q=m}}if(!(i&2))w=t;else{i=f[a+100>>2]|0;b[t>>0]=82;w=dSb(i,t+1|0)|0}t=f[a+52>>2]|0;if(!t)x=w;else{i=a+60|0;q=0;g=w;while(1){w=f[(f[i>>2]|0)+4+(q<<2)>>2]|0;b[g>>0]=90;d=g+1|0;u=_i[f[(f[w>>2]|0)+60>>2]&1023](w)|0;if(u>>>0>127){v=u;e=d;while(1){b[e>>0]=v|128;m=v>>>7;n=e+1|0;if(v>>>0>16383){v=m;e=n}else{y=n;z=m;break}}}else{y=d;z=u}b[y>>0]=z;e=hj[f[(f[w>>2]|0)+64>>2]&511](w,c,y+1|0)|0;q=q+1|0;if((q|0)==(t|0)){x=e;break}else g=e}}g=f[a+68>>2]|0;if(!g)A=x;else{t=a+76|0;q=0;y=x;while(1){x=f[(f[t>>2]|0)+4+(q<<2)>>2]|0;b[y>>0]=98;z=y+1|0;i=_i[f[(f[x>>2]|0)+60>>2]&1023](x)|0;if(i>>>0>127){e=i;v=z;while(1){b[v>>0]=e|128;s=e>>>7;h=v+1|0;if(e>>>0>16383){e=s;v=h}else{B=h;C=s;break}}}else{B=z;C=i}b[B>>0]=C;v=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,B+1|0)|0;q=q+1|0;if((q|0)==(g|0)){A=v;break}else y=v}}y=f[a+84>>2]|0;if(!y)D=A;else{g=a+92|0;q=0;B=A;while(1){A=f[(f[g>>2]|0)+4+(q<<2)>>2]|0;b[B>>0]=106;C=B+1|0;t=_i[f[(f[A>>2]|0)+60>>2]&1023](A)|0;if(t>>>0>127){v=t;e=C;while(1){b[e>>0]=v|128;w=v>>>7;u=e+1|0;if(v>>>0>16383){v=w;e=u}else{E=u;F=w;break}}}else{E=C;F=t}b[E>>0]=F;e=hj[f[(f[A>>2]|0)+64>>2]&511](A,c,E+1|0)|0;q=q+1|0;if((q|0)==(y|0)){D=e;break}else B=e}}B=f[a+4>>2]|0;if(!(B&1)){G=D;return G|0}G=Hjc(B&-2,D)|0;return G|0}function Zlb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function _lb(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,16280,0)|0;if(!c){Ehc(b,a);return}else{Nkb(a,c);return}}function $lb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function amb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220437]|0)!=2){f[d>>2]=161028;f[d+4>>2]=97;b[d+8>>0]=0;DTb(881748,d);ZSb(d)}d=526504;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function bmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(144)|0;$jb(a);o=a}else{if(f[l+64>>2]|0)OQb(l,16184,144);a=NQb(l,144,1764)|0;$jb(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function cmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(28)|0;Rkb(a);o=a}else{if(f[l+64>>2]|0)OQb(l,16248,32);a=NQb(l,32,1765)|0;Rkb(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function dmb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function emb(a,b){a=a|0;b=b|0;rkb(b,a);return}function fmb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function gmb(a,b){a=a|0;b=b|0;Whb(b,a);return}function hmb(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function imb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=97552;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;if((a|0)!=525888?(f[220441]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=101;b[d+8>>0]=0;DTb(881764,d);ZSb(d)}f[a+12>>2]=0;f[a+48>>2]=527320;f[a+52>>2]=527320;f[a+56>>2]=527320;f[a+60>>2]=527320;d=a+64|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function jmb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function kmb(a){a=a|0;var c=0;c=f[a+48>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+52>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+56>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+60>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==525888)return;c=f[a+64>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function lmb(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function mmb(a){a=a|0;var c=0;c=f[a+88>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+92>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+96>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+100>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==525648)return;c=f[a+104>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+108>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function nmb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220438]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=98;b[c+8>>0]=0;DTb(881752,c);ZSb(c);u=a;return}function omb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[220437]|0)==2){d=f[220435]|0;u=a;return d|0}f[c>>2]=161028;f[c+4>>2]=97;b[c+8>>0]=0;DTb(881748,c);ZSb(c);d=f[220435]|0;u=a;return d|0}function pmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=96372;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];e=a+12|0;g=a+16|0;h=b+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;e=f[h>>2]|0;if(e|0){SHa(g,e);dJc((f[a+24>>2]|0)+4|0,(f[b+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[g>>2]=f[h>>2]}h=a+28|0;f[h>>2]=0;f[a+32>>2]=0;g=a+36|0;f[g>>2]=0;e=b+28|0;i=f[e>>2]|0;if(i|0){UHa(h,i);dJc((f[g>>2]|0)+8|0,(f[b+36>>2]|0)+8|0,f[e>>2]<<3|0)|0;f[h>>2]=f[e>>2]}e=a+40|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;yNa(e,b+40|0);e=a+56|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;Pkb(e,b+56|0);e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;ulb(e,b+72|0);e=f[b+4>>2]|0;if(e&1|0){h=f[c>>2]|0;if(!(h&1))j=mNa(c)|0;else j=h&-2;ojc(j,e&-2)}e=a+88|0;f[e>>2]=527320;j=f[d>>2]|0;if((j&1|0)!=0?(h=f[b+88>>2]|0,(h|0)!=527320):0){GLa(e,h);k=f[d>>2]|0}else k=j;j=a+92|0;f[j>>2]=527320;if((k&2|0)!=0?(h=f[b+92>>2]|0,(h|0)!=527320):0){GLa(j,h);l=f[d>>2]|0}else l=k;k=a+96|0;f[k>>2]=527320;if((l&4|0)!=0?(h=f[b+96>>2]|0,(h|0)!=527320):0){GLa(k,h);m=f[d>>2]|0}else m=l;l=a+100|0;f[l>>2]=527320;if((m&8|0)!=0?(h=f[b+100>>2]|0,(h|0)!=527320):0){GLa(l,h);n=f[d>>2]|0}else n=m;if(!(n&16)){o=0;p=n}else{n=VDc(144)|0;qmb(n,f[b+104>>2]|0);o=n;p=f[d>>2]|0}f[a+104>>2]=o;if(!(p&32)){q=0;r=a+108|0;f[r>>2]=q;s=a+112|0;t=b+112|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];f[s+8>>2]=f[t+8>>2];f[s+12>>2]=f[t+12>>2];return}p=VDc(104)|0;rmb(p,f[b+108>>2]|0);q=p;r=a+108|0;f[r>>2]=q;s=a+112|0;t=b+112|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];f[s+8>>2]=f[t+8>>2];f[s+12>>2]=f[t+12>>2];return}function qmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=97228;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];e=a+12|0;g=a+16|0;h=b+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;e=f[h>>2]|0;if(e|0){UHa(g,e);dJc((f[a+24>>2]|0)+8|0,(f[b+24>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[g>>2]=f[h>>2]}h=a+28|0;f[h>>2]=0;f[a+32>>2]=0;g=a+36|0;f[g>>2]=0;e=b+28|0;i=f[e>>2]|0;if(i|0){SHa(h,i);dJc((f[g>>2]|0)+4|0,(f[b+36>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=f[e>>2]}e=a+44|0;f[e>>2]=0;f[a+48>>2]=0;h=a+52|0;f[h>>2]=0;g=b+44|0;i=f[g>>2]|0;if(i|0){KLa(e,i);dJc((f[h>>2]|0)+4|0,(f[b+52>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[e>>2]=f[g>>2]}g=a+60|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;yNa(g,b+60|0);g=a+76|0;f[g>>2]=0;f[a+80>>2]=0;e=a+84|0;f[e>>2]=0;h=b+76|0;i=f[h>>2]|0;if(i|0){UHa(g,i);dJc((f[e>>2]|0)+8|0,(f[b+84>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[g>>2]=f[h>>2]}h=a+92|0;f[h>>2]=0;f[a+96>>2]=0;g=a+100|0;f[g>>2]=0;e=b+92|0;i=f[e>>2]|0;if(i|0){THa(h,i);dJc((f[g>>2]|0)+8|0,(f[b+100>>2]|0)+8|0,f[e>>2]<<3|0)|0;f[h>>2]=f[e>>2]}e=a+108|0;f[e>>2]=0;f[a+112>>2]=0;h=a+116|0;f[h>>2]=0;g=b+108|0;i=f[g>>2]|0;if(i|0){Hjb(e,i);dJc((f[h>>2]|0)+8|0,(f[b+116>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[e>>2]=f[g>>2]}g=f[b+4>>2]|0;if(g&1|0){e=f[c>>2]|0;if(!(e&1))j=mNa(c)|0;else j=e&-2;ojc(j,g&-2)}g=a+124|0;f[g>>2]=527320;j=f[d>>2]|0;if((j&1|0)!=0?(e=f[b+124>>2]|0,(e|0)!=527320):0){GLa(g,e);k=f[d>>2]|0}else k=j;j=a+128|0;f[j>>2]=527320;if((k&2|0)!=0?(e=f[b+128>>2]|0,(e|0)!=527320):0){GLa(j,e);l=f[d>>2]|0}else l=k;k=a+132|0;f[k>>2]=527320;if((l&4|0)!=0?(e=f[b+132>>2]|0,(e|0)!=527320):0){GLa(k,e);m=f[d>>2]|0}else m=l;if(!(m&8)){n=0;o=a+136|0;f[o>>2]=n;p=b+140|0;q=f[p>>2]|0;r=a+140|0;f[r>>2]=q;return}m=VDc(32)|0;smb(m,f[b+136>>2]|0);n=m;o=a+136|0;f[o>>2]=n;p=b+140|0;q=f[p>>2]|0;r=a+140|0;f[r>>2]=q;return}function rmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=97876;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;Okb(a+16|0,b+16|0);e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;Pkb(e,b+32|0);e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;Qkb(e,b+48|0);e=a+64|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;Qkb(e,b+64|0);e=a+80|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;Qkb(e,b+80|0);e=f[b+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}e=a+96|0;f[e>>2]=527320;h=f[d>>2]|0;if((h&1|0)!=0?(g=f[b+96>>2]|0,(g|0)!=527320):0){GLa(e,g);i=f[d>>2]|0}else i=h;h=a+100|0;f[h>>2]=527320;if(!(i&2))return;i=f[b+100>>2]|0;if((i|0)==527320)return;GLa(h,i);return}function smb(a,b){a=a|0;b=b|0;var c=0,d=0;f[a>>2]=97336;c=a+4|0;f[c>>2]=0;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=0;d=f[b+4>>2]|0;if(d&1|0)ojc(mNa(c)|0,d&-2);d=a+16|0;a=b+16|0;f[d>>2]=f[a>>2];f[d+4>>2]=f[a+4>>2];f[d+8>>2]=f[a+8>>2];f[d+12>>2]=f[a+12>>2];return}function tmb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);olb(a,b);return}function umb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);Gjb(a,b);return}function vmb(){return 0}function wmb(a){a=a|0;var c=0,d=0,e=0;a=u;u=u+16|0;c=a;f[c>>2]=0;f[c+4>>2]=0;a=tT(c,15)|0;d=425433;e=a+15|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));z5(-215,c,425449,425466,627)}function xmb(){var a=0,b=0,c=0;a=f[220451]|0;if(!a){b=VDc(4)|0;k6(b);f[220451]=b;c=b}else c=a;f[220450]=c;return}function ymb(){var a=0,b=0;a=f[220451]|0;if(a|0){b=a;return b|0}a=VDc(4)|0;k6(a);f[220451]=a;b=a;return b|0}function zmb(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0;a=u;u=u+16|0;c=a;if((b[526568]|0)==0?MIc(526568)|0:0){b[1152665]=1;be(1767,1152665,x|0)|0}f[c>>2]=0;f[c+4>>2]=0;d=tT(c,5)|0;b[d>>0]=b[425537]|0;b[d+1>>0]=b[425538]|0;b[d+2>>0]=b[425539]|0;b[d+3>>0]=b[425540]|0;b[d+4>>0]=b[425541]|0;MHa(c,1199);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,5)|0;b[d>>0]=b[425543]|0;b[d+1>>0]=b[425544]|0;b[d+2>>0]=b[425545]|0;b[d+3>>0]=b[425546]|0;b[d+4>>0]=b[425547]|0;MHa(c,1200);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,6)|0;b[d>>0]=b[454781]|0;b[d+1>>0]=b[454782]|0;b[d+2>>0]=b[454783]|0;b[d+3>>0]=b[454784]|0;b[d+4>>0]=b[454785]|0;b[d+5>>0]=b[454786]|0;MHa(c,1201);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,7)|0;b[d>>0]=b[426093]|0;b[d+1>>0]=b[426094]|0;b[d+2>>0]=b[426095]|0;b[d+3>>0]=b[426096]|0;b[d+4>>0]=b[426097]|0;b[d+5>>0]=b[426098]|0;b[d+6>>0]=b[426099]|0;MHa(c,1202);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,7)|0;b[d>>0]=b[428347]|0;b[d+1>>0]=b[428348]|0;b[d+2>>0]=b[428349]|0;b[d+3>>0]=b[428350]|0;b[d+4>>0]=b[428351]|0;b[d+5>>0]=b[428352]|0;b[d+6>>0]=b[428353]|0;MHa(c,1203);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,6)|0;b[d>>0]=b[454574]|0;b[d+1>>0]=b[454575]|0;b[d+2>>0]=b[454576]|0;b[d+3>>0]=b[454577]|0;b[d+4>>0]=b[454578]|0;b[d+5>>0]=b[454579]|0;MHa(c,1204);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,6)|0;b[d>>0]=b[425549]|0;b[d+1>>0]=b[425550]|0;b[d+2>>0]=b[425551]|0;b[d+3>>0]=b[425552]|0;b[d+4>>0]=b[425553]|0;b[d+5>>0]=b[425554]|0;MHa(c,1205);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,13)|0;e=425556;g=d+13|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1206);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,11)|0;e=455045;g=d+11|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1207);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,13)|0;e=425570;g=d+13|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1208);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,7)|0;b[h>>0]=b[454888]|0;b[h+1>>0]=b[454889]|0;b[h+2>>0]=b[454890]|0;b[h+3>>0]=b[454891]|0;b[h+4>>0]=b[454892]|0;b[h+5>>0]=b[454893]|0;b[h+6>>0]=b[454894]|0;MHa(c,1209);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,10)|0;e=425584;g=d+10|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1209);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,12)|0;e=425595;g=d+12|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1209);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,3)|0;b[h>>0]=b[425608]|0;b[h+1>>0]=b[425609]|0;b[h+2>>0]=b[425610]|0;MHa(c,1210);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,12)|0;e=425612;g=d+12|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1211);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,7)|0;b[h>>0]=b[454837]|0;b[h+1>>0]=b[454838]|0;b[h+2>>0]=b[454839]|0;b[h+3>>0]=b[454840]|0;b[h+4>>0]=b[454841]|0;b[h+5>>0]=b[454842]|0;b[h+6>>0]=b[454843]|0;MHa(c,1212);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,3)|0;b[h>>0]=b[425625]|0;b[h+1>>0]=b[425626]|0;b[h+2>>0]=b[425627]|0;MHa(c,1213);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,4)|0;b[h>>0]=82;b[h+1>>0]=101;b[h+2>>0]=76;b[h+3>>0]=85;MHa(c,1214);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,5)|0;b[h>>0]=b[425629]|0;b[h+1>>0]=b[425630]|0;b[h+2>>0]=b[425631]|0;b[h+3>>0]=b[425632]|0;b[h+4>>0]=b[425633]|0;MHa(c,1215);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,13)|0;e=425635;g=d+13|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1216);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,5)|0;b[h>>0]=b[425649]|0;b[h+1>>0]=b[425650]|0;b[h+2>>0]=b[425651]|0;b[h+3>>0]=b[425652]|0;b[h+4>>0]=b[425653]|0;MHa(c,1216);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,7)|0;b[h>>0]=b[425655]|0;b[h+1>>0]=b[425656]|0;b[h+2>>0]=b[425657]|0;b[h+3>>0]=b[425658]|0;b[h+4>>0]=b[425659]|0;b[h+5>>0]=b[425660]|0;b[h+6>>0]=b[425661]|0;MHa(c,1217);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,4)|0;b[h>>0]=84;b[h+1>>0]=97;b[h+2>>0]=110;b[h+3>>0]=72;MHa(c,1218);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,3)|0;b[h>>0]=b[425663]|0;b[h+1>>0]=b[425664]|0;b[h+2>>0]=b[425665]|0;MHa(c,1219);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,4)|0;b[h>>0]=66;b[h+1>>0]=78;b[h+2>>0]=76;b[h+3>>0]=76;MHa(c,1220);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,6)|0;b[h>>0]=b[425667]|0;b[h+1>>0]=b[425668]|0;b[h+2>>0]=b[425669]|0;b[h+3>>0]=b[425670]|0;b[h+4>>0]=b[425671]|0;b[h+5>>0]=b[425672]|0;MHa(c,1221);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,5)|0;b[h>>0]=b[451285]|0;b[h+1>>0]=b[451286]|0;b[h+2>>0]=b[451287]|0;b[h+3>>0]=b[451288]|0;b[h+4>>0]=b[451289]|0;MHa(c,1222);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,9)|0;e=454964;g=d+9|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1223);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,9)|0;e=425674;g=d+9|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1224);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,7)|0;b[h>>0]=b[429297]|0;b[h+1>>0]=b[429298]|0;b[h+2>>0]=b[429299]|0;b[h+3>>0]=b[429300]|0;b[h+4>>0]=b[429301]|0;b[h+5>>0]=b[429302]|0;b[h+6>>0]=b[429303]|0;MHa(c,1225);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,8)|0;i=h;b[i>>0]=73;b[i+1>>0]=100;b[i+2>>0]=101;b[i+3>>0]=110;i=h+4|0;b[i>>0]=116;b[i+1>>0]=105;b[i+2>>0]=116;b[i+3>>0]=121;MHa(c,1225);uT(c);f[c>>2]=0;f[c+4>>2]=0;i=tT(c,7)|0;b[i>>0]=b[425684]|0;b[i+1>>0]=b[425685]|0;b[i+2>>0]=b[425686]|0;b[i+3>>0]=b[425687]|0;b[i+4>>0]=b[425688]|0;b[i+5>>0]=b[425689]|0;b[i+6>>0]=b[425690]|0;MHa(c,1225);uT(c);f[c>>2]=0;f[c+4>>2]=0;i=tT(c,4)|0;b[i>>0]=67;b[i+1>>0]=114;b[i+2>>0]=111;b[i+3>>0]=112;MHa(c,1226);uT(c);f[c>>2]=0;f[c+4>>2]=0;i=tT(c,7)|0;b[i>>0]=b[454641]|0;b[i+1>>0]=b[454642]|0;b[i+2>>0]=b[454643]|0;b[i+3>>0]=b[454644]|0;b[i+4>>0]=b[454645]|0;b[i+5>>0]=b[454646]|0;b[i+6>>0]=b[454647]|0;MHa(c,1227);uT(c);f[c>>2]=0;f[c+4>>2]=0;i=tT(c,7)|0;b[i>>0]=b[454705]|0;b[i+1>>0]=b[454706]|0;b[i+2>>0]=b[454707]|0;b[i+3>>0]=b[454708]|0;b[i+4>>0]=b[454709]|0;b[i+5>>0]=b[454710]|0;b[i+6>>0]=b[454711]|0;MHa(c,1228);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,14)|0;e=425692;g=d+14|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1229);uT(c);f[c>>2]=0;f[c+4>>2]=0;i=tT(c,8)|0;h=i;b[h>>0]=80;b[h+1>>0]=114;b[h+2>>0]=105;b[h+3>>0]=111;h=i+4|0;b[h>>0]=114;b[h+1>>0]=66;b[h+2>>0]=111;b[h+3>>0]=120;MHa(c,1230);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,17)|0;e=425707;g=d+17|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1230);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,5)|0;b[h>>0]=b[454741]|0;b[h+1>>0]=b[454742]|0;b[h+2>>0]=b[454743]|0;b[h+3>>0]=b[454744]|0;b[h+4>>0]=b[454745]|0;MHa(c,1231);uT(c);f[c>>2]=0;f[c+4>>2]=0;h=tT(c,6)|0;b[h>>0]=b[454545]|0;b[h+1>>0]=b[454546]|0;b[h+2>>0]=b[454547]|0;b[h+3>>0]=b[454548]|0;b[h+4>>0]=b[454549]|0;b[h+5>>0]=b[454550]|0;MHa(c,1232);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,15)|0;e=446308;g=d+15|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1233);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,13)|0;e=425725;g=d+13|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1234);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,9)|0;e=425739;g=d+9|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));MHa(c,1234);uT(c);f[c>>2]=0;f[c+4>>2]=0;e=tT(c,5)|0;b[e>>0]=b[425749]|0;b[e+1>>0]=b[425750]|0;b[e+2>>0]=b[425751]|0;b[e+3>>0]=b[425752]|0;b[e+4>>0]=b[425753]|0;MHa(c,1235);uT(c);f[c>>2]=0;f[c+4>>2]=0;e=tT(c,7)|0;b[e>>0]=b[425755]|0;b[e+1>>0]=b[425756]|0;b[e+2>>0]=b[425757]|0;b[e+3>>0]=b[425758]|0;b[e+4>>0]=b[425759]|0;b[e+5>>0]=b[425760]|0;b[e+6>>0]=b[425761]|0;MHa(c,1236);uT(c);f[c>>2]=0;f[c+4>>2]=0;e=tT(c,8)|0;d=e;b[d>>0]=80;b[d+1>>0]=114;b[d+2>>0]=111;b[d+3>>0]=112;d=e+4|0;b[d>>0]=111;b[d+1>>0]=115;b[d+2>>0]=97;b[d+3>>0]=108;MHa(c,1237);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,5)|0;b[d>>0]=b[435704]|0;b[d+1>>0]=b[435705]|0;b[d+2>>0]=b[435706]|0;b[d+3>>0]=b[435707]|0;b[d+4>>0]=b[435708]|0;MHa(c,1238);uT(c);f[c>>2]=0;f[c+4>>2]=0;d=tT(c,4)|0;b[d>>0]=76;b[d+1>>0]=83;b[d+2>>0]=84;b[d+3>>0]=77;MHa(c,1239);uT(c);u=a;return}function Amb(a){a=a|0;b[a>>0]=0;BTb();return}function Bmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Irb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Cmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Wvb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Dmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;nvb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Emb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Dpb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Fmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;zrb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Gmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Cvb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Hmb(a,b){a=a|0;b=b|0;Ovb(a,b);return}function Imb(a,b){a=a|0;b=b|0;Uyb(a,b);return}function Jmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Opb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Kmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;pqb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Lmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;rAb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Mmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Gqb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Nmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;bwb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Omb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Jyb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Pmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Zrb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Qmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Asb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Rmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Qsb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Smb(a,b){a=a|0;b=b|0;Wub(a,b);return}function Tmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;utb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Umb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;etb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Vmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Ktb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Wmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;oub(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Xmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;_tb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Ymb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Eub(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Zmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;mzb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function _mb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Xwb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function $mb(a,b){a=a|0;b=b|0;Szb(a,b);return}function anb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Kwb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function bnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;exb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function cnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;opb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function dnb(a,b){a=a|0;b=b|0;Jzb(a,b);return}function enb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;$zb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function fnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;$yb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function gnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Ayb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function hnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;vxb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function inb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;dpb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function jnb(a,b){a=a|0;b=b|0;irb(a,b);return}function knb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;jrb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function lnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;jsb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function mnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Wqb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function nnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;twb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function onb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+32|0;c=b+12|0;d=b;f[c>>2]=0;e=c+4|0;f[e>>2]=0;f[c+8>>2]=0;g=VDc(64)|0;pnb(g);h=VDc(16)|0;f[h+4>>2]=1;f[h>>2]=97984;f[h+8>>2]=g;f[d>>2]=h;f[d+4>>2]=g;i=f[e>>2]|0;j=c+8|0;if((i|0)==(f[j>>2]|0))qnb(c,d);else{f[i>>2]=h;f[i+4>>2]=g;g=h+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(h=g+4|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(64)|0;rnb(g);i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=98004;f[i+8>>2]=g;f[d>>2]=i;f[d+4>>2]=g;h=f[e>>2]|0;if((h|0)==(f[j>>2]|0))qnb(c,d);else{f[h>>2]=i;f[h+4>>2]=g;g=i+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(i=g+4|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(64)|0;snb(g);h=VDc(16)|0;f[h+4>>2]=1;f[h>>2]=98024;f[h+8>>2]=g;f[d>>2]=h;f[d+4>>2]=g;i=f[e>>2]|0;if((i|0)==(f[j>>2]|0))qnb(c,d);else{f[i>>2]=h;f[i+4>>2]=g;g=h+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(h=g+4|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(64)|0;tnb(g);i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=98044;f[i+8>>2]=g;f[d>>2]=i;f[d+4>>2]=g;h=f[e>>2]|0;if((h|0)==(f[j>>2]|0))qnb(c,d);else{f[h>>2]=i;f[h+4>>2]=g;g=i+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(i=g+4|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(64)|0;unb(g);h=VDc(16)|0;f[h+4>>2]=1;f[h>>2]=98064;f[h+8>>2]=g;f[d>>2]=h;f[d+4>>2]=g;i=f[e>>2]|0;if((i|0)==(f[j>>2]|0))qnb(c,d);else{f[i>>2]=h;f[i+4>>2]=g;g=h+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(h=g+4|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(64)|0;vnb(g);i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=98084;f[i+8>>2]=g;f[d>>2]=i;f[d+4>>2]=g;h=f[e>>2]|0;if((h|0)==(f[j>>2]|0))qnb(c,d);else{f[h>>2]=i;f[h+4>>2]=g;g=i+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(i=g+4|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(68)|0;wnb(g,3);h=VDc(16)|0;f[h+4>>2]=1;f[h>>2]=98104;f[h+8>>2]=g;f[d>>2]=h;f[d+4>>2]=g;i=f[e>>2]|0;if((i|0)==(f[j>>2]|0))qnb(c,d);else{f[i>>2]=h;f[i+4>>2]=g;g=h+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(h=g+4|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(64)|0;xnb(g);i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=98124;f[i+8>>2]=g;f[d>>2]=i;f[d+4>>2]=g;h=f[e>>2]|0;if((h|0)==(f[j>>2]|0))qnb(c,d);else{f[h>>2]=i;f[h+4>>2]=g;g=i+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(i=g+4|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(64)|0;ynb(g);h=VDc(16)|0;f[h+4>>2]=1;f[h>>2]=98144;f[h+8>>2]=g;f[d>>2]=h;f[d+4>>2]=g;i=f[e>>2]|0;if((i|0)==(f[j>>2]|0))qnb(c,d);else{f[i>>2]=h;f[i+4>>2]=g;g=h+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;if(g|0?(h=g+4|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=VDc(64)|0;znb(g);i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=98164;f[i+8>>2]=g;f[d>>2]=i;f[d+4>>2]=g;h=f[e>>2]|0;if((h|0)==(f[j>>2]|0))qnb(c,d);else{f[h>>2]=i;f[h+4>>2]=g;g=i+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;do if(g|0){i=g+4|0;h=f[i>>2]|0;f[i>>2]=h+-1;if((h|0)!=1)break;Yi[f[(f[g>>2]|0)+8>>2]&2047](g)}while(0);g=VDc(64)|0;Anb(g);h=VDc(16)|0;f[h+4>>2]=1;f[h>>2]=98184;f[h+8>>2]=g;f[d>>2]=h;f[d+4>>2]=g;i=f[e>>2]|0;if((i|0)==(f[j>>2]|0))qnb(c,d);else{f[i>>2]=h;f[i+4>>2]=g;g=h+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;do if(g|0){h=g+4|0;i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)!=1)break;Yi[f[(f[g>>2]|0)+8>>2]&2047](g)}while(0);g=VDc(64)|0;Bnb(g);i=VDc(16)|0;f[i+4>>2]=1;f[i>>2]=98204;f[i+8>>2]=g;f[d>>2]=i;f[d+4>>2]=g;h=f[e>>2]|0;if((h|0)==(f[j>>2]|0))qnb(c,d);else{f[h>>2]=i;f[h+4>>2]=g;g=i+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;do if(g|0){i=g+4|0;h=f[i>>2]|0;f[i>>2]=h+-1;if((h|0)!=1)break;Yi[f[(f[g>>2]|0)+8>>2]&2047](g)}while(0);g=VDc(64)|0;Cnb(g);h=VDc(16)|0;f[h+4>>2]=1;f[h>>2]=98224;f[h+8>>2]=g;f[d>>2]=h;f[d+4>>2]=g;i=f[e>>2]|0;if((i|0)==(f[j>>2]|0))qnb(c,d);else{f[i>>2]=h;f[i+4>>2]=g;g=h+4|0;f[g>>2]=(f[g>>2]|0)+1;f[e>>2]=(f[e>>2]|0)+8}g=f[d>>2]|0;do if(g|0){h=g+4|0;i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)!=1)break;Yi[f[(f[g>>2]|0)+8>>2]&2047](g)}while(0);g=f[a+12>>2]|0;f[d>>2]=0;i=d+4|0;f[i>>2]=0;f[d+8>>2]=0;do if((g|0)>0){h=0;j=g;while(1){k=f[c>>2]|0;a:do if((f[e>>2]|0)==(k|0))l=j;else{m=0;n=k;while(1){o=f[n+(m<<3)+4>>2]|0;if(hh[f[(f[o>>2]|0)+8>>2]&127](o,a,h,d)|0)break;o=m+1|0;n=f[c>>2]|0;if(o>>>0>=(f[e>>2]|0)-n>>3>>>0){l=j;break a}else m=o}Dnb(f[(f[c>>2]|0)+(m<<3)+4>>2]|0,a,d);l=j+1-((f[i>>2]|0)-(f[d>>2]|0)>>2)|0}while(0);h=h+1|0;if((h|0)>=(l|0))break;else j=l}j=f[d>>2]|0;if(!j)break;h=f[i>>2]|0;if((h|0)!=(j|0))f[i>>2]=h+(~((h+-4-j|0)>>>2)<<2);YDc(j)}while(0);i=f[c>>2]|0;if(!i){u=b;return}d=f[e>>2]|0;if((d|0)==(i|0))p=i;else{l=d;do{d=l+-8|0;f[e>>2]=d;a=f[d>>2]|0;do if(a|0){g=a+4|0;j=f[g>>2]|0;f[g>>2]=j+-1;if((j|0)!=1)break;Yi[f[(f[a>>2]|0)+8>>2]&2047](a)}while(0);f[d>>2]=0;f[l+-4>>2]=0;l=f[e>>2]|0}while((l|0)!=(i|0));p=f[c>>2]|0}YDc(p);u=b;return}function pnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98668;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;m=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){n=f[l>>2]|0;if((n|0)!=(j|0))f[l>>2]=n+(~((n+-4-j|0)>>>2)<<2);YDc(j)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;n=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){p=f[l>>2]|0;if((p|0)!=(j|0))f[l>>2]=p+(~((p+-4-j|0)>>>2)<<2);YDc(j)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[j>>2]|0;if((q|0)!=(l|0))f[j>>2]=q+(~((q+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;q=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){r=f[l>>2]|0;if((r|0)!=(j|0))f[l>>2]=r+(~((r+-4-j|0)>>>2)<<2);YDc(j)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[427390]|0;b[d+1>>0]=b[427391]|0;b[d+2>>0]=b[427392]|0;b[d+3>>0]=0;i=Jnb(a,d,n,m,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[427636]|0;b[d+1>>0]=b[427637]|0;b[d+2>>0]=b[427638]|0;b[d+3>>0]=b[427639]|0;b[d+4>>0]=b[427640]|0;b[d+5>>0]=0;j=Jnb(a,d,i,-1,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;i=Jnb(a,d,j,q,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;j=Jnb(a,d,k,i,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;r=Jnb(a,d,o,i,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[428165]|0;b[d+1>>0]=b[428166]|0;b[d+2>>0]=b[428167]|0;b[d+3>>0]=0;i=Jnb(a,d,p,r,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[427390]|0;b[d+1>>0]=b[427391]|0;b[d+2>>0]=b[427392]|0;b[d+3>>0]=0;Jnb(a,d,j,i,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=VDc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=14;g=e;i=428681;h=g+14|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(h|0));b[e+14>>0]=0;Knb(a,d,k,q,p,o,n,m);if((b[d+11>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function qnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;l=f[b>>2]|0;f[e>>2]=l;f[m+(g<<3)+4>>2]=f[b+4>>2];if(!l){n=j;o=i}else{i=l+4|0;f[i>>2]=(f[i>>2]|0)+1;n=f[c>>2]|0;o=f[a>>2]|0}i=e+8|0;if((n|0)==(o|0)){p=h;q=n;r=n}else{l=n;n=h;h=e;do{e=l;l=l+-8|0;j=f[l>>2]|0;f[h+-8>>2]=j;f[h+-4>>2]=f[e+-4>>2];if(j|0){e=j+4|0;f[e>>2]=(f[e>>2]|0)+1}h=n+-8|0;n=h}while((l|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=i;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=d;d=d+-8|0;i=f[d>>2]|0;if(i|0?(c=i+4|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);f[d>>2]=0;f[r+-4>>2]=0}while((d|0)!=(k|0))}if(!q)return;YDc(q);return}function rnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98588;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;m=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){n=f[l>>2]|0;if((n|0)!=(j|0))f[l>>2]=n+(~((n+-4-j|0)>>>2)<<2);YDc(j)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;n=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){p=f[l>>2]|0;if((p|0)!=(j|0))f[l>>2]=p+(~((p+-4-j|0)>>>2)<<2);YDc(j)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[j>>2]|0;if((q|0)!=(l|0))f[j>>2]=q+(~((q+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[427390]|0;b[d+1>>0]=b[427391]|0;b[d+2>>0]=b[427392]|0;b[d+3>>0]=0;i=Jnb(a,d,n,m,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[427636]|0;b[d+1>>0]=b[427637]|0;b[d+2>>0]=b[427638]|0;b[d+3>>0]=b[427639]|0;b[d+4>>0]=b[427640]|0;b[d+5>>0]=0;l=Jnb(a,d,i,-1,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;i=Jnb(a,d,k,l,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;q=Jnb(a,d,o,l,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[428165]|0;b[d+1>>0]=b[428166]|0;b[d+2>>0]=b[428167]|0;b[d+3>>0]=0;l=Jnb(a,d,p,q,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[427390]|0;b[d+1>>0]=b[427391]|0;b[d+2>>0]=b[427392]|0;b[d+3>>0]=0;Jnb(a,d,i,l,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=VDc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=14;g=e;l=428681;h=g+14|0;do{b[g>>0]=b[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(h|0));b[e+14>>0]=0;Knb(a,d,k,p,p,o,n,m);if((b[d+11>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function snb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98564;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;m=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){n=f[l>>2]|0;if((n|0)!=(j|0))f[l>>2]=n+(~((n+-4-j|0)>>>2)<<2);YDc(j)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;n=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){p=f[l>>2]|0;if((p|0)!=(j|0))f[l>>2]=p+(~((p+-4-j|0)>>>2)<<2);YDc(j)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[j>>2]|0;if((q|0)!=(l|0))f[j>>2]=q+(~((q+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=VDc(16)|0;f[d>>2]=i;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=i;l=426415;h=g+12|0;do{b[g>>0]=b[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(h|0));b[i+12>>0]=0;i=Jnb(a,d,m,n,o,p)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;n=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){l=f[o>>2]|0;if((l|0)!=(m|0))f[o>>2]=l+(~((l+-4-m|0)>>>2)<<2);YDc(m)}if((b[p>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=4;f[d>>2]=1801675088;b[d+4>>0]=0;p=Jnb(a,d,i,n,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[426093]|0;b[d+1>>0]=b[426094]|0;b[d+2>>0]=b[426095]|0;b[d+3>>0]=b[426096]|0;b[d+4>>0]=b[426097]|0;b[d+5>>0]=b[426098]|0;b[d+6>>0]=b[426099]|0;b[d+7>>0]=0;Jnb(a,d,k,p,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[428347]|0;b[d+1>>0]=b[428348]|0;b[d+2>>0]=b[428349]|0;b[d+3>>0]=b[428350]|0;b[d+4>>0]=b[428351]|0;b[d+5>>0]=b[428352]|0;b[d+6>>0]=b[428353]|0;b[d+7>>0]=0;Knb(a,d,k,-1,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function tnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98540;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=5;b[d>>0]=b[426087]|0;b[d+1>>0]=b[426088]|0;b[d+2>>0]=b[426089]|0;b[d+3>>0]=b[426090]|0;b[d+4>>0]=b[426091]|0;b[d+5>>0]=0;l=Jnb(a,d,k,-1,-1,-1)|0;if((b[i>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;j=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){o=f[m>>2]|0;if((o|0)!=(n|0))f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);YDc(n)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){p=f[n>>2]|0;if((p|0)!=(m|0))f[n>>2]=p+(~((p+-4-m|0)>>>2)<<2);YDc(m)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;p=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[m>>2]|0;if((q|0)!=(n|0))f[m>>2]=q+(~((q+-4-n|0)>>>2)<<2);YDc(n)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=VDc(16)|0;f[d>>2]=i;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=i;n=426415;h=g+12|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[i+12>>0]=0;i=Jnb(a,d,l,j,o,p)|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;j=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){n=f[o>>2]|0;if((n|0)!=(l|0))f[o>>2]=n+(~((n+-4-l|0)>>>2)<<2);YDc(l)}if((b[p>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=4;f[d>>2]=1801675088;b[d+4>>0]=0;p=Jnb(a,d,i,j,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[426093]|0;b[d+1>>0]=b[426094]|0;b[d+2>>0]=b[426095]|0;b[d+3>>0]=b[426096]|0;b[d+4>>0]=b[426097]|0;b[d+5>>0]=b[426098]|0;b[d+6>>0]=b[426099]|0;b[d+7>>0]=0;Jnb(a,d,k,p,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[428347]|0;b[d+1>>0]=b[428348]|0;b[d+2>>0]=b[428349]|0;b[d+3>>0]=b[428350]|0;b[d+4>>0]=b[428351]|0;b[d+5>>0]=b[428352]|0;b[d+6>>0]=b[428353]|0;b[d+7>>0]=0;Knb(a,d,k,-1,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function unb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98516;g=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;f[d+8>>2]=0;i=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){k=f[h>>2]|0;if((k|0)!=(j|0))f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2);YDc(j)}if((b[g>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;h=f[d>>2]|0;if(h|0){l=f[j>>2]|0;if((l|0)!=(h|0))f[j>>2]=l+(~((l+-4-h|0)>>>2)<<2);YDc(h)}if((b[g>>0]|0)<0)YDc(f[e>>2]|0);g=d+4|0;f[g>>2]=0;f[g+4>>2]=0;g=d+11|0;b[g>>0]=3;b[d>>0]=b[428161]|0;b[d+1>>0]=b[428162]|0;b[d+2>>0]=b[428163]|0;b[d+3>>0]=0;h=Jnb(a,d,i,k,-1,-1)|0;if((b[g>>0]|0)<0)YDc(f[d>>2]|0);g=d+4|0;f[g>>2]=0;f[g+4>>2]=0;g=d+11|0;b[g>>0]=3;b[d>>0]=b[428165]|0;b[d+1>>0]=b[428166]|0;b[d+2>>0]=b[428167]|0;b[d+3>>0]=0;k=Jnb(a,d,i,h,-1,-1)|0;if((b[g>>0]|0)<0)YDc(f[d>>2]|0);g=d+4|0;f[g>>2]=0;f[g+4>>2]=0;g=d+11|0;b[g>>0]=3;b[d>>0]=b[428169]|0;b[d+1>>0]=b[428170]|0;b[d+2>>0]=b[428171]|0;b[d+3>>0]=0;h=Jnb(a,d,k,-1,-1,-1)|0;if((b[g>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;k=d+4|0;f[k>>2]=0;f[d+8>>2]=0;l=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){m=f[k>>2]|0;if((m|0)!=(j|0))f[k>>2]=m+(~((m+-4-j|0)>>>2)<<2);YDc(j)}if((b[g>>0]|0)<0)YDc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[427624]|0;b[d+1>>0]=b[427625]|0;b[d+2>>0]=b[427626]|0;b[d+3>>0]=0;g=Jnb(a,d,h,l,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[428173]|0;b[d+1>>0]=b[428174]|0;b[d+2>>0]=b[428175]|0;b[d+3>>0]=b[428176]|0;b[d+4>>0]=b[428177]|0;b[d+5>>0]=b[428178]|0;b[d+6>>0]=b[428179]|0;b[d+7>>0]=0;Jnb(a,d,h,g,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[454837]|0;b[d+1>>0]=b[454838]|0;b[d+2>>0]=b[454839]|0;b[d+3>>0]=b[454840]|0;b[d+4>>0]=b[454841]|0;b[d+5>>0]=b[454842]|0;b[d+6>>0]=b[454843]|0;b[d+7>>0]=0;Knb(a,d,i,-1,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function vnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98492;g=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;f[d+8>>2]=0;i=Inb(a,e,d)|0;j=f[d>>2]|0;if(j|0){k=f[h>>2]|0;if((k|0)!=(j|0))f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2);YDc(j)}if((b[g>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;g=d+11|0;b[g>>0]=4;f[d>>2]=1970038098;b[d+4>>0]=0;j=Jnb(a,d,i,-1,-1,-1)|0;if((b[g>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;k=d+4|0;f[k>>2]=0;f[d+8>>2]=0;h=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[k>>2]|0;if((m|0)!=(l|0))f[k>>2]=m+(~((m+-4-l|0)>>>2)<<2);YDc(l)}if((b[g>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;m=Inb(a,e,d)|0;k=f[d>>2]|0;if(k|0){n=f[l>>2]|0;if((n|0)!=(k|0))f[l>>2]=n+(~((n+-4-k|0)>>>2)<<2);YDc(k)}if((b[g>>0]|0)<0)YDc(f[e>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[427983]|0;b[d+1>>0]=b[427984]|0;b[d+2>>0]=b[427985]|0;b[d+3>>0]=b[427986]|0;b[d+4>>0]=b[427987]|0;b[d+5>>0]=b[427988]|0;b[d+6>>0]=b[427989]|0;b[d+7>>0]=0;g=Jnb(a,d,j,h,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[427628]|0;b[d+1>>0]=b[427629]|0;b[d+2>>0]=b[427630]|0;b[d+3>>0]=b[427631]|0;b[d+4>>0]=b[427632]|0;b[d+5>>0]=b[427633]|0;b[d+6>>0]=b[427634]|0;b[d+7>>0]=0;Jnb(a,d,g,m,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[427991]|0;b[d+1>>0]=b[427992]|0;b[d+2>>0]=b[427993]|0;b[d+3>>0]=b[427994]|0;b[d+4>>0]=b[427995]|0;b[d+5>>0]=0;Knb(a,d,i,-1,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}function wnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=a+4|0;j=i+60|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[a>>2]=98468;k=a+64|0;f[k>>2]=c;c=g+11|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;m=Inb(a,g,e)|0;n=f[e>>2]|0;if(n|0){o=f[l>>2]|0;if((o|0)!=(n|0))f[l>>2]=o+(~((o+-4-n|0)>>>2)<<2);YDc(n)}if((b[c>>0]|0)<0)YDc(f[g>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=e+11|0;b[c>>0]=5;b[e>>0]=b[426087]|0;b[e+1>>0]=b[426088]|0;b[e+2>>0]=b[426089]|0;b[e+3>>0]=b[426090]|0;b[e+4>>0]=b[426091]|0;b[e+5>>0]=0;n=Jnb(a,e,m,-1,-1,-1)|0;if((b[c>>0]|0)<0)YDc(f[e>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=g+11|0;b[c>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[e>>2]=0;o=e+4|0;f[o>>2]=0;f[e+8>>2]=0;l=Inb(a,g,e)|0;p=f[e>>2]|0;if(p|0){q=f[o>>2]|0;if((q|0)!=(p|0))f[o>>2]=q+(~((q+-4-p|0)>>>2)<<2);YDc(p)}if((b[c>>0]|0)<0)YDc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=g+11|0;b[c>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[e>>2]=0;p=e+4|0;f[p>>2]=0;f[e+8>>2]=0;q=Inb(a,g,e)|0;o=f[e>>2]|0;if(o|0){r=f[p>>2]|0;if((r|0)!=(o|0))f[p>>2]=r+(~((r+-4-o|0)>>>2)<<2);YDc(o)}if((b[c>>0]|0)<0)YDc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=g+11|0;b[c>>0]=5;b[g>>0]=b[426101]|0;b[g+1>>0]=b[426102]|0;b[g+2>>0]=b[426103]|0;b[g+3>>0]=b[426104]|0;b[g+4>>0]=b[426105]|0;b[g+5>>0]=0;f[e>>2]=0;o=e+4|0;f[o>>2]=0;f[e+8>>2]=0;r=Inb(a,g,e)|0;p=f[e>>2]|0;if(p|0){s=f[o>>2]|0;if((s|0)!=(p|0))f[o>>2]=s+(~((s+-4-p|0)>>>2)<<2);YDc(p)}if((b[c>>0]|0)<0)YDc(f[g>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=VDc(16)|0;f[e>>2]=c;f[e+8>>2]=-2147483632;f[e+4>>2]=12;i=c;p=426415;j=i+12|0;do{b[i>>0]=b[p>>0]|0;i=i+1|0;p=p+1|0}while((i|0)<(j|0));b[c+12>>0]=0;c=Jnb(a,e,n,l,q,r)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);r=(f[k>>2]|0)+1|0;f[g>>2]=0;q=g+4|0;f[q>>2]=0;f[g+8>>2]=0;if(r>>>0>1073741823)mCc(g);l=r<<2;n=VDc(l)|0;f[g>>2]=n;p=n+(r<<2)|0;f[g+8>>2]=p;XIc(n|0,0,l|0)|0;f[q>>2]=p;f[n>>2]=c;if((f[k>>2]|0)>0){c=h+11|0;n=h+5|0;p=e+4|0;l=e+8|0;r=0;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[c>>0]=5;b[h>>0]=b[426101]|0;b[h+1>>0]=b[426102]|0;b[h+2>>0]=b[426103]|0;b[h+3>>0]=b[426104]|0;b[h+4>>0]=b[426105]|0;b[n>>0]=0;f[e>>2]=0;f[p>>2]=0;f[l>>2]=0;i=Inb(a,h,e)|0;j=f[e>>2]|0;if(j|0){s=f[p>>2]|0;if((s|0)!=(j|0))f[p>>2]=s+(~((s+-4-j|0)>>>2)<<2);YDc(j)}r=r+1|0;f[(f[g>>2]|0)+(r<<2)>>2]=i;if((b[c>>0]|0)<0)YDc(f[h>>2]|0)}while((r|0)<(f[k>>2]|0))};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;k=e+11|0;b[k>>0]=4;f[e>>2]=1801675088;b[e+4>>0]=0;r=Inb(a,e,g)|0;if((b[k>>0]|0)<0)YDc(f[e>>2]|0);f[e+8>>2]=0;k=e+11|0;b[k>>0]=7;b[e>>0]=b[426093]|0;b[e+1>>0]=b[426094]|0;b[e+2>>0]=b[426095]|0;b[e+3>>0]=b[426096]|0;b[e+4>>0]=b[426097]|0;b[e+5>>0]=b[426098]|0;b[e+6>>0]=b[426099]|0;b[e+7>>0]=0;Jnb(a,e,m,r,-1,-1)|0;if((b[k>>0]|0)<0)YDc(f[e>>2]|0);f[f[g>>2]>>2]=m;f[e+8>>2]=0;m=e+11|0;b[m>>0]=7;b[e>>0]=b[426093]|0;b[e+1>>0]=b[426094]|0;b[e+2>>0]=b[426095]|0;b[e+3>>0]=b[426096]|0;b[e+4>>0]=b[426097]|0;b[e+5>>0]=b[426098]|0;b[e+6>>0]=b[426099]|0;b[e+7>>0]=0;Pnb(a,e,g);if((b[m>>0]|0)<0)YDc(f[e>>2]|0);e=f[g>>2]|0;if(!e){u=d;return}g=f[q>>2]|0;if((g|0)!=(e|0))f[q>>2]=g+(~((g+-4-e|0)>>>2)<<2);YDc(e);u=d;return}function xnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=98444;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=Inb(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);YDc(l)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=6;b[d>>0]=b[427617]|0;b[d+1>>0]=b[427618]|0;b[d+2>>0]=b[427619]|0;b[d+3>>0]=b[427620]|0;b[d+4>>0]=b[427621]|0;b[d+5>>0]=b[427622]|0;b[d+6>>0]=0;l=Jnb(a,d,k,-1,-1,-1)|0;if((b[i>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;j=Inb(a,e,d)|0;n=f[d>>2]|0;if(n|0){o=f[m>>2]|0;if((o|0)!=(n|0))f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);YDc(n)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);i=d+4|0;f[i>>2]=0;f[i+4>>2]=0;i=d+11|0;b[i>>0]=3;b[d>>0]=b[427624]|0;b[d+1>>0]=b[427625]|0;b[d+2>>0]=b[427626]|0;b[d+3>>0]=0;n=Jnb(a,d,l,j,-1,-1)|0;if((b[i>>0]|0)<0)YDc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[426101]|0;b[e+1>>0]=b[426102]|0;b[e+2>>0]=b[426103]|0;b[e+3>>0]=b[426104]|0;b[e+4>>0]=b[426105]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;o=Inb(a,e,d)|0;m=f[d>>2]|0;if(m|0){p=f[l>>2]|0;if((p|0)!=(m|0))f[l>>2]=p+(~((p+-4-m|0)>>>2)<<2);YDc(m)}if((b[i>>0]|0)<0)YDc(f[e>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[427628]|0;b[d+1>>0]=b[427629]|0;b[d+2>>0]=b[427630]|0;b[d+3>>0]=b[427631]|0;b[d+4>>0]=b[427632]|0;b[d+5>>0]=b[427633]|0;b[d+6>>0]=b[427634]|0;b[d+7>>0]=0;i=Jnb(a,d,n,o,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[427636]|0;b[d+1>>0]=b[427637]|0;b[d+2>>0]=b[427638]|0;b[d+3>>0]=b[427639]|0;b[d+4>>0]=b[427640]|0;b[d+5>>0]=0;o=Jnb(a,d,i,-1,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[426428]|0;b[d+1>>0]=b[426429]|0;b[d+2>>0]=b[426430]|0;b[d+3>>0]=0;Jnb(a,d,k,o,-1,-1)|0;if((b[e>>0]|0)<0)YDc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=VDc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=11;g=e;o=427642;h=g+11|0;do{b[g>>0]=b[o>>0]|0;g=g+1|0;o=o+1|0}while((g|0)<(h|0));b[e+11>>0]=0;Knb(a,d,k,j,-1,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}YDc(f[d>>2]|0);u=c;return}
function zoa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+32|0;i=h+16|0;j=h;if((c|0)<=-1){f[i>>2]=0;k=i+4|0;f[k>>2]=0;l=tT(i,26)|0;m=l;n=270140;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,i,270289,270182,116)}q=f[a>>2]|0;r=((f[a+4>>2]|0)-q|0)/40|0;s=q;if((r|0)<=(c|0)){f[i>>2]=0;k=i+4|0;f[k>>2]=0;l=tT(i,26)|0;m=l;n=270140;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,i,270289,270182,116)}if(!((d|0)>-1&(r|0)>(d|0))){f[i>>2]=0;f[i+4>>2]=0;m=tT(i,26)|0;n=270298;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,i,270289,270182,117)}if(!(e>=0.0&g>=0.0)){f[i>>2]=0;f[i+4>>2]=0;m=tT(i,15)|0;n=270325;o=m+15|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,i,270289,270182,118)}if((c|0)==(d|0)){f[i>>2]=0;f[i+4>>2]=0;n=tT(i,6)|0;b[n>>0]=b[270341]|0;b[n+1>>0]=b[270342]|0;b[n+2>>0]=b[270343]|0;b[n+3>>0]=b[270344]|0;b[n+4>>0]=b[270345]|0;b[n+5>>0]=b[270346]|0;z5(-215,i,270289,270182,119)}n=a+12|0;m=a+16|0;o=f[m>>2]|0;r=f[n>>2]|0;if((o|0)==(r|0)){Coa(n,2);t=f[m>>2]|0;v=a;w=f[a>>2]|0;x=f[n>>2]|0}else{t=o;v=a;w=s;x=r}f[i>>2]=d;f[i+4>>2]=f[w+(c*40|0)+8>>2];p[i+8>>3]=e;f[w+(c*40|0)+8>>2]=t-x>>4;x=a+20|0;if((t|0)==(f[x>>2]|0)){Doa(n,i);a=f[m>>2]|0;y=a;z=a}else{a=t;f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];i=(f[m>>2]|0)+16|0;f[m>>2]=i;y=i;z=i}f[j>>2]=c;c=(f[v>>2]|0)+(d*40|0)+8|0;f[j+4>>2]=f[c>>2];p[j+8>>3]=g;f[c>>2]=y-(f[n>>2]|0)>>4;if((z|0)==(f[x>>2]|0)){Doa(n,j);u=h;return}else{f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[m>>2]=(f[m>>2]|0)+16;u=h;return}}function Aoa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;c=u;u=u+80|0;d=c;e=c+56|0;g=c+52|0;h=c+48|0;i=c+40|0;f[d>>2]=d;j=f[a>>2]|0;k=f[a+12>>2]|0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;m=(f[a+4>>2]|0)-j|0;if((m|0)>0){n=(m>>>0)/40|0;m=d;o=0;while(1){q=j+(o*40|0)|0;f[j+(o*40|0)+12>>2]=0;r=+p[j+(o*40|0)+24>>3];if(r!=0.0){f[m>>2]=q;f[j+(o*40|0)+16>>2]=1;b[j+(o*40|0)+32>>0]=r<0.0&1;s=q;t=-1}else{s=m;t=0}f[j+(o*40|0)+4>>2]=t;o=o+1|0;if((o|0)>=(n|0))break;else m=s}v=s;w=f[d>>2]|0}else{v=d;w=d}f[v>>2]=d;f[d>>2]=0;s=a+24|0;a=e+8|0;a:do if((w|0)!=(d|0)){m=w;n=0;o=v;t=0;b:while(1){q=-1;x=m;y=o;while(1){f[g>>2]=x;if(!(f[x+4>>2]|0)){z=q;A=y;B=x}else{C=b[x+32>>0]|0;D=f[x+8>>2]|0;c:do if(!D){E=q;F=y}else{G=C&255;H=D;I=y;while(1){J=H^G;do if(!(+p[k+(J<<4)+8>>3]==0.0)){K=f[k+(H<<4)>>2]|0;M=j+(K*40|0)|0;f[h>>2]=M;N=j+(K*40|0)+4|0;O=j+(K*40|0)+32|0;if(!(f[N>>2]|0)){b[O>>0]=C;f[j+(K*40|0)+4>>2]=H^1;P=f[g>>2]|0;f[j+(K*40|0)+12>>2]=f[P+12>>2];f[j+(K*40|0)+16>>2]=(f[P+16>>2]|0)+1;if(f[M>>2]|0){Q=I;break}f[M>>2]=d;M=f[h>>2]|0;f[I>>2]=M;Q=M;break}if((b[O>>0]|0)!=C<<24>>24){E=J;F=I;break c}O=f[g>>2]|0;M=(f[O+16>>2]|0)+1|0;if((f[j+(K*40|0)+16>>2]|0)>(M|0)?(P=f[O+12>>2]|0,(f[j+(K*40|0)+12>>2]|0)<=(P|0)):0){f[N>>2]=H^1;f[j+(K*40|0)+12>>2]=P;f[j+(K*40|0)+16>>2]=M;Q=I}else Q=I}else Q=I;while(0);H=f[k+(H<<4)+4>>2]|0;if(!H){E=q;F=Q;break}else I=Q}}while(0);if((E|0)>0){R=x;S=E;T=F;break}z=E;A=F;B=f[g>>2]|0}x=f[x>>2]|0;f[B>>2]=0;if((x|0)==(d|0)){U=24;break}else{q=z;y=A}}if((U|0)==24){U=0;if((z|0)<1){V=t;break a}else{R=d;S=z;T=A}}y=k+(S<<4)+8|0;r=+p[y>>3];if(!(r>0.0)){U=27;break}q=S^1;W=r;x=q;while(1){X=f[k+(x<<4)>>2]|0;x=f[j+(X*40|0)+4>>2]|0;if((x|0)<0)break;Y=+p[k+((x^1)<<4)+8>>3];Z=W>Y?Y:W;if(!(Z>0.0)){_=X;U=30;break b}else W=Z}f[g>>2]=j+(X*40|0);Z=+L(+(+p[j+(X*40|0)+24>>3]));Y=W>Z?Z:W;if(Y>0.0){$=Y;aa=S}else{U=32;break}while(1){ba=f[k+(aa<<4)>>2]|0;aa=f[j+(ba*40|0)+4>>2]|0;if((aa|0)<0)break;Y=+p[k+(aa<<4)+8>>3];Z=$>Y?Y:$;if(!(Z>0.0)){_=ba;U=30;break b}else $=Z}f[g>>2]=j+(ba*40|0);W=+L(+(+p[j+(ba*40|0)+24>>3]));Z=$>W?W:$;if(!(Z>0.0)){U=32;break}p[y>>3]=r-Z;x=k+(q<<4)+8|0;p[x>>3]=Z+ +p[x>>3];p[s>>3]=Z+ +p[s>>3];x=f[k+(q<<4)>>2]|0;C=j+(x*40|0)|0;f[g>>2]=C;D=f[j+(x*40|0)+4>>2]|0;I=C;if((D|0)<0){ca=x;da=I}else{x=D;D=I;while(1){I=k+(x<<4)+8|0;p[I>>3]=Z+ +p[I>>3];I=k+((x^1)<<4)+8|0;W=+p[I>>3]-Z;p[I>>3]=W;if(W==0.0){I=f[l>>2]|0;if((I|0)==(f[a>>2]|0))Boa(e,g);else{f[I>>2]=D;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}I=f[k+(x<<4)>>2]|0;C=j+(I*40|0)|0;f[g>>2]=C;x=f[j+(I*40|0)+4>>2]|0;H=C;if((x|0)<0){ca=I;da=H;break}else D=H}}D=j+(ca*40|0)+24|0;r=+p[D>>3]-Z;p[D>>3]=r;if(r==0.0){D=f[l>>2]|0;if((D|0)==(f[a>>2]|0))Boa(e,g);else{f[D>>2]=da;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}D=f[k+(S<<4)>>2]|0;x=j+(D*40|0)|0;f[g>>2]=x;q=f[j+(D*40|0)+4>>2]|0;y=x;if((q|0)<0){ea=D;fa=y}else{D=q;q=y;while(1){y=k+((D^1)<<4)+8|0;p[y>>3]=Z+ +p[y>>3];y=k+(D<<4)+8|0;r=+p[y>>3]-Z;p[y>>3]=r;if(r==0.0){y=f[l>>2]|0;if((y|0)==(f[a>>2]|0))Boa(e,g);else{f[y>>2]=q;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}y=f[k+(D<<4)>>2]|0;x=j+(y*40|0)|0;f[g>>2]=x;D=f[j+(y*40|0)+4>>2]|0;H=x;if((D|0)<0){ea=y;fa=H;break}else q=H}}q=j+(ea*40|0)+24|0;r=Z+ +p[q>>3];p[q>>3]=r;if(r==0.0){q=f[l>>2]|0;if((q|0)==(f[a>>2]|0))Boa(e,g);else{f[q>>2]=fa;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}n=n+1|0;q=f[e>>2]|0;D=f[l>>2]|0;d:do if((q|0)==(D|0)){ga=T;ha=q}else{H=T;y=q;x=D;while(1){I=x;while(1){I=I+-4|0;ia=f[I>>2]|0;f[l>>2]=I;ja=b[ia+32>>0]|0;ka=ia+8|0;C=f[ka>>2]|0;if(!C){U=50;break}G=(ja^1)&255;J=2147483647;M=C;C=0;while(1){e:do if(!(+p[k+((M^G)<<4)+8>>3]==0.0)?(K=f[k+(M<<4)>>2]|0,P=j+(K*40|0)|0,f[h>>2]=P,(b[j+(K*40|0)+32>>0]|0)==ja<<24>>24):0){if(!(f[j+(K*40|0)+4>>2]|0)){la=J;ma=C;break}N=j+(K*40|0)+12|0;f:do if((f[N>>2]|0)==(n|0)){na=0;oa=K;U=56}else{O=0;pa=P;qa=N;while(1){ra=f[pa+4>>2]|0;sa=O+1|0;if((ra|0)<0)break;ta=f[k+(ra<<4)>>2]|0;ua=j+(ta*40|0)|0;f[h>>2]=ua;va=j+(ta*40|0)+12|0;if((f[va>>2]|0)==(n|0)){na=sa;oa=ta;U=56;break f}else{O=sa;pa=ua;qa=va}}if((ra|0)==-2){la=J;ma=C;break e}f[qa>>2]=n;f[pa+16>>2]=1;wa=sa}while(0);if((U|0)==56){U=0;wa=(f[j+(oa*40|0)+16>>2]|0)+na|0}N=wa+1|0;if((N|0)==2147483647){la=J;ma=C;break}O=(N|0)<(J|0);va=O?M:C;ua=O?N:J;f[h>>2]=P;O=j+(K*40|0)+12|0;if((f[O>>2]|0)==(n|0)){la=ua;ma=va;break}else{xa=N;ya=K;za=O}do{f[za>>2]=n;xa=xa+-1|0;f[j+(ya*40|0)+16>>2]=xa;ya=f[k+(f[j+(ya*40|0)+4>>2]<<4)>>2]|0;za=j+(ya*40|0)+12|0}while((f[za>>2]|0)!=(n|0));f[h>>2]=j+(ya*40|0);la=ua;ma=va}else{la=J;ma=C}while(0);M=f[k+(M<<4)+4>>2]|0;if(!M)break;else{J=la;C=ma}}f[ia+4>>2]=ma;C=ia+12|0;if((ma|0)<=0){Aa=C;break}f[C>>2]=n;f[ia+16>>2]=la;if((y|0)==(I|0)){ga=H;ha=y;break d}}if((U|0)==50){U=0;f[ia+4>>2]=0;Aa=ia+12|0}f[Aa>>2]=0;C=f[ka>>2]|0;if(!C){Ba=H;Ca=I}else{J=(ja^1)&255;M=C;C=H;while(1){G=f[k+(M<<4)>>2]|0;K=j+(G*40|0)|0;f[h>>2]=K;P=f[j+(G*40|0)+4>>2]|0;do if(P|0?(b[j+(G*40|0)+32>>0]|0)==ja<<24>>24:0){do if(+p[k+((M^J)<<4)+8>>3]!=0.0){if(f[K>>2]|0){Da=C;break}f[K>>2]=d;O=f[h>>2]|0;f[C>>2]=O;Da=O}else Da=C;while(0);if((P|0)<=0){Ea=Da;break}if((j+((f[k+(P<<4)>>2]|0)*40|0)|0)!=(ia|0)){Ea=Da;break}O=f[l>>2]|0;if((O|0)==(f[a>>2]|0))Boa(e,h);else{f[O>>2]=f[h>>2];f[l>>2]=(f[l>>2]|0)+4}f[(f[h>>2]|0)+4>>2]=-2;Ea=Da}else Ea=C;while(0);M=f[k+(M<<4)+4>>2]|0;if(!M)break;else C=Ea}Ba=Ea;Ca=f[l>>2]|0}y=f[e>>2]|0;if((y|0)==(Ca|0)){ga=Ba;ha=Ca;break}else{H=Ba;x=Ca}}}while(0);if((R|0)==(d|0)){V=ha;break a}else{m=R;o=ga;t=ha}}if((U|0)==27){f[i>>2]=0;f[i+4>>2]=0;Fa=tT(i,13)|0;Ga=270267;Ha=Fa+13|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));z5(-215,i,270281,270182,244)}else if((U|0)==30){f[g>>2]=j+(_*40|0);f[i>>2]=0;f[i+4>>2]=0;Fa=tT(i,13)|0;Ga=270267;Ha=Fa+13|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));z5(-215,i,270281,270182,254)}else if((U|0)==32){f[i>>2]=0;f[i+4>>2]=0;Fa=tT(i,13)|0;Ga=270267;Ha=Fa+13|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));z5(-215,i,270281,270182,258)}}else V=0;while(0);$=+p[s>>3];if(!V){u=c;return +$}s=f[l>>2]|0;if((s|0)!=(V|0))f[l>>2]=s+(~((s+-4-V|0)>>>2)<<2);YDc(V);u=c;return +$}function Boa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function Coa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)mCc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=k+(d<<4)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(0-(b>>4)<<4)|0;if((b|0)>0)dJc(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;YDc(d);return}function Doa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;YDc(d);return}function Eoa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;if((e|0)<1){Foa(a,b,c,d,f,g);return}else{Goa(a,b,c,d,e,f,g);return}}function Foa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;i=u;u=u+208|0;j=i+144|0;k=i+88|0;l=i+72|0;m=i+16|0;n=i;if((h+-5|0)>>>0>=2){f[j>>2]=0;f[j+4>>2]=0;o=tT(j,34)|0;p=270520;q=o+34|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,j,270735,270571,61)}Y$(a,3,1,h,-1,1,0);Y$(c,3,1,h,-1,1,0);do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[j>>2]=f[r>>2];s=j+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=j+8|0;f[v>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];f[j+16>>2]=f[r+16>>2];f[j+20>>2]=f[r+20>>2];f[j+24>>2]=f[r+24>>2];f[j+28>>2]=f[r+28>>2];f[j+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[j+36>>2]=w;f[j+40>>2]=v;v=j+48|0;x=j+44|0;f[x>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;ZS(j,r);break}}else a$(j,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];r=k+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=k+8|0;f[t>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=t;t=k+48|0;x=k+44|0;f[x>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;ZS(k,a);break}}else a$(k,c,-1);while(0);if(!((e|d|0)>-1&(e+d|0)==1)){f[l>>2]=0;f[l+4>>2]=0;o=tT(l,32)|0;p=270752;q=o+32|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-215,l,270735,270571,67)}p=m+4|0;o=m+8|0;q=m+12|0;c=m+16|0;a=m+20|0;r=m+24|0;s=m+28|0;t=m+40|0;x=m+48|0;v=m+44|0;w=m+52|0;y=n+8|0;z=n+4|0;A=m+36|0;B=l+4|0;C=l+8|0;if(g){switch(d|0){case 0:{D=3;E=10;F=3;G=42;break}case 1:{D=1;E=0;F=-1;G=42;break}default:{}}if((G|0)==42){f[l>>2]=F;f[B>>2]=E;f[C>>2]=D}D=f[j+8>>2]|0;E=f[j+12>>2]|0;f[m>>2]=1124007940;f[p>>2]=2;f[o>>2]=D;f[q>>2]=E;f[c>>2]=l;f[a>>2]=l;F=r+8|0;f[F>>2]=0;f[F+4>>2]=0;f[t>>2]=o;f[v>>2]=x;F=E<<2;f[x>>2]=F;f[w>>2]=4;g=l+((Y(E,D)|0)<<2)|0;f[s>>2]=g;f[r>>2]=g+(0-F)+F;WS(m);F=y;f[F>>2]=0;f[F+4>>2]=0;f[n>>2]=33619968;f[z>>2]=j;LZ(m,n,h,(d|0)==1?1.0:.03125,0.0);F=f[A>>2]|0;if(F|0?(g=F+12|0,F=f[g>>2]|0,f[g>>2]=F+-1,(F|0)==1):0)_S(m);f[A>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){F=f[t>>2]|0;g=0;do{f[F+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[p>>2]|0))}g=f[v>>2]|0;if((g|0)!=(x|0))g0(g);switch(e|0){case 0:{H=3;I=10;J=3;G=62;break}case 1:{H=1;I=0;J=-1;G=62;break}default:{}}if((G|0)==62){f[l>>2]=J;f[B>>2]=I;f[C>>2]=H}H=f[k+8>>2]|0;I=f[k+12>>2]|0;f[m>>2]=1124007940;f[p>>2]=2;f[o>>2]=H;f[q>>2]=I;f[c>>2]=l;f[a>>2]=l;J=r+8|0;f[J>>2]=0;f[J+4>>2]=0;f[t>>2]=o;f[v>>2]=x;J=I<<2;f[x>>2]=J;f[w>>2]=4;g=l+((Y(I,H)|0)<<2)|0;f[s>>2]=g;f[r>>2]=g+(0-J)+J;WS(m);J=y;f[J>>2]=0;f[J+4>>2]=0;f[n>>2]=33619968;f[z>>2]=k;LZ(m,n,h,(e|0)==1?1.0:.03125,0.0);J=f[A>>2]|0;if(J|0?(g=J+12|0,J=f[g>>2]|0,f[g>>2]=J+-1,(J|0)==1):0)_S(m);f[A>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){J=f[t>>2]|0;g=0;do{f[J+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[p>>2]|0))}g=f[v>>2]|0;if((g|0)!=(x|0))g0(g)}else{switch(d|0){case 0:{K=3;L=10;M=3;G=22;break}case 1:{K=1;L=0;M=-1;G=22;break}default:{}}if((G|0)==22){f[l>>2]=M;f[B>>2]=L;f[C>>2]=K}K=f[j+8>>2]|0;L=f[j+12>>2]|0;f[m>>2]=1124007940;f[p>>2]=2;f[o>>2]=K;f[q>>2]=L;f[c>>2]=l;f[a>>2]=l;M=r+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=o;f[v>>2]=x;M=L<<2;f[x>>2]=M;f[w>>2]=4;d=l+((Y(L,K)|0)<<2)|0;f[s>>2]=d;f[r>>2]=d+(0-M)+M;WS(m);M=y;f[M>>2]=0;f[M+4>>2]=0;f[n>>2]=33619968;f[z>>2]=j;LZ(m,n,h,1.0,0.0);M=f[A>>2]|0;if(M|0?(d=M+12|0,M=f[d>>2]|0,f[d>>2]=M+-1,(M|0)==1):0)_S(m);f[A>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){M=f[t>>2]|0;d=0;do{f[M+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[p>>2]|0))}d=f[v>>2]|0;if((d|0)!=(x|0))g0(d);switch(e|0){case 0:{N=3;O=10;P=3;G=73;break}case 1:{N=1;O=0;P=-1;G=73;break}default:{}}if((G|0)==73){f[l>>2]=P;f[B>>2]=O;f[C>>2]=N}N=f[k+8>>2]|0;C=f[k+12>>2]|0;f[m>>2]=1124007940;f[p>>2]=2;f[o>>2]=N;f[q>>2]=C;f[c>>2]=l;f[a>>2]=l;a=r+8|0;f[a>>2]=0;f[a+4>>2]=0;f[t>>2]=o;f[v>>2]=x;o=C<<2;f[x>>2]=o;f[w>>2]=4;w=l+((Y(C,N)|0)<<2)|0;f[s>>2]=w;f[r>>2]=w+(0-o)+o;WS(m);o=y;f[o>>2]=0;f[o+4>>2]=0;f[n>>2]=33619968;f[z>>2]=k;LZ(m,n,h,1.0,0.0);h=f[A>>2]|0;if(h|0?(n=h+12|0,h=f[n>>2]|0,f[n>>2]=h+-1,(h|0)==1):0)_S(m);f[A>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[t>>2]|0;t=0;do{f[c+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[p>>2]|0))}p=f[v>>2]|0;if((p|0)!=(x|0))g0(p)}p=k+36|0;x=f[p>>2]|0;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)_S(k);f[p>>2]=0;p=k+16|0;x=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[x>>2]|0)>0){p=f[k+40>>2]|0;v=0;do{f[p+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[x>>2]|0))}x=f[k+44>>2]|0;if((x|0)!=(k+48|0))g0(x);x=j+36|0;k=f[x>>2]|0;if(k|0?(v=k+12|0,k=f[v>>2]|0,f[v>>2]=k+-1,(k|0)==1):0)_S(j);f[x>>2]=0;x=j+16|0;k=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){x=f[j+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=i;return}g0(k);u=i;return}function Goa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0;j=u;u=u+208|0;k=j+144|0;l=j+88|0;m=j+72|0;n=j+16|0;o=j;p=(g|0)==1;q=(d|0)>0&p?3:g;r=(e|0)>0&p?3:g;if((i+-5|0)>>>0>=2){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,34)|0;t=270520;v=s+34|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270555,270571,96)}Y$(a,q,1,i,-1,1,0);Y$(c,r,1,i,-1,1,0);do if((d$(a)|0)==65536){p=f[a+4>>2]|0;f[k>>2]=f[p>>2];w=k+4|0;x=p+4|0;f[w>>2]=f[x>>2];y=k+8|0;f[y>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];z=f[p+36>>2]|0;f[k+36>>2]=z;f[k+40>>2]=y;y=k+48|0;A=k+44|0;f[A>>2]=y;f[y>>2]=0;f[k+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[p+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;ZS(k,p);break}}else a$(k,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[l>>2]=f[a>>2];p=l+4|0;w=a+4|0;f[p>>2]=f[w>>2];x=l+8|0;f[x>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[l+36>>2]=y;f[l+40>>2]=x;x=l+48|0;A=l+44|0;f[A>>2]=x;f[x>>2]=0;f[l+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[p>>2]=0;ZS(l,a);break}}else a$(l,c,-1);while(0);if((g|0)>31|(g&1|0)==0){f[m>>2]=0;f[m+4>>2]=0;s=tT(m,50)|0;t=270638;v=s+50|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-211,m,270555,270571,104)}g=((q|0)<(r|0)?r:q)+1|0;f[m>>2]=0;c=m+4|0;f[c>>2]=0;f[m+8>>2]=0;do if(g|0)if(g>>>0>1073741823)mCc(m);else{a=g<<2;p=VDc(a)|0;f[m>>2]=p;w=p+(g<<2)|0;f[m+8>>2]=w;XIc(p|0,0,a|0)|0;f[c>>2]=w;break}while(0);if(!((e|d|0)>-1&(e+d|0)>0)){f[n>>2]=0;f[n+4>>2]=0;s=tT(n,31)|0;t=270689;v=s+31|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,n,270555,270571,107)}g=o+8|0;w=o+4|0;a=n+36|0;p=n+16|0;x=n+4|0;A=n+40|0;y=n+44|0;z=n+48|0;B=0;do{C=(B|0)==0;D=C?k:l;E=C?d:e;F=C?q:r;if((F|0)<=(E|0)){G=31;break}switch(F|0){case 1:{C=f[m>>2]|0;H=0;I=C;J=C;G=52;break}case 3:{do if(E){C=f[m>>2]|0;if((E|0)==1){f[C>>2]=-1;K=0;L=C;M=C;break}else{f[C>>2]=1;K=-2;L=C;M=C;break}}else{C=f[m>>2]|0;f[C>>2]=1;K=2;L=C;M=C}while(0);f[L+4>>2]=K;H=2;I=L;J=M;G=52;break}default:{C=f[m>>2]|0;N=1;O=0;while(1){f[C+(O<<2)>>2]=N;if((O|0)<(F|0)){N=0;O=O+1|0}else break}O=F+~E|0;if((O|0)>0){N=f[m>>2]|0;if((F|0)<1)P=N;else{Q=0;do{R=f[N>>2]|0;S=R;T=1;U=R;while(1){R=f[N+(T<<2)>>2]|0;f[N+(T+-1<<2)>>2]=S;if((T|0)==(F|0))break;else{S=U+R|0;T=T+1|0;U=R}}Q=Q+1|0}while((Q|0)!=(O|0));P=N}}else P=C;if((E|0)>0){N=f[m>>2]|0;if((F|0)<1)V=N;else{O=0;do{Q=f[N>>2]|0;U=0-Q|0;T=1;S=Q;while(1){Q=f[N+(T<<2)>>2]|0;f[N+(T+-1<<2)>>2]=U;if((T|0)==(F|0))break;else{U=S-Q|0;T=T+1|0;S=Q}}O=O+1|0}while((O|0)!=(E|0));V=N}}else V=P}}if((G|0)==52){G=0;f[I+(H<<2)>>2]=1;V=J}Vj(n,f[D+8>>2]|0,f[D+12>>2]|0,4,V,0);if(h)W=1.0/+(1<<F+~E|0);else W=1.0;N=g;f[N>>2]=0;f[N+4>>2]=0;f[o>>2]=33619968;f[w>>2]=D;LZ(n,o,i,W,0.0);N=f[a>>2]|0;if(N|0?(O=N+12|0,N=f[O>>2]|0,f[O>>2]=N+-1,(N|0)==1):0)_S(n);f[a>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[x>>2]|0)>0){N=f[A>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[x>>2]|0))}O=f[y>>2]|0;if((O|0)!=(z|0))g0(O);B=B+1|0}while((B|0)<2);if((G|0)==31){f[n>>2]=0;f[n+4>>2]=0;s=tT(n,13)|0;t=270721;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,n,270555,270571,115)}n=f[m>>2]|0;if(n|0){m=f[c>>2]|0;if((m|0)!=(n|0))f[c>>2]=m+(~((m+-4-n|0)>>>2)<<2);YDc(n)}n=l+36|0;m=f[n>>2]|0;if(m|0?(c=m+12|0,m=f[c>>2]|0,f[c>>2]=m+-1,(m|0)==1):0)_S(l);f[n>>2]=0;n=l+16|0;m=l+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[m>>2]|0)>0){n=f[l+40>>2]|0;c=0;do{f[n+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))g0(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(c=l+12|0,l=f[c>>2]|0,f[c>>2]=l+-1,(l|0)==1):0)_S(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[k+40>>2]|0;c=0;do{f[m+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)==(k+48|0)){u=j;return}g0(l);u=j;return}function Hoa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=u;u=u+320|0;l=k+264|0;m=k+256|0;n=k+200|0;o=k+144|0;p=k+88|0;q=k+80|0;r=k+72|0;s=k+56|0;t=k+32|0;v=k+16|0;w=k;x=k+48|0;y=c$(a,-1)|0;z=y&7;A=(c|0)<0?z:c;b$(m,a,-1);v$(b,m,A&7|y&4088,-1,0,0);y=(A|0)<(z|0)?z:A;z=(y|0)>5?y:5;f[n>>2]=1124007936;y=n+4|0;m=n+8|0;c=n+40|0;B=y;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[c>>2]=m;m=n+48|0;D=n+44|0;f[D>>2]=m;f[m>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;E=o+4|0;F=o+8|0;G=o+40|0;B=E;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[G>>2]=F;F=o+48|0;B=o+44|0;f[B>>2]=F;f[F>>2]=0;f[o+52>>2]=0;C=l+8|0;f[C>>2]=0;f[C+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;C=p+8|0;f[C>>2]=0;f[C+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=o;if((g|0)<1)Foa(l,p,d,e,0,z);else Goa(l,p,d,e,g,0,z);do if(h!=1.0)if(!d){z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;LZ(n,l,-1,h,0.0);break}else{z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=o;LZ(o,l,-1,h,0.0);break}while(0);do if((d$(a)|0)==65536){d=f[a+4>>2]|0;f[l>>2]=f[d>>2];z=l+4|0;g=d+4|0;f[z>>2]=f[g>>2];e=l+8|0;f[e>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];C=f[d+36>>2]|0;f[l+36>>2]=C;f[l+40>>2]=e;e=l+48|0;H=l+44|0;f[H>>2]=e;f[e>>2]=0;f[l+52>>2]=0;if(C|0){e=C+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[g>>2]|0)<3){g=f[d+44>>2]|0;e=f[H>>2]|0;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];break}else{f[z>>2]=0;ZS(l,d);break}}else a$(l,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[p>>2]=f[a>>2];d=p+4|0;z=a+4|0;f[d>>2]=f[z>>2];g=p+8|0;f[g>>2]=f[a+8>>2];f[p+12>>2]=f[a+12>>2];f[p+16>>2]=f[a+16>>2];f[p+20>>2]=f[a+20>>2];f[p+24>>2]=f[a+24>>2];f[p+28>>2]=f[a+28>>2];f[p+32>>2]=f[a+32>>2];e=f[a+36>>2]|0;f[p+36>>2]=e;f[p+40>>2]=g;g=p+48|0;H=p+44|0;f[H>>2]=g;f[g>>2]=0;f[p+52>>2]=0;if(e|0){g=e+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;g=f[H>>2]|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];break}else{f[d>>2]=0;ZS(p,a);break}}else a$(p,b,-1);while(0);f[q>>2]=0;f[q+4>>2]=0;b=f[l+8>>2]|0;f[r>>2]=f[l+12>>2];f[r+4>>2]=b;if(!(j&16))jT(l,r,q);q=l+16|0;r=l+44|0;b=p+16|0;a=p+44|0;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=l;d=t+8|0;f[d>>2]=0;f[d+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=n;f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=o;f[x>>2]=-1;f[x+4>>2]=-1;lwa(s,t,A,v,w,x,i,j);j=p+36|0;x=f[j>>2]|0;if(x|0?(w=x+12|0,x=f[w>>2]|0,f[w>>2]=x+-1,(x|0)==1):0)_S(p);f[j>>2]=0;j=p+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[j>>2]|0)>0){b=f[p+40>>2]|0;x=0;do{f[b+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[j>>2]|0))}j=f[a>>2]|0;if((j|0)!=(p+48|0))g0(j);j=l+36|0;p=f[j>>2]|0;if(p|0?(a=p+12|0,p=f[a>>2]|0,f[a>>2]=p+-1,(p|0)==1):0)_S(l);f[j>>2]=0;j=l+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[l+40>>2]|0;p=0;do{f[q+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}j=f[r>>2]|0;if((j|0)!=(l+48|0))g0(j);j=o+36|0;l=f[j>>2]|0;if(l|0?(r=l+12|0,l=f[r>>2]|0,f[r>>2]=l+-1,(l|0)==1):0)_S(o);f[j>>2]=0;j=o+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[E>>2]|0)>0){j=f[G>>2]|0;G=0;do{f[j+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[B>>2]|0;if((E|0)!=(F|0))g0(E);E=n+36|0;F=f[E>>2]|0;if(F|0?(B=F+12|0,F=f[B>>2]|0,f[B>>2]=F+-1,(F|0)==1):0)_S(n);f[E>>2]=0;E=n+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[y>>2]|0)>0){E=f[c>>2]|0;c=0;do{f[E+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[y>>2]|0))}y=f[D>>2]|0;if((y|0)==(m|0)){u=k;return}g0(y);u=k;return}function Ioa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=u;u=u+320|0;k=j+264|0;l=j+256|0;m=j+200|0;n=j+144|0;o=j+88|0;p=j+80|0;q=j+72|0;r=j+56|0;s=j+32|0;t=j+16|0;v=j;w=j+48|0;x=c$(a,-1)|0;y=x&7;z=(c|0)<0?y:c;b$(l,a,-1);v$(b,l,z&7|x&4088,-1,0,0);x=(z|0)<(y|0)?y:z;y=(x|0)>5?x:5;f[m>>2]=1124007936;x=m+4|0;l=m+8|0;c=m+40|0;A=x;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[c>>2]=l;l=m+48|0;C=m+44|0;f[C>>2]=l;f[l>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;D=n+4|0;E=n+8|0;F=n+40|0;A=D;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[F>>2]=E;E=n+48|0;A=n+44|0;f[A>>2]=E;f[E>>2]=0;f[n+52>>2]=0;B=k+8|0;f[B>>2]=0;f[B+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=m;B=o+8|0;f[B>>2]=0;f[B+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=n;Foa(k,o,d,e,0,y);do if(g!=1.0)if(!d){y=k+8|0;f[y>>2]=0;f[y+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=m;LZ(m,k,-1,g,0.0);break}else{y=k+8|0;f[y>>2]=0;f[y+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=n;LZ(n,k,-1,g,0.0);break}while(0);do if((d$(a)|0)==65536){d=f[a+4>>2]|0;f[k>>2]=f[d>>2];y=k+4|0;e=d+4|0;f[y>>2]=f[e>>2];B=k+8|0;f[B>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];f[k+16>>2]=f[d+16>>2];f[k+20>>2]=f[d+20>>2];f[k+24>>2]=f[d+24>>2];f[k+28>>2]=f[d+28>>2];f[k+32>>2]=f[d+32>>2];G=f[d+36>>2]|0;f[k+36>>2]=G;f[k+40>>2]=B;B=k+48|0;H=k+44|0;f[H>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(G|0){B=G+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[e>>2]|0)<3){e=f[d+44>>2]|0;B=f[H>>2]|0;f[B>>2]=f[e>>2];f[B+4>>2]=f[e+4>>2];break}else{f[y>>2]=0;ZS(k,d);break}}else a$(k,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[o>>2]=f[a>>2];d=o+4|0;y=a+4|0;f[d>>2]=f[y>>2];e=o+8|0;f[e>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[o+36>>2]=B;f[o+40>>2]=e;e=o+48|0;H=o+44|0;f[H>>2]=e;f[e>>2]=0;f[o+52>>2]=0;if(B|0){e=B+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;e=f[H>>2]|0;f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];break}else{f[d>>2]=0;ZS(o,a);break}}else a$(o,b,-1);while(0);f[p>>2]=0;f[p+4>>2]=0;b=f[k+8>>2]|0;f[q>>2]=f[k+12>>2];f[q+4>>2]=b;if(!(i&16))jT(k,q,p);p=k+16|0;q=k+44|0;b=o+16|0;a=o+44|0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=k;d=s+8|0;f[d>>2]=0;f[d+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=m;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=n;f[w>>2]=-1;f[w+4>>2]=-1;lwa(r,s,z,t,v,w,h,i);i=o+36|0;w=f[i>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)_S(o);f[i>>2]=0;i=o+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[o+40>>2]|0;w=0;do{f[b+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}i=f[a>>2]|0;if((i|0)!=(o+48|0))g0(i);i=k+36|0;o=f[i>>2]|0;if(o|0?(a=o+12|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0)_S(k);f[i>>2]=0;i=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[i>>2]|0)>0){p=f[k+40>>2]|0;o=0;do{f[p+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[i>>2]|0))}i=f[q>>2]|0;if((i|0)!=(k+48|0))g0(i);i=n+36|0;k=f[i>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)_S(n);f[i>>2]=0;i=n+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[D>>2]|0)>0){i=f[F>>2]|0;F=0;do{f[i+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[D>>2]|0))}D=f[A>>2]|0;if((D|0)!=(E|0))g0(D);D=m+36|0;E=f[D>>2]|0;if(E|0?(A=E+12|0,E=f[A>>2]|0,f[A>>2]=E+-1,(E|0)==1):0)_S(m);f[D>>2]=0;D=m+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[x>>2]|0)>0){D=f[c>>2]|0;c=0;do{f[D+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[x>>2]|0))}x=f[C>>2]|0;if((x|0)==(l|0)){u=j;return}g0(x);u=j;return}function Joa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;i=u;u=u+608|0;j=i+584|0;k=i+512|0;l=i;m=i+504|0;n=i+496|0;o=i+432|0;p=i+368|0;q=i+312|0;r=i+256|0;s=i+248|0;t=i+240|0;v=i+232|0;w=i+488|0;x=i+224|0;y=i+424|0;z=i+168|0;A=i+112|0;B=i+56|0;C=c$(a,-1)|0;D=C&7;E=C>>>3&511;F=E+1|0;G=(c|0)<0?D:c;b$(m,a,-1);c=E<<3;v$(b,m,G&7|c,-1,0,0);if((d|2|0)==3){m=(d|0)==3;H=k;E=57772;I=H+72|0;do{f[H>>2]=f[E>>2];H=H+4|0;E=E+4|0}while((H|0)<(I|0));J=m&1;m=k+(J*36|0)|0;f[l>>2]=1124007941;K=l+4|0;f[K>>2]=2;L=l+8|0;f[L>>2]=3;f[l+12>>2]=3;M=l+16|0;f[M>>2]=m;f[l+20>>2]=m;m=l+24|0;N=l+40|0;O=m+8|0;f[O>>2]=0;f[O+4>>2]=0;f[N>>2]=L;L=l+48|0;O=l+44|0;f[O>>2]=L;f[L>>2]=12;f[l+52>>2]=4;P=k+(J*36|0)+36|0;f[l+28>>2]=P;f[m>>2]=P;WS(l);P=e!=1.0;if(P){m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;LZ(l,j,-1,e,0.0)}m=l+36|0;Q=f[m>>2]|0;if(Q|0?(R=Q+12|0,Q=f[R>>2]|0,f[R>>2]=Q+-1,(Q|0)==1):0)_S(l);f[m>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[K>>2]|0)>0){M=f[N>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[O>>2]|0;if((K|0)!=(L|0))g0(K);H=k;E=57772;I=H+72|0;do{f[H>>2]=f[E>>2];H=H+4|0;E=E+4|0}while((H|0)<(I|0));E=k+(J*36|0)|0;f[l>>2]=1124007941;K=l+4|0;f[K>>2]=2;L=l+8|0;f[L>>2]=3;f[l+12>>2]=3;O=l+16|0;f[O>>2]=E;f[l+20>>2]=E;E=l+24|0;N=l+40|0;M=E+8|0;f[M>>2]=0;f[M+4>>2]=0;f[N>>2]=L;L=l+48|0;M=l+44|0;f[M>>2]=L;f[L>>2]=12;f[l+52>>2]=4;m=k+(J*36|0)+36|0;f[l+28>>2]=m;f[E>>2]=m;WS(l);if(P){P=j+8|0;f[P>>2]=0;f[P+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;LZ(l,j,-1,e,0.0)}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=l;f[n>>2]=-1;f[n+4>>2]=-1;kwa(a,b,G,j,n,g,h);n=l+36|0;P=f[n>>2]|0;if(P|0?(m=P+12|0,P=f[m>>2]|0,f[m>>2]=P+-1,(P|0)==1):0)_S(l);f[n>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[K>>2]|0)>0){O=f[N>>2]|0;N=0;do{f[O+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[M>>2]|0;if((K|0)!=(L|0))g0(K);u=i;return}K=(G|0)<(D|0)?D:G;L=(K|0)>5?K:5;K=((d|0)<6&(D|0)==0?3:D>>>0<6?5:6)|c;f[o>>2]=1124007936;c=o+4|0;M=o+8|0;N=o+40|0;H=c;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[N>>2]=M;O=o+48|0;n=o+44|0;f[n>>2]=O;f[O>>2]=0;f[o+52>>2]=0;f[p>>2]=1124007936;P=p+4|0;m=p+8|0;E=p+40|0;H=P;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[E>>2]=m;m=p+48|0;J=p+44|0;f[J>>2]=m;f[m>>2]=0;f[p+52>>2]=0;Q=j+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=o;Q=k+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=p;Goa(j,k,2,0,d,0,L);do if((d$(a)|0)==65536){L=f[a+4>>2]|0;f[q>>2]=f[L>>2];d=q+4|0;Q=L+4|0;f[d>>2]=f[Q>>2];R=q+8|0;f[R>>2]=f[L+8>>2];f[q+12>>2]=f[L+12>>2];f[q+16>>2]=f[L+16>>2];f[q+20>>2]=f[L+20>>2];f[q+24>>2]=f[L+24>>2];f[q+28>>2]=f[L+28>>2];f[q+32>>2]=f[L+32>>2];S=f[L+36>>2]|0;f[q+36>>2]=S;f[q+40>>2]=R;R=q+48|0;T=q+44|0;f[T>>2]=R;f[R>>2]=0;f[q+52>>2]=0;if(S|0){R=S+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[Q>>2]|0)<3){Q=f[L+44>>2]|0;R=f[T>>2]|0;f[R>>2]=f[Q>>2];f[R+4>>2]=f[Q+4>>2];break}else{f[d>>2]=0;ZS(q,L);break}}else a$(q,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[r>>2]=f[a>>2];L=r+4|0;d=a+4|0;f[L>>2]=f[d>>2];Q=r+8|0;f[Q>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];R=f[a+36>>2]|0;f[r+36>>2]=R;f[r+40>>2]=Q;Q=r+48|0;T=r+44|0;f[T>>2]=Q;f[Q>>2]=0;f[r+52>>2]=0;if(R|0){Q=R+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[d>>2]|0)<3){d=f[a+44>>2]|0;Q=f[T>>2]|0;f[Q>>2]=f[d>>2];f[Q+4>>2]=f[d+4>>2];break}else{f[L>>2]=0;ZS(r,a);break}}else a$(r,b,-1);while(0);f[s>>2]=0;f[s+4>>2]=0;b=q+12|0;a=q+8|0;L=f[a>>2]|0;f[t>>2]=f[b>>2];f[t+4>>2]=L;if(!(h&16))jT(q,t,s);L=h&-17;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=o;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=p;f[w>>2]=-1;f[w+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Hua(v,C,K,j,k,w,0.0,L,L,l);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=p;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=o;f[y>>2]=-1;f[y+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Hua(x,C,K,j,k,y,0.0,L,L,l);L=v+4|0;y=f[L>>2]|0;C=hh[f[(f[y>>2]|0)+12>>2]&127](y,q,t,s)|0;y=x+4|0;w=f[y>>2]|0;hh[f[(f[w>>2]|0)+12>>2]&127](w,q,t,s)|0;s=q+16|0;t=q+44|0;w=(f[s>>2]|0)+(Y(f[f[t>>2]>>2]|0,C)|0)|0;C=f[b>>2]|0;h=Y(C,F<<(47696>>>(D<<1)&3))|0;D=f[a>>2]|0;F=h>>>0>16384?1:16384/(h>>>0)|0;h=(D|0)<(F|0)?D:F;F=(f[M>>2]|0)+-1+h|0;f[z>>2]=1124007936;D=z+4|0;d=z+8|0;Q=z+40|0;H=D;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Q>>2]=d;T=z+48|0;R=z+44|0;f[R>>2]=T;f[T>>2]=0;f[z+52>>2]=0;f[j>>2]=F;F=j+4|0;f[F>>2]=C;XS(z,2,j,K);C=h+-1+(f[M>>2]|0)|0;M=f[b>>2]|0;f[A>>2]=1124007936;b=A+4|0;S=A+8|0;U=A+40|0;H=b;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[U>>2]=S;H=A+48|0;I=A+44|0;f[I>>2]=H;f[H>>2]=0;f[A+52>>2]=0;f[j>>2]=C;f[F>>2]=M;XS(A,2,j,K);if((f[a>>2]|0)>0){K=q+48|0;M=z+16|0;F=A+16|0;C=j+4|0;V=k+4|0;W=j+8|0;X=j+12|0;Z=j+4|0;_=k+8|0;$=k+12|0;aa=k+4|0;ba=l+8|0;ca=l+4|0;da=j+8|0;ea=j+4|0;fa=B+36|0;ga=B+16|0;ha=B+4|0;ia=B+40|0;ja=B+44|0;ka=B+48|0;la=w;w=0;ma=f[K>>2]|0;while(1){na=f[L>>2]|0;xg[f[(f[na>>2]|0)+16>>2]&127](na,la,ma,h,f[M>>2]|0,f[T>>2]|0)|0;na=f[y>>2]|0;oa=xg[f[(f[na>>2]|0)+16>>2]&127](na,la,f[K>>2]|0,h,f[F>>2]|0,f[H>>2]|0)|0;if((oa|0)>0){na=oa+w|0;f[j>>2]=w;f[C>>2]=na;f[k>>2]=-2147483648;f[V>>2]=2147483647;$S(B,r,j,k);f[S>>2]=oa;f[d>>2]=oa;f[W>>2]=0;f[X>>2]=0;f[j>>2]=16842752;f[Z>>2]=z;f[_>>2]=0;f[$>>2]=0;f[k>>2]=16842752;f[aa>>2]=A;pa=ba;f[pa>>2]=0;f[pa+4>>2]=0;f[l>>2]=33619968;f[ca>>2]=z;mL(j,k,l,e0()|0,-1);pa=da;f[pa>>2]=0;f[pa+4>>2]=0;f[j>>2]=33619968;f[ea>>2]=B;LZ(z,j,G,e,g);pa=f[fa>>2]|0;if(pa|0?(qa=pa+12|0,pa=f[qa>>2]|0,f[qa>>2]=pa+-1,(pa|0)==1):0)_S(B);f[fa>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ha>>2]|0)>0){pa=f[ia>>2]|0;qa=0;do{f[pa+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[ha>>2]|0))}qa=f[ja>>2]|0;if((qa|0)!=(ka|0))g0(qa);ra=na}else ra=oa+w|0;ma=f[K>>2]|0;la=la+(Y(ma,h)|0)|0;if((ra|0)>=(f[a>>2]|0))break;else w=ra}}ra=A+36|0;w=f[ra>>2]|0;if(w|0?(a=w+12|0,w=f[a>>2]|0,f[a>>2]=w+-1,(w|0)==1):0)_S(A);f[ra>>2]=0;ra=A+16|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[b>>2]|0)>0){ra=f[U>>2]|0;U=0;do{f[ra+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[b>>2]|0))}b=f[I>>2]|0;if((b|0)!=(H|0))g0(b);b=z+36|0;H=f[b>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)_S(z);f[b>>2]=0;b=z+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[D>>2]|0)>0){b=f[Q>>2]|0;Q=0;do{f[b+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[D>>2]|0))}D=f[R>>2]|0;if((D|0)!=(T|0))g0(D);D=f[x>>2]|0;if(D|0?(x=D+4|0,T=f[x>>2]|0,f[x>>2]=T+-1,(T|0)==1):0)Yi[f[(f[D>>2]|0)+8>>2]&2047](D);D=f[v>>2]|0;if(D|0?(v=D+4|0,T=f[v>>2]|0,f[v>>2]=T+-1,(T|0)==1):0)Yi[f[(f[D>>2]|0)+8>>2]&2047](D);D=r+36|0;T=f[D>>2]|0;if(T|0?(v=T+12|0,T=f[v>>2]|0,f[v>>2]=T+-1,(T|0)==1):0)_S(r);f[D>>2]=0;D=r+16|0;T=r+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[T>>2]|0)>0){D=f[r+40>>2]|0;v=0;do{f[D+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[T>>2]|0))}T=f[r+44>>2]|0;if((T|0)!=(r+48|0))g0(T);T=q+36|0;r=f[T>>2]|0;if(r|0?(v=r+12|0,r=f[v>>2]|0,f[v>>2]=r+-1,(r|0)==1):0)_S(q);f[T>>2]=0;T=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[T>>2]|0)>0){s=f[q+40>>2]|0;r=0;do{f[s+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[T>>2]|0))}T=f[t>>2]|0;if((T|0)!=(q+48|0))g0(T);T=p+36|0;q=f[T>>2]|0;do if(q|0){t=q+12|0;r=f[t>>2]|0;f[t>>2]=r+-1;if((r|0)!=1)break;_S(p)}while(0);f[T>>2]=0;T=p+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[P>>2]|0)>0){T=f[E>>2]|0;E=0;do{f[T+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[P>>2]|0))}P=f[J>>2]|0;if((P|0)!=(m|0))g0(P);P=o+36|0;m=f[P>>2]|0;do if(m|0){J=m+12|0;E=f[J>>2]|0;f[J>>2]=E+-1;if((E|0)!=1)break;_S(o)}while(0);f[P>>2]=0;P=o+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[c>>2]|0)>0){P=f[N>>2]|0;N=0;do{f[P+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[c>>2]|0))}c=f[n>>2]|0;if((c|0)!=(O|0))g0(c);u=i;return}function Koa(){var a=0;if(((((Loa(1,0)|0)!=0?(Loa(1,1)|0)!=0:0)?(Loa(2,0)|0)!=0:0)?(Loa(2,1)|0)!=0:0)?(Loa(4,0)|0)!=0:0)a=(Loa(4,1)|0)!=0&1;else a=0;b[1150602]=a;return}function Loa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;e=u;u=u+1072|0;g=e+1064|0;h=e;switch(a|0){case 1:{i=861568;k=1051008;l=2;break}case 2:{i=533888;k=887168;l=4;break}case 4:{i=599424;k=919936;l=8;break}default:{f[g>>2]=0;f[g+4>>2]=0;m=tT(g,38)|0;o=270785;p=m+38|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-5,g,270824,270839,226)}}q=1150603+a|0;if(b[q>>0]|0){r=i;s=k;t=c?s:r;u=e;return t|0}v=h+8|0;f[h>>2]=v;w=h+4|0;f[w>>2]=256;switch(a|0){case 1:{a=0;x=v;while(1){y=+(a|0)*.03125;n[x>>2]=1.0-y;n[x+4>>2]=y;a=a+1|0;if((a|0)==32){z=v;break}else x=x+8|0}break}case 2:{x=0;a=v;while(1){y=+(x|0)*.03125;A=y+1.0;B=A*(A*(3.75-A*.75)+-6.0)+3.0;n[a>>2]=B;A=y*(y*(y*1.25+-2.25))+1.0;n[a+4>>2]=A;C=1.0-y;y=C*(C*(C*1.25+-2.25))+1.0;n[a+8>>2]=y;n[a+12>>2]=1.0-B-A-y;x=x+1|0;if((x|0)==32){z=v;break}else a=a+16|0}break}case 4:{a=0;x=v;while(1){y=+(a|0)*.03125;if(y<1.1920928955078125e-07){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;D=1.0}else{A=y+3.0;y=-A*3.141592653589793*.25;B=+P(+y);C=+O(+y);E=C*0.0;F=(B+E)/(y*y);y=-(A+-1.0)*3.141592653589793*.25;G=B*-.7071067811865476;H=C*-.7071067811865476;I=(G+H)/(y*y);y=-(A+-2.0)*3.141592653589793*.25;J=B*0.0;K=(J+C)/(y*y);y=-(A+-3.0)*3.141592653589793*.25;L=B*.7071067811865476;M=(L+H)/(y*y);y=-(A+-4.0)*3.141592653589793*.25;H=(E-B)/(y*y);y=-(A+-5.0)*3.141592653589793*.25;B=C*.7071067811865476;E=(L+B)/(y*y);y=-(A+-6.0)*3.141592653589793*.25;L=(J-C)/(y*y);y=-(A+-7.0)*3.141592653589793*.25;A=(G+B)/(y*y);y=1.0/(A+(L+(E+(H+(M+(K+(I+(F+0.0))))))));n[x>>2]=F*y;n[x+4>>2]=I*y;n[x+8>>2]=K*y;n[x+16>>2]=H*y;n[x+20>>2]=E*y;n[x+24>>2]=L*y;n[x+28>>2]=A*y;D=M*y}n[x+12>>2]=D;a=a+1|0;if((a|0)==32)break;else x=x+32|0}z=f[h>>2]|0;break}default:{f[g>>2]=0;f[g+4>>2]=0;m=tT(g,28)|0;o=270908;p=m+28|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));z5(-5,g,270937,270839,209)}}g=Y(l,l)|0;o=l>>>1;m=g<<5;p=g<<10;x=i+(p<<2)|0;a=Y(o,l)|0;N=o+a|0;Q=o+1|0;R=Q+a|0;S=Y(Q,l)|0;T=o+S|0;U=Q+S|0;S=0;V=i;i=k;while(1){W=S<<5;X=(S|0)<16&1;Z=Y(S,l)|0;_=0;$=V;V=V+(m<<2)|0;aa=i;while(1){ba=_+W|0;b[1150611+(ba<<1)>>0]=(_|0)<16&1;b[1150611+(ba<<1)+1>>0]=X;ba=Y(_,l)|0;ca=0;da=0;while(1){D=+n[z+(da+Z<<2)>>2];ea=Y(da,l)|0;fa=0;ga=ca;do{y=D*+n[z+(fa+ba<<2)>>2];ha=fa+ea|0;n[$+(ha<<2)>>2]=y;ia=mrc(y*32768.0)|0;ja=(ia+32768|0)>>>0<65536?ia:(ia|0)>0?32767:32768;d[aa+(ha<<1)>>1]=ja;ga=(ja<<16>>16)+ga|0;fa=fa+1|0}while((fa|0)<(l|0));da=da+1|0;if((da|0)>=(l|0))break;else ca=ga}if((ga|0)!=32768){ca=d[aa+(N<<1)>>1]|0;da=d[aa+(R<<1)>>1]|0;ba=da<<16>>16<ca<<16>>16;fa=ba?o:da<<16>>16>ca<<16>>16?Q:o;ca=ba?Q:o;ba=d[aa+(T<<1)>>1]|0;if(ba<<16>>16<(d[aa+(a+ca<<1)>>1]|0)){ka=o;la=Q;ma=fa;na=o}else{da=ba<<16>>16>(d[aa+(a+fa<<1)>>1]|0);ka=ca;la=o;ma=da?o:fa;na=da?Q:o}da=d[aa+(U<<1)>>1]|0;fa=aa+((Y(la,l)|0)+ka<<1)|0;if(da<<16>>16<(d[fa>>1]|0)){oa=Q;pa=Q;qa=ma;ra=na}else{fa=aa+((Y(na,l)|0)+ma<<1)|0;ca=da<<16>>16>(d[fa>>1]|0);oa=ka;pa=la;qa=ca?Q:ma;ra=ca?Q:na}if((ga|0)<32768){ca=(Y(ra,l)|0)+qa|0;sa=d[aa+(ca<<1)>>1]|0;ta=ca}else{ca=(Y(pa,l)|0)+oa|0;sa=j[aa+(ca<<1)>>1]|0;ta=ca}d[aa+(ta<<1)>>1]=-32768-ga+sa}_=_+1|0;if((_|0)==32)break;else{$=$+(g<<2)|0;aa=aa+(g<<1)|0}}S=S+1|0;if((S|0)==32)break;else i=i+(m<<1)|0}m=Y(Y(l,-1024)|0,l)|0;l=x+(m<<2)|0;x=k+(p<<1)+(m<<1)|0;b[q>>0]=1;if((z|0)!=(v|0)){if(z|0)ZDc(z);f[h>>2]=v;f[w>>2]=264}r=l;s=x;t=c?s:r;u=e;return t|0}function Moa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;j=u;u=u+368|0;k=j;l=j+304|0;m=j+240|0;n=j+184|0;o=j+296|0;q=j+128|0;r=j+72|0;if(r$(d)|0){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,14)|0;t=270952;v=s+14|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1708)}if(!(r$(e)|0)?(b$(k,e,-1),b$(l,d,-1),!((f[k>>2]|0)==(f[l>>2]|0)?(f[k+4>>2]|0)==(f[l+4>>2]|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,47)|0;t=270973;v=s+47|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1709)}do if((d$(a)|0)==65536){w=f[a+4>>2]|0;f[l>>2]=f[w>>2];x=l+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=l+8|0;f[z>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];f[l+16>>2]=f[w+16>>2];f[l+20>>2]=f[w+20>>2];f[l+24>>2]=f[w+24>>2];f[l+28>>2]=f[w+28>>2];f[l+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[l+36>>2]=A;f[l+40>>2]=z;z=l+48|0;B=l+44|0;f[B>>2]=z;f[z>>2]=0;f[l+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(l,w);break}}else a$(l,a,-1);while(0);do if((d$(d)|0)==65536){w=f[d+4>>2]|0;f[m>>2]=f[w>>2];x=m+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[w+8>>2];f[m+12>>2]=f[w+12>>2];f[m+16>>2]=f[w+16>>2];f[m+20>>2]=f[w+20>>2];f[m+24>>2]=f[w+24>>2];f[m+28>>2]=f[w+28>>2];f[m+32>>2]=f[w+32>>2];B=f[w+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=z;z=m+48|0;A=m+44|0;f[A>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(B|0){z=B+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[A>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(m,w);break}}else a$(m,d,-1);while(0);do if((d$(e)|0)==65536){d=f[e+4>>2]|0;f[n>>2]=f[d>>2];w=n+4|0;x=d+4|0;f[w>>2]=f[x>>2];y=n+8|0;f[y>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];z=f[d+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=y;y=n+48|0;A=n+44|0;f[A>>2]=y;f[y>>2]=0;f[n+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[d+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;ZS(n,d);break}}else a$(n,e,-1);while(0);e=m+40|0;d=f[e>>2]|0;w=f[d>>2]|0;f[o>>2]=f[d+4>>2];f[o+4>>2]=w;v$(c,o,f[l>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){o=f[c+4>>2]|0;f[q>>2]=f[o>>2];w=q+4|0;d=o+4|0;f[w>>2]=f[d>>2];x=q+8|0;f[x>>2]=f[o+8>>2];y=q+12|0;f[y>>2]=f[o+12>>2];f[q+16>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2];f[q+24>>2]=f[o+24>>2];f[q+28>>2]=f[o+28>>2];f[q+32>>2]=f[o+32>>2];A=f[o+36>>2]|0;f[q+36>>2]=A;f[q+40>>2]=x;x=q+48|0;z=q+44|0;f[z>>2]=x;f[x>>2]=0;f[q+52>>2]=0;if(A|0){x=A+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[d>>2]|0)<3){d=f[o+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[d>>2];f[x+4>>2]=f[d+4>>2];C=y;break}else{f[w>>2]=0;ZS(q,o);C=y;break}}else{a$(q,c,-1);C=q+12|0}while(0);if((f[C>>2]|0)>=32767){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,88)|0;s=E;t=271021;v=s+88|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1729)}c=q+8|0;if((f[c>>2]|0)>=32767){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,88)|0;s=E;t=271021;v=s+88|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1729)}y=l+12|0;if((f[y>>2]|0)>=32767){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,88)|0;s=E;t=271021;v=s+88|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1729)}o=l+8|0;if((f[o>>2]|0)>=32767){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,88)|0;s=E;t=271021;v=s+88|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1729)}E=q+16|0;D=l+16|0;if((f[E>>2]|0)==(f[D>>2]|0)){f[r>>2]=1124007936;w=r+4|0;d=r+8|0;x=r+40|0;s=w;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[x>>2]=d;z=r+48|0;A=r+44|0;f[A>>2]=z;f[z>>2]=0;f[r+52>>2]=0;B=k+8|0;f[B>>2]=0;f[B+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=r;h_(l,k);B=r+36|0;F=f[B>>2]|0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}G=l+36|0;F=f[G>>2]|0;if(F|0?(H=F+12|0,F=f[H>>2]|0,f[H>>2]=F+-1,(F|0)==1):0)_S(l);f[G>>2]=0;F=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[F>>2]|0)>0){H=f[l+40>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0;J=f[F>>2]|0}while((I|0)<(J|0));f[l>>2]=f[r>>2];if((J|0)<3)K=50;else K=52}else{f[l>>2]=f[r>>2];K=50}if((K|0)==50){J=f[w>>2]|0;if((J|0)<3){f[F>>2]=J;f[o>>2]=f[d>>2];f[y>>2]=f[r+12>>2];y=f[A>>2]|0;d=f[l+44>>2]|0;f[d>>2]=f[y>>2];f[d+4>>2]=f[y+4>>2]}else K=52}if((K|0)==52)ZS(l,r);y=r+16|0;f[D>>2]=f[y>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];d=f[B>>2]|0;f[G>>2]=d;if(d|0?(G=d+12|0,d=f[G>>2]|0,f[G>>2]=d+-1,(d|0)==1):0)_S(r);f[B>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[w>>2]|0)>0){y=f[x>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[w>>2]|0))}w=f[A>>2]|0;if((w|0)!=(z|0))g0(w)}w=(g|0)==3?1:g;g=f[l>>2]&7;z=(g|0)==0;switch(w|0){case 0:{A=f[57844+(g<<2)>>2]|0;if((g|0)==7){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,11)|0;t=271110;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1789)}else{L=0;M=A;N=0}break}case 1:{O=f[57876+(g<<2)>>2]|0;K=71;break}case 2:{A=f[57908+(g<<2)>>2]|0;if((q$(a,-1)|0)<5){O=A;K=71}else{f[k>>2]=0;f[k+4>>2]=0;s=tT(k,20)|0;t=271122;v=s+20|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1797)}break}case 4:{A=f[57940+(g<<2)>>2]|0;if((q$(a,-1)|0)<5){O=A;K=71}else{f[k>>2]=0;f[k+4>>2]=0;s=tT(k,20)|0;t=271122;v=s+20|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1801)}break}default:{f[k>>2]=0;f[k+4>>2]=0;s=tT(k,28)|0;t=270908;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-5,k,270967,270839,1804)}}do if((K|0)==71)if(!O){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,10)|0;t=271143;v=s+10|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1805)}else{L=Loa(w,z)|0;M=0;N=O;break}while(0);O=m;z=n;w=f[m>>2]|0;A=w&4095;a=(A|0)==11;g=f[n>>2]|0;if(a)if((g&4094|0)!=2?(f[n+16>>2]|0)!=0:0){x=f[n+4>>2]|0;if((x|0)<3)P=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{y=f[n+40>>2]|0;B=0;d=1;while(1){G=Y(f[y+(B<<2)>>2]|0,d)|0;B=B+1|0;if((B|0)==(x|0)){P=G;break}else d=G}}if(!((x|0)==0|(P|0)==0))K=82;else K=90}else K=90;else K=82;do if((K|0)==82){P=g&4095;if((P|0)==11){if((w&4094|0)==2){K=90;break}if(!(f[m+16>>2]|0)){K=90;break}x=f[m+4>>2]|0;if((x|0)<3)Q=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{d=f[e>>2]|0;B=0;y=1;while(1){G=Y(f[d+(B<<2)>>2]|0,y)|0;B=B+1|0;if((B|0)==(x|0)){Q=G;break}else y=G}}if((x|0)==0|(Q|0)==0){K=90;break}}switch(w&4095){case 11:case 13:{if(f[n+16>>2]|0){y=f[n+4>>2]|0;if((y|0)<3)R=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{B=f[n+40>>2]|0;d=0;G=1;while(1){o=Y(f[B+(d<<2)>>2]|0,G)|0;d=d+1|0;if((d|0)==(y|0)){R=o;break}else G=o}}if(!((y|0)==0|(R|0)==0))K=98}break}default:K=98}if((K|0)==98?!((A|0)==5&(P|0)==5):0){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,126)|0;t=271154;v=s+126|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,270967,270839,1820)}S=(w&4088|0)==0;T=z;U=O}while(0);if((K|0)==90){S=0;T=a?z:O;U=a?O:z}f[k>>2]=57980;f[k+4>>2]=l;f[k+8>>2]=q;f[k+12>>2]=U;f[k+16>>2]=T;f[k+20>>2]=h;p[k+24>>3]=+p[i>>3];p[k+32>>3]=+p[i+8>>3];p[k+40>>3]=+p[i+16>>3];p[k+48>>3]=+p[i+24>>3];f[k+56>>2]=S&1;f[k+60>>2]=M;f[k+64>>2]=N;f[k+68>>2]=L;L=f[c>>2]|0;f[r>>2]=0;f[r+4>>2]=L;c=q+4|0;N=f[c>>2]|0;if((N|0)<3)V=Y(f[C>>2]|0,L)|0;else{L=f[q+40>>2]|0;C=0;M=1;while(1){S=Y(f[L+(C<<2)>>2]|0,M)|0;C=C+1|0;if((C|0)==(N|0)){V=S;break}else M=S}}y8(r,k,+(V>>>0)*.0000152587890625);V=q+36|0;k=f[V>>2]|0;if(k|0?(r=k+12|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)_S(q);f[V>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[c>>2]|0)>0){E=f[q+40>>2]|0;V=0;do{f[E+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[c>>2]|0))}c=f[q+44>>2]|0;if((c|0)!=(q+48|0))g0(c);c=n+36|0;q=f[c>>2]|0;if(q|0?(V=q+12|0,q=f[V>>2]|0,f[V>>2]=q+-1,(q|0)==1):0)_S(n);f[c>>2]=0;c=n+16|0;q=n+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[n+40>>2]|0;V=0;do{f[c+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[q>>2]|0))}q=f[n+44>>2]|0;if((q|0)!=(n+48|0))g0(q);q=m+36|0;n=f[q>>2]|0;do if(n|0){V=n+12|0;c=f[V>>2]|0;f[V>>2]=c+-1;if((c|0)!=1)break;_S(m)}while(0);f[q>>2]=0;q=m+16|0;n=m+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[n>>2]|0)>0){q=f[e>>2]|0;e=0;do{f[q+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))g0(n);n=l+36|0;m=f[n>>2]|0;do if(m|0){e=m+12|0;q=f[e>>2]|0;f[e>>2]=q+-1;if((q|0)!=1)break;_S(l)}while(0);f[n>>2]=0;n=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[n>>2]|0)>0){D=f[l+40>>2]|0;m=0;do{f[D+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)==(l+48|0)){u=j;return}g0(n);u=j;return}function Noa(a){a=a|0;YDc(a);return}function Ooa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0;c=u;u=u+416|0;e=c+352|0;g=c+296|0;i=c+240|0;k=c+184|0;l=c+72|0;m=c+16|0;o=c+128|0;p=c;q=a+8|0;r=f[q>>2]|0;s=f[r+8>>2]|0;t=a+12|0;v=f[f[t>>2]>>2]&7;w=16384/(((s|0)<128?s:128)|0)|0;x=f[r+12>>2]|0;r=(x|0)<(w|0)?x:w;w=16384/(r|0)|0;x=(s|0)<(w|0)?s:w;f[g>>2]=1124007936;w=g+4|0;s=g+8|0;y=g+40|0;z=w;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[y>>2]=s;s=g+48|0;B=g+44|0;f[B>>2]=s;f[s>>2]=0;f[g+52>>2]=0;f[e>>2]=x;C=e+4|0;f[C>>2]=r;XS(g,2,e,11);f[i>>2]=1124007936;D=i+4|0;E=i+8|0;F=i+40|0;z=D;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[F>>2]=E;E=i+48|0;z=i+44|0;f[z>>2]=E;f[E>>2]=0;f[i+52>>2]=0;A=a+60|0;if(!(f[A>>2]|0)){f[e>>2]=x;f[C>>2]=r;XS(i,2,e,2)}C=f[b>>2]|0;G=b+4|0;if((C|0)<(f[G>>2]|0)){b=k+4|0;H=k+8|0;I=k+12|0;J=l+4|0;K=l+8|0;L=l+12|0;M=m+4|0;N=m+8|0;O=m+12|0;P=a+64|0;Q=a+4|0;R=a+68|0;S=a+20|0;T=a+24|0;U=l+36|0;V=l+16|0;W=l+4|0;X=l+40|0;Z=l+44|0;_=l+48|0;$=k+16|0;aa=k+44|0;ba=a+16|0;ca=p+4|0;da=p+8|0;ea=p+12|0;fa=m+36|0;ga=k+36|0;ha=k+4|0;ia=k+40|0;ja=m+4|0;ka=m+8|0;la=k+8|0;ma=m+12|0;na=k+12|0;oa=m+44|0;pa=m+16|0;qa=m+20|0;ra=k+20|0;sa=m+24|0;ta=k+24|0;ua=m+28|0;va=k+28|0;wa=m+32|0;xa=k+32|0;ya=m+40|0;za=m+48|0;Aa=a+56|0;a=k+48|0;Ba=e+36|0;Ca=e+16|0;Da=e+4|0;Ea=e+40|0;Fa=e+44|0;Ga=e+48|0;Ha=m+4|0;Ia=m+8|0;Ja=m+12|0;Ka=l+36|0;La=l+4|0;Ma=l+8|0;Na=l+12|0;Oa=l+44|0;Pa=l+16|0;Qa=l+20|0;Ra=l+24|0;Sa=l+28|0;Ta=l+32|0;Ua=l+40|0;Va=l+48|0;Wa=(v|0)==5;v=l+4|0;Xa=l+8|0;Ya=l+12|0;Za=m+8|0;_a=m+4|0;$a=o+36|0;ab=o+16|0;bb=o+4|0;cb=o+40|0;db=o+44|0;eb=o+48|0;fb=C;C=f[q>>2]|0;while(1){gb=f[C+12>>2]|0;if((gb|0)>0){hb=0;ib=gb;gb=C;while(1){jb=(f[G>>2]|0)-fb|0;kb=(jb|0)<(x|0)?jb:x;jb=ib-hb|0;lb=(jb|0)<(r|0)?jb:r;f[k>>2]=hb;f[b>>2]=fb;f[H>>2]=lb;f[I>>2]=kb;cT(e,gb,k);f[l>>2]=0;f[J>>2]=0;f[K>>2]=lb;f[L>>2]=kb;cT(k,g,l);if(!(f[A>>2]|0)){f[m>>2]=0;f[M>>2]=0;f[N>>2]=lb;f[O>>2]=kb;cT(l,i,m);if((kb|0)>0){jb=(lb|0)>0;mb=hb<<1;nb=0;do{ob=(f[$>>2]|0)+(Y(f[f[aa>>2]>>2]|0,nb)|0)|0;pb=(f[V>>2]|0)+(Y(f[f[Z>>2]>>2]|0,nb)|0)|0;qb=f[t>>2]|0;do if((f[qb>>2]&4095|0)==11?(f[f[ba>>2]>>2]&4094|0)==2:0){f[p>>2]=hb;f[ca>>2]=fb;f[da>>2]=lb;f[ea>>2]=kb;cT(m,qb,p);rb=f[fa>>2]|0;if(rb|0){sb=rb+12|0;f[sb>>2]=(f[sb>>2]|0)+1}sb=f[ga>>2]|0;if(sb|0?(rb=sb+12|0,sb=f[rb>>2]|0,f[rb>>2]=sb+-1,(sb|0)==1):0)_S(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){sb=f[ia>>2]|0;rb=0;do{f[sb+(rb<<2)>>2]=0;rb=rb+1|0;tb=f[ha>>2]|0}while((rb|0)<(tb|0));f[k>>2]=f[m>>2];if((tb|0)<3)ub=73;else ub=75}else{f[k>>2]=f[m>>2];ub=73}if((ub|0)==73){ub=0;rb=f[ja>>2]|0;if((rb|0)<3){f[ha>>2]=rb;f[la>>2]=f[ka>>2];f[na>>2]=f[ma>>2];rb=f[oa>>2]|0;sb=f[aa>>2]|0;f[sb>>2]=f[rb>>2];f[sb+4>>2]=f[rb+4>>2]}else ub=75}if((ub|0)==75){ub=0;ZS(k,m)}f[$>>2]=f[pa>>2];f[ra>>2]=f[qa>>2];f[ta>>2]=f[sa>>2];f[va>>2]=f[ua>>2];f[xa>>2]=f[wa>>2];rb=f[fa>>2]|0;f[ga>>2]=rb;do if(rb|0){sb=rb+12|0;vb=f[sb>>2]|0;f[sb>>2]=vb+-1;if((vb|0)!=1)break;_S(m)}while(0);f[fa>>2]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[ja>>2]|0)>0){rb=f[ya>>2]|0;vb=0;do{f[rb+(vb<<2)>>2]=0;vb=vb+1|0}while((vb|0)<(f[ja>>2]|0))}vb=f[oa>>2]|0;if((vb|0)!=(za|0))g0(vb);vb=f[ba>>2]|0;rb=(f[vb+16>>2]|0)+(Y(f[f[vb+44>>2]>>2]|0,nb+fb|0)|0)+(hb<<1)|0;if(jb)wb=0;else break;do{d[pb+(wb<<1)>>1]=d[rb+(wb<<1)>>1]&1023;wb=wb+1|0}while((wb|0)<(lb|0))}else ub=86;while(0);do if((ub|0)==86){ub=0;rb=nb+fb|0;vb=(f[qb+16>>2]|0)+(Y(f[f[qb+44>>2]>>2]|0,rb)|0)|0;if(!(f[Aa>>2]|0)){sb=vb+(mb<<2)|0;if(jb)xb=0;else break;do{yb=xb<<1;zb=mrc(+n[sb+(yb<<2)>>2]*32.0)|0;Ab=yb|1;Bb=mrc(+n[sb+(Ab<<2)>>2]*32.0)|0;Cb=zb>>5;d[ob+(yb<<1)>>1]=(Cb+32768|0)>>>0<65536?Cb:(Cb|0)>0?32767:32768;Cb=Bb>>5;d[ob+(Ab<<1)>>1]=(Cb+32768|0)>>>0<65536?Cb:(Cb|0)>0?32767:32768;d[pb+(xb<<1)>>1]=Bb<<5&992|zb&31;xb=xb+1|0}while((xb|0)<(lb|0))}else{sb=vb+(hb<<2)|0;zb=f[ba>>2]|0;Bb=(f[zb+16>>2]|0)+(Y(f[f[zb+44>>2]>>2]|0,rb)|0)+(hb<<2)|0;if(jb)Db=0;else break;do{zb=mrc(+n[sb+(Db<<2)>>2]*32.0)|0;Cb=mrc(+n[Bb+(Db<<2)>>2]*32.0)|0;Ab=zb>>5;yb=Db<<1;d[ob+(yb<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;Ab=Cb>>5;d[ob+((yb|1)<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;d[pb+(Db<<1)>>1]=Cb<<5&992|zb&31;Db=Db+1|0}while((Db|0)<(lb|0))}}while(0);nb=nb+1|0}while((nb|0)<(kb|0))}Ii[f[P>>2]&127](f[Q>>2]|0,e,k,l,f[R>>2]|0,f[S>>2]|0,T);nb=f[U>>2]|0;if(nb|0?(jb=nb+12|0,nb=f[jb>>2]|0,f[jb>>2]=nb+-1,(nb|0)==1):0)_S(l);f[U>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[W>>2]|0)>0){nb=f[X>>2]|0;jb=0;do{f[nb+(jb<<2)>>2]=0;jb=jb+1|0}while((jb|0)<(f[W>>2]|0))}jb=f[Z>>2]|0;if((jb|0)!=(_|0))g0(jb)}else{jb=f[t>>2]|0;do if((f[jb>>2]&4095|0)==11){nb=f[ba>>2]|0;if(f[nb+16>>2]|0){mb=f[nb+4>>2]|0;if((mb|0)<3)Eb=Y(f[nb+12>>2]|0,f[nb+8>>2]|0)|0;else{pb=f[nb+40>>2]|0;nb=0;ob=1;while(1){qb=Y(f[pb+(nb<<2)>>2]|0,ob)|0;nb=nb+1|0;if((nb|0)==(mb|0)){Eb=qb;break}else ob=qb}}if(!((mb|0)==0|(Eb|0)==0)){ub=36;break}}f[m>>2]=hb;f[Ha>>2]=fb;f[Ia>>2]=lb;f[Ja>>2]=kb;cT(l,jb,m);ob=f[Ka>>2]|0;if(ob|0){nb=ob+12|0;f[nb>>2]=(f[nb>>2]|0)+1}nb=f[ga>>2]|0;if(nb|0?(ob=nb+12|0,nb=f[ob>>2]|0,f[ob>>2]=nb+-1,(nb|0)==1):0)_S(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){nb=f[ia>>2]|0;ob=0;do{f[nb+(ob<<2)>>2]=0;ob=ob+1|0;Fb=f[ha>>2]|0}while((ob|0)<(Fb|0));f[k>>2]=f[l>>2];if((Fb|0)<3)ub=24;else ub=26}else{f[k>>2]=f[l>>2];ub=24}if((ub|0)==24){ub=0;ob=f[La>>2]|0;if((ob|0)<3){f[ha>>2]=ob;f[la>>2]=f[Ma>>2];f[na>>2]=f[Na>>2];ob=f[Oa>>2]|0;nb=f[aa>>2]|0;f[nb>>2]=f[ob>>2];f[nb+4>>2]=f[ob+4>>2]}else ub=26}if((ub|0)==26){ub=0;ZS(k,l)}f[$>>2]=f[Pa>>2];f[ra>>2]=f[Qa>>2];f[ta>>2]=f[Ra>>2];f[va>>2]=f[Sa>>2];f[xa>>2]=f[Ta>>2];ob=f[Ka>>2]|0;f[ga>>2]=ob;if(ob|0?(nb=ob+12|0,ob=f[nb>>2]|0,f[nb>>2]=ob+-1,(ob|0)==1):0)_S(l);f[Ka>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[La>>2]|0)>0){ob=f[Ua>>2]|0;nb=0;do{f[ob+(nb<<2)>>2]=0;nb=nb+1|0}while((nb|0)<(f[La>>2]|0))}nb=f[Oa>>2]|0;if((nb|0)!=(Va|0))g0(nb)}else ub=36;while(0);a:do if((ub|0)==36){ub=0;if(!Wa){if((kb|0)<=0)break;nb=f[$>>2]|0;ob=f[jb+16>>2]|0;mb=hb<<1;pb=f[ba>>2]|0;qb=f[pb+16>>2]|0;if((lb|0)<=0)break;Bb=f[f[aa>>2]>>2]|0;sb=f[f[jb+44>>2]>>2]|0;rb=f[f[pb+44>>2]>>2]|0;pb=0;while(1){vb=nb+(Y(Bb,pb)|0)|0;zb=pb+fb|0;Cb=ob+(Y(sb,zb)|0)+(mb<<1)|0;Ab=qb+(Y(rb,zb)|0)+(hb<<1)|0;zb=0;do{yb=d[Ab+(zb<<1)>>1]&1023;Gb=zb<<1;d[vb+(Gb<<1)>>1]=(h[1150611+(yb<<1)>>0]|0)+(j[Cb+(Gb<<1)>>1]|0);Hb=Gb|1;d[vb+(Hb<<1)>>1]=(h[1150611+(yb<<1)+1>>0]|0)+(j[Cb+(Hb<<1)>>1]|0);zb=zb+1|0}while((zb|0)<(lb|0));pb=pb+1|0;if((pb|0)>=(kb|0))break a}}if(f[Aa>>2]|0){if((kb|0)<=0)break;pb=f[$>>2]|0;rb=f[f[aa>>2]>>2]|0;qb=f[jb+16>>2]|0;mb=f[f[jb+44>>2]>>2]|0;sb=f[ba>>2]|0;ob=f[sb+16>>2]|0;Bb=f[f[sb+44>>2]>>2]|0;if((lb|0)>0)Ib=0;else break;while(1){sb=pb+(Y(rb,Ib)|0)|0;nb=Ib+fb|0;zb=qb+(Y(mb,nb)|0)+(hb<<2)|0;Cb=ob+(Y(Bb,nb)|0)+(hb<<2)|0;nb=0;do{vb=mrc(+n[zb+(nb<<2)>>2])|0;Ab=nb<<1;d[sb+(Ab<<1)>>1]=(vb+32768|0)>>>0<65536?vb:(vb|0)>0?32767:32768;vb=mrc(+n[Cb+(nb<<2)>>2])|0;d[sb+((Ab|1)<<1)>>1]=(vb+32768|0)>>>0<65536?vb:(vb|0)>0?32767:32768;nb=nb+1|0}while((nb|0)<(lb|0));Ib=Ib+1|0;if((Ib|0)>=(kb|0))break a}}f[l>>2]=hb;f[v>>2]=fb;f[Xa>>2]=lb;f[Ya>>2]=kb;cT(o,jb,l);Bb=Za;f[Bb>>2]=0;f[Bb+4>>2]=0;f[m>>2]=33619968;f[_a>>2]=k;LZ(o,m,f[k>>2]&7,1.0,0.0);Bb=f[$a>>2]|0;if(Bb|0?(ob=Bb+12|0,Bb=f[ob>>2]|0,f[ob>>2]=Bb+-1,(Bb|0)==1):0)_S(o);f[$a>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[bb>>2]|0)>0){Bb=f[cb>>2]|0;ob=0;do{f[Bb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[bb>>2]|0))}ob=f[db>>2]|0;if((ob|0)!=(eb|0))g0(ob)}while(0);gi[f[A>>2]&255](f[Q>>2]|0,e,k,f[S>>2]|0,T)}jb=f[ga>>2]|0;if(jb|0?(kb=jb+12|0,jb=f[kb>>2]|0,f[kb>>2]=jb+-1,(jb|0)==1):0)_S(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){jb=f[ia>>2]|0;kb=0;do{f[jb+(kb<<2)>>2]=0;kb=kb+1|0}while((kb|0)<(f[ha>>2]|0))}kb=f[aa>>2]|0;if((kb|0)!=(a|0))g0(kb);kb=f[Ba>>2]|0;if(kb|0?(jb=kb+12|0,kb=f[jb>>2]|0,f[jb>>2]=kb+-1,(kb|0)==1):0)_S(e);f[Ba>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[Da>>2]|0)>0){kb=f[Ea>>2]|0;jb=0;do{f[kb+(jb<<2)>>2]=0;jb=jb+1|0}while((jb|0)<(f[Da>>2]|0))}jb=f[Fa>>2]|0;if((jb|0)!=(Ga|0))g0(jb);hb=hb+r|0;jb=f[q>>2]|0;ib=f[jb+12>>2]|0;if((ib|0)<=(hb|0)){Jb=jb;break}else gb=jb}}else Jb=C;fb=fb+x|0;if((fb|0)>=(f[G>>2]|0))break;else C=Jb}}Jb=i+36|0;C=f[Jb>>2]|0;if(C|0?(G=C+12|0,C=f[G>>2]|0,f[G>>2]=C+-1,(C|0)==1):0)_S(i);f[Jb>>2]=0;Jb=i+16|0;f[Jb>>2]=0;f[Jb+4>>2]=0;f[Jb+8>>2]=0;f[Jb+12>>2]=0;if((f[D>>2]|0)>0){Jb=f[F>>2]|0;F=0;do{f[Jb+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[D>>2]|0))}D=f[z>>2]|0;if((D|0)!=(E|0))g0(D);D=g+36|0;E=f[D>>2]|0;if(E|0?(z=E+12|0,E=f[z>>2]|0,f[z>>2]=E+-1,(E|0)==1):0)_S(g);f[D>>2]=0;D=g+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[w>>2]|0)>0){D=f[y>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}w=f[B>>2]|0;if((w|0)==(s|0)){u=c;return}g0(w);u=c;return}function Poa(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;m=u;u=u+576|0;n=m+64|0;o=m+32|0;q=m;r=f[a+40>>2]|0;s=f[r+4>>2]|0;t=f[r>>2]|0;r=f[c+40>>2]|0;v=f[r+4>>2]|0;w=f[r>>2]|0;r=(f[a>>2]|0)>>>3;x=(r&511)+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=nrc(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=(k|0)!=5?k:4;l=s+-7|0;A=(l|0)>0?l:0;l=t+-7|0;B=(l|0)>0?l:0;if((f[c>>2]&16384|0)!=0?(f[e>>2]&16384|0)!=0:0){l=(f[g>>2]&16384|0)!=0;C=Y(l?w:1,v)|0;if(l){D=C;E=1}else{F=C;G=6}}else{F=v;G=6}if((G|0)==6)if((w|0)>0){D=F;E=w}else{u=m;return}w=c+16|0;F=c+44|0;c=e+16|0;v=e+44|0;e=g+16|0;C=g+44|0;g=(D|0)>0;l=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(k|0)==5;k=(a|0)==0;P=o+4|0;Q=o+8|0;R=o+12|0;S=o+16|0;T=o+20|0;U=o+24|0;V=o+28|0;W=(r|-512)^511;r=q+4|0;X=q+8|0;Z=q+12|0;_=q+16|0;$=q+20|0;aa=q+24|0;ba=q+28|0;ca=0;da=y;while(1){y=f[w>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[c>>2]|0)+(Y(f[f[v>>2]>>2]|0,ca)|0)|0;ga=(f[e>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(g){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(x,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=i+(j[ga+(ia<<1)>>1]<<6<<1)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+(Y(la,z)|0)+(Y(oa,x)|0)|0;while(1){ta=0;ua=0;va=sa;wa=qa;while(1){xa=Y(d[wa>>1]|0,h[va>>0]|0)|0;ya=Y(d[wa+2>>1]|0,h[va+x>>0]|0)|0;za=Y(d[wa+4>>1]|0,h[va+l>>0]|0)|0;Aa=Y(d[wa+6>>1]|0,h[va+H>>0]|0)|0;Ba=Y(d[wa+8>>1]|0,h[va+I>>0]|0)|0;Ca=Y(d[wa+10>>1]|0,h[va+J>>0]|0)|0;Da=Y(d[wa+12>>1]|0,h[va+K>>0]|0)|0;ua=xa+ua+ya+za+Aa+Ba+Ca+Da+(Y(d[wa+14>>1]|0,h[va+L>>0]|0)|0)|0;ta=ta+1|0;if((ta|0)==8)break;else{va=va+z|0;wa=wa+16|0}}wa=ua+16384>>15;b[ha+ra>>0]=wa>>>0<256?wa:(wa|0)>0?255:0;ra=ra+1|0;if((ra|0)==(x|0)){Ea=ja;break}else sa=sa+M+N|0}}else{if(O?!(na>>>0<s>>>0&pa>>>0<t>>>0):0)Fa=ja;else G=19;do if((G|0)==19){G=0;if(k?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(s|0)&(la|0)<(t|0)^1:0){dJc(ka|0,n|0,x|0)|0;Fa=ja;break}sa=Y(p_(oa,s,a)|0,x)|0;f[o>>2]=sa;ra=p_(la,t,a)|0;f[q>>2]=ra;ra=Y(p_(na+-2|0,s,a)|0,x)|0;f[P>>2]=ra;wa=p_(pa+-2|0,t,a)|0;f[r>>2]=wa;wa=Y(p_(na+-1|0,s,a)|0,x)|0;f[Q>>2]=wa;va=p_(pa+-1|0,t,a)|0;f[X>>2]=va;va=Y(p_(na,s,a)|0,x)|0;f[R>>2]=va;ta=p_(pa,t,a)|0;f[Z>>2]=ta;ta=Y(p_(na+1|0,s,a)|0,x)|0;f[S>>2]=ta;Da=p_(pa+1|0,t,a)|0;f[_>>2]=Da;Da=Y(p_(na+2|0,s,a)|0,x)|0;f[T>>2]=Da;Ca=p_(pa+2|0,t,a)|0;f[$>>2]=Ca;Ca=Y(p_(na+3|0,s,a)|0,x)|0;f[U>>2]=Ca;Ba=p_(pa+3|0,t,a)|0;f[aa>>2]=Ba;Ba=Y(p_(na+4|0,s,a)|0,x)|0;f[V>>2]=Ba;Aa=p_(pa+4|0,t,a)|0;f[ba>>2]=Aa;Aa=0;za=ja;ya=sa;sa=ra;ra=wa;wa=va;va=ta;ta=Da;Da=Ca;Ca=Ba;while(1){Ba=h[n+Aa>>0]|0;xa=Ba<<15;Ga=(sa|0)>-1;Ha=(ra|0)>-1;Ia=(wa|0)>-1;Ja=(va|0)>-1;Ka=(ta|0)>-1;La=(Da|0)>-1;Ma=(Ca|0)>-1;if((ya|0)>-1){Na=0;Oa=xa;Pa=qa;while(1){Qa=f[q+(Na<<2)>>2]|0;Ra=za+(Y(Qa,z)|0)|0;do if((Qa|0)<0)Sa=Oa;else{Ta=(Y((h[Ra+ya>>0]|0)-Ba|0,d[Pa>>1]|0)|0)+Oa|0;if(Ga)Ua=(Y((h[Ra+sa>>0]|0)-Ba|0,d[Pa+2>>1]|0)|0)+Ta|0;else Ua=Ta;if(Ha)Va=(Y((h[Ra+ra>>0]|0)-Ba|0,d[Pa+4>>1]|0)|0)+Ua|0;else Va=Ua;if(Ia)Wa=(Y((h[Ra+wa>>0]|0)-Ba|0,d[Pa+6>>1]|0)|0)+Va|0;else Wa=Va;if(Ja)Xa=(Y((h[Ra+va>>0]|0)-Ba|0,d[Pa+8>>1]|0)|0)+Wa|0;else Xa=Wa;if(Ka)Ya=(Y((h[Ra+ta>>0]|0)-Ba|0,d[Pa+10>>1]|0)|0)+Xa|0;else Ya=Xa;if(La)Za=(Y((h[Ra+Da>>0]|0)-Ba|0,d[Pa+12>>1]|0)|0)+Ya|0;else Za=Ya;if(!Ma){Sa=Za;break}Sa=(Y((h[Ra+Ca>>0]|0)-Ba|0,d[Pa+14>>1]|0)|0)+Za|0}while(0);Na=Na+1|0;if((Na|0)==8){_a=Sa;break}else{Oa=Sa;Pa=Pa+16|0}}}else{Pa=0;Oa=xa;Na=qa;while(1){Ra=f[q+(Pa<<2)>>2]|0;Qa=za+(Y(Ra,z)|0)|0;do if((Ra|0)<0)$a=Oa;else{if(Ga)ab=(Y((h[Qa+sa>>0]|0)-Ba|0,d[Na+2>>1]|0)|0)+Oa|0;else ab=Oa;if(Ha)bb=(Y((h[Qa+ra>>0]|0)-Ba|0,d[Na+4>>1]|0)|0)+ab|0;else bb=ab;if(Ia)cb=(Y((h[Qa+wa>>0]|0)-Ba|0,d[Na+6>>1]|0)|0)+bb|0;else cb=bb;if(Ja)db=(Y((h[Qa+va>>0]|0)-Ba|0,d[Na+8>>1]|0)|0)+cb|0;else db=cb;if(Ka)eb=(Y((h[Qa+ta>>0]|0)-Ba|0,d[Na+10>>1]|0)|0)+db|0;else eb=db;if(La)fb=(Y((h[Qa+Da>>0]|0)-Ba|0,d[Na+12>>1]|0)|0)+eb|0;else fb=eb;if(!Ma){$a=fb;break}$a=(Y((h[Qa+Ca>>0]|0)-Ba|0,d[Na+14>>1]|0)|0)+fb|0}while(0);Pa=Pa+1|0;if((Pa|0)==8){_a=$a;break}else{Oa=$a;Na=Na+16|0}}}Na=_a+16384>>15;b[ha+Aa>>0]=Na>>>0<256?Na:(Na|0)>0?255:0;Na=Aa+1|0;if((Na|0)==(x|0))break;Aa=Na;za=za+1|0;ya=f[o>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;Da=f[U>>2]|0;Ca=f[V>>2]|0}Fa=ja+x+W|0}while(0);Ea=Fa}ia=ia+1|0;if((ia|0)==(D|0)){gb=Ea;break}else{ha=ha+x|0;ja=Ea}}}else gb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=gb}u=m;return}function Qoa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+1088|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=nrc(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<1)+((Y(oa,x)|0)<<1)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+(j[va>>1]|0)*+n[wa>>2]+ +(j[va+(x<<1)>>1]|0)*+n[wa+4>>2]+ +(j[va+(i<<1)>>1]|0)*+n[wa+8>>2]+ +(j[va+(H<<1)>>1]|0)*+n[wa+12>>2]+ +(j[va+(I<<1)>>1]|0)*+n[wa+16>>2]+ +(j[va+(J<<1)>>1]|0)*+n[wa+20>>2]+ +(j[va+(K<<1)>>1]|0)*+n[wa+24>>2]+ +(j[va+(L<<1)>>1]|0)*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<1)|0;wa=wa+32|0}}wa=mrc(ua)|0;d[ha+(ra<<1)>>1]=wa>>>0<65536?wa:(wa|0)>0?65535:0;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<1)+(N<<1)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){dJc(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(p_(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=p_(la,s,a)|0;f[o>>2]=ra;ra=Y(p_(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=p_(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(p_(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=p_(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(p_(na,r,a)|0,x)|0;f[R>>2]=va;ta=p_(pa,s,a)|0;f[Z>>2]=ta;ta=Y(p_(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=p_(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(p_(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=p_(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(p_(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=p_(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(p_(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=p_(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+(j[l+(Ca<<1)>>1]|0);Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<1)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+ +n[Oa>>2]*(+(j[Qa+(Ea<<1)>>1]|0)-Fa);if(Ba)Ta=Sa+ +n[Oa+4>>2]*(+(j[Qa+(sa<<1)>>1]|0)-Fa);else Ta=Sa;if(Ga)Ua=Ta+ +n[Oa+8>>2]*(+(j[Qa+(ra<<1)>>1]|0)-Fa);else Ua=Ta;if(Ha)Va=Ua+ +n[Oa+12>>2]*(+(j[Qa+(wa<<1)>>1]|0)-Fa);else Va=Ua;if(Ia)Wa=Va+ +n[Oa+16>>2]*(+(j[Qa+(va<<1)>>1]|0)-Fa);else Wa=Va;if(Ja)Xa=Wa+ +n[Oa+20>>2]*(+(j[Qa+(ta<<1)>>1]|0)-Fa);else Xa=Wa;if(Ka)Ya=Xa+ +n[Oa+24>>2]*(+(j[Qa+(za<<1)>>1]|0)-Fa);else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+ +n[Oa+28>>2]*(+(j[Qa+(Aa<<1)>>1]|0)-Fa)}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<1)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+ +n[Ma+4>>2]*(+(j[Pa+(sa<<1)>>1]|0)-Fa);else $a=Na;if(Ga)ab=$a+ +n[Ma+8>>2]*(+(j[Pa+(ra<<1)>>1]|0)-Fa);else ab=$a;if(Ha)bb=ab+ +n[Ma+12>>2]*(+(j[Pa+(wa<<1)>>1]|0)-Fa);else bb=ab;if(Ia)cb=bb+ +n[Ma+16>>2]*(+(j[Pa+(va<<1)>>1]|0)-Fa);else cb=bb;if(Ja)db=cb+ +n[Ma+20>>2]*(+(j[Pa+(ta<<1)>>1]|0)-Fa);else db=cb;if(Ka)eb=db+ +n[Ma+24>>2]*(+(j[Pa+(za<<1)>>1]|0)-Fa);else eb=db;if(!La){_a=eb;break}_a=eb+ +n[Ma+28>>2]*(+(j[Pa+(Aa<<1)>>1]|0)-Fa)}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}Ma=mrc(Za)|0;d[ha+(Ca<<1)>>1]=Ma>>>0<65536?Ma:(Ma|0)>0?65535:0;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+2|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<1)+(W<<1)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<1)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function Roa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+1088|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=nrc(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<1)+((Y(oa,x)|0)<<1)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+(d[va>>1]|0)*+n[wa>>2]+ +(d[va+(x<<1)>>1]|0)*+n[wa+4>>2]+ +(d[va+(i<<1)>>1]|0)*+n[wa+8>>2]+ +(d[va+(H<<1)>>1]|0)*+n[wa+12>>2]+ +(d[va+(I<<1)>>1]|0)*+n[wa+16>>2]+ +(d[va+(J<<1)>>1]|0)*+n[wa+20>>2]+ +(d[va+(K<<1)>>1]|0)*+n[wa+24>>2]+ +(d[va+(L<<1)>>1]|0)*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<1)|0;wa=wa+32|0}}wa=mrc(ua)|0;d[ha+(ra<<1)>>1]=(wa+32768|0)>>>0<65536?wa:(wa|0)>0?32767:32768;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<1)+(N<<1)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){dJc(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(p_(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=p_(la,s,a)|0;f[o>>2]=ra;ra=Y(p_(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=p_(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(p_(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=p_(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(p_(na,r,a)|0,x)|0;f[R>>2]=va;ta=p_(pa,s,a)|0;f[Z>>2]=ta;ta=Y(p_(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=p_(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(p_(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=p_(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(p_(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=p_(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(p_(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=p_(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+(d[l+(Ca<<1)>>1]|0);Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<1)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+ +n[Oa>>2]*(+(d[Qa+(Ea<<1)>>1]|0)-Fa);if(Ba)Ta=Sa+ +n[Oa+4>>2]*(+(d[Qa+(sa<<1)>>1]|0)-Fa);else Ta=Sa;if(Ga)Ua=Ta+ +n[Oa+8>>2]*(+(d[Qa+(ra<<1)>>1]|0)-Fa);else Ua=Ta;if(Ha)Va=Ua+ +n[Oa+12>>2]*(+(d[Qa+(wa<<1)>>1]|0)-Fa);else Va=Ua;if(Ia)Wa=Va+ +n[Oa+16>>2]*(+(d[Qa+(va<<1)>>1]|0)-Fa);else Wa=Va;if(Ja)Xa=Wa+ +n[Oa+20>>2]*(+(d[Qa+(ta<<1)>>1]|0)-Fa);else Xa=Wa;if(Ka)Ya=Xa+ +n[Oa+24>>2]*(+(d[Qa+(za<<1)>>1]|0)-Fa);else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+ +n[Oa+28>>2]*(+(d[Qa+(Aa<<1)>>1]|0)-Fa)}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<1)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+ +n[Ma+4>>2]*(+(d[Pa+(sa<<1)>>1]|0)-Fa);else $a=Na;if(Ga)ab=$a+ +n[Ma+8>>2]*(+(d[Pa+(ra<<1)>>1]|0)-Fa);else ab=$a;if(Ha)bb=ab+ +n[Ma+12>>2]*(+(d[Pa+(wa<<1)>>1]|0)-Fa);else bb=ab;if(Ia)cb=bb+ +n[Ma+16>>2]*(+(d[Pa+(va<<1)>>1]|0)-Fa);else cb=bb;if(Ja)db=cb+ +n[Ma+20>>2]*(+(d[Pa+(ta<<1)>>1]|0)-Fa);else db=cb;if(Ka)eb=db+ +n[Ma+24>>2]*(+(d[Pa+(za<<1)>>1]|0)-Fa);else eb=db;if(!La){_a=eb;break}_a=eb+ +n[Ma+28>>2]*(+(d[Pa+(Aa<<1)>>1]|0)-Fa)}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}Ma=mrc(Za)|0;d[ha+(Ca<<1)>>1]=(Ma+32768|0)>>>0<65536?Ma:(Ma|0)>0?32767:32768;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+2|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<1)+(W<<1)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<1)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function Soa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+2112|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>2;a=0;do{n[l+(a<<2)>>2]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<2)+4|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<2)+((Y(oa,x)|0)<<2)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+n[va>>2]*+n[wa>>2]+ +n[va+(x<<2)>>2]*+n[wa+4>>2]+ +n[va+(i<<2)>>2]*+n[wa+8>>2]+ +n[va+(H<<2)>>2]*+n[wa+12>>2]+ +n[va+(I<<2)>>2]*+n[wa+16>>2]+ +n[va+(J<<2)>>2]*+n[wa+20>>2]+ +n[va+(K<<2)>>2]*+n[wa+24>>2]+ +n[va+(L<<2)>>2]*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<2)|0;wa=wa+32|0}}n[ha+(ra<<2)>>2]=ua;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<2)+(N<<2)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){dJc(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(p_(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=p_(la,s,a)|0;f[o>>2]=ra;ra=Y(p_(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=p_(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(p_(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=p_(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(p_(na,r,a)|0,x)|0;f[R>>2]=va;ta=p_(pa,s,a)|0;f[Z>>2]=ta;ta=Y(p_(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=p_(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(p_(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=p_(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(p_(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=p_(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(p_(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=p_(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+n[l+(Ca<<2)>>2];Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<2)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+(+n[Qa+(Ea<<2)>>2]-Fa)*+n[Oa>>2];if(Ba)Ta=Sa+(+n[Qa+(sa<<2)>>2]-Fa)*+n[Oa+4>>2];else Ta=Sa;if(Ga)Ua=Ta+(+n[Qa+(ra<<2)>>2]-Fa)*+n[Oa+8>>2];else Ua=Ta;if(Ha)Va=Ua+(+n[Qa+(wa<<2)>>2]-Fa)*+n[Oa+12>>2];else Va=Ua;if(Ia)Wa=Va+(+n[Qa+(va<<2)>>2]-Fa)*+n[Oa+16>>2];else Wa=Va;if(Ja)Xa=Wa+(+n[Qa+(ta<<2)>>2]-Fa)*+n[Oa+20>>2];else Xa=Wa;if(Ka)Ya=Xa+(+n[Qa+(za<<2)>>2]-Fa)*+n[Oa+24>>2];else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+(+n[Qa+(Aa<<2)>>2]-Fa)*+n[Oa+28>>2]}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<2)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+(+n[Pa+(sa<<2)>>2]-Fa)*+n[Ma+4>>2];else $a=Na;if(Ga)ab=$a+(+n[Pa+(ra<<2)>>2]-Fa)*+n[Ma+8>>2];else ab=$a;if(Ha)bb=ab+(+n[Pa+(wa<<2)>>2]-Fa)*+n[Ma+12>>2];else bb=ab;if(Ia)cb=bb+(+n[Pa+(va<<2)>>2]-Fa)*+n[Ma+16>>2];else cb=bb;if(Ja)db=cb+(+n[Pa+(ta<<2)>>2]-Fa)*+n[Ma+20>>2];else db=cb;if(Ka)eb=db+(+n[Pa+(za<<2)>>2]-Fa)*+n[Ma+24>>2];else eb=db;if(!La){_a=eb;break}_a=eb+(+n[Pa+(Aa<<2)>>2]-Fa)*+n[Ma+28>>2]}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}n[ha+(Ca<<2)>>2]=Za;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+4|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<2)+(W<<2)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<2)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function Toa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+4160|0;l=k;m=k+4128|0;o=k+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>3;a=0;do{p[l+(a<<3)>>3]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<3)+8|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<3)+((Y(oa,x)|0)<<3)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+p[va>>3]*+n[wa>>2]+ +p[va+(x<<3)>>3]*+n[wa+4>>2]+ +p[va+(i<<3)>>3]*+n[wa+8>>2]+ +p[va+(H<<3)>>3]*+n[wa+12>>2]+ +p[va+(I<<3)>>3]*+n[wa+16>>2]+ +p[va+(J<<3)>>3]*+n[wa+20>>2]+ +p[va+(K<<3)>>3]*+n[wa+24>>2]+ +p[va+(L<<3)>>3]*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<3)|0;wa=wa+32|0}}p[ha+(ra<<3)>>3]=ua;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<3)+(N<<3)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){dJc(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(p_(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=p_(la,s,a)|0;f[o>>2]=ra;ra=Y(p_(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=p_(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(p_(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=p_(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(p_(na,r,a)|0,x)|0;f[R>>2]=va;ta=p_(pa,s,a)|0;f[Z>>2]=ta;ta=Y(p_(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=p_(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(p_(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=p_(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(p_(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=p_(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(p_(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=p_(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+p[l+(Ca<<3)>>3];Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<3)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+(+p[Qa+(Ea<<3)>>3]-Fa)*+n[Oa>>2];if(Ba)Ta=Sa+(+p[Qa+(sa<<3)>>3]-Fa)*+n[Oa+4>>2];else Ta=Sa;if(Ga)Ua=Ta+(+p[Qa+(ra<<3)>>3]-Fa)*+n[Oa+8>>2];else Ua=Ta;if(Ha)Va=Ua+(+p[Qa+(wa<<3)>>3]-Fa)*+n[Oa+12>>2];else Va=Ua;if(Ia)Wa=Va+(+p[Qa+(va<<3)>>3]-Fa)*+n[Oa+16>>2];else Wa=Va;if(Ja)Xa=Wa+(+p[Qa+(ta<<3)>>3]-Fa)*+n[Oa+20>>2];else Xa=Wa;if(Ka)Ya=Xa+(+p[Qa+(za<<3)>>3]-Fa)*+n[Oa+24>>2];else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+(+p[Qa+(Aa<<3)>>3]-Fa)*+n[Oa+28>>2]}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<3)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+(+p[Pa+(sa<<3)>>3]-Fa)*+n[Ma+4>>2];else $a=Na;if(Ga)ab=$a+(+p[Pa+(ra<<3)>>3]-Fa)*+n[Ma+8>>2];else ab=$a;if(Ha)bb=ab+(+p[Pa+(wa<<3)>>3]-Fa)*+n[Ma+12>>2];else bb=ab;if(Ia)cb=bb+(+p[Pa+(va<<3)>>3]-Fa)*+n[Ma+16>>2];else cb=bb;if(Ja)db=cb+(+p[Pa+(ta<<3)>>3]-Fa)*+n[Ma+20>>2];else db=cb;if(Ka)eb=db+(+p[Pa+(za<<3)>>3]-Fa)*+n[Ma+24>>2];else eb=db;if(!La){_a=eb;break}_a=eb+(+p[Pa+(Aa<<3)>>3]-Fa)*+n[Ma+28>>2]}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}p[ha+(Ca<<3)>>3]=Za;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+8|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<3)+(W<<3)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<3)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function Uoa(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0;m=u;u=u+544|0;n=m+32|0;o=m+16|0;q=m;r=f[a+40>>2]|0;s=f[r+4>>2]|0;t=f[r>>2]|0;r=f[c+40>>2]|0;v=f[r+4>>2]|0;w=f[r>>2]|0;r=(f[a>>2]|0)>>>3;x=(r&511)+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=nrc(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=(k|0)!=5?k:4;l=s+-3|0;A=(l|0)>0?l:0;l=t+-3|0;B=(l|0)>0?l:0;if((f[c>>2]&16384|0)!=0?(f[e>>2]&16384|0)!=0:0){l=(f[g>>2]&16384|0)!=0;C=Y(l?w:1,v)|0;if(l){D=C;E=1}else{F=C;G=6}}else{F=v;G=6}if((G|0)==6)if((w|0)>0){D=F;E=w}else{u=m;return}w=c+16|0;F=c+44|0;c=e+16|0;v=e+44|0;e=g+16|0;C=g+44|0;g=(D|0)>0;l=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(k|0)==5;k=(a|0)==0;K=o+4|0;L=o+8|0;M=o+12|0;N=(r|-512)^511;r=q+4|0;O=q+8|0;P=q+12|0;Q=0;R=y;while(1){y=f[w>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[c>>2]|0)+(Y(f[f[v>>2]>>2]|0,Q)|0)|0;U=(f[e>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(g){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(x,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=i+(j[U+(W<<1)>>1]<<4<<1)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=ca+2|0;ea=ca+4|0;fa=ca+6|0;ga=ca+8|0;ha=ca+10|0;ia=ca+12|0;ja=ca+14|0;ka=ca+16|0;la=ca+18|0;ma=ca+20|0;na=ca+22|0;oa=ca+24|0;pa=ca+26|0;qa=ca+28|0;ra=ca+30|0;sa=0;ta=X+(Y(_,z)|0)+(Y(aa,x)|0)|0;while(1){ua=Y(d[ca>>1]|0,h[ta>>0]|0)|0;va=Y(d[da>>1]|0,h[ta+x>>0]|0)|0;wa=Y(d[ea>>1]|0,h[ta+l>>0]|0)|0;xa=Y(d[fa>>1]|0,h[ta+H>>0]|0)|0;ya=ta+z|0;za=Y(d[ga>>1]|0,h[ya>>0]|0)|0;Aa=Y(d[ha>>1]|0,h[ya+x>>0]|0)|0;Ba=Y(d[ia>>1]|0,h[ya+l>>0]|0)|0;Ca=Y(d[ja>>1]|0,h[ya+H>>0]|0)|0;Da=ya+z|0;ya=Y(d[ka>>1]|0,h[Da>>0]|0)|0;Ea=Y(d[la>>1]|0,h[Da+x>>0]|0)|0;Fa=Y(d[ma>>1]|0,h[Da+l>>0]|0)|0;Ga=Y(d[na>>1]|0,h[Da+H>>0]|0)|0;Ha=Da+z|0;Da=Y(d[oa>>1]|0,h[Ha>>0]|0)|0;Ia=Y(d[pa>>1]|0,h[Ha+x>>0]|0)|0;Ja=Y(d[qa>>1]|0,h[Ha+l>>0]|0)|0;Ka=ua+16384+va+wa+xa+za+Aa+Ba+Ca+ya+Ea+Fa+Ga+Da+Ia+Ja+(Y(d[ra>>1]|0,h[Ha+H>>0]|0)|0)>>15;b[V+sa>>0]=Ka>>>0<256?Ka:(Ka|0)>0?255:0;sa=sa+1|0;if((sa|0)==(x|0)){La=X;break}else ta=Ha+I|0}}else{if(J?!($>>>0<s>>>0&ba>>>0<t>>>0):0)Ma=X;else G=17;do if((G|0)==17){G=0;if(k?(ba+3|0)<1|((ba|0)>(t|0)|(($|0)>(s|0)|($+3|0)<1)):0){dJc(Z|0,n|0,x|0)|0;Ma=X;break}ta=Y(p_(aa,s,a)|0,x)|0;f[o>>2]=ta;sa=p_(_,t,a)|0;f[q>>2]=sa;sa=Y(p_($,s,a)|0,x)|0;f[K>>2]=sa;ra=p_(ba,t,a)|0;f[r>>2]=ra;ra=Y(p_($+1|0,s,a)|0,x)|0;f[L>>2]=ra;qa=p_(ba+1|0,t,a)|0;f[O>>2]=qa;qa=Y(p_($+2|0,s,a)|0,x)|0;f[M>>2]=qa;pa=p_(ba+2|0,t,a)|0;f[P>>2]=pa;pa=ca+8|0;oa=pa+8|0;na=oa+8|0;ma=na+2|0;la=na+4|0;ka=na+6|0;ja=oa+2|0;ia=oa+4|0;ha=oa+6|0;ga=pa+2|0;fa=pa+4|0;ea=pa+6|0;da=ca+2|0;Ha=ca+4|0;Ka=ca+6|0;Ja=ca+8|0;Ia=Ja+8|0;Da=Ia+8|0;Ga=Da+2|0;Fa=Da+4|0;Ea=Da+6|0;Da=Ia+2|0;ya=Ia+4|0;Ca=Ia+6|0;Ia=Ja+2|0;Ba=Ja+4|0;Aa=Ja+6|0;Ja=ca+2|0;za=ca+4|0;xa=ca+6|0;wa=ca+8|0;va=ca+16|0;ua=ca+24|0;Na=ua+4|0;Oa=ua+6|0;ua=va+4|0;Pa=va+6|0;va=wa+4|0;Qa=wa+6|0;wa=ca+4|0;Ra=ca+6|0;Sa=0;Ta=X;Ua=ta;ta=sa;sa=ra;ra=qa;while(1){qa=h[n+Sa>>0]|0;Va=qa<<15;Wa=(ta|0)>-1;Xa=(sa|0)>-1;Ya=(ra|0)>-1;Za=f[q>>2]|0;_a=Ta+(Y(Za,z)|0)|0;$a=(Za|0)<0;do if((Ua|0)>-1){if(!$a){Za=(Y((h[_a+Ua>>0]|0)-qa|0,d[ca>>1]|0)|0)+Va|0;if(Wa)ab=(Y((h[_a+ta>>0]|0)-qa|0,d[da>>1]|0)|0)+Za|0;else ab=Za;if(Xa)bb=(Y((h[_a+sa>>0]|0)-qa|0,d[Ha>>1]|0)|0)+ab|0;else bb=ab;if(Ya)cb=(Y((h[_a+ra>>0]|0)-qa|0,d[Ka>>1]|0)|0)+bb|0;else cb=bb}else cb=Va;Za=f[r>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){Za=(Y((h[db+Ua>>0]|0)-qa|0,d[pa>>1]|0)|0)+cb|0;if(Wa)eb=(Y((h[db+ta>>0]|0)-qa|0,d[ga>>1]|0)|0)+Za|0;else eb=Za;if(Xa)fb=(Y((h[db+sa>>0]|0)-qa|0,d[fa>>1]|0)|0)+eb|0;else fb=eb;if(Ya)gb=(Y((h[db+ra>>0]|0)-qa|0,d[ea>>1]|0)|0)+fb|0;else gb=fb}else gb=cb;db=f[O>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)>=0){db=(Y((h[Za+Ua>>0]|0)-qa|0,d[oa>>1]|0)|0)+gb|0;if(Wa)hb=(Y((h[Za+ta>>0]|0)-qa|0,d[ja>>1]|0)|0)+db|0;else hb=db;if(Xa)ib=(Y((h[Za+sa>>0]|0)-qa|0,d[ia>>1]|0)|0)+hb|0;else ib=hb;if(Ya)jb=(Y((h[Za+ra>>0]|0)-qa|0,d[ha>>1]|0)|0)+ib|0;else jb=ib}else jb=gb;Za=f[P>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){Za=(Y((h[db+Ua>>0]|0)-qa|0,d[na>>1]|0)|0)+jb|0;if(Wa)kb=(Y((h[db+ta>>0]|0)-qa|0,d[ma>>1]|0)|0)+Za|0;else kb=Za;if(Xa)lb=(Y((h[db+sa>>0]|0)-qa|0,d[la>>1]|0)|0)+kb|0;else lb=kb;if(Ya)mb=(Y((h[db+ra>>0]|0)-qa|0,d[ka>>1]|0)|0)+lb|0;else mb=lb}else mb=jb}else if(Wa){if(!$a){db=(Y((h[_a+ta>>0]|0)-qa|0,d[Ja>>1]|0)|0)+Va|0;if(Xa)nb=(Y((h[_a+sa>>0]|0)-qa|0,d[za>>1]|0)|0)+db|0;else nb=db;if(Ya)ob=(Y((h[_a+ra>>0]|0)-qa|0,d[xa>>1]|0)|0)+nb|0;else ob=nb}else ob=Va;db=f[r>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)>=0){db=(Y((h[Za+ta>>0]|0)-qa|0,d[Ia>>1]|0)|0)+ob|0;if(Xa)pb=(Y((h[Za+sa>>0]|0)-qa|0,d[Ba>>1]|0)|0)+db|0;else pb=db;if(Ya)qb=(Y((h[Za+ra>>0]|0)-qa|0,d[Aa>>1]|0)|0)+pb|0;else qb=pb}else qb=ob;Za=f[O>>2]|0;db=Ta+(Y(Za,z)|0)|0;do if((Za|0)<0)rb=qb;else{sb=(Y((h[db+ta>>0]|0)-qa|0,d[Da>>1]|0)|0)+qb|0;if(Xa)tb=(Y((h[db+sa>>0]|0)-qa|0,d[ya>>1]|0)|0)+sb|0;else tb=sb;if(!Ya){rb=tb;break}rb=(Y((h[db+ra>>0]|0)-qa|0,d[Ca>>1]|0)|0)+tb|0}while(0);db=f[P>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)<0){mb=rb;break}db=(Y((h[Za+ta>>0]|0)-qa|0,d[Ga>>1]|0)|0)+rb|0;if(Xa)ub=(Y((h[Za+sa>>0]|0)-qa|0,d[Fa>>1]|0)|0)+db|0;else ub=db;if(!Ya){mb=ub;break}mb=(Y((h[Za+ra>>0]|0)-qa|0,d[Ea>>1]|0)|0)+ub|0;break}else{if(!$a){if(Xa)vb=(Y((h[_a+sa>>0]|0)-qa|0,d[wa>>1]|0)|0)+Va|0;else vb=Va;if(Ya)wb=(Y((h[_a+ra>>0]|0)-qa|0,d[Ra>>1]|0)|0)+vb|0;else wb=vb}else wb=Va;Za=f[r>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){if(Xa)xb=(Y((h[db+sa>>0]|0)-qa|0,d[va>>1]|0)|0)+wb|0;else xb=wb;if(Ya)yb=(Y((h[db+ra>>0]|0)-qa|0,d[Qa>>1]|0)|0)+xb|0;else yb=xb}else yb=wb;db=f[O>>2]|0;Za=Ta+(Y(db,z)|0)|0;do if((db|0)<0)zb=yb;else{if(Xa)Ab=(Y((h[Za+sa>>0]|0)-qa|0,d[ua>>1]|0)|0)+yb|0;else Ab=yb;if(!Ya){zb=Ab;break}zb=(Y((h[Za+ra>>0]|0)-qa|0,d[Pa>>1]|0)|0)+Ab|0}while(0);Za=f[P>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)<0){mb=zb;break}if(Xa)Bb=(Y((h[db+sa>>0]|0)-qa|0,d[Na>>1]|0)|0)+zb|0;else Bb=zb;if(!Ya){mb=Bb;break}mb=(Y((h[db+ra>>0]|0)-qa|0,d[Oa>>1]|0)|0)+Bb|0;break}while(0);qa=mb+16384>>15;b[V+Sa>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;qa=Sa+1|0;if((qa|0)==(x|0))break;Sa=qa;Ta=Ta+1|0;Ua=f[o>>2]|0;ta=f[K>>2]|0;sa=f[L>>2]|0;ra=f[M>>2]|0}Ma=X+x+N|0}while(0);La=Ma}W=W+1|0;if((W|0)==(D|0)){Cb=La;break}else{V=V+x|0;X=La}}}else Cb=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Cb}u=m;return}function Voa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+1056|0;l=k+32|0;m=k+16|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=nrc(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<1)+((Y(aa,x)|0)<<1)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<1)|0;wa=da+(z<<1)|0;xa=wa+(z<<1)|0;ya=mrc(+(j[va>>1]|0)*ea+ +(j[va+(x<<1)>>1]|0)*fa+ +(j[va+(i<<1)>>1]|0)*ga+ +(j[va+(H<<1)>>1]|0)*ha+(+(j[da>>1]|0)*ia+ +(j[da+(x<<1)>>1]|0)*ja+ +(j[da+(i<<1)>>1]|0)*ka+ +(j[da+(H<<1)>>1]|0)*la)+(+(j[wa>>1]|0)*ma+ +(j[wa+(x<<1)>>1]|0)*na+ +(j[wa+(i<<1)>>1]|0)*oa+ +(j[wa+(H<<1)>>1]|0)*pa)+(+(j[xa>>1]|0)*qa+ +(j[xa+(x<<1)>>1]|0)*ra+ +(j[xa+(i<<1)>>1]|0)*sa+ +(j[xa+(H<<1)>>1]|0)*ta))|0;d[V+(ua<<1)>>1]=ya>>>0<65536?ya:(ya|0)>0?65535:0;ua=ua+1|0;if((ua|0)==(x|0)){za=X;break}else va=xa+(I<<1)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)Aa=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){dJc(Z|0,l|0,q|0)|0;Aa=X;break}va=Y(p_(aa,r,a)|0,x)|0;f[m>>2]=va;ua=p_(_,s,a)|0;f[o>>2]=ua;xa=Y(p_($,r,a)|0,x)|0;f[K>>2]=xa;ya=p_(ba,s,a)|0;f[w>>2]=ya;wa=Y(p_($+1|0,r,a)|0,x)|0;f[L>>2]=wa;da=p_(ba+1|0,s,a)|0;f[O>>2]=da;Ba=Y(p_($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=p_(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(ya,z)|0;Ha=(ya|0)<0;Ia=Fa+16|0;Ja=Y(da,z)|0;Ka=(da|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(ya,z)|0;_a=(ya|0)<0;ya=ca+32|0;$a=Y(da,z)|0;ab=(da|0)<0;da=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=da+8|0;db=da+12|0;da=ya+8|0;eb=ya+12|0;ya=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=wa;wa=Ba;while(1){ta=+(j[l+(hb<<1)>>1]|0);Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(wa|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<1)|0;if(!Ea){sa=ta+ +n[Fa>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)nb=sa+ +n[Va>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else nb=sa;if(lb)ob=nb+ +n[Wa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else ob=nb}else ob=ta;mb=ib+(Ga<<1)|0;if(!Ha){sa=ob+ +n[Ia>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)pb=sa+ +n[Ta>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else pb=sa;if(lb)qb=pb+ +n[Ua>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else qb=pb}else qb=ob;mb=ib+(Ja<<1)|0;do if(Ka)rb=qb;else{sa=qb+ +n[La>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)sb=sa+ +n[Ra>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else sb=sa;if(!lb){rb=sb;break}rb=sb+ +n[Sa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(Ma<<1)|0;if(Na){tb=rb;break}sa=rb+ +n[Oa>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)ub=sa+ +n[Pa>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else ub=sa;if(!lb){tb=ub;break}tb=ub+ +n[Qa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);break}else{mb=ib+(Xa<<1)|0;if(!Ya){if(kb)vb=ta+ +n[ua>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else vb=ta;if(lb)wb=vb+ +n[gb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else wb=vb}else wb=ta;mb=ib+(Za<<1)|0;if(!_a){if(kb)xb=wb+ +n[ya>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else xb=wb;if(lb)yb=xb+ +n[fb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else yb=xb}else yb=wb;mb=ib+($a<<1)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+ +n[da>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+ +n[eb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(bb<<1)|0;if(cb){tb=zb;break}if(kb)Bb=zb+ +n[Ca>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+ +n[db>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<1)|0;if((Db|0)>=0){ra=sa+ +n[Cb>>2]*(+(j[Eb+(jb<<1)>>1]|0)-ta);if(Ba)Fb=ra+ +n[Cb+4>>2]*(+(j[Eb+(va<<1)>>1]|0)-ta);else Fb=ra;if(kb)Gb=Fb+ +n[Cb+8>>2]*(+(j[Eb+(xa<<1)>>1]|0)-ta);else Gb=Fb;if(lb)Hb=Gb+ +n[Cb+12>>2]*(+(j[Eb+(wa<<1)>>1]|0)-ta);else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);lb=mrc(tb)|0;d[V+(hb<<1)>>1]=lb>>>0<65536?lb:(lb|0)>0?65535:0;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+2|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;wa=f[M>>2]|0}Aa=X+(x<<1)+(N<<1)|0}while(0);za=Aa}W=W+1|0;if((W|0)==(D|0)){Ib=za;break}else{V=V+(x<<1)|0;X=za}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Woa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+1056|0;l=k+32|0;m=k+16|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=nrc(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<1)+((Y(aa,x)|0)<<1)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<1)|0;wa=da+(z<<1)|0;xa=wa+(z<<1)|0;ya=mrc(+(d[va>>1]|0)*ea+ +(d[va+(x<<1)>>1]|0)*fa+ +(d[va+(i<<1)>>1]|0)*ga+ +(d[va+(H<<1)>>1]|0)*ha+(+(d[da>>1]|0)*ia+ +(d[da+(x<<1)>>1]|0)*ja+ +(d[da+(i<<1)>>1]|0)*ka+ +(d[da+(H<<1)>>1]|0)*la)+(+(d[wa>>1]|0)*ma+ +(d[wa+(x<<1)>>1]|0)*na+ +(d[wa+(i<<1)>>1]|0)*oa+ +(d[wa+(H<<1)>>1]|0)*pa)+(+(d[xa>>1]|0)*qa+ +(d[xa+(x<<1)>>1]|0)*ra+ +(d[xa+(i<<1)>>1]|0)*sa+ +(d[xa+(H<<1)>>1]|0)*ta))|0;d[V+(ua<<1)>>1]=(ya+32768|0)>>>0<65536?ya:(ya|0)>0?32767:32768;ua=ua+1|0;if((ua|0)==(x|0)){za=X;break}else va=xa+(I<<1)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)Aa=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){dJc(Z|0,l|0,q|0)|0;Aa=X;break}va=Y(p_(aa,r,a)|0,x)|0;f[m>>2]=va;ua=p_(_,s,a)|0;f[o>>2]=ua;xa=Y(p_($,r,a)|0,x)|0;f[K>>2]=xa;ya=p_(ba,s,a)|0;f[w>>2]=ya;wa=Y(p_($+1|0,r,a)|0,x)|0;f[L>>2]=wa;da=p_(ba+1|0,s,a)|0;f[O>>2]=da;Ba=Y(p_($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=p_(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(ya,z)|0;Ha=(ya|0)<0;Ia=Fa+16|0;Ja=Y(da,z)|0;Ka=(da|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(ya,z)|0;_a=(ya|0)<0;ya=ca+32|0;$a=Y(da,z)|0;ab=(da|0)<0;da=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=da+8|0;db=da+12|0;da=ya+8|0;eb=ya+12|0;ya=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=wa;wa=Ba;while(1){ta=+(d[l+(hb<<1)>>1]|0);Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(wa|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<1)|0;if(!Ea){sa=ta+ +n[Fa>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)nb=sa+ +n[Va>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else nb=sa;if(lb)ob=nb+ +n[Wa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else ob=nb}else ob=ta;mb=ib+(Ga<<1)|0;if(!Ha){sa=ob+ +n[Ia>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)pb=sa+ +n[Ta>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else pb=sa;if(lb)qb=pb+ +n[Ua>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else qb=pb}else qb=ob;mb=ib+(Ja<<1)|0;do if(Ka)rb=qb;else{sa=qb+ +n[La>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)sb=sa+ +n[Ra>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else sb=sa;if(!lb){rb=sb;break}rb=sb+ +n[Sa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(Ma<<1)|0;if(Na){tb=rb;break}sa=rb+ +n[Oa>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)ub=sa+ +n[Pa>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else ub=sa;if(!lb){tb=ub;break}tb=ub+ +n[Qa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);break}else{mb=ib+(Xa<<1)|0;if(!Ya){if(kb)vb=ta+ +n[ua>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else vb=ta;if(lb)wb=vb+ +n[gb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else wb=vb}else wb=ta;mb=ib+(Za<<1)|0;if(!_a){if(kb)xb=wb+ +n[ya>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else xb=wb;if(lb)yb=xb+ +n[fb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else yb=xb}else yb=wb;mb=ib+($a<<1)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+ +n[da>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+ +n[eb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(bb<<1)|0;if(cb){tb=zb;break}if(kb)Bb=zb+ +n[Ca>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+ +n[db>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<1)|0;if((Db|0)>=0){ra=sa+ +n[Cb>>2]*(+(d[Eb+(jb<<1)>>1]|0)-ta);if(Ba)Fb=ra+ +n[Cb+4>>2]*(+(d[Eb+(va<<1)>>1]|0)-ta);else Fb=ra;if(kb)Gb=Fb+ +n[Cb+8>>2]*(+(d[Eb+(xa<<1)>>1]|0)-ta);else Gb=Fb;if(lb)Hb=Gb+ +n[Cb+12>>2]*(+(d[Eb+(wa<<1)>>1]|0)-ta);else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);lb=mrc(tb)|0;d[V+(hb<<1)>>1]=(lb+32768|0)>>>0<65536?lb:(lb|0)>0?32767:32768;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+2|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;wa=f[M>>2]|0}Aa=X+(x<<1)+(N<<1)|0}while(0);za=Aa}W=W+1|0;if((W|0)==(D|0)){Ib=za;break}else{V=V+(x<<1)|0;X=za}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Xoa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0,pb=0,qb=0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0;k=u;u=u+2064|0;l=k+16|0;m=k;o=f[a+40>>2]|0;q=f[o+4>>2]|0;r=f[o>>2]|0;o=f[b+40>>2]|0;s=f[o+4>>2]|0;t=f[o>>2]|0;o=(f[a>>2]|0)>>>3;v=o&511;w=v+1|0;x=f[a+16>>2]|0;y=(f[a+48>>2]|0)>>>2;a=0;do{n[l+(a<<2)>>2]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(w|0));a=(h|0)!=5?h:4;i=q+-3|0;z=(i|0)>0?i:0;i=r+-3|0;A=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;B=Y(i?t:1,s)|0;if(i){C=B;D=1}else{E=B;F=6}}else{E=s;F=6}if((F|0)==6)if((t|0)>0){C=E;D=t}else{u=k;return}t=b+16|0;E=b+44|0;b=c+16|0;s=c+44|0;c=e+16|0;B=e+44|0;e=(C|0)>0;i=w<<1;G=w*3|0;H=(Y(y,-3)|0)+1|0;I=(h|0)==5;h=(a|0)==0;J=m+4|0;K=m+8|0;L=m+12|0;M=(o|-512)^511;o=(v<<2)+4|0;v=0;N=x;while(1){x=f[t>>2]|0;O=Y(f[f[E>>2]>>2]|0,v)|0;P=(f[b>>2]|0)+(Y(f[f[s>>2]>>2]|0,v)|0)|0;Q=(f[c>>2]|0)+(Y(f[f[B>>2]>>2]|0,v)|0)|0;if(e){R=x+O|0;S=0;T=N;while(1){U=x+(O+(Y(o,S)|0))|0;V=S<<1;W=d[P+(V<<1)>>1]|0;X=W+-1|0;Z=d[P+((V|1)<<1)>>1]|0;V=Z+-1|0;_=g+(j[Q+(S<<1)>>1]<<4<<2)|0;if(X>>>0<z>>>0&V>>>0<A>>>0){$=_+4|0;aa=_+8|0;ba=_+12|0;ca=_+16|0;da=_+20|0;ea=_+24|0;fa=_+28|0;ga=_+32|0;ha=_+36|0;ia=_+40|0;ja=_+44|0;ka=_+48|0;la=_+52|0;ma=_+56|0;na=_+60|0;oa=0;pa=T+((Y(V,y)|0)<<2)+((Y(X,w)|0)<<2)|0;while(1){qa=pa+(y<<2)|0;ra=qa+(y<<2)|0;sa=ra+(y<<2)|0;n[R+(oa<<2)>>2]=+n[pa>>2]*+n[_>>2]+ +n[pa+(w<<2)>>2]*+n[$>>2]+ +n[pa+(i<<2)>>2]*+n[aa>>2]+ +n[pa+(G<<2)>>2]*+n[ba>>2]+(+n[qa>>2]*+n[ca>>2]+ +n[qa+(w<<2)>>2]*+n[da>>2]+ +n[qa+(i<<2)>>2]*+n[ea>>2]+ +n[qa+(G<<2)>>2]*+n[fa>>2])+(+n[ra>>2]*+n[ga>>2]+ +n[ra+(w<<2)>>2]*+n[ha>>2]+ +n[ra+(i<<2)>>2]*+n[ia>>2]+ +n[ra+(G<<2)>>2]*+n[ja>>2])+(+n[sa>>2]*+n[ka>>2]+ +n[sa+(w<<2)>>2]*+n[la>>2]+ +n[sa+(i<<2)>>2]*+n[ma>>2]+ +n[sa+(G<<2)>>2]*+n[na>>2]);oa=oa+1|0;if((oa|0)==(w|0)){ta=T;break}else pa=sa+(H<<2)|0}}else{if(I?!(W>>>0<q>>>0&Z>>>0<r>>>0):0)ua=T;else F=17;do if((F|0)==17){F=0;if(h?(Z+3|0)<1|((Z|0)>(r|0)|((W|0)>(q|0)|(W+3|0)<1)):0){dJc(U|0,l|0,o|0)|0;ua=T;break}pa=Y(p_(X,q,a)|0,w)|0;f[m>>2]=pa;oa=p_(V,r,a)|0;na=Y(p_(W,q,a)|0,w)|0;f[J>>2]=na;ma=p_(Z,r,a)|0;la=Y(p_(W+1|0,q,a)|0,w)|0;f[K>>2]=la;ka=p_(Z+1|0,r,a)|0;ja=Y(p_(W+2|0,q,a)|0,w)|0;f[L>>2]=ja;ia=p_(Z+2|0,r,a)|0;ha=Y(oa,y)|0;ga=(oa|0)<0;fa=_+16|0;ea=Y(ma,y)|0;da=(ma|0)<0;ca=fa+16|0;ba=Y(ka,y)|0;aa=(ka|0)<0;$=ca+16|0;sa=Y(ia,y)|0;ra=(ia|0)<0;qa=$+4|0;va=$+8|0;wa=$+12|0;xa=ca+4|0;ya=ca+8|0;za=ca+12|0;Aa=fa+4|0;Ba=fa+8|0;Ca=fa+12|0;Da=_+4|0;Ea=_+8|0;Fa=_+12|0;Ga=Y(oa,y)|0;Ha=(oa|0)<0;Ia=_+16|0;Ja=Y(ma,y)|0;Ka=(ma|0)<0;La=Ia+16|0;Ma=Y(ka,y)|0;Na=(ka|0)<0;Oa=La+16|0;Pa=Y(ia,y)|0;Qa=(ia|0)<0;Ra=Oa+4|0;Sa=Oa+8|0;Ta=Oa+12|0;Oa=La+4|0;Ua=La+8|0;Va=La+12|0;La=Ia+4|0;Wa=Ia+8|0;Xa=Ia+12|0;Ia=_+4|0;Ya=_+8|0;Za=_+12|0;_a=Y(oa,y)|0;$a=(oa|0)<0;oa=_+16|0;ab=Y(ma,y)|0;bb=(ma|0)<0;ma=_+32|0;cb=Y(ka,y)|0;db=(ka|0)<0;ka=_+48|0;eb=Y(ia,y)|0;fb=(ia|0)<0;ia=ka+8|0;gb=ka+12|0;ka=ma+8|0;hb=ma+12|0;ma=oa+8|0;ib=oa+12|0;oa=_+8|0;jb=_+12|0;kb=0;lb=T;mb=pa;pa=na;na=la;la=ja;while(1){nb=+n[l+(kb<<2)>>2];ja=(pa|0)>-1;ob=(na|0)>-1;pb=(la|0)>-1;do if((mb|0)>-1){qb=lb+(ha<<2)|0;if(!ga){rb=nb+(+n[qb+(mb<<2)>>2]-nb)*+n[_>>2];if(ja)sb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[Da>>2];else sb=rb;if(ob)tb=sb+(+n[qb+(na<<2)>>2]-nb)*+n[Ea>>2];else tb=sb;if(pb)ub=tb+(+n[qb+(la<<2)>>2]-nb)*+n[Fa>>2];else ub=tb}else ub=nb;qb=lb+(ea<<2)|0;if(!da){rb=ub+(+n[qb+(mb<<2)>>2]-nb)*+n[fa>>2];if(ja)vb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[Aa>>2];else vb=rb;if(ob)wb=vb+(+n[qb+(na<<2)>>2]-nb)*+n[Ba>>2];else wb=vb;if(pb)xb=wb+(+n[qb+(la<<2)>>2]-nb)*+n[Ca>>2];else xb=wb}else xb=ub;qb=lb+(ba<<2)|0;if(!aa){rb=xb+(+n[qb+(mb<<2)>>2]-nb)*+n[ca>>2];if(ja)yb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[xa>>2];else yb=rb;if(ob)zb=yb+(+n[qb+(na<<2)>>2]-nb)*+n[ya>>2];else zb=yb;if(pb)Ab=zb+(+n[qb+(la<<2)>>2]-nb)*+n[za>>2];else Ab=zb}else Ab=xb;qb=lb+(sa<<2)|0;if(!ra){rb=Ab+(+n[qb+(mb<<2)>>2]-nb)*+n[$>>2];if(ja)Bb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[qa>>2];else Bb=rb;if(ob)Cb=Bb+(+n[qb+(na<<2)>>2]-nb)*+n[va>>2];else Cb=Bb;if(pb)Db=Cb+(+n[qb+(la<<2)>>2]-nb)*+n[wa>>2];else Db=Cb}else Db=Ab}else if(ja){qb=lb+(Ga<<2)|0;if(!Ha){rb=nb+(+n[qb+(pa<<2)>>2]-nb)*+n[Ia>>2];if(ob)Eb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Ya>>2];else Eb=rb;if(pb)Fb=Eb+(+n[qb+(la<<2)>>2]-nb)*+n[Za>>2];else Fb=Eb}else Fb=nb;qb=lb+(Ja<<2)|0;if(!Ka){rb=Fb+(+n[qb+(pa<<2)>>2]-nb)*+n[La>>2];if(ob)Gb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Wa>>2];else Gb=rb;if(pb)Hb=Gb+(+n[qb+(la<<2)>>2]-nb)*+n[Xa>>2];else Hb=Gb}else Hb=Fb;qb=lb+(Ma<<2)|0;do if(Na)Ib=Hb;else{rb=Hb+(+n[qb+(pa<<2)>>2]-nb)*+n[Oa>>2];if(ob)Jb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Ua>>2];else Jb=rb;if(!pb){Ib=Jb;break}Ib=Jb+(+n[qb+(la<<2)>>2]-nb)*+n[Va>>2]}while(0);qb=lb+(Pa<<2)|0;if(Qa){Db=Ib;break}rb=Ib+(+n[qb+(pa<<2)>>2]-nb)*+n[Ra>>2];if(ob)Kb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Sa>>2];else Kb=rb;if(!pb){Db=Kb;break}Db=Kb+(+n[qb+(la<<2)>>2]-nb)*+n[Ta>>2];break}else{qb=lb+(_a<<2)|0;if(!$a){if(ob)Lb=nb+(+n[qb+(na<<2)>>2]-nb)*+n[oa>>2];else Lb=nb;if(pb)Mb=Lb+(+n[qb+(la<<2)>>2]-nb)*+n[jb>>2];else Mb=Lb}else Mb=nb;qb=lb+(ab<<2)|0;if(!bb){if(ob)Nb=Mb+(+n[qb+(na<<2)>>2]-nb)*+n[ma>>2];else Nb=Mb;if(pb)Ob=Nb+(+n[qb+(la<<2)>>2]-nb)*+n[ib>>2];else Ob=Nb}else Ob=Mb;qb=lb+(cb<<2)|0;do if(db)Pb=Ob;else{if(ob)Qb=Ob+(+n[qb+(na<<2)>>2]-nb)*+n[ka>>2];else Qb=Ob;if(!pb){Pb=Qb;break}Pb=Qb+(+n[qb+(la<<2)>>2]-nb)*+n[hb>>2]}while(0);qb=lb+(eb<<2)|0;if(fb){Db=Pb;break}if(ob)Rb=Pb+(+n[qb+(na<<2)>>2]-nb)*+n[ia>>2];else Rb=Pb;if(!pb){Db=Rb;break}Db=Rb+(+n[qb+(la<<2)>>2]-nb)*+n[gb>>2];break}while(0);n[R+(kb<<2)>>2]=Db;pb=kb+1|0;if((pb|0)==(w|0))break;kb=pb;lb=lb+4|0;mb=f[m>>2]|0;pa=f[J>>2]|0;na=f[K>>2]|0;la=f[L>>2]|0}ua=T+(w<<2)+(M<<2)|0}while(0);ta=ua}S=S+1|0;if((S|0)==(C|0)){Sb=ta;break}else{R=R+(w<<2)|0;T=ta}}}else Sb=N;v=v+1|0;if((v|0)==(D|0))break;else N=Sb}u=k;return}function Yoa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+4128|0;l=k;m=k+4112|0;o=k+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>3;a=0;do{p[l+(a<<3)>>3]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<3)+8|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<3)+((Y(aa,x)|0)<<3)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<3)|0;wa=da+(z<<3)|0;xa=wa+(z<<3)|0;p[V+(ua<<3)>>3]=+p[va>>3]*ea+ +p[va+(x<<3)>>3]*fa+ +p[va+(i<<3)>>3]*ga+ +p[va+(H<<3)>>3]*ha+(+p[da>>3]*ia+ +p[da+(x<<3)>>3]*ja+ +p[da+(i<<3)>>3]*ka+ +p[da+(H<<3)>>3]*la)+(+p[wa>>3]*ma+ +p[wa+(x<<3)>>3]*na+ +p[wa+(i<<3)>>3]*oa+ +p[wa+(H<<3)>>3]*pa)+(+p[xa>>3]*qa+ +p[xa+(x<<3)>>3]*ra+ +p[xa+(i<<3)>>3]*sa+ +p[xa+(H<<3)>>3]*ta);ua=ua+1|0;if((ua|0)==(x|0)){ya=X;break}else va=xa+(I<<3)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)za=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){dJc(Z|0,l|0,q|0)|0;za=X;break}va=Y(p_(aa,r,a)|0,x)|0;f[m>>2]=va;ua=p_(_,s,a)|0;f[o>>2]=ua;xa=Y(p_($,r,a)|0,x)|0;f[K>>2]=xa;wa=p_(ba,s,a)|0;f[w>>2]=wa;da=Y(p_($+1|0,r,a)|0,x)|0;f[L>>2]=da;Aa=p_(ba+1|0,s,a)|0;f[O>>2]=Aa;Ba=Y(p_($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=p_(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(wa,z)|0;Ha=(wa|0)<0;Ia=Fa+16|0;Ja=Y(Aa,z)|0;Ka=(Aa|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(wa,z)|0;_a=(wa|0)<0;wa=ca+32|0;$a=Y(Aa,z)|0;ab=(Aa|0)<0;Aa=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=Aa+8|0;db=Aa+12|0;Aa=wa+8|0;eb=wa+12|0;wa=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=da;da=Ba;while(1){ta=+p[l+(hb<<3)>>3];Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(da|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<3)|0;if(!Ea){sa=ta+(+p[mb+(va<<3)>>3]-ta)*+n[Fa>>2];if(kb)nb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Va>>2];else nb=sa;if(lb)ob=nb+(+p[mb+(da<<3)>>3]-ta)*+n[Wa>>2];else ob=nb}else ob=ta;mb=ib+(Ga<<3)|0;if(!Ha){sa=ob+(+p[mb+(va<<3)>>3]-ta)*+n[Ia>>2];if(kb)pb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Ta>>2];else pb=sa;if(lb)qb=pb+(+p[mb+(da<<3)>>3]-ta)*+n[Ua>>2];else qb=pb}else qb=ob;mb=ib+(Ja<<3)|0;do if(Ka)rb=qb;else{sa=qb+(+p[mb+(va<<3)>>3]-ta)*+n[La>>2];if(kb)sb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Ra>>2];else sb=sa;if(!lb){rb=sb;break}rb=sb+(+p[mb+(da<<3)>>3]-ta)*+n[Sa>>2]}while(0);mb=ib+(Ma<<3)|0;if(Na){tb=rb;break}sa=rb+(+p[mb+(va<<3)>>3]-ta)*+n[Oa>>2];if(kb)ub=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Pa>>2];else ub=sa;if(!lb){tb=ub;break}tb=ub+(+p[mb+(da<<3)>>3]-ta)*+n[Qa>>2];break}else{mb=ib+(Xa<<3)|0;if(!Ya){if(kb)vb=ta+(+p[mb+(xa<<3)>>3]-ta)*+n[ua>>2];else vb=ta;if(lb)wb=vb+(+p[mb+(da<<3)>>3]-ta)*+n[gb>>2];else wb=vb}else wb=ta;mb=ib+(Za<<3)|0;if(!_a){if(kb)xb=wb+(+p[mb+(xa<<3)>>3]-ta)*+n[wa>>2];else xb=wb;if(lb)yb=xb+(+p[mb+(da<<3)>>3]-ta)*+n[fb>>2];else yb=xb}else yb=wb;mb=ib+($a<<3)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+(+p[mb+(xa<<3)>>3]-ta)*+n[Aa>>2];else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+(+p[mb+(da<<3)>>3]-ta)*+n[eb>>2]}while(0);mb=ib+(bb<<3)|0;if(cb){tb=zb;break}if(kb)Bb=zb+(+p[mb+(xa<<3)>>3]-ta)*+n[Ca>>2];else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+(+p[mb+(da<<3)>>3]-ta)*+n[db>>2];break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<3)|0;if((Db|0)>=0){ra=sa+(+p[Eb+(jb<<3)>>3]-ta)*+n[Cb>>2];if(Ba)Fb=ra+(+p[Eb+(va<<3)>>3]-ta)*+n[Cb+4>>2];else Fb=ra;if(kb)Gb=Fb+(+p[Eb+(xa<<3)>>3]-ta)*+n[Cb+8>>2];else Gb=Fb;if(lb)Hb=Gb+(+p[Eb+(da<<3)>>3]-ta)*+n[Cb+12>>2];else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);p[V+(hb<<3)>>3]=tb;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+8|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;da=f[M>>2]|0}za=X+(x<<3)+(N<<3)|0}while(0);ya=za}W=W+1|0;if((W|0)==(D|0)){Ib=ya;break}else{V=V+(x<<3)|0;X=ya}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Zoa(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;m=u;u=u+528|0;n=m+8|0;o=m;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=nrc(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=r+-1|0;l=(a|0)>0?a:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){f[o>>2]=0;f[o+4>>2]=0;C=tT(o,14)|0;D=271301;E=C+14|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,o,271316,270839,666)}if((v|0)<=0){u=m;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(k|0)==5;G=F&(x|0)!=3;H=(w|0)==0;w=(k|0)==0;I=(k|0)==1;J=q&65535;q=z+1|0;K=z+2|0;L=z+3|0;M=z+4|0;N=z+5|0;O=z+6|0;P=z+7|0;Q=0;do{R=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;S=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,Q)|0)|0;if(!g){T=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,Q)|0)|0;U=0;V=0;W=0;while(1){do if((W|0)<(t|0)){X=W<<1;if((d[R+(X<<1)>>1]|0)>>>0>=l>>>0)if(V){Z=18;break}else{_=T;$=W;aa=U;ba=0;break}else{ca=(d[R+((X|1)<<1)>>1]|0)>>>0<B>>>0;Z=16;break}}else{ca=V^1;Z=16}while(0);do if((Z|0)==16){Z=0;if(V^ca)if(ca){if(G){_=T+(Y(W-U|0,x)|0)|0;$=W;aa=W;ba=1;break}X=(W|0)>(U|0);if(H){if(!X){_=T;$=U;aa=W;ba=1;break}da=W-U|0;ea=U;fa=T;while(1){ga=ea<<1;ha=d[R+(ga<<1)>>1]|0;ia=ha<<16>>16;ja=d[R+((ga|1)<<1)>>1]|0;ga=ja<<16>>16;do if(w)if(ja<<16>>16<-1|ha<<16>>16>-2&(ia|0)<(r|0)&(ga|0)<(s|0)^1){ka=b[n>>0]|0;break}else{la=i+(j[S+(ea<<1)>>1]<<2<<1)|0;Z=49;break}else{ma=i+(j[S+(ea<<1)>>1]<<2<<1)|0;if(I){na=ha<<16>>16>-1?((ia|0)<(r|0)?ia:a):0;oa=ia+1|0;pa=ha<<16>>16>-2?((oa|0)<(r|0)?oa:a):0;oa=ga+1|0;qa=Y(ja<<16>>16>-1?((ga|0)<(s|0)?ga:A):0,z)|0;ra=Y(ja<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,z)|0;sa=y+(ra+pa)|0;ta=y+(ra+na)|0;ua=y+(qa+pa)|0;va=y+(qa+na)|0;wa=ma;Z=50}else{la=ma;Z=49}}while(0);if((Z|0)==49){Z=0;ja=p_(ia,r,k)|0;ha=p_(ia+1|0,r,k)|0;ma=p_(ga,s,k)|0;na=p_(ga+1|0,s,k)|0;qa=Y(ma,z)|0;pa=Y(na,z)|0;sa=(na|ha|0)>-1?y+(pa+ha)|0:n;ta=(na|ja|0)>-1?y+(pa+ja)|0:n;ua=(ma|ha|0)>-1?y+(qa+ha)|0:n;va=(ma|ja|0)>-1?y+(qa+ja)|0:n;wa=la;Z=50}if((Z|0)==50){Z=0;ja=Y(d[wa>>1]|0,h[va>>0]|0)|0;qa=Y(d[wa+2>>1]|0,h[ua>>0]|0)|0;ma=Y(d[wa+4>>1]|0,h[ta>>0]|0)|0;ha=ja+16384+qa+ma+(Y(d[wa+6>>1]|0,h[sa>>0]|0)|0)>>15;ka=(ha>>>0<256?ha:(ha|0)>0?255:0)&255}b[fa>>0]=ka;ea=ea+1|0;if((ea|0)==(W|0))break;else fa=fa+1|0}_=T+da|0;$=W;aa=W;ba=1;break}if(X){fa=Y(x,W+-1-U|0)|0;ea=U;ha=T;while(1){ma=ea<<1;qa=d[R+(ma<<1)>>1]|0;ja=qa<<16>>16;pa=d[R+((ma|1)<<1)>>1]|0;ma=pa<<16>>16;do if(w)if(pa<<16>>16<-1|qa<<16>>16>-2&(ja|0)<(r|0)&(ma|0)<(s|0)^1){na=0;do{b[ha+na>>0]=b[n+na>>0]|0;na=na+1|0}while((na|0)!=(x|0))}else{xa=i+(j[S+(ea<<1)>>1]<<2<<1)|0;Z=58;break}else{na=i+(j[S+(ea<<1)>>1]<<2<<1)|0;if(I){ra=ja+1|0;oa=ma+1|0;ya=y+(Y(pa<<16>>16>-1?((ma|0)<(s|0)?ma:A):0,z)|0)|0;za=Y(qa<<16>>16>-1?((ja|0)<(r|0)?ja:a):0,x)|0;Aa=Y(qa<<16>>16>-2?((ra|0)<(r|0)?ra:a):0,x)|0;ra=y+(Y(pa<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,z)|0)|0;Ba=ra+Aa|0;Ca=ra+za|0;Da=ya+Aa|0;Ea=ya+za|0;Fa=na;Z=61}else{xa=na;Z=58}}while(0);do if((Z|0)==58){Z=0;if(F?!(ja>>>0<a>>>0&ma>>>0<A>>>0):0)break;pa=p_(ja,r,k)|0;qa=p_(ja+1|0,r,k)|0;ga=p_(ma,s,k)|0;ia=p_(ma+1|0,s,k)|0;na=y+(Y(ga,z)|0)|0;za=Y(pa,x)|0;ya=Y(qa,x)|0;Aa=y+(Y(ia,z)|0)|0;Ba=(ia|qa|0)>-1?Aa+ya|0:n;Ca=(ia|pa|0)>-1?Aa+za|0:n;Da=(ga|qa|0)>-1?na+ya|0:n;Ea=(ga|pa|0)>-1?na+za|0:n;Fa=xa;Z=61}while(0);if((Z|0)==61){Z=0;ma=Fa+2|0;ja=Fa+4|0;za=Fa+6|0;na=0;do{pa=Y(d[Fa>>1]|0,h[Ea+na>>0]|0)|0;ga=Y(d[ma>>1]|0,h[Da+na>>0]|0)|0;ya=Y(d[ja>>1]|0,h[Ca+na>>0]|0)|0;qa=pa+16384+ga+ya+(Y(d[za>>1]|0,h[Ba+na>>0]|0)|0)>>15;b[ha+na>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;na=na+1|0}while((na|0)!=(x|0))}ea=ea+1|0;if((ea|0)==(W|0))break;else ha=ha+x|0}_=T+x+fa|0;$=W;aa=W;ba=1}else{_=T;$=U;aa=W;ba=1}}else Z=18;else{_=T;$=W;aa=U;ba=V}}while(0);a:do if((Z|0)==18){Z=0;switch(J&511){case 0:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ha=W-U|0;ea=T;X=U;while(1){da=X<<1;na=i+(j[S+(X<<1)>>1]<<2<<1)|0;za=y+(Y(d[R+((da|1)<<1)>>1]|0,z)|0)+(d[R+(da<<1)>>1]|0)|0;da=Y(d[na>>1]|0,h[za>>0]|0)|0;ja=Y(d[na+2>>1]|0,h[za+1>>0]|0)|0;ma=Y(d[na+4>>1]|0,h[za+z>>0]|0)|0;qa=da+16384+ja+ma+(Y(d[na+6>>1]|0,h[za+q>>0]|0)|0)>>15;b[ea>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;X=X+1|0;if((X|0)==(W|0))break;else ea=ea+1|0}_=T+ha|0;$=W;aa=W;ba=0;break a;break}case 1:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ea=W-U<<1;X=T;fa=U;while(1){qa=fa<<1;za=i+(j[S+(fa<<1)>>1]<<2<<1)|0;na=y+(Y(d[R+((qa|1)<<1)>>1]|0,z)|0)+(d[R+(qa<<1)>>1]<<1)|0;qa=d[za>>1]|0;ma=Y(qa,h[na>>0]|0)|0;ja=d[za+2>>1]|0;da=Y(ja,h[na+2>>0]|0)|0;ya=d[za+4>>1]|0;ga=Y(ya,h[na+z>>0]|0)|0;pa=d[za+6>>1]|0;za=Y(pa,h[na+K>>0]|0)|0;Aa=Y(h[na+1>>0]|0,qa)|0;qa=Y(h[na+3>>0]|0,ja)|0;ja=Y(h[na+q>>0]|0,ya)|0;ya=Y(h[na+L>>0]|0,pa)|0;pa=ma+16384+da+ga+za>>15;b[X>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;pa=Aa+16384+qa+ja+ya>>15;b[X+1>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;fa=fa+1|0;if((fa|0)==(W|0))break;else X=X+2|0}_=T+ea|0;$=W;aa=W;ba=0;break a;break}case 2:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}X=(W-U|0)*3|0;fa=T;ha=U;while(1){pa=ha<<1;ya=i+(j[S+(ha<<1)>>1]<<2<<1)|0;ja=y+(Y(d[R+((pa|1)<<1)>>1]|0,z)|0)+((d[R+(pa<<1)>>1]|0)*3|0)|0;pa=d[ya>>1]|0;qa=Y(pa,h[ja>>0]|0)|0;Aa=d[ya+2>>1]|0;za=Y(Aa,h[ja+3>>0]|0)|0;ga=d[ya+4>>1]|0;da=Y(ga,h[ja+z>>0]|0)|0;ma=d[ya+6>>1]|0;ya=Y(ma,h[ja+L>>0]|0)|0;na=Y(h[ja+1>>0]|0,pa)|0;ia=Y(h[ja+4>>0]|0,Aa)|0;ra=Y(h[ja+q>>0]|0,ga)|0;oa=Y(h[ja+M>>0]|0,ma)|0;Ga=Y(h[ja+2>>0]|0,pa)|0;pa=Y(h[ja+5>>0]|0,Aa)|0;Aa=Y(h[ja+K>>0]|0,ga)|0;ga=Y(h[ja+N>>0]|0,ma)|0;ma=qa+16384+za+da+ya>>15;b[fa>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=na+16384+ia+ra+oa>>15;b[fa+1>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=Ga+16384+pa+Aa+ga>>15;b[fa+2>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ha=ha+1|0;if((ha|0)==(W|0))break;else fa=fa+3|0}_=T+X|0;$=W;aa=W;ba=0;break a;break}case 3:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}fa=W-U<<2;ha=U;ea=T;while(1){ma=ha<<1;ga=i+(j[S+(ha<<1)>>1]<<2<<1)|0;Aa=y+(Y(d[R+((ma|1)<<1)>>1]|0,z)|0)+(d[R+(ma<<1)>>1]<<2)|0;ma=d[ga>>1]|0;pa=Y(ma,h[Aa>>0]|0)|0;Ga=ga+2|0;oa=d[Ga>>1]|0;ra=Y(oa,h[Aa+4>>0]|0)|0;ia=ga+4|0;na=d[ia>>1]|0;ya=Y(na,h[Aa+z>>0]|0)|0;da=ga+6|0;za=d[da>>1]|0;qa=Y(za,h[Aa+M>>0]|0)|0;ja=Y(h[Aa+1>>0]|0,ma)|0;ma=Y(h[Aa+5>>0]|0,oa)|0;oa=Y(h[Aa+q>>0]|0,na)|0;na=Y(h[Aa+N>>0]|0,za)|0;za=pa+16384+ra+ya+qa>>15;b[ea>>0]=za>>>0<256?za:(za|0)>0?255:0;za=ja+16384+ma+oa+na>>15;b[ea+1>>0]=za>>>0<256?za:(za|0)>0?255:0;za=d[ga>>1]|0;ga=Y(za,h[Aa+2>>0]|0)|0;na=d[Ga>>1]|0;Ga=Y(na,h[Aa+6>>0]|0)|0;oa=d[ia>>1]|0;ia=Y(oa,h[Aa+K>>0]|0)|0;ma=d[da>>1]|0;da=Y(ma,h[Aa+O>>0]|0)|0;ja=Y(h[Aa+3>>0]|0,za)|0;za=Y(h[Aa+7>>0]|0,na)|0;na=Y(h[Aa+L>>0]|0,oa)|0;oa=Y(h[Aa+P>>0]|0,ma)|0;ma=ga+16384+Ga+ia+da>>15;b[ea+2>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=ja+16384+za+na+oa>>15;b[ea+3>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ha=ha+1|0;if((ha|0)==(W|0))break;else ea=ea+4|0}_=T+fa|0;$=W;aa=W;ba=0;break a;break}default:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ea=Y(x,W+-1-U|0)|0;ha=U;X=T;while(1){ma=ha<<1;oa=i+(j[S+(ha<<1)>>1]<<2<<1)|0;na=y+(Y(d[R+((ma|1)<<1)>>1]|0,z)|0)+(Y(d[R+(ma<<1)>>1]|0,x)|0)|0;ma=oa+2|0;za=oa+4|0;ja=oa+6|0;da=0;do{ia=Y(d[oa>>1]|0,h[na+da>>0]|0)|0;Ga=Y(d[ma>>1]|0,h[na+(da+x)>>0]|0)|0;ga=da+z|0;Aa=Y(d[za>>1]|0,h[na+ga>>0]|0)|0;qa=ia+16384+Ga+Aa+(Y(d[ja>>1]|0,h[na+(ga+x)>>0]|0)|0)>>15;b[X+da>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;da=da+1|0}while((da|0)!=(x|0));ha=ha+1|0;if((ha|0)==(W|0))break;else X=X+x|0}_=T+x+ea|0;$=W;aa=W;ba=0;break a}}}while(0);if(($|0)<(t|0)){T=_;U=aa;V=ba;W=$+1|0}else break}}Q=Q+1|0}while((Q|0)!=(v|0));u=m;return}function _oa(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+1040|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=nrc(+p[k+((a&3)<<3)>>3])|0;d[m+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=z>>>1;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){f[o>>2]=0;f[o+4>>2]=0;C=tT(o,14)|0;D=271301;E=C+14|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,o,271316,270839,666)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<1)+2|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<1)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=d[m>>1]|0;break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<1)|0;ua=d[y+(sa+oa<<1)>>1]|0;va=d[y+(ra+qa<<1)>>1]|0;wa=d[y+(ra+oa<<1)>>1]|0;xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=p_(ja,r,i)|0;ia=p_(ja+1|0,r,i)|0;na=p_(ha,s,i)|0;oa=p_(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<1)|0;else ya=m;ra=d[ya>>1]|0;if((na|ia|0)>-1)za=y+((Y(na,a)|0)+ia<<1)|0;else za=m;na=d[za>>1]|0;if((oa|ka|0)>-1)Aa=y+((Y(oa,a)|0)+ka<<1)|0;else Aa=m;ka=d[Aa>>1]|0;if((oa|ia|0)<=-1){ta=m;ua=ka;va=na;wa=ra;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<1)|0;ua=ka;va=na;wa=ra;xa=ma;_=57}while(0);if((_|0)==57){_=0;ha=mrc(+(wa&65535)*+n[xa>>2]+ +(va&65535)*+n[xa+4>>2]+ +(ua&65535)*+n[xa+8>>2]+ +(j[ta>>1]|0)*+n[xa+12>>2])|0;la=(ha>>>0<65536?ha:(ha|0)>0?65535:0)&65535}d[ga>>1]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+2|0}$=U+(ea<<1)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ra=d[S+(ja<<1)>>1]|0;na=ra<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ra<<16>>16>-2&(na|0)<(r|0)&(ja|0)<(s|0)^1){ia=0;do{d[ha+(ia<<1)>>1]=d[m+(ia<<1)>>1]|0;ia=ia+1|0}while((ia|0)!=(x|0))}else{Ba=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{ia=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=na+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<1)|0;pa=Y(ra<<16>>16>-1?((na|0)<(r|0)?na:z):0,x)|0;Ca=Y(ra<<16>>16>-2?((oa|0)<(r|0)?oa:z):0,x)|0;oa=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<1)|0;Da=oa+(Ca<<1)|0;Ea=oa+(pa<<1)|0;Fa=sa+(Ca<<1)|0;Ga=sa+(pa<<1)|0;Ha=ia;_=75}else{Ba=ia;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(na>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=p_(na,r,i)|0;ra=p_(na+1|0,r,i)|0;ia=p_(ja,s,i)|0;pa=p_(ja+1|0,s,i)|0;if((ia|ka|0)>-1)Ia=y+((Y(ia,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ia=m;if((ia|ra|0)>-1)Ja=y+((Y(ia,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;else Ja=m;if((pa|ka|0)>-1)Ka=y+((Y(pa,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ka=m;if((pa|ra|0)<=-1){Da=m;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75;break}Da=y+((Y(pa,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75}while(0);if((_|0)==75){_=0;La=+n[Ha>>2];Ma=+n[Ha+4>>2];Na=+n[Ha+8>>2];Oa=+n[Ha+12>>2];ja=0;do{na=mrc(+(j[Ga+(ja<<1)>>1]|0)*La+ +(j[Fa+(ja<<1)>>1]|0)*Ma+ +(j[Ea+(ja<<1)>>1]|0)*Na+ +(j[Da+(ja<<1)>>1]|0)*Oa)|0;d[ha+(ja<<1)>>1]=na>>>0<65536?na:(na|0)>0?65535:0;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<1)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1)|0;ea=mrc(+(j[na>>1]|0)*+n[ja>>2]+ +(j[na+2>>1]|0)*+n[ja+4>>2]+ +(j[na+(a<<1)>>1]|0)*+n[ja+8>>2]+ +(j[na+(q<<1)>>1]|0)*+n[ja+12>>2])|0;d[fa>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+2|0}$=U+(ha<<1)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ea=ga<<1;ja=h+(j[T+(ga<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1<<1)|0;Oa=+n[ja>>2];Na=+n[ja+4>>2];Ma=+n[ja+8>>2];La=+n[ja+12>>2];Pa=Oa*+(j[na+2>>1]|0)+Na*+(j[na+6>>1]|0)+Ma*+(j[na+(q<<1)>>1]|0)+La*+(j[na+(M<<1)>>1]|0);ja=mrc(+(j[na>>1]|0)*Oa+ +(j[na+4>>1]|0)*Na+ +(j[na+(a<<1)>>1]|0)*Ma+ +(j[na+(L<<1)>>1]|0)*La)|0;d[Z>>1]=ja>>>0<65536?ja:(ja|0)>0?65535:0;ja=mrc(Pa)|0;d[Z+2>>1]=ja>>>0<65536?ja:(ja|0)>0?65535:0;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+4|0}$=U+(fa<<1)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ja=ha<<1;na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<1)+((d[S+(ja<<1)>>1]|0)*3<<1)|0;Pa=+n[na>>2];La=+n[na+4>>2];Ma=+n[na+8>>2];Na=+n[na+12>>2];Oa=Pa*+(j[ea+2>>1]|0)+La*+(j[ea+8>>1]|0)+Ma*+(j[ea+(q<<1)>>1]|0)+Na*+(j[ea+(N<<1)>>1]|0);Qa=Pa*+(j[ea+4>>1]|0)+La*+(j[ea+10>>1]|0)+Ma*+(j[ea+(L<<1)>>1]|0)+Na*+(j[ea+(O<<1)>>1]|0);na=mrc(+(j[ea>>1]|0)*Pa+ +(j[ea+6>>1]|0)*La+ +(j[ea+(a<<1)>>1]|0)*Ma+ +(j[ea+(M<<1)>>1]|0)*Na)|0;d[ga>>1]=na>>>0<65536?na:(na|0)>0?65535:0;na=mrc(Oa)|0;d[ga+2>>1]=na>>>0<65536?na:(na|0)>0?65535:0;na=mrc(Qa)|0;d[ga+4>>1]=na>>>0<65536?na:(na|0)>0?65535:0;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+6|0}$=U+(Z<<1)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){na=ha<<1;ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((na|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(na<<1)>>1]<<2<<1)|0;Qa=+n[ea>>2];Oa=+n[ea+4>>2];Na=+n[ea+8>>2];Ma=+n[ea+12>>2];La=Qa*+(j[ja+2>>1]|0)+Oa*+(j[ja+10>>1]|0)+Na*+(j[ja+(q<<1)>>1]|0)+Ma*+(j[ja+(O<<1)>>1]|0);ea=mrc(+(j[ja>>1]|0)*Qa+ +(j[ja+8>>1]|0)*Oa+ +(j[ja+(a<<1)>>1]|0)*Na+ +(j[ja+(N<<1)>>1]|0)*Ma)|0;d[fa>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ea=mrc(La)|0;d[fa+2>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;La=Qa*+(j[ja+6>>1]|0)+Oa*+(j[ja+14>>1]|0)+Na*+(j[ja+(M<<1)>>1]|0)+Ma*+(j[ja+(Q<<1)>>1]|0);ea=mrc(+(j[ja+4>>1]|0)*Qa+ +(j[ja+12>>1]|0)*Oa+ +(j[ja+(L<<1)>>1]|0)*Na+ +(j[ja+(P<<1)>>1]|0)*Ma)|0;d[fa+4>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ea=mrc(La)|0;d[fa+6>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+8|0}$=U+(ga<<1)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<1)|0;La=+n[ja>>2];Ma=+n[ja+4>>2];Na=+n[ja+8>>2];Oa=+n[ja+12>>2];ja=0;do{ea=ja+a|0;ra=mrc(+(j[na+(ja<<1)>>1]|0)*La+ +(j[na+(ja+x<<1)>>1]|0)*Ma+ +(j[na+(ea<<1)>>1]|0)*Na+ +(j[na+(ea+x<<1)>>1]|0)*Oa)|0;d[Z+(ja<<1)>>1]=ra>>>0<65536?ra:(ra|0)>0?65535:0;ja=ja+1|0}while((ja|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<1)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function $oa(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+1040|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=nrc(+p[k+((a&3)<<3)>>3])|0;d[m+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=z>>>1;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){f[o>>2]=0;f[o+4>>2]=0;C=tT(o,14)|0;D=271301;E=C+14|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,o,271316,270839,666)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<1)+2|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<1)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=d[m>>1]|0;break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<1)|0;ua=d[y+(sa+oa<<1)>>1]|0;va=d[y+(ra+qa<<1)>>1]|0;wa=d[y+(ra+oa<<1)>>1]|0;xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=p_(ja,r,i)|0;ia=p_(ja+1|0,r,i)|0;na=p_(ha,s,i)|0;oa=p_(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<1)|0;else ya=m;ra=d[ya>>1]|0;if((na|ia|0)>-1)za=y+((Y(na,a)|0)+ia<<1)|0;else za=m;na=d[za>>1]|0;if((oa|ka|0)>-1)Aa=y+((Y(oa,a)|0)+ka<<1)|0;else Aa=m;ka=d[Aa>>1]|0;if((oa|ia|0)<=-1){ta=m;ua=ka;va=na;wa=ra;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<1)|0;ua=ka;va=na;wa=ra;xa=ma;_=57}while(0);if((_|0)==57){_=0;ha=mrc(+(wa<<16>>16)*+n[xa>>2]+ +(va<<16>>16)*+n[xa+4>>2]+ +(ua<<16>>16)*+n[xa+8>>2]+ +(d[ta>>1]|0)*+n[xa+12>>2])|0;la=((ha+32768|0)>>>0<65536?ha:(ha|0)>0?32767:32768)&65535}d[ga>>1]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+2|0}$=U+(ea<<1)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ra=d[S+(ja<<1)>>1]|0;na=ra<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ra<<16>>16>-2&(na|0)<(r|0)&(ja|0)<(s|0)^1){ia=0;do{d[ha+(ia<<1)>>1]=d[m+(ia<<1)>>1]|0;ia=ia+1|0}while((ia|0)!=(x|0))}else{Ba=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{ia=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=na+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<1)|0;pa=Y(ra<<16>>16>-1?((na|0)<(r|0)?na:z):0,x)|0;Ca=Y(ra<<16>>16>-2?((oa|0)<(r|0)?oa:z):0,x)|0;oa=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<1)|0;Da=oa+(Ca<<1)|0;Ea=oa+(pa<<1)|0;Fa=sa+(Ca<<1)|0;Ga=sa+(pa<<1)|0;Ha=ia;_=75}else{Ba=ia;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(na>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=p_(na,r,i)|0;ra=p_(na+1|0,r,i)|0;ia=p_(ja,s,i)|0;pa=p_(ja+1|0,s,i)|0;if((ia|ka|0)>-1)Ia=y+((Y(ia,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ia=m;if((ia|ra|0)>-1)Ja=y+((Y(ia,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;else Ja=m;if((pa|ka|0)>-1)Ka=y+((Y(pa,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ka=m;if((pa|ra|0)<=-1){Da=m;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75;break}Da=y+((Y(pa,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75}while(0);if((_|0)==75){_=0;La=+n[Ha>>2];Ma=+n[Ha+4>>2];Na=+n[Ha+8>>2];Oa=+n[Ha+12>>2];ja=0;do{na=mrc(+(d[Ga+(ja<<1)>>1]|0)*La+ +(d[Fa+(ja<<1)>>1]|0)*Ma+ +(d[Ea+(ja<<1)>>1]|0)*Na+ +(d[Da+(ja<<1)>>1]|0)*Oa)|0;d[ha+(ja<<1)>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<1)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1)|0;ea=mrc(+(d[na>>1]|0)*+n[ja>>2]+ +(d[na+2>>1]|0)*+n[ja+4>>2]+ +(d[na+(a<<1)>>1]|0)*+n[ja+8>>2]+ +(d[na+(q<<1)>>1]|0)*+n[ja+12>>2])|0;d[fa>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+2|0}$=U+(ha<<1)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ea=ga<<1;ja=h+(j[T+(ga<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1<<1)|0;Oa=+n[ja>>2];Na=+n[ja+4>>2];Ma=+n[ja+8>>2];La=+n[ja+12>>2];Pa=Oa*+(d[na+2>>1]|0)+Na*+(d[na+6>>1]|0)+Ma*+(d[na+(q<<1)>>1]|0)+La*+(d[na+(M<<1)>>1]|0);ja=mrc(+(d[na>>1]|0)*Oa+ +(d[na+4>>1]|0)*Na+ +(d[na+(a<<1)>>1]|0)*Ma+ +(d[na+(L<<1)>>1]|0)*La)|0;d[Z>>1]=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;ja=mrc(Pa)|0;d[Z+2>>1]=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+4|0}$=U+(fa<<1)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ja=ha<<1;na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<1)+((d[S+(ja<<1)>>1]|0)*3<<1)|0;Pa=+n[na>>2];La=+n[na+4>>2];Ma=+n[na+8>>2];Na=+n[na+12>>2];Oa=Pa*+(d[ea+2>>1]|0)+La*+(d[ea+8>>1]|0)+Ma*+(d[ea+(q<<1)>>1]|0)+Na*+(d[ea+(N<<1)>>1]|0);Qa=Pa*+(d[ea+4>>1]|0)+La*+(d[ea+10>>1]|0)+Ma*+(d[ea+(L<<1)>>1]|0)+Na*+(d[ea+(O<<1)>>1]|0);na=mrc(+(d[ea>>1]|0)*Pa+ +(d[ea+6>>1]|0)*La+ +(d[ea+(a<<1)>>1]|0)*Ma+ +(d[ea+(M<<1)>>1]|0)*Na)|0;d[ga>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;na=mrc(Oa)|0;d[ga+2>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;na=mrc(Qa)|0;d[ga+4>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+6|0}$=U+(Z<<1)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){na=ha<<1;ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((na|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(na<<1)>>1]<<2<<1)|0;Qa=+n[ea>>2];Oa=+n[ea+4>>2];Na=+n[ea+8>>2];Ma=+n[ea+12>>2];La=Qa*+(d[ja+2>>1]|0)+Oa*+(d[ja+10>>1]|0)+Na*+(d[ja+(q<<1)>>1]|0)+Ma*+(d[ja+(O<<1)>>1]|0);ea=mrc(+(d[ja>>1]|0)*Qa+ +(d[ja+8>>1]|0)*Oa+ +(d[ja+(a<<1)>>1]|0)*Na+ +(d[ja+(N<<1)>>1]|0)*Ma)|0;d[fa>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ea=mrc(La)|0;d[fa+2>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;La=Qa*+(d[ja+6>>1]|0)+Oa*+(d[ja+14>>1]|0)+Na*+(d[ja+(M<<1)>>1]|0)+Ma*+(d[ja+(Q<<1)>>1]|0);ea=mrc(+(d[ja+4>>1]|0)*Qa+ +(d[ja+12>>1]|0)*Oa+ +(d[ja+(L<<1)>>1]|0)*Na+ +(d[ja+(P<<1)>>1]|0)*Ma)|0;d[fa+4>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ea=mrc(La)|0;d[fa+6>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+8|0}$=U+(ga<<1)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<1)|0;La=+n[ja>>2];Ma=+n[ja+4>>2];Na=+n[ja+8>>2];Oa=+n[ja+12>>2];ja=0;do{ea=ja+a|0;ra=mrc(+(d[na+(ja<<1)>>1]|0)*La+ +(d[na+(ja+x<<1)>>1]|0)*Ma+ +(d[na+(ea<<1)>>1]|0)*Na+ +(d[na+(ea+x<<1)>>1]|0)*Oa)|0;d[Z+(ja<<1)>>1]=(ra+32768|0)>>>0<65536?ra:(ra|0)>0?32767:32768;ja=ja+1|0}while((ja|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<1)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function apa(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+2064|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{n[m+(a<<2)>>2]=+p[k+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=z>>>2;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){f[o>>2]=0;f[o+4>>2]=0;C=tT(o,14)|0;D=271301;E=C+14|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,o,271316,270839,666)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<2)+4|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<2)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=+n[m>>2];break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<2)|0;ua=+n[y+(sa+oa<<2)>>2];va=+n[y+(ra+qa<<2)>>2];wa=+n[y+(ra+oa<<2)>>2];xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=p_(ja,r,i)|0;ia=p_(ja+1|0,r,i)|0;na=p_(ha,s,i)|0;oa=p_(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<2)|0;else ya=m;za=+n[ya>>2];if((na|ia|0)>-1)Aa=y+((Y(na,a)|0)+ia<<2)|0;else Aa=m;Ba=+n[Aa>>2];if((oa|ka|0)>-1)Ca=y+((Y(oa,a)|0)+ka<<2)|0;else Ca=m;Da=+n[Ca>>2];if((oa|ia|0)<=-1){ta=m;ua=Da;va=Ba;wa=za;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<2)|0;ua=Da;va=Ba;wa=za;xa=ma;_=57}while(0);if((_|0)==57){_=0;la=wa*+n[xa>>2]+va*+n[xa+4>>2]+ua*+n[xa+8>>2]+ +n[ta>>2]*+n[xa+12>>2]}n[ga>>2]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+4|0}$=U+(ea<<2)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<2)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ia=d[S+(ja<<1)>>1]|0;oa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(oa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{f[ha+(na<<2)>>2]=f[m+(na<<2)>>2];na=na+1|0}while((na|0)!=(x|0))}else{Ea=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){ra=oa+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<2)|0;pa=Y(ia<<16>>16>-1?((oa|0)<(r|0)?oa:z):0,x)|0;Fa=Y(ia<<16>>16>-2?((ra|0)<(r|0)?ra:z):0,x)|0;ra=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<2)|0;Ga=ra+(Fa<<2)|0;Ha=ra+(pa<<2)|0;Ia=sa+(Fa<<2)|0;Ja=sa+(pa<<2)|0;Ka=na;_=75}else{Ea=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(oa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=p_(oa,r,i)|0;ia=p_(oa+1|0,r,i)|0;na=p_(ja,s,i)|0;pa=p_(ja+1|0,s,i)|0;if((na|ka|0)>-1)La=y+((Y(na,a)|0)<<2)+((Y(ka,x)|0)<<2)|0;else La=m;if((na|ia|0)>-1)Ma=y+((Y(na,a)|0)<<2)+((Y(ia,x)|0)<<2)|0;else Ma=m;if((pa|ka|0)>-1)Na=y+((Y(pa,a)|0)<<2)+((Y(ka,x)|0)<<2)|0;else Na=m;if((pa|ia|0)<=-1){Ga=m;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75;break}Ga=y+((Y(pa,a)|0)<<2)+((Y(ia,x)|0)<<2)|0;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75}while(0);if((_|0)==75){_=0;ja=Ka+4|0;oa=Ka+8|0;ia=Ka+12|0;pa=0;do{n[ha+(pa<<2)>>2]=+n[Ja+(pa<<2)>>2]*+n[Ka>>2]+ +n[Ia+(pa<<2)>>2]*+n[ja>>2]+ +n[Ha+(pa<<2)>>2]*+n[oa>>2]+ +n[Ga+(pa<<2)>>2]*+n[ia>>2];pa=pa+1|0}while((pa|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<2)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;pa=h+(j[T+(Z<<1)>>1]<<2<<2)|0;ia=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(ea<<1)>>1]<<2)|0;n[fa>>2]=+n[ia>>2]*+n[pa>>2]+ +n[ia+4>>2]*+n[pa+4>>2]+ +n[ia+(a<<2)>>2]*+n[pa+8>>2]+ +n[ia+(q<<2)>>2]*+n[pa+12>>2];Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+4|0}$=U+(ha<<2)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){pa=ga<<1;ia=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((pa|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(pa<<1)>>1]<<1<<2)|0;za=+n[ia>>2];Ba=+n[ia+4>>2];Da=+n[ia+8>>2];Oa=+n[ia+12>>2];Pa=za*+n[ea+4>>2]+Ba*+n[ea+12>>2]+Da*+n[ea+(q<<2)>>2]+Oa*+n[ea+(M<<2)>>2];n[Z>>2]=+n[ea>>2]*za+ +n[ea+8>>2]*Ba+ +n[ea+(a<<2)>>2]*Da+ +n[ea+(L<<2)>>2]*Oa;n[Z+4>>2]=Pa;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+8|0}$=U+(fa<<2)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ea=ha<<1;ia=h+(j[T+(ha<<1)>>1]<<2<<2)|0;pa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+((d[S+(ea<<1)>>1]|0)*3<<2)|0;Pa=+n[ia>>2];Oa=+n[ia+4>>2];Da=+n[ia+8>>2];Ba=+n[ia+12>>2];za=Pa*+n[pa+4>>2]+Oa*+n[pa+16>>2]+Da*+n[pa+(q<<2)>>2]+Ba*+n[pa+(N<<2)>>2];Qa=Pa*+n[pa+8>>2]+Oa*+n[pa+20>>2]+Da*+n[pa+(L<<2)>>2]+Ba*+n[pa+(O<<2)>>2];n[ga>>2]=+n[pa>>2]*Pa+ +n[pa+12>>2]*Oa+ +n[pa+(a<<2)>>2]*Da+ +n[pa+(M<<2)>>2]*Ba;n[ga+4>>2]=za;n[ga+8>>2]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+12|0}$=U+(Z<<2)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){pa=ha<<1;ia=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((pa|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(pa<<1)>>1]<<2<<2)|0;Qa=+n[ia>>2];pa=ia+4|0;za=+n[pa>>2];oa=ia+8|0;Ba=+n[oa>>2];ja=ia+12|0;Da=+n[ja>>2];Oa=Qa*+n[ea+4>>2]+za*+n[ea+20>>2]+Ba*+n[ea+(q<<2)>>2]+Da*+n[ea+(O<<2)>>2];n[fa>>2]=+n[ea>>2]*Qa+ +n[ea+16>>2]*za+ +n[ea+(a<<2)>>2]*Ba+ +n[ea+(N<<2)>>2]*Da;n[fa+4>>2]=Oa;Oa=+n[ia>>2];Da=+n[pa>>2];Ba=+n[oa>>2];za=+n[ja>>2];Qa=Oa*+n[ea+12>>2]+Da*+n[ea+28>>2]+Ba*+n[ea+(M<<2)>>2]+za*+n[ea+(Q<<2)>>2];n[fa+8>>2]=+n[ea+8>>2]*Oa+ +n[ea+24>>2]*Da+ +n[ea+(L<<2)>>2]*Ba+ +n[ea+(P<<2)>>2]*za;n[fa+12>>2]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+16|0}$=U+(ga<<2)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<2)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;oa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<2)|0;ea=ja+4|0;pa=ja+8|0;ia=ja+12|0;ka=0;do{na=ka+a|0;n[Z+(ka<<2)>>2]=+n[oa+(ka<<2)>>2]*+n[ja>>2]+ +n[oa+(ka+x<<2)>>2]*+n[ea>>2]+ +n[oa+(na<<2)>>2]*+n[pa>>2]+ +n[oa+(na+x<<2)>>2]*+n[ia>>2];ka=ka+1|0}while((ka|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<2)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function bpa(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+4112|0;m=l;o=l+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{p[m+(a<<3)>>3]=+p[k+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=z>>>3;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){f[o>>2]=0;f[o+4>>2]=0;C=tT(o,14)|0;D=271301;E=C+14|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));z5(-215,o,271316,270839,666)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<3)+8|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<3)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=+p[m>>3];break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<3)|0;ua=+p[y+(sa+oa<<3)>>3];va=+p[y+(ra+qa<<3)>>3];wa=+p[y+(ra+oa<<3)>>3];xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=p_(ja,r,i)|0;ia=p_(ja+1|0,r,i)|0;na=p_(ha,s,i)|0;oa=p_(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<3)|0;else ya=m;za=+p[ya>>3];if((na|ia|0)>-1)Aa=y+((Y(na,a)|0)+ia<<3)|0;else Aa=m;Ba=+p[Aa>>3];if((oa|ka|0)>-1)Ca=y+((Y(oa,a)|0)+ka<<3)|0;else Ca=m;Da=+p[Ca>>3];if((oa|ia|0)<=-1){ta=m;ua=Da;va=Ba;wa=za;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<3)|0;ua=Da;va=Ba;wa=za;xa=ma;_=57}while(0);if((_|0)==57){_=0;la=wa*+n[xa>>2]+va*+n[xa+4>>2]+ua*+n[xa+8>>2]+ +p[ta>>3]*+n[xa+12>>2]}p[ga>>3]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+8|0}$=U+(ea<<3)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<3)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ia=d[S+(ja<<1)>>1]|0;oa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(oa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{p[ha+(na<<3)>>3]=+p[m+(na<<3)>>3];na=na+1|0}while((na|0)!=(x|0))}else{Ea=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){ra=oa+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<3)|0;pa=Y(ia<<16>>16>-1?((oa|0)<(r|0)?oa:z):0,x)|0;Fa=Y(ia<<16>>16>-2?((ra|0)<(r|0)?ra:z):0,x)|0;ra=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<3)|0;Ga=ra+(Fa<<3)|0;Ha=ra+(pa<<3)|0;Ia=sa+(Fa<<3)|0;Ja=sa+(pa<<3)|0;Ka=na;_=75}else{Ea=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(oa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=p_(oa,r,i)|0;ia=p_(oa+1|0,r,i)|0;na=p_(ja,s,i)|0;pa=p_(ja+1|0,s,i)|0;if((na|ka|0)>-1)La=y+((Y(na,a)|0)<<3)+((Y(ka,x)|0)<<3)|0;else La=m;if((na|ia|0)>-1)Ma=y+((Y(na,a)|0)<<3)+((Y(ia,x)|0)<<3)|0;else Ma=m;if((pa|ka|0)>-1)Na=y+((Y(pa,a)|0)<<3)+((Y(ka,x)|0)<<3)|0;else Na=m;if((pa|ia|0)<=-1){Ga=m;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75;break}Ga=y+((Y(pa,a)|0)<<3)+((Y(ia,x)|0)<<3)|0;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75}while(0);if((_|0)==75){_=0;za=+n[Ka>>2];Ba=+n[Ka+4>>2];Da=+n[Ka+8>>2];Oa=+n[Ka+12>>2];ja=0;do{p[ha+(ja<<3)>>3]=+p[Ja+(ja<<3)>>3]*za+ +p[Ia+(ja<<3)>>3]*Ba+ +p[Ha+(ja<<3)>>3]*Da+ +p[Ga+(ja<<3)>>3]*Oa;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<3)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;oa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ea<<1)>>1]<<3)|0;p[fa>>3]=+p[oa>>3]*+n[ja>>2]+ +p[oa+8>>3]*+n[ja+4>>2]+ +p[oa+(a<<3)>>3]*+n[ja+8>>2]+ +p[oa+(q<<3)>>3]*+n[ja+12>>2];Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+8|0}$=U+(ha<<3)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ja=ga<<1;oa=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ja<<1)>>1]<<1<<3)|0;Oa=+n[oa>>2];Da=+n[oa+4>>2];Ba=+n[oa+8>>2];za=+n[oa+12>>2];Pa=Oa*+p[ea+8>>3]+Da*+p[ea+24>>3]+Ba*+p[ea+(q<<3)>>3]+za*+p[ea+(M<<3)>>3];p[Z>>3]=+p[ea>>3]*Oa+ +p[ea+16>>3]*Da+ +p[ea+(a<<3)>>3]*Ba+ +p[ea+(L<<3)>>3]*za;p[Z+8>>3]=Pa;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+16|0}$=U+(fa<<3)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ea=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+((d[S+(ea<<1)>>1]|0)*3<<3)|0;Pa=+n[oa>>2];za=+n[oa+4>>2];Ba=+n[oa+8>>2];Da=+n[oa+12>>2];Oa=Pa*+p[ja+8>>3]+za*+p[ja+32>>3]+Ba*+p[ja+(q<<3)>>3]+Da*+p[ja+(N<<3)>>3];Qa=Pa*+p[ja+16>>3]+za*+p[ja+40>>3]+Ba*+p[ja+(L<<3)>>3]+Da*+p[ja+(O<<3)>>3];p[ga>>3]=+p[ja>>3]*Pa+ +p[ja+24>>3]*za+ +p[ja+(a<<3)>>3]*Ba+ +p[ja+(M<<3)>>3]*Da;p[ga+8>>3]=Oa;p[ga+16>>3]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+24|0}$=U+(Z<<3)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){ja=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ja<<1)>>1]<<2<<3)|0;Qa=+n[oa>>2];Oa=+n[oa+4>>2];Da=+n[oa+8>>2];Ba=+n[oa+12>>2];za=Qa*+p[ea+8>>3]+Oa*+p[ea+40>>3]+Da*+p[ea+(q<<3)>>3]+Ba*+p[ea+(O<<3)>>3];p[fa>>3]=+p[ea>>3]*Qa+ +p[ea+32>>3]*Oa+ +p[ea+(a<<3)>>3]*Da+ +p[ea+(N<<3)>>3]*Ba;p[fa+8>>3]=za;za=Qa*+p[ea+24>>3]+Oa*+p[ea+56>>3]+Da*+p[ea+(M<<3)>>3]+Ba*+p[ea+(Q<<3)>>3];p[fa+16>>3]=+p[ea+16>>3]*Qa+ +p[ea+48>>3]*Oa+ +p[ea+(L<<3)>>3]*Da+ +p[ea+(P<<3)>>3]*Ba;p[fa+24>>3]=za;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+32|0}$=U+(ga<<3)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<3)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<3)|0;za=+n[oa>>2];Ba=+n[oa+4>>2];Da=+n[oa+8>>2];Oa=+n[oa+12>>2];oa=0;do{ea=oa+a|0;p[Z+(oa<<3)>>3]=+p[ja+(oa<<3)>>3]*za+ +p[ja+(oa+x<<3)>>3]*Ba+ +p[ja+(ea<<3)>>3]*Da+ +p[ja+(ea+x<<3)>>3]*Oa;oa=oa+1|0}while((oa|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<3)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function cpa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+512|0;j=i;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=(f[a>>2]|0)>>>3&511;q=k+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{t=nrc(+p[h+((a&3)<<3)>>3])|0;b[j+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(q|0));if(f[c>>2]&16384){a=(f[e>>2]&16384|0)!=0;h=Y(a?o:1,n)|0;if(a){v=h;w=1}else{x=h;y=5}}else{x=n;y=5}if((y|0)==5)if((o|0)>0){v=x;w=o}else{u=i;return}o=c+16|0;x=c+44|0;c=e+16|0;n=e+44|0;e=(k|0)==0;k=(v|0)>0;h=l+-1|0;a=m+-1|0;t=(q|0)==3;z=(q|0)==4;A=(g|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[x>>2]>>2]|0,B)|0)|0;D=(f[c>>2]|0)+(Y(f[f[n>>2]>>2]|0,B)|0)|0;a:do if(e){if(k)switch(g|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<l>>>0&F>>>0<m>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(m|0)?F:a):0;K=G<<16>>16>-1?((H|0)<(l|0)?H:h):0}H=r+((Y(J,s)|0)+K)|0;b[C+E>>0]=b[H>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;H=r+((Y(F,s)|0)+G)|0;b[C+E>>0]=b[(G>>>0<l>>>0&F>>>0<m>>>0?H:j)>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}default:{E=0;do{H=E<<1;F=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;if(!(F>>>0<l>>>0&G>>>0<m>>>0)){if(!A){H=p_(F,l,g)|0;L=H;M=p_(G,m,g)|0;y=28}}else{L=F;M=G;y=28}if((y|0)==28){y=0;G=r+((Y(M,s)|0)+L)|0;b[C+E>>0]=b[G>>0]|0}E=E+1|0}while((E|0)!=(v|0))}}}else if(k){if(A){E=0;G=C;while(1){F=E<<1;H=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(H>>>0<l>>>0&I>>>0<m>>>0){F=r+(Y(I,s)|0)|0;if(t){N=F+(H*3|0)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;b[G+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[G+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(v|0))break a;else G=G+q|0}}else{O=0;P=C}while(1){G=O<<1;E=d[D+(G<<1)>>1]|0;H=E<<16>>16;I=d[D+((G|1)<<1)>>1]|0;G=I<<16>>16;b:do if(H>>>0<l>>>0&G>>>0<m>>>0){F=r+(Y(G,s)|0)|0;if(t){N=F+(H*3|0)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;b[P+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[P+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}else{switch(g|0){case 5:{break b;break}case 1:{Q=r+(Y(I<<16>>16>-1?((G|0)<(m|0)?G:a):0,s)|0)+(Y(E<<16>>16>-1?((H|0)<(l|0)?H:h):0,q)|0)|0;break}case 0:{Q=j;break}default:{F=p_(H,l,g)|0;Q=r+(Y(p_(G,m,g)|0,s)|0)+(Y(F,q)|0)|0}}F=0;do{b[P+F>>0]=b[Q+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);O=O+1|0;if((O|0)==(v|0))break;else P=P+q|0}}while(0);B=B+1|0}while((B|0)!=(w|0));u=i;return}function dpa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+512|0;j=i;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=(f[a>>2]|0)>>>3&511;q=k+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{t=nrc(+p[h+((a&3)<<3)>>3])|0;b[j+a>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+1|0}while((a|0)!=(q|0));if(f[c>>2]&16384){a=(f[e>>2]&16384|0)!=0;h=Y(a?o:1,n)|0;if(a){v=h;w=1}else{x=h;y=5}}else{x=n;y=5}if((y|0)==5)if((o|0)>0){v=x;w=o}else{u=i;return}o=c+16|0;x=c+44|0;c=e+16|0;n=e+44|0;e=(k|0)==0;k=(v|0)>0;h=l+-1|0;a=m+-1|0;t=(q|0)==3;z=(q|0)==4;A=(g|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[x>>2]>>2]|0,B)|0)|0;D=(f[c>>2]|0)+(Y(f[f[n>>2]>>2]|0,B)|0)|0;a:do if(e){if(k)switch(g|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<l>>>0&F>>>0<m>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(m|0)?F:a):0;K=G<<16>>16>-1?((H|0)<(l|0)?H:h):0}H=r+((Y(J,s)|0)+K)|0;b[C+E>>0]=b[H>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;H=r+((Y(F,s)|0)+G)|0;b[C+E>>0]=b[(G>>>0<l>>>0&F>>>0<m>>>0?H:j)>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}default:{E=0;do{H=E<<1;F=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;if(!(F>>>0<l>>>0&G>>>0<m>>>0)){if(!A){H=p_(F,l,g)|0;L=H;M=p_(G,m,g)|0;y=28}}else{L=F;M=G;y=28}if((y|0)==28){y=0;G=r+((Y(M,s)|0)+L)|0;b[C+E>>0]=b[G>>0]|0}E=E+1|0}while((E|0)!=(v|0))}}}else if(k){if(A){E=0;G=C;while(1){F=E<<1;H=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(H>>>0<l>>>0&I>>>0<m>>>0){F=r+(Y(I,s)|0)|0;if(t){N=F+(H*3|0)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;b[G+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[G+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(v|0))break a;else G=G+q|0}}else{O=0;P=C}while(1){G=O<<1;E=d[D+(G<<1)>>1]|0;H=E<<16>>16;I=d[D+((G|1)<<1)>>1]|0;G=I<<16>>16;b:do if(H>>>0<l>>>0&G>>>0<m>>>0){F=r+(Y(G,s)|0)|0;if(t){N=F+(H*3|0)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;b[P+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[P+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}else{switch(g|0){case 5:{break b;break}case 1:{Q=r+(Y(I<<16>>16>-1?((G|0)<(m|0)?G:a):0,s)|0)+(Y(E<<16>>16>-1?((H|0)<(l|0)?H:h):0,q)|0)|0;break}case 0:{Q=j;break}default:{F=p_(H,l,g)|0;Q=r+(Y(p_(G,m,g)|0,s)|0)+(Y(F,q)|0)|0}}F=0;do{b[P+F>>0]=b[Q+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);O=O+1|0;if((O|0)==(v|0))break;else P=P+q|0}}while(0);B=B+1|0}while((B|0)!=(w|0));u=i;return}function epa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+1024|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=nrc(+p[g+((a&3)<<3)>>3])|0;d[i+(a<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+1|0}while((a|0)!=(o|0));a=r>>>1;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<1)|0;else K=i;d[B+(D<<1)>>1]=d[K>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=p_(E,k,e)|0;L=F;M=p_(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;d[G+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[G+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<1)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;d[P+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[P+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<1)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<1)|0;break}case 0:{Q=i;break}default:{E=p_(F,k,e)|0;Q=q+((Y(p_(G,l,e)|0,a)|0)<<1)+((Y(E,o)|0)<<1)|0}}E=0;do{d[P+(E<<1)>>1]=d[Q+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<1)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function fpa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+1024|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=nrc(+p[g+((a&3)<<3)>>3])|0;d[i+(a<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;a=a+1|0}while((a|0)!=(o|0));a=r>>>1;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<1)|0;else K=i;d[B+(D<<1)>>1]=d[K>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=p_(E,k,e)|0;L=F;M=p_(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;d[G+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[G+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<1)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;d[P+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[P+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<1)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<1)|0;break}case 0:{Q=i;break}default:{E=p_(F,k,e)|0;Q=q+((Y(p_(G,l,e)|0,a)|0)<<1)+((Y(E,o)|0)<<1)|0}}E=0;do{d[P+(E<<1)>>1]=d[Q+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<1)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function gpa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+2048|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=nrc(+p[g+((a&3)<<3)>>3])|0;f[i+(a<<2)>>2]=s;a=a+1|0}while((a|0)!=(o|0));a=r>>>2;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<2)|0;f[B+(D<<2)>>2]=f[G>>2];D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<2)|0;else K=i;f[B+(D<<2)>>2]=f[K>>2];D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=p_(E,k,e)|0;L=F;M=p_(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<2)|0;f[B+(D<<2)>>2]=f[G>>2]}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<2)|0;if(s){N=E+(F*3<<2)|0;f[G>>2]=f[N>>2];f[G+4>>2]=f[N+4>>2];f[G+8>>2]=f[N+8>>2];break}if(y){N=E+(F<<2<<2)|0;f[G>>2]=f[N>>2];f[G+4>>2]=f[N+4>>2];f[G+8>>2]=f[N+8>>2];f[G+12>>2]=f[N+12>>2];break}N=E+((Y(F,o)|0)<<2)|0;E=0;do{f[G+(E<<2)>>2]=f[N+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<2)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<2)|0;if(s){N=E+(F*3<<2)|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];break}if(y){N=E+(F<<2<<2)|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];f[P+12>>2]=f[N+12>>2];break}N=E+((Y(F,o)|0)<<2)|0;E=0;do{f[P+(E<<2)>>2]=f[N+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<2)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<2)|0;break}case 0:{Q=i;break}default:{E=p_(F,k,e)|0;Q=q+((Y(p_(G,l,e)|0,a)|0)<<2)+((Y(E,o)|0)<<2)|0}}E=0;do{f[P+(E<<2)>>2]=f[Q+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<2)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function hpa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=u;u=u+2048|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;o=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;q=j+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{n[i+(a<<2)>>2]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(q|0));a=s>>>2;if(f[b>>2]&16384){s=(f[c>>2]&16384|0)!=0;g=Y(s?o:1,m)|0;if(s){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((o|0)>0){t=w;v=o}else{u=h;return}o=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;s=l+-1|0;y=(q|0)==3;z=(q|0)==4;A=(e|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[w>>2]>>2]|0,B)|0)|0;D=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,B)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<k>>>0&F>>>0<l>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(l|0)?F:s):0;K=G<<16>>16>-1?((H|0)<(k|0)?H:g):0}H=r+((Y(J,a)|0)+K<<2)|0;f[C+(E<<2)>>2]=f[H>>2];E=E+1|0}while((E|0)!=(t|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;if(G>>>0<k>>>0&F>>>0<l>>>0)L=r+((Y(F,a)|0)+G<<2)|0;else L=i;f[C+(E<<2)>>2]=f[L>>2];E=E+1|0}while((E|0)!=(t|0));break}default:{E=0;do{G=E<<1;F=d[D+(G<<1)>>1]|0;H=d[D+((G|1)<<1)>>1]|0;if(!(F>>>0<k>>>0&H>>>0<l>>>0)){if(!A){G=p_(F,k,e)|0;M=G;N=p_(H,l,e)|0;x=30}}else{M=F;N=H;x=30}if((x|0)==30){x=0;H=r+((Y(N,a)|0)+M<<2)|0;f[C+(E<<2)>>2]=f[H>>2]}E=E+1|0}while((E|0)!=(t|0))}}}else if(j){if(A){E=0;H=C;while(1){F=E<<1;G=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(G>>>0<k>>>0&I>>>0<l>>>0){F=r+((Y(I,a)|0)<<2)|0;if(y){O=F+(G*3<<2)|0;f[H>>2]=f[O>>2];f[H+4>>2]=f[O+4>>2];f[H+8>>2]=f[O+8>>2];break}if(z){O=F+(G<<2<<2)|0;f[H>>2]=f[O>>2];f[H+4>>2]=f[O+4>>2];f[H+8>>2]=f[O+8>>2];f[H+12>>2]=f[O+12>>2];break}O=F+((Y(G,q)|0)<<2)|0;F=0;do{f[H+(F<<2)>>2]=f[O+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(t|0))break a;else H=H+(q<<2)|0}}else{P=0;Q=C}while(1){H=P<<1;E=d[D+(H<<1)>>1]|0;G=E<<16>>16;I=d[D+((H|1)<<1)>>1]|0;H=I<<16>>16;b:do if(G>>>0<k>>>0&H>>>0<l>>>0){F=r+((Y(H,a)|0)<<2)|0;if(y){O=F+(G*3<<2)|0;f[Q>>2]=f[O>>2];f[Q+4>>2]=f[O+4>>2];f[Q+8>>2]=f[O+8>>2];break}if(z){O=F+(G<<2<<2)|0;f[Q>>2]=f[O>>2];f[Q+4>>2]=f[O+4>>2];f[Q+8>>2]=f[O+8>>2];f[Q+12>>2]=f[O+12>>2];break}O=F+((Y(G,q)|0)<<2)|0;F=0;do{f[Q+(F<<2)>>2]=f[O+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}else{switch(e|0){case 5:{break b;break}case 1:{R=r+((Y(I<<16>>16>-1?((H|0)<(l|0)?H:s):0,a)|0)<<2)+((Y(E<<16>>16>-1?((G|0)<(k|0)?G:g):0,q)|0)<<2)|0;break}case 0:{R=i;break}default:{F=p_(G,k,e)|0;R=r+((Y(p_(H,l,e)|0,a)|0)<<2)+((Y(F,q)|0)<<2)|0}}F=0;do{f[Q+(F<<2)>>2]=f[R+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}while(0);P=P+1|0;if((P|0)==(t|0))break;else Q=Q+(q<<2)|0}}while(0);B=B+1|0}while((B|0)!=(v|0));u=h;return}function ipa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+4096|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{p[i+(a<<3)>>3]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(o|0));a=r>>>3;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){s=g;t=1}else{v=g;w=5}}else{v=m;w=5}if((w|0)==5)if((n|0)>0){s=v;t=n}else{u=h;return}n=b+16|0;v=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(s|0)>0;g=k+-1|0;r=l+-1|0;x=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[v>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<3)|0;p[B+(D<<3)>>3]=+p[G>>3];D=D+1|0}while((D|0)!=(s|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<3)|0;else K=i;p[B+(D<<3)>>3]=+p[K>>3];D=D+1|0}while((D|0)!=(s|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=p_(E,k,e)|0;L=F;M=p_(G,l,e)|0;w=30}}else{L=E;M=G;w=30}if((w|0)==30){w=0;G=q+((Y(M,a)|0)+L<<3)|0;p[B+(D<<3)>>3]=+p[G>>3]}D=D+1|0}while((D|0)!=(s|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<3)|0;if(x){N=E+(F*3<<3)|0;p[G>>3]=+p[N>>3];p[G+8>>3]=+p[N+8>>3];p[G+16>>3]=+p[N+16>>3];break}if(y){N=E+(F<<2<<3)|0;p[G>>3]=+p[N>>3];p[G+8>>3]=+p[N+8>>3];p[G+16>>3]=+p[N+16>>3];p[G+24>>3]=+p[N+24>>3];break}N=E+((Y(F,o)|0)<<3)|0;E=0;do{p[G+(E<<3)>>3]=+p[N+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(s|0))break a;else G=G+(o<<3)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<3)|0;if(x){N=E+(F*3<<3)|0;p[P>>3]=+p[N>>3];p[P+8>>3]=+p[N+8>>3];p[P+16>>3]=+p[N+16>>3];break}if(y){N=E+(F<<2<<3)|0;p[P>>3]=+p[N>>3];p[P+8>>3]=+p[N+8>>3];p[P+16>>3]=+p[N+16>>3];p[P+24>>3]=+p[N+24>>3];break}N=E+((Y(F,o)|0)<<3)|0;E=0;do{p[P+(E<<3)>>3]=+p[N+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<3)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<3)|0;break}case 0:{Q=i;break}default:{E=p_(F,k,e)|0;Q=q+((Y(p_(G,l,e)|0,a)|0)<<3)+((Y(E,o)|0)<<3)|0}}E=0;do{p[P+(E<<3)>>3]=+p[Q+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(s|0))break;else P=P+(o<<3)|0}}while(0);A=A+1|0}while((A|0)!=(t|0));u=h;return}function jpa(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0;o=u;u=u+1408|0;q=o+1352|0;r=o+1288|0;s=o+1296|0;t=o+208|0;v=o+224|0;w=o+216|0;x=o+32|0;y=o;f[r>>2]=d;f[r+4>>2]=e;CY(q,r,a,b,c);f[t>>2]=i;f[t+4>>2]=j;CY(s,t,a,g,h);h=s+12|0;g=f[h>>2]|0;a=g<<1;t=v+8|0;f[v>>2]=t;j=v+4|0;f[j>>2]=a;if(a>>>0>264){i=XDc(a>>>0>1073741823?-1:a<<2)|0;f[v>>2]=i;z=i}else z=t;i=z+(g<<2)|0;if((g|0)>0){A=+p[k>>3];B=+p[k+24>>3];g=f[h>>2]|0;a=0;do{C=+(a|0);c=nrc(C*A*1024.0)|0;f[z+(a<<2)>>2]=c;c=nrc(C*B*1024.0)|0;f[i+(a<<2)>>2]=c;a=a+1|0}while((a|0)<(g|0))}g=s+8|0;a=f[g>>2]|0;f[w>>2]=0;f[w+4>>2]=a;B=+p[n+8>>3];A=+p[n+16>>3];C=+p[n+24>>3];p[y>>3]=+p[n>>3];p[y+8>>3]=B;p[y+16>>3]=A;p[y+24>>3]=C;kpa(x,q,s,l,m,y,z,i,k);k=s+4|0;i=f[k>>2]|0;if((i|0)<3)D=Y(f[h>>2]|0,f[g>>2]|0)|0;else{g=f[s+40>>2]|0;h=0;z=1;while(1){y=Y(f[g+(h<<2)>>2]|0,z)|0;h=h+1|0;if((h|0)==(i|0)){D=y;break}else z=y}}y8(w,x,+(D>>>0)*.0000152587890625);lpa(x);x=f[v>>2]|0;if((x|0)!=(t|0)){if(x|0)ZDc(x);f[v>>2]=t;f[j>>2]=264}j=s+36|0;t=f[j>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)_S(s);f[j>>2]=0;j=s+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){j=f[s+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[k>>2]|0))}k=f[s+44>>2]|0;if((k|0)!=(s+48|0))g0(k);k=q+36|0;s=f[k>>2]|0;if(s|0?(t=s+12|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)_S(q);f[k>>2]=0;k=q+16|0;s=q+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[s>>2]|0)>0){k=f[q+40>>2]|0;t=0;do{f[k+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=o;return}g0(s);u=o;return}function kpa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;f[a>>2]=58e3;k=a+4|0;f[k>>2]=f[b>>2];l=a+8|0;m=b+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;q=a+48|0;f[q>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[b+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;ZS(k,b)}b=a+60|0;f[b>>2]=f[c>>2];k=a+64|0;l=c+4|0;f[k>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;q=a+104|0;f[q>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[c+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];r=a+116|0;f[r>>2]=d;s=a+120|0;f[s>>2]=e;t=+p[g>>3];u=a+128|0;p[u>>3]=t;v=g+8|0;w=+p[v>>3];x=a+136|0;p[x>>3]=w;y=g+16|0;z=+p[y>>3];A=a+144|0;p[A>>3]=z;B=g+24|0;C=+p[B>>3];D=a+152|0;p[D>>3]=C;E=a+160|0;f[E>>2]=h;F=a+164|0;f[F>>2]=i;G=a+168|0;f[G>>2]=j;return}else{f[k>>2]=0;ZS(b,c);r=a+116|0;f[r>>2]=d;s=a+120|0;f[s>>2]=e;t=+p[g>>3];u=a+128|0;p[u>>3]=t;v=g+8|0;w=+p[v>>3];x=a+136|0;p[x>>3]=w;y=g+16|0;z=+p[y>>3];A=a+144|0;p[A>>3]=z;B=g+24|0;C=+p[B>>3];D=a+152|0;p[D>>3]=C;E=a+160|0;f[E>>2]=h;F=a+164|0;f[F>>2]=i;G=a+168|0;f[G>>2]=j;return}}function lpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58e3;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function mpa(a){a=a|0;lpa(a);YDc(a);return}function npa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;c=u;u=u+24912|0;e=c+8520|0;g=c+328|0;h=c+272|0;i=c+216|0;j=c+160|0;k=c+104|0;l=c+88|0;m=c+72|0;n=c+56|0;o=c;q=a+116|0;r=(f[q>>2]|0)==0?512:16;s=a+60|0;t=f[a+68>>2]|0;v=4096/(((t|0)<32?t:32)|0)|0;w=a+72|0;x=f[w>>2]|0;y=(x|0)<(v|0)?x:v;v=4096/(y|0)|0;x=(t|0)<(v|0)?t:v;v=f[b>>2]|0;t=b+4|0;if((v|0)>=(f[t>>2]|0)){u=c;return}b=h+4|0;z=h+8|0;A=h+12|0;B=h+16|0;C=h+20|0;D=h+24|0;E=h+28|0;F=h+40|0;G=h+48|0;H=h+44|0;I=h+52|0;J=i+4|0;K=i+8|0;L=i+40|0;M=i+48|0;N=i+44|0;O=i+52|0;P=k+4|0;Q=k+8|0;R=k+12|0;S=a+4|0;T=k+8|0;U=k+12|0;V=k+4|0;W=l+8|0;X=l+4|0;Z=m+8|0;_=m+12|0;$=m+4|0;aa=o+4|0;ba=o+8|0;ca=o+40|0;da=o+48|0;ea=o+44|0;fa=o+52|0;ga=n+8|0;ha=n+12|0;ia=n+4|0;ja=a+120|0;ka=a+128|0;la=o+36|0;ma=o+16|0;na=j+36|0;oa=j+16|0;pa=j+4|0;qa=j+40|0;ra=j+44|0;sa=j+48|0;ta=i+36|0;ua=i+16|0;va=h+36|0;wa=k+4|0;xa=k+8|0;ya=k+12|0;za=k+16|0;Aa=k+20|0;Ba=k+24|0;Ca=k+28|0;Da=k+40|0;Ea=k+48|0;Fa=k+44|0;Ga=k+52|0;Ha=l+8|0;Ia=l+12|0;Ja=l+4|0;Ka=m+8|0;La=m+4|0;Ma=n+8|0;Na=n+12|0;Oa=n+4|0;Pa=o+8|0;Qa=o+12|0;Ra=o+4|0;Sa=k+36|0;Ta=a+168|0;Ua=a+160|0;Va=a+164|0;a=D+8|0;Wa=Ba+8|0;Xa=v;v=f[w>>2]|0;while(1){if((v|0)>0){Ya=0;Za=v;while(1){_a=Za-Ya|0;$a=(_a|0)<(y|0)?_a:y;_a=(f[t>>2]|0)-Xa|0;ab=(_a|0)<(x|0)?_a:x;f[h>>2]=1124007947;f[b>>2]=2;f[z>>2]=ab;f[A>>2]=$a;f[B>>2]=e;f[C>>2]=e;_a=a;f[_a>>2]=0;f[_a+4>>2]=0;f[F>>2]=z;f[H>>2]=G;_a=$a<<2;f[G>>2]=_a;f[I>>2]=4;bb=e+(Y(ab,_a)|0)|0;f[E>>2]=bb;f[D>>2]=bb+(0-_a)+_a;WS(h);f[i>>2]=1124007936;_a=J;bb=_a+36|0;do{f[_a>>2]=0;_a=_a+4|0}while((_a|0)<(bb|0));f[L>>2]=K;f[N>>2]=M;f[M>>2]=0;f[O>>2]=0;f[k>>2]=Ya;f[P>>2]=Xa;f[Q>>2]=$a;f[R>>2]=ab;cT(j,s,k);if((ab|0)>0){cb=f[Ta>>2]|0;db=+p[cb+8>>3];eb=+p[cb+16>>3];fb=+p[cb+32>>3];gb=+p[cb+40>>3];cb=f[q>>2]|0;hb=(cb|0)==0;ib=($a|0)>0;jb=0;do{kb=Y(jb,$a)|0;lb=e+(kb<<1<<1)|0;mb=+(jb+Xa|0);nb=(nrc((mb*db+eb)*1024.0)|0)+r|0;ob=(nrc((mb*fb+gb)*1024.0)|0)+r|0;if(hb){if(ib){pb=f[Ua>>2]|0;qb=f[Va>>2]|0;rb=0;do{sb=rb+Ya|0;tb=(f[pb+(sb<<2)>>2]|0)+nb>>10;ub=(f[qb+(sb<<2)>>2]|0)+ob>>10;sb=rb<<1;d[lb+(sb<<1)>>1]=(tb+32768|0)>>>0<65536?tb:(tb|0)>0?32767:32768;d[lb+((sb|1)<<1)>>1]=(ub+32768|0)>>>0<65536?ub:(ub|0)>0?32767:32768;rb=rb+1|0}while((rb|0)<($a|0))}}else{rb=g+(kb<<1)|0;if(ib){qb=f[Ua>>2]|0;pb=f[Va>>2]|0;ub=0;do{sb=ub+Ya|0;tb=(f[qb+(sb<<2)>>2]|0)+nb|0;vb=(f[pb+(sb<<2)>>2]|0)+ob|0;sb=tb>>10;wb=ub<<1;d[lb+(wb<<1)>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;sb=vb>>10;d[lb+((wb|1)<<1)>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;d[rb+(ub<<1)>>1]=vb&992|tb>>>5&31;ub=ub+1|0}while((ub|0)<($a|0))}}jb=jb+1|0}while((jb|0)<(ab|0));xb=cb}else xb=f[q>>2]|0;if(!xb){f[T>>2]=0;f[U>>2]=0;f[k>>2]=16842752;f[V>>2]=S;cb=W;f[cb>>2]=0;f[cb+4>>2]=0;f[l>>2]=33619968;f[X>>2]=j;f[Z>>2]=0;f[_>>2]=0;f[m>>2]=16842752;f[$>>2]=h;f[o>>2]=1124007936;_a=aa;bb=_a+36|0;do{f[_a>>2]=0;_a=_a+4|0}while((_a|0)<(bb|0));f[ca>>2]=ba;f[ea>>2]=da;f[da>>2]=0;f[fa>>2]=0;f[ga>>2]=0;f[ha>>2]=0;f[n>>2]=16842752;f[ia>>2]=o;Moa(k,l,m,n,0,f[ja>>2]|0,ka);_a=f[la>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)_S(o);f[la>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[aa>>2]|0)>0){_a=f[ca>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[aa>>2]|0))}bb=f[ea>>2]|0;if((bb|0)!=(da|0))g0(bb)}else{f[k>>2]=1124007938;f[wa>>2]=2;f[xa>>2]=ab;f[ya>>2]=$a;f[za>>2]=g;f[Aa>>2]=g;bb=Wa;f[bb>>2]=0;f[bb+4>>2]=0;f[Da>>2]=xa;f[Fa>>2]=Ea;bb=$a<<1;f[Ea>>2]=bb;f[Ga>>2]=2;_a=g+((Y(ab,$a)|0)<<1)|0;f[Ca>>2]=_a;f[Ba>>2]=_a+(0-bb)+bb;WS(k);f[Ha>>2]=0;f[Ia>>2]=0;f[l>>2]=16842752;f[Ja>>2]=S;bb=Ka;f[bb>>2]=0;f[bb+4>>2]=0;f[m>>2]=33619968;f[La>>2]=j;f[Ma>>2]=0;f[Na>>2]=0;f[n>>2]=16842752;f[Oa>>2]=h;f[Pa>>2]=0;f[Qa>>2]=0;f[o>>2]=16842752;f[Ra>>2]=k;Moa(l,m,n,o,f[q>>2]|0,f[ja>>2]|0,ka);bb=f[Sa>>2]|0;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)_S(k);f[Sa>>2]=0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[wa>>2]|0)>0){bb=f[Da>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[wa>>2]|0))}_a=f[Fa>>2]|0;if((_a|0)!=(Ea|0))g0(_a)}_a=f[na>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)_S(j);f[na>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[pa>>2]|0)>0){_a=f[qa>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[pa>>2]|0))}bb=f[ra>>2]|0;if((bb|0)!=(sa|0))g0(bb);bb=f[ta>>2]|0;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)_S(i);f[ta>>2]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[J>>2]|0)>0){bb=f[L>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[J>>2]|0))}_a=f[N>>2]|0;if((_a|0)!=(M|0))g0(_a);_a=f[va>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)_S(h);f[va>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[b>>2]|0)>0){_a=f[F>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[b>>2]|0))}bb=f[H>>2]|0;if((bb|0)!=(G|0))g0(bb);Ya=Ya+y|0;bb=f[w>>2]|0;if((bb|0)<=(Ya|0)){yb=bb;break}else Za=bb}}else yb=v;Xa=Xa+x|0;if((Xa|0)>=(f[t>>2]|0))break;else v=yb}u=c;return}function opa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0;j=u;u=u+304|0;k=j;l=j+240|0;m=j+176|0;n=j+232|0;o=j+120|0;q=j+64|0;r=j+48|0;s=g&7;a:do if((q$(a,-1)|0)>=5){switch(g&7){case 2:case 4:break;default:break a}f[k>>2]=0;f[k+4>>2]=0;t=tT(k,89)|0;v=271355;w=t+89|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,k,271445,270839,2597)}while(0);do if((d$(a)|0)==65536){x=f[a+4>>2]|0;f[l>>2]=f[x>>2];y=l+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[x+8>>2];f[l+12>>2]=f[x+12>>2];f[l+16>>2]=f[x+16>>2];f[l+20>>2]=f[x+20>>2];f[l+24>>2]=f[x+24>>2];f[l+28>>2]=f[x+28>>2];f[l+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;C=l+44|0;f[C>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;ZS(l,x);break}}else a$(l,a,-1);while(0);do if((d$(d)|0)==65536){a=f[d+4>>2]|0;f[m>>2]=f[a>>2];x=m+4|0;y=a+4|0;f[x>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;C=m+44|0;f[C>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(m,a);break}}else a$(m,d,-1);while(0);d=f[e>>2]|0;if((d|0)>=1?(a=f[e+4>>2]|0,(a|0)>=1):0){D=a;E=d}else{d=f[l+40>>2]|0;D=f[d>>2]|0;E=f[d+4>>2]|0}f[n>>2]=E;f[n+4>>2]=D;v$(c,n,f[l>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){n=f[c+4>>2]|0;f[o>>2]=f[n>>2];D=o+4|0;E=n+4|0;f[D>>2]=f[E>>2];d=o+8|0;f[d>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];f[o+16>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];a=f[n+36>>2]|0;f[o+36>>2]=a;f[o+40>>2]=d;d=o+48|0;e=o+44|0;f[e>>2]=d;f[d>>2]=0;f[o+52>>2]=0;if(a|0){d=a+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[E>>2]|0)<3){E=f[n+44>>2]|0;d=f[e>>2]|0;f[d>>2]=f[E>>2];f[d+4>>2]=f[E+4>>2];break}else{f[D>>2]=0;ZS(o,n);break}}else a$(o,c,-1);while(0);c=l+12|0;if((f[c>>2]|0)<=0){f[k>>2]=0;F=k+4|0;f[F>>2]=0;G=tT(k,28)|0;t=G;v=271456;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,k,271445,270839,2611)}n=l+8|0;if((f[n>>2]|0)<=0){f[k>>2]=0;F=k+4|0;f[F>>2]=0;G=tT(k,28)|0;t=G;v=271456;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,k,271445,270839,2611)}G=o+16|0;F=l+16|0;if((f[G>>2]|0)==(f[F>>2]|0)){f[q>>2]=1124007936;D=q+4|0;E=q+8|0;d=q+40|0;t=D;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[d>>2]=E;e=q+48|0;a=q+44|0;f[a>>2]=e;f[e>>2]=0;f[q+52>>2]=0;x=k+8|0;f[x>>2]=0;f[x+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=q;h_(l,k);x=q+36|0;y=f[x>>2]|0;if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}z=l+36|0;y=f[z>>2]|0;if(y|0?(C=y+12|0,y=f[C>>2]|0,f[C>>2]=y+-1,(y|0)==1):0)_S(l);f[z>>2]=0;y=l+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[y>>2]|0)>0){C=f[l+40>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0;H=f[y>>2]|0}while((A|0)<(H|0));f[l>>2]=f[q>>2];if((H|0)<3)I=42;else I=44}else{f[l>>2]=f[q>>2];I=42}if((I|0)==42){H=f[D>>2]|0;if((H|0)<3){f[y>>2]=H;f[n>>2]=f[E>>2];f[c>>2]=f[q+12>>2];E=f[a>>2]|0;H=f[l+44>>2]|0;f[H>>2]=f[E>>2];f[H+4>>2]=f[E+4>>2]}else I=44}if((I|0)==44)ZS(l,q);I=q+16|0;f[F>>2]=f[I>>2];f[l+20>>2]=f[q+20>>2];f[l+24>>2]=f[q+24>>2];f[l+28>>2]=f[q+28>>2];f[l+32>>2]=f[q+32>>2];E=f[x>>2]|0;f[z>>2]=E;if(E|0?(z=E+12|0,E=f[z>>2]|0,f[z>>2]=E+-1,(E|0)==1):0)_S(q);f[x>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[D>>2]|0)>0){I=f[d>>2]|0;d=0;do{f[I+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[D>>2]|0))}D=f[a>>2]|0;if((D|0)!=(e|0))g0(D)}t=k;w=t+48|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[q>>2]=1124007942;D=q+4|0;f[D>>2]=2;e=q+8|0;f[e>>2]=2;f[q+12>>2]=3;a=q+16|0;f[a>>2]=k;f[q+20>>2]=k;d=q+24|0;I=q+40|0;x=d+8|0;f[x>>2]=0;f[x+4>>2]=0;f[I>>2]=e;e=q+48|0;x=q+44|0;f[x>>2]=e;f[e>>2]=24;f[q+52>>2]=8;f[q+28>>2]=k+48;f[d>>2]=k+48;WS(q);d=(s|0)==3?1:s;if(((f[m>>2]&4095)+-5|0)>>>0>=2){f[r>>2]=0;J=r+4|0;f[J>>2]=0;K=tT(r,76)|0;t=K;v=271485;w=t+76|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,r,271445,270839,2620)}if((f[m+8>>2]|0)!=2){f[r>>2]=0;J=r+4|0;f[J>>2]=0;K=tT(r,76)|0;t=K;v=271485;w=t+76|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,r,271445,270839,2620)}if((f[m+12>>2]|0)!=3){f[r>>2]=0;J=r+4|0;f[J>>2]=0;K=tT(r,76)|0;t=K;v=271485;w=t+76|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,r,271445,270839,2620)}v=r+8|0;f[v>>2]=0;f[v+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=q;LZ(m,r,f[q>>2]&4095,1.0,0.0);if(!(g&16)){L=+p[k>>3];g=k+32|0;M=+p[g>>3];r=k+8|0;N=+p[r>>3];v=k+24|0;O=+p[v>>3];P=L*M-N*O;Q=P!=0.0?1.0/P:0.0;P=M*Q;M=L*Q;p[k>>3]=P;L=-Q;Q=N*L;p[r>>3]=Q;N=O*L;p[v>>3]=N;p[g>>3]=M;g=k+16|0;L=+p[g>>3];v=k+40|0;O=+p[v>>3];p[g>>3]=-(P*L)-Q*O;p[v>>3]=-(L*N)-M*O}v=l+48|0;g=o+48|0;jpa(f[l>>2]&4095,f[F>>2]|0,f[v>>2]|0,f[c>>2]|0,f[n>>2]|0,f[G>>2]|0,f[g>>2]|0,f[o+12>>2]|0,f[o+8>>2]|0,k,d,h,i);i=q+36|0;h=f[i>>2]|0;if(h|0?(d=h+12|0,h=f[d>>2]|0,f[d>>2]=h+-1,(h|0)==1):0)_S(q);f[i>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[D>>2]|0)>0){a=f[I>>2]|0;I=0;do{f[a+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[D>>2]|0))}D=f[x>>2]|0;if((D|0)!=(e|0))g0(D);D=o+36|0;e=f[D>>2]|0;if(e|0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0)_S(o);f[D>>2]=0;D=o+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[D>>2]|0)>0){G=f[o+40>>2]|0;e=0;do{f[G+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[D>>2]|0))}D=f[o+44>>2]|0;if((D|0)!=(g|0))g0(D);D=m+36|0;g=f[D>>2]|0;do if(g|0){o=g+12|0;e=f[o>>2]|0;f[o>>2]=e+-1;if((e|0)!=1)break;_S(m)}while(0);f[D>>2]=0;D=m+16|0;g=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[g>>2]|0)>0){D=f[m+40>>2]|0;e=0;do{f[D+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[g>>2]|0))}g=f[m+44>>2]|0;if((g|0)!=(m+48|0))g0(g);g=l+36|0;m=f[g>>2]|0;do if(m|0){e=m+12|0;D=f[e>>2]|0;f[e>>2]=D+-1;if((D|0)!=1)break;_S(l)}while(0);f[g>>2]=0;g=l+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[g>>2]|0)>0){F=f[l+40>>2]|0;m=0;do{f[F+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[g>>2]|0))}g=f[l+44>>2]|0;if((g|0)==(v|0)){u=j;return}g0(g);u=j;return}function ppa(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0;o=u;u=u+336|0;q=o+272|0;r=o+208|0;s=o+216|0;t=o+192|0;v=o+200|0;w=o+32|0;x=o;f[r>>2]=d;f[r+4>>2]=e;CY(q,r,a,b,c);f[t>>2]=i;f[t+4>>2]=j;CY(s,t,a,g,h);h=s+8|0;g=f[h>>2]|0;f[v>>2]=0;f[v+4>>2]=g;y=+p[n+8>>3];z=+p[n+16>>3];A=+p[n+24>>3];p[x>>3]=+p[n>>3];p[x+8>>3]=y;p[x+16>>3]=z;p[x+24>>3]=A;qpa(w,q,s,k,l,m,x);x=s+4|0;m=f[x>>2]|0;if((m|0)<3)B=Y(f[s+12>>2]|0,f[h>>2]|0)|0;else{h=f[s+40>>2]|0;l=0;k=1;while(1){n=Y(f[h+(l<<2)>>2]|0,k)|0;l=l+1|0;if((l|0)==(m|0)){B=n;break}else k=n}}y8(v,w,+(B>>>0)*.0000152587890625);rpa(w);w=s+36|0;B=f[w>>2]|0;if(B|0?(v=B+12|0,B=f[v>>2]|0,f[v>>2]=B+-1,(B|0)==1):0)_S(s);f[w>>2]=0;w=s+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[s+40>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[x>>2]|0))}x=f[s+44>>2]|0;if((x|0)!=(s+48|0))g0(x);x=q+36|0;s=f[x>>2]|0;if(s|0?(B=s+12|0,s=f[B>>2]|0,f[B>>2]=s+-1,(s|0)==1):0)_S(q);f[x>>2]=0;x=q+16|0;s=q+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[q+40>>2]|0;B=0;do{f[x+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=o;return}g0(s);u=o;return}function qpa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0;f[a>>2]=58020;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;ZS(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;q=a+120|0;f[q>>2]=e;r=a+124|0;f[r>>2]=g;s=+p[h>>3];t=a+128|0;p[t>>3]=s;u=h+8|0;v=+p[u>>3];w=a+136|0;p[w>>3]=v;x=h+16|0;y=+p[x>>3];z=a+144|0;p[z>>3]=y;A=h+24|0;B=+p[A>>3];C=a+152|0;p[C>>3]=B;return}else{f[i>>2]=0;ZS(b,c);o=a+116|0;f[o>>2]=d;q=a+120|0;f[q>>2]=e;r=a+124|0;f[r>>2]=g;s=+p[h>>3];t=a+128|0;p[t>>3]=s;u=h+8|0;v=+p[u>>3];w=a+136|0;p[w>>3]=v;x=h+16|0;y=+p[x>>3];z=a+144|0;p[z>>3]=y;A=h+24|0;B=+p[A>>3];C=a+152|0;p[C>>3]=B;return}}function rpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58020;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function spa(a){a=a|0;rpa(a);YDc(a);return}function tpa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0,zb=0,Ab=0,Bb=0;c=u;u=u+6480|0;e=c+2376|0;g=c+328|0;h=c+272|0;i=c+216|0;j=c+160|0;k=c+104|0;l=c+88|0;m=c+72|0;n=c+56|0;o=c;q=a+60|0;r=f[a+72>>2]|0;s=f[a+68>>2]|0;t=1024/(((s|0)<16?s:16)|0)|0;v=(r|0)<(t|0)?r:t;t=1024/(v|0)|0;w=(s|0)<(t|0)?s:t;t=f[b>>2]|0;s=b+4|0;if((t|0)>=(f[s>>2]|0)){u=c;return}b=(r|0)>0;x=h+4|0;y=h+8|0;z=h+12|0;A=h+16|0;B=h+20|0;C=h+24|0;D=h+28|0;E=h+40|0;F=h+48|0;G=h+44|0;H=h+52|0;I=i+4|0;J=i+8|0;K=i+40|0;L=i+48|0;M=i+44|0;N=i+52|0;O=k+4|0;P=k+8|0;Q=k+12|0;R=a+120|0;S=a+4|0;T=k+8|0;U=k+12|0;V=k+4|0;W=l+8|0;X=l+4|0;Z=m+8|0;_=m+12|0;$=m+4|0;aa=o+4|0;ba=o+8|0;ca=o+40|0;da=o+48|0;ea=o+44|0;fa=o+52|0;ga=n+8|0;ha=n+12|0;ia=n+4|0;ja=a+124|0;ka=a+128|0;la=o+36|0;ma=o+16|0;na=j+36|0;oa=j+16|0;pa=j+4|0;qa=j+40|0;ra=j+44|0;sa=j+48|0;ta=i+36|0;ua=i+16|0;va=h+36|0;wa=k+4|0;xa=k+8|0;ya=k+12|0;za=k+16|0;Aa=k+20|0;Ba=k+24|0;Ca=k+28|0;Da=k+40|0;Ea=k+48|0;Fa=k+44|0;Ga=k+52|0;Ha=l+8|0;Ia=l+12|0;Ja=l+4|0;Ka=m+8|0;La=m+4|0;Ma=n+8|0;Na=n+12|0;Oa=n+4|0;Pa=o+8|0;Qa=o+12|0;Ra=o+4|0;Sa=k+36|0;Ta=a+116|0;a=C+8|0;Ua=Ba+8|0;Va=t;do{if(b){t=0;do{Wa=r-t|0;Xa=(Wa|0)<(v|0)?Wa:v;Wa=(f[s>>2]|0)-Va|0;Ya=(Wa|0)<(w|0)?Wa:w;f[h>>2]=1124007947;f[x>>2]=2;f[y>>2]=Ya;f[z>>2]=Xa;f[A>>2]=e;f[B>>2]=e;Wa=a;f[Wa>>2]=0;f[Wa+4>>2]=0;f[E>>2]=y;f[G>>2]=F;Wa=Xa<<2;f[F>>2]=Wa;f[H>>2]=4;Za=e+(Y(Ya,Wa)|0)|0;f[D>>2]=Za;f[C>>2]=Za+(0-Wa)+Wa;WS(h);f[i>>2]=1124007936;Wa=I;Za=Wa+36|0;do{f[Wa>>2]=0;Wa=Wa+4|0}while((Wa|0)<(Za|0));f[K>>2]=J;f[M>>2]=L;f[L>>2]=0;f[N>>2]=0;f[k>>2]=t;f[O>>2]=Va;f[P>>2]=Xa;f[Q>>2]=Ya;cT(j,q,k);_a=(f[R>>2]|0)==0;if((Ya|0)>0){$a=f[Ta>>2]|0;ab=+p[$a>>3];bb=+(t|0);cb=bb*ab;db=+p[$a+8>>3];eb=+p[$a+16>>3];fb=+p[$a+24>>3];gb=bb*fb;hb=+p[$a+32>>3];ib=+p[$a+40>>3];jb=+p[$a+48>>3];kb=bb*jb;bb=+p[$a+56>>3];lb=+p[$a+64>>3];$a=(Xa|0)>0;mb=0;do{nb=Y(mb,Xa)|0;ob=e+(nb<<1<<1)|0;pb=+(mb+Va|0);qb=eb+(cb+pb*db);rb=ib+(gb+pb*hb);sb=lb+(kb+pb*bb);if(_a){if($a){tb=0;do{pb=+(tb|0);ub=sb+pb*jb;vb=ub!=0.0?1.0/ub:0.0;ub=vb*(qb+pb*ab);wb=ub<2147483647.0?ub:2147483647.0;ub=vb*(rb+pb*fb);pb=ub<2147483647.0?ub:2147483647.0;xb=nrc(wb>-2147483648.0?wb:-2147483648.0)|0;yb=nrc(pb>-2147483648.0?pb:-2147483648.0)|0;zb=tb<<1;d[ob+(zb<<1)>>1]=(xb+32768|0)>>>0<65536?xb:(xb|0)>0?32767:32768;d[ob+((zb|1)<<1)>>1]=(yb+32768|0)>>>0<65536?yb:(yb|0)>0?32767:32768;tb=tb+1|0}while((tb|0)<(Xa|0))}}else{tb=g+(nb<<1)|0;if($a){yb=0;do{pb=+(yb|0);wb=sb+pb*jb;ub=wb!=0.0?32.0/wb:0.0;wb=ub*(qb+pb*ab);vb=wb<2147483647.0?wb:2147483647.0;wb=ub*(rb+pb*fb);pb=wb<2147483647.0?wb:2147483647.0;zb=nrc(vb>-2147483648.0?vb:-2147483648.0)|0;xb=nrc(pb>-2147483648.0?pb:-2147483648.0)|0;Ab=zb>>5;Bb=yb<<1;d[ob+(Bb<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;Ab=xb>>5;d[ob+((Bb|1)<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;d[tb+(yb<<1)>>1]=xb<<5&992|zb&31;yb=yb+1|0}while((yb|0)<(Xa|0))}}mb=mb+1|0}while((mb|0)<(Ya|0))}if(_a){f[T>>2]=0;f[U>>2]=0;f[k>>2]=16842752;f[V>>2]=S;mb=W;f[mb>>2]=0;f[mb+4>>2]=0;f[l>>2]=33619968;f[X>>2]=j;f[Z>>2]=0;f[_>>2]=0;f[m>>2]=16842752;f[$>>2]=h;f[o>>2]=1124007936;Wa=aa;Za=Wa+36|0;do{f[Wa>>2]=0;Wa=Wa+4|0}while((Wa|0)<(Za|0));f[ca>>2]=ba;f[ea>>2]=da;f[da>>2]=0;f[fa>>2]=0;f[ga>>2]=0;f[ha>>2]=0;f[n>>2]=16842752;f[ia>>2]=o;Moa(k,l,m,n,0,f[ja>>2]|0,ka);Wa=f[la>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)_S(o);f[la>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[aa>>2]|0)>0){Wa=f[ca>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[aa>>2]|0))}Za=f[ea>>2]|0;if((Za|0)!=(da|0))g0(Za)}else{f[k>>2]=1124007938;f[wa>>2]=2;f[xa>>2]=Ya;f[ya>>2]=Xa;f[za>>2]=g;f[Aa>>2]=g;Za=Ua;f[Za>>2]=0;f[Za+4>>2]=0;f[Da>>2]=xa;f[Fa>>2]=Ea;Za=Xa<<1;f[Ea>>2]=Za;f[Ga>>2]=2;Wa=g+((Y(Ya,Xa)|0)<<1)|0;f[Ca>>2]=Wa;f[Ba>>2]=Wa+(0-Za)+Za;WS(k);f[Ha>>2]=0;f[Ia>>2]=0;f[l>>2]=16842752;f[Ja>>2]=S;Za=Ka;f[Za>>2]=0;f[Za+4>>2]=0;f[m>>2]=33619968;f[La>>2]=j;f[Ma>>2]=0;f[Na>>2]=0;f[n>>2]=16842752;f[Oa>>2]=h;f[Pa>>2]=0;f[Qa>>2]=0;f[o>>2]=16842752;f[Ra>>2]=k;Moa(l,m,n,o,f[R>>2]|0,f[ja>>2]|0,ka);Za=f[Sa>>2]|0;if(Za|0?(Wa=Za+12|0,Za=f[Wa>>2]|0,f[Wa>>2]=Za+-1,(Za|0)==1):0)_S(k);f[Sa>>2]=0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[wa>>2]|0)>0){Za=f[Da>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[wa>>2]|0))}Wa=f[Fa>>2]|0;if((Wa|0)!=(Ea|0))g0(Wa)}Wa=f[na>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)_S(j);f[na>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[pa>>2]|0)>0){Wa=f[qa>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[pa>>2]|0))}Za=f[ra>>2]|0;if((Za|0)!=(sa|0))g0(Za);Za=f[ta>>2]|0;if(Za|0?(Wa=Za+12|0,Za=f[Wa>>2]|0,f[Wa>>2]=Za+-1,(Za|0)==1):0)_S(i);f[ta>>2]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[I>>2]|0)>0){Za=f[K>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[I>>2]|0))}Wa=f[M>>2]|0;if((Wa|0)!=(L|0))g0(Wa);Wa=f[va>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)_S(h);f[va>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[x>>2]|0)>0){Wa=f[E>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[x>>2]|0))}Za=f[G>>2]|0;if((Za|0)!=(F|0))g0(Za);t=t+v|0}while((r|0)>(t|0))}Va=Va+w|0}while((Va|0)<(f[s>>2]|0));u=c;return}function upa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+336|0;k=j;l=j+280|0;m=j+216|0;n=j+272|0;o=j+160|0;p=j+104|0;q=j+88|0;r=j+72|0;if(!(o$(a,-1)|0)){f[k>>2]=0;f[k+4>>2]=0;s=tT(k,16)|0;t=271592;v=s+16|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,k,271609,270839,2903)}do if((d$(a)|0)==65536){w=f[a+4>>2]|0;f[l>>2]=f[w>>2];x=l+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=l+8|0;f[z>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];f[l+16>>2]=f[w+16>>2];f[l+20>>2]=f[w+20>>2];f[l+24>>2]=f[w+24>>2];f[l+28>>2]=f[w+28>>2];f[l+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[l+36>>2]=A;f[l+40>>2]=z;z=l+48|0;B=l+44|0;f[B>>2]=z;f[z>>2]=0;f[l+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(l,w);break}}else a$(l,a,-1);while(0);do if((d$(d)|0)==65536){a=f[d+4>>2]|0;f[m>>2]=f[a>>2];w=m+4|0;x=a+4|0;f[w>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];z=f[a+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=y;y=m+48|0;B=m+44|0;f[B>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[a+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;ZS(m,a);break}}else a$(m,d,-1);while(0);d=f[e>>2]|0;if((d|0)>=1?(a=f[e+4>>2]|0,(a|0)>=1):0){C=a;D=d}else{d=f[l+40>>2]|0;C=f[d>>2]|0;D=f[d+4>>2]|0}f[n>>2]=D;f[n+4>>2]=C;v$(c,n,f[l>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){n=f[c+4>>2]|0;f[o>>2]=f[n>>2];C=o+4|0;D=n+4|0;f[C>>2]=f[D>>2];d=o+8|0;f[d>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];a=o+16|0;f[a>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];e=f[n+36>>2]|0;f[o+36>>2]=e;f[o+40>>2]=d;d=o+48|0;w=o+44|0;f[w>>2]=d;f[d>>2]=0;f[o+52>>2]=0;if(e|0){d=e+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[D>>2]|0)<3){D=f[n+44>>2]|0;d=f[w>>2]|0;f[d>>2]=f[D>>2];f[d+4>>2]=f[D+4>>2];E=a;break}else{f[C>>2]=0;ZS(o,n);E=a;break}}else{a$(o,c,-1);E=o+16|0}while(0);c=l+16|0;if((f[E>>2]|0)==(f[c>>2]|0)){f[p>>2]=1124007936;a=p+4|0;n=p+8|0;C=p+40|0;s=a;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[C>>2]=n;D=p+48|0;d=p+44|0;f[d>>2]=D;f[D>>2]=0;f[p+52>>2]=0;w=k+8|0;f[w>>2]=0;f[w+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=p;h_(l,k);w=p+36|0;e=f[w>>2]|0;if(e|0){x=e+12|0;f[x>>2]=(f[x>>2]|0)+1}x=l+36|0;e=f[x>>2]|0;if(e|0?(y=e+12|0,e=f[y>>2]|0,f[y>>2]=e+-1,(e|0)==1):0)_S(l);f[x>>2]=0;e=l+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[e>>2]|0)>0){y=f[l+40>>2]|0;B=0;do{f[y+(B<<2)>>2]=0;B=B+1|0;F=f[e>>2]|0}while((B|0)<(F|0));f[l>>2]=f[p>>2];if((F|0)<3)G=38;else G=40}else{f[l>>2]=f[p>>2];G=38}if((G|0)==38){F=f[a>>2]|0;if((F|0)<3){f[e>>2]=F;f[l+8>>2]=f[n>>2];f[l+12>>2]=f[p+12>>2];n=f[d>>2]|0;F=f[l+44>>2]|0;f[F>>2]=f[n>>2];f[F+4>>2]=f[n+4>>2]}else G=40}if((G|0)==40)ZS(l,p);G=p+16|0;f[c>>2]=f[G>>2];f[l+20>>2]=f[p+20>>2];f[l+24>>2]=f[p+24>>2];f[l+28>>2]=f[p+28>>2];f[l+32>>2]=f[p+32>>2];n=f[w>>2]|0;f[x>>2]=n;if(n|0?(x=n+12|0,n=f[x>>2]|0,f[x>>2]=n+-1,(n|0)==1):0)_S(p);f[w>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){G=f[C>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[a>>2]|0))}a=f[d>>2]|0;if((a|0)!=(D|0))g0(a)}f[p>>2]=1124007942;a=p+4|0;f[a>>2]=2;D=p+8|0;f[D>>2]=3;f[p+12>>2]=3;d=p+16|0;f[d>>2]=k;f[p+20>>2]=k;C=p+24|0;G=p+40|0;w=C+8|0;f[w>>2]=0;f[w+4>>2]=0;f[G>>2]=D;D=p+48|0;w=p+44|0;f[w>>2]=D;f[D>>2]=24;f[p+52>>2]=8;f[p+28>>2]=k+72;f[C>>2]=k+72;WS(p);k=g&7;C=(k|0)==3?1:k;if(((f[m>>2]&4095)+-5|0)>>>0>=2){f[q>>2]=0;H=q+4|0;f[H>>2]=0;I=tT(q,76)|0;s=I;t=271625;v=s+76|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,q,271609,270839,2927)}if((f[m+8>>2]|0)!=3){f[q>>2]=0;H=q+4|0;f[H>>2]=0;I=tT(q,76)|0;s=I;t=271625;v=s+76|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,q,271609,270839,2927)}if((f[m+12>>2]|0)!=3){f[q>>2]=0;H=q+4|0;f[H>>2]=0;I=tT(q,76)|0;s=I;t=271625;v=s+76|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,q,271609,270839,2927)}t=q+8|0;f[t>>2]=0;f[t+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=p;LZ(m,q,f[p>>2]&4095,1.0,0.0);if(!(g&16)){f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=p;g=r+8|0;f[g>>2]=0;f[g+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=p;+fQ(q,r,0)}r=l+48|0;q=o+48|0;ppa(f[l>>2]&4095,f[c>>2]|0,f[r>>2]|0,f[l+12>>2]|0,f[l+8>>2]|0,f[E>>2]|0,f[q>>2]|0,f[o+12>>2]|0,f[o+8>>2]|0,f[d>>2]|0,C,h,i);i=p+36|0;h=f[i>>2]|0;if(h|0?(C=h+12|0,h=f[C>>2]|0,f[C>>2]=h+-1,(h|0)==1):0)_S(p);f[i>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[a>>2]|0)>0){d=f[G>>2]|0;G=0;do{f[d+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[a>>2]|0))}a=f[w>>2]|0;if((a|0)!=(D|0))g0(a);a=o+36|0;D=f[a>>2]|0;if(D|0?(w=D+12|0,D=f[w>>2]|0,f[w>>2]=D+-1,(D|0)==1):0)_S(o);f[a>>2]=0;a=o+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[a>>2]|0)>0){E=f[o+40>>2]|0;D=0;do{f[E+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[a>>2]|0))}a=f[o+44>>2]|0;if((a|0)!=(q|0))g0(a);a=m+36|0;q=f[a>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)_S(m);f[a>>2]=0;a=m+16|0;q=m+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){a=f[m+40>>2]|0;o=0;do{f[a+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[q>>2]|0))}q=f[m+44>>2]|0;if((q|0)!=(m+48|0))g0(q);q=l+36|0;m=f[q>>2]|0;do if(m|0){o=m+12|0;a=f[o>>2]|0;f[o>>2]=a+-1;if((a|0)!=1)break;_S(l)}while(0);f[q>>2]=0;q=l+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[l+40>>2]|0;m=0;do{f[c+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[q>>2]|0))}q=f[l+44>>2]|0;if((q|0)==(r|0)){u=j;return}g0(q);u=j;return}function vpa(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0;e=u;u=u+16|0;g=e;h=c*.017453292519943295;c=+O(+h)*d;i=+P(+h)*d;f[a>>2]=1124007936;j=a+8|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=a+48|0;f[a+44>>2]=j;f[j>>2]=0;f[a+52>>2]=0;f[g>>2]=2;f[g+4>>2]=3;XS(a,2,g,6);g=f[a+16>>2]|0;p[g>>3]=c;p[g+8>>3]=i;d=1.0-c;h=+n[b>>2];o=+n[b+4>>2];p[g+16>>3]=d*h-i*o;p[g+24>>3]=-i;p[g+32>>3]=c;p[g+40>>3]=i*h+d*o;u=e;return}function wpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0;e=u;u=u+800|0;g=e+64|0;h=e+736|0;i=e;j=e+680|0;k=e+624|0;l=e+608|0;m=e+592|0;o=e+576|0;f[a>>2]=1124007936;q=a+8|0;r=a+40|0;s=a+4|0;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;q=a+48|0;f[a+44>>2]=q;f[q>>2]=0;f[a+52>>2]=0;f[g>>2]=3;f[g+4>>2]=3;XS(a,2,g,6);q=a+16|0;a=f[q>>2]|0;f[h>>2]=1124007942;r=h+4|0;f[r>>2]=2;v=h+8|0;f[v>>2]=8;f[h+12>>2]=1;w=h+16|0;f[w>>2]=a;f[h+20>>2]=a;x=h+24|0;y=h+40|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[y>>2]=v;v=h+48|0;z=h+44|0;f[z>>2]=v;A=h+52|0;f[A>>2]=0;f[v>>2]=0;if(!a){f[g>>2]=0;f[g+4>>2]=0;s=tT(g,28)|0;B=271702;t=s+28|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(t|0));z5(-215,g,271731,461938,579)}f[v>>2]=8;f[A>>2]=8;A=a+64|0;f[h+28>>2]=A;f[x>>2]=A;WS(h);f[j>>2]=1124007942;A=j+4|0;f[A>>2]=2;x=j+8|0;f[x>>2]=8;f[j+12>>2]=8;a=j+16|0;f[a>>2]=g;f[j+20>>2]=g;B=j+24|0;s=j+40|0;t=B+8|0;f[t>>2]=0;f[t+4>>2]=0;f[s>>2]=x;x=j+48|0;t=j+44|0;f[t>>2]=x;f[x>>2]=64;f[j+52>>2]=8;f[j+28>>2]=g+512;f[B>>2]=g+512;WS(j);f[k>>2]=1124007942;B=k+4|0;f[B>>2]=2;C=k+8|0;f[C>>2]=8;f[k+12>>2]=1;D=k+16|0;f[D>>2]=i;f[k+20>>2]=i;E=k+24|0;F=k+40|0;G=E+8|0;f[G>>2]=0;f[G+4>>2]=0;f[F>>2]=C;C=k+48|0;G=k+44|0;f[G>>2]=C;f[C>>2]=8;f[k+52>>2]=8;f[k+28>>2]=i+64;f[E>>2]=i+64;WS(k);E=0;do{H=+n[c+(E<<3)>>2];I=H;J=E+4|0;p[g+(J<<6)+24>>3]=I;p[g+(E<<6)>>3]=I;I=+n[c+(E<<3)+4>>2];K=I;p[g+(J<<6)+32>>3]=K;p[g+(E<<6)+8>>3]=K;p[g+(J<<6)+40>>3]=1.0;p[g+(E<<6)+16>>3]=1.0;L=g+(J<<6)|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;L=g+(E<<6)+24|0;K=-H;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;H=+n[d+(E<<3)>>2];p[g+(E<<6)+48>>3]=H*K;M=-I;p[g+(E<<6)+56>>3]=H*M;I=+n[d+(E<<3)+4>>2];p[g+(J<<6)+48>>3]=I*K;p[g+(J<<6)+56>>3]=I*M;p[i+(E<<3)>>3]=H;p[i+(J<<3)>>3]=I;E=E+1|0}while((E|0)!=4);if((b[519832]|0)==0?MIc(519832)|0:0){E=u6(271735,0)|0;f[219488]=E}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;E=o+8|0;f[E>>2]=0;f[E+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=h;oQ(l,m,o,f[219488]|0)|0;p[(f[q>>2]|0)+64>>3]=1.0;q=k+36|0;o=f[q>>2]|0;if(o|0?(m=o+12|0,o=f[m>>2]|0,f[m>>2]=o+-1,(o|0)==1):0)_S(k);f[q>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[B>>2]|0)>0){D=f[F>>2]|0;F=0;do{f[D+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[B>>2]|0))}B=f[G>>2]|0;if((B|0)!=(C|0))g0(B);B=j+36|0;C=f[B>>2]|0;if(C|0?(G=C+12|0,C=f[G>>2]|0,f[G>>2]=C+-1,(C|0)==1):0)_S(j);f[B>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[A>>2]|0)>0){a=f[s>>2]|0;s=0;do{f[a+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[A>>2]|0))}A=f[t>>2]|0;if((A|0)!=(x|0))g0(A);A=h+36|0;x=f[A>>2]|0;if(x|0?(t=x+12|0,x=f[t>>2]|0,f[t>>2]=x+-1,(x|0)==1):0)_S(h);f[A>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[r>>2]|0)>0){w=f[y>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[r>>2]|0))}r=f[z>>2]|0;if((r|0)==(v|0)){u=e;return}g0(r);u=e;return}function xpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;e=u;u=u+560|0;g=e+48|0;h=e+496|0;i=e;j=e+440|0;k=e+384|0;l=e+368|0;m=e+352|0;o=e+336|0;f[a>>2]=1124007936;q=a+8|0;r=a+40|0;s=a+4|0;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;q=a+48|0;f[a+44>>2]=q;f[q>>2]=0;f[a+52>>2]=0;f[g>>2]=2;f[g+4>>2]=3;XS(a,2,g,6);q=f[a+16>>2]|0;f[h>>2]=1124007942;a=h+4|0;f[a>>2]=2;r=h+8|0;f[r>>2]=6;f[h+12>>2]=1;v=h+16|0;f[v>>2]=q;f[h+20>>2]=q;w=h+24|0;x=h+40|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[x>>2]=r;r=h+48|0;y=h+44|0;f[y>>2]=r;z=h+52|0;f[z>>2]=0;f[r>>2]=0;if(!q){f[g>>2]=0;f[g+4>>2]=0;s=tT(g,28)|0;A=271702;t=s+28|0;do{b[s>>0]=b[A>>0]|0;s=s+1|0;A=A+1|0}while((s|0)<(t|0));z5(-215,g,271731,461938,579)}f[r>>2]=8;f[z>>2]=8;z=q+48|0;f[h+28>>2]=z;f[w>>2]=z;WS(h);f[j>>2]=1124007942;z=j+4|0;f[z>>2]=2;w=j+8|0;f[w>>2]=6;f[j+12>>2]=6;q=j+16|0;f[q>>2]=g;f[j+20>>2]=g;A=j+24|0;B=j+40|0;C=A+8|0;f[C>>2]=0;f[C+4>>2]=0;f[B>>2]=w;w=j+48|0;C=j+44|0;f[C>>2]=w;f[w>>2]=48;f[j+52>>2]=8;f[j+28>>2]=g+288;f[A>>2]=g+288;WS(j);f[k>>2]=1124007942;A=k+4|0;f[A>>2]=2;D=k+8|0;f[D>>2]=6;f[k+12>>2]=1;E=k+16|0;f[E>>2]=i;f[k+20>>2]=i;F=k+24|0;G=k+40|0;H=F+8|0;f[H>>2]=0;f[H+4>>2]=0;f[G>>2]=D;D=k+48|0;H=k+44|0;f[H>>2]=D;f[D>>2]=8;f[k+52>>2]=8;f[k+28>>2]=i+48;f[F>>2]=i+48;WS(k);I=+n[c>>2];p[g+72>>3]=I;p[g>>3]=I;I=+n[c+4>>2];p[g+80>>3]=I;p[g+8>>3]=I;p[g+88>>3]=1.0;p[g+16>>3]=1.0;s=g+24|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i>>3]=+n[d>>2];p[i+8>>3]=+n[d+4>>2];I=+n[c+8>>2];p[g+168>>3]=I;p[g+96>>3]=I;I=+n[c+12>>2];p[g+176>>3]=I;p[g+104>>3]=I;p[g+184>>3]=1.0;p[g+112>>3]=1.0;F=d+8|0;s=g+120|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i+16>>3]=+n[F>>2];p[i+24>>3]=+n[d+12>>2];I=+n[c+16>>2];p[g+264>>3]=I;p[g+192>>3]=I;I=+n[c+20>>2];p[g+272>>3]=I;p[g+200>>3]=I;p[g+280>>3]=1.0;p[g+208>>3]=1.0;c=d+16|0;s=g+216|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i+32>>3]=+n[c>>2];p[i+40>>3]=+n[d+20>>2];f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;d=o+8|0;f[d>>2]=0;f[d+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=h;oQ(l,m,o,0)|0;o=k+36|0;m=f[o>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)_S(k);f[o>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[A>>2]|0)>0){E=f[G>>2]|0;G=0;do{f[E+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[A>>2]|0))}A=f[H>>2]|0;if((A|0)!=(D|0))g0(A);A=j+36|0;D=f[A>>2]|0;if(D|0?(H=D+12|0,D=f[H>>2]|0,f[H>>2]=D+-1,(D|0)==1):0)_S(j);f[A>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[z>>2]|0)>0){q=f[B>>2]|0;B=0;do{f[q+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[C>>2]|0;if((z|0)!=(w|0))g0(z);z=h+36|0;w=f[z>>2]|0;if(w|0?(C=w+12|0,w=f[C>>2]|0,f[C>>2]=w+-1,(w|0)==1):0)_S(h);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[a>>2]|0)>0){v=f[x>>2]|0;x=0;do{f[v+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}a=f[y>>2]|0;if((a|0)==(r|0)){u=e;return}g0(a);u=e;return}function ypa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+128|0;g=e+64|0;h=e+8|0;i=e;do if((d$(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;ZS(g,j);break}}else a$(g,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];j=h+4|0;k=c+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];m=f[c+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[c+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;ZS(h,c);break}}else a$(h,d,-1);while(0);if((pT(g,2,5,1)|0)!=4){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,66)|0;r=q;s=271787;t=r+66|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,i,271854,270839,3159)}if((pT(h,2,5,1)|0)!=4){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,66)|0;r=q;s=271787;t=r+66|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,i,271854,270839,3159)}i=g+16|0;s=h+16|0;wpa(a,f[i>>2]|0,f[s>>2]|0);a=h+36|0;r=f[a>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)_S(h);f[a>>2]=0;a=h+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[h+40>>2]|0;r=0;do{f[s+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))g0(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(r=h+12|0,h=f[r>>2]|0,f[r>>2]=h+-1,(h|0)==1):0)_S(g);f[a>>2]=0;a=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g+40>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}g0(a);u=e;return}function zpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+128|0;g=e+64|0;h=e+8|0;i=e;do if((d$(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;ZS(g,j);break}}else a$(g,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];j=h+4|0;k=c+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];m=f[c+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[c+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;ZS(h,c);break}}else a$(h,d,-1);while(0);if((pT(g,2,5,1)|0)!=3){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,66)|0;r=q;s=271878;t=r+66|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,i,271945,270839,3166)}if((pT(h,2,5,1)|0)!=3){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,66)|0;r=q;s=271878;t=r+66|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,i,271945,270839,3166)}i=g+16|0;s=h+16|0;xpa(a,f[i>>2]|0,f[s>>2]|0);a=h+36|0;r=f[a>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)_S(h);f[a>>2]=0;a=h+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[h+40>>2]|0;r=0;do{f[s+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))g0(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(r=h+12|0,h=f[r>>2]|0,f[r>>2]=h+-1,(h|0)==1):0)_S(g);f[a>>2]=0;a=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g+40>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}g0(a);u=e;return}function Apa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0;d=u;u=u+1152|0;e=d+80|0;g=d+64|0;h=d+56|0;i=d;f[i>>2]=1124007936;j=i+4|0;k=i+8|0;l=i+40|0;m=j;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[l>>2]=k;p=i+48|0;q=i+44|0;f[q>>2]=p;f[p>>2]=0;f[i+52>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;r=e+8|0;f[r>>2]=0;f[r+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=i;Xxa(c,e,1,1);if((f[i>>2]&7|0)!=5){f[e>>2]=1124007936;c=e+4|0;r=e+8|0;t=e+40|0;m=c;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[t>>2]=r;v=e+48|0;w=e+44|0;f[w>>2]=v;f[v>>2]=0;f[e+52>>2]=0;x=g+8|0;f[x>>2]=0;f[x+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;LZ(i,g,5,1.0,0.0);x=e+36|0;y=f[x>>2]|0;if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}z=i+36|0;y=f[z>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)_S(i);f[z>>2]=0;y=i+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0;C=f[j>>2]|0}while((B|0)<(C|0));f[i>>2]=f[e>>2];if((C|0)<3)D=12;else D=14}else{f[i>>2]=f[e>>2];D=12}if((D|0)==12){C=f[c>>2]|0;if((C|0)<3){f[j>>2]=C;f[k>>2]=f[r>>2];f[i+12>>2]=f[e+12>>2];r=f[w>>2]|0;k=f[q>>2]|0;f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2]}else D=14}if((D|0)==14)ZS(i,e);r=e+16|0;f[y>>2]=f[r>>2];f[i+20>>2]=f[e+20>>2];f[i+24>>2]=f[e+24>>2];f[i+28>>2]=f[e+28>>2];f[i+32>>2]=f[e+32>>2];y=f[x>>2]|0;f[z>>2]=y;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)_S(e);f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[t>>2]|0;t=0;do{f[r+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[c>>2]|0))}c=f[w>>2]|0;if((c|0)!=(v|0))g0(c)}c=pT(i,2,-1,1)|0;v=i+16|0;w=f[v>>2]|0;a:do if((c|0)>2){t=c*3|0;r=e+8|0;f[e>>2]=r;x=e+4|0;f[x>>2]=t;if(t>>>0>264){y=XDc(t>>>0>1073741823?-1:t<<2)|0;f[e>>2]=y;E=y}else E=r;y=E+(c<<2)|0;f[g>>2]=-1;f[g+4>>2]=-1;f[g+8>>2]=-1;f[g+12>>2]=-1;t=f[w>>2]|0;z=f[w+4>>2]|0;F=(f[s>>2]=t,+n[s>>2]);G=(f[s>>2]=z,+n[s>>2]);k=0;C=0;B=0;A=0;H=0;I=F;J=F;F=G;K=G;L=t;t=z;while(1){G=(f[s>>2]=L,+n[s>>2]);z=G<I;C=z?k:C;N=G>J;A=N?k:A;O=(f[s>>2]=t,+n[s>>2]);P=O>F;H=P?k:H;Q=O<K;B=Q?k:B;R=k;k=k+1|0;S=(k|0)<(c|0)?k:0;L=f[w+(S<<3)>>2]|0;t=f[w+(S<<3)+4>>2]|0;T=(f[s>>2]=L,+n[s>>2])-G;V=T;W=(f[s>>2]=t,+n[s>>2])-O;X=W;n[y+(R<<3)>>2]=T;n[y+(R<<3)+4>>2]=W;W=1.0/+M(+(V*V+X*X));n[E+(R<<2)>>2]=W;if((k|0)==(c|0))break;else{I=z?G:I;J=N?G:J;F=P?O:F;K=Q?O:K}}k=c+-1|0;K=+n[y+(k<<3)>>2];F=+n[y+(k<<3)+4>>2];k=0;while(1){J=K;K=+n[y+(k<<3)>>2];I=F;F=+n[y+(k<<3)+4>>2];Y=J*F-I*K;k=k+1|0;if(Y!=0.0)break;if((k|0)>=(c|0)){D=32;break}}if((D|0)==32){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,16)|0;k=272733;o=m+16|0;do{b[m>>0]=b[k>>0]|0;m=m+1|0;k=k+1|0}while((m|0)<(o|0));z5(-215,h,272750,272767,166)}f[g>>2]=B;k=g+4|0;f[k>>2]=A;t=g+8|0;f[t>>2]=H;L=g+12|0;f[L>>2]=C;Q=0;K=Y>0.0?1.0:-1.0;F=0.0;I=3402823466385288598117041.0e14;P=0;J=0.0;O=0.0;G=0.0;N=0;W=0.0;z=B;R=A;S=H;Z=C;b:while(1){X=(K*+n[y+(z<<3)>>2]+F*+n[y+(z<<3)+4>>2])*+n[E+(z<<2)>>2];V=(K*+n[y+(R<<3)+4>>2]-F*+n[y+(R<<3)>>2])*+n[E+(R<<2)>>2];_=V>X;T=_?V:X;X=(-(K*+n[y+(S<<3)>>2])-F*+n[y+(S<<3)+4>>2])*+n[E+(S<<2)>>2];$=X>T;aa=(F*+n[y+(Z<<3)>>2]-K*+n[y+(Z<<3)+4>>2])*+n[E+(Z<<2)>>2]>($?X:T)?3:$?2:_&1;_=g+(aa<<2)|0;$=f[_>>2]|0;T=+n[E+($<<2)>>2];X=+n[y+($<<3)>>2]*T;V=T*+n[y+($<<3)+4>>2];switch(aa&3){case 0:{ba=X;ca=V;break}case 1:{ba=V;ca=-X;break}case 2:{ba=-X;ca=-V;break}case 3:{ba=-V;ca=X;break}default:{D=38;break b}}aa=$+1|0;f[_>>2]=(aa|0)==(c|0)?0:aa;R=f[k>>2]|0;Z=f[L>>2]|0;X=ba*(+n[w+(R<<3)>>2]-+n[w+(Z<<3)>>2])+ca*(+n[w+(R<<3)+4>>2]-+n[w+(Z<<3)+4>>2]);S=f[t>>2]|0;z=f[g>>2]|0;V=ba*(+n[w+(S<<3)+4>>2]-+n[w+(z<<3)+4>>2])-ca*(+n[w+(S<<3)>>2]-+n[w+(z<<3)>>2]);T=X*V;if(!(T<=I)){da=I;ea=P;fa=J;ga=O;ha=G;ia=N;ja=W}else{da=T;ea=Z;fa=X;ga=ca;ha=V;ia=z;ja=ba}Q=Q+1|0;if((Q|0)>=(c|0))break;else{K=ba;F=ca;I=da;P=ea;J=fa;O=ga;G=ha;N=ia;W=ja}}W=-ga;G=ja*+n[w+(ea<<3)>>2]+ga*+n[w+(ea<<3)+4>>2];O=+n[w+(ia<<3)>>2]*W+ja*+n[w+(ia<<3)+4>>2];J=1.0/(ja*ja-ga*W);I=fa*ja;F=ga*fa;K=ha*W;V=ha*ja;if((E|0)!=(r|0)){ZDc(E);f[e>>2]=r;f[x>>2]=264}n[a>>2]=J*(ja*G-ga*O)+(I+K)*.5;n[a+4>>2]=J*(ja*O-G*W)+(F+V)*.5;W=I;I=F;F=+M(+(W*W+I*I));n[a+8>>2]=F;F=K;K=V;V=+M(+(F*F+K*K));n[a+12>>2]=V;V=+U(+I,+W);n[a+16>>2]=V}else switch(c|0){case 2:{V=+n[w>>2];W=+n[w+8>>2];n[a>>2]=(V+W)*.5;I=+n[w+4>>2];K=+n[w+12>>2];n[a+4>>2]=(I+K)*.5;F=W-V;V=K-I;I=+M(+(F*F+V*V));n[a+8>>2]=I;n[a+12>>2]=0.0;I=+U(+V,+F);n[a+16>>2]=I;break a;break}case 1:{f[a>>2]=f[w>>2];f[a+4>>2]=f[w+4>>2];break a;break}default:break a}while(0);w=a+16|0;n[w>>2]=+n[w>>2]*180.0/3.141592653589793;w=i+36|0;a=f[w>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)_S(i);f[w>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[j>>2]|0)>0){v=f[l>>2]|0;l=0;do{f[v+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)==(p|0)){u=d;return}g0(j);u=d;return}function Bpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+128|0;h=g+64|0;i=g;j=g+8|0;do if((d$(a)|0)==65536){k=f[a+4>>2]|0;f[h>>2]=f[k>>2];l=h+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=h+8|0;f[n>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[h+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[h+36>>2]=o;p=h+40|0;f[p>>2]=n;n=h+48|0;q=h+44|0;f[q>>2]=n;f[n>>2]=0;f[h+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];r=p;break}else{f[l>>2]=0;ZS(h,k);r=p;break}}else{a$(h,a,-1);r=h+40|0}while(0);a=f[r>>2]|0;p=f[a>>2]|0;f[i>>2]=f[a+4>>2];f[i+4>>2]=p;v$(b,i,5,-1,0,0);do if((d$(b)|0)==65536){i=f[b+4>>2]|0;f[j>>2]=f[i>>2];p=j+4|0;a=i+4|0;f[p>>2]=f[a>>2];k=j+8|0;f[k>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];l=f[i+36>>2]|0;f[j+36>>2]=l;f[j+40>>2]=k;k=j+48|0;m=j+44|0;f[m>>2]=k;f[k>>2]=0;f[j+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[a>>2]|0)<3){a=f[i+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[a>>2];f[k+4>>2]=f[a+4>>2];break}else{f[p>>2]=0;ZS(j,i);break}}else a$(j,b,-1);while(0);Cpa(h,j,c,d,0,0.0,e);e=j+36|0;d=f[e>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(j);f[e>>2]=0;e=j+16|0;d=j+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[d>>2]|0)>0){e=f[j+40>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[j+44>>2]|0;if((d|0)!=(j+48|0))g0(d);d=h+36|0;j=f[d>>2]|0;if(j|0?(c=j+12|0,j=f[c>>2]|0,f[c>>2]=j+-1,(j|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;j=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[r>>2]|0;r=0;do{f[d+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[j>>2]|0))}j=f[h+44>>2]|0;if((j|0)==(h+48|0)){u=g;return}g0(j);u=g;return}function Cpa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0;j=u;u=u+224|0;k=j+200|0;l=j+144|0;m=j+88|0;o=j+24|0;p=j;q=j+80|0;r=j+16|0;s=f[a>>2]|0;t=(e|0)>0;v=+(d|0)*(t?+(1<<e+-1|0):4.0);w=(e|0)<0?v*2.0:v;v=1.0/((s&7|0)==0?w*255.0:w);switch(s&4095){case 5:case 0:break;default:{f[k>>2]=0;f[k+4>>2]=0;x=tT(k,47)|0;s=272840;y=x+47|0;do{b[x>>0]=b[s>>0]|0;x=x+1|0;s=s+1|0}while((x|0)<(y|0));Dpa(k,272888,269)}}f[l>>2]=1124007936;s=l+4|0;z=l+8|0;A=l+40|0;x=s;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[A>>2]=z;z=l+48|0;B=l+44|0;f[B>>2]=z;f[z>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;C=m+4|0;D=m+8|0;E=m+40|0;x=C;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[E>>2]=D;D=m+48|0;F=m+44|0;f[F>>2]=D;f[D>>2]=0;f[m+52>>2]=0;if(t){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;t=o+8|0;f[t>>2]=0;f[t+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;Hoa(k,o,5,1,0,e,v,0.0,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;t=o+8|0;f[t>>2]=0;f[t+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;Hoa(k,o,5,0,1,e,v,0.0,i)}else{f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;Ioa(k,o,5,1,0,v,0.0,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;Ioa(k,o,5,0,1,v,0.0,i)}e=f[a+40>>2]|0;a=f[e+4>>2]|0;t=f[e>>2]|0;f[o>>2]=1124007936;e=o+4|0;G=o+8|0;H=o+40|0;x=e;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[H>>2]=G;G=o+48|0;x=o+44|0;f[x>>2]=G;f[G>>2]=0;f[o+52>>2]=0;f[k>>2]=t;f[k+4>>2]=a;XS(o,2,k,21);if((t|0)>0?(y=f[o+16>>2]|0,I=f[f[x>>2]>>2]|0,J=f[l+16>>2]|0,K=f[f[B>>2]>>2]|0,N=f[m+16>>2]|0,O=f[f[F>>2]>>2]|0,(a|0)>0):0){P=0;do{Q=y+(Y(I,P)|0)|0;R=J+(Y(K,P)|0)|0;S=N+(Y(O,P)|0)|0;T=0;do{v=+n[R+(T<<2)>>2];w=+n[S+(T<<2)>>2];U=T*3|0;n[Q+(U<<2)>>2]=v*v;n[Q+(U+1<<2)>>2]=v*w;n[Q+(U+2<<2)>>2]=w*w;T=T+1|0}while((T|0)!=(a|0));P=P+1|0}while((P|0)!=(t|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=o;t=p+8|0;f[t>>2]=0;f[t+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=o;t=f[o>>2]&7;f[q>>2]=d;f[q+4>>2]=d;f[r>>2]=-1;f[r+4>>2]=-1;Yma(k,p,t,q,r,0,i);a:do switch(g|0){case 0:{i=f[c+16>>2]|0;r=f[c+44>>2]|0;q=f[H>>2]|0;t=f[q+4>>2]|0;p=f[q>>2]|0;if(f[o>>2]&16384){q=(f[c>>2]&16384|0)!=0;k=Y(q?p:1,t)|0;if(q){V=k;W=1}else{X=k;Z=14}}else{X=t;Z=14}if((Z|0)==14)if((p|0)>0){V=X;W=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;k=f[r>>2]|0;if((V|0)>0){r=0;do{q=p+(Y(r,t)|0)|0;d=i+(Y(r,k)|0)|0;P=0;do{a=P*3|0;w=+n[q+(a<<2)>>2]*.5;v=+n[q+(a+1<<2)>>2];_=+n[q+(a+2<<2)>>2]*.5;$=w-_;aa=w+_-+M(+(v*v+$*$));n[d+(P<<2)>>2]=aa;P=P+1|0}while((P|0)!=(V|0));r=r+1|0}while((r|0)!=(W|0))}break}case 1:{r=f[c+16>>2]|0;k=f[c+44>>2]|0;i=f[H>>2]|0;t=f[i+4>>2]|0;p=f[i>>2]|0;if(f[o>>2]&16384){i=(f[c>>2]&16384|0)!=0;P=Y(i?p:1,t)|0;if(i){ba=P;ca=1}else{da=P;Z=21}}else{da=t;Z=21}if((Z|0)==21)if((p|0)>0){ba=da;ca=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;P=f[k>>2]|0;if((ba|0)>0){k=0;do{i=p+(Y(k,t)|0)|0;d=r+(Y(k,P)|0)|0;q=0;do{a=q*3|0;aa=+n[i+(a<<2)>>2];$=+n[i+(a+1<<2)>>2];v=+n[i+(a+2<<2)>>2];_=aa+v;n[d+(q<<2)>>2]=aa*v-$*$-_*(_*h);q=q+1|0}while((q|0)!=(ba|0));k=k+1|0}while((k|0)!=(ca|0))}break}case 2:{k=f[c+16>>2]|0;P=f[c+44>>2]|0;r=f[H>>2]|0;t=f[r+4>>2]|0;p=f[r>>2]|0;if(f[o>>2]&16384){r=(f[c>>2]&16384|0)!=0;q=Y(r?p:1,t)|0;if(r){ea=q;fa=1}else{ga=q;Z=28}}else{ga=t;Z=28}if((Z|0)==28)if((p|0)>0){ea=ga;fa=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;q=f[P>>2]|0;P=(ea|0)>0;r=0;do{d=p+(Y(r,t)|0)|0;i=k+(Y(r,q)|0)|0;if(P){a=0;do{O=a*3|0;_=+n[d+(O<<2)>>2];$=+n[d+(O+1<<2)>>2];v=$;aa=+n[d+(O+2<<2)>>2];w=(_+aa)*.5;ha=_-aa;ia=+M(+(v*v+ha*ha*.25));ha=ia+w;ja=w-ia;ia=ha-_;w=+L(+$);if(w+ +L(+ia)<.0001){$=ha-aa;ka=w+ +L(+$);la=1.0/(ka+1.1920928955078125e-07);if(ka<.0001){ma=v*la;na=$*la}else{ma=v;na=$}}else{ma=ia;na=v}ia=1.0/+M(+(na*na+ma*ma+2.220446049250313e-16));O=a*6|0;n[i+(O<<2)>>2]=ha;n[i+(O+2<<2)>>2]=na*ia;n[i+(O+3<<2)>>2]=ma*ia;ia=ja-_;if(w+ +L(+ia)<.0001){_=ja-aa;aa=w+ +L(+_);w=1.0/(aa+1.1920928955078125e-07);if(aa<.0001){oa=v*w;pa=_*w}else{oa=v;pa=_}}else{oa=ia;pa=v}v=1.0/+M(+(pa*pa+oa*oa+2.220446049250313e-16));n[i+((O|1)<<2)>>2]=ja;n[i+(O+4<<2)>>2]=pa*v;n[i+(O+5<<2)>>2]=oa*v;a=a+1|0}while((a|0)!=(ea|0))}r=r+1|0}while((r|0)!=(fa|0));break}default:{}}while(0);fa=o+36|0;ea=f[fa>>2]|0;if(ea|0?(ga=ea+12|0,ea=f[ga>>2]|0,f[ga>>2]=ea+-1,(ea|0)==1):0)_S(o);f[fa>>2]=0;fa=o+16|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[e>>2]|0)>0){fa=f[H>>2]|0;H=0;do{f[fa+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[e>>2]|0))}e=f[x>>2]|0;if((e|0)!=(G|0))g0(e);e=m+36|0;G=f[e>>2]|0;if(G|0?(x=G+12|0,G=f[x>>2]|0,f[x>>2]=G+-1,(G|0)==1):0)_S(m);f[e>>2]=0;e=m+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[C>>2]|0)>0){e=f[E>>2]|0;E=0;do{f[e+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[C>>2]|0))}C=f[F>>2]|0;if((C|0)!=(D|0))g0(C);C=l+36|0;D=f[C>>2]|0;if(D|0?(F=D+12|0,D=f[F>>2]|0,f[F>>2]=D+-1,(D|0)==1):0)_S(l);f[C>>2]=0;C=l+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[s>>2]|0)>0){C=f[A>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[s>>2]|0))}s=f[B>>2]|0;if((s|0)==(z|0)){u=j;return}g0(s);u=j;return}function Dpa(a,b,c){a=a|0;b=b|0;c=c|0;z5(-215,a,b,272908,c);return}function Epa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+128|0;i=h+64|0;j=h;k=h+8|0;do if((d$(a)|0)==65536){l=f[a+4>>2]|0;f[i>>2]=f[l>>2];m=i+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=i+8|0;f[o>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];f[i+16>>2]=f[l+16>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];f[i+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[i+36>>2]=p;q=i+40|0;f[q>>2]=o;o=i+48|0;r=i+44|0;f[r>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=q;break}else{f[m>>2]=0;ZS(i,l);s=q;break}}else{a$(i,a,-1);s=i+40|0}while(0);a=f[s>>2]|0;q=f[a>>2]|0;f[j>>2]=f[a+4>>2];f[j+4>>2]=q;v$(b,j,5,-1,0,0);do if((d$(b)|0)==65536){j=f[b+4>>2]|0;f[k>>2]=f[j>>2];q=k+4|0;a=j+4|0;f[q>>2]=f[a>>2];l=k+8|0;f[l>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];m=f[j+36>>2]|0;f[k+36>>2]=m;f[k+40>>2]=l;l=k+48|0;n=k+44|0;f[n>>2]=l;f[l>>2]=0;f[k+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[a>>2]|0)<3){a=f[j+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[a>>2];f[l+4>>2]=f[a+4>>2];break}else{f[q>>2]=0;ZS(k,j);break}}else a$(k,b,-1);while(0);Cpa(i,k,c,d,1,e,g);g=k+36|0;d=f[g>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(k);f[g>>2]=0;g=k+16|0;d=k+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){g=f[k+40>>2]|0;c=0;do{f[g+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[k+44>>2]|0;if((d|0)!=(k+48|0))g0(d);d=i+36|0;k=f[d>>2]|0;if(k|0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)_S(i);f[d>>2]=0;d=i+16|0;k=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[s>>2]|0;s=0;do{f[d+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)==(i+48|0)){u=h;return}g0(k);u=h;return}function Fpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;do if((d$(b)|0)==65536){j=f[b+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;ZS(g,j);break}}else a$(g,b,-1);while(0);do if(!d?(b=f[g>>2]|0,(b&4095|0)==6):0){f[a>>2]=b;b=a+4|0;j=g+4|0;k=f[j>>2]|0;f[b>>2]=k;l=a+8|0;f[l>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];f[a+20>>2]=f[g+20>>2];f[a+24>>2]=f[g+24>>2];f[a+28>>2]=f[g+28>>2];f[a+32>>2]=f[g+32>>2];m=g+36|0;o=f[m>>2]|0;f[a+36>>2]=o;f[a+40>>2]=l;l=a+48|0;n=a+44|0;f[n>>2]=l;f[l>>2]=0;f[a+52>>2]=0;if(!o)q=k;else{k=o+12|0;f[k>>2]=(f[k>>2]|0)+1;q=f[j>>2]|0}if((q|0)<3){j=f[g+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];r=m;break}else{f[b>>2]=0;ZS(a,g);r=m;break}}else s=15;while(0);if((s|0)==15){f[h>>2]=1124007936;s=h+4|0;q=h+8|0;m=h+40|0;b=s;j=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(j|0));f[m>>2]=q;b=h+48|0;j=h+44|0;f[j>>2]=b;f[b>>2]=0;f[h+52>>2]=0;k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;LZ(g,i,6,1.0,0.0);if(d){d=h+16|0;i=f[d>>2]|0;p[i+16>>3]=+((f[c>>2]|0)+-1|0)*.5;p[i+40>>3]=+((f[c+4>>2]|0)+-1|0)*.5;t=d;v=i}else{i=h+16|0;t=i;v=f[i>>2]|0}f[a>>2]=f[h>>2];i=a+4|0;d=f[s>>2]|0;f[i>>2]=d;c=a+8|0;f[c>>2]=f[q>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=v;f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];v=h+36|0;q=f[v>>2]|0;f[a+36>>2]=q;f[a+40>>2]=c;c=a+48|0;k=a+44|0;f[k>>2]=c;f[c>>2]=0;f[a+52>>2]=0;if(!q)w=d;else{d=q+12|0;f[d>>2]=(f[d>>2]|0)+1;w=f[s>>2]|0}if((w|0)<3){w=f[j>>2]|0;d=f[k>>2]|0;f[d>>2]=f[w>>2];f[d+4>>2]=f[w+4>>2]}else{f[i>>2]=0;ZS(a,h)}a=f[v>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(h);f[v>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[m>>2]|0;m=0;do{f[t+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j>>2]|0;if((s|0)!=(b|0))g0(s);r=g+36|0}s=f[r>>2]|0;if(s|0?(b=s+12|0,s=f[b>>2]|0,f[b>>2]=s+-1,(s|0)==1):0)_S(g);f[r>>2]=0;r=g+16|0;s=g+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){r=f[g+40>>2]|0;b=0;do{f[r+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[s>>2]|0))}s=f[g+44>>2]|0;if((s|0)==(g+48|0)){u=e;return}g0(s);u=e;return}function Gpa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0;k=u;u=u+1664|0;l=k+832|0;m=k+1640|0;n=k+1584|0;o=k+1528|0;q=k+1472|0;r=k+1408|0;s=k+1464|0;t=k+1352|0;v=k+1288|0;w=k+1344|0;x=k+1232|0;y=k+608|0;z=k+1176|0;A=k+1120|0;B=k+1112|0;C=k+1056|0;D=k+384|0;E=k+160|0;F=k;do if((d$(a)|0)==65536){G=f[a+4>>2]|0;f[n>>2]=f[G>>2];H=n+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=n+8|0;f[J>>2]=f[G+8>>2];f[n+12>>2]=f[G+12>>2];f[n+16>>2]=f[G+16>>2];f[n+20>>2]=f[G+20>>2];f[n+24>>2]=f[G+24>>2];f[n+28>>2]=f[G+28>>2];f[n+32>>2]=f[G+32>>2];K=f[G+36>>2]|0;f[n+36>>2]=K;f[n+40>>2]=J;J=n+48|0;L=n+44|0;f[L>>2]=J;f[J>>2]=0;f[n+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;ZS(n,G);break}}else a$(n,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[o>>2]=f[a>>2];G=o+4|0;H=a+4|0;f[G>>2]=f[H>>2];I=o+8|0;f[I>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];J=f[a+36>>2]|0;f[o+36>>2]=J;f[o+40>>2]=I;I=o+48|0;L=o+44|0;f[L>>2]=I;f[I>>2]=0;f[o+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[a+44>>2]|0;I=f[L>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;ZS(o,a);break}}else a$(o,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[q>>2]=f[c>>2];a=q+4|0;G=c+4|0;f[a>>2]=f[G>>2];H=q+8|0;f[H>>2]=f[c+8>>2];f[q+12>>2]=f[c+12>>2];f[q+16>>2]=f[c+16>>2];f[q+20>>2]=f[c+20>>2];f[q+24>>2]=f[c+24>>2];f[q+28>>2]=f[c+28>>2];f[q+32>>2]=f[c+32>>2];I=f[c+36>>2]|0;f[q+36>>2]=I;f[q+40>>2]=H;H=q+48|0;L=q+44|0;f[L>>2]=H;f[H>>2]=0;f[q+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[c+44>>2]|0;H=f[L>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[a>>2]=0;ZS(q,c);break}}else a$(q,d,-1);while(0);do if((d$(e)|0)==65536){d=f[e+4>>2]|0;f[r>>2]=f[d>>2];c=r+4|0;a=d+4|0;f[c>>2]=f[a>>2];G=r+8|0;f[G>>2]=f[d+8>>2];f[r+12>>2]=f[d+12>>2];f[r+16>>2]=f[d+16>>2];f[r+20>>2]=f[d+20>>2];f[r+24>>2]=f[d+24>>2];f[r+28>>2]=f[d+28>>2];f[r+32>>2]=f[d+32>>2];H=f[d+36>>2]|0;f[r+36>>2]=H;f[r+40>>2]=G;G=r+48|0;L=r+44|0;f[L>>2]=G;f[G>>2]=0;f[r+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+44>>2]|0;G=f[L>>2]|0;f[G>>2]=f[a>>2];f[G+4>>2]=f[a+4>>2];break}else{f[c>>2]=0;ZS(r,d);break}}else a$(r,e,-1);while(0);e=(h|0)<1?11:h;h=(e|0)==11;switch(e|0){case 5:case 11:case 13:break;default:{f[l>>2]=0;f[l+4>>2]=0;M=tT(l,62)|0;N=272976;Q=M+62|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(Q|0));z5(-215,l,273039,273063,200)}}f[s>>2]=f[g>>2];d=g+4|0;f[s+4>>2]=f[d>>2];v$(i,s,e,-1,0,0);do if((d$(i)|0)==65536){s=f[i+4>>2]|0;f[t>>2]=f[s>>2];c=t+4|0;a=s+4|0;f[c>>2]=f[a>>2];G=t+8|0;f[G>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];f[t+32>>2]=f[s+32>>2];L=f[s+36>>2]|0;f[t+36>>2]=L;f[t+40>>2]=G;G=t+48|0;H=t+44|0;f[H>>2]=G;f[G>>2]=0;f[t+52>>2]=0;if(L|0){G=L+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[a>>2]|0)<3){a=f[s+44>>2]|0;G=f[H>>2]|0;f[G>>2]=f[a>>2];f[G+4>>2]=f[a+4>>2];break}else{f[c>>2]=0;ZS(t,s);break}}else a$(t,i,-1);while(0);f[v>>2]=1124007936;i=v+4|0;s=v+8|0;c=v+40|0;M=i;Q=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(Q|0));f[c>>2]=s;a=v+48|0;G=v+44|0;f[G>>2]=a;f[a>>2]=0;f[v+52>>2]=0;if((e|0)!=13){f[w>>2]=f[g>>2];f[w+4>>2]=f[d>>2];v$(j,w,h?2:5,-1,0,0);do if((d$(j)|0)==65536){h=f[j+4>>2]|0;f[l>>2]=f[h>>2];w=l+4|0;H=h+4|0;f[w>>2]=f[H>>2];L=l+8|0;f[L>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];I=l+36|0;J=f[h+36>>2]|0;f[I>>2]=J;f[l+40>>2]=L;L=l+48|0;K=l+44|0;f[K>>2]=L;f[L>>2]=0;f[l+52>>2]=0;if(J|0){L=J+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[H>>2]|0)<3){H=f[h+44>>2]|0;L=f[K>>2]|0;f[L>>2]=f[H>>2];f[L+4>>2]=f[H+4>>2];R=I;break}else{f[w>>2]=0;ZS(l,h);R=I;break}}else{a$(l,j,-1);R=l+36|0}while(0);I=f[R>>2]|0;if(I|0){h=I+12|0;f[h>>2]=(f[h>>2]|0)+1}h=v+36|0;I=f[h>>2]|0;if(I|0?(w=I+12|0,I=f[w>>2]|0,f[w>>2]=I+-1,(I|0)==1):0)_S(v);f[h>>2]=0;I=v+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[i>>2]|0)>0){w=f[c>>2]|0;H=0;do{f[w+(H<<2)>>2]=0;H=H+1|0;S=f[i>>2]|0}while((H|0)<(S|0));f[v>>2]=f[l>>2];if((S|0)<3)T=56;else T=58}else{f[v>>2]=f[l>>2];T=56}if((T|0)==56){S=f[l+4>>2]|0;if((S|0)<3){f[i>>2]=S;f[s>>2]=f[l+8>>2];f[v+12>>2]=f[l+12>>2];s=f[l+44>>2]|0;S=f[G>>2]|0;f[S>>2]=f[s>>2];f[S+4>>2]=f[s+4>>2]}else T=58}if((T|0)==58)ZS(v,l);s=l+16|0;f[I>>2]=f[s>>2];f[v+20>>2]=f[l+20>>2];f[v+24>>2]=f[l+24>>2];f[v+28>>2]=f[l+28>>2];f[v+32>>2]=f[l+32>>2];I=f[R>>2]|0;f[h>>2]=I;if(I|0?(h=I+12|0,I=f[h>>2]|0,f[h>>2]=I+-1,(I|0)==1):0)_S(l);f[R>>2]=0;R=l+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[R>>2]|0)>0){s=f[l+40>>2]|0;I=0;do{f[s+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[R>>2]|0))}R=f[l+44>>2]|0;if((R|0)!=(l+48|0))g0(R)}else u$(j);GY(y,3,3,6);Hpa(x,y);$j(y);Ipa(z,n);y=A+4|0;j=A+8|0;R=A+40|0;M=y;Q=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(Q|0));f[R>>2]=j;j=A+48|0;I=A+44|0;f[I>>2]=j;f[j>>2]=0;f[A+52>>2]=0;f[A>>2]=1124007942;s=r+16|0;if(f[s>>2]|0){h=f[r+4>>2]|0;if((h|0)<3)U=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{S=f[r+40>>2]|0;H=0;w=1;while(1){L=Y(f[S+(H<<2)>>2]|0,w)|0;H=H+1|0;if((H|0)==(h|0)){U=L;break}else w=L}}if(!((h|0)==0|(U|0)==0)){Ipa(l,r);Jpa(A,l)|0;U=l+36|0;h=f[U>>2]|0;if(h|0?(w=h+12|0,h=f[w>>2]|0,f[w>>2]=h+-1,(h|0)==1):0)_S(l);f[U>>2]=0;U=l+16|0;h=l+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[h>>2]|0)>0){U=f[l+40>>2]|0;w=0;do{f[U+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[h>>2]|0))}h=f[l+44>>2]|0;if((h|0)!=(l+48|0))g0(h)}else T=84}else T=84;if((T|0)==84){f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=-2130640890;f[m+4>>2]=z;f[B>>2]=f[g>>2];f[B+4>>2]=f[d>>2];Fpa(l,m,B,1);Kpa(A,l)|0;B=l+36|0;h=f[B>>2]|0;if(h|0?(w=h+12|0,h=f[w>>2]|0,f[w>>2]=h+-1,(h|0)==1):0)_S(l);f[B>>2]=0;B=l+16|0;h=l+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[h>>2]|0)>0){B=f[l+40>>2]|0;w=0;do{f[B+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[h>>2]|0))}h=f[l+44>>2]|0;if((h|0)!=(l+48|0))g0(h)}h=q+16|0;if(f[h>>2]|0){w=f[q+4>>2]|0;if((w|0)<3)V=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{B=f[q+40>>2]|0;U=0;H=1;while(1){S=Y(f[B+(U<<2)>>2]|0,H)|0;U=U+1|0;if((U|0)==(w|0)){V=S;break}else H=S}}if(!((w|0)==0|(V|0)==0)){Ipa(l,q);Jpa(x,l)|0;V=l+36|0;w=f[V>>2]|0;if(w|0?(H=w+12|0,w=f[H>>2]|0,f[H>>2]=w+-1,(w|0)==1):0)_S(l);f[V>>2]=0;V=l+16|0;w=l+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[w>>2]|0)>0){V=f[l+40>>2]|0;H=0;do{f[V+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[w>>2]|0))}w=f[l+44>>2]|0;if((w|0)!=(l+48|0))g0(w)}}w=o+16|0;H=(f[w>>2]|0)==0;V=o+4|0;U=f[V>>2]|0;if(!H){if((U|0)<3)W=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{B=f[o+40>>2]|0;S=0;L=1;while(1){K=Y(f[B+(S<<2)>>2]|0,L)|0;S=S+1|0;if((S|0)==(U|0)){W=K;break}else L=K}}if(!((U|0)==0|(W|0)==0)){Ipa(l,o);W=l+36|0;L=f[W>>2]|0;if(L|0){S=L+12|0;f[S>>2]=(f[S>>2]|0)+1}S=o+36|0;L=f[S>>2]|0;if(L|0?(B=L+12|0,L=f[B>>2]|0,f[B>>2]=L+-1,(L|0)==1):0)_S(o);f[S>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[V>>2]|0)>0){L=f[o+40>>2]|0;B=0;do{f[L+(B<<2)>>2]=0;B=B+1|0;X=f[V>>2]|0}while((B|0)<(X|0));f[o>>2]=f[l>>2];if((X|0)<3)T=124;else T=126}else{f[o>>2]=f[l>>2];T=124}if((T|0)==124){X=f[l+4>>2]|0;if((X|0)<3){f[V>>2]=X;f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];X=f[l+44>>2]|0;V=f[o+44>>2]|0;f[V>>2]=f[X>>2];f[V+4>>2]=f[X+4>>2]}else T=126}if((T|0)==126)ZS(o,l);X=l+16|0;f[w>>2]=f[X>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];f[o+28>>2]=f[l+28>>2];f[o+32>>2]=f[l+32>>2];V=f[W>>2]|0;f[S>>2]=V;if(V|0?(S=V+12|0,V=f[S>>2]|0,f[S>>2]=V+-1,(V|0)==1):0)_S(l);f[W>>2]=0;W=l+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[W>>2]|0)>0){X=f[l+40>>2]|0;V=0;do{f[X+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[W>>2]|0))}W=f[l+44>>2]|0;if((W|0)!=(l+48|0))g0(W)}else T=136}else T=136;if((T|0)==136){if(!((((U|0)<3?(f[o+8>>2]|0)==14:0)?(f[o+12>>2]|0)==1:0)?!((f[o>>2]&4095|0)!=6|H):0))T=140;if((T|0)==140){f[l>>2]=14;f[l+4>>2]=1;XS(o,2,l,6)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;k_(o,l)|0}T=z+40|0;H=f[T>>2]|0;if(!((f[H>>2]|0)==3?(f[H+4>>2]|0)==3:0)){f[l>>2]=0;Z=l+4|0;f[Z>>2]=0;_=tT(l,45)|0;M=_;N=273134;Q=M+45|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(Q|0));z5(-215,l,273039,273063,230)}H=x+40|0;U=f[H>>2]|0;if(!((f[U>>2]|0)==3?(f[U+4>>2]|0)==3:0)){f[l>>2]=0;Z=l+4|0;f[Z>>2]=0;_=tT(l,45)|0;M=_;N=273134;Q=M+45|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(Q|0));z5(-215,l,273039,273063,230)}_=f[R>>2]|0;if(!((f[_>>2]|0)==3?((f[_+4>>2]|0)+-3|0)>>>0<2:0)){f[l>>2]=0;f[l+4>>2]=0;M=tT(l,49)|0;N=273180;Q=M+49|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(Q|0));z5(-215,l,273039,273063,231)}f[l>>2]=-2147483648;f[l+4>>2]=2147483647;f[m>>2]=0;f[m+4>>2]=3;$S(F,A,l,m);mY(E,F,x);bY(D,E,0);Hpa(C,D);$j(D);$j(E);E=F+36|0;D=f[E>>2]|0;if(D|0?(N=D+12|0,D=f[N>>2]|0,f[N>>2]=D+-1,(D|0)==1):0)_S(F);f[E>>2]=0;E=F+16|0;D=F+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[D>>2]|0)>0){E=f[F+40>>2]|0;N=0;do{f[E+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[D>>2]|0))}D=f[F+44>>2]|0;if((D|0)!=(F+48|0))g0(D);D=C+16|0;N=f[D>>2]|0;E=z+16|0;M=f[E>>2]|0;Q=z+44|0;$=+p[M+16>>3];_=M+(f[f[Q>>2]>>2]|0)|0;aa=+p[_+16>>3];ba=+p[M>>3];ca=+p[_+8>>3];_=o+40|0;M=f[_>>2]|0;Z=f[M+4>>2]|0;U=f[M>>2]|0;M=(Z|0)==1;if(!(M&(U|0)==4)?(W=(U|0)==1,!((Z|0)==14&W|(M&(U|0)==14|((Z|0)==12&W|(M&(U|0)==12|((Z|0)==8&W|(M&(U|0)==8|((Z|0)==5&W|((Z|0)==4&W|M&(U|0)==5))))))))):0){f[l>>2]=0;f[l+4>>2]=0;dJc(tT(l,350)|0,273230,350)|0;z5(-215,l,273039,273063,242)}U=o+8|0;M=f[U>>2]|0;if((M|0)!=1)if(!(f[o>>2]&16384)){xY(l,o);W=f[l>>2]|0;ei[f[(f[W>>2]|0)+12>>2]&511](W,l,o,-1);$j(l);da=f[U>>2]|0}else da=M;else da=1;M=f[w>>2]|0;U=o+44|0;ea=+p[M>>3];fa=+p[M+8>>3];ga=+p[M+16>>3];ha=+p[M+24>>3];W=(f[o+12>>2]|0)+-1+da|0;do if((W|0)>4){ia=+p[M+32>>3];if((W|0)>7){ja=+p[M+40>>3];ka=+p[M+48>>3];la=+p[M+56>>3];if((W|0)<=11){ma=0.0;na=0.0;oa=ia;pa=ja;qa=ka;ra=la;sa=0.0;ta=0.0;ua=0.0;va=0.0;break}wa=+p[M+64>>3];xa=+p[M+72>>3];ya=+p[M+80>>3];za=+p[M+88>>3];if((W|0)<=13){ma=0.0;na=0.0;oa=ia;pa=ja;qa=ka;ra=la;sa=wa;ta=xa;ua=ya;va=za;break}ma=+p[M+96>>3];na=+p[M+104>>3];oa=ia;pa=ja;qa=ka;ra=la;sa=wa;ta=xa;ua=ya;va=za}else{ma=0.0;na=0.0;oa=ia;pa=0.0;qa=0.0;ra=0.0;sa=0.0;ta=0.0;ua=0.0;va=0.0}}else{ma=0.0;na=0.0;oa=0.0;pa=0.0;qa=0.0;ra=0.0;sa=0.0;ta=0.0;ua=0.0;va=0.0}while(0);ia=+O(+ma);za=+P(+ma);ma=+O(+na);ya=+P(+na);na=ya*0.0;xa=ma+0.0-na;wa=ma*0.0;la=wa+0.0;ka=ia*0.0;ja=za*ya+(ka+la);Aa=za*0.0;Ba=Aa+la-ia*ya;la=ia+0.0-Aa;Ca=ka+(za+0.0);Da=wa+(ya+0.0);ya=na+0.0;na=ka+ya-za*ma;za=ia*ma+(Aa+ya);ya=-Ba;Aa=-Ca;ma=la*0.0;ia=Ca*0.0;ka=xa*0.0+0.0;wa=ja*0.0+0.0;Ea=Ba*0.0+0.0;p[l>>3]=Da*ya+(xa*za+0.0);p[l+8>>3]=na*ya+(ma+(ja*za+0.0));p[l+16>>3]=za*ya+(ia+(Ba*za+0.0));p[l+24>>3]=Da*Aa+(ka+za*0.0);p[l+32>>3]=na*Aa+(wa+la*za);p[l+40>>3]=za*Aa+(Ea+Ca*za);p[l+48>>3]=Da+ka;p[l+56>>3]=na+(ma+wa);p[l+64>>3]=za+(ia+Ea);M=f[d>>2]|0;f[m>>2]=0;f[m+4>>2]=M;d=f[g>>2]|0;f[F>>2]=58040;f[F+4>>2]=d;f[F+8>>2]=M;f[F+12>>2]=t;f[F+16>>2]=v;f[F+20>>2]=e;f[F+24>>2]=N;f[F+28>>2]=l;p[F+32>>3]=$;p[F+40>>3]=aa;p[F+48>>3]=ba;p[F+56>>3]=ca;p[F+64>>3]=ea;p[F+72>>3]=fa;p[F+80>>3]=ga;p[F+88>>3]=ha;p[F+96>>3]=oa;p[F+104>>3]=pa;p[F+112>>3]=qa;p[F+120>>3]=ra;p[F+128>>3]=sa;p[F+136>>3]=ta;p[F+144>>3]=ua;p[F+152>>3]=va;y8(m,F,-1.0);F=C+36|0;m=f[F>>2]|0;do if(m|0){l=m+12|0;N=f[l>>2]|0;f[l>>2]=N+-1;if((N|0)!=1)break;_S(C)}while(0);f[F>>2]=0;F=C+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[F>>2]|0)>0){D=f[C+40>>2]|0;m=0;do{f[D+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[F>>2]|0))}F=f[C+44>>2]|0;if((F|0)!=(C+48|0))g0(F);F=A+36|0;C=f[F>>2]|0;do if(C|0){m=C+12|0;D=f[m>>2]|0;f[m>>2]=D+-1;if((D|0)!=1)break;_S(A)}while(0);f[F>>2]=0;F=A+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[y>>2]|0)>0){F=f[R>>2]|0;R=0;do{f[F+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[y>>2]|0))}y=f[I>>2]|0;if((y|0)!=(j|0))g0(y);y=z+36|0;j=f[y>>2]|0;do if(j|0){I=j+12|0;R=f[I>>2]|0;f[I>>2]=R+-1;if((R|0)!=1)break;_S(z)}while(0);f[y>>2]=0;y=z+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[y>>2]|0)>0){E=f[T>>2]|0;T=0;do{f[E+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[y>>2]|0))}y=f[Q>>2]|0;if((y|0)!=(z+48|0))g0(y);y=x+36|0;z=f[y>>2]|0;do if(z|0){Q=z+12|0;T=f[Q>>2]|0;f[Q>>2]=T+-1;if((T|0)!=1)break;_S(x)}while(0);f[y>>2]=0;y=x+16|0;z=x+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[z>>2]|0)>0){y=f[H>>2]|0;H=0;do{f[y+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[z>>2]|0))}z=f[x+44>>2]|0;if((z|0)!=(x+48|0))g0(z);z=v+36|0;x=f[z>>2]|0;do if(x|0){H=x+12|0;y=f[H>>2]|0;f[H>>2]=y+-1;if((y|0)!=1)break;_S(v)}while(0);f[z>>2]=0;z=v+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[i>>2]|0)>0){z=f[c>>2]|0;c=0;do{f[z+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[G>>2]|0;if((i|0)!=(a|0))g0(i);i=t+36|0;a=f[i>>2]|0;do if(a|0){G=a+12|0;c=f[G>>2]|0;f[G>>2]=c+-1;if((c|0)!=1)break;_S(t)}while(0);f[i>>2]=0;i=t+16|0;a=t+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[t+40>>2]|0;c=0;do{f[i+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[a>>2]|0))}a=f[t+44>>2]|0;if((a|0)!=(t+48|0))g0(a);a=r+36|0;t=f[a>>2]|0;do if(t|0){c=t+12|0;i=f[c>>2]|0;f[c>>2]=i+-1;if((i|0)!=1)break;_S(r)}while(0);f[a>>2]=0;a=r+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[r+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[a>>2]|0))}a=f[r+44>>2]|0;if((a|0)!=(r+48|0))g0(a);a=q+36|0;r=f[a>>2]|0;do if(r|0){t=r+12|0;s=f[t>>2]|0;f[t>>2]=s+-1;if((s|0)!=1)break;_S(q)}while(0);f[a>>2]=0;a=q+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[a>>2]|0)>0){h=f[q+40>>2]|0;r=0;do{f[h+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[a>>2]|0))}a=f[q+44>>2]|0;if((a|0)!=(q+48|0))g0(a);a=o+36|0;q=f[a>>2]|0;do if(q|0){r=q+12|0;h=f[r>>2]|0;f[r>>2]=h+-1;if((h|0)!=1)break;_S(o)}while(0);f[a>>2]=0;a=o+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[a>>2]|0)>0){w=f[_>>2]|0;_=0;do{f[w+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[a>>2]|0))}a=f[U>>2]|0;if((a|0)!=(o+48|0))g0(a);a=n+36|0;o=f[a>>2]|0;do if(o|0){U=o+12|0;_=f[U>>2]|0;f[U>>2]=_+-1;if((_|0)!=1)break;_S(n)}while(0);f[a>>2]=0;a=n+16|0;o=n+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[o>>2]|0)>0){a=f[n+40>>2]|0;_=0;do{f[a+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)==(n+48|0)){u=k;return}g0(o);u=k;return}function Hpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007942;c=f[b>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,b,a,6);return}function Ipa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007942;Kpa(a,b)|0;return}function Jpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((a|0)==(b|0))return a|0;c=b+36|0;d=f[c>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+36|0;d=f[e>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)_S(a);f[e>>2]=0;d=a+16|0;g=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[g>>2]|0)>0){h=f[a+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0;j=f[g>>2]|0}while((i|0)<(j|0));f[a>>2]=f[b>>2];if((j|0)<3)k=12;else k=14}else{f[a>>2]=f[b>>2];k=12}if((k|0)==12){j=f[b+4>>2]|0;if((j|0)<3){f[g>>2]=j;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];j=f[b+44>>2]|0;g=f[a+44>>2]|0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2]}else k=14}if((k|0)==14)ZS(a,b);f[d>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[e>>2]=f[c>>2];return a|0}function Kpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d;g=f[c>>2]|0;if((g&4095|0)==6){if((a|0)==(c|0)){h=a;u=d;return h|0}i=c+36|0;j=f[i>>2]|0;if(j|0){k=j+12|0;f[k>>2]=(f[k>>2]|0)+1}k=a+36|0;j=f[k>>2]|0;if(j|0?(l=j+12|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)_S(a);f[k>>2]=0;j=a+16|0;l=a+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[l>>2]|0)>0){m=f[a+40>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0;o=f[l>>2]|0}while((n|0)<(o|0));f[a>>2]=f[c>>2];if((o|0)<3)p=13;else p=15}else{f[a>>2]=f[c>>2];p=13}if((p|0)==13){o=f[c+4>>2]|0;if((o|0)<3){f[l>>2]=o;f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];o=f[c+44>>2]|0;l=f[a+44>>2]|0;f[l>>2]=f[o>>2];f[l+4>>2]=f[o+4>>2]}else p=15}if((p|0)==15)ZS(a,c);f[j>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[k>>2]=f[i>>2];h=a;u=d;return h|0}if((g&7|0)==6){mT(e,c,1,f[c+4>>2]|0,0);i=Kpa(a,e)|0;k=e+36|0;j=f[k>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)_S(e);f[k>>2]=0;k=e+16|0;j=e+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[e+40>>2]|0;p=0;do{f[k+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}j=f[e+44>>2]|0;if((j|0)!=(e+48|0))g0(j);h=i;u=d;return h|0}else{if(g&4088|0?f[c+16>>2]|0:0){g=f[c+4>>2]|0;if((g|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{i=f[c+40>>2]|0;j=0;p=1;while(1){k=Y(f[i+(j<<2)>>2]|0,p)|0;j=j+1|0;if((j|0)==(g|0)){q=k;break}else p=k}}if(!((g|0)==0|(q|0)==0)){f[e>>2]=0;f[e+4>>2]=0;q=tT(e,52)|0;g=461885;p=q+52|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(p|0));z5(-215,e,518179,461938,1756)}}g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=-2113863674;f[e+4>>2]=a;LZ(c,e,6,1.0,0.0);h=a;u=d;return h|0}return 0}function Lpa(a){a=a|0;YDc(a);return}function Mpa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;i=f[c+4>>2]|0;if((h|0)>=(i|0)){u=e;return}c=a+12|0;j=a+16|0;k=a+24|0;l=f[k>>2]|0;m=l+8|0;o=l+16|0;q=l+32|0;r=l+40|0;s=l+56|0;t=l+64|0;l=a+20|0;v=a+4|0;w=a+96|0;x=a+72|0;y=a+64|0;z=a+120|0;A=a+112|0;B=a+104|0;C=a+80|0;D=a+88|0;E=a+128|0;F=a+136|0;G=a+144|0;H=a+152|0;I=a+28|0;J=a+48|0;K=a+32|0;L=a+56|0;M=a+40|0;a=h;a:while(1){h=f[c>>2]|0;N=(f[h+16>>2]|0)+(Y(f[f[h+44>>2]>>2]|0,a)|0)|0;h=f[j>>2]|0;O=f[h+16>>2]|0;if(O){P=f[h+4>>2]|0;if((P|0)<3)Q=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{R=f[h+40>>2]|0;S=0;T=1;while(1){U=Y(f[R+(S<<2)>>2]|0,T)|0;S=S+1|0;if((S|0)==(P|0)){Q=U;break}else T=U}}if(!((P|0)==0|(Q|0)==0))V=O+(Y(f[f[h+44>>2]>>2]|0,a)|0)|0;else V=0}else V=0;W=+(a|0);X=W*+p[m>>3]+ +p[o>>3];Z=W*+p[q>>3]+ +p[r>>3];_=W*+p[s>>3]+ +p[t>>3];T=f[l>>2]|0;switch(T|0){case 11:{if(!((N|0)!=0&(V|0)!=0)){$=13;break a}break}case 5:{if(!((N|0)!=0&(V|0)!=0)){$=15;break a}break}default:if(!N){$=19;break a}}S=f[v>>2]|0;if((S|0)>0){R=(T|0)==11;U=f[k>>2]|0;aa=U+24|0;ba=U+48|0;ca=(T|0)==5;W=+p[w>>3];da=+p[x>>3];ea=+p[y>>3];fa=+p[z>>3];ga=+p[A>>3];ha=+p[B>>3];ia=+p[C>>3];ja=+p[D>>3];ka=+p[E>>3];la=+p[F>>3];ma=+p[G>>3];na=+p[H>>3];oa=+p[J>>3];pa=X;X=Z;Z=_;T=0;while(1){_=1.0/Z;qa=_*pa;ra=X*_;_=qa*qa;sa=ra*ra;ta=sa+_;ua=ra*(qa*2.0);va=(ta*(ea+ta*(ta*W+da))+1.0)/(ta*(ha+ta*(ta*fa+ga))+1.0);wa=ta*(ta*la)+(ta*ka+((ta+_*2.0)*ja+(ua*ia+qa*va)));qa=ta*(ta*na)+(ta*ma+(ua*ja+((sa*2.0+ta)*ia+ra*va)));xa=f[I>>2]|0;va=+p[xa+64>>3]+(wa*+p[xa+48>>3]+0.0+qa*+p[xa+56>>3]);ra=va!=0.0?1.0/va:1.0;va=+p[K>>3]+(+p[xa+16>>3]+(+p[xa+8>>3]*qa+(+p[xa>>3]*wa+0.0)))*(oa*ra);ta=+p[M>>3]+(+p[xa+40>>3]+(wa*+p[xa+24>>3]+0.0+qa*+p[xa+32>>3]))*(+p[L>>3]*ra);if(R){xa=nrc(va*32.0)|0;ya=nrc(ta*32.0)|0;d[N+(T<<2)>>1]=xa>>>5;d[N+((T<<1|1)<<1)>>1]=ya>>>5;d[V+(T<<1)>>1]=ya<<5&992|xa&31}else{ra=va;if(ca){n[N+(T<<2)>>2]=ra;za=V+(T<<2)|0}else{xa=T<<1;n[N+(xa<<2)>>2]=ra;za=N+((xa|1)<<2)|0}n[za>>2]=ta}T=T+1|0;if((T|0)>=(S|0))break;else{pa=pa+ +p[U>>3];X=X+ +p[aa>>3];Z=Z+ +p[ba>>3]}}}a=a+1|0;if((a|0)>=(i|0)){$=3;break}}if(($|0)==3){u=e;return}else if(($|0)==13){f[g>>2]=0;f[g+4>>2]=0;Aa=tT(g,24)|0;Ba=273581;Ca=Aa+24|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));z5(-215,g,518189,273063,117)}else if(($|0)==15){f[g>>2]=0;f[g+4>>2]=0;Aa=tT(g,26)|0;Ba=273606;Ca=Aa+26|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));z5(-215,g,518189,273063,119)}else if(($|0)==19){f[g>>2]=0;f[g+4>>2]=0;Aa=tT(g,10)|0;Ba=273633;Ca=Aa+10|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));z5(-215,g,518189,273063,121)}}function Npa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;h=u;u=u+1120|0;i=h+256|0;j=h+1104|0;k=h+1040|0;l=h+984|0;m=h+928|0;n=h+872|0;o=h+1096|0;q=h+816|0;r=h+760|0;s=h+704|0;t=h+648|0;v=h+592|0;w=h+536|0;x=h+32|0;y=h+472|0;z=h+416|0;A=h+360|0;B=h+344|0;C=h+328|0;D=h+528|0;E=h;F=h+312|0;do if((d$(a)|0)==65536){G=f[a+4>>2]|0;f[k>>2]=f[G>>2];H=k+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=k+8|0;f[J>>2]=f[G+8>>2];f[k+12>>2]=f[G+12>>2];f[k+16>>2]=f[G+16>>2];f[k+20>>2]=f[G+20>>2];f[k+24>>2]=f[G+24>>2];f[k+28>>2]=f[G+28>>2];f[k+32>>2]=f[G+32>>2];K=f[G+36>>2]|0;f[k+36>>2]=K;f[k+40>>2]=J;J=k+48|0;L=k+44|0;f[L>>2]=J;f[J>>2]=0;f[k+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;ZS(k,G);break}}else a$(k,a,-1);while(0);do if((d$(d)|0)==65536){a=f[d+4>>2]|0;f[l>>2]=f[a>>2];G=l+4|0;H=a+4|0;f[G>>2]=f[H>>2];I=l+8|0;f[I>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];J=f[a+36>>2]|0;f[l+36>>2]=J;f[l+40>>2]=I;I=l+48|0;L=l+44|0;f[L>>2]=I;f[I>>2]=0;f[l+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[a+44>>2]|0;I=f[L>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;ZS(l,a);break}}else a$(l,d,-1);while(0);do if((d$(e)|0)==65536){d=f[e+4>>2]|0;f[m>>2]=f[d>>2];a=m+4|0;G=d+4|0;f[a>>2]=f[G>>2];H=m+8|0;f[H>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];I=f[d+36>>2]|0;f[m+36>>2]=I;f[m+40>>2]=H;H=m+48|0;L=m+44|0;f[L>>2]=H;f[H>>2]=0;f[m+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[d+44>>2]|0;H=f[L>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[a>>2]=0;ZS(m,d);break}}else a$(m,e,-1);while(0);do if((d$(g)|0)==65536){e=f[g+4>>2]|0;f[n>>2]=f[e>>2];d=n+4|0;a=e+4|0;f[d>>2]=f[a>>2];G=n+8|0;f[G>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];f[n+16>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];H=f[e+36>>2]|0;f[n+36>>2]=H;f[n+40>>2]=G;G=n+48|0;L=n+44|0;f[L>>2]=G;f[G>>2]=0;f[n+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[a>>2]|0)<3){a=f[e+44>>2]|0;G=f[L>>2]|0;f[G>>2]=f[a>>2];f[G+4>>2]=f[a+4>>2];break}else{f[d>>2]=0;ZS(n,e);break}}else a$(n,g,-1);while(0);g=k+40|0;e=f[g>>2]|0;d=f[e>>2]|0;f[o>>2]=f[e+4>>2];f[o+4>>2]=d;v$(c,o,f[k>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){o=f[c+4>>2]|0;f[q>>2]=f[o>>2];d=q+4|0;e=o+4|0;f[d>>2]=f[e>>2];a=q+8|0;f[a>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2];G=q+16|0;f[G>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2];f[q+24>>2]=f[o+24>>2];f[q+28>>2]=f[o+28>>2];f[q+32>>2]=f[o+32>>2];L=f[o+36>>2]|0;f[q+36>>2]=L;f[q+40>>2]=a;a=q+48|0;H=q+44|0;f[H>>2]=a;f[a>>2]=0;f[q+52>>2]=0;if(L|0){a=L+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[e>>2]|0)<3){e=f[o+44>>2]|0;a=f[H>>2]|0;f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];M=G;break}else{f[d>>2]=0;ZS(q,o);M=G;break}}else{a$(q,c,-1);M=q+16|0}while(0);c=k+16|0;if((f[M>>2]|0)==(f[c>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;N=tT(i,20)|0;G=273678;O=N+20|0;do{b[N>>0]=b[G>>0]|0;N=N+1|0;G=G+1|0}while((N|0)<(O|0));z5(-215,i,273699,273063,284)}G=k+12|0;o=f[G>>2]|0;d=4096/(((o|0)>1?o:1)>>>0)|0;e=k+8|0;a=f[e>>2]|0;H=d>>>0>1?d:1;d=(a|0)<(H|0)?a:H;f[r>>2]=1124007936;H=r+4|0;a=r+8|0;L=r+40|0;N=H;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[L>>2]=a;a=r+48|0;I=r+44|0;f[I>>2]=a;f[a>>2]=0;f[r+52>>2]=0;f[i>>2]=d;J=i+4|0;f[J>>2]=o;XS(r,2,i,11);o=f[G>>2]|0;f[s>>2]=1124007936;K=s+4|0;P=s+8|0;Q=s+40|0;N=K;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[Q>>2]=P;P=s+48|0;R=s+44|0;f[R>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[i>>2]=d;f[J>>2]=o;XS(s,2,i,2);o=t+4|0;S=t+8|0;T=t+40|0;N=o;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[T>>2]=S;S=t+48|0;U=t+44|0;f[U>>2]=S;f[S>>2]=0;f[t+52>>2]=0;f[t>>2]=1124007942;V=v+4|0;W=v+8|0;X=v+40|0;N=V;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[X>>2]=W;W=v+48|0;N=v+44|0;f[N>>2]=W;f[W>>2]=0;f[v+52>>2]=0;f[v>>2]=1124007942;GY(x,3,3,6);Hpa(w,x);$j(x);x=i+8|0;f[x>>2]=0;f[x+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=t;LZ(l,i,6,1.0,0.0);x=m+16|0;O=(f[x>>2]|0)==0;Z=m+4|0;_=f[Z>>2]|0;if(!O){if((_|0)<3)$=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{aa=f[m+40>>2]|0;ba=0;ca=1;while(1){da=Y(f[aa+(ba<<2)>>2]|0,ca)|0;ba=ba+1|0;if((ba|0)==(_|0)){$=da;break}else ca=da}}if(!((_|0)==0|($|0)==0)){Ipa(i,m);$=i+36|0;ca=f[$>>2]|0;if(ca|0){ba=ca+12|0;f[ba>>2]=(f[ba>>2]|0)+1}ba=m+36|0;ca=f[ba>>2]|0;if(ca|0?(aa=ca+12|0,ca=f[aa>>2]|0,f[aa>>2]=ca+-1,(ca|0)==1):0)_S(m);f[ba>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[Z>>2]|0)>0){ca=f[m+40>>2]|0;aa=0;do{f[ca+(aa<<2)>>2]=0;aa=aa+1|0;ea=f[Z>>2]|0}while((aa|0)<(ea|0));f[m>>2]=f[i>>2];if((ea|0)<3)fa=54;else fa=56}else{f[m>>2]=f[i>>2];fa=54}if((fa|0)==54){ea=f[i+4>>2]|0;if((ea|0)<3){f[Z>>2]=ea;f[m+8>>2]=f[i+8>>2];f[m+12>>2]=f[i+12>>2];ea=f[i+44>>2]|0;Z=f[m+44>>2]|0;f[Z>>2]=f[ea>>2];f[Z+4>>2]=f[ea+4>>2]}else fa=56}if((fa|0)==56)ZS(m,i);ea=i+16|0;f[x>>2]=f[ea>>2];f[m+20>>2]=f[i+20>>2];f[m+24>>2]=f[i+24>>2];f[m+28>>2]=f[i+28>>2];f[m+32>>2]=f[i+32>>2];Z=f[$>>2]|0;f[ba>>2]=Z;if(Z|0?(ba=Z+12|0,Z=f[ba>>2]|0,f[ba>>2]=Z+-1,(Z|0)==1):0)_S(i);f[$>>2]=0;$=i+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[$>>2]|0)>0){ea=f[i+40>>2]|0;Z=0;do{f[ea+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[$>>2]|0))}$=f[i+44>>2]|0;if(($|0)!=(i+48|0))g0($)}else fa=66}else fa=66;if((fa|0)==66){if(!((((_|0)<3?(f[m+8>>2]|0)==5:0)?(f[m+12>>2]|0)==1:0)?!((f[m>>2]&4095|0)!=6|O):0))fa=70;if((fa|0)==70){f[i>>2]=5;f[J>>2]=1;XS(m,2,i,6)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;k_(m,i)|0}J=n+16|0;if(f[J>>2]|0){O=f[n+4>>2]|0;if((O|0)<3)ga=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{_=f[n+40>>2]|0;$=0;Z=1;while(1){ea=Y(f[_+($<<2)>>2]|0,Z)|0;$=$+1|0;if(($|0)==(O|0)){ga=ea;break}else Z=ea}}if(!((O|0)==0|(ga|0)==0)){ga=i+8|0;f[ga>>2]=0;f[ga+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=v;LZ(n,i,6,1.0,0.0)}else fa=79}else fa=79;if((fa|0)==79){fa=i+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=v;h_(t,i)}fa=v+16|0;ha=+p[(f[fa>>2]|0)+(f[f[N>>2]>>2]|0)+16>>3];ga=f[e>>2]|0;if((ga|0)>0){O=i+4|0;Z=j+4|0;$=i+4|0;_=j+4|0;ea=i+4|0;ba=j+4|0;aa=i+8|0;ca=i+12|0;da=i+4|0;ia=j+8|0;ja=j+12|0;ka=j+4|0;la=B+8|0;ma=B+12|0;na=B+4|0;oa=C+8|0;pa=C+12|0;qa=C+4|0;ra=D+4|0;sa=E+8|0;ta=E+4|0;ua=F+8|0;va=F+4|0;wa=i+8|0;xa=i+12|0;ya=i+4|0;za=j+8|0;Aa=j+4|0;Ba=B+8|0;Ca=B+12|0;Da=B+4|0;Ea=C+8|0;Fa=C+12|0;Ga=C+4|0;Ha=A+36|0;Ia=A+16|0;Ja=A+4|0;Ka=A+40|0;La=A+44|0;Ma=A+48|0;Na=z+36|0;Oa=z+16|0;Pa=z+4|0;Qa=z+40|0;Ra=z+44|0;Sa=z+48|0;Ta=y+36|0;Ua=y+16|0;Va=y+4|0;Wa=y+40|0;Xa=y+44|0;Ya=y+48|0;Za=0;_a=ga;do{ga=_a-Za|0;$a=(ga|0)<(d|0)?ga:d;p[(f[fa>>2]|0)+(f[f[N>>2]>>2]|0)+16>>3]=ha-+(Za|0);f[i>>2]=0;f[O>>2]=$a;f[j>>2]=-2147483648;f[Z>>2]=2147483647;$S(y,r,i,j);f[i>>2]=0;f[$>>2]=$a;f[j>>2]=-2147483648;f[_>>2]=2147483647;$S(z,s,i,j);f[i>>2]=Za;f[ea>>2]=$a+Za;f[j>>2]=-2147483648;f[ba>>2]=2147483647;$S(A,q,i,j);f[aa>>2]=0;f[ca>>2]=0;f[i>>2]=-2130640890;f[da>>2]=t;f[ia>>2]=0;f[ja>>2]=0;f[j>>2]=16842752;f[ka>>2]=m;f[la>>2]=0;f[ma>>2]=0;f[B>>2]=-2130640890;f[na>>2]=w;f[oa>>2]=0;f[pa>>2]=0;f[C>>2]=-2130640890;f[qa>>2]=v;f[D>>2]=f[G>>2];f[ra>>2]=$a;$a=f[y>>2]&4095;ga=sa;f[ga>>2]=0;f[ga+4>>2]=0;f[E>>2]=33619968;f[ta>>2]=y;ga=ua;f[ga>>2]=0;f[ga+4>>2]=0;f[F>>2]=33619968;f[va>>2]=z;Gpa(i,j,B,C,D,$a,E,F);f[wa>>2]=0;f[xa>>2]=0;f[i>>2]=16842752;f[ya>>2]=k;$a=za;f[$a>>2]=0;f[$a+4>>2]=0;f[j>>2]=33619968;f[Aa>>2]=A;f[Ba>>2]=0;f[Ca>>2]=0;f[B>>2]=16842752;f[Da>>2]=y;f[Ea>>2]=0;f[Fa>>2]=0;f[C>>2]=16842752;f[Ga>>2]=z;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[E+28>>2]=0;Moa(i,j,B,C,1,0,E);$a=f[Ha>>2]|0;if($a|0?(ga=$a+12|0,$a=f[ga>>2]|0,f[ga>>2]=$a+-1,($a|0)==1):0)_S(A);f[Ha>>2]=0;f[Ia>>2]=0;f[Ia+4>>2]=0;f[Ia+8>>2]=0;f[Ia+12>>2]=0;if((f[Ja>>2]|0)>0){$a=f[Ka>>2]|0;ga=0;do{f[$a+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[Ja>>2]|0))}ga=f[La>>2]|0;if((ga|0)!=(Ma|0))g0(ga);ga=f[Na>>2]|0;if(ga|0?($a=ga+12|0,ga=f[$a>>2]|0,f[$a>>2]=ga+-1,(ga|0)==1):0)_S(z);f[Na>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[Pa>>2]|0)>0){ga=f[Qa>>2]|0;$a=0;do{f[ga+($a<<2)>>2]=0;$a=$a+1|0}while(($a|0)<(f[Pa>>2]|0))}$a=f[Ra>>2]|0;if(($a|0)!=(Sa|0))g0($a);$a=f[Ta>>2]|0;if($a|0?(ga=$a+12|0,$a=f[ga>>2]|0,f[ga>>2]=$a+-1,($a|0)==1):0)_S(y);f[Ta>>2]=0;f[Ua>>2]=0;f[Ua+4>>2]=0;f[Ua+8>>2]=0;f[Ua+12>>2]=0;if((f[Va>>2]|0)>0){$a=f[Wa>>2]|0;ga=0;do{f[$a+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[Va>>2]|0))}ga=f[Xa>>2]|0;if((ga|0)!=(Ya|0))g0(ga);Za=Za+d|0;_a=f[e>>2]|0}while((_a|0)>(Za|0))}Za=w+36|0;_a=f[Za>>2]|0;if(_a|0?(e=_a+12|0,_a=f[e>>2]|0,f[e>>2]=_a+-1,(_a|0)==1):0)_S(w);f[Za>>2]=0;Za=w+16|0;_a=w+4|0;f[Za>>2]=0;f[Za+4>>2]=0;f[Za+8>>2]=0;f[Za+12>>2]=0;if((f[_a>>2]|0)>0){Za=f[w+40>>2]|0;e=0;do{f[Za+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[_a>>2]|0))}_a=f[w+44>>2]|0;if((_a|0)!=(w+48|0))g0(_a);_a=v+36|0;w=f[_a>>2]|0;if(w|0?(e=w+12|0,w=f[e>>2]|0,f[e>>2]=w+-1,(w|0)==1):0)_S(v);f[_a>>2]=0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[V>>2]|0)>0){fa=f[X>>2]|0;X=0;do{f[fa+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[V>>2]|0))}V=f[N>>2]|0;if((V|0)!=(W|0))g0(V);V=t+36|0;W=f[V>>2]|0;if(W|0?(N=W+12|0,W=f[N>>2]|0,f[N>>2]=W+-1,(W|0)==1):0)_S(t);f[V>>2]=0;V=t+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[o>>2]|0)>0){V=f[T>>2]|0;T=0;do{f[V+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[o>>2]|0))}o=f[U>>2]|0;if((o|0)!=(S|0))g0(o);o=s+36|0;S=f[o>>2]|0;do if(S|0){U=S+12|0;T=f[U>>2]|0;f[U>>2]=T+-1;if((T|0)!=1)break;_S(s)}while(0);f[o>>2]=0;o=s+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[K>>2]|0)>0){o=f[Q>>2]|0;Q=0;do{f[o+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[K>>2]|0))}K=f[R>>2]|0;if((K|0)!=(P|0))g0(K);K=r+36|0;P=f[K>>2]|0;do if(P|0){R=P+12|0;Q=f[R>>2]|0;f[R>>2]=Q+-1;if((Q|0)!=1)break;_S(r)}while(0);f[K>>2]=0;K=r+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[H>>2]|0)>0){K=f[L>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[H>>2]|0))}H=f[I>>2]|0;if((H|0)!=(a|0))g0(H);H=q+36|0;a=f[H>>2]|0;do if(a|0){I=a+12|0;L=f[I>>2]|0;f[I>>2]=L+-1;if((L|0)!=1)break;_S(q)}while(0);f[H>>2]=0;H=q+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[H>>2]|0)>0){M=f[q+40>>2]|0;a=0;do{f[M+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[H>>2]|0))}H=f[q+44>>2]|0;if((H|0)!=(q+48|0))g0(H);H=n+36|0;q=f[H>>2]|0;do if(q|0){a=q+12|0;M=f[a>>2]|0;f[a>>2]=M+-1;if((M|0)!=1)break;_S(n)}while(0);f[H>>2]=0;H=n+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[H>>2]|0)>0){J=f[n+40>>2]|0;q=0;do{f[J+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[H>>2]|0))}H=f[n+44>>2]|0;if((H|0)!=(n+48|0))g0(H);H=m+36|0;n=f[H>>2]|0;do if(n|0){q=n+12|0;J=f[q>>2]|0;f[q>>2]=J+-1;if((J|0)!=1)break;_S(m)}while(0);f[H>>2]=0;H=m+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[H>>2]|0)>0){x=f[m+40>>2]|0;n=0;do{f[x+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[H>>2]|0))}H=f[m+44>>2]|0;if((H|0)!=(m+48|0))g0(H);H=l+36|0;m=f[H>>2]|0;do if(m|0){n=m+12|0;x=f[n>>2]|0;f[n>>2]=x+-1;if((x|0)!=1)break;_S(l)}while(0);f[H>>2]=0;H=l+16|0;m=l+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[m>>2]|0)>0){H=f[l+40>>2]|0;x=0;do{f[H+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))g0(m);m=k+36|0;l=f[m>>2]|0;do if(l|0){x=l+12|0;H=f[x>>2]|0;f[x>>2]=H+-1;if((H|0)!=1)break;_S(k)}while(0);f[m>>2]=0;m=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[m>>2]|0)>0){c=f[g>>2]|0;g=0;do{f[c+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)==(k+48|0)){u=h;return}g0(m);u=h;return}function Opa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0;i=u;u=u+1264|0;j=i+1200|0;k=i+136|0;l=i+24|0;m=i;o=i+80|0;do if((d$(a)|0)==65536){p=f[a+4>>2]|0;f[l>>2]=f[p>>2];q=l+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=l+8|0;f[s>>2]=f[p+8>>2];f[l+12>>2]=f[p+12>>2];f[l+16>>2]=f[p+16>>2];f[l+20>>2]=f[p+20>>2];f[l+24>>2]=f[p+24>>2];f[l+28>>2]=f[p+28>>2];f[l+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[l+36>>2]=t;f[l+40>>2]=s;s=l+48|0;v=l+44|0;f[v>>2]=s;f[s>>2]=0;f[l+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;ZS(l,p);break}}else a$(l,a,-1);while(0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;a=pT(l,2,-1,0)|0;p=pT(l,3,-1,0)|0;q=(a|0)>-1;if((p&a|0)<=-1){f[j>>2]=0;f[j+4>>2]=0;w=tT(j,30)|0;x=273709;y=w+30|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,j,273740,273748,607)}if((f[l>>2]&16391|0)==16389)z=l+16|0;else{f[j>>2]=1124007936;r=j+4|0;s=j+8|0;v=j+40|0;w=r;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[v>>2]=s;t=j+48|0;A=j+44|0;f[A>>2]=t;f[t>>2]=0;f[j+52>>2]=0;B=k+8|0;f[B>>2]=0;f[B+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;LZ(l,k,5,1.0,0.0);B=j+36|0;C=f[B>>2]|0;if(C|0){D=C+12|0;f[D>>2]=(f[D>>2]|0)+1}D=l+36|0;C=f[D>>2]|0;if(C|0?(E=C+12|0,C=f[E>>2]|0,f[E>>2]=C+-1,(C|0)==1):0)_S(l);f[D>>2]=0;C=l+16|0;E=l+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[E>>2]|0)>0){F=f[l+40>>2]|0;G=0;do{f[F+(G<<2)>>2]=0;G=G+1|0;H=f[E>>2]|0}while((G|0)<(H|0));f[l>>2]=f[j>>2];if((H|0)<3)I=22;else I=24}else{f[l>>2]=f[j>>2];I=22}if((I|0)==22){H=f[r>>2]|0;if((H|0)<3){f[E>>2]=H;f[l+8>>2]=f[s>>2];f[l+12>>2]=f[j+12>>2];s=f[A>>2]|0;H=f[l+44>>2]|0;f[H>>2]=f[s>>2];f[H+4>>2]=f[s+4>>2]}else I=24}if((I|0)==24)ZS(l,j);s=j+16|0;f[C>>2]=f[s>>2];f[l+20>>2]=f[j+20>>2];f[l+24>>2]=f[j+24>>2];f[l+28>>2]=f[j+28>>2];f[l+32>>2]=f[j+32>>2];H=f[B>>2]|0;f[D>>2]=H;if(H|0?(D=H+12|0,H=f[D>>2]|0,f[D>>2]=H+-1,(H|0)==1):0)_S(j);f[B>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[v>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[r>>2]|0))}r=f[A>>2]|0;if((r|0)!=(t|0))g0(r);z=C}C=f[z>>2]|0;if(q){K=e;N=g;O=h;P=+(a|0)*1.1920928955078125e-07;Q=N!=0.0?N:1.0;q=O!=0.0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;switch(d|0){case 2:{Ppa(C,a,0,m);break}case 1:{S=359;T=0;I=42;break}case 4:{S=360;T=0;I=42;break}case 5:{S=0;T=41;I=42;break}case 6:{S=0;T=42;I=42;break}case 7:{S=0;T=43;I=42;break}default:{f[k>>2]=0;f[k+4>>2]=0;w=tT(k,21)|0;x=273817;y=w+21|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-5,k,273839,273748,361)}}if((I|0)==42){r=a<<1;t=k+8|0;f[k>>2]=t;A=k+4|0;f[A>>2]=r;if(r>>>0>264){v=XDc(r>>>0>1073741823?-1:r<<2)|0;f[k>>2]=v;U=v}else U=t;v=U+(a<<2)|0;r=(a|0)>0;s=(a|0)<10?a:10;B=j+4|0;N=q?O:.009999999776482582;q=j+8|0;H=j+12|0;D=(S|0)==0;E=a<<2;G=(a|0)==0|r^1;F=0;O=0.0;V=1797693134862315708145274.0e284;W=0.0;X=0.0;Y=0.0;Z=0.0;_=-1;$=-1;while(1){if(r)XIc(U|0,0,E|0)|0;if(G){aa=_;ba=$}else{ca=0;da=_;ea=$;while(1){fa=da;ga=ea;do{ha=mJc(fa|0,0,-130063606,0)|0;fa=UIc(ha|0,J|0,ga|0,0)|0;ga=J;ia=U+(((fa>>>0)%(a>>>0)|0)<<2)|0}while(!(+n[ia>>2]<1.1920928955078125e-07));ca=ca+1|0;n[ia>>2]=1.0;if((ca|0)>=(s|0)){aa=fa;ba=ga;break}else{da=fa;ea=ga}}}Ppa(C,a,U,j);ea=0;ja=O;da=0;ka=W;la=X;ma=Y;na=Z;while(1){if(ea){oa=+n[j>>2];pa=+n[B>>2];qa=ka*oa+la*pa;ra=qa<-1.0?-1.0:qa;if(+L(+(+R(+(ra>1.0?1.0:ra))))<N?(ra=+L(+(+n[q>>2]-ma)),qa=+L(+(+n[H>>2]-na)),(ra>qa?ra:qa)<Q):0){sa=ja;ta=ka;ua=la;va=ma;wa=na;break}else{xa=oa;ya=pa}}else{xa=+n[j>>2];ya=+n[B>>2]}pa=+n[q>>2];oa=+n[H>>2];if(r){qa=0.0;ca=0;while(1){ra=+L(+(ya*(+n[C+(ca<<3)>>2]-pa)-xa*(+n[C+(ca<<3)+4>>2]-oa)));n[v+(ca<<2)>>2]=ra;za=qa+ra;ca=ca+1|0;if((ca|0)==(a|0)){Aa=za;break}else qa=za}}else Aa=0.0;if(Aa<P){sa=Aa;ta=ka;ua=la;va=ma;wa=na;break}if(D)$h[T&63](v,a,U,K);else Ti[S&511](v,a,U);if(r){ca=0;qa=0.0;while(1){za=qa+ +n[U+(ca<<2)>>2];ca=ca+1|0;if((ca|0)==(a|0)){Ba=za;break}else qa=za}}else Ba=0.0;if(+L(+Ba)>1.1920928955078125e-07){qa=1.0/Ba;if(r){ca=0;do{ga=U+(ca<<2)|0;n[ga>>2]=qa*+n[ga>>2];ca=ca+1|0}while((ca|0)!=(a|0))}}else if(r){ca=0;do{n[U+(ca<<2)>>2]=1.0;ca=ca+1|0}while((ca|0)!=(a|0))}Ppa(C,a,U,j);da=da+1|0;if((da|0)>=30){sa=Aa;ta=xa;ua=ya;va=pa;wa=oa;break}else{ea=1;ja=Aa;ka=xa;la=ya;ma=pa;na=oa}}if(sa<V){f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];if(sa<P)break;else Ca=sa}else Ca=V;F=F+1|0;if((F|0)>=20)break;else{O=sa;V=Ca;W=ta;X=ua;Y=va;Z=wa;_=aa;$=ba}}ba=f[k>>2]|0;if((ba|0)!=(t|0)){if(ba|0)ZDc(ba);f[k>>2]=t;f[A>>2]=264}}}else{wa=e;e=g;g=h;h=+(p|0)*1.1920928955078125e-07;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;Z=e!=0.0?e:1.0;A=g!=0.0;switch(d|0){case 2:{Vpa(C,p,0,m);break}case 1:{Da=359;Ea=0;I=86;break}case 4:{Da=360;Ea=0;I=86;break}case 5:{Da=0;Ea=41;I=86;break}case 6:{Da=0;Ea=42;I=86;break}case 7:{Da=0;Ea=43;I=86;break}default:{f[k>>2]=0;f[k+4>>2]=0;w=tT(k,16)|0;x=273849;y=w+16|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-5,k,273866,273748,496)}}if((I|0)==86){I=p<<1;x=k+8|0;f[k>>2]=x;w=k+4|0;f[w>>2]=I;if(I>>>0>264){y=XDc(I>>>0>1073741823?-1:I<<2)|0;f[k>>2]=y;Fa=y}else Fa=x;y=Fa+(p<<2)|0;I=(p|0)>0;d=(p|0)<10?p:10;t=j+4|0;ba=j+8|0;e=A?g:.009999999776482582;A=j+12|0;$=j+16|0;aa=j+20|0;_=(Da|0)==0;F=p<<2;U=(p|0)==0|I^1;r=0;g=1797693134862315708145274.0e284;va=0.0;Y=0.0;ua=0.0;X=0.0;ta=0.0;W=0.0;Ca=0.0;v=-1;S=-1;while(1){if(I)XIc(Fa|0,0,F|0)|0;if(U){Ga=v;Ha=S}else{T=0;D=v;H=S;while(1){q=D;B=H;do{s=mJc(q|0,0,-130063606,0)|0;q=UIc(s|0,J|0,B|0,0)|0;B=J;Ia=Fa+(((q>>>0)%(p>>>0)|0)<<2)|0}while(!(+n[Ia>>2]<1.1920928955078125e-07));T=T+1|0;n[Ia>>2]=1.0;if((T|0)>=(d|0)){Ga=q;Ha=B;break}else{D=q;H=B}}}Vpa(C,p,Fa,j);H=0;oa=va;D=0;pa=Y;V=ua;sa=X;O=ta;P=W;ya=Ca;while(1){xa=+n[j>>2];if(H){Aa=+n[t>>2];Ba=+n[ba>>2];K=pa*xa+P*Aa+ya*Ba;Q=K<-1.0?-1.0:K;if(+L(+(+R(+(Q>1.0?1.0:Q))))<e?(Q=+n[A>>2]-V,K=+n[$>>2]-sa,N=+n[aa>>2]-O,na=xa-pa,ma=Aa-P,la=Ba-ya,ka=+L(+(la*K-ma*N)),ja=+L(+(na*N-la*Q)),la=+L(+(ma*Q-na*K)),K=ka>ja?ka:ja,(K>la?K:la)<Z):0){Ja=oa;Ka=pa;La=V;Ma=sa;Na=O;Oa=P;Pa=ya;break}else{Qa=Aa;Ra=Ba}}else{Qa=+n[t>>2];Ra=+n[ba>>2]}Ba=+n[A>>2];Aa=+n[$>>2];la=+n[aa>>2];if(I){K=0.0;T=0;while(1){ja=+n[C+(T*12|0)>>2]-Ba;ka=+n[C+(T*12|0)+4>>2]-Aa;na=+n[C+(T*12|0)+8>>2]-la;Q=Qa*na-Ra*ka;ma=Ra*ja-xa*na;na=xa*ka-Qa*ja;ja=+M(+(na*na+(Q*Q+ma*ma)));n[y+(T<<2)>>2]=ja;ma=K+ja;T=T+1|0;if((T|0)==(p|0)){Sa=ma;break}else K=ma}}else Sa=0.0;if(_)$h[Ea&63](y,p,Fa,wa);else Ti[Da&511](y,p,Fa);if(I){T=0;K=0.0;while(1){ma=K+ +n[Fa+(T<<2)>>2];T=T+1|0;if((T|0)==(p|0)){Ta=ma;break}else K=ma}}else Ta=0.0;if(+L(+Ta)>1.1920928955078125e-07){K=1.0/Ta;if(I){T=0;do{B=Fa+(T<<2)|0;n[B>>2]=K*+n[B>>2];T=T+1|0}while((T|0)!=(p|0))}}else if(I){T=0;do{n[Fa+(T<<2)>>2]=1.0;T=T+1|0}while((T|0)!=(p|0))}Vpa(C,p,Fa,j);D=D+1|0;if((D|0)>=30){Ja=Sa;Ka=xa;La=Ba;Ma=Aa;Na=la;Oa=Qa;Pa=Ra;break}else{H=1;oa=Sa;pa=xa;V=Ba;sa=Aa;O=la;P=Qa;ya=Ra}}if(Ja<g){f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];f[m+16>>2]=f[j+16>>2];f[m+20>>2]=f[j+20>>2];if(Ja<h)break;else Ua=Ja}else Ua=g;r=r+1|0;if((r|0)>=20)break;else{g=Ua;va=Ja;Y=Ka;ua=La;X=Ma;ta=Na;W=Oa;Ca=Pa;v=Ga;S=Ha}}Ha=f[k>>2]|0;if((Ha|0)!=(x|0)){if(Ha|0)ZDc(Ha);f[k>>2]=x;f[w>>2]=264}}}w=a>>31&2|4;f[o>>2]=1124007941;a=o+4|0;f[a>>2]=2;x=o+8|0;f[x>>2]=w;f[o+12>>2]=1;k=o+16|0;f[k>>2]=m;f[o+20>>2]=m;Ha=o+24|0;S=o+40|0;Ga=Ha+8|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[S>>2]=x;x=o+48|0;Ga=o+44|0;f[Ga>>2]=x;f[x>>2]=4;f[o+52>>2]=4;v=m+(w<<2)|0;f[o+28>>2]=v;f[Ha>>2]=v;WS(o);h_(o,c);c=o+36|0;v=f[c>>2]|0;if(v|0?(Ha=v+12|0,v=f[Ha>>2]|0,f[Ha>>2]=v+-1,(v|0)==1):0)_S(o);f[c>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[a>>2]|0)>0){k=f[S>>2]|0;S=0;do{f[k+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[a>>2]|0))}a=f[Ga>>2]|0;if((a|0)!=(x|0))g0(a);a=l+36|0;x=f[a>>2]|0;if(x|0?(Ga=x+12|0,x=f[Ga>>2]|0,f[Ga>>2]=x+-1,(x|0)==1):0)_S(l);f[a>>2]=0;a=l+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[a>>2]|0)>0){z=f[l+40>>2]|0;x=0;do{f[z+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}a=f[l+44>>2]|0;if((a|0)==(l+48|0)){u=i;return}g0(a);u=i;return}function Ppa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;g=u;u=u+16|0;h=g;if((c|0)<=0){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,9)|0;j=273876;k=i+9|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,273901,273748,50)}if(!d){h=0;l=0.0;m=0.0;o=0.0;p=0.0;q=0.0;do{r=+n[a+(h<<3)>>2];q=q+r;s=+n[a+(h<<3)+4>>2];l=l+s;m=m+r*r;o=o+s*s;p=p+r*s;h=h+1|0}while((h|0)!=(c|0));t=+(c|0);v=q;w=l;x=m;y=o;z=p}else{p=0.0;h=0;o=0.0;m=0.0;l=0.0;q=0.0;s=0.0;while(1){r=+n[d+(h<<2)>>2];A=+n[a+(h<<3)>>2];B=r*A;C=s+B;D=+n[a+(h<<3)+4>>2];E=r*D;F=o+E;G=m+A*B;A=l+D*E;E=q+B*D;D=p+r;h=h+1|0;if((h|0)==(c|0)){t=D;v=C;w=F;x=G;y=A;z=E;break}else{p=D;o=F;m=G;l=A;q=E;s=C}}}s=v/t;v=w/t;w=+U(+((z/t-v*s)*2.0),+(x/t-s*s-(y/t-v*v)))*.5;t=+O(+w);n[e>>2]=t;t=+P(+w);n[e+4>>2]=t;n[e+8>>2]=s;n[e+12>>2]=v;u=g;return}function Qpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0;e=d<=0.0?1.3450000286102295:d;if((b|0)>0)f=0;else return;do{d=+n[a+(f<<2)>>2];n[c+(f<<2)>>2]=d<e?1.0:e/d;f=f+1|0}while((f|0)!=(b|0));return}function Rpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0;e=d==0.0?.3350532650947571:1.0/d;if((b|0)>0)f=0;else return;do{d=+n[a+(f<<2)>>2];g=+V(+-(e*(e*(d*d))));n[c+(f<<2)>>2]=g;f=f+1|0}while((f|0)!=(b|0));return}function Spa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0;e=d==0.0?.7143877744674683:1.0/d;if((b|0)>0)f=0;else return;do{n[c+(f<<2)>>2]=1.0/(e*+n[a+(f<<2)>>2]+1.0);f=f+1|0}while((f|0)!=(b|0));return}function Tpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0.0;if((b|0)>0)d=0;else return;do{e=+n[a+(d<<2)>>2];f=1.0/+M(+(e*e*.5+1.0));n[c+(d<<2)>>2]=f;d=d+1|0}while((d|0)!=(b|0));return}function Upa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((b|0)>0)d=0;else return;do{e=+L(+(+n[a+(d<<2)>>2]));n[c+(d<<2)>>2]=1.0/(e<1.0e-06?1.0e-06:e);d=d+1|0}while((d|0)!=(b|0));return}function Vpa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;g=u;u=u+304|0;h=g+264|0;i=g+228|0;j=g+216|0;k=g+160|0;l=g+104|0;m=g+48|0;o=g+32|0;p=g+16|0;q=g;if((c|0)<=0){f[h>>2]=0;f[h+4>>2]=0;r=tT(h,9)|0;s=273876;t=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,h,273886,273748,102)};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=i;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));if(!d){r=0;v=0.0;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;do{E=+n[a+(r*12|0)>>2];F=+n[a+(r*12|0)+4>>2];G=+n[a+(r*12|0)+8>>2];y=y+E*E;B=B+E*F;D=D+E*G;z=z+F*F;C=C+F*G;A=A+G*G;v=v+E;w=w+F;x=x+G;r=r+1|0}while((r|0)!=(c|0));H=+(c|0);I=v;J=w;K=x;L=y;N=z;O=A;P=B;Q=C;R=D}else{r=0;D=0.0;C=0.0;B=0.0;A=0.0;z=0.0;y=0.0;x=0.0;w=0.0;v=0.0;G=0.0;while(1){F=+n[a+(r*12|0)>>2];E=+n[a+(r*12|0)+4>>2];S=+n[a+(r*12|0)+8>>2];T=+n[d+(r<<2)>>2];U=z+F*F*T;V=w+F*E*T;W=G+F*S*T;X=y+E*E*T;Y=v+E*S*T;Z=x+S*S*T;_=C+F*T;F=B+E*T;E=A+S*T;S=D+T;r=r+1|0;if((r|0)==(c|0)){H=S;I=_;J=F;K=E;L=U;N=X;O=Z;P=V;Q=Y;R=W;break}else{D=S;C=_;B=F;A=E;z=U;y=X;x=Z;w=V;v=Y;G=W}}}G=I/H;I=J/H;J=K/H;K=L/H-G*G;L=N/H-I*I;N=O/H-J*J;n[h>>2]=N+L;O=-(P/H-G*I);n[h+4>>2]=O;P=-(R/H-G*J);n[h+8>>2]=P;n[h+12>>2]=O;n[h+16>>2]=K+N;N=-(Q/H-I*J);n[h+20>>2]=N;n[h+24>>2]=P;n[h+28>>2]=N;n[h+32>>2]=L+K;f[k>>2]=1124007941;c=k+4|0;f[c>>2]=2;r=k+8|0;f[r>>2]=3;f[k+12>>2]=3;d=k+16|0;f[d>>2]=h;f[k+20>>2]=h;a=k+24|0;t=k+40|0;s=a+8|0;f[s>>2]=0;f[s+4>>2]=0;f[t>>2]=r;r=k+48|0;s=k+44|0;f[s>>2]=r;f[r>>2]=12;f[k+52>>2]=4;f[k+28>>2]=h+36;f[a>>2]=h+36;WS(k);f[l>>2]=1124007941;h=l+4|0;f[h>>2]=2;a=l+8|0;f[a>>2]=3;f[l+12>>2]=3;$=l+16|0;f[$>>2]=i;f[l+20>>2]=i;aa=l+24|0;ba=l+40|0;ca=aa+8|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ba>>2]=a;a=l+48|0;ca=l+44|0;f[ca>>2]=a;f[a>>2]=12;f[l+52>>2]=4;f[l+28>>2]=i+36;f[aa>>2]=i+36;WS(l);f[m>>2]=1124007941;aa=m+4|0;f[aa>>2]=2;da=m+8|0;f[da>>2]=3;f[m+12>>2]=1;ea=m+16|0;f[ea>>2]=j;f[m+20>>2]=j;fa=m+24|0;ga=m+40|0;ha=fa+8|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ga>>2]=da;da=m+48|0;ha=m+44|0;f[ha>>2]=da;f[da>>2]=4;f[m+52>>2]=4;f[m+28>>2]=j+12;f[fa>>2]=j+12;WS(m);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;fa=p+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=m;fa=q+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;iQ(o,p,q)|0;q=!(+n[j>>2]<+n[j+4>>2]);p=i+((+n[j+((q&1)<<2)>>2]<+n[j+8>>2]?(q?3:0):6)<<2)|0;K=+n[p>>2];L=K;N=+n[p+4>>2];P=N;H=+n[p+8>>2];Q=H;O=+M(+(L*L+P*P+Q*Q));Q=O<1.0e-06?1.0e-06:O;n[e>>2]=K/Q;n[e+4>>2]=N/Q;n[e+8>>2]=H/Q;n[e+12>>2]=G;n[e+16>>2]=I;n[e+20>>2]=J;e=m+36|0;p=f[e>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)_S(m);f[e>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[aa>>2]|0)>0){ea=f[ga>>2]|0;ga=0;do{f[ea+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[aa>>2]|0))}aa=f[ha>>2]|0;if((aa|0)!=(da|0))g0(aa);aa=l+36|0;da=f[aa>>2]|0;if(da|0?(ha=da+12|0,da=f[ha>>2]|0,f[ha>>2]=da+-1,(da|0)==1):0)_S(l);f[aa>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[h>>2]|0)>0){$=f[ba>>2]|0;ba=0;do{f[$+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[h>>2]|0))}h=f[ca>>2]|0;if((h|0)!=(a|0))g0(h);h=k+36|0;a=f[h>>2]|0;if(a|0?(ca=a+12|0,a=f[ca>>2]|0,f[ca>>2]=a+-1,(a|0)==1):0)_S(k);f[h>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[t>>2]|0;t=0;do{f[d+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[c>>2]|0))}c=f[s>>2]|0;if((c|0)==(r|0)){u=g;return}g0(c);u=g;return}function Wpa(a,b,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0;p=u;u=u+16|0;q=p;r=(a|0)==0;s=r&(b|0)==4;t=(c|0)==6;if(s&t){Xpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}v=(c|0)==5;if(s&v){Ypa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(s&(c|0)==4){Zpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}c=(b|0)==5;s=r&c;if(s&t){_pa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(s&v){$pa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}s=(b|0)==6;if(r&s&t){aqa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==2&s&t){bqa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==3&s&t){cqa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}r=(a|0)==5;b=r&c;if(b&t){dqa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(b&v){eqa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(r&s&t){fqa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(!((a|0)==6&s&t)){f[q>>2]=0;f[q+4>>2]=0;hqa(-210,q,273916,549)}gqa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}function Xpa(a,c,d,e,g,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;o=u;u=u+1072|0;q=0-n|0;r=o;s=e>>>2;e=k>>>2;k=0-e|0;t=i>>>3;i=Y(n,l)|0;l=i+n|0;v=l<<2;XIc(d|0,0,v|0)|0;w=d+(s+n<<2)|0;if(!g)x=0;else{XIc(g|0,0,l<<3|0)|0;x=g+(t+n<<3)|0}if(!j)y=0;else{XIc(j|0,0,v|0)|0;y=j+(e+n<<2)|0}j=(y|0)==0;if((x|0)==0&j){if((m|0)<=0){u=o;return}v=(i|0)>0;g=c-n|0;z=s-n|0;if((n|0)<=0){u=o;return}A=n+-1|0;B=n<<2;C=w;D=0;E=a;while(1){if(v){F=0;G=C;H=E;while(1){f[G+(q<<2)>>2]=0;I=0;J=0;do{I=(h[H+J>>0]|0)+I|0;f[G+(J<<2)>>2]=I+(f[G+(J-s<<2)>>2]|0);J=J+n|0}while((J|0)<(i|0));F=F+1|0;if((F|0)==(n|0))break;else{G=G+4|0;H=H+1|0}}}else XIc(C+(q<<2)|0,0,B|0)|0;D=D+1|0;if((D|0)==(m|0))break;else{C=C+(A<<2)+4+(z<<2)|0;E=E+A+1+g|0}}u=o;return}if(j){if((m|0)<=0){u=o;return}j=(i|0)>0;g=c-n|0;A=s-n|0;E=t-n|0;if((n|0)<=0){u=o;return}z=n+-1|0;C=x;D=0;B=w;v=a;while(1){if(j){H=0;G=C;F=B;J=v;while(1){f[F+(q<<2)>>2]=0;p[G+(q<<3)>>3]=0.0;K=0.0;I=0;L=0;do{M=b[J+L>>0]|0;I=(M&255)+I|0;N=+(M&255);K=K+N*N;N=+p[G+(L-t<<3)>>3]+K;f[F+(L<<2)>>2]=I+(f[F+(L-s<<2)>>2]|0);p[G+(L<<3)>>3]=N;L=L+n|0}while((L|0)<(i|0));H=H+1|0;if((H|0)==(n|0))break;else{G=G+8|0;F=F+4|0;J=J+1|0}}}else{J=0;F=C;G=B;while(1){f[G+(q<<2)>>2]=0;p[F+(q<<3)>>3]=0.0;J=J+1|0;if((J|0)==(n|0))break;else{F=F+8|0;G=G+4|0}}}D=D+1|0;if((D|0)==(m|0))break;else{C=C+(z<<3)+8+(E<<3)|0;B=B+(z<<2)+4+(A<<2)|0;v=v+z+1+g|0}}u=o;return}g=r+8|0;f[r>>2]=g;z=r+4|0;f[z>>2]=l;if(l>>>0>264){v=XDc(l>>>0>1073741823?-1:l<<2)|0;f[r>>2]=v;O=v}else O=g;v=(n|0)>0;do if(v){l=(i|0)==(n|0);A=s+(n<<1)|0;B=y+(n<<2)|0;if((i|0)>0){P=O;Q=y;R=0;S=x;T=w;U=a}else{E=O;C=y;D=0;j=x;G=w;while(1){f[C+(q<<2)>>2]=0;f[G+(q<<2)>>2]=0;if(l)f[E+(n<<2)>>2]=0;if(!j)V=0;else{p[j+(q<<3)>>3]=0.0;V=j+8|0}D=D+1|0;if((D|0)==(n|0))break;else{E=E+4|0;C=C+4|0;j=V;G=G+4|0}}W=O+(n<<2)|0;X=B;Z=V;_=a+n|0;$=d+(A<<2)|0;break}while(1){f[Q+(q<<2)>>2]=0;f[T+(q<<2)>>2]=0;G=(S|0)!=0;if(G){K=0.0;j=0;C=0;do{E=b[U+C>>0]|0;D=E&255;f[Q+(C<<2)>>2]=D;f[P+(C<<2)>>2]=D;j=D+j|0;N=+(E&255);K=K+N*N;f[T+(C<<2)>>2]=j;p[S+(C<<3)>>3]=K;C=C+n|0}while((C|0)<(i|0))}else{C=0;j=0;do{E=h[U+j>>0]|0;f[Q+(j<<2)>>2]=E;f[P+(j<<2)>>2]=E;C=E+C|0;f[T+(j<<2)>>2]=C;j=j+n|0}while((j|0)<(i|0))}if(l)f[P+(n<<2)>>2]=0;if(G){p[S+(q<<3)>>3]=0.0;aa=S+8|0}else aa=0;R=R+1|0;if((R|0)==(n|0))break;else{P=P+4|0;Q=Q+4|0;S=aa;T=T+4|0;U=U+1|0}}W=O+(n<<2)|0;X=B;Z=aa;_=a+n|0;$=d+(A<<2)|0}else{W=O;X=y;Z=x;_=a;$=w}while(0);if((m|0)>1){w=c-n|0;a=s-n|0;x=e-n|0;y=t-n|0;d=0-s|0;aa=0-t|0;U=i-n|0;T=(U|0)>(n|0);S=e+n|0;Q=(i|0)>(n|0);i=W;W=X;X=1;P=$;$=Z;Z=_;while(1){_=Z+w|0;R=P+(a<<2)|0;V=W+(x<<2)|0;l=i+(q<<2)|0;j=($|0)==0?0:$+(y<<3)|0;if(v){C=P+(s<<2)|0;E=l;D=V;F=0;J=R;H=_;L=j;while(1){I=b[H>>0]|0;M=I&255;K=+(I&255);N=K*K;f[J+(q<<2)>>2]=0;I=(L|0)!=0;if(I)p[L+(q<<3)>>3]=0.0;ba=D+(k<<2)|0;f[D+(q<<2)>>2]=f[ba>>2];f[J>>2]=(f[J+(d<<2)>>2]|0)+M;if(I)p[L>>3]=N+ +p[L+(aa<<3)>>3];f[D>>2]=(f[ba>>2]|0)+M+(f[E+(n<<2)>>2]|0);if(T)if(I){ba=M;K=N;ca=M;da=n;while(1){ea=f[E+(da<<2)>>2]|0;f[E+(da-n<<2)>>2]=ea+ba;fa=b[H+da>>0]|0;ga=fa&255;ha=+(fa&255);fa=ga+ca|0;ia=K+ha*ha;f[J+(da<<2)>>2]=fa+(f[J+(da-s<<2)>>2]|0);p[L+(da<<3)>>3]=ia+ +p[L+(da-t<<3)>>3];ja=da+n|0;f[D+(da<<2)>>2]=ga+ea+(f[E+(ja<<2)>>2]|0)+(f[D+(da-S<<2)>>2]|0);if((ja|0)<(U|0)){ba=ga;K=ia;ca=fa;da=ja}else{ka=ga;la=ia;ma=fa;na=ja;break}}}else{da=M;K=N;ca=M;ba=n;while(1){G=f[E+(ba<<2)>>2]|0;f[E+(ba-n<<2)>>2]=G+da;ja=b[H+ba>>0]|0;fa=ja&255;ia=+(ja&255);ja=fa+ca|0;ha=K+ia*ia;f[J+(ba<<2)>>2]=ja+(f[J+(ba-s<<2)>>2]|0);ga=ba+n|0;f[D+(ba<<2)>>2]=fa+G+(f[E+(ga<<2)>>2]|0)+(f[D+(ba-S<<2)>>2]|0);if((ga|0)<(U|0)){da=fa;K=ha;ca=ja;ba=ga}else{ka=fa;la=ha;ma=ja;na=ga;break}}}else{ka=M;la=N;ma=M;na=n}if(Q){ba=E+(na<<2)|0;ca=f[ba>>2]|0;f[E+(na-n<<2)>>2]=ca+ka;da=b[H+na>>0]|0;ga=da&255;f[J+(na<<2)>>2]=ga+ma+(f[J+(na-s<<2)>>2]|0);K=+(da&255);if(I)p[L+(na<<3)>>3]=la+K*K+ +p[L+(na-t<<3)>>3];f[D+(na<<2)>>2]=ga+ca+(f[D+(na-S<<2)>>2]|0);f[ba>>2]=ga}L=I?L+8|0:0;F=F+1|0;if((F|0)==(n|0))break;else{E=E+4|0;D=D+4|0;J=J+4|0;H=H+1|0}}oa=i;pa=W+(e<<2)|0;qa=Z+c|0;ra=C;sa=L}else{oa=l;pa=V;qa=_;ra=R;sa=j}X=X+1|0;if((X|0)==(m|0))break;else{i=oa;W=pa;P=ra;$=sa;Z=qa}}}if((O|0)!=(g|0)){ZDc(O);f[r>>2]=g;f[z>>2]=264}u=o;return}function Ypa(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;p=u;u=u+1072|0;q=0-o|0;r=p;s=e>>>2;e=k>>>2;k=0-e|0;t=i>>>2;i=Y(o,l)|0;l=i+o|0;v=l<<2;XIc(d|0,0,v|0)|0;w=d+(s+o<<2)|0;if(!g)x=0;else{XIc(g|0,0,v|0)|0;x=g+(t+o<<2)|0}if(!j)y=0;else{XIc(j|0,0,v|0)|0;y=j+(e+o<<2)|0}j=(y|0)==0;if((x|0)==0&j){if((m|0)<=0){u=p;return}v=(i|0)>0;g=c-o|0;z=s-o|0;if((o|0)<=0){u=p;return}A=o+-1|0;B=o<<2;C=w;D=0;E=a;while(1){if(v){F=0;G=C;H=E;while(1){f[G+(q<<2)>>2]=0;I=0;J=0;do{I=(h[H+J>>0]|0)+I|0;f[G+(J<<2)>>2]=I+(f[G+(J-s<<2)>>2]|0);J=J+o|0}while((J|0)<(i|0));F=F+1|0;if((F|0)==(o|0))break;else{G=G+4|0;H=H+1|0}}}else XIc(C+(q<<2)|0,0,B|0)|0;D=D+1|0;if((D|0)==(m|0))break;else{C=C+(A<<2)+4+(z<<2)|0;E=E+A+1+g|0}}u=p;return}if(j){if((m|0)<=0){u=p;return}j=(i|0)>0;g=c-o|0;A=s-o|0;E=t-o|0;if((o|0)<=0){u=p;return}z=o+-1|0;C=x;D=0;B=w;v=a;while(1){if(j){H=0;G=C;F=B;J=v;while(1){f[F+(q<<2)>>2]=0;n[G+(q<<2)>>2]=0.0;K=0.0;I=0;L=0;do{M=b[J+L>>0]|0;I=(M&255)+I|0;N=+(M&255);K=K+N*N;N=+n[G+(L-t<<2)>>2]+K;f[F+(L<<2)>>2]=I+(f[F+(L-s<<2)>>2]|0);n[G+(L<<2)>>2]=N;L=L+o|0}while((L|0)<(i|0));H=H+1|0;if((H|0)==(o|0))break;else{G=G+4|0;F=F+4|0;J=J+1|0}}}else{J=0;F=C;G=B;while(1){f[G+(q<<2)>>2]=0;n[F+(q<<2)>>2]=0.0;J=J+1|0;if((J|0)==(o|0))break;else{F=F+4|0;G=G+4|0}}}D=D+1|0;if((D|0)==(m|0))break;else{C=C+(z<<2)+4+(E<<2)|0;B=B+(z<<2)+4+(A<<2)|0;v=v+z+1+g|0}}u=p;return}g=r+8|0;f[r>>2]=g;z=r+4|0;f[z>>2]=l;if(l>>>0>264){v=XDc(l>>>0>1073741823?-1:l<<2)|0;f[r>>2]=v;O=v}else O=g;v=(o|0)>0;do if(v){l=(i|0)==(o|0);A=s+(o<<1)|0;B=y+(o<<2)|0;if((i|0)>0){P=O;Q=y;R=0;S=x;T=w;U=a}else{E=O;C=y;D=0;j=x;G=w;while(1){f[C+(q<<2)>>2]=0;f[G+(q<<2)>>2]=0;if(l)f[E+(o<<2)>>2]=0;if(!j)V=0;else{n[j+(q<<2)>>2]=0.0;V=j+4|0}D=D+1|0;if((D|0)==(o|0))break;else{E=E+4|0;C=C+4|0;j=V;G=G+4|0}}W=O+(o<<2)|0;X=B;Z=V;_=a+o|0;$=d+(A<<2)|0;break}while(1){f[Q+(q<<2)>>2]=0;f[T+(q<<2)>>2]=0;G=(S|0)!=0;if(G){K=0.0;j=0;C=0;do{E=b[U+C>>0]|0;D=E&255;f[Q+(C<<2)>>2]=D;f[P+(C<<2)>>2]=D;j=D+j|0;N=+(E&255);K=K+N*N;f[T+(C<<2)>>2]=j;n[S+(C<<2)>>2]=K;C=C+o|0}while((C|0)<(i|0))}else{C=0;j=0;do{E=h[U+j>>0]|0;f[Q+(j<<2)>>2]=E;f[P+(j<<2)>>2]=E;C=E+C|0;f[T+(j<<2)>>2]=C;j=j+o|0}while((j|0)<(i|0))}if(l)f[P+(o<<2)>>2]=0;if(G){n[S+(q<<2)>>2]=0.0;aa=S+4|0}else aa=0;R=R+1|0;if((R|0)==(o|0))break;else{P=P+4|0;Q=Q+4|0;S=aa;T=T+4|0;U=U+1|0}}W=O+(o<<2)|0;X=B;Z=aa;_=a+o|0;$=d+(A<<2)|0}else{W=O;X=y;Z=x;_=a;$=w}while(0);if((m|0)>1){w=c-o|0;a=s-o|0;x=e-o|0;y=t-o|0;d=0-s|0;aa=0-t|0;U=i-o|0;T=(U|0)>(o|0);S=e+o|0;Q=(i|0)>(o|0);i=W;W=X;X=1;P=$;$=Z;Z=_;while(1){_=Z+w|0;R=P+(a<<2)|0;V=W+(x<<2)|0;l=i+(q<<2)|0;j=($|0)==0?0:$+(y<<2)|0;if(v){C=P+(s<<2)|0;E=l;D=V;F=0;J=R;H=_;L=j;while(1){I=b[H>>0]|0;M=I&255;K=+(I&255);N=K*K;f[J+(q<<2)>>2]=0;I=(L|0)!=0;if(I)n[L+(q<<2)>>2]=0.0;ba=D+(k<<2)|0;f[D+(q<<2)>>2]=f[ba>>2];f[J>>2]=(f[J+(d<<2)>>2]|0)+M;if(I)n[L>>2]=N+ +n[L+(aa<<2)>>2];f[D>>2]=(f[ba>>2]|0)+M+(f[E+(o<<2)>>2]|0);if(T)if(I){ba=M;K=N;ca=M;da=o;while(1){ea=f[E+(da<<2)>>2]|0;f[E+(da-o<<2)>>2]=ea+ba;fa=b[H+da>>0]|0;ga=fa&255;ha=+(fa&255);fa=ga+ca|0;ia=K+ha*ha;f[J+(da<<2)>>2]=fa+(f[J+(da-s<<2)>>2]|0);n[L+(da<<2)>>2]=ia+ +n[L+(da-t<<2)>>2];ja=da+o|0;f[D+(da<<2)>>2]=ga+ea+(f[E+(ja<<2)>>2]|0)+(f[D+(da-S<<2)>>2]|0);if((ja|0)<(U|0)){ba=ga;K=ia;ca=fa;da=ja}else{ka=ga;la=ia;ma=fa;na=ja;break}}}else{da=M;K=N;ca=M;ba=o;while(1){G=f[E+(ba<<2)>>2]|0;f[E+(ba-o<<2)>>2]=G+da;ja=b[H+ba>>0]|0;fa=ja&255;ia=+(ja&255);ja=fa+ca|0;ha=K+ia*ia;f[J+(ba<<2)>>2]=ja+(f[J+(ba-s<<2)>>2]|0);ga=ba+o|0;f[D+(ba<<2)>>2]=fa+G+(f[E+(ga<<2)>>2]|0)+(f[D+(ba-S<<2)>>2]|0);if((ga|0)<(U|0)){da=fa;K=ha;ca=ja;ba=ga}else{ka=fa;la=ha;ma=ja;na=ga;break}}}else{ka=M;la=N;ma=M;na=o}if(Q){ba=E+(na<<2)|0;ca=f[ba>>2]|0;f[E+(na-o<<2)>>2]=ca+ka;da=b[H+na>>0]|0;ga=da&255;f[J+(na<<2)>>2]=ga+ma+(f[J+(na-s<<2)>>2]|0);K=+(da&255);if(I)n[L+(na<<2)>>2]=la+K*K+ +n[L+(na-t<<2)>>2];f[D+(na<<2)>>2]=ga+ca+(f[D+(na-S<<2)>>2]|0);f[ba>>2]=ga}L=I?L+4|0:0;F=F+1|0;if((F|0)==(o|0))break;else{E=E+4|0;D=D+4|0;J=J+4|0;H=H+1|0}}oa=i;pa=W+(e<<2)|0;qa=Z+c|0;ra=C;sa=L}else{oa=l;pa=V;qa=_;ra=R;sa=j}X=X+1|0;if((X|0)==(m|0))break;else{i=oa;W=pa;P=ra;$=sa;Z=qa}}}if((O|0)!=(g|0)){ZDc(O);f[r>>2]=g;f[z>>2]=264}u=p;return}function Zpa(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;n=u;u=u+1072|0;o=0-m|0;p=n;q=d>>>2;d=j>>>2;j=0-d|0;r=g>>>2;g=Y(m,k)|0;k=g+m|0;s=k<<2;XIc(c|0,0,s|0)|0;t=c+(q+m<<2)|0;if(!e)v=0;else{XIc(e|0,0,s|0)|0;v=e+(r+m<<2)|0}if(!i)w=0;else{XIc(i|0,0,s|0)|0;w=i+(d+m<<2)|0}i=(w|0)==0;if((v|0)==0&i){if((l|0)<=0){u=n;return}s=(g|0)>0;e=b-m|0;x=q-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;z=m<<2;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){f[E+(o<<2)>>2]=0;G=0;H=0;do{G=(h[F+H>>0]|0)+G|0;f[E+(H<<2)>>2]=G+(f[E+(H-q<<2)>>2]|0);H=H+m|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(m|0))break;else{E=E+4|0;F=F+1|0}}}else XIc(A+(o<<2)|0,0,z|0)|0;B=B+1|0;if((B|0)==(l|0))break;else{A=A+(y<<2)+4+(x<<2)|0;C=C+y+1+e|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(g|0)>0;e=b-m|0;y=q-m|0;C=r-m|0;if((m|0)<=0){u=n;return}x=m+-1|0;A=v;B=0;z=t;s=a;while(1){if(i){F=0;E=A;D=z;H=s;while(1){f[D+(o<<2)>>2]=0;f[E+(o<<2)>>2]=0;G=0;I=0;J=0;do{K=h[H+J>>0]|0;I=K+I|0;G=(Y(K,K)|0)+G|0;K=G+(f[E+(J-r<<2)>>2]|0)|0;f[D+(J<<2)>>2]=I+(f[D+(J-q<<2)>>2]|0);f[E+(J<<2)>>2]=K;J=J+m|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(m|0))break;else{E=E+4|0;D=D+4|0;H=H+1|0}}}else{H=0;D=A;E=z;while(1){f[E+(o<<2)>>2]=0;f[D+(o<<2)>>2]=0;H=H+1|0;if((H|0)==(m|0))break;else{D=D+4|0;E=E+4|0}}}B=B+1|0;if((B|0)==(l|0))break;else{A=A+(x<<2)+4+(C<<2)|0;z=z+(x<<2)+4+(y<<2)|0;s=s+x+1+e|0}}u=n;return}e=p+8|0;f[p>>2]=e;x=p+4|0;f[x>>2]=k;if(k>>>0>264){s=XDc(k>>>0>1073741823?-1:k<<2)|0;f[p>>2]=s;L=s}else L=e;s=(m|0)>0;do if(s){k=(g|0)==(m|0);y=q+(m<<1)|0;z=w+(m<<2)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;i=v;E=t;while(1){f[A+(o<<2)>>2]=0;f[E+(o<<2)>>2]=0;if(k)f[C+(m<<2)>>2]=0;if(!i)S=0;else{f[i+(o<<2)>>2]=0;S=i+4|0}B=B+1|0;if((B|0)==(m|0))break;else{C=C+4|0;A=A+4|0;i=S;E=E+4|0}}T=L+(m<<2)|0;U=z;V=S;W=a+m|0;X=c+(y<<2)|0;break}while(1){f[N+(o<<2)>>2]=0;f[Q+(o<<2)>>2]=0;E=(P|0)!=0;if(E){i=0;A=0;C=0;do{B=h[R+C>>0]|0;f[N+(C<<2)>>2]=B;f[M+(C<<2)>>2]=B;A=B+A|0;i=(Y(B,B)|0)+i|0;f[Q+(C<<2)>>2]=A;f[P+(C<<2)>>2]=i;C=C+m|0}while((C|0)<(g|0))}else{C=0;i=0;do{A=h[R+i>>0]|0;f[N+(i<<2)>>2]=A;f[M+(i<<2)>>2]=A;C=A+C|0;f[Q+(i<<2)>>2]=C;i=i+m|0}while((i|0)<(g|0))}if(k)f[M+(m<<2)>>2]=0;if(E){f[P+(o<<2)>>2]=0;Z=P+4|0}else Z=0;O=O+1|0;if((O|0)==(m|0))break;else{M=M+4|0;N=N+4|0;P=Z;Q=Q+4|0;R=R+1|0}}T=L+(m<<2)|0;U=z;V=Z;W=a+m|0;X=c+(y<<2)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((l|0)>1){t=b-m|0;a=q-m|0;v=d-m|0;w=r-m|0;c=0-q|0;Z=0-r|0;R=g-m|0;Q=(R|0)>(m|0);P=d+m|0;N=(g|0)>(m|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+t|0;O=M+(a<<2)|0;S=T+(v<<2)|0;k=g+(o<<2)|0;i=(X|0)==0?0:X+(w<<2)|0;if(s){C=M+(q<<2)|0;A=k;B=S;D=0;H=O;F=W;J=i;while(1){I=h[F>>0]|0;G=Y(I,I)|0;f[H+(o<<2)>>2]=0;K=(J|0)!=0;if(K)f[J+(o<<2)>>2]=0;_=B+(j<<2)|0;f[B+(o<<2)>>2]=f[_>>2];f[H>>2]=(f[H+(c<<2)>>2]|0)+I;if(K)f[J>>2]=(f[J+(Z<<2)>>2]|0)+G;f[B>>2]=(f[_>>2]|0)+I+(f[A+(m<<2)>>2]|0);if(Q)if(K){_=I;$=G;aa=I;ba=m;while(1){ca=f[A+(ba<<2)>>2]|0;f[A+(ba-m<<2)>>2]=ca+_;da=h[F+ba>>0]|0;ea=da+aa|0;fa=(Y(da,da)|0)+$|0;f[H+(ba<<2)>>2]=ea+(f[H+(ba-q<<2)>>2]|0);f[J+(ba<<2)>>2]=(f[J+(ba-r<<2)>>2]|0)+fa;ga=ba+m|0;f[B+(ba<<2)>>2]=da+ca+(f[A+(ga<<2)>>2]|0)+(f[B+(ba-P<<2)>>2]|0);if((ga|0)<(R|0)){_=da;$=fa;aa=ea;ba=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;$=I;_=m;while(1){E=f[A+(_<<2)>>2]|0;f[A+(_-m<<2)>>2]=E+ba;ga=h[F+_>>0]|0;ea=ga+$|0;fa=(Y(ga,ga)|0)+aa|0;f[H+(_<<2)>>2]=ea+(f[H+(_-q<<2)>>2]|0);da=_+m|0;f[B+(_<<2)>>2]=ga+E+(f[A+(da<<2)>>2]|0)+(f[B+(_-P<<2)>>2]|0);if((da|0)<(R|0)){ba=ga;aa=fa;$=ea;_=da}else{ha=ga;ia=fa;ja=ea;ka=da;break}}}else{ha=I;ia=G;ja=I;ka=m}if(N){_=A+(ka<<2)|0;$=f[_>>2]|0;f[A+(ka-m<<2)>>2]=$+ha;aa=h[F+ka>>0]|0;f[H+(ka<<2)>>2]=aa+ja+(f[H+(ka-q<<2)>>2]|0);if(K){ba=(Y(aa,aa)|0)+ia|0;f[J+(ka<<2)>>2]=ba+(f[J+(ka-r<<2)>>2]|0)}f[B+(ka<<2)>>2]=aa+$+(f[B+(ka-P<<2)>>2]|0);f[_>>2]=aa}J=K?J+4|0:0;D=D+1|0;if((D|0)==(m|0))break;else{A=A+4|0;B=B+4|0;H=H+4|0;F=F+1|0}}la=g;ma=T+(d<<2)|0;na=V+b|0;oa=C;pa=J}else{la=k;ma=S;na=W;oa=O;pa=i}U=U+1|0;if((U|0)==(l|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){ZDc(L);f[p>>2]=e;f[x>>2]=264}u=n;return}function _pa(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;q=u;u=u+1072|0;r=0-o|0;s=q;t=e>>>2;e=k>>>2;k=0-e|0;v=i>>>3;i=Y(o,l)|0;l=i+o|0;w=l<<2;XIc(d|0,0,w|0)|0;x=d+(t+o<<2)|0;if(!g)y=0;else{XIc(g|0,0,l<<3|0)|0;y=g+(v+o<<3)|0}if(!j)z=0;else{XIc(j|0,0,w|0)|0;z=j+(e+o<<2)|0}j=(z|0)==0;if((y|0)==0&j){if((m|0)<=0){u=q;return}w=(i|0)>0;g=c-o|0;A=t-o|0;if((o|0)<=0){u=q;return}B=o+-1|0;C=o<<2;D=x;E=0;F=a;while(1){if(w){G=0;H=D;I=F;while(1){n[H+(r<<2)>>2]=0.0;J=0.0;K=0;do{J=J+ +(h[I+K>>0]|0);n[H+(K<<2)>>2]=+n[H+(K-t<<2)>>2]+J;K=K+o|0}while((K|0)<(i|0));G=G+1|0;if((G|0)==(o|0))break;else{H=H+4|0;I=I+1|0}}}else XIc(D+(r<<2)|0,0,C|0)|0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+(B<<2)+4+(A<<2)|0;F=F+B+1+g|0}}u=q;return}if(j){if((m|0)<=0){u=q;return}j=(i|0)>0;g=c-o|0;B=t-o|0;F=v-o|0;if((o|0)<=0){u=q;return}A=o+-1|0;D=y;E=0;C=x;w=a;while(1){if(j){I=0;H=D;G=C;K=w;while(1){n[G+(r<<2)>>2]=0.0;p[H+(r<<3)>>3]=0.0;J=0.0;L=0.0;M=0;do{N=b[K+M>>0]|0;L=L+ +(N&255);O=+(N&255);J=J+O*O;O=+p[H+(M-v<<3)>>3]+J;n[G+(M<<2)>>2]=+n[G+(M-t<<2)>>2]+L;p[H+(M<<3)>>3]=O;M=M+o|0}while((M|0)<(i|0));I=I+1|0;if((I|0)==(o|0))break;else{H=H+8|0;G=G+4|0;K=K+1|0}}}else{K=0;G=D;H=C;while(1){n[H+(r<<2)>>2]=0.0;p[G+(r<<3)>>3]=0.0;K=K+1|0;if((K|0)==(o|0))break;else{G=G+8|0;H=H+4|0}}}E=E+1|0;if((E|0)==(m|0))break;else{D=D+(A<<3)+8+(F<<3)|0;C=C+(A<<2)+4+(B<<2)|0;w=w+A+1+g|0}}u=q;return}g=s+8|0;f[s>>2]=g;A=s+4|0;f[A>>2]=l;if(l>>>0>264){w=XDc(l>>>0>1073741823?-1:l<<2)|0;f[s>>2]=w;P=w}else P=g;w=(o|0)>0;do if(w){l=(i|0)==(o|0);B=t+(o<<1)|0;C=z+(o<<2)|0;if((i|0)>0){Q=P;R=z;S=0;T=y;U=x;V=a}else{F=P;D=z;E=0;j=y;H=x;while(1){n[D+(r<<2)>>2]=0.0;n[H+(r<<2)>>2]=0.0;if(l)n[F+(o<<2)>>2]=0.0;if(!j)W=0;else{p[j+(r<<3)>>3]=0.0;W=j+8|0}E=E+1|0;if((E|0)==(o|0))break;else{F=F+4|0;D=D+4|0;j=W;H=H+4|0}}X=P+(o<<2)|0;Z=C;_=W;$=a+o|0;aa=d+(B<<2)|0;break}while(1){n[R+(r<<2)>>2]=0.0;n[U+(r<<2)>>2]=0.0;H=(T|0)!=0;if(H){L=0.0;J=0.0;j=0;do{D=b[V+j>>0]|0;O=+(D&255);n[R+(j<<2)>>2]=O;n[Q+(j<<2)>>2]=O;J=J+O;O=+(D&255);L=L+O*O;n[U+(j<<2)>>2]=J;p[T+(j<<3)>>3]=L;j=j+o|0}while((j|0)<(i|0))}else{L=0.0;j=0;do{J=+(h[V+j>>0]|0);n[R+(j<<2)>>2]=J;n[Q+(j<<2)>>2]=J;L=L+J;n[U+(j<<2)>>2]=L;j=j+o|0}while((j|0)<(i|0))}if(l)n[Q+(o<<2)>>2]=0.0;if(H){p[T+(r<<3)>>3]=0.0;ba=T+8|0}else ba=0;S=S+1|0;if((S|0)==(o|0))break;else{Q=Q+4|0;R=R+4|0;T=ba;U=U+4|0;V=V+1|0}}X=P+(o<<2)|0;Z=C;_=ba;$=a+o|0;aa=d+(B<<2)|0}else{X=P;Z=z;_=y;$=a;aa=x}while(0);if((m|0)>1){x=c-o|0;a=t-o|0;y=e-o|0;z=v-o|0;d=0-t|0;ba=0-v|0;V=i-o|0;U=(V|0)>(o|0);T=e+o|0;R=(i|0)>(o|0);i=X;X=Z;Z=1;Q=aa;aa=_;_=$;while(1){$=_+x|0;S=Q+(a<<2)|0;W=X+(y<<2)|0;l=i+(r<<2)|0;j=(aa|0)==0?0:aa+(z<<3)|0;if(w){D=Q+(t<<2)|0;F=l;E=W;G=0;K=S;I=$;M=j;while(1){N=b[I>>0]|0;L=+(N&255);J=+(N&255);O=J*J;n[K+(r<<2)>>2]=0.0;N=(M|0)!=0;if(N)p[M+(r<<3)>>3]=0.0;ca=E+(k<<2)|0;f[E+(r<<2)>>2]=f[ca>>2];n[K>>2]=L+ +n[K+(d<<2)>>2];if(N)p[M>>3]=O+ +p[M+(ba<<3)>>3];n[E>>2]=L+ +n[ca>>2]+ +n[F+(o<<2)>>2];if(U)if(N){J=L;da=O;ea=L;ca=o;while(1){fa=+n[F+(ca<<2)>>2];n[F+(ca-o<<2)>>2]=J+fa;ga=b[I+ca>>0]|0;ha=+(ga&255);ia=+(ga&255);ja=ea+ha;ka=da+ia*ia;n[K+(ca<<2)>>2]=+n[K+(ca-t<<2)>>2]+ja;p[M+(ca<<3)>>3]=ka+ +p[M+(ca-v<<3)>>3];ga=ca+o|0;n[E+(ca<<2)>>2]=fa+(ha+ +n[F+(ga<<2)>>2]+ +n[E+(ca-T<<2)>>2]);if((ga|0)<(V|0)){J=ha;da=ka;ea=ja;ca=ga}else{la=ha;ma=ka;na=ja;oa=ga;break}}}else{ea=L;da=O;J=L;ca=o;while(1){ja=+n[F+(ca<<2)>>2];n[F+(ca-o<<2)>>2]=ea+ja;H=b[I+ca>>0]|0;ka=+(H&255);ha=+(H&255);fa=J+ka;ia=da+ha*ha;n[K+(ca<<2)>>2]=+n[K+(ca-t<<2)>>2]+fa;H=ca+o|0;n[E+(ca<<2)>>2]=ja+(ka+ +n[F+(H<<2)>>2]+ +n[E+(ca-T<<2)>>2]);if((H|0)<(V|0)){ea=ka;da=ia;J=fa;ca=H}else{la=ka;ma=ia;na=fa;oa=H;break}}}else{la=L;ma=O;na=L;oa=o}if(R){ca=F+(oa<<2)|0;J=+n[ca>>2];n[F+(oa-o<<2)>>2]=la+J;H=b[I+oa>>0]|0;da=+(H&255);n[K+(oa<<2)>>2]=+n[K+(oa-t<<2)>>2]+(na+da);ea=+(H&255);if(N)p[M+(oa<<3)>>3]=ma+ea*ea+ +p[M+(oa-v<<3)>>3];n[E+(oa<<2)>>2]=J+da+ +n[E+(oa-T<<2)>>2];n[ca>>2]=da}M=N?M+8|0:0;G=G+1|0;if((G|0)==(o|0))break;else{F=F+4|0;E=E+4|0;K=K+4|0;I=I+1|0}}pa=i;qa=X+(e<<2)|0;ra=_+c|0;sa=D;ta=M}else{pa=l;qa=W;ra=$;sa=S;ta=j}Z=Z+1|0;if((Z|0)==(m|0))break;else{i=pa;X=qa;Q=sa;aa=ta;_=ra}}}if((P|0)!=(g|0)){ZDc(P);f[s>>2]=g;f[A>>2]=264}u=q;return}function $pa(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;o=u;u=u+1072|0;p=0-m|0;q=o;r=d>>>2;d=j>>>2;j=0-d|0;s=g>>>2;g=Y(m,k)|0;k=g+m|0;t=k<<2;XIc(c|0,0,t|0)|0;v=c+(r+m<<2)|0;if(!e)w=0;else{XIc(e|0,0,t|0)|0;w=e+(s+m<<2)|0}if(!i)x=0;else{XIc(i|0,0,t|0)|0;x=i+(d+m<<2)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=o;return}t=(g|0)>0;e=b-m|0;y=r-m|0;if((m|0)<=0){u=o;return}z=m+-1|0;A=m<<2;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){n[F+(p<<2)>>2]=0.0;H=0.0;I=0;do{H=H+ +(h[G+I>>0]|0);n[F+(I<<2)>>2]=+n[F+(I-r<<2)>>2]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+4|0;G=G+1|0}}}else XIc(B+(p<<2)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<2)+4+(y<<2)|0;D=D+z+1+e|0}}u=o;return}if(i){if((l|0)<=0){u=o;return}i=(g|0)>0;e=b-m|0;z=r-m|0;D=s-m|0;if((m|0)<=0){u=o;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){n[E+(p<<2)>>2]=0.0;n[F+(p<<2)>>2]=0.0;H=0.0;J=0.0;K=0;do{L=+(h[I+K>>0]|0);J=J+L;H=H+L*L;L=+n[F+(K-s<<2)>>2]+H;n[E+(K<<2)>>2]=+n[E+(K-r<<2)>>2]+J;n[F+(K<<2)>>2]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+4|0;E=E+4|0;I=I+1|0}}}else{I=0;E=B;F=A;while(1){n[F+(p<<2)>>2]=0.0;n[E+(p<<2)>>2]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+4|0;F=F+4|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<2)+4+(D<<2)|0;A=A+(y<<2)+4+(z<<2)|0;t=t+y+1+e|0}}u=o;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>264){t=XDc(k>>>0>1073741823?-1:k<<2)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=r+(m<<1)|0;A=x+(m<<2)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){n[B+(p<<2)>>2]=0.0;n[F+(p<<2)>>2]=0.0;if(k)n[D+(m<<2)>>2]=0.0;if(!i)T=0;else{n[i+(p<<2)>>2]=0.0;T=i+4|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+4|0;B=B+4|0;i=T;F=F+4|0}}U=M+(m<<2)|0;V=A;W=T;X=a+m|0;Z=c+(z<<2)|0;break}while(1){n[O+(p<<2)>>2]=0.0;n[R+(p<<2)>>2]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(h[S+i>>0]|0);n[O+(i<<2)>>2]=L;n[N+(i<<2)>>2]=L;H=H+L;J=J+L*L;n[R+(i<<2)>>2]=H;n[Q+(i<<2)>>2]=J;i=i+m|0}while((i|0)<(g|0))}else{J=0.0;i=0;do{H=+(h[S+i>>0]|0);n[O+(i<<2)>>2]=H;n[N+(i<<2)>>2]=H;J=J+H;n[R+(i<<2)>>2]=J;i=i+m|0}while((i|0)<(g|0))}if(k)n[N+(m<<2)>>2]=0.0;if(F){n[Q+(p<<2)>>2]=0.0;_=Q+4|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+4|0;O=O+4|0;Q=_;R=R+4|0;S=S+1|0}}U=M+(m<<2)|0;V=A;W=_;X=a+m|0;Z=c+(z<<2)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=b-m|0;a=r-m|0;w=d-m|0;x=s-m|0;c=0-r|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+v|0;P=N+(a<<2)|0;T=U+(w<<2)|0;k=g+(p<<2)|0;i=(Z|0)==0?0:Z+(x<<2)|0;if(t){B=N+(r<<2)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(h[G>>0]|0);H=J*J;n[I+(p<<2)>>2]=0.0;$=(K|0)!=0;if($)n[K+(p<<2)>>2]=0.0;aa=C+(j<<2)|0;f[C+(p<<2)>>2]=f[aa>>2];n[I>>2]=J+ +n[I+(c<<2)>>2];if($)n[K>>2]=H+ +n[K+(_<<2)>>2];n[C>>2]=J+ +n[aa>>2]+ +n[D+(m<<2)>>2];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+n[D+(aa<<2)>>2];n[D+(aa-m<<2)>>2]=L+da;ea=+(h[G+aa>>0]|0);fa=ca+ea;ga=ba+ea*ea;n[I+(aa<<2)>>2]=+n[I+(aa-r<<2)>>2]+fa;n[K+(aa<<2)>>2]=ga+ +n[K+(aa-s<<2)>>2];ha=aa+m|0;n[C+(aa<<2)>>2]=da+(ea+ +n[D+(ha<<2)>>2]+ +n[C+(aa-Q<<2)>>2]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+n[D+(aa<<2)>>2];n[D+(aa-m<<2)>>2]=ca+fa;ga=+(h[G+aa>>0]|0);ea=L+ga;da=ba+ga*ga;n[I+(aa<<2)>>2]=+n[I+(aa-r<<2)>>2]+ea;F=aa+m|0;n[C+(aa<<2)>>2]=fa+(ga+ +n[D+(F<<2)>>2]+ +n[C+(aa-Q<<2)>>2]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<2)|0;L=+n[aa>>2];n[D+(la-m<<2)>>2]=ia+L;ba=+(h[G+la>>0]|0);n[I+(la<<2)>>2]=+n[I+(la-r<<2)>>2]+(ka+ba);if($)n[K+(la<<2)>>2]=ja+ba*ba+ +n[K+(la-s<<2)>>2];n[C+(la<<2)>>2]=L+ba+ +n[C+(la-Q<<2)>>2];n[aa>>2]=ba}K=$?K+4|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+4|0;C=C+4|0;I=I+4|0;G=G+1|0}}ma=g;na=U+(d<<2)|0;oa=W+b|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){ZDc(M);f[q>>2]=e;f[y>>2]=264}u=o;return}function aqa(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=d>>>3;d=j>>>3;j=0-d|0;s=g>>>3;g=Y(m,k)|0;k=g+m|0;t=k<<3;XIc(c|0,0,t|0)|0;v=c+(r+m<<3)|0;if(!e)w=0;else{XIc(e|0,0,t|0)|0;w=e+(s+m<<3)|0}if(!i)x=0;else{XIc(i|0,0,t|0)|0;x=i+(d+m<<3)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=n;return}t=(g|0)>0;e=b-m|0;y=r-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(h[G+I>>0]|0);p[F+(I<<3)>>3]=+p[F+(I-r<<3)>>3]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+1|0}}}else XIc(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+z+1+e|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(g|0)>0;e=b-m|0;z=r-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(h[I+K>>0]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-r<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+1|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+y+1+e|0}}u=n;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=XDc(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=r+(m<<1)|0;A=x+(m<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!i)T=0;else{p[i+(o<<3)>>3]=0.0;T=i+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;i=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+m|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(h[S+i>>0]|0);p[O+(i<<3)>>3]=L;p[N+(i<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(i<<3)>>3]=H;p[Q+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(g|0))}else{J=0.0;i=0;do{H=+(h[S+i>>0]|0);p[O+(i<<3)>>3]=H;p[N+(i<<3)>>3]=H;J=J+H;p[R+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(g|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+1|0}}U=M+(m<<3)|0;V=A;W=_;X=a+m|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=b-m|0;a=r-m|0;w=d-m|0;x=s-m|0;c=0-r|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+v|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=g+(o<<3)|0;i=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(r<<3)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(h[G>>0]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(j<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(h[G+aa>>0]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-r<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(h[G+aa>>0]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-r<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(h[G+la>>0]|0);p[I+(la<<3)>>3]=+p[I+(la-r<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+1|0}}ma=g;na=U+(d<<3)|0;oa=W+b|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){ZDc(M);f[q>>2]=e;f[y>>2]=136}u=n;return}function bqa(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=b>>>1;b=d>>>3;d=i>>>3;i=0-d|0;s=g>>>3;g=Y(m,k)|0;k=g+m|0;t=k<<3;XIc(c|0,0,t|0)|0;v=c+(b+m<<3)|0;if(!e)w=0;else{XIc(e|0,0,t|0)|0;w=e+(s+m<<3)|0}if(!h)x=0;else{XIc(h|0,0,t|0)|0;x=h+(d+m<<3)|0}h=(x|0)==0;if((w|0)==0&h){if((l|0)<=0){u=n;return}t=(g|0)>0;e=r-m|0;y=b-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(j[G+(I<<1)>>1]|0);p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+2|0}}}else XIc(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<1)+2+(e<<1)|0}}u=n;return}if(h){if((l|0)<=0){u=n;return}h=(g|0)>0;e=r-m|0;z=b-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(j[I+(K<<1)>>1]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+2|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<1)+2+(e<<1)|0}}u=n;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=XDc(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=b+(m<<1)|0;A=x+(m<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;h=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!h)T=0;else{p[h+(o<<3)>>3]=0.0;T=h+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;h=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+(m<<1)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;h=0;do{L=+(j[S+(h<<1)>>1]|0);p[O+(h<<3)>>3]=L;p[N+(h<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(h<<3)>>3]=H;p[Q+(h<<3)>>3]=J;h=h+m|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+(j[S+(h<<1)>>1]|0);p[O+(h<<3)>>3]=H;p[N+(h<<3)>>3]=H;J=J+H;p[R+(h<<3)>>3]=J;h=h+m|0}while((h|0)<(g|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+2|0}}U=M+(m<<3)|0;V=A;W=_;X=a+(m<<1)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=r-m|0;a=b-m|0;w=d-m|0;x=s-m|0;c=0-b|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<1)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=g+(o<<3)|0;h=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=k;C=T;E=0;I=P;G=X;K=h;while(1){J=+(j[G>>1]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(i<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(j[G+(aa<<1)>>1]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(j[G+(aa<<1)>>1]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(j[G+(la<<1)>>1]|0);p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+2|0}}ma=g;na=U+(d<<3)|0;oa=W+(r<<1)|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=h}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){ZDc(M);f[q>>2]=e;f[y>>2]=136}u=n;return}function cqa(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=b>>>1;b=e>>>3;e=j>>>3;j=0-e|0;s=h>>>3;h=Y(m,k)|0;k=h+m|0;t=k<<3;XIc(c|0,0,t|0)|0;v=c+(b+m<<3)|0;if(!g)w=0;else{XIc(g|0,0,t|0)|0;w=g+(s+m<<3)|0}if(!i)x=0;else{XIc(i|0,0,t|0)|0;x=i+(e+m<<3)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=n;return}t=(h|0)>0;g=r-m|0;y=b-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(d[G+(I<<1)>>1]|0);p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+m|0}while((I|0)<(h|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+2|0}}}else XIc(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<1)+2+(g<<1)|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(h|0)>0;g=r-m|0;z=b-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(d[I+(K<<1)>>1]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(h|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+2|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<1)+2+(g<<1)|0}}u=n;return}g=q+8|0;f[q>>2]=g;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=XDc(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=g;t=(m|0)>0;do if(t){k=(h|0)==(m|0);z=b+(m<<1)|0;A=x+(m<<3)|0;if((h|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!i)T=0;else{p[i+(o<<3)>>3]=0.0;T=i+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;i=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+(m<<1)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(d[S+(i<<1)>>1]|0);p[O+(i<<3)>>3]=L;p[N+(i<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(i<<3)>>3]=H;p[Q+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(h|0))}else{J=0.0;i=0;do{H=+(d[S+(i<<1)>>1]|0);p[O+(i<<3)>>3]=H;p[N+(i<<3)>>3]=H;J=J+H;p[R+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(h|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+2|0}}U=M+(m<<3)|0;V=A;W=_;X=a+(m<<1)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=r-m|0;a=b-m|0;w=e-m|0;x=s-m|0;c=0-b|0;_=0-s|0;S=h-m|0;R=(S|0)>(m|0);Q=e+m|0;O=(h|0)>(m|0);h=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<1)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=h+(o<<3)|0;i=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(d[G>>1]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(j<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(d[G+(aa<<1)>>1]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(d[G+(aa<<1)>>1]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(d[G+(la<<1)>>1]|0);p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+2|0}}ma=h;na=U+(e<<3)|0;oa=W+(r<<1)|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{h=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(g|0)){ZDc(M);f[q>>2]=g;f[y>>2]=136}u=n;return}function dqa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;m=u;u=u+1072|0;o=0-l|0;q=m;r=b>>>2;b=d>>>2;d=i>>>2;i=0-d|0;s=g>>>3;g=Y(l,j)|0;j=g+l|0;t=j<<2;XIc(c|0,0,t|0)|0;v=c+(b+l<<2)|0;if(!e)w=0;else{XIc(e|0,0,j<<3|0)|0;w=e+(s+l<<3)|0}if(!h)x=0;else{XIc(h|0,0,t|0)|0;x=h+(d+l<<2)|0}h=(x|0)==0;if((w|0)==0&h){if((k|0)<=0){u=m;return}t=(g|0)>0;e=r-l|0;y=b-l|0;if((l|0)<=0){u=m;return}z=l+-1|0;A=l<<2;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){n[F+(o<<2)>>2]=0.0;H=0.0;I=0;do{H=H+ +n[G+(I<<2)>>2];n[F+(I<<2)>>2]=+n[F+(I-b<<2)>>2]+H;I=I+l|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(l|0))break;else{F=F+4|0;G=G+4|0}}}else XIc(B+(o<<2)|0,0,A|0)|0;C=C+1|0;if((C|0)==(k|0))break;else{B=B+(z<<2)+4+(y<<2)|0;D=D+(z<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=r-l|0;z=b-l|0;D=s-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){n[E+(o<<2)>>2]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+n[I+(K<<2)>>2];J=J+L;M=L;H=H+M*M;M=+p[F+(K-s<<3)>>3]+H;n[E+(K<<2)>>2]=+n[E+(K-b<<2)>>2]+J;p[F+(K<<3)>>3]=M;K=K+l|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(l|0))break;else{F=F+8|0;E=E+4|0;I=I+4|0}}}else{I=0;E=B;F=A;while(1){n[F+(o<<2)>>2]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(l|0))break;else{E=E+8|0;F=F+4|0}}}C=C+1|0;if((C|0)==(k|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<2)+4+(z<<2)|0;t=t+(y<<2)+4+(e<<2)|0}}u=m;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=j;if(j>>>0>264){t=XDc(j>>>0>1073741823?-1:j<<2)|0;f[q>>2]=t;N=t}else N=e;t=(l|0)>0;do if(t){j=(g|0)==(l|0);z=b+(l<<1)|0;A=x+(l<<2)|0;if((g|0)>0){O=N;P=x;Q=0;R=w;S=v;T=a}else{D=N;B=x;C=0;h=w;F=v;while(1){n[B+(o<<2)>>2]=0.0;n[F+(o<<2)>>2]=0.0;if(j)n[D+(l<<2)>>2]=0.0;if(!h)U=0;else{p[h+(o<<3)>>3]=0.0;U=h+8|0}C=C+1|0;if((C|0)==(l|0))break;else{D=D+4|0;B=B+4|0;h=U;F=F+4|0}}V=N+(l<<2)|0;W=A;X=U;Z=a+(l<<2)|0;_=c+(z<<2)|0;break}while(1){n[P+(o<<2)>>2]=0.0;n[S+(o<<2)>>2]=0.0;F=(R|0)!=0;if(F){J=0.0;H=0.0;h=0;do{M=+n[T+(h<<2)>>2];n[P+(h<<2)>>2]=M;n[O+(h<<2)>>2]=M;H=H+M;L=M;J=J+L*L;n[S+(h<<2)>>2]=H;p[R+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+n[T+(h<<2)>>2];n[P+(h<<2)>>2]=H;n[O+(h<<2)>>2]=H;J=J+H;n[S+(h<<2)>>2]=J;h=h+l|0}while((h|0)<(g|0))}if(j)n[O+(l<<2)>>2]=0.0;if(F){p[R+(o<<3)>>3]=0.0;$=R+8|0}else $=0;Q=Q+1|0;if((Q|0)==(l|0))break;else{O=O+4|0;P=P+4|0;R=$;S=S+4|0;T=T+4|0}}V=N+(l<<2)|0;W=A;X=$;Z=a+(l<<2)|0;_=c+(z<<2)|0}else{V=N;W=x;X=w;Z=a;_=v}while(0);if((k|0)>1){v=r-l|0;a=b-l|0;w=d-l|0;x=s-l|0;c=0-b|0;$=0-s|0;T=g-l|0;S=(T|0)>(l|0);R=d+l|0;P=(g|0)>(l|0);g=V;V=W;W=1;O=_;_=X;X=Z;while(1){Z=X+(v<<2)|0;Q=O+(a<<2)|0;U=V+(w<<2)|0;j=g+(o<<2)|0;h=(_|0)==0?0:_+(x<<3)|0;if(t){B=O+(b<<2)|0;D=j;C=U;E=0;I=Q;G=Z;K=h;while(1){J=+n[G>>2];H=J;L=H*H;n[I+(o<<2)>>2]=0.0;aa=(K|0)!=0;if(aa)p[K+(o<<3)>>3]=0.0;ba=C+(i<<2)|0;f[C+(o<<2)>>2]=f[ba>>2];n[I>>2]=J+ +n[I+(c<<2)>>2];if(aa)p[K>>3]=L+ +p[K+($<<3)>>3];n[C>>2]=J+ +n[ba>>2]+ +n[D+(l<<2)>>2];if(S)if(aa){H=J;M=L;ca=J;ba=l;while(1){da=+n[D+(ba<<2)>>2];n[D+(ba-l<<2)>>2]=H+da;ea=+n[G+(ba<<2)>>2];fa=ea;ga=ca+ea;ha=M+fa*fa;n[I+(ba<<2)>>2]=+n[I+(ba-b<<2)>>2]+ga;p[K+(ba<<3)>>3]=ha+ +p[K+(ba-s<<3)>>3];ia=ba+l|0;n[C+(ba<<2)>>2]=da+(ea+ +n[D+(ia<<2)>>2]+ +n[C+(ba-R<<2)>>2]);if((ia|0)<(T|0)){H=ea;M=ha;ca=ga;ba=ia}else{ja=ea;ka=ha;la=ga;ma=ia;break}}}else{ca=J;M=L;H=J;ba=l;while(1){ga=+n[D+(ba<<2)>>2];n[D+(ba-l<<2)>>2]=ca+ga;ha=+n[G+(ba<<2)>>2];ea=ha;da=H+ha;fa=M+ea*ea;n[I+(ba<<2)>>2]=+n[I+(ba-b<<2)>>2]+da;F=ba+l|0;n[C+(ba<<2)>>2]=ga+(ha+ +n[D+(F<<2)>>2]+ +n[C+(ba-R<<2)>>2]);if((F|0)<(T|0)){ca=ha;M=fa;H=da;ba=F}else{ja=ha;ka=fa;la=da;ma=F;break}}}else{ja=J;ka=L;la=J;ma=l}if(P){ba=D+(ma<<2)|0;H=+n[ba>>2];n[D+(ma-l<<2)>>2]=ja+H;M=+n[G+(ma<<2)>>2];ca=M;n[I+(ma<<2)>>2]=+n[I+(ma-b<<2)>>2]+(la+M);if(aa)p[K+(ma<<3)>>3]=ka+ca*ca+ +p[K+(ma-s<<3)>>3];n[C+(ma<<2)>>2]=H+M+ +n[C+(ma-R<<2)>>2];n[ba>>2]=M}K=aa?K+8|0:0;E=E+1|0;if((E|0)==(l|0))break;else{D=D+4|0;C=C+4|0;I=I+4|0;G=G+4|0}}na=g;oa=V+(d<<2)|0;pa=X+(r<<2)|0;qa=B;ra=K}else{na=j;oa=U;pa=Z;qa=Q;ra=h}W=W+1|0;if((W|0)==(k|0))break;else{g=na;V=oa;O=qa;_=ra;X=pa}}}if((N|0)!=(e|0)){ZDc(N);f[q>>2]=e;f[y>>2]=264}u=m;return}function eqa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;m=u;u=u+1072|0;o=0-l|0;p=m;q=b>>>2;b=d>>>2;d=i>>>2;i=0-d|0;r=g>>>2;g=Y(l,j)|0;j=g+l|0;s=j<<2;XIc(c|0,0,s|0)|0;t=c+(b+l<<2)|0;if(!e)v=0;else{XIc(e|0,0,s|0)|0;v=e+(r+l<<2)|0}if(!h)w=0;else{XIc(h|0,0,s|0)|0;w=h+(d+l<<2)|0}h=(w|0)==0;if((v|0)==0&h){if((k|0)<=0){u=m;return}s=(g|0)>0;e=q-l|0;x=b-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;z=l<<2;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){n[E+(o<<2)>>2]=0.0;G=0.0;H=0;do{G=G+ +n[F+(H<<2)>>2];n[E+(H<<2)>>2]=+n[E+(H-b<<2)>>2]+G;H=H+l|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(l|0))break;else{E=E+4|0;F=F+4|0}}}else XIc(A+(o<<2)|0,0,z|0)|0;B=B+1|0;if((B|0)==(k|0))break;else{A=A+(y<<2)+4+(x<<2)|0;C=C+(y<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=q-l|0;y=b-l|0;C=r-l|0;if((l|0)<=0){u=m;return}x=l+-1|0;A=v;B=0;z=t;s=a;while(1){if(h){F=0;E=A;D=z;H=s;while(1){n[D+(o<<2)>>2]=0.0;n[E+(o<<2)>>2]=0.0;G=0.0;I=0.0;J=0;do{K=+n[H+(J<<2)>>2];I=I+K;G=G+K*K;K=+n[E+(J-r<<2)>>2]+G;n[D+(J<<2)>>2]=+n[D+(J-b<<2)>>2]+I;n[E+(J<<2)>>2]=K;J=J+l|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(l|0))break;else{E=E+4|0;D=D+4|0;H=H+4|0}}}else{H=0;D=A;E=z;while(1){n[E+(o<<2)>>2]=0.0;n[D+(o<<2)>>2]=0.0;H=H+1|0;if((H|0)==(l|0))break;else{D=D+4|0;E=E+4|0}}}B=B+1|0;if((B|0)==(k|0))break;else{A=A+(x<<2)+4+(C<<2)|0;z=z+(x<<2)+4+(y<<2)|0;s=s+(x<<2)+4+(e<<2)|0}}u=m;return}e=p+8|0;f[p>>2]=e;x=p+4|0;f[x>>2]=j;if(j>>>0>264){s=XDc(j>>>0>1073741823?-1:j<<2)|0;f[p>>2]=s;L=s}else L=e;s=(l|0)>0;do if(s){j=(g|0)==(l|0);y=b+(l<<1)|0;z=w+(l<<2)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;h=v;E=t;while(1){n[A+(o<<2)>>2]=0.0;n[E+(o<<2)>>2]=0.0;if(j)n[C+(l<<2)>>2]=0.0;if(!h)S=0;else{n[h+(o<<2)>>2]=0.0;S=h+4|0}B=B+1|0;if((B|0)==(l|0))break;else{C=C+4|0;A=A+4|0;h=S;E=E+4|0}}T=L+(l<<2)|0;U=z;V=S;W=a+(l<<2)|0;X=c+(y<<2)|0;break}while(1){n[N+(o<<2)>>2]=0.0;n[Q+(o<<2)>>2]=0.0;E=(P|0)!=0;if(E){I=0.0;G=0.0;h=0;do{K=+n[R+(h<<2)>>2];n[N+(h<<2)>>2]=K;n[M+(h<<2)>>2]=K;G=G+K;I=I+K*K;n[Q+(h<<2)>>2]=G;n[P+(h<<2)>>2]=I;h=h+l|0}while((h|0)<(g|0))}else{I=0.0;h=0;do{G=+n[R+(h<<2)>>2];n[N+(h<<2)>>2]=G;n[M+(h<<2)>>2]=G;I=I+G;n[Q+(h<<2)>>2]=I;h=h+l|0}while((h|0)<(g|0))}if(j)n[M+(l<<2)>>2]=0.0;if(E){n[P+(o<<2)>>2]=0.0;Z=P+4|0}else Z=0;O=O+1|0;if((O|0)==(l|0))break;else{M=M+4|0;N=N+4|0;P=Z;Q=Q+4|0;R=R+4|0}}T=L+(l<<2)|0;U=z;V=Z;W=a+(l<<2)|0;X=c+(y<<2)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((k|0)>1){t=q-l|0;a=b-l|0;v=d-l|0;w=r-l|0;c=0-b|0;Z=0-r|0;R=g-l|0;Q=(R|0)>(l|0);P=d+l|0;N=(g|0)>(l|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+(t<<2)|0;O=M+(a<<2)|0;S=T+(v<<2)|0;j=g+(o<<2)|0;h=(X|0)==0?0:X+(w<<2)|0;if(s){A=M+(b<<2)|0;C=j;B=S;D=0;H=O;F=W;J=h;while(1){I=+n[F>>2];G=I*I;n[H+(o<<2)>>2]=0.0;_=(J|0)!=0;if(_)n[J+(o<<2)>>2]=0.0;$=B+(i<<2)|0;f[B+(o<<2)>>2]=f[$>>2];n[H>>2]=I+ +n[H+(c<<2)>>2];if(_)n[J>>2]=G+ +n[J+(Z<<2)>>2];n[B>>2]=I+ +n[$>>2]+ +n[C+(l<<2)>>2];if(Q)if(_){K=I;aa=G;ba=I;$=l;while(1){ca=+n[C+($<<2)>>2];n[C+($-l<<2)>>2]=K+ca;da=+n[F+($<<2)>>2];ea=ba+da;fa=aa+da*da;n[H+($<<2)>>2]=+n[H+($-b<<2)>>2]+ea;n[J+($<<2)>>2]=fa+ +n[J+($-r<<2)>>2];ga=$+l|0;n[B+($<<2)>>2]=ca+(da+ +n[C+(ga<<2)>>2]+ +n[B+($-P<<2)>>2]);if((ga|0)<(R|0)){K=da;aa=fa;ba=ea;$=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;K=I;$=l;while(1){ea=+n[C+($<<2)>>2];n[C+($-l<<2)>>2]=ba+ea;fa=+n[F+($<<2)>>2];da=K+fa;ca=aa+fa*fa;n[H+($<<2)>>2]=+n[H+($-b<<2)>>2]+da;E=$+l|0;n[B+($<<2)>>2]=ea+(fa+ +n[C+(E<<2)>>2]+ +n[B+($-P<<2)>>2]);if((E|0)<(R|0)){ba=fa;aa=ca;K=da;$=E}else{ha=fa;ia=ca;ja=da;ka=E;break}}}else{ha=I;ia=G;ja=I;ka=l}if(N){$=C+(ka<<2)|0;K=+n[$>>2];n[C+(ka-l<<2)>>2]=ha+K;aa=+n[F+(ka<<2)>>2];n[H+(ka<<2)>>2]=+n[H+(ka-b<<2)>>2]+(ja+aa);if(_)n[J+(ka<<2)>>2]=ia+aa*aa+ +n[J+(ka-r<<2)>>2];n[B+(ka<<2)>>2]=K+aa+ +n[B+(ka-P<<2)>>2];n[$>>2]=aa}J=_?J+4|0:0;D=D+1|0;if((D|0)==(l|0))break;else{C=C+4|0;B=B+4|0;H=H+4|0;F=F+4|0}}la=g;ma=T+(d<<2)|0;na=V+(q<<2)|0;oa=A;pa=J}else{la=j;ma=S;na=W;oa=O;pa=h}U=U+1|0;if((U|0)==(k|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){ZDc(L);f[p>>2]=e;f[x>>2]=264}u=m;return}function fqa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;m=u;u=u+1104|0;o=0-l|0;q=m;r=b>>>2;b=d>>>3;d=i>>>3;i=0-d|0;s=g>>>3;g=Y(l,j)|0;j=g+l|0;t=j<<3;XIc(c|0,0,t|0)|0;v=c+(b+l<<3)|0;if(!e)w=0;else{XIc(e|0,0,t|0)|0;w=e+(s+l<<3)|0}if(!h)x=0;else{XIc(h|0,0,t|0)|0;x=h+(d+l<<3)|0}h=(x|0)==0;if((w|0)==0&h){if((k|0)<=0){u=m;return}t=(g|0)>0;e=r-l|0;y=b-l|0;if((l|0)<=0){u=m;return}z=l+-1|0;A=l<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +n[G+(I<<2)>>2];p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+l|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(l|0))break;else{F=F+8|0;G=G+4|0}}}else XIc(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(k|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=r-l|0;z=b-l|0;D=s-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+n[I+(K<<2)>>2];J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+l|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(l|0))break;else{F=F+8|0;E=E+8|0;I=I+4|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(l|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(k|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<2)+4+(e<<2)|0}}u=m;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=j;if(j>>>0>136){t=XDc(j>>>0>536870911?-1:j<<3)|0;f[q>>2]=t;M=t}else M=e;t=(l|0)>0;do if(t){j=(g|0)==(l|0);z=b+(l<<1)|0;A=x+(l<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;h=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(j)p[D+(l<<3)>>3]=0.0;if(!h)T=0;else{p[h+(o<<3)>>3]=0.0;T=h+8|0}C=C+1|0;if((C|0)==(l|0))break;else{D=D+8|0;B=B+8|0;h=T;F=F+8|0}}U=M+(l<<3)|0;V=A;W=T;X=a+(l<<2)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;h=0;do{L=+n[S+(h<<2)>>2];p[O+(h<<3)>>3]=L;p[N+(h<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(h<<3)>>3]=H;p[Q+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+n[S+(h<<2)>>2];p[O+(h<<3)>>3]=H;p[N+(h<<3)>>3]=H;J=J+H;p[R+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}if(j)p[N+(l<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(l|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+4|0}}U=M+(l<<3)|0;V=A;W=_;X=a+(l<<2)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((k|0)>1){v=r-l|0;a=b-l|0;w=d-l|0;x=s-l|0;c=0-b|0;_=0-s|0;S=g-l|0;R=(S|0)>(l|0);Q=d+l|0;O=(g|0)>(l|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<2)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;j=g+(o<<3)|0;h=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=j;C=T;E=0;I=P;G=X;K=h;while(1){J=+n[G>>2];H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(i<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(l<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=l;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-l<<3)>>3]=L+da;ea=+n[G+(aa<<2)>>2];fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+l|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=l;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-l<<3)>>3]=ca+fa;ga=+n[G+(aa<<2)>>2];ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+l|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=l}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-l<<3)>>3]=ia+L;ba=+n[G+(la<<2)>>2];p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(l|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+4|0}}ma=g;na=U+(d<<3)|0;oa=W+(r<<2)|0;pa=B;qa=K}else{ma=j;na=T;oa=X;pa=P;qa=h}V=V+1|0;if((V|0)==(k|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){ZDc(M);f[q>>2]=e;f[y>>2]=136}u=m;return}function gqa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;m=u;u=u+1104|0;n=0-l|0;o=m;q=b>>>3;b=d>>>3;d=i>>>3;i=0-d|0;r=g>>>3;g=Y(l,j)|0;j=g+l|0;s=j<<3;XIc(c|0,0,s|0)|0;t=c+(b+l<<3)|0;if(!e)v=0;else{XIc(e|0,0,s|0)|0;v=e+(r+l<<3)|0}if(!h)w=0;else{XIc(h|0,0,s|0)|0;w=h+(d+l<<3)|0}h=(w|0)==0;if((v|0)==0&h){if((k|0)<=0){u=m;return}s=(g|0)>0;e=q-l|0;x=b-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;z=l<<3;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){p[E+(n<<3)>>3]=0.0;G=0.0;H=0;do{G=G+ +p[F+(H<<3)>>3];p[E+(H<<3)>>3]=+p[E+(H-b<<3)>>3]+G;H=H+l|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(l|0))break;else{E=E+8|0;F=F+8|0}}}else XIc(A+(n<<3)|0,0,z|0)|0;B=B+1|0;if((B|0)==(k|0))break;else{A=A+(y<<3)+8+(x<<3)|0;C=C+(y<<3)+8+(e<<3)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=q-l|0;y=b-l|0;C=r-l|0;if((l|0)<=0){u=m;return}x=l+-1|0;A=v;B=0;z=t;s=a;while(1){if(h){F=0;E=A;D=z;H=s;while(1){p[D+(n<<3)>>3]=0.0;p[E+(n<<3)>>3]=0.0;G=0.0;I=0.0;J=0;do{K=+p[H+(J<<3)>>3];I=I+K;G=G+K*K;K=+p[E+(J-r<<3)>>3]+G;p[D+(J<<3)>>3]=+p[D+(J-b<<3)>>3]+I;p[E+(J<<3)>>3]=K;J=J+l|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(l|0))break;else{E=E+8|0;D=D+8|0;H=H+8|0}}}else{H=0;D=A;E=z;while(1){p[E+(n<<3)>>3]=0.0;p[D+(n<<3)>>3]=0.0;H=H+1|0;if((H|0)==(l|0))break;else{D=D+8|0;E=E+8|0}}}B=B+1|0;if((B|0)==(k|0))break;else{A=A+(x<<3)+8+(C<<3)|0;z=z+(x<<3)+8+(y<<3)|0;s=s+(x<<3)+8+(e<<3)|0}}u=m;return}e=o+8|0;f[o>>2]=e;x=o+4|0;f[x>>2]=j;if(j>>>0>136){s=XDc(j>>>0>536870911?-1:j<<3)|0;f[o>>2]=s;L=s}else L=e;s=(l|0)>0;do if(s){j=(g|0)==(l|0);y=b+(l<<1)|0;z=w+(l<<3)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;h=v;E=t;while(1){p[A+(n<<3)>>3]=0.0;p[E+(n<<3)>>3]=0.0;if(j)p[C+(l<<3)>>3]=0.0;if(!h)S=0;else{p[h+(n<<3)>>3]=0.0;S=h+8|0}B=B+1|0;if((B|0)==(l|0))break;else{C=C+8|0;A=A+8|0;h=S;E=E+8|0}}T=L+(l<<3)|0;U=z;V=S;W=a+(l<<3)|0;X=c+(y<<3)|0;break}while(1){p[N+(n<<3)>>3]=0.0;p[Q+(n<<3)>>3]=0.0;E=(P|0)!=0;if(E){I=0.0;G=0.0;h=0;do{K=+p[R+(h<<3)>>3];p[N+(h<<3)>>3]=K;p[M+(h<<3)>>3]=K;G=G+K;I=I+K*K;p[Q+(h<<3)>>3]=G;p[P+(h<<3)>>3]=I;h=h+l|0}while((h|0)<(g|0))}else{I=0.0;h=0;do{G=+p[R+(h<<3)>>3];p[N+(h<<3)>>3]=G;p[M+(h<<3)>>3]=G;I=I+G;p[Q+(h<<3)>>3]=I;h=h+l|0}while((h|0)<(g|0))}if(j)p[M+(l<<3)>>3]=0.0;if(E){p[P+(n<<3)>>3]=0.0;Z=P+8|0}else Z=0;O=O+1|0;if((O|0)==(l|0))break;else{M=M+8|0;N=N+8|0;P=Z;Q=Q+8|0;R=R+8|0}}T=L+(l<<3)|0;U=z;V=Z;W=a+(l<<3)|0;X=c+(y<<3)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((k|0)>1){t=q-l|0;a=b-l|0;v=d-l|0;w=r-l|0;c=0-b|0;Z=0-r|0;R=g-l|0;Q=(R|0)>(l|0);P=d+l|0;N=(g|0)>(l|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+(t<<3)|0;O=M+(a<<3)|0;S=T+(v<<3)|0;j=g+(n<<3)|0;h=(X|0)==0?0:X+(w<<3)|0;if(s){A=M+(b<<3)|0;C=j;B=S;D=0;H=O;F=W;J=h;while(1){I=+p[F>>3];G=I*I;p[H+(n<<3)>>3]=0.0;_=(J|0)!=0;if(_)p[J+(n<<3)>>3]=0.0;$=B+(i<<3)|0;p[B+(n<<3)>>3]=+p[$>>3];p[H>>3]=I+ +p[H+(c<<3)>>3];if(_)p[J>>3]=G+ +p[J+(Z<<3)>>3];p[B>>3]=I+ +p[$>>3]+ +p[C+(l<<3)>>3];if(Q)if(_){K=I;aa=G;ba=I;$=l;while(1){ca=+p[C+($<<3)>>3];p[C+($-l<<3)>>3]=K+ca;da=+p[F+($<<3)>>3];ea=ba+da;fa=aa+da*da;p[H+($<<3)>>3]=+p[H+($-b<<3)>>3]+ea;p[J+($<<3)>>3]=fa+ +p[J+($-r<<3)>>3];ga=$+l|0;p[B+($<<3)>>3]=ca+(da+ +p[C+(ga<<3)>>3]+ +p[B+($-P<<3)>>3]);if((ga|0)<(R|0)){K=da;aa=fa;ba=ea;$=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;K=I;$=l;while(1){ea=+p[C+($<<3)>>3];p[C+($-l<<3)>>3]=ba+ea;fa=+p[F+($<<3)>>3];da=K+fa;ca=aa+fa*fa;p[H+($<<3)>>3]=+p[H+($-b<<3)>>3]+da;E=$+l|0;p[B+($<<3)>>3]=ea+(fa+ +p[C+(E<<3)>>3]+ +p[B+($-P<<3)>>3]);if((E|0)<(R|0)){ba=fa;aa=ca;K=da;$=E}else{ha=fa;ia=ca;ja=da;ka=E;break}}}else{ha=I;ia=G;ja=I;ka=l}if(N){$=C+(ka<<3)|0;K=+p[$>>3];p[C+(ka-l<<3)>>3]=ha+K;aa=+p[F+(ka<<3)>>3];p[H+(ka<<3)>>3]=+p[H+(ka-b<<3)>>3]+(ja+aa);if(_)p[J+(ka<<3)>>3]=ia+aa*aa+ +p[J+(ka-r<<3)>>3];p[B+(ka<<3)>>3]=K+aa+ +p[B+(ka-P<<3)>>3];p[$>>3]=aa}J=_?J+8|0:0;D=D+1|0;if((D|0)==(l|0))break;else{C=C+8|0;B=B+8|0;H=H+8|0;F=F+8|0}}la=g;ma=T+(d<<3)|0;na=V+(q<<3)|0;oa=A;pa=J}else{la=j;ma=S;na=W;oa=O;pa=h}U=U+1|0;if((U|0)==(k|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){ZDc(L);f[o>>2]=e;f[x>>2]=136}u=m;return}function hqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,273925,d);return}function iqa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;h=u;u=u+320|0;i=h+304|0;j=h+240|0;k=h+248|0;l=h+184|0;m=h+128|0;n=h+72|0;o=h+8|0;p=h+16|0;q=h;r=c$(a,-1)|0;s=r&7;t=r>>>3&511;r=t+1|0;v=((e|0)<1?((s|0)==0?4:6):e)&7;e=(g|0)<1?6:g&7;b$(i,a,-1);g=(f[i>>2]|0)+1|0;w=(f[i+4>>2]|0)+1|0;f[j>>2]=g;f[j+4>>2]=w;i=t<<3;t=v|i;v$(b,j,t,-1,0,0);do if((d$(a)|0)==65536){j=f[a+4>>2]|0;f[k>>2]=f[j>>2];x=k+4|0;y=j+4|0;f[x>>2]=f[y>>2];z=k+8|0;f[z>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];A=f[j+36>>2]|0;f[k+36>>2]=A;f[k+40>>2]=z;z=k+48|0;B=k+44|0;f[B>>2]=z;f[z>>2]=0;f[k+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[j+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(k,j);break}}else a$(k,a,-1);while(0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[l>>2]=f[a>>2];j=l+4|0;x=a+4|0;f[j>>2]=f[x>>2];y=l+8|0;f[y>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];z=f[a+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=y;y=l+48|0;B=l+44|0;f[B>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[a+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[j>>2]=0;ZS(l,a);break}}else a$(l,b,-1);while(0);f[m>>2]=1124007936;b=m+4|0;a=m+8|0;j=m+40|0;x=b;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[j>>2]=a;B=m+48|0;z=m+44|0;f[z>>2]=B;f[B>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;A=n+4|0;C=n+8|0;D=n+40|0;x=A;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[D>>2]=C;x=n+48|0;y=n+44|0;f[y>>2]=x;f[x>>2]=0;f[n+52>>2]=0;if($$(c)|0){f[o>>2]=g;f[o+4>>2]=w;v$(c,o,i|e,-1,0,0);do if((d$(c)|0)==65536){i=f[c+4>>2]|0;f[p>>2]=f[i>>2];o=p+4|0;E=i+4|0;f[o>>2]=f[E>>2];F=p+8|0;f[F>>2]=f[i+8>>2];f[p+12>>2]=f[i+12>>2];f[p+16>>2]=f[i+16>>2];f[p+20>>2]=f[i+20>>2];f[p+24>>2]=f[i+24>>2];f[p+28>>2]=f[i+28>>2];f[p+32>>2]=f[i+32>>2];G=p+36|0;H=f[i+36>>2]|0;f[G>>2]=H;f[p+40>>2]=F;F=p+48|0;I=p+44|0;f[I>>2]=F;f[F>>2]=0;f[p+52>>2]=0;if(H|0){F=H+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[i+44>>2]|0;F=f[I>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];J=G;break}else{f[o>>2]=0;ZS(p,i);J=G;break}}else{a$(p,c,-1);J=p+36|0}while(0);c=f[J>>2]|0;if(c|0){G=c+12|0;f[G>>2]=(f[G>>2]|0)+1}G=m+36|0;c=f[G>>2]|0;if(c|0?(i=c+12|0,c=f[i>>2]|0,f[i>>2]=c+-1,(c|0)==1):0)_S(m);f[G>>2]=0;c=m+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){i=f[j>>2]|0;o=0;do{f[i+(o<<2)>>2]=0;o=o+1|0;K=f[b>>2]|0}while((o|0)<(K|0));f[m>>2]=f[p>>2];if((K|0)<3)L=33;else L=35}else{f[m>>2]=f[p>>2];L=33}if((L|0)==33){K=f[p+4>>2]|0;if((K|0)<3){f[b>>2]=K;f[a>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];a=f[p+44>>2]|0;K=f[z>>2]|0;f[K>>2]=f[a>>2];f[K+4>>2]=f[a+4>>2]}else L=35}if((L|0)==35)ZS(m,p);a=p+16|0;f[c>>2]=f[a>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];c=f[J>>2]|0;f[G>>2]=c;if(c|0?(G=c+12|0,c=f[G>>2]|0,f[G>>2]=c+-1,(c|0)==1):0)_S(p);f[J>>2]=0;J=p+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[J>>2]|0)>0){a=f[p+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[J>>2]|0))}J=f[p+44>>2]|0;if((J|0)!=(p+48|0))g0(J)}if($$(d)|0){f[q>>2]=g;f[q+4>>2]=w;v$(d,q,t,-1,0,0);do if((d$(d)|0)==65536){t=f[d+4>>2]|0;f[p>>2]=f[t>>2];q=p+4|0;w=t+4|0;f[q>>2]=f[w>>2];g=p+8|0;f[g>>2]=f[t+8>>2];f[p+12>>2]=f[t+12>>2];f[p+16>>2]=f[t+16>>2];f[p+20>>2]=f[t+20>>2];f[p+24>>2]=f[t+24>>2];f[p+28>>2]=f[t+28>>2];f[p+32>>2]=f[t+32>>2];J=p+36|0;c=f[t+36>>2]|0;f[J>>2]=c;f[p+40>>2]=g;g=p+48|0;a=p+44|0;f[a>>2]=g;f[g>>2]=0;f[p+52>>2]=0;if(c|0){g=c+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;g=f[a>>2]|0;f[g>>2]=f[w>>2];f[g+4>>2]=f[w+4>>2];M=J;break}else{f[q>>2]=0;ZS(p,t);M=J;break}}else{a$(p,d,-1);M=p+36|0}while(0);d=f[M>>2]|0;if(d|0){J=d+12|0;f[J>>2]=(f[J>>2]|0)+1}J=n+36|0;d=f[J>>2]|0;if(d|0?(t=d+12|0,d=f[t>>2]|0,f[t>>2]=d+-1,(d|0)==1):0)_S(n);f[J>>2]=0;d=n+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[A>>2]|0)>0){t=f[D>>2]|0;q=0;do{f[t+(q<<2)>>2]=0;q=q+1|0;N=f[A>>2]|0}while((q|0)<(N|0));f[n>>2]=f[p>>2];if((N|0)<3)L=64;else L=66}else{f[n>>2]=f[p>>2];L=64}if((L|0)==64){N=f[p+4>>2]|0;if((N|0)<3){f[A>>2]=N;f[C>>2]=f[p+8>>2];f[n+12>>2]=f[p+12>>2];C=f[p+44>>2]|0;N=f[y>>2]|0;f[N>>2]=f[C>>2];f[N+4>>2]=f[C+4>>2]}else L=66}if((L|0)==66)ZS(n,p);L=p+16|0;f[d>>2]=f[L>>2];f[n+20>>2]=f[p+20>>2];f[n+24>>2]=f[p+24>>2];f[n+28>>2]=f[p+28>>2];f[n+32>>2]=f[p+32>>2];C=f[M>>2]|0;f[J>>2]=C;if(C|0?(J=C+12|0,C=f[J>>2]|0,f[J>>2]=C+-1,(C|0)==1):0)_S(p);f[M>>2]=0;M=p+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){L=f[p+40>>2]|0;C=0;do{f[L+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[M>>2]|0))}M=f[p+44>>2]|0;if((M|0)!=(p+48|0))g0(M);O=d}else O=n+16|0;d=k+16|0;M=k+44|0;p=k+48|0;C=l+16|0;L=l+44|0;J=l+48|0;N=m+16|0;Wpa(s,v,e,f[d>>2]|0,f[p>>2]|0,f[C>>2]|0,f[J>>2]|0,f[N>>2]|0,f[B>>2]|0,f[O>>2]|0,f[x>>2]|0,f[k+12>>2]|0,f[k+8>>2]|0,r);r=n+36|0;e=f[r>>2]|0;if(e|0?(v=e+12|0,e=f[v>>2]|0,f[v>>2]=e+-1,(e|0)==1):0)_S(n);f[r>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[A>>2]|0)>0){O=f[D>>2]|0;D=0;do{f[O+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[A>>2]|0))}A=f[y>>2]|0;if((A|0)!=(x|0))g0(A);A=m+36|0;x=f[A>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)_S(m);f[A>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[b>>2]|0)>0){N=f[j>>2]|0;j=0;do{f[N+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[b>>2]|0))}b=f[z>>2]|0;if((b|0)!=(B|0))g0(b);b=l+36|0;B=f[b>>2]|0;if(B|0?(z=B+12|0,B=f[z>>2]|0,f[z>>2]=B+-1,(B|0)==1):0)_S(l);f[b>>2]=0;b=l+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[b>>2]|0)>0){C=f[l+40>>2]|0;l=0;do{f[C+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[b>>2]|0))}b=f[L>>2]|0;if((b|0)!=(J|0))g0(b);b=k+36|0;J=f[b>>2]|0;if(J|0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0)_S(k);f[b>>2]=0;b=k+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[k+40>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[b>>2]|0))}b=f[M>>2]|0;if((b|0)==(p|0)){u=h;return}g0(b);u=h;return}function jqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=e0()|0;iqa(a,b,d,e0()|0,c,-1);return}function kqa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;iqa(a,b,c,e0()|0,d,e);return}function lqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;g=u;u=u+496|0;h=g+440|0;i=g+384|0;j=g+328|0;k=g+272|0;l=g+216|0;m=g+160|0;n=g+104|0;o=g+48|0;p=g+32|0;q=g+16|0;r=g;O4(h,a,0,1,0,0);O4(i,c,0,1,0,0);f[j>>2]=f[i>>2];c=j+4|0;a=i+4|0;s=f[a>>2]|0;f[c>>2]=s;t=j+8|0;f[t>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];v=j+16|0;w=i+16|0;f[v>>2]=f[w>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];x=j+36|0;y=i+36|0;z=f[y>>2]|0;f[x>>2]=z;A=j+40|0;f[A>>2]=t;t=j+48|0;B=j+44|0;f[B>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(!z)C=s;else{s=z+12|0;f[s>>2]=(f[s>>2]|0)+1;C=f[a>>2]|0}if((C|0)<3){C=f[i+44>>2]|0;s=f[B>>2]|0;f[s>>2]=f[C>>2];f[s+4>>2]=f[C+4>>2]}else{f[c>>2]=0;ZS(j,i)}f[k>>2]=1124007936;C=k+4|0;s=k+8|0;z=k+40|0;D=C;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[z>>2]=s;F=k+48|0;G=k+44|0;f[G>>2]=F;f[F>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;H=l+4|0;I=l+8|0;J=l+40|0;D=H;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[J>>2]=I;K=l+48|0;L=l+44|0;f[L>>2]=K;f[K>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;M=m+4|0;N=m+8|0;O=m+40|0;D=M;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[O>>2]=N;P=m+48|0;Q=m+44|0;f[Q>>2]=P;f[P>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;R=n+4|0;S=n+8|0;T=n+40|0;D=R;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[T>>2]=S;U=n+48|0;V=n+44|0;f[V>>2]=U;f[U>>2]=0;f[n+52>>2]=0;if(!d)W=0;else{O4(o,d,0,1,0,0);d=o+36|0;X=f[d>>2]|0;if(X|0){Y=X+12|0;f[Y>>2]=(f[Y>>2]|0)+1}Y=l+36|0;X=f[Y>>2]|0;if(X|0?(Z=X+12|0,X=f[Z>>2]|0,f[Z>>2]=X+-1,(X|0)==1):0)_S(l);f[Y>>2]=0;X=l+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[H>>2]|0)>0){Z=f[J>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0;$=f[H>>2]|0}while((_|0)<($|0));f[l>>2]=f[o>>2];if(($|0)<3)aa=17;else aa=19}else{f[l>>2]=f[o>>2];aa=17}if((aa|0)==17){$=f[o+4>>2]|0;if(($|0)<3){f[H>>2]=$;f[I>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];$=f[o+44>>2]|0;_=f[L>>2]|0;f[_>>2]=f[$>>2];f[_+4>>2]=f[$+4>>2]}else aa=19}if((aa|0)==19)ZS(l,o);$=o+16|0;f[X>>2]=f[$>>2];_=l+20|0;f[_>>2]=f[o+20>>2];Z=l+24|0;f[Z>>2]=f[o+24>>2];ba=l+28|0;f[ba>>2]=f[o+28>>2];ca=l+32|0;f[ca>>2]=f[o+32>>2];da=f[d>>2]|0;f[Y>>2]=da;if(da|0){ea=da+12|0;f[ea>>2]=(f[ea>>2]|0)+1}ea=k+36|0;da=f[ea>>2]|0;if(da|0?(fa=da+12|0,da=f[fa>>2]|0,f[fa>>2]=da+-1,(da|0)==1):0)_S(k);f[ea>>2]=0;da=k+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[C>>2]|0)>0){fa=f[z>>2]|0;ga=0;do{f[fa+(ga<<2)>>2]=0;ga=ga+1|0;ha=f[C>>2]|0}while((ga|0)<(ha|0));f[k>>2]=f[l>>2];if((ha|0)<3)aa=30;else aa=32}else{f[k>>2]=f[l>>2];aa=30}if((aa|0)==30){ha=f[H>>2]|0;if((ha|0)<3){f[C>>2]=ha;f[s>>2]=f[I>>2];f[k+12>>2]=f[l+12>>2];I=f[L>>2]|0;s=f[G>>2]|0;f[s>>2]=f[I>>2];f[s+4>>2]=f[I+4>>2]}else aa=32}if((aa|0)==32)ZS(k,l);f[da>>2]=f[X>>2];f[k+20>>2]=f[_>>2];f[k+24>>2]=f[Z>>2];f[k+28>>2]=f[ba>>2];f[k+32>>2]=f[ca>>2];f[ea>>2]=f[Y>>2];Y=f[d>>2]|0;if(Y|0?(ea=Y+12|0,Y=f[ea>>2]|0,f[ea>>2]=Y+-1,(Y|0)==1):0)_S(o);f[d>>2]=0;d=o+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[d>>2]|0)>0){$=f[o+40>>2]|0;Y=0;do{f[$+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[d>>2]|0))}d=f[o+44>>2]|0;if((d|0)!=(o+48|0))g0(d);W=l}if(!e)ia=0;else{O4(o,e,0,1,0,0);e=o+36|0;d=f[e>>2]|0;if(d|0){Y=d+12|0;f[Y>>2]=(f[Y>>2]|0)+1}Y=n+36|0;d=f[Y>>2]|0;if(d|0?($=d+12|0,d=f[$>>2]|0,f[$>>2]=d+-1,(d|0)==1):0)_S(n);f[Y>>2]=0;d=n+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[R>>2]|0)>0){$=f[T>>2]|0;ea=0;do{f[$+(ea<<2)>>2]=0;ea=ea+1|0;ja=f[R>>2]|0}while((ea|0)<(ja|0));f[n>>2]=f[o>>2];if((ja|0)<3)aa=53;else aa=55}else{f[n>>2]=f[o>>2];aa=53}if((aa|0)==53){ja=f[o+4>>2]|0;if((ja|0)<3){f[R>>2]=ja;f[S>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];ja=f[o+44>>2]|0;ea=f[V>>2]|0;f[ea>>2]=f[ja>>2];f[ea+4>>2]=f[ja+4>>2]}else aa=55}if((aa|0)==55)ZS(n,o);ja=o+16|0;f[d>>2]=f[ja>>2];ea=n+20|0;f[ea>>2]=f[o+20>>2];$=n+24|0;f[$>>2]=f[o+24>>2];ca=n+28|0;f[ca>>2]=f[o+28>>2];ba=n+32|0;f[ba>>2]=f[o+32>>2];Z=f[e>>2]|0;f[Y>>2]=Z;if(Z|0){_=Z+12|0;f[_>>2]=(f[_>>2]|0)+1}_=m+36|0;Z=f[_>>2]|0;if(Z|0?(X=Z+12|0,Z=f[X>>2]|0,f[X>>2]=Z+-1,(Z|0)==1):0)_S(m);f[_>>2]=0;Z=m+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[M>>2]|0)>0){X=f[O>>2]|0;da=0;do{f[X+(da<<2)>>2]=0;da=da+1|0;ka=f[M>>2]|0}while((da|0)<(ka|0));f[m>>2]=f[n>>2];if((ka|0)<3)aa=66;else aa=68}else{f[m>>2]=f[n>>2];aa=66}if((aa|0)==66){ka=f[R>>2]|0;if((ka|0)<3){f[M>>2]=ka;f[N>>2]=f[S>>2];f[m+12>>2]=f[n+12>>2];S=f[V>>2]|0;N=f[Q>>2]|0;f[N>>2]=f[S>>2];f[N+4>>2]=f[S+4>>2]}else aa=68}if((aa|0)==68)ZS(m,n);f[Z>>2]=f[d>>2];f[m+20>>2]=f[ea>>2];f[m+24>>2]=f[$>>2];f[m+28>>2]=f[ca>>2];f[m+32>>2]=f[ba>>2];f[_>>2]=f[Y>>2];Y=f[e>>2]|0;if(Y|0?(_=Y+12|0,Y=f[_>>2]|0,f[_>>2]=Y+-1,(Y|0)==1):0)_S(o);f[e>>2]=0;e=o+4|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[e>>2]|0)>0){ja=f[o+40>>2]|0;Y=0;do{f[ja+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[e>>2]|0))}e=f[o+44>>2]|0;if((e|0)!=(o+48|0))g0(e);ia=n}f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=h;e=p+8|0;f[e>>2]=0;f[e+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;if(!W){f[q>>2]=33554432;f[q+4>>2]=0}else{f[q>>2]=33619968;f[q+4>>2]=W}W=r+8|0;f[W>>2]=0;f[W+4>>2]=0;if(!ia){f[r>>2]=33554432;f[r+4>>2]=0}else{f[r>>2]=33619968;f[r+4>>2]=ia}iqa(o,p,q,r,f[i>>2]&7,-1);if((f[w>>2]|0)!=(f[v>>2]|0)){f[o>>2]=0;la=o+4|0;f[la>>2]=0;ma=tT(o,81)|0;D=ma;na=273996;E=D+81|0;do{b[D>>0]=b[na>>0]|0;D=D+1|0;na=na+1|0}while((D|0)<(E|0));hqa(-215,o,274078,631)}r=l+16|0;q=k+16|0;if((f[r>>2]|0)!=(f[q>>2]|0)){f[o>>2]=0;la=o+4|0;f[la>>2]=0;ma=tT(o,81)|0;D=ma;na=273996;E=D+81|0;do{b[D>>0]=b[na>>0]|0;D=D+1|0;na=na+1|0}while((D|0)<(E|0));hqa(-215,o,274078,631)}p=n+16|0;ia=m+16|0;if((f[p>>2]|0)!=(f[ia>>2]|0)){f[o>>2]=0;la=o+4|0;f[la>>2]=0;ma=tT(o,81)|0;D=ma;na=273996;E=D+81|0;do{b[D>>0]=b[na>>0]|0;D=D+1|0;na=na+1|0}while((D|0)<(E|0));hqa(-215,o,274078,631)}o=n+36|0;na=f[o>>2]|0;if(na|0?(D=na+12|0,na=f[D>>2]|0,f[D>>2]=na+-1,(na|0)==1):0)_S(n);f[o>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[R>>2]|0)>0){p=f[T>>2]|0;T=0;do{f[p+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[V>>2]|0;if((R|0)!=(U|0))g0(R);R=m+36|0;U=f[R>>2]|0;if(U|0?(V=U+12|0,U=f[V>>2]|0,f[V>>2]=U+-1,(U|0)==1):0)_S(m);f[R>>2]=0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[M>>2]|0)>0){ia=f[O>>2]|0;O=0;do{f[ia+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))g0(M);M=l+36|0;P=f[M>>2]|0;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)_S(l);f[M>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[H>>2]|0)>0){r=f[J>>2]|0;J=0;do{f[r+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[L>>2]|0;if((H|0)!=(K|0))g0(H);H=k+36|0;K=f[H>>2]|0;do if(K|0){L=K+12|0;J=f[L>>2]|0;f[L>>2]=J+-1;if((J|0)!=1)break;_S(k)}while(0);f[H>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[C>>2]|0)>0){q=f[z>>2]|0;z=0;do{f[q+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[C>>2]|0))}C=f[G>>2]|0;if((C|0)!=(F|0))g0(C);C=f[x>>2]|0;do if(C|0){F=C+12|0;G=f[F>>2]|0;f[F>>2]=G+-1;if((G|0)!=1)break;_S(j)}while(0);f[x>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[c>>2]|0)>0){v=f[A>>2]|0;A=0;do{f[v+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[c>>2]|0))}c=f[B>>2]|0;if((c|0)!=(t|0))g0(c);c=f[y>>2]|0;do if(c|0){t=c+12|0;B=f[t>>2]|0;f[t>>2]=B+-1;if((B|0)!=1)break;_S(i)}while(0);f[y>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[a>>2]|0)>0){w=f[i+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[i+44>>2]|0;if((a|0)!=(i+48|0))g0(a);a=h+36|0;i=f[a>>2]|0;do if(i|0){y=i+12|0;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break;_S(h)}while(0);f[a>>2]=0;a=h+16|0;i=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[h+40>>2]|0;w=0;do{f[a+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=g;return}g0(i);u=g;return}function mqa(a){a=a|0;return}function nqa(a){a=a|0;YDc(a);return}function oqa(a){a=a|0;return}function pqa(a){a=a|0;YDc(a);return}function qqa(a){a=a|0;return}function rqa(a){a=a|0;return}function sqa(a){a=a|0;YDc(a);return}function tqa(a){a=a|0;return}function uqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58128;b=a+192|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+196>>2]=0;b=a+184|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+188>>2]=0;b=a+176|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+180>>2]=0;b=f[a+164>>2]|0;if(b|0){c=a+168|0;e=f[c>>2]|0;if((e|0)!=(b|0))f[c>>2]=e+(~((e+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+128>>2]|0;if(b|0){e=a+132|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;YDc(b)}b=f[a+116>>2]|0;if(b|0){e=a+120|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;YDc(b)}b=f[a+104>>2]|0;if(b|0){e=a+108|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;YDc(b)}b=f[a+92>>2]|0;if(b|0){e=a+96|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;YDc(b)}b=f[a+76>>2]|0;if(!b)return;e=a+80|0;a=f[e>>2]|0;if((a|0)!=(b|0))f[e>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function vqa(a){a=a|0;uqa(a);YDc(a);return}function wqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;g=u;u=u+16|0;h=g;i=f[c>>2]|0;j=a+36|0;f[j>>2]=i;k=f[c+4>>2]|0;c=a+40|0;f[c>>2]=k;l=f[e>>2]|0;m=f[e+4>>2]|0;e=f[d>>2]|0;n=f[d+4>>2]|0;d=a+44|0;f[d>>2]=l;o=a+48|0;f[o>>2]=m;p=a+52|0;f[p>>2]=e;q=a+56|0;f[q>>2]=n;if(((e+l|0)>(i|0)?1:(l|m|e|n|0)<0)|(n+m|0)>(k|0)){f[h>>2]=0;f[h+4>>2]=0;dJc(tT(h,143)|0,274377,143)|0;z5(-215,h,274521,274199,173)}k=a+4|0;m=f[k>>2]|0;n=(m>>>3&511)+1<<(47696>>>(m<<1&14)&3);l=a+12|0;i=f[l>>2]|0;r=(i>>>3&511)+1<<(47696>>>(i<<1&14)&3);i=a+116|0;s=f[i>>2]|0;t=a+120|0;v=(s|0)==(f[t>>2]|0)?0:s;s=a+16|0;w=a+20|0;x=f[w>>2]|0;y=x+3|0;z=a+28|0;A=f[z>>2]|0;B=x-A+-1|0;x=((A|0)<(B|0)?B:A)<<1|1;A=(y|0)<(x|0)?x:y;y=a+32|0;x=f[y>>2]|0;if((x|0)>=(e|0)){B=a+164|0;C=a+168|0;D=f[C>>2]|0;E=f[B>>2]|0;if((A|0)==(D-E>>2|0))F=a+180|0;else{G=C;H=C;I=B;J=B;K=E;L=D;M=7}}else{D=a+168|0;E=a+164|0;G=D;H=D;I=E;J=E;K=f[E>>2]|0;L=f[D>>2]|0;M=7}do if((M|0)==7){D=L-K>>2;E=K;B=L;if(A>>>0<=D>>>0)if(A>>>0<D>>>0?(C=E+(A<<2)|0,(B|0)!=(C|0)):0){f[G>>2]=B+(~((B+-4-C|0)>>>2)<<2);N=x;O=e;P=m}else{N=x;O=e;P=m}else{bha(J,A-D|0);N=f[y>>2]|0;O=f[p>>2]|0;P=f[k>>2]|0}D=(N|0)<(O|0)?O:N;f[y>>2]=D;C=(P>>>3&511)+1|0;B=a+104|0;E=Y(D+-1+(f[s>>2]|0)|0,n)|0;D=a+108|0;Q=f[D>>2]|0;R=f[B>>2]|0;S=Q-R|0;T=R;R=Q;if(E>>>0<=S>>>0){if(E>>>0<S>>>0?(Q=T+E|0,(R|0)!=(Q|0)):0)f[D>>2]=Q}else y$(B,E-S|0);if(!(f[a+72>>2]|0)){if(!v){f[h>>2]=0;f[h+4>>2]=0;U=tT(h,16)|0;V=274527;W=U+16|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));z5(-215,h,274521,274199,191)}S=a+128|0;E=f[l>>2]|0;Q=f[y>>2]|0;D=f[s>>2]|0;R=Y((E>>>3&511)+1<<(47696>>>(E<<1&14)&3),Q+63+D|0)|0;E=a+132|0;T=f[E>>2]|0;X=f[S>>2]|0;Z=T-X|0;_=X;$=T;if(R>>>0<=Z>>>0)if(R>>>0<Z>>>0?(T=_+R|0,($|0)!=(T|0)):0){f[E>>2]=T;aa=X;ba=Q;ca=D}else{aa=X;ba=Q;ca=D}else{y$(S,R-Z|0);aa=f[S>>2]|0;ba=f[y>>2]|0;ca=f[s>>2]|0}S=aa+63&-64;Z=Y(ba+-1+ca|0,n)|0;R=a+180|0;D=f[R>>2]|0;if(!D)da=f[B>>2]|0;else da=S;if((Z|0)>0){Q=(f[t>>2]|0)-(f[i>>2]|0)|0;X=0;do{T=Z-X|0;Q=(T|0)<(Q|0)?T:Q;if((Q|0)>0){T=0;do{b[da+(T+X)>>0]=b[v+T>>0]|0;T=T+1|0}while((T|0)<(Q|0))}X=Q+X|0}while((Z|0)>(X|0));ea=f[R>>2]|0}else ea=D;if(!ea){X=f[a+188>>2]|0;gi[f[(f[X>>2]|0)+8>>2]&255](X,f[B>>2]|0,S,f[y>>2]|0,C);fa=R}else fa=R}else fa=a+180|0;if(!(f[fa>>2]|0))ga=0;else ga=(f[s>>2]|0)+-1|0;X=Y((f[y>>2]|0)+63+ga&-64,r)|0;Z=a+92|0;Q=(Y(X,(f[H>>2]|0)-(f[I>>2]|0)>>2)|0)+64|0;X=a+96|0;T=f[X>>2]|0;E=f[Z>>2]|0;$=T-E|0;if(Q>>>0>$>>>0){y$(Z,Q-$|0);F=fa;break}if(Q>>>0<$>>>0?($=E+Q|0,(T|0)!=($|0)):0){f[X>>2]=$;F=fa}else F=fa}while(0);fa=f[p>>2]|0;I=f[F>>2]|0;H=(I|0)==0;ga=f[s>>2]|0;y=Y(fa+15+(H?0:ga+-1|0)&-16,r)|0;r=a+140|0;f[r>>2]=y;y=f[a+24>>2]|0;ea=f[d>>2]|0;d=y-ea|0;da=(d|0)>0;i=a+60|0;f[i>>2]=da?d:0;t=f[j>>2]|0;j=ga+-1-y+ea+fa-t|0;fa=(j|0)>0;ga=a+64|0;f[ga>>2]=fa?j:0;a:do if(da|fa){j=a+68|0;ca=f[j>>2]|0;if(!ca){if(!v){f[h>>2]=0;f[h+4>>2]=0;U=tT(h,16)|0;V=274527;W=U+16|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));z5(-215,h,274521,274199,225)}if(!H){R=(f[a+168>>2]|0)-(f[a+164>>2]|0)|0;if((R|0)>0)ha=R>>2;else break}else ha=1;R=a+104|0;C=a+92|0;S=0;B=I;while(1){if(!B)ia=f[R>>2]|0;else ia=((f[C>>2]|0)+63&-64)+(Y(f[r>>2]|0,S)|0)|0;dJc(ia|0,v|0,Y(f[i>>2]|0,n)|0)|0;D=f[ga>>2]|0;dJc(ia+(Y((f[p>>2]|0)+-1+(f[s>>2]|0)-D|0,n)|0)|0,v|0,Y(D,n)|0)|0;D=S+1|0;if((D|0)==(ha|0))break a;S=D;B=f[F>>2]|0}}B=((y|0)<(ea|0)?y:ea)-ea|0;S=f[a+88>>2]|0;C=f[a+76>>2]|0;b:do if(da){if((S|0)>0){ja=0;ka=d;la=ca}else{p_(0-d|0,t,ca)|0;R=f[i>>2]|0;if((R|0)>1){ma=R;na=1}else break;while(1){p_(na-ma|0,t,f[j>>2]|0)|0;na=na+1|0;ma=f[i>>2]|0;if((na|0)>=(ma|0))break b}}while(1){R=Y((p_(ja-ka|0,t,la)|0)+B|0,S)|0;D=Y(ja,S)|0;ba=0;do{f[C+(ba+D<<2)>>2]=ba+R;ba=ba+1|0}while((ba|0)!=(S|0));ba=ja+1|0;R=f[i>>2]|0;if((ba|0)>=(R|0))break b;ja=ba;ka=R;la=f[j>>2]|0}}while(0);if((f[ga>>2]|0)>0){if((S|0)>0)oa=0;else{ca=0;while(1){p_(ca+t|0,t,f[j>>2]|0)|0;ca=ca+1|0;if((ca|0)>=(f[ga>>2]|0))break a}}do{ca=Y((p_(oa+t|0,t,f[j>>2]|0)|0)+B|0,S)|0;R=0;do{ba=C+((Y((f[i>>2]|0)+oa|0,S)|0)+R<<2)|0;f[ba>>2]=R+ca;R=R+1|0}while((R|0)!=(S|0));oa=oa+1|0}while((oa|0)<(f[ga>>2]|0))}}while(0);f[a+160>>2]=0;f[a+156>>2]=0;ga=f[o>>2]|0;o=f[z>>2]|0;z=ga-o|0;oa=(z|0)>0?z:0;f[a+148>>2]=oa;z=a+144|0;f[z>>2]=oa;oa=ga+-1+(f[q>>2]|0)+(f[w>>2]|0)-o|0;o=f[c>>2]|0;f[a+152>>2]=(o|0)<(oa|0)?o:oa;oa=f[a+196>>2]|0;if(oa|0)Yi[f[(f[oa>>2]|0)+12>>2]&2047](oa);oa=f[F>>2]|0;if(!oa){pa=f[z>>2]|0;u=g;return pa|0}Yi[f[(f[oa>>2]|0)+12>>2]&2047](oa);pa=f[z>>2]|0;u=g;return pa|0}function xqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;h=f[(f[a>>2]|0)+8>>2]|0;i=f[b+40>>2]|0;b=f[i>>2]|0;f[g>>2]=f[i+4>>2];f[g+4>>2]=b;hh[h&127](a,c,g,d)|0;u=e;return (f[a+144>>2]|0)-(f[d+4>>2]|0)|0}function yqa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;i=u;u=u+16|0;j=i;if((f[a+36>>2]|0)<=0){f[j>>2]=0;k=j+4|0;f[k>>2]=0;l=tT(j,43)|0;m=l;n=274267;o=m+43|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,j,274311,274199,288)}p=a+40|0;if((f[p>>2]|0)<=0){f[j>>2]=0;k=j+4|0;f[k>>2]=0;l=tT(j,43)|0;m=l;n=274267;o=m+43|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,j,274311,274199,288)}l=f[a+76>>2]|0;k=a+4|0;q=f[k>>2]|0;r=(q>>>3&511)+1<<(47696>>>(q<<1&14)&3);q=f[a+88>>2]|0;s=f[a+164>>2]|0;t=(f[a+168>>2]|0)-s>>2;v=((f[a+12>>2]|0)>>>3&511)+1|0;w=a+52|0;x=f[w>>2]|0;y=f[a+16>>2]|0;z=f[a+20>>2]|0;A=f[a+28>>2]|0;B=f[a+60>>2]|0;C=f[a+64>>2]|0;D=f[a+24>>2]|0;E=f[a+44>>2]|0;F=a+180|0;G=(f[F>>2]|0)==0;if((B|0)>0|(C|0)>0)H=(f[a+68>>2]|0)!=0;else H=0;I=c+(Y((D|0)<(E|0)?D:E,0-r|0)|0)|0;E=a+144|0;D=f[E>>2]|0;c=a+156|0;J=f[c>>2]|0;K=(f[a+152>>2]|0)-D-J|0;L=(K|0)<(e|0)?K:e;if(!((g|0)!=0&(I|0)!=0&(L|0)>0)){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,23)|0;n=274319;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,j,274311,274199,307)}e=t-A|0;K=a+48|0;M=t+1-z|0;N=a+148|0;O=a+92|0;P=a+140|0;Q=a+104|0;R=Y(B,r)|0;S=x+-1+y-C|0;y=Y(S-B|0,r)|0;T=(q<<2|0)==(r|0);U=Y(B,q)|0;B=(U|0)>0;V=Y(C,q)|0;W=(V|0)>0;X=Y(S,q)|0;q=(R|0)>0;Z=Y(C,r)|0;C=(Z|0)>0;_=Y(S,r)|0;r=a+188|0;S=a+56|0;$=a+160|0;aa=z+-1|0;ba=a+196|0;ca=a+72|0;da=a+128|0;a=I;I=g;g=0;ea=L;L=D;D=J;a:while(1){J=e-L-D+(f[K>>2]|0)|0;fa=(J|0)>0?J:M;J=(ea|0)<(fa|0)?ea:fa;fa=ea-J|0;ga=J+-1|0;do if((J|0)>0){ha=Y(J,d)|0;if(G){ia=a;ja=L;ka=D;la=ga;while(1){ma=((f[O>>2]|0)+63&-64)+(Y(f[P>>2]|0,(ja-(f[N>>2]|0)+ka|0)%(t|0)|0)|0)|0;na=f[Q>>2]|0;f[c>>2]=ka+1;if((ka|0)>=(t|0)){f[c>>2]=ka;f[E>>2]=ja+1}dJc(na+R|0,ia|0,y|0)|0;do if(H)if(T){if(B){oa=0;do{f[na+(oa<<2)>>2]=f[ia+(f[l+(oa<<2)>>2]<<2)>>2];oa=oa+1|0}while((oa|0)!=(U|0))}if(W)pa=0;else break;do{f[na+(pa+X<<2)>>2]=f[ia+(f[l+(pa+U<<2)>>2]<<2)>>2];pa=pa+1|0}while((pa|0)!=(V|0))}else{if(q){oa=0;do{b[na+oa>>0]=b[ia+(f[l+(oa<<2)>>2]|0)>>0]|0;oa=oa+1|0}while((oa|0)!=(R|0))}if(C)qa=0;else break;do{b[na+(qa+_)>>0]=b[ia+(f[l+(qa+R<<2)>>2]|0)>>0]|0;qa=qa+1|0}while((qa|0)!=(Z|0))}while(0);oa=f[r>>2]|0;gi[f[(f[oa>>2]|0)+8>>2]&255](oa,na,ma,x,((f[k>>2]|0)>>>3&511)+1|0);if((la|0)<=0)break;ia=ia+d|0;ja=f[E>>2]|0;ka=f[c>>2]|0;la=la+-1|0}ra=a+ha|0;break}else{la=a;ka=L;ja=D;ia=ga;while(1){oa=((f[O>>2]|0)+63&-64)+(Y(f[P>>2]|0,(ka-(f[N>>2]|0)+ja|0)%(t|0)|0)|0)|0;f[c>>2]=ja+1;if((ja|0)>=(t|0)){f[c>>2]=ja;f[E>>2]=ka+1}dJc(oa+R|0,la|0,y|0)|0;do if(H)if(T){if(B){sa=0;do{f[oa+(sa<<2)>>2]=f[la+(f[l+(sa<<2)>>2]<<2)>>2];sa=sa+1|0}while((sa|0)!=(U|0))}if(W)ta=0;else break;do{f[oa+(ta+X<<2)>>2]=f[la+(f[l+(ta+U<<2)>>2]<<2)>>2];ta=ta+1|0}while((ta|0)!=(V|0))}else{if(q){sa=0;do{b[oa+sa>>0]=b[la+(f[l+(sa<<2)>>2]|0)>>0]|0;sa=sa+1|0}while((sa|0)!=(R|0))}if(C)ua=0;else break;do{b[oa+(ua+_)>>0]=b[la+(f[l+(ua+R<<2)>>2]|0)>>0]|0;ua=ua+1|0}while((ua|0)!=(Z|0))}while(0);if((ia|0)<=0)break;la=la+d|0;ka=f[E>>2]|0;ja=f[c>>2]|0;ia=ia+-1|0}ra=a+ha|0;break}}else ra=a;while(0);ga=f[$>>2]|0;J=aa-g+(f[S>>2]|0)-ga|0;ia=(J|0)<(t|0)?J:t;b:do if((ia|0)>0){J=g-A|0;ja=0;ka=ga;while(1){la=p_(J+ja+ka+(f[K>>2]|0)|0,f[p>>2]|0,f[ca>>2]|0)|0;if((la|0)<0)va=(f[da>>2]|0)+63&-64;else{oa=f[E>>2]|0;if((la|0)<(oa|0)){wa=46;break a}if((la|0)>=((f[c>>2]|0)+oa|0)){xa=ja;break b}va=((f[O>>2]|0)+63&-64)+(Y(f[P>>2]|0,(la-(f[N>>2]|0)|0)%(t|0)|0)|0)|0}f[s+(ja<<2)>>2]=va;la=ja+1|0;if((la|0)>=(ia|0)){xa=la;break b}ja=la;ka=f[$>>2]|0}}else xa=0;while(0);if((xa|0)<(z|0))break;ia=xa-aa|0;ga=f[F>>2]|0;if(!ga){ka=f[ba>>2]|0;ja=Y(f[w>>2]|0,v)|0;Fh[f[(f[ka>>2]|0)+8>>2]&255](ka,s,I,h,ia,ja)}else Ii[f[(f[ga>>2]|0)+8>>2]&127](ga,s,I,h,ia,f[w>>2]|0,v);ga=I+(Y(ia,h)|0)|0;a=ra;I=ga;g=ia+g|0;ea=fa;L=f[E>>2]|0;D=f[c>>2]|0}if((wa|0)==46){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,14)|0;n=274343;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,j,274311,274199,363)}wa=(f[$>>2]|0)+g|0;f[$>>2]=wa;if((wa|0)>(f[S>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,18)|0;n=274358;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,j,274311,274199,380)}else{u=i;return g|0}return 0}function zqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;if((f[c>>2]&4095|0)==(f[a+4>>2]|0)?(f[d>>2]&4095|0)==(f[a+8>>2]|0):0){j=hh[f[(f[a>>2]|0)+12>>2]&127](a,c,e,g)|0;g=f[c+48>>2]|0;e=(f[c+16>>2]|0)+(Y(g,j)|0)|0;xg[f[(f[a>>2]|0)+16>>2]&127](a,e,g,(f[a+152>>2]|0)-(f[a+144>>2]|0)|0,f[d+16>>2]|0,f[d+48>>2]|0)|0;u=h;return}f[i>>2]=0;f[i+4>>2]=0;h=tT(i,46)|0;d=274152;a=h+46|0;do{b[h>>0]=b[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(a|0));z5(-215,i,440714,274199,388)}function Aqa(a){a=a|0;f[a>>2]=58060;f[a+8>>2]=-1;f[a+4>>2]=-1;return}function Bqa(a){a=a|0;f[a>>2]=58080;f[a+8>>2]=-1;f[a+4>>2]=-1;return}function Cqa(a){a=a|0;var b=0;f[a>>2]=58104;b=a+4|0;f[b>>2]=-1;f[b+4>>2]=-1;f[b+8>>2]=-1;f[b+12>>2]=-1;return}function Dqa(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;f[a>>2]=58128;f[a+4>>2]=-1;f[a+8>>2]=-1;f[a+12>>2]=-1;l=a+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[a+36>>2]=-1;f[a+40>>2]=-1;l=a+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[a+68>>2]=1;f[a+72>>2]=1;l=a+76|0;m=l+124|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));Eqa(a,b,c,d,e,g,h,i,j,k);return}function Eqa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;m=u;u=u+16|0;n=m;o=g&4095;p=a+4|0;f[p>>2]=o;q=(g>>>3&511)+1<<(47696>>>(o<<1&14)&3);f[a+8>>2]=h&4095;h=a+12|0;f[h>>2]=i&4095;i=a+176|0;o=f[c>>2]|0;g=f[c+4>>2]|0;if(o|0){c=o+4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[i>>2]|0;f[i>>2]=o;o=a+180|0;f[o>>2]=g;if(c|0?(g=c+4|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);c=a+184|0;i=f[d>>2]|0;g=f[d+4>>2]|0;if(i|0){d=i+4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[c>>2]|0;f[c>>2]=i;i=a+188|0;f[i>>2]=g;if(d|0?(g=d+4|0,c=f[g>>2]|0,f[g>>2]=c+-1,(c|0)==1):0)Yi[f[(f[d>>2]|0)+8>>2]&2047](d);d=a+192|0;c=f[e>>2]|0;g=f[e+4>>2]|0;if(c|0){e=c+4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[d>>2]|0;f[d>>2]=c;c=a+196|0;f[c>>2]=g;if(e|0?(g=e+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)Yi[f[(f[e>>2]|0)+8>>2]&2047](e);e=(k|0)<0?j:k;k=a+68|0;f[k>>2]=j;j=a+72|0;f[j>>2]=e;if((e|0)==3){f[n>>2]=0;f[n+4>>2]=0;r=tT(n,31)|0;s=274564;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,n,274596,274199,127)}e=f[o>>2]|0;do if(!e){o=f[i>>2]|0;if(!o){f[n>>2]=0;v=n+4|0;f[v>>2]=0;w=tT(n,25)|0;r=w;s=274601;t=r+25|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,n,274596,274199,131)}d=f[c>>2]|0;if(!d){f[n>>2]=0;v=n+4|0;f[v>>2]=0;w=tT(n,25)|0;r=w;s=274601;t=r+25|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,n,274596,274199,131)}else{g=f[o+4>>2]|0;x=f[d+4>>2]|0;f[a+16>>2]=g;f[a+20>>2]=x;y=f[o+8>>2]|0;z=f[d+8>>2]|0;f[a+24>>2]=y;A=z;B=y;C=g;D=x;break}}else if((f[h>>2]|0)==(f[p>>2]|0)){x=f[e+4>>2]|0;f[a+16>>2]=x;g=f[e+8>>2]|0;f[a+20>>2]=g;y=f[e+12>>2]|0;f[a+24>>2]=y;A=f[e+16>>2]|0;B=y;C=x;D=g;break}else{f[n>>2]=0;f[n+4>>2]=0;r=tT(n,18)|0;s=274627;t=r+18|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,n,274596,274199,137)}while(0);f[a+28>>2]=A;if(!((B|A|0)>-1&(B|0)<(C|0)&(A|0)<(D|0))){f[n>>2]=0;f[n+4>>2]=0;r=tT(n,83)|0;s=274646;t=r+83|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,n,274596,274199,143)}n=q>>>((f[p>>2]|0)>>>1&2);f[a+88>>2]=n;s=C+-1|0;C=(s|0)>1?s:1;s=a+76|0;r=Y(C,n)|0;n=a+80|0;t=f[n>>2]|0;D=f[s>>2]|0;A=t-D>>2;B=D;D=t;if(r>>>0<=A>>>0){if(r>>>0<A>>>0?(t=B+(r<<2)|0,(D|0)!=(t|0)):0)f[n>>2]=D+(~((D+-4-t|0)>>>2)<<2)}else lN(s,r-A|0);f[a+140>>2]=0;f[a+32>>2]=0;A=f[a+128>>2]|0;r=a+132|0;if((f[r>>2]|0)!=(A|0))f[r>>2]=A;if(f[k>>2]|0?f[j>>2]|0:0){E=a+36|0;f[E>>2]=-1;F=a+40|0;f[F>>2]=-1;u=m;return}j=a+116|0;k=Y(C,q)|0;q=a+120|0;A=f[q>>2]|0;r=f[j>>2]|0;s=A-r|0;t=r;r=A;if(k>>>0<=s>>>0)if(k>>>0<s>>>0?(A=t+k|0,(r|0)!=(A|0)):0){f[q>>2]=A;G=t}else G=t;else{y$(j,k-s|0);G=f[j>>2]|0}j=f[p>>2]|0;p=j>>>3&511;s=p+1|0;c1(l,G,(s>>>0>4?24:p<<3)|j&7,Y(s,C)|0);E=a+36|0;f[E>>2]=-1;F=a+40|0;f[F>>2]=-1;u=m;return}function Fqa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;d=u;u=u+128|0;e=d+72|0;g=d+16|0;h=d;do if((d$(a)|0)==65536){i=f[a+4>>2]|0;f[e>>2]=f[i>>2];j=e+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[e+36>>2]=m;f[e+40>>2]=l;l=e+48|0;n=e+44|0;f[n>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];o=e;break}else{f[j>>2]=0;ZS(e,i);o=e;break}}else{a$(e,a,-1);o=e}while(0);if(f[o>>2]&4088|0){f[g>>2]=0;f[g+4>>2]=0;q=tT(g,23)|0;o=274730;r=q+23|0;do{b[q>>0]=b[o>>0]|0;q=q+1|0;o=o+1|0}while((q|0)<(r|0));z5(-215,g,274754,274199,407)}o=e+8|0;a=e+12|0;i=Y(f[a>>2]|0,f[o>>2]|0)|0;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[l>>2]=k;k=g+48|0;q=g+44|0;f[q>>2]=k;f[k>>2]=0;f[g+52>>2]=0;r=h+8|0;f[r>>2]=0;f[r+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;LZ(e,h,6,1.0,0.0);h=g+16|0;r=f[h>>2]|0;n=f[o>>2]|0;o=f[a>>2]|0;if((n|0)==1|(o|0)==1?(f[c>>2]<<1|1|0)==(o|0):0)s=(f[c+4>>2]<<1|1|0)==(n|0)?15:12;else s=12;if((i|0)>0){n=i+-1|0;t=0.0;c=0;o=s;while(1){v=+p[r+(c<<3)>>3];w=+p[r+(n-c<<3)>>3];a=v!=w?o&-2:o;m=v!=-w?a&-3:a;a=v<0.0?m&-5:m;m=v!=+(nrc(v)|0);x=m?a&-9:a;w=t+v;c=c+1|0;if((c|0)==(i|0)){y=w;z=x;break}else{t=w;o=x}}}else{y=0.0;z=s}s=+L(+(y+-1.0))>(+L(+y)+1.0)*1.1920928955078125e-07;o=s?z&-5:z;z=g+36|0;s=f[z>>2]|0;if(s|0?(i=s+12|0,s=f[i>>2]|0,f[i>>2]=s+-1,(s|0)==1):0)_S(g);f[z>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){h=f[l>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(k|0))g0(j);j=e+36|0;k=f[j>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)_S(e);f[j>>2]=0;j=e+16|0;k=e+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){j=f[e+40>>2]|0;q=0;do{f[j+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[k>>2]|0))}k=f[e+44>>2]|0;if((k|0)==(e+48|0)){u=d;return o|0}g0(k);u=d;return o|0}function Gqa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;i=u;u=u+80|0;j=i;k=i+64|0;l=i+8|0;do if((d$(e)|0)==65536){m=f[e+4>>2]|0;f[l>>2]=f[m>>2];n=l+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=l+8|0;f[p>>2]=f[m+8>>2];f[l+12>>2]=f[m+12>>2];f[l+16>>2]=f[m+16>>2];f[l+20>>2]=f[m+20>>2];f[l+24>>2]=f[m+24>>2];f[l+28>>2]=f[m+28>>2];f[l+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[l+36>>2]=q;f[l+40>>2]=p;p=l+48|0;r=l+44|0;f[r>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;ZS(l,m);break}}else a$(l,e,-1);while(0);e=c&7;m=d&7;if((d^c)&4088|0){f[k>>2]=0;s=k+4|0;f[s>>2]=0;t=tT(k,89)|0;v=t;w=274768;x=v+89|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,k,274858,274199,3605)}if((m|0)<((e>>>0>4?e:4)|0)){f[k>>2]=0;s=k+4|0;f[s>>2]=0;t=tT(k,89)|0;v=t;w=274768;x=v+89|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,k,274858,274199,3605)}if((f[l>>2]&4095|0)!=(m|0)){f[k>>2]=0;s=k+4|0;f[s>>2]=0;t=tT(k,89)|0;v=t;w=274768;x=v+89|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,k,274858,274199,3605)}w=(e|0)==0;v=w&(m|0)==4;do if(h&3|0?((f[l+12>>2]|0)+(f[l+8>>2]|0)|0)<7:0){if(v){x=VDc(76)|0;Hqa(x,l,g,h,k);t=VDc(16)|0;s=t+4|0;f[s>>2]=1;f[t>>2]=58160;f[t+8>>2]=x;f[a>>2]=t;f[a+4>>2]=x;f[s>>2]=(f[s>>2]|0)+1;x=f[s>>2]|0;f[s>>2]=x+-1;if((x|0)==1)Yi[f[(f[t>>2]|0)+8>>2]&2047](t);break}if((e|0)==5&(m|0)==5){t=VDc(76)|0;Iqa(t,l,g,h,k);x=VDc(16)|0;s=x+4|0;f[s>>2]=1;f[x>>2]=58180;f[x+8>>2]=t;f[a>>2]=x;f[a+4>>2]=t;f[s>>2]=(f[s>>2]|0)+1;t=f[s>>2]|0;f[s>>2]=t+-1;if((t|0)==1)Yi[f[(f[x>>2]|0)+8>>2]&2047](x)}else y=25}else if(v){x=VDc(72)|0;Jqa(x,l,g,k);t=VDc(16)|0;s=t+4|0;f[s>>2]=1;f[t>>2]=58200;f[t+8>>2]=x;f[a>>2]=t;f[a+4>>2]=x;f[s>>2]=(f[s>>2]|0)+1;x=f[s>>2]|0;f[s>>2]=x+-1;if((x|0)==1)Yi[f[(f[t>>2]|0)+8>>2]&2047](t)}else y=25;while(0);do if((y|0)==25){v=(m|0)==5;if(w&v){h=VDc(72)|0;Kqa(h,l,g,k);t=VDc(16)|0;x=t+4|0;f[x>>2]=1;f[t>>2]=58220;f[t+8>>2]=h;f[a>>2]=t;f[a+4>>2]=h;f[x>>2]=(f[x>>2]|0)+1;h=f[x>>2]|0;f[x>>2]=h+-1;if((h|0)!=1)break;Yi[f[(f[t>>2]|0)+8>>2]&2047](t);break}t=(m|0)==6;if(w&t){h=VDc(72)|0;Lqa(h,l,g,k);x=VDc(16)|0;s=x+4|0;f[s>>2]=1;f[x>>2]=58240;f[x+8>>2]=h;f[a>>2]=x;f[a+4>>2]=h;f[s>>2]=(f[s>>2]|0)+1;h=f[s>>2]|0;f[s>>2]=h+-1;if((h|0)!=1)break;Yi[f[(f[x>>2]|0)+8>>2]&2047](x);break}x=(e|0)==2;if(x&v){h=VDc(72)|0;Mqa(h,l,g,k);s=VDc(16)|0;n=s+4|0;f[n>>2]=1;f[s>>2]=58260;f[s+8>>2]=h;f[a>>2]=s;f[a+4>>2]=h;f[n>>2]=(f[n>>2]|0)+1;h=f[n>>2]|0;f[n>>2]=h+-1;if((h|0)!=1)break;Yi[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(x&t){x=VDc(72)|0;Nqa(x,l,g,k);s=VDc(16)|0;h=s+4|0;f[h>>2]=1;f[s>>2]=58280;f[s+8>>2]=x;f[a>>2]=s;f[a+4>>2]=x;f[h>>2]=(f[h>>2]|0)+1;x=f[h>>2]|0;f[h>>2]=x+-1;if((x|0)!=1)break;Yi[f[(f[s>>2]|0)+8>>2]&2047](s);break}s=(e|0)==3;if(s&v){x=VDc(72)|0;Oqa(x,l,g,k);h=VDc(16)|0;n=h+4|0;f[n>>2]=1;f[h>>2]=58300;f[h+8>>2]=x;f[a>>2]=h;f[a+4>>2]=x;f[n>>2]=(f[n>>2]|0)+1;x=f[n>>2]|0;f[n>>2]=x+-1;if((x|0)==1)Yi[f[(f[h>>2]|0)+8>>2]&2047](h);break}if(s&t){s=VDc(72)|0;Pqa(s,l,g,k);h=VDc(16)|0;x=h+4|0;f[x>>2]=1;f[h>>2]=58320;f[h+8>>2]=s;f[a>>2]=h;f[a+4>>2]=s;f[x>>2]=(f[x>>2]|0)+1;s=f[x>>2]|0;f[x>>2]=s+-1;if((s|0)!=1)break;Yi[f[(f[h>>2]|0)+8>>2]&2047](h);break}h=(e|0)==5;if(h&v){v=VDc(72)|0;Qqa(v,l,g,k);s=VDc(16)|0;x=s+4|0;f[x>>2]=1;f[s>>2]=58340;f[s+8>>2]=v;f[a>>2]=s;f[a+4>>2]=v;f[x>>2]=(f[x>>2]|0)+1;v=f[x>>2]|0;f[x>>2]=v+-1;if((v|0)==1)Yi[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(h&t){h=VDc(72)|0;Rqa(h,l,g,k);s=VDc(16)|0;v=s+4|0;f[v>>2]=1;f[s>>2]=58360;f[s+8>>2]=h;f[a>>2]=s;f[a+4>>2]=h;f[v>>2]=(f[v>>2]|0)+1;h=f[v>>2]|0;f[v>>2]=h+-1;if((h|0)!=1)break;Yi[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(!((e|0)==6&t)){f[j>>2]=c;f[j+4>>2]=d;F5(k,274877,j);z5(-213,k,274858,274199,3644)}t=VDc(72)|0;Sqa(t,l,g,k);s=VDc(16)|0;h=s+4|0;f[h>>2]=1;f[s>>2]=58380;f[s+8>>2]=t;f[a>>2]=s;f[a+4>>2]=t;f[h>>2]=(f[h>>2]|0)+1;t=f[h>>2]|0;f[h>>2]=t+-1;if((t|0)==1)Yi[f[(f[s>>2]|0)+8>>2]&2047](s)}while(0);a=l+36|0;k=f[a>>2]|0;if(k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)_S(l);f[a>>2]=0;a=l+16|0;k=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[k>>2]|0)>0){a=f[l+40>>2]|0;g=0;do{f[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[k>>2]|0))}k=f[l+44>>2]|0;if((k|0)==(l+48|0)){u=i;return}g0(k);u=i;return}function Hqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Zra(a,c,d,g);f[a>>2]=58640;f[a+72>>2]=e;if(e&3|0?(f[a+4>>2]|0)<6:0){u=h;return}f[i>>2]=0;f[i+4>>2]=0;h=tT(i,84)|0;a=276322;e=h+84|0;do{b[h>>0]=b[a>>0]|0;h=h+1|0;a=a+1|0}while((h|0)<(e|0));z5(-215,i,276407,274199,3112)}function Iqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Rra(a,c,d,g);f[a>>2]=58600;f[a+72>>2]=e;if(e&3|0?(f[a+4>>2]|0)<6:0){u=h;return}f[i>>2]=0;f[i+4>>2]=0;h=tT(i,84)|0;a=276322;e=h+84|0;do{b[h>>0]=b[a>>0]|0;h=h+1|0;a=a+1|0}while((h|0)<(e|0));z5(-215,i,276407,274199,3112)}function Jqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58580;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=4){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Kqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58560;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Lqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58540;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Mqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58520;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Nqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58500;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Oqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58480;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Pqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58460;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Qqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58440;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Rqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58420;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Sqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58400;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Tqa(a){a=a|0;YDc(a);return}function Uqa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Vqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58400;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Wqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58400;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Xqa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<3)|0;m=+p[h>>3];n=m*+p[l+8>>3];o=m*+p[l+16>>3];q=m*+p[l+24>>3];p[c+(k<<3)>>3]=m*+p[l>>3];p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<3)|0;q=+p[h>>3];l=k;o=q*+p[k+24>>3];n=q*+p[k+16>>3];m=q*+p[k+8>>3];r=q*+p[k>>3];k=1;do{l=l+(e<<3)|0;q=+p[h+(k<<3)>>3];r=r+q*+p[l>>3];m=m+q*+p[l+8>>3];n=n+q*+p[l+16>>3];o=o+q*+p[l+24>>3];k=k+1|0}while((k|0)!=(g|0));p[c+(j<<3)>>3]=r;p[c+((j|1)<<3)>>3]=m;p[c+((j|2)<<3)>>3]=n;p[c+((j|3)<<3)>>3]=o;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+p[b+(d<<3)>>3];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<3)|0;q=+p[h>>3]*+p[d>>3];i=d;d=1;do{i=i+(e<<3)|0;q=q+ +p[h+(d<<3)>>3]*+p[i>>3];d=d+1|0}while((d|0)!=(g|0));p[c+(s<<3)>>3]=q;s=s+1|0}while((s|0)!=(a|0));return}function Yqa(a){a=a|0;YDc(a);return}function Zqa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _qa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58420;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function $qa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58420;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function ara(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+p[h>>3];o=m*+n[l+4>>2];q=m*+n[l+8>>2];r=m*+n[l+12>>2];p[c+(k<<3)>>3]=m*+n[l>>2];p[c+((k|1)<<3)>>3]=o;p[c+((k|2)<<3)>>3]=q;p[c+((k|3)<<3)>>3]=r;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;r=+p[h>>3];l=k;q=r*+n[k+12>>2];o=r*+n[k+8>>2];m=r*+n[k+4>>2];s=r*+n[k>>2];k=1;do{l=l+(e<<2)|0;r=+p[h+(k<<3)>>3];s=s+r*+n[l>>2];m=m+r*+n[l+4>>2];o=o+r*+n[l+8>>2];q=q+r*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));p[c+(j<<3)>>3]=s;p[c+((j|1)<<3)>>3]=m;p[c+((j|2)<<3)>>3]=o;p[c+((j|3)<<3)>>3]=q;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<2)|0;r=+p[h>>3]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;r=r+ +p[h+(d<<3)>>3]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function bra(a){a=a|0;YDc(a);return}function cra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58440;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function era(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58440;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function fra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+n[h>>2];o=m*+n[l+4>>2];p=m*+n[l+8>>2];q=m*+n[l+12>>2];n[c+(k<<2)>>2]=m*+n[l>>2];n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;q=+n[h>>2];l=k;p=q*+n[k+12>>2];o=q*+n[k+8>>2];m=q*+n[k+4>>2];r=q*+n[k>>2];k=1;do{l=l+(e<<2)|0;q=+n[h+(k<<2)>>2];r=r+q*+n[l>>2];m=m+q*+n[l+4>>2];o=o+q*+n[l+8>>2];p=p+q*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));n[c+(j<<2)>>2]=r;n[c+((j|1)<<2)>>2]=m;n[c+((j|2)<<2)>>2]=o;n[c+((j|3)<<2)>>2]=p;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<2)|0;q=+n[h>>2]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;q=q+ +n[h+(d<<2)>>2]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));n[c+(s<<2)>>2]=q;s=s+1|0}while((s|0)!=(a|0));return}function gra(a){a=a|0;YDc(a);return}function hra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ira(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58460;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function jra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58460;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function kra(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;h=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(g,e)|0;e=a+-4|0;do if((a|0)<4)j=0;else{if((h|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;n=+p[i>>3];o=n*+(d[m+2>>1]|0);q=n*+(d[m+4>>1]|0);r=n*+(d[m+6>>1]|0);p[c+(l<<3)>>3]=n*+(d[m>>1]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(e|0));j=a&-4;break}do{l=b+(k<<1)|0;r=+p[i>>3];m=l;q=r*+(d[l+6>>1]|0);o=r*+(d[l+4>>1]|0);n=r*+(d[l+2>>1]|0);s=r*+(d[l>>1]|0);l=1;do{m=m+(g<<1)|0;r=+p[i+(l<<3)>>3];s=s+r*+(d[m>>1]|0);n=n+r*+(d[m+2>>1]|0);o=o+r*+(d[m+4>>1]|0);q=q+r*+(d[m+6>>1]|0);l=l+1|0}while((l|0)!=(h|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(e|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((h|0)>1)t=j;else{e=j;do{p[c+(e<<3)>>3]=+p[i>>3]*+(d[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(a|0));return}do{e=b+(t<<1)|0;r=+p[i>>3]*+(d[e>>1]|0);j=e;e=1;do{j=j+(g<<1)|0;r=r+ +p[i+(e<<3)>>3]*+(d[j>>1]|0);e=e+1|0}while((e|0)!=(h|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function lra(a){a=a|0;YDc(a);return}function mra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58480;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function ora(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58480;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function pra(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;h=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(g,e)|0;e=a+-4|0;do if((a|0)<4)j=0;else{if((h|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;o=+n[i>>2];p=o*+(d[m+2>>1]|0);q=o*+(d[m+4>>1]|0);r=o*+(d[m+6>>1]|0);n[c+(l<<2)>>2]=o*+(d[m>>1]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(e|0));j=a&-4;break}do{l=b+(k<<1)|0;r=+n[i>>2];m=l;q=r*+(d[l+6>>1]|0);p=r*+(d[l+4>>1]|0);o=r*+(d[l+2>>1]|0);s=r*+(d[l>>1]|0);l=1;do{m=m+(g<<1)|0;r=+n[i+(l<<2)>>2];s=s+r*+(d[m>>1]|0);o=o+r*+(d[m+2>>1]|0);p=p+r*+(d[m+4>>1]|0);q=q+r*+(d[m+6>>1]|0);l=l+1|0}while((l|0)!=(h|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(e|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((h|0)>1)t=j;else{e=j;do{n[c+(e<<2)>>2]=+n[i>>2]*+(d[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(a|0));return}do{e=b+(t<<1)|0;r=+n[i>>2]*+(d[e>>1]|0);j=e;e=1;do{j=j+(g<<1)|0;r=r+ +n[i+(e<<2)>>2]*+(d[j>>1]|0);e=e+1|0}while((e|0)!=(h|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function qra(a){a=a|0;YDc(a);return}function rra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function sra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58500;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function tra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58500;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function ura(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;n=+p[h>>3];o=n*+(j[m+2>>1]|0);q=n*+(j[m+4>>1]|0);r=n*+(j[m+6>>1]|0);p[c+(l<<3)>>3]=n*+(j[m>>1]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(d|0));i=a&-4;break}do{l=b+(k<<1)|0;r=+p[h>>3];m=l;q=r*+(j[l+6>>1]|0);o=r*+(j[l+4>>1]|0);n=r*+(j[l+2>>1]|0);s=r*+(j[l>>1]|0);l=1;do{m=m+(e<<1)|0;r=+p[h+(l<<3)>>3];s=s+r*+(j[m>>1]|0);n=n+r*+(j[m+2>>1]|0);o=o+r*+(j[m+4>>1]|0);q=q+r*+(j[m+6>>1]|0);l=l+1|0}while((l|0)!=(g|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+(j[b+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<1)|0;r=+p[h>>3]*+(j[d>>1]|0);i=d;d=1;do{i=i+(e<<1)|0;r=r+ +p[h+(d<<3)>>3]*+(j[i>>1]|0);d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function vra(a){a=a|0;YDc(a);return}function wra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58520;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function yra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58520;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function zra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;o=+n[h>>2];p=o*+(j[m+2>>1]|0);q=o*+(j[m+4>>1]|0);r=o*+(j[m+6>>1]|0);n[c+(l<<2)>>2]=o*+(j[m>>1]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));i=a&-4;break}do{l=b+(k<<1)|0;r=+n[h>>2];m=l;q=r*+(j[l+6>>1]|0);p=r*+(j[l+4>>1]|0);o=r*+(j[l+2>>1]|0);s=r*+(j[l>>1]|0);l=1;do{m=m+(e<<1)|0;r=+n[h+(l<<2)>>2];s=s+r*+(j[m>>1]|0);o=o+r*+(j[m+2>>1]|0);p=p+r*+(j[m+4>>1]|0);q=q+r*+(j[m+6>>1]|0);l=l+1|0}while((l|0)!=(g|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+(j[b+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<1)|0;r=+n[h>>2]*+(j[d>>1]|0);i=d;d=1;do{i=i+(e<<1)|0;r=r+ +n[h+(d<<2)>>2]*+(j[i>>1]|0);d=d+1|0}while((d|0)!=(g|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function Ara(a){a=a|0;YDc(a);return}function Bra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Cra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58540;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Dra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58540;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Era(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=+p[i>>3];o=n*+(h[m+1>>0]|0);q=n*+(h[m+2>>0]|0);r=n*+(h[m+3>>0]|0);p[c+(l<<3)>>3]=n*+(h[m>>0]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=+p[i>>3];m=l;q=r*+(h[l+3>>0]|0);o=r*+(h[l+2>>0]|0);n=r*+(h[l+1>>0]|0);s=r*+(h[l>>0]|0);l=1;do{m=m+e|0;r=+p[i+(l<<3)>>3];s=s+r*+(h[m>>0]|0);n=n+r*+(h[m+1>>0]|0);o=o+r*+(h[m+2>>0]|0);q=q+r*+(h[m+3>>0]|0);l=l+1|0}while((l|0)!=(g|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)t=j;else{d=j;do{p[c+(d<<3)>>3]=+p[i>>3]*+(h[b+d>>0]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+t|0;r=+p[i>>3]*+(h[d>>0]|0);j=d;d=1;do{j=j+e|0;r=r+ +p[i+(d<<3)>>3]*+(h[j>>0]|0);d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function Fra(a){a=a|0;YDc(a);return}function Gra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Hra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58560;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Ira(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58560;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Jra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;o=+n[i>>2];p=o*+(h[m+1>>0]|0);q=o*+(h[m+2>>0]|0);r=o*+(h[m+3>>0]|0);n[c+(l<<2)>>2]=o*+(h[m>>0]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=+n[i>>2];m=l;q=r*+(h[l+3>>0]|0);p=r*+(h[l+2>>0]|0);o=r*+(h[l+1>>0]|0);s=r*+(h[l>>0]|0);l=1;do{m=m+e|0;r=+n[i+(l<<2)>>2];s=s+r*+(h[m>>0]|0);o=o+r*+(h[m+1>>0]|0);p=p+r*+(h[m+2>>0]|0);q=q+r*+(h[m+3>>0]|0);l=l+1|0}while((l|0)!=(g|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)t=j;else{d=j;do{n[c+(d<<2)>>2]=+n[i>>2]*+(h[b+d>>0]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+t|0;r=+n[i>>2]*+(h[d>>0]|0);j=d;d=1;do{j=j+e|0;r=r+ +n[i+(d<<2)>>2]*+(h[j>>0]|0);d=d+1|0}while((d|0)!=(g|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function Kra(a){a=a|0;YDc(a);return}function Lra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Mra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58580;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Nra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58580;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Ora(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=f[i>>2]|0;o=Y(h[m>>0]|0,n)|0;p=Y(h[m+1>>0]|0,n)|0;q=Y(h[m+2>>0]|0,n)|0;r=Y(h[m+3>>0]|0,n)|0;f[c+(l<<2)>>2]=o;f[c+((l|1)<<2)>>2]=p;f[c+((l|2)<<2)>>2]=q;f[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=f[i>>2]|0;q=Y(h[l>>0]|0,r)|0;p=Y(h[l+1>>0]|0,r)|0;o=Y(h[l+2>>0]|0,r)|0;n=l;m=Y(h[l+3>>0]|0,r)|0;r=o;o=p;p=q;q=1;do{n=n+e|0;l=f[i+(q<<2)>>2]|0;p=(Y(h[n>>0]|0,l)|0)+p|0;o=(Y(h[n+1>>0]|0,l)|0)+o|0;r=(Y(h[n+2>>0]|0,l)|0)+r|0;m=(Y(h[n+3>>0]|0,l)|0)+m|0;q=q+1|0}while((q|0)!=(g|0));f[c+(k<<2)>>2]=p;f[c+((k|1)<<2)>>2]=o;f[c+((k|2)<<2)>>2]=r;f[c+((k|3)<<2)>>2]=m;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)s=j;else{d=j;do{j=Y(h[b+d>>0]|0,f[i>>2]|0)|0;f[c+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(a|0));return}do{d=b+s|0;j=Y(h[d>>0]|0,f[i>>2]|0)|0;k=d;d=1;do{k=k+e|0;j=(Y(h[k>>0]|0,f[i+(d<<2)>>2]|0)|0)+j|0;d=d+1|0}while((d|0)!=(g|0));f[c+(s<<2)>>2]=j;s=s+1|0}while((s|0)!=(a|0));return}function Pra(a){a=a|0;YDc(a);return}function Qra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Rra(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58620;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function Sra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58620;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Tra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58620;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Ura(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+n[h>>2];o=m*+n[l+4>>2];p=m*+n[l+8>>2];q=m*+n[l+12>>2];n[c+(k<<2)>>2]=m*+n[l>>2];n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;q=+n[h>>2];l=k;p=q*+n[k+12>>2];o=q*+n[k+8>>2];m=q*+n[k+4>>2];r=q*+n[k>>2];k=1;do{l=l+(e<<2)|0;q=+n[h+(k<<2)>>2];r=r+q*+n[l>>2];m=m+q*+n[l+4>>2];o=o+q*+n[l+8>>2];p=p+q*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));n[c+(j<<2)>>2]=r;n[c+((j|1)<<2)>>2]=m;n[c+((j|2)<<2)>>2]=o;n[c+((j|3)<<2)>>2]=p;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<2)|0;q=+n[h>>2]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;q=q+ +n[h+(d<<2)>>2]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));n[c+(s<<2)>>2]=q;s=s+1|0}while((s|0)!=(a|0));return}function Vra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58620;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Wra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0;g=f[a+4>>2]|0;h=(g|0)/2|0;i=Y(h,e)|0;j=(f[a+28>>2]|0)+(h<<2)|0;k=b+(i<<2)|0;l=Y(e,d)|0;if(!(f[a+72>>2]&1)){a:do switch(g|0){case 3:{m=+n[j+4>>2];a=l+-2|0;d=(l|0)<2;if(+n[j>>2]==0.0&m==1.0){if(d){o=k;p=0;break a}q=0-e|0;r=e+1|0;s=1-e|0;t=a>>>1;u=t<<1;v=b+((i<<2)+(t<<3)+8)|0;t=k;w=0;while(1){x=+n[t+(r<<2)>>2]-+n[t+(s<<2)>>2];n[c+(w<<2)>>2]=+n[t+(e<<2)>>2]-+n[t+(q<<2)>>2];n[c+((w|1)<<2)>>2]=x;w=w+2|0;if((w|0)>(a|0))break;else t=t+8|0}o=v;p=u+2|0;break a}else{if(d){o=k;p=0;break a}t=0-e|0;w=e+1|0;q=1-e|0;s=a>>>1;r=s<<1;y=b+((i<<2)+(s<<3)+8)|0;s=k;z=0;while(1){x=m*(+n[s+(w<<2)>>2]-+n[s+(q<<2)>>2]);n[c+(z<<2)>>2]=m*(+n[s+(e<<2)>>2]-+n[s+(t<<2)>>2]);n[c+((z|1)<<2)>>2]=x;z=z+2|0;if((z|0)>(a|0))break;else s=s+8|0}o=y;p=r+2|0;break a}break}case 5:{m=+n[j+4>>2];x=+n[j+8>>2];s=l+-2|0;if((l|0)<2){o=k;p=0}else{a=0-e|0;z=e<<1;t=a<<1;q=e+1|0;w=1-e|0;d=z|1;u=1-z|0;v=s>>>1;A=v<<1;B=b+((i<<2)+(v<<3)+8)|0;v=0;C=k;while(1){D=m*(+n[C+(q<<2)>>2]-+n[C+(w<<2)>>2])+x*(+n[C+(d<<2)>>2]-+n[C+(u<<2)>>2]);n[c+(v<<2)>>2]=m*(+n[C+(e<<2)>>2]-+n[C+(a<<2)>>2])+x*(+n[C+(z<<2)>>2]-+n[C+(t<<2)>>2]);n[c+((v|1)<<2)>>2]=D;v=v+2|0;if((v|0)>(s|0))break;else C=C+8|0}o=B;p=A+2|0}break}default:{o=k;p=0}}while(0);if((p|0)>=(l|0))return;if((g|0)<2){C=o;s=p;while(1){n[c+(s<<2)>>2]=+n[j>>2]*+n[C>>2];s=s+1|0;if((s|0)==(l|0))break;else C=C+4|0}return}else{E=o;F=p}while(1){x=+n[j>>2]*+n[E>>2];p=e;o=1;while(1){x=x+ +n[j+(o<<2)>>2]*(+n[E+(p<<2)>>2]-+n[E+(0-p<<2)>>2]);if((o|0)>=(h|0))break;else{p=p+e|0;o=o+1|0}}n[c+(F<<2)>>2]=x;F=F+1|0;if((F|0)==(l|0))break;else E=E+4|0}return}b:do switch(g|0){case 1:{if(+n[j>>2]==1.0?(E=l+-2|0,(l|0)>=2):0){F=E>>>1;o=F<<1;p=b+((i<<2)+(F<<3)+8)|0;F=0;A=k;while(1){B=F|1;C=f[k+(B<<2)>>2]|0;f[c+(F<<2)>>2]=f[A>>2];f[c+(B<<2)>>2]=C;C=F+2|0;if((C|0)>(E|0))break;else{F=C;A=k+(C<<2)|0}}G=p;H=o+2|0}else{G=k;H=0}break}case 3:{x=+n[j>>2];m=+n[j+4>>2];A=m==1.0;if(x==2.0&A){F=l+-2|0;if((l|0)<2){G=k;H=0;break b}E=0-e|0;C=1-e|0;B=e+1|0;s=F>>>1;v=s<<1;t=b+((i<<2)+(s<<3)+8)|0;s=k;z=0;while(1){D=+n[s+(B<<2)>>2]+(+n[s+(C<<2)>>2]+ +n[s+4>>2]*2.0);n[c+(z<<2)>>2]=+n[s+(e<<2)>>2]+(+n[s+(E<<2)>>2]+ +n[s>>2]*2.0);n[c+((z|1)<<2)>>2]=D;z=z+2|0;if((z|0)>(F|0))break;else s=s+8|0}G=t;H=v+2|0;break b}s=l+-2|0;F=(l|0)<2;if(x==-2.0&A){if(F){G=k;H=0;break b}z=0-e|0;E=1-e|0;C=e+1|0;B=s>>>1;o=B<<1;p=b+((i<<2)+(B<<3)+8)|0;B=k;a=0;while(1){D=+n[B+(C<<2)>>2]+(+n[B+(E<<2)>>2]-+n[B+4>>2]*2.0);n[c+(a<<2)>>2]=+n[B+(e<<2)>>2]+(+n[B+(z<<2)>>2]-+n[B>>2]*2.0);n[c+((a|1)<<2)>>2]=D;a=a+2|0;if((a|0)>(s|0))break;else B=B+8|0}G=p;H=o+2|0;break b}else{if(F){G=k;H=0;break b}B=0-e|0;a=1-e|0;z=e+1|0;E=s>>>1;C=E<<1;A=b+((i<<2)+(E<<3)+8)|0;E=k;v=0;while(1){D=x*+n[E+4>>2]+m*(+n[E+(a<<2)>>2]+ +n[E+(z<<2)>>2]);n[c+(v<<2)>>2]=x*+n[E>>2]+m*(+n[E+(B<<2)>>2]+ +n[E+(e<<2)>>2]);n[c+((v|1)<<2)>>2]=D;v=v+2|0;if((v|0)>(s|0))break;else E=E+8|0}G=A;H=C+2|0;break b}break}case 5:{m=+n[j>>2];x=+n[j+4>>2];D=+n[j+8>>2];E=l+-2|0;s=(l|0)<2;if(m==-2.0&x==0.0&D==1.0){if(s){G=k;H=0;break b}v=0-e<<1;B=e<<1;z=1-B|0;a=B|1;F=E>>>1;o=F<<1;p=b+((i<<2)+(F<<3)+8)|0;F=k;t=0;while(1){I=+n[F+(z<<2)>>2]-+n[F+4>>2]*2.0+ +n[F+(a<<2)>>2];n[c+(t<<2)>>2]=+n[F+(v<<2)>>2]-+n[F>>2]*2.0+ +n[F+(B<<2)>>2];n[c+((t|1)<<2)>>2]=I;t=t+2|0;if((t|0)>(E|0))break;else F=F+8|0}G=p;H=o+2|0;break b}else{if(s){G=k;H=0;break b}F=0-e|0;t=F<<1;B=e<<1;v=1-e|0;a=e+1|0;z=1-B|0;C=B|1;A=E>>>1;u=A<<1;d=b+((i<<2)+(A<<3)+8)|0;A=k;w=0;while(1){I=m*+n[A+4>>2]+x*(+n[A+(v<<2)>>2]+ +n[A+(a<<2)>>2])+D*(+n[A+(z<<2)>>2]+ +n[A+(C<<2)>>2]);n[c+(w<<2)>>2]=m*+n[A>>2]+x*(+n[A+(F<<2)>>2]+ +n[A+(e<<2)>>2])+D*(+n[A+(t<<2)>>2]+ +n[A+(B<<2)>>2]);n[c+((w|1)<<2)>>2]=I;w=w+2|0;if((w|0)>(E|0))break;else A=A+8|0}G=d;H=u+2|0;break b}break}default:{G=k;H=0}}while(0);if((H|0)>=(l|0))return;if((g|0)<2){g=G;k=H;while(1){n[c+(k<<2)>>2]=+n[j>>2]*+n[g>>2];k=k+1|0;if((k|0)==(l|0))break;else g=g+4|0}return}else{J=G;K=H}while(1){H=e;G=1;D=+n[j>>2]*+n[J>>2];while(1){D=D+ +n[j+(G<<2)>>2]*(+n[J+(H<<2)>>2]+ +n[J+(0-H<<2)>>2]);if((G|0)>=(h|0))break;else{H=H+e|0;G=G+1|0}}n[c+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(l|0))break;else J=J+4|0}return}function Xra(a){a=a|0;YDc(a);return}function Yra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zra(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=58660;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){_S(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)ZS(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;h_(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=4){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,77)|0;n=z;A=275034;o=n+77|0;do{b[n>>0]=b[A>>0]|0;n=n+1|0;A=A+1|0}while((n|0)<(o|0));z5(-215,g,275112,274199,3053)}}function _ra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58660;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function $ra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58660;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function asa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=f[i>>2]|0;o=Y(h[m>>0]|0,n)|0;p=Y(h[m+1>>0]|0,n)|0;q=Y(h[m+2>>0]|0,n)|0;r=Y(h[m+3>>0]|0,n)|0;f[c+(l<<2)>>2]=o;f[c+((l|1)<<2)>>2]=p;f[c+((l|2)<<2)>>2]=q;f[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=f[i>>2]|0;q=Y(h[l>>0]|0,r)|0;p=Y(h[l+1>>0]|0,r)|0;o=Y(h[l+2>>0]|0,r)|0;n=l;m=Y(h[l+3>>0]|0,r)|0;r=o;o=p;p=q;q=1;do{n=n+e|0;l=f[i+(q<<2)>>2]|0;p=(Y(h[n>>0]|0,l)|0)+p|0;o=(Y(h[n+1>>0]|0,l)|0)+o|0;r=(Y(h[n+2>>0]|0,l)|0)+r|0;m=(Y(h[n+3>>0]|0,l)|0)+m|0;q=q+1|0}while((q|0)!=(g|0));f[c+(k<<2)>>2]=p;f[c+((k|1)<<2)>>2]=o;f[c+((k|2)<<2)>>2]=r;f[c+((k|3)<<2)>>2]=m;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)s=j;else{d=j;do{j=Y(h[b+d>>0]|0,f[i>>2]|0)|0;f[c+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(a|0));return}do{d=b+s|0;j=Y(h[d>>0]|0,f[i>>2]|0)|0;k=d;d=1;do{k=k+e|0;j=(Y(h[k>>0]|0,f[i+(d<<2)>>2]|0)|0)+j|0;d=d+1|0}while((d|0)!=(g|0));f[c+(s<<2)>>2]=j;s=s+1|0}while((s|0)!=(a|0));return}function bsa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58660;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function csa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[a+4>>2]|0;i=(g|0)/2|0;j=Y(i,e)|0;k=(f[a+28>>2]|0)+(i<<2)|0;l=b+j|0;m=Y(e,d)|0;if(!(f[a+72>>2]&1)){a:do switch(g|0){case 3:{a=f[k+4>>2]|0;d=m+-2|0;n=(m|0)<2;if((f[k>>2]|0)==0&(a|0)==1){if(n){o=l;p=0;break a}q=0-e|0;r=e+1|0;s=1-e|0;t=d&-2;u=j+t+2|0;v=l;w=0;while(1){x=(h[v+r>>0]|0)-(h[v+s>>0]|0)|0;f[c+(w<<2)>>2]=(h[v+e>>0]|0)-(h[v+q>>0]|0);f[c+((w|1)<<2)>>2]=x;w=w+2|0;if((w|0)>(d|0))break;else v=v+2|0}o=b+u|0;p=t+2|0;break a}else{if(n){o=l;p=0;break a}v=0-e|0;w=e+1|0;q=1-e|0;s=d&-2;r=j+s+2|0;x=l;y=0;while(1){z=Y((h[x+e>>0]|0)-(h[x+v>>0]|0)|0,a)|0;A=Y((h[x+w>>0]|0)-(h[x+q>>0]|0)|0,a)|0;f[c+(y<<2)>>2]=z;f[c+((y|1)<<2)>>2]=A;y=y+2|0;if((y|0)>(d|0))break;else x=x+2|0}o=b+r|0;p=s+2|0;break a}break}case 5:{x=f[k+4>>2]|0;d=f[k+8>>2]|0;y=m+-2|0;if((m|0)<2){o=l;p=0}else{a=0-e|0;q=e<<1;w=a<<1;v=e+1|0;n=1-e|0;t=q|1;u=1-q|0;A=y&-2;z=j+A+2|0;B=0;C=l;while(1){D=Y((h[C+e>>0]|0)-(h[C+a>>0]|0)|0,x)|0;E=(Y((h[C+q>>0]|0)-(h[C+w>>0]|0)|0,d)|0)+D|0;D=Y((h[C+v>>0]|0)-(h[C+n>>0]|0)|0,x)|0;F=(Y((h[C+t>>0]|0)-(h[C+u>>0]|0)|0,d)|0)+D|0;f[c+(B<<2)>>2]=E;f[c+((B|1)<<2)>>2]=F;B=B+2|0;if((B|0)>(y|0))break;else C=C+2|0}o=b+z|0;p=A+2|0}break}default:{o=l;p=0}}while(0);if((p|0)>=(m|0))return;if((g|0)<2){C=o;y=p;while(1){B=Y(h[C>>0]|0,f[k>>2]|0)|0;f[c+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(m|0))break;else C=C+1|0}return}else{G=o;H=p}while(1){p=Y(h[G>>0]|0,f[k>>2]|0)|0;o=e;C=1;while(1){p=(Y((h[G+o>>0]|0)-(h[G+(0-o)>>0]|0)|0,f[k+(C<<2)>>2]|0)|0)+p|0;if((C|0)>=(i|0))break;else{o=o+e|0;C=C+1|0}}f[c+(H<<2)>>2]=p;H=H+1|0;if((H|0)==(m|0))break;else G=G+1|0}return}b:do switch(g|0){case 1:{if((f[k>>2]|0)==1?(G=m+-2|0,(m|0)>=2):0){H=G&-2;C=j+H+2|0;o=0;A=l;while(1){z=o|1;y=h[l+z>>0]|0;f[c+(o<<2)>>2]=h[A>>0];f[c+(z<<2)>>2]=y;y=o+2|0;if((y|0)>(G|0))break;else{o=y;A=l+y|0}}I=b+C|0;J=H+2|0}else{I=l;J=0}break}case 3:{A=f[k>>2]|0;o=f[k+4>>2]|0;G=(o|0)==1;if((A|0)==2&G){p=m+-2|0;if((m|0)<2){I=l;J=0;break b}y=0-e|0;z=1-e|0;B=e+1|0;d=p&-2;u=j+d+2|0;t=l;x=0;while(1){n=((h[t+1>>0]|0)<<1)+(h[t+z>>0]|0)+(h[t+B>>0]|0)|0;f[c+(x<<2)>>2]=((h[t>>0]|0)<<1)+(h[t+y>>0]|0)+(h[t+e>>0]|0);f[c+((x|1)<<2)>>2]=n;x=x+2|0;if((x|0)>(p|0))break;else t=t+2|0}I=b+u|0;J=d+2|0;break b}t=m+-2|0;p=(m|0)<2;if((A|0)==-2&G){if(p){I=l;J=0;break b}x=0-e|0;y=1-e|0;B=e+1|0;z=t&-2;H=j+z+2|0;C=l;n=0;while(1){v=(h[C+y>>0]|0)-((h[C+1>>0]|0)<<1)+(h[C+B>>0]|0)|0;f[c+(n<<2)>>2]=(h[C+x>>0]|0)-((h[C>>0]|0)<<1)+(h[C+e>>0]|0);f[c+((n|1)<<2)>>2]=v;n=n+2|0;if((n|0)>(t|0))break;else C=C+2|0}I=b+H|0;J=z+2|0;break b}else{if(p){I=l;J=0;break b}C=0-e|0;n=1-e|0;x=e+1|0;B=t&-2;y=j+B+2|0;G=l;d=0;while(1){u=Y(h[G>>0]|0,A)|0;v=(Y((h[G+e>>0]|0)+(h[G+C>>0]|0)|0,o)|0)+u|0;u=Y(h[G+1>>0]|0,A)|0;w=(Y((h[G+x>>0]|0)+(h[G+n>>0]|0)|0,o)|0)+u|0;f[c+(d<<2)>>2]=v;f[c+((d|1)<<2)>>2]=w;d=d+2|0;if((d|0)>(t|0))break;else G=G+2|0}I=b+y|0;J=B+2|0;break b}break}case 5:{G=f[k>>2]|0;t=f[k+4>>2]|0;d=f[k+8>>2]|0;o=m+-2|0;n=(m|0)<2;if((G|0)==-2&(t|0)==0&(d|0)==1){if(n){I=l;J=0;break b}x=0-e<<1;A=e<<1;C=1-A|0;p=A|1;z=o&-2;H=j+z+2|0;w=l;v=0;while(1){u=Y(h[w>>0]|0,-2)|0;q=Y(h[w+1>>0]|0,-2)|0;a=q+(h[w+C>>0]|0)+(h[w+p>>0]|0)|0;f[c+(v<<2)>>2]=u+(h[w+x>>0]|0)+(h[w+A>>0]|0);f[c+((v|1)<<2)>>2]=a;v=v+2|0;if((v|0)>(o|0))break;else w=w+2|0}I=b+H|0;J=z+2|0;break b}else{if(n){I=l;J=0;break b}w=0-e|0;v=w<<1;A=e<<1;x=1-e|0;p=e+1|0;C=1-A|0;B=A|1;y=o&-2;a=j+y+2|0;u=l;q=0;while(1){s=Y(h[u>>0]|0,G)|0;r=(Y((h[u+e>>0]|0)+(h[u+w>>0]|0)|0,t)|0)+s|0;s=r+(Y((h[u+A>>0]|0)+(h[u+v>>0]|0)|0,d)|0)|0;r=Y(h[u+1>>0]|0,G)|0;F=(Y((h[u+p>>0]|0)+(h[u+x>>0]|0)|0,t)|0)+r|0;r=F+(Y((h[u+B>>0]|0)+(h[u+C>>0]|0)|0,d)|0)|0;f[c+(q<<2)>>2]=s;f[c+((q|1)<<2)>>2]=r;q=q+2|0;if((q|0)>(o|0))break;else u=u+2|0}I=b+a|0;J=y+2|0;break b}break}default:{I=l;J=0}}while(0);if((J|0)>=(m|0))return;if((g|0)<2){g=I;l=J;while(1){b=Y(h[g>>0]|0,f[k>>2]|0)|0;f[c+(l<<2)>>2]=b;l=l+1|0;if((l|0)==(m|0))break;else g=g+1|0}return}else{K=I;L=J}while(1){J=e;I=1;g=Y(h[K>>0]|0,f[k>>2]|0)|0;while(1){g=(Y((h[K+(0-J)>>0]|0)+(h[K+J>>0]|0)|0,f[k+(I<<2)>>2]|0)|0)+g|0;if((I|0)>=(i|0))break;else{J=J+e|0;I=I+1|0}}f[c+(L<<2)>>2]=g;L=L+1|0;if((L|0)==(m|0))break;else K=K+1|0}return}function dsa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;k=u;u=u+80|0;l=k;m=k+72|0;n=k+64|0;o=k+8|0;do if((d$(e)|0)==65536){p=f[e+4>>2]|0;f[o>>2]=f[p>>2];q=o+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=o+8|0;f[s>>2]=f[p+8>>2];f[o+12>>2]=f[p+12>>2];f[o+16>>2]=f[p+16>>2];f[o+20>>2]=f[p+20>>2];f[o+24>>2]=f[p+24>>2];f[o+28>>2]=f[p+28>>2];f[o+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[o+36>>2]=t;f[o+40>>2]=s;s=o+48|0;v=o+44|0;f[v>>2]=s;f[s>>2]=0;f[o+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;ZS(o,p);break}}else a$(o,e,-1);while(0);e=c&7;p=d&7;if((d^c)&4088|0){f[m>>2]=0;w=m+4|0;f[w>>2]=0;x=tT(m,89)|0;y=x;z=276723;A=y+89|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,m,276813,274199,3658)}if((e|0)<((p>>>0>4?p:4)|0)){f[m>>2]=0;w=m+4|0;f[w>>2]=0;x=tT(m,89)|0;y=x;z=276723;A=y+89|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,m,276813,274199,3658)}if((f[o>>2]&4095|0)!=(e|0)){f[m>>2]=0;w=m+4|0;f[w>>2]=0;x=tT(m,89)|0;y=x;z=276723;A=y+89|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,m,276813,274199,3658)}do if(!(h&3)){z=(p|0)==0;if((e|0)==4&z){f[n>>2]=j;f[n+4>>2]=(j|0)==0?0:1<<j+-1;y=VDc(84)|0;esa(y,o,g,i,n,m);A=VDc(16)|0;x=A+4|0;f[x>>2]=1;f[A>>2]=58680;f[A+8>>2]=y;f[a>>2]=A;f[a+4>>2]=y;f[x>>2]=(f[x>>2]|0)+1;y=f[x>>2]|0;f[x>>2]=y+-1;if((y|0)==1)Yi[f[(f[A>>2]|0)+8>>2]&2047](A);break}A=(e|0)==5;if(A&z){y=VDc(76)|0;fsa(y,o,g,i,m,n);x=VDc(16)|0;w=x+4|0;f[w>>2]=1;f[x>>2]=58700;f[x+8>>2]=y;f[a>>2]=x;f[a+4>>2]=y;f[w>>2]=(f[w>>2]|0)+1;y=f[w>>2]|0;f[w>>2]=y+-1;if((y|0)!=1)break;Yi[f[(f[x>>2]|0)+8>>2]&2047](x);break}x=(e|0)==6;if(x&z){z=VDc(80)|0;gsa(z,o,g,i,m,n);y=VDc(16)|0;w=y+4|0;f[w>>2]=1;f[y>>2]=58720;f[y+8>>2]=z;f[a>>2]=y;f[a+4>>2]=z;f[w>>2]=(f[w>>2]|0)+1;z=f[w>>2]|0;f[w>>2]=z+-1;if((z|0)!=1)break;Yi[f[(f[y>>2]|0)+8>>2]&2047](y);break}y=(p|0)==2;if(A&y){z=VDc(76)|0;hsa(z,o,g,i,m,n);w=VDc(16)|0;q=w+4|0;f[q>>2]=1;f[w>>2]=58740;f[w+8>>2]=z;f[a>>2]=w;f[a+4>>2]=z;f[q>>2]=(f[q>>2]|0)+1;z=f[q>>2]|0;f[q>>2]=z+-1;if((z|0)!=1)break;Yi[f[(f[w>>2]|0)+8>>2]&2047](w);break}if(x&y){y=VDc(80)|0;isa(y,o,g,i,m,n);w=VDc(16)|0;z=w+4|0;f[z>>2]=1;f[w>>2]=58760;f[w+8>>2]=y;f[a>>2]=w;f[a+4>>2]=y;f[z>>2]=(f[z>>2]|0)+1;y=f[z>>2]|0;f[z>>2]=y+-1;if((y|0)!=1)break;Yi[f[(f[w>>2]|0)+8>>2]&2047](w);break}w=(p|0)==3;if(A&w){y=VDc(76)|0;jsa(y,o,g,i,m,n);z=VDc(16)|0;q=z+4|0;f[q>>2]=1;f[z>>2]=58780;f[z+8>>2]=y;f[a>>2]=z;f[a+4>>2]=y;f[q>>2]=(f[q>>2]|0)+1;y=f[q>>2]|0;f[q>>2]=y+-1;if((y|0)!=1)break;Yi[f[(f[z>>2]|0)+8>>2]&2047](z);break}if(x&w){w=VDc(80)|0;ksa(w,o,g,i,m,n);z=VDc(16)|0;y=z+4|0;f[y>>2]=1;f[z>>2]=58800;f[z+8>>2]=w;f[a>>2]=z;f[a+4>>2]=w;f[y>>2]=(f[y>>2]|0)+1;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break;Yi[f[(f[z>>2]|0)+8>>2]&2047](z);break}if(A&(p|0)==5){A=VDc(76)|0;lsa(A,o,g,i,m,n);z=VDc(16)|0;w=z+4|0;f[w>>2]=1;f[z>>2]=58820;f[z+8>>2]=A;f[a>>2]=z;f[a+4>>2]=A;f[w>>2]=(f[w>>2]|0)+1;A=f[w>>2]|0;f[w>>2]=A+-1;if((A|0)!=1)break;Yi[f[(f[z>>2]|0)+8>>2]&2047](z);break}if(!(x&(p|0)==6)){f[l>>2]=c;B=l+4|0;f[B>>2]=d;F5(m,276835,l);z5(-213,m,276813,274199,3739)}x=VDc(80)|0;msa(x,o,g,i,m,n);z=VDc(16)|0;A=z+4|0;f[A>>2]=1;f[z>>2]=58840;f[z+8>>2]=x;f[a>>2]=z;f[a+4>>2]=x;f[A>>2]=(f[A>>2]|0)+1;x=f[A>>2]|0;f[A>>2]=x+-1;if((x|0)==1)Yi[f[(f[z>>2]|0)+8>>2]&2047](z)}else{if(((f[o+12>>2]|0)+(f[o+8>>2]|0)|0)==4){z=(e|0)==4;if(z&(p|0)==0){f[m>>2]=j;f[m+4>>2]=(j|0)==0?0:1<<j+-1;x=VDc(88)|0;nsa(x,o,g,i,h,m,n);A=VDc(16)|0;w=A+4|0;f[w>>2]=1;f[A>>2]=58860;f[A+8>>2]=x;f[a>>2]=A;f[a+4>>2]=x;f[w>>2]=(f[w>>2]|0)+1;x=f[w>>2]|0;f[w>>2]=x+-1;if((x|0)==1)Yi[f[(f[A>>2]|0)+8>>2]&2047](A);break}if(z&(p|0)==3&(j|0)==0){z=VDc(80)|0;osa(z,o,g,i,h,m,n);A=VDc(16)|0;x=A+4|0;f[x>>2]=1;f[A>>2]=58880;f[A+8>>2]=z;f[a>>2]=A;f[a+4>>2]=z;f[x>>2]=(f[x>>2]|0)+1;z=f[x>>2]|0;f[x>>2]=z+-1;if((z|0)==1)Yi[f[(f[A>>2]|0)+8>>2]&2047](A);break}if((e|0)==5&(p|0)==5){A=VDc(80)|0;psa(A,o,g,i,h,m,n);z=VDc(16)|0;x=z+4|0;f[x>>2]=1;f[z>>2]=58900;f[z+8>>2]=A;f[a>>2]=z;f[a+4>>2]=A;f[x>>2]=(f[x>>2]|0)+1;A=f[x>>2]|0;f[x>>2]=A+-1;if((A|0)==1)Yi[f[(f[z>>2]|0)+8>>2]&2047](z);break}}z=(p|0)==0;A=(e|0)==4;if(A&z){f[m>>2]=j;f[m+4>>2]=(j|0)==0?0:1<<j+-1;x=VDc(88)|0;qsa(x,o,g,i,h,m,n);w=VDc(16)|0;y=w+4|0;f[y>>2]=1;f[w>>2]=58920;f[w+8>>2]=x;f[a>>2]=w;f[a+4>>2]=x;f[y>>2]=(f[y>>2]|0)+1;x=f[y>>2]|0;f[y>>2]=x+-1;if((x|0)==1)Yi[f[(f[w>>2]|0)+8>>2]&2047](w);break}w=(e|0)==5;if(w&z){x=VDc(80)|0;rsa(x,o,g,i,h,m,n);y=VDc(16)|0;q=y+4|0;f[q>>2]=1;f[y>>2]=58940;f[y+8>>2]=x;f[a>>2]=y;f[a+4>>2]=x;f[q>>2]=(f[q>>2]|0)+1;x=f[q>>2]|0;f[q>>2]=x+-1;if((x|0)!=1)break;Yi[f[(f[y>>2]|0)+8>>2]&2047](y);break}y=(e|0)==6;if(y&z){z=VDc(88)|0;ssa(z,o,g,i,h,m,n);x=VDc(16)|0;q=x+4|0;f[q>>2]=1;f[x>>2]=58960;f[x+8>>2]=z;f[a>>2]=x;f[a+4>>2]=z;f[q>>2]=(f[q>>2]|0)+1;z=f[q>>2]|0;f[q>>2]=z+-1;if((z|0)!=1)break;Yi[f[(f[x>>2]|0)+8>>2]&2047](x);break}x=(p|0)==2;if(w&x){z=VDc(80)|0;tsa(z,o,g,i,h,m,n);q=VDc(16)|0;r=q+4|0;f[r>>2]=1;f[q>>2]=58980;f[q+8>>2]=z;f[a>>2]=q;f[a+4>>2]=z;f[r>>2]=(f[r>>2]|0)+1;z=f[r>>2]|0;f[r>>2]=z+-1;if((z|0)!=1)break;Yi[f[(f[q>>2]|0)+8>>2]&2047](q);break}if(y&x){x=VDc(88)|0;usa(x,o,g,i,h,m,n);q=VDc(16)|0;z=q+4|0;f[z>>2]=1;f[q>>2]=59e3;f[q+8>>2]=x;f[a>>2]=q;f[a+4>>2]=x;f[z>>2]=(f[z>>2]|0)+1;x=f[z>>2]|0;f[z>>2]=x+-1;if((x|0)!=1)break;Yi[f[(f[q>>2]|0)+8>>2]&2047](q);break}q=(p|0)==3;if(A&q){A=VDc(80)|0;vsa(A,o,g,i,h,m,n);x=VDc(16)|0;z=x+4|0;f[z>>2]=1;f[x>>2]=59020;f[x+8>>2]=A;f[a>>2]=x;f[a+4>>2]=A;f[z>>2]=(f[z>>2]|0)+1;A=f[z>>2]|0;f[z>>2]=A+-1;if((A|0)!=1)break;Yi[f[(f[x>>2]|0)+8>>2]&2047](x);break}if(w&q){x=VDc(80)|0;wsa(x,o,g,i,h,m,n);A=VDc(16)|0;z=A+4|0;f[z>>2]=1;f[A>>2]=59040;f[A+8>>2]=x;f[a>>2]=A;f[a+4>>2]=x;f[z>>2]=(f[z>>2]|0)+1;x=f[z>>2]|0;f[z>>2]=x+-1;if((x|0)==1)Yi[f[(f[A>>2]|0)+8>>2]&2047](A);break}if(y&q){q=VDc(88)|0;xsa(q,o,g,i,h,m,n);A=VDc(16)|0;x=A+4|0;f[x>>2]=1;f[A>>2]=59060;f[A+8>>2]=q;f[a>>2]=A;f[a+4>>2]=q;f[x>>2]=(f[x>>2]|0)+1;q=f[x>>2]|0;f[x>>2]=q+-1;if((q|0)!=1)break;Yi[f[(f[A>>2]|0)+8>>2]&2047](A);break}if(w&(p|0)==5){w=VDc(80)|0;ysa(w,o,g,i,h,m,n);A=VDc(16)|0;q=A+4|0;f[q>>2]=1;f[A>>2]=59080;f[A+8>>2]=w;f[a>>2]=A;f[a+4>>2]=w;f[q>>2]=(f[q>>2]|0)+1;w=f[q>>2]|0;f[q>>2]=w+-1;if((w|0)==1)Yi[f[(f[A>>2]|0)+8>>2]&2047](A);break}if(!(y&(p|0)==6)){f[l>>2]=c;B=l+4|0;f[B>>2]=d;F5(m,276835,l);z5(-213,m,276813,274199,3739)}y=VDc(88)|0;zsa(y,o,g,i,h,m,n);A=VDc(16)|0;w=A+4|0;f[w>>2]=1;f[A>>2]=59100;f[A+8>>2]=y;f[a>>2]=A;f[a+4>>2]=y;f[w>>2]=(f[w>>2]|0)+1;y=f[w>>2]|0;f[w>>2]=y+-1;if((y|0)==1)Yi[f[(f[A>>2]|0)+8>>2]&2047](A)}while(0);a=o+36|0;n=f[a>>2]|0;if(n|0?(m=n+12|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)_S(o);f[a>>2]=0;a=o+16|0;n=o+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[n>>2]|0)>0){a=f[o+40>>2]|0;m=0;do{f[a+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[n>>2]|0))}n=f[o+44>>2]|0;if((n|0)==(o+48|0)){u=k;return}g0(n);u=k;return}function esa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;i=h;j=a+8|0;f[j>>2]=-1;k=a+4|0;f[k>>2]=-1;f[a>>2]=59576;l=a+12|0;f[l>>2]=1124007936;m=a+16|0;n=a+20|0;o=a+52|0;p=m;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=n;r=a+60|0;s=a+56|0;f[s>>2]=r;t=a+68|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if(f[c>>2]&16384){if((l|0)!=(c|0)){r=c+36|0;v=f[r>>2]|0;if(v){w=v+12|0;f[w>>2]=(f[w>>2]|0)+1;w=a+48|0;v=f[w>>2]|0;if((v|0)!=0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0){_S(l);y=w}else y=w}else y=a+48|0;f[y>>2]=0;w=a+28|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){v=f[o>>2]|0;o=0;do{f[v+(o<<2)>>2]=0;o=o+1|0;z=f[m>>2]|0}while((o|0)<(z|0));f[l>>2]=f[c>>2];if((z|0)<3)A=13;else A=15}else{f[l>>2]=f[c>>2];A=13}if((A|0)==13){z=f[c+4>>2]|0;if((z|0)<3){f[m>>2]=z;f[n>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];z=f[c+44>>2]|0;m=f[s>>2]|0;f[m>>2]=f[z>>2];f[m+4>>2]=f[z+4>>2]}else A=15}if((A|0)==15)ZS(l,c);f[w>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[y>>2]=f[r>>2]}}else{r=i+8|0;f[r>>2]=0;f[r+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;h_(c,i)}f[j>>2]=d;d=f[n>>2]|0;n=f[a+24>>2]|0;f[k>>2]=d+-1+n;k=nrc(e)|0;f[a+80>>2]=k;k=g;g=f[k+4>>2]|0;a=t;f[a>>2]=f[k>>2];f[a+4>>2]=g;if((f[l>>2]&4095|0)!=4){f[i>>2]=0;B=i+4|0;f[B>>2]=0;C=tT(i,77)|0;p=C;D=278074;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));z5(-215,i,278152,274199,3251)}if((d|0)==1|(n|0)==1){u=h;return}else{f[i>>2]=0;B=i+4|0;f[B>>2]=0;C=tT(i,77)|0;p=C;D=278074;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));z5(-215,i,278152,274199,3251)}}function fsa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59528;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}}function gsa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59480;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)!=6){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;o=B;C=278074;q=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;o=B;C=278074;q=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(q|0));z5(-215,g,278152,274199,3251)}}function hsa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59432;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}}function isa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59384;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)!=6){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;o=B;C=278074;q=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;o=B;C=278074;q=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(q|0));z5(-215,g,278152,274199,3251)}}function jsa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59288;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}}function ksa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59240;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)!=6){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;o=B;C=278074;q=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;o=B;C=278074;q=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(q|0));z5(-215,g,278152,274199,3251)}}function lsa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59192;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}}function msa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59144;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)!=6){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;o=B;C=278074;q=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;o=B;C=278074;q=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(q|0));z5(-215,g,278152,274199,3251)}}function nsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;qsa(a,c,d,e,g,h,i);f[a>>2]=59744;if((f[a+4>>2]|0)==3){u=j;return}else{f[k>>2]=0;f[k+4>>2]=0;j=tT(k,16)|0;a=279397;i=j+16|0;do{b[j>>0]=b[a>>0]|0;j=j+1|0;a=a+1|0}while((j|0)<(i|0));z5(-215,k,279414,274199,3420)}}function osa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;cua(a,c,d,e,g,h,i);f[a>>2]=59672;if((f[a+4>>2]|0)==3){u=j;return}else{f[k>>2]=0;f[k+4>>2]=0;j=tT(k,16)|0;a=279397;i=j+16|0;do{b[j>>0]=b[a>>0]|0;j=j+1|0;a=a+1|0}while((j|0)<(i|0));z5(-215,k,279414,274199,3420)}}function psa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Tta(a,c,d,e,g,h,i);f[a>>2]=59600;if((f[a+4>>2]|0)==3){u=j;return}else{f[k>>2]=0;f[k+4>>2]=0;j=tT(k,16)|0;a=279397;i=j+16|0;do{b[j>>0]=b[a>>0]|0;j=j+1|0;a=a+1|0}while((j|0)<(i|0));z5(-215,k,279414,274199,3420)}}function qsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;esa(a,c,d,e,h,i);f[a>>2]=59552;f[a+84>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function rsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;fsa(a,c,d,e,h,i);f[a>>2]=59504;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function ssa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;gsa(a,c,d,e,h,i);f[a>>2]=59456;f[a+80>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function tsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;hsa(a,c,d,e,h,i);f[a>>2]=59408;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function usa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;isa(a,c,d,e,h,i);f[a>>2]=59360;f[a+80>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function vsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;cta(a,c,d,e,h,i);f[a>>2]=59312;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function wsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;jsa(a,c,d,e,h,i);f[a>>2]=59264;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function xsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;ksa(a,c,d,e,h,i);f[a>>2]=59216;f[a+80>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function ysa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;lsa(a,c,d,e,h,i);f[a>>2]=59168;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function zsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;msa(a,c,d,e,h,i);f[a>>2]=59120;f[a+80>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function Asa(a){a=a|0;YDc(a);return}function Bsa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Csa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59144;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Dsa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59144;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Esa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+p[a+72>>3];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;n=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)o=0;else{e=f[n>>2]|0;if(l)q=0;else{r=0;while(1){s=+p[h>>3];t=e+(r<<3)|0;u=i+s*+p[t+8>>3];v=i+s*+p[t+16>>3];w=i+s*+p[t+24>>3];p[b+(r<<3)>>3]=i+s*+p[t>>3];p[b+((r|1)<<3)>>3]=u;p[b+((r|2)<<3)>>3]=v;p[b+((r|3)<<3)>>3]=w;r=r+4|0;if((r|0)>(a|0)){o=m;break a}}}do{w=+p[h>>3];r=e+(q<<3)|0;v=i+w*+p[r+24>>3];u=i+w*+p[r+16>>3];s=i+w*+p[r+8>>3];x=i+w*+p[r>>3];r=1;do{t=(f[n+(r<<2)>>2]|0)+(q<<3)|0;w=+p[h+(r<<3)>>3];x=x+w*+p[t>>3];s=s+w*+p[t+8>>3];u=u+w*+p[t+16>>3];v=v+w*+p[t+24>>3];r=r+1|0}while((r|0)!=(j|0));p[b+(q<<3)>>3]=x;p[b+((q|1)<<3)>>3]=s;p[b+((q|2)<<3)>>3]=u;p[b+((q|3)<<3)>>3]=v;q=q+4|0}while((q|0)<=(a|0));o=m}while(0);b:do if((o|0)<(g|0)){e=f[n>>2]|0;if(l)y=o;else{r=o;while(1){p[b+(r<<3)>>3]=i+ +p[h>>3]*+p[e+(r<<3)>>3];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +p[h>>3]*+p[e+(y<<3)>>3];r=1;do{w=w+ +p[h+(r<<3)>>3]*+p[(f[n+(r<<2)>>2]|0)+(y<<3)>>3];r=r+1|0}while((r|0)!=(j|0));p[b+(y<<3)>>3]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{n=n+4|0;b=b+d|0}}return}function Fsa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59144;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Gsa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<3)|0;k=+p[a+72>>3];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+80>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;n=(h|0)<2;o=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(n){u=0;while(1){p[q+(u<<3)>>3]=k;p[q+((u|1)<<3)>>3]=k;p[q+((u|2)<<3)>>3]=k;p[q+((u|3)<<3)>>3]=k;u=u+4|0;if((u|0)>(a|0)){t=o;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<3)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<3)|0;C=+p[j+(u<<3)>>3];z=z+C*(+p[A>>3]-+p[B>>3]);y=y+C*(+p[A+8>>3]-+p[B+8>>3]);x=x+C*(+p[A+16>>3]-+p[B+16>>3]);w=w+C*(+p[A+24>>3]-+p[B+24>>3]);if((u|0)>=(i|0))break;else u=u+1|0}p[q+(v<<3)>>3]=z;p[q+((v|1)<<3)>>3]=y;p[q+((v|2)<<3)>>3]=x;p[q+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(a|0));t=o}while(0);b:do if((t|0)<(g|0)){if(n){u=t;while(1){p[q+(u<<3)>>3]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +p[j+(u<<3)>>3]*(+p[(f[r+(u<<2)>>2]|0)+(D<<3)>>3]-+p[(f[r+(0-u<<2)>>2]|0)+(D<<3)>>3]);if((u|0)>=(i|0))break;else u=u+1|0}p[q+(D<<3)>>3]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+p[j>>3];t=b+(D<<3)|0;x=k+w*+p[t+8>>3];y=k+w*+p[t+16>>3];z=k+w*+p[t+24>>3];p[l+(D<<3)>>3]=k+w*+p[t>>3];p[l+((D|1)<<3)>>3]=x;p[l+((D|2)<<3)>>3]=y;p[l+((D|3)<<3)>>3]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+p[j>>3];D=b+(F<<3)|0;y=k+z*+p[D+24>>3];x=k+z*+p[D+16>>3];w=k+z*+p[D+8>>3];G=k+z*+p[D>>3];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<3)|0;n=(f[q+(0-D<<2)>>2]|0)+(F<<3)|0;z=+p[j+(D<<3)>>3];G=G+z*(+p[t>>3]+ +p[n>>3]);w=w+z*(+p[t+8>>3]+ +p[n+8>>3]);x=x+z*(+p[t+16>>3]+ +p[n+16>>3]);y=y+z*(+p[t+24>>3]+ +p[n+24>>3]);if((D|0)>=(i|0))break;else D=D+1|0}p[l+(F<<3)>>3]=G;p[l+((F|1)<<3)>>3]=w;p[l+((F|2)<<3)>>3]=x;p[l+((F|3)<<3)>>3]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){p[l+(D<<3)>>3]=k+ +p[j>>3]*+p[b+(D<<3)>>3];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +p[j>>3]*+p[b+(H<<3)>>3];D=1;while(1){C=C+ +p[j+(D<<3)>>3]*(+p[(f[q+(D<<2)>>2]|0)+(H<<3)>>3]+ +p[(f[q+(0-D<<2)>>2]|0)+(H<<3)>>3]);if((D|0)>=(i|0))break;else D=D+1|0}p[l+(H<<3)>>3]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function Hsa(a){a=a|0;YDc(a);return}function Isa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Jsa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59192;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Ksa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59192;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Lsa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+n[a+72>>2];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;o=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)p=0;else{e=f[o>>2]|0;if(l)q=0;else{r=0;while(1){s=+n[h>>2];t=e+(r<<2)|0;u=i+s*+n[t+4>>2];v=i+s*+n[t+8>>2];w=i+s*+n[t+12>>2];n[b+(r<<2)>>2]=i+s*+n[t>>2];n[b+((r|1)<<2)>>2]=u;n[b+((r|2)<<2)>>2]=v;n[b+((r|3)<<2)>>2]=w;r=r+4|0;if((r|0)>(a|0)){p=m;break a}}}do{w=+n[h>>2];r=e+(q<<2)|0;v=i+w*+n[r+12>>2];u=i+w*+n[r+8>>2];s=i+w*+n[r+4>>2];x=i+w*+n[r>>2];r=1;do{t=(f[o+(r<<2)>>2]|0)+(q<<2)|0;w=+n[h+(r<<2)>>2];x=x+w*+n[t>>2];s=s+w*+n[t+4>>2];u=u+w*+n[t+8>>2];v=v+w*+n[t+12>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(q<<2)>>2]=x;n[b+((q|1)<<2)>>2]=s;n[b+((q|2)<<2)>>2]=u;n[b+((q|3)<<2)>>2]=v;q=q+4|0}while((q|0)<=(a|0));p=m}while(0);b:do if((p|0)<(g|0)){e=f[o>>2]|0;if(l)y=p;else{r=p;while(1){n[b+(r<<2)>>2]=i+ +n[h>>2]*+n[e+(r<<2)>>2];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +n[h>>2]*+n[e+(y<<2)>>2];r=1;do{w=w+ +n[h+(r<<2)>>2]*+n[(f[o+(r<<2)>>2]|0)+(y<<2)>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(y<<2)>>2]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{o=o+4|0;b=b+d|0}}return}function Msa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59192;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Nsa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=+n[a+72>>2];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+76>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;o=(h|0)<2;p=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(o){u=0;while(1){n[q+(u<<2)>>2]=k;n[q+((u|1)<<2)>>2]=k;n[q+((u|2)<<2)>>2]=k;n[q+((u|3)<<2)>>2]=k;u=u+4|0;if((u|0)>(a|0)){t=p;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<2)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<2)|0;C=+n[j+(u<<2)>>2];z=z+C*(+n[A>>2]-+n[B>>2]);y=y+C*(+n[A+4>>2]-+n[B+4>>2]);x=x+C*(+n[A+8>>2]-+n[B+8>>2]);w=w+C*(+n[A+12>>2]-+n[B+12>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(v<<2)>>2]=z;n[q+((v|1)<<2)>>2]=y;n[q+((v|2)<<2)>>2]=x;n[q+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(a|0));t=p}while(0);b:do if((t|0)<(g|0)){if(o){u=t;while(1){n[q+(u<<2)>>2]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +n[j+(u<<2)>>2]*(+n[(f[r+(u<<2)>>2]|0)+(D<<2)>>2]-+n[(f[r+(0-u<<2)>>2]|0)+(D<<2)>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+n[j>>2];t=b+(D<<2)|0;x=k+w*+n[t+4>>2];y=k+w*+n[t+8>>2];z=k+w*+n[t+12>>2];n[l+(D<<2)>>2]=k+w*+n[t>>2];n[l+((D|1)<<2)>>2]=x;n[l+((D|2)<<2)>>2]=y;n[l+((D|3)<<2)>>2]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+n[j>>2];D=b+(F<<2)|0;y=k+z*+n[D+12>>2];x=k+z*+n[D+8>>2];w=k+z*+n[D+4>>2];G=k+z*+n[D>>2];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<2)|0;o=(f[q+(0-D<<2)>>2]|0)+(F<<2)|0;z=+n[j+(D<<2)>>2];G=G+z*(+n[t>>2]+ +n[o>>2]);w=w+z*(+n[t+4>>2]+ +n[o+4>>2]);x=x+z*(+n[t+8>>2]+ +n[o+8>>2]);y=y+z*(+n[t+12>>2]+ +n[o+12>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(F<<2)>>2]=G;n[l+((F|1)<<2)>>2]=w;n[l+((F|2)<<2)>>2]=x;n[l+((F|3)<<2)>>2]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){n[l+(D<<2)>>2]=k+ +n[j>>2]*+n[b+(D<<2)>>2];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +n[j>>2]*+n[b+(H<<2)>>2];D=1;while(1){C=C+ +n[j+(D<<2)>>2]*(+n[(f[q+(D<<2)>>2]|0)+(H<<2)>>2]+ +n[(f[q+(0-D<<2)>>2]|0)+(H<<2)>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(H<<2)>>2]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function Osa(a){a=a|0;YDc(a);return}function Psa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Qsa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59240;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Rsa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59240;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Ssa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+p[i>>3];g=f[o>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<3)|0;v=j+r*+p[u+8>>3];w=j+r*+p[u+16>>3];x=j+r*+p[u+24>>3];y=nrc(j+r*+p[u>>3])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=nrc(v)|0;d[b+((t|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=nrc(w)|0;d[b+((t|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=nrc(x)|0;d[b+((t|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+4|0;if((t|0)>(a|0)){q=n;break a}}}do{t=g+(s<<3)|0;x=j+r*+p[t+24>>3];w=j+r*+p[t+16>>3];v=j+r*+p[t+8>>3];z=j+r*+p[t>>3];t=1;do{y=(f[o+(t<<2)>>2]|0)+(s<<3)|0;A=+p[i+(t<<3)>>3];z=z+A*+p[y>>3];v=v+A*+p[y+8>>3];w=w+A*+p[y+16>>3];x=x+A*+p[y+24>>3];t=t+1|0}while((t|0)!=(k|0));t=nrc(z)|0;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=nrc(v)|0;d[b+((s|1)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=nrc(w)|0;d[b+((s|2)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=nrc(x)|0;d[b+((s|3)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;s=s+4|0}while((s|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){r=+p[i>>3];g=f[o>>2]|0;if(m)B=q;else{t=q;while(1){y=nrc(j+r*+p[g+(t<<3)>>3])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+p[g+(B<<3)>>3];t=1;do{A=A+ +p[i+(t<<3)>>3]*+p[(f[o+(t<<2)>>2]|0)+(B<<3)>>3];t=t+1|0}while((t|0)!=(k|0));t=nrc(A)|0;d[b+(B<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function Tsa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59240;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Usa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+p[k>>3];w=f[r>>2]|0;if(o){x=0;while(1){y=w+(x<<3)|0;z=l+v*+p[y+8>>3];A=l+v*+p[y+16>>3];B=l+v*+p[y+24>>3];C=nrc(l+v*+p[y>>3])|0;d[s+(x<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=nrc(z)|0;d[s+((x|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=nrc(A)|0;d[s+((x|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=nrc(B)|0;d[s+((x|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<3)|0;B=l+v*+p[x+24>>3];A=l+v*+p[x+16>>3];z=l+v*+p[x+8>>3];E=l+v*+p[x>>3];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<3)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<3)|0;F=+p[k+(x<<3)>>3];E=E+F*(+p[C>>3]+ +p[y>>3]);z=z+F*(+p[C+8>>3]+ +p[y+8>>3]);A=A+F*(+p[C+16>>3]+ +p[y+16>>3]);B=B+F*(+p[C+24>>3]+ +p[y+24>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=nrc(E)|0;d[s+(D<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=nrc(z)|0;d[s+((D|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=nrc(A)|0;d[s+((D|2)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=nrc(B)|0;d[s+((D|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+p[k>>3];w=f[r>>2]|0;if(o){x=u;while(1){y=nrc(l+v*+p[w+(x<<3)>>3])|0;d[s+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+p[w+(G<<3)>>3];x=1;while(1){F=F+ +p[k+(x<<3)>>3]*(+p[(f[r+(x<<2)>>2]|0)+(G<<3)>>3]+ +p[(f[r+(0-x<<2)>>2]|0)+(G<<3)>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=nrc(F)|0;d[s+(G<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=nrc(l)|0;G=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(n|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<3)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<3)|0;E=+p[k+(b<<3)>>3];z=z+E*(+p[G>>3]-+p[u>>3]);A=A+E*(+p[G+8>>3]-+p[u+8>>3]);B=B+E*(+p[G+16>>3]-+p[u+16>>3]);v=v+E*(+p[G+24>>3]-+p[u+24>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=nrc(z)|0;d[r+(I<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=nrc(A)|0;d[r+((I|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=nrc(B)|0;d[r+((I|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=nrc(v)|0;d[r+((I|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;I=I+4|0}while((I|0)<=(n|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=nrc(l)|0;u=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +p[k+(b<<3)>>3]*(+p[(f[c+(b<<2)>>2]|0)+(J<<3)>>3]-+p[(f[c+(0-b<<2)>>2]|0)+(J<<3)>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=nrc(F)|0;d[r+(J<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function Vsa(a){a=a|0;YDc(a);return}function Wsa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Xsa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59288;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Ysa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59288;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Zsa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+n[i>>2];g=f[p>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<2)|0;v=j+r*+n[u+4>>2];w=j+r*+n[u+8>>2];x=j+r*+n[u+12>>2];y=mrc(j+r*+n[u>>2])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=mrc(v)|0;d[b+((t|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=mrc(w)|0;d[b+((t|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=mrc(x)|0;d[b+((t|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+4|0;if((t|0)>(a|0)){q=o;break a}}}do{t=g+(s<<2)|0;x=j+r*+n[t+12>>2];w=j+r*+n[t+8>>2];v=j+r*+n[t+4>>2];z=j+r*+n[t>>2];t=1;do{y=(f[p+(t<<2)>>2]|0)+(s<<2)|0;A=+n[i+(t<<2)>>2];z=z+A*+n[y>>2];v=v+A*+n[y+4>>2];w=w+A*+n[y+8>>2];x=x+A*+n[y+12>>2];t=t+1|0}while((t|0)!=(k|0));t=mrc(z)|0;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=mrc(v)|0;d[b+((s|1)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=mrc(w)|0;d[b+((s|2)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=mrc(x)|0;d[b+((s|3)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;s=s+4|0}while((s|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){r=+n[i>>2];g=f[p>>2]|0;if(m)B=q;else{t=q;while(1){y=mrc(j+r*+n[g+(t<<2)>>2])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+n[g+(B<<2)>>2];t=1;do{A=A+ +n[i+(t<<2)>>2]*+n[(f[p+(t<<2)>>2]|0)+(B<<2)>>2];t=t+1|0}while((t|0)!=(k|0));t=mrc(A)|0;d[b+(B<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{p=p+4|0;b=b+e|0}}return}function _sa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59288;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function $sa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=b+(j<<2)|0;b=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+n[k>>2];w=f[r>>2]|0;if(p){x=0;while(1){y=w+(x<<2)|0;z=l+v*+n[y+4>>2];A=l+v*+n[y+8>>2];B=l+v*+n[y+12>>2];C=mrc(l+v*+n[y>>2])|0;d[s+(x<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=mrc(z)|0;d[s+((x|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=mrc(A)|0;d[s+((x|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=mrc(B)|0;d[s+((x|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<2)|0;B=l+v*+n[x+12>>2];A=l+v*+n[x+8>>2];z=l+v*+n[x+4>>2];E=l+v*+n[x>>2];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<2)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<2)|0;F=+n[k+(x<<2)>>2];E=E+F*(+n[C>>2]+ +n[y>>2]);z=z+F*(+n[C+4>>2]+ +n[y+4>>2]);A=A+F*(+n[C+8>>2]+ +n[y+8>>2]);B=B+F*(+n[C+12>>2]+ +n[y+12>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=mrc(E)|0;d[s+(D<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=mrc(z)|0;d[s+((D|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=mrc(A)|0;d[s+((D|2)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=mrc(B)|0;d[s+((D|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+n[k>>2];w=f[r>>2]|0;if(p){x=u;while(1){y=mrc(l+v*+n[w+(x<<2)>>2])|0;d[s+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+n[w+(G<<2)>>2];x=1;while(1){F=F+ +n[k+(x<<2)>>2]*(+n[(f[r+(x<<2)>>2]|0)+(G<<2)>>2]+ +n[(f[r+(0-x<<2)>>2]|0)+(G<<2)>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=mrc(F)|0;d[s+(G<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=mrc(l)|0;G=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(o|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<2)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<2)|0;E=+n[k+(b<<2)>>2];z=z+E*(+n[G>>2]-+n[u>>2]);A=A+E*(+n[G+4>>2]-+n[u+4>>2]);B=B+E*(+n[G+8>>2]-+n[u+8>>2]);v=v+E*(+n[G+12>>2]-+n[u+12>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=mrc(z)|0;d[r+(I<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=mrc(A)|0;d[r+((I|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=mrc(B)|0;d[r+((I|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=mrc(v)|0;d[r+((I|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;I=I+4|0}while((I|0)<=(o|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=mrc(l)|0;u=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +n[k+(b<<2)>>2]*(+n[(f[c+(b<<2)>>2]|0)+(J<<2)>>2]-+n[(f[c+(0-b<<2)>>2]|0)+(J<<2)>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=mrc(F)|0;d[r+(J<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function ata(a){a=a|0;YDc(a);return}function bta(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function cta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59336;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+60|0;r=a+56|0;f[r>>2]=q;f[q>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){q=c+36|0;s=f[q>>2]|0;if(s){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1;t=a+48|0;s=f[t>>2]|0;if((s|0)!=0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){_S(k);w=t}else w=t}else w=a+48|0;f[w>>2]=0;t=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){s=f[n>>2]|0;n=0;do{f[s+(n<<2)>>2]=0;n=n+1|0;x=f[l>>2]|0}while((n|0)<(x|0));f[k>>2]=f[c>>2];if((x|0)<3)y=13;else y=15}else{f[k>>2]=f[c>>2];y=13}if((y|0)==13){x=f[c+4>>2]|0;if((x|0)<3){f[l>>2]=x;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];x=f[c+44>>2]|0;l=f[r>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2]}else y=15}if((y|0)==15)ZS(k,c);f[t>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[w>>2]=f[q>>2]}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;j=nrc(e)|0;f[a+72>>2]=j;if((f[k>>2]&4095|0)!=4){f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,77)|0;o=A;B=278074;p=o+77|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,77)|0;o=A;B=278074;p=o+77|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));z5(-215,g,278152,274199,3251)}}function dta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59336;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function eta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59336;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function fta(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+72>>2]|0;k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)p=0;else{g=f[i>>2]|0;q=f[o>>2]|0;if(m)r=0;else{s=0;while(1){t=q+(s<<2)|0;u=(Y(f[t>>2]|0,g)|0)+j|0;v=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;x=(Y(f[t+12>>2]|0,g)|0)+j|0;d[b+(s<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[b+((s|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((s|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((s|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;s=s+4|0;if((s|0)>(a|0)){p=n;break a}}}do{s=q+(r<<2)|0;x=(Y(f[s>>2]|0,g)|0)+j|0;w=(Y(f[s+4>>2]|0,g)|0)+j|0;v=(Y(f[s+8>>2]|0,g)|0)+j|0;u=(Y(f[s+12>>2]|0,g)|0)+j|0;s=v;v=w;w=x;x=1;do{t=(f[o+(x<<2)>>2]|0)+(r<<2)|0;y=f[i+(x<<2)>>2]|0;w=(Y(f[t>>2]|0,y)|0)+w|0;v=(Y(f[t+4>>2]|0,y)|0)+v|0;s=(Y(f[t+8>>2]|0,y)|0)+s|0;u=(Y(f[t+12>>2]|0,y)|0)+u|0;x=x+1|0}while((x|0)!=(k|0));d[b+(r<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((r|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((r|2)<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+((r|3)<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;r=r+4|0}while((r|0)<=(a|0));p=n}while(0);b:do if((p|0)<(h|0)){g=f[i>>2]|0;q=f[o>>2]|0;if(m)z=p;else{x=p;while(1){y=(Y(f[q+(x<<2)>>2]|0,g)|0)+j|0;d[b+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}do{x=(Y(f[q+(z<<2)>>2]|0,g)|0)+j|0;y=1;do{x=(Y(f[(f[o+(y<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(y<<2)>>2]|0)|0)+x|0;y=y+1|0}while((y|0)!=(k|0));d[b+(z<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function gta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59336;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function hta(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+72>>2]|0;m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(!(f[a+76>>2]&1)){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;p=h&-4;q=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;r=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;s=c;t=m;u=b;while(1){a:do if(g)v=0;else{if(o){w=0;while(1){d[s+(w<<1)>>1]=r;d[s+((w|1)<<1)>>1]=r;d[s+((w|2)<<1)>>1]=r;d[s+((w|3)<<1)>>1]=r;w=w+4|0;if((w|0)>(a|0)){v=p;break a}}}else x=0;do{w=l;y=l;z=l;A=l;B=1;while(1){C=(f[t+(B<<2)>>2]|0)+(x<<2)|0;D=(f[t+(0-B<<2)>>2]|0)+(x<<2)|0;E=f[k+(B<<2)>>2]|0;A=(Y((f[C>>2]|0)-(f[D>>2]|0)|0,E)|0)+A|0;z=(Y((f[C+4>>2]|0)-(f[D+4>>2]|0)|0,E)|0)+z|0;y=(Y((f[C+8>>2]|0)-(f[D+8>>2]|0)|0,E)|0)+y|0;w=(Y((f[C+12>>2]|0)-(f[D+12>>2]|0)|0,E)|0)+w|0;if((B|0)>=(j|0))break;else B=B+1|0}d[s+(x<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;d[s+((x|1)<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[s+((x|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[s+((x|3)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;x=x+4|0}while((x|0)<=(a|0));v=p}while(0);b:do if((v|0)<(h|0)){if(o){B=v;while(1){d[s+(B<<1)>>1]=q;B=B+1|0;if((B|0)==(h|0))break b}}else F=v;do{B=l;E=1;while(1){B=(Y((f[(f[t+(E<<2)>>2]|0)+(F<<2)>>2]|0)-(f[(f[t+(0-E<<2)>>2]|0)+(F<<2)>>2]|0)|0,f[k+(E<<2)>>2]|0)|0)+B|0;if((E|0)>=(j|0))break;else E=E+1|0}d[s+(F<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;F=F+1|0}while((F|0)!=(h|0))}while(0);if(!u)break;else{s=s+e|0;t=t+4|0;u=u+-1|0}}return}else{if(n)return;n=h+-4|0;u=(h|0)<4;t=(i|0)<2;i=h&-4;s=m;m=c;c=b;while(1){c:do if(u)G=0;else{b=f[k>>2]|0;F=f[s>>2]|0;if(t){v=0;while(1){q=F+(v<<2)|0;o=(Y(f[q>>2]|0,b)|0)+l|0;p=(Y(f[q+4>>2]|0,b)|0)+l|0;a=(Y(f[q+8>>2]|0,b)|0)+l|0;x=(Y(f[q+12>>2]|0,b)|0)+l|0;d[m+(v<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[m+((v|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((v|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((v|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;v=v+4|0;if((v|0)>(n|0)){G=i;break c}}}else H=0;do{v=F+(H<<2)|0;x=(Y(f[v>>2]|0,b)|0)+l|0;a=(Y(f[v+4>>2]|0,b)|0)+l|0;p=(Y(f[v+8>>2]|0,b)|0)+l|0;o=(Y(f[v+12>>2]|0,b)|0)+l|0;v=p;p=a;a=x;x=1;while(1){q=(f[s+(x<<2)>>2]|0)+(H<<2)|0;r=(f[s+(0-x<<2)>>2]|0)+(H<<2)|0;g=f[k+(x<<2)>>2]|0;a=(Y((f[r>>2]|0)+(f[q>>2]|0)|0,g)|0)+a|0;p=(Y((f[r+4>>2]|0)+(f[q+4>>2]|0)|0,g)|0)+p|0;v=(Y((f[r+8>>2]|0)+(f[q+8>>2]|0)|0,g)|0)+v|0;o=(Y((f[r+12>>2]|0)+(f[q+12>>2]|0)|0,g)|0)+o|0;if((x|0)>=(j|0))break;else x=x+1|0}d[m+(H<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((H|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((H|2)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[m+((H|3)<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;H=H+4|0}while((H|0)<=(n|0));G=i}while(0);d:do if((G|0)<(h|0)){b=f[k>>2]|0;F=f[s>>2]|0;if(t){x=G;while(1){B=(Y(f[F+(x<<2)>>2]|0,b)|0)+l|0;d[m+(x<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break d}}else I=G;do{x=(Y(f[F+(I<<2)>>2]|0,b)|0)+l|0;B=1;while(1){x=(Y((f[(f[s+(0-B<<2)>>2]|0)+(I<<2)>>2]|0)+(f[(f[s+(B<<2)>>2]|0)+(I<<2)>>2]|0)|0,f[k+(B<<2)>>2]|0)|0)+x|0;if((B|0)>=(j|0))break;else B=B+1|0}d[m+(I<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!c)break;else{s=s+4|0;m=m+e|0;c=c+-1|0}}return}}function ita(a){a=a|0;YDc(a);return}function jta(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function kta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59384;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function lta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59384;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function mta(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+p[i>>3];g=f[o>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<3)|0;v=j+r*+p[u+8>>3];w=j+r*+p[u+16>>3];x=j+r*+p[u+24>>3];y=nrc(j+r*+p[u>>3])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=nrc(v)|0;d[b+((t|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=nrc(w)|0;d[b+((t|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=nrc(x)|0;d[b+((t|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+4|0;if((t|0)>(a|0)){q=n;break a}}}do{t=g+(s<<3)|0;x=j+r*+p[t+24>>3];w=j+r*+p[t+16>>3];v=j+r*+p[t+8>>3];z=j+r*+p[t>>3];t=1;do{y=(f[o+(t<<2)>>2]|0)+(s<<3)|0;A=+p[i+(t<<3)>>3];z=z+A*+p[y>>3];v=v+A*+p[y+8>>3];w=w+A*+p[y+16>>3];x=x+A*+p[y+24>>3];t=t+1|0}while((t|0)!=(k|0));t=nrc(z)|0;d[b+(s<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=nrc(v)|0;d[b+((s|1)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=nrc(w)|0;d[b+((s|2)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=nrc(x)|0;d[b+((s|3)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;s=s+4|0}while((s|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){r=+p[i>>3];g=f[o>>2]|0;if(m)B=q;else{t=q;while(1){y=nrc(j+r*+p[g+(t<<3)>>3])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+p[g+(B<<3)>>3];t=1;do{A=A+ +p[i+(t<<3)>>3]*+p[(f[o+(t<<2)>>2]|0)+(B<<3)>>3];t=t+1|0}while((t|0)!=(k|0));t=nrc(A)|0;d[b+(B<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function nta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59384;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function ota(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+p[k>>3];w=f[r>>2]|0;if(o){x=0;while(1){y=w+(x<<3)|0;z=l+v*+p[y+8>>3];A=l+v*+p[y+16>>3];B=l+v*+p[y+24>>3];C=nrc(l+v*+p[y>>3])|0;d[s+(x<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=nrc(z)|0;d[s+((x|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=nrc(A)|0;d[s+((x|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=nrc(B)|0;d[s+((x|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<3)|0;B=l+v*+p[x+24>>3];A=l+v*+p[x+16>>3];z=l+v*+p[x+8>>3];E=l+v*+p[x>>3];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<3)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<3)|0;F=+p[k+(x<<3)>>3];E=E+F*(+p[C>>3]+ +p[y>>3]);z=z+F*(+p[C+8>>3]+ +p[y+8>>3]);A=A+F*(+p[C+16>>3]+ +p[y+16>>3]);B=B+F*(+p[C+24>>3]+ +p[y+24>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=nrc(E)|0;d[s+(D<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=nrc(z)|0;d[s+((D|1)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=nrc(A)|0;d[s+((D|2)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=nrc(B)|0;d[s+((D|3)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+p[k>>3];w=f[r>>2]|0;if(o){x=u;while(1){y=nrc(l+v*+p[w+(x<<3)>>3])|0;d[s+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+p[w+(G<<3)>>3];x=1;while(1){F=F+ +p[k+(x<<3)>>3]*(+p[(f[r+(x<<2)>>2]|0)+(G<<3)>>3]+ +p[(f[r+(0-x<<2)>>2]|0)+(G<<3)>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=nrc(F)|0;d[s+(G<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=nrc(l)|0;G=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(n|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<3)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<3)|0;E=+p[k+(b<<3)>>3];z=z+E*(+p[G>>3]-+p[u>>3]);A=A+E*(+p[G+8>>3]-+p[u+8>>3]);B=B+E*(+p[G+16>>3]-+p[u+16>>3]);v=v+E*(+p[G+24>>3]-+p[u+24>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=nrc(z)|0;d[r+(I<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=nrc(A)|0;d[r+((I|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=nrc(B)|0;d[r+((I|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=nrc(v)|0;d[r+((I|3)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;I=I+4|0}while((I|0)<=(n|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=nrc(l)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +p[k+(b<<3)>>3]*(+p[(f[c+(b<<2)>>2]|0)+(J<<3)>>3]-+p[(f[c+(0-b<<2)>>2]|0)+(J<<3)>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=nrc(F)|0;d[r+(J<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function pta(a){a=a|0;YDc(a);return}function qta(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59432;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function sta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59432;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function tta(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+n[i>>2];g=f[p>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<2)|0;v=j+r*+n[u+4>>2];w=j+r*+n[u+8>>2];x=j+r*+n[u+12>>2];y=mrc(j+r*+n[u>>2])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=mrc(v)|0;d[b+((t|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=mrc(w)|0;d[b+((t|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=mrc(x)|0;d[b+((t|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+4|0;if((t|0)>(a|0)){q=o;break a}}}do{t=g+(s<<2)|0;x=j+r*+n[t+12>>2];w=j+r*+n[t+8>>2];v=j+r*+n[t+4>>2];z=j+r*+n[t>>2];t=1;do{y=(f[p+(t<<2)>>2]|0)+(s<<2)|0;A=+n[i+(t<<2)>>2];z=z+A*+n[y>>2];v=v+A*+n[y+4>>2];w=w+A*+n[y+8>>2];x=x+A*+n[y+12>>2];t=t+1|0}while((t|0)!=(k|0));t=mrc(z)|0;d[b+(s<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=mrc(v)|0;d[b+((s|1)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=mrc(w)|0;d[b+((s|2)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=mrc(x)|0;d[b+((s|3)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;s=s+4|0}while((s|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){r=+n[i>>2];g=f[p>>2]|0;if(m)B=q;else{t=q;while(1){y=mrc(j+r*+n[g+(t<<2)>>2])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+n[g+(B<<2)>>2];t=1;do{A=A+ +n[i+(t<<2)>>2]*+n[(f[p+(t<<2)>>2]|0)+(B<<2)>>2];t=t+1|0}while((t|0)!=(k|0));t=mrc(A)|0;d[b+(B<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{p=p+4|0;b=b+e|0}}return}function uta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59432;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function vta(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=b+(j<<2)|0;b=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+n[k>>2];w=f[r>>2]|0;if(p){x=0;while(1){y=w+(x<<2)|0;z=l+v*+n[y+4>>2];A=l+v*+n[y+8>>2];B=l+v*+n[y+12>>2];C=mrc(l+v*+n[y>>2])|0;d[s+(x<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=mrc(z)|0;d[s+((x|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=mrc(A)|0;d[s+((x|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=mrc(B)|0;d[s+((x|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<2)|0;B=l+v*+n[x+12>>2];A=l+v*+n[x+8>>2];z=l+v*+n[x+4>>2];E=l+v*+n[x>>2];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<2)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<2)|0;F=+n[k+(x<<2)>>2];E=E+F*(+n[C>>2]+ +n[y>>2]);z=z+F*(+n[C+4>>2]+ +n[y+4>>2]);A=A+F*(+n[C+8>>2]+ +n[y+8>>2]);B=B+F*(+n[C+12>>2]+ +n[y+12>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=mrc(E)|0;d[s+(D<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=mrc(z)|0;d[s+((D|1)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=mrc(A)|0;d[s+((D|2)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=mrc(B)|0;d[s+((D|3)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+n[k>>2];w=f[r>>2]|0;if(p){x=u;while(1){y=mrc(l+v*+n[w+(x<<2)>>2])|0;d[s+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+n[w+(G<<2)>>2];x=1;while(1){F=F+ +n[k+(x<<2)>>2]*(+n[(f[r+(x<<2)>>2]|0)+(G<<2)>>2]+ +n[(f[r+(0-x<<2)>>2]|0)+(G<<2)>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=mrc(F)|0;d[s+(G<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=mrc(l)|0;G=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(o|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<2)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<2)|0;E=+n[k+(b<<2)>>2];z=z+E*(+n[G>>2]-+n[u>>2]);A=A+E*(+n[G+4>>2]-+n[u+4>>2]);B=B+E*(+n[G+8>>2]-+n[u+8>>2]);v=v+E*(+n[G+12>>2]-+n[u+12>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=mrc(z)|0;d[r+(I<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=mrc(A)|0;d[r+((I|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=mrc(B)|0;d[r+((I|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=mrc(v)|0;d[r+((I|3)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;I=I+4|0}while((I|0)<=(o|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=mrc(l)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +n[k+(b<<2)>>2]*(+n[(f[c+(b<<2)>>2]|0)+(J<<2)>>2]-+n[(f[c+(0-b<<2)>>2]|0)+(J<<2)>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=mrc(F)|0;d[r+(J<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function wta(a){a=a|0;YDc(a);return}function xta(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function yta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59480;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function zta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59480;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Ata(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=c;c=d;d=g;while(1){d=d+-1|0;a:do if(l)q=0;else{if(m)r=0;else{g=0;while(1){s=+p[i>>3];t=(f[o>>2]|0)+(g<<3)|0;u=j+s*+p[t+8>>3];v=j+s*+p[t+16>>3];w=j+s*+p[t+24>>3];x=nrc(j+s*+p[t>>3])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;x=nrc(u)|0;b[c+(g|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=nrc(v)|0;b[c+(g|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=nrc(w)|0;b[c+(g|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+4|0;if((g|0)>(a|0)){q=n;break a}}}do{w=+p[i>>3];g=(f[o>>2]|0)+(r<<3)|0;v=j+w*+p[g+24>>3];u=j+w*+p[g+16>>3];s=j+w*+p[g+8>>3];y=j+w*+p[g>>3];g=1;do{x=(f[o+(g<<2)>>2]|0)+(r<<3)|0;w=+p[i+(g<<3)>>3];y=y+w*+p[x>>3];s=s+w*+p[x+8>>3];u=u+w*+p[x+16>>3];v=v+w*+p[x+24>>3];g=g+1|0}while((g|0)!=(k|0));g=nrc(y)|0;b[c+r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=nrc(s)|0;b[c+(r|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=nrc(u)|0;b[c+(r|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=nrc(v)|0;b[c+(r|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;r=r+4|0}while((r|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){if(m)z=q;else{g=q;while(1){x=nrc(j+ +p[i>>3]*+p[(f[o>>2]|0)+(g<<3)>>3])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+1|0;if((g|0)==(h|0))break b}}do{w=j+ +p[i>>3]*+p[(f[o>>2]|0)+(z<<3)>>3];g=1;do{w=w+ +p[i+(g<<3)>>3]*+p[(f[o+(g<<2)>>2]|0)+(z<<3)>>3];g=g+1|0}while((g|0)!=(k|0));g=nrc(w)|0;b[c+z>>0]=g>>>0<256?g:(g|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{o=o+4|0;c=c+e|0}}return}function Bta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59480;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Cta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=c+(j<<2)|0;c=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=d;t=c;while(1){a:do if(g)u=0;else{if(o){v=0;while(1){w=+p[k>>3];x=(f[r>>2]|0)+(v<<3)|0;y=l+w*+p[x+8>>3];z=l+w*+p[x+16>>3];A=l+w*+p[x+24>>3];B=nrc(l+w*+p[x>>3])|0;b[s+v>>0]=B>>>0<256?B:(B|0)>0?255:0;B=nrc(y)|0;b[s+(v|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=nrc(z)|0;b[s+(v|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=nrc(A)|0;b[s+(v|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;v=v+4|0;if((v|0)>(a|0)){u=q;break a}}}else C=0;do{A=+p[k>>3];v=(f[r>>2]|0)+(C<<3)|0;z=l+A*+p[v+24>>3];y=l+A*+p[v+16>>3];w=l+A*+p[v+8>>3];D=l+A*+p[v>>3];v=1;while(1){B=(f[r+(v<<2)>>2]|0)+(C<<3)|0;x=(f[r+(0-v<<2)>>2]|0)+(C<<3)|0;A=+p[k+(v<<3)>>3];D=D+A*(+p[B>>3]+ +p[x>>3]);w=w+A*(+p[B+8>>3]+ +p[x+8>>3]);y=y+A*(+p[B+16>>3]+ +p[x+16>>3]);z=z+A*(+p[B+24>>3]+ +p[x+24>>3]);if((v|0)>=(j|0))break;else v=v+1|0}v=nrc(D)|0;b[s+C>>0]=v>>>0<256?v:(v|0)>0?255:0;v=nrc(w)|0;b[s+(C|1)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=nrc(y)|0;b[s+(C|2)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=nrc(z)|0;b[s+(C|3)>>0]=v>>>0<256?v:(v|0)>0?255:0;C=C+4|0}while((C|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){if(o){v=u;while(1){x=nrc(l+ +p[k>>3]*+p[(f[r>>2]|0)+(v<<3)>>3])|0;b[s+v>>0]=x>>>0<256?x:(x|0)>0?255:0;v=v+1|0;if((v|0)==(h|0))break b}}else E=u;do{A=l+ +p[k>>3]*+p[(f[r>>2]|0)+(E<<3)>>3];v=1;while(1){A=A+ +p[k+(v<<3)>>3]*(+p[(f[r+(v<<2)>>2]|0)+(E<<3)>>3]+ +p[(f[r+(0-v<<2)>>2]|0)+(E<<3)>>3]);if((v|0)>=(j|0))break;else v=v+1|0}v=nrc(A)|0;b[s+E>>0]=v>>>0<256?v:(v|0)>0?255:0;E=E+1|0}while((E|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=d;d=m;m=c;while(1){c:do if(t)F=0;else{if(s){c=nrc(l)|0;E=(c>>>0<256?c:(c|0)>0?255:0)&255;c=0;while(1){b[r+c>>0]=E;b[r+(c|1)>>0]=E;b[r+(c|2)>>0]=E;b[r+(c|3)>>0]=E;c=c+4|0;if((c|0)>(n|0)){F=i;break c}}}else G=0;do{z=l;y=l;w=l;D=l;c=1;while(1){E=(f[d+(c<<2)>>2]|0)+(G<<3)|0;u=(f[d+(0-c<<2)>>2]|0)+(G<<3)|0;H=+p[k+(c<<3)>>3];D=D+H*(+p[E>>3]-+p[u>>3]);w=w+H*(+p[E+8>>3]-+p[u+8>>3]);y=y+H*(+p[E+16>>3]-+p[u+16>>3]);z=z+H*(+p[E+24>>3]-+p[u+24>>3]);if((c|0)>=(j|0))break;else c=c+1|0}c=nrc(D)|0;b[r+G>>0]=c>>>0<256?c:(c|0)>0?255:0;c=nrc(w)|0;b[r+(G|1)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=nrc(y)|0;b[r+(G|2)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=nrc(z)|0;b[r+(G|3)>>0]=c>>>0<256?c:(c|0)>0?255:0;G=G+4|0}while((G|0)<=(n|0));F=i}while(0);d:do if((F|0)<(h|0)){if(s){c=nrc(l)|0;u=(c>>>0<256?c:(c|0)>0?255:0)&255;c=F;while(1){b[r+c>>0]=u;c=c+1|0;if((c|0)==(h|0))break d}}else I=F;do{A=l;c=1;while(1){A=A+ +p[k+(c<<3)>>3]*(+p[(f[d+(c<<2)>>2]|0)+(I<<3)>>3]-+p[(f[d+(0-c<<2)>>2]|0)+(I<<3)>>3]);if((c|0)>=(j|0))break;else c=c+1|0}c=nrc(A)|0;b[r+I>>0]=c>>>0<256?c:(c|0)>0?255:0;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;d=d+4|0;m=m+-1|0}}return}function Dta(a){a=a|0;YDc(a);return}function Eta(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59528;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Gta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59528;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Hta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=c;c=d;d=g;while(1){d=d+-1|0;a:do if(l)q=0;else{if(m)r=0;else{g=0;while(1){s=+n[i>>2];t=(f[p>>2]|0)+(g<<2)|0;u=j+s*+n[t+4>>2];v=j+s*+n[t+8>>2];w=j+s*+n[t+12>>2];x=mrc(j+s*+n[t>>2])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;x=mrc(u)|0;b[c+(g|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=mrc(v)|0;b[c+(g|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=mrc(w)|0;b[c+(g|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+4|0;if((g|0)>(a|0)){q=o;break a}}}do{w=+n[i>>2];g=(f[p>>2]|0)+(r<<2)|0;v=j+w*+n[g+12>>2];u=j+w*+n[g+8>>2];s=j+w*+n[g+4>>2];y=j+w*+n[g>>2];g=1;do{x=(f[p+(g<<2)>>2]|0)+(r<<2)|0;w=+n[i+(g<<2)>>2];y=y+w*+n[x>>2];s=s+w*+n[x+4>>2];u=u+w*+n[x+8>>2];v=v+w*+n[x+12>>2];g=g+1|0}while((g|0)!=(k|0));g=mrc(y)|0;b[c+r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=mrc(s)|0;b[c+(r|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=mrc(u)|0;b[c+(r|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=mrc(v)|0;b[c+(r|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;r=r+4|0}while((r|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){if(m)z=q;else{g=q;while(1){x=mrc(j+ +n[i>>2]*+n[(f[p>>2]|0)+(g<<2)>>2])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+1|0;if((g|0)==(h|0))break b}}do{w=j+ +n[i>>2]*+n[(f[p>>2]|0)+(z<<2)>>2];g=1;do{w=w+ +n[i+(g<<2)>>2]*+n[(f[p+(g<<2)>>2]|0)+(z<<2)>>2];g=g+1|0}while((g|0)!=(k|0));g=mrc(w)|0;b[c+z>>0]=g>>>0<256?g:(g|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{p=p+4|0;c=c+e|0}}return}function Ita(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59528;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Jta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=c+(j<<2)|0;c=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=d;t=c;while(1){a:do if(g)u=0;else{if(p){v=0;while(1){w=+n[k>>2];x=(f[r>>2]|0)+(v<<2)|0;y=l+w*+n[x+4>>2];z=l+w*+n[x+8>>2];A=l+w*+n[x+12>>2];B=mrc(l+w*+n[x>>2])|0;b[s+v>>0]=B>>>0<256?B:(B|0)>0?255:0;B=mrc(y)|0;b[s+(v|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=mrc(z)|0;b[s+(v|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=mrc(A)|0;b[s+(v|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;v=v+4|0;if((v|0)>(a|0)){u=q;break a}}}else C=0;do{A=+n[k>>2];v=(f[r>>2]|0)+(C<<2)|0;z=l+A*+n[v+12>>2];y=l+A*+n[v+8>>2];w=l+A*+n[v+4>>2];D=l+A*+n[v>>2];v=1;while(1){B=(f[r+(v<<2)>>2]|0)+(C<<2)|0;x=(f[r+(0-v<<2)>>2]|0)+(C<<2)|0;A=+n[k+(v<<2)>>2];D=D+A*(+n[B>>2]+ +n[x>>2]);w=w+A*(+n[B+4>>2]+ +n[x+4>>2]);y=y+A*(+n[B+8>>2]+ +n[x+8>>2]);z=z+A*(+n[B+12>>2]+ +n[x+12>>2]);if((v|0)>=(j|0))break;else v=v+1|0}v=mrc(D)|0;b[s+C>>0]=v>>>0<256?v:(v|0)>0?255:0;v=mrc(w)|0;b[s+(C|1)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=mrc(y)|0;b[s+(C|2)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=mrc(z)|0;b[s+(C|3)>>0]=v>>>0<256?v:(v|0)>0?255:0;C=C+4|0}while((C|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){if(p){v=u;while(1){x=mrc(l+ +n[k>>2]*+n[(f[r>>2]|0)+(v<<2)>>2])|0;b[s+v>>0]=x>>>0<256?x:(x|0)>0?255:0;v=v+1|0;if((v|0)==(h|0))break b}}else E=u;do{A=l+ +n[k>>2]*+n[(f[r>>2]|0)+(E<<2)>>2];v=1;while(1){A=A+ +n[k+(v<<2)>>2]*(+n[(f[r+(v<<2)>>2]|0)+(E<<2)>>2]+ +n[(f[r+(0-v<<2)>>2]|0)+(E<<2)>>2]);if((v|0)>=(j|0))break;else v=v+1|0}v=mrc(A)|0;b[s+E>>0]=v>>>0<256?v:(v|0)>0?255:0;E=E+1|0}while((E|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=d;d=m;m=c;while(1){c:do if(t)F=0;else{if(s){c=mrc(l)|0;E=(c>>>0<256?c:(c|0)>0?255:0)&255;c=0;while(1){b[r+c>>0]=E;b[r+(c|1)>>0]=E;b[r+(c|2)>>0]=E;b[r+(c|3)>>0]=E;c=c+4|0;if((c|0)>(o|0)){F=i;break c}}}else G=0;do{z=l;y=l;w=l;D=l;c=1;while(1){E=(f[d+(c<<2)>>2]|0)+(G<<2)|0;u=(f[d+(0-c<<2)>>2]|0)+(G<<2)|0;H=+n[k+(c<<2)>>2];D=D+H*(+n[E>>2]-+n[u>>2]);w=w+H*(+n[E+4>>2]-+n[u+4>>2]);y=y+H*(+n[E+8>>2]-+n[u+8>>2]);z=z+H*(+n[E+12>>2]-+n[u+12>>2]);if((c|0)>=(j|0))break;else c=c+1|0}c=mrc(D)|0;b[r+G>>0]=c>>>0<256?c:(c|0)>0?255:0;c=mrc(w)|0;b[r+(G|1)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=mrc(y)|0;b[r+(G|2)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=mrc(z)|0;b[r+(G|3)>>0]=c>>>0<256?c:(c|0)>0?255:0;G=G+4|0}while((G|0)<=(o|0));F=i}while(0);d:do if((F|0)<(h|0)){if(s){c=mrc(l)|0;u=(c>>>0<256?c:(c|0)>0?255:0)&255;c=F;while(1){b[r+c>>0]=u;c=c+1|0;if((c|0)==(h|0))break d}}else I=F;do{A=l;c=1;while(1){A=A+ +n[k+(c<<2)>>2]*(+n[(f[d+(c<<2)>>2]|0)+(I<<2)>>2]-+n[(f[d+(0-c<<2)>>2]|0)+(I<<2)>>2]);if((c|0)>=(j|0))break;else c=c+1|0}c=mrc(A)|0;b[r+I>>0]=c>>>0<256?c:(c|0)>0?255:0;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;d=d+4|0;m=m+-1|0}}return}function Kta(a){a=a|0;YDc(a);return}function Lta(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Mta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59576;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Nta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59576;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Ota(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+80>>2]|0;k=f[a+4>>2]|0;l=a+68|0;a=f[l>>2]|0;m=f[l+4>>2]|0;if(!g)return;l=h+-4|0;n=(h|0)<4;o=(k|0)>1;p=h&-4;q=c;c=d;d=g;while(1){d=d+-1|0;a:do if(n)r=0;else{if(o)s=0;else{g=0;while(1){t=f[i>>2]|0;u=(f[q>>2]|0)+(g<<2)|0;v=(Y(f[u>>2]|0,t)|0)+j|0;w=(Y(f[u+4>>2]|0,t)|0)+j|0;x=(Y(f[u+8>>2]|0,t)|0)+j|0;y=(Y(f[u+12>>2]|0,t)|0)+j|0;t=v+m>>a;b[c+g>>0]=t>>>0<256?t:(t|0)>0?255:0;t=w+m>>a;b[c+(g|1)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=x+m>>a;b[c+(g|2)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=y+m>>a;b[c+(g|3)>>0]=t>>>0<256?t:(t|0)>0?255:0;g=g+4|0;if((g|0)>(l|0)){r=p;break a}}}do{g=f[i>>2]|0;t=(f[q>>2]|0)+(s<<2)|0;y=(Y(f[t>>2]|0,g)|0)+j|0;x=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;v=(Y(f[t+12>>2]|0,g)|0)+j|0;g=w;w=x;x=y;y=1;do{t=(f[q+(y<<2)>>2]|0)+(s<<2)|0;u=f[i+(y<<2)>>2]|0;x=(Y(f[t>>2]|0,u)|0)+x|0;w=(Y(f[t+4>>2]|0,u)|0)+w|0;g=(Y(f[t+8>>2]|0,u)|0)+g|0;v=(Y(f[t+12>>2]|0,u)|0)+v|0;y=y+1|0}while((y|0)!=(k|0));y=x+m>>a;b[c+s>>0]=y>>>0<256?y:(y|0)>0?255:0;y=w+m>>a;b[c+(s|1)>>0]=y>>>0<256?y:(y|0)>0?255:0;y=g+m>>a;b[c+(s|2)>>0]=y>>>0<256?y:(y|0)>0?255:0;y=v+m>>a;b[c+(s|3)>>0]=y>>>0<256?y:(y|0)>0?255:0;s=s+4|0}while((s|0)<=(l|0));r=p}while(0);b:do if((r|0)<(h|0)){if(o)z=r;else{y=r;while(1){u=(Y(f[(f[q>>2]|0)+(y<<2)>>2]|0,f[i>>2]|0)|0)+j+m>>a;b[c+y>>0]=u>>>0<256?u:(u|0)>0?255:0;y=y+1|0;if((y|0)==(h|0))break b}}do{y=(Y(f[(f[q>>2]|0)+(z<<2)>>2]|0,f[i>>2]|0)|0)+j|0;u=1;do{y=(Y(f[(f[q+(u<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(u<<2)>>2]|0)|0)+y|0;u=u+1|0}while((u|0)!=(k|0));u=y+m>>a;b[c+z>>0]=u>>>0<256?u:(u|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{q=q+4|0;c=c+e|0}}return}function Pta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59576;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Qta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+80>>2]|0;m=a+68|0;n=f[m>>2]|0;o=f[m+4>>2]|0;m=c+(j<<2)|0;c=g+-1|0;p=(g|0)==0;if(!(f[a+84>>2]&1)){if(p)return;a=h+-4|0;g=(h|0)<4;q=(i|0)<2;r=h&-4;s=l+o>>n;t=(s>>>0<256?s:(s|0)>0?255:0)&255;s=l+o>>n;u=(s>>>0<256?s:(s|0)>0?255:0)&255;s=d;v=m;w=c;while(1){a:do if(g)x=0;else{if(q){y=0;while(1){b[s+y>>0]=u;b[s+(y|1)>>0]=u;b[s+(y|2)>>0]=u;b[s+(y|3)>>0]=u;y=y+4|0;if((y|0)>(a|0)){x=r;break a}}}else z=0;do{y=l;A=l;B=l;C=l;D=1;while(1){E=(f[v+(D<<2)>>2]|0)+(z<<2)|0;F=(f[v+(0-D<<2)>>2]|0)+(z<<2)|0;G=f[k+(D<<2)>>2]|0;C=(Y((f[E>>2]|0)-(f[F>>2]|0)|0,G)|0)+C|0;B=(Y((f[E+4>>2]|0)-(f[F+4>>2]|0)|0,G)|0)+B|0;A=(Y((f[E+8>>2]|0)-(f[F+8>>2]|0)|0,G)|0)+A|0;y=(Y((f[E+12>>2]|0)-(f[F+12>>2]|0)|0,G)|0)+y|0;if((D|0)>=(j|0))break;else D=D+1|0}D=C+o>>n;b[s+z>>0]=D>>>0<256?D:(D|0)>0?255:0;D=B+o>>n;b[s+(z|1)>>0]=D>>>0<256?D:(D|0)>0?255:0;D=A+o>>n;b[s+(z|2)>>0]=D>>>0<256?D:(D|0)>0?255:0;D=y+o>>n;b[s+(z|3)>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+4|0}while((z|0)<=(a|0));x=r}while(0);b:do if((x|0)<(h|0)){if(q){D=x;while(1){b[s+D>>0]=t;D=D+1|0;if((D|0)==(h|0))break b}}else H=x;do{D=l;G=1;while(1){D=(Y((f[(f[v+(G<<2)>>2]|0)+(H<<2)>>2]|0)-(f[(f[v+(0-G<<2)>>2]|0)+(H<<2)>>2]|0)|0,f[k+(G<<2)>>2]|0)|0)+D|0;if((G|0)>=(j|0))break;else G=G+1|0}G=D+o>>n;b[s+H>>0]=G>>>0<256?G:(G|0)>0?255:0;H=H+1|0}while((H|0)!=(h|0))}while(0);if(!w)break;else{s=s+e|0;v=v+4|0;w=w+-1|0}}return}else{if(p)return;p=h+-4|0;w=(h|0)<4;v=(i|0)<2;i=h&-4;s=m;m=d;d=c;while(1){c:do if(w)I=0;else{if(v){c=0;while(1){H=f[k>>2]|0;x=(f[s>>2]|0)+(c<<2)|0;t=(Y(f[x>>2]|0,H)|0)+l|0;q=(Y(f[x+4>>2]|0,H)|0)+l|0;r=(Y(f[x+8>>2]|0,H)|0)+l|0;a=(Y(f[x+12>>2]|0,H)|0)+l|0;H=t+o>>n;b[m+c>>0]=H>>>0<256?H:(H|0)>0?255:0;H=q+o>>n;b[m+(c|1)>>0]=H>>>0<256?H:(H|0)>0?255:0;H=r+o>>n;b[m+(c|2)>>0]=H>>>0<256?H:(H|0)>0?255:0;H=a+o>>n;b[m+(c|3)>>0]=H>>>0<256?H:(H|0)>0?255:0;c=c+4|0;if((c|0)>(p|0)){I=i;break c}}}else J=0;do{c=f[k>>2]|0;H=(f[s>>2]|0)+(J<<2)|0;a=(Y(f[H>>2]|0,c)|0)+l|0;r=(Y(f[H+4>>2]|0,c)|0)+l|0;q=(Y(f[H+8>>2]|0,c)|0)+l|0;t=(Y(f[H+12>>2]|0,c)|0)+l|0;c=q;q=r;r=a;a=1;while(1){H=(f[s+(a<<2)>>2]|0)+(J<<2)|0;x=(f[s+(0-a<<2)>>2]|0)+(J<<2)|0;z=f[k+(a<<2)>>2]|0;r=(Y((f[x>>2]|0)+(f[H>>2]|0)|0,z)|0)+r|0;q=(Y((f[x+4>>2]|0)+(f[H+4>>2]|0)|0,z)|0)+q|0;c=(Y((f[x+8>>2]|0)+(f[H+8>>2]|0)|0,z)|0)+c|0;t=(Y((f[x+12>>2]|0)+(f[H+12>>2]|0)|0,z)|0)+t|0;if((a|0)>=(j|0))break;else a=a+1|0}a=r+o>>n;b[m+J>>0]=a>>>0<256?a:(a|0)>0?255:0;a=q+o>>n;b[m+(J|1)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=c+o>>n;b[m+(J|2)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=t+o>>n;b[m+(J|3)>>0]=a>>>0<256?a:(a|0)>0?255:0;J=J+4|0}while((J|0)<=(p|0));I=i}while(0);d:do if((I|0)<(h|0)){if(v){a=I;while(1){D=(Y(f[(f[s>>2]|0)+(a<<2)>>2]|0,f[k>>2]|0)|0)+l+o>>n;b[m+a>>0]=D>>>0<256?D:(D|0)>0?255:0;a=a+1|0;if((a|0)==(h|0))break d}}else K=I;do{a=(Y(f[(f[s>>2]|0)+(K<<2)>>2]|0,f[k>>2]|0)|0)+l|0;D=1;while(1){a=(Y((f[(f[s+(0-D<<2)>>2]|0)+(K<<2)>>2]|0)+(f[(f[s+(D<<2)>>2]|0)+(K<<2)>>2]|0)|0,f[k+(D<<2)>>2]|0)|0)+a|0;if((D|0)>=(j|0))break;else D=D+1|0}D=a+o>>n;b[m+K>>0]=D>>>0<256?D:(D|0)>0?255:0;K=K+1|0}while((K|0)!=(h|0))}while(0);if(!d)break;else{s=s+4|0;m=m+e|0;d=d+-1|0}}return}}function Rta(a){a=a|0;YDc(a);return}function Sta(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tta(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Zta(a,c,d,e,h,i);f[a>>2]=59648;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function Uta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59624;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function Vta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59624;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Wta(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+n[a+72>>2];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;o=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)p=0;else{e=f[o>>2]|0;if(l)q=0;else{r=0;while(1){s=+n[h>>2];t=e+(r<<2)|0;u=i+s*+n[t+4>>2];v=i+s*+n[t+8>>2];w=i+s*+n[t+12>>2];n[b+(r<<2)>>2]=i+s*+n[t>>2];n[b+((r|1)<<2)>>2]=u;n[b+((r|2)<<2)>>2]=v;n[b+((r|3)<<2)>>2]=w;r=r+4|0;if((r|0)>(a|0)){p=m;break a}}}do{w=+n[h>>2];r=e+(q<<2)|0;v=i+w*+n[r+12>>2];u=i+w*+n[r+8>>2];s=i+w*+n[r+4>>2];x=i+w*+n[r>>2];r=1;do{t=(f[o+(r<<2)>>2]|0)+(q<<2)|0;w=+n[h+(r<<2)>>2];x=x+w*+n[t>>2];s=s+w*+n[t+4>>2];u=u+w*+n[t+8>>2];v=v+w*+n[t+12>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(q<<2)>>2]=x;n[b+((q|1)<<2)>>2]=s;n[b+((q|2)<<2)>>2]=u;n[b+((q|3)<<2)>>2]=v;q=q+4|0}while((q|0)<=(a|0));p=m}while(0);b:do if((p|0)<(g|0)){e=f[o>>2]|0;if(l)y=p;else{r=p;while(1){n[b+(r<<2)>>2]=i+ +n[h>>2]*+n[e+(r<<2)>>2];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +n[h>>2]*+n[e+(y<<2)>>2];r=1;do{w=w+ +n[h+(r<<2)>>2]*+n[(f[o+(r<<2)>>2]|0)+(y<<2)>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(y<<2)>>2]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{o=o+4|0;b=b+d|0}}return}function Xta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59624;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function Yta(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0;h=(f[a+4>>2]|0)/2|0;i=(f[a+28>>2]|0)+(h<<2)|0;j=(f[a+76>>2]&1|0)==0;k=+n[i>>2];l=+n[i+4>>2];i=l==1.0;m=k==2.0&i;o=k==-2.0&i;p=k!=0.0;q=p|i?p^1:l==-1.0;r=+n[a+72>>2];if(!e)return;a=l<0.0;p=g+-4|0;i=(g|0)<4;s=g&-4;t=c;c=b+(h<<2)|0;h=e;while(1){h=h+-1|0;e=f[c+-4>>2]|0;b=f[c>>2]|0;c=c+4|0;u=f[c>>2]|0;a:do if(j)if(q){v=a?u:e;w=a?e:u;if(i)x=0;else{y=w;z=v;A=0;do{B=A|1;C=r+(+n[y+(B<<2)>>2]-+n[z+(B<<2)>>2]);n[t+(A<<2)>>2]=r+(+n[y+(A<<2)>>2]-+n[z+(A<<2)>>2]);n[t+(B<<2)>>2]=C;B=A|2;D=A|3;C=r+(+n[y+(D<<2)>>2]-+n[z+(D<<2)>>2]);n[t+(B<<2)>>2]=r+(+n[y+(B<<2)>>2]-+n[z+(B<<2)>>2]);n[t+(D<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));x=s}if((x|0)>=(g|0))break;A=w;z=v;y=x;do{n[t+(y<<2)>>2]=r+(+n[A+(y<<2)>>2]-+n[z+(y<<2)>>2]);y=y+1|0}while((y|0)!=(g|0))}else{if(i)E=0;else{y=u;z=e;A=0;do{v=A|1;C=r+l*(+n[y+(v<<2)>>2]-+n[z+(v<<2)>>2]);n[t+(A<<2)>>2]=r+l*(+n[y+(A<<2)>>2]-+n[z+(A<<2)>>2]);n[t+(v<<2)>>2]=C;v=A|2;w=A|3;C=r+l*(+n[y+(w<<2)>>2]-+n[z+(w<<2)>>2]);n[t+(v<<2)>>2]=r+l*(+n[y+(v<<2)>>2]-+n[z+(v<<2)>>2]);n[t+(w<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));E=s}if((E|0)>=(g|0))break;A=u;z=e;y=E;do{n[t+(y<<2)>>2]=r+l*(+n[A+(y<<2)>>2]-+n[z+(y<<2)>>2]);y=y+1|0}while((y|0)!=(g|0))}else{if(m){if(i)F=0;else{y=e;z=u;A=0;do{w=A|1;C=r+(+n[z+(w<<2)>>2]+(+n[y+(w<<2)>>2]+ +n[b+(w<<2)>>2]*2.0));n[t+(A<<2)>>2]=r+(+n[z+(A<<2)>>2]+(+n[y+(A<<2)>>2]+ +n[b+(A<<2)>>2]*2.0));n[t+(w<<2)>>2]=C;w=A|2;v=A|3;C=r+(+n[z+(v<<2)>>2]+(+n[y+(v<<2)>>2]+ +n[b+(v<<2)>>2]*2.0));n[t+(w<<2)>>2]=r+(+n[z+(w<<2)>>2]+(+n[y+(w<<2)>>2]+ +n[b+(w<<2)>>2]*2.0));n[t+(v<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));F=s}if((F|0)>=(g|0))break;A=e;y=u;z=F;while(1){n[t+(z<<2)>>2]=r+(+n[y+(z<<2)>>2]+(+n[A+(z<<2)>>2]+ +n[b+(z<<2)>>2]*2.0));z=z+1|0;if((z|0)==(g|0))break a}}if(o){if(i)G=0;else{z=e;A=u;y=0;do{v=y|1;C=r+(+n[A+(v<<2)>>2]+(+n[z+(v<<2)>>2]-+n[b+(v<<2)>>2]*2.0));n[t+(y<<2)>>2]=r+(+n[A+(y<<2)>>2]+(+n[z+(y<<2)>>2]-+n[b+(y<<2)>>2]*2.0));n[t+(v<<2)>>2]=C;v=y|2;w=y|3;C=r+(+n[A+(w<<2)>>2]+(+n[z+(w<<2)>>2]-+n[b+(w<<2)>>2]*2.0));n[t+(v<<2)>>2]=r+(+n[A+(v<<2)>>2]+(+n[z+(v<<2)>>2]-+n[b+(v<<2)>>2]*2.0));n[t+(w<<2)>>2]=C;y=y+4|0}while((y|0)<=(p|0));G=s}if((G|0)>=(g|0))break;y=e;z=u;A=G;do{n[t+(A<<2)>>2]=r+(+n[z+(A<<2)>>2]+(+n[y+(A<<2)>>2]-+n[b+(A<<2)>>2]*2.0));A=A+1|0}while((A|0)!=(g|0))}else{if(i)H=0;else{A=e;y=u;z=0;do{w=z|1;C=r+(l*(+n[A+(w<<2)>>2]+ +n[y+(w<<2)>>2])+k*+n[b+(w<<2)>>2]);n[t+(z<<2)>>2]=r+(l*(+n[A+(z<<2)>>2]+ +n[y+(z<<2)>>2])+k*+n[b+(z<<2)>>2]);n[t+(w<<2)>>2]=C;w=z|2;v=z|3;C=r+(l*(+n[A+(v<<2)>>2]+ +n[y+(v<<2)>>2])+k*+n[b+(v<<2)>>2]);n[t+(w<<2)>>2]=r+(l*(+n[A+(w<<2)>>2]+ +n[y+(w<<2)>>2])+k*+n[b+(w<<2)>>2]);n[t+(v<<2)>>2]=C;z=z+4|0}while((z|0)<=(p|0));H=s}if((H|0)>=(g|0))break;z=e;y=u;A=H;do{n[t+(A<<2)>>2]=r+(l*(+n[z+(A<<2)>>2]+ +n[y+(A<<2)>>2])+k*+n[b+(A<<2)>>2]);A=A+1|0}while((A|0)!=(g|0))}}while(0);if(!h)break;else t=t+d|0}return}function Zta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59624;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){_S(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)ZS(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;A=g+4|0;f[A>>2]=0;B=tT(g,77)|0;p=B;C=278074;q=p+77|0;do{b[p>>0]=b[C>>0]|0;p=p+1|0;C=C+1|0}while((p|0)<(q|0));z5(-215,g,278152,274199,3251)}}function _ta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59624;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function $ta(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=+n[a+72>>2];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+76>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;o=(h|0)<2;p=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(o){u=0;while(1){n[q+(u<<2)>>2]=k;n[q+((u|1)<<2)>>2]=k;n[q+((u|2)<<2)>>2]=k;n[q+((u|3)<<2)>>2]=k;u=u+4|0;if((u|0)>(a|0)){t=p;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<2)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<2)|0;C=+n[j+(u<<2)>>2];z=z+C*(+n[A>>2]-+n[B>>2]);y=y+C*(+n[A+4>>2]-+n[B+4>>2]);x=x+C*(+n[A+8>>2]-+n[B+8>>2]);w=w+C*(+n[A+12>>2]-+n[B+12>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(v<<2)>>2]=z;n[q+((v|1)<<2)>>2]=y;n[q+((v|2)<<2)>>2]=x;n[q+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(a|0));t=p}while(0);b:do if((t|0)<(g|0)){if(o){u=t;while(1){n[q+(u<<2)>>2]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +n[j+(u<<2)>>2]*(+n[(f[r+(u<<2)>>2]|0)+(D<<2)>>2]-+n[(f[r+(0-u<<2)>>2]|0)+(D<<2)>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+n[j>>2];t=b+(D<<2)|0;x=k+w*+n[t+4>>2];y=k+w*+n[t+8>>2];z=k+w*+n[t+12>>2];n[l+(D<<2)>>2]=k+w*+n[t>>2];n[l+((D|1)<<2)>>2]=x;n[l+((D|2)<<2)>>2]=y;n[l+((D|3)<<2)>>2]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+n[j>>2];D=b+(F<<2)|0;y=k+z*+n[D+12>>2];x=k+z*+n[D+8>>2];w=k+z*+n[D+4>>2];G=k+z*+n[D>>2];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<2)|0;o=(f[q+(0-D<<2)>>2]|0)+(F<<2)|0;z=+n[j+(D<<2)>>2];G=G+z*(+n[t>>2]+ +n[o>>2]);w=w+z*(+n[t+4>>2]+ +n[o+4>>2]);x=x+z*(+n[t+8>>2]+ +n[o+8>>2]);y=y+z*(+n[t+12>>2]+ +n[o+12>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(F<<2)>>2]=G;n[l+((F|1)<<2)>>2]=w;n[l+((F|2)<<2)>>2]=x;n[l+((F|3)<<2)>>2]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){n[l+(D<<2)>>2]=k+ +n[j>>2]*+n[b+(D<<2)>>2];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +n[j>>2]*+n[b+(H<<2)>>2];D=1;while(1){C=C+ +n[j+(D<<2)>>2]*(+n[(f[q+(D<<2)>>2]|0)+(H<<2)>>2]+ +n[(f[q+(0-D<<2)>>2]|0)+(H<<2)>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(H<<2)>>2]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function aua(a){a=a|0;YDc(a);return}function bua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function cua(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;iua(a,c,d,e,h,i);f[a>>2]=59720;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;g=tT(k,64)|0;a=277020;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));z5(-215,k,277085,274199,3314)}else{u=j;return}}function dua(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59696;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;g0(b);return}function eua(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59696;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function fua(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+72>>2]|0;k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)p=0;else{g=f[i>>2]|0;q=f[o>>2]|0;if(m)r=0;else{s=0;while(1){t=q+(s<<2)|0;u=(Y(f[t>>2]|0,g)|0)+j|0;v=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;x=(Y(f[t+12>>2]|0,g)|0)+j|0;d[b+(s<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[b+((s|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((s|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((s|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;s=s+4|0;if((s|0)>(a|0)){p=n;break a}}}do{s=q+(r<<2)|0;x=(Y(f[s>>2]|0,g)|0)+j|0;w=(Y(f[s+4>>2]|0,g)|0)+j|0;v=(Y(f[s+8>>2]|0,g)|0)+j|0;u=(Y(f[s+12>>2]|0,g)|0)+j|0;s=v;v=w;w=x;x=1;do{t=(f[o+(x<<2)>>2]|0)+(r<<2)|0;y=f[i+(x<<2)>>2]|0;w=(Y(f[t>>2]|0,y)|0)+w|0;v=(Y(f[t+4>>2]|0,y)|0)+v|0;s=(Y(f[t+8>>2]|0,y)|0)+s|0;u=(Y(f[t+12>>2]|0,y)|0)+u|0;x=x+1|0}while((x|0)!=(k|0));d[b+(r<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((r|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((r|2)<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+((r|3)<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;r=r+4|0}while((r|0)<=(a|0));p=n}while(0);b:do if((p|0)<(h|0)){g=f[i>>2]|0;q=f[o>>2]|0;if(m)z=p;else{x=p;while(1){y=(Y(f[q+(x<<2)>>2]|0,g)|0)+j|0;d[b+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}do{x=(Y(f[q+(z<<2)>>2]|0,g)|0)+j|0;y=1;do{x=(Y(f[(f[o+(y<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(y<<2)>>2]|0)|0)+x|0;y=y+1|0}while((y|0)!=(k|0));d[b+(z<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function gua(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59696;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function hua(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=(f[a+4>>2]|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=(f[a+76>>2]&1|0)==0;l=f[j>>2]|0;m=f[j+4>>2]|0;j=(m|0)==1;n=(l|0)==2&j;o=(l|0)==-2&j;p=(l|0)==0&(j|(m|0)==-1);j=f[a+72>>2]|0;if(!g)return;a=(m|0)<0;q=h+-4|0;r=(h|0)<4;s=h&-4;t=c;c=b+(i<<2)|0;i=g;while(1){i=i+-1|0;g=f[c+-4>>2]|0;b=f[c>>2]|0;c=c+4|0;u=f[c>>2]|0;a:do if(k)if(p){v=a?u:g;w=a?g:u;if(r)x=0;else{y=w;z=v;A=0;do{B=(f[y+(A<<2)>>2]|0)-(f[z+(A<<2)>>2]|0)+j|0;C=A|1;D=(f[y+(C<<2)>>2]|0)-(f[z+(C<<2)>>2]|0)+j|0;d[t+(A<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(C<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;D=A|2;C=(f[y+(D<<2)>>2]|0)-(f[z+(D<<2)>>2]|0)+j|0;B=A|3;E=(f[y+(B<<2)>>2]|0)-(f[z+(B<<2)>>2]|0)+j|0;d[t+(D<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;d[t+(B<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));x=s}if((x|0)>=(h|0))break;A=w;z=v;y=x;do{E=(f[A+(y<<2)>>2]|0)-(f[z+(y<<2)>>2]|0)+j|0;d[t+(y<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(r)F=0;else{y=u;z=g;A=0;do{v=(Y((f[y+(A<<2)>>2]|0)-(f[z+(A<<2)>>2]|0)|0,m)|0)+j|0;w=A|1;E=(Y((f[y+(w<<2)>>2]|0)-(f[z+(w<<2)>>2]|0)|0,m)|0)+j|0;d[t+(A<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[t+(w<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;E=A|2;w=(Y((f[y+(E<<2)>>2]|0)-(f[z+(E<<2)>>2]|0)|0,m)|0)+j|0;v=A|3;B=(Y((f[y+(v<<2)>>2]|0)-(f[z+(v<<2)>>2]|0)|0,m)|0)+j|0;d[t+(E<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[t+(v<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));F=s}if((F|0)>=(h|0))break;A=u;z=g;y=F;do{B=(Y((f[A+(y<<2)>>2]|0)-(f[z+(y<<2)>>2]|0)|0,m)|0)+j|0;d[t+(y<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(n){if(r)G=0;else{y=g;z=u;A=0;do{B=(f[y+(A<<2)>>2]|0)+j+(f[b+(A<<2)>>2]<<1)+(f[z+(A<<2)>>2]|0)|0;v=A|1;w=(f[y+(v<<2)>>2]|0)+j+(f[b+(v<<2)>>2]<<1)+(f[z+(v<<2)>>2]|0)|0;d[t+(A<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(v<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;w=A|2;v=(f[y+(w<<2)>>2]|0)+j+(f[b+(w<<2)>>2]<<1)+(f[z+(w<<2)>>2]|0)|0;B=A|3;E=(f[y+(B<<2)>>2]|0)+j+(f[b+(B<<2)>>2]<<1)+(f[z+(B<<2)>>2]|0)|0;d[t+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[t+(B<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));G=s}if((G|0)>=(h|0))break;A=g;z=u;y=G;while(1){E=(f[A+(y<<2)>>2]|0)+j+(f[b+(y<<2)>>2]<<1)+(f[z+(y<<2)>>2]|0)|0;d[t+(y<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;y=y+1|0;if((y|0)==(h|0))break a}}if(o){if(r)H=0;else{y=g;z=u;A=0;do{E=(f[y+(A<<2)>>2]|0)+j-(f[b+(A<<2)>>2]<<1)+(f[z+(A<<2)>>2]|0)|0;B=A|1;v=(f[y+(B<<2)>>2]|0)+j-(f[b+(B<<2)>>2]<<1)+(f[z+(B<<2)>>2]|0)|0;d[t+(A<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(B<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;v=A|2;B=(f[y+(v<<2)>>2]|0)+j-(f[b+(v<<2)>>2]<<1)+(f[z+(v<<2)>>2]|0)|0;E=A|3;w=(f[y+(E<<2)>>2]|0)+j-(f[b+(E<<2)>>2]<<1)+(f[z+(E<<2)>>2]|0)|0;d[t+(v<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(E<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));H=s}if((H|0)>=(h|0))break;A=g;z=u;y=H;do{w=(f[A+(y<<2)>>2]|0)+j-(f[b+(y<<2)>>2]<<1)+(f[z+(y<<2)>>2]|0)|0;d[t+(y<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(r)I=0;else{y=g;z=u;A=0;do{w=Y((f[z+(A<<2)>>2]|0)+(f[y+(A<<2)>>2]|0)|0,m)|0;E=(Y(f[b+(A<<2)>>2]|0,l)|0)+j+w|0;w=A|1;B=Y((f[z+(w<<2)>>2]|0)+(f[y+(w<<2)>>2]|0)|0,m)|0;v=(Y(f[b+(w<<2)>>2]|0,l)|0)+j+B|0;d[t+(A<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;v=A|2;w=Y((f[z+(v<<2)>>2]|0)+(f[y+(v<<2)>>2]|0)|0,m)|0;E=(Y(f[b+(v<<2)>>2]|0,l)|0)+j+w|0;w=A|3;B=Y((f[z+(w<<2)>>2]|0)+(f[y+(w<<2)>>2]|0)|0,m)|0;C=(Y(f[b+(w<<2)>>2]|0,l)|0)+j+B|0;d[t+(v<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(w<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));I=s}if((I|0)>=(h|0))break;A=g;y=u;z=I;do{C=Y((f[y+(z<<2)>>2]|0)+(f[A+(z<<2)>>2]|0)|0,m)|0;w=(Y(f[b+(z<<2)>>2]|0,l)|0)+j+C|0;d[t+(z<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}}while(0);if(!i)break;else t=t+e|0}return}function iua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=59696;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+60|0;r=a+56|0;f[r>>2]=q;f[q>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){q=c+36|0;s=f[q>>2]|0;if(s){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1;t=a+48|0;s=f[t>>2]|0;if((s|0)!=0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){_S(k);w=t}else w=t}else w=a+48|0;f[w>>2]=0;t=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){s=f[n>>2]|0;n=0;do{f[s+(n<<2)>>2]=0;n=n+1|0;x=f[l>>2]|0}while((n|0)<(x|0));f[k>>2]=f[c>>2];if((x|0)<3)y=13;else y=15}else{f[k>>2]=f[c>>2];y=13}if((y|0)==13){x=f[c+4>>2]|0;if((x|0)<3){f[l>>2]=x;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];x=f[c+44>>2]|0;l=f[r>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2]}else y=15}if((y|0)==15)ZS(k,c);f[t>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[w>>2]=f[q>>2]}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;h_(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;j=nrc(e)|0;f[a+72>>2]=j;if((f[k>>2]&4095|0)!=4){f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,77)|0;o=A;B=278074;p=o+77|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));z5(-215,g,278152,274199,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,77)|0;o=A;B=278074;p=o+77|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));z5(-215,g,278152,274199,3251)}}function jua(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59696;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function kua(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+72>>2]|0;m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(!(f[a+76>>2]&1)){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;p=h&-4;q=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;r=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;s=c;t=m;u=b;while(1){a:do if(g)v=0;else{if(o){w=0;while(1){d[s+(w<<1)>>1]=r;d[s+((w|1)<<1)>>1]=r;d[s+((w|2)<<1)>>1]=r;d[s+((w|3)<<1)>>1]=r;w=w+4|0;if((w|0)>(a|0)){v=p;break a}}}else x=0;do{w=l;y=l;z=l;A=l;B=1;while(1){C=(f[t+(B<<2)>>2]|0)+(x<<2)|0;D=(f[t+(0-B<<2)>>2]|0)+(x<<2)|0;E=f[k+(B<<2)>>2]|0;A=(Y((f[C>>2]|0)-(f[D>>2]|0)|0,E)|0)+A|0;z=(Y((f[C+4>>2]|0)-(f[D+4>>2]|0)|0,E)|0)+z|0;y=(Y((f[C+8>>2]|0)-(f[D+8>>2]|0)|0,E)|0)+y|0;w=(Y((f[C+12>>2]|0)-(f[D+12>>2]|0)|0,E)|0)+w|0;if((B|0)>=(j|0))break;else B=B+1|0}d[s+(x<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;d[s+((x|1)<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[s+((x|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[s+((x|3)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;x=x+4|0}while((x|0)<=(a|0));v=p}while(0);b:do if((v|0)<(h|0)){if(o){B=v;while(1){d[s+(B<<1)>>1]=q;B=B+1|0;if((B|0)==(h|0))break b}}else F=v;do{B=l;E=1;while(1){B=(Y((f[(f[t+(E<<2)>>2]|0)+(F<<2)>>2]|0)-(f[(f[t+(0-E<<2)>>2]|0)+(F<<2)>>2]|0)|0,f[k+(E<<2)>>2]|0)|0)+B|0;if((E|0)>=(j|0))break;else E=E+1|0}d[s+(F<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;F=F+1|0}while((F|0)!=(h|0))}while(0);if(!u)break;else{s=s+e|0;t=t+4|0;u=u+-1|0}}return}else{if(n)return;n=h+-4|0;u=(h|0)<4;t=(i|0)<2;i=h&-4;s=m;m=c;c=b;while(1){c:do if(u)G=0;else{b=f[k>>2]|0;F=f[s>>2]|0;if(t){v=0;while(1){q=F+(v<<2)|0;o=(Y(f[q>>2]|0,b)|0)+l|0;p=(Y(f[q+4>>2]|0,b)|0)+l|0;a=(Y(f[q+8>>2]|0,b)|0)+l|0;x=(Y(f[q+12>>2]|0,b)|0)+l|0;d[m+(v<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[m+((v|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((v|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((v|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;v=v+4|0;if((v|0)>(n|0)){G=i;break c}}}else H=0;do{v=F+(H<<2)|0;x=(Y(f[v>>2]|0,b)|0)+l|0;a=(Y(f[v+4>>2]|0,b)|0)+l|0;p=(Y(f[v+8>>2]|0,b)|0)+l|0;o=(Y(f[v+12>>2]|0,b)|0)+l|0;v=p;p=a;a=x;x=1;while(1){q=(f[s+(x<<2)>>2]|0)+(H<<2)|0;r=(f[s+(0-x<<2)>>2]|0)+(H<<2)|0;g=f[k+(x<<2)>>2]|0;a=(Y((f[r>>2]|0)+(f[q>>2]|0)|0,g)|0)+a|0;p=(Y((f[r+4>>2]|0)+(f[q+4>>2]|0)|0,g)|0)+p|0;v=(Y((f[r+8>>2]|0)+(f[q+8>>2]|0)|0,g)|0)+v|0;o=(Y((f[r+12>>2]|0)+(f[q+12>>2]|0)|0,g)|0)+o|0;if((x|0)>=(j|0))break;else x=x+1|0}d[m+(H<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((H|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((H|2)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[m+((H|3)<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;H=H+4|0}while((H|0)<=(n|0));G=i}while(0);d:do if((G|0)<(h|0)){b=f[k>>2]|0;F=f[s>>2]|0;if(t){x=G;while(1){B=(Y(f[F+(x<<2)>>2]|0,b)|0)+l|0;d[m+(x<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break d}}else I=G;do{x=(Y(f[F+(I<<2)>>2]|0,b)|0)+l|0;B=1;while(1){x=(Y((f[(f[s+(0-B<<2)>>2]|0)+(I<<2)>>2]|0)+(f[(f[s+(B<<2)>>2]|0)+(I<<2)>>2]|0)|0,f[k+(B<<2)>>2]|0)|0)+x|0;if((B|0)>=(j|0))break;else B=B+1|0}d[m+(I<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!c)break;else{s=s+4|0;m=m+e|0;c=c+-1|0}}return}}function lua(a){a=a|0;YDc(a);return}function mua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nua(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=59576;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){YDc(a);return}g0(b);YDc(a);return}function oua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=(f[a+4>>2]|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=(f[a+84>>2]&1|0)==0;l=f[j>>2]|0;m=f[j+4>>2]|0;j=(m|0)==1;n=(l|0)==2&j;o=(l|0)==-2&j;p=(l|0)==0&(j|(m|0)==-1);j=a+68|0;q=f[j>>2]|0;if(!g)return;r=(m|0)<0;s=h+-4|0;t=(h|0)<4;u=(f[j+4>>2]|0)+(f[a+80>>2]|0)|0;a=h&-4;j=d;d=c+(i<<2)|0;i=g;while(1){i=i+-1|0;g=f[d+-4>>2]|0;c=f[d>>2]|0;d=d+4|0;v=f[d>>2]|0;a:do if(k)if(p){w=r?v:g;x=r?g:v;if(t)y=0;else{z=x;A=w;B=0;do{C=B|1;D=f[z+(C<<2)>>2]|0;E=f[A+(C<<2)>>2]|0;F=u+(f[z+(B<<2)>>2]|0)-(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=F>>>0<256?F:(F|0)>0?255:0;F=u+D-E>>q;b[j+C>>0]=F>>>0<256?F:(F|0)>0?255:0;F=B|2;C=B|3;E=f[z+(C<<2)>>2]|0;D=f[A+(C<<2)>>2]|0;G=u+(f[z+(F<<2)>>2]|0)-(f[A+(F<<2)>>2]|0)>>q;b[j+F>>0]=G>>>0<256?G:(G|0)>0?255:0;G=u+E-D>>q;b[j+C>>0]=G>>>0<256?G:(G|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));y=a}if((y|0)>=(h|0))break;B=x;A=w;z=y;do{G=u+(f[B+(z<<2)>>2]|0)-(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=G>>>0<256?G:(G|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(t)H=0;else{z=v;A=g;B=0;do{w=Y((f[z+(B<<2)>>2]|0)-(f[A+(B<<2)>>2]|0)|0,m)|0;x=B|1;G=Y((f[z+(x<<2)>>2]|0)-(f[A+(x<<2)>>2]|0)|0,m)|0;C=u+w>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+G>>q;b[j+x>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;x=Y((f[z+(C<<2)>>2]|0)-(f[A+(C<<2)>>2]|0)|0,m)|0;G=B|3;w=Y((f[z+(G<<2)>>2]|0)-(f[A+(G<<2)>>2]|0)|0,m)|0;D=u+x>>q;b[j+C>>0]=D>>>0<256?D:(D|0)>0?255:0;D=u+w>>q;b[j+G>>0]=D>>>0<256?D:(D|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));H=a}if((H|0)>=(h|0))break;B=v;A=g;z=H;do{D=u+(Y((f[B+(z<<2)>>2]|0)-(f[A+(z<<2)>>2]|0)|0,m)|0)>>q;b[j+z>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(n){if(t)I=0;else{z=g;A=v;B=0;do{D=B|1;G=f[z+(D<<2)>>2]|0;w=f[c+(D<<2)>>2]<<1;C=f[A+(D<<2)>>2]|0;x=u+(f[z+(B<<2)>>2]|0)+(f[c+(B<<2)>>2]<<1)+(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=x>>>0<256?x:(x|0)>0?255:0;x=u+G+w+C>>q;b[j+D>>0]=x>>>0<256?x:(x|0)>0?255:0;x=B|2;D=B|3;C=f[z+(D<<2)>>2]|0;w=f[c+(D<<2)>>2]<<1;G=f[A+(D<<2)>>2]|0;E=u+(f[z+(x<<2)>>2]|0)+(f[c+(x<<2)>>2]<<1)+(f[A+(x<<2)>>2]|0)>>q;b[j+x>>0]=E>>>0<256?E:(E|0)>0?255:0;E=u+C+w+G>>q;b[j+D>>0]=E>>>0<256?E:(E|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));I=a}if((I|0)>=(h|0))break;B=g;A=v;z=I;while(1){E=u+(f[B+(z<<2)>>2]|0)+(f[c+(z<<2)>>2]<<1)+(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=E>>>0<256?E:(E|0)>0?255:0;z=z+1|0;if((z|0)==(h|0))break a}}if(o){if(t)J=0;else{z=g;A=v;B=0;do{E=B|1;D=f[z+(E<<2)>>2]|0;G=f[c+(E<<2)>>2]<<1;w=f[A+(E<<2)>>2]|0;C=u+(f[z+(B<<2)>>2]|0)-(f[c+(B<<2)>>2]<<1)+(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+D-G+w>>q;b[j+E>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;E=B|3;w=f[z+(E<<2)>>2]|0;G=f[c+(E<<2)>>2]<<1;D=f[A+(E<<2)>>2]|0;x=u+(f[z+(C<<2)>>2]|0)-(f[c+(C<<2)>>2]<<1)+(f[A+(C<<2)>>2]|0)>>q;b[j+C>>0]=x>>>0<256?x:(x|0)>0?255:0;x=u+w-G+D>>q;b[j+E>>0]=x>>>0<256?x:(x|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));J=a}if((J|0)>=(h|0))break;B=g;A=v;z=J;do{x=u+(f[B+(z<<2)>>2]|0)-(f[c+(z<<2)>>2]<<1)+(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=x>>>0<256?x:(x|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(t)K=0;else{z=g;A=v;B=0;do{x=Y((f[A+(B<<2)>>2]|0)+(f[z+(B<<2)>>2]|0)|0,m)|0;E=Y(f[c+(B<<2)>>2]|0,l)|0;D=B|1;G=Y((f[A+(D<<2)>>2]|0)+(f[z+(D<<2)>>2]|0)|0,m)|0;w=Y(f[c+(D<<2)>>2]|0,l)|0;C=u+E+x>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+w+G>>q;b[j+D>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;D=Y((f[A+(C<<2)>>2]|0)+(f[z+(C<<2)>>2]|0)|0,m)|0;G=Y(f[c+(C<<2)>>2]|0,l)|0;w=B|3;x=Y((f[A+(w<<2)>>2]|0)+(f[z+(w<<2)>>2]|0)|0,m)|0;E=Y(f[c+(w<<2)>>2]|0,l)|0;F=u+G+D>>q;b[j+C>>0]=F>>>0<256?F:(F|0)>0?255:0;F=u+E+x>>q;b[j+w>>0]=F>>>0<256?F:(F|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));K=a}if((K|0)>=(h|0))break;B=g;z=v;A=K;do{F=Y((f[z+(A<<2)>>2]|0)+(f[B+(A<<2)>>2]|0)|0,m)|0;w=u+(Y(f[c+(A<<2)>>2]|0,l)|0)+F>>q;b[j+A>>0]=w>>>0<256?w:(w|0)>0?255:0;A=A+1|0}while((A|0)!=(h|0))}}while(0);if(!i)break;else j=j+e|0}return}function pua(a){a=a|0;YDc(a);return}function qua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rua(a){a=a|0;YDc(a);return}function sua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tua(a){a=a|0;YDc(a);return}function uua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function vua(a){a=a|0;YDc(a);return}function wua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xua(a){a=a|0;YDc(a);return}function yua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zua(a){a=a|0;YDc(a);return}function Aua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Bua(a){a=a|0;YDc(a);return}function Cua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Dua(a){a=a|0;YDc(a);return}function Eua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fua(a){a=a|0;YDc(a);return}function Gua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Hua(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0;m=u;u=u+288|0;n=m+232|0;o=m+176|0;p=m+120|0;q=m+112|0;r=m+104|0;s=m+48|0;t=m+32|0;v=m+16|0;w=m;do if((d$(e)|0)==65536){x=f[e+4>>2]|0;f[n>>2]=f[x>>2];y=n+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[x+8>>2];f[n+12>>2]=f[x+12>>2];f[n+16>>2]=f[x+16>>2];f[n+20>>2]=f[x+20>>2];f[n+24>>2]=f[x+24>>2];f[n+28>>2]=f[x+28>>2];f[n+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;ZS(n,x);break}}else a$(n,e,-1);while(0);do if((d$(g)|0)==65536){e=f[g+4>>2]|0;f[o>>2]=f[e>>2];x=o+4|0;y=e+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];f[o+16>>2]=f[e+16>>2];f[o+20>>2]=f[e+20>>2];f[o+24>>2]=f[e+24>>2];f[o+28>>2]=f[e+28>>2];f[o+32>>2]=f[e+32>>2];A=f[e+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;C=o+44|0;f[C>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[e+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(o,e);break}}else a$(o,g,-1);while(0);g=c&4095;e=d&4095;x=c&7;y=d&7;z=c>>>3&511;if((z|0)!=(d>>>3&511|0)){f[p>>2]=0;f[p+4>>2]=0;D=tT(p,25)|0;d=281090;E=D+25|0;do{b[D>>0]=b[d>>0]|0;D=D+1|0;d=d+1|0}while((D|0)<(E|0));z5(-215,p,281116,274199,3755)}d=n+8|0;c=o+8|0;C=o+12|0;A=(f[c>>2]|0)+-1+(f[C>>2]|0)|0;B=f[h>>2]|0;if((B|0)<0){F=((f[d>>2]|0)+-1+(f[n+12>>2]|0)|0)/2|0;f[h>>2]=F;G=F}else G=B;B=h+4|0;if((f[B>>2]|0)<0)f[B>>2]=(A|0)/2|0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;A=(f[d>>2]|0)==1;f[q>>2]=A?G:0;f[q+4>>2]=A?0:G;G=Fqa(p,q)|0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=o;q=(f[c>>2]|0)==1;A=f[B>>2]|0;f[r>>2]=q?A:0;f[r+4>>2]=q?0:A;A=Fqa(p,r)|0;f[p>>2]=1124007936;r=p+4|0;q=p+8|0;F=p+40|0;D=r;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[F>>2]=q;H=p+48|0;I=p+44|0;f[I>>2]=H;f[H>>2]=0;f[p+52>>2]=0;f[s>>2]=1124007936;J=s+4|0;K=s+8|0;L=s+40|0;D=J;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[L>>2]=K;D=s+48|0;E=s+44|0;f[E>>2]=D;f[D>>2]=0;f[s+52>>2]=0;M=x>>>0<y>>>0?y:x;N=(M|0)>5?M:5;do if(!x){M=(y|0)==0;if(!((G|0)==5&(A|0)==5&M)){if((G&3|0)==0|(A&3|0)==0){O=26;break}if(!((G&8&A|0)!=0&(y|0)==3)){O=26;break}}P=M?8:0;M=t+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;Q=+(1<<P|0);LZ(n,t,4,Q,0.0);M=t+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=s;LZ(o,t,4,Q,0.0);M=P<<1;R=M;S=4;T=+(1<<M|0)*i}else O=26;while(0);do if((O|0)==26){if((f[n>>2]&4095|0)==(N|0)){y=n+36|0;x=f[y>>2]|0;if(x){M=x+12|0;f[M>>2]=(f[M>>2]|0)+1;M=p+36|0;x=f[M>>2]|0;if((x|0)!=0?(P=x+12|0,x=f[P>>2]|0,f[P>>2]=x+-1,(x|0)==1):0){_S(p);U=M}else U=M}else U=p+36|0;f[U>>2]=0;M=p+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[r>>2]|0)>0){x=f[F>>2]|0;P=0;do{f[x+(P<<2)>>2]=0;P=P+1|0;V=f[r>>2]|0}while((P|0)<(V|0));f[p>>2]=f[n>>2];if((V|0)<3)O=38;else O=40}else{f[p>>2]=f[n>>2];O=38}if((O|0)==38){P=f[n+4>>2]|0;if((P|0)<3){f[r>>2]=P;f[q>>2]=f[d>>2];f[p+12>>2]=f[n+12>>2];P=f[n+44>>2]|0;x=f[I>>2]|0;f[x>>2]=f[P>>2];f[x+4>>2]=f[P+4>>2]}else O=40}if((O|0)==40)ZS(p,n);f[M>>2]=f[n+16>>2];f[p+20>>2]=f[n+20>>2];f[p+24>>2]=f[n+24>>2];f[p+28>>2]=f[n+28>>2];f[p+32>>2]=f[n+32>>2];f[U>>2]=f[y>>2]}else{P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;LZ(n,t,N,1.0,0.0)}if((f[o>>2]&4095|0)!=(N|0)){P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=s;LZ(o,t,N,1.0,0.0);R=0;S=N;T=i;break}P=o+36|0;x=f[P>>2]|0;if(x|0){W=x+12|0;f[W>>2]=(f[W>>2]|0)+1}W=s+36|0;x=f[W>>2]|0;if(x|0?(X=x+12|0,x=f[X>>2]|0,f[X>>2]=x+-1,(x|0)==1):0)_S(s);f[W>>2]=0;x=s+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[J>>2]|0)>0){X=f[L>>2]|0;Y=0;do{f[X+(Y<<2)>>2]=0;Y=Y+1|0;Z=f[J>>2]|0}while((Y|0)<(Z|0));f[s>>2]=f[o>>2];if((Z|0)<3)O=54;else O=56}else{f[s>>2]=f[o>>2];O=54}if((O|0)==54){Y=f[o+4>>2]|0;if((Y|0)<3){f[J>>2]=Y;f[K>>2]=f[c>>2];f[s+12>>2]=f[C>>2];Y=f[o+44>>2]|0;X=f[E>>2]|0;f[X>>2]=f[Y>>2];f[X+4>>2]=f[Y+4>>2]}else O=56}if((O|0)==56)ZS(s,o);f[x>>2]=f[o+16>>2];f[s+20>>2]=f[o+20>>2];f[s+24>>2]=f[o+24>>2];f[s+28>>2]=f[o+28>>2];f[s+32>>2]=f[o+32>>2];f[W>>2]=f[P>>2];R=0;S=N;T=i}while(0);N=S&7|z<<3;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=p;Gqa(t,g,N,v,f[h>>2]|0,G);f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=s;dsa(v,N,e,w,f[B>>2]|0,A,T,R);R=VDc(200)|0;f[w>>2]=0;f[w+4>>2]=0;Dqa(R,w,t,v,g,e,N,j,k,l);l=VDc(16)|0;f[l+4>>2]=1;f[l>>2]=56396;f[l+8>>2]=R;f[a>>2]=l;f[a+4>>2]=R;R=f[v>>2]|0;if(R|0?(v=R+4|0,a=f[v>>2]|0,f[v>>2]=a+-1,(a|0)==1):0)Yi[f[(f[R>>2]|0)+8>>2]&2047](R);R=f[t>>2]|0;if(R|0?(t=R+4|0,a=f[t>>2]|0,f[t>>2]=a+-1,(a|0)==1):0)Yi[f[(f[R>>2]|0)+8>>2]&2047](R);R=s+36|0;a=f[R>>2]|0;if(a|0?(t=a+12|0,a=f[t>>2]|0,f[t>>2]=a+-1,(a|0)==1):0)_S(s);f[R>>2]=0;R=s+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[J>>2]|0)>0){R=f[L>>2]|0;L=0;do{f[R+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[J>>2]|0))}J=f[E>>2]|0;if((J|0)!=(D|0))g0(J);J=p+36|0;D=f[J>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)_S(p);f[J>>2]=0;J=p+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[r>>2]|0)>0){J=f[F>>2]|0;F=0;do{f[J+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[r>>2]|0))}r=f[I>>2]|0;if((r|0)!=(H|0))g0(r);r=o+36|0;H=f[r>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)_S(o);f[r>>2]=0;r=o+16|0;H=o+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[H>>2]|0)>0){r=f[o+40>>2]|0;I=0;do{f[r+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[H>>2]|0))}H=f[o+44>>2]|0;if((H|0)!=(o+48|0))g0(H);H=n+36|0;o=f[H>>2]|0;if(o|0?(I=o+12|0,o=f[I>>2]|0,f[I>>2]=o+-1,(o|0)==1):0)_S(n);f[H>>2]=0;H=n+16|0;o=n+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[o>>2]|0)>0){H=f[n+40>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)==(n+48|0)){u=m;return}g0(o);u=m;return}function Iua(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0;e=u;u=u+16|0;g=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;h=N2(g)|0;i=f[a>>2]|0;j=(h|0)==0?1:h;h=i&65535;switch(h&4095){case 0:case 4:case 5:case 6:break;default:{f[g>>2]=0;f[g+4>>2]=0;k=tT(g,71)|0;l=281144;m=k+71|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,g,281216,274199,3822)}}g=c+4|0;l=f[g>>2]|0;k=f[c>>2]|0;m=l-k>>3;o=k;k=l;if(j>>>0<=m>>>0){if(j>>>0<m>>>0?(l=o+(j<<3)|0,(k|0)!=(l|0)):0)f[g>>2]=k+(~((k+-8-l|0)>>>3)<<3)}else Jua(c,j-m|0);m=Y((i>>>3&511)+1<<(47696>>>(i<<1&14)&3),j)|0;j=d+4|0;i=f[j>>2]|0;l=f[d>>2]|0;k=i-l|0;g=l;l=i;if(m>>>0<=k>>>0)if(m>>>0<k>>>0?(i=g+m|0,(l|0)!=(i|0)):0){f[j>>2]=i;q=g}else q=g;else{y$(d,m-k|0);q=f[d>>2]|0}d=a+8|0;if((f[d>>2]|0)<=0){u=e;return}k=a+16|0;m=a+44|0;g=a+12|0;a=(h&4095)==0;i=0;j=0;l=f[g>>2]|0;while(1){o=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,i)|0)|0;a:do if((l|0)>0){if(a){r=0;s=j;t=l;while(1){v=b[o+r>>0]|0;if(!(v<<24>>24)){w=s;x=t}else{y=f[c>>2]|0;f[y+(s<<3)>>2]=r;f[y+(s<<3)+4>>2]=i;b[q+s>>0]=v;w=s+1|0;x=f[g>>2]|0}r=r+1|0;if((r|0)>=(x|0)){z=w;A=x;break a}else{s=w;t=x}}}t=f[c>>2]|0;s=0;r=j;v=l;while(1){switch(h&4095){case 5:{B=+n[o+(s<<2)>>2];if(B==0.0){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=i;n[q+(r<<2)>>2]=B;C=r+1|0;D=v}break}case 4:{y=f[o+(s<<2)>>2]|0;if(!y){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=i;f[q+(r<<2)>>2]=y;C=r+1|0;D=f[g>>2]|0}break}default:{B=+p[o+(s<<3)>>3];if(B==0.0){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=i;p[q+(r<<3)>>3]=B;C=r+1|0;D=v}}}s=s+1|0;if((s|0)>=(D|0)){z=C;A=D;break a}else{r=C;v=D}}}else{z=j;A=l}while(0);i=i+1|0;if((i|0)>=(f[d>>2]|0))break;else{j=z;l=A}}u=e;return}function Jua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){XIc(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;g=j+b|0;k=i;if(g>>>0>536870911)mCc(a);l=d-i|0;d=l>>2;m=l>>3>>>0<268435455?(d>>>0<g>>>0?g:d):536870911;do if(m)if(m>>>0>536870911){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{n=VDc(m<<3)|0;break}else n=0;while(0);d=n+(j<<3)|0;j=n+(m<<3)|0;XIc(d|0,0,b<<3|0)|0;m=d+(b<<3)|0;if((h|0)==(k|0)){o=d;p=i}else{b=h+-8-i|0;i=h;h=d;while(1){n=i;i=i+-8|0;f[h+-8>>2]=f[i>>2];f[h+-4>>2]=f[n+-4>>2];if((i|0)==(k|0))break;else h=h+-8|0}o=d+(~(b>>>3)<<3)|0;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;YDc(p);return}function Kua(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=u;u=u+144|0;k=j;l=j+120|0;m=j+137|0;n=j+136|0;o=j+64|0;p=j+8|0;do if((d$(e)|0)==65536){q=f[e+4>>2]|0;f[o>>2]=f[q>>2];r=o+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=o+8|0;f[t>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[o+20>>2]=f[q+20>>2];f[o+24>>2]=f[q+24>>2];f[o+28>>2]=f[q+28>>2];f[o+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[o+36>>2]=v;f[o+40>>2]=t;t=o+48|0;w=o+44|0;f[w>>2]=t;f[t>>2]=0;f[o+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];x=o;break}else{f[r>>2]=0;ZS(o,q);x=o;break}}else{a$(o,e,-1);x=o}while(0);e=c&7;q=d&7;if(q>>>0<e>>>0|((d^c)&4088|0)!=0){f[l>>2]=0;f[l+4>>2]=0;y=tT(l,44)|0;z=281235;A=y+44|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,l,281280,274199,4428)}r=f[g>>2]|0;s=g+4|0;t=f[s>>2]|0;w=o+40|0;v=f[w>>2]|0;B=f[v+4>>2]|0;C=f[v>>2]|0;v=(r|0)==-1?(B|0)/2|0:r;r=(t|0)==-1?(C|0)/2|0:t;if(!((v|0)>-1&(v|0)<(B|0))){f[l>>2]=0;D=l+4|0;f[D>>2]=0;E=tT(l,52)|0;y=E;z=281296;A=y+52|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,l,281349,281365,363)}if((r|0)<0|(r|0)>=(C|0)){f[l>>2]=0;D=l+4|0;f[D>>2]=0;E=tT(l,52)|0;y=E;z=281296;A=y+52|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,l,281349,281365,363)}f[g>>2]=v;f[s>>2]=r;r=(e|0)==6;v=(q|0)==6;z=r|v?6:5;f[p>>2]=1124007936;E=p+4|0;D=p+8|0;C=p+40|0;y=E;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[C>>2]=D;y=p+48|0;A=p+44|0;f[A>>2]=y;f[y>>2]=0;f[p+52>>2]=0;B=f[x>>2]&4095;if((B|0)==(z|0)){t=o+36|0;F=f[t>>2]|0;if(F){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1;G=p+36|0;F=f[G>>2]|0;if((F|0)!=0?(H=F+12|0,F=f[H>>2]|0,f[H>>2]=F+-1,(F|0)==1):0){_S(p);I=G}else I=G}else I=p+36|0;f[I>>2]=0;G=p+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[E>>2]|0)>0){F=f[C>>2]|0;H=0;do{f[F+(H<<2)>>2]=0;H=H+1|0;J=f[E>>2]|0}while((H|0)<(J|0));f[p>>2]=f[x>>2];if((J|0)<3)K=24;else K=26}else{f[p>>2]=f[x>>2];K=24}if((K|0)==24){x=f[o+4>>2]|0;if((x|0)<3){f[E>>2]=x;f[D>>2]=f[o+8>>2];f[p+12>>2]=f[o+12>>2];D=f[o+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[D>>2];f[x+4>>2]=f[D+4>>2]}else K=26}if((K|0)==26)ZS(p,o);f[G>>2]=f[o+16>>2];f[p+20>>2]=f[o+20>>2];f[p+24>>2]=f[o+24>>2];f[p+28>>2]=f[o+28>>2];f[p+32>>2]=f[o+32>>2];f[I>>2]=f[t>>2]}else{t=l+8|0;f[t>>2]=0;f[t+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=p;LZ(o,l,z,(B|0)==4?1.0/+(1<<i|0):1.0,0.0)}i=(e|0)==0;do if(!((d|c)&7)){B=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Lua(B,p,l,h,m,n);z=VDc(16)|0;t=z+4|0;f[t>>2]=1;f[z>>2]=59768;f[z+8>>2]=B;f[a>>2]=z;f[a+4>>2]=B;f[t>>2]=(f[t>>2]|0)+1;B=f[t>>2]|0;f[t>>2]=B+-1;if((B|0)==1)Yi[f[(f[z>>2]|0)+8>>2]&2047](z)}else{z=(q|0)==2;if(i&z){B=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Mua(B,p,l,h,m,n);t=VDc(16)|0;I=t+4|0;f[I>>2]=1;f[t>>2]=59788;f[t+8>>2]=B;f[a>>2]=t;f[a+4>>2]=B;f[I>>2]=(f[I>>2]|0)+1;B=f[I>>2]|0;f[I>>2]=B+-1;if((B|0)!=1)break;Yi[f[(f[t>>2]|0)+8>>2]&2047](t);break}t=(q|0)==3;if(i&t){B=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Nua(B,p,l,h,m,n);I=VDc(16)|0;G=I+4|0;f[G>>2]=1;f[I>>2]=59808;f[I+8>>2]=B;f[a>>2]=I;f[a+4>>2]=B;f[G>>2]=(f[G>>2]|0)+1;B=f[G>>2]|0;f[G>>2]=B+-1;if((B|0)==1)Yi[f[(f[I>>2]|0)+8>>2]&2047](I);break}I=(q|0)==5;if(i&I){B=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Oua(B,p,l,h,m,n);G=VDc(16)|0;K=G+4|0;f[K>>2]=1;f[G>>2]=59828;f[G+8>>2]=B;f[a>>2]=G;f[a+4>>2]=B;f[K>>2]=(f[K>>2]|0)+1;B=f[K>>2]|0;f[K>>2]=B+-1;if((B|0)!=1)break;Yi[f[(f[G>>2]|0)+8>>2]&2047](G);break}if(i&v){G=VDc(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Pua(G,p,l,h,m,n);B=VDc(16)|0;K=B+4|0;f[K>>2]=1;f[B>>2]=59848;f[B+8>>2]=G;f[a>>2]=B;f[a+4>>2]=G;f[K>>2]=(f[K>>2]|0)+1;G=f[K>>2]|0;f[K>>2]=G+-1;if((G|0)!=1)break;Yi[f[(f[B>>2]|0)+8>>2]&2047](B);break}B=(e|0)==2;if(B&z){z=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Qua(z,p,l,h,m,n);G=VDc(16)|0;K=G+4|0;f[K>>2]=1;f[G>>2]=59868;f[G+8>>2]=z;f[a>>2]=G;f[a+4>>2]=z;f[K>>2]=(f[K>>2]|0)+1;z=f[K>>2]|0;f[K>>2]=z+-1;if((z|0)!=1)break;Yi[f[(f[G>>2]|0)+8>>2]&2047](G);break}if(B&I){G=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Rua(G,p,l,h,m,n);z=VDc(16)|0;K=z+4|0;f[K>>2]=1;f[z>>2]=59888;f[z+8>>2]=G;f[a>>2]=z;f[a+4>>2]=G;f[K>>2]=(f[K>>2]|0)+1;G=f[K>>2]|0;f[K>>2]=G+-1;if((G|0)!=1)break;Yi[f[(f[z>>2]|0)+8>>2]&2047](z);break}if(B&v){B=VDc(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Sua(B,p,l,h,m,n);z=VDc(16)|0;G=z+4|0;f[G>>2]=1;f[z>>2]=59908;f[z+8>>2]=B;f[a>>2]=z;f[a+4>>2]=B;f[G>>2]=(f[G>>2]|0)+1;B=f[G>>2]|0;f[G>>2]=B+-1;if((B|0)!=1)break;Yi[f[(f[z>>2]|0)+8>>2]&2047](z);break}z=(e|0)==3;if(z&t){t=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Tua(t,p,l,h,m,n);B=VDc(16)|0;G=B+4|0;f[G>>2]=1;f[B>>2]=59928;f[B+8>>2]=t;f[a>>2]=B;f[a+4>>2]=t;f[G>>2]=(f[G>>2]|0)+1;t=f[G>>2]|0;f[G>>2]=t+-1;if((t|0)!=1)break;Yi[f[(f[B>>2]|0)+8>>2]&2047](B);break}if(z&I){B=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Uua(B,p,l,h,m,n);t=VDc(16)|0;G=t+4|0;f[G>>2]=1;f[t>>2]=59948;f[t+8>>2]=B;f[a>>2]=t;f[a+4>>2]=B;f[G>>2]=(f[G>>2]|0)+1;B=f[G>>2]|0;f[G>>2]=B+-1;if((B|0)!=1)break;Yi[f[(f[t>>2]|0)+8>>2]&2047](t);break}if(z&v){z=VDc(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Vua(z,p,l,h,m,n);t=VDc(16)|0;B=t+4|0;f[B>>2]=1;f[t>>2]=59968;f[t+8>>2]=z;f[a>>2]=t;f[a+4>>2]=z;f[B>>2]=(f[B>>2]|0)+1;z=f[B>>2]|0;f[B>>2]=z+-1;if((z|0)!=1)break;Yi[f[(f[t>>2]|0)+8>>2]&2047](t);break}if((e|0)==5&I){I=VDc(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Wua(I,p,l,h,m,n);t=VDc(16)|0;z=t+4|0;f[z>>2]=1;f[t>>2]=59988;f[t+8>>2]=I;f[a>>2]=t;f[a+4>>2]=I;f[z>>2]=(f[z>>2]|0)+1;I=f[z>>2]|0;f[z>>2]=I+-1;if((I|0)==1)Yi[f[(f[t>>2]|0)+8>>2]&2047](t);break}if(!(r&v)){f[k>>2]=c;f[k+4>>2]=d;F5(l,281439,k);z5(-213,l,281280,274199,4493)}t=VDc(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Xua(t,p,l,h,m,n);I=VDc(16)|0;z=I+4|0;f[z>>2]=1;f[I>>2]=60008;f[I+8>>2]=t;f[a>>2]=I;f[a+4>>2]=t;f[z>>2]=(f[z>>2]|0)+1;t=f[z>>2]|0;f[z>>2]=t+-1;if((t|0)==1)Yi[f[(f[I>>2]|0)+8>>2]&2047](I)}while(0);a=p+36|0;n=f[a>>2]|0;if(n|0?(m=n+12|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)_S(p);f[a>>2]=0;a=p+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[E>>2]|0)>0){a=f[C>>2]|0;C=0;do{f[a+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[E>>2]|0))}E=f[A>>2]|0;if((E|0)!=(y|0))g0(E);E=o+36|0;y=f[E>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)_S(o);f[E>>2]=0;E=o+16|0;y=o+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[y>>2]|0)>0){E=f[w>>2]|0;w=0;do{f[E+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[y>>2]|0))}y=f[o+44>>2]|0;if((y|0)==(o+48|0)){u=j;return}g0(y);u=j;return}function Lua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60316;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Mua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60292;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Nua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60268;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Oua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60244;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Pua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60220;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=tT(g,36)|0;a=281616;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Qua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60196;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Rua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60172;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Sua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60148;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=tT(g,36)|0;a=281616;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Tua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60124;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Uua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60100;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Vua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60076;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=tT(g,36)|0;a=281616;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Wua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60052;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,36)|0;a=281616;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Xua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=60028;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=tT(g,36)|0;a=281616;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));z5(-215,g,281653,274199,3883)}Iua(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){bha(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Yua(a){a=a|0;YDc(a);return}function Zua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _ua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60028;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function $ua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60028;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function ava(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;i=+p[a+56>>3];j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=f[a+44>>2]|0;m=(f[a+24>>2]|0)-j|0;a=m>>3;n=Y(h,g)|0;if((e|0)<=0)return;g=(m|0)>0;m=n+-4|0;o=(n|0)<4;q=n&-4;r=b;b=c;c=e;while(1){if(g){e=0;do{s=(f[r+(f[j+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(e<<3)>>2]|0,h)|0)<<3)|0;f[l+(e<<2)>>2]=s;e=e+1|0}while((e|0)<(a|0))}a:do if(o)t=0;else{if(g)u=0;else{e=0;while(1){p[b+(e<<3)>>3]=i;p[b+((e|1)<<3)>>3]=i;p[b+((e|2)<<3)>>3]=i;p[b+((e|3)<<3)>>3]=i;e=e+4|0;if((e|0)>(m|0)){t=q;break a}}}do{v=i;w=i;x=i;y=i;e=0;do{s=(f[l+(e<<2)>>2]|0)+(u<<3)|0;z=+p[k+(e<<3)>>3];y=y+z*+p[s>>3];x=x+z*+p[s+8>>3];w=w+z*+p[s+16>>3];v=v+z*+p[s+24>>3];e=e+1|0}while((e|0)<(a|0));p[b+(u<<3)>>3]=y;p[b+((u|1)<<3)>>3]=x;p[b+((u|2)<<3)>>3]=w;p[b+((u|3)<<3)>>3]=v;u=u+4|0}while((u|0)<=(m|0));t=q}while(0);b:do if((t|0)<(n|0)){if(g)A=t;else{e=t;while(1){p[b+(e<<3)>>3]=i;e=e+1|0;if((e|0)==(n|0))break b}}do{z=i;e=0;do{z=z+ +p[k+(e<<3)>>3]*+p[(f[l+(e<<2)>>2]|0)+(A<<3)>>3];e=e+1|0}while((e|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(n|0))}while(0);if((c|0)>1){r=r+4|0;b=b+d|0;c=c+-1|0}else break}return}function bva(a){a=a|0;YDc(a);return}function cva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60052;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function eva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60052;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function fva(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;i=+n[a+56>>2];j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=f[a+44>>2]|0;m=(f[a+24>>2]|0)-j|0;a=m>>3;o=Y(h,g)|0;if((e|0)<=0)return;g=(m|0)>0;m=o+-4|0;p=(o|0)<4;q=o&-4;r=b;b=c;c=e;while(1){if(g){e=0;do{s=(f[r+(f[j+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(e<<3)>>2]|0,h)|0)<<2)|0;f[l+(e<<2)>>2]=s;e=e+1|0}while((e|0)<(a|0))}a:do if(p)t=0;else{if(g)u=0;else{e=0;while(1){n[b+(e<<2)>>2]=i;n[b+((e|1)<<2)>>2]=i;n[b+((e|2)<<2)>>2]=i;n[b+((e|3)<<2)>>2]=i;e=e+4|0;if((e|0)>(m|0)){t=q;break a}}}do{v=i;w=i;x=i;y=i;e=0;do{s=(f[l+(e<<2)>>2]|0)+(u<<2)|0;z=+n[k+(e<<2)>>2];y=y+z*+n[s>>2];x=x+z*+n[s+4>>2];w=w+z*+n[s+8>>2];v=v+z*+n[s+12>>2];e=e+1|0}while((e|0)<(a|0));n[b+(u<<2)>>2]=y;n[b+((u|1)<<2)>>2]=x;n[b+((u|2)<<2)>>2]=w;n[b+((u|3)<<2)>>2]=v;u=u+4|0}while((u|0)<=(m|0));t=q}while(0);b:do if((t|0)<(o|0)){if(g)A=t;else{e=t;while(1){n[b+(e<<2)>>2]=i;e=e+1|0;if((e|0)==(o|0))break b}}do{z=i;e=0;do{z=z+ +n[k+(e<<2)>>2]*+n[(f[l+(e<<2)>>2]|0)+(A<<2)>>2];e=e+1|0}while((e|0)<(a|0));n[b+(A<<2)>>2]=z;A=A+1|0}while((A|0)!=(o|0))}while(0);if((c|0)>1){r=r+4|0;b=b+d|0;c=c+-1|0}else break}return}function gva(a){a=a|0;YDc(a);return}function hva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function iva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60076;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function jva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60076;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function kva(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(i,h)|0;if((g|0)<=0)return;h=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=0;while(1){p[b+(g<<3)>>3]=j;p[b+((g|1)<<3)>>3]=j;p[b+((g|2)<<3)>>3]=j;p[b+((g|3)<<3)>>3]=j;g=g+4|0;if((g|0)>(n|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+p[l+(g<<3)>>3];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(h)B=u;else{g=u;while(1){p[b+(g<<3)>>3]=j;g=g+1|0;if((g|0)==(o|0))break b}}do{A=j;g=0;do{A=A+ +p[l+(g<<3)>>3]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function lva(a){a=a|0;YDc(a);return}function mva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60100;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function ova(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60100;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function pva(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,h)|0;if((g|0)<=0)return;h=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=0;while(1){n[b+(g<<2)>>2]=j;n[b+((g|1)<<2)>>2]=j;n[b+((g|2)<<2)>>2]=j;n[b+((g|3)<<2)>>2]=j;g=g+4|0;if((g|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+n[l+(g<<2)>>2];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(h)B=u;else{g=u;while(1){n[b+(g<<2)>>2]=j;g=g+1|0;if((g|0)==(p|0))break b}}do{A=j;g=0;do{A=A+ +n[l+(g<<2)>>2]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function qva(a){a=a|0;YDc(a);return}function rva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function sva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60124;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function tva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60124;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function uva(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,h)|0;if((g|0)<=0)return;h=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=mrc(j)|0;t=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=0;while(1){d[b+(g<<1)>>1]=t;d[b+((g|1)<<1)>>1]=t;d[b+((g|2)<<1)>>1]=t;d[b+((g|3)<<1)>>1]=t;g=g+4|0;if((g|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+n[l+(g<<2)>>2];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(z)|0;d[b+(v<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=mrc(y)|0;d[b+((v|1)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=mrc(x)|0;d[b+((v|2)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=mrc(w)|0;d[b+((v|3)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(h)B=u;else{g=mrc(j)|0;t=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=u;while(1){d[b+(g<<1)>>1]=t;g=g+1|0;if((g|0)==(p|0))break b}}do{A=j;g=0;do{A=A+ +n[l+(g<<2)>>2]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(A)|0;d[b+(B<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function vva(a){a=a|0;YDc(a);return}function wva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60148;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function yva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60148;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function zva(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;i=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(h,g)|0;if((e|0)<=0)return;g=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(e<<3)>>2]|0,h)|0)<<1)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){p[b+(e<<3)>>3]=i;p[b+((e|1)<<3)>>3]=i;p[b+((e|2)<<3)>>3]=i;p[b+((e|3)<<3)>>3]=i;e=e+4|0;if((e|0)>(n|0)){u=r;break a}}}do{w=i;x=i;y=i;z=i;e=0;do{t=(f[m+(e<<2)>>2]|0)+(v<<1)|0;A=+p[l+(e<<3)>>3];z=z+A*+(j[t>>1]|0);y=y+A*+(j[t+2>>1]|0);x=x+A*+(j[t+4>>1]|0);w=w+A*+(j[t+6>>1]|0);e=e+1|0}while((e|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(g)B=u;else{e=u;while(1){p[b+(e<<3)>>3]=i;e=e+1|0;if((e|0)==(o|0))break b}}do{A=i;e=0;do{A=A+ +p[l+(e<<3)>>3]*+(j[(f[m+(e<<2)>>2]|0)+(B<<1)>>1]|0);e=e+1|0}while((e|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function Ava(a){a=a|0;YDc(a);return}function Bva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Cva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60172;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Dva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60172;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Eva(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;i=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(h,g)|0;if((e|0)<=0)return;g=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(e<<3)>>2]|0,h)|0)<<1)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){n[b+(e<<2)>>2]=i;n[b+((e|1)<<2)>>2]=i;n[b+((e|2)<<2)>>2]=i;n[b+((e|3)<<2)>>2]=i;e=e+4|0;if((e|0)>(o|0)){u=r;break a}}}do{w=i;x=i;y=i;z=i;e=0;do{t=(f[m+(e<<2)>>2]|0)+(v<<1)|0;A=+n[l+(e<<2)>>2];z=z+A*+(j[t>>1]|0);y=y+A*+(j[t+2>>1]|0);x=x+A*+(j[t+4>>1]|0);w=w+A*+(j[t+6>>1]|0);e=e+1|0}while((e|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(g)B=u;else{e=u;while(1){n[b+(e<<2)>>2]=i;e=e+1|0;if((e|0)==(p|0))break b}}do{A=i;e=0;do{A=A+ +n[l+(e<<2)>>2]*+(j[(f[m+(e<<2)>>2]|0)+(B<<1)>>1]|0);e=e+1|0}while((e|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function Fva(a){a=a|0;YDc(a);return}function Gva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Hva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60196;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Iva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60196;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Jva(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(i,h)|0;if((g|0)<=0)return;h=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(h){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[l+(g<<3)>>2]|0,i)|0)<<1)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(h)w=0;else{g=mrc(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+(w<<1)|0;B=+n[m+(g<<2)>>2];A=A+B*+(j[u>>1]|0);z=z+B*+(j[u+2>>1]|0);y=y+B*+(j[u+4>>1]|0);x=x+B*+(j[u+6>>1]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(A)|0;d[b+(w<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=mrc(z)|0;d[b+((w|1)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=mrc(y)|0;d[b+((w|2)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=mrc(x)|0;d[b+((w|3)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(h)C=v;else{g=mrc(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(j[(f[o+(g<<2)>>2]|0)+(C<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(B)|0;d[b+(C<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function Kva(a){a=a|0;YDc(a);return}function Lva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Mva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60220;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Nva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60220;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Ova(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(i,g)|0;if((e|0)<=0)return;g=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(e<<3)>>2]|0,i)|0)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){p[b+(e<<3)>>3]=j;p[b+((e|1)<<3)>>3]=j;p[b+((e|2)<<3)>>3]=j;p[b+((e|3)<<3)>>3]=j;e=e+4|0;if((e|0)>(n|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;e=0;do{t=(f[m+(e<<2)>>2]|0)+v|0;A=+p[l+(e<<3)>>3];z=z+A*+(h[t>>0]|0);y=y+A*+(h[t+1>>0]|0);x=x+A*+(h[t+2>>0]|0);w=w+A*+(h[t+3>>0]|0);e=e+1|0}while((e|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(g)B=u;else{e=u;while(1){p[b+(e<<3)>>3]=j;e=e+1|0;if((e|0)==(o|0))break b}}do{A=j;e=0;do{A=A+ +p[l+(e<<3)>>3]*+(h[(f[m+(e<<2)>>2]|0)+B>>0]|0);e=e+1|0}while((e|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function Pva(a){a=a|0;YDc(a);return}function Qva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Rva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60244;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Sva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60244;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Tva(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,g)|0;if((e|0)<=0)return;g=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(e<<3)>>2]|0,i)|0)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){n[b+(e<<2)>>2]=j;n[b+((e|1)<<2)>>2]=j;n[b+((e|2)<<2)>>2]=j;n[b+((e|3)<<2)>>2]=j;e=e+4|0;if((e|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;e=0;do{t=(f[m+(e<<2)>>2]|0)+v|0;A=+n[l+(e<<2)>>2];z=z+A*+(h[t>>0]|0);y=y+A*+(h[t+1>>0]|0);x=x+A*+(h[t+2>>0]|0);w=w+A*+(h[t+3>>0]|0);e=e+1|0}while((e|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(g)B=u;else{e=u;while(1){n[b+(e<<2)>>2]=j;e=e+1|0;if((e|0)==(p|0))break b}}do{A=j;e=0;do{A=A+ +n[l+(e<<2)>>2]*+(h[(f[m+(e<<2)>>2]|0)+B>>0]|0);e=e+1|0}while((e|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function Uva(a){a=a|0;YDc(a);return}function Vva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Wva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60268;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Xva(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60268;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Yva(a,b,c,e,g,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=mrc(k)|0;u=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(A)|0;d[b+(w<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=mrc(z)|0;d[b+((w|1)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=mrc(y)|0;d[b+((w|2)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=mrc(x)|0;d[b+((w|3)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=mrc(k)|0;u=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(B)|0;d[b+(C<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function Zva(a){a=a|0;YDc(a);return}function _va(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $va(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60292;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function awa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60292;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function bwa(a,b,c,e,g,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=mrc(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(A)|0;d[b+(w<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=mrc(z)|0;d[b+((w|1)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=mrc(y)|0;d[b+((w|2)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=mrc(x)|0;d[b+((w|3)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=mrc(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(B)|0;d[b+(C<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function cwa(a){a=a|0;YDc(a);return}function dwa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ewa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60316;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function fwa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=60316;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function gwa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=c;c=d;d=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=mrc(k)|0;u=(g>>>0<256?g:(g|0)>0?255:0)&255;g=0;while(1){b[c+g>>0]=u;b[c+(g|1)>>0]=u;b[c+(g|2)>>0]=u;b[c+(g|3)>>0]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(A)|0;b[c+w>>0]=g>>>0<256?g:(g|0)>0?255:0;g=mrc(z)|0;b[c+(w|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=mrc(y)|0;b[c+(w|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=mrc(x)|0;b[c+(w|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=mrc(k)|0;u=(g>>>0<256?g:(g|0)>0?255:0)&255;g=v;while(1){b[c+g>>0]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=mrc(B)|0;b[c+C>>0]=g>>>0<256?g:(g|0)>0?255:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((d|0)>1){t=t+4|0;c=c+e|0;d=d+-1|0}else break}return}function hwa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=u;u=u+160|0;m=l+96|0;n=l+40|0;o=l+32|0;p=l+8|0;q=l+24|0;r=l;do if((d$(e)|0)==65536){s=f[e+4>>2]|0;f[m>>2]=f[s>>2];t=m+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=m+8|0;f[w>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];f[m+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[m+36>>2]=x;f[m+40>>2]=w;w=m+48|0;y=m+44|0;f[y>>2]=w;f[w>>2]=0;f[m+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;ZS(m,s);break}}else a$(m,e,-1);while(0);e=c&4095;s=d&4095;if((d^c)&4088|0){f[n>>2]=0;f[n+4>>2]=0;c=tT(n,25)|0;d=281090;t=c+25|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(t|0));z5(-215,n,283486,274199,4507)}f[n>>2]=f[m>>2];d=n+4|0;c=m+4|0;t=f[c>>2]|0;f[d>>2]=t;v=n+8|0;f[v>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];w=n+16|0;y=m+16|0;f[w>>2]=f[y>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];x=n+36|0;z=m+36|0;A=f[z>>2]|0;f[x>>2]=A;B=n+40|0;f[B>>2]=v;v=n+48|0;C=n+44|0;f[C>>2]=v;f[v>>2]=0;f[n+52>>2]=0;if(!A)D=t;else{t=A+12|0;f[t>>2]=(f[t>>2]|0)+1;D=f[c>>2]|0}if((D|0)<3){D=f[m+44>>2]|0;t=f[C>>2]|0;f[t>>2]=f[D>>2];f[t+4>>2]=f[D+4>>2]}else{f[d>>2]=0;ZS(n,m)}f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];Kua(o,e,s,p,q,h,0);f[p>>2]=0;f[p+4>>2]=0;f[r>>2]=0;f[r+4>>2]=0;q=VDc(200)|0;Dqa(q,o,p,r,e,s,e,i,j,k);k=VDc(16)|0;f[k+4>>2]=1;f[k>>2]=56396;f[k+8>>2]=q;f[a>>2]=k;f[a+4>>2]=q;q=f[o>>2]|0;if(q|0?(o=q+4|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)Yi[f[(f[q>>2]|0)+8>>2]&2047](q);q=f[x>>2]|0;if(q|0?(a=q+12|0,q=f[a>>2]|0,f[a>>2]=q+-1,(q|0)==1):0)_S(n);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[d>>2]|0)>0){w=f[B>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[d>>2]|0))}d=f[C>>2]|0;if((d|0)!=(v|0))g0(d);d=f[z>>2]|0;if(d|0?(v=d+12|0,d=f[v>>2]|0,f[v>>2]=d+-1,(d|0)==1):0)_S(m);f[z>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[m+40>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=f[m+44>>2]|0;if((c|0)==(m+48|0)){u=l;return}g0(c);u=l;return}function iwa(a,b,c,d,e,g,h,i,j,k,l,m,n,o,q,r,s,t,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;r=r|0;s=s|0;t=t|0;v=v|0;w=+w;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;y=u;u=u+496|0;z=y+432|0;A=y+56|0;B=y+376|0;C=y+320|0;D=y+264|0;E=y;F=y+208|0;G=y+200|0;H=y+144|0;I=y+136|0;J=y+128|0;K=y+120|0;L=y+104|0;M=y+88|0;N=y+80|0;O=y+72|0;P=y+64|0;p[A>>3]=w;if((Y(s,r)|0)<=49){f[A>>2]=r;f[A+4>>2]=s;CY(z,A,c,o,q);f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=z;f[D>>2]=t;f[D+4>>2]=v;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[E+28>>2]=0;hwa(B,a,b,C,D,w,x&-17,-1,E);f[F>>2]=i;f[F+4>>2]=j;CY(C,F,a,d,e);f[G>>2]=i;f[G+4>>2]=j;CY(E,G,b,g,h);j=f[B+4>>2]|0;i=f[(f[j>>2]|0)+20>>2]|0;f[H>>2]=k;f[H+4>>2]=l;f[I>>2]=m;f[I+4>>2]=n;gi[i&255](j,C,E,H,I);j=E+36|0;i=f[j>>2]|0;if(i|0?(Q=i+12|0,i=f[Q>>2]|0,f[Q>>2]=i+-1,(i|0)==1):0)_S(E);f[j>>2]=0;j=E+16|0;i=E+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[E+40>>2]|0;Q=0;do{f[j+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[i>>2]|0))}i=f[E+44>>2]|0;if((i|0)!=(E+48|0))g0(i);i=C+36|0;Q=f[i>>2]|0;if(Q|0?(j=Q+12|0,Q=f[j>>2]|0,f[j>>2]=Q+-1,(Q|0)==1):0)_S(C);f[i>>2]=0;i=C+16|0;Q=C+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[Q>>2]|0)>0){i=f[C+40>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[Q>>2]|0))}Q=f[C+44>>2]|0;if((Q|0)!=(C+48|0))g0(Q);Q=f[B>>2]|0;if(Q|0?(j=Q+4|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)Yi[f[(f[Q>>2]|0)+8>>2]&2047](Q);Q=z+36|0;i=f[Q>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)_S(z);f[Q>>2]=0;Q=z+16|0;i=z+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[i>>2]|0)>0){Q=f[z+40>>2]|0;j=0;do{f[Q+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[z+44>>2]|0;if((i|0)!=(z+48|0))g0(i);u=y;return}f[C>>2]=r;f[C+4>>2]=s;CY(B,C,c,o,q);f[E>>2]=k-m;f[E+4>>2]=l-n;CY(D,E,a,d,e);f[G>>2]=k;f[G+4>>2]=l;CY(F,G,b,g,h);f[H>>2]=1124007936;G=H+4|0;e=H+8|0;E=H+40|0;n=G;m=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(m|0));f[E>>2]=e;n=H+48|0;m=H+44|0;f[m>>2]=n;f[n>>2]=0;f[H+52>>2]=0;q=a>>>3&511;a=b&4088;o=b&7;if((q|0)!=0&+p[A>>3]!=0.0){if((o+-5|0)>>>0>1|(d|0)==(g|0)){c=(o|0)==6?6:5;f[z>>2]=l;f[z+4>>2]=k;XS(H,2,z,c|a);R=c}else{f[I>>2]=k;f[I+4>>2]=l;CY(z,I,b,g,h);I=z+36|0;c=f[I>>2]|0;if(c|0){a=c+12|0;f[a>>2]=(f[a>>2]|0)+1}a=H+36|0;c=f[a>>2]|0;if(c|0?(C=c+12|0,c=f[C>>2]|0,f[C>>2]=c+-1,(c|0)==1):0)_S(H);f[a>>2]=0;c=H+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[G>>2]|0)>0){C=f[E>>2]|0;s=0;do{f[C+(s<<2)>>2]=0;s=s+1|0;S=f[G>>2]|0}while((s|0)<(S|0));f[H>>2]=f[z>>2];if((S|0)<3)T=14;else T=16}else{f[H>>2]=f[z>>2];T=14}if((T|0)==14){S=f[z+4>>2]|0;if((S|0)<3){f[G>>2]=S;f[e>>2]=f[z+8>>2];f[H+12>>2]=f[z+12>>2];S=f[z+44>>2]|0;s=f[m>>2]|0;f[s>>2]=f[S>>2];f[s+4>>2]=f[S+4>>2]}else T=16}if((T|0)==16)ZS(H,z);S=z+16|0;f[c>>2]=f[S>>2];f[H+20>>2]=f[z+20>>2];f[H+24>>2]=f[z+24>>2];f[H+28>>2]=f[z+28>>2];f[H+32>>2]=f[z+32>>2];c=f[I>>2]|0;f[a>>2]=c;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)_S(z);f[I>>2]=0;I=z+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[I>>2]|0)>0){S=f[z+40>>2]|0;c=0;do{f[S+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[I>>2]|0))}I=f[z+44>>2]|0;if((I|0)!=(z+48|0))g0(I);R=o}I=f[D+40>>2]|0;c=f[I>>2]|0;f[J>>2]=f[I+4>>2];f[J+4>>2]=c;f[K>>2]=t;f[K+4>>2]=v;Bfa(D,B,H,J,R|q<<3,K,0.0,x);f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=H;f[L>>2]=-1056833530;f[L+4>>2]=A;f[L+8>>2]=1;f[L+12>>2]=1;K=M+8|0;f[K>>2]=0;f[K+4>>2]=0;f[M>>2]=33619968;f[M+4>>2]=H;mL(z,L,M,e0()|0,-1);if((f[H+16>>2]|0)!=(g|0)){M=z+8|0;f[M>>2]=0;f[M+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=F;LZ(H,z,f[F>>2]&4095,1.0,0.0)}}else{if((d|0)!=(g|0)){f[N>>2]=k;f[N+4>>2]=l;CY(z,N,b,g,h);h=z+36|0;N=f[h>>2]|0;if(N|0){d=N+12|0;f[d>>2]=(f[d>>2]|0)+1}d=H+36|0;N=f[d>>2]|0;if(N|0?(M=N+12|0,N=f[M>>2]|0,f[M>>2]=N+-1,(N|0)==1):0)_S(H);f[d>>2]=0;N=H+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[G>>2]|0)>0){M=f[E>>2]|0;L=0;do{f[M+(L<<2)>>2]=0;L=L+1|0;U=f[G>>2]|0}while((L|0)<(U|0));f[H>>2]=f[z>>2];if((U|0)<3)T=40;else T=42}else{f[H>>2]=f[z>>2];T=40}if((T|0)==40){U=f[z+4>>2]|0;if((U|0)<3){f[G>>2]=U;f[e>>2]=f[z+8>>2];f[H+12>>2]=f[z+12>>2];e=f[z+44>>2]|0;U=f[m>>2]|0;f[U>>2]=f[e>>2];f[U+4>>2]=f[e+4>>2]}else T=42}if((T|0)==42)ZS(H,z);T=z+16|0;f[N>>2]=f[T>>2];f[H+20>>2]=f[z+20>>2];f[H+24>>2]=f[z+24>>2];f[H+28>>2]=f[z+28>>2];f[H+32>>2]=f[z+32>>2];N=f[h>>2]|0;f[d>>2]=N;if(N|0?(d=N+12|0,N=f[d>>2]|0,f[d>>2]=N+-1,(N|0)==1):0)_S(z);f[h>>2]=0;h=z+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[h>>2]|0)>0){T=f[z+40>>2]|0;N=0;do{f[T+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[h>>2]|0))}h=f[z+44>>2]|0;if((h|0)!=(z+48|0))g0(h)}else{f[z>>2]=l;f[z+4>>2]=k;XS(H,2,z,b&4095)}b=f[D+40>>2]|0;k=f[b>>2]|0;f[O>>2]=f[b+4>>2];f[O+4>>2]=k;f[P>>2]=t;f[P+4>>2]=v;Bfa(D,B,H,O,q<<3|o,P,+p[A>>3],x);if((f[H+16>>2]|0)!=(g|0)){g=z+8|0;f[g>>2]=0;f[g+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=F;h_(H,z)}}z=H+36|0;g=f[z>>2]|0;if(g|0?(x=g+12|0,g=f[x>>2]|0,f[x>>2]=g+-1,(g|0)==1):0)_S(H);f[z>>2]=0;z=H+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[G>>2]|0)>0){z=f[E>>2]|0;E=0;do{f[z+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[G>>2]|0))}G=f[m>>2]|0;if((G|0)!=(n|0))g0(G);G=F+36|0;n=f[G>>2]|0;if(n|0?(m=n+12|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)_S(F);f[G>>2]=0;G=F+16|0;n=F+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[n>>2]|0)>0){G=f[F+40>>2]|0;m=0;do{f[G+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[n>>2]|0))}n=f[F+44>>2]|0;if((n|0)!=(F+48|0))g0(n);n=D+36|0;F=f[n>>2]|0;if(F|0?(m=F+12|0,F=f[m>>2]|0,f[m>>2]=F+-1,(F|0)==1):0)_S(D);f[n>>2]=0;n=D+16|0;F=D+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[F>>2]|0)>0){n=f[D+40>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[F>>2]|0))}F=f[D+44>>2]|0;if((F|0)!=(D+48|0))g0(F);F=B+36|0;D=f[F>>2]|0;if(D|0?(m=D+12|0,D=f[m>>2]|0,f[m>>2]=D+-1,(D|0)==1):0)_S(B);f[F>>2]=0;F=B+16|0;D=B+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[D>>2]|0)>0){F=f[B+40>>2]|0;m=0;do{f[F+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[D>>2]|0))}D=f[B+44>>2]|0;if((D|0)!=(B+48|0))g0(D);u=y;return}function jwa(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p,q,r,s,t,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;v=+v;w=w|0;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;x=u;u=u+320|0;y=x+256|0;z=x+248|0;A=x+192|0;B=x+184|0;C=x+176|0;D=x+120|0;E=x+64|0;F=x+56|0;G=x;H=x+48|0;I=x+40|0;J=x+32|0;f[z>>2]=p;f[z+4>>2]=1;CY(y,z,c,o,0);f[B>>2]=r;f[B+4>>2]=1;CY(A,B,c,q,0);f[D+8>>2]=0;f[D+12>>2]=0;f[D>>2]=16842752;f[D+4>>2]=y;f[E+8>>2]=0;f[E+12>>2]=0;f[E>>2]=16842752;f[E+4>>2]=A;f[F>>2]=s;f[F+4>>2]=t;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[G+16>>2]=0;f[G+20>>2]=0;f[G+24>>2]=0;f[G+28>>2]=0;Hua(C,a,b,D,E,F,v,w&-17,-1,G);f[H>>2]=i;f[H+4>>2]=j;CY(D,H,a,d,e);f[I>>2]=i;f[I+4>>2]=j;CY(E,I,b,g,h);h=f[C+4>>2]|0;g=f[(f[h>>2]|0)+20>>2]|0;f[G>>2]=k;f[G+4>>2]=l;f[J>>2]=m;f[J+4>>2]=n;gi[g&255](h,D,E,G,J);J=E+36|0;G=f[J>>2]|0;if(G|0?(h=G+12|0,G=f[h>>2]|0,f[h>>2]=G+-1,(G|0)==1):0)_S(E);f[J>>2]=0;J=E+16|0;G=E+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[G>>2]|0)>0){J=f[E+40>>2]|0;h=0;do{f[J+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[G>>2]|0))}G=f[E+44>>2]|0;if((G|0)!=(E+48|0))g0(G);G=D+36|0;E=f[G>>2]|0;if(E|0?(h=E+12|0,E=f[h>>2]|0,f[h>>2]=E+-1,(E|0)==1):0)_S(D);f[G>>2]=0;G=D+16|0;E=D+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[E>>2]|0)>0){G=f[D+40>>2]|0;h=0;do{f[G+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[E>>2]|0))}E=f[D+44>>2]|0;if((E|0)!=(D+48|0))g0(E);E=f[C>>2]|0;if(E|0?(C=E+4|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)Yi[f[(f[E>>2]|0)+8>>2]&2047](E);E=A+36|0;D=f[E>>2]|0;if(D|0?(C=D+12|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)_S(A);f[E>>2]=0;E=A+16|0;D=A+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[D>>2]|0)>0){E=f[A+40>>2]|0;C=0;do{f[E+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[D>>2]|0))}D=f[A+44>>2]|0;if((D|0)!=(A+48|0))g0(D);D=y+36|0;A=f[D>>2]|0;if(A|0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0)_S(y);f[D>>2]=0;D=y+16|0;A=y+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[A>>2]|0)>0){D=f[y+40>>2]|0;C=0;do{f[D+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[y+44>>2]|0;if((A|0)==(y+48|0)){u=x;return}g0(A);u=x;return}function kwa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=u;u=u+192|0;k=j+184|0;l=j+128|0;m=j+72|0;n=j+8|0;o=j+16|0;p=j;do if((d$(a)|0)==65536){q=f[a+4>>2]|0;f[l>>2]=f[q>>2];r=l+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=l+8|0;f[t>>2]=f[q+8>>2];f[l+12>>2]=f[q+12>>2];f[l+16>>2]=f[q+16>>2];f[l+20>>2]=f[q+20>>2];f[l+24>>2]=f[q+24>>2];f[l+28>>2]=f[q+28>>2];f[l+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[l+36>>2]=v;f[l+40>>2]=t;t=l+48|0;w=l+44|0;f[w>>2]=t;f[t>>2]=0;f[l+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;ZS(l,q);break}}else a$(l,a,-1);while(0);do if((d$(e)|0)==65536){a=f[e+4>>2]|0;f[m>>2]=f[a>>2];q=m+4|0;r=a+4|0;f[q>>2]=f[r>>2];s=m+8|0;f[s>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[m+36>>2]=t;f[m+40>>2]=s;s=m+48|0;w=m+44|0;f[w>>2]=s;f[s>>2]=0;f[m+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[a+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;ZS(m,a);break}}else a$(m,e,-1);while(0);e=f[l>>2]|0;a=l+40|0;q=f[a>>2]|0;r=f[q>>2]|0;f[n>>2]=f[q+4>>2];f[n+4>>2]=r;v$(c,n,e&4088|((d|0)<0?e:d)&7,-1,0,0);do if((d$(c)|0)==65536){d=f[c+4>>2]|0;f[o>>2]=f[d>>2];e=o+4|0;n=d+4|0;f[e>>2]=f[n>>2];r=o+8|0;f[r>>2]=f[d+8>>2];f[o+12>>2]=f[d+12>>2];f[o+16>>2]=f[d+16>>2];f[o+20>>2]=f[d+20>>2];f[o+24>>2]=f[d+24>>2];f[o+28>>2]=f[d+28>>2];f[o+32>>2]=f[d+32>>2];q=f[d+36>>2]|0;f[o+36>>2]=q;f[o+40>>2]=r;r=o+48|0;s=o+44|0;f[s>>2]=r;f[r>>2]=0;f[o+52>>2]=0;if(q|0){r=q+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[n>>2]|0)<3){n=f[d+44>>2]|0;r=f[s>>2]|0;f[r>>2]=f[n>>2];f[r+4>>2]=f[n+4>>2];break}else{f[e>>2]=0;ZS(o,d);break}}else a$(o,c,-1);while(0);c=f[g>>2]|0;d=f[g+4>>2]|0;g=m+40|0;e=f[g>>2]|0;n=f[e+4>>2]|0;r=f[e>>2]|0;e=(c|0)==-1?(n|0)/2|0:c;c=(d|0)==-1?(r|0)/2|0:d;if(!((e|0)>-1&(e|0)<(n|0))){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,52)|0;z=y;A=281296;B=z+52|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,281349,281365,363)}if((c|0)<0|(c|0)>=(r|0)){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,52)|0;z=y;A=281296;B=z+52|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,k,281349,281365,363)}f[k>>2]=0;A=k+4|0;f[A>>2]=0;z=f[l+12>>2]|0;B=f[l+8>>2]|0;f[p>>2]=z;y=p+4|0;f[y>>2]=B;if(!(i&16)){jT(l,p,k);C=f[p>>2]|0;D=f[y>>2]|0;E=f[k>>2]|0;F=f[A>>2]|0}else{C=z;D=B;E=0;F=0}B=f[l>>2]|0;z=l+16|0;A=l+48|0;k=o+16|0;y=o+48|0;p=m+16|0;x=m+48|0;iwa(B&4095,f[o>>2]&4095,f[m>>2]&4095,f[z>>2]|0,f[A>>2]|0,f[k>>2]|0,f[y>>2]|0,f[o+12>>2]|0,f[o+8>>2]|0,C,D,E,F,f[p>>2]|0,f[x>>2]|0,f[m+12>>2]|0,f[m+8>>2]|0,e,c,h,i,(B&32768|0)!=0);B=o+36|0;i=f[B>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)_S(o);f[B>>2]=0;B=o+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[B>>2]|0)>0){k=f[o+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[B>>2]|0))}B=f[o+44>>2]|0;if((B|0)!=(y|0))g0(B);B=m+36|0;y=f[B>>2]|0;if(y|0?(o=y+12|0,y=f[o>>2]|0,f[o>>2]=y+-1,(y|0)==1):0)_S(m);f[B>>2]=0;B=m+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[B>>2]|0)>0){p=f[g>>2]|0;g=0;do{f[p+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[B>>2]|0))}B=f[m+44>>2]|0;if((B|0)!=(x|0))g0(B);B=l+36|0;x=f[B>>2]|0;if(x|0?(m=x+12|0,x=f[m>>2]|0,f[m>>2]=x+-1,(x|0)==1):0)_S(l);f[B>>2]=0;B=l+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[B>>2]|0)>0){z=f[a>>2]|0;a=0;do{f[z+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[B>>2]|0))}B=f[l+44>>2]|0;if((B|0)==(A|0)){u=j;return}g0(B);u=j;return}function lwa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;k=u;u=u+384|0;l=k+360|0;m=k+304|0;n=k+248|0;o=k+184|0;p=k+240|0;q=k+128|0;r=k+120|0;s=k+112|0;t=k+56|0;v=k;do if((d$(a)|0)==65536){w=f[a+4>>2]|0;f[m>>2]=f[w>>2];x=m+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[w+8>>2];f[m+12>>2]=f[w+12>>2];f[m+16>>2]=f[w+16>>2];f[m+20>>2]=f[w+20>>2];f[m+24>>2]=f[w+24>>2];f[m+28>>2]=f[w+28>>2];f[m+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(m,w);break}}else a$(m,a,-1);while(0);do if((d$(e)|0)==65536){a=f[e+4>>2]|0;f[n>>2]=f[a>>2];w=n+4|0;x=a+4|0;f[w>>2]=f[x>>2];y=n+8|0;f[y>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];z=f[a+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=y;y=n+48|0;B=n+44|0;f[B>>2]=y;f[y>>2]=0;f[n+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[a+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;ZS(n,a);break}}else a$(n,e,-1);while(0);do if((d$(g)|0)==65536){e=f[g+4>>2]|0;f[o>>2]=f[e>>2];a=o+4|0;w=e+4|0;f[a>>2]=f[w>>2];x=o+8|0;f[x>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];f[o+16>>2]=f[e+16>>2];f[o+20>>2]=f[e+20>>2];f[o+24>>2]=f[e+24>>2];f[o+28>>2]=f[e+28>>2];f[o+32>>2]=f[e+32>>2];y=f[e+36>>2]|0;f[o+36>>2]=y;f[o+40>>2]=x;x=o+48|0;B=o+44|0;f[B>>2]=x;f[x>>2]=0;f[o+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[e+44>>2]|0;x=f[B>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[a>>2]=0;ZS(o,e);break}}else a$(o,g,-1);while(0);g=f[m>>2]|0;e=m+40|0;a=f[e>>2]|0;w=f[a>>2]|0;f[p>>2]=f[a+4>>2];f[p+4>>2]=w;v$(c,p,g&4088|((d|0)<0?g:d)&7,-1,0,0);do if((d$(c)|0)==65536){d=f[c+4>>2]|0;f[q>>2]=f[d>>2];g=q+4|0;p=d+4|0;f[g>>2]=f[p>>2];w=q+8|0;f[w>>2]=f[d+8>>2];f[q+12>>2]=f[d+12>>2];f[q+16>>2]=f[d+16>>2];f[q+20>>2]=f[d+20>>2];f[q+24>>2]=f[d+24>>2];f[q+28>>2]=f[d+28>>2];f[q+32>>2]=f[d+32>>2];a=f[d+36>>2]|0;f[q+36>>2]=a;f[q+40>>2]=w;w=q+48|0;x=q+44|0;f[x>>2]=w;f[w>>2]=0;f[q+52>>2]=0;if(a|0){w=a+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[p>>2]|0)<3){p=f[d+44>>2]|0;w=f[x>>2]|0;f[w>>2]=f[p>>2];f[w+4>>2]=f[p+4>>2];break}else{f[g>>2]=0;ZS(q,d);break}}else a$(q,c,-1);while(0);f[r>>2]=0;c=r+4|0;f[c>>2]=0;d=f[m+8>>2]|0;f[s>>2]=f[m+12>>2];g=s+4|0;f[g>>2]=d;if(!(j&16))jT(m,s,r);d=f[n>>2]|0;if((f[o>>2]^d)&4095|0){f[l>>2]=0;C=l+4|0;f[C>>2]=0;D=tT(l,120)|0;E=D;F=283505;G=E+120|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,l,283626,274199,4949)}p=n+12|0;w=f[p>>2]|0;if((w|0)!=1?(f[n+8>>2]|0)!=1:0){f[l>>2]=0;C=l+4|0;f[C>>2]=0;D=tT(l,120)|0;E=D;F=283505;G=E+120|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,l,283626,274199,4949)}x=o+12|0;if((f[x>>2]|0)!=1?(f[o+8>>2]|0)!=1:0){f[l>>2]=0;C=l+4|0;f[C>>2]=0;D=tT(l,120)|0;E=D;F=283505;G=E+120|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,l,283626,274199,4949)}do if(d&16384){f[t>>2]=d;F=t+4|0;D=n+4|0;C=f[D>>2]|0;f[F>>2]=C;a=t+8|0;f[a>>2]=f[n+8>>2];f[t+12>>2]=w;f[t+16>>2]=f[n+16>>2];f[t+20>>2]=f[n+20>>2];f[t+24>>2]=f[n+24>>2];f[t+28>>2]=f[n+28>>2];f[t+32>>2]=f[n+32>>2];B=f[n+36>>2]|0;f[t+36>>2]=B;f[t+40>>2]=a;a=t+48|0;y=t+44|0;f[y>>2]=a;f[a>>2]=0;f[t+52>>2]=0;if(!B)H=C;else{C=B+12|0;f[C>>2]=(f[C>>2]|0)+1;H=f[D>>2]|0}if((H|0)<3){D=f[n+44>>2]|0;C=f[y>>2]|0;f[C>>2]=f[D>>2];f[C+4>>2]=f[D+4>>2];break}else{f[F>>2]=0;ZS(t,n);break}}else{f[t>>2]=1124007936;F=t+8|0;D=t+40|0;E=t+4|0;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[D>>2]=F;C=t+48|0;f[t+44>>2]=C;f[C>>2]=0;f[t+52>>2]=0;C=l+8|0;f[C>>2]=0;f[C+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=t;h_(n,l)}while(0);H=f[o>>2]|0;do if(H&16384){f[v>>2]=H;w=v+4|0;d=o+4|0;C=f[d>>2]|0;f[w>>2]=C;y=v+8|0;B=o+8|0;f[y>>2]=f[B>>2];f[v+12>>2]=f[x>>2];a=v+16|0;f[a>>2]=f[o+16>>2];f[v+20>>2]=f[o+20>>2];f[v+24>>2]=f[o+24>>2];f[v+28>>2]=f[o+28>>2];f[v+32>>2]=f[o+32>>2];z=f[o+36>>2]|0;f[v+36>>2]=z;f[v+40>>2]=y;y=v+48|0;A=v+44|0;f[A>>2]=y;f[y>>2]=0;f[v+52>>2]=0;if(!z)I=C;else{C=z+12|0;f[C>>2]=(f[C>>2]|0)+1;I=f[d>>2]|0}if((I|0)<3){d=f[o+44>>2]|0;C=f[A>>2]|0;f[C>>2]=f[d>>2];f[C+4>>2]=f[d+4>>2];J=B;K=a;break}else{f[w>>2]=0;ZS(v,o);J=B;K=a;break}}else{f[v>>2]=1124007936;a=v+8|0;B=v+40|0;E=v+4|0;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[B>>2]=a;F=v+48|0;f[v+44>>2]=F;f[F>>2]=0;f[v+52>>2]=0;F=l+8|0;f[F>>2]=0;f[F+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=v;h_(o,l);J=o+8|0;K=v+16|0}while(0);l=m+16|0;E=m+48|0;G=q+16|0;I=q+48|0;H=t+16|0;jwa(f[m>>2]&4095,f[q>>2]&4095,f[n>>2]&4095,f[l>>2]|0,f[E>>2]|0,f[G>>2]|0,f[I>>2]|0,f[q+12>>2]|0,f[q+8>>2]|0,f[s>>2]|0,f[g>>2]|0,f[r>>2]|0,f[c>>2]|0,f[H>>2]|0,(f[p>>2]|0)+-1+(f[n+8>>2]|0)|0,f[K>>2]|0,(f[x>>2]|0)+-1+(f[J>>2]|0)|0,f[h>>2]|0,f[h+4>>2]|0,i,j&-17);j=v+36|0;h=f[j>>2]|0;if(h|0?(J=h+12|0,h=f[J>>2]|0,f[J>>2]=h+-1,(h|0)==1):0)_S(v);f[j>>2]=0;j=v+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[j>>2]|0)>0){K=f[v+40>>2]|0;h=0;do{f[K+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))g0(j);j=t+36|0;v=f[j>>2]|0;if(v|0?(h=v+12|0,v=f[h>>2]|0,f[h>>2]=v+-1,(v|0)==1):0)_S(t);f[j>>2]=0;j=t+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[j>>2]|0)>0){H=f[t+40>>2]|0;v=0;do{f[H+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[j>>2]|0))}j=f[t+44>>2]|0;if((j|0)!=(t+48|0))g0(j);j=q+36|0;t=f[j>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)_S(q);f[j>>2]=0;j=q+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[j>>2]|0)>0){G=f[q+40>>2]|0;t=0;do{f[G+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[q+44>>2]|0;if((j|0)!=(I|0))g0(j);j=o+36|0;I=f[j>>2]|0;do if(I|0){q=I+12|0;t=f[q>>2]|0;f[q>>2]=t+-1;if((t|0)!=1)break;_S(o)}while(0);f[j>>2]=0;j=o+16|0;I=o+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[I>>2]|0)>0){j=f[o+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[I>>2]|0))}I=f[o+44>>2]|0;if((I|0)!=(o+48|0))g0(I);I=n+36|0;o=f[I>>2]|0;do if(o|0){t=o+12|0;j=f[t>>2]|0;f[t>>2]=j+-1;if((j|0)!=1)break;_S(n)}while(0);f[I>>2]=0;I=n+16|0;o=n+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[o>>2]|0)>0){I=f[n+40>>2]|0;j=0;do{f[I+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)!=(n+48|0))g0(o);o=m+36|0;n=f[o>>2]|0;do if(n|0){j=n+12|0;I=f[j>>2]|0;f[j>>2]=I+-1;if((I|0)!=1)break;_S(m)}while(0);f[o>>2]=0;o=m+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[o>>2]|0)>0){l=f[e>>2]|0;e=0;do{f[l+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)==(E|0)){u=k;return}g0(o);u=k;return}function mwa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0;o=u;u=u+64|0;p=o+48|0;q=o+16|0;r=o;s=(i|0)==5?360:l?256:180;l=k?2:0;k=(i|0)==0;if(!m)if(k){f[r>>2]=j;f[r+4>>2]=3;f[r+8>>2]=l;n[r+12>>2]=+(s|0)/360.0;f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=60380;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=r;y8(p,q,+(Y(h,g)|0)*.0000152587890625);u=o;return}else{f[r>>2]=j;f[r+4>>2]=l;n[r+8>>2]=+(s|0)/360.0;f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=60400;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=r;y8(p,q,+(Y(h,g)|0)*.0000152587890625);u=o;return}if(!k){f[r>>2]=j;f[r+4>>2]=l;n[r+8>>2]=+(s|0);f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=60360;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=r;y8(p,q,+(Y(h,g)|0)*.0000152587890625);u=o;return}f[r>>2]=j;f[r+4>>2]=l;f[r+8>>2]=s;switch(s&511){case 256:case 180:break;default:{f[p>>2]=0;f[p+4>>2]=0;s=tT(p,30)|0;l=283638;j=s+30|0;do{b[s>>0]=b[l>>0]|0;s=s+1|0;l=l+1|0}while((s|0)<(j|0));z5(-215,p,283669,283679,21)}}f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=60340;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=r;y8(p,q,+(Y(h,g)|0)*.0000152587890625);u=o;return}function nwa(a){a=a|0;YDc(a);return}function owa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;i=h*3|0;if((h|0)<=0){h=c;do h=h+1|0;while((h|0)<(d|0));return}h=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=h;h=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c+4>>2]|0;l=f[c>>2]|0;m=k^2;o=c+8|0;c=h;p=0;while(1){q=+n[c+(k<<2)>>2];r=+n[c+4>>2];s=+n[c+(m<<2)>>2];t=s<r?r:s;u=t<q?q:t;t=s>r?r:s;v=t>q?q:t;t=u-v;w=u+v;x=w*.5;if(t>1.1920928955078125e-07){y=t/(x<.5?w:2.0-u-v);v=60.0/t;do if(!(u==s))if(u==r){z=(q-s)*v+120.0;break}else{z=(s-r)*v+240.0;break}else z=(r-q)*v;while(0);if(z<0.0){A=y;B=z+360.0}else{A=y;B=z}}else{A=0.0;B=0.0}n[j+(p<<2)>>2]=B*+n[o>>2];n[j+(p+1<<2)>>2]=x;n[j+(p+2<<2)>>2]=A;p=p+3|0;if((p|0)>=(i|0))break;else c=c+(l<<2)|0}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;h=h+b|0}}return}function pwa(a){a=a|0;YDc(a);return}function qwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){rwa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function rwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+8|0;l=a+4|0;m=a+12|0;a=d;d=0;o=c;while(1){c=e-d|0;p=((c|0)<256?c:256)*3|0;q=(c|0)>0;if(q){c=0;r=o;do{n[i+(c<<2)>>2]=+(h[r>>0]|0)*.003921568859368563;n[i+(c+1<<2)>>2]=+(h[r+1>>0]|0)*.003921568859368563;n[i+(c+2<<2)>>2]=+(h[r+2>>0]|0)*.003921568859368563;c=c+3|0;r=r+j|0}while((c|0)<(p|0));c=f[k>>2]|0;s=f[l>>2]|0;if(q){t=c^2;v=i;w=0;while(1){x=+n[v+(c<<2)>>2];y=+n[v+4>>2];z=+n[v+(t<<2)>>2];A=z<y?y:z;B=A<x?x:A;A=z>y?y:z;C=A>x?x:A;A=B-C;D=B+C;E=D*.5;if(A>1.1920928955078125e-07){F=A/(E<.5?D:2.0-B-C);C=60.0/A;do if(!(B==z))if(B==y){G=(x-z)*C+120.0;break}else{G=(z-y)*C+240.0;break}else G=(y-x)*C;while(0);if(G<0.0){H=F;I=G+360.0}else{H=F;I=G}}else{H=0.0;I=0.0}n[i+(w<<2)>>2]=I*+n[m>>2];n[i+(w+1<<2)>>2]=E;n[i+(w+2<<2)>>2]=H;w=w+3|0;if((w|0)>=(p|0))break;else v=v+(s<<2)|0}if(q){s=0;do{v=mrc(+n[i+(s<<2)>>2])|0;b[a+s>>0]=v>>>0<256?v:(v|0)>0?255:0;v=s+1|0;w=mrc(+n[i+(v<<2)>>2]*255.0)|0;b[a+v>>0]=w>>>0<256?w:(w|0)>0?255:0;w=s+2|0;v=mrc(+n[i+(w<<2)>>2]*255.0)|0;b[a+w>>0]=v>>>0<256?v:(v|0)>0?255:0;s=s+3|0}while((s|0)<(p|0));J=r}else J=r}else J=r}else J=o;d=d+256|0;if((d|0)>=(e|0))break;else{a=a+768|0;o=J}}u=g;return}function swa(a){a=a|0;YDc(a);return}function twa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;i=h*3|0;if((h|0)<=0){h=c;do h=h+1|0;while((h|0)<(d|0));return}h=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=h;h=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c+4>>2]|0;l=f[c>>2]|0;m=+n[c+8>>2]*2.7777778450399637e-03;c=k^2;o=h;p=0;while(1){q=+n[o+(k<<2)>>2];r=+n[o+4>>2];s=+n[o+(c<<2)>>2];t=s<r?r:s;u=t<q?q:t;t=s>r?r:s;v=u-(t>q?q:t);t=v/(+L(+u)+1.1920928955078125e-07);w=60.0/(v+1.1920928955078125e-07);do if(!(u==s))if(u==r){x=(q-s)*w+120.0;break}else{x=(s-r)*w+240.0;break}else x=(r-q)*w;while(0);n[j+(p<<2)>>2]=m*(x<0.0?x+360.0:x);n[j+(p+1<<2)>>2]=t;n[j+(p+2<<2)>>2]=u;p=p+3|0;if((p|0)>=(i|0))break;else o=o+(l<<2)|0}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;h=h+b|0}}return}function uwa(a){a=a|0;YDc(a);return}function vwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){wwa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function wwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=f[a+4>>2]|0;i=f[a>>2]|0;j=f[a+8>>2]|0;a=(j|0)==180?877956:878980;k=e*3|0;if(!(b[1152659]|0)){f[219745]=0;f[219489]=0;f[220001]=0;l=1;do{m=+(l|0);n=nrc(1044480.0/m)|0;f[880004+(l<<2)>>2]=n;o=m*6.0;n=nrc(737280.0/o)|0;f[877956+(l<<2)>>2]=n;n=nrc(1048576.0/o)|0;f[878980+(l<<2)>>2]=n;l=l+1|0}while((l|0)!=256);b[1152659]=1}if((e|0)<=0)return;e=g^2;l=c;c=0;while(1){n=h[l+g>>0]|0;p=h[l+1>>0]|0;q=h[l+e>>0]|0;r=p-n|0;s=r+256|0;if(s>>>0<769)t=h[271964+s>>0]|0;else t=0;s=t+n|0;u=q-s+256|0;if(u>>>0<769)v=h[271964+u>>0]|0;else v=0;u=v+s|0;s=n-p+256|0;if(s>>>0<769)w=h[271964+s>>0]|0;else w=0;s=n-w|0;x=s-q+256|0;if(x>>>0<769)y=h[271964+x>>0]|0;else y=0;x=y-s+u|0;s=(x>>>0<256?x:(x|0)>0?255:0)&255;x=((Y(s,f[880004+(u<<2)>>2]|0)|0)+2048|0)>>>12;z=(Y((u|0)==(q|0)?r:(u|0)==(p|0)?n-q+(s<<1)|0:q-p+(s<<2)|0,f[a+(s<<2)>>2]|0)|0)+2048>>12;s=((z|0)<0?j:0)+z|0;b[d+c>>0]=s>>>0<256?s:(s|0)>0?255:0;b[d+(c+1)>>0]=x;b[d+(c+2)>>0]=u;c=c+3|0;if((c|0)>=(k|0))break;else l=l+i|0}return}function xwa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0;m=u;u=u+64|0;o=m+48|0;p=m+16|0;q=m;r=(h|0)==5?360:k?255:180;k=j?2:0;j=(h|0)==0;if(l)if(j){f[q>>2]=i;f[q+4>>2]=k;n[q+8>>2]=6.0/+(r|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=60420;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=q;y8(o,p,+(Y(g,e)|0)*.0000152587890625);u=m;return}else{f[q>>2]=i;f[q+4>>2]=k;n[q+8>>2]=6.0/+(r|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=60440;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=q;y8(o,p,+(Y(g,e)|0)*.0000152587890625);u=m;return}else if(j){f[q>>2]=i;f[q+4>>2]=3;f[q+8>>2]=k;n[q+12>>2]=6.0/+(r|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=60460;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=q;y8(o,p,+(Y(g,e)|0)*.0000152587890625);u=m;return}else{f[q>>2]=i;f[q+4>>2]=k;n[q+8>>2]=6.0/+(r|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=60480;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=q;y8(o,p,+(Y(g,e)|0)*.0000152587890625);u=m;return}}function ywa(a){a=a|0;YDc(a);return}function zwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){Awa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function Awa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=f[a>>2]|0;j=d*3|0;if((d|0)<=0){u=e;return}d=h^2;k=a+8|0;a=g+4|0;l=g+8|0;m=g+12|0;if((i|0)==4){o=0;p=c;while(1){q=+n[b+(o<<2)>>2];r=+n[b+(o+1<<2)>>2];s=+n[b+(o+2<<2)>>2];if(s==0.0){t=r;v=r;w=r}else{if(!(r<=.5))x=r+s-r*s;else x=r*(s+1.0);s=r*2.0-x;r=q*+n[k>>2];if(!(r<0.0))if(!(r>=6.0))y=r;else{q=r;while(1){z=q+-6.0;if(!(z>=6.0)){y=z;break}else q=z}}else{q=r;while(1){z=q+6.0;if(z<0.0)q=z;else{y=z;break}}}A=~~y;B=A-(+(A|0)>y&1)|0;q=y-+(B|0);n[g>>2]=x;n[a>>2]=s;r=x-s;n[l>>2]=s+r*(1.0-q);n[m>>2]=s+r*q;t=+n[g+(f[60492+(B*12|0)+8>>2]<<2)>>2];v=+n[g+(f[60492+(B*12|0)+4>>2]<<2)>>2];w=+n[g+(f[60492+(B*12|0)>>2]<<2)>>2]}n[p+(h<<2)>>2]=w;n[p+4>>2]=v;n[p+(d<<2)>>2]=t;n[p+12>>2]=1.0;o=o+3|0;if((o|0)>=(j|0))break;else p=p+16|0}u=e;return}else{p=0;o=c;while(1){t=+n[b+(p<<2)>>2];v=+n[b+(p+1<<2)>>2];w=+n[b+(p+2<<2)>>2];if(w==0.0){C=v;D=v;E=v}else{if(!(v<=.5))F=v+w-v*w;else F=v*(w+1.0);w=v*2.0-F;v=t*+n[k>>2];if(!(v<0.0))if(!(v>=6.0))G=v;else{t=v;while(1){x=t+-6.0;if(!(x>=6.0)){G=x;break}else t=x}}else{t=v;while(1){s=t+6.0;if(s<0.0)t=s;else{G=s;break}}}c=~~G;B=c-(+(c|0)>G&1)|0;t=G-+(B|0);n[g>>2]=F;n[a>>2]=w;v=F-w;n[l>>2]=w+v*(1.0-t);n[m>>2]=w+v*t;C=+n[g+(f[60492+(B*12|0)+8>>2]<<2)>>2];D=+n[g+(f[60492+(B*12|0)+4>>2]<<2)>>2];E=+n[g+(f[60492+(B*12|0)>>2]<<2)>>2]}n[o+(h<<2)>>2]=E;n[o+4>>2]=D;n[o+(d<<2)>>2]=C;p=p+3|0;if((p|0)>=(j|0))break;else o=o+(i<<2)|0}u=e;return}}function Bwa(a){a=a|0;YDc(a);return}function Cwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){Dwa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function Dwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+4|0;a=(j|0)==4;l=d;d=0;m=c;while(1){c=e-d|0;o=(c|0)<256?c:256;p=o*3|0;q=(c|0)>0;if(q){c=0;do{n[i+(c<<2)>>2]=+(h[m+c>>0]|0);r=c+1|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;r=c+2|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;c=c+3|0}while((c|0)<(p|0));Awa(k,i,i,o);if(q)if(a){c=0;r=l;while(1){s=mrc(+n[i+(c<<2)>>2]*255.0)|0;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=mrc(+n[i+(c+1<<2)>>2]*255.0)|0;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=mrc(+n[i+(c+2<<2)>>2]*255.0)|0;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;c=c+3|0;s=r+4|0;if((c|0)>=(p|0)){t=s;break}else r=s}}else{r=0;c=l;while(1){q=mrc(+n[i+(r<<2)>>2]*255.0)|0;b[c>>0]=q>>>0<256?q:(q|0)>0?255:0;q=mrc(+n[i+(r+1<<2)>>2]*255.0)|0;b[c+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=mrc(+n[i+(r+2<<2)>>2]*255.0)|0;b[c+2>>0]=q>>>0<256?q:(q|0)>0?255:0;r=r+3|0;q=c+j|0;if((r|0)>=(p|0)){t=q;break}else c=q}}else t=l}else{Awa(k,i,i,o);t=l}d=d+256|0;if((d|0)>=(e|0))break;else{l=t;m=m+768|0}}u=g;return}function Ewa(a){a=a|0;YDc(a);return}function Fwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0;c=u;u=u+16|0;d=c;e=f[b>>2]|0;g=f[b+4>>2]|0;if((e|0)>=(g|0)){u=c;return}b=f[a+16>>2]|0;h=(f[a+12>>2]|0)+(Y(b,e)|0)|0;i=f[a+8>>2]|0;j=(f[a+4>>2]|0)+(Y(i,e)|0)|0;k=a+24|0;l=d+4|0;m=d+8|0;o=d+12|0;p=d+4|0;q=d+8|0;r=d+12|0;s=f[a+20>>2]|0;a=s*3|0;t=(s|0)>0;s=h;h=j;j=e;while(1){e=f[k>>2]|0;v=f[e+4>>2]|0;w=f[e>>2]|0;if((w|0)==3){if(t){x=e+8|0;y=v^2;z=0;A=s;while(1){B=h+(z<<2)|0;C=+n[B+4>>2];D=+n[B+8>>2];if(C==0.0){E=D;F=D;G=D}else{H=+n[x>>2]*+n[B>>2];if(!(H<0.0))if(!(H>=6.0))I=H;else{J=H;while(1){K=J+-6.0;if(!(K>=6.0)){I=K;break}else J=K}}else{J=H;while(1){K=J+6.0;if(K<0.0)J=K;else{I=K;break}}}B=~~I;L=B-(+(B|0)>I&1)|0;B=L>>>0>5;J=B?0.0:I-+(L|0);M=B?0:L;n[d>>2]=D;n[l>>2]=D*(1.0-C);n[m>>2]=D*(1.0-C*J);n[o>>2]=D*(1.0-C*(1.0-J));E=+n[d+(f[60564+(M*12|0)+8>>2]<<2)>>2];F=+n[d+(f[60564+(M*12|0)+4>>2]<<2)>>2];G=+n[d+(f[60564+(M*12|0)>>2]<<2)>>2]}n[A+(v<<2)>>2]=G;n[A+4>>2]=F;n[A+(y<<2)>>2]=E;z=z+3|0;if((z|0)>=(a|0))break;else A=A+12|0}}}else if(t){A=e+8|0;z=v^2;y=0;x=s;while(1){M=h+(y<<2)|0;J=+n[M+4>>2];H=+n[M+8>>2];if(J==0.0){N=H;O=H;P=H}else{K=+n[A>>2]*+n[M>>2];if(!(K<0.0))if(!(K>=6.0))Q=K;else{R=K;while(1){S=R+-6.0;if(!(S>=6.0)){Q=S;break}else R=S}}else{R=K;while(1){C=R+6.0;if(C<0.0)R=C;else{Q=C;break}}}M=~~Q;L=M-(+(M|0)>Q&1)|0;M=L>>>0>5;R=M?0.0:Q-+(L|0);B=M?0:L;n[d>>2]=H;n[p>>2]=H*(1.0-J);n[q>>2]=H*(1.0-J*R);n[r>>2]=H*(1.0-J*(1.0-R));N=+n[d+(f[60564+(B*12|0)+8>>2]<<2)>>2];O=+n[d+(f[60564+(B*12|0)+4>>2]<<2)>>2];P=+n[d+(f[60564+(B*12|0)>>2]<<2)>>2]}n[x+(v<<2)>>2]=P;n[x+4>>2]=O;n[x+(z<<2)>>2]=N;n[x+12>>2]=1.0;y=y+3|0;if((y|0)>=(a|0))break;else x=x+(w<<2)|0}}j=j+1|0;if((j|0)>=(g|0))break;else{s=s+b|0;h=h+i|0}}u=c;return}function Gwa(a){a=a|0;YDc(a);return}function Hwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){Iwa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function Iwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0;g=u;u=u+48|0;i=g+24|0;j=g;k=f[a>>2]|0;l=e*3|0;if((e|0)<=0){u=g;return}e=j+4|0;m=j+8|0;o=j+12|0;p=a+4|0;q=j+16|0;r=j+20|0;s=(k|0)==4;t=a+8|0;a=i+4|0;v=i+8|0;w=i+12|0;x=0;y=d;while(1){z=+(h[c+x>>0]|0);n[j>>2]=z;A=+(h[c+(x+1)>>0]|0)*.003921568859368563;n[e>>2]=A;B=+(h[c+(x+2)>>0]|0)*.003921568859368563;n[m>>2]=B;d=f[p>>2]|0;if(A==0.0){C=B;D=B;E=B}else{F=+n[t>>2]*z;if(!(F<0.0))if(!(F>=6.0))G=F;else{z=F;while(1){H=z+-6.0;if(!(H>=6.0)){G=H;break}else z=H}}else{z=F;while(1){H=z+6.0;if(H<0.0)z=H;else{G=H;break}}}I=~~G;J=I-(+(I|0)>G&1)|0;I=J>>>0>5;z=I?0.0:G-+(J|0);K=I?0:J;n[i>>2]=B;n[a>>2]=B*(1.0-A);n[v>>2]=B*(1.0-A*z);n[w>>2]=B*(1.0-A*(1.0-z));C=+n[i+(f[60564+(K*12|0)+8>>2]<<2)>>2];D=+n[i+(f[60564+(K*12|0)+4>>2]<<2)>>2];E=+n[i+(f[60564+(K*12|0)>>2]<<2)>>2]}n[o+(d<<2)>>2]=E;n[q>>2]=D;n[o+((d^2)<<2)>>2]=C;K=mrc(+n[o>>2]*255.0)|0;b[y>>0]=K>>>0<256?K:(K|0)>0?255:0;K=mrc(+n[q>>2]*255.0)|0;b[y+1>>0]=K>>>0<256?K:(K|0)>0?255:0;K=mrc(+n[r>>2]*255.0)|0;b[y+2>>0]=K>>>0<256?K:(K|0)>0?255:0;if(s)b[y+3>>0]=-1;x=x+3|0;if((x|0)>=(l|0))break;else y=y+k|0}u=g;return}function Jwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;Kwa(g,a,b,3);mwa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,d,0);Lwa(g);u=e;return}function Kwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=x>>>3;n=(m&511)+1|0;f[a+116>>2]=n;y=x&7;z=a+112|0;f[z>>2]=y;if((m&510|0)!=2)e2(n,60636);if((e|0)!=3)e2(e,60664);switch(x&7){case 0:case 5:break;default:b2(y,60692)}y=c+4|0;x=d+4|0;if((f[y>>2]|0)!=(f[x>>2]|0)){do if((d$(c)|0)==65536){e=f[y>>2]|0;f[h>>2]=f[e>>2];n=h+4|0;m=e+4|0;f[n>>2]=f[m>>2];A=h+8|0;f[A>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];B=f[e+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=A;A=h+48|0;C=h+44|0;f[C>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[m>>2]|0)<3){m=f[e+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[m>>2];f[A+4>>2]=f[m+4>>2];break}else{f[n>>2]=0;ZS(h,e);break}}else a$(h,c,-1);while(0);y=h+36|0;e=f[y>>2]|0;if((a|0)==(h|0))D=e;else{if(e|0){n=e+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+36|0;e=f[n>>2]|0;if(e|0?(m=e+12|0,e=f[m>>2]|0,f[m>>2]=e+-1,(e|0)==1):0)_S(a);f[n>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[j>>2]|0)>0){m=f[l>>2]|0;A=0;do{f[m+(A<<2)>>2]=0;A=A+1|0;E=f[j>>2]|0}while((A|0)<(E|0));f[a>>2]=f[h>>2];if((E|0)<3)F=29;else F=31}else{f[a>>2]=f[h>>2];F=29}if((F|0)==29){E=f[h+4>>2]|0;if((E|0)<3){f[j>>2]=E;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;E=f[p>>2]|0;f[E>>2]=f[k>>2];f[E+4>>2]=f[k+4>>2]}else F=31}if((F|0)==31)ZS(a,h);f[e>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];e=f[y>>2]|0;f[n>>2]=e;D=e}if(D|0?(e=D+12|0,D=f[e>>2]|0,f[e>>2]=D+-1,(D|0)==1):0)_S(h);f[y>>2]=0;y=h+16|0;D=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[D>>2]|0)>0){y=f[h+40>>2]|0;e=0;do{f[y+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[D>>2]|0))}D=f[h+44>>2]|0;if((D|0)!=(h+48|0))g0(D)}else{D=h+8|0;f[D>>2]=0;f[D+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;D=f[c>>2]|0;f[t>>2]=l;f[w>>2]=D;f[i>>2]=l;f[i+4>>2]=D;v$(d,i,f[z>>2]&7|16,-1,0,0);do if((d$(d)|0)==65536){z=f[x>>2]|0;f[h>>2]=f[z>>2];i=h+4|0;D=z+4|0;f[i>>2]=f[D>>2];l=h+8|0;f[l>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];w=f[z+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[D>>2]|0)<3){D=f[z+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[D>>2];f[l+4>>2]=f[D+4>>2];break}else{f[i>>2]=0;ZS(h,z);break}}else a$(h,d,-1);while(0);d=h+36|0;x=f[d>>2]|0;if((o|0)==(h|0))G=x;else{if(x|0){z=x+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+92|0;x=f[z>>2]|0;if(x|0?(i=x+12|0,x=f[i>>2]|0,f[i>>2]=x+-1,(x|0)==1):0)_S(o);f[z>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;H=f[q>>2]|0}while((s|0)<(H|0));f[o>>2]=f[h>>2];if((H|0)<3)F=60;else F=62}else{f[o>>2]=f[h>>2];F=60}if((F|0)==60){H=f[h+4>>2]|0;if((H|0)<3){f[q>>2]=H;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;H=f[v>>2]|0;f[H>>2]=f[r>>2];f[H+4>>2]=f[r+4>>2]}else F=62}if((F|0)==62)ZS(o,h);f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[z>>2]=a;G=a}if(G|0?(a=G+12|0,G=f[a>>2]|0,f[a>>2]=G+-1,(G|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;G=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[G>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)==(h+48|0)){u=g;return}g0(G);u=g;return}function Lwa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function Mwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;Kwa(g,a,b,3);mwa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,d,1);Lwa(g);u=e;return}function Nwa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;Owa(h,a,b,i);xwa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,e,0);Pwa(h);u=g;return}function Owa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=(x>>>3&511)+1|0;f[a+116>>2]=m;n=x&7;y=a+112|0;f[y>>2]=n;if((m|0)!=3)e2(m,60720);if((e+-3|0)>>>0>=2)e2(e,60748);switch(x&7){case 0:case 5:break;default:b2(n,60776)}n=c+4|0;x=d+4|0;if((f[n>>2]|0)!=(f[x>>2]|0)){do if((d$(c)|0)==65536){m=f[n>>2]|0;f[h>>2]=f[m>>2];z=h+4|0;A=m+4|0;f[z>>2]=f[A>>2];B=h+8|0;f[B>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];C=f[m+36>>2]|0;f[h+36>>2]=C;f[h+40>>2]=B;B=h+48|0;D=h+44|0;f[D>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[m+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;ZS(h,m);break}}else a$(h,c,-1);while(0);n=h+36|0;m=f[n>>2]|0;if((a|0)==(h|0))E=m;else{if(m|0){z=m+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+36|0;m=f[z>>2]|0;if(m|0?(A=m+12|0,m=f[A>>2]|0,f[A>>2]=m+-1,(m|0)==1):0)_S(a);f[z>>2]=0;m=a+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0;F=f[j>>2]|0}while((B|0)<(F|0));f[a>>2]=f[h>>2];if((F|0)<3)G=29;else G=31}else{f[a>>2]=f[h>>2];G=29}if((G|0)==29){F=f[h+4>>2]|0;if((F|0)<3){f[j>>2]=F;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;F=f[p>>2]|0;f[F>>2]=f[k>>2];f[F+4>>2]=f[k+4>>2]}else G=31}if((G|0)==31)ZS(a,h);f[m>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];m=f[n>>2]|0;f[z>>2]=m;E=m}if(E|0?(m=E+12|0,E=f[m>>2]|0,f[m>>2]=E+-1,(E|0)==1):0)_S(h);f[n>>2]=0;n=h+16|0;E=h+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[E>>2]|0)>0){n=f[h+40>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[E>>2]|0))}E=f[h+44>>2]|0;if((E|0)!=(h+48|0))g0(E)}else{E=h+8|0;f[E>>2]=0;f[E+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;E=f[c>>2]|0;f[t>>2]=l;f[w>>2]=E;f[i>>2]=l;f[i+4>>2]=E;v$(d,i,f[y>>2]&7|(e<<3)+-8,-1,0,0);do if((d$(d)|0)==65536){e=f[x>>2]|0;f[h>>2]=f[e>>2];y=h+4|0;i=e+4|0;f[y>>2]=f[i>>2];E=h+8|0;f[E>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=E;E=h+48|0;w=h+44|0;f[w>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(l|0){E=l+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;E=f[w>>2]|0;f[E>>2]=f[i>>2];f[E+4>>2]=f[i+4>>2];break}else{f[y>>2]=0;ZS(h,e);break}}else a$(h,d,-1);while(0);d=h+36|0;x=f[d>>2]|0;if((o|0)==(h|0))H=x;else{if(x|0){e=x+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+92|0;x=f[e>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)_S(o);f[e>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){y=f[s>>2]|0;s=0;do{f[y+(s<<2)>>2]=0;s=s+1|0;I=f[q>>2]|0}while((s|0)<(I|0));f[o>>2]=f[h>>2];if((I|0)<3)G=60;else G=62}else{f[o>>2]=f[h>>2];G=60}if((G|0)==60){I=f[h+4>>2]|0;if((I|0)<3){f[q>>2]=I;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;I=f[v>>2]|0;f[I>>2]=f[r>>2];f[I+4>>2]=f[r+4>>2]}else G=62}if((G|0)==62)ZS(o,h);f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[e>>2]=a;H=a}if(H|0?(a=H+12|0,H=f[a>>2]|0,f[a>>2]=H+-1,(H|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;H=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[H>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[H>>2]|0))}H=f[h+44>>2]|0;if((H|0)==(h+48|0)){u=g;return}g0(H);u=g;return}function Pwa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function Qwa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;Owa(h,a,b,i);xwa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,e,1);Pwa(h);u=g;return}function Rwa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;i=+i;var j=0,k=0,l=0.0;a:do if(X$(b)|0){j=c$(b,-1)|0;switch(j|0){case 13:case 21:{k=j;break a;break}default:{}}c2(j,60804)}else k=13;while(0);l=c;c=d;if(f==0.0&g==0.0){Swa(a,b,k,l,c,e,2147483647,h,i);return}else{j=nrc(f)|0;Twa(a,b,k,l,c,e,j,nrc(g)|0,2147483647,h,i);return}}function Swa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0;l=u;u=u+2544|0;m=l+224|0;o=l+2480|0;p=l+2424|0;q=l;r=l+2408|0;s=l+1344|0;t=l+280|0;v=(d|0)==13;switch(d|0){case 13:case 21:break;default:c2(d,60860)}do if((d$(a)|0)==65536){w=f[a+4>>2]|0;f[o>>2]=f[w>>2];x=o+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[w+8>>2];f[o+12>>2]=f[w+12>>2];f[o+16>>2]=f[w+16>>2];f[o+20>>2]=f[w+20>>2];f[o+24>>2]=f[w+24>>2];f[o+28>>2]=f[w+28>>2];f[o+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;B=o+44|0;f[B>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];C=o;break}else{f[x>>2]=0;ZS(o,w);C=o;break}}else{a$(o,a,-1);C=o}while(0);D=1.0/e;if(f[C>>2]&4095|0){f[m>>2]=0;f[m+4>>2]=0;E=tT(m,21)|0;F=284606;G=E+21|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,m,284884,284643,120)}if((i|0)<=0){f[m>>2]=0;f[m+4>>2]=0;E=tT(m,12)|0;F=284710;G=E+12|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,m,284884,284643,121)}F=o+16|0;C=f[F>>2]|0;a=o+44|0;w=o+48|0;x=f[w>>2]|0;y=f[o+12>>2]|0;z=f[o+8>>2]|0;if(!(k>=j))a2(k,j,60888);B=nrc((k-j)/g)|0;A=mrc(+(z+y<<1|1|0)/e)|0;H=A+2|0;AY(q,B+2|0,H,4);f[p>>2]=1124007936;I=p+4|0;J=p+8|0;K=p+40|0;E=I;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[K>>2]=J;J=p+48|0;E=p+44|0;f[E>>2]=J;f[J>>2]=0;f[p+52>>2]=0;G=f[q>>2]|0;ei[f[(f[G>>2]|0)+12>>2]&511](G,q,p,-1);$j(q);f[r>>2]=0;q=r+4|0;f[q>>2]=0;f[r+8>>2]=0;G=s+8|0;f[s>>2]=G;L=s+4|0;M=B>>>0>264;f[L>>2]=B;if(M){N=XDc(B>>>0>1073741823?-1:B<<2)|0;f[s>>2]=N;Q=N}else Q=G;N=t+8|0;f[t>>2]=N;R=t+4|0;f[R>>2]=B;if(M){M=XDc(B>>>0>1073741823?-1:B<<2)|0;f[t>>2]=M;S=M}else S=N;M=p+16|0;T=f[M>>2]|0;U=(B|0)>0;if(U){k=D;D=j;V=0;while(1){W=D;X=k*+P(+W);n[Q+(V<<2)>>2]=X;X=k*+O(+W);n[S+(V<<2)>>2]=X;V=V+1|0;if((V|0)==(B|0))break;else D=D+g}}if((z|0)>0?(V=((A+-1|0)/2|0)+1|0,(y|0)>0):0){Z=0;do{_=Y(Z,x)|0;D=+(Z|0);if(U){$=0;do{if(b[C+($+_)>>0]|0){k=+($|0);aa=0;do{ba=aa;aa=aa+1|0;ca=T+(V+(Y(aa,H)|0)+(mrc(k*+n[S+(ba<<2)>>2]+D*+n[Q+(ba<<2)>>2])|0)<<2)|0;f[ca>>2]=(f[ca>>2]|0)+1}while((aa|0)!=(B|0))}$=$+1|0}while(($|0)!=(y|0))}Z=Z+1|0}while((Z|0)!=(z|0))}if((A|0)>0?(z=-2-A|0,Z=r+8|0,U):0){U=0;do{y=0;do{y=y+1|0;Q=(Y(y,H)|0)+U|0;S=Q+1|0;f[m>>2]=S;V=f[T+(S<<2)>>2]|0;do if(((((V|0)>(h|0)?(V|0)>(f[T+(Q<<2)>>2]|0):0)?(V|0)>=(f[T+(Q+2<<2)>>2]|0):0)?(V|0)>(f[T+(z+S<<2)>>2]|0):0)?(V|0)>=(f[T+(S+H<<2)>>2]|0):0){C=f[q>>2]|0;if((C|0)==(f[Z>>2]|0)){g6(r,m);break}else{f[C>>2]=S;f[q>>2]=C+4;break}}while(0)}while((y|0)!=(B|0));U=U+1|0}while((U|0)!=(A|0));da=f[r>>2]|0;ea=f[q>>2]|0}else{da=0;ea=0}f[m>>2]=T;Vwa(da,ea,m);ea=(f[q>>2]|0)-(f[r>>2]|0)>>2;da=(ea|0)<(i|0)?ea:i;D=1.0/+(H|0);Y$(c,da,1,d,-1,0,0);do if((d$(c)|0)==65536){d=f[c+4>>2]|0;f[m>>2]=f[d>>2];i=m+4|0;ea=d+4|0;f[i>>2]=f[ea>>2];U=m+8|0;f[U>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];B=f[d+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=U;U=m+48|0;Z=m+44|0;f[Z>>2]=U;f[U>>2]=0;f[m+52>>2]=0;if(B|0){U=B+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[d+44>>2]|0;U=f[Z>>2]|0;f[U>>2]=f[ea>>2];f[U+4>>2]=f[ea+4>>2];break}else{f[i>>2]=0;ZS(m,d);break}}else a$(m,c,-1);while(0);if((da|0)>0){k=+(A+-1|0)*.5;X=j;A=m+16|0;c=m+40|0;d=m+44|0;i=m+12|0;if(v){v=0;do{ea=f[(f[r>>2]|0)+(v<<2)>>2]|0;j=D*+(ea|0);U=~~j;Z=U-(+(U|0)>j&1)|0;j=(+(ea+-1-(Y(Z,H)|0)|0)-k)*e;W=X+ +(Z+-1|0)*g;Z=f[A>>2]|0;do if((f[m>>2]&16384|0)==0?(ea=f[c>>2]|0,(f[ea>>2]|0)!=1):0){U=f[f[d>>2]>>2]|0;if((f[ea+4>>2]|0)==1){fa=Z+(Y(U,v)|0)|0;break}else{ea=f[i>>2]|0;B=(v|0)/(ea|0)|0;fa=Z+(Y(B,U)|0)+(v-(Y(B,ea)|0)<<3)|0;break}}else ga=59;while(0);if((ga|0)==59){ga=0;fa=Z+(v<<3)|0}n[fa>>2]=j;n[fa+4>>2]=W;v=v+1|0}while((v|0)<(da|0))}else{v=0;do{fa=f[(f[r>>2]|0)+(v<<2)>>2]|0;ha=D*+(fa|0);ea=~~ha;B=ea-(+(ea|0)>ha&1)|0;ha=(+(fa+-1-(Y(B,H)|0)|0)-k)*e;ia=X+ +(B+-1|0)*g;ja=+(f[T+(fa<<2)>>2]|0);fa=f[A>>2]|0;do if((f[m>>2]&16384|0)==0?(B=f[c>>2]|0,(f[B>>2]|0)!=1):0){ea=f[f[d>>2]>>2]|0;if((f[B+4>>2]|0)==1){ka=fa+(Y(ea,v)|0)|0;break}else{B=f[i>>2]|0;U=(v|0)/(B|0)|0;ka=fa+(Y(U,ea)|0)+((v-(Y(U,B)|0)|0)*12|0)|0;break}}else ga=63;while(0);if((ga|0)==63){ga=0;ka=fa+(v*12|0)|0}n[ka>>2]=ha;n[ka+4>>2]=ia;n[ka+8>>2]=ja;v=v+1|0}while((v|0)<(da|0))}}da=m+36|0;v=f[da>>2]|0;if(v|0?(ka=v+12|0,v=f[ka>>2]|0,f[ka>>2]=v+-1,(v|0)==1):0)_S(m);f[da>>2]=0;da=m+16|0;v=m+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[v>>2]|0)>0){da=f[m+40>>2]|0;ka=0;do{f[da+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[v>>2]|0))}v=f[m+44>>2]|0;if((v|0)!=(m+48|0))g0(v);v=f[t>>2]|0;if((v|0)!=(N|0)){if(v|0)ZDc(v);f[t>>2]=N;f[R>>2]=264}R=f[s>>2]|0;if((R|0)!=(G|0)){if(R|0)ZDc(R);f[s>>2]=G;f[L>>2]=264}L=f[r>>2]|0;if(L|0){r=f[q>>2]|0;if((r|0)!=(L|0))f[q>>2]=r+(~((r+-4-L|0)>>>2)<<2);YDc(L)}L=p+36|0;r=f[L>>2]|0;if(r|0?(q=r+12|0,r=f[q>>2]|0,f[q>>2]=r+-1,(r|0)==1):0)_S(p);f[L>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[I>>2]|0)>0){M=f[K>>2]|0;K=0;do{f[M+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[I>>2]|0))}I=f[E>>2]|0;if((I|0)!=(J|0))g0(I);I=o+36|0;J=f[I>>2]|0;do if(J|0){E=J+12|0;K=f[E>>2]|0;f[E>>2]=K+-1;if((K|0)!=1)break;_S(o)}while(0);f[I>>2]=0;I=o+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[I>>2]|0)>0){F=f[o+40>>2]|0;o=0;do{f[F+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[I>>2]|0))}I=f[a>>2]|0;if((I|0)==(w|0)){u=l;return}g0(I);u=l;return}function Twa(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=+e;g=+g;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;o=+o;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,N=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;p=u;u=u+192|0;q=p+128|0;r=p+116|0;s=p+104|0;t=p+92|0;v=p+80|0;w=p+68|0;x=p+56|0;y=p;z=(d|0)==13;switch(d|0){case 13:case 21:break;default:c2(d,60832)}do if((d$(a)|0)==65536){A=f[a+4>>2]|0;f[q>>2]=f[A>>2];B=q+4|0;C=A+4|0;f[B>>2]=f[C>>2];D=q+8|0;f[D>>2]=f[A+8>>2];f[q+12>>2]=f[A+12>>2];f[q+16>>2]=f[A+16>>2];f[q+20>>2]=f[A+20>>2];f[q+24>>2]=f[A+24>>2];f[q+28>>2]=f[A+28>>2];f[q+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[q+36>>2]=E;f[q+40>>2]=D;D=q+48|0;F=q+44|0;f[F>>2]=D;f[D>>2]=0;f[q+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];G=q;break}else{f[B>>2]=0;ZS(q,A);G=q;break}}else{a$(q,a,-1);G=q}while(0);A=Y(k,j)|0;f[r>>2]=0;B=r+4|0;f[B>>2]=0;f[r+8>>2]=0;if(f[G>>2]&4095|0){f[s>>2]=0;f[s+4>>2]=0;H=tT(s,21)|0;I=284606;J=H+21|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));z5(-215,s,284628,284643,262)}if((l|0)<=0){f[s>>2]=0;f[s+4>>2]=0;H=tT(s,12)|0;I=284710;J=H+12|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));z5(-215,s,284628,284643,263)}I=(i|0)<255?i:255;i=q+16|0;H=f[i>>2]|0;J=q+44|0;G=q+48|0;C=f[G>>2]|0;D=f[q+12>>2]|0;F=f[q+8>>2]|0;K=1.0/e;N=1.0/g;P=+(j|0);Q=e/P;R=g/+(k|0);S=1.0/Q;T=1.0/R;U=+(D|0);V=+(F|0);W=K*+M(+(U*U+V*V));j=~~W;E=j-(+(j|0)>W&1)|0;W=N;V=W*6.283185307179586;j=~~V;X=j-(+(j|0)>V&1)|0;f[s>>2]=I;n[s+4>>2]=-1.0;n[s+8>>2]=0.0;j=r+8|0;Uwa(r,s);Z=Y(k*5|0,X)|0;f[s>>2]=0;_=s+4|0;f[_>>2]=0;f[s+8>>2]=0;if(!Z)$=0;else{if(Z>>>0>1073741823)mCc(s);aa=Z<<2;ba=VDc(aa)|0;f[s>>2]=ba;ca=ba+(Z<<2)|0;f[s+8>>2]=ca;XIc(ba|0,0,aa|0)|0;f[_>>2]=ca;ca=0;do{V=+O(+(R*+(ca|0)*.20000000298023224));n[ba+(ca<<2)>>2]=V;ca=ca+1|0}while((ca|0)!=(Z|0));$=ba}ba=Y(E,X)|0;f[t>>2]=0;Z=t+4|0;f[Z>>2]=0;f[t+8>>2]=0;if(!ba)da=0;else{if((ba|0)<0)mCc(t);ca=VDc(ba)|0;f[Z>>2]=ca;f[t>>2]=ca;f[t+8>>2]=ca+ba;aa=ba;ea=ca;do{b[ea>>0]=0;ea=(f[Z>>2]|0)+1|0;f[Z>>2]=ea;aa=aa+-1|0}while((aa|0)!=0);da=f[t>>2]|0}aa=(F|0)>0;if(aa&(D|0)>0){ea=0;ca=0;while(1){fa=Y(ea,C)|0;ga=0;ha=ca;do{ha=((b[H+(ga+fa)>>0]|0)!=0&1)+ha|0;ga=ga+1|0}while((ga|0)!=(D|0));ea=ea+1|0;if((ea|0)==(F|0)){ia=ha;break}else ca=ha}}else ia=0;f[v>>2]=0;ca=v+4|0;f[ca>>2]=0;f[v+8>>2]=0;ea=(ia|0)==0;do if(!ea)if(ia>>>0>1073741823)mCc(v);else{ga=ia<<2;fa=VDc(ga)|0;f[v>>2]=fa;ja=fa+(ia<<2)|0;f[v+8>>2]=ja;XIc(fa|0,0,ga|0)|0;f[ca>>2]=ja;ka=fa;break}else ka=0;while(0);f[w>>2]=0;fa=w+4|0;f[fa>>2]=0;f[w+8>>2]=0;if(ea){la=0;ma=0}else{ea=ia<<2;ja=VDc(ea)|0;f[w>>2]=ja;ga=ja+(ia<<2)|0;f[w+8>>2]=ga;XIc(ja|0,0,ea|0)|0;f[fa>>2]=ga;la=ja;ma=ja}if(aa){aa=(D|0)>0;ja=0;ga=0;while(1){if(aa){ea=Y(ga,C)|0;V=+(ga|0)+.5;U=V;na=U*U;oa=0;pa=ja;while(1){if(b[H+(oa+ea)>>0]|0){f[ka+(pa<<2)>>2]=oa;f[la+(pa<<2)>>2]=ga;qa=pa+1|0;U=+(oa|0)+.5;ra=+L(+(+o3(V,U)*.01745329238474369));sa=U;U=+M(+(na+sa*sa));sa=K*U;ta=W*(ra+1.5707963267948966);ua=~~ta;va=da+(ua-(+(ua|0)>ta&1))|0;b[va>>0]=(b[va>>0]|0)+1<<24>>24;ta=e/U;U=ta<g?ta:g;ta=N*U;wa=3.141592653589793/U;va=~~wa;ua=va-(+(va|0)>wa&1)|0;if((ua|0)>1){wa=N*(ra+U);ra=-1.5707963705062866;va=-1;xa=1;while(1){ra=U+ra;ya=~~wa;za=va;va=(Y(~~(sa*+O(+ra)),X)|0)+(ya-(+(ya|0)>wa&1))|0;ya=da+va|0;b[ya>>0]=((va|0)!=(za|0)&1)+(h[ya>>0]|0);xa=xa+1|0;if((xa|0)==(ua|0)){Aa=qa;break}else wa=ta+wa}}else Aa=qa}else Aa=pa;oa=oa+1|0;if((oa|0)>=(D|0)){Ba=Aa;break}else pa=Aa}}else Ba=ja;ga=ga+1|0;if((ga|0)>=(F|0))break;else ja=Ba}}Ba=(E|0)>0;if(Ba&(X|0)>0){ja=0;F=0;while(1){ga=Y(ja,X)|0;Aa=0;D=F;do{D=((h[da+(Aa+ga)>>0]|0)>(I|0)&1)+D|0;Aa=Aa+1|0}while((Aa|0)!=(X|0));ja=ja+1|0;if((ja|0)==(E|0)){Ca=D;break}else F=D}}else Ca=0;if((Ca*100|0)>(ba|0)){Swa(a,c,d,e,g,I,l,m,o);Da=la;Ea=ma}else{ma=A+2|0;f[x>>2]=0;a=x+4|0;f[a>>2]=0;f[x+8>>2]=0;if(!ma)Fa=0;else{if((A|0)<-2)mCc(x);ba=VDc(ma)|0;f[a>>2]=ba;f[x>>2]=ba;f[x+8>>2]=ba+ma;Ca=ma;ma=ba;do{b[ma>>0]=0;ma=(f[a>>2]|0)+1|0;f[a>>2]=ma;Ca=Ca+-1|0}while((Ca|0)!=0);Fa=f[x>>2]|0}Ca=Fa+1|0;if(Ba){Ba=(X|0)>0;Fa=(ia|0)>0;o=T;ma=(k|0)>0;ba=(A|0)>0;F=y+4|0;ja=y+8|0;Aa=0;while(1){if(Ba){ga=Y(Aa,X)|0;T=+(Aa|0);m=P*T;N=T*e;H=0;do{do if((h[da+(H+ga)>>0]|0)>(I|0)){XIc(Ca|0,0,A|0)|0;a:do if(Fa){C=Y(H,k)|0;if(ma)Ga=0;else{aa=0;while(1){+o3(+(f[la+(aa<<2)>>2]|0)+.5,+(f[ka+(aa<<2)>>2]|0)+.5);aa=aa+1|0;if((aa|0)>=(ia|0))break a}}do{T=+(f[la+(Ga<<2)>>2]|0)+.5;W=+(f[ka+(Ga<<2)>>2]|0)+.5;K=W;na=T;V=S*+M(+(na*na+K*K));K=o*(+L(+(+o3(T,W)*.01745329238474369))+1.5707963267948966);aa=~~K;pa=(C-aa+(+(aa|0)>K&1)|0)*5|0;aa=0;while(1){K=V*+n[$+(((pa|0)>-1?pa:0-pa|0)<<2)>>2]-m;oa=~~K;ea=(Y(oa-(+(oa|0)>K&1)|0,k)|0)+aa|0;oa=ea>>31&~ea^ea;ea=Ca+(((oa|0)>=(A|0)?oa^A:0)^oa)|0;b[ea>>0]=(b[ea>>0]|0)+1<<24>>24;aa=aa+1|0;if((aa|0)==(k|0))break;else pa=pa+5|0}Ga=Ga+1|0}while((Ga|0)<(ia|0))}while(0);if(!ba)break;V=+(H|0)*g;C=f[B>>2]|0;pa=f[r>>2]|0;aa=0;ea=pa;oa=C;ha=pa;pa=C;while(1){C=oa-ea|0;ua=((C|0)/12|0)+-1|0;if((C|0)>=12){xa=b[Ca+aa>>0]|0;if((f[ha+(ua*12|0)>>2]|0)<(xa&255|0)){Ha=xa;Ia=74}else{Ja=pa;Ka=ha;La=ha;Ma=oa}}else{Ha=b[Ca+aa>>0]|0;Ia=74}if((Ia|0)==74){Ia=0;f[y>>2]=Ha&255;n[F>>2]=N+Q*+((aa|0)/(k|0)|0|0);n[ja>>2]=V+R*+((aa|0)%(k|0)|0|0)+-1.5707963705062866;if((pa|0)==(f[j>>2]|0))Uwa(r,y);else{f[pa>>2]=f[y>>2];f[pa+4>>2]=f[y+4>>2];f[pa+8>>2]=f[y+8>>2];f[B>>2]=(f[B>>2]|0)+12}b:do if((C|0)>0){xa=ua;while(1){va=f[r>>2]|0;ya=va+(xa*12|0)|0;if((f[ya>>2]|0)>(f[y>>2]|0)){Na=xa;break b}za=va+((xa+1|0)*12|0)|0;f[za>>2]=f[ya>>2];f[za+4>>2]=f[ya+4>>2];f[za+8>>2]=f[ya+8>>2];ya=xa+-1|0;if((xa|0)>0)xa=ya;else{Na=ya;break}}}else Na=ua;while(0);ua=(f[r>>2]|0)+((Na+1|0)*12|0)|0;f[ua>>2]=f[y>>2];f[ua+4>>2]=f[y+4>>2];f[ua+8>>2]=f[y+8>>2];ua=f[B>>2]|0;C=f[r>>2]|0;xa=ua;if(((ua-C|0)/12|0|0)>(l|0)){ya=xa+-12|0;f[B>>2]=ya;Oa=ya;Pa=ya}else{Oa=xa;Pa=ua}Ja=Oa;Ka=C;La=C;Ma=Pa}aa=aa+1|0;if((aa|0)>=(A|0))break;else{ea=La;oa=Ma;ha=Ka;pa=Ja}}}while(0);H=H+1|0}while((H|0)<(X|0))}Aa=Aa+1|0;if((Aa|0)>=(E|0)){Qa=B;Ra=r;break}}}else{Qa=B;Ra=r}Y$(c,((f[Qa>>2]|0)-(f[Ra>>2]|0)|0)/12|0,1,d,-1,0,0);do if((d$(c)|0)==65536){d=f[c+4>>2]|0;f[y>>2]=f[d>>2];E=y+4|0;Aa=d+4|0;f[E>>2]=f[Aa>>2];X=y+8|0;f[X>>2]=f[d+8>>2];f[y+12>>2]=f[d+12>>2];f[y+16>>2]=f[d+16>>2];f[y+20>>2]=f[d+20>>2];f[y+24>>2]=f[d+24>>2];f[y+28>>2]=f[d+28>>2];f[y+32>>2]=f[d+32>>2];Ja=f[d+36>>2]|0;f[y+36>>2]=Ja;f[y+40>>2]=X;X=y+48|0;Ka=y+44|0;f[Ka>>2]=X;f[X>>2]=0;f[y+52>>2]=0;if(Ja|0){X=Ja+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[Aa>>2]|0)<3){Aa=f[d+44>>2]|0;X=f[Ka>>2]|0;f[X>>2]=f[Aa>>2];f[X+4>>2]=f[Aa+4>>2];break}else{f[E>>2]=0;ZS(y,d);break}}else a$(y,c,-1);while(0);c=f[Qa>>2]|0;d=f[Ra>>2]|0;E=d;if((c|0)!=(d|0)){Aa=y+16|0;X=y+40|0;Ka=y+44|0;Ja=y+12|0;if(z){z=0;Ma=E;La=d;A=c;while(1){R=+n[Ma+(z*12|0)+4>>2];if(R<0.0){Sa=La;Ta=A}else{Pa=f[Ma+(z*12|0)+8>>2]|0;Oa=f[Aa>>2]|0;do if(!(f[y>>2]&16384)){l=f[X>>2]|0;if((f[l>>2]|0)==1){Ia=101;break}Na=f[f[Ka>>2]>>2]|0;if((f[l+4>>2]|0)==1){Ua=Oa+(Y(Na,z)|0)|0;break}else{l=f[Ja>>2]|0;j=(z|0)/(l|0)|0;Ua=Oa+(Y(j,Na)|0)+(z-(Y(j,l)|0)<<3)|0;break}}else Ia=101;while(0);if((Ia|0)==101){Ia=0;Ua=Oa+(z<<3)|0}n[Ua>>2]=R;f[Ua+4>>2]=Pa;Sa=f[Ra>>2]|0;Ta=f[Qa>>2]|0}z=z+1|0;if(z>>>0>=((Ta-Sa|0)/12|0)>>>0)break;else{Ma=Sa;La=Sa;A=Ta}}}else{Ta=0;A=E;E=d;d=c;while(1){Q=+n[A+(Ta*12|0)+4>>2];if(Q<0.0){Va=E;Wa=d}else{c=f[A+(Ta*12|0)+8>>2]|0;g=+(f[A+(Ta*12|0)>>2]|0);Sa=f[Aa>>2]|0;do if(!(f[y>>2]&16384)){La=f[X>>2]|0;if((f[La>>2]|0)==1){Ia=115;break}Ma=f[f[Ka>>2]>>2]|0;if((f[La+4>>2]|0)==1){Xa=Sa+(Y(Ma,Ta)|0)|0;break}else{La=f[Ja>>2]|0;z=(Ta|0)/(La|0)|0;Xa=Sa+(Y(z,Ma)|0)+((Ta-(Y(z,La)|0)|0)*12|0)|0;break}}else Ia=115;while(0);if((Ia|0)==115){Ia=0;Xa=Sa+(Ta*12|0)|0}n[Xa>>2]=Q;f[Xa+4>>2]=c;n[Xa+8>>2]=g;Va=f[Ra>>2]|0;Wa=f[Qa>>2]|0}Ta=Ta+1|0;if(Ta>>>0>=((Wa-Va|0)/12|0)>>>0)break;else{A=Va;E=Va;d=Wa}}}}Wa=y+36|0;d=f[Wa>>2]|0;if(d|0?(Va=d+12|0,d=f[Va>>2]|0,f[Va>>2]=d+-1,(d|0)==1):0)_S(y);f[Wa>>2]=0;Wa=y+16|0;d=y+4|0;f[Wa>>2]=0;f[Wa+4>>2]=0;f[Wa+8>>2]=0;f[Wa+12>>2]=0;if((f[d>>2]|0)>0){Wa=f[y+40>>2]|0;Va=0;do{f[Wa+(Va<<2)>>2]=0;Va=Va+1|0}while((Va|0)<(f[d>>2]|0))}d=f[y+44>>2]|0;if((d|0)!=(y+48|0))g0(d);d=f[x>>2]|0;if(d|0){if((f[a>>2]|0)!=(d|0))f[a>>2]=d;YDc(d)}d=f[w>>2]|0;Da=d;Ea=d}if(Da|0){d=f[fa>>2]|0;if((d|0)!=(Da|0))f[fa>>2]=d+(~((d+-4-Da|0)>>>2)<<2);YDc(Ea)}Ea=f[v>>2]|0;if(Ea|0){v=f[ca>>2]|0;if((v|0)!=(Ea|0))f[ca>>2]=v+(~((v+-4-Ea|0)>>>2)<<2);YDc(Ea)}Ea=f[t>>2]|0;if(Ea|0){if((f[Z>>2]|0)!=(Ea|0))f[Z>>2]=Ea;YDc(Ea)}Ea=f[s>>2]|0;if(Ea|0){s=f[_>>2]|0;if((s|0)!=(Ea|0))f[_>>2]=s+(~((s+-4-Ea|0)>>>2)<<2);YDc(Ea)}Ea=f[r>>2]|0;if(Ea|0){r=f[B>>2]|0;if((r|0)!=(Ea|0))f[B>>2]=r+(~(((r+-12-Ea|0)>>>0)/12|0)*12|0);YDc(Ea)}Ea=q+36|0;r=f[Ea>>2]|0;if(r|0?(B=r+12|0,r=f[B>>2]|0,f[B>>2]=r+-1,(r|0)==1):0)_S(q);f[Ea>>2]=0;Ea=q+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[Ea>>2]|0)>0){i=f[q+40>>2]|0;q=0;do{f[i+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[Ea>>2]|0))}Ea=f[J>>2]|0;if((Ea|0)==(G|0)){u=p;return}g0(Ea);u=p;return}function Uwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)mCc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;YDc(d);return}function Vwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=15;break a;break}case 5:{l=16;break a;break}case 1:case 0:{l=63;break a;break}default:{}}if((j|0)<124){l=18;break a}m=h+(((k|0)/2|0)<<2)|0;do if((j|0)<=3996){n=f[m>>2]|0;o=f[h>>2]|0;p=f[c>>2]|0;q=f[p+(n<<2)>>2]|0;r=p+(o<<2)|0;s=f[r>>2]|0;t=f[e>>2]|0;u=f[p+(t<<2)>>2]|0;v=(u|0)>(q|0)|(t|0)<(n|0)&(u|0)==(q|0);if(!((q|0)>(s|0)|(n|0)<(o|0)&(q|0)==(s|0))){if(!v){w=0;x=p;break}f[m>>2]=t;f[e>>2]=n;s=f[m>>2]|0;q=f[h>>2]|0;u=f[p+(s<<2)>>2]|0;y=f[p+(q<<2)>>2]|0;if(!((u|0)>(y|0)|(s|0)<(q|0)&(u|0)==(y|0))){w=1;x=p;break}f[h>>2]=s;f[m>>2]=q;w=2;x=p;break}if(v){f[h>>2]=t;f[e>>2]=o;w=1;x=p;break}f[h>>2]=n;f[m>>2]=o;n=f[e>>2]|0;t=f[p+(n<<2)>>2]|0;v=f[r>>2]|0;if((t|0)>(v|0)|(n|0)<(o|0)&(t|0)==(v|0)){f[m>>2]=n;f[e>>2]=o;w=2;x=p}else{w=1;x=p}}else{p=(k|0)/4|0;o=Xwa(h,h+(p<<2)|0,m,m+(p<<2)|0,e,c)|0;w=o;x=f[c>>2]|0}while(0);z=f[h>>2]|0;k=f[m>>2]|0;j=f[x+(z<<2)>>2]|0;o=f[x+(k<<2)>>2]|0;if((j|0)>(o|0)|(z|0)<(k|0)&(j|0)==(o|0)){A=e;B=w;break}o=f[c>>2]|0;j=o+(k<<2)|0;C=e;while(1){C=C+-4|0;if((h|0)==(C|0))break;D=f[C>>2]|0;p=f[o+(D<<2)>>2]|0;n=f[j>>2]|0;if((p|0)>(n|0)|(D|0)<(k|0)&(p|0)==(n|0)){l=45;break b}}k=h+4|0;j=f[e>>2]|0;n=f[o+(z<<2)>>2]|0;p=f[o+(j<<2)>>2]|0;if((n|0)>(p|0)|(z|0)<(j|0)&(n|0)==(p|0))E=k;else{if((k|0)==(e|0)){l=63;break a}else F=k;while(1){G=f[F>>2]|0;k=f[o+(G<<2)>>2]|0;if((n|0)>(k|0)|(z|0)<(G|0)&(n|0)==(k|0))break;k=F+4|0;if((k|0)==(e|0)){l=63;break a}else F=k}f[F>>2]=j;f[e>>2]=G;E=F+4|0}if((E|0)==(e|0)){l=63;break a}n=f[c>>2]|0;o=e;k=E;while(1){p=f[h>>2]|0;v=f[n+(p<<2)>>2]|0;t=k;while(1){H=f[t>>2]|0;r=f[n+(H<<2)>>2]|0;I=t+4|0;if((v|0)>(r|0)|(p|0)<(H|0)&(v|0)==(r|0)){J=o;break}else t=I}do{J=J+-4|0;K=f[J>>2]|0;r=f[n+(K<<2)>>2]|0}while((v|0)>(r|0)|(p|0)<(K|0)&(v|0)==(r|0));if(t>>>0>=J>>>0){h=t;continue b}f[t>>2]=K;f[J>>2]=H;o=J;k=I}}if((l|0)==45){l=0;f[h>>2]=D;f[C>>2]=z;A=C;B=w+1|0}k=h+4|0;c:do if(k>>>0<A>>>0){o=f[c>>2]|0;n=m;j=A;v=k;p=B;while(1){r=f[n>>2]|0;q=f[o+(r<<2)>>2]|0;s=v;while(1){L=f[s>>2]|0;y=f[o+(L<<2)>>2]|0;M=s+4|0;if((y|0)>(q|0)|(L|0)<(r|0)&(y|0)==(q|0))s=M;else{N=j;break}}do{N=N+-4|0;O=f[N>>2]|0;t=f[o+(O<<2)>>2]|0}while(!((t|0)>(q|0)|(O|0)<(r|0)&(t|0)==(q|0)));if(s>>>0>N>>>0){P=n;Q=p;R=s;break c}f[s>>2]=O;f[N>>2]=L;n=(n|0)==(s|0)?N:n;j=N;v=M;p=p+1|0}}else{P=m;Q=B;R=k}while(0);if((R|0)!=(P|0)?(k=f[P>>2]|0,p=f[R>>2]|0,v=f[c>>2]|0,j=f[v+(k<<2)>>2]|0,n=f[v+(p<<2)>>2]|0,(j|0)>(n|0)|(k|0)<(p|0)&(j|0)==(n|0)):0){f[R>>2]=k;f[P>>2]=p;S=Q+1|0}else S=Q;if(!S){T=Zwa(h,R,c)|0;p=R+4|0;if(Zwa(p,a,c)|0){l=62;break}if(T){g=p;continue}}p=R;if((p-i|0)>=(b-p|0)){l=61;break}Vwa(h,R,c);g=R+4|0}if((l|0)==61){l=0;Vwa(R+4|0,a,c);d=h;a=R;continue}else if((l|0)==62){l=0;if(T){l=63;break}else{d=h;a=R;continue}}}if((l|0)==5){R=f[e>>2]|0;d=f[h>>2]|0;T=f[c>>2]|0;i=f[T+(R<<2)>>2]|0;S=f[T+(d<<2)>>2]|0;if(!((i|0)>(S|0)|(R|0)<(d|0)&(i|0)==(S|0)))return;f[h>>2]=R;f[e>>2]=d;return}else if((l|0)==7){d=h+4|0;R=f[d>>2]|0;S=f[h>>2]|0;i=f[c>>2]|0;T=f[i+(R<<2)>>2]|0;Q=i+(S<<2)|0;P=f[Q>>2]|0;B=f[e>>2]|0;m=f[i+(B<<2)>>2]|0;M=(m|0)>(T|0)|(B|0)<(R|0)&(m|0)==(T|0);if(!((T|0)>(P|0)|(R|0)<(S|0)&(T|0)==(P|0))){if(!M)return;f[d>>2]=B;f[e>>2]=R;P=f[d>>2]|0;T=f[h>>2]|0;m=f[i+(P<<2)>>2]|0;N=f[i+(T<<2)>>2]|0;if(!((m|0)>(N|0)|(P|0)<(T|0)&(m|0)==(N|0)))return;f[h>>2]=P;f[d>>2]=T;return}if(M){f[h>>2]=B;f[e>>2]=S;return}f[h>>2]=R;f[d>>2]=S;R=f[e>>2]|0;B=f[i+(R<<2)>>2]|0;i=f[Q>>2]|0;if(!((B|0)>(i|0)|(R|0)<(S|0)&(B|0)==(i|0)))return;f[d>>2]=R;f[e>>2]=S;return}else if((l|0)==15){Wwa(h,h+4|0,h+8|0,e,c)|0;return}else if((l|0)==16){Xwa(h,h+4|0,h+8|0,h+12|0,e,c)|0;return}else if((l|0)==18){Ywa(h,a,c);return}else if((l|0)==63)return}function Wwa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[b>>2]|0;h=f[a>>2]|0;i=f[e>>2]|0;e=f[i+(g<<2)>>2]|0;j=i+(h<<2)|0;k=f[j>>2]|0;l=f[c>>2]|0;m=f[i+(l<<2)>>2]|0;n=(m|0)>(e|0)|(l|0)<(g|0)&(m|0)==(e|0);do if((e|0)>(k|0)|(g|0)<(h|0)&(e|0)==(k|0)){if(n){f[a>>2]=l;f[c>>2]=h;o=1;p=h;break}f[a>>2]=g;f[b>>2]=h;m=f[c>>2]|0;q=f[i+(m<<2)>>2]|0;r=f[j>>2]|0;if((q|0)>(r|0)|(m|0)<(h|0)&(q|0)==(r|0)){f[b>>2]=m;f[c>>2]=h;o=2;p=h}else{o=1;p=m}}else if(n){f[b>>2]=l;f[c>>2]=g;m=f[b>>2]|0;r=f[a>>2]|0;q=f[i+(m<<2)>>2]|0;s=f[i+(r<<2)>>2]|0;if((q|0)>(s|0)|(m|0)<(r|0)&(q|0)==(s|0)){f[a>>2]=m;f[b>>2]=r;o=2;p=f[c>>2]|0}else{o=1;p=g}}else{o=0;p=l}while(0);l=f[d>>2]|0;g=f[i+(l<<2)>>2]|0;n=f[i+(p<<2)>>2]|0;if(!((g|0)>(n|0)|(l|0)<(p|0)&(g|0)==(n|0))){t=o;return t|0}f[c>>2]=l;f[d>>2]=p;p=f[c>>2]|0;d=f[b>>2]|0;l=f[i+(p<<2)>>2]|0;n=f[i+(d<<2)>>2]|0;if(!((l|0)>(n|0)|(p|0)<(d|0)&(l|0)==(n|0))){t=o+1|0;return t|0}f[b>>2]=p;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;p=f[i+(d<<2)>>2]|0;n=f[i+(c<<2)>>2]|0;if(!((p|0)>(n|0)|(d|0)<(c|0)&(p|0)==(n|0))){t=o+2|0;return t|0}f[a>>2]=d;f[b>>2]=c;t=o+3|0;return t|0}function Xwa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=Wwa(a,b,c,d,g)|0;i=f[e>>2]|0;j=f[d>>2]|0;k=f[g>>2]|0;g=f[k+(i<<2)>>2]|0;l=f[k+(j<<2)>>2]|0;if(!((g|0)>(l|0)|(i|0)<(j|0)&(g|0)==(l|0))){m=h;return m|0}f[d>>2]=i;f[e>>2]=j;j=f[d>>2]|0;e=f[c>>2]|0;i=f[k+(j<<2)>>2]|0;l=f[k+(e<<2)>>2]|0;if(!((i|0)>(l|0)|(j|0)<(e|0)&(i|0)==(l|0))){m=h+1|0;return m|0}f[c>>2]=j;f[d>>2]=e;e=f[c>>2]|0;d=f[b>>2]|0;j=f[k+(e<<2)>>2]|0;l=f[k+(d<<2)>>2]|0;if(!((j|0)>(l|0)|(e|0)<(d|0)&(j|0)==(l|0))){m=h+2|0;return m|0}f[b>>2]=e;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;e=f[k+(d<<2)>>2]|0;l=f[k+(c<<2)>>2]|0;if(!((e|0)>(l|0)|(d|0)<(c|0)&(e|0)==(l|0))){m=h+3|0;return m|0}f[a>>2]=d;f[b>>2]=c;m=h+4|0;return m|0}function Ywa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a+8|0;e=a+4|0;g=f[e>>2]|0;h=f[a>>2]|0;i=f[c>>2]|0;j=f[i+(g<<2)>>2]|0;k=i+(h<<2)|0;l=f[k>>2]|0;m=f[d>>2]|0;n=i+(m<<2)|0;o=f[n>>2]|0;p=(o|0)>(j|0)|(m|0)<(g|0)&(o|0)==(j|0);do if((j|0)>(l|0)|(g|0)<(h|0)&(j|0)==(l|0)){if(p){f[a>>2]=m;f[d>>2]=h;q=h;break}f[a>>2]=g;f[e>>2]=h;o=f[n>>2]|0;r=f[k>>2]|0;if((o|0)>(r|0)|(m|0)<(h|0)&(o|0)==(r|0)){f[e>>2]=m;f[d>>2]=h;q=h}else q=m}else if(p){f[e>>2]=m;f[d>>2]=g;r=f[n>>2]|0;o=f[k>>2]|0;if((r|0)>(o|0)|(m|0)<(h|0)&(r|0)==(o|0)){f[a>>2]=m;f[e>>2]=h;q=g}else q=g}else q=m;while(0);m=a+12|0;if((m|0)==(b|0))return;else{s=m;t=d;u=i;v=q}while(1){q=f[s>>2]|0;i=f[u+(q<<2)>>2]|0;d=f[u+(v<<2)>>2]|0;if((i|0)>(d|0)|(q|0)<(v|0)&(i|0)==(d|0)){d=f[c>>2]|0;i=d+(q<<2)|0;m=t;g=s;h=v;while(1){f[g>>2]=h;if((m|0)==(a|0)){w=a;break}e=m+-4|0;h=f[e>>2]|0;k=f[i>>2]|0;n=f[d+(h<<2)>>2]|0;if(!((k|0)>(n|0)|(q|0)<(h|0)&(k|0)==(n|0))){w=m;break}else{n=m;m=e;g=n}}f[w>>2]=q;x=d}else x=u;g=s+4|0;if((g|0)==(b|0))break;m=f[s>>2]|0;h=s;s=g;u=x;v=m;t=h}return}function Zwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[c>>2]|0;i=f[h+(e<<2)>>2]|0;j=f[h+(g<<2)>>2]|0;if(!((i|0)>(j|0)|(e|0)<(g|0)&(i|0)==(j|0))){k=1;return k|0}f[a>>2]=e;f[d>>2]=g;k=1;return k|0}case 3:{g=a+4|0;d=b+-4|0;e=f[g>>2]|0;j=f[a>>2]|0;i=f[c>>2]|0;h=f[i+(e<<2)>>2]|0;l=i+(j<<2)|0;m=f[l>>2]|0;n=f[d>>2]|0;o=f[i+(n<<2)>>2]|0;p=(o|0)>(h|0)|(n|0)<(e|0)&(o|0)==(h|0);if(!((h|0)>(m|0)|(e|0)<(j|0)&(h|0)==(m|0))){if(!p){k=1;return k|0}f[g>>2]=n;f[d>>2]=e;m=f[g>>2]|0;h=f[a>>2]|0;o=f[i+(m<<2)>>2]|0;q=f[i+(h<<2)>>2]|0;if(!((o|0)>(q|0)|(m|0)<(h|0)&(o|0)==(q|0))){k=1;return k|0}f[a>>2]=m;f[g>>2]=h;k=1;return k|0}if(p){f[a>>2]=n;f[d>>2]=j;k=1;return k|0}f[a>>2]=e;f[g>>2]=j;e=f[d>>2]|0;n=f[i+(e<<2)>>2]|0;i=f[l>>2]|0;if(!((n|0)>(i|0)|(e|0)<(j|0)&(n|0)==(i|0))){k=1;return k|0}f[g>>2]=e;f[d>>2]=j;k=1;return k|0}case 4:{Wwa(a,a+4|0,a+8|0,b+-4|0,c)|0;k=1;return k|0}case 5:{Xwa(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;k=1;return k|0}case 1:case 0:{k=1;return k|0}default:{j=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;i=f[c>>2]|0;n=f[i+(e<<2)>>2]|0;l=i+(g<<2)|0;p=f[l>>2]|0;h=f[j>>2]|0;m=i+(h<<2)|0;q=f[m>>2]|0;o=(q|0)>(n|0)|(h|0)<(e|0)&(q|0)==(n|0);do if((n|0)>(p|0)|(e|0)<(g|0)&(n|0)==(p|0)){if(o){f[a>>2]=h;f[j>>2]=g;r=g;break}f[a>>2]=e;f[d>>2]=g;q=f[m>>2]|0;s=f[l>>2]|0;if((q|0)>(s|0)|(h|0)<(g|0)&(q|0)==(s|0)){f[d>>2]=h;f[j>>2]=g;r=g}else r=h}else if(o){f[d>>2]=h;f[j>>2]=e;s=f[m>>2]|0;q=f[l>>2]|0;if((s|0)>(q|0)|(h|0)<(g|0)&(s|0)==(q|0)){f[a>>2]=h;f[d>>2]=g;r=e}else r=e}else r=h;while(0);h=a+12|0;a:do if((h|0)==(b|0)){t=1;u=0}else{e=h;g=0;d=j;l=i;m=r;while(1){o=f[e>>2]|0;p=f[l+(o<<2)>>2]|0;n=f[l+(m<<2)>>2]|0;if((p|0)>(n|0)|(o|0)<(m|0)&(p|0)==(n|0)){n=f[c>>2]|0;p=n+(o<<2)|0;q=d;s=e;v=m;while(1){f[s>>2]=v;if((q|0)==(a|0)){w=a;break}x=q+-4|0;v=f[x>>2]|0;y=f[p>>2]|0;z=f[n+(v<<2)>>2]|0;if(!((y|0)>(z|0)|(o|0)<(v|0)&(y|0)==(z|0))){w=q;break}else{z=q;q=x;s=z}}f[w>>2]=o;s=g+1|0;if((s|0)==8){t=0;u=(e+4|0)==(b|0);break a}else{A=s;B=n}}else{A=g;B=l}s=e+4|0;if((s|0)==(b|0)){t=1;u=0;break a}q=f[e>>2]|0;v=e;e=s;g=A;l=B;m=q;d=v}}while(0);k=u|t;return k|0}}return 0}function _wa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;i=u;u=u+128|0;j=i+72|0;k=i+56|0;l=i;do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[j>>2]=f[m>>2];n=j+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=j+8|0;f[p>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[j+16>>2]=f[m+16>>2];f[j+20>>2]=f[m+20>>2];f[j+24>>2]=f[m+24>>2];f[j+28>>2]=f[m+28>>2];f[j+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[j+36>>2]=q;f[j+40>>2]=p;p=j+48|0;r=j+44|0;f[r>>2]=p;f[p>>2]=0;f[j+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;ZS(j,m);break}}else a$(j,a,-1);while(0);f[k>>2]=0;a=k+4|0;f[a>>2]=0;f[k+8>>2]=0;m=nrc(g)|0;$wa(j,c,d,e,m,nrc(h)|0,k,2147483647);f[l>>2]=1124024348;m=l+4|0;f[m>>2]=2;e=l+8|0;n=f[a>>2]|0;o=f[k>>2]|0;p=n-o|0;f[e>>2]=p>>4;f[l+12>>2]=1;r=l+16|0;q=l+40|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[q>>2]=e;e=l+48|0;s=l+44|0;f[s>>2]=e;f[e>>2]=0;t=l+52|0;f[t>>2]=0;v=o;if((v|0)!=(n|0)){f[t>>2]=16;f[e>>2]=16;f[r>>2]=v;f[l+20>>2]=v;v=o+p|0;f[l+24>>2]=v;f[l+28>>2]=v}h_(l,b);b=l+36|0;v=f[b>>2]|0;if(v|0?(p=v+12|0,v=f[p>>2]|0,f[p>>2]=v+-1,(v|0)==1):0)_S(l);f[b>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[m>>2]|0)>0){r=f[q>>2]|0;q=0;do{f[r+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[m>>2]|0))}m=f[s>>2]|0;if((m|0)!=(e|0))g0(m);m=f[k>>2]|0;if(m|0){k=f[a>>2]|0;if((k|0)!=(m|0))f[a>>2]=k+(~((k+-16-m|0)>>>4)<<4);YDc(m)}m=j+36|0;k=f[m>>2]|0;if(k|0?(a=k+12|0,k=f[a>>2]|0,f[a>>2]=k+-1,(k|0)==1):0)_S(j);f[m>>2]=0;m=j+16|0;k=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[j+40>>2]|0;a=0;do{f[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=i;return}g0(k);u=i;return}function $wa(a,c,d,e,g,h,i,j){a=a|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;k=u;u=u+416|0;l=k+392|0;m=k+384|0;o=k+328|0;p=k;q=k+272|0;r=k+256|0;s=k+240|0;t=k+224|0;f[m>>2]=0;v=m+4|0;f[v>>2]=0;w=1.0/c;if(f[a>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;x=tT(l,23)|0;y=285187;z=x+23|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,l,285211,284643,471)}y=f[a+12>>2]|0;A=f[a+8>>2]|0;B=d;C=nrc(3.141592653589793/B)|0;D=mrc(+(A+y<<1|1|0)/c)|0;AY(p,C,D,4);f[o>>2]=1124007936;E=o+4|0;F=o+8|0;G=o+40|0;x=E;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[G>>2]=F;F=o+48|0;H=o+44|0;f[H>>2]=F;f[F>>2]=0;f[o+52>>2]=0;I=f[p>>2]|0;ei[f[(f[I>>2]|0)+12>>2]&511](I,p,o,-1);$j(p);f[q>>2]=1124007936;p=q+4|0;I=q+8|0;K=q+40|0;x=p;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[K>>2]=I;I=q+48|0;x=q+44|0;f[x>>2]=I;f[I>>2]=0;f[q+52>>2]=0;f[l>>2]=A;f[l+4>>2]=y;XS(q,2,l,0);z=C<<1;f[l>>2]=0;M=l+4|0;f[M>>2]=0;f[l+8>>2]=0;if(C){if(z>>>0>1073741823)mCc(l);N=C<<3;Q=VDc(N)|0;f[l>>2]=Q;R=Q+(z<<2)|0;f[l+8>>2]=R;XIc(Q|0,0,N|0)|0;f[M>>2]=R;R=(C|0)>0;if(R){c=w;N=0;do{w=B*+(N|0);d=c*+O(+w);z=N<<1;n[Q+(z<<2)>>2]=d;d=c*+P(+w);n[Q+((z|1)<<2)>>2]=d;N=N+1|0}while((N|0)!=(C|0));S=R;T=Q}else{S=0;T=Q}}else{S=0;T=0}Q=q+16|0;R=f[Q>>2]|0;f[r>>2]=0;N=r+4|0;f[N>>2]=0;f[r+8>>2]=0;f[v>>2]=0;do if((A|0)>0){z=a+16|0;U=a+44|0;V=r+8|0;if((y|0)>0){W=R;X=0}else{Z=0;do Z=Z+1|0;while((Z|0)<(A|0));f[m>>2]=0;f[v>>2]=Z;_=0;$=0;aa=0;break}while(1){ba=(f[z>>2]|0)+(Y(f[f[U>>2]>>2]|0,X)|0)|0;ca=W+(Y(f[f[x>>2]>>2]|0,X)|0)|0;f[m>>2]=0;da=0;do{ea=ca+da|0;do if(b[ba+da>>0]|0){b[ea>>0]=1;fa=f[N>>2]|0;if((fa|0)==(f[V>>2]|0)){fga(r,m);break}else{f[fa>>2]=f[m>>2];f[fa+4>>2]=f[v>>2];f[N>>2]=fa+8;break}}else b[ea>>0]=0;while(0);da=(f[m>>2]|0)+1|0;f[m>>2]=da}while((da|0)<(y|0));da=(f[v>>2]|0)+1|0;f[v>>2]=da;if((da|0)>=(A|0))break;W=f[Q>>2]|0;X=da}V=f[r>>2]|0;_=V;$=f[N>>2]|0;aa=V}else{_=0;$=0;aa=0}while(0);X=$-_|0;a:do if((X|0)>0){_=e+-1|0;$=o+16|0;W=(D+-1|0)/2|0;v=s+8|0;m=s+12|0;a=s+4|0;V=t+4|0;U=t+8|0;z=t+12|0;Z=i+4|0;da=i+8|0;ba=S^1;ca=X>>>3;ea=-1;fa=-1;ga=aa;while(1){ha=mJc(ea|0,0,-130063606,0)|0;ia=UIc(ha|0,J|0,fa|0,0)|0;ha=J;ja=(ia>>>0)%(ca>>>0)|0;ka=f[ga+(ja<<3)>>2]|0;la=f[ga+(ja<<3)+4>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;ma=f[$>>2]|0;na=ca+-1|0;f[ga+(ja<<3)>>2]=f[ga+(na<<3)>>2];f[ga+(ja<<3)+4>>2]=f[ga+(na<<3)+4>>2];ja=R+((Y(la,y)|0)+ka)|0;if(!((b[ja>>0]|0)==0|ba)){c=+(ka|0);B=+(la|0);ja=_;oa=0;pa=0;qa=ma;while(1){ma=oa<<1;ra=qa+((mrc(c*+n[T+(ma<<2)>>2]+B*+n[T+((ma|1)<<2)>>2])|0)+W<<2)|0;ma=f[ra>>2]|0;sa=ma+1|0;f[ra>>2]=sa;ra=(ja|0)>(ma|0);pa=ra?pa:oa;ja=ra?ja:sa;oa=oa+1|0;if((oa|0)==(C|0))break;else qa=qa+(D<<2)|0}if((ja|0)>=(e|0)){qa=pa<<1;B=+n[T+((qa|1)<<2)>>2];c=+n[T+(qa<<2)>>2];d=+L(+-B);w=+L(+c);if(d>w){ta=0;ua=mrc(c*65536.0/d)|0;va=B<-0.0?1:-1;wa=la<<16|32768;xa=ka}else{ta=1;ua=c>0.0?1:-1;va=mrc(B*-65536.0/w)|0;wa=la;xa=ka<<16|32768}qa=0-va|0;oa=0-ua|0;sa=wa>>16;ra=xa>>16;if(((ta?ra:xa)|0)>=0){ma=f[a>>2]|0;ya=f[s>>2]|0;b:do if(ta){za=ra;Aa=ya;Ba=wa;Ca=ma;Da=xa;Ea=0;while(1){if(!((Ba|0)<(A|0)&((za|0)<(y|0)&(Ba|0)>-1))){Fa=Aa;Ga=Ca;break b}Ha=R+(Y(Ba,y)|0)+za|0;if(!(b[Ha>>0]|0))if((Ea|0)<(h|0)){Ia=Aa;Ja=Ca;Ka=Ea+1|0}else{Fa=Aa;Ga=Ca;break b}else{Ia=za;Ja=Ba;Ka=0}Da=Da+va|0;za=Da>>16;if((za|0)<0){Fa=Ia;Ga=Ja;break}else{Aa=Ia;Ba=Ba+ua|0;Ca=Ja;Ea=Ka}}}else{Ea=xa;Ca=ya;Ba=sa;Aa=ma;za=wa;Da=0;while(1){if(!((Ba|0)<(A|0)&((Ea|0)<(y|0)&(Ba|0)>-1))){Fa=Ca;Ga=Aa;break b}Ha=R+(Y(Ba,y)|0)+Ea|0;if(!(b[Ha>>0]|0))if((Da|0)<(h|0)){La=Ca;Ma=Aa;Na=Da+1|0}else{Fa=Ca;Ga=Aa;break b}else{La=Ea;Ma=Ba;Na=0}Ea=Ea+va|0;Ha=za+ua|0;if((Ea|0)<0){Fa=La;Ga=Ma;break}else{Ca=La;Ba=Ha>>16;Aa=Ma;za=Ha;Da=Na}}}while(0);f[a>>2]=Ga;f[s>>2]=Fa;ma=f[m>>2]|0;ya=f[v>>2]|0;c:do if(ta){ka=ra;la=ya;pa=wa;ja=ma;Da=xa;za=0;while(1){if(!((pa|0)<(A|0)&((ka|0)<(y|0)&(pa|0)>-1))){Oa=la;Pa=ja;break c}Aa=R+(Y(pa,y)|0)+ka|0;if(!(b[Aa>>0]|0))if((za|0)<(h|0)){Qa=la;Ra=ja;Sa=za+1|0}else{Oa=la;Pa=ja;break c}else{Qa=ka;Ra=pa;Sa=0}Da=Da-va|0;ka=Da>>16;if((ka|0)<0){Oa=Qa;Pa=Ra;break}else{la=Qa;pa=pa-ua|0;ja=Ra;za=Sa}}}else{za=xa;ja=ya;pa=sa;la=ma;ka=wa;Da=0;while(1){if(!((pa|0)<(A|0)&((za|0)<(y|0)&(pa|0)>-1))){Oa=ja;Pa=la;break c}Aa=R+(Y(pa,y)|0)+za|0;if(!(b[Aa>>0]|0))if((Da|0)<(h|0)){Ta=ja;Ua=la;Va=Da+1|0}else{Oa=ja;Pa=la;break c}else{Ta=za;Ua=pa;Va=0}za=za-va|0;Aa=ka-ua|0;if((za|0)<0){Oa=Ta;Pa=Ua;break}else{ja=Ta;pa=Aa>>16;la=Ua;ka=Aa;Da=Va}}}while(0);f[m>>2]=Pa;f[v>>2]=Oa}ma=(f[v>>2]|0)-(f[s>>2]|0)|0;if((((ma|0)>-1?ma:0-ma|0)|0)<(g|0)){ma=(f[m>>2]|0)-(f[a>>2]|0)|0;Wa=(((ma|0)>-1?ma:0-ma|0)|0)>=(g|0)}else Wa=1;ma=Wa&S;sa=0;do{ya=(sa|0)==1;ra=ya?qa:va;Da=ya?oa:ua;ya=s+(sa<<3)|0;ka=s+(sa<<3)+4|0;d:do if(ta){la=wa;pa=xa;while(1){ja=pa>>16;za=R+(Y(la,y)|0)+ja|0;if(b[za>>0]|0){if(ma){w=+(ja|0);B=+(la|0);Aa=0;Ba=f[$>>2]|0;while(1){Ca=Aa<<1;Ea=Ba+((mrc(w*+n[T+(Ca<<2)>>2]+B*+n[T+((Ca|1)<<2)>>2])|0)+W<<2)|0;f[Ea>>2]=(f[Ea>>2]|0)+-1;Aa=Aa+1|0;if((Aa|0)==(C|0))break;else Ba=Ba+(D<<2)|0}}b[za>>0]=0}if((la|0)==(f[ka>>2]|0)?(ja|0)==(f[ya>>2]|0):0)break d;la=la+Da|0;pa=pa+ra|0}}else{if(Wa){Xa=wa;Ya=xa}else{pa=f[ka>>2]|0;la=f[ya>>2]|0;Ba=wa;Aa=xa;while(1){Ea=Ba>>16;Ca=R+(Y(Ea,y)|0)+Aa|0;if(b[Ca>>0]|0)b[Ca>>0]=0;if((Ea|0)==(pa|0)&(Aa|0)==(la|0))break d;Ba=Ba+Da|0;Aa=Aa+ra|0}}while(1){Aa=Xa>>16;Ba=R+(Y(Aa,y)|0)+Ya|0;if(b[Ba>>0]|0){if(S){B=+(Ya|0);w=+(Aa|0);la=0;pa=f[$>>2]|0;while(1){Ea=la<<1;Ca=pa+((mrc(B*+n[T+(Ea<<2)>>2]+w*+n[T+((Ea|1)<<2)>>2])|0)+W<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+-1;la=la+1|0;if((la|0)==(C|0))break;else pa=pa+(D<<2)|0}}b[Ba>>0]=0}if((Aa|0)==(f[ka>>2]|0)?(Ya|0)==(f[ya>>2]|0):0)break d;Xa=Xa+Da|0;Ya=Ya+ra|0}}while(0);sa=sa+1|0}while((sa|0)!=2);if(Wa){sa=f[s>>2]|0;ma=f[a>>2]|0;oa=f[v>>2]|0;qa=f[m>>2]|0;f[t>>2]=sa;f[V>>2]=ma;f[U>>2]=oa;f[z>>2]=qa;qa=f[Z>>2]|0;if((qa|0)==(f[da>>2]|0)){axa(i,t);Za=f[Z>>2]|0}else{f[qa>>2]=sa;f[qa+4>>2]=f[V>>2];f[qa+8>>2]=f[U>>2];f[qa+12>>2]=f[z>>2];sa=qa+16|0;f[Z>>2]=sa;Za=sa}if((Za-(f[i>>2]|0)>>4|0)>=(j|0))break}}}if((ca|0)<=1)break a;ca=na;ea=ia;fa=ha;ga=f[r>>2]|0}}while(0);j=f[r>>2]|0;if(j|0){r=f[N>>2]|0;if((r|0)!=(j|0))f[N>>2]=r+(~((r+-8-j|0)>>>3)<<3);YDc(j)}j=f[l>>2]|0;if(j|0){l=f[M>>2]|0;if((l|0)!=(j|0))f[M>>2]=l+(~((l+-4-j|0)>>>2)<<2);YDc(j)}j=q+36|0;l=f[j>>2]|0;if(l|0?(M=l+12|0,l=f[M>>2]|0,f[M>>2]=l+-1,(l|0)==1):0)_S(q);f[j>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[p>>2]|0)>0){Q=f[K>>2]|0;K=0;do{f[Q+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[p>>2]|0))}p=f[x>>2]|0;if((p|0)!=(I|0))g0(p);p=o+36|0;I=f[p>>2]|0;if(I|0?(x=I+12|0,I=f[x>>2]|0,f[x>>2]=I+-1,(I|0)==1):0)_S(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[E>>2]|0)>0){p=f[G>>2]|0;G=0;do{f[p+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[H>>2]|0;if((E|0)==(F|0)){u=k;return}g0(E);u=k;return}function axa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function bxa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;cxa(a,b,c,d,e,f,g,h,i,-1);return}function cxa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=+i;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0;m=u;u=u+592|0;o=m;p=m+528|0;q=m+496|0;r=m+440|0;t=m+384|0;v=m+328|0;w=m+324|0;x=m+312|0;y=m+256|0;z=m+200|0;A=m+184|0;B=m+128|0;C=m+72|0;D=m+16|0;if(X$(c)|0){E=c$(c,-1)|0;if((E|8|0)==29)F=E;else c2(E,60916)}else F=21;if(r$(a)|0){f[o>>2]=0;G=o+4|0;f[G>>2]=0;H=tT(o,82)|0;I=H;J=285235;K=I+82|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-215,o,285318,284643,1736)}if(c$(a,-1)|0){f[o>>2]=0;G=o+4|0;f[G>>2]=0;H=tT(o,82)|0;I=H;J=285235;K=I+82|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-215,o,285318,284643,1736)}if((d$(a)|0)!=65536?(d$(a)|0)!=655360:0){f[o>>2]=0;G=o+4|0;f[G>>2]=0;H=tT(o,82)|0;I=H;J=285235;K=I+82|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-215,o,285318,284643,1736)}if((((d$(c)|0)!=65536?(d$(c)|0)!=196608:0)?(d$(c)|0)!=786432:0)?(d$(c)|0)!=917504:0){f[o>>2]=0;f[o+4>>2]=0;I=tT(o,39)|0;J=285331;K=I+39|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-215,o,285318,284643,1737)}if(e<=0.0|g<=0.0|h<=0.0|i<=0.0){f[o>>2]=0;f[o+4>>2]=0;I=tT(o,76)|0;J=285371;K=I+76|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-211,o,285318,284643,1740)}H=nrc(h)|0;G=nrc(i)|0;E=nrc(3.0)|0;L=(j|0)>0?j:0;j=(l|0)<0?2147483647:l;l=(k|0)<0;if((k|0)<1){M=k$(a,-1)|0;N=l$(a,-1)|0;O=(M|0)<(N|0)?N:M}else O=(L|0)<(k|0)?k:L+2|0;if((d|0)!=3){f[o>>2]=0;f[o+4>>2]=0;I=tT(o,69)|0;J=285543;K=I+69|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-5,o,285318,284643,1771)}switch(F|0){case 21:{i=e;h=g;switch(E|0){case 3:case 5:case 7:case -1:break;default:{f[o>>2]=0;f[o+4>>2]=0;I=tT(o,73)|0;J=285448;K=I+73|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-215,o,285522,284643,1631)}}P=i<1.0?1.0:i;i=1.0/P;f[r>>2]=1124007936;F=r+4|0;d=r+8|0;k=r+40|0;I=F;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[k>>2]=d;M=r+48|0;N=r+44|0;f[N>>2]=M;f[M>>2]=0;f[r+52>>2]=0;f[t>>2]=1124007936;Q=t+4|0;R=t+8|0;S=t+40|0;I=Q;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[S>>2]=R;R=t+48|0;T=t+44|0;f[T>>2]=R;f[R>>2]=0;f[t+52>>2]=0;f[v>>2]=1124007936;U=v+4|0;V=v+8|0;W=v+40|0;I=U;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[W>>2]=V;V=v+48|0;X=v+44|0;f[X>>2]=V;f[V>>2]=0;f[v+52>>2]=0;Z=o+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=t;Hoa(a,o,3,1,0,E,1.0,0.0,1);Z=o+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=v;Hoa(a,o,3,0,1,E,1.0,0.0,1);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=t;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=v;Z=q+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=r;Z=(H|0)/2|0;coa(o,p,q,+(((Z|0)>1?Z:1)|0),+(H|0),0);k6(w);Z=z8()|0;_=(Z|0)>1;f[x>>2]=0;$=x+4|0;f[$>>2]=0;f[x+8>>2]=0;aa=k$(a,-1)|0;ba=l$(a,-1)|0;b[o>>0]=0;dxa(y,aa,ba,o);ba=f[d>>2]|0;f[o>>2]=0;f[o+4>>2]=ba;f[p>>2]=60952;f[p+4>>2]=r;f[p+8>>2]=t;f[p+12>>2]=v;f[p+16>>2]=L;f[p+20>>2]=O;n[p+24>>2]=i;f[p+28>>2]=x;f[p+32>>2]=y;f[p+48>>2]=w;ca=i*+(f[r+12>>2]|0);d=~~ca;aa=(+(d|0)<ca&1)+d|0;f[p+36>>2]=aa;ca=i*+(ba|0);ba=~~ca;f[p+40>>2]=(+(ba|0)<ca&1)+ba;f[p+44>>2]=aa+2;ca=+(((Z|0)>1?Z:1)|0);y8(o,p,ca);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=-2130640896;f[o+4>>2]=y;Z=N2(o)|0;if((Z|0)>=1){aa=f[x>>2]|0;f[z>>2]=f[aa>>2];ba=z+4|0;d=aa+4|0;f[ba>>2]=f[d>>2];da=z+8|0;f[da>>2]=f[aa+8>>2];ea=z+12|0;f[ea>>2]=f[aa+12>>2];fa=z+16|0;f[fa>>2]=f[aa+16>>2];f[z+20>>2]=f[aa+20>>2];f[z+24>>2]=f[aa+24>>2];f[z+28>>2]=f[aa+28>>2];f[z+32>>2]=f[aa+32>>2];ga=z+36|0;ha=f[aa+36>>2]|0;f[ga>>2]=ha;ia=z+40|0;f[ia>>2]=da;ja=z+48|0;ka=z+44|0;f[ka>>2]=ja;f[ja>>2]=0;f[z+52>>2]=0;if(ha|0){la=ha+12|0;f[la>>2]=(f[la>>2]|0)+1}if((f[d>>2]|0)<3){d=f[aa+44>>2]|0;la=f[ka>>2]|0;f[la>>2]=f[d>>2];f[la+4>>2]=f[d+4>>2]}else{f[ba>>2]=0;ZS(z,aa)}aa=f[$>>2]|0;d=f[x>>2]|0;la=d;if(((aa-d|0)/56|0)>>>0>1){d=o+8|0;ha=o+12|0;ma=o+4|0;na=p+8|0;oa=p+12|0;pa=p+4|0;qa=q+8|0;ra=q+4|0;sa=1;ta=la;while(1){f[d>>2]=0;f[ha>>2]=0;f[o>>2]=16842752;f[ma>>2]=z;f[na>>2]=0;f[oa>>2]=0;f[p>>2]=16842752;f[pa>>2]=ta+(sa*56|0);ua=qa;f[ua>>2]=0;f[ua+4>>2]=0;f[q>>2]=33619968;f[ra>>2]=z;mL(o,p,q,e0()|0,-1);sa=sa+1|0;ua=f[$>>2]|0;va=f[x>>2]|0;wa=va;if(sa>>>0>=((ua-va|0)/56|0)>>>0){xa=wa;ya=ua;break}else ta=wa}}else{xa=la;ya=aa}aa=ya;if((aa|0)!=(xa|0)){ya=aa;do{aa=ya+-56|0;f[$>>2]=aa;la=ya+-20|0;ta=f[la>>2]|0;if(ta|0?(sa=ta+12|0,ta=f[sa>>2]|0,f[sa>>2]=ta+-1,(ta|0)==1):0)_S(aa);f[la>>2]=0;la=ya+-40|0;aa=ya+-52|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[aa>>2]|0)>0){la=f[ya+-16>>2]|0;ta=0;do{f[la+(ta<<2)>>2]=0;ta=ta+1|0}while((ta|0)<(f[aa>>2]|0))}aa=f[ya+-12>>2]|0;if((aa|0)!=(ya+-8|0))g0(aa);ya=f[$>>2]|0}while((ya|0)!=(xa|0))}f[p>>2]=0;xa=p+4|0;f[xa>>2]=0;f[p+8>>2]=0;ya=f[da>>2]|0;f[o>>2]=1;f[o+4>>2]=ya+-1;f[q>>2]=60972;f[q+4>>2]=z;f[q+8>>2]=p;f[q+12>>2]=G;f[q+28>>2]=w;f[q+16>>2]=f[ea>>2];f[q+20>>2]=ya;f[q+24>>2]=f[fa>>2];y8(o,q,_?+((ya+-2|0)/4|0|0):1.0);ya=f[xa>>2]|0;_=f[p>>2]|0;da=ya-_>>2;$=_;if(!da)za=$;else{f[o>>2]=f[fa>>2];Vwa($,ya,o);f[q>>2]=0;ya=q+4|0;f[ya>>2]=0;f[q+8>>2]=0;$=q+8|0;_=VDc(3072)|0;aa=_;f[q>>2]=aa;f[ya>>2]=aa;f[$>>2]=_+3072;a:do if(l){_=f[ea>>2]|0;ta=f[p>>2]|0;la=(f[xa>>2]|0)-ta>>2;i=h*h;if(la|0){sa=o+4|0;ra=o+8|0;qa=0;pa=ta;ta=aa;oa=aa;while(1){na=f[pa+(qa<<2)>>2]|0;ma=(na|0)/(_|0)|0;Aa=P*(+(na-(Y(ma,_)|0)|0)+.5);Ba=P*(+(ma|0)+.5);n[o>>2]=Aa;n[sa>>2]=Ba;n[ra>>2]=0.0;ma=oa-ta|0;na=(ma|0)/12|0;ha=ta;d=oa;if(ma){ma=1;wa=0;do{Ca=Aa-+n[ha+(wa*12|0)>>2];Da=Ba-+n[ha+(wa*12|0)+4>>2];ua=!(Ca*Ca+Da*Da<i);ma=ma&ua;wa=wa+1|0}while(wa>>>0<na>>>0&ua);if(ma)Ea=49}else Ea=49;do if((Ea|0)==49){Ea=0;if((d|0)==(f[$>>2]|0)){voa(q,o);break}else{n[oa>>2]=Aa;f[d+4>>2]=f[sa>>2];f[d+8>>2]=f[ra>>2];f[ya>>2]=d+12;break}}while(0);d=qa+1|0;if((d|0)==(la|0))break a;qa=d;pa=f[p>>2]|0;ta=f[q>>2]|0;oa=f[ya>>2]|0}}}else{f[A>>2]=0;oa=A+4|0;f[oa>>2]=0;f[A+8>>2]=0;if((Z|0)<(Y(O,O)|0)){f[B>>2]=0;ta=B+4|0;f[ta>>2]=0;f[B+8>>2]=0;exa(B,Z);pa=y+8|0;qa=f[pa>>2]|0;if((qa|0)>0){la=y+16|0;ra=y+44|0;sa=y+12|0;_=o+4|0;d=B+8|0;ma=qa;qa=0;na=f[sa>>2]|0;while(1){wa=(f[la>>2]|0)+(Y(f[f[ra>>2]>>2]|0,qa)|0)|0;if((na|0)>0){ha=na;ua=0;while(1){if(!(b[wa+ua>>0]|0))Fa=ha;else{f[o>>2]=ua;f[_>>2]=qa;va=f[ta>>2]|0;if((va|0)==(f[d>>2]|0)){fga(B,o);Ga=f[sa>>2]|0}else{f[va>>2]=ua;f[va+4>>2]=qa;f[ta>>2]=va+8;Ga=ha}Fa=Ga}ua=ua+1|0;if((ua|0)>=(Fa|0))break;else ha=Fa}Ha=Fa;Ia=f[pa>>2]|0}else{Ha=na;Ia=ma}qa=qa+1|0;if((qa|0)>=(Ia|0))break;else{ma=Ia;na=Ha}}}f[o>>2]=0;f[o+4>>2]=da;fxa(C,B,Z,p,A,f[ea>>2]|0,G,L,O,P,w);y8(o,C,ca);na=f[B>>2]|0;if(na|0){ma=f[ta>>2]|0;if((ma|0)!=(na|0))f[ta>>2]=ma+(~((ma+-8-na|0)>>>3)<<3);YDc(na)}}else{f[o>>2]=0;f[o+4>>2]=da;gxa(B,y,Z,p,A,f[ea>>2]|0,G,L,O,P,w);y8(o,B,ca)}na=f[A>>2]|0;ma=f[oa>>2]|0;f[o>>2]=540;ixa(na,ma,o);ma=f[A>>2]|0;na=f[oa>>2]|0;if((ma|0)!=(na|0)){qa=o+4|0;pa=o+8|0;sa=ma;do{ma=f[sa>>2]|0;f[o>>2]=ma;f[qa>>2]=f[sa+4>>2];f[pa>>2]=f[sa+8>>2];d=f[ya>>2]|0;if((d|0)==(f[$>>2]|0))voa(q,o);else{f[d>>2]=ma;f[d+4>>2]=f[qa>>2];f[d+8>>2]=f[pa>>2];f[ya>>2]=d+12}sa=sa+16|0}while((sa|0)!=(na|0))}i=h*h;na=f[ya>>2]|0;sa=f[q>>2]|0;pa=(na-sa|0)/12|0;if(pa>>>0>1){qa=1;ta=1;d=na;ma=sa;while(1){_=ma;ra=f[_+(ta*12|0)>>2]|0;la=f[_+(ta*12|0)+4>>2]|0;ha=f[_+(ta*12|0)+8>>2]|0;Aa=(f[s>>2]=ra,+n[s>>2]);Ba=(f[s>>2]=la,+n[s>>2]);if(qa){ua=1;wa=0;do{Da=Aa-+n[_+(wa*12|0)>>2];Ca=Ba-+n[_+(wa*12|0)+4>>2];va=!(Da*Da+Ca*Ca<i);ua=ua&va;wa=wa+1|0}while(wa>>>0<qa>>>0&va);if(!ua){Ja=qa;Ka=ma;La=d}else Ea=87}else Ea=87;if((Ea|0)==87){Ea=0;f[_+(qa*12|0)>>2]=ra;f[_+(qa*12|0)+4>>2]=la;f[_+(qa*12|0)+8>>2]=ha;Ja=qa+1|0;Ka=f[q>>2]|0;La=f[ya>>2]|0}ta=ta+1|0;wa=(La-Ka|0)/12|0;if(ta>>>0>=wa>>>0){Ma=Ja;Na=wa;Oa=Ka;Pa=La;break}else{qa=Ja;d=La;ma=Ka}}}else{Ma=1;Na=pa;Oa=sa;Pa=na}ma=Oa;d=Pa;do if(Ma>>>0>Na>>>0)jxa(q,Ma-Na|0);else{if(Ma>>>0>=Na>>>0)break;qa=ma+(Ma*12|0)|0;if((d|0)==(qa|0))break;f[ya>>2]=d+(~(((d+-12-qa|0)>>>0)/12|0)*12|0)}while(0);d=f[A>>2]|0;if(d|0){ma=f[oa>>2]|0;if((ma|0)!=(d|0))f[oa>>2]=ma+(~((ma+-16-d|0)>>>4)<<4);YDc(d)}}while(0);Ma=f[q>>2]|0;Na=(f[ya>>2]|0)-Ma|0;Pa=(Na|0)/12|0;if(!Na)Qa=Ma;else{Vj(D,1,(Pa|0)<(j|0)?Pa:j,21,Ma,0);h_(D,c);Ma=D+36|0;Pa=f[Ma>>2]|0;do if(Pa|0){Na=Pa+12|0;Oa=f[Na>>2]|0;f[Na>>2]=Oa+-1;if((Oa|0)!=1)break;_S(D)}while(0);f[Ma>>2]=0;Ma=D+16|0;Pa=D+4|0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[Ma+8>>2]=0;f[Ma+12>>2]=0;if((f[Pa>>2]|0)>0){Ma=f[D+40>>2]|0;Oa=0;do{f[Ma+(Oa<<2)>>2]=0;Oa=Oa+1|0}while((Oa|0)<(f[Pa>>2]|0))}Pa=f[D+44>>2]|0;if((Pa|0)!=(D+48|0))g0(Pa);Qa=f[q>>2]|0}if(Qa|0){Pa=f[ya>>2]|0;if((Pa|0)!=(Qa|0))f[ya>>2]=Pa+(~(((Pa+-12-Qa|0)>>>0)/12|0)*12|0);YDc(Qa)}za=f[p>>2]|0}if(za|0){Qa=f[xa>>2]|0;if((Qa|0)!=(za|0))f[xa>>2]=Qa+(~((Qa+-4-za|0)>>>2)<<2);YDc(za)}za=f[ga>>2]|0;if(za|0?(Qa=za+12|0,za=f[Qa>>2]|0,f[Qa>>2]=za+-1,(za|0)==1):0)_S(z);f[ga>>2]=0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[ba>>2]|0)>0){fa=f[ia>>2]|0;ia=0;do{f[fa+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ba>>2]|0))}ba=f[ka>>2]|0;if((ba|0)!=(ja|0))g0(ba)}ba=y+36|0;ja=f[ba>>2]|0;if(ja|0?(ka=ja+12|0,ja=f[ka>>2]|0,f[ka>>2]=ja+-1,(ja|0)==1):0)_S(y);f[ba>>2]=0;ba=y+16|0;ja=y+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ja>>2]|0)>0){ba=f[y+40>>2]|0;ka=0;do{f[ba+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[ja>>2]|0))}ja=f[y+44>>2]|0;if((ja|0)!=(y+48|0))g0(ja);mx(x);l6(w);ja=v+36|0;ka=f[ja>>2]|0;if(ka|0?(ba=ka+12|0,ka=f[ba>>2]|0,f[ba>>2]=ka+-1,(ka|0)==1):0)_S(v);f[ja>>2]=0;ja=v+16|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[U>>2]|0)>0){ja=f[W>>2]|0;W=0;do{f[ja+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[U>>2]|0))}U=f[X>>2]|0;if((U|0)!=(V|0))g0(U);U=t+36|0;V=f[U>>2]|0;if(V|0?(X=V+12|0,V=f[X>>2]|0,f[X>>2]=V+-1,(V|0)==1):0)_S(t);f[U>>2]=0;U=t+16|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[Q>>2]|0)>0){U=f[S>>2]|0;S=0;do{f[U+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[Q>>2]|0))}Q=f[T>>2]|0;if((Q|0)!=(R|0))g0(Q);Q=r+36|0;R=f[Q>>2]|0;do if(R|0){T=R+12|0;S=f[T>>2]|0;f[T>>2]=S+-1;if((S|0)!=1)break;_S(r)}while(0);f[Q>>2]=0;Q=r+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[F>>2]|0)>0){Q=f[k>>2]|0;k=0;do{f[Q+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[F>>2]|0))}F=f[N>>2]|0;if((F|0)!=(M|0))g0(F);u=m;return}case 29:{h=e;e=g;switch(E|0){case 3:case 5:case 7:case -1:break;default:{f[o>>2]=0;f[o+4>>2]=0;I=tT(o,73)|0;J=285448;K=I+73|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-215,o,285522,284643,1631)}}g=h<1.0?1.0:h;h=1.0/g;f[r>>2]=1124007936;F=r+4|0;M=r+8|0;N=r+40|0;I=F;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[N>>2]=M;k=r+48|0;Q=r+44|0;f[Q>>2]=k;f[k>>2]=0;f[r+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[T>>2]=S;S=t+48|0;U=t+44|0;f[U>>2]=S;f[S>>2]=0;f[t+52>>2]=0;f[v>>2]=1124007936;V=v+4|0;X=v+8|0;W=v+40|0;I=V;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[W>>2]=X;X=v+48|0;ja=v+44|0;f[ja>>2]=X;f[X>>2]=0;f[v+52>>2]=0;ka=o+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=t;Hoa(a,o,3,1,0,E,1.0,0.0,1);ka=o+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=v;Hoa(a,o,3,0,1,E,1.0,0.0,1);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=t;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=v;E=q+8|0;f[E>>2]=0;f[E+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=r;E=(H|0)/2|0;coa(o,p,q,+(((E|0)>1?E:1)|0),+(H|0),0);k6(w);H=z8()|0;E=(H|0)>1;f[x>>2]=0;ka=x+4|0;f[ka>>2]=0;f[x+8>>2]=0;ba=k$(a,-1)|0;ia=l$(a,-1)|0;b[o>>0]=0;dxa(y,ba,ia,o);ia=f[M>>2]|0;f[o>>2]=0;f[o+4>>2]=ia;f[p>>2]=60952;f[p+4>>2]=r;f[p+8>>2]=t;f[p+12>>2]=v;f[p+16>>2]=L;f[p+20>>2]=O;n[p+24>>2]=h;f[p+28>>2]=x;f[p+32>>2]=y;f[p+48>>2]=w;ca=h*+(f[r+12>>2]|0);M=~~ca;ba=(+(M|0)<ca&1)+M|0;f[p+36>>2]=ba;ca=h*+(ia|0);ia=~~ca;f[p+40>>2]=(+(ia|0)<ca&1)+ia;f[p+44>>2]=ba+2;ca=+(((H|0)>1?H:1)|0);y8(o,p,ca);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=-2130640896;f[o+4>>2]=y;H=N2(o)|0;if((H|0)>=1){ba=f[x>>2]|0;f[z>>2]=f[ba>>2];ia=z+4|0;M=ba+4|0;f[ia>>2]=f[M>>2];a=z+8|0;f[a>>2]=f[ba+8>>2];fa=z+12|0;f[fa>>2]=f[ba+12>>2];ga=z+16|0;f[ga>>2]=f[ba+16>>2];f[z+20>>2]=f[ba+20>>2];f[z+24>>2]=f[ba+24>>2];f[z+28>>2]=f[ba+28>>2];f[z+32>>2]=f[ba+32>>2];za=z+36|0;Qa=f[ba+36>>2]|0;f[za>>2]=Qa;xa=z+40|0;f[xa>>2]=a;Pa=z+48|0;ya=z+44|0;f[ya>>2]=Pa;f[Pa>>2]=0;f[z+52>>2]=0;if(Qa|0){Oa=Qa+12|0;f[Oa>>2]=(f[Oa>>2]|0)+1}if((f[M>>2]|0)<3){M=f[ba+44>>2]|0;Oa=f[ya>>2]|0;f[Oa>>2]=f[M>>2];f[Oa+4>>2]=f[M+4>>2]}else{f[ia>>2]=0;ZS(z,ba)}ba=f[ka>>2]|0;M=f[x>>2]|0;Oa=M;if(((ba-M|0)/56|0)>>>0>1){M=o+8|0;Qa=o+12|0;Ma=o+4|0;Na=p+8|0;Ka=p+12|0;La=p+4|0;Ja=q+8|0;$=q+4|0;ea=1;Z=Oa;while(1){f[M>>2]=0;f[Qa>>2]=0;f[o>>2]=16842752;f[Ma>>2]=z;f[Na>>2]=0;f[Ka>>2]=0;f[p>>2]=16842752;f[La>>2]=Z+(ea*56|0);da=Ja;f[da>>2]=0;f[da+4>>2]=0;f[q>>2]=33619968;f[$>>2]=z;mL(o,p,q,e0()|0,-1);ea=ea+1|0;da=f[ka>>2]|0;Ha=f[x>>2]|0;Ia=Ha;if(ea>>>0>=((da-Ha|0)/56|0)>>>0){Ra=Ia;Sa=da;break}else Z=Ia}}else{Ra=Oa;Sa=ba}ba=Sa;if((ba|0)!=(Ra|0)){Sa=ba;do{ba=Sa+-56|0;f[ka>>2]=ba;Oa=Sa+-20|0;Z=f[Oa>>2]|0;if(Z|0?(ea=Z+12|0,Z=f[ea>>2]|0,f[ea>>2]=Z+-1,(Z|0)==1):0)_S(ba);f[Oa>>2]=0;Oa=Sa+-40|0;ba=Sa+-52|0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[ba>>2]|0)>0){Oa=f[Sa+-16>>2]|0;Z=0;do{f[Oa+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[ba>>2]|0))}ba=f[Sa+-12>>2]|0;if((ba|0)!=(Sa+-8|0))g0(ba);Sa=f[ka>>2]|0}while((Sa|0)!=(Ra|0))}f[p>>2]=0;Ra=p+4|0;f[Ra>>2]=0;f[p+8>>2]=0;Sa=f[a>>2]|0;f[o>>2]=1;f[o+4>>2]=Sa+-1;f[q>>2]=60972;f[q+4>>2]=z;f[q+8>>2]=p;f[q+12>>2]=G;f[q+28>>2]=w;f[q+16>>2]=f[fa>>2];f[q+20>>2]=Sa;f[q+24>>2]=f[ga>>2];y8(o,q,E?+((Sa+-2|0)/4|0|0):1.0);Sa=f[Ra>>2]|0;E=f[p>>2]|0;a=Sa-E>>2;ka=E;if(!a)Ta=ka;else{f[o>>2]=f[ga>>2];Vwa(ka,Sa,o);f[q>>2]=0;Sa=q+4|0;f[Sa>>2]=0;f[q+8>>2]=0;ka=q+8|0;E=VDc(4096)|0;ba=E;f[q>>2]=ba;f[Sa>>2]=ba;f[ka>>2]=E+4096;b:do if(l){E=f[fa>>2]|0;Z=f[p>>2]|0;Oa=(f[Ra>>2]|0)-Z>>2;h=e*e;if(Oa|0){oa=o+4|0;ea=o+8|0;$=o+12|0;Ja=0;La=Z;Z=ba;Ka=ba;while(1){Na=f[La+(Ja<<2)>>2]|0;Ma=(Na|0)/(E|0)|0;P=g*(+(Na-(Y(Ma,E)|0)|0)+.5);i=g*(+(Ma|0)+.5);n[o>>2]=P;n[oa>>2]=i;n[ea>>2]=0.0;n[$>>2]=+(Na|0);Na=Ka-Z>>4;Ma=Z;Qa=Ka;if(Na){M=1;Ia=0;do{Ba=P-+n[Ma+(Ia<<4)>>2];Aa=i-+n[Ma+(Ia<<4)+4>>2];da=!(Ba*Ba+Aa*Aa<h);M=M&da;Ia=Ia+1|0}while(Ia>>>0<Na>>>0&da);if(M)Ea=183}else Ea=183;do if((Ea|0)==183){Ea=0;if((Qa|0)==(f[ka>>2]|0)){kxa(q,o);break}else{n[Ka>>2]=P;f[Qa+4>>2]=f[oa>>2];f[Qa+8>>2]=f[ea>>2];f[Qa+12>>2]=f[$>>2];f[Sa>>2]=Qa+16;break}}while(0);Qa=Ja+1|0;if((Qa|0)==(Oa|0))break b;Ja=Qa;La=f[p>>2]|0;Z=f[q>>2]|0;Ka=f[Sa>>2]|0}}}else{f[A>>2]=0;Ka=A+4|0;f[Ka>>2]=0;f[A+8>>2]=0;if((H|0)<(Y(O,O)|0)){f[B>>2]=0;Z=B+4|0;f[Z>>2]=0;f[B+8>>2]=0;exa(B,H);La=y+8|0;Ja=f[La>>2]|0;if((Ja|0)>0){Oa=y+16|0;$=y+44|0;ea=y+12|0;oa=o+4|0;E=B+8|0;Qa=Ja;Ja=0;M=f[ea>>2]|0;while(1){Na=(f[Oa>>2]|0)+(Y(f[f[$>>2]>>2]|0,Ja)|0)|0;if((M|0)>0){Ia=M;Ma=0;while(1){if(!(b[Na+Ma>>0]|0))Ua=Ia;else{f[o>>2]=Ma;f[oa>>2]=Ja;ha=f[Z>>2]|0;if((ha|0)==(f[E>>2]|0)){fga(B,o);Va=f[ea>>2]|0}else{f[ha>>2]=Ma;f[ha+4>>2]=Ja;f[Z>>2]=ha+8;Va=Ia}Ua=Va}Ma=Ma+1|0;if((Ma|0)>=(Ua|0))break;else Ia=Ua}Wa=Ua;Xa=f[La>>2]|0}else{Wa=M;Xa=Qa}Ja=Ja+1|0;if((Ja|0)>=(Xa|0))break;else{Qa=Xa;M=Wa}}}f[o>>2]=0;f[o+4>>2]=a;fxa(C,B,H,p,A,f[fa>>2]|0,G,L,O,g,w);y8(o,C,ca);M=f[B>>2]|0;if(M|0){Qa=f[Z>>2]|0;if((Qa|0)!=(M|0))f[Z>>2]=Qa+(~((Qa+-8-M|0)>>>3)<<3);YDc(M)}}else{f[o>>2]=0;f[o+4>>2]=a;gxa(B,y,H,p,A,f[fa>>2]|0,G,L,O,g,w);y8(o,B,ca)}M=f[A>>2]|0;Qa=f[Ka>>2]|0;f[o>>2]=540;ixa(M,Qa,o);Qa=f[A>>2]|0;M=f[Ka>>2]|0;if((Qa|0)!=(M|0)){Ja=o+4|0;La=o+8|0;ea=o+12|0;E=Qa;do{Qa=f[E>>2]|0;oa=f[E+4>>2]|0;$=f[E+8>>2]|0;h=+(f[E+12>>2]|0);f[o>>2]=Qa;f[Ja>>2]=oa;f[La>>2]=$;n[ea>>2]=h;$=f[Sa>>2]|0;if(($|0)==(f[ka>>2]|0))kxa(q,o);else{f[$>>2]=Qa;f[$+4>>2]=f[Ja>>2];f[$+8>>2]=f[La>>2];f[$+12>>2]=f[ea>>2];f[Sa>>2]=$+16}E=E+16|0}while((E|0)!=(M|0))}h=e*e;M=f[Sa>>2]|0;E=f[q>>2]|0;ea=M-E>>4;if(ea>>>0>1){La=1;Ja=1;Z=M;$=E;while(1){Qa=$;oa=f[Qa+(Ja<<4)>>2]|0;Oa=f[Qa+(Ja<<4)+4>>2]|0;Ia=f[Qa+(Ja<<4)+8>>2]|0;Ma=f[Qa+(Ja<<4)+12>>2]|0;P=(f[s>>2]=oa,+n[s>>2]);i=(f[s>>2]=Oa,+n[s>>2]);if(La){Na=1;ha=0;do{Aa=P-+n[Qa+(ha<<4)>>2];Ba=i-+n[Qa+(ha<<4)+4>>2];_=!(Aa*Aa+Ba*Ba<h);Na=Na&_;ha=ha+1|0}while(ha>>>0<La>>>0&_);if(!Na){Ya=La;Za=$;_a=Z}else Ea=221}else Ea=221;if((Ea|0)==221){Ea=0;f[Qa+(La<<4)>>2]=oa;f[Qa+(La<<4)+4>>2]=Oa;f[Qa+(La<<4)+8>>2]=Ia;f[Qa+(La<<4)+12>>2]=Ma;Ya=La+1|0;Za=f[q>>2]|0;_a=f[Sa>>2]|0}Ja=Ja+1|0;ha=_a-Za>>4;if(Ja>>>0>=ha>>>0){$a=Ya;ab=ha;bb=Za;cb=_a;break}else{La=Ya;Z=_a;$=Za}}}else{$a=1;ab=ea;bb=E;cb=M}$=bb;Z=cb;do if($a>>>0>ab>>>0)lxa(q,$a-ab|0);else{if($a>>>0>=ab>>>0)break;La=$+($a<<4)|0;if((Z|0)==(La|0))break;f[Sa>>2]=Z+(~((Z+-16-La|0)>>>4)<<4)}while(0);Z=f[A>>2]|0;if(Z|0){$=f[Ka>>2]|0;if(($|0)!=(Z|0))f[Ka>>2]=$+(~(($+-16-Z|0)>>>4)<<4);YDc(Z)}}while(0);A=f[q>>2]|0;$a=(f[Sa>>2]|0)-A>>4;if(!$a)db=A;else{Vj(D,1,($a|0)<(j|0)?$a:j,29,A,0);h_(D,c);c=D+36|0;A=f[c>>2]|0;do if(A|0){j=A+12|0;$a=f[j>>2]|0;f[j>>2]=$a+-1;if(($a|0)!=1)break;_S(D)}while(0);f[c>>2]=0;c=D+16|0;A=D+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[A>>2]|0)>0){c=f[D+40>>2]|0;$a=0;do{f[c+($a<<2)>>2]=0;$a=$a+1|0}while(($a|0)<(f[A>>2]|0))}A=f[D+44>>2]|0;if((A|0)!=(D+48|0))g0(A);db=f[q>>2]|0}if(db|0){q=f[Sa>>2]|0;if((q|0)!=(db|0))f[Sa>>2]=q+(~((q+-16-db|0)>>>4)<<4);YDc(db)}Ta=f[p>>2]|0}if(Ta|0){p=f[Ra>>2]|0;if((p|0)!=(Ta|0))f[Ra>>2]=p+(~((p+-4-Ta|0)>>>2)<<2);YDc(Ta)}Ta=f[za>>2]|0;if(Ta|0?(p=Ta+12|0,Ta=f[p>>2]|0,f[p>>2]=Ta+-1,(Ta|0)==1):0)_S(z);f[za>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ia>>2]|0)>0){ga=f[xa>>2]|0;xa=0;do{f[ga+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[ia>>2]|0))}ia=f[ya>>2]|0;if((ia|0)!=(Pa|0))g0(ia)}ia=y+36|0;Pa=f[ia>>2]|0;if(Pa|0?(ya=Pa+12|0,Pa=f[ya>>2]|0,f[ya>>2]=Pa+-1,(Pa|0)==1):0)_S(y);f[ia>>2]=0;ia=y+16|0;Pa=y+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[Pa>>2]|0)>0){ia=f[y+40>>2]|0;ya=0;do{f[ia+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[Pa>>2]|0))}Pa=f[y+44>>2]|0;if((Pa|0)!=(y+48|0))g0(Pa);mx(x);l6(w);w=v+36|0;x=f[w>>2]|0;if(x|0?(Pa=x+12|0,x=f[Pa>>2]|0,f[Pa>>2]=x+-1,(x|0)==1):0)_S(v);f[w>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[V>>2]|0)>0){w=f[W>>2]|0;W=0;do{f[w+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[V>>2]|0))}V=f[ja>>2]|0;if((V|0)!=(X|0))g0(V);V=t+36|0;X=f[V>>2]|0;if(X|0?(ja=X+12|0,X=f[ja>>2]|0,f[ja>>2]=X+-1,(X|0)==1):0)_S(t);f[V>>2]=0;V=t+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[R>>2]|0)>0){V=f[T>>2]|0;T=0;do{f[V+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[U>>2]|0;if((R|0)!=(S|0))g0(R);R=r+36|0;S=f[R>>2]|0;do if(S|0){U=S+12|0;T=f[U>>2]|0;f[U>>2]=T+-1;if((T|0)!=1)break;_S(r)}while(0);f[R>>2]=0;R=r+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[F>>2]|0)>0){R=f[N>>2]|0;N=0;do{f[R+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[F>>2]|0))}F=f[Q>>2]|0;if((F|0)!=(k|0))g0(F);u=m;return}default:{f[o>>2]=0;f[o+4>>2]=0;I=tT(o,14)|0;J=284827;K=I+14|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));z5(-2,o,285318,284643,1768)}}}function dxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e;f[a>>2]=1124007936;i=a+8|0;j=a+40|0;k=a+4|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+48|0;f[a+44>>2]=i;f[i>>2]=0;f[a+52>>2]=0;f[g>>2]=b;f[g+4>>2]=c;XS(a,2,g,0);p[g>>3]=+(h[d>>0]|0);d=g+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;k_(a,g)|0;u=e;return}function exa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[a>>2]|0;e=d;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>536870911){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}h=f[g>>2]|0;i=VDc(b<<3)|0;j=i+(h-d>>3<<3)|0;k=j;l=i+(b<<3)|0;b=h;if((b|0)==(e|0))m=k;else{h=b+-8-d|0;i=b;b=j;while(1){n=i;i=i+-8|0;f[b+-8>>2]=f[i>>2];f[b+-4>>2]=f[n+-4>>2];if((i|0)==(e|0))break;else b=b+-8|0}m=j+(~(h>>>3)<<3)|0}f[a>>2]=m;f[g>>2]=k;f[c>>2]=l;if(!d)return;YDc(d);return}function fxa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=m|0;var o=0,p=0;o=u;u=u+16|0;p=o;f[a>>2]=61012;f[a+4>>2]=c;f[a+8>>2]=d;f[a+12>>2]=e;f[a+16>>2]=g;f[a+20>>2]=h;f[a+24>>2]=i;f[a+28>>2]=j;f[a+32>>2]=k;n[a+36>>2]=l;f[a+52>>2]=m;l=+(j|0);n[a+44>>2]=l*l;l=+(k|0);n[a+48>>2]=l*l;f[a+40>>2]=(f[e+4>>2]|0)-(f[e>>2]|0)>>2;if((d|0)>0){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,8)|0;d=o;b[d>>0]=110;b[d+1>>0]=122;b[d+2>>0]=83;b[d+3>>0]=122;d=o+4|0;b[d>>0]=32;b[d+1>>0]=62;b[d+2>>0]=32;b[d+3>>0]=48;z5(-215,p,285613,284643,1395)}}function gxa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=m|0;var o=0,p=0;o=u;u=u+16|0;p=o;f[a>>2]=60992;f[a+4>>2]=c;f[a+8>>2]=d;f[a+12>>2]=e;f[a+16>>2]=g;f[a+20>>2]=h;f[a+24>>2]=i;f[a+28>>2]=j;f[a+32>>2]=k;n[a+36>>2]=l;f[a+52>>2]=m;l=+(j|0);n[a+44>>2]=l*l;l=+(k|0);n[a+48>>2]=l*l;f[a+40>>2]=(f[e+4>>2]|0)-(f[e>>2]|0)>>2;if((d|0)>0){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,8)|0;d=o;b[d>>0]=110;b[d+1>>0]=122;b[d+2>>0]=83;b[d+3>>0]=122;d=o+4|0;b[d>>0]=32;b[d+1>>0]=62;b[d+2>>0]=32;b[d+3>>0]=48;z5(-215,p,285613,284643,1395)}}function hxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,g=0.0,h=0;c=f[a+12>>2]|0;d=f[b+12>>2]|0;if((c|0)<=(d|0))if((c|0)>=(d|0)){e=+n[a+8>>2];g=+n[b+8>>2];if(!(e>g))if(!(e<g)){g=+n[a>>2];e=+n[b>>2];if(!(g<e))if(!(g>e)?+n[a+4>>2]<+n[b+4>>2]:0)h=1;else h=0;else h=1}else h=0;else h=1}else h=0;else h=1;return h|0}function ixa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-16|0;i=a+-12|0;j=a+-8|0;k=a+-4|0;l=g;while(1){m=l;b:while(1){n=m;o=b-n|0;p=o>>4;switch(p|0){case 2:{q=5;break a;break}case 3:{q=7;break a;break}case 4:{q=8;break a;break}case 5:{q=12;break a;break}case 1:case 0:{q=56;break a;break}default:{}}if((o|0)<112){q=14;break a}r=m+(((p|0)/2|0)<<4)|0;if((o|0)>15984){o=(p|0)/4|0;s=nxa(m,m+(o<<4)|0,r,r+(o<<4)|0,h,c)|0}else s=mxa(m,r,h,c)|0;if(Mi[f[c>>2]&1023](m,r)|0){t=h;v=s;break}else w=h;while(1){x=w+-16|0;if((m|0)==(x|0))break;if(Mi[f[c>>2]&1023](x,r)|0){q=39;break b}else w=x}o=m+16|0;if(Mi[f[c>>2]&1023](m,h)|0)y=o;else{if((o|0)==(h|0)){q=56;break a}else z=o;while(1){if(Mi[f[c>>2]&1023](m,z)|0)break;o=z+16|0;if((o|0)==(h|0)){q=56;break a}else z=o}o=f[z>>2]|0;p=f[z+4>>2]|0;A=f[z+8>>2]|0;B=f[z+12>>2]|0;f[z>>2]=f[h>>2];f[z+4>>2]=f[h+4>>2];f[z+8>>2]=f[h+8>>2];f[z+12>>2]=f[h+12>>2];f[h>>2]=o;f[i>>2]=p;f[j>>2]=A;f[k>>2]=B;y=z+16|0}if((y|0)==(h|0)){q=56;break a}else{C=h;D=y}while(1){B=D;while(1){E=B+16|0;if(Mi[f[c>>2]&1023](m,B)|0){F=C;break}else B=E}while(1){G=F+-16|0;if(Mi[f[c>>2]&1023](m,G)|0)F=G;else break}if(B>>>0>=G>>>0){m=B;continue b}A=f[B>>2]|0;p=f[B+4>>2]|0;o=f[B+8>>2]|0;H=f[B+12>>2]|0;f[B>>2]=f[G>>2];f[B+4>>2]=f[G+4>>2];f[B+8>>2]=f[G+8>>2];f[B+12>>2]=f[G+12>>2];f[G>>2]=A;f[F+-12>>2]=p;f[F+-8>>2]=o;f[F+-4>>2]=H;C=G;D=E}}if((q|0)==39){q=0;H=f[m>>2]|0;o=f[m+4>>2]|0;p=f[m+8>>2]|0;A=f[m+12>>2]|0;f[m>>2]=f[x>>2];f[m+4>>2]=f[x+4>>2];f[m+8>>2]=f[x+8>>2];f[m+12>>2]=f[x+12>>2];f[x>>2]=H;f[w+-12>>2]=o;f[w+-8>>2]=p;f[w+-4>>2]=A;t=x;v=s+1|0}A=m+16|0;c:do if(A>>>0<t>>>0){p=r;o=t;H=A;I=v;while(1){J=H;while(1){K=J+16|0;if(Mi[f[c>>2]&1023](J,p)|0)J=K;else{L=o;break}}while(1){M=L+-16|0;if(Mi[f[c>>2]&1023](M,p)|0)break;else L=M}if(J>>>0>M>>>0){N=p;O=I;P=J;break c}B=f[J>>2]|0;Q=f[J+4>>2]|0;R=f[J+8>>2]|0;S=f[J+12>>2]|0;f[J>>2]=f[M>>2];f[J+4>>2]=f[M+4>>2];f[J+8>>2]=f[M+8>>2];f[J+12>>2]=f[M+12>>2];f[M>>2]=B;f[L+-12>>2]=Q;f[L+-8>>2]=R;f[L+-4>>2]=S;p=(p|0)==(J|0)?M:p;o=M;H=K;I=I+1|0}}else{N=r;O=v;P=A}while(0);if((P|0)!=(N|0)?Mi[f[c>>2]&1023](N,P)|0:0){A=f[P>>2]|0;I=f[P+4>>2]|0;H=f[P+8>>2]|0;o=f[P+12>>2]|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];f[P+12>>2]=f[N+12>>2];f[N>>2]=A;f[N+4>>2]=I;f[N+8>>2]=H;f[N+12>>2]=o;T=O+1|0}else T=O;if(!T){U=oxa(m,P,c)|0;o=P+16|0;if(oxa(o,a,c)|0){q=55;break}if(U){l=o;continue}}o=P;if((o-n|0)>=(b-o|0)){q=54;break}ixa(m,P,c);l=P+16|0}if((q|0)==54){q=0;ixa(P+16|0,a,c);g=m;a=P;continue}else if((q|0)==55){q=0;if(U){q=56;break}else{g=m;a=P;continue}}}if((q|0)==5){if(!(Mi[f[c>>2]&1023](h,m)|0)){u=d;return}P=f[m>>2]|0;g=f[m+4>>2]|0;U=f[m+8>>2]|0;n=f[m+12>>2]|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[h>>2]=P;f[i>>2]=g;f[j>>2]=U;f[k>>2]=n;u=d;return}else if((q|0)==7){mxa(m,m+16|0,h,c)|0;u=d;return}else if((q|0)==8){n=m+16|0;U=m+32|0;mxa(m,n,U,c)|0;if(!(Mi[f[c>>2]&1023](h,U)|0)){u=d;return}g=f[U>>2]|0;P=m+36|0;T=f[P>>2]|0;O=m+40|0;N=f[O>>2]|0;v=m+44|0;r=f[v>>2]|0;f[U>>2]=f[h>>2];f[U+4>>2]=f[h+4>>2];f[U+8>>2]=f[h+8>>2];f[U+12>>2]=f[h+12>>2];f[h>>2]=g;f[i>>2]=T;f[j>>2]=N;f[k>>2]=r;if(!(Mi[f[c>>2]&1023](U,n)|0)){u=d;return}r=f[n>>2]|0;k=m+20|0;N=f[k>>2]|0;j=m+24|0;T=f[j>>2]|0;i=m+28|0;g=f[i>>2]|0;f[n>>2]=f[U>>2];f[n+4>>2]=f[U+4>>2];f[n+8>>2]=f[U+8>>2];f[n+12>>2]=f[U+12>>2];f[U>>2]=r;f[P>>2]=N;f[O>>2]=T;f[v>>2]=g;if(!(Mi[f[c>>2]&1023](n,m)|0)){u=d;return}g=f[m>>2]|0;v=f[m+4>>2]|0;T=f[m+8>>2]|0;O=f[m+12>>2]|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];f[n>>2]=g;f[k>>2]=v;f[j>>2]=T;f[i>>2]=O;u=d;return}else if((q|0)==12){nxa(m,m+16|0,m+32|0,m+48|0,h,c)|0;u=d;return}else if((q|0)==14){h=m+32|0;mxa(m,m+16|0,h,c)|0;O=m+48|0;if((O|0)==(a|0)){u=d;return}i=e+4|0;T=e+8|0;j=e+12|0;v=O;O=h;while(1){if(Mi[f[c>>2]&1023](v,O)|0){f[e>>2]=f[v>>2];f[i>>2]=f[v+4>>2];f[T>>2]=f[v+8>>2];f[j>>2]=f[v+12>>2];h=O;k=v;while(1){f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];if((h|0)==(m|0))break;g=h+-16|0;if(Mi[f[c>>2]&1023](e,g)|0){n=h;h=g;k=n}else break}f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2]}k=v+16|0;if((k|0)==(a|0))break;else{n=v;v=k;O=n}}u=d;return}else if((q|0)==56){u=d;return}}function jxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)mCc(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=h;g=k+(d*12|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=k+12|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=b;b=b+-12|0;j=i;i=i+-12|0;f[b>>2]=f[i>>2];f[h+-8>>2]=f[j+-8>>2];f[h+-4>>2]=f[j+-4>>2]}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function kxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;do{m=j;j=j+-16|0;k=n;n=n+-16|0;f[j>>2]=f[n>>2];f[m+-12>>2]=f[k+-12>>2];f[m+-8>>2]=f[k+-8>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function lxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)mCc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;do{n=b;b=b+-16|0;o=j;j=j+-16|0;f[b>>2]=f[j>>2];f[n+-12>>2]=f[o+-12>>2];f[n+-8>>2]=f[o+-8>>2];f[n+-4>>2]=f[o+-4>>2]}while((j|0)!=(g|0));l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function mxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=Mi[f[d>>2]&1023](b,a)|0;g=Mi[f[d>>2]&1023](c,b)|0;if(!e){if(!g){h=0;return h|0}e=f[b>>2]|0;i=b+4|0;j=f[i>>2]|0;k=b+8|0;l=f[k>>2]|0;m=b+12|0;n=f[m>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=e;f[c+4>>2]=j;f[c+8>>2]=l;f[c+12>>2]=n;if(!(Mi[f[d>>2]&1023](b,a)|0)){h=1;return h|0}n=f[a>>2]|0;l=f[a+4>>2]|0;j=f[a+8>>2]|0;e=f[a+12>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=n;f[i>>2]=l;f[k>>2]=j;f[m>>2]=e;h=2;return h|0}e=f[a>>2]|0;m=f[a+4>>2]|0;j=f[a+8>>2]|0;k=f[a+12>>2]|0;if(g){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[c>>2]=e;f[c+4>>2]=m;f[c+8>>2]=j;f[c+12>>2]=k;h=1;return h|0};f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=e;e=b+4|0;f[e>>2]=m;m=b+8|0;f[m>>2]=j;j=b+12|0;f[j>>2]=k;if(!(Mi[f[d>>2]&1023](c,b)|0)){h=1;return h|0}d=f[b>>2]|0;k=f[e>>2]|0;e=f[m>>2]|0;m=f[j>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=d;f[c+4>>2]=k;f[c+8>>2]=e;f[c+12>>2]=m;h=2;return h|0}function nxa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=mxa(a,b,c,g)|0;if(Mi[f[g>>2]&1023](d,c)|0){i=f[c>>2]|0;j=c+4|0;k=f[j>>2]|0;l=c+8|0;m=f[l>>2]|0;n=c+12|0;o=f[n>>2]|0;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=i;f[d+4>>2]=k;f[d+8>>2]=m;f[d+12>>2]=o;o=h+1|0;if(Mi[f[g>>2]&1023](c,b)|0){m=f[b>>2]|0;k=b+4|0;i=f[k>>2]|0;p=b+8|0;q=f[p>>2]|0;r=b+12|0;s=f[r>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=m;f[j>>2]=i;f[l>>2]=q;f[n>>2]=s;if(Mi[f[g>>2]&1023](b,a)|0){s=f[a>>2]|0;n=f[a+4>>2]|0;q=f[a+8>>2]|0;l=f[a+12>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=s;f[k>>2]=n;f[p>>2]=q;f[r>>2]=l;t=h+3|0}else t=h+2|0}else t=o}else t=h;if(!(Mi[f[g>>2]&1023](e,d)|0)){u=t;return u|0}h=f[d>>2]|0;o=d+4|0;l=f[o>>2]|0;r=d+8|0;q=f[r>>2]|0;p=d+12|0;n=f[p>>2]|0;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[e>>2]=h;f[e+4>>2]=l;f[e+8>>2]=q;f[e+12>>2]=n;if(!(Mi[f[g>>2]&1023](d,c)|0)){u=t+1|0;return u|0}n=f[c>>2]|0;e=c+4|0;q=f[e>>2]|0;l=c+8|0;h=f[l>>2]|0;k=c+12|0;s=f[k>>2]|0;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=n;f[o>>2]=q;f[r>>2]=h;f[p>>2]=s;if(!(Mi[f[g>>2]&1023](c,b)|0)){u=t+2|0;return u|0}s=f[b>>2]|0;p=b+4|0;h=f[p>>2]|0;r=b+8|0;q=f[r>>2]|0;o=b+12|0;n=f[o>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=s;f[e>>2]=h;f[l>>2]=q;f[k>>2]=n;if(!(Mi[f[g>>2]&1023](b,a)|0)){u=t+3|0;return u|0}g=f[a>>2]|0;n=f[a+4>>2]|0;k=f[a+8>>2]|0;q=f[a+12>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=g;f[p>>2]=n;f[r>>2]=k;f[o>>2]=q;u=t+4|0;return u|0}function oxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;switch(b-a>>4|0){case 2:{g=b+-16|0;if(!(Mi[f[c>>2]&1023](g,a)|0)){h=1;u=d;return h|0}i=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;l=f[a+12>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=i;f[b+-12>>2]=j;f[b+-8>>2]=k;f[b+-4>>2]=l;h=1;u=d;return h|0}case 3:{mxa(a,a+16|0,b+-16|0,c)|0;h=1;u=d;return h|0}case 4:{l=a+16|0;k=a+32|0;j=b+-16|0;mxa(a,l,k,c)|0;if(!(Mi[f[c>>2]&1023](j,k)|0)){h=1;u=d;return h|0}i=f[k>>2]|0;g=a+36|0;m=f[g>>2]|0;n=a+40|0;o=f[n>>2]|0;p=a+44|0;q=f[p>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];f[k+8>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[j>>2]=i;f[b+-12>>2]=m;f[b+-8>>2]=o;f[b+-4>>2]=q;if(!(Mi[f[c>>2]&1023](k,l)|0)){h=1;u=d;return h|0}q=f[l>>2]|0;o=a+20|0;m=f[o>>2]|0;i=a+24|0;j=f[i>>2]|0;r=a+28|0;s=f[r>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[k>>2]=q;f[g>>2]=m;f[n>>2]=j;f[p>>2]=s;if(!(Mi[f[c>>2]&1023](l,a)|0)){h=1;u=d;return h|0}s=f[a>>2]|0;p=f[a+4>>2]|0;j=f[a+8>>2]|0;n=f[a+12>>2]|0;f[a>>2]=f[l>>2];f[a+4>>2]=f[l+4>>2];f[a+8>>2]=f[l+8>>2];f[a+12>>2]=f[l+12>>2];f[l>>2]=s;f[o>>2]=p;f[i>>2]=j;f[r>>2]=n;h=1;u=d;return h|0}case 5:{nxa(a,a+16|0,a+32|0,a+48|0,b+-16|0,c)|0;h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{n=a+32|0;mxa(a,a+16|0,n,c)|0;r=a+48|0;a:do if((r|0)==(b|0)){t=1;v=0}else{j=e+4|0;i=e+8|0;p=e+12|0;o=r;s=0;l=n;while(1){if(Mi[f[c>>2]&1023](o,l)|0){f[e>>2]=f[o>>2];f[j>>2]=f[o+4>>2];f[i>>2]=f[o+8>>2];f[p>>2]=f[o+12>>2];m=l;g=o;while(1){f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];f[g+12>>2]=f[m+12>>2];if((m|0)==(a|0))break;q=m+-16|0;if(Mi[f[c>>2]&1023](e,q)|0){k=m;m=q;g=k}else break}f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];g=s+1|0;if((g|0)==8){t=0;v=(o+16|0)==(b|0);break a}else w=g}else w=s;g=o+16|0;if((g|0)==(b|0)){t=1;v=0;break}else{k=o;o=g;s=w;l=k}}}while(0);h=v|t;u=d;return h|0}}return 0}function pxa(a){a=a|0;YDc(a);return}function qxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0,Oa=0.0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0;d=u;u=u+3376|0;e=d+3312|0;g=d+3256|0;h=d+3240|0;i=d+3224|0;j=d+2160|0;k=d+1096|0;l=d+32|0;m=d;o=d+24|0;p=d+20|0;q=d+16|0;f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;s=a+32|0;t=f[s>>2]|0;v=a+28|0;w=a+36|0;x=+n[w>>2];y=mrc(+(t-(f[v>>2]|0)|0)/x*10.0)|0;z=j+8|0;f[j>>2]=z;A=j+4|0;f[A>>2]=y;if(y>>>0>264){B=XDc(y>>>0>1073741823?-1:y<<2)|0;f[j>>2]=B}B=f[a+8>>2]|0;C=k+8|0;f[k>>2]=C;D=k+4|0;E=B>>>0>264;f[D>>2]=B;if(E){F=XDc(B>>>0>1073741823?-1:B<<2)|0;f[k>>2]=F;G=F}else G=C;F=l+8|0;f[l>>2]=F;H=l+4|0;f[H>>2]=B;if(E){E=XDc(B>>>0>1073741823?-1:B<<2)|0;f[l>>2]=E;I=E}else I=F;E=f[c>>2]|0;B=c+4|0;c=f[B>>2]|0;J=(E|0)==0?(c|0)==(f[a+40>>2]|0):0;do if((E|0)<(c|0)){K=a+12|0;L=a+20|0;M=a+4|0;N=a+44|0;O=a+48|0;P=h+8|0;Q=h+12|0;R=h+4|0;S=m+8|0;T=m+4|0;U=y+-1|0;V=(y|0)>1;W=g+36|0;X=g+16|0;Z=g+4|0;_=g+40|0;$=g+44|0;aa=g+48|0;ba=e+36|0;ca=e+16|0;da=e+4|0;ea=e+40|0;fa=e+44|0;ga=e+48|0;ha=a+24|0;ia=e+4|0;ja=e+8|0;ka=e+12|0;la=i+8|0;ma=E;na=x;oa=t;while(1){pa=f[(f[f[K>>2]>>2]|0)+(ma<<2)>>2]|0;qa=f[L>>2]|0;ra=(pa|0)/(qa|0)|0;sa=na*(+(pa-(Y(ra,qa)|0)|0)+.5);ta=na*(+(ra|0)+.5);ra=f[M>>2]|0;ua=+(oa+1|0);qa=~~(sa-ua);pa=(qa|0)>0?qa:0;qa=~~(sa+ua);va=f[ra+12>>2]|0;wa=(va|0)<(qa|0)?va:qa;qa=~~(ta-ua);va=(qa|0)>0?qa:0;qa=~~(ta+ua);xa=f[ra+8>>2]|0;ya=(xa|0)<(qa|0)?xa:qa;if((va|0)<(ya|0)&(pa|0)<(wa|0)){qa=f[ra+16>>2]|0;xa=f[f[ra+44>>2]>>2]|0;ra=va;va=0;while(1){za=qa+(Y(ra,xa)|0)|0;ua=ta-+(ra|0);Aa=ua*ua;Ba=pa;Ca=va;while(1){if(((b[za+Ba>>0]|0)!=0?(ua=sa-+(Ba|0),Da=Aa+ua*ua,+n[N>>2]<=Da):0)?Da<=+n[O>>2]:0){n[G+(Ca<<2)>>2]=Da;Ea=Ca+1|0}else Ea=Ca;Ba=Ba+1|0;if((Ba|0)>=(wa|0))break;else Ca=Ea}ra=ra+1|0;if((ra|0)>=(ya|0))break;else va=Ea}if(Ea){Vj(e,1,Ea,5,G,0);Vj(g,1,Ea,5,I,0);f[P>>2]=0;f[Q>>2]=0;f[h>>2]=-2130640891;f[R>>2]=e;va=S;f[va>>2]=0;f[va+4>>2]=0;f[m>>2]=-2113863675;f[T>>2]=g;l3(h,m);XIc(f[j>>2]|0,0,f[A>>2]<<2|0)|0;if((Ea|0)>0){Aa=+n[w>>2];va=f[j>>2]|0;ya=0;do{ra=mrc((+n[I+(ya<<2)>>2]-+(f[v>>2]|0))/Aa*10.0)|0;wa=(ra|0)<(U|0)?ra:U;ra=va+(((wa|0)>0?wa:0)<<2)|0;f[ra>>2]=(f[ra>>2]|0)+1;ya=ya+1|0}while((ya|0)!=(Ea|0))}a:do if(V){ya=f[j>>2]|0;va=y;ra=0;Aa=0.0;while(1){wa=va+-1|0;Da=+(ra|0);b:do if(!(Aa<1.1920928955078125e-07)){pa=va;xa=wa;while(1){qa=f[ya+(xa<<2)>>2]|0;if(qa){do if((xa|0)>-1){Ca=pa+-10|0;Ba=xa+-1|0;if((xa|0)>(Ca|0)&(xa|0)!=0){Fa=Ba;Ga=qa}else{Ha=qa;Ia=Ba;break}while(1){Ba=(f[ya+(Fa<<2)>>2]|0)+Ga|0;za=Fa+-1|0;if((Fa|0)>(Ca|0)&(Fa|0)>0){Fa=za;Ga=Ba}else{Ha=Ba;Ia=za;break}}}else{Ha=0;Ia=xa}while(0);ua=+(Ia+xa|0)*.5/10.0*+n[w>>2]+ +(f[v>>2]|0);if(!(Aa*+(Ha|0)>=Da*ua))Ja=Ia;else{Ka=Ha;La=Ia;Ma=ua;break b}}else Ja=xa;if((Ja|0)>1){pa=Ja;xa=Ja+-1|0}else{Na=ra;Oa=Aa;break a}}}else{xa=va;pa=wa;while(1){qa=f[ya+(pa<<2)>>2]|0;if(qa){do if((pa|0)>-1){Ca=xa+-10|0;za=pa+-1|0;if((pa|0)>(Ca|0)&(pa|0)!=0){Pa=za;Qa=qa}else{Ra=qa;Sa=za;break}while(1){za=(f[ya+(Pa<<2)>>2]|0)+Qa|0;Ba=Pa+-1|0;if((Pa|0)>(Ca|0)&(Pa|0)>0){Pa=Ba;Qa=za}else{Ra=za;Sa=Ba;break}}}else{Ra=0;Sa=pa}while(0);ua=+(Sa+pa|0)*.5/10.0*+n[w>>2]+ +(f[v>>2]|0);if((Ra|0)<(ra|0)?!(Aa*+(Ra|0)>=Da*ua):0)Ta=Sa;else{Ka=Ra;La=Sa;Ma=ua;break b}}else Ta=pa;if((Ta|0)>1){xa=Ta;pa=Ta+-1|0}else{Na=ra;Oa=Aa;break a}}}while(0);if((La|0)>1){va=La;ra=Ka;Aa=Ma}else{Na=Ka;Oa=Ma;break}}}else{Na=0;Oa=0.0}while(0);ra=f[W>>2]|0;if(ra|0?(va=ra+12|0,ra=f[va>>2]|0,f[va>>2]=ra+-1,(ra|0)==1):0)_S(g);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){ra=f[_>>2]|0;va=0;do{f[ra+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[Z>>2]|0))}va=f[$>>2]|0;if((va|0)!=(aa|0))g0(va);va=f[ba>>2]|0;if(va|0?(ra=va+12|0,va=f[ra>>2]|0,f[ra>>2]=va+-1,(va|0)==1):0)_S(e);f[ba>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[da>>2]|0)>0){va=f[ea>>2]|0;ra=0;do{f[va+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[da>>2]|0))}ra=f[fa>>2]|0;if((ra|0)!=(ga|0))g0(ra);Ua=Oa;Va=Na}else{Ua=0.0;Va=0}}else{Ua=0.0;Va=0}if((Va|0)>(f[ha>>2]|0)){n[e>>2]=sa;n[ia>>2]=ta;n[ja>>2]=Ua;f[ka>>2]=Va;ra=f[r>>2]|0;if((ra|0)==(f[la>>2]|0))rxa(i,e);else{n[ra>>2]=sa;f[ra+4>>2]=f[ia>>2];f[ra+8>>2]=f[ja>>2];f[ra+12>>2]=Va;f[r>>2]=ra+16}}ra=ma+1|0;if((ra|0)>=(f[B>>2]|0))break;ma=ra;na=+n[w>>2];oa=f[s>>2]|0}oa=f[i>>2]|0;ma=f[r>>2]|0;if((oa|0)!=(ma|0)){f[e>>2]=540;ixa(oa,ma,e);if(J){ma=f[a+16>>2]|0;oa=f[ma>>2]|0;f[ma>>2]=f[i>>2];f[i>>2]=oa;oa=ma+4|0;ja=f[oa>>2]|0;f[oa>>2]=f[r>>2];f[r>>2]=ja;ja=ma+8|0;ma=i+8|0;oa=f[ja>>2]|0;f[ja>>2]=f[ma>>2];f[ma>>2]=oa;break}oa=f[a+52>>2]|0;m6(oa);ma=f[a+16>>2]|0;ja=f[ma>>2]|0;ia=ma+4|0;la=f[ia>>2]|0;ka=la;if((ja|0)==(la|0)){f[ma>>2]=f[i>>2];f[i>>2]=ja;f[ia>>2]=f[r>>2];f[r>>2]=ka;ia=ma+8|0;ja=i+8|0;la=f[ia>>2]|0;f[ia>>2]=f[ja>>2];f[ja>>2]=la}else{f[o>>2]=ka;f[p>>2]=f[i>>2];f[q>>2]=f[r>>2];f[h>>2]=f[o>>2];f[g>>2]=f[p>>2];f[e>>2]=f[q>>2];sxa(ma,h,g,e)|0}n6(oa)}}while(0);e=f[l>>2]|0;if((e|0)!=(F|0)){if(e|0)ZDc(e);f[l>>2]=F;f[H>>2]=264}H=f[k>>2]|0;if((H|0)!=(C|0)){if(H|0)ZDc(H);f[k>>2]=C;f[D>>2]=264}D=f[j>>2]|0;if((D|0)!=(z|0)){if(D|0)ZDc(D);f[j>>2]=z;f[A>>2]=264}A=f[i>>2]|0;if(!A){u=d;return}i=f[r>>2]|0;if((i|0)!=(A|0))f[r>>2]=i+(~((i+-16-A|0)>>>4)<<4);YDc(A);u=d;return}function rxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;do{m=j;j=j+-16|0;k=n;n=n+-16|0;f[j>>2]=f[n>>2];f[m+-12>>2]=f[k+-12>>2];f[m+-8>>2]=f[k+-8>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function sxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=h>>4;i=e+(b<<4)|0;j=f[c>>2]|0;k=f[d>>2]|0;d=k-j|0;l=d>>4;m=k;if((d|0)<=0){n=i;return n|0}d=a+8|0;o=f[d>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((l|0)<=(o-r>>4|0)){s=i;t=r-s|0;u=t>>4;if((l|0)>(u|0)){v=j+(u<<4)|0;u=v;if((v|0)==(m|0))w=q;else{x=m+-16-u|0;y=v;v=q;while(1){f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2];f[v+8>>2]=f[y+8>>2];f[v+12>>2]=f[y+12>>2];y=y+16|0;if((y|0)==(m|0))break;else v=v+16|0}v=q+((x>>>4)+1<<4)|0;f[p>>2]=v;w=v}if((t|0)>0){z=u;A=w}else{n=i;return n|0}}else{z=k;A=q}k=A-(i+(l<<4))|0;w=k>>4;u=i+(w<<4)|0;if(u>>>0<q>>>0){t=(q+(0-w<<4)+~s|0)>>>4;s=u;u=A;while(1){f[u>>2]=f[s>>2];f[u+4>>2]=f[s+4>>2];f[u+8>>2]=f[s+8>>2];f[u+12>>2]=f[s+12>>2];s=s+16|0;if(s>>>0>=q>>>0)break;else u=u+16|0}f[p>>2]=A+(t+1<<4)}if(!w)B=j;else{fJc(A+(0-w<<4)|0,i|0,k|0)|0;B=f[c>>2]|0}c=z-B|0;if(!c){n=i;return n|0}fJc(i|0,B|0,c|0)|0;n=i;return n|0}c=(r-g>>4)+l|0;if(c>>>0>268435455)mCc(a);l=o-g|0;o=l>>3;r=l>>4>>>0<134217727?(o>>>0<c>>>0?c:o):268435455;o=i;c=h>>4;do if(r)if(r>>>0>268435455){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{C=VDc(r<<4)|0;break}else C=0;while(0);h=C+(c<<4)|0;c=C+(r<<4)|0;r=j;if((r|0)==(m|0))D=h;else{C=((m+-16-j|0)>>>4)+1|0;j=r;r=h;while(1){f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];j=j+16|0;if((j|0)==(m|0))break;else r=r+16|0}D=h+(C<<4)|0}if(!b)E=h;else{b=i+-16-g|0;g=i;C=h;do{r=C;C=C+-16|0;m=g;g=g+-16|0;f[C>>2]=f[g>>2];f[r+-12>>2]=f[m+-12>>2];f[r+-8>>2]=f[m+-8>>2];f[r+-4>>2]=f[m+-4>>2]}while((g|0)!=(e|0));E=h+(~(b>>>4)<<4)|0}b=E;if((q|0)==(i|0))F=D;else{E=q+-16-o|0;o=i;i=D;while(1){f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];f[i+12>>2]=f[o+12>>2];o=o+16|0;if((o|0)==(q|0))break;else i=i+16|0}F=D+((E>>>4)+1<<4)|0}f[a>>2]=b;f[p>>2]=F;f[d>>2]=c;if(!e){n=h;return n|0}YDc(e);n=h;return n|0}function txa(a){a=a|0;YDc(a);return}function uxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0,Oa=0.0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0;c=u;u=u+3376|0;d=c+3312|0;e=c+3256|0;g=c+3240|0;h=c+3224|0;i=c+2160|0;j=c+1096|0;k=c+32|0;l=c;m=c+24|0;o=c+20|0;p=c+16|0;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;r=a+28|0;s=a+36|0;t=+n[s>>2];v=mrc(+((f[a+32>>2]|0)-(f[r>>2]|0)|0)/t*10.0)|0;w=i+8|0;f[i>>2]=w;x=i+4|0;f[x>>2]=v;if(v>>>0>264){y=XDc(v>>>0>1073741823?-1:v<<2)|0;f[i>>2]=y}y=a+8|0;z=f[y>>2]|0;A=j+8|0;f[j>>2]=A;B=j+4|0;C=z>>>0>264;f[B>>2]=z;if(C){D=XDc(z>>>0>1073741823?-1:z<<2)|0;f[j>>2]=D;E=D}else E=A;D=k+8|0;f[k>>2]=D;F=k+4|0;f[F>>2]=z;if(C){C=XDc(z>>>0>1073741823?-1:z<<2)|0;f[k>>2]=C;G=C}else G=D;C=f[b>>2]|0;H=b+4|0;b=f[H>>2]|0;I=(C|0)==0?(b|0)==(f[a+40>>2]|0):0;do if((C|0)<(b|0)){J=a+12|0;K=a+20|0;L=a+4|0;M=a+44|0;N=a+48|0;O=g+8|0;P=g+12|0;Q=g+4|0;R=l+8|0;S=l+4|0;T=v+-1|0;U=(v|0)>1;V=e+36|0;W=e+16|0;X=e+4|0;Z=e+40|0;_=e+44|0;$=e+48|0;aa=d+36|0;ba=d+16|0;ca=d+4|0;da=d+40|0;ea=d+44|0;fa=d+48|0;ga=a+24|0;ha=d+4|0;ia=d+8|0;ja=d+12|0;ka=h+8|0;la=C;ma=t;na=z;while(1){oa=f[(f[f[J>>2]>>2]|0)+(la<<2)>>2]|0;pa=f[K>>2]|0;qa=(oa|0)/(pa|0)|0;ra=ma*(+(oa-(Y(qa,pa)|0)|0)+.5);sa=ma*(+(qa|0)+.5);qa=f[f[L>>2]>>2]|0;if((na|0)>0){ta=+n[M>>2];pa=0;oa=0;while(1){ua=ra-+(f[qa+(pa<<3)>>2]|0);va=sa-+(f[qa+(pa<<3)+4>>2]|0);wa=ua*ua+va*va;if(ta<=wa?wa<=+n[N>>2]:0){n[E+(oa<<2)>>2]=wa;xa=oa+1|0}else xa=oa;pa=pa+1|0;if((pa|0)==(na|0))break;else oa=xa}if(xa){Vj(d,1,xa,5,E,0);Vj(e,1,xa,5,G,0);f[O>>2]=0;f[P>>2]=0;f[g>>2]=-2130640891;f[Q>>2]=d;oa=R;f[oa>>2]=0;f[oa+4>>2]=0;f[l>>2]=-2113863675;f[S>>2]=e;l3(g,l);XIc(f[i>>2]|0,0,f[x>>2]<<2|0)|0;if((xa|0)>0){ta=+n[s>>2];oa=f[i>>2]|0;pa=0;do{qa=mrc((+n[G+(pa<<2)>>2]-+(f[r>>2]|0))/ta*10.0)|0;ya=(qa|0)<(T|0)?qa:T;qa=oa+(((ya|0)>0?ya:0)<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;pa=pa+1|0}while((pa|0)!=(xa|0))}a:do if(U){pa=f[i>>2]|0;oa=v;qa=0;ta=0.0;while(1){ya=oa+-1|0;wa=+(qa|0);b:do if(!(ta<1.1920928955078125e-07)){za=oa;Aa=ya;while(1){Ba=f[pa+(Aa<<2)>>2]|0;if(Ba){do if((Aa|0)>-1){Ca=za+-10|0;Da=Aa+-1|0;if((Aa|0)>(Ca|0)&(Aa|0)!=0){Ea=Da;Fa=Ba}else{Ga=Ba;Ha=Da;break}while(1){Da=(f[pa+(Ea<<2)>>2]|0)+Fa|0;Ia=Ea+-1|0;if((Ea|0)>(Ca|0)&(Ea|0)>0){Ea=Ia;Fa=Da}else{Ga=Da;Ha=Ia;break}}}else{Ga=0;Ha=Aa}while(0);va=+(Ha+Aa|0)*.5/10.0*+n[s>>2]+ +(f[r>>2]|0);if(!(ta*+(Ga|0)>=wa*va))Ja=Ha;else{Ka=Ga;La=Ha;Ma=va;break b}}else Ja=Aa;if((Ja|0)>1){za=Ja;Aa=Ja+-1|0}else{Na=qa;Oa=ta;break a}}}else{Aa=oa;za=ya;while(1){Ba=f[pa+(za<<2)>>2]|0;if(Ba){do if((za|0)>-1){Ca=Aa+-10|0;Ia=za+-1|0;if((za|0)>(Ca|0)&(za|0)!=0){Pa=Ia;Qa=Ba}else{Ra=Ba;Sa=Ia;break}while(1){Ia=(f[pa+(Pa<<2)>>2]|0)+Qa|0;Da=Pa+-1|0;if((Pa|0)>(Ca|0)&(Pa|0)>0){Pa=Da;Qa=Ia}else{Ra=Ia;Sa=Da;break}}}else{Ra=0;Sa=za}while(0);va=+(Sa+za|0)*.5/10.0*+n[s>>2]+ +(f[r>>2]|0);if((Ra|0)<(qa|0)?!(ta*+(Ra|0)>=wa*va):0)Ta=Sa;else{Ka=Ra;La=Sa;Ma=va;break b}}else Ta=za;if((Ta|0)>1){Aa=Ta;za=Ta+-1|0}else{Na=qa;Oa=ta;break a}}}while(0);if((La|0)>1){oa=La;qa=Ka;ta=Ma}else{Na=Ka;Oa=Ma;break}}}else{Na=0;Oa=0.0}while(0);qa=f[V>>2]|0;if(qa|0?(oa=qa+12|0,qa=f[oa>>2]|0,f[oa>>2]=qa+-1,(qa|0)==1):0)_S(e);f[V>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[X>>2]|0)>0){qa=f[Z>>2]|0;oa=0;do{f[qa+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[X>>2]|0))}oa=f[_>>2]|0;if((oa|0)!=($|0))g0(oa);oa=f[aa>>2]|0;if(oa|0?(qa=oa+12|0,oa=f[qa>>2]|0,f[qa>>2]=oa+-1,(oa|0)==1):0)_S(d);f[aa>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ca>>2]|0)>0){oa=f[da>>2]|0;qa=0;do{f[oa+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[ca>>2]|0))}qa=f[ea>>2]|0;if((qa|0)!=(fa|0))g0(qa);Ua=Oa;Va=Na}else{Ua=0.0;Va=0}}else{Ua=0.0;Va=0}if((Va|0)>(f[ga>>2]|0)){n[d>>2]=ra;n[ha>>2]=sa;n[ia>>2]=Ua;f[ja>>2]=Va;qa=f[q>>2]|0;if((qa|0)==(f[ka>>2]|0))rxa(h,d);else{n[qa>>2]=ra;f[qa+4>>2]=f[ha>>2];f[qa+8>>2]=f[ia>>2];f[qa+12>>2]=Va;f[q>>2]=qa+16}}qa=la+1|0;if((qa|0)>=(f[H>>2]|0))break;la=qa;ma=+n[s>>2];na=f[y>>2]|0}na=f[h>>2]|0;la=f[q>>2]|0;if((na|0)!=(la|0)){f[d>>2]=540;ixa(na,la,d);if(I){la=f[a+16>>2]|0;na=f[la>>2]|0;f[la>>2]=f[h>>2];f[h>>2]=na;na=la+4|0;ia=f[na>>2]|0;f[na>>2]=f[q>>2];f[q>>2]=ia;ia=la+8|0;la=h+8|0;na=f[ia>>2]|0;f[ia>>2]=f[la>>2];f[la>>2]=na;break}na=f[a+52>>2]|0;m6(na);la=f[a+16>>2]|0;ia=f[la>>2]|0;ha=la+4|0;ka=f[ha>>2]|0;ja=ka;if((ia|0)==(ka|0)){f[la>>2]=f[h>>2];f[h>>2]=ia;f[ha>>2]=f[q>>2];f[q>>2]=ja;ha=la+8|0;ia=h+8|0;ka=f[ha>>2]|0;f[ha>>2]=f[ia>>2];f[ia>>2]=ka}else{f[m>>2]=ja;f[o>>2]=f[h>>2];f[p>>2]=f[q>>2];f[g>>2]=f[m>>2];f[e>>2]=f[o>>2];f[d>>2]=f[p>>2];sxa(la,g,e,d)|0}n6(na)}}while(0);d=f[k>>2]|0;if((d|0)!=(D|0)){if(d|0)ZDc(d);f[k>>2]=D;f[F>>2]=264}F=f[j>>2]|0;if((F|0)!=(A|0)){if(F|0)ZDc(F);f[j>>2]=A;f[B>>2]=264}B=f[i>>2]|0;if((B|0)!=(w|0)){if(B|0)ZDc(B);f[i>>2]=w;f[x>>2]=264}x=f[h>>2]|0;if(!x){u=c;return}h=f[q>>2]|0;if((h|0)!=(x|0))f[q>>2]=h+(~((h+-16-x|0)>>>4)<<4);YDc(x);u=c;return}function vxa(a){a=a|0;YDc(a);return}function wxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+48|0;d=c+32|0;e=c+28|0;g=c+24|0;h=c+12|0;i=c+8|0;j=c+4|0;k=c;l=f[b>>2]|0;m=f[b+4>>2]|0;f[h>>2]=0;b=h+4|0;f[b>>2]=0;f[h+8>>2]=0;n=(l|0)==1?(m|0)==((f[(f[a+4>>2]|0)+8>>2]|0)+-1|0):0;o=(l|0)>1?l:1;l=(f[a+20>>2]|0)+-1|0;p=(m|0)<(l|0)?m:l;do if((o|0)<(p|0)){l=a+16|0;m=a+24|0;q=a+12|0;r=h+8|0;s=o;t=f[l>>2]|0;while(1){v=Y(t,s)|0;w=v+1|0;f[d>>2]=w;if((t+-1|0)>1){x=1;y=t;z=v;v=w;while(1){w=f[m>>2]|0;A=f[w+(v<<2)>>2]|0;do if(((((A|0)>(f[q>>2]|0)?(A|0)>(f[w+(z<<2)>>2]|0):0)?(A|0)>=(f[w+(z+2<<2)>>2]|0):0)?(A|0)>(f[w+(v-y<<2)>>2]|0):0)?(A|0)>=(f[w+(y+v<<2)>>2]|0):0){B=f[b>>2]|0;if((B|0)==(f[r>>2]|0)){g6(h,d);break}else{f[B>>2]=v;f[b>>2]=B+4;break}}while(0);x=x+1|0;z=f[d>>2]|0;v=z+1|0;f[d>>2]=v;w=f[l>>2]|0;if((x|0)>=(w+-1|0)){C=w;break}else y=w}}else C=t;s=s+1|0;if((s|0)>=(p|0))break;else t=C}t=f[h>>2]|0;s=f[b>>2]|0;if((t|0)!=(s|0)){if(!n){l=f[a+28>>2]|0;m6(l);r=f[a+8>>2]|0;f[i>>2]=f[r+4>>2];f[j>>2]=f[h>>2];f[k>>2]=f[b>>2];f[g>>2]=f[i>>2];f[e>>2]=f[j>>2];f[d>>2]=f[k>>2];yxa(r,g,e,d)|0;n6(l);D=19;break}l=f[a+8>>2]|0;if((l|0)==(h|0))D=19;else{xxa(l,t,s);D=19}}else E=t}else D=19;while(0);if((D|0)==19)E=f[h>>2]|0;if(!E){u=c;return}h=f[b>>2]|0;if((h|0)!=(E|0))f[b>>2]=h+(~((h+-4-E|0)>>>2)<<2);YDc(E);u=c;return}function xxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)fJc(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);YDc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)mCc(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)mCc(a);j=VDc(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;dJc(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function yxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(h>>2<<2)|0;i=f[c>>2]|0;j=f[d>>2]|0;d=j-i|0;k=d>>2;l=j;if((d|0)<=0){m=b;return m|0}d=a+8|0;n=f[d>>2]|0;o=a+4|0;p=f[o>>2]|0;q=p;if((k|0)<=(n-q>>2|0)){r=b;s=q-r|0;t=s>>2;if((k|0)>(t|0)){u=i+(t<<2)|0;t=u;if((u|0)==(l|0))v=p;else{w=l+-4-t|0;x=u;u=p;while(1){f[u>>2]=f[x>>2];x=x+4|0;if((x|0)==(l|0))break;else u=u+4|0}u=p+((w>>>2)+1<<2)|0;f[o>>2]=u;v=u}if((s|0)>0){y=t;z=v}else{m=b;return m|0}}else{y=j;z=p}j=z-(b+(k<<2))|0;v=j>>2;t=b+(v<<2)|0;if(t>>>0<p>>>0){s=(p+(0-v<<2)+~r|0)>>>2;r=t;t=z;while(1){f[t>>2]=f[r>>2];r=r+4|0;if(r>>>0>=p>>>0)break;else t=t+4|0}f[o>>2]=z+(s+1<<2)}if(!v)A=i;else{fJc(z+(0-v<<2)|0,b|0,j|0)|0;A=f[c>>2]|0}c=y-A|0;if(!c){m=b;return m|0}fJc(b|0,A|0,c|0)|0;m=b;return m|0}c=(q-g>>2)+k|0;if(c>>>0>1073741823)mCc(a);k=n-g|0;g=k>>1;n=k>>2>>>0<536870911?(g>>>0<c>>>0?c:g):1073741823;g=b;c=h>>2;do if(n)if(n>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{B=VDc(n<<2)|0;break}else B=0;while(0);k=B+(c<<2)|0;A=B+(n<<2)|0;n=i;if((n|0)==(l|0))C=k;else{B=((l+-4-i|0)>>>2)+1|0;i=n;n=k;while(1){f[n>>2]=f[i>>2];i=i+4|0;if((i|0)==(l|0))break;else n=n+4|0}C=k+(B<<2)|0}B=k+(0-c<<2)|0;if((h|0)>0)dJc(B|0,e|0,h|0)|0;h=q-g|0;if((h|0)>0){dJc(C|0,b|0,h|0)|0;D=C+(h>>>2<<2)|0}else D=C;f[a>>2]=B;f[o>>2]=D;f[d>>2]=A;if(!e){m=k;return m|0}YDc(e);m=k;return m|0}function zxa(a){a=a|0;YDc(a);return}function Axa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+176|0;g=e+160|0;h=e;i=e+144|0;j=e+88|0;k=e+32|0;l=a+40|0;m=(f[l>>2]|0)+2|0;o=a+36|0;p=(f[o>>2]|0)+2|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=1124007936;q=j+4|0;r=j+8|0;s=j+40|0;t=q;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=r;t=j+48|0;v=j+44|0;f[v>>2]=t;f[t>>2]=0;f[j+52>>2]=0;f[g>>2]=m;f[g+4>>2]=p;XS(j,2,g,4);k_(j,h)|0;p=j+16|0;m=f[p>>2]|0;w=a+32|0;x=f[w>>2]|0;y=f[x+8>>2]|0;z=f[x+12>>2]|0;b[g>>0]=0;dxa(k,y,z,g);z=f[c>>2]|0;y=f[c+4>>2]|0;c=a+4|0;x=f[c>>2]|0;A=f[x+12>>2]|0;if((f[x>>2]&16384|0)!=0?(f[f[a+8>>2]>>2]&16384|0)!=0:0){B=(f[f[a+12>>2]>>2]&16384|0)!=0;C=Y(B?y-z|0:1,A)|0;D=B?z+1|0:y;E=C}else{D=y;E=A}a:do if((z|0)<(D|0)){A=a+8|0;y=a+12|0;C=(E|0)>0;B=k+16|0;F=k+44|0;G=a+24|0;H=a+16|0;I=a+20|0;J=a+44|0;K=z;L=x;while(1){N=(f[L+16>>2]|0)+(Y(f[f[L+44>>2]>>2]|0,K)|0)|0;O=f[A>>2]|0;P=(f[O+16>>2]|0)+(Y(f[f[O+44>>2]>>2]|0,K)|0)|0;O=f[y>>2]|0;Q=(f[O+16>>2]|0)+(Y(f[f[O+44>>2]>>2]|0,K)|0)|0;if(C){O=0;do{b:do if((O|0)<(E|0)){R=O;while(1){if(b[N+R>>0]|0){S=R;break b}T=R+1|0;if((T|0)<(E|0))R=T;else{S=T;break}}}else S=O;while(0);c:do if(((S|0)!=(E|0)?(R=d[P+(S<<1)>>1]|0,U=+(R<<16>>16),T=d[Q+(S<<1)>>1]|0,V=+(T<<16>>16),(T|R)<<16>>16):0)?(W=+M(+(U*U+V*V)),!(W<1.0)):0){R=f[(f[c>>2]|0)+12>>2]|0;T=(S|0)%(R|0)|0;X=((S|0)/(R|0)|0)+K|0;R=(f[B>>2]|0)+(Y(f[f[F>>2]>>2]|0,X)|0)+T|0;b[R>>0]=1;Z=+n[G>>2];R=mrc(U*Z*1024.0/W)|0;_=mrc(V*Z*1024.0/W)|0;$=mrc(+(T|0)*Z*1024.0)|0;T=mrc(+(X|0)*Z*1024.0)|0;X=f[H>>2]|0;aa=f[I>>2]|0;if((X|0)>(aa|0)){ba=X;ca=aa}else{da=X;ea=(Y(X,_)|0)+T|0;fa=(Y(X,R)|0)+$|0;X=aa;while(1){aa=fa>>10;ga=ea>>10;if(aa>>>0>=(f[o>>2]|0)>>>0){ha=X;break}if(ga>>>0>=(f[l>>2]|0)>>>0){ha=X;break}ia=m+((Y(f[J>>2]|0,ga)|0)+aa<<2)|0;f[ia>>2]=(f[ia>>2]|0)+1;ia=f[I>>2]|0;if((da|0)<(ia|0)){da=da+1|0;ea=ea+_|0;fa=fa+R|0;X=ia}else{ha=ia;break}}ba=f[H>>2]|0;ca=ha}if((ba|0)<=(ca|0)){X=ba;fa=(Y(ba,0-_|0)|0)+T|0;ea=(Y(ba,0-R|0)|0)+$|0;while(1){da=ea>>10;ia=fa>>10;if(da>>>0>=(f[o>>2]|0)>>>0)break c;if(ia>>>0>=(f[l>>2]|0)>>>0)break c;aa=m+((Y(f[J>>2]|0,ia)|0)+da<<2)|0;f[aa>>2]=(f[aa>>2]|0)+1;if((X|0)<(f[I>>2]|0)){X=X+1|0;fa=fa-_|0;ea=ea-R|0}else break}}}while(0);O=S+1|0}while((O|0)<(E|0))}O=K+1|0;if((O|0)==(D|0))break a;K=O;L=f[c>>2]|0}}while(0);c=f[a+48>>2]|0;m6(c);D=f[a+28>>2]|0;a=D+4|0;E=f[a>>2]|0;if((E|0)==(f[D+8>>2]|0))Bxa(D,j);else{f[E>>2]=f[j>>2];D=E+4|0;f[D>>2]=f[q>>2];S=E+8|0;f[S>>2]=f[r>>2];f[E+12>>2]=f[j+12>>2];f[E+16>>2]=f[p>>2];f[E+20>>2]=f[j+20>>2];f[E+24>>2]=f[j+24>>2];f[E+28>>2]=f[j+28>>2];f[E+32>>2]=f[j+32>>2];r=f[j+36>>2]|0;f[E+36>>2]=r;f[E+40>>2]=S;S=E+48|0;m=E+44|0;f[m>>2]=S;f[S>>2]=0;f[E+52>>2]=0;if(r|0){S=r+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[q>>2]|0)<3){S=f[v>>2]|0;r=f[m>>2]|0;f[r>>2]=f[S>>2];f[r+4>>2]=f[S+4>>2]}else{f[D>>2]=0;ZS(E,j)}f[a>>2]=(f[a>>2]|0)+56}a=f[w>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=-2130640896;f[g+4>>2]=k;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=-2130640896;f[h+4>>2]=a;w=i+8|0;f[w>>2]=0;f[w+4>>2]=0;f[i>>2]=-2113863680;f[i+4>>2]=a;fL(g,h,i,e0()|0);n6(c);c=k+36|0;i=f[c>>2]|0;if(i|0?(h=i+12|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)_S(k);f[c>>2]=0;c=k+16|0;i=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[i>>2]|0)>0){c=f[k+40>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[i>>2]|0))}i=f[k+44>>2]|0;if((i|0)!=(k+48|0))g0(i);i=j+36|0;k=f[i>>2]|0;if(k|0?(h=k+12|0,k=f[h>>2]|0,f[h>>2]=k+-1,(k|0)==1):0)_S(j);f[i>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[s>>2]|0;s=0;do{f[p+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[v>>2]|0;if((q|0)==(t|0)){u=e;return}g0(q);u=e;return}function Bxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/56|0;h=g+1|0;if(h>>>0>76695844)mCc(a);i=((f[a+8>>2]|0)-e|0)/56|0;e=i<<1;j=i>>>0<38347922?(e>>>0<h>>>0?h:e):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>76695844){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{k=VDc(j*56|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*56|0)|0;h=d+8|0;f[h>>2]=e;f[d+4>>2]=e;f[d+12>>2]=k+(j*56|0);f[e>>2]=f[b>>2];j=k+(g*56|0)+4|0;i=b+4|0;l=f[i>>2]|0;f[j>>2]=l;m=k+(g*56|0)+8|0;f[m>>2]=f[b+8>>2];f[k+(g*56|0)+12>>2]=f[b+12>>2];f[k+(g*56|0)+16>>2]=f[b+16>>2];f[k+(g*56|0)+20>>2]=f[b+20>>2];f[k+(g*56|0)+24>>2]=f[b+24>>2];f[k+(g*56|0)+28>>2]=f[b+28>>2];f[k+(g*56|0)+32>>2]=f[b+32>>2];n=f[b+36>>2]|0;f[k+(g*56|0)+36>>2]=n;f[k+(g*56|0)+40>>2]=m;m=k+(g*56|0)+48|0;o=k+(g*56|0)+44|0;f[o>>2]=m;f[m>>2]=0;f[k+(g*56|0)+52>>2]=0;if(!n)p=l;else{l=n+12|0;f[l>>2]=(f[l>>2]|0)+1;p=f[i>>2]|0}if((p|0)<3){p=f[b+44>>2]|0;i=f[o>>2]|0;f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;hx(a,d);ix(d);u=c;return}else{f[j>>2]=0;ZS(e,b);q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;hx(a,d);ix(d);u=c;return}}function Cxa(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;i=u;u=u+1360|0;j=i+336|0;k=i+280|0;l=i+272|0;m=i+144|0;n=i;o=i+216|0;q=i+160|0;do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[k>>2]=f[r>>2];s=k+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=k+8|0;f[v>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[k+16>>2]=f[r+16>>2];f[k+20>>2]=f[r+20>>2];f[k+24>>2]=f[r+24>>2];f[k+28>>2]=f[r+28>>2];f[k+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[k+36>>2]=w;f[k+40>>2]=v;v=k+48|0;x=k+44|0;f[x>>2]=v;f[v>>2]=0;f[k+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;ZS(k,r);break}}else a$(k,a,-1);while(0);a=g&7;switch(g&-8|0){case 24:{f[j>>2]=0;f[j+4>>2]=0;y=tT(j,57)|0;z=286006;A=y+57|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Dxa(-215,j,467837,1403);break}case 8:{r=f[k>>2]|0;if(r&4095|0){f[j>>2]=0;f[j+4>>2]=0;y=tT(j,21)|0;z=288681;A=y+21|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Dxa(-215,j,467837,1406)}s=k+40|0;t=f[s>>2]|0;v=f[t+4>>2]|0;x=f[t>>2]|0;w=(r&16384|0)!=0;B=Y(x,v)|0;C=w?B:v;v=w?1:x;x=w?B:f[k+48>>2]|0;XIc(j|0,0,1024)|0;a:do if((v|0)>0){w=f[k+16>>2]|0;D=C+-4|0;if((C|0)<4){if((C|0)>0)E=0;else{F=0.0;G=0;break}while(1){H=w+(Y(E,x)|0)|0;I=0;do{J=j+((h[H+I>>0]|0)<<2)|0;f[J>>2]=(f[J>>2]|0)+1;I=I+1|0}while((I|0)!=(C|0));E=E+1|0;if((E|0)==(v|0)){F=0.0;G=0;break a}}}I=C&-4;if((I|0)<(C|0))K=0;else{H=0;while(1){J=w+(Y(H,x)|0)|0;L=0;do{M=h[J+(L|1)>>0]|0;N=j+((h[J+L>>0]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=j+(M<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=h[J+(L|3)>>0]|0;M=j+((h[J+(L|2)>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=j+(N<<2)|0;f[M>>2]=(f[M>>2]|0)+1;L=L+4|0}while((L|0)<=(D|0));H=H+1|0;if((H|0)==(v|0)){F=0.0;G=0;break a}}}do{H=w+(Y(K,x)|0)|0;L=0;do{J=h[H+(L|1)>>0]|0;M=j+((h[H+L>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=j+(J<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=h[H+(L|3)>>0]|0;J=j+((h[H+(L|2)>>0]|0)<<2)|0;f[J>>2]=(f[J>>2]|0)+1;J=j+(M<<2)|0;f[J>>2]=(f[J>>2]|0)+1;L=L+4|0}while((L|0)<=(D|0));O=I;do{L=j+((h[H+O>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;O=O+1|0}while((O|0)!=(C|0));K=K+1|0}while((K|0)!=(v|0));F=0.0;G=0}else{F=0.0;G=0}while(0);do{F=F+ +(G|0)*+(f[j+(G<<2)>>2]|0);G=G+1|0}while((G|0)!=256);P=1.0/+(B|0);Q=P*F;F=0.0;R=0.0;S=0.0;T=0.0;B=0;while(1){U=P*+(f[j+(B<<2)>>2]|0);V=T*F;F=F+U;W=1.0-F;if(!((W<F?W:F)<1.1920928955078125e-07)?!((F<W?W:F)>.9999998807907104):0){X=+(B|0);Z=(V+X*U)/F;U=Z-(Q-F*Z)/W;_=U*(F*W*U);G=_>S;$=Z;aa=G?X:R;ba=G?_:S}else{$=V;aa=R;ba=S}B=B+1|0;if((B|0)==256)break;else{R=aa;S=ba;T=$}}ca=aa;da=k;ea=s;fa=t;ga=r;break}case 16:{r=f[k>>2]|0;if(r&4095|0){f[j>>2]=0;f[j+4>>2]=0;y=tT(j,21)|0;z=288681;A=y+21|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Dxa(-215,j,467837,1411)}z=k+40|0;y=f[z>>2]|0;A=f[y+4>>2]|0;t=f[y>>2]|0;s=(r&16384|0)!=0;B=Y(t,A)|0;G=s?1:t;t=s?B:A;A=s?B:f[k+48>>2]|0;XIc(j|0,0,1024)|0;b:do if((G|0)>0){B=f[k+16>>2]|0;s=t+-4|0;if((t|0)<4){if((t|0)>0)ha=0;else{ia=0;break}while(1){v=B+(Y(ha,A)|0)|0;K=0;do{C=j+((h[v+K>>0]|0)<<2)|0;f[C>>2]=(f[C>>2]|0)+1;K=K+1|0}while((K|0)!=(t|0));ha=ha+1|0;if((ha|0)==(G|0)){ia=0;break b}}}K=t&-4;if((K|0)<(t|0))ja=0;else{v=0;while(1){C=B+(Y(v,A)|0)|0;O=0;do{x=h[C+(O|1)>>0]|0;E=j+((h[C+O>>0]|0)<<2)|0;f[E>>2]=(f[E>>2]|0)+1;E=j+(x<<2)|0;f[E>>2]=(f[E>>2]|0)+1;E=h[C+(O|3)>>0]|0;x=j+((h[C+(O|2)>>0]|0)<<2)|0;f[x>>2]=(f[x>>2]|0)+1;x=j+(E<<2)|0;f[x>>2]=(f[x>>2]|0)+1;O=O+4|0}while((O|0)<=(s|0));v=v+1|0;if((v|0)==(G|0)){ia=0;break b}}}do{v=B+(Y(ja,A)|0)|0;O=0;do{C=h[v+(O|1)>>0]|0;x=j+((h[v+O>>0]|0)<<2)|0;f[x>>2]=(f[x>>2]|0)+1;x=j+(C<<2)|0;f[x>>2]=(f[x>>2]|0)+1;x=h[v+(O|3)>>0]|0;C=j+((h[v+(O|2)>>0]|0)<<2)|0;f[C>>2]=(f[C>>2]|0)+1;C=j+(x<<2)|0;f[C>>2]=(f[C>>2]|0)+1;O=O+4|0}while((O|0)<=(s|0));ka=K;do{O=j+((h[v+ka>>0]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;ka=ka+1|0}while((ka|0)!=(t|0));ja=ja+1|0}while((ja|0)!=(G|0));ia=0}else ia=0;while(0);while(1){if((f[j+(ia<<2)>>2]|0)>0){la=ia;break}ia=ia+1|0;if((ia|0)>=256){la=0;break}}ia=(((la|0)>0)<<31>>31)+la|0;la=255;while(1){if((f[j+(la<<2)>>2]|0)>0){ma=la;break}if((la|0)>1)la=la+-1|0;else{ma=0;break}}la=(ma|0)<255;G=0;ja=0;t=0;do{ka=f[j+(t<<2)>>2]|0;A=(ka|0)>(G|0);ja=A?t:ja;G=A?ka:G;t=t+1|0}while((t|0)!=256);t=(la&1)+ma|0;if((ja-ia|0)<(t-ja|0)){ma=255;la=0;do{ka=j+(la<<2)|0;A=f[ka>>2]|0;ha=j+(ma<<2)|0;f[ka>>2]=f[ha>>2];f[ha>>2]=A;la=la+1|0;ma=ma+-1|0}while((la|0)<(ma|0));na=1;oa=255-t|0;pa=255-ja|0}else{na=0;oa=ia;pa=ja}aa=+(oa|0);$=+(G|0);T=+(oa-pa|0);if((oa|0)<(pa|0)){ba=0.0;S=aa;G=oa;while(1){G=G+1|0;R=+(G|0);F=$*R+T*+(f[j+(G<<2)>>2]|0);oa=F>ba;Q=oa?R:S;if((G|0)==(pa|0)){qa=Q;break}else{ba=oa?F:ba;S=Q}}}else qa=aa;aa=qa+-1.0;ca=na?255.0-aa:aa;da=k;ea=z;fa=y;ga=r;break}default:{r=k+40|0;ca=d;da=k;ea=r;fa=f[r>>2]|0;ga=f[k>>2]|0}}r=f[fa>>2]|0;f[l>>2]=f[fa+4>>2];f[l+4>>2]=r;v$(c,l,ga&4095,-1,0,0);do if((d$(c)|0)==65536){ga=f[c+4>>2]|0;f[j>>2]=f[ga>>2];l=j+4|0;r=ga+4|0;f[l>>2]=f[r>>2];fa=j+8|0;f[fa>>2]=f[ga+8>>2];f[j+12>>2]=f[ga+12>>2];f[j+16>>2]=f[ga+16>>2];f[j+20>>2]=f[ga+20>>2];f[j+24>>2]=f[ga+24>>2];f[j+28>>2]=f[ga+28>>2];f[j+32>>2]=f[ga+32>>2];y=f[ga+36>>2]|0;f[j+36>>2]=y;f[j+40>>2]=fa;fa=j+48|0;z=j+44|0;f[z>>2]=fa;f[fa>>2]=0;f[j+52>>2]=0;if(y|0){fa=y+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[r>>2]|0)<3){r=f[ga+44>>2]|0;fa=f[z>>2]|0;f[fa>>2]=f[r>>2];f[fa+4>>2]=f[r+4>>2];break}else{f[l>>2]=0;ZS(j,ga);break}}else a$(j,c,-1);while(0);c=f[da>>2]|0;c:do switch(c&7){case 0:{da=~~ca;ga=da-(+(da|0)>ca&1)|0;d=+(ga|0);da=nrc(e)|0;l=(a|0)==2;r=l?ga:da;da=r>>>0<256?r:(r|0)>0?255:0;r=da&255;fa=(ga|0)>254;if(ga>>>0<=254){ra=+(da&255);sa=d;ta=101;break c}if((a|1|0)!=1?!((l|(a|0)==4)&(ga|0)<0|(a|0)==3&fa):0){ga=m+8|0;f[ga>>2]=0;f[ga+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;h_(k,m);ua=d;break c}switch(g&7){case 0:{va=fa?0:r;break}case 1:{va=fa?r:0;break}default:va=0}p[n>>3]=+(va|0);f[m>>2]=-1056833530;f[m+4>>2]=n;f[m+8>>2]=1;f[m+12>>2]=1;l_(j,m,e0()|0)|0;ua=d;break}case 3:{r=~~ca;fa=r-(+(r|0)>ca&1)|0;d=+(fa|0);r=nrc(e)|0;ga=(a|0)==2;l=ga?fa:r;r=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;l=r<<16>>16;da=(fa|0)>32766;if((fa+32768|0)>>>0<=65534){ra=+((r&65535)<<16>>16);sa=d;ta=101;break c}if((a|1|0)!=1?!((ga|(a|0)==4)&(fa|0)<-32768|(a|0)==3&da):0){fa=m+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;h_(k,m);ua=d;break c}switch(g&7){case 0:{wa=da?0:l;break}case 1:{wa=da?l:0;break}default:wa=0}p[n>>3]=+(wa|0);f[m>>2]=-1056833530;f[m+4>>2]=n;f[m+8>>2]=1;f[m+12>>2]=1;l_(j,m,e0()|0)|0;ua=d;break}case 2:{l=~~ca;da=l-(+(l|0)>ca&1)|0;d=+(da|0);l=nrc(e)|0;fa=(a|0)==2?da:l;l=fa>>>0<65536?fa:(fa|0)>0?65535:0;fa=l&65535;ga=(da|0)>65534;if(da>>>0<=65534){ra=+(l&65535);sa=d;ta=101;break c}l=g&255;d:do if((a|1|0)==1)ta=94;else{switch(l&7){case 2:case 4:{if((a|0)==3&ga|(da|0)<0){ta=94;break d}break}default:if((a|0)==3&ga){xa=0;break d}}r=m+8|0;f[r>>2]=0;f[r+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;h_(k,m);ua=d;break c}while(0);e:do if((ta|0)==94)switch(l&7){case 0:{xa=ga?0:fa;break e;break}case 1:{xa=ga?fa:0;break e;break}default:{xa=0;break e}}while(0);p[n>>3]=+(xa|0);f[m>>2]=-1056833530;f[m+4>>2]=n;f[m+8>>2]=1;f[m+12>>2]=1;l_(j,m,e0()|0)|0;ua=d;break}case 6:case 5:{ra=e;sa=ca;ta=101;break}default:{f[m>>2]=0;f[m+4>>2]=0;Dxa(-210,m,467837,1509)}}while(0);if((ta|0)==101){ta=j+8|0;xa=f[ta>>2]|0;f[m>>2]=0;f[m+4>>2]=xa;f[o>>2]=c;c=o+4|0;xa=k+4|0;g=f[xa>>2]|0;f[c>>2]=g;wa=o+8|0;f[wa>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];va=o+16|0;f[va>>2]=f[k+16>>2];f[o+20>>2]=f[k+20>>2];f[o+24>>2]=f[k+24>>2];f[o+28>>2]=f[k+28>>2];f[o+32>>2]=f[k+32>>2];fa=o+36|0;ga=f[k+36>>2]|0;f[fa>>2]=ga;l=o+40|0;f[l>>2]=wa;wa=o+48|0;da=o+44|0;f[da>>2]=wa;f[wa>>2]=0;f[o+52>>2]=0;if(!ga)ya=g;else{g=ga+12|0;f[g>>2]=(f[g>>2]|0)+1;ya=f[xa>>2]|0}if((ya|0)<3){ya=f[k+44>>2]|0;xa=f[da>>2]|0;f[xa>>2]=f[ya>>2];f[xa+4>>2]=f[ya+4>>2]}else{f[c>>2]=0;ZS(o,k)}f[q>>2]=f[j>>2];ya=q+4|0;xa=j+4|0;g=f[xa>>2]|0;f[ya>>2]=g;ga=q+8|0;f[ga>>2]=f[ta>>2];r=j+12|0;f[q+12>>2]=f[r>>2];z=q+16|0;f[z>>2]=f[j+16>>2];f[q+20>>2]=f[j+20>>2];f[q+24>>2]=f[j+24>>2];f[q+28>>2]=f[j+28>>2];f[q+32>>2]=f[j+32>>2];y=q+36|0;na=f[j+36>>2]|0;f[y>>2]=na;pa=q+40|0;f[pa>>2]=ga;ga=q+48|0;G=q+44|0;f[G>>2]=ga;f[ga>>2]=0;f[q+52>>2]=0;if(!na)za=g;else{g=na+12|0;f[g>>2]=(f[g>>2]|0)+1;za=f[xa>>2]|0}if((za|0)<3){za=f[j+44>>2]|0;g=f[G>>2]|0;f[g>>2]=f[za>>2];f[g+4>>2]=f[za+4>>2]}else{f[ya>>2]=0;ZS(q,j)}Exa(n,o,q,sa,ra,a);a=f[xa>>2]|0;if((a|0)<3)Aa=Y(f[r>>2]|0,f[ta>>2]|0)|0;else{ta=f[j+40>>2]|0;r=0;xa=1;while(1){za=Y(f[ta+(r<<2)>>2]|0,xa)|0;r=r+1|0;if((r|0)==(a|0)){Aa=za;break}else xa=za}}y8(m,n,+(Aa>>>0)*.0000152587890625);Fxa(n);n=f[y>>2]|0;if(n|0?(Aa=n+12|0,n=f[Aa>>2]|0,f[Aa>>2]=n+-1,(n|0)==1):0)_S(q);f[y>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[ya>>2]|0)>0){z=f[pa>>2]|0;pa=0;do{f[z+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[ya>>2]|0))}ya=f[G>>2]|0;if((ya|0)!=(ga|0))g0(ya);ya=f[fa>>2]|0;if(ya|0?(ga=ya+12|0,ya=f[ga>>2]|0,f[ga>>2]=ya+-1,(ya|0)==1):0)_S(o);f[fa>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[c>>2]|0)>0){va=f[l>>2]|0;l=0;do{f[va+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[c>>2]|0))}c=f[da>>2]|0;if((c|0)!=(wa|0))g0(c);ua=sa}c=j+36|0;wa=f[c>>2]|0;if(wa|0?(da=wa+12|0,wa=f[da>>2]|0,f[da>>2]=wa+-1,(wa|0)==1):0)_S(j);f[c>>2]=0;c=j+16|0;wa=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[wa>>2]|0)>0){c=f[j+40>>2]|0;da=0;do{f[c+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[wa>>2]|0))}wa=f[j+44>>2]|0;if((wa|0)!=(j+48|0))g0(wa);wa=k+36|0;j=f[wa>>2]|0;if(j|0?(da=j+12|0,j=f[da>>2]|0,f[da>>2]=j+-1,(j|0)==1):0)_S(k);f[wa>>2]=0;wa=k+16|0;j=k+4|0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[j>>2]|0)>0){wa=f[ea>>2]|0;ea=0;do{f[wa+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[j>>2]|0))}j=f[k+44>>2]|0;if((j|0)==(k+48|0)){u=i;return +ua}g0(j);u=i;return +ua}function Dxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,286101,d);return}function Exa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f[a>>2]=61032;h=a+4|0;f[h>>2]=1124007936;i=a+8|0;j=a+12|0;k=a+44|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;n=a+52|0;o=a+48|0;f[o>>2]=n;f[n>>2]=0;f[a+56>>2]=0;n=a+60|0;f[n>>2]=1124007936;q=a+64|0;r=a+68|0;s=a+100|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;l=a+108|0;m=a+104|0;f[m>>2]=l;f[l>>2]=0;f[a+112>>2]=0;if((h|0)!=(b|0)){l=b+36|0;t=f[l>>2]|0;if(t){u=t+12|0;f[u>>2]=(f[u>>2]|0)+1;u=a+40|0;t=f[u>>2]|0;if((t|0)!=0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0){_S(h);w=u}else w=u}else w=a+40|0;f[w>>2]=0;u=a+20|0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=0;f[u+12>>2]=0;if((f[i>>2]|0)>0){t=f[k>>2]|0;k=0;do{f[t+(k<<2)>>2]=0;k=k+1|0;x=f[i>>2]|0}while((k|0)<(x|0));f[h>>2]=f[b>>2];if((x|0)<3)y=12;else y=14}else{f[h>>2]=f[b>>2];y=12}if((y|0)==12){x=f[b+4>>2]|0;if((x|0)<3){f[i>>2]=x;f[j>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];j=f[b+44>>2]|0;x=f[o>>2]|0;f[x>>2]=f[j>>2];f[x+4>>2]=f[j+4>>2]}else y=14}if((y|0)==14)ZS(h,b);f[u>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];f[w>>2]=f[l>>2]}if((n|0)==(c|0)){z=a+120|0;p[z>>3]=d;A=a+128|0;p[A>>3]=e;B=a+136|0;f[B>>2]=g;return}l=c+36|0;w=f[l>>2]|0;if(w|0){b=w+12|0;f[b>>2]=(f[b>>2]|0)+1}b=a+96|0;w=f[b>>2]|0;if(w|0?(u=w+12|0,w=f[u>>2]|0,f[u>>2]=w+-1,(w|0)==1):0)_S(n);f[b>>2]=0;w=a+76|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[q>>2]|0)>0){u=f[s>>2]|0;s=0;do{f[u+(s<<2)>>2]=0;s=s+1|0;C=f[q>>2]|0}while((s|0)<(C|0));f[n>>2]=f[c>>2];if((C|0)<3)y=27;else y=29}else{f[n>>2]=f[c>>2];y=27}if((y|0)==27){C=f[c+4>>2]|0;if((C|0)<3){f[q>>2]=C;f[r>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];r=f[c+44>>2]|0;C=f[m>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2]}else y=29}if((y|0)==29)ZS(n,c);f[w>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];f[b>>2]=f[l>>2];z=a+120|0;p[z>>3]=d;A=a+128|0;p[A>>3]=e;B=a+136|0;f[B>>2]=g;return}function Fxa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=61032;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Gxa(a){a=a|0;Fxa(a);YDc(a);return}function Hxa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;e=u;u=u+384|0;g=e+120|0;i=e+112|0;k=e+56|0;l=e;m=f[c>>2]|0;o=f[c+4>>2]|0;f[g>>2]=m;f[g+4>>2]=o;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;$S(k,a+4|0,g,i);f[g>>2]=m;f[g+4>>2]=o;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;$S(l,a+60|0,g,i);i=k+16|0;o=l+16|0;m=f[k>>2]|0;c=m>>>3&511;q=a+120|0;r=a+128|0;s=a+136|0;a:do switch(m&7){case 0:{a=~~+p[q>>3]&255;t=~~+p[r>>3]&255;v=f[s>>2]|0;w=f[k+40>>2]|0;x=f[w>>2]|0;y=Y(f[w+4>>2]|0,c+1|0)|0;w=f[k+48>>2]|0;z=f[l+48>>2]|0;if(!(m&16384)){A=w;B=z;C=y;D=x}else{E=(f[l>>2]&16384|0)!=0;F=Y(y,x)|0;A=E?F:w;B=E?F:z;C=E?F:y;D=E?1:x}if((C|0)>0){x=a&255;E=x+1|0;XIc(g|0,0,256)|0;switch(v|0){case 0:{XIc(g|0,0,E|0)|0;if(E>>>0<256)XIc(g+E|0,t|0,x^255|0)|0;break}case 1:{XIc(g|0,t|0,E|0)|0;if(E>>>0<256)XIc(g+E|0,0,x^255|0)|0;break}case 2:{t=0;do{b[g+t>>0]=t;t=t+1|0}while((t|0)!=(E|0));if(E>>>0<256)XIc(g+E|0,a|0,x^255|0)|0;break}case 3:{XIc(g|0,0,E|0)|0;if(E>>>0<256){t=E;do{b[g+t>>0]=t;t=t+1|0}while((t|0)!=256)}break}case 4:{t=0;do{b[g+t>>0]=t;t=t+1|0}while((t|0)!=(E|0));if(E>>>0<256)XIc(g+E|0,0,x^255|0)|0;break}default:{}}t=f[i>>2]|0;a=f[o>>2]|0;b:do if((D|0)>0){v=C+-4|0;if((C|0)<4){y=0;F=t;z=a;while(1){w=0;do{b[z+w>>0]=b[g+(h[F+w>>0]|0)>>0]|0;w=w+1|0}while((w|0)!=(C|0));y=y+1|0;if((y|0)==(D|0))break b;else{F=F+A|0;z=z+B|0}}}z=C&-4;if((z|0)<(C|0)){G=0;H=t;I=a}else{F=0;y=t;w=a;while(1){J=0;do{K=J|1;L=b[g+(h[y+K>>0]|0)>>0]|0;b[w+J>>0]=b[g+(h[y+J>>0]|0)>>0]|0;b[w+K>>0]=L;L=J|2;K=J|3;M=b[g+(h[y+K>>0]|0)>>0]|0;b[w+L>>0]=b[g+(h[y+L>>0]|0)>>0]|0;b[w+K>>0]=M;J=J+4|0}while((J|0)<=(v|0));F=F+1|0;if((F|0)==(D|0))break b;else{y=y+A|0;w=w+B|0}}}while(1){w=0;do{y=w|1;F=b[g+(h[H+y>>0]|0)>>0]|0;b[I+w>>0]=b[g+(h[H+w>>0]|0)>>0]|0;b[I+y>>0]=F;F=w|2;y=w|3;J=b[g+(h[H+y>>0]|0)>>0]|0;b[I+F>>0]=b[g+(h[H+F>>0]|0)>>0]|0;b[I+y>>0]=J;w=w+4|0}while((w|0)<=(v|0));N=z;do{b[I+N>>0]=b[g+(h[H+N>>0]|0)>>0]|0;N=N+1|0}while((N|0)!=(C|0));G=G+1|0;if((G|0)==(D|0))break;else{H=H+A|0;I=I+B|0}}}while(0)}break}case 3:{a=~~+p[q>>3];t=~~+p[r>>3];x=f[k+40>>2]|0;E=f[x>>2]|0;z=Y(f[x+4>>2]|0,c+1|0)|0;x=f[i>>2]|0;v=f[o>>2]|0;w=(f[k+48>>2]|0)>>>1;J=(f[l+48>>2]|0)>>>1;if(!(m&16384)){O=J;P=w;Q=z;R=E}else{y=(f[l>>2]&16384|0)!=0;F=Y(z,E)|0;O=y?F:J;P=y?F:w;Q=y?F:z;R=y?1:E}switch(f[s>>2]|0){case 0:{if((Q|0)>0&(R|0)>0){S=x;T=v;U=0}else break a;while(1){E=0;do{d[T+(E<<1)>>1]=(d[S+(E<<1)>>1]|0)>a<<16>>16?t:0;E=E+1|0}while((E|0)!=(Q|0));U=U+1|0;if((U|0)==(R|0))break;else{S=S+(P<<1)|0;T=T+(O<<1)|0}}break}case 1:{if((Q|0)>0&(R|0)>0){V=x;W=v;X=0}else break a;while(1){E=0;do{d[W+(E<<1)>>1]=(d[V+(E<<1)>>1]|0)>a<<16>>16?0:t;E=E+1|0}while((E|0)!=(Q|0));X=X+1|0;if((X|0)==(R|0))break;else{V=V+(P<<1)|0;W=W+(O<<1)|0}}break}case 2:{if((Q|0)>0&(R|0)>0){Z=x;_=v;$=0}else break a;while(1){t=0;do{E=d[Z+(t<<1)>>1]|0;d[_+(t<<1)>>1]=E<<16>>16>a<<16>>16?a:E;t=t+1|0}while((t|0)!=(Q|0));$=$+1|0;if(($|0)==(R|0))break;else{Z=Z+(P<<1)|0;_=_+(O<<1)|0}}break}case 3:{if((Q|0)>0&(R|0)>0){aa=x;ba=v;ca=0}else break a;while(1){t=0;do{E=d[aa+(t<<1)>>1]|0;d[ba+(t<<1)>>1]=E<<16>>16>a<<16>>16?E:0;t=t+1|0}while((t|0)!=(Q|0));ca=ca+1|0;if((ca|0)==(R|0))break;else{aa=aa+(P<<1)|0;ba=ba+(O<<1)|0}}break}case 4:{if((Q|0)>0&(R|0)>0){da=x;ea=v;fa=0}else break a;while(1){t=0;do{E=d[da+(t<<1)>>1]|0;d[ea+(t<<1)>>1]=E<<16>>16>a<<16>>16?0:E;t=t+1|0}while((t|0)!=(Q|0));fa=fa+1|0;if((fa|0)==(R|0))break;else{da=da+(P<<1)|0;ea=ea+(O<<1)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;Dxa(-5,g,286064,120)}}break}case 2:{a=~~+p[q>>3]&65535;v=~~+p[r>>3]&65535;x=f[k+40>>2]|0;t=f[x>>2]|0;E=Y(f[x+4>>2]|0,c+1|0)|0;x=((f[k+48>>2]|0)>>>0)/((1212424721>>>(m<<2&28)&15)>>>0)|0;y=f[l>>2]|0;z=((f[l+48>>2]|0)>>>0)/((1212424721>>>(y<<2&28)&15)>>>0)|0;F=(m&16384|0)==0;w=(y&16384|0)!=0;y=Y(E,t)|0;J=F?E:w?y:E;E=F?t:w?1:t;t=F?z:w?y:z;z=F?x:w?y:x;x=f[i>>2]|0;y=f[o>>2]|0;switch(f[s>>2]|0){case 0:{if((J|0)>0&(E|0)>0){ga=x;ha=y;ia=0}else break a;while(1){w=0;do{d[ha+(w<<1)>>1]=(j[ga+(w<<1)>>1]|0)>(a&65535)?v:0;w=w+1|0}while((w|0)!=(J|0));ia=ia+1|0;if((ia|0)==(E|0))break;else{ga=ga+(z<<1)|0;ha=ha+(t<<1)|0}}break}case 1:{if((J|0)>0&(E|0)>0){ja=x;ka=y;la=0}else break a;while(1){w=0;do{d[ka+(w<<1)>>1]=(j[ja+(w<<1)>>1]|0)>(a&65535)?0:v;w=w+1|0}while((w|0)!=(J|0));la=la+1|0;if((la|0)==(E|0))break;else{ja=ja+(z<<1)|0;ka=ka+(t<<1)|0}}break}case 2:{if((J|0)>0&(E|0)>0){ma=x;na=y;oa=0}else break a;while(1){v=0;do{w=d[ma+(v<<1)>>1]|0;d[na+(v<<1)>>1]=(w&65535)>(a&65535)?a:w;v=v+1|0}while((v|0)!=(J|0));oa=oa+1|0;if((oa|0)==(E|0))break;else{ma=ma+(z<<1)|0;na=na+(t<<1)|0}}break}case 3:{if((J|0)>0&(E|0)>0){pa=x;qa=y;ra=0}else break a;while(1){v=0;do{w=d[pa+(v<<1)>>1]|0;d[qa+(v<<1)>>1]=(w&65535)>(a&65535)?w:0;v=v+1|0}while((v|0)!=(J|0));ra=ra+1|0;if((ra|0)==(E|0))break;else{pa=pa+(z<<1)|0;qa=qa+(t<<1)|0}}break}case 4:{if((J|0)>0&(E|0)>0){sa=x;ta=y;ua=0}else break a;while(1){v=0;do{w=d[sa+(v<<1)>>1]|0;d[ta+(v<<1)>>1]=(w&65535)>(a&65535)?0:w;v=v+1|0}while((v|0)!=(J|0));ua=ua+1|0;if((ua|0)==(E|0))break;else{sa=sa+(z<<1)|0;ta=ta+(t<<1)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;Dxa(-5,g,286064,120)}}break}case 5:{va=+p[q>>3];wa=+p[r>>3];t=f[k+40>>2]|0;z=f[t>>2]|0;E=Y(f[t+4>>2]|0,c+1|0)|0;t=f[i>>2]|0;J=f[o>>2]|0;a=(f[k+48>>2]|0)>>>2;y=(f[l+48>>2]|0)>>>2;if(!(m&16384)){xa=E;ya=z}else{x=(f[l>>2]&16384|0)!=0;v=Y(x?z:1,E)|0;xa=v;ya=x?1:z}switch(f[s>>2]|0){case 0:{if((xa|0)>0&(ya|0)>0){za=t;Aa=J;Ba=0}else break a;while(1){z=0;do{n[Aa+(z<<2)>>2]=+n[za+(z<<2)>>2]>va?wa:0.0;z=z+1|0}while((z|0)!=(xa|0));Ba=Ba+1|0;if((Ba|0)==(ya|0))break;else{za=za+(a<<2)|0;Aa=Aa+(y<<2)|0}}break}case 1:{if((xa|0)>0&(ya|0)>0){Ca=t;Da=J;Ea=0}else break a;while(1){z=0;do{n[Da+(z<<2)>>2]=!(+n[Ca+(z<<2)>>2]<=va)?0.0:wa;z=z+1|0}while((z|0)!=(xa|0));Ea=Ea+1|0;if((Ea|0)==(ya|0))break;else{Ca=Ca+(a<<2)|0;Da=Da+(y<<2)|0}}break}case 2:{if((xa|0)>0&(ya|0)>0){Fa=t;Ga=J;Ha=0}else break a;while(1){z=0;do{wa=+n[Fa+(z<<2)>>2];n[Ga+(z<<2)>>2]=wa>va?va:wa;z=z+1|0}while((z|0)!=(xa|0));Ha=Ha+1|0;if((Ha|0)==(ya|0))break;else{Fa=Fa+(a<<2)|0;Ga=Ga+(y<<2)|0}}break}case 3:{if((xa|0)>0&(ya|0)>0){Ia=t;Ja=J;Ka=0}else break a;while(1){z=0;do{wa=+n[Ia+(z<<2)>>2];n[Ja+(z<<2)>>2]=wa>va?wa:0.0;z=z+1|0}while((z|0)!=(xa|0));Ka=Ka+1|0;if((Ka|0)==(ya|0))break;else{Ia=Ia+(a<<2)|0;Ja=Ja+(y<<2)|0}}break}case 4:{if((xa|0)>0&(ya|0)>0){La=t;Ma=J;Na=0}else break a;while(1){z=0;do{wa=+n[La+(z<<2)>>2];n[Ma+(z<<2)>>2]=!(wa<=va)?0.0:wa;z=z+1|0}while((z|0)!=(xa|0));Na=Na+1|0;if((Na|0)==(ya|0))break;else{La=La+(a<<2)|0;Ma=Ma+(y<<2)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;Dxa(-5,g,286064,120)}}break}case 6:{va=+p[q>>3];wa=+p[r>>3];y=f[k+40>>2]|0;a=f[y>>2]|0;J=Y(f[y+4>>2]|0,c+1|0)|0;y=f[i>>2]|0;t=f[o>>2]|0;z=(f[k+48>>2]|0)>>>3;x=(f[l+48>>2]|0)>>>3;if(!(m&16384)){Oa=J;Pa=a}else{v=(f[l>>2]&16384|0)!=0;E=Y(v?a:1,J)|0;Oa=E;Pa=v?1:a}switch(f[s>>2]|0){case 0:{if((Oa|0)>0&(Pa|0)>0){Qa=y;Ra=t;Sa=0}else break a;while(1){a=0;do{p[Ra+(a<<3)>>3]=+p[Qa+(a<<3)>>3]>va?wa:0.0;a=a+1|0}while((a|0)!=(Oa|0));Sa=Sa+1|0;if((Sa|0)==(Pa|0))break;else{Qa=Qa+(z<<3)|0;Ra=Ra+(x<<3)|0}}break}case 1:{if((Oa|0)>0&(Pa|0)>0){Ta=y;Ua=t;Va=0}else break a;while(1){a=0;do{p[Ua+(a<<3)>>3]=!(+p[Ta+(a<<3)>>3]<=va)?0.0:wa;a=a+1|0}while((a|0)!=(Oa|0));Va=Va+1|0;if((Va|0)==(Pa|0))break;else{Ta=Ta+(z<<3)|0;Ua=Ua+(x<<3)|0}}break}case 2:{if((Oa|0)>0&(Pa|0)>0){Wa=y;Xa=t;Ya=0}else break a;while(1){a=0;do{wa=+p[Wa+(a<<3)>>3];p[Xa+(a<<3)>>3]=wa>va?va:wa;a=a+1|0}while((a|0)!=(Oa|0));Ya=Ya+1|0;if((Ya|0)==(Pa|0))break;else{Wa=Wa+(z<<3)|0;Xa=Xa+(x<<3)|0}}break}case 3:{if((Oa|0)>0&(Pa|0)>0){Za=y;_a=t;$a=0}else break a;while(1){a=0;do{wa=+p[Za+(a<<3)>>3];p[_a+(a<<3)>>3]=wa>va?wa:0.0;a=a+1|0}while((a|0)!=(Oa|0));$a=$a+1|0;if(($a|0)==(Pa|0))break;else{Za=Za+(z<<3)|0;_a=_a+(x<<3)|0}}break}case 4:{if((Oa|0)>0&(Pa|0)>0){ab=y;bb=t;cb=0}else break a;while(1){a=0;do{wa=+p[ab+(a<<3)>>3];p[bb+(a<<3)>>3]=!(wa<=va)?0.0:wa;a=a+1|0}while((a|0)!=(Oa|0));cb=cb+1|0;if((cb|0)==(Pa|0))break;else{ab=ab+(z<<3)|0;bb=bb+(x<<3)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;Dxa(-5,g,286064,120)}}break}default:{}}while(0);g=l+36|0;bb=f[g>>2]|0;if(bb|0?(ab=bb+12|0,bb=f[ab>>2]|0,f[ab>>2]=bb+-1,(bb|0)==1):0)_S(l);f[g>>2]=0;g=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[g>>2]|0)>0){o=f[l+40>>2]|0;bb=0;do{f[o+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[g>>2]|0))}g=f[l+44>>2]|0;if((g|0)!=(l+48|0))g0(g);g=k+36|0;l=f[g>>2]|0;if(l|0?(bb=l+12|0,l=f[bb>>2]|0,f[bb>>2]=l+-1,(l|0)==1):0)_S(k);f[g>>2]=0;g=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[g>>2]|0)>0){i=f[k+40>>2]|0;l=0;do{f[i+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[k+44>>2]|0;if((g|0)==(k+48|0)){u=e;return}g0(g);u=e;return}function Ixa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;k=u;u=u+1056|0;l=k+1e3|0;m=k+944|0;n=k+936|0;o=k;p=k+160|0;q=k+96|0;r=k+928|0;s=k+152|0;t=k+72|0;v=k+56|0;w=k+88|0;do if((d$(a)|0)==65536){x=f[a+4>>2]|0;f[l>>2]=f[x>>2];y=l+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[x+8>>2];f[l+12>>2]=f[x+12>>2];f[l+16>>2]=f[x+16>>2];f[l+20>>2]=f[x+20>>2];f[l+24>>2]=f[x+24>>2];f[l+28>>2]=f[x+28>>2];f[l+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;C=l+44|0;f[C>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];D=l;break}else{f[y>>2]=0;ZS(l,x);D=l;break}}else{a$(l,a,-1);D=l}while(0);if(f[D>>2]&4095|0){f[m>>2]=0;f[m+4>>2]=0;E=tT(m,21)|0;F=288681;G=E+21|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));Dxa(-215,m,286169,1524)}if(!((i|0)>1&((i|0)%2|0|0)==1)){f[m>>2]=0;f[m+4>>2]=0;E=tT(m,35)|0;F=286187;G=E+35|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));Dxa(-215,m,286169,1525)}a=l+40|0;x=f[a>>2]|0;y=f[x+4>>2]|0;z=f[x>>2]|0;f[n>>2]=y;f[n+4>>2]=z;v$(c,n,0,-1,0,0);do if((d$(c)|0)==65536){n=f[c+4>>2]|0;f[m>>2]=f[n>>2];x=m+4|0;A=n+4|0;f[x>>2]=f[A>>2];C=m+8|0;f[C>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];f[m+16>>2]=f[n+16>>2];f[m+20>>2]=f[n+20>>2];f[m+24>>2]=f[n+24>>2];f[m+28>>2]=f[n+28>>2];f[m+32>>2]=f[n+32>>2];B=f[n+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=C;C=m+48|0;H=m+44|0;f[H>>2]=C;f[C>>2]=0;f[m+52>>2]=0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[A>>2]|0)<3){A=f[n+44>>2]|0;C=f[H>>2]|0;f[C>>2]=f[A>>2];f[C+4>>2]=f[A+4>>2];break}else{f[x>>2]=0;ZS(m,n);break}}else a$(m,c,-1);while(0);if(!(d<0.0)){c=l+16|0;n=m+16|0;f[o>>2]=1124007936;x=o+4|0;A=o+8|0;C=o+40|0;E=x;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[C>>2]=A;H=o+48|0;B=o+44|0;f[B>>2]=H;f[H>>2]=0;f[o+52>>2]=0;if((f[c>>2]|0)!=(f[n>>2]|0)){I=m+36|0;J=f[I>>2]|0;if(J){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1;K=o+36|0;J=f[K>>2]|0;if((J|0)!=0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0){_S(o);M=K}else M=K}else M=o+36|0;f[M>>2]=0;K=o+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[x>>2]|0)>0){J=f[C>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0;N=f[x>>2]|0}while((L|0)<(N|0));f[o>>2]=f[m>>2];if((N|0)<3)O=32;else O=34}else{f[o>>2]=f[m>>2];O=32}if((O|0)==32){N=f[m+4>>2]|0;if((N|0)<3){f[x>>2]=N;f[A>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];A=f[m+44>>2]|0;N=f[B>>2]|0;f[N>>2]=f[A>>2];f[N+4>>2]=f[A+4>>2]}else O=34}if((O|0)==34)ZS(o,m);f[K>>2]=f[n>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];f[o+32>>2]=f[m+32>>2];f[M>>2]=f[I>>2]}switch(e|0){case 0:{f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=l;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;e=f[D>>2]&4095;f[r>>2]=i;f[r+4>>2]=i;f[s>>2]=-1;f[s+4>>2]=-1;Yma(p,q,e,r,s,1,17);break}case 1:{f[p>>2]=1124007936;s=p+4|0;r=p+8|0;e=p+40|0;E=s;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[e>>2]=r;I=p+48|0;M=p+44|0;f[M>>2]=I;f[I>>2]=0;f[p+52>>2]=0;f[q>>2]=1124007936;K=q+4|0;A=q+8|0;N=q+40|0;E=K;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[N>>2]=A;L=q+48|0;J=q+44|0;f[J>>2]=L;f[L>>2]=0;f[q+52>>2]=0;P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;LZ(l,t,5,1.0,0.0);P=p+36|0;Q=f[P>>2]|0;if(Q|0){R=Q+12|0;f[R>>2]=(f[R>>2]|0)+1}R=q+36|0;Q=f[R>>2]|0;if(Q|0?(S=Q+12|0,Q=f[S>>2]|0,f[S>>2]=Q+-1,(Q|0)==1):0)_S(q);f[R>>2]=0;Q=q+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[K>>2]|0)>0){S=f[N>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0;U=f[K>>2]|0}while((T|0)<(U|0));f[q>>2]=f[p>>2];if((U|0)<3)O=48;else O=50}else{f[q>>2]=f[p>>2];O=48}if((O|0)==48){U=f[s>>2]|0;if((U|0)<3){f[K>>2]=U;f[A>>2]=f[r>>2];f[q+12>>2]=f[p+12>>2];r=f[M>>2]|0;A=f[J>>2]|0;f[A>>2]=f[r>>2];f[A+4>>2]=f[r+4>>2]}else O=50}if((O|0)==50)ZS(q,p);r=p+16|0;f[Q>>2]=f[r>>2];f[q+20>>2]=f[p+20>>2];f[q+24>>2]=f[p+24>>2];f[q+28>>2]=f[p+28>>2];f[q+32>>2]=f[p+32>>2];f[R>>2]=f[P>>2];f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=p;A=v+8|0;f[A>>2]=0;f[A+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=q;f[w>>2]=i;f[w+4>>2]=i;Gfa(t,v,w,0.0,0.0,17);w=t+8|0;f[w>>2]=0;f[w+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=o;LZ(q,t,f[D>>2]&4095,1.0,0.0);t=f[R>>2]|0;if(t|0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0)_S(q);f[R>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[K>>2]|0)>0){Q=f[N>>2]|0;N=0;do{f[Q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[J>>2]|0;if((K|0)!=(L|0))g0(K);K=f[P>>2]|0;if(K|0?(L=K+12|0,K=f[L>>2]|0,f[L>>2]=K+-1,(K|0)==1):0)_S(p);f[P>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){r=f[e>>2]|0;e=0;do{f[r+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[s>>2]|0))}s=f[M>>2]|0;if((s|0)!=(I|0))g0(s);break}default:{f[p>>2]=0;f[p+4>>2]=0;E=tT(p,45)|0;F=286223;G=E+45|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));Dxa(-206,p,286169,1557)}}s=nrc(d)|0;I=(s>>>0<256?s:(s|0)>0?255:0)&255;s=~~j;d=+(s|0);if(!g){M=0-(s+(d<j&1))|0;e=0;do{b[p+e>>0]=(e+-255|0)>(M|0)?I:0;e=e+1|0}while((e|0)!=768);V=p}else{if((g|0)!=1){f[q>>2]=0;f[q+4>>2]=0;E=tT(q,34)|0;F=286269;G=E+34|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));Dxa(-206,q,286169,1571)}q=(d>j&1)-s|0;s=0;do{b[p+s>>0]=(s+-255|0)<=(q|0)?I:0;s=s+1|0}while((s|0)!=768);V=p}if((f[D>>2]&16384|0)!=0?(f[o>>2]&16384|0)!=0:0){D=(f[m>>2]&16384|0)!=0;V=Y(D?z:1,y)|0;if(D){W=V;X=1;O=80}else{Z=V;O=79}}else{Z=y;O=79}if((O|0)==79?(z|0)>0:0){W=Z;X=z;O=80}if((O|0)==80?(O=l+44|0,z=o+16|0,Z=m+44|0,(W|0)>0):0){y=0;do{V=(f[c>>2]|0)+(Y(f[f[O>>2]>>2]|0,y)|0)|0;D=(f[z>>2]|0)+(Y(f[f[B>>2]>>2]|0,y)|0)|0;s=(f[n>>2]|0)+(Y(f[f[Z>>2]>>2]|0,y)|0)|0;I=0;do{b[s+I>>0]=b[p+((h[V+I>>0]|0)+255-(h[D+I>>0]|0))>>0]|0;I=I+1|0}while((I|0)!=(W|0));y=y+1|0}while((y|0)!=(X|0))}X=o+36|0;y=f[X>>2]|0;if(y|0?(W=y+12|0,y=f[W>>2]|0,f[W>>2]=y+-1,(y|0)==1):0)_S(o);f[X>>2]=0;X=o+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[x>>2]|0)>0){X=f[C>>2]|0;C=0;do{f[X+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[x>>2]|0))}x=f[B>>2]|0;if((x|0)!=(H|0))g0(x)}else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;k_(m,o)|0}o=m+36|0;x=f[o>>2]|0;if(x|0?(H=x+12|0,x=f[H>>2]|0,f[H>>2]=x+-1,(x|0)==1):0)_S(m);f[o>>2]=0;o=m+16|0;x=m+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[x>>2]|0)>0){o=f[m+40>>2]|0;H=0;do{f[o+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[x>>2]|0))}x=f[m+44>>2]|0;if((x|0)!=(m+48|0))g0(x);x=l+36|0;m=f[x>>2]|0;if(m|0?(H=m+12|0,m=f[H>>2]|0,f[H>>2]=m+-1,(m|0)==1):0)_S(l);f[x>>2]=0;x=l+16|0;m=l+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[m>>2]|0)>0){x=f[a>>2]|0;a=0;do{f[x+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=k;return}g0(m);u=k;return}function Jxa(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;h=u;u=u+208|0;i=h+144|0;j=h+88|0;k=h+32|0;l=h+16|0;m=h;O4(i,a,0,1,0,0);O4(j,c,0,1,0,0);f[k>>2]=f[j>>2];c=k+4|0;a=j+4|0;n=f[a>>2]|0;f[c>>2]=n;o=k+8|0;f[o>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];p=k+16|0;q=j+16|0;f[p>>2]=f[q>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];r=k+36|0;s=j+36|0;t=f[s>>2]|0;f[r>>2]=t;v=k+40|0;f[v>>2]=o;o=k+48|0;w=k+44|0;f[w>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(!t)x=n;else{n=t+12|0;f[n>>2]=(f[n>>2]|0)+1;x=f[a>>2]|0}if((x|0)<3){x=f[j+44>>2]|0;n=f[w>>2]|0;f[n>>2]=f[x>>2];f[n+4>>2]=f[x+4>>2]}else{f[c>>2]=0;ZS(k,j)}x=i+40|0;n=f[x>>2]|0;t=f[n+-4>>2]|0;y=j+40|0;z=f[y>>2]|0;a:do if((t|0)==(f[z+-4>>2]|0)){if((t|0)==2){if((f[n>>2]|0)!=(f[z>>2]|0))break;if((f[n+4>>2]|0)!=(f[z+4>>2]|0))break}else if((t|0)>0){A=0;do{if((f[n+(A<<2)>>2]|0)!=(f[z+(A<<2)>>2]|0))break a;A=A+1|0}while((A|0)<(t|0))}A=f[i>>2]|0;B=f[j>>2]|0;if(((B^A)&4088|0)==0?(C=B&7,(A&7|0)==(C|0)|(C|0)==0):0){f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=i;C=m+8|0;f[C>>2]=0;f[C+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;D=+Cxa(l,m,d,e,g);if((f[p>>2]|0)!=(f[q>>2]|0)){C=l+8|0;f[C>>2]=0;f[C+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;LZ(j,l,f[k>>2]&7,1.0,0.0)}C=f[r>>2]|0;if(C|0?(A=C+12|0,C=f[A>>2]|0,f[A>>2]=C+-1,(C|0)==1):0)_S(k);f[r>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){C=f[v>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[c>>2]|0))}A=f[w>>2]|0;if((A|0)!=(o|0))g0(A);A=f[s>>2]|0;if(A|0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0)_S(j);f[s>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[a>>2]|0)>0){A=f[y>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[a>>2]|0))}C=f[j+44>>2]|0;if((C|0)!=(j+48|0))g0(C);C=i+36|0;A=f[C>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)_S(i);f[C>>2]=0;C=i+16|0;A=i+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[A>>2]|0)>0){C=f[x>>2]|0;B=0;do{f[C+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[A>>2]|0))}A=f[i+44>>2]|0;if((A|0)==(i+48|0)){u=h;return +D}g0(A);u=h;return +D}}while(0);f[l>>2]=0;f[l+4>>2]=0;h=tT(l,112)|0;i=286304;x=h+112|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(x|0));Dxa(-215,l,286417,1596);return +(0.0)}function Kxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0;e=u;u=u+80|0;g=e+16|0;h=e+8|0;i=e;do if((d$(a)|0)==65536){j=f[a+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=m;m=g+48|0;p=g+44|0;f[p>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;ZS(g,j);break}}else a$(g,a,-1);while(0);a=pT(g,2,-1,1)|0;j=f[g>>2]&7;if((a|0)<=-1){f[h>>2]=0;q=h+4|0;f[q>>2]=0;r=tT(h,50)|0;t=r;v=286429;w=t+50|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,286480,286499,158)}k=(j|0)==5;if((j|1|0)!=5){f[h>>2]=0;q=h+4|0;f[q>>2]=0;r=tT(h,50)|0;t=r;v=286429;w=t+50|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,h,286480,286499,158)}v=c+4|0;n[v>>2]=0.0;n[c>>2]=0.0;n[d>>2]=0.0;a:do if(a|0){t=f[g+16>>2]|0;switch(a|0){case 1:{w=f[t>>2]|0;if(k){x=w;y=f[t+4>>2]|0}else{r=(n[s>>2]=+(w|0),f[s>>2]|0);x=r;y=(n[s>>2]=+(f[t+4>>2]|0),f[s>>2]|0)}f[c>>2]=x;f[v>>2]=y;n[d>>2]=9.999999747378752e-05;break a;break}case 2:{if(k){z=+n[t+12>>2];A=+n[t+4>>2];B=+n[t+8>>2];C=+n[t>>2]}else{z=+(f[t+12>>2]|0);A=+(f[t+4>>2]|0);B=+(f[t+8>>2]|0);C=+(f[t>>2]|0)}n[c>>2]=(C+B)*.5;n[v>>2]=(A+z)*.5;D=C-B;E=A-z;F=+M(+(E*E+D*D))*.5+9.999999747378752e-05;n[d>>2]=F;break a;break}default:{n[h>>2]=0.0;r=h+4|0;n[r>>2]=0.0;n[i>>2]=0.0;b:do if(k){F=+n[t+8>>2];D=(+n[t>>2]+F)*.5;n[h>>2]=D;w=t+4|0;E=+n[t+12>>2];G=(+n[w>>2]+E)*.5;n[r>>2]=G;H=+n[t>>2]-F;F=+n[w>>2]-E;E=+M(+(H*H+F*F))*.5+9.999999747378752e-05;n[i>>2]=E;w=2;F=D;D=G;G=E;while(1){E=+n[t+(w<<3)>>2]-F;H=+n[t+(w<<3)+4>>2]-D;if(!(+M(+(E*E+H*H))<G))Lxa(t,w,h,i);q=w+1|0;if((q|0)==(a|0))break b;w=q;F=+n[h>>2];D=+n[r>>2];G=+n[i>>2]}}else{w=f[t>>2]|0;q=f[t+8>>2]|0;G=+(q+w|0)*.5;n[h>>2]=G;j=f[t+4>>2]|0;l=f[t+12>>2]|0;D=+(l+j|0)*.5;n[r>>2]=D;F=+(w-q|0);H=+(j-l|0);E=+M(+(F*F+H*H))*.5+9.999999747378752e-05;n[i>>2]=E;l=2;H=G;G=D;D=E;while(1){E=+(f[t+(l<<3)>>2]|0)-H;F=+(f[t+(l<<3)+4>>2]|0)-G;if(!(+M(+(E*E+F*F))<D))Mxa(t,l,h,i);j=l+1|0;if((j|0)==(a|0))break b;l=j;H=+n[h>>2];G=+n[r>>2];D=+n[i>>2]}}while(0);f[c>>2]=f[h>>2];f[v>>2]=f[r>>2];f[d>>2]=f[i>>2];break a}}}while(0);i=g+36|0;d=f[i>>2]|0;if(d|0?(v=d+12|0,d=f[v>>2]|0,f[v>>2]=d+-1,(d|0)==1):0)_S(g);f[i>>2]=0;i=g+16|0;d=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[d>>2]|0)>0){i=f[g+40>>2]|0;v=0;do{f[i+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[d>>2]|0))}d=f[g+44>>2]|0;if((d|0)==(g+48|0)){u=e;return}g0(d);u=e;return}function Lxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0.0,j=0.0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0;e=a+(b<<3)|0;n[c>>2]=(+n[a>>2]+ +n[e>>2])*.5;f=a+4|0;g=a+(b<<3)+4|0;h=c+4|0;n[h>>2]=(+n[f>>2]+ +n[g>>2])*.5;i=+n[a>>2]-+n[e>>2];j=+n[f>>2]-+n[g>>2];k=+M(+(i*i+j*j))*.5+9.999999747378752e-05;n[d>>2]=k;if((b|0)>1){l=1;m=k}else return;while(1){f=a+(l<<3)|0;k=+n[f>>2];o=a+(l<<3)+4|0;j=+n[o>>2];i=+n[c>>2]-k;p=+n[h>>2]-j;if(+M(+(i*i+p*p))<m)q=m;else{n[c>>2]=(k+ +n[e>>2])*.5;n[h>>2]=(j+ +n[g>>2])*.5;j=+n[f>>2]-+n[e>>2];k=+n[o>>2]-+n[g>>2];p=+M(+(j*j+k*k))*.5+9.999999747378752e-05;n[d>>2]=p;r=0;k=p;while(1){p=+n[a+(r<<3)>>2];j=+n[a+(r<<3)+4>>2];i=+n[c>>2]-p;s=+n[h>>2]-j;if(+M(+(i*i+s*s))<k)t=k;else{s=+n[e>>2];i=+n[g>>2];u=+n[f>>2];v=+n[o>>2];w=u-s;x=v-i;y=p-s;z=j-i;A=w*((s+u)*.5)+x*((i+v)*.5);v=y*((p+s)*.5)+z*((j+i)*.5);j=z*w-y*x;p=(z*A-x*v)/j;x=(w*v-y*A)/j;n[c>>2]=p;n[h>>2]=x;j=p-s;s=x-i;i=+M(+(j*j+s*s))+9.999999747378752e-05;n[d>>2]=i;t=i}r=r+1|0;if((r|0)==(l|0)){q=t;break}else k=t}}l=l+1|0;if((l|0)==(b|0))break;else m=q}return}function Mxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0;e=f[a>>2]|0;g=f[a+(b<<3)>>2]|0;n[c>>2]=+(g+e|0)*.5;h=f[a+4>>2]|0;i=f[a+(b<<3)+4>>2]|0;j=c+4|0;n[j>>2]=+(i+h|0)*.5;k=+(e-g|0);l=+(h-i|0);m=+M(+(k*k+l*l))*.5+9.999999747378752e-05;n[d>>2]=m;if((b|0)<=1)return;l=+(g|0);k=+(i|0);h=1;o=m;while(1){e=f[a+(h<<3)>>2]|0;m=+(e|0);p=f[a+(h<<3)+4>>2]|0;q=+(p|0);r=+n[c>>2]-m;s=+n[j>>2]-q;if(+M(+(r*r+s*s))<o)t=o;else{n[c>>2]=+(g+e|0)*.5;n[j>>2]=+(i+p|0)*.5;s=+(e-g|0);r=+(p-i|0);u=+M(+(s*s+r*r))*.5+9.999999747378752e-05;n[d>>2]=u;r=m-l;s=q-k;v=r*((m+l)*.5)+s*((q+k)*.5);p=0;q=u;while(1){u=+(f[a+(p<<3)>>2]|0);m=+(f[a+(p<<3)+4>>2]|0);w=+n[c>>2]-u;x=+n[j>>2]-m;if(+M(+(w*w+x*x))<q)y=q;else{x=u-l;w=m-k;z=x*((l+u)*.5)+w*((k+m)*.5);m=r*w-s*x;u=(v*w-s*z)/m;w=(r*z-v*x)/m;n[c>>2]=u;n[j>>2]=w;m=u-l;u=w-k;w=+M(+(m*m+u*u))+9.999999747378752e-05;n[d>>2]=w;y=w}p=p+1|0;if((p|0)==(h|0)){t=y;break}else q=y}}h=h+1|0;if((h|0)==(b|0))break;else o=t}return}function Nxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;d=u;u=u+64|0;e=d+8|0;g=d;do if((d$(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;ZS(e,h);break}}else a$(e,a,-1);while(0);a=pT(e,2,-1,1)|0;h=f[e>>2]&7;if((a|0)<=-1){f[g>>2]=0;o=g+4|0;f[o>>2]=0;p=tT(g,50)|0;q=p;r=286429;t=q+50|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));z5(-215,g,286571,286499,237)}i=(h|0)==5;if((h|1|0)!=5){f[g>>2]=0;o=g+4|0;f[o>>2]=0;p=tT(g,50)|0;q=p;r=286429;t=q+50|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));z5(-215,g,286571,286499,237)}if((a|0)>=2){g=c?a+-1|0:0;c=f[e+16>>2]|0;if(i){v=0.0;i=0;r=f[c+(g<<3)>>2]|0;q=f[c+(g<<3)+4>>2]|0;while(1){t=r;r=f[c+(i<<3)>>2]|0;w=(f[s>>2]=r,+n[s>>2]);p=q;q=f[c+(i<<3)+4>>2]|0;x=(f[s>>2]=q,+n[s>>2]);y=w-(f[s>>2]=t,+n[s>>2]);w=x-(f[s>>2]=p,+n[s>>2]);x=v+ +M(+(w*w+y*y));i=i+1|0;if((i|0)==(a|0)){z=x;break}else v=x}}else{v=0.0;i=0;x=+(f[c+(g<<3)>>2]|0);y=+(f[c+(g<<3)+4>>2]|0);while(1){w=x;x=+(f[c+(i<<3)>>2]|0);A=y;y=+(f[c+(i<<3)+4>>2]|0);B=x-w;w=y-A;A=v+ +M(+(w*w+B*B));i=i+1|0;if((i|0)==(a|0)){z=A;break}else v=A}}}else z=0.0;a=e+36|0;i=f[a>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)_S(e);f[a>>2]=0;a=e+16|0;i=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[e+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)==(e+48|0)){u=d;return +z}g0(i);u=d;return +z}function Oxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0;d=u;u=u+64|0;e=d+8|0;g=d;do if((d$(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;ZS(e,h);break}}else a$(e,a,-1);while(0);a=pT(e,2,-1,1)|0;h=f[e>>2]&7;if((a|0)<=-1){f[g>>2]=0;o=g+4|0;f[o>>2]=0;p=tT(g,52)|0;q=p;r=286581;t=q+52|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));z5(-215,g,286634,286499,272)}i=(h|0)==5;if((h|1|0)!=5){f[g>>2]=0;o=g+4|0;f[o>>2]=0;p=tT(g,52)|0;q=p;r=286581;t=q+52|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));z5(-215,g,286634,286499,272)}if(a){g=f[e+16>>2]|0;r=a+-1|0;if(i){v=0.0;i=0;q=f[g+(r<<3)+4>>2]|0;w=+n[g+(r<<3)>>2];while(1){x=w;w=+n[g+(i<<3)>>2];t=q;q=f[g+(i<<3)+4>>2]|0;y=x*(f[s>>2]=q,+n[s>>2]);x=v+(y-(f[s>>2]=t,+n[s>>2])*w);i=i+1|0;if((i|0)==(a|0)){z=x;break}else v=x}}else{v=0.0;i=0;w=+(f[g+(r<<3)>>2]|0);x=+(f[g+(r<<3)+4>>2]|0);while(1){y=w;w=+(f[g+(i<<3)>>2]|0);A=x;x=+(f[g+(i<<3)+4>>2]|0);B=v+(y*x-A*w);i=i+1|0;if((i|0)==(a|0)){z=B;break}else v=B}}v=z*.5;if(c)C=v;else C=+L(+v)}else C=0.0;c=e+36|0;a=f[c>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)_S(e);f[c>>2]=0;c=e+16|0;a=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[e+40>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[a>>2]|0))}a=f[e+44>>2]|0;if((a|0)==(e+48|0)){u=d;return +C}g0(a);u=d;return +C}function Pxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,Q=0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0.0;d=u;u=u+2592|0;e=d+2528|0;g=d+2232|0;h=d+2192|0;i=d+1096|0;j=d;k=d+2472|0;l=d+2416|0;m=d+2360|0;o=d+2304|0;q=d+2288|0;r=d+2272|0;do if((d$(c)|0)==65536){s=f[c+4>>2]|0;f[e>>2]=f[s>>2];t=e+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=e+8|0;f[w>>2]=f[s+8>>2];f[e+12>>2]=f[s+12>>2];f[e+16>>2]=f[s+16>>2];f[e+20>>2]=f[s+20>>2];f[e+24>>2]=f[s+24>>2];f[e+28>>2]=f[s+28>>2];f[e+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[e+36>>2]=x;f[e+40>>2]=w;w=e+48|0;y=e+44|0;f[y>>2]=w;f[w>>2]=0;f[e+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;ZS(e,s);break}}else a$(e,c,-1);while(0);c=pT(e,2,-1,1)|0;s=f[e>>2]&7;if((c|0)<=-1){f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,46)|0;B=A;C=286646;D=B+46|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,g,286693,286499,305)}t=(s|0)==5;if((s|1|0)!=5){f[g>>2]=0;z=g+4|0;f[z>>2]=0;A=tT(g,46)|0;B=A;C=286646;D=B+46|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,g,286693,286499,305)};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;if((c|0)<5){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,52)|0;C=286704;D=B+52|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-201,g,286693,286499,310)}B=g;D=B+40|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));B=h;D=B+40|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));B=e+16|0;D=f[B>>2]|0;C=e+44|0;A=c*5|0;z=i+8|0;f[i>>2]=z;s=i+4|0;f[s>>2]=A;if(A>>>0>136){v=XDc(A>>>0>536870911?-1:A<<3)|0;f[i>>2]=v;E=v}else E=z;v=j+8|0;f[j>>2]=v;A=j+4|0;f[A>>2]=c;if(c>>>0>136){w=XDc(c>>>0>536870911?-1:c<<3)|0;f[j>>2]=w;F=w}else F=v;Vj(k,c,5,6,E,0);Vj(l,c,1,6,F,0);f[m>>2]=1124007942;w=m+4|0;f[w>>2]=2;y=m+8|0;f[y>>2]=5;x=m+12|0;f[x>>2]=1;G=m+16|0;f[G>>2]=g;H=m+20|0;f[H>>2]=g;I=m+24|0;J=m+28|0;K=m+40|0;N=I+8|0;f[N>>2]=0;f[N+4>>2]=0;f[K>>2]=y;N=m+48|0;O=m+44|0;f[O>>2]=N;f[N>>2]=8;f[m+52>>2]=8;f[J>>2]=g+40;f[I>>2]=g+40;WS(m);if(t){Q=0;R=0.0;S=0.0;while(1){T=R+ +n[D+(Q<<3)>>2];V=S+ +n[D+(Q<<3)+4>>2];Q=Q+1|0;if((Q|0)==(c|0)){W=T;X=V;break}else{R=T;S=V}}}else{Q=0;S=0.0;R=0.0;while(1){V=S+ +(f[D+(Q<<3)>>2]|0);T=R+ +(f[D+(Q<<3)+4>>2]|0);Q=Q+1|0;if((Q|0)==(c|0)){W=V;X=T;break}else{S=V;R=T}}}R=+(c|0);S=W/R;W=X/R;if(t){Q=0;do{R=+n[D+(Q<<3)>>2]-S;X=+n[D+(Q<<3)+4>>2]-W;p[F+(Q<<3)>>3]=1.0e4;T=R;Y=Q*5|0;p[E+(Y<<3)>>3]=-(T*T);R=X;p[E+(Y+1<<3)>>3]=-(R*R);p[E+(Y+2<<3)>>3]=-(R*T);p[E+(Y+3<<3)>>3]=T;p[E+(Y+4<<3)>>3]=R;Q=Q+1|0}while((Q|0)!=(c|0))}else{Q=0;do{R=+(f[D+(Q<<3)>>2]|0)-S;T=+(f[D+(Q<<3)+4>>2]|0)-W;p[F+(Q<<3)>>3]=1.0e4;X=R;Y=Q*5|0;p[E+(Y<<3)>>3]=-(X*X);R=T;p[E+(Y+1<<3)>>3]=-(R*R);p[E+(Y+2<<3)>>3]=-(R*X);p[E+(Y+3<<3)>>3]=X;p[E+(Y+4<<3)>>3]=R;Q=Q+1|0}while((Q|0)!=(c|0))}f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;Q=r+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;oQ(o,q,r,1)|0;f[o>>2]=1124007942;Q=o+4|0;f[Q>>2]=2;Y=o+8|0;f[Y>>2]=2;Z=o+12|0;f[Z>>2]=2;_=o+16|0;f[_>>2]=E;$=o+20|0;f[$>>2]=E;aa=o+24|0;ba=o+28|0;ca=o+40|0;da=aa+8|0;f[da>>2]=0;f[da+4>>2]=0;f[ca>>2]=Y;da=o+48|0;ea=o+44|0;f[ea>>2]=da;f[da>>2]=16;f[o+52>>2]=8;fa=E+32|0;f[ba>>2]=fa;f[aa>>2]=fa;WS(o);fa=o+36|0;ga=f[fa>>2]|0;if(ga|0){ha=ga+12|0;f[ha>>2]=(f[ha>>2]|0)+1}ha=k+36|0;ga=f[ha>>2]|0;if(ga|0?(ia=ga+12|0,ga=f[ia>>2]|0,f[ia>>2]=ga+-1,(ga|0)==1):0)_S(k);f[ha>>2]=0;ga=k+16|0;ia=k+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ia>>2]|0)>0){ja=f[k+40>>2]|0;ka=0;do{f[ja+(ka<<2)>>2]=0;ka=ka+1|0;la=f[ia>>2]|0}while((ka|0)<(la|0));f[k>>2]=f[o>>2];if((la|0)<3)ma=33;else ma=35}else{f[k>>2]=f[o>>2];ma=33}if((ma|0)==33){la=f[Q>>2]|0;if((la|0)<3){f[ia>>2]=la;f[k+8>>2]=f[Y>>2];f[k+12>>2]=f[Z>>2];Z=f[ea>>2]|0;Y=f[k+44>>2]|0;f[Y>>2]=f[Z>>2];f[Y+4>>2]=f[Z+4>>2]}else ma=35}if((ma|0)==35)ZS(k,o);f[ga>>2]=f[_>>2];Z=k+20|0;f[Z>>2]=f[$>>2];$=k+24|0;f[$>>2]=f[aa>>2];aa=k+28|0;f[aa>>2]=f[ba>>2];ba=k+32|0;f[ba>>2]=f[o+32>>2];Y=f[fa>>2]|0;f[ha>>2]=Y;if(Y|0?(la=Y+12|0,Y=f[la>>2]|0,f[la>>2]=Y+-1,(Y|0)==1):0)_S(o);f[fa>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Q>>2]|0)>0){_=f[ca>>2]|0;ca=0;do{f[_+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[Q>>2]|0))}Q=f[ea>>2]|0;if((Q|0)!=(da|0))g0(Q);f[o>>2]=1124007942;Q=o+4|0;f[Q>>2]=2;da=o+8|0;f[da>>2]=2;ea=o+12|0;f[ea>>2]=1;ca=o+16|0;f[ca>>2]=F;_=o+20|0;f[_>>2]=F;fa=o+24|0;Y=o+28|0;la=o+40|0;ka=fa+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[la>>2]=da;ka=o+48|0;ja=o+44|0;f[ja>>2]=ka;f[ka>>2]=8;f[o+52>>2]=8;na=F+16|0;f[Y>>2]=na;f[fa>>2]=na;WS(o);na=o+36|0;oa=f[na>>2]|0;if(oa|0){pa=oa+12|0;f[pa>>2]=(f[pa>>2]|0)+1}pa=l+36|0;oa=f[pa>>2]|0;if(oa|0?(qa=oa+12|0,oa=f[qa>>2]|0,f[qa>>2]=oa+-1,(oa|0)==1):0)_S(l);f[pa>>2]=0;oa=l+16|0;qa=l+4|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[qa>>2]|0)>0){ra=f[l+40>>2]|0;sa=0;do{f[ra+(sa<<2)>>2]=0;sa=sa+1|0;ta=f[qa>>2]|0}while((sa|0)<(ta|0));f[l>>2]=f[o>>2];if((ta|0)<3)ma=54;else ma=56}else{f[l>>2]=f[o>>2];ma=54}if((ma|0)==54){ta=f[Q>>2]|0;if((ta|0)<3){f[qa>>2]=ta;f[l+8>>2]=f[da>>2];f[l+12>>2]=f[ea>>2];ea=f[ja>>2]|0;da=f[l+44>>2]|0;f[da>>2]=f[ea>>2];f[da+4>>2]=f[ea+4>>2]}else ma=56}if((ma|0)==56)ZS(l,o);f[oa>>2]=f[ca>>2];ea=l+20|0;f[ea>>2]=f[_>>2];_=l+24|0;f[_>>2]=f[fa>>2];fa=l+28|0;f[fa>>2]=f[Y>>2];Y=l+32|0;f[Y>>2]=f[o+32>>2];da=f[na>>2]|0;f[pa>>2]=da;if(da|0?(ta=da+12|0,da=f[ta>>2]|0,f[ta>>2]=da+-1,(da|0)==1):0)_S(o);f[na>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[Q>>2]|0)>0){ca=f[la>>2]|0;la=0;do{f[ca+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Q>>2]|0))}Q=f[ja>>2]|0;if((Q|0)!=(ka|0))g0(Q);f[o>>2]=1124007942;Q=o+4|0;f[Q>>2]=2;ka=o+8|0;f[ka>>2]=2;ja=o+12|0;f[ja>>2]=1;la=o+16|0;f[la>>2]=h;ca=o+20|0;f[ca>>2]=h;na=o+24|0;da=o+28|0;ta=o+40|0;sa=na+8|0;f[sa>>2]=0;f[sa+4>>2]=0;f[ta>>2]=ka;sa=o+48|0;ra=o+44|0;f[ra>>2]=sa;f[sa>>2]=8;f[o+52>>2]=8;ua=h+16|0;f[da>>2]=ua;f[na>>2]=ua;WS(o);va=o+36|0;wa=f[va>>2]|0;if(wa|0){xa=wa+12|0;f[xa>>2]=(f[xa>>2]|0)+1}xa=m+36|0;wa=f[xa>>2]|0;do if(wa|0){ya=wa+12|0;za=f[ya>>2]|0;f[ya>>2]=za+-1;if((za|0)!=1)break;_S(m)}while(0);f[xa>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[w>>2]|0)>0){wa=f[K>>2]|0;za=0;do{f[wa+(za<<2)>>2]=0;za=za+1|0;Aa=f[w>>2]|0}while((za|0)<(Aa|0));f[m>>2]=f[o>>2];if((Aa|0)<3)ma=75;else ma=77}else{f[m>>2]=f[o>>2];ma=75}do if((ma|0)==75){Aa=f[Q>>2]|0;if((Aa|0)>=3){ma=77;break}f[w>>2]=Aa;f[y>>2]=f[ka>>2];f[x>>2]=f[ja>>2];Aa=f[ra>>2]|0;za=f[O>>2]|0;f[za>>2]=f[Aa>>2];f[za+4>>2]=f[Aa+4>>2]}while(0);if((ma|0)==77)ZS(m,o);f[G>>2]=f[la>>2];f[H>>2]=f[ca>>2];f[I>>2]=f[na>>2];f[J>>2]=f[da>>2];da=m+32|0;f[da>>2]=f[o+32>>2];na=f[va>>2]|0;f[xa>>2]=na;do if(na|0){ca=na+12|0;ja=f[ca>>2]|0;f[ca>>2]=ja+-1;if((ja|0)!=1)break;_S(o)}while(0);f[va>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[Q>>2]|0)>0){la=f[ta>>2]|0;ta=0;do{f[la+(ta<<2)>>2]=0;ta=ta+1|0}while((ta|0)<(f[Q>>2]|0))}Q=f[ra>>2]|0;if((Q|0)!=(sa|0))g0(Q);p[E>>3]=+p[g>>3]*2.0;Q=g+16|0;R=+p[Q>>3];p[E+16>>3]=R;p[E+8>>3]=R;sa=g+8|0;p[E+24>>3]=+p[sa>>3]*2.0;ra=g+24|0;p[F>>3]=+p[ra>>3];p[F+8>>3]=+p[g+32>>3];f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;ta=r+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;oQ(o,q,r,1)|0;Vj(o,c,3,6,E,0);ta=o+36|0;la=f[ta>>2]|0;if(la|0){va=la+12|0;f[va>>2]=(f[va>>2]|0)+1}va=f[ha>>2]|0;do if(va|0){la=va+12|0;na=f[la>>2]|0;f[la>>2]=na+-1;if((na|0)!=1)break;_S(k)}while(0);f[ha>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ia>>2]|0)>0){va=f[k+40>>2]|0;na=0;do{f[va+(na<<2)>>2]=0;na=na+1|0;Ba=f[ia>>2]|0}while((na|0)<(Ba|0));f[k>>2]=f[o>>2];if((Ba|0)<3)ma=96;else ma=98}else{f[k>>2]=f[o>>2];ma=96}do if((ma|0)==96){Ba=f[o+4>>2]|0;if((Ba|0)>=3){ma=98;break}f[ia>>2]=Ba;f[k+8>>2]=f[o+8>>2];f[k+12>>2]=f[o+12>>2];Ba=f[o+44>>2]|0;na=f[k+44>>2]|0;f[na>>2]=f[Ba>>2];f[na+4>>2]=f[Ba+4>>2]}while(0);if((ma|0)==98)ZS(k,o);Ba=o+16|0;f[ga>>2]=f[Ba>>2];f[Z>>2]=f[o+20>>2];f[$>>2]=f[o+24>>2];f[aa>>2]=f[o+28>>2];f[ba>>2]=f[o+32>>2];ba=f[ta>>2]|0;f[ha>>2]=ba;do if(ba|0){aa=ba+12|0;$=f[aa>>2]|0;f[aa>>2]=$+-1;if(($|0)!=1)break;_S(o)}while(0);f[ta>>2]=0;ta=o+4|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Ba+8>>2]=0;f[Ba+12>>2]=0;if((f[ta>>2]|0)>0){Ba=f[o+40>>2]|0;ba=0;do{f[Ba+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[ta>>2]|0))}ta=f[o+44>>2]|0;if((ta|0)!=(o+48|0))g0(ta);Vj(o,c,1,6,F,0);ta=o+36|0;ba=f[ta>>2]|0;if(ba|0){Ba=ba+12|0;f[Ba>>2]=(f[Ba>>2]|0)+1}Ba=f[pa>>2]|0;do if(Ba|0){ba=Ba+12|0;$=f[ba>>2]|0;f[ba>>2]=$+-1;if(($|0)!=1)break;_S(l)}while(0);f[pa>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[qa>>2]|0)>0){Ba=f[l+40>>2]|0;$=0;do{f[Ba+($<<2)>>2]=0;$=$+1|0;Ca=f[qa>>2]|0}while(($|0)<(Ca|0));f[l>>2]=f[o>>2];if((Ca|0)<3)ma=117;else ma=119}else{f[l>>2]=f[o>>2];ma=117}do if((ma|0)==117){Ca=f[o+4>>2]|0;if((Ca|0)>=3){ma=119;break}f[qa>>2]=Ca;f[l+8>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];Ca=f[o+44>>2]|0;$=f[l+44>>2]|0;f[$>>2]=f[Ca>>2];f[$+4>>2]=f[Ca+4>>2]}while(0);if((ma|0)==119)ZS(l,o);Ca=o+16|0;f[oa>>2]=f[Ca>>2];f[ea>>2]=f[o+20>>2];f[_>>2]=f[o+24>>2];f[fa>>2]=f[o+28>>2];f[Y>>2]=f[o+32>>2];Y=f[ta>>2]|0;f[pa>>2]=Y;do if(Y|0){fa=Y+12|0;_=f[fa>>2]|0;f[fa>>2]=_+-1;if((_|0)!=1)break;_S(o)}while(0);f[ta>>2]=0;ta=o+4|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[ta>>2]|0)>0){Ca=f[o+40>>2]|0;Y=0;do{f[Ca+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[ta>>2]|0))}ta=f[o+44>>2]|0;if((ta|0)!=(o+48|0))g0(ta);f[o>>2]=1124007942;ta=o+4|0;f[ta>>2]=2;Y=o+8|0;f[Y>>2]=3;Ca=o+12|0;f[Ca>>2]=1;_=o+16|0;f[_>>2]=g;fa=o+20|0;f[fa>>2]=g;ea=o+24|0;$=o+28|0;Ba=o+40|0;ba=ea+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[Ba>>2]=Y;ba=o+48|0;aa=o+44|0;f[aa>>2]=ba;f[ba>>2]=8;f[o+52>>2]=8;f[$>>2]=ra;f[ea>>2]=ra;WS(o);ra=o+36|0;Z=f[ra>>2]|0;if(Z|0){na=Z+12|0;f[na>>2]=(f[na>>2]|0)+1}na=f[xa>>2]|0;do if(na|0){Z=na+12|0;va=f[Z>>2]|0;f[Z>>2]=va+-1;if((va|0)!=1)break;_S(m)}while(0);f[xa>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[w>>2]|0)>0){na=f[K>>2]|0;va=0;do{f[na+(va<<2)>>2]=0;va=va+1|0;Da=f[w>>2]|0}while((va|0)<(Da|0));f[m>>2]=f[o>>2];if((Da|0)<3)ma=138;else ma=140}else{f[m>>2]=f[o>>2];ma=138}do if((ma|0)==138){Da=f[ta>>2]|0;if((Da|0)>=3){ma=140;break}f[w>>2]=Da;f[y>>2]=f[Y>>2];f[x>>2]=f[Ca>>2];Da=f[aa>>2]|0;va=f[O>>2]|0;f[va>>2]=f[Da>>2];f[va+4>>2]=f[Da+4>>2]}while(0);if((ma|0)==140)ZS(m,o);f[G>>2]=f[_>>2];f[H>>2]=f[fa>>2];f[I>>2]=f[ea>>2];f[J>>2]=f[$>>2];f[da>>2]=f[o+32>>2];da=f[ra>>2]|0;f[xa>>2]=da;do if(da|0){$=da+12|0;J=f[$>>2]|0;f[$>>2]=J+-1;if((J|0)!=1)break;_S(o)}while(0);f[ra>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[ta>>2]|0)>0){_=f[Ba>>2]|0;Ba=0;do{f[_+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[ta>>2]|0))}ta=f[aa>>2]|0;if((ta|0)!=(ba|0))g0(ta);R=+p[h>>3];X=+p[h+8>>3];if(t){t=0;do{T=+n[D+(t<<3)>>2]-S;V=+n[D+(t<<3)+4>>2]-W;p[F+(t<<3)>>3]=1.0;Ea=T;T=Ea-R;ta=t*3|0;p[E+(ta<<3)>>3]=T*T;T=V;V=T-X;p[E+(ta+1<<3)>>3]=V*V;p[E+(ta+2<<3)>>3]=(Ea-R)*(T-X);t=t+1|0}while((t|0)!=(c|0))}else{t=0;do{T=+(f[D+(t<<3)>>2]|0)-S;Ea=+(f[D+(t<<3)+4>>2]|0)-W;p[F+(t<<3)>>3]=1.0;V=T;T=V-R;ta=t*3|0;p[E+(ta<<3)>>3]=T*T;T=Ea;Ea=T-X;p[E+(ta+1<<3)>>3]=Ea*Ea;p[E+(ta+2<<3)>>3]=(V-R)*(T-X);t=t+1|0}while((t|0)!=(c|0))}f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;oQ(o,q,r,1)|0;X=+p[Q>>3];R=+p[sa>>3];T=+p[g>>3];V=R-T;Ea=+U(+X,+V)*-.5;p[h+32>>3]=Ea;if(+L(+X)>1.0e-08)Fa=X/+P(+(Ea*-2.0));else Fa=V;V=T+R;R=+L(+(V-Fa));if(R>1.0e-08)Ga=+M(+(2.0/R));else Ga=R;p[ua>>3]=Ga;R=+L(+(V+Fa));if(R>1.0e-08)Ha=+M(+(2.0/R));else Ha=R;p[h+24>>3]=Ha;n[a>>2]=S+ +p[h>>3];n[a+4>>2]=W+ +p[h+8>>3];W=Ga*2.0;h=a+8|0;n[h>>2]=W;Ga=Ha*2.0;ua=a+12|0;n[ua>>2]=Ga;if(W>Ga){n[h>>2]=Ga;n[ua>>2]=W;W=Ea*180.0/3.141592653589793+90.0;ua=a+16|0;n[ua>>2]=W;Ia=ua;Ja=W}else{ua=a+16|0;Ia=ua;Ja=+n[ua>>2]}W=Ja+360.0;if(Ja<-180.0){n[Ia>>2]=W;Ka=W}else Ka=Ja;if(Ka>360.0)n[Ia>>2]=Ka+-360.0;Ia=f[xa>>2]|0;do if(Ia|0){ua=Ia+12|0;a=f[ua>>2]|0;f[ua>>2]=a+-1;if((a|0)!=1)break;_S(m)}while(0);f[xa>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[w>>2]|0)>0){G=f[K>>2]|0;K=0;do{f[G+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[w>>2]|0))}w=f[O>>2]|0;if((w|0)!=(N|0))g0(w);w=f[pa>>2]|0;do if(w|0){N=w+12|0;O=f[N>>2]|0;f[N>>2]=O+-1;if((O|0)!=1)break;_S(l)}while(0);f[pa>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[qa>>2]|0)>0){oa=f[l+40>>2]|0;pa=0;do{f[oa+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[qa>>2]|0))}qa=f[l+44>>2]|0;if((qa|0)!=(l+48|0))g0(qa);qa=f[ha>>2]|0;do if(qa|0){l=qa+12|0;pa=f[l>>2]|0;f[l>>2]=pa+-1;if((pa|0)!=1)break;_S(k)}while(0);f[ha>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ia>>2]|0)>0){ga=f[k+40>>2]|0;ha=0;do{f[ga+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ia>>2]|0))}ia=f[k+44>>2]|0;if((ia|0)!=(k+48|0))g0(ia);ia=f[j>>2]|0;if((ia|0)!=(v|0)){if(ia|0)ZDc(ia);f[j>>2]=v;f[A>>2]=136}A=f[i>>2]|0;if((A|0)!=(z|0)){if(A|0)ZDc(A);f[i>>2]=z;f[s>>2]=136}s=e+36|0;z=f[s>>2]|0;do if(z|0){i=z+12|0;A=f[i>>2]|0;f[i>>2]=A+-1;if((A|0)!=1)break;_S(e)}while(0);f[s>>2]=0;s=e+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[s>>2]|0)>0){B=f[e+40>>2]|0;z=0;do{f[B+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[s>>2]|0))}s=f[C>>2]|0;if((s|0)==(e+48|0)){u=d;return}g0(s);u=d;return}function Qxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+64|0;d=c;do if((d$(b)|0)==65536){e=f[b+4>>2]|0;f[d>>2]=f[e>>2];g=d+4|0;h=e+4|0;f[g>>2]=f[h>>2];i=d+8|0;f[i>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[d+16>>2]=f[e+16>>2];f[d+20>>2]=f[e+20>>2];f[d+24>>2]=f[e+24>>2];f[d+28>>2]=f[e+28>>2];f[d+32>>2]=f[e+32>>2];j=f[e+36>>2]|0;f[d+36>>2]=j;f[d+40>>2]=i;i=d+48|0;k=d+44|0;f[k>>2]=i;f[i>>2]=0;f[d+52>>2]=0;if(j|0){i=j+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[h>>2]|0)<3){h=f[e+44>>2]|0;i=f[k>>2]|0;f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];l=d;break}else{f[g>>2]=0;ZS(d,e);l=d;break}}else{a$(d,b,-1);l=d}while(0);if(!(f[l>>2]&7))Rxa(a,d);else Sxa(a,d);a=d+36|0;l=f[a>>2]|0;if(l|0?(b=l+12|0,l=f[b>>2]|0,f[b>>2]=l+-1,(l|0)==1):0)_S(d);f[a>>2]=0;a=d+16|0;l=d+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[l>>2]|0)>0){a=f[d+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[l>>2]|0))}l=f[d+44>>2]|0;if((l|0)==(d+48|0)){u=c;return}g0(l);u=c;return}function Rxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;if(!((g&6)>>>0<2&(g&4088|0)==0)){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,43)|0;h=286778;i=g+43|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,e,286822,286499,859)}e=f[c+40>>2]|0;h=f[e+4>>2]|0;g=f[e>>2]|0;if((g|0)<=0){j=h;k=-1;l=-1;m=0;n=(j|0)<(h|0);o=n?k:0;p=n?j:0;q=l+1|0;r=q-p|0;s=m-o|0;f[a>>2]=p;t=a+4|0;f[t>>2]=o;v=a+8|0;f[v>>2]=r;w=a+12|0;f[w>>2]=s;u=d;return}e=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;c=-1;x=-1;y=0;z=-1;A=h;while(1){B=e+(Y(i,y)|0)|0;C=B;D=C+3&-4;E=D;F=D-C|0;C=(F|0)>(h|0)?h:F;a:do if((C|0)>0){D=0;while(1){if(b[B+D>>0]|0)break;G=D+1|0;if((G|0)<(C|0))D=G;else{H=0;I=x;J=A;break a}}H=1;I=(D|0)>(x|0)?D:x;J=(D|0)<(A|0)?D:A}else{H=0;I=x;J=A}while(0);if((h|0)>(F|0)){B=J-C|0;G=I-C|0;K=h-C|0;L=B+-4|0;b:do if((B|0)<4)M=0;else{N=0;while(1){if(f[E+N>>2]|0){M=N;break b}O=N+4|0;if((O|0)>(L|0)){M=O;break}else N=O}}while(0);c:do if((M|0)<(B|0)){L=M;while(1){if(b[E+L>>0]|0)break;F=L+1|0;if((F|0)<(B|0))L=F;else{P=H;Q=F;R=B;S=G;break c}}P=1;Q=L;R=L;S=(L|0)>(G|0)?L:G}else{P=H;Q=M;R=B;S=G}while(0);G=Q+-1|0;B=(G|0)<(S|0)?S:G;G=K;while(1){T=G+-1|0;U=(T|0)>(B|0);V=(T&3|0)==3;if(V|U^1){W=20;break}if(!(b[E+T>>0]|0))G=T;else{X=T;break}}d:do if((W|0)==20){W=0;if(U&V?(G=B+3|0,(T|0)>(G|0)):0){K=T;while(1){if(f[E+K+-3>>2]|0){X=K;break d}F=K+-4|0;if((F|0)>(G|0))K=F;else{X=F;break}}}else X=T}while(0);e:do if((X|0)>(B|0)){K=X;while(1){if(b[E+K>>0]|0){Z=1;_=K;break e}G=K+-1|0;if((G|0)>(B|0))K=G;else{$=G;W=27;break}}}else{$=X;W=27}while(0);f:do if((W|0)==27){W=0;if(!P){B=Q&-4;K=$+-3|0;g:do if((B|0)>(K|0))aa=B;else{G=B;while(1){if(f[E+G>>2]|0){aa=G;break g}L=G+4|0;if((L|0)>(K|0)){aa=L;break}else G=L}}while(0);if((aa|0)>($|0)){Z=0;_=S}else{K=aa;while(1){if(b[E+K>>0]|0){Z=1;_=S;break f}if((K|0)<($|0))K=K+1|0;else{Z=0;_=S;break}}}}else{Z=P;_=S}}while(0);ba=R+C|0;ca=Z;da=_+C|0}else{ba=J;ca=H;da=I}E=(ca|0)==0;z=E?z:y;c=E?c:(c|0)<0?y:c;y=y+1|0;if((y|0)==(g|0))break;else{x=da;A=ba}}j=ba;k=c;l=da;m=z+1|0;n=(j|0)<(h|0);o=n?k:0;p=n?j:0;q=l+1|0;r=q-p|0;s=m-o|0;f[a>>2]=p;t=a+4|0;f[t>>2]=o;v=a+8|0;f[v>>2]=r;w=a+12|0;f[w>>2]=s;u=d;return}function Sxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0;d=u;u=u+16|0;e=d;g=pT(c,2,-1,1)|0;h=f[c>>2]&7;if((g|0)<=-1){f[e>>2]=0;i=e+4|0;f[i>>2]=0;j=tT(e,52)|0;k=j;l=286581;m=k+52|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,286757,286499,741)}o=(h|0)==5;if((h|1|0)!=5){f[e>>2]=0;i=e+4|0;f[i>>2]=0;j=tT(e,52)|0;k=j;l=286581;m=k+52|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,286757,286499,741)}if(!g){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;u=d;return}e=f[c+16>>2]|0;c=f[e>>2]|0;l=f[e+4>>2]|0;if(!o)if((g|0)>1){o=c;k=l;m=c;j=1;i=l;while(1){h=f[e+(j<<3)>>2]|0;p=f[e+(j<<3)+4>>2]|0;q=(o|0)>(h|0)?h:o;r=(m|0)<(h|0)?h:m;h=(k|0)>(p|0)?p:k;t=(i|0)<(p|0)?p:i;j=j+1|0;if((j|0)==(g|0)){v=q;w=h;x=r;y=t;break}else{o=q;k=h;m=r;i=t}}}else{v=c;w=l;x=c;y=l}else{i=c>>31&2147483647^c;c=l>>31&2147483647^l;if((g|0)>1){l=1;m=c;k=i;o=c;j=i;while(1){t=f[e+(l<<3)>>2]|0;r=f[e+(l<<3)+4>>2]|0;h=t>>31&2147483647^t;t=r>>31&2147483647^r;r=(j|0)>(h|0)?h:j;q=(k|0)<(h|0)?h:k;h=(m|0)>(t|0)?t:m;p=(o|0)<(t|0)?t:o;l=l+1|0;if((l|0)==(g|0)){z=r;A=h;B=q;C=p;break}else{m=h;k=q;o=p;j=r}}}else{z=i;A=c;B=i;C=c}D=(f[s>>2]=z>>31&2147483647^z,+n[s>>2]);z=~~D;E=(f[s>>2]=A>>31&2147483647^A,+n[s>>2]);A=~~E;F=(f[s>>2]=B>>31&2147483647^B,+n[s>>2]);B=~~F;G=(f[s>>2]=C>>31&2147483647^C,+n[s>>2]);C=~~G;v=z-(+(z|0)>D&1)|0;w=A-(+(A|0)>E&1)|0;x=B-(+(B|0)>F&1)|0;y=C-(+(C|0)>G&1)|0}f[a>>2]=v;f[a+4>>2]=w;f[a+8>>2]=x+1-v;f[a+12>>2]=y+1-w;u=d;return}function Txa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+1344|0;g=e+1256|0;h=e+1236|0;i=e+1208|0;j=e;k=e+1152|0;l=e+1096|0;if((c|0)!=0?(m=f[c>>2]|0,(m&-65536|0)==1117323264):0){if((m&4094|0)!=12){f[j>>2]=0;f[j+4>>2]=0;n=tT(j,25)|0;o=286839;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-5,j,286865,286499,1316)}if((f[c+4>>2]|0)>=88)if(!d){m=c+56|0;f[a>>2]=f[m>>2];f[a+4>>2]=f[m+4>>2];f[a+8>>2]=f[m+8>>2];f[a+12>>2]=f[m+12>>2];u=e;return}else{q=d;r=c;s=21}else{q=0;r=c;s=21}}else s=6;a:do if((s|0)==6){d=G0(c,i,0,0)|0;switch(f[d>>2]&4095){case 13:case 12:{q=0;r=kya(0,d,g,h)|0;s=21;break a;break}case 1:case 0:{if(!d){q=0;r=0;s=21;break a}O4(k,d,0,1,0,0);Rxa(j,k);d=f[j>>2]|0;m=f[j+4>>2]|0;t=f[j+8>>2]|0;v=f[j+12>>2]|0;w=k+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)_S(k);f[w>>2]=0;w=k+16|0;x=k+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[k+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[k+44>>2]|0;if((x|0)!=(k+48|0))g0(x);z=d;A=t;B=v;C=m;break a;break}default:{f[j>>2]=0;f[j+4>>2]=0;n=tT(j,56)|0;o=286880;p=n+56|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z5(-210,j,286865,286499,1336)}}}while(0);if((s|0)==21){if(!(f[r+24>>2]|0)){D=0;E=0;F=0;G=0}else{s=j+8|0;f[j>>2]=s;o=j+4|0;f[o>>2]=136;O4(l,r,0,0,0,j);Sxa(k,l);n=f[k>>2]|0;p=f[k+4>>2]|0;h=f[k+8>>2]|0;g=f[k+12>>2]|0;k=l+36|0;i=f[k>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)_S(l);f[k>>2]=0;k=l+16|0;i=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[l+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[l+44>>2]|0;if((i|0)!=(l+48|0))g0(i);i=f[j>>2]|0;if((i|0)!=(s|0)){if(i|0)ZDc(i);f[j>>2]=s;f[o>>2]=136}D=n;E=h;F=g;G=p}if(!q){z=D;A=E;B=F;C=G}else{f[r+56>>2]=D;f[r+60>>2]=G;f[r+64>>2]=E;f[r+68>>2]=F;z=D;A=E;B=F;C=G}}f[a>>2]=z;f[a+4>>2]=C;f[a+8>>2]=A;f[a+12>>2]=B;u=e;return}function Uxa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0.0,lc=0.0,mc=0.0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0,sc=0,tc=0.0,uc=0,vc=0;g=u;u=u+6592|0;i=g+4096|0;k=g;l=g+6272|0;m=g+6576|0;o=g+6568|0;p=g+6560|0;q=g+6544|0;r=g+6540|0;t=g+6536|0;v=g+6532|0;w=g+6528|0;x=g+6524|0;y=g+6520|0;z=g+6516|0;A=g+6512|0;B=g+6508|0;C=g+6504|0;D=g+6500|0;E=g+6496|0;F=g+6492|0;G=g+6488|0;H=g+6484|0;I=g+6480|0;J=g+6476|0;K=g+6472|0;L=g+6416|0;M=g+6552|0;N=g+6360|0;O=g+6304|0;if(((e|0)%2|0|0)!=1){f[i>>2]=0;P=i+4|0;f[P>>2]=0;Q=tT(i,40)|0;R=Q;S=286937;T=R+40|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));Vxa(-215,i,286978,1162)}if((n$(a,-1)|0)>=3){f[i>>2]=0;P=i+4|0;f[P>>2]=0;Q=tT(i,40)|0;R=Q;S=286937;T=R+40|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));Vxa(-215,i,286978,1162)}if((e|0)>=2?!(r$(a)|0):0){do if((d$(a)|0)==65536){Q=f[a+4>>2]|0;f[L>>2]=f[Q>>2];P=L+4|0;U=Q+4|0;f[P>>2]=f[U>>2];V=L+8|0;f[V>>2]=f[Q+8>>2];f[L+12>>2]=f[Q+12>>2];f[L+16>>2]=f[Q+16>>2];f[L+20>>2]=f[Q+20>>2];f[L+24>>2]=f[Q+24>>2];f[L+28>>2]=f[Q+28>>2];f[L+32>>2]=f[Q+32>>2];W=f[Q+36>>2]|0;f[L+36>>2]=W;X=L+40|0;f[X>>2]=V;V=L+48|0;Z=L+44|0;f[Z>>2]=V;f[V>>2]=0;f[L+52>>2]=0;if(W|0){V=W+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[U>>2]|0)<3){U=f[Q+44>>2]|0;V=f[Z>>2]|0;f[V>>2]=f[U>>2];f[V+4>>2]=f[U+4>>2];_=L;$=X;break}else{f[P>>2]=0;ZS(L,Q);_=L;$=X;break}}else{a$(L,a,-1);_=L;$=L+40|0}while(0);X=f[$>>2]|0;Q=f[X>>2]|0;f[M>>2]=f[X+4>>2];f[M+4>>2]=Q;v$(c,M,f[_>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){M=f[c+4>>2]|0;f[N>>2]=f[M>>2];Q=N+4|0;X=M+4|0;f[Q>>2]=f[X>>2];P=N+8|0;f[P>>2]=f[M+8>>2];f[N+12>>2]=f[M+12>>2];U=N+16|0;f[U>>2]=f[M+16>>2];f[N+20>>2]=f[M+20>>2];f[N+24>>2]=f[M+24>>2];f[N+28>>2]=f[M+28>>2];f[N+32>>2]=f[M+32>>2];V=f[M+36>>2]|0;f[N+36>>2]=V;f[N+40>>2]=P;P=N+48|0;Z=N+44|0;f[Z>>2]=P;f[P>>2]=0;f[N+52>>2]=0;if(V|0){P=V+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[X>>2]|0)<3){X=f[M+44>>2]|0;P=f[Z>>2]|0;f[P>>2]=f[X>>2];f[P+4>>2]=f[X+4>>2];aa=U;break}else{f[Q>>2]=0;ZS(N,M);aa=U;break}}else{a$(N,c,-1);aa=N+16|0}while(0);U=L+16|0;M=L+12|0;Q=L+8|0;X=f[_>>2]|0;switch(e|0){case 3:{ba=1;break}case 5:{if(!(X&7)){P=(X>>>3&511)+1|0;ba=(P|0)==2|P>>>0>4}else ba=1;break}default:ba=0}f[O>>2]=1124007936;P=O+4|0;X=O+8|0;Z=O+40|0;R=P;T=R+36|0;do{f[R>>2]=0;R=R+4|0}while((R|0)<(T|0));f[Z>>2]=X;V=O+48|0;W=O+44|0;f[W>>2]=V;f[V>>2]=0;f[O+52>>2]=0;a:do if(!ba){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=L;ca=k+8|0;f[ca>>2]=0;f[ca+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=O;ca=(e|0)/2|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;q_(i,k,0,0,ca,ca,17,l);da=f[O>>2]|0;if(da&7|0){f[i>>2]=0;ea=i+4|0;f[ea>>2]=0;fa=tT(i,55)|0;R=fa;S=286989;T=R+55|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));Vxa(-215,i,286978,1222)}switch((f[_>>2]|0)>>>3&511){case 0:case 2:case 3:break;default:{f[i>>2]=0;ea=i+4|0;f[ea>>2]=0;fa=tT(i,55)|0;R=fa;S=286989;T=R+55|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));Vxa(-215,i,286978,1222)}}ga=f[L+4>>2]|0;if((ga|0)<3)ha=Y(f[M>>2]|0,f[Q>>2]|0)|0;else{ia=f[$>>2]|0;ja=0;ka=1;while(1){la=Y(f[ia+(ja<<2)>>2]|0,ka)|0;ja=ja+1|0;if((ja|0)==(ga|0)){ha=la;break}else ka=la}}ma=+(ha>>>0)*9.5367431640625e-07;if(((ma<1.0?39:ma<4.0?21:9)|0)>=(e|0)){ka=(Y(e,e)|0)>>>1;ga=f[N+40>>2]|0;ja=f[ga+4>>2]|0;ia=f[ga>>2]|0;ga=f[O+16>>2]|0;la=f[aa>>2]|0;na=f[V>>2]|0;oa=f[N+48>>2]|0;pa=da>>>3;qa=pa&511;ra=qa+1|0;sa=ga+(Y(na,ia)|0)|0;if(qa>>>0>=4){f[l>>2]=0;f[l+4>>2]=0;R=tT(l,17)|0;S=287045;T=R+17|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));Vxa(-215,l,287063,351)}if((ja|0)>0){da=ia+-1|0;qa=Y(na,da)|0;ta=Y(oa,da)|0;ua=0-na|0;va=0-oa|0;wa=ra<<6;xa=ra<<10;ya=(e|0)<-1;za=(ia|0)>0;Aa=pa&65535;Ba=e<<2;Ca=(e|0)>0;Da=e*3|0;Ea=Y(ra,e)|0;Fa=(Ea|0)>0;Ga=ca+1|0;Ha=(na|0)!=0;Ia=ga;Ja=la;Ka=0;while(1){La=(Ka&1|0)==0;Ma=La?oa:va;Na=La?na:ua;Oa=La?Ia:Ia+qa|0;Pa=La?Ja:Ja+ta|0;XIc(i|0,0,wa|0)|0;XIc(k|0,0,xa|0)|0;b:do if(ya)Qa=Oa;else{La=(Na|0)>0;if(Fa){Ra=0;Sa=Oa}else{Ta=0;Ua=Oa;while(1){if(La)if((Ta|0)<(da|0))Va=169;else Wa=Ua;else if(Ha&(ia-Ta|0)>1)Va=169;else Wa=Ua;if((Va|0)==169){Va=0;Wa=Ua+Na|0}if((Ta|0)<(ca|0)){Ta=Ta+1|0;Ua=Wa}else{Qa=Wa;break b}}}while(1){if((Ra|0)>0){Ua=0;do{Ta=0;do{Xa=h[Sa+(Ta+Ua)>>0]|0;Ya=k+(Ua<<10)+(Xa<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=i+(Ua<<6)+(Xa>>>4<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ta=Ta+ra|0}while((Ta|0)<(Ea|0));Ua=Ua+1|0}while((Ua|0)!=(ra|0))}else{Ua=0;do{Ta=0;do{Ya=h[Sa+(Ta+Ua)>>0]|0;Xa=k+(Ua<<10)+(Ya<<2)|0;f[Xa>>2]=(f[Xa>>2]|0)+Ga;Xa=i+(Ua<<6)+(Ya>>>4<<2)|0;f[Xa>>2]=(f[Xa>>2]|0)+Ga;Ta=Ta+ra|0}while((Ta|0)<(Ea|0));Ua=Ua+1|0}while((Ua|0)!=(ra|0))}if(La)if((Ra|0)<(da|0))Va=159;else Za=Sa;else if(Ha&(ia-Ra|0)>1)Va=159;else Za=Sa;if((Va|0)==159){Va=0;Za=Sa+Na|0}if((Ra|0)<(ca|0)){Ra=Ra+1|0;Sa=Za}else{Qa=Za;break}}}while(0);c:do if(za){La=(Na|0)>-1;Ua=(Na|0)<1;Ta=Pa;Xa=Oa;Ya=0;_a=Qa;while(1){$a=0;do{ab=0;bb=0;while(1){cb=(f[i+($a<<6)+(bb<<2)>>2]|0)+ab|0;if((cb|0)>(ka|0))break;else{ab=cb;bb=bb+1|0}}cb=ab;db=bb<<4;while(1){cb=(f[k+($a<<10)+(db<<2)>>2]|0)+cb|0;if((cb|0)>(ka|0))break;else db=db+1|0}b[Ta+$a>>0]=db;$a=$a+1|0}while(($a|0)!=(ra|0));$a=Ya+1|0;if(($a|0)==(ia|0))break c;d:do switch(Aa&511){case 0:{if(Ca)eb=0;else break d;do{cb=h[Xa+eb>>0]|0;bb=h[_a+eb>>0]|0;ab=k+(cb<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=i+(cb>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=k+(bb<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=i+(bb>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;eb=eb+1|0}while((eb|0)!=(e|0));break}case 2:{if(Ca)fb=0;else break d;do{db=h[Xa+fb>>0]|0;ab=k+(db<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=i+(db>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=fb+1|0;db=h[Xa+ab>>0]|0;bb=k+1024+(db<<2)|0;f[bb>>2]=(f[bb>>2]|0)+-1;bb=i+64+(db>>>4<<2)|0;f[bb>>2]=(f[bb>>2]|0)+-1;bb=fb+2|0;db=h[Xa+bb>>0]|0;cb=k+2048+(db<<2)|0;f[cb>>2]=(f[cb>>2]|0)+-1;cb=i+128+(db>>>4<<2)|0;f[cb>>2]=(f[cb>>2]|0)+-1;cb=h[_a+fb>>0]|0;db=k+(cb<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=i+(cb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=h[_a+ab>>0]|0;ab=k+1024+(db<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=i+64+(db>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=h[_a+bb>>0]|0;bb=k+2048+(ab<<2)|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=i+128+(ab>>>4<<2)|0;f[bb>>2]=(f[bb>>2]|0)+1;fb=fb+3|0}while((fb|0)<(Da|0));break}default:{if(Ca)gb=0;else break d;do{bb=h[Xa+gb>>0]|0;ab=k+(bb<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=i+(bb>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=gb|1;bb=h[Xa+ab>>0]|0;db=k+1024+(bb<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=i+64+(bb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=gb|2;bb=h[Xa+db>>0]|0;cb=k+2048+(bb<<2)|0;f[cb>>2]=(f[cb>>2]|0)+-1;cb=i+128+(bb>>>4<<2)|0;f[cb>>2]=(f[cb>>2]|0)+-1;cb=gb|3;bb=h[Xa+cb>>0]|0;hb=k+3072+(bb<<2)|0;f[hb>>2]=(f[hb>>2]|0)+-1;hb=i+192+(bb>>>4<<2)|0;f[hb>>2]=(f[hb>>2]|0)+-1;hb=h[_a+gb>>0]|0;bb=k+(hb<<2)|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=i+(hb>>>4<<2)|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=h[_a+ab>>0]|0;ab=k+1024+(bb<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=i+64+(bb>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=h[_a+db>>0]|0;db=k+2048+(ab<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=i+128+(ab>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=h[_a+cb>>0]|0;cb=k+3072+(db<<2)|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=i+192+(db>>>4<<2)|0;f[cb>>2]=(f[cb>>2]|0)+1;gb=gb+4|0}while((gb|0)<(Ba|0))}}while(0);cb=_a+Na|0;if(($a|0)<(ia|0)){Ta=Ta+Ma|0;Xa=(Ya|0)<(ca|0)?Xa:Xa+Na|0;Ya=$a;_a=(Ua|cb>>>0>=sa>>>0)&(La|cb>>>0<Ia>>>0)?_a:cb}else break c}}while(0);Ka=Ka+1|0;if((Ka|0)==(ja|0))break;else{Ia=Ia+ra|0;Ja=Ja+ra|0}}}break}ra=(f[N>>2]|0)>>>3&511;Ja=ra+1|0;Ia=f[N+8>>2]|0;ja=e+-1|0;Ka=(ja|0)/2|0;if(ra>>>0>=4){f[i>>2]=0;f[i+4>>2]=0;R=tT(i,17)|0;S=287045;T=R+17|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));Vxa(-215,i,287080,114)}sa=f[V>>2]|0;ca=f[N+48>>2]|0;ia=N+12|0;Ba=512/(Ja>>>0)|0;Ca=f[ia>>2]|0;Da=(Ba|0)<(Ca|0)?Ba:Ca;Ba=Ka<<1;Aa=Da+Ba|0;ka=Y(Aa<<4,Ja)|0;za=ka+16|0;f[l>>2]=0;Ha=l+4|0;f[Ha>>2]=0;f[l+8>>2]=0;do if(za)if((ka|0)<-16)mCc(l);else{da=za<<1;Ea=VDc(da)|0;f[l>>2]=Ea;Ga=Ea+(za<<1)|0;f[l+8>>2]=Ga;XIc(Ea|0,0,da|0)|0;f[Ha>>2]=Ga;ib=Ea;break}else ib=0;while(0);za=Y(Ja<<8,Aa)|0|16;f[m>>2]=0;ka=m+4|0;f[ka>>2]=0;f[m+8>>2]=0;if((za|0)<0)mCc(m);Ea=za<<1;Ga=VDc(Ea)|0;f[m>>2]=Ga;da=Ga+(za<<1)|0;f[m+8>>2]=da;XIc(Ga|0,0,Ea|0)|0;f[ka>>2]=da;Ea=ib+15&-16;za=Ea;Fa=Ga+15&-16;ya=Fa;do if((Ca|0)>0){xa=O+16|0;wa=Ea;ta=Ja<<1;qa=Fa;ua=Ja<<9;na=Ka+2|0;va=(ja|0)>3;oa=Ia+-1|0;la=(Ia|0)>0;ga=Ja*544|0;pa=Ja<<5;Na=Ba|1;Ma=(ja|0)>1;Oa=(Y(Ba,Ka)|0)+Ba|0;Pa=0;_a=Ca;e:while(1){La=_a-Pa|0;Ua=((Da|0)<(La|0)?Da:La)+Ba|0;La=(f[xa>>2]|0)+(Y(Pa,Ja)|0)|0;Ya=f[aa>>2]|0;Xa=Y(Pa-Ka|0,Ja)|0;Ta=Ua<<4;XIc(wa|0,0,Y(ta,Ta)|0)|0;XIc(qa|0,0,Y(ua,Ua)|0)|0;cb=(Ua|0)>0;if(cb){db=0;do{ab=Y(db,Ua)|0;bb=db<<4;hb=0;do{jb=La+((Y(hb,Ja)|0)+db)|0;kb=za+(((h[jb>>0]|0)>>>4|hb+ab<<4)<<1)|0;d[kb>>1]=(j[kb>>1]|0)+na;kb=h[jb>>0]|0;jb=ya+(((Y(kb>>>4|bb,Ua)|0)+hb<<4|kb&15)<<1)|0;d[jb>>1]=(j[jb>>1]|0)+na;hb=hb+1|0}while((hb|0)<(Ua|0));if(va){hb=1;do{$a=La+(Y((oa|0)<(hb|0)?oa:hb,sa)|0)|0;jb=0;do{kb=$a+((Y(jb,Ja)|0)+db)|0;lb=za+(((h[kb>>0]|0)>>>4|jb+ab<<4)<<1)|0;d[lb>>1]=(d[lb>>1]|0)+1<<16>>16;lb=h[kb>>0]|0;kb=ya+(((Y(lb>>>4|bb,Ua)|0)+jb<<4|lb&15)<<1)|0;d[kb>>1]=(d[kb>>1]|0)+1<<16>>16;jb=jb+1|0}while((jb|0)<(Ua|0));hb=hb+1|0}while((hb|0)<(Ka|0))}db=db+1|0}while((db|0)!=(Ja|0))}db=Ya+Xa|0;if(la){hb=Ua-Ka|0;bb=(Ka|0)<(hb|0);ab=Ua+-1|0;jb=0;do{$a=jb-Ka+-1|0;kb=La+(Y(($a|0)>0?$a:0,sa)|0)|0;$a=jb+Ka|0;lb=La+(Y(($a|0)<(oa|0)?$a:oa,sa)|0)|0;XIc(i|0,0,ga|0)|0;XIc(k|0,0,pa|0)|0;$a=Y(jb,ca)|0;mb=0;while(1){if(cb){nb=Y(mb,Ua)|0;ob=mb<<4;pb=0;do{qb=pb+nb<<4;rb=(Y(pb,Ja)|0)+mb|0;sb=kb+rb|0;tb=za+(((h[sb>>0]|0)>>>4|qb)<<1)|0;d[tb>>1]=(d[tb>>1]|0)+-1<<16>>16;tb=h[sb>>0]|0;sb=ya+(((Y(tb>>>4|ob,Ua)|0)+pb<<4|tb&15)<<1)|0;d[sb>>1]=(d[sb>>1]|0)+-1<<16>>16;sb=lb+rb|0;rb=za+(((h[sb>>0]|0)>>>4|qb)<<1)|0;d[rb>>1]=(d[rb>>1]|0)+1<<16>>16;rb=h[sb>>0]|0;sb=ya+(((Y(rb>>>4|ob,Ua)|0)+pb<<4|rb&15)<<1)|0;d[sb>>1]=(d[sb>>1]|0)+1<<16>>16;pb=pb+1|0}while((pb|0)<(Ua|0));ub=ob}else ub=mb<<4;ob=0;do{pb=Y(ob+ub|0,Ta)|0;nb=0;do{sb=Y(j[ya+(nb+pb<<1)>>1]|0,Na)|0;rb=i+(mb*544|0)+32+(ob<<5)+(nb<<1)|0;d[rb>>1]=(j[rb>>1]|0)+sb;nb=nb+1|0}while((nb|0)!=16);ob=ob+1|0}while((ob|0)!=16);if(Ma){ob=za+((Y(mb,Ta)|0)<<1)|0;nb=0;while(1){pb=0;do{sb=i+(mb*544|0)+(pb<<1)|0;d[sb>>1]=(j[sb>>1]|0)+(j[ob+(pb<<1)>>1]|0);pb=pb+1|0}while((pb|0)!=16);nb=nb+1|0;if((nb|0)>=(Ba|0))break;else ob=ob+32|0}}if(bb){ob=Y(mb,Ua)|0;nb=mb+$a|0;pb=i+(mb*544|0)|0;sb=i+(mb*544|0)+2|0;rb=i+(mb*544|0)+4|0;qb=i+(mb*544|0)+6|0;tb=i+(mb*544|0)+8|0;vb=i+(mb*544|0)+10|0;wb=i+(mb*544|0)+12|0;xb=i+(mb*544|0)+14|0;yb=i+(mb*544|0)+16|0;zb=i+(mb*544|0)+18|0;Ab=i+(mb*544|0)+20|0;Bb=i+(mb*544|0)+22|0;Cb=i+(mb*544|0)+24|0;Db=i+(mb*544|0)+26|0;Eb=i+(mb*544|0)+28|0;Fb=i+(mb*544|0)+30|0;Gb=Ka;do{Hb=Gb+Ka|0;Ib=za+(((ab|0)<(Hb|0)?ab:Hb)+ob<<4<<1)|0;Jb=0;do{Kb=i+(mb*544|0)+(Jb<<1)|0;d[Kb>>1]=(j[Kb>>1]|0)+(j[Ib+(Jb<<1)>>1]|0);Jb=Jb+1|0}while((Jb|0)!=16);Jb=j[pb>>1]|0;do if((Jb|0)<=(Oa|0)){Ib=(j[sb>>1]|0)+Jb|0;if((Ib|0)>(Oa|0)){Lb=Jb;Mb=1;break}Kb=(j[rb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=2;break}Ib=(j[qb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=3;break}Kb=(j[tb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=4;break}Ib=(j[vb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=5;break}Kb=(j[wb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=6;break}Ib=(j[xb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=7;break}Kb=(j[yb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=8;break}Ib=(j[zb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=9;break}Kb=(j[Ab>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=10;break}Ib=(j[Bb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=11;break}Kb=(j[Cb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=12;break}Ib=(j[Db>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=13;break}Kb=(j[Eb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=14;break}if(((j[Fb>>1]|0)+Kb|0)>(Oa|0)){Lb=Kb;Mb=15}else{Va=273;break e}}else{Lb=0;Mb=0}while(0);Jb=k+(mb<<5)+(Mb<<1)|0;Kb=d[Jb>>1]|0;Ib=Kb&65535;Nb=Gb-Ka|0;do if((Ib|0)>(Nb|0)){Ob=ya+((Y(Mb|ub,Ta)|0)<<1)|0;if((Ib|0)>(Hb|0))break;else Pb=Kb;do{Qb=Pb&65535;Rb=((Qb|0)<(Ua|0)?Qb:ab)<<4;Sb=Qb-Ba|0;Qb=(Sb|0)<1?0:(Sb<<4)+-16|0;Sb=0;do{Tb=i+(mb*544|0)+32+(Mb<<5)+(Sb<<1)|0;d[Tb>>1]=(j[Ob+(Sb+Rb<<1)>>1]|0)-(j[Ob+(Sb+Qb<<1)>>1]|0)+(j[Tb>>1]|0);Sb=Sb+1|0}while((Sb|0)!=16);Pb=Pb+1<<16>>16;d[Jb>>1]=Pb}while((Pb&65535|0)<=(Hb|0))}else{Ob=i+(mb*544|0)+32+(Mb<<5)|0;f[Ob>>2]=0;f[Ob+4>>2]=0;f[Ob+8>>2]=0;f[Ob+12>>2]=0;f[Ob+16>>2]=0;f[Ob+20>>2]=0;f[Ob+24>>2]=0;f[Ob+28>>2]=0;Ob=Y(Mb|ub,Ua)|0;Sb=Nb&65535;d[Jb>>1]=Sb;Qb=Nb&65535;Rb=Hb+1|0;Tb=(Hb|0)<(Ua|0)?Rb:Ua;if((Qb|0)<(Tb|0)){Ub=ya+(Ob+Nb<<4<<1)|0;Vb=Sb;while(1){Sb=0;do{Wb=i+(mb*544|0)+32+(Mb<<5)+(Sb<<1)|0;d[Wb>>1]=(j[Wb>>1]|0)+(j[Ub+(Sb<<1)>>1]|0);Sb=Sb+1|0}while((Sb|0)!=16);Vb=Vb+1<<16>>16;d[Jb>>1]=Vb;Sb=Vb&65535;if((Sb|0)>=(Tb|0)){Xb=Sb;break}else Ub=Ub+32|0}}else Xb=Qb;if((Xb|0)>(Hb|0))break;Ub=ya+(Ob+ab<<4<<1)|0;Tb=Rb-Ua|0;Vb=0;do{Sb=Y(j[Ub+(Vb<<1)>>1]|0,Tb)|0;Wb=i+(mb*544|0)+32+(Mb<<5)+(Vb<<1)|0;d[Wb>>1]=(j[Wb>>1]|0)+Sb;Vb=Vb+1|0}while((Vb|0)!=16);d[Jb>>1]=Rb}while(0);Jb=za+(((Nb|0)>0?Nb:0)+ob<<4<<1)|0;Hb=0;do{Kb=i+(mb*544|0)+(Hb<<1)|0;d[Kb>>1]=(j[Kb>>1]|0)-(j[Jb+(Hb<<1)>>1]|0);Hb=Hb+1|0}while((Hb|0)!=16);Hb=(j[i+(mb*544|0)+32+(Mb<<5)>>1]|0)+Lb|0;do if((Hb|0)<=(Oa|0)){Jb=(j[i+(mb*544|0)+32+(Mb<<5)+2>>1]|0)+Hb|0;if((Jb|0)>(Oa|0)){Yb=1;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+4>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=2;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+6>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=3;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+8>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=4;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+10>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=5;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+12>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=6;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+14>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=7;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+16>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=8;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+18>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=9;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+20>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=10;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+22>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=11;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+24>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=12;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+26>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=13;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+28>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=14;break}if(((j[i+(mb*544|0)+32+(Mb<<5)+30>>1]|0)+Nb|0)>(Oa|0))Yb=15;else{Va=288;break e}}else Yb=0;while(0);Hb=db+(nb+(Y(Gb,Ja)|0))|0;b[Hb>>0]=Yb|Mb<<4;Gb=Gb+1|0}while((Gb|0)<(hb|0))}if((mb|0)<(ra|0))mb=mb+1|0;else break}jb=jb+1|0}while((jb|0)<(Ia|0))}Pa=Pa+Da|0;_a=f[ia>>2]|0;if((_a|0)<=(Pa|0)){Va=198;break}}if((Va|0)==198){Pa=f[m>>2]|0;if(!Pa)break;Zb=f[ka>>2]|0;_b=Pa;$b=Pa;Va=200;break}else if((Va|0)==273){f[o>>2]=0;f[o+4>>2]=0;Pa=tT(o,6)|0;b[Pa>>0]=b[287097]|0;b[Pa+1>>0]=b[287098]|0;b[Pa+2>>0]=b[287099]|0;b[Pa+3>>0]=b[287100]|0;b[Pa+4>>0]=b[287101]|0;b[Pa+5>>0]=b[287102]|0;Vxa(-215,o,287080,228)}else if((Va|0)==288){f[o>>2]=0;f[o+4>>2]=0;Pa=tT(o,6)|0;b[Pa>>0]=b[287104]|0;b[Pa+1>>0]=b[287105]|0;b[Pa+2>>0]=b[287106]|0;b[Pa+3>>0]=b[287107]|0;b[Pa+4>>0]=b[287108]|0;b[Pa+5>>0]=b[287109]|0;Vxa(-215,o,287080,324)}}else{Zb=da;_b=Ga;$b=Ga;Va=200}while(0);if((Va|0)==200){if((Zb|0)!=(_b|0))f[ka>>2]=Zb+(~((Zb+-2-_b|0)>>>1)<<1);YDc($b)}Ga=f[l>>2]|0;if(Ga|0){da=f[Ha>>2]|0;if((da|0)!=(Ga|0))f[Ha>>2]=da+(~((da+-2-Ga|0)>>>1)<<1);YDc(Ga)}}else{if((f[aa>>2]|0)==(f[U>>2]|0)){Ga=i+8|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=O;h_(L,i)}else{Ga=L+36|0;da=f[Ga>>2]|0;if(da){ia=da+12|0;f[ia>>2]=(f[ia>>2]|0)+1;ia=O+36|0;da=f[ia>>2]|0;if((da|0)!=0?(Da=da+12|0,da=f[Da>>2]|0,f[Da>>2]=da+-1,(da|0)==1):0){_S(O);ac=ia}else ac=ia}else ac=O+36|0;f[ac>>2]=0;ia=O+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[P>>2]|0)>0){da=f[Z>>2]|0;Da=0;do{f[da+(Da<<2)>>2]=0;Da=Da+1|0;bc=f[P>>2]|0}while((Da|0)<(bc|0));f[O>>2]=f[_>>2];if((bc|0)<3)Va=37;else Va=39}else{f[O>>2]=f[_>>2];Va=37}if((Va|0)==37){Da=f[L+4>>2]|0;if((Da|0)<3){f[P>>2]=Da;f[X>>2]=f[Q>>2];f[O+12>>2]=f[M>>2];Da=f[L+44>>2]|0;da=f[W>>2]|0;f[da>>2]=f[Da>>2];f[da+4>>2]=f[Da+4>>2]}else Va=39}if((Va|0)==39)ZS(O,L);f[ia>>2]=f[U>>2];f[O+20>>2]=f[L+20>>2];f[O+24>>2]=f[L+24>>2];f[O+28>>2]=f[L+28>>2];f[O+32>>2]=f[L+32>>2];f[ac>>2]=f[Ga>>2]}Da=f[O>>2]|0;switch(Da&7){case 0:{Wxa(O,N,e);break a;break}case 2:{da=f[O+16>>2]|0;Ha=f[aa>>2]|0;ka=(f[V>>2]|0)>>>1;Ia=(f[N+48>>2]|0)>>>1;ra=f[N+40>>2]|0;Ja=f[ra+4>>2]|0;za=f[ra>>2]|0;ra=Da>>>3;ya=ra&511;Ba=ya+1|0;switch(e|0){case 3:{Ka=(za|0)==1;if((Ja|0)==1|Ka){ca=za+Ja|0;sa=ca+-1|0;Ca=Ka?Ba:ka;ja=Ka?0:ka-Ba|0;Fa=Ka?Ba:Ia;if((ca|0)<=1)break a;Ka=0-Ca|0;Ea=ca+-2|0;ca=Ha;Aa=0;Pa=da;while(1){_a=(Aa|0)>0?Ka:0;Oa=(Aa|0)<(Ea|0)?Ca:0;Ma=0;Na=Pa;while(1){pa=d[Na+(_a<<1)>>1]|0;ga=d[Na>>1]|0;oa=j[Na+(Oa<<1)>>1]|0;la=(ga&65535)<(pa&65535);va=(la?ga:pa)&65535;na=(la?pa:ga)&65535;ga=oa>>>0<na>>>0?oa:na;d[ca+(Ma<<1)>>1]=(ga|0)<(va|0)?va:ga;Ma=Ma+1|0;if((Ma|0)==(Ba|0))break;else Na=Na+2|0}Aa=Aa+1|0;if((Aa|0)>=(sa|0))break a;else{ca=ca+(Fa<<1)|0;Pa=Pa+(Ba<<1)+(ja<<1)|0}}}ja=Y(Ja,Ba)|0;if((za|0)<=0)break a;Pa=za+-1|0;Fa=(ra|-512)^511;ca=Fa+-1+ja|0;sa=ja-Ba|0;Aa=Ha;Ca=0;while(1){Ea=Ca+-1|0;Ka=da+((Y((Ea|0)>0?Ea:0,ka)|0)<<1)|0;Ea=da+((Y(Ca,ka)|0)<<1)|0;Ca=Ca+1|0;Ga=da+((Y((Pa|0)<(Ca|0)?Pa:Ca,ka)|0)<<1)|0;ia=Ba;Na=0;f:while(1){if((Na|0)<(ia|0)){Ma=Na;do{Oa=Ma-((Ma|0)>(ya|0)?Ba:0)|0;_a=((Ma|0)<(sa|0)?Ba:0)+Ma|0;ga=d[Ka+(Oa<<1)>>1]|0;va=d[Ka+(Ma<<1)>>1]|0;na=d[Ka+(_a<<1)>>1]|0;oa=d[Ea+(Oa<<1)>>1]|0;pa=d[Ea+(Ma<<1)>>1]|0;la=d[Ea+(_a<<1)>>1]|0;ua=d[Ga+(Oa<<1)>>1]|0;Oa=d[Ga+(Ma<<1)>>1]|0;qa=d[Ga+(_a<<1)>>1]|0;_a=(na&65535)<(va&65535);ta=_a?na:va;wa=_a?va:na;na=(la&65535)<(pa&65535);va=na?la:pa;_a=na?pa:la;la=(qa&65535)<(Oa&65535);pa=la?qa:Oa;na=la?Oa:qa;qa=(ta&65535)<(ga&65535);Oa=(qa?ta:ga)&65535;la=qa?ga:ta;ta=(va&65535)<(oa&65535);ga=(ta?va:oa)&65535;qa=ta?oa:va;va=(pa&65535)<(ua&65535);oa=(va?pa:ua)&65535;ta=va?ua:pa;pa=(wa&65535)<(la&65535);ua=(pa?wa:la)&65535;va=(pa?la:wa)&65535;wa=(_a&65535)<(qa&65535);la=wa?_a:qa;pa=(wa?qa:_a)&65535;_a=(na&65535)<(ta&65535);qa=_a?na:ta;wa=(_a?ta:na)&65535;na=ga>>>0<Oa>>>0?Oa:ga;ga=wa>>>0<pa>>>0?wa:pa;pa=(qa&65535)<(la&65535);wa=(pa?qa:la)&65535;Oa=(pa?la:qa)&65535;qa=(oa|0)<(na|0)?na:oa;oa=wa>>>0<ua>>>0?ua:wa;wa=(ga|0)<(va|0)?ga:va;va=(Oa|0)<(oa|0)?Oa:oa;oa=(wa|0)<(va|0);Oa=oa?wa:va;ga=oa?va:wa;wa=(Oa|0)<(qa|0)?qa:Oa;d[Aa+(Ma<<1)>>1]=(ga|0)<(wa|0)?ga:wa;Ma=Ma+1|0}while((Ma|0)!=(ia|0));cc=ia}else cc=Na;if((ia|0)==(ja|0))break;if((cc|0)>(ca|0)){ia=ja;Na=cc;continue}else dc=cc;while(1){Ma=Ka+(dc<<1)|0;wa=d[Ma+(Fa<<1)>>1]|0;ga=d[Ma>>1]|0;Oa=d[Ma+(Ba<<1)>>1]|0;Ma=Ea+(dc<<1)|0;qa=d[Ma+(Fa<<1)>>1]|0;va=d[Ma>>1]|0;oa=d[Ma+(Ba<<1)>>1]|0;Ma=Ga+(dc<<1)|0;ua=d[Ma+(Fa<<1)>>1]|0;na=d[Ma>>1]|0;la=d[Ma+(Ba<<1)>>1]|0;Ma=(Oa&65535)<(ga&65535);pa=Ma?Oa:ga;ta=Ma?ga:Oa;Oa=(oa&65535)<(va&65535);ga=Oa?oa:va;Ma=Oa?va:oa;oa=(la&65535)<(na&65535);va=oa?la:na;Oa=oa?na:la;la=(pa&65535)<(wa&65535);na=(la?pa:wa)&65535;oa=la?wa:pa;pa=(ga&65535)<(qa&65535);wa=(pa?ga:qa)&65535;la=pa?qa:ga;ga=(va&65535)<(ua&65535);qa=(ga?va:ua)&65535;pa=ga?ua:va;va=(ta&65535)<(oa&65535);ua=(va?ta:oa)&65535;ga=(va?oa:ta)&65535;ta=(Ma&65535)<(la&65535);oa=ta?Ma:la;va=(ta?la:Ma)&65535;Ma=(Oa&65535)<(pa&65535);la=Ma?Oa:pa;ta=(Ma?pa:Oa)&65535;Oa=wa>>>0<na>>>0?na:wa;wa=ta>>>0<va>>>0?ta:va;va=(la&65535)<(oa&65535);ta=(va?la:oa)&65535;na=(va?oa:la)&65535;la=(qa|0)<(Oa|0)?Oa:qa;qa=ta>>>0<ua>>>0?ua:ta;ta=(wa|0)<(ga|0)?wa:ga;ga=(na|0)<(qa|0)?na:qa;qa=(ta|0)<(ga|0);na=qa?ta:ga;wa=qa?ga:ta;ta=(na|0)<(la|0)?la:na;d[Aa+(dc<<1)>>1]=(wa|0)<(ta|0)?wa:ta;ta=dc+1|0;if((dc|0)<(ca|0))dc=ta;else{ia=ja;Na=ta;continue f}}}if((Ca|0)==(za|0))break;else Aa=Aa+(Ia<<1)|0}break}case 5:{Aa=(za|0)==1;if((Ja|0)==1|Aa){Ca=za+Ja|0;ja=Ca+-1|0;ca=Aa?Ba:ka;Fa=Aa?0:ka-Ba|0;sa=Aa?Ba:Ia;if((Ca|0)<=1)break a;Aa=0-ca|0;Pa=Aa<<1;Na=Ca+-2|0;ia=Ca+-3|0;Ca=ca<<1;Ga=Ha;Ea=0;Ka=da;while(1){ta=(Ea|0)>0?Aa:0;wa=(Ea|0)>1?Pa:ta;na=(Ea|0)<(Na|0)?ca:0;la=(Ea|0)<(ia|0)?Ca:na;ga=Ka;qa=0;while(1){ua=d[ga+(wa<<1)>>1]|0;Oa=d[ga+(ta<<1)>>1]|0;oa=d[ga>>1]|0;va=d[ga+(na<<1)>>1]|0;pa=d[ga+(la<<1)>>1]|0;Ma=(Oa&65535)<(ua&65535);_a=(Ma?Oa:ua)&65535;xa=(Ma?ua:Oa)&65535;Oa=(pa&65535)<(va&65535);ua=Oa?pa:va;Ma=Oa?va:pa;pa=(ua&65535)<(oa&65535);va=(pa?ua:oa)&65535;Oa=pa?oa:ua;ua=(Ma&65535)<(Oa&65535);oa=(ua?Ma:Oa)&65535;pa=(ua?Oa:Ma)&65535;Ma=va>>>0<_a>>>0?_a:va;va=(pa|0)<(Ma|0)?pa:Ma;Ma=oa>>>0<xa>>>0?oa:xa;d[Ga+(qa<<1)>>1]=(va|0)<(Ma|0)?Ma:va;qa=qa+1|0;if((qa|0)==(Ba|0))break;else ga=ga+2|0}Ea=Ea+1|0;if((Ea|0)>=(ja|0))break a;else{Ga=Ga+(sa<<1)|0;Ka=Ka+(Ba<<1)+(Fa<<1)|0}}}Fa=Y(Ja,Ba)|0;if((za|0)<=0)break a;Ka=za+-1|0;sa=Ba<<1;Ga=0-sa|0;ja=Fa+~sa|0;Ea=(ra|-512)^511;Ca=Fa-Ba|0;ia=Fa-sa|0;ca=Ha;Na=0;while(1){Pa=Na+-2|0;Aa=da+((Y((Pa|0)>0?Pa:0,ka)|0)<<1)|0;Pa=Na+-1|0;ga=da+((Y((Pa|0)>0?Pa:0,ka)|0)<<1)|0;Pa=da+((Y(Na,ka)|0)<<1)|0;qa=Na;Na=Na+1|0;la=da+((Y((Ka|0)<(Na|0)?Ka:Na,ka)|0)<<1)|0;na=qa+2|0;qa=da+((Y((Ka|0)<(na|0)?Ka:na,ka)|0)<<1)|0;na=sa;ta=0;g:while(1){if((ta|0)<(na|0)){wa=ta;do{va=wa-((wa|0)>(ya|0)?Ba:0)|0;Ma=(wa|0)<(sa|0)?va:wa-sa|0;xa=((wa|0)<(Ca|0)?Ba:0)+wa|0;oa=(wa|0)<(ia|0)?wa+sa|0:xa;pa=d[Aa+(Ma<<1)>>1]|0;_a=d[Aa+(va<<1)>>1]|0;Oa=d[Aa+(wa<<1)>>1]|0;ua=d[Aa+(xa<<1)>>1]|0;jb=d[Aa+(oa<<1)>>1]|0;hb=d[ga+(Ma<<1)>>1]|0;db=d[ga+(va<<1)>>1]|0;Ua=d[ga+(wa<<1)>>1]|0;ab=d[ga+(xa<<1)>>1]|0;Ta=d[ga+(oa<<1)>>1]|0;bb=d[Pa+(Ma<<1)>>1]|0;cb=d[Pa+(va<<1)>>1]|0;La=d[Pa+(wa<<1)>>1]|0;Xa=d[Pa+(xa<<1)>>1]|0;Ya=d[Pa+(oa<<1)>>1]|0;mb=d[la+(Ma<<1)>>1]|0;$a=d[la+(va<<1)>>1]|0;lb=d[la+(wa<<1)>>1]|0;kb=d[la+(xa<<1)>>1]|0;Gb=d[la+(oa<<1)>>1]|0;nb=d[qa+(Ma<<1)>>1]|0;Ma=d[qa+(va<<1)>>1]|0;va=d[qa+(wa<<1)>>1]|0;ob=d[qa+(xa<<1)>>1]|0;xa=d[qa+(oa<<1)>>1]|0;oa=(Oa&65535)<(_a&65535)?Oa:_a;Fb=(Oa&65535)>(_a&65535)?Oa:_a;_a=(oa&65535)<(pa&65535);Oa=_a?oa:pa;Eb=_a?pa:oa;oa=(Fb&65535)<(Eb&65535);pa=oa?Fb:Eb;_a=oa?Eb:Fb;Fb=(hb&65535)<(jb&65535);Eb=Fb?hb:jb;oa=Fb?jb:hb;hb=(Eb&65535)<(ua&65535);jb=hb?Eb:ua;Fb=hb?ua:Eb;Eb=(oa&65535)<(Fb&65535);ua=Eb?oa:Fb;hb=Eb?Fb:oa;oa=(jb&65535)<(Oa&65535);Fb=oa?jb:Oa;Eb=oa?Oa:jb;jb=(hb&65535)<(_a&65535);Oa=jb?hb:_a;oa=jb?_a:hb;hb=(Eb&65535)<(Oa&65535);_a=hb?Eb:Oa;jb=hb?Oa:Eb;Eb=(ua&65535)<(pa&65535);Oa=Eb?ua:pa;hb=Eb?pa:ua;ua=(_a&65535)<(Oa&65535);pa=ua?_a:Oa;Eb=ua?Oa:_a;_a=(hb&65535)<(jb&65535);Oa=_a?hb:jb;ua=_a?jb:hb;hb=(ab&65535)<(Ua&65535);jb=hb?ab:Ua;_a=hb?Ua:ab;ab=(jb&65535)<(db&65535);Ua=ab?jb:db;hb=ab?db:jb;jb=(_a&65535)<(hb&65535);db=jb?_a:hb;ab=jb?hb:_a;_a=(cb&65535)<(bb&65535);hb=_a?cb:bb;jb=_a?bb:cb;cb=(hb&65535)<(Ta&65535);bb=cb?hb:Ta;_a=cb?Ta:hb;hb=(jb&65535)<(_a&65535);Ta=hb?jb:_a;cb=hb?_a:jb;jb=(bb&65535)<(Ua&65535);_a=jb?bb:Ua;hb=jb?Ua:bb;bb=(cb&65535)<(ab&65535);Ua=bb?cb:ab;jb=bb?ab:cb;cb=(hb&65535)<(Ua&65535);ab=cb?hb:Ua;bb=cb?Ua:hb;hb=(Ta&65535)<(db&65535);Ua=hb?Ta:db;cb=hb?db:Ta;Ta=(ab&65535)<(Ua&65535);db=Ta?ab:Ua;hb=Ta?Ua:ab;ab=(cb&65535)<(bb&65535);Ua=ab?cb:bb;Ta=ab?bb:cb;cb=(_a&65535)<(Fb&65535);bb=(cb?_a:Fb)&65535;ab=cb?Fb:_a;_a=(Ta&65535)<(ua&65535);Fb=_a?Ta:ua;cb=_a?ua:Ta;Ta=(ab&65535)<(Fb&65535);ua=Ta?ab:Fb;_a=Ta?Fb:ab;ab=(hb&65535)<(Eb&65535);Fb=ab?hb:Eb;Ta=ab?Eb:hb;hb=(ua&65535)<(Fb&65535);Eb=hb?ua:Fb;ab=hb?Fb:ua;ua=(Ta&65535)<(_a&65535);Fb=ua?Ta:_a;hb=ua?_a:Ta;Ta=(db&65535)<(pa&65535);_a=Ta?db:pa;ua=Ta?pa:db;db=(jb&65535)<(oa&65535);pa=db?jb:oa;Ta=(db?oa:jb)&65535;jb=(ua&65535)<(pa&65535);oa=jb?ua:pa;db=jb?pa:ua;ua=(Ua&65535)<(Oa&65535);pa=ua?Ua:Oa;jb=ua?Oa:Ua;Ua=(oa&65535)<(pa&65535);Oa=Ua?oa:pa;ua=Ua?pa:oa;oa=(jb&65535)<(db&65535);pa=oa?jb:db;Ua=oa?db:jb;jb=(Eb&65535)<(_a&65535);db=(jb?Eb:_a)&65535;oa=(jb?_a:Eb)&65535;Eb=(ab&65535)<(Oa&65535);_a=(Eb?ab:Oa)&65535;jb=(Eb?Oa:ab)&65535;ab=(Fb&65535)<(ua&65535);Oa=(ab?Fb:ua)&65535;Eb=(ab?ua:Fb)&65535;Fb=(hb&65535)<(pa&65535);ua=(Fb?hb:pa)&65535;ab=(Fb?pa:hb)&65535;hb=(cb&65535)<(Ua&65535);pa=(hb?cb:Ua)&65535;Fb=(hb?Ua:cb)&65535;cb=(Ya&65535)<(Xa&65535);Ua=cb?Ya:Xa;hb=cb?Xa:Ya;Ya=(Ua&65535)<(La&65535);Xa=Ya?Ua:La;cb=Ya?La:Ua;Ua=(hb&65535)<(cb&65535);La=Ua?hb:cb;Ya=Ua?cb:hb;hb=(lb&65535)<($a&65535);cb=hb?lb:$a;Ua=hb?$a:lb;lb=(cb&65535)<(mb&65535);$a=lb?cb:mb;hb=lb?mb:cb;cb=(Ua&65535)<(hb&65535);mb=cb?Ua:hb;lb=cb?hb:Ua;Ua=($a&65535)<(Xa&65535);hb=Ua?$a:Xa;cb=Ua?Xa:$a;$a=(lb&65535)<(Ya&65535);Xa=$a?lb:Ya;Ua=$a?Ya:lb;lb=(cb&65535)<(Xa&65535);Ya=lb?cb:Xa;$a=lb?Xa:cb;cb=(mb&65535)<(La&65535);Xa=cb?mb:La;lb=cb?La:mb;mb=(Ya&65535)<(Xa&65535);La=mb?Ya:Xa;cb=mb?Xa:Ya;Ya=(lb&65535)<($a&65535);Xa=Ya?lb:$a;mb=Ya?$a:lb;lb=(nb&65535)<(Gb&65535);$a=lb?nb:Gb;Ya=lb?Gb:nb;nb=($a&65535)<(kb&65535);Gb=nb?$a:kb;lb=nb?kb:$a;$a=(Ya&65535)<(lb&65535);kb=$a?Ya:lb;nb=$a?lb:Ya;Ya=(va&65535)<(Ma&65535);lb=Ya?va:Ma;$a=Ya?Ma:va;va=(xa&65535)<(ob&65535);Ma=va?xa:ob;Ya=va?ob:xa;xa=(Ma&65535)<(lb&65535);ob=xa?Ma:lb;va=xa?lb:Ma;Ma=(Ya&65535)<($a&65535);lb=Ma?Ya:$a;xa=Ma?$a:Ya;Ya=(va&65535)<(lb&65535);$a=Ya?va:lb;Ma=Ya?lb:va;va=(ob&65535)<(Gb&65535);lb=va?ob:Gb;Ya=va?Gb:ob;ob=(Ma&65535)<(nb&65535);Gb=ob?Ma:nb;va=ob?nb:Ma;Ma=(Ya&65535)<(Gb&65535);nb=Ma?Ya:Gb;ob=Ma?Gb:Ya;Ya=($a&65535)<(kb&65535);Gb=Ya?$a:kb;Ma=Ya?kb:$a;$a=(xa&65535)<(Ma&65535);kb=$a?xa:Ma;Ya=$a?Ma:xa;xa=(nb&65535)<(Gb&65535);Ma=xa?nb:Gb;$a=xa?Gb:nb;nb=(kb&65535)<(ob&65535);Gb=nb?kb:ob;xa=nb?ob:kb;kb=(Ya&65535)<(va&65535);ob=kb?Ya:va;nb=kb?va:Ya;Ya=(lb&65535)<(hb&65535);va=(Ya?lb:hb)&65535;kb=Ya?hb:lb;lb=(xa&65535)<(mb&65535);hb=lb?xa:mb;Ya=lb?mb:xa;xa=(kb&65535)<(hb&65535);mb=xa?kb:hb;lb=xa?hb:kb;kb=($a&65535)<(cb&65535);hb=kb?$a:cb;xa=kb?cb:$a;$a=(nb&65535)<(xa&65535);cb=$a?nb:xa;kb=$a?xa:nb;nb=(mb&65535)<(hb&65535);xa=nb?mb:hb;$a=nb?hb:mb;mb=(cb&65535)<(lb&65535);hb=mb?cb:lb;nb=mb?lb:cb;cb=(kb&65535)<(Ya&65535);lb=cb?kb:Ya;mb=cb?Ya:kb;kb=(Ma&65535)<(La&65535);Ya=kb?Ma:La;cb=kb?La:Ma;Ma=(ob&65535)<(Ua&65535);La=Ma?ob:Ua;kb=Ma?Ua:ob;ob=(cb&65535)<(La&65535);Ua=ob?cb:La;Ma=ob?La:cb;cb=(Gb&65535)<(Xa&65535);La=cb?Gb:Xa;ob=cb?Xa:Gb;Gb=(Ua&65535)<(La&65535);Xa=Gb?Ua:La;cb=Gb?La:Ua;Ua=(ob&65535)<(Ma&65535);La=Ua?ob:Ma;Gb=Ua?Ma:ob;ob=(xa&65535)<(Ya&65535);Ma=(ob?xa:Ya)&65535;Ua=(ob?Ya:xa)&65535;xa=($a&65535)<(Xa&65535);Ya=(xa?$a:Xa)&65535;ob=(xa?Xa:$a)&65535;$a=(hb&65535)<(cb&65535);Xa=($a?hb:cb)&65535;xa=($a?cb:hb)&65535;hb=(nb&65535)<(La&65535);cb=(hb?nb:La)&65535;$a=(hb?La:nb)&65535;nb=(lb&65535)<(Gb&65535);La=(nb?lb:Gb)&65535;hb=(nb?Gb:lb)&65535;lb=(mb&65535)<(kb&65535);Gb=(lb?mb:kb)&65535;nb=(lb?kb:mb)&65535;mb=va>>>0<bb>>>0?bb:va;va=$a>>>0<ab>>>0?$a:ab;ab=(mb|0)<(va|0)?va:mb;mb=ob>>>0<jb>>>0?jb:ob;ob=(nb|0)<(mb|0)?nb:mb;mb=(ob|0)<(ab|0)?ob:ab;ab=Ua>>>0<oa>>>0?oa:Ua;Ua=hb>>>0<Fb>>>0?hb:Fb;Fb=(ab|0)<(Ua|0)?ab:Ua;Ua=xa>>>0<Eb>>>0?xa:Eb;Eb=(Fb|0)<(Ua|0)?Ua:Fb;Fb=(mb|0)<(Eb|0)?Eb:mb;mb=Ma>>>0<db>>>0?db:Ma;Ma=La>>>0<pa>>>0?La:pa;pa=(mb|0)<(Ma|0)?Ma:mb;mb=Xa>>>0<Oa>>>0?Oa:Xa;Xa=(mb|0)<(pa|0)?mb:pa;pa=Ya>>>0<_a>>>0?_a:Ya;Ya=Gb>>>0<Ta>>>0?Gb:Ta;Ta=(pa|0)<(Ya|0)?pa:Ya;Ya=cb>>>0<ua>>>0?cb:ua;ua=(Ta|0)<(Ya|0)?Ya:Ta;Ta=(Xa|0)<(ua|0)?Xa:ua;d[ca+(wa<<1)>>1]=(Fb|0)<(Ta|0)?Ta:Fb;wa=wa+1|0}while((wa|0)!=(na|0));ec=na}else ec=ta;if((na|0)==(Fa|0))break;if((ec|0)>(ja|0)){na=Fa;ta=ec;continue}else fc=ec;while(1){wa=Aa+(fc<<1)|0;Fb=d[wa+(Ga<<1)>>1]|0;Ta=d[wa+(Ea<<1)>>1]|0;ua=d[wa>>1]|0;Xa=d[wa+(Ba<<1)>>1]|0;Ya=d[wa+(sa<<1)>>1]|0;wa=ga+(fc<<1)|0;cb=d[wa+(Ga<<1)>>1]|0;pa=d[wa+(Ea<<1)>>1]|0;Gb=d[wa>>1]|0;_a=d[wa+(Ba<<1)>>1]|0;mb=d[wa+(sa<<1)>>1]|0;wa=Pa+(fc<<1)|0;Oa=d[wa+(Ga<<1)>>1]|0;Ma=d[wa+(Ea<<1)>>1]|0;La=d[wa>>1]|0;db=d[wa+(Ba<<1)>>1]|0;Eb=d[wa+(sa<<1)>>1]|0;wa=la+(fc<<1)|0;Ua=d[wa+(Ga<<1)>>1]|0;xa=d[wa+(Ea<<1)>>1]|0;ab=d[wa>>1]|0;hb=d[wa+(Ba<<1)>>1]|0;oa=d[wa+(sa<<1)>>1]|0;wa=qa+(fc<<1)|0;ob=d[wa+(Ga<<1)>>1]|0;nb=d[wa+(Ea<<1)>>1]|0;jb=d[wa>>1]|0;va=d[wa+(Ba<<1)>>1]|0;$a=d[wa+(sa<<1)>>1]|0;wa=(ua&65535)<(Ta&65535)?ua:Ta;bb=(ua&65535)>(Ta&65535)?ua:Ta;Ta=(wa&65535)<(Fb&65535);ua=Ta?wa:Fb;kb=Ta?Fb:wa;wa=(bb&65535)<(kb&65535);Fb=wa?bb:kb;Ta=wa?kb:bb;bb=(cb&65535)<(Ya&65535);kb=bb?cb:Ya;wa=bb?Ya:cb;cb=(kb&65535)<(Xa&65535);Ya=cb?kb:Xa;bb=cb?Xa:kb;kb=(wa&65535)<(bb&65535);Xa=kb?wa:bb;cb=kb?bb:wa;wa=(Ya&65535)<(ua&65535);bb=wa?Ya:ua;kb=wa?ua:Ya;Ya=(cb&65535)<(Ta&65535);ua=Ya?cb:Ta;wa=Ya?Ta:cb;cb=(kb&65535)<(ua&65535);Ta=cb?kb:ua;Ya=cb?ua:kb;kb=(Xa&65535)<(Fb&65535);ua=kb?Xa:Fb;cb=kb?Fb:Xa;Xa=(Ta&65535)<(ua&65535);Fb=Xa?Ta:ua;kb=Xa?ua:Ta;Ta=(cb&65535)<(Ya&65535);ua=Ta?cb:Ya;Xa=Ta?Ya:cb;cb=(_a&65535)<(Gb&65535);Ya=cb?_a:Gb;Ta=cb?Gb:_a;_a=(Ya&65535)<(pa&65535);Gb=_a?Ya:pa;cb=_a?pa:Ya;Ya=(Ta&65535)<(cb&65535);pa=Ya?Ta:cb;_a=Ya?cb:Ta;Ta=(Ma&65535)<(Oa&65535);cb=Ta?Ma:Oa;Ya=Ta?Oa:Ma;Ma=(cb&65535)<(mb&65535);Oa=Ma?cb:mb;Ta=Ma?mb:cb;cb=(Ya&65535)<(Ta&65535);mb=cb?Ya:Ta;Ma=cb?Ta:Ya;Ya=(Oa&65535)<(Gb&65535);Ta=Ya?Oa:Gb;cb=Ya?Gb:Oa;Oa=(Ma&65535)<(_a&65535);Gb=Oa?Ma:_a;Ya=Oa?_a:Ma;Ma=(cb&65535)<(Gb&65535);_a=Ma?cb:Gb;Oa=Ma?Gb:cb;cb=(mb&65535)<(pa&65535);Gb=cb?mb:pa;Ma=cb?pa:mb;mb=(_a&65535)<(Gb&65535);pa=mb?_a:Gb;cb=mb?Gb:_a;_a=(Ma&65535)<(Oa&65535);Gb=_a?Ma:Oa;mb=_a?Oa:Ma;Ma=(Ta&65535)<(bb&65535);Oa=(Ma?Ta:bb)&65535;_a=Ma?bb:Ta;Ta=(mb&65535)<(Xa&65535);bb=Ta?mb:Xa;Ma=Ta?Xa:mb;mb=(_a&65535)<(bb&65535);Xa=mb?_a:bb;Ta=mb?bb:_a;_a=(cb&65535)<(kb&65535);bb=_a?cb:kb;mb=_a?kb:cb;cb=(Xa&65535)<(bb&65535);kb=cb?Xa:bb;_a=cb?bb:Xa;Xa=(mb&65535)<(Ta&65535);bb=Xa?mb:Ta;cb=Xa?Ta:mb;mb=(pa&65535)<(Fb&65535);Ta=mb?pa:Fb;Xa=mb?Fb:pa;pa=(Ya&65535)<(wa&65535);Fb=pa?Ya:wa;mb=(pa?wa:Ya)&65535;Ya=(Xa&65535)<(Fb&65535);wa=Ya?Xa:Fb;pa=Ya?Fb:Xa;Xa=(Gb&65535)<(ua&65535);Fb=Xa?Gb:ua;Ya=Xa?ua:Gb;Gb=(wa&65535)<(Fb&65535);ua=Gb?wa:Fb;Xa=Gb?Fb:wa;wa=(Ya&65535)<(pa&65535);Fb=wa?Ya:pa;Gb=wa?pa:Ya;Ya=(kb&65535)<(Ta&65535);pa=(Ya?kb:Ta)&65535;wa=(Ya?Ta:kb)&65535;kb=(_a&65535)<(ua&65535);Ta=(kb?_a:ua)&65535;Ya=(kb?ua:_a)&65535;_a=(bb&65535)<(Xa&65535);ua=(_a?bb:Xa)&65535;kb=(_a?Xa:bb)&65535;bb=(cb&65535)<(Fb&65535);Xa=(bb?cb:Fb)&65535;_a=(bb?Fb:cb)&65535;cb=(Ma&65535)<(Gb&65535);Fb=(cb?Ma:Gb)&65535;bb=(cb?Gb:Ma)&65535;Ma=(Eb&65535)<(db&65535);Gb=Ma?Eb:db;cb=Ma?db:Eb;Eb=(Gb&65535)<(La&65535);db=Eb?Gb:La;Ma=Eb?La:Gb;Gb=(cb&65535)<(Ma&65535);La=Gb?cb:Ma;Eb=Gb?Ma:cb;cb=(ab&65535)<(xa&65535);Ma=cb?ab:xa;Gb=cb?xa:ab;ab=(Ma&65535)<(Ua&65535);xa=ab?Ma:Ua;cb=ab?Ua:Ma;Ma=(Gb&65535)<(cb&65535);Ua=Ma?Gb:cb;ab=Ma?cb:Gb;Gb=(xa&65535)<(db&65535);cb=Gb?xa:db;Ma=Gb?db:xa;xa=(ab&65535)<(Eb&65535);db=xa?ab:Eb;Gb=xa?Eb:ab;ab=(Ma&65535)<(db&65535);Eb=ab?Ma:db;xa=ab?db:Ma;Ma=(Ua&65535)<(La&65535);db=Ma?Ua:La;ab=Ma?La:Ua;Ua=(Eb&65535)<(db&65535);La=Ua?Eb:db;Ma=Ua?db:Eb;Eb=(ab&65535)<(xa&65535);db=Eb?ab:xa;Ua=Eb?xa:ab;ab=(ob&65535)<(oa&65535);xa=ab?ob:oa;Eb=ab?oa:ob;ob=(xa&65535)<(hb&65535);oa=ob?xa:hb;ab=ob?hb:xa;xa=(Eb&65535)<(ab&65535);hb=xa?Eb:ab;ob=xa?ab:Eb;Eb=(jb&65535)<(nb&65535);ab=Eb?jb:nb;xa=Eb?nb:jb;jb=($a&65535)<(va&65535);nb=jb?$a:va;Eb=jb?va:$a;$a=(nb&65535)<(ab&65535);va=$a?nb:ab;jb=$a?ab:nb;nb=(Eb&65535)<(xa&65535);ab=nb?Eb:xa;$a=nb?xa:Eb;Eb=(jb&65535)<(ab&65535);xa=Eb?jb:ab;nb=Eb?ab:jb;jb=(va&65535)<(oa&65535);ab=jb?va:oa;Eb=jb?oa:va;va=(nb&65535)<(ob&65535);oa=va?nb:ob;jb=va?ob:nb;nb=(Eb&65535)<(oa&65535);ob=nb?Eb:oa;va=nb?oa:Eb;Eb=(xa&65535)<(hb&65535);oa=Eb?xa:hb;nb=Eb?hb:xa;xa=($a&65535)<(nb&65535);hb=xa?$a:nb;Eb=xa?nb:$a;$a=(ob&65535)<(oa&65535);nb=$a?ob:oa;xa=$a?oa:ob;ob=(hb&65535)<(va&65535);oa=ob?hb:va;$a=ob?va:hb;hb=(Eb&65535)<(jb&65535);va=hb?Eb:jb;ob=hb?jb:Eb;Eb=(ab&65535)<(cb&65535);jb=(Eb?ab:cb)&65535;hb=Eb?cb:ab;ab=($a&65535)<(Ua&65535);cb=ab?$a:Ua;Eb=ab?Ua:$a;$a=(hb&65535)<(cb&65535);Ua=$a?hb:cb;ab=$a?cb:hb;hb=(xa&65535)<(Ma&65535);cb=hb?xa:Ma;$a=hb?Ma:xa;xa=(ob&65535)<($a&65535);Ma=xa?ob:$a;hb=xa?$a:ob;ob=(Ua&65535)<(cb&65535);$a=ob?Ua:cb;xa=ob?cb:Ua;Ua=(Ma&65535)<(ab&65535);cb=Ua?Ma:ab;ob=Ua?ab:Ma;Ma=(hb&65535)<(Eb&65535);ab=Ma?hb:Eb;Ua=Ma?Eb:hb;hb=(nb&65535)<(La&65535);Eb=hb?nb:La;Ma=hb?La:nb;nb=(va&65535)<(Gb&65535);La=nb?va:Gb;hb=nb?Gb:va;va=(Ma&65535)<(La&65535);Gb=va?Ma:La;nb=va?La:Ma;Ma=(oa&65535)<(db&65535);La=Ma?oa:db;va=Ma?db:oa;oa=(Gb&65535)<(La&65535);db=oa?Gb:La;Ma=oa?La:Gb;Gb=(va&65535)<(nb&65535);La=Gb?va:nb;oa=Gb?nb:va;va=($a&65535)<(Eb&65535);nb=(va?$a:Eb)&65535;Gb=(va?Eb:$a)&65535;$a=(xa&65535)<(db&65535);Eb=($a?xa:db)&65535;va=($a?db:xa)&65535;xa=(cb&65535)<(Ma&65535);db=(xa?cb:Ma)&65535;$a=(xa?Ma:cb)&65535;cb=(ob&65535)<(La&65535);Ma=(cb?ob:La)&65535;xa=(cb?La:ob)&65535;ob=(ab&65535)<(oa&65535);La=(ob?ab:oa)&65535;cb=(ob?oa:ab)&65535;ab=(Ua&65535)<(hb&65535);oa=(ab?Ua:hb)&65535;ob=(ab?hb:Ua)&65535;Ua=jb>>>0<Oa>>>0?Oa:jb;jb=xa>>>0<_a>>>0?xa:_a;_a=(Ua|0)<(jb|0)?jb:Ua;Ua=va>>>0<Ya>>>0?Ya:va;va=(ob|0)<(Ua|0)?ob:Ua;Ua=(va|0)<(_a|0)?va:_a;_a=Gb>>>0<wa>>>0?wa:Gb;Gb=cb>>>0<bb>>>0?cb:bb;bb=(_a|0)<(Gb|0)?_a:Gb;Gb=$a>>>0<kb>>>0?$a:kb;kb=(bb|0)<(Gb|0)?Gb:bb;bb=(Ua|0)<(kb|0)?kb:Ua;Ua=nb>>>0<pa>>>0?pa:nb;nb=La>>>0<Fb>>>0?La:Fb;Fb=(Ua|0)<(nb|0)?nb:Ua;Ua=db>>>0<ua>>>0?ua:db;db=(Ua|0)<(Fb|0)?Ua:Fb;Fb=Eb>>>0<Ta>>>0?Ta:Eb;Eb=oa>>>0<mb>>>0?oa:mb;mb=(Fb|0)<(Eb|0)?Fb:Eb;Eb=Ma>>>0<Xa>>>0?Ma:Xa;Xa=(mb|0)<(Eb|0)?Eb:mb;mb=(db|0)<(Xa|0)?db:Xa;d[ca+(fc<<1)>>1]=(bb|0)<(mb|0)?mb:bb;bb=fc+1|0;if((fc|0)<(ja|0))fc=bb;else{na=Fa;ta=bb;continue g}}}if((Na|0)==(za|0))break;else ca=ca+(Ia<<1)|0}break}default:break a}break}case 3:{Ia=f[O+16>>2]|0;ca=f[aa>>2]|0;za=(f[V>>2]|0)>>>1;Na=(f[N+48>>2]|0)>>>1;Fa=f[N+40>>2]|0;ja=f[Fa+4>>2]|0;sa=f[Fa>>2]|0;Fa=Da>>>3;Ba=Fa&511;Ea=Ba+1|0;switch(e|0){case 3:{Ga=(sa|0)==1;if((ja|0)==1|Ga){ia=sa+ja|0;Ca=ia+-1|0;ya=Ga?Ea:za;ka=Ga?0:za-Ea|0;Ka=Ga?Ea:Na;if((ia|0)<=1)break a;Ga=0-ya|0;da=ia+-2|0;ia=ca;Ha=0;ra=Ia;while(1){Ja=(Ha|0)>0?Ga:0;ta=(Ha|0)<(da|0)?ya:0;na=0;qa=ra;while(1){la=d[qa+(Ja<<1)>>1]|0;Pa=d[qa>>1]|0;ga=d[qa+(ta<<1)>>1]|0;Aa=Pa<<16>>16<la<<16>>16;bb=(Aa?Pa:la)<<16>>16;mb=(Aa?la:Pa)<<16>>16;Pa=(ga|0)<(mb|0)?ga:mb;d[ia+(na<<1)>>1]=(Pa|0)<(bb|0)?bb:Pa;na=na+1|0;if((na|0)==(Ea|0))break;else qa=qa+2|0}Ha=Ha+1|0;if((Ha|0)>=(Ca|0))break a;else{ia=ia+(Ka<<1)|0;ra=ra+(Ea<<1)+(ka<<1)|0}}}ka=Y(ja,Ea)|0;if((sa|0)<=0)break a;ra=sa+-1|0;Ka=(Fa|-512)^511;ia=Ka+-1+ka|0;Ca=ka-Ea|0;Ha=ca;ya=0;while(1){da=ya+-1|0;Ga=Ia+((Y((da|0)>0?da:0,za)|0)<<1)|0;da=Ia+((Y(ya,za)|0)<<1)|0;ya=ya+1|0;qa=Ia+((Y((ra|0)<(ya|0)?ra:ya,za)|0)<<1)|0;na=Ea;ta=0;h:while(1){if((ta|0)<(na|0)){Ja=ta;do{Pa=Ja-((Ja|0)>(Ba|0)?Ea:0)|0;bb=((Ja|0)<(Ca|0)?Ea:0)+Ja|0;mb=d[Ga+(Pa<<1)>>1]|0;ga=d[Ga+(Ja<<1)>>1]|0;la=d[Ga+(bb<<1)>>1]|0;Aa=d[da+(Pa<<1)>>1]|0;Xa=d[da+(Ja<<1)>>1]|0;db=d[da+(bb<<1)>>1]|0;Eb=d[qa+(Pa<<1)>>1]|0;Pa=d[qa+(Ja<<1)>>1]|0;Ma=d[qa+(bb<<1)>>1]|0;bb=la<<16>>16<ga<<16>>16;Fb=bb?la:ga;oa=bb?ga:la;la=db<<16>>16<Xa<<16>>16;ga=la?db:Xa;bb=la?Xa:db;db=Ma<<16>>16<Pa<<16>>16;Xa=db?Ma:Pa;la=db?Pa:Ma;Ma=Fb<<16>>16<mb<<16>>16;Pa=(Ma?Fb:mb)<<16>>16;db=Ma?mb:Fb;Fb=ga<<16>>16<Aa<<16>>16;mb=(Fb?ga:Aa)<<16>>16;Ma=Fb?Aa:ga;ga=Xa<<16>>16<Eb<<16>>16;Aa=(ga?Xa:Eb)<<16>>16;Fb=ga?Eb:Xa;Xa=oa<<16>>16<db<<16>>16;Eb=(Xa?oa:db)<<16>>16;ga=(Xa?db:oa)<<16>>16;oa=bb<<16>>16<Ma<<16>>16;db=oa?bb:Ma;Xa=(oa?Ma:bb)<<16>>16;bb=la<<16>>16<Fb<<16>>16;Ma=bb?la:Fb;oa=(bb?Fb:la)<<16>>16;la=(mb|0)<(Pa|0)?Pa:mb;mb=(oa|0)<(Xa|0)?oa:Xa;Xa=Ma<<16>>16<db<<16>>16;oa=(Xa?Ma:db)<<16>>16;Pa=(Xa?db:Ma)<<16>>16;Ma=(Aa|0)<(la|0)?la:Aa;Aa=(oa|0)<(Eb|0)?Eb:oa;oa=(mb|0)<(ga|0)?mb:ga;ga=(Pa|0)<(Aa|0)?Pa:Aa;Aa=(oa|0)<(ga|0);Pa=Aa?oa:ga;mb=Aa?ga:oa;oa=(Pa|0)<(Ma|0)?Ma:Pa;d[Ha+(Ja<<1)>>1]=(mb|0)<(oa|0)?mb:oa;Ja=Ja+1|0}while((Ja|0)!=(na|0));gc=na}else gc=ta;if((na|0)==(ka|0))break;if((gc|0)>(ia|0)){na=ka;ta=gc;continue}else hc=gc;while(1){Ja=Ga+(hc<<1)|0;oa=d[Ja+(Ka<<1)>>1]|0;mb=d[Ja>>1]|0;Pa=d[Ja+(Ea<<1)>>1]|0;Ja=da+(hc<<1)|0;Ma=d[Ja+(Ka<<1)>>1]|0;ga=d[Ja>>1]|0;Aa=d[Ja+(Ea<<1)>>1]|0;Ja=qa+(hc<<1)|0;Eb=d[Ja+(Ka<<1)>>1]|0;la=d[Ja>>1]|0;db=d[Ja+(Ea<<1)>>1]|0;Ja=Pa<<16>>16<mb<<16>>16;Xa=Ja?Pa:mb;Fb=Ja?mb:Pa;Pa=Aa<<16>>16<ga<<16>>16;mb=Pa?Aa:ga;Ja=Pa?ga:Aa;Aa=db<<16>>16<la<<16>>16;ga=Aa?db:la;Pa=Aa?la:db;db=Xa<<16>>16<oa<<16>>16;la=(db?Xa:oa)<<16>>16;Aa=db?oa:Xa;Xa=mb<<16>>16<Ma<<16>>16;oa=(Xa?mb:Ma)<<16>>16;db=Xa?Ma:mb;mb=ga<<16>>16<Eb<<16>>16;Ma=(mb?ga:Eb)<<16>>16;Xa=mb?Eb:ga;ga=Fb<<16>>16<Aa<<16>>16;Eb=(ga?Fb:Aa)<<16>>16;mb=(ga?Aa:Fb)<<16>>16;Fb=Ja<<16>>16<db<<16>>16;Aa=Fb?Ja:db;ga=(Fb?db:Ja)<<16>>16;Ja=Pa<<16>>16<Xa<<16>>16;db=Ja?Pa:Xa;Fb=(Ja?Xa:Pa)<<16>>16;Pa=(oa|0)<(la|0)?la:oa;oa=(Fb|0)<(ga|0)?Fb:ga;ga=db<<16>>16<Aa<<16>>16;Fb=(ga?db:Aa)<<16>>16;la=(ga?Aa:db)<<16>>16;db=(Ma|0)<(Pa|0)?Pa:Ma;Ma=(Fb|0)<(Eb|0)?Eb:Fb;Fb=(oa|0)<(mb|0)?oa:mb;mb=(la|0)<(Ma|0)?la:Ma;Ma=(Fb|0)<(mb|0);la=Ma?Fb:mb;oa=Ma?mb:Fb;Fb=(la|0)<(db|0)?db:la;d[Ha+(hc<<1)>>1]=(oa|0)<(Fb|0)?oa:Fb;Fb=hc+1|0;if((hc|0)<(ia|0))hc=Fb;else{na=ka;ta=Fb;continue h}}}if((ya|0)==(sa|0))break;else Ha=Ha+(Na<<1)|0}break}case 5:{Ha=(sa|0)==1;if((ja|0)==1|Ha){ya=sa+ja|0;ka=ya+-1|0;ia=Ha?Ea:za;Ka=Ha?0:za-Ea|0;Ca=Ha?Ea:Na;if((ya|0)<=1)break a;Ha=0-ia|0;ra=Ha<<1;ta=ya+-2|0;na=ya+-3|0;ya=ia<<1;qa=ca;da=0;Ga=Ia;while(1){Fb=(da|0)>0?Ha:0;oa=(da|0)>1?ra:Fb;la=(da|0)<(ta|0)?ia:0;db=(da|0)<(na|0)?ya:la;mb=Ga;Ma=0;while(1){Eb=d[mb+(oa<<1)>>1]|0;Pa=d[mb+(Fb<<1)>>1]|0;Aa=d[mb>>1]|0;ga=d[mb+(la<<1)>>1]|0;Xa=d[mb+(db<<1)>>1]|0;Ja=Pa<<16>>16<Eb<<16>>16;bb=(Ja?Pa:Eb)<<16>>16;Ta=(Ja?Eb:Pa)<<16>>16;Pa=Xa<<16>>16<ga<<16>>16;Eb=Pa?Xa:ga;Ja=Pa?ga:Xa;Xa=Eb<<16>>16<Aa<<16>>16;ga=(Xa?Eb:Aa)<<16>>16;Pa=Xa?Aa:Eb;Eb=Ja<<16>>16<Pa<<16>>16;Aa=(Eb?Ja:Pa)<<16>>16;Xa=(Eb?Pa:Ja)<<16>>16;Ja=(ga|0)<(bb|0)?bb:ga;ga=(Xa|0)<(Ja|0)?Xa:Ja;Ja=(Aa|0)<(Ta|0)?Aa:Ta;d[qa+(Ma<<1)>>1]=(ga|0)<(Ja|0)?Ja:ga;Ma=Ma+1|0;if((Ma|0)==(Ea|0))break;else mb=mb+2|0}da=da+1|0;if((da|0)>=(ka|0))break a;else{qa=qa+(Ca<<1)|0;Ga=Ga+(Ea<<1)+(Ka<<1)|0}}}Ka=Y(ja,Ea)|0;if((sa|0)<=0)break a;Ga=sa+-1|0;Ca=Ea<<1;qa=0-Ca|0;ka=Ka+~Ca|0;da=(Fa|-512)^511;ya=Ka-Ea|0;na=Ka-Ca|0;ia=ca;ta=0;while(1){ra=ta+-2|0;Ha=Ia+((Y((ra|0)>0?ra:0,za)|0)<<1)|0;ra=ta+-1|0;mb=Ia+((Y((ra|0)>0?ra:0,za)|0)<<1)|0;ra=Ia+((Y(ta,za)|0)<<1)|0;Ma=ta;ta=ta+1|0;db=Ia+((Y((Ga|0)<(ta|0)?Ga:ta,za)|0)<<1)|0;la=Ma+2|0;Ma=Ia+((Y((Ga|0)<(la|0)?Ga:la,za)|0)<<1)|0;la=Ca;Fb=0;i:while(1){if((Fb|0)<(la|0)){oa=Fb;do{ga=oa-((oa|0)>(Ba|0)?Ea:0)|0;Ja=(oa|0)<(Ca|0)?ga:oa-Ca|0;Ta=((oa|0)<(ya|0)?Ea:0)+oa|0;Aa=(oa|0)<(na|0)?oa+Ca|0:Ta;Xa=d[Ha+(Ja<<1)>>1]|0;bb=d[Ha+(ga<<1)>>1]|0;Pa=d[Ha+(oa<<1)>>1]|0;Eb=d[Ha+(Ta<<1)>>1]|0;Ua=d[Ha+(Aa<<1)>>1]|0;ua=d[mb+(Ja<<1)>>1]|0;nb=d[mb+(ga<<1)>>1]|0;La=d[mb+(oa<<1)>>1]|0;pa=d[mb+(Ta<<1)>>1]|0;kb=d[mb+(Aa<<1)>>1]|0;Gb=d[ra+(Ja<<1)>>1]|0;$a=d[ra+(ga<<1)>>1]|0;_a=d[ra+(oa<<1)>>1]|0;cb=d[ra+(Ta<<1)>>1]|0;wa=d[ra+(Aa<<1)>>1]|0;va=d[db+(Ja<<1)>>1]|0;ob=d[db+(ga<<1)>>1]|0;Ya=d[db+(oa<<1)>>1]|0;jb=d[db+(Ta<<1)>>1]|0;xa=d[db+(Aa<<1)>>1]|0;Oa=d[Ma+(Ja<<1)>>1]|0;Ja=d[Ma+(ga<<1)>>1]|0;ga=d[Ma+(oa<<1)>>1]|0;hb=d[Ma+(Ta<<1)>>1]|0;Ta=d[Ma+(Aa<<1)>>1]|0;Aa=Pa<<16>>16<bb<<16>>16?Pa:bb;ab=Pa<<16>>16>bb<<16>>16?Pa:bb;bb=Aa<<16>>16<Xa<<16>>16;Pa=bb?Aa:Xa;lb=bb?Xa:Aa;Aa=ab<<16>>16<lb<<16>>16;Xa=Aa?ab:lb;bb=Aa?lb:ab;ab=ua<<16>>16<Ua<<16>>16;lb=ab?ua:Ua;Aa=ab?Ua:ua;ua=lb<<16>>16<Eb<<16>>16;Ua=ua?lb:Eb;ab=ua?Eb:lb;lb=Aa<<16>>16<ab<<16>>16;Eb=lb?Aa:ab;ua=lb?ab:Aa;Aa=Ua<<16>>16<Pa<<16>>16;ab=Aa?Ua:Pa;lb=Aa?Pa:Ua;Ua=ua<<16>>16<bb<<16>>16;Pa=Ua?ua:bb;Aa=Ua?bb:ua;ua=lb<<16>>16<Pa<<16>>16;bb=ua?lb:Pa;Ua=ua?Pa:lb;lb=Eb<<16>>16<Xa<<16>>16;Pa=lb?Eb:Xa;ua=lb?Xa:Eb;Eb=bb<<16>>16<Pa<<16>>16;Xa=Eb?bb:Pa;lb=Eb?Pa:bb;bb=ua<<16>>16<Ua<<16>>16;Pa=bb?ua:Ua;Eb=bb?Ua:ua;ua=pa<<16>>16<La<<16>>16;Ua=ua?pa:La;bb=ua?La:pa;pa=Ua<<16>>16<nb<<16>>16;La=pa?Ua:nb;ua=pa?nb:Ua;Ua=bb<<16>>16<ua<<16>>16;nb=Ua?bb:ua;pa=Ua?ua:bb;bb=$a<<16>>16<Gb<<16>>16;ua=bb?$a:Gb;Ua=bb?Gb:$a;$a=ua<<16>>16<kb<<16>>16;Gb=$a?ua:kb;bb=$a?kb:ua;ua=Ua<<16>>16<bb<<16>>16;kb=ua?Ua:bb;$a=ua?bb:Ua;Ua=Gb<<16>>16<La<<16>>16;bb=Ua?Gb:La;ua=Ua?La:Gb;Gb=$a<<16>>16<pa<<16>>16;La=Gb?$a:pa;Ua=Gb?pa:$a;$a=ua<<16>>16<La<<16>>16;pa=$a?ua:La;Gb=$a?La:ua;ua=kb<<16>>16<nb<<16>>16;La=ua?kb:nb;$a=ua?nb:kb;kb=pa<<16>>16<La<<16>>16;nb=kb?pa:La;ua=kb?La:pa;pa=$a<<16>>16<Gb<<16>>16;La=pa?$a:Gb;kb=pa?Gb:$a;$a=bb<<16>>16<ab<<16>>16;Gb=($a?bb:ab)<<16>>16;pa=$a?ab:bb;bb=kb<<16>>16<Eb<<16>>16;ab=bb?kb:Eb;$a=bb?Eb:kb;kb=pa<<16>>16<ab<<16>>16;Eb=kb?pa:ab;bb=kb?ab:pa;pa=ua<<16>>16<lb<<16>>16;ab=pa?ua:lb;kb=pa?lb:ua;ua=Eb<<16>>16<ab<<16>>16;lb=ua?Eb:ab;pa=ua?ab:Eb;Eb=kb<<16>>16<bb<<16>>16;ab=Eb?kb:bb;ua=Eb?bb:kb;kb=nb<<16>>16<Xa<<16>>16;bb=kb?nb:Xa;Eb=kb?Xa:nb;nb=Ua<<16>>16<Aa<<16>>16;Xa=nb?Ua:Aa;kb=(nb?Aa:Ua)<<16>>16;Ua=Eb<<16>>16<Xa<<16>>16;Aa=Ua?Eb:Xa;nb=Ua?Xa:Eb;Eb=La<<16>>16<Pa<<16>>16;Xa=Eb?La:Pa;Ua=Eb?Pa:La;La=Aa<<16>>16<Xa<<16>>16;Pa=La?Aa:Xa;Eb=La?Xa:Aa;Aa=Ua<<16>>16<nb<<16>>16;Xa=Aa?Ua:nb;La=Aa?nb:Ua;Ua=lb<<16>>16<bb<<16>>16;nb=(Ua?lb:bb)<<16>>16;Aa=(Ua?bb:lb)<<16>>16;lb=pa<<16>>16<Pa<<16>>16;bb=(lb?pa:Pa)<<16>>16;Ua=(lb?Pa:pa)<<16>>16;pa=ab<<16>>16<Eb<<16>>16;Pa=(pa?ab:Eb)<<16>>16;lb=(pa?Eb:ab)<<16>>16;ab=ua<<16>>16<Xa<<16>>16;Eb=(ab?ua:Xa)<<16>>16;pa=(ab?Xa:ua)<<16>>16;ua=$a<<16>>16<La<<16>>16;Xa=(ua?$a:La)<<16>>16;ab=(ua?La:$a)<<16>>16;$a=wa<<16>>16<cb<<16>>16;La=$a?wa:cb;ua=$a?cb:wa;wa=La<<16>>16<_a<<16>>16;cb=wa?La:_a;$a=wa?_a:La;La=ua<<16>>16<$a<<16>>16;_a=La?ua:$a;wa=La?$a:ua;ua=Ya<<16>>16<ob<<16>>16;$a=ua?Ya:ob;La=ua?ob:Ya;Ya=$a<<16>>16<va<<16>>16;ob=Ya?$a:va;ua=Ya?va:$a;$a=La<<16>>16<ua<<16>>16;va=$a?La:ua;Ya=$a?ua:La;La=ob<<16>>16<cb<<16>>16;ua=La?ob:cb;$a=La?cb:ob;ob=Ya<<16>>16<wa<<16>>16;cb=ob?Ya:wa;La=ob?wa:Ya;Ya=$a<<16>>16<cb<<16>>16;wa=Ya?$a:cb;ob=Ya?cb:$a;$a=va<<16>>16<_a<<16>>16;cb=$a?va:_a;Ya=$a?_a:va;va=wa<<16>>16<cb<<16>>16;_a=va?wa:cb;$a=va?cb:wa;wa=Ya<<16>>16<ob<<16>>16;cb=wa?Ya:ob;va=wa?ob:Ya;Ya=Oa<<16>>16<xa<<16>>16;ob=Ya?Oa:xa;wa=Ya?xa:Oa;Oa=ob<<16>>16<jb<<16>>16;xa=Oa?ob:jb;Ya=Oa?jb:ob;ob=wa<<16>>16<Ya<<16>>16;jb=ob?wa:Ya;Oa=ob?Ya:wa;wa=ga<<16>>16<Ja<<16>>16;Ya=wa?ga:Ja;ob=wa?Ja:ga;ga=Ta<<16>>16<hb<<16>>16;Ja=ga?Ta:hb;wa=ga?hb:Ta;Ta=Ja<<16>>16<Ya<<16>>16;hb=Ta?Ja:Ya;ga=Ta?Ya:Ja;Ja=wa<<16>>16<ob<<16>>16;Ya=Ja?wa:ob;Ta=Ja?ob:wa;wa=ga<<16>>16<Ya<<16>>16;ob=wa?ga:Ya;Ja=wa?Ya:ga;ga=hb<<16>>16<xa<<16>>16;Ya=ga?hb:xa;wa=ga?xa:hb;hb=Ja<<16>>16<Oa<<16>>16;xa=hb?Ja:Oa;ga=hb?Oa:Ja;Ja=wa<<16>>16<xa<<16>>16;Oa=Ja?wa:xa;hb=Ja?xa:wa;wa=ob<<16>>16<jb<<16>>16;xa=wa?ob:jb;Ja=wa?jb:ob;ob=Ta<<16>>16<Ja<<16>>16;jb=ob?Ta:Ja;wa=ob?Ja:Ta;Ta=Oa<<16>>16<xa<<16>>16;Ja=Ta?Oa:xa;ob=Ta?xa:Oa;Oa=jb<<16>>16<hb<<16>>16;xa=Oa?jb:hb;Ta=Oa?hb:jb;jb=wa<<16>>16<ga<<16>>16;hb=jb?wa:ga;Oa=jb?ga:wa;wa=Ya<<16>>16<ua<<16>>16;ga=(wa?Ya:ua)<<16>>16;jb=wa?ua:Ya;Ya=Ta<<16>>16<va<<16>>16;ua=Ya?Ta:va;wa=Ya?va:Ta;Ta=jb<<16>>16<ua<<16>>16;va=Ta?jb:ua;Ya=Ta?ua:jb;jb=ob<<16>>16<$a<<16>>16;ua=jb?ob:$a;Ta=jb?$a:ob;ob=Oa<<16>>16<Ta<<16>>16;$a=ob?Oa:Ta;jb=ob?Ta:Oa;Oa=va<<16>>16<ua<<16>>16;Ta=Oa?va:ua;ob=Oa?ua:va;va=$a<<16>>16<Ya<<16>>16;ua=va?$a:Ya;Oa=va?Ya:$a;$a=jb<<16>>16<wa<<16>>16;Ya=$a?jb:wa;va=$a?wa:jb;jb=Ja<<16>>16<_a<<16>>16;wa=jb?Ja:_a;$a=jb?_a:Ja;Ja=hb<<16>>16<La<<16>>16;_a=Ja?hb:La;jb=Ja?La:hb;hb=$a<<16>>16<_a<<16>>16;La=hb?$a:_a;Ja=hb?_a:$a;$a=xa<<16>>16<cb<<16>>16;_a=$a?xa:cb;hb=$a?cb:xa;xa=La<<16>>16<_a<<16>>16;cb=xa?La:_a;$a=xa?_a:La;La=hb<<16>>16<Ja<<16>>16;_a=La?hb:Ja;xa=La?Ja:hb;hb=Ta<<16>>16<wa<<16>>16;Ja=(hb?Ta:wa)<<16>>16;La=(hb?wa:Ta)<<16>>16;Ta=ob<<16>>16<cb<<16>>16;wa=(Ta?ob:cb)<<16>>16;hb=(Ta?cb:ob)<<16>>16;ob=ua<<16>>16<$a<<16>>16;cb=(ob?ua:$a)<<16>>16;Ta=(ob?$a:ua)<<16>>16;ua=Oa<<16>>16<_a<<16>>16;$a=(ua?Oa:_a)<<16>>16;ob=(ua?_a:Oa)<<16>>16;Oa=Ya<<16>>16<xa<<16>>16;_a=(Oa?Ya:xa)<<16>>16;ua=(Oa?xa:Ya)<<16>>16;Ya=va<<16>>16<jb<<16>>16;xa=(Ya?va:jb)<<16>>16;Oa=(Ya?jb:va)<<16>>16;va=(ga|0)<(Gb|0)?Gb:ga;ga=(ob|0)<(pa|0)?ob:pa;pa=(va|0)<(ga|0)?ga:va;va=(hb|0)<(Ua|0)?Ua:hb;hb=(Oa|0)<(va|0)?Oa:va;va=(hb|0)<(pa|0)?hb:pa;pa=(La|0)<(Aa|0)?Aa:La;La=(ua|0)<(ab|0)?ua:ab;ab=(pa|0)<(La|0)?pa:La;La=(Ta|0)<(lb|0)?Ta:lb;lb=(ab|0)<(La|0)?La:ab;ab=(va|0)<(lb|0)?lb:va;va=(Ja|0)<(nb|0)?nb:Ja;Ja=(_a|0)<(Xa|0)?_a:Xa;Xa=(va|0)<(Ja|0)?Ja:va;va=(cb|0)<(Pa|0)?Pa:cb;cb=(va|0)<(Xa|0)?va:Xa;Xa=(wa|0)<(bb|0)?bb:wa;wa=(xa|0)<(kb|0)?xa:kb;kb=(Xa|0)<(wa|0)?Xa:wa;wa=($a|0)<(Eb|0)?$a:Eb;Eb=(kb|0)<(wa|0)?wa:kb;kb=(cb|0)<(Eb|0)?cb:Eb;d[ia+(oa<<1)>>1]=(ab|0)<(kb|0)?kb:ab;oa=oa+1|0}while((oa|0)!=(la|0));ic=la}else ic=Fb;if((la|0)==(Ka|0))break;if((ic|0)>(ka|0)){la=Ka;Fb=ic;continue}else jc=ic;while(1){oa=Ha+(jc<<1)|0;ab=d[oa+(qa<<1)>>1]|0;kb=d[oa+(da<<1)>>1]|0;Eb=d[oa>>1]|0;cb=d[oa+(Ea<<1)>>1]|0;wa=d[oa+(Ca<<1)>>1]|0;oa=mb+(jc<<1)|0;$a=d[oa+(qa<<1)>>1]|0;Xa=d[oa+(da<<1)>>1]|0;xa=d[oa>>1]|0;bb=d[oa+(Ea<<1)>>1]|0;va=d[oa+(Ca<<1)>>1]|0;oa=ra+(jc<<1)|0;Pa=d[oa+(qa<<1)>>1]|0;Ja=d[oa+(da<<1)>>1]|0;_a=d[oa>>1]|0;nb=d[oa+(Ea<<1)>>1]|0;lb=d[oa+(Ca<<1)>>1]|0;oa=db+(jc<<1)|0;La=d[oa+(qa<<1)>>1]|0;Ta=d[oa+(da<<1)>>1]|0;pa=d[oa>>1]|0;ua=d[oa+(Ea<<1)>>1]|0;Aa=d[oa+(Ca<<1)>>1]|0;oa=Ma+(jc<<1)|0;hb=d[oa+(qa<<1)>>1]|0;Oa=d[oa+(da<<1)>>1]|0;Ua=d[oa>>1]|0;ga=d[oa+(Ea<<1)>>1]|0;ob=d[oa+(Ca<<1)>>1]|0;oa=Eb<<16>>16<kb<<16>>16?Eb:kb;Gb=Eb<<16>>16>kb<<16>>16?Eb:kb;kb=oa<<16>>16<ab<<16>>16;Eb=kb?oa:ab;jb=kb?ab:oa;oa=Gb<<16>>16<jb<<16>>16;ab=oa?Gb:jb;kb=oa?jb:Gb;Gb=$a<<16>>16<wa<<16>>16;jb=Gb?$a:wa;oa=Gb?wa:$a;$a=jb<<16>>16<cb<<16>>16;wa=$a?jb:cb;Gb=$a?cb:jb;jb=oa<<16>>16<Gb<<16>>16;cb=jb?oa:Gb;$a=jb?Gb:oa;oa=wa<<16>>16<Eb<<16>>16;Gb=oa?wa:Eb;jb=oa?Eb:wa;wa=$a<<16>>16<kb<<16>>16;Eb=wa?$a:kb;oa=wa?kb:$a;$a=jb<<16>>16<Eb<<16>>16;kb=$a?jb:Eb;wa=$a?Eb:jb;jb=cb<<16>>16<ab<<16>>16;Eb=jb?cb:ab;$a=jb?ab:cb;cb=kb<<16>>16<Eb<<16>>16;ab=cb?kb:Eb;jb=cb?Eb:kb;kb=$a<<16>>16<wa<<16>>16;Eb=kb?$a:wa;cb=kb?wa:$a;$a=bb<<16>>16<xa<<16>>16;wa=$a?bb:xa;kb=$a?xa:bb;bb=wa<<16>>16<Xa<<16>>16;xa=bb?wa:Xa;$a=bb?Xa:wa;wa=kb<<16>>16<$a<<16>>16;Xa=wa?kb:$a;bb=wa?$a:kb;kb=Ja<<16>>16<Pa<<16>>16;$a=kb?Ja:Pa;wa=kb?Pa:Ja;Ja=$a<<16>>16<va<<16>>16;Pa=Ja?$a:va;kb=Ja?va:$a;$a=wa<<16>>16<kb<<16>>16;va=$a?wa:kb;Ja=$a?kb:wa;wa=Pa<<16>>16<xa<<16>>16;kb=wa?Pa:xa;$a=wa?xa:Pa;Pa=Ja<<16>>16<bb<<16>>16;xa=Pa?Ja:bb;wa=Pa?bb:Ja;Ja=$a<<16>>16<xa<<16>>16;bb=Ja?$a:xa;Pa=Ja?xa:$a;$a=va<<16>>16<Xa<<16>>16;xa=$a?va:Xa;Ja=$a?Xa:va;va=bb<<16>>16<xa<<16>>16;Xa=va?bb:xa;$a=va?xa:bb;bb=Ja<<16>>16<Pa<<16>>16;xa=bb?Ja:Pa;va=bb?Pa:Ja;Ja=kb<<16>>16<Gb<<16>>16;Pa=(Ja?kb:Gb)<<16>>16;bb=Ja?Gb:kb;kb=va<<16>>16<cb<<16>>16;Gb=kb?va:cb;Ja=kb?cb:va;va=bb<<16>>16<Gb<<16>>16;cb=va?bb:Gb;kb=va?Gb:bb;bb=$a<<16>>16<jb<<16>>16;Gb=bb?$a:jb;va=bb?jb:$a;$a=cb<<16>>16<Gb<<16>>16;jb=$a?cb:Gb;bb=$a?Gb:cb;cb=va<<16>>16<kb<<16>>16;Gb=cb?va:kb;$a=cb?kb:va;va=Xa<<16>>16<ab<<16>>16;kb=va?Xa:ab;cb=va?ab:Xa;Xa=wa<<16>>16<oa<<16>>16;ab=Xa?wa:oa;va=(Xa?oa:wa)<<16>>16;wa=cb<<16>>16<ab<<16>>16;oa=wa?cb:ab;Xa=wa?ab:cb;cb=xa<<16>>16<Eb<<16>>16;ab=cb?xa:Eb;wa=cb?Eb:xa;xa=oa<<16>>16<ab<<16>>16;Eb=xa?oa:ab;cb=xa?ab:oa;oa=wa<<16>>16<Xa<<16>>16;ab=oa?wa:Xa;xa=oa?Xa:wa;wa=jb<<16>>16<kb<<16>>16;Xa=(wa?jb:kb)<<16>>16;oa=(wa?kb:jb)<<16>>16;jb=bb<<16>>16<Eb<<16>>16;kb=(jb?bb:Eb)<<16>>16;wa=(jb?Eb:bb)<<16>>16;bb=Gb<<16>>16<cb<<16>>16;Eb=(bb?Gb:cb)<<16>>16;jb=(bb?cb:Gb)<<16>>16;Gb=$a<<16>>16<ab<<16>>16;cb=(Gb?$a:ab)<<16>>16;bb=(Gb?ab:$a)<<16>>16;$a=Ja<<16>>16<xa<<16>>16;ab=($a?Ja:xa)<<16>>16;Gb=($a?xa:Ja)<<16>>16;Ja=lb<<16>>16<nb<<16>>16;xa=Ja?lb:nb;$a=Ja?nb:lb;lb=xa<<16>>16<_a<<16>>16;nb=lb?xa:_a;Ja=lb?_a:xa;xa=$a<<16>>16<Ja<<16>>16;_a=xa?$a:Ja;lb=xa?Ja:$a;$a=pa<<16>>16<Ta<<16>>16;Ja=$a?pa:Ta;xa=$a?Ta:pa;pa=Ja<<16>>16<La<<16>>16;Ta=pa?Ja:La;$a=pa?La:Ja;Ja=xa<<16>>16<$a<<16>>16;La=Ja?xa:$a;pa=Ja?$a:xa;xa=Ta<<16>>16<nb<<16>>16;$a=xa?Ta:nb;Ja=xa?nb:Ta;Ta=pa<<16>>16<lb<<16>>16;nb=Ta?pa:lb;xa=Ta?lb:pa;pa=Ja<<16>>16<nb<<16>>16;lb=pa?Ja:nb;Ta=pa?nb:Ja;Ja=La<<16>>16<_a<<16>>16;nb=Ja?La:_a;pa=Ja?_a:La;La=lb<<16>>16<nb<<16>>16;_a=La?lb:nb;Ja=La?nb:lb;lb=pa<<16>>16<Ta<<16>>16;nb=lb?pa:Ta;La=lb?Ta:pa;pa=hb<<16>>16<Aa<<16>>16;Ta=pa?hb:Aa;lb=pa?Aa:hb;hb=Ta<<16>>16<ua<<16>>16;Aa=hb?Ta:ua;pa=hb?ua:Ta;Ta=lb<<16>>16<pa<<16>>16;ua=Ta?lb:pa;hb=Ta?pa:lb;lb=Ua<<16>>16<Oa<<16>>16;pa=lb?Ua:Oa;Ta=lb?Oa:Ua;Ua=ob<<16>>16<ga<<16>>16;Oa=Ua?ob:ga;lb=Ua?ga:ob;ob=Oa<<16>>16<pa<<16>>16;ga=ob?Oa:pa;Ua=ob?pa:Oa;Oa=lb<<16>>16<Ta<<16>>16;pa=Oa?lb:Ta;ob=Oa?Ta:lb;lb=Ua<<16>>16<pa<<16>>16;Ta=lb?Ua:pa;Oa=lb?pa:Ua;Ua=ga<<16>>16<Aa<<16>>16;pa=Ua?ga:Aa;lb=Ua?Aa:ga;ga=Oa<<16>>16<hb<<16>>16;Aa=ga?Oa:hb;Ua=ga?hb:Oa;Oa=lb<<16>>16<Aa<<16>>16;hb=Oa?lb:Aa;ga=Oa?Aa:lb;lb=Ta<<16>>16<ua<<16>>16;Aa=lb?Ta:ua;Oa=lb?ua:Ta;Ta=ob<<16>>16<Oa<<16>>16;ua=Ta?ob:Oa;lb=Ta?Oa:ob;ob=hb<<16>>16<Aa<<16>>16;Oa=ob?hb:Aa;Ta=ob?Aa:hb;hb=ua<<16>>16<ga<<16>>16;Aa=hb?ua:ga;ob=hb?ga:ua;ua=lb<<16>>16<Ua<<16>>16;ga=ua?lb:Ua;hb=ua?Ua:lb;lb=pa<<16>>16<$a<<16>>16;Ua=(lb?pa:$a)<<16>>16;ua=lb?$a:pa;pa=ob<<16>>16<La<<16>>16;$a=pa?ob:La;lb=pa?La:ob;ob=ua<<16>>16<$a<<16>>16;La=ob?ua:$a;pa=ob?$a:ua;ua=Ta<<16>>16<Ja<<16>>16;$a=ua?Ta:Ja;ob=ua?Ja:Ta;Ta=hb<<16>>16<ob<<16>>16;Ja=Ta?hb:ob;ua=Ta?ob:hb;hb=La<<16>>16<$a<<16>>16;ob=hb?La:$a;Ta=hb?$a:La;La=Ja<<16>>16<pa<<16>>16;$a=La?Ja:pa;hb=La?pa:Ja;Ja=ua<<16>>16<lb<<16>>16;pa=Ja?ua:lb;La=Ja?lb:ua;ua=Oa<<16>>16<_a<<16>>16;lb=ua?Oa:_a;Ja=ua?_a:Oa;Oa=ga<<16>>16<xa<<16>>16;_a=Oa?ga:xa;ua=Oa?xa:ga;ga=Ja<<16>>16<_a<<16>>16;xa=ga?Ja:_a;Oa=ga?_a:Ja;Ja=Aa<<16>>16<nb<<16>>16;_a=Ja?Aa:nb;ga=Ja?nb:Aa;Aa=xa<<16>>16<_a<<16>>16;nb=Aa?xa:_a;Ja=Aa?_a:xa;xa=ga<<16>>16<Oa<<16>>16;_a=xa?ga:Oa;Aa=xa?Oa:ga;ga=ob<<16>>16<lb<<16>>16;Oa=(ga?ob:lb)<<16>>16;xa=(ga?lb:ob)<<16>>16;ob=Ta<<16>>16<nb<<16>>16;lb=(ob?Ta:nb)<<16>>16;ga=(ob?nb:Ta)<<16>>16;Ta=$a<<16>>16<Ja<<16>>16;nb=(Ta?$a:Ja)<<16>>16;ob=(Ta?Ja:$a)<<16>>16;$a=hb<<16>>16<_a<<16>>16;Ja=($a?hb:_a)<<16>>16;Ta=($a?_a:hb)<<16>>16;hb=pa<<16>>16<Aa<<16>>16;_a=(hb?pa:Aa)<<16>>16;$a=(hb?Aa:pa)<<16>>16;pa=La<<16>>16<ua<<16>>16;Aa=(pa?La:ua)<<16>>16;hb=(pa?ua:La)<<16>>16;La=(Ua|0)<(Pa|0)?Pa:Ua;Ua=(Ta|0)<(bb|0)?Ta:bb;bb=(La|0)<(Ua|0)?Ua:La;La=(ga|0)<(wa|0)?wa:ga;ga=(hb|0)<(La|0)?hb:La;La=(ga|0)<(bb|0)?ga:bb;bb=(xa|0)<(oa|0)?oa:xa;xa=($a|0)<(Gb|0)?$a:Gb;Gb=(bb|0)<(xa|0)?bb:xa;xa=(ob|0)<(jb|0)?ob:jb;jb=(Gb|0)<(xa|0)?xa:Gb;Gb=(La|0)<(jb|0)?jb:La;La=(Oa|0)<(Xa|0)?Xa:Oa;Oa=(_a|0)<(ab|0)?_a:ab;ab=(La|0)<(Oa|0)?Oa:La;La=(nb|0)<(Eb|0)?Eb:nb;nb=(La|0)<(ab|0)?La:ab;ab=(lb|0)<(kb|0)?kb:lb;lb=(Aa|0)<(va|0)?Aa:va;va=(ab|0)<(lb|0)?ab:lb;lb=(Ja|0)<(cb|0)?Ja:cb;cb=(va|0)<(lb|0)?lb:va;va=(nb|0)<(cb|0)?nb:cb;d[ia+(jc<<1)>>1]=(Gb|0)<(va|0)?va:Gb;Gb=jc+1|0;if((jc|0)<(ka|0))jc=Gb;else{la=Ka;Fb=Gb;continue i}}}if((ta|0)==(sa|0))break;else ia=ia+(Na<<1)|0}break}default:break a}break}case 5:{Na=f[O+16>>2]|0;ia=f[aa>>2]|0;sa=(f[V>>2]|0)>>>2;ta=(f[N+48>>2]|0)>>>2;Ka=f[N+40>>2]|0;ka=f[Ka+4>>2]|0;Ca=f[Ka>>2]|0;Ka=Da>>>3;Ea=Ka&511;da=Ea+1|0;switch(e|0){case 3:{qa=(Ca|0)==1;if((ka|0)==1|qa){na=Ca+ka|0;ya=na+-1|0;Ba=qa?da:sa;za=qa?0:sa-da|0;Ga=qa?da:ta;if((na|0)<=1)break a;qa=0-Ba|0;Ia=na+-2|0;na=Na;ca=ia;Fa=0;while(1){ja=(Fa|0)>0?qa:0;Fb=(Fa|0)<(Ia|0)?Ba:0;la=0;Ma=na;while(1){db=f[Ma+(ja<<2)>>2]|0;f[i>>2]=db;ra=f[Ma>>2]|0;f[k>>2]=ra;ma=+n[Ma+(Fb<<2)>>2];kc=(f[s>>2]=db,+n[s>>2]);lc=(f[s>>2]=ra,+n[s>>2]);ra=lc<kc;mc=+n[(ra?k:i)>>2];nc=ra?kc:lc;lc=ma<nc?ma:nc;n[ca+(la<<2)>>2]=lc<mc?mc:lc;la=la+1|0;if((la|0)==(da|0))break;else Ma=Ma+4|0}Fa=Fa+1|0;if((Fa|0)>=(ya|0))break a;else{na=na+(da<<2)+(za<<2)|0;ca=ca+(Ga<<2)|0}}}Ga=Y(ka,da)|0;if((Ca|0)<=0)break a;ca=Ca+-1|0;za=(Ka|-512)^511;na=za+-1+Ga|0;ya=Ga-da|0;Fa=ia;Ba=0;while(1){Ia=Ba+-1|0;qa=Na+((Y((Ia|0)>0?Ia:0,sa)|0)<<2)|0;Ia=Na+((Y(Ba,sa)|0)<<2)|0;Ba=Ba+1|0;Da=Na+((Y((ca|0)<(Ba|0)?ca:Ba,sa)|0)<<2)|0;Ma=da;la=0;j:while(1){if((la|0)<(Ma|0)){Fb=la;do{ja=Fb-((Fb|0)>(Ea|0)?da:0)|0;ra=((Fb|0)<(ya|0)?da:0)+Fb|0;db=f[qa+(ja<<2)>>2]|0;mb=f[qa+(Fb<<2)>>2]|0;f[i>>2]=mb;Ha=f[qa+(ra<<2)>>2]|0;f[k>>2]=Ha;Gb=f[Ia+(ja<<2)>>2]|0;va=f[Ia+(Fb<<2)>>2]|0;f[l>>2]=va;cb=f[Ia+(ra<<2)>>2]|0;f[m>>2]=cb;nb=f[Da+(ja<<2)>>2]|0;ja=f[Da+(Fb<<2)>>2]|0;f[o>>2]=ja;lb=f[Da+(ra<<2)>>2]|0;f[p>>2]=lb;lc=(f[s>>2]=mb,+n[s>>2]);mc=(f[s>>2]=Ha,+n[s>>2]);Ha=mc<lc;mb=f[(Ha?k:i)>>2]|0;nc=Ha?lc:mc;n[k>>2]=nc;mc=(f[s>>2]=va,+n[s>>2]);lc=(f[s>>2]=cb,+n[s>>2]);cb=lc<mc;va=f[(cb?m:l)>>2]|0;ma=cb?mc:lc;n[m>>2]=ma;lc=(f[s>>2]=ja,+n[s>>2]);mc=(f[s>>2]=lb,+n[s>>2]);lb=mc<lc;ja=f[(lb?p:o)>>2]|0;kc=lb?lc:mc;n[p>>2]=kc;mc=(f[s>>2]=db,+n[s>>2]);lc=(f[s>>2]=mb,+n[s>>2]);lb=lc<mc;oc=lb?mc:lc;n[i>>2]=oc;lc=(f[s>>2]=Gb,+n[s>>2]);mc=(f[s>>2]=va,+n[s>>2]);cb=mc<lc;pc=cb?lc:mc;n[l>>2]=pc;mc=(f[s>>2]=nb,+n[s>>2]);lc=(f[s>>2]=ja,+n[s>>2]);Ha=lc<mc;qc=Ha?mc:lc;n[o>>2]=qc;ra=nc<oc;lc=ra?+n[k>>2]:+n[i>>2];mc=ra?oc:nc;n[k>>2]=mc;ra=ma<pc;Ja=f[(ra?m:l)>>2]|0;f[l>>2]=Ja;nc=ra?pc:ma;n[m>>2]=nc;ra=kc<qc;ab=f[(ra?p:o)>>2]|0;f[o>>2]=ab;ma=ra?qc:kc;n[p>>2]=ma;kc=(f[s>>2]=lb?mb:db,+n[s>>2]);qc=(f[s>>2]=cb?va:Gb,+n[s>>2]);pc=qc<kc?kc:qc;Gb=f[(ma<nc?p:m)>>2]|0;f[m>>2]=Gb;nc=(f[s>>2]=Ja,+n[s>>2]);ma=(f[s>>2]=ab,+n[s>>2]);ab=ma<nc;qc=ab?+n[o>>2]:+n[l>>2];kc=ab?nc:ma;n[o>>2]=kc;ma=(f[s>>2]=Ha?ja:nb,+n[s>>2]);nc=ma<pc?pc:ma;ma=qc<lc?lc:qc;n[l>>2]=ma;nb=f[((f[s>>2]=Gb,+n[s>>2])<mc?m:k)>>2]|0;f[k>>2]=nb;Gb=f[(kc<ma?o:l)>>2]|0;f[l>>2]=Gb;ma=(f[s>>2]=Gb,+n[s>>2]);kc=(f[s>>2]=nb,+n[s>>2]);nb=kc<ma;mc=nb?+n[k>>2]:(f[s>>2]=Gb,+n[s>>2]);qc=nb?ma:kc;n[k>>2]=qc;kc=mc<nc?nc:mc;n[l>>2]=kc;f[Fa+(Fb<<2)>>2]=f[(qc<kc?k:l)>>2];Fb=Fb+1|0}while((Fb|0)!=(Ma|0));rc=Ma}else rc=la;if((Ma|0)==(Ga|0))break;if((rc|0)>(na|0)){Ma=Ga;la=rc;continue}else sc=rc;while(1){Fb=qa+(sc<<2)|0;nb=f[Fb+(za<<2)>>2]|0;Gb=f[Fb>>2]|0;f[i>>2]=Gb;ja=f[Fb+(da<<2)>>2]|0;f[k>>2]=ja;Fb=Ia+(sc<<2)|0;Ha=f[Fb+(za<<2)>>2]|0;ab=f[Fb>>2]|0;f[l>>2]=ab;Ja=f[Fb+(da<<2)>>2]|0;f[m>>2]=Ja;Fb=Da+(sc<<2)|0;va=f[Fb+(za<<2)>>2]|0;cb=f[Fb>>2]|0;f[o>>2]=cb;db=f[Fb+(da<<2)>>2]|0;f[p>>2]=db;kc=(f[s>>2]=Gb,+n[s>>2]);qc=(f[s>>2]=ja,+n[s>>2]);ja=qc<kc;Gb=f[(ja?k:i)>>2]|0;mc=ja?kc:qc;n[k>>2]=mc;qc=(f[s>>2]=ab,+n[s>>2]);kc=(f[s>>2]=Ja,+n[s>>2]);Ja=kc<qc;ab=f[(Ja?m:l)>>2]|0;nc=Ja?qc:kc;n[m>>2]=nc;kc=(f[s>>2]=cb,+n[s>>2]);qc=(f[s>>2]=db,+n[s>>2]);db=qc<kc;cb=f[(db?p:o)>>2]|0;ma=db?kc:qc;n[p>>2]=ma;qc=(f[s>>2]=nb,+n[s>>2]);kc=(f[s>>2]=Gb,+n[s>>2]);db=kc<qc;lc=db?qc:kc;n[i>>2]=lc;kc=(f[s>>2]=Ha,+n[s>>2]);qc=(f[s>>2]=ab,+n[s>>2]);Ja=qc<kc;pc=Ja?kc:qc;n[l>>2]=pc;qc=(f[s>>2]=va,+n[s>>2]);kc=(f[s>>2]=cb,+n[s>>2]);ja=kc<qc;oc=ja?qc:kc;n[o>>2]=oc;Fb=mc<lc;kc=Fb?+n[k>>2]:+n[i>>2];qc=Fb?lc:mc;n[k>>2]=qc;Fb=nc<pc;mb=f[(Fb?m:l)>>2]|0;f[l>>2]=mb;mc=Fb?pc:nc;n[m>>2]=mc;Fb=ma<oc;lb=f[(Fb?p:o)>>2]|0;f[o>>2]=lb;nc=Fb?oc:ma;n[p>>2]=nc;ma=(f[s>>2]=db?Gb:nb,+n[s>>2]);oc=(f[s>>2]=Ja?ab:Ha,+n[s>>2]);pc=oc<ma?ma:oc;Ha=f[(nc<mc?p:m)>>2]|0;f[m>>2]=Ha;mc=(f[s>>2]=mb,+n[s>>2]);nc=(f[s>>2]=lb,+n[s>>2]);lb=nc<mc;oc=lb?+n[o>>2]:+n[l>>2];ma=lb?mc:nc;n[o>>2]=ma;nc=(f[s>>2]=ja?cb:va,+n[s>>2]);mc=nc<pc?pc:nc;nc=oc<kc?kc:oc;n[l>>2]=nc;va=f[((f[s>>2]=Ha,+n[s>>2])<qc?m:k)>>2]|0;f[k>>2]=va;Ha=f[(ma<nc?o:l)>>2]|0;f[l>>2]=Ha;nc=(f[s>>2]=Ha,+n[s>>2]);ma=(f[s>>2]=va,+n[s>>2]);va=ma<nc;qc=va?+n[k>>2]:(f[s>>2]=Ha,+n[s>>2]);oc=va?nc:ma;n[k>>2]=oc;ma=qc<mc?mc:qc;n[l>>2]=ma;f[Fa+(sc<<2)>>2]=f[(oc<ma?k:l)>>2];va=sc+1|0;if((sc|0)<(na|0))sc=va;else{Ma=Ga;la=va;continue j}}}if((Ba|0)==(Ca|0))break;else Fa=Fa+(ta<<2)|0}break}case 5:{Fa=(Ca|0)==1;if((ka|0)==1|Fa){Ba=Ca+ka|0;Ga=Ba+-1|0;na=Fa?da:sa;za=Fa?0:sa-da|0;ya=Fa?da:ta;if((Ba|0)<=1)break a;Fa=0-na|0;ca=Fa<<1;la=Ba+-2|0;Ma=Ba+-3|0;Ba=na<<1;Da=Na;Ia=ia;qa=0;while(1){va=(qa|0)>0?Fa:0;Ha=(qa|0)>1?ca:va;cb=(qa|0)<(la|0)?na:0;ja=(qa|0)<(Ma|0)?Ba:cb;lb=Da;mb=0;while(1){ab=f[lb+(Ha<<2)>>2]|0;f[i>>2]=ab;Ja=f[lb+(va<<2)>>2]|0;f[k>>2]=Ja;nb=f[lb>>2]|0;f[l>>2]=nb;Gb=f[lb+(cb<<2)>>2]|0;f[m>>2]=Gb;db=f[lb+(ja<<2)>>2]|0;f[o>>2]=db;ma=(f[s>>2]=ab,+n[s>>2]);oc=(f[s>>2]=Ja,+n[s>>2]);Ja=oc<ma;qc=+n[(Ja?k:i)>>2];mc=Ja?ma:oc;oc=(f[s>>2]=Gb,+n[s>>2]);ma=(f[s>>2]=db,+n[s>>2]);db=ma<oc;Gb=f[(db?o:m)>>2]|0;f[m>>2]=Gb;nc=db?oc:ma;n[o>>2]=nc;ma=(f[s>>2]=nb,+n[s>>2]);oc=(f[s>>2]=Gb,+n[s>>2]);nb=oc<ma;kc=nb?(f[s>>2]=Gb,+n[s>>2]):+n[l>>2];pc=nb?ma:oc;n[m>>2]=pc;nb=nc<pc;oc=nb?+n[o>>2]:pc;ma=nb?pc:nc;n[o>>2]=ma;nc=kc<qc?qc:kc;n[l>>2]=nc;kc=ma<nc?ma:nc;nc=oc<mc?oc:mc;n[Ia+(mb<<2)>>2]=kc<nc?nc:kc;mb=mb+1|0;if((mb|0)==(da|0))break;else lb=lb+4|0}qa=qa+1|0;if((qa|0)>=(Ga|0))break a;else{Da=Da+(da<<2)+(za<<2)|0;Ia=Ia+(ya<<2)|0}}}ya=Y(ka,da)|0;if((Ca|0)<=0)break a;Ia=Ca+-1|0;za=da<<1;Da=0-za|0;Ga=ya+~za|0;qa=(Ka|-512)^511;Ba=ya-da|0;Ma=ya-za|0;na=ia;la=0;while(1){ca=la+-2|0;Fa=Na+((Y((ca|0)>0?ca:0,sa)|0)<<2)|0;ca=la+-1|0;lb=Na+((Y((ca|0)>0?ca:0,sa)|0)<<2)|0;ca=Na+((Y(la,sa)|0)<<2)|0;mb=la;la=la+1|0;ja=Na+((Y((Ia|0)<(la|0)?Ia:la,sa)|0)<<2)|0;cb=mb+2|0;mb=Na+((Y((Ia|0)<(cb|0)?Ia:cb,sa)|0)<<2)|0;cb=za;va=0;k:while(1){if((va|0)<(cb|0)){Ha=va;do{nb=Ha-((Ha|0)>(Ea|0)?da:0)|0;Gb=(Ha|0)<(za|0)?nb:Ha-za|0;db=((Ha|0)<(Ba|0)?da:0)+Ha|0;Ja=(Ha|0)<(Ma|0)?Ha+za|0:db;f[i>>2]=f[Fa+(Gb<<2)>>2];ab=f[Fa+(nb<<2)>>2]|0;f[k>>2]=ab;Fb=f[Fa+(Ha<<2)>>2]|0;f[l>>2]=Fb;f[m>>2]=f[Fa+(db<<2)>>2];f[o>>2]=f[Fa+(Ja<<2)>>2];f[p>>2]=f[lb+(Gb<<2)>>2];f[q>>2]=f[lb+(nb<<2)>>2];f[r>>2]=f[lb+(Ha<<2)>>2];f[t>>2]=f[lb+(db<<2)>>2];f[v>>2]=f[lb+(Ja<<2)>>2];f[w>>2]=f[ca+(Gb<<2)>>2];f[x>>2]=f[ca+(nb<<2)>>2];f[y>>2]=f[ca+(Ha<<2)>>2];f[z>>2]=f[ca+(db<<2)>>2];f[A>>2]=f[ca+(Ja<<2)>>2];f[B>>2]=f[ja+(Gb<<2)>>2];f[C>>2]=f[ja+(nb<<2)>>2];f[D>>2]=f[ja+(Ha<<2)>>2];f[E>>2]=f[ja+(db<<2)>>2];f[F>>2]=f[ja+(Ja<<2)>>2];f[G>>2]=f[mb+(Gb<<2)>>2];f[H>>2]=f[mb+(nb<<2)>>2];f[I>>2]=f[mb+(Ha<<2)>>2];f[J>>2]=f[mb+(db<<2)>>2];f[K>>2]=f[mb+(Ja<<2)>>2];kc=(f[s>>2]=ab,+n[s>>2]);nc=(f[s>>2]=Fb,+n[s>>2]);Fb=nc<kc;ab=f[(Fb?l:k)>>2]|0;f[k>>2]=ab;mc=Fb?kc:nc;n[l>>2]=mc;nc=+n[i>>2];kc=(f[s>>2]=ab,+n[s>>2]);ab=kc<nc;Fb=f[(ab?k:i)>>2]|0;f[i>>2]=Fb;oc=ab?nc:kc;n[k>>2]=oc;ab=mc<oc;Ja=f[(ab?l:k)>>2]|0;f[k>>2]=Ja;kc=ab?oc:mc;n[l>>2]=kc;mc=+n[o>>2];oc=+n[p>>2];ab=oc<mc;db=f[(ab?p:o)>>2]|0;f[o>>2]=db;nc=ab?mc:oc;n[p>>2]=nc;oc=+n[m>>2];mc=(f[s>>2]=db,+n[s>>2]);db=mc<oc;ab=f[(db?o:m)>>2]|0;f[m>>2]=ab;ma=db?oc:mc;n[o>>2]=ma;db=nc<ma;nb=f[(db?p:o)>>2]|0;f[o>>2]=nb;mc=db?ma:nc;n[p>>2]=mc;nc=(f[s>>2]=Fb,+n[s>>2]);ma=(f[s>>2]=ab,+n[s>>2]);ab=ma<nc;f[i>>2]=f[(ab?m:i)>>2];oc=ab?nc:ma;n[m>>2]=oc;ab=mc<kc;Fb=f[(ab?p:l)>>2]|0;f[l>>2]=Fb;n[p>>2]=ab?kc:mc;mc=(f[s>>2]=Fb,+n[s>>2]);Fb=oc<mc;ab=f[(Fb?m:l)>>2]|0;f[l>>2]=ab;kc=Fb?mc:oc;n[m>>2]=kc;oc=(f[s>>2]=Ja,+n[s>>2]);mc=(f[s>>2]=nb,+n[s>>2]);nb=mc<oc;Ja=f[(nb?o:k)>>2]|0;f[k>>2]=Ja;ma=nb?oc:mc;n[o>>2]=ma;mc=(f[s>>2]=Ja,+n[s>>2]);oc=(f[s>>2]=ab,+n[s>>2]);ab=oc<mc;f[k>>2]=f[(ab?l:k)>>2];n[l>>2]=ab?mc:oc;ab=ma<kc;f[m>>2]=f[(ab?o:m)>>2];n[o>>2]=ab?kc:ma;ma=+n[r>>2];kc=+n[t>>2];ab=kc<ma;Ja=f[(ab?t:r)>>2]|0;f[r>>2]=Ja;oc=ab?ma:kc;n[t>>2]=oc;kc=+n[q>>2];ma=(f[s>>2]=Ja,+n[s>>2]);Ja=ma<kc;ab=f[(Ja?r:q)>>2]|0;f[q>>2]=ab;mc=Ja?kc:ma;n[r>>2]=mc;Ja=oc<mc;nb=f[(Ja?t:r)>>2]|0;f[r>>2]=nb;ma=Ja?mc:oc;n[t>>2]=ma;oc=+n[w>>2];mc=+n[x>>2];Ja=mc<oc;Fb=f[(Ja?x:w)>>2]|0;f[w>>2]=Fb;kc=Ja?oc:mc;n[x>>2]=kc;mc=+n[v>>2];oc=(f[s>>2]=Fb,+n[s>>2]);Fb=oc<mc;Ja=f[(Fb?w:v)>>2]|0;f[v>>2]=Ja;nc=Fb?mc:oc;n[w>>2]=nc;Fb=kc<nc;db=f[(Fb?x:w)>>2]|0;f[w>>2]=db;oc=Fb?nc:kc;n[x>>2]=oc;kc=(f[s>>2]=ab,+n[s>>2]);nc=(f[s>>2]=Ja,+n[s>>2]);Ja=nc<kc;ab=f[(Ja?v:q)>>2]|0;f[q>>2]=ab;mc=Ja?kc:nc;n[v>>2]=mc;Ja=oc<ma;Fb=f[(Ja?x:t)>>2]|0;f[t>>2]=Fb;nc=Ja?ma:oc;n[x>>2]=nc;oc=(f[s>>2]=Fb,+n[s>>2]);Fb=mc<oc;Ja=f[(Fb?v:t)>>2]|0;f[t>>2]=Ja;ma=Fb?oc:mc;n[v>>2]=ma;mc=(f[s>>2]=nb,+n[s>>2]);oc=(f[s>>2]=db,+n[s>>2]);db=oc<mc;nb=f[(db?w:r)>>2]|0;f[r>>2]=nb;kc=db?mc:oc;n[w>>2]=kc;oc=(f[s>>2]=nb,+n[s>>2]);mc=(f[s>>2]=Ja,+n[s>>2]);Ja=mc<oc;nb=f[(Ja?t:r)>>2]|0;f[r>>2]=nb;qc=Ja?oc:mc;n[t>>2]=qc;Ja=kc<ma;db=f[(Ja?w:v)>>2]|0;f[v>>2]=db;mc=Ja?ma:kc;n[w>>2]=mc;kc=+n[i>>2];ma=(f[s>>2]=ab,+n[s>>2]);ab=ma<kc;f[i>>2]=f[(ab?q:i)>>2];oc=ab?kc:ma;n[q>>2]=oc;ma=+n[o>>2];ab=mc<ma;Ja=f[(ab?w:o)>>2]|0;f[o>>2]=Ja;n[w>>2]=ab?ma:mc;mc=(f[s>>2]=Ja,+n[s>>2]);Ja=oc<mc;ab=f[(Ja?q:o)>>2]|0;f[o>>2]=ab;ma=Ja?mc:oc;n[q>>2]=ma;oc=+n[l>>2];Ja=qc<oc;Fb=f[(Ja?t:l)>>2]|0;f[l>>2]=Fb;mc=Ja?oc:qc;n[t>>2]=mc;qc=(f[s>>2]=Fb,+n[s>>2]);oc=(f[s>>2]=ab,+n[s>>2]);ab=oc<qc;Fb=f[(ab?o:l)>>2]|0;f[l>>2]=Fb;kc=ab?qc:oc;n[o>>2]=kc;ab=mc<ma;Ja=f[(ab?t:q)>>2]|0;f[q>>2]=Ja;oc=ab?ma:mc;n[t>>2]=oc;mc=+n[k>>2];ma=(f[s>>2]=nb,+n[s>>2]);nb=ma<mc;ab=f[(nb?r:k)>>2]|0;f[k>>2]=ab;qc=nb?mc:ma;n[r>>2]=qc;ma=+n[p>>2];nb=nc<ma;Gb=f[(nb?x:p)>>2]|0;f[p>>2]=Gb;n[x>>2]=nb?ma:nc;nc=(f[s>>2]=Gb,+n[s>>2]);Gb=qc<nc;nb=f[(Gb?r:p)>>2]|0;f[p>>2]=nb;ma=Gb?nc:qc;n[r>>2]=ma;qc=+n[m>>2];nc=(f[s>>2]=db,+n[s>>2]);db=nc<qc;Gb=f[(db?v:m)>>2]|0;f[m>>2]=Gb;mc=db?qc:nc;n[v>>2]=mc;nc=(f[s>>2]=Gb,+n[s>>2]);qc=(f[s>>2]=nb,+n[s>>2]);nb=qc<nc;Gb=f[(nb?p:m)>>2]|0;f[m>>2]=Gb;pc=nb?nc:qc;n[p>>2]=pc;nb=mc<ma;db=f[(nb?v:r)>>2]|0;f[r>>2]=db;qc=nb?ma:mc;n[v>>2]=qc;mc=(f[s>>2]=ab,+n[s>>2]);ma=(f[s>>2]=Fb,+n[s>>2]);Fb=ma<mc;f[k>>2]=f[(Fb?l:k)>>2];n[l>>2]=Fb?mc:ma;ma=(f[s>>2]=Gb,+n[s>>2]);Gb=kc<ma;f[m>>2]=f[(Gb?o:m)>>2];n[o>>2]=Gb?ma:kc;kc=(f[s>>2]=Ja,+n[s>>2]);Ja=kc<pc;f[p>>2]=f[(Ja?q:p)>>2];n[q>>2]=Ja?pc:kc;kc=(f[s>>2]=db,+n[s>>2]);db=oc<kc;f[r>>2]=f[(db?t:r)>>2];n[t>>2]=db?kc:oc;oc=+n[w>>2];db=oc<qc;f[v>>2]=f[(db?w:v)>>2];n[w>>2]=db?qc:oc;oc=+n[z>>2];qc=+n[A>>2];db=qc<oc;Ja=f[(db?A:z)>>2]|0;f[z>>2]=Ja;kc=db?oc:qc;n[A>>2]=kc;qc=+n[y>>2];oc=(f[s>>2]=Ja,+n[s>>2]);Ja=oc<qc;db=f[(Ja?z:y)>>2]|0;f[y>>2]=db;pc=Ja?qc:oc;n[z>>2]=pc;Ja=kc<pc;Gb=f[(Ja?A:z)>>2]|0;f[z>>2]=Gb;oc=Ja?pc:kc;n[A>>2]=oc;kc=+n[C>>2];pc=+n[D>>2];Ja=pc<kc;Fb=f[(Ja?D:C)>>2]|0;f[C>>2]=Fb;qc=Ja?kc:pc;n[D>>2]=qc;pc=+n[B>>2];kc=(f[s>>2]=Fb,+n[s>>2]);Fb=kc<pc;Ja=f[(Fb?C:B)>>2]|0;f[B>>2]=Ja;ma=Fb?pc:kc;n[C>>2]=ma;Fb=qc<ma;ab=f[(Fb?D:C)>>2]|0;f[C>>2]=ab;kc=Fb?ma:qc;n[D>>2]=kc;qc=(f[s>>2]=db,+n[s>>2]);ma=(f[s>>2]=Ja,+n[s>>2]);Ja=ma<qc;f[y>>2]=f[(Ja?B:y)>>2];pc=Ja?qc:ma;n[B>>2]=pc;Ja=kc<oc;db=f[(Ja?D:A)>>2]|0;f[A>>2]=db;n[D>>2]=Ja?oc:kc;kc=(f[s>>2]=db,+n[s>>2]);db=pc<kc;Ja=f[(db?B:A)>>2]|0;f[A>>2]=Ja;oc=db?kc:pc;n[B>>2]=oc;pc=(f[s>>2]=Gb,+n[s>>2]);kc=(f[s>>2]=ab,+n[s>>2]);ab=kc<pc;Gb=f[(ab?C:z)>>2]|0;f[z>>2]=Gb;ma=ab?pc:kc;n[C>>2]=ma;kc=(f[s>>2]=Gb,+n[s>>2]);pc=(f[s>>2]=Ja,+n[s>>2]);Ja=pc<kc;f[z>>2]=f[(Ja?A:z)>>2];n[A>>2]=Ja?kc:pc;Ja=ma<oc;f[B>>2]=f[(Ja?C:B)>>2];n[C>>2]=Ja?oc:ma;ma=+n[F>>2];oc=+n[G>>2];Ja=oc<ma;Gb=f[(Ja?G:F)>>2]|0;f[F>>2]=Gb;pc=Ja?ma:oc;n[G>>2]=pc;oc=+n[E>>2];ma=(f[s>>2]=Gb,+n[s>>2]);Gb=ma<oc;Ja=f[(Gb?F:E)>>2]|0;f[E>>2]=Ja;kc=Gb?oc:ma;n[F>>2]=kc;Gb=pc<kc;ab=f[(Gb?G:F)>>2]|0;f[F>>2]=ab;ma=Gb?kc:pc;n[G>>2]=ma;pc=+n[H>>2];kc=+n[I>>2];Gb=kc<pc;db=f[(Gb?I:H)>>2]|0;f[H>>2]=db;oc=Gb?pc:kc;n[I>>2]=oc;kc=+n[J>>2];pc=+n[K>>2];Gb=pc<kc;Fb=f[(Gb?K:J)>>2]|0;f[J>>2]=Fb;qc=Gb?kc:pc;n[K>>2]=qc;pc=(f[s>>2]=db,+n[s>>2]);kc=(f[s>>2]=Fb,+n[s>>2]);Fb=kc<pc;db=f[(Fb?J:H)>>2]|0;f[H>>2]=db;mc=Fb?pc:kc;n[J>>2]=mc;Fb=qc<oc;Gb=f[(Fb?K:I)>>2]|0;f[I>>2]=Gb;kc=Fb?oc:qc;n[K>>2]=kc;qc=(f[s>>2]=Gb,+n[s>>2]);Gb=mc<qc;Fb=f[(Gb?J:I)>>2]|0;f[I>>2]=Fb;oc=Gb?qc:mc;n[J>>2]=oc;mc=(f[s>>2]=Ja,+n[s>>2]);qc=(f[s>>2]=db,+n[s>>2]);db=qc<mc;Ja=f[(db?H:E)>>2]|0;f[E>>2]=Ja;pc=db?mc:qc;n[H>>2]=pc;db=oc<ma;Gb=f[(db?J:G)>>2]|0;f[G>>2]=Gb;qc=db?ma:oc;n[J>>2]=qc;oc=(f[s>>2]=Gb,+n[s>>2]);Gb=pc<oc;db=f[(Gb?H:G)>>2]|0;f[G>>2]=db;ma=Gb?oc:pc;n[H>>2]=ma;pc=(f[s>>2]=ab,+n[s>>2]);oc=(f[s>>2]=Fb,+n[s>>2]);Fb=oc<pc;ab=f[(Fb?I:F)>>2]|0;f[F>>2]=ab;mc=Fb?pc:oc;n[I>>2]=mc;Fb=kc<mc;Gb=f[(Fb?K:I)>>2]|0;f[I>>2]=Gb;oc=Fb?mc:kc;n[K>>2]=oc;kc=(f[s>>2]=ab,+n[s>>2]);mc=(f[s>>2]=db,+n[s>>2]);db=mc<kc;ab=f[(db?G:F)>>2]|0;f[F>>2]=ab;pc=db?kc:mc;n[G>>2]=pc;mc=(f[s>>2]=Gb,+n[s>>2]);Gb=mc<ma;f[H>>2]=f[(Gb?I:H)>>2];kc=Gb?ma:mc;n[I>>2]=kc;Gb=oc<qc;db=f[(Gb?K:J)>>2]|0;f[J>>2]=db;mc=Gb?qc:oc;n[K>>2]=mc;oc=+n[y>>2];qc=(f[s>>2]=Ja,+n[s>>2]);Ja=qc<oc;f[y>>2]=f[(Ja?E:y)>>2];ma=Ja?oc:qc;n[E>>2]=ma;qc=+n[C>>2];Ja=kc<qc;Gb=f[(Ja?I:C)>>2]|0;f[C>>2]=Gb;oc=Ja?qc:kc;n[I>>2]=oc;kc=(f[s>>2]=Gb,+n[s>>2]);Gb=ma<kc;Ja=f[(Gb?E:C)>>2]|0;f[C>>2]=Ja;qc=Gb?kc:ma;n[E>>2]=qc;ma=+n[A>>2];Gb=pc<ma;Fb=f[(Gb?G:A)>>2]|0;f[A>>2]=Fb;kc=Gb?ma:pc;n[G>>2]=kc;Gb=mc<kc;nb=f[(Gb?K:G)>>2]|0;f[G>>2]=nb;pc=Gb?kc:mc;n[K>>2]=pc;mc=(f[s>>2]=Fb,+n[s>>2]);kc=(f[s>>2]=Ja,+n[s>>2]);Ja=kc<mc;Fb=f[(Ja?C:A)>>2]|0;f[A>>2]=Fb;ma=Ja?mc:kc;n[C>>2]=ma;kc=(f[s>>2]=nb,+n[s>>2]);nb=kc<qc;Ja=f[(nb?G:E)>>2]|0;f[E>>2]=Ja;mc=nb?qc:kc;n[G>>2]=mc;nb=pc<oc;Gb=f[(nb?K:I)>>2]|0;f[I>>2]=Gb;kc=nb?oc:pc;n[K>>2]=kc;pc=+n[z>>2];oc=(f[s>>2]=ab,+n[s>>2]);ab=oc<pc;nb=f[(ab?F:z)>>2]|0;f[z>>2]=nb;qc=ab?pc:oc;n[F>>2]=qc;oc=+n[D>>2];pc=(f[s>>2]=db,+n[s>>2]);db=pc<oc;ab=f[(db?J:D)>>2]|0;f[D>>2]=ab;nc=db?oc:pc;n[J>>2]=nc;pc=(f[s>>2]=ab,+n[s>>2]);ab=qc<pc;db=f[(ab?F:D)>>2]|0;f[D>>2]=db;oc=ab?pc:qc;n[F>>2]=oc;qc=+n[B>>2];pc=+n[H>>2];ab=pc<qc;ra=f[(ab?H:B)>>2]|0;f[B>>2]=ra;lc=ab?qc:pc;n[H>>2]=lc;pc=(f[s>>2]=ra,+n[s>>2]);qc=(f[s>>2]=db,+n[s>>2]);db=qc<pc;ra=f[(db?D:B)>>2]|0;f[B>>2]=ra;tc=db?pc:qc;n[D>>2]=tc;db=lc<oc;ab=f[(db?H:F)>>2]|0;f[F>>2]=ab;qc=db?oc:lc;n[H>>2]=qc;lc=(f[s>>2]=nb,+n[s>>2]);oc=(f[s>>2]=Fb,+n[s>>2]);Fb=oc<lc;f[z>>2]=f[(Fb?A:z)>>2];pc=Fb?lc:oc;n[A>>2]=pc;oc=(f[s>>2]=ra,+n[s>>2]);ra=ma<oc;f[B>>2]=f[(ra?C:B)>>2];lc=ra?oc:ma;n[C>>2]=lc;ma=(f[s>>2]=Ja,+n[s>>2]);Ja=ma<tc;f[D>>2]=f[(Ja?E:D)>>2];oc=Ja?tc:ma;n[E>>2]=oc;ma=(f[s>>2]=ab,+n[s>>2]);ab=mc<ma;f[F>>2]=f[(ab?G:F)>>2];tc=ab?ma:mc;n[G>>2]=tc;mc=(f[s>>2]=Gb,+n[s>>2]);Gb=mc<qc;f[H>>2]=f[(Gb?I:H)>>2];ma=Gb?qc:mc;n[I>>2]=ma;Gb=kc<nc;f[J>>2]=f[(Gb?K:J)>>2];mc=Gb?nc:kc;n[K>>2]=mc;kc=+n[i>>2];nc=+n[y>>2];Gb=nc<kc;f[i>>2]=f[(Gb?y:i)>>2];qc=Gb?kc:nc;n[y>>2]=qc;nc=+n[t>>2];Gb=tc<nc;ab=f[(Gb?G:t)>>2]|0;f[t>>2]=ab;n[G>>2]=Gb?nc:tc;tc=(f[s>>2]=ab,+n[s>>2]);ab=qc<tc;f[t>>2]=f[(ab?y:t)>>2];nc=ab?tc:qc;n[y>>2]=nc;qc=+n[o>>2];ab=lc<qc;f[o>>2]=f[(ab?C:o)>>2];tc=ab?qc:lc;n[C>>2]=tc;ab=mc<tc;Gb=f[(ab?K:C)>>2]|0;f[C>>2]=Gb;n[K>>2]=ab?tc:mc;mc=(f[s>>2]=Gb,+n[s>>2]);Gb=mc<nc;ab=f[(Gb?C:y)>>2]|0;f[y>>2]=ab;n[C>>2]=Gb?nc:mc;mc=+n[l>>2];Gb=pc<mc;f[l>>2]=f[(Gb?A:l)>>2];nc=Gb?mc:pc;n[A>>2]=nc;Gb=f[(ma<+n[w>>2]?I:w)>>2]|0;f[w>>2]=Gb;Ja=f[(nc<(f[s>>2]=Gb,+n[s>>2])?A:w)>>2]|0;f[w>>2]=Ja;Gb=f[(oc<+n[q>>2]?E:q)>>2]|0;f[q>>2]=Gb;oc=(f[s>>2]=Gb,+n[s>>2]);nc=(f[s>>2]=Ja,+n[s>>2]);ma=nc<oc?oc:nc;n[w>>2]=ma;nc=(f[s>>2]=ab,+n[s>>2]);oc=nc<ma?ma:nc;nc=+n[k>>2];ma=+n[z>>2];pc=ma<nc?nc:ma;n[z>>2]=pc;ab=f[(+n[H>>2]<+n[v>>2]?H:v)>>2]|0;f[v>>2]=ab;ma=(f[s>>2]=ab,+n[s>>2]);nc=pc<ma?ma:pc;n[z>>2]=nc;pc=+n[p>>2];ma=+n[D>>2];mc=ma<pc?pc:ma;n[D>>2]=mc;ma=mc<nc?mc:+n[z>>2];mc=+n[m>>2];nc=+n[B>>2];pc=nc<mc?mc:nc;n[B>>2]=pc;ab=f[(+n[J>>2]<+n[x>>2]?J:x)>>2]|0;f[x>>2]=ab;Ja=pc<(f[s>>2]=ab,+n[s>>2]);pc=Ja?+n[B>>2]:(f[s>>2]=ab,+n[s>>2]);nc=+n[r>>2];mc=+n[F>>2];tc=mc<nc?mc:nc;nc=pc<tc?tc:pc;pc=ma<nc?ma:nc;n[na+(Ha<<2)>>2]=oc<pc?pc:oc;Ha=Ha+1|0}while((Ha|0)!=(cb|0));uc=cb}else uc=va;if((cb|0)==(ya|0))break;if((uc|0)>(Ga|0)){cb=ya;va=uc;continue}else vc=uc;while(1){Ha=Fa+(vc<<2)|0;f[i>>2]=f[Ha+(Da<<2)>>2];ab=f[Ha+(qa<<2)>>2]|0;f[k>>2]=ab;Ja=f[Ha>>2]|0;f[l>>2]=Ja;f[m>>2]=f[Ha+(da<<2)>>2];f[o>>2]=f[Ha+(za<<2)>>2];Ha=lb+(vc<<2)|0;f[p>>2]=f[Ha+(Da<<2)>>2];f[q>>2]=f[Ha+(qa<<2)>>2];f[r>>2]=f[Ha>>2];f[t>>2]=f[Ha+(da<<2)>>2];f[v>>2]=f[Ha+(za<<2)>>2];Ha=ca+(vc<<2)|0;f[w>>2]=f[Ha+(Da<<2)>>2];f[x>>2]=f[Ha+(qa<<2)>>2];f[y>>2]=f[Ha>>2];f[z>>2]=f[Ha+(da<<2)>>2];f[A>>2]=f[Ha+(za<<2)>>2];Ha=ja+(vc<<2)|0;f[B>>2]=f[Ha+(Da<<2)>>2];f[C>>2]=f[Ha+(qa<<2)>>2];f[D>>2]=f[Ha>>2];f[E>>2]=f[Ha+(da<<2)>>2];f[F>>2]=f[Ha+(za<<2)>>2];Ha=mb+(vc<<2)|0;f[G>>2]=f[Ha+(Da<<2)>>2];f[H>>2]=f[Ha+(qa<<2)>>2];f[I>>2]=f[Ha>>2];f[J>>2]=f[Ha+(da<<2)>>2];f[K>>2]=f[Ha+(za<<2)>>2];oc=(f[s>>2]=ab,+n[s>>2]);pc=(f[s>>2]=Ja,+n[s>>2]);Ja=pc<oc;ab=f[(Ja?l:k)>>2]|0;f[k>>2]=ab;nc=Ja?oc:pc;n[l>>2]=nc;pc=+n[i>>2];oc=(f[s>>2]=ab,+n[s>>2]);ab=oc<pc;Ja=f[(ab?k:i)>>2]|0;f[i>>2]=Ja;ma=ab?pc:oc;n[k>>2]=ma;ab=nc<ma;Ha=f[(ab?l:k)>>2]|0;f[k>>2]=Ha;oc=ab?ma:nc;n[l>>2]=oc;nc=+n[o>>2];ma=+n[p>>2];ab=ma<nc;Gb=f[(ab?p:o)>>2]|0;f[o>>2]=Gb;pc=ab?nc:ma;n[p>>2]=pc;ma=+n[m>>2];nc=(f[s>>2]=Gb,+n[s>>2]);Gb=nc<ma;ab=f[(Gb?o:m)>>2]|0;f[m>>2]=ab;tc=Gb?ma:nc;n[o>>2]=tc;Gb=pc<tc;ra=f[(Gb?p:o)>>2]|0;f[o>>2]=ra;nc=Gb?tc:pc;n[p>>2]=nc;pc=(f[s>>2]=Ja,+n[s>>2]);tc=(f[s>>2]=ab,+n[s>>2]);ab=tc<pc;f[i>>2]=f[(ab?m:i)>>2];ma=ab?pc:tc;n[m>>2]=ma;ab=nc<oc;Ja=f[(ab?p:l)>>2]|0;f[l>>2]=Ja;n[p>>2]=ab?oc:nc;nc=(f[s>>2]=Ja,+n[s>>2]);Ja=ma<nc;ab=f[(Ja?m:l)>>2]|0;f[l>>2]=ab;oc=Ja?nc:ma;n[m>>2]=oc;ma=(f[s>>2]=Ha,+n[s>>2]);nc=(f[s>>2]=ra,+n[s>>2]);ra=nc<ma;Ha=f[(ra?o:k)>>2]|0;f[k>>2]=Ha;tc=ra?ma:nc;n[o>>2]=tc;nc=(f[s>>2]=Ha,+n[s>>2]);ma=(f[s>>2]=ab,+n[s>>2]);ab=ma<nc;f[k>>2]=f[(ab?l:k)>>2];n[l>>2]=ab?nc:ma;ab=tc<oc;f[m>>2]=f[(ab?o:m)>>2];n[o>>2]=ab?oc:tc;tc=+n[r>>2];oc=+n[t>>2];ab=oc<tc;Ha=f[(ab?t:r)>>2]|0;f[r>>2]=Ha;ma=ab?tc:oc;n[t>>2]=ma;oc=+n[q>>2];tc=(f[s>>2]=Ha,+n[s>>2]);Ha=tc<oc;ab=f[(Ha?r:q)>>2]|0;f[q>>2]=ab;nc=Ha?oc:tc;n[r>>2]=nc;Ha=ma<nc;ra=f[(Ha?t:r)>>2]|0;f[r>>2]=ra;tc=Ha?nc:ma;n[t>>2]=tc;ma=+n[w>>2];nc=+n[x>>2];Ha=nc<ma;Ja=f[(Ha?x:w)>>2]|0;f[w>>2]=Ja;oc=Ha?ma:nc;n[x>>2]=oc;nc=+n[v>>2];ma=(f[s>>2]=Ja,+n[s>>2]);Ja=ma<nc;Ha=f[(Ja?w:v)>>2]|0;f[v>>2]=Ha;pc=Ja?nc:ma;n[w>>2]=pc;Ja=oc<pc;Gb=f[(Ja?x:w)>>2]|0;f[w>>2]=Gb;ma=Ja?pc:oc;n[x>>2]=ma;oc=(f[s>>2]=ab,+n[s>>2]);pc=(f[s>>2]=Ha,+n[s>>2]);Ha=pc<oc;ab=f[(Ha?v:q)>>2]|0;f[q>>2]=ab;nc=Ha?oc:pc;n[v>>2]=nc;Ha=ma<tc;Ja=f[(Ha?x:t)>>2]|0;f[t>>2]=Ja;pc=Ha?tc:ma;n[x>>2]=pc;ma=(f[s>>2]=Ja,+n[s>>2]);Ja=nc<ma;Ha=f[(Ja?v:t)>>2]|0;f[t>>2]=Ha;tc=Ja?ma:nc;n[v>>2]=tc;nc=(f[s>>2]=ra,+n[s>>2]);ma=(f[s>>2]=Gb,+n[s>>2]);Gb=ma<nc;ra=f[(Gb?w:r)>>2]|0;f[r>>2]=ra;oc=Gb?nc:ma;n[w>>2]=oc;ma=(f[s>>2]=ra,+n[s>>2]);nc=(f[s>>2]=Ha,+n[s>>2]);Ha=nc<ma;ra=f[(Ha?t:r)>>2]|0;f[r>>2]=ra;mc=Ha?ma:nc;n[t>>2]=mc;Ha=oc<tc;Gb=f[(Ha?w:v)>>2]|0;f[v>>2]=Gb;nc=Ha?tc:oc;n[w>>2]=nc;oc=+n[i>>2];tc=(f[s>>2]=ab,+n[s>>2]);ab=tc<oc;f[i>>2]=f[(ab?q:i)>>2];ma=ab?oc:tc;n[q>>2]=ma;tc=+n[o>>2];ab=nc<tc;Ha=f[(ab?w:o)>>2]|0;f[o>>2]=Ha;n[w>>2]=ab?tc:nc;nc=(f[s>>2]=Ha,+n[s>>2]);Ha=ma<nc;ab=f[(Ha?q:o)>>2]|0;f[o>>2]=ab;tc=Ha?nc:ma;n[q>>2]=tc;ma=+n[l>>2];Ha=mc<ma;Ja=f[(Ha?t:l)>>2]|0;f[l>>2]=Ja;nc=Ha?ma:mc;n[t>>2]=nc;mc=(f[s>>2]=Ja,+n[s>>2]);ma=(f[s>>2]=ab,+n[s>>2]);ab=ma<mc;Ja=f[(ab?o:l)>>2]|0;f[l>>2]=Ja;oc=ab?mc:ma;n[o>>2]=oc;ab=nc<tc;Ha=f[(ab?t:q)>>2]|0;f[q>>2]=Ha;ma=ab?tc:nc;n[t>>2]=ma;nc=+n[k>>2];tc=(f[s>>2]=ra,+n[s>>2]);ra=tc<nc;ab=f[(ra?r:k)>>2]|0;f[k>>2]=ab;mc=ra?nc:tc;n[r>>2]=mc;tc=+n[p>>2];ra=pc<tc;Fb=f[(ra?x:p)>>2]|0;f[p>>2]=Fb;n[x>>2]=ra?tc:pc;pc=(f[s>>2]=Fb,+n[s>>2]);Fb=mc<pc;ra=f[(Fb?r:p)>>2]|0;f[p>>2]=ra;tc=Fb?pc:mc;n[r>>2]=tc;mc=+n[m>>2];pc=(f[s>>2]=Gb,+n[s>>2]);Gb=pc<mc;Fb=f[(Gb?v:m)>>2]|0;f[m>>2]=Fb;nc=Gb?mc:pc;n[v>>2]=nc;pc=(f[s>>2]=Fb,+n[s>>2]);mc=(f[s>>2]=ra,+n[s>>2]);ra=mc<pc;Fb=f[(ra?p:m)>>2]|0;f[m>>2]=Fb;lc=ra?pc:mc;n[p>>2]=lc;ra=nc<tc;Gb=f[(ra?v:r)>>2]|0;f[r>>2]=Gb;mc=ra?tc:nc;n[v>>2]=mc;nc=(f[s>>2]=ab,+n[s>>2]);tc=(f[s>>2]=Ja,+n[s>>2]);Ja=tc<nc;f[k>>2]=f[(Ja?l:k)>>2];n[l>>2]=Ja?nc:tc;tc=(f[s>>2]=Fb,+n[s>>2]);Fb=oc<tc;f[m>>2]=f[(Fb?o:m)>>2];n[o>>2]=Fb?tc:oc;oc=(f[s>>2]=Ha,+n[s>>2]);Ha=oc<lc;f[p>>2]=f[(Ha?q:p)>>2];n[q>>2]=Ha?lc:oc;oc=(f[s>>2]=Gb,+n[s>>2]);Gb=ma<oc;f[r>>2]=f[(Gb?t:r)>>2];n[t>>2]=Gb?oc:ma;ma=+n[w>>2];Gb=ma<mc;f[v>>2]=f[(Gb?w:v)>>2];n[w>>2]=Gb?mc:ma;ma=+n[z>>2];mc=+n[A>>2];Gb=mc<ma;Ha=f[(Gb?A:z)>>2]|0;f[z>>2]=Ha;oc=Gb?ma:mc;n[A>>2]=oc;mc=+n[y>>2];ma=(f[s>>2]=Ha,+n[s>>2]);Ha=ma<mc;Gb=f[(Ha?z:y)>>2]|0;f[y>>2]=Gb;lc=Ha?mc:ma;n[z>>2]=lc;Ha=oc<lc;Fb=f[(Ha?A:z)>>2]|0;f[z>>2]=Fb;ma=Ha?lc:oc;n[A>>2]=ma;oc=+n[C>>2];lc=+n[D>>2];Ha=lc<oc;Ja=f[(Ha?D:C)>>2]|0;f[C>>2]=Ja;mc=Ha?oc:lc;n[D>>2]=mc;lc=+n[B>>2];oc=(f[s>>2]=Ja,+n[s>>2]);Ja=oc<lc;Ha=f[(Ja?C:B)>>2]|0;f[B>>2]=Ha;tc=Ja?lc:oc;n[C>>2]=tc;Ja=mc<tc;ab=f[(Ja?D:C)>>2]|0;f[C>>2]=ab;oc=Ja?tc:mc;n[D>>2]=oc;mc=(f[s>>2]=Gb,+n[s>>2]);tc=(f[s>>2]=Ha,+n[s>>2]);Ha=tc<mc;f[y>>2]=f[(Ha?B:y)>>2];lc=Ha?mc:tc;n[B>>2]=lc;Ha=oc<ma;Gb=f[(Ha?D:A)>>2]|0;f[A>>2]=Gb;n[D>>2]=Ha?ma:oc;oc=(f[s>>2]=Gb,+n[s>>2]);Gb=lc<oc;Ha=f[(Gb?B:A)>>2]|0;f[A>>2]=Ha;ma=Gb?oc:lc;n[B>>2]=ma;lc=(f[s>>2]=Fb,+n[s>>2]);oc=(f[s>>2]=ab,+n[s>>2]);ab=oc<lc;Fb=f[(ab?C:z)>>2]|0;f[z>>2]=Fb;tc=ab?lc:oc;n[C>>2]=tc;oc=(f[s>>2]=Fb,+n[s>>2]);lc=(f[s>>2]=Ha,+n[s>>2]);Ha=lc<oc;f[z>>2]=f[(Ha?A:z)>>2];n[A>>2]=Ha?oc:lc;Ha=tc<ma;f[B>>2]=f[(Ha?C:B)>>2];n[C>>2]=Ha?ma:tc;tc=+n[F>>2];ma=+n[G>>2];Ha=ma<tc;Fb=f[(Ha?G:F)>>2]|0;f[F>>2]=Fb;lc=Ha?tc:ma;n[G>>2]=lc;ma=+n[E>>2];tc=(f[s>>2]=Fb,+n[s>>2]);Fb=tc<ma;Ha=f[(Fb?F:E)>>2]|0;f[E>>2]=Ha;oc=Fb?ma:tc;n[F>>2]=oc;Fb=lc<oc;ab=f[(Fb?G:F)>>2]|0;f[F>>2]=ab;tc=Fb?oc:lc;n[G>>2]=tc;lc=+n[H>>2];oc=+n[I>>2];Fb=oc<lc;Gb=f[(Fb?I:H)>>2]|0;f[H>>2]=Gb;ma=Fb?lc:oc;n[I>>2]=ma;oc=+n[J>>2];lc=+n[K>>2];Fb=lc<oc;Ja=f[(Fb?K:J)>>2]|0;f[J>>2]=Ja;mc=Fb?oc:lc;n[K>>2]=mc;lc=(f[s>>2]=Gb,+n[s>>2]);oc=(f[s>>2]=Ja,+n[s>>2]);Ja=oc<lc;Gb=f[(Ja?J:H)>>2]|0;f[H>>2]=Gb;nc=Ja?lc:oc;n[J>>2]=nc;Ja=mc<ma;Fb=f[(Ja?K:I)>>2]|0;f[I>>2]=Fb;oc=Ja?ma:mc;n[K>>2]=oc;mc=(f[s>>2]=Fb,+n[s>>2]);Fb=nc<mc;Ja=f[(Fb?J:I)>>2]|0;f[I>>2]=Ja;ma=Fb?mc:nc;n[J>>2]=ma;nc=(f[s>>2]=Ha,+n[s>>2]);mc=(f[s>>2]=Gb,+n[s>>2]);Gb=mc<nc;Ha=f[(Gb?H:E)>>2]|0;f[E>>2]=Ha;lc=Gb?nc:mc;n[H>>2]=lc;Gb=ma<tc;Fb=f[(Gb?J:G)>>2]|0;f[G>>2]=Fb;mc=Gb?tc:ma;n[J>>2]=mc;ma=(f[s>>2]=Fb,+n[s>>2]);Fb=lc<ma;Gb=f[(Fb?H:G)>>2]|0;f[G>>2]=Gb;tc=Fb?ma:lc;n[H>>2]=tc;lc=(f[s>>2]=ab,+n[s>>2]);ma=(f[s>>2]=Ja,+n[s>>2]);Ja=ma<lc;ab=f[(Ja?I:F)>>2]|0;f[F>>2]=ab;nc=Ja?lc:ma;n[I>>2]=nc;Ja=oc<nc;Fb=f[(Ja?K:I)>>2]|0;f[I>>2]=Fb;ma=Ja?nc:oc;n[K>>2]=ma;oc=(f[s>>2]=ab,+n[s>>2]);nc=(f[s>>2]=Gb,+n[s>>2]);Gb=nc<oc;ab=f[(Gb?G:F)>>2]|0;f[F>>2]=ab;lc=Gb?oc:nc;n[G>>2]=lc;nc=(f[s>>2]=Fb,+n[s>>2]);Fb=nc<tc;f[H>>2]=f[(Fb?I:H)>>2];oc=Fb?tc:nc;n[I>>2]=oc;Fb=ma<mc;Gb=f[(Fb?K:J)>>2]|0;f[J>>2]=Gb;nc=Fb?mc:ma;n[K>>2]=nc;ma=+n[y>>2];mc=(f[s>>2]=Ha,+n[s>>2]);Ha=mc<ma;f[y>>2]=f[(Ha?E:y)>>2];tc=Ha?ma:mc;n[E>>2]=tc;mc=+n[C>>2];Ha=oc<mc;Fb=f[(Ha?I:C)>>2]|0;f[C>>2]=Fb;ma=Ha?mc:oc;n[I>>2]=ma;oc=(f[s>>2]=Fb,+n[s>>2]);Fb=tc<oc;Ha=f[(Fb?E:C)>>2]|0;f[C>>2]=Ha;mc=Fb?oc:tc;n[E>>2]=mc;tc=+n[A>>2];Fb=lc<tc;Ja=f[(Fb?G:A)>>2]|0;f[A>>2]=Ja;oc=Fb?tc:lc;n[G>>2]=oc;Fb=nc<oc;ra=f[(Fb?K:G)>>2]|0;f[G>>2]=ra;lc=Fb?oc:nc;n[K>>2]=lc;nc=(f[s>>2]=Ja,+n[s>>2]);oc=(f[s>>2]=Ha,+n[s>>2]);Ha=oc<nc;Ja=f[(Ha?C:A)>>2]|0;f[A>>2]=Ja;tc=Ha?nc:oc;n[C>>2]=tc;oc=(f[s>>2]=ra,+n[s>>2]);ra=oc<mc;Ha=f[(ra?G:E)>>2]|0;f[E>>2]=Ha;nc=ra?mc:oc;n[G>>2]=nc;ra=lc<ma;Fb=f[(ra?K:I)>>2]|0;f[I>>2]=Fb;oc=ra?ma:lc;n[K>>2]=oc;lc=+n[z>>2];ma=(f[s>>2]=ab,+n[s>>2]);ab=ma<lc;ra=f[(ab?F:z)>>2]|0;f[z>>2]=ra;mc=ab?lc:ma;n[F>>2]=mc;ma=+n[D>>2];lc=(f[s>>2]=Gb,+n[s>>2]);Gb=lc<ma;ab=f[(Gb?J:D)>>2]|0;f[D>>2]=ab;pc=Gb?ma:lc;n[J>>2]=pc;lc=(f[s>>2]=ab,+n[s>>2]);ab=mc<lc;Gb=f[(ab?F:D)>>2]|0;f[D>>2]=Gb;ma=ab?lc:mc;n[F>>2]=ma;mc=+n[B>>2];lc=+n[H>>2];ab=lc<mc;nb=f[(ab?H:B)>>2]|0;f[B>>2]=nb;qc=ab?mc:lc;n[H>>2]=qc;lc=(f[s>>2]=nb,+n[s>>2]);mc=(f[s>>2]=Gb,+n[s>>2]);Gb=mc<lc;nb=f[(Gb?D:B)>>2]|0;f[B>>2]=nb;kc=Gb?lc:mc;n[D>>2]=kc;Gb=qc<ma;ab=f[(Gb?H:F)>>2]|0;f[F>>2]=ab;mc=Gb?ma:qc;n[H>>2]=mc;qc=(f[s>>2]=ra,+n[s>>2]);ma=(f[s>>2]=Ja,+n[s>>2]);Ja=ma<qc;f[z>>2]=f[(Ja?A:z)>>2];lc=Ja?qc:ma;n[A>>2]=lc;ma=(f[s>>2]=nb,+n[s>>2]);nb=tc<ma;f[B>>2]=f[(nb?C:B)>>2];qc=nb?ma:tc;n[C>>2]=qc;tc=(f[s>>2]=Ha,+n[s>>2]);Ha=tc<kc;f[D>>2]=f[(Ha?E:D)>>2];ma=Ha?kc:tc;n[E>>2]=ma;tc=(f[s>>2]=ab,+n[s>>2]);ab=nc<tc;f[F>>2]=f[(ab?G:F)>>2];kc=ab?tc:nc;n[G>>2]=kc;nc=(f[s>>2]=Fb,+n[s>>2]);Fb=nc<mc;f[H>>2]=f[(Fb?I:H)>>2];tc=Fb?mc:nc;n[I>>2]=tc;Fb=oc<pc;f[J>>2]=f[(Fb?K:J)>>2];nc=Fb?pc:oc;n[K>>2]=nc;oc=+n[i>>2];pc=+n[y>>2];Fb=pc<oc;f[i>>2]=f[(Fb?y:i)>>2];mc=Fb?oc:pc;n[y>>2]=mc;pc=+n[t>>2];Fb=kc<pc;ab=f[(Fb?G:t)>>2]|0;f[t>>2]=ab;n[G>>2]=Fb?pc:kc;kc=(f[s>>2]=ab,+n[s>>2]);ab=mc<kc;f[t>>2]=f[(ab?y:t)>>2];pc=ab?kc:mc;n[y>>2]=pc;mc=+n[o>>2];ab=qc<mc;f[o>>2]=f[(ab?C:o)>>2];kc=ab?mc:qc;n[C>>2]=kc;ab=nc<kc;Fb=f[(ab?K:C)>>2]|0;f[C>>2]=Fb;n[K>>2]=ab?kc:nc;nc=(f[s>>2]=Fb,+n[s>>2]);Fb=nc<pc;ab=f[(Fb?C:y)>>2]|0;f[y>>2]=ab;n[C>>2]=Fb?pc:nc;nc=+n[l>>2];Fb=lc<nc;f[l>>2]=f[(Fb?A:l)>>2];pc=Fb?nc:lc;n[A>>2]=pc;Fb=f[(tc<+n[w>>2]?I:w)>>2]|0;f[w>>2]=Fb;Ha=f[(pc<(f[s>>2]=Fb,+n[s>>2])?A:w)>>2]|0;f[w>>2]=Ha;Fb=f[(ma<+n[q>>2]?E:q)>>2]|0;f[q>>2]=Fb;ma=(f[s>>2]=Fb,+n[s>>2]);pc=(f[s>>2]=Ha,+n[s>>2]);tc=pc<ma?ma:pc;n[w>>2]=tc;pc=(f[s>>2]=ab,+n[s>>2]);ma=pc<tc?tc:pc;pc=+n[k>>2];tc=+n[z>>2];lc=tc<pc?pc:tc;n[z>>2]=lc;ab=f[(+n[H>>2]<+n[v>>2]?H:v)>>2]|0;f[v>>2]=ab;tc=(f[s>>2]=ab,+n[s>>2]);pc=lc<tc?tc:lc;n[z>>2]=pc;lc=+n[p>>2];tc=+n[D>>2];nc=tc<lc?lc:tc;n[D>>2]=nc;tc=nc<pc?nc:+n[z>>2];nc=+n[m>>2];pc=+n[B>>2];lc=pc<nc?nc:pc;n[B>>2]=lc;ab=f[(+n[J>>2]<+n[x>>2]?J:x)>>2]|0;f[x>>2]=ab;Ha=lc<(f[s>>2]=ab,+n[s>>2]);lc=Ha?+n[B>>2]:(f[s>>2]=ab,+n[s>>2]);pc=+n[r>>2];nc=+n[F>>2];kc=nc<pc?nc:pc;pc=lc<kc?kc:lc;lc=tc<pc?tc:pc;n[na+(vc<<2)>>2]=ma<lc?lc:ma;ab=vc+1|0;if((vc|0)<(Ga|0))vc=ab;else{cb=ya;va=ab;continue k}}}if((la|0)==(Ca|0))break;else na=na+(ta<<2)|0}break}default:break a}break}default:{f[i>>2]=0;f[i+4>>2]=0;Vxa(-210,i,286978,1213)}}}while(0);i=O+36|0;vc=f[i>>2]|0;if(vc|0?(F=vc+12|0,vc=f[F>>2]|0,f[F>>2]=vc+-1,(vc|0)==1):0)_S(O);f[i>>2]=0;i=O+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[P>>2]|0)>0){i=f[Z>>2]|0;Z=0;do{f[i+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[P>>2]|0))}P=f[W>>2]|0;if((P|0)!=(V|0))g0(P);P=N+36|0;V=f[P>>2]|0;if(V|0?(W=V+12|0,V=f[W>>2]|0,f[W>>2]=V+-1,(V|0)==1):0)_S(N);f[P>>2]=0;P=N+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[P>>2]|0)>0){aa=f[N+40>>2]|0;V=0;do{f[aa+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[P>>2]|0))}P=f[N+44>>2]|0;if((P|0)!=(N+48|0))g0(P);P=L+36|0;N=f[P>>2]|0;if(N|0?(V=N+12|0,N=f[V>>2]|0,f[V>>2]=N+-1,(N|0)==1):0)_S(L);f[P>>2]=0;P=L+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[P>>2]|0)>0){U=f[$>>2]|0;$=0;do{f[U+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[P>>2]|0))}P=f[L+44>>2]|0;if((P|0)!=(L+48|0))g0(P);u=g;return}t$(a,c);u=g;return}function Vxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,287111,d);return}function Wxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0;e=u;u=u+128|0;g=e+100|0;i=e;j=f[a+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=f[c+48>>2]|0;n=f[c+40>>2]|0;c=f[n+4>>2]|0;o=f[n>>2]|0;n=(f[a>>2]|0)>>>3;a=n&511;p=a+1|0;switch(d|0){case 3:{d=(o|0)==1;if((c|0)==1|d){q=o+c|0;r=q+-1|0;s=d?p:l;t=d?0:l-p|0;v=d?p:m;if((q|0)<=1){u=e;return}d=0-s|0;w=q+-2|0;q=j;x=k;y=0;while(1){z=(y|0)>0?d:0;A=(y|0)<(w|0)?s:0;B=0;C=q;while(1){D=h[C+z>>0]|0;E=h[C>>0]|0;F=D-E+256|0;if(F>>>0<769)G=h[271964+F>>0]|0;else G=0;F=G+E|0;E=F-(h[C+A>>0]|0)+256|0;if(E>>>0<769)H=h[271964+E>>0]|0;else H=0;E=F-H|0;F=(D|256)-G-E|0;if(F>>>0<769)I=h[271964+F>>0]|0;else I=0;b[x+B>>0]=I+E;B=B+1|0;if((B|0)==(p|0))break;else C=C+1|0}y=y+1|0;if((y|0)>=(r|0))break;else{q=q+p+t|0;x=x+v|0}}u=e;return}v=Y(p,c)|0;if((o|0)<=0){u=e;return}x=o+-1|0;t=(n|-512)^511;q=t+-1+v|0;r=v-p|0;y=k;I=0;while(1){G=I+-1|0;H=j+(Y((G|0)>0?G:0,l)|0)|0;G=j+(Y(I,l)|0)|0;I=I+1|0;s=j+(Y((x|0)<(I|0)?x:I,l)|0)|0;w=p;d=0;a:while(1){if((d|0)<(w|0)){C=d;do{B=C-((C|0)>(a|0)?p:0)|0;A=((C|0)<(r|0)?p:0)+C|0;z=h[H+B>>0]|0;E=h[H+C>>0]|0;F=h[H+A>>0]|0;D=h[G+B>>0]|0;J=h[G+C>>0]|0;K=h[G+A>>0]|0;L=h[s+B>>0]|0;B=h[s+C>>0]|0;M=h[s+A>>0]|0;A=E-F+256|0;if(A>>>0<769)N=h[271964+A>>0]|0;else N=0;A=N+F|0;F=E-N|0;E=J-K+256|0;if(E>>>0<769)O=h[271964+E>>0]|0;else O=0;E=O+K|0;K=J-O|0;J=B-M+256|0;if(J>>>0<769)P=h[271964+J>>0]|0;else P=0;J=P+M|0;M=B-P|0;B=z-F+256|0;if(B>>>0<769)Q=h[271964+B>>0]|0;else Q=0;B=Q+F|0;F=D-K+256|0;if(F>>>0<769)R=h[271964+F>>0]|0;else R=0;F=R+K|0;K=D-R|0;D=L-M+256|0;if(D>>>0<769)S=h[271964+D>>0]|0;else S=0;D=S+M|0;M=L-S|0;L=B-A+256|0;if(L>>>0<769)T=h[271964+L>>0]|0;else T=0;L=T+A|0;A=F-E+256|0;if(A>>>0<769)U=h[271964+A>>0]|0;else U=0;A=U+E|0;E=F-U|0;F=D-J+256|0;if(F>>>0<769)V=h[271964+F>>0]|0;else V=0;F=D-V|0;D=(z|256)-Q-K|0;if(D>>>0<769)W=h[271964+D>>0]|0;else W=0;D=256-J+A-V|0;if(D>>>0<769)X=h[271964+D>>0]|0;else X=0;D=E-F+256|0;if(D>>>0<769)Z=h[271964+D>>0]|0;else Z=0;D=E-Z|0;E=K+256-M+W|0;if(E>>>0<769)_=h[271964+E>>0]|0;else _=0;E=B+256-T-D|0;if(E>>>0<769)$=h[271964+E>>0]|0;else $=0;E=$+D|0;D=L+256-A+X|0;if(D>>>0<769)aa=h[271964+D>>0]|0;else aa=0;D=L-aa|0;L=256-F-Z+E|0;if(L>>>0<769)ba=h[271964+L>>0]|0;else ba=0;L=E-ba|0;E=L-D+256|0;if(E>>>0<769)ca=h[271964+E>>0]|0;else ca=0;E=L-ca|0;L=M+256+_-E|0;if(L>>>0<769)da=h[271964+L>>0]|0;else da=0;L=da+E|0;E=256-D-ca+L|0;if(E>>>0<769)ea=h[271964+E>>0]|0;else ea=0;b[y+C>>0]=L-ea;C=C+1|0}while((C|0)!=(w|0));fa=w}else fa=d;if((w|0)==(v|0))break;if((fa|0)>(q|0)){w=v;d=fa;continue}else ga=fa;while(1){C=H+ga|0;L=h[C+t>>0]|0;E=h[C>>0]|0;D=h[C+p>>0]|0;C=G+ga|0;M=h[C+t>>0]|0;F=h[C>>0]|0;A=h[C+p>>0]|0;C=s+ga|0;B=h[C+t>>0]|0;K=h[C>>0]|0;J=h[C+p>>0]|0;C=E-D+256|0;if(C>>>0<769)ha=h[271964+C>>0]|0;else ha=0;C=ha+D|0;D=E-ha|0;E=F-A+256|0;if(E>>>0<769)ia=h[271964+E>>0]|0;else ia=0;E=ia+A|0;A=F-ia|0;F=K-J+256|0;if(F>>>0<769)ja=h[271964+F>>0]|0;else ja=0;F=ja+J|0;J=K-ja|0;K=L-D+256|0;if(K>>>0<769)ka=h[271964+K>>0]|0;else ka=0;K=ka+D|0;D=M-A+256|0;if(D>>>0<769)la=h[271964+D>>0]|0;else la=0;D=la+A|0;A=M-la|0;M=B-J+256|0;if(M>>>0<769)ma=h[271964+M>>0]|0;else ma=0;M=ma+J|0;J=B-ma|0;B=K-C+256|0;if(B>>>0<769)na=h[271964+B>>0]|0;else na=0;B=na+C|0;C=D-E+256|0;if(C>>>0<769)oa=h[271964+C>>0]|0;else oa=0;C=oa+E|0;E=D-oa|0;D=M-F+256|0;if(D>>>0<769)pa=h[271964+D>>0]|0;else pa=0;D=M-pa|0;M=(L|256)-ka-A|0;if(M>>>0<769)qa=h[271964+M>>0]|0;else qa=0;M=256-F+C-pa|0;if(M>>>0<769)ra=h[271964+M>>0]|0;else ra=0;M=E-D+256|0;if(M>>>0<769)sa=h[271964+M>>0]|0;else sa=0;M=E-sa|0;E=A+256-J+qa|0;if(E>>>0<769)ta=h[271964+E>>0]|0;else ta=0;E=K+256-na-M|0;if(E>>>0<769)ua=h[271964+E>>0]|0;else ua=0;E=ua+M|0;M=B+256-C+ra|0;if(M>>>0<769)va=h[271964+M>>0]|0;else va=0;M=B-va|0;B=256-D-sa+E|0;if(B>>>0<769)wa=h[271964+B>>0]|0;else wa=0;B=E-wa|0;E=B-M+256|0;if(E>>>0<769)xa=h[271964+E>>0]|0;else xa=0;E=B-xa|0;B=J+256+ta-E|0;if(B>>>0<769)ya=h[271964+B>>0]|0;else ya=0;B=ya+E|0;E=256-M-xa+B|0;if(E>>>0<769)za=h[271964+E>>0]|0;else za=0;b[y+ga>>0]=B-za;B=ga+1|0;if((ga|0)<(q|0))ga=B;else{w=v;d=B;continue a}}}if((I|0)==(o|0))break;else y=y+m|0}u=e;return}case 5:{y=(o|0)==1;if((c|0)==1|y){I=o+c|0;v=I+-1|0;ga=y?p:l;q=y?0:l-p|0;za=y?p:m;if((I|0)<=1){u=e;return}y=0-ga|0;xa=y<<1;ya=I+-2|0;ta=I+-3|0;I=ga<<1;wa=j;sa=k;va=0;while(1){ra=(va|0)>0?y:0;ua=(va|0)>1?xa:ra;na=(va|0)<(ya|0)?ga:0;qa=(va|0)<(ta|0)?I:na;pa=wa;ka=0;while(1){oa=h[pa+ua>>0]|0;ma=h[pa+ra>>0]|0;la=h[pa>>0]|0;ja=h[pa+na>>0]|0;ia=h[pa+qa>>0]|0;ha=oa-ma+256|0;if(ha>>>0<769)Aa=h[271964+ha>>0]|0;else Aa=0;ha=ja-ia+256|0;if(ha>>>0<769)Ba=h[271964+ha>>0]|0;else Ba=0;ha=Ba+ia|0;ia=ja-Ba|0;ja=la-ia+256|0;if(ja>>>0<769)Ca=h[271964+ja>>0]|0;else Ca=0;ja=Ca+ia|0;ia=la-Ca|0;la=ja-ha+256|0;if(la>>>0<769)Da=h[271964+la>>0]|0;else Da=0;la=(oa|256)-Aa-ia|0;if(la>>>0<769)Ea=h[271964+la>>0]|0;else Ea=0;la=Ea+ia|0;ia=256-ha-Da+la|0;if(ia>>>0<769)Fa=h[271964+ia>>0]|0;else Fa=0;ia=la-Fa|0;la=Aa+ma+256|0;ma=la-ja+Da|0;if(ma>>>0<769)Ga=h[271964+ma>>0]|0;else Ga=0;ma=la-ia-Ga|0;if(ma>>>0<769)Ha=h[271964+ma>>0]|0;else Ha=0;b[sa+ka>>0]=Ha+ia;ka=ka+1|0;if((ka|0)==(p|0))break;else pa=pa+1|0}va=va+1|0;if((va|0)>=(v|0))break;else{wa=wa+p+q|0;sa=sa+za|0}}u=e;return}za=Y(p,c)|0;if((o|0)<=0){u=e;return}c=g+4|0;sa=g+8|0;q=o+-1|0;wa=g+12|0;v=g+16|0;va=p<<1;Ha=0-va|0;Ga=za+-1-va|0;Da=(n|-512)^511;n=i+4|0;Aa=i+8|0;Fa=i+16|0;Ea=i+20|0;Ca=i+12|0;Ba=i+28|0;I=i+32|0;ta=i+24|0;ga=i+40|0;ya=i+44|0;xa=i+36|0;y=i+52|0;pa=i+56|0;ka=i+48|0;qa=i+64|0;na=i+68|0;ra=i+60|0;ua=i+76|0;ia=i+80|0;ma=i+72|0;la=i+84|0;ja=i+88|0;ha=i+92|0;oa=i+96|0;t=za-p|0;fa=za-va|0;ea=i+4|0;ca=i+8|0;da=i+16|0;_=i+20|0;ba=i+12|0;Z=i+28|0;aa=i+32|0;X=i+24|0;$=i+40|0;T=i+44|0;W=i+36|0;V=i+52|0;Q=i+56|0;U=i+48|0;S=i+64|0;R=i+68|0;P=i+60|0;O=i+76|0;N=i+80|0;r=i+72|0;x=i+84|0;d=i+88|0;w=i+92|0;s=i+96|0;G=k;k=0;while(1){H=k+-2|0;B=j+(Y((H|0)>0?H:0,l)|0)|0;f[g>>2]=B;B=k+-1|0;H=j+(Y((B|0)>0?B:0,l)|0)|0;f[c>>2]=H;H=j+(Y(k,l)|0)|0;f[sa>>2]=H;H=k;k=k+1|0;B=j+(Y((q|0)<(k|0)?q:k,l)|0)|0;f[wa>>2]=B;B=H+2|0;H=j+(Y((q|0)<(B|0)?q:B,l)|0)|0;f[v>>2]=H;H=va;B=0;b:while(1){if((B|0)<(H|0)){E=B;do{M=E-((E|0)>(a|0)?p:0)|0;J=(E|0)<(va|0)?M:E-va|0;D=((E|0)<(t|0)?p:0)+E|0;C=(E|0)<(fa|0)?E+va|0:D;K=f[g>>2]|0;f[i>>2]=h[K+J>>0];A=h[K+M>>0]|0;f[ea>>2]=A;F=h[K+E>>0]|0;f[ca>>2]=F;L=h[K+D>>0]|0;f[ba>>2]=L;z=h[K+C>>0]|0;f[da>>2]=z;K=f[c>>2]|0;Ia=h[K+J>>0]|0;f[_>>2]=Ia;Ja=h[K+M>>0]|0;f[X>>2]=Ja;Ka=h[K+E>>0]|0;f[Z>>2]=Ka;La=h[K+D>>0]|0;f[aa>>2]=La;Ma=h[K+C>>0]|0;f[W>>2]=Ma;K=f[sa>>2]|0;Na=h[K+J>>0]|0;f[$>>2]=Na;Oa=h[K+M>>0]|0;f[T>>2]=Oa;Pa=h[K+E>>0]|0;f[U>>2]=Pa;Qa=h[K+D>>0]|0;f[V>>2]=Qa;Ra=h[K+C>>0]|0;f[Q>>2]=Ra;K=f[wa>>2]|0;Sa=h[K+J>>0]|0;f[P>>2]=Sa;Ta=h[K+M>>0]|0;f[S>>2]=Ta;Ua=h[K+E>>0]|0;f[R>>2]=Ua;Va=h[K+D>>0]|0;f[r>>2]=Va;Wa=h[K+C>>0]|0;f[O>>2]=Wa;K=f[v>>2]|0;Xa=h[K+J>>0]|0;f[N>>2]=Xa;J=h[K+M>>0]|0;f[x>>2]=J;M=h[K+E>>0]|0;f[d>>2]=M;Ya=h[K+D>>0]|0;f[w>>2]=Ya;D=h[K+C>>0]|0;f[s>>2]=D;C=A-F+256|0;if(C>>>0<769)Za=h[271964+C>>0]|0;else Za=0;C=Za+F|0;f[ca>>2]=C;F=(f[ea>>2]|0)-Za|0;f[ea>>2]=F;A=f[i>>2]|0;K=A-F+256|0;if(K>>>0<769)_a=h[271964+K>>0]|0;else _a=0;K=_a+F|0;f[ea>>2]=K;F=A-_a|0;f[i>>2]=F;A=K-C+256|0;if(A>>>0<769)$a=h[271964+A>>0]|0;else $a=0;A=$a+C|0;f[ca>>2]=A;C=K-$a|0;f[ea>>2]=C;K=z-Ia+256|0;if(K>>>0<769)ab=h[271964+K>>0]|0;else ab=0;K=ab+Ia|0;f[_>>2]=K;Ia=z-ab|0;f[da>>2]=Ia;z=L-Ia+256|0;if(z>>>0<769)bb=h[271964+z>>0]|0;else bb=0;z=bb+Ia|0;f[da>>2]=z;Ia=L-bb|0;f[ba>>2]=Ia;L=z-K+256|0;if(L>>>0<769)cb=h[271964+L>>0]|0;else cb=0;L=cb+K|0;f[_>>2]=L;K=z-cb|0;f[da>>2]=K;z=F-Ia+256|0;if(z>>>0<769)db=h[271964+z>>0]|0;else db=0;z=db+Ia|0;f[ba>>2]=z;Ia=F-db|0;f[i>>2]=Ia;F=A-L+256|0;if(F>>>0<769)eb=h[271964+F>>0]|0;else eb=0;F=eb+L|0;f[_>>2]=F;L=A-eb|0;f[ca>>2]=L;A=L-z+256|0;if(A>>>0<769)fb=h[271964+A>>0]|0;else fb=0;A=fb+z|0;f[ba>>2]=A;z=L-fb|0;f[ca>>2]=z;L=C-K+256|0;if(L>>>0<769)gb=h[271964+L>>0]|0;else gb=0;L=gb+K|0;f[da>>2]=L;K=C-gb|0;f[ea>>2]=K;C=K-z+256|0;if(C>>>0<769)hb=h[271964+C>>0]|0;else hb=0;C=hb+z|0;f[ca>>2]=C;z=K-hb|0;f[ea>>2]=z;K=A-L+256|0;if(K>>>0<769)ib=h[271964+K>>0]|0;else ib=0;K=ib+L|0;f[da>>2]=K;L=A-ib|0;f[ba>>2]=L;A=Ka-La+256|0;if(A>>>0<769)jb=h[271964+A>>0]|0;else jb=0;A=jb+La|0;f[aa>>2]=A;La=Ka-jb|0;f[Z>>2]=La;Ka=Ja-La+256|0;if(Ka>>>0<769)kb=h[271964+Ka>>0]|0;else kb=0;Ka=kb+La|0;f[Z>>2]=Ka;La=Ja-kb|0;f[X>>2]=La;Ja=Ka-A+256|0;if(Ja>>>0<769)lb=h[271964+Ja>>0]|0;else lb=0;Ja=lb+A|0;f[aa>>2]=Ja;A=Ka-lb|0;f[Z>>2]=A;Ka=Na-Oa+256|0;if(Ka>>>0<769)mb=h[271964+Ka>>0]|0;else mb=0;Ka=mb+Oa|0;f[T>>2]=Ka;Oa=Na-mb|0;f[$>>2]=Oa;Na=Ma-Oa+256|0;if(Na>>>0<769)nb=h[271964+Na>>0]|0;else nb=0;Na=nb+Oa|0;f[$>>2]=Na;Oa=Ma-nb|0;f[W>>2]=Oa;Ma=Na-Ka+256|0;if(Ma>>>0<769)ob=h[271964+Ma>>0]|0;else ob=0;Ma=ob+Ka|0;f[T>>2]=Ma;Ka=Na-ob|0;f[$>>2]=Ka;Na=La-Oa+256|0;if(Na>>>0<769)pb=h[271964+Na>>0]|0;else pb=0;Na=pb+Oa|0;f[W>>2]=Na;Oa=La-pb|0;f[X>>2]=Oa;La=Ja-Ma+256|0;if(La>>>0<769)qb=h[271964+La>>0]|0;else qb=0;La=qb+Ma|0;f[T>>2]=La;Ma=Ja-qb|0;f[aa>>2]=Ma;Ja=Ma-Na+256|0;if(Ja>>>0<769)rb=h[271964+Ja>>0]|0;else rb=0;Ja=rb+Na|0;f[W>>2]=Ja;Na=Ma-rb|0;f[aa>>2]=Na;Ma=A-Ka+256|0;if(Ma>>>0<769)sb=h[271964+Ma>>0]|0;else sb=0;Ma=sb+Ka|0;f[$>>2]=Ma;Ka=A-sb|0;f[Z>>2]=Ka;A=Ka-Na+256|0;if(A>>>0<769)tb=h[271964+A>>0]|0;else tb=0;A=tb+Na|0;f[aa>>2]=A;Na=Ka-tb|0;f[Z>>2]=Na;Ka=Ja-Ma+256|0;if(Ka>>>0<769)ub=h[271964+Ka>>0]|0;else ub=0;Ka=ub+Ma|0;f[$>>2]=Ka;Ma=Ja-ub|0;f[W>>2]=Ma;Ja=Ia-Oa+256|0;if(Ja>>>0<769)vb=h[271964+Ja>>0]|0;else vb=0;Ja=vb+Oa|0;f[X>>2]=Ja;Oa=Ia-vb|0;f[i>>2]=Oa;Ia=K-Ka+256|0;if(Ia>>>0<769)wb=h[271964+Ia>>0]|0;else wb=0;Ia=wb+Ka|0;f[$>>2]=Ia;Ka=K-wb|0;f[da>>2]=Ka;K=Ka-Ja+256|0;if(K>>>0<769)xb=h[271964+K>>0]|0;else xb=0;K=xb+Ja|0;f[X>>2]=K;Ja=Ka-xb|0;f[da>>2]=Ja;Ka=C-A+256|0;if(Ka>>>0<769)yb=h[271964+Ka>>0]|0;else yb=0;Ka=yb+A|0;f[aa>>2]=Ka;A=C-yb|0;f[ca>>2]=A;C=A-Ja+256|0;if(C>>>0<769)zb=h[271964+C>>0]|0;else zb=0;C=zb+Ja|0;f[da>>2]=C;Ja=A-zb|0;f[ca>>2]=Ja;A=K-Ka+256|0;if(A>>>0<769)Ab=h[271964+A>>0]|0;else Ab=0;A=Ab+Ka|0;f[aa>>2]=A;Ka=K-Ab|0;f[X>>2]=Ka;K=z-Na+256|0;if(K>>>0<769)Bb=h[271964+K>>0]|0;else Bb=0;K=Bb+Na|0;f[Z>>2]=K;Na=z-Bb|0;f[ea>>2]=Na;z=F-La+256|0;if(z>>>0<769)Cb=h[271964+z>>0]|0;else Cb=0;z=Cb+La|0;f[T>>2]=z;La=F-Cb|0;f[_>>2]=La;F=La-K+256|0;if(F>>>0<769)Db=h[271964+F>>0]|0;else Db=0;F=Db+K|0;f[Z>>2]=F;K=La-Db|0;f[_>>2]=K;La=L-Ma+256|0;if(La>>>0<769)Eb=h[271964+La>>0]|0;else Eb=0;La=Eb+Ma|0;f[W>>2]=La;Ma=L-Eb|0;f[ba>>2]=Ma;L=Ma-K+256|0;if(L>>>0<769)Fb=h[271964+L>>0]|0;else Fb=0;L=Fb+K|0;f[_>>2]=L;K=Ma-Fb|0;f[ba>>2]=K;Ma=F-La+256|0;if(Ma>>>0<769)Gb=h[271964+Ma>>0]|0;else Gb=0;Ma=Gb+La|0;f[W>>2]=Ma;La=F-Gb|0;f[Z>>2]=La;F=Na-Ja+256|0;if(F>>>0<769)Hb=h[271964+F>>0]|0;else Hb=0;F=Hb+Ja|0;f[ca>>2]=F;Ja=Na-Hb|0;f[ea>>2]=Ja;Na=K-C+256|0;if(Na>>>0<769)Ib=h[271964+Na>>0]|0;else Ib=0;Na=Ib+C|0;f[da>>2]=Na;C=K-Ib|0;f[ba>>2]=C;K=L-Ka+256|0;if(K>>>0<769)Jb=h[271964+K>>0]|0;else Jb=0;K=Jb+Ka|0;f[X>>2]=K;Ka=L-Jb|0;f[_>>2]=Ka;L=La-A+256|0;if(L>>>0<769)Kb=h[271964+L>>0]|0;else Kb=0;L=Kb+A|0;f[aa>>2]=L;A=La-Kb|0;f[Z>>2]=A;La=Ma-Ia+256|0;if(La>>>0<769)Lb=h[271964+La>>0]|0;else Lb=0;La=Lb+Ia|0;f[$>>2]=La;Ia=Ma-Lb|0;f[W>>2]=Ia;Ma=Qa-Ra+256|0;if(Ma>>>0<769)Mb=h[271964+Ma>>0]|0;else Mb=0;Ma=Mb+Ra|0;f[Q>>2]=Ma;Ra=Qa-Mb|0;f[V>>2]=Ra;Qa=Pa-Ra+256|0;if(Qa>>>0<769)Nb=h[271964+Qa>>0]|0;else Nb=0;Qa=Nb+Ra|0;f[V>>2]=Qa;Ra=Pa-Nb|0;f[U>>2]=Ra;Pa=Qa-Ma+256|0;if(Pa>>>0<769)Ob=h[271964+Pa>>0]|0;else Ob=0;Pa=Ob+Ma|0;f[Q>>2]=Pa;Ma=Qa-Ob|0;f[V>>2]=Ma;Qa=Ta-Ua+256|0;if(Qa>>>0<769)Pb=h[271964+Qa>>0]|0;else Pb=0;Qa=Pb+Ua|0;f[R>>2]=Qa;Ua=Ta-Pb|0;f[S>>2]=Ua;Ta=Sa-Ua+256|0;if(Ta>>>0<769)Qb=h[271964+Ta>>0]|0;else Qb=0;Ta=Qb+Ua|0;f[S>>2]=Ta;Ua=Sa-Qb|0;f[P>>2]=Ua;Sa=Ta-Qa+256|0;if(Sa>>>0<769)Rb=h[271964+Sa>>0]|0;else Rb=0;Sa=Rb+Qa|0;f[R>>2]=Sa;Qa=Ta-Rb|0;f[S>>2]=Qa;Ta=Ra-Ua+256|0;if(Ta>>>0<769)Sb=h[271964+Ta>>0]|0;else Sb=0;Ta=Sb+Ua|0;f[P>>2]=Ta;Ua=Ra-Sb|0;f[U>>2]=Ua;Ra=Pa-Sa+256|0;if(Ra>>>0<769)Tb=h[271964+Ra>>0]|0;else Tb=0;Ra=Tb+Sa|0;f[R>>2]=Ra;Sa=Pa-Tb|0;f[Q>>2]=Sa;Pa=Sa-Ta+256|0;if(Pa>>>0<769)Ub=h[271964+Pa>>0]|0;else Ub=0;Pa=Ub+Ta|0;f[P>>2]=Pa;Ta=Sa-Ub|0;f[Q>>2]=Ta;Sa=Ma-Qa+256|0;if(Sa>>>0<769)Vb=h[271964+Sa>>0]|0;else Vb=0;Sa=Vb+Qa|0;f[S>>2]=Sa;Qa=Ma-Vb|0;f[V>>2]=Qa;Ma=Qa-Ta+256|0;if(Ma>>>0<769)Wb=h[271964+Ma>>0]|0;else Wb=0;Ma=Wb+Ta|0;f[Q>>2]=Ma;Ta=Qa-Wb|0;f[V>>2]=Ta;Qa=Pa-Sa+256|0;if(Qa>>>0<769)Xb=h[271964+Qa>>0]|0;else Xb=0;Qa=Xb+Sa|0;f[S>>2]=Qa;Sa=Pa-Xb|0;f[P>>2]=Sa;Pa=Wa-Xa+256|0;if(Pa>>>0<769)Yb=h[271964+Pa>>0]|0;else Yb=0;Pa=Yb+Xa|0;f[N>>2]=Pa;Xa=Wa-Yb|0;f[O>>2]=Xa;Wa=Va-Xa+256|0;if(Wa>>>0<769)Zb=h[271964+Wa>>0]|0;else Zb=0;Wa=Zb+Xa|0;f[O>>2]=Wa;Xa=Va-Zb|0;f[r>>2]=Xa;Va=Wa-Pa+256|0;if(Va>>>0<769)_b=h[271964+Va>>0]|0;else _b=0;Va=_b+Pa|0;f[N>>2]=Va;Pa=Wa-_b|0;f[O>>2]=Pa;Wa=J-M+256|0;if(Wa>>>0<769)$b=h[271964+Wa>>0]|0;else $b=0;Wa=$b+M|0;f[d>>2]=Wa;M=J-$b|0;f[x>>2]=M;J=Ya-D+256|0;if(J>>>0<769)ac=h[271964+J>>0]|0;else ac=0;J=ac+D|0;f[s>>2]=J;D=Ya-ac|0;f[w>>2]=D;Ya=M-D+256|0;if(Ya>>>0<769)bc=h[271964+Ya>>0]|0;else bc=0;Ya=bc+D|0;f[w>>2]=Ya;D=M-bc|0;f[x>>2]=D;M=Wa-J+256|0;if(M>>>0<769)cc=h[271964+M>>0]|0;else cc=0;M=cc+J|0;f[s>>2]=M;J=Wa-cc|0;f[d>>2]=J;Wa=J-Ya+256|0;if(Wa>>>0<769)dc=h[271964+Wa>>0]|0;else dc=0;Wa=dc+Ya|0;f[w>>2]=Wa;Ya=J-dc|0;f[d>>2]=Ya;J=Xa-D+256|0;if(J>>>0<769)ec=h[271964+J>>0]|0;else ec=0;J=ec+D|0;f[x>>2]=J;D=Xa-ec|0;f[r>>2]=D;Xa=Va-Wa+256|0;if(Xa>>>0<769)fc=h[271964+Xa>>0]|0;else fc=0;Xa=fc+Wa|0;f[w>>2]=Xa;Wa=Va-fc|0;f[N>>2]=Wa;Va=Wa-J+256|0;if(Va>>>0<769)gc=h[271964+Va>>0]|0;else gc=0;Va=gc+J|0;f[x>>2]=Va;J=Wa-gc|0;f[N>>2]=J;Wa=Pa-Ya+256|0;if(Wa>>>0<769)hc=h[271964+Wa>>0]|0;else hc=0;Wa=hc+Ya|0;f[d>>2]=Wa;Ya=Pa-hc|0;f[O>>2]=Ya;Pa=Wa-M+256|0;if(Pa>>>0<769)ic=h[271964+Pa>>0]|0;else ic=0;Pa=ic+M|0;f[s>>2]=Pa;M=Wa-ic|0;f[d>>2]=M;Wa=Ya-J+256|0;if(Wa>>>0<769)jc=h[271964+Wa>>0]|0;else jc=0;Wa=jc+J|0;f[N>>2]=Wa;J=Ya-jc|0;f[O>>2]=J;Ya=Va-M+256|0;if(Ya>>>0<769)kc=h[271964+Ya>>0]|0;else kc=0;Ya=kc+M|0;f[d>>2]=Ya;M=Va-kc|0;f[x>>2]=M;Va=Xa-Pa+256|0;if(Va>>>0<769)lc=h[271964+Va>>0]|0;else lc=0;Va=lc+Pa|0;f[s>>2]=Va;Pa=Xa-lc|0;f[w>>2]=Pa;Xa=Ua-D+256|0;if(Xa>>>0<769)mc=h[271964+Xa>>0]|0;else mc=0;Xa=mc+D|0;f[r>>2]=Xa;D=Ua-mc|0;f[U>>2]=D;Ua=Qa-Ya+256|0;if(Ua>>>0<769)nc=h[271964+Ua>>0]|0;else nc=0;Ua=nc+Ya|0;f[d>>2]=Ua;Ya=Qa-nc|0;f[S>>2]=Ya;Qa=Ya-Xa+256|0;if(Qa>>>0<769)oc=h[271964+Qa>>0]|0;else oc=0;Qa=oc+Xa|0;f[r>>2]=Qa;Xa=Ya-oc|0;f[S>>2]=Xa;Ya=Ma-Wa+256|0;if(Ya>>>0<769)pc=h[271964+Ya>>0]|0;else pc=0;Ya=pc+Wa|0;f[N>>2]=Ya;Wa=Ma-pc|0;f[Q>>2]=Wa;Ma=Ya-Va+256|0;if(Ma>>>0<769)qc=h[271964+Ma>>0]|0;else qc=0;Ma=qc+Va|0;f[s>>2]=Ma;Va=Ya-qc|0;f[N>>2]=Va;Ya=Wa-Xa+256|0;if(Ya>>>0<769)rc=h[271964+Ya>>0]|0;else rc=0;Ya=rc+Xa|0;f[S>>2]=Ya;Xa=Wa-rc|0;f[Q>>2]=Xa;Wa=Qa-Va+256|0;if(Wa>>>0<769)sc=h[271964+Wa>>0]|0;else sc=0;Wa=sc+Va|0;f[N>>2]=Wa;Va=Qa-sc|0;f[r>>2]=Va;Qa=Ua-Ma+256|0;if(Qa>>>0<769)tc=h[271964+Qa>>0]|0;else tc=0;Qa=tc+Ma|0;f[s>>2]=Qa;Ma=Ua-tc|0;f[d>>2]=Ma;Ua=Ta-J+256|0;if(Ua>>>0<769)uc=h[271964+Ua>>0]|0;else uc=0;Ua=uc+J|0;f[O>>2]=Ua;J=Ta-uc|0;f[V>>2]=J;Ta=Ra-Pa+256|0;if(Ta>>>0<769)vc=h[271964+Ta>>0]|0;else vc=0;Ta=vc+Pa|0;f[w>>2]=Ta;Pa=Ra-vc|0;f[R>>2]=Pa;Ra=Pa-Ua+256|0;if(Ra>>>0<769)wc=h[271964+Ra>>0]|0;else wc=0;Ra=wc+Ua|0;f[O>>2]=Ra;Ua=Pa-wc|0;f[R>>2]=Ua;Pa=Sa-M+256|0;if(Pa>>>0<769)xc=h[271964+Pa>>0]|0;else xc=0;Pa=xc+M|0;f[x>>2]=Pa;M=Sa-xc|0;f[P>>2]=M;Sa=M-Ua+256|0;if(Sa>>>0<769)yc=h[271964+Sa>>0]|0;else yc=0;Sa=yc+Ua|0;f[R>>2]=Sa;Ua=M-yc|0;f[P>>2]=Ua;M=Ra-Pa+256|0;if(M>>>0<769)zc=h[271964+M>>0]|0;else zc=0;M=zc+Pa|0;f[x>>2]=M;Pa=Ra-zc|0;f[O>>2]=Pa;Ra=J-Xa+256|0;if(Ra>>>0<769)Ac=h[271964+Ra>>0]|0;else Ac=0;Ra=Ac+Xa|0;f[Q>>2]=Ra;Xa=J-Ac|0;f[V>>2]=Xa;J=Ua-Ya+256|0;if(J>>>0<769)Bc=h[271964+J>>0]|0;else Bc=0;J=Bc+Ya|0;f[S>>2]=J;Ya=Ua-Bc|0;f[P>>2]=Ya;Ua=Sa-Va+256|0;if(Ua>>>0<769)Cc=h[271964+Ua>>0]|0;else Cc=0;Ua=Cc+Va|0;f[r>>2]=Ua;Va=Sa-Cc|0;f[R>>2]=Va;Sa=Pa-Wa+256|0;if(Sa>>>0<769)Dc=h[271964+Sa>>0]|0;else Dc=0;Sa=Dc+Wa|0;f[N>>2]=Sa;Wa=Pa-Dc|0;f[O>>2]=Wa;Pa=M-Ma+256|0;if(Pa>>>0<769)Ec=h[271964+Pa>>0]|0;else Ec=0;Pa=Ec+Ma|0;f[d>>2]=Pa;Ma=M-Ec|0;f[x>>2]=Ma;M=Ta-Qa+256|0;if(M>>>0<769)Fc=h[271964+M>>0]|0;else Fc=0;M=Fc+Qa|0;f[s>>2]=M;Qa=Ta-Fc|0;f[w>>2]=Qa;Ta=Oa-D+256|0;if(Ta>>>0<769)Gc=h[271964+Ta>>0]|0;else Gc=0;Ta=Gc+D|0;f[U>>2]=Ta;f[i>>2]=Oa-Gc;Oa=L-Sa+256|0;if(Oa>>>0<769)Hc=h[271964+Oa>>0]|0;else Hc=0;f[N>>2]=Hc+Sa;Sa=L-Hc|0;f[aa>>2]=Sa;L=Sa-Ta+256|0;if(L>>>0<769)Ic=h[271964+L>>0]|0;else Ic=0;L=Ic+Ta|0;f[U>>2]=L;f[aa>>2]=Sa-Ic;Sa=Na-J+256|0;if(Sa>>>0<769)Jc=h[271964+Sa>>0]|0;else Jc=0;Sa=Jc+J|0;f[S>>2]=Sa;f[da>>2]=Na-Jc;Na=Sa-M+256|0;if(Na>>>0<769)Kc=h[271964+Na>>0]|0;else Kc=0;f[s>>2]=Kc+M;M=Sa-Kc|0;f[S>>2]=M;Sa=L-M+256|0;if(Sa>>>0<769)Lc=h[271964+Sa>>0]|0;else Lc=0;f[S>>2]=Lc+M;M=L-Lc|0;f[U>>2]=M;L=F-Ra+256|0;if(L>>>0<769)Mc=h[271964+L>>0]|0;else Mc=0;L=Mc+Ra|0;f[Q>>2]=L;f[ca>>2]=F-Mc;F=La-Pa+256|0;if(F>>>0<769)Nc=h[271964+F>>0]|0;else Nc=0;f[d>>2]=Nc+Pa;Pa=La-Nc|0;f[$>>2]=Pa;La=Pa-L+256|0;if(La>>>0<769)Oc=h[271964+La>>0]|0;else Oc=0;f[Q>>2]=Oc+L;L=Pa-Oc|0;f[$>>2]=L;Pa=K-Ua+256|0;if(Pa>>>0<769)Pc=h[271964+Pa>>0]|0;else Pc=0;f[r>>2]=Pc+Ua;Ua=K-Pc|0;f[X>>2]=Ua;K=Ua-L+256|0;if(K>>>0<769)Qc=h[271964+K>>0]|0;else Qc=0;K=Qc+L|0;f[$>>2]=K;f[X>>2]=Ua-Qc;Ua=K-M+256|0;if(Ua>>>0<769)Rc=h[271964+Ua>>0]|0;else Rc=0;Ua=Rc+M|0;f[U>>2]=Ua;f[$>>2]=K-Rc;K=Ja-Xa+256|0;if(K>>>0<769)Sc=h[271964+K>>0]|0;else Sc=0;K=Sc+Xa|0;f[V>>2]=K;f[ea>>2]=Ja-Sc;Ja=Ia-Ma+256|0;if(Ja>>>0<769)Tc=h[271964+Ja>>0]|0;else Tc=0;f[x>>2]=Tc+Ma;Ma=Ia-Tc|0;f[W>>2]=Ma;Ia=Ma-K+256|0;if(Ia>>>0<769)Uc=h[271964+Ia>>0]|0;else Uc=0;Ia=Uc+K|0;f[V>>2]=Ia;f[W>>2]=Ma-Uc;Ma=Ka-Va+256|0;if(Ma>>>0<769)Vc=h[271964+Ma>>0]|0;else Vc=0;Ma=Vc+Va|0;f[R>>2]=Ma;f[_>>2]=Ka-Vc;Ka=Ia-Ma+256|0;if(Ka>>>0<769)Wc=h[271964+Ka>>0]|0;else Wc=0;f[R>>2]=Wc+Ma;Ma=Ia-Wc|0;f[V>>2]=Ma;Ia=C-Ya+256|0;if(Ia>>>0<769)Xc=h[271964+Ia>>0]|0;else Xc=0;Ia=Xc+Ya|0;f[P>>2]=Ia;f[ba>>2]=C-Xc;C=z-Qa+256|0;if(C>>>0<769)Yc=h[271964+C>>0]|0;else Yc=0;f[w>>2]=Yc+Qa;Qa=z-Yc|0;f[T>>2]=Qa;z=Qa-Ia+256|0;if(z>>>0<769)Zc=h[271964+z>>0]|0;else Zc=0;f[P>>2]=Zc+Ia;Ia=Qa-Zc|0;f[T>>2]=Ia;Qa=A-Wa+256|0;if(Qa>>>0<769)_c=h[271964+Qa>>0]|0;else _c=0;f[O>>2]=_c+Wa;Wa=A-_c|0;f[Z>>2]=Wa;A=Wa-Ia+256|0;if(A>>>0<769)$c=h[271964+A>>0]|0;else $c=0;A=$c+Ia|0;f[T>>2]=A;f[Z>>2]=Wa-$c;Wa=A-Ma+256|0;if(Wa>>>0<769)ad=h[271964+Wa>>0]|0;else ad=0;f[V>>2]=ad+Ma;Ma=A-ad|0;f[T>>2]=Ma;A=Ma-Ua+256|0;if(A>>>0<769)bd=h[271964+A>>0]|0;else bd=0;b[G+E>>0]=bd+Ua;E=E+1|0}while((E|0)!=(H|0));cd=H}else cd=B;if((H|0)==(za|0))break;if((cd|0)>(Ga|0)){H=za;B=cd;continue}else dd=cd;while(1){E=(f[g>>2]|0)+dd|0;f[i>>2]=h[E+Ha>>0];Ua=h[E+Da>>0]|0;f[n>>2]=Ua;A=h[E>>0]|0;f[Aa>>2]=A;Ma=h[E+p>>0]|0;f[Ca>>2]=Ma;Wa=h[E+va>>0]|0;f[Fa>>2]=Wa;E=(f[c>>2]|0)+dd|0;Ia=h[E+Ha>>0]|0;f[Ea>>2]=Ia;Qa=h[E+Da>>0]|0;f[ta>>2]=Qa;z=h[E>>0]|0;f[Ba>>2]=z;C=h[E+p>>0]|0;f[I>>2]=C;Ya=h[E+va>>0]|0;f[xa>>2]=Ya;E=(f[sa>>2]|0)+dd|0;Ka=h[E+Ha>>0]|0;f[ga>>2]=Ka;Va=h[E+Da>>0]|0;f[ya>>2]=Va;K=h[E>>0]|0;f[ka>>2]=K;Ja=h[E+p>>0]|0;f[y>>2]=Ja;Xa=h[E+va>>0]|0;f[pa>>2]=Xa;E=(f[wa>>2]|0)+dd|0;M=h[E+Ha>>0]|0;f[ra>>2]=M;L=h[E+Da>>0]|0;f[qa>>2]=L;Pa=h[E>>0]|0;f[na>>2]=Pa;La=h[E+p>>0]|0;f[ma>>2]=La;F=h[E+va>>0]|0;f[ua>>2]=F;E=(f[v>>2]|0)+dd|0;Ra=h[E+Ha>>0]|0;f[ia>>2]=Ra;Sa=h[E+Da>>0]|0;f[la>>2]=Sa;Na=h[E>>0]|0;f[ja>>2]=Na;J=h[E+p>>0]|0;f[ha>>2]=J;Ta=h[E+va>>0]|0;f[oa>>2]=Ta;E=Ua-A+256|0;if(E>>>0<769)ed=h[271964+E>>0]|0;else ed=0;E=ed+A|0;f[Aa>>2]=E;A=(f[n>>2]|0)-ed|0;f[n>>2]=A;Ua=f[i>>2]|0;Oa=Ua-A+256|0;if(Oa>>>0<769)fd=h[271964+Oa>>0]|0;else fd=0;Oa=fd+A|0;f[n>>2]=Oa;A=Ua-fd|0;f[i>>2]=A;Ua=Oa-E+256|0;if(Ua>>>0<769)gd=h[271964+Ua>>0]|0;else gd=0;Ua=gd+E|0;f[Aa>>2]=Ua;E=Oa-gd|0;f[n>>2]=E;Oa=Wa-Ia+256|0;if(Oa>>>0<769)hd=h[271964+Oa>>0]|0;else hd=0;Oa=hd+Ia|0;f[Ea>>2]=Oa;Ia=Wa-hd|0;f[Fa>>2]=Ia;Wa=Ma-Ia+256|0;if(Wa>>>0<769)id=h[271964+Wa>>0]|0;else id=0;Wa=id+Ia|0;f[Fa>>2]=Wa;Ia=Ma-id|0;f[Ca>>2]=Ia;Ma=Wa-Oa+256|0;if(Ma>>>0<769)jd=h[271964+Ma>>0]|0;else jd=0;Ma=jd+Oa|0;f[Ea>>2]=Ma;Oa=Wa-jd|0;f[Fa>>2]=Oa;Wa=A-Ia+256|0;if(Wa>>>0<769)kd=h[271964+Wa>>0]|0;else kd=0;Wa=kd+Ia|0;f[Ca>>2]=Wa;Ia=A-kd|0;f[i>>2]=Ia;A=Ua-Ma+256|0;if(A>>>0<769)ld=h[271964+A>>0]|0;else ld=0;A=ld+Ma|0;f[Ea>>2]=A;Ma=Ua-ld|0;f[Aa>>2]=Ma;Ua=Ma-Wa+256|0;if(Ua>>>0<769)md=h[271964+Ua>>0]|0;else md=0;Ua=md+Wa|0;f[Ca>>2]=Ua;Wa=Ma-md|0;f[Aa>>2]=Wa;Ma=E-Oa+256|0;if(Ma>>>0<769)nd=h[271964+Ma>>0]|0;else nd=0;Ma=nd+Oa|0;f[Fa>>2]=Ma;Oa=E-nd|0;f[n>>2]=Oa;E=Oa-Wa+256|0;if(E>>>0<769)od=h[271964+E>>0]|0;else od=0;E=od+Wa|0;f[Aa>>2]=E;Wa=Oa-od|0;f[n>>2]=Wa;Oa=Ua-Ma+256|0;if(Oa>>>0<769)pd=h[271964+Oa>>0]|0;else pd=0;Oa=pd+Ma|0;f[Fa>>2]=Oa;Ma=Ua-pd|0;f[Ca>>2]=Ma;Ua=z-C+256|0;if(Ua>>>0<769)qd=h[271964+Ua>>0]|0;else qd=0;Ua=qd+C|0;f[I>>2]=Ua;C=z-qd|0;f[Ba>>2]=C;z=Qa-C+256|0;if(z>>>0<769)rd=h[271964+z>>0]|0;else rd=0;z=rd+C|0;f[Ba>>2]=z;C=Qa-rd|0;f[ta>>2]=C;Qa=z-Ua+256|0;if(Qa>>>0<769)sd=h[271964+Qa>>0]|0;else sd=0;Qa=sd+Ua|0;f[I>>2]=Qa;Ua=z-sd|0;f[Ba>>2]=Ua;z=Ka-Va+256|0;if(z>>>0<769)td=h[271964+z>>0]|0;else td=0;z=td+Va|0;f[ya>>2]=z;Va=Ka-td|0;f[ga>>2]=Va;Ka=Ya-Va+256|0;if(Ka>>>0<769)ud=h[271964+Ka>>0]|0;else ud=0;Ka=ud+Va|0;f[ga>>2]=Ka;Va=Ya-ud|0;f[xa>>2]=Va;Ya=Ka-z+256|0;if(Ya>>>0<769)vd=h[271964+Ya>>0]|0;else vd=0;Ya=vd+z|0;f[ya>>2]=Ya;z=Ka-vd|0;f[ga>>2]=z;Ka=C-Va+256|0;if(Ka>>>0<769)wd=h[271964+Ka>>0]|0;else wd=0;Ka=wd+Va|0;f[xa>>2]=Ka;Va=C-wd|0;f[ta>>2]=Va;C=Qa-Ya+256|0;if(C>>>0<769)xd=h[271964+C>>0]|0;else xd=0;C=xd+Ya|0;f[ya>>2]=C;Ya=Qa-xd|0;f[I>>2]=Ya;Qa=Ya-Ka+256|0;if(Qa>>>0<769)yd=h[271964+Qa>>0]|0;else yd=0;Qa=yd+Ka|0;f[xa>>2]=Qa;Ka=Ya-yd|0;f[I>>2]=Ka;Ya=Ua-z+256|0;if(Ya>>>0<769)zd=h[271964+Ya>>0]|0;else zd=0;Ya=zd+z|0;f[ga>>2]=Ya;z=Ua-zd|0;f[Ba>>2]=z;Ua=z-Ka+256|0;if(Ua>>>0<769)Ad=h[271964+Ua>>0]|0;else Ad=0;Ua=Ad+Ka|0;f[I>>2]=Ua;Ka=z-Ad|0;f[Ba>>2]=Ka;z=Qa-Ya+256|0;if(z>>>0<769)Bd=h[271964+z>>0]|0;else Bd=0;z=Bd+Ya|0;f[ga>>2]=z;Ya=Qa-Bd|0;f[xa>>2]=Ya;Qa=Ia-Va+256|0;if(Qa>>>0<769)Cd=h[271964+Qa>>0]|0;else Cd=0;Qa=Cd+Va|0;f[ta>>2]=Qa;Va=Ia-Cd|0;f[i>>2]=Va;Ia=Oa-z+256|0;if(Ia>>>0<769)Dd=h[271964+Ia>>0]|0;else Dd=0;Ia=Dd+z|0;f[ga>>2]=Ia;z=Oa-Dd|0;f[Fa>>2]=z;Oa=z-Qa+256|0;if(Oa>>>0<769)Ed=h[271964+Oa>>0]|0;else Ed=0;Oa=Ed+Qa|0;f[ta>>2]=Oa;Qa=z-Ed|0;f[Fa>>2]=Qa;z=E-Ua+256|0;if(z>>>0<769)Fd=h[271964+z>>0]|0;else Fd=0;z=Fd+Ua|0;f[I>>2]=z;Ua=E-Fd|0;f[Aa>>2]=Ua;E=Ua-Qa+256|0;if(E>>>0<769)Gd=h[271964+E>>0]|0;else Gd=0;E=Gd+Qa|0;f[Fa>>2]=E;Qa=Ua-Gd|0;f[Aa>>2]=Qa;Ua=Oa-z+256|0;if(Ua>>>0<769)Hd=h[271964+Ua>>0]|0;else Hd=0;Ua=Hd+z|0;f[I>>2]=Ua;z=Oa-Hd|0;f[ta>>2]=z;Oa=Wa-Ka+256|0;if(Oa>>>0<769)Id=h[271964+Oa>>0]|0;else Id=0;Oa=Id+Ka|0;f[Ba>>2]=Oa;Ka=Wa-Id|0;f[n>>2]=Ka;Wa=A-C+256|0;if(Wa>>>0<769)Jd=h[271964+Wa>>0]|0;else Jd=0;Wa=Jd+C|0;f[ya>>2]=Wa;C=A-Jd|0;f[Ea>>2]=C;A=C-Oa+256|0;if(A>>>0<769)Kd=h[271964+A>>0]|0;else Kd=0;A=Kd+Oa|0;f[Ba>>2]=A;Oa=C-Kd|0;f[Ea>>2]=Oa;C=Ma-Ya+256|0;if(C>>>0<769)Ld=h[271964+C>>0]|0;else Ld=0;C=Ld+Ya|0;f[xa>>2]=C;Ya=Ma-Ld|0;f[Ca>>2]=Ya;Ma=Ya-Oa+256|0;if(Ma>>>0<769)Md=h[271964+Ma>>0]|0;else Md=0;Ma=Md+Oa|0;f[Ea>>2]=Ma;Oa=Ya-Md|0;f[Ca>>2]=Oa;Ya=A-C+256|0;if(Ya>>>0<769)Nd=h[271964+Ya>>0]|0;else Nd=0;Ya=Nd+C|0;f[xa>>2]=Ya;C=A-Nd|0;f[Ba>>2]=C;A=Ka-Qa+256|0;if(A>>>0<769)Od=h[271964+A>>0]|0;else Od=0;A=Od+Qa|0;f[Aa>>2]=A;Qa=Ka-Od|0;f[n>>2]=Qa;Ka=Oa-E+256|0;if(Ka>>>0<769)Pd=h[271964+Ka>>0]|0;else Pd=0;Ka=Pd+E|0;f[Fa>>2]=Ka;E=Oa-Pd|0;f[Ca>>2]=E;Oa=Ma-z+256|0;if(Oa>>>0<769)Qd=h[271964+Oa>>0]|0;else Qd=0;Oa=Qd+z|0;f[ta>>2]=Oa;z=Ma-Qd|0;f[Ea>>2]=z;Ma=C-Ua+256|0;if(Ma>>>0<769)Rd=h[271964+Ma>>0]|0;else Rd=0;Ma=Rd+Ua|0;f[I>>2]=Ma;Ua=C-Rd|0;f[Ba>>2]=Ua;C=Ya-Ia+256|0;if(C>>>0<769)Sd=h[271964+C>>0]|0;else Sd=0;C=Sd+Ia|0;f[ga>>2]=C;Ia=Ya-Sd|0;f[xa>>2]=Ia;Ya=Ja-Xa+256|0;if(Ya>>>0<769)Td=h[271964+Ya>>0]|0;else Td=0;Ya=Td+Xa|0;f[pa>>2]=Ya;Xa=Ja-Td|0;f[y>>2]=Xa;Ja=K-Xa+256|0;if(Ja>>>0<769)Ud=h[271964+Ja>>0]|0;else Ud=0;Ja=Ud+Xa|0;f[y>>2]=Ja;Xa=K-Ud|0;f[ka>>2]=Xa;K=Ja-Ya+256|0;if(K>>>0<769)Vd=h[271964+K>>0]|0;else Vd=0;K=Vd+Ya|0;f[pa>>2]=K;Ya=Ja-Vd|0;f[y>>2]=Ya;Ja=L-Pa+256|0;if(Ja>>>0<769)Wd=h[271964+Ja>>0]|0;else Wd=0;Ja=Wd+Pa|0;f[na>>2]=Ja;Pa=L-Wd|0;f[qa>>2]=Pa;L=M-Pa+256|0;if(L>>>0<769)Xd=h[271964+L>>0]|0;else Xd=0;L=Xd+Pa|0;f[qa>>2]=L;Pa=M-Xd|0;f[ra>>2]=Pa;M=L-Ja+256|0;if(M>>>0<769)Yd=h[271964+M>>0]|0;else Yd=0;M=Yd+Ja|0;f[na>>2]=M;Ja=L-Yd|0;f[qa>>2]=Ja;L=Xa-Pa+256|0;if(L>>>0<769)Zd=h[271964+L>>0]|0;else Zd=0;L=Zd+Pa|0;f[ra>>2]=L;Pa=Xa-Zd|0;f[ka>>2]=Pa;Xa=K-M+256|0;if(Xa>>>0<769)_d=h[271964+Xa>>0]|0;else _d=0;Xa=_d+M|0;f[na>>2]=Xa;M=K-_d|0;f[pa>>2]=M;K=M-L+256|0;if(K>>>0<769)$d=h[271964+K>>0]|0;else $d=0;K=$d+L|0;f[ra>>2]=K;L=M-$d|0;f[pa>>2]=L;M=Ya-Ja+256|0;if(M>>>0<769)ae=h[271964+M>>0]|0;else ae=0;M=ae+Ja|0;f[qa>>2]=M;Ja=Ya-ae|0;f[y>>2]=Ja;Ya=Ja-L+256|0;if(Ya>>>0<769)be=h[271964+Ya>>0]|0;else be=0;Ya=be+L|0;f[pa>>2]=Ya;L=Ja-be|0;f[y>>2]=L;Ja=K-M+256|0;if(Ja>>>0<769)ce=h[271964+Ja>>0]|0;else ce=0;Ja=ce+M|0;f[qa>>2]=Ja;M=K-ce|0;f[ra>>2]=M;K=F-Ra+256|0;if(K>>>0<769)de=h[271964+K>>0]|0;else de=0;K=de+Ra|0;f[ia>>2]=K;Ra=F-de|0;f[ua>>2]=Ra;F=La-Ra+256|0;if(F>>>0<769)ee=h[271964+F>>0]|0;else ee=0;F=ee+Ra|0;f[ua>>2]=F;Ra=La-ee|0;f[ma>>2]=Ra;La=F-K+256|0;if(La>>>0<769)fe=h[271964+La>>0]|0;else fe=0;La=fe+K|0;f[ia>>2]=La;K=F-fe|0;f[ua>>2]=K;F=Sa-Na+256|0;if(F>>>0<769)ge=h[271964+F>>0]|0;else ge=0;F=ge+Na|0;f[ja>>2]=F;Na=Sa-ge|0;f[la>>2]=Na;Sa=J-Ta+256|0;if(Sa>>>0<769)he=h[271964+Sa>>0]|0;else he=0;Sa=he+Ta|0;f[oa>>2]=Sa;Ta=J-he|0;f[ha>>2]=Ta;J=Na-Ta+256|0;if(J>>>0<769)ie=h[271964+J>>0]|0;else ie=0;J=ie+Ta|0;f[ha>>2]=J;Ta=Na-ie|0;f[la>>2]=Ta;Na=F-Sa+256|0;if(Na>>>0<769)je=h[271964+Na>>0]|0;else je=0;Na=je+Sa|0;f[oa>>2]=Na;Sa=F-je|0;f[ja>>2]=Sa;F=Sa-J+256|0;if(F>>>0<769)ke=h[271964+F>>0]|0;else ke=0;F=ke+J|0;f[ha>>2]=F;J=Sa-ke|0;f[ja>>2]=J;Sa=Ra-Ta+256|0;if(Sa>>>0<769)le=h[271964+Sa>>0]|0;else le=0;Sa=le+Ta|0;f[la>>2]=Sa;Ta=Ra-le|0;f[ma>>2]=Ta;Ra=La-F+256|0;if(Ra>>>0<769)me=h[271964+Ra>>0]|0;else me=0;Ra=me+F|0;f[ha>>2]=Ra;F=La-me|0;f[ia>>2]=F;La=F-Sa+256|0;if(La>>>0<769)ne=h[271964+La>>0]|0;else ne=0;La=ne+Sa|0;f[la>>2]=La;Sa=F-ne|0;f[ia>>2]=Sa;F=K-J+256|0;if(F>>>0<769)oe=h[271964+F>>0]|0;else oe=0;F=oe+J|0;f[ja>>2]=F;J=K-oe|0;f[ua>>2]=J;K=F-Na+256|0;if(K>>>0<769)pe=h[271964+K>>0]|0;else pe=0;K=pe+Na|0;f[oa>>2]=K;Na=F-pe|0;f[ja>>2]=Na;F=J-Sa+256|0;if(F>>>0<769)qe=h[271964+F>>0]|0;else qe=0;F=qe+Sa|0;f[ia>>2]=F;Sa=J-qe|0;f[ua>>2]=Sa;J=La-Na+256|0;if(J>>>0<769)re=h[271964+J>>0]|0;else re=0;J=re+Na|0;f[ja>>2]=J;Na=La-re|0;f[la>>2]=Na;La=Ra-K+256|0;if(La>>>0<769)se=h[271964+La>>0]|0;else se=0;La=se+K|0;f[oa>>2]=La;K=Ra-se|0;f[ha>>2]=K;Ra=Pa-Ta+256|0;if(Ra>>>0<769)te=h[271964+Ra>>0]|0;else te=0;Ra=te+Ta|0;f[ma>>2]=Ra;Ta=Pa-te|0;f[ka>>2]=Ta;Pa=Ja-J+256|0;if(Pa>>>0<769)ue=h[271964+Pa>>0]|0;else ue=0;Pa=ue+J|0;f[ja>>2]=Pa;J=Ja-ue|0;f[qa>>2]=J;Ja=J-Ra+256|0;if(Ja>>>0<769)ve=h[271964+Ja>>0]|0;else ve=0;Ja=ve+Ra|0;f[ma>>2]=Ja;Ra=J-ve|0;f[qa>>2]=Ra;J=Ya-F+256|0;if(J>>>0<769)we=h[271964+J>>0]|0;else we=0;J=we+F|0;f[ia>>2]=J;F=Ya-we|0;f[pa>>2]=F;Ya=J-La+256|0;if(Ya>>>0<769)xe=h[271964+Ya>>0]|0;else xe=0;Ya=xe+La|0;f[oa>>2]=Ya;La=J-xe|0;f[ia>>2]=La;J=F-Ra+256|0;if(J>>>0<769)ye=h[271964+J>>0]|0;else ye=0;J=ye+Ra|0;f[qa>>2]=J;Ra=F-ye|0;f[pa>>2]=Ra;F=Ja-La+256|0;if(F>>>0<769)ze=h[271964+F>>0]|0;else ze=0;F=ze+La|0;f[ia>>2]=F;La=Ja-ze|0;f[ma>>2]=La;Ja=Pa-Ya+256|0;if(Ja>>>0<769)Ae=h[271964+Ja>>0]|0;else Ae=0;Ja=Ae+Ya|0;f[oa>>2]=Ja;Ya=Pa-Ae|0;f[ja>>2]=Ya;Pa=L-Sa+256|0;if(Pa>>>0<769)Be=h[271964+Pa>>0]|0;else Be=0;Pa=Be+Sa|0;f[ua>>2]=Pa;Sa=L-Be|0;f[y>>2]=Sa;L=Xa-K+256|0;if(L>>>0<769)Ce=h[271964+L>>0]|0;else Ce=0;L=Ce+K|0;f[ha>>2]=L;K=Xa-Ce|0;f[na>>2]=K;Xa=K-Pa+256|0;if(Xa>>>0<769)De=h[271964+Xa>>0]|0;else De=0;Xa=De+Pa|0;f[ua>>2]=Xa;Pa=K-De|0;f[na>>2]=Pa;K=M-Na+256|0;if(K>>>0<769)Ee=h[271964+K>>0]|0;else Ee=0;K=Ee+Na|0;f[la>>2]=K;Na=M-Ee|0;f[ra>>2]=Na;M=Na-Pa+256|0;if(M>>>0<769)Fe=h[271964+M>>0]|0;else Fe=0;M=Fe+Pa|0;f[na>>2]=M;Pa=Na-Fe|0;f[ra>>2]=Pa;Na=Xa-K+256|0;if(Na>>>0<769)Ge=h[271964+Na>>0]|0;else Ge=0;Na=Ge+K|0;f[la>>2]=Na;K=Xa-Ge|0;f[ua>>2]=K;Xa=Sa-Ra+256|0;if(Xa>>>0<769)He=h[271964+Xa>>0]|0;else He=0;Xa=He+Ra|0;f[pa>>2]=Xa;Ra=Sa-He|0;f[y>>2]=Ra;Sa=Pa-J+256|0;if(Sa>>>0<769)Ie=h[271964+Sa>>0]|0;else Ie=0;Sa=Ie+J|0;f[qa>>2]=Sa;J=Pa-Ie|0;f[ra>>2]=J;Pa=M-La+256|0;if(Pa>>>0<769)Je=h[271964+Pa>>0]|0;else Je=0;Pa=Je+La|0;f[ma>>2]=Pa;La=M-Je|0;f[na>>2]=La;M=K-F+256|0;if(M>>>0<769)Ke=h[271964+M>>0]|0;else Ke=0;M=Ke+F|0;f[ia>>2]=M;F=K-Ke|0;f[ua>>2]=F;K=Na-Ya+256|0;if(K>>>0<769)Le=h[271964+K>>0]|0;else Le=0;K=Le+Ya|0;f[ja>>2]=K;Ya=Na-Le|0;f[la>>2]=Ya;Na=L-Ja+256|0;if(Na>>>0<769)Me=h[271964+Na>>0]|0;else Me=0;Na=Me+Ja|0;f[oa>>2]=Na;Ja=L-Me|0;f[ha>>2]=Ja;L=Va-Ta+256|0;if(L>>>0<769)Ne=h[271964+L>>0]|0;else Ne=0;L=Ne+Ta|0;f[ka>>2]=L;f[i>>2]=Va-Ne;Va=Ma-M+256|0;if(Va>>>0<769)Oe=h[271964+Va>>0]|0;else Oe=0;f[ia>>2]=Oe+M;M=Ma-Oe|0;f[I>>2]=M;Ma=M-L+256|0;if(Ma>>>0<769)Pe=h[271964+Ma>>0]|0;else Pe=0;Ma=Pe+L|0;f[ka>>2]=Ma;f[I>>2]=M-Pe;M=Ka-Sa+256|0;if(M>>>0<769)Qe=h[271964+M>>0]|0;else Qe=0;M=Qe+Sa|0;f[qa>>2]=M;f[Fa>>2]=Ka-Qe;Ka=M-Na+256|0;if(Ka>>>0<769)Re=h[271964+Ka>>0]|0;else Re=0;f[oa>>2]=Re+Na;Na=M-Re|0;f[qa>>2]=Na;M=Ma-Na+256|0;if(M>>>0<769)Se=h[271964+M>>0]|0;else Se=0;f[qa>>2]=Se+Na;Na=Ma-Se|0;f[ka>>2]=Na;Ma=A-Xa+256|0;if(Ma>>>0<769)Te=h[271964+Ma>>0]|0;else Te=0;Ma=Te+Xa|0;f[pa>>2]=Ma;f[Aa>>2]=A-Te;A=C-K+256|0;if(A>>>0<769)Ue=h[271964+A>>0]|0;else Ue=0;f[ja>>2]=Ue+K;K=C-Ue|0;f[ga>>2]=K;C=K-Ma+256|0;if(C>>>0<769)Ve=h[271964+C>>0]|0;else Ve=0;f[pa>>2]=Ve+Ma;Ma=K-Ve|0;f[ga>>2]=Ma;K=Oa-Pa+256|0;if(K>>>0<769)We=h[271964+K>>0]|0;else We=0;f[ma>>2]=We+Pa;Pa=Oa-We|0;f[ta>>2]=Pa;Oa=Pa-Ma+256|0;if(Oa>>>0<769)Xe=h[271964+Oa>>0]|0;else Xe=0;Oa=Xe+Ma|0;f[ga>>2]=Oa;f[ta>>2]=Pa-Xe;Pa=Oa-Na+256|0;if(Pa>>>0<769)Ye=h[271964+Pa>>0]|0;else Ye=0;Pa=Ye+Na|0;f[ka>>2]=Pa;f[ga>>2]=Oa-Ye;Oa=Qa-Ra+256|0;if(Oa>>>0<769)Ze=h[271964+Oa>>0]|0;else Ze=0;Oa=Ze+Ra|0;f[y>>2]=Oa;f[n>>2]=Qa-Ze;Qa=Ia-Ya+256|0;if(Qa>>>0<769)_e=h[271964+Qa>>0]|0;else _e=0;f[la>>2]=_e+Ya;Ya=Ia-_e|0;f[xa>>2]=Ya;Ia=Ya-Oa+256|0;if(Ia>>>0<769)$e=h[271964+Ia>>0]|0;else $e=0;Ia=$e+Oa|0;f[y>>2]=Ia;f[xa>>2]=Ya-$e;Ya=z-La+256|0;if(Ya>>>0<769)af=h[271964+Ya>>0]|0;else af=0;Ya=af+La|0;f[na>>2]=Ya;f[Ea>>2]=z-af;z=Ia-Ya+256|0;if(z>>>0<769)bf=h[271964+z>>0]|0;else bf=0;f[na>>2]=bf+Ya;Ya=Ia-bf|0;f[y>>2]=Ya;Ia=E-J+256|0;if(Ia>>>0<769)cf=h[271964+Ia>>0]|0;else cf=0;Ia=cf+J|0;f[ra>>2]=Ia;f[Ca>>2]=E-cf;E=Wa-Ja+256|0;if(E>>>0<769)df=h[271964+E>>0]|0;else df=0;f[ha>>2]=df+Ja;Ja=Wa-df|0;f[ya>>2]=Ja;Wa=Ja-Ia+256|0;if(Wa>>>0<769)ef=h[271964+Wa>>0]|0;else ef=0;f[ra>>2]=ef+Ia;Ia=Ja-ef|0;f[ya>>2]=Ia;Ja=Ua-F+256|0;if(Ja>>>0<769)ff=h[271964+Ja>>0]|0;else ff=0;f[ua>>2]=ff+F;F=Ua-ff|0;f[Ba>>2]=F;Ua=F-Ia+256|0;if(Ua>>>0<769)gf=h[271964+Ua>>0]|0;else gf=0;Ua=gf+Ia|0;f[ya>>2]=Ua;f[Ba>>2]=F-gf;F=Ua-Ya+256|0;if(F>>>0<769)hf=h[271964+F>>0]|0;else hf=0;f[y>>2]=hf+Ya;Ya=Ua-hf|0;f[ya>>2]=Ya;Ua=Ya-Pa+256|0;if(Ua>>>0<769)jf=h[271964+Ua>>0]|0;else jf=0;b[G+dd>>0]=jf+Pa;Pa=dd+1|0;if((dd|0)<(Ga|0))dd=Pa;else{H=za;B=Pa;continue b}}}if((k|0)==(o|0))break;else G=G+m|0}u=e;return}default:{u=e;return}}}function Xxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;g=u;u=u+3360|0;h=g;i=g+3304|0;j=g+2184|0;k=g+1120|0;l=g+56|0;m=g+3248|0;o=a+4|0;p=c+4|0;if((f[o>>2]|0)==(f[p>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;q=tT(h,34)|0;r=287184;s=q+34|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,h,287219,287230,133)}do if((d$(a)|0)==65536){t=f[o>>2]|0;f[i>>2]=f[t>>2];v=i+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=i+8|0;f[x>>2]=f[t+8>>2];f[i+12>>2]=f[t+12>>2];f[i+16>>2]=f[t+16>>2];f[i+20>>2]=f[t+20>>2];f[i+24>>2]=f[t+24>>2];f[i+28>>2]=f[t+28>>2];f[i+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[i+36>>2]=y;f[i+40>>2]=x;x=i+48|0;z=i+44|0;f[z>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;ZS(i,t);break}}else a$(i,a,-1);while(0);a=pT(i,2,-1,1)|0;o=f[i>>2]&7;if((a|0)<=-1){f[h>>2]=0;A=h+4|0;f[A>>2]=0;B=tT(h,50)|0;q=B;r=287300;s=q+50|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,h,287219,287230,137)}t=(o|0)==5;if((o|1|0)!=5){f[h>>2]=0;A=h+4|0;f[A>>2]=0;B=tT(h,50)|0;q=B;r=287300;s=q+50|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,h,287219,287230,137)}if(a){if(X$(c)|0)C=(c$(c,-1)|0)!=4;else C=e;e=j+8|0;f[j>>2]=e;B=j+4|0;A=a>>>0>264;f[B>>2]=a;if(A){v=XDc(a>>>0>1073741823?-1:a<<2)|0;f[j>>2]=v;D=v}else D=e;v=a+2|0;w=k+8|0;f[k>>2]=w;x=k+4|0;f[x>>2]=v;if(v>>>0>264){z=XDc(v>>>0>1073741823?-1:v<<2)|0;f[k>>2]=z;E=z}else E=w;z=l+8|0;f[l>>2]=z;v=l+4|0;f[v>>2]=a;if(A){A=XDc(a>>>0>1073741823?-1:a<<2)|0;f[l>>2]=A;F=A}else F=z;A=f[i+16>>2]|0;if(!(f[i>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;q=tT(h,21)|0;r=287351;s=q+21|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,h,287219,287230,156)}else G=0;do{f[D+(G<<2)>>2]=A+(G<<3);G=G+1|0}while((G|0)!=(a|0));G=D+(a<<2)|0;if(t){Zxa(D,G,h);if((a|0)>1){r=1;q=0;s=0;while(1){H=+n[(f[D+(r<<2)>>2]|0)+4>>2];y=+n[(f[D+(q<<2)>>2]|0)+4>>2]>H?r:q;I=+n[(f[D+(s<<2)>>2]|0)+4>>2]<H?r:s;r=r+1|0;if((r|0)==(a|0)){J=y;K=I;break}else{q=y;s=I}}}else{J=0;K=0}}else{Yxa(D,G,h);if((a|0)>1){G=0;s=0;q=1;while(1){r=f[(f[D+(q<<2)>>2]|0)+4>>2]|0;I=(f[(f[D+(G<<2)>>2]|0)+4>>2]|0)>(r|0)?q:G;y=(f[(f[D+(s<<2)>>2]|0)+4>>2]|0)<(r|0)?q:s;q=q+1|0;if((q|0)==(a|0)){J=I;K=y;break}else{G=I;s=y}}}else{J=0;K=0}}s=f[D>>2]|0;G=a+-1|0;a=f[D+(G<<2)>>2]|0;if((f[s>>2]|0)==(f[a>>2]|0)?(f[s+4>>2]|0)==(f[a+4>>2]|0):0){f[F>>2]=0;L=1}else{a=E;if(t){s=$xa(D,0,K,E,-1,1)|0;q=E+(s<<2)|0;M=q;N=$xa(D,G,K,q,-1,-1)|0;O=s}else{s=_xa(D,0,K,E,-1,1)|0;q=E+(s<<2)|0;M=q;N=_xa(D,G,K,q,-1,-1)|0;O=s}s=M;M=d?a:s;q=d?O:N;K=d?s:a;s=d?N:O;O=q+-1|0;if((q|0)>1){N=M;y=A;I=0;do{f[F+(I<<2)>>2]=(f[D+(f[N+(I<<2)>>2]<<2)>>2]|0)-y>>3;I=I+1|0}while((I|0)!=(O|0));P=O}else P=0;if((s|0)>1){O=K;I=A;y=s+P+-1|0;N=P;r=s;do{r=r+-1|0;Q=N;N=N+1|0;f[F+(Q<<2)>>2]=(f[D+(f[O+(r<<2)>>2]<<2)>>2]|0)-I>>3}while((N|0)!=(y|0));if((s|0)>2){R=y;S=K+4|0;T=47}else{U=y;T=45}}else{U=P;T=45}if((T|0)==45)if((q|0)>2){R=U;S=M+(q+-2<<2)|0;T=47}else{V=U;W=-1}if((T|0)==47){V=R;W=f[S>>2]|0}if(t){t=$xa(D,0,J,E,1,-1)|0;S=E+(t<<2)|0;X=S;Z=t;_=$xa(D,G,J,S,1,1)|0}else{S=_xa(D,0,J,E,1,-1)|0;t=E+(S<<2)|0;X=t;Z=S;_=_xa(D,G,J,t,1,1)|0}t=X;X=d?t:a;J=d?_:Z;G=d?a:t;t=d?Z:_;do if((W|0)>-1){do if((J|0)>2){$=X+4|0;T=56}else{if((J+t|0)<=2){aa=-1;break}$=G+(2-J<<2)|0;T=56}while(0);if((T|0)==56)aa=f[$>>2]|0;if((aa|0)!=(W|0)){if((aa|0)<=-1){T=62;break}_=f[D+(aa<<2)>>2]|0;Z=f[D+(W<<2)>>2]|0;if((f[_>>2]|0)!=(f[Z>>2]|0)){T=62;break}if((f[_+4>>2]|0)!=(f[Z+4>>2]|0)){T=62;break}}Z=(t|0)<2?t:2;if((J|0)<2){ba=Z;ca=V}else{da=Z;ea=2;fa=1;T=63}}else T=62;while(0);if((T|0)==62)if((J|0)>1){da=t;ea=J;fa=J+-1|0;T=63}else{ba=t;ca=V}if((T|0)==63){T=X;X=A;t=ea+V|0;ea=V;V=0;while(1){f[F+(ea<<2)>>2]=(f[D+(f[T+(V<<2)>>2]<<2)>>2]|0)-X>>3;V=V+1|0;if((V|0)==(fa|0))break;else ea=ea+1|0}ba=da;ca=t+-1|0}if((ba|0)>1){t=G;G=A;da=ba+ca|0;ea=ca;fa=ba;while(1){fa=fa+-1|0;f[F+(ea<<2)>>2]=(f[D+(f[t+(fa<<2)>>2]<<2)>>2]|0)-G>>3;if((fa|0)<=1)break;else ea=ea+1|0}L=da+-1|0}else L=ca}if(C){Y$(c,L,1,o|8,-1,0,0);do if((d$(c)|0)==65536){o=f[p>>2]|0;f[h>>2]=f[o>>2];C=h+4|0;ca=o+4|0;f[C>>2]=f[ca>>2];da=h+8|0;f[da>>2]=f[o+8>>2];f[h+12>>2]=f[o+12>>2];f[h+16>>2]=f[o+16>>2];f[h+20>>2]=f[o+20>>2];f[h+24>>2]=f[o+24>>2];f[h+28>>2]=f[o+28>>2];f[h+32>>2]=f[o+32>>2];ea=f[o+36>>2]|0;f[h+36>>2]=ea;f[h+40>>2]=da;da=h+48|0;fa=h+44|0;f[fa>>2]=da;f[da>>2]=0;f[h+52>>2]=0;if(ea|0){da=ea+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[ca>>2]|0)<3){ca=f[o+44>>2]|0;da=f[fa>>2]|0;f[da>>2]=f[ca>>2];f[da+4>>2]=f[ca+4>>2];ga=h;break}else{f[C>>2]=0;ZS(h,o);ga=h;break}}else{a$(h,c,-1);ga=h}while(0);if(!(f[ga>>2]&16384))ha=f[f[h+44>>2]>>2]|0;else ha=8;if((L|0)>0){ga=f[h+16>>2]|0;p=0;do{o=f[F+(p<<2)>>2]|0;C=ga+(Y(p,ha)|0)|0;f[C>>2]=f[A+(o<<3)>>2];f[C+4>>2]=f[A+(o<<3)+4>>2];p=p+1|0}while((p|0)!=(L|0))}p=h+36|0;A=f[p>>2]|0;do if(A|0){ha=A+12|0;ga=f[ha>>2]|0;f[ha>>2]=ga+-1;if((ga|0)!=1)break;_S(h)}while(0);f[p>>2]=0;p=h+16|0;A=h+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[A>>2]|0)>0){p=f[h+40>>2]|0;ga=0;do{f[p+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[A>>2]|0))}A=f[h+44>>2]|0;if((A|0)!=(h+48|0))g0(A)}else{Vj(m,L,1,4,F,0);h_(m,c);F=m+36|0;L=f[F>>2]|0;if(L|0?(A=L+12|0,L=f[A>>2]|0,f[A>>2]=L+-1,(L|0)==1):0)_S(m);f[F>>2]=0;F=m+16|0;L=m+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[L>>2]|0)>0){F=f[m+40>>2]|0;A=0;do{f[F+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[L>>2]|0))}L=f[m+44>>2]|0;if((L|0)!=(m+48|0))g0(L)}L=f[l>>2]|0;if((L|0)!=(z|0)){if(L|0)ZDc(L);f[l>>2]=z;f[v>>2]=264}v=f[k>>2]|0;if((v|0)!=(w|0)){if(v|0)ZDc(v);f[k>>2]=w;f[x>>2]=264}x=f[j>>2]|0;if((x|0)!=(e|0)){if(x|0)ZDc(x);f[j>>2]=e;f[B>>2]=264}}else u$(c);c=i+36|0;B=f[c>>2]|0;if(B|0?(e=B+12|0,B=f[e>>2]|0,f[e>>2]=B+-1,(B|0)==1):0)_S(i);f[c>>2]=0;c=i+16|0;B=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[B>>2]|0)>0){c=f[i+40>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[B>>2]|0))}B=f[i+44>>2]|0;if((B|0)==(i+48|0)){u=g;return}g0(B);u=g;return}function Yxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=a+-8|0;h=d;while(1){i=h;b:while(1){j=i;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=5;break a;break}case 3:{m=9;break a;break}case 4:{m=27;break a;break}case 5:{m=28;break a;break}case 1:case 0:{m=107;break a;break}default:{}}if((k|0)<124){m=30;break a}n=i+(((l|0)/2|0)<<2)|0;do if((k|0)>3996){o=(l|0)/4|0;p=fya(i,i+(o<<2)|0,n,n+(o<<2)|0,e,c)|0}else{o=f[n>>2]|0;q=f[i>>2]|0;r=f[o>>2]|0;s=f[q>>2]|0;t=o;u=q;if((r|0)>=(s|0))if((r|0)==(s|0))v=(f[o+4>>2]|0)<(f[q+4>>2]|0);else v=0;else v=1;w=f[e>>2]|0;x=f[w>>2]|0;y=w;if((x|0)>=(r|0))if((x|0)==(r|0))z=(f[w+4>>2]|0)<(f[o+4>>2]|0);else z=0;else z=1;if(!v){if(!z){p=0;break}f[n>>2]=y;f[e>>2]=t;o=f[n>>2]|0;w=f[i>>2]|0;r=f[o>>2]|0;x=f[w>>2]|0;A=w;B=o;if((r|0)>=(x|0)){if((r|0)!=(x|0)){p=1;break}if((f[o+4>>2]|0)>=(f[w+4>>2]|0)){p=1;break}}f[i>>2]=B;f[n>>2]=A;p=2;break}if(z){f[i>>2]=y;f[e>>2]=u;p=1;break}f[i>>2]=t;f[n>>2]=u;t=f[e>>2]|0;y=f[t>>2]|0;A=t;if((y|0)>=(s|0)){if((y|0)!=(s|0)){p=1;break}if((f[t+4>>2]|0)>=(f[q+4>>2]|0)){p=1;break}}f[n>>2]=A;f[e>>2]=u;p=2}while(0);C=f[i>>2]|0;l=f[n>>2]|0;k=f[C>>2]|0;u=f[l>>2]|0;if((k|0)<(u|0)){D=e;E=p;break}if((k|0)==(u|0)?(f[C+4>>2]|0)<(f[l+4>>2]|0):0){D=e;E=p;break}if((i|0)!=(g|0)){A=l+4|0;F=g;while(1){G=f[F>>2]|0;l=f[G>>2]|0;if((l|0)<(u|0)){m=82;break b}if((l|0)==(u|0)?(f[G+4>>2]|0)<(f[A>>2]|0):0){m=82;break b}l=F+-4|0;if((i|0)==(l|0))break;else F=l}}A=i+4|0;u=f[e>>2]|0;l=f[u>>2]|0;q=u;do if((k|0)<(l|0))H=A;else{if((k|0)==(l|0)?(f[C+4>>2]|0)<(f[u+4>>2]|0):0){H=A;break}if((A|0)==(e|0)){m=107;break a}t=C+4|0;s=A;while(1){I=f[s>>2]|0;y=f[I>>2]|0;if((k|0)<(y|0))break;if((k|0)==(y|0)?(f[t>>2]|0)<(f[I+4>>2]|0):0)break;y=s+4|0;if((y|0)==(e|0)){m=107;break a}else s=y}f[s>>2]=q;f[e>>2]=I;H=s+4|0}while(0);if((H|0)==(e|0)){m=107;break a}else{J=e;K=H}while(1){q=f[i>>2]|0;k=f[K>>2]|0;A=f[q>>2]|0;u=f[k>>2]|0;c:do if((A|0)<(u|0))L=K;else{l=q+4|0;t=K;y=u;B=k;while(1){if((A|0)==(y|0)?(f[l>>2]|0)<(f[B+4>>2]|0):0){L=t;break c}w=t+4|0;B=f[w>>2]|0;y=f[B>>2]|0;if((A|0)<(y|0)){L=w;break}else t=w}}while(0);k=q+4|0;u=J;while(1){s=u;u=u+-4|0;M=f[u>>2]|0;s=f[M>>2]|0;if((A|0)<(s|0)){u=u;continue}if((A|0)!=(s|0))break;if((f[k>>2]|0)>=(f[M+4>>2]|0))break}if(L>>>0>=u>>>0){i=L;continue b}k=f[L>>2]|0;f[L>>2]=M;f[u>>2]=k;J=u;K=L+4|0}}if((m|0)==82){m=0;f[i>>2]=G;f[F>>2]=C;D=F;E=p+1|0}k=i+4|0;d:do if(k>>>0<D>>>0){A=n;q=D;s=k;t=E;while(1){y=f[A>>2]|0;B=f[y>>2]|0;l=y+4|0;y=s;while(1){N=f[y>>2]|0;w=f[N>>2]|0;if((w|0)>=(B|0)){if((w|0)!=(B|0))break;if((f[N+4>>2]|0)>=(f[l>>2]|0))break}y=y+4|0}u=N;w=q+-4|0;o=f[w>>2]|0;x=f[o>>2]|0;e:do if((x|0)<(B|0))O=w;else{r=x;P=o;Q=w;while(1){if((r|0)==(B|0)?(f[P+4>>2]|0)<(f[l>>2]|0):0){O=Q;break e}R=Q+-4|0;P=f[R>>2]|0;r=f[P>>2]|0;if((r|0)<(B|0)){O=R;break}else Q=R}}while(0);if(y>>>0>O>>>0){S=A;T=t;U=y;break d}f[y>>2]=f[O>>2];f[O>>2]=u;A=(A|0)==(y|0)?O:A;q=O;s=y+4|0;t=t+1|0}}else{S=n;T=E;U=k}while(0);do if((U|0)==(S|0))V=T;else{k=f[S>>2]|0;t=f[U>>2]|0;s=f[k>>2]|0;q=f[t>>2]|0;A=t;B=k;if((s|0)>=(q|0)){if((s|0)!=(q|0)){V=T;break}if((f[k+4>>2]|0)>=(f[t+4>>2]|0)){V=T;break}}f[U>>2]=B;f[S>>2]=A;V=T+1|0}while(0);if(!V){W=hya(i,U,c)|0;A=U+4|0;if(hya(A,a,c)|0){m=106;break}if(W){h=A;continue}}A=U;if((A-j|0)>=(b-A|0)){m=105;break}Yxa(i,U,c);h=U+4|0}if((m|0)==105){m=0;Yxa(U+4|0,a,c);d=i;a=U;continue}else if((m|0)==106){m=0;if(W){m=107;break}else{d=i;a=U;continue}}}if((m|0)==5){U=f[e>>2]|0;d=f[i>>2]|0;W=f[U>>2]|0;j=f[d>>2]|0;V=d;T=U;if((W|0)>=(j|0)){if((W|0)!=(j|0))return;if((f[U+4>>2]|0)>=(f[d+4>>2]|0))return}f[i>>2]=T;f[e>>2]=V;return}else if((m|0)==9){V=i+4|0;T=f[V>>2]|0;d=f[i>>2]|0;U=f[T>>2]|0;j=f[d>>2]|0;W=T;S=d;if((U|0)>=(j|0))if((U|0)==(j|0))X=(f[T+4>>2]|0)<(f[d+4>>2]|0);else X=0;else X=1;E=f[e>>2]|0;n=f[E>>2]|0;O=E;if((n|0)>=(U|0))if((n|0)==(U|0))Y=(f[E+4>>2]|0)<(f[T+4>>2]|0);else Y=0;else Y=1;if(!X){if(!Y)return;f[V>>2]=O;f[e>>2]=W;X=f[V>>2]|0;T=f[i>>2]|0;E=f[X>>2]|0;U=f[T>>2]|0;n=T;N=X;if((E|0)>=(U|0)){if((E|0)!=(U|0))return;if((f[X+4>>2]|0)>=(f[T+4>>2]|0))return}f[i>>2]=N;f[V>>2]=n;return}if(Y){f[i>>2]=O;f[e>>2]=S;return}f[i>>2]=W;f[V>>2]=S;W=f[e>>2]|0;O=f[W>>2]|0;Y=W;if((O|0)>=(j|0)){if((O|0)!=(j|0))return;if((f[W+4>>2]|0)>=(f[d+4>>2]|0))return}f[V>>2]=Y;f[e>>2]=S;return}else if((m|0)==27){eya(i,i+4|0,i+8|0,e,c)|0;return}else if((m|0)==28){fya(i,i+4|0,i+8|0,i+12|0,e,c)|0;return}else if((m|0)==30){gya(i,a,c);return}else if((m|0)==107)return}
function oea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;c=u;u=u+1120|0;d=c+16|0;e=c;g=a+28|0;h=f[g>>2]|0;i=a+36|0;j=f[i>>2]|0;k=Y(h<<1,j)|0;l=d+8|0;XIc(l|0,0,1088)|0;f[d>>2]=l;m=d+4|0;f[m>>2]=k;if(k>>>0>136){n=XDc(k>>>0>536870911?-1:k<<3)|0;XIc(n|0,0,k<<3|0)|0;f[d>>2]=n;o=n}else o=l;n=f[a+64>>2]|0;k=f[b>>2]|0;p=(n|0)<(k|0)?k:n;q=b+4|0;r=f[q>>2]|0;s=f[a+68>>2]|0;t=(r|0)<(s|0)?r:s;if((k|0)<(n|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,j,f[a+40>>2]|0,f[a+48>>2]|0,o,f[a+56>>2]|0,f[a+60>>2]|0,h);v=-1;w=1;x=f[b>>2]|0}else{v=-2;w=0;x=k}if((x|0)<(p|0)){k=f[d>>2]|0;b=f[a+20>>2]|0;h=a+24|0;o=x;do{j=b+(Y(f[h>>2]|0,o)|0)|0;n=Y(f[i>>2]|0,f[g>>2]|0)|0;if((n|0)>0){s=0;do{r=k+(s<<3)|0;y=UIc(f[r>>2]|0,f[r+4>>2]|0,-2147483648,0)|0;r=$Ic(y|0,J|0,32)|0;y=J;z=UIc(r|0,y|0,-2147483648,0)|0;A=J;f[j+(s<<2)>>2]=A>>>0<1|(A|0)==1&z>>>0<0?r:(y|0)>0|(y|0)==0&r>>>0>0?2147483647:-2147483648;s=s+1|0}while((s|0)!=(n|0))}o=o+1|0}while((o|0)<(p|0));B=p}else B=x;if((B|0)<(t|0)){x=a+44|0;p=a+16|0;o=a+20|0;k=a+24|0;h=e+8|0;b=a+52|0;n=a+72|0;s=a+4|0;j=a+8|0;r=a+40|0;y=a+48|0;z=a+56|0;A=a+60|0;C=v;D=w;E=B;F=0;while(1){G=B+F<<1;H=(f[x>>2]|0)+(E<<2)|0;I=C+2|0;K=f[H>>2]|0;L=(K|0)<(I|0)?I:K;I=K+2|0;M=f[p>>2]|0;if((L|0)<(((M|0)<(I|0)?M:I)|0)){I=L;L=D;while(1){N=(f[s>>2]|0)+(Y(f[j>>2]|0,I)|0)|0;O=f[i>>2]|0;P=f[g>>2]|0;Q=(f[d>>2]|0)+((Y(Y(O,L)|0,P)|0)<<3)|0;wi[f[n>>2]&255](N,O,f[r>>2]|0,f[y>>2]|0,Q,f[z>>2]|0,f[A>>2]|0,P);I=I+1|0;P=(L+1|0)%2|0;Q=f[H>>2]|0;O=Q+2|0;N=f[p>>2]|0;if((I|0)>=(((N|0)<(O|0)?N:O)|0)){R=P;S=N;T=Q;break}else L=P}}else{R=D;S=M;T=K}L=S+-2|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;I=(((T|0)<(L|0)?L:T)+R-((C|0)<(L|0)?L:C)|0)%2|0;if((I|0)>0){dJc(e|0,(f[b>>2]|0)+((E<<1)+2-I<<3)|0,I<<3|0)|0;U=I}else U=0;dJc(e+(U<<3)|0,(f[b>>2]|0)+(U+G-I<<3)|0,16-(U<<3)|0)|0;L=f[d>>2]|0;H=Y(f[i>>2]|0,f[g>>2]|0)|0;P=(f[o>>2]|0)+(Y(f[k>>2]|0,E)|0)|0;if((H|0)>0){Q=e;N=f[Q>>2]|0;O=f[Q+4>>2]|0;Q=(O|0)<0;V=TIc(0,0,N|0,O|0)|0;W=Q?V:N;V=Q?J:O;Q=h;X=f[Q>>2]|0;Z=f[Q+4>>2]|0;Q=(Z|0)<0;_=TIc(0,0,X|0,Z|0)|0;$=Q?_:X;_=Q?J:Z;Q=0;do{aa=L+(Q<<3)|0;ba=f[aa>>2]|0;ca=f[aa+4>>2]|0;aa=(ca|0)<0;da=TIc(0,0,ba|0,ca|0)|0;ea=aa?da:ba;da=aa?J:ca;aa=ca^O;ca=mJc(ea|0,0,W|0,0)|0;UIc(ca|0,J|0,-2147483648,0)|0;ca=J;fa=mJc(da|0,0,W|0,0)|0;ga=J;ha=mJc(ea|0,0,V|0,0)|0;ea=J;ia=mJc(da|0,0,V|0,0)|0;da=J;ja=UIc(fa|0,0,ha|0,0)|0;ha=UIc(ja|0,J|0,ca|0,0)|0;ca=J;ja=UIc(ia|0,0,ga|0,0)|0;ga=UIc(ja|0,J|0,ea|0,0)|0;ea=UIc(ga|0,J|0,ca|0,0)|0;ca=J|da;if(ca>>>0>0|(ca|0)==0&(ea|ia)>>>0>2147483647){ia=aJc(ba^N|0,aa|0,63)|0;ba=UIc(ia|0,J|0,-1,2147483647)|0;ka=ba;la=J}else{ba=(aa|0)<0;aa=TIc(0,0,ha|0,ea|0)|0;ka=ba?aa:ha;la=ba?J:ea}ea=L+(Q+H<<3)|0;ba=f[ea>>2]|0;ha=f[ea+4>>2]|0;ea=(ha|0)<0;aa=TIc(0,0,ba|0,ha|0)|0;ia=ea?aa:ba;aa=ea?J:ha;ea=ha^Z;ha=mJc(ia|0,0,$|0,0)|0;UIc(ha|0,J|0,-2147483648,0)|0;ha=J;ca=mJc(aa|0,0,$|0,0)|0;da=J;ga=mJc(ia|0,0,_|0,0)|0;ia=J;ja=mJc(aa|0,0,_|0,0)|0;aa=J;fa=UIc(ca|0,0,ga|0,0)|0;ga=UIc(fa|0,J|0,ha|0,0)|0;ha=J;fa=UIc(ja|0,0,da|0,0)|0;da=UIc(fa|0,J|0,ia|0,0)|0;ia=UIc(da|0,J|0,ha|0,0)|0;ha=J|aa;if(ha>>>0>0|(ha|0)==0&(ia|ja)>>>0>2147483647){ja=aJc(ba^X|0,ea|0,63)|0;ba=UIc(ja|0,J|0,-1,2147483647)|0;ma=ba;na=J}else{ba=(ea|0)<0;ea=TIc(0,0,ga|0,ia|0)|0;ma=ba?ea:ga;na=ba?J:ia}ia=UIc(ma|0,na|0,ka|0,la|0)|0;ba=J;ga=((ba^la)&(ba^na)|0)<0;ea=UIc((ga?-1:ia)|0,(ga?(ba|2147483647)^-2147483648:ba)|0,-2147483648,0)|0;ba=$Ic(ea|0,J|0,32)|0;ea=J;ga=UIc(ba|0,ea|0,-2147483648,0)|0;ia=J;f[P+(Q<<2)>>2]=ia>>>0<1|(ia|0)==1&ga>>>0<0?ba:(ea|0)>0|(ea|0)==0&ba>>>0>0?2147483647:-2147483648;Q=Q+1|0}while((Q|0)!=(H|0))}H=E+1|0;if((H|0)<(t|0)){C=T;D=I;E=H;F=F+1|0}else{oa=T;pa=I;qa=H;ra=L;sa=p;break}}}else{oa=v;pa=w;qa=B;ra=f[d>>2]|0;sa=a+16|0}B=f[sa>>2]|0;if((oa+2|0)>(B|0))ta=ra+((Y(Y(f[g>>2]|0,(pa+~oa+B|0)%2|0)|0,f[i>>2]|0)|0)<<3)|0;else{oa=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,B+-1|0)|0)|0;wi[f[a+72>>2]&255](oa,f[i>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,ra,f[a+56>>2]|0,f[a+60>>2]|0,f[g>>2]|0);ta=ra}ra=f[q>>2]|0;if((qa|0)<(ra|0)){oa=f[a+20>>2]|0;B=a+24|0;a=qa;qa=ra;while(1){ra=oa+(Y(f[B>>2]|0,a)|0)|0;pa=Y(f[i>>2]|0,f[g>>2]|0)|0;if((pa|0)>0){sa=0;do{w=ta+(sa<<3)|0;v=UIc(f[w>>2]|0,f[w+4>>2]|0,-2147483648,0)|0;w=$Ic(v|0,J|0,32)|0;v=J;p=UIc(w|0,v|0,-2147483648,0)|0;T=J;f[ra+(sa<<2)>>2]=T>>>0<1|(T|0)==1&p>>>0<0?w:(v|0)>0|(v|0)==0&w>>>0>0?2147483647:-2147483648;sa=sa+1|0}while((sa|0)!=(pa|0));ua=f[q>>2]|0}else ua=qa;a=a+1|0;if((a|0)>=(ua|0))break;else qa=ua}}ua=f[d>>2]|0;if((ua|0)==(l|0)){u=c;return}if(ua|0)ZDc(ua);f[d>>2]=l;f[m>>2]=136;u=c;return}function pea(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=j[a>>1]<<16;if((h|0)>0){l=0;m=g;while(1){f[m>>2]=b;l=l+1|0;if((l|0)==(h|0))break;else m=m+4|0}n=e+(h<<1<<2)|0;o=h;p=g+(h<<2)|0}else{n=e;o=0;p=g}if((o|0)<(i|0)){g=n;n=o;e=p;while(1){h=a+(f[c+(n<<2)>>2]<<1)|0;m=f[g>>2]|0;l=d[h>>1]|0;b=mJc(l|0,((l|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;m=J;l=UIc(b|0,m|0,-2147483648,0)|0;q=J;r=q>>>0<1|(q|0)==1&l>>>0<0?b:(m|0)>0|(m|0)==0&b>>>0>0?2147483647:-2147483648;b=f[g+4>>2]|0;m=d[h+2>>1]|0;h=mJc(m|0,((m|0)<0)<<31>>31|0,b|0,((b|0)<0)<<31>>31|0)|0;b=J;m=UIc(h|0,b|0,-2147483648,0)|0;l=J;q=l>>>0<1|(l|0)==1&m>>>0<0?h:(b|0)>0|(b|0)==0&h>>>0>0?2147483647:-2147483648;h=q+r|0;f[e>>2]=((h^r)&(h^q)|0)<0?(h|2147483647)^-2147483648:h;n=n+1|0;if((n|0)==(i|0))break;else{g=g+8|0;e=e+4|0}}s=i;t=p+(i-o<<2)|0}else{s=o;t=p}p=j[a+(f[c+(k+-1<<2)>>2]<<1)>>1]<<16;if((s|0)<(k|0)){u=s;v=t}else return;while(1){f[v>>2]=p;u=u+1|0;if((u|0)==(k|0))break;else v=v+4|0}return}function qea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;yea(a,b,c,d,e,f,g,h);return}function rea(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;if((h|0)>0){m=h<<1;n=0;o=g;while(1){f[o>>2]=b;f[o+4>>2]=l;n=n+1|0;if((n|0)==(h|0))break;else o=o+8|0}p=e+(m<<2)|0;q=h;r=g+(m<<2)|0}else{p=e;q=0;r=g}if((q|0)<(i|0)){g=i-q|0;e=q;m=r;h=p;while(1){p=a+(f[c+(e<<2)>>2]<<1<<1)|0;o=f[h>>2]|0;n=d[p>>1]|0;l=mJc(n|0,((n|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;n=UIc(l|0,o|0,-2147483648,0)|0;b=J;s=b>>>0<1|(b|0)==1&n>>>0<0?l:(o|0)>0|(o|0)==0&l>>>0>0?2147483647:-2147483648;l=h+4|0;o=f[l>>2]|0;n=d[p+4>>1]|0;b=mJc(n|0,((n|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;n=UIc(b|0,o|0,-2147483648,0)|0;t=J;u=t>>>0<1|(t|0)==1&n>>>0<0?b:(o|0)>0|(o|0)==0&b>>>0>0?2147483647:-2147483648;b=u+s|0;f[m>>2]=((b^s)&(b^u)|0)<0?(b|2147483647)^-2147483648:b;b=f[h>>2]|0;u=d[p+2>>1]|0;s=mJc(u|0,((u|0)<0)<<31>>31|0,b|0,((b|0)<0)<<31>>31|0)|0;b=J;u=UIc(s|0,b|0,-2147483648,0)|0;o=J;n=o>>>0<1|(o|0)==1&u>>>0<0?s:(b|0)>0|(b|0)==0&s>>>0>0?2147483647:-2147483648;s=f[l>>2]|0;l=d[p+6>>1]|0;p=mJc(l|0,((l|0)<0)<<31>>31|0,s|0,((s|0)<0)<<31>>31|0)|0;s=J;l=UIc(p|0,s|0,-2147483648,0)|0;b=J;u=b>>>0<1|(b|0)==1&l>>>0<0?p:(s|0)>0|(s|0)==0&p>>>0>0?2147483647:-2147483648;p=u+n|0;f[m+4>>2]=((p^n)&(p^u)|0)<0?(p|2147483647)^-2147483648:p;e=e+1|0;if((e|0)==(i|0))break;else{m=m+8|0;h=h+8|0}}v=i;w=r+(g<<1<<2)|0}else{v=q;w=r}r=a+(f[c+(k+-1<<2)>>2]<<1<<1)|0;c=j[r>>1]<<16;a=j[r+2>>1]<<16;if((v|0)<(k|0)){x=w;y=v}else return;while(1){f[x>>2]=c;f[x+4>>2]=a;y=y+1|0;if((y|0)==(k|0))break;else x=x+8|0}return}function sea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;yea(a,b,c,d,e,f,g,h);return}function tea(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;m=j[a+4>>1]<<16;if((h|0)>0){n=h*3|0;o=0;p=g;while(1){f[p>>2]=b;f[p+4>>2]=l;f[p+8>>2]=m;o=o+1|0;if((o|0)==(h|0))break;else p=p+12|0}q=e+(h<<1<<2)|0;r=h;s=g+(n<<2)|0}else{q=e;r=0;s=g}if((r|0)<(i|0)){g=i-r|0;e=r;n=s;h=q;while(1){q=a+((f[c+(e<<2)>>2]|0)*3<<1)|0;p=f[h>>2]|0;o=d[q>>1]|0;m=mJc(o|0,((o|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;o=UIc(m|0,p|0,-2147483648,0)|0;l=J;b=l>>>0<1|(l|0)==1&o>>>0<0?m:(p|0)>0|(p|0)==0&m>>>0>0?2147483647:-2147483648;m=h+4|0;p=f[m>>2]|0;o=d[q+6>>1]|0;l=mJc(o|0,((o|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;o=UIc(l|0,p|0,-2147483648,0)|0;t=J;u=t>>>0<1|(t|0)==1&o>>>0<0?l:(p|0)>0|(p|0)==0&l>>>0>0?2147483647:-2147483648;l=u+b|0;f[n>>2]=((l^b)&(l^u)|0)<0?(l|2147483647)^-2147483648:l;l=f[h>>2]|0;u=d[q+2>>1]|0;b=mJc(u|0,((u|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;u=UIc(b|0,l|0,-2147483648,0)|0;p=J;o=p>>>0<1|(p|0)==1&u>>>0<0?b:(l|0)>0|(l|0)==0&b>>>0>0?2147483647:-2147483648;b=f[m>>2]|0;l=d[q+8>>1]|0;u=mJc(l|0,((l|0)<0)<<31>>31|0,b|0,((b|0)<0)<<31>>31|0)|0;b=J;l=UIc(u|0,b|0,-2147483648,0)|0;p=J;t=p>>>0<1|(p|0)==1&l>>>0<0?u:(b|0)>0|(b|0)==0&u>>>0>0?2147483647:-2147483648;u=t+o|0;f[n+4>>2]=((u^o)&(u^t)|0)<0?(u|2147483647)^-2147483648:u;u=f[h>>2]|0;t=d[q+4>>1]|0;o=mJc(t|0,((t|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;u=J;t=UIc(o|0,u|0,-2147483648,0)|0;b=J;l=b>>>0<1|(b|0)==1&t>>>0<0?o:(u|0)>0|(u|0)==0&o>>>0>0?2147483647:-2147483648;o=f[m>>2]|0;m=d[q+10>>1]|0;q=mJc(m|0,((m|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;m=UIc(q|0,o|0,-2147483648,0)|0;u=J;t=u>>>0<1|(u|0)==1&m>>>0<0?q:(o|0)>0|(o|0)==0&q>>>0>0?2147483647:-2147483648;q=t+l|0;f[n+8>>2]=((q^l)&(q^t)|0)<0?(q|2147483647)^-2147483648:q;e=e+1|0;if((e|0)==(i|0))break;else{n=n+12|0;h=h+8|0}}v=i;w=s+(g*3<<2)|0}else{v=r;w=s}s=a+((f[c+(k+-1<<2)>>2]|0)*3<<1)|0;c=j[s>>1]<<16;a=j[s+2>>1]<<16;r=j[s+4>>1]<<16;if((v|0)<(k|0)){x=w;y=v}else return;while(1){f[x>>2]=c;f[x+4>>2]=a;f[x+8>>2]=r;y=y+1|0;if((y|0)==(k|0))break;else x=x+12|0}return}function uea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;yea(a,b,c,d,e,f,g,h);return}function vea(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;m=j[a+4>>1]<<16;n=j[a+6>>1]<<16;if((h|0)>0){o=h<<2;p=0;q=g;while(1){f[q>>2]=b;f[q+4>>2]=l;f[q+8>>2]=m;f[q+12>>2]=n;p=p+1|0;if((p|0)==(h|0))break;else q=q+16|0}r=e+(h<<1<<2)|0;s=h;t=g+(o<<2)|0}else{r=e;s=0;t=g}if((s|0)<(i|0)){g=i-s|0;e=r;r=s;o=t;while(1){h=a+(f[c+(r<<2)>>2]<<2<<1)|0;q=f[e>>2]|0;p=d[h>>1]|0;n=mJc(p|0,((p|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;q=J;p=UIc(n|0,q|0,-2147483648,0)|0;m=J;l=m>>>0<1|(m|0)==1&p>>>0<0?n:(q|0)>0|(q|0)==0&n>>>0>0?2147483647:-2147483648;n=e+4|0;q=f[n>>2]|0;p=d[h+8>>1]|0;m=mJc(p|0,((p|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;q=J;p=UIc(m|0,q|0,-2147483648,0)|0;b=J;u=b>>>0<1|(b|0)==1&p>>>0<0?m:(q|0)>0|(q|0)==0&m>>>0>0?2147483647:-2147483648;m=u+l|0;f[o>>2]=((m^l)&(m^u)|0)<0?(m|2147483647)^-2147483648:m;m=f[e>>2]|0;u=d[h+2>>1]|0;l=mJc(u|0,((u|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;m=J;u=UIc(l|0,m|0,-2147483648,0)|0;q=J;p=q>>>0<1|(q|0)==1&u>>>0<0?l:(m|0)>0|(m|0)==0&l>>>0>0?2147483647:-2147483648;l=f[n>>2]|0;m=d[h+10>>1]|0;u=mJc(m|0,((m|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;m=UIc(u|0,l|0,-2147483648,0)|0;q=J;b=q>>>0<1|(q|0)==1&m>>>0<0?u:(l|0)>0|(l|0)==0&u>>>0>0?2147483647:-2147483648;u=b+p|0;f[o+4>>2]=((u^p)&(u^b)|0)<0?(u|2147483647)^-2147483648:u;u=f[e>>2]|0;b=d[h+4>>1]|0;p=mJc(b|0,((b|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;u=J;b=UIc(p|0,u|0,-2147483648,0)|0;l=J;m=l>>>0<1|(l|0)==1&b>>>0<0?p:(u|0)>0|(u|0)==0&p>>>0>0?2147483647:-2147483648;p=f[n>>2]|0;u=d[h+12>>1]|0;b=mJc(u|0,((u|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;u=UIc(b|0,p|0,-2147483648,0)|0;l=J;q=l>>>0<1|(l|0)==1&u>>>0<0?b:(p|0)>0|(p|0)==0&b>>>0>0?2147483647:-2147483648;b=q+m|0;f[o+8>>2]=((b^m)&(b^q)|0)<0?(b|2147483647)^-2147483648:b;b=f[e>>2]|0;q=d[h+6>>1]|0;m=mJc(q|0,((q|0)<0)<<31>>31|0,b|0,((b|0)<0)<<31>>31|0)|0;b=J;q=UIc(m|0,b|0,-2147483648,0)|0;p=J;u=p>>>0<1|(p|0)==1&q>>>0<0?m:(b|0)>0|(b|0)==0&m>>>0>0?2147483647:-2147483648;m=f[n>>2]|0;n=d[h+14>>1]|0;h=mJc(n|0,((n|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;m=J;n=UIc(h|0,m|0,-2147483648,0)|0;b=J;q=b>>>0<1|(b|0)==1&n>>>0<0?h:(m|0)>0|(m|0)==0&h>>>0>0?2147483647:-2147483648;h=q+u|0;f[o+12>>2]=((h^u)&(h^q)|0)<0?(h|2147483647)^-2147483648:h;r=r+1|0;if((r|0)==(i|0))break;else{e=e+8|0;o=o+16|0}}v=i;w=t+(g<<2<<2)|0}else{v=s;w=t}t=a+(f[c+(k+-1<<2)>>2]<<2<<1)|0;c=j[t>>1]<<16;a=j[t+2>>1]<<16;s=j[t+4>>1]<<16;g=j[t+6>>1]<<16;if((v|0)<(k|0)){x=w;y=v}else return;while(1){f[x>>2]=c;f[x+4>>2]=a;f[x+8>>2]=s;f[x+12>>2]=g;y=y+1|0;if((y|0)==(k|0))break;else x=x+16|0}return}function wea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;yea(a,b,c,d,e,f,g,h);return}function xea(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;do if((h|0)>0){l=h<<1;if((b|0)<=0){m=e+(l<<2)|0;n=g;o=h;break}p=Y(h,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){f[t>>2]=j[a+(s<<1)>>1]<<16;s=s+1|0;if((s|0)==(b|0))break;else t=t+4|0}r=r+1|0;if((r|0)==(h|0))break;else q=q+(b<<2)|0}m=e+(l<<2)|0;n=g+(p<<2)|0;o=h}else{m=e;n=g;o=0}while(0);if((o|0)<(i|0))if((b|0)>0){g=n+((Y(i-o|0,b)|0)<<2)|0;e=m;m=o;h=n;while(1){q=a+((Y(f[c+(m<<2)>>2]|0,b)|0)<<1)|0;r=e+4|0;t=0;s=h;while(1){u=f[e>>2]|0;v=d[q+(t<<1)>>1]|0;w=mJc(v|0,((v|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;u=J;v=UIc(w|0,u|0,-2147483648,0)|0;x=J;y=x>>>0<1|(x|0)==1&v>>>0<0?w:(u|0)>0|(u|0)==0&w>>>0>0?2147483647:-2147483648;f[s>>2]=y;w=f[r>>2]|0;u=d[q+(t+b<<1)>>1]|0;v=mJc(u|0,((u|0)<0)<<31>>31|0,w|0,((w|0)<0)<<31>>31|0)|0;w=J;u=UIc(v|0,w|0,-2147483648,0)|0;x=J;z=x>>>0<1|(x|0)==1&u>>>0<0?v:(w|0)>0|(w|0)==0&v>>>0>0?2147483647:-2147483648;v=z+y|0;f[s>>2]=((v^y)&(v^z)|0)<0?(v|2147483647)^-2147483648:v;t=t+1|0;if((t|0)==(b|0))break;else s=s+4|0}m=m+1|0;if((m|0)==(i|0)){A=i;B=g;break}else{e=e+8|0;h=h+(b<<2)|0}}}else{A=i;B=n}else{A=o;B=n}n=a+((Y(f[c+(k+-1<<2)>>2]|0,b)|0)<<1)|0;if((A|0)<(k|0)&(b|0)>0){C=A;D=B}else return;while(1){B=0;A=D;while(1){f[A>>2]=j[n+(B<<1)>>1]<<16;B=B+1|0;if((B|0)==(b|0))break;else A=A+4|0}C=C+1|0;if((C|0)==(k|0))break;else D=D+(b<<2)|0}return}function yea(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;do if((h|0)>0){l=h<<1;if((b|0)<=0){m=e+(l<<2)|0;n=g;o=h;break}p=Y(h,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){f[t>>2]=j[a+(s<<1)>>1]<<16;s=s+1|0;if((s|0)==(b|0))break;else t=t+4|0}r=r+1|0;if((r|0)==(h|0))break;else q=q+(b<<2)|0}m=e+(l<<2)|0;n=g+(p<<2)|0;o=h}else{m=e;n=g;o=0}while(0);if((o|0)<(i|0)){g=(b|0)>0;e=m;m=o;h=n;while(1){q=a+((Y(f[c+(m<<2)>>2]|0,b)|0)<<1)|0;if(g){r=e+4|0;t=0;s=h;while(1){u=f[e>>2]|0;if(!u)v=0;else{w=d[q+(t<<1)>>1]|0;x=mJc(w|0,((w|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;u=J;w=UIc(x|0,u|0,-2147483648,0)|0;y=J;v=y>>>0<1|(y|0)==1&w>>>0<0?x:(u|0)>0|(u|0)==0&x>>>0>0?2147483647:-2147483648}f[s>>2]=v;x=f[r>>2]|0;if(!x)z=0;else{u=d[q+(t+b<<1)>>1]|0;w=mJc(u|0,((u|0)<0)<<31>>31|0,x|0,((x|0)<0)<<31>>31|0)|0;x=J;u=UIc(w|0,x|0,-2147483648,0)|0;y=J;z=y>>>0<1|(y|0)==1&u>>>0<0?w:(x|0)>0|(x|0)==0&w>>>0>0?2147483647:-2147483648}w=v+z|0;f[s>>2]=((w^v)&(w^z)|0)<0?(w|2147483647)^-2147483648:w;t=t+1|0;if((t|0)==(b|0))break;else s=s+4|0}A=h+(b<<2)|0}else A=h;m=m+1|0;if((m|0)==(i|0)){B=i;C=A;break}else{e=e+8|0;h=A}}}else{B=o;C=n}n=a+((Y(f[c+(k+-1<<2)>>2]|0,b)|0)<<1)|0;if((B|0)<(k|0)&(b|0)>0){D=B;E=C}else return;while(1){C=0;B=E;while(1){f[B>>2]=j[n+(C<<1)>>1]<<16;C=C+1|0;if((C|0)==(b|0))break;else B=B+4|0}D=D+1|0;if((D|0)==(k|0))break;else E=E+(b<<2)|0}return}function zea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;Vmc(j,b);p[h>>3]=.5;bnc(g,j,h);fnc(k,a,g);p[l>>3]=.5;enc(i,k,l);k=_mc(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;Vmc(m,k);enc(l,i,m);Vmc(h,65536);fnc(g,l,h);h=Zmc(g)|0;f[d+4>>2]=h;g=65536-h|0;f[d>>2]=(g&h|0)<0?(g|2147483647)^-2147483648:g;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function Aea(a){a=a|0;YDc(a);return}function Bea(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;c=u;u=u+1072|0;e=c+8|0;g=c;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;XIc(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=XDc(l>>>0>1073741823?-1:l<<2)|0;XIc(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[b>>2]|0;q=(o|0)<(l|0)?l:o;r=b+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[b>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=f[e>>2]|0;b=f[a+20>>2]|0;i=f[a+24>>2]|0;p=Y(f[j>>2]|0,f[h>>2]|0)|0;if((p|0)>0){k=y;do{o=b+(Y(i,k)|0)|0;t=0;do{s=(f[l+(t<<2)>>2]|0)+32768>>16;d[o+(t<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;t=t+1|0}while((t|0)!=(p|0));k=k+1|0}while((k|0)<(q|0));z=q}else z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;k=a+20|0;p=a+24|0;l=g+4|0;i=a+52|0;b=a+72|0;t=a+4|0;o=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[t>>2]|0)+(Y(f[o>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;wi[f[b>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){dJc(g|0,(f[i>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;dJc(g+(V<<2)|0,(f[i>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[k>>2]|0)+(Y(f[p>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=((R|0)<0)<<31>>31;P=f[l>>2]|0;W=((P|0)<0)<<31>>31;X=0;do{Z=f[M+(X<<2)>>2]|0;_=mJc(Z|0,((Z|0)<0)<<31>>31|0,R|0,O|0)|0;Z=J;$=f[M+(X+I<<2)>>2]|0;aa=mJc($|0,(($|0)<0)<<31>>31|0,P|0,W|0)|0;$=J;ba=UIc(aa|0,$|0,_|0,Z|0)|0;_=J;aa=((_^Z)&(_^$)|0)<0;$=UIc((aa?-1:ba)|0,(aa?(_|2147483647)^-2147483648:_)|0,-2147483648,0)|0;_=$Ic($|0,J|0,32)|0;$=J;aa=UIc(_|0,$|0,32768,0)|0;ba=J;d[Q+(X<<1)>>1]=ba>>>0<0|(ba|0)==0&aa>>>0<65536?_&65535:($|0)>0|($|0)==0&_>>>0>0?32767:-32768;X=X+1|0}while((X|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{ca=U;da=K;ea=I;fa=M;ga=T;break}}}else{ca=w;da=x;ea=z;fa=f[e>>2]|0;ga=f[a+16>>2]|0}if((ca+2|0)>(ga|0))ha=fa+((Y(Y(f[h>>2]|0,(da+~ca+ga|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{ca=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,ga+-1|0)|0)|0;wi[f[a+72>>2]&255](ca,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,fa,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);ha=fa}fa=f[r>>2]|0;if((ea|0)<(fa|0)?(r=f[a+20>>2]|0,ca=f[a+24>>2]|0,a=Y(f[j>>2]|0,f[h>>2]|0)|0,(a|0)>0):0){h=ea;do{ea=r+(Y(ca,h)|0)|0;j=0;do{ga=(f[ha+(j<<2)>>2]|0)+32768>>16;d[ea+(j<<1)>>1]=(ga+32768|0)>>>0<65536?ga:(ga|0)>0?32767:32768;j=j+1|0}while((j|0)!=(a|0));h=h+1|0}while((h|0)<(fa|0))}fa=f[e>>2]|0;if((fa|0)==(m|0)){u=c;return}if(fa|0)ZDc(fa);f[e>>2]=m;f[n>>2]=264;u=c;return}function Cea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=(j[a>>1]|0)<<16;if((g|0)>0){k=g<<1;l=0;m=e;while(1){f[m>>2]=b;l=l+1|0;if((l|0)==(g|0))break;else m=m+4|0}n=d+(k<<2)|0;o=g;p=e+(g<<2)|0}else{n=d;o=0;p=e}if((o|0)<(h|0)){e=h-o|0;d=o;g=p;k=n;while(1){n=a+(f[c+(d<<2)>>2]<<1)|0;m=mJc(j[n>>1]|0|0,0,f[k>>2]|0,0)|0;l=J;b=l>>>0<0|(l|0)==0&m>>>0<4294967295;l=b?m:-1;m=mJc(j[n+2>>1]|0|0,0,f[k+4>>2]|0,0)|0;n=J;b=n>>>0<0|(n|0)==0&m>>>0<4294967295;n=b?m:-1;m=n+l|0;f[g>>2]=m>>>0<l>>>0?-1:m;d=d+1|0;if((d|0)==(h|0))break;else{g=g+4|0;k=k+8|0}}q=h;r=p+(e<<2)|0}else{q=o;r=p}p=(j[a+(f[c+(i+-1<<2)>>2]<<1)>>1]|0)<<16;if((q|0)<(i|0)){s=r;t=q}else return;while(1){f[s>>2]=p;t=t+1|0;if((t|0)==(i|0))break;else s=s+4|0}return}function Dea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Lea(a,b,c,d,e,f,g,h);return}function Eea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;if((g|0)>0){l=g<<1;m=0;n=e;while(1){f[n>>2]=b;f[n+4>>2]=k;m=m+1|0;if((m|0)==(g|0))break;else n=n+8|0}o=d+(l<<2)|0;p=g;q=e+(l<<2)|0}else{o=d;p=0;q=e}if((p|0)<(h|0)){e=h-p|0;d=p;l=q;g=o;while(1){o=a+(f[c+(d<<2)>>2]<<1<<1)|0;n=mJc(j[o>>1]|0|0,0,f[g>>2]|0,0)|0;m=J;k=m>>>0<0|(m|0)==0&n>>>0<4294967295;m=k?n:-1;n=g+4|0;k=mJc(j[o+4>>1]|0|0,0,f[n>>2]|0,0)|0;b=J;r=b>>>0<0|(b|0)==0&k>>>0<4294967295;b=r?k:-1;k=b+m|0;f[l>>2]=k>>>0<m>>>0?-1:k;k=mJc(j[o+2>>1]|0|0,0,f[g>>2]|0,0)|0;m=J;b=m>>>0<0|(m|0)==0&k>>>0<4294967295;m=b?k:-1;k=mJc(j[o+6>>1]|0|0,0,f[n>>2]|0,0)|0;n=J;o=n>>>0<0|(n|0)==0&k>>>0<4294967295;n=o?k:-1;k=n+m|0;f[l+4>>2]=k>>>0<m>>>0?-1:k;d=d+1|0;if((d|0)==(h|0))break;else{l=l+8|0;g=g+8|0}}s=h;t=q+(e<<1<<2)|0}else{s=p;t=q}q=a+(f[c+(i+-1<<2)>>2]<<1<<1)|0;c=(j[q>>1]|0)<<16;a=(j[q+2>>1]|0)<<16;if((s|0)<(i|0)){u=s;v=t}else return;while(1){f[v>>2]=c;f[v+4>>2]=a;u=u+1|0;if((u|0)==(i|0))break;else v=v+8|0}return}function Fea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Lea(a,b,c,d,e,f,g,h);return}function Gea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;l=(j[a+4>>1]|0)<<16;if((g|0)>0){m=g*3|0;n=0;o=e;while(1){f[o>>2]=b;f[o+4>>2]=k;f[o+8>>2]=l;n=n+1|0;if((n|0)==(g|0))break;else o=o+12|0}p=d+(g<<1<<2)|0;q=g;r=e+(m<<2)|0}else{p=d;q=0;r=e}if((q|0)<(h|0)){e=h-q|0;d=q;m=r;g=p;while(1){p=a+((f[c+(d<<2)>>2]|0)*3<<1)|0;o=mJc(j[p>>1]|0|0,0,f[g>>2]|0,0)|0;n=J;l=n>>>0<0|(n|0)==0&o>>>0<4294967295;n=l?o:-1;o=g+4|0;l=mJc(j[p+6>>1]|0|0,0,f[o>>2]|0,0)|0;k=J;b=k>>>0<0|(k|0)==0&l>>>0<4294967295;k=b?l:-1;l=k+n|0;f[m>>2]=l>>>0<n>>>0?-1:l;l=mJc(j[p+2>>1]|0|0,0,f[g>>2]|0,0)|0;n=J;k=n>>>0<0|(n|0)==0&l>>>0<4294967295;n=k?l:-1;l=mJc(j[p+8>>1]|0|0,0,f[o>>2]|0,0)|0;k=J;b=k>>>0<0|(k|0)==0&l>>>0<4294967295;k=b?l:-1;l=k+n|0;f[m+4>>2]=l>>>0<n>>>0?-1:l;l=mJc(j[p+4>>1]|0|0,0,f[g>>2]|0,0)|0;n=J;k=n>>>0<0|(n|0)==0&l>>>0<4294967295;n=k?l:-1;l=mJc(j[p+10>>1]|0|0,0,f[o>>2]|0,0)|0;o=J;p=o>>>0<0|(o|0)==0&l>>>0<4294967295;o=p?l:-1;l=o+n|0;f[m+8>>2]=l>>>0<n>>>0?-1:l;d=d+1|0;if((d|0)==(h|0))break;else{m=m+12|0;g=g+8|0}}s=h;t=r+(e*3<<2)|0}else{s=q;t=r}r=a+((f[c+(i+-1<<2)>>2]|0)*3<<1)|0;c=(j[r>>1]|0)<<16;a=(j[r+2>>1]|0)<<16;q=(j[r+4>>1]|0)<<16;if((s|0)<(i|0)){u=t;v=s}else return;while(1){f[u>>2]=c;f[u+4>>2]=a;f[u+8>>2]=q;v=v+1|0;if((v|0)==(i|0))break;else u=u+12|0}return}function Hea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Lea(a,b,c,d,e,f,g,h);return}function Iea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;l=(j[a+4>>1]|0)<<16;m=(j[a+6>>1]|0)<<16;if((g|0)>0){n=g<<2;o=0;p=e;while(1){f[p>>2]=b;f[p+4>>2]=k;f[p+8>>2]=l;f[p+12>>2]=m;o=o+1|0;if((o|0)==(g|0))break;else p=p+16|0}q=d+(g<<1<<2)|0;r=g;s=e+(n<<2)|0}else{q=d;r=0;s=e}if((r|0)<(h|0)){e=h-r|0;d=r;n=s;g=q;while(1){q=a+(f[c+(d<<2)>>2]<<2<<1)|0;p=mJc(j[q>>1]|0|0,0,f[g>>2]|0,0)|0;o=J;m=o>>>0<0|(o|0)==0&p>>>0<4294967295;o=m?p:-1;p=g+4|0;m=mJc(j[q+8>>1]|0|0,0,f[p>>2]|0,0)|0;l=J;k=l>>>0<0|(l|0)==0&m>>>0<4294967295;l=k?m:-1;m=l+o|0;f[n>>2]=m>>>0<o>>>0?-1:m;m=mJc(j[q+2>>1]|0|0,0,f[g>>2]|0,0)|0;o=J;l=o>>>0<0|(o|0)==0&m>>>0<4294967295;o=l?m:-1;m=mJc(j[q+10>>1]|0|0,0,f[p>>2]|0,0)|0;l=J;k=l>>>0<0|(l|0)==0&m>>>0<4294967295;l=k?m:-1;m=l+o|0;f[n+4>>2]=m>>>0<o>>>0?-1:m;m=mJc(j[q+4>>1]|0|0,0,f[g>>2]|0,0)|0;o=J;l=o>>>0<0|(o|0)==0&m>>>0<4294967295;o=l?m:-1;m=mJc(j[q+12>>1]|0|0,0,f[p>>2]|0,0)|0;l=J;k=l>>>0<0|(l|0)==0&m>>>0<4294967295;l=k?m:-1;m=l+o|0;f[n+8>>2]=m>>>0<o>>>0?-1:m;m=mJc(j[q+6>>1]|0|0,0,f[g>>2]|0,0)|0;o=J;l=o>>>0<0|(o|0)==0&m>>>0<4294967295;o=l?m:-1;m=mJc(j[q+14>>1]|0|0,0,f[p>>2]|0,0)|0;p=J;q=p>>>0<0|(p|0)==0&m>>>0<4294967295;p=q?m:-1;m=p+o|0;f[n+12>>2]=m>>>0<o>>>0?-1:m;d=d+1|0;if((d|0)==(h|0))break;else{n=n+16|0;g=g+8|0}}t=h;u=s+(e<<2<<2)|0}else{t=r;u=s}s=a+(f[c+(i+-1<<2)>>2]<<2<<1)|0;c=(j[s>>1]|0)<<16;a=(j[s+2>>1]|0)<<16;r=(j[s+4>>1]|0)<<16;e=(j[s+6>>1]|0)<<16;if((t|0)<(i|0)){v=u;w=t}else return;while(1){f[v>>2]=c;f[v+4>>2]=a;f[v+8>>2]=r;f[v+12>>2]=e;w=w+1|0;if((w|0)==(i|0))break;else v=v+16|0}return}function Jea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Lea(a,b,c,d,e,f,g,h);return}function Kea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;do if((g|0)>0){k=g<<1;if((b|0)<=0){l=d+(k<<2)|0;m=e;n=g;break}o=Y(g,b)|0;p=e;q=0;while(1){r=0;s=p;while(1){f[s>>2]=(j[a+(r<<1)>>1]|0)<<16;r=r+1|0;if((r|0)==(b|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(g|0))break;else p=p+(b<<2)|0}l=d+(k<<2)|0;m=e+(o<<2)|0;n=g}else{l=d;m=e;n=0}while(0);if((n|0)<(h|0))if((b|0)>0){e=m+((Y(h-n|0,b)|0)<<2)|0;d=l;l=n;g=m;while(1){p=a+((Y(f[c+(l<<2)>>2]|0,b)|0)<<1)|0;q=d+4|0;s=0;r=g;while(1){t=mJc(j[p+(s<<1)>>1]|0|0,0,f[d>>2]|0,0)|0;u=J;v=u>>>0<0|(u|0)==0&t>>>0<4294967295;u=v?t:-1;f[r>>2]=u;t=mJc(j[p+(s+b<<1)>>1]|0|0,0,f[q>>2]|0,0)|0;v=J;w=v>>>0<0|(v|0)==0&t>>>0<4294967295;v=w?t:-1;t=v+u|0;f[r>>2]=t>>>0<u>>>0?-1:t;s=s+1|0;if((s|0)==(b|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(h|0)){x=h;y=e;break}else{d=d+8|0;g=g+(b<<2)|0}}}else{x=h;y=m}else{x=n;y=m}m=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<1)|0;if((x|0)<(i|0)&(b|0)>0){z=x;A=y}else return;while(1){y=0;x=A;while(1){f[x>>2]=(j[m+(y<<1)>>1]|0)<<16;y=y+1|0;if((y|0)==(b|0))break;else x=x+4|0}z=z+1|0;if((z|0)==(i|0))break;else A=A+(b<<2)|0}return}function Lea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;do if((g|0)>0){k=g<<1;if((b|0)<=0){l=d+(k<<2)|0;m=e;n=g;break}o=Y(g,b)|0;p=e;q=0;while(1){r=0;s=p;while(1){f[s>>2]=(j[a+(r<<1)>>1]|0)<<16;r=r+1|0;if((r|0)==(b|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(g|0))break;else p=p+(b<<2)|0}l=d+(k<<2)|0;m=e+(o<<2)|0;n=g}else{l=d;m=e;n=0}while(0);if((n|0)<(h|0))if((b|0)>0){e=m+((Y(h-n|0,b)|0)<<2)|0;d=l;l=n;g=m;while(1){p=a+((Y(f[c+(l<<2)>>2]|0,b)|0)<<1)|0;q=d+4|0;s=0;r=g;while(1){t=f[d>>2]|0;if(!t)u=0;else{v=mJc(j[p+(s<<1)>>1]|0|0,0,t|0,0)|0;t=J;w=t>>>0<0|(t|0)==0&v>>>0<4294967295;t=w?v:-1;u=t}f[r>>2]=u;t=f[q>>2]|0;if(!t)x=0;else{v=mJc(j[p+(s+b<<1)>>1]|0|0,0,t|0,0)|0;t=J;w=t>>>0<0|(t|0)==0&v>>>0<4294967295;t=w?v:-1;x=t}t=u+x|0;f[r>>2]=t>>>0<u>>>0?-1:t;s=s+1|0;if((s|0)==(b|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(h|0)){y=h;z=e;break}else{d=d+8|0;g=g+(b<<2)|0}}}else{y=h;z=m}else{y=n;z=m}m=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<1)|0;if((y|0)<(i|0)&(b|0)>0){A=y;B=z}else return;while(1){z=0;y=B;while(1){f[y>>2]=(j[m+(z<<1)>>1]|0)<<16;z=z+1|0;if((z|0)==(b|0))break;else y=y+4|0}A=A+1|0;if((A|0)==(i|0))break;else B=B+(b<<2)|0}return}function Mea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;Vmc(j,b);p[h>>3]=.5;bnc(g,j,h);fnc(k,a,g);p[l>>3]=.5;enc(i,k,l);k=_mc(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)>=(n|0)){f[c>>2]=n;n=a+16|0;j=f[n>>2]|0;f[n>>2]=(j|0)>(b|0)?b:j;u=e;return}f[c>>2]=k;Vmc(m,k);enc(l,i,m);if((f[l+4>>2]|0)<0)o=0;else{Vmc(h,65536);fnc(g,l,h);o=Zmc(g)|0}f[d+4>>2]=o;f[d>>2]=o>>>0<65536?65536-o|0:0;u=e;return}o=a+12|0;a=b+1|0;b=f[o>>2]|0;f[o>>2]=(b|0)<(a|0)?a:b;u=e;return}function Nea(a){a=a|0;YDc(a);return}function Oea(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;c=u;u=u+1072|0;e=c+8|0;g=c;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;XIc(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=XDc(l>>>0>1073741823?-1:l<<2)|0;XIc(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[b>>2]|0;q=(o|0)<(l|0)?l:o;r=b+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[b>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=f[e>>2]|0;b=f[a+20>>2]|0;i=f[a+24>>2]|0;p=Y(f[j>>2]|0,f[h>>2]|0)|0;if((p|0)>0){k=y;do{o=b+(Y(i,k)|0)|0;t=0;do{d[o+(t<<1)>>1]=((f[l+(t<<2)>>2]|0)+32768|0)>>>16;t=t+1|0}while((t|0)!=(p|0));k=k+1|0}while((k|0)<(q|0));z=q}else z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;k=a+20|0;p=a+24|0;l=g+4|0;i=a+52|0;b=a+72|0;t=a+4|0;o=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[t>>2]|0)+(Y(f[o>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;wi[f[b>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){dJc(g|0,(f[i>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;dJc(g+(V<<2)|0,(f[i>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[k>>2]|0)+(Y(f[p>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=f[l>>2]|0;P=0;do{W=mJc(f[M+(P<<2)>>2]|0,0,R|0,0)|0;X=J;Z=mJc(f[M+(P+I<<2)>>2]|0,0,O|0,0)|0;_=UIc(Z|0,J|0,W|0,X|0)|0;Z=J;$=Z>>>0<X>>>0|(Z|0)==(X|0)&_>>>0<W>>>0;UIc(_|0,Z|0,-2147483648,0)|0;Z=$?0:J;_=$?0:0;$=_>>>0<0|(_|0)==0&Z>>>0<65535;_=$?Z:65535;d[Q+(P<<1)>>1]=_;P=P+1|0}while((P|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{aa=U;ba=K;ca=I;da=M;ea=T;break}}}else{aa=w;ba=x;ca=z;da=f[e>>2]|0;ea=f[a+16>>2]|0}if((aa+2|0)>(ea|0))fa=da+((Y(Y(f[h>>2]|0,(ba+~aa+ea|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{aa=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,ea+-1|0)|0)|0;wi[f[a+72>>2]&255](aa,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,da,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);fa=da}da=f[r>>2]|0;if((ca|0)<(da|0)?(r=f[a+20>>2]|0,aa=f[a+24>>2]|0,a=Y(f[j>>2]|0,f[h>>2]|0)|0,(a|0)>0):0){h=ca;do{ca=r+(Y(aa,h)|0)|0;j=0;do{d[ca+(j<<1)>>1]=((f[fa+(j<<2)>>2]|0)+32768|0)>>>16;j=j+1|0}while((j|0)!=(a|0));h=h+1|0}while((h|0)<(da|0))}da=f[e>>2]|0;if((da|0)==(m|0)){u=c;return}if(da|0)ZDc(da);f[e>>2]=m;f[n>>2]=264;u=c;return}function Pea(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=b[a>>0]<<16;if((h|0)>0){k=0;l=g;while(1){f[l>>2]=c;k=k+1|0;if((k|0)==(h|0))break;else l=l+4|0}m=e+(h<<1<<2)|0;n=h;o=g+(h<<2)|0}else{m=e;n=0;o=g}if((n|0)<(i|0)){g=m;m=n;e=o;while(1){h=a+(f[d+(m<<2)>>2]|0)|0;l=f[g>>2]|0;k=b[h>>0]|0;c=mJc(k|0,((k|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;k=UIc(c|0,l|0,-2147483648,0)|0;p=J;q=p>>>0<1|(p|0)==1&k>>>0<0?c:(l|0)>0|(l|0)==0&c>>>0>0?2147483647:-2147483648;c=f[g+4>>2]|0;l=b[h+1>>0]|0;h=mJc(l|0,((l|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;l=UIc(h|0,c|0,-2147483648,0)|0;k=J;p=k>>>0<1|(k|0)==1&l>>>0<0?h:(c|0)>0|(c|0)==0&h>>>0>0?2147483647:-2147483648;h=p+q|0;f[e>>2]=((h^q)&(h^p)|0)<0?(h|2147483647)^-2147483648:h;m=m+1|0;if((m|0)==(i|0))break;else{g=g+8|0;e=e+4|0}}r=i;s=o+(i-n<<2)|0}else{r=n;s=o}o=b[a+(f[d+(j+-1<<2)>>2]|0)>>0]<<16;if((r|0)<(j|0)){t=r;u=s}else return;while(1){f[u>>2]=o;t=t+1|0;if((t|0)==(j|0))break;else u=u+4|0}return}function Qea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Yea(a,b,c,d,e,f,g,h);return}function Rea(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;if((h|0)>0){l=h<<1;m=0;n=g;while(1){f[n>>2]=c;f[n+4>>2]=k;m=m+1|0;if((m|0)==(h|0))break;else n=n+8|0}o=e+(l<<2)|0;p=h;q=g+(l<<2)|0}else{o=e;p=0;q=g}if((p|0)<(i|0)){g=i-p|0;e=p;l=q;h=o;while(1){o=a+(f[d+(e<<2)>>2]<<1)|0;n=f[h>>2]|0;m=b[o>>0]|0;k=mJc(m|0,((m|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;n=J;m=UIc(k|0,n|0,-2147483648,0)|0;c=J;r=c>>>0<1|(c|0)==1&m>>>0<0?k:(n|0)>0|(n|0)==0&k>>>0>0?2147483647:-2147483648;k=h+4|0;n=f[k>>2]|0;m=b[o+2>>0]|0;c=mJc(m|0,((m|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;n=J;m=UIc(c|0,n|0,-2147483648,0)|0;s=J;t=s>>>0<1|(s|0)==1&m>>>0<0?c:(n|0)>0|(n|0)==0&c>>>0>0?2147483647:-2147483648;c=t+r|0;f[l>>2]=((c^r)&(c^t)|0)<0?(c|2147483647)^-2147483648:c;c=f[h>>2]|0;t=b[o+1>>0]|0;r=mJc(t|0,((t|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;t=UIc(r|0,c|0,-2147483648,0)|0;n=J;m=n>>>0<1|(n|0)==1&t>>>0<0?r:(c|0)>0|(c|0)==0&r>>>0>0?2147483647:-2147483648;r=f[k>>2]|0;k=b[o+3>>0]|0;o=mJc(k|0,((k|0)<0)<<31>>31|0,r|0,((r|0)<0)<<31>>31|0)|0;r=J;k=UIc(o|0,r|0,-2147483648,0)|0;c=J;t=c>>>0<1|(c|0)==1&k>>>0<0?o:(r|0)>0|(r|0)==0&o>>>0>0?2147483647:-2147483648;o=t+m|0;f[l+4>>2]=((o^m)&(o^t)|0)<0?(o|2147483647)^-2147483648:o;e=e+1|0;if((e|0)==(i|0))break;else{l=l+8|0;h=h+8|0}}u=i;v=q+(g<<1<<2)|0}else{u=p;v=q}q=a+(f[d+(j+-1<<2)>>2]<<1)|0;d=b[q>>0]<<16;a=b[q+1>>0]<<16;if((u|0)<(j|0)){w=v;x=u}else return;while(1){f[w>>2]=d;f[w+4>>2]=a;x=x+1|0;if((x|0)==(j|0))break;else w=w+8|0}return}function Sea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Yea(a,b,c,d,e,f,g,h);return}function Tea(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;l=b[a+2>>0]<<16;if((h|0)>0){m=h*3|0;n=0;o=g;while(1){f[o>>2]=c;f[o+4>>2]=k;f[o+8>>2]=l;n=n+1|0;if((n|0)==(h|0))break;else o=o+12|0}p=e+(h<<1<<2)|0;q=h;r=g+(m<<2)|0}else{p=e;q=0;r=g}if((q|0)<(i|0)){g=i-q|0;e=q;m=r;h=p;while(1){p=a+((f[d+(e<<2)>>2]|0)*3|0)|0;o=f[h>>2]|0;n=b[p>>0]|0;l=mJc(n|0,((n|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;n=UIc(l|0,o|0,-2147483648,0)|0;k=J;c=k>>>0<1|(k|0)==1&n>>>0<0?l:(o|0)>0|(o|0)==0&l>>>0>0?2147483647:-2147483648;l=h+4|0;o=f[l>>2]|0;n=b[p+3>>0]|0;k=mJc(n|0,((n|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;n=UIc(k|0,o|0,-2147483648,0)|0;s=J;t=s>>>0<1|(s|0)==1&n>>>0<0?k:(o|0)>0|(o|0)==0&k>>>0>0?2147483647:-2147483648;k=t+c|0;f[m>>2]=((k^c)&(k^t)|0)<0?(k|2147483647)^-2147483648:k;k=f[h>>2]|0;t=b[p+1>>0]|0;c=mJc(t|0,((t|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;k=J;t=UIc(c|0,k|0,-2147483648,0)|0;o=J;n=o>>>0<1|(o|0)==1&t>>>0<0?c:(k|0)>0|(k|0)==0&c>>>0>0?2147483647:-2147483648;c=f[l>>2]|0;k=b[p+4>>0]|0;t=mJc(k|0,((k|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;k=UIc(t|0,c|0,-2147483648,0)|0;o=J;s=o>>>0<1|(o|0)==1&k>>>0<0?t:(c|0)>0|(c|0)==0&t>>>0>0?2147483647:-2147483648;t=s+n|0;f[m+4>>2]=((t^n)&(t^s)|0)<0?(t|2147483647)^-2147483648:t;t=f[h>>2]|0;s=b[p+2>>0]|0;n=mJc(s|0,((s|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;s=UIc(n|0,t|0,-2147483648,0)|0;c=J;k=c>>>0<1|(c|0)==1&s>>>0<0?n:(t|0)>0|(t|0)==0&n>>>0>0?2147483647:-2147483648;n=f[l>>2]|0;l=b[p+5>>0]|0;p=mJc(l|0,((l|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;n=J;l=UIc(p|0,n|0,-2147483648,0)|0;t=J;s=t>>>0<1|(t|0)==1&l>>>0<0?p:(n|0)>0|(n|0)==0&p>>>0>0?2147483647:-2147483648;p=s+k|0;f[m+8>>2]=((p^k)&(p^s)|0)<0?(p|2147483647)^-2147483648:p;e=e+1|0;if((e|0)==(i|0))break;else{m=m+12|0;h=h+8|0}}u=i;v=r+(g*3<<2)|0}else{u=q;v=r}r=a+((f[d+(j+-1<<2)>>2]|0)*3|0)|0;d=b[r>>0]<<16;a=b[r+1>>0]<<16;q=b[r+2>>0]<<16;if((u|0)<(j|0)){w=v;x=u}else return;while(1){f[w>>2]=d;f[w+4>>2]=a;f[w+8>>2]=q;x=x+1|0;if((x|0)==(j|0))break;else w=w+12|0}return}function Uea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Yea(a,b,c,d,e,f,g,h);return}function Vea(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;l=b[a+2>>0]<<16;m=b[a+3>>0]<<16;if((h|0)>0){n=h<<2;o=0;p=g;while(1){f[p>>2]=c;f[p+4>>2]=k;f[p+8>>2]=l;f[p+12>>2]=m;o=o+1|0;if((o|0)==(h|0))break;else p=p+16|0}q=e+(h<<1<<2)|0;r=h;s=g+(n<<2)|0}else{q=e;r=0;s=g}if((r|0)<(i|0)){g=i-r|0;e=q;q=r;n=s;while(1){h=a+(f[d+(q<<2)>>2]<<2)|0;p=f[e>>2]|0;o=b[h>>0]|0;m=mJc(o|0,((o|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;o=UIc(m|0,p|0,-2147483648,0)|0;l=J;k=l>>>0<1|(l|0)==1&o>>>0<0?m:(p|0)>0|(p|0)==0&m>>>0>0?2147483647:-2147483648;m=e+4|0;p=f[m>>2]|0;o=b[h+4>>0]|0;l=mJc(o|0,((o|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;o=UIc(l|0,p|0,-2147483648,0)|0;c=J;t=c>>>0<1|(c|0)==1&o>>>0<0?l:(p|0)>0|(p|0)==0&l>>>0>0?2147483647:-2147483648;l=t+k|0;f[n>>2]=((l^k)&(l^t)|0)<0?(l|2147483647)^-2147483648:l;l=f[e>>2]|0;t=b[h+1>>0]|0;k=mJc(t|0,((t|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;t=UIc(k|0,l|0,-2147483648,0)|0;p=J;o=p>>>0<1|(p|0)==1&t>>>0<0?k:(l|0)>0|(l|0)==0&k>>>0>0?2147483647:-2147483648;k=f[m>>2]|0;l=b[h+5>>0]|0;t=mJc(l|0,((l|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;k=J;l=UIc(t|0,k|0,-2147483648,0)|0;p=J;c=p>>>0<1|(p|0)==1&l>>>0<0?t:(k|0)>0|(k|0)==0&t>>>0>0?2147483647:-2147483648;t=c+o|0;f[n+4>>2]=((t^o)&(t^c)|0)<0?(t|2147483647)^-2147483648:t;t=f[e>>2]|0;c=b[h+2>>0]|0;o=mJc(c|0,((c|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;c=UIc(o|0,t|0,-2147483648,0)|0;k=J;l=k>>>0<1|(k|0)==1&c>>>0<0?o:(t|0)>0|(t|0)==0&o>>>0>0?2147483647:-2147483648;o=f[m>>2]|0;t=b[h+6>>0]|0;c=mJc(t|0,((t|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;t=UIc(c|0,o|0,-2147483648,0)|0;k=J;p=k>>>0<1|(k|0)==1&t>>>0<0?c:(o|0)>0|(o|0)==0&c>>>0>0?2147483647:-2147483648;c=p+l|0;f[n+8>>2]=((c^l)&(c^p)|0)<0?(c|2147483647)^-2147483648:c;c=f[e>>2]|0;p=b[h+3>>0]|0;l=mJc(p|0,((p|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;p=UIc(l|0,c|0,-2147483648,0)|0;o=J;t=o>>>0<1|(o|0)==1&p>>>0<0?l:(c|0)>0|(c|0)==0&l>>>0>0?2147483647:-2147483648;l=f[m>>2]|0;m=b[h+7>>0]|0;h=mJc(m|0,((m|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;m=UIc(h|0,l|0,-2147483648,0)|0;c=J;p=c>>>0<1|(c|0)==1&m>>>0<0?h:(l|0)>0|(l|0)==0&h>>>0>0?2147483647:-2147483648;h=p+t|0;f[n+12>>2]=((h^t)&(h^p)|0)<0?(h|2147483647)^-2147483648:h;q=q+1|0;if((q|0)==(i|0))break;else{e=e+8|0;n=n+16|0}}u=i;v=s+(g<<2<<2)|0}else{u=r;v=s}s=a+(f[d+(j+-1<<2)>>2]<<2)|0;d=b[s>>0]<<16;a=b[s+1>>0]<<16;r=b[s+2>>0]<<16;g=b[s+3>>0]<<16;if((u|0)<(j|0)){w=v;x=u}else return;while(1){f[w>>2]=d;f[w+4>>2]=a;f[w+8>>2]=r;f[w+12>>2]=g;x=x+1|0;if((x|0)==(j|0))break;else w=w+16|0}return}function Wea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Yea(a,b,c,d,e,f,g,h);return}function Xea(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;do if((h|0)>0){k=h<<1;if((c|0)<=0){l=e+(k<<2)|0;m=g;n=h;break}o=Y(h,c)|0;p=g;q=0;while(1){r=0;s=p;while(1){f[s>>2]=b[a+r>>0]<<16;r=r+1|0;if((r|0)==(c|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(h|0))break;else p=p+(c<<2)|0}l=e+(k<<2)|0;m=g+(o<<2)|0;n=h}else{l=e;m=g;n=0}while(0);if((n|0)<(i|0))if((c|0)>0){g=m+((Y(i-n|0,c)|0)<<2)|0;e=l;l=n;h=m;while(1){p=a+(Y(f[d+(l<<2)>>2]|0,c)|0)|0;q=e+4|0;s=0;r=h;while(1){t=f[e>>2]|0;u=b[p+s>>0]|0;v=mJc(u|0,((u|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;u=UIc(v|0,t|0,-2147483648,0)|0;w=J;x=w>>>0<1|(w|0)==1&u>>>0<0?v:(t|0)>0|(t|0)==0&v>>>0>0?2147483647:-2147483648;f[r>>2]=x;v=f[q>>2]|0;t=b[p+(s+c)>>0]|0;u=mJc(t|0,((t|0)<0)<<31>>31|0,v|0,((v|0)<0)<<31>>31|0)|0;v=J;t=UIc(u|0,v|0,-2147483648,0)|0;w=J;y=w>>>0<1|(w|0)==1&t>>>0<0?u:(v|0)>0|(v|0)==0&u>>>0>0?2147483647:-2147483648;u=y+x|0;f[r>>2]=((u^x)&(u^y)|0)<0?(u|2147483647)^-2147483648:u;s=s+1|0;if((s|0)==(c|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(i|0)){z=i;A=g;break}else{e=e+8|0;h=h+(c<<2)|0}}}else{z=i;A=m}else{z=n;A=m}m=a+(Y(f[d+(j+-1<<2)>>2]|0,c)|0)|0;if((z|0)<(j|0)&(c|0)>0){B=z;C=A}else return;while(1){A=0;z=C;while(1){f[z>>2]=b[m+A>>0]<<16;A=A+1|0;if((A|0)==(c|0))break;else z=z+4|0}B=B+1|0;if((B|0)==(j|0))break;else C=C+(c<<2)|0}return}function Yea(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;do if((h|0)>0){k=h<<1;if((c|0)<=0){l=e+(k<<2)|0;m=g;n=h;break}o=Y(h,c)|0;p=g;q=0;while(1){r=0;s=p;while(1){f[s>>2]=b[a+r>>0]<<16;r=r+1|0;if((r|0)==(c|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(h|0))break;else p=p+(c<<2)|0}l=e+(k<<2)|0;m=g+(o<<2)|0;n=h}else{l=e;m=g;n=0}while(0);if((n|0)<(i|0))if((c|0)>0){g=m+((Y(i-n|0,c)|0)<<2)|0;e=l;l=n;h=m;while(1){p=a+(Y(f[d+(l<<2)>>2]|0,c)|0)|0;q=e+4|0;s=0;r=h;while(1){t=f[e>>2]|0;if(!t)u=0;else{v=b[p+s>>0]|0;w=mJc(v|0,((v|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;v=UIc(w|0,t|0,-2147483648,0)|0;x=J;u=x>>>0<1|(x|0)==1&v>>>0<0?w:(t|0)>0|(t|0)==0&w>>>0>0?2147483647:-2147483648}f[r>>2]=u;w=f[q>>2]|0;if(!w)y=0;else{t=b[p+(s+c)>>0]|0;v=mJc(t|0,((t|0)<0)<<31>>31|0,w|0,((w|0)<0)<<31>>31|0)|0;w=J;t=UIc(v|0,w|0,-2147483648,0)|0;x=J;y=x>>>0<1|(x|0)==1&t>>>0<0?v:(w|0)>0|(w|0)==0&v>>>0>0?2147483647:-2147483648}v=u+y|0;f[r>>2]=((v^u)&(v^y)|0)<0?(v|2147483647)^-2147483648:v;s=s+1|0;if((s|0)==(c|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(i|0)){z=i;A=g;break}else{e=e+8|0;h=h+(c<<2)|0}}}else{z=i;A=m}else{z=n;A=m}m=a+(Y(f[d+(j+-1<<2)>>2]|0,c)|0)|0;if((z|0)<(j|0)&(c|0)>0){B=z;C=A}else return;while(1){A=0;z=C;while(1){f[z>>2]=b[m+A>>0]<<16;A=A+1|0;if((A|0)==(c|0))break;else z=z+4|0}B=B+1|0;if((B|0)==(j|0))break;else C=C+(c<<2)|0}return}function Zea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;Vmc(j,b);p[h>>3]=.5;bnc(g,j,h);fnc(k,a,g);p[l>>3]=.5;enc(i,k,l);k=_mc(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;Vmc(m,k);enc(l,i,m);Vmc(h,65536);fnc(g,l,h);h=Zmc(g)|0;f[d+4>>2]=h;g=65536-h|0;f[d>>2]=(g&h|0)<0?(g|2147483647)^-2147483648:g;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function _ea(a){a=a|0;YDc(a);return}function $ea(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=u;u=u+1072|0;e=d+8|0;g=d;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;XIc(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=XDc(l>>>0>1073741823?-1:l<<2)|0;XIc(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[c>>2]|0;q=(o|0)<(l|0)?l:o;r=c+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[c>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=a+20|0;c=a+24|0;i=y;do{p=f[e>>2]|0;k=(f[l>>2]|0)+(Y(f[c>>2]|0,i)|0)|0;o=Y(f[j>>2]|0,f[h>>2]|0)|0;if((o|0)>0){t=0;do{s=(f[p+(t<<2)>>2]|0)+32768>>16;b[k+t>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;t=t+1|0}while((t|0)!=(o|0))}i=i+1|0}while((i|0)<(q|0));z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;i=a+20|0;c=a+24|0;l=g+4|0;o=a+52|0;t=a+72|0;k=a+4|0;p=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[k>>2]|0)+(Y(f[p>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;wi[f[t>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){dJc(g|0,(f[o>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;dJc(g+(V<<2)|0,(f[o>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[i>>2]|0)+(Y(f[c>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=f[l>>2]|0;P=((R|0)<0)<<31>>31;W=((O|0)<0)<<31>>31;X=0;do{Z=f[M+(X<<2)>>2]|0;_=mJc(R|0,P|0,Z|0,((Z|0)<0)<<31>>31|0)|0;Z=J;$=f[M+(X+I<<2)>>2]|0;aa=mJc(O|0,W|0,$|0,(($|0)<0)<<31>>31|0)|0;$=J;ba=UIc(aa|0,$|0,_|0,Z|0)|0;_=J;aa=((_^Z)&(_^$)|0)<0;$=UIc((aa?-1:ba)|0,(aa?(_|2147483647)^-2147483648:_)|0,-2147483648,0)|0;_=$Ic($|0,J|0,32)|0;$=J;aa=UIc(_|0,$|0,128,0)|0;ba=J;b[Q+X>>0]=ba>>>0<0|(ba|0)==0&aa>>>0<256?_&255:($|0)>0|($|0)==0&_>>>0>0?127:-128;X=X+1|0}while((X|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{ca=U;da=K;ea=I;fa=q;break}}}else{ca=w;da=x;ea=z;fa=a+16|0}z=f[e>>2]|0;x=f[fa>>2]|0;if((ca+2|0)>(x|0))ga=z+((Y(Y(f[h>>2]|0,(da+~ca+x|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{ca=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,x+-1|0)|0)|0;wi[f[a+72>>2]&255](ca,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,z,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);ga=z}z=f[r>>2]|0;if((ea|0)<(z|0)){ca=a+20|0;x=a+24|0;a=ea;ea=z;while(1){z=(f[ca>>2]|0)+(Y(f[x>>2]|0,a)|0)|0;da=Y(f[j>>2]|0,f[h>>2]|0)|0;if((da|0)>0){fa=0;do{w=(f[ga+(fa<<2)>>2]|0)+32768>>16;b[z+fa>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;fa=fa+1|0}while((fa|0)!=(da|0));ha=f[r>>2]|0}else ha=ea;a=a+1|0;if((a|0)>=(ha|0))break;else ea=ha}}ha=f[e>>2]|0;if((ha|0)==(m|0)){u=d;return}if(ha|0)ZDc(ha);f[e>>2]=m;f[n>>2]=264;u=d;return}function afa(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=(h[a>>0]|0)<<8&65535;if((i|0)>0){m=i<<1;n=0;o=g;while(1){d[o>>1]=b;n=n+1|0;if((n|0)==(i|0))break;else o=o+2|0}p=e+(m<<1)|0;q=i;r=g+(i<<1)|0}else{p=e;q=0;r=g}if((q|0)<(k|0)){g=k-q|0;e=q;i=r;m=p;while(1){p=a+(f[c+(e<<2)>>2]|0)|0;o=Y(h[p>>0]|0,j[m>>1]|0)|0;n=o>>>0<65535?o:65535;o=Y(h[p+1>>0]|0,j[m+2>>1]|0)|0;p=(o>>>0<65535?o:65535)+n|0;d[i>>1]=n>>>0>(p&65535)>>>0?-1:p&65535;e=e+1|0;if((e|0)==(k|0))break;else{i=i+2|0;m=m+4|0}}s=k;t=r+(g<<1)|0}else{s=q;t=r}r=(h[a+(f[c+(l+-1<<2)>>2]|0)>>0]|0)<<8&65535;if((s|0)<(l|0)){u=t;v=s}else return;while(1){d[u>>1]=r;v=v+1|0;if((v|0)==(l|0))break;else u=u+2|0}return}function bfa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;jfa(a,b,c,d,e,f,g,h);return}function cfa(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=(h[a>>0]|0)<<8&65535;m=(h[a+1>>0]|0)<<8&65535;if((i|0)>0){n=i<<1;o=g+(n<<1)|0;p=0;q=g;while(1){d[q>>1]=b;d[q+2>>1]=m;p=p+1|0;if((p|0)==(i|0))break;else q=q+4|0}r=e+(n<<1)|0;s=i;t=o}else{r=e;s=0;t=g}if((s|0)<(k|0)){g=k-s<<1;e=s;o=t;i=r;while(1){r=a+(f[c+(e<<2)>>2]<<1)|0;n=Y(h[r>>0]|0,j[i>>1]|0)|0;q=n>>>0<65535?n:65535;n=i+2|0;p=Y(h[r+2>>0]|0,j[n>>1]|0)|0;m=(p>>>0<65535?p:65535)+q|0;d[o>>1]=q>>>0>(m&65535)>>>0?-1:m&65535;m=Y(h[r+1>>0]|0,j[i>>1]|0)|0;q=m>>>0<65535?m:65535;m=Y(h[r+3>>0]|0,j[n>>1]|0)|0;n=(m>>>0<65535?m:65535)+q|0;d[o+2>>1]=q>>>0>(n&65535)>>>0?-1:n&65535;e=e+1|0;if((e|0)==(k|0))break;else{o=o+4|0;i=i+4|0}}u=k;v=t+(g<<1)|0}else{u=s;v=t}t=a+(f[c+(l+-1<<2)>>2]<<1)|0;c=(h[t>>0]|0)<<8&65535;a=(h[t+1>>0]|0)<<8&65535;if((u|0)<(l|0)){w=v;x=u}else return;while(1){d[w>>1]=c;d[w+2>>1]=a;x=x+1|0;if((x|0)==(l|0))break;else w=w+4|0}return}function dfa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;jfa(a,b,c,d,e,f,g,h);return}function efa(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=(h[a>>0]|0)<<8&65535;m=(h[a+1>>0]|0)<<8&65535;n=(h[a+2>>0]|0)<<8&65535;if((i|0)>0){o=i*3|0;p=0;q=g;while(1){d[q>>1]=b;d[q+2>>1]=m;d[q+4>>1]=n;p=p+1|0;if((p|0)==(i|0))break;else q=q+6|0}r=e+(i<<1<<1)|0;s=i;t=g+(o<<1)|0}else{r=e;s=0;t=g}if((s|0)<(k|0)){g=k-s|0;e=s;o=t;i=r;while(1){r=a+((f[c+(e<<2)>>2]|0)*3|0)|0;q=Y(h[r>>0]|0,j[i>>1]|0)|0;p=q>>>0<65535?q:65535;q=i+2|0;n=Y(h[r+3>>0]|0,j[q>>1]|0)|0;m=(n>>>0<65535?n:65535)+p|0;d[o>>1]=p>>>0>(m&65535)>>>0?-1:m&65535;m=Y(h[r+1>>0]|0,j[i>>1]|0)|0;p=m>>>0<65535?m:65535;m=Y(h[r+4>>0]|0,j[q>>1]|0)|0;n=(m>>>0<65535?m:65535)+p|0;d[o+2>>1]=p>>>0>(n&65535)>>>0?-1:n&65535;n=Y(h[r+2>>0]|0,j[i>>1]|0)|0;p=n>>>0<65535?n:65535;n=Y(h[r+5>>0]|0,j[q>>1]|0)|0;q=(n>>>0<65535?n:65535)+p|0;d[o+4>>1]=p>>>0>(q&65535)>>>0?-1:q&65535;e=e+1|0;if((e|0)==(k|0))break;else{o=o+6|0;i=i+4|0}}u=k;v=t+(g*3<<1)|0}else{u=s;v=t}t=a+((f[c+(l+-1<<2)>>2]|0)*3|0)|0;c=(h[t>>0]|0)<<8&65535;a=(h[t+1>>0]|0)<<8&65535;s=(h[t+2>>0]|0)<<8&65535;if((u|0)<(l|0)){w=v;x=u}else return;while(1){d[w>>1]=c;d[w+2>>1]=a;d[w+4>>1]=s;x=x+1|0;if((x|0)==(l|0))break;else w=w+6|0}return}function ffa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;jfa(a,b,c,d,e,f,g,h);return}function gfa(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((i|0)>0){i=(h[a+3>>0]|0)<<8&65535;b=(h[a+2>>0]|0)<<8&65535;m=(h[a+1>>0]|0)<<8&65535;d[g>>1]=(h[a>>0]|0)<<8;d[g+2>>1]=m;d[g+4>>1]=b;d[g+6>>1]=i;n=e+4|0;o=1;p=g+8|0}else{n=e;o=0;p=g}if((o|0)<(k|0)){g=k-o<<2;e=n;n=o;i=p;while(1){b=a+(f[c+(n<<2)>>2]<<2)|0;m=Y(h[b>>0]|0,j[e>>1]|0)|0;q=m>>>0<65535?m:65535;m=e+2|0;r=Y(h[b+4>>0]|0,j[m>>1]|0)|0;s=(r>>>0<65535?r:65535)+q|0;d[i>>1]=q>>>0>(s&65535)>>>0?-1:s&65535;s=Y(h[b+1>>0]|0,j[e>>1]|0)|0;q=s>>>0<65535?s:65535;s=Y(h[b+5>>0]|0,j[m>>1]|0)|0;r=(s>>>0<65535?s:65535)+q|0;d[i+2>>1]=q>>>0>(r&65535)>>>0?-1:r&65535;r=Y(h[b+2>>0]|0,j[e>>1]|0)|0;q=r>>>0<65535?r:65535;r=Y(h[b+6>>0]|0,j[m>>1]|0)|0;s=(r>>>0<65535?r:65535)+q|0;d[i+4>>1]=q>>>0>(s&65535)>>>0?-1:s&65535;s=Y(h[b+3>>0]|0,j[e>>1]|0)|0;q=s>>>0<65535?s:65535;s=Y(h[b+7>>0]|0,j[m>>1]|0)|0;m=(s>>>0<65535?s:65535)+q|0;d[i+6>>1]=q>>>0>(m&65535)>>>0?-1:m&65535;n=n+1|0;if((n|0)==(k|0))break;else{e=e+4|0;i=i+8|0}}t=k;u=p+(g<<1)|0}else{t=o;u=p}p=a+(f[c+(l+-1<<2)>>2]<<2)|0;if((t|0)>=(l|0))return;l=(h[p+3>>0]|0)<<8&65535;t=(h[p+2>>0]|0)<<8&65535;c=(h[p+1>>0]|0)<<8&65535;d[u>>1]=(h[p>>0]|0)<<8;d[u+2>>1]=c;d[u+4>>1]=t;d[u+6>>1]=l;return}function hfa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;jfa(a,b,c,d,e,f,g,h);return}function ifa(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;do if((i|0)>0){m=i<<1;if((b|0)<=0){n=e+(m<<1)|0;o=g;p=i;break}q=Y(i,b)|0;r=g;s=0;while(1){t=0;u=r;while(1){d[u>>1]=(h[a+t>>0]|0)<<8;t=t+1|0;if((t|0)==(b|0))break;else u=u+2|0}s=s+1|0;if((s|0)==(i|0))break;else r=r+(b<<1)|0}n=e+(m<<1)|0;o=g+(q<<1)|0;p=i}else{n=e;o=g;p=0}while(0);if((p|0)<(k|0))if((b|0)>0){g=o+((Y(k-p|0,b)|0)<<1)|0;e=n;n=p;i=o;while(1){r=a+(Y(f[c+(n<<2)>>2]|0,b)|0)|0;s=e+2|0;u=0;t=i;while(1){v=Y(h[r+u>>0]|0,j[e>>1]|0)|0;w=v>>>0<65535?v:65535;d[t>>1]=w;v=Y(h[r+(u+b)>>0]|0,j[s>>1]|0)|0;x=(v>>>0<65535?v:65535)+w|0;d[t>>1]=w>>>0>(x&65535)>>>0?-1:x&65535;u=u+1|0;if((u|0)==(b|0))break;else t=t+2|0}n=n+1|0;if((n|0)==(k|0)){y=k;z=g;break}else{e=e+4|0;i=i+(b<<1)|0}}}else{y=k;z=o}else{y=p;z=o}o=a+(Y(f[c+(l+-1<<2)>>2]|0,b)|0)|0;if((y|0)<(l|0)&(b|0)>0){A=y;B=z}else return;while(1){z=0;y=B;while(1){d[y>>1]=(h[o+z>>0]|0)<<8;z=z+1|0;if((z|0)==(b|0))break;else y=y+2|0}A=A+1|0;if((A|0)==(l|0))break;else B=B+(b<<1)|0}return}function jfa(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;do if((i|0)>0){l=i<<1;if((b|0)<=0){m=e+(l<<1)|0;n=g;o=i;break}p=Y(i,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){d[t>>1]=(h[a+s>>0]|0)<<8;s=s+1|0;if((s|0)==(b|0))break;else t=t+2|0}r=r+1|0;if((r|0)==(i|0))break;else q=q+(b<<1)|0}m=e+(l<<1)|0;n=g+(p<<1)|0;o=i}else{m=e;n=g;o=0}while(0);if((o|0)<(j|0))if((b|0)>0){g=n+((Y(j-o|0,b)|0)<<1)|0;e=m;m=o;i=n;while(1){q=a+(Y(f[c+(m<<2)>>2]|0,b)|0)|0;r=e+2|0;t=0;s=i;while(1){u=d[e>>1]|0;if(!(u<<16>>16))v=0;else{w=Y(h[q+t>>0]|0,u&65535)|0;v=(w>>>0<65535?w:65535)&65535}d[s>>1]=v;w=d[r>>1]|0;if(!(w<<16>>16))x=0;else{u=Y(h[q+(t+b)>>0]|0,w&65535)|0;x=u>>>0<65535?u:65535}u=v&65535;w=u+x|0;d[s>>1]=u>>>0>(w&65535)>>>0?-1:w&65535;t=t+1|0;if((t|0)==(b|0))break;else s=s+2|0}m=m+1|0;if((m|0)==(j|0)){y=j;z=g;break}else{e=e+4|0;i=i+(b<<1)|0}}}else{y=j;z=n}else{y=o;z=n}n=a+(Y(f[c+(k+-1<<2)>>2]|0,b)|0)|0;if((y|0)<(k|0)&(b|0)>0){A=y;B=z}else return;while(1){z=0;y=B;while(1){d[y>>1]=(h[n+z>>0]|0)<<8;z=z+1|0;if((z|0)==(b|0))break;else y=y+2|0}A=A+1|0;if((A|0)==(k|0))break;else B=B+(b<<1)|0}return}function kfa(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;g=u;u=u+64|0;h=g+48|0;i=g+40|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;Vmc(k,b);p[i>>3]=.5;bnc(h,k,i);fnc(l,a,h);p[m>>3]=.5;enc(j,l,m);l=_mc(j)|0;if((l|0)>-1?(k=f[a+8>>2]|0,(k|0)>1):0){o=k+-1|0;if((l|0)>=(o|0)){f[c>>2]=o;o=a+16|0;k=f[o>>2]|0;f[o>>2]=(k|0)>(b|0)?b:k;u=g;return}f[c>>2]=l;Vmc(n,l);enc(m,j,n);if((f[m+4>>2]|0)<0)q=0;else{Vmc(i,256);fnc(h,m,i);q=(Zmc(h)|0)&65535}d[e+2>>1]=q;d[e>>1]=(q&65535)<256?256-(q&65535)&65535:0;u=g;return}q=a+12|0;a=b+1|0;b=f[q>>2]|0;f[q>>2]=(b|0)<(a|0)?a:b;u=g;return}function lfa(a){a=a|0;YDc(a);return}function mfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;d=u;u=u+1056|0;e=d+8|0;g=d;h=a+28|0;i=f[h>>2]|0;k=a+36|0;l=f[k>>2]|0;m=Y(i<<1,l)|0;n=e+8|0;XIc(n|0,0,1040)|0;f[e>>2]=n;o=e+4|0;f[o>>2]=m;if(m>>>0>520){p=XDc(m>>>0>2147483647?-1:m<<1)|0;XIc(p|0,0,m<<1|0)|0;f[e>>2]=p;q=p}else q=n;p=f[a+64>>2]|0;m=f[c>>2]|0;r=(p|0)<(m|0)?m:p;s=c+4|0;t=f[s>>2]|0;v=f[a+68>>2]|0;w=(t|0)<(v|0)?t:v;if((m|0)<(p|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,l,f[a+40>>2]|0,f[a+48>>2]|0,q,f[a+56>>2]|0,f[a+60>>2]|0,i);x=-1;y=1;z=f[c>>2]|0}else{x=-2;y=0;z=m}if((z|0)<(r|0)){m=a+20|0;c=a+24|0;i=z;do{q=Y(f[k>>2]|0,f[h>>2]|0)|0;if((q|0)>0){l=(f[m>>2]|0)+(Y(f[c>>2]|0,i)|0)|0;p=f[e>>2]|0;v=l;l=0;while(1){b[v>>0]=((j[p>>1]|0)+128|0)>>>8;l=l+1|0;if((l|0)==(q|0))break;else{p=p+2|0;v=v+1|0}}}i=i+1|0}while((i|0)<(r|0));A=r}else A=z;if((A|0)<(w|0)){z=a+44|0;r=a+16|0;i=a+20|0;c=a+24|0;m=g+2|0;v=a+52|0;p=a+72|0;q=a+4|0;l=a+8|0;t=a+40|0;B=a+48|0;C=a+56|0;D=a+60|0;E=x;F=y;G=A;H=0;while(1){I=A+H<<1;J=(f[z>>2]|0)+(G<<2)|0;K=E+2|0;L=f[J>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[r>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=F;while(1){O=(f[q>>2]|0)+(Y(f[l>>2]|0,K)|0)|0;P=f[k>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<1)|0;wi[f[p>>2]&255](O,P,f[t>>2]|0,f[B>>2]|0,R,f[C>>2]|0,f[D>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[J>>2]|0;P=R+2|0;O=f[r>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=F;T=N;U=L}M=T+-2|0;f[g>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((E|0)<(M|0)?M:E)|0)%2|0;if((K|0)>0){dJc(g|0,(f[v>>2]|0)+((G<<1)+2-K<<1)|0,K<<1|0)|0;V=K}else V=0;dJc(g+(V<<1)|0,(f[v>>2]|0)+(V+I-K<<1)|0,4-(V<<1)|0)|0;M=f[e>>2]|0;J=Y(f[k>>2]|0,f[h>>2]|0)|0;if((J|0)>0){Q=0;R=M;O=(f[i>>2]|0)+(Y(f[c>>2]|0,G)|0)|0;P=M+(J<<1)|0;while(1){M=Y(j[g>>1]|0,j[R>>1]|0)|0;W=(Y(j[m>>1]|0,j[P>>1]|0)|0)+M|0;X=W>>>0<M>>>0?0:(W+32768|0)>>>16;b[O>>0]=X>>>0<255?X:255;Q=Q+1|0;if((Q|0)==(J|0))break;else{R=R+2|0;O=O+1|0;P=P+2|0}}}P=G+1|0;if((P|0)<(w|0)){E=U;F=K;G=P;H=H+1|0}else{Z=U;_=K;$=P;aa=r;break}}}else{Z=x;_=y;$=A;aa=a+16|0}A=f[e>>2]|0;y=f[aa>>2]|0;if((Z+2|0)>(y|0))ba=A+((Y(Y(f[h>>2]|0,(_+~Z+y|0)%2|0)|0,f[k>>2]|0)|0)<<1)|0;else{Z=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,y+-1|0)|0)|0;wi[f[a+72>>2]&255](Z,f[k>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,A,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);ba=A}A=f[s>>2]|0;if(($|0)<(A|0)){Z=a+20|0;y=a+24|0;a=$;$=A;while(1){A=Y(f[k>>2]|0,f[h>>2]|0)|0;if((A|0)>0){_=ba;aa=(f[Z>>2]|0)+(Y(f[y>>2]|0,a)|0)|0;x=0;while(1){b[aa>>0]=((j[_>>1]|0)+128|0)>>>8;x=x+1|0;if((x|0)==(A|0))break;else{_=_+2|0;aa=aa+1|0}}ca=f[s>>2]|0}else ca=$;a=a+1|0;if((a|0)>=(ca|0))break;else $=ca}}ca=f[e>>2]|0;if((ca|0)==(n|0)){u=d;return}if(ca|0)ZDc(ca);f[e>>2]=n;f[o>>2]=520;u=d;return}function nfa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0;i=u;u=u+144|0;j=i+136|0;k=i+80|0;l=i+72|0;m=i+16|0;n=i;b$(j,a,-1);o=f[j>>2]|0;if((o|0)<1){f[k>>2]=0;p=k+4|0;f[p>>2]=0;q=tT(k,14)|0;r=q;s=271301;t=r+14|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,k,251123,251130,3784)}v=j+4|0;w=f[v>>2]|0;if((w|0)<1){f[k>>2]=0;p=k+4|0;f[p>>2]=0;q=tT(k,14)|0;r=q;s=271301;t=r+14|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,k,251123,251130,3784)}q=f[d>>2]|0;p=(q|0)<1;if(!p?(f[d+4>>2]|0)>=1:0)x=10;else{if(!(e>0.0&g>0.0)){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,54)|0;s=254003;t=r+54|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,k,251123,251130,3785)}if(p){y=d+4|0;x=11}else x=10}if((x|0)==10){p=d+4|0;z=f[p>>2]|0;if((z|0)<1){y=p;x=11}else{A=+(z|0)/+(w|0);B=+(q|0)/+(o|0)}}if((x|0)==11){x=nrc(+(o|0)*e)|0;o=nrc(+(w|0)*g)|0;f[d>>2]=x;f[y>>2]=o;if((x|0)<1|(o|0)<1){f[k>>2]=0;f[k+4>>2]=0;r=tT(k,14)|0;s=251198;t=r+14|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,k,251123,251130,3790)}else{A=g;B=e}}do if((h|0)==5){if((p$(a,-1)|0)!=5?(p$(a,-1)|0)!=6:0){C=5;break}C=1}else C=h;while(0);do if((d$(a)|0)==65536){h=f[a+4>>2]|0;f[k>>2]=f[h>>2];s=k+4|0;r=h+4|0;f[s>>2]=f[r>>2];t=k+8|0;f[t>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[k+16>>2]=f[h+16>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];o=f[h+36>>2]|0;f[k+36>>2]=o;f[k+40>>2]=t;t=k+48|0;x=k+44|0;f[x>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(o|0){t=o+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[r>>2]|0)<3){r=f[h+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];D=k;break}else{f[s>>2]=0;ZS(k,h);D=k;break}}else{a$(k,a,-1);D=k}while(0);f[l>>2]=f[d>>2];a=d+4|0;f[l+4>>2]=f[a>>2];v$(c,l,f[D>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){l=f[c+4>>2]|0;f[m>>2]=f[l>>2];h=m+4|0;s=l+4|0;f[h>>2]=f[s>>2];r=m+8|0;f[r>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];t=f[l+36>>2]|0;f[m+36>>2]=t;f[m+40>>2]=r;r=m+48|0;x=m+44|0;f[x>>2]=r;f[r>>2]=0;f[m+52>>2]=0;if(t|0){r=t+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[s>>2]|0)<3){s=f[l+44>>2]|0;r=f[x>>2]|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];break}else{f[h>>2]=0;ZS(m,l);break}}else a$(m,c,-1);while(0);if((f[d>>2]|0)==(f[j>>2]|0)?(f[a>>2]|0)==(f[v>>2]|0):0){v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=m;h_(k,n)}else jba(f[D>>2]&4095,f[k+16>>2]|0,f[k+48>>2]|0,f[k+12>>2]|0,f[k+8>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,f[m+12>>2]|0,f[m+8>>2]|0,B,A,C);C=m+36|0;D=f[C>>2]|0;if(D|0?(n=D+12|0,D=f[n>>2]|0,f[n>>2]=D+-1,(D|0)==1):0)_S(m);f[C>>2]=0;C=m+16|0;D=m+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[D>>2]|0)>0){C=f[m+40>>2]|0;n=0;do{f[C+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[D>>2]|0))}D=f[m+44>>2]|0;if((D|0)!=(m+48|0))g0(D);D=k+36|0;m=f[D>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)_S(k);f[D>>2]=0;D=k+16|0;m=k+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[m>>2]|0)>0){D=f[k+40>>2]|0;n=0;do{f[D+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)==(k+48|0)){u=i;return}g0(m);u=i;return}function ofa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+160|0;g=e+96|0;h=e+40|0;i=e+24|0;j=e;k=e+16|0;O4(g,a,0,1,0,0);O4(h,c,0,1,0,0);if((f[h>>2]^f[g>>2])&4095|0){f[i>>2]=0;f[i+4>>2]=0;c=tT(i,24)|0;a=453346;l=c+24|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(l|0));z5(-215,i,254058,251130,3823)}f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=g;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=h;a=h+40|0;c=f[a>>2]|0;l=f[c>>2]|0;f[k>>2]=f[c+4>>2];f[k+4>>2]=l;nfa(i,j,k,+(f[h+12>>2]|0)/+(f[g+12>>2]|0),+(f[h+8>>2]|0)/+(f[g+8>>2]|0),d);d=h+36|0;k=f[d>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;k=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[a>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[k>>2]|0))}k=f[h+44>>2]|0;if((k|0)!=(h+48|0))g0(k);k=g+36|0;h=f[k>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)_S(g);f[k>>2]=0;k=g+16|0;h=g+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[h>>2]|0)>0){k=f[g+40>>2]|0;a=0;do{f[k+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}g0(h);u=e;return}function pfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(c|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;z5(-27,e,254067,254090,60)}if((f[a+28>>2]|0)!=1){f[e>>2]=0;g=e+4|0;f[g>>2]=0;z5(-201,e,254067,254090,63)}if((f[a+4>>2]|0)<64){f[e>>2]=0;g=e+4|0;f[g>>2]=0;z5(-201,e,254067,254090,63)}else{r7(a,c,0);e=a+56|0;a=f[e+4>>2]|0;g=c+36|0;f[g>>2]=f[e>>2];f[g+4>>2]=a;b[c+44>>0]=1;b[c+45>>0]=0;b[c+46>>0]=1;b[c+47>>0]=-1;b[c+48>>0]=0;a=c+49|0;b[a>>0]=-1;b[a+1>>0]=-1>>8;b[a+2>>0]=-1>>16;b[a+3>>0]=-1>>24;b[c+53>>0]=0;b[c+54>>0]=-1;b[c+55>>0]=1;b[c+56>>0]=0;b[c+57>>0]=1;b[c+58>>0]=1;b[c+59>>0]=1;u=d;return}}function qfa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=u;u=u+48|0;l=k+8|0;m=k;if(!c){f[l>>2]=0;f[l+4>>2]=0;z5(-27,l,254160,254090,184)}n=G0(a,l,0,0)|0;l=f[n>>2]|0;a=(l&4095|0)==4;o=(e|0)==2&a?4:e;if(!((l&4094|0)==0&(o|0)<4|a&(o|0)==4)){f[m>>2]=0;f[m+4>>2]=0;p=tT(m,119)|0;q=254185;r=p+119|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-210,m,254160,254090,195)}a=f[n+24>>2]|0;l=f[n+20>>2]|0;e=f[n+4>>2]|0;s=f[n+16>>2]|0;if(g>>>0>4){f[m>>2]=0;f[m+4>>2]=0;z5(-211,m,254160,254090,202)}t=(g|0)==0;if(((t?64:88)|0)>(d|0)){f[m>>2]=0;f[m+4>>2]=0;z5(-201,m,254160,254090,205)}v=h0(788)|0;XIc(v+8|0,0,780)|0;w=v+4|0;f[w>>2]=c;f[v>>2]=c;f[v+40>>2]=s;x=s+e|0;f[v+44>>2]=x;f[v+48>>2]=e;y=a+-1|0;f[v+52>>2]=y;z=l+-1|0;f[v+56>>2]=z;f[v+244>>2]=o;A=v+60|0;f[A>>2]=h;f[A+4>>2]=i;f[v+72>>2]=1;f[v+68>>2]=1;f[v+76>>2]=0;f[v+80>>2]=1;f[v+84>>2]=2;i=v+180|0;f[v+148>>2]=i;f[v+176>>2]=1;f[v+140>>2]=0;f[v+144>>2]=0;f[v+152>>2]=0;f[v+156>>2]=0;f[v+160>>2]=a;f[v+164>>2]=l;f[v+88>>2]=0;f[v+248>>2]=0;f[i>>2]=32768;i=v+236|0;f[i>>2]=g;f[v+240>>2]=g;do if((g+-3|0)>>>0>=2){A=v+252|0;if(t){f[A>>2]=20480;B=d;C=1;D=0;E=20480;F=A;break}else{f[A>>2]=20492;B=d;C=8;D=g;E=20492;F=A;break}}else{f[i>>2]=0;A=v+252|0;f[A>>2]=20480;B=64;C=1;D=g;E=20480;F=A}while(0);f[v+256>>2]=B;f[v+260>>2]=C;f[v+268>>2]=d;d=(D|0)==0;D=v+264|0;f[D>>2]=d?E:20492;f[v+272>>2]=d?C:8;f[F>>2]=E;f[D>>2]=t?20480:20492;h7(c,v+16|0);if((g|0)>2){g=e7(f[w>>2]|0)|0;f[v>>2]=g}if((o|0)>1){o=e7(f[w>>2]|0)|0;f[v+8>>2]=o;w=G7(0,64,44,o)|0;f[v+12>>2]=w}if((e|0)<=-1){f[m>>2]=0;f[m+4>>2]=0;p=tT(m,9)|0;q=254305;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,m,254160,254090,285)}if((l|0)<=0){f[m>>2]=0;f[m+4>>2]=0;p=tT(m,16)|0;q=254315;r=p+16|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,m,254160,254090,286)}if((j|0?(j=f[n>>2]|0,m=(j>>>3&511)+1<<(47696>>>(j<<1&14)&3),j=Y(m,a)|0,XIc(s|0,0,j|0)|0,XIc(s+(Y(e,z)|0)|0,0,j|0)|0,(z|0)>1):0)?(j=Y(m,y)|0,(m|0)>0):0){y=1;s=x;while(1){x=0;do{b[s+(x+j)>>0]=0;b[s+x>>0]=0;x=x+1|0}while((x|0)!=(m|0));y=y+1|0;if((y|0)==(z|0))break;else s=s+e|0}}if((f[n>>2]&4095|0)==4){u=k;return v|0}+Jxa(n,n,0.0,1.0,0);u=k;return v|0}function rfa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0;c=u;u=u+128|0;d=c+104|0;e=c+88|0;g=c+80|0;h=c+72|0;i=c+8|0;j=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;z5(-27,d,254332,254090,1007)}k=a+48|0;l=f[k>>2]|0;if((l|0)<=-1){f[d>>2]=0;f[d+4>>2]=0;m=tT(d,22)|0;n=254350;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,254332,254090,1013)}p=a+88|0;q=f[p>>2]|0;if(!q)r=l;else{l=a+248|0;if(f[l>>2]|0){s=a+4|0;h7(f[s>>2]|0,d);if((f[d>>2]|0)==(f[a+32>>2]|0)?(f[d+4>>2]|0)==(f[a+36>>2]|0):0)i7(f[s>>2]|0,a+24|0);f[l>>2]=0}l=f[q+12>>2]|0;if(l|0)R7(l,f[(f[q+8>>2]|0)+12>>2]|0,a+180|0);f[p>>2]=0;r=f[k>>2]|0}k=f[a+40>>2]|0;q=a+44|0;l=f[q>>2]|0;s=r>>>2;t=a+68|0;v=f[t>>2]|0;w=a+72|0;x=f[w>>2]|0;y=f[a+52>>2]|0;z=f[a+56>>2]|0;A=f[a+244>>2]|0;B=a+76|0;C=a+84|0;D=v+-1|0;E=(A|0)==4;if(E){F=-1073741824;G=f[l+(D<<2)>>2]|0}else{F=-2;G=b[l+D>>0]|0}if((x|0)>=(z|0)){H=0;u=c;return H|0}D=~F;I=(A|0)==0;J=a+136|0;K=a+4|0;L=a+24|0;M=a+252|0;N=a+256|0;O=a+260|0;P=a+92|0;Q=a+60|0;R=a+64|0;S=a+236|0;T=0-r|0;U=1-r|0;V=i+4|0;W=i+8|0;X=~r;Z=i+12|0;_=i+16|0;$=r+-1|0;aa=i+20|0;ba=i+24|0;ca=r+1|0;da=i+28|0;ea=i+32|0;fa=d+12|0;ga=d+20|0;ha=a+240|0;ia=a+32|0;ja=a+268|0;ka=a+12|0;la=0-s|0;ma=1-s|0;na=~s;oa=s+-1|0;pa=s+1|0;qa=d+12|0;ra=d+20|0;sa=d+12|0;ta=d+20|0;ua=(A|0)<2;va=E?k:0;wa=(va|0)!=0;xa=G;G=f[C>>2]|0;ya=l;l=x;x=v;v=f[B>>2]|0;za=f[a+80>>2]|0;a:while(1){Aa=E?ya:0;b:do if((x|0)<(y|0)){Ba=(Aa|0)!=0;Ca=Y(za,r)|0;Da=Y(za,s)|0;Ea=0;Fa=xa;Ga=G;Ha=x;Ia=v;while(1){Ja=(Ha|0)<(y|0);c:do if(Ba)if(Ja){Ka=Fa;La=Ha;while(1){Ma=f[Aa+(La<<2)>>2]|0;if((Ma|0)!=(Ka|0)?(Ma^Ka)&D|0:0){Na=Ma;Oa=Ka;Pa=La;break c}Qa=La+1|0;if((Qa|0)<(y|0)){Ka=Ma;La=Qa}else{Na=Ma;Oa=Ma;Pa=Qa;break}}}else{Na=Ea;Oa=Fa;Pa=Ha}else if(Ja){La=Ha;while(1){Ka=b[ya+La>>0]|0;if((Ka|0)!=(Fa|0)){Na=Ka;Oa=Fa;Pa=La;break c}Ka=La+1|0;if((Ka|0)<(y|0))La=Ka;else{Na=Fa;Oa=Fa;Pa=Ka;break}}}else{Na=Ea;Oa=Fa;Pa=Ha}while(0);if((Pa|0)>=(y|0)){Ra=Ga;break b}if(Ba){Ja=(Oa&F|0)!=0;La=(Na&F|0)==0;if(!(((Oa|0)==0|Ja)&La))if(La&(Ja^1))if(Ja)Sa=36;else{Ta=1;Ua=Ia;Sa=37}else{Va=Ga;Wa=Na;Xa=Ia}else{Ta=0;Ua=Ia;Sa=37}}else if(!((Oa|0)==0&(Na|0)==1))if(!((Oa|0)<1|(Na|0)!=0))if(!(Oa&F)){Ta=1;Ua=Ia;Sa=37}else Sa=36;else{Va=Ga;Wa=Na;Xa=Ia}else{Ta=0;Ua=Ia;Sa=37}if((Sa|0)==36){Sa=0;Ta=1;Ua=Pa+-1|0;Sa=37}d:do if((Sa|0)==37){Sa=0;e:do if(I){if(Ta|0){Va=Ga;Wa=Na;Xa=Ua;break d}if((b[k+(Ua+Ca)>>0]|0)>0){Va=Ga;Wa=Na;Xa=Ua;break d}else{Ya=J;Za=Pa;_a=1}}else{Ja=Pa-Ta|0;if(!ua){if(!Ta)switch(A|0){case 2:case 4:{Ya=J;Za=Ja;_a=0;break e;break}default:{}}if((Ua|0)>=1){if(wa)$a=f[va+(Ua+Da<<2)>>2]|0;else $a=b[k+(Ua+Ca)>>0]|0;La=f[a+276+(($a&127)<<2)>>2]|0;if(!La){Sa=81;break a}Ka=Aa+(Ua<<2)|0;Qa=ya+Ua|0;Ma=La;La=0;f:while(1){do if((Ua-(f[Ma+16>>2]|0)|0)>>>0<(f[Ma+24>>2]|0)>>>0){if((za-(f[Ma+20>>2]|0)|0)>>>0>=(f[Ma+28>>2]|0)>>>0){ab=La;break}if(!La){ab=Ma;break}bb=f[La+36>>2]|0;if(!wa){cb=k+(Y(bb,r)|0)|0;db=cb+(f[La+32>>2]|0)|0;cb=f[La+40>>2]|0;f[i>>2]=1;f[V>>2]=U;f[W>>2]=T;f[Z>>2]=X;f[_>>2]=-1;f[aa>>2]=$;f[ba>>2]=r;f[da>>2]=ca;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];eb=cb|0?0:4;cb=eb;do{cb=cb+7&7;fb=db+(f[i+(cb<<2)>>2]|0)|0;gb=(cb|0)==(eb|0)}while(!((b[fb>>0]|0)!=0|gb));g:do if(gb)hb=db;else{eb=db;ib=cb;while(1){jb=ib;while(1){kb=jb+1|0;lb=eb+(f[i+(kb<<2)>>2]|0)|0;if(!lb){Sa=72;break a}if((kb|0)<15&(b[lb>>0]|0)==0)jb=kb;else break}if((eb|0)==(Qa|0)){Sa=75;break f}if((eb|0)==(fb|0)&(lb|0)==(db|0)){hb=fb;break g}eb=lb;ib=jb+5&7}}while(0);if((hb|0)==(Qa|0)){mb=La;break f}else{ab=Ma;break}}db=va+((Y(bb,s)|0)<<2)|0;cb=db+(f[La+32>>2]<<2)|0;if(!cb){Sa=54;break a}db=f[La+40>>2]|0;ib=f[cb>>2]&1073741823;f[i>>2]=1;f[V>>2]=ma;f[W>>2]=la;f[Z>>2]=na;f[_>>2]=-1;f[aa>>2]=oa;f[ba>>2]=s;f[da>>2]=pa;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];eb=db|0?0:4;db=eb;do{db=db+7&7;nb=cb+(f[i+(db<<2)>>2]<<2)|0;ob=(db|0)==(eb|0)}while(!(ob|(f[nb>>2]&1073741823|0)==(ib|0)));h:do if(ob)pb=cb;else{eb=cb;bb=db;while(1){kb=bb;while(1){qb=kb+1|0;rb=eb+(f[i+(qb<<2)>>2]<<2)|0;if(!rb){Sa=60;break a}if((qb|0)<15?(f[rb>>2]&1073741823|0)!=(ib|0):0)kb=qb;else break}if((eb|0)==(Ka|0)){Sa=63;break f}if((eb|0)==(nb|0)&(rb|0)==(cb|0)){pb=nb;break h}eb=rb;bb=kb+5&7}}while(0);if((pb|0)==(Ka|0)){mb=La;break f}else ab=Ma}else ab=La;while(0);Ma=f[Ma+4>>2]|0;if(!Ma){mb=ab;break}else La=ab}if((Sa|0)==63){Sa=0;mb=La}else if((Sa|0)==75){Sa=0;mb=La}if(!mb){Sa=81;break a}if((f[mb+40>>2]|0)==(Ta|0)){Ma=f[mb+8>>2]|0;sb=(Ma|0)==0?J:Ma}else sb=mb;if(!(f[sb+12>>2]|0)){Va=Ga;Wa=Na;Xa=Ua;break d}else{Ya=sb;Za=Ja;_a=0}}else{Ya=J;Za=Ja;_a=0}}else{Ya=J;Za=Ja;_a=1}}while(0);h7(f[K>>2]|0,L);Ma=m7(f[M>>2]|0,f[N>>2]|0,f[O>>2]|0,f[a>>2]|0)|0;f[Ma>>2]=f[Ma>>2]|(Ta|0?32768:0);f[j>>2]=0;if(_a){f[j>>2]=P;Ka=ya+Pa+(0-Ta)|0;Qa=(f[Q>>2]|0)+Za|0;cb=(f[R>>2]|0)+l|0;ib=f[S>>2]|0;f[i>>2]=1;f[V>>2]=U;f[W>>2]=T;f[Z>>2]=X;f[_>>2]=-1;f[aa>>2]=$;f[ba>>2]=r;f[da>>2]=ca;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];t7(Ma,d);db=(ib|0)<1;if(db){bb=Ma+56|0;f[bb>>2]=Qa;f[bb+4>>2]=cb}bb=(f[Ma>>2]|0)>>>13&4^4;eb=bb;do{eb=eb+7&7;tb=Ka+(f[i+(eb<<2)>>2]|0)|0;ub=(eb|0)==(bb|0)}while(!((b[tb>>0]|0)!=0|ub));i:do if(ub){b[Ka>>0]=-126;if((ib|0)>0){bb=f[fa>>2]|0;if(bb>>>0<(f[ga>>2]|0)>>>0)vb=bb;else{x7(d);vb=f[fa>>2]|0}bb=vb;jb=bb;b[jb>>0]=Qa;b[jb+1>>0]=Qa>>8;b[jb+2>>0]=Qa>>16;b[jb+3>>0]=Qa>>24;jb=bb+4|0;b[jb>>0]=cb;b[jb+1>>0]=cb>>8;b[jb+2>>0]=cb>>16;b[jb+3>>0]=cb>>24;f[fa>>2]=(f[fa>>2]|0)+8;w7(d)|0;Sa=133}else Sa=132}else{if(db){jb=Ka;bb=eb;while(1){qb=bb;while(1){wb=qb+1|0;xb=jb+(f[i+(wb<<2)>>2]|0)|0;if(!xb){Sa=121;break a}if((wb|0)<15&(b[xb>>0]|0)==0)qb=wb;else break}yb=wb&7;if((yb+-1|0)>>>0>=bb>>>0){if((b[jb>>0]|0)==1){zb=2;Sa=114}}else{zb=-126;Sa=114}if((Sa|0)==114){Sa=0;b[jb>>0]=zb}Ab=f[fa>>2]|0;if(Ab>>>0<(f[ga>>2]|0)>>>0)Bb=Ab;else{x7(d);Bb=f[fa>>2]|0}b[Bb>>0]=yb;f[fa>>2]=(f[fa>>2]|0)+1;if((jb|0)==(tb|0)&(xb|0)==(Ka|0)){Sa=132;break i}jb=xb;bb=qb+5&7}}if((ib|0)==1){bb=Ka;jb=eb;Ja=Qa;La=cb;while(1){yb=jb;while(1){Cb=yb+1|0;Db=bb+(f[i+(Cb<<2)>>2]|0)|0;if(!Db){Sa=121;break a}if((Cb|0)<15&(b[Db>>0]|0)==0)yb=Cb;else break}qb=Cb&7;if((qb+-1|0)>>>0>=jb>>>0){if((b[bb>>0]|0)==1){Eb=2;Sa=104}}else{Eb=-126;Sa=104}if((Sa|0)==104){Sa=0;b[bb>>0]=Eb}Ab=f[fa>>2]|0;if(Ab>>>0<(f[ga>>2]|0)>>>0)Fb=Ab;else{x7(d);Fb=f[fa>>2]|0}Ab=Fb;Gb=Ab;b[Gb>>0]=Ja;b[Gb+1>>0]=Ja>>8;b[Gb+2>>0]=Ja>>16;b[Gb+3>>0]=Ja>>24;Gb=Ab+4|0;b[Gb>>0]=La;b[Gb+1>>0]=La>>8;b[Gb+2>>0]=La>>16;b[Gb+3>>0]=La>>24;f[fa>>2]=(f[fa>>2]|0)+8;if((bb|0)==(tb|0)&(Db|0)==(Ka|0)){Sa=132;break i}bb=Db;jb=yb+5&7;Ja=(f[47804+(qb<<3)>>2]|0)+Ja|0;La=(f[47804+(qb<<3)+4>>2]|0)+La|0}}La=Ka;Ja=eb^4;jb=eb;bb=Qa;qb=cb;while(1){Gb=jb;while(1){Hb=Gb+1|0;Ib=La+(f[i+(Hb<<2)>>2]|0)|0;if(!Ib){Sa=121;break a}if((Hb|0)<15&(b[Ib>>0]|0)==0)Gb=Hb;else break}yb=Hb&7;if((yb+-1|0)>>>0>=jb>>>0){if((b[La>>0]|0)==1){Jb=2;Sa=125}}else{Jb=-126;Sa=125}if((Sa|0)==125){Sa=0;b[La>>0]=Jb}if((yb|0)==(Ja|0))Kb=Ja;else{Ab=f[fa>>2]|0;if(Ab>>>0<(f[ga>>2]|0)>>>0)Lb=Ab;else{x7(d);Lb=f[fa>>2]|0}Ab=Lb;Mb=Ab;b[Mb>>0]=bb;b[Mb+1>>0]=bb>>8;b[Mb+2>>0]=bb>>16;b[Mb+3>>0]=bb>>24;Mb=Ab+4|0;b[Mb>>0]=qb;b[Mb+1>>0]=qb>>8;b[Mb+2>>0]=qb>>16;b[Mb+3>>0]=qb>>24;f[fa>>2]=(f[fa>>2]|0)+8;Kb=yb}if((La|0)==(tb|0)&(Ib|0)==(Ka|0)){Sa=132;break i}La=Ib;Ja=Kb;jb=Gb+5&7;bb=(f[47804+(yb<<3)>>2]|0)+bb|0;qb=(f[47804+(yb<<3)+4>>2]|0)+qb|0}}while(0);if((Sa|0)==132?(Sa=0,w7(d)|0,ib|0):0)Sa=133;if((Sa|0)==133){Sa=0;Txa(e,Ma,1)}Nb=Ga;Ob=f[j>>2]|0}else{H7(f[ka>>2]|0,0,j)|0;Ka=f[j>>2]|0;if(!Ka){Sa=136;break a}cb=0-Ta|0;if(Ba){Qa=f[Aa+(Za<<2)>>2]&127;eb=Aa+(Pa<<2)+(cb<<2)|0;db=(f[Q>>2]|0)+Za|0;qb=(f[R>>2]|0)+l|0;bb=f[S>>2]|0;if(!eb){Sa=139;break a}f[e>>2]=0;f[g>>2]=0;jb=f[eb>>2]|0;Ja=jb&1073741823;La=Ja|1073741824;yb=jb|-1073741824;f[i>>2]=1;f[V>>2]=ma;f[W>>2]=la;f[Z>>2]=na;f[_>>2]=-1;f[aa>>2]=oa;f[ba>>2]=s;f[da>>2]=pa;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];t7(Ma,d);jb=(bb|0)<1;if(jb){Mb=Ma+56|0;f[Mb>>2]=db;f[Mb+4>>2]=qb}f[g>>2]=db;f[e>>2]=db;Mb=(f[Ma>>2]|0)>>>13&4^4;Ab=Mb;do{Ab=Ab+7&7;Pb=eb+(f[i+(Ab<<2)>>2]<<2)|0;Qb=(Ab|0)==(Mb|0)}while(!(Qb|(f[Pb>>2]&1073741823|0)==(Ja|0)));j:do if(Qb){f[eb>>2]=yb;if((bb|0)<=0){Rb=qb;Sb=qb;break}Mb=f[qa>>2]|0;if(Mb>>>0<(f[ra>>2]|0)>>>0)Tb=Mb;else{x7(d);Tb=f[qa>>2]|0}Mb=Tb;ib=Mb;b[ib>>0]=db;b[ib+1>>0]=db>>8;b[ib+2>>0]=db>>16;b[ib+3>>0]=db>>24;ib=Mb+4|0;b[ib>>0]=qb;b[ib+1>>0]=qb>>8;b[ib+2>>0]=qb>>16;b[ib+3>>0]=qb>>24;f[qa>>2]=(f[qa>>2]|0)+8;Rb=qb;Sb=qb}else{ib=Ab^4;if(jb){Mb=eb;Ub=ib;Vb=Ab;Wb=db;Xb=qb;Yb=qb;Zb=qb;while(1){_b=Vb;while(1){$b=_b+1|0;ac=Mb+(f[i+($b<<2)>>2]<<2)|0;if(!ac){Sa=184;break a}if(($b|0)<15?(f[ac>>2]&1073741823|0)!=(Ja|0):0)_b=$b;else break}Gb=$b&7;if((Gb+-1|0)>>>0>=Vb>>>0){if((f[Mb>>2]|0)==(Ja|0)){bc=La;Sa=172}}else{bc=yb;Sa=172}if((Sa|0)==172){Sa=0;f[Mb>>2]=bc}cc=f[qa>>2]|0;if(cc>>>0<(f[ra>>2]|0)>>>0)dc=cc;else{x7(d);dc=f[qa>>2]|0}b[dc>>0]=Gb;f[qa>>2]=(f[qa>>2]|0)+1;if((Gb|0)==(Ub|0)){ec=Xb;fc=Yb}else{if((Wb|0)>=(f[e>>2]|0)){if((Wb|0)>(f[g>>2]|0)){gc=g;Sa=178}}else{gc=e;Sa=178}if((Sa|0)==178){Sa=0;f[gc>>2]=Wb}cc=(Zb|0)<(Xb|0);ec=cc?Zb:Xb;fc=cc?Yb:(Zb|0)>(Yb|0)?Zb:Yb}if((Mb|0)==(Pb|0)&(ac|0)==(eb|0)){Rb=ec;Sb=fc;break j}Mb=ac;Ub=Gb;Vb=_b+5&7;Wb=(f[47804+(Gb<<3)>>2]|0)+Wb|0;Xb=ec;Yb=fc;Zb=(f[47804+(Gb<<3)+4>>2]|0)+Zb|0}}if((bb|0)==1){Zb=eb;Yb=ib;Xb=Ab;Wb=db;Vb=qb;Ub=qb;Mb=qb;while(1){Gb=Xb;while(1){hc=Gb+1|0;ic=Zb+(f[i+(hc<<2)>>2]<<2)|0;if(!ic){Sa=184;break a}if((hc|0)<15?(f[ic>>2]&1073741823|0)!=(Ja|0):0)Gb=hc;else break}_b=hc&7;if((_b+-1|0)>>>0>=Xb>>>0){if((f[Zb>>2]|0)==(Ja|0)){jc=La;Sa=157}}else{jc=yb;Sa=157}if((Sa|0)==157){Sa=0;f[Zb>>2]=jc}cc=f[qa>>2]|0;if(cc>>>0<(f[ra>>2]|0)>>>0)kc=cc;else{x7(d);kc=f[qa>>2]|0}cc=kc;lc=cc;b[lc>>0]=Wb;b[lc+1>>0]=Wb>>8;b[lc+2>>0]=Wb>>16;b[lc+3>>0]=Wb>>24;lc=cc+4|0;b[lc>>0]=Mb;b[lc+1>>0]=Mb>>8;b[lc+2>>0]=Mb>>16;b[lc+3>>0]=Mb>>24;f[qa>>2]=(f[qa>>2]|0)+8;if((_b|0)==(Yb|0)){mc=Vb;nc=Ub}else{if((Wb|0)>=(f[e>>2]|0)){if((Wb|0)>(f[g>>2]|0)){oc=g;Sa=163}}else{oc=e;Sa=163}if((Sa|0)==163){Sa=0;f[oc>>2]=Wb}lc=(Mb|0)<(Vb|0);mc=lc?Mb:Vb;nc=lc?Ub:(Mb|0)>(Ub|0)?Mb:Ub}if((Zb|0)==(Pb|0)&(ic|0)==(eb|0)){Rb=mc;Sb=nc;break j}Zb=ic;Yb=_b;Xb=Gb+5&7;Wb=(f[47804+(_b<<3)>>2]|0)+Wb|0;Vb=mc;Ub=nc;Mb=(f[47804+(_b<<3)+4>>2]|0)+Mb|0}}else{pc=eb;qc=ib;rc=Ab;sc=db;tc=qb;uc=qb;vc=qb}while(1){Mb=rc;while(1){wc=Mb+1|0;xc=pc+(f[i+(wc<<2)>>2]<<2)|0;if(!xc){Sa=184;break a}if((wc|0)<15?(f[xc>>2]&1073741823|0)!=(Ja|0):0)Mb=wc;else break}Gb=wc&7;if((Gb+-1|0)>>>0>=rc>>>0){if((f[pc>>2]|0)==(Ja|0)){yc=La;Sa=188}}else{yc=yb;Sa=188}if((Sa|0)==188){Sa=0;f[pc>>2]=yc}Ub=(Gb|0)==(qc|0);do if(Ub){zc=tc;Ac=uc}else{Vb=f[qa>>2]|0;if(Vb>>>0<(f[ra>>2]|0)>>>0)Bc=Vb;else{x7(d);Bc=f[qa>>2]|0}Vb=Bc;Wb=Vb;b[Wb>>0]=sc;b[Wb+1>>0]=sc>>8;b[Wb+2>>0]=sc>>16;b[Wb+3>>0]=sc>>24;Wb=Vb+4|0;b[Wb>>0]=vc;b[Wb+1>>0]=vc>>8;b[Wb+2>>0]=vc>>16;b[Wb+3>>0]=vc>>24;f[qa>>2]=(f[qa>>2]|0)+8;if(Ub){zc=tc;Ac=uc;break}if((sc|0)>=(f[e>>2]|0)){if((sc|0)>(f[g>>2]|0)){Cc=g;Sa=195}}else{Cc=e;Sa=195}if((Sa|0)==195){Sa=0;f[Cc>>2]=sc}Wb=(vc|0)<(tc|0);zc=Wb?vc:tc;Ac=Wb?uc:(vc|0)>(uc|0)?vc:uc}while(0);if((pc|0)==(Pb|0)&(xc|0)==(eb|0)){Rb=zc;Sb=Ac;break j}pc=xc;qc=Gb;rc=Mb+5&7;sc=(f[47804+(Gb<<3)>>2]|0)+sc|0;tc=zc;uc=Ac;vc=(f[47804+(Gb<<3)+4>>2]|0)+vc|0}}while(0);eb=f[e>>2]|0;yb=1-eb+(f[g>>2]|0)|0;f[g>>2]=yb;La=1-Rb+Sb|0;w7(d)|0;if(bb|0){f[Ma+56>>2]=eb;f[Ma+60>>2]=Rb;f[Ma+64>>2]=yb;f[Ma+68>>2]=La}f[Ka+16>>2]=eb;f[Ka+20>>2]=Rb;f[Ka+24>>2]=yb;f[Ka+28>>2]=La;Dc=Qa;Ec=Ga}else{La=Ga+1&127;yb=((La|0)==0?3:0)+La|0;La=ya+Pa+cb|0;eb=(f[Q>>2]|0)+Za|0;Ja=(f[R>>2]|0)+l|0;qb=f[S>>2]|0;f[e>>2]=0;f[g>>2]=0;f[i>>2]=1;f[V>>2]=U;f[W>>2]=T;f[Z>>2]=X;f[_>>2]=-1;f[aa>>2]=$;f[ba>>2]=r;f[da>>2]=ca;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];t7(Ma,d);db=(qb|0)<1;if(db){Ab=Ma+56|0;f[Ab>>2]=eb;f[Ab+4>>2]=Ja}f[g>>2]=eb;f[e>>2]=eb;Ab=(f[Ma>>2]|0)>>>13&4^4;jb=Ab;do{jb=jb+7&7;Fc=La+(f[i+(jb<<2)>>2]|0)|0;Gc=(jb|0)==(Ab|0)}while(!((b[Fc>>0]|0)!=0|Gc));k:do if(Gc){b[La>>0]=Ga|128;if((qb|0)<=0){Hc=Ja;Ic=Ja;break}Ab=f[sa>>2]|0;if(Ab>>>0<(f[ta>>2]|0)>>>0)Jc=Ab;else{x7(d);Jc=f[sa>>2]|0}Ab=Jc;cb=Ab;b[cb>>0]=eb;b[cb+1>>0]=eb>>8;b[cb+2>>0]=eb>>16;b[cb+3>>0]=eb>>24;cb=Ab+4|0;b[cb>>0]=Ja;b[cb+1>>0]=Ja>>8;b[cb+2>>0]=Ja>>16;b[cb+3>>0]=Ja>>24;f[sa>>2]=(f[sa>>2]|0)+8;Hc=Ja;Ic=Ja}else{cb=jb^4;Ab=Ga|128;if(db){Qa=La;bb=cb;ib=jb;Ub=eb;Wb=Ja;Vb=Ja;Xb=Ja;while(1){Yb=ib;while(1){Kc=Yb+1|0;Lc=Qa+(f[i+(Kc<<2)>>2]|0)|0;if(!Lc){Sa=246;break a}if((Kc|0)<15&(b[Lc>>0]|0)==0)Yb=Kc;else break}Gb=Kc&7;if((Gb+-1|0)>>>0>=ib>>>0){if((b[Qa>>0]|0)==1){Mc=Ga;Sa=234}}else{Mc=Ab;Sa=234}if((Sa|0)==234){Sa=0;b[Qa>>0]=Mc}Mb=f[sa>>2]|0;if(Mb>>>0<(f[ta>>2]|0)>>>0)Nc=Mb;else{x7(d);Nc=f[sa>>2]|0}b[Nc>>0]=Gb;f[sa>>2]=(f[sa>>2]|0)+1;if((Gb|0)==(bb|0)){Oc=Wb;Pc=Vb}else{if((Ub|0)>=(f[e>>2]|0)){if((Ub|0)>(f[g>>2]|0)){Qc=g;Sa=240}}else{Qc=e;Sa=240}if((Sa|0)==240){Sa=0;f[Qc>>2]=Ub}Mb=(Xb|0)<(Wb|0);Oc=Mb?Xb:Wb;Pc=Mb?Vb:(Xb|0)>(Vb|0)?Xb:Vb}if((Qa|0)==(Fc|0)&(Lc|0)==(La|0)){Hc=Oc;Ic=Pc;break k}Qa=Lc;bb=Gb;ib=Yb+5&7;Ub=(f[47804+(Gb<<3)>>2]|0)+Ub|0;Wb=Oc;Vb=Pc;Xb=(f[47804+(Gb<<3)+4>>2]|0)+Xb|0}}if((qb|0)==1){Xb=La;Vb=cb;Wb=jb;Ub=eb;ib=Ja;bb=Ja;Qa=Ja;while(1){Gb=Wb;while(1){Rc=Gb+1|0;Sc=Xb+(f[i+(Rc<<2)>>2]|0)|0;if(!Sc){Sa=246;break a}if((Rc|0)<15&(b[Sc>>0]|0)==0)Gb=Rc;else break}Yb=Rc&7;if((Yb+-1|0)>>>0>=Wb>>>0){if((b[Xb>>0]|0)==1){Tc=Ga;Sa=219}}else{Tc=Ab;Sa=219}if((Sa|0)==219){Sa=0;b[Xb>>0]=Tc}Mb=f[sa>>2]|0;if(Mb>>>0<(f[ta>>2]|0)>>>0)Uc=Mb;else{x7(d);Uc=f[sa>>2]|0}Mb=Uc;Zb=Mb;b[Zb>>0]=Ub;b[Zb+1>>0]=Ub>>8;b[Zb+2>>0]=Ub>>16;b[Zb+3>>0]=Ub>>24;Zb=Mb+4|0;b[Zb>>0]=Qa;b[Zb+1>>0]=Qa>>8;b[Zb+2>>0]=Qa>>16;b[Zb+3>>0]=Qa>>24;f[sa>>2]=(f[sa>>2]|0)+8;if((Yb|0)==(Vb|0)){Vc=ib;Wc=bb}else{if((Ub|0)>=(f[e>>2]|0)){if((Ub|0)>(f[g>>2]|0)){Xc=g;Sa=225}}else{Xc=e;Sa=225}if((Sa|0)==225){Sa=0;f[Xc>>2]=Ub}Zb=(Qa|0)<(ib|0);Vc=Zb?Qa:ib;Wc=Zb?bb:(Qa|0)>(bb|0)?Qa:bb}if((Xb|0)==(Fc|0)&(Sc|0)==(La|0)){Hc=Vc;Ic=Wc;break k}Xb=Sc;Vb=Yb;Wb=Gb+5&7;Ub=(f[47804+(Yb<<3)>>2]|0)+Ub|0;ib=Vc;bb=Wc;Qa=(f[47804+(Yb<<3)+4>>2]|0)+Qa|0}}else{Yc=La;Zc=cb;_c=jb;$c=eb;ad=Ja;bd=Ja;cd=Ja}while(1){Qa=_c;while(1){dd=Qa+1|0;ed=Yc+(f[i+(dd<<2)>>2]|0)|0;if(!ed){Sa=246;break a}if((dd|0)<15&(b[ed>>0]|0)==0)Qa=dd;else break}Gb=dd&7;if((Gb+-1|0)>>>0>=_c>>>0){if((b[Yc>>0]|0)==1){fd=Ga;Sa=250}}else{fd=Ab;Sa=250}if((Sa|0)==250){Sa=0;b[Yc>>0]=fd}bb=(Gb|0)==(Zc|0);do if(bb){gd=ad;hd=bd}else{ib=f[sa>>2]|0;if(ib>>>0<(f[ta>>2]|0)>>>0)id=ib;else{x7(d);id=f[sa>>2]|0}ib=id;Ub=ib;b[Ub>>0]=$c;b[Ub+1>>0]=$c>>8;b[Ub+2>>0]=$c>>16;b[Ub+3>>0]=$c>>24;Ub=ib+4|0;b[Ub>>0]=cd;b[Ub+1>>0]=cd>>8;b[Ub+2>>0]=cd>>16;b[Ub+3>>0]=cd>>24;f[sa>>2]=(f[sa>>2]|0)+8;if(bb){gd=ad;hd=bd;break}if(($c|0)>=(f[e>>2]|0)){if(($c|0)>(f[g>>2]|0)){jd=g;Sa=257}}else{jd=e;Sa=257}if((Sa|0)==257){Sa=0;f[jd>>2]=$c}Ub=(cd|0)<(ad|0);gd=Ub?cd:ad;hd=Ub?bd:(cd|0)>(bd|0)?cd:bd}while(0);if((Yc|0)==(Fc|0)&(ed|0)==(La|0)){Hc=gd;Ic=hd;break k}Yc=ed;Zc=Gb;_c=Qa+5&7;$c=(f[47804+(Gb<<3)>>2]|0)+$c|0;ad=gd;bd=hd;cd=(f[47804+(Gb<<3)+4>>2]|0)+cd|0}}while(0);La=f[e>>2]|0;Ja=1-La+(f[g>>2]|0)|0;f[g>>2]=Ja;eb=1-Hc+Ic|0;w7(d)|0;if(qb|0){f[Ma+56>>2]=La;f[Ma+60>>2]=Hc;f[Ma+64>>2]=Ja;f[Ma+68>>2]=eb}f[Ka+16>>2]=La;f[Ka+20>>2]=Hc;f[Ka+24>>2]=Ja;f[Ka+28>>2]=eb;Dc=Ga;Ec=yb}eb=f[j>>2]|0;Ja=eb+16|0;f[Ja>>2]=(f[Ja>>2]|0)-(f[Q>>2]|0);Ja=eb+20|0;f[Ja>>2]=(f[Ja>>2]|0)-(f[R>>2]|0);Ja=a+276+(Dc<<2)|0;f[eb+4>>2]=f[Ja>>2];f[Ja>>2]=eb;Nb=Ec;Ob=eb}f[Ob+40>>2]=Ta;f[Ob+12>>2]=Ma;eb=Ob+32|0;f[eb>>2]=Za;f[eb+4>>2]=l;f[Ob+8>>2]=Ya;eb=f[ha>>2]|0;if((f[S>>2]|0)==(eb|0)){kd=Ya;ld=Ma;md=Ob}else{Ja=xfa(Ma,f[ja>>2]|0,f[K>>2]|0,eb)|0;f[(f[j>>2]|0)+12>>2]=Ja;g7(f[a>>2]|0);Ja=f[j>>2]|0;kd=f[Ja+8>>2]|0;ld=f[Ja+12>>2]|0;md=Ja}f[ld+16>>2]=f[kd+12>>2];nd=f[K>>2]|0;if(f[Ya+12>>2]|0){Sa=274;break a}f[md+12>>2]=0;Ja=f[a>>2]|0;if((Ja|0)==(nd|0))i7(nd,L);else g7(Ja);Va=Nb;Wa=b[ya+Pa>>0]|0;Xa=Za}while(0);Ha=Pa+1|0;if((Ha|0)>=(y|0)){Ra=Va;break}else{Ea=Wa;Fa=Wa;Ga=Va;Ia=Wa>>>0>1?Pa:Xa}}}else Ra=G;while(0);Aa=l+1|0;if((Aa|0)<(z|0)){xa=0;G=Ra;ya=ya+r|0;l=Aa;x=1;v=0;za=Aa}else{H=0;Sa=275;break}}switch(Sa|0){case 54:{f[d>>2]=0;f[d+4>>2]=0;m=tT(d,11)|0;n=254373;o=m+11|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,254385,254090,816);break}case 60:{f[d>>2]=0;f[d+4>>2]=0;m=tT(d,10)|0;n=254405;o=m+10|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,254385,254090,852);break}case 72:{f[d>>2]=0;f[d+4>>2]=0;m=tT(d,10)|0;n=254405;o=m+10|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,254416,254090,664);break}case 81:{f[d>>2]=0;f[d+4>>2]=0;m=tT(d,13)|0;n=254432;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,254332,254090,1176);break}case 121:{f[e>>2]=0;f[e+4>>2]=0;m=tT(e,10)|0;n=254405;o=m+10|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,254446,254090,568);break}case 136:{f[d>>2]=0;f[d+4>>2]=0;e=tT(d,7)|0;b[e>>0]=b[254462]|0;b[e+1>>0]=b[254463]|0;b[e+2>>0]=b[254464]|0;b[e+3>>0]=b[254465]|0;b[e+4>>0]=b[254466]|0;b[e+5>>0]=b[254467]|0;b[e+6>>0]=b[254468]|0;z5(-215,d,254332,254090,1218);break}case 139:{f[d>>2]=0;f[d+4>>2]=0;m=tT(d,11)|0;n=254373;o=m+11|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,d,254470,254090,876);break}case 184:{f[h>>2]=0;f[h+4>>2]=0;m=tT(h,10)|0;n=254405;o=m+10|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,254470,254090,936);break}case 246:{f[h>>2]=0;f[h+4>>2]=0;m=tT(h,10)|0;n=254405;o=m+10|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,h,254492,254090,745);break}case 274:{h7(nd,ia);ia=f[j>>2]|0;f[p>>2]=ia;f[t>>2]=Pa+1+(Ba?0-Ta|0:0);f[w>>2]=l;l=B;f[l>>2]=Za;f[l+4>>2]=za;f[q>>2]=ya;f[C>>2]=Nb;H=f[ia+12>>2]|0;u=c;return H|0}case 275:{u=c;return H|0}}return 0}function sfa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;z5(-27,c,254510,254090,1321)}d=f[a>>2]|0;if(!d){e=0;u=b;return e|0}g=d+88|0;h=f[g>>2]|0;if(h|0){i=d+248|0;if(f[i>>2]|0){j=d+4|0;h7(f[j>>2]|0,c);if((f[c>>2]|0)==(f[d+32>>2]|0)?(f[c+4>>2]|0)==(f[d+36>>2]|0):0)i7(f[j>>2]|0,d+24|0);f[i>>2]=0}i=f[h+12>>2]|0;if(i|0)R7(i,f[(f[h+8>>2]|0)+12>>2]|0,d+180|0);f[g>>2]=0}if((f[d>>2]|0)!=(f[d+4>>2]|0))f7(d);g=d+8|0;if(f[g>>2]|0)f7(g);g=f[d+200>>2]|0;i0(f[a>>2]|0);f[a>>2]=0;e=g;u=b;return e|0}function tfa(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;m=u;u=u+160|0;n=m+136|0;o=m+112|0;p=m+88|0;q=m+56|0;r=m+24|0;s=m+8|0;t=m;f[t>>2]=0;if(!d){f[n>>2]=0;f[n+4>>2]=0;v=tT(n,25)|0;w=254528;x=v+25|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-27,n,254554,254090,1809)}f[d>>2]=0;if((i|0)!=5){y=qfa(a,c,e,g,i,j,k,l)|0;f[t>>2]=y;l=-1;i=y;while(1){z=l+1|0;if(!(rfa(i)|0))break;l=z;i=f[t>>2]|0}i=sfa(t)|0;f[d>>2]=i;A=z;u=m;return A|0}if(k|j|0){f[n>>2]=0;f[n+4>>2]=0;v=tT(n,51)|0;w=254574;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-211,n,254554,254090,1817)}if(!c){f[r>>2]=0;f[r+4>>2]=0;v=tT(r,20)|0;w=254626;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-27,r,254647,254090,1501)}if((e|0)<88){f[r>>2]=0;f[r+4>>2]=0;v=tT(r,48)|0;w=254673;x=v+48|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-201,r,254647,254090,1507)}j=e7(c)|0;if(!j)B=0;else{k=VDc(16)|0;f[k+4>>2]=1;f[k>>2]=47876;f[k+8>>2]=j;B=k}k=e7(c)|0;if(!k)C=0;else{z=VDc(16)|0;f[z+4>>2]=1;f[z>>2]=47876;f[z+8>>2]=k;C=z}z=G0(a,r,0,0)|0;if(f[z>>2]&4094|0){f[s>>2]=0;f[s+4>>2]=0;v=tT(s,32)|0;w=254722;x=v+32|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-5,s,254647,254090,1518)}w=f[z+16>>2]|0;v=f[z+4>>2]|0;x=f[z+20>>2]|0;r=f[z+24>>2]|0;z=m7(0,56,16,j)|0;t7(z,p);u7(0,56,4,k,n);u7(0,56,4,k,o);k=p+12|0;j=f[k>>2]|0;a=p+20|0;if(j>>>0<(f[a>>2]|0)>>>0)D=j;else{x7(p);D=f[k>>2]|0}b[D>>0]=0;b[D+1>>0]=0;b[D+2>>0]=0;b[D+3>>0]=0;j=D+4|0;b[j>>0]=0;b[j+1>>0]=0;b[j+2>>0]=0;b[j+3>>0]=0;j=D+12|0;b[j>>0]=0;b[j+1>>0]=0;b[j+2>>0]=0;b[j+3>>0]=0;j=(f[k>>2]|0)+16|0;f[k>>2]=j;D=p+4|0;i=j+(0-(f[(f[D>>2]|0)+28>>2]|0))|0;j=(r|0)>0;a:do if(j){t=n+12|0;l=n+20|0;y=0;g=i;while(1){E=y;while(1){if(b[w+E>>0]|0){F=E;break}G=E+1|0;if((G|0)<(r|0))E=G;else{F=G;break}}if((F|0)==(r|0)){H=g;break a}E=f[k>>2]|0;if(E>>>0<(f[a>>2]|0)>>>0)I=E;else{x7(p);I=f[k>>2]|0}b[I>>0]=0;b[I+1>>0]=0;b[I+2>>0]=0;b[I+3>>0]=0;E=I+4|0;b[E>>0]=0;b[E+1>>0]=0;b[E+2>>0]=0;b[E+3>>0]=0;E=I+8|0;b[E>>0]=F;b[E+1>>0]=F>>8;b[E+2>>0]=F>>16;b[E+3>>0]=F>>24;E=I+12|0;b[E>>0]=0;b[E+1>>0]=0;b[E+2>>0]=0;b[E+3>>0]=0;E=(f[k>>2]|0)+16|0;f[k>>2]=E;G=E+(0-(f[(f[D>>2]|0)+28>>2]|0))|0;f[g+4>>2]=G;J=F+1|0;b:do if((r|0)>(J|0)){K=J;while(1){if(!(b[w+K>>0]|0)){L=K;break b}M=K+1|0;if((M|0)<(r|0))K=M;else{L=M;break}}}else L=J;while(0);J=L+-1|0;if(E>>>0<(f[a>>2]|0)>>>0)N=E;else{x7(p);N=f[k>>2]|0}b[N>>0]=0;b[N+1>>0]=0;b[N+2>>0]=0;b[N+3>>0]=0;K=N+4|0;b[K>>0]=0;b[K+1>>0]=0;b[K+2>>0]=0;b[K+3>>0]=0;K=N+8|0;b[K>>0]=J;b[K+1>>0]=J>>8;b[K+2>>0]=J>>16;b[K+3>>0]=J>>24;J=N+12|0;b[J>>0]=0;b[J+1>>0]=0;b[J+2>>0]=0;b[J+3>>0]=0;J=(f[k>>2]|0)+16|0;f[k>>2]=J;K=J+(0-(f[(f[D>>2]|0)+28>>2]|0))|0;J=G+4|0;f[J>>2]=K;f[G>>2]=K;K=f[t>>2]|0;if(K>>>0<(f[l>>2]|0)>>>0)O=K;else{x7(n);O=f[t>>2]|0}b[O>>0]=G;b[O+1>>0]=G>>8;b[O+2>>0]=G>>16;b[O+3>>0]=G>>24;f[t>>2]=(f[t>>2]|0)+4;K=f[J>>2]|0;if((L|0)<(r|0)){y=L;g=K}else{H=K;break}}}else H=i;while(0);v7(p);L=f[i+4>>2]|0;i=z+24|0;z=f[i>>2]|0;O=z+-1|0;f[H+4>>2]=0;c:do if((x|0)>1){N=n+12|0;F=n+20|0;I=o+12|0;g=o+20|0;y=1;t=0;l=L;K=w;J=O;M=H;P=z;while(1){Q=K+v|0;d:do if(j){R=0;S=M;while(1){T=R;while(1){if(b[Q+T>>0]|0){U=T;break}V=T+1|0;if((V|0)<(r|0))T=V;else{U=V;break}}if((U|0)==(r|0)){W=S;break d}T=f[k>>2]|0;if(T>>>0<(f[a>>2]|0)>>>0)X=T;else{x7(p);X=f[k>>2]|0}b[X>>0]=0;b[X+1>>0]=0;b[X+2>>0]=0;b[X+3>>0]=0;T=X+4|0;b[T>>0]=0;b[T+1>>0]=0;b[T+2>>0]=0;b[T+3>>0]=0;T=X+8|0;b[T>>0]=U;b[T+1>>0]=U>>8;b[T+2>>0]=U>>16;b[T+3>>0]=U>>24;T=X+12|0;b[T>>0]=y;b[T+1>>0]=y>>8;b[T+2>>0]=y>>16;b[T+3>>0]=y>>24;T=(f[k>>2]|0)+16|0;f[k>>2]=T;V=T+(0-(f[(f[D>>2]|0)+28>>2]|0))|0;f[S+4>>2]=V;Y=U+1|0;e:do if((r|0)>(Y|0)){Z=Y;while(1){if(!(b[Q+Z>>0]|0)){_=Z;break e}$=Z+1|0;if(($|0)<(r|0))Z=$;else{_=$;break}}}else _=Y;while(0);Y=_+-1|0;if(T>>>0<(f[a>>2]|0)>>>0)aa=T;else{x7(p);aa=f[k>>2]|0}b[aa>>0]=0;b[aa+1>>0]=0;b[aa+2>>0]=0;b[aa+3>>0]=0;Z=aa+4|0;b[Z>>0]=0;b[Z+1>>0]=0;b[Z+2>>0]=0;b[Z+3>>0]=0;Z=aa+8|0;b[Z>>0]=Y;b[Z+1>>0]=Y>>8;b[Z+2>>0]=Y>>16;b[Z+3>>0]=Y>>24;Y=aa+12|0;b[Y>>0]=y;b[Y+1>>0]=y>>8;b[Y+2>>0]=y>>16;b[Y+3>>0]=y>>24;Y=(f[k>>2]|0)+16|0;f[k>>2]=Y;Z=Y+(0-(f[(f[D>>2]|0)+28>>2]|0))|0;f[V+4>>2]=Z;if((_|0)<(r|0)){R=_;S=Z}else{W=Z;break}}}else W=M;while(0);v7(p);G=f[M+4>>2]|0;E=(f[i>>2]|0)-P|0;f[W+4>>2]=0;S=(J|0)/2|0;R=(E|0)/2|0;f:do if((J|0)>1&(E|0)>1){Z=0;Y=0;$=G;ba=l;ca=0;da=t;while(1){g:do switch(ca|0){case 0:{ea=f[ba+4>>2]|0;fa=f[ea+8>>2]|0;ga=$+4|0;ha=f[ga>>2]|0;ia=f[ha+8>>2]|0;if((fa|0)<(ia|0)){ja=(fa|0)<((f[$+8>>2]|0)+-1|0);f[(ja?ea:$)>>2]=ba;ka=Z+1|0;la=Y;ma=$;na=f[ea+4>>2]|0;oa=(ja^1)&1;pa=ja?da:ea;break g}if((f[ba+8>>2]|0)>(ia+1|0)){f[$>>2]=ha;ia=f[N>>2]|0;if(ia>>>0<(f[F>>2]|0)>>>0)qa=ia;else{x7(n);qa=f[N>>2]|0}b[qa>>0]=$;b[qa+1>>0]=$>>8;b[qa+2>>0]=$>>16;b[qa+3>>0]=$>>24;f[N>>2]=(f[N>>2]|0)+4;ra=0;sa=da;ta=f[ga>>2]|0}else{f[$>>2]=ba;ra=-1;sa=ha;ta=ha}ka=Z;la=Y+1|0;ma=f[ta+4>>2]|0;na=ba;oa=ra;pa=sa;break}case 1:{ha=f[$+4>>2]|0;ga=f[ha+8>>2]|0;if((f[ba+8>>2]|0)>(ga+1|0)){f[da>>2]=ha;ka=Z;la=Y+1|0;ma=f[ha+4>>2]|0;na=ba;oa=0;pa=da;break g}f[da>>2]=ba;ia=f[ba+4>>2]|0;if((f[ia+8>>2]|0)<(ga|0)){ka=Z+1|0;la=Y;ma=$;na=f[ia+4>>2]|0;oa=1;pa=ia;break g}else{ka=Z;la=Y+1|0;ma=f[ha+4>>2]|0;na=ba;oa=-1;pa=ha;break g}break}case -1:{ha=ba+4|0;ia=f[ha>>2]|0;if((f[$+8>>2]|0)>((f[ia+8>>2]|0)+1|0)){f[ia>>2]=da;ka=Z+1|0;la=Y;ma=$;na=f[ia+4>>2]|0;oa=0;pa=da;break g}ia=f[I>>2]|0;if(ia>>>0<(f[g>>2]|0)>>>0)ua=ia;else{x7(o);ua=f[I>>2]|0}b[ua>>0]=$;b[ua+1>>0]=$>>8;b[ua+2>>0]=$>>16;b[ua+3>>0]=$>>24;f[I>>2]=(f[I>>2]|0)+4;f[$>>2]=da;ia=f[$+4>>2]|0;ga=f[ha>>2]|0;if((f[ia+8>>2]|0)<(f[ga+8>>2]|0)){ka=Z;la=Y+1|0;ma=f[ia+4>>2]|0;na=ba;oa=-1;pa=ia;break g}else{ka=Z+1|0;la=Y;ma=$;na=f[ga+4>>2]|0;oa=1;pa=ga;break g}break}default:{ka=Z;la=Y;ma=$;na=ba;oa=ca;pa=da}}while(0);if((la|0)<(R|0)&(ka|0)<(S|0)){Z=ka;Y=la;$=ma;ba=na;ca=oa;da=pa}else{va=ka;wa=la;xa=ma;ya=na;za=oa;Aa=pa;break f}}}else{va=0;wa=0;xa=G;ya=l;za=0;Aa=t}while(0);if((wa|0)<(R|0)){da=wa;ca=xa;ba=za;while(1){$=ca+4|0;Y=f[$>>2]|0;if(!ba){f[ca>>2]=Y;Z=f[N>>2]|0;if(Z>>>0<(f[F>>2]|0)>>>0)Ba=Z;else{x7(n);Ba=f[N>>2]|0}b[Ba>>0]=ca;b[Ba+1>>0]=ca>>8;b[Ba+2>>0]=ca>>16;b[Ba+3>>0]=ca>>24;f[N>>2]=(f[N>>2]|0)+4;Ca=f[$>>2]|0}else{f[Aa>>2]=Y;Ca=Y}da=da+1|0;if((da|0)>=(R|0)){Da=0;break}else{ca=f[Ca+4>>2]|0;ba=0}}}else Da=za;if((va|0)<(S|0)){ba=va;ca=ya;R=Da;while(1){da=f[ca+4>>2]|0;Y=ca;ca=f[da+4>>2]|0;f[da>>2]=(R|0)==0?Y:Aa;ba=ba+1|0;if((ba|0)==(S|0))break;else R=0}}R=y+1|0;if((R|0)>=(x|0)){Ea=G;Fa=E;break c}y=R;t=Aa;l=G;K=Q;J=E;M=W;P=f[i>>2]|0}}else{Ea=L;Fa=O}while(0);O=(Fa|0)/2|0;if((Fa|0)>1){Fa=0;L=Ea;while(1){Ea=f[L+4>>2]|0;f[Ea>>2]=L;Fa=Fa+1|0;if((Fa|0)>=(O|0))break;else L=f[Ea+4>>2]|0}}L=w7(n)|0;n=w7(o)|0;o=q+12|0;O=q+20|0;Fa=0;Ea=0;i=0;W=0;while(1){Aa=(W|0)==0;x=Aa?L:n;r7(x,q,0);Da=x+24|0;if((f[Da>>2]|0)>0)if(Aa){Aa=Ea;x=i;ya=Fa;va=0;while(1){za=f[o>>2]|0;Ca=h[za>>0]|h[za+1>>0]<<8|h[za+2>>0]<<16|h[za+3>>0]<<24;Ba=za+4|0;f[o>>2]=Ba;if(Ba>>>0>=(f[O>>2]|0)>>>0)z7(q,1);do if(!(f[Ca>>2]|0)){Ga=Aa;Ha=x}else{u7(20492,e,8,c,p);Ba=Ca;za=f[k>>2]|0;do{if(za>>>0<(f[a>>2]|0)>>>0)Ia=za;else{x7(p);Ia=f[k>>2]|0}xa=Ba+8|0;wa=xa;pa=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;wa=xa+4|0;xa=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;wa=Ia;oa=wa;b[oa>>0]=pa;b[oa+1>>0]=pa>>8;b[oa+2>>0]=pa>>16;b[oa+3>>0]=pa>>24;pa=wa+4|0;b[pa>>0]=xa;b[pa+1>>0]=xa>>8;b[pa+2>>0]=xa>>16;b[pa+3>>0]=xa>>24;za=(f[k>>2]|0)+8|0;f[k>>2]=za;xa=Ba;Ba=f[Ba>>2]|0;f[xa>>2]=0}while((Ba|0)!=(Ca|0));Ba=w7(p)|0;Txa(s,Ba,1);if(!Aa){Ga=Ba;Ha=Ba;break}f[Ba+8>>2]=x;f[x+12>>2]=Ba;Ga=Aa;Ha=Ba}while(0);va=va+1|0;Ca=ya+1|0;if((va|0)>=(f[Da>>2]|0)){Ja=Ca;Ka=Ga;La=Ha;break}else{Aa=Ga;x=Ha;ya=Ca}}}else{ya=Ea;x=i;Aa=Fa;va=0;while(1){Ca=f[o>>2]|0;E=h[Ca>>0]|h[Ca+1>>0]<<8|h[Ca+2>>0]<<16|h[Ca+3>>0]<<24;Q=Ca+4|0;f[o>>2]=Q;if(Q>>>0>=(f[O>>2]|0)>>>0)z7(q,1);do if(!(f[E>>2]|0)){Ma=ya;Na=x}else{u7(20492,e,8,c,p);Q=E;Ca=f[k>>2]|0;do{if(Ca>>>0<(f[a>>2]|0)>>>0)Oa=Ca;else{x7(p);Oa=f[k>>2]|0}G=Q+8|0;Ba=G;za=h[Ba>>0]|h[Ba+1>>0]<<8|h[Ba+2>>0]<<16|h[Ba+3>>0]<<24;Ba=G+4|0;G=h[Ba>>0]|h[Ba+1>>0]<<8|h[Ba+2>>0]<<16|h[Ba+3>>0]<<24;Ba=Oa;xa=Ba;b[xa>>0]=za;b[xa+1>>0]=za>>8;b[xa+2>>0]=za>>16;b[xa+3>>0]=za>>24;za=Ba+4|0;b[za>>0]=G;b[za+1>>0]=G>>8;b[za+2>>0]=G>>16;b[za+3>>0]=G>>24;Ca=(f[k>>2]|0)+8|0;f[k>>2]=Ca;G=Q;Q=f[Q>>2]|0;f[G>>2]=0}while((Q|0)!=(E|0));Q=w7(p)|0;Txa(s,Q,1);f[Q>>2]=f[Q>>2]|32768;if(!ya){Ma=Q;Na=Q;break}f[Q+8>>2]=x;f[x+12>>2]=Q;Ma=ya;Na=Q}while(0);va=va+1|0;E=Aa+1|0;if((va|0)>=(f[Da>>2]|0)){Ja=E;Ka=Ma;La=Na;break}else{ya=Ma;x=Na;Aa=E}}}else{Ja=Fa;Ka=Ea;La=i}W=W+1|0;if((W|0)>=2)break;else{Fa=Ja;Ea=Ka;i=La}}La=(Ka|0)==0?-1:Ja;f[d>>2]=Ka;Ka=C;if(C|0?(d=Ka+4|0,Ja=f[d>>2]|0,f[d>>2]=Ja+-1,(Ja|0)==1):0)Yi[f[(f[C>>2]|0)+8>>2]&2047](Ka);Ka=B;if(!B){A=La;u=m;return A|0}C=Ka+4|0;Ja=f[C>>2]|0;f[C>>2]=Ja+-1;if((Ja|0)!=1){A=La;u=m;return A|0}Yi[f[(f[B>>2]|0)+8>>2]&2047](Ka);A=La;u=m;return A|0}function ufa(a){a=a|0;YDc(a);return}function vfa(a){a=a|0;a1(a+12|0,f[a+8>>2]|0);if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function wfa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;i=u;u=u+384|0;j=i+336|0;k=i+280|0;l=i+224|0;m=i+184|0;n=i;o=i+88|0;p=i+32|0;q=i+216|0;r=i+128|0;if(((d$(c)|0)!=262144?(d$(c)|0)!=327680:0)?(d$(c)|0)!=720896:0){f[j>>2]=0;f[j+4>>2]=0;dJc(tT(j,155)|0,254823,155)|0;z5(-215,j,254979,254090,1884)}if(!(r$(c)|0)){if((q$(c,-1)|0)!=2){f[j>>2]=0;s=j+4|0;f[s>>2]=0;t=tT(j,79)|0;v=t;w=254992;x=v+79|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,j,254979,254090,1886)}if((p$(c,-1)|0)!=4){f[j>>2]=0;s=j+4|0;f[s>>2]=0;t=tT(j,79)|0;v=t;w=254992;x=v+79|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,j,254979,254090,1886)}}do if((d$(a)|0)==65536){t=f[a+4>>2]|0;f[k>>2]=f[t>>2];s=k+4|0;y=t+4|0;f[s>>2]=f[y>>2];z=k+8|0;f[z>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[k+16>>2]=f[t+16>>2];f[k+20>>2]=f[t+20>>2];f[k+24>>2]=f[t+24>>2];f[k+28>>2]=f[t+28>>2];f[k+32>>2]=f[t+32>>2];A=f[t+36>>2]|0;f[k+36>>2]=A;f[k+40>>2]=z;z=k+48|0;B=k+44|0;f[B>>2]=z;f[z>>2]=0;f[k+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[t+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[s>>2]=0;ZS(k,t);break}}else a$(k,a,-1);while(0);f[l>>2]=1124007936;a=l+4|0;t=l+8|0;s=l+40|0;v=a;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[s>>2]=t;y=l+48|0;z=l+44|0;f[z>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if((g|0)==5){B=k+36|0;A=f[B>>2]|0;if(A){C=A+12|0;f[C>>2]=(f[C>>2]|0)+1;C=l+36|0;A=f[C>>2]|0;if((A|0)!=0?(D=A+12|0,A=f[D>>2]|0,f[D>>2]=A+-1,(A|0)==1):0){_S(l);E=C}else E=C}else E=l+36|0;f[E>>2]=0;C=l+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[a>>2]|0)>0){A=f[s>>2]|0;D=0;do{f[A+(D<<2)>>2]=0;D=D+1|0;F=f[a>>2]|0}while((D|0)<(F|0));f[l>>2]=f[k>>2];if((F|0)<3)G=28;else G=30}else{f[l>>2]=f[k>>2];G=28}if((G|0)==28){F=f[k+4>>2]|0;if((F|0)<3){f[a>>2]=F;f[t>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];F=f[k+44>>2]|0;D=f[z>>2]|0;f[D>>2]=f[F>>2];f[D+4>>2]=f[F+4>>2]}else G=30}if((G|0)==30)ZS(l,k);f[C>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];f[E>>2]=f[B>>2];H=0}else{f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=k;B=m+8|0;f[B>>2]=0;f[B+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=l;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[n+28>>2]=0;q_(j,m,1,1,1,1,16,n);H=-1}B=c7(0)|0;if(!B)I=0;else{E=VDc(16)|0;f[E+4>>2]=1;f[E>>2]=47876;f[E+8>>2]=B;I=E}E=f[t>>2]|0;t=(f[a>>2]|0)==1?1:f[l+12>>2]|0;C=f[l>>2]|0;G=l+16|0;F=f[G>>2]|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=F;f[m+20>>2]=E;f[m+24>>2]=t;f[m+4>>2]=f[f[z>>2]>>2];f[m>>2]=C&20479|1111621632;f[n>>2]=0;if($$(d)|0)_$(d);tfa(m,B,n,88,e,g,(f[h>>2]|0)+H|0,(f[h+4>>2]|0)+H|0,0)|0;H=f[n>>2]|0;if(H){n=O7(H,56,B)|0;do if(n)if((f[n+28>>2]|0)==4){J=f[n+24>>2]|0;break}else{f[j>>2]=0;f[j+4>>2]=0;v=tT(j,39)|0;w=466950;x=v+39|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,j,466990,466994,2965)}else J=0;while(0);Y$(c,J,1,0,-1,1,0);r7(n,o,0);B=o+32|0;f[B>>2]=0;H=(J|0)>0;a:do if(H){h=o+12|0;g=p+4|0;e=p+16|0;m=p+36|0;C=p+40|0;t=p+48|0;E=p+44|0;F=q+4|0;D=o+20|0;A=o+4|0;K=0;while(1){L=f[f[h>>2]>>2]|0;f[L+72>>2]=K;Y$(c,f[L+24>>2]|0,1,12,K,1,0);a$(p,c,K);if(!(f[p>>2]&16384))break;M=f[e>>2]|0;f[q>>2]=0;f[F>>2]=1073741823;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2];p7(L,M,j)|0;M=f[m>>2]|0;if(M|0?(L=M+12|0,M=f[L>>2]|0,f[L>>2]=M+-1,(M|0)==1):0)_S(p);f[m>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){M=f[C>>2]|0;L=0;do{f[M+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[g>>2]|0))}L=f[E>>2]|0;if((L|0)!=(t|0))g0(L);K=K+1|0;L=(f[h>>2]|0)+4|0;f[h>>2]=L;if(L>>>0>=(f[D>>2]|0)>>>0)z7(o,1);L=(f[B>>2]|0)+1|0;f[B>>2]=L;f[B>>2]=(L|0)<(f[(f[A>>2]|0)+24>>2]<<1|0)?L:0;if((K|0)>=(J|0))break a}f[j>>2]=0;f[j+4>>2]=0;v=tT(j,17)|0;w=255072;x=v+17|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,j,254979,254090,1920)}while(0);if($$(d)|0){Y$(d,1,J,28,-1,1,0);do if((d$(d)|0)==65536){p=f[d+4>>2]|0;f[r>>2]=f[p>>2];q=r+4|0;K=p+4|0;f[q>>2]=f[K>>2];A=r+8|0;f[A>>2]=f[p+8>>2];f[r+12>>2]=f[p+12>>2];D=r+16|0;f[D>>2]=f[p+16>>2];f[r+20>>2]=f[p+20>>2];f[r+24>>2]=f[p+24>>2];f[r+28>>2]=f[p+28>>2];f[r+32>>2]=f[p+32>>2];h=r+36|0;t=f[p+36>>2]|0;f[h>>2]=t;f[r+40>>2]=A;A=r+48|0;E=r+44|0;f[E>>2]=A;f[A>>2]=0;f[r+52>>2]=0;if(t|0){A=t+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[K>>2]|0)<3){K=f[p+44>>2]|0;A=f[E>>2]|0;f[A>>2]=f[K>>2];f[A+4>>2]=f[K+4>>2];N=D;O=E;P=h;break}else{f[q>>2]=0;ZS(r,p);N=D;O=E;P=h;break}}else{a$(r,d,-1);N=r+16|0;O=r+44|0;P=r+36|0}while(0);d=f[N>>2]|0;h=f[P>>2]|0;if(h|0?(E=h+12|0,h=f[E>>2]|0,f[E>>2]=h+-1,(h|0)==1):0)_S(r);f[P>>2]=0;P=r+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[P>>2]|0)>0){N=f[r+40>>2]|0;h=0;do{f[N+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[P>>2]|0))}P=f[O>>2]|0;if((P|0)!=(r+48|0))g0(P);r7(n,j,0);f[j+32>>2]=0;v=o;w=j;x=v+36|0;do{f[v>>2]=f[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));if(H){H=o+12|0;w=o+20|0;v=o+4|0;x=0;do{j=f[f[H>>2]>>2]|0;n=f[j+12>>2]|0;if(!n)Q=-1;else Q=f[n+72>>2]|0;n=f[j+8>>2]|0;if(!n)R=-1;else R=f[n+72>>2]|0;n=f[j+20>>2]|0;if(!n)S=-1;else S=f[n+72>>2]|0;n=f[j+16>>2]|0;if(!n)T=-1;else T=f[n+72>>2]|0;f[d+(x<<4)>>2]=Q;f[d+(x<<4)+4>>2]=R;f[d+(x<<4)+8>>2]=S;f[d+(x<<4)+12>>2]=T;x=x+1|0;n=(f[H>>2]|0)+4|0;f[H>>2]=n;if(n>>>0>=(f[w>>2]|0)>>>0)z7(o,1);n=(f[B>>2]|0)+1|0;f[B>>2]=n;f[B>>2]=(n|0)<(f[(f[v>>2]|0)+24>>2]<<1|0)?n:0}while((x|0)<(J|0))}}}else _$(c);if(I|0?(c=I+4|0,J=f[c>>2]|0,f[c>>2]=J+-1,(J|0)==1):0)Yi[f[(f[I>>2]|0)+8>>2]&2047](I);I=l+36|0;J=f[I>>2]|0;if(J|0?(c=J+12|0,J=f[c>>2]|0,f[c>>2]=J+-1,(J|0)==1):0)_S(l);f[I>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){G=f[s>>2]|0;s=0;do{f[G+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[a>>2]|0))}a=f[z>>2]|0;if((a|0)!=(y|0))g0(a);a=k+36|0;y=f[a>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)_S(k);f[a>>2]=0;a=k+16|0;y=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[y>>2]|0)>0){a=f[k+40>>2]|0;z=0;do{f[a+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[k+44>>2]|0;if((y|0)==(k+48|0)){u=i;return}g0(y);u=i;return}function xfa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;g=u;u=u+1312|0;i=g+112|0;j=g+92|0;k=g+32|0;l=g+8|0;m=g;o=a+24|0;p=f[o>>2]|0;q=p+8|0;r=i+8|0;f[i>>2]=r;t=i+4|0;f[t>>2]=q;if(q>>>0>59){v=XDc(q>>>0>214748364?-1:q*20|0)|0;f[i>>2]=v;w=v}else w=r;v=a+56|0;q=f[v>>2]|0;x=f[v+4>>2]|0;v=f[a>>2]|0;if((v&12288|0)!=4096){f[m>>2]=0;y=m+4|0;f[y>>2]=0;z=tT(m,32)|0;A=z;B=255090;C=A+32|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,m,255123,255147,74)}if((v&16384|0)==0?1:(f[a+28>>2]|0)!=1){f[m>>2]=0;y=m+4|0;f[y>>2]=0;z=tT(m,32)|0;A=z;B=255090;C=A+32|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,m,255123,255147,74)}if((c|0)<=87){f[m>>2]=0;f[m+4>>2]=0;A=tT(m,37)|0;B=255215;C=A+37|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));z5(-215,m,255123,255147,75)}u7(v&-4096|12,c,8,d,l);if(f[o>>2]|0){o=k+32|0;b[o>>0]=0;pfa(a,k);a=j+16|0;f[a>>2]=0;a:do if((p|0)>0){d=k+28|0;c=k+12|0;v=k+36|0;m=(e|0)==1;B=l+12|0;A=l+20|0;C=k+20|0;z=k+40|0;if((e|0)<3)D=0;else{y=j;E=0;while(1){F=b[f[d>>2]>>0]|0;G=f[c>>2]|0;f[d>>2]=G;H=v;I=f[H>>2]|0;J=f[H+4>>2]|0;H=G;if(!G)K=b[o>>0]|0;else{G=b[H>>0]|0;b[o>>0]=G;L=H+1|0;f[c>>2]=L;if(L>>>0<(f[C>>2]|0)>>>0){N=G;O=I}else{z7(k,1);N=b[o>>0]|0;O=f[v>>2]|0}G=N<<24>>24;f[v>>2]=O+(b[k+44+(G<<1)>>0]|0);f[z>>2]=(f[z>>2]|0)+(b[k+44+(G<<1)+1>>0]|0);K=N}G=(K<<24>>24)-F|0;F=f[47888+(G+7<<2)>>2]|0;L=w+(E*20|0)|0;if(!G)P=y;else{f[y+16>>2]=L;P=L}f[w+(E*20|0)+12>>2]=F;F=w+(E*20|0)|0;f[F>>2]=I;f[F+4>>2]=J;J=E+1|0;if((J|0)<(p|0)){y=P;E=J}else{Q=P;R=J;break a}}}while(1){E=b[f[d>>2]>>0]|0;y=f[c>>2]|0;f[d>>2]=y;J=v;F=f[J>>2]|0;I=f[J+4>>2]|0;J=y;if(!y)S=b[o>>0]|0;else{y=b[J>>0]|0;b[o>>0]=y;L=J+1|0;f[c>>2]=L;if(L>>>0<(f[C>>2]|0)>>>0){T=y;U=F}else{z7(k,1);T=b[o>>0]|0;U=f[v>>2]|0}y=T<<24>>24;f[v>>2]=U+(b[k+44+(y<<1)>>0]|0);f[z>>2]=(f[z>>2]|0)+(b[k+44+(y<<1)+1>>0]|0);S=T}if(m|S<<24>>24!=E<<24>>24){E=f[B>>2]|0;if(E>>>0<(f[A>>2]|0)>>>0)V=E;else{x7(l);V=f[B>>2]|0}E=V;y=E;b[y>>0]=F;b[y+1>>0]=F>>8;b[y+2>>0]=F>>16;b[y+3>>0]=F>>24;F=E+4|0;b[F>>0]=I;b[F+1>>0]=I>>8;b[F+2>>0]=I>>16;b[F+3>>0]=I>>24;f[B>>2]=(f[B>>2]|0)+8}I=D+1|0;if((I|0)<(p|0))D=I;else{Q=j;R=I;break}}}else{Q=j;R=0}while(0);if((e|0)>=3){f[Q+16>>2]=0;Q=f[a>>2]|0;D=w;p=(e|0)==4;e=Q;do{V=(e-D|0)/20|0;S=f[e>>2]|0;T=f[e+4>>2]|0;k=1;U=0;o=0;while(1){P=V-k|0;K=((P|0)<0?R:0)+P|0;P=k+V|0;N=P-((P|0)>=(R|0)?R:0)|0;P=f[w+(K*20|0)>>2]|0;O=(f[w+(N*20|0)>>2]|0)-P|0;B=f[w+(K*20|0)+4>>2]|0;K=(f[w+(N*20|0)+4>>2]|0)-B|0;N=(Y(K,K)|0)+(Y(O,O)|0)|0;A=(Y(K,S-P|0)|0)-(Y(T-B|0,O)|0)|0;O=(n[s>>2]=+(U|0)*+(N|0)-+(o|0)*+(A|0),f[s>>2]|0);if((k|0)>1){if((o|0)>=(N|0))break;if((U|0)>0&(O|0)<1)break;if((U|0)<0&(O|0)>-1)break}k=k+1|0;U=A;o=N}o=k+-1|0;f[e+8>>2]=o;if(p){U=o;N=0;while(1){A=V-U|0;O=((A|0)<0?R:0)+A|0;A=U+V|0;B=A-((A|0)>=(R|0)?R:0)|0;A=(f[w+(O*20|0)>>2]|0)-S|0;P=(f[w+(O*20|0)+4>>2]|0)-T|0;O=(f[w+(B*20|0)>>2]|0)-S|0;K=(f[w+(B*20|0)+4>>2]|0)-T|0;if((P|A|0)==0|(K|O|0)==0){W=N;break}X=+(A|0);Z=+(P|0);_=+(O|0);$=+(K|0);aa=+((Y(K,P)|0)+(Y(O,A)|0)|0)/+M(+((X*X+Z*Z)*(_*_+$*$)))+1.1;A=(n[s>>2]=aa,f[s>>2]|0);if(!((U|0)>=(o|0)|(A|0)>(N|0))){W=N;break}if((U|0)>1){U=U+-1|0;N=A}else{W=A;break}}f[e+12>>2]=W}e=f[e+16>>2]|0}while((e|0)!=0);ba=j;ca=Q;while(1){Q=f[ca+8>>2]>>1;e=ca+12|0;W=f[e>>2]|0;N=(ca-D|0)/20|0;b:do if((Q|0)<1)da=ca;else{U=1;while(1){o=N-U|0;if((f[w+((((o|0)<0?R:0)+o|0)*20|0)+12>>2]|0)>(W|0))break;o=U+N|0;if((f[w+((o-((o|0)>=(R|0)?R:0)|0)*20|0)+12>>2]|0)>(W|0))break;if((U|0)<(Q|0))U=U+1|0;else{da=ca;break b}}f[ba+16>>2]=f[ca+16>>2];f[e>>2]=0;da=ba}while(0);ca=f[ca+16>>2]|0;if(!ca)break;else ba=da}da=j;ba=f[a>>2]|0;while(1){do if((f[ba+8>>2]|0)==1){ca=ba+12|0;e=f[ca>>2]|0;Q=ba-D|0;W=(Q|0)/20|0;N=W+1|0;if((e|0)>(f[w+((W+-1+((Q|0)<20?R:0)|0)*20|0)+12>>2]|0)?(e|0)>(f[w+((N-((N|0)>=(R|0)?R:0)|0)*20|0)+12>>2]|0):0){ea=ba;break}f[da+16>>2]=f[ba+16>>2];f[ca>>2]=0;ea=da}else ea=ba;while(0);ba=f[ba+16>>2]|0;if(!ba)break;else da=ea}do if(!p){if(f[w+12>>2]|0?(ea=R+-1|0,f[w+(ea*20|0)+12>>2]|0):0){c:do if((R|0)>1){da=1;while(1){if(!(f[w+(da*20|0)+12>>2]|0)){fa=da;break c}f[w+((da+-1|0)*20|0)+12>>2]=0;ba=da+1|0;if((ba|0)<(R|0))da=ba;else{fa=ba;break}}}else fa=1;while(0);if((fa|0)==(R|0))break;da=fa+-1|0;d:do if((R|0)>2){ba=R+-2|0;ca=ea;while(1){if(!(f[w+(ba*20|0)+12>>2]|0)){ga=ca;break d}f[w+(ba*20|0)+16>>2]=0;f[w+(ca*20|0)+12>>2]=0;if((ba|0)>1){N=ba;ba=ba+-1|0;ca=N}else{ga=ba;break}}}else ga=ea;while(0);if((da|0)==0&(ga|0)==(ea|0)){ba=((f[w+16>>2]|0)-D|0)/20|0;ca=w+(R*20|0)|0;f[ca>>2]=f[w>>2];f[ca+4>>2]=f[w+4>>2];f[ca+8>>2]=f[w+8>>2];f[ca+12>>2]=f[w+12>>2];f[ca+16>>2]=f[w+16>>2];f[w+(R*20|0)+16>>2]=0;f[w+(ea*20|0)+16>>2]=ca;ha=ba}else ha=da;f[a>>2]=w+(ha*20|0)}ba=j;ca=f[a>>2]|0;while(1){N=ca+16|0;e=f[N>>2]|0;e:do if(!e){ia=1;ja=ba;ka=ca;la=e;ma=N}else{Q=1;W=ba;U=ca;o=e;T=N;while(1){if((o-U|0)!=20){ia=Q;ja=W;ka=U;la=o;ma=T;break e}S=Q+1|0;V=o+16|0;k=f[V>>2]|0;if(!k){ia=S;ja=U;ka=o;la=k;ma=V;break}else{A=o;O=U;Q=S;o=k;T=V;U=A;W=O}}}while(0);if((ia|0)>1){do if((ia|0)==2){N=f[ja+12>>2]|0;e=f[ka+12>>2]|0;if((N|0)<=(e|0)){if((N|0)!=(e|0)){na=ka;oa=ba;break}if((f[ja+8>>2]|0)>(f[ka+8>>2]|0)){na=ka;oa=ba;break}}na=la;oa=ja}else{na=ka;oa=f[ba+16>>2]|0}while(0);f[oa+16>>2]=na;pa=f[ma>>2]|0}else pa=la;if(!pa)break;else{ba=ka;ca=pa}}}while(0);pa=l+12|0;ka=l+20|0;la=f[a>>2]|0;a=f[pa>>2]|0;do{if(a>>>0<(f[ka>>2]|0)>>>0)qa=a;else{x7(l);qa=f[pa>>2]|0}ma=la;na=ma;oa=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=ma+4|0;ma=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=qa;ja=na;b[ja>>0]=oa;b[ja+1>>0]=oa>>8;b[ja+2>>0]=oa>>16;b[ja+3>>0]=oa>>24;oa=na+4|0;b[oa>>0]=ma;b[oa+1>>0]=ma>>8;b[oa+2>>0]=ma>>16;b[oa+3>>0]=ma>>24;a=(f[pa>>2]|0)+8|0;f[pa>>2]=a;la=f[la+16>>2]|0}while((la|0)!=0)}}else{la=l+12|0;a=f[la>>2]|0;if(a>>>0<(f[l+20>>2]|0)>>>0)ra=a;else{x7(l);ra=f[la>>2]|0}a=ra;ra=a;b[ra>>0]=q;b[ra+1>>0]=q>>8;b[ra+2>>0]=q>>16;b[ra+3>>0]=q>>24;q=a+4|0;b[q>>0]=x;b[q+1>>0]=x>>8;b[q+2>>0]=x>>16;b[q+3>>0]=x>>24;f[la>>2]=(f[la>>2]|0)+8}la=w7(l)|0;l=f[i>>2]|0;if((l|0)==(r|0)){u=g;return la|0}if(l|0)ZDc(l);f[i>>2]=r;f[t>>2]=59;u=g;return la|0}function yfa(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+2320|0;h=g+2256|0;i=g+1160|0;j=g+64|0;k=g;l=g+8|0;do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[h>>2]=f[m>>2];n=h+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;ZS(h,m);break}}else a$(h,a,-1);while(0);a=pT(h,2,-1,1)|0;m=f[h>>2]|0;n=m&7;if(!((a|0)>-1&(n|1|0)==5)){f[i>>2]=0;f[i+4>>2]=0;o=tT(i,52)|0;p=255253;r=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(r|0));z5(-215,i,255306,255147,682)}if(a){p=i+8|0;XIc(p|0,0,1088)|0;f[i>>2]=p;o=i+4|0;r=a>>>0>136;f[o>>2]=a;if(r){q=XDc(a>>>0>536870911?-1:a<<3)|0;XIc(q|0,0,a<<3|0)|0;f[i>>2]=q;s=q}else s=p;q=j+8|0;XIc(q|0,0,1088)|0;f[j>>2]=q;t=j+4|0;f[t>>2]=a;if(r){r=XDc(a>>>0>536870911?-1:a<<3)|0;XIc(r|0,0,a<<3|0)|0;f[j>>2]=r}switch(m&7){case 4:{v=zfa(f[h+16>>2]|0,a,s,e,d,j)|0;break}case 5:{v=Afa(f[h+16>>2]|0,a,s,e,d,j)|0;break}default:{f[k>>2]=0;f[k+4>>2]=0;z5(-210,k,255306,255147,700)}}Vj(l,v,1,n|8,s,0);h_(l,c);s=l+36|0;n=f[s>>2]|0;if(n|0?(v=n+12|0,n=f[v>>2]|0,f[v>>2]=n+-1,(n|0)==1):0)_S(l);f[s>>2]=0;s=l+16|0;n=l+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[n>>2]|0)>0){s=f[l+40>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)!=(l+48|0))g0(n);n=f[j>>2]|0;if((n|0)!=(q|0)){if(n|0)ZDc(n);f[j>>2]=q;f[t>>2]=136}t=f[i>>2]|0;if((t|0)!=(p|0)){if(t|0)ZDc(t);f[i>>2]=p;f[o>>2]=136}}else u$(c);c=h+36|0;o=f[c>>2]|0;if(o|0?(p=o+12|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)_S(h);f[c>>2]=0;c=h+16|0;o=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[h+40>>2]|0;p=0;do{f[c+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[o>>2]|0))}o=f[h+44>>2]|0;if((o|0)==(h+48|0)){u=g;return}g0(o);u=g;return}function zfa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0.0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;if(!b){k=0;return k|0}l=e*e;if(!d){m=b+-1|0;if((f[a+(m<<3)>>2]|0)==(f[a>>2]|0)?(f[a+(m<<3)+4>>2]|0)==(f[a+4>>2]|0):0){n=1;o=7}else{if(!i){f[h>>2]=0;p=0}else p=i;q=j;f[q>>2]=0;f[q+4>>2]=m;r=1;s=j;t=p;u=0;v=b;o=41}}else{n=3;o=7}do if((o|0)==7){if((b|0)>1){p=0;m=0;q=0;while(1){w=(m+q|0)%(b|0)|0;x=f[a+(w<<3)>>2]|0;y=f[a+(w<<3)+4>>2]|0;z=w+1|0;w=1;e=0.0;A=(z|0)>=(b|0)?0:z;z=q;do{B=A+1|0;C=A;A=(B|0)>=(b|0)?0:B;D=+((f[a+(C<<3)>>2]|0)-x|0);E=+((f[a+(C<<3)+4>>2]|0)-y|0);F=D*D+E*E;C=F>e;z=C?w:z;e=C?F:e;w=w+1|0}while((w|0)!=(b|0));p=p+1|0;if((p|0)>=(n|0)){G=A;H=e;I=x;J=z;K=y;break}else{m=A;q=z}}}else{q=0;m=0;do{M=(m|0)%(b|0)|0;p=M+1|0;m=(p|0)>=(b|0)?0:p;q=q+1|0}while((q|0)<(n|0));G=m;H=0.0;I=f[a+(M<<3)>>2]|0;J=0;K=f[a+(M<<3)+4>>2]|0}if(H<=l){f[c>>2]=I;f[c+4>>2]=K;N=1;break}q=(G|0)%(b|0)|0;p=(q+J|0)%(b|0)|0;if(!i){w=(i*3|0)>>>1;C=f[h>>2]|0;if(C>>>0<w>>>0){B=f[g>>2]|0;O=g+8|0;f[g>>2]=O;f[h>>2]=w;if((C|0)!=0&(O|0)!=(B|0)){P=B;Q=f[P+4>>2]|0;R=O;f[R>>2]=f[P>>2];f[R+4>>2]=Q;if((C|0)!=1){Q=B+8|0;R=f[Q+4>>2]|0;P=g+16|0;f[P>>2]=f[Q>>2];f[P+4>>2]=R;if((C|0)==2)S=C;else{R=2;do{P=B+(R<<3)|0;Q=f[P+4>>2]|0;O=(f[g>>2]|0)+(R<<3)|0;f[O>>2]=f[P>>2];f[O+4>>2]=Q;R=R+1|0}while((R|0)!=(C|0));S=C}}else S=1}else S=C;do{R=(f[g>>2]|0)+(S<<3)|0;f[R>>2]=0;f[R+4>>2]=0;S=S+1|0}while((S|0)!=(w|0));if(!((B|0)==(g+8|0)|(B|0)==0))ZDc(B)}else f[h>>2]=w;T=f[g>>2]|0;U=f[h>>2]|0}else{T=j;U=i}C=T;f[C>>2]=p;f[C+4>>2]=q;if(U>>>0>1){V=T;W=U}else{C=U*3|0;R=C>>>1;m=f[h>>2]|0;if(m>>>0<R>>>0){Q=f[g>>2]|0;if(C>>>0>273){C=XDc(R>>>0>536870911?-1:R<<3)|0;XIc(C|0,0,R<<3|0)|0;X=C}else X=g+8|0;f[g>>2]=X;f[h>>2]=R;if((m|0)!=0&(X|0)!=(Q|0)){C=Q;O=f[C+4>>2]|0;P=X;f[P>>2]=f[C>>2];f[P+4>>2]=O;if((m|0)!=1){O=Q+8|0;P=f[O+4>>2]|0;C=X+8|0;f[C>>2]=f[O>>2];f[C+4>>2]=P;if((m|0)==2)Z=m;else{P=2;do{C=Q+(P<<3)|0;O=f[C+4>>2]|0;_=(f[g>>2]|0)+(P<<3)|0;f[_>>2]=f[C>>2];f[_+4>>2]=O;P=P+1|0}while((P|0)!=(m|0));Z=m}}else Z=1}else Z=m;do{P=(f[g>>2]|0)+(Z<<3)|0;f[P>>2]=0;f[P+4>>2]=0;Z=Z+1|0}while((Z|0)!=(R|0));if(!((Q|0)==(g+8|0)|(Q|0)==0))ZDc(Q)}else f[h>>2]=R;V=f[g>>2]|0;W=f[h>>2]|0}m=V+8|0;f[m>>2]=q;f[m+4>>2]=p;r=2;s=V;t=W;u=1;v=p;o=41}while(0);if((o|0)==41){o=b+-1|0;W=g+8|0;V=0;Z=r;r=s;s=t;t=v;a:while(1){v=V;X=Z;U=t;while(1){$=X+-1|0;T=r+($<<3)|0;aa=f[T>>2]|0;ba=f[T+4>>2]|0;T=f[a+(aa<<3)>>2]|0;i=f[a+(aa<<3)+4>>2]|0;j=aa+1|0;S=(j|0)>=(b|0)?0:j;if((S|0)!=(ba|0)){H=+((f[a+(ba<<3)>>2]|0)-T|0);F=+((f[a+(ba<<3)+4>>2]|0)-i|0);E=0.0;j=S;ca=U;b:while(1){S=j;do{if((S|0)==(ba|0))break b;J=S+1|0;G=S;S=(J|0)>=(b|0)?0:J;da=+L(+(H*+((f[a+(G<<3)+4>>2]|0)-i|0)-F*+((f[a+(G<<3)>>2]|0)-T|0)))}while(!(da>E));E=da;j=S;ca=(o+S|0)%(b|0)|0}if(!(E*E<=l*(F*F+H*H)))break;else ea=ca}else ea=U;j=v+1|0;f[c+(v<<3)>>2]=T;f[c+(v<<3)+4>>2]=i;if(!$){fa=j;break a}else{v=j;X=$;U=ea}}if($>>>0<s>>>0){ga=r;ha=s}else{U=s*3|0;p=U>>>1;q=f[h>>2]|0;if(q>>>0<p>>>0){R=f[g>>2]|0;if(U>>>0>273){U=XDc(p>>>0>536870911?-1:p<<3)|0;XIc(U|0,0,p<<3|0)|0;ia=U}else ia=W;f[g>>2]=ia;f[h>>2]=p;if((q|0)!=0&(ia|0)!=(R|0)){U=R;Q=f[U+4>>2]|0;j=ia;f[j>>2]=f[U>>2];f[j+4>>2]=Q;if((q|0)!=1){Q=R+8|0;j=f[Q+4>>2]|0;U=ia+8|0;f[U>>2]=f[Q>>2];f[U+4>>2]=j;if((q|0)==2)ja=q;else{j=2;do{U=R+(j<<3)|0;Q=f[U+4>>2]|0;z=(f[g>>2]|0)+(j<<3)|0;f[z>>2]=f[U>>2];f[z+4>>2]=Q;j=j+1|0}while((j|0)!=(q|0));ja=q}}else ja=1}else ja=q;do{j=(f[g>>2]|0)+(ja<<3)|0;f[j>>2]=0;f[j+4>>2]=0;ja=ja+1|0}while((ja|0)!=(p|0));if(!((R|0)==(W|0)|(R|0)==0))ZDc(R)}else f[h>>2]=p;ga=f[g>>2]|0;ha=f[h>>2]|0}q=ga+($<<3)|0;f[q>>2]=ca;f[q+4>>2]=ba;if(X>>>0<ha>>>0){ka=ga;la=ha}else{q=ha*3|0;j=q>>>1;Q=f[h>>2]|0;if(Q>>>0<j>>>0){z=f[g>>2]|0;if(q>>>0>273){q=XDc(j>>>0>536870911?-1:j<<3)|0;XIc(q|0,0,j<<3|0)|0;ma=q}else ma=W;f[g>>2]=ma;f[h>>2]=j;if((Q|0)!=0&(ma|0)!=(z|0)){q=z;U=f[q+4>>2]|0;A=ma;f[A>>2]=f[q>>2];f[A+4>>2]=U;if((Q|0)!=1){U=z+8|0;A=f[U+4>>2]|0;q=ma+8|0;f[q>>2]=f[U>>2];f[q+4>>2]=A;if((Q|0)==2)na=Q;else{A=2;do{q=z+(A<<3)|0;U=f[q+4>>2]|0;y=(f[g>>2]|0)+(A<<3)|0;f[y>>2]=f[q>>2];f[y+4>>2]=U;A=A+1|0}while((A|0)!=(Q|0));na=Q}}else na=1}else na=Q;do{A=(f[g>>2]|0)+(na<<3)|0;f[A>>2]=0;f[A+4>>2]=0;na=na+1|0}while((na|0)!=(j|0));if(!((z|0)==(W|0)|(z|0)==0))ZDc(z)}else f[h>>2]=j;ka=f[g>>2]|0;la=f[h>>2]|0}Z=X+1|0;Q=ka+(X<<3)|0;f[Q>>2]=aa;f[Q+4>>2]=ca;if(!Z){fa=v;break}else{V=v;r=ka;s=la;t=ca}}if(u)N=fa;else{f[c+(fa<<3)>>2]=f[a+(o<<3)>>2];f[c+(fa<<3)+4>>2]=f[a+(o<<3)+4>>2];N=fa+1|0}}fa=d?N+-1|0:0;o=fa+1|0;a=(o|0)>=(N|0)?0:o;o=f[c+(a<<3)>>2]|0;u=f[c+(a<<3)+4>>2]|0;ca=a+1|0;t=(d^1)&1;la=N-t|0;if((N|0)>2&(t|0)<(la|0)){da=l*.5;s=a;ka=t;t=N;r=(ca|0)>=(N|0)?0:ca;ca=o;V=f[c+(fa<<3)>>2]|0;Z=u;aa=f[c+(fa<<3)+4>>2]|0;while(1){fa=f[c+(r<<3)>>2]|0;h=f[c+(r<<3)+4>>2]|0;g=r+1|0;W=(g|0)>=(N|0)?0:g;g=fa-V|0;l=+(g|0);na=h-aa|0;e=+(na|0);ma=ca-V|0;ha=Z-aa|0;D=+L(+(+(ma|0)*e-+(ha|0)*l));if(((Y(h-Z|0,ha)|0)+(Y(fa-ca|0,ma)|0)|0)>-1&((na|0)!=0&(g|0?D*D<=da*(l*l+e*e):0))){f[c+(s<<3)>>2]=fa;f[c+(s<<3)+4>>2]=h;g=s+1|0;na=W+1|0;oa=(g|0)>=(N|0)?0:g;pa=ka+1|0;qa=t+-1|0;ra=(na|0)>=(N|0)?0:na;sa=f[c+(W<<3)>>2]|0;ta=fa;ua=f[c+(W<<3)+4>>2]|0;va=h}else{f[c+(s<<3)>>2]=ca;f[c+(s<<3)+4>>2]=Z;na=s+1|0;oa=(na|0)>=(N|0)?0:na;pa=ka;qa=t;ra=W;sa=fa;ta=ca;ua=h;va=Z}ka=pa+1|0;if(!((qa|0)>2&(ka|0)<(la|0))){wa=oa;xa=qa;ya=sa;za=ua;break}else{s=oa;t=qa;r=ra;ca=sa;V=ta;Z=ua;aa=va}}}else{wa=a;xa=N;ya=o;za=u}if(d){k=xa;return k|0}f[c+(wa<<3)>>2]=ya;f[c+(wa<<3)+4>>2]=za;k=xa;return k|0}function Afa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;if(!b){k=0;return k|0}l=e*e;do if(d){m=3;o=8}else{p=b+-1|0;if(!(+n[a+(p<<3)>>2]!=+n[a>>2])?!(+n[a+(p<<3)+4>>2]!=+n[a+4>>2]):0){m=1;o=8;break}if(!i){f[h>>2]=0;q=0}else q=i;r=j;f[r>>2]=0;f[r+4>>2]=p;t=1;u=j;v=q;w=0;x=b;o=42}while(0);do if((o|0)==8){if((b|0)>1){q=0;p=0;r=0;while(1){y=(p+r|0)%(b|0)|0;z=f[a+(y<<3)>>2]|0;A=f[a+(y<<3)+4>>2]|0;B=y+1|0;e=(f[s>>2]=z,+n[s>>2]);C=(f[s>>2]=A,+n[s>>2]);y=1;D=0.0;E=(B|0)>=(b|0)?0:B;B=r;do{F=E+1|0;G=E;E=(F|0)>=(b|0)?0:F;H=+n[a+(G<<3)>>2]-e;I=+n[a+(G<<3)+4>>2]-C;J=H*H+I*I;G=J>D;B=G?y:B;D=G?J:D;y=y+1|0}while((y|0)!=(b|0));q=q+1|0;if((q|0)>=(m|0)){K=E;M=D;N=z;O=B;P=A;break}else{p=E;r=B}}}else{r=0;p=0;do{Q=(p|0)%(b|0)|0;q=Q+1|0;p=(q|0)>=(b|0)?0:q;r=r+1|0}while((r|0)<(m|0));K=p;M=0.0;N=f[a+(Q<<3)>>2]|0;O=0;P=f[a+(Q<<3)+4>>2]|0}if(M<=l){f[c>>2]=N;f[c+4>>2]=P;R=1;break}r=(K|0)%(b|0)|0;q=(r+O|0)%(b|0)|0;if(!i){y=(i*3|0)>>>1;G=f[h>>2]|0;if(G>>>0<y>>>0){F=f[g>>2]|0;S=g+8|0;f[g>>2]=S;f[h>>2]=y;if((G|0)!=0&(S|0)!=(F|0)){T=F;U=f[T+4>>2]|0;V=S;f[V>>2]=f[T>>2];f[V+4>>2]=U;if((G|0)!=1){U=F+8|0;V=f[U+4>>2]|0;T=g+16|0;f[T>>2]=f[U>>2];f[T+4>>2]=V;if((G|0)==2)W=G;else{V=2;do{T=F+(V<<3)|0;U=f[T+4>>2]|0;S=(f[g>>2]|0)+(V<<3)|0;f[S>>2]=f[T>>2];f[S+4>>2]=U;V=V+1|0}while((V|0)!=(G|0));W=G}}else W=1}else W=G;do{V=(f[g>>2]|0)+(W<<3)|0;f[V>>2]=0;f[V+4>>2]=0;W=W+1|0}while((W|0)!=(y|0));if(!((F|0)==(g+8|0)|(F|0)==0))ZDc(F)}else f[h>>2]=y;X=f[g>>2]|0;Y=f[h>>2]|0}else{X=j;Y=i}G=X;f[G>>2]=q;f[G+4>>2]=r;if(Y>>>0>1){Z=X;_=Y}else{G=Y*3|0;V=G>>>1;p=f[h>>2]|0;if(p>>>0<V>>>0){U=f[g>>2]|0;if(G>>>0>273){G=XDc(V>>>0>536870911?-1:V<<3)|0;XIc(G|0,0,V<<3|0)|0;$=G}else $=g+8|0;f[g>>2]=$;f[h>>2]=V;if((p|0)!=0&($|0)!=(U|0)){G=U;S=f[G+4>>2]|0;T=$;f[T>>2]=f[G>>2];f[T+4>>2]=S;if((p|0)!=1){S=U+8|0;T=f[S+4>>2]|0;G=$+8|0;f[G>>2]=f[S>>2];f[G+4>>2]=T;if((p|0)==2)aa=p;else{T=2;do{G=U+(T<<3)|0;S=f[G+4>>2]|0;ba=(f[g>>2]|0)+(T<<3)|0;f[ba>>2]=f[G>>2];f[ba+4>>2]=S;T=T+1|0}while((T|0)!=(p|0));aa=p}}else aa=1}else aa=p;do{T=(f[g>>2]|0)+(aa<<3)|0;f[T>>2]=0;f[T+4>>2]=0;aa=aa+1|0}while((aa|0)!=(V|0));if(!((U|0)==(g+8|0)|(U|0)==0))ZDc(U)}else f[h>>2]=V;Z=f[g>>2]|0;_=f[h>>2]|0}p=Z+8|0;f[p>>2]=r;f[p+4>>2]=q;t=2;u=Z;v=_;w=1;x=q;o=42}while(0);if((o|0)==42){o=b+-1|0;_=g+8|0;Z=0;aa=t;t=u;u=v;v=x;a:while(1){x=Z;$=aa;Y=v;while(1){ca=$+-1|0;X=t+(ca<<3)|0;da=f[X>>2]|0;ea=f[X+4>>2]|0;X=f[a+(da<<3)>>2]|0;i=f[a+(da<<3)+4>>2]|0;j=da+1|0;W=(j|0)>=(b|0)?0:j;if((W|0)!=(ea|0)){M=(f[s>>2]=X,+n[s>>2]);C=+n[a+(ea<<3)>>2]-M;e=(f[s>>2]=i,+n[s>>2]);J=+n[a+(ea<<3)+4>>2]-e;I=0.0;j=W;fa=Y;b:while(1){W=j;do{if((W|0)==(ea|0))break b;O=W+1|0;K=W;W=(O|0)>=(b|0)?0:O;ga=+L(+(C*(+n[a+(K<<3)+4>>2]-e)-J*(+n[a+(K<<3)>>2]-M)))}while(!(ga>I));I=ga;j=W;fa=(o+W|0)%(b|0)|0}if(!(I*I<=l*(J*J+C*C)))break;else ha=fa}else ha=Y;j=x+1|0;f[c+(x<<3)>>2]=X;f[c+(x<<3)+4>>2]=i;if(!ca){ia=j;break a}else{x=j;$=ca;Y=ha}}if(ca>>>0<u>>>0){ja=t;ka=u}else{Y=u*3|0;q=Y>>>1;r=f[h>>2]|0;if(r>>>0<q>>>0){V=f[g>>2]|0;if(Y>>>0>273){Y=XDc(q>>>0>536870911?-1:q<<3)|0;XIc(Y|0,0,q<<3|0)|0;la=Y}else la=_;f[g>>2]=la;f[h>>2]=q;if((r|0)!=0&(la|0)!=(V|0)){Y=V;U=f[Y+4>>2]|0;j=la;f[j>>2]=f[Y>>2];f[j+4>>2]=U;if((r|0)!=1){U=V+8|0;j=f[U+4>>2]|0;Y=la+8|0;f[Y>>2]=f[U>>2];f[Y+4>>2]=j;if((r|0)==2)ma=r;else{j=2;do{Y=V+(j<<3)|0;U=f[Y+4>>2]|0;B=(f[g>>2]|0)+(j<<3)|0;f[B>>2]=f[Y>>2];f[B+4>>2]=U;j=j+1|0}while((j|0)!=(r|0));ma=r}}else ma=1}else ma=r;do{j=(f[g>>2]|0)+(ma<<3)|0;f[j>>2]=0;f[j+4>>2]=0;ma=ma+1|0}while((ma|0)!=(q|0));if(!((V|0)==(_|0)|(V|0)==0))ZDc(V)}else f[h>>2]=q;ja=f[g>>2]|0;ka=f[h>>2]|0}r=ja+(ca<<3)|0;f[r>>2]=fa;f[r+4>>2]=ea;if($>>>0<ka>>>0){na=ja;oa=ka}else{r=ka*3|0;j=r>>>1;U=f[h>>2]|0;if(U>>>0<j>>>0){B=f[g>>2]|0;if(r>>>0>273){r=XDc(j>>>0>536870911?-1:j<<3)|0;XIc(r|0,0,j<<3|0)|0;pa=r}else pa=_;f[g>>2]=pa;f[h>>2]=j;if((U|0)!=0&(pa|0)!=(B|0)){r=B;Y=f[r+4>>2]|0;E=pa;f[E>>2]=f[r>>2];f[E+4>>2]=Y;if((U|0)!=1){Y=B+8|0;E=f[Y+4>>2]|0;r=pa+8|0;f[r>>2]=f[Y>>2];f[r+4>>2]=E;if((U|0)==2)qa=U;else{E=2;do{r=B+(E<<3)|0;Y=f[r+4>>2]|0;A=(f[g>>2]|0)+(E<<3)|0;f[A>>2]=f[r>>2];f[A+4>>2]=Y;E=E+1|0}while((E|0)!=(U|0));qa=U}}else qa=1}else qa=U;do{E=(f[g>>2]|0)+(qa<<3)|0;f[E>>2]=0;f[E+4>>2]=0;qa=qa+1|0}while((qa|0)!=(j|0));if(!((B|0)==(_|0)|(B|0)==0))ZDc(B)}else f[h>>2]=j;na=f[g>>2]|0;oa=f[h>>2]|0}aa=$+1|0;U=na+($<<3)|0;f[U>>2]=da;f[U+4>>2]=fa;if(!aa){ia=x;break}else{Z=x;t=na;u=oa;v=fa}}if(w)R=ia;else{f[c+(ia<<3)>>2]=f[a+(o<<3)>>2];f[c+(ia<<3)+4>>2]=f[a+(o<<3)+4>>2];R=ia+1|0}}ia=d?R+-1|0:0;o=ia+1|0;a=(o|0)>=(R|0)?0:o;o=f[c+(a<<3)>>2]|0;w=f[c+(a<<3)+4>>2]|0;fa=a+1|0;v=(d^1)&1;oa=R-v|0;if((R|0)>2&(v|0)<(oa|0)){ga=l*.5;u=a;na=v;v=R;t=(fa|0)>=(R|0)?0:fa;fa=o;Z=f[c+(ia<<3)>>2]|0;aa=w;da=f[c+(ia<<3)+4>>2]|0;while(1){ia=f[c+(t<<3)>>2]|0;h=f[c+(t<<3)+4>>2]|0;g=t+1|0;_=(g|0)>=(R|0)?0:g;l=(f[s>>2]=ia,+n[s>>2]);M=(f[s>>2]=Z,+n[s>>2]);e=l-M;D=e;H=(f[s>>2]=h,+n[s>>2]);ra=(f[s>>2]=da,+n[s>>2]);sa=H-ra;ta=sa;ua=(f[s>>2]=fa,+n[s>>2]);va=ua-M;M=(f[s>>2]=aa,+n[s>>2]);wa=M-ra;ra=+L(+(va*ta-wa*D));if(va*(l-ua)+wa*(H-M)>=0.0&(sa!=0.0&(e!=0.0?ra*ra<=ga*(D*D+ta*ta):0))){f[c+(u<<3)>>2]=ia;f[c+(u<<3)+4>>2]=h;g=u+1|0;qa=_+1|0;xa=(g|0)>=(R|0)?0:g;ya=na+1|0;za=v+-1|0;Aa=(qa|0)>=(R|0)?0:qa;Ba=f[c+(_<<3)>>2]|0;Ca=ia;Da=f[c+(_<<3)+4>>2]|0;Ea=h}else{f[c+(u<<3)>>2]=fa;f[c+(u<<3)+4>>2]=aa;qa=u+1|0;xa=(qa|0)>=(R|0)?0:qa;ya=na;za=v;Aa=_;Ba=ia;Ca=fa;Da=h;Ea=aa}na=ya+1|0;if(!((za|0)>2&(na|0)<(oa|0))){Fa=xa;Ga=za;Ha=Ba;Ia=Da;break}else{u=xa;v=za;t=Aa;fa=Ba;Z=Ca;aa=Da;da=Ea}}}else{Fa=a;Ga=R;Ha=o;Ia=w}if(d){k=Ga;return k|0}f[c+(Fa<<3)>>2]=Ha;f[c+(Fa<<3)+4>>2]=Ia;k=Ga;return k|0}function Bfa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0;k=u;u=u+816|0;l=k+88|0;m=k+792|0;n=k+736|0;o=k+732|0;p=k+728|0;q=k+672|0;r=k+616|0;s=k+608|0;t=k+552|0;v=k+496|0;w=k+440|0;x=k+32|0;y=k+384|0;z=k+328|0;A=k+272|0;B=k+216|0;C=k+160|0;D=k;E=k+144|0;f[m>>2]=0;F=m+4|0;f[F>>2]=0;f[m+8>>2]=0;f[n>>2]=f[c>>2];G=n+4|0;H=c+4|0;I=f[H>>2]|0;f[G>>2]=I;J=n+8|0;f[J>>2]=f[c+8>>2];K=n+12|0;f[K>>2]=f[c+12>>2];L=n+16|0;f[L>>2]=f[c+16>>2];M=n+20|0;f[M>>2]=f[c+20>>2];N=n+24|0;f[N>>2]=f[c+24>>2];O=n+28|0;f[O>>2]=f[c+28>>2];P=n+32|0;f[P>>2]=f[c+32>>2];Q=n+36|0;R=f[c+36>>2]|0;f[Q>>2]=R;S=n+40|0;f[S>>2]=J;T=n+48|0;U=n+44|0;f[U>>2]=T;f[T>>2]=0;f[n+52>>2]=0;if(!R)V=I;else{I=R+12|0;f[I>>2]=(f[I>>2]|0)+1;V=f[H>>2]|0}if((V|0)<3){V=f[c+44>>2]|0;H=f[U>>2]|0;f[H>>2]=f[V>>2];f[H+4>>2]=f[V+4>>2]}else{f[G>>2]=0;ZS(n,c)}V=f[a>>2]|0;H=V&7;I=V>>>3;V=I&511;R=f[n>>2]|0;W=R&7;f[o>>2]=W;X=R>>>3&511;R=X+1|0;Z=g&7;f[p>>2]=Z;_=g>>>3;$=_&511;aa=a+4|0;if(!((f[aa>>2]|0)<3&(f[G>>2]|0)<3)){f[l>>2]=0;ba=l+4|0;f[ba>>2]=0;ca=tT(l,50)|0;da=ca;ea=255319;fa=da+50|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,l,255370,255380,579)}ga=d+4|0;if((f[ga>>2]|0)>=3){f[l>>2]=0;ba=l+4|0;f[ba>>2]=0;ca=tT(l,50)|0;da=ca;ea=255319;fa=da+50|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,l,255370,255380,579)}if((H|0)!=(W|0)){ca=H>>>0>5?H:5;if((W|0)==(ca|0))ha=W;else{W=l+8|0;f[W>>2]=0;f[W+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;LZ(c,l,ca,1.0,0.0);ca=f[n>>2]&7;f[o>>2]=ca;ha=ca}}else ha=H;if(!((H|0)==(ha|0)|(ha|0)==5)){f[l>>2]=0;f[l+4>>2]=0;da=tT(l,35)|0;ea=255452;fa=da+35|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,l,255370,255380,587)}ca=f[e+4>>2]|0;c=a+8|0;if((ca|0)>=((f[J>>2]|0)+(f[c>>2]|0)|0)){f[l>>2]=0;ia=l+4|0;f[ia>>2]=0;ja=tT(l,91)|0;da=ja;ea=255488;fa=da+91|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,l,255370,255380,589)}W=f[e>>2]|0;e=a+12|0;if((W|0)>=((f[K>>2]|0)+(f[e>>2]|0)|0)){f[l>>2]=0;ia=l+4|0;f[ia>>2]=0;ja=tT(l,91)|0;da=ja;ea=255488;fa=da+91|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,l,255370,255380,589)}ja=($|0)==0;if(!(ja|i==0.0)){f[l>>2]=0;f[l+4>>2]=0;da=tT(l,22)|0;ea=255580;fa=da+22|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,l,255370,255380,591)}$=g&4095;if(!(((((f[ga>>2]|0)<3?(f[d+8>>2]|0)==(ca|0):0)?(f[d+12>>2]|0)==(W|0):0)?(f[d>>2]&4095|0)==($|0):0)?(f[d+16>>2]|0)!=0:0)){f[l>>2]=ca;f[l+4>>2]=W;XS(d,2,l,$)}if(H>>>0>1)ka=6;else{$=ha>>>0>5?ha:5;ka=($|0)<(Z|0)?Z:$}$=f[K>>2]|0;W=nrc(+($|0)*4.5)|0;ca=256-$+1|0;ga=(W|0)<(ca|0)?ca:W;W=d+12|0;ca=f[W>>2]|0;g=f[J>>2]|0;ia=nrc(+(g|0)*4.5)|0;ba=256-g+1|0;g=(ia|0)<(ba|0)?ba:ia;ia=d+8|0;ba=f[ia>>2]|0;la=wN($+-1+((ca|0)<(ga|0)?ca:ga)|0)|0;ga=(la|0)>2?la:2;la=wN(((ba|0)<(g|0)?ba:g)+-1+(f[J>>2]|0)|0)|0;if((ga|0)<1|(la|0)<1){f[l>>2]=0;f[l+4>>2]=0;da=tT(l,28)|0;ea=255603;fa=da+28|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-211,l,255370,255380,608)}g=ga-(f[K>>2]|0)|0;ba=f[W>>2]|0;ca=(g|0)>=(ba|0)?ba:g+1|0;g=la-(f[J>>2]|0)|0;ba=f[ia>>2]|0;$=(g|0)>=(ba|0)?ba:g+1|0;g=Y(la,R)|0;f[q>>2]=1124007936;R=q+4|0;ba=q+8|0;ma=q+40|0;da=R;fa=da+36|0;do{f[da>>2]=0;da=da+4|0}while((da|0)<(fa|0));f[ma>>2]=ba;ba=q+48|0;na=q+44|0;f[na>>2]=ba;f[ba>>2]=0;f[q+52>>2]=0;oa=ka&4095;f[l>>2]=g;g=l+4|0;f[g>>2]=ga;XS(q,2,l,oa);f[r>>2]=1124007936;pa=r+4|0;qa=r+8|0;ra=r+40|0;da=pa;fa=da+36|0;do{f[da>>2]=0;da=da+4|0}while((da|0)<(fa|0));f[ra>>2]=qa;qa=r+48|0;sa=r+44|0;f[sa>>2]=qa;f[qa>>2]=0;f[r+52>>2]=0;f[l>>2]=la;f[g>>2]=ga;XS(r,2,l,oa);oa=(X|0)!=0;if((ha|0)==(ka|0)|oa^1)ta=0;else ta=Y(f[K>>2]<<(47696>>>(ha<<1)&3),f[J>>2]|0)|0;ha=(V|0)!=0;g=(H|0)==(ka|0);if(g|ha^1)ua=ta;else{va=(Y($+-1+(f[J>>2]|0)|0,ca+-1+(f[K>>2]|0)|0)|0)<<(47696>>>(H<<1)&3);ua=(ta|0)<(va|0)?va:ta}if(((I|_)&511|0)==0|(Z|0)==(ka|0))wa=ua;else{_=(Y($,ca)|0)<<(47696>>>(Z<<1)&3);wa=(ua|0)<(_|0)?_:ua}ua=f[F>>2]|0;_=f[m>>2]|0;Z=ua-_|0;I=_;_=ua;if(wa>>>0<=Z>>>0){if(wa>>>0<Z>>>0?(ua=I+wa|0,(_|0)!=(ua|0)):0)f[F>>2]=ua}else y$(m,wa-Z|0);gN(s,ga,la,f[q>>2]&7,1,1,1024,f[J>>2]|0);Z=t+4|0;wa=t+8|0;ua=t+12|0;_=t+16|0;I=t+20|0;ta=t+24|0;va=t+28|0;xa=t+32|0;ya=t+36|0;za=t+40|0;Aa=t+48|0;Ba=t+44|0;Ca=t+52|0;Da=l+4|0;Ea=l+8|0;Fa=l+12|0;Ga=l+4|0;Ha=l+8|0;Ia=l+12|0;Ja=x+4|0;Ka=w+4|0;La=x+8|0;Ma=w+8|0;Na=x+12|0;Oa=w+12|0;Pa=x+16|0;Qa=w+16|0;Ra=x+20|0;Sa=w+20|0;Ta=x+24|0;Ua=w+24|0;Va=x+28|0;Wa=w+28|0;Xa=x+32|0;Ya=w+32|0;Za=x+36|0;_a=w+36|0;$a=x+40|0;ab=x+48|0;bb=x+44|0;cb=x+52|0;db=w+44|0;eb=l+4|0;fb=v+12|0;gb=x+4|0;hb=y+4|0;ib=l+36|0;jb=l+16|0;kb=l+4|0;lb=l+40|0;mb=l+44|0;nb=l+48|0;ob=s+4|0;pb=v+16|0;qb=v+48|0;rb=w+40|0;sb=w+48|0;tb=v+36|0;ub=v+4|0;vb=v+40|0;wb=v+44|0;xb=l+8|0;yb=l+4|0;zb=0;a:while(1){Ab=Y(zb,la)|0;f[t>>2]=f[n>>2];Bb=f[G>>2]|0;f[Z>>2]=Bb;f[wa>>2]=f[J>>2];f[ua>>2]=f[K>>2];f[_>>2]=f[L>>2];f[I>>2]=f[M>>2];f[ta>>2]=f[N>>2];f[va>>2]=f[O>>2];f[xa>>2]=f[P>>2];Cb=f[Q>>2]|0;f[ya>>2]=Cb;f[za>>2]=wa;f[Ba>>2]=Aa;f[Aa>>2]=0;f[Ca>>2]=0;if(!Cb)Db=Bb;else{Bb=Cb+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1;Db=f[G>>2]|0}if((Db|0)<3){Bb=f[U>>2]|0;Cb=f[Ba>>2]|0;f[Cb>>2]=f[Bb>>2];f[Cb+4>>2]=f[Bb+4>>2]}else{f[Z>>2]=0;ZS(t,n)}f[l>>2]=0;f[Da>>2]=Ab;f[Ea>>2]=ga;f[Fa>>2]=la;cT(v,q,l);Bb=f[K>>2]|0;Cb=f[J>>2]|0;f[l>>2]=0;f[Ga>>2]=Ab;f[Ha>>2]=Bb;f[Ia>>2]=Cb;cT(w,q,l);if(oa){Cb=f[o>>2]|0;do if((Cb|0)==(ka|0)){f[x>>2]=f[w>>2];Bb=f[Ka>>2]|0;f[Ja>>2]=Bb;f[La>>2]=f[Ma>>2];f[Na>>2]=f[Oa>>2];f[Pa>>2]=f[Qa>>2];f[Ra>>2]=f[Sa>>2];f[Ta>>2]=f[Ua>>2];f[Va>>2]=f[Wa>>2];f[Xa>>2]=f[Ya>>2];Ab=f[_a>>2]|0;f[Za>>2]=Ab;f[$a>>2]=La;f[bb>>2]=ab;f[ab>>2]=0;f[cb>>2]=0;if(!Ab)Eb=Bb;else{Bb=Ab+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1;Eb=f[Ka>>2]|0}if((Eb|0)<3){Bb=f[db>>2]|0;Ab=f[bb>>2]|0;f[Ab>>2]=f[Bb>>2];f[Ab+4>>2]=f[Bb+4>>2];break}else{f[Ja>>2]=0;ZS(x,w);break}}else{Bb=f[S>>2]|0;Ab=f[Bb+4>>2]|0;Fb=f[Bb>>2]|0;Bb=f[m>>2]|0;f[x>>2]=Cb&4095|1124007936;f[Ja>>2]=2;f[La>>2]=Fb;f[Na>>2]=Ab;f[Pa>>2]=Bb;f[Ra>>2]=Bb;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;f[$a>>2]=La;f[bb>>2]=ab;f[cb>>2]=0;f[ab>>2]=0;if((Y(Fb,Ab)|0)!=0&(Bb|0)==0){Gb=54;break a}Hb=(Cb>>>3&511)+1<<(47696>>>(Cb<<1&14)&3);Ib=Y(Ab,Hb)|0;f[ab>>2]=Ib;f[cb>>2]=Hb;Hb=Bb+(Y(Fb,Ib)|0)|0;f[Va>>2]=Hb;f[Ta>>2]=Hb+(0-Ib)+Ib;WS(x)}while(0);Cb=f[Za>>2]|0;if(Cb|0){Ib=Cb+12|0;f[Ib>>2]=(f[Ib>>2]|0)+1}Ib=f[ya>>2]|0;do if(Ib|0){Cb=Ib+12|0;Hb=f[Cb>>2]|0;f[Cb>>2]=Hb+-1;if((Hb|0)!=1)break;_S(t)}while(0);f[ya>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){Ib=f[za>>2]|0;Hb=0;do{f[Ib+(Hb<<2)>>2]=0;Hb=Hb+1|0;Jb=f[Z>>2]|0}while((Hb|0)<(Jb|0));f[t>>2]=f[x>>2];if((Jb|0)<3)Gb=66;else Gb=68}else{f[t>>2]=f[x>>2];Gb=66}do if((Gb|0)==66){Gb=0;Hb=f[Ja>>2]|0;if((Hb|0)>=3){Gb=68;break}f[Z>>2]=Hb;f[wa>>2]=f[La>>2];f[ua>>2]=f[Na>>2];Hb=f[bb>>2]|0;Ib=f[Ba>>2]|0;f[Ib>>2]=f[Hb>>2];f[Ib+4>>2]=f[Hb+4>>2]}while(0);if((Gb|0)==68){Gb=0;ZS(t,x)}f[_>>2]=f[Pa>>2];f[I>>2]=f[Ra>>2];f[ta>>2]=f[Ta>>2];f[va>>2]=f[Va>>2];f[xa>>2]=f[Xa>>2];Hb=f[Za>>2]|0;f[ya>>2]=Hb;do if(Hb|0){Ib=Hb+12|0;Cb=f[Ib>>2]|0;f[Ib>>2]=Cb+-1;if((Cb|0)!=1)break;_S(x)}while(0);f[Za>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[Ja>>2]|0)>0){Hb=f[$a>>2]|0;Cb=0;do{f[Hb+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[Ja>>2]|0))}Cb=f[bb>>2]|0;if((Cb|0)!=(ab|0))g0(Cb);f[l>>2]=zb;f[eb>>2]=0;SQ(n,1,t,1,l,1)}if((f[Qa>>2]|0)!=(f[_>>2]|0)){Cb=xb;f[Cb>>2]=0;f[Cb+4>>2]=0;f[l>>2]=33619968;f[yb>>2]=w;LZ(t,l,f[w>>2]&7,1.0,0.0)}Cb=f[fb>>2]|0;Hb=f[K>>2]|0;if((Cb|0)>(Hb|0)){Ib=f[J>>2]|0;f[x>>2]=0;f[gb>>2]=Ib;f[y>>2]=Hb;f[hb>>2]=Cb;$S(l,v,x,y);f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;k_(l,x)|0;Cb=f[ib>>2]|0;do if(Cb|0){Hb=Cb+12|0;Ib=f[Hb>>2]|0;f[Hb>>2]=Ib+-1;if((Ib|0)!=1)break;_S(l)}while(0);f[ib>>2]=0;f[jb>>2]=0;f[jb+4>>2]=0;f[jb+8>>2]=0;f[jb+12>>2]=0;if((f[kb>>2]|0)>0){Cb=f[lb>>2]|0;Ib=0;do{f[Cb+(Ib<<2)>>2]=0;Ib=Ib+1|0}while((Ib|0)<(f[kb>>2]|0))}Ib=f[mb>>2]|0;if((Ib|0)!=(nb|0))g0(Ib)}Ib=f[ob>>2]|0;Cb=f[pb>>2]|0;Hb=f[qb>>2]|0;gi[f[f[Ib>>2]>>2]&255](Ib,Cb,Hb,Cb,Hb);Hb=f[_a>>2]|0;do if(Hb|0){Cb=Hb+12|0;Ib=f[Cb>>2]|0;f[Cb>>2]=Ib+-1;if((Ib|0)!=1)break;_S(w)}while(0);f[_a>>2]=0;f[Qa>>2]=0;f[Qa+4>>2]=0;f[Qa+8>>2]=0;f[Qa+12>>2]=0;if((f[Ka>>2]|0)>0){Hb=f[rb>>2]|0;Ib=0;do{f[Hb+(Ib<<2)>>2]=0;Ib=Ib+1|0}while((Ib|0)<(f[Ka>>2]|0))}Ib=f[db>>2]|0;if((Ib|0)!=(sb|0))g0(Ib);Ib=f[tb>>2]|0;do if(Ib|0){Hb=Ib+12|0;Cb=f[Hb>>2]|0;f[Hb>>2]=Cb+-1;if((Cb|0)!=1)break;_S(v)}while(0);f[tb>>2]=0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[ub>>2]|0)>0){Ib=f[vb>>2]|0;Cb=0;do{f[Ib+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[ub>>2]|0))}Cb=f[wb>>2]|0;if((Cb|0)!=(qb|0))g0(Cb);Cb=f[ya>>2]|0;do if(Cb|0){Ib=Cb+12|0;Hb=f[Ib>>2]|0;f[Ib>>2]=Hb+-1;if((Hb|0)!=1)break;_S(t)}while(0);f[ya>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){Cb=f[za>>2]|0;Hb=0;do{f[Cb+(Hb<<2)>>2]=0;Hb=Hb+1|0}while((Hb|0)<(f[Z>>2]|0))}Hb=f[Ba>>2]|0;if((Hb|0)!=(Aa|0))g0(Hb);if((zb|0)<(X|0))zb=zb+1|0;else break}if((Gb|0)==54){f[l>>2]=0;f[l+4>>2]=0;da=tT(l,28)|0;ea=271702;fa=da+28|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,l,271731,461938,608)}zb=(ca+-1+(f[W>>2]|0)|0)/(ca|0)|0;X=$+-1|0;Aa=Y((X+(f[ia>>2]|0)|0)/($|0)|0,zb)|0;Ba=f[a+40>>2]|0;Z=f[Ba>>2]|0;f[t>>2]=f[Ba+4>>2];Ba=t+4|0;f[Ba>>2]=Z;f[v>>2]=0;Z=v+4|0;f[Z>>2]=0;f[w>>2]=f[a>>2];za=w+4|0;_=f[aa>>2]|0;f[za>>2]=_;ya=w+8|0;f[ya>>2]=f[c>>2];qb=w+12|0;f[qb>>2]=f[e>>2];wb=w+16|0;f[wb>>2]=f[a+16>>2];f[w+20>>2]=f[a+20>>2];f[w+24>>2]=f[a+24>>2];f[w+28>>2]=f[a+28>>2];f[w+32>>2]=f[a+32>>2];ub=w+36|0;vb=f[a+36>>2]|0;f[ub>>2]=vb;pb=w+40|0;f[pb>>2]=ya;tb=w+48|0;sb=w+44|0;f[sb>>2]=tb;f[tb>>2]=0;f[w+52>>2]=0;if(!vb)Kb=_;else{_=vb+12|0;f[_>>2]=(f[_>>2]|0)+1;Kb=f[aa>>2]|0}if((Kb|0)<3){Kb=f[a+44>>2]|0;aa=f[sb>>2]|0;f[aa>>2]=f[Kb>>2];f[aa+4>>2]=f[Kb+4>>2]}else{f[za>>2]=0;ZS(w,a)}if(!(j&16)){jT(a,t,v);a=f[Z>>2]|0;Kb=f[v>>2]|0;kT(w,a,(f[Ba>>2]|0)-a-(f[c>>2]|0)|0,Kb,(f[t>>2]|0)-Kb-(f[e>>2]|0)|0)|0}e=j|16;gN(l,ga,la,ka,1,1,1024,X+(f[J>>2]|0)|0);X=f[l>>2]|0;j=f[l+4>>2]|0;Kb=(X|0)==0;t=X;if(Kb){Lb=l;Mb=t}else{c=t+4|0;f[c>>2]=(f[c>>2]|0)+1;Lb=l;Mb=f[l>>2]|0}do if(Mb|0){c=Mb+4|0;a=f[c>>2]|0;f[c>>2]=a+-1;if((a|0)!=1)break;Yi[f[(f[Mb>>2]|0)+8>>2]&2047](Mb)}while(0);f[Lb>>2]=0;gN(l,ga,la,ka,1,1,1027,$);Lb=f[l>>2]|0;Mb=f[l+4>>2]|0;a=(Lb|0)==0;c=Lb;if(a){Nb=l;Ob=c}else{Ba=c+4|0;f[Ba>>2]=(f[Ba>>2]|0)+1;Nb=l;Ob=f[l>>2]|0}do if(Ob|0){Ba=Ob+4|0;aa=f[Ba>>2]|0;f[Ba>>2]=aa+-1;if((aa|0)!=1)break;Yi[f[(f[Ob>>2]|0)+8>>2]&2047](Ob)}while(0);f[Nb>>2]=0;b:do if((Aa|0)>0){Nb=h+4|0;Ob=l+4|0;aa=y+4|0;Ba=l+4|0;_=l+8|0;vb=l+12|0;db=l+4|0;Ka=l+8|0;rb=l+12|0;Qa=l+4|0;_a=l+8|0;ob=l+12|0;nb=B+4|0;mb=x+4|0;kb=B+8|0;lb=x+8|0;jb=B+12|0;ib=x+12|0;hb=B+16|0;gb=x+16|0;fb=B+20|0;yb=x+20|0;xb=B+24|0;eb=x+24|0;ab=B+28|0;bb=x+28|0;Ja=B+32|0;$a=x+32|0;Pa=B+36|0;Za=x+36|0;Xa=B+40|0;xa=B+48|0;Va=B+44|0;va=B+52|0;Ta=x+44|0;ta=C+4|0;Ra=z+4|0;I=C+8|0;Na=z+8|0;ua=C+12|0;La=z+12|0;wa=C+16|0;Jb=z+16|0;cb=C+20|0;Eb=z+20|0;Ya=C+24|0;Wa=z+24|0;Ua=C+28|0;Sa=z+28|0;Oa=C+32|0;Ma=z+32|0;o=C+36|0;Ia=z+36|0;Ha=C+40|0;Ga=C+48|0;Fa=C+44|0;Ea=C+52|0;Da=z+44|0;Db=l+4|0;Ca=H|1124007936;P=47696>>>(H<<1)&3;O=1<<P;N=l+8|0;M=l+12|0;Hb=l+4|0;Cb=C+8|0;Ib=C+4|0;Fb=y+8|0;Bb=y+12|0;Ab=r+16|0;Pb=C+4|0;Qb=C+8|0;Rb=C+12|0;Sb=C+8|0;Tb=C+12|0;Ub=C+4|0;Vb=D+8|0;Wb=D+12|0;Xb=D+4|0;Yb=E+8|0;Zb=E+4|0;_b=D+4|0;$b=D+8|0;ac=D+12|0;bc=C+36|0;cc=C+4|0;dc=C+8|0;ec=C+12|0;fc=C+44|0;gc=C+16|0;hc=C+20|0;ic=C+24|0;jc=C+28|0;kc=C+32|0;lc=C+40|0;mc=C+48|0;nc=C+8|0;oc=C+4|0;pc=C+8|0;qc=C+12|0;rc=C+4|0;sc=D+8|0;tc=D+12|0;uc=D+4|0;vc=E+8|0;wc=E+4|0;xc=C+4|0;yc=C+8|0;zc=C+12|0;Ac=C+16|0;Bc=C+20|0;Cc=C+24|0;Dc=C+28|0;Ec=C+40|0;Fc=C+48|0;Gc=C+44|0;Hc=C+52|0;Ic=D+8|0;Jc=D+4|0;Kc=C+36|0;Lc=C+32|0;Mc=l+36|0;Nc=l+16|0;Oc=l+4|0;Pc=l+40|0;Qc=l+44|0;Rc=l+48|0;Sc=C+4|0;Tc=C+4|0;Uc=C+8|0;Vc=C+12|0;Wc=C+16|0;Xc=C+20|0;Yc=C+24|0;Zc=C+28|0;_c=C+40|0;$c=C+48|0;ad=C+44|0;bd=C+52|0;cd=D+8|0;dd=D+4|0;ed=C+36|0;fd=C+32|0;gd=C+8|0;hd=C+12|0;id=C+4|0;jd=D+8|0;kd=D+4|0;ld=l+8|0;md=l+12|0;nd=l+4|0;od=C+8|0;pd=C+4|0;qd=l+8|0;rd=l+4|0;sd=A+36|0;td=A+16|0;ud=A+4|0;vd=A+40|0;wd=A+44|0;xd=A+48|0;yd=z+40|0;zd=z+48|0;Ad=y+36|0;Bd=y+16|0;Cd=y+4|0;Dd=y+40|0;Ed=y+44|0;Fd=y+48|0;Gd=x+40|0;Hd=x+48|0;Id=Cc+8|0;Jd=Yc+8|0;Kd=0;c:while(1){Ld=Y((Kd|0)%(zb|0)|0,ca)|0;Md=Y((Kd|0)/(zb|0)|0,$)|0;Nd=(f[W>>2]|0)-Ld|0;Od=(Nd|0)<(ca|0)?Nd:ca;Nd=(f[ia>>2]|0)-Md|0;Pd=(Nd|0)<($|0)?Nd:$;Qd=(f[K>>2]|0)+-1+Od|0;Rd=(f[J>>2]|0)+-1+Pd|0;Sd=Ld-(f[h>>2]|0)+(f[v>>2]|0)|0;Td=Md-(f[Nb>>2]|0)+(f[Z>>2]|0)|0;Ud=(Sd|0)>0?Sd:0;Vd=(Td|0)>0?Td:0;Wd=Sd+Qd|0;Xd=f[qb>>2]|0;Yd=(Wd|0)<(Xd|0)?Wd:Xd;Xd=Td+Rd|0;Wd=f[ya>>2]|0;Zd=(Xd|0)<(Wd|0)?Xd:Wd;f[l>>2]=Vd;f[Ob>>2]=Zd;f[y>>2]=Ud;f[aa>>2]=Yd;$S(x,w,l,y);f[l>>2]=0;f[Ba>>2]=0;f[_>>2]=Qd;f[vb>>2]=Rd;cT(y,r,l);Wd=Ud-Sd|0;Sd=Vd-Td|0;Td=Yd-Ud|0;Ud=Zd-Vd|0;f[l>>2]=Wd;f[db>>2]=Sd;f[Ka>>2]=Td;f[rb>>2]=Ud;cT(z,r,l);f[l>>2]=Ld;f[Qa>>2]=Md;f[_a>>2]=Od;f[ob>>2]=Pd;cT(A,d,l);Md=(Y(Ud,Td)|0)!=0;Ld=Td<<P;Vd=Y(Ld,Ud)|0;Zd=0-Ld|0;Yd=(Td|0)<(Qd|0)|(Ud|0)<(Rd|0);Qd=($|0)<=(Nd|0);Nd=0;while(1){f[B>>2]=f[x>>2];Xd=f[mb>>2]|0;f[nb>>2]=Xd;f[kb>>2]=f[lb>>2];f[jb>>2]=f[ib>>2];f[hb>>2]=f[gb>>2];f[fb>>2]=f[yb>>2];f[xb>>2]=f[eb>>2];f[ab>>2]=f[bb>>2];f[Ja>>2]=f[$a>>2];_d=f[Za>>2]|0;f[Pa>>2]=_d;f[Xa>>2]=kb;f[Va>>2]=xa;f[xa>>2]=0;f[va>>2]=0;if(!_d)$d=Xd;else{Xd=_d+12|0;f[Xd>>2]=(f[Xd>>2]|0)+1;$d=f[mb>>2]|0}if(($d|0)<3){Xd=f[Ta>>2]|0;_d=f[Va>>2]|0;f[_d>>2]=f[Xd>>2];f[_d+4>>2]=f[Xd+4>>2]}else{f[nb>>2]=0;ZS(B,x)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;k_(r,l)|0;if(ha){do if(g){f[C>>2]=f[z>>2];Xd=f[Ra>>2]|0;f[ta>>2]=Xd;f[I>>2]=f[Na>>2];f[ua>>2]=f[La>>2];f[wa>>2]=f[Jb>>2];f[cb>>2]=f[Eb>>2];f[Ya>>2]=f[Wa>>2];f[Ua>>2]=f[Sa>>2];f[Oa>>2]=f[Ma>>2];_d=f[Ia>>2]|0;f[o>>2]=_d;f[Ha>>2]=I;f[Fa>>2]=Ga;f[Ga>>2]=0;f[Ea>>2]=0;if(!_d)ae=Xd;else{Xd=_d+12|0;f[Xd>>2]=(f[Xd>>2]|0)+1;ae=f[Ra>>2]|0}if((ae|0)<3){Xd=f[Da>>2]|0;_d=f[Fa>>2]|0;f[_d>>2]=f[Xd>>2];f[_d+4>>2]=f[Xd+4>>2];break}else{f[ta>>2]=0;ZS(C,z);break}}else{Xd=f[m>>2]|0;f[C>>2]=Ca;f[ta>>2]=2;f[I>>2]=Ud;f[ua>>2]=Td;f[wa>>2]=Xd;f[cb>>2]=Xd;f[Ya>>2]=0;f[Ya+4>>2]=0;f[Ya+8>>2]=0;f[Ya+12>>2]=0;f[Ha>>2]=I;f[Fa>>2]=Ga;f[Ea>>2]=0;f[Ga>>2]=0;if(Md&(Xd|0)==0)break c;f[Ga>>2]=Ld;f[Ea>>2]=O;_d=Xd+Vd|0;f[Ua>>2]=_d;f[Ya>>2]=_d+Zd+Ld;WS(C)}while(0);_d=f[o>>2]|0;if(_d|0){Xd=_d+12|0;f[Xd>>2]=(f[Xd>>2]|0)+1}Xd=f[Pa>>2]|0;do if(Xd|0){_d=Xd+12|0;be=f[_d>>2]|0;f[_d>>2]=be+-1;if((be|0)!=1)break;_S(B)}while(0);f[Pa>>2]=0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[nb>>2]|0)>0){Xd=f[Xa>>2]|0;be=0;do{f[Xd+(be<<2)>>2]=0;be=be+1|0;ce=f[nb>>2]|0}while((be|0)<(ce|0));f[B>>2]=f[C>>2];if((ce|0)<3)Gb=162;else Gb=164}else{f[B>>2]=f[C>>2];Gb=162}do if((Gb|0)==162){Gb=0;be=f[ta>>2]|0;if((be|0)>=3){Gb=164;break}f[nb>>2]=be;f[kb>>2]=f[I>>2];f[jb>>2]=f[ua>>2];be=f[Fa>>2]|0;Xd=f[Va>>2]|0;f[Xd>>2]=f[be>>2];f[Xd+4>>2]=f[be+4>>2]}while(0);if((Gb|0)==164){Gb=0;ZS(B,C)}f[hb>>2]=f[wa>>2];f[fb>>2]=f[cb>>2];f[xb>>2]=f[Ya>>2];f[ab>>2]=f[Ua>>2];f[Ja>>2]=f[Oa>>2];be=f[o>>2]|0;f[Pa>>2]=be;do if(be|0){Xd=be+12|0;_d=f[Xd>>2]|0;f[Xd>>2]=_d+-1;if((_d|0)!=1)break;_S(C)}while(0);f[o>>2]=0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[ta>>2]|0)>0){be=f[Ha>>2]|0;_d=0;do{f[be+(_d<<2)>>2]=0;_d=_d+1|0}while((_d|0)<(f[ta>>2]|0))}_d=f[Fa>>2]|0;if((_d|0)!=(Ga|0))g0(_d);f[l>>2]=Nd;f[Db>>2]=0;SQ(x,1,B,1,l,1)}if((f[Jb>>2]|0)!=(f[hb>>2]|0)){_d=qd;f[_d>>2]=0;f[_d+4>>2]=0;f[l>>2]=33619968;f[rd>>2]=z;LZ(B,l,f[z>>2]&7,1.0,0.0)}if(Yd){f[N>>2]=0;f[M>>2]=0;f[l>>2]=16842752;f[Hb>>2]=z;_d=Cb;f[_d>>2]=0;f[_d+4>>2]=0;f[C>>2]=33619968;f[Ib>>2]=y;_d=f[Fb>>2]|0;be=f[Na>>2]|0;Xd=f[Bb>>2]|0;de=f[La>>2]|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[D+16>>2]=0;f[D+20>>2]=0;f[D+24>>2]=0;f[D+28>>2]=0;q_(l,C,Sd,_d-Sd-be|0,Wd,Xd-Wd-de|0,e,D)}if(Qd){de=f[Ab>>2]|0;Xd=f[qa>>2]|0;gi[f[f[j>>2]>>2]&255](j,de,Xd,de,Xd)}else{f[ld>>2]=0;f[md>>2]=0;f[l>>2]=16842752;f[nd>>2]=r;Xd=od;f[Xd>>2]=0;f[Xd+4>>2]=0;f[C>>2]=33619968;f[pd>>2]=r;uN(l,C,0,Rd)}Xd=Y(Nd,la)|0;f[C>>2]=0;f[Pb>>2]=oa?Xd:0;f[Qb>>2]=ga;f[Rb>>2]=la;cT(l,q,C);f[Sb>>2]=0;f[Tb>>2]=0;f[C>>2]=16842752;f[Ub>>2]=r;f[Vb>>2]=0;f[Wb>>2]=0;f[D>>2]=16842752;f[Xb>>2]=l;Xd=Yb;f[Xd>>2]=0;f[Xd+4>>2]=0;f[E>>2]=33619968;f[Zb>>2]=r;vN(C,D,E,0,1);if(Qd){Xd=f[Ab>>2]|0;de=f[qa>>2]|0;gi[f[f[Mb>>2]>>2]&255](Mb,Xd,de,Xd,de)}else{f[gd>>2]=0;f[hd>>2]=0;f[C>>2]=16842752;f[id>>2]=r;de=jd;f[de>>2]=0;f[de+4>>2]=0;f[D>>2]=33619968;f[kd>>2]=r;uN(C,D,3,Pd)}f[D>>2]=0;f[_b>>2]=0;f[$b>>2]=Od;f[ac>>2]=Pd;cT(C,r,D);de=f[bc>>2]|0;if(de|0){Xd=de+12|0;f[Xd>>2]=(f[Xd>>2]|0)+1}Xd=f[Pa>>2]|0;do if(Xd|0){de=Xd+12|0;be=f[de>>2]|0;f[de>>2]=be+-1;if((be|0)!=1)break;_S(B)}while(0);f[Pa>>2]=0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[nb>>2]|0)>0){Xd=f[Xa>>2]|0;be=0;do{f[Xd+(be<<2)>>2]=0;be=be+1|0;ee=f[nb>>2]|0}while((be|0)<(ee|0));f[B>>2]=f[C>>2];if((ee|0)<3)Gb=194;else Gb=196}else{f[B>>2]=f[C>>2];Gb=194}do if((Gb|0)==194){Gb=0;be=f[cc>>2]|0;if((be|0)>=3){Gb=196;break}f[nb>>2]=be;f[kb>>2]=f[dc>>2];f[jb>>2]=f[ec>>2];be=f[fc>>2]|0;Xd=f[Va>>2]|0;f[Xd>>2]=f[be>>2];f[Xd+4>>2]=f[be+4>>2]}while(0);if((Gb|0)==196){Gb=0;ZS(B,C)}f[hb>>2]=f[gc>>2];f[fb>>2]=f[hc>>2];f[xb>>2]=f[ic>>2];f[ab>>2]=f[jc>>2];f[Ja>>2]=f[kc>>2];be=f[bc>>2]|0;f[Pa>>2]=be;do if(be|0){Xd=be+12|0;de=f[Xd>>2]|0;f[Xd>>2]=de+-1;if((de|0)!=1)break;_S(C)}while(0);f[bc>>2]=0;f[gc>>2]=0;f[gc+4>>2]=0;f[gc+8>>2]=0;f[gc+12>>2]=0;if((f[cc>>2]|0)>0){be=f[lc>>2]|0;de=0;do{f[be+(de<<2)>>2]=0;de=de+1|0}while((de|0)<(f[cc>>2]|0))}de=f[fc>>2]|0;if((de|0)!=(mc|0))g0(de);do if(ja){if(!Nd){de=nc;f[de>>2]=0;f[de+4>>2]=0;f[C>>2]=33619968;f[oc>>2]=A;LZ(B,C,f[p>>2]|0,1.0,i);break}de=f[p>>2]|0;if((ka|0)!=(de|0)){be=f[m>>2]|0;f[C>>2]=de&4095|1124007936;f[xc>>2]=2;f[yc>>2]=Pd;f[zc>>2]=Od;f[Ac>>2]=be;f[Bc>>2]=be;Xd=Id;f[Xd>>2]=0;f[Xd+4>>2]=0;f[Ec>>2]=yc;f[Gc>>2]=Fc;Xd=(de>>>3&511)+1<<(47696>>>(de<<1&14)&3);_d=Y(Xd,Od)|0;f[Fc>>2]=_d;f[Hc>>2]=Xd;Xd=be+(Y(_d,Pd)|0)|0;f[Dc>>2]=Xd;f[Cc>>2]=Xd+(0-_d)+_d;WS(C);_d=Ic;f[_d>>2]=0;f[_d+4>>2]=0;f[D>>2]=33619968;f[Jc>>2]=C;LZ(B,D,de,1.0,0.0);de=f[Kc>>2]|0;if(de|0){_d=de+12|0;f[_d>>2]=(f[_d>>2]|0)+1}_d=f[Pa>>2]|0;do if(_d|0){de=_d+12|0;Xd=f[de>>2]|0;f[de>>2]=Xd+-1;if((Xd|0)!=1)break;_S(B)}while(0);f[Pa>>2]=0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[nb>>2]|0)>0){_d=f[Xa>>2]|0;Xd=0;do{f[_d+(Xd<<2)>>2]=0;Xd=Xd+1|0;fe=f[nb>>2]|0}while((Xd|0)<(fe|0));f[B>>2]=f[C>>2];if((fe|0)<3)Gb=243;else Gb=245}else{f[B>>2]=f[C>>2];Gb=243}do if((Gb|0)==243){Gb=0;Xd=f[xc>>2]|0;if((Xd|0)>=3){Gb=245;break}f[nb>>2]=Xd;f[kb>>2]=f[yc>>2];f[jb>>2]=f[zc>>2];Xd=f[Gc>>2]|0;_d=f[Va>>2]|0;f[_d>>2]=f[Xd>>2];f[_d+4>>2]=f[Xd+4>>2]}while(0);if((Gb|0)==245){Gb=0;ZS(B,C)}f[hb>>2]=f[Ac>>2];f[fb>>2]=f[Bc>>2];f[xb>>2]=f[Cc>>2];f[ab>>2]=f[Dc>>2];f[Ja>>2]=f[Lc>>2];Xd=f[Kc>>2]|0;f[Pa>>2]=Xd;do if(Xd|0){_d=Xd+12|0;de=f[_d>>2]|0;f[_d>>2]=de+-1;if((de|0)!=1)break;_S(C)}while(0);f[Kc>>2]=0;f[Ac>>2]=0;f[Ac+4>>2]=0;f[Ac+8>>2]=0;f[Ac+12>>2]=0;if((f[xc>>2]|0)>0){Xd=f[Ec>>2]|0;de=0;do{f[Xd+(de<<2)>>2]=0;de=de+1|0}while((de|0)<(f[xc>>2]|0))}de=f[Gc>>2]|0;if((de|0)!=(Fc|0))g0(de)}f[pc>>2]=0;f[qc>>2]=0;f[C>>2]=16842752;f[rc>>2]=B;f[sc>>2]=0;f[tc>>2]=0;f[D>>2]=16842752;f[uc>>2]=A;de=vc;f[de>>2]=0;f[de+4>>2]=0;f[E>>2]=33619968;f[wc>>2]=A;mL(C,D,E,e0()|0,-1)}else{de=f[p>>2]|0;if((de|0)!=(ka|0)){Xd=f[m>>2]|0;f[C>>2]=de&4095|1124007936;f[Tc>>2]=2;f[Uc>>2]=Pd;f[Vc>>2]=Od;f[Wc>>2]=Xd;f[Xc>>2]=Xd;_d=Jd;f[_d>>2]=0;f[_d+4>>2]=0;f[_c>>2]=Uc;f[ad>>2]=$c;_d=(de>>>3&511)+1<<(47696>>>(de<<1&14)&3);be=Y(_d,Od)|0;f[$c>>2]=be;f[bd>>2]=_d;_d=Xd+(Y(be,Pd)|0)|0;f[Zc>>2]=_d;f[Yc>>2]=_d+(0-be)+be;WS(C);be=cd;f[be>>2]=0;f[be+4>>2]=0;f[D>>2]=33619968;f[dd>>2]=C;LZ(B,D,de,1.0,i);de=f[ed>>2]|0;if(de|0){be=de+12|0;f[be>>2]=(f[be>>2]|0)+1}be=f[Pa>>2]|0;do if(be|0){de=be+12|0;_d=f[de>>2]|0;f[de>>2]=_d+-1;if((_d|0)!=1)break;_S(B)}while(0);f[Pa>>2]=0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[nb>>2]|0)>0){be=f[Xa>>2]|0;_d=0;do{f[be+(_d<<2)>>2]=0;_d=_d+1|0;ge=f[nb>>2]|0}while((_d|0)<(ge|0));f[B>>2]=f[C>>2];if((ge|0)<3)Gb=217;else Gb=219}else{f[B>>2]=f[C>>2];Gb=217}do if((Gb|0)==217){Gb=0;_d=f[Tc>>2]|0;if((_d|0)>=3){Gb=219;break}f[nb>>2]=_d;f[kb>>2]=f[Uc>>2];f[jb>>2]=f[Vc>>2];_d=f[ad>>2]|0;be=f[Va>>2]|0;f[be>>2]=f[_d>>2];f[be+4>>2]=f[_d+4>>2]}while(0);if((Gb|0)==219){Gb=0;ZS(B,C)}f[hb>>2]=f[Wc>>2];f[fb>>2]=f[Xc>>2];f[xb>>2]=f[Yc>>2];f[ab>>2]=f[Zc>>2];f[Ja>>2]=f[fd>>2];_d=f[ed>>2]|0;f[Pa>>2]=_d;do if(_d|0){be=_d+12|0;de=f[be>>2]|0;f[be>>2]=de+-1;if((de|0)!=1)break;_S(C)}while(0);f[ed>>2]=0;f[Wc>>2]=0;f[Wc+4>>2]=0;f[Wc+8>>2]=0;f[Wc+12>>2]=0;if((f[Tc>>2]|0)>0){_d=f[_c>>2]|0;de=0;do{f[_d+(de<<2)>>2]=0;de=de+1|0}while((de|0)<(f[Tc>>2]|0))}de=f[ad>>2]|0;if((de|0)!=($c|0))g0(de)}f[C>>2]=0;f[Sc>>2]=Nd;SQ(B,1,A,1,C,1)}while(0);de=f[Mc>>2]|0;do if(de|0){_d=de+12|0;be=f[_d>>2]|0;f[_d>>2]=be+-1;if((be|0)!=1)break;_S(l)}while(0);f[Mc>>2]=0;f[Nc>>2]=0;f[Nc+4>>2]=0;f[Nc+8>>2]=0;f[Nc+12>>2]=0;if((f[Oc>>2]|0)>0){de=f[Pc>>2]|0;be=0;do{f[de+(be<<2)>>2]=0;be=be+1|0}while((be|0)<(f[Oc>>2]|0))}be=f[Qc>>2]|0;if((be|0)!=(Rc|0))g0(be);be=f[Pa>>2]|0;do if(be|0){de=be+12|0;_d=f[de>>2]|0;f[de>>2]=_d+-1;if((_d|0)!=1)break;_S(B)}while(0);f[Pa>>2]=0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[nb>>2]|0)>0){be=f[Xa>>2]|0;_d=0;do{f[be+(_d<<2)>>2]=0;_d=_d+1|0}while((_d|0)<(f[nb>>2]|0))}_d=f[Va>>2]|0;if((_d|0)!=(xa|0))g0(_d);if((Nd|0)<(V|0))Nd=Nd+1|0;else break}Nd=f[sd>>2]|0;do if(Nd|0){Pd=Nd+12|0;Od=f[Pd>>2]|0;f[Pd>>2]=Od+-1;if((Od|0)!=1)break;_S(A)}while(0);f[sd>>2]=0;f[td>>2]=0;f[td+4>>2]=0;f[td+8>>2]=0;f[td+12>>2]=0;if((f[ud>>2]|0)>0){Nd=f[vd>>2]|0;Od=0;do{f[Nd+(Od<<2)>>2]=0;Od=Od+1|0}while((Od|0)<(f[ud>>2]|0))}Od=f[wd>>2]|0;if((Od|0)!=(xd|0))g0(Od);Od=f[Ia>>2]|0;do if(Od|0){Nd=Od+12|0;Pd=f[Nd>>2]|0;f[Nd>>2]=Pd+-1;if((Pd|0)!=1)break;_S(z)}while(0);f[Ia>>2]=0;f[Jb>>2]=0;f[Jb+4>>2]=0;f[Jb+8>>2]=0;f[Jb+12>>2]=0;if((f[Ra>>2]|0)>0){Od=f[yd>>2]|0;Pd=0;do{f[Od+(Pd<<2)>>2]=0;Pd=Pd+1|0}while((Pd|0)<(f[Ra>>2]|0))}Pd=f[Da>>2]|0;if((Pd|0)!=(zd|0))g0(Pd);Pd=f[Ad>>2]|0;do if(Pd|0){Od=Pd+12|0;Nd=f[Od>>2]|0;f[Od>>2]=Nd+-1;if((Nd|0)!=1)break;_S(y)}while(0);f[Ad>>2]=0;f[Bd>>2]=0;f[Bd+4>>2]=0;f[Bd+8>>2]=0;f[Bd+12>>2]=0;if((f[Cd>>2]|0)>0){Pd=f[Dd>>2]|0;Nd=0;do{f[Pd+(Nd<<2)>>2]=0;Nd=Nd+1|0}while((Nd|0)<(f[Cd>>2]|0))}Nd=f[Ed>>2]|0;if((Nd|0)!=(Fd|0))g0(Nd);Nd=f[Za>>2]|0;do if(Nd|0){Pd=Nd+12|0;Od=f[Pd>>2]|0;f[Pd>>2]=Od+-1;if((Od|0)!=1)break;_S(x)}while(0);f[Za>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){Nd=f[Gd>>2]|0;Od=0;do{f[Nd+(Od<<2)>>2]=0;Od=Od+1|0}while((Od|0)<(f[mb>>2]|0))}Od=f[Ta>>2]|0;if((Od|0)!=(Hd|0))g0(Od);Kd=Kd+1|0;if((Kd|0)>=(Aa|0))break b}f[l>>2]=0;f[l+4>>2]=0;da=tT(l,28)|0;ea=271702;fa=da+28|0;do{b[da>>0]=b[ea>>0]|0;da=da+1|0;ea=ea+1|0}while((da|0)<(fa|0));z5(-215,l,271731,461938,579)}while(0);do if(!a){l=c+4|0;ea=f[l>>2]|0;f[l>>2]=ea+-1;if((ea|0)!=1)break;Yi[f[(f[Lb>>2]|0)+8>>2]&2047](c)}while(0);do if(!Kb){c=t+4|0;Lb=f[c>>2]|0;f[c>>2]=Lb+-1;if((Lb|0)!=1)break;Yi[f[(f[X>>2]|0)+8>>2]&2047](t)}while(0);t=f[ub>>2]|0;do if(t|0){X=t+12|0;Kb=f[X>>2]|0;f[X>>2]=Kb+-1;if((Kb|0)!=1)break;_S(w)}while(0);f[ub>>2]=0;f[wb>>2]=0;f[wb+4>>2]=0;f[wb+8>>2]=0;f[wb+12>>2]=0;if((f[za>>2]|0)>0){wb=f[pb>>2]|0;pb=0;do{f[wb+(pb<<2)>>2]=0;pb=pb+1|0}while((pb|0)<(f[za>>2]|0))}za=f[sb>>2]|0;if((za|0)!=(tb|0))g0(za);za=f[s>>2]|0;do if(za|0){s=za+4|0;tb=f[s>>2]|0;f[s>>2]=tb+-1;if((tb|0)!=1)break;Yi[f[(f[za>>2]|0)+8>>2]&2047](za)}while(0);za=r+36|0;tb=f[za>>2]|0;do if(tb|0){s=tb+12|0;sb=f[s>>2]|0;f[s>>2]=sb+-1;if((sb|0)!=1)break;_S(r)}while(0);f[za>>2]=0;za=r+16|0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[pa>>2]|0)>0){za=f[ra>>2]|0;ra=0;do{f[za+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[pa>>2]|0))}pa=f[sa>>2]|0;if((pa|0)!=(qa|0))g0(pa);pa=q+36|0;qa=f[pa>>2]|0;do if(qa|0){sa=qa+12|0;ra=f[sa>>2]|0;f[sa>>2]=ra+-1;if((ra|0)!=1)break;_S(q)}while(0);f[pa>>2]=0;pa=q+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[R>>2]|0)>0){pa=f[ma>>2]|0;ma=0;do{f[pa+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[R>>2]|0))}R=f[na>>2]|0;if((R|0)!=(ba|0))g0(R);R=f[Q>>2]|0;do if(R|0){ba=R+12|0;na=f[ba>>2]|0;f[ba>>2]=na+-1;if((na|0)!=1)break;_S(n)}while(0);f[Q>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[G>>2]|0)>0){L=f[S>>2]|0;S=0;do{f[L+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[G>>2]|0))}G=f[U>>2]|0;if((G|0)!=(T|0))g0(G);G=f[m>>2]|0;if(!G){u=k;return}if((f[F>>2]|0)!=(G|0))f[F>>2]=G;YDc(G);u=k;return}function Cfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0;h=u;u=u+2192|0;i=h+1360|0;j=h+2128|0;k=h+1328|0;l=h+1272|0;m=h+1216|0;o=h+2072|0;q=h+2016|0;r=h+1896|0;s=h+1824|0;t=h+992|0;v=h+1760|0;w=h+768|0;x=h+1704|0;y=h+544|0;z=h+512|0;A=h+480|0;B=h+256|0;C=h+32|0;D=h+1648|0;E=h+1640|0;F=h+1632|0;G=h+1624|0;H=h+1616|0;I=h;J=h+1608|0;K=h+1600|0;N=h+1592|0;O=h+1584|0;P=h+2008|0;Q=h+2e3|0;R=h+1992|0;S=h+1984|0;T=h+1976|0;U=h+1968|0;V=h+1960|0;W=h+1952|0;X=h+1888|0;Z=h+1880|0;_=h+1816|0;if(!(r$(g)|0)){$=c$(a,-1)|0;aa=$&4088;if(e>>>0>=6){f[i>>2]=0;f[i+4>>2]=0;ba=tT(i,55)|0;ca=255632;da=ba+55|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255688,255380,768)}ea=($&7|0)==0;switch($&7){case 0:case 5:break;default:{f[i>>2]=0;fa=i+4|0;f[fa>>2]=0;ga=tT(i,80)|0;ba=ga;ca=255706;da=ba+80|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255688,255380,769)}}if(($|0)!=(c$(c,-1)|0)){f[i>>2]=0;fa=i+4|0;f[fa>>2]=0;ga=tT(i,80)|0;ba=ga;ca=255706;da=ba+80|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255688,255380,769)}if((n$(a,-1)|0)>=3){f[i>>2]=0;fa=i+4|0;f[fa>>2]=0;ga=tT(i,80)|0;ba=ga;ca=255706;da=ba+80|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255688,255380,769)}do if((d$(a)|0)==65536){ga=f[a+4>>2]|0;f[l>>2]=f[ga>>2];fa=l+4|0;$=ga+4|0;f[fa>>2]=f[$>>2];ha=l+8|0;f[ha>>2]=f[ga+8>>2];f[l+12>>2]=f[ga+12>>2];f[l+16>>2]=f[ga+16>>2];f[l+20>>2]=f[ga+20>>2];f[l+24>>2]=f[ga+24>>2];f[l+28>>2]=f[ga+28>>2];f[l+32>>2]=f[ga+32>>2];ia=f[ga+36>>2]|0;f[l+36>>2]=ia;f[l+40>>2]=ha;ha=l+48|0;ja=l+44|0;f[ja>>2]=ha;f[ha>>2]=0;f[l+52>>2]=0;if(ia|0){ha=ia+12|0;f[ha>>2]=(f[ha>>2]|0)+1}if((f[$>>2]|0)<3){$=f[ga+44>>2]|0;ha=f[ja>>2]|0;f[ha>>2]=f[$>>2];f[ha+4>>2]=f[$+4>>2];break}else{f[fa>>2]=0;ZS(l,ga);break}}else a$(l,a,-1);while(0);do if((d$(c)|0)==65536){ga=f[c+4>>2]|0;f[m>>2]=f[ga>>2];fa=m+4|0;$=ga+4|0;f[fa>>2]=f[$>>2];ha=m+8|0;f[ha>>2]=f[ga+8>>2];f[m+12>>2]=f[ga+12>>2];f[m+16>>2]=f[ga+16>>2];f[m+20>>2]=f[ga+20>>2];f[m+24>>2]=f[ga+24>>2];f[m+28>>2]=f[ga+28>>2];f[m+32>>2]=f[ga+32>>2];ja=f[ga+36>>2]|0;f[m+36>>2]=ja;f[m+40>>2]=ha;ha=m+48|0;ia=m+44|0;f[ia>>2]=ha;f[ha>>2]=0;f[m+52>>2]=0;if(ja|0){ha=ja+12|0;f[ha>>2]=(f[ha>>2]|0)+1}if((f[$>>2]|0)<3){$=f[ga+44>>2]|0;ha=f[ia>>2]|0;f[ha>>2]=f[$>>2];f[ha+4>>2]=f[$+4>>2];break}else{f[fa>>2]=0;ZS(m,ga);break}}else a$(m,c,-1);while(0);do if((d$(g)|0)==65536){ga=f[g+4>>2]|0;f[o>>2]=f[ga>>2];fa=o+4|0;$=ga+4|0;f[fa>>2]=f[$>>2];ha=o+8|0;f[ha>>2]=f[ga+8>>2];f[o+12>>2]=f[ga+12>>2];f[o+16>>2]=f[ga+16>>2];f[o+20>>2]=f[ga+20>>2];f[o+24>>2]=f[ga+24>>2];f[o+28>>2]=f[ga+28>>2];f[o+32>>2]=f[ga+32>>2];ia=f[ga+36>>2]|0;f[o+36>>2]=ia;f[o+40>>2]=ha;ha=o+48|0;ja=o+44|0;f[ja>>2]=ha;f[ha>>2]=0;f[o+52>>2]=0;if(ia|0){ha=ia+12|0;f[ha>>2]=(f[ha>>2]|0)+1}if((f[$>>2]|0)<3){$=f[ga+44>>2]|0;ha=f[ja>>2]|0;f[ha>>2]=f[$>>2];f[ha+4>>2]=f[$+4>>2];break}else{f[fa>>2]=0;ZS(o,ga);break}}else a$(o,g,-1);while(0);g=f[m>>2]|0;ga=f[l>>2]&4088;if(ea){fa=i+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;LZ(l,i,aa|5,.00392156862745098,0.0)}if(!(g&7)){aa=i+8|0;f[aa>>2]=0;f[aa+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;LZ(m,i,g&4088|5,.00392156862745098,0.0)}if(ea){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[j>>2]=-1056833530;f[j+4>>2]=k;f[j+8>>2]=1;f[j+12>>2]=4;ea=q+8|0;f[ea>>2]=0;f[ea+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;uL(i,j,q,5);ea=i+8|0;f[ea>>2]=0;f[ea+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;LZ(o,i,ga|5,.00392156862745098,0.0)}ga=m+12|0;ea=(f[l+12>>2]|0)-(f[ga>>2]|0)+1|0;g=m+8|0;aa=(f[l+8>>2]|0)-(f[g>>2]|0)+1|0;f[r>>2]=ea;f[r+4>>2]=aa;v$(d,r,5,-1,0,0);do if((d$(d)|0)==65536){fa=f[d+4>>2]|0;f[q>>2]=f[fa>>2];$=q+4|0;ha=fa+4|0;f[$>>2]=f[ha>>2];ja=q+8|0;f[ja>>2]=f[fa+8>>2];f[q+12>>2]=f[fa+12>>2];f[q+16>>2]=f[fa+16>>2];f[q+20>>2]=f[fa+20>>2];f[q+24>>2]=f[fa+24>>2];f[q+28>>2]=f[fa+28>>2];f[q+32>>2]=f[fa+32>>2];ia=f[fa+36>>2]|0;f[q+36>>2]=ia;f[q+40>>2]=ja;ja=q+48|0;ka=q+44|0;f[ka>>2]=ja;f[ja>>2]=0;f[q+52>>2]=0;if(ia|0){ja=ia+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[fa+44>>2]|0;ja=f[ka>>2]|0;f[ja>>2]=f[ha>>2];f[ja+4>>2]=f[ha+4>>2];break}else{f[$>>2]=0;ZS(q,fa);break}}else a$(q,d,-1);while(0);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=l;zY(t,l,i,1.0);f[s>>2]=1124007936;fa=s+4|0;$=s+8|0;ha=s+40|0;ba=fa;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[ha>>2]=$;$=s+48|0;ja=s+44|0;f[ja>>2]=$;f[$>>2]=0;f[s+52>>2]=0;ka=f[t>>2]|0;ei[f[(f[ka>>2]|0)+12>>2]&511](ka,t,s,-1);$j(t);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;zY(w,o,i,1.0);f[v>>2]=1124007936;ka=v+4|0;ia=v+8|0;la=v+40|0;ba=ka;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[la>>2]=ia;ia=v+48|0;ma=v+44|0;f[ma>>2]=ia;f[ia>>2]=0;f[v+52>>2]=0;na=f[w>>2]|0;ei[f[(f[na>>2]|0)+12>>2]&511](na,w,v,-1);$j(w);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;zY(y,m,i,1.0);f[x>>2]=1124007936;w=x+4|0;na=x+8|0;oa=x+40|0;ba=w;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[oa>>2]=na;na=x+48|0;pa=x+44|0;f[pa>>2]=na;f[na>>2]=0;f[x+52>>2]=0;qa=f[y>>2]|0;ei[f[(f[qa>>2]|0)+12>>2]&511](qa,y,x,-1);$j(y);f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[A+16>>2]=0;f[A+20>>2]=0;f[A+24>>2]=0;f[A+28>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=x;f[j>>2]=-1040056314;f[j+4>>2]=z;f[j+8>>2]=1;f[j+12>>2]=4;f[k>>2]=-1040056314;f[k+4>>2]=A;f[k+8>>2]=1;f[k+12>>2]=4;F2(i,j,k,e0()|0);ra=+p[A>>3];sa=+p[A+8>>3];ta=+p[A+16>>3];ua=+p[A+24>>3];va=+p[z>>3];wa=+p[z+8>>3];xa=+p[z+16>>3];ya=+p[z+24>>3];za=(ra*ra+sa*sa+ta*ta+ua*ua+(va*va+wa*wa+xa*xa+ya*ya))*(+(f[g>>2]|0)*+(f[ga>>2]|0));a:do switch(e|0){case 0:{f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=v;zY(C,m,i,1.0);f[B>>2]=1124007936;ga=B+4|0;g=B+8|0;z=B+40|0;ba=ga;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[z>>2]=g;A=B+48|0;y=B+44|0;f[y>>2]=A;f[A>>2]=0;f[B+52>>2]=0;qa=f[C>>2]|0;ei[f[(f[qa>>2]|0)+12>>2]&511](qa,C,B,-1);$j(C);f[D>>2]=1124007936;qa=D+4|0;Aa=D+8|0;Ba=D+40|0;ba=qa;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[Ba>>2]=Aa;g=D+48|0;Ca=D+44|0;f[Ca>>2]=g;f[g>>2]=0;f[D+52>>2]=0;f[i>>2]=aa;f[i+4>>2]=ea;XS(D,2,i,5);Da=f[Ba>>2]|0;Ea=f[Da>>2]|0;f[E>>2]=f[Da+4>>2];f[E+4>>2]=Ea;Ea=f[D>>2]&4095;f[F>>2]=0;f[F+4>>2]=0;Bfa(l,B,D,E,Ea,F,0.0,0);Ea=f[q+40>>2]|0;Da=f[Ea>>2]|0;f[G>>2]=f[Ea+4>>2];f[G+4>>2]=Da;Da=f[q>>2]&4095;f[H>>2]=0;f[H+4>>2]=0;Bfa(s,o,q,G,Da,H,0.0,0);nY(i,D,2.0);Da=f[i>>2]|0;Ti[f[(f[Da>>2]|0)+28>>2]&511](Da,i,q);$j(i);p[I>>3]=za;Da=I+8|0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;f[Da+16>>2]=0;f[Da+20>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=q;f[j>>2]=-1056833530;f[j+4>>2]=I;f[j+8>>2]=1;f[j+12>>2]=4;Da=k+8|0;f[Da>>2]=0;f[Da+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=q;mL(i,j,k,e0()|0,-1);Da=D+36|0;Ea=f[Da>>2]|0;if(Ea|0?(Fa=Ea+12|0,Ea=f[Fa>>2]|0,f[Fa>>2]=Ea+-1,(Ea|0)==1):0)_S(D);f[Da>>2]=0;Da=D+16|0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[qa>>2]|0)>0){Da=f[Ba>>2]|0;Ea=0;do{f[Da+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[qa>>2]|0))}qa=f[Ca>>2]|0;if((qa|0)!=(g|0))g0(qa);qa=B+36|0;Ea=f[qa>>2]|0;if(Ea|0?(Da=Ea+12|0,Ea=f[Da>>2]|0,f[Da>>2]=Ea+-1,(Ea|0)==1):0)_S(B);f[qa>>2]=0;qa=B+16|0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[ga>>2]|0)>0){qa=f[z>>2]|0;Ea=0;do{f[qa+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[ga>>2]|0))}ga=f[y>>2]|0;if((ga|0)!=(A|0))g0(ga);break}case 3:{if(za<2.220446049250313e-16){p[i>>3]=1.0;p[i+8>>3]=1.0;p[i+16>>3]=1.0;p[i+24>>3]=1.0;k_(q,i)|0;break a}f[j>>2]=1124007936;ga=j+4|0;Ea=j+8|0;qa=j+40|0;ba=ga;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[qa>>2]=Ea;A=j+48|0;y=j+44|0;f[y>>2]=A;f[A>>2]=0;f[j+52>>2]=0;f[i>>2]=aa;f[i+4>>2]=ea;XS(j,2,i,5);z=f[qa>>2]|0;g=f[z>>2]|0;f[J>>2]=f[z+4>>2];f[J+4>>2]=g;g=f[j>>2]&4095;f[K>>2]=0;f[K+4>>2]=0;Bfa(s,v,j,J,g,K,0.0,0);g=f[q+40>>2]|0;z=f[g>>2]|0;f[N>>2]=f[g+4>>2];f[N+4>>2]=z;z=f[q>>2]&4095;f[O>>2]=0;f[O+4>>2]=0;Bfa(l,x,q,N,z,O,0.0,0);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=j;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;l3(i,k);qY(B,1.0,j);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=-1056571392;f[k+4>>2]=B;zY(i,q,k,1.0);z=f[i>>2]|0;ei[f[(f[z>>2]|0)+12>>2]&511](z,i,q,-1);$j(i);$j(B);ya=+M(+za);z=i+8|0;f[z>>2]=0;f[z+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;LZ(q,i,-1,1.0/ya,0.0);z=j+36|0;g=f[z>>2]|0;if(g|0?(Ca=g+12|0,g=f[Ca>>2]|0,f[Ca>>2]=g+-1,(g|0)==1):0)_S(j);f[z>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[ga>>2]|0)>0){z=f[qa>>2]|0;g=0;do{f[z+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[ga>>2]|0))}ga=f[y>>2]|0;if((ga|0)!=(A|0))g0(ga);break}default:{f[i>>2]=0;f[i+4>>2]=0;z5(-213,i,255688,255380,841)}}while(0);B=x+36|0;O=f[B>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)_S(x);f[B>>2]=0;B=x+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[w>>2]|0)>0){B=f[oa>>2]|0;oa=0;do{f[B+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[w>>2]|0))}w=f[pa>>2]|0;if((w|0)!=(na|0))g0(w);w=v+36|0;na=f[w>>2]|0;if(na|0?(pa=na+12|0,na=f[pa>>2]|0,f[pa>>2]=na+-1,(na|0)==1):0)_S(v);f[w>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[ka>>2]|0)>0){w=f[la>>2]|0;la=0;do{f[w+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[ka>>2]|0))}ka=f[ma>>2]|0;if((ka|0)!=(ia|0))g0(ka);ka=s+36|0;ia=f[ka>>2]|0;do if(ia|0){ma=ia+12|0;la=f[ma>>2]|0;f[ma>>2]=la+-1;if((la|0)!=1)break;_S(s)}while(0);f[ka>>2]=0;ka=s+16|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[fa>>2]|0)>0){ka=f[ha>>2]|0;ha=0;do{f[ka+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[fa>>2]|0))}fa=f[ja>>2]|0;if((fa|0)!=($|0))g0(fa);fa=q+36|0;$=f[fa>>2]|0;do if($|0){ja=$+12|0;ha=f[ja>>2]|0;f[ja>>2]=ha+-1;if((ha|0)!=1)break;_S(q)}while(0);f[fa>>2]=0;fa=q+16|0;$=q+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[$>>2]|0)>0){fa=f[q+40>>2]|0;ha=0;do{f[fa+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[$>>2]|0))}$=f[q+44>>2]|0;if(($|0)!=(q+48|0))g0($);$=o+36|0;ha=f[$>>2]|0;do if(ha|0){fa=ha+12|0;ja=f[fa>>2]|0;f[fa>>2]=ja+-1;if((ja|0)!=1)break;_S(o)}while(0);f[$>>2]=0;$=o+16|0;ha=o+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){$=f[o+40>>2]|0;ja=0;do{f[$+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[ha>>2]|0))}ha=f[o+44>>2]|0;if((ha|0)!=(o+48|0))g0(ha);ha=m+36|0;ja=f[ha>>2]|0;do if(ja|0){$=ja+12|0;fa=f[$>>2]|0;f[$>>2]=fa+-1;if((fa|0)!=1)break;_S(m)}while(0);f[ha>>2]=0;ha=m+16|0;ja=m+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ja>>2]|0)>0){ha=f[m+40>>2]|0;fa=0;do{f[ha+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[ja>>2]|0))}ja=f[m+44>>2]|0;if((ja|0)!=(m+48|0))g0(ja);ja=l+36|0;fa=f[ja>>2]|0;do if(fa|0){ha=fa+12|0;$=f[ha>>2]|0;f[ha>>2]=$+-1;if(($|0)!=1)break;_S(l)}while(0);f[ja>>2]=0;ja=l+16|0;fa=l+4|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[fa>>2]|0)>0){ja=f[l+40>>2]|0;$=0;do{f[ja+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[fa>>2]|0))}fa=f[l+44>>2]|0;if((fa|0)!=(l+48|0))g0(fa);u=h;return}fa=c$(a,-1)|0;$=(fa>>>3&511)+1|0;if(e>>>0>=6){f[i>>2]=0;f[i+4>>2]=0;ba=tT(i,55)|0;ca=255632;da=ba+55|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255787,255380,1106)}switch(fa&7){case 0:case 5:break;default:{f[i>>2]=0;Ga=i+4|0;f[Ga>>2]=0;Ha=tT(i,80)|0;ba=Ha;ca=255706;da=ba+80|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255787,255380,1107)}}if((fa|0)!=(c$(c,-1)|0)){f[i>>2]=0;Ga=i+4|0;f[Ga>>2]=0;Ha=tT(i,80)|0;ba=Ha;ca=255706;da=ba+80|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255787,255380,1107)}if((n$(a,-1)|0)>=3){f[i>>2]=0;Ga=i+4|0;f[Ga>>2]=0;Ha=tT(i,80)|0;ba=Ha;ca=255706;da=ba+80|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255787,255380,1107)}b$(P,a,-1);Ha=f[P+4>>2]|0;b$(Q,c,-1);if((Ha|0)>=(f[Q+4>>2]|0)?(b$(R,a,-1),Q=f[R>>2]|0,b$(S,c,-1),(Q|0)>=(f[S>>2]|0)):0)Ia=0;else{b$(T,a,-1);S=f[T+4>>2]|0;b$(U,c,-1);if((S|0)>(f[U+4>>2]|0)){f[i>>2]=0;Ja=i+4|0;f[Ja>>2]=0;Ka=tT(i,86)|0;ba=Ka;ca=255801;da=ba+86|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255787,255380,1112)}b$(V,a,-1);U=f[V>>2]|0;b$(W,c,-1);if((U|0)>(f[W>>2]|0)){f[i>>2]=0;Ja=i+4|0;f[Ja>>2]=0;Ka=tT(i,86)|0;ba=Ka;ca=255801;da=ba+86|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,i,255787,255380,1112)}else Ia=1}do if((d$(a)|0)==65536){Ka=f[a+4>>2]|0;f[r>>2]=f[Ka>>2];Ja=r+4|0;W=Ka+4|0;f[Ja>>2]=f[W>>2];U=r+8|0;f[U>>2]=f[Ka+8>>2];f[r+12>>2]=f[Ka+12>>2];f[r+16>>2]=f[Ka+16>>2];f[r+20>>2]=f[Ka+20>>2];f[r+24>>2]=f[Ka+24>>2];f[r+28>>2]=f[Ka+28>>2];f[r+32>>2]=f[Ka+32>>2];V=f[Ka+36>>2]|0;f[r+36>>2]=V;f[r+40>>2]=U;U=r+48|0;S=r+44|0;f[S>>2]=U;f[U>>2]=0;f[r+52>>2]=0;if(V|0){U=V+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[W>>2]|0)<3){W=f[Ka+44>>2]|0;U=f[S>>2]|0;f[U>>2]=f[W>>2];f[U+4>>2]=f[W+4>>2];break}else{f[Ja>>2]=0;ZS(r,Ka);break}}else a$(r,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[s>>2]=f[a>>2];Ka=s+4|0;Ja=a+4|0;f[Ka>>2]=f[Ja>>2];W=s+8|0;f[W>>2]=f[a+8>>2];f[s+12>>2]=f[a+12>>2];f[s+16>>2]=f[a+16>>2];f[s+20>>2]=f[a+20>>2];f[s+24>>2]=f[a+24>>2];f[s+28>>2]=f[a+28>>2];f[s+32>>2]=f[a+32>>2];U=f[a+36>>2]|0;f[s+36>>2]=U;f[s+40>>2]=W;W=s+48|0;S=s+44|0;f[S>>2]=W;f[W>>2]=0;f[s+52>>2]=0;if(U|0){W=U+12|0;f[W>>2]=(f[W>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[a+44>>2]|0;W=f[S>>2]|0;f[W>>2]=f[Ja>>2];f[W+4>>2]=f[Ja+4>>2];break}else{f[Ka>>2]=0;ZS(s,a);break}}else a$(s,c,-1);while(0);if(Ia){f[i>>2]=f[r>>2];Ia=i+4|0;c=r+4|0;a=f[c>>2]|0;f[Ia>>2]=a;Ka=i+8|0;Ja=r+8|0;f[Ka>>2]=f[Ja>>2];W=i+12|0;S=r+12|0;f[W>>2]=f[S>>2];U=i+16|0;V=r+16|0;f[U>>2]=f[V>>2];T=i+20|0;Q=r+20|0;f[T>>2]=f[Q>>2];R=i+24|0;Ha=r+24|0;f[R>>2]=f[Ha>>2];P=i+28|0;Ga=r+28|0;f[P>>2]=f[Ga>>2];fa=i+32|0;ja=r+32|0;f[fa>>2]=f[ja>>2];ha=i+36|0;ka=r+36|0;ia=f[ka>>2]|0;f[ha>>2]=ia;la=i+40|0;f[la>>2]=Ka;ma=i+48|0;w=i+44|0;f[w>>2]=ma;f[ma>>2]=0;f[i+52>>2]=0;if(!ia)La=a;else{a=ia+12|0;f[a>>2]=(f[a>>2]|0)+1;La=f[c>>2]|0}if((La|0)<3){La=f[r+44>>2]|0;a=f[w>>2]|0;f[a>>2]=f[La>>2];f[a+4>>2]=f[La+4>>2]}else{f[Ia>>2]=0;ZS(i,r)}La=s+36|0;a=f[La>>2]|0;if(a|0){ia=a+12|0;f[ia>>2]=(f[ia>>2]|0)+1}ia=f[ka>>2]|0;if(ia|0?(a=ia+12|0,ia=f[a>>2]|0,f[a>>2]=ia+-1,(ia|0)==1):0)_S(r);f[ka>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[c>>2]|0)>0){ia=f[r+40>>2]|0;a=0;do{f[ia+(a<<2)>>2]=0;a=a+1|0;Ma=f[c>>2]|0}while((a|0)<(Ma|0));f[r>>2]=f[s>>2];if((Ma|0)<3)Na=171;else Na=173}else{f[r>>2]=f[s>>2];Na=171}if((Na|0)==171){Ma=f[s+4>>2]|0;if((Ma|0)<3){f[c>>2]=Ma;f[Ja>>2]=f[s+8>>2];f[S>>2]=f[s+12>>2];Ma=f[s+44>>2]|0;c=f[r+44>>2]|0;f[c>>2]=f[Ma>>2];f[c+4>>2]=f[Ma+4>>2]}else Na=173}if((Na|0)==173)ZS(r,s);Ma=s+16|0;f[V>>2]=f[Ma>>2];V=s+20|0;f[Q>>2]=f[V>>2];Q=s+24|0;f[Ha>>2]=f[Q>>2];Ha=s+28|0;f[Ga>>2]=f[Ha>>2];Ga=s+32|0;f[ja>>2]=f[Ga>>2];ja=f[La>>2]|0;f[ka>>2]=ja;ka=f[ha>>2]|0;if(!ka)Oa=ja;else{ja=ka+12|0;f[ja>>2]=(f[ja>>2]|0)+1;Oa=f[La>>2]|0}if(Oa|0?(ja=Oa+12|0,Oa=f[ja>>2]|0,f[ja>>2]=Oa+-1,(Oa|0)==1):0)_S(s);f[La>>2]=0;Oa=s+4|0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[Ma+8>>2]=0;f[Ma+12>>2]=0;if((f[Oa>>2]|0)>0){ja=f[s+40>>2]|0;ka=0;do{f[ja+(ka<<2)>>2]=0;ka=ka+1|0;Pa=f[Oa>>2]|0}while((ka|0)<(Pa|0));f[s>>2]=f[i>>2];if((Pa|0)<3)Na=184;else Na=186}else{f[s>>2]=f[i>>2];Na=184}if((Na|0)==184){Pa=f[Ia>>2]|0;if((Pa|0)<3){f[Oa>>2]=Pa;f[s+8>>2]=f[Ka>>2];f[s+12>>2]=f[W>>2];W=f[w>>2]|0;Ka=f[s+44>>2]|0;f[Ka>>2]=f[W>>2];f[Ka+4>>2]=f[W+4>>2]}else Na=186}if((Na|0)==186)ZS(s,i);f[Ma>>2]=f[U>>2];f[V>>2]=f[T>>2];f[Q>>2]=f[R>>2];f[Ha>>2]=f[P>>2];f[Ga>>2]=f[fa>>2];fa=f[ha>>2]|0;f[La>>2]=fa;if(fa|0?(La=fa+12|0,fa=f[La>>2]|0,f[La>>2]=fa+-1,(fa|0)==1):0)_S(i);f[ha>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[Ia>>2]|0)>0){U=f[la>>2]|0;la=0;do{f[U+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Ia>>2]|0))}Ia=f[w>>2]|0;if((Ia|0)!=(ma|0))g0(Ia);Qa=Ja;Ra=S}else{Qa=r+8|0;Ra=r+12|0}S=s+12|0;Ja=s+8|0;Ia=(f[Qa>>2]|0)+1-(f[Ja>>2]|0)|0;f[X>>2]=(f[Ra>>2]|0)+1-(f[S>>2]|0);f[X+4>>2]=Ia;v$(d,X,5,-1,0,0);do if((d$(d)|0)==65536){X=f[d+4>>2]|0;f[t>>2]=f[X>>2];Ia=t+4|0;Ra=X+4|0;f[Ia>>2]=f[Ra>>2];Qa=t+8|0;f[Qa>>2]=f[X+8>>2];f[t+12>>2]=f[X+12>>2];f[t+16>>2]=f[X+16>>2];f[t+20>>2]=f[X+20>>2];f[t+24>>2]=f[X+24>>2];f[t+28>>2]=f[X+28>>2];f[t+32>>2]=f[X+32>>2];ma=f[X+36>>2]|0;f[t+36>>2]=ma;w=t+40|0;f[w>>2]=Qa;Qa=t+48|0;la=t+44|0;f[la>>2]=Qa;f[Qa>>2]=0;f[t+52>>2]=0;if(ma|0){Qa=ma+12|0;f[Qa>>2]=(f[Qa>>2]|0)+1}if((f[Ra>>2]|0)<3){Ra=f[X+44>>2]|0;Qa=f[la>>2]|0;f[Qa>>2]=f[Ra>>2];f[Qa+4>>2]=f[Ra+4>>2];Sa=w;Ta=t;break}else{f[Ia>>2]=0;ZS(t,X);Sa=w;Ta=t;break}}else{a$(t,d,-1);Sa=t+40|0;Ta=t}while(0);d=f[Sa>>2]|0;w=f[d>>2]|0;f[Z>>2]=f[d+4>>2];f[Z+4>>2]=w;w=f[Ta>>2]&4095;f[_>>2]=0;f[_+4>>2]=0;Bfa(r,s,t,Z,w,_,0.0,0);switch(e|0){case 2:break;case 3:{Ua=0;Na=205;break}default:{Ua=(e|1|0)==5?1:2;Na=205}}if((Na|0)==205){_=(e|0)==5;za=1.0/(+(f[Ja>>2]|0)*+(f[S>>2]|0));f[i>>2]=1124007936;w=i+4|0;Z=i+8|0;Ta=i+40|0;ba=w;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[Ta>>2]=Z;Z=i+48|0;d=i+44|0;f[d>>2]=Z;f[Z>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;X=j+4|0;Ia=j+8|0;Ra=j+40|0;ba=X;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[Ra>>2]=Ia;Ia=j+48|0;Qa=j+44|0;f[Qa>>2]=Ia;f[Ia>>2]=0;f[j+52>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;do if((e|0)!=4){f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=r;la=o+8|0;f[la>>2]=0;f[la+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;la=q+8|0;f[la>>2]=0;f[la+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;kqa(m,o,q,6,-1);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;f[o>>2]=-1040056314;f[o+4>>2]=k;f[o+8>>2]=1;f[o+12>>2]=4;f[q>>2]=-1040056314;f[q+4>>2]=l;f[q+8>>2]=1;f[q+12>>2]=4;F2(m,o,q,e0()|0);ya=+p[l>>3];xa=+p[l+8>>3];wa=+p[l+16>>3];va=+p[l+24>>3];ua=ya*ya+xa*xa+wa*wa+va*va;if(_&ua<2.220446049250313e-16){p[m>>3]=1.0;p[m+8>>3]=1.0;p[m+16>>3]=1.0;p[m+24>>3]=1.0;k_(t,m)|0;break}va=+p[k>>3];wa=+p[k+8>>3];xa=+p[k+16>>3];ya=+p[k+24>>3];ta=ua+va*va+wa*wa+xa*xa+ya*ya;if((Ua|0)==1)Va=ua;else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Va=ta}la=f[j+16>>2]|0;if(!la){f[m>>2]=0;f[m+4>>2]=0;ba=tT(m,18)|0;ca=255888;da=ba+18|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,m,255907,255380,892)}else{ua=+M(+Va)/+M(+za);A=Y(f[S>>2]|0,$)|0;y=la+(Y(f[Ia>>2]|0,f[Ja>>2]|0)|0)|0;Wa=la;Xa=la+(A<<3)|0;Ya=y;Za=y+(A<<3)|0;_a=ta/za;$a=ua;Na=214;break}}else{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=r;A=o+8|0;f[A>>2]=0;f[A+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;jqa(m,o,6);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;D2(m,o,e0()|0);f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];f[k+12>>2]=f[m+12>>2];f[k+16>>2]=f[m+16>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];Wa=0;Xa=0;Ya=0;Za=0;_a=0.0;$a=0.0;Na=214}while(0);if((Na|0)==214){Na=f[i+16>>2]|0;if(!Na){f[m>>2]=0;f[m+4>>2]=0;ba=tT(m,16)|0;ca=255928;da=ba+16|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));z5(-215,m,255907,255380,899)}m=Y(f[S>>2]|0,$)|0;S=Na+(m<<3)|0;ca=f[Z>>2]|0;ba=Na+(Y(ca,f[Ja>>2]|0)|0)|0;Ja=ba+(m<<3)|0;m=ca>>>3;ca=(f[j+16>>2]|0)==0?0:(f[Ia>>2]|0)>>>3;da=f[t+8>>2]|0;if((da|0)>0){o=f[t+16>>2]|0;_=f[f[t+44>>2]>>2]|0;l=f[t+12>>2]|0;q=(l|0)>0;Va=+((e|0)==1&1);A=Ua&255;Ua=0;do{y=o+(Y(Ua,_)|0)|0;ma=Y(Ua,ca)|0;b:do if(q)switch(A&3){case 1:{U=ma;ha=Y(Ua,m)|0;fa=0;while(1){La=y+(fa<<2)|0;ua=0.0;ya=+n[La>>2];Ga=0;do{P=Ga+ha|0;xa=+p[Na+(P<<3)>>3]-+p[S+(P<<3)>>3]-+p[ba+(P<<3)>>3]+ +p[Ja+(P<<3)>>3];ua=ua+xa*xa;ya=ya-xa*+p[k+(Ga<<3)>>3];Ga=Ga+1|0}while((Ga|0)!=($|0));xa=za*ua;switch(e|0){case 1:case 3:case 5:{wa=0.0;Ga=0;while(1){P=Ga+U|0;va=wa+(+p[Wa+(P<<3)>>3]-+p[Xa+(P<<3)>>3]-+p[Ya+(P<<3)>>3]+ +p[Za+(P<<3)>>3]);Ga=Ga+1|0;if((Ga|0)==($|0)){ab=va;break}else wa=va}break}default:ab=0.0}c:do switch(e|0){case 1:case 3:case 5:{wa=ab-xa;ua=wa<0.0?0.0:wa;wa=ab*1.1920928955078125e-06;if(!(ua<=(wa<.5?wa:.5)))bb=$a*+M(+ua);else bb=0.0;ua=+L(+ya);if(ua<bb){cb=ya/bb;break c}if(!(ua<bb*1.125)){cb=Va;break c}cb=ya>0.0?1.0:-1.0;break}default:cb=ya}while(0);n[La>>2]=cb;fa=fa+1|0;if((fa|0)==(l|0))break b;else{U=U+$|0;ha=ha+$|0}}break}case 2:{ha=ma;U=0;while(1){fa=y+(U<<2)|0;ya=+n[fa>>2];xa=0.0;Ga=0;do{P=Ga+ha|0;xa=xa+(+p[Wa+(P<<3)>>3]-+p[Xa+(P<<3)>>3]-+p[Ya+(P<<3)>>3]+ +p[Za+(P<<3)>>3]);Ga=Ga+1|0}while((Ga|0)!=($|0));ua=_a+(xa-ya*2.0);wa=ua<0.0?0.0:ua;d:do switch(e|0){case 1:case 3:case 5:{ua=xa<0.0?0.0:xa;va=xa*1.1920928955078125e-06;if(!(ua<=(va<.5?va:.5)))db=$a*+M(+ua);else db=0.0;ua=+L(+wa);if(ua<db){eb=wa/db;break d}if(!(ua<db*1.125)){eb=Va;break d}eb=wa>0.0?1.0:-1.0;break}default:eb=wa}while(0);n[fa>>2]=eb;U=U+1|0;if((U|0)==(l|0))break b;else ha=ha+$|0}break}default:{ha=ma;U=0;while(1){Ga=y+(U<<2)|0;wa=+n[Ga>>2];xa=wa;switch(e|0){case 1:case 3:case 5:{ya=0.0;La=0;while(1){P=La+ha|0;ua=ya+(+p[Wa+(P<<3)>>3]-+p[Xa+(P<<3)>>3]-+p[Ya+(P<<3)>>3]+ +p[Za+(P<<3)>>3]);La=La+1|0;if((La|0)==($|0)){fb=ua;break}else ya=ua}break}default:fb=0.0}e:do switch(e|0){case 1:case 3:case 5:{ya=fb<0.0?0.0:fb;ua=fb*1.1920928955078125e-06;if(!(ya<=(ua<.5?ua:.5)))gb=$a*+M(+ya);else gb=0.0;ya=+L(+wa);if(ya<gb){hb=xa/gb;break e}if(!(ya<gb*1.125)){hb=Va;break e}hb=wa>0.0?1.0:-1.0;break}default:hb=xa}while(0);n[Ga>>2]=hb;U=U+1|0;if((U|0)==(l|0))break b;else ha=ha+$|0}}}while(0);Ua=Ua+1|0}while((Ua|0)!=(da|0))}}da=j+36|0;Ua=f[da>>2]|0;if(Ua|0?($=Ua+12|0,Ua=f[$>>2]|0,f[$>>2]=Ua+-1,(Ua|0)==1):0)_S(j);f[da>>2]=0;da=j+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[X>>2]|0)>0){da=f[Ra>>2]|0;Ra=0;do{f[da+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[X>>2]|0))}X=f[Qa>>2]|0;if((X|0)!=(Ia|0))g0(X);X=i+36|0;Ia=f[X>>2]|0;if(Ia|0?(Qa=Ia+12|0,Ia=f[Qa>>2]|0,f[Qa>>2]=Ia+-1,(Ia|0)==1):0)_S(i);f[X>>2]=0;X=i+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[w>>2]|0)>0){X=f[Ta>>2]|0;Ta=0;do{f[X+(Ta<<2)>>2]=0;Ta=Ta+1|0}while((Ta|0)<(f[w>>2]|0))}w=f[d>>2]|0;if((w|0)!=(Z|0))g0(w)}w=t+36|0;Z=f[w>>2]|0;if(Z|0?(d=Z+12|0,Z=f[d>>2]|0,f[d>>2]=Z+-1,(Z|0)==1):0)_S(t);f[w>>2]=0;w=t+16|0;Z=t+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[Z>>2]|0)>0){w=f[Sa>>2]|0;Sa=0;do{f[w+(Sa<<2)>>2]=0;Sa=Sa+1|0}while((Sa|0)<(f[Z>>2]|0))}Z=f[t+44>>2]|0;if((Z|0)!=(t+48|0))g0(Z);Z=s+36|0;t=f[Z>>2]|0;if(t|0?(Sa=t+12|0,t=f[Sa>>2]|0,f[Sa>>2]=t+-1,(t|0)==1):0)_S(s);f[Z>>2]=0;Z=s+16|0;t=s+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[t>>2]|0)>0){Z=f[s+40>>2]|0;Sa=0;do{f[Z+(Sa<<2)>>2]=0;Sa=Sa+1|0}while((Sa|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))g0(t);t=r+36|0;s=f[t>>2]|0;if(s|0?(Sa=s+12|0,s=f[Sa>>2]|0,f[Sa>>2]=s+-1,(s|0)==1):0)_S(r);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;Sa=0;do{f[t+(Sa<<2)>>2]=0;Sa=Sa+1|0}while((Sa|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))g0(s);u=h;return}function Dfa(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0;g=u;u=u+16|0;h=g;if((c|0)<=0){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,5)|0;b[i>>0]=b[466053]|0;b[i+1>>0]=b[466054]|0;b[i+2>>0]=b[466055]|0;b[i+3>>0]=b[466056]|0;b[i+4>>0]=b[466057]|0;Efa(-215,h,255945,63)}i=d<=0.0&((c|0)<8&(c&1|0)!=0)?47948+((c>>>1)*28|0)|0:0;j=(e|0)==5;if((e+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,34)|0;l=270520;m=k+34|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));Efa(-215,h,255945,76)}f[a>>2]=1124007936;l=a+8|0;o=a+40|0;k=a+4|0;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[o>>2]=l;l=a+48|0;f[a+44>>2]=l;f[l>>2]=0;f[a+52>>2]=0;f[h>>2]=c;f[h+4>>2]=1;XS(a,2,h,e&4095);e=f[a+16>>2]|0;q=+(c+-1|0)*.5;r=d>0.0?d:(q+-1.0)*.3+.8;d=-.5/(r*r);if(i)if(j){a=0;r=0.0;while(1){s=+n[i+(a<<2)>>2];n[e+(a<<2)>>2]=s;t=r+s;a=a+1|0;if((a|0)==(c|0)){v=t;break}else r=t}}else{a=0;r=0.0;while(1){t=+n[i+(a<<2)>>2];p[e+(a<<3)>>3]=t;s=r+t;a=a+1|0;if((a|0)==(c|0)){v=s;break}else r=s}}else{a=0;r=0.0;while(1){s=+(a|0)-q;t=+V(+(s*(d*s)));if(j){s=t;n[e+(a<<2)>>2]=s;w=s}else{p[e+(a<<3)>>3]=t;w=t}t=r+w;a=a+1|0;if((a|0)==(c|0)){v=t;break}else r=t}}r=1.0/v;if(j){j=0;do{a=e+(j<<2)|0;n[a>>2]=r*+n[a>>2];j=j+1|0}while((j|0)!=(c|0));u=g;return}else{j=0;do{a=e+(j<<3)|0;p[a>>3]=r*+p[a>>3];j=j+1|0}while((j|0)!=(c|0));u=g;return}}function Efa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,255963,d);return}function Ffa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;i=u;u=u+64|0;j=i;k=d&7;l=!(h<=0.0)?h:g;d=f[e>>2]|0;if(g>0.0&(d|0)<1){m=nrc(((k|0)==0?3.0:4.0)*g*2.0+1.0)|0|1;f[e>>2]=m;n=m}else n=d;d=e+4|0;m=f[d>>2]|0;if(l>0.0&(m|0)<1){o=nrc(((k|0)==0?3.0:4.0)*l*2.0+1.0)|0|1;f[d>>2]=o;p=o}else p=m;if(!((n|0)>0&((n|0)%2|0|0)==1)){f[j>>2]=0;q=j+4|0;f[q>>2]=0;r=tT(j,84)|0;s=r;t=256031;v=s+84|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));Efa(-215,j,256116,2140)}if(!((p|0)>0&((p|0)%2|0|0)==1)){f[j>>2]=0;q=j+4|0;f[q>>2]=0;r=tT(j,84)|0;s=r;t=256031;v=s+84|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));Efa(-215,j,256116,2140)}h=g<0.0?0.0:g;g=l<0.0?0.0:l;t=k>>>0>5?k:5;Dfa(j,n,h,t);if((j|0)==(a|0)){w=j+36|0;x=f[a+36>>2]|0}else{n=j+36|0;k=f[n>>2]|0;if(k|0){s=k+12|0;f[s>>2]=(f[s>>2]|0)+1}s=a+36|0;k=f[s>>2]|0;if(k|0?(v=k+12|0,k=f[v>>2]|0,f[v>>2]=k+-1,(k|0)==1):0)_S(a);f[s>>2]=0;k=a+16|0;v=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[v>>2]|0)>0){r=f[a+40>>2]|0;q=0;do{f[r+(q<<2)>>2]=0;q=q+1|0;y=f[v>>2]|0}while((q|0)<(y|0));f[a>>2]=f[j>>2];if((y|0)<3)z=20;else z=22}else{f[a>>2]=f[j>>2];z=20}if((z|0)==20){y=f[j+4>>2]|0;if((y|0)<3){f[v>>2]=y;f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];y=f[j+44>>2]|0;v=f[a+44>>2]|0;f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2]}else z=22}if((z|0)==22)ZS(a,j);f[k>>2]=f[j+16>>2];f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];k=f[n>>2]|0;f[s>>2]=k;w=n;x=k}if(x|0?(k=x+12|0,x=f[k>>2]|0,f[k>>2]=x+-1,(x|0)==1):0)_S(j);f[w>>2]=0;w=j+16|0;x=j+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[j+40>>2]|0;k=0;do{f[w+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))g0(x);x=f[d>>2]|0;if((x|0)==(f[e>>2]|0)?+L(+(h-g))<2.220446049250313e-16:0){if((c|0)==(a|0)){u=i;return}e=a+36|0;d=f[e>>2]|0;if(d|0){k=d+12|0;f[k>>2]=(f[k>>2]|0)+1}k=c+36|0;d=f[k>>2]|0;if(d|0?(w=d+12|0,d=f[w>>2]|0,f[w>>2]=d+-1,(d|0)==1):0)_S(c);f[k>>2]=0;d=c+16|0;w=c+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[w>>2]|0)>0){n=f[c+40>>2]|0;s=0;do{f[n+(s<<2)>>2]=0;s=s+1|0;A=f[w>>2]|0}while((s|0)<(A|0));f[c>>2]=f[a>>2];if((A|0)<3)z=45;else z=47}else{f[c>>2]=f[a>>2];z=45}if((z|0)==45){A=f[a+4>>2]|0;if((A|0)<3){f[w>>2]=A;f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];A=f[a+44>>2]|0;w=f[c+44>>2]|0;f[w>>2]=f[A>>2];f[w+4>>2]=f[A+4>>2]}else z=47}if((z|0)==47)ZS(c,a);f[d>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];f[k>>2]=f[e>>2];u=i;return}Dfa(j,x,g,t);if((j|0)==(c|0)){B=j+36|0;C=f[c+36>>2]|0}else{t=j+36|0;x=f[t>>2]|0;if(x|0){e=x+12|0;f[e>>2]=(f[e>>2]|0)+1}e=c+36|0;x=f[e>>2]|0;if(x|0?(k=x+12|0,x=f[k>>2]|0,f[k>>2]=x+-1,(x|0)==1):0)_S(c);f[e>>2]=0;x=c+16|0;k=c+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){a=f[c+40>>2]|0;d=0;do{f[a+(d<<2)>>2]=0;d=d+1|0;D=f[k>>2]|0}while((d|0)<(D|0));f[c>>2]=f[j>>2];if((D|0)<3)z=61;else z=63}else{f[c>>2]=f[j>>2];z=61}if((z|0)==61){D=f[j+4>>2]|0;if((D|0)<3){f[k>>2]=D;f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];D=f[j+44>>2]|0;k=f[c+44>>2]|0;f[k>>2]=f[D>>2];f[k+4>>2]=f[D+4>>2]}else z=63}if((z|0)==63)ZS(c,j);f[x>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[c+28>>2]=f[j+28>>2];f[c+32>>2]=f[j+32>>2];c=f[t>>2]|0;f[e>>2]=c;B=t;C=c}if(C|0?(c=C+12|0,C=f[c>>2]|0,f[c>>2]=C+-1,(C|0)==1):0)_S(j);f[B>>2]=0;B=j+16|0;C=j+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){B=f[j+40>>2]|0;c=0;do{f[B+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[C>>2]|0))}C=f[j+44>>2]|0;if((C|0)!=(j+48|0))g0(C);u=i;return}function Gfa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;j=u;u=u+528|0;k=j+464|0;l=j+448|0;m=j+456|0;n=j+336|0;o=j+392|0;p=j+280|0;q=j+224|0;r=j+168|0;s=j+160|0;t=j+152|0;v=j+64|0;w=j+136|0;x=j+120|0;y=j+8|0;z=j;A=c$(a,-1)|0;b$(l,a,-1);f[m>>2]=f[l>>2];B=l+4|0;f[m+4>>2]=f[B>>2];v$(c,m,A,-1,0,0);m=i&-17;a:do if(m|0){do if(!(i&16)){do if((d$(a)|0)==65536){C=f[a+4>>2]|0;f[n>>2]=f[C>>2];D=n+4|0;E=C+4|0;f[D>>2]=f[E>>2];F=n+8|0;f[F>>2]=f[C+8>>2];f[n+12>>2]=f[C+12>>2];f[n+16>>2]=f[C+16>>2];f[n+20>>2]=f[C+20>>2];f[n+24>>2]=f[C+24>>2];f[n+28>>2]=f[C+28>>2];f[n+32>>2]=f[C+32>>2];G=n+36|0;H=f[C+36>>2]|0;f[G>>2]=H;f[n+40>>2]=F;F=n+48|0;I=n+44|0;f[I>>2]=F;f[F>>2]=0;f[n+52>>2]=0;if(H|0){F=H+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;F=f[I>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];J=G;K=n;break}else{f[D>>2]=0;ZS(n,C);J=G;K=n;break}}else{a$(n,a,-1);J=n+36|0;K=n}while(0);G=(f[K>>2]&32768|0)==0;C=f[J>>2]|0;if(C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)_S(n);f[J>>2]=0;C=n+16|0;D=n+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[D>>2]|0)>0){C=f[n+40>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[D>>2]|0))}D=f[n+44>>2]|0;if((D|0)==(n+48|0))if(G)break;else break a;else{g0(D);if(G)break;else break a}}while(0);if((f[B>>2]|0)==1)f[e+4>>2]=1;if((f[l>>2]|0)==1)f[e>>2]=1}while(0);if((f[e>>2]|0)==1?(f[e+4>>2]|0)==1:0){t$(a,c);u=j;return}l=A&7;f[o>>2]=1124007936;B=o+4|0;n=o+8|0;J=o+40|0;K=B;D=K+36|0;do{f[K>>2]=0;K=K+4|0}while((K|0)<(D|0));f[J>>2]=n;n=o+48|0;E=o+44|0;f[E>>2]=n;f[n>>2]=0;f[o+52>>2]=0;f[p>>2]=1124007936;C=p+4|0;F=p+8|0;I=p+40|0;K=C;D=K+36|0;do{f[K>>2]=0;K=K+4|0}while((K|0)<(D|0));f[I>>2]=F;F=p+48|0;H=p+44|0;f[H>>2]=F;f[F>>2]=0;f[p+52>>2]=0;Ffa(o,p,A,e,g,h);do if((d$(a)|0)==65536){A=f[a+4>>2]|0;f[q>>2]=f[A>>2];M=q+4|0;N=A+4|0;f[M>>2]=f[N>>2];O=q+8|0;f[O>>2]=f[A+8>>2];f[q+12>>2]=f[A+12>>2];f[q+16>>2]=f[A+16>>2];f[q+20>>2]=f[A+20>>2];f[q+24>>2]=f[A+24>>2];f[q+28>>2]=f[A+28>>2];f[q+32>>2]=f[A+32>>2];P=f[A+36>>2]|0;f[q+36>>2]=P;f[q+40>>2]=O;O=q+48|0;Q=q+44|0;f[Q>>2]=O;f[O>>2]=0;f[q+52>>2]=0;if(P|0){O=P+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[N>>2]|0)<3){N=f[A+44>>2]|0;O=f[Q>>2]|0;f[O>>2]=f[N>>2];f[O+4>>2]=f[N+4>>2];break}else{f[M>>2]=0;ZS(q,A);break}}else a$(q,a,-1);while(0);do if((d$(c)|0)==65536){A=f[c+4>>2]|0;f[r>>2]=f[A>>2];M=r+4|0;N=A+4|0;f[M>>2]=f[N>>2];O=r+8|0;f[O>>2]=f[A+8>>2];f[r+12>>2]=f[A+12>>2];f[r+16>>2]=f[A+16>>2];f[r+20>>2]=f[A+20>>2];f[r+24>>2]=f[A+24>>2];f[r+28>>2]=f[A+28>>2];f[r+32>>2]=f[A+32>>2];Q=f[A+36>>2]|0;f[r+36>>2]=Q;f[r+40>>2]=O;O=r+48|0;P=r+44|0;f[P>>2]=O;f[O>>2]=0;f[r+52>>2]=0;if(Q|0){O=Q+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[N>>2]|0)<3){N=f[A+44>>2]|0;O=f[P>>2]|0;f[O>>2]=f[N>>2];f[O+4>>2]=f[N+4>>2];break}else{f[M>>2]=0;ZS(r,A);break}}else a$(r,c,-1);while(0);f[s>>2]=0;f[s+4>>2]=0;c=q+12|0;A=q+8|0;M=f[A>>2]|0;f[t>>2]=f[c>>2];f[t+4>>2]=M;M=(i&16|0)!=0;if(!M)jT(q,t,s);s=q+16|0;t=q+44|0;N=r+16|0;O=r+44|0;P=e+4|0;Q=(l|0)==0;if(!(M|Q^1)){do if((d$(a)|0)==65536){M=f[a+4>>2]|0;f[v>>2]=f[M>>2];R=v+4|0;S=M+4|0;f[R>>2]=f[S>>2];T=v+8|0;f[T>>2]=f[M+8>>2];f[v+12>>2]=f[M+12>>2];f[v+16>>2]=f[M+16>>2];f[v+20>>2]=f[M+20>>2];f[v+24>>2]=f[M+24>>2];f[v+28>>2]=f[M+28>>2];f[v+32>>2]=f[M+32>>2];U=v+36|0;V=f[M+36>>2]|0;f[U>>2]=V;f[v+40>>2]=T;T=v+48|0;W=v+44|0;f[W>>2]=T;f[T>>2]=0;f[v+52>>2]=0;if(V|0){T=V+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[M+44>>2]|0;T=f[W>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];X=v;Y=U;break}else{f[R>>2]=0;ZS(v,M);X=v;Y=U;break}}else{a$(v,a,-1);X=v;Y=v+36|0}while(0);a=(f[X>>2]&32768|0)==0;X=f[Y>>2]|0;if(X|0?(U=X+12|0,X=f[U>>2]|0,f[U>>2]=X+-1,(X|0)==1):0)_S(v);f[Y>>2]=0;Y=v+16|0;X=v+4|0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[X>>2]|0)>0){Y=f[v+40>>2]|0;U=0;do{f[Y+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[X>>2]|0))}X=f[v+44>>2]|0;if((X|0)==(v+48|0))Z=a;else{g0(X);Z=a}}else Z=Q;if(Z){f[w>>2]=0;Z=w+4|0;f[Z>>2]=0;f[w+8>>2]=0;f[x>>2]=0;a=x+4|0;f[a>>2]=0;f[x+8>>2]=0;_=!(h<=0.0)?h:g;X=f[e>>2]|0;if(g>0.0&(X|0)<1){v=nrc((Q?3.0:4.0)*g*2.0+1.0)|0|1;f[e>>2]=v;$=v}else $=X;X=f[P>>2]|0;if(_>0.0&(X|0)<1){v=nrc(_*(Q?3.0:4.0)*2.0+1.0)|0|1;f[P>>2]=v;aa=v}else aa=X;if(!(($|0)>0&(($|0)%2|0|0)==1)){f[k>>2]=0;ba=k+4|0;f[ba>>2]=0;ca=tT(k,84)|0;K=ca;da=256031;D=K+84|0;do{b[K>>0]=b[da>>0]|0;K=K+1|0;da=da+1|0}while((K|0)<(D|0));Efa(-215,k,256116,2140)}if(!((aa|0)>0&((aa|0)%2|0|0)==1)){f[k>>2]=0;ba=k+4|0;f[ba>>2]=0;ca=tT(k,84)|0;K=ca;da=256031;D=K+84|0;do{b[K>>0]=b[da>>0]|0;K=K+1|0;da=da+1|0}while((K|0)<(D|0));Efa(-215,k,256116,2140)}h=g<0.0?0.0:g;g=_<0.0?0.0:_;Hfa($,h,w);$=f[P>>2]|0;do if(($|0)==(f[e>>2]|0)?+L(+(h-g))<2.220446049250313e-16:0){P=f[w>>2]|0;da=f[Z>>2]|0;ca=da;ba=P;aa=ca-ba|0;X=aa>>1;v=x+8|0;Q=f[v>>2]|0;U=f[x>>2]|0;Y=U;if(X>>>0<=Q-U>>1>>>0){M=f[a>>2]|0;R=M-U>>1;S=X>>>0>R>>>0;T=S?P+(R<<1)|0:da;da=M;R=M;if((T|0)==(P|0))ea=Y;else{M=P;W=Y;while(1){d[W>>1]=d[M>>1]|0;M=M+2|0;if((M|0)==(T|0))break;else W=W+2|0}ea=Y+(((T+-2-ba|0)>>>1)+1<<1)|0}if(S){W=ca-T|0;if((W|0)<=0)break;dJc(R|0,T|0,W|0)|0;f[a>>2]=(f[a>>2]|0)+(W>>>1<<1);break}else{if((da|0)==(ea|0))break;f[a>>2]=da+(~((da+-2-ea|0)>>>1)<<1);break}}W=U;if(!U)fa=Q;else{M=f[a>>2]|0;if((M|0)!=(Y|0))f[a>>2]=M+(~((M+-2-U|0)>>>1)<<1);YDc(W);f[v>>2]=0;f[a>>2]=0;f[x>>2]=0;fa=0}if((aa|0)<0)mCc(x);W=fa>>1>>>0<1073741823?(fa>>>0<X>>>0?X:fa):2147483647;if((W|0)<0)mCc(x);M=VDc(W<<1)|0;f[a>>2]=M;f[x>>2]=M;f[v>>2]=M+(W<<1);if((aa|0)>0){dJc(M|0,P|0,aa|0)|0;f[a>>2]=M+(aa>>>1<<1)}}else ga=87;while(0);if((ga|0)==87)Hfa($,g,x);$=f[s>>2]|0;fa=f[N>>2]|0;if(($|0)==(fa|0)){f[y>>2]=1124007936;ea=y+4|0;e=y+8|0;M=y+40|0;K=ea;D=K+36|0;do{f[K>>2]=0;K=K+4|0}while((K|0)<(D|0));f[M>>2]=e;K=y+48|0;D=y+44|0;f[D>>2]=K;f[K>>2]=0;f[y+52>>2]=0;W=k+8|0;f[W>>2]=0;f[W+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=y;h_(q,k);W=y+36|0;V=f[W>>2]|0;if(V|0){ha=V+12|0;f[ha>>2]=(f[ha>>2]|0)+1}ha=q+36|0;V=f[ha>>2]|0;if(V|0?(ia=V+12|0,V=f[ia>>2]|0,f[ia>>2]=V+-1,(V|0)==1):0)_S(q);f[ha>>2]=0;V=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[V>>2]|0)>0){ia=f[q+40>>2]|0;ja=0;do{f[ia+(ja<<2)>>2]=0;ja=ja+1|0;ka=f[V>>2]|0}while((ja|0)<(ka|0));f[q>>2]=f[y>>2];if((ka|0)<3)ga=100;else ga=102}else{f[q>>2]=f[y>>2];ga=100}if((ga|0)==100){ka=f[ea>>2]|0;if((ka|0)<3){f[V>>2]=ka;f[A>>2]=f[e>>2];f[c>>2]=f[y+12>>2];c=f[D>>2]|0;e=f[t>>2]|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2]}else ga=102}if((ga|0)==102)ZS(q,y);ga=y+16|0;f[s>>2]=f[ga>>2];f[q+20>>2]=f[y+20>>2];f[q+24>>2]=f[y+24>>2];f[q+28>>2]=f[y+28>>2];f[q+32>>2]=f[y+32>>2];c=f[W>>2]|0;f[ha>>2]=c;do if(c|0){ha=c+12|0;e=f[ha>>2]|0;f[ha>>2]=e+-1;if((e|0)!=1)break;_S(y)}while(0);f[W>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ea>>2]|0)>0){ga=f[M>>2]|0;M=0;do{f[ga+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[ea>>2]|0))}ea=f[D>>2]|0;if((ea|0)!=(K|0))g0(ea);la=f[s>>2]|0;ma=f[N>>2]|0}else{la=$;ma=fa}fa=((f[f[t>>2]>>2]|0)>>>0)/((1212424721>>>(f[q>>2]<<2&28)&15)>>>0)|0;$=f[r>>2]|0;ea=((f[f[O>>2]>>2]|0)>>>0)/((1212424721>>>($<<2&28)&15)>>>0)|0;K=f[r+12>>2]|0;D=f[r+8>>2]|0;M=f[w>>2]|0;ga=(f[Z>>2]|0)-M|0;W=ga>>1;c=f[x>>2]|0;e=(f[a>>2]|0)-c|0;ha=e>>1;f[k>>2]=48068;f[k+4>>2]=la;f[k+8>>2]=ma;f[k+12>>2]=fa;f[k+16>>2]=ea;f[k+20>>2]=K;f[k+24>>2]=D;f[k+28>>2]=($>>>3&511)+1;f[k+32>>2]=M;f[k+36>>2]=c;f[k+40>>2]=W;f[k+44>>2]=ha;f[k+48>>2]=m;b:do switch(W|0){case 1:{f[k+52>>2]=(d[M>>1]|0)==256?101:100;break}case 3:{m=d[M>>1]|0;if((m<<16>>16==64?(d[M+2>>1]|0)==128:0)?(d[M+4>>1]|0)==64:0)na=108;else{$=d[M+4>>1]|0;na=((m&65535)<=($&65535)?1:((m&65535)-($&65535)&65535)<<16>>16==0)?103:102}f[k+52>>2]=na;break}case 5:{if(((((d[M+4>>1]|0)==96?(d[M+2>>1]|0)==64:0)?(d[M+6>>1]|0)==64:0)?(d[M>>1]|0)==16:0)?(d[M+8>>1]|0)==16:0)oa=109;else if((d[M>>1]|0)==(d[M+8>>1]|0))oa=(d[M+2>>1]|0)==(d[M+6>>1]|0)?105:104;else oa=104;f[k+52>>2]=oa;break}default:{$=k+52|0;if(((W|0)%2|0|0)!=1){f[$>>2]=107;break b}f[$>>2]=106;if((ga|0)>2){m=W>>>1;K=0;while(1){if((d[M+(K<<1)>>1]|0)!=(d[M+(W+~K<<1)>>1]|0))break;K=K+1|0;if((K|0)>=(m|0))break b}f[$>>2]=107}}}while(0);c:do switch(ha|0){case 1:{f[k+56>>2]=(d[c>>1]|0)==256?163:162;break}case 3:{if((d[c>>1]|0)==64?(d[c+2>>1]|0)==128:0)pa=(d[c+4>>1]|0)==64?165:164;else pa=164;f[k+56>>2]=pa;break}case 5:{if((((d[c+4>>1]|0)==96?(d[c+2>>1]|0)==64:0)?(d[c+6>>1]|0)==64:0)?(d[c>>1]|0)==16:0)qa=(d[c+8>>1]|0)==16?167:166;else qa=166;f[k+56>>2]=qa;break}default:{W=k+56|0;if(((ha|0)%2|0|0)!=1){f[W>>2]=169;break c}f[W>>2]=168;if((e|0)>2){M=ha>>>1;ga=0;while(1){if((d[c+(ga<<1)>>1]|0)!=(d[c+(ha+~ga<<1)>>1]|0))break;ga=ga+1|0;if((ga|0)>=(M|0))break c}f[W>>2]=169}}}while(0);f[y>>2]=0;f[y+4>>2]=D;D=z8()|0;ha=A8()|0;c=(ha|0)<(D|0)?ha:D;y8(y,k,+(((c|0)>1?c:1)|0));c=f[x>>2]|0;if(c|0){D=f[a>>2]|0;if((D|0)!=(c|0))f[a>>2]=D+(~((D+-2-c|0)>>>1)<<1);YDc(c)}c=f[w>>2]|0;if(c|0){D=f[Z>>2]|0;if((D|0)!=(c|0))f[Z>>2]=D+(~((D+-2-c|0)>>>1)<<1);YDc(c)}}else{f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=q;c=w+8|0;f[c>>2]=0;f[c+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=r;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;f[z>>2]=-1;f[z+4>>2]=-1;lwa(k,w,l,x,y,z,0.0,i)}i=r+36|0;z=f[i>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)_S(r);f[i>>2]=0;i=r+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[i>>2]|0)>0){N=f[r+40>>2]|0;z=0;do{f[N+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[i>>2]|0))}i=f[O>>2]|0;if((i|0)!=(r+48|0))g0(i);i=q+36|0;r=f[i>>2]|0;if(r|0?(O=r+12|0,r=f[O>>2]|0,f[O>>2]=r+-1,(r|0)==1):0)_S(q);f[i>>2]=0;i=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[i>>2]|0)>0){s=f[q+40>>2]|0;r=0;do{f[s+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[i>>2]|0))}i=f[t>>2]|0;if((i|0)!=(q+48|0))g0(i);i=p+36|0;q=f[i>>2]|0;if(q|0?(t=q+12|0,q=f[t>>2]|0,f[t>>2]=q+-1,(q|0)==1):0)_S(p);f[i>>2]=0;i=p+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[C>>2]|0)>0){i=f[I>>2]|0;I=0;do{f[i+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[C>>2]|0))}C=f[H>>2]|0;if((C|0)!=(F|0))g0(C);C=o+36|0;F=f[C>>2]|0;if(F|0?(H=F+12|0,F=f[H>>2]|0,f[H>>2]=F+-1,(F|0)==1):0)_S(o);f[C>>2]=0;C=o+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){C=f[J>>2]|0;J=0;do{f[C+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[B>>2]|0))}B=f[E>>2]|0;if((B|0)!=(n|0))g0(B);u=j;return}function Hfa(a,b,c){a=a|0;b=+b;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=u;u=u+128|0;g=e+104|0;h=e+96|0;i=e+88|0;j=e+80|0;k=e+64|0;l=e+56|0;m=e+40|0;n=e+32|0;o=e+24|0;q=e+16|0;r=e+8|0;s=e;t=e+112|0;a:do if(!(b<=0.0))v=7;else switch(a|0){case 1:{p[i>>3]=1.0;Vmc(h,256);fnc(g,i,h);w=(Zmc(g)|0)&65535;x=VDc(2)|0;f[t>>2]=x;y=x+2|0;f[t+8>>2]=y;d[x>>1]=w;f[t+4>>2]=y;break a;break}case 3:{p[i>>3]=.25;Vmc(h,256);fnc(g,i,h);y=(Zmc(g)|0)&65535;p[j>>3]=.5;Vmc(h,256);fnc(g,j,h);w=(Zmc(g)|0)&65535;p[k>>3]=.25;Vmc(h,256);fnc(g,k,h);x=(Zmc(g)|0)&65535;z=VDc(6)|0;f[t>>2]=z;A=z+6|0;f[t+8>>2]=A;d[z>>1]=y;d[z+2>>1]=w;d[z+4>>1]=x;f[t+4>>2]=A;break a;break}case 5:{p[i>>3]=.0625;Vmc(h,256);fnc(g,i,h);A=(Zmc(g)|0)&65535;p[j>>3]=.25;Vmc(h,256);fnc(g,j,h);x=(Zmc(g)|0)&65535;p[k>>3]=.375;Vmc(h,256);fnc(g,k,h);z=(Zmc(g)|0)&65535;p[l>>3]=.25;Vmc(h,256);fnc(g,l,h);w=(Zmc(g)|0)&65535;p[m>>3]=.0625;Vmc(h,256);fnc(g,m,h);y=(Zmc(g)|0)&65535;B=VDc(10)|0;f[t>>2]=B;C=B+10|0;f[t+8>>2]=C;d[B>>1]=A;d[B+2>>1]=x;d[B+4>>1]=z;d[B+6>>1]=w;d[B+8>>1]=y;f[t+4>>2]=C;break a;break}case 7:{p[i>>3]=.03125;Vmc(h,256);fnc(g,i,h);C=(Zmc(g)|0)&65535;p[j>>3]=.109375;Vmc(h,256);fnc(g,j,h);y=(Zmc(g)|0)&65535;p[k>>3]=.21875;Vmc(h,256);fnc(g,k,h);B=(Zmc(g)|0)&65535;p[l>>3]=.28125;Vmc(h,256);fnc(g,l,h);w=(Zmc(g)|0)&65535;p[m>>3]=.21875;Vmc(h,256);fnc(g,m,h);z=(Zmc(g)|0)&65535;p[n>>3]=.109375;Vmc(h,256);fnc(g,n,h);x=(Zmc(g)|0)&65535;p[o>>3]=.03125;Vmc(h,256);fnc(g,o,h);A=(Zmc(g)|0)&65535;D=VDc(14)|0;f[t>>2]=D;E=D+14|0;f[t+8>>2]=E;d[D>>1]=C;d[D+2>>1]=y;d[D+4>>1]=B;d[D+6>>1]=w;d[D+8>>1]=z;d[D+10>>1]=x;d[D+12>>1]=A;f[t+4>>2]=E;break a;break}default:{v=7;break a}}while(0);if((v|0)==7){if(b>0.0)p[i>>3]=b;else{Vmc(g,a);p[h>>3]=.15;p[j>>3]=.35;knc(i,g,h,j)}p[q>>3]=-.125;fnc(g,i,i);gnc(j,q,g);f[k>>2]=0;q=k+4|0;f[q>>2]=0;f[k+8>>2]=0;i=(a|0)==0;if(i){p[l>>3]=0.0;F=0;G=l}else{if(a>>>0>536870911)mCc(k);v=a<<3;o=VDc(v)|0;f[k>>2]=o;E=o+(a<<3)|0;f[k+8>>2]=E;XIc(o|0,0,v|0)|0;f[q>>2]=E;p[l>>3]=0.0;E=1-a|0;v=0;while(1){Vmc(r,Y(E,E)|0);fnc(h,r,j);lnc(g,h);o=(f[k>>2]|0)+(v<<3)|0;if((g|0)!=(o|0)){A=g;D=f[A+4>>2]|0;x=o;f[x>>2]=f[A>>2];f[x+4>>2]=D}bnc(g,l,o);o=g;D=f[o+4>>2]|0;x=l;f[x>>2]=f[o>>2];f[x+4>>2]=D;v=v+1|0;if((v|0)>=(a|0)){F=1;G=l;break}else E=E+2|0}}E=s;f[E>>2]=0;f[E+4>>2]=1072693248;gnc(g,s,l);s=g;E=f[s+4>>2]|0;G=l;f[G>>2]=f[s>>2];f[G+4>>2]=E;f[m>>2]=0;E=m+4|0;f[E>>2]=0;f[m+8>>2]=0;do if(!i)if((a|0)<0)mCc(m);else{G=a<<1;s=VDc(G)|0;f[m>>2]=s;v=s+(a<<1)|0;f[m+8>>2]=v;XIc(s|0,0,G|0)|0;f[E>>2]=v;H=v;I=v;J=s;K=s;break}else{H=0;I=0;J=0;K=0}while(0);if(F){F=0;do{fnc(n,(f[k>>2]|0)+(F<<3)|0,l);i=f[m>>2]|0;if((f[n+4>>2]|0)<0)L=0;else{Vmc(h,256);fnc(g,n,h);L=(Zmc(g)|0)&65535}d[i+(F<<1)>>1]=L;F=F+1|0}while((F|0)<(a|0));a=f[E>>2]|0;F=f[m>>2]|0;M=F;N=a;O=F;P=a}else{M=K;N=H;O=J;P=I}f[t>>2]=0;I=t+4|0;f[I>>2]=0;f[t+8>>2]=0;J=N-M|0;M=J>>1;if(M){if((J|0)<0)mCc(t);H=VDc(J)|0;f[I>>2]=H;f[t>>2]=H;f[t+8>>2]=H+(M<<1);M=N-O|0;J=N;if((M|0)>0){dJc(H|0,O|0,M|0)|0;f[I>>2]=H+(M>>>1<<1);Q=J}else Q=J}else Q=P;if(O|0){if((Q|0)!=(O|0))f[E>>2]=Q+(~((Q+-2-O|0)>>>1)<<1);YDc(O)}O=f[k>>2]|0;if(O|0){k=f[q>>2]|0;if((k|0)!=(O|0))f[q>>2]=k+(~((k+-8-O|0)>>>3)<<3);YDc(O)}}do if((t|0)!=(c|0)){O=f[t>>2]|0;k=f[t+4>>2]|0;q=k;Q=O;E=q-Q|0;P=E>>1;J=c+8|0;M=f[J>>2]|0;H=f[c>>2]|0;I=H;if(P>>>0<=M-H>>1>>>0){N=c+4|0;K=f[N>>2]|0;a=K-H>>1;F=P>>>0>a>>>0;m=F?O+(a<<1)|0:k;k=K;a=K;if((m|0)==(O|0))R=I;else{K=m+-2|0;L=O;g=I;while(1){d[g>>1]=d[L>>1]|0;L=L+2|0;if((L|0)==(m|0))break;else g=g+2|0}R=I+(((K-Q|0)>>>1)+1<<1)|0}if(F){g=q-m|0;if((g|0)<=0)break;dJc(a|0,m|0,g|0)|0;f[N>>2]=(f[N>>2]|0)+(g>>>1<<1);break}else{if((k|0)==(R|0))break;f[N>>2]=k+(~((k+-2-R|0)>>>1)<<1);break}}g=H;if(!H)S=M;else{L=c+4|0;h=f[L>>2]|0;if((h|0)!=(I|0))f[L>>2]=h+(~((h+-2-H|0)>>>1)<<1);YDc(g);f[J>>2]=0;f[L>>2]=0;f[c>>2]=0;S=0}if((E|0)<0)mCc(c);L=S>>1>>>0<1073741823?(S>>>0<P>>>0?P:S):2147483647;if((L|0)<0)mCc(c);g=VDc(L<<1)|0;h=c+4|0;f[h>>2]=g;f[c>>2]=g;f[J>>2]=g+(L<<1);if((E|0)>0){dJc(g|0,O|0,E|0)|0;f[h>>2]=g+(E>>>1<<1)}}while(0);c=f[t>>2]|0;if(!c){u=e;return}S=t+4|0;t=f[S>>2]|0;if((t|0)!=(c|0))f[S>>2]=t+(~((t+-2-c|0)>>>1)<<1);YDc(c);u=e;return}function Ifa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0;i=Y(g,b)|0;if((i|0)>0)j=0;else return;do{d[f+(j<<1)>>1]=(h[a+j>>0]|0)<<8;j=j+1|0}while((j|0)!=(i|0));return}function Jfa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;i=Y(g,b)|0;if((i|0)<=0)return;b=0;do{g=Y(h[a+b>>0]|0,j[c>>1]|0)|0;d[f+(b<<1)>>1]=g>>>0<65535?g:65535;b=b+1|0}while((b|0)!=(i|0));return}function Kfa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((g|0)==1){if(!i)k=d[c+2>>1]|0;else{e=(j[c>>1]|0)<<1&65534;l=e+(j[c+2>>1]|0)|0;k=e>>>0>(l&65535)>>>0?-1:l&65535}if((b|0)<=0)return;l=k&65535;k=0;do{e=Y(h[a+k>>0]|0,l)|0;d[f+(k<<1)>>1]=e>>>0<65535?e:65535;k=k+1|0}while((k|0)!=(b|0));return}k=(i|0)!=0;if(k){l=p_(-1,g,i)|0;if((b|0)>0){e=c+2|0;m=Y(l,b)|0;l=0;do{n=Y(h[a+l>>0]|0,j[e>>1]|0)|0;o=(Y((h[a+(l+m)>>0]|0)+(h[a+(l+b)>>0]|0)|0,j[c>>1]|0)|0)+n&65535;d[f+(l<<1)>>1]=o;l=l+1|0}while((l|0)!=(b|0))}}else if((b|0)>0){l=c+2|0;m=0;do{e=Y(h[a+m>>0]|0,j[l>>1]|0)|0;o=e>>>0<65535?e:65535;e=Y(h[a+(m+b)>>0]|0,j[c>>1]|0)|0;n=(e>>>0<65535?e:65535)+o|0;d[f+(m<<1)>>1]=o>>>0>(n&65535)>>>0?-1:n&65535;m=m+1|0}while((m|0)!=(b|0))}m=a+b|0;l=f+(b<<1)|0;n=g+-1|0;o=Y(n,b)|0;if((o|0)>(b|0)){e=c+2|0;p=0-b|0;q=f+(Y((g<<1)+-2|0,b)|0)|0;f=m;r=l;s=b;while(1){t=Y(h[f>>0]|0,j[e>>1]|0)|0;u=(Y((h[f+b>>0]|0)+(h[f+p>>0]|0)|0,j[c>>1]|0)|0)+t&65535;d[r>>1]=u;s=s+1|0;if((s|0)==(o|0))break;else{f=f+1|0;r=r+2|0}}v=a+o|0;w=q}else{v=m;w=l}if(k){k=Y((p_(g,g,i)|0)-n|0,b)|0;if((b|0)<=0)return;n=c+2|0;i=0;do{g=Y(h[v+i>>0]|0,j[n>>1]|0)|0;l=(Y((h[v+(i+k)>>0]|0)+(h[v+(i-b)>>0]|0)|0,j[c>>1]|0)|0)+g&65535;d[w+(i<<1)>>1]=l;i=i+1|0}while((i|0)!=(b|0));return}else{if((b|0)<=0)return;i=c+2|0;k=0;do{n=Y(h[v+(k-b)>>0]|0,j[c>>1]|0)|0;l=n>>>0<65535?n:65535;n=Y(h[v+k>>0]|0,j[i>>1]|0)|0;g=(n>>>0<65535?n:65535)+l|0;d[w+(k<<1)>>1]=l>>>0>(g&65535)>>>0?-1:g&65535;k=k+1|0}while((k|0)!=(b|0));return}}function Lfa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((g|0)==1){if(!i)k=d[c+2>>1]|0;else{e=j[c>>1]|0;l=(j[c+2>>1]|0)+e&65535;m=e>>>0>l>>>0?65535:l;l=m+(j[c+4>>1]|0)|0;k=m>>>0>(l&65535)>>>0?-1:l&65535}if((b|0)<=0)return;l=k&65535;k=0;do{m=Y(h[a+k>>0]|0,l)|0;d[f+(k<<1)>>1]=m>>>0<65535?m:65535;k=k+1|0}while((k|0)!=(b|0));return}k=(b|0)>0;if(k){l=c+2|0;m=c+4|0;e=0;do{n=Y(h[a+e>>0]|0,j[l>>1]|0)|0;o=n>>>0<65535?n:65535;n=Y(h[a+(e+b)>>0]|0,j[m>>1]|0)|0;p=(n>>>0<65535?n:65535)+o|0;d[f+(e<<1)>>1]=o>>>0>(p&65535)>>>0?-1:p&65535;e=e+1|0}while((e|0)!=(b|0))}e=(i|0)!=0;if(e?(m=p_(-1,g,i)|0,k):0){l=Y(m,b)|0;m=0;do{p=Y(h[a+(m+l)>>0]|0,j[c>>1]|0)|0;o=f+(m<<1)|0;n=j[o>>1]|0;q=(p>>>0<65535?p:65535)+n|0;d[o>>1]=n>>>0>(q&65535)>>>0?-1:q&65535;m=m+1|0}while((m|0)!=(b|0))}m=a+b|0;l=f+(b<<1)|0;q=g+-1|0;n=Y(q,b)|0;if((n|0)>(b|0)){o=0-b|0;p=c+2|0;r=c+4|0;s=f+(Y((g<<1)+-2|0,b)|0)|0;f=m;t=l;u=b;while(1){v=Y(h[f+o>>0]|0,j[c>>1]|0)|0;w=v>>>0<65535?v:65535;v=Y(h[f>>0]|0,j[p>>1]|0)|0;x=(v>>>0<65535?v:65535)+w&65535;v=Y(h[f+b>>0]|0,j[r>>1]|0)|0;y=w>>>0>x>>>0?65535:x;x=y+(v>>>0<65535?v:65535)|0;d[t>>1]=y>>>0>(x&65535)>>>0?-1:x&65535;u=u+1|0;if((u|0)==(n|0))break;else{f=f+1|0;t=t+2|0}}z=a+n|0;A=s}else{z=m;A=l}if(k){l=c+2|0;m=0;do{s=Y(h[z+(m-b)>>0]|0,j[c>>1]|0)|0;n=s>>>0<65535?s:65535;s=Y(h[z+m>>0]|0,j[l>>1]|0)|0;a=(s>>>0<65535?s:65535)+n|0;d[A+(m<<1)>>1]=n>>>0>(a&65535)>>>0?-1:a&65535;m=m+1|0}while((m|0)!=(b|0))}if(!e)return;e=Y((p_(g,g,i)|0)-q|0,b)|0;if(!k)return;k=c+4|0;c=0;do{q=Y(h[z+(c+e)>>0]|0,j[k>>1]|0)|0;i=A+(c<<1)|0;g=j[i>>1]|0;m=(q>>>0<65535?q:65535)+g|0;d[i>>1]=g>>>0>(m&65535)>>>0?-1:m&65535;c=c+1|0}while((c|0)!=(b|0));return}function Mfa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((g|0)==1){e=(b|0)>0;if(!i){if(e)k=0;else return;do{d[f+(k<<1)>>1]=(h[a+k>>0]|0)<<7;k=k+1|0}while((k|0)!=(b|0));return}else{if(e)l=0;else return;do{d[f+(l<<1)>>1]=(h[a+l>>0]|0)<<8;l=l+1|0}while((l|0)!=(b|0));return}}l=(b|0)>0;if(l){e=0;do{d[f+(e<<1)>>1]=((h[a+(e+b)>>0]|0)<<6)+((h[a+e>>0]|0)<<7);e=e+1|0}while((e|0)!=(b|0))}e=(i|0)!=0;if(e?(k=p_(-1,g,i)|0,l):0){c=Y(k,b)|0;k=0;do{m=f+(k<<1)|0;n=j[m>>1]|0;o=((h[a+(k+c)>>0]|0)<<6)+n|0;d[m>>1]=n>>>0>(o&65535)>>>0?-1:o&65535;k=k+1|0}while((k|0)!=(b|0))}k=a+b|0;c=f+(b<<1)|0;o=g+-1|0;n=Y(o,b)|0;if((n|0)>(b|0)){m=0-b|0;p=f+(Y((g<<1)+-2|0,b)|0)|0;f=k;q=c;r=b;while(1){d[q>>1]=(h[f+b>>0]|0)+(h[f+m>>0]|0)+((h[f>>0]|0)<<1)<<6;r=r+1|0;if((r|0)==(n|0))break;else{f=f+1|0;q=q+2|0}}s=a+n|0;t=p}else{s=k;t=c}if(l){c=0;do{d[t+(c<<1)>>1]=((h[s+c>>0]|0)<<7)+((h[s+(c-b)>>0]|0)<<6);c=c+1|0}while((c|0)!=(b|0))}if(!e)return;e=Y((p_(g,g,i)|0)-o|0,b)|0;if(l)u=0;else return;do{l=t+(u<<1)|0;o=j[l>>1]|0;i=((h[s+(u+e)>>0]|0)<<6)+o|0;d[l>>1]=o>>>0>(i&65535)>>>0?-1:i&65535;u=u+1|0}while((u|0)!=(b|0));return}function Nfa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(g|0){case 1:{if(!i)k=d[c+4>>1]|0;else{e=j[c>>1]|0;l=(j[c+2>>1]|0)+e|0;m=e>>>0>(l&65535)>>>0?65534:l<<1&65534;l=m+(j[c+4>>1]|0)|0;k=m>>>0>(l&65535)>>>0?-1:l&65535}if((b|0)<=0)return;l=k&65535;k=0;do{m=Y(h[a+k>>0]|0,l)|0;d[f+(k<<1)>>1]=m>>>0<65535?m:65535;k=k+1|0}while((k|0)!=(b|0));return}case 2:{if(!i){if((b|0)<=0)return;k=c+4|0;l=c+2|0;m=0;do{e=a+m|0;n=Y(h[e>>0]|0,j[k>>1]|0)|0;o=n>>>0<65535?n:65535;n=m+b|0;p=a+n|0;q=Y(h[p>>0]|0,j[l>>1]|0)|0;r=(q>>>0<65535?q:65535)+o|0;d[f+(m<<1)>>1]=o>>>0>(r&65535)>>>0?-1:r&65535;r=Y(h[e>>0]|0,j[l>>1]|0)|0;e=r>>>0<65535?r:65535;r=Y(h[p>>0]|0,j[k>>1]|0)|0;p=(r>>>0<65535?r:65535)+e|0;d[f+(n<<1)>>1]=e>>>0>(p&65535)>>>0?-1:p&65535;m=m+1|0}while((m|0)!=(b|0));return}else{m=Y(p_(-2,2,i)|0,b)|0;k=Y(p_(-1,2,i)|0,b)|0;l=Y(p_(2,2,i)|0,b)|0;p=Y(p_(3,2,i)|0,b)|0;if((b|0)<=0)return;e=c+2|0;n=c+4|0;r=0;do{o=a+(r+k)|0;q=r+b|0;s=a+q|0;t=Y((h[s>>0]|0)+(h[o>>0]|0)|0,j[e>>1]|0)|0;u=a+r|0;v=(Y(h[u>>0]|0,j[n>>1]|0)|0)+t|0;t=a+(r+l)|0;w=v+(Y((h[a+(r+m)>>0]|0)+(h[t>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(r<<1)>>1]=w;w=Y((h[a+(r+p)>>0]|0)+(h[o>>0]|0)|0,j[c>>1]|0)|0;o=(Y((h[t>>0]|0)+(h[u>>0]|0)|0,j[e>>1]|0)|0)+w|0;w=o+(Y(h[s>>0]|0,j[n>>1]|0)|0)&65535;d[f+(q<<1)>>1]=w;r=r+1|0}while((r|0)!=(b|0));return}break}case 3:{if(!i){if((b|0)<=0)return;r=c+4|0;n=c+2|0;e=b<<1;p=0;do{m=a+p|0;l=Y(h[m>>0]|0,j[r>>1]|0)|0;k=l>>>0<65535?l:65535;l=p+b|0;w=a+l|0;q=Y(h[w>>0]|0,j[n>>1]|0)|0;s=(q>>>0<65535?q:65535)+k&65535;q=p+e|0;o=a+q|0;u=Y(h[o>>0]|0,j[c>>1]|0)|0;t=k>>>0>s>>>0?65535:s;s=t+(u>>>0<65535?u:65535)|0;d[f+(p<<1)>>1]=t>>>0>(s&65535)>>>0?-1:s&65535;s=Y((h[o>>0]|0)+(h[m>>0]|0)|0,j[n>>1]|0)|0;t=(Y(h[w>>0]|0,j[r>>1]|0)|0)+s&65535;d[f+(l<<1)>>1]=t;t=Y(h[m>>0]|0,j[c>>1]|0)|0;m=t>>>0<65535?t:65535;t=Y(h[w>>0]|0,j[n>>1]|0)|0;w=(t>>>0<65535?t:65535)+m&65535;t=Y(h[o>>0]|0,j[r>>1]|0)|0;o=m>>>0>w>>>0?65535:w;w=o+(t>>>0<65535?t:65535)|0;d[f+(q<<1)>>1]=o>>>0>(w&65535)>>>0?-1:w&65535;p=p+1|0}while((p|0)!=(b|0));return}else{p=Y(p_(-2,3,i)|0,b)|0;r=Y(p_(-1,3,i)|0,b)|0;n=Y(p_(3,3,i)|0,b)|0;e=Y(p_(4,3,i)|0,b)|0;if((b|0)<=0)return;w=c+4|0;o=c+2|0;q=b<<1;t=0;do{m=a+t|0;l=Y(h[m>>0]|0,j[w>>1]|0)|0;s=t+b|0;u=a+s|0;k=a+(t+r)|0;v=(Y((h[k>>0]|0)+(h[u>>0]|0)|0,j[o>>1]|0)|0)+l|0;l=t+q|0;x=a+l|0;y=v+(Y((h[a+(t+p)>>0]|0)+(h[x>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(t<<1)>>1]=y;y=Y(h[u>>0]|0,j[w>>1]|0)|0;v=(Y((h[x>>0]|0)+(h[m>>0]|0)|0,j[o>>1]|0)|0)+y|0;y=a+(t+n)|0;z=v+(Y((h[y>>0]|0)+(h[k>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(s<<1)>>1]=z;z=Y((h[a+(t+e)>>0]|0)+(h[m>>0]|0)|0,j[c>>1]|0)|0;m=(Y((h[y>>0]|0)+(h[u>>0]|0)|0,j[o>>1]|0)|0)+z|0;z=m+(Y(h[x>>0]|0,j[w>>1]|0)|0)&65535;d[f+(l<<1)>>1]=z;t=t+1|0}while((t|0)!=(b|0));return}break}default:{t=(i|0)!=0;if(t){w=Y(p_(-2,g,i)|0,b)|0;o=Y(p_(-1,g,i)|0,b)|0;if((b|0)>0){e=c+4|0;n=c+2|0;p=b<<1;q=b*3|0;r=0;do{z=a+r|0;l=Y(h[z>>0]|0,j[e>>1]|0)|0;x=r+b|0;m=a+x|0;u=a+(r+o)|0;y=(Y((h[u>>0]|0)+(h[m>>0]|0)|0,j[n>>1]|0)|0)+l|0;l=a+(r+p)|0;s=y+(Y((h[a+(r+w)>>0]|0)+(h[l>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(r<<1)>>1]=s;s=Y((h[l>>0]|0)+(h[z>>0]|0)|0,j[n>>1]|0)|0;z=(Y(h[m>>0]|0,j[e>>1]|0)|0)+s|0;s=z+(Y((h[u>>0]|0)+(h[a+(r+q)>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(x<<1)>>1]=s;r=r+1|0}while((r|0)!=(b|0))}}else if((b|0)>0){r=c+4|0;q=c+2|0;e=b<<1;n=b*3|0;w=0;do{p=a+w|0;o=Y(h[p>>0]|0,j[r>>1]|0)|0;s=o>>>0<65535?o:65535;o=w+b|0;x=a+o|0;u=Y(h[x>>0]|0,j[q>>1]|0)|0;z=(u>>>0<65535?u:65535)+s&65535;u=a+(w+e)|0;m=Y(h[u>>0]|0,j[c>>1]|0)|0;l=s>>>0>z>>>0?65535:z;z=l+(m>>>0<65535?m:65535)|0;d[f+(w<<1)>>1]=l>>>0>(z&65535)>>>0?-1:z&65535;z=Y((h[u>>0]|0)+(h[p>>0]|0)|0,j[q>>1]|0)|0;p=(Y(h[x>>0]|0,j[r>>1]|0)|0)+z|0;z=p+(Y(h[a+(w+n)>>0]|0,j[c>>1]|0)|0)&65535;d[f+(o<<1)>>1]=z;w=w+1|0}while((w|0)!=(b|0))}w=b<<1;n=a+w|0;r=f+(w<<1)|0;q=g+-2|0;e=Y(q,b)|0;if((w|0)<(e|0)){z=Y(b,-2)|0;o=c+2|0;p=0-b|0;x=c+4|0;u=f+(Y((g<<1)+-4|0,b)|0)|0;f=n;l=r;m=w;while(1){s=Y((h[f+w>>0]|0)+(h[f+z>>0]|0)|0,j[c>>1]|0)|0;y=(Y((h[f+b>>0]|0)+(h[f+p>>0]|0)|0,j[o>>1]|0)|0)+s|0;s=y+(Y(h[f>>0]|0,j[x>>1]|0)|0)&65535;d[l>>1]=s;m=m+1|0;if((m|0)==(e|0))break;else{f=f+1|0;l=l+2|0}}A=a+e|0;B=u}else{A=n;B=r}if(t){t=Y((p_(g,g,i)|0)-q|0,b)|0;r=Y((p_(g+1|0,g,i)|0)-q|0,b)|0;if((b|0)<=0)return;q=c+2|0;i=c+4|0;g=0;do{n=A+(g+t)|0;u=Y((h[n>>0]|0)+(h[A+(g-w)>>0]|0)|0,j[c>>1]|0)|0;e=A+(g-b)|0;a=g+b|0;l=A+a|0;f=(Y((h[l>>0]|0)+(h[e>>0]|0)|0,j[q>>1]|0)|0)+u|0;u=A+g|0;m=f+(Y(h[u>>0]|0,j[i>>1]|0)|0)&65535;d[B+(g<<1)>>1]=m;m=Y((h[A+(g+r)>>0]|0)+(h[e>>0]|0)|0,j[c>>1]|0)|0;e=(Y((h[n>>0]|0)+(h[u>>0]|0)|0,j[q>>1]|0)|0)+m|0;m=e+(Y(h[l>>0]|0,j[i>>1]|0)|0)&65535;d[B+(a<<1)>>1]=m;g=g+1|0}while((g|0)!=(b|0));return}else{if((b|0)<=0)return;g=c+2|0;i=c+4|0;q=0;do{r=Y(h[A+(q-w)>>0]|0,j[c>>1]|0)|0;t=A+(q-b)|0;m=q+b|0;a=A+m|0;l=(Y((h[a>>0]|0)+(h[t>>0]|0)|0,j[g>>1]|0)|0)+r|0;r=A+q|0;e=l+(Y(h[r>>0]|0,j[i>>1]|0)|0)&65535;d[B+(q<<1)>>1]=e;e=Y(h[t>>0]|0,j[c>>1]|0)|0;t=e>>>0<65535?e:65535;e=Y(h[r>>0]|0,j[g>>1]|0)|0;r=(e>>>0<65535?e:65535)+t&65535;e=Y(h[a>>0]|0,j[i>>1]|0)|0;a=t>>>0>r>>>0?65535:r;r=a+(e>>>0<65535?e:65535)|0;d[B+(m<<1)>>1]=a>>>0>(r&65535)>>>0?-1:r&65535;q=q+1|0}while((q|0)!=(b|0));return}}}}function Ofa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;switch(g|0){case 1:{if(!i)k=d[c+4>>1]|0;else{e=j[c>>1]|0;l=(j[c+2>>1]|0)+e&65535;m=e>>>0>l>>>0?65535:l;l=m+(j[c+4>>1]|0)&65535;e=m>>>0>l>>>0?65535:l;l=e+(j[c+6>>1]|0)&65535;m=e>>>0>l>>>0?65535:l;l=m+(j[c+8>>1]|0)|0;k=m>>>0>(l&65535)>>>0?-1:l&65535}if((b|0)<=0)return;l=k&65535;k=0;do{m=Y(h[a+k>>0]|0,l)|0;d[f+(k<<1)>>1]=m>>>0<65535?m:65535;k=k+1|0}while((k|0)!=(b|0));return}case 2:{if(!i){if((b|0)<=0)return;k=c+4|0;l=c+6|0;m=c+2|0;e=0;do{n=a+e|0;o=Y(h[n>>0]|0,j[k>>1]|0)|0;p=o>>>0<65535?o:65535;o=e+b|0;q=a+o|0;r=Y(h[q>>0]|0,j[l>>1]|0)|0;s=(r>>>0<65535?r:65535)+p|0;d[f+(e<<1)>>1]=p>>>0>(s&65535)>>>0?-1:s&65535;s=Y(h[n>>0]|0,j[m>>1]|0)|0;n=s>>>0<65535?s:65535;s=Y(h[q>>0]|0,j[k>>1]|0)|0;q=(s>>>0<65535?s:65535)+n|0;d[f+(o<<1)>>1]=n>>>0>(q&65535)>>>0?-1:q&65535;e=e+1|0}while((e|0)!=(b|0));return}else{e=Y(p_(-2,2,i)|0,b)|0;k=Y(p_(-1,2,i)|0,b)|0;m=Y(p_(2,2,i)|0,b)|0;l=Y(p_(3,2,i)|0,b)|0;if((b|0)<=0)return;q=c+2|0;n=c+4|0;o=c+6|0;s=c+8|0;p=0;do{r=a+(p+k)|0;t=Y(h[r>>0]|0,j[q>>1]|0)|0;u=t>>>0<65535?t:65535;t=a+p|0;v=Y(h[t>>0]|0,j[n>>1]|0)|0;w=(v>>>0<65535?v:65535)+u&65535;v=p+b|0;x=a+v|0;y=Y(h[x>>0]|0,j[o>>1]|0)|0;z=u>>>0>w>>>0?65535:w;w=z+(y>>>0<65535?y:65535)&65535;y=a+(p+m)|0;u=Y(h[y>>0]|0,j[s>>1]|0)|0;A=z>>>0>w>>>0?65535:w;w=A+(u>>>0<65535?u:65535)&65535;u=Y(h[a+(p+e)>>0]|0,j[c>>1]|0)|0;z=A>>>0>w>>>0?65535:w;w=z+(u>>>0<65535?u:65535)|0;d[f+(p<<1)>>1]=z>>>0>(w&65535)>>>0?-1:w&65535;w=Y(h[r>>0]|0,j[c>>1]|0)|0;r=w>>>0<65535?w:65535;w=Y(h[t>>0]|0,j[q>>1]|0)|0;t=(w>>>0<65535?w:65535)+r&65535;w=Y(h[x>>0]|0,j[n>>1]|0)|0;x=r>>>0>t>>>0?65535:t;t=x+(w>>>0<65535?w:65535)&65535;w=Y(h[y>>0]|0,j[o>>1]|0)|0;y=x>>>0>t>>>0?65535:t;t=y+(w>>>0<65535?w:65535)&65535;w=Y(h[a+(p+l)>>0]|0,j[s>>1]|0)|0;x=y>>>0>t>>>0?65535:t;t=x+(w>>>0<65535?w:65535)|0;d[f+(v<<1)>>1]=x>>>0>(t&65535)>>>0?-1:t&65535;p=p+1|0}while((p|0)!=(b|0));return}break}case 3:{if(!i){if((b|0)<=0)return;p=c+4|0;s=c+6|0;l=b<<1;o=c+8|0;n=c+2|0;q=0;do{e=a+q|0;m=Y(h[e>>0]|0,j[p>>1]|0)|0;k=m>>>0<65535?m:65535;m=q+b|0;t=a+m|0;x=Y(h[t>>0]|0,j[s>>1]|0)|0;v=(x>>>0<65535?x:65535)+k&65535;x=q+l|0;w=a+x|0;y=Y(h[w>>0]|0,j[o>>1]|0)|0;r=k>>>0>v>>>0?65535:v;v=r+(y>>>0<65535?y:65535)|0;d[f+(q<<1)>>1]=r>>>0>(v&65535)>>>0?-1:v&65535;v=Y(h[e>>0]|0,j[n>>1]|0)|0;r=v>>>0<65535?v:65535;v=Y(h[t>>0]|0,j[p>>1]|0)|0;y=(v>>>0<65535?v:65535)+r&65535;v=Y(h[w>>0]|0,j[s>>1]|0)|0;k=r>>>0>y>>>0?65535:y;y=k+(v>>>0<65535?v:65535)|0;d[f+(m<<1)>>1]=k>>>0>(y&65535)>>>0?-1:y&65535;y=Y(h[e>>0]|0,j[c>>1]|0)|0;e=y>>>0<65535?y:65535;y=Y(h[t>>0]|0,j[n>>1]|0)|0;t=(y>>>0<65535?y:65535)+e&65535;y=Y(h[w>>0]|0,j[p>>1]|0)|0;w=e>>>0>t>>>0?65535:t;t=w+(y>>>0<65535?y:65535)|0;d[f+(x<<1)>>1]=w>>>0>(t&65535)>>>0?-1:t&65535;q=q+1|0}while((q|0)!=(b|0));return}else{q=Y(p_(-2,3,i)|0,b)|0;p=Y(p_(-1,3,i)|0,b)|0;n=Y(p_(3,3,i)|0,b)|0;s=Y(p_(4,3,i)|0,b)|0;if((b|0)<=0)return;o=c+4|0;l=c+6|0;t=b<<1;w=c+8|0;x=c+2|0;y=0;do{e=a+y|0;k=Y(h[e>>0]|0,j[o>>1]|0)|0;m=k>>>0<65535?k:65535;k=y+b|0;v=a+k|0;r=Y(h[v>>0]|0,j[l>>1]|0)|0;z=(r>>>0<65535?r:65535)+m&65535;r=y+t|0;u=a+r|0;A=Y(h[u>>0]|0,j[w>>1]|0)|0;B=m>>>0>z>>>0?65535:z;z=B+(A>>>0<65535?A:65535)&65535;A=Y(h[a+(y+q)>>0]|0,j[c>>1]|0)|0;m=B>>>0>z>>>0?65535:z;z=m+(A>>>0<65535?A:65535)&65535;A=a+(y+p)|0;B=Y(h[A>>0]|0,j[x>>1]|0)|0;C=m>>>0>z>>>0?65535:z;z=C+(B>>>0<65535?B:65535)|0;d[f+(y<<1)>>1]=C>>>0>(z&65535)>>>0?-1:z&65535;z=Y(h[e>>0]|0,j[x>>1]|0)|0;C=z>>>0<65535?z:65535;z=Y(h[v>>0]|0,j[o>>1]|0)|0;B=(z>>>0<65535?z:65535)+C&65535;z=Y(h[u>>0]|0,j[l>>1]|0)|0;m=C>>>0>B>>>0?65535:B;B=m+(z>>>0<65535?z:65535)&65535;z=Y(h[A>>0]|0,j[c>>1]|0)|0;A=m>>>0>B>>>0?65535:B;B=A+(z>>>0<65535?z:65535)&65535;z=a+(y+n)|0;m=Y(h[z>>0]|0,j[w>>1]|0)|0;C=A>>>0>B>>>0?65535:B;B=C+(m>>>0<65535?m:65535)|0;d[f+(k<<1)>>1]=C>>>0>(B&65535)>>>0?-1:B&65535;B=Y(h[e>>0]|0,j[c>>1]|0)|0;e=B>>>0<65535?B:65535;B=Y(h[v>>0]|0,j[x>>1]|0)|0;v=(B>>>0<65535?B:65535)+e&65535;B=Y(h[u>>0]|0,j[o>>1]|0)|0;u=e>>>0>v>>>0?65535:v;v=u+(B>>>0<65535?B:65535)&65535;B=Y(h[z>>0]|0,j[l>>1]|0)|0;z=u>>>0>v>>>0?65535:v;v=z+(B>>>0<65535?B:65535)&65535;B=Y(h[a+(y+s)>>0]|0,j[w>>1]|0)|0;u=z>>>0>v>>>0?65535:v;v=u+(B>>>0<65535?B:65535)|0;d[f+(r<<1)>>1]=u>>>0>(v&65535)>>>0?-1:v&65535;y=y+1|0}while((y|0)!=(b|0));return}break}default:{y=(b|0)>0;if(y){w=c+4|0;s=c+6|0;l=b<<1;o=c+8|0;x=c+2|0;n=b*3|0;p=0;do{q=a+p|0;t=Y(h[q>>0]|0,j[w>>1]|0)|0;v=t>>>0<65535?t:65535;t=p+b|0;u=a+t|0;r=Y(h[u>>0]|0,j[s>>1]|0)|0;B=(r>>>0<65535?r:65535)+v&65535;r=a+(p+l)|0;z=Y(h[r>>0]|0,j[o>>1]|0)|0;e=v>>>0>B>>>0?65535:B;B=e+(z>>>0<65535?z:65535)|0;d[f+(p<<1)>>1]=e>>>0>(B&65535)>>>0?-1:B&65535;B=Y(h[q>>0]|0,j[x>>1]|0)|0;q=B>>>0<65535?B:65535;B=Y(h[u>>0]|0,j[w>>1]|0)|0;u=(B>>>0<65535?B:65535)+q&65535;B=Y(h[r>>0]|0,j[s>>1]|0)|0;r=q>>>0>u>>>0?65535:u;u=r+(B>>>0<65535?B:65535)&65535;B=Y(h[a+(p+n)>>0]|0,j[o>>1]|0)|0;q=r>>>0>u>>>0?65535:u;u=q+(B>>>0<65535?B:65535)|0;d[f+(t<<1)>>1]=q>>>0>(u&65535)>>>0?-1:u&65535;p=p+1|0}while((p|0)!=(b|0))}p=(i|0)!=0;if(p?(o=Y(p_(-2,g,i)|0,b)|0,n=Y(p_(-1,g,i)|0,b)|0,y):0){s=c+2|0;w=0;do{x=Y(h[a+(w+o)>>0]|0,j[c>>1]|0)|0;l=f+(w<<1)|0;u=j[l>>1]|0;q=(x>>>0<65535?x:65535)+u&65535;x=a+(w+n)|0;t=Y(h[x>>0]|0,j[s>>1]|0)|0;B=u>>>0>q>>>0?65535:q;q=B+(t>>>0<65535?t:65535)|0;d[l>>1]=B>>>0>(q&65535)>>>0?-1:q&65535;q=Y(h[x>>0]|0,j[c>>1]|0)|0;x=f+(w+b<<1)|0;B=j[x>>1]|0;l=(q>>>0<65535?q:65535)+B|0;d[x>>1]=B>>>0>(l&65535)>>>0?-1:l&65535;w=w+1|0}while((w|0)!=(b|0))}w=b<<1;s=a+w|0;n=f+(w<<1)|0;o=g+-2|0;l=Y(o,b)|0;if((w|0)<(l|0)){B=Y(b,-2)|0;x=0-b|0;q=c+2|0;t=c+4|0;u=c+6|0;r=c+8|0;e=f+(Y((g<<1)+-4|0,b)|0)|0;f=s;z=n;v=w;while(1){C=Y(h[f+B>>0]|0,j[c>>1]|0)|0;k=C>>>0<65535?C:65535;C=Y(h[f+x>>0]|0,j[q>>1]|0)|0;m=(C>>>0<65535?C:65535)+k&65535;C=Y(h[f>>0]|0,j[t>>1]|0)|0;A=k>>>0>m>>>0?65535:m;m=A+(C>>>0<65535?C:65535)&65535;C=Y(h[f+b>>0]|0,j[u>>1]|0)|0;k=A>>>0>m>>>0?65535:m;m=k+(C>>>0<65535?C:65535)&65535;C=Y(h[f+w>>0]|0,j[r>>1]|0)|0;A=k>>>0>m>>>0?65535:m;m=A+(C>>>0<65535?C:65535)|0;d[z>>1]=A>>>0>(m&65535)>>>0?-1:m&65535;v=v+1|0;if((v|0)==(l|0))break;else{f=f+1|0;z=z+2|0}}D=a+l|0;E=e}else{D=s;E=n}if(y){n=c+2|0;s=c+4|0;e=c+6|0;l=0;do{a=Y(h[D+(l-w)>>0]|0,j[c>>1]|0)|0;z=a>>>0<65535?a:65535;a=D+(l-b)|0;f=Y(h[a>>0]|0,j[n>>1]|0)|0;v=(f>>>0<65535?f:65535)+z&65535;f=D+l|0;r=Y(h[f>>0]|0,j[s>>1]|0)|0;u=z>>>0>v>>>0?65535:v;v=u+(r>>>0<65535?r:65535)&65535;r=l+b|0;z=D+r|0;t=Y(h[z>>0]|0,j[e>>1]|0)|0;q=u>>>0>v>>>0?65535:v;v=q+(t>>>0<65535?t:65535)|0;d[E+(l<<1)>>1]=q>>>0>(v&65535)>>>0?-1:v&65535;v=Y(h[a>>0]|0,j[c>>1]|0)|0;a=v>>>0<65535?v:65535;v=Y(h[f>>0]|0,j[n>>1]|0)|0;f=(v>>>0<65535?v:65535)+a&65535;v=Y(h[z>>0]|0,j[s>>1]|0)|0;z=a>>>0>f>>>0?65535:f;f=z+(v>>>0<65535?v:65535)|0;d[E+(r<<1)>>1]=z>>>0>(f&65535)>>>0?-1:f&65535;l=l+1|0}while((l|0)!=(b|0))}if(!p)return;p=Y((p_(g,g,i)|0)-o|0,b)|0;l=Y((p_(g+1|0,g,i)|0)-o|0,b)|0;if(!y)return;y=c+8|0;o=c+6|0;c=0;do{i=D+(c+p)|0;g=Y(h[i>>0]|0,j[y>>1]|0)|0;s=E+(c<<1)|0;n=j[s>>1]|0;e=(g>>>0<65535?g:65535)+n|0;d[s>>1]=n>>>0>(e&65535)>>>0?-1:e&65535;e=Y(h[i>>0]|0,j[o>>1]|0)|0;i=E+(c+b<<1)|0;n=j[i>>1]|0;s=(e>>>0<65535?e:65535)+n&65535;e=Y(h[D+(c+l)>>0]|0,j[y>>1]|0)|0;g=n>>>0>s>>>0?65535:s;s=g+(e>>>0<65535?e:65535)|0;d[i>>1]=g>>>0>(s&65535)>>>0?-1:s&65535;c=c+1|0}while((c|0)!=(b|0));return}}}function Pfa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;switch(g|0){case 1:{e=(b|0)>0;if(!i){if(e)k=0;else return;do{d[f+(k<<1)>>1]=(h[a+k>>0]|0)*96;k=k+1|0}while((k|0)!=(b|0));return}else{if(e)l=0;else return;do{d[f+(l<<1)>>1]=(h[a+l>>0]|0)<<8;l=l+1|0}while((l|0)!=(b|0));return}break}case 2:{if(!i){if((b|0)>0)m=0;else return;do{l=a+m|0;e=m+b|0;k=a+e|0;d[f+(m<<1)>>1]=((h[k>>0]|0)<<6)+((h[l>>0]|0)*96|0);d[f+(e<<1)>>1]=((h[k>>0]|0)*96|0)+((h[l>>0]|0)<<6);m=m+1|0}while((m|0)!=(b|0));return}else{m=Y(p_(-2,2,i)|0,b)|0;l=Y(p_(-1,2,i)|0,b)|0;k=Y(p_(2,2,i)|0,b)|0;e=Y(p_(3,2,i)|0,b)|0;if((b|0)>0)n=0;else return;do{c=a+n|0;o=a+(n+l)|0;p=((h[o>>0]|0)<<6)+((h[c>>0]|0)*96|0)|0;q=n+b|0;r=a+q|0;s=((h[r>>0]|0)<<6)+p&65504;t=a+(n+k)|0;u=p>>>0>s>>>0?65535:s;s=u+((h[t>>0]|0)<<4)&65535;p=u>>>0>s>>>0?65535:s;s=p+((h[a+(n+m)>>0]|0)<<4)|0;d[f+(n<<1)>>1]=p>>>0>(s&65535)>>>0?-1:s&65535;s=((h[c>>0]|0)<<6)+((h[r>>0]|0)*96|0)|0;r=((h[t>>0]|0)<<6)+s&65504;t=s>>>0>r>>>0?65535:r;r=t+((h[o>>0]|0)<<4)&65535;o=t>>>0>r>>>0?65535:r;r=o+((h[a+(n+e)>>0]|0)<<4)|0;d[f+(q<<1)>>1]=o>>>0>(r&65535)>>>0?-1:r&65535;n=n+1|0}while((n|0)!=(b|0));return}break}case 3:{if(!i){if((b|0)<=0)return;n=b<<1;e=0;do{m=a+e|0;k=e+b|0;l=a+k|0;r=((h[l>>0]|0)<<6)+((h[m>>0]|0)*96|0)|0;o=e+n|0;q=a+o|0;t=((h[q>>0]|0)<<4)+r|0;d[f+(e<<1)>>1]=r>>>0>(t&65520)>>>0?-1:t&65535;t=((h[m>>0]|0)<<6)+((h[l>>0]|0)*96|0)|0;r=((h[q>>0]|0)<<6)+t|0;d[f+(k<<1)>>1]=t>>>0>(r&65504)>>>0?-1:r&65535;r=((h[l>>0]|0)<<6)+((h[q>>0]|0)*96|0)|0;q=((h[m>>0]|0)<<4)+r|0;d[f+(o<<1)>>1]=r>>>0>(q&65520)>>>0?-1:q&65535;e=e+1|0}while((e|0)!=(b|0));return}else{e=Y(p_(-2,3,i)|0,b)|0;n=Y(p_(-1,3,i)|0,b)|0;q=Y(p_(3,3,i)|0,b)|0;r=Y(p_(4,3,i)|0,b)|0;if((b|0)<=0)return;o=b<<1;m=0;do{l=a+m|0;t=m+b|0;k=a+t|0;s=((h[k>>0]|0)<<6)+((h[l>>0]|0)*96|0)|0;c=a+(m+n)|0;p=((h[c>>0]|0)<<6)+s&65504;u=m+o|0;v=a+u|0;w=s>>>0>p>>>0?65535:p;p=w+((h[v>>0]|0)<<4)&65535;s=w>>>0>p>>>0?65535:p;p=s+((h[a+(m+e)>>0]|0)<<4)|0;d[f+(m<<1)>>1]=s>>>0>(p&65535)>>>0?-1:p&65535;p=((h[l>>0]|0)<<6)+((h[k>>0]|0)*96|0)|0;s=((h[v>>0]|0)<<6)+p&65504;w=p>>>0>s>>>0?65535:s;s=w+((h[c>>0]|0)<<4)&65535;c=a+(m+q)|0;p=w>>>0>s>>>0?65535:s;s=p+((h[c>>0]|0)<<4)|0;d[f+(t<<1)>>1]=p>>>0>(s&65535)>>>0?-1:s&65535;s=((h[k>>0]|0)<<6)+((h[v>>0]|0)*96|0)|0;v=((h[c>>0]|0)<<6)+s&65504;c=s>>>0>v>>>0?65535:v;v=c+((h[l>>0]|0)<<4)&65535;l=c>>>0>v>>>0?65535:v;v=l+((h[a+(m+r)>>0]|0)<<4)|0;d[f+(u<<1)>>1]=l>>>0>(v&65535)>>>0?-1:v&65535;m=m+1|0}while((m|0)!=(b|0));return}break}default:{m=(b|0)>0;if(m){r=b<<1;q=b*3|0;e=0;do{o=a+e|0;n=e+b|0;v=a+n|0;l=((h[v>>0]|0)<<6)+((h[o>>0]|0)*96|0)|0;u=a+(e+r)|0;c=((h[u>>0]|0)<<4)+l|0;d[f+(e<<1)>>1]=l>>>0>(c&65520)>>>0?-1:c&65535;c=((h[o>>0]|0)<<6)+((h[v>>0]|0)*96|0)|0;v=((h[u>>0]|0)<<6)+c&65504;u=c>>>0>v>>>0?65535:v;v=u+((h[a+(e+q)>>0]|0)<<4)|0;d[f+(n<<1)>>1]=u>>>0>(v&65535)>>>0?-1:v&65535;e=e+1|0}while((e|0)!=(b|0))}e=(i|0)!=0;if(e?(q=Y(p_(-2,g,i)|0,b)|0,r=Y(p_(-1,g,i)|0,b)|0,m):0){v=0;do{u=f+(v<<1)|0;n=j[u>>1]|0;c=((h[a+(v+q)>>0]|0)<<4)+n&65535;o=a+(v+r)|0;l=n>>>0>c>>>0?65535:c;c=l+((h[o>>0]|0)<<6)|0;d[u>>1]=l>>>0>(c&65535)>>>0?-1:c&65535;c=f+(v+b<<1)|0;l=j[c>>1]|0;u=((h[o>>0]|0)<<4)+l|0;d[c>>1]=l>>>0>(u&65535)>>>0?-1:u&65535;v=v+1|0}while((v|0)!=(b|0))}v=b<<1;r=a+v|0;q=f+(v<<1)|0;u=g+-2|0;l=Y(u,b)|0;if((v|0)<(l|0)){c=0-b|0;o=Y(b,-2)|0;n=f+(Y((g<<1)+-4|0,b)|0)|0;f=r;s=q;k=v;while(1){d[s>>1]=(h[f+o>>0]|0)+((h[f>>0]|0)*6|0)+((h[f+b>>0]|0)+(h[f+c>>0]|0)<<2)+(h[f+v>>0]|0)<<4;k=k+1|0;if((k|0)==(l|0))break;else{f=f+1|0;s=s+2|0}}x=a+l|0;y=n}else{x=r;y=q}if(m){q=0;do{r=x+q|0;n=x+(q-b)|0;l=((h[n>>0]|0)<<6)+((h[r>>0]|0)*96|0)|0;a=q+b|0;s=x+a|0;f=((h[s>>0]|0)<<6)+l&65504;k=l>>>0>f>>>0?65535:f;f=k+((h[x+(q-v)>>0]|0)<<4)|0;d[y+(q<<1)>>1]=k>>>0>(f&65535)>>>0?-1:f&65535;f=((h[r>>0]|0)<<6)+((h[s>>0]|0)*96|0)|0;s=((h[n>>0]|0)<<4)+f|0;d[y+(a<<1)>>1]=f>>>0>(s&65520)>>>0?-1:s&65535;q=q+1|0}while((q|0)!=(b|0))}if(!e)return;e=Y((p_(g,g,i)|0)-u|0,b)|0;q=Y((p_(g+1|0,g,i)|0)-u|0,b)|0;if(m)z=0;else return;do{m=x+(z+e)|0;u=y+(z<<1)|0;i=j[u>>1]|0;g=((h[m>>0]|0)<<4)+i|0;d[u>>1]=i>>>0>(g&65535)>>>0?-1:g&65535;g=y+(z+b<<1)|0;i=j[g>>1]|0;u=((h[m>>0]|0)<<6)+i&65535;m=i>>>0>u>>>0?65535:u;u=m+((h[x+(z+q)>>0]|0)<<4)|0;d[g>>1]=m>>>0>(u&65535)>>>0?-1:u&65535;z=z+1|0}while((z|0)!=(b|0));return}}}function Qfa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;k=(e|0)/2|0;l=e-k|0;m=(k|0)>(g|0)?g:k;if((m|0)>0){n=(b|0)>0;o=(i|0)!=0;p=k+-1|0;q=~g;r=n^1;s=f;t=0;u=p;v=p-e|0;p=l;while(1){w=u-((v|0)>(q|0)?v:q)|0;if(n){x=c+(k-t<<1)|0;y=0;do{z=Y(h[a+y>>0]|0,j[x>>1]|0)|0;d[s+(y<<1)>>1]=z>>>0<65535?z:65535;y=y+1|0}while((y|0)!=(b|0))}a:do if(o?(y=t-k|0,(y|0)<0):0){if(n){A=0;B=y}else{x=y;while(1){p_(x,g,i)|0;if((x|0)<-1)x=x+1|0;else break a}}while(1){x=Y(p_(B,g,i)|0,b)|0;y=c+(A<<1)|0;z=0;do{C=Y(h[a+(z+x)>>0]|0,j[y>>1]|0)|0;D=s+(z<<1)|0;E=j[D>>1]|0;F=(C>>>0<65535?C:65535)+E|0;d[D>>1]=E>>>0>(F&65535)>>>0?-1:F&65535;z=z+1|0}while((z|0)!=(b|0));if((B|0)<-1){A=A+1|0;B=B+1|0}else break}}while(0);z=k-t+1|0;y=t+l|0;x=(y|0)>(g|0)?g:y;F=(x|0)<2;if(F|r){G=F?z:w;H=F?1:x}else{F=z;z=1;while(1){E=Y(z,b)|0;D=c+(F<<1)|0;C=0;do{I=Y(h[a+(C+E)>>0]|0,j[D>>1]|0)|0;J=s+(C<<1)|0;K=j[J>>1]|0;L=(I>>>0<65535?I:65535)+K|0;d[J>>1]=K>>>0>(L&65535)>>>0?-1:L&65535;C=C+1|0}while((C|0)!=(b|0));z=z+1|0;C=F+1|0;if((z|0)>=(x|0)){G=C;H=x;break}else F=C}}b:do if(o&(H|0)<(y|0)){if(n){M=G;N=H}else{F=H;while(1){p_(F,g,i)|0;F=F+1|0;if((F|0)==(p|0))break b}}while(1){F=Y(p_(N,g,i)|0,b)|0;x=c+(M<<1)|0;z=0;do{w=Y(h[a+(z+F)>>0]|0,j[x>>1]|0)|0;C=s+(z<<1)|0;D=j[C>>1]|0;E=(w>>>0<65535?w:65535)+D|0;d[C>>1]=D>>>0>(E&65535)>>>0?-1:E&65535;z=z+1|0}while((z|0)!=(b|0));N=N+1|0;if((N|0)==(p|0))break;else M=M+1|0}}while(0);t=t+1|0;y=s+(b<<1)|0;if((t|0)>=(m|0)){O=y;P=m;break}else{s=y;u=u+-1|0;v=v+-1|0;p=p+1|0}}}else{O=f;P=0}f=Y(P,b)|0;p=Y(1-l+g|0,b)|0;do if((f|0)<(p|0)){l=Y(k,b)|0;v=c+(k<<1)|0;u=e+-1|0;s=Y(k+g+1-P-e|0,b)|0;m=a+s|0;if((e|0)>1){Q=a;R=O;S=f}else{t=a;M=O;N=f;while(1){H=Y(h[t+l>>0]|0,j[v>>1]|0)|0;d[M>>1]=H>>>0<65535?H:65535;N=N+1|0;if((N|0)==(p|0))break;else{t=t+1|0;M=M+2|0}}T=m;U=O+(s<<1)|0;V=p;break}while(1){M=Y(h[Q+l>>0]|0,j[v>>1]|0)|0;t=(M>>>0<65535?M:65535)&65535;d[R>>1]=t;M=0;N=t;do{t=Q+(Y(M,b)|0)|0;H=j[c+(M<<1)>>1]|0;G=Y(h[t>>0]|0,H)|0;t=N&65535;n=(G>>>0<65535?G:65535)+t&65535;G=Q+(Y(u-M|0,b)|0)|0;o=Y(h[G>>0]|0,H)|0;H=t>>>0>n>>>0?65535:n;n=H+(o>>>0<65535?o:65535)|0;N=H>>>0>(n&65535)>>>0?-1:n&65535;d[R>>1]=N;M=M+1|0}while((M|0)<(k|0));S=S+1|0;if((S|0)==(p|0))break;else{Q=Q+1|0;R=R+2|0}}T=m;U=O+(s<<1)|0;V=p}else{T=a;U=O;V=f}while(0);f=(V|0)/(b|0)|0;V=f-k|0;O=g-k|0;if((V|0)>=(O|0))return;a=(b|0)>0;p=(i|0)!=0;R=a^1;Q=T;T=V;V=U;U=k+g-f|0;while(1){if(a){f=0;do{k=Y(h[Q+f>>0]|0,j[c>>1]|0)|0;d[V+(f<<1)>>1]=k>>>0<65535?k:65535;f=f+1|0}while((f|0)!=(b|0))}f=g-T|0;s=(f|0)<2;if(s|R)W=s?1:f;else{s=1;do{m=Y(s,b)|0;k=c+(s<<1)|0;S=0;do{P=Y(h[Q+(S+m)>>0]|0,j[k>>1]|0)|0;u=V+(S<<1)|0;v=j[u>>1]|0;l=(P>>>0<65535?P:65535)+v|0;d[u>>1]=v>>>0>(l&65535)>>>0?-1:l&65535;S=S+1|0}while((S|0)!=(b|0));s=s+1|0}while((s|0)!=(U|0));W=f}c:do if(p&(W|0)<(e|0)){if(a)X=W;else{f=W;while(1){p_(f+T|0,g,i)|0;f=f+1|0;if((f|0)==(e|0))break c}}do{f=Y((p_(X+T|0,g,i)|0)-T|0,b)|0;s=c+(X<<1)|0;S=0;do{k=Y(h[Q+(S+f)>>0]|0,j[s>>1]|0)|0;m=V+(S<<1)|0;l=j[m>>1]|0;v=(k>>>0<65535?k:65535)+l|0;d[m>>1]=l>>>0>(v&65535)>>>0?-1:v&65535;S=S+1|0}while((S|0)!=(b|0));X=X+1|0}while((X|0)!=(e|0))}while(0);T=T+1|0;if((T|0)==(O|0))break;else{Q=Q+b|0;V=V+(b<<1)|0;U=U+-1|0}}return}function Rfa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;k=(e|0)/2|0;l=e-k|0;m=(k|0)>(g|0)?g:k;if((m|0)>0){n=(b|0)>0;o=(i|0)!=0;p=k+-1|0;q=~g;r=n^1;s=f;t=0;u=p;v=p-e|0;p=l;while(1){w=u-((v|0)>(q|0)?v:q)|0;if(n){x=c+(k-t<<1)|0;y=0;do{z=Y(h[a+y>>0]|0,j[x>>1]|0)|0;d[s+(y<<1)>>1]=z>>>0<65535?z:65535;y=y+1|0}while((y|0)!=(b|0))}a:do if(o?(y=t-k|0,(y|0)<0):0){if(n){A=0;B=y}else{x=y;while(1){p_(x,g,i)|0;if((x|0)<-1)x=x+1|0;else break a}}while(1){x=Y(p_(B,g,i)|0,b)|0;y=c+(A<<1)|0;z=0;do{C=Y(h[a+(z+x)>>0]|0,j[y>>1]|0)|0;D=s+(z<<1)|0;E=j[D>>1]|0;F=(C>>>0<65535?C:65535)+E|0;d[D>>1]=E>>>0>(F&65535)>>>0?-1:F&65535;z=z+1|0}while((z|0)!=(b|0));if((B|0)<-1){A=A+1|0;B=B+1|0}else break}}while(0);z=k-t+1|0;y=t+l|0;x=(y|0)>(g|0)?g:y;F=(x|0)<2;if(F|r){G=F?z:w;H=F?1:x}else{F=z;z=1;while(1){E=Y(z,b)|0;D=c+(F<<1)|0;C=0;do{I=Y(h[a+(C+E)>>0]|0,j[D>>1]|0)|0;J=s+(C<<1)|0;K=j[J>>1]|0;L=(I>>>0<65535?I:65535)+K|0;d[J>>1]=K>>>0>(L&65535)>>>0?-1:L&65535;C=C+1|0}while((C|0)!=(b|0));z=z+1|0;C=F+1|0;if((z|0)>=(x|0)){G=C;H=x;break}else F=C}}b:do if(o&(H|0)<(y|0)){if(n){M=G;N=H}else{F=H;while(1){p_(F,g,i)|0;F=F+1|0;if((F|0)==(p|0))break b}}while(1){F=Y(p_(N,g,i)|0,b)|0;x=c+(M<<1)|0;z=0;do{w=Y(h[a+(z+F)>>0]|0,j[x>>1]|0)|0;C=s+(z<<1)|0;D=j[C>>1]|0;E=(w>>>0<65535?w:65535)+D|0;d[C>>1]=D>>>0>(E&65535)>>>0?-1:E&65535;z=z+1|0}while((z|0)!=(b|0));N=N+1|0;if((N|0)==(p|0))break;else M=M+1|0}}while(0);t=t+1|0;y=s+(b<<1)|0;if((t|0)>=(m|0)){O=y;P=m;break}else{s=y;u=u+-1|0;v=v+-1|0;p=p+1|0}}}else{O=f;P=0}f=Y(P,b)|0;p=Y(1-l+g|0,b)|0;do if((f|0)<(p|0)){l=Y(k+g+1-P-e|0,b)|0;v=a+l|0;if((e|0)>1){Q=a;R=O;S=f}else{u=a;s=O;m=f;while(1){t=Y(h[u>>0]|0,j[c>>1]|0)|0;d[s>>1]=t>>>0<65535?t:65535;m=m+1|0;if((m|0)==(p|0))break;else{u=u+1|0;s=s+2|0}}T=v;U=O+(l<<1)|0;V=p;break}while(1){s=Y(h[Q>>0]|0,j[c>>1]|0)|0;u=(s>>>0<65535?s:65535)&65535;d[R>>1]=u;s=1;m=u;do{u=Q+(Y(s,b)|0)|0;t=Y(h[u>>0]|0,j[c+(s<<1)>>1]|0)|0;u=m&65535;M=(t>>>0<65535?t:65535)+u|0;m=u>>>0>(M&65535)>>>0?-1:M&65535;d[R>>1]=m;s=s+1|0}while((s|0)!=(e|0));S=S+1|0;if((S|0)==(p|0))break;else{Q=Q+1|0;R=R+2|0}}T=v;U=O+(l<<1)|0;V=p}else{T=a;U=O;V=f}while(0);f=(V|0)/(b|0)|0;V=f-k|0;O=g-k|0;if((V|0)>=(O|0))return;a=(b|0)>0;p=(i|0)!=0;R=a^1;Q=T;T=V;V=U;U=k+g-f|0;while(1){if(a){f=0;do{k=Y(h[Q+f>>0]|0,j[c>>1]|0)|0;d[V+(f<<1)>>1]=k>>>0<65535?k:65535;f=f+1|0}while((f|0)!=(b|0))}f=g-T|0;l=(f|0)<2;if(l|R)W=l?1:f;else{l=1;do{v=Y(l,b)|0;k=c+(l<<1)|0;S=0;do{P=Y(h[Q+(S+v)>>0]|0,j[k>>1]|0)|0;s=V+(S<<1)|0;m=j[s>>1]|0;M=(P>>>0<65535?P:65535)+m|0;d[s>>1]=m>>>0>(M&65535)>>>0?-1:M&65535;S=S+1|0}while((S|0)!=(b|0));l=l+1|0}while((l|0)!=(U|0));W=f}c:do if(p&(W|0)<(e|0)){if(a)X=W;else{f=W;while(1){p_(f+T|0,g,i)|0;f=f+1|0;if((f|0)==(e|0))break c}}do{f=Y((p_(X+T|0,g,i)|0)-T|0,b)|0;l=c+(X<<1)|0;S=0;do{k=Y(h[Q+(S+f)>>0]|0,j[l>>1]|0)|0;v=V+(S<<1)|0;M=j[v>>1]|0;m=(k>>>0<65535?k:65535)+M|0;d[v>>1]=M>>>0>(m&65535)>>>0?-1:m&65535;S=S+1|0}while((S|0)!=(b|0));X=X+1|0}while((X|0)!=(e|0))}while(0);T=T+1|0;if((T|0)==(O|0))break;else{Q=Q+b|0;V=V+(b<<1)|0;U=U+-1|0}}return}function Sfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;d=f[a>>2]|0;if((g|0)>0)h=0;else return;do{b[e+h>>0]=((j[d+(h<<1)>>1]|0)+128|0)>>>8;h=h+1|0}while((h|0)!=(g|0));return}function Tfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;d=f[a>>2]|0;if((g|0)<=0)return;a=0;do{h=((Y(j[d+(a<<1)>>1]|0,j[c>>1]|0)|0)+32768|0)>>>16;b[e+a>>0]=h>>>0<255?h:255;a=a+1|0}while((a|0)!=(g|0));return}function Ufa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;if((g|0)<=0)return;d=a+8|0;c=a+4|0;h=0;do{b[e+h>>0]=((j[(f[a>>2]|0)+(h<<1)>>1]|0)+512+(j[(f[d>>2]|0)+(h<<1)>>1]|0)+((j[(f[c>>2]|0)+(h<<1)>>1]|0)<<1)|0)>>>10;h=h+1|0}while((h|0)!=(g|0));return}function Vfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0;if((g|0)<=0)return;d=a+4|0;h=c+2|0;i=a+8|0;k=c+4|0;l=0;do{m=Y(j[(f[a>>2]|0)+(l<<1)>>1]|0,j[c>>1]|0)|0;n=(Y(j[(f[d>>2]|0)+(l<<1)>>1]|0,j[h>>1]|0)|0)+m|0;o=n>>>0<m>>>0?-1:n;n=(Y(j[(f[i>>2]|0)+(l<<1)>>1]|0,j[k>>1]|0)|0)+o|0;m=n>>>0<o>>>0?0:(n+32768|0)>>>16;b[e+l>>0]=m>>>0<255?m:255;l=l+1|0}while((l|0)!=(g|0));return}function Wfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0;if((g|0)<=0)return;d=a+8|0;c=a+4|0;h=a+12|0;i=a+16|0;k=0;do{b[e+k>>0]=(((j[(f[d>>2]|0)+(k<<1)>>1]|0)*6|0)+2048+((j[(f[h>>2]|0)+(k<<1)>>1]|0)+(j[(f[c>>2]|0)+(k<<1)>>1]|0)<<2)+(j[(f[a>>2]|0)+(k<<1)>>1]|0)+(j[(f[i>>2]|0)+(k<<1)>>1]|0)|0)>>>12;k=k+1|0}while((k|0)!=(g|0));return}function Xfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((g|0)<=0)return;d=a+4|0;h=c+2|0;i=a+8|0;k=c+4|0;l=a+12|0;m=c+6|0;n=a+16|0;o=c+8|0;p=0;do{q=Y(j[(f[a>>2]|0)+(p<<1)>>1]|0,j[c>>1]|0)|0;r=(Y(j[(f[d>>2]|0)+(p<<1)>>1]|0,j[h>>1]|0)|0)+q|0;s=r>>>0<q>>>0?-1:r;r=(Y(j[(f[i>>2]|0)+(p<<1)>>1]|0,j[k>>1]|0)|0)+s|0;q=r>>>0<s>>>0?-1:r;r=(Y(j[(f[l>>2]|0)+(p<<1)>>1]|0,j[m>>1]|0)|0)+q|0;s=r>>>0<q>>>0?-1:r;r=(Y(j[(f[n>>2]|0)+(p<<1)>>1]|0,j[o>>1]|0)|0)+s|0;q=r>>>0<s>>>0?0:(r+32768|0)>>>16;b[e+p>>0]=q>>>0<255?q:255;p=p+1|0}while((p|0)!=(g|0));return}function Yfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0;if((g|0)<=0)return;if((d|0)>1)h=0;else{i=0;do{k=((Y(j[(f[a>>2]|0)+(i<<1)>>1]|0,j[c>>1]|0)|0)+32768|0)>>>16;b[e+i>>0]=k>>>0<255?k:255;i=i+1|0}while((i|0)!=(g|0));return}do{i=1;k=Y(j[(f[a>>2]|0)+(h<<1)>>1]|0,j[c>>1]|0)|0;do{l=(Y(j[(f[a+(i<<2)>>2]|0)+(h<<1)>>1]|0,j[c+(i<<1)>>1]|0)|0)+k|0;k=l>>>0<k>>>0?-1:l;i=i+1|0}while((i|0)!=(d|0));i=(k+32768|0)>>>16;b[e+h>>0]=i>>>0<255?i:255;h=h+1|0}while((h|0)!=(g|0));return}function Zfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0;if((g|0)<=0)return;if((d|0)>1)h=0;else{i=0;do{k=((Y(j[(f[a>>2]|0)+(i<<1)>>1]|0,j[c>>1]|0)|0)+32768|0)>>>16;b[e+i>>0]=k>>>0<255?k:255;i=i+1|0}while((i|0)!=(g|0));return}do{i=1;k=Y(j[(f[a>>2]|0)+(h<<1)>>1]|0,j[c>>1]|0)|0;do{l=(Y(j[(f[a+(i<<2)>>2]|0)+(h<<1)>>1]|0,j[c+(i<<1)>>1]|0)|0)+k|0;k=l>>>0<k>>>0?-1:l;i=i+1|0}while((i|0)!=(d|0));i=(k+32768|0)>>>16;b[e+h>>0]=i>>>0<255?i:255;h=h+1|0}while((h|0)!=(g|0));return}function _fa(a){a=a|0;YDc(a);return}function $fa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;d=u;u=u+2128|0;e=d+1072|0;g=d+8|0;h=d;i=a+20|0;k=f[i>>2]|0;l=a+28|0;m=f[l>>2]|0;n=Y(m,k)|0;o=a+44|0;p=f[o>>2]|0;q=Y(n,p)|0;n=e+8|0;XIc(n|0,0,1040)|0;f[e>>2]=n;r=e+4|0;f[r>>2]=q;if(q>>>0>520){s=XDc(q>>>0>2147483647?-1:q<<1)|0;XIc(s|0,0,q<<1|0)|0;f[e>>2]=s;t=s}else t=n;s=p<<1;q=g+8|0;f[g>>2]=q;v=g+4|0;f[v>>2]=s;if(s>>>0>264){w=XDc(s>>>0>1073741823?-1:s<<2)|0;f[g>>2]=w;x=w}else x=q;w=f[c>>2]|0;a:do if((p|0)==1){f[x>>2]=t;s=c+4|0;if((w|0)<(f[s>>2]|0)){y=a+52|0;z=a+4|0;A=a+12|0;B=a+32|0;C=a+40|0;D=a+48|0;E=a+56|0;F=a+36|0;G=a+8|0;H=a+16|0;I=w;J=m;K=t;L=k;while(1){M=(f[z>>2]|0)+(Y(f[A>>2]|0,I)|0)|0;Ii[f[y>>2]&127](M,J,f[B>>2]|0,f[C>>2]|0,K,L,f[D>>2]|0);M=(f[G>>2]|0)+(Y(f[H>>2]|0,I)|0)|0;N=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[E>>2]&255](x,f[F>>2]|0,f[o>>2]|0,M,N);N=I+1|0;if((N|0)>=(f[s>>2]|0))break a;I=N;J=f[l>>2]|0;K=f[x>>2]|0;L=f[i>>2]|0}}}else{L=a+48|0;K=f[L>>2]|0;J=(p|0)/2|0;I=p-J|0;s=I+-1|0;F=w-J|0;if(K|0){E=(F|0)>0?F:0;H=I+w|0;f[h>>2]=H;G=a+24|0;D=f[G>>2]|0;if((E|0)<(((D|0)<(H|0)?D:H)|0)){C=a+52|0;B=a+4|0;y=a+12|0;A=a+32|0;z=a+40|0;N=E;M=0;O=K;K=k;P=m;Q=p;while(1){R=t+((Y(Y(K,M)|0,P)|0)<<1)|0;S=x+(M<<2)|0;f[S>>2]=R;f[x+(Q+M<<2)>>2]=R;R=(f[B>>2]|0)+(Y(f[y>>2]|0,N)|0)|0;Ii[f[C>>2]&127](R,P,f[A>>2]|0,f[z>>2]|0,f[S>>2]|0,K,O);T=N+1|0;U=M+1|0;V=f[G>>2]|0;if((T|0)>=(((V|0)<(H|0)?V:H)|0))break;N=T;M=U;O=f[L>>2]|0;K=f[i>>2]|0;P=f[l>>2]|0;Q=f[o>>2]|0}W=f[h>>2]|0;X=T;Z=U;_=V}else{W=H;X=E;Z=0;_=D}b:do if((X|0)<(W|0)){Q=a+52|0;P=a+4|0;K=a+12|0;O=a+32|0;M=a+40|0;N=X;z=Z;A=_;while(1){C=p_(N,A,f[L>>2]|0)|0;y=(f[o>>2]|0)+z|0;if((C|0)<(E|0)){B=f[i>>2]|0;S=Y(B,z)|0;R=f[l>>2]|0;$=t+((Y(S,R)|0)<<1)|0;S=x+(z<<2)|0;f[S>>2]=$;f[x+(y<<2)>>2]=$;$=(f[P>>2]|0)+(Y(f[K>>2]|0,C)|0)|0;Ii[f[Q>>2]&127]($,R,f[O>>2]|0,f[M>>2]|0,f[S>>2]|0,B,f[L>>2]|0)}else{B=f[x+(C-E<<2)>>2]|0;f[x+(z<<2)>>2]=B;f[x+(y<<2)>>2]=B}B=N+1|0;y=z+1|0;if((B|0)>=(W|0)){aa=B;ba=y;break b}N=B;z=y;A=f[G>>2]|0}}else{aa=X;ba=Z}while(0);if((F|0)<0){E=f[h>>2]|0;D=a+52|0;H=a+4|0;A=a+12|0;z=a+32|0;N=a+40|0;M=F;while(1){O=p_(M,f[G>>2]|0,f[L>>2]|0)|0;Q=f[o>>2]|0;K=(Q<<1)+M|0;P=Q+M|0;if((O|0)<(E|0)){Q=f[x+(O<<2)>>2]|0;f[x+(P<<2)>>2]=Q;f[x+(K<<2)>>2]=Q}else{Q=f[i>>2]|0;y=Y(Q,P)|0;B=f[l>>2]|0;C=t+((Y(y,B)|0)<<1)|0;y=x+(P<<2)|0;f[y>>2]=C;f[x+(K<<2)>>2]=C;C=(f[H>>2]|0)+(Y(f[A>>2]|0,O)|0)|0;Ii[f[D>>2]&127](C,B,f[z>>2]|0,f[N>>2]|0,f[y>>2]|0,Q,f[L>>2]|0)}if((M|0)<-1)M=M+1|0;else break}}M=a+56|0;N=a+36|0;z=a+8|0;D=a+16|0;A=(f[z>>2]|0)+(Y(f[D>>2]|0,w)|0)|0;H=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[M>>2]&255](x+(ba<<2)|0,f[N>>2]|0,f[o>>2]|0,A,H);H=f[o>>2]|0;A=c+4|0;E=(f[A>>2]|0)+s|0;Q=f[G>>2]|0;y=(ba|0)%(H|0)|0;B=(E|0)<(Q|0)?E:Q;f[h>>2]=B;Q=w+1|0;if((aa|0)<(((B|0)<(H|0)?B:H)|0)){E=a+52|0;C=a+4|0;O=a+12|0;K=a+32|0;P=a+40|0;S=Q;R=aa;$=y;ca=H;do{H=f[i>>2]|0;da=Y(H,$)|0;ea=f[l>>2]|0;fa=t+((Y(da,ea)|0)<<1)|0;da=x+($<<2)|0;f[da>>2]=fa;f[x+(ca+$<<2)>>2]=fa;fa=(f[C>>2]|0)+(Y(f[O>>2]|0,R)|0)|0;Ii[f[E>>2]&127](fa,ea,f[K>>2]|0,f[P>>2]|0,f[da>>2]|0,H,f[L>>2]|0);H=f[o>>2]|0;$=($+1|0)%(H|0)|0;da=(f[z>>2]|0)+(Y(f[D>>2]|0,S)|0)|0;ea=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[M>>2]&255](x+($<<2)|0,f[N>>2]|0,H,da,ea);R=R+1|0;S=S+1|0;ca=f[o>>2]|0}while((R|0)<(((B|0)<(ca|0)?B:ca)|0));ga=f[h>>2]|0;ha=S;ia=R;ja=$}else{ga=B;ha=Q;ia=aa;ja=y}if((ia|0)<(ga|0)){ca=a+52|0;P=a+4|0;K=a+12|0;E=a+32|0;O=a+40|0;C=ha;ea=ia;da=ja;while(1){H=(f[P>>2]|0)+(Y(f[K>>2]|0,ea)|0)|0;Ii[f[ca>>2]&127](H,f[l>>2]|0,f[E>>2]|0,f[O>>2]|0,f[x+(da<<2)>>2]|0,f[i>>2]|0,f[L>>2]|0);H=f[o>>2]|0;fa=(da+1|0)%(H|0)|0;ka=(f[z>>2]|0)+(Y(f[D>>2]|0,C)|0)|0;la=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[M>>2]&255](x+(fa<<2)|0,f[N>>2]|0,H,ka,la);la=ea+1|0;ka=C+1|0;if((la|0)<(ga|0)){C=ka;ea=la;da=fa}else{ma=ka;na=la;oa=fa;break}}}else{ma=ha;na=ia;oa=ja}if((na|0)<((f[A>>2]|0)+s|0)){da=a+52|0;ea=a+4|0;C=a+12|0;O=a+32|0;E=a+40|0;ca=ma;K=na;P=oa;while(1){y=p_(K,f[G>>2]|0,f[L>>2]|0)|0;Q=K-y|0;B=f[o>>2]|0;if((Q|0)>(B|0)){$=(f[ea>>2]|0)+(Y(f[C>>2]|0,y)|0)|0;Ii[f[da>>2]&127]($,f[l>>2]|0,f[O>>2]|0,f[E>>2]|0,f[x+(P<<2)>>2]|0,f[i>>2]|0,f[L>>2]|0)}else{$=f[x+(((P-Q+B|0)%(B|0)|0)<<2)>>2]|0;f[x+(P<<2)>>2]=$;f[x+(B+P<<2)>>2]=$}$=f[o>>2]|0;P=(P+1|0)%($|0)|0;B=(f[z>>2]|0)+(Y(f[D>>2]|0,ca)|0)|0;Q=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[M>>2]&255](x+(P<<2)|0,f[N>>2]|0,$,B,Q);K=K+1|0;if((K|0)>=((f[A>>2]|0)+s|0))break;else ca=ca+1|0}}break}ca=I+w|0;A=a+24|0;K=f[A>>2]|0;N=(K|0)<(ca|0)?K:ca;f[h>>2]=N;ca=(F|0)>0;K=ca?F:0;c:do if((K|0)<(N|0)){P=a+52|0;M=a+4|0;D=a+12|0;z=a+32|0;E=a+40|0;O=K;da=0;C=k;ea=m;G=p;Q=0;while(1){B=t+((Y(Y(C,da)|0,ea)|0)<<1)|0;$=x+(da<<2)|0;f[$>>2]=B;f[x+(G+da<<2)>>2]=B;B=(f[M>>2]|0)+(Y(f[D>>2]|0,O)|0)|0;Ii[f[P>>2]&127](B,ea,f[z>>2]|0,f[E>>2]|0,f[$>>2]|0,C,Q);pa=O+1|0;qa=da+1|0;if((pa|0)>=(N|0))break;O=pa;da=qa;C=f[i>>2]|0;ea=f[l>>2]|0;G=f[o>>2]|0;Q=f[L>>2]|0}Q=a+36|0;G=f[Q>>2]|0;switch(da|0){case 0:{ea=(f[a+8>>2]|0)+(Y(f[a+16>>2]|0,w)|0)|0;C=Y(f[l>>2]|0,f[i>>2]|0)|0;O=f[x>>2]|0;if((C|0)<=0){ra=1;sa=pa;ta=Q;break c}E=G+((ca?0:0-F|0)<<1)|0;z=0;do{P=((Y(j[O+(z<<1)>>1]|0,j[E>>1]|0)|0)+32768|0)>>>16;b[ea+z>>0]=P>>>0<255?P:255;z=z+1|0}while((z|0)!=(C|0));ra=qa;sa=pa;ta=Q;break}case 2:{C=G+((ca?0:0-F|0)<<1)|0;z=(f[a+8>>2]|0)+(Y(f[a+16>>2]|0,w)|0)|0;ea=Y(f[l>>2]|0,f[i>>2]|0)|0;if((ea|0)<=0){ra=3;sa=pa;ta=Q;break c}E=x+4|0;O=C+2|0;da=x+8|0;P=C+4|0;D=0;do{M=Y(j[(f[x>>2]|0)+(D<<1)>>1]|0,j[C>>1]|0)|0;$=(Y(j[(f[E>>2]|0)+(D<<1)>>1]|0,j[O>>1]|0)|0)+M|0;B=$>>>0<M>>>0?-1:$;$=(Y(j[(f[da>>2]|0)+(D<<1)>>1]|0,j[P>>1]|0)|0)+B|0;M=$>>>0<B>>>0?0:($+32768|0)>>>16;b[z+D>>0]=M>>>0<255?M:255;D=D+1|0}while((D|0)!=(ea|0));ra=qa;sa=pa;ta=Q;break}case 4:{ea=G+((ca?0:0-F|0)<<1)|0;D=(f[a+8>>2]|0)+(Y(f[a+16>>2]|0,w)|0)|0;z=Y(f[l>>2]|0,f[i>>2]|0)|0;if((z|0)<=0){ra=5;sa=pa;ta=Q;break c}P=x+4|0;da=ea+2|0;O=x+8|0;E=ea+4|0;C=x+12|0;M=ea+6|0;$=x+16|0;B=ea+8|0;y=0;do{R=Y(j[(f[x>>2]|0)+(y<<1)>>1]|0,j[ea>>1]|0)|0;S=(Y(j[(f[P>>2]|0)+(y<<1)>>1]|0,j[da>>1]|0)|0)+R|0;fa=S>>>0<R>>>0?-1:S;S=(Y(j[(f[O>>2]|0)+(y<<1)>>1]|0,j[E>>1]|0)|0)+fa|0;R=S>>>0<fa>>>0?-1:S;S=(Y(j[(f[C>>2]|0)+(y<<1)>>1]|0,j[M>>1]|0)|0)+R|0;fa=S>>>0<R>>>0?-1:S;S=(Y(j[(f[$>>2]|0)+(y<<1)>>1]|0,j[B>>1]|0)|0)+fa|0;R=S>>>0<fa>>>0?0:(S+32768|0)>>>16;b[D+y>>0]=R>>>0<255?R:255;y=y+1|0}while((y|0)!=(z|0));ra=qa;sa=pa;ta=Q;break}default:{ua=qa;va=pa;wa=Q;xa=G;ya=58;break c}}}else{z=a+36|0;ua=0;va=K;wa=z;xa=f[z>>2]|0;ya=58}while(0);d:do if((ya|0)==58){N=xa+((ca?0:0-F|0)<<1)|0;I=(f[a+8>>2]|0)+(Y(f[a+16>>2]|0,w)|0)|0;z=Y(f[l>>2]|0,f[i>>2]|0)|0;if((z|0)>0){if((ua|0)>1)za=0;else{y=0;while(1){D=((Y(j[(f[x>>2]|0)+(y<<1)>>1]|0,j[N>>1]|0)|0)+32768|0)>>>16;b[I+y>>0]=D>>>0<255?D:255;y=y+1|0;if((y|0)==(z|0)){ra=ua;sa=va;ta=wa;break d}}}do{y=1;G=Y(j[(f[x>>2]|0)+(za<<1)>>1]|0,j[N>>1]|0)|0;do{Q=(Y(j[(f[x+(y<<2)>>2]|0)+(za<<1)>>1]|0,j[N+(y<<1)>>1]|0)|0)+G|0;G=Q>>>0<G>>>0?-1:Q;y=y+1|0}while((y|0)!=(ua|0));y=(G+32768|0)>>>16;b[I+za>>0]=y>>>0<255?y:255;za=za+1|0}while((za|0)!=(z|0));ra=ua;sa=va;ta=wa}else{ra=ua;sa=va;ta=wa}}while(0);F=f[o>>2]|0;ca=c+4|0;z=(f[ca>>2]|0)+s|0;I=f[A>>2]|0;N=(ra|0)%(F|0)|0;y=(z|0)<(I|0)?z:I;f[h>>2]=y;I=w+1|0;if((sa|0)<(((y|0)<(F|0)?y:F)|0)){z=a+52|0;Q=a+4|0;D=a+12|0;B=a+32|0;$=a+40|0;M=a+16|0;C=a+8|0;E=x+4|0;O=x+8|0;da=x+12|0;P=x+16|0;ea=I;R=sa;S=N;fa=F;while(1){la=f[i>>2]|0;ka=Y(la,S)|0;H=f[l>>2]|0;Aa=t+((Y(ka,H)|0)<<1)|0;ka=x+(S<<2)|0;f[ka>>2]=Aa;f[x+(fa+S<<2)>>2]=Aa;Aa=(f[Q>>2]|0)+(Y(f[D>>2]|0,R)|0)|0;Ii[f[z>>2]&127](Aa,H,f[B>>2]|0,f[$>>2]|0,f[ka>>2]|0,la,f[L>>2]|0);la=S+1|0;ka=~S;H=f[ta>>2]|0;Aa=f[C>>2]|0;Ba=Y(f[i>>2]|0,f[l>>2]|0)|0;Ca=Y(f[M>>2]|0,ea)|0;e:do if((la|0)==3){Da=H+(f[o>>2]<<1)+(ka<<1)|0;Ea=Aa+Ca|0;if((Ba|0)>0){Fa=Da+2|0;Ga=Da+4|0;Ha=0;do{Ia=Y(j[(f[x>>2]|0)+(Ha<<1)>>1]|0,j[Da>>1]|0)|0;Ja=(Y(j[(f[E>>2]|0)+(Ha<<1)>>1]|0,j[Fa>>1]|0)|0)+Ia|0;Ka=Ja>>>0<Ia>>>0?-1:Ja;Ja=(Y(j[(f[O>>2]|0)+(Ha<<1)>>1]|0,j[Ga>>1]|0)|0)+Ka|0;Ia=Ja>>>0<Ka>>>0?0:(Ja+32768|0)>>>16;b[Ea+Ha>>0]=Ia>>>0<255?Ia:255;Ha=Ha+1|0}while((Ha|0)!=(Ba|0))}}else{Ha=H+(f[o>>2]<<1)+(ka<<1)|0;Ea=Aa+Ca|0;Ga=(Ba|0)>0;if((la|0)==5){if(!Ga)break;Fa=Ha+2|0;Da=Ha+4|0;G=Ha+6|0;Ia=Ha+8|0;Ja=0;while(1){Ka=Y(j[(f[x>>2]|0)+(Ja<<1)>>1]|0,j[Ha>>1]|0)|0;La=(Y(j[(f[E>>2]|0)+(Ja<<1)>>1]|0,j[Fa>>1]|0)|0)+Ka|0;Ma=La>>>0<Ka>>>0?-1:La;La=(Y(j[(f[O>>2]|0)+(Ja<<1)>>1]|0,j[Da>>1]|0)|0)+Ma|0;Ka=La>>>0<Ma>>>0?-1:La;La=(Y(j[(f[da>>2]|0)+(Ja<<1)>>1]|0,j[G>>1]|0)|0)+Ka|0;Ma=La>>>0<Ka>>>0?-1:La;La=(Y(j[(f[P>>2]|0)+(Ja<<1)>>1]|0,j[Ia>>1]|0)|0)+Ma|0;Ka=La>>>0<Ma>>>0?0:(La+32768|0)>>>16;b[Ea+Ja>>0]=Ka>>>0<255?Ka:255;Ja=Ja+1|0;if((Ja|0)==(Ba|0))break e}}if(Ga){if((R|0)>0)Na=0;else{Ja=0;while(1){Ia=((Y(j[(f[x>>2]|0)+(Ja<<1)>>1]|0,j[Ha>>1]|0)|0)+32768|0)>>>16;b[Ea+Ja>>0]=Ia>>>0<255?Ia:255;Ja=Ja+1|0;if((Ja|0)==(Ba|0))break e}}do{Ja=1;Ga=Y(j[(f[x>>2]|0)+(Na<<1)>>1]|0,j[Ha>>1]|0)|0;while(1){Ia=(Y(j[(f[x+(Ja<<2)>>2]|0)+(Na<<1)>>1]|0,j[Ha+(Ja<<1)>>1]|0)|0)+Ga|0;Ga=Ia>>>0<Ga>>>0?-1:Ia;if((Ja|0)==(R|0))break;else Ja=Ja+1|0}Ja=(Ga+32768|0)>>>16;b[Ea+Na>>0]=Ja>>>0<255?Ja:255;Na=Na+1|0}while((Na|0)!=(Ba|0))}}while(0);Ba=f[o>>2]|0;Ca=(la|0)%(Ba|0)|0;Aa=R+1|0;ka=ea+1|0;if((Aa|0)<(((y|0)<(Ba|0)?y:Ba)|0)){ea=ka;R=Aa;S=Ca;fa=Ba}else{Oa=ka;Pa=Ca;Qa=Aa;Ra=Ba;break}}}else{Oa=I;Pa=N;Qa=sa;Ra=F}if((Qa-K|0)<(Ra|0)){fa=Oa-J|0;S=f[ca>>2]|0;R=S-J|0;if((fa|0)<(((R|0)<0?R:0)|0)){R=a+16|0;ea=a+8|0;y=x+4|0;P=x+8|0;da=x+12|0;O=x+16|0;E=Oa;M=fa;while(1){C=f[A>>2]|0;$=0-M|0;B=f[ta>>2]|0;z=f[ea>>2]|0;D=Y(f[R>>2]|0,E)|0;Q=Y(f[i>>2]|0,f[l>>2]|0)|0;f:do if((C|0)==3){s=B+($<<1)|0;Ba=z+D|0;if((Q|0)>0){Aa=s+2|0;Ca=s+4|0;ka=0;do{H=Y(j[(f[x>>2]|0)+(ka<<1)>>1]|0,j[s>>1]|0)|0;Ea=(Y(j[(f[y>>2]|0)+(ka<<1)>>1]|0,j[Aa>>1]|0)|0)+H|0;Ha=Ea>>>0<H>>>0?-1:Ea;Ea=(Y(j[(f[P>>2]|0)+(ka<<1)>>1]|0,j[Ca>>1]|0)|0)+Ha|0;H=Ea>>>0<Ha>>>0?0:(Ea+32768|0)>>>16;b[Ba+ka>>0]=H>>>0<255?H:255;ka=ka+1|0}while((ka|0)!=(Q|0))}}else{ka=B+($<<1)|0;Ba=z+D|0;Ca=(Q|0)>0;if((C|0)==5){if(!Ca)break;Aa=ka+2|0;s=ka+4|0;H=ka+6|0;Ea=ka+8|0;Ha=0;while(1){Ja=Y(j[(f[x>>2]|0)+(Ha<<1)>>1]|0,j[ka>>1]|0)|0;Ia=(Y(j[(f[y>>2]|0)+(Ha<<1)>>1]|0,j[Aa>>1]|0)|0)+Ja|0;G=Ia>>>0<Ja>>>0?-1:Ia;Ia=(Y(j[(f[P>>2]|0)+(Ha<<1)>>1]|0,j[s>>1]|0)|0)+G|0;Ja=Ia>>>0<G>>>0?-1:Ia;Ia=(Y(j[(f[da>>2]|0)+(Ha<<1)>>1]|0,j[H>>1]|0)|0)+Ja|0;G=Ia>>>0<Ja>>>0?-1:Ia;Ia=(Y(j[(f[O>>2]|0)+(Ha<<1)>>1]|0,j[Ea>>1]|0)|0)+G|0;Ja=Ia>>>0<G>>>0?0:(Ia+32768|0)>>>16;b[Ba+Ha>>0]=Ja>>>0<255?Ja:255;Ha=Ha+1|0;if((Ha|0)==(Q|0))break f}}if(Ca){if((C|0)>1)Sa=0;else{Ha=0;while(1){Ea=((Y(j[(f[x>>2]|0)+(Ha<<1)>>1]|0,j[ka>>1]|0)|0)+32768|0)>>>16;b[Ba+Ha>>0]=Ea>>>0<255?Ea:255;Ha=Ha+1|0;if((Ha|0)==(Q|0))break f}}do{Ha=1;Ca=Y(j[(f[x>>2]|0)+(Sa<<1)>>1]|0,j[ka>>1]|0)|0;do{Ea=(Y(j[(f[x+(Ha<<2)>>2]|0)+(Sa<<1)>>1]|0,j[ka+(Ha<<1)>>1]|0)|0)+Ca|0;Ca=Ea>>>0<Ca>>>0?-1:Ea;Ha=Ha+1|0}while((Ha|0)!=(C|0));Ha=(Ca+32768|0)>>>16;b[Ba+Sa>>0]=Ha>>>0<255?Ha:255;Sa=Sa+1|0}while((Sa|0)!=(Q|0))}}while(0);Q=M+1|0;C=E+1|0;D=f[ca>>2]|0;z=D-J|0;if((Q|0)<(((z|0)<0?z:0)|0)){E=C;M=Q}else{Ta=C;Ua=Q;Va=D;break}}}else{Ta=Oa;Ua=fa;Va=S}if((Ua|0)<(Va-J|0)){M=0-K|0;E=a+8|0;O=a+16|0;da=Ta;P=Ua;while(1){y=(f[A>>2]|0)-P|0;g:do if((y|0)==3){R=x+(P<<2)+(M<<2)|0;ea=f[ta>>2]|0;F=(f[E>>2]|0)+(Y(f[O>>2]|0,da)|0)|0;N=Y(f[l>>2]|0,f[i>>2]|0)|0;if((N|0)>0){I=R+4|0;D=ea+2|0;Q=R+8|0;C=ea+4|0;z=0;do{$=Y(j[(f[R>>2]|0)+(z<<1)>>1]|0,j[ea>>1]|0)|0;B=(Y(j[(f[I>>2]|0)+(z<<1)>>1]|0,j[D>>1]|0)|0)+$|0;la=B>>>0<$>>>0?-1:B;B=(Y(j[(f[Q>>2]|0)+(z<<1)>>1]|0,j[C>>1]|0)|0)+la|0;$=B>>>0<la>>>0?0:(B+32768|0)>>>16;b[F+z>>0]=$>>>0<255?$:255;z=z+1|0}while((z|0)!=(N|0))}}else{N=x+(P<<2)+(M<<2)|0;z=f[ta>>2]|0;F=(f[E>>2]|0)+(Y(f[O>>2]|0,da)|0)|0;C=Y(f[l>>2]|0,f[i>>2]|0)|0;Q=(C|0)>0;if((y|0)==5){if(!Q)break;D=N+4|0;I=z+2|0;ea=N+8|0;R=z+4|0;$=N+12|0;B=z+6|0;la=N+16|0;Ba=z+8|0;ka=0;while(1){Ha=Y(j[(f[N>>2]|0)+(ka<<1)>>1]|0,j[z>>1]|0)|0;Ga=(Y(j[(f[D>>2]|0)+(ka<<1)>>1]|0,j[I>>1]|0)|0)+Ha|0;Ea=Ga>>>0<Ha>>>0?-1:Ga;Ga=(Y(j[(f[ea>>2]|0)+(ka<<1)>>1]|0,j[R>>1]|0)|0)+Ea|0;Ha=Ga>>>0<Ea>>>0?-1:Ga;Ga=(Y(j[(f[$>>2]|0)+(ka<<1)>>1]|0,j[B>>1]|0)|0)+Ha|0;Ea=Ga>>>0<Ha>>>0?-1:Ga;Ga=(Y(j[(f[la>>2]|0)+(ka<<1)>>1]|0,j[Ba>>1]|0)|0)+Ea|0;Ha=Ga>>>0<Ea>>>0?0:(Ga+32768|0)>>>16;b[F+ka>>0]=Ha>>>0<255?Ha:255;ka=ka+1|0;if((ka|0)==(C|0))break g}}if(Q){if((y|0)>1)Wa=0;else{ka=0;while(1){Ba=((Y(j[(f[N>>2]|0)+(ka<<1)>>1]|0,j[z>>1]|0)|0)+32768|0)>>>16;b[F+ka>>0]=Ba>>>0<255?Ba:255;ka=ka+1|0;if((ka|0)==(C|0))break g}}do{ka=1;Q=Y(j[(f[N>>2]|0)+(Wa<<1)>>1]|0,j[z>>1]|0)|0;do{Ba=(Y(j[(f[N+(ka<<2)>>2]|0)+(Wa<<1)>>1]|0,j[z+(ka<<1)>>1]|0)|0)+Q|0;Q=Ba>>>0<Q>>>0?-1:Ba;ka=ka+1|0}while((ka|0)!=(y|0));ka=(Q+32768|0)>>>16;b[F+Wa>>0]=ka>>>0<255?ka:255;Wa=Wa+1|0}while((Wa|0)!=(C|0))}}while(0);P=P+1|0;if((P|0)>=((f[ca>>2]|0)-J|0))break;else da=da+1|0}}}else{da=f[h>>2]|0;if((Qa|0)<(da|0)){P=a+52|0;O=a+4|0;E=a+12|0;M=a+32|0;K=a+40|0;S=a+56|0;fa=a+8|0;y=a+16|0;C=Oa;F=Qa;z=Pa;while(1){N=(f[O>>2]|0)+(Y(f[E>>2]|0,F)|0)|0;Ii[f[P>>2]&127](N,f[l>>2]|0,f[M>>2]|0,f[K>>2]|0,f[x+(z<<2)>>2]|0,f[i>>2]|0,f[L>>2]|0);N=f[o>>2]|0;ka=(z+1|0)%(N|0)|0;Ca=(f[fa>>2]|0)+(Y(f[y>>2]|0,C)|0)|0;Ba=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[S>>2]&255](x+(ka<<2)|0,f[ta>>2]|0,N,Ca,Ba);F=F+1|0;Ba=C+1|0;if((F|0)>=(da|0)){Xa=Ba;Ya=ka;break}else{C=Ba;z=ka}}}else{Xa=Oa;Ya=Pa}z=Xa-J|0;if((z|0)<((f[ca>>2]|0)-J|0)){C=a+16|0;da=a+8|0;F=Xa;S=z;z=(Ya+1|0)%(f[o>>2]|0)|0;while(1){y=(f[A>>2]|0)-S|0;fa=f[ta>>2]|0;L=f[da>>2]|0;K=Y(f[i>>2]|0,f[l>>2]|0)|0;M=Y(f[C>>2]|0,F)|0;h:do if((y|0)==3){P=x+(z<<2)|0;E=L+M|0;if((K|0)>0){O=P+4|0;ka=fa+2|0;Ba=P+8|0;Ca=fa+4|0;N=0;do{la=Y(j[(f[P>>2]|0)+(N<<1)>>1]|0,j[fa>>1]|0)|0;B=(Y(j[(f[O>>2]|0)+(N<<1)>>1]|0,j[ka>>1]|0)|0)+la|0;$=B>>>0<la>>>0?-1:B;B=(Y(j[(f[Ba>>2]|0)+(N<<1)>>1]|0,j[Ca>>1]|0)|0)+$|0;la=B>>>0<$>>>0?0:(B+32768|0)>>>16;b[E+N>>0]=la>>>0<255?la:255;N=N+1|0}while((N|0)!=(K|0))}}else{N=x+(z<<2)|0;E=L+M|0;Ca=(K|0)>0;if((y|0)==5){if(!Ca)break;Ba=N+4|0;ka=fa+2|0;O=N+8|0;P=fa+4|0;la=N+12|0;B=fa+6|0;$=N+16|0;R=fa+8|0;ea=0;while(1){I=Y(j[(f[N>>2]|0)+(ea<<1)>>1]|0,j[fa>>1]|0)|0;D=(Y(j[(f[Ba>>2]|0)+(ea<<1)>>1]|0,j[ka>>1]|0)|0)+I|0;Ha=D>>>0<I>>>0?-1:D;D=(Y(j[(f[O>>2]|0)+(ea<<1)>>1]|0,j[P>>1]|0)|0)+Ha|0;I=D>>>0<Ha>>>0?-1:D;D=(Y(j[(f[la>>2]|0)+(ea<<1)>>1]|0,j[B>>1]|0)|0)+I|0;Ha=D>>>0<I>>>0?-1:D;D=(Y(j[(f[$>>2]|0)+(ea<<1)>>1]|0,j[R>>1]|0)|0)+Ha|0;I=D>>>0<Ha>>>0?0:(D+32768|0)>>>16;b[E+ea>>0]=I>>>0<255?I:255;ea=ea+1|0;if((ea|0)==(K|0))break h}}if(Ca){if((y|0)>1)Za=0;else{ea=0;while(1){R=((Y(j[(f[N>>2]|0)+(ea<<1)>>1]|0,j[fa>>1]|0)|0)+32768|0)>>>16;b[E+ea>>0]=R>>>0<255?R:255;ea=ea+1|0;if((ea|0)==(K|0))break h}}do{ea=1;Ca=Y(j[(f[N>>2]|0)+(Za<<1)>>1]|0,j[fa>>1]|0)|0;do{R=(Y(j[(f[N+(ea<<2)>>2]|0)+(Za<<1)>>1]|0,j[fa+(ea<<1)>>1]|0)|0)+Ca|0;Ca=R>>>0<Ca>>>0?-1:R;ea=ea+1|0}while((ea|0)!=(y|0));ea=(Ca+32768|0)>>>16;b[E+Za>>0]=ea>>>0<255?ea:255;Za=Za+1|0}while((Za|0)!=(K|0))}}while(0);S=S+1|0;if((S|0)>=((f[ca>>2]|0)-J|0))break;else{F=F+1|0;z=z+1|0}}}}}while(0);Za=f[g>>2]|0;if((Za|0)!=(q|0)){if(Za|0)ZDc(Za);f[g>>2]=q;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(n|0)){u=d;return}if(v|0)ZDc(v);f[e>>2]=n;f[r>>2]=520;u=d;return}function aga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,M=0;d=a;e=f[d>>2]|0;g=f[d+4>>2]|0;d=UIc(e|0,g|0,-1,-1)|0;h=J;i=a+8|0;a=f[i>>2]|0;j=f[i+4>>2]|0;i=UIc(a|0,j|0,-1,-1)|0;k=J;if((g|0)<0|(g|0)==0&e>>>0<1|((j|0)<0|(j|0)==0&a>>>0<1)){l=0;return l|0}m=b+8|0;n=c+8|0;o=b;p=f[o>>2]|0;q=f[o+4>>2]|0;o=aJc(p|0,q|0,63)|0;r=m;s=f[r>>2]|0;t=f[r+4>>2]|0;r=aJc(s|0,t|0,61)|0;u=(((q|0)>(g|0)|(q|0)==(g|0)&p>>>0>=e>>>0)&1)<<1|o|r&4|(((t|0)>(j|0)|(t|0)==(j|0)&s>>>0>=a>>>0)&1)<<3;r=c;o=f[r>>2]|0;v=f[r+4>>2]|0;r=aJc(o|0,v|0,63)|0;w=n;x=f[w>>2]|0;y=f[w+4>>2]|0;w=aJc(x|0,y|0,61)|0;z=(((v|0)>(g|0)|(v|0)==(g|0)&o>>>0>=e>>>0)&1)<<1|r|w&4|(((y|0)>(j|0)|(y|0)==(j|0)&x>>>0>=a>>>0)&1)<<3;if(!((z&u|0)!=0|(z|u|0)==0)){if(!(u&12)){A=u;B=p;C=q;D=s;E=t}else{a=u>>>0<8;j=a?0:i;w=a?0:k;a=TIc(j|0,w|0,s|0,t|0)|0;F=+(a>>>0)+4294967296.0*+(J|0);a=TIc(o|0,v|0,p|0,q|0)|0;G=(+(a>>>0)+4294967296.0*+(J|0))*F;a=TIc(x|0,y|0,s|0,t|0)|0;F=G/(+(a>>>0)+4294967296.0*+(J|0));a=UIc(~~F>>>0|0,(+L(F)>=1.0?(F>0.0?~~+Z(+K(F/4294967296.0),4294967295.0)>>>0:~~+X((F-+(~~F>>>0))/4294967296.0)>>>0):0)|0,p|0,q|0)|0;q=J;p=b;f[p>>2]=a;f[p+4>>2]=q;p=m;f[p>>2]=j;f[p+4>>2]=w;p=aJc(a|0,q|0,63)|0;A=(((q|0)>(g|0)|(q|0)==(g|0)&a>>>0>=e>>>0)&1)<<1|p;B=a;C=q;D=j;E=w}if(!(z&12))H=z;else{w=z>>>0<8;j=w?0:i;i=w?0:k;k=n;w=f[k>>2]|0;q=f[k+4>>2]|0;k=TIc(j|0,i|0,w|0,q|0)|0;F=+(k>>>0)+4294967296.0*+(J|0);k=c;a=f[k>>2]|0;p=f[k+4>>2]|0;k=TIc(a|0,p|0,B|0,C|0)|0;G=F*(+(k>>>0)+4294967296.0*+(J|0));k=TIc(w|0,q|0,D|0,E|0)|0;F=G/(+(k>>>0)+4294967296.0*+(J|0));k=UIc(~~F>>>0|0,(+L(F)>=1.0?(F>0.0?~~+Z(+K(F/4294967296.0),4294967295.0)>>>0:~~+X((F-+(~~F>>>0))/4294967296.0)>>>0):0)|0,a|0,p|0)|0;p=J;a=c;f[a>>2]=k;f[a+4>>2]=p;a=n;f[a>>2]=j;f[a+4>>2]=i;i=aJc(k|0,p|0,63)|0;H=(((p|0)>(g|0)|(p|0)==(g|0)&k>>>0>=e>>>0)&1)<<1|i}if(!((H&A|0)!=0|(H|A|0)==0)){if(A|0){i=(A|0)==1;e=i?0:d;k=i?0:h;i=b;g=f[i>>2]|0;p=f[i+4>>2]|0;i=TIc(e|0,k|0,g|0,p|0)|0;F=+(i>>>0)+4294967296.0*+(J|0);i=n;a=m;j=f[a>>2]|0;E=f[a+4>>2]|0;a=TIc(f[i>>2]|0,f[i+4>>2]|0,j|0,E|0)|0;G=F*(+(a>>>0)+4294967296.0*+(J|0));a=c;i=TIc(f[a>>2]|0,f[a+4>>2]|0,g|0,p|0)|0;F=G/(+(i>>>0)+4294967296.0*+(J|0));i=UIc(~~F>>>0|0,(+L(F)>=1.0?(F>0.0?~~+Z(+K(F/4294967296.0),4294967295.0)>>>0:~~+X((F-+(~~F>>>0))/4294967296.0)>>>0):0)|0,j|0,E|0)|0;E=m;f[E>>2]=i;f[E+4>>2]=J;E=b;f[E>>2]=e;f[E+4>>2]=k}if(!H){I=0;M=0}else{k=(H|0)==1;E=k?0:d;d=k?0:h;h=c;k=f[h>>2]|0;e=f[h+4>>2]|0;h=TIc(E|0,d|0,k|0,e|0)|0;F=+(h>>>0)+4294967296.0*+(J|0);h=n;i=f[h>>2]|0;j=f[h+4>>2]|0;h=m;m=TIc(i|0,j|0,f[h>>2]|0,f[h+4>>2]|0)|0;G=F*(+(m>>>0)+4294967296.0*+(J|0));m=b;b=TIc(k|0,e|0,f[m>>2]|0,f[m+4>>2]|0)|0;F=G/(+(b>>>0)+4294967296.0*+(J|0));b=UIc(~~F>>>0|0,(+L(F)>=1.0?(F>0.0?~~+Z(+K(F/4294967296.0),4294967295.0)>>>0:~~+X((F-+(~~F>>>0))/4294967296.0)>>>0):0)|0,i|0,j|0)|0;j=n;f[j>>2]=b;f[j+4>>2]=J;j=c;f[j>>2]=E;f[j+4>>2]=d;I=0;M=0}}else{I=H;M=A}}else{I=z;M=u}l=(M|I|0)==0;return l|0}function bga(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;m=a+20|0;f[m>>2]=-1;n=(g|0)==8;switch(g|0){case 4:case 8:break;default:{f[j>>2]=0;f[j+4>>2]=0;g=tT(j,38)|0;o=256198;p=g+38|0;do{b[g>>0]=b[o>>0]|0;g=g+1|0;o=o+1|0}while((g|0)<(p|0));cga(-215,j,256237,168)}}o=f[d>>2]|0;g=f[c+12>>2]|0;p=f[e>>2]|0;if((o>>>0<g>>>0&p>>>0<g>>>0?(g=f[c+8>>2]|0,(f[d+4>>2]|0)>>>0<g>>>0):0)?(q=f[e+4>>2]|0,q>>>0<g>>>0):0){r=p;s=q}else{q=f[c+40>>2]|0;g=f[q+4>>2]|0;t=f[q>>2]|0;q=d+4|0;v=f[q>>2]|0;w=j;f[w>>2]=o;f[w+4>>2]=((o|0)<0)<<31>>31;o=j+8|0;w=o;f[w>>2]=v;f[w+4>>2]=((v|0)<0)<<31>>31;v=e+4|0;w=f[v>>2]|0;x=k;f[x>>2]=p;f[x+4>>2]=((p|0)<0)<<31>>31;p=k+8|0;x=p;f[x>>2]=w;f[x+4>>2]=((w|0)<0)<<31>>31;w=l;f[w>>2]=g;f[w+4>>2]=((g|0)<0)<<31>>31;g=l+8|0;f[g>>2]=t;f[g+4>>2]=((t|0)<0)<<31>>31;t=aga(l,j,k)|0;f[d>>2]=f[j>>2];f[q>>2]=f[o>>2];o=f[k>>2]|0;f[e>>2]=o;e=f[p>>2]|0;f[v>>2]=e;if(t){r=o;s=e}else{f[a>>2]=f[c+16>>2];e=a+16|0;f[a+4>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;y=0;z=0;A=a+8|0;f[A>>2]=z;B=a+12|0;f[B>>2]=y;u=i;return}}e=f[c+4>>2]|0;if((e|0)>0)C=f[(f[c+44>>2]|0)+(e+-1<<2)>>2]|0;else C=0;e=c+48|0;o=f[e>>2]|0;t=f[d>>2]|0;v=r-t|0;p=d+4|0;k=f[p>>2]|0;q=s-k|0;j=v>>31;l=(j^v)-j|0;if(h){h=j&(t^r)^t;f[d>>2]=h;d=(s^k)&j^k;f[p>>2]=d;D=(q^j)-j|0;E=C;F=d;G=h}else{D=q;E=(j^C)-j|0;F=k;G=t}t=c+16|0;c=(f[t>>2]|0)+(Y(F,o)|0)+(Y(G,C)|0)|0;f[a>>2]=c;c=D>>31;G=(c^D)-c|0;D=(c^o)-c|0;c=(G|0)>(l|0);o=(c?G:0)^l;l=(c?o:0)^G;G=(c?l:0)^o;o=(c?D:0)^E;E=(c?o:0)^D;D=(c?E:0)^o;o=G<<1;c=l<<1;if(n){H=o;I=G-c|0;J=G;K=E}else{H=o+c|0;I=0;J=G+l|0;K=E-D|0}f[a+16>>2]=I;f[a+28>>2]=H;f[a+24>>2]=0-c;f[a+36>>2]=K;f[a+32>>2]=D;f[m>>2]=J+1;f[a+4>>2]=f[t>>2];y=C;z=f[e>>2]|0;A=a+8|0;f[A>>2]=z;B=a+12|0;f[B>>2]=y;u=i;return}function cga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,256250,d);return}function dga(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=u;u=u+64|0;j=i+40|0;k=i+16|0;l=i;m=i+32|0;f[j>>2]=0;n=j+4|0;f[n>>2]=0;f[j+8>>2]=0;o=+(f[a+4>>2]|0);p[k>>3]=+(f[a>>2]|0);p[k+8>>3]=o;o=+(f[b+4>>2]|0);p[l>>3]=+(f[b>>2]|0);p[l+8>>3]=o;ega(k,l,c,d,e,g,j);g=h+4|0;e=f[g>>2]|0;d=f[h>>2]|0;c=e;if((e|0)==(d|0)|(c|0)==(d|0))q=e;else{e=c+(~((c+-8-d|0)>>>3)<<3)|0;f[g>>2]=e;q=e}e=f[n>>2]|0;c=f[j>>2]|0;l=c;if((e|0)==(c|0)){r=d;s=q;t=l}else{q=m+4|0;d=h+8|0;k=0;b=-2147483648;v=-2147483648;w=l;x=l;l=c;c=e;while(1){e=nrc(+p[w+(k<<4)>>3])|0;f[m>>2]=e;y=nrc(+p[w+(k<<4)+8>>3])|0;f[q>>2]=y;if((e|0)!=(b|0)|(y|0)!=(v|0)){z=f[g>>2]|0;if((z|0)==(f[d>>2]|0)){fga(h,m);A=f[n>>2]|0;B=f[j>>2]|0}else{f[z>>2]=e;f[z+4>>2]=y;f[g>>2]=z+8;A=c;B=l}C=f[m>>2]|0;D=f[q>>2]|0;E=B;F=A;G=B}else{C=b;D=v;E=l;F=c;G=x}k=k+1|0;if(k>>>0>=F-E>>4>>>0)break;else{b=C;v=D;w=E;x=G;l=E;c=F}}r=f[h>>2]|0;s=f[g>>2]|0;t=G}if((s-r|0)==8){gga(h,2,a);H=f[j>>2]|0}else H=t;if(!H){u=i;return}t=f[n>>2]|0;if((t|0)!=(H|0))f[n>>2]=t+(~((t+-16-H|0)>>>4)<<4);YDc(H);u=i;return}function ega(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0,E=0;i=u;u=u+16|0;j=i;k=((c|0)>0?c:0)+359-c|0;l=k-((k>>>0)%360|0)+c|0;c=~l;k=l+((c|0)>-361?c:-361)+360|0;c=l+(((k>>>0)%360|0)-k)|0;k=(d|0)>(e|0);l=k?d:e;m=k?e:d;if((m|0)<0){k=~((e|0)<(d|0)?e:d);d=((m|0)>-360?m:-360)+k+360|0;e=d-((d>>>0)%360|0)|0;o=e+359-k|0;q=l+e+360|0}else{o=m;q=l}if((q|0)>360){l=q+-361|0;m=l-((l>>>0)%360|0)|0;r=o+-360-m|0;s=q+-360-m|0}else{r=o;s=q}q=(s-r|0)>360;o=q?360:s;s=q?0:r;r=(c>>31&360)+c|0;t=+n[48080+(r<<2)>>2];v=+n[48080+(450-r<<2)>>2];r=h+4|0;c=f[r>>2]|0;q=f[h>>2]|0;m=c;if((c|0)==(q|0)|(m|0)==(q|0)){w=c;x=m}else{c=m+(~((m+-16-q|0)>>>4)<<4)|0;f[r>>2]=c;w=c;x=c}c=o+g|0;if((s|0)<(c|0)){m=b+8|0;y=v;v=t;l=a+8|0;e=j+8|0;k=h+8|0;d=s;s=x;while(1){x=(d|0)>(o|0)?o:d;z=(x|0)<0?x+360|0:x;t=+p[b>>3]*+n[48080+(450-z<<2)>>2];A=+p[m>>3]*+n[48080+(z<<2)>>2];B=y*t+ +p[a>>3]-v*A;p[j>>3]=B;C=y*A+(v*t+ +p[l>>3]);p[e>>3]=C;if((s|0)==(f[k>>2]|0))hga(h,j);else{p[s>>3]=B;p[s+8>>3]=C;f[r>>2]=s+16}z=d+g|0;if((z|0)>=(c|0))break;d=z;s=f[r>>2]|0}D=f[h>>2]|0;E=f[r>>2]|0}else{D=q;E=w}if((E-D|0)!=16){u=i;return}iga(h,2,a);u=i;return}function fga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;while(1){m=n;n=n+-8|0;f[j+-8>>2]=f[n>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-8|0}o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function gga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>3>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>3;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+4|0;o=m;m=h;while(1){f[m>>2]=f[c>>2];f[m+4>>2]=f[j>>2];o=o+-1|0;if(!o)break;else m=m+8|0}}if(!l){m=h+(b<<3)|0;if((n|0)==(m|0))return;else{p=i;q=n+(~((n+-8-m|0)>>>3)<<3)|0;break}}else{m=b-k|0;o=c+4|0;j=m;r=n;while(1){f[r>>2]=f[c>>2];f[r+4>>2]=f[o>>2];j=j+-1|0;if(!j)break;else r=r+8|0}p=i;q=n+(m<<3)|0;break}}else{r=g;if(!g)s=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-8-g|0)>>>3)<<3);YDc(r);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;s=0}if(b>>>0>536870911)mCc(a);j=s>>2;r=s>>3>>>0<268435455?(j>>>0<b>>>0?b:j):536870911;if(r>>>0>536870911)mCc(a);j=VDc(r<<3)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(r<<3);r=c+4|0;k=b;l=j;while(1){f[l>>2]=f[c>>2];f[l+4>>2]=f[r>>2];k=k+-1|0;if(!k)break;else l=l+8|0}p=o;q=j+(b<<3)|0}while(0);f[p>>2]=q;return}function hga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;p[l>>3]=+p[b>>3];p[n+(g<<4)+8>>3]=+p[b+8>>3];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;p[j+-16>>3]=+p[n>>3];p[j+-8>>3]=+p[m+-8>>3];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function iga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>4>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>4;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+8|0;o=m;m=h;while(1){p[m>>3]=+p[c>>3];p[m+8>>3]=+p[j>>3];o=o+-1|0;if(!o)break;else m=m+16|0}}if(!l){m=h+(b<<4)|0;if((n|0)==(m|0))return;else{q=i;r=n+(~((n+-16-m|0)>>>4)<<4)|0;break}}else{m=b-k|0;o=c+8|0;j=m;s=n;while(1){p[s>>3]=+p[c>>3];p[s+8>>3]=+p[o>>3];j=j+-1|0;if(!j)break;else s=s+16|0}q=i;r=n+(m<<4)|0;break}}else{s=g;if(!g)t=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-16-g|0)>>>4)<<4);YDc(s);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;t=0}if(b>>>0>268435455)mCc(a);j=t>>3;s=t>>4>>>0<134217727?(j>>>0<b>>>0?b:j):268435455;if(s>>>0>268435455)mCc(a);j=VDc(s<<4)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(s<<4);s=c+8|0;k=b;l=j;while(1){p[l>>3]=+p[c>>3];p[l+8>>3]=+p[s>>3];k=k+-1|0;if(!k)break;else l=l+16|0}q=o;r=j+(b<<4)|0}while(0);f[q>>2]=r;return}function jga(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;j=u;u=u+128|0;k=j+64|0;l=j+32|0;m=j+16|0;n=j;do if((d$(a)|0)==65536){o=f[a+4>>2]|0;f[k>>2]=f[o>>2];p=k+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=k+8|0;f[r>>2]=f[o+8>>2];f[k+12>>2]=f[o+12>>2];f[k+16>>2]=f[o+16>>2];f[k+20>>2]=f[o+20>>2];f[k+24>>2]=f[o+24>>2];f[k+28>>2]=f[o+28>>2];f[k+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[k+36>>2]=s;f[k+40>>2]=r;r=k+48|0;t=k+44|0;f[t>>2]=r;f[r>>2]=0;f[k+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;ZS(k,o);break}}else a$(k,a,-1);while(0);if((h|0)==16)v=(f[k>>2]&7|0)==0?16:8;else v=h;if((g+-1|0)>>>0>=32767){f[l>>2]=0;f[l+4>>2]=0;w=tT(l,43)|0;x=256319;y=w+43|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));cga(-215,l,256363,1811)}if(i>>>0>=17){f[l>>2]=0;f[l+4>>2]=0;w=tT(l,31)|0;x=256368;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));cga(-215,l,256363,1812)}c1(e,l,f[k>>2]&4095,0);e=f[c>>2]|0;x=f[c+4>>2]|0;c=m;f[c>>2]=e;f[c+4>>2]=((e|0)<0)<<31>>31;e=m+8|0;f[e>>2]=x;f[e+4>>2]=((x|0)<0)<<31>>31;x=f[d>>2]|0;e=f[d+4>>2]|0;d=n;f[d>>2]=x;f[d+4>>2]=((x|0)<0)<<31>>31;x=n+8|0;f[x>>2]=e;f[x+4>>2]=((e|0)<0)<<31>>31;kga(k,m,n,l,g,v,3,i);i=k+36|0;v=f[i>>2]|0;if(v|0?(g=v+12|0,v=f[g>>2]|0,f[g>>2]=v+-1,(v|0)==1):0)_S(k);f[i>>2]=0;i=k+16|0;v=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[v>>2]|0)>0){i=f[k+40>>2]|0;g=0;do{f[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[v>>2]|0))}v=f[k+44>>2]|0;if((v|0)==(k+48|0)){u=j;return}g0(v);u=j;return}function kga(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0.0,O=0.0,P=0.0,Q=0.0;j=u;u=u+176|0;k=j+80|0;l=j+64|0;m=j+48|0;n=j+32|0;o=j+96|0;p=j+160|0;q=j+16|0;r=j;s=16-i|0;t=b;v=jJc(f[t>>2]|0,f[t+4>>2]|0,s|0)|0;t=b;f[t>>2]=v;f[t+4>>2]=J;t=b+8|0;v=t;w=jJc(f[v>>2]|0,f[v+4>>2]|0,s|0)|0;v=t;f[v>>2]=w;f[v+4>>2]=J;v=c;w=jJc(f[v>>2]|0,f[v+4>>2]|0,s|0)|0;v=J;x=c;f[x>>2]=w;f[x+4>>2]=v;x=c+8|0;y=x;z=jJc(f[y>>2]|0,f[y+4>>2]|0,s|0)|0;s=J;y=x;f[y>>2]=z;f[y+4>>2]=s;if((e|0)<2){if((g|0)>=16){y=b;A=f[y+4>>2]|0;B=m;f[B>>2]=f[y>>2];f[B+4>>2]=A;A=t;B=f[A+4>>2]|0;y=m+8|0;f[y>>2]=f[A>>2];f[y+4>>2]=B;B=n;f[B>>2]=w;f[B+4>>2]=v;B=n+8|0;f[B>>2]=z;f[B+4>>2]=s;nga(a,m,n,d);u=j;return}a:do if(i|0){switch(g|0){case 1:case 4:{break a;break}default:{}}n=b;m=f[n+4>>2]|0;B=k;f[B>>2]=f[n>>2];f[B+4>>2]=m;m=t;B=f[m+4>>2]|0;n=k+8|0;f[n>>2]=f[m>>2];f[n+4>>2]=B;B=l;f[B>>2]=w;f[B+4>>2]=v;B=l+8|0;f[B>>2]=z;f[B+4>>2]=s;mga(a,k,l,d);u=j;return}while(0);l=b;k=UIc(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=$Ic(k|0,J|0,16)|0;k=b;f[k>>2]=l;f[k+4>>2]=J;k=t;l=UIc(f[k>>2]|0,f[k+4>>2]|0,32768,0)|0;k=$Ic(l|0,J|0,16)|0;l=t;f[l>>2]=k;f[l+4>>2]=J;l=c;k=UIc(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=$Ic(k|0,J|0,16)|0;k=J;i=c;f[i>>2]=l;f[i+4>>2]=k;i=x;B=UIc(f[i>>2]|0,f[i+4>>2]|0,32768,0)|0;i=$Ic(B|0,J|0,16)|0;B=J;n=x;f[n>>2]=i;f[n+4>>2]=B;n=b;m=f[n>>2]|0;y=f[n+4>>2]|0;n=UIc(m|0,y|0,-2147483648,0)|0;A=J;C=t;D=f[C>>2]|0;E=f[C+4>>2]|0;C=UIc(D|0,E|0,-2147483648,0)|0;F=J;G=UIc(l|0,k|0,-2147483648,0)|0;H=J;I=UIc(i|0,B|0,-2147483648,0)|0;K=J;lga(a,A>>>0<1|(A|0)==1&n>>>0<0?m:(y|0)>0|(y|0)==0&m>>>0>0?2147483647:-2147483648,F>>>0<1|(F|0)==1&C>>>0<0?D:(E|0)>0|(E|0)==0&D>>>0>0?2147483647:-2147483648,H>>>0<1|(H|0)==1&G>>>0<0?l:(k|0)>0|(k|0)==0&l>>>0>0?2147483647:-2147483648,K>>>0<1|(K|0)==1&I>>>0<0?i:(B|0)>0|(B|0)==0&i>>>0>0?2147483647:-2147483648,d,g);u=j;return}i=o;B=i+64|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(B|0));i=b;B=f[i>>2]|0;I=f[i+4>>2]|0;i=TIc(B|0,I|0,w|0,v|0)|0;N=(+(i>>>0)+4294967296.0*+(J|0))*.0000152587890625;i=t;K=f[i>>2]|0;l=f[i+4>>2]|0;i=TIc(z|0,s|0,K|0,l|0)|0;O=(+(i>>>0)+4294967296.0*+(J|0))*.0000152587890625;P=N*N+O*O;i=e<<15;if(+L(+P)>2.220446049250313e-16){Q=(+(i|0)+ +(e<<16&65536|0)*.5)/+M(+P);e=nrc(O*Q)|0;k=((e|0)<0)<<31>>31;G=nrc(N*Q)|0;H=((G|0)<0)<<31>>31;D=UIc(e|0,k|0,B|0,I|0)|0;E=o;f[E>>2]=D;f[E+4>>2]=J;E=UIc(K|0,l|0,G|0,H|0)|0;D=o+8|0;f[D>>2]=E;f[D+4>>2]=J;D=TIc(B|0,I|0,e|0,k|0)|0;I=o+16|0;f[I>>2]=D;f[I+4>>2]=J;I=TIc(K|0,l|0,G|0,H|0)|0;l=o+24|0;f[l>>2]=I;f[l+4>>2]=J;l=TIc(w|0,v|0,e|0,k|0)|0;I=o+32|0;f[I>>2]=l;f[I+4>>2]=J;I=TIc(z|0,s|0,G|0,H|0)|0;l=o+40|0;f[l>>2]=I;f[l+4>>2]=J;l=UIc(w|0,v|0,e|0,k|0)|0;k=o+48|0;f[k>>2]=l;f[k+4>>2]=J;k=UIc(z|0,s|0,G|0,H|0)|0;H=o+56|0;f[H>>2]=k;f[H+4>>2]=J;oga(a,o,4,d,g,16)}o=p+4|0;H=i+32768>>16;k=q+8|0;G=((i|0)<0)<<31>>31;s=r+8|0;z=(h&1|0)==0;if((g|0)<16){if(!z){l=b;e=UIc(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=aJc(e|0,J|0,16)|0;e=t;v=UIc(f[e>>2]|0,f[e+4>>2]|0,32768,0)|0;e=aJc(v|0,J|0,16)|0;f[p>>2]=l;f[o>>2]=e;pga(a,p,H,d,1)}e=c;l=f[e>>2]|0;v=f[e+4>>2]|0;e=b;f[e>>2]=l;f[e+4>>2]=v;e=x;w=f[e>>2]|0;I=f[e+4>>2]|0;e=t;f[e>>2]=w;f[e+4>>2]=I;if(h&2|0){e=UIc(l|0,v|0,32768,0)|0;v=aJc(e|0,J|0,16)|0;e=UIc(w|0,I|0,32768,0)|0;I=aJc(e|0,J|0,16)|0;f[p>>2]=v;f[o>>2]=I;pga(a,p,H,d,1)}}else{if(!z){z=b;H=f[z+4>>2]|0;p=q;f[p>>2]=f[z>>2];f[p+4>>2]=H;H=t;p=f[H+4>>2]|0;z=k;f[z>>2]=f[H>>2];f[z+4>>2]=p;p=r;f[p>>2]=i;f[p+4>>2]=G;p=s;f[p>>2]=i;f[p+4>>2]=G;qga(a,q,r,0,0,360,d,-1,g)}p=c;z=f[p>>2]|0;H=f[p+4>>2]|0;p=b;f[p>>2]=z;f[p+4>>2]=H;p=x;I=f[p>>2]|0;o=f[p+4>>2]|0;p=t;f[p>>2]=I;f[p+4>>2]=o;if(h&2|0){h=q;f[h>>2]=z;f[h+4>>2]=H;H=k;f[H>>2]=I;f[H+4>>2]=o;o=r;f[o>>2]=i;f[o+4>>2]=G;o=s;f[o>>2]=i;f[o+4>>2]=G;qga(a,q,r,0,0,360,d,-1,g)}}g=c;c=f[g+4>>2]|0;d=b;f[d>>2]=f[g>>2];f[d+4>>2]=c;c=x;x=f[c+4>>2]|0;d=t;f[d>>2]=f[c>>2];f[d+4>>2]=x;u=j;return}function lga(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=u;u=u+64|0;k=j+16|0;l=j+8|0;m=j;switch(i|0){case 0:{n=8;break}case 1:{n=4;break}default:n=i}f[l>>2]=c;f[l+4>>2]=d;f[m>>2]=e;f[m+4>>2]=g;bga(k,a,l,m,n,1);n=f[k+20>>2]|0;m=f[a+4>>2]|0;if((m|0)>0)o=f[(f[a+44>>2]|0)+(m+-1<<2)>>2]|0;else o=0;if((n|0)<=0){u=j;return}m=k+16|0;a=k+24|0;l=k+28|0;g=k+32|0;e=k+36|0;d=h+1|0;c=h+2|0;switch(o|0){case 1:{i=0;p=f[k>>2]|0;do{b[p>>0]=b[h>>0]|0;i=i+1|0;q=f[m>>2]|0;r=q>>31;f[m>>2]=(f[a>>2]|0)+q+(f[l>>2]&r);p=(f[k>>2]|0)+((f[e>>2]&r)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}case 3:{i=0;p=f[k>>2]|0;do{b[p>>0]=b[h>>0]|0;b[p+1>>0]=b[d>>0]|0;b[p+2>>0]=b[c>>0]|0;i=i+1|0;r=f[m>>2]|0;q=r>>31;f[m>>2]=(f[a>>2]|0)+r+(f[l>>2]&q);p=(f[k>>2]|0)+((f[e>>2]&q)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}default:{i=0;p=f[k>>2]|0;do{dJc(p|0,h|0,o|0)|0;i=i+1|0;c=f[m>>2]|0;d=c>>31;f[m>>2]=(f[a>>2]|0)+c+(f[l>>2]&d);p=(f[k>>2]|0)+((f[e>>2]&d)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}}}function mga(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;g=u;u=u+16|0;h=g;i=b[e>>0]|0;j=b[e+1>>0]|0;k=b[e+2>>0]|0;l=f[a+4>>2]|0;if((l|0)>0)m=f[(f[a+44>>2]|0)+(l+-1<<2)>>2]|0;else m=0;l=f[a+16>>2]|0;n=f[a+48>>2]|0;o=f[a+40>>2]|0;a=f[o+4>>2]|0;p=f[o>>2]|0;o=jJc(a|0,((a|0)<0)<<31>>31|0,16)|0;q=J;r=jJc(p|0,((p|0)<0)<<31>>31|0,16)|0;s=h;f[s>>2]=o;f[s+4>>2]=q;q=h+8|0;f[q>>2]=r;f[q+4>>2]=J;if(!(aga(h,c,d)|0)){u=g;return}h=d;q=f[h>>2]|0;r=f[h+4>>2]|0;h=c;s=f[h>>2]|0;o=f[h+4>>2]|0;h=TIc(q|0,r|0,s|0,o|0)|0;t=J;v=d+8|0;w=v;x=f[w>>2]|0;y=f[w+4>>2]|0;w=c+8|0;z=w;A=f[z>>2]|0;B=f[z+4>>2]|0;z=TIc(x|0,y|0,A|0,B|0)|0;C=J;D=$Ic(h|0,t|0,63)|0;E=J;F=TIc(D^h|0,E^t|0,D|0,E|0)|0;G=J;H=$Ic(z|0,C|0,63)|0;I=J;K=TIc(H^z|0,I^C|0,H|0,I|0)|0;L=J;M=(G|0)>(L|0)|(G|0)==(L|0)&F>>>0>K>>>0;if(M){N=TIc(z^D|0,C^E|0,D|0,E|0)|0;C=D&q^s;z=E&r^o;O=c;f[O>>2]=C;f[O+4>>2]=z;O=d;P=f[O>>2]^C&D;C=f[O+4>>2]^z&E;z=d;f[z>>2]=P;f[z+4>>2]=C;z=c;O=f[z>>2]^P&D;P=f[z+4>>2]^C&E;C=c;f[C>>2]=O;f[C+4>>2]=P;C=D&x^A;z=E&y^B;Q=w;f[Q>>2]=C;f[Q+4>>2]=z;Q=v;R=f[Q>>2]^C&D;C=f[Q+4>>2]^z&E;z=v;f[z>>2]=R;f[z+4>>2]=C;z=w;Q=f[z>>2]^R&D;D=f[z+4>>2]^C&E;E=w;f[E>>2]=Q;f[E+4>>2]=D;E=jJc(N|0,J|0,16)|0;N=kJc(E|0,J|0,F|1|0,G|0)|0;S=d;T=O;U=P;V=O;W=P;X=Q;Z=D;_=N;$=J;aa=65536;ba=0}else{N=TIc(H^h|0,I^t|0,H|0,I|0)|0;t=H&q^s;s=I&r^o;o=c;f[o>>2]=t;f[o+4>>2]=s;o=d;r=f[o>>2]^t&H;t=f[o+4>>2]^s&I;s=d;f[s>>2]=r;f[s+4>>2]=t;s=c;o=f[s>>2]^r&H;r=f[s+4>>2]^t&I;t=c;f[t>>2]=o;f[t+4>>2]=r;t=A^x&H;x=B^y&I;y=w;f[y>>2]=t;f[y+4>>2]=x;y=v;B=f[y>>2]^t&H;t=f[y+4>>2]^x&I;x=v;f[x>>2]=B;f[x+4>>2]=t;x=w;y=f[x>>2]^B&H;H=f[x+4>>2]^t&I;I=w;f[I>>2]=y;f[I+4>>2]=H;I=jJc(N|0,J|0,16)|0;N=kJc(I|0,J|0,K|1|0,L|0)|0;S=v;T=y;U=H;V=o;W=r;X=y;Z=H;_=65536;$=0;aa=N;ba=J}N=S;S=TIc(f[N>>2]|0,f[N+4>>2]|0,T|0,U|0)|0;U=aJc(S|0,J|0,16)|0;S=UIc(V|0,W|0,32768,0)|0;W=c;f[W>>2]=S;f[W+4>>2]=J;W=UIc(X|0,Z|0,32768,0)|0;Z=w;f[Z>>2]=W;f[Z+4>>2]=J;Z=d;d=v;v=f[d>>2]|0;W=f[d+4>>2]|0;d=UIc(f[Z>>2]|0,f[Z+4>>2]|0,32768,0)|0;Z=J;X=UIc(v|0,W|0,32768,0)|0;W=aJc(X|0,J|0,16)|0;X=aJc(d|0,Z|0,16)|0;Z=(X|0)>-1;switch(m|0){case 3:{if(Z?(d=l+(Y(W,n)|0)+(X*3|0)|0,(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1)):0){b[d>>0]=i;b[d+1>>0]=j;b[d+2>>0]=k}if(M){d=c;v=$Ic(f[d>>2]|0,f[d+4>>2]|0,16)|0;d=J;S=c;f[S>>2]=v;f[S+4>>2]=d;if((U|0)<=-1){u=g;return}S=w;V=U;T=f[S>>2]|0;N=f[S+4>>2]|0;S=v;v=d;while(1){d=aJc(T|0,N|0,16)|0;if((S|0)>-1?(H=l+(Y(d,n)|0)+(S*3|0)|0,(d|0)<(p|0)&((S|0)<(a|0)&(d|0)>-1)):0){b[H>>0]=i;b[H+1>>0]=j;b[H+2>>0]=k;H=c;d=w;ca=f[H>>2]|0;da=f[H+4>>2]|0;ea=f[d>>2]|0;fa=f[d+4>>2]|0}else{ca=S;da=v;ea=T;fa=N}S=UIc(ca|0,da|0,1,0)|0;v=J;d=c;f[d>>2]=S;f[d+4>>2]=v;T=UIc(ea|0,fa|0,_|0,$|0)|0;N=J;d=w;f[d>>2]=T;f[d+4>>2]=N;if((V|0)<=0)break;else V=V+-1|0}u=g;return}else{V=w;N=$Ic(f[V>>2]|0,f[V+4>>2]|0,16)|0;V=J;T=w;f[T>>2]=N;f[T+4>>2]=V;if((U|0)<=-1){u=g;return}T=c;fa=U;ea=f[T>>2]|0;v=f[T+4>>2]|0;T=N;N=V;while(1){V=aJc(ea|0,v|0,16)|0;if((V|0)>-1?(S=l+(Y(T,n)|0)+(V*3|0)|0,(T|0)<(p|0)&((V|0)<(a|0)&(T|0)>-1)):0){b[S>>0]=i;b[S+1>>0]=j;b[S+2>>0]=k;S=c;V=w;ga=f[S>>2]|0;ha=f[S+4>>2]|0;ia=f[V>>2]|0;ja=f[V+4>>2]|0}else{ga=ea;ha=v;ia=T;ja=N}ea=UIc(ga|0,ha|0,aa|0,ba|0)|0;v=J;V=c;f[V>>2]=ea;f[V+4>>2]=v;T=UIc(ia|0,ja|0,1,0)|0;N=J;V=w;f[V>>2]=T;f[V+4>>2]=N;if((fa|0)<=0)break;else fa=fa+-1|0}u=g;return}break}case 1:{if(Z?(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1):0){fa=l+(Y(W,n)|0)+X|0;b[fa>>0]=i}if(M){fa=c;N=$Ic(f[fa>>2]|0,f[fa+4>>2]|0,16)|0;fa=J;T=c;f[T>>2]=N;f[T+4>>2]=fa;if((U|0)<=-1){u=g;return}T=w;ja=U;ia=f[T>>2]|0;v=f[T+4>>2]|0;T=N;N=fa;while(1){fa=aJc(ia|0,v|0,16)|0;if((T|0)>-1?(fa|0)<(p|0)&((T|0)<(a|0)&(fa|0)>-1):0){ea=l+(Y(fa,n)|0)+T|0;b[ea>>0]=i;ea=c;fa=w;ka=f[ea>>2]|0;la=f[ea+4>>2]|0;ma=f[fa>>2]|0;na=f[fa+4>>2]|0}else{ka=T;la=N;ma=ia;na=v}T=UIc(ka|0,la|0,1,0)|0;N=J;fa=c;f[fa>>2]=T;f[fa+4>>2]=N;ia=UIc(ma|0,na|0,_|0,$|0)|0;v=J;fa=w;f[fa>>2]=ia;f[fa+4>>2]=v;if((ja|0)<=0)break;else ja=ja+-1|0}u=g;return}else{ja=w;v=$Ic(f[ja>>2]|0,f[ja+4>>2]|0,16)|0;ja=J;ia=w;f[ia>>2]=v;f[ia+4>>2]=ja;if((U|0)<=-1){u=g;return}ia=c;na=U;ma=f[ia>>2]|0;N=f[ia+4>>2]|0;ia=v;v=ja;while(1){ja=aJc(ma|0,N|0,16)|0;if((ja|0)>-1?(ia|0)<(p|0)&((ja|0)<(a|0)&(ia|0)>-1):0){T=l+(Y(ia,n)|0)+ja|0;b[T>>0]=i;T=c;ja=w;oa=f[T>>2]|0;pa=f[T+4>>2]|0;qa=f[ja>>2]|0;ra=f[ja+4>>2]|0}else{oa=ma;pa=N;qa=ia;ra=v}ma=UIc(oa|0,pa|0,aa|0,ba|0)|0;N=J;ja=c;f[ja>>2]=ma;f[ja+4>>2]=N;ia=UIc(qa|0,ra|0,1,0)|0;v=J;ja=w;f[ja>>2]=ia;f[ja+4>>2]=v;if((na|0)<=0)break;else na=na+-1|0}u=g;return}break}default:{if((Z?(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1):0)?(Z=l+(Y(W,n)|0)+(Y(X,m)|0)|0,X=((m|0)<0)<<31>>31,(m|0)>0):0){W=0;na=0;do{b[Z+W>>0]=b[e+W>>0]|0;W=UIc(W|0,na|0,1,0)|0;na=J}while((na|0)<(X|0)|(na|0)==(X|0)&W>>>0<m>>>0)}if(M){M=c;W=$Ic(f[M>>2]|0,f[M+4>>2]|0,16)|0;M=J;X=c;f[X>>2]=W;f[X+4>>2]=M;if((U|0)<=-1){u=g;return}X=((m|0)<0)<<31>>31;na=w;Z=f[na>>2]|0;v=f[na+4>>2]|0;if((m|0)>0){sa=U;ta=Z;ua=v;va=W;wa=M}else{na=U;ia=W;W=M;M=Z;Z=v;while(1){ia=UIc(ia|0,W|0,1,0)|0;W=J;M=UIc(M|0,Z|0,_|0,$|0)|0;Z=J;if((na|0)<=0)break;else na=na+-1|0}na=c;f[na>>2]=ia;f[na+4>>2]=W;W=w;f[W>>2]=M;f[W+4>>2]=Z;u=g;return}while(1){Z=aJc(ta|0,ua|0,16)|0;if((va|0)>-1?(Z|0)<(p|0)&((va|0)<(a|0)&(Z|0)>-1):0){W=l+(Y(Z,n)|0)+(Y(va,m)|0)|0;Z=0;M=0;do{b[W+Z>>0]=b[e+Z>>0]|0;Z=UIc(Z|0,M|0,1,0)|0;M=J}while((M|0)<(X|0)|(M|0)==(X|0)&Z>>>0<m>>>0);Z=c;M=w;xa=f[Z>>2]|0;ya=f[Z+4>>2]|0;za=f[M>>2]|0;Aa=f[M+4>>2]|0}else{xa=va;ya=wa;za=ta;Aa=ua}va=UIc(xa|0,ya|0,1,0)|0;wa=J;M=c;f[M>>2]=va;f[M+4>>2]=wa;ta=UIc(za|0,Aa|0,_|0,$|0)|0;ua=J;M=w;f[M>>2]=ta;f[M+4>>2]=ua;if((sa|0)<=0)break;else sa=sa+-1|0}u=g;return}else{sa=w;ua=$Ic(f[sa>>2]|0,f[sa+4>>2]|0,16)|0;sa=J;ta=w;f[ta>>2]=ua;f[ta+4>>2]=sa;if((U|0)<=-1){u=g;return}ta=((m|0)<0)<<31>>31;$=c;_=f[$>>2]|0;Aa=f[$+4>>2]|0;if((m|0)>0){Ba=U;Ca=_;Da=Aa;Ea=ua;Fa=sa}else{$=U;U=_;_=Aa;Aa=ua;ua=sa;while(1){U=UIc(U|0,_|0,aa|0,ba|0)|0;_=J;Aa=UIc(Aa|0,ua|0,1,0)|0;ua=J;if(($|0)<=0)break;else $=$+-1|0}$=c;f[$>>2]=U;f[$+4>>2]=_;_=w;f[_>>2]=Aa;f[_+4>>2]=ua;u=g;return}while(1){ua=aJc(Ca|0,Da|0,16)|0;if((ua|0)>-1?(Ea|0)<(p|0)&((ua|0)<(a|0)&(Ea|0)>-1):0){_=l+(Y(Ea,n)|0)+(Y(ua,m)|0)|0;ua=0;Aa=0;do{b[_+ua>>0]=b[e+ua>>0]|0;ua=UIc(ua|0,Aa|0,1,0)|0;Aa=J}while((Aa|0)<(ta|0)|(Aa|0)==(ta|0)&ua>>>0<m>>>0);ua=c;Aa=w;Ga=f[ua>>2]|0;Ha=f[ua+4>>2]|0;Ia=f[Aa>>2]|0;Ja=f[Aa+4>>2]|0}else{Ga=Ca;Ha=Da;Ia=Ea;Ja=Fa}Ca=UIc(Ga|0,Ha|0,aa|0,ba|0)|0;Da=J;Aa=c;f[Aa>>2]=Ca;f[Aa+4>>2]=Da;Ea=UIc(Ia|0,Ja|0,1,0)|0;Fa=J;Aa=w;f[Aa>>2]=Ea;f[Aa+4>>2]=Fa;if((Ba|0)<=0)break;else Ba=Ba+-1|0}u=g;return}}}}function nga(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;g=u;u=u+64|0;i=g+16|0;j=g;k=h[e>>0]|0;l=h[e+1>>0]|0;m=h[e+2>>0]|0;n=h[e+3>>0]|0;o=f[a>>2]|0;p=o>>>3;q=f[a+16>>2]|0;r=f[a+48>>2]|0;s=f[a+40>>2]|0;t=f[s+4>>2]|0;v=f[s>>2]|0;s=p&65535;switch(s&511){case 0:case 2:case 3:{if(!(o&7)){o=c;w=UIc(f[o>>2]|0,f[o+4>>2]|0,-131072,-1)|0;o=c;f[o>>2]=w;f[o+4>>2]=J;o=c+8|0;w=o;x=UIc(f[w>>2]|0,f[w+4>>2]|0,-131072,-1)|0;w=o;f[w>>2]=x;f[w+4>>2]=J;w=d;x=UIc(f[w>>2]|0,f[w+4>>2]|0,-131072,-1)|0;w=d;f[w>>2]=x;f[w+4>>2]=J;w=d+8|0;x=w;y=UIc(f[x>>2]|0,f[x+4>>2]|0,-131072,-1)|0;x=w;f[x>>2]=y;f[x+4>>2]=J;x=q+((p&511)+1+r<<1)|0;p=jJc(t|0,((t|0)<0)<<31>>31|0,16)|0;t=UIc(p|0,J|0,-327679,-1)|0;p=J;q=jJc(v|0,((v|0)<0)<<31>>31|0,16)|0;v=UIc(q|0,J|0,-327679,-1)|0;q=j;f[q>>2]=t;f[q+4>>2]=p;p=j+8|0;f[p>>2]=v;f[p+4>>2]=J;if(!(aga(j,c,d)|0)){u=g;return}j=d;p=f[j>>2]|0;v=f[j+4>>2]|0;j=c;q=f[j>>2]|0;t=f[j+4>>2]|0;j=TIc(p|0,v|0,q|0,t|0)|0;y=J;z=w;A=f[z>>2]|0;B=f[z+4>>2]|0;z=o;C=f[z>>2]|0;D=f[z+4>>2]|0;z=TIc(A|0,B|0,C|0,D|0)|0;E=J;F=$Ic(j|0,y|0,63)|0;G=J;H=TIc(F^j|0,G^y|0,F|0,G|0)|0;I=J;K=$Ic(z|0,E|0,63)|0;L=J;M=TIc(K^z|0,L^E|0,K|0,L|0)|0;N=J;O=(I|0)>(N|0)|(I|0)==(N|0)&H>>>0>M>>>0;if(O){P=TIc(z^F|0,E^G|0,F|0,G|0)|0;E=F&p^q;z=G&v^t;Q=c;f[Q>>2]=E;f[Q+4>>2]=z;Q=d;R=f[Q>>2]^E&F;E=f[Q+4>>2]^z&G;z=d;f[z>>2]=R;f[z+4>>2]=E;z=c;Q=f[z+4>>2]^E&G;E=c;f[E>>2]=f[z>>2]^R&F;f[E+4>>2]=Q;Q=F&A^C;E=G&B^D;R=o;f[R>>2]=Q;f[R+4>>2]=E;R=w;z=f[R>>2]^Q&F;Q=f[R+4>>2]^E&G;E=w;f[E>>2]=z;f[E+4>>2]=Q;E=o;R=f[E>>2]^z&F;F=f[E+4>>2]^Q&G;G=jJc(P|0,J|0,16)|0;P=kJc(G|0,J|0,H|1|0,I|0)|0;I=J;H=d;G=UIc(f[H>>2]|0,f[H+4>>2]|0,65536,0)|0;H=J;Q=d;f[Q>>2]=G;f[Q+4>>2]=H;Q=aJc(G|0,H|0,16)|0;E=J;z=c;S=f[z>>2]|0;T=f[z+4>>2]|0;z=aJc(S|0,T|0,16)|0;U=TIc(Q|0,E|0,z|0,J|0)|0;z=TIc(0,0,P|0,I|0)|0;E=mJc(S&65535|0,0,z|0,J|0)|0;z=$Ic(E|0,J|0,16)|0;E=J;Q=UIc(R|0,F|0,32768,0)|0;F=UIc(Q|0,J|0,z|0,E|0)|0;E=J;z=o;f[z>>2]=F;f[z+4>>2]=E;z=aJc(P|0,I|0,11)|0;Q=$Ic(S|0,T|0,9)|0;R=J;V=$Ic(G|0,H|0,9)|0;W=U;X=z&63^((I|0)<0?63:0);Z=J;_=R;$=Q;aa=V;ba=S;ca=T;da=P;ea=I;fa=F;ga=E;ha=65536;ia=0}else{E=TIc(K^j|0,L^y|0,K|0,L|0)|0;y=K&p^q;q=L&v^t;t=c;f[t>>2]=y;f[t+4>>2]=q;t=d;v=f[t>>2]^y&K;y=f[t+4>>2]^q&L;q=d;f[q>>2]=v;f[q+4>>2]=y;q=c;t=f[q>>2]^v&K;v=f[q+4>>2]^y&L;y=C^A&K;A=D^B&L;B=o;f[B>>2]=y;f[B+4>>2]=A;B=w;D=f[B>>2]^y&K;y=f[B+4>>2]^A&L;A=w;f[A>>2]=D;f[A+4>>2]=y;A=o;B=f[A+4>>2]^y&L;L=o;f[L>>2]=f[A>>2]^D&K;f[L+4>>2]=B;B=jJc(E|0,J|0,16)|0;E=kJc(B|0,J|0,M|1|0,N|0)|0;N=J;M=w;B=UIc(f[M>>2]|0,f[M+4>>2]|0,65536,0)|0;M=J;L=w;f[L>>2]=B;f[L+4>>2]=M;L=aJc(B|0,M|0,16)|0;w=J;K=o;D=f[K>>2]|0;A=f[K+4>>2]|0;K=aJc(D|0,A|0,16)|0;y=TIc(L|0,w|0,K|0,J|0)|0;K=TIc(0,0,E|0,N|0)|0;w=mJc(D&65535|0,0,K|0,J|0)|0;K=$Ic(w|0,J|0,16)|0;w=J;L=UIc(t|0,v|0,32768,0)|0;v=UIc(L|0,J|0,K|0,w|0)|0;w=J;K=c;f[K>>2]=v;f[K+4>>2]=w;K=aJc(E|0,N|0,11)|0;L=aJc(D|0,A|0,9)|0;t=J;C=aJc(B|0,M|0,9)|0;W=y;X=K&63^((N|0)<0?63:0);Z=J;_=t;$=L;aa=C;ba=v;ca=w;da=65536;ea=0;fa=D;ga=A;ha=E;ia=N}N=$&120;$=aa&120;if(!(X&32))ja=h[256459+X>>0]|0;else ja=256;X=ja<<7;aa=Y(ja,120-N|4)|0;E=Y(ja,$|4)|0;f[i>>2]=0;f[i+32>>2]=ja;A=TIc($|0,0,N|0,0)|0;N=J;$=mJc(ja|0,0,A&120|4|0,0)|0;D=aJc($|0,J|0,8)|0;f[i+12>>2]=D;f[i+4>>2]=D;f[i+8>>2]=aa>>>8&511;D=UIc(A|0,N|0,128,0)|0;N=mJc(ja|0,0,D|4|0,J|0)|0;D=aJc(N|0,J|0,8)|0;f[i+16>>2]=D&511;f[i+20>>2]=(aa+X|0)>>>8&511;f[i+24>>2]=E>>>8;f[i+28>>2]=(E+X|0)>>>8&511;switch(s&511){case 2:{s=(W|0)>-1;if(O){if(!s){u=g;return}X=$Ic(ba|0,ca|0,16)|0;E=mJc(X|0,J|0,3,0)|0;X=0;aa=x+E|0;E=W;D=fa;N=ga;while(1){ja=$Ic(D|0,N|0,16)|0;A=UIc(ja|0,J|0,-1,-1)|0;ja=mJc(A|0,J|0,r|0,0)|0;A=aa+ja|0;ja=f[i+(((((X|0)>1?2:1)&(X|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;$=aJc(D|0,N|0,11)|0;w=$&31;$=(Y(f[49884+((w|32)<<2)>>2]|0,ja)|0)>>>8&255;v=h[A>>0]|0;C=(((Y(k-v|0,$)|0)+127|0)>>>8)+v|0;v=A+1|0;L=h[v>>0]|0;t=(((Y(l-L|0,$)|0)+127|0)>>>8)+L|0;L=A+2|0;_=h[L>>0]|0;Z=(((Y(m-_|0,$)|0)+127|0)>>>8)+_|0;_=(((Y(l-(t&255)|0,$)|0)+127|0)>>>8)+t|0;t=(((Y(m-(Z&255)|0,$)|0)+127|0)>>>8)+Z|0;Z=(((Y(k-(C&255)|0,$)|0)+127|0)>>>8)+C&255;b[A>>0]=Z;b[v>>0]=_;b[L>>0]=t;t=A+r|0;A=(Y(f[49884+(w<<2)>>2]|0,ja)|0)>>>8&255;L=h[t>>0]|0;_=(((Y(k-L|0,A)|0)+127|0)>>>8)+L|0;L=t+1|0;v=h[L>>0]|0;Z=(((Y(l-v|0,A)|0)+127|0)>>>8)+v|0;v=t+2|0;C=h[v>>0]|0;$=(((Y(m-C|0,A)|0)+127|0)>>>8)+C|0;C=(((Y(l-(Z&255)|0,A)|0)+127|0)>>>8)+Z|0;Z=(((Y(m-($&255)|0,A)|0)+127|0)>>>8)+$|0;$=(((Y(k-(_&255)|0,A)|0)+127|0)>>>8)+_&255;b[t>>0]=$;b[L>>0]=C;b[v>>0]=Z;Z=t+r|0;t=(Y(f[49884+((w^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[Z>>0]|0;w=(((Y(k-ja|0,t)|0)+127|0)>>>8)+ja|0;ja=Z+1|0;v=h[ja>>0]|0;C=(((Y(l-v|0,t)|0)+127|0)>>>8)+v|0;v=Z+2|0;L=h[v>>0]|0;$=(((Y(m-L|0,t)|0)+127|0)>>>8)+L|0;L=(((Y(l-(C&255)|0,t)|0)+127|0)>>>8)+C|0;C=(((Y(m-($&255)|0,t)|0)+127|0)>>>8)+$|0;$=(((Y(k-(w&255)|0,t)|0)+127|0)>>>8)+w&255;b[Z>>0]=$;b[ja>>0]=L;b[v>>0]=C;C=o;D=UIc(f[C>>2]|0,f[C+4>>2]|0,da|0,ea|0)|0;N=J;C=o;f[C>>2]=D;f[C+4>>2]=N;if((E|0)<=0)break;else{X=X+1|0;aa=aa+3|0;E=E+-1|0}}u=g;return}else{if(!s){u=g;return}s=$Ic(fa|0,ga|0,16)|0;E=mJc(s|0,J|0,r|0,0)|0;s=0;aa=x+E|0;E=W;X=ba;N=ca;while(1){D=$Ic(X|0,N|0,16)|0;C=mJc(D|0,J|0,3,0)|0;D=UIc(C|0,J|0,-3,0)|0;C=aa+D|0;D=f[i+(((((s|0)>1?2:1)&(s|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;v=aJc(X|0,N|0,11)|0;L=v&31;v=(Y(f[49884+((L|32)<<2)>>2]|0,D)|0)>>>8&255;ja=h[C>>0]|0;$=(((Y(k-ja|0,v)|0)+127|0)>>>8)+ja|0;ja=C+1|0;Z=h[ja>>0]|0;w=(((Y(l-Z|0,v)|0)+127|0)>>>8)+Z|0;Z=C+2|0;t=h[Z>>0]|0;_=(((Y(m-t|0,v)|0)+127|0)>>>8)+t|0;t=(((Y(l-(w&255)|0,v)|0)+127|0)>>>8)+w|0;w=(((Y(m-(_&255)|0,v)|0)+127|0)>>>8)+_|0;_=(((Y(k-($&255)|0,v)|0)+127|0)>>>8)+$&255;b[C>>0]=_;b[ja>>0]=t;b[Z>>0]=w;w=C+3|0;C=(Y(f[49884+(L<<2)>>2]|0,D)|0)>>>8&255;Z=h[w>>0]|0;t=(((Y(k-Z|0,C)|0)+127|0)>>>8)+Z|0;Z=w+1|0;ja=h[Z>>0]|0;_=(((Y(l-ja|0,C)|0)+127|0)>>>8)+ja|0;ja=w+2|0;$=h[ja>>0]|0;v=(((Y(m-$|0,C)|0)+127|0)>>>8)+$|0;$=(((Y(l-(_&255)|0,C)|0)+127|0)>>>8)+_|0;_=(((Y(m-(v&255)|0,C)|0)+127|0)>>>8)+v|0;v=(((Y(k-(t&255)|0,C)|0)+127|0)>>>8)+t&255;b[w>>0]=v;b[Z>>0]=$;b[ja>>0]=_;_=w+3|0;w=(Y(f[49884+((L^63)<<2)>>2]|0,D)|0)>>>8&255;D=h[_>>0]|0;L=(((Y(k-D|0,w)|0)+127|0)>>>8)+D|0;D=_+1|0;ja=h[D>>0]|0;$=(((Y(l-ja|0,w)|0)+127|0)>>>8)+ja|0;ja=_+2|0;Z=h[ja>>0]|0;v=(((Y(m-Z|0,w)|0)+127|0)>>>8)+Z|0;Z=(((Y(l-($&255)|0,w)|0)+127|0)>>>8)+$|0;$=(((Y(m-(v&255)|0,w)|0)+127|0)>>>8)+v|0;v=(((Y(k-(L&255)|0,w)|0)+127|0)>>>8)+L&255;b[_>>0]=v;b[D>>0]=Z;b[ja>>0]=$;$=c;X=UIc(f[$>>2]|0,f[$+4>>2]|0,ha|0,ia|0)|0;N=J;$=c;f[$>>2]=X;f[$+4>>2]=N;if((E|0)<=0)break;else{s=s+1|0;aa=aa+r|0;E=E+-1|0}}u=g;return}break}case 0:{E=(W|0)>-1;if(O){if(!E){u=g;return}aa=aJc(ba|0,ca|0,16)|0;s=0;N=x+aa|0;aa=W;X=fa;$=ga;while(1){ja=$Ic(X|0,$|0,16)|0;Z=UIc(ja|0,J|0,-1,-1)|0;ja=mJc(Z|0,J|0,r|0,0)|0;Z=N+ja|0;ja=f[i+(((((s|0)>1?2:1)&(s|2))*3|0)+(((aa|0)>1?2:1)&(aa|2))<<2)>>2]|0;D=aJc(X|0,$|0,11)|0;v=D&31;D=(Y(f[49884+((v|32)<<2)>>2]|0,ja)|0)>>>8&255;_=h[Z>>0]|0;L=(((Y(k-_|0,D)|0)+127|0)>>>8)+_|0;_=(((Y(k-(L&255)|0,D)|0)+127|0)>>>8)+L&255;b[Z>>0]=_;_=Z+r|0;Z=(Y(f[49884+(v<<2)>>2]|0,ja)|0)>>>8&255;L=h[_>>0]|0;D=(((Y(k-L|0,Z)|0)+127|0)>>>8)+L|0;L=(((Y(k-(D&255)|0,Z)|0)+127|0)>>>8)+D&255;b[_>>0]=L;L=_+r|0;_=(Y(f[49884+((v^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[L>>0]|0;v=(((Y(k-ja|0,_)|0)+127|0)>>>8)+ja|0;ja=(((Y(k-(v&255)|0,_)|0)+127|0)>>>8)+v&255;b[L>>0]=ja;ja=o;X=UIc(f[ja>>2]|0,f[ja+4>>2]|0,da|0,ea|0)|0;$=J;ja=o;f[ja>>2]=X;f[ja+4>>2]=$;if((aa|0)<=0)break;else{s=s+1|0;N=N+1|0;aa=aa+-1|0}}u=g;return}else{if(!E){u=g;return}E=$Ic(fa|0,ga|0,16)|0;aa=mJc(E|0,J|0,r|0,0)|0;E=0;N=x+aa|0;aa=W;s=ba;$=ca;while(1){X=aJc(s|0,$|0,16)|0;ja=UIc(X|0,J|0,-1,0)|0;X=N+ja|0;ja=f[i+(((((E|0)>1?2:1)&(E|2))*3|0)+(((aa|0)>1?2:1)&(aa|2))<<2)>>2]|0;L=aJc(s|0,$|0,11)|0;v=L&31;L=(Y(f[49884+((v|32)<<2)>>2]|0,ja)|0)>>>8&255;_=h[X>>0]|0;D=(((Y(k-_|0,L)|0)+127|0)>>>8)+_|0;_=(((Y(k-(D&255)|0,L)|0)+127|0)>>>8)+D&255;b[X>>0]=_;_=X+1|0;X=(Y(f[49884+(v<<2)>>2]|0,ja)|0)>>>8&255;D=h[_>>0]|0;L=(((Y(k-D|0,X)|0)+127|0)>>>8)+D|0;D=(((Y(k-(L&255)|0,X)|0)+127|0)>>>8)+L&255;b[_>>0]=D;D=_+1|0;_=(Y(f[49884+((v^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[D>>0]|0;v=(((Y(k-ja|0,_)|0)+127|0)>>>8)+ja|0;ja=(((Y(k-(v&255)|0,_)|0)+127|0)>>>8)+v&255;b[D>>0]=ja;ja=c;s=UIc(f[ja>>2]|0,f[ja+4>>2]|0,ha|0,ia|0)|0;$=J;ja=c;f[ja>>2]=s;f[ja+4>>2]=$;if((aa|0)<=0)break;else{E=E+1|0;N=N+r|0;aa=aa+-1|0}}u=g;return}break}default:{aa=(W|0)>-1;if(O){if(!aa){u=g;return}O=$Ic(ba|0,ca|0,16)|0;N=jJc(O|0,J|0,2)|0;O=x+N|0;N=0;E=W;$=fa;s=ga;while(1){ja=$Ic($|0,s|0,16)|0;D=UIc(ja|0,J|0,-1,-1)|0;ja=mJc(D|0,J|0,r|0,0)|0;D=O+ja|0;ja=f[i+(((((N|0)>1?2:1)&(N|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;v=aJc($|0,s|0,11)|0;_=v&31;v=(Y(f[49884+((_|32)<<2)>>2]|0,ja)|0)>>>8&255;L=h[D>>0]|0;X=(((Y(k-L|0,v)|0)+127|0)>>>8)+L|0;L=D+1|0;Z=h[L>>0]|0;w=(((Y(l-Z|0,v)|0)+127|0)>>>8)+Z|0;Z=D+2|0;t=h[Z>>0]|0;C=(((Y(m-t|0,v)|0)+127|0)>>>8)+t|0;t=D+3|0;A=h[t>>0]|0;K=(((Y(n-A|0,v)|0)+127|0)>>>8)+A|0;A=(((Y(l-(w&255)|0,v)|0)+127|0)>>>8)+w|0;w=(((Y(m-(C&255)|0,v)|0)+127|0)>>>8)+C|0;C=(((Y(n-(K&255)|0,v)|0)+127|0)>>>8)+K|0;K=(((Y(k-(X&255)|0,v)|0)+127|0)>>>8)+X&255;b[D>>0]=K;b[L>>0]=A;b[Z>>0]=w;b[t>>0]=C;C=D+r|0;D=(Y(f[49884+(_<<2)>>2]|0,ja)|0)>>>8&255;t=h[C>>0]|0;w=(((Y(k-t|0,D)|0)+127|0)>>>8)+t|0;t=C+1|0;Z=h[t>>0]|0;A=(((Y(l-Z|0,D)|0)+127|0)>>>8)+Z|0;Z=C+2|0;L=h[Z>>0]|0;K=(((Y(m-L|0,D)|0)+127|0)>>>8)+L|0;L=C+3|0;X=h[L>>0]|0;v=(((Y(n-X|0,D)|0)+127|0)>>>8)+X|0;X=(((Y(l-(A&255)|0,D)|0)+127|0)>>>8)+A|0;A=(((Y(m-(K&255)|0,D)|0)+127|0)>>>8)+K|0;K=(((Y(n-(v&255)|0,D)|0)+127|0)>>>8)+v|0;v=(((Y(k-(w&255)|0,D)|0)+127|0)>>>8)+w&255;b[C>>0]=v;b[t>>0]=X;b[Z>>0]=A;b[L>>0]=K;K=C+r|0;C=(Y(f[49884+((_^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[K>>0]|0;_=(((Y(k-ja|0,C)|0)+127|0)>>>8)+ja|0;ja=K+1|0;L=h[ja>>0]|0;A=(((Y(l-L|0,C)|0)+127|0)>>>8)+L|0;L=K+2|0;Z=h[L>>0]|0;X=(((Y(m-Z|0,C)|0)+127|0)>>>8)+Z|0;Z=K+3|0;t=h[Z>>0]|0;v=(((Y(n-t|0,C)|0)+127|0)>>>8)+t|0;t=(((Y(l-(A&255)|0,C)|0)+127|0)>>>8)+A|0;A=(((Y(m-(X&255)|0,C)|0)+127|0)>>>8)+X|0;X=(((Y(n-(v&255)|0,C)|0)+127|0)>>>8)+v|0;v=(((Y(k-(_&255)|0,C)|0)+127|0)>>>8)+_&255;b[K>>0]=v;b[ja>>0]=t;b[L>>0]=A;b[Z>>0]=X;X=o;$=UIc(f[X>>2]|0,f[X+4>>2]|0,da|0,ea|0)|0;s=J;X=o;f[X>>2]=$;f[X+4>>2]=s;if((E|0)<=0)break;else{O=O+4|0;N=N+1|0;E=E+-1|0}}u=g;return}else{if(!aa){u=g;return}aa=$Ic(fa|0,ga|0,16)|0;ga=mJc(aa|0,J|0,r|0,0)|0;aa=x+ga|0;ga=0;x=W;W=ba;ba=ca;while(1){ca=$Ic(W|0,ba|0,16)|0;fa=jJc(ca|0,J|0,2)|0;ca=UIc(fa|0,J|0,-4,0)|0;fa=aa+ca|0;ca=f[i+(((((ga|0)>1?2:1)&(ga|2))*3|0)+(((x|0)>1?2:1)&(x|2))<<2)>>2]|0;E=aJc(W|0,ba|0,11)|0;N=E&31;E=(Y(f[49884+((N|32)<<2)>>2]|0,ca)|0)>>>8&255;O=h[fa>>0]|0;s=(((Y(k-O|0,E)|0)+127|0)>>>8)+O|0;O=fa+1|0;$=h[O>>0]|0;o=(((Y(l-$|0,E)|0)+127|0)>>>8)+$|0;$=fa+2|0;ea=h[$>>0]|0;da=(((Y(m-ea|0,E)|0)+127|0)>>>8)+ea|0;ea=fa+3|0;X=h[ea>>0]|0;Z=(((Y(n-X|0,E)|0)+127|0)>>>8)+X|0;X=(((Y(l-(o&255)|0,E)|0)+127|0)>>>8)+o|0;o=(((Y(m-(da&255)|0,E)|0)+127|0)>>>8)+da|0;da=(((Y(n-(Z&255)|0,E)|0)+127|0)>>>8)+Z|0;Z=(((Y(k-(s&255)|0,E)|0)+127|0)>>>8)+s&255;b[fa>>0]=Z;b[O>>0]=X;b[$>>0]=o;b[ea>>0]=da;da=fa+4|0;fa=(Y(f[49884+(N<<2)>>2]|0,ca)|0)>>>8&255;ea=h[da>>0]|0;o=(((Y(k-ea|0,fa)|0)+127|0)>>>8)+ea|0;ea=da+1|0;$=h[ea>>0]|0;X=(((Y(l-$|0,fa)|0)+127|0)>>>8)+$|0;$=da+2|0;O=h[$>>0]|0;Z=(((Y(m-O|0,fa)|0)+127|0)>>>8)+O|0;O=da+3|0;s=h[O>>0]|0;E=(((Y(n-s|0,fa)|0)+127|0)>>>8)+s|0;s=(((Y(l-(X&255)|0,fa)|0)+127|0)>>>8)+X|0;X=(((Y(m-(Z&255)|0,fa)|0)+127|0)>>>8)+Z|0;Z=(((Y(n-(E&255)|0,fa)|0)+127|0)>>>8)+E|0;E=(((Y(k-(o&255)|0,fa)|0)+127|0)>>>8)+o&255;b[da>>0]=E;b[ea>>0]=s;b[$>>0]=X;b[O>>0]=Z;Z=da+4|0;da=(Y(f[49884+((N^63)<<2)>>2]|0,ca)|0)>>>8&255;ca=h[Z>>0]|0;N=(((Y(k-ca|0,da)|0)+127|0)>>>8)+ca|0;ca=Z+1|0;O=h[ca>>0]|0;X=(((Y(l-O|0,da)|0)+127|0)>>>8)+O|0;O=Z+2|0;$=h[O>>0]|0;s=(((Y(m-$|0,da)|0)+127|0)>>>8)+$|0;$=Z+3|0;ea=h[$>>0]|0;E=(((Y(n-ea|0,da)|0)+127|0)>>>8)+ea|0;ea=(((Y(l-(X&255)|0,da)|0)+127|0)>>>8)+X|0;X=(((Y(m-(s&255)|0,da)|0)+127|0)>>>8)+s|0;s=(((Y(n-(E&255)|0,da)|0)+127|0)>>>8)+E|0;E=(((Y(k-(N&255)|0,da)|0)+127|0)>>>8)+N&255;b[Z>>0]=E;b[ca>>0]=ea;b[O>>0]=X;b[$>>0]=s;s=c;W=UIc(f[s>>2]|0,f[s+4>>2]|0,ha|0,ia|0)|0;ba=J;s=c;f[s>>2]=W;f[s+4>>2]=ba;if((x|0)<=0)break;else{aa=aa+r|0;ga=ga+1|0;x=x+-1|0}}u=g;return}}}}break}default:{}}x=c;ga=aJc(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=c+8|0;c=aJc(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=d;r=aJc(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=d+8|0;d=aJc(f[x>>2]|0,f[x+4>>2]|0,16)|0;lga(a,ga,c,r,d,e,8);u=g;return}function oga(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;i=u;u=u+128|0;j=i+64|0;k=i+48|0;l=i+32|0;m=i+16|0;n=i;o=1<<h>>1;p=f[a+16>>2]|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[a+4>>2]|0;if((q|0)>0)t=f[(f[a+44>>2]|0)+(q+-1<<2)>>2]|0;else t=0;q=(g|0)<16;v=q?32768:65535;w=q?0:0;x=q?32768:0;y=q?0:0;z=d+-1|0;A=c+(z<<4)|0;B=c+(z<<4)+8|0;C=f[B>>2]|0;D=f[B+4>>2]|0;B=16-h|0;E=jJc(f[A>>2]|0,f[A+4>>2]|0,B|0)|0;A=J;F=jJc(C|0,D|0,B|0)|0;D=J;C=c;G=f[C>>2]|0;H=f[C+4>>2]|0;C=c+8|0;I=f[C>>2]|0;K=f[C+4>>2]|0;a:do if((d|0)>0){C=(h|0)==0;L=k+8|0;M=l+8|0;N=m+8|0;O=n+8|0;if((g|0)<9){P=0;Q=0;R=H;S=G;T=E;U=A;V=F;W=D;X=K;Z=K;_=I;$=I;aa=K;ba=I;ca=H;da=H;ea=G;fa=G}else{ga=0;ha=0;ia=K;ja=K;ka=I;la=I;ma=K;na=I;oa=H;pa=H;qa=G;ra=G;sa=H;ta=G;ua=E;va=A;wa=F;xa=D;while(1){ya=(ia|0)<(ja|0)|(ia|0)==(ja|0)&ka>>>0<la>>>0;za=ya?ga:ha;Aa=ya?ka:la;Ba=ya?ia:ja;ya=(ma|0)<(ia|0)|(ma|0)==(ia|0)&na>>>0<ka>>>0;Ca=ya?ka:na;Da=ya?ia:ma;ya=(oa|0)<(pa|0)|(oa|0)==(pa|0)&qa>>>0<ra>>>0;Ea=ya?ra:qa;Fa=ya?pa:oa;ya=(sa|0)>(pa|0)|(sa|0)==(pa|0)&ta>>>0>ra>>>0;Ga=ya?ra:ta;Ha=ya?pa:sa;ya=jJc(ra|0,pa|0,B|0)|0;Ia=J;Ja=jJc(ka|0,ia|0,B|0)|0;Ka=J;La=m;f[La>>2]=ua;f[La+4>>2]=va;La=N;f[La>>2]=wa;f[La+4>>2]=xa;La=n;f[La>>2]=ya;f[La+4>>2]=Ia;La=O;f[La>>2]=Ja;f[La+4>>2]=Ka;nga(a,m,n,e);La=ga+1|0;if((La|0)==(d|0)){Ma=za;Na=Aa;Oa=Ba;Pa=Ca;Qa=Da;Ra=Ea;Sa=Fa;Ta=Ga;Ua=Ha;break a}Va=c+(La<<4)|0;Wa=c+(La<<4)+8|0;ga=La;ha=za;ia=f[Wa+4>>2]|0;ja=Ba;ka=f[Wa>>2]|0;la=Aa;ma=Da;na=Ca;oa=Fa;pa=f[Va+4>>2]|0;qa=Ea;ra=f[Va>>2]|0;sa=Ha;ta=Ga;ua=ya;va=Ia;wa=Ja;xa=Ka}}while(1){xa=(X|0)<(Z|0)|(X|0)==(Z|0)&_>>>0<$>>>0;wa=xa?P:Q;va=xa?_:$;ua=xa?X:Z;xa=(aa|0)<(X|0)|(aa|0)==(X|0)&ba>>>0<_>>>0;ta=xa?_:ba;sa=xa?X:aa;xa=(ca|0)<(da|0)|(ca|0)==(da|0)&ea>>>0<fa>>>0;ra=xa?fa:ea;qa=xa?da:ca;xa=(R|0)>(da|0)|(R|0)==(da|0)&S>>>0>fa>>>0;pa=xa?fa:S;oa=xa?da:R;xa=jJc(fa|0,da|0,B|0)|0;na=J;ma=jJc(_|0,X|0,B|0)|0;la=J;if(C){ka=aJc(T|0,U|0,16)|0;ja=aJc(V|0,W|0,16)|0;ia=aJc(xa|0,na|0,16)|0;ha=aJc(ma|0,la|0,16)|0;lga(a,ka,ja,ia,ha,e,g)}else{ha=k;f[ha>>2]=T;f[ha+4>>2]=U;ha=L;f[ha>>2]=V;f[ha+4>>2]=W;ha=l;f[ha>>2]=xa;f[ha+4>>2]=na;ha=M;f[ha>>2]=ma;f[ha+4>>2]=la;mga(a,k,l,e)}ha=P+1|0;if((ha|0)==(d|0)){Ma=wa;Na=va;Oa=ua;Pa=ta;Qa=sa;Ra=ra;Sa=qa;Ta=pa;Ua=oa;break a}ia=c+(ha<<4)|0;ja=c+(ha<<4)+8|0;P=ha;Q=wa;R=oa;S=pa;T=xa;U=na;V=ma;W=la;X=f[ja+4>>2]|0;Z=ua;_=f[ja>>2]|0;$=va;aa=sa;ba=ta;ca=qa;da=f[ia+4>>2]|0;ea=ra;fa=f[ia>>2]|0}}else{Ma=0;Na=I;Oa=K;Pa=I;Qa=K;Ra=G;Sa=H;Ta=G;Ua=H}while(0);H=((o|0)<0)<<31>>31;G=UIc(Na|0,Oa|0,o|0,H|0)|0;Oa=$Ic(G|0,J|0,h|0)|0;G=UIc(Pa|0,Qa|0,o|0,H|0)|0;Qa=$Ic(G|0,J|0,h|0)|0;G=J;if((d|0)<3){u=i;return}Pa=UIc(Ra|0,Sa|0,o|0,H|0)|0;Sa=$Ic(Pa|0,J|0,h|0)|0;Pa=J;Pa=UIc(Ta|0,Ua|0,o|0,H|0)|0;Ua=$Ic(Pa|0,J|0,h|0)|0;if(!((Sa|Qa|0)>-1&(Ua|0)<(r|0))){u=i;return}if((Oa|0)>=(s|0)){u=i;return}Ua=s+-1|0;s=((Ua|0)<0)<<31>>31;Sa=(G|0)>(s|0)|(G|0)==(s|0)&Qa>>>0>Ua>>>0;s=Sa?Ua:Qa;Qa=j+32|0;f[Qa>>2]=Ma;f[j>>2]=Ma;Ma=j+56|0;f[Ma>>2]=Oa;Ua=j+24|0;f[Ua>>2]=Oa;Sa=j+4|0;f[Sa>>2]=1;G=j+36|0;f[G>>2]=z;z=j+40|0;Pa=z;f[Pa>>2]=-65536;f[Pa+4>>2]=-1;Pa=j+8|0;Ta=Pa;f[Ta>>2]=-65536;f[Ta+4>>2]=-1;Ta=j+48|0;Ra=Ta;f[Ra>>2]=0;f[Ra+4>>2]=0;Ra=j+16|0;Na=Ra;f[Na>>2]=0;f[Na+4>>2]=0;Na=a+48|0;a=p+(Y(f[Na>>2]|0,Oa)|0)|0;p=r+-1|0;K=(t|0)==1;I=(h|0)==16?0:B;B=Oa;fa=a;a=d;ea=-65536;da=-1;ca=-65536;ba=-1;while(1){if(!q?!((B|0)<(s|0)|(B|0)==(Oa|0)):0){Xa=a;Ya=ba;Za=da;_a=ca;$a=ea}else ab=18;b:do if((ab|0)==18){ab=0;c:do if((B|0)<(f[Ua>>2]|0)){bb=a;cb=ca;db=ba}else{aa=f[Sa>>2]|0;$=f[j>>2]|0;_=a;while(1){Z=$+aa|0;eb=Z-((Z|0)<(d|0)?0:d)|0;Z=_;_=_+-1|0;if((Z|0)<=0){bb=_;cb=ca;db=ba;break c}Z=c+(eb<<4)+8|0;X=UIc(f[Z>>2]|0,f[Z+4>>2]|0,o|0,H|0)|0;fb=$Ic(X|0,J|0,h|0)|0;if((fb|0)>(B|0))break;else $=eb}aa=c+($<<4)|0;X=c+(eb<<4)|0;Z=f[X>>2]|0;W=f[X+4>>2]|0;X=jJc(f[aa>>2]|0,f[aa+4>>2]|0,I|0)|0;aa=J;V=jJc(Z|0,W|0,I|0)|0;f[Ua>>2]=fb;W=TIc(V|0,J|0,X|0,aa|0)|0;V=jJc(W|0,J|0,1)|0;W=fb-B|0;Z=UIc(V|0,J|0,W|0,((W|0)<0)<<31>>31|0)|0;V=W<<1;W=kJc(Z|0,J|0,V|0,((V|0)<0)<<31>>31|0)|0;V=Ra;f[V>>2]=W;f[V+4>>2]=J;V=Pa;f[V>>2]=X;f[V+4>>2]=aa;f[j>>2]=eb;bb=_;cb=X;db=aa}while(0);if((B|0)<(f[Ma>>2]|0)){Xa=bb;Ya=db;Za=da;_a=cb;$a=ea}else{aa=f[G>>2]|0;X=f[Qa>>2]|0;V=bb;while(1){W=X+aa|0;gb=W-((W|0)<(d|0)?0:d)|0;W=V;V=V+-1|0;if((W|0)<=0){Xa=V;Ya=db;Za=da;_a=cb;$a=ea;break b}W=c+(gb<<4)+8|0;Z=UIc(f[W>>2]|0,f[W+4>>2]|0,o|0,H|0)|0;hb=$Ic(Z|0,J|0,h|0)|0;if((hb|0)>(B|0))break;else X=gb}aa=c+(X<<4)|0;Z=c+(gb<<4)|0;W=f[Z>>2]|0;U=f[Z+4>>2]|0;Z=jJc(f[aa>>2]|0,f[aa+4>>2]|0,I|0)|0;aa=J;T=jJc(W|0,U|0,I|0)|0;f[Ma>>2]=hb;U=TIc(T|0,J|0,Z|0,aa|0)|0;T=jJc(U|0,J|0,1)|0;U=hb-B|0;W=UIc(T|0,J|0,U|0,((U|0)<0)<<31>>31|0)|0;T=U<<1;U=kJc(W|0,J|0,T|0,((T|0)<0)<<31>>31|0)|0;T=Ta;f[T>>2]=U;f[T+4>>2]=J;T=z;f[T>>2]=Z;f[T+4>>2]=aa;f[Qa>>2]=gb;Xa=V;Ya=db;Za=aa;_a=cb;$a=Z}}while(0);if((Xa|0)<0){ab=35;break}do if((B|0)>-1?(Z=(Ya|0)>(Za|0)|(Ya|0)==(Za|0)&_a>>>0>$a>>>0,aa=j+((Z&1)<<5)+8|0,T=UIc(f[aa>>2]|0,f[aa+4>>2]|0,v|0,w|0)|0,aa=aJc(T|0,J|0,16)|0,T=j+(((Z^1)&1)<<5)+8|0,Z=UIc(f[T>>2]|0,f[T+4>>2]|0,x|0,y|0)|0,T=aJc(Z|0,J|0,16)|0,(aa|0)<(r|0)&(T|0)>-1):0){Z=Y((aa|0)>0?aa:0,t)|0;aa=fa+Z|0;U=Y(((T|0)<(r|0)?T:p)+1|0,t)|0;T=fa+U|0;if(K){XIc(aa|0,b[e>>0]|0,T-aa|0)|0;break}if((Z|0)<(U|0)){dJc(aa|0,e|0,t|0)|0;ib=aa+t|0}else ib=aa;if(ib>>>0<T>>>0){U=T;Z=t;W=ib;while(1){dJc(W|0,aa|0,Z|0)|0;W=W+Z|0;S=Z<<1;R=U-W|0;if(W>>>0>=T>>>0)break;else Z=R>>>0<S>>>0?R:S}}}while(0);Z=Ra;T=Pa;ca=UIc(f[T>>2]|0,f[T+4>>2]|0,f[Z>>2]|0,f[Z+4>>2]|0)|0;ba=J;Z=Pa;f[Z>>2]=ca;f[Z+4>>2]=ba;Z=Ta;T=z;ea=UIc(f[T>>2]|0,f[T+4>>2]|0,f[Z>>2]|0,f[Z+4>>2]|0)|0;da=J;Z=z;f[Z>>2]=ea;f[Z+4>>2]=da;if((B|0)>=(s|0)){ab=35;break}else{B=B+1|0;fa=fa+(f[Na>>2]|0)|0;a=Xa}}if((ab|0)==35){u=i;return}}function pga(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;h=f[a+40>>2]|0;i=f[h+4>>2]|0;j=f[h>>2]|0;h=f[a+48>>2]|0;k=f[a+4>>2]|0;if((k|0)>0)l=f[(f[a+44>>2]|0)+(k+-1<<2)>>2]|0;else l=0;k=f[a+16>>2]|0;a=f[c>>2]|0;if((a|0)>=(d|0)&(a|0)<(i-d|0)){m=f[c+4>>2]|0;n=(m|0)<(j-d|0)&(m|0)>=(d|0)}else n=0;if((d|0)<0)return;m=c+4|0;o=(g|0)!=0;g=(l|0)==1;p=i+-1|0;q=d;r=0;s=1;t=(d<<1)+-1|0;d=0;u=a;while(1){a=f[m>>2]|0;v=a-r|0;w=a+r|0;x=a-q|0;y=a+q|0;a=u-q|0;z=u+q|0;A=u-r|0;B=u+r|0;do if(n){C=k+(Y(v,h)|0)|0;D=k+(Y(w,h)|0)|0;E=Y(a,l)|0;F=C+E|0;if(!o){dJc(F|0,e|0,l|0)|0;dJc(D+E|0,e|0,l|0)|0;G=Y(z,l)|0;dJc(C+G|0,e|0,l|0)|0;dJc(D+G|0,e|0,l|0)|0;G=k+(Y(x,h)|0)|0;H=k+(Y(y,h)|0)|0;I=Y(A,l)|0;dJc(G+I|0,e|0,l|0)|0;dJc(H+I|0,e|0,l|0)|0;I=Y(B,l)|0;dJc(G+I|0,e|0,l|0)|0;dJc(H+I|0,e|0,l|0)|0;break}I=Y(z+1|0,l)|0;H=C+I|0;if(!g){C=(I|0)>(E|0);if(C){dJc(F|0,e|0,l|0)|0;J=F+l|0}else J=F;if(J>>>0<H>>>0){G=H;K=l;L=J;while(1){dJc(L|0,F|0,K|0)|0;L=L+K|0;M=K<<1;N=G-L|0;if(L>>>0>=H>>>0)break;else K=N>>>0<M>>>0?N:M}}K=D+E|0;L=D+I|0;if(C){dJc(K|0,e|0,l|0)|0;O=D+E+l|0}else O=K;if(O>>>0<L>>>0){G=L;M=l;N=O;while(1){dJc(N|0,K|0,M|0)|0;N=N+M|0;P=M<<1;Q=G-N|0;if(N>>>0>=L>>>0)break;else M=Q>>>0<P>>>0?Q:P}}}else{XIc(F|0,b[e>>0]|0,H-F|0)|0;XIc(D+E|0,b[e>>0]|0,I-E|0)|0}M=k+(Y(x,h)|0)|0;L=k+(Y(y,h)|0)|0;N=Y(A,l)|0;G=M+N|0;K=Y(B+1|0,l)|0;C=M+K|0;if(g){XIc(G|0,b[e>>0]|0,C-G|0)|0;XIc(L+N|0,b[e>>0]|0,K-N|0)|0;break}M=(K|0)>(N|0);if(M){dJc(G|0,e|0,l|0)|0;R=G+l|0}else R=G;if(R>>>0<C>>>0){P=C;Q=l;S=R;while(1){dJc(S|0,G|0,Q|0)|0;S=S+Q|0;T=Q<<1;U=P-S|0;if(S>>>0>=C>>>0)break;else Q=U>>>0<T>>>0?U:T}}Q=L+N|0;C=L+K|0;if(M){dJc(Q|0,e|0,l|0)|0;V=L+N+l|0}else V=Q;if(V>>>0<C>>>0){S=C;P=l;G=V;while(1){dJc(G|0,Q|0,P|0)|0;G=G+P|0;E=P<<1;I=S-G|0;if(G>>>0>=C>>>0)break;else P=I>>>0<E>>>0?I:E}}}else if((a|0)<(i|0)&(z|0)>-1?(x|0)<(j|0)&(y|0)>-1:0){P=o?((a|0)>0?a:0):a;C=o&(z|0)>=(i|0)?p:z;do if(v>>>0<j>>>0){G=k+(Y(v,h)|0)|0;if(!o){if((P|0)>-1)dJc(G+(Y(P,l)|0)|0,e|0,l|0)|0;if((C|0)>=(i|0))break;dJc(G+(Y(C,l)|0)|0,e|0,l|0)|0;break}S=Y(P,l)|0;Q=G+S|0;N=Y(C+1|0,l)|0;L=G+N|0;if(g){XIc(Q|0,b[e>>0]|0,L-Q|0)|0;break}if((S|0)<(N|0)){dJc(Q|0,e|0,l|0)|0;W=Q+l|0}else W=Q;if(W>>>0<L>>>0){N=L;S=l;G=W;while(1){dJc(G|0,Q|0,S|0)|0;G=G+S|0;M=S<<1;K=N-G|0;if(G>>>0>=L>>>0)break;else S=K>>>0<M>>>0?K:M}}}while(0);do if(w>>>0<j>>>0){S=k+(Y(w,h)|0)|0;if(!o){if((P|0)>-1)dJc(S+(Y(P,l)|0)|0,e|0,l|0)|0;if((C|0)>=(i|0))break;dJc(S+(Y(C,l)|0)|0,e|0,l|0)|0;break}L=Y(P,l)|0;G=S+L|0;N=Y(C+1|0,l)|0;Q=S+N|0;if(g){XIc(G|0,b[e>>0]|0,Q-G|0)|0;break}if((L|0)<(N|0)){dJc(G|0,e|0,l|0)|0;X=G+l|0}else X=G;if(X>>>0<Q>>>0){N=Q;L=l;S=X;while(1){dJc(S|0,G|0,L|0)|0;S=S+L|0;M=L<<1;K=N-S|0;if(S>>>0>=Q>>>0)break;else L=K>>>0<M>>>0?K:M}}}while(0);if((A|0)<(i|0)&(B|0)>-1){C=o?((A|0)>0?A:0):A;P=o&(B|0)>=(i|0)?p:B;do if(x>>>0<j>>>0){L=k+(Y(x,h)|0)|0;if(!o){if((C|0)>-1)dJc(L+(Y(C,l)|0)|0,e|0,l|0)|0;if((P|0)>=(i|0))break;dJc(L+(Y(P,l)|0)|0,e|0,l|0)|0;break}Q=Y(C,l)|0;S=L+Q|0;N=Y(P+1|0,l)|0;G=L+N|0;if(g){XIc(S|0,b[e>>0]|0,G-S|0)|0;break}if((Q|0)<(N|0)){dJc(S|0,e|0,l|0)|0;Z=S+l|0}else Z=S;if(Z>>>0<G>>>0){N=G;Q=l;L=Z;while(1){dJc(L|0,S|0,Q|0)|0;L=L+Q|0;M=Q<<1;K=N-L|0;if(L>>>0>=G>>>0)break;else Q=K>>>0<M>>>0?K:M}}}while(0);if(y>>>0<j>>>0){Q=k+(Y(y,h)|0)|0;if(!o){if((C|0)>-1)dJc(Q+(Y(C,l)|0)|0,e|0,l|0)|0;if((P|0)>=(i|0))break;dJc(Q+(Y(P,l)|0)|0,e|0,l|0)|0;break}G=Y(C,l)|0;L=Q+G|0;N=Y(P+1|0,l)|0;S=Q+N|0;if(g){XIc(L|0,b[e>>0]|0,S-L|0)|0;break}if((G|0)<(N|0)){dJc(L|0,e|0,l|0)|0;_=L+l|0}else _=L;if(_>>>0<S>>>0){N=S;G=l;Q=_;while(1){dJc(Q|0,L|0,G|0)|0;Q=Q+G|0;M=G<<1;K=N-Q|0;if(Q>>>0>=S>>>0)break;else G=K>>>0<M>>>0?K:M}}}}}while(0);y=d+s|0;x=(y|0)>0;B=(x<<31>>31)+q|0;if((B|0)<=(r|0))break;A=y-(x?t:0)|0;q=B;r=r+1|0;s=s+2|0;t=t-(x?2:0)|0;d=A;u=f[c>>2]|0}return}function qga(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;k=u;u=u+80|0;l=k+68|0;m=k+32|0;n=k;o=k+56|0;q=k+16|0;r=k+48|0;s=c;t=f[s>>2]|0;v=f[s+4>>2]|0;s=(v|0)>-1|(v|0)==-1&t>>>0>4294967295;w=TIc(0,0,t|0,v|0)|0;x=s?t:w;w=s?v:J;v=c;f[v>>2]=x;f[v+4>>2]=w;v=c+8|0;c=v;s=f[c>>2]|0;t=f[c+4>>2]|0;c=(t|0)>-1|(t|0)==-1&s>>>0>4294967295;y=TIc(0,0,s|0,t|0)|0;z=c?s:y;y=c?t:J;t=v;f[t>>2]=z;f[t+4>>2]=y;t=(w|0)<(y|0)|(w|0)==(y|0)&x>>>0<z>>>0;v=UIc((t?z:x)|0,(t?y:w)|0,32768,0)|0;t=aJc(v|0,J|0,16)|0;if((t|0)<3)A=90;else A=(t|0)<10?30:(t|0)<15?18:5;f[l>>2]=0;t=l+4|0;f[t>>2]=0;f[l+8>>2]=0;v=b;c=b+8|0;s=c;B=+((f[s>>2]|0)>>>0)+4294967296.0*+(f[s+4>>2]|0);p[m>>3]=+((f[v>>2]|0)>>>0)+4294967296.0*+(f[v+4>>2]|0);p[m+8>>3]=B;p[n>>3]=+(x>>>0)+4294967296.0*+(w|0);p[n+8>>3]=+(z>>>0)+4294967296.0*+(y|0);ega(m,n,d,e,g,A,l);f[o>>2]=0;A=o+4|0;f[A>>2]=0;f[o+8>>2]=0;d=f[t>>2]|0;n=f[l>>2]|0;if((d|0)==(n|0)){C=0;D=0}else{m=q+8|0;y=o+8|0;z=0;w=n;n=-1;x=-1;v=-1;s=-1;E=d;while(1){d=w;F=nrc(+p[d+(z<<4)>>3]*.0000152587890625)|0;G=jJc(F|0,((F|0)<0)<<31>>31|0,16)|0;F=J;H=nrc(+p[d+(z<<4)+8>>3]*.0000152587890625)|0;I=jJc(H|0,((H|0)<0)<<31>>31|0,16)|0;H=J;K=nrc(+p[d+(z<<4)>>3]-(+(G>>>0)+4294967296.0*+(F|0)))|0;L=UIc(K|0,((K|0)<0)<<31>>31|0,G|0,F|0)|0;F=J;G=q;f[G>>2]=L;f[G+4>>2]=F;G=nrc(+p[d+(z<<4)+8>>3]-(+(I>>>0)+4294967296.0*+(H|0)))|0;d=UIc(G|0,((G|0)<0)<<31>>31|0,I|0,H|0)|0;H=J;I=m;f[I>>2]=d;f[I+4>>2]=H;if((L|0)!=(v|0)|(F|0)!=(s|0)|((d|0)!=(n|0)|(H|0)!=(x|0))){I=f[A>>2]|0;if((I|0)==(f[y>>2]|0)){rga(o,q);M=f[t>>2]|0;N=f[l>>2]|0}else{G=I;f[G>>2]=L;f[G+4>>2]=F;F=I+8|0;f[F>>2]=d;f[F+4>>2]=H;f[A>>2]=I+16;M=E;N=w}I=q;H=m;O=N;P=M;Q=f[H>>2]|0;R=f[H+4>>2]|0;S=f[I>>2]|0;T=f[I+4>>2]|0}else{O=w;P=E;Q=n;R=x;S=v;T=s}z=z+1|0;if(z>>>0>=P-O>>4>>>0)break;else{w=O;n=Q;x=R;v=S;s=T;E=P}}C=f[A>>2]|0;D=f[o>>2]|0}if((C-D|0)==16)sga(o,2,b);do if((i|0)<=-1){if((g-e|0)>359){D=f[o>>2]|0;oga(a,D,(f[A>>2]|0)-D>>4,h,j,16);break}D=f[A>>2]|0;if((D|0)==(f[o+8>>2]|0)){rga(o,b);U=f[A>>2]|0}else{C=b;P=f[C+4>>2]|0;E=D;f[E>>2]=f[C>>2];f[E+4>>2]=P;P=c;E=f[P+4>>2]|0;C=D+8|0;f[C>>2]=f[P>>2];f[C+4>>2]=E;E=D+16|0;f[A>>2]=E;U=E}f[q>>2]=0;E=q+4|0;f[E>>2]=0;f[q+8>>2]=0;D=f[o>>2]|0;f[r>>2]=0;f[r+4>>2]=0;uga(a,D,U-D>>4,q,h,j,16,r);vga(a,q,h);D=f[q>>2]|0;if(D|0){C=f[E>>2]|0;if((C|0)!=(D|0))f[E>>2]=C+(~((C+-32-D|0)>>>5)<<5);YDc(D)}}else{D=f[o>>2]|0;tga(a,D,(f[A>>2]|0)-D>>4,0,h,i,j,16)}while(0);j=f[o>>2]|0;if(j|0){o=f[A>>2]|0;if((o|0)!=(j|0))f[A>>2]=o+(~((o+-16-j|0)>>>4)<<4);YDc(j)}j=f[l>>2]|0;if(!j){u=k;return}l=f[t>>2]|0;if((l|0)!=(j|0))f[t>>2]=l+(~((l+-16-j|0)>>>4)<<4);YDc(j);u=k;return}function rga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;m=b;k=f[m+4>>2]|0;o=l;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=b+8|0;b=f[k+4>>2]|0;o=n+(g<<4)+8|0;f[o>>2]=f[k>>2];f[o+4>>2]=b;b=l+16|0;if((j|0)==(i|0))p=l;else{o=j+-16-e|0;k=j;j=l;while(1){g=k;k=k+-16|0;n=k;m=f[n+4>>2]|0;q=j+-16|0;f[q>>2]=f[n>>2];f[q+4>>2]=m;m=g+-8|0;g=f[m+4>>2]|0;q=j+-8|0;f[q>>2]=f[m>>2];f[q+4>>2]=g;if((k|0)==(i|0))break;else j=j+-16|0}p=l+(~(o>>>4)<<4)|0}f[a>>2]=p;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function sga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>4>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>4;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+8|0;o=m;m=h;while(1){p=c;q=f[p+4>>2]|0;r=m;f[r>>2]=f[p>>2];f[r+4>>2]=q;q=j;r=f[q+4>>2]|0;p=m+8|0;f[p>>2]=f[q>>2];f[p+4>>2]=r;o=o+-1|0;if(!o)break;else m=m+16|0}}if(!l){m=h+(b<<4)|0;if((n|0)==(m|0))return;else{s=i;t=n+(~((n+-16-m|0)>>>4)<<4)|0;break}}else{m=b-k|0;o=c+8|0;j=m;r=n;while(1){p=c;q=f[p+4>>2]|0;u=r;f[u>>2]=f[p>>2];f[u+4>>2]=q;q=o;u=f[q+4>>2]|0;p=r+8|0;f[p>>2]=f[q>>2];f[p+4>>2]=u;j=j+-1|0;if(!j)break;else r=r+16|0}s=i;t=n+(m<<4)|0;break}}else{r=g;if(!g)v=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-16-g|0)>>>4)<<4);YDc(r);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;v=0}if(b>>>0>268435455)mCc(a);j=v>>3;r=v>>4>>>0<134217727?(j>>>0<b>>>0?b:j):268435455;if(r>>>0>268435455)mCc(a);j=VDc(r<<4)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(r<<4);r=c+8|0;k=b;l=j;while(1){u=c;p=f[u+4>>2]|0;q=l;f[q>>2]=f[u>>2];f[q+4>>2]=p;p=r;q=f[p+4>>2]|0;u=l+8|0;f[u>>2]=f[p>>2];f[u+4>>2]=q;k=k+-1|0;if(!k)break;else l=l+16|0}s=o;t=j+(b<<4)|0}while(0);f[s>>2]=t;return}function tga(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;if((c|0)==0|(d|0)<1){u=k;return}if(!((h|0)>-1&j>>>0<17)){f[l>>2]=0;f[l+4>>2]=0;o=tT(l,49)|0;p=256400;q=o+49|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));cga(-215,l,256450,1720)}l=(e^1)&1;p=e?d+-1|0:0;if((l|0)>=(d|0)){u=k;return}o=c+(p<<4)+8|0;q=c+(p<<4)|0;p=m+8|0;r=n+8|0;s=e?2:3;e=l;l=f[q>>2]|0;t=f[q+4>>2]|0;q=f[o>>2]|0;v=f[o+4>>2]|0;while(1){o=c+(e<<4)|0;w=l;l=f[o>>2]|0;x=t;t=f[o+4>>2]|0;o=c+(e<<4)+8|0;y=q;q=f[o>>2]|0;z=v;v=f[o+4>>2]|0;o=m;f[o>>2]=w;f[o+4>>2]=x;x=p;f[x>>2]=y;f[x+4>>2]=z;z=n;f[z>>2]=l;f[z+4>>2]=t;z=r;f[z>>2]=q;f[z+4>>2]=v;kga(a,m,n,g,h,i,s,j);e=e+1|0;if((e|0)==(d|0))break;else s=2}u=k;return}function uga(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+96|0;k=j+80|0;l=j+64|0;m=j+32|0;n=j+16|0;o=j;p=(f[i+4>>2]|0)+(1<<h>>1)|0;q=c+-1|0;r=b+(q<<4)|0;s=f[r>>2]|0;t=f[r+4>>2]|0;r=k+8|0;v=b+(q<<4)+8|0;q=f[v>>2]|0;w=f[v+4>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;v=f[i>>2]|0;x=UIc(v|0,((v|0)<0)<<31>>31|0,s|0,t|0)|0;t=16-h|0;s=jJc(x|0,J|0,t|0)|0;x=J;v=k;f[v>>2]=s;f[v+4>>2]=x;v=((p|0)<0)<<31>>31;y=UIc(q|0,w|0,p|0,v|0)|0;w=$Ic(y|0,J|0,h|0)|0;y=J;q=r;f[q>>2]=w;f[q+4>>2]=y;q=d+4|0;Cga(d,((f[q>>2]|0)-(f[d>>2]|0)>>5)+c|0);if((c|0)<=0){u=j;return}z=l+8|0;A=(g|0)<16;B=m+4|0;C=m+8|0;D=m+16|0;E=d+8|0;F=n+8|0;G=o+8|0;H=0;I=s;s=x;x=w;w=y;do{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;y=b+(H<<4)|0;K=b+(H<<4)+8|0;L=f[K>>2]|0;M=f[K+4>>2]|0;K=f[i>>2]|0;N=UIc(K|0,((K|0)<0)<<31>>31|0,f[y>>2]|0,f[y+4>>2]|0)|0;y=I;I=jJc(N|0,J|0,t|0)|0;N=s;s=J;K=l;f[K>>2]=I;f[K+4>>2]=s;K=UIc(L|0,M|0,p|0,v|0)|0;M=x;x=$Ic(K|0,J|0,h|0)|0;K=w;w=J;L=z;f[L>>2]=x;f[L+4>>2]=w;if(A){L=UIc(y|0,N|0,32768,0)|0;O=$Ic(L|0,J|0,16)|0;L=J;P=UIc(I|0,s|0,32768,0)|0;Q=$Ic(P|0,J|0,16)|0;P=J;R=UIc(O|0,L|0,-2147483648,0)|0;S=J;T=UIc(M|0,K|0,-2147483648,0)|0;U=J;V=UIc(Q|0,P|0,-2147483648,0)|0;W=J;X=UIc(x|0,w|0,-2147483648,0)|0;Y=J;lga(a,S>>>0<1|(S|0)==1&R>>>0<0?O:(L|0)>0|(L|0)==0&O>>>0>0?2147483647:-2147483648,U>>>0<1|(U|0)==1&T>>>0<0?M:(K|0)>0|(K|0)==0&M>>>0>0?2147483647:-2147483648,W>>>0<1|(W|0)==1&V>>>0<0?Q:(P|0)>0|(P|0)==0&Q>>>0>0?2147483647:-2147483648,Y>>>0<1|(Y|0)==1&X>>>0<0?x:(w|0)>0|(w|0)==0&x>>>0>0?2147483647:-2147483648,e,g)}else{X=jJc(M|0,K|0,16)|0;Y=J;Q=jJc(x|0,w|0,16)|0;P=n;f[P>>2]=y;f[P+4>>2]=N;P=F;f[P>>2]=X;f[P+4>>2]=Y;Y=o;f[Y>>2]=I;f[Y+4>>2]=s;Y=G;f[Y>>2]=Q;f[Y+4>>2]=J;nga(a,n,o,e)}do if(!((x|0)==(M|0)&(w|0)==(K|0))){Y=(w|0)>(K|0)|(w|0)==(K|0)&x>>>0>M>>>0;Q=Y?k:l;f[m>>2]=f[Q+8>>2];f[B>>2]=f[(Y?l:k)+8>>2];Y=Q;Q=f[Y+4>>2]|0;P=C;f[P>>2]=f[Y>>2];f[P+4>>2]=Q;Q=TIc(I|0,s|0,y|0,N|0)|0;P=J;Y=TIc(x|0,w|0,M|0,K|0)|0;X=kJc(Q|0,P|0,Y|0,J|0)|0;Y=D;f[Y>>2]=X;f[Y+4>>2]=J;Y=f[q>>2]|0;if((Y|0)==(f[E>>2]|0)){xga(d,m);break}else{f[Y>>2]=f[m>>2];f[Y+4>>2]=f[m+4>>2];f[Y+8>>2]=f[m+8>>2];f[Y+12>>2]=f[m+12>>2];f[Y+16>>2]=f[m+16>>2];f[Y+20>>2]=f[m+20>>2];f[Y+24>>2]=f[m+24>>2];f[Y+28>>2]=f[m+28>>2];f[q>>2]=(f[q>>2]|0)+32;break}}while(0);H=H+1|0;K=k;f[K>>2]=I;f[K+4>>2]=s;K=r;f[K>>2]=x;f[K+4>>2]=w}while((H|0)!=(c|0));u=j;return}function vga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+48|0;g=e+32|0;h=e;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;l=j-k|0;m=l>>5;n=f[a+40>>2]|0;o=f[n+4>>2]|0;p=f[n>>2]|0;n=f[a+4>>2]|0;q=k;k=j;if((n|0)>0)r=f[(f[a+44>>2]|0)+(n+-1<<2)>>2]|0;else r=0;if((l|0)<64){u=e;return}else{s=-2147483648;t=2147483647;v=0;w=2147483647;x=-1;y=-1;z=-1}while(1){l=q+(v<<5)+8|0;n=f[l>>2]|0;j=f[l+4>>2]|0;l=f[q+(v<<5)+4>>2]|0;A=f[q+(v<<5)>>2]|0;B=l-A|0;C=q+(v<<5)+16|0;D=mJc(B|0,((B|0)<0)<<31>>31|0,f[C>>2]|0,f[C+4>>2]|0)|0;C=UIc(D|0,J|0,n|0,j|0)|0;D=J;t=(A|0)<(t|0)?A:t;s=(s|0)<(l|0)?l:s;l=(j|0)<(w|0)|(j|0)==(w|0)&n>>>0<x>>>0;A=l?n:x;B=l?j:w;l=(y|0)<(j|0)|(y|0)==(j|0)&z>>>0<n>>>0;E=l?n:z;n=l?j:y;j=(D|0)<(B|0)|(D|0)==(B|0)&C>>>0<A>>>0;x=j?C:A;w=j?D:B;B=(n|0)<(D|0)|(n|0)==(D|0)&E>>>0<C>>>0;y=B?D:n;v=v+1|0;if((v|0)>=(m|0))break;else z=B?C:E}if((s|0)<0){u=e;return}if((y|0)<0|(t|0)>=(p|0)){u=e;return}t=jJc(o|0,((o|0)<0)<<31>>31|0,16)|0;y=J;if(!((w|0)<(y|0)|(w|0)==(y|0)&x>>>0<t>>>0)){u=e;return}wga(q,k,g);f[h>>2]=2147483647;g=f[i>>2]|0;if((g|0)==(f[c+8>>2]|0))xga(c,h);else{f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[i>>2]=(f[i>>2]|0)+32}i=h+24|0;f[i>>2]=0;g=f[c>>2]|0;k=(s|0)>(p|0)?p:s;s=f[g>>2]|0;if((s|0)>=(k|0)){u=e;return}p=a+16|0;q=a+44|0;a=o+-1|0;t=(r|0)==1;x=s;s=g;g=0;y=0;while(1){a:do if((x|0)<0){w=f[c>>2]|0;z=0;v=h;E=y;C=s;B=g;while(1){b:do if(!E)F=22;else{n=v+24|0;D=E;while(1){if((f[D+4>>2]|0)!=(x|0))break;j=D+24|0;f[n>>2]=f[j>>2];A=f[j>>2]|0;if(!A){F=22;break b}else D=A}if((f[C>>2]|0)<=(x|0)?(A=D+8|0,j=f[A+4>>2]|0,l=C+8|0,G=f[l+4>>2]|0,!((j|0)<(G|0)|((j|0)==(G|0)?(f[A>>2]|0)>>>0<(f[l>>2]|0)>>>0:0))):0)if((B|0)<(m|0)){H=D;I=n;F=24;break}else{K=C;L=B;break a}M=D;N=f[D+24>>2]|0;O=C;P=B}while(0);if((F|0)==22){F=0;if(!((B|0)<(m|0)?(f[C>>2]|0)==(x|0):0)){K=C;L=B;break a}H=0;I=v+24|0;F=24}if((F|0)==24){F=0;f[I>>2]=C;f[C+24>>2]=H;l=B+1|0;M=C;N=H;O=w+(l<<5)|0;P=l}if(z|0){l=v+16|0;A=v+8|0;G=A;j=UIc(f[G>>2]|0,f[G+4>>2]|0,f[l>>2]|0,f[l+4>>2]|0)|0;l=A;f[l>>2]=j;f[l+4>>2]=J;l=M+16|0;j=M+8|0;A=j;G=UIc(f[A>>2]|0,f[A+4>>2]|0,f[l>>2]|0,f[l+4>>2]|0)|0;l=j;f[l>>2]=G;f[l+4>>2]=J}z=z^1;v=M;E=N;C=O;B=P}}else{B=0;C=h;E=y;v=s;z=g;while(1){c:do if(!E)F=31;else{w=C+24|0;l=E;while(1){if((f[l+4>>2]|0)!=(x|0))break;G=l+24|0;f[w>>2]=f[G>>2];j=f[G>>2]|0;if(!j){F=31;break c}else l=j}if((f[v>>2]|0)<=(x|0)?(D=l+8|0,n=f[D+4>>2]|0,j=v+8|0,G=f[j+4>>2]|0,!((n|0)<(G|0)|((n|0)==(G|0)?(f[D>>2]|0)>>>0<(f[j>>2]|0)>>>0:0))):0)if((z|0)<(m|0)){Q=l;R=w;F=40;break}else{K=v;L=z;break a}S=l;T=f[l+24>>2]|0;U=v;V=z}while(0);if((F|0)==31){F=0;if(!((z|0)<(m|0)?(f[v>>2]|0)==(x|0):0)){K=v;L=z;break a}Q=0;R=C+24|0;F=40}if((F|0)==40){F=0;f[R>>2]=v;f[v+24>>2]=Q;j=z+1|0;S=v;T=Q;U=(f[c>>2]|0)+(j<<5)|0;V=j}if(B|0){j=(f[p>>2]|0)+(Y(f[f[q>>2]>>2]|0,x)|0)|0;D=C+8|0;G=D;n=f[G>>2]|0;A=f[G+4>>2]|0;G=S+8|0;W=G;X=f[W>>2]|0;Z=f[W+4>>2]|0;W=(A|0)>(Z|0)|(A|0)==(Z|0)&n>>>0>X>>>0;_=UIc((W?X:n)|0,(W?Z:A)|0,65535,0)|0;$=aJc(_|0,J|0,16)|0;_=aJc((W?n:X)|0,(W?A:Z)|0,16)|0;do if((_|0)>-1&($|0)<(o|0)){Z=Y(($|0)>0?$:0,r)|0;A=j+Z|0;W=Y(((_|0)<(o|0)?_:a)+1|0,r)|0;X=j+W|0;if(t){XIc(A|0,b[d>>0]|0,X-A|0)|0;break}if((Z|0)<(W|0)){dJc(A|0,d|0,r|0)|0;aa=A+r|0}else aa=A;if(aa>>>0<X>>>0){W=X;Z=r;n=aa;while(1){dJc(n|0,A|0,Z|0)|0;n=n+Z|0;ba=Z<<1;ca=W-n|0;if(n>>>0>=X>>>0)break;else Z=ca>>>0<ba>>>0?ca:ba}}}while(0);j=C+16|0;_=D;$=UIc(f[_>>2]|0,f[_+4>>2]|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=D;f[j>>2]=$;f[j+4>>2]=J;j=S+16|0;$=G;_=UIc(f[$>>2]|0,f[$+4>>2]|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=G;f[j>>2]=_;f[j+4>>2]=J}B=B^1;C=S;E=T;v=U;z=V}}while(0);z=0;v=0;E=f[i>>2]|0;while(1){d:do if((E|0)==(v|0)){da=z;ea=h}else{C=z;B=h;j=E;while(1){_=j+24|0;$=f[_>>2]|0;if(!$){da=C;ea=B;break d}Z=j+8|0;X=f[Z>>2]|0;n=f[Z+4>>2]|0;Z=C;W=B;A=$;while(1){$=A+8|0;l=f[$+4>>2]|0;if(!((n|0)>(l|0)|((n|0)==(l|0)?X>>>0>(f[$>>2]|0)>>>0:0)))break;f[W+24>>2]=A;$=A+24|0;f[_>>2]=f[$>>2];f[$>>2]=j;$=f[_>>2]|0;if(!$){da=1;ea=A;break d}else{l=A;Z=1;A=$;W=l}}if((A|0)==(v|0)){da=Z;ea=j;break}else{W=j;C=Z;j=A;B=W}}}while(0);if(!da)break;E=f[i>>2]|0;if(!((ea|0)!=(h|0)&(ea|0)!=(E|0)))break;else{z=da;v=ea}}v=x+1|0;if((v|0)>=(k|0))break;x=v;s=K;g=L;y=f[i>>2]|0}u=e;return}function wga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;d=u;u=u+32|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-32|0;i=a+-64|0;j=a+-24|0;k=a+-16|0;l=g;while(1){m=l;b:while(1){n=m;o=b-n|0;p=o>>5;switch(p|0){case 2:{q=5;break a;break}case 3:{q=11;break a;break}case 4:{q=12;break a;break}case 5:{q=13;break a;break}case 1:case 0:{q=107;break a;break}default:{}}if((o|0)<992){q=15;break a}r=(p|0)/2|0;s=m+(r<<5)|0;if((o|0)>31968){o=(p|0)/4|0;t=Aga(m,m+(o<<5)|0,s,s+(o<<5)|0,h,c)|0}else t=yga(m,s,h,c)|0;o=f[m>>2]|0;p=f[s>>2]|0;if((o|0)==(p|0)){v=m+8|0;w=f[v>>2]|0;x=f[v+4>>2]|0;v=m+(r<<5)+8|0;y=f[v>>2]|0;z=f[v+4>>2]|0;if((w|0)==(y|0)&(x|0)==(z|0)){v=m+16|0;A=m+(r<<5)+16|0;B=f[v+4>>2]|0;C=f[A+4>>2]|0;D=f[v>>2]|0;E=f[A>>2]|0}else{B=x;C=z;D=w;E=y}if((B|0)<(C|0)|(B|0)==(C|0)&D>>>0<E>>>0){F=h;G=t;break}}else if((o|0)<(p|0)){F=h;G=t;break}if((m|0)!=(i|0)){y=m+(r<<5)+8|0;w=m+(r<<5)+16|0;r=h;H=i;while(1){z=f[H>>2]|0;if((z|0)==(p|0)){x=r+-24|0;A=f[x>>2]|0;v=f[x+4>>2]|0;x=y;I=f[x>>2]|0;J=f[x+4>>2]|0;if((A|0)==(I|0)&(v|0)==(J|0)){x=r+-16|0;K=w;L=f[x+4>>2]|0;M=f[K+4>>2]|0;N=f[x>>2]|0;O=f[K>>2]|0}else{L=v;M=J;N=A;O=I}if((L|0)<(M|0)|(L|0)==(M|0)&N>>>0<O>>>0){q=77;break b}}else if((z|0)<(p|0)){q=77;break b}z=H+-32|0;if((m|0)==(z|0))break;else{I=H;H=z;r=I}}}r=m+32|0;p=f[h>>2]|0;if((o|0)==(p|0)){w=m+8|0;y=f[w>>2]|0;I=f[w+4>>2]|0;w=j;z=f[w>>2]|0;A=f[w+4>>2]|0;if((y|0)==(z|0)&(I|0)==(A|0)){w=m+16|0;J=k;P=f[w+4>>2]|0;Q=f[J+4>>2]|0;R=f[w>>2]|0;S=f[J>>2]|0}else{P=I;Q=A;R=y;S=z}if((P|0)<(Q|0)|(P|0)==(Q|0)&R>>>0<S>>>0)T=r;else q=46}else if((o|0)<(p|0))T=r;else q=46;if((q|0)==46){q=0;if((r|0)==(h|0)){q=107;break a}p=m+8|0;z=m+16|0;y=r;while(1){r=f[y>>2]|0;if((o|0)==(r|0)){A=p;I=f[A>>2]|0;J=f[A+4>>2]|0;A=y+8|0;w=f[A>>2]|0;v=f[A+4>>2]|0;if((I|0)==(w|0)&(J|0)==(v|0)){A=z;K=y+16|0;U=f[A+4>>2]|0;V=f[K+4>>2]|0;W=f[A>>2]|0;X=f[K>>2]|0}else{U=J;V=v;W=I;X=w}if((U|0)<(V|0)|(U|0)==(V|0)&W>>>0<X>>>0)break}else if((o|0)<(r|0))break;r=y+32|0;if((r|0)==(h|0)){q=107;break a}else y=r}f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];f[e+8>>2]=f[y+8>>2];f[e+12>>2]=f[y+12>>2];f[e+16>>2]=f[y+16>>2];f[e+20>>2]=f[y+20>>2];f[e+24>>2]=f[y+24>>2];f[e+28>>2]=f[y+28>>2];f[y>>2]=f[h>>2];f[y+4>>2]=f[h+4>>2];f[y+8>>2]=f[h+8>>2];f[y+12>>2]=f[h+12>>2];f[y+16>>2]=f[h+16>>2];f[y+20>>2]=f[h+20>>2];f[y+24>>2]=f[h+24>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];T=y+32|0}if((T|0)==(h|0)){q=107;break a}o=m+8|0;z=m+16|0;p=h;r=T;while(1){w=f[m>>2]|0;I=r;while(1){v=f[I>>2]|0;if((w|0)==(v|0)){J=o;K=f[J>>2]|0;A=f[J+4>>2]|0;J=I+8|0;x=f[J>>2]|0;Y=f[J+4>>2]|0;if((K|0)==(x|0)&(A|0)==(Y|0)){J=z;Z=I+16|0;_=f[J+4>>2]|0;$=f[Z+4>>2]|0;aa=f[J>>2]|0;ba=f[Z>>2]|0}else{_=A;$=Y;aa=K;ba=x}if((_|0)<($|0)|(_|0)==($|0)&aa>>>0<ba>>>0){ca=p;break}}else if((w|0)<(v|0)){ca=p;break}I=I+32|0}while(1){v=ca;ca=ca+-32|0;x=f[ca>>2]|0;if((w|0)!=(x|0))if((w|0)<(x|0)){ca=ca;continue}else break;x=o;K=f[x>>2]|0;Y=f[x+4>>2]|0;x=v+-24|0;A=f[x>>2]|0;Z=f[x+4>>2]|0;if((K|0)==(A|0)&(Y|0)==(Z|0)){x=z;J=v+-16|0;da=f[x+4>>2]|0;ea=f[J+4>>2]|0;fa=f[x>>2]|0;ga=f[J>>2]|0}else{da=Y;ea=Z;fa=K;ga=A}if(!((da|0)<(ea|0)|(da|0)==(ea|0)&fa>>>0<ga>>>0))break}if(I>>>0>=ca>>>0){m=I;continue b};f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[e+16>>2]=f[I+16>>2];f[e+20>>2]=f[I+20>>2];f[e+24>>2]=f[I+24>>2];f[e+28>>2]=f[I+28>>2];f[I>>2]=f[ca>>2];f[I+4>>2]=f[ca+4>>2];f[I+8>>2]=f[ca+8>>2];f[I+12>>2]=f[ca+12>>2];f[I+16>>2]=f[ca+16>>2];f[I+20>>2]=f[ca+20>>2];f[I+24>>2]=f[ca+24>>2];f[ca>>2]=f[e>>2];f[ca+4>>2]=f[e+4>>2];f[ca+8>>2]=f[e+8>>2];f[ca+12>>2]=f[e+12>>2];f[ca+16>>2]=f[e+16>>2];f[ca+20>>2]=f[e+20>>2];f[ca+24>>2]=f[e+24>>2];p=ca;r=I+32|0}}if((q|0)==77){q=0;f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[m>>2]=f[H>>2];f[m+4>>2]=f[H+4>>2];f[m+8>>2]=f[H+8>>2];f[m+12>>2]=f[H+12>>2];f[m+16>>2]=f[H+16>>2];f[m+20>>2]=f[H+20>>2];f[m+24>>2]=f[H+24>>2];f[H>>2]=f[e>>2];f[H+4>>2]=f[e+4>>2];f[H+8>>2]=f[e+8>>2];f[H+12>>2]=f[e+12>>2];f[H+16>>2]=f[e+16>>2];f[H+20>>2]=f[e+20>>2];f[H+24>>2]=f[e+24>>2];F=H;G=t+1|0}r=m+32|0;c:do if(r>>>0<F>>>0){p=s;z=F;o=r;y=G;while(1){w=f[p>>2]|0;A=p+8|0;K=p+16|0;Z=o;while(1){Y=f[Z>>2]|0;if((Y|0)==(w|0)){J=Z+8|0;x=f[J>>2]|0;v=f[J+4>>2]|0;J=A;ha=f[J>>2]|0;ia=f[J+4>>2]|0;if((x|0)==(ha|0)&(v|0)==(ia|0)){J=Z+16|0;ja=K;ka=f[J+4>>2]|0;la=f[ja+4>>2]|0;ma=f[J>>2]|0;na=f[ja>>2]|0}else{ka=v;la=ia;ma=x;na=ha}if(!((ka|0)<(la|0)|(ka|0)==(la|0)&ma>>>0<na>>>0)){oa=z;break}}else if((Y|0)>=(w|0)){oa=z;break}Z=Z+32|0}while(1){I=oa;oa=oa+-32|0;Y=f[oa>>2]|0;if((Y|0)!=(w|0))if((Y|0)<(w|0))break;else{oa=oa;continue}Y=I+-24|0;ha=f[Y>>2]|0;x=f[Y+4>>2]|0;Y=A;ia=f[Y>>2]|0;v=f[Y+4>>2]|0;if((ha|0)==(ia|0)&(x|0)==(v|0)){Y=I+-16|0;I=K;pa=f[Y+4>>2]|0;qa=f[I+4>>2]|0;ra=f[Y>>2]|0;sa=f[I>>2]|0}else{pa=x;qa=v;ra=ha;sa=ia}if((pa|0)<(qa|0)|(pa|0)==(qa|0)&ra>>>0<sa>>>0)break}if(Z>>>0>oa>>>0){ta=p;ua=y;va=Z;break c};f[e>>2]=f[Z>>2];f[e+4>>2]=f[Z+4>>2];f[e+8>>2]=f[Z+8>>2];f[e+12>>2]=f[Z+12>>2];f[e+16>>2]=f[Z+16>>2];f[e+20>>2]=f[Z+20>>2];f[e+24>>2]=f[Z+24>>2];f[e+28>>2]=f[Z+28>>2];f[Z>>2]=f[oa>>2];f[Z+4>>2]=f[oa+4>>2];f[Z+8>>2]=f[oa+8>>2];f[Z+12>>2]=f[oa+12>>2];f[Z+16>>2]=f[oa+16>>2];f[Z+20>>2]=f[oa+20>>2];f[Z+24>>2]=f[oa+24>>2];f[oa>>2]=f[e>>2];f[oa+4>>2]=f[e+4>>2];f[oa+8>>2]=f[e+8>>2];f[oa+12>>2]=f[e+12>>2];f[oa+16>>2]=f[e+16>>2];f[oa+20>>2]=f[e+20>>2];f[oa+24>>2]=f[e+24>>2];p=(p|0)==(Z|0)?oa:p;z=oa;o=Z+32|0;y=y+1|0}}else{ta=s;ua=G;va=r}while(0);do if((va|0)==(ta|0))wa=ua;else{r=f[ta>>2]|0;y=f[va>>2]|0;if((r|0)==(y|0)){o=ta+8|0;z=f[o>>2]|0;p=f[o+4>>2]|0;o=va+8|0;K=f[o>>2]|0;A=f[o+4>>2]|0;if((z|0)==(K|0)&(p|0)==(A|0)){o=ta+16|0;w=va+16|0;xa=f[o+4>>2]|0;ya=f[w+4>>2]|0;za=f[o>>2]|0;Aa=f[w>>2]|0}else{xa=p;ya=A;za=z;Aa=K}if(!((xa|0)<(ya|0)|(xa|0)==(ya|0)&za>>>0<Aa>>>0)){wa=ua;break}}else if((r|0)>=(y|0)){wa=ua;break};f[e>>2]=f[va>>2];f[e+4>>2]=f[va+4>>2];f[e+8>>2]=f[va+8>>2];f[e+12>>2]=f[va+12>>2];f[e+16>>2]=f[va+16>>2];f[e+20>>2]=f[va+20>>2];f[e+24>>2]=f[va+24>>2];f[e+28>>2]=f[va+28>>2];f[va>>2]=f[ta>>2];f[va+4>>2]=f[ta+4>>2];f[va+8>>2]=f[ta+8>>2];f[va+12>>2]=f[ta+12>>2];f[va+16>>2]=f[ta+16>>2];f[va+20>>2]=f[ta+20>>2];f[va+24>>2]=f[ta+24>>2];f[ta>>2]=f[e>>2];f[ta+4>>2]=f[e+4>>2];f[ta+8>>2]=f[e+8>>2];f[ta+12>>2]=f[e+12>>2];f[ta+16>>2]=f[e+16>>2];f[ta+20>>2]=f[e+20>>2];f[ta+24>>2]=f[e+24>>2];wa=ua+1|0}while(0);if(!wa){Ba=Bga(m,va,c)|0;y=va+32|0;if(Bga(y,a,c)|0){q=106;break}if(Ba){l=y;continue}}y=va;if((y-n|0)>=(b-y|0)){q=105;break}wga(m,va,c);l=va+32|0}if((q|0)==105){q=0;wga(va+32|0,a,c);g=m;a=va;continue}else if((q|0)==106){q=0;if(Ba){q=107;break}else{g=m;a=va;continue}}}if((q|0)==5){va=f[h>>2]|0;g=f[m>>2]|0;if((va|0)==(g|0)){Ba=j;j=f[Ba>>2]|0;n=f[Ba+4>>2]|0;Ba=m+8|0;wa=f[Ba>>2]|0;ua=f[Ba+4>>2]|0;if((j|0)==(wa|0)&(n|0)==(ua|0)){Ba=k;k=m+16|0;Ca=f[Ba+4>>2]|0;Da=f[k+4>>2]|0;Ea=f[Ba>>2]|0;Fa=f[k>>2]|0}else{Ca=n;Da=ua;Ea=j;Fa=wa}if(!((Ca|0)<(Da|0)|(Ca|0)==(Da|0)&Ea>>>0<Fa>>>0)){u=d;return}}else if((va|0)>=(g|0)){u=d;return};f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[m+20>>2]=f[h+20>>2];f[m+24>>2]=f[h+24>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];u=d;return}else if((q|0)==11){yga(m,m+32|0,h,c)|0;u=d;return}else if((q|0)==12){zga(m,m+32|0,m+64|0,h,c)|0;u=d;return}else if((q|0)==13){Aga(m,m+32|0,m+64|0,m+96|0,h,c)|0;u=d;return}else if((q|0)==15){h=m+64|0;yga(m,m+32|0,h,c)|0;c=m+96|0;if((c|0)==(a|0)){u=d;return}else{Ga=c;Ha=h}while(1){h=f[Ga>>2]|0;c=f[Ha>>2]|0;if((h|0)==(c|0)){e=Ga+8|0;g=f[e>>2]|0;va=f[e+4>>2]|0;e=Ha+8|0;Fa=f[e>>2]|0;Ea=f[e+4>>2]|0;if((g|0)==(Fa|0)&(va|0)==(Ea|0)){e=Ga+16|0;Da=Ha+16|0;Ia=f[e+4>>2]|0;Ja=f[Da+4>>2]|0;Ka=f[e>>2]|0;La=f[Da>>2]|0}else{Ia=va;Ja=Ea;Ka=g;La=Fa}if((Ia|0)<(Ja|0)|(Ia|0)==(Ja|0)&Ka>>>0<La>>>0){Ma=g;Na=va;q=22}}else if((h|0)<(c|0)){c=Ga+8|0;Ma=f[c>>2]|0;Na=f[c+4>>2]|0;q=22}if((q|0)==22){q=0;c=f[Ga+4>>2]|0;va=Ga+16|0;g=f[va>>2]|0;Fa=f[va+4>>2]|0;va=f[Ga+24>>2]|0;f[Ga>>2]=f[Ha>>2];f[Ga+4>>2]=f[Ha+4>>2];f[Ga+8>>2]=f[Ha+8>>2];f[Ga+12>>2]=f[Ha+12>>2];f[Ga+16>>2]=f[Ha+16>>2];f[Ga+20>>2]=f[Ha+20>>2];f[Ga+24>>2]=f[Ha+24>>2];d:do if((Ha|0)==(m|0))Oa=m;else{Ea=Ha;while(1){Da=Ea;Ea=Ea+-32|0;e=f[Ea>>2]|0;if((h|0)==(e|0)){Ca=Da+-24|0;wa=f[Ca>>2]|0;j=f[Ca+4>>2]|0;if((Ma|0)==(wa|0)&(Na|0)==(j|0)){Ca=Da+-16|0;Pa=Fa;Qa=f[Ca+4>>2]|0;Ra=g;Sa=f[Ca>>2]|0}else{Pa=Na;Qa=j;Ra=Ma;Sa=wa}if(!((Pa|0)<(Qa|0)|(Pa|0)==(Qa|0)&Ra>>>0<Sa>>>0)){Oa=Da;break d}}else if((h|0)>=(e|0)){Oa=Da;break d};f[Da>>2]=f[Ea>>2];f[Da+4>>2]=f[Ea+4>>2];f[Da+8>>2]=f[Ea+8>>2];f[Da+12>>2]=f[Ea+12>>2];f[Da+16>>2]=f[Ea+16>>2];f[Da+20>>2]=f[Ea+20>>2];f[Da+24>>2]=f[Ea+24>>2];if((Ea|0)==(m|0)){Oa=m;break}}}while(0);f[Oa>>2]=h;f[Oa+4>>2]=c;Ea=Oa+8|0;f[Ea>>2]=Ma;f[Ea+4>>2]=Na;Ea=Oa+16|0;f[Ea>>2]=g;f[Ea+4>>2]=Fa;f[Oa+24>>2]=va}Ea=Ga+32|0;if((Ea|0)==(a|0))break;else{Da=Ga;Ga=Ea;Ha=Da}}u=d;return}else if((q|0)==107){u=d;return}}function xga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>5;h=g+1|0;if(h>>>0>134217727)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>4;l=j>>5>>>0<67108863?(k>>>0<h>>>0?h:k):134217727;do if(l)if(l>>>0>134217727){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<5)|0;break}else m=0;while(0);k=m+(g<<5)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];f[k+28>>2]=f[b+28>>2];b=k+(0-g<<5)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+32;f[i>>2]=m+(l<<5);if(!d)return;YDc(d);return}function yga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+32|0;e=d;g=f[b>>2]|0;h=f[a>>2]|0;if((g|0)==(h|0)){i=b+8|0;j=f[i>>2]|0;k=f[i+4>>2]|0;i=a+8|0;l=f[i>>2]|0;m=f[i+4>>2]|0;if((j|0)==(l|0)&(k|0)==(m|0)){i=b+16|0;n=a+16|0;o=f[i+4>>2]|0;p=f[n+4>>2]|0;q=f[i>>2]|0;r=f[n>>2]|0}else{o=k;p=m;q=j;r=l}s=(o|0)<(p|0)|(o|0)==(p|0)&q>>>0<r>>>0}else s=(g|0)<(h|0);h=f[c>>2]|0;if((h|0)==(g|0)){r=c+8|0;q=f[r>>2]|0;p=f[r+4>>2]|0;r=b+8|0;o=f[r>>2]|0;l=f[r+4>>2]|0;if((q|0)==(o|0)&(p|0)==(l|0)){r=c+16|0;j=b+16|0;t=f[r+4>>2]|0;v=f[j+4>>2]|0;w=f[r>>2]|0;x=f[j>>2]|0}else{t=p;v=l;w=q;x=o}y=(t|0)<(v|0)|(t|0)==(v|0)&w>>>0<x>>>0}else y=(h|0)<(g|0);if(!s){if(!y){z=0;u=d;return z|0};f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[e+12>>2]=f[b+12>>2];f[e+16>>2]=f[b+16>>2];f[e+20>>2]=f[b+20>>2];f[e+24>>2]=f[b+24>>2];f[e+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];s=f[b>>2]|0;g=f[a>>2]|0;if((s|0)==(g|0)){h=b+8|0;x=f[h>>2]|0;w=f[h+4>>2]|0;h=a+8|0;v=f[h>>2]|0;t=f[h+4>>2]|0;if((x|0)==(v|0)&(w|0)==(t|0)){h=b+16|0;o=a+16|0;A=f[h+4>>2]|0;B=f[o+4>>2]|0;C=f[h>>2]|0;D=f[o>>2]|0}else{A=w;B=t;C=x;D=v}if(!((A|0)<(B|0)|(A|0)==(B|0)&C>>>0<D>>>0)){z=1;u=d;return z|0}}else if((s|0)>=(g|0)){z=1;u=d;return z|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];z=2;u=d;return z|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];if(y){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];z=1;u=d;return z|0};f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];a=f[c>>2]|0;y=f[b>>2]|0;if((a|0)==(y|0)){g=c+8|0;s=f[g>>2]|0;D=f[g+4>>2]|0;g=b+8|0;C=f[g>>2]|0;B=f[g+4>>2]|0;if((s|0)==(C|0)&(D|0)==(B|0)){g=c+16|0;A=b+16|0;E=f[g+4>>2]|0;F=f[A+4>>2]|0;G=f[g>>2]|0;H=f[A>>2]|0}else{E=D;F=B;G=s;H=C}if(!((E|0)<(F|0)|(E|0)==(F|0)&G>>>0<H>>>0)){z=1;u=d;return z|0}}else if((a|0)>=(y|0)){z=1;u=d;return z|0};f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[e+12>>2]=f[b+12>>2];f[e+16>>2]=f[b+16>>2];f[e+20>>2]=f[b+20>>2];f[e+24>>2]=f[b+24>>2];f[e+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];z=2;u=d;return z|0}function zga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+32|0;h=g;i=yga(a,b,c,e)|0;e=f[d>>2]|0;j=f[c>>2]|0;if((e|0)==(j|0)){k=d+8|0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c+8|0;n=f[k>>2]|0;o=f[k+4>>2]|0;if((l|0)==(n|0)&(m|0)==(o|0)){k=d+16|0;p=c+16|0;q=f[k+4>>2]|0;r=f[p+4>>2]|0;s=f[k>>2]|0;t=f[p>>2]|0}else{q=m;r=o;s=l;t=n}if(!((q|0)<(r|0)|(q|0)==(r|0)&s>>>0<t>>>0)){v=i;u=g;return v|0}}else if((e|0)>=(j|0)){v=i;u=g;return v|0};f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[h+8>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];f[d+8>>2]=f[h+8>>2];f[d+12>>2]=f[h+12>>2];f[d+16>>2]=f[h+16>>2];f[d+20>>2]=f[h+20>>2];f[d+24>>2]=f[h+24>>2];d=i+1|0;j=f[c>>2]|0;e=f[b>>2]|0;if((j|0)==(e|0)){t=c+8|0;s=f[t>>2]|0;r=f[t+4>>2]|0;t=b+8|0;q=f[t>>2]|0;n=f[t+4>>2]|0;if((s|0)==(q|0)&(r|0)==(n|0)){t=c+16|0;l=b+16|0;w=f[t+4>>2]|0;x=f[l+4>>2]|0;y=f[t>>2]|0;z=f[l>>2]|0}else{w=r;x=n;y=s;z=q}if(!((w|0)<(x|0)|(w|0)==(x|0)&y>>>0<z>>>0)){v=d;u=g;return v|0}}else if((j|0)>=(e|0)){v=d;u=g;return v|0};f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[h+8>>2]=f[b+8>>2];f[h+12>>2]=f[b+12>>2];f[h+16>>2]=f[b+16>>2];f[h+20>>2]=f[b+20>>2];f[h+24>>2]=f[b+24>>2];f[h+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];c=i+2|0;d=f[b>>2]|0;e=f[a>>2]|0;if((d|0)==(e|0)){j=b+8|0;z=f[j>>2]|0;y=f[j+4>>2]|0;j=a+8|0;x=f[j>>2]|0;w=f[j+4>>2]|0;if((z|0)==(x|0)&(y|0)==(w|0)){j=b+16|0;q=a+16|0;A=f[j+4>>2]|0;B=f[q+4>>2]|0;C=f[j>>2]|0;D=f[q>>2]|0}else{A=y;B=w;C=z;D=x}if(!((A|0)<(B|0)|(A|0)==(B|0)&C>>>0<D>>>0)){v=c;u=g;return v|0}}else if((d|0)>=(e|0)){v=c;u=g;return v|0};f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[h>>2];f[b+4>>2]=f[h+4>>2];f[b+8>>2]=f[h+8>>2];f[b+12>>2]=f[h+12>>2];f[b+16>>2]=f[h+16>>2];f[b+20>>2]=f[h+20>>2];f[b+24>>2]=f[h+24>>2];v=i+3|0;u=g;return v|0}function Aga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+32|0;i=h;j=zga(a,b,c,d,g)|0;g=f[e>>2]|0;k=f[d>>2]|0;if((g|0)==(k|0)){l=e+8|0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=d+8|0;o=f[l>>2]|0;p=f[l+4>>2]|0;if((m|0)==(o|0)&(n|0)==(p|0)){l=e+16|0;q=d+16|0;r=f[l+4>>2]|0;s=f[q+4>>2]|0;t=f[l>>2]|0;v=f[q>>2]|0}else{r=n;s=p;t=m;v=o}if(!((r|0)<(s|0)|(r|0)==(s|0)&t>>>0<v>>>0)){w=j;u=h;return w|0}}else if((g|0)>=(k|0)){w=j;u=h;return w|0};f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[d+16>>2]=f[e+16>>2];f[d+20>>2]=f[e+20>>2];f[d+24>>2]=f[e+24>>2];f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];e=j+1|0;k=f[d>>2]|0;g=f[c>>2]|0;if((k|0)==(g|0)){v=d+8|0;t=f[v>>2]|0;s=f[v+4>>2]|0;v=c+8|0;r=f[v>>2]|0;o=f[v+4>>2]|0;if((t|0)==(r|0)&(s|0)==(o|0)){v=d+16|0;m=c+16|0;x=f[v+4>>2]|0;y=f[m+4>>2]|0;z=f[v>>2]|0;A=f[m>>2]|0}else{x=s;y=o;z=t;A=r}if(!((x|0)<(y|0)|(x|0)==(y|0)&z>>>0<A>>>0)){w=e;u=h;return w|0}}else if((k|0)>=(g|0)){w=e;u=h;return w|0};f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[d>>2]=f[i>>2];f[d+4>>2]=f[i+4>>2];f[d+8>>2]=f[i+8>>2];f[d+12>>2]=f[i+12>>2];f[d+16>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];d=j+2|0;e=f[c>>2]|0;g=f[b>>2]|0;if((e|0)==(g|0)){k=c+8|0;A=f[k>>2]|0;z=f[k+4>>2]|0;k=b+8|0;y=f[k>>2]|0;x=f[k+4>>2]|0;if((A|0)==(y|0)&(z|0)==(x|0)){k=c+16|0;r=b+16|0;B=f[k+4>>2]|0;C=f[r+4>>2]|0;D=f[k>>2]|0;E=f[r>>2]|0}else{B=z;C=x;D=A;E=y}if(!((B|0)<(C|0)|(B|0)==(C|0)&D>>>0<E>>>0)){w=d;u=h;return w|0}}else if((e|0)>=(g|0)){w=d;u=h;return w|0};f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];f[i+16>>2]=f[b+16>>2];f[i+20>>2]=f[b+20>>2];f[i+24>>2]=f[b+24>>2];f[i+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];c=j+3|0;d=f[b>>2]|0;g=f[a>>2]|0;if((d|0)==(g|0)){e=b+8|0;E=f[e>>2]|0;D=f[e+4>>2]|0;e=a+8|0;C=f[e>>2]|0;B=f[e+4>>2]|0;if((E|0)==(C|0)&(D|0)==(B|0)){e=b+16|0;y=a+16|0;F=f[e+4>>2]|0;G=f[y+4>>2]|0;H=f[e>>2]|0;I=f[y>>2]|0}else{F=D;G=B;H=E;I=C}if(!((F|0)<(G|0)|(F|0)==(G|0)&H>>>0<I>>>0)){w=c;u=h;return w|0}}else if((d|0)>=(g|0)){w=c;u=h;return w|0};f[i>>2]=f[a>>2];f[i+4>>2]=f[a+4>>2];f[i+8>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[i>>2];f[b+4>>2]=f[i+4>>2];f[b+8>>2]=f[i+8>>2];f[b+12>>2]=f[i+12>>2];f[b+16>>2]=f[i+16>>2];f[b+20>>2]=f[i+20>>2];f[b+24>>2]=f[i+24>>2];w=j+4|0;u=h;return w|0}function Bga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+32|0;e=d;switch(b-a>>5|0){case 2:{g=b+-32|0;h=f[g>>2]|0;i=f[a>>2]|0;if((h|0)==(i|0)){j=b+-24|0;k=f[j>>2]|0;l=f[j+4>>2]|0;j=a+8|0;m=f[j>>2]|0;n=f[j+4>>2]|0;if((k|0)==(m|0)&(l|0)==(n|0)){j=b+-16|0;o=a+16|0;p=f[j+4>>2]|0;q=f[o+4>>2]|0;r=f[j>>2]|0;s=f[o>>2]|0}else{p=l;q=n;r=k;s=m}if(!((p|0)<(q|0)|(p|0)==(q|0)&r>>>0<s>>>0)){t=1;u=d;return t|0}}else if((h|0)>=(i|0)){t=1;u=d;return t|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];f[a+20>>2]=f[g+20>>2];f[a+24>>2]=f[g+24>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2];f[g+24>>2]=f[e+24>>2];t=1;u=d;return t|0}case 3:{yga(a,a+32|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 4:{zga(a,a+32|0,a+64|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 5:{Aga(a,a+32|0,a+64|0,a+96|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 1:case 0:{t=1;u=d;return t|0}default:{g=a+64|0;yga(a,a+32|0,g,c)|0;c=a+96|0;a:do if((c|0)==(b|0)){v=1;w=0}else{i=c;h=0;s=g;while(1){r=f[i>>2]|0;q=f[s>>2]|0;if((r|0)==(q|0)){p=i+8|0;m=f[p>>2]|0;k=f[p+4>>2]|0;p=s+8|0;n=f[p>>2]|0;l=f[p+4>>2]|0;if((m|0)==(n|0)&(k|0)==(l|0)){p=i+16|0;o=s+16|0;x=f[p+4>>2]|0;y=f[o+4>>2]|0;z=f[p>>2]|0;A=f[o>>2]|0}else{x=k;y=l;z=m;A=n}if((x|0)<(y|0)|(x|0)==(y|0)&z>>>0<A>>>0){B=m;C=k;D=19}else E=h}else if((r|0)<(q|0)){q=i+8|0;B=f[q>>2]|0;C=f[q+4>>2]|0;D=19}else E=h;if((D|0)==19){D=0;q=f[i+4>>2]|0;k=i+16|0;m=f[k>>2]|0;n=f[k+4>>2]|0;k=i+24|0;l=f[k+4>>2]|0;o=e;f[o>>2]=f[k>>2];f[o+4>>2]=l;f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[i+8>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];f[i+20>>2]=f[s+20>>2];f[i+24>>2]=f[s+24>>2];b:do if((s|0)==(a|0))F=a;else{l=s;while(1){o=l;l=l+-32|0;k=f[l>>2]|0;if((r|0)==(k|0)){p=o+-24|0;j=f[p>>2]|0;G=f[p+4>>2]|0;if((B|0)==(j|0)&(C|0)==(G|0)){p=o+-16|0;H=n;I=f[p+4>>2]|0;J=m;K=f[p>>2]|0}else{H=C;I=G;J=B;K=j}if(!((H|0)<(I|0)|(H|0)==(I|0)&J>>>0<K>>>0)){F=o;break b}}else if((r|0)>=(k|0)){F=o;break b};f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];if((l|0)==(a|0)){F=a;break}}}while(0);f[F>>2]=r;f[F+4>>2]=q;l=F+8|0;f[l>>2]=B;f[l+4>>2]=C;l=F+16|0;f[l>>2]=m;f[l+4>>2]=n;f[F+24>>2]=f[e>>2];l=h+1|0;if((l|0)==8){v=0;w=(i+32|0)==(b|0);break a}else E=l}l=i+32|0;if((l|0)==(b|0)){v=1;w=0;break}else{o=i;i=l;h=E;s=o}}}while(0);t=w|v;u=d;return t|0}}return 0}function Cga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>5>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>134217727){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>5;i=VDc(b<<5)|0;j=i+(h<<5)|0;k=j+(0-h<<5)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<5);if(!d)return;YDc(d);return}function Dga(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;j=u;u=u+160|0;k=j+96|0;l=j+64|0;m=j;do if((d$(a)|0)==65536){n=f[a+4>>2]|0;f[k>>2]=f[n>>2];o=k+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=k+8|0;f[q>>2]=f[n+8>>2];f[k+12>>2]=f[n+12>>2];f[k+16>>2]=f[n+16>>2];f[k+20>>2]=f[n+20>>2];f[k+24>>2]=f[n+24>>2];f[k+28>>2]=f[n+28>>2];f[k+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=q;q=k+48|0;s=k+44|0;f[s>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;ZS(k,n);break}}else a$(k,a,-1);while(0);if((h|0)==16)t=(f[k>>2]&7|0)==0?16:8;else t=h;if((g|0)>=32768){f[l>>2]=0;f[l+4>>2]=0;v=tT(l,26)|0;w=256491;x=v+26|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));cga(-215,l,256518,1850)}if(i>>>0>=17){f[l>>2]=0;f[l+4>>2]=0;v=tT(l,31)|0;w=256368;x=v+31|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));cga(-215,l,256518,1851)}c1(e,l,f[k>>2]&4095,0);e=f[c>>2]|0;w=((e|0)<0)<<31>>31;v=f[c+4>>2]|0;c=((v|0)<0)<<31>>31;x=m;f[x>>2]=e;f[x+4>>2]=w;x=m+8|0;f[x>>2]=v;f[x+4>>2]=c;x=f[d>>2]|0;h=((x|0)<0)<<31>>31;a=m+16|0;f[a>>2]=x;f[a+4>>2]=h;a=m+24|0;f[a>>2]=v;f[a+4>>2]=c;c=f[d+4>>2]|0;d=((c|0)<0)<<31>>31;a=m+32|0;f[a>>2]=x;f[a+4>>2]=h;h=m+40|0;f[h>>2]=c;f[h+4>>2]=d;h=m+48|0;f[h>>2]=e;f[h+4>>2]=w;w=m+56|0;f[w>>2]=c;f[w+4>>2]=d;if((g|0)>-1)tga(k,m,4,1,l,g,t,i);else oga(k,m,4,l,t,i);i=k+36|0;t=f[i>>2]|0;if(t|0?(l=t+12|0,t=f[l>>2]|0,f[l>>2]=t+-1,(t|0)==1):0)_S(k);f[i>>2]=0;i=k+16|0;t=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[t>>2]|0)>0){i=f[k+40>>2]|0;l=0;do{f[i+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[t>>2]|0))}t=f[k+44>>2]|0;if((t|0)==(k+48|0)){u=j;return}g0(t);u=j;return}function Ega(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;j=u;u=u+128|0;k=j+72|0;l=j+32|0;m=j+16|0;n=j;o=j+64|0;do if((d$(a)|0)==65536){p=f[a+4>>2]|0;f[k>>2]=f[p>>2];q=k+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[k+36>>2]=t;f[k+40>>2]=s;s=k+48|0;v=k+44|0;f[v>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;ZS(k,p);break}}else a$(k,a,-1);while(0);if((h|0)==16)w=(f[k>>2]&7|0)==0?16:8;else w=h;if(!((i|0)<17&((g|0)<32768&(i|d|0)>-1))){f[l>>2]=0;f[l+4>>2]=0;h=tT(l,76)|0;a=256528;p=h+76|0;do{b[h>>0]=b[a>>0]|0;h=h+1|0;a=a+1|0}while((h|0)<(p|0));cga(-215,l,256605,1896)}c1(e,l,f[k>>2]&4095,0);if((i|0)>0|((g|0)>1|(w|0)!=8)){e=f[c>>2]|0;a=f[c+4>>2]|0;h=16-i|0;i=jJc(e|0,((e|0)<0)<<31>>31|0,h|0)|0;e=J;p=jJc(a|0,((a|0)<0)<<31>>31|0,h|0)|0;a=J;q=jJc(d|0,((d|0)<0)<<31>>31|0,h|0)|0;h=J;r=m;f[r>>2]=i;f[r+4>>2]=e;e=m+8|0;f[e>>2]=p;f[e+4>>2]=a;a=n;f[a>>2]=q;f[a+4>>2]=h;a=n+8|0;f[a>>2]=q;f[a+4>>2]=h;qga(k,m,n,0,0,360,l,g,w)}else{f[o>>2]=f[c>>2];f[o+4>>2]=f[c+4>>2];pga(k,o,d,l,g>>>31)}g=k+36|0;l=f[g>>2]|0;if(l|0?(d=l+12|0,l=f[d>>2]|0,f[d>>2]=l+-1,(l|0)==1):0)_S(k);f[g>>2]=0;g=k+16|0;l=k+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[l>>2]|0)>0){g=f[k+40>>2]|0;d=0;do{f[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)==(k+48|0)){u=j;return}g0(l);u=j;return}function Fga(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=u;u=u+128|0;n=m+64|0;o=m+32|0;p=m+16|0;q=m;do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[n>>2]=f[r>>2];s=n+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=n+8|0;f[v>>2]=f[r+8>>2];f[n+12>>2]=f[r+12>>2];f[n+16>>2]=f[r+16>>2];f[n+20>>2]=f[r+20>>2];f[n+24>>2]=f[r+24>>2];f[n+28>>2]=f[r+28>>2];f[n+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[n+36>>2]=w;f[n+40>>2]=v;v=n+48|0;x=n+44|0;f[x>>2]=v;f[v>>2]=0;f[n+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;ZS(n,r);break}}else a$(n,a,-1);while(0);if((k|0)==16)y=(f[n>>2]&7|0)==0?16:8;else y=k;if((f[d>>2]|0)<=-1){f[o>>2]=0;z=o+4|0;f[z>>2]=0;A=tT(o,100)|0;B=A;C=256612;D=B+100|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));cga(-215,o,256713,1928)}k=d+4|0;if(!((l|0)<17&((j|0)<32768?(f[k>>2]|l|0)>-1:0))){f[o>>2]=0;z=o+4|0;f[z>>2]=0;A=tT(o,100)|0;B=A;C=256612;D=B+100|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));cga(-215,o,256713,1928)}c1(i,o,f[n>>2]&4095,0);i=nrc(e)|0;C=nrc(g)|0;B=nrc(h)|0;D=f[c>>2]|0;A=f[c+4>>2]|0;c=f[d>>2]|0;d=f[k>>2]|0;k=16-l|0;l=jJc(D|0,((D|0)<0)<<31>>31|0,k|0)|0;D=J;z=jJc(A|0,((A|0)<0)<<31>>31|0,k|0)|0;A=J;a=jJc(c|0,((c|0)<0)<<31>>31|0,k|0)|0;c=J;r=jJc(d|0,((d|0)<0)<<31>>31|0,k|0)|0;k=p;f[k>>2]=l;f[k+4>>2]=D;D=p+8|0;f[D>>2]=z;f[D+4>>2]=A;A=q;f[A>>2]=a;f[A+4>>2]=c;c=q+8|0;f[c>>2]=r;f[c+4>>2]=J;qga(n,p,q,i,C,B,o,j,y);y=n+36|0;j=f[y>>2]|0;if(j|0?(o=j+12|0,j=f[o>>2]|0,f[o>>2]=j+-1,(j|0)==1):0)_S(n);f[y>>2]=0;y=n+16|0;j=n+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){y=f[n+40>>2]|0;o=0;do{f[y+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[j>>2]|0))}j=f[n+44>>2]|0;if((j|0)==(n+48|0)){u=m;return}g0(j);u=m;return}function Gga(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0;h=u;u=u+128|0;i=h+64|0;j=h+32|0;k=h+16|0;l=h;do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[i>>2]=f[m>>2];o=i+4|0;p=m+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[m+8>>2];f[i+12>>2]=f[m+12>>2];f[i+16>>2]=f[m+16>>2];f[i+20>>2]=f[m+20>>2];f[i+24>>2]=f[m+24>>2];f[i+28>>2]=f[m+28>>2];f[i+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;s=i+44|0;f[s>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[m+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;ZS(i,m);break}}else a$(i,a,-1);while(0);if((g|0)==16)t=(f[i>>2]&7|0)==0?16:8;else t=g;g=c+8|0;if(!(+n[g>>2]>=0.0)){f[j>>2]=0;v=j+4|0;f[v>>2]=0;w=tT(j,73)|0;x=w;y=256721;z=x+73|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));cga(-215,j,256713,1958)}a=c+12|0;if(!((e|0)<32768&+n[a>>2]>=0.0)){f[j>>2]=0;v=j+4|0;f[v>>2]=0;w=tT(j,73)|0;x=w;y=256721;z=x+73|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));cga(-215,j,256713,1958)}c1(d,j,f[i>>2]&4095,0);d=mrc(+n[c+16>>2])|0;A=+n[c>>2];y=mrc(A)|0;B=+n[c+4>>2];c=mrc(B)|0;x=jJc(y|0,((y|0)<0)<<31>>31|0,16)|0;z=J;w=mrc((A-+(y|0))*65536.0)|0;y=UIc(w|0,((w|0)<0)<<31>>31|0,x|0,z|0)|0;z=J;x=jJc(c|0,((c|0)<0)<<31>>31|0,16)|0;w=J;v=mrc((B-+(c|0))*65536.0)|0;c=UIc(v|0,((v|0)<0)<<31>>31|0,x|0,w|0)|0;w=J;B=+n[g>>2];g=mrc(B)|0;A=+n[a>>2];a=mrc(A)|0;x=jJc(g|0,((g|0)<0)<<31>>31|0,15)|0;v=J;m=mrc((B-+(g|0))*32768.0)|0;g=UIc(m|0,((m|0)<0)<<31>>31|0,x|0,v|0)|0;v=J;x=jJc(a|0,((a|0)<0)<<31>>31|0,15)|0;m=J;o=mrc((A-+(a|0))*32768.0)|0;a=UIc(o|0,((o|0)<0)<<31>>31|0,x|0,m|0)|0;m=k;f[m>>2]=y;f[m+4>>2]=z;z=k+8|0;f[z>>2]=c;f[z+4>>2]=w;w=l;f[w>>2]=g;f[w+4>>2]=v;v=l+8|0;f[v>>2]=a;f[v+4>>2]=J;qga(i,k,l,d,0,360,j,e,t);t=i+36|0;e=f[t>>2]|0;if(e|0?(j=e+12|0,e=f[j>>2]|0,f[j>>2]=e+-1,(e|0)==1):0)_S(i);f[t>>2]=0;t=i+16|0;e=i+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[e>>2]|0)>0){t=f[i+40>>2]|0;j=0;do{f[t+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[e>>2]|0))}e=f[i+44>>2]|0;if((e|0)==(i+48|0)){u=h;return}g0(e);u=h;return}function Hga(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;m=u;u=u+128|0;n=m+16|0;o=m+64|0;p=m+48|0;q=m;r=c+4|0;if(!(f[r>>2]|0)){u=m;return}do if((d$(a)|0)==65536){s=f[a+4>>2]|0;f[o>>2]=f[s>>2];t=o+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=o+8|0;f[w>>2]=f[s+8>>2];f[o+12>>2]=f[s+12>>2];f[o+16>>2]=f[s+16>>2];f[o+20>>2]=f[s+20>>2];f[o+24>>2]=f[s+24>>2];f[o+28>>2]=f[s+28>>2];f[o+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[o+36>>2]=x;f[o+40>>2]=w;w=o+48|0;y=o+44|0;f[y>>2]=w;f[w>>2]=0;f[o+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;ZS(o,s);break}}else a$(o,a,-1);while(0);a=(e&16|0)!=0;switch(e&15){case 0:{z=54620;break}case 1:{z=a?50140:50524;break}case 2:{z=54236;break}case 3:{z=a?50908:51292;break}case 4:{z=a?51932:52316;break}case 5:{z=a?52700:53084;break}case 6:{z=53852;break}case 7:{z=53468;break}default:{f[n>>2]=0;f[n+4>>2]=0;a=tT(n,17)|0;s=256795;t=a+17|0;do{b[a>>0]=b[s>>0]|0;a=a+1|0;s=s+1|0}while((a|0)<(t|0));cga(-211,n,256813,2212)}}c1(i,n,f[o>>2]&4095,0);i=0-(f[z>>2]&15)|0;s=nrc(g*65536.0)|0;if((k|0)==16)A=(f[o>>2]&7|0)==0?16:8;else A=k;k=l?0-s|0:s;l=f[d>>2]|0;a=jJc(l|0,((l|0)<0)<<31>>31|0,16)|0;l=J;t=f[d+4>>2]|0;d=jJc(t|0,((t|0)<0)<<31>>31|0,16)|0;t=Y(k,i)|0;i=UIc(d|0,J|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;f[p>>2]=0;d=p+4|0;f[d>>2]=0;f[p+8>>2]=0;v=p+8|0;w=VDc(16384)|0;y=w;f[p>>2]=y;f[d>>2]=y;f[v>>2]=w+16384;if((f[r>>2]|0)>0){y=(e|0)==3;e=((s|0)<0)<<31>>31;x=((k|0)<0)<<31>>31;B=q+8|0;C=a;a=l;l=0;while(1){D=f[c>>2]|0;E=b[D+l>>0]|0;F=E&255;a:do if(y&E<<24>>24<0){switch(E<<24>>24){case -48:{G=l+1|0;H=b[D+G>>0]|0;if((H+112&255)<48){I=175;K=(H&255)+-17|0;L=127;M=G;break a}else{N=H;O=G}break}case -47:{G=l+1|0;H=b[D+G>>0]|0;if(H<<24>>24<0&(H&255)<144){I=191;K=(H&255)+47|0;L=175;M=G;break a}else{N=H;O=G}break}default:{if((E&255)<=191){I=127;K=63;L=32;M=l;break a}G=l+1|0;H=(b[D+G>>0]|0)==0?l:G;if((E&255)<=223){I=127;K=63;L=32;M=H;break a}G=H+1|0;P=(b[D+G>>0]|0)==0?H:G;if((E&255)<=239){I=127;K=63;L=32;M=P;break a}G=P+1|0;H=(b[D+G>>0]|0)==0?P:G;if((E&255)<=247){I=127;K=63;L=32;M=H;break a}G=H+1|0;P=(b[D+G>>0]|0)==0?H:G;if((E&255)<=251){I=127;K=63;L=32;M=P;break a}G=P+1|0;I=127;K=63;L=32;M=(b[D+G>>0]|0)==0?P:G;break a}}I=127;K=63;L=32;M=N<<24>>24==0?l:O}else{I=127;K=F;L=32;M=l}while(0);F=f[62848+(f[z+(((K|0)<(L|0)|(K|0)>=(I|0)?32:K+-31|0)<<2)>>2]<<2)>>2]|0;D=(h[F>>0]|0)+-82|0;E=(h[F+1>>0]|0)+-82|0;G=mJc(E|0,((E|0)<0)<<31>>31|0,s|0,e|0)|0;E=J;P=mJc(D|0,((D|0)<0)<<31>>31|0,s|0,e|0)|0;D=TIc(C|0,a|0,P|0,J|0)|0;P=J;H=f[d>>2]|0;Q=f[p>>2]|0;R=H;if(!((H|0)==(Q|0)|(R|0)==(Q|0)))f[d>>2]=R+(~((R+-16-Q|0)>>>4)<<4);Q=F+2|0;b:while(1){F=b[Q>>0]|0;switch(F<<24>>24){case 0:case 32:break;default:{R=(F&255)+-82|0;H=(h[Q+1>>0]|0)+-82|0;S=UIc(mJc(R|0,((R|0)<0)<<31>>31|0,s|0,e|0)|0,J|0,D|0,P|0)|0;R=J;T=UIc(i|0,t|0,mJc(H|0,((H|0)<0)<<31>>31|0,k|0,x|0)|0,J|0)|0;H=J;U=q;f[U>>2]=S;f[U+4>>2]=R;U=B;f[U>>2]=T;f[U+4>>2]=H;U=f[d>>2]|0;if((U|0)==(f[v>>2]|0))rga(p,q);else{V=U;f[V>>2]=S;f[V+4>>2]=R;R=U+8|0;f[R>>2]=T;f[R+4>>2]=H;f[d>>2]=U+16}Q=Q+2|0;continue b}}U=f[p>>2]|0;H=(f[d>>2]|0)-U>>4;if(H>>>0>1){tga(o,U,H,0,n,j,A,16);W=b[Q>>0]|0}else W=F;if(!(W<<24>>24))break;F=Q+1|0;H=f[d>>2]|0;U=f[p>>2]|0;R=H;if((H|0)==(U|0)|(R|0)==(U|0)){Q=F;continue}f[d>>2]=R+(~((R+-16-U|0)>>>4)<<4);Q=F}C=UIc(D|0,P|0,G|0,E|0)|0;l=M+1|0;if((l|0)>=(f[r>>2]|0))break;else a=J}a=f[p>>2]|0;if(a|0){X=a;Z=a;_=23}}else{X=w;Z=w;_=23}if((_|0)==23){_=f[d>>2]|0;if((_|0)!=(X|0))f[d>>2]=_+(~((_+-16-X|0)>>>4)<<4);YDc(Z)}Z=o+36|0;X=f[Z>>2]|0;if(X|0?(_=X+12|0,X=f[_>>2]|0,f[_>>2]=X+-1,(X|0)==1):0)_S(o);f[Z>>2]=0;Z=o+16|0;X=o+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[X>>2]|0)>0){Z=f[o+40>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[X>>2]|0))}X=f[o+44>>2]|0;if((X|0)!=(o+48|0))g0(X);u=m;return}function Iga(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0.0;l=u;u=u+368|0;m=l+304|0;n=l+96|0;o=l+64|0;q=l+248|0;r=l+192|0;s=l+160|0;t=l+148|0;v=l+136|0;w=l+32|0;x=l;y=l+128|0;do if((d$(a)|0)==65536){z=f[a+4>>2]|0;f[q>>2]=f[z>>2];A=q+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=q+8|0;f[C>>2]=f[z+8>>2];f[q+12>>2]=f[z+12>>2];f[q+16>>2]=f[z+16>>2];f[q+20>>2]=f[z+20>>2];f[q+24>>2]=f[z+24>>2];f[q+28>>2]=f[z+28>>2];f[q+32>>2]=f[z+32>>2];D=f[z+36>>2]|0;f[q+36>>2]=D;f[q+40>>2]=C;C=q+48|0;E=q+44|0;f[E>>2]=C;f[C>>2]=0;f[q+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[A>>2]=0;ZS(q,z);break}}else a$(q,a,-1);while(0);do if((d$(i)|0)==65536){a=f[i+4>>2]|0;f[r>>2]=f[a>>2];z=r+4|0;A=a+4|0;f[z>>2]=f[A>>2];B=r+8|0;f[B>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];C=f[a+36>>2]|0;f[r+36>>2]=C;f[r+40>>2]=B;B=r+48|0;E=r+44|0;f[E>>2]=B;f[B>>2]=0;f[r+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[a+44>>2]|0;B=f[E>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;ZS(r,a);break}}else a$(r,i,-1);while(0);i=f[q+8>>2]|0;a=q+4|0;z=(f[a>>2]|0)==1?1:f[q+12>>2]|0;A=f[q>>2]|0;B=q+16|0;E=f[B>>2]|0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=E;f[s+20>>2]=i;f[s+24>>2]=z;z=q+44|0;f[s+4>>2]=f[f[z>>2]>>2];f[s>>2]=A&20479|1111621632;A=o$(c,-1)|0;f[t>>2]=0;i=t+4|0;f[i>>2]=0;f[t+8>>2]=0;f[v>>2]=0;E=v+4|0;f[E>>2]=0;f[v+8>>2]=0;if(A|0){Jga(t,A);C=f[E>>2]|0;D=f[v>>2]|0;F=(C-D|0)/20|0;G=D;D=C;if(A>>>0<=F>>>0){if(A>>>0<F>>>0?(C=G+(A*20|0)|0,(D|0)!=(C|0)):0)f[E>>2]=D+(~(((D+-20-C|0)>>>0)/20|0)*20|0)}else Kga(v,A-F|0);F=f[t>>2]|0;C=0;do{f[F+(C*56|0)+52>>2]=0;C=C+1|0}while((C|0)!=(A|0));C=(d|0)>-1;do if(C)if((A|0)>(d|0)){H=d;I=d+1|0;J=28;break}else{f[m>>2]=0;f[m+4>>2]=0;K=tT(m,41)|0;L=256825;M=K+41|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));cga(-215,m,256867,2500)}else if(!A){N=0;O=A;P=0}else{H=0;I=A;J=28}while(0);a:do if((J|0)==28){d=c+4|0;F=m+4|0;D=m+8|0;G=m+12|0;Q=m+16|0;R=m+20|0;S=m+24|0;T=m+28|0;U=m+32|0;V=m+36|0;W=m+40|0;X=m+48|0;Z=m+44|0;_=m+52|0;$=H;while(1){do if(($|0)<0&(d$(c)|0)==65536){aa=f[d>>2]|0;f[m>>2]=f[aa>>2];ba=aa+4|0;f[F>>2]=f[ba>>2];f[D>>2]=f[aa+8>>2];f[G>>2]=f[aa+12>>2];f[Q>>2]=f[aa+16>>2];f[R>>2]=f[aa+20>>2];f[S>>2]=f[aa+24>>2];f[T>>2]=f[aa+28>>2];f[U>>2]=f[aa+32>>2];ca=f[aa+36>>2]|0;f[V>>2]=ca;f[W>>2]=D;f[Z>>2]=X;f[X>>2]=0;f[_>>2]=0;if(ca|0){da=ca+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[ba>>2]|0)<3){ba=f[aa+44>>2]|0;da=f[Z>>2]|0;f[da>>2]=f[ba>>2];f[da+4>>2]=f[ba+4>>2];break}else{f[F>>2]=0;ZS(m,aa);break}}else a$(m,c,$);while(0);if(f[Q>>2]|0){aa=f[F>>2]|0;if((aa|0)<3)ea=Y(f[G>>2]|0,f[D>>2]|0)|0;else{ba=f[W>>2]|0;da=0;ca=1;while(1){fa=Y(f[ba+(da<<2)>>2]|0,ca)|0;da=da+1|0;if((da|0)==(aa|0)){ea=fa;break}else ca=fa}}if(!((aa|0)==0|(ea|0)==0)){ca=pT(m,2,4,1)|0;if((ca|0)<=0)break;s7(20492,56,8,f[Q>>2]|0,ca,(f[t>>2]|0)+($*56|0)|0,(f[v>>2]|0)+($*20|0)|0)|0}}ca=f[V>>2]|0;if(ca|0?(da=ca+12|0,ca=f[da>>2]|0,f[da>>2]=ca+-1,(ca|0)==1):0)_S(m);f[V>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[F>>2]|0)>0){ca=f[W>>2]|0;da=0;do{f[ca+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[F>>2]|0))}da=f[Z>>2]|0;if((da|0)!=(X|0))g0(da);$=$+1|0;if($>>>0>=I>>>0){N=H;O=I;P=1;break a}}f[n>>2]=0;f[n+4>>2]=0;K=tT(n,11)|0;L=256880;M=K+11|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));cga(-215,n,256867,2511)}while(0);I=f[r+16>>2]|0;do if(I){H=f[r+4>>2]|0;ea=(H|0)<3;if(ea)ga=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{$=f[r+40>>2]|0;X=0;Z=1;while(1){F=Y(f[$+(X<<2)>>2]|0,Z)|0;X=X+1|0;if((X|0)==(H|0)){ga=F;break}else Z=F}}if(!((j|0)==0|((H|0)==0|(ga|0)==0))){Z=O-N|0;if(ea)ha=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{X=f[r+40>>2]|0;$=0;F=1;while(1){W=Y(f[X+($<<2)>>2]|0,F)|0;$=$+1|0;if(($|0)==(H|0)){ha=W;break}else F=W}}if((ha|0)!=(A|0)){f[m>>2]=0;ia=m+4|0;f[ia>>2]=0;ja=tT(m,62)|0;K=ja;L=256892;M=K+62|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));cga(-215,m,256867,2525)}if((f[r>>2]&4095|0)!=28){f[m>>2]=0;ia=m+4|0;f[ia>>2]=0;ja=tT(m,62)|0;K=ja;L=256892;M=K+62|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));cga(-215,m,256867,2525)}if((Z|0)!=(A|0)){F=f[I+(N<<4)+8>>2]|0;if((F|0)<=-1)break;Lga(c,A,I,F,t,v);H=f[t>>2]|0;f[H+(N*56|0)+20>>2]=H+(F*56|0);break}if(P){F=f[t>>2]|0;H=N;do{$=f[I+(H<<4)>>2]|0;X=f[I+(H<<4)+4>>2]|0;ea=f[I+(H<<4)+8>>2]|0;W=f[I+(H<<4)+12>>2]|0;f[F+(H*56|0)+12>>2]=$>>>0<A>>>0?F+($*56|0)|0:0;f[F+(H*56|0)+8>>2]=X>>>0<A>>>0?F+(X*56|0)|0:0;f[F+(H*56|0)+20>>2]=ea>>>0<A>>>0?F+(ea*56|0)|0:0;f[F+(H*56|0)+16>>2]=W>>>0<A>>>0?F+(W*56|0)|0:0;H=H+1|0}while((H|0)!=(O|0))}}else J=60}else J=60;while(0);if((J|0)==60?P:0){P=O+-1|0;J=f[t>>2]|0;A=N;do{I=A;A=A+1|0;f[J+(I*56|0)+12>>2]=I>>>0<P>>>0?J+(A*56|0)|0:0;f[J+(I*56|0)+8>>2]=I>>>0>N>>>0?J+((I+-1|0)*56|0)|0:0}while((A|0)!=(O|0))}O=(f[t>>2]|0)+(N*56|0)|0;ka=+p[e>>3];p[w>>3]=ka;la=+p[e+8>>3];p[w+8>>3]=la;ma=+p[e+16>>3];p[w+16>>3]=ma;na=+p[e+24>>3];p[w+24>>3]=na;p[x>>3]=ka;p[x+8>>3]=la;p[x+16>>3]=ma;p[x+24>>3]=na;e=f[k+4>>2]|0;f[y>>2]=f[k>>2];f[y+4>>2]=e;f[o>>2]=f[w>>2];f[o+4>>2]=f[w+4>>2];f[o+8>>2]=f[w+8>>2];f[o+12>>2]=f[w+12>>2];f[o+16>>2]=f[w+16>>2];f[o+20>>2]=f[w+20>>2];f[o+24>>2]=f[w+24>>2];f[o+28>>2]=f[w+28>>2];f[n>>2]=f[x>>2];f[n+4>>2]=f[x+4>>2];f[n+8>>2]=f[x+8>>2];f[n+12>>2]=f[x+12>>2];f[n+16>>2]=f[x+16>>2];f[n+20>>2]=f[x+20>>2];f[n+24>>2]=f[x+24>>2];f[n+28>>2]=f[x+28>>2];f[m>>2]=f[y>>2];f[m+4>>2]=f[y+4>>2];Mga(s,O,o,n,C?0-j|0:j,g,h,m);m=f[v>>2]|0;if(m|0){v=f[E>>2]|0;if((v|0)!=(m|0))f[E>>2]=v+(~(((v+-20-m|0)>>>0)/20|0)*20|0);YDc(m)}}m=f[t>>2]|0;if(m|0){t=f[i>>2]|0;if((t|0)!=(m|0))f[i>>2]=t+(~(((t+-56-m|0)>>>0)/56|0)*56|0);YDc(m)}m=r+36|0;t=f[m>>2]|0;if(t|0?(i=t+12|0,t=f[i>>2]|0,f[i>>2]=t+-1,(t|0)==1):0)_S(r);f[m>>2]=0;m=r+16|0;t=r+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[t>>2]|0)>0){m=f[r+40>>2]|0;i=0;do{f[m+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[t>>2]|0))}t=f[r+44>>2]|0;if((t|0)!=(r+48|0))g0(t);t=q+36|0;r=f[t>>2]|0;if(r|0?(i=r+12|0,r=f[i>>2]|0,f[i>>2]=r+-1,(r|0)==1):0)_S(q);f[t>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){B=f[q+40>>2]|0;t=0;do{f[B+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[a>>2]|0))}a=f[z>>2]|0;if((a|0)==(q+48|0)){u=l;return}g0(a);u=l;return}function Jga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/56|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+56|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/56|0;g=i+b|0;if(g>>>0>76695844)mCc(a);l=(d-h|0)/56|0;h=l<<1;d=l>>>0<38347922?(h>>>0<g>>>0?g:h):76695844;do if(d)if(d>>>0>76695844){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{m=VDc(d*56|0)|0;break}else m=0;while(0);h=m+(i*56|0)|0;i=m+(d*56|0)|0;d=b;b=h;m=h;do{j=b;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+56|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(((b|0)/-56|0)*56|0)|0;if((b|0)>0)dJc(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;YDc(d);return}function Kga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)mCc(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=k+(d*20|0)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(((b|0)/-20|0)*20|0)|0;if((b|0)>0)dJc(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;YDc(d);return}function Lga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+64|0;i=h;if((d|0)<=-1){u=h;return}j=i+16|0;k=i+4|0;l=i+8|0;m=i+12|0;n=i+36|0;o=i+40|0;p=i+44|0;q=i+48|0;r=d;do{a$(i,a,r);d=f[j>>2]|0;s=f[k>>2]|0;if(!d)t=0;else{if((s|0)<3)v=Y(f[m>>2]|0,f[l>>2]|0)|0;else{w=f[o>>2]|0;x=0;y=1;while(1){z=Y(f[w+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(s|0)){v=z;break}else y=z}}t=(s|0)==0|(v|0)==0?0:d}if((s|0)<3)A=Y(f[m>>2]|0,f[l>>2]|0)|0;else{y=f[o>>2]|0;x=0;w=1;while(1){z=Y(f[y+(x<<2)>>2]|0,w)|0;x=x+1|0;if((x|0)==(s|0)){A=z;break}else w=z}}s7(20492,56,8,t,A,(f[e>>2]|0)+(r*56|0)|0,(f[g>>2]|0)+(r*20|0)|0)|0;w=c+(r<<4)|0;s=f[w>>2]|0;x=f[c+(r<<4)+4>>2]|0;y=f[c+(r<<4)+8>>2]|0;d=f[c+(r<<4)+12>>2]|0;z=f[e>>2]|0;f[z+(r*56|0)+12>>2]=(s|0)>-1&(s|0)<(b|0)?z+(s*56|0)|0:0;s=f[e>>2]|0;f[s+(r*56|0)+8>>2]=(x|0)>-1&(x|0)<(b|0)?s+(x*56|0)|0:0;x=(y|0)>-1;s=f[e>>2]|0;f[s+(r*56|0)+20>>2]=x&(y|0)<(b|0)?s+(y*56|0)|0:0;s=f[e>>2]|0;f[s+(r*56|0)+16>>2]=(d|0)>-1&(d|0)<(b|0)?s+(d*56|0)|0:0;if(x)Lga(a,b,c,y,e,g);y=f[n>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)_S(i);f[n>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){y=f[o>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[k>>2]|0))}x=f[p>>2]|0;if((x|0)!=(q|0))g0(x);r=f[w>>2]|0}while((r|0)>-1);u=h;return}function Mga(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;l=u;u=u+384|0;m=l+368|0;n=l+356|0;o=l+344|0;q=l+208|0;r=l+176|0;s=l+288|0;t=l+144|0;v=l+112|0;w=l+256|0;x=l+80|0;y=l+96|0;z=l+64|0;A=l+48|0;B=l+32|0;C=l+248|0;D=l+16|0;E=l;F=l+240|0;f[n>>2]=0;G=n+4|0;f[G>>2]=0;f[n+8>>2]=0;f[o>>2]=0;H=o+4|0;f[H>>2]=0;f[o+8>>2]=0;I=+p[d+8>>3];J=+p[d+16>>3];K=+p[d+24>>3];p[q>>3]=+p[d>>3];p[q+8>>3]=I;p[q+16>>3]=J;p[q+24>>3]=K;K=+p[e+8>>3];J=+p[e+16>>3];I=+p[e+24>>3];p[r>>3]=+p[e>>3];p[r+8>>3]=K;p[r+16>>3]=J;p[r+24>>3]=I;O4(s,a,0,1,0,0);a=f[k>>2]|0;e=f[k+4>>2]|0;if((j|0)==16)L=(f[s>>2]&7|0)==0?16:8;else L=j;do if(c|0){if((i|0)>=32768){f[w>>2]=0;f[w+4>>2]=0;M=tT(w,26)|0;N=256491;O=M+26|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));cga(-215,w,256955,2584)}c1(q,t,f[s>>2]&4095,0);c1(r,v,f[s>>2]&4095,0);j=(g|0)>-2147483646?g:-2147483646;k=(j|0)==2147483647?2147483646:j;j=c+12|0;if((k|0)<0){d=f[j>>2]|0;f[j>>2]=0;P=1-k|0;Q=d}else{P=k;Q=0}P7(m,c,P);k=w+12|0;d=(i|0)<0;R=w+20|0;S=x+8|0;T=o+8|0;U=(i|0)>-1;V=D+8|0;W=E+8|0;X=x+8|0;Y=F+4|0;Z=y+8|0;_=z+8|0;$=x+8|0;aa=A+8|0;ba=B+8|0;ca=C+4|0;a:while(1){da=Q7(m)|0;if(!da){ea=61;break}fa=f[da+24>>2]|0;ga=f[da>>2]|0;ha=ga&4095;ia=(ga&32768|0)==0?t:v;r7(da,w,0);ga=f[k>>2]|0;if(!ga){ea=11;break}if(d?(ja=f[H>>2]|0,ka=f[o>>2]|0,la=ja,!((ja|0)==(ka|0)|(la|0)==(ka|0))):0)f[H>>2]=la+(~((la+-16-ka|0)>>>4)<<4);ka=f[da>>2]|0;do if((ka&12288|0)==4096){if(!((ka&16384|0)==0?1:(f[da+28>>2]|0)!=1)){la=da+56|0;ja=f[la>>2]|0;ma=da+60|0;na=f[ma>>2]|0;oa=b[ga>>0]|0;pa=ja+a|0;qa=na+e|0;b:do if((fa|0)>0){if(U){ra=oa;sa=0;ta=pa;ua=ja;va=na;wa=qa;xa=ga;while(1){ya=b[xa>>0]|0;za=xa+1|0;f[k>>2]=za;if(za>>>0>=(f[R>>2]|0)>>>0)z7(w,1);za=ya<<24>>24;if(ya<<24>>24==ra<<24>>24){Aa=ra;Ba=ta;Ca=wa}else{Da=y;f[Da>>2]=ta;f[Da+4>>2]=((ta|0)<0)<<31>>31;Da=Z;f[Da>>2]=wa;f[Da+4>>2]=((wa|0)<0)<<31>>31;Da=z;f[Da>>2]=ua;f[Da+4>>2]=((ua|0)<0)<<31>>31;Da=_;f[Da>>2]=va;f[Da+4>>2]=((va|0)<0)<<31>>31;kga(s,y,z,ia,i,L,2,0);Aa=ya;Ba=ua;Ca=va}ya=sa+1|0;if((ya|0)>=(fa|0)){Ea=Ba;Fa=Ca;break b}ra=Aa;sa=ya;ta=Ba;ua=(f[55004+(za<<3)>>2]|0)+ua|0;va=(f[55004+(za<<3)+4>>2]|0)+va|0;wa=Ca;xa=f[k>>2]|0}}else{Ga=oa;Ha=0;Ia=pa;Ja=ja;Ka=na;La=qa;Ma=ga}while(1){xa=b[Ma>>0]|0;wa=Ma+1|0;f[k>>2]=wa;if(wa>>>0>=(f[R>>2]|0)>>>0)z7(w,1);wa=xa<<24>>24;if(xa<<24>>24==Ga<<24>>24){Na=Ga;Oa=Ia;Pa=La}else{va=((Ja|0)<0)<<31>>31;ua=((Ka|0)<0)<<31>>31;ta=x;f[ta>>2]=Ja;f[ta+4>>2]=va;ta=$;f[ta>>2]=Ka;f[ta+4>>2]=ua;ta=f[H>>2]|0;if((ta|0)==(f[T>>2]|0))rga(o,x);else{sa=ta;f[sa>>2]=Ja;f[sa+4>>2]=va;va=ta+8|0;f[va>>2]=Ka;f[va+4>>2]=ua;f[H>>2]=ta+16}Na=xa;Oa=Ja;Pa=Ka}xa=Ha+1|0;if((xa|0)>=(fa|0)){Ea=Oa;Fa=Pa;break b}Ga=Na;Ha=xa;Ia=Oa;Ja=(f[55004+(wa<<3)>>2]|0)+Ja|0;Ka=(f[55004+(wa<<3)+4>>2]|0)+Ka|0;La=Pa;Ma=f[k>>2]|0}}else{Ea=pa;Fa=qa}while(0);if(U){qa=A;f[qa>>2]=Ea;f[qa+4>>2]=((Ea|0)<0)<<31>>31;qa=aa;f[qa>>2]=Fa;f[qa+4>>2]=((Fa|0)<0)<<31>>31;qa=(f[la>>2]|0)+a|0;pa=(f[ma>>2]|0)+e|0;na=B;f[na>>2]=qa;f[na+4>>2]=((qa|0)<0)<<31>>31;qa=ba;f[qa>>2]=pa;f[qa+4>>2]=((pa|0)<0)<<31>>31;kga(s,A,B,ia,i,L,2,0);break}else{pa=f[o>>2]|0;qa=(f[H>>2]|0)-pa>>4;f[C>>2]=a;f[ca>>2]=e;uga(s,pa,qa,n,t,L,0,C);break}}if((ka&4094|0)==12){if((ha|0)!=12){ea=39;break a}qa=fa-(ka>>>14&1^1)|0;pa=ga;na=pa;ja=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=pa+4|0;pa=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=ga+8|0;f[k>>2]=na;if(na>>>0>=(f[R>>2]|0)>>>0)z7(w,1);na=ja+a|0;ja=pa+e|0;if(d){pa=((na|0)<0)<<31>>31;oa=((ja|0)<0)<<31>>31;wa=x;f[wa>>2]=na;f[wa+4>>2]=pa;wa=S;f[wa>>2]=ja;f[wa+4>>2]=oa;wa=f[H>>2]|0;if((wa|0)==(f[T>>2]|0))rga(o,x);else{xa=wa;f[xa>>2]=na;f[xa+4>>2]=pa;pa=wa+8|0;f[pa>>2]=ja;f[pa+4>>2]=oa;f[H>>2]=wa+16}}c:do if((qa|0)>0){if(U){wa=0;oa=na;pa=ja;while(1){xa=f[k>>2]|0;ta=xa;ua=ta;va=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;ua=ta+4|0;ta=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;ua=xa+8|0;f[k>>2]=ua;if(ua>>>0>=(f[R>>2]|0)>>>0)z7(w,1);ua=oa;oa=va+a|0;va=D;f[va>>2]=ua;f[va+4>>2]=((ua|0)<0)<<31>>31;ua=V;f[ua>>2]=pa;f[ua+4>>2]=((pa|0)<0)<<31>>31;pa=ta+e|0;ta=E;f[ta>>2]=oa;f[ta+4>>2]=((oa|0)<0)<<31>>31;ta=W;f[ta>>2]=pa;f[ta+4>>2]=((pa|0)<0)<<31>>31;kga(s,D,E,ia,i,L,2,0);wa=wa+1|0;if((wa|0)>=(qa|0))break c}}else Qa=0;do{wa=f[k>>2]|0;pa=wa;oa=pa;ta=h[oa>>0]|h[oa+1>>0]<<8|h[oa+2>>0]<<16|h[oa+3>>0]<<24;oa=pa+4|0;pa=h[oa>>0]|h[oa+1>>0]<<8|h[oa+2>>0]<<16|h[oa+3>>0]<<24;oa=wa+8|0;f[k>>2]=oa;if(oa>>>0>=(f[R>>2]|0)>>>0)z7(w,1);oa=ta+a|0;ta=pa+e|0;pa=((oa|0)<0)<<31>>31;wa=((ta|0)<0)<<31>>31;ua=x;f[ua>>2]=oa;f[ua+4>>2]=pa;ua=X;f[ua>>2]=ta;f[ua+4>>2]=wa;ua=f[H>>2]|0;if((ua|0)==(f[T>>2]|0))rga(o,x);else{va=ua;f[va>>2]=oa;f[va+4>>2]=pa;pa=ua+8|0;f[pa>>2]=ta;f[pa+4>>2]=wa;f[H>>2]=ua+16}Qa=Qa+1|0}while((Qa|0)<(qa|0))}while(0);if(d){qa=f[o>>2]|0;ja=(f[H>>2]|0)-qa>>4;f[F>>2]=0;f[Y>>2]=0;uga(s,qa,ja,n,t,L,0,F)}}}while(0)}if((ea|0)==11){f[x>>2]=0;f[x+4>>2]=0;M=tT(x,18)|0;N=256970;O=M+18|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));cga(-215,x,256955,2608)}else if((ea|0)==39){f[x>>2]=0;f[x+4>>2]=0;M=tT(x,21)|0;N=256989;O=M+21|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));cga(-215,x,256955,2651)}else if((ea|0)==61){if(d)vga(s,n,t);if(!Q)break;f[j>>2]=Q;break}}while(0);Q=s+36|0;t=f[Q>>2]|0;if(t|0?(ea=t+12|0,t=f[ea>>2]|0,f[ea>>2]=t+-1,(t|0)==1):0)_S(s);f[Q>>2]=0;Q=s+16|0;t=s+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[t>>2]|0)>0){Q=f[s+40>>2]|0;ea=0;do{f[Q+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))g0(t);t=f[o>>2]|0;if(t|0){o=f[H>>2]|0;if((o|0)!=(t|0))f[H>>2]=o+(~((o+-16-t|0)>>>4)<<4);YDc(t)}t=f[n>>2]|0;if(!t){u=l;return}n=f[G>>2]|0;if((n|0)!=(t|0))f[G>>2]=n+(~((n+-32-t|0)>>>5)<<5);YDc(t);u=l;return}function Nga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,257011,d);return}function Oga(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;g=u;u=u+112|0;h=g+56|0;i=g;if(r$(a)|0){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,13)|0;k=371005;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));Nga(-215,h,257078,181)}a:do if((e|0)<1)switch(d|0){case 120:case 119:case 122:case 121:case 112:case 111:case 104:case 105:case 102:case 103:case 94:case 95:case 96:case 97:case 9:case 29:case 19:case 28:case 18:case 5:case 2:case 0:{m=4;break a;break}case 116:case 115:case 118:case 117:case 108:case 107:case 100:case 101:case 98:case 99:case 90:case 91:case 92:case 93:case 8:case 25:case 15:case 24:case 14:case 4:case 3:case 1:{m=3;break a;break}default:{m=0;break a}}else m=e;while(0);do switch(d|0){case 5:case 4:case 3:case 1:case 2:case 0:{$Aa(a,c,m,d>>>0>1);u=g;return}case 27:case 17:case 23:case 13:case 26:case 16:case 22:case 12:{e=d+-12|0;b:do if(e>>>0<15){n=(11178>>>(e&32767)&1)!=0;switch(d|0){case 20:case 21:case 19:case 18:case 15:case 14:case 17:case 16:case 13:case 12:{o=n;p=6;break b;break}case 24:case 25:case 26:case 23:case 22:{q=n;r=11;break b;break}default:{}}o=n;p=0}else{q=1;r=11}while(0);if((r|0)==11){o=q;p=5}cBa(a,c,o,p);u=g;return}case 29:case 19:case 25:case 15:case 28:case 18:case 24:case 14:{e=d+-14|0;c:do if(e>>>0<15){n=(10986>>>(e&32767)&1)!=0;switch(d|0){case 24:case 27:case 26:case 23:case 22:case 25:case 28:{s=n;r=16;break c;break}case 20:case 21:case 19:case 18:case 15:case 14:case 17:case 16:{t=n;v=6;break c;break}default:{}}t=n;v=0}else{s=1;r=16}while(0);if((r|0)==16){t=s;v=5}fBa(a,c,m,t,v);u=g;return}case 11:case 7:case 10:case 6:{switch(d|0){case 10:case 6:{w=0;break}default:w=1}iBa(a,c,w);u=g;return}case 31:case 21:{switch(d|0){case 22:case 30:case 31:case 29:case 28:case 25:case 24:case 27:case 26:case 23:{x=5;break}case 21:{x=6;break}default:x=0}oBa(a,c,x);u=g;return}case 9:case 8:{lBa(a,c,m);u=g;return}case 30:case 20:{switch(d|0){case 22:case 30:case 29:case 28:case 25:case 24:case 27:case 26:case 23:{y=5;break}case 20:case 21:{y=6;break}default:y=0}rBa(a,c,y);u=g;return}case 83:case 82:case 37:case 36:{switch(d|0){case 40:case 80:case 78:case 58:case 38:case 82:case 36:case 56:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 68:case 66:case 52:{z=0;break}default:z=1}RCa(a,c,z,(d|1|0)==37);u=g;return}case 85:case 84:case 39:case 38:{switch(d|0){case 40:case 80:case 78:case 84:case 38:case 82:case 58:case 56:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 68:case 66:case 52:{A=0;break}default:A=1}SCa(a,c,m,A,(d|1|0)==39);u=g;return}case 33:case 32:{jAa(a,c,(d|0)!=32);u=g;return}case 35:case 34:{mAa(a,c,m,(d|0)!=34);u=g;return}case 67:case 41:case 66:case 40:{e=d+-40|0;if(e>>>0<27)B=(65711086>>>(e&134217727)&1|0)!=0;else B=1;Mwa(a,c,B,(d+-66|0)>>>0<8);u=g;return}case 69:case 53:case 68:case 52:{e=d+-52|0;if(e>>>0<17)C=(48810>>>(e&131071)&1|0)!=0;else C=1;Jwa(a,c,C,(d+-66|0)>>>0<8);u=g;return}case 71:case 55:case 70:case 54:{e=d+-54|0;if(e>>>0<17)D=(44970>>>(e&131071)&1|0)!=0;else D=1;Qwa(a,c,m,D,(d+-66|0)>>>0<8);u=g;return}case 73:case 61:case 72:case 60:{e=d+-60|0;if(e>>>0<13)E=(2750>>>(e&8191)&1)!=0;else E=1;Nwa(a,c,m,E,(d+-66|0)>>>0<8);u=g;return}case 75:case 45:case 74:case 44:{e=d+-44|0;if(e>>>0<31){n=(717138622>>>(e&2147483647)&1|0)!=0;if(e>>>0<16){F=n;G=((-3901&65535)>>>(e&65535)&1)!=0}else{F=n;G=0}}else{F=1;G=0}fAa(a,c,F,G);u=g;return}case 77:case 51:case 76:case 50:{n=d+-50|0;if(n>>>0<27){e=(44759722>>>(n&134217727)&1|0)!=0;n=d+-44|0;if(n>>>0<16){H=e;I=((-3901&65535)>>>(n&65535)&1)!=0}else{H=e;I=0}}else{H=1;I=0}gAa(a,c,H,I);u=g;return}case 79:case 57:case 78:case 56:{e=d+-56|0;if(e>>>0<23){n=(2796522>>>(e&8388607)&1|0)!=0;e=d+-44|0;if(e>>>0<16){J=n;K=((-3901&65535)>>>(e&65535)&1)!=0}else{J=n;K=0}}else{J=1;K=0}hAa(a,c,m,J,K);u=g;return}case 81:case 59:case 80:case 58:{n=d+-58|0;if(n>>>0<23){e=(2796282>>>(n&8388607)&1|0)!=0;n=d+-44|0;if(n>>>0<16){L=e;M=((-3901&65535)>>>(n&65535)&1)!=0}else{L=e;M=0}}else{L=1;M=0}iAa(a,c,m,L,M);u=g;return}case 142:case 141:case 140:case 139:case 138:case 137:case 136:case 135:case 65:case 64:case 63:case 62:case 49:case 48:case 47:case 46:case 89:case 88:case 87:case 86:{f[h>>2]=1124007936;e=h+4|0;n=h+8|0;N=h+40|0;j=e;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));f[N>>2]=n;O=h+48|0;P=h+44|0;f[P>>2]=O;f[O>>2]=0;f[h+52>>2]=0;Q=a+4|0;if((f[Q>>2]|0)!=(f[c+4>>2]|0)){do if((d$(a)|0)==65536){R=f[Q>>2]|0;f[i>>2]=f[R>>2];S=i+4|0;T=R+4|0;f[S>>2]=f[T>>2];U=i+8|0;f[U>>2]=f[R+8>>2];f[i+12>>2]=f[R+12>>2];f[i+16>>2]=f[R+16>>2];f[i+20>>2]=f[R+20>>2];f[i+24>>2]=f[R+24>>2];f[i+28>>2]=f[R+28>>2];f[i+32>>2]=f[R+32>>2];V=i+36|0;W=f[R+36>>2]|0;f[V>>2]=W;f[i+40>>2]=U;U=i+48|0;X=i+44|0;f[X>>2]=U;f[U>>2]=0;f[i+52>>2]=0;if(W|0){U=W+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[T>>2]|0)<3){T=f[R+44>>2]|0;U=f[X>>2]|0;f[U>>2]=f[T>>2];f[U+4>>2]=f[T+4>>2];Y=V;break}else{f[S>>2]=0;ZS(i,R);Y=V;break}}else{a$(i,a,-1);Y=i+36|0}while(0);Q=f[Y>>2]|0;if(Q|0){V=Q+12|0;f[V>>2]=(f[V>>2]|0)+1}V=h+36|0;Q=f[V>>2]|0;if(Q|0?(R=Q+12|0,Q=f[R>>2]|0,f[R>>2]=Q+-1,(Q|0)==1):0)_S(h);f[V>>2]=0;Q=h+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[e>>2]|0)>0){R=f[N>>2]|0;S=0;do{f[R+(S<<2)>>2]=0;S=S+1|0;Z=f[e>>2]|0}while((S|0)<(Z|0));f[h>>2]=f[i>>2];if((Z|0)<3)r=86;else r=88}else{f[h>>2]=f[i>>2];r=86}if((r|0)==86){S=f[i+4>>2]|0;if((S|0)<3){f[e>>2]=S;f[n>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];S=f[i+44>>2]|0;R=f[P>>2]|0;f[R>>2]=f[S>>2];f[R+4>>2]=f[S+4>>2]}else r=88}if((r|0)==88)ZS(h,i);S=i+16|0;f[Q>>2]=f[S>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];R=f[Y>>2]|0;f[V>>2]=R;if(R|0?(T=R+12|0,R=f[T>>2]|0,f[T>>2]=R+-1,(R|0)==1):0)_S(i);f[Y>>2]=0;R=i+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[R>>2]|0)>0){S=f[i+40>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[i+44>>2]|0;if((R|0)!=(i+48|0))g0(R)}else{R=i+8|0;f[R>>2]=0;f[R+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;t$(a,i)}f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=h;oka(i,c,d,m);R=h+36|0;T=f[R>>2]|0;if(T|0?(S=T+12|0,T=f[S>>2]|0,f[S>>2]=T+-1,(T|0)==1):0)_S(h);f[R>>2]=0;R=h+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[e>>2]|0)>0){R=f[N>>2]|0;T=0;do{f[R+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[e>>2]|0))}e=f[P>>2]|0;if((e|0)!=(O|0))g0(e);u=g;return}case 94:case 95:case 96:case 97:case 90:case 91:case 92:case 93:{e=d+-91|0;T=e>>>0>6|(e&1|0)!=0;switch(d|0){case 94:case 95:case 90:case 91:{_=0;break}case 96:case 97:case 92:case 93:{_=1;break}default:_=-1}cDa(a,c,m,T,_);u=g;return}case 104:case 105:case 100:case 101:case 102:case 103:case 98:case 99:{T=d+-99|0;e=T>>>0>6|(T&1|0)!=0;switch(d|0){case 102:case 103:case 98:case 99:{$=1;break}case 104:case 105:case 100:case 101:{$=0;break}default:$=-1}$Ca(a,c,m,e,$);u=g;return}case 106:{YCa(a,c);u=g;return}case 130:case 129:case 128:case 127:case 134:case 133:case 132:case 131:{e=d+-128|0;T=e>>>0>6|(e&1|0)!=0;switch(d|0){case 134:case 133:case 132:case 131:{aa=2;break}case 130:case 129:case 128:case 127:{aa=1;break}default:aa=-1}VCa(a,c,T,aa);u=g;return}case 122:case 121:case 120:case 119:case 118:case 117:case 116:case 115:case 112:case 111:case 108:case 107:{T=d+-107|0;if(T>>>0<6)ba=51>>>(T&63)&1;else ba=0;T=d+-108|0;d:do if(T>>>0<15){e=(10990>>>(T&32767)&1)!=0;switch(d|0){case 119:case 116:case 115:case 112:case 111:case 108:case 120:{ca=e;r=124;break d;break}case 122:case 121:case 118:case 117:{da=1;ea=e;break d;break}default:{}}da=-1;ea=e}else{ca=1;r=124}while(0);if((r|0)==124){da=0;ea=ca}TCa(a,c,m,ea,da,ba);u=g;return}case 124:case 123:{UCa(a,c,(d|0)==123&1);u=g;return}case 125:{uBa(a,c);u=g;return}case 126:{xBa(a,c);u=g;return}default:{f[h>>2]=0;f[h+4>>2]=0;j=tT(h,41)|0;k=369734;l=j+41|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));Nga(-206,h,257078,351)}}while(0)}function Pga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+208|0;g=e+144|0;h=e+88|0;i=e+32|0;j=e+16|0;k=e;O4(g,a,0,1,0,0);O4(h,c,0,1,0,0);f[i>>2]=f[h>>2];c=i+4|0;a=h+4|0;l=f[a>>2]|0;f[c>>2]=l;m=i+8|0;f[m>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];n=i+16|0;o=h+16|0;f[n>>2]=f[o>>2];f[i+20>>2]=f[h+20>>2];f[i+24>>2]=f[h+24>>2];f[i+28>>2]=f[h+28>>2];f[i+32>>2]=f[h+32>>2];p=i+36|0;q=h+36|0;r=f[q>>2]|0;f[p>>2]=r;s=i+40|0;f[s>>2]=m;m=i+48|0;t=i+44|0;f[t>>2]=m;f[m>>2]=0;f[i+52>>2]=0;if(!r)v=l;else{l=r+12|0;f[l>>2]=(f[l>>2]|0)+1;v=f[a>>2]|0}if((v|0)<3){v=f[h+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[v>>2];f[l+4>>2]=f[v+4>>2]}else{f[c>>2]=0;ZS(i,h)}v=f[i>>2]|0;if((v^f[g>>2])&7|0){f[j>>2]=0;f[j+4>>2]=0;w=tT(j,26)|0;x=257087;y=w+26|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));Nga(-215,j,257114,361)}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=g;l=k+8|0;f[l>>2]=0;f[l+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;Oga(j,k,d,(v>>>3&511)+1|0);if((f[n>>2]|0)!=(f[o>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;w=tT(j,21)|0;x=257125;y=w+21|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));Nga(-215,j,257114,364)}j=f[p>>2]|0;if(j|0?(x=j+12|0,j=f[x>>2]|0,f[x>>2]=j+-1,(j|0)==1):0)_S(i);f[p>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[c>>2]|0)>0){n=f[s>>2]|0;s=0;do{f[n+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[c>>2]|0))}c=f[t>>2]|0;if((c|0)!=(m|0))g0(c);c=f[q>>2]|0;if(c|0?(m=c+12|0,c=f[m>>2]|0,f[m>>2]=c+-1,(c|0)==1):0)_S(h);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[a>>2]|0)>0){o=f[h+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))g0(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(q=h+12|0,h=f[q>>2]|0,f[q>>2]=h+-1,(h|0)==1):0)_S(g);f[a>>2]=0;a=g+16|0;h=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[g+40>>2]|0;q=0;do{f[a+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}g0(h);u=e;return}function Qga(){s5(533884,257147,954,1730,539,278,955);be(1715,533884,x|0)|0;return}function Rga(a){a=a|0;var b=0;if((a|0)!=0?(f[a>>2]&-65536|0)==1111818240:0)b=(f[a+4>>2]|0)!=0;else b=0;return b&1|0}function Sga(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;Xga(-27,d,257644,2324)}e=f[a>>2]|0;if(!e){u=c;return}if((f[e>>2]&-65536|0)==1111818240?(g=e+4|0,f[g>>2]|0):0){f[a>>2]=0;a=f[g>>2]|0;if((a|0)!=0?(f[a>>2]&-65536|0)==1111752704:0)J0(g);else{M0(a);f[g>>2]=0}g=e+264|0;a=f[g>>2]|0;if(a|0){i0(a);f[g>>2]=0}i0(e);u=c;return}f[d>>2]=0;f[d+4>>2]=0;c=tT(d,24)|0;e=257272;g=c+24|0;do{b[c>>0]=b[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(g|0));Xga(-5,d,257644,2331)}function Tga(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+272|0;e=d+136|0;g=d+8|0;h=d;i=h0(544)|0;j=j1(a,c,284842)|0;a:do if(!j)k=0;else switch(f[j>>2]&7){case 1:{k=f[j+8>>2]|0;break a;break}case 2:{k=nrc(+p[j+8>>3])|0;break a;break}default:{k=2147483647;break a}}while(0);j=j1(a,c,257535)|0;b:do if(!j)l=0;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break b;break}case 2:{l=nrc(+p[j+8>>3])|0;break b;break}default:{l=2147483647;break b}}while(0);j=j1(a,c,257546)|0;c:do if(!j)m=0;else switch(f[j>>2]&7){case 1:{m=f[j+8>>2]|0;break c;break}case 2:{m=nrc(+p[j+8>>3])|0;break c;break}default:{m=2147483647;break c}}while(0);j=(l|0)!=0;l=(m|0)!=0;f[i>>2]=k|(j?1024:0)|(l?2048:0)|1111818240;if(k){k=k1(a,j1(a,c,257562)|0,0)|0;f[i+4>>2]=k;if(!k){f[e>>2]=0;n=e+4|0;f[n>>2]=0;o=tT(e,22)|0;q=o;r=257596;s=q+22|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));Xga(-2,e,257584,3450)}if((f[k>>2]&-65536|0)!=1111752704){f[e>>2]=0;n=e+4|0;f[n>>2]=0;o=tT(e,22)|0;q=o;r=257596;s=q+22|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));Xga(-2,e,257584,3450)}}else{o=k1(a,j1(a,c,257558)|0,0)|0;f[e>>2]=o;if(!o){f[h>>2]=0;t=h+4|0;f[t>>2]=0;v=tT(h,16)|0;q=v;r=257567;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));Xga(-2,h,257584,3429)}if((f[o>>2]&-65536|0)!=1111687168){f[h>>2]=0;t=h+4|0;f[t>>2]=0;v=tT(h,16)|0;q=v;r=257567;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));Xga(-2,h,257584,3429)}n=o+16|0;if(!(f[n>>2]|0)){f[h>>2]=0;t=h+4|0;f[t>>2]=0;v=tT(h,16)|0;q=v;r=257567;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));Xga(-2,h,257584,3429)}v=o+4|0;t=f[v>>2]|0;if((t|0)>0){k=0;do{f[g+(k<<2)>>2]=f[o+20+(k<<3)>>2];k=k+1|0;m=f[v>>2]|0}while((k|0)<(m|0));w=m}else w=t;t=i+268|0;A0(t,w,g,f[o>>2]|0,f[o+16>>2]|0)|0;f[i+4>>2]=t;f[i+276>>2]=f[o+8>>2];t=f[o>>2]&-65536;d:do if((t|0)<1111687168){switch(t|0){case 1111621632:break;default:break d}if((((f[o+24>>2]|0)>0?(f[o+20>>2]|0)>0:0)?f[n>>2]|0:0)?(w=f[o+8>>2]|0,w|0):0)f[w>>2]=(f[w>>2]|0)+1}else{switch(t|0){case 1111687168:break;default:break d}if(f[n>>2]|0?(w=f[o+8>>2]|0,w|0):0)f[w>>2]=(f[w>>2]|0)+1}while(0);y0(e)}if(!l){u=d;return i|0}l=Q0(f[i+4>>2]|0,e)|0;o=(l|0)>0;if(o){n=0;t=0;while(1){w=n+1+(f[e+(t<<2)>>2]|0)|0;t=t+1|0;if((t|0)==(l|0)){x=w;break}else n=w}}else x=0;n=j1(a,c,454316)|0;if(!n){f[h>>2]=0;f[h+4>>2]=0;q=tT(h,24)|0;r=257619;s=q+24|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));Xga(-2,h,257584,3467)}x1(a,n,g);if(!j){j=h0(x+l<<2)|0;x=i+264|0;f[x>>2]=j;if(o?(n=j+(l<<2)|0,f[j>>2]=n,y1(a,g,(f[e>>2]|0)+1|0,n,502807),(l|0)!=1):0){j=n;n=e;h=1;do{j=j+((f[n>>2]|0)+1<<2)|0;f[(f[x>>2]|0)+(h<<2)>>2]=j;n=e+(h<<2)|0;y1(a,g,(f[n>>2]|0)+1|0,j,502807);h=h+1|0}while((h|0)!=(l|0))}}else{if(o){o=i+8|0;h=0;do{y1(a,g,2,o+(h<<3)|0,502807);h=h+1|0}while((h|0)!=(l|0))}f[i+264>>2]=0}u=d;return i|0}function Uga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+176|0;e=d+160|0;g=d+8|0;h=d+152|0;i=d+144|0;j=d+136|0;k=d;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];q1(a,b,6,257147,e);b=f[c>>2]|0;h=b&1024;l=(h|0)==0;m=b&2048;n=(m|0)==0;s1(a,284842,b&1);s1(a,257535,h>>>10);s1(a,257546,m>>>11);m=c+4|0;h=f[m>>2]|0;if((h|0)!=0?(f[h>>2]&-65536|0)==1111752704:0){f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];D1(a,257562,h,e)}else{f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];D1(a,257558,c+268|0,e)}if(n){r1(a);u=d;return}n=Q0(f[m>>2]|0,g)|0;f[k>>2]=0;f[k+4>>2]=0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];q1(a,454316,13,0,e);e=(n|0)>0;if(l){if(e){l=c+264|0;k=0;do{w1(a,f[(f[l>>2]|0)+(k<<2)>>2]|0,(f[g+(k<<2)>>2]|0)+1|0,502807);k=k+1|0}while((k|0)!=(n|0))}}else if(e){e=c+8|0;c=0;do{w1(a,e+(c<<3)|0,2,502807);c=c+1|0}while((c|0)!=(n|0))}r1(a);r1(a);u=d;return}function Vga(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=0;Wga(a,c);u=b;return f[c>>2]|0}function Wga(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+256|0;e=d+128|0;g=d;if(!c){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,34)|0;i=257159;j=h+34|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));Xga(-27,e,257194,2714)}k=f[c>>2]|0;do if((a|0?(f[a>>2]&-65536|0)==1111818240:0)?(l=a+4|0,m=f[l>>2]|0,m|0):0){n=(k|0)!=0;if(n){if((f[k>>2]&-65536|0)!=1111818240)break;if(!(f[k+4>>2]|0))break}o=(f[m>>2]&-65536|0)==1111752704;p=Q0(m,e)|0;do if(n){m=f[k+4>>2]|0;if(!m){if(o){q=20;break}}else if(o^(f[m>>2]&-65536|0)==1111752704){q=20;break}if((p|0)!=(Q0(m,g)|0)){q=20;break}a:do if((p|0)>0){m=0;while(1){if((f[e+(m<<2)>>2]|0)!=(f[g+(m<<2)>>2]|0)){r=m;break a}s=m+1|0;if((s|0)<(p|0))m=s;else{r=s;break}}}else r=0;while(0);if((r|0)==(p|0))t=k;else q=20}else q=20;while(0);if((q|0)==20){Sga(c);n=Yga(p,e,o&1,0,0)|0;f[c>>2]=n;t=n}n=f[a>>2]|0;if(!(n&2048)){v=f[l>>2]|0;w=t+4|0;x=f[w>>2]|0;r_(v,x,0);u=d;return}if(!(n&1024))y=f[a+264>>2]|0;else{if((p|0)>0){m=0;do{f[g+(m<<2)>>2]=a+8+(m<<3);m=m+1|0}while((m|0)!=(p|0))}y=g}Zga(t,y,n>>>10&1);v=f[l>>2]|0;w=t+4|0;x=f[w>>2]|0;r_(v,x,0);u=d;return}while(0);f[e>>2]=0;f[e+4>>2]=0;h=tT(e,27)|0;i=257205;j=h+27|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));Xga(-5,e,257194,2719)}function Xga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,257464,d);return}function Yga(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(a>>>0>32){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,36)|0;k=257370;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));Xga(-19,i,257407,2265)}if(!c){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,20)|0;k=257420;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));Xga(-9,i,257407,2268)}m=h0(544)|0;f[m>>2]=((g|0)==0?1111818240:1111819264)|d&1;f[m+264>>2]=0;n=m+4|0;f[n>>2]=0;switch(d|0){case 0:{d=m+268|0;o=A0(d,a,c,5,0)|0;f[n>>2]=o;w0(d);break}case 1:{d=I0(a,c,5)|0;f[n>>2]=d;break}default:{f[i>>2]=0;f[i+4>>2]=0;j=tT(i,22)|0;k=257441;l=j+22|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));Xga(-5,i,257407,2284)}}if(!e){u=h;return m|0}Zga(m,e,g);u=h;return m|0}function Zga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0.0;e=u;u=u+144|0;g=e+8|0;h=e;if(!c){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,19)|0;j=257233;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));Xga(-27,h,257253,2784)}if(!a){f[h>>2]=0;l=h+4|0;f[l>>2]=0;m=tT(h,24)|0;i=m;j=257272;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));Xga(-5,h,257253,2787)}if((f[a>>2]&-65536|0)!=1111818240){f[h>>2]=0;l=h+4|0;f[l>>2]=0;m=tT(h,24)|0;i=m;j=257272;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));Xga(-5,h,257253,2787)}o=f[a+4>>2]|0;if(!o){f[h>>2]=0;l=h+4|0;f[l>>2]=0;m=tT(h,24)|0;i=m;j=257272;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));Xga(-5,h,257253,2787)}m=Q0(o,g)|0;o=(m|0)>0;if(o){l=0;p=0;while(1){q=l+1+(f[g+(p<<2)>>2]|0)|0;p=p+1|0;if((p|0)==(m|0)){r=q;break}else l=q}}else r=0;if(d|0){a:do if(o){d=0;while(1){l=f[c+(d<<2)>>2]|0;if(!l)break;f[a+8+(d<<3)>>2]=f[l>>2];f[a+8+(d<<3)+4>>2]=f[l+4>>2];d=d+1|0;if((d|0)>=(m|0))break a}f[h>>2]=0;f[h+4>>2]=0;i=tT(h,32)|0;j=257297;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));Xga(-27,h,257253,2798)}while(0);s=f[a>>2]|3072;f[a>>2]=s;u=e;return}d=a+264|0;l=f[d>>2]|0;if(!l){p=h0(r+m<<2)|0;f[d>>2]=p;t=p}else t=l;b:do if(o){l=t+(m<<2)|0;p=0;c:while(1){r=f[c+(p<<2)>>2]|0;if(!r){v=21;break}q=f[g+(p<<2)>>2]|0;if((q|0)>=0){w=-3402823466385288598117041.0e14;x=0;while(1){y=w;w=+n[r+(x<<2)>>2];if(w<=y){v=23;break c}n[l+(x<<2)>>2]=w;if((x|0)>=(q|0))break;else x=x+1|0}}f[(f[d>>2]|0)+(p<<2)>>2]=l;p=p+1|0;if((p|0)>=(m|0))break b;else l=l+(q+1<<2)|0}if((v|0)==21){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,32)|0;j=257297;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));Xga(-27,h,257253,2822)}else if((v|0)==23){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,39)|0;j=257330;k=i+39|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));Xga(-211,h,257253,2828)}}while(0);s=f[a>>2]&-3073|2048;f[a>>2]=s;u=e;return}function _ga(a,c,d,e,g,i,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0;q=u;u=u+1552|0;r=q;s=q+528|0;t=q+400|0;v=q+288|0;w=q+344|0;x=q+232|0;y=q+176|0;z=q+160|0;A=q+148|0;B=q+136|0;C=q+128|0;do if((d$(e)|0)==65536){D=f[e+4>>2]|0;f[v>>2]=f[D>>2];E=v+4|0;F=D+4|0;f[E>>2]=f[F>>2];G=v+8|0;f[G>>2]=f[D+8>>2];f[v+12>>2]=f[D+12>>2];f[v+16>>2]=f[D+16>>2];f[v+20>>2]=f[D+20>>2];f[v+24>>2]=f[D+24>>2];f[v+28>>2]=f[D+28>>2];f[v+32>>2]=f[D+32>>2];H=f[D+36>>2]|0;f[v+36>>2]=H;f[v+40>>2]=G;G=v+48|0;I=v+44|0;f[I>>2]=G;f[G>>2]=0;f[v+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[D+44>>2]|0;G=f[I>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;ZS(v,D);break}}else a$(v,e,-1);while(0);if(!((i|0)>0&(k|0)!=0)){f[r>>2]=0;f[r+4>>2]=0;J=tT(r,20)|0;K=257658;L=J+20|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Xga(-215,r,257679,877)}do if((d$(g)|0)==65536){e=f[g+4>>2]|0;f[w>>2]=f[e>>2];D=w+4|0;E=e+4|0;f[D>>2]=f[E>>2];F=w+8|0;f[F>>2]=f[e+8>>2];f[w+12>>2]=f[e+12>>2];G=w+16|0;f[G>>2]=f[e+16>>2];f[w+20>>2]=f[e+20>>2];f[w+24>>2]=f[e+24>>2];f[w+28>>2]=f[e+28>>2];f[w+32>>2]=f[e+32>>2];I=w+36|0;H=f[e+36>>2]|0;f[I>>2]=H;f[w+40>>2]=F;F=w+48|0;M=w+44|0;f[M>>2]=F;f[F>>2]=0;f[w+52>>2]=0;if(H|0){F=H+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[e+44>>2]|0;F=f[M>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];N=M;O=I;P=G;break}else{f[D>>2]=0;ZS(w,e);N=M;O=I;P=G;break}}else{a$(w,g,-1);N=w+44|0;O=w+36|0;P=w+16|0}while(0);G=f[P>>2]|0;I=f[O>>2]|0;if(I|0?(M=I+12|0,I=f[M>>2]|0,f[M>>2]=I+-1,(I|0)==1):0)_S(w);f[O>>2]=0;O=w+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[O>>2]|0)>0){P=f[w+40>>2]|0;I=0;do{f[P+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[O>>2]|0))}O=f[N>>2]|0;if((O|0)!=(w+48|0))g0(O);w$(g,i,k,5,-1,0,0);do if((d$(g)|0)==65536){k=f[g+4>>2]|0;f[x>>2]=f[k>>2];O=x+4|0;w=k+4|0;f[O>>2]=f[w>>2];N=x+8|0;f[N>>2]=f[k+8>>2];I=x+12|0;f[I>>2]=f[k+12>>2];P=x+16|0;f[P>>2]=f[k+16>>2];M=x+20|0;f[M>>2]=f[k+20>>2];e=x+24|0;f[e>>2]=f[k+24>>2];D=x+28|0;f[D>>2]=f[k+28>>2];E=x+32|0;f[E>>2]=f[k+32>>2];F=x+36|0;H=f[k+36>>2]|0;f[F>>2]=H;f[x+40>>2]=N;Q=x+48|0;R=x+44|0;f[R>>2]=Q;f[Q>>2]=0;f[x+52>>2]=0;if(H|0){Q=H+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[w>>2]|0)<3){w=f[k+44>>2]|0;Q=f[R>>2]|0;f[Q>>2]=f[w>>2];f[Q+4>>2]=f[w+4>>2];S=P;T=x;U=O;V=N;W=I;X=M;Z=e;_=D;$=E;aa=F;ba=F;break}else{f[O>>2]=0;ZS(x,k);S=P;T=x;U=O;V=N;W=I;X=M;Z=e;_=D;$=E;aa=F;ba=F;break}}else{a$(x,g,-1);F=x+36|0;S=x+16|0;T=x;U=x+4|0;V=x+8|0;W=x+12|0;X=x+20|0;Z=x+24|0;_=x+28|0;$=x+32|0;aa=F;ba=F}while(0);g=f[S>>2]|0;f[y>>2]=f[T>>2];T=y+4|0;F=f[U>>2]|0;f[T>>2]=F;E=y+8|0;f[E>>2]=f[V>>2];f[y+12>>2]=f[W>>2];W=y+16|0;f[W>>2]=g;f[y+20>>2]=f[X>>2];f[y+24>>2]=f[Z>>2];f[y+28>>2]=f[_>>2];f[y+32>>2]=f[$>>2];$=y+36|0;_=f[ba>>2]|0;f[$>>2]=_;ba=y+40|0;f[ba>>2]=E;E=y+48|0;Z=y+44|0;f[Z>>2]=E;f[E>>2]=0;f[y+52>>2]=0;if(!_)ca=F;else{F=_+12|0;f[F>>2]=(f[F>>2]|0)+1;ca=f[U>>2]|0}if((ca|0)<3){ca=f[x+44>>2]|0;F=f[Z>>2]|0;f[F>>2]=f[ca>>2];f[F+4>>2]=f[ca+4>>2]}else{f[T>>2]=0;ZS(y,x)}f[y>>2]=f[y>>2]&-4096|4;if((G|0)==(g|0)&o){o=r+8|0;f[o>>2]=0;f[o+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=y;LZ(x,r,4,1.0,0.0)}else{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;k_(x,r)|0}f[z>>2]=0;o=z+4|0;f[o>>2]=0;f[z+8>>2]=0;f[A>>2]=0;g=A+4|0;f[g>>2]=0;f[A+8>>2]=0;f[B>>2]=0;G=B+4|0;f[G>>2]=0;f[B+8>>2]=0;f[C>>2]=0;ca=C+4|0;f[ca>>2]=0;F=v+16|0;if(f[F>>2]|0){_=f[v+4>>2]|0;if((_|0)<3)da=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{X=f[v+40>>2]|0;V=0;D=1;while(1){e=Y(f[X+(V<<2)>>2]|0,D)|0;V=V+1|0;if((V|0)==(_|0)){da=e;break}else D=e}}if(!((_|0)==0|(da|0)==0)?f[v>>2]&4095|0:0){f[r>>2]=0;f[r+4>>2]=0;J=tT(r,38)|0;K=257688;L=J+38|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Xga(-215,r,257679,904)}}da=x+40|0;$ga(a,c,d,v,i,f[da>>2]|0,l,m,z,A,C,B);d=m?f[B>>2]|0:0;switch(f[a>>2]&7){case 0:{a=f[C>>2]|0;c=f[ca>>2]|0;_=f[z>>2]|0;D=f[A>>2]|0;V=f[W>>2]|0;X=f[_+(i<<2)>>2]|0;e=f[D+((i<<1|1)<<2)>>2]|0;f[r>>2]=0;M=r+4|0;f[M>>2]=0;f[r+8>>2]=0;f[s>>2]=1123876864;f[s+4>>2]=0;aha(y,s,i,l,d,m,0,r);I=f[r>>2]|0;switch(i|0){case 1:{N=f[D>>2]|0;O=f[D+4>>2]|0;XIc(s|0,0,1024)|0;a:do if(!c)ea=0;else{P=f[_>>2]|0;k=(N|0)==1;w=N<<1;Q=(a|0)<4;R=a+-4|0;if((a|0)<=0){H=a&-4;fa=Y(N,H)|0;ga=X;ha=P;ia=c;while(1){ia=ia+-1|0;do if(!ga){do if(k){if(Q){ja=0;ka=ha;break}else{la=0;ma=ha}while(1){na=h[ha+(la|1)>>0]|0;oa=s+(h[ma>>0]<<2)|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=s+(na<<2)|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=h[ha+(la|3)>>0]|0;na=s+(h[ha+(la|2)>>0]<<2)|0;f[na>>2]=(f[na>>2]|0)+1;na=s+(oa<<2)|0;f[na>>2]=(f[na>>2]|0)+1;na=la+4|0;if((na|0)>(R|0))break;else{la=na;ma=ha+na|0}}ja=H;ka=ha+H|0}else{if(Q){ja=0;ka=ha;break}else{pa=ha;qa=0}while(1){na=h[pa+N>>0]|0;oa=s+(h[pa>>0]<<2)|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=s+(na<<2)|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=pa+w|0;na=h[oa+N>>0]|0;ra=s+(h[oa>>0]<<2)|0;f[ra>>2]=(f[ra>>2]|0)+1;ra=s+(na<<2)|0;f[ra>>2]=(f[ra>>2]|0)+1;qa=qa+4|0;if((qa|0)>(R|0))break;else pa=oa+w|0}ja=H;ka=ha+fa|0}while(0);if((a|0)<=(ja|0)){sa=ka;break}oa=Y(N,a-ja|0)|0;ra=ka;na=ja;while(1){ta=s+(h[ra>>0]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;na=na+1|0;if((na|0)==(a|0))break;else ra=ra+N|0}sa=ka+oa|0}else sa=ha;while(0);if(!ia){ea=0;break a}else{ga=ga+e|0;ha=sa+O|0}}}ha=Y(a,N)|0;ga=a&-4;ia=Y(N,ga)|0;fa=X;H=P;ra=c;while(1){ra=ra+-1|0;do if(!fa){do if(k){if(Q){ua=0;va=H;break}else{wa=0;xa=H}while(1){na=h[H+(wa|1)>>0]|0;ta=s+(h[xa>>0]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=s+(na<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=h[H+(wa|3)>>0]|0;na=s+(h[H+(wa|2)>>0]<<2)|0;f[na>>2]=(f[na>>2]|0)+1;na=s+(ta<<2)|0;f[na>>2]=(f[na>>2]|0)+1;na=wa+4|0;if((na|0)>(R|0))break;else{wa=na;xa=H+na|0}}ua=ga;va=H+ga|0}else{if(Q){ua=0;va=H;break}else{ya=H;za=0}while(1){na=h[ya+N>>0]|0;ta=s+(h[ya>>0]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=s+(na<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=ya+w|0;na=h[ta+N>>0]|0;Aa=s+(h[ta>>0]<<2)|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=s+(na<<2)|0;f[Aa>>2]=(f[Aa>>2]|0)+1;za=za+4|0;if((za|0)>(R|0))break;else ya=ta+w|0}ua=ga;va=H+ia|0}while(0);if((a|0)<=(ua|0)){Ba=va;break}oa=Y(N,a-ua|0)|0;ta=va;Aa=ua;while(1){na=s+(h[ta>>0]<<2)|0;f[na>>2]=(f[na>>2]|0)+1;Aa=Aa+1|0;if((Aa|0)==(a|0))break;else ta=ta+N|0}Ba=va+oa|0}else{ta=H;Aa=0;while(1){if(b[fa+Aa>>0]|0){na=s+(h[ta>>0]<<2)|0;f[na>>2]=(f[na>>2]|0)+1}Aa=Aa+1|0;if((Aa|0)==(a|0))break;else ta=ta+N|0}Ba=H+ha|0}while(0);if(!ra){ea=0;break}else{fa=fa+e|0;H=Ba+O|0}}}while(0);do{O=f[I+(ea<<2)>>2]|0;Ba=V+O|0;if(O>>>0<1073741824)f[Ba>>2]=(f[Ba>>2]|0)+(f[s+(ea<<2)>>2]|0);ea=ea+1|0}while((ea|0)!=256);Ca=134;break}case 2:{ea=f[D>>2]|0;Ba=f[D+4>>2]|0;O=f[D+8>>2]|0;N=f[D+12>>2]|0;if((c|0)!=0&(a|0)>0){va=a+-1|0;ua=Y(ea,va)|0;ya=Y(O,va)|0;va=f[_>>2]|0;za=f[_+4>>2]|0;xa=X;wa=c;while(1){wa=wa+-1|0;if(!xa){sa=va;ka=za;ja=0;while(1){pa=(f[I+((h[ka>>0]|256)<<2)>>2]|0)+(f[I+(h[sa>>0]<<2)>>2]|0)|0;if(pa>>>0<1073741824){qa=V+pa|0;f[qa>>2]=(f[qa>>2]|0)+1}ja=ja+1|0;if((ja|0)==(a|0))break;else{sa=sa+ea|0;ka=ka+O|0}}}else{ka=va;sa=za;ja=0;while(1){do if(b[xa+ja>>0]|0){qa=(f[I+((h[sa>>0]|256)<<2)>>2]|0)+(f[I+(h[ka>>0]<<2)>>2]|0)|0;if(qa>>>0>=1073741824)break;pa=V+qa|0;f[pa>>2]=(f[pa>>2]|0)+1}while(0);ja=ja+1|0;if((ja|0)==(a|0))break;else{ka=ka+ea|0;sa=sa+O|0}}}if(!wa){Ca=133;break}else{va=va+ua+ea+Ba|0;za=za+ya+O+N|0;xa=xa+e|0}}}else Ca=133;break}case 3:{xa=f[D>>2]|0;N=f[D+4>>2]|0;O=f[D+8>>2]|0;ya=f[D+12>>2]|0;za=f[D+16>>2]|0;Ba=f[D+20>>2]|0;if((c|0)!=0&(a|0)>0){ea=a+-1|0;ua=Y(za,ea)|0;va=Y(O,ea)|0;wa=Y(xa,ea)|0;ea=f[_+8>>2]|0;sa=f[_+4>>2]|0;ka=f[_>>2]|0;ja=X;pa=c;while(1){pa=pa+-1|0;if(!ja){qa=ea;ma=sa;la=ka;H=0;while(1){fa=(f[I+((h[ma>>0]|256)<<2)>>2]|0)+(f[I+(h[la>>0]<<2)>>2]|0)+(f[I+((h[qa>>0]|512)<<2)>>2]|0)|0;if(fa>>>0<1073741824){ra=V+fa|0;f[ra>>2]=(f[ra>>2]|0)+1}H=H+1|0;if((H|0)==(a|0))break;else{qa=qa+za|0;ma=ma+O|0;la=la+xa|0}}}else{la=ea;ma=sa;qa=ka;H=0;while(1){do if(b[ja+H>>0]|0){ra=(f[I+((h[ma>>0]|256)<<2)>>2]|0)+(f[I+(h[qa>>0]<<2)>>2]|0)+(f[I+((h[la>>0]|512)<<2)>>2]|0)|0;if(ra>>>0>=1073741824)break;fa=V+ra|0;f[fa>>2]=(f[fa>>2]|0)+1}while(0);H=H+1|0;if((H|0)==(a|0))break;else{la=la+za|0;ma=ma+O|0;qa=qa+xa|0}}}if(!pa){Ca=133;break}else{ea=ea+ua+za+Ba|0;sa=sa+va+O+ya|0;ka=ka+wa+xa+N|0;ja=ja+e|0}}}else Ca=133;break}default:if(!c)Ca=133;else{ja=(a|0)>0;N=X;X=c;while(1){X=X+-1|0;if(!N)if(ja){c=0;do{xa=0;wa=V;while(1){ka=_+(xa<<2)|0;ya=f[ka>>2]|0;O=f[I+((h[ya>>0]|xa<<8)<<2)>>2]|0;if(O>>>0>1073741823){Da=xa;Ea=wa;break}va=wa+O|0;f[ka>>2]=ya+(f[D+(xa<<1<<2)>>2]|0);ya=xa+1|0;if((ya|0)<(i|0)){xa=ya;wa=va}else{Da=ya;Ea=va;break}}do if((Da|0)==(i|0))f[Ea>>2]=(f[Ea>>2]|0)+1;else{if((Da|0)<(i|0))Fa=Da;else break;do{wa=_+(Fa<<2)|0;f[wa>>2]=(f[wa>>2]|0)+(f[D+(Fa<<1<<2)>>2]|0);Fa=Fa+1|0}while((Fa|0)!=(i|0))}while(0);c=c+1|0}while((c|0)!=(a|0));Ga=0}else Ga=0;else if(ja){c=0;while(1){b:do if(!(b[N+c>>0]|0)){Ha=0;Ia=V}else{wa=0;xa=V;while(1){va=_+(wa<<2)|0;ya=f[va>>2]|0;ka=f[I+((h[ya>>0]|wa<<8)<<2)>>2]|0;if(ka>>>0>1073741823){Ha=wa;Ia=xa;break b}O=xa+ka|0;f[va>>2]=ya+(f[D+(wa<<1<<2)>>2]|0);ya=wa+1|0;if((ya|0)<(i|0)){wa=ya;xa=O}else{Ha=ya;Ia=O;break}}}while(0);do if((Ha|0)==(i|0))f[Ia>>2]=(f[Ia>>2]|0)+1;else{if((Ha|0)<(i|0))Ja=Ha;else break;do{xa=_+(Ja<<2)|0;f[xa>>2]=(f[xa>>2]|0)+(f[D+(Ja<<1<<2)>>2]|0);Ja=Ja+1|0}while((Ja|0)!=(i|0))}while(0);c=c+1|0;if((c|0)==(a|0)){Ga=0;break}}}else Ga=0;do{c=_+(Ga<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[D+((Ga<<1|1)<<2)>>2]|0);Ga=Ga+1|0}while((Ga|0)!=(i|0));if(!X){Ca=133;break}else N=N+e|0}}}if((Ca|0)==133?I|0:0)Ca=134;if((Ca|0)==134){Ca=f[M>>2]|0;if((Ca|0)!=(I|0))f[M>>2]=Ca+(~((Ca+-4-I|0)>>>2)<<2);YDc(I)}break}case 2:{I=f[C>>2]|0;Ca=f[ca>>2]|0;M=f[z>>2]|0;e=f[A>>2]|0;N=f[W>>2]|0;X=f[M+(i<<2)>>2]|0;Ga=f[e+((i<<1|1)<<2)>>2]|0;D=i<<2;_=f[Z>>2]|0;dJc(s|0,f[ba>>2]|0,D|0)|0;dJc(t|0,_|0,D|0)|0;c:do if(!m){if(!l){f[r>>2]=0;f[r+4>>2]=0;J=tT(r,55)|0;K=257727;L=J+55|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Xga(-5,r,257783,431)}dJc(r|0,l|0,D|0)|0;if(Ca|0){_=(I|0)>0;a=X;Ja=Ca;while(1){Ja=Ja+-1|0;if(_)if(!a){Ha=0;do{Ia=N;V=0;while(1){ja=M+(V<<2)|0;Fa=f[ja>>2]|0;Ka=+(j[Fa>>1]|0);Da=f[r+(V<<2)>>2]|0;Ea=f[s+(V<<2)>>2]|0;c=-1;while(1){xa=c+1|0;if(!(Ka>=+n[Da+(xa<<2)>>2])){La=c;break}if((xa|0)<(Ea|0))c=xa;else{La=xa;break}}if(La>>>0>=Ea>>>0){Ma=Ia;Na=V;break}f[ja>>2]=Fa+(f[e+(V<<1<<2)>>2]<<1);c=Ia+(Y(f[t+(V<<2)>>2]|0,La)|0)|0;Da=V+1|0;if((Da|0)<(i|0)){Ia=c;V=Da}else{Ma=c;Na=Da;break}}do if((Na|0)==(i|0))f[Ma>>2]=(f[Ma>>2]|0)+1;else{if((Na|0)<(i|0))Oa=Na;else break;do{V=M+(Oa<<2)|0;f[V>>2]=(f[V>>2]|0)+(f[e+(Oa<<1<<2)>>2]<<1);Oa=Oa+1|0}while((Oa|0)!=(i|0))}while(0);Ha=Ha+1|0}while((Ha|0)!=(I|0));Pa=0}else{Ha=0;while(1){d:do if(!(b[a+Ha>>0]|0)){Qa=N;Ra=0}else{Fa=N;ja=0;while(1){Ea=M+(ja<<2)|0;V=f[Ea>>2]|0;Ka=+(j[V>>1]|0);Ia=f[r+(ja<<2)>>2]|0;Da=f[s+(ja<<2)>>2]|0;c=-1;while(1){xa=c+1|0;if(!(Ka>=+n[Ia+(xa<<2)>>2])){Sa=c;break}if((xa|0)<(Da|0))c=xa;else{Sa=xa;break}}if(Sa>>>0>=Da>>>0){Qa=Fa;Ra=ja;break d}f[Ea>>2]=V+(f[e+(ja<<1<<2)>>2]<<1);c=Fa+(Y(f[t+(ja<<2)>>2]|0,Sa)|0)|0;Ia=ja+1|0;if((Ia|0)<(i|0)){Fa=c;ja=Ia}else{Qa=c;Ra=Ia;break}}}while(0);do if((Ra|0)==(i|0))f[Qa>>2]=(f[Qa>>2]|0)+1;else{if((Ra|0)<(i|0))Ta=Ra;else break;do{ja=M+(Ta<<2)|0;f[ja>>2]=(f[ja>>2]|0)+(f[e+(Ta<<1<<2)>>2]<<1);Ta=Ta+1|0}while((Ta|0)!=(i|0))}while(0);Ha=Ha+1|0;if((Ha|0)==(I|0)){Pa=0;break}}}else Pa=0;do{Ha=M+(Pa<<2)|0;f[Ha>>2]=(f[Ha>>2]|0)+(f[e+((Pa<<1|1)<<2)>>2]<<1);Pa=Pa+1|0}while((Pa|0)!=(i|0));if(!Ja)break;else a=a+Ga|0}}}else switch(i|0){case 1:{Ka=+p[d>>3];Ua=+p[d+8>>3];a=f[s>>2]|0;Ja=f[e>>2]|0;_=f[e+4>>2]|0;if(!Ca)break c;if((I|0)<=0)break c;Ha=Y(Ja,I+-1|0)|0;ja=X;Fa=f[M>>2]|0;Ia=Ca;while(1){Ia=Ia+-1|0;if(!ja){c=0;xa=Fa;while(1){Va=Ua+Ka*+(j[xa>>1]|0);wa=~~Va;O=wa-(+(wa|0)>Va&1)|0;wa=N+(O<<2)|0;if(O>>>0<a>>>0)f[wa>>2]=(f[wa>>2]|0)+1;c=c+1|0;if((c|0)==(I|0))break;else xa=xa+(Ja<<1)|0}}else{xa=0;c=Fa;while(1){do if(b[ja+xa>>0]|0){Va=Ua+Ka*+(j[c>>1]|0);wa=~~Va;O=wa-(+(wa|0)>Va&1)|0;wa=N+(O<<2)|0;if(O>>>0>=a>>>0)break;f[wa>>2]=(f[wa>>2]|0)+1}while(0);xa=xa+1|0;if((xa|0)==(I|0))break;else c=c+(Ja<<1)|0}}if(!Ia)break;else{ja=ja+Ga|0;Fa=Fa+(Ha<<1)+(Ja<<1)+(_<<1)|0}}break}case 2:{Ka=+p[d>>3];Ua=+p[d+8>>3];Va=+p[d+16>>3];Wa=+p[d+24>>3];_=f[s>>2]|0;Ja=f[s+4>>2]|0;Ha=f[e>>2]|0;Fa=f[e+4>>2]|0;ja=f[e+8>>2]|0;Ia=f[e+12>>2]|0;a=f[t>>2]|0;if(!((Ca|0)!=0&(I|0)>0))break c;c=I+-1|0;xa=Y(Ha,c)|0;wa=Y(ja,c)|0;c=f[M>>2]|0;O=f[M+4>>2]|0;ya=X;va=Ca;while(1){va=va+-1|0;if(!ya){ka=c;sa=O;Ba=0;while(1){Xa=Ua+Ka*+(j[ka>>1]|0);za=~~Xa;ua=za-(+(za|0)>Xa&1)|0;Xa=Wa+Va*+(j[sa>>1]|0);za=~~Xa;ea=za-(+(za|0)>Xa&1)|0;za=N+(Y(ua,a)|0)+(ea<<2)|0;if(ua>>>0<_>>>0&ea>>>0<Ja>>>0)f[za>>2]=(f[za>>2]|0)+1;Ba=Ba+1|0;if((Ba|0)==(I|0))break;else{ka=ka+(Ha<<1)|0;sa=sa+(ja<<1)|0}}}else{sa=c;ka=O;Ba=0;while(1){do if(b[ya+Ba>>0]|0){Xa=Ua+Ka*+(j[sa>>1]|0);za=~~Xa;ea=za-(+(za|0)>Xa&1)|0;Xa=Wa+Va*+(j[ka>>1]|0);za=~~Xa;ua=za-(+(za|0)>Xa&1)|0;za=N+(Y(ea,a)|0)+(ua<<2)|0;if(!(ea>>>0<_>>>0&ua>>>0<Ja>>>0))break;f[za>>2]=(f[za>>2]|0)+1}while(0);Ba=Ba+1|0;if((Ba|0)==(I|0))break;else{sa=sa+(Ha<<1)|0;ka=ka+(ja<<1)|0}}}if(!va)break;else{c=c+(xa<<1)+(Ha<<1)+(Fa<<1)|0;O=O+(wa<<1)+(ja<<1)+(Ia<<1)|0;ya=ya+Ga|0}}break}case 3:{Va=+p[d>>3];Wa=+p[d+8>>3];Ka=+p[d+16>>3];Ua=+p[d+24>>3];Xa=+p[d+32>>3];Ya=+p[d+40>>3];ya=f[s>>2]|0;Ia=f[s+4>>2]|0;ja=f[s+8>>2]|0;wa=f[e>>2]|0;O=f[e+4>>2]|0;Fa=f[e+8>>2]|0;Ha=f[e+12>>2]|0;xa=f[e+16>>2]|0;c=f[e+20>>2]|0;va=f[t>>2]|0;Ja=f[t+4>>2]|0;if(!Ca)break c;_=(I|0)>0;a=Y(I,wa)|0;ka=Y(I,Fa)|0;sa=Y(I,xa)|0;Ba=f[M>>2]|0;za=f[M+4>>2]|0;ua=f[M+8>>2]|0;ea=X;pa=Ca;while(1){pa=pa+-1|0;if(!ea)if(_){qa=za+(ka<<1)|0;ma=Ba;la=za;H=ua;fa=0;while(1){Za=Wa+Va*+(j[ma>>1]|0);ra=~~Za;ha=ra-(+(ra|0)>Za&1)|0;Za=Ua+Ka*+(j[la>>1]|0);ra=~~Za;ia=ra-(+(ra|0)>Za&1)|0;Za=Ya+Xa*+(j[H>>1]|0);ra=~~Za;ga=ra-(+(ra|0)>Za&1)|0;ra=N+(Y(ha,va)|0)+(Y(ia,Ja)|0)+(ga<<2)|0;if(ha>>>0<ya>>>0&ia>>>0<Ia>>>0&ga>>>0<ja>>>0)f[ra>>2]=(f[ra>>2]|0)+1;fa=fa+1|0;if((fa|0)==(I|0))break;else{ma=ma+(wa<<1)|0;la=la+(Fa<<1)|0;H=H+(xa<<1)|0}}_a=Ba+(a<<1)|0;$a=qa;ab=ua+(sa<<1)|0}else{_a=Ba;$a=za;ab=ua}else if(_){H=za+(ka<<1)|0;la=Ba;ma=za;fa=ua;ra=0;while(1){do if(b[ea+ra>>0]|0){Za=Wa+Va*+(j[la>>1]|0);ga=~~Za;ia=ga-(+(ga|0)>Za&1)|0;Za=Ua+Ka*+(j[ma>>1]|0);ga=~~Za;ha=ga-(+(ga|0)>Za&1)|0;Za=Ya+Xa*+(j[fa>>1]|0);ga=~~Za;w=ga-(+(ga|0)>Za&1)|0;ga=N+(Y(ia,va)|0)+(Y(ha,Ja)|0)+(w<<2)|0;if(!(ia>>>0<ya>>>0&ha>>>0<Ia>>>0&w>>>0<ja>>>0))break;f[ga>>2]=(f[ga>>2]|0)+1}while(0);ra=ra+1|0;if((ra|0)==(I|0))break;else{la=la+(wa<<1)|0;ma=ma+(Fa<<1)|0;fa=fa+(xa<<1)|0}}_a=Ba+(a<<1)|0;$a=H;ab=ua+(sa<<1)|0}else{_a=Ba;$a=za;ab=ua}if(!pa)break;else{Ba=_a+(O<<1)|0;za=$a+(Ha<<1)|0;ua=ab+(c<<1)|0;ea=ea+Ga|0}}break}default:{if(!Ca)break c;ea=(I|0)>0;c=X;ua=Ca;while(1){ua=ua+-1|0;if(!c)if(ea){Ha=0;do{za=N;O=0;while(1){Ba=M+(O<<2)|0;pa=f[Ba>>2]|0;sa=O<<1;Xa=+(j[pa>>1]|0)*+p[d+(sa<<3)>>3]+ +p[d+((sa|1)<<3)>>3];a=~~Xa;xa=a-(+(a|0)>Xa&1)|0;if(xa>>>0>=(f[s+(O<<2)>>2]|0)>>>0){bb=za;cb=O;break}f[Ba>>2]=pa+(f[e+(sa<<2)>>2]<<1);sa=za+(Y(f[t+(O<<2)>>2]|0,xa)|0)|0;xa=O+1|0;if((xa|0)<(i|0)){za=sa;O=xa}else{bb=sa;cb=xa;break}}do if((cb|0)==(i|0))f[bb>>2]=(f[bb>>2]|0)+1;else{if((cb|0)<(i|0))db=cb;else break;do{O=M+(db<<2)|0;f[O>>2]=(f[O>>2]|0)+(f[e+(db<<1<<2)>>2]<<1);db=db+1|0}while((db|0)!=(i|0))}while(0);Ha=Ha+1|0}while((Ha|0)!=(I|0));eb=0}else eb=0;else if(ea){Ha=0;while(1){e:do if(!(b[c+Ha>>0]|0)){fb=N;gb=0}else{H=N;O=0;while(1){za=M+(O<<2)|0;xa=f[za>>2]|0;sa=O<<1;Xa=+(j[xa>>1]|0)*+p[d+(sa<<3)>>3]+ +p[d+((sa|1)<<3)>>3];pa=~~Xa;Ba=pa-(+(pa|0)>Xa&1)|0;if(Ba>>>0>=(f[s+(O<<2)>>2]|0)>>>0){fb=H;gb=O;break e}f[za>>2]=xa+(f[e+(sa<<2)>>2]<<1);sa=H+(Y(f[t+(O<<2)>>2]|0,Ba)|0)|0;Ba=O+1|0;if((Ba|0)<(i|0)){H=sa;O=Ba}else{fb=sa;gb=Ba;break}}}while(0);do if((gb|0)==(i|0))f[fb>>2]=(f[fb>>2]|0)+1;else{if((gb|0)<(i|0))hb=gb;else break;do{O=M+(hb<<2)|0;f[O>>2]=(f[O>>2]|0)+(f[e+(hb<<1<<2)>>2]<<1);hb=hb+1|0}while((hb|0)!=(i|0))}while(0);Ha=Ha+1|0;if((Ha|0)==(I|0)){eb=0;break}}}else eb=0;do{Ha=M+(eb<<2)|0;f[Ha>>2]=(f[Ha>>2]|0)+(f[e+((eb<<1|1)<<2)>>2]<<1);eb=eb+1|0}while((eb|0)!=(i|0));if(!ua)break;else c=c+Ga|0}}}while(0);break}case 5:{Ga=f[C>>2]|0;C=f[ca>>2]|0;ca=f[z>>2]|0;eb=f[A>>2]|0;e=f[W>>2]|0;M=f[ca+(i<<2)>>2]|0;I=f[eb+((i<<1|1)<<2)>>2]|0;hb=i<<2;gb=f[Z>>2]|0;dJc(s|0,f[ba>>2]|0,hb|0)|0;dJc(t|0,gb|0,hb|0)|0;f:do if(!m){if(!l){f[r>>2]=0;f[r+4>>2]=0;J=tT(r,55)|0;K=257727;L=J+55|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));Xga(-5,r,257783,431)}dJc(r|0,l|0,hb|0)|0;if(C|0){gb=(Ga|0)>0;fb=M;N=C;while(1){N=N+-1|0;if(gb)if(!fb){db=0;do{cb=e;bb=0;while(1){Ca=ca+(bb<<2)|0;X=f[Ca>>2]|0;Xa=+n[X>>2];ab=f[r+(bb<<2)>>2]|0;$a=f[s+(bb<<2)>>2]|0;_a=-1;while(1){Pa=_a+1|0;if(!(Xa>=+n[ab+(Pa<<2)>>2])){ib=_a;break}if((Pa|0)<($a|0))_a=Pa;else{ib=Pa;break}}if(ib>>>0>=$a>>>0){jb=cb;kb=bb;break}f[Ca>>2]=X+(f[eb+(bb<<1<<2)>>2]<<2);_a=cb+(Y(f[t+(bb<<2)>>2]|0,ib)|0)|0;ab=bb+1|0;if((ab|0)<(i|0)){cb=_a;bb=ab}else{jb=_a;kb=ab;break}}do if((kb|0)==(i|0))f[jb>>2]=(f[jb>>2]|0)+1;else{if((kb|0)<(i|0))lb=kb;else break;do{bb=ca+(lb<<2)|0;f[bb>>2]=(f[bb>>2]|0)+(f[eb+(lb<<1<<2)>>2]<<2);lb=lb+1|0}while((lb|0)!=(i|0))}while(0);db=db+1|0}while((db|0)!=(Ga|0));mb=0}else{db=0;while(1){g:do if(!(b[fb+db>>0]|0)){nb=e;ob=0}else{X=e;Ca=0;while(1){$a=ca+(Ca<<2)|0;bb=f[$a>>2]|0;Xa=+n[bb>>2];cb=f[r+(Ca<<2)>>2]|0;ab=f[s+(Ca<<2)>>2]|0;_a=-1;while(1){Pa=_a+1|0;if(!(Xa>=+n[cb+(Pa<<2)>>2])){pb=_a;break}if((Pa|0)<(ab|0))_a=Pa;else{pb=Pa;break}}if(pb>>>0>=ab>>>0){nb=X;ob=Ca;break g}f[$a>>2]=bb+(f[eb+(Ca<<1<<2)>>2]<<2);_a=X+(Y(f[t+(Ca<<2)>>2]|0,pb)|0)|0;cb=Ca+1|0;if((cb|0)<(i|0)){X=_a;Ca=cb}else{nb=_a;ob=cb;break}}}while(0);do if((ob|0)==(i|0))f[nb>>2]=(f[nb>>2]|0)+1;else{if((ob|0)<(i|0))qb=ob;else break;do{Ca=ca+(qb<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+(f[eb+(qb<<1<<2)>>2]<<2);qb=qb+1|0}while((qb|0)!=(i|0))}while(0);db=db+1|0;if((db|0)==(Ga|0)){mb=0;break}}}else mb=0;do{db=ca+(mb<<2)|0;f[db>>2]=(f[db>>2]|0)+(f[eb+((mb<<1|1)<<2)>>2]<<2);mb=mb+1|0}while((mb|0)!=(i|0));if(!N)break;else fb=fb+I|0}}}else switch(i|0){case 1:{Xa=+p[d>>3];Ya=+p[d+8>>3];fb=f[s>>2]|0;N=f[eb>>2]|0;gb=f[eb+4>>2]|0;if(!C)break f;if((Ga|0)<=0)break f;db=Y(N,Ga+-1|0)|0;Ca=M;X=f[ca>>2]|0;cb=C;while(1){cb=cb+-1|0;if(!Ca){_a=0;V=X;while(1){Ka=Ya+Xa*+n[V>>2];Ea=~~Ka;Da=Ea-(+(Ea|0)>Ka&1)|0;Ea=e+(Da<<2)|0;if(Da>>>0<fb>>>0)f[Ea>>2]=(f[Ea>>2]|0)+1;_a=_a+1|0;if((_a|0)==(Ga|0))break;else V=V+(N<<2)|0}}else{V=0;_a=X;while(1){do if(b[Ca+V>>0]|0){Ka=Ya+Xa*+n[_a>>2];Ea=~~Ka;Da=Ea-(+(Ea|0)>Ka&1)|0;Ea=e+(Da<<2)|0;if(Da>>>0>=fb>>>0)break;f[Ea>>2]=(f[Ea>>2]|0)+1}while(0);V=V+1|0;if((V|0)==(Ga|0))break;else _a=_a+(N<<2)|0}}if(!cb)break;else{Ca=Ca+I|0;X=X+(db<<2)+(N<<2)+(gb<<2)|0}}break}case 2:{Xa=+p[d>>3];Ya=+p[d+8>>3];Ka=+p[d+16>>3];Ua=+p[d+24>>3];gb=f[s>>2]|0;N=f[s+4>>2]|0;db=f[eb>>2]|0;X=f[eb+4>>2]|0;Ca=f[eb+8>>2]|0;cb=f[eb+12>>2]|0;fb=f[t>>2]|0;if(!((C|0)!=0&(Ga|0)>0))break f;_a=Ga+-1|0;V=Y(db,_a)|0;Ea=Y(Ca,_a)|0;_a=f[ca>>2]|0;Da=f[ca+4>>2]|0;Pa=M;Ta=C;while(1){Ta=Ta+-1|0;if(!Pa){Ra=_a;Qa=Da;Sa=0;while(1){Va=Ya+Xa*+n[Ra>>2];Oa=~~Va;Na=Oa-(+(Oa|0)>Va&1)|0;Va=Ua+Ka*+n[Qa>>2];Oa=~~Va;Ma=Oa-(+(Oa|0)>Va&1)|0;Oa=e+(Y(Na,fb)|0)+(Ma<<2)|0;if(Na>>>0<gb>>>0&Ma>>>0<N>>>0)f[Oa>>2]=(f[Oa>>2]|0)+1;Sa=Sa+1|0;if((Sa|0)==(Ga|0))break;else{Ra=Ra+(db<<2)|0;Qa=Qa+(Ca<<2)|0}}}else{Qa=_a;Ra=Da;Sa=0;while(1){do if(b[Pa+Sa>>0]|0){Va=Ya+Xa*+n[Qa>>2];Oa=~~Va;Ma=Oa-(+(Oa|0)>Va&1)|0;Va=Ua+Ka*+n[Ra>>2];Oa=~~Va;Na=Oa-(+(Oa|0)>Va&1)|0;Oa=e+(Y(Ma,fb)|0)+(Na<<2)|0;if(!(Ma>>>0<gb>>>0&Na>>>0<N>>>0))break;f[Oa>>2]=(f[Oa>>2]|0)+1}while(0);Sa=Sa+1|0;if((Sa|0)==(Ga|0))break;else{Qa=Qa+(db<<2)|0;Ra=Ra+(Ca<<2)|0}}}if(!Ta)break;else{_a=_a+(V<<2)+(db<<2)+(X<<2)|0;Da=Da+(Ea<<2)+(Ca<<2)+(cb<<2)|0;Pa=Pa+I|0}}break}case 3:{Ka=+p[d>>3];Ua=+p[d+8>>3];Xa=+p[d+16>>3];Ya=+p[d+24>>3];Va=+p[d+32>>3];Wa=+p[d+40>>3];Pa=f[s>>2]|0;cb=f[s+4>>2]|0;Ca=f[s+8>>2]|0;Ea=f[eb>>2]|0;Da=f[eb+4>>2]|0;X=f[eb+8>>2]|0;db=f[eb+12>>2]|0;V=f[eb+16>>2]|0;_a=f[eb+20>>2]|0;Ta=f[t>>2]|0;N=f[t+4>>2]|0;if(!C)break f;gb=(Ga|0)>0;fb=Y(Ga,Ea)|0;Ra=Y(Ga,X)|0;Qa=Y(Ga,V)|0;Sa=f[ca>>2]|0;Oa=f[ca+4>>2]|0;Na=f[ca+8>>2]|0;Ma=M;La=C;while(1){La=La+-1|0;if(!Ma)if(gb){D=Oa+(Ra<<2)|0;c=Sa;ua=Oa;ea=Na;Ha=0;while(1){Za=Ua+Ka*+n[c>>2];O=~~Za;H=O-(+(O|0)>Za&1)|0;Za=Ya+Xa*+n[ua>>2];O=~~Za;Ba=O-(+(O|0)>Za&1)|0;Za=Wa+Va*+n[ea>>2];O=~~Za;sa=O-(+(O|0)>Za&1)|0;O=e+(Y(H,Ta)|0)+(Y(Ba,N)|0)+(sa<<2)|0;if(H>>>0<Pa>>>0&Ba>>>0<cb>>>0&sa>>>0<Ca>>>0)f[O>>2]=(f[O>>2]|0)+1;Ha=Ha+1|0;if((Ha|0)==(Ga|0))break;else{c=c+(Ea<<2)|0;ua=ua+(X<<2)|0;ea=ea+(V<<2)|0}}rb=Sa+(fb<<2)|0;sb=D;tb=Na+(Qa<<2)|0}else{rb=Sa;sb=Oa;tb=Na}else if(gb){ea=Oa+(Ra<<2)|0;ua=Sa;c=Oa;Ha=Na;O=0;while(1){do if(b[Ma+O>>0]|0){Za=Ua+Ka*+n[ua>>2];sa=~~Za;Ba=sa-(+(sa|0)>Za&1)|0;Za=Ya+Xa*+n[c>>2];sa=~~Za;H=sa-(+(sa|0)>Za&1)|0;Za=Wa+Va*+n[Ha>>2];sa=~~Za;xa=sa-(+(sa|0)>Za&1)|0;sa=e+(Y(Ba,Ta)|0)+(Y(H,N)|0)+(xa<<2)|0;if(!(Ba>>>0<Pa>>>0&H>>>0<cb>>>0&xa>>>0<Ca>>>0))break;f[sa>>2]=(f[sa>>2]|0)+1}while(0);O=O+1|0;if((O|0)==(Ga|0))break;else{ua=ua+(Ea<<2)|0;c=c+(X<<2)|0;Ha=Ha+(V<<2)|0}}rb=Sa+(fb<<2)|0;sb=ea;tb=Na+(Qa<<2)|0}else{rb=Sa;sb=Oa;tb=Na}if(!La)break;else{Sa=rb+(Da<<2)|0;Oa=sb+(db<<2)|0;Na=tb+(_a<<2)|0;Ma=Ma+I|0}}break}default:{if(!C)break f;Ma=(Ga|0)>0;_a=M;Na=C;while(1){Na=Na+-1|0;if(!_a)if(Ma){db=0;do{Oa=e;Da=0;while(1){Sa=ca+(Da<<2)|0;La=f[Sa>>2]|0;Qa=Da<<1;Va=+n[La>>2]*+p[d+(Qa<<3)>>3]+ +p[d+((Qa|1)<<3)>>3];fb=~~Va;V=fb-(+(fb|0)>Va&1)|0;if(V>>>0>=(f[s+(Da<<2)>>2]|0)>>>0){ub=Oa;vb=Da;break}f[Sa>>2]=La+(f[eb+(Qa<<2)>>2]<<2);Qa=Oa+(Y(f[t+(Da<<2)>>2]|0,V)|0)|0;V=Da+1|0;if((V|0)<(i|0)){Oa=Qa;Da=V}else{ub=Qa;vb=V;break}}do if((vb|0)==(i|0))f[ub>>2]=(f[ub>>2]|0)+1;else{if((vb|0)<(i|0))wb=vb;else break;do{Da=ca+(wb<<2)|0;f[Da>>2]=(f[Da>>2]|0)+(f[eb+(wb<<1<<2)>>2]<<2);wb=wb+1|0}while((wb|0)!=(i|0))}while(0);db=db+1|0}while((db|0)!=(Ga|0));xb=0}else xb=0;else if(Ma){db=0;while(1){h:do if(!(b[_a+db>>0]|0)){yb=e;zb=0}else{ea=e;Da=0;while(1){Oa=ca+(Da<<2)|0;V=f[Oa>>2]|0;Qa=Da<<1;Va=+n[V>>2]*+p[d+(Qa<<3)>>3]+ +p[d+((Qa|1)<<3)>>3];La=~~Va;Sa=La-(+(La|0)>Va&1)|0;if(Sa>>>0>=(f[s+(Da<<2)>>2]|0)>>>0){yb=ea;zb=Da;break h}f[Oa>>2]=V+(f[eb+(Qa<<2)>>2]<<2);Qa=ea+(Y(f[t+(Da<<2)>>2]|0,Sa)|0)|0;Sa=Da+1|0;if((Sa|0)<(i|0)){ea=Qa;Da=Sa}else{yb=Qa;zb=Sa;break}}}while(0);do if((zb|0)==(i|0))f[yb>>2]=(f[yb>>2]|0)+1;else{if((zb|0)<(i|0))Ab=zb;else break;do{Da=ca+(Ab<<2)|0;f[Da>>2]=(f[Da>>2]|0)+(f[eb+(Ab<<1<<2)>>2]<<2);Ab=Ab+1|0}while((Ab|0)!=(i|0))}while(0);db=db+1|0;if((db|0)==(Ga|0)){xb=0;break}}}else xb=0;do{db=ca+(xb<<2)|0;f[db>>2]=(f[db>>2]|0)+(f[eb+((xb<<1|1)<<2)>>2]<<2);xb=xb+1|0}while((xb|0)!=(i|0));if(!Na)break;else _a=_a+I|0}}}while(0);break}default:{f[r>>2]=0;f[r+4>>2]=0;Xga(-210,r,257679,918)}}I=r+8|0;f[I>>2]=0;f[I+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=x;LZ(y,r,5,1.0,0.0);r=f[B>>2]|0;if(r|0){B=f[G>>2]|0;if((B|0)!=(r|0))f[G>>2]=B+(~((B+-8-r|0)>>>3)<<3);YDc(r)}r=f[A>>2]|0;if(r|0){A=f[g>>2]|0;if((A|0)!=(r|0))f[g>>2]=A+(~((A+-4-r|0)>>>2)<<2);YDc(r)}r=f[z>>2]|0;if(r|0){z=f[o>>2]|0;if((z|0)!=(r|0))f[o>>2]=z+(~((z+-4-r|0)>>>2)<<2);YDc(r)}r=f[$>>2]|0;if(r|0?(z=r+12|0,r=f[z>>2]|0,f[z>>2]=r+-1,(r|0)==1):0)_S(y);f[$>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[T>>2]|0)>0){W=f[ba>>2]|0;ba=0;do{f[W+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[T>>2]|0))}T=f[Z>>2]|0;if((T|0)!=(E|0))g0(T);T=f[aa>>2]|0;if(T|0?(E=T+12|0,T=f[E>>2]|0,f[E>>2]=T+-1,(T|0)==1):0)_S(x);f[aa>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[U>>2]|0)>0){S=f[da>>2]|0;da=0;do{f[S+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[U>>2]|0))}U=f[x+44>>2]|0;if((U|0)!=(x+48|0))g0(U);U=v+36|0;x=f[U>>2]|0;do if(x|0){da=x+12|0;S=f[da>>2]|0;f[da>>2]=S+-1;if((S|0)!=1)break;_S(v)}while(0);f[U>>2]=0;U=v+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[U>>2]|0)>0){F=f[v+40>>2]|0;x=0;do{f[F+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[U>>2]|0))}U=f[v+44>>2]|0;if((U|0)==(v+48|0)){u=q;return}g0(U);u=q;return}function $ga(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0;q=u;u=u+16|0;r=q;s=(d|0)!=0;if(!(s|(c|0)==(g|0))){f[r>>2]=0;f[r+4>>2]=0;t=tT(r,32)|0;v=257817;w=t+32|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,128)}x=f[a+40>>2]|0;y=f[x>>2]|0;f[m>>2]=f[x+4>>2];x=m+4|0;f[x>>2]=y;y=f[a>>2]|0;z=y&7;A=1212424721>>>(y<<2&28)&15;y=g+1|0;B=k+4|0;C=f[B>>2]|0;D=f[k>>2]|0;E=C-D>>2;F=D;D=C;if(y>>>0<=E>>>0){if(y>>>0<E>>>0?(C=F+(y<<2)|0,(D|0)!=(C|0)):0)f[B>>2]=D+(~((D+-4-C|0)>>>2)<<2)}else bha(k,y-E|0);E=y<<1;y=l+4|0;C=f[y>>2]|0;D=f[l>>2]|0;B=C-D>>2;F=D;D=C;if(E>>>0<=B>>>0){if(E>>>0<B>>>0?(C=F+(E<<2)|0,(D|0)!=(C|0)):0)f[y>>2]=D+(~((D+-4-C|0)>>>2)<<2)}else lN(l,E-B|0);B=(g|0)>0;a:do if(B){E=(c|0)>0;if(!s){C=0;D=1;while(1){y=f[a+(C*56|0)>>2]|0;if(y&4088|0){G=22;break}F=f[a+(C*56|0)+40>>2]|0;if(!(((f[F>>2]|0)==(f[x>>2]|0)?(f[F+4>>2]|0)==(f[m>>2]|0):0)&(y&7|0)==(z|0))){G=26;break}F=D&(y&16384|0)!=0;f[(f[k>>2]|0)+(C<<2)>>2]=f[a+(C*56|0)+16>>2];H=(y>>>3&511)+1|0;y=C<<1;I=f[l>>2]|0;f[I+(y<<2)>>2]=H;J=(((f[a+(C*56|0)+48>>2]|0)>>>0)/(A>>>0)|0)-(Y(H,f[m>>2]|0)|0)|0;f[I+((y|1)<<2)>>2]=J;C=C+1|0;if((C|0)>=(g|0)){K=F;break a}else D=F}if((G|0)==22){f[r>>2]=0;f[r+4>>2]=0;t=tT(r,25)|0;v=257868;w=t+25|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,143)}else if((G|0)==26){f[r>>2]=0;L=r+4|0;f[L>>2]=0;M=tT(r,56)|0;t=M;v=257913;w=t+56|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,155)}}else{N=0;O=1}b:while(1){D=f[d+(N<<2)>>2]|0;if((D|0)<=-1){G=23;break}if(E){P=0;Q=D}else{G=24;break}while(1){R=f[a+(P*56|0)>>2]|0;S=R>>>3&511;if((Q|0)<=(S|0))break;D=P+1|0;if((D|0)<(c|0)){P=D;Q=Q+-1-S|0}else{G=24;break b}}D=f[a+(P*56|0)+40>>2]|0;if(!(((f[D>>2]|0)==(f[x>>2]|0)?(f[D+4>>2]|0)==(f[m>>2]|0):0)&(R&7|0)==(z|0))){G=26;break}D=O&(R&16384|0)!=0;C=(f[a+(P*56|0)+16>>2]|0)+(Y(Q,A)|0)|0;f[(f[k>>2]|0)+(N<<2)>>2]=C;C=S+1|0;F=N<<1;J=f[l>>2]|0;f[J+(F<<2)>>2]=C;y=(((f[a+(P*56|0)+48>>2]|0)>>>0)/(A>>>0)|0)-(Y(C,f[m>>2]|0)|0)|0;f[J+((F|1)<<2)>>2]=y;N=N+1|0;if((N|0)>=(g|0)){K=D;break a}else O=D}if((G|0)==23){f[r>>2]=0;f[r+4>>2]=0;E=tT(r,6)|0;b[E>>0]=b[257894]|0;b[E+1>>0]=b[257895]|0;b[E+2>>0]=b[257896]|0;b[E+3>>0]=b[257897]|0;b[E+4>>0]=b[257898]|0;b[E+5>>0]=b[257899]|0;Xga(-215,r,257850,148)}else if((G|0)==24){f[r>>2]=0;f[r+4>>2]=0;t=tT(r,11)|0;v=257901;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,152)}else if((G|0)==26){f[r>>2]=0;L=r+4|0;f[L>>2]=0;M=tT(r,56)|0;t=M;v=257913;w=t+56|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,155)}}else K=1;while(0);M=f[e+16>>2]|0;L=M;do if(!M){if(K)G=40}else{O=f[e+4>>2]|0;if((O|0)<3)T=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{N=f[e+40>>2]|0;A=0;P=1;while(1){a=Y(f[N+(A<<2)>>2]|0,P)|0;A=A+1|0;if((A|0)==(O|0)){T=a;break}else P=a}}if((O|0)==0|(T|0)==0)if(K){G=40;break}else break;P=f[e+40>>2]|0;if(!((f[P>>2]|0)==(f[x>>2]|0)?(f[P+4>>2]|0)==(f[m>>2]|0):0)){f[r>>2]=0;U=r+4|0;f[U>>2]=0;V=tT(r,45)|0;t=V;v=257970;w=t+45|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,165)}O=f[e>>2]|0;if(!(O&4088)){f[(f[k>>2]|0)+(g<<2)>>2]=L;P=g<<1;A=f[l>>2]|0;f[A+(P<<2)>>2]=1;f[A+((P|1)<<2)>>2]=((f[e+48>>2]|0)>>>0)/((1212424721>>>(f[e>>2]<<2&28)&15)>>>0)|0;if(K&(O&16384|0)!=0){G=40;break}else break}else{f[r>>2]=0;U=r+4|0;f[U>>2]=0;V=tT(r,45)|0;t=V;v=257970;w=t+45|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,165)}}while(0);if((G|0)==40){V=Y(f[m>>2]|0,f[x>>2]|0)|0;f[m>>2]=V;f[x>>2]=1}if(!i){if(z|0){f[r>>2]=0;f[r+4>>2]=0;t=tT(r,14)|0;v=373096;w=t+14|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,180)}z=g<<1;x=o+4|0;V=f[x>>2]|0;m=f[o>>2]|0;U=V-m>>3;K=m;m=V;if(z>>>0<=U>>>0){if(z>>>0<U>>>0?(V=K+(z<<3)|0,(m|0)!=(V|0)):0)f[x>>2]=m+(~((m+-8-V|0)>>>3)<<3)}else cha(o,z-U|0);if(!B){u=q;return}U=f[o>>2]|0;z=0;do{V=z<<1;p[U+(V<<3)>>3]=+(f[h+(z<<2)>>2]|0)*.00390625;p[U+((V|1)<<3)>>3]=0.0;z=z+1|0}while((z|0)!=(g|0));u=q;return}if(!j){if(B)W=0;else{u=q;return}c:while(1){j=f[h+(W<<2)>>2]|0;z=i+(W<<2)|0;U=0;while(1){if(U>>>0>=j>>>0)break;V=f[z>>2]|0;m=U;U=U+1|0;if(!(+n[V+(m<<2)>>2]<+n[V+(U<<2)>>2])){G=69;break c}}W=W+1|0;if((W|0)>=(g|0)){G=70;break}}if((G|0)==69){f[r>>2]=0;f[r+4>>2]=0;t=tT(r,29)|0;v=258057;w=t+29|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,207)}else if((G|0)==70){u=q;return}}W=g<<1;U=o+4|0;z=f[U>>2]|0;j=f[o>>2]|0;V=z-j>>3;m=j;j=z;if(W>>>0<=V>>>0){if(W>>>0<V>>>0?(z=m+(W<<3)|0,(j|0)!=(z|0)):0)f[U>>2]=j+(~((j+-8-z|0)>>>3)<<3)}else cha(o,W-V|0);if(!B){u=q;return}B=f[o>>2]|0;o=0;while(1){V=f[i+(o<<2)>>2]|0;if(!V){G=63;break}X=+n[V>>2];Z=+n[V+4>>2];if(!(X<Z)){G=63;break}_=X;X=+(f[h+(o<<2)>>2]|0)/(Z-_);V=o<<1;p[B+(V<<3)>>3]=X;p[B+((V|1)<<3)>>3]=-(_*X);o=o+1|0;if((o|0)>=(g|0)){G=70;break}}if((G|0)==63){f[r>>2]=0;f[r+4>>2]=0;t=tT(r,40)|0;v=258016;w=t+40|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,r,257850,194)}else if((G|0)==70){u=q;return}}function aha(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=u;u=u+16|0;l=k;m=d<<8;o=j+4|0;q=f[o>>2]|0;r=f[j>>2]|0;s=q-r>>2;t=r;r=q;if(m>>>0<=s>>>0)if(m>>>0<s>>>0?(q=t+(m<<2)|0,(r|0)!=(q|0)):0){f[o>>2]=r+(~((r+-4-q|0)>>>2)<<2);v=t}else v=t;else{A6(j,m-s|0);v=f[j>>2]|0}if(h){if((d|0)<=0){u=k;return}h=f[c+4>>2]|0;j=(h|0)==0;s=f[a+40>>2]|0;m=f[a+44>>2]|0;if(i)w=0;else{t=0;do{q=t<<1;x=+p[g+(q<<3)>>3];y=+p[g+((q|1)<<3)>>3];q=f[s+(t<<2)>>2]|0;r=f[m+(t<<2)>>2]|0;o=t<<8;z=0;do{A=y+x*+(z|0);B=~~A;C=B-(+(B|0)>A&1)|0;B=Y(C,r)|0;f[v+(z+o<<2)>>2]=C>>>0<q>>>0?B:1073741824;z=z+1|0}while((z|0)!=256);t=t+1|0}while((t|0)!=(d|0));u=k;return}do{t=w<<1;x=+p[g+(t<<3)>>3];y=+p[g+((t|1)<<3)>>3];if(j)D=0;else D=f[h+48+(w<<2)>>2]|0;t=w<<8;m=0;do{A=y+x*+(m|0);s=~~A;z=s-(+(s|0)>A&1)|0;f[v+(m+t<<2)>>2]=z>>>0<D>>>0?z:1073741824;m=m+1|0}while((m|0)!=256);w=w+1|0}while((w|0)!=(d|0));u=k;return}if(!e){f[l>>2]=0;f[l+4>>2]=0;w=tT(l,55)|0;D=257727;h=w+55|0;do{b[w>>0]=b[D>>0]|0;w=w+1|0;D=D+1|0}while((w|0)<(h|0));Xga(-5,l,257793,116)}if((d|0)<=0){u=k;return}l=f[c+4>>2]|0;c=(l|0)==0;D=f[a+40>>2]|0;w=f[a+44>>2]|0;if(i)E=0;else{i=0;do{a=f[e+(i<<2)>>2]|0;x=+n[a>>2];h=~~x;j=(+(h|0)<x&1)+h|0;h=f[D+(i<<2)>>2]|0;g=f[w+(i<<2)>>2]|0;m=i<<8;t=1073741824;z=(j|0)<256?j:256;j=-1;s=0;while(1){if((s|0)<(z|0)){q=s;do{f[v+(q+m<<2)>>2]=t;q=q+1|0}while((q|0)!=(z|0));F=z}else F=s;q=j+1|0;if(q>>>0>=h>>>0)break;x=+n[a+(j+2<<2)>>2];o=~~x;r=(+(o|0)<x&1)+o|0;t=Y(q,g)|0;z=(r|0)<256?r:256;j=q;s=F}if((F|0)<256){s=F;do{f[v+(s+m<<2)>>2]=1073741824;s=s+1|0}while((s|0)!=256)}i=i+1|0}while((i|0)!=(d|0));u=k;return}do{i=f[e+(E<<2)>>2]|0;x=+n[i>>2];F=~~x;w=(+(F|0)<x&1)+F|0;if(c)G=0;else G=f[l+48+(E<<2)>>2]|0;F=E<<8;D=1073741824;s=(w|0)<256?w:256;w=-1;m=0;while(1){if((m|0)<(s|0)){j=m;do{f[v+(j+F<<2)>>2]=D;j=j+1|0}while((j|0)!=(s|0));H=s}else H=m;j=w+1|0;if(j>>>0>=G>>>0)break;x=+n[i+(w+2<<2)>>2];z=~~x;g=(+(z|0)<x&1)+z|0;D=j;s=(g|0)<256?g:256;w=j;m=H}if((H|0)<256){m=H;do{f[v+(m+F<<2)>>2]=1073741824;m=m+1|0}while((m|0)!=256)}E=E+1|0}while((E|0)!=(d|0));u=k;return}function bha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function cha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){XIc(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)mCc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;XIc(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;YDc(h);return}function dha(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;j=u;u=u+1648|0;k=j+1520|0;l=j+56|0;m=j;n=(f[g+4>>2]|0)-(f[g>>2]|0)|0;o=n>>2;p=(f[h+4>>2]|0)-(f[h>>2]|0)|0;q=p>>2;r=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;s=o$(a,-1)|0;if(!((n|0)>0&(s|0)>0)){f[k>>2]=0;f[k+4>>2]=0;t=tT(k,23)|0;v=258087;w=t+23|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,k,257679,1200)}if((q|0)!=(n>>>1|0)){if(q|0){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,55)|0;t=y;v=258111;w=t+55|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,k,257679,1201)}if(p$(a,0)|0){f[k>>2]=0;x=k+4|0;f[x>>2]=0;y=tT(k,55)|0;t=y;v=258111;w=t+55|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,k,257679,1201)}}y=(r|0)==0;if(!(y|(r|0)==(o|0))){f[k>>2]=0;f[k+4>>2]=0;t=tT(k,23)|0;v=258167;w=t+23|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Xga(-215,k,257679,1202)}if((p|0)>0?(v=(q|0)/2|0,(p|0)>4):0){p=f[h>>2]|0;h=0;do{f[k+(h<<2)>>2]=p+(h<<1<<2);h=h+1|0}while((h|0)<(v|0))}YQ(l,s);v=m+4|0;h=m+8|0;p=m+12|0;t=m+16|0;w=m+20|0;r=m+24|0;x=m+28|0;n=m+32|0;z=m+36|0;A=m+40|0;B=m+48|0;C=m+44|0;D=0;do{a$(m,a,D);E=f[l>>2]|0;F=E+(D*56|0)|0;if((F|0)!=(m|0)){G=f[z>>2]|0;if(G|0){H=G+12|0;f[H>>2]=(f[H>>2]|0)+1}H=E+(D*56|0)+36|0;G=f[H>>2]|0;if(G|0?(I=G+12|0,G=f[I>>2]|0,f[I>>2]=G+-1,(G|0)==1):0)_S(F);f[H>>2]=0;G=E+(D*56|0)+16|0;I=E+(D*56|0)+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[I>>2]|0)>0){J=f[E+(D*56|0)+40>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0;L=f[I>>2]|0}while((K|0)<(L|0));f[F>>2]=f[m>>2];if((L|0)<3)M=25;else M=27}else{f[F>>2]=f[m>>2];M=25}if((M|0)==25){M=0;K=f[v>>2]|0;if((K|0)<3){f[I>>2]=K;f[E+(D*56|0)+8>>2]=f[h>>2];f[E+(D*56|0)+12>>2]=f[p>>2];K=f[C>>2]|0;J=f[E+(D*56|0)+44>>2]|0;f[J>>2]=f[K>>2];f[J+4>>2]=f[K+4>>2]}else M=27}if((M|0)==27){M=0;ZS(F,m)}f[G>>2]=f[t>>2];f[E+(D*56|0)+20>>2]=f[w>>2];f[E+(D*56|0)+24>>2]=f[r>>2];f[E+(D*56|0)+28>>2]=f[x>>2];f[E+(D*56|0)+32>>2]=f[n>>2];f[H>>2]=f[z>>2]}K=f[z>>2]|0;if(K|0?(J=K+12|0,K=f[J>>2]|0,f[J>>2]=K+-1,(K|0)==1):0)_S(m);f[z>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[v>>2]|0)>0){K=f[A>>2]|0;J=0;do{f[K+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[v>>2]|0))}J=f[C>>2]|0;if((J|0)!=(B|0))g0(J);D=D+1|0}while((D|0)<(s|0));_ga(f[l>>2]|0,s,y?0:f[c>>2]|0,d,e,o,f[g>>2]|0,q|0?k:0,1,i);ZQ(l);u=j;return}function eha(a,c,e,g,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=+l;m=m|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0,Xa=0;o=u;u=u+688|0;q=o+552|0;r=o+296|0;s=o+168|0;t=o+104|0;v=o+88|0;w=o+76|0;x=o+64|0;y=o+56|0;z=o+160|0;A=o;do if((d$(g)|0)==65536){B=f[g+4>>2]|0;f[t>>2]=f[B>>2];C=t+4|0;D=B+4|0;f[C>>2]=f[D>>2];E=t+8|0;f[E>>2]=f[B+8>>2];f[t+12>>2]=f[B+12>>2];f[t+16>>2]=f[B+16>>2];f[t+20>>2]=f[B+20>>2];f[t+24>>2]=f[B+24>>2];f[t+28>>2]=f[B+28>>2];f[t+32>>2]=f[B+32>>2];F=f[B+36>>2]|0;f[t+36>>2]=F;f[t+40>>2]=E;E=t+48|0;G=t+44|0;f[G>>2]=E;f[E>>2]=0;f[t+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[B+44>>2]|0;E=f[G>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];H=C;break}else{f[C>>2]=0;ZS(t,B);H=C;break}}else{a$(t,g,-1);H=t+4|0}while(0);f[v>>2]=0;g=v+4|0;f[g>>2]=0;f[v+8>>2]=0;f[w>>2]=0;C=w+4|0;f[C>>2]=0;f[w+8>>2]=0;f[x>>2]=0;B=x+4|0;f[B>>2]=0;f[x+8>>2]=0;f[y>>2]=0;D=y+4|0;f[D>>2]=0;E=f[H>>2]|0;if((E|0)!=2)if((E|0)>0)I=E;else{f[q>>2]=0;J=q+4|0;f[J>>2]=0;K=tT(q,25)|0;L=K;M=258191;N=L+25|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));Xga(-215,q,258217,1531)}else I=(f[(f[t+40>>2]|0)+4>>2]|0)==1?1:2;G=t+16|0;if(!(f[G>>2]|0)){f[q>>2]=0;J=q+4|0;f[J>>2]=0;K=tT(q,25)|0;L=K;M=258191;N=L+25|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));Xga(-215,q,258217,1531)}if((E|0)<3)O=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{F=f[t+40>>2]|0;P=0;Q=1;while(1){R=Y(f[F+(P<<2)>>2]|0,Q)|0;P=P+1|0;if((P|0)==(E|0)){O=R;break}else Q=R}}if((E|0)==0|(O|0)==0){f[q>>2]=0;J=q+4|0;f[J>>2]=0;K=tT(q,25)|0;L=K;M=258191;N=L+25|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));Xga(-215,q,258217,1531)}K=f[a+40>>2]|0;J=f[K>>2]|0;f[z>>2]=f[K+4>>2];f[z+4>>2]=J;v$(i,z,f[a>>2]&7,-1,0,0);do if((d$(i)|0)==65536){z=f[i+4>>2]|0;f[A>>2]=f[z>>2];J=A+4|0;K=z+4|0;f[J>>2]=f[K>>2];O=A+8|0;f[O>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];f[A+32>>2]=f[z+32>>2];E=f[z+36>>2]|0;f[A+36>>2]=E;f[A+40>>2]=O;O=A+48|0;Q=A+44|0;f[Q>>2]=O;f[O>>2]=0;f[A+52>>2]=0;if(E|0){O=E+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[K>>2]|0)<3){K=f[z+44>>2]|0;O=f[Q>>2]|0;f[O>>2]=f[K>>2];f[O+4>>2]=f[K+4>>2];break}else{f[J>>2]=0;ZS(A,z);break}}else a$(A,i,-1);while(0);i=t+40|0;$ga(a,c,e,A,I,f[i>>2]|0,k,m,v,w,y,x);e=m?f[x>>2]|0:0;switch(f[a>>2]&7){case 0:{a=f[y>>2]|0;c=f[D>>2]|0;S=l;z=f[v>>2]|0;J=f[w>>2]|0;K=f[G>>2]|0;O=f[z+(I<<2)>>2]|0;Q=f[J+((I<<1|1)<<2)>>2]|0;f[q>>2]=0;E=q+4|0;f[E>>2]=0;f[q+8>>2]=0;f[r>>2]=1123876864;f[r+4>>2]=0;aha(t,r,I,k,e,m,0,q);P=f[q>>2]|0;a:do switch(I|0){case 1:{F=f[J>>2]|0;R=f[J+4>>2]|0;XIc(r|0,0,256)|0;T=f[z>>2]|0;U=0;do{V=f[P+(U<<2)>>2]|0;if(V>>>0<1073741824){W=mrc(S*+n[K+V>>2])|0;b[r+U>>0]=W>>>0<256?W:(W|0)>0?255:0}U=U+1|0}while((U|0)!=256);U=c+-1|0;b:do if(c|0){W=F<<1;V=(a|0)<4;X=a+-4|0;if((F|0)==1){if(V){Z=(a|0)>0;_=O;$=T;aa=U;while(1){if(Z){ba=0;ca=$;while(1){b[_+ba>>0]=b[r+(h[ca>>0]|0)>>0]|0;ba=ba+1|0;if((ba|0)==(a|0))break;else ca=ca+1|0}da=$+a|0}else da=$;if(!aa)break b;else{_=_+Q|0;$=da+R|0;aa=aa+-1|0}}}aa=a&-4;$=(aa|0)<(a|0);_=O;Z=T;ca=U;while(1){ba=0;ea=Z;while(1){fa=ba|1;ga=b[r+(h[Z+fa>>0]|0)>>0]|0;b[_+ba>>0]=b[r+(h[ea>>0]|0)>>0]|0;b[_+fa>>0]=ga;ga=ba|2;fa=ba|3;ha=b[r+(h[Z+fa>>0]|0)>>0]|0;b[_+ga>>0]=b[r+(h[Z+ga>>0]|0)>>0]|0;b[_+fa>>0]=ha;ha=ba+4|0;if((ha|0)>(X|0))break;else{ba=ha;ea=Z+ha|0}}if($){ea=aa;ba=Z+aa|0;while(1){b[_+ea>>0]=b[r+(h[ba>>0]|0)>>0]|0;ea=ea+1|0;if((ea|0)==(a|0)){ia=a;break}else ba=ba+1|0}}else ia=aa;if(!ca)break;else{_=_+Q|0;Z=Z+ia+R|0;ca=ca+-1|0}}}else{if(V){ca=Y(a,F)|0;Z=(a|0)>0;_=O;aa=T;$=U;while(1){if(Z){ba=0;ea=aa;while(1){b[_+ba>>0]=b[r+(h[ea>>0]|0)>>0]|0;ba=ba+1|0;if((ba|0)==(a|0))break;else ea=ea+F|0}ja=aa+ca|0}else ja=aa;if(!$)break b;else{_=_+Q|0;aa=ja+R|0;$=$+-1|0}}}$=a&-4;aa=Y(F,$)|0;_=Y(a,F)|0;ca=($|0)<(a|0);Z=O;V=T;ea=U;while(1){ba=0;ha=V;while(1){fa=b[r+(h[ha+F>>0]|0)>>0]|0;b[Z+ba>>0]=b[r+(h[ha>>0]|0)>>0]|0;b[Z+(ba|1)>>0]=fa;fa=ha+W|0;ga=b[r+(h[fa+F>>0]|0)>>0]|0;b[Z+(ba|2)>>0]=b[r+(h[fa>>0]|0)>>0]|0;b[Z+(ba|3)>>0]=ga;ba=ba+4|0;if((ba|0)>(X|0))break;else ha=fa+W|0}if(ca){ha=$;ba=V+aa|0;while(1){b[Z+ha>>0]=b[r+(h[ba>>0]|0)>>0]|0;ha=ha+1|0;if((ha|0)==(a|0)){ka=_;break}else ba=ba+F|0}}else ka=aa;if(!ea)break;else{Z=Z+Q|0;V=V+ka+R|0;ea=ea+-1|0}}}}while(0);break}case 2:{R=f[J>>2]|0;F=f[J+4>>2]|0;U=f[J+8>>2]|0;T=f[J+12>>2]|0;if((c|0)!=0&(a|0)>0){ea=Y(a,R)|0;V=Y(a,U)|0;Z=f[z>>2]|0;aa=f[z+4>>2]|0;_=O;$=c;while(1){ca=Z+ea|0;W=Z;X=aa;ba=0;while(1){ha=(f[P+((h[X>>0]|0|256)<<2)>>2]|0)+(f[P+((h[W>>0]|0)<<2)>>2]|0)|0;if(ha>>>0<1073741824){fa=mrc(S*+n[K+ha>>2])|0;la=(fa>>>0<256?fa:(fa|0)>0?255:0)&255}else la=0;b[_+ba>>0]=la;ba=ba+1|0;if((ba|0)==(a|0))break;else{W=W+R|0;X=X+U|0}}$=$+-1|0;if(!$)break;else{Z=ca+F|0;aa=aa+V+T|0;_=_+Q|0}}}break}case 3:{_=f[J>>2]|0;T=f[J+4>>2]|0;V=f[J+8>>2]|0;aa=f[J+12>>2]|0;F=f[J+16>>2]|0;Z=f[J+20>>2]|0;if((c|0)!=0&(a|0)>0){$=Y(a,_)|0;U=Y(a,V)|0;R=Y(a,F)|0;ea=f[z+8>>2]|0;X=f[z+4>>2]|0;W=f[z>>2]|0;ba=O;fa=c;while(1){fa=fa+-1|0;ha=X+U|0;ga=ea;ma=X;na=W;oa=0;while(1){pa=(f[P+((h[ma>>0]|0|256)<<2)>>2]|0)+(f[P+((h[na>>0]|0)<<2)>>2]|0)+(f[P+((h[ga>>0]|0|512)<<2)>>2]|0)|0;if(pa>>>0<1073741824){qa=mrc(S*+n[K+pa>>2])|0;ra=(qa>>>0<256?qa:(qa|0)>0?255:0)&255}else ra=0;b[ba+oa>>0]=ra;oa=oa+1|0;if((oa|0)==(a|0))break;else{ga=ga+F|0;ma=ma+V|0;na=na+_|0}}if(!fa)break;else{ea=ea+R+Z|0;X=ha+aa|0;W=W+$+T|0;ba=ba+Q|0}}}break}default:if(c|0){if((a|0)>0){sa=O;ta=c}else{ba=c;while(1){T=0;do{$=z+(T<<2)|0;f[$>>2]=(f[$>>2]|0)+(f[J+((T<<1|1)<<2)>>2]|0);T=T+1|0}while((T|0)!=(I|0));ba=ba+-1|0;if(!ba)break a}}while(1){ba=0;do{T=K;ha=0;while(1){$=z+(ha<<2)|0;W=f[$>>2]|0;aa=f[P+((h[W>>0]|0|ha<<8)<<2)>>2]|0;if(aa>>>0>1073741823){ua=T;va=ha;break}X=T+aa|0;f[$>>2]=W+(f[J+(ha<<1<<2)>>2]|0);W=ha+1|0;if((W|0)<(I|0)){T=X;ha=W}else{ua=X;va=W;break}}if((va|0)!=(I|0)){b[sa+ba>>0]=0;if((va|0)<(I|0)){ha=va;do{T=z+(ha<<2)|0;f[T>>2]=(f[T>>2]|0)+(f[J+(ha<<1<<2)>>2]|0);ha=ha+1|0}while((ha|0)!=(I|0))}}else{ha=mrc(S*+n[ua>>2])|0;b[sa+ba>>0]=ha>>>0<256?ha:(ha|0)>0?255:0}ba=ba+1|0}while((ba|0)!=(a|0));wa=0;do{ba=z+(wa<<2)|0;f[ba>>2]=(f[ba>>2]|0)+(f[J+((wa<<1|1)<<2)>>2]|0);wa=wa+1|0}while((wa|0)!=(I|0));ta=ta+-1|0;if(!ta)break;else sa=sa+Q|0}}}while(0);Q=f[q>>2]|0;if(Q|0){sa=f[E>>2]|0;if((sa|0)!=(Q|0))f[E>>2]=sa+(~((sa+-4-Q|0)>>>2)<<2);YDc(Q)}break}case 2:{Q=f[y>>2]|0;sa=f[D>>2]|0;S=l;E=f[v>>2]|0;ta=f[w>>2]|0;wa=f[G>>2]|0;J=f[E+(I<<2)>>2]|0;z=f[ta+((I<<1|1)<<2)>>2]|0;a=I<<2;ua=f[t+44>>2]|0;dJc(r|0,f[i>>2]|0,a|0)|0;dJc(s|0,ua|0,a|0)|0;c:do if(!m){if(!k){f[q>>2]=0;f[q+4>>2]=0;L=tT(q,55)|0;M=257727;N=L+55|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));Xga(-5,q,258233,1389)}dJc(q|0,k|0,a|0)|0;if(sa|0){ua=(Q|0)>0;va=J;P=sa;while(1){P=P+-1|0;if(ua){K=0;do{c=wa;O=0;while(1){ra=E+(O<<2)|0;la=f[ra>>2]|0;xa=+(j[la>>1]|0);ka=f[q+(O<<2)>>2]|0;ja=f[r+(O<<2)>>2]|0;ia=-1;while(1){da=ia+1|0;if(!(xa>=+n[ka+(da<<2)>>2])){ya=ia;break}if((da|0)<(ja|0))ia=da;else{ya=da;break}}if(ya>>>0>=ja>>>0){za=c;Aa=O;break}f[ra>>2]=la+(f[ta+(O<<1<<2)>>2]<<1);ia=c+(Y(f[s+(O<<2)>>2]|0,ya)|0)|0;ka=O+1|0;if((ka|0)<(I|0)){c=ia;O=ka}else{za=ia;Aa=ka;break}}if((Aa|0)!=(I|0)){d[va+(K<<1)>>1]=0;if((Aa|0)<(I|0)){O=Aa;do{c=E+(O<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[ta+(O<<1<<2)>>2]<<1);O=O+1|0}while((O|0)!=(I|0))}}else{O=mrc(S*+n[za>>2])|0;d[va+(K<<1)>>1]=O>>>0<65536?O:(O|0)>0?65535:0}K=K+1|0}while((K|0)!=(Q|0));Ba=0}else Ba=0;do{K=E+(Ba<<2)|0;f[K>>2]=(f[K>>2]|0)+(f[ta+((Ba<<1|1)<<2)>>2]<<1);Ba=Ba+1|0}while((Ba|0)!=(I|0));if(!P)break;else va=va+(z<<1)|0}}}else switch(I|0){case 1:{xa=+p[e>>3];Ca=+p[e+8>>3];va=f[r>>2]|0;P=f[ta>>2]|0;ua=f[ta+4>>2]|0;if(!sa)break c;if((Q|0)<=0)break c;K=Y(Q,P)|0;O=J;c=f[E>>2]|0;ka=sa;while(1){ka=ka+-1|0;ia=0;da=c;while(1){Da=Ca+xa*+(j[da>>1]|0);ba=~~Da;ha=ba-(+(ba|0)>Da&1)|0;if(ha>>>0<va>>>0){ba=mrc(S*+n[wa+(ha<<2)>>2])|0;Ea=(ba>>>0<65536?ba:(ba|0)>0?65535:0)&65535}else Ea=0;d[O+(ia<<1)>>1]=Ea;ia=ia+1|0;if((ia|0)==(Q|0))break;else da=da+(P<<1)|0}if(!ka)break;else{O=O+(z<<1)|0;c=c+(K<<1)+(ua<<1)|0}}break}case 2:{xa=+p[e>>3];Ca=+p[e+8>>3];Da=+p[e+16>>3];Fa=+p[e+24>>3];ua=f[r>>2]|0;K=f[r+4>>2]|0;c=f[ta>>2]|0;O=f[ta+4>>2]|0;ka=f[ta+8>>2]|0;P=f[ta+12>>2]|0;va=f[s>>2]|0;if(!((Q|0)>0&(sa|0)!=0))break c;da=Y(Q,c)|0;ia=Y(Q,ka)|0;ba=f[E>>2]|0;ha=f[E+4>>2]|0;T=J;W=sa;while(1){X=ba+(da<<1)|0;$=0;aa=ba;Z=ha;while(1){Ga=Ca+xa*+(j[aa>>1]|0);R=~~Ga;ea=R-(+(R|0)>Ga&1)|0;Ga=Fa+Da*+(j[Z>>1]|0);R=~~Ga;fa=R-(+(R|0)>Ga&1)|0;if(ea>>>0<ua>>>0&fa>>>0<K>>>0){R=wa+(Y(ea,va)|0)+(fa<<2)|0;fa=mrc(S*+n[R>>2])|0;Ha=(fa>>>0<65536?fa:(fa|0)>0?65535:0)&65535}else Ha=0;d[T+($<<1)>>1]=Ha;$=$+1|0;if(($|0)==(Q|0))break;else{aa=aa+(c<<1)|0;Z=Z+(ka<<1)|0}}W=W+-1|0;if(!W)break;else{ba=X+(O<<1)|0;ha=ha+(ia<<1)+(P<<1)|0;T=T+(z<<1)|0}}break}case 3:{Da=+p[e>>3];Fa=+p[e+8>>3];xa=+p[e+16>>3];Ca=+p[e+24>>3];Ga=+p[e+32>>3];Ia=+p[e+40>>3];T=f[r>>2]|0;P=f[r+4>>2]|0;ia=f[r+8>>2]|0;ha=f[ta>>2]|0;O=f[ta+4>>2]|0;ba=f[ta+8>>2]|0;W=f[ta+12>>2]|0;ka=f[ta+16>>2]|0;c=f[ta+20>>2]|0;va=f[s>>2]|0;K=f[s+4>>2]|0;if(!((Q|0)>0&(sa|0)!=0))break c;ua=Y(Q,ha)|0;da=Y(Q,ba)|0;Z=Y(Q,ka)|0;aa=f[E>>2]|0;$=f[E+4>>2]|0;fa=f[E+8>>2]|0;R=J;ea=sa;while(1){ea=ea+-1|0;_=$+(da<<1)|0;V=aa;F=$;U=fa;na=0;while(1){Ja=Fa+Da*+(j[V>>1]|0);ma=~~Ja;ga=ma-(+(ma|0)>Ja&1)|0;Ja=Ca+xa*+(j[F>>1]|0);ma=~~Ja;oa=ma-(+(ma|0)>Ja&1)|0;Ja=Ia+Ga*+(j[U>>1]|0);ma=~~Ja;ca=ma-(+(ma|0)>Ja&1)|0;if(ga>>>0<T>>>0&oa>>>0<P>>>0&ca>>>0<ia>>>0){ma=wa+(Y(ga,va)|0)+(Y(oa,K)|0)+(ca<<2)|0;ca=mrc(S*+n[ma>>2])|0;Ka=(ca>>>0<65536?ca:(ca|0)>0?65535:0)&65535}else Ka=0;d[R+(na<<1)>>1]=Ka;na=na+1|0;if((na|0)==(Q|0))break;else{V=V+(ha<<1)|0;F=F+(ba<<1)|0;U=U+(ka<<1)|0}}if(!ea)break;else{aa=aa+(ua<<1)+(O<<1)|0;$=_+(W<<1)|0;fa=fa+(Z<<1)+(c<<1)|0;R=R+(z<<1)|0}}break}default:{if(!sa)break c;R=(k|0)==0;c=(Q|0)>0;Z=J;fa=sa;while(1){fa=fa+-1|0;if(c){W=0;while(1){d:do if(R){$=wa;O=0;while(1){ua=E+(O<<2)|0;aa=f[ua>>2]|0;ea=O<<1;Ga=+(j[aa>>1]|0)*+p[e+(ea<<3)>>3]+ +p[e+((ea|1)<<3)>>3];ka=~~Ga;ba=ka-(+(ka|0)>Ga&1)|0;if(ba>>>0>=(f[r+(O<<2)>>2]|0)>>>0){La=$;Ma=O;break d}f[ua>>2]=aa+(f[ta+(ea<<2)>>2]<<1);ea=$+(Y(f[s+(O<<2)>>2]|0,ba)|0)|0;ba=O+1|0;if((ba|0)<(I|0)){$=ea;O=ba}else{La=ea;Ma=ba;break}}}else{O=wa;$=0;while(1){la=E+($<<2)|0;ra=f[la>>2]|0;ja=d[ra>>1]|0;ba=$<<1;Ga=+(ja&65535)*+p[e+(ba<<3)>>3]+ +p[e+((ba|1)<<3)>>3];ea=~~Ga;aa=ea-(+(ea|0)>Ga&1)|0;if(aa>>>0>=(f[r+($<<2)>>2]|0)>>>0){La=O;Ma=$;break d}if(+(ja&65535)>=+n[(f[k+($<<2)>>2]|0)+4>>2]){La=O;Ma=$;break d}f[la>>2]=ra+(f[ta+(ba<<2)>>2]<<1);ba=O+(Y(f[s+($<<2)>>2]|0,aa)|0)|0;aa=$+1|0;if((aa|0)<(I|0)){O=ba;$=aa}else{La=ba;Ma=aa;break}}}while(0);if((Ma|0)!=(I|0)){d[Z+(W<<1)>>1]=0;if((Ma|0)<(I|0)){$=Ma;do{O=E+($<<2)|0;f[O>>2]=(f[O>>2]|0)+(f[ta+($<<1<<2)>>2]<<1);$=$+1|0}while(($|0)!=(I|0))}}else{$=mrc(S*+n[La>>2])|0;d[Z+(W<<1)>>1]=$>>>0<65536?$:($|0)>0?65535:0}W=W+1|0;if((W|0)==(Q|0)){Na=0;break}}}else Na=0;do{W=E+(Na<<2)|0;f[W>>2]=(f[W>>2]|0)+(f[ta+((Na<<1|1)<<2)>>2]<<1);Na=Na+1|0}while((Na|0)!=(I|0));if(!fa)break;else Z=Z+(z<<1)|0}}}while(0);break}case 5:{z=f[y>>2]|0;y=f[D>>2]|0;S=l;D=f[v>>2]|0;Na=f[w>>2]|0;ta=f[G>>2]|0;E=f[D+(I<<2)>>2]|0;Q=f[Na+((I<<1|1)<<2)>>2]|0;La=I<<2;Ma=f[t+44>>2]|0;dJc(r|0,f[i>>2]|0,La|0)|0;dJc(s|0,Ma|0,La|0)|0;e:do if(!m){if(!k){f[q>>2]=0;f[q+4>>2]=0;L=tT(q,55)|0;M=257727;N=L+55|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));Xga(-5,q,258233,1389)}dJc(q|0,k|0,La|0)|0;if(y|0){Ma=(z|0)>0;wa=E;sa=y;while(1){sa=sa+-1|0;if(Ma){J=0;do{Ka=ta;Ha=0;while(1){Ea=D+(Ha<<2)|0;Ba=f[Ea>>2]|0;l=+n[Ba>>2];za=f[q+(Ha<<2)>>2]|0;Aa=f[r+(Ha<<2)>>2]|0;ya=-1;while(1){a=ya+1|0;if(!(l>=+n[za+(a<<2)>>2])){Oa=ya;break}if((a|0)<(Aa|0))ya=a;else{Oa=a;break}}if(Oa>>>0>=Aa>>>0){Pa=Ka;Qa=Ha;break}f[Ea>>2]=Ba+(f[Na+(Ha<<1<<2)>>2]<<2);ya=Ka+(Y(f[s+(Ha<<2)>>2]|0,Oa)|0)|0;za=Ha+1|0;if((za|0)<(I|0)){Ka=ya;Ha=za}else{Pa=ya;Qa=za;break}}if((Qa|0)!=(I|0)){n[wa+(J<<2)>>2]=0.0;if((Qa|0)<(I|0)){Ha=Qa;do{Ka=D+(Ha<<2)|0;f[Ka>>2]=(f[Ka>>2]|0)+(f[Na+(Ha<<1<<2)>>2]<<2);Ha=Ha+1|0}while((Ha|0)!=(I|0))}}else n[wa+(J<<2)>>2]=S*+n[Pa>>2];J=J+1|0}while((J|0)!=(z|0));Ra=0}else Ra=0;do{J=D+(Ra<<2)|0;f[J>>2]=(f[J>>2]|0)+(f[Na+((Ra<<1|1)<<2)>>2]<<2);Ra=Ra+1|0}while((Ra|0)!=(I|0));if(!sa)break;else wa=wa+(Q<<2)|0}}}else switch(I|0){case 1:{l=+p[e>>3];Ga=+p[e+8>>3];wa=f[r>>2]|0;sa=f[Na>>2]|0;Ma=f[Na+4>>2]|0;if(!y)break e;if((z|0)<=0)break e;J=Y(z,sa)|0;Ha=E;Ka=f[D>>2]|0;za=y;while(1){za=za+-1|0;ya=0;a=Ka;while(1){Ia=Ga+l*+n[a>>2];Z=~~Ia;fa=Z-(+(Z|0)>Ia&1)|0;if(fa>>>0<wa>>>0)Sa=S*+n[ta+(fa<<2)>>2];else Sa=0.0;n[Ha+(ya<<2)>>2]=Sa;ya=ya+1|0;if((ya|0)==(z|0))break;else a=a+(sa<<2)|0}if(!za)break;else{Ha=Ha+(Q<<2)|0;Ka=Ka+(J<<2)+(Ma<<2)|0}}break}case 2:{l=+p[e>>3];Ga=+p[e+8>>3];Ia=+p[e+16>>3];xa=+p[e+24>>3];Ma=f[r>>2]|0;J=f[r+4>>2]|0;Ka=f[Na>>2]|0;Ha=f[Na+4>>2]|0;za=f[Na+8>>2]|0;sa=f[Na+12>>2]|0;wa=f[s>>2]|0;if(!((z|0)>0&(y|0)!=0))break e;a=Y(z,Ka)|0;ya=Y(z,za)|0;fa=f[D>>2]|0;Z=f[D+4>>2]|0;R=E;c=y;while(1){W=fa+(a<<2)|0;_=0;$=fa;O=Z;while(1){Ca=Ga+l*+n[$>>2];aa=~~Ca;ba=aa-(+(aa|0)>Ca&1)|0;Ca=xa+Ia*+n[O>>2];aa=~~Ca;ra=aa-(+(aa|0)>Ca&1)|0;if(ba>>>0<Ma>>>0&ra>>>0<J>>>0){aa=ta+(Y(ba,wa)|0)+(ra<<2)|0;Ta=S*+n[aa>>2]}else Ta=0.0;n[R+(_<<2)>>2]=Ta;_=_+1|0;if((_|0)==(z|0))break;else{$=$+(Ka<<2)|0;O=O+(za<<2)|0}}c=c+-1|0;if(!c)break;else{fa=W+(Ha<<2)|0;Z=Z+(ya<<2)+(sa<<2)|0;R=R+(Q<<2)|0}}break}case 3:{Ia=+p[e>>3];xa=+p[e+8>>3];l=+p[e+16>>3];Ga=+p[e+24>>3];Ca=+p[e+32>>3];Da=+p[e+40>>3];R=f[r>>2]|0;sa=f[r+4>>2]|0;ya=f[r+8>>2]|0;Z=f[Na>>2]|0;Ha=f[Na+4>>2]|0;fa=f[Na+8>>2]|0;c=f[Na+12>>2]|0;za=f[Na+16>>2]|0;Ka=f[Na+20>>2]|0;wa=f[s>>2]|0;J=f[s+4>>2]|0;if(!((z|0)>0&(y|0)!=0))break e;Ma=Y(z,Z)|0;a=Y(z,fa)|0;O=Y(z,za)|0;$=f[D>>2]|0;_=f[D+4>>2]|0;aa=f[D+8>>2]|0;ra=E;ba=y;while(1){ba=ba+-1|0;la=_+(a<<2)|0;ja=$;ea=_;ua=aa;ka=0;while(1){Fa=xa+Ia*+n[ja>>2];ha=~~Fa;K=ha-(+(ha|0)>Fa&1)|0;Fa=Ga+l*+n[ea>>2];ha=~~Fa;va=ha-(+(ha|0)>Fa&1)|0;Fa=Da+Ca*+n[ua>>2];ha=~~Fa;ia=ha-(+(ha|0)>Fa&1)|0;if(K>>>0<R>>>0&va>>>0<sa>>>0&ia>>>0<ya>>>0){ha=ta+(Y(K,wa)|0)+(Y(va,J)|0)+(ia<<2)|0;Ua=S*+n[ha>>2]}else Ua=0.0;n[ra+(ka<<2)>>2]=Ua;ka=ka+1|0;if((ka|0)==(z|0))break;else{ja=ja+(Z<<2)|0;ea=ea+(fa<<2)|0;ua=ua+(za<<2)|0}}if(!ba)break;else{$=$+(Ma<<2)+(Ha<<2)|0;_=la+(c<<2)|0;aa=aa+(O<<2)+(Ka<<2)|0;ra=ra+(Q<<2)|0}}break}default:{if(!y)break e;ra=(k|0)==0;Ka=(z|0)>0;O=E;aa=y;while(1){aa=aa+-1|0;if(Ka){c=0;while(1){f:do if(ra){_=ta;Ha=0;while(1){Ma=D+(Ha<<2)|0;$=f[Ma>>2]|0;ba=Ha<<1;Ca=+n[$>>2]*+p[e+(ba<<3)>>3]+ +p[e+((ba|1)<<3)>>3];za=~~Ca;fa=za-(+(za|0)>Ca&1)|0;if(fa>>>0>=(f[r+(Ha<<2)>>2]|0)>>>0){Va=_;Wa=Ha;break f}f[Ma>>2]=$+(f[Na+(ba<<2)>>2]<<2);ba=_+(Y(f[s+(Ha<<2)>>2]|0,fa)|0)|0;fa=Ha+1|0;if((fa|0)<(I|0)){_=ba;Ha=fa}else{Va=ba;Wa=fa;break}}}else{Ha=ta;_=0;while(1){Ba=D+(_<<2)|0;Ea=f[Ba>>2]|0;Ca=+n[Ea>>2];Aa=_<<1;Da=Ca*+p[e+(Aa<<3)>>3]+ +p[e+((Aa|1)<<3)>>3];fa=~~Da;ba=fa-(+(fa|0)>Da&1)|0;if(ba>>>0>=(f[r+(_<<2)>>2]|0)>>>0){Va=Ha;Wa=_;break f}if(Ca>=+n[(f[k+(_<<2)>>2]|0)+4>>2]){Va=Ha;Wa=_;break f}f[Ba>>2]=Ea+(f[Na+(Aa<<2)>>2]<<2);Aa=Ha+(Y(f[s+(_<<2)>>2]|0,ba)|0)|0;ba=_+1|0;if((ba|0)<(I|0)){Ha=Aa;_=ba}else{Va=Aa;Wa=ba;break}}}while(0);if((Wa|0)!=(I|0)){n[O+(c<<2)>>2]=0.0;if((Wa|0)<(I|0)){_=Wa;do{Ha=D+(_<<2)|0;f[Ha>>2]=(f[Ha>>2]|0)+(f[Na+(_<<1<<2)>>2]<<2);_=_+1|0}while((_|0)!=(I|0))}}else n[O+(c<<2)>>2]=S*+n[Va>>2];c=c+1|0;if((c|0)==(z|0)){Xa=0;break}}}else Xa=0;do{c=D+(Xa<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[Na+((Xa<<1|1)<<2)>>2]<<2);Xa=Xa+1|0}while((Xa|0)!=(I|0));if(!aa)break;else O=O+(Q<<2)|0}}}while(0);break}default:{f[q>>2]=0;f[q+4>>2]=0;Xga(-210,q,258217,1546)}}q=A+36|0;Q=f[q>>2]|0;if(Q|0?(I=Q+12|0,Q=f[I>>2]|0,f[I>>2]=Q+-1,(Q|0)==1):0)_S(A);f[q>>2]=0;q=A+16|0;Q=A+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[Q>>2]|0)>0){q=f[A+40>>2]|0;I=0;do{f[q+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[Q>>2]|0))}Q=f[A+44>>2]|0;if((Q|0)!=(A+48|0))g0(Q);Q=f[x>>2]|0;if(Q|0){x=f[B>>2]|0;if((x|0)!=(Q|0))f[B>>2]=x+(~((x+-8-Q|0)>>>3)<<3);YDc(Q)}Q=f[w>>2]|0;if(Q|0){w=f[C>>2]|0;if((w|0)!=(Q|0))f[C>>2]=w+(~((w+-4-Q|0)>>>2)<<2);YDc(Q)}Q=f[v>>2]|0;if(Q|0){v=f[g>>2]|0;if((v|0)!=(Q|0))f[g>>2]=v+(~((v+-4-Q|0)>>>2)<<2);YDc(Q)}Q=t+36|0;v=f[Q>>2]|0;if(v|0?(g=v+12|0,v=f[g>>2]|0,f[g>>2]=v+-1,(v|0)==1):0)_S(t);f[Q>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[H>>2]|0)>0){G=f[i>>2]|0;i=0;do{f[G+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[H>>2]|0))}H=f[t+44>>2]|0;if((H|0)==(t+48|0)){u=o;return}g0(H);u=o;return}function fha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+3696|0;j=i+3632|0;k=i+3576|0;l=i+1520|0;m=i+56|0;n=i;n$(d,-1)|0;do if((d$(d)|0)==65536){o=f[d+4>>2]|0;f[j>>2]=f[o>>2];p=j+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[j+16>>2]=f[o+16>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;t=j+44|0;f[t>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];v=j;break}else{f[p>>2]=0;ZS(j,o);v=j;break}}else{a$(j,d,-1);v=j}while(0);f[k>>2]=1124007936;o=k+4|0;p=k+8|0;q=k+40|0;r=o;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));f[q>>2]=p;s=k+48|0;w=k+44|0;f[w>>2]=s;f[s>>2]=0;f[k+52>>2]=0;x=f[v>>2]|0;y=x>>>3&511;z=y+1|0;if(y){if(!(x&16384)){f[l>>2]=0;f[l+4>>2]=0;r=tT(l,17)|0;A=258247;t=r+17|0;do{b[r>>0]=b[A>>0]|0;r=r+1|0;A=A+1|0}while((r|0)<(t|0));Xga(-215,l,258217,1889)}y=f[j+4>>2]|0;dJc(l|0,f[j+40>>2]|0,y<<2|0)|0;f[l+(y<<2)>>2]=z;dT(m,y+1|0,l,x&7,f[j+16>>2]|0,0);x=m+36|0;y=f[x>>2]|0;if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}z=k+36|0;y=f[z>>2]|0;if(y|0?(B=y+12|0,y=f[B>>2]|0,f[B>>2]=y+-1,(y|0)==1):0)_S(k);f[z>>2]=0;y=k+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[o>>2]|0)>0){B=f[q>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0;D=f[o>>2]|0}while((C|0)<(D|0));f[k>>2]=f[m>>2];if((D|0)<3)E=21;else E=23}else{f[k>>2]=f[m>>2];E=21}if((E|0)==21){D=f[m+4>>2]|0;if((D|0)<3){f[o>>2]=D;f[p>>2]=f[m+8>>2];f[k+12>>2]=f[m+12>>2];D=f[m+44>>2]|0;C=f[w>>2]|0;f[C>>2]=f[D>>2];f[C+4>>2]=f[D+4>>2]}else E=23}if((E|0)==23)ZS(k,m);D=m+16|0;f[y>>2]=f[D>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];f[k+32>>2]=f[m+32>>2];y=f[x>>2]|0;f[z>>2]=y;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)_S(m);f[x>>2]=0;x=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[x>>2]|0)>0){D=f[m+40>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[m+44>>2]|0;if((x|0)!=(m+48|0))g0(x)}else{x=j+36|0;y=f[x>>2]|0;if(y){D=y+12|0;f[D>>2]=(f[D>>2]|0)+1;D=k+36|0;y=f[D>>2]|0;if((y|0)!=0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0){_S(k);F=D}else F=D}else F=k+36|0;f[F>>2]=0;D=k+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[o>>2]|0)>0){y=f[q>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0;G=f[o>>2]|0}while((z|0)<(G|0));f[k>>2]=f[v>>2];if((G|0)<3)E=43;else E=45}else{f[k>>2]=f[v>>2];E=43}if((E|0)==43){v=f[j+4>>2]|0;if((v|0)<3){f[o>>2]=v;f[p>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];v=f[j+44>>2]|0;G=f[w>>2]|0;f[G>>2]=f[v>>2];f[G+4>>2]=f[v+4>>2]}else E=45}if((E|0)==45)ZS(k,j);f[D>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];f[F>>2]=f[x>>2]}x=(f[p>>2]|0)==1;p=(f[k+12>>2]|0)==1;F=x|p;D=f[o>>2]|0;v=(f[g+4>>2]|0)-(f[g>>2]|0)|0;G=v>>2;z=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;y=o$(a,-1)|0;if((y|0)<=0){f[l>>2]=0;f[l+4>>2]=0;r=tT(l,11)|0;A=258265;t=r+11|0;do{b[r>>0]=b[A>>0]|0;r=r+1|0;A=A+1|0}while((r|0)<(t|0));Xga(-215,l,258217,1902)}if((G|0)!=(D<<1|0)?(G|0)!=2|(x|p)^1:0){if(G|0){f[l>>2]=0;H=l+4|0;f[H>>2]=0;I=tT(l,76)|0;r=I;A=258277;t=r+76|0;do{b[r>>0]=b[A>>0]|0;r=r+1|0;A=A+1|0}while((r|0)<(t|0));Xga(-215,l,258217,1903)}if(p$(a,0)|0){f[l>>2]=0;H=l+4|0;f[H>>2]=0;I=tT(l,76)|0;r=I;A=258277;t=r+76|0;do{b[r>>0]=b[A>>0]|0;r=r+1|0;A=A+1|0}while((r|0)<(t|0));Xga(-215,l,258217,1903)}}I=(z|0)==0;if(!(I|(z|0)==(D|0))?(z|0)!=1|F^1:0){f[l>>2]=0;f[l+4>>2]=0;r=tT(l,44)|0;A=258354;t=r+44|0;do{b[r>>0]=b[A>>0]|0;r=r+1|0;A=A+1|0}while((r|0)<(t|0));Xga(-215,l,258217,1904)}if((v|0)>0?(A=(G|0)/2|0,(v|0)>4):0){v=f[g>>2]|0;g=0;do{f[l+(g<<2)>>2]=v+(g<<1<<2);g=g+1|0}while((g|0)<(A|0))}YQ(m,y);A=n+4|0;g=n+8|0;v=n+12|0;r=n+16|0;t=n+20|0;F=n+24|0;z=n+28|0;D=n+32|0;H=n+36|0;p=n+40|0;x=n+48|0;C=n+44|0;B=0;do{a$(n,a,B);J=f[m>>2]|0;K=J+(B*56|0)|0;if((K|0)!=(n|0)){L=f[H>>2]|0;if(L|0){M=L+12|0;f[M>>2]=(f[M>>2]|0)+1}M=J+(B*56|0)+36|0;L=f[M>>2]|0;if(L|0?(N=L+12|0,L=f[N>>2]|0,f[N>>2]=L+-1,(L|0)==1):0)_S(K);f[M>>2]=0;L=J+(B*56|0)+16|0;N=J+(B*56|0)+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[N>>2]|0)>0){O=f[J+(B*56|0)+40>>2]|0;P=0;do{f[O+(P<<2)>>2]=0;P=P+1|0;Q=f[N>>2]|0}while((P|0)<(Q|0));f[K>>2]=f[n>>2];if((Q|0)<3)E=73;else E=75}else{f[K>>2]=f[n>>2];E=73}if((E|0)==73){E=0;P=f[A>>2]|0;if((P|0)<3){f[N>>2]=P;f[J+(B*56|0)+8>>2]=f[g>>2];f[J+(B*56|0)+12>>2]=f[v>>2];P=f[C>>2]|0;O=f[J+(B*56|0)+44>>2]|0;f[O>>2]=f[P>>2];f[O+4>>2]=f[P+4>>2]}else E=75}if((E|0)==75){E=0;ZS(K,n)}f[L>>2]=f[r>>2];f[J+(B*56|0)+20>>2]=f[t>>2];f[J+(B*56|0)+24>>2]=f[F>>2];f[J+(B*56|0)+28>>2]=f[z>>2];f[J+(B*56|0)+32>>2]=f[D>>2];f[M>>2]=f[H>>2]}P=f[H>>2]|0;if(P|0?(O=P+12|0,P=f[O>>2]|0,f[O>>2]=P+-1,(P|0)==1):0)_S(n);f[H>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[A>>2]|0)>0){P=f[p>>2]|0;O=0;do{f[P+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[A>>2]|0))}O=f[C>>2]|0;if((O|0)!=(x|0))g0(O);B=B+1|0}while((B|0)<(y|0));eha(f[m>>2]|0,y,I?0:f[c>>2]|0,d,e,G|0?l:0,h,1);ZQ(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(G=l+12|0,l=f[G>>2]|0,f[G>>2]=l+-1,(l|0)==1):0)_S(k);f[m>>2]=0;m=k+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){m=f[q>>2]|0;q=0;do{f[m+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[w>>2]|0;if((o|0)!=(s|0))g0(o);o=j+36|0;s=f[o>>2]|0;if(s|0?(w=s+12|0,s=f[w>>2]|0,f[w>>2]=s+-1,(s|0)==1):0)_S(j);f[o>>2]=0;o=j+16|0;s=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[s>>2]|0)>0){o=f[j+40>>2]|0;w=0;do{f[o+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(j+48|0)){u=i;return}g0(s);u=i;return}function gha(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,X=0.0,Z=0,_=0.0,$=0,aa=0.0;e=u;u=u+288|0;g=e+224|0;h=e+168|0;i=e+152|0;j=e+40|0;k=e+8|0;l=e;do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[g>>2]=f[m>>2];o=g+4|0;p=m+4|0;f[o>>2]=f[p>>2];q=g+8|0;f[q>>2]=f[m+8>>2];f[g+12>>2]=f[m+12>>2];f[g+16>>2]=f[m+16>>2];f[g+20>>2]=f[m+20>>2];f[g+24>>2]=f[m+24>>2];f[g+28>>2]=f[m+28>>2];f[g+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[g+36>>2]=r;f[g+40>>2]=q;q=g+48|0;s=g+44|0;f[s>>2]=q;f[q>>2]=0;f[g+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[m+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;ZS(g,m);break}}else a$(g,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];m=h+4|0;o=a+4|0;f[m>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;s=h+44|0;f[s>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[a+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;ZS(h,a);break}}else a$(h,c,-1);while(0);f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;f[j>>2]=1124007936;c=j+8|0;a=j+40|0;m=j+4|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[a>>2]=c;c=j+48|0;f[j+44>>2]=c;f[c>>2]=0;f[j+52>>2]=0;f[j+56>>2]=1124007936;c=j+64|0;a=j+96|0;m=j+60|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[a>>2]=c;c=j+104|0;f[j+100>>2]=c;f[c>>2]=0;f[j+108>>2]=0;x2(k,i,j,-1);i=f[g>>2]|0;if(!((i&7|0)==5?((f[h>>2]^i)&4095|0)==0:0)){f[l>>2]=0;f[l+4>>2]=0;m=tT(l,46)|0;t=258399;o=m+46|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));Xga(-215,l,258446,1935)}i=k+4|0;c=f[i>>2]|0;if(!(f[c>>2]&16384)){f[l>>2]=0;v=l+4|0;f[v>>2]=0;w=tT(l,58)|0;m=w;t=258458;o=m+58|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));Xga(-215,l,258446,1939)}if(!(f[c+56>>2]&16384)){f[l>>2]=0;v=l+4|0;f[v>>2]=0;w=tT(l,58)|0;m=w;t=258458;o=m+58|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));Xga(-215,l,258446,1939)}w=k+16|0;v=(d|0)==1;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;c=0;a:while(1){if(c>>>0>=(f[w>>2]|0)>>>0)break;a=f[i>>2]|0;p=f[a+16>>2]|0;s=f[a+72>>2]|0;q=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;a=Y(q,((f[g>>2]|0)>>>3&511)+1|0)|0;switch(d|0){case 1:case 4:{if((a|0)>0)if(v){q=0;D=x;while(1){E=+n[p+(q<<2)>>2];F=E-+n[s+(q<<2)>>2];r=+L(+E)>2.220446049250313e-16;G=r?D+F*F/E:D;q=q+1|0;if((q|0)==(a|0)){H=A;I=B;J=C;K=y;N=z;O=G;break}else D=G}}else{q=0;D=x;while(1){G=+n[p+(q<<2)>>2];E=+n[s+(q<<2)>>2];F=G-E;P=G+E;r=+L(+P)>2.220446049250313e-16;E=r?D+F*F/P:D;q=q+1|0;if((q|0)==(a|0)){H=A;I=B;J=C;K=y;N=z;O=E;break}else D=E}}else{H=A;I=B;J=C;K=y;N=z;O=x}break}case 0:{if((a|0)>0){q=0;D=y;E=z;P=A;F=B;G=C;while(1){Q=+n[p+(q<<2)>>2];R=+n[s+(q<<2)>>2];S=F+Q*R;T=D+Q;U=P+Q*Q;Q=E+R;V=G+R*R;q=q+1|0;if((q|0)==(a|0)){H=U;I=S;J=V;K=T;N=Q;O=x;break}else{D=T;E=Q;P=U;F=S;G=V}}}else{H=A;I=B;J=C;K=y;N=z;O=x}break}case 2:{if((a|0)>0){q=0;G=x;while(1){F=+n[s+(q<<2)>>2];P=+n[p+(q<<2)>>2];E=G+(F<P?F:P);q=q+1|0;if((q|0)==(a|0)){H=A;I=B;J=C;K=y;N=z;O=E;break}else G=E}}else{H=A;I=B;J=C;K=y;N=z;O=x}break}case 3:{if((a|0)>0){G=y;E=z;q=0;P=x;while(1){F=+n[p+(q<<2)>>2];D=+n[s+(q<<2)>>2];V=P+ +M(+(F*D));S=G+F;F=E+D;q=q+1|0;if((q|0)==(a|0)){H=A;I=B;J=C;K=S;N=F;O=V;break}else{G=S;E=F;P=V}}}else{H=A;I=B;J=C;K=y;N=z;O=x}break}case 5:{if((a|0)>0){q=0;P=x;while(1){E=+n[p+(q<<2)>>2];G=E;V=+n[s+(q<<2)>>2];if(!(+L(+E)<=2.220446049250313e-16)){r=!(+L(+V)<=2.220446049250313e-16);X=P+G*+W(+(G/(r?V:1.0e-10)))}else X=P;q=q+1|0;if((q|0)==(a|0)){H=A;I=B;J=C;K=y;N=z;O=X;break}else P=X}}else{H=A;I=B;J=C;K=y;N=z;O=x}break}default:{Z=38;break a}}A2(k)|0;x=O;y=K;z=N;A=H;B=I;C=J;c=c+1|0}if((Z|0)==38){f[l>>2]=0;f[l+4>>2]=0;m=tT(l,25)|0;t=264554;o=m+25|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));Xga(-5,l,258446,2108)}switch(d|0){case 4:{_=x*2.0;break}case 0:{d=f[g+4>>2]|0;if((d|0)<3)$=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{l=f[g+40>>2]|0;t=0;m=1;while(1){o=Y(f[l+(t<<2)>>2]|0,m)|0;t=t+1|0;if((t|0)==(d|0)){$=o;break}else m=o}}J=1.0/+($>>>0);I=(A-y*y*J)*(C-z*z*J);if(+L(+I)>2.220446049250313e-16)_=(B-z*y*J)/+M(+I);else _=1.0;break}case 3:{I=z*y;if(+L(+I)>1.1920928955078125e-07)aa=1.0/+M(+I);else aa=1.0;I=1.0-x*aa;_=+M(+(I<0.0?0.0:I));break}default:_=x}$=j+56|0;m=j+92|0;d=f[m>>2]|0;if(d|0?(t=d+12|0,d=f[t>>2]|0,f[t>>2]=d+-1,(d|0)==1):0)_S($);f[m>>2]=0;m=j+72|0;$=j+60|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[$>>2]|0)>0){m=f[j+96>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[$>>2]|0))}$=f[j+100>>2]|0;if(($|0)!=(j+104|0))g0($);$=j+36|0;d=f[$>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)_S(j);f[$>>2]=0;$=j+16|0;d=j+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[d>>2]|0)>0){$=f[j+40>>2]|0;m=0;do{f[$+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[d>>2]|0))}d=f[j+44>>2]|0;if((d|0)!=(j+48|0))g0(d);d=h+36|0;j=f[d>>2]|0;if(j|0?(m=j+12|0,j=f[m>>2]|0,f[m>>2]=j+-1,(j|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;j=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[h+40>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[j>>2]|0))}j=f[h+44>>2]|0;if((j|0)!=(h+48|0))g0(j);j=g+36|0;h=f[j>>2]|0;if(h|0?(m=h+12|0,h=f[m>>2]|0,f[m>>2]=h+-1,(h|0)==1):0)_S(g);f[j>>2]=0;j=g+16|0;h=g+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[g+40>>2]|0;m=0;do{f[j+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return +_}g0(h);u=e;return +_}function hha(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0;d=u;u=u+2240|0;e=d+2184|0;g=d+2176|0;h=d+2120|0;i=d+2112|0;j=d+1088|0;k=d+64|0;l=d+48|0;m=d+32|0;n=d+24|0;o=d+8|0;q=d;if(c$(a,-1)|0){f[e>>2]=0;f[e+4>>2]=0;r=tT(e,22)|0;s=258517;t=r+22|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));Xga(-215,e,258540,3334)}if(r$(a)|0){u=d;return}do if((d$(a)|0)==65536){s=f[a+4>>2]|0;f[e>>2]=f[s>>2];r=e+4|0;t=s+4|0;f[r>>2]=f[t>>2];v=e+8|0;f[v>>2]=f[s+8>>2];f[e+12>>2]=f[s+12>>2];f[e+16>>2]=f[s+16>>2];f[e+20>>2]=f[s+20>>2];f[e+24>>2]=f[s+24>>2];f[e+28>>2]=f[s+28>>2];f[e+32>>2]=f[s+32>>2];w=f[s+36>>2]|0;f[e+36>>2]=w;x=e+40|0;f[x>>2]=v;v=e+48|0;y=e+44|0;f[y>>2]=v;f[v>>2]=0;f[e+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[s+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=e;A=x;break}else{f[r>>2]=0;ZS(e,s);z=e;A=x;break}}else{a$(e,a,-1);z=e;A=e+40|0}while(0);a=f[A>>2]|0;x=f[a>>2]|0;f[g>>2]=f[a+4>>2];f[g+4>>2]=x;v$(c,g,f[z>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){z=f[c+4>>2]|0;f[h>>2]=f[z>>2];g=h+4|0;x=z+4|0;f[g>>2]=f[x>>2];a=h+8|0;f[a>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];s=f[z+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=a;a=h+48|0;r=h+44|0;f[r>>2]=a;f[a>>2]=0;f[h+52>>2]=0;if(s|0){a=s+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[x>>2]|0)<3){x=f[z+44>>2]|0;a=f[r>>2]|0;f[a>>2]=f[x>>2];f[a+4>>2]=f[x+4>>2];break}else{f[g>>2]=0;ZS(h,z);break}}else a$(h,c,-1);while(0);k6(i);XIc(j|0,0,1024)|0;f[l>>2]=55076;f[l+4>>2]=e;f[l+8>>2]=j;f[l+12>>2]=i;f[m>>2]=55096;f[m+4>>2]=e;f[m+8>>2]=h;f[m+12>>2]=k;c=e+8|0;z=f[c>>2]|0;f[n>>2]=0;f[n+4>>2]=z;g=e+4|0;x=f[g>>2]|0;if((x|0)<3)B=Y(f[e+12>>2]|0,z)|0;else{z=f[A>>2]|0;a=0;r=1;while(1){s=Y(f[z+(a<<2)>>2]|0,r)|0;a=a+1|0;if((a|0)==(x|0)){B=s;break}else r=s}}if(B>>>0>307199){y8(n,l,-1.0);C=0}else{iha(l,n);C=0}while(1){D=f[j+(C<<2)>>2]|0;E=C+1|0;if(!D)C=E;else break}l=f[g>>2]|0;B=(l|0)<3;if(B)F=Y(f[e+12>>2]|0,f[c>>2]|0)|0;else{r=f[A>>2]|0;x=0;a=1;while(1){z=Y(f[r+(x<<2)>>2]|0,a)|0;x=x+1|0;if((x|0)==(l|0)){F=z;break}else a=z}}do if((F|0)!=(D|0)){G=255.0/+(F-D|0);f[k+(C<<2)>>2]=0;if((E|0)<256){a=0;x=E;do{a=(f[j+(x<<2)>>2]|0)+a|0;r=mrc(G*+(a|0))|0;f[k+(x<<2)>>2]=(r>>>0<256?r:(r|0)>0?255:0)&255;x=x+1|0}while((x|0)!=256)}if(B)H=Y(f[e+12>>2]|0,f[c>>2]|0)|0;else{x=f[A>>2]|0;a=0;r=1;while(1){z=Y(f[x+(a<<2)>>2]|0,r)|0;a=a+1|0;if((a|0)==(l|0)){H=z;break}else r=z}}if(H>>>0>307199){y8(n,m,-1.0);break}else{jha(m,n);break}}else{p[q>>3]=+(C|0);f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;l_(h,o,e0()|0)|0}while(0);l6(i);i=h+36|0;o=f[i>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)_S(h);f[i>>2]=0;i=h+16|0;o=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[o>>2]|0)>0){i=f[h+40>>2]|0;q=0;do{f[i+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[h+44>>2]|0;if((o|0)!=(h+48|0))g0(o);o=e+36|0;h=f[o>>2]|0;if(h|0?(q=h+12|0,h=f[q>>2]|0,f[q>>2]=h+-1,(h|0)==1):0)_S(e);f[o>>2]=0;o=e+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[g>>2]|0)>0){o=f[A>>2]|0;A=0;do{f[o+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))g0(g);u=d;return}function iha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+1024|0;d=c;XIc(d|0,0,1024)|0;e=f[a+4>>2]|0;g=f[e+48>>2]|0;i=f[b>>2]|0;j=(f[b+4>>2]|0)-i|0;b=(f[e>>2]&16384|0)!=0;k=Y(b?j:1,f[e+12>>2]|0)|0;l=(f[e+16>>2]|0)+(Y(f[f[e+44>>2]>>2]|0,i)|0)|0;i=b?1:j;j=i+-1|0;a:do if(i|0){b=k+-4|0;if((k|0)<4){e=(k|0)>0;m=l;n=j;while(1){if(e){o=0;do{p=d+((h[m+o>>0]|0)<<2)|0;f[p>>2]=(f[p>>2]|0)+1;o=o+1|0}while((o|0)!=(k|0))}if(!n)break a;else{m=m+g|0;n=n+-1|0}}}n=k&-4;m=(n|0)<(k|0);e=l;o=j;while(1){p=0;do{q=h[e+(p|1)>>0]|0;r=d+((h[e+p>>0]|0)<<2)|0;f[r>>2]=(f[r>>2]|0)+1;r=d+(q<<2)|0;f[r>>2]=(f[r>>2]|0)+1;r=h[e+(p|3)>>0]|0;q=d+((h[e+(p|2)>>0]|0)<<2)|0;f[q>>2]=(f[q>>2]|0)+1;q=d+(r<<2)|0;f[q>>2]=(f[q>>2]|0)+1;p=p+4|0}while((p|0)<=(b|0));if(m){p=n;do{q=d+((h[e+p>>0]|0)<<2)|0;f[q>>2]=(f[q>>2]|0)+1;p=p+1|0}while((p|0)!=(k|0))}if(!o)break;else{e=e+g|0;o=o+-1|0}}}while(0);g=f[a+12>>2]|0;m6(g);k=f[a+8>>2]|0;a=0;do{j=k+(a<<2)|0;f[j>>2]=(f[j>>2]|0)+(f[d+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=256);n6(g);u=c;return}function jha(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+4>>2]|0;e=f[d+48>>2]|0;g=f[a+8>>2]|0;i=f[g+48>>2]|0;j=f[d+12>>2]|0;k=f[c>>2]|0;l=(f[c+4>>2]|0)-k|0;c=f[a+12>>2]|0;if(!(f[d>>2]&16384)){m=j;n=l}else{a=(f[g>>2]&16384|0)!=0;o=Y(a?l:1,j)|0;m=o;n=a?1:l}l=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,k)|0)|0;d=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,k)|0)|0;k=n+-1|0;if(!n)return;n=m+-4|0;if((m|0)<4){g=(m|0)>0;a=l;o=d;j=k;while(1){if(g){p=0;do{b[o+p>>0]=f[c+((h[a+p>>0]|0)<<2)>>2];p=p+1|0}while((p|0)!=(m|0))}if(!j)break;else{a=a+e|0;o=o+i|0;j=j+-1|0}}return}j=m&-4;o=(j|0)<(m|0);a=l;l=d;d=k;while(1){k=0;do{g=k|1;p=f[c+((h[a+g>>0]|0)<<2)>>2]|0;b[l+k>>0]=f[c+((h[a+k>>0]|0)<<2)>>2];b[l+g>>0]=p;p=k|2;g=k|3;q=f[c+((h[a+g>>0]|0)<<2)>>2]|0;b[l+p>>0]=f[c+((h[a+p>>0]|0)<<2)>>2];b[l+g>>0]=q;k=k+4|0}while((k|0)<=(n|0));if(o){k=j;do{b[l+k>>0]=f[c+((h[a+k>>0]|0)<<2)>>2];k=k+1|0}while((k|0)!=(m|0))}if(!d)break;else{a=a+e|0;l=l+i|0;d=d+-1|0}}return}function kha(a){a=a|0;YDc(a);return}function lha(a){a=a|0;YDc(a);return}function mha(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,K=0.0,L=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0;e=u;u=u+64|0;g=e+8|0;h=e;do if((d$(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;ZS(g,i);break}}else a$(g,a,-1);while(0);a=pT(g,2,-1,1)|0;i=f[g>>2]&7;if((a|0)<=-1){f[h>>2]=0;p=h+4|0;f[p>>2]=0;q=tT(h,50)|0;r=q;t=258680;v=r+50|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));z5(-215,h,258731,258610,103)}j=(i|0)==5;if((i|1|0)!=5){f[h>>2]=0;p=h+4|0;f[p>>2]=0;q=tT(h,50)|0;r=q;t=258680;v=r+50|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));z5(-215,h,258731,258610,103)}w=+n[c>>2];h=mrc(w)|0;x=+n[c+4>>2];c=mrc(x)|0;a:do if(!a)y=d?-1797693134862315708145274.0e284:-1.0;else{t=f[g+16>>2]|0;r=a+-1|0;v=f[t+(r<<3)>>2]|0;q=f[t+(r<<3)+4>>2]|0;if(+(h|0)==w&((j|d)^1)&+(c|0)==x){r=0;p=0;i=v;k=q;while(1){l=i;i=f[t+(r<<3)>>2]|0;o=k;k=f[t+(r<<3)+4>>2]|0;m=(k|0)>(c|0);if((c|0)<(o|0))if(m)z=18;else z=17;else if(m)z=17;else z=18;if((z|0)==17){z=0;if(!((h|0)>(l|0)&(i|0)<(h|0))){m=c-o|0;A=i-l|0;B=mJc(A|0,((A|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;m=J;A=h-l|0;C=k-o|0;D=mJc(C|0,((C|0)<0)<<31>>31|0,A|0,((A|0)<0)<<31>>31|0)|0;A=TIc(B|0,m|0,D|0,J|0)|0;D=J;m=(k|0)<(o|0);B=TIc(0,0,A|0,D|0)|0;C=m?J:D;if((A|0)==0&(D|0)==0){y=0.0;break a}else E=(((C|0)>0|(C|0)==0&(m?B:A)>>>0>0)&1)+p|0}else z=18}if((z|0)==18){z=0;if((c|0)==(k|0)){if((h|0)==(i|0)){y=0.0;break a}if((c|0)==(o|0)){if(!((h|0)<(l|0)|(h|0)>(i|0))){y=0.0;break a}if(!((h|0)>(l|0)|(i|0)>(h|0))){y=0.0;break a}else E=p}else E=p}else E=p}r=r+1|0;if((r|0)>=(a|0))break;else p=E}y=+((E<<1&2)+-1|0);break}if(j){F=v;G=q;H=(f[s>>2]=q,+n[s>>2])}else{I=+(q|0);p=(n[s>>2]=+(v|0),f[s>>2]|0);F=p;G=(n[s>>2]=I,f[s>>2]|0);H=I}if(!d){if(j){p=0;r=0;i=F;I=H;while(1){k=i;i=f[t+(p<<3)>>2]|0;K=(f[s>>2]=i,+n[s>>2]);L=I;I=+n[t+(p<<3)+4>>2];if((!(L<=x)|!(I<=x)?!(L>x&I>x):0)?(N=(f[s>>2]=k,+n[s>>2]),!(N<w&K<w)):0){O=(K-N)*(x-L)-(I-L)*(w-N);if(O==0.0){y=0.0;break a}P=((I<L?-O:O)>0.0&1)+r|0}else if(x==I){if(w==K){y=0.0;break a}if(x==L){L=(f[s>>2]=k,+n[s>>2]);if(!(!(L<=w)|!(w<=K))){y=0.0;break a}if(!(!(K<=w)|!(w<=L))){y=0.0;break a}else P=r}else P=r}else P=r;p=p+1|0;if((p|0)>=(a|0)){Q=P;break}else r=P}}else{r=0;p=0;i=F;I=H;while(1){L=+(f[t+(r<<3)>>2]|0);K=I;I=+(f[t+(r<<3)+4>>2]|0);v=i;i=(n[s>>2]=L,f[s>>2]|0);if((!(K<=x)|!(I<=x)?!(K>x&I>x):0)?(O=(f[s>>2]=v,+n[s>>2]),!(O<w&L<w)):0){N=(L-O)*(x-K)-(I-K)*(w-O);if(N==0.0){y=0.0;break a}R=((I<K?-N:N)>0.0&1)+p|0}else if(x==I){if(w==L){y=0.0;break a}if(x==K){K=(f[s>>2]=v,+n[s>>2]);if(!(!(K<=w)|!(w<=L))){y=0.0;break a}if(!(!(L<=w)|!(w<=K))){y=0.0;break a}else R=p}else R=p}else R=p;r=r+1|0;if((r|0)>=(a|0)){Q=R;break}else p=R}}y=+((Q<<1&2)+-1|0);break}b:do if(j){I=3402823466385288598117041.0e14;K=1.0;p=0;r=0;i=F;v=G;while(1){q=i;i=f[t+(p<<3)>>2]|0;L=(f[s>>2]=i,+n[s>>2]);k=v;v=f[t+(p<<3)+4>>2]|0;N=(f[s>>2]=v,+n[s>>2]);O=(f[s>>2]=q,+n[s>>2]);S=L-O;T=(f[s>>2]=k,+n[s>>2]);U=N-T;V=U;W=w-O;X=x-T;Y=w-L;Z=x-N;do if(!(S*W+V*X<=0.0))if(!(S*Y+V*Z>=0.0)){_=S*X-V*W;$=S*S+V*V;aa=_*_;break}else{$=1.0;aa=Y*Y+Z*Z;break}else{$=1.0;aa=W*W+X*X}while(0);if(K*aa<I*$)if(aa==0.0){ba=aa;ca=$;da=r;break b}else{ea=aa;fa=$}else{ea=I;fa=K}if((!(T<=x)|!(N<=x)?!(T>x&N>x):0)?!(O<w&L<w):0){Z=S*X-V*W;ga=((U<0.0?-Z:Z)>0.0&1)+r|0}else ga=r;p=p+1|0;if((p|0)>=(a|0)){ba=ea;ca=fa;da=ga;break}else{I=ea;K=fa;r=ga}}}else{K=3402823466385288598117041.0e14;I=1.0;r=0;p=0;v=F;i=G;while(1){Z=+(f[t+(r<<3)>>2]|0);Y=+(f[t+(r<<3)+4>>2]|0);k=v;v=(n[s>>2]=Z,f[s>>2]|0);q=i;i=(n[s>>2]=Y,f[s>>2]|0);_=(f[s>>2]=k,+n[s>>2]);ha=Z-_;ia=(f[s>>2]=q,+n[s>>2]);ja=Y-ia;ka=ja;la=w-_;ma=x-ia;na=w-Z;oa=x-Y;do if(!(ha*la+ka*ma<=0.0))if(!(ha*na+ka*oa>=0.0)){pa=ha*ma-ka*la;qa=ha*ha+ka*ka;ra=pa*pa;break}else{qa=1.0;ra=na*na+oa*oa;break}else{qa=1.0;ra=la*la+ma*ma}while(0);if(I*ra<K*qa)if(ra==0.0){ba=ra;ca=qa;da=p;break b}else{sa=ra;ta=qa}else{sa=K;ta=I}if((!(ia<=x)|!(Y<=x)?!(ia>x&Y>x):0)?!(_<w&Z<w):0){oa=ha*ma-ka*la;ua=((ja<0.0?-oa:oa)>0.0&1)+p|0}else ua=p;r=r+1|0;if((r|0)>=(a|0)){ba=sa;ca=ta;da=ua;break}else{K=sa;I=ta;p=ua}}}while(0);I=+M(+(ba/ca));y=(da&1|0)==0?-I:I}while(0);da=g+36|0;ua=f[da>>2]|0;if(ua|0?(a=ua+12|0,ua=f[a>>2]|0,f[a>>2]=ua+-1,(ua|0)==1):0)_S(g);f[da>>2]=0;da=g+16|0;ua=g+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ua>>2]|0)>0){da=f[g+40>>2]|0;a=0;do{f[da+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[ua>>2]|0))}ua=f[g+44>>2]|0;if((ua|0)==(g+48|0)){u=e;return +y}g0(ua);u=e;return +y}function nha(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=h+8|0;k=(g|0)<0?(e|0)/2|0:g;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;g=tT(j,39)|0;l=258748;m=g+39|0;do{b[g>>0]=b[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(m|0));z5(-215,j,258788,258811,853)}l=(d&7|0)==0;if(!c){if(l){c=VDc(16)|0;Aqa(c);f[c>>2]=55116;f[c+4>>2]=e;f[c+8>>2]=k;g=VDc(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=55136;f[g+8>>2]=c;f[a>>2]=g;f[a+4>>2]=c;f[m>>2]=(f[m>>2]|0)+1;c=f[m>>2]|0;f[m>>2]=c+-1;if((c|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}switch(d&7){case 2:{g=VDc(16)|0;Aqa(g);f[g>>2]=55156;f[g+4>>2]=e;f[g+8>>2]=k;c=VDc(16)|0;m=c+4|0;f[m>>2]=1;f[c>>2]=55176;f[c+8>>2]=g;f[a>>2]=c;f[a+4>>2]=g;f[m>>2]=(f[m>>2]|0)+1;g=f[m>>2]|0;f[m>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 3:{c=VDc(16)|0;Aqa(c);f[c>>2]=55196;f[c+4>>2]=e;f[c+8>>2]=k;g=VDc(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=55216;f[g+8>>2]=c;f[a>>2]=g;f[a+4>>2]=c;f[m>>2]=(f[m>>2]|0)+1;c=f[m>>2]|0;f[m>>2]=c+-1;if((c|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}case 5:{g=VDc(16)|0;Aqa(g);f[g>>2]=55236;f[g+4>>2]=e;f[g+8>>2]=k;c=VDc(16)|0;m=c+4|0;f[m>>2]=1;f[c>>2]=55256;f[c+8>>2]=g;f[a>>2]=c;f[a+4>>2]=g;f[m>>2]=(f[m>>2]|0)+1;g=f[m>>2]|0;f[m>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 6:{c=VDc(16)|0;Aqa(c);f[c>>2]=55276;f[c+4>>2]=e;f[c+8>>2]=k;g=VDc(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=55296;f[g+8>>2]=c;f[a>>2]=g;f[a+4>>2]=c;f[m>>2]=(f[m>>2]|0)+1;c=f[m>>2]|0;f[m>>2]=c+-1;if((c|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}default:{f[i>>2]=d;F5(j,258878,i);z5(-213,j,258788,258811,891)}}}else{if(l){l=VDc(16)|0;Aqa(l);f[l>>2]=55316;f[l+4>>2]=e;f[l+8>>2]=k;g=VDc(16)|0;c=g+4|0;f[c>>2]=1;f[g>>2]=55336;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[c>>2]=(f[c>>2]|0)+1;l=f[c>>2]|0;f[c>>2]=l+-1;if((l|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}switch(d&7){case 2:{g=VDc(16)|0;Aqa(g);f[g>>2]=55356;f[g+4>>2]=e;f[g+8>>2]=k;l=VDc(16)|0;c=l+4|0;f[c>>2]=1;f[l>>2]=55376;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[c>>2]=(f[c>>2]|0)+1;g=f[c>>2]|0;f[c>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=h;return}case 3:{l=VDc(16)|0;Aqa(l);f[l>>2]=55396;f[l+4>>2]=e;f[l+8>>2]=k;g=VDc(16)|0;c=g+4|0;f[c>>2]=1;f[g>>2]=55416;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[c>>2]=(f[c>>2]|0)+1;l=f[c>>2]|0;f[c>>2]=l+-1;if((l|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}case 5:{g=VDc(16)|0;Aqa(g);f[g>>2]=55436;f[g+4>>2]=e;f[g+8>>2]=k;l=VDc(16)|0;c=l+4|0;f[c>>2]=1;f[l>>2]=55456;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[c>>2]=(f[c>>2]|0)+1;g=f[c>>2]|0;f[c>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=h;return}case 6:{l=VDc(16)|0;Aqa(l);f[l>>2]=55476;f[l+4>>2]=e;f[l+8>>2]=k;k=VDc(16)|0;e=k+4|0;f[e>>2]=1;f[k>>2]=55496;f[k+8>>2]=l;f[a>>2]=k;f[a+4>>2]=l;f[e>>2]=(f[e>>2]|0)+1;l=f[e>>2]|0;f[e>>2]=l+-1;if((l|0)!=1){u=h;return}Yi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}default:{f[i>>2]=d;F5(j,258878,i);z5(-213,j,258788,258811,891)}}}}function oha(a){a=a|0;YDc(a);return}function pha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function qha(a){a=a|0;YDc(a);return}function rha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{p[c+(h<<3)>>3]=+p[b+(h<<3)>>3];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)n=0;else{o=0;while(1){q=c+(o<<3)|0;r=+p[q+(e<<3)>>3];s=+p[q>>3];p[l+(o<<3)>>3]=r<s?s:r;s=+p[q+(h<<3)>>3];p[l+(o+e<<3)>>3]=r<s?s:r;q=o+h|0;if((q|0)>(d|0)){m=q;break a}else o=q}}while(1){o=c+(n<<3)|0;r=+p[o+(e<<3)>>3];q=h;do{s=+p[o+(q<<3)>>3];r=r<s?s:r;q=q+e|0}while((q|0)<(g|0));s=+p[o>>3];p[l+(n<<3)>>3]=r<s?s:r;s=+p[o+(q<<3)>>3];p[l+(n+e<<3)>>3]=r<s?s:r;t=n+h|0;if((t|0)>(d|0)){m=t;break}else n=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){p[l+(t<<3)>>3]=+p[c+(t<<3)>>3];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<3)|0;s=+p[t>>3];v=e;do{w=+p[t+(v<<3)>>3];s=s<w?w:s;v=v+e|0}while((v|0)<(g|0));p[l+(u<<3)>>3]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+8|0;c=c+8|0}}return}function sha(a){a=a|0;YDc(a);return}function tha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uha(a){a=a|0;YDc(a);return}function vha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{f[c+(h<<2)>>2]=f[b+(h<<2)>>2];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)o=0;else{p=0;while(1){q=c+(p<<2)|0;r=+n[q+(e<<2)>>2];s=+n[q>>2];n[l+(p<<2)>>2]=r<s?s:r;s=+n[q+(h<<2)>>2];n[l+(p+e<<2)>>2]=r<s?s:r;q=p+h|0;if((q|0)>(d|0)){m=q;break a}else p=q}}while(1){p=c+(o<<2)|0;r=+n[p+(e<<2)>>2];q=h;do{s=+n[p+(q<<2)>>2];r=r<s?s:r;q=q+e|0}while((q|0)<(g|0));s=+n[p>>2];n[l+(o<<2)>>2]=r<s?s:r;s=+n[p+(q<<2)>>2];n[l+(o+e<<2)>>2]=r<s?s:r;t=o+h|0;if((t|0)>(d|0)){m=t;break}else o=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){f[l+(t<<2)>>2]=f[c+(t<<2)>>2];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<2)|0;s=+n[t>>2];v=e;do{w=+n[t+(v<<2)>>2];s=s<w?w:s;v=v+e|0}while((v|0)<(g|0));n[l+(u<<2)>>2]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+4|0;c=c+4|0}}return}function wha(a){a=a|0;YDc(a);return}function xha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function yha(a){a=a|0;YDc(a);return}function zha(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=r<<16>>16<s<<16>>16?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=r<<16>>16<s<<16>>16?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=r<<16>>16<q<<16>>16?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=r<<16>>16<q<<16>>16?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=r<<16>>16<q<<16>>16?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=u<<16>>16<w<<16>>16?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function Aha(a){a=a|0;YDc(a);return}function Bha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Cha(a){a=a|0;YDc(a);return}function Dha(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=(r&65535)<(s&65535)?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=(r&65535)<(s&65535)?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=(r&65535)<(q&65535)?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=(r&65535)<(q&65535)?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=(r&65535)<(q&65535)?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=(u&65535)<(w&65535)?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function Eha(a){a=a|0;YDc(a);return}function Fha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Gha(a){a=a|0;YDc(a);return}function Hha(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((i|0)==(g|0)){if((a|0)>0)j=0;else return;do{b[d+j>>0]=b[c+j>>0]|0;j=j+1|0}while((j|0)!=(a|0));return}if((g|0)<=0)return;j=g<<1;e=a-j|0;k=(e|0)<0;l=(i|0)>(g|0);m=(j|0)<(i|0);n=d;d=c;c=0;while(1){a:do if(k)o=0;else{if(m)p=0;else{q=0;while(1){r=d+q|0;s=h[r+g>>0]|0;t=(h[r>>0]|0)-s+256|0;if(t>>>0<769)u=h[271964+t>>0]|0;else u=0;b[n+q>>0]=u+s;t=(h[r+j>>0]|0)-s+256|0;if(t>>>0<769)v=h[271964+t>>0]|0;else v=0;b[n+(q+g)>>0]=v+s;s=q+j|0;if((s|0)>(e|0)){o=s;break a}else q=s}}while(1){q=d+p|0;s=b[q+g>>0]|0;t=j;while(1){r=s&255;w=(h[q+t>>0]|0)-r+256|0;if(w>>>0<769)x=h[271964+w>>0]|0;else x=0;y=x+r|0;t=t+g|0;if((t|0)>=(i|0))break;else s=y&255}s=y&255;r=(h[q>>0]|0)-s+256|0;if(r>>>0<769)z=h[271964+r>>0]|0;else z=0;b[n+p>>0]=z+y;r=(h[q+t>>0]|0)-s+256|0;if(r>>>0<769)A=h[271964+r>>0]|0;else A=0;b[n+(p+g)>>0]=A+y;r=p+j|0;if((r|0)>(e|0)){o=r;break}else p=r}}while(0);b:do if((o|0)<(a|0)){if(l)B=o;else{r=o;while(1){b[n+r>>0]=b[d+r>>0]|0;r=r+g|0;if((r|0)>=(a|0))break b}}do{r=d+B|0;s=b[r>>0]|0;w=g;do{C=s&255;D=(h[r+w>>0]|0)-C+256|0;if(D>>>0<769)E=h[271964+D>>0]|0;else E=0;s=E+C&255;w=w+g|0}while((w|0)<(i|0));b[n+B>>0]=s;B=B+g|0}while((B|0)<(a|0))}while(0);c=c+1|0;if((c|0)==(g|0))break;else{n=n+1|0;d=d+1|0}}return}function Iha(a){a=a|0;YDc(a);return}function Jha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Kha(a){a=a|0;YDc(a);return}function Lha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{p[c+(h<<3)>>3]=+p[b+(h<<3)>>3];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)n=0;else{o=0;while(1){q=c+(o<<3)|0;r=+p[q+(e<<3)>>3];s=+p[q>>3];p[l+(o<<3)>>3]=s<r?s:r;s=+p[q+(h<<3)>>3];p[l+(o+e<<3)>>3]=s<r?s:r;q=o+h|0;if((q|0)>(d|0)){m=q;break a}else o=q}}while(1){o=c+(n<<3)|0;r=+p[o+(e<<3)>>3];q=h;do{s=+p[o+(q<<3)>>3];r=s<r?s:r;q=q+e|0}while((q|0)<(g|0));s=+p[o>>3];p[l+(n<<3)>>3]=s<r?s:r;s=+p[o+(q<<3)>>3];p[l+(n+e<<3)>>3]=s<r?s:r;t=n+h|0;if((t|0)>(d|0)){m=t;break}else n=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){p[l+(t<<3)>>3]=+p[c+(t<<3)>>3];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<3)|0;s=+p[t>>3];v=e;do{w=+p[t+(v<<3)>>3];s=w<s?w:s;v=v+e|0}while((v|0)<(g|0));p[l+(u<<3)>>3]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+8|0;c=c+8|0}}return}function Mha(a){a=a|0;YDc(a);return}function Nha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Oha(a){a=a|0;YDc(a);return}function Pha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{f[c+(h<<2)>>2]=f[b+(h<<2)>>2];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)o=0;else{p=0;while(1){q=c+(p<<2)|0;r=+n[q+(e<<2)>>2];s=+n[q>>2];n[l+(p<<2)>>2]=s<r?s:r;s=+n[q+(h<<2)>>2];n[l+(p+e<<2)>>2]=s<r?s:r;q=p+h|0;if((q|0)>(d|0)){m=q;break a}else p=q}}while(1){p=c+(o<<2)|0;r=+n[p+(e<<2)>>2];q=h;do{s=+n[p+(q<<2)>>2];r=s<r?s:r;q=q+e|0}while((q|0)<(g|0));s=+n[p>>2];n[l+(o<<2)>>2]=s<r?s:r;s=+n[p+(q<<2)>>2];n[l+(o+e<<2)>>2]=s<r?s:r;t=o+h|0;if((t|0)>(d|0)){m=t;break}else o=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){f[l+(t<<2)>>2]=f[c+(t<<2)>>2];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<2)|0;s=+n[t>>2];v=e;do{w=+n[t+(v<<2)>>2];s=w<s?w:s;v=v+e|0}while((v|0)<(g|0));n[l+(u<<2)>>2]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+4|0;c=c+4|0}}return}function Qha(a){a=a|0;YDc(a);return}function Rha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sha(a){a=a|0;YDc(a);return}function Tha(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=s<<16>>16<r<<16>>16?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=s<<16>>16<r<<16>>16?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=q<<16>>16<r<<16>>16?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=q<<16>>16<r<<16>>16?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=q<<16>>16<r<<16>>16?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=w<<16>>16<u<<16>>16?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function Uha(a){a=a|0;YDc(a);return}function Vha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Wha(a){a=a|0;YDc(a);return}function Xha(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=(s&65535)<(r&65535)?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=(s&65535)<(r&65535)?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=(q&65535)<(r&65535)?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=(q&65535)<(r&65535)?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=(q&65535)<(r&65535)?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=(w&65535)<(u&65535)?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function Yha(a){a=a|0;YDc(a);return}function Zha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _ha(a){a=a|0;YDc(a);return}function $ha(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((i|0)==(g|0)){if((a|0)>0)j=0;else return;do{b[d+j>>0]=b[c+j>>0]|0;j=j+1|0}while((j|0)!=(a|0));return}if((g|0)<=0)return;j=g<<1;e=a-j|0;k=(e|0)<0;l=(i|0)>(g|0);m=(j|0)<(i|0);n=d;d=c;c=0;while(1){a:do if(k)o=0;else{if(m)p=0;else{q=0;while(1){r=d+q|0;s=h[r+g>>0]|0;t=s-(h[r>>0]|0)+256|0;if(t>>>0<769)u=h[271964+t>>0]|0;else u=0;b[n+q>>0]=s-u;t=s-(h[r+j>>0]|0)+256|0;if(t>>>0<769)v=h[271964+t>>0]|0;else v=0;b[n+(q+g)>>0]=s-v;s=q+j|0;if((s|0)>(e|0)){o=s;break a}else q=s}}while(1){q=d+p|0;s=b[q+g>>0]|0;t=j;while(1){r=s&255;w=r-(h[q+t>>0]|0)+256|0;if(w>>>0<769)x=h[271964+w>>0]|0;else x=0;y=r-x|0;t=t+g|0;if((t|0)>=(i|0))break;else s=y&255}s=y&255;r=s-(h[q>>0]|0)+256|0;if(r>>>0<769)z=h[271964+r>>0]|0;else z=0;b[n+p>>0]=y-z;r=s-(h[q+t>>0]|0)+256|0;if(r>>>0<769)A=h[271964+r>>0]|0;else A=0;b[n+(p+g)>>0]=y-A;r=p+j|0;if((r|0)>(e|0)){o=r;break}else p=r}}while(0);b:do if((o|0)<(a|0)){if(l)B=o;else{r=o;while(1){b[n+r>>0]=b[d+r>>0]|0;r=r+g|0;if((r|0)>=(a|0))break b}}do{r=d+B|0;s=b[r>>0]|0;w=g;do{C=s&255;D=C-(h[r+w>>0]|0)+256|0;if(D>>>0<769)E=h[271964+D>>0]|0;else E=0;s=C-E&255;w=w+g|0}while((w|0)<(i|0));b[n+B>>0]=s;B=B+g|0}while((B|0)<(a|0))}while(0);c=c+1|0;if((c|0)==(g|0))break;else{n=n+1|0;d=d+1|0}}return}function aia(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=h+8|0;k=(g|0)<0?(e|0)/2|0:g;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;g=tT(j,39)|0;l=258748;m=g+39|0;do{b[g>>0]=b[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(m|0));z5(-215,j,260546,258811,899)}l=(d&7|0)==0;if(!c){if(l){c=VDc(16)|0;Bqa(c);f[c>>2]=55516;f[c+4>>2]=e;f[c+8>>2]=k;g=VDc(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=55540;f[g+8>>2]=c;f[a>>2]=g;f[a+4>>2]=c;f[m>>2]=(f[m>>2]|0)+1;c=f[m>>2]|0;f[m>>2]=c+-1;if((c|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}switch(d&7){case 2:{g=VDc(16)|0;Bqa(g);f[g>>2]=55560;f[g+4>>2]=e;f[g+8>>2]=k;c=VDc(16)|0;m=c+4|0;f[m>>2]=1;f[c>>2]=55584;f[c+8>>2]=g;f[a>>2]=c;f[a+4>>2]=g;f[m>>2]=(f[m>>2]|0)+1;g=f[m>>2]|0;f[m>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 3:{c=VDc(16)|0;Bqa(c);f[c>>2]=55604;f[c+4>>2]=e;f[c+8>>2]=k;g=VDc(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=55628;f[g+8>>2]=c;f[a>>2]=g;f[a+4>>2]=c;f[m>>2]=(f[m>>2]|0)+1;c=f[m>>2]|0;f[m>>2]=c+-1;if((c|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}case 5:{g=VDc(16)|0;Bqa(g);f[g>>2]=55648;f[g+4>>2]=e;f[g+8>>2]=k;c=VDc(16)|0;m=c+4|0;f[m>>2]=1;f[c>>2]=55672;f[c+8>>2]=g;f[a>>2]=c;f[a+4>>2]=g;f[m>>2]=(f[m>>2]|0)+1;g=f[m>>2]|0;f[m>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 6:{c=VDc(16)|0;Bqa(c);f[c>>2]=55692;f[c+4>>2]=e;f[c+8>>2]=k;g=VDc(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=55716;f[g+8>>2]=c;f[a>>2]=g;f[a+4>>2]=c;f[m>>2]=(f[m>>2]|0)+1;c=f[m>>2]|0;f[m>>2]=c+-1;if((c|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}default:{f[i>>2]=d;F5(j,258878,i);z5(-213,j,260546,258811,937)}}}else{if(l){l=VDc(16)|0;Bqa(l);f[l>>2]=55736;f[l+4>>2]=e;f[l+8>>2]=k;g=VDc(16)|0;c=g+4|0;f[c>>2]=1;f[g>>2]=55760;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[c>>2]=(f[c>>2]|0)+1;l=f[c>>2]|0;f[c>>2]=l+-1;if((l|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}switch(d&7){case 2:{g=VDc(16)|0;Bqa(g);f[g>>2]=55780;f[g+4>>2]=e;f[g+8>>2]=k;l=VDc(16)|0;c=l+4|0;f[c>>2]=1;f[l>>2]=55804;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[c>>2]=(f[c>>2]|0)+1;g=f[c>>2]|0;f[c>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=h;return}case 3:{l=VDc(16)|0;Bqa(l);f[l>>2]=55824;f[l+4>>2]=e;f[l+8>>2]=k;g=VDc(16)|0;c=g+4|0;f[c>>2]=1;f[g>>2]=55848;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[c>>2]=(f[c>>2]|0)+1;l=f[c>>2]|0;f[c>>2]=l+-1;if((l|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}case 5:{g=VDc(16)|0;Bqa(g);f[g>>2]=55868;f[g+4>>2]=e;f[g+8>>2]=k;l=VDc(16)|0;c=l+4|0;f[c>>2]=1;f[l>>2]=55892;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[c>>2]=(f[c>>2]|0)+1;g=f[c>>2]|0;f[c>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=h;return}case 6:{l=VDc(16)|0;Bqa(l);f[l>>2]=55912;f[l+4>>2]=e;f[l+8>>2]=k;k=VDc(16)|0;e=k+4|0;f[e>>2]=1;f[k>>2]=55936;f[k+8>>2]=l;f[a>>2]=k;f[a+4>>2]=l;f[e>>2]=(f[e>>2]|0)+1;l=f[e>>2]|0;f[e>>2]=l+-1;if((l|0)!=1){u=h;return}Yi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}default:{f[i>>2]=d;F5(j,258878,i);z5(-213,j,260546,258811,937)}}}}function bia(a){a=a|0;YDc(a);return}function cia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dia(a){a=a|0;YDc(a);return}function eia(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>3;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;n=c;o=b;q=e;while(1){a:do if(j)r=0;else{s=f[o+4>>2]|0;t=f[o>>2]|0;if(!k){u=f[o+8>>2]|0;v=0;while(1){w=s+(v<<3)|0;x=+p[w>>3];y=+p[w+8>>3];z=+p[w+16>>3];A=+p[w+24>>3];w=t+(v<<3)|0;B=+p[w>>3];p[n+(v<<3)>>3]=x<B?B:x;B=+p[w+8>>3];p[n+((v|1)<<3)>>3]=y<B?B:y;B=+p[w+16>>3];p[n+((v|2)<<3)>>3]=z<B?B:z;B=+p[w+24>>3];p[n+((v|3)<<3)>>3]=A<B?B:A;w=u+(v<<3)|0;B=+p[w>>3];C=v+a|0;p[n+(C<<3)>>3]=x<B?B:x;x=+p[w+8>>3];p[n+(C+1<<3)>>3]=y<x?x:y;y=+p[w+16>>3];p[n+(C+2<<3)>>3]=z<y?y:z;z=+p[w+24>>3];p[n+(C+3<<3)>>3]=A<z?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[o+(h<<2)>>2]|0;u=0;do{C=s+(u<<3)|0;A=+p[C+24>>3];z=+p[C+16>>3];y=+p[C+8>>3];x=+p[C>>3];C=2;do{w=(f[o+(C<<2)>>2]|0)+(u<<3)|0;B=+p[w>>3];x=x<B?B:x;B=+p[w+8>>3];y=y<B?B:y;B=+p[w+16>>3];z=z<B?B:z;B=+p[w+24>>3];A=A<B?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<3)|0;B=+p[C>>3];p[n+(u<<3)>>3]=x<B?B:x;B=+p[C+8>>3];p[n+((u|1)<<3)>>3]=y<B?B:y;B=+p[C+16>>3];p[n+((u|2)<<3)>>3]=z<B?B:z;B=+p[C+24>>3];p[n+((u|3)<<3)>>3]=A<B?B:A;C=v+(u<<3)|0;B=+p[C>>3];w=u+a|0;p[n+(w<<3)>>3]=x<B?B:x;B=+p[C+8>>3];p[n+(w+1<<3)>>3]=y<B?B:y;B=+p[C+16>>3];p[n+(w+2<<3)>>3]=z<B?B:z;B=+p[C+24>>3];p[n+(w+3<<3)>>3]=A<B?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[o+4>>2]|0;v=f[o>>2]|0;if(!k){t=f[o+8>>2]|0;s=r;while(1){B=+p[u+(s<<3)>>3];D=+p[v+(s<<3)>>3];p[n+(s<<3)>>3]=B<D?D:B;D=+p[t+(s<<3)>>3];p[n+(s+a<<3)>>3]=B<D?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[o+(h<<2)>>2]|0;t=r;do{B=+p[u+(t<<3)>>3];w=2;do{D=+p[(f[o+(w<<2)>>2]|0)+(t<<3)>>3];B=B<D?D:B;w=w+1|0}while((w|0)!=(h|0));A=+p[v+(t<<3)>>3];p[n+(t<<3)>>3]=B<A?A:B;A=+p[s+(t<<3)>>3];p[n+(t+a<<3)>>3]=B<A?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=n+(l<<3)|0;v=o+8|0;if((t|0)>1){n=s;o=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{o=0;while(1){n=E+(o<<3)|0;A=+p[n+8>>3];z=+p[n+16>>3];y=+p[n+24>>3];p[G+(o<<3)>>3]=+p[n>>3];p[G+((o|1)<<3)>>3]=A;p[G+((o|2)<<3)>>3]=z;p[G+((o|3)<<3)>>3]=y;o=o+4|0;if((o|0)>(e|0)){H=c;break c}}}do{o=E+(I<<3)|0;y=+p[o+24>>3];z=+p[o+16>>3];A=+p[o+8>>3];x=+p[o>>3];o=1;do{n=(f[q+(o<<2)>>2]|0)+(I<<3)|0;D=+p[n>>3];x=x<D?D:x;D=+p[n+8>>3];A=A<D?D:A;D=+p[n+16>>3];z=z<D?D:z;D=+p[n+24>>3];y=y<D?D:y;o=o+1|0}while((o|0)!=(h|0));p[G+(I<<3)>>3]=x;p[G+((I|1)<<3)>>3]=A;p[G+((I|2)<<3)>>3]=z;p[G+((I|3)<<3)>>3]=y;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{o=H;while(1){p[G+(o<<3)>>3]=+p[E+(o<<3)>>3];o=o+1|0;if((o|0)==(g|0))break d}}do{B=+p[E+(J<<3)>>3];o=1;do{D=+p[(f[q+(o<<2)>>2]|0)+(J<<3)>>3];B=B<D?D:B;o=o+1|0}while((o|0)!=(h|0));p[G+(J<<3)>>3]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<3)|0}else break}return}function fia(a){a=a|0;YDc(a);return}function gia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hia(a){a=a|0;YDc(a);return}function iia(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>2;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;o=c;p=b;q=e;while(1){a:do if(j)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!k){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<2)|0;x=+n[w>>2];y=+n[w+4>>2];z=+n[w+8>>2];A=+n[w+12>>2];w=t+(v<<2)|0;B=+n[w>>2];n[o+(v<<2)>>2]=x<B?B:x;B=+n[w+4>>2];n[o+((v|1)<<2)>>2]=y<B?B:y;B=+n[w+8>>2];n[o+((v|2)<<2)>>2]=z<B?B:z;B=+n[w+12>>2];n[o+((v|3)<<2)>>2]=A<B?B:A;w=u+(v<<2)|0;B=+n[w>>2];C=v+a|0;n[o+(C<<2)>>2]=x<B?B:x;x=+n[w+4>>2];n[o+(C+1<<2)>>2]=y<x?x:y;y=+n[w+8>>2];n[o+(C+2<<2)>>2]=z<y?y:z;z=+n[w+12>>2];n[o+(C+3<<2)>>2]=A<z?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[p+(h<<2)>>2]|0;u=0;do{C=s+(u<<2)|0;A=+n[C+12>>2];z=+n[C+8>>2];y=+n[C+4>>2];x=+n[C>>2];C=2;do{w=(f[p+(C<<2)>>2]|0)+(u<<2)|0;B=+n[w>>2];x=x<B?B:x;B=+n[w+4>>2];y=y<B?B:y;B=+n[w+8>>2];z=z<B?B:z;B=+n[w+12>>2];A=A<B?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<2)|0;B=+n[C>>2];n[o+(u<<2)>>2]=x<B?B:x;B=+n[C+4>>2];n[o+((u|1)<<2)>>2]=y<B?B:y;B=+n[C+8>>2];n[o+((u|2)<<2)>>2]=z<B?B:z;B=+n[C+12>>2];n[o+((u|3)<<2)>>2]=A<B?B:A;C=v+(u<<2)|0;B=+n[C>>2];w=u+a|0;n[o+(w<<2)>>2]=x<B?B:x;B=+n[C+4>>2];n[o+(w+1<<2)>>2]=y<B?B:y;B=+n[C+8>>2];n[o+(w+2<<2)>>2]=z<B?B:z;B=+n[C+12>>2];n[o+(w+3<<2)>>2]=A<B?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!k){t=f[p+8>>2]|0;s=r;while(1){B=+n[u+(s<<2)>>2];D=+n[v+(s<<2)>>2];n[o+(s<<2)>>2]=B<D?D:B;D=+n[t+(s<<2)>>2];n[o+(s+a<<2)>>2]=B<D?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[p+(h<<2)>>2]|0;t=r;do{B=+n[u+(t<<2)>>2];w=2;do{D=+n[(f[p+(w<<2)>>2]|0)+(t<<2)>>2];B=B<D?D:B;w=w+1|0}while((w|0)!=(h|0));A=+n[v+(t<<2)>>2];n[o+(t<<2)>>2]=B<A?A:B;A=+n[s+(t<<2)>>2];n[o+(t+a<<2)>>2]=B<A?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=o+(l<<2)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{p=0;while(1){o=E+(p<<2)|0;l=f[o+4>>2]|0;r=f[o+8>>2]|0;k=f[o+12>>2]|0;f[G+(p<<2)>>2]=f[o>>2];f[G+((p|1)<<2)>>2]=l;f[G+((p|2)<<2)>>2]=r;f[G+((p|3)<<2)>>2]=k;p=p+4|0;if((p|0)>(e|0)){H=c;break c}}}do{p=E+(I<<2)|0;A=+n[p+12>>2];z=+n[p+8>>2];y=+n[p+4>>2];x=+n[p>>2];p=1;do{k=(f[q+(p<<2)>>2]|0)+(I<<2)|0;D=+n[k>>2];x=x<D?D:x;D=+n[k+4>>2];y=y<D?D:y;D=+n[k+8>>2];z=z<D?D:z;D=+n[k+12>>2];A=A<D?D:A;p=p+1|0}while((p|0)!=(h|0));n[G+(I<<2)>>2]=x;n[G+((I|1)<<2)>>2]=y;n[G+((I|2)<<2)>>2]=z;n[G+((I|3)<<2)>>2]=A;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{p=H;while(1){f[G+(p<<2)>>2]=f[E+(p<<2)>>2];p=p+1|0;if((p|0)==(g|0))break d}}do{B=+n[E+(J<<2)>>2];p=1;do{D=+n[(f[q+(p<<2)>>2]|0)+(J<<2)>>2];B=B<D?D:B;p=p+1|0}while((p|0)!=(h|0));n[G+(J<<2)>>2]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<2)|0}else break}return}function jia(a){a=a|0;YDc(a);return}function kia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function lia(a){a=a|0;YDc(a);return}function mia(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=x<<16>>16<B<<16>>16?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=y<<16>>16<B<<16>>16?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=z<<16>>16<B<<16>>16?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=A<<16>>16<B<<16>>16?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=x<<16>>16<w<<16>>16?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=y<<16>>16<x<<16>>16?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=z<<16>>16<y<<16>>16?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=A<<16>>16<z<<16>>16?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=y<<16>>16<w<<16>>16?w:y;w=d[x+2>>1]|0;B=B<<16>>16<w<<16>>16?w:B;w=d[x+4>>1]|0;C=C<<16>>16<w<<16>>16?w:C;w=d[x+6>>1]|0;z=z<<16>>16<w<<16>>16?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=y<<16>>16<w<<16>>16?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=B<<16>>16<w<<16>>16?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=C<<16>>16<w<<16>>16?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=z<<16>>16<w<<16>>16?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=y<<16>>16<A<<16>>16?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=B<<16>>16<A<<16>>16?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=C<<16>>16<A<<16>>16?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=z<<16>>16<A<<16>>16?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=A<<16>>16<x<<16>>16?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=A<<16>>16<x<<16>>16?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=A<<16>>16<w<<16>>16?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=A<<16>>16<x<<16>>16?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=A<<16>>16<x<<16>>16?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=o<<16>>16<j<<16>>16?j:o;j=d[n+2>>1]|0;m=m<<16>>16<j<<16>>16?j:m;j=d[n+4>>1]|0;r=r<<16>>16<j<<16>>16?j:r;j=d[n+6>>1]|0;l=l<<16>>16<j<<16>>16?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=p<<16>>16<j<<16>>16?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function nia(a){a=a|0;YDc(a);return}function oia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pia(a){a=a|0;YDc(a);return}function qia(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=(x&65535)<(B&65535)?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=(y&65535)<(B&65535)?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=(z&65535)<(B&65535)?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=(A&65535)<(B&65535)?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=(x&65535)<(w&65535)?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=(y&65535)<(x&65535)?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=(z&65535)<(y&65535)?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=(A&65535)<(z&65535)?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=(y&65535)<(w&65535)?w:y;w=d[x+2>>1]|0;B=(B&65535)<(w&65535)?w:B;w=d[x+4>>1]|0;C=(C&65535)<(w&65535)?w:C;w=d[x+6>>1]|0;z=(z&65535)<(w&65535)?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=(y&65535)<(w&65535)?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=(B&65535)<(w&65535)?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=(C&65535)<(w&65535)?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=(z&65535)<(w&65535)?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=(y&65535)<(A&65535)?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=(B&65535)<(A&65535)?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=(C&65535)<(A&65535)?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=(z&65535)<(A&65535)?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(A&65535)<(x&65535)?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=(A&65535)<(x&65535)?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=(A&65535)<(w&65535)?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=(A&65535)<(x&65535)?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=(A&65535)<(x&65535)?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=(o&65535)<(j&65535)?j:o;j=d[n+2>>1]|0;m=(m&65535)<(j&65535)?j:m;j=d[n+4>>1]|0;r=(r&65535)<(j&65535)?j:r;j=d[n+6>>1]|0;l=(l&65535)<(j&65535)?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=(p&65535)<(j&65535)?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function ria(a){a=a|0;YDc(a);return}function sia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tia(a){a=a|0;YDc(a);return}function uia(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=f[a+4>>2]|0;a=(j|0)>1;if(a&(g|0)>1){k=i+-4|0;l=(i|0)<4;m=(j|0)>2;n=e<<1;o=i&-4;p=d;q=c;r=g;while(1){if(l)s=0;else{t=q+4|0;u=0;do{v=(f[t>>2]|0)+u|0;w=b[v>>0]|0;x=b[v+1>>0]|0;y=b[v+2>>0]|0;z=b[v+3>>0]|0;if(m){v=z;A=y;B=x;C=w;D=2;while(1){E=(f[q+(D<<2)>>2]|0)+u|0;F=C&255;G=(h[E>>0]|0)-F+256|0;if(G>>>0<769)H=h[271964+G>>0]|0;else H=0;G=H+F&255;F=B&255;I=(h[E+1>>0]|0)-F+256|0;if(I>>>0<769)J=h[271964+I>>0]|0;else J=0;I=J+F&255;F=A&255;K=(h[E+2>>0]|0)-F+256|0;if(K>>>0<769)L=h[271964+K>>0]|0;else L=0;K=L+F&255;F=v&255;M=(h[E+3>>0]|0)-F+256|0;if(M>>>0<769)N=h[271964+M>>0]|0;else N=0;M=N+F&255;D=D+1|0;if((D|0)==(j|0)){O=M;P=K;Q=I;R=G;S=j;break}else{v=M;A=K;B=I;C=G}}}else{O=z;P=y;Q=x;R=w;S=2}C=(f[q>>2]|0)+u|0;B=R&255;A=(h[C>>0]|0)-B+256|0;if(A>>>0<769)T=h[271964+A>>0]|0;else T=0;b[p+u>>0]=T+B;A=Q&255;v=(h[C+1>>0]|0)-A+256|0;if(v>>>0<769)U=h[271964+v>>0]|0;else U=0;b[p+(u|1)>>0]=U+A;v=P&255;D=(h[C+2>>0]|0)-v+256|0;if(D>>>0<769)V=h[271964+D>>0]|0;else V=0;b[p+(u|2)>>0]=V+v;D=O&255;G=(h[C+3>>0]|0)-D+256|0;if(G>>>0<769)W=h[271964+G>>0]|0;else W=0;b[p+(u|3)>>0]=W+D;G=(f[q+(S<<2)>>2]|0)+u|0;C=(h[G>>0]|0)-B+256|0;if(C>>>0<769)X=h[271964+C>>0]|0;else X=0;C=u+e|0;b[p+C>>0]=X+B;B=(h[G+1>>0]|0)-A+256|0;if(B>>>0<769)Y=h[271964+B>>0]|0;else Y=0;b[p+(C+1)>>0]=Y+A;A=(h[G+2>>0]|0)-v+256|0;if(A>>>0<769)Z=h[271964+A>>0]|0;else Z=0;b[p+(C+2)>>0]=Z+v;v=(h[G+3>>0]|0)-D+256|0;if(v>>>0<769)_=h[271964+v>>0]|0;else _=0;b[p+(C+3)>>0]=_+D;u=u+4|0}while((u|0)<=(k|0));s=o}a:do if((s|0)<(i|0)){u=q+4|0;if(!m){t=q+8|0;D=s;while(1){C=h[(f[u>>2]|0)+D>>0]|0;v=(h[(f[q>>2]|0)+D>>0]|0)-C+256|0;if(v>>>0<769)$=h[271964+v>>0]|0;else $=0;b[p+D>>0]=$+C;v=(h[(f[t>>2]|0)+D>>0]|0)-C+256|0;if(v>>>0<769)aa=h[271964+v>>0]|0;else aa=0;b[p+(D+e)>>0]=aa+C;D=D+1|0;if((D|0)==(i|0))break a}}D=q+(j<<2)|0;t=s;do{w=b[(f[u>>2]|0)+t>>0]|0;x=2;while(1){y=w&255;z=(h[(f[q+(x<<2)>>2]|0)+t>>0]|0)-y+256|0;if(z>>>0<769)ba=h[271964+z>>0]|0;else ba=0;ca=ba+y|0;x=x+1|0;if((x|0)==(j|0))break;else w=ca&255}w=ca&255;x=(h[(f[q>>2]|0)+t>>0]|0)-w+256|0;if(x>>>0<769)da=h[271964+x>>0]|0;else da=0;b[p+t>>0]=da+ca;x=(h[(f[D>>2]|0)+t>>0]|0)-w+256|0;if(x>>>0<769)ea=h[271964+x>>0]|0;else ea=0;b[p+(t+e)>>0]=ea+ca;t=t+1|0}while((t|0)!=(i|0))}while(0);t=r+-2|0;D=p+n|0;u=q+8|0;if((t|0)>1){p=D;q=u;r=t}else{fa=D;ga=u;ha=t;break}}}else{fa=d;ga=c;ha=g}if((ha|0)<=0)return;g=i+-4|0;c=(i|0)<4;d=i&-4;r=ga;ga=ha;ha=fa;while(1){b:do if(c)ia=0;else{if(a)ja=0;else{fa=0;while(1){q=(f[r>>2]|0)+fa|0;p=b[q+1>>0]|0;n=b[q+2>>0]|0;ca=b[q+3>>0]|0;b[ha+fa>>0]=b[q>>0]|0;b[ha+(fa|1)>>0]=p;b[ha+(fa|2)>>0]=n;b[ha+(fa|3)>>0]=ca;fa=fa+4|0;if((fa|0)>(g|0)){ia=d;break b}}}do{fa=(f[r>>2]|0)+ja|0;ca=b[fa+3>>0]|0;n=b[fa+2>>0]|0;p=b[fa+1>>0]|0;q=b[fa>>0]|0;fa=1;do{ea=(f[r+(fa<<2)>>2]|0)+ja|0;da=q&255;ba=(h[ea>>0]|0)-da+256|0;if(ba>>>0<769)ka=h[271964+ba>>0]|0;else ka=0;q=ka+da&255;da=p&255;ba=(h[ea+1>>0]|0)-da+256|0;if(ba>>>0<769)la=h[271964+ba>>0]|0;else la=0;p=la+da&255;da=n&255;ba=(h[ea+2>>0]|0)-da+256|0;if(ba>>>0<769)ma=h[271964+ba>>0]|0;else ma=0;n=ma+da&255;da=ca&255;ba=(h[ea+3>>0]|0)-da+256|0;if(ba>>>0<769)na=h[271964+ba>>0]|0;else na=0;ca=na+da&255;fa=fa+1|0}while((fa|0)!=(j|0));b[ha+ja>>0]=q;b[ha+(ja|1)>>0]=p;b[ha+(ja|2)>>0]=n;b[ha+(ja|3)>>0]=ca;ja=ja+4|0}while((ja|0)<=(g|0));ia=d}while(0);c:do if((ia|0)<(i|0)){if(a)oa=ia;else{fa=ia;while(1){b[ha+fa>>0]=b[(f[r>>2]|0)+fa>>0]|0;fa=fa+1|0;if((fa|0)==(i|0))break c}}do{fa=b[(f[r>>2]|0)+oa>>0]|0;da=1;do{ba=fa&255;ea=(h[(f[r+(da<<2)>>2]|0)+oa>>0]|0)-ba+256|0;if(ea>>>0<769)pa=h[271964+ea>>0]|0;else pa=0;fa=pa+ba&255;da=da+1|0}while((da|0)!=(j|0));b[ha+oa>>0]=fa;oa=oa+1|0}while((oa|0)!=(i|0))}while(0);if((ga|0)>1){r=r+4|0;ga=ga+-1|0;ha=ha+e|0}else break}return}function via(a){a=a|0;YDc(a);return}function wia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xia(a){a=a|0;YDc(a);return}function yia(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>3;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;n=c;o=b;q=e;while(1){a:do if(j)r=0;else{s=f[o+4>>2]|0;t=f[o>>2]|0;if(!k){u=f[o+8>>2]|0;v=0;while(1){w=s+(v<<3)|0;x=+p[w>>3];y=+p[w+8>>3];z=+p[w+16>>3];A=+p[w+24>>3];w=t+(v<<3)|0;B=+p[w>>3];p[n+(v<<3)>>3]=B<x?B:x;B=+p[w+8>>3];p[n+((v|1)<<3)>>3]=B<y?B:y;B=+p[w+16>>3];p[n+((v|2)<<3)>>3]=B<z?B:z;B=+p[w+24>>3];p[n+((v|3)<<3)>>3]=B<A?B:A;w=u+(v<<3)|0;B=+p[w>>3];C=v+a|0;p[n+(C<<3)>>3]=B<x?B:x;x=+p[w+8>>3];p[n+(C+1<<3)>>3]=x<y?x:y;y=+p[w+16>>3];p[n+(C+2<<3)>>3]=y<z?y:z;z=+p[w+24>>3];p[n+(C+3<<3)>>3]=z<A?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[o+(h<<2)>>2]|0;u=0;do{C=s+(u<<3)|0;A=+p[C+24>>3];z=+p[C+16>>3];y=+p[C+8>>3];x=+p[C>>3];C=2;do{w=(f[o+(C<<2)>>2]|0)+(u<<3)|0;B=+p[w>>3];x=B<x?B:x;B=+p[w+8>>3];y=B<y?B:y;B=+p[w+16>>3];z=B<z?B:z;B=+p[w+24>>3];A=B<A?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<3)|0;B=+p[C>>3];p[n+(u<<3)>>3]=B<x?B:x;B=+p[C+8>>3];p[n+((u|1)<<3)>>3]=B<y?B:y;B=+p[C+16>>3];p[n+((u|2)<<3)>>3]=B<z?B:z;B=+p[C+24>>3];p[n+((u|3)<<3)>>3]=B<A?B:A;C=v+(u<<3)|0;B=+p[C>>3];w=u+a|0;p[n+(w<<3)>>3]=B<x?B:x;B=+p[C+8>>3];p[n+(w+1<<3)>>3]=B<y?B:y;B=+p[C+16>>3];p[n+(w+2<<3)>>3]=B<z?B:z;B=+p[C+24>>3];p[n+(w+3<<3)>>3]=B<A?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[o+4>>2]|0;v=f[o>>2]|0;if(!k){t=f[o+8>>2]|0;s=r;while(1){B=+p[u+(s<<3)>>3];D=+p[v+(s<<3)>>3];p[n+(s<<3)>>3]=D<B?D:B;D=+p[t+(s<<3)>>3];p[n+(s+a<<3)>>3]=D<B?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[o+(h<<2)>>2]|0;t=r;do{B=+p[u+(t<<3)>>3];w=2;do{D=+p[(f[o+(w<<2)>>2]|0)+(t<<3)>>3];B=D<B?D:B;w=w+1|0}while((w|0)!=(h|0));A=+p[v+(t<<3)>>3];p[n+(t<<3)>>3]=A<B?A:B;A=+p[s+(t<<3)>>3];p[n+(t+a<<3)>>3]=A<B?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=n+(l<<3)|0;v=o+8|0;if((t|0)>1){n=s;o=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{o=0;while(1){n=E+(o<<3)|0;A=+p[n+8>>3];z=+p[n+16>>3];y=+p[n+24>>3];p[G+(o<<3)>>3]=+p[n>>3];p[G+((o|1)<<3)>>3]=A;p[G+((o|2)<<3)>>3]=z;p[G+((o|3)<<3)>>3]=y;o=o+4|0;if((o|0)>(e|0)){H=c;break c}}}do{o=E+(I<<3)|0;y=+p[o+24>>3];z=+p[o+16>>3];A=+p[o+8>>3];x=+p[o>>3];o=1;do{n=(f[q+(o<<2)>>2]|0)+(I<<3)|0;D=+p[n>>3];x=D<x?D:x;D=+p[n+8>>3];A=D<A?D:A;D=+p[n+16>>3];z=D<z?D:z;D=+p[n+24>>3];y=D<y?D:y;o=o+1|0}while((o|0)!=(h|0));p[G+(I<<3)>>3]=x;p[G+((I|1)<<3)>>3]=A;p[G+((I|2)<<3)>>3]=z;p[G+((I|3)<<3)>>3]=y;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{o=H;while(1){p[G+(o<<3)>>3]=+p[E+(o<<3)>>3];o=o+1|0;if((o|0)==(g|0))break d}}do{B=+p[E+(J<<3)>>3];o=1;do{D=+p[(f[q+(o<<2)>>2]|0)+(J<<3)>>3];B=D<B?D:B;o=o+1|0}while((o|0)!=(h|0));p[G+(J<<3)>>3]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<3)|0}else break}return}function zia(a){a=a|0;YDc(a);return}function Aia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Bia(a){a=a|0;YDc(a);return}function Cia(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>2;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;o=c;p=b;q=e;while(1){a:do if(j)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!k){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<2)|0;x=+n[w>>2];y=+n[w+4>>2];z=+n[w+8>>2];A=+n[w+12>>2];w=t+(v<<2)|0;B=+n[w>>2];n[o+(v<<2)>>2]=B<x?B:x;B=+n[w+4>>2];n[o+((v|1)<<2)>>2]=B<y?B:y;B=+n[w+8>>2];n[o+((v|2)<<2)>>2]=B<z?B:z;B=+n[w+12>>2];n[o+((v|3)<<2)>>2]=B<A?B:A;w=u+(v<<2)|0;B=+n[w>>2];C=v+a|0;n[o+(C<<2)>>2]=B<x?B:x;x=+n[w+4>>2];n[o+(C+1<<2)>>2]=x<y?x:y;y=+n[w+8>>2];n[o+(C+2<<2)>>2]=y<z?y:z;z=+n[w+12>>2];n[o+(C+3<<2)>>2]=z<A?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[p+(h<<2)>>2]|0;u=0;do{C=s+(u<<2)|0;A=+n[C+12>>2];z=+n[C+8>>2];y=+n[C+4>>2];x=+n[C>>2];C=2;do{w=(f[p+(C<<2)>>2]|0)+(u<<2)|0;B=+n[w>>2];x=B<x?B:x;B=+n[w+4>>2];y=B<y?B:y;B=+n[w+8>>2];z=B<z?B:z;B=+n[w+12>>2];A=B<A?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<2)|0;B=+n[C>>2];n[o+(u<<2)>>2]=B<x?B:x;B=+n[C+4>>2];n[o+((u|1)<<2)>>2]=B<y?B:y;B=+n[C+8>>2];n[o+((u|2)<<2)>>2]=B<z?B:z;B=+n[C+12>>2];n[o+((u|3)<<2)>>2]=B<A?B:A;C=v+(u<<2)|0;B=+n[C>>2];w=u+a|0;n[o+(w<<2)>>2]=B<x?B:x;B=+n[C+4>>2];n[o+(w+1<<2)>>2]=B<y?B:y;B=+n[C+8>>2];n[o+(w+2<<2)>>2]=B<z?B:z;B=+n[C+12>>2];n[o+(w+3<<2)>>2]=B<A?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!k){t=f[p+8>>2]|0;s=r;while(1){B=+n[u+(s<<2)>>2];D=+n[v+(s<<2)>>2];n[o+(s<<2)>>2]=D<B?D:B;D=+n[t+(s<<2)>>2];n[o+(s+a<<2)>>2]=D<B?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[p+(h<<2)>>2]|0;t=r;do{B=+n[u+(t<<2)>>2];w=2;do{D=+n[(f[p+(w<<2)>>2]|0)+(t<<2)>>2];B=D<B?D:B;w=w+1|0}while((w|0)!=(h|0));A=+n[v+(t<<2)>>2];n[o+(t<<2)>>2]=A<B?A:B;A=+n[s+(t<<2)>>2];n[o+(t+a<<2)>>2]=A<B?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=o+(l<<2)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{p=0;while(1){o=E+(p<<2)|0;l=f[o+4>>2]|0;r=f[o+8>>2]|0;k=f[o+12>>2]|0;f[G+(p<<2)>>2]=f[o>>2];f[G+((p|1)<<2)>>2]=l;f[G+((p|2)<<2)>>2]=r;f[G+((p|3)<<2)>>2]=k;p=p+4|0;if((p|0)>(e|0)){H=c;break c}}}do{p=E+(I<<2)|0;A=+n[p+12>>2];z=+n[p+8>>2];y=+n[p+4>>2];x=+n[p>>2];p=1;do{k=(f[q+(p<<2)>>2]|0)+(I<<2)|0;D=+n[k>>2];x=D<x?D:x;D=+n[k+4>>2];y=D<y?D:y;D=+n[k+8>>2];z=D<z?D:z;D=+n[k+12>>2];A=D<A?D:A;p=p+1|0}while((p|0)!=(h|0));n[G+(I<<2)>>2]=x;n[G+((I|1)<<2)>>2]=y;n[G+((I|2)<<2)>>2]=z;n[G+((I|3)<<2)>>2]=A;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{p=H;while(1){f[G+(p<<2)>>2]=f[E+(p<<2)>>2];p=p+1|0;if((p|0)==(g|0))break d}}do{B=+n[E+(J<<2)>>2];p=1;do{D=+n[(f[q+(p<<2)>>2]|0)+(J<<2)>>2];B=D<B?D:B;p=p+1|0}while((p|0)!=(h|0));n[G+(J<<2)>>2]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<2)|0}else break}return}function Dia(a){a=a|0;YDc(a);return}function Eia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fia(a){a=a|0;YDc(a);return}function Gia(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=B<<16>>16<x<<16>>16?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=B<<16>>16<y<<16>>16?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=B<<16>>16<z<<16>>16?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=B<<16>>16<A<<16>>16?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=w<<16>>16<x<<16>>16?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=x<<16>>16<y<<16>>16?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=y<<16>>16<z<<16>>16?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=z<<16>>16<A<<16>>16?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=w<<16>>16<y<<16>>16?w:y;w=d[x+2>>1]|0;B=w<<16>>16<B<<16>>16?w:B;w=d[x+4>>1]|0;C=w<<16>>16<C<<16>>16?w:C;w=d[x+6>>1]|0;z=w<<16>>16<z<<16>>16?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=w<<16>>16<y<<16>>16?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=w<<16>>16<B<<16>>16?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=w<<16>>16<C<<16>>16?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=w<<16>>16<z<<16>>16?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=A<<16>>16<y<<16>>16?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=A<<16>>16<B<<16>>16?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=A<<16>>16<C<<16>>16?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=A<<16>>16<z<<16>>16?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=x<<16>>16<A<<16>>16?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=x<<16>>16<A<<16>>16?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=w<<16>>16<A<<16>>16?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=x<<16>>16<A<<16>>16?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=x<<16>>16<A<<16>>16?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=j<<16>>16<o<<16>>16?j:o;j=d[n+2>>1]|0;m=j<<16>>16<m<<16>>16?j:m;j=d[n+4>>1]|0;r=j<<16>>16<r<<16>>16?j:r;j=d[n+6>>1]|0;l=j<<16>>16<l<<16>>16?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=j<<16>>16<p<<16>>16?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function Hia(a){a=a|0;YDc(a);return}function Iia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Jia(a){a=a|0;YDc(a);return}function Kia(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=(B&65535)<(x&65535)?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=(B&65535)<(y&65535)?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=(B&65535)<(z&65535)?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=(B&65535)<(A&65535)?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=(w&65535)<(x&65535)?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=(x&65535)<(y&65535)?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=(y&65535)<(z&65535)?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=(z&65535)<(A&65535)?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=(w&65535)<(y&65535)?w:y;w=d[x+2>>1]|0;B=(w&65535)<(B&65535)?w:B;w=d[x+4>>1]|0;C=(w&65535)<(C&65535)?w:C;w=d[x+6>>1]|0;z=(w&65535)<(z&65535)?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=(w&65535)<(y&65535)?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=(w&65535)<(B&65535)?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=(w&65535)<(C&65535)?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=(w&65535)<(z&65535)?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=(A&65535)<(y&65535)?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=(A&65535)<(B&65535)?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=(A&65535)<(C&65535)?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=(A&65535)<(z&65535)?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(x&65535)<(A&65535)?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=(x&65535)<(A&65535)?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=(w&65535)<(A&65535)?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=(x&65535)<(A&65535)?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=(x&65535)<(A&65535)?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=(j&65535)<(o&65535)?j:o;j=d[n+2>>1]|0;m=(j&65535)<(m&65535)?j:m;j=d[n+4>>1]|0;r=(j&65535)<(r&65535)?j:r;j=d[n+6>>1]|0;l=(j&65535)<(l&65535)?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=(j&65535)<(p&65535)?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function Lia(a){a=a|0;YDc(a);return}function Mia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Nia(a){a=a|0;YDc(a);return}function Oia(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=f[a+4>>2]|0;a=(j|0)>1;if(a&(g|0)>1){k=i+-4|0;l=(i|0)<4;m=(j|0)>2;n=e<<1;o=i&-4;p=d;q=c;r=g;while(1){if(l)s=0;else{t=q+4|0;u=0;do{v=(f[t>>2]|0)+u|0;w=b[v>>0]|0;x=b[v+1>>0]|0;y=b[v+2>>0]|0;z=b[v+3>>0]|0;if(m){v=z;A=y;B=x;C=w;D=2;while(1){E=(f[q+(D<<2)>>2]|0)+u|0;F=C&255;G=F-(h[E>>0]|0)+256|0;if(G>>>0<769)H=h[271964+G>>0]|0;else H=0;G=F-H&255;F=B&255;I=F-(h[E+1>>0]|0)+256|0;if(I>>>0<769)J=h[271964+I>>0]|0;else J=0;I=F-J&255;F=A&255;K=F-(h[E+2>>0]|0)+256|0;if(K>>>0<769)L=h[271964+K>>0]|0;else L=0;K=F-L&255;F=v&255;M=F-(h[E+3>>0]|0)+256|0;if(M>>>0<769)N=h[271964+M>>0]|0;else N=0;M=F-N&255;D=D+1|0;if((D|0)==(j|0)){O=M;P=K;Q=I;R=G;S=j;break}else{v=M;A=K;B=I;C=G}}}else{O=z;P=y;Q=x;R=w;S=2}C=(f[q>>2]|0)+u|0;B=R&255;A=B-(h[C>>0]|0)+256|0;if(A>>>0<769)T=h[271964+A>>0]|0;else T=0;b[p+u>>0]=B-T;A=Q&255;v=A-(h[C+1>>0]|0)+256|0;if(v>>>0<769)U=h[271964+v>>0]|0;else U=0;b[p+(u|1)>>0]=A-U;v=P&255;D=v-(h[C+2>>0]|0)+256|0;if(D>>>0<769)V=h[271964+D>>0]|0;else V=0;b[p+(u|2)>>0]=v-V;D=O&255;G=D-(h[C+3>>0]|0)+256|0;if(G>>>0<769)W=h[271964+G>>0]|0;else W=0;b[p+(u|3)>>0]=D-W;G=(f[q+(S<<2)>>2]|0)+u|0;C=B-(h[G>>0]|0)+256|0;if(C>>>0<769)X=h[271964+C>>0]|0;else X=0;C=u+e|0;b[p+C>>0]=B-X;B=A-(h[G+1>>0]|0)+256|0;if(B>>>0<769)Y=h[271964+B>>0]|0;else Y=0;b[p+(C+1)>>0]=A-Y;A=v-(h[G+2>>0]|0)+256|0;if(A>>>0<769)Z=h[271964+A>>0]|0;else Z=0;b[p+(C+2)>>0]=v-Z;v=D-(h[G+3>>0]|0)+256|0;if(v>>>0<769)_=h[271964+v>>0]|0;else _=0;b[p+(C+3)>>0]=D-_;u=u+4|0}while((u|0)<=(k|0));s=o}a:do if((s|0)<(i|0)){u=q+4|0;if(!m){t=q+8|0;D=s;while(1){C=h[(f[u>>2]|0)+D>>0]|0;v=C-(h[(f[q>>2]|0)+D>>0]|0)+256|0;if(v>>>0<769)$=h[271964+v>>0]|0;else $=0;b[p+D>>0]=C-$;v=C-(h[(f[t>>2]|0)+D>>0]|0)+256|0;if(v>>>0<769)aa=h[271964+v>>0]|0;else aa=0;b[p+(D+e)>>0]=C-aa;D=D+1|0;if((D|0)==(i|0))break a}}D=q+(j<<2)|0;t=s;do{w=b[(f[u>>2]|0)+t>>0]|0;x=2;while(1){y=w&255;z=y-(h[(f[q+(x<<2)>>2]|0)+t>>0]|0)+256|0;if(z>>>0<769)ba=h[271964+z>>0]|0;else ba=0;ca=y-ba|0;x=x+1|0;if((x|0)==(j|0))break;else w=ca&255}w=ca&255;x=w-(h[(f[q>>2]|0)+t>>0]|0)+256|0;if(x>>>0<769)da=h[271964+x>>0]|0;else da=0;b[p+t>>0]=ca-da;x=w-(h[(f[D>>2]|0)+t>>0]|0)+256|0;if(x>>>0<769)ea=h[271964+x>>0]|0;else ea=0;b[p+(t+e)>>0]=ca-ea;t=t+1|0}while((t|0)!=(i|0))}while(0);t=r+-2|0;D=p+n|0;u=q+8|0;if((t|0)>1){p=D;q=u;r=t}else{fa=D;ga=u;ha=t;break}}}else{fa=d;ga=c;ha=g}if((ha|0)<=0)return;g=i+-4|0;c=(i|0)<4;d=i&-4;r=ga;ga=ha;ha=fa;while(1){b:do if(c)ia=0;else{if(a)ja=0;else{fa=0;while(1){q=(f[r>>2]|0)+fa|0;p=b[q+1>>0]|0;n=b[q+2>>0]|0;ea=b[q+3>>0]|0;b[ha+fa>>0]=b[q>>0]|0;b[ha+(fa|1)>>0]=p;b[ha+(fa|2)>>0]=n;b[ha+(fa|3)>>0]=ea;fa=fa+4|0;if((fa|0)>(g|0)){ia=d;break b}}}do{fa=(f[r>>2]|0)+ja|0;ea=b[fa+3>>0]|0;n=b[fa+2>>0]|0;p=b[fa+1>>0]|0;q=b[fa>>0]|0;fa=1;do{ca=(f[r+(fa<<2)>>2]|0)+ja|0;da=q&255;ba=da-(h[ca>>0]|0)+256|0;if(ba>>>0<769)ka=h[271964+ba>>0]|0;else ka=0;q=da-ka&255;da=p&255;ba=da-(h[ca+1>>0]|0)+256|0;if(ba>>>0<769)la=h[271964+ba>>0]|0;else la=0;p=da-la&255;da=n&255;ba=da-(h[ca+2>>0]|0)+256|0;if(ba>>>0<769)ma=h[271964+ba>>0]|0;else ma=0;n=da-ma&255;da=ea&255;ba=da-(h[ca+3>>0]|0)+256|0;if(ba>>>0<769)na=h[271964+ba>>0]|0;else na=0;ea=da-na&255;fa=fa+1|0}while((fa|0)!=(j|0));b[ha+ja>>0]=q;b[ha+(ja|1)>>0]=p;b[ha+(ja|2)>>0]=n;b[ha+(ja|3)>>0]=ea;ja=ja+4|0}while((ja|0)<=(g|0));ia=d}while(0);c:do if((ia|0)<(i|0)){if(a)oa=ia;else{fa=ia;while(1){b[ha+fa>>0]=b[(f[r>>2]|0)+fa>>0]|0;fa=fa+1|0;if((fa|0)==(i|0))break c}}do{fa=b[(f[r>>2]|0)+oa>>0]|0;da=1;do{ba=fa&255;ca=ba-(h[(f[r+(da<<2)>>2]|0)+oa>>0]|0)+256|0;if(ca>>>0<769)pa=h[271964+ca>>0]|0;else pa=0;fa=ba-pa&255;da=da+1|0}while((da|0)!=(j|0));b[ha+oa>>0]=fa;oa=oa+1|0}while((oa|0)!=(i|0))}while(0);if((ga|0)>1){r=r+4|0;ga=ga+-1|0;ha=ha+e|0}else break}return}function Pia(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+80|0;i=h;j=h+64|0;k=h+8|0;do if((d$(e)|0)==65536){l=f[e+4>>2]|0;f[k>>2]=f[l>>2];m=k+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=k+8|0;f[o>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];f[k+20>>2]=f[l+20>>2];f[k+24>>2]=f[l+24>>2];f[k+28>>2]=f[l+28>>2];f[k+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[k+36>>2]=p;q=k+40|0;f[q>>2]=o;o=k+48|0;r=k+44|0;f[r>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=q;break}else{f[m>>2]=0;ZS(k,l);s=q;break}}else{a$(k,e,-1);s=k+40|0}while(0);e=d&7;q=f[g>>2]|0;l=g+4|0;m=f[l>>2]|0;n=f[s>>2]|0;o=f[n+4>>2]|0;r=f[n>>2]|0;n=(q|0)==-1?(o|0)/2|0:q;q=(m|0)==-1?(r|0)/2|0:m;if(!((n|0)>-1&(n|0)<(o|0))){f[j>>2]=0;t=j+4|0;f[t>>2]=0;v=tT(j,52)|0;w=v;x=281296;y=w+52|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,j,281349,281365,363)}if((q|0)<0|(q|0)>=(r|0)){f[j>>2]=0;t=j+4|0;f[t>>2]=0;v=tT(j,52)|0;w=v;x=281296;y=w+52|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,j,281349,281365,363)}f[g>>2]=n;f[l>>2]=q;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;w=tT(j,39)|0;x=258748;y=w+39|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,j,262332,258811,946)}x=(e|0)==0;a:do if(!c){if(x){e=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Qia(e,k,j);w=VDc(16)|0;y=w+4|0;f[y>>2]=1;f[w>>2]=55956;f[w+8>>2]=e;f[a>>2]=w;f[a+4>>2]=e;f[y>>2]=(f[y>>2]|0)+1;e=f[y>>2]|0;f[y>>2]=e+-1;if((e|0)!=1)break;Yi[f[(f[w>>2]|0)+8>>2]&2047](w);break}switch(d&7){case 2:{w=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Ria(w,k,j);e=VDc(16)|0;y=e+4|0;f[y>>2]=1;f[e>>2]=55976;f[e+8>>2]=w;f[a>>2]=e;f[a+4>>2]=w;f[y>>2]=(f[y>>2]|0)+1;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break a;Yi[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 3:{e=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Sia(e,k,j);w=VDc(16)|0;y=w+4|0;f[y>>2]=1;f[w>>2]=55996;f[w+8>>2]=e;f[a>>2]=w;f[a+4>>2]=e;f[y>>2]=(f[y>>2]|0)+1;e=f[y>>2]|0;f[y>>2]=e+-1;if((e|0)!=1)break a;Yi[f[(f[w>>2]|0)+8>>2]&2047](w);break a;break}case 5:{w=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Tia(w,k,j);e=VDc(16)|0;y=e+4|0;f[y>>2]=1;f[e>>2]=56016;f[e+8>>2]=w;f[a>>2]=e;f[a+4>>2]=w;f[y>>2]=(f[y>>2]|0)+1;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break a;Yi[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 6:{e=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Uia(e,k,j);w=VDc(16)|0;y=w+4|0;f[y>>2]=1;f[w>>2]=56036;f[w+8>>2]=e;f[a>>2]=w;f[a+4>>2]=e;f[y>>2]=(f[y>>2]|0)+1;e=f[y>>2]|0;f[y>>2]=e+-1;if((e|0)!=1)break a;Yi[f[(f[w>>2]|0)+8>>2]&2047](w);break a;break}default:{f[i>>2]=d;F5(j,258878,i);z5(-213,j,262332,258811,974)}}}else{if(x){w=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Via(w,k,j);e=VDc(16)|0;y=e+4|0;f[y>>2]=1;f[e>>2]=56056;f[e+8>>2]=w;f[a>>2]=e;f[a+4>>2]=w;f[y>>2]=(f[y>>2]|0)+1;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break;Yi[f[(f[e>>2]|0)+8>>2]&2047](e);break}switch(d&7){case 2:{e=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Wia(e,k,j);w=VDc(16)|0;y=w+4|0;f[y>>2]=1;f[w>>2]=56076;f[w+8>>2]=e;f[a>>2]=w;f[a+4>>2]=e;f[y>>2]=(f[y>>2]|0)+1;e=f[y>>2]|0;f[y>>2]=e+-1;if((e|0)!=1)break a;Yi[f[(f[w>>2]|0)+8>>2]&2047](w);break a;break}case 3:{w=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Xia(w,k,j);e=VDc(16)|0;y=e+4|0;f[y>>2]=1;f[e>>2]=56096;f[e+8>>2]=w;f[a>>2]=e;f[a+4>>2]=w;f[y>>2]=(f[y>>2]|0)+1;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break a;Yi[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 5:{e=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Yia(e,k,j);w=VDc(16)|0;y=w+4|0;f[y>>2]=1;f[w>>2]=56116;f[w+8>>2]=e;f[a>>2]=w;f[a+4>>2]=e;f[y>>2]=(f[y>>2]|0)+1;e=f[y>>2]|0;f[y>>2]=e+-1;if((e|0)!=1)break a;Yi[f[(f[w>>2]|0)+8>>2]&2047](w);break a;break}case 6:{w=VDc(48)|0;f[j>>2]=n;f[j+4>>2]=q;Zia(w,k,j);e=VDc(16)|0;y=e+4|0;f[y>>2]=1;f[e>>2]=56136;f[e+8>>2]=w;f[a>>2]=e;f[a+4>>2]=w;f[y>>2]=(f[y>>2]|0)+1;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break a;Yi[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}default:{f[i>>2]=d;F5(j,258878,i);z5(-213,j,262332,258811,974)}}}while(0);j=k+36|0;i=f[j>>2]|0;if(i|0?(d=i+12|0,i=f[d>>2]|0,f[d>>2]=i+-1,(i|0)==1):0)_S(k);f[j>>2]=0;j=k+16|0;i=k+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[s>>2]|0;s=0;do{f[j+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[i>>2]|0))}i=f[k+44>>2]|0;if((i|0)==(k+48|0)){u=h;return}g0(i);u=h;return}function Qia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56372;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Ria(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56348;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Sia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56324;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Tia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56300;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Uia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56276;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Via(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56252;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Wia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56228;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Xia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56204;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Yia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56180;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function Zia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;Cqa(a);f[a>>2]=56156;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,23)|0;a=262454;d=l+23|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));z5(-215,g,262478,258811,788)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Iua(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else bha(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;YDc(l);u=e;return}function _ia(a){a=a|0;YDc(a);return}function $ia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function aja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56156;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function bja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56156;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function cja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;n=(l|0)<4;o=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<3)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(n)s=0;else{c=f[j>>2]|0;if(o)t=0;else{r=0;while(1){u=c+(r<<3)|0;v=+p[u+8>>3];w=+p[u+16>>3];x=+p[u+24>>3];p[b+(r<<3)>>3]=+p[u>>3];p[b+((r|1)<<3)>>3]=v;p[b+((r|2)<<3)>>3]=w;p[b+((r|3)<<3)>>3]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<3)|0;x=+p[r+24>>3];w=+p[r+16>>3];v=+p[r+8>>3];y=+p[r>>3];r=1;do{u=(f[j+(r<<2)>>2]|0)+(t<<3)|0;z=+p[u>>3];y=y<z?z:y;z=+p[u+8>>3];v=v<z?z:v;z=+p[u+16>>3];w=w<z?z:w;z=+p[u+24>>3];x=x<z?z:x;r=r+1|0}while((r|0)<(a|0));p[b+(t<<3)>>3]=y;p[b+((t|1)<<3)>>3]=v;p[b+((t|2)<<3)>>3]=w;p[b+((t|3)<<3)>>3]=x;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(o)A=s;else{r=s;while(1){p[b+(r<<3)>>3]=+p[c+(r<<3)>>3];r=r+1|0;if((r|0)==(l|0))break b}}do{z=+p[c+(A<<3)>>3];r=1;do{B=+p[(f[j+(r<<2)>>2]|0)+(A<<3)>>3];z=z<B?B:z;r=r+1|0}while((r|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function dja(a){a=a|0;YDc(a);return}function eja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56180;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function gja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56180;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function hja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;o=(l|0)<4;p=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<2)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[j>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<2)|0;v=f[u+4>>2]|0;w=f[u+8>>2]|0;x=f[u+12>>2]|0;f[b+(r<<2)>>2]=f[u>>2];f[b+((r|1)<<2)>>2]=v;f[b+((r|2)<<2)>>2]=w;f[b+((r|3)<<2)>>2]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<2)|0;y=+n[r+12>>2];z=+n[r+8>>2];A=+n[r+4>>2];B=+n[r>>2];r=1;do{x=(f[j+(r<<2)>>2]|0)+(t<<2)|0;C=+n[x>>2];B=B<C?C:B;C=+n[x+4>>2];A=A<C?C:A;C=+n[x+8>>2];z=z<C?C:z;C=+n[x+12>>2];y=y<C?C:y;r=r+1|0}while((r|0)<(a|0));n[b+(t<<2)>>2]=B;n[b+((t|1)<<2)>>2]=A;n[b+((t|2)<<2)>>2]=z;n[b+((t|3)<<2)>>2]=y;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(p)D=s;else{r=s;while(1){f[b+(r<<2)>>2]=f[c+(r<<2)>>2];r=r+1|0;if((r|0)==(l|0))break b}}do{C=+n[c+(D<<2)>>2];r=1;do{E=+n[(f[j+(r<<2)>>2]|0)+(D<<2)>>2];C=C<E?E:C;r=r+1|0}while((r|0)<(a|0));n[b+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function ija(a){a=a|0;YDc(a);return}function jja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function kja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56204;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function lja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56204;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function mja(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=u<<16>>16<z<<16>>16?z:u;z=d[y+2>>1]|0;v=v<<16>>16<z<<16>>16?z:v;z=d[y+4>>1]|0;w=w<<16>>16<z<<16>>16?z:w;z=d[y+6>>1]|0;x=x<<16>>16<z<<16>>16?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=r<<16>>16<y<<16>>16?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function nja(a){a=a|0;YDc(a);return}function oja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56228;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function qja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56228;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function rja(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=(u&65535)<(z&65535)?z:u;z=d[y+2>>1]|0;v=(v&65535)<(z&65535)?z:v;z=d[y+4>>1]|0;w=(w&65535)<(z&65535)?z:w;z=d[y+6>>1]|0;x=(x&65535)<(z&65535)?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=(r&65535)<(y&65535)?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function sja(a){a=a|0;YDc(a);return}function tja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56252;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function vja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56252;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function wja(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=(f[a+24>>2]|0)-k|0;a=m>>3;n=Y(j,i)|0;if((g|0)<=0)return;i=(m|0)>0;o=n+-4|0;p=(n|0)<4;q=(m|0)>8;m=n&-4;r=c;c=d;d=g;while(1){if(i){g=0;do{s=(f[r+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(g<<3)>>2]|0,j)|0)|0;f[l+(g<<2)>>2]=s;g=g+1|0}while((g|0)<(a|0))}a:do if(p)t=0;else{if(q)u=0;else{g=0;while(1){s=(f[l>>2]|0)+g|0;v=b[s+1>>0]|0;w=b[s+2>>0]|0;x=b[s+3>>0]|0;b[c+g>>0]=b[s>>0]|0;b[c+(g|1)>>0]=v;b[c+(g|2)>>0]=w;b[c+(g|3)>>0]=x;g=g+4|0;if((g|0)>(o|0)){t=m;break a}}}do{g=(f[l>>2]|0)+u|0;x=b[g+3>>0]|0;w=b[g+2>>0]|0;v=b[g+1>>0]|0;s=b[g>>0]|0;g=1;do{y=(f[l+(g<<2)>>2]|0)+u|0;z=s&255;A=(h[y>>0]|0)-z+256|0;if(A>>>0<769)B=h[271964+A>>0]|0;else B=0;s=B+z&255;z=v&255;A=(h[y+1>>0]|0)-z+256|0;if(A>>>0<769)C=h[271964+A>>0]|0;else C=0;v=C+z&255;z=w&255;A=(h[y+2>>0]|0)-z+256|0;if(A>>>0<769)D=h[271964+A>>0]|0;else D=0;w=D+z&255;z=x&255;A=(h[y+3>>0]|0)-z+256|0;if(A>>>0<769)E=h[271964+A>>0]|0;else E=0;x=E+z&255;g=g+1|0}while((g|0)<(a|0));b[c+u>>0]=s;b[c+(u|1)>>0]=v;b[c+(u|2)>>0]=w;b[c+(u|3)>>0]=x;u=u+4|0}while((u|0)<=(o|0));t=m}while(0);b:do if((t|0)<(n|0)){if(q)F=t;else{g=t;while(1){b[c+g>>0]=b[(f[l>>2]|0)+g>>0]|0;g=g+1|0;if((g|0)==(n|0))break b}}do{g=b[(f[l>>2]|0)+F>>0]|0;z=1;do{A=g&255;y=(h[(f[l+(z<<2)>>2]|0)+F>>0]|0)-A+256|0;if(y>>>0<769)G=h[271964+y>>0]|0;else G=0;g=G+A&255;z=z+1|0}while((z|0)<(a|0));b[c+F>>0]=g;F=F+1|0}while((F|0)!=(n|0))}while(0);if((d|0)>1){r=r+4|0;c=c+e|0;d=d+-1|0}else break}return}function xja(a){a=a|0;YDc(a);return}function yja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56276;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Aja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56276;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Bja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;n=(l|0)<4;o=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<3)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(n)s=0;else{c=f[j>>2]|0;if(o)t=0;else{r=0;while(1){u=c+(r<<3)|0;v=+p[u+8>>3];w=+p[u+16>>3];x=+p[u+24>>3];p[b+(r<<3)>>3]=+p[u>>3];p[b+((r|1)<<3)>>3]=v;p[b+((r|2)<<3)>>3]=w;p[b+((r|3)<<3)>>3]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<3)|0;x=+p[r+24>>3];w=+p[r+16>>3];v=+p[r+8>>3];y=+p[r>>3];r=1;do{u=(f[j+(r<<2)>>2]|0)+(t<<3)|0;z=+p[u>>3];y=z<y?z:y;z=+p[u+8>>3];v=z<v?z:v;z=+p[u+16>>3];w=z<w?z:w;z=+p[u+24>>3];x=z<x?z:x;r=r+1|0}while((r|0)<(a|0));p[b+(t<<3)>>3]=y;p[b+((t|1)<<3)>>3]=v;p[b+((t|2)<<3)>>3]=w;p[b+((t|3)<<3)>>3]=x;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(o)A=s;else{r=s;while(1){p[b+(r<<3)>>3]=+p[c+(r<<3)>>3];r=r+1|0;if((r|0)==(l|0))break b}}do{z=+p[c+(A<<3)>>3];r=1;do{B=+p[(f[j+(r<<2)>>2]|0)+(A<<3)>>3];z=B<z?B:z;r=r+1|0}while((r|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function Cja(a){a=a|0;YDc(a);return}function Dja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Eja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56300;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Fja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56300;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Gja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;o=(l|0)<4;p=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<2)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[j>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<2)|0;v=f[u+4>>2]|0;w=f[u+8>>2]|0;x=f[u+12>>2]|0;f[b+(r<<2)>>2]=f[u>>2];f[b+((r|1)<<2)>>2]=v;f[b+((r|2)<<2)>>2]=w;f[b+((r|3)<<2)>>2]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<2)|0;y=+n[r+12>>2];z=+n[r+8>>2];A=+n[r+4>>2];B=+n[r>>2];r=1;do{x=(f[j+(r<<2)>>2]|0)+(t<<2)|0;C=+n[x>>2];B=C<B?C:B;C=+n[x+4>>2];A=C<A?C:A;C=+n[x+8>>2];z=C<z?C:z;C=+n[x+12>>2];y=C<y?C:y;r=r+1|0}while((r|0)<(a|0));n[b+(t<<2)>>2]=B;n[b+((t|1)<<2)>>2]=A;n[b+((t|2)<<2)>>2]=z;n[b+((t|3)<<2)>>2]=y;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(p)D=s;else{r=s;while(1){f[b+(r<<2)>>2]=f[c+(r<<2)>>2];r=r+1|0;if((r|0)==(l|0))break b}}do{C=+n[c+(D<<2)>>2];r=1;do{E=+n[(f[j+(r<<2)>>2]|0)+(D<<2)>>2];C=E<C?E:C;r=r+1|0}while((r|0)<(a|0));n[b+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function Hja(a){a=a|0;YDc(a);return}function Ija(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Jja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56324;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Kja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56324;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Lja(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=z<<16>>16<u<<16>>16?z:u;z=d[y+2>>1]|0;v=z<<16>>16<v<<16>>16?z:v;z=d[y+4>>1]|0;w=z<<16>>16<w<<16>>16?z:w;z=d[y+6>>1]|0;x=z<<16>>16<x<<16>>16?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=y<<16>>16<r<<16>>16?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function Mja(a){a=a|0;YDc(a);return}function Nja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Oja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56348;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Pja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56348;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Qja(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=(z&65535)<(u&65535)?z:u;z=d[y+2>>1]|0;v=(z&65535)<(v&65535)?z:v;z=d[y+4>>1]|0;w=(z&65535)<(w&65535)?z:w;z=d[y+6>>1]|0;x=(z&65535)<(x&65535)?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=(y&65535)<(r&65535)?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function Rja(a){a=a|0;YDc(a);return}function Sja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56372;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Uja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56372;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}b=f[a+20>>2]|0;if(!b){YDc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Vja(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=(f[a+24>>2]|0)-k|0;a=m>>3;n=Y(j,i)|0;if((g|0)<=0)return;i=(m|0)>0;o=n+-4|0;p=(n|0)<4;q=(m|0)>8;m=n&-4;r=c;c=d;d=g;while(1){if(i){g=0;do{s=(f[r+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(g<<3)>>2]|0,j)|0)|0;f[l+(g<<2)>>2]=s;g=g+1|0}while((g|0)<(a|0))}a:do if(p)t=0;else{if(q)u=0;else{g=0;while(1){s=(f[l>>2]|0)+g|0;v=b[s+1>>0]|0;w=b[s+2>>0]|0;x=b[s+3>>0]|0;b[c+g>>0]=b[s>>0]|0;b[c+(g|1)>>0]=v;b[c+(g|2)>>0]=w;b[c+(g|3)>>0]=x;g=g+4|0;if((g|0)>(o|0)){t=m;break a}}}do{g=(f[l>>2]|0)+u|0;x=b[g+3>>0]|0;w=b[g+2>>0]|0;v=b[g+1>>0]|0;s=b[g>>0]|0;g=1;do{y=(f[l+(g<<2)>>2]|0)+u|0;z=s&255;A=z-(h[y>>0]|0)+256|0;if(A>>>0<769)B=h[271964+A>>0]|0;else B=0;s=z-B&255;z=v&255;A=z-(h[y+1>>0]|0)+256|0;if(A>>>0<769)C=h[271964+A>>0]|0;else C=0;v=z-C&255;z=w&255;A=z-(h[y+2>>0]|0)+256|0;if(A>>>0<769)D=h[271964+A>>0]|0;else D=0;w=z-D&255;z=x&255;A=z-(h[y+3>>0]|0)+256|0;if(A>>>0<769)E=h[271964+A>>0]|0;else E=0;x=z-E&255;g=g+1|0}while((g|0)<(a|0));b[c+u>>0]=s;b[c+(u|1)>>0]=v;b[c+(u|2)>>0]=w;b[c+(u|3)>>0]=x;u=u+4|0}while((u|0)<=(o|0));t=m}while(0);b:do if((t|0)<(n|0)){if(q)F=t;else{g=t;while(1){b[c+g>>0]=b[(f[l>>2]|0)+g>>0]|0;g=g+1|0;if((g|0)==(n|0))break b}}do{g=b[(f[l>>2]|0)+F>>0]|0;z=1;do{A=g&255;y=A-(h[(f[l+(z<<2)>>2]|0)+F>>0]|0)+256|0;if(y>>>0<769)G=h[271964+y>>0]|0;else G=0;g=A-G&255;z=z+1|0}while((z|0)<(a|0));b[c+F>>0]=g;F=F+1|0}while((F|0)!=(n|0))}while(0);if((d|0)>1){r=r+4|0;c=c+e|0;d=d+-1|0}else break}return}function Wja(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0;k=u;u=u+144|0;l=k+128|0;m=k+72|0;n=k+64|0;o=k+56|0;q=k;r=k+32|0;s=k+48|0;do if((d$(e)|0)==65536){t=f[e+4>>2]|0;f[m>>2]=f[t>>2];v=m+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[t+8>>2];f[m+12>>2]=f[t+12>>2];f[m+16>>2]=f[t+16>>2];f[m+20>>2]=f[t+20>>2];f[m+24>>2]=f[t+24>>2];f[m+28>>2]=f[t+28>>2];f[m+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[m+36>>2]=y;z=m+40|0;f[z>>2]=x;x=m+48|0;A=m+44|0;f[A>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];B=z;break}else{f[v>>2]=0;ZS(m,t);B=z;break}}else{a$(m,e,-1);B=m+40|0}while(0);e=f[g>>2]|0;z=g+4|0;t=f[z>>2]|0;v=f[B>>2]|0;w=f[v+4>>2]|0;x=f[v>>2]|0;v=(e|0)==-1?(w|0)/2|0:e;e=(t|0)==-1?(x|0)/2|0:t;if(!((v|0)>-1&(v|0)<(w|0))){f[l>>2]=0;C=l+4|0;f[C>>2]=0;D=tT(l,52)|0;E=D;F=281296;G=E+52|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,l,281349,281365,363)}if((e|0)<0|(e|0)>=(x|0)){f[l>>2]=0;C=l+4|0;f[C>>2]=0;D=tT(l,52)|0;E=D;F=281296;G=E+52|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,l,281349,281365,363)}f[g>>2]=v;f[z>>2]=e;f[l>>2]=0;e=l+4|0;f[e>>2]=0;f[n>>2]=0;v=n+4|0;f[v>>2]=0;f[o>>2]=0;D=o+4|0;f[D>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=m;C=N2(q)|0;x=m+8|0;w=f[m+12>>2]|0;if((C|0)==(Y(w,f[x>>2]|0)|0)){nha(q,c,d,w,f[g>>2]|0);w=f[q>>2]|0;C=f[q+4>>2]|0;if(w|0){t=w+4|0;f[t>>2]=(f[t>>2]|0)+1}t=f[l>>2]|0;f[l>>2]=w;f[e>>2]=C;if(t|0?(C=t+4|0,e=f[C>>2]|0,f[C>>2]=e+-1,(e|0)==1):0)Yi[f[(f[t>>2]|0)+8>>2]&2047](t);t=f[q>>2]|0;if(t|0?(e=t+4|0,C=f[e>>2]|0,f[e>>2]=C+-1,(C|0)==1):0)Yi[f[(f[t>>2]|0)+8>>2]&2047](t);aia(q,c,d,f[x>>2]|0,f[z>>2]|0);x=f[q>>2]|0;t=f[q+4>>2]|0;if(x|0){C=x+4|0;f[C>>2]=(f[C>>2]|0)+1}C=f[n>>2]|0;f[n>>2]=x;f[v>>2]=t;if(C|0?(t=C+4|0,v=f[t>>2]|0,f[t>>2]=v+-1,(v|0)==1):0)Yi[f[(f[C>>2]|0)+8>>2]&2047](C);C=f[q>>2]|0;if(C|0?(v=C+4|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)Yi[f[(f[C>>2]|0)+8>>2]&2047](C)}else{f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;f[s>>2]=f[g>>2];f[s+4>>2]=f[z>>2];Pia(q,c,d,r,s);s=f[q>>2]|0;z=f[q+4>>2]|0;if(s|0){g=s+4|0;f[g>>2]=(f[g>>2]|0)+1}g=f[o>>2]|0;f[o>>2]=s;f[D>>2]=z;if(g|0?(z=g+4|0,D=f[z>>2]|0,f[z>>2]=D+-1,(D|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[q>>2]|0;if(g|0?(D=g+4|0,z=f[D>>2]|0,f[D>>2]=z+-1,(z|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g)}H=+p[j>>3];p[q>>3]=H;I=+p[j+8>>3];g=q+8|0;p[g>>3]=I;J=+p[j+16>>3];z=q+16|0;p[z>>3]=J;K=+p[j+24>>3];j=q+24|0;p[j>>3]=K;do if(((h|0)==0|(i|0)==0)&H==1797693134862315708145274.0e284&I==1797693134862315708145274.0e284?!(K!=1797693134862315708145274.0e284|J!=1797693134862315708145274.0e284):0){D=d&7;s=(D|2|0)==2;C=(D|0)==3;t=(D|0)==5;D=d&255;switch(D&7){case 0:case 2:case 3:case 5:case 6:break;default:{f[r>>2]=0;f[r+4>>2]=0;E=tT(r,90)|0;F=263908;G=E+90|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));z5(-215,r,263999,258811,1004)}}if(c|0){L=s?0.0:C?-32768.0:t?-3402823466385288598117041.0e14:-1797693134862315708145274.0e284;p[q>>3]=L;p[g>>3]=L;p[z>>3]=L;p[j>>3]=L;break}switch(D&7){case 0:{M=255.0;break}case 2:{M=65535.0;break}default:M=C?32767.0:t?3402823466385288598117041.0e14:1797693134862315708145274.0e284}p[q>>3]=M;p[g>>3]=M;p[z>>3]=M;p[j>>3]=M}while(0);j=VDc(200)|0;Dqa(j,o,l,n,d,d,d,h,i,q);q=VDc(16)|0;f[q+4>>2]=1;f[q>>2]=56396;f[q+8>>2]=j;f[a>>2]=q;f[a+4>>2]=j;j=f[o>>2]|0;if(j|0?(o=j+4|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)Yi[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[n>>2]|0;if(j|0?(n=j+4|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)Yi[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[l>>2]|0;if(j|0?(l=j+4|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)Yi[f[(f[j>>2]|0)+8>>2]&2047](j);j=m+36|0;a=f[j>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)_S(m);f[j>>2]=0;j=m+16|0;a=m+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[a>>2]|0)>0){j=f[B>>2]|0;B=0;do{f[j+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[a>>2]|0))}a=f[m+44>>2]|0;if((a|0)==(m+48|0)){u=k;return}g0(a);u=k;return}function Xja(a){a=a|0;YDc(a);return}function Yja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zja(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+16|0;h=g;if(c>>>0>=3){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,69)|0;j=264094;k=i+69|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,264164,258811,1028)}l=f[e>>2]|0;m=e+4|0;n=f[m>>2]|0;o=f[d>>2]|0;p=d+4|0;q=f[p>>2]|0;r=(o|0)/2|0;s=(l|0)==-1?r:l;l=(n|0)==-1?(q|0)/2|0:n;if(!((s|0)>-1&(s|0)<(o|0))){f[h>>2]=0;t=h+4|0;f[t>>2]=0;v=tT(h,52)|0;i=v;j=281296;k=i+52|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,281349,281365,363)}if((l|0)<0|(l|0)>=(q|0)){f[h>>2]=0;t=h+4|0;f[t>>2]=0;v=tT(h,52)|0;i=v;j=281296;k=i+52|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,281349,281365,363)}f[e>>2]=s;f[m>>2]=l;l=f[p>>2]|0;s=(o|0)==1&(l|0)==1?0:c;if((s|0)==2){c=(l|0)/2|0;w=+(c|0);x=(l+1|0)>>>0>2?1.0/(w*w):0.0;y=r;z=c}else{x=0.0;y=0;z=0}f[a>>2]=1124007936;c=a+8|0;r=a+40|0;i=a+4|0;k=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(k|0));f[r>>2]=c;c=a+48|0;r=a+44|0;f[r>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[h>>2]=l;f[h+4>>2]=o;XS(a,2,h,0);if((f[p>>2]|0)<=0){u=g;return}h=a+16|0;w=+(y|0);a=Y(z,z)|0;if(!s){o=0;l=f[d>>2]|0;while(1){c=(f[h>>2]|0)+(Y(f[f[r>>2]>>2]|0,o)|0)|0;if((l|0)>0){XIc(c|0,1,l|0)|0;A=l;B=f[d>>2]|0}else{A=0;B=l}if((A|0)<(B|0)){i=A;do{b[c+i>>0]=0;i=i+1|0;k=f[d>>2]|0}while((i|0)<(k|0));C=k}else C=B;o=o+1|0;if((o|0)>=(f[p>>2]|0))break;else l=C}u=g;return}C=(s|0)==1;s=0;do{l=f[h>>2]|0;o=Y(f[f[r>>2]>>2]|0,s)|0;B=l+o|0;do if(C)if((s|0)!=(f[m>>2]|0)){A=f[e>>2]|0;i=A+1|0;if((A|0)>0){D=i;E=A;F=23;break}else{G=0;H=i;F=24;break}}else{G=0;H=f[d>>2]|0;F=24;break}else{i=s-z|0;if((((i|0)>-1?i:0-i|0)|0)<=(z|0)){A=nrc(w*+M(+(x*+(a-(Y(i,i)|0)|0))))|0;i=y-A|0;c=A+y|0;A=f[d>>2]|0;k=(A|0)<=(c|0)?A:c+1|0;if((i|0)>0){D=k;E=i;F=23}else{G=0;H=k;F=24}}else I=0}while(0);if((F|0)==23){F=0;XIc(B|0,0,E|0)|0;G=E;H=D;F=24}if((F|0)==24){F=0;if((H|0)>(G|0)){XIc(l+(G+o)|0,1,H-G|0)|0;I=H}else I=G}if((I|0)<(f[d>>2]|0)){k=I;do{b[B+k>>0]=0;k=k+1|0}while((k|0)<(f[d>>2]|0))}s=s+1|0}while((s|0)<(f[p>>2]|0));u=g;return}function _ja(a,b,c,d,e,g,h,i,j,k,l,m,n,o,q,r,s,t,v,w,x,y,z,A,B,C,D,E){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;r=r|0;s=s|0;t=t|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;var F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0;E=u;u=u+224|0;F=E+168|0;G=E+160|0;H=E+152|0;I=E+96|0;J=E+88|0;K=E;L=E+80|0;M=E+72|0;N=E+64|0;O=E+56|0;f[G>>2]=x;f[G+4>>2]=y;CY(F,G,t,v,w);P=+p[C>>3];Q=+p[C+8>>3];R=+p[C+16>>3];S=+p[C+24>>3];f[I+8>>2]=0;f[I+12>>2]=0;f[I>>2]=16842752;f[I+4>>2]=F;f[J>>2]=z;f[J+4>>2]=A;p[K>>3]=P;p[K+8>>3]=Q;p[K+16>>3]=R;p[K+24>>3]=S;Wja(H,a,b,I,J,B,B,K);f[L>>2]=i;f[L+4>>2]=j;CY(I,L,b,d,e);f[M>>2]=i;f[M+4>>2]=j;CY(K,M,c,g,h);f[N>>2]=m;f[N+4>>2]=n;f[O>>2]=k;f[O+4>>2]=l;l=f[H+4>>2]|0;gi[f[(f[l>>2]|0)+20>>2]&255](l,I,K,O,N);f[N>>2]=r;f[N+4>>2]=s;f[O>>2]=o;f[O+4>>2]=q;if((D|0)>1){q=1;do{gi[f[(f[l>>2]|0)+20>>2]&255](l,K,K,O,N);q=q+1|0}while((q|0)<(D|0))}D=K+36|0;q=f[D>>2]|0;if(q|0?(N=q+12|0,q=f[N>>2]|0,f[N>>2]=q+-1,(q|0)==1):0)_S(K);f[D>>2]=0;D=K+16|0;q=K+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[q>>2]|0)>0){D=f[K+40>>2]|0;N=0;do{f[D+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[q>>2]|0))}q=f[K+44>>2]|0;if((q|0)!=(K+48|0))g0(q);q=I+36|0;K=f[q>>2]|0;if(K|0?(N=K+12|0,K=f[N>>2]|0,f[N>>2]=K+-1,(K|0)==1):0)_S(I);f[q>>2]=0;q=I+16|0;K=I+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[K>>2]|0)>0){q=f[I+40>>2]|0;N=0;do{f[q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[I+44>>2]|0;if((K|0)!=(I+48|0))g0(K);K=f[H>>2]|0;if(K|0?(H=K+4|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)Yi[f[(f[K>>2]|0)+8>>2]&2047](K);K=F+36|0;I=f[K>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)_S(F);f[K>>2]=0;K=F+16|0;I=F+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[I>>2]|0)>0){K=f[F+40>>2]|0;H=0;do{f[K+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}I=f[F+44>>2]|0;if((I|0)==(F+48|0)){u=E;return}g0(I);u=E;return}function $ja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];aka(0,a,b,c,j,e,g,h);u=i;return}function aka(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;k=u;u=u+240|0;l=k+184|0;m=k+128|0;n=k+120|0;o=k+112|0;p=k+104|0;q=k+96|0;r=k+32|0;s=k+40|0;t=k+24|0;v=k+16|0;w=k+8|0;x=k;do if((d$(e)|0)==65536){y=f[e+4>>2]|0;f[m>>2]=f[y>>2];z=m+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=m+8|0;f[B>>2]=f[y+8>>2];f[m+12>>2]=f[y+12>>2];C=m+16|0;f[C>>2]=f[y+16>>2];f[m+20>>2]=f[y+20>>2];f[m+24>>2]=f[y+24>>2];f[m+28>>2]=f[y+28>>2];f[m+32>>2]=f[y+32>>2];D=f[y+36>>2]|0;f[m+36>>2]=D;f[m+40>>2]=B;B=m+48|0;E=m+44|0;f[E>>2]=B;f[B>>2]=0;f[m+52>>2]=0;if(D|0){B=D+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[E>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];F=C;break}else{f[z>>2]=0;ZS(m,y);F=C;break}}else{a$(m,e,-1);F=m+16|0}while(0);e=(f[F>>2]|0)==0;if(!e){C=f[m+4>>2]|0;if((C|0)<3)G=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{y=f[m+40>>2]|0;z=0;A=1;while(1){B=Y(f[y+(z<<2)>>2]|0,A)|0;z=z+1|0;if((z|0)==(C|0)){G=B;break}else A=B}}if(!((C|0)==0|(G|0)==0)){G=f[m+40>>2]|0;H=f[G+4>>2]|0;I=f[G>>2]|0}else{H=3;I=3}}else{H=3;I=3}G=f[g>>2]|0;C=g+4|0;A=f[C>>2]|0;z=(G|0)==-1?(H|0)/2|0:G;G=(A|0)==-1?(I|0)/2|0:A;if(!((z|0)>-1&(z|0)<(H|0))){f[l>>2]=0;J=l+4|0;f[J>>2]=0;K=tT(l,52)|0;L=K;M=281296;N=L+52|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));z5(-215,l,281349,281365,363)}if((G|0)<0|(G|0)>=(I|0)){f[l>>2]=0;J=l+4|0;f[J>>2]=0;K=tT(l,52)|0;L=K;M=281296;N=L+52|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));z5(-215,l,281349,281365,363)}f[g>>2]=z;f[C>>2]=G;if((h|0)!=0?(G=m+8|0,z=m+12|0,M=Y(f[z>>2]|0,f[G>>2]|0)|0,(M|0)!=1):0){if(!e){e=m+4|0;L=f[e>>2]|0;if((L|0)<3)O=M;else{M=f[m+40>>2]|0;N=0;K=1;while(1){J=Y(f[M+(N<<2)>>2]|0,K)|0;N=N+1|0;if((N|0)==(L|0)){O=J;break}else K=J}}if(!((L|0)==0|(O|0)==0))if((h|0)>1?(f[l+8>>2]=0,f[l+12>>2]=0,f[l>>2]=16842752,f[l+4>>2]=m,O=N2(l)|0,(O|0)==(Y(f[z>>2]|0,f[G>>2]|0)|0)):0){O=Y(f[g>>2]|0,h)|0;L=Y(f[C>>2]|0,h)|0;f[g>>2]=O;f[C>>2]=L;K=h+-1|0;N=(Y(H+-1|0,K)|0)+H|0;H=(Y(I+-1|0,K)|0)+I|0;f[p>>2]=N;f[p+4>>2]=H;f[q>>2]=O;f[q+4>>2]=L;Zja(l,0,p,q);q=l+36|0;p=f[q>>2]|0;if(p|0){L=p+12|0;f[L>>2]=(f[L>>2]|0)+1}L=m+36|0;p=f[L>>2]|0;if(p|0?(O=p+12|0,p=f[O>>2]|0,f[O>>2]=p+-1,(p|0)==1):0)_S(m);f[L>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[e>>2]|0)>0){p=f[m+40>>2]|0;O=0;do{f[p+(O<<2)>>2]=0;O=O+1|0;P=f[e>>2]|0}while((O|0)<(P|0));f[m>>2]=f[l>>2];if((P|0)<3)Q=60;else Q=62}else{f[m>>2]=f[l>>2];Q=60}if((Q|0)==60){P=f[l+4>>2]|0;if((P|0)<3){f[e>>2]=P;f[G>>2]=f[l+8>>2];f[z>>2]=f[l+12>>2];P=f[l+44>>2]|0;e=f[m+44>>2]|0;f[e>>2]=f[P>>2];f[e+4>>2]=f[P+4>>2]}else Q=62}if((Q|0)==62)ZS(m,l);P=l+16|0;f[F>>2]=f[P>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];e=f[q>>2]|0;f[L>>2]=e;if(e|0?(L=e+12|0,e=f[L>>2]|0,f[L>>2]=e+-1,(e|0)==1):0)_S(l);f[q>>2]=0;q=l+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[q>>2]|0)>0){P=f[l+40>>2]|0;e=0;do{f[P+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[q>>2]|0))}q=f[l+44>>2]|0;if((q|0)!=(l+48|0))g0(q);R=1}else R=h;else Q=26}else Q=26;if((Q|0)==26){q=h<<1|1;f[n>>2]=q;f[n+4>>2]=q;f[o>>2]=-1;f[o+4>>2]=-1;Zja(l,0,n,o);o=l+36|0;n=f[o>>2]|0;if(n|0){q=n+12|0;f[q>>2]=(f[q>>2]|0)+1}q=m+36|0;n=f[q>>2]|0;if(n|0?(e=n+12|0,n=f[e>>2]|0,f[e>>2]=n+-1,(n|0)==1):0)_S(m);f[q>>2]=0;n=m+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[n>>2]|0)>0){e=f[m+40>>2]|0;P=0;do{f[e+(P<<2)>>2]=0;P=P+1|0;S=f[n>>2]|0}while((P|0)<(S|0));f[m>>2]=f[l>>2];if((S|0)<3)Q=36;else Q=38}else{f[m>>2]=f[l>>2];Q=36}if((Q|0)==36){S=f[l+4>>2]|0;if((S|0)<3){f[n>>2]=S;f[G>>2]=f[l+8>>2];f[z>>2]=f[l+12>>2];S=f[l+44>>2]|0;n=f[m+44>>2]|0;f[n>>2]=f[S>>2];f[n+4>>2]=f[S+4>>2]}else Q=38}if((Q|0)==38)ZS(m,l);Q=l+16|0;f[F>>2]=f[Q>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];S=f[o>>2]|0;f[q>>2]=S;if(S|0?(q=S+12|0,S=f[q>>2]|0,f[q>>2]=S+-1,(S|0)==1):0)_S(l);f[o>>2]=0;o=l+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[o>>2]|0)>0){Q=f[l+40>>2]|0;S=0;do{f[Q+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))g0(o);f[g>>2]=h;f[C>>2]=h;R=1}do if((d$(c)|0)==65536){h=f[c+4>>2]|0;f[l>>2]=f[h>>2];o=l+4|0;S=h+4|0;f[o>>2]=f[S>>2];Q=l+8|0;f[Q>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];q=f[h+36>>2]|0;f[l+36>>2]=q;n=l+40|0;f[n>>2]=Q;Q=l+48|0;P=l+44|0;f[P>>2]=Q;f[Q>>2]=0;f[l+52>>2]=0;if(q|0){Q=q+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[S>>2]|0)<3){S=f[h+44>>2]|0;Q=f[P>>2]|0;f[Q>>2]=f[S>>2];f[Q+4>>2]=f[S+4>>2];T=n;U=l;break}else{f[o>>2]=0;ZS(l,h);T=n;U=l;break}}else{a$(l,c,-1);T=l+40|0;U=l}while(0);n=f[T>>2]|0;h=f[n>>2]|0;f[r>>2]=f[n+4>>2];f[r+4>>2]=h;v$(d,r,f[U>>2]&4095,-1,0,0);do if((d$(d)|0)==65536){r=f[d+4>>2]|0;f[s>>2]=f[r>>2];h=s+4|0;n=r+4|0;f[h>>2]=f[n>>2];o=s+8|0;f[o>>2]=f[r+8>>2];S=s+12|0;f[S>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];Q=f[r+36>>2]|0;f[s+36>>2]=Q;f[s+40>>2]=o;P=s+48|0;q=s+44|0;f[q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;if(Q|0){P=Q+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[n>>2]|0)<3){n=f[r+44>>2]|0;P=f[q>>2]|0;f[P>>2]=f[n>>2];f[P+4>>2]=f[n+4>>2];V=S;W=o;break}else{f[h>>2]=0;ZS(s,r);V=S;W=o;break}}else{a$(s,d,-1);V=s+12|0;W=s+8|0}while(0);f[t>>2]=0;o=t+4|0;f[o>>2]=0;S=l+12|0;r=f[S>>2]|0;h=l+8|0;n=f[h>>2]|0;f[v>>2]=r;P=v+4|0;f[P>>2]=n;f[w>>2]=0;q=w+4|0;f[q>>2]=0;Q=f[V>>2]|0;V=f[W>>2]|0;f[x>>2]=Q;W=x+4|0;f[W>>2]=V;e=(i&16|0)!=0;if(e){X=r;Z=n;_=r;$=n;aa=0;ba=0;ca=Q;da=V;ea=0;fa=0}else{jT(l,v,t);jT(s,x,w);X=f[S>>2]|0;Z=f[h>>2]|0;_=f[v>>2]|0;$=f[P>>2]|0;aa=f[t>>2]|0;ba=f[o>>2]|0;ca=f[x>>2]|0;da=f[W>>2]|0;ea=f[w>>2]|0;fa=f[q>>2]|0}q=f[U>>2]|0;U=l+16|0;w=l+48|0;W=s+16|0;x=s+48|0;_ja(a,q&4095,f[s>>2]&4095,f[U>>2]|0,f[w>>2]|0,f[W>>2]|0,f[x>>2]|0,X,Z,_,$,aa,ba,ca,da,ea,fa,f[m>>2]&4095,f[F>>2]|0,f[m+48>>2]|0,f[z>>2]|0,f[G>>2]|0,f[g>>2]|0,f[C>>2]|0,i&-17,j,R,(q&32768|0)!=0&(e^1));e=s+36|0;q=f[e>>2]|0;if(q|0?(R=q+12|0,q=f[R>>2]|0,f[R>>2]=q+-1,(q|0)==1):0)_S(s);f[e>>2]=0;e=s+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[e>>2]|0)>0){W=f[s+40>>2]|0;q=0;do{f[W+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[e>>2]|0))}e=f[s+44>>2]|0;if((e|0)!=(x|0))g0(e);e=l+36|0;x=f[e>>2]|0;if(x|0?(s=x+12|0,x=f[s>>2]|0,f[s>>2]=x+-1,(x|0)==1):0)_S(l);f[e>>2]=0;e=l+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[e>>2]|0)>0){U=f[T>>2]|0;T=0;do{f[U+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[e>>2]|0))}e=f[l+44>>2]|0;if((e|0)!=(w|0))g0(e)}else t$(c,d);d=m+36|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(m);f[d>>2]=0;d=m+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[d>>2]|0)>0){F=f[m+40>>2]|0;c=0;do{f[F+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[m+44>>2]|0;if((d|0)==(m+48|0)){u=k;return}g0(d);u=k;return}function bka(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];aka(1,a,b,c,j,e,g,h);u=i;return}function cka(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;k=u;u=u+816|0;l=k+32|0;m=k+744|0;n=k+688|0;o=k+624|0;q=k+808|0;r=k+800|0;s=k+568|0;t=k+512|0;v=k+680|0;w=k+456|0;x=k+400|0;y=k+344|0;z=k+288|0;A=k;B=k+272|0;C=k+256|0;do if((d$(e)|0)==65536){D=f[e+4>>2]|0;f[o>>2]=f[D>>2];E=o+4|0;F=D+4|0;f[E>>2]=f[F>>2];G=o+8|0;f[G>>2]=f[D+8>>2];f[o+12>>2]=f[D+12>>2];H=o+16|0;f[H>>2]=f[D+16>>2];f[o+20>>2]=f[D+20>>2];f[o+24>>2]=f[D+24>>2];f[o+28>>2]=f[D+28>>2];f[o+32>>2]=f[D+32>>2];I=f[D+36>>2]|0;f[o+36>>2]=I;f[o+40>>2]=G;G=o+48|0;J=o+44|0;f[J>>2]=G;f[G>>2]=0;f[o+52>>2]=0;if(I|0){G=I+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[D+44>>2]|0;G=f[J>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];K=H;break}else{f[E>>2]=0;ZS(o,D);K=H;break}}else{a$(o,e,-1);K=o+16|0}while(0);if(f[K>>2]|0){e=f[o+4>>2]|0;if((e|0)<3)L=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{H=f[o+40>>2]|0;D=0;E=1;while(1){F=Y(f[H+(D<<2)>>2]|0,E)|0;D=D+1|0;if((D|0)==(e|0)){L=F;break}else E=F}}if((e|0)==0|(L|0)==0)M=14}else M=14;if((M|0)==14){f[q>>2]=3;f[q+4>>2]=3;f[r>>2]=1;f[r+4>>2]=1;Zja(l,0,q,r);r=l+36|0;q=f[r>>2]|0;if(q|0){L=q+12|0;f[L>>2]=(f[L>>2]|0)+1}L=o+36|0;q=f[L>>2]|0;if(q|0?(e=q+12|0,q=f[e>>2]|0,f[e>>2]=q+-1,(q|0)==1):0)_S(o);f[L>>2]=0;q=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[q>>2]|0)>0){e=f[o+40>>2]|0;E=0;do{f[e+(E<<2)>>2]=0;E=E+1|0;N=f[q>>2]|0}while((E|0)<(N|0));f[o>>2]=f[l>>2];if((N|0)<3)M=24;else M=26}else{f[o>>2]=f[l>>2];M=24}if((M|0)==24){N=f[l+4>>2]|0;if((N|0)<3){f[q>>2]=N;f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];N=f[l+44>>2]|0;q=f[o+44>>2]|0;f[q>>2]=f[N>>2];f[q+4>>2]=f[N+4>>2]}else M=26}if((M|0)==26)ZS(o,l);N=l+16|0;f[K>>2]=f[N>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];f[o+28>>2]=f[l+28>>2];f[o+32>>2]=f[l+32>>2];q=f[r>>2]|0;f[L>>2]=q;if(q|0?(L=q+12|0,q=f[L>>2]|0,f[L>>2]=q+-1,(q|0)==1):0)_S(l);f[r>>2]=0;r=l+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[r>>2]|0)>0){N=f[l+40>>2]|0;q=0;do{f[N+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))g0(r)}do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[s>>2]=f[r>>2];q=s+4|0;N=r+4|0;f[q>>2]=f[N>>2];L=s+8|0;f[L>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];E=f[r+36>>2]|0;f[s+36>>2]=E;e=s+40|0;f[e>>2]=L;L=s+48|0;D=s+44|0;f[D>>2]=L;f[L>>2]=0;f[s+52>>2]=0;if(E|0){L=E+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[N>>2]|0)<3){N=f[r+44>>2]|0;L=f[D>>2]|0;f[L>>2]=f[N>>2];f[L+4>>2]=f[N+4>>2];O=e;P=s;break}else{f[q>>2]=0;ZS(s,r);O=e;P=s;break}}else{a$(s,a,-1);O=s+40|0;P=s}while(0);f[t>>2]=1124007936;a=t+4|0;e=t+8|0;r=t+40|0;q=a;N=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(N|0));f[r>>2]=e;L=t+48|0;D=t+44|0;f[D>>2]=L;f[L>>2]=0;f[t+52>>2]=0;E=f[O>>2]|0;H=f[E>>2]|0;f[v>>2]=f[E+4>>2];f[v+4>>2]=H;v$(c,v,f[P>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){v=f[c+4>>2]|0;f[w>>2]=f[v>>2];H=w+4|0;E=v+4|0;f[H>>2]=f[E>>2];F=w+8|0;f[F>>2]=f[v+8>>2];f[w+12>>2]=f[v+12>>2];f[w+16>>2]=f[v+16>>2];f[w+20>>2]=f[v+20>>2];f[w+24>>2]=f[v+24>>2];f[w+28>>2]=f[v+28>>2];f[w+32>>2]=f[v+32>>2];G=f[v+36>>2]|0;f[w+36>>2]=G;f[w+40>>2]=F;F=w+48|0;J=w+44|0;f[J>>2]=F;f[F>>2]=0;f[w+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[v+44>>2]|0;F=f[J>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[H>>2]=0;ZS(w,v);break}}else a$(w,c,-1);while(0);a:do switch(d|0){case 0:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=f[g+4>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=c;aka(0,m,n,x,l,h,i,j);break}case 1:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=f[g+4>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=c;aka(1,m,n,x,l,h,i,j);break}case 2:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=g+4|0;v=f[c>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=v;aka(0,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=w;v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;v=f[c>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=v;aka(1,m,n,x,l,h,i,j);break}case 3:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;v=g+4|0;c=f[v>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=c;aka(1,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=w;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=f[v>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=c;aka(0,m,n,x,l,h,i,j);break}case 4:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=g+4|0;v=f[c>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=v;aka(0,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;v=f[c>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=v;aka(1,m,n,x,l,h,i,j);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=w;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;oL(l,m,n,e0()|0,-1);break}case 5:{v=w+16|0;if((f[s+16>>2]|0)!=(f[v>>2]|0)){c=w+36|0;H=f[c>>2]|0;if(H|0){E=H+12|0;f[E>>2]=(f[E>>2]|0)+1}E=t+36|0;H=f[E>>2]|0;if(H|0?(F=H+12|0,H=f[F>>2]|0,f[F>>2]=H+-1,(H|0)==1):0)_S(t);f[E>>2]=0;H=t+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[a>>2]|0)>0){F=f[r>>2]|0;J=0;do{f[F+(J<<2)>>2]=0;J=J+1|0;Q=f[a>>2]|0}while((J|0)<(Q|0));f[t>>2]=f[w>>2];if((Q|0)<3)M=67;else M=69}else{f[t>>2]=f[w>>2];M=67}if((M|0)==67){J=f[w+4>>2]|0;if((J|0)<3){f[a>>2]=J;f[e>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];J=f[w+44>>2]|0;F=f[D>>2]|0;f[F>>2]=f[J>>2];f[F+4>>2]=f[J+4>>2]}else M=69}if((M|0)==69)ZS(t,w);f[H>>2]=f[v>>2];f[t+20>>2]=f[w+20>>2];f[t+24>>2]=f[w+24>>2];f[t+28>>2]=f[w+28>>2];f[t+32>>2]=f[w+32>>2];f[E>>2]=f[c>>2]}f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;J=n+8|0;f[J>>2]=0;f[J+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;J=g+4|0;F=f[J>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=F;aka(0,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;F=n+8|0;f[F>>2]=0;f[F+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;F=f[J>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=F;aka(1,m,n,x,l,h,i,j);fY(l,s,t);F=f[l>>2]|0;ei[f[(f[F>>2]|0)+12>>2]&511](F,l,w,-1);$j(l);break}case 6:{F=w+16|0;if((f[s+16>>2]|0)!=(f[F>>2]|0)){J=w+36|0;G=f[J>>2]|0;if(G|0){I=G+12|0;f[I>>2]=(f[I>>2]|0)+1}I=t+36|0;G=f[I>>2]|0;if(G|0?(R=G+12|0,G=f[R>>2]|0,f[R>>2]=G+-1,(G|0)==1):0)_S(t);f[I>>2]=0;G=t+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){R=f[r>>2]|0;S=0;do{f[R+(S<<2)>>2]=0;S=S+1|0;T=f[a>>2]|0}while((S|0)<(T|0));f[t>>2]=f[w>>2];if((T|0)<3)M=83;else M=85}else{f[t>>2]=f[w>>2];M=83}if((M|0)==83){S=f[w+4>>2]|0;if((S|0)<3){f[a>>2]=S;f[e>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];S=f[w+44>>2]|0;R=f[D>>2]|0;f[R>>2]=f[S>>2];f[R+4>>2]=f[S+4>>2]}else M=85}if((M|0)==85)ZS(t,w);f[G>>2]=f[F>>2];f[t+20>>2]=f[w+20>>2];f[t+24>>2]=f[w+24>>2];f[t+28>>2]=f[w+28>>2];f[t+32>>2]=f[w+32>>2];f[I>>2]=f[J>>2]}f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;S=n+8|0;f[S>>2]=0;f[S+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;S=g+4|0;R=f[S>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=R;aka(1,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;R=n+8|0;f[R>>2]=0;f[R+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;R=f[S>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=R;aka(0,m,n,x,l,h,i,j);fY(l,t,s);R=f[l>>2]|0;ei[f[(f[R>>2]|0)+12>>2]&511](R,l,w,-1);$j(l);break}case 7:{if(f[P>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;q=tT(l,21)|0;U=288681;N=q+21|0;do{b[q>>0]=b[U>>0]|0;q=q+1|0;U=U+1|0}while((q|0)<(N|0));z5(-215,l,264186,258811,2113)}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=o;if((N2(l)|0)<1){J=l+8|0;f[J>>2]=0;f[J+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=w;h_(s,l);break a}f[m>>2]=1124007936;J=m+4|0;I=m+8|0;F=m+40|0;q=J;N=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(N|0));f[F>>2]=I;G=m+48|0;R=m+44|0;f[R>>2]=G;f[G>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;S=n+4|0;c=n+8|0;E=n+40|0;q=S;N=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(N|0));f[E>>2]=c;I=n+48|0;v=n+44|0;f[v>>2]=I;f[I>>2]=0;f[n+52>>2]=0;f[x>>2]=1124007936;H=x+4|0;V=x+8|0;W=x+40|0;q=H;N=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(N|0));f[W>>2]=V;c=x+48|0;X=x+44|0;f[X>>2]=c;f[c>>2]=0;f[x+52>>2]=0;f[y>>2]=1124007936;Z=y+4|0;_=y+8|0;$=y+40|0;q=Z;N=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(N|0));f[$>>2]=_;aa=y+48|0;ba=y+44|0;f[ba>>2]=aa;f[aa>>2]=0;f[y+52>>2]=0;sY(l,o,1.0);ca=f[l>>2]|0;ei[f[(f[ca>>2]|0)+12>>2]&511](ca,l,m,-1);$j(l);sY(l,o,-1.0);ca=f[l>>2]|0;ei[f[(f[ca>>2]|0)+12>>2]&511](ca,l,n,-1);$j(l);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=m;if((N2(l)|0)<1){ca=f[O>>2]|0;da=f[ca+4>>2]|0;ea=f[ca>>2]|0;ca=f[P>>2]&4095;p[A>>3]=255.0;fa=A+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;f[fa+16>>2]=0;f[fa+20>>2]=0;f[z>>2]=1124007936;fa=z+4|0;ga=z+8|0;ha=z+40|0;q=fa;N=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(N|0));f[ha>>2]=ga;ia=z+48|0;ja=z+44|0;f[ja>>2]=ia;f[ia>>2]=0;f[z+52>>2]=0;f[l>>2]=ea;f[l+4>>2]=da;XS(z,2,l,ca);k_(z,A)|0;ka=z+36|0;la=f[ka>>2]|0;if(la|0){ma=la+12|0;f[ma>>2]=(f[ma>>2]|0)+1}ma=x+36|0;la=f[ma>>2]|0;if(la|0?(na=la+12|0,la=f[na>>2]|0,f[na>>2]=la+-1,(la|0)==1):0)_S(x);f[ma>>2]=0;la=x+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[H>>2]|0)>0){na=f[W>>2]|0;oa=0;do{f[na+(oa<<2)>>2]=0;oa=oa+1|0;pa=f[H>>2]|0}while((oa|0)<(pa|0));f[x>>2]=f[z>>2];if((pa|0)<3)M=103;else M=105}else{f[x>>2]=f[z>>2];M=103}if((M|0)==103){oa=f[fa>>2]|0;if((oa|0)<3){f[H>>2]=oa;f[V>>2]=f[ga>>2];f[x+12>>2]=f[z+12>>2];oa=f[ja>>2]|0;na=f[X>>2]|0;f[na>>2]=f[oa>>2];f[na+4>>2]=f[oa+4>>2]}else M=105}if((M|0)==105)ZS(x,z);oa=z+16|0;f[la>>2]=f[oa>>2];f[x+20>>2]=f[z+20>>2];f[x+24>>2]=f[z+24>>2];f[x+28>>2]=f[z+28>>2];f[x+32>>2]=f[z+32>>2];na=f[ka>>2]|0;f[ma>>2]=na;if(na|0?(ca=na+12|0,na=f[ca>>2]|0,f[ca>>2]=na+-1,(na|0)==1):0)_S(z);f[ka>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[fa>>2]|0)>0){oa=f[ha>>2]|0;na=0;do{f[oa+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[fa>>2]|0))}fa=f[ja>>2]|0;if((fa|0)!=(ia|0))g0(fa)}else{f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=s;fa=A+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[A>>2]=33619968;f[A+4>>2]=x;f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=m;fa=f[g+4>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=fa;aka(0,z,A,B,l,h,i,j)}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=n;if((N2(l)|0)<1){fa=f[O>>2]|0;na=f[fa+4>>2]|0;oa=f[fa>>2]|0;fa=f[P>>2]&4095;p[A>>3]=255.0;ha=A+8|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;f[ha+16>>2]=0;f[ha+20>>2]=0;f[z>>2]=1124007936;ha=z+4|0;ka=z+8|0;ma=z+40|0;q=ha;N=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(N|0));f[ma>>2]=ka;ia=z+48|0;ja=z+44|0;f[ja>>2]=ia;f[ia>>2]=0;f[z+52>>2]=0;f[l>>2]=oa;f[l+4>>2]=na;XS(z,2,l,fa);k_(z,A)|0;la=z+36|0;ga=f[la>>2]|0;if(ga|0){V=ga+12|0;f[V>>2]=(f[V>>2]|0)+1}V=y+36|0;ga=f[V>>2]|0;if(ga|0?(ca=ga+12|0,ga=f[ca>>2]|0,f[ca>>2]=ga+-1,(ga|0)==1):0)_S(y);f[V>>2]=0;ga=y+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[Z>>2]|0)>0){ca=f[$>>2]|0;da=0;do{f[ca+(da<<2)>>2]=0;da=da+1|0;qa=f[Z>>2]|0}while((da|0)<(qa|0));f[y>>2]=f[z>>2];if((qa|0)<3)M=127;else M=129}else{f[y>>2]=f[z>>2];M=127}if((M|0)==127){da=f[ha>>2]|0;if((da|0)<3){f[Z>>2]=da;f[_>>2]=f[ka>>2];f[y+12>>2]=f[z+12>>2];da=f[ja>>2]|0;ca=f[ba>>2]|0;f[ca>>2]=f[da>>2];f[ca+4>>2]=f[da+4>>2]}else M=129}if((M|0)==129)ZS(y,z);da=z+16|0;f[ga>>2]=f[da>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];f[y+32>>2]=f[z+32>>2];ca=f[la>>2]|0;f[V>>2]=ca;if(ca|0?(fa=ca+12|0,ca=f[fa>>2]|0,f[fa>>2]=ca+-1,(ca|0)==1):0)_S(z);f[la>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ha>>2]|0)>0){da=f[ma>>2]|0;ca=0;do{f[da+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[ha>>2]|0))}ha=f[ja>>2]|0;if((ha|0)!=(ia|0))g0(ha)}else{f[z>>2]=1124007936;ha=z+4|0;ca=z+8|0;da=z+40|0;q=ha;N=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(N|0));f[da>>2]=ca;ia=z+48|0;ja=z+44|0;f[ja>>2]=ia;f[ia>>2]=0;f[z+52>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=s;ma=A+8|0;f[ma>>2]=0;f[ma+4>>2]=0;f[A>>2]=33619968;f[A+4>>2]=z;hL(l,A,e0()|0);f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=z;ma=B+8|0;f[ma>>2]=0;f[ma+4>>2]=0;f[B>>2]=33619968;f[B+4>>2]=y;f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=n;ma=f[g+4>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=ma;aka(0,A,B,C,l,h,i,j);ma=z+36|0;la=f[ma>>2]|0;if(la|0?(V=la+12|0,la=f[V>>2]|0,f[V>>2]=la+-1,(la|0)==1):0)_S(z);f[ma>>2]=0;ma=z+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ha>>2]|0)>0){ma=f[da>>2]|0;la=0;do{f[ma+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[ha>>2]|0))}ha=f[ja>>2]|0;if((ha|0)!=(ia|0))g0(ha)}tY(l,x,y);ha=f[l>>2]|0;ei[f[(f[ha>>2]|0)+12>>2]&511](ha,l,w,-1);$j(l);ha=y+36|0;la=f[ha>>2]|0;if(la|0?(ma=la+12|0,la=f[ma>>2]|0,f[ma>>2]=la+-1,(la|0)==1):0)_S(y);f[ha>>2]=0;ha=y+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[Z>>2]|0)>0){ha=f[$>>2]|0;la=0;do{f[ha+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Z>>2]|0))}Z=f[ba>>2]|0;if((Z|0)!=(aa|0))g0(Z);Z=x+36|0;la=f[Z>>2]|0;if(la|0?(ha=la+12|0,la=f[ha>>2]|0,f[ha>>2]=la+-1,(la|0)==1):0)_S(x);f[Z>>2]=0;Z=x+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[H>>2]|0)>0){Z=f[W>>2]|0;la=0;do{f[Z+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[H>>2]|0))}H=f[X>>2]|0;if((H|0)!=(c|0))g0(H);H=n+36|0;la=f[H>>2]|0;if(la|0?(Z=la+12|0,la=f[Z>>2]|0,f[Z>>2]=la+-1,(la|0)==1):0)_S(n);f[H>>2]=0;H=n+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[S>>2]|0)>0){H=f[E>>2]|0;la=0;do{f[H+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[S>>2]|0))}S=f[v>>2]|0;if((S|0)!=(I|0))g0(S);S=m+36|0;la=f[S>>2]|0;do if(la|0){H=la+12|0;E=f[H>>2]|0;f[H>>2]=E+-1;if((E|0)!=1)break;_S(m)}while(0);f[S>>2]=0;la=m+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[J>>2]|0)>0){la=f[F>>2]|0;I=0;do{f[la+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[J>>2]|0))}J=f[R>>2]|0;if((J|0)!=(G|0))g0(J);break}default:{f[l>>2]=0;f[l+4>>2]=0;q=tT(l,31)|0;U=264199;N=q+31|0;do{b[q>>0]=b[U>>0]|0;q=q+1|0;U=U+1|0}while((q|0)<(N|0));z5(-5,l,264186,258811,2141)}}while(0);l=w+36|0;U=f[l>>2]|0;if(U|0?(q=U+12|0,U=f[q>>2]|0,f[q>>2]=U+-1,(U|0)==1):0)_S(w);f[l>>2]=0;l=w+16|0;U=w+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[U>>2]|0)>0){l=f[w+40>>2]|0;q=0;do{f[l+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[U>>2]|0))}U=f[w+44>>2]|0;if((U|0)!=(w+48|0))g0(U);U=t+36|0;w=f[U>>2]|0;if(w|0?(q=w+12|0,w=f[q>>2]|0,f[q>>2]=w+-1,(w|0)==1):0)_S(t);f[U>>2]=0;U=t+16|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[a>>2]|0)>0){U=f[r>>2]|0;r=0;do{f[U+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[a>>2]|0))}a=f[D>>2]|0;if((a|0)!=(L|0))g0(a);a=s+36|0;L=f[a>>2]|0;if(L|0?(D=L+12|0,L=f[D>>2]|0,f[D>>2]=L+-1,(L|0)==1):0)_S(s);f[a>>2]=0;a=s+16|0;L=s+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[L>>2]|0)>0){a=f[O>>2]|0;O=0;do{f[a+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[s+44>>2]|0;if((L|0)!=(s+48|0))g0(L);L=o+36|0;s=f[L>>2]|0;if(s|0?(O=s+12|0,s=f[O>>2]|0,f[O>>2]=s+-1,(s|0)==1):0)_S(o);f[L>>2]=0;L=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[L>>2]|0)>0){K=f[o+40>>2]|0;s=0;do{f[K+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[L>>2]|0))}L=f[o+44>>2]|0;if((L|0)==(o+48|0)){u=k;return}g0(L);u=k;return}function dka(a){a=a|0;XIc(a|0,0,192)|0;return}function eka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0;e=u;u=u+1344|0;g=e+256|0;h=e+312|0;i=e+248|0;j=e+192|0;k=e+136|0;l=e+8|0;m=e+120|0;o=e+104|0;q=e;r=e+88|0;s=c$(c,-1)|0;t=s&7;v=s&4088;b$(i,c,-1);if((f[i>>2]|0)>=1?(w=i+4|0,(f[w>>2]|0)>=1):0){do if((d$(c)|0)==65536){x=f[c+4>>2]|0;f[j>>2]=f[x>>2];y=j+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[x+8>>2];f[j+12>>2]=f[x+12>>2];f[j+16>>2]=f[x+16>>2];f[j+20>>2]=f[x+20>>2];f[j+24>>2]=f[x+24>>2];f[j+28>>2]=f[x+28>>2];f[j+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[j+36>>2]=B;f[j+40>>2]=A;A=j+48|0;C=j+44|0;f[C>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;ZS(j,x);break}}else a$(j,c,-1);while(0);if((t|1|0)==5&(pT(j,2,-1,1)|0)>-1){XIc(a|0,0,192)|0;c=pT(j,2,-1,1)|0;x=f[j>>2]|0;y=(x&7|0)==5;z=f[j+16>>2]|0;if((x&6|0)!=4){f[g>>2]=0;f[g+4>>2]=0;D=tT(g,54)|0;E=264231;F=D+54|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,g,264286,264301,101)}if(c|0){x=c+-1|0;if(y){G=+n[z+(x<<3)+4>>2];H=+n[z+(x<<3)>>2]}else{G=+(f[z+(x<<3)+4>>2]|0);H=+(f[z+(x<<3)>>2]|0)}I=H*H;J=G*G;if((c|0)>0)if(y){y=0;K=0.0;N=0.0;O=J;P=I;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=H;_=G;while(1){$=Z;Z=+n[z+(y<<3)>>2];aa=_;_=+n[z+(y<<3)+4>>2];ba=P;P=Z*Z;ca=O;O=_*_;da=$*_-aa*Z;ea=$+Z;fa=aa+_;ga=K+da;ha=ea*da;ia=N+ha;ja=fa*da;ka=Q+ja;la=R+da*(P+$*ea);ma=X+da*($*(aa+fa)+Z*(_+fa));na=W+da*(O+aa*fa);oa=V+(ba+P)*ha;ha=S+(ca+O)*ja;ja=U+da*(ba*(aa*3.0+_)+$*(Z*2.0)*fa+P*(aa+_*3.0));fa=T+da*(O*($+Z*3.0)+(ca*($*3.0+Z)+ea*(aa*(_*2.0))));y=y+1|0;if((y|0)==(c|0)){pa=ga;qa=ia;ra=ka;sa=la;ta=ha;ua=fa;va=ja;wa=oa;xa=na;ya=ma;break}else{K=ga;N=ia;Q=ka;R=la;S=ha;T=fa;U=ja;V=oa;W=na;X=ma}}}else{y=0;X=0.0;W=0.0;V=J;J=I;I=0.0;U=0.0;T=0.0;S=0.0;R=0.0;Q=0.0;N=0.0;K=0.0;_=H;H=G;while(1){G=_;_=+(f[z+(y<<3)>>2]|0);Z=H;H=+(f[z+(y<<3)+4>>2]|0);O=J;J=_*_;P=V;V=H*H;ma=G*H-Z*_;na=G+_;oa=Z+H;ja=X+ma;fa=na*ma;ha=W+fa;la=oa*ma;ka=I+la;ia=U+ma*(J+G*na);ga=K+ma*(G*(Z+oa)+_*(H+oa));aa=N+ma*(V+Z*oa);ea=Q+(O+J)*fa;fa=T+(P+V)*la;la=R+ma*(O*(Z*3.0+H)+G*(_*2.0)*oa+J*(Z+H*3.0));oa=S+ma*(V*(G+_*3.0)+(P*(G*3.0+_)+na*(Z*(H*2.0))));y=y+1|0;if((y|0)==(c|0)){pa=ja;qa=ha;ra=ka;sa=ia;ta=fa;ua=oa;va=la;wa=ea;xa=aa;ya=ga;break}else{X=ja;W=ha;I=ka;U=ia;T=fa;S=oa;R=la;Q=ea;N=aa;K=ga}}}else{pa=0.0;qa=0.0;ra=0.0;sa=0.0;ta=0.0;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0}if(+L(+pa)>1.1920928955078125e-07){c=pa>0.0;K=c?.16666666666666666:-.16666666666666666;N=c?.08333333333333333:-.08333333333333333;Q=c?.05:-.05;R=c?.016666666666666666:-.016666666666666666;S=pa*(c?.5:-.5);p[a>>3]=S;pa=qa*K;p[a+8>>3]=pa;qa=ra*K;p[a+16>>3]=qa;K=sa*N;p[a+24>>3]=K;sa=ya*(c?.041666666666666664:-.041666666666666664);p[a+32>>3]=sa;ya=xa*N;p[a+40>>3]=ya;N=wa*Q;p[a+48>>3]=N;wa=va*R;p[a+56>>3]=wa;va=ua*R;p[a+64>>3]=va;R=ta*Q;p[a+72>>3]=R;c=+L(+S)>2.220446049250313e-16;Q=1.0/S;S=c?Q:0.0;ta=c?qa*Q:0.0;ua=c?pa*Q:0.0;Q=pa*ua;xa=K-Q;K=pa*ta;pa=sa-K;sa=qa*ta;ra=ya-sa;p[a+80>>3]=xa;p[a+88>>3]=pa;p[a+96>>3]=ra;ya=N-ua*(Q+xa*3.0);p[a+104>>3]=ya;Q=pa+pa;N=wa-ua*(qa*ua+Q)-ta*xa;p[a+112>>3]=N;qa=va-ta*(K+Q)-ua*ra;p[a+120>>3]=qa;ua=R-ta*(sa+ra*3.0);p[a+128>>3]=ua;sa=S*S;ta=sa*+M(+(+L(+S)));p[a+136>>3]=sa*xa;p[a+144>>3]=sa*pa;p[a+152>>3]=sa*ra;p[a+160>>3]=ya*ta;p[a+168>>3]=N*ta;p[a+176>>3]=qa*ta;p[a+184>>3]=ua*ta}}}else{if(v|0){f[g>>2]=0;f[g+4>>2]=0;D=tT(g,43)|0;E=264370;F=D+43|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-5,g,264414,264301,681)}a:do if((t|0)==0|d)za=1194;else switch(s&7){case 2:{za=1195;break a;break}case 3:{za=1196;break a;break}case 5:{za=1197;break a;break}case 6:{za=1198;break a;break}default:{f[g>>2]=0;f[g+4>>2]=0;z5(-210,g,264414,264301,696)}}while(0);f[g>>2]=f[j>>2];s=g+4|0;t=j+4|0;E=f[t>>2]|0;f[s>>2]=E;D=g+8|0;f[D>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];F=g+16|0;f[F>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];v=g+36|0;c=f[j+36>>2]|0;f[v>>2]=c;y=g+40|0;f[y>>2]=D;D=g+48|0;z=g+44|0;f[z>>2]=D;f[D>>2]=0;f[g+52>>2]=0;if(!c)Aa=E;else{E=c+12|0;f[E>>2]=(f[E>>2]|0)+1;Aa=f[t>>2]|0}if((Aa|0)<3){Aa=f[j+44>>2]|0;t=f[z>>2]|0;f[t>>2]=f[Aa>>2];f[t+4>>2]=f[Aa+4>>2]}else{f[s>>2]=0;ZS(g,j)}Aa=f[w>>2]|0;if((Aa|0)>0){t=l+4|0;E=l+8|0;c=l+12|0;x=l+4|0;A=l+8|0;C=l+12|0;B=l+16|0;Ba=l+20|0;Ca=l+24|0;Da=l+28|0;Ea=l+40|0;Fa=l+48|0;Ga=l+44|0;Ha=l+52|0;Ia=m+8|0;Ja=m+12|0;Ka=m+4|0;La=o+8|0;Ma=o+12|0;Na=o+4|0;Oa=r+8|0;Pa=r+4|0;Qa=l+36|0;Ra=k+36|0;Sa=k+16|0;Ta=k+4|0;Ua=k+40|0;Va=k+8|0;Wa=k+12|0;Xa=k+44|0;Ya=k+20|0;Za=k+24|0;_a=k+28|0;$a=l+32|0;ab=k+32|0;bb=l+8|0;cb=l+16|0;db=l+24|0;eb=l+32|0;fb=l+40|0;gb=l+48|0;hb=l+56|0;ib=l+64|0;jb=l+72|0;kb=k+48|0;lb=Ca+8|0;mb=0;ta=0.0;ua=0.0;qa=0.0;N=0.0;ya=0.0;ra=0.0;sa=0.0;pa=0.0;xa=0.0;S=0.0;nb=Aa;Aa=f[i>>2]|0;while(1){ob=nb-mb|0;pb=(ob|0)<32?ob:32;if((Aa|0)>0){R=+(mb|0);ob=0;Q=ta;K=ua;va=qa;wa=N;T=ya;U=ra;I=sa;W=pa;X=xa;H=S;qb=Aa;do{rb=qb-ob|0;sb=(rb|0)<32?rb:32;f[l>>2]=ob;f[t>>2]=mb;f[E>>2]=sb;f[c>>2]=pb;cT(k,g,l);if(d){f[l>>2]=1124007936;f[x>>2]=2;f[A>>2]=pb;f[C>>2]=sb;f[B>>2]=h;f[Ba>>2]=h;rb=lb;f[rb>>2]=0;f[rb+4>>2]=0;f[Ea>>2]=A;f[Ga>>2]=Fa;rb=Y(sb,pb)|0;f[Fa>>2]=sb;f[Ha>>2]=1;tb=h+rb|0;f[Da>>2]=tb;f[Ca>>2]=tb+(0-sb)+sb;WS(l);f[Ia>>2]=0;f[Ja>>2]=0;f[m>>2]=16842752;f[Ka>>2]=k;p[q>>3]=0.0;f[o>>2]=-1056833530;f[Na>>2]=q;f[La>>2]=1;f[Ma>>2]=1;sb=Oa;f[sb>>2]=0;f[sb+4>>2]=0;f[r>>2]=33619968;f[Pa>>2]=l;uL(m,o,r,5);sb=f[Qa>>2]|0;if(sb|0){tb=sb+12|0;f[tb>>2]=(f[tb>>2]|0)+1}tb=f[Ra>>2]|0;do if(tb|0){sb=tb+12|0;rb=f[sb>>2]|0;f[sb>>2]=rb+-1;if((rb|0)!=1)break;_S(k)}while(0);f[Ra>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[Ta>>2]|0)>0){tb=f[Ua>>2]|0;rb=0;do{f[tb+(rb<<2)>>2]=0;rb=rb+1|0;ub=f[Ta>>2]|0}while((rb|0)<(ub|0));f[k>>2]=f[l>>2];if((ub|0)<3)vb=62;else vb=64}else{f[k>>2]=f[l>>2];vb=62}do if((vb|0)==62){vb=0;rb=f[x>>2]|0;if((rb|0)>=3){vb=64;break}f[Ta>>2]=rb;f[Va>>2]=f[A>>2];f[Wa>>2]=f[C>>2];rb=f[Ga>>2]|0;tb=f[Xa>>2]|0;f[tb>>2]=f[rb>>2];f[tb+4>>2]=f[rb+4>>2]}while(0);if((vb|0)==64){vb=0;ZS(k,l)}f[Sa>>2]=f[B>>2];f[Ya>>2]=f[Ba>>2];f[Za>>2]=f[Ca>>2];f[_a>>2]=f[Da>>2];f[ab>>2]=f[$a>>2];rb=f[Qa>>2]|0;f[Ra>>2]=rb;do if(rb|0){tb=rb+12|0;sb=f[tb>>2]|0;f[tb>>2]=sb+-1;if((sb|0)!=1)break;_S(l)}while(0);f[Qa>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[x>>2]|0)>0){rb=f[Ea>>2]|0;sb=0;do{f[rb+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[x>>2]|0))}sb=f[Ga>>2]|0;if((sb|0)!=(Fa|0))g0(sb)}mi[za&2047](k,l);_=+p[l>>3];if(d){V=_*.00392156862745098;p[l>>3]=V;J=+p[bb>>3]*.00392156862745098;p[bb>>3]=J;ga=+p[cb>>3]*.00392156862745098;p[cb>>3]=ga;aa=+p[db>>3]*.00392156862745098;p[db>>3]=aa;ea=+p[eb>>3]*.00392156862745098;p[eb>>3]=ea;la=+p[fb>>3]*.00392156862745098;p[fb>>3]=la;oa=+p[gb>>3]*.00392156862745098;p[gb>>3]=oa;fa=+p[hb>>3]*.00392156862745098;p[hb>>3]=fa;ia=+p[ib>>3]*.00392156862745098;p[ib>>3]=ia;ka=+p[jb>>3]*.00392156862745098;p[jb>>3]=ka;wb=V;xb=J;yb=ga;zb=aa;Ab=ea;Bb=la;Cb=oa;Db=fa;Eb=ia;Fb=ka}else{wb=_;xb=+p[bb>>3];yb=+p[cb>>3];zb=+p[db>>3];Ab=+p[eb>>3];Bb=+p[fb>>3];Cb=+p[gb>>3];Db=+p[hb>>3];Eb=+p[ib>>3];Fb=+p[jb>>3]}_=+(ob|0);ka=_*wb;ia=R*wb;Q=Q+wb;fa=xb+ka;H=H+fa;oa=ia+yb;K=K+oa;va=va+(zb+_*(ka+xb*2.0));la=_*oa;oa=R*xb;wa=wa+(oa+(Ab+la));T=T+(Bb+R*(ia+yb*2.0));U=U+(Cb+_*(zb*3.0+_*(ka+xb*3.0)));I=I+(R*zb+(Db+_*(la+(oa+Ab)*2.0)));W=W+(_*Bb+(Eb+R*(R*fa+(_*yb+Ab)*2.0)));X=X+(R*(R*(ia+yb*3.0)+Bb*3.0)+Fb);sb=f[Ra>>2]|0;do if(sb|0){rb=sb+12|0;tb=f[rb>>2]|0;f[rb>>2]=tb+-1;if((tb|0)!=1)break;_S(k)}while(0);f[Ra>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[Ta>>2]|0)>0){sb=f[Ua>>2]|0;tb=0;do{f[sb+(tb<<2)>>2]=0;tb=tb+1|0}while((tb|0)<(f[Ta>>2]|0))}tb=f[Xa>>2]|0;if((tb|0)!=(kb|0))g0(tb);ob=ob+32|0;qb=f[i>>2]|0}while((qb|0)>(ob|0));Gb=Q;Hb=K;Ib=va;Jb=wa;Kb=T;Lb=U;Mb=I;Nb=W;Ob=X;Pb=H;Qb=f[w>>2]|0;Rb=qb}else{Gb=ta;Hb=ua;Ib=qa;Jb=N;Kb=ya;Lb=ra;Mb=sa;Nb=pa;Ob=xa;Pb=S;Qb=nb;Rb=Aa}mb=mb+32|0;if((Qb|0)<=(mb|0)){Sb=Gb;Tb=Hb;Ub=Ib;Vb=Jb;Wb=Kb;Xb=Lb;Yb=Mb;Zb=Nb;_b=Ob;$b=Pb;break}else{ta=Gb;ua=Hb;qa=Ib;N=Jb;ya=Kb;ra=Lb;sa=Mb;pa=Nb;xa=Ob;S=Pb;nb=Qb;Aa=Rb}}}else{Sb=0.0;Tb=0.0;Ub=0.0;Vb=0.0;Wb=0.0;Xb=0.0;Yb=0.0;Zb=0.0;_b=0.0;$b=0.0}Rb=+L(+Sb)>2.220446049250313e-16;Pb=1.0/Sb;S=Rb?Pb:0.0;Ob=Rb?Tb*Pb:0.0;xa=Rb?$b*Pb:0.0;Pb=$b*xa;Nb=Ub-Pb;pa=$b*Ob;Mb=Vb-pa;sa=Tb*Ob;Lb=Wb-sa;ra=Xb-xa*(Pb+Nb*3.0);Pb=Mb+Mb;Kb=Yb-xa*(Tb*xa+Pb)-Ob*Nb;ya=Zb-Ob*(pa+Pb)-xa*Lb;xa=_b-Ob*(sa+Lb*3.0);sa=S*S;Ob=+M(+(+L(+S)))*sa;p[a>>3]=Sb;p[a+8>>3]=$b;p[a+16>>3]=Tb;p[a+24>>3]=Ub;p[a+32>>3]=Vb;p[a+40>>3]=Wb;p[a+48>>3]=Xb;p[a+56>>3]=Yb;p[a+64>>3]=Zb;p[a+72>>3]=_b;p[a+80>>3]=Nb;p[a+88>>3]=Mb;p[a+96>>3]=Lb;p[a+104>>3]=ra;p[a+112>>3]=Kb;p[a+120>>3]=ya;p[a+128>>3]=xa;p[a+136>>3]=sa*Nb;p[a+144>>3]=sa*Mb;p[a+152>>3]=sa*Lb;p[a+160>>3]=Ob*ra;p[a+168>>3]=Ob*Kb;p[a+176>>3]=Ob*ya;p[a+184>>3]=Ob*xa;Rb=f[v>>2]|0;if(Rb|0?(Aa=Rb+12|0,Rb=f[Aa>>2]|0,f[Aa>>2]=Rb+-1,(Rb|0)==1):0)_S(g);f[v>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[s>>2]|0)>0){F=f[y>>2]|0;y=0;do{f[F+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[s>>2]|0))}s=f[z>>2]|0;if((s|0)!=(D|0))g0(s)}s=j+36|0;D=f[s>>2]|0;if(D|0?(z=D+12|0,D=f[z>>2]|0,f[z>>2]=D+-1,(D|0)==1):0)_S(j);f[s>>2]=0;s=j+16|0;D=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[D>>2]|0)>0){s=f[j+40>>2]|0;z=0;do{f[s+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[D>>2]|0))}D=f[j+44>>2]|0;if((D|0)!=(j+48|0))g0(D);u=e;return}XIc(a|0,0,192)|0;u=e;return}function fka(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0;c=f[a+40>>2]|0;e=f[c+4>>2]|0;g=f[c>>2]|0;if((g|0)>0?(c=f[a+16>>2]|0,h=f[f[a+44>>2]>>2]|0,(e|0)>0):0){a=0;i=0;j=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;do{D=c+(Y(h,a)|0)|0;E=0;F=0;G=0;H=0;I=0;K=0;do{L=d[D+(H<<1)>>1]|0;M=Y(L,H)|0;G=L+G|0;F=M+F|0;L=Y(M,H)|0;E=L+E|0;M=Y(L,H)|0;I=UIc(M|0,((M|0)<0)<<31>>31|0,I|0,K|0)|0;K=J;H=H+1|0}while((H|0)!=(e|0));H=Y(G,a)|0;D=Y(a,a)|0;M=((H|0)<0)<<31>>31;L=mJc(H|0,M|0,D|0,0)|0;z=UIc(z|0,A|0,L|0,J|0)|0;A=J;L=((F|0)<0)<<31>>31;N=mJc(F|0,L|0,D|0,0)|0;B=UIc(B|0,C|0,N|0,J|0)|0;C=J;N=((E|0)<0)<<31>>31;O=mJc(E|0,N|0,a|0,((a|0)<0)<<31>>31|0)|0;i=UIc(i|0,j|0,O|0,J|0)|0;j=J;k=UIc(k|0,l|0,I|0,K|0)|0;l=J;O=Y(G,D)|0;m=UIc(m|0,n|0,O|0,((O|0)<0)<<31>>31|0)|0;n=J;O=Y(F,a)|0;o=UIc(o|0,q|0,O|0,((O|0)<0)<<31>>31|0)|0;q=J;r=UIc(r|0,s|0,E|0,N|0)|0;s=J;t=UIc(t|0,u|0,H|0,M|0)|0;u=J;v=UIc(v|0,w|0,F|0,L|0)|0;w=J;x=UIc(x|0,y|0,G|0,((G|0)<0)<<31>>31|0)|0;y=J;a=a+1|0}while((a|0)!=(g|0));P=+(x>>>0)+4294967296.0*+(y|0);Q=+(v>>>0)+4294967296.0*+(w|0);R=+(t>>>0)+4294967296.0*+(u|0);S=+(r>>>0)+4294967296.0*+(s|0);T=+(o>>>0)+4294967296.0*+(q|0);U=+(m>>>0)+4294967296.0*+(n|0);V=+(k>>>0)+4294967296.0*+(l|0);W=+(i>>>0)+4294967296.0*+(j|0);X=+(B>>>0)+4294967296.0*+(C|0);Z=+(z>>>0)+4294967296.0*+(A|0)}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0}p[b>>3]=P;p[b+8>>3]=Q;p[b+16>>3]=R;p[b+24>>3]=S;p[b+32>>3]=T;p[b+40>>3]=U;p[b+48>>3]=V;p[b+56>>3]=W;p[b+64>>3]=X;p[b+72>>3]=Z;return}function gka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0;c=u;u=u+80|0;d=c;e=f[a+40>>2]|0;g=f[e+4>>2]|0;h=f[e>>2]|0;e=d;i=e+80|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));if((h|0)<=0){e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}k=f[a+16>>2]|0;l=f[f[a+44>>2]>>2]|0;a=d+72|0;m=d+64|0;o=d+56|0;q=d+48|0;r=d+40|0;s=d+32|0;t=d+24|0;v=d+16|0;w=d+8|0;if((g|0)>0){x=0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;while(1){I=k+(Y(l,x)|0)|0;J=0.0;K=0.0;L=0.0;M=0.0;N=0;do{O=+n[I+(N<<2)>>2];P=+(N|0);Q=P*O;M=M+O;L=L+Q;O=P*Q;K=K+O;J=J+P*O;N=N+1|0}while((N|0)!=(g|0));O=+(x|0);P=O*M;Q=+(Y(x,x)|0);R=Q*P+y;S=Q*L+z;T=O*K+A;U=J+B;V=Q*M+C;Q=O*L+D;O=K+E;W=P+F;P=L+G;X=M+H;x=x+1|0;if((x|0)==(h|0)){Z=R;_=S;$=T;aa=U;ba=V;ca=Q;da=O;ea=W;fa=P;ga=X;break}else{y=R;z=S;A=T;B=U;C=V;D=Q;E=O;F=W;G=P;H=X}}}else{x=0;H=0.0;G=0.0;F=0.0;E=0.0;D=0.0;C=0.0;while(1){B=+(x|0)*0.0;A=+(Y(x,x)|0);z=A*B+H;y=A*0.0;A=y+G;X=B+F;P=y+E;y=B+D;W=B+C;x=x+1|0;if((x|0)==(h|0)){Z=z;_=A;$=X;aa=0.0;ba=P;ca=y;da=0.0;ea=W;fa=0.0;ga=0.0;break}else{H=z;G=A;F=X;E=P;D=y;C=W}}}p[a>>3]=Z;p[m>>3]=_;p[o>>3]=$;p[q>>3]=aa;p[r>>3]=ba;p[s>>3]=ca;p[t>>3]=da;p[v>>3]=ea;p[w>>3]=fa;p[d>>3]=ga;e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}function hka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0;c=u;u=u+80|0;d=c;e=f[a+40>>2]|0;g=f[e+4>>2]|0;h=f[e>>2]|0;e=d;i=e+80|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));if((h|0)<=0){e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}k=f[a+16>>2]|0;l=f[f[a+44>>2]>>2]|0;a=d+72|0;m=d+64|0;n=d+56|0;o=d+48|0;q=d+40|0;r=d+32|0;s=d+24|0;t=d+16|0;v=d+8|0;if((g|0)>0){w=0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;while(1){H=k+(Y(l,w)|0)|0;I=0.0;J=0.0;K=0.0;L=0.0;M=0;do{N=+p[H+(M<<3)>>3];O=+(M|0);P=O*N;L=L+N;K=K+P;N=O*P;J=J+N;I=I+O*N;M=M+1|0}while((M|0)!=(g|0));N=+(w|0);O=N*L;P=+(Y(w,w)|0);Q=P*O+x;R=P*K+y;S=N*J+z;T=I+A;U=P*L+B;P=N*K+C;N=J+D;V=O+E;O=K+F;W=L+G;w=w+1|0;if((w|0)==(h|0)){X=Q;Z=R;_=S;$=T;aa=U;ba=P;ca=N;da=V;ea=O;fa=W;break}else{x=Q;y=R;z=S;A=T;B=U;C=P;D=N;E=V;F=O;G=W}}}else{w=0;G=0.0;F=0.0;E=0.0;D=0.0;C=0.0;B=0.0;while(1){A=+(w|0)*0.0;z=+(Y(w,w)|0);y=z*A+G;x=z*0.0;z=x+F;W=A+E;O=x+D;x=A+C;V=A+B;w=w+1|0;if((w|0)==(h|0)){X=y;Z=z;_=W;$=0.0;aa=O;ba=x;ca=0.0;da=V;ea=0.0;fa=0.0;break}else{G=y;F=z;E=W;D=O;C=x;B=V}}}p[a>>3]=X;p[m>>3]=Z;p[n>>3]=_;p[o>>3]=$;p[q>>3]=aa;p[r>>3]=ba;p[s>>3]=ca;p[t>>3]=da;p[v>>3]=ea;p[d>>3]=fa;e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}function ika(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;c=f[a+40>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;if((e|0)>0?(c=f[a+16>>2]|0,g=f[f[a+44>>2]>>2]|0,(d|0)>0):0){a=0;i=0;j=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;do{t=c+(Y(g,a)|0)|0;u=0;v=0;w=0;x=0;y=0;do{z=h[t+y>>0]|0;A=Y(z,y)|0;x=z+x|0;w=A+w|0;z=Y(A,y)|0;v=z+v|0;u=(Y(z,y)|0)+u|0;y=y+1|0}while((y|0)!=(d|0));y=Y(x,a)|0;t=Y(a,a)|0;i=i+(Y(y,t)|0)|0;j=j+(Y(w,t)|0)|0;k=k+(Y(v,a)|0)|0;l=l+u|0;m=m+(Y(x,t)|0)|0;n=n+(Y(w,a)|0)|0;o=o+v|0;q=q+y|0;r=r+w|0;s=s+x|0;a=a+1|0}while((a|0)!=(e|0));B=+(s|0);C=+(r|0);D=+(q|0);E=+(o|0);F=+(n|0);G=+(m|0);H=+(l|0);I=+(k|0);J=+(j|0);K=+(i|0)}else{B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0}p[b>>3]=B;p[b+8>>3]=C;p[b+16>>3]=D;p[b+24>>3]=E;p[b+32>>3]=F;p[b+40>>3]=G;p[b+48>>3]=H;p[b+56>>3]=I;p[b+64>>3]=J;p[b+72>>3]=K;return}function jka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0;c=f[a+40>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;if((e|0)>0?(c=f[a+16>>2]|0,g=f[f[a+44>>2]>>2]|0,(d|0)>0):0){a=0;h=0;i=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;do{D=c+(Y(g,a)|0)|0;E=0;F=0;G=0;H=0;I=0;K=0;do{L=j[D+(H<<1)>>1]|0;M=Y(L,H)|0;G=L+G|0;F=M+F|0;L=Y(M,H)|0;E=L+E|0;M=Y(L,H)|0;I=UIc(M|0,((M|0)<0)<<31>>31|0,I|0,K|0)|0;K=J;H=H+1|0}while((H|0)!=(d|0));H=Y(G,a)|0;D=Y(a,a)|0;M=((H|0)<0)<<31>>31;L=mJc(H|0,M|0,D|0,0)|0;z=UIc(z|0,A|0,L|0,J|0)|0;A=J;L=((F|0)<0)<<31>>31;N=mJc(F|0,L|0,D|0,0)|0;B=UIc(B|0,C|0,N|0,J|0)|0;C=J;N=((E|0)<0)<<31>>31;O=mJc(E|0,N|0,a|0,((a|0)<0)<<31>>31|0)|0;h=UIc(h|0,i|0,O|0,J|0)|0;i=J;k=UIc(k|0,l|0,I|0,K|0)|0;l=J;O=Y(G,D)|0;m=UIc(m|0,n|0,O|0,((O|0)<0)<<31>>31|0)|0;n=J;O=Y(F,a)|0;o=UIc(o|0,q|0,O|0,((O|0)<0)<<31>>31|0)|0;q=J;r=UIc(r|0,s|0,E|0,N|0)|0;s=J;t=UIc(t|0,u|0,H|0,M|0)|0;u=J;v=UIc(v|0,w|0,F|0,L|0)|0;w=J;x=UIc(x|0,y|0,G|0,((G|0)<0)<<31>>31|0)|0;y=J;a=a+1|0}while((a|0)!=(e|0));P=+(x>>>0)+4294967296.0*+(y|0);Q=+(v>>>0)+4294967296.0*+(w|0);R=+(t>>>0)+4294967296.0*+(u|0);S=+(r>>>0)+4294967296.0*+(s|0);T=+(o>>>0)+4294967296.0*+(q|0);U=+(m>>>0)+4294967296.0*+(n|0);V=+(k>>>0)+4294967296.0*+(l|0);W=+(h>>>0)+4294967296.0*+(i|0);X=+(B>>>0)+4294967296.0*+(C|0);Z=+(z>>>0)+4294967296.0*+(A|0)}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0}p[b>>3]=P;p[b+8>>3]=Q;p[b+16>>3]=R;p[b+24>>3]=S;p[b+32>>3]=T;p[b+40>>3]=U;p[b+48>>3]=V;p[b+56>>3]=W;p[b+64>>3]=X;p[b+72>>3]=Z;return}function kka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0.0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;c=a+160|0;d=a+176|0;e=+p[c>>3]+ +p[d>>3];f=a+168|0;g=a+184|0;h=+p[f>>3]+ +p[g>>3];i=e*e;j=h*h;k=a+144|0;l=+p[k>>3]*4.0;m=+p[a+136>>3];n=+p[a+152>>3];o=m-n;p[b>>3]=m+n;p[b+8>>3]=o*o+l*+p[k>>3];p[b+24>>3]=i+j;p[b+40>>3]=h*(e*l)+(i-j)*o;o=e*(i-j*3.0);e=h*(i*3.0-j);j=+p[c>>3]-+p[d>>3]*3.0;i=+p[f>>3]*3.0-+p[g>>3];p[b+16>>3]=j*j+i*i;p[b+32>>3]=o*j+e*i;p[b+48>>3]=o*i-e*j;return}function lka(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0;d=u;u=u+4240|0;e=d+4184|0;g=d+4128|0;i=d+4112|0;j=d+2064|0;k=d+8|0;l=d;do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[e>>2]=f[m>>2];n=e+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=e+8|0;f[p>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[e+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[e+36>>2]=q;f[e+40>>2]=p;p=e+48|0;r=e+44|0;f[r>>2]=p;f[p>>2]=0;f[e+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;ZS(e,m);break}}else a$(e,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[g>>2]=f[a>>2];m=g+4|0;n=a+4|0;f[m>>2]=f[n>>2];o=g+8|0;f[o>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[g+16>>2]=f[a+16>>2];f[g+20>>2]=f[a+20>>2];f[g+24>>2]=f[a+24>>2];f[g+28>>2]=f[a+28>>2];f[g+32>>2]=f[a+32>>2];p=f[a+36>>2]|0;f[g+36>>2]=p;f[g+40>>2]=o;o=g+48|0;r=g+44|0;f[r>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[a+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[m>>2]=0;ZS(g,a);break}}else a$(g,c,-1);while(0);c=e+40|0;a=f[c>>2]|0;m=f[a+4>>2]|0;n=f[a>>2]|0;f[i>>2]=0;a=i+4|0;f[a>>2]=0;f[i+8>>2]=0;XIc(j|0,0,2048)|0;if((f[e>>2]&4095|0)!=16){f[l>>2]=0;s=l+4|0;f[s>>2]=0;t=tT(l,47)|0;v=t;w=264422;x=v+47|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,l,264470,264480,161)}if((f[g>>2]&4095|0)!=4){f[l>>2]=0;s=l+4|0;f[s>>2]=0;t=tT(l,47)|0;v=t;w=264422;x=v+47|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,l,264470,264480,161)}t=g+40|0;s=f[t>>2]|0;if(!((n|0)==(f[s>>2]|0)?(m|0)==(f[s+4>>2]|0):0)){f[l>>2]=0;f[l+4>>2]=0;v=tT(l,24)|0;w=288826;x=v+24|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,l,264470,264480,162)}l=e+16|0;w=f[l>>2]|0;v=e+48|0;x=f[v>>2]|0;s=g+16|0;o=f[s>>2]|0;r=g+48|0;p=f[r>>2]|0;XIc(k|0,0,1024)|0;q=e+44|0;y=g+44|0;z=p>>>2;p=256;do{f[k+(p<<2)>>2]=p+-256;p=p+1|0}while((p|0)!=513);p=n+-1|0;if((m|0)>0){n=Y(z,p)|0;A=0;do{f[o+(A+n<<2)>>2]=-1;f[o+(A<<2)>>2]=-1;A=A+1|0}while((A|0)!=(m|0))}if((p|0)>1){A=m+-1|0;m=(A|0)>1;n=0-z|0;B=0-x|0;C=0;D=o;o=w;w=1;E=0;F=0;G=0;H=0;I=0;J=0;while(1){o=o+x|0;D=D+(z<<2)|0;f[D+(A<<2)>>2]=-1;f[D>>2]=-1;if(m){K=Y(w,z)|0;L=Y(w,x)|0;M=C;N=1;O=J;P=E;Q=F;R=G;S=H;T=I;while(1){U=D+(N<<2)|0;V=f[U>>2]|0;if((V|0)>=0)if(!V)W=33;else{X=M;Z=P;_=Q;$=R;aa=S;ba=T;ca=O}else{f[U>>2]=0;W=33}do if((W|0)==33){W=0;if((f[U+-4>>2]|0)>0){V=N*3|0;da=o+V|0;ea=da+-3|0;fa=(h[da>>0]|0)-(h[ea>>0]|0)|0;ga=(h[da+1>>0]|0)-(h[ea+1>>0]|0)|0;ha=(ga|0)>-1?ga:0-ga|0;ga=(h[da+2>>0]|0)-(h[ea+2>>0]|0)|0;ea=(ga|0)>-1?ga:0-ga|0;ia=ea+(f[k+((f[k+(((fa|0)>-1?fa:0-fa|0)+256-ha<<2)>>2]|0)+256+ha-ea<<2)>>2]|0)|0;ja=f[U+4>>2]|0;ka=da;la=V}else{V=f[U+4>>2]|0;if(((V|0)<=0?(f[U+(n<<2)>>2]|0)<=0:0)?(f[U+(z<<2)>>2]|0)<=0:0){X=M;Z=P;_=Q;$=R;aa=S;ba=T;ca=O;break}da=N*3|0;ia=256;ja=V;ka=o+da|0;la=da}if((ja|0)>0){da=(h[ka>>0]|0)-(h[ka+3>>0]|0)|0;V=(h[ka+1>>0]|0)-(h[ka+4>>0]|0)|0;ea=(V|0)>-1?V:0-V|0;V=(h[ka+2>>0]|0)-(h[ka+5>>0]|0)|0;ha=(V|0)>-1?V:0-V|0;ma=ia-(f[k+(ia+256-(f[k+((f[k+(((da|0)>-1?da:0-da|0)+256-ea<<2)>>2]|0)+256+ea-ha<<2)>>2]|0)-ha<<2)>>2]|0)|0}else ma=ia;if((f[U+(n<<2)>>2]|0)>0){ha=ka+B|0;ea=(h[ka>>0]|0)-(h[ha>>0]|0)|0;da=(h[ka+1>>0]|0)-(h[ha+1>>0]|0)|0;V=(da|0)>-1?da:0-da|0;da=(h[ka+2>>0]|0)-(h[ha+2>>0]|0)|0;ha=(da|0)>-1?da:0-da|0;na=ma-(f[k+(ma+256-(f[k+((f[k+(((ea|0)>-1?ea:0-ea|0)+256-V<<2)>>2]|0)+256+V-ha<<2)>>2]|0)-ha<<2)>>2]|0)|0}else na=ma;if((f[U+(z<<2)>>2]|0)>0){ha=ka+x|0;V=(h[ka>>0]|0)-(h[ha>>0]|0)|0;ea=(h[ka+1>>0]|0)-(h[ha+1>>0]|0)|0;da=(ea|0)>-1?ea:0-ea|0;ea=(h[ka+2>>0]|0)-(h[ha+2>>0]|0)|0;ha=(ea|0)>-1?ea:0-ea|0;oa=na-(f[k+(na+256-(f[k+((f[k+(((V|0)>-1?V:0-V|0)+256-da<<2)>>2]|0)+256+da-ha<<2)>>2]|0)-ha<<2)>>2]|0)|0}else oa=na;if(!M){ha=f[a>>2]|0;da=ha-O|0;V=(da|0)/12|0;ea=V*3|0;fa=(ea|0)>257?(ea|0)/2|0:128;ea=O;ga=ha;do if(fa>>>0>V>>>0){mka(i,fa-V|0);W=51}else{if(fa>>>0>=V>>>0){W=51;break}ha=ea+(fa*12|0)|0;if((ga|0)==(ha|0)){pa=V;qa=T;break}f[a>>2]=ga+(~(((ga+-12-ha|0)>>>0)/12|0)*12|0);pa=V;qa=T}while(0);do if((W|0)==51){W=0;ga=f[i>>2]|0;if(da|0){pa=V;qa=ga;break}f[ga>>2]=0;pa=1;qa=ga}while(0);V=fa+-1|0;if((pa|0)<(V|0)){da=pa;do{ga=da;da=da+1|0;f[qa+(ga*12|0)>>2]=da}while((da|0)!=(V|0))}f[qa+(V*12|0)>>2]=0;ra=pa;sa=qa}else{ra=M;sa=T}da=sa+(ra*12|0)|0;fa=f[da>>2]|0;f[da>>2]=0;f[sa+(ra*12|0)+4>>2]=N+K;f[sa+(ra*12|0)+8>>2]=la+L;da=j+(oa<<3)+4|0;ga=f[da>>2]|0;ea=f[i>>2]|0;f[((ga|0)==0?j+(oa<<3)|0:ea+(ga*12|0)|0)>>2]=ra;f[da>>2]=ra;f[U>>2]=-2;da=ea;X=fa;Z=da;_=da;$=da;aa=da;ba=ea;ca=da}while(0);N=N+1|0;if((N|0)>=(A|0)){ta=X;ua=Z;va=_;wa=$;xa=aa;ya=ba;za=ca;break}else{M=X;O=ca;P=Z;Q=_;R=$;S=aa;T=ba}}}else{ta=C;ua=E;va=F;wa=G;xa=H;ya=I;za=J}w=w+1|0;if((w|0)>=(p|0)){Aa=ta;Ba=ua;Ca=va;Da=wa;Ea=xa;Fa=ya;break}else{C=ta;E=ua;F=va;G=wa;H=xa;I=ya;J=za}}}else{Aa=0;Ba=0;Ca=0;Da=0;Ea=0;Fa=0}za=0;while(1){if(f[j+(za<<3)>>2]|0){Ga=za;W=62;break}za=za+1|0;if((za|0)>=256){W=61;break}}if((W|0)==61)if((za|0)==256)Ha=Fa;else{Ga=za;W=62}a:do if((W|0)==62){za=f[l>>2]|0;J=f[s>>2]|0;ya=0-z|0;I=0-x|0;xa=Ga;H=Aa;wa=Ba;G=Ca;va=Da;F=Ea;ua=Fa;while(1){E=xa;ta=H;while(1){C=f[j+(E<<3)>>2]|0;b:do if(!C){p=E;while(1){Ia=p+1|0;if((Ia|0)>=256)break;w=f[j+(Ia<<3)>>2]|0;if(!w)p=Ia;else{Ja=Ia;Ka=w;break b}}if((Ia|0)==256){Ha=ua;break a}Ja=Ia;Ka=f[j+(Ia<<3)>>2]|0}else{Ja=E;Ka=C}while(0);C=ua+(Ka*12|0)|0;V=f[C>>2]|0;f[j+(Ja<<3)>>2]=V;if(!V)f[j+(Ja<<3)+4>>2]=0;f[C>>2]=ta;La=f[ua+(Ka*12|0)+4>>2]|0;Ma=f[ua+(Ka*12|0)+8>>2]|0;Na=J+(La<<2)|0;Oa=Na+-4|0;Pa=f[Oa>>2]|0;C=(Pa|0)>0?Pa:0;Qa=Na+4|0;Ra=f[Qa>>2]|0;if((Ra|0)>0)Sa=(Pa|0)<1?Ra:(Ra|0)==(C|0)?C:-1;else Sa=C;Ta=Na+(ya<<2)|0;C=f[Ta>>2]|0;if((C|0)>0)Ua=(Sa|0)==0?C:(C|0)==(Sa|0)?Sa:-1;else Ua=Sa;Va=Na+(z<<2)|0;Wa=f[Va>>2]|0;if((Wa|0)>0)if(!Ua){W=77;break}else Xa=(Wa|0)==(Ua|0)?Ua:-1;else Xa=Ua;f[Na>>2]=Xa;if((Xa|0)==-1){E=Ja;ta=Ka}else break}if((W|0)==77){W=0;f[Na>>2]=Wa}ta=za+Ma|0;if(!Pa){E=ta+-3|0;C=(h[ta>>0]|0)-(h[E>>0]|0)|0;V=(h[ta+1>>0]|0)-(h[E+1>>0]|0)|0;p=(V|0)>-1?V:0-V|0;V=(h[ta+2>>0]|0)-(h[E+2>>0]|0)|0;E=(V|0)>-1?V:0-V|0;V=E+(f[k+((f[k+(((C|0)>-1?C:0-C|0)+256-p<<2)>>2]|0)+256+p-E<<2)>>2]|0)|0;if(!Ka){E=f[a>>2]|0;p=E-F|0;C=(p|0)/12|0;w=C*3|0;ba=(w|0)>257?(w|0)/2|0:128;w=F;aa=E;if(ba>>>0<=C>>>0)if(ba>>>0<C>>>0){E=w+(ba*12|0)|0;if((aa|0)==(E|0)){Ya=C;Za=ua}else{f[a>>2]=aa+(~(((aa+-12-E|0)>>>0)/12|0)*12|0);Ya=C;Za=ua}}else W=86;else{mka(i,ba-C|0);W=86}if((W|0)==86){W=0;E=f[i>>2]|0;if(!p){f[E>>2]=0;Ya=1;Za=E}else{Ya=C;Za=E}}E=ba+-1|0;if((Ya|0)<(E|0)){ba=Ya;do{C=ba;ba=ba+1|0;f[Za+(C*12|0)>>2]=ba}while((ba|0)!=(E|0))}f[Za+(E*12|0)>>2]=0;_a=Ya;$a=Za}else{_a=Ka;$a=ua}ba=$a+(_a*12|0)|0;C=f[ba>>2]|0;f[ba>>2]=0;f[$a+(_a*12|0)+4>>2]=La+-1;f[$a+(_a*12|0)+8>>2]=Ma+-3;ba=j+(V<<3)+4|0;p=f[ba>>2]|0;aa=f[i>>2]|0;f[((p|0)==0?j+(V<<3)|0:aa+(p*12|0)|0)>>2]=_a;f[ba>>2]=_a;ba=Ja-(f[k+(Ja+256-V<<2)>>2]|0)|0;f[Oa>>2]=-2;p=aa;ab=ba;bb=C;cb=f[Qa>>2]|0;db=p;eb=p;fb=p;gb=p;hb=aa}else{ab=Ja;bb=Ka;cb=Ra;db=va;eb=wa;fb=G;gb=F;hb=ua}if(!cb){aa=ta+3|0;p=(h[ta>>0]|0)-(h[aa>>0]|0)|0;C=(h[ta+1>>0]|0)-(h[aa+1>>0]|0)|0;ba=(C|0)>-1?C:0-C|0;C=(h[ta+2>>0]|0)-(h[aa+2>>0]|0)|0;aa=(C|0)>-1?C:0-C|0;C=aa+(f[k+((f[k+(((p|0)>-1?p:0-p|0)+256-ba<<2)>>2]|0)+256+ba-aa<<2)>>2]|0)|0;if(!bb){aa=f[a>>2]|0;ba=aa-db|0;p=(ba|0)/12|0;w=p*3|0;$=(w|0)>257?(w|0)/2|0:128;w=db;_=aa;if($>>>0<=p>>>0)if($>>>0<p>>>0){aa=w+($*12|0)|0;if((_|0)==(aa|0)){ib=p;jb=hb}else{f[a>>2]=_+(~(((_+-12-aa|0)>>>0)/12|0)*12|0);ib=p;jb=hb}}else W=99;else{mka(i,$-p|0);W=99}if((W|0)==99){W=0;aa=f[i>>2]|0;if(!ba){f[aa>>2]=0;ib=1;jb=aa}else{ib=p;jb=aa}}aa=$+-1|0;if((ib|0)<(aa|0)){$=ib;do{p=$;$=$+1|0;f[jb+(p*12|0)>>2]=$}while(($|0)!=(aa|0))}f[jb+(aa*12|0)>>2]=0;kb=ib;lb=jb}else{kb=bb;lb=hb}$=lb+(kb*12|0)|0;V=f[$>>2]|0;f[$>>2]=0;f[lb+(kb*12|0)+4>>2]=La+1;f[lb+(kb*12|0)+8>>2]=Ma+3;$=j+(C<<3)+4|0;E=f[$>>2]|0;p=f[i>>2]|0;f[((E|0)==0?j+(C<<3)|0:p+(E*12|0)|0)>>2]=kb;f[$>>2]=kb;$=ab-(f[k+(ab+256-C<<2)>>2]|0)|0;f[Qa>>2]=-2;E=p;mb=$;nb=V;ob=E;pb=E;qb=E;rb=E;sb=p}else{mb=ab;nb=bb;ob=fb;pb=eb;qb=db;rb=gb;sb=hb}if(!(f[Ta>>2]|0)){p=ta+I|0;E=(h[ta>>0]|0)-(h[p>>0]|0)|0;V=(h[ta+1>>0]|0)-(h[p+1>>0]|0)|0;$=(V|0)>-1?V:0-V|0;V=(h[ta+2>>0]|0)-(h[p+2>>0]|0)|0;p=(V|0)>-1?V:0-V|0;V=p+(f[k+((f[k+(((E|0)>-1?E:0-E|0)+256-$<<2)>>2]|0)+256+$-p<<2)>>2]|0)|0;if(!nb){p=f[a>>2]|0;$=p-ob|0;E=($|0)/12|0;ba=E*3|0;_=(ba|0)>257?(ba|0)/2|0:128;ba=ob;w=p;if(_>>>0<=E>>>0)if(_>>>0<E>>>0){p=ba+(_*12|0)|0;if((w|0)==(p|0)){tb=E;ub=sb}else{f[a>>2]=w+(~(((w+-12-p|0)>>>0)/12|0)*12|0);tb=E;ub=sb}}else W=112;else{mka(i,_-E|0);W=112}if((W|0)==112){W=0;p=f[i>>2]|0;if(!$){f[p>>2]=0;tb=1;ub=p}else{tb=E;ub=p}}p=_+-1|0;if((tb|0)<(p|0)){_=tb;do{E=_;_=_+1|0;f[ub+(E*12|0)>>2]=_}while((_|0)!=(p|0))}f[ub+(p*12|0)>>2]=0;vb=tb;wb=ub}else{vb=nb;wb=sb}_=wb+(vb*12|0)|0;C=f[_>>2]|0;f[_>>2]=0;f[wb+(vb*12|0)+4>>2]=La-z;f[wb+(vb*12|0)+8>>2]=Ma-x;_=j+(V<<3)+4|0;aa=f[_>>2]|0;E=f[i>>2]|0;f[((aa|0)==0?j+(V<<3)|0:E+(aa*12|0)|0)>>2]=vb;f[_>>2]=vb;_=mb-(f[k+(mb+256-V<<2)>>2]|0)|0;f[Ta>>2]=-2;aa=E;xb=C;yb=_;zb=aa;Ab=aa;Bb=aa;Cb=aa;Db=E}else{xb=nb;yb=mb;zb=pb;Ab=ob;Bb=qb;Cb=rb;Db=sb}if(f[Va>>2]|0){xa=yb;H=xb;wa=zb;G=Ab;va=Bb;F=Cb;ua=Db;continue}E=ta+x|0;aa=(h[ta>>0]|0)-(h[E>>0]|0)|0;_=(h[ta+1>>0]|0)-(h[E+1>>0]|0)|0;C=(_|0)>-1?_:0-_|0;_=(h[ta+2>>0]|0)-(h[E+2>>0]|0)|0;E=(_|0)>-1?_:0-_|0;_=E+(f[k+((f[k+(((aa|0)>-1?aa:0-aa|0)+256-C<<2)>>2]|0)+256+C-E<<2)>>2]|0)|0;if(!xb){E=f[a>>2]|0;C=E-zb|0;aa=(C|0)/12|0;$=aa*3|0;w=($|0)>257?($|0)/2|0:128;$=zb;ba=E;if(w>>>0<=aa>>>0)if(w>>>0<aa>>>0){E=$+(w*12|0)|0;if((ba|0)==(E|0)){Eb=aa;Fb=Db}else{f[a>>2]=ba+(~(((ba+-12-E|0)>>>0)/12|0)*12|0);Eb=aa;Fb=Db}}else W=125;else{mka(i,w-aa|0);W=125}if((W|0)==125){W=0;E=f[i>>2]|0;if(!C){f[E>>2]=0;Eb=1;Fb=E}else{Eb=aa;Fb=E}}E=w+-1|0;if((Eb|0)<(E|0)){w=Eb;do{aa=w;w=w+1|0;f[Fb+(aa*12|0)>>2]=w}while((w|0)!=(E|0))}f[Fb+(E*12|0)>>2]=0;Gb=Eb;Hb=Fb}else{Gb=xb;Hb=Db}w=Hb+(Gb*12|0)|0;ta=f[w>>2]|0;f[w>>2]=0;f[Hb+(Gb*12|0)+4>>2]=La+z;f[Hb+(Gb*12|0)+8>>2]=Ma+x;w=j+(_<<3)+4|0;V=f[w>>2]|0;p=f[i>>2]|0;f[((V|0)==0?j+(_<<3)|0:p+(V*12|0)|0)>>2]=Gb;f[w>>2]=Gb;w=yb-(f[k+(yb+256-_<<2)>>2]|0)|0;f[Va>>2]=-2;V=p;xa=w;H=ta;wa=V;G=V;va=V;F=V;ua=p}}while(0);if(Ha|0){Va=f[a>>2]|0;if((Va|0)!=(Ha|0))f[a>>2]=Va+(~(((Va+-12-Ha|0)>>>0)/12|0)*12|0);YDc(Ha)}Ha=g+36|0;Va=f[Ha>>2]|0;if(Va|0?(a=Va+12|0,Va=f[a>>2]|0,f[a>>2]=Va+-1,(Va|0)==1):0)_S(g);f[Ha>>2]=0;Ha=g+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[Ha>>2]|0)>0){s=f[t>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[Ha>>2]|0))}Ha=f[y>>2]|0;if((Ha|0)!=(r|0))g0(Ha);Ha=e+36|0;r=f[Ha>>2]|0;if(r|0?(y=r+12|0,r=f[y>>2]|0,f[y>>2]=r+-1,(r|0)==1):0)_S(e);f[Ha>>2]=0;Ha=e+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[Ha>>2]|0)>0){l=f[c>>2]|0;c=0;do{f[l+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[Ha>>2]|0))}Ha=f[q>>2]|0;if((Ha|0)==(v|0)){u=d;return}g0(Ha);u=d;return}function mka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)mCc(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=k+(d*12|0)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=k+12|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(((b|0)/-12|0)*12|0)|0;if((b|0)>0)dJc(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;YDc(d);return}function nka(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0;g=u;u=u+304|0;h=g+248|0;i=g+192|0;j=g;eka(j,a,0);kka(j,h);eka(j,c,0);kka(j,i);switch(d|0){case 1:{d=0;c=0;e=0.0;a=0;while(1){k=+p[h+(a<<3)>>3];l=+L(+k);m=+p[i+(a<<3)>>3];n=+L(+m);c=k!=k|0.0!=0.0|k==0.0?c:1;d=m!=m|0.0!=0.0|m==0.0?d:1;if(l>1.0e-05&n>1.0e-05){o=1.0/((k>0.0?1.0:k<0.0?-1.0:0.0)*+krc(l));q=e+ +L(+(1.0/((m>0.0?1.0:m<0.0?-1.0:0.0)*+krc(n))-o))}else q=e;a=a+1|0;if((a|0)==7)break;else e=q}r=(d&1)!=0;s=(c&1)!=0;t=q;v=s^r;w=v?1797693134862315708145274.0e284:t;u=g;return +w}case 2:{c=0;d=0;a=0;q=0.0;while(1){e=+p[h+(c<<3)>>3];o=+L(+e);n=+p[i+(c<<3)>>3];m=+L(+n);a=e!=e|0.0!=0.0|e==0.0?a:1;d=n!=n|0.0!=0.0|n==0.0?d:1;if(o>1.0e-05&m>1.0e-05){l=(e>0.0?1.0:e<0.0?-1.0:0.0)*+krc(o);x=q+ +L(+((n>0.0?1.0:n<0.0?-1.0:0.0)*+krc(m)-l))}else x=q;c=c+1|0;if((c|0)==7)break;else q=x}r=(d&1)!=0;s=(a&1)!=0;t=x;v=s^r;w=v?1797693134862315708145274.0e284:t;u=g;return +w}case 3:{a=0;d=0;c=0;x=0.0;while(1){q=+p[h+(a<<3)>>3];l=+L(+q);m=+p[i+(a<<3)>>3];n=+L(+m);y=c|q==q&0.0==0.0&q!=0.0;z=d|m==m&0.0==0.0&m!=0.0;if(l>1.0e-05&n>1.0e-05?(o=(q>0.0?1.0:q<0.0?-1.0:0.0)*+krc(l),l=+L(+((o-(m>0.0?1.0:m<0.0?-1.0:0.0)*+krc(n))/o)),x<l):0)A=l;else A=x;a=a+1|0;if((a|0)==7){r=z;s=y;t=A;break}else{d=z;c=y;x=A}}v=s^r;w=v?1797693134862315708145274.0e284:t;u=g;return +w}default:{f[j>>2]=0;f[j+4>>2]=0;g=tT(j,25)|0;v=264554;r=g+25|0;do{b[g>>0]=b[v>>0]|0;g=g+1|0;v=v+1|0}while((g|0)<(r|0));z5(-5,j,264580,264592,161)}}return +(0.0)}function oka(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0.0,Pb=0,Qb=0,Rb=0,Sb=0.0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0;i=u;u=u+1520|0;k=i+472|0;l=i;m=i+328|0;o=i+248|0;p=i+192|0;q=i+320|0;r=i+312|0;s=i+136|0;t=i+304|0;do if((d$(a)|0)==65536){v=f[a+4>>2]|0;f[o>>2]=f[v>>2];w=o+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=o+8|0;f[y>>2]=f[v+8>>2];f[o+12>>2]=f[v+12>>2];f[o+16>>2]=f[v+16>>2];f[o+20>>2]=f[v+20>>2];f[o+24>>2]=f[v+24>>2];f[o+28>>2]=f[v+28>>2];f[o+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[o+36>>2]=z;A=o+40|0;f[A>>2]=y;y=o+48|0;B=o+44|0;f[B>>2]=y;f[y>>2]=0;f[o+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];C=o;D=A;break}else{f[w>>2]=0;ZS(o,v);C=o;D=A;break}}else{a$(o,a,-1);C=o;D=o+40|0}while(0);f[p>>2]=1124007936;a=p+4|0;A=p+8|0;v=p+40|0;w=a;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));f[v>>2]=A;y=p+48|0;B=p+44|0;f[B>>2]=y;f[y>>2]=0;f[p+52>>2]=0;z=f[D>>2]|0;E=f[z+4>>2]|0;F=f[z>>2]|0;G=f[C>>2]|0;C=G>>>3&511;H=G&7;G=(H|0)==0;I=(H|0)==2;if((H|2|0)!=2){f[k>>2]=0;f[k+4>>2]=0;w=tT(k,33)|0;J=264667;x=w+33|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-215,k,1670)}K=o+16|0;if(!(f[K>>2]|0)){f[k>>2]=0;L=k+4|0;f[L>>2]=0;M=tT(k,12)|0;w=M;J=374774;x=w+12|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-215,k,1671)}N=o+4|0;O=f[N>>2]|0;if((O|0)<3)P=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{Q=1;R=F;while(1){S=Y(f[z+(Q<<2)>>2]|0,R)|0;Q=Q+1|0;if((Q|0)==(O|0)){P=S;break}else R=S}}if((O|0)==0|(P|0)==0){f[k>>2]=0;L=k+4|0;f[L>>2]=0;M=tT(k,12)|0;w=M;J=374774;x=w+12|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-215,k,1671)}a:do switch(e|0){case 89:case 88:case 87:case 86:{if(!((g|0)<2&(C|0)==0)){f[k>>2]=0;f[k+4>>2]=0;w=tT(k,20)|0;J=264701;x=w+20|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-215,k,1678)}f[q>>2]=E;f[q+4>>2]=F;v$(c,q,H,-1,0,0);do if((d$(c)|0)==65536){M=f[c+4>>2]|0;f[k>>2]=f[M>>2];L=k+4|0;P=M+4|0;f[L>>2]=f[P>>2];O=k+8|0;f[O>>2]=f[M+8>>2];f[k+12>>2]=f[M+12>>2];f[k+16>>2]=f[M+16>>2];f[k+20>>2]=f[M+20>>2];f[k+24>>2]=f[M+24>>2];f[k+28>>2]=f[M+28>>2];f[k+32>>2]=f[M+32>>2];R=k+36|0;Q=f[M+36>>2]|0;f[R>>2]=Q;f[k+40>>2]=O;O=k+48|0;z=k+44|0;f[z>>2]=O;f[O>>2]=0;f[k+52>>2]=0;if(Q|0){O=Q+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[P>>2]|0)<3){P=f[M+44>>2]|0;O=f[z>>2]|0;f[O>>2]=f[P>>2];f[O+4>>2]=f[P+4>>2];T=R;break}else{f[L>>2]=0;ZS(k,M);T=R;break}}else{a$(k,c,-1);T=k+36|0}while(0);R=f[T>>2]|0;if(R|0){M=R+12|0;f[M>>2]=(f[M>>2]|0)+1}M=p+36|0;R=f[M>>2]|0;if(R|0?(L=R+12|0,R=f[L>>2]|0,f[L>>2]=R+-1,(R|0)==1):0)_S(p);f[M>>2]=0;R=p+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[a>>2]|0)>0){L=f[v>>2]|0;P=0;do{f[L+(P<<2)>>2]=0;P=P+1|0;U=f[a>>2]|0}while((P|0)<(U|0));f[p>>2]=f[k>>2];if((U|0)<3)V=36;else V=38}else{f[p>>2]=f[k>>2];V=36}if((V|0)==36){P=f[k+4>>2]|0;if((P|0)<3){f[a>>2]=P;f[A>>2]=f[k+8>>2];f[p+12>>2]=f[k+12>>2];P=f[k+44>>2]|0;L=f[B>>2]|0;f[L>>2]=f[P>>2];f[L+4>>2]=f[P+4>>2]}else V=38}if((V|0)==38)ZS(p,k);P=k+16|0;f[R>>2]=f[P>>2];f[p+20>>2]=f[k+20>>2];f[p+24>>2]=f[k+24>>2];f[p+28>>2]=f[k+28>>2];f[p+32>>2]=f[k+32>>2];L=f[T>>2]|0;f[M>>2]=L;if(L|0?(O=L+12|0,L=f[O>>2]|0,f[O>>2]=L+-1,(L|0)==1):0)_S(k);f[T>>2]=0;L=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[L>>2]|0)>0){P=f[k+40>>2]|0;O=0;do{f[P+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[k+44>>2]|0;if((L|0)!=(k+48|0))g0(L);if(G){L=f[D>>2]|0;O=f[L+4>>2]|0;P=f[L>>2]|0;L=k+4|0;z=(e&-2|0)==86;Q=P+-2|0;f[L>>2]=Q;f[k>>2]=O+-2;if((P|0)>2){f[l>>2]=0;f[l+4>>2]=Q;qka(m,o,p,((e|0)==87|(e|0)==89)&1,z,k,z?1868:4899,z?4899:1868);z=f[a>>2]|0;if((z|0)<3)W=Y(f[p+12>>2]|0,f[A>>2]|0)|0;else{Q=f[v>>2]|0;P=0;O=1;while(1){S=Y(f[Q+(P<<2)>>2]|0,O)|0;P=P+1|0;if((P|0)==(z|0)){W=S;break}else O=S}}y8(l,m,+(W>>>0)*.0000152587890625);rka(m)}O=f[v>>2]|0;z=f[O+4>>2]|0;P=f[O>>2]|0;f[k>>2]=z;f[L>>2]=P;O=f[R>>2]|0;Q=f[y>>2]|0;S=(z|0)>0;do if((P|0)>2){if(S){z=0;do{b[O+z>>0]=b[O+(z+Q)>>0]|0;X=f[L>>2]|0;Z=O+((Y(X+-2|0,Q)|0)+z)|0;_=O+((Y(X+-1|0,Q)|0)+z)|0;b[_>>0]=b[Z>>0]|0;z=z+1|0}while((z|0)<(f[k>>2]|0))}}else if(S){z=O+(Y(P+-1|0,Q)|0)|0;b[z>>0]=0;b[O>>0]=0;if((f[k>>2]|0)>1)$=1;else break;do{z=O+((Y((f[L>>2]|0)+-1|0,Q)|0)+$)|0;b[z>>0]=0;b[O+$>>0]=0;$=$+1|0}while(($|0)<(f[k>>2]|0))}while(0);aa=M;break a}if(!I){f[k>>2]=0;f[k+4>>2]=0;w=tT(k,54)|0;J=264722;x=w+54|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-210,k,1688)}O=f[D>>2]|0;Q=f[O+4>>2]|0;L=f[O>>2]|0;O=k+4|0;P=(e&-2|0)==86;S=L+-2|0;f[O>>2]=S;f[k>>2]=Q+-2;if((L|0)>2){f[l>>2]=0;f[l+4>>2]=S;ska(m,o,p,((e|0)==87|(e|0)==89)&1,P,k,P?1868:4899,P?4899:1868);P=f[a>>2]|0;if((P|0)<3)ba=Y(f[p+12>>2]|0,f[A>>2]|0)|0;else{S=f[v>>2]|0;L=0;Q=1;while(1){z=Y(f[S+(L<<2)>>2]|0,Q)|0;L=L+1|0;if((L|0)==(P|0)){ba=z;break}else Q=z}}y8(l,m,+(ba>>>0)*.0000152587890625);tka(m)}Q=f[v>>2]|0;P=f[Q+4>>2]|0;L=f[Q>>2]|0;f[k>>2]=P;f[O>>2]=L;Q=f[R>>2]|0;S=(f[y>>2]|0)>>>1;z=(P|0)>0;if((L|0)>2){if(z){Z=Y(S,L+-2|0)|0;_=Y(S,L+-1|0)|0;X=0;do{d[Q+(X<<1)>>1]=d[Q+(X+S<<1)>>1]|0;d[Q+(X+_<<1)>>1]=d[Q+(X+Z<<1)>>1]|0;X=X+1|0}while((X|0)!=(P|0))}}else if(z){X=Y(S,L+-1|0)|0;Z=0;do{d[Q+(Z+X<<1)>>1]=0;d[Q+(Z<<1)>>1]=0;Z=Z+1|0}while((Z|0)!=(P|0))}aa=M;break}case 142:case 141:case 140:case 139:{ca=(g|0)<1?4:g;V=78;break}case 65:case 64:case 63:case 62:case 49:case 48:case 47:case 46:{ca=g;V=78;break}case 138:case 137:case 136:case 135:{if(!(((g|0)<1|(g|0)==3)&(C|0)==0)){f[k>>2]=0;f[k+4>>2]=0;w=tT(k,20)|0;J=264866;x=w+20|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-215,k,1729)}f[t>>2]=E;f[t+4>>2]=F;v$(c,t,H|16,-1,0,0);do if((d$(c)|0)==65536){M=f[c+4>>2]|0;f[k>>2]=f[M>>2];P=k+4|0;Z=M+4|0;f[P>>2]=f[Z>>2];Q=k+8|0;f[Q>>2]=f[M+8>>2];f[k+12>>2]=f[M+12>>2];f[k+16>>2]=f[M+16>>2];f[k+20>>2]=f[M+20>>2];f[k+24>>2]=f[M+24>>2];f[k+28>>2]=f[M+28>>2];f[k+32>>2]=f[M+32>>2];X=k+36|0;L=f[M+36>>2]|0;f[X>>2]=L;f[k+40>>2]=Q;Q=k+48|0;S=k+44|0;f[S>>2]=Q;f[Q>>2]=0;f[k+52>>2]=0;if(L|0){Q=L+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[Z>>2]|0)<3){Z=f[M+44>>2]|0;Q=f[S>>2]|0;f[Q>>2]=f[Z>>2];f[Q+4>>2]=f[Z+4>>2];da=X;break}else{f[P>>2]=0;ZS(k,M);da=X;break}}else{a$(k,c,-1);da=k+36|0}while(0);X=f[da>>2]|0;if(X|0){M=X+12|0;f[M>>2]=(f[M>>2]|0)+1}M=p+36|0;X=f[M>>2]|0;if(X|0?(P=X+12|0,X=f[P>>2]|0,f[P>>2]=X+-1,(X|0)==1):0)_S(p);f[M>>2]=0;X=p+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[a>>2]|0)>0){P=f[v>>2]|0;Z=0;do{f[P+(Z<<2)>>2]=0;Z=Z+1|0;ea=f[a>>2]|0}while((Z|0)<(ea|0));f[p>>2]=f[k>>2];if((ea|0)<3)V=199;else V=201}else{f[p>>2]=f[k>>2];V=199}if((V|0)==199){Z=f[k+4>>2]|0;if((Z|0)<3){f[a>>2]=Z;f[A>>2]=f[k+8>>2];f[p+12>>2]=f[k+12>>2];Z=f[k+44>>2]|0;P=f[B>>2]|0;f[P>>2]=f[Z>>2];f[P+4>>2]=f[Z+4>>2]}else V=201}if((V|0)==201)ZS(p,k);Z=k+16|0;f[X>>2]=f[Z>>2];f[p+20>>2]=f[k+20>>2];f[p+24>>2]=f[k+24>>2];f[p+28>>2]=f[k+28>>2];f[p+32>>2]=f[k+32>>2];P=f[da>>2]|0;f[M>>2]=P;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)_S(k);f[da>>2]=0;P=k+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[P>>2]|0)>0){Z=f[k+40>>2]|0;Q=0;do{f[Z+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[P>>2]|0))}P=f[k+44>>2]|0;if((P|0)!=(k+48|0))g0(P);if(G){P=f[D>>2]|0;Q=f[P+4>>2]|0;Z=f[P>>2]|0;f[k>>2]=Q;P=k+4|0;f[P>>2]=Z;b:do if((Q|0)<3|(Z|0)<3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;k_(p,l)|0}else{f[k>>2]=Q+-2;f[P>>2]=Z+-2;xka(l,o,p,k,(e+-135|0)>>>0<2&1,(e|2|0)==138&1);S=f[P>>2]|0;f[m>>2]=0;f[m+4>>2]=S;S=f[a>>2]|0;if((S|0)<3)fa=Y(f[p+12>>2]|0,f[A>>2]|0)|0;else{L=f[v>>2]|0;z=0;_=1;while(1){R=Y(f[L+(z<<2)>>2]|0,_)|0;z=z+1|0;if((z|0)==(S|0)){fa=R;break}else _=R}}y8(m,l,+(fa>>>0)*.0000152587890625);yka(l);_=f[v>>2]|0;S=f[_+4>>2]|0;z=f[_>>2]|0;f[P>>2]=z;_=f[p>>2]|0;L=Y((_>>>3&511)+1|0,S)|0;f[k>>2]=L;S=((f[y>>2]|0)>>>0)/((1212424721>>>(_<<2&28)&15)>>>0)|0;_=f[X>>2]|0;R=_+(Y(S,z+-1|0)|0)|0;O=(L|0)>0;if((z|0)<=2){if(O)ga=0;else break;while(1){b[R+ga>>0]=0;b[_+ga>>0]=0;ga=ga+1|0;if((ga|0)>=(f[k>>2]|0))break b}}if(!O)break;z=_+S|0;L=R+(0-S)|0;ha=0;do{b[_+ha>>0]=b[z+ha>>0]|0;b[R+ha>>0]=b[L+ha>>0]|0;ha=ha+1|0}while((ha|0)<(f[k>>2]|0))}while(0);aa=M;break a}if(!I){f[k>>2]=0;f[k+4>>2]=0;w=tT(k,74)|0;J=264887;x=w+74|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-210,k,1738)}P=f[D>>2]|0;Z=f[P+4>>2]|0;Q=f[P>>2]|0;f[k>>2]=Z;P=k+4|0;f[P>>2]=Q;c:do if((Z|0)<3|(Q|0)<3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;k_(p,l)|0}else{f[k>>2]=Z+-2;f[P>>2]=Q+-2;zka(l,o,p,k,(e+-135|0)>>>0<2&1,(e|2|0)==138&1);ha=f[P>>2]|0;f[m>>2]=0;f[m+4>>2]=ha;ha=f[a>>2]|0;if((ha|0)<3)ia=Y(f[p+12>>2]|0,f[A>>2]|0)|0;else{L=f[v>>2]|0;R=0;z=1;while(1){_=Y(f[L+(R<<2)>>2]|0,z)|0;R=R+1|0;if((R|0)==(ha|0)){ia=_;break}else z=_}}y8(m,l,+(ia>>>0)*.0000152587890625);Aka(l);z=f[v>>2]|0;ha=f[z+4>>2]|0;R=f[z>>2]|0;f[P>>2]=R;z=f[p>>2]|0;L=Y((z>>>3&511)+1|0,ha)|0;f[k>>2]=L;ha=((f[y>>2]|0)>>>0)/((1212424721>>>(z<<2&28)&15)>>>0)|0;z=f[X>>2]|0;_=z+((Y(ha,R+-1|0)|0)<<1)|0;S=(L|0)>0;if((R|0)<=2){if(S)ja=0;else break;while(1){d[_+(ja<<1)>>1]=0;d[z+(ja<<1)>>1]=0;ja=ja+1|0;if((ja|0)==(L|0))break c}}if(!S)break;R=z+(ha<<1)|0;O=_+(0-ha<<1)|0;ka=0;do{d[z+(ka<<1)>>1]=d[R+(ka<<1)>>1]|0;d[_+(ka<<1)>>1]=d[O+(ka<<1)>>1]|0;ka=ka+1|0}while((ka|0)!=(L|0))}while(0);aa=M;break}default:{f[k>>2]=0;f[k+4>>2]=0;w=tT(k,43)|0;J=264962;x=w+43|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-206,k,1743)}}while(0);if((V|0)==78){V=(ca|0)<1?3:ca;if(!((C|0)==0&(V+-3|0)>>>0<2)){f[k>>2]=0;f[k+4>>2]=0;w=tT(k,34)|0;J=264777;x=w+34|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-215,k,1700)}f[r>>2]=E;f[r+4>>2]=F;v$(c,r,(V<<3)+-8|H,-1,0,0);do if((d$(c)|0)==65536){H=f[c+4>>2]|0;f[s>>2]=f[H>>2];V=s+4|0;r=H+4|0;f[V>>2]=f[r>>2];F=s+8|0;f[F>>2]=f[H+8>>2];f[s+12>>2]=f[H+12>>2];f[s+16>>2]=f[H+16>>2];f[s+20>>2]=f[H+20>>2];f[s+24>>2]=f[H+24>>2];f[s+28>>2]=f[H+28>>2];f[s+32>>2]=f[H+32>>2];E=f[H+36>>2]|0;f[s+36>>2]=E;f[s+40>>2]=F;F=s+48|0;C=s+44|0;f[C>>2]=F;f[F>>2]=0;f[s+52>>2]=0;if(E|0){F=E+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[r>>2]|0)<3){r=f[H+44>>2]|0;F=f[C>>2]|0;f[F>>2]=f[r>>2];f[F+4>>2]=f[r+4>>2];break}else{f[V>>2]=0;ZS(s,H);break}}else a$(s,c,-1);while(0);d:do switch(e|0){case 46:case 47:case 48:case 49:case 139:case 140:case 141:case 142:{if(G){uka(o,s,e);break d}if(!I){f[k>>2]=0;f[k+4>>2]=0;w=tT(k,53)|0;J=264812;x=w+53|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-210,k,1715)}c=(f[s+48>>2]|0)>>>1;H=f[D>>2]|0;V=f[H+4>>2]|0;r=f[H>>2]|0;f[k>>2]=V;H=k+4|0;f[H>>2]=r;switch(e|0){case 46:case 47:case 139:{la=-1;break}default:la=(e|0)==140?-1:1}switch(e|0){case 142:case 47:case 49:case 140:{ma=1;break}default:ma=0}F=((f[s>>2]|0)>>>3&511)+1|0;C=r+-2|0;f[H>>2]=C;f[k>>2]=V+-2;if((r|0)>2){f[l>>2]=0;f[l+4>>2]=C;vka(m,o,s,ma,la,k);C=f[s+4>>2]|0;if((C|0)<3)na=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{r=f[s+40>>2]|0;V=0;E=1;while(1){ca=Y(f[r+(V<<2)>>2]|0,E)|0;V=V+1|0;if((V|0)==(C|0)){na=ca;break}else E=ca}}y8(l,m,+(na>>>0)*.0000152587890625);wka(m)}E=f[s+40>>2]|0;C=f[E+4>>2]|0;V=f[E>>2]|0;f[k>>2]=C;f[H>>2]=V;E=f[s+16>>2]|0;r=Y(C,F)|0;C=(r|0)>0;if((V|0)>2){if(C){ca=Y(V+-2|0,c)|0;ja=Y(V+-1|0,c)|0;ia=0;do{d[E+(ia<<1)>>1]=d[E+(ia+c<<1)>>1]|0;d[E+(ia+ja<<1)>>1]=d[E+(ia+ca<<1)>>1]|0;ia=ia+1|0}while((ia|0)!=(r|0))}}else if(C){ia=Y(V+-1|0,c)|0;ca=0;do{d[E+(ca+ia<<1)>>1]=0;d[E+(ca<<1)>>1]=0;ca=ca+1|0}while((ca|0)!=(r|0))}break}default:{if(!G){f[k>>2]=0;f[k+4>>2]=0;w=tT(k,14)|0;J=373096;x=w+14|0;do{b[w>>0]=b[J>>0]|0;w=w+1|0;J=J+1|0}while((w|0)<(x|0));pka(-215,k,1719)}r=f[K>>2]|0;ca=f[o+48>>2]|0;E=f[s+16>>2]|0;ia=f[s+48>>2]|0;c=f[D>>2]|0;V=f[c+4>>2]|0;C=f[c>>2]|0;if((((V|0)>(C|0)?C:V)|0)<8){uka(o,s,e);break d}c=V<<1;ja=V*3|0;F=V<<2;H=V*5|0;A=V*6|0;ga=V*49|0;fa=V*147|0;da=k+8|0;f[k>>2]=da;ea=k+4|0;f[ea>>2]=fa;if(fa>>>0>520){t=XDc(fa>>>0>2147483647?-1:fa<<1)|0;f[k>>2]=t;oa=t}else oa=da;t=ca<<1;fa=r+t|0;r=C+-4|0;if((r|0)>2){g=V+-2|0;ba=V+-1|0;$=(ba|0)>1;W=~ca;T=ca+-1|0;U=0-ca|0;q=1-ca|0;M=ca+1|0;X=(g|0)>2;P=ja+-9|0;Q=g*3|0;Z=V+1|0;L=c|1;ka=c+-1|0;O=ja+-1|0;_=ja+1|0;R=U<<1;z=R+-1|0;ha=R|1;S=t+-1|0;pa=t|1;qa=-2-ca|0;ra=ca+-2|0;sa=2-ca|0;ta=ca+2|0;ua=F|1;va=F+-1|0;wa=H+-1|0;xa=H+1|0;ya=Y(ca,-2)|0;za=ya+2|0;Aa=A|1;Ba=t+-2|0;Ca=A+-1|0;Da=ya+-2|0;ya=t+2|0;Ea=g+V|0;Fa=g+c|0;Ga=g+ja|0;Ha=g+F|0;Ia=g+H|0;Ja=g+A|0;Ka=(e|1|0)==63?0:2;La=2;Ma=(e|0)!=62&(e|0)!=64;while(1){Na=Y(La,ia)|0;Oa=(La|0)==2?-1:1;do{Pa=Oa+La|0;Qa=oa+((Y((Pa+-1|0)%3|0,ga)|0)<<1)+2|0;d[Qa+(g<<1)>>1]=0;d[Qa+-2>>1]=0;d[Qa+(Ea<<1)>>1]=0;d[Qa+(ba<<1)>>1]=0;d[Qa+(Fa<<1)>>1]=0;d[Qa+(ka<<1)>>1]=0;d[Qa+(Ga<<1)>>1]=0;d[Qa+(O<<1)>>1]=0;d[Qa+(Ha<<1)>>1]=0;d[Qa+(va<<1)>>1]=0;d[Qa+(Ia<<1)>>1]=0;d[Qa+(wa<<1)>>1]=0;d[Qa+(Ja<<1)>>1]=0;d[Qa+(Ca<<1)>>1]=0;if($){Ra=Qa;Qa=fa+(Y(Pa,ca)|0)+1|0;Pa=1;while(1){Sa=Qa+W|0;Ta=Qa+T|0;Ua=(h[Sa>>0]|0)-(h[Ta>>0]|0)|0;Va=Qa+U|0;Wa=Qa+ca|0;Xa=(h[Va>>0]|0)-(h[Wa>>0]|0)|0;Ya=Qa+q|0;Za=Qa+M|0;_a=(h[Ya>>0]|0)-(h[Za>>0]|0)|0;d[Ra>>1]=(((Xa|0)>-1?Xa:0-Xa|0)<<1)+((Ua|0)>-1?Ua:0-Ua|0)+((_a|0)>-1?_a:0-_a|0);_a=(h[Sa>>0]|0)-(h[Ya>>0]|0)|0;Ua=Qa+-1|0;Qa=Qa+1|0;Xa=(h[Ua>>0]|0)-(h[Qa>>0]|0)|0;$a=(h[Ta>>0]|0)-(h[Za>>0]|0)|0;d[Ra+(V<<1)>>1]=(((Xa|0)>-1?Xa:0-Xa|0)<<1)+((_a|0)>-1?_a:0-_a|0)+(($a|0)>-1?$a:0-$a|0);$a=(h[Ya>>0]|0)-(h[Ta>>0]|0)|0;Ta=Ra+(c<<1)|0;d[Ta>>1]=(($a|0)>-1?$a:0-$a|0)<<1;$a=(h[Sa>>0]|0)-(h[Za>>0]|0)|0;Za=Ra+(ja<<1)|0;d[Za>>1]=(($a|0)>-1?$a:0-$a|0)<<1;$a=(h[Va>>0]|0)-(h[Ua>>0]|0)|0;Sa=(h[Wa>>0]|0)-(h[Qa>>0]|0)|0;d[Ra+(F<<1)>>1]=(($a|0)>-1?$a:0-$a|0)+(j[Ta>>1]|0)+((Sa|0)>-1?Sa:0-Sa|0);Sa=(h[Va>>0]|0)-(h[Qa>>0]|0)|0;Ta=(h[Wa>>0]|0)-(h[Ua>>0]|0)|0;d[Ra+(H<<1)>>1]=((Sa|0)>-1?Sa:0-Sa|0)+(j[Za>>1]|0)+((Ta|0)>-1?Ta:0-Ta|0);d[Ra+(A<<1)>>1]=((h[Ua>>0]|0)+(h[Va>>0]|0)+(h[Qa>>0]|0)+(h[Wa>>0]|0)|0)>>>1;Pa=Pa+1|0;if((Pa|0)==(ba|0))break;else Ra=Ra+2|0}}Oa=Oa+1|0}while((Oa|0)!=2);Oa=E+Na|0;if(X){Ra=Ka^2;Pa=Ma;Qa=oa+((Y((La|0)%3|0,ga)|0)<<1)+4|0;Wa=oa+((Y((La+-1|0)%3|0,ga)|0)<<1)+4|0;Va=oa+((Y((La+-2|0)%3|0,ga)|0)<<1)+4|0;Ua=Oa+6|0;Ta=fa+(Y(La,ca)|0)+2|0;Za=2;while(1){Sa=j[Wa>>1]|0;$a=Sa+(j[Va>>1]|0)|0;Ya=(j[Qa>>1]|0)+Sa|0;Sa=j[Wa+(V<<1)>>1]|0;_a=Sa+(j[Wa+(ba<<1)>>1]|0)|0;Xa=(j[Wa+(Z<<1)>>1]|0)+Sa|0;Sa=Ya>>>0<$a>>>0?Ya:$a;ab=(_a|0)<(Sa|0)?_a:Sa;Sa=(Xa|0)<(ab|0)?Xa:ab;ab=$a>>>0<Ya>>>0?Ya:$a;bb=(ab|0)<(_a|0)?_a:ab;ab=(bb|0)<(Xa|0)?Xa:bb;if(Pa){bb=j[Wa+(c<<1)>>1]|0;cb=(j[Va+(L<<1)>>1]|0)+(j[Va+(c<<1)>>1]|0)+bb+(j[Wa+(L<<1)>>1]|0)|0;db=(j[Wa+(ka<<1)>>1]|0)+bb+(j[Qa+(c<<1)>>1]|0)+(j[Qa+(ka<<1)>>1]|0)|0;bb=j[Wa+(ja<<1)>>1]|0;eb=(j[Va+(O<<1)>>1]|0)+(j[Va+(ja<<1)>>1]|0)+bb+(j[Wa+(O<<1)>>1]|0)|0;fb=(j[Wa+(_<<1)>>1]|0)+bb+(j[Qa+(ja<<1)>>1]|0)+(j[Qa+(_<<1)>>1]|0)|0;bb=(cb|0)<(Sa|0)?cb:Sa;gb=(db|0)<(bb|0)?db:bb;bb=(eb|0)<(gb|0)?eb:gb;gb=(ab|0)<(cb|0)?cb:ab;hb=(gb|0)<(db|0)?db:gb;gb=(hb|0)<(eb|0)?eb:hb;hb=(gb|0)<(fb|0)?fb:gb;gb=((hb|0)<2?1:hb>>>1)+((fb|0)<(bb|0)?fb:bb)|0;if(($a|0)<(gb|0)){ib=1;jb=(h[Ta+U>>0]|0)<<1;kb=(h[Ta>>0]|0)+(h[Ta+R>>0]|0)|0;lb=(h[Ta+ha>>0]|0)+(h[Ta+z>>0]|0)|0}else{ib=0;jb=0;kb=0;lb=0}if((Ya|0)<(gb|0)){mb=ib+1|0;nb=((h[Ta+ca>>0]|0)<<1)+jb|0;ob=(h[Ta+t>>0]|0)+kb+(h[Ta>>0]|0)|0;pb=(h[Ta+S>>0]|0)+lb+(h[Ta+pa>>0]|0)|0}else{mb=ib;nb=jb;ob=kb;pb=lb}if((_a|0)<(gb|0)){qb=mb+1|0;rb=(h[Ta+qa>>0]|0)+nb+(h[Ta+ra>>0]|0)|0;sb=(h[Ta+-2>>0]|0)+ob+(h[Ta>>0]|0)|0;tb=((h[Ta+-1>>0]|0)<<1)+pb|0}else{qb=mb;rb=nb;sb=ob;tb=pb}if((Xa|0)<(gb|0)){ub=qb+1|0;vb=(h[Ta+sa>>0]|0)+rb+(h[Ta+ta>>0]|0)|0;wb=(h[Ta+2>>0]|0)+sb+(h[Ta>>0]|0)|0;xb=((h[Ta+1>>0]|0)<<1)+tb|0}else{ub=qb;vb=rb;wb=sb;xb=tb}if((cb|0)<(gb|0)){yb=ub+1|0;zb=(h[Ta+U>>0]|0)+vb+(h[Ta+sa>>0]|0)|0;Ab=((h[Ta+q>>0]|0)<<1)+wb|0;Bb=(h[Ta+ha>>0]|0)+xb+(h[Ta+1>>0]|0)|0}else{yb=ub;zb=vb;Ab=wb;Bb=xb}if((db|0)<(gb|0)){Cb=yb+1|0;Db=(h[Ta+ca>>0]|0)+zb+(h[Ta+ra>>0]|0)|0;Eb=((h[Ta+T>>0]|0)<<1)+Ab|0;Fb=(h[Ta+S>>0]|0)+Bb+(h[Ta+-1>>0]|0)|0}else{Cb=yb;Db=zb;Eb=Ab;Fb=Bb}if((eb|0)<(gb|0)){Gb=Cb+1|0;Hb=(h[Ta+qa>>0]|0)+Db+(h[Ta+U>>0]|0)|0;Ib=((h[Ta+W>>0]|0)<<1)+Eb|0;Jb=(h[Ta+z>>0]|0)+Fb+(h[Ta+-1>>0]|0)|0}else{Gb=Cb;Hb=Db;Ib=Eb;Jb=Fb}if((fb|0)<(gb|0)){Kb=Gb+1|0;Lb=(h[Ta+ta>>0]|0)+Hb+(h[Ta+ca>>0]|0)|0;Mb=((h[Ta+M>>0]|0)<<1)+Ib|0;Nb=(h[Ta+pa>>0]|0)+Jb+(h[Ta+1>>0]|0)|0}else{Kb=Gb;Lb=Hb;Mb=Ib;Nb=Jb}gb=h[Ta>>0]|0;Ob=+n[56408+(Kb<<2)>>2];Pb=gb;Qb=(mrc(+(Nb-Mb|0)*Ob)|0)+gb|0;Rb=gb;Sb=Ob;Tb=Lb-Mb|0}else{gb=j[Wa+(F<<1)>>1]|0;fb=gb+(j[Va+(ua<<1)>>1]|0)|0;eb=(j[Qa+(va<<1)>>1]|0)+gb|0;gb=j[Wa+(H<<1)>>1]|0;db=gb+(j[Va+(wa<<1)>>1]|0)|0;cb=(j[Qa+(xa<<1)>>1]|0)+gb|0;gb=(fb|0)<(Sa|0)?fb:Sa;Sa=(eb|0)<(gb|0)?eb:gb;gb=(db|0)<(Sa|0)?db:Sa;Sa=(ab|0)<(fb|0)?fb:ab;ab=(Sa|0)<(eb|0)?eb:Sa;Sa=(ab|0)<(db|0)?db:ab;ab=(Sa|0)<(cb|0)?cb:Sa;Sa=((ab|0)<2?1:ab>>>1)+((cb|0)<(gb|0)?cb:gb)|0;gb=h[Ta>>0]|0;if(($a|0)<(Sa|0)){Ub=1;Vb=(h[Ta+q>>0]|0)+(h[Ta+W>>0]|0)|0;Wb=(h[Ta+U>>0]|0)<<1;Xb=(h[Ta+R>>0]|0)+gb|0}else{Ub=0;Vb=0;Wb=0;Xb=0}if((Ya|0)<(Sa|0)){Yb=Ub+1|0;Zb=(h[Ta+T>>0]|0)+Vb+(h[Ta+M>>0]|0)|0;_b=((h[Ta+ca>>0]|0)<<1)+Wb|0;$b=Xb+gb+(h[Ta+t>>0]|0)|0}else{Yb=Ub;Zb=Vb;_b=Wb;$b=Xb}if((_a|0)<(Sa|0)){ac=Yb+1|0;bc=(h[Ta+W>>0]|0)+Zb+(h[Ta+T>>0]|0)|0;cc=((h[Ta+-1>>0]|0)<<1)+_b|0;dc=$b+gb+(h[Ta+-2>>0]|0)|0}else{ac=Yb;bc=Zb;cc=_b;dc=$b}if((Xa|0)<(Sa|0)){ec=ac+1|0;fc=(h[Ta+q>>0]|0)+bc+(h[Ta+M>>0]|0)|0;gc=((h[Ta+1>>0]|0)<<1)+cc|0;hc=dc+gb+(h[Ta+2>>0]|0)|0}else{ec=ac;fc=bc;gc=cc;hc=dc}if((fb|0)<(Sa|0)){ic=ec+1|0;jc=((h[Ta+q>>0]|0)<<1)+fc|0;kc=(j[Va+(Aa<<1)>>1]|0)+gc|0;lc=hc+gb+(h[Ta+za>>0]|0)|0}else{ic=ec;jc=fc;kc=gc;lc=hc}if((eb|0)<(Sa|0)){mc=ic+1|0;nc=((h[Ta+T>>0]|0)<<1)+jc|0;oc=(j[Qa+(Ca<<1)>>1]|0)+kc|0;pc=lc+gb+(h[Ta+Ba>>0]|0)|0}else{mc=ic;nc=jc;oc=kc;pc=lc}if((db|0)<(Sa|0)){qc=mc+1|0;rc=((h[Ta+q>>0]|0)<<1)+nc|0;sc=(j[Va+(Ca<<1)>>1]|0)+oc|0;tc=pc+gb+(h[Ta+Da>>0]|0)|0}else{qc=mc;rc=nc;sc=oc;tc=pc}if((cb|0)<(Sa|0)){uc=qc+1|0;vc=((h[Ta+q>>0]|0)<<1)+rc|0;wc=(j[Qa+(Aa<<1)>>1]|0)+sc|0;xc=tc+gb+(h[Ta+ya>>0]|0)|0}else{uc=qc;vc=rc;wc=sc;xc=tc}Ob=+n[56408+(uc<<2)>>2];Pb=(mrc(+(wc-xc|0)*Ob)|0)+gb|0;Qb=gb;Rb=gb;Sb=Ob;Tb=vc-xc|0}gb=(mrc(+(Tb|0)*Sb)|0)+Rb|0;b[Ua+Ka>>0]=gb>>>0<256?gb:(gb|0)>0?255:0;b[Ua+1>>0]=Pb>>>0<256?Pb:(Pb|0)>0?255:0;b[Ua+Ra>>0]=Qb>>>0<256?Qb:(Qb|0)>0?255:0;Za=Za+1|0;if((Za|0)==(g|0)){yc=Ra;break}else{Pa=Pa^1;Qa=Qa+2|0;Wa=Wa+2|0;Va=Va+2|0;Ua=Ua+3|0;Ta=Ta+1|0}}}else yc=Ka^2;Ta=P+Na|0;Ua=Na+Q|0;Va=E+(Na+5)|0;b[Va>>0]=b[E+(Na+8)>>0]|0;b[E+Ua>>0]=b[E+Ta>>0]|0;Wa=E+(Na+4)|0;b[Wa>>0]=b[E+(Na+7)>>0]|0;b[E+(Ua+1)>>0]=b[E+(Ta+1)>>0]|0;Qa=E+(Na+3)|0;b[Qa>>0]=b[E+(Na+6)>>0]|0;b[E+(Ua+2)>>0]=b[E+(Ta+2)>>0]|0;b[E+(Na+2)>>0]=b[Va>>0]|0;b[E+(Ua+3)>>0]=b[E+(Ta+3)>>0]|0;b[E+(Na+1)>>0]=b[Wa>>0]|0;b[E+(Ua+4)>>0]=b[E+(Ta+4)>>0]|0;b[Oa>>0]=b[Qa>>0]|0;b[E+(Ua+5)>>0]=b[E+(Ta+5)>>0]|0;La=La+1|0;if((La|0)==(r|0))break;else{Ka=yc;Ma=Ma^1}}}if((ja|0)>0){Ma=ia<<1;Ka=Y(C+-5|0,ia)|0;La=Y(C+-1|0,ia)|0;Q=Y(C+-2|0,ia)|0;P=Y(C+-3|0,ia)|0;g=Y(r,ia)|0;ya=0;do{Aa=b[E+(ya+Ma)>>0]|0;b[E+(ya+ia)>>0]=Aa;b[E+ya>>0]=Aa;Aa=b[E+(ya+Ka)>>0]|0;b[E+(ya+La)>>0]=Aa;b[E+(ya+Q)>>0]=Aa;b[E+(ya+P)>>0]=Aa;b[E+(ya+g)>>0]=Aa;ya=ya+1|0}while((ya|0)!=(ja|0))}ja=f[k>>2]|0;if((ja|0)!=(da|0)){if(ja|0)ZDc(ja);f[k>>2]=da;f[ea>>2]=520}}}while(0);k=s+36|0;yc=f[k>>2]|0;if(yc|0?(Qb=yc+12|0,yc=f[Qb>>2]|0,f[Qb>>2]=yc+-1,(yc|0)==1):0)_S(s);f[k>>2]=0;k=s+16|0;yc=s+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[yc>>2]|0)>0){k=f[s+40>>2]|0;Qb=0;do{f[k+(Qb<<2)>>2]=0;Qb=Qb+1|0}while((Qb|0)<(f[yc>>2]|0))}yc=f[s+44>>2]|0;if((yc|0)!=(s+48|0))g0(yc);aa=p+36|0}yc=f[aa>>2]|0;if(yc|0?(s=yc+12|0,yc=f[s>>2]|0,f[s>>2]=yc+-1,(yc|0)==1):0)_S(p);f[aa>>2]=0;aa=p+16|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[a>>2]|0)>0){aa=f[v>>2]|0;v=0;do{f[aa+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[B>>2]|0;if((a|0)!=(y|0))g0(a);a=o+36|0;y=f[a>>2]|0;if(y|0?(B=y+12|0,y=f[B>>2]|0,f[B>>2]=y+-1,(y|0)==1):0)_S(o);f[a>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[N>>2]|0)>0){K=f[D>>2]|0;D=0;do{f[K+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[N>>2]|0))}N=f[o+44>>2]|0;if((N|0)==(o+48|0)){u=i;return}g0(N);u=i;return}function pka(a,b,c){a=a|0;b=b|0;c=c|0;z5(a,b,265410,265422,c);return}function qka(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=g&1;f[a>>2]=56552;g=a+4|0;f[g>>2]=f[c>>2];l=a+8|0;m=c+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;p=a+48|0;f[p>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[c+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;ZS(g,c)}c=a+60|0;f[c>>2]=f[d>>2];g=a+64|0;l=d+4|0;f[g>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];n=f[d+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;p=a+104|0;f[p>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}else{f[g>>2]=0;ZS(c,d);q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}}function rka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56552;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function ska(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=g&1;f[a>>2]=56532;g=a+4|0;f[g>>2]=f[c>>2];l=a+8|0;m=c+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;p=a+48|0;f[p>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[c+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;ZS(g,c)}c=a+60|0;f[c>>2]=f[d>>2];g=a+64|0;l=d+4|0;f[g>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];n=f[d+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;p=a+104|0;f[p>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}else{f[g>>2]=0;ZS(c,d);q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}}function tka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56532;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function uka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+160|0;g=e+144|0;h=e+136|0;i=e;j=f[c+48>>2]|0;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;f[g>>2]=l;k=g+4|0;f[k>>2]=m;switch(d|0){case 46:case 47:case 139:{n=-1;break}default:n=(d|0)==140?-1:1}switch(d|0){case 142:case 47:case 49:case 140:{o=1;break}default:o=0}d=((f[c>>2]|0)>>>3&511)+1|0;p=m+-2|0;f[k>>2]=p;f[g>>2]=l+-2;if((m|0)>2){f[h>>2]=0;f[h+4>>2]=p;Hka(i,a,c,o,n,g);n=f[c+4>>2]|0;if((n|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+40>>2]|0;a=0;p=1;while(1){m=Y(f[o+(a<<2)>>2]|0,p)|0;a=a+1|0;if((a|0)==(n|0)){q=m;break}else p=m}}y8(h,i,+(q>>>0)*.0000152587890625);Ika(i)}i=f[c+40>>2]|0;q=f[i+4>>2]|0;h=f[i>>2]|0;f[g>>2]=q;f[k>>2]=h;i=f[c+16>>2]|0;c=(Y(q,d)|0)>0;if((h|0)>2){if(c)r=0;else{u=e;return}do{b[i+r>>0]=b[i+(r+j)>>0]|0;q=f[k>>2]|0;p=i+((Y(q+-2|0,j)|0)+r)|0;n=i+((Y(q+-1|0,j)|0)+r)|0;b[n>>0]=b[p>>0]|0;r=r+1|0}while((r|0)<(Y(f[g>>2]|0,d)|0));u=e;return}if(!c){u=e;return}c=i+(Y(h+-1|0,j)|0)|0;b[c>>0]=0;b[i>>0]=0;if((Y(f[g>>2]|0,d)|0)>1)s=1;else{u=e;return}do{c=i+((Y((f[k>>2]|0)+-1|0,j)|0)+s)|0;b[c>>0]=0;b[i+s>>0]=0;s=s+1|0}while((s|0)<(Y(f[g>>2]|0,d)|0));u=e;return}function vka(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=56492;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;ZS(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}else{f[h>>2]=0;ZS(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}}function wka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56492;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function xka(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=56472;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;ZS(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}else{f[h>>2]=0;ZS(b,c);n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}}function yka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56472;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function zka(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=56452;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;ZS(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}else{f[h>>2]=0;ZS(b,c);n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}}function Aka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56452;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Bka(a){a=a|0;Aka(a);YDc(a);return}function Cka(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=f[a+60>>2]|0;e=(c>>>3&511)+1|0;g=e<<1;h=((f[a+52>>2]|0)>>>0)/((1212424721>>>(f[a+4>>2]<<2&28)&15)>>>0)|0;i=f[a+108>>2]|0;k=(i>>>0)/((1212424721>>>(c<<2&28)&15)>>>0)|0;c=f[b>>2]|0;l=c+1|0;m=f[b+4>>2]|0;if((c|0)>=(m|0))return;b=c&1;n=(f[a+76>>2]|0)+(Y(l,i)|0)+(e<<1)|0;i=0-h|0;o=a+116|0;p=g-k|0;q=e-k|0;k=~h;r=1-h|0;s=h+-1|0;t=h+1|0;u=c;c=n;n=(f[a+20>>2]|0)+(Y(f[f[a+48>>2]>>2]|0,l)|0)+2|0;l=b^f[a+124>>2];v=b^f[a+128>>2];while(1){if(!v){w=1;x=c;y=n}else{a=l<<1;d[c+(a<<1)>>1]=((j[n+(h<<1)>>1]|0)+(j[n+(i<<1)>>1]|0)|0)>>>1;d[c+2>>1]=d[n>>1]|0;b=n+2|0;d[c+(2-a<<1)>>1]=((j[b>>1]|0)+(j[n+-2>>1]|0)|0)>>>1;w=2;x=c+(e<<1)|0;y=b}b=f[o>>2]|0;a=(w|0)<(b|0);if(!l)if(a){z=w;A=x;B=y;while(1){C=B+(r<<1)|0;D=B+(t<<1)|0;d[A>>1]=((j[B+(k<<1)>>1]|0)+2+(j[C>>1]|0)+(j[B+(s<<1)>>1]|0)+(j[D>>1]|0)|0)>>>2;E=j[B+-2>>1]|0;F=B+2|0;G=d[F>>1]|0;H=E-(G&65535)|0;I=j[B+(h<<1)>>1]|0;J=d[B+(i<<1)>>1]|0;K=I-(J&65535)|0;L=(((H|0)>-1?H:0-H|0)|0)>(((K|0)>-1?K:0-K|0)|0);d[A+2>>1]=((L?I:E)+1+((L?J:G)&65535)|0)>>>1;d[A+4>>1]=d[B>>1]|0;d[A+6>>1]=((j[C>>1]|0)+1+(j[D>>1]|0)|0)>>>1;d[A+8>>1]=d[F>>1]|0;F=B+4|0;d[A+10>>1]=((j[B>>1]|0)+1+(j[F>>1]|0)|0)>>>1;D=z+2|0;C=A+(g<<1)|0;if((D|0)<(b|0)){z=D;A=C;B=F}else{M=D;N=C;O=F;break}}}else{M=w;N=x;O=y}else if(a){B=w;A=x;z=y;while(1){d[A>>1]=d[z>>1]|0;F=j[z+-2>>1]|0;C=z+2|0;D=d[C>>1]|0;G=F-(D&65535)|0;J=j[z+(h<<1)>>1]|0;L=d[z+(i<<1)>>1]|0;E=J-(L&65535)|0;I=(((G|0)>-1?G:0-G|0)|0)>(((E|0)>-1?E:0-E|0)|0);d[A+2>>1]=((I?J:F)+1+((I?L:D)&65535)|0)>>>1;D=z+(r<<1)|0;L=z+(t<<1)|0;d[A+4>>1]=((j[D>>1]|0)+(j[z+(k<<1)>>1]|0)+(j[z+(s<<1)>>1]|0)+(j[L>>1]|0)|0)>>>2;I=z+4|0;d[A+6>>1]=((j[z>>1]|0)+1+(j[I>>1]|0)|0)>>>1;d[A+8>>1]=d[C>>1]|0;d[A+10>>1]=((j[D>>1]|0)+1+(j[L>>1]|0)|0)>>>1;L=B+2|0;D=A+(g<<1)|0;if((L|0)<(b|0)){B=L;A=D;z=I}else{M=L;N=D;O=I;break}}}else{M=w;N=x;O=y}if((M|0)>(b|0)){P=N;Q=O}else{z=l<<1;d[N+(z<<1)>>1]=((j[O+(k<<1)>>1]|0)+2+(j[O+(r<<1)>>1]|0)+(j[O+(s<<1)>>1]|0)+(j[O+(t<<1)>>1]|0)|0)>>>2;A=j[O+-2>>1]|0;B=O+2|0;a=d[B>>1]|0;I=A-(a&65535)|0;D=j[O+(h<<1)>>1]|0;L=d[O+(i<<1)>>1]|0;C=D-(L&65535)|0;F=(((I|0)>-1?I:0-I|0)|0)>(((C|0)>-1?C:0-C|0)|0);d[N+2>>1]=((F?D:A)+1+((F?L:a)&65535)|0)>>>1;d[N+(2-z<<1)>>1]=d[O>>1]|0;P=N+(e<<1)|0;Q=B}B=0;do{d[P+(B<<1)>>1]=d[P+(B-e<<1)>>1]|0;d[P+(q+B<<1)>>1]=d[P+(p+B<<1)>>1]|0;B=B+1|0}while((B|0)!=(e|0));u=u+1|0;if((u|0)>=(m|0))break;else{c=P+(g<<1)|0;n=Q+4|0;l=l^1;v=v^1}}return}function Dka(a){a=a|0;yka(a);YDc(a);return}function Eka(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=f[a+60>>2]|0;e=(d>>>3&511)+1|0;g=e<<1;i=((f[a+52>>2]|0)>>>0)/((1212424721>>>(f[a+4>>2]<<2&28)&15)>>>0)|0;j=f[a+108>>2]|0;k=(j>>>0)/((1212424721>>>(d<<2&28)&15)>>>0)|0;d=f[c>>2]|0;l=d+1|0;m=c+4|0;if((d|0)>=(f[m>>2]|0))return;c=d&1;n=(f[a+76>>2]|0)+(Y(l,j)|0)+e|0;j=0-i|0;o=a+116|0;p=g-k|0;q=e-k|0;k=~i;r=1-i|0;s=i+-1|0;t=i+1|0;u=d;d=n;n=(f[a+20>>2]|0)+(Y(f[f[a+48>>2]>>2]|0,l)|0)+1|0;l=c^f[a+124>>2];v=c^f[a+128>>2];while(1){if(!v){w=1;x=d;y=n}else{a=l<<1;b[d+a>>0]=((h[n+i>>0]|0)+(h[n+j>>0]|0)|0)>>>1;b[d+1>>0]=b[n>>0]|0;c=n+1|0;b[d+(2-a)>>0]=((h[c>>0]|0)+(h[n+-1>>0]|0)|0)>>>1;w=2;x=d+e|0;y=c}c=f[o>>2]|0;a=(w|0)<(c|0);if(!l)if(a){z=w;A=x;B=y;while(1){C=B+r|0;D=B+t|0;b[A>>0]=((h[B+k>>0]|0)+2+(h[C>>0]|0)+(h[B+s>>0]|0)+(h[D>>0]|0)|0)>>>2;E=h[B+-1>>0]|0;F=B+1|0;G=b[F>>0]|0;H=E-(G&255)|0;I=h[B+i>>0]|0;J=b[B+j>>0]|0;K=I-(J&255)|0;L=(((H|0)>-1?H:0-H|0)|0)>(((K|0)>-1?K:0-K|0)|0);b[A+1>>0]=((L?I:E)+1+((L?J:G)&255)|0)>>>1;b[A+2>>0]=b[B>>0]|0;b[A+3>>0]=((h[C>>0]|0)+1+(h[D>>0]|0)|0)>>>1;b[A+4>>0]=b[F>>0]|0;F=B+2|0;b[A+5>>0]=((h[B>>0]|0)+1+(h[F>>0]|0)|0)>>>1;D=z+2|0;C=A+g|0;G=f[o>>2]|0;if((D|0)<(G|0)){z=D;A=C;B=F}else{M=D;N=C;O=F;P=G;break}}}else{M=w;N=x;O=y;P=c}else if(a){B=w;A=x;z=y;while(1){b[A>>0]=b[z>>0]|0;G=h[z+-1>>0]|0;F=z+1|0;C=b[F>>0]|0;D=G-(C&255)|0;J=h[z+i>>0]|0;L=b[z+j>>0]|0;E=J-(L&255)|0;I=(((D|0)>-1?D:0-D|0)|0)>(((E|0)>-1?E:0-E|0)|0);b[A+1>>0]=((I?J:G)+1+((I?L:C)&255)|0)>>>1;C=z+r|0;L=z+t|0;b[A+2>>0]=((h[C>>0]|0)+(h[z+k>>0]|0)+(h[z+s>>0]|0)+(h[L>>0]|0)|0)>>>2;I=z+2|0;b[A+3>>0]=((h[z>>0]|0)+1+(h[I>>0]|0)|0)>>>1;b[A+4>>0]=b[F>>0]|0;b[A+5>>0]=((h[C>>0]|0)+1+(h[L>>0]|0)|0)>>>1;L=B+2|0;C=A+g|0;F=f[o>>2]|0;if((L|0)<(F|0)){B=L;A=C;z=I}else{M=L;N=C;O=I;P=F;break}}}else{M=w;N=x;O=y;P=c}if((M|0)>(P|0)){Q=N;R=O}else{z=l<<1;b[N+z>>0]=((h[O+k>>0]|0)+2+(h[O+r>>0]|0)+(h[O+s>>0]|0)+(h[O+t>>0]|0)|0)>>>2;A=h[O+-1>>0]|0;B=O+1|0;a=b[B>>0]|0;F=A-(a&255)|0;I=h[O+i>>0]|0;C=b[O+j>>0]|0;L=I-(C&255)|0;G=(((F|0)>-1?F:0-F|0)|0)>(((L|0)>-1?L:0-L|0)|0);b[N+1>>0]=((G?I:A)+1+((G?C:a)&255)|0)>>>1;b[N+(2-z)>>0]=b[O>>0]|0;Q=N+e|0;R=B}B=0;do{b[Q+B>>0]=b[Q+(B-e)>>0]|0;b[Q+(q+B)>>0]=b[Q+(p+B)>>0]|0;B=B+1|0}while((B|0)!=(e|0));u=u+1|0;if((u|0)>=(f[m>>2]|0))break;else{d=Q+g|0;n=R+2|0;l=l^1;v=v^1}}return}function Fka(a){a=a|0;wka(a);YDc(a);return}function Gka(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;c=((f[a+60>>2]|0)>>>3&511)+1|0;e=c<<1;g=f[a+52>>2]|0;h=g>>>1;i=f[b>>2]|0;k=(f[a+108>>2]|0)>>>1;l=f[a+120>>2]|0;m=f[a+116>>2]|0;n=(i&1|0)==0;o=f[b+4>>2]|0;if((i|0)>=(o|0))return;b=(f[a+76>>2]|0)+((Y(k,i+1|0)|0)<<1)+(c<<1)+2|0;p=(f[a+20>>2]|0)+((Y(i,h)|0)<<1)|0;q=a+124|0;a=f[q>>2]|0;r=(a|0)<1;s=(c|0)==3;t=Y(a,c)|0;u=t+1|0;v=t+-1|0;w=t+2|0;x=g|1;g=h+2|0;y=h+1|0;z=(c|0)==4;A=h<<1;B=A+2|0;C=A|1;D=h+3|0;E=b;b=i;i=p;p=n?m:(m|0)==0&1;m=n?l:0-l|0;while(1){l=i+(a<<1)|0;if(r){d[E+(u<<1)>>1]=0;d[E+(t<<1)>>1]=0;d[E+(v<<1)>>1]=0;if(s){F=-4;G=0;H=-3;I=-2}else{d[E+-6>>1]=0;d[E+-8>>1]=0;F=-2;G=-1;H=w;I=-5}d[E+(I<<1)>>1]=0;d[E+(H<<1)>>1]=G;d[E+(F<<1)>>1]=G;J=p;K=m}else{n=(p|0)!=0;if(n){L=i+2|0;M=((j[i+(h<<1)>>1]|0)+1+(j[i+(g<<1)>>1]|0)|0)>>>1;d[E+(0-m<<1)>>1]=((j[L>>1]|0)+1+(j[i+(x<<1)>>1]|0)|0)>>>1;d[E>>1]=d[i+(y<<1)>>1]|0;d[E+(m<<1)>>1]=M;if(z)d[E+4>>1]=-1;N=E+(c<<1)|0;O=L}else{N=E;O=i}L=(m|0)>0;M=l+-4|0;P=O>>>0>M>>>0;do if(s)if(L){if(P){Q=N;R=O;break}else{S=O;T=N}while(1){U=S+4|0;V=S+(B<<1)|0;W=S+(g<<1)|0;X=((j[S+2>>1]|0)+2+(j[S+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[S+(C<<1)>>1]|0)|0)>>>2;d[T+-2>>1]=((j[S>>1]|0)+2+(j[U>>1]|0)+(j[S+(A<<1)>>1]|0)+(j[V>>1]|0)|0)>>>2;d[T>>1]=X;X=S+(y<<1)|0;d[T+2>>1]=d[X>>1]|0;Z=((j[X>>1]|0)+1+(j[S+(D<<1)>>1]|0)|0)>>>1;d[T+4>>1]=((j[U>>1]|0)+1+(j[V>>1]|0)|0)>>>1;d[T+6>>1]=d[W>>1]|0;d[T+8>>1]=Z;Z=T+(e<<1)|0;if(U>>>0>M>>>0){Q=Z;R=U;break}else{S=U;T=Z}}}else{if(P){Q=N;R=O;break}else{_=O;$=N}while(1){Z=_+4|0;U=_+(B<<1)|0;W=_+(g<<1)|0;V=((j[_+2>>1]|0)+2+(j[_+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[_+(C<<1)>>1]|0)|0)>>>2;d[$+2>>1]=((j[_>>1]|0)+2+(j[Z>>1]|0)+(j[_+(A<<1)>>1]|0)+(j[U>>1]|0)|0)>>>2;d[$>>1]=V;V=_+(y<<1)|0;d[$+-2>>1]=d[V>>1]|0;X=((j[V>>1]|0)+1+(j[_+(D<<1)>>1]|0)|0)>>>1;d[$+8>>1]=((j[Z>>1]|0)+1+(j[U>>1]|0)|0)>>>1;d[$+6>>1]=d[W>>1]|0;d[$+4>>1]=X;X=$+(e<<1)|0;if(Z>>>0>M>>>0){Q=X;R=Z;break}else{_=Z;$=X}}}else if(L){if(P){Q=N;R=O;break}else{aa=O;ba=N}while(1){X=aa+4|0;Z=aa+(B<<1)|0;W=aa+(g<<1)|0;U=((j[aa+2>>1]|0)+2+(j[aa+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[aa+(C<<1)>>1]|0)|0)>>>2;d[ba+-2>>1]=((j[aa>>1]|0)+2+(j[X>>1]|0)+(j[aa+(A<<1)>>1]|0)+(j[Z>>1]|0)|0)>>>2;d[ba>>1]=U;U=aa+(y<<1)|0;d[ba+2>>1]=d[U>>1]|0;d[ba+4>>1]=-1;V=((j[U>>1]|0)+1+(j[aa+(D<<1)>>1]|0)|0)>>>1;d[ba+6>>1]=((j[X>>1]|0)+1+(j[Z>>1]|0)|0)>>>1;d[ba+8>>1]=d[W>>1]|0;d[ba+10>>1]=V;d[ba+12>>1]=-1;V=ba+(e<<1)|0;if(X>>>0>M>>>0){Q=V;R=X;break}else{aa=X;ba=V}}}else{if(P){Q=N;R=O;break}else{ca=O;da=N}while(1){V=ca+4|0;X=ca+(B<<1)|0;W=((j[ca>>1]|0)+2+(j[V>>1]|0)+(j[ca+(A<<1)>>1]|0)+(j[X>>1]|0)|0)>>>2;Z=ca+(g<<1)|0;U=((j[ca+2>>1]|0)+2+(j[ca+(h<<1)>>1]|0)+(j[Z>>1]|0)+(j[ca+(C<<1)>>1]|0)|0)>>>2;ea=ca+(y<<1)|0;d[da+-2>>1]=d[ea>>1]|0;d[da>>1]=U;d[da+2>>1]=W;d[da+4>>1]=-1;W=((j[V>>1]|0)+1+(j[X>>1]|0)|0)>>>1;d[da+6>>1]=((j[ea>>1]|0)+1+(j[ca+(D<<1)>>1]|0)|0)>>>1;d[da+8>>1]=d[Z>>1]|0;d[da+10>>1]=W;d[da+12>>1]=-1;W=da+(e<<1)|0;if(V>>>0>M>>>0){Q=W;R=V;break}else{ca=V;da=W}}}while(0);if(R>>>0<l>>>0?(M=((j[R+2>>1]|0)+2+(j[R+(h<<1)>>1]|0)+(j[R+(g<<1)>>1]|0)+(j[R+(C<<1)>>1]|0)|0)>>>2,d[Q+(0-m<<1)>>1]=((j[R>>1]|0)+2+(j[R+4>>1]|0)+(j[R+(A<<1)>>1]|0)+(j[R+(B<<1)>>1]|0)|0)>>>2,d[Q>>1]=M,d[Q+(m<<1)>>1]=d[R+(y<<1)>>1]|0,z):0)d[Q+4>>1]=-1;M=d[E+-2>>1]|0;P=d[E+2>>1]|0;L=d[E>>1]|0;W=Y(f[q>>2]|0,c)|0;V=W+-4|0;if(s){d[E+-8>>1]=M;d[E+-6>>1]=L;d[E+-4>>1]=P;fa=W;ga=d[E+(V<<1)>>1]|0;ha=1}else{d[E+-10>>1]=M;d[E+-8>>1]=L;d[E+-6>>1]=P;d[E+-4>>1]=d[E+4>>1]|0;P=d[E+(W+-5<<1)>>1]|0;d[E+(W<<1)>>1]=d[E+(V<<1)>>1]|0;fa=W+1|0;ga=P;ha=2}d[E+(W+-1<<1)>>1]=ga;d[E+(fa<<1)>>1]=d[E+(W+-3<<1)>>1]|0;d[E+(ha+W<<1)>>1]=d[E+(W+-2<<1)>>1]|0;J=(n^1)&1;K=0-m|0}b=b+1|0;if((b|0)>=(o|0))break;else{E=E+(k<<1)|0;i=i+(h<<1)|0;p=J;m=K}}return}function Hka(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=56512;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;ZS(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}else{f[h>>2]=0;ZS(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}}function Ika(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56512;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Jka(a){a=a|0;Ika(a);YDc(a);return}function Kka(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=((f[a+60>>2]|0)>>>3&511)+1|0;e=d<<1;g=f[a+52>>2]|0;i=f[c>>2]|0;j=f[a+108>>2]|0;k=f[a+120>>2]|0;l=f[a+116>>2]|0;m=(i&1|0)==0;n=c+4|0;if((i|0)>=(f[n>>2]|0))return;c=(f[a+76>>2]|0)+(Y(i+1|0,j)|0)+d+1|0;o=a+124|0;p=(d|0)==3;q=g<<1;r=q|1;s=g+2|0;t=g+1|0;u=(d|0)==4;v=q+2|0;w=g+3|0;x=c;c=i;y=(f[a+20>>2]|0)+(Y(i,g)|0)|0;i=m?l:(l|0)==0&1;l=m?k:0-k|0;while(1){k=f[o>>2]|0;m=y+k|0;if((k|0)<1){a=x+((Y(k,d)|0)+1)|0;b[a>>0]=0;a=x+(Y(f[o>>2]|0,d)|0)|0;b[a>>0]=0;a=x+((Y(f[o>>2]|0,d)|0)+-1)|0;b[a>>0]=0;if(p){b[x+-2>>0]=0;z=-4;A=0;B=-3}else{b[x+-3>>0]=0;b[x+-4>>0]=0;b[x+-5>>0]=0;z=-2;A=-1;B=(Y(f[o>>2]|0,d)|0)+2|0}b[x+B>>0]=A;b[x+z>>0]=A;C=i;D=l}else{a=(i|0)!=0;if(a){k=y+1|0;E=((h[y+g>>0]|0)+1+(h[y+s>>0]|0)|0)>>>1;b[x+(0-l)>>0]=((h[k>>0]|0)+1+(h[y+r>>0]|0)|0)>>>1;b[x>>0]=b[y+t>>0]|0;b[x+l>>0]=E;if(u)b[x+2>>0]=-1;F=x+d|0;G=k}else{F=x;G=y}k=(l|0)>0;E=m+-2|0;H=G>>>0>E>>>0;do if(p)if(k){if(H){I=F;J=G;break}else{K=G;L=F}while(1){M=K+2|0;N=K+v|0;O=K+s|0;P=((h[K+1>>0]|0)+2+(h[K+g>>0]|0)+(h[O>>0]|0)+(h[K+r>>0]|0)|0)>>>2;b[L+-1>>0]=((h[K>>0]|0)+2+(h[M>>0]|0)+(h[K+q>>0]|0)+(h[N>>0]|0)|0)>>>2;b[L>>0]=P;P=K+t|0;b[L+1>>0]=b[P>>0]|0;Q=((h[P>>0]|0)+1+(h[K+w>>0]|0)|0)>>>1;b[L+2>>0]=((h[M>>0]|0)+1+(h[N>>0]|0)|0)>>>1;b[L+3>>0]=b[O>>0]|0;b[L+4>>0]=Q;Q=L+e|0;if(M>>>0>E>>>0){I=Q;J=M;break}else{K=M;L=Q}}}else{if(H){I=F;J=G;break}else{R=G;S=F}while(1){Q=R+2|0;M=R+v|0;O=R+s|0;N=((h[R+1>>0]|0)+2+(h[R+g>>0]|0)+(h[O>>0]|0)+(h[R+r>>0]|0)|0)>>>2;b[S+1>>0]=((h[R>>0]|0)+2+(h[Q>>0]|0)+(h[R+q>>0]|0)+(h[M>>0]|0)|0)>>>2;b[S>>0]=N;N=R+t|0;b[S+-1>>0]=b[N>>0]|0;P=((h[N>>0]|0)+1+(h[R+w>>0]|0)|0)>>>1;b[S+4>>0]=((h[Q>>0]|0)+1+(h[M>>0]|0)|0)>>>1;b[S+3>>0]=b[O>>0]|0;b[S+2>>0]=P;P=S+e|0;if(Q>>>0>E>>>0){I=P;J=Q;break}else{R=Q;S=P}}}else if(k){if(H){I=F;J=G;break}else{T=G;U=F}while(1){P=T+2|0;Q=T+v|0;O=T+s|0;M=((h[T+1>>0]|0)+2+(h[T+g>>0]|0)+(h[O>>0]|0)+(h[T+r>>0]|0)|0)>>>2;b[U+-1>>0]=((h[T>>0]|0)+2+(h[P>>0]|0)+(h[T+q>>0]|0)+(h[Q>>0]|0)|0)>>>2;b[U>>0]=M;M=T+t|0;b[U+1>>0]=b[M>>0]|0;b[U+2>>0]=-1;N=((h[M>>0]|0)+1+(h[T+w>>0]|0)|0)>>>1;b[U+3>>0]=((h[P>>0]|0)+1+(h[Q>>0]|0)|0)>>>1;b[U+4>>0]=b[O>>0]|0;b[U+5>>0]=N;b[U+6>>0]=-1;N=U+e|0;if(P>>>0>E>>>0){I=N;J=P;break}else{T=P;U=N}}}else{if(H){I=F;J=G;break}else{V=G;W=F}while(1){N=V+2|0;P=V+v|0;O=((h[V>>0]|0)+2+(h[N>>0]|0)+(h[V+q>>0]|0)+(h[P>>0]|0)|0)>>>2;Q=V+s|0;M=((h[V+1>>0]|0)+2+(h[V+g>>0]|0)+(h[Q>>0]|0)+(h[V+r>>0]|0)|0)>>>2;X=V+t|0;b[W+-1>>0]=b[X>>0]|0;b[W>>0]=M;b[W+1>>0]=O;b[W+2>>0]=-1;O=((h[N>>0]|0)+1+(h[P>>0]|0)|0)>>>1;b[W+3>>0]=((h[X>>0]|0)+1+(h[V+w>>0]|0)|0)>>>1;b[W+4>>0]=b[Q>>0]|0;b[W+5>>0]=O;b[W+6>>0]=-1;O=W+e|0;if(N>>>0>E>>>0){I=O;J=N;break}else{V=N;W=O}}}while(0);if(J>>>0<m>>>0?(E=((h[J+1>>0]|0)+2+(h[J+g>>0]|0)+(h[J+s>>0]|0)+(h[J+r>>0]|0)|0)>>>2,b[I+(0-l)>>0]=((h[J>>0]|0)+2+(h[J+2>>0]|0)+(h[J+q>>0]|0)+(h[J+v>>0]|0)|0)>>>2,b[I>>0]=E,b[I+l>>0]=b[J+t>>0]|0,u):0)b[I+2>>0]=-1;E=b[x+-1>>0]|0;H=b[x+1>>0]|0;k=b[x>>0]|0;if(p){b[x+-4>>0]=E;b[x+-3>>0]=k;b[x+-2>>0]=H;O=(f[o>>2]|0)*3|0;b[x+(O+-1)>>0]=b[x+(O+-4)>>0]|0;O=(f[o>>2]|0)*3|0;Z=O;_=O;$=1}else{b[x+-5>>0]=E;b[x+-4>>0]=k;b[x+-3>>0]=H;b[x+-2>>0]=b[x+2>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+(H+-1)>>0]=b[x+(H+-5)>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+H>>0]=b[x+(H+-4)>>0]|0;H=Y(f[o>>2]|0,d)|0;Z=H;_=H+1|0;$=2}b[x+_>>0]=b[x+(Z+-3)>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+(H+$)>>0]=b[x+(H+-2)>>0]|0;C=(a^1)&1;D=0-l|0}c=c+1|0;if((c|0)>=(f[n>>2]|0))break;else{x=x+j|0;y=y+g|0;i=C;l=D}}return}function Lka(a){a=a|0;tka(a);YDc(a);return}function Mka(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=f[a+52>>2]|0;e=c>>>1;g=(f[a+108>>2]|0)>>>1;h=f[a+132>>2]|0;i=f[a+136>>2]|0;k=f[a+116>>2]|0;l=f[b>>2]|0;m=(l&1|0)==0;n=f[b+4>>2]|0;if((l|0)>=(n|0))return;b=(f[a+76>>2]|0)+(g+1<<1)+((Y(l,g)|0)<<1)|0;o=(f[a+20>>2]|0)+((Y(l,e)|0)<<1)|0;p=f[a+124>>2]|0;a=(p|0)<1;q=c|1;c=e+2|0;r=e+1|0;s=e<<1;t=s+2|0;u=s|1;v=e+3|0;w=p+-1|0;x=b;b=l;l=o;o=m?k:(k|0)==0&1;k=m?i:h;y=m?h:i;while(1){i=l+(p<<1)|0;if(a){d[x+(p<<1)>>1]=0;d[x+-2>>1]=0;z=k;A=o;B=y}else{h=(o|0)!=0;if(h){m=l+2|0;C=Y((j[l+(q<<1)>>1]|0)+(j[m>>1]|0)|0,k)|0;D=Y((j[l+(c<<1)>>1]|0)+(j[l+(e<<1)>>1]|0)|0,y)|0;d[x>>1]=(C+16384+D+((j[l+(r<<1)>>1]|0)*19234|0)|0)>>>15;E=x+2|0;F=m}else{E=x;F=l}m=i+-4|0;if(F>>>0>m>>>0){G=E;H=F}else{D=y<<2;C=F;I=E;while(1){J=C+4|0;K=C+(t<<1)|0;L=Y((j[J>>1]|0)+(j[C>>1]|0)+(j[C+(s<<1)>>1]|0)+(j[K>>1]|0)|0,k)|0;M=C+(c<<1)|0;N=C+(r<<1)|0;O=(L+32768+(((j[C+(e<<1)>>1]|0)+(j[C+2>>1]|0)+(j[M>>1]|0)+(j[C+(u<<1)>>1]|0)|0)*9617|0)+(Y(D,j[N>>1]|0)|0)|0)>>>16&65535;d[I>>1]=O;O=Y((j[K>>1]|0)+(j[J>>1]|0)|0,k)|0;K=Y((j[C+(v<<1)>>1]|0)+(j[N>>1]|0)|0,y)|0;d[I+2>>1]=(O+16384+K+((j[M>>1]|0)*19234|0)|0)>>>15;M=I+4|0;if(J>>>0>m>>>0){G=M;H=J;break}else{C=J;I=M}}}if(H>>>0<i>>>0){I=Y((j[H+4>>1]|0)+(j[H>>1]|0)+(j[H+(s<<1)>>1]|0)+(j[H+(t<<1)>>1]|0)|0,k)|0;C=(I+32768+(((j[H+(e<<1)>>1]|0)+(j[H+2>>1]|0)+(j[H+(c<<1)>>1]|0)+(j[H+(u<<1)>>1]|0)|0)*9617|0)+(Y(y<<2,j[H+(r<<1)>>1]|0)|0)|0)>>>16&65535;d[G>>1]=C}d[x+-2>>1]=d[x>>1]|0;d[x+(p<<1)>>1]=d[x+(w<<1)>>1]|0;z=y;A=(h^1)&1;B=k}b=b+1|0;if((b|0)>=(n|0))break;else{x=x+(g<<1)|0;l=l+(e<<1)|0;o=A;k=z;y=B}}return}function Nka(a){a=a|0;rka(a);YDc(a);return}function Oka(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[a+52>>2]|0;e=f[a+108>>2]|0;g=f[a+132>>2]|0;i=f[a+136>>2]|0;j=f[a+116>>2]|0;k=f[c>>2]|0;l=(k&1|0)==0;m=c+4|0;if((k|0)>=(f[m>>2]|0))return;c=(f[a+76>>2]|0)+(e+1)+(Y(k,e)|0)|0;n=(f[a+20>>2]|0)+(Y(k,d)|0)|0;o=a+124|0;a=d<<1;p=a|1;q=d+2|0;r=d+1|0;s=a+2|0;t=d+3|0;u=c;c=k;k=n;n=l?j:(j|0)==0&1;j=l?i:g;v=l?g:i;while(1){i=f[o>>2]|0;g=k+i|0;if((i|0)<1){b[u+i>>0]=0;b[u+-1>>0]=0;w=j;x=n;y=v}else{i=(n|0)!=0;if(i){l=k+1|0;z=Y((h[k+p>>0]|0)+(h[l>>0]|0)|0,j)|0;A=Y((h[k+q>>0]|0)+(h[k+d>>0]|0)|0,v)|0;b[u>>0]=(z+16384+A+((h[k+r>>0]|0)*19234|0)|0)>>>15;B=u+1|0;C=l}else{B=u;C=k}l=g+-2|0;if(C>>>0>l>>>0){D=B;E=C}else{A=v<<2;z=C;F=B;while(1){G=z+2|0;H=z+s|0;I=Y((h[G>>0]|0)+(h[z>>0]|0)+(h[z+a>>0]|0)+(h[H>>0]|0)|0,j)|0;J=z+q|0;K=z+r|0;L=(I+32768+(((h[z+d>>0]|0)+(h[z+1>>0]|0)+(h[J>>0]|0)+(h[z+p>>0]|0)|0)*9617|0)+(Y(A,h[K>>0]|0)|0)|0)>>>16&255;b[F>>0]=L;L=Y((h[H>>0]|0)+(h[G>>0]|0)|0,j)|0;H=Y((h[z+t>>0]|0)+(h[K>>0]|0)|0,v)|0;b[F+1>>0]=(L+16384+H+((h[J>>0]|0)*19234|0)|0)>>>15;J=F+2|0;if(G>>>0>l>>>0){D=J;E=G;break}else{z=G;F=J}}}if(E>>>0<g>>>0){F=Y((h[E+2>>0]|0)+(h[E>>0]|0)+(h[E+a>>0]|0)+(h[E+s>>0]|0)|0,j)|0;z=(F+32768+(((h[E+d>>0]|0)+(h[E+1>>0]|0)+(h[E+q>>0]|0)+(h[E+p>>0]|0)|0)*9617|0)+(Y(v<<2,h[E+r>>0]|0)|0)|0)>>>16&255;b[D>>0]=z}b[u+-1>>0]=b[u>>0]|0;z=f[o>>2]|0;b[u+z>>0]=b[u+(z+-1)>>0]|0;w=v;x=(i^1)&1;y=j}c=c+1|0;if((c|0)>=(f[m>>2]|0))break;else{u=u+e|0;k=k+d|0;n=x;j=w;v=y}}return}function Pka(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=h+8|0;k=c&7;l=d&7;if((d^c)&4088|0){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,40)|0;n=265495;o=m+40|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Qka(-215,j,265536,1405)}n=(g|0)<0?(e|0)/2|0:g;g=(k|0)==0;m=(l|0)==4;if(g&m){o=VDc(12)|0;Aqa(o);f[o>>2]=56572;f[o+4>>2]=e;f[o+8>>2]=n;p=VDc(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=56592;f[p+8>>2]=o;f[a>>2]=p;f[a+4>>2]=o;f[q>>2]=(f[q>>2]|0)+1;o=f[q>>2]|0;f[q>>2]=o+-1;if((o|0)!=1){u=h;return}Yi[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(g&(l|0)==2){p=VDc(12)|0;Aqa(p);f[p>>2]=56612;f[p+4>>2]=e;f[p+8>>2]=n;o=VDc(16)|0;q=o+4|0;f[q>>2]=1;f[o>>2]=56632;f[o+8>>2]=p;f[a>>2]=o;f[a+4>>2]=p;f[q>>2]=(f[q>>2]|0)+1;p=f[q>>2]|0;f[q>>2]=p+-1;if((p|0)!=1){u=h;return}Yi[f[(f[o>>2]|0)+8>>2]&2047](o);u=h;return}o=(l|0)==6;if(g&o){g=VDc(12)|0;Aqa(g);f[g>>2]=56652;f[g+4>>2]=e;f[g+8>>2]=n;l=VDc(16)|0;p=l+4|0;f[p>>2]=1;f[l>>2]=56672;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[p>>2]=(f[p>>2]|0)+1;g=f[p>>2]|0;f[p>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=h;return}l=(k|0)==2;if(l&m){g=VDc(12)|0;Aqa(g);f[g>>2]=56692;f[g+4>>2]=e;f[g+8>>2]=n;p=VDc(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=56712;f[p+8>>2]=g;f[a>>2]=p;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(l&o){l=VDc(12)|0;Aqa(l);f[l>>2]=56732;f[l+4>>2]=e;f[l+8>>2]=n;p=VDc(16)|0;g=p+4|0;f[g>>2]=1;f[p>>2]=56752;f[p+8>>2]=l;f[a>>2]=p;f[a+4>>2]=l;f[g>>2]=(f[g>>2]|0)+1;l=f[g>>2]|0;f[g>>2]=l+-1;if((l|0)!=1){u=h;return}Yi[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}p=(k|0)==3;if(p&m){l=VDc(12)|0;Aqa(l);f[l>>2]=56772;f[l+4>>2]=e;f[l+8>>2]=n;g=VDc(16)|0;q=g+4|0;f[q>>2]=1;f[g>>2]=56792;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[q>>2]=(f[q>>2]|0)+1;l=f[q>>2]|0;f[q>>2]=l+-1;if((l|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if((k|0)==4&m){m=VDc(12)|0;Aqa(m);f[m>>2]=56812;f[m+4>>2]=e;f[m+8>>2]=n;g=VDc(16)|0;l=g+4|0;f[l>>2]=1;f[g>>2]=56832;f[g+8>>2]=m;f[a>>2]=g;f[a+4>>2]=m;f[l>>2]=(f[l>>2]|0)+1;m=f[l>>2]|0;f[l>>2]=m+-1;if((m|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if(p&o){p=VDc(12)|0;Aqa(p);f[p>>2]=56852;f[p+4>>2]=e;f[p+8>>2]=n;g=VDc(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=56872;f[g+8>>2]=p;f[a>>2]=g;f[a+4>>2]=p;f[m>>2]=(f[m>>2]|0)+1;p=f[m>>2]|0;f[m>>2]=p+-1;if((p|0)!=1){u=h;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if((k|0)==5&o){g=VDc(12)|0;Aqa(g);f[g>>2]=56892;f[g+4>>2]=e;f[g+8>>2]=n;p=VDc(16)|0;m=p+4|0;f[m>>2]=1;f[p>>2]=56912;f[p+8>>2]=g;f[a>>2]=p;f[a+4>>2]=g;f[m>>2]=(f[m>>2]|0)+1;g=f[m>>2]|0;f[m>>2]=g+-1;if((g|0)!=1){u=h;return}Yi[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(!((k|0)==6&o)){f[i>>2]=c;f[i+4>>2]=d;F5(j,274877,i);Qka(-213,j,265536,1433)}j=VDc(12)|0;Aqa(j);f[j>>2]=56932;f[j+4>>2]=e;f[j+8>>2]=n;n=VDc(16)|0;e=n+4|0;f[e>>2]=1;f[n>>2]=56952;f[n+8>>2]=j;f[a>>2]=n;f[a+4>>2]=j;f[e>>2]=(f[e>>2]|0)+1;j=f[e>>2]|0;f[e>>2]=j+-1;if((j|0)!=1){u=h;return}Yi[f[(f[n>>2]|0)+8>>2]&2047](n);u=h;return}function Qka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,266412,d);return}function Rka(a){a=a|0;YDc(a);return}function Ska(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tka(a){a=a|0;YDc(a);return}function Uka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{p[c+(j<<3)>>3]=+p[b+(j<<3)>>3]+ +p[b+(j+e<<3)>>3]+ +p[b+(j+i<<3)>>3];j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{p[c+(k<<3)>>3]=+p[b+(k<<3)>>3]+ +p[b+(k+e<<3)>>3]+ +p[b+(k+d<<3)>>3]+ +p[b+(k+j<<3)>>3]+ +p[b+(k+i<<3)>>3];k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){l=0.0;g=0;while(1){m=l+ +p[b+(g<<3)>>3];g=g+1|0;if((g|0)==(a|0)){n=m;break}else l=m}}else n=0.0;p[c>>3]=n;if((h|0)>0){o=n;q=0}else return;do{o=o+(+p[b+(q+a<<3)>>3]-+p[b+(q<<3)>>3]);q=q+1|0;p[c+(q<<3)>>3]=o}while((q|0)!=(h|0));return}case 3:{if((a|0)>0){o=0.0;n=0.0;l=0.0;q=0;while(1){m=l+ +p[b+(q<<3)>>3];r=n+ +p[b+(q+1<<3)>>3];s=o+ +p[b+(q+2<<3)>>3];q=q+3|0;if((q|0)>=(a|0)){t=s;u=r;v=m;break}else{o=s;n=r;l=m}}}else{t=0.0;u=0.0;v=0.0}p[c>>3]=v;p[c+8>>3]=u;p[c+16>>3]=t;if((h|0)>0){w=t;x=u;y=v;z=0}else return;do{q=z+a|0;y=y+(+p[b+(q<<3)>>3]-+p[b+(z<<3)>>3]);x=x+(+p[b+(q+1<<3)>>3]-+p[b+(z+1<<3)>>3]);w=w+(+p[b+(q+2<<3)>>3]-+p[b+(z+2<<3)>>3]);q=z;z=z+3|0;p[c+(z<<3)>>3]=y;p[c+(q+4<<3)>>3]=x;p[c+(q+5<<3)>>3]=w}while((z|0)<(h|0));return}case 4:{if((a|0)>0){w=0.0;x=0.0;y=0.0;v=0.0;z=0;while(1){u=v+ +p[b+(z<<3)>>3];t=y+ +p[b+((z|1)<<3)>>3];l=x+ +p[b+((z|2)<<3)>>3];n=w+ +p[b+((z|3)<<3)>>3];z=z+4|0;if((z|0)>=(a|0)){A=n;B=l;C=t;D=u;break}else{w=n;x=l;y=t;v=u}}}else{A=0.0;B=0.0;C=0.0;D=0.0}p[c>>3]=D;p[c+8>>3]=C;p[c+16>>3]=B;p[c+24>>3]=A;if((h|0)>0){E=A;F=B;G=C;H=D;I=0}else return;do{z=I+a|0;H=H+(+p[b+(z<<3)>>3]-+p[b+(I<<3)>>3]);G=G+(+p[b+(z+1<<3)>>3]-+p[b+((I|1)<<3)>>3]);F=F+(+p[b+(z+2<<3)>>3]-+p[b+((I|2)<<3)>>3]);E=E+(+p[b+(z+3<<3)>>3]-+p[b+((I|3)<<3)>>3]);z=I;I=I+4|0;p[c+(I<<3)>>3]=H;p[c+(z+5<<3)>>3]=G;p[c+(z+6<<3)>>3]=F;p[c+(z+7<<3)>>3]=E}while((I|0)<(h|0));return}default:{if((e|0)<=0)return;I=(h|0)>0;if((a|0)>0){z=0;q=c;g=b;while(1){E=0.0;k=0;do{E=E+ +p[g+(k<<3)>>3];k=k+e|0}while((k|0)<(a|0));p[q>>3]=E;if(I){F=E;k=0;do{F=F+(+p[g+(k+a<<3)>>3]-+p[g+(k<<3)>>3]);k=k+e|0;p[q+(k<<3)>>3]=F}while((k|0)<(h|0))}z=z+1|0;if((z|0)==(e|0))break;else{q=q+8|0;g=g+8|0}}return}if(I){J=0;K=c;L=b}else{XIc(c|0,0,e<<3|0)|0;return}while(1){p[K>>3]=0.0;F=0.0;c=0;do{F=F+(+p[L+(c+a<<3)>>3]-+p[L+(c<<3)>>3]);c=c+e|0;p[K+(c<<3)>>3]=F}while((c|0)<(h|0));J=J+1|0;if((J|0)==(e|0))break;else{K=K+8|0;L=L+8|0}}return}}}}function Vka(a){a=a|0;YDc(a);return}function Wka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Xka(a){a=a|0;YDc(a);return}function Yka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{p[c+(j<<3)>>3]=+n[b+(j<<2)>>2]+ +n[b+(j+e<<2)>>2]+ +n[b+(j+i<<2)>>2];j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{p[c+(k<<3)>>3]=+n[b+(k<<2)>>2]+ +n[b+(k+e<<2)>>2]+ +n[b+(k+d<<2)>>2]+ +n[b+(k+j<<2)>>2]+ +n[b+(k+i<<2)>>2];k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){l=0.0;g=0;while(1){m=l+ +n[b+(g<<2)>>2];g=g+1|0;if((g|0)==(a|0)){o=m;break}else l=m}}else o=0.0;p[c>>3]=o;if((h|0)>0){q=o;r=0}else return;do{q=q+(+n[b+(r+a<<2)>>2]-+n[b+(r<<2)>>2]);r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(h|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;l=0.0;r=0;while(1){m=l+ +n[b+(r<<2)>>2];s=o+ +n[b+(r+1<<2)>>2];t=q+ +n[b+(r+2<<2)>>2];r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=m;break}else{q=t;o=s;l=m}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((h|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+n[b+(r<<2)>>2]-+n[b+(A<<2)>>2]);y=y+(+n[b+(r+1<<2)>>2]-+n[b+(A+1<<2)>>2]);x=x+(+n[b+(r+2<<2)>>2]-+n[b+(A+2<<2)>>2]);r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(h|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +n[b+(A<<2)>>2];u=z+ +n[b+((A|1)<<2)>>2];l=y+ +n[b+((A|2)<<2)>>2];o=x+ +n[b+((A|3)<<2)>>2];A=A+4|0;if((A|0)>=(a|0)){B=o;C=l;D=u;E=v;break}else{x=o;y=l;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((h|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+n[b+(A<<2)>>2]-+n[b+(J<<2)>>2]);H=H+(+n[b+(A+1<<2)>>2]-+n[b+((J|1)<<2)>>2]);G=G+(+n[b+(A+2<<2)>>2]-+n[b+((J|2)<<2)>>2]);F=F+(+n[b+(A+3<<2)>>2]-+n[b+((J|3)<<2)>>2]);A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(h|0));return}default:{if((e|0)<=0)return;J=(h|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;k=0;do{F=F+ +n[g+(k<<2)>>2];k=k+e|0}while((k|0)<(a|0));p[r>>3]=F;if(J){G=F;k=0;do{G=G+(+n[g+(k+a<<2)>>2]-+n[g+(k<<2)>>2]);k=k+e|0;p[r+(k<<3)>>3]=G}while((k|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+4|0}}return}if(J){K=0;L=c;M=b}else{XIc(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+n[M+(c+a<<2)>>2]-+n[M+(c<<2)>>2]);c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(h|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+4|0}}return}}}}function Zka(a){a=a|0;YDc(a);return}function _ka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $ka(a){a=a|0;YDc(a);return}function ala(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;h=f[a+4>>2]|0;a=Y(h,g)|0;i=Y(e+-1|0,g)|0;switch(h|0){case 3:{h=Y(g,e)|0;if((h|0)<=0)return;j=g<<1;k=0;do{p[c+(k<<3)>>3]=+(d[b+(k<<1)>>1]|0)+ +(d[b+(k+g<<1)>>1]|0)+ +(d[b+(k+j<<1)>>1]|0);k=k+1|0}while((k|0)!=(h|0));return}case 5:{h=Y(g,e)|0;if((h|0)<=0)return;e=g<<1;k=g*3|0;j=g<<2;l=0;do{p[c+(l<<3)>>3]=+(d[b+(l<<1)>>1]|0)+ +(d[b+(l+g<<1)>>1]|0)+ +(d[b+(l+e<<1)>>1]|0)+ +(d[b+(l+k<<1)>>1]|0)+ +(d[b+(l+j<<1)>>1]|0);l=l+1|0}while((l|0)!=(h|0));return}default:switch(g|0){case 1:{if((a|0)>0){m=0.0;h=0;while(1){n=m+ +(d[b+(h<<1)>>1]|0);h=h+1|0;if((h|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((i|0)>0){q=o;r=0}else return;do{q=q+(+(d[b+(r+a<<1)>>1]|0)-+(d[b+(r<<1)>>1]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(i|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(d[b+(r<<1)>>1]|0);s=o+ +(d[b+(r+1<<1)>>1]|0);t=q+ +(d[b+(r+2<<1)>>1]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((i|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(d[b+(r<<1)>>1]|0)-+(d[b+(A<<1)>>1]|0));y=y+(+(d[b+(r+1<<1)>>1]|0)-+(d[b+(A+1<<1)>>1]|0));x=x+(+(d[b+(r+2<<1)>>1]|0)-+(d[b+(A+2<<1)>>1]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(i|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(d[b+(A<<1)>>1]|0);u=z+ +(d[b+((A|1)<<1)>>1]|0);m=y+ +(d[b+((A|2)<<1)>>1]|0);o=x+ +(d[b+((A|3)<<1)>>1]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((i|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(d[b+(A<<1)>>1]|0)-+(d[b+(J<<1)>>1]|0));H=H+(+(d[b+(A+1<<1)>>1]|0)-+(d[b+((J|1)<<1)>>1]|0));G=G+(+(d[b+(A+2<<1)>>1]|0)-+(d[b+((J|2)<<1)>>1]|0));F=F+(+(d[b+(A+3<<1)>>1]|0)-+(d[b+((J|3)<<1)>>1]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(i|0));return}default:{if((g|0)<=0)return;J=(i|0)>0;if((a|0)>0){A=0;r=c;h=b;while(1){F=0.0;l=0;do{F=F+ +(d[h+(l<<1)>>1]|0);l=l+g|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(d[h+(l+a<<1)>>1]|0)-+(d[h+(l<<1)>>1]|0));l=l+g|0;p[r+(l<<3)>>3]=G}while((l|0)<(i|0))}A=A+1|0;if((A|0)==(g|0))break;else{r=r+8|0;h=h+2|0}}return}if(J){K=0;L=c;M=b}else{XIc(c|0,0,g<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(d[M+(c+a<<1)>>1]|0)-+(d[M+(c<<1)>>1]|0));c=c+g|0;p[L+(c<<3)>>3]=G}while((c|0)<(i|0));K=K+1|0;if((K|0)==(g|0))break;else{L=L+8|0;M=M+2|0}}return}}}}function bla(a){a=a|0;YDc(a);return}function cla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dla(a){a=a|0;YDc(a);return}function ela(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{f[c+(j<<2)>>2]=(f[b+(j+e<<2)>>2]|0)+(f[b+(j<<2)>>2]|0)+(f[b+(j+i<<2)>>2]|0);j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{f[c+(k<<2)>>2]=(f[b+(k+e<<2)>>2]|0)+(f[b+(k<<2)>>2]|0)+(f[b+(k+d<<2)>>2]|0)+(f[b+(k+j<<2)>>2]|0)+(f[b+(k+i<<2)>>2]|0);k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;k=0;while(1){i=(f[b+(k<<2)>>2]|0)+g|0;k=k+1|0;if((k|0)==(a|0)){l=i;break}else g=i}}else l=0;f[c>>2]=l;if((h|0)>0){m=l;n=0}else return;do{m=(f[b+(n+a<<2)>>2]|0)-(f[b+(n<<2)>>2]|0)+m|0;n=n+1|0;f[c+(n<<2)>>2]=m}while((n|0)!=(h|0));return}case 3:{if((a|0)>0){n=0;m=0;l=0;g=0;while(1){k=(f[b+(g<<2)>>2]|0)+l|0;i=(f[b+(g+1<<2)>>2]|0)+m|0;j=(f[b+(g+2<<2)>>2]|0)+n|0;g=g+3|0;if((g|0)>=(a|0)){o=j;p=i;q=k;break}else{n=j;m=i;l=k}}}else{o=0;p=0;q=0}f[c>>2]=q;f[c+4>>2]=p;f[c+8>>2]=o;if((h|0)>0){r=o;s=p;t=q;u=0}else return;do{q=u+a|0;t=(f[b+(q<<2)>>2]|0)-(f[b+(u<<2)>>2]|0)+t|0;s=(f[b+(q+1<<2)>>2]|0)-(f[b+(u+1<<2)>>2]|0)+s|0;r=(f[b+(q+2<<2)>>2]|0)-(f[b+(u+2<<2)>>2]|0)+r|0;q=u;u=u+3|0;f[c+(u<<2)>>2]=t;f[c+(q+4<<2)>>2]=s;f[c+(q+5<<2)>>2]=r}while((u|0)<(h|0));return}case 4:{if((a|0)>0){u=0;r=0;s=0;t=0;q=0;while(1){p=(f[b+(q<<2)>>2]|0)+t|0;o=(f[b+((q|1)<<2)>>2]|0)+s|0;l=(f[b+((q|2)<<2)>>2]|0)+r|0;m=(f[b+((q|3)<<2)>>2]|0)+u|0;q=q+4|0;if((q|0)>=(a|0)){v=m;w=l;x=o;y=p;break}else{u=m;r=l;s=o;t=p}}}else{v=0;w=0;x=0;y=0}f[c>>2]=y;f[c+4>>2]=x;f[c+8>>2]=w;f[c+12>>2]=v;if((h|0)>0){z=v;A=w;B=x;C=y;D=0}else return;do{y=D+a|0;C=(f[b+(y<<2)>>2]|0)-(f[b+(D<<2)>>2]|0)+C|0;B=(f[b+(y+1<<2)>>2]|0)-(f[b+((D|1)<<2)>>2]|0)+B|0;A=(f[b+(y+2<<2)>>2]|0)-(f[b+((D|2)<<2)>>2]|0)+A|0;z=(f[b+(y+3<<2)>>2]|0)-(f[b+((D|3)<<2)>>2]|0)+z|0;y=D;D=D+4|0;f[c+(D<<2)>>2]=C;f[c+(y+5<<2)>>2]=B;f[c+(y+6<<2)>>2]=A;f[c+(y+7<<2)>>2]=z}while((D|0)<(h|0));return}default:{if((e|0)<=0)return;D=(h|0)>0;if((a|0)>0){z=0;A=c;B=b;while(1){C=0;y=0;do{C=(f[B+(y<<2)>>2]|0)+C|0;y=y+e|0}while((y|0)<(a|0));f[A>>2]=C;if(D){y=C;x=0;do{y=(f[B+(x+a<<2)>>2]|0)-(f[B+(x<<2)>>2]|0)+y|0;x=x+e|0;f[A+(x<<2)>>2]=y}while((x|0)<(h|0))}z=z+1|0;if((z|0)==(e|0))break;else{A=A+4|0;B=B+4|0}}return}if(D){E=0;F=c;G=b}else{XIc(c|0,0,e<<2|0)|0;return}while(1){f[F>>2]=0;c=0;b=0;do{c=(f[G+(b+a<<2)>>2]|0)-(f[G+(b<<2)>>2]|0)+c|0;b=b+e|0;f[F+(b<<2)>>2]=c}while((b|0)<(h|0));E=E+1|0;if((E|0)==(e|0))break;else{F=F+4|0;G=G+4|0}}return}}}}function fla(a){a=a|0;YDc(a);return}function gla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hla(a){a=a|0;YDc(a);return}function ila(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=f[a+4>>2]|0;a=Y(h,g)|0;i=Y(e+-1|0,g)|0;switch(h|0){case 3:{h=Y(g,e)|0;if((h|0)<=0)return;j=g<<1;k=0;do{f[c+(k<<2)>>2]=(d[b+(k+g<<1)>>1]|0)+(d[b+(k<<1)>>1]|0)+(d[b+(k+j<<1)>>1]|0);k=k+1|0}while((k|0)!=(h|0));return}case 5:{h=Y(g,e)|0;if((h|0)<=0)return;e=g<<1;k=g*3|0;j=g<<2;l=0;do{f[c+(l<<2)>>2]=(d[b+(l+g<<1)>>1]|0)+(d[b+(l<<1)>>1]|0)+(d[b+(l+e<<1)>>1]|0)+(d[b+(l+k<<1)>>1]|0)+(d[b+(l+j<<1)>>1]|0);l=l+1|0}while((l|0)!=(h|0));return}default:switch(g|0){case 1:{if((a|0)>0){h=0;l=0;while(1){j=(d[b+(l<<1)>>1]|0)+h|0;l=l+1|0;if((l|0)==(a|0)){m=j;break}else h=j}}else m=0;f[c>>2]=m;if((i|0)>0){n=m;o=0}else return;do{n=(d[b+(o+a<<1)>>1]|0)-(d[b+(o<<1)>>1]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(i|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;h=0;while(1){l=(d[b+(h<<1)>>1]|0)+m|0;j=(d[b+(h+1<<1)>>1]|0)+n|0;k=(d[b+(h+2<<1)>>1]|0)+o|0;h=h+3|0;if((h|0)>=(a|0)){p=k;q=j;r=l;break}else{o=k;n=j;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((i|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(d[b+(r<<1)>>1]|0)-(d[b+(v<<1)>>1]|0)+u|0;t=(d[b+(r+1<<1)>>1]|0)-(d[b+(v+1<<1)>>1]|0)+t|0;s=(d[b+(r+2<<1)>>1]|0)-(d[b+(v+2<<1)>>1]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(i|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(d[b+(r<<1)>>1]|0)+u|0;p=(d[b+((r|1)<<1)>>1]|0)+t|0;m=(d[b+((r|2)<<1)>>1]|0)+s|0;n=(d[b+((r|3)<<1)>>1]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((i|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(d[b+(z<<1)>>1]|0)-(d[b+(E<<1)>>1]|0)+D|0;C=(d[b+(z+1<<1)>>1]|0)-(d[b+((E|1)<<1)>>1]|0)+C|0;B=(d[b+(z+2<<1)>>1]|0)-(d[b+((E|2)<<1)>>1]|0)+B|0;A=(d[b+(z+3<<1)>>1]|0)-(d[b+((E|3)<<1)>>1]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(i|0));return}default:{if((g|0)<=0)return;E=(i|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(d[C+(z<<1)>>1]|0)+D|0;z=z+g|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(d[C+(y+a<<1)>>1]|0)-(d[C+(y<<1)>>1]|0)+z|0;y=y+g|0;f[B+(y<<2)>>2]=z}while((y|0)<(i|0))}A=A+1|0;if((A|0)==(g|0))break;else{B=B+4|0;C=C+2|0}}return}if(E){F=0;G=c;H=b}else{XIc(c|0,0,g<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(d[H+(b+a<<1)>>1]|0)-(d[H+(b<<1)>>1]|0)+c|0;b=b+g|0;f[G+(b<<2)>>2]=c}while((b|0)<(i|0));F=F+1|0;if((F|0)==(g|0))break;else{G=G+4|0;H=H+2|0}}return}}}}function jla(a){a=a|0;YDc(a);return}function kla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function lla(a){a=a|0;YDc(a);return}function mla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;k=0;do{p[c+(k<<3)>>3]=+(j[b+(k<<1)>>1]|0)+ +(j[b+(k+e<<1)>>1]|0)+ +(j[b+(k+i<<1)>>1]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;i=e<<2;l=0;do{p[c+(l<<3)>>3]=+(j[b+(l<<1)>>1]|0)+ +(j[b+(l+e<<1)>>1]|0)+ +(j[b+(l+d<<1)>>1]|0)+ +(j[b+(l+k<<1)>>1]|0)+ +(j[b+(l+i<<1)>>1]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){m=0.0;g=0;while(1){n=m+ +(j[b+(g<<1)>>1]|0);g=g+1|0;if((g|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((h|0)>0){q=o;r=0}else return;do{q=q+(+(j[b+(r+a<<1)>>1]|0)-+(j[b+(r<<1)>>1]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(h|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(j[b+(r<<1)>>1]|0);s=o+ +(j[b+(r+1<<1)>>1]|0);t=q+ +(j[b+(r+2<<1)>>1]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((h|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(j[b+(r<<1)>>1]|0)-+(j[b+(A<<1)>>1]|0));y=y+(+(j[b+(r+1<<1)>>1]|0)-+(j[b+(A+1<<1)>>1]|0));x=x+(+(j[b+(r+2<<1)>>1]|0)-+(j[b+(A+2<<1)>>1]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(h|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(j[b+(A<<1)>>1]|0);u=z+ +(j[b+((A|1)<<1)>>1]|0);m=y+ +(j[b+((A|2)<<1)>>1]|0);o=x+ +(j[b+((A|3)<<1)>>1]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((h|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(j[b+(A<<1)>>1]|0)-+(j[b+(J<<1)>>1]|0));H=H+(+(j[b+(A+1<<1)>>1]|0)-+(j[b+((J|1)<<1)>>1]|0));G=G+(+(j[b+(A+2<<1)>>1]|0)-+(j[b+((J|2)<<1)>>1]|0));F=F+(+(j[b+(A+3<<1)>>1]|0)-+(j[b+((J|3)<<1)>>1]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(h|0));return}default:{if((e|0)<=0)return;J=(h|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;l=0;do{F=F+ +(j[g+(l<<1)>>1]|0);l=l+e|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(j[g+(l+a<<1)>>1]|0)-+(j[g+(l<<1)>>1]|0));l=l+e|0;p[r+(l<<3)>>3]=G}while((l|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+2|0}}return}if(J){K=0;L=c;M=b}else{XIc(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(j[M+(c+a<<1)>>1]|0)-+(j[M+(c<<1)>>1]|0));c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(h|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+2|0}}return}}}}function nla(a){a=a|0;YDc(a);return}function ola(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pla(a){a=a|0;YDc(a);return}function qla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;k=0;do{f[c+(k<<2)>>2]=(j[b+(k+e<<1)>>1]|0)+(j[b+(k<<1)>>1]|0)+(j[b+(k+i<<1)>>1]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;i=e<<2;l=0;do{f[c+(l<<2)>>2]=(j[b+(l+e<<1)>>1]|0)+(j[b+(l<<1)>>1]|0)+(j[b+(l+d<<1)>>1]|0)+(j[b+(l+k<<1)>>1]|0)+(j[b+(l+i<<1)>>1]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0;while(1){i=(j[b+(l<<1)>>1]|0)+g|0;l=l+1|0;if((l|0)==(a|0)){m=i;break}else g=i}}else m=0;f[c>>2]=m;if((h|0)>0){n=m;o=0}else return;do{n=(j[b+(o+a<<1)>>1]|0)-(j[b+(o<<1)>>1]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(h|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;g=0;while(1){l=(j[b+(g<<1)>>1]|0)+m|0;i=(j[b+(g+1<<1)>>1]|0)+n|0;k=(j[b+(g+2<<1)>>1]|0)+o|0;g=g+3|0;if((g|0)>=(a|0)){p=k;q=i;r=l;break}else{o=k;n=i;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((h|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(j[b+(r<<1)>>1]|0)-(j[b+(v<<1)>>1]|0)+u|0;t=(j[b+(r+1<<1)>>1]|0)-(j[b+(v+1<<1)>>1]|0)+t|0;s=(j[b+(r+2<<1)>>1]|0)-(j[b+(v+2<<1)>>1]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(h|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(j[b+(r<<1)>>1]|0)+u|0;p=(j[b+((r|1)<<1)>>1]|0)+t|0;m=(j[b+((r|2)<<1)>>1]|0)+s|0;n=(j[b+((r|3)<<1)>>1]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((h|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(j[b+(z<<1)>>1]|0)-(j[b+(E<<1)>>1]|0)+D|0;C=(j[b+(z+1<<1)>>1]|0)-(j[b+((E|1)<<1)>>1]|0)+C|0;B=(j[b+(z+2<<1)>>1]|0)-(j[b+((E|2)<<1)>>1]|0)+B|0;A=(j[b+(z+3<<1)>>1]|0)-(j[b+((E|3)<<1)>>1]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(h|0));return}default:{if((e|0)<=0)return;E=(h|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(j[C+(z<<1)>>1]|0)+D|0;z=z+e|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(j[C+(y+a<<1)>>1]|0)-(j[C+(y<<1)>>1]|0)+z|0;y=y+e|0;f[B+(y<<2)>>2]=z}while((y|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{B=B+4|0;C=C+2|0}}return}if(E){F=0;G=c;H=b}else{XIc(c|0,0,e<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(j[H+(b+a<<1)>>1]|0)-(j[H+(b<<1)>>1]|0)+c|0;b=b+e|0;f[G+(b<<2)>>2]=c}while((b|0)<(h|0));F=F+1|0;if((F|0)==(e|0))break;else{G=G+4|0;H=H+2|0}}return}}}}function rla(a){a=a|0;YDc(a);return}function sla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tla(a){a=a|0;YDc(a);return}function ula(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;i=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;j=e<<1;k=0;do{p[c+(k<<3)>>3]=+(h[b+k>>0]|0)+ +(h[b+(k+e)>>0]|0)+ +(h[b+(k+j)>>0]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;j=e<<2;l=0;do{p[c+(l<<3)>>3]=+(h[b+l>>0]|0)+ +(h[b+(l+e)>>0]|0)+ +(h[b+(l+d)>>0]|0)+ +(h[b+(l+k)>>0]|0)+ +(h[b+(l+j)>>0]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){m=0.0;g=0;while(1){n=m+ +(h[b+g>>0]|0);g=g+1|0;if((g|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((i|0)>0){q=o;r=0}else return;do{q=q+(+(h[b+(r+a)>>0]|0)-+(h[b+r>>0]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(i|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(h[b+r>>0]|0);s=o+ +(h[b+(r+1)>>0]|0);t=q+ +(h[b+(r+2)>>0]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((i|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(h[b+r>>0]|0)-+(h[b+A>>0]|0));y=y+(+(h[b+(r+1)>>0]|0)-+(h[b+(A+1)>>0]|0));x=x+(+(h[b+(r+2)>>0]|0)-+(h[b+(A+2)>>0]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(i|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(h[b+A>>0]|0);u=z+ +(h[b+(A|1)>>0]|0);m=y+ +(h[b+(A|2)>>0]|0);o=x+ +(h[b+(A|3)>>0]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((i|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(h[b+A>>0]|0)-+(h[b+J>>0]|0));H=H+(+(h[b+(A+1)>>0]|0)-+(h[b+(J|1)>>0]|0));G=G+(+(h[b+(A+2)>>0]|0)-+(h[b+(J|2)>>0]|0));F=F+(+(h[b+(A+3)>>0]|0)-+(h[b+(J|3)>>0]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(i|0));return}default:{if((e|0)<=0)return;J=(i|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;l=0;do{F=F+ +(h[g+l>>0]|0);l=l+e|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(h[g+(l+a)>>0]|0)-+(h[g+l>>0]|0));l=l+e|0;p[r+(l<<3)>>3]=G}while((l|0)<(i|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+1|0}}return}if(J){K=0;L=c;M=b}else{XIc(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(h[M+(c+a)>>0]|0)-+(h[M+c>>0]|0));c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(i|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+1|0}}return}}}}function vla(a){a=a|0;YDc(a);return}function wla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xla(a){a=a|0;YDc(a);return}function yla(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=Y(i,g)|0;j=Y(e+-1|0,g)|0;switch(i|0){case 3:{i=Y(g,e)|0;if((i|0)<=0)return;k=g<<1;l=0;do{d[c+(l<<1)>>1]=(h[b+(l+g)>>0]|0)+(h[b+l>>0]|0)+(h[b+(l+k)>>0]|0);l=l+1|0}while((l|0)!=(i|0));return}case 5:{i=Y(g,e)|0;if((i|0)<=0)return;e=g<<1;l=g*3|0;k=g<<2;m=0;do{d[c+(m<<1)>>1]=(h[b+(m+g)>>0]|0)+(h[b+m>>0]|0)+(h[b+(m+e)>>0]|0)+(h[b+(m+l)>>0]|0)+(h[b+(m+k)>>0]|0);m=m+1|0}while((m|0)!=(i|0));return}default:switch(g|0){case 1:{if((a|0)>0){i=0;m=0;do{i=(h[b+m>>0]|0)+(i&65535)|0;m=m+1|0}while((m|0)!=(a|0));n=i&65535}else n=0;d[c>>1]=n;if((j|0)>0){o=n;p=0}else return;do{o=(h[b+(p+a)>>0]|0)+(o&65535)-(h[b+p>>0]|0)&65535;p=p+1|0;d[c+(p<<1)>>1]=o}while((p|0)!=(j|0));return}case 3:{if((a|0)>0){p=0;o=0;n=0;i=0;do{n=(h[b+i>>0]|0)+(n&65535)|0;o=(h[b+(i+1)>>0]|0)+(o&65535)|0;p=(h[b+(i+2)>>0]|0)+(p&65535)|0;i=i+3|0}while((i|0)<(a|0));q=p&65535;r=o&65535;s=n&65535}else{q=0;r=0;s=0}d[c>>1]=s;d[c+2>>1]=r;d[c+4>>1]=q;if((j|0)>0){t=q;u=r;v=s;w=0}else return;do{s=w+a|0;v=(h[b+s>>0]|0)+(v&65535)-(h[b+w>>0]|0)&65535;u=(h[b+(s+1)>>0]|0)+(u&65535)-(h[b+(w+1)>>0]|0)&65535;t=(h[b+(s+2)>>0]|0)+(t&65535)-(h[b+(w+2)>>0]|0)&65535;s=w;w=w+3|0;d[c+(w<<1)>>1]=v;d[c+(s+4<<1)>>1]=u;d[c+(s+5<<1)>>1]=t}while((w|0)<(j|0));return}case 4:{if((a|0)>0){w=0;t=0;u=0;v=0;s=0;do{v=(h[b+s>>0]|0)+(v&65535)|0;u=(h[b+(s|1)>>0]|0)+(u&65535)|0;t=(h[b+(s|2)>>0]|0)+(t&65535)|0;w=(h[b+(s|3)>>0]|0)+(w&65535)|0;s=s+4|0}while((s|0)<(a|0));x=w&65535;y=t&65535;z=u&65535;A=v&65535}else{x=0;y=0;z=0;A=0}d[c>>1]=A;d[c+2>>1]=z;d[c+4>>1]=y;d[c+6>>1]=x;if((j|0)>0){B=x;C=y;D=z;E=A;F=0}else return;do{A=F+a|0;E=(h[b+A>>0]|0)+(E&65535)-(h[b+F>>0]|0)&65535;D=(h[b+(A+1)>>0]|0)+(D&65535)-(h[b+(F|1)>>0]|0)&65535;C=(h[b+(A+2)>>0]|0)+(C&65535)-(h[b+(F|2)>>0]|0)&65535;B=(h[b+(A+3)>>0]|0)+(B&65535)-(h[b+(F|3)>>0]|0)&65535;A=F;F=F+4|0;d[c+(F<<1)>>1]=E;d[c+(A+5<<1)>>1]=D;d[c+(A+6<<1)>>1]=C;d[c+(A+7<<1)>>1]=B}while((F|0)<(j|0));return}default:{if((g|0)<=0)return;F=(j|0)>0;if((a|0)>0){B=0;C=c;D=b;while(1){E=0;A=0;do{E=(h[D+A>>0]|0)+(E&65535)|0;A=A+g|0}while((A|0)<(a|0));d[C>>1]=E;if(F){A=E;z=0;do{A=(h[D+(z+a)>>0]|0)+(A&65535)-(h[D+z>>0]|0)|0;z=z+g|0;d[C+(z<<1)>>1]=A}while((z|0)<(j|0))}B=B+1|0;if((B|0)==(g|0))break;else{C=C+2|0;D=D+1|0}}return}if(F){G=0;H=c;I=b}else{XIc(c|0,0,g<<1|0)|0;return}while(1){d[H>>1]=0;c=0;b=0;do{c=(h[I+(b+a)>>0]|0)+(c&65535)-(h[I+b>>0]|0)|0;b=b+g|0;d[H+(b<<1)>>1]=c}while((b|0)<(j|0));G=G+1|0;if((G|0)==(g|0))break;else{H=H+2|0;I=I+1|0}}return}}}}function zla(a){a=a|0;YDc(a);return}function Ala(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Bla(a){a=a|0;YDc(a);return}function Cla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f[a+4>>2]|0;a=Y(g,e)|0;i=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;j=e<<1;k=0;do{f[c+(k<<2)>>2]=(h[b+(k+e)>>0]|0)+(h[b+k>>0]|0)+(h[b+(k+j)>>0]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;j=e<<2;l=0;do{f[c+(l<<2)>>2]=(h[b+(l+e)>>0]|0)+(h[b+l>>0]|0)+(h[b+(l+d)>>0]|0)+(h[b+(l+k)>>0]|0)+(h[b+(l+j)>>0]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0;while(1){j=(h[b+l>>0]|0)+g|0;l=l+1|0;if((l|0)==(a|0)){m=j;break}else g=j}}else m=0;f[c>>2]=m;if((i|0)>0){n=m;o=0}else return;do{n=(h[b+(o+a)>>0]|0)-(h[b+o>>0]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(i|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;g=0;while(1){l=(h[b+g>>0]|0)+m|0;j=(h[b+(g+1)>>0]|0)+n|0;k=(h[b+(g+2)>>0]|0)+o|0;g=g+3|0;if((g|0)>=(a|0)){p=k;q=j;r=l;break}else{o=k;n=j;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((i|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(h[b+r>>0]|0)-(h[b+v>>0]|0)+u|0;t=(h[b+(r+1)>>0]|0)-(h[b+(v+1)>>0]|0)+t|0;s=(h[b+(r+2)>>0]|0)-(h[b+(v+2)>>0]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(i|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(h[b+r>>0]|0)+u|0;p=(h[b+(r|1)>>0]|0)+t|0;m=(h[b+(r|2)>>0]|0)+s|0;n=(h[b+(r|3)>>0]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((i|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(h[b+z>>0]|0)-(h[b+E>>0]|0)+D|0;C=(h[b+(z+1)>>0]|0)-(h[b+(E|1)>>0]|0)+C|0;B=(h[b+(z+2)>>0]|0)-(h[b+(E|2)>>0]|0)+B|0;A=(h[b+(z+3)>>0]|0)-(h[b+(E|3)>>0]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(i|0));return}default:{if((e|0)<=0)return;E=(i|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(h[C+z>>0]|0)+D|0;z=z+e|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(h[C+(y+a)>>0]|0)-(h[C+y>>0]|0)+z|0;y=y+e|0;f[B+(y<<2)>>2]=z}while((y|0)<(i|0))}A=A+1|0;if((A|0)==(e|0))break;else{B=B+4|0;C=C+1|0}}return}if(E){F=0;G=c;H=b}else{XIc(c|0,0,e<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(h[H+(b+a)>>0]|0)-(h[H+b>>0]|0)+c|0;b=b+e|0;f[G+(b<<2)>>2]=c}while((b|0)<(i|0));F=F+1|0;if((F|0)==(e|0))break;else{G=G+4|0;H=H+1|0}}return}}}}function Dla(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0;i=u;u=u+16|0;j=i;k=i+8|0;l=c&7;m=d&7;if((d^c)&4088|0){f[k>>2]=0;f[k+4>>2]=0;n=tT(k,40)|0;o=266484;q=n+40|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));Qka(-215,k,266525,1441)}o=(g|0)<0?(e|0)/2|0:g;g=(m|0)==0;n=(l|0)==4;if(n&g){q=VDc(40)|0;Bqa(q);f[q>>2]=56972;f[q+28>>2]=0;f[q+32>>2]=0;f[q+36>>2]=0;f[q+4>>2]=e;f[q+8>>2]=o;p[q+16>>3]=h;f[q+24>>2]=0;r=VDc(16)|0;s=r+4|0;f[s>>2]=1;f[r>>2]=56996;f[r+8>>2]=q;f[a>>2]=r;f[a+4>>2]=q;f[s>>2]=(f[s>>2]|0)+1;q=f[s>>2]|0;f[s>>2]=q+-1;if((q|0)!=1){u=i;return}Yi[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}if((l|0)==2&g){r=VDc(48)|0;Bqa(r);f[r>>2]=57016;f[r+36>>2]=0;f[r+40>>2]=0;f[r+44>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;q=r+28|0;f[q>>2]=0;s=r+32|0;f[s>>2]=1;do if(h!=1.0){t=nrc(1.0/h)|0;v=8388608.0/+(t|0);w=~~v;x=w-(+(w|0)>v&1)|0;f[s>>2]=x;w=(t|0)/2|0;f[q>>2]=w;if(v-+(x|0)<.5){f[q>>2]=w+1;break}else{f[s>>2]=x+1;break}}while(0);s=VDc(16)|0;q=s+4|0;f[q>>2]=1;f[s>>2]=57040;f[s+8>>2]=r;f[a>>2]=s;f[a+4>>2]=r;f[q>>2]=(f[q>>2]|0)+1;r=f[q>>2]|0;f[q>>2]=r+-1;if((r|0)!=1){u=i;return}Yi[f[(f[s>>2]|0)+8>>2]&2047](s);u=i;return}s=(l|0)==6;if(s&g){g=VDc(40)|0;Bqa(g);f[g>>2]=57060;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;l=VDc(16)|0;r=l+4|0;f[r>>2]=1;f[l>>2]=57084;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[r>>2]=(f[r>>2]|0)+1;g=f[r>>2]|0;f[r>>2]=g+-1;if((g|0)!=1){u=i;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}l=(m|0)==2;if(n&l){g=VDc(40)|0;Bqa(g);f[g>>2]=57104;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;r=VDc(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=57128;f[r+8>>2]=g;f[a>>2]=r;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=i;return}Yi[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}if(s&l){l=VDc(40)|0;Bqa(l);f[l>>2]=57148;f[l+28>>2]=0;f[l+32>>2]=0;f[l+36>>2]=0;f[l+4>>2]=e;f[l+8>>2]=o;p[l+16>>3]=h;f[l+24>>2]=0;r=VDc(16)|0;g=r+4|0;f[g>>2]=1;f[r>>2]=57172;f[r+8>>2]=l;f[a>>2]=r;f[a+4>>2]=l;f[g>>2]=(f[g>>2]|0)+1;l=f[g>>2]|0;f[g>>2]=l+-1;if((l|0)!=1){u=i;return}Yi[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}r=(m|0)==3;if(n&r){l=VDc(40)|0;Bqa(l);f[l>>2]=57192;f[l+28>>2]=0;f[l+32>>2]=0;f[l+36>>2]=0;f[l+4>>2]=e;f[l+8>>2]=o;p[l+16>>3]=h;f[l+24>>2]=0;g=VDc(16)|0;q=g+4|0;f[q>>2]=1;f[g>>2]=57216;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[q>>2]=(f[q>>2]|0)+1;l=f[q>>2]|0;f[q>>2]=l+-1;if((l|0)!=1){u=i;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=i;return}if(s&r){r=VDc(40)|0;Bqa(r);f[r>>2]=57236;f[r+28>>2]=0;f[r+32>>2]=0;f[r+36>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;g=VDc(16)|0;l=g+4|0;f[l>>2]=1;f[g>>2]=57260;f[g+8>>2]=r;f[a>>2]=g;f[a+4>>2]=r;f[l>>2]=(f[l>>2]|0)+1;r=f[l>>2]|0;f[l>>2]=r+-1;if((r|0)!=1){u=i;return}Yi[f[(f[g>>2]|0)+8>>2]&2047](g);u=i;return}if(n&(m|0)==4){g=VDc(40)|0;Bqa(g);f[g>>2]=57280;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;r=VDc(16)|0;l=r+4|0;f[l>>2]=1;f[r>>2]=57304;f[r+8>>2]=g;f[a>>2]=r;f[a+4>>2]=g;f[l>>2]=(f[l>>2]|0)+1;g=f[l>>2]|0;f[l>>2]=g+-1;if((g|0)!=1){u=i;return}Yi[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}r=(m|0)==5;if(n&r){g=VDc(40)|0;Bqa(g);f[g>>2]=57324;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;l=VDc(16)|0;q=l+4|0;f[q>>2]=1;f[l>>2]=57348;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=i;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}if(s&r){r=VDc(40)|0;Bqa(r);f[r>>2]=57368;f[r+28>>2]=0;f[r+32>>2]=0;f[r+36>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;l=VDc(16)|0;g=l+4|0;f[g>>2]=1;f[l>>2]=57392;f[l+8>>2]=r;f[a>>2]=l;f[a+4>>2]=r;f[g>>2]=(f[g>>2]|0)+1;r=f[g>>2]|0;f[g>>2]=r+-1;if((r|0)!=1){u=i;return}Yi[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}l=(m|0)==6;if(n&l){n=VDc(40)|0;Bqa(n);f[n>>2]=57412;f[n+28>>2]=0;f[n+32>>2]=0;f[n+36>>2]=0;f[n+4>>2]=e;f[n+8>>2]=o;p[n+16>>3]=h;f[n+24>>2]=0;m=VDc(16)|0;r=m+4|0;f[r>>2]=1;f[m>>2]=57436;f[m+8>>2]=n;f[a>>2]=m;f[a+4>>2]=n;f[r>>2]=(f[r>>2]|0)+1;n=f[r>>2]|0;f[r>>2]=n+-1;if((n|0)!=1){u=i;return}Yi[f[(f[m>>2]|0)+8>>2]&2047](m);u=i;return}if(!(s&l)){f[j>>2]=c;f[j+4>>2]=d;F5(k,266544,j);Qka(-213,k,266525,1473)}k=VDc(40)|0;Bqa(k);f[k>>2]=57456;f[k+28>>2]=0;f[k+32>>2]=0;f[k+36>>2]=0;f[k+4>>2]=e;f[k+8>>2]=o;p[k+16>>3]=h;f[k+24>>2]=0;o=VDc(16)|0;e=o+4|0;f[e>>2]=1;f[o>>2]=57480;f[o+8>>2]=k;f[a>>2]=o;f[a+4>>2]=k;f[e>>2]=(f[e>>2]|0)+1;k=f[e>>2]|0;f[e>>2]=k+-1;if((k|0)!=1){u=i;return}Yi[f[(f[o>>2]|0)+8>>2]&2047](o);u=i;return}function Ela(a){a=a|0;YDc(a);return}function Fla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Gla(a){a=a|0;var b=0,c=0;f[a>>2]=57456;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Hla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57456;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Ila(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>3;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{f[j>>2]=0;f[j+4>>2]=0;v=tT(j,19)|0;t=266690;z=v+19|0;do{b[v>>0]=b[t>>0]|0;v=v+1|0;t=t+1|0}while((v|0)<(z|0));Qka(-215,j,518189,212)}}else{A=q;B=s;C=9}}else{t=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(v=s+(h<<3)|0,(t|0)!=(v|0)):0){f[n>>2]=t+(~((t+-8-v|0)>>>3)<<3);D=s}else D=s;else{cha(m,h-r|0);D=f[m>>2]|0}v=a+24|0;f[v>>2]=0;A=v;B=D;C=9}while(0);if((C|0)==9){XIc(B|0,0,h<<3|0)|0;C=f[A>>2]|0;D=f[a+4>>2]|0;a=D+-1|0;if((C|0)<(a|0)){if((h|0)>0){m=c;r=C;while(1){s=f[m>>2]|0;n=0;do{o=B+(n<<3)|0;p[o>>3]=+p[s+(n<<3)>>3]+ +p[o>>3];n=n+1|0}while((n|0)!=(h|0));n=r+1|0;s=m+4|0;if((n|0)<(a|0)){m=s;r=n}else{E=n;F=s;break}}}else{r=C+1|0;m=(a|0)>(r|0)?a:r;E=m;F=c+(m-C<<2)|0}f[A>>2]=E;w=F;x=D;y=B}else{w=c;x=D;y=B}}if(!g){u=i;return}B=1-x|0;x=h+-2|0;D=(h|0)<2;c=h&-2;F=d;d=w;w=g;while(1){w=w+-1|0;g=f[d>>2]|0;E=f[d+(B<<2)>>2]|0;if(l){if(D)G=0;else{A=0;do{C=y+(A<<3)|0;H=+p[C>>3]+ +p[g+(A<<3)>>3];m=A|1;r=y+(m<<3)|0;I=+p[r>>3]+ +p[g+(m<<3)>>3];p[F+(A<<3)>>3]=k*H;p[F+(m<<3)>>3]=k*I;J=I-+p[E+(m<<3)>>3];p[C>>3]=H-+p[E+(A<<3)>>3];p[r>>3]=J;A=A+2|0}while((A|0)<=(x|0));G=c}if((G|0)<(h|0)){A=G;do{r=y+(A<<3)|0;J=+p[r>>3]+ +p[g+(A<<3)>>3];p[F+(A<<3)>>3]=k*J;p[r>>3]=J-+p[E+(A<<3)>>3];A=A+1|0}while((A|0)!=(h|0))}}else{if(D)K=0;else{A=0;do{r=y+(A<<3)|0;J=+p[r>>3]+ +p[g+(A<<3)>>3];C=A|1;m=y+(C<<3)|0;H=+p[m>>3]+ +p[g+(C<<3)>>3];p[F+(A<<3)>>3]=J;p[F+(C<<3)>>3]=H;I=H-+p[E+(C<<3)>>3];p[r>>3]=J-+p[E+(A<<3)>>3];p[m>>3]=I;A=A+2|0}while((A|0)<=(x|0));K=c}if((K|0)<(h|0)){A=K;do{m=y+(A<<3)|0;I=+p[m>>3]+ +p[g+(A<<3)>>3];p[F+(A<<3)>>3]=I;p[m>>3]=I-+p[E+(A<<3)>>3];A=A+1|0}while((A|0)!=(h|0))}}if(!w)break;else{F=F+e|0;d=d+4|0}}u=i;return}function Jla(a){a=a|0;f[a+24>>2]=0;return}function Kla(a){a=a|0;YDc(a);return}function Lla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Mla(a){a=a|0;var b=0,c=0;f[a>>2]=57412;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function Nla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57412;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function Ola(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{f[j>>2]=0;f[j+4>>2]=0;v=tT(j,19)|0;t=266690;z=v+19|0;do{b[v>>0]=b[t>>0]|0;v=v+1|0;t=t+1|0}while((v|0)<(z|0));Qka(-215,j,518189,212)}}else{A=q;B=s;C=9}}else{t=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(v=s+(h<<2)|0,(t|0)!=(v|0)):0){f[n>>2]=t+(~((t+-4-v|0)>>>2)<<2);D=s}else D=s;else{lN(m,h-r|0);D=f[m>>2]|0}v=a+24|0;f[v>>2]=0;A=v;B=D;C=9}while(0);do if((C|0)==9){XIc(B|0,0,h<<2|0)|0;D=f[A>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((D|0)<(s|0)){if((h|0)>0)E=c;else{n=c;o=D;do{o=o+1|0;n=n+4|0}while((o|0)<(s|0));f[A>>2]=o;w=n;x=r;y=B;break}while(1){s=f[E>>2]|0;q=0;do{D=B+(q<<2)|0;f[D>>2]=(f[D>>2]|0)+(f[s+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(h|0));q=(f[A>>2]|0)+1|0;f[A>>2]=q;s=E+4|0;D=f[m>>2]|0;if((q|0)<(D+-1|0))E=s;else{w=s;x=D;y=B;break}}}else{w=c;x=r;y=B}}while(0);if(!g){u=i;return}B=a+4|0;a=h+-2|0;c=(h|0)<2;E=h&-2;A=d;d=w;w=g;g=x;while(1){x=w+-1|0;C=f[d>>2]|0;m=f[d+(1-g<<2)>>2]|0;if(l){if(c)F=0;else{n=0;do{o=y+(n<<2)|0;D=(f[C+(n<<2)>>2]|0)+(f[o>>2]|0)|0;s=n|1;q=y+(s<<2)|0;j=(f[C+(s<<2)>>2]|0)+(f[q>>2]|0)|0;p[A+(n<<3)>>3]=k*+(D|0);p[A+(s<<3)>>3]=k*+(j|0);v=j-(f[m+(s<<2)>>2]|0)|0;f[o>>2]=D-(f[m+(n<<2)>>2]|0);f[q>>2]=v;n=n+2|0}while((n|0)<=(a|0));F=E}if((F|0)<(h|0)){n=F;do{r=y+(n<<2)|0;v=(f[C+(n<<2)>>2]|0)+(f[r>>2]|0)|0;p[A+(n<<3)>>3]=k*+(v|0);f[r>>2]=v-(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(h|0))}}else{if(c)G=0;else{n=0;do{v=y+(n<<2)|0;r=(f[C+(n<<2)>>2]|0)+(f[v>>2]|0)|0;q=n|1;D=y+(q<<2)|0;o=(f[C+(q<<2)>>2]|0)+(f[D>>2]|0)|0;p[A+(n<<3)>>3]=+(r|0);p[A+(q<<3)>>3]=+(o|0);s=o-(f[m+(q<<2)>>2]|0)|0;f[v>>2]=r-(f[m+(n<<2)>>2]|0);f[D>>2]=s;n=n+2|0}while((n|0)<=(a|0));G=E}if((G|0)<(h|0)){n=G;do{s=y+(n<<2)|0;D=(f[C+(n<<2)>>2]|0)+(f[s>>2]|0)|0;p[A+(n<<3)>>3]=+(D|0);f[s>>2]=D-(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(h|0))}}if(!x)break;A=A+e|0;d=d+4|0;w=x;g=f[B>>2]|0}u=i;return}function Pla(a){a=a|0;f[a+24>>2]=0;return}function Qla(a){a=a|0;YDc(a);return}function Rla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sla(a){a=a|0;var b=0,c=0;f[a>>2]=57368;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Tla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57368;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Ula(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[m>>2]|0;s=q-r>>3;t=r;do if((s|0)==(h|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{f[j>>2]=0;f[j+4>>2]=0;w=tT(j,19)|0;v=266690;A=w+19|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(A|0));Qka(-215,j,518189,212)}}else{B=r;C=t;D=9}}else{v=q;if(s>>>0>=h>>>0)if(s>>>0>h>>>0?(w=t+(h<<3)|0,(v|0)!=(w|0)):0){f[o>>2]=v+(~((v+-8-w|0)>>>3)<<3);E=t}else E=t;else{cha(m,h-s|0);E=f[m>>2]|0}w=a+24|0;f[w>>2]=0;B=w;C=E;D=9}while(0);if((D|0)==9){XIc(C|0,0,h<<3|0)|0;D=f[B>>2]|0;E=f[a+4>>2]|0;a=E+-1|0;if((D|0)<(a|0)){if((h|0)>0){m=c;s=D;while(1){t=f[m>>2]|0;o=0;do{q=C+(o<<3)|0;p[q>>3]=+p[t+(o<<3)>>3]+ +p[q>>3];o=o+1|0}while((o|0)!=(h|0));o=s+1|0;t=m+4|0;if((o|0)<(a|0)){m=t;s=o}else{F=o;G=t;break}}}else{s=D+1|0;m=(a|0)>(s|0)?a:s;F=m;G=c+(m-D<<2)|0}f[B>>2]=F;x=G;y=E;z=C}else{x=c;y=E;z=C}}if(!g){u=i;return}C=1-y|0;y=h+-2|0;E=(h|0)<2;c=h&-2;G=d;d=x;x=g;while(1){x=x+-1|0;g=f[d>>2]|0;F=f[d+(C<<2)>>2]|0;if(l){if(E)H=0;else{B=0;do{D=z+(B<<3)|0;I=+p[D>>3]+ +p[g+(B<<3)>>3];m=B|1;s=z+(m<<3)|0;J=+p[s>>3]+ +p[g+(m<<3)>>3];n[G+(B<<2)>>2]=k*I;n[G+(m<<2)>>2]=k*J;K=J-+p[F+(m<<3)>>3];p[D>>3]=I-+p[F+(B<<3)>>3];p[s>>3]=K;B=B+2|0}while((B|0)<=(y|0));H=c}if((H|0)<(h|0)){B=H;do{s=z+(B<<3)|0;K=+p[s>>3]+ +p[g+(B<<3)>>3];n[G+(B<<2)>>2]=k*K;p[s>>3]=K-+p[F+(B<<3)>>3];B=B+1|0}while((B|0)!=(h|0))}}else{if(E)L=0;else{B=0;do{s=z+(B<<3)|0;K=+p[s>>3]+ +p[g+(B<<3)>>3];D=B|1;m=z+(D<<3)|0;I=+p[m>>3]+ +p[g+(D<<3)>>3];n[G+(B<<2)>>2]=K;n[G+(D<<2)>>2]=I;J=I-+p[F+(D<<3)>>3];p[s>>3]=K-+p[F+(B<<3)>>3];p[m>>3]=J;B=B+2|0}while((B|0)<=(y|0));L=c}if((L|0)<(h|0)){B=L;do{m=z+(B<<3)|0;J=+p[m>>3]+ +p[g+(B<<3)>>3];n[G+(B<<2)>>2]=J;p[m>>3]=J-+p[F+(B<<3)>>3];B=B+1|0}while((B|0)!=(h|0))}}if(!x)break;else{G=G+e|0;d=d+4|0}}u=i;return}function Vla(a){a=a|0;f[a+24>>2]=0;return}function Wla(a){a=a|0;YDc(a);return}function Xla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Yla(a){a=a|0;var b=0,c=0;f[a>>2]=57324;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function Zla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57324;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function _la(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[m>>2]|0;s=q-r>>2;t=r;do if((s|0)==(h|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{f[j>>2]=0;f[j+4>>2]=0;w=tT(j,19)|0;v=266690;A=w+19|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(A|0));Qka(-215,j,518189,1090)}}else{B=r;C=t;D=9}}else{v=q;if(s>>>0>=h>>>0)if(s>>>0>h>>>0?(w=t+(h<<2)|0,(v|0)!=(w|0)):0){f[o>>2]=v+(~((v+-4-w|0)>>>2)<<2);E=t}else E=t;else{lN(m,h-s|0);E=f[m>>2]|0}w=a+24|0;f[w>>2]=0;B=w;C=E;D=9}while(0);do if((D|0)==9){XIc(C|0,0,h<<2|0)|0;E=f[B>>2]|0;m=a+4|0;s=f[m>>2]|0;t=s+-1|0;if((E|0)<(t|0)){if((h|0)>0)F=c;else{o=c;q=E;do{q=q+1|0;o=o+4|0}while((q|0)<(t|0));f[B>>2]=q;x=o;y=s;z=C;break}while(1){t=f[F>>2]|0;r=0;do{E=C+(r<<2)|0;f[E>>2]=(f[E>>2]|0)+(f[t+(r<<2)>>2]|0);r=r+1|0}while((r|0)!=(h|0));r=(f[B>>2]|0)+1|0;f[B>>2]=r;t=F+4|0;E=f[m>>2]|0;if((r|0)<(E+-1|0))F=t;else{x=t;y=E;z=C;break}}}else{x=c;y=s;z=C}}while(0);C=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=x;F=y;B=C;while(1){D=f[c>>2]|0;m=f[c+(1-F<<2)>>2]|0;if(a){o=0;do{q=z+(o<<2)|0;E=(f[D+(o<<2)>>2]|0)+(f[q>>2]|0)|0;n[l+(o<<2)>>2]=k*+(E|0);f[q>>2]=E-(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0))}if(!B)break;l=l+e|0;c=c+4|0;F=f[g>>2]|0;B=B+-1|0}u=i;return}if(a){G=d;H=x;I=C;J=y}else{u=i;return}while(1){y=f[H>>2]|0;C=f[H+(1-J<<2)>>2]|0;x=0;do{d=z+(x<<2)|0;a=(f[y+(x<<2)>>2]|0)+(f[d>>2]|0)|0;n[G+(x<<2)>>2]=+(a|0);f[d>>2]=a-(f[C+(x<<2)>>2]|0);x=x+1|0}while((x|0)!=(h|0));if(!I)break;G=G+e|0;H=H+4|0;I=I+-1|0;J=f[g>>2]|0}u=i;return}function $la(a){a=a|0;f[a+24>>2]=0;return}function ama(a){a=a|0;YDc(a);return}function bma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function cma(a){a=a|0;var b=0,c=0;f[a>>2]=57280;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function dma(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57280;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function ema(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{f[j>>2]=0;f[j+4>>2]=0;v=tT(j,19)|0;t=266690;z=v+19|0;do{b[v>>0]=b[t>>0]|0;v=v+1|0;t=t+1|0}while((v|0)<(z|0));Qka(-215,j,518189,954)}}else{A=q;B=s;C=9}}else{t=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(v=s+(h<<2)|0,(t|0)!=(v|0)):0){f[n>>2]=t+(~((t+-4-v|0)>>>2)<<2);D=s}else D=s;else{lN(m,h-r|0);D=f[m>>2]|0}v=a+24|0;f[v>>2]=0;A=v;B=D;C=9}while(0);do if((C|0)==9){XIc(B|0,0,h<<2|0)|0;D=f[A>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((D|0)<(s|0)){if((h|0)>0)E=c;else{n=c;o=D;do{o=o+1|0;n=n+4|0}while((o|0)<(s|0));f[A>>2]=o;w=n;x=r;y=B;break}while(1){s=f[E>>2]|0;q=0;do{D=B+(q<<2)|0;f[D>>2]=(f[D>>2]|0)+(f[s+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(h|0));q=(f[A>>2]|0)+1|0;f[A>>2]=q;s=E+4|0;D=f[m>>2]|0;if((q|0)<(D+-1|0))E=s;else{w=s;x=D;y=B;break}}}else{w=c;x=r;y=B}}while(0);B=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=w;E=x;A=B;while(1){C=f[c>>2]|0;m=f[c+(1-E<<2)>>2]|0;if(a){n=0;do{o=y+(n<<2)|0;D=(f[C+(n<<2)>>2]|0)+(f[o>>2]|0)|0;s=nrc(k*+(D|0))|0;f[l+(n<<2)>>2]=s;f[o>>2]=D-(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(h|0))}if(!A)break;l=l+e|0;c=c+4|0;E=f[g>>2]|0;A=A+-1|0}u=i;return}if(a){F=d;G=w;H=B;I=x}else{u=i;return}while(1){x=f[G>>2]|0;B=f[G+(1-I<<2)>>2]|0;w=0;do{d=y+(w<<2)|0;a=(f[x+(w<<2)>>2]|0)+(f[d>>2]|0)|0;f[F+(w<<2)>>2]=a;f[d>>2]=a-(f[B+(w<<2)>>2]|0);w=w+1|0}while((w|0)!=(h|0));if(!H)break;F=F+e|0;G=G+4|0;H=H+-1|0;I=f[g>>2]|0}u=i;return}function fma(a){a=a|0;f[a+24>>2]=0;return}function gma(a){a=a|0;YDc(a);return}function hma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ima(a){a=a|0;var b=0,c=0;f[a>>2]=57236;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function jma(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57236;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function kma(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>3;t=r;do if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{f[k>>2]=0;f[k+4>>2]=0;w=tT(k,19)|0;v=266690;A=w+19|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(A|0));Qka(-215,k,518189,212)}}else{B=r;C=t;D=9}}else{v=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(w=t+(i<<3)|0,(v|0)!=(w|0)):0){f[o>>2]=v+(~((v+-8-w|0)>>>3)<<3);E=t}else E=t;else{cha(n,i-s|0);E=f[n>>2]|0}w=a+24|0;f[w>>2]=0;B=w;C=E;D=9}while(0);if((D|0)==9){XIc(C|0,0,i<<3|0)|0;D=f[B>>2]|0;E=f[a+4>>2]|0;a=E+-1|0;if((D|0)<(a|0)){if((i|0)>0){n=c;s=D;while(1){t=f[n>>2]|0;o=0;do{q=C+(o<<3)|0;p[q>>3]=+p[t+(o<<3)>>3]+ +p[q>>3];o=o+1|0}while((o|0)!=(i|0));o=s+1|0;t=n+4|0;if((o|0)<(a|0)){n=t;s=o}else{F=o;G=t;break}}}else{s=D+1|0;n=(a|0)>(s|0)?a:s;F=n;G=c+(n-D<<2)|0}f[B>>2]=F;x=G;y=E;z=C}else{x=c;y=E;z=C}}if(!h){u=j;return}C=1-y|0;y=i+-2|0;E=(i|0)<2;c=i&-2;G=e;e=x;x=h;while(1){x=x+-1|0;h=f[e>>2]|0;F=f[e+(C<<2)>>2]|0;if(m){if(E)H=0;else{B=0;do{D=z+(B<<3)|0;I=+p[D>>3]+ +p[h+(B<<3)>>3];n=B|1;s=z+(n<<3)|0;J=+p[s>>3]+ +p[h+(n<<3)>>3];a=nrc(l*I)|0;d[G+(B<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=nrc(l*J)|0;d[G+(n<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;K=J-+p[F+(n<<3)>>3];p[D>>3]=I-+p[F+(B<<3)>>3];p[s>>3]=K;B=B+2|0}while((B|0)<=(y|0));H=c}if((H|0)<(i|0)){B=H;do{s=z+(B<<3)|0;K=+p[s>>3]+ +p[h+(B<<3)>>3];D=nrc(l*K)|0;d[G+(B<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;p[s>>3]=K-+p[F+(B<<3)>>3];B=B+1|0}while((B|0)!=(i|0))}}else{if(E)L=0;else{B=0;do{s=z+(B<<3)|0;K=+p[s>>3]+ +p[h+(B<<3)>>3];D=B|1;n=z+(D<<3)|0;I=+p[n>>3]+ +p[h+(D<<3)>>3];a=nrc(K)|0;d[G+(B<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=nrc(I)|0;d[G+(D<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;J=I-+p[F+(D<<3)>>3];p[s>>3]=K-+p[F+(B<<3)>>3];p[n>>3]=J;B=B+2|0}while((B|0)<=(y|0));L=c}if((L|0)<(i|0)){B=L;do{n=z+(B<<3)|0;J=+p[n>>3]+ +p[h+(B<<3)>>3];s=nrc(J)|0;d[G+(B<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;p[n>>3]=J-+p[F+(B<<3)>>3];B=B+1|0}while((B|0)!=(i|0))}}if(!x)break;else{G=G+g|0;e=e+4|0}}u=j;return}function lma(a){a=a|0;f[a+24>>2]=0;return}function mma(a){a=a|0;YDc(a);return}function nma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function oma(a){a=a|0;var b=0,c=0;f[a>>2]=57192;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function pma(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57192;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function qma(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>2;t=r;do if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{f[k>>2]=0;f[k+4>>2]=0;w=tT(k,19)|0;v=266690;A=w+19|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(A|0));Qka(-215,k,518189,656)}}else{B=r;C=t;D=9}}else{v=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(w=t+(i<<2)|0,(v|0)!=(w|0)):0){f[o>>2]=v+(~((v+-4-w|0)>>>2)<<2);E=t}else E=t;else{lN(n,i-s|0);E=f[n>>2]|0}w=a+24|0;f[w>>2]=0;B=w;C=E;D=9}while(0);do if((D|0)==9){XIc(C|0,0,i<<2|0)|0;E=f[B>>2]|0;n=a+4|0;s=f[n>>2]|0;t=s+-1|0;if((E|0)<(t|0)){if((i|0)>0)F=c;else{o=c;q=E;do{q=q+1|0;o=o+4|0}while((q|0)<(t|0));f[B>>2]=q;x=o;y=s;z=C;break}while(1){t=f[F>>2]|0;r=0;do{E=C+(r<<2)|0;f[E>>2]=(f[E>>2]|0)+(f[t+(r<<2)>>2]|0);r=r+1|0}while((r|0)!=(i|0));r=(f[B>>2]|0)+1|0;f[B>>2]=r;t=F+4|0;E=f[n>>2]|0;if((r|0)<(E+-1|0))F=t;else{x=t;y=E;z=C;break}}}else{x=c;y=s;z=C}}while(0);C=h+-1|0;if(!h){u=j;return}h=a+4|0;a=(i|0)>0;if(m){m=e;c=x;F=y;B=C;while(1){D=f[c>>2]|0;n=f[c+(1-F<<2)>>2]|0;if(a){o=0;do{q=z+(o<<2)|0;E=(f[D+(o<<2)>>2]|0)+(f[q>>2]|0)|0;t=nrc(l*+(E|0))|0;d[m+(o<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;f[q>>2]=E-(f[n+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(i|0))}if(!B)break;m=m+g|0;c=c+4|0;F=f[h>>2]|0;B=B+-1|0}u=j;return}else{B=e;e=x;x=C;C=y;while(1){y=f[e>>2]|0;F=f[e+(1-C<<2)>>2]|0;if(a){c=0;do{m=z+(c<<2)|0;o=(f[y+(c<<2)>>2]|0)+(f[m>>2]|0)|0;d[B+(c<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;f[m>>2]=o-(f[F+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(i|0))}if(!x)break;B=B+g|0;e=e+4|0;x=x+-1|0;C=f[h>>2]|0}u=j;return}}function rma(a){a=a|0;f[a+24>>2]=0;return}function sma(a){a=a|0;YDc(a);return}function tma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uma(a){a=a|0;var b=0,c=0;f[a>>2]=57148;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function vma(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57148;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function wma(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>3;t=r;do if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{f[k>>2]=0;f[k+4>>2]=0;w=tT(k,19)|0;v=266690;A=w+19|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(A|0));Qka(-215,k,518189,212)}}else{B=r;C=t;D=9}}else{v=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(w=t+(i<<3)|0,(v|0)!=(w|0)):0){f[o>>2]=v+(~((v+-8-w|0)>>>3)<<3);E=t}else E=t;else{cha(n,i-s|0);E=f[n>>2]|0}w=a+24|0;f[w>>2]=0;B=w;C=E;D=9}while(0);if((D|0)==9){XIc(C|0,0,i<<3|0)|0;D=f[B>>2]|0;E=f[a+4>>2]|0;a=E+-1|0;if((D|0)<(a|0)){if((i|0)>0){n=c;s=D;while(1){t=f[n>>2]|0;o=0;do{q=C+(o<<3)|0;p[q>>3]=+p[t+(o<<3)>>3]+ +p[q>>3];o=o+1|0}while((o|0)!=(i|0));o=s+1|0;t=n+4|0;if((o|0)<(a|0)){n=t;s=o}else{F=o;G=t;break}}}else{s=D+1|0;n=(a|0)>(s|0)?a:s;F=n;G=c+(n-D<<2)|0}f[B>>2]=F;x=G;y=E;z=C}else{x=c;y=E;z=C}}if(!h){u=j;return}C=1-y|0;y=i+-2|0;E=(i|0)<2;c=i&-2;G=e;e=x;x=h;while(1){x=x+-1|0;h=f[e>>2]|0;F=f[e+(C<<2)>>2]|0;if(m){if(E)H=0;else{B=0;do{D=z+(B<<3)|0;I=+p[D>>3]+ +p[h+(B<<3)>>3];n=B|1;s=z+(n<<3)|0;J=+p[s>>3]+ +p[h+(n<<3)>>3];a=nrc(l*I)|0;d[G+(B<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=nrc(l*J)|0;d[G+(n<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;K=J-+p[F+(n<<3)>>3];p[D>>3]=I-+p[F+(B<<3)>>3];p[s>>3]=K;B=B+2|0}while((B|0)<=(y|0));H=c}if((H|0)<(i|0)){B=H;do{s=z+(B<<3)|0;K=+p[s>>3]+ +p[h+(B<<3)>>3];D=nrc(l*K)|0;d[G+(B<<1)>>1]=D>>>0<65536?D:(D|0)>0?65535:0;p[s>>3]=K-+p[F+(B<<3)>>3];B=B+1|0}while((B|0)!=(i|0))}}else{if(E)L=0;else{B=0;do{s=z+(B<<3)|0;K=+p[s>>3]+ +p[h+(B<<3)>>3];D=B|1;n=z+(D<<3)|0;I=+p[n>>3]+ +p[h+(D<<3)>>3];a=nrc(K)|0;d[G+(B<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=nrc(I)|0;d[G+(D<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;J=I-+p[F+(D<<3)>>3];p[s>>3]=K-+p[F+(B<<3)>>3];p[n>>3]=J;B=B+2|0}while((B|0)<=(y|0));L=c}if((L|0)<(i|0)){B=L;do{n=z+(B<<3)|0;J=+p[n>>3]+ +p[h+(B<<3)>>3];s=nrc(J)|0;d[G+(B<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;p[n>>3]=J-+p[F+(B<<3)>>3];B=B+1|0}while((B|0)!=(i|0))}}if(!x)break;else{G=G+g|0;e=e+4|0}}u=j;return}function xma(a){a=a|0;f[a+24>>2]=0;return}function yma(a){a=a|0;YDc(a);return}function zma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ama(a){a=a|0;var b=0,c=0;f[a>>2]=57104;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function Bma(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57104;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function Cma(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>2;t=r;do if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{f[k>>2]=0;f[k+4>>2]=0;w=tT(k,19)|0;v=266690;A=w+19|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(A|0));Qka(-215,k,518189,806)}}else{B=r;C=t;D=9}}else{v=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(w=t+(i<<2)|0,(v|0)!=(w|0)):0){f[o>>2]=v+(~((v+-4-w|0)>>>2)<<2);E=t}else E=t;else{lN(n,i-s|0);E=f[n>>2]|0}w=a+24|0;f[w>>2]=0;B=w;C=E;D=9}while(0);do if((D|0)==9){XIc(C|0,0,i<<2|0)|0;E=f[B>>2]|0;n=a+4|0;s=f[n>>2]|0;t=s+-1|0;if((E|0)<(t|0)){if((i|0)>0)F=c;else{o=c;q=E;do{q=q+1|0;o=o+4|0}while((q|0)<(t|0));f[B>>2]=q;x=o;y=s;z=C;break}while(1){t=f[F>>2]|0;r=0;do{E=C+(r<<2)|0;f[E>>2]=(f[E>>2]|0)+(f[t+(r<<2)>>2]|0);r=r+1|0}while((r|0)!=(i|0));r=(f[B>>2]|0)+1|0;f[B>>2]=r;t=F+4|0;E=f[n>>2]|0;if((r|0)<(E+-1|0))F=t;else{x=t;y=E;z=C;break}}}else{x=c;y=s;z=C}}while(0);C=h+-1|0;if(!h){u=j;return}h=a+4|0;a=(i|0)>0;if(m){m=e;c=x;F=y;B=C;while(1){D=f[c>>2]|0;n=f[c+(1-F<<2)>>2]|0;if(a){o=0;do{q=z+(o<<2)|0;E=(f[D+(o<<2)>>2]|0)+(f[q>>2]|0)|0;t=nrc(l*+(E|0))|0;d[m+(o<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;f[q>>2]=E-(f[n+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(i|0))}if(!B)break;m=m+g|0;c=c+4|0;F=f[h>>2]|0;B=B+-1|0}u=j;return}else{B=e;e=x;x=C;C=y;while(1){y=f[e>>2]|0;F=f[e+(1-C<<2)>>2]|0;if(a){c=0;do{m=z+(c<<2)|0;o=(f[y+(c<<2)>>2]|0)+(f[m>>2]|0)|0;d[B+(c<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;f[m>>2]=o-(f[F+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(i|0))}if(!x)break;B=B+g|0;e=e+4|0;x=x+-1|0;C=f[h>>2]|0}u=j;return}}function Dma(a){a=a|0;f[a+24>>2]=0;return}function Ema(a){a=a|0;YDc(a);return}function Fma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Gma(a){a=a|0;var b=0,c=0;f[a>>2]=57060;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);YDc(b);return}function Hma(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57060;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b);YDc(a);return}function Ima(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>3;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{f[j>>2]=0;f[j+4>>2]=0;v=tT(j,19)|0;t=266690;z=v+19|0;do{b[v>>0]=b[t>>0]|0;v=v+1|0;t=t+1|0}while((v|0)<(z|0));Qka(-215,j,518189,212)}}else{A=q;B=s;C=9}}else{t=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(v=s+(h<<3)|0,(t|0)!=(v|0)):0){f[n>>2]=t+(~((t+-8-v|0)>>>3)<<3);D=s}else D=s;else{cha(m,h-r|0);D=f[m>>2]|0}v=a+24|0;f[v>>2]=0;A=v;B=D;C=9}while(0);if((C|0)==9){XIc(B|0,0,h<<3|0)|0;C=f[A>>2]|0;D=f[a+4>>2]|0;m=D+-1|0;if((C|0)<(m|0)){if((h|0)>0){r=c;s=C;while(1){n=f[r>>2]|0;o=0;do{j=B+(o<<3)|0;p[j>>3]=+p[n+(o<<3)>>3]+ +p[j>>3];o=o+1|0}while((o|0)!=(h|0));o=s+1|0;n=r+4|0;if((o|0)<(m|0)){r=n;s=o}else{E=o;F=n;break}}}else{s=C+1|0;r=(m|0)>(s|0)?m:s;E=r;F=c+(r-C<<2)|0}f[A>>2]=E;w=F;x=D;y=B}else{w=c;x=D;y=B}}if(!g){u=i;return}B=a+4|0;a=h+-2|0;D=(h|0)<2;c=h&-2;F=d;d=w;w=g;g=x;while(1){x=w+-1|0;E=f[d>>2]|0;A=f[d+(1-g<<2)>>2]|0;if(l){if(D)G=0;else{C=0;do{r=y+(C<<3)|0;H=+p[r>>3]+ +p[E+(C<<3)>>3];s=C|1;m=y+(s<<3)|0;I=+p[m>>3]+ +p[E+(s<<3)>>3];n=nrc(k*H)|0;b[F+C>>0]=n>>>0<256?n:(n|0)>0?255:0;n=nrc(k*I)|0;b[F+s>>0]=n>>>0<256?n:(n|0)>0?255:0;J=I-+p[A+(s<<3)>>3];p[r>>3]=H-+p[A+(C<<3)>>3];p[m>>3]=J;C=C+2|0}while((C|0)<=(a|0));G=c}if((G|0)<(h|0)){C=G;do{m=y+(C<<3)|0;J=+p[m>>3]+ +p[E+(C<<3)>>3];r=nrc(k*J)|0;b[F+C>>0]=r>>>0<256?r:(r|0)>0?255:0;p[m>>3]=J-+p[A+(C<<3)>>3];C=C+1|0}while((C|0)!=(h|0))}}else{if(D)K=0;else{C=0;do{m=y+(C<<3)|0;J=+p[m>>3]+ +p[E+(C<<3)>>3];r=C|1;s=y+(r<<3)|0;H=+p[s>>3]+ +p[E+(r<<3)>>3];n=nrc(J)|0;b[F+C>>0]=n>>>0<256?n:(n|0)>0?255:0;n=nrc(H)|0;b[F+r>>0]=n>>>0<256?n:(n|0)>0?255:0;I=H-+p[A+(r<<3)>>3];p[m>>3]=J-+p[A+(C<<3)>>3];p[s>>3]=I;C=C+2|0}while((C|0)<=(a|0));K=c}if((K|0)<(h|0)){C=K;do{s=y+(C<<3)|0;I=+p[s>>3]+ +p[E+(C<<3)>>3];m=nrc(I)|0;b[F+C>>0]=m>>>0<256?m:(m|0)>0?255:0;p[s>>3]=I-+p[A+(C<<3)>>3];C=C+1|0}while((C|0)!=(h|0))}}if(!x)break;F=F+e|0;d=d+4|0;w=x;g=f[B>>2]|0}u=i;return}function Jma(a){a=a|0;f[a+24>>2]=0;return}function Kma(a){a=a|0;YDc(a);return}function Lma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Mma(a){a=a|0;var b=0,c=0;f[a>>2]=57016;b=f[a+36>>2]|0;if(!b)return;c=a+40|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-2-b|0)>>>1)<<1);YDc(b);return}function Nma(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=57016;b=f[a+36>>2]|0;if(!b){YDc(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-2-b|0)>>>1)<<1);YDc(b);YDc(a);return}function Oma(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=u;u=u+16|0;l=k;m=f[a+32>>2]|0;n=f[a+28>>2]|0;o=+p[a+16>>3]!=1.0;q=a+36|0;r=a+40|0;s=f[r>>2]|0;t=f[q>>2]|0;v=s-t>>1;w=t;do if((v|0)==(i|0)){t=a+24|0;x=f[t>>2]|0;if(x){y=f[a+4>>2]|0;if((x|0)==(y+-1|0)){z=c+(x<<2)|0;A=y;B=w;break}else{f[l>>2]=0;f[l+4>>2]=0;y=tT(l,19)|0;x=266690;C=y+19|0;do{b[y>>0]=b[x>>0]|0;y=y+1|0;x=x+1|0}while((y|0)<(C|0));Qka(-215,l,518189,492)}}else{D=t;E=w;F=9}}else{x=s;if(v>>>0>=i>>>0)if(v>>>0>i>>>0?(y=w+(i<<1)|0,(x|0)!=(y|0)):0){f[r>>2]=x+(~((x+-2-y|0)>>>1)<<1);G=w}else G=w;else{Qma(q,i-v|0);G=f[q>>2]|0}y=a+24|0;f[y>>2]=0;D=y;E=G;F=9}while(0);if((F|0)==9){XIc(E|0,0,i<<1|0)|0;F=f[D>>2]|0;G=f[a+4>>2]|0;q=G+-1|0;if((F|0)<(q|0)){if((i|0)>0){v=c;w=F;while(1){r=f[v>>2]|0;s=0;do{l=E+(s<<1)|0;d[l>>1]=(j[l>>1]|0)+(j[r+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0));s=w+1|0;r=v+4|0;if((s|0)<(q|0)){v=r;w=s}else{H=s;I=r;break}}}else{w=F+1|0;v=(q|0)>(w|0)?q:w;H=v;I=c+(v-F<<2)|0}f[D>>2]=H;z=I;A=G;B=E}else{z=c;A=G;B=E}}E=h+-1|0;if(!h){u=k;return}h=a+4|0;a=(i|0)>0;if(o){o=e;G=z;c=A;I=E;while(1){H=f[G>>2]|0;D=f[G+(1-c<<2)>>2]|0;if(a){F=0;do{v=B+(F<<1)|0;w=(j[H+(F<<1)>>1]|0)+(j[v>>1]|0)|0;q=(Y(w+n|0,m)|0)>>>23&255;b[o+F>>0]=q;d[v>>1]=w-(j[D+(F<<1)>>1]|0);F=F+1|0}while((F|0)!=(i|0))}if(!I)break;o=o+g|0;G=G+4|0;c=f[h>>2]|0;I=I+-1|0}u=k;return}else{I=e;e=z;z=A;A=E;while(1){E=f[e>>2]|0;c=f[e+(1-z<<2)>>2]|0;if(a){G=0;do{o=B+(G<<1)|0;m=(j[E+(G<<1)>>1]|0)+(j[o>>1]|0)|0;b[I+G>>0]=m>>>0<256?m:m|0?255:0;d[o>>1]=m-(j[c+(G<<1)>>1]|0);G=G+1|0}while((G|0)!=(i|0))}if(!A)break;I=I+g|0;e=e+4|0;z=f[h>>2]|0;A=A+-1|0}u=k;return}}function Pma(a){a=a|0;f[a+24>>2]=0;return}function Qma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>1>>>0>=b>>>0){XIc(g|0,0,b<<1|0)|0;f[e>>2]=g+(b<<1);return}h=f[a>>2]|0;i=g-h|0;g=i>>1;j=g+b|0;if((j|0)<0)mCc(a);k=d-h|0;d=k>>1>>>0<1073741823?(k>>>0<j>>>0?j:k):2147483647;do if(d)if((d|0)<0){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{l=VDc(d<<1)|0;break}else l=0;while(0);k=l+(g<<1)|0;XIc(k|0,0,b<<1|0)|0;j=k+(0-g<<1)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=k+(b<<1);f[c>>2]=l+(d<<1);if(!h)return;YDc(h);return}function Rma(a){a=a|0;YDc(a);return}function Sma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tma(a){a=a|0;var b=0,c=0;f[a>>2]=56972;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);YDc(b);return}function Uma(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56972;b=f[a+28>>2]|0;if(!b){YDc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);YDc(a);return}function Vma(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{f[j>>2]=0;f[j+4>>2]=0;v=tT(j,19)|0;t=266690;z=v+19|0;do{b[v>>0]=b[t>>0]|0;v=v+1|0;t=t+1|0}while((v|0)<(z|0));Qka(-215,j,518189,320)}}else{A=q;B=s;C=9}}else{t=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(v=s+(h<<2)|0,(t|0)!=(v|0)):0){f[n>>2]=t+(~((t+-4-v|0)>>>2)<<2);D=s}else D=s;else{lN(m,h-r|0);D=f[m>>2]|0}v=a+24|0;f[v>>2]=0;A=v;B=D;C=9}while(0);do if((C|0)==9){XIc(B|0,0,h<<2|0)|0;D=f[A>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((D|0)<(s|0)){if((h|0)>0)E=c;else{n=c;o=D;do{o=o+1|0;n=n+4|0}while((o|0)<(s|0));f[A>>2]=o;w=n;x=r;y=B;break}while(1){s=f[E>>2]|0;q=0;do{D=B+(q<<2)|0;f[D>>2]=(f[D>>2]|0)+(f[s+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(h|0));q=(f[A>>2]|0)+1|0;f[A>>2]=q;s=E+4|0;D=f[m>>2]|0;if((q|0)<(D+-1|0))E=s;else{w=s;x=D;y=B;break}}}else{w=c;x=r;y=B}}while(0);B=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=w;E=x;A=B;while(1){C=f[c>>2]|0;m=f[c+(1-E<<2)>>2]|0;if(a){n=0;do{o=y+(n<<2)|0;D=(f[C+(n<<2)>>2]|0)+(f[o>>2]|0)|0;s=nrc(k*+(D|0))|0;b[l+n>>0]=s>>>0<256?s:(s|0)>0?255:0;f[o>>2]=D-(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(h|0))}if(!A)break;l=l+e|0;c=c+4|0;E=f[g>>2]|0;A=A+-1|0}u=i;return}else{A=d;d=w;w=B;B=x;while(1){x=f[d>>2]|0;E=f[d+(1-B<<2)>>2]|0;if(a){c=0;do{l=y+(c<<2)|0;n=(f[x+(c<<2)>>2]|0)+(f[l>>2]|0)|0;b[A+c>>0]=n>>>0<256?n:(n|0)>0?255:0;f[l>>2]=n-(f[E+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(h|0))}if(!w)break;A=A+e|0;d=d+4|0;w=w+-1|0;B=f[g>>2]|0}u=i;return}}function Wma(a){a=a|0;f[a+24>>2]=0;return}function Xma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0;i=u;u=u+64|0;j=i;k=i+48|0;l=i+40|0;m=i+32|0;n=b&7;o=b&4088;p=(n|0)==0;if(p)if((c&7|0)==0?(Y(f[d+4>>2]|0,f[d>>2]|0)|0)<257:0)q=2;else r=5;else if(n>>>0<5)r=5;else q=6;do if((r|0)==5){if(g?(s=Y(f[d+4>>2]|0,f[d>>2]|0)|0,(s|0)>((p?8388608:(n|0)==2?32768:65536)|0)):0){q=6;break}q=4}while(0);n=q|o;Pka(k,b,n,f[d>>2]|0,f[e>>2]|0);o=f[d+4>>2]|0;if(g)t=1.0/+(Y(f[d>>2]|0,o)|0);else t=1.0;Dla(l,n,c,o,f[e+4>>2]|0,t);f[m>>2]=0;f[m+4>>2]=0;e=VDc(200)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;Dqa(e,m,k,l,b,c,n,h,-1,j);j=VDc(16)|0;f[j+4>>2]=1;f[j>>2]=56396;f[j+8>>2]=e;f[a>>2]=j;f[a+4>>2]=e;e=f[m>>2]|0;if(e|0?(m=e+4|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)Yi[f[(f[e>>2]|0)+8>>2]&2047](e);e=f[l>>2]|0;if(e|0?(l=e+4|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)Yi[f[(f[e>>2]|0)+8>>2]&2047](e);e=f[k>>2]|0;if(!e){u=i;return}k=e+4|0;a=f[k>>2]|0;f[k>>2]=a+-1;if((a|0)!=1){u=i;return}Yi[f[(f[e>>2]|0)+8>>2]&2047](e);u=i;return}function Yma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+160|0;j=i+104|0;k=i+40|0;l=i+48|0;m=i+32|0;n=i+24|0;o=i+16|0;p=i+8|0;q=i;do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[j>>2]=f[r>>2];s=j+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=j+8|0;f[v>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];f[j+16>>2]=f[r+16>>2];f[j+20>>2]=f[r+20>>2];f[j+24>>2]=f[r+24>>2];f[j+28>>2]=f[r+28>>2];f[j+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[j+36>>2]=w;x=j+40|0;f[x>>2]=v;v=j+48|0;y=j+44|0;f[y>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=x;A=j;break}else{f[s>>2]=0;ZS(j,r);z=x;A=j;break}}else{a$(j,a,-1);z=j+40|0;A=j}while(0);a=f[A>>2]|0;x=f[z>>2]|0;r=f[x>>2]|0;f[k>>2]=f[x+4>>2];f[k+4>>2]=r;v$(b,k,((c|0)<0?a:c)&7|a&4088,-1,0,0);do if((d$(b)|0)==65536){a=f[b+4>>2]|0;f[l>>2]=f[a>>2];c=l+4|0;k=a+4|0;f[c>>2]=f[k>>2];r=l+8|0;f[r>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[l+36>>2]=x;f[l+40>>2]=r;r=l+48|0;s=l+44|0;f[s>>2]=r;f[r>>2]=0;f[l+52>>2]=0;if(x|0){r=x+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+44>>2]|0;r=f[s>>2]|0;f[r>>2]=f[k>>2];f[r+4>>2]=f[k+4>>2];break}else{f[c>>2]=0;ZS(l,a);break}}else a$(l,b,-1);while(0);b=(h&16|0)==0;if(!(b|g^1)){a=f[j+8>>2]|0;if((a|0)==1)f[d+4>>2]=1;c=f[j+12>>2]|0;if((c|0)==1){f[d>>2]=1;B=1;C=a}else{B=c;C=a}}else{B=f[j+12>>2]|0;C=f[j+8>>2]|0}f[m>>2]=0;f[m+4>>2]=0;f[n>>2]=B;f[n+4>>2]=C;if(b)jT(j,n,m);b=j+16|0;C=j+44|0;B=l+16|0;a=l+44|0;c=f[A>>2]&4095;A=f[l>>2]&4095;f[p>>2]=f[d>>2];f[p+4>>2]=f[d+4>>2];f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];Xma(o,c,A,p,q,g,h&-17);h=f[o+4>>2]|0;gi[f[(f[h>>2]|0)+20>>2]&255](h,j,l,n,m);m=f[o>>2]|0;if(m|0?(o=m+4|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)Yi[f[(f[m>>2]|0)+8>>2]&2047](m);m=l+36|0;n=f[m>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)_S(l);f[m>>2]=0;m=l+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[m>>2]|0)>0){B=f[l+40>>2]|0;n=0;do{f[B+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[a>>2]|0;if((m|0)!=(l+48|0))g0(m);m=j+36|0;l=f[m>>2]|0;if(l|0?(a=l+12|0,l=f[a>>2]|0,f[a>>2]=l+-1,(l|0)==1):0)_S(j);f[m>>2]=0;m=j+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[m>>2]|0)>0){b=f[z>>2]|0;z=0;do{f[b+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[m>>2]|0))}m=f[C>>2]|0;if((m|0)==(j+48|0)){u=i;return}g0(m);u=i;return}function Zma(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];Yma(a,b,-1,h,i,1,e);u=g;return}function _ma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;i=u;u=u+192|0;j=i+32|0;k=i;l=i+184|0;m=i+120|0;n=i+176|0;o=i+64|0;p=i+56|0;q=i+48|0;r=i+40|0;s=c$(a,-1)|0;t=s&7;v=s&4088;b$(l,a,-1);w=(c|0)<0?(t>>>0<5?5:6):c;if(!((h|0)==0|g^1)){if((f[l+4>>2]|0)==1)f[d+4>>2]=1;if((f[l>>2]|0)==1)f[d>>2]=1}c=(t|0)==0;t=(c?4:6)|v;x=w&7|v;do if((d$(a)|0)==65536){v=f[a+4>>2]|0;f[m>>2]=f[v>>2];w=m+4|0;y=v+4|0;f[w>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[v+8>>2];f[m+12>>2]=f[v+12>>2];f[m+16>>2]=f[v+16>>2];f[m+20>>2]=f[v+20>>2];f[m+24>>2]=f[v+24>>2];f[m+28>>2]=f[v+28>>2];f[m+32>>2]=f[v+32>>2];A=f[v+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[v+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[w>>2]=0;ZS(m,v);break}}else a$(m,a,-1);while(0);f[n>>2]=f[l>>2];f[n+4>>2]=f[l+4>>2];v$(b,n,x,-1,0,0);do if((d$(b)|0)==65536){n=f[b+4>>2]|0;f[o>>2]=f[n>>2];l=o+4|0;a=n+4|0;f[l>>2]=f[a>>2];v=o+8|0;f[v>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];f[o+16>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];w=f[n+36>>2]|0;f[o+36>>2]=w;f[o+40>>2]=v;v=o+48|0;y=o+44|0;f[y>>2]=v;f[v>>2]=0;f[o+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[a>>2]|0)<3){a=f[n+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[a>>2];f[v+4>>2]=f[a+4>>2];break}else{f[l>>2]=0;ZS(o,n);break}}else a$(o,b,-1);while(0);b=f[d>>2]|0;n=f[e>>2]|0;l=(n|0)<0?(b|0)/2|0:n;a:do if(c){n=VDc(12)|0;Aqa(n);f[n>>2]=57500;f[n+4>>2]=b;f[n+8>>2]=l;a=VDc(16)|0;v=a+4|0;f[v>>2]=1;f[a>>2]=57520;f[a+8>>2]=n;f[p>>2]=a;f[p+4>>2]=n;f[v>>2]=(f[v>>2]|0)+1;n=f[v>>2]|0;f[v>>2]=n+-1;if((n|0)==1)Yi[f[(f[a>>2]|0)+8>>2]&2047](a)}else switch(s&7){case 2:{a=VDc(12)|0;Aqa(a);f[a>>2]=57540;f[a+4>>2]=b;f[a+8>>2]=l;n=VDc(16)|0;v=n+4|0;f[v>>2]=1;f[n>>2]=57560;f[n+8>>2]=a;f[p>>2]=n;f[p+4>>2]=a;f[v>>2]=(f[v>>2]|0)+1;a=f[v>>2]|0;f[v>>2]=a+-1;if((a|0)!=1)break a;Yi[f[(f[n>>2]|0)+8>>2]&2047](n);break a;break}case 3:{n=VDc(12)|0;Aqa(n);f[n>>2]=57580;f[n+4>>2]=b;f[n+8>>2]=l;a=VDc(16)|0;v=a+4|0;f[v>>2]=1;f[a>>2]=57600;f[a+8>>2]=n;f[p>>2]=a;f[p+4>>2]=n;f[v>>2]=(f[v>>2]|0)+1;n=f[v>>2]|0;f[v>>2]=n+-1;if((n|0)!=1)break a;Yi[f[(f[a>>2]|0)+8>>2]&2047](a);break a;break}case 5:{a=VDc(12)|0;Aqa(a);f[a>>2]=57620;f[a+4>>2]=b;f[a+8>>2]=l;n=VDc(16)|0;v=n+4|0;f[v>>2]=1;f[n>>2]=57640;f[n+8>>2]=a;f[p>>2]=n;f[p+4>>2]=a;f[v>>2]=(f[v>>2]|0)+1;a=f[v>>2]|0;f[v>>2]=a+-1;if((a|0)!=1)break a;Yi[f[(f[n>>2]|0)+8>>2]&2047](n);break a;break}case 6:{n=VDc(12)|0;Aqa(n);f[n>>2]=57660;f[n+4>>2]=b;f[n+8>>2]=l;a=VDc(16)|0;v=a+4|0;f[v>>2]=1;f[a>>2]=57680;f[a+8>>2]=n;f[p>>2]=a;f[p+4>>2]=n;f[v>>2]=(f[v>>2]|0)+1;n=f[v>>2]|0;f[v>>2]=n+-1;if((n|0)!=1)break a;Yi[f[(f[a>>2]|0)+8>>2]&2047](a);break a;break}default:{f[j>>2]=s;f[j+4>>2]=t;F5(k,274877,j);Qka(-213,k,267742,1753)}}while(0);j=f[d+4>>2]|0;if(g)C=1.0/+(Y(f[d>>2]|0,j)|0);else C=1.0;Dla(q,t,x,j,f[e+4>>2]|0,C);f[r>>2]=0;f[r+4>>2]=0;e=VDc(200)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Dqa(e,r,p,q,s,x,t,h,-1,k);h=VDc(16)|0;t=h+4|0;f[t>>2]=1;f[h>>2]=56396;f[h+8>>2]=e;x=f[r>>2]|0;if(x|0?(s=x+4|0,j=f[s>>2]|0,f[s>>2]=j+-1,(j|0)==1):0)Yi[f[(f[x>>2]|0)+8>>2]&2047](x);f[k>>2]=0;f[k+4>>2]=0;x=f[m+8>>2]|0;f[r>>2]=f[m+12>>2];f[r+4>>2]=x;jT(m,r,k);gi[f[(f[e>>2]|0)+20>>2]&255](e,m,o,r,k);k=f[t>>2]|0;f[t>>2]=k+-1;if((k|0)==1)Yi[f[(f[h>>2]|0)+8>>2]&2047](h);h=f[q>>2]|0;if(h|0?(q=h+4|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)Yi[f[(f[h>>2]|0)+8>>2]&2047](h);h=f[p>>2]|0;if(h|0?(p=h+4|0,k=f[p>>2]|0,f[p>>2]=k+-1,(k|0)==1):0)Yi[f[(f[h>>2]|0)+8>>2]&2047](h);h=o+36|0;k=f[h>>2]|0;if(k|0?(p=k+12|0,k=f[p>>2]|0,f[p>>2]=k+-1,(k|0)==1):0)_S(o);f[h>>2]=0;h=o+16|0;k=o+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[o+40>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[k>>2]|0))}k=f[o+44>>2]|0;if((k|0)!=(o+48|0))g0(k);k=m+36|0;o=f[k>>2]|0;if(o|0?(p=o+12|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)_S(m);f[k>>2]=0;k=m+16|0;o=m+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[o>>2]|0)>0){k=f[m+40>>2]|0;p=0;do{f[k+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)==(m+48|0)){u=i;return}g0(o);u=i;return}function $ma(a){a=a|0;YDc(a);return}function ana(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bna(a){a=a|0;YDc(a);return}function cna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,q=0,r=0,s=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;j=b;while(1){k=0.0;l=0;do{m=+p[j+(l<<3)>>3];k=k+m*m;l=l+e|0}while((l|0)<(g|0));p[h>>3]=k;if(d){l=0;m=k;do{n=+p[j+(l<<3)>>3];o=+p[j+(l+g<<3)>>3];m=m+(o*o-n*n);l=l+e|0;p[h+(l<<3)>>3]=m}while((l|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;j=j+8|0}}return}if(d){q=c;r=0;s=b}else{XIc(c|0,0,e<<3|0)|0;return}while(1){p[q>>3]=0.0;c=0;m=0.0;do{k=+p[s+(c<<3)>>3];n=+p[s+(c+g<<3)>>3];m=m+(n*n-k*k);c=c+e|0;p[q+(c<<3)>>3]=m}while((c|0)<(a|0));r=r+1|0;if((r|0)==(e|0))break;else{q=q+8|0;s=s+8|0}}return}function dna(a){a=a|0;YDc(a);return}function ena(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fna(a){a=a|0;YDc(a);return}function gna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0.0,l=0,m=0.0,o=0.0,q=0.0,r=0,s=0,t=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;j=b;while(1){k=0.0;l=0;do{m=+n[j+(l<<2)>>2];k=k+m*m;l=l+e|0}while((l|0)<(g|0));p[h>>3]=k;if(d){l=0;m=k;do{o=+n[j+(l<<2)>>2];q=+n[j+(l+g<<2)>>2];m=m+(q*q-o*o);l=l+e|0;p[h+(l<<3)>>3]=m}while((l|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;j=j+4|0}}return}if(d){r=c;s=0;t=b}else{XIc(c|0,0,e<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;m=0.0;do{k=+n[t+(c<<2)>>2];o=+n[t+(c+g<<2)>>2];m=m+(o*o-k*k);c=c+e|0;p[r+(c<<3)>>3]=m}while((c|0)<(a|0));s=s+1|0;if((s|0)==(e|0))break;else{r=r+8|0;t=t+4|0}}return}function hna(a){a=a|0;YDc(a);return}function ina(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jna(a){a=a|0;YDc(a);return}function kna(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(e+-1|0,g)|0;if((g|0)<=0)return;e=(a|0)>0;if((h|0)>0){i=c;j=0;k=b;while(1){l=0.0;m=0;do{n=+(d[k+(m<<1)>>1]|0);l=l+n*n;m=m+g|0}while((m|0)<(h|0));p[i>>3]=l;if(e){m=0;n=l;do{o=+(d[k+(m<<1)>>1]|0);q=+(d[k+(m+h<<1)>>1]|0);n=n+(q*q-o*o);m=m+g|0;p[i+(m<<3)>>3]=n}while((m|0)<(a|0))}j=j+1|0;if((j|0)==(g|0))break;else{i=i+8|0;k=k+2|0}}return}if(e){r=c;s=0;t=b}else{XIc(c|0,0,g<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;n=0.0;do{l=+(d[t+(c<<1)>>1]|0);o=+(d[t+(c+h<<1)>>1]|0);n=n+(o*o-l*l);c=c+g|0;p[r+(c<<3)>>3]=n}while((c|0)<(a|0));s=s+1|0;if((s|0)==(g|0))break;else{r=r+8|0;t=t+2|0}}return}function lna(a){a=a|0;YDc(a);return}function mna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nna(a){a=a|0;YDc(a);return}function ona(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;k=b;while(1){l=0.0;m=0;do{n=+(j[k+(m<<1)>>1]|0);l=l+n*n;m=m+e|0}while((m|0)<(g|0));p[h>>3]=l;if(d){m=0;n=l;do{o=+(j[k+(m<<1)>>1]|0);q=+(j[k+(m+g<<1)>>1]|0);n=n+(q*q-o*o);m=m+e|0;p[h+(m<<3)>>3]=n}while((m|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;k=k+2|0}}return}if(d){r=c;s=0;t=b}else{XIc(c|0,0,e<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;n=0.0;do{l=+(j[t+(c<<1)>>1]|0);o=+(j[t+(c+g<<1)>>1]|0);n=n+(o*o-l*l);c=c+e|0;p[r+(c<<3)>>3]=n}while((c|0)<(a|0));s=s+1|0;if((s|0)==(e|0))break;else{r=r+8|0;t=t+2|0}}return}function pna(a){a=a|0;YDc(a);return}function qna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rna(a){a=a|0;YDc(a);return}function sna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){i=c;j=0;k=b;while(1){l=0;m=0;do{n=h[k+m>>0]|0;l=(Y(n,n)|0)+l|0;m=m+e|0}while((m|0)<(g|0));f[i>>2]=l;if(d){m=0;n=l;do{o=h[k+m>>0]|0;p=h[k+(m+g)>>0]|0;n=(Y(p,p)|0)-(Y(o,o)|0)+n|0;m=m+e|0;f[i+(m<<2)>>2]=n}while((m|0)<(a|0))}j=j+1|0;if((j|0)==(e|0))break;else{i=i+4|0;k=k+1|0}}return}if(d){q=c;r=0;s=b}else{XIc(c|0,0,e<<2|0)|0;return}while(1){f[q>>2]=0;c=0;b=0;do{d=h[s+c>>0]|0;k=h[s+(c+g)>>0]|0;b=(Y(k,k)|0)-(Y(d,d)|0)+b|0;c=c+e|0;f[q+(c<<2)>>2]=b}while((c|0)<(a|0));r=r+1|0;if((r|0)==(e|0))break;else{q=q+4|0;s=s+1|0}}return}function tna(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+128|0;h=g+72|0;i=g+64|0;j=g+8|0;k=g;if(!e){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,29)|0;m=268221;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));una(-215,h,268251,883)}do if((d$(a)|0)==65536){m=f[a+4>>2]|0;f[h>>2]=f[m>>2];l=h+4|0;n=m+4|0;f[l>>2]=f[n>>2];o=h+8|0;f[o>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];p=f[m+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=o;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[m+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[l>>2]=0;ZS(h,m);break}}else a$(h,a,-1);while(0);a=f[d>>2]|0;if((a|0)>=1?(m=f[d+4>>2]|0,(m|0)>=1):0){r=a;s=m}else{r=((f[h+12>>2]|0)+1|0)/2|0;s=((f[h+8>>2]|0)+1|0)/2|0}f[i>>2]=r;f[i+4>>2]=s;v$(c,i,f[h>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){i=f[c+4>>2]|0;f[j>>2]=f[i>>2];s=j+4|0;r=i+4|0;f[s>>2]=f[r>>2];m=j+8|0;f[m>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];a=j+16|0;f[a>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];d=f[i+36>>2]|0;f[j+36>>2]=d;f[j+40>>2]=m;m=j+48|0;l=j+44|0;f[l>>2]=m;f[m>>2]=0;f[j+52>>2]=0;if(d|0){m=d+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[r>>2]|0)<3){r=f[i+44>>2]|0;m=f[l>>2]|0;f[m>>2]=f[r>>2];f[m+4>>2]=f[r+4>>2];t=a;break}else{f[s>>2]=0;ZS(j,i);t=a;break}}else{a$(j,c,-1);t=j+16|0}while(0);c=h+16|0;switch(f[h>>2]&7){case 0:{v=349;break}case 3:{v=350;break}case 2:{v=351;break}case 5:{v=352;break}case 6:{v=353;break}default:{f[k>>2]=0;f[k+4>>2]=0;una(-210,k,268251,924)}}Ti[v&511](h,j,e);e=j+36|0;v=f[e>>2]|0;if(v|0?(k=v+12|0,v=f[k>>2]|0,f[k>>2]=v+-1,(v|0)==1):0)_S(j);f[e>>2]=0;e=j+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[e>>2]|0)>0){t=f[j+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[e>>2]|0))}e=f[j+44>>2]|0;if((e|0)!=(j+48|0))g0(e);e=h+36|0;j=f[e>>2]|0;if(j|0?(v=j+12|0,j=f[v>>2]|0,f[v>>2]=j+-1,(j|0)==1):0)_S(h);f[e>>2]=0;e=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[e>>2]|0)>0){c=f[h+40>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}g0(e);u=g;return}function una(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,268398,d);return}function vna(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+30816|0;h=g+29744|0;i=g+15408|0;j=g+1072|0;k=g+8|0;l=g;m=a+16|0;if(!(f[m>>2]|0)){f[h>>2]=0;n=h+4|0;f[n>>2]=0;o=tT(h,13)|0;p=o;q=371005;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));una(-215,h,268259,399)}s=f[a+4>>2]|0;if((s|0)<3)t=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{v=f[a+40>>2]|0;w=0;x=1;while(1){y=Y(f[v+(w<<2)>>2]|0,x)|0;w=w+1|0;if((w|0)==(s|0)){t=y;break}else x=y}}if((s|0)==0|(t|0)==0){f[h>>2]=0;n=h+4|0;f[n>>2]=0;o=tT(h,13)|0;p=o;q=371005;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));una(-215,h,268259,399)}q=f[a+40>>2]|0;p=f[q+4>>2]|0;r=f[q>>2]|0;q=f[c+40>>2]|0;o=f[q+4>>2]|0;n=f[q>>2]|0;q=(f[a>>2]|0)>>>3;t=(q&511)+1|0;s=Y(t,o)|0;x=s+15&-16;w=(x*5|0)+16|0;v=h+8|0;f[h>>2]=v;y=h+4|0;f[y>>2]=w;if(w>>>0>264){z=XDc(w>>>0>1073741823?-1:w<<2)|0;f[h>>2]=z;A=z}else A=v;z=A+15&-16;A=k+8|0;f[k>>2]=A;w=k+4|0;f[w>>2]=s;if(s>>>0>264){B=XDc(s>>>0>1073741823?-1:s<<2)|0;f[k>>2]=B;C=B}else C=A;if(!((p|0)>0&(r|0)>0)){f[l>>2]=0;D=l+4|0;f[D>>2]=0;E=tT(l,129)|0;dJc(E|0,268268,129)|0;una(-215,l,268259,414)}B=(o<<1)-p|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[l>>2]=0;D=l+4|0;f[D>>2]=0;E=tT(l,129)|0;dJc(E|0,268268,129)|0;una(-215,l,268259,414)}B=(n<<1)-r|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[l>>2]=0;D=l+4|0;f[D>>2]=0;E=tT(l,129)|0;dJc(E|0,268268,129)|0;una(-215,l,268259,414)}l=((p+-3|0)/2|0)+1|0;E=(o|0)<(l|0)?o:l;l=(E<<1)+-2|0;o=0;do{D=Y(p_(o+-2|0,p,e)|0,t)|0;B=Y(p_(l+o|0,p,e)|0,t)|0;F=Y(o,t)|0;G=0;do{H=G+F|0;f[i+(H<<2)>>2]=G+D;f[j+(H<<2)>>2]=G+B;G=G+1|0}while((G|0)!=(t|0));o=o+1|0}while((o|0)<7);o=Y(t,E)|0;E=(s|0)>0;if(E){p=t<<1;l=0;do{G=(Y(p,(l|0)/(t|0)|0)|0)+((l|0)%(t|0)|0)|0;f[C+(l<<2)>>2]=G;l=l+1|0}while((l|0)!=(s|0))}if((n|0)>0){l=c+16|0;p=c+44|0;c=a+44|0;a=q&65535;q=t<<1;G=t*3|0;B=t<<2;D=-2;F=0;while(1){H=(f[l>>2]|0)+(Y(f[f[p>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,x)|0)<<2)|0;N=p_(L,r,e)|0;O=(f[m>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=t;P=i;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{f[M+(R<<2)>>2]=((d[O+(f[P+(R+G<<2)>>2]<<1)>>1]|0)+(d[O+(f[P+(R+t<<2)>>2]<<1)>>1]|0)<<2)+((d[O+(f[P+(R+q<<2)>>2]<<1)>>1]|0)*6|0)+(d[O+(f[P+(R<<2)>>2]<<1)>>1]|0)+(d[O+(f[P+(R+B<<2)>>2]<<1)>>1]|0);R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(o|0)){R=S;do{T=R<<1;f[M+(R<<2)>>2]=(d[O+(T+-2<<1)>>1]|0)+((d[O+(T<<1)>>1]|0)*6|0)+((d[O+((T|1)<<1)>>1]|0)+(d[O+(T+-1<<1)>>1]|0)<<2)+(d[O+(T+2<<1)>>1]|0);R=R+1|0}while((R|0)<(o|0));U=o}else U=S;break}case 2:{if((S|0)<(o|0)){R=S;while(1){T=O+(R<<1<<1)|0;V=(d[T+-10>>1]|0)+((d[T+2>>1]|0)*6|0)+((d[T+8>>1]|0)+(d[T+-4>>1]|0)<<2)+(d[T+14>>1]|0)|0;W=(d[T+-8>>1]|0)+((d[T+4>>1]|0)*6|0)+((d[T+10>>1]|0)+(d[T+-2>>1]|0)<<2)+(d[T+16>>1]|0)|0;f[M+(R<<2)>>2]=(d[T+-12>>1]|0)+((d[T>>1]|0)*6|0)+((d[T+6>>1]|0)+(d[T+-6>>1]|0)<<2)+(d[T+12>>1]|0);f[M+(R+1<<2)>>2]=V;f[M+(R+2<<2)>>2]=W;W=R+3|0;if((W|0)<(o|0))R=W;else{U=W;break}}}else U=S;break}case 3:{if((S|0)<(o|0)){R=S;while(1){W=O+(R<<1<<1)|0;V=(d[W+-14>>1]|0)+((d[W+2>>1]|0)*6|0)+((d[W+10>>1]|0)+(d[W+-6>>1]|0)<<2)+(d[W+18>>1]|0)|0;f[M+(R<<2)>>2]=(d[W+-16>>1]|0)+((d[W>>1]|0)*6|0)+((d[W+8>>1]|0)+(d[W+-8>>1]|0)<<2)+(d[W+16>>1]|0);f[M+(R+1<<2)>>2]=V;V=(d[W+-10>>1]|0)+((d[W+6>>1]|0)*6|0)+((d[W+14>>1]|0)+(d[W+-2>>1]|0)<<2)+(d[W+22>>1]|0)|0;f[M+(R+2<<2)>>2]=(d[W+-12>>1]|0)+((d[W+4>>1]|0)*6|0)+((d[W+12>>1]|0)+(d[W+-4>>1]|0)<<2)+(d[W+20>>1]|0);f[M+(R+3<<2)>>2]=V;V=R+4|0;if((V|0)<(o|0))R=V;else{U=V;break}}}else U=S;break}default:if((S|0)<(o|0)){R=S;do{V=f[C+(R<<2)>>2]|0;f[M+(R<<2)>>2]=(d[O+(V-q<<1)>>1]|0)+((d[O+(V<<1)>>1]|0)*6|0)+((d[O+(V+t<<1)>>1]|0)+(d[O+(V-t<<1)>>1]|0)<<2)+(d[O+(V+q<<1)>>1]|0);R=R+1|0}while((R|0)<(o|0));U=o}else U=S}N=s;P=j+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,x)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,x)|0)<<2)|0;P=z+((Y((J|0)%5|0,x)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,x)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,x)|0)<<2)|0;if(E){M=0;do{d[H+(M<<1)>>1]=(((f[P+(M<<2)>>2]|0)*6|0)+128+(f[L+(M<<2)>>2]|0)+((f[N+(M<<2)>>2]|0)+(f[Q+(M<<2)>>2]|0)<<2)+(f[O+(M<<2)>>2]|0)|0)>>>8;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(n|0))break;else D=K}}K=f[k>>2]|0;if((K|0)!=(A|0)){if(K|0)ZDc(K);f[k>>2]=A;f[w>>2]=264}w=f[h>>2]|0;if((w|0)==(v|0)){u=g;return}if(w|0)ZDc(w);f[h>>2]=v;f[y>>2]=264;u=g;return}function wna(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+30816|0;h=g+29744|0;i=g+15408|0;k=g+1072|0;l=g+8|0;m=g;n=a+16|0;if(!(f[n>>2]|0)){f[h>>2]=0;o=h+4|0;f[o>>2]=0;p=tT(h,13)|0;q=p;r=371005;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));una(-215,h,268259,399)}t=f[a+4>>2]|0;if((t|0)<3)v=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{w=f[a+40>>2]|0;x=0;y=1;while(1){z=Y(f[w+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(t|0)){v=z;break}else y=z}}if((t|0)==0|(v|0)==0){f[h>>2]=0;o=h+4|0;f[o>>2]=0;p=tT(h,13)|0;q=p;r=371005;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));una(-215,h,268259,399)}r=f[a+40>>2]|0;q=f[r+4>>2]|0;s=f[r>>2]|0;r=f[c+40>>2]|0;p=f[r+4>>2]|0;o=f[r>>2]|0;r=(f[a>>2]|0)>>>3;v=(r&511)+1|0;t=Y(v,p)|0;y=t+15&-16;x=(y*5|0)+16|0;w=h+8|0;f[h>>2]=w;z=h+4|0;f[z>>2]=x;if(x>>>0>264){A=XDc(x>>>0>1073741823?-1:x<<2)|0;f[h>>2]=A;B=A}else B=w;A=B+15&-16;B=l+8|0;f[l>>2]=B;x=l+4|0;f[x>>2]=t;if(t>>>0>264){C=XDc(t>>>0>1073741823?-1:t<<2)|0;f[l>>2]=C;D=C}else D=B;if(!((q|0)>0&(s|0)>0)){f[m>>2]=0;E=m+4|0;f[E>>2]=0;F=tT(m,129)|0;dJc(F|0,268268,129)|0;una(-215,m,268259,414)}C=(p<<1)-q|0;if((((C|0)>-1?C:0-C|0)|0)>=3){f[m>>2]=0;E=m+4|0;f[E>>2]=0;F=tT(m,129)|0;dJc(F|0,268268,129)|0;una(-215,m,268259,414)}C=(o<<1)-s|0;if((((C|0)>-1?C:0-C|0)|0)>=3){f[m>>2]=0;E=m+4|0;f[E>>2]=0;F=tT(m,129)|0;dJc(F|0,268268,129)|0;una(-215,m,268259,414)}m=((q+-3|0)/2|0)+1|0;F=(p|0)<(m|0)?p:m;m=(F<<1)+-2|0;p=0;do{E=Y(p_(p+-2|0,q,e)|0,v)|0;C=Y(p_(m+p|0,q,e)|0,v)|0;G=Y(p,v)|0;H=0;do{I=H+G|0;f[i+(I<<2)>>2]=H+E;f[k+(I<<2)>>2]=H+C;H=H+1|0}while((H|0)!=(v|0));p=p+1|0}while((p|0)<7);p=Y(v,F)|0;F=(t|0)>0;if(F){q=v<<1;m=0;do{H=(Y(q,(m|0)/(v|0)|0)|0)+((m|0)%(v|0)|0)|0;f[D+(m<<2)>>2]=H;m=m+1|0}while((m|0)!=(t|0))}if((o|0)>0){m=c+16|0;q=c+44|0;c=a+44|0;a=r&65535;r=v<<1;H=v*3|0;C=v<<2;E=-2;G=0;while(1){I=(f[m>>2]|0)+(Y(f[f[q>>2]>>2]|0,G)|0)|0;J=G<<1;K=J+2|0;if((E|0)>(K|0))L=E;else{M=E;while(1){N=A+((Y((M+2|0)%5|0,y)|0)<<2)|0;O=p_(M,s,e)|0;P=(f[n>>2]|0)+(Y(f[f[c>>2]>>2]|0,O)|0)|0;O=v;Q=i;R=0;while(1){if((R|0)<(O|0)){S=R;do{f[N+(S<<2)>>2]=((j[P+(f[Q+(S+H<<2)>>2]<<1)>>1]|0)+(j[P+(f[Q+(S+v<<2)>>2]<<1)>>1]|0)<<2)+((j[P+(f[Q+(S+r<<2)>>2]<<1)>>1]|0)*6|0)+(j[P+(f[Q+(S<<2)>>2]<<1)>>1]|0)+(j[P+(f[Q+(S+C<<2)>>2]<<1)>>1]|0);S=S+1|0}while((S|0)!=(O|0));T=O}else T=R;if((T|0)==(t|0))break;switch(a&511){case 0:{if((T|0)<(p|0)){S=T;do{U=S<<1;f[N+(S<<2)>>2]=(j[P+(U+-2<<1)>>1]|0)+((j[P+(U<<1)>>1]|0)*6|0)+((j[P+((U|1)<<1)>>1]|0)+(j[P+(U+-1<<1)>>1]|0)<<2)+(j[P+(U+2<<1)>>1]|0);S=S+1|0}while((S|0)<(p|0));V=p}else V=T;break}case 2:{if((T|0)<(p|0)){S=T;while(1){U=P+(S<<1<<1)|0;W=(j[U+-10>>1]|0)+((j[U+2>>1]|0)*6|0)+((j[U+8>>1]|0)+(j[U+-4>>1]|0)<<2)+(j[U+14>>1]|0)|0;X=(j[U+-8>>1]|0)+((j[U+4>>1]|0)*6|0)+((j[U+10>>1]|0)+(j[U+-2>>1]|0)<<2)+(j[U+16>>1]|0)|0;f[N+(S<<2)>>2]=(j[U+-12>>1]|0)+((j[U>>1]|0)*6|0)+((j[U+6>>1]|0)+(j[U+-6>>1]|0)<<2)+(j[U+12>>1]|0);f[N+(S+1<<2)>>2]=W;f[N+(S+2<<2)>>2]=X;X=S+3|0;if((X|0)<(p|0))S=X;else{V=X;break}}}else V=T;break}case 3:{if((T|0)<(p|0)){S=T;while(1){X=P+(S<<1<<1)|0;W=(j[X+-14>>1]|0)+((j[X+2>>1]|0)*6|0)+((j[X+10>>1]|0)+(j[X+-6>>1]|0)<<2)+(j[X+18>>1]|0)|0;f[N+(S<<2)>>2]=(j[X+-16>>1]|0)+((j[X>>1]|0)*6|0)+((j[X+8>>1]|0)+(j[X+-8>>1]|0)<<2)+(j[X+16>>1]|0);f[N+(S+1<<2)>>2]=W;W=(j[X+-10>>1]|0)+((j[X+6>>1]|0)*6|0)+((j[X+14>>1]|0)+(j[X+-2>>1]|0)<<2)+(j[X+22>>1]|0)|0;f[N+(S+2<<2)>>2]=(j[X+-12>>1]|0)+((j[X+4>>1]|0)*6|0)+((j[X+12>>1]|0)+(j[X+-4>>1]|0)<<2)+(j[X+20>>1]|0);f[N+(S+3<<2)>>2]=W;W=S+4|0;if((W|0)<(p|0))S=W;else{V=W;break}}}else V=T;break}default:if((T|0)<(p|0)){S=T;do{W=f[D+(S<<2)>>2]|0;f[N+(S<<2)>>2]=(j[P+(W-r<<1)>>1]|0)+((j[P+(W<<1)>>1]|0)*6|0)+((j[P+(W+v<<1)>>1]|0)+(j[P+(W-v<<1)>>1]|0)<<2)+(j[P+(W+r<<1)>>1]|0);S=S+1|0}while((S|0)<(p|0));V=p}else V=T}O=t;Q=k+(0-V<<2)|0;R=V}R=M+1|0;if((M|0)<(K|0))M=R;else{L=R;break}}}M=A+((Y((J|0)%5|0,y)|0)<<2)|0;R=A+((Y((J|1|0)%5|0,y)|0)<<2)|0;Q=A+((Y((K|0)%5|0,y)|0)<<2)|0;O=A+((Y((J+3|0)%5|0,y)|0)<<2)|0;P=A+((Y((J+4|0)%5|0,y)|0)<<2)|0;if(F){N=0;do{d[I+(N<<1)>>1]=(((f[Q+(N<<2)>>2]|0)*6|0)+128+(f[M+(N<<2)>>2]|0)+((f[O+(N<<2)>>2]|0)+(f[R+(N<<2)>>2]|0)<<2)+(f[P+(N<<2)>>2]|0)|0)>>>8;N=N+1|0}while((N|0)!=(t|0))}G=G+1|0;if((G|0)>=(o|0))break;else E=L}}L=f[l>>2]|0;if((L|0)!=(B|0)){if(L|0)ZDc(L);f[l>>2]=B;f[x>>2]=264}x=f[h>>2]|0;if((x|0)==(w|0)){u=g;return}if(x|0)ZDc(x);f[h>>2]=w;f[z>>2]=264;u=g;return}function xna(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;e=u;u=u+30816|0;g=e+29744|0;h=e+15408|0;i=e+1072|0;j=e+8|0;k=e;l=a+16|0;if(!(f[l>>2]|0)){f[g>>2]=0;m=g+4|0;f[m>>2]=0;o=tT(g,13)|0;p=o;q=371005;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));una(-215,g,268259,399)}s=f[a+4>>2]|0;if((s|0)<3)t=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{v=f[a+40>>2]|0;w=0;x=1;while(1){y=Y(f[v+(w<<2)>>2]|0,x)|0;w=w+1|0;if((w|0)==(s|0)){t=y;break}else x=y}}if((s|0)==0|(t|0)==0){f[g>>2]=0;m=g+4|0;f[m>>2]=0;o=tT(g,13)|0;p=o;q=371005;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));una(-215,g,268259,399)}q=f[a+40>>2]|0;p=f[q+4>>2]|0;r=f[q>>2]|0;q=f[c+40>>2]|0;o=f[q+4>>2]|0;m=f[q>>2]|0;q=(f[a>>2]|0)>>>3;t=(q&511)+1|0;s=Y(t,o)|0;x=s+15&-16;w=(x*5|0)+16|0;v=g+8|0;f[g>>2]=v;y=g+4|0;f[y>>2]=w;if(w>>>0>264){z=XDc(w>>>0>1073741823?-1:w<<2)|0;f[g>>2]=z;A=z}else A=v;z=A+15&-16;A=j+8|0;f[j>>2]=A;w=j+4|0;f[w>>2]=s;if(s>>>0>264){B=XDc(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=B;C=B}else C=A;if(!((p|0)>0&(r|0)>0)){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,129)|0;dJc(E|0,268268,129)|0;una(-215,k,268259,414)}B=(o<<1)-p|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,129)|0;dJc(E|0,268268,129)|0;una(-215,k,268259,414)}B=(m<<1)-r|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,129)|0;dJc(E|0,268268,129)|0;una(-215,k,268259,414)}k=((p+-3|0)/2|0)+1|0;E=(o|0)<(k|0)?o:k;k=(E<<1)+-2|0;o=0;do{D=Y(p_(o+-2|0,p,d)|0,t)|0;B=Y(p_(k+o|0,p,d)|0,t)|0;F=Y(o,t)|0;G=0;do{H=G+F|0;f[h+(H<<2)>>2]=G+D;f[i+(H<<2)>>2]=G+B;G=G+1|0}while((G|0)!=(t|0));o=o+1|0}while((o|0)<7);o=Y(t,E)|0;E=(s|0)>0;if(E){p=t<<1;k=0;do{G=(Y(p,(k|0)/(t|0)|0)|0)+((k|0)%(t|0)|0)|0;f[C+(k<<2)>>2]=G;k=k+1|0}while((k|0)!=(s|0))}if((m|0)>0){k=c+16|0;p=c+44|0;c=a+44|0;a=q&65535;q=t<<1;G=t*3|0;B=t<<2;D=-2;F=0;while(1){H=(f[k>>2]|0)+(Y(f[f[p>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,x)|0)<<2)|0;N=p_(L,r,d)|0;O=(f[l>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=t;P=h;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{n[M+(R<<2)>>2]=+n[O+(f[P+(R<<2)>>2]<<2)>>2]+(+n[O+(f[P+(R+q<<2)>>2]<<2)>>2]*6.0+(+n[O+(f[P+(R+t<<2)>>2]<<2)>>2]+ +n[O+(f[P+(R+G<<2)>>2]<<2)>>2])*4.0)+ +n[O+(f[P+(R+B<<2)>>2]<<2)>>2];R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(o|0)){R=S;do{T=R<<1;n[M+(R<<2)>>2]=+n[O+(T+2<<2)>>2]+(+n[O+(T+-2<<2)>>2]+(+n[O+(T<<2)>>2]*6.0+(+n[O+(T+-1<<2)>>2]+ +n[O+((T|1)<<2)>>2])*4.0));R=R+1|0}while((R|0)<(o|0));U=o}else U=S;break}case 2:{if((S|0)<(o|0)){R=S;while(1){T=O+(R<<1<<2)|0;V=+n[T+28>>2]+(+n[T+-20>>2]+(+n[T+4>>2]*6.0+(+n[T+-8>>2]+ +n[T+16>>2])*4.0));W=+n[T+32>>2]+(+n[T+-16>>2]+(+n[T+8>>2]*6.0+(+n[T+-4>>2]+ +n[T+20>>2])*4.0));n[M+(R<<2)>>2]=+n[T+24>>2]+(+n[T+-24>>2]+(+n[T>>2]*6.0+(+n[T+-12>>2]+ +n[T+12>>2])*4.0));n[M+(R+1<<2)>>2]=V;n[M+(R+2<<2)>>2]=W;T=R+3|0;if((T|0)<(o|0))R=T;else{U=T;break}}}else U=S;break}case 3:{if((S|0)<(o|0)){R=S;while(1){T=O+(R<<1<<2)|0;W=+n[T+36>>2]+(+n[T+-28>>2]+(+n[T+4>>2]*6.0+(+n[T+-12>>2]+ +n[T+20>>2])*4.0));n[M+(R<<2)>>2]=+n[T+32>>2]+(+n[T+-32>>2]+(+n[T>>2]*6.0+(+n[T+-16>>2]+ +n[T+16>>2])*4.0));n[M+(R+1<<2)>>2]=W;W=+n[T+44>>2]+(+n[T+-20>>2]+(+n[T+12>>2]*6.0+(+n[T+-4>>2]+ +n[T+28>>2])*4.0));n[M+(R+2<<2)>>2]=+n[T+40>>2]+(+n[T+-24>>2]+(+n[T+8>>2]*6.0+(+n[T+-8>>2]+ +n[T+24>>2])*4.0));n[M+(R+3<<2)>>2]=W;T=R+4|0;if((T|0)<(o|0))R=T;else{U=T;break}}}else U=S;break}default:if((S|0)<(o|0)){R=S;do{T=f[C+(R<<2)>>2]|0;n[M+(R<<2)>>2]=+n[O+(T+q<<2)>>2]+(+n[O+(T-q<<2)>>2]+(+n[O+(T<<2)>>2]*6.0+(+n[O+(T-t<<2)>>2]+ +n[O+(T+t<<2)>>2])*4.0));R=R+1|0}while((R|0)<(o|0));U=o}else U=S}N=s;P=i+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,x)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,x)|0)<<2)|0;P=z+((Y((J|0)%5|0,x)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,x)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,x)|0)<<2)|0;if(E){M=0;do{n[H+(M<<2)>>2]=(+n[O+(M<<2)>>2]+(+n[L+(M<<2)>>2]+(+n[P+(M<<2)>>2]*6.0+(+n[Q+(M<<2)>>2]+ +n[N+(M<<2)>>2])*4.0)))*.00390625;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(m|0))break;else D=K}}K=f[j>>2]|0;if((K|0)!=(A|0)){if(K|0)ZDc(K);f[j>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(v|0)){u=e;return}if(w|0)ZDc(w);f[g>>2]=v;f[y>>2]=264;u=e;return}function yna(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;e=u;u=u+30848|0;g=e;h=e+16504|0;i=e+2168|0;j=e+1104|0;k=e+1096|0;l=a+16|0;if(!(f[l>>2]|0)){f[g>>2]=0;m=g+4|0;f[m>>2]=0;n=tT(g,13)|0;o=n;q=371005;r=o+13|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));una(-215,g,268259,399)}s=f[a+4>>2]|0;if((s|0)<3)t=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{v=f[a+40>>2]|0;w=0;x=1;while(1){y=Y(f[v+(w<<2)>>2]|0,x)|0;w=w+1|0;if((w|0)==(s|0)){t=y;break}else x=y}}if((s|0)==0|(t|0)==0){f[g>>2]=0;m=g+4|0;f[m>>2]=0;n=tT(g,13)|0;o=n;q=371005;r=o+13|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));una(-215,g,268259,399)}q=f[a+40>>2]|0;o=f[q+4>>2]|0;r=f[q>>2]|0;q=f[c+40>>2]|0;n=f[q+4>>2]|0;m=f[q>>2]|0;q=(f[a>>2]|0)>>>3;t=(q&511)+1|0;s=Y(t,n)|0;x=s+15&-16;w=(x*5|0)+16|0;v=g+8|0;f[g>>2]=v;y=g+4|0;f[y>>2]=w;if(w>>>0>136){z=XDc(w>>>0>536870911?-1:w<<3)|0;f[g>>2]=z;A=z}else A=v;z=A+15&-16;A=j+8|0;f[j>>2]=A;w=j+4|0;f[w>>2]=s;if(s>>>0>264){B=XDc(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=B;C=B}else C=A;if(!((o|0)>0&(r|0)>0)){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,129)|0;dJc(E|0,268268,129)|0;una(-215,k,268259,414)}B=(n<<1)-o|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,129)|0;dJc(E|0,268268,129)|0;una(-215,k,268259,414)}B=(m<<1)-r|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[k>>2]=0;D=k+4|0;f[D>>2]=0;E=tT(k,129)|0;dJc(E|0,268268,129)|0;una(-215,k,268259,414)}k=((o+-3|0)/2|0)+1|0;E=(n|0)<(k|0)?n:k;k=(E<<1)+-2|0;n=0;do{D=Y(p_(n+-2|0,o,d)|0,t)|0;B=Y(p_(k+n|0,o,d)|0,t)|0;F=Y(n,t)|0;G=0;do{H=G+F|0;f[h+(H<<2)>>2]=G+D;f[i+(H<<2)>>2]=G+B;G=G+1|0}while((G|0)!=(t|0));n=n+1|0}while((n|0)<7);n=Y(t,E)|0;E=(s|0)>0;if(E){o=t<<1;k=0;do{G=(Y(o,(k|0)/(t|0)|0)|0)+((k|0)%(t|0)|0)|0;f[C+(k<<2)>>2]=G;k=k+1|0}while((k|0)!=(s|0))}if((m|0)>0){k=c+16|0;o=c+44|0;c=a+44|0;a=q&65535;q=t<<1;G=t*3|0;B=t<<2;D=-2;F=0;while(1){H=(f[k>>2]|0)+(Y(f[f[o>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,x)|0)<<3)|0;N=p_(L,r,d)|0;O=(f[l>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=t;P=h;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{p[M+(R<<3)>>3]=+p[O+(f[P+(R<<2)>>2]<<3)>>3]+(+p[O+(f[P+(R+q<<2)>>2]<<3)>>3]*6.0+(+p[O+(f[P+(R+t<<2)>>2]<<3)>>3]+ +p[O+(f[P+(R+G<<2)>>2]<<3)>>3])*4.0)+ +p[O+(f[P+(R+B<<2)>>2]<<3)>>3];R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(n|0)){R=S;do{T=R<<1;p[M+(R<<3)>>3]=+p[O+(T+2<<3)>>3]+(+p[O+(T+-2<<3)>>3]+(+p[O+(T<<3)>>3]*6.0+(+p[O+(T+-1<<3)>>3]+ +p[O+((T|1)<<3)>>3])*4.0));R=R+1|0}while((R|0)<(n|0));U=n}else U=S;break}case 2:{if((S|0)<(n|0)){R=S;while(1){T=O+(R<<1<<3)|0;V=+p[T+56>>3]+(+p[T+-40>>3]+(+p[T+8>>3]*6.0+(+p[T+-16>>3]+ +p[T+32>>3])*4.0));W=+p[T+64>>3]+(+p[T+-32>>3]+(+p[T+16>>3]*6.0+(+p[T+-8>>3]+ +p[T+40>>3])*4.0));p[M+(R<<3)>>3]=+p[T+48>>3]+(+p[T+-48>>3]+(+p[T>>3]*6.0+(+p[T+-24>>3]+ +p[T+24>>3])*4.0));p[M+(R+1<<3)>>3]=V;p[M+(R+2<<3)>>3]=W;T=R+3|0;if((T|0)<(n|0))R=T;else{U=T;break}}}else U=S;break}case 3:{if((S|0)<(n|0)){R=S;while(1){T=O+(R<<1<<3)|0;W=+p[T+72>>3]+(+p[T+-56>>3]+(+p[T+8>>3]*6.0+(+p[T+-24>>3]+ +p[T+40>>3])*4.0));p[M+(R<<3)>>3]=+p[T+64>>3]+(+p[T+-64>>3]+(+p[T>>3]*6.0+(+p[T+-32>>3]+ +p[T+32>>3])*4.0));p[M+(R+1<<3)>>3]=W;W=+p[T+88>>3]+(+p[T+-40>>3]+(+p[T+24>>3]*6.0+(+p[T+-8>>3]+ +p[T+56>>3])*4.0));p[M+(R+2<<3)>>3]=+p[T+80>>3]+(+p[T+-48>>3]+(+p[T+16>>3]*6.0+(+p[T+-16>>3]+ +p[T+48>>3])*4.0));p[M+(R+3<<3)>>3]=W;T=R+4|0;if((T|0)<(n|0))R=T;else{U=T;break}}}else U=S;break}default:if((S|0)<(n|0)){R=S;do{T=f[C+(R<<2)>>2]|0;p[M+(R<<3)>>3]=+p[O+(T+q<<3)>>3]+(+p[O+(T-q<<3)>>3]+(+p[O+(T<<3)>>3]*6.0+(+p[O+(T-t<<3)>>3]+ +p[O+(T+t<<3)>>3])*4.0));R=R+1|0}while((R|0)<(n|0));U=n}else U=S}N=s;P=i+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,x)|0)<<3)|0;Q=z+((Y((I|1|0)%5|0,x)|0)<<3)|0;P=z+((Y((J|0)%5|0,x)|0)<<3)|0;N=z+((Y((I+3|0)%5|0,x)|0)<<3)|0;O=z+((Y((I+4|0)%5|0,x)|0)<<3)|0;if(E){M=0;do{p[H+(M<<3)>>3]=(+p[O+(M<<3)>>3]+(+p[L+(M<<3)>>3]+(+p[P+(M<<3)>>3]*6.0+(+p[Q+(M<<3)>>3]+ +p[N+(M<<3)>>3])*4.0)))*.00390625;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(m|0))break;else D=K}}K=f[j>>2]|0;if((K|0)!=(A|0)){if(K|0)ZDc(K);f[j>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(v|0)){u=e;return}if(w|0)ZDc(w);f[g>>2]=v;f[y>>2]=136;u=e;return}function zna(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=u;u=u+30816|0;g=e+29744|0;i=e+15408|0;j=e+1072|0;k=e+8|0;l=e;m=a+16|0;if(!(f[m>>2]|0)){f[g>>2]=0;n=g+4|0;f[n>>2]=0;o=tT(g,13)|0;p=o;q=371005;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));una(-215,g,268259,399)}s=f[a+4>>2]|0;if((s|0)<3)t=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{v=f[a+40>>2]|0;w=0;x=1;while(1){y=Y(f[v+(w<<2)>>2]|0,x)|0;w=w+1|0;if((w|0)==(s|0)){t=y;break}else x=y}}if((s|0)==0|(t|0)==0){f[g>>2]=0;n=g+4|0;f[n>>2]=0;o=tT(g,13)|0;p=o;q=371005;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));una(-215,g,268259,399)}q=f[a+40>>2]|0;p=f[q+4>>2]|0;r=f[q>>2]|0;q=f[c+40>>2]|0;o=f[q+4>>2]|0;n=f[q>>2]|0;q=(f[a>>2]|0)>>>3;t=(q&511)+1|0;s=Y(t,o)|0;x=s+15&-16;w=(x*5|0)+16|0;v=g+8|0;f[g>>2]=v;y=g+4|0;f[y>>2]=w;if(w>>>0>264){z=XDc(w>>>0>1073741823?-1:w<<2)|0;f[g>>2]=z;A=z}else A=v;z=A+15&-16;A=k+8|0;f[k>>2]=A;w=k+4|0;f[w>>2]=s;if(s>>>0>264){B=XDc(s>>>0>1073741823?-1:s<<2)|0;f[k>>2]=B;C=B}else C=A;if(!((p|0)>0&(r|0)>0)){f[l>>2]=0;D=l+4|0;f[D>>2]=0;E=tT(l,129)|0;dJc(E|0,268268,129)|0;una(-215,l,268259,414)}B=(o<<1)-p|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[l>>2]=0;D=l+4|0;f[D>>2]=0;E=tT(l,129)|0;dJc(E|0,268268,129)|0;una(-215,l,268259,414)}B=(n<<1)-r|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[l>>2]=0;D=l+4|0;f[D>>2]=0;E=tT(l,129)|0;dJc(E|0,268268,129)|0;una(-215,l,268259,414)}l=((p+-3|0)/2|0)+1|0;E=(o|0)<(l|0)?o:l;l=(E<<1)+-2|0;o=0;do{D=Y(p_(o+-2|0,p,d)|0,t)|0;B=Y(p_(l+o|0,p,d)|0,t)|0;F=Y(o,t)|0;G=0;do{H=G+F|0;f[i+(H<<2)>>2]=G+D;f[j+(H<<2)>>2]=G+B;G=G+1|0}while((G|0)!=(t|0));o=o+1|0}while((o|0)<7);o=Y(t,E)|0;E=(s|0)>0;if(E){p=t<<1;l=0;do{G=(Y(p,(l|0)/(t|0)|0)|0)+((l|0)%(t|0)|0)|0;f[C+(l<<2)>>2]=G;l=l+1|0}while((l|0)!=(s|0))}if((n|0)>0){l=c+16|0;p=c+44|0;c=a+44|0;a=q&65535;q=t<<1;G=t*3|0;B=t<<2;D=-2;F=0;while(1){H=(f[l>>2]|0)+(Y(f[f[p>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,x)|0)<<2)|0;N=p_(L,r,d)|0;O=(f[m>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=t;P=i;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{f[M+(R<<2)>>2]=((h[O+(f[P+(R+G<<2)>>2]|0)>>0]|0)+(h[O+(f[P+(R+t<<2)>>2]|0)>>0]|0)<<2)+((h[O+(f[P+(R+q<<2)>>2]|0)>>0]|0)*6|0)+(h[O+(f[P+(R<<2)>>2]|0)>>0]|0)+(h[O+(f[P+(R+B<<2)>>2]|0)>>0]|0);R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(o|0)){R=S;do{T=R<<1;f[M+(R<<2)>>2]=(h[O+(T+-2)>>0]|0)+((h[O+T>>0]|0)*6|0)+((h[O+(T|1)>>0]|0)+(h[O+(T+-1)>>0]|0)<<2)+(h[O+(T+2)>>0]|0);R=R+1|0}while((R|0)<(o|0));U=o}else U=S;break}case 2:{if((S|0)<(o|0)){R=S;while(1){T=O+(R<<1)|0;V=(h[T+-5>>0]|0)+((h[T+1>>0]|0)*6|0)+((h[T+4>>0]|0)+(h[T+-2>>0]|0)<<2)+(h[T+7>>0]|0)|0;W=(h[T+-4>>0]|0)+((h[T+2>>0]|0)*6|0)+((h[T+5>>0]|0)+(h[T+-1>>0]|0)<<2)+(h[T+8>>0]|0)|0;f[M+(R<<2)>>2]=(h[T+-6>>0]|0)+((h[T>>0]|0)*6|0)+((h[T+3>>0]|0)+(h[T+-3>>0]|0)<<2)+(h[T+6>>0]|0);f[M+(R+1<<2)>>2]=V;f[M+(R+2<<2)>>2]=W;W=R+3|0;if((W|0)<(o|0))R=W;else{U=W;break}}}else U=S;break}case 3:{if((S|0)<(o|0)){R=S;while(1){W=O+(R<<1)|0;V=(h[W+-7>>0]|0)+((h[W+1>>0]|0)*6|0)+((h[W+5>>0]|0)+(h[W+-3>>0]|0)<<2)+(h[W+9>>0]|0)|0;f[M+(R<<2)>>2]=(h[W+-8>>0]|0)+((h[W>>0]|0)*6|0)+((h[W+4>>0]|0)+(h[W+-4>>0]|0)<<2)+(h[W+8>>0]|0);f[M+(R+1<<2)>>2]=V;V=(h[W+-5>>0]|0)+((h[W+3>>0]|0)*6|0)+((h[W+7>>0]|0)+(h[W+-1>>0]|0)<<2)+(h[W+11>>0]|0)|0;f[M+(R+2<<2)>>2]=(h[W+-6>>0]|0)+((h[W+2>>0]|0)*6|0)+((h[W+6>>0]|0)+(h[W+-2>>0]|0)<<2)+(h[W+10>>0]|0);f[M+(R+3<<2)>>2]=V;V=R+4|0;if((V|0)<(o|0))R=V;else{U=V;break}}}else U=S;break}default:if((S|0)<(o|0)){R=S;do{V=f[C+(R<<2)>>2]|0;f[M+(R<<2)>>2]=(h[O+(V-q)>>0]|0)+((h[O+V>>0]|0)*6|0)+((h[O+(V+t)>>0]|0)+(h[O+(V-t)>>0]|0)<<2)+(h[O+(V+q)>>0]|0);R=R+1|0}while((R|0)<(o|0));U=o}else U=S}N=s;P=j+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,x)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,x)|0)<<2)|0;P=z+((Y((J|0)%5|0,x)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,x)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,x)|0)<<2)|0;if(E){M=0;do{b[H+M>>0]=(((f[P+(M<<2)>>2]|0)*6|0)+128+(f[L+(M<<2)>>2]|0)+((f[N+(M<<2)>>2]|0)+(f[Q+(M<<2)>>2]|0)<<2)+(f[O+(M<<2)>>2]|0)|0)>>>8;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(n|0))break;else D=K}}K=f[k>>2]|0;if((K|0)!=(A|0)){if(K|0)ZDc(K);f[k>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(v|0)){u=e;return}if(w|0)ZDc(w);f[g>>2]=v;f[y>>2]=264;u=e;return}function Ana(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+128|0;h=g+72|0;i=g+64|0;j=g+8|0;k=g;if((e|0)!=4){f[h>>2]=0;f[h+4>>2]=0;e=tT(h,28)|0;l=268468;m=e+28|0;do{b[e>>0]=b[l>>0]|0;e=e+1|0;l=l+1|0}while((e|0)<(m|0));una(-215,h,268497,995)}do if((d$(a)|0)==65536){l=f[a+4>>2]|0;f[h>>2]=f[l>>2];e=h+4|0;m=l+4|0;f[e>>2]=f[m>>2];n=h+8|0;f[n>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];o=f[l+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=n;n=h+48|0;p=h+44|0;f[p>>2]=n;f[n>>2]=0;f[h+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[l+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];break}else{f[e>>2]=0;ZS(h,l);break}}else a$(h,a,-1);while(0);a=f[d>>2]|0;if((a|0)>=1?(l=f[d+4>>2]|0,(l|0)>=1):0){q=a;r=l}else{q=f[h+12>>2]<<1;r=f[h+8>>2]<<1}f[i>>2]=q;f[i+4>>2]=r;v$(c,i,f[h>>2]&4095,-1,0,0);do if((d$(c)|0)==65536){i=f[c+4>>2]|0;f[j>>2]=f[i>>2];r=j+4|0;q=i+4|0;f[r>>2]=f[q>>2];l=j+8|0;f[l>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];a=f[i+36>>2]|0;f[j+36>>2]=a;f[j+40>>2]=l;l=j+48|0;d=j+44|0;f[d>>2]=l;f[l>>2]=0;f[j+52>>2]=0;if(a|0){l=a+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[q>>2]|0)<3){q=f[i+44>>2]|0;l=f[d>>2]|0;f[l>>2]=f[q>>2];f[l+4>>2]=f[q+4>>2];break}else{f[r>>2]=0;ZS(j,i);break}}else a$(j,c,-1);while(0);switch(f[h>>2]&7){case 0:{s=354;break}case 3:{s=355;break}case 2:{s=356;break}case 5:{s=357;break}case 6:{s=358;break}default:{f[k>>2]=0;f[k+4>>2]=0;una(-210,k,268497,1032)}}Ti[s&511](h,j,4);s=j+36|0;k=f[s>>2]|0;if(k|0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)_S(j);f[s>>2]=0;s=j+16|0;k=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){s=f[j+40>>2]|0;c=0;do{f[s+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))g0(k);k=h+36|0;j=f[k>>2]|0;if(j|0?(c=j+12|0,j=f[c>>2]|0,f[c>>2]=j+-1,(j|0)==1):0)_S(h);f[k>>2]=0;k=h+16|0;j=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[h+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[h+44>>2]|0;if((j|0)==(h+48|0)){u=g;return}g0(j);u=g;return}function Bna(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=u;u=u+2144|0;g=e+1072|0;h=e+8|0;i=e;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[c+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(j,m+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(j,k)|0;p=h+8|0;f[h>>2]=p;v=h+4|0;f[v>>2]=t;if(t>>>0>264){w=XDc(t>>>0>1073741823?-1:t<<2)|0;f[h>>2]=w;x=w}else x=p;w=m-(k<<1)|0;if((((w|0)>-1?w:0-w|0)|0)!=((m|0)%2|0|0)){f[i>>2]=0;y=i+4|0;f[y>>2]=0;z=tT(i,119)|0;A=z;B=268503;C=A+119|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));una(-215,i,268623,537)}w=l<<1;k=n-w|0;if((((k|0)>-1?k:0-k|0)|0)!=((n|0)%2|0|0)){f[i>>2]=0;y=i+4|0;f[y>>2]=0;z=tT(i,119)|0;A=z;B=268503;C=A+119|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));una(-215,i,268623,537)}i=Y(j,m)|0;if((t|0)>0){m=j<<1;B=0;do{A=(Y(m,(B|0)/(j|0)|0)|0)+((B|0)%(j|0)|0)|0;f[x+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(t|0))}if((l|0)>0){B=c+16|0;m=c+44|0;A=n+-1|0;C=(i|0)>0;z=a+16|0;y=a+44|0;a=(t|0)==(j|0);k=t-j|0;D=(i|0)>(t<<1|0);t=c+12|0;E=(j|0)<(k|0);F=-1;G=0;while(1){H=G<<1;I=f[B>>2]|0;J=f[f[m>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(A|0)<(L|0)?A:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(p_(J<<1,w,4)|0)/2|0;P=(f[z>>2]|0)+(Y(f[f[y>>2]>>2]|0,O)|0)|0;if(!a){if(D){O=0;do{Q=f[x+(O<<2)>>2]|0;R=d[P+(O<<1)>>1]|0;S=d[P+(O+j<<1)>>1]|0;f[N+(Q<<2)>>2]=(S<<1)+(R*6|0);f[N+(Q+j<<2)>>2]=S+R<<2;R=O+k|0;S=f[x+(R<<2)>>2]|0;Q=d[P+(R<<1)>>1]|0;T=Q<<3;f[N+(S<<2)>>2]=(Q*7|0)+(d[P+(R-j<<1)>>1]|0);f[N+(S+j<<2)>>2]=T;f[N+(O+-1+(f[t>>2]|0)<<2)>>2]=T;O=O+1|0}while((O|0)!=(j|0))}else{O=0;do{T=f[x+(O<<2)>>2]|0;S=d[P+(O<<1)>>1]|0;R=d[P+(O+j<<1)>>1]|0;f[N+(T<<2)>>2]=(R<<1)+(S*6|0);f[N+(T+j<<2)>>2]=R+S<<2;S=O+k|0;R=f[x+(S<<2)>>2]|0;T=d[P+(S<<1)>>1]|0;f[N+(R<<2)>>2]=(T*7|0)+(d[P+(S-j<<1)>>1]|0);f[N+(R+j<<2)>>2]=T<<3;O=O+1|0}while((O|0)!=(j|0))}if(E){O=j;do{T=f[x+(O<<2)>>2]|0;R=d[P+(O<<1)>>1]|0;S=d[P+(O+j<<1)>>1]|0;f[N+(T<<2)>>2]=(R*6|0)+(d[P+(O-j<<1)>>1]|0)+S;f[N+(T+j<<2)>>2]=S+R<<2;O=O+1|0}while((O|0)!=(k|0))}}else{O=0;do{R=d[P+(O<<1)>>1]<<3;f[N+(O+j<<2)>>2]=R;f[N+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(j|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;O=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(C){P=0;do{R=f[O+(P<<2)>>2]|0;S=f[N+(P<<2)>>2]|0;T=((R*6|0)+32+S+(f[J+(P<<2)>>2]|0)|0)>>>6&65535;d[H+(P<<1)>>1]=((S+R<<2)+32|0)>>>6;d[K+(P<<1)>>1]=T;P=P+1|0}while((P|0)!=(i|0))}if((G|0)>=(l|0))break;else F=M}}if((n|0)>(w|0)?(n=f[c+16>>2]|0,M=f[f[c+44>>2]>>2]|0,c=n+(Y(M,w+-2|0)|0)|0,F=n+(Y(M,w)|0)|0,(i|0)>0):0){w=0;do{d[F+(w<<1)>>1]=d[c+(w<<1)>>1]|0;w=w+1|0}while((w|0)!=(i|0))}i=f[h>>2]|0;if((i|0)!=(p|0)){if(i|0)ZDc(i);f[h>>2]=p;f[v>>2]=264}v=f[g>>2]|0;if((v|0)==(q|0)){u=e;return}if(v|0)ZDc(v);f[g>>2]=q;f[r>>2]=264;u=e;return}function Cna(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+2144|0;g=e+1072|0;h=e+8|0;i=e;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=((f[a>>2]|0)>>>3&511)+1|0;p=(Y(k,n+1|0)|0)+15&-16;q=(p*3|0)+16|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=XDc(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=v+15&-16;v=Y(k,l)|0;q=h+8|0;f[h>>2]=q;w=h+4|0;f[w>>2]=v;if(v>>>0>264){x=XDc(v>>>0>1073741823?-1:v<<2)|0;f[h>>2]=x;y=x}else y=q;x=n-(l<<1)|0;if((((x|0)>-1?x:0-x|0)|0)!=((n|0)%2|0|0)){f[i>>2]=0;z=i+4|0;f[z>>2]=0;A=tT(i,119)|0;B=A;C=268503;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));una(-215,i,268623,537)}x=m<<1;l=o-x|0;if((((l|0)>-1?l:0-l|0)|0)!=((o|0)%2|0|0)){f[i>>2]=0;z=i+4|0;f[z>>2]=0;A=tT(i,119)|0;B=A;C=268503;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));una(-215,i,268623,537)}i=Y(k,n)|0;if((v|0)>0){n=k<<1;C=0;do{B=(Y(n,(C|0)/(k|0)|0)|0)+((C|0)%(k|0)|0)|0;f[y+(C<<2)>>2]=B;C=C+1|0}while((C|0)!=(v|0))}if((m|0)>0){C=c+16|0;n=c+44|0;B=o+-1|0;D=(i|0)>0;A=a+16|0;z=a+44|0;a=(v|0)==(k|0);l=v-k|0;E=(i|0)>(v<<1|0);v=c+12|0;F=(k|0)<(l|0);G=-1;H=0;while(1){I=H<<1;J=f[C>>2]|0;K=f[f[n>>2]>>2]|0;L=J+(Y(K,I)|0)|0;M=I|1;I=J+(Y(K,(B|0)<(M|0)?B:M)|0)|0;M=H;H=H+1|0;if((G|0)>(H|0))N=G;else{K=G;while(1){J=K+1|0;O=t+((Y((J|0)%3|0,p)|0)<<2)|0;P=(p_(K<<1,x,4)|0)/2|0;Q=(f[A>>2]|0)+(Y(f[f[z>>2]>>2]|0,P)|0)|0;if(!a){if(E){P=0;do{R=f[y+(P<<2)>>2]|0;S=j[Q+(P<<1)>>1]|0;T=j[Q+(P+k<<1)>>1]|0;f[O+(R<<2)>>2]=(T<<1)+(S*6|0);f[O+(R+k<<2)>>2]=T+S<<2;S=P+l|0;T=f[y+(S<<2)>>2]|0;R=j[Q+(S<<1)>>1]|0;U=R<<3;f[O+(T<<2)>>2]=(R*7|0)+(j[Q+(S-k<<1)>>1]|0);f[O+(T+k<<2)>>2]=U;f[O+(P+-1+(f[v>>2]|0)<<2)>>2]=U;P=P+1|0}while((P|0)!=(k|0))}else{P=0;do{U=f[y+(P<<2)>>2]|0;T=j[Q+(P<<1)>>1]|0;S=j[Q+(P+k<<1)>>1]|0;f[O+(U<<2)>>2]=(S<<1)+(T*6|0);f[O+(U+k<<2)>>2]=S+T<<2;T=P+l|0;S=f[y+(T<<2)>>2]|0;U=j[Q+(T<<1)>>1]|0;f[O+(S<<2)>>2]=(U*7|0)+(j[Q+(T-k<<1)>>1]|0);f[O+(S+k<<2)>>2]=U<<3;P=P+1|0}while((P|0)!=(k|0))}if(F){P=k;do{U=f[y+(P<<2)>>2]|0;S=j[Q+(P<<1)>>1]|0;T=j[Q+(P+k<<1)>>1]|0;f[O+(U<<2)>>2]=(S*6|0)+(j[Q+(P-k<<1)>>1]|0)+T;f[O+(U+k<<2)>>2]=T+S<<2;P=P+1|0}while((P|0)!=(l|0))}}else{P=0;do{S=(j[Q+(P<<1)>>1]|0)<<3;f[O+(P+k<<2)>>2]=S;f[O+(P<<2)>>2]=S;P=P+1|0}while((P|0)!=(k|0))}if((K|0)>(M|0)){N=J;break}else K=J}}K=t+((Y((M|0)%3|0,p)|0)<<2)|0;P=t+((Y((H|0)%3|0,p)|0)<<2)|0;O=t+((Y((M+2|0)%3|0,p)|0)<<2)|0;if(D){Q=0;do{S=f[P+(Q<<2)>>2]|0;T=f[O+(Q<<2)>>2]|0;U=((S*6|0)+32+T+(f[K+(Q<<2)>>2]|0)|0)>>>6&65535;d[I+(Q<<1)>>1]=((T+S<<2)+32|0)>>>6;d[L+(Q<<1)>>1]=U;Q=Q+1|0}while((Q|0)!=(i|0))}if((H|0)>=(m|0))break;else G=N}}if((o|0)>(x|0)?(o=f[c+16>>2]|0,N=f[f[c+44>>2]>>2]|0,c=o+(Y(N,x+-2|0)|0)|0,G=o+(Y(N,x)|0)|0,(i|0)>0):0){x=0;do{d[G+(x<<1)>>1]=d[c+(x<<1)>>1]|0;x=x+1|0}while((x|0)!=(i|0))}i=f[h>>2]|0;if((i|0)!=(q|0)){if(i|0)ZDc(i);f[h>>2]=q;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(r|0)){u=e;return}if(w|0)ZDc(w);f[g>>2]=r;f[s>>2]=264;u=e;return}function Dna(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0.0;d=u;u=u+2144|0;e=d+1072|0;g=d+8|0;h=d;i=f[a+40>>2]|0;j=f[i+4>>2]|0;k=f[i>>2]|0;i=f[c+40>>2]|0;l=f[i+4>>2]|0;m=f[i>>2]|0;i=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(i,l+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(i,j)|0;p=g+8|0;f[g>>2]=p;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=XDc(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=p;w=l-(j<<1)|0;if((((w|0)>-1?w:0-w|0)|0)!=((l|0)%2|0|0)){f[h>>2]=0;y=h+4|0;f[y>>2]=0;z=tT(h,119)|0;A=z;B=268503;C=A+119|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));una(-215,h,268623,537)}w=k<<1;j=m-w|0;if((((j|0)>-1?j:0-j|0)|0)!=((m|0)%2|0|0)){f[h>>2]=0;y=h+4|0;f[y>>2]=0;z=tT(h,119)|0;A=z;B=268503;C=A+119|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));una(-215,h,268623,537)}h=Y(i,l)|0;if((t|0)>0){l=i<<1;B=0;do{A=(Y(l,(B|0)/(i|0)|0)|0)+((B|0)%(i|0)|0)|0;f[x+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(t|0))}if((k|0)>0){B=c+16|0;l=c+44|0;A=m+-1|0;C=(h|0)>0;z=a+16|0;y=a+44|0;a=(t|0)==(i|0);j=t-i|0;D=(h|0)>(t<<1|0);t=c+12|0;E=(i|0)<(j|0);F=-1;G=0;while(1){H=G<<1;I=f[B>>2]|0;J=f[f[l>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(A|0)<(L|0)?A:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(p_(J<<1,w,4)|0)/2|0;P=(f[z>>2]|0)+(Y(f[f[y>>2]>>2]|0,O)|0)|0;if(!a){O=f[t>>2]|0;if(D){Q=0;do{R=f[x+(Q<<2)>>2]|0;S=+n[P+(Q<<2)>>2];T=+n[P+(Q+i<<2)>>2];n[N+(R<<2)>>2]=S*6.0+T*2.0;n[N+(R+i<<2)>>2]=(S+T)*4.0;R=Q+j|0;U=f[x+(R<<2)>>2]|0;T=+n[P+(R<<2)>>2];S=T*8.0;n[N+(U<<2)>>2]=+n[P+(R-i<<2)>>2]+T*7.0;n[N+(U+i<<2)>>2]=S;n[N+(Q+-1+O<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(i|0))}else{Q=0;do{O=f[x+(Q<<2)>>2]|0;S=+n[P+(Q<<2)>>2];T=+n[P+(Q+i<<2)>>2];n[N+(O<<2)>>2]=S*6.0+T*2.0;n[N+(O+i<<2)>>2]=(S+T)*4.0;O=Q+j|0;U=f[x+(O<<2)>>2]|0;T=+n[P+(O<<2)>>2];n[N+(U<<2)>>2]=+n[P+(O-i<<2)>>2]+T*7.0;n[N+(U+i<<2)>>2]=T*8.0;Q=Q+1|0}while((Q|0)!=(i|0))}if(E){Q=i;do{U=f[x+(Q<<2)>>2]|0;T=+n[P+(Q<<2)>>2];S=+n[P+(Q+i<<2)>>2];n[N+(U<<2)>>2]=S+(+n[P+(Q-i<<2)>>2]+T*6.0);n[N+(U+i<<2)>>2]=(T+S)*4.0;Q=Q+1|0}while((Q|0)!=(j|0))}}else{Q=0;do{S=+n[P+(Q<<2)>>2]*8.0;n[N+(Q+i<<2)>>2]=S;n[N+(Q<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(i|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;Q=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(C){P=0;do{S=+n[Q+(P<<2)>>2];T=+n[N+(P<<2)>>2];V=(T+(S*6.0+ +n[J+(P<<2)>>2]))*.015625;n[H+(P<<2)>>2]=(S+T)*4.0*.015625;n[K+(P<<2)>>2]=V;P=P+1|0}while((P|0)!=(h|0))}if((G|0)>=(k|0))break;else F=M}}if((m|0)>(w|0)?(m=f[c+16>>2]|0,M=f[f[c+44>>2]>>2]|0,c=m+(Y(M,w+-2|0)|0)|0,F=m+(Y(M,w)|0)|0,(h|0)>0):0){w=0;do{f[F+(w<<2)>>2]=f[c+(w<<2)>>2];w=w+1|0}while((w|0)!=(h|0))}h=f[g>>2]|0;if((h|0)!=(p|0)){if(h|0)ZDc(h);f[g>>2]=p;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)ZDc(v);f[e>>2]=q;f[r>>2]=264;u=d;return}function Ena(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0.0;d=u;u=u+2176|0;e=d;g=d+1104|0;h=d+1096|0;i=f[a+40>>2]|0;j=f[i+4>>2]|0;k=f[i>>2]|0;i=f[c+40>>2]|0;l=f[i+4>>2]|0;m=f[i>>2]|0;i=((f[a>>2]|0)>>>3&511)+1|0;n=(Y(i,l+1|0)|0)+15&-16;o=(n*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=o;if(o>>>0>136){s=XDc(o>>>0>536870911?-1:o<<3)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(i,j)|0;o=g+8|0;f[g>>2]=o;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=XDc(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=o;w=l-(j<<1)|0;if((((w|0)>-1?w:0-w|0)|0)!=((l|0)%2|0|0)){f[h>>2]=0;y=h+4|0;f[y>>2]=0;z=tT(h,119)|0;A=z;B=268503;C=A+119|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));una(-215,h,268623,537)}w=k<<1;j=m-w|0;if((((j|0)>-1?j:0-j|0)|0)!=((m|0)%2|0|0)){f[h>>2]=0;y=h+4|0;f[y>>2]=0;z=tT(h,119)|0;A=z;B=268503;C=A+119|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));una(-215,h,268623,537)}h=Y(i,l)|0;if((t|0)>0){l=i<<1;B=0;do{A=(Y(l,(B|0)/(i|0)|0)|0)+((B|0)%(i|0)|0)|0;f[x+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(t|0))}if((k|0)>0){B=c+16|0;l=c+44|0;A=m+-1|0;C=(h|0)>0;z=a+16|0;y=a+44|0;a=(t|0)==(i|0);j=t-i|0;D=(h|0)>(t<<1|0);t=c+12|0;E=(i|0)<(j|0);F=-1;G=0;while(1){H=G<<1;I=f[B>>2]|0;J=f[f[l>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(A|0)<(L|0)?A:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,n)|0)<<3)|0;O=(p_(J<<1,w,4)|0)/2|0;P=(f[z>>2]|0)+(Y(f[f[y>>2]>>2]|0,O)|0)|0;if(!a){O=f[t>>2]|0;if(D){Q=0;do{R=f[x+(Q<<2)>>2]|0;S=+p[P+(Q<<3)>>3];T=+p[P+(Q+i<<3)>>3];p[N+(R<<3)>>3]=S*6.0+T*2.0;p[N+(R+i<<3)>>3]=(S+T)*4.0;R=Q+j|0;U=f[x+(R<<2)>>2]|0;T=+p[P+(R<<3)>>3];S=T*8.0;p[N+(U<<3)>>3]=+p[P+(R-i<<3)>>3]+T*7.0;p[N+(U+i<<3)>>3]=S;p[N+(Q+-1+O<<3)>>3]=S;Q=Q+1|0}while((Q|0)!=(i|0))}else{Q=0;do{O=f[x+(Q<<2)>>2]|0;S=+p[P+(Q<<3)>>3];T=+p[P+(Q+i<<3)>>3];p[N+(O<<3)>>3]=S*6.0+T*2.0;p[N+(O+i<<3)>>3]=(S+T)*4.0;O=Q+j|0;U=f[x+(O<<2)>>2]|0;T=+p[P+(O<<3)>>3];p[N+(U<<3)>>3]=+p[P+(O-i<<3)>>3]+T*7.0;p[N+(U+i<<3)>>3]=T*8.0;Q=Q+1|0}while((Q|0)!=(i|0))}if(E){Q=i;do{U=f[x+(Q<<2)>>2]|0;T=+p[P+(Q<<3)>>3];S=+p[P+(Q+i<<3)>>3];p[N+(U<<3)>>3]=S+(+p[P+(Q-i<<3)>>3]+T*6.0);p[N+(U+i<<3)>>3]=(T+S)*4.0;Q=Q+1|0}while((Q|0)!=(j|0))}}else{Q=0;do{S=+p[P+(Q<<3)>>3]*8.0;p[N+(Q+i<<3)>>3]=S;p[N+(Q<<3)>>3]=S;Q=Q+1|0}while((Q|0)!=(i|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,n)|0)<<3)|0;Q=s+((Y((G|0)%3|0,n)|0)<<3)|0;N=s+((Y((L+2|0)%3|0,n)|0)<<3)|0;if(C){P=0;do{S=+p[Q+(P<<3)>>3];T=+p[N+(P<<3)>>3];V=(T+(S*6.0+ +p[J+(P<<3)>>3]))*.015625;p[H+(P<<3)>>3]=(S+T)*4.0*.015625;p[K+(P<<3)>>3]=V;P=P+1|0}while((P|0)!=(h|0))}if((G|0)>=(k|0))break;else F=M}}if((m|0)>(w|0)?(m=f[c+16>>2]|0,M=f[f[c+44>>2]>>2]|0,c=m+(Y(M,w+-2|0)|0)|0,F=m+(Y(M,w)|0)|0,(h|0)>0):0){w=0;do{p[F+(w<<3)>>3]=+p[c+(w<<3)>>3];w=w+1|0}while((w|0)!=(h|0))}h=f[g>>2]|0;if((h|0)!=(o|0)){if(h|0)ZDc(h);f[g>>2]=o;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)ZDc(v);f[e>>2]=q;f[r>>2]=136;u=d;return}function Fna(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=u;u=u+2144|0;e=d+1072|0;g=d+8|0;i=d;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[c+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(j,m+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(j,k)|0;p=g+8|0;f[g>>2]=p;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=XDc(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=p;w=m-(k<<1)|0;if((((w|0)>-1?w:0-w|0)|0)!=((m|0)%2|0|0)){f[i>>2]=0;y=i+4|0;f[y>>2]=0;z=tT(i,119)|0;A=z;B=268503;C=A+119|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));una(-215,i,268623,537)}w=l<<1;k=n-w|0;if((((k|0)>-1?k:0-k|0)|0)!=((n|0)%2|0|0)){f[i>>2]=0;y=i+4|0;f[y>>2]=0;z=tT(i,119)|0;A=z;B=268503;C=A+119|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));una(-215,i,268623,537)}i=Y(j,m)|0;if((t|0)>0){m=j<<1;B=0;do{A=(Y(m,(B|0)/(j|0)|0)|0)+((B|0)%(j|0)|0)|0;f[x+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(t|0))}if((l|0)>0){B=c+16|0;m=c+44|0;A=n+-1|0;C=(i|0)>0;z=a+16|0;y=a+44|0;a=(t|0)==(j|0);k=t-j|0;D=(i|0)>(t<<1|0);t=c+12|0;E=(j|0)<(k|0);F=-1;G=0;while(1){H=G<<1;I=f[B>>2]|0;J=f[f[m>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(A|0)<(L|0)?A:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(p_(J<<1,w,4)|0)/2|0;P=(f[z>>2]|0)+(Y(f[f[y>>2]>>2]|0,O)|0)|0;if(!a){if(D){O=0;do{Q=f[x+(O<<2)>>2]|0;R=h[P+O>>0]|0;S=h[P+(O+j)>>0]|0;f[N+(Q<<2)>>2]=(S<<1)+(R*6|0);f[N+(Q+j<<2)>>2]=S+R<<2;R=O+k|0;S=f[x+(R<<2)>>2]|0;Q=h[P+R>>0]|0;T=Q<<3;f[N+(S<<2)>>2]=(Q*7|0)+(h[P+(R-j)>>0]|0);f[N+(S+j<<2)>>2]=T;f[N+(O+-1+(f[t>>2]|0)<<2)>>2]=T;O=O+1|0}while((O|0)!=(j|0))}else{O=0;do{T=f[x+(O<<2)>>2]|0;S=h[P+O>>0]|0;R=h[P+(O+j)>>0]|0;f[N+(T<<2)>>2]=(R<<1)+(S*6|0);f[N+(T+j<<2)>>2]=R+S<<2;S=O+k|0;R=f[x+(S<<2)>>2]|0;T=h[P+S>>0]|0;f[N+(R<<2)>>2]=(T*7|0)+(h[P+(S-j)>>0]|0);f[N+(R+j<<2)>>2]=T<<3;O=O+1|0}while((O|0)!=(j|0))}if(E){O=j;do{T=f[x+(O<<2)>>2]|0;R=h[P+O>>0]|0;S=h[P+(O+j)>>0]|0;f[N+(T<<2)>>2]=(R*6|0)+(h[P+(O-j)>>0]|0)+S;f[N+(T+j<<2)>>2]=S+R<<2;O=O+1|0}while((O|0)!=(k|0))}}else{O=0;do{R=(h[P+O>>0]|0)<<3;f[N+(O+j<<2)>>2]=R;f[N+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(j|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;O=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(C){P=0;do{R=f[O+(P<<2)>>2]|0;S=f[N+(P<<2)>>2]|0;T=((R*6|0)+32+S+(f[J+(P<<2)>>2]|0)|0)>>>6&255;b[H+P>>0]=((S+R<<2)+32|0)>>>6;b[K+P>>0]=T;P=P+1|0}while((P|0)!=(i|0))}if((G|0)>=(l|0))break;else F=M}}if((n|0)>(w|0)?(n=f[c+16>>2]|0,M=f[f[c+44>>2]>>2]|0,c=n+(Y(M,w+-2|0)|0)|0,F=n+(Y(M,w)|0)|0,(i|0)>0):0){w=0;do{b[F+w>>0]=b[c+w>>0]|0;w=w+1|0}while((w|0)!=(i|0))}i=f[g>>2]|0;if((i|0)!=(p|0)){if(i|0)ZDc(i);f[g>>2]=p;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)ZDc(v);f[e>>2]=q;f[r>>2]=264;u=d;return}function Gna(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0;i=u;u=u+384|0;j=i+104|0;k=i+88|0;l=i+320|0;m=i+32|0;o=i+272|0;q=i;r=i+312|0;s=i+216|0;t=i+160|0;b$(r,a,-1);v$(c,r,c$(a,-1)|0,-1,0,0);do if((d$(a)|0)==65536){r=f[a+4>>2]|0;f[s>>2]=f[r>>2];v=s+4|0;w=r+4|0;f[v>>2]=f[w>>2];x=s+8|0;f[x>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];y=f[r+36>>2]|0;f[s+36>>2]=y;f[s+40>>2]=x;x=s+48|0;z=s+44|0;f[z>>2]=x;f[x>>2]=0;f[s+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[r+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;ZS(s,r);break}}else a$(s,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[t>>2]=f[a>>2];r=t+4|0;v=a+4|0;f[r>>2]=f[v>>2];w=t+8|0;f[w>>2]=f[a+8>>2];f[t+12>>2]=f[a+12>>2];f[t+16>>2]=f[a+16>>2];f[t+20>>2]=f[a+20>>2];f[t+24>>2]=f[a+24>>2];f[t+28>>2]=f[a+28>>2];f[t+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[t+36>>2]=x;f[t+40>>2]=w;w=t+48|0;z=t+44|0;f[z>>2]=w;f[w>>2]=0;f[t+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[a+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[r>>2]=0;ZS(t,a);break}}else a$(t,c,-1);while(0);c=f[s>>2]|0;switch(c&7){case 0:{a=(c>>>3&511)+1|0;r=f[f[s+40>>2]>>2]|0;switch(c&4095){case 16:case 0:break;default:{f[j>>2]=0;A=j+4|0;f[A>>2]=0;B=tT(j,72)|0;C=B;D=268630;E=C+72|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));Hna(-215,j,268703,642)}}if((f[s+16>>2]|0)==(f[t+16>>2]|0)){f[j>>2]=0;A=j+4|0;f[A>>2]=0;B=tT(j,72)|0;C=B;D=268630;E=C+72|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));Hna(-215,j,268703,642)}F=!(e<=0.0)?e:1.0;G=!(g<=0.0)?g:1.0;H=-.5/(F*F);F=-.5/(G*G);if((d|0)<1)I=nrc(G*1.5)|0;else I=d>>>1;B=(I|0)>1?I:1;I=B<<1|1;f[j>>2]=1124007936;A=j+4|0;v=j+8|0;w=j+40|0;C=A;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[w>>2]=v;v=j+48|0;z=j+44|0;f[z>>2]=v;f[v>>2]=0;f[j+52>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=s;x=l+8|0;f[x>>2]=0;f[x+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;q_(k,l,B,B,B,B,h,m);x=a<<8;y=a<<10;J=VDc(y)|0;XIc(J|0,0,y|0)|0;y=Y(I,I)|0;f[k>>2]=0;I=k+4|0;f[I>>2]=0;f[k+8>>2]=0;if(y>>>0>1073741823)mCc(k);K=y<<2;N=VDc(K)|0;f[k>>2]=N;O=N+(y<<2)|0;f[k+8>>2]=O;XIc(N|0,0,K|0)|0;f[I>>2]=O;O=VDc(K)|0;XIc(O|0,0,K|0)|0;K=0;do{G=+V(+(H*+(Y(K,K)|0)));n[J+(K<<2)>>2]=G;K=K+1|0}while((K|0)!=(x|0));x=0-B|0;if((B|0)<(x|0))P=0;else{H=+(B|0);K=f[v>>2]|0;y=0;Q=x;while(1){G=+(Q|0);R=G*G;S=Y(Q,K)|0;T=x;U=y;while(1){G=+(T|0);W=+M(+(R+G*G));if(W>H)X=U;else{Z=(Y(T,a)|0)+S|0;G=+V(+(F*(W*W)));n[N+(U<<2)>>2]=G;f[O+(U<<2)>>2]=Z;X=U+1|0}if((T|0)<(B|0)){T=T+1|0;U=X}else break}if((Q|0)<(B|0)){y=X;Q=Q+1|0}else{P=X;break}}}f[l>>2]=57700;f[l+4>>2]=j;f[l+8>>2]=t;f[l+12>>2]=B;f[l+16>>2]=P;f[l+20>>2]=O;f[l+24>>2]=N;f[l+28>>2]=J;f[m>>2]=0;f[m+4>>2]=r;r=f[t+4>>2]|0;if((r|0)<3)_=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{N=f[t+40>>2]|0;P=0;B=1;while(1){X=Y(f[N+(P<<2)>>2]|0,B)|0;P=P+1|0;if((P|0)==(r|0)){_=X;break}else B=X}}y8(m,l,+(_>>>0)*.0000152587890625);YDc(O);O=f[k>>2]|0;if(O|0){_=f[I>>2]|0;if((_|0)!=(O|0))f[I>>2]=_+(~((_+-4-O|0)>>>2)<<2);YDc(O)}YDc(J);J=j+36|0;O=f[J>>2]|0;if(O|0?(_=O+12|0,O=f[_>>2]|0,f[_>>2]=O+-1,(O|0)==1):0)_S(j);f[J>>2]=0;J=j+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[A>>2]|0)>0){J=f[w>>2]|0;w=0;do{f[J+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[A>>2]|0))}A=f[z>>2]|0;if((A|0)!=(v|0))g0(A);break}case 5:{A=(c>>>3&511)+1|0;p[j>>3]=-1.0;p[k>>3]=1.0;v=f[f[s+40>>2]>>2]|0;switch(c&4095){case 21:case 5:break;default:{f[l>>2]=0;$=l+4|0;f[$>>2]=0;aa=tT(l,74)|0;C=aa;D=268722;E=C+74|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));Hna(-215,l,268797,1171)}}if((f[s+16>>2]|0)==(f[t+16>>2]|0)){f[l>>2]=0;$=l+4|0;f[$>>2]=0;aa=tT(l,74)|0;C=aa;D=268722;E=C+74|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));Hna(-215,l,268797,1171)}F=!(e<=0.0)?e:1.0;e=!(g<=0.0)?g:1.0;g=-.5/(F*F);F=-.5/(e*e);if((d|0)<1)ba=nrc(e*1.5)|0;else ba=d>>>1;d=(ba|0)>1?ba:1;ba=d<<1|1;lT(m,s,1,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=m;ET(l,j,k,0,0,e0()|0);aa=m+36|0;$=f[aa>>2]|0;if($|0?(c=$+12|0,$=f[c>>2]|0,f[c>>2]=$+-1,($|0)==1):0)_S(m);f[aa>>2]=0;aa=m+16|0;$=m+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[m+40>>2]|0;c=0;do{f[aa+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[$>>2]|0))}$=f[m+44>>2]|0;if(($|0)!=(m+48|0))g0($);if(!(+L(+(+p[j>>3]-+p[k>>3]))<1.1920928955078125e-07)){f[l>>2]=1124007936;$=l+4|0;c=l+8|0;aa=l+40|0;C=$;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[aa>>2]=c;c=l+48|0;z=l+44|0;f[z>>2]=c;f[c>>2]=0;f[l+52>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;w=o+8|0;f[w>>2]=0;f[w+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[q+28>>2]=0;q_(m,o,d,d,d,d,h,q);h=Y(ba,ba)|0;f[m>>2]=0;ba=m+4|0;f[ba>>2]=0;f[m+8>>2]=0;if(h>>>0>1073741823)mCc(m);w=h<<2;J=VDc(w)|0;f[m>>2]=J;O=J+(h<<2)|0;f[m+8>>2]=O;XIc(J|0,0,w|0)|0;f[ba>>2]=O;O=VDc(w)|0;XIc(O|0,0,w|0)|0;e=+p[k>>3];H=+p[j>>3];k=A<<12;w=k|2;h=w<<2;_=VDc(h)|0;XIc(_|0,0,h|0)|0;R=+(k|0)/(+(A|0)*(e-H));k=0;H=1.0;while(1){if(H>0.0){e=+(k|0)/R;G=+V(+(g*(e*e)));ca=G;da=G}else{ca=H;da=0.0}n[_+(k<<2)>>2]=da;k=k+1|0;if((k|0)==(w|0))break;else H=ca}w=0-d|0;if((d|0)<(w|0))ea=0;else{ca=+(d|0);k=(f[c>>2]|0)>>>2;h=0;I=w;while(1){H=+(I|0);da=H*H;B=Y(I,k)|0;r=w;P=h;while(1){H=+(r|0);g=+M(+(da+H*H));if((r|I|0)==0|g>ca)fa=P;else{N=(Y(r,A)|0)+B|0;H=+V(+(F*(g*g)));n[J+(P<<2)>>2]=H;f[O+(P<<2)>>2]=N;fa=P+1|0}if((r|0)<(d|0)){r=r+1|0;P=fa}else break}if((I|0)<(d|0)){h=fa;I=I+1|0}else{ea=fa;break}}}f[o>>2]=57720;f[o+4>>2]=A;f[o+8>>2]=d;f[o+12>>2]=ea;f[o+16>>2]=O;f[o+20>>2]=l;f[o+24>>2]=t;n[o+28>>2]=R;f[o+32>>2]=J;f[o+36>>2]=_;f[q>>2]=0;f[q+4>>2]=v;v=f[t+4>>2]|0;if((v|0)<3)ga=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{J=f[t+40>>2]|0;ea=0;d=1;while(1){A=Y(f[J+(ea<<2)>>2]|0,d)|0;ea=ea+1|0;if((ea|0)==(v|0)){ga=A;break}else d=A}}y8(q,o,+(ga>>>0)*.0000152587890625);YDc(_);YDc(O);O=f[m>>2]|0;if(O|0){m=f[ba>>2]|0;if((m|0)!=(O|0))f[ba>>2]=m+(~((m+-4-O|0)>>>2)<<2);YDc(O)}O=l+36|0;m=f[O>>2]|0;if(m|0?(ba=m+12|0,m=f[ba>>2]|0,f[ba>>2]=m+-1,(m|0)==1):0)_S(l);f[O>>2]=0;O=l+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[$>>2]|0)>0){O=f[aa>>2]|0;aa=0;do{f[O+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[$>>2]|0))}$=f[z>>2]|0;if(($|0)!=(c|0))g0($)}else{$=l+8|0;f[$>>2]=0;f[$+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=t;h_(s,l)}break}default:{f[j>>2]=0;f[j+4>>2]=0;C=tT(j,61)|0;D=268817;E=C+61|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));Hna(-210,j,268879,1365)}}j=t+36|0;D=f[j>>2]|0;if(D|0?(C=D+12|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)_S(t);f[j>>2]=0;j=t+16|0;D=t+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[D>>2]|0)>0){j=f[t+40>>2]|0;C=0;do{f[j+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[D>>2]|0))}D=f[t+44>>2]|0;if((D|0)!=(t+48|0))g0(D);D=s+36|0;t=f[D>>2]|0;if(t|0?(C=t+12|0,t=f[C>>2]|0,f[C>>2]=t+-1,(t|0)==1):0)_S(s);f[D>>2]=0;D=s+16|0;t=s+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[t>>2]|0)>0){D=f[s+40>>2]|0;C=0;do{f[D+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)==(s+48|0)){u=i;return}g0(t);u=i;return}function Hna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,268972,d);return}function Ina(a){a=a|0;YDc(a);return}function Jna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0.0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0.0,Qa=0,Ra=0.0;d=u;u=u+1072|0;e=d;g=a+24|0;h=f[g>>2]|0;i=f[(f[h+40>>2]|0)+4>>2]|0;j=f[c>>2]|0;k=c+4|0;if((j|0)>=(f[k>>2]|0)){u=d;return}c=a+20|0;l=a+8|0;m=a+4|0;o=i+15|0;p=o&-16;q=o+p|0;r=e+8|0;t=e+4|0;v=q>>>0>264;w=q>>>0>1073741823?-1:q<<2;x=a+12|0;y=a+16|0;z=(i|0)>0;A=a+28|0;B=a+32|0;C=a+36|0;a=o+(p*3|0)|0;o=e+8|0;D=e+4|0;E=a>>>0>264;F=a>>>0>1073741823?-1:a<<2;G=q<<2;H=a<<2;I=j;j=h;a:while(1){h=f[c>>2]|0;J=f[l>>2]|0;K=(f[h+16>>2]|0)+(Y(f[f[h+44>>2]>>2]|0,J+I|0)|0)|0;h=f[m>>2]|0;M=K+((Y(h,J)|0)<<2)|0;J=(f[j+16>>2]|0)+(Y(f[f[j+44>>2]>>2]|0,I)|0)|0;switch(h|0){case 1:{f[e>>2]=r;f[t>>2]=q;if(v){h=XDc(w)|0;f[e>>2]=h;N=h}else N=r;XIc(N|0,0,G|0)|0;h=f[e>>2]|0;K=h+15&-16;O=K+(p<<2)|0;P=f[x>>2]|0;Q=h;if((P|0)<4)R=0;else{S=f[y>>2]|0;T=P+-4|0;U=((T|0)>3?T:3)&2147483644;V=0;do{W=M+(f[S+(V<<2)>>2]<<2)|0;X=V|1;Z=M+(f[S+(X<<2)>>2]<<2)|0;_=V|2;$=M+(f[S+(_<<2)>>2]<<2)|0;aa=V|3;ba=M+(f[S+(aa<<2)>>2]<<2)|0;if(z){ca=0;do{da=+n[M+(ca<<2)>>2];ea=+n[W+(ca<<2)>>2];fa=+L(+(ea-da));ga=+n[A>>2];ha=fa*ga;ia=~~ha;ja=ia-(+(ia|0)>ha&1)|0;fa=ha-+(ja|0);if(((n[s>>2]=ea,f[s>>2]|0)&2147483647)>>>0>2139095040)ka=ga;else{if(((n[s>>2]=da,f[s>>2]|0)&2147483647)>>>0>2139095040)la=1.0;else{ia=f[C>>2]|0;ga=+n[ia+(ja<<2)>>2];la=ga+fa*(+n[ia+(ja+1<<2)>>2]-ga)}ga=+n[(f[B>>2]|0)+(V<<2)>>2]*la;ja=O+(ca<<2)|0;n[ja>>2]=+n[ja>>2]+ga;ja=K+(ca<<2)|0;n[ja>>2]=ea*ga+ +n[ja>>2];ka=+n[A>>2]}ga=+n[Z+(ca<<2)>>2];ea=+L(+(ga-da))*ka;ja=~~ea;ia=ja-(+(ja|0)>ea&1)|0;fa=ea-+(ia|0);if(((n[s>>2]=ga,f[s>>2]|0)&2147483647)>>>0>2139095040)ma=ka;else{if(((n[s>>2]=da,f[s>>2]|0)&2147483647)>>>0>2139095040)na=1.0;else{ja=f[C>>2]|0;ea=+n[ja+(ia<<2)>>2];na=ea+fa*(+n[ja+(ia+1<<2)>>2]-ea)}ea=+n[(f[B>>2]|0)+(X<<2)>>2]*na;ia=O+(ca<<2)|0;n[ia>>2]=+n[ia>>2]+ea;ia=K+(ca<<2)|0;n[ia>>2]=ga*ea+ +n[ia>>2];ma=+n[A>>2]}ea=+n[$+(ca<<2)>>2];ga=+L(+(ea-da))*ma;ia=~~ga;ja=ia-(+(ia|0)>ga&1)|0;fa=ga-+(ja|0);if(((n[s>>2]=ea,f[s>>2]|0)&2147483647)>>>0>2139095040)oa=ma;else{if(((n[s>>2]=da,f[s>>2]|0)&2147483647)>>>0>2139095040)pa=1.0;else{ia=f[C>>2]|0;ga=+n[ia+(ja<<2)>>2];pa=ga+fa*(+n[ia+(ja+1<<2)>>2]-ga)}ga=+n[(f[B>>2]|0)+(_<<2)>>2]*pa;ja=O+(ca<<2)|0;n[ja>>2]=+n[ja>>2]+ga;ja=K+(ca<<2)|0;n[ja>>2]=ea*ga+ +n[ja>>2];oa=+n[A>>2]}ga=+n[ba+(ca<<2)>>2];ea=+L(+(ga-da))*oa;ja=~~ea;ia=ja-(+(ja|0)>ea&1)|0;fa=ea-+(ia|0);if(((n[s>>2]=ga,f[s>>2]|0)&2147483647)>>>0<=2139095040){if(((n[s>>2]=da,f[s>>2]|0)&2147483647)>>>0>2139095040)qa=1.0;else{ja=f[C>>2]|0;da=+n[ja+(ia<<2)>>2];qa=da+fa*(+n[ja+(ia+1<<2)>>2]-da)}da=+n[(f[B>>2]|0)+(aa<<2)>>2]*qa;ia=O+(ca<<2)|0;n[ia>>2]=+n[ia>>2]+da;ia=K+(ca<<2)|0;n[ia>>2]=ga*da+ +n[ia>>2]}ca=ca+1|0}while((ca|0)!=(i|0))}V=V+4|0}while((V|0)<=(T|0));R=U+4|0}if((R|0)<(P|0)){T=f[y>>2]|0;if(z){V=R;do{S=M+(f[T+(V<<2)>>2]<<2)|0;ca=0;do{da=+n[S+(ca<<2)>>2];ga=+n[M+(ca<<2)>>2];fa=+L(+(da-ga));ea=fa*+n[A>>2];aa=~~ea;ba=aa-(+(aa|0)>ea&1)|0;fa=ea-+(ba|0);if(((n[s>>2]=da,f[s>>2]|0)&2147483647)>>>0<=2139095040){if(((n[s>>2]=ga,f[s>>2]|0)&2147483647)>>>0>2139095040)ra=1.0;else{aa=f[C>>2]|0;ga=+n[aa+(ba<<2)>>2];ra=ga+fa*(+n[aa+(ba+1<<2)>>2]-ga)}ga=+n[(f[B>>2]|0)+(V<<2)>>2]*ra;ba=O+(ca<<2)|0;n[ba>>2]=+n[ba>>2]+ga;ba=K+(ca<<2)|0;n[ba>>2]=da*ga+ +n[ba>>2]}ca=ca+1|0}while((ca|0)!=(i|0));V=V+1|0}while((V|0)<(P|0));sa=37}}else sa=37;if((sa|0)==37?(sa=0,z):0){P=0;do{ga=+n[M+(P<<2)>>2];da=+n[K+(P<<2)>>2];fa=+n[O+(P<<2)>>2];if(((n[s>>2]=ga,f[s>>2]|0)&2147483647)>>>0>2139095040)ta=da/fa;else ta=(ga+da)/(fa+1.0);n[J+(P<<2)>>2]=ta;P=P+1|0}while((P|0)!=(i|0))}if((Q|0)!=(r|0)){if(h|0)ZDc(h);f[e>>2]=r;f[t>>2]=264}break}case 3:{f[e>>2]=o;f[D>>2]=a;if(E){P=XDc(F)|0;f[e>>2]=P;ua=P}else ua=o;XIc(ua|0,0,H|0)|0;P=f[e>>2]|0;O=P+15&-16;K=O+(p<<2)|0;V=K+(p<<2)|0;T=V+(p<<2)|0;U=f[x>>2]|0;ca=P;if((U|0)<4)va=0;else{S=f[y>>2]|0;ba=U+-4|0;aa=((ba|0)>3?ba:3)&2147483644;_=0;do{$=_|1;X=_|2;Z=_|3;if(z){W=M+(f[S+(_<<2)>>2]<<2)|0;ia=M+(f[S+($<<2)>>2]<<2)|0;ja=M+(f[S+(X<<2)>>2]<<2)|0;wa=M+(f[S+(Z<<2)>>2]<<2)|0;xa=M;ya=0;while(1){fa=+n[xa>>2];da=+n[xa+4>>2];ga=+n[xa+8>>2];if(((n[s>>2]=fa,f[s>>2]|0)&2147483647)>>>0>2139095040)za=1;else{Aa=(n[s>>2]=da,f[s>>2]|0)&2147483647;za=Aa>>>0>2139095040|((n[s>>2]=ga,f[s>>2]|0)&2147483647)>>>0>2139095040}ea=+n[W>>2];ha=+n[W+4>>2];Ba=+n[W+8>>2];if(((n[s>>2]=ea,f[s>>2]|0)&2147483647)>>>0>2139095040)Ca=1;else{Aa=(n[s>>2]=ha,f[s>>2]|0)&2147483647;Ca=Aa>>>0>2139095040|((n[s>>2]=Ba,f[s>>2]|0)&2147483647)>>>0>2139095040}Da=+L(+(ea-fa))+ +L(+(ha-da))+ +L(+(Ba-ga));Ea=Da*+n[A>>2];Aa=~~Ea;Fa=Aa-(+(Aa|0)>Ea&1)|0;Da=Ea-+(Fa|0);if(!Ca){if(za)Ga=1.0;else{Aa=f[C>>2]|0;Ea=+n[Aa+(Fa<<2)>>2];Ga=Ea+Da*(+n[Aa+(Fa+1<<2)>>2]-Ea)}Ea=+n[(f[B>>2]|0)+(_<<2)>>2]*Ga;Fa=T+(ya<<2)|0;n[Fa>>2]=+n[Fa>>2]+Ea;Fa=O+(ya<<2)|0;n[Fa>>2]=ea*Ea+ +n[Fa>>2];Fa=K+(ya<<2)|0;n[Fa>>2]=ha*Ea+ +n[Fa>>2];Fa=V+(ya<<2)|0;n[Fa>>2]=Ba*Ea+ +n[Fa>>2]}Ea=+n[ia>>2];Ba=+n[ia+4>>2];ha=+n[ia+8>>2];if(((n[s>>2]=Ea,f[s>>2]|0)&2147483647)>>>0>2139095040)Ha=1;else{Fa=(n[s>>2]=Ba,f[s>>2]|0)&2147483647;Ha=Fa>>>0>2139095040|((n[s>>2]=ha,f[s>>2]|0)&2147483647)>>>0>2139095040}ea=+L(+(Ea-fa))+ +L(+(Ba-da))+ +L(+(ha-ga));Da=ea*+n[A>>2];Fa=~~Da;Aa=Fa-(+(Fa|0)>Da&1)|0;ea=Da-+(Aa|0);if(!Ha){if(za)Ia=1.0;else{Fa=f[C>>2]|0;Da=+n[Fa+(Aa<<2)>>2];Ia=Da+ea*(+n[Fa+(Aa+1<<2)>>2]-Da)}Da=+n[(f[B>>2]|0)+($<<2)>>2]*Ia;Aa=T+(ya<<2)|0;n[Aa>>2]=+n[Aa>>2]+Da;Aa=O+(ya<<2)|0;n[Aa>>2]=Ea*Da+ +n[Aa>>2];Aa=K+(ya<<2)|0;n[Aa>>2]=Ba*Da+ +n[Aa>>2];Aa=V+(ya<<2)|0;n[Aa>>2]=ha*Da+ +n[Aa>>2]}Da=+n[ja>>2];ha=+n[ja+4>>2];Ba=+n[ja+8>>2];if(((n[s>>2]=Da,f[s>>2]|0)&2147483647)>>>0>2139095040)Ja=1;else{Aa=(n[s>>2]=ha,f[s>>2]|0)&2147483647;Ja=Aa>>>0>2139095040|((n[s>>2]=Ba,f[s>>2]|0)&2147483647)>>>0>2139095040}Ea=+L(+(Da-fa))+ +L(+(ha-da))+ +L(+(Ba-ga));ea=Ea*+n[A>>2];Aa=~~ea;Fa=Aa-(+(Aa|0)>ea&1)|0;Ea=ea-+(Fa|0);if(!Ja){if(za)Ka=1.0;else{Aa=f[C>>2]|0;ea=+n[Aa+(Fa<<2)>>2];Ka=ea+Ea*(+n[Aa+(Fa+1<<2)>>2]-ea)}ea=+n[(f[B>>2]|0)+(X<<2)>>2]*Ka;Fa=T+(ya<<2)|0;n[Fa>>2]=+n[Fa>>2]+ea;Fa=O+(ya<<2)|0;n[Fa>>2]=Da*ea+ +n[Fa>>2];Fa=K+(ya<<2)|0;n[Fa>>2]=ha*ea+ +n[Fa>>2];Fa=V+(ya<<2)|0;n[Fa>>2]=Ba*ea+ +n[Fa>>2]}ea=+n[wa>>2];Ba=+n[wa+4>>2];ha=+n[wa+8>>2];if(((n[s>>2]=ea,f[s>>2]|0)&2147483647)>>>0>2139095040)La=1;else{Fa=(n[s>>2]=Ba,f[s>>2]|0)&2147483647;La=Fa>>>0>2139095040|((n[s>>2]=ha,f[s>>2]|0)&2147483647)>>>0>2139095040}Da=+L(+(ea-fa))+ +L(+(Ba-da))+ +L(+(ha-ga));ga=Da*+n[A>>2];Fa=~~ga;Aa=Fa-(+(Fa|0)>ga&1)|0;Da=ga-+(Aa|0);if(!La){if(za)Ma=1.0;else{Fa=f[C>>2]|0;ga=+n[Fa+(Aa<<2)>>2];Ma=ga+Da*(+n[Fa+(Aa+1<<2)>>2]-ga)}ga=+n[(f[B>>2]|0)+(Z<<2)>>2]*Ma;Aa=T+(ya<<2)|0;n[Aa>>2]=+n[Aa>>2]+ga;Aa=O+(ya<<2)|0;n[Aa>>2]=ea*ga+ +n[Aa>>2];Aa=K+(ya<<2)|0;n[Aa>>2]=Ba*ga+ +n[Aa>>2];Aa=V+(ya<<2)|0;n[Aa>>2]=ha*ga+ +n[Aa>>2]}ya=ya+1|0;if((ya|0)==(i|0))break;else{W=W+12|0;ia=ia+12|0;ja=ja+12|0;wa=wa+12|0;xa=xa+12|0}}}_=_+4|0}while((_|0)<=(ba|0));va=aa+4|0}if((va|0)<(U|0)){ba=f[y>>2]|0;if(z){_=va;do{S=M;h=M+(f[ba+(_<<2)>>2]<<2)|0;Q=0;while(1){ga=+n[h>>2];ha=+n[h+4>>2];Ba=+n[h+8>>2];if(((n[s>>2]=ga,f[s>>2]|0)&2147483647)>>>0>2139095040)Na=1;else{xa=(n[s>>2]=ha,f[s>>2]|0)&2147483647;Na=xa>>>0>2139095040|((n[s>>2]=Ba,f[s>>2]|0)&2147483647)>>>0>2139095040}ea=+n[S>>2];Da=+n[S+4>>2];da=+n[S+8>>2];if(((n[s>>2]=ea,f[s>>2]|0)&2147483647)>>>0>2139095040)Oa=1;else{xa=(n[s>>2]=Da,f[s>>2]|0)&2147483647;Oa=xa>>>0>2139095040|((n[s>>2]=da,f[s>>2]|0)&2147483647)>>>0>2139095040}fa=+L(+(ga-ea))+ +L(+(ha-Da))+ +L(+(Ba-da));da=fa*+n[A>>2];xa=~~da;wa=xa-(+(xa|0)>da&1)|0;fa=da-+(wa|0);if(!Na){if(Oa)Pa=1.0;else{xa=f[C>>2]|0;da=+n[xa+(wa<<2)>>2];Pa=da+fa*(+n[xa+(wa+1<<2)>>2]-da)}da=+n[(f[B>>2]|0)+(_<<2)>>2]*Pa;wa=T+(Q<<2)|0;n[wa>>2]=+n[wa>>2]+da;wa=O+(Q<<2)|0;n[wa>>2]=ga*da+ +n[wa>>2];wa=K+(Q<<2)|0;n[wa>>2]=ha*da+ +n[wa>>2];wa=V+(Q<<2)|0;n[wa>>2]=Ba*da+ +n[wa>>2]}Q=Q+1|0;if((Q|0)==(i|0))break;else{S=S+12|0;h=h+12|0}}_=_+1|0}while((_|0)<(U|0));sa=96}}else sa=96;if((sa|0)==96?(sa=0,z):0){U=M;_=J;ba=0;while(1){da=+n[U>>2];Ba=+n[U+4>>2];ha=+n[U+8>>2];U=U+12|0;if((((n[s>>2]=da,f[s>>2]|0)&2147483647)>>>0<=2139095040?((n[s>>2]=Ba,f[s>>2]|0)&2147483647)>>>0<=2139095040:0)?((n[s>>2]=ha,f[s>>2]|0)&2147483647)>>>0<=2139095040:0){aa=T+(ba<<2)|0;ga=1.0/(+n[aa>>2]+1.0);n[aa>>2]=ga;n[_>>2]=ga*(da+ +n[O+(ba<<2)>>2]);n[_+4>>2]=(Ba+ +n[K+(ba<<2)>>2])*+n[aa>>2];Qa=aa;Ra=ha+ +n[V+(ba<<2)>>2]}else{aa=T+(ba<<2)|0;ha=1.0/+n[aa>>2];n[aa>>2]=ha;n[_>>2]=ha*+n[O+(ba<<2)>>2];n[_+4>>2]=+n[K+(ba<<2)>>2]*+n[aa>>2];Qa=aa;Ra=+n[V+(ba<<2)>>2]}n[_+8>>2]=Ra*+n[Qa>>2];ba=ba+1|0;if((ba|0)==(i|0))break;else _=_+12|0}}if((ca|0)!=(o|0)){if(P|0)ZDc(P);f[e>>2]=o;f[D>>2]=264}break}default:{sa=47;break a}}_=I+1|0;if((_|0)>=(f[k>>2]|0)){sa=110;break}I=_;j=f[g>>2]|0}if((sa|0)==47){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,7)|0;b[g>>0]=b[268895]|0;b[g+1>>0]=b[268896]|0;b[g+2>>0]=b[268897]|0;b[g+3>>0]=b[268898]|0;b[g+4>>0]=b[268899]|0;b[g+5>>0]=b[268900]|0;b[g+6>>0]=b[268901]|0;Hna(-215,e,518189,900)}else if((sa|0)==110){u=d;return}}function Kna(a){a=a|0;YDc(a);return}function Lna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;d=u;u=u+1072|0;e=d;g=a+8|0;i=f[g>>2]|0;j=(f[i>>2]|0)>>>3&511;k=j+1|0;l=f[(f[i+40>>2]|0)+4>>2]|0;m=f[c>>2]|0;o=c+4|0;if((m|0)>=(f[o>>2]|0)){u=d;return}c=a+4|0;p=a+12|0;q=(j|0)==0;j=l+15|0;r=j&-16;s=j+r|0;t=e+8|0;v=e+4|0;w=s>>>0>264;x=s>>>0>1073741823?-1:s<<2;y=a+16|0;z=a+20|0;A=(l|0)>0;B=a+24|0;C=a+28|0;a=j+(r*3|0)|0;j=e+8|0;D=e+4|0;E=a>>>0>264;F=a>>>0>1073741823?-1:a<<2;G=s<<2;H=a<<2;I=m;m=i;while(1){i=f[c>>2]|0;J=f[p>>2]|0;K=(f[i+16>>2]|0)+(Y(f[f[i+44>>2]>>2]|0,J+I|0)|0)+(Y(J,k)|0)|0;J=(f[m+16>>2]|0)+(Y(f[f[m+44>>2]>>2]|0,I)|0)|0;if(q){f[e>>2]=t;f[v>>2]=s;if(w){i=XDc(x)|0;f[e>>2]=i;L=i}else L=t;XIc(L|0,0,G|0)|0;i=f[e>>2]|0;M=i+15&-16;N=M+(r<<2)|0;O=f[y>>2]|0;P=i;if((O|0)<4)Q=0;else{i=f[z>>2]|0;R=O+-4|0;S=0;while(1){T=K+(f[i+(S<<2)>>2]|0)|0;U=S|1;V=K+(f[i+(U<<2)>>2]|0)|0;W=S|2;X=K+(f[i+(W<<2)>>2]|0)|0;Z=S|3;_=K+(f[i+(Z<<2)>>2]|0)|0;if(A){$=f[B>>2]|0;aa=f[C>>2]|0;ba=$+(S<<2)|0;ca=$+(U<<2)|0;U=$+(W<<2)|0;W=$+(Z<<2)|0;Z=0;do{$=h[K+Z>>0]|0;da=b[T+Z>>0]|0;ea=(da&255)-$|0;fa=+n[ba>>2]*+n[aa+(((ea|0)>-1?ea:0-ea|0)<<2)>>2];ea=N+(Z<<2)|0;n[ea>>2]=+n[ea>>2]+fa;ga=M+(Z<<2)|0;n[ga>>2]=+(da&255)*fa+ +n[ga>>2];da=b[V+Z>>0]|0;ha=(da&255)-$|0;fa=+n[ca>>2]*+n[aa+(((ha|0)>-1?ha:0-ha|0)<<2)>>2];n[ea>>2]=+n[ea>>2]+fa;n[ga>>2]=+(da&255)*fa+ +n[ga>>2];da=b[X+Z>>0]|0;ha=(da&255)-$|0;fa=+n[U>>2]*+n[aa+(((ha|0)>-1?ha:0-ha|0)<<2)>>2];n[ea>>2]=+n[ea>>2]+fa;n[ga>>2]=+(da&255)*fa+ +n[ga>>2];da=b[_+Z>>0]|0;ha=(da&255)-$|0;fa=+n[W>>2]*+n[aa+(((ha|0)>-1?ha:0-ha|0)<<2)>>2];n[ea>>2]=+n[ea>>2]+fa;n[ga>>2]=+(da&255)*fa+ +n[ga>>2];Z=Z+1|0}while((Z|0)!=(l|0))}Z=S+4|0;if((Z|0)>(R|0)){Q=Z;break}else S=Z}}a:do if((Q|0)<(O|0)){if(!A){S=Q;while(1){S=S+1|0;if((S|0)>=(O|0))break a}}S=f[z>>2]|0;R=f[B>>2]|0;i=f[C>>2]|0;Z=Q;do{aa=K+(f[S+(Z<<2)>>2]|0)|0;W=R+(Z<<2)|0;_=0;do{U=b[aa+_>>0]|0;X=(U&255)-(h[K+_>>0]|0)|0;fa=+n[W>>2]*+n[i+(((X|0)>-1?X:0-X|0)<<2)>>2];X=N+(_<<2)|0;n[X>>2]=+n[X>>2]+fa;X=M+(_<<2)|0;n[X>>2]=+(U&255)*fa+ +n[X>>2];_=_+1|0}while((_|0)!=(l|0));Z=Z+1|0}while((Z|0)<(O|0))}while(0);if(A){O=0;do{Z=(mrc(+n[M+(O<<2)>>2]/+n[N+(O<<2)>>2])|0)&255;b[J+O>>0]=Z;O=O+1|0}while((O|0)!=(l|0));ia=f[e>>2]|0}else ia=P;if((ia|0)!=(t|0)){if(ia|0)ZDc(ia);f[e>>2]=t;f[v>>2]=264}}else{f[e>>2]=j;f[D>>2]=a;if(E){O=XDc(F)|0;f[e>>2]=O;ja=O}else ja=j;XIc(ja|0,0,H|0)|0;O=(f[e>>2]|0)+15&-16;N=O+(r<<2)|0;M=N+(r<<2)|0;Z=M+(r<<2)|0;i=f[y>>2]|0;if((i|0)<4){ka=0;la=i}else{R=0;S=i;while(1){i=f[z>>2]|0;_=R|1;W=R|2;aa=R|3;if(A){X=K+(f[i+(R<<2)>>2]|0)|0;U=K+(f[i+(_<<2)>>2]|0)|0;ca=K+(f[i+(W<<2)>>2]|0)|0;V=K+(f[i+(aa<<2)>>2]|0)|0;i=K;ba=0;T=f[B>>2]|0;ga=f[C>>2]|0;while(1){da=h[i>>0]|0;ea=h[i+1>>0]|0;ha=h[i+2>>0]|0;$=b[X>>0]|0;ma=b[X+1>>0]|0;na=b[X+2>>0]|0;oa=($&255)-da|0;pa=(ma&255)-ea|0;qa=(na&255)-ha|0;fa=+n[T+(R<<2)>>2]*+n[ga+(((pa|0)>-1?pa:0-pa|0)+((oa|0)>-1?oa:0-oa|0)+((qa|0)>-1?qa:0-qa|0)<<2)>>2];qa=Z+(ba<<2)|0;n[qa>>2]=+n[qa>>2]+fa;oa=O+(ba<<2)|0;n[oa>>2]=+($&255)*fa+ +n[oa>>2];$=N+(ba<<2)|0;n[$>>2]=+(ma&255)*fa+ +n[$>>2];ma=M+(ba<<2)|0;n[ma>>2]=+(na&255)*fa+ +n[ma>>2];na=b[U>>0]|0;pa=b[U+1>>0]|0;ra=b[U+2>>0]|0;sa=(na&255)-da|0;ta=(pa&255)-ea|0;ua=(ra&255)-ha|0;fa=+n[T+(_<<2)>>2]*+n[ga+(((ta|0)>-1?ta:0-ta|0)+((sa|0)>-1?sa:0-sa|0)+((ua|0)>-1?ua:0-ua|0)<<2)>>2];n[qa>>2]=+n[qa>>2]+fa;n[oa>>2]=+(na&255)*fa+ +n[oa>>2];n[$>>2]=+(pa&255)*fa+ +n[$>>2];n[ma>>2]=+(ra&255)*fa+ +n[ma>>2];ra=b[ca>>0]|0;pa=b[ca+1>>0]|0;na=b[ca+2>>0]|0;T=f[B>>2]|0;ga=f[C>>2]|0;ua=(ra&255)-da|0;sa=(pa&255)-ea|0;ta=(na&255)-ha|0;fa=+n[T+(W<<2)>>2]*+n[ga+(((sa|0)>-1?sa:0-sa|0)+((ua|0)>-1?ua:0-ua|0)+((ta|0)>-1?ta:0-ta|0)<<2)>>2];n[qa>>2]=+n[qa>>2]+fa;n[oa>>2]=+(ra&255)*fa+ +n[oa>>2];n[$>>2]=+(pa&255)*fa+ +n[$>>2];n[ma>>2]=+(na&255)*fa+ +n[ma>>2];na=b[V>>0]|0;pa=b[V+1>>0]|0;ra=b[V+2>>0]|0;ta=(na&255)-da|0;da=(pa&255)-ea|0;ea=(ra&255)-ha|0;fa=+n[T+(aa<<2)>>2]*+n[ga+(((da|0)>-1?da:0-da|0)+((ta|0)>-1?ta:0-ta|0)+((ea|0)>-1?ea:0-ea|0)<<2)>>2];n[qa>>2]=+n[qa>>2]+fa;n[oa>>2]=+(na&255)*fa+ +n[oa>>2];n[$>>2]=+(pa&255)*fa+ +n[$>>2];n[ma>>2]=+(ra&255)*fa+ +n[ma>>2];ba=ba+1|0;if((ba|0)==(l|0))break;else{X=X+3|0;U=U+3|0;ca=ca+3|0;V=V+3|0;i=i+3|0}}va=f[y>>2]|0}else va=S;i=R+4|0;if((i|0)>(va+-4|0)){ka=i;la=va;break}else{R=i;S=va}}}b:do if((ka|0)<(la|0)){if(!A){S=ka;while(1){S=S+1|0;if((S|0)>=(la|0))break b}}S=f[z>>2]|0;R=f[B>>2]|0;P=f[C>>2]|0;i=ka;do{V=R+(i<<2)|0;ca=K;U=K+(f[S+(i<<2)>>2]|0)|0;X=0;while(1){ba=b[U>>0]|0;ga=b[U+1>>0]|0;aa=b[U+2>>0]|0;T=(ba&255)-(h[ca>>0]|0)|0;W=(ga&255)-(h[ca+1>>0]|0)|0;_=(aa&255)-(h[ca+2>>0]|0)|0;fa=+n[V>>2]*+n[P+(((W|0)>-1?W:0-W|0)+((T|0)>-1?T:0-T|0)+((_|0)>-1?_:0-_|0)<<2)>>2];_=Z+(X<<2)|0;n[_>>2]=+n[_>>2]+fa;_=O+(X<<2)|0;n[_>>2]=+(ba&255)*fa+ +n[_>>2];_=N+(X<<2)|0;n[_>>2]=+(ga&255)*fa+ +n[_>>2];_=M+(X<<2)|0;n[_>>2]=+(aa&255)*fa+ +n[_>>2];X=X+1|0;if((X|0)==(l|0))break;else{ca=ca+3|0;U=U+3|0}}i=i+1|0}while((i|0)<(la|0))}while(0);if(A){K=J;i=0;while(1){P=Z+(i<<2)|0;fa=1.0/+n[P>>2];n[P>>2]=fa;S=(mrc(fa*+n[O+(i<<2)>>2])|0)&255;b[K>>0]=S;S=(mrc(+n[N+(i<<2)>>2]*+n[P>>2])|0)&255;b[K+1>>0]=S;S=(mrc(+n[M+(i<<2)>>2]*+n[P>>2])|0)&255;b[K+2>>0]=S;i=i+1|0;if((i|0)==(l|0))break;else K=K+3|0}}K=f[e>>2]|0;if((K|0)!=(j|0)){if(K|0)ZDc(K);f[e>>2]=j;f[D>>2]=264}}K=I+1|0;if((K|0)>=(f[o>>2]|0))break;I=K;m=f[g>>2]|0}u=d;return}function Mna(a,c,d,e,g,h){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;i=u;u=u+336|0;j=i+320|0;k=i+256|0;l=i+312|0;m=i+192|0;n=i+136|0;o=i+248|0;p=i+80|0;q=i+56|0;r=i+48|0;s=i;if(p$(a,-1)|0){f[j>>2]=0;f[j+4>>2]=0;t=tT(j,21)|0;v=269050;w=t+21|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,j,269072,269078,947)}b$(j,a,-1);x=c+4|0;y=a+4|0;if((f[x>>2]|0)==(f[y>>2]|0)?c$(a,-1)|0:0){f[k>>2]=0;f[k+4>>2]=0;t=tT(k,100)|0;v=269145;w=t+100|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,k,269072,269078,952)}f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];v$(c,l,0,-1,0,0);l=(g|0)<0&(h^1);j=l|h;h=l?g&2147483647:g;if(!(h&1)){f[k>>2]=0;z=k+4|0;f[z>>2]=0;A=tT(k,43)|0;t=A;v=269246;w=t+43|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-206,k,269072,269078,964)}switch(h|0){case 7:{B=d*.0625;C=e*.0625;break}case -1:case 6:case 5:case 4:case 3:{B=d;C=e;break}default:{f[k>>2]=0;z=k+4|0;f[z>>2]=0;A=tT(k,43)|0;t=A;v=269246;w=t+43|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-206,k,269072,269078,964)}}v=B>C;e=v?B:C;d=v?C:B;do if((d$(a)|0)==65536){v=f[y>>2]|0;f[k>>2]=f[v>>2];A=k+4|0;z=v+4|0;f[A>>2]=f[z>>2];g=k+8|0;f[g>>2]=f[v+8>>2];f[k+12>>2]=f[v+12>>2];f[k+16>>2]=f[v+16>>2];f[k+20>>2]=f[v+20>>2];f[k+24>>2]=f[v+24>>2];f[k+28>>2]=f[v+28>>2];f[k+32>>2]=f[v+32>>2];l=f[v+36>>2]|0;f[k+36>>2]=l;f[k+40>>2]=g;g=k+48|0;D=k+44|0;f[D>>2]=g;f[g>>2]=0;f[k+52>>2]=0;if(l|0){g=l+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[z>>2]|0)<3){z=f[v+44>>2]|0;g=f[D>>2]|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];break}else{f[A>>2]=0;ZS(k,v);break}}else a$(k,a,-1);while(0);do if((d$(c)|0)==65536){a=f[x>>2]|0;f[m>>2]=f[a>>2];y=m+4|0;v=a+4|0;f[y>>2]=f[v>>2];A=m+8|0;f[A>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];z=f[a+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=A;A=m+48|0;g=m+44|0;f[g>>2]=A;f[A>>2]=0;f[m+52>>2]=0;if(z|0){A=z+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[v>>2]|0)<3){v=f[a+44>>2]|0;A=f[g>>2]|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];break}else{f[y>>2]=0;ZS(m,a);break}}else a$(m,c,-1);while(0);c=k+40|0;x=f[c>>2]|0;a=f[x>>2]|0;f[o>>2]=f[x+4>>2];f[o+4>>2]=a;a=k+16|0;x=k+48|0;CY(n,o,f[k>>2]&4095,f[a>>2]|0,f[x>>2]|0);o=n+16|0;y=m+16|0;v=n+12|0;A=n+8|0;if(j){B=d<32767.0?d:32767.0;C=e<32767.0?e:32767.0;E=B>0.0?B*B:B;if(C>0.0){F=C*C;G=E}else{F=C;G=E}}else{F=e;G=d}g=~~G;z=g-(+(g|0)>G&1)|0;g=~~F;D=g-(+(g|0)>F&1)|0;g=z8()|0;l=A8()|0;H=(l|0)<(g|0)?l:g;g=(H|0)>1?H:1;H=f[A>>2]|0;l=(h|0)<0?4:(((h|0)/2|0)<<1)+2|0;if(((H|0)/(g|0)|0|0)<(l|0)){I=(H|0)/(l|0)|0;J=(I|0)>1?I:1}else J=g;f[p>>2]=1124007936;g=p+4|0;I=p+8|0;l=p+40|0;t=g;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[l>>2]=I;I=p+48|0;t=p+44|0;f[t>>2]=I;f[I>>2]=0;f[p+52>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[r>>2]=0;f[r+4>>2]=H;Nna(s,n,p,q,z,D,h,j);y8(r,s,+(J|0));f[s>>2]=57740;l6(s+44|0);J=f[p+12>>2]|0;j=q+20|0;h=f[j>>2]|0;if(h|0){D=q+16|0;z=q+4|0;H=q+8|0;w=0-J|0;K=~J;L=1-J|0;M=J+-1|0;N=J+1|0;O=h;while(1){h=f[D>>2]|0;P=O+-1|0;Q=h+P|0;R=f[z>>2]|0;S=f[(f[R+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]|0;f[j>>2]=P;P=f[H>>2]|0;Q=P-R|0;if((1-O-h+((Q|0)==0?0:(Q<<8)+-1|0)|0)>>>0>2047){YDc(f[P+-4>>2]|0);f[H>>2]=(f[H>>2]|0)+-4}P=S+w|0;if(!(b[S+K>>0]|0)){Q=P+-1|0;b[Q>>0]=2;h=f[z>>2]|0;R=(f[H>>2]|0)-h|0;T=f[D>>2]|0;U=f[j>>2]|0;if((((R|0)==0?0:(R<<8)+-1|0)|0)==(U+T|0)){Ona(q);V=f[D>>2]|0;W=f[j>>2]|0;X=f[z>>2]|0}else{V=T;W=U;X=h}h=W+V|0;f[(f[X+(h>>>10<<2)>>2]|0)+((h&1023)<<2)>>2]=Q;f[j>>2]=W+1}if(!(b[P>>0]|0)){b[P>>0]=2;Q=f[z>>2]|0;h=(f[H>>2]|0)-Q|0;U=f[D>>2]|0;T=f[j>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(T+U|0)){Ona(q);Z=f[D>>2]|0;_=f[j>>2]|0;$=f[z>>2]|0}else{Z=U;_=T;$=Q}Q=_+Z|0;f[(f[$+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=_+1}if(!(b[S+L>>0]|0)){P=S+w+1|0;b[P>>0]=2;Q=f[z>>2]|0;T=(f[H>>2]|0)-Q|0;U=f[D>>2]|0;h=f[j>>2]|0;if((((T|0)==0?0:(T<<8)+-1|0)|0)==(h+U|0)){Ona(q);aa=f[D>>2]|0;ba=f[j>>2]|0;ca=f[z>>2]|0}else{aa=U;ba=h;ca=Q}Q=ba+aa|0;f[(f[ca+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=ba+1}P=S+-1|0;if(!(b[P>>0]|0)){b[P>>0]=2;Q=f[z>>2]|0;h=(f[H>>2]|0)-Q|0;U=f[D>>2]|0;T=f[j>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(T+U|0)){Ona(q);da=f[D>>2]|0;ea=f[j>>2]|0;fa=f[z>>2]|0}else{da=U;ea=T;fa=Q}Q=ea+da|0;f[(f[fa+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=ea+1}P=S+1|0;if(!(b[P>>0]|0)){b[P>>0]=2;Q=f[z>>2]|0;T=(f[H>>2]|0)-Q|0;U=f[D>>2]|0;h=f[j>>2]|0;if((((T|0)==0?0:(T<<8)+-1|0)|0)==(h+U|0)){Ona(q);ga=f[D>>2]|0;ha=f[j>>2]|0;ia=f[z>>2]|0}else{ga=U;ha=h;ia=Q}Q=ha+ga|0;f[(f[ia+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=ha+1}P=S+J|0;if(!(b[S+M>>0]|0)){Q=P+-1|0;b[Q>>0]=2;h=f[z>>2]|0;U=(f[H>>2]|0)-h|0;T=f[D>>2]|0;R=f[j>>2]|0;if((((U|0)==0?0:(U<<8)+-1|0)|0)==(R+T|0)){Ona(q);ja=f[D>>2]|0;ka=f[j>>2]|0;la=f[z>>2]|0}else{ja=T;ka=R;la=h}h=ka+ja|0;f[(f[la+(h>>>10<<2)>>2]|0)+((h&1023)<<2)>>2]=Q;f[j>>2]=ka+1}if(!(b[P>>0]|0)){b[P>>0]=2;Q=f[z>>2]|0;h=(f[H>>2]|0)-Q|0;R=f[D>>2]|0;T=f[j>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(T+R|0)){Ona(q);ma=f[D>>2]|0;na=f[j>>2]|0;oa=f[z>>2]|0}else{ma=R;na=T;oa=Q}Q=na+ma|0;f[(f[oa+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=na+1}if(!(b[S+N>>0]|0)){P=S+J+1|0;b[P>>0]=2;S=f[z>>2]|0;Q=(f[H>>2]|0)-S|0;T=f[D>>2]|0;R=f[j>>2]|0;if((((Q|0)==0?0:(Q<<8)+-1|0)|0)==(R+T|0)){Ona(q);pa=f[D>>2]|0;qa=f[j>>2]|0;ra=f[z>>2]|0}else{pa=T;qa=R;ra=S}S=qa+pa|0;f[(f[ra+(S>>>10<<2)>>2]|0)+((S&1023)<<2)>>2]=P;P=qa+1|0;f[j>>2]=P;sa=P}else sa=f[j>>2]|0;if(!sa)break;else O=sa}}sa=f[A>>2]|0;f[r>>2]=0;f[r+4>>2]=sa;f[s>>2]=57760;f[s+4>>2]=p;f[s+8>>2]=m;A=n+4|0;O=f[A>>2]|0;if((O|0)<3)ta=Y(f[v>>2]|0,sa)|0;else{sa=f[n+40>>2]|0;v=0;j=1;while(1){qa=Y(f[sa+(v<<2)>>2]|0,j)|0;v=v+1|0;if((v|0)==(O|0)){ta=qa;break}else j=qa}}y8(r,s,+(ta>>>0)*.0000152587890625);Pna(q);q=p+36|0;ta=f[q>>2]|0;if(ta|0?(s=ta+12|0,ta=f[s>>2]|0,f[s>>2]=ta+-1,(ta|0)==1):0)_S(p);f[q>>2]=0;q=p+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[g>>2]|0)>0){q=f[l>>2]|0;l=0;do{f[q+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[t>>2]|0;if((g|0)!=(I|0))g0(g);g=n+36|0;I=f[g>>2]|0;if(I|0?(t=I+12|0,I=f[t>>2]|0,f[t>>2]=I+-1,(I|0)==1):0)_S(n);f[g>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[A>>2]|0)>0){o=f[n+40>>2]|0;g=0;do{f[o+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[A>>2]|0))}A=f[n+44>>2]|0;if((A|0)!=(n+48|0))g0(A);A=m+36|0;n=f[A>>2]|0;if(n|0?(g=n+12|0,n=f[g>>2]|0,f[g>>2]=n+-1,(n|0)==1):0)_S(m);f[A>>2]=0;A=m+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[A>>2]|0)>0){y=f[m+40>>2]|0;n=0;do{f[y+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[A>>2]|0))}A=f[m+44>>2]|0;if((A|0)!=(m+48|0))g0(A);A=k+36|0;m=f[A>>2]|0;do if(m|0){n=m+12|0;y=f[n>>2]|0;f[n>>2]=y+-1;if((y|0)!=1)break;_S(k)}while(0);f[A>>2]=0;A=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[A>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[A>>2]|0))}A=f[k+44>>2]|0;if((A|0)==(x|0)){u=i;return}g0(A);u=i;return}function Nna(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=u;u=u+144|0;l=k+120|0;m=k;n=k+64|0;o=k+8|0;f[a>>2]=57740;q=a+4|0;f[q>>2]=c;f[a+8>>2]=c;c=a+12|0;f[c>>2]=d;f[a+16>>2]=e;f[a+20>>2]=g;f[a+24>>2]=h;f[a+28>>2]=i;b[a+32>>0]=j&1;k6(a+44|0);j=f[q>>2]|0;i=(f[j+8>>2]|0)+2|0;h=(f[j+12>>2]|0)+2|0;j=d+4|0;if(!(((((f[j>>2]|0)<3?(f[d+8>>2]|0)==(i|0):0)?(f[d+12>>2]|0)==(h|0):0)?(f[d>>2]&4095|0)==0:0)?(f[d+16>>2]|0)!=0:0)){f[l>>2]=i;f[l+4>>2]=h;XS(d,2,l,0)}h=f[c>>2]|0;if((h|0)==(d|0))r=d;else{i=d+36|0;g=f[i>>2]|0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}e=h+36|0;g=f[e>>2]|0;if(g|0?(s=g+12|0,g=f[s>>2]|0,f[s>>2]=g+-1,(g|0)==1):0)_S(h);f[e>>2]=0;g=h+16|0;s=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[s>>2]|0)>0){t=f[h+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0;w=f[s>>2]|0}while((v|0)<(w|0));f[h>>2]=f[d>>2];if((w|0)<3)x=18;else x=20}else{f[h>>2]=f[d>>2];x=18}if((x|0)==18){w=f[j>>2]|0;if((w|0)<3){f[s>>2]=w;f[h+8>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];w=f[d+44>>2]|0;s=f[h+44>>2]|0;f[s>>2]=f[w>>2];f[s+4>>2]=f[w+4>>2]}else x=20}if((x|0)==20)ZS(h,d);f[g>>2]=f[d+16>>2];f[h+20>>2]=f[d+20>>2];f[h+24>>2]=f[d+24>>2];f[h+28>>2]=f[d+28>>2];f[h+32>>2]=f[d+32>>2];f[e>>2]=f[i>>2];r=f[c>>2]|0}f[l>>2]=0;f[l+4>>2]=1;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;$S(n,r,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;l_(n,l,e0()|0)|0;r=n+36|0;i=f[r>>2]|0;if(i|0?(e=i+12|0,i=f[e>>2]|0,f[e>>2]=i+-1,(i|0)==1):0)_S(n);f[r>>2]=0;r=n+16|0;i=n+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[i>>2]|0)>0){r=f[n+40>>2]|0;e=0;do{f[r+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))g0(i);i=f[c>>2]|0;n=f[(f[q>>2]|0)+8>>2]|0;f[l>>2]=n+1;f[l+4>>2]=n+2;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;$S(o,i,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;l_(o,l,e0()|0)|0;l=o+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)_S(o);f[l>>2]=0;l=o+16|0;m=o+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[o+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[o+44>>2]|0;if((m|0)==(o+48|0)){y=f[c>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=1;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}g0(m);y=f[c>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=1;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}function Ona(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;b=u;u=u+32|0;c=b;d=a+16|0;e=f[d>>2]|0;if(e>>>0>1023){f[d>>2]=e+-1024;e=a+4|0;d=f[e>>2]|0;g=f[d>>2]|0;h=d+4|0;f[e>>2]=h;d=a+8|0;i=f[d>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;m=i;do if((i|0)==(k|0)){n=f[a>>2]|0;o=n;if(h>>>0>n>>>0){p=h;q=((p-o>>2)+1|0)/-2|0;r=h+(q<<2)|0;s=m-p|0;p=s>>2;if(!p)t=h;else{fJc(r|0,h|0,s|0)|0;t=f[e>>2]|0}s=r+(p<<2)|0;f[d>>2]=s;f[e>>2]=t+(q<<2);v=s;break}s=l-o>>1;o=(s|0)==0?1:s;if(o>>>0>1073741823){s=af(8)|0;bEc(s,503977);f[s>>2]=185532;ig(s|0,23696,1627)}s=VDc(o<<2)|0;q=s;p=s+(o>>>2<<2)|0;r=p;w=s+(o<<2)|0;if((h|0)==(i|0)){x=r;y=n}else{n=p;p=r;o=h;do{f[n>>2]=f[o>>2];n=p+4|0;p=n;o=o+4|0}while((o|0)!=(i|0));x=p;y=f[a>>2]|0}f[a>>2]=q;f[e>>2]=r;f[d>>2]=x;f[j>>2]=w;if(!y)v=x;else{YDc(y);v=f[d>>2]|0}}else v=i;while(0);f[v>>2]=g;f[d>>2]=(f[d>>2]|0)+4;u=b;return}d=a+8|0;g=f[d>>2]|0;v=a+4|0;i=f[v>>2]|0;y=g-i|0;x=a+12|0;j=f[x>>2]|0;e=f[a>>2]|0;h=j-e|0;l=g;t=j;m=i;k=e;if(y>>>0>=h>>>0){o=h>>1;n=(o|0)==0?1:o;f[c+12>>2]=0;f[c+16>>2]=a+12;if(n>>>0>1073741823){o=af(8)|0;bEc(o,503977);f[o>>2]=185532;ig(o|0,23696,1627)}o=y>>2;s=VDc(n<<2)|0;f[c>>2]=s;z=s+(o<<2)|0;A=c+8|0;f[A>>2]=z;B=c+4|0;f[B>>2]=z;C=s+(n<<2)|0;D=c+12|0;f[D>>2]=C;E=s;F=VDc(4096)|0;G=C;C=z;do if((o|0)==(n|0)){if(z>>>0>s>>>0){H=z+((((C-E>>2)+1|0)/-2|0)<<2)|0;f[A>>2]=H;f[B>>2]=H;I=H;break}H=G-E>>1;J=(H|0)==0?1:H;if(J>>>0>1073741823){H=af(8)|0;bEc(H,503977);f[H>>2]=185532;ig(H|0,23696,1627)}else{H=VDc(J<<2)|0;K=H+(J>>>2<<2)|0;L=K;f[c>>2]=H;f[B>>2]=L;f[A>>2]=L;f[D>>2]=H+(J<<2);YDc(s);I=K;break}}else I=z;while(0);f[I>>2]=F;f[A>>2]=(f[A>>2]|0)+4;F=f[d>>2]|0;while(1){M=f[v>>2]|0;if((F|0)==(M|0))break;I=F+-4|0;Tna(c,I);F=I}I=M;M=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=M;f[v>>2]=f[B>>2];f[B>>2]=I;B=f[d>>2]|0;f[d>>2]=f[A>>2];f[A>>2]=B;z=f[x>>2]|0;f[x>>2]=f[D>>2];f[D>>2]=z;z=B;if((z|0)!=(F|0))f[A>>2]=z+(~((z+-4-I|0)>>>2)<<2);if(M|0)YDc(M);u=b;return}if((j|0)==(g|0)){j=VDc(4096)|0;f[c>>2]=j;Sna(a,c);c=f[v>>2]|0;j=f[c>>2]|0;M=c+4|0;f[v>>2]=M;c=f[d>>2]|0;I=f[x>>2]|0;z=I;A=c;do if((c|0)==(I|0)){F=f[a>>2]|0;B=F;if(M>>>0>F>>>0){D=M;s=((D-B>>2)+1|0)/-2|0;E=M+(s<<2)|0;G=A-D|0;D=G>>2;if(!D)N=M;else{fJc(E|0,M|0,G|0)|0;N=f[v>>2]|0}G=E+(D<<2)|0;f[d>>2]=G;f[v>>2]=N+(s<<2);O=G;break}G=z-B>>1;B=(G|0)==0?1:G;if(B>>>0>1073741823){G=af(8)|0;bEc(G,503977);f[G>>2]=185532;ig(G|0,23696,1627)}G=VDc(B<<2)|0;s=G;D=G+(B>>>2<<2)|0;E=D;C=G+(B<<2)|0;if((M|0)==(c|0)){P=E;Q=F}else{F=D;D=E;B=M;do{f[F>>2]=f[B>>2];F=D+4|0;D=F;B=B+4|0}while((B|0)!=(c|0));P=D;Q=f[a>>2]|0}f[a>>2]=s;f[v>>2]=E;f[d>>2]=P;f[x>>2]=C;if(!Q)O=P;else{YDc(Q);O=f[d>>2]|0}}else O=c;while(0);f[O>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}else{j=VDc(4096)|0;O=g;do if((l|0)==(t|0)){if(m>>>0>k>>>0){g=((i-e>>2)+1|0)/-2|0;c=m+(g<<2)|0;Q=y>>2;if(!Q)R=m;else{fJc(c|0,i|0,y|0)|0;R=f[v>>2]|0}P=c+(Q<<2)|0;f[d>>2]=P;f[v>>2]=R+(g<<2);S=P;break}P=h>>1;g=(P|0)==0?1:P;if(g>>>0>1073741823){P=af(8)|0;bEc(P,503977);f[P>>2]=185532;ig(P|0,23696,1627)}P=VDc(g<<2)|0;Q=P;c=P+(g>>>2<<2)|0;M=c;z=P+(g<<2)|0;if((m|0)==(l|0)){T=M;U=k}else{g=c;c=M;P=m;do{f[g>>2]=f[P>>2];g=c+4|0;c=g;P=P+4|0}while((P|0)!=(l|0));T=c;U=f[a>>2]|0}f[a>>2]=Q;f[v>>2]=M;f[d>>2]=T;f[x>>2]=z;if(!U)S=T;else{YDc(U);S=f[d>>2]|0}}else S=O;while(0);f[S>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}}function Pna(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=a+4|0;c=f[b>>2]|0;d=a+16|0;e=f[d>>2]|0;g=c+(e>>>10<<2)|0;h=a+8|0;i=f[h>>2]|0;j=i;k=c;if((i|0)==(c|0)){l=0;m=a+20|0;n=0}else{i=a+20|0;o=(f[i>>2]|0)+e|0;l=(f[c+(o>>>10<<2)>>2]|0)+((o&1023)<<2)|0;m=i;n=(f[g>>2]|0)+((e&1023)<<2)|0}e=g;g=n;a:while(1){n=g;do{i=n;if((i|0)==(l|0))break a;n=i+4|0}while((n-(f[e>>2]|0)|0)!=4096);n=e+4|0;e=n;g=f[n>>2]|0}f[m>>2]=0;m=j-k>>2;if(m>>>0>2){k=c;do{YDc(f[k>>2]|0);k=(f[b>>2]|0)+4|0;f[b>>2]=k;c=(f[h>>2]|0)-k>>2}while(c>>>0>2);p=c}else p=m;switch(p|0){case 1:{q=512;r=13;break}case 2:{q=1024;r=13;break}default:{}}if((r|0)==13)f[d>>2]=q;q=f[b>>2]|0;d=f[h>>2]|0;if((q|0)!=(d|0)){r=q;do{YDc(f[r>>2]|0);r=r+4|0}while((r|0)!=(d|0));d=f[b>>2]|0;b=f[h>>2]|0;if((b|0)!=(d|0))f[h>>2]=b+(~((b+-4-d|0)>>>2)<<2)}d=f[a>>2]|0;if(!d)return;YDc(d);return}function Qna(a){a=a|0;YDc(a);return}function Rna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;e=c+4|0;c=f[e>>2]|0;if((d|0)>=(c|0))return;g=a+8|0;i=a+4|0;a=d;d=f[g>>2]|0;j=c;while(1){c=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,a)|0)|0;k=f[i>>2]|0;a=a+1|0;l=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,a)|0)+1|0;if((f[d+12>>2]|0)>0){k=0;do{b[c+k>>0]=0-((h[l+k>>0]|0)>>>1);k=k+1|0;m=f[g>>2]|0}while((k|0)<(f[m+12>>2]|0));n=f[e>>2]|0;o=m}else{n=j;o=d}if((a|0)>=(n|0))break;else{d=o;j=n}}return}function Sna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{fJc(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;bEc(m,503977);f[m>>2]=185532;ig(m|0,23696,1627)}m=VDc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{YDc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function Tna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{fJc(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;bEc(m,503977);f[m>>2]=185532;ig(m|0,23696,1627)}m=VDc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{YDc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function Una(a){a=a|0;f[a>>2]=57740;l6(a+44|0);return}function Vna(a){a=a|0;f[a>>2]=57740;l6(a+44|0);YDc(a);return}function Wna(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0;e=u;u=u+3440|0;g=e+3416|0;h=e+3408|0;i=e+3352|0;j=e+3280|0;k=e+3216|0;l=e+2168|0;m=e+1120|0;n=e+1096|0;o=e+1072|0;p=e+8|0;q=e+3344|0;r=e+3336|0;s=e+3272|0;t=e;f[j>>2]=1124007936;v=j+4|0;w=j+8|0;x=j+40|0;y=v;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[x>>2]=w;A=j+48|0;B=j+44|0;f[B>>2]=A;f[A>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;C=k+4|0;D=k+8|0;E=k+40|0;y=C;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[E>>2]=D;y=k+48|0;z=k+44|0;f[z>>2]=y;f[y>>2]=0;f[k+52>>2]=0;F=l+8|0;f[l>>2]=F;G=l+4|0;f[G>>2]=0;H=m+8|0;f[m>>2]=H;I=m+4|0;f[I>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;J=f[c>>2]|0;K=J+-1|0;L=(K|0)>0?K:0;K=a+4|0;M=f[K>>2]|0;N=c+4|0;O=(f[N>>2]|0)+1|0;P=f[M+8>>2]|0;Q=(O|0)<(P|0)?O:P;if(!(b[a+33>>0]|0)){f[g>>2]=L;f[g+4>>2]=Q;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;$S(i,M,g,h);P=i+36|0;O=f[P>>2]|0;if(O|0){R=O+12|0;f[R>>2]=(f[R>>2]|0)+1}R=j+36|0;O=f[R>>2]|0;if(O|0?(S=O+12|0,O=f[S>>2]|0,f[S>>2]=O+-1,(O|0)==1):0)_S(j);f[R>>2]=0;O=j+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[v>>2]|0)>0){S=f[x>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0;U=f[v>>2]|0}while((T|0)<(U|0));f[j>>2]=f[i>>2];if((U|0)<3)V=29;else V=31}else{f[j>>2]=f[i>>2];V=29}if((V|0)==29){U=f[i+4>>2]|0;if((U|0)<3){f[v>>2]=U;f[w>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];w=f[i+44>>2]|0;U=f[B>>2]|0;f[U>>2]=f[w>>2];f[U+4>>2]=f[w+4>>2]}else V=31}if((V|0)==31)ZS(j,i);w=i+16|0;f[O>>2]=f[w>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];O=f[P>>2]|0;f[R>>2]=O;if(O|0?(R=O+12|0,O=f[R>>2]|0,f[R>>2]=O+-1,(O|0)==1):0)_S(i);f[P>>2]=0;P=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[P>>2]|0)>0){w=f[i+40>>2]|0;O=0;do{f[w+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[P>>2]|0))}P=f[i+44>>2]|0;if((P|0)!=(i+48|0))g0(P);P=f[a+8>>2]|0;f[g>>2]=L;f[g+4>>2]=Q;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;$S(i,P,g,h);P=i+36|0;O=f[P>>2]|0;if(O|0){w=O+12|0;f[w>>2]=(f[w>>2]|0)+1}w=k+36|0;O=f[w>>2]|0;if(O|0?(R=O+12|0,O=f[R>>2]|0,f[R>>2]=O+-1,(O|0)==1):0)_S(k);f[w>>2]=0;O=k+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[C>>2]|0)>0){R=f[E>>2]|0;U=0;do{f[R+(U<<2)>>2]=0;U=U+1|0;W=f[C>>2]|0}while((U|0)<(W|0));f[k>>2]=f[i>>2];if((W|0)<3)V=50;else V=52}else{f[k>>2]=f[i>>2];V=50}if((V|0)==50){W=f[i+4>>2]|0;if((W|0)<3){f[C>>2]=W;f[D>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];D=f[i+44>>2]|0;W=f[z>>2]|0;f[W>>2]=f[D>>2];f[W+4>>2]=f[D+4>>2]}else V=52}if((V|0)==52)ZS(k,i);D=i+16|0;f[O>>2]=f[D>>2];f[k+20>>2]=f[i+20>>2];f[k+24>>2]=f[i+24>>2];f[k+28>>2]=f[i+28>>2];f[k+32>>2]=f[i+32>>2];O=f[P>>2]|0;f[w>>2]=O;if(O|0?(w=O+12|0,O=f[w>>2]|0,f[w>>2]=O+-1,(O|0)==1):0)_S(i);f[P>>2]=0;P=i+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[P>>2]|0)>0){D=f[i+40>>2]|0;O=0;do{f[D+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[P>>2]|0))}P=f[i+44>>2]|0;if((P|0)!=(i+48|0))g0(P)}else{P=a+28|0;X=(f[P>>2]|0)==7?.0625:1.0;f[g>>2]=L;f[g+4>>2]=Q;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;$S(p,M,g,h);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=p;M=g+8|0;f[M>>2]=0;f[M+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;Hoa(i,g,3,1,0,f[P>>2]|0,X,0.0,1);M=p+36|0;O=f[M>>2]|0;if(O|0?(D=O+12|0,O=f[D>>2]|0,f[D>>2]=O+-1,(O|0)==1):0)_S(p);f[M>>2]=0;M=p+16|0;O=p+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[O>>2]|0)>0){M=f[p+40>>2]|0;D=0;do{f[M+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[O>>2]|0))}O=f[p+44>>2]|0;if((O|0)!=(p+48|0))g0(O);O=f[K>>2]|0;f[g>>2]=L;f[g+4>>2]=Q;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;$S(p,O,g,h);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=p;O=g+8|0;f[O>>2]=0;f[O+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;Hoa(i,g,3,0,1,f[P>>2]|0,X,0.0,1);P=p+36|0;O=f[P>>2]|0;if(O|0?(D=O+12|0,O=f[D>>2]|0,f[D>>2]=O+-1,(O|0)==1):0)_S(p);f[P>>2]=0;P=p+16|0;O=p+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[O>>2]|0)>0){P=f[p+40>>2]|0;D=0;do{f[P+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[O>>2]|0))}O=f[p+44>>2]|0;if((O|0)!=(p+48|0))g0(O)}O=a+40|0;D=f[O>>2]|0;if((D|0)>1){P=j+12|0;M=f[P>>2]<<1;if((f[G>>2]|0)>>>0<M>>>0){w=f[l>>2]|0;if((w|0)!=(F|0)){if(w|0)ZDc(w);f[l>>2]=F;f[G>>2]=520}f[G>>2]=M;if(M>>>0>520){w=XDc(M>>>0>2147483647?-1:M<<1)|0;f[l>>2]=w}}else f[G>>2]=M;M=k+12|0;w=f[M>>2]<<1;if((f[I>>2]|0)>>>0<w>>>0){W=f[m>>2]|0;if((W|0)!=(H|0)){if(W|0)ZDc(W);f[m>>2]=H;f[I>>2]=520}f[I>>2]=w;if(w>>>0>520){W=XDc(w>>>0>2147483647?-1:w<<1)|0;f[m>>2]=W;Z=W}else Z=H}else{f[I>>2]=w;Z=f[m>>2]|0}w=f[l>>2]|0;_=Z+(f[M>>2]<<1)|0;$=w+(f[P>>2]<<1)|0;aa=Z;ba=w;ca=f[O>>2]|0}else{_=0;$=0;aa=0;ba=0;ca=D}D=a+36|0;w=f[D>>2]|0;Z=Y(w*3|0,ca)|0;P=p+8|0;f[p>>2]=P;M=p+4|0;f[M>>2]=Z;if(Z>>>0>264){W=XDc(Z>>>0>1073741823?-1:Z<<2)|0;f[p>>2]=W;da=W}else da=P;W=da+4|0;Z=Y(ca,w)|0;ca=W+(Z<<2)|0;U=ca+(Z<<2)|0;Z=U+-4|0;if((L|0)==(f[c>>2]|0))XIc(Z|0,0,w<<2|0)|0;else{f[Z>>2]=0;f[U+(f[(f[K>>2]|0)+12>>2]<<2)>>2]=0}f[da>>2]=0;f[W+(f[(f[K>>2]|0)+12>>2]<<2)>>2]=0;f[ca+-4>>2]=0;f[ca+(f[(f[K>>2]|0)+12>>2]<<2)>>2]=0;da=f[N>>2]|0;if((L|0)>(da|0)){ea=da;fa=a+12|0}else{da=j+16|0;Z=k+16|0;w=a+32|0;R=a+12|0;T=a+20|0;S=a+24|0;ga=n+8|0;ha=n+4|0;ia=n+16|0;ja=n+20|0;ka=L;la=_;_=$;$=aa;aa=ba;ba=U;U=ca;ca=W;while(1){if((ka|0)<(Q|0)){W=ka-L|0;ma=(f[da>>2]|0)+(Y(f[f[B>>2]>>2]|0,W)|0)|0;na=(f[Z>>2]|0)+(Y(f[f[z>>2]>>2]|0,W)|0)|0;W=Y(f[O>>2]|0,f[(f[K>>2]|0)+12>>2]|0)|0;oa=(W|0)>0;if(!(b[w>>0]|0)){if(oa){pa=ca;qa=0;do{ra=d[ma+(qa<<1)>>1]|0;sa=ra<<16>>16;ta=d[na+(qa<<1)>>1]|0;ua=ta<<16>>16;f[pa+(qa<<2)>>2]=(ta<<16>>16>-1?ua:0-ua|0)+(ra<<16>>16>-1?sa:0-sa|0);qa=qa+1|0}while((qa|0)!=(W|0))}}else if(oa){qa=ca;pa=0;do{sa=d[ma+(pa<<1)>>1]|0;ra=Y(sa,sa)|0;sa=d[na+(pa<<1)>>1]|0;ua=(Y(sa,sa)|0)+ra|0;f[qa+(pa<<2)>>2]=ua;pa=pa+1|0}while((pa|0)!=(W|0))}W=f[O>>2]|0;if((W|0)>1){pa=f[(f[K>>2]|0)+12>>2]|0;qa=ca;if((pa|0)>0){oa=aa;ua=$;ra=0;sa=0;ta=W;while(1){W=f[qa+(sa<<2)>>2]|0;if((ta|0)>1){va=sa;wa=1;xa=W;while(1){ya=wa+sa|0;za=(f[qa+(ya<<2)>>2]|0)>(xa|0)?ya:va;wa=wa+1|0;ya=f[qa+(za<<2)>>2]|0;if((wa|0)>=(ta|0)){Aa=za;Ba=ya;break}else{va=za;xa=ya}}}else{Aa=sa;Ba=W}f[qa+(ra<<2)>>2]=Ba;d[oa+(ra<<1)>>1]=d[ma+(Aa<<1)>>1]|0;d[ua+(ra<<1)>>1]=d[na+(Aa<<1)>>1]|0;ra=ra+1|0;xa=f[O>>2]|0;va=f[(f[K>>2]|0)+12>>2]|0;if((ra|0)>=(va|0)){Ca=va;break}else{sa=xa+sa|0;ta=xa}}}else Ca=pa;f[qa+(Ca<<2)>>2]=0;Da=$;Ea=aa;Fa=la;Ga=_}else{Da=la;Ea=_;Fa=$;Ga=aa}if((ka|0)>(f[c>>2]|0)){Ha=Da;Ia=Ea;Ja=Fa;Ka=Ga;V=106}else{La=Da;Ma=Ea;Na=Fa;Oa=Ga}}else{XIc(ca+-4|0,0,f[D>>2]<<2|0)|0;ta=(f[O>>2]|0)>1;Ha=ta?$:la;Ia=ta?aa:_;Ja=ta?la:$;Ka=ta?_:aa;V=106}if((V|0)==106){V=0;ta=f[R>>2]|0;sa=(f[ta+16>>2]|0)+(Y(f[f[ta+44>>2]>>2]|0,ka)|0)|0;ta=sa+1|0;b[sa>>0]=1;b[ta+(f[(f[K>>2]|0)+12>>2]|0)>>0]=1;if((f[O>>2]|0)==1){sa=ka-L+-1|0;ra=(f[da>>2]|0)+(Y(f[f[B>>2]>>2]|0,sa)|0)|0;Pa=ra;Qa=(f[Z>>2]|0)+(Y(f[f[z>>2]>>2]|0,sa)|0)|0}else{Pa=Ka;Qa=Ja}if((f[(f[K>>2]|0)+12>>2]|0)>0){sa=ba;ra=U;na=ca;ua=0;do{ma=f[sa+(ua<<2)>>2]|0;do if((ma|0)>(f[T>>2]|0)){oa=d[Pa+(ua<<1)>>1]|0;xa=d[Qa+(ua<<1)>>1]|0;va=oa<<16>>16;wa=oa<<16>>16>-1?va:0-va|0;va=xa<<16>>16;ya=(xa<<16>>16>-1?va:0-va|0)<<15;if((ya|0)<(wa*13573|0)){if((ma|0)<=(f[sa+(ua+-1<<2)>>2]|0)){V=135;break}if((ma|0)<(f[sa+(ua+1<<2)>>2]|0)){V=135;break}va=ta+ua|0;if((ma|0)<=(f[S>>2]|0)){b[va>>0]=0;break}b[va>>0]=2;za=f[ha>>2]|0;Ra=(f[ga>>2]|0)-za|0;Sa=f[ia>>2]|0;Ta=f[ja>>2]|0;if((((Ra|0)==0?0:(Ra<<8)+-1|0)|0)==(Ta+Sa|0)){Ona(n);Ua=f[ia>>2]|0;Va=f[ja>>2]|0;Wa=f[ha>>2]|0}else{Ua=Sa;Va=Ta;Wa=za}za=Va+Ua|0;f[(f[Wa+(za>>>10<<2)>>2]|0)+((za&1023)<<2)>>2]=va;f[ja>>2]=Va+1;break}if((ya|0)>(wa*79109|0)){if((ma|0)<=(f[ra+(ua<<2)>>2]|0)){V=135;break}if((ma|0)<(f[na+(ua<<2)>>2]|0)){V=135;break}wa=ta+ua|0;if((ma|0)<=(f[S>>2]|0)){b[wa>>0]=0;break}b[wa>>0]=2;ya=f[ha>>2]|0;va=(f[ga>>2]|0)-ya|0;za=f[ia>>2]|0;Ta=f[ja>>2]|0;if((((va|0)==0?0:(va<<8)+-1|0)|0)==(Ta+za|0)){Ona(n);Xa=f[ia>>2]|0;Ya=f[ja>>2]|0;Za=f[ha>>2]|0}else{Xa=za;Ya=Ta;Za=ya}ya=Ya+Xa|0;f[(f[Za+(ya>>>10<<2)>>2]|0)+((ya&1023)<<2)>>2]=wa;f[ja>>2]=Ya+1;break}else{wa=(xa^oa)<<16>>16<0?-1:1;if((ma|0)<=(f[ra+(ua-wa<<2)>>2]|0)){V=135;break}if((ma|0)<=(f[na+(wa+ua<<2)>>2]|0)){V=135;break}wa=ta+ua|0;if((ma|0)<=(f[S>>2]|0)){b[wa>>0]=0;break}b[wa>>0]=2;oa=f[ha>>2]|0;xa=(f[ga>>2]|0)-oa|0;ya=f[ia>>2]|0;Ta=f[ja>>2]|0;if((((xa|0)==0?0:(xa<<8)+-1|0)|0)==(Ta+ya|0)){Ona(n);_a=f[ia>>2]|0;$a=f[ja>>2]|0;ab=f[ha>>2]|0}else{_a=ya;$a=Ta;ab=oa}oa=$a+_a|0;f[(f[ab+(oa>>>10<<2)>>2]|0)+((oa&1023)<<2)>>2]=wa;f[ja>>2]=$a+1;break}}else V=135;while(0);if((V|0)==135){V=0;b[ta+ua>>0]=1}ua=ua+1|0}while((ua|0)<(f[(f[K>>2]|0)+12>>2]|0));La=Ha;Ma=Ia;Na=Ja;Oa=Ka}else{La=Ha;Ma=Ia;Na=Ja;Oa=Ka}}ua=f[N>>2]|0;if((ka|0)<(ua|0)){ta=ca;ka=ka+1|0;la=La;_=Ma;$=Na;aa=Oa;ca=U;U=ba;ba=ta}else{ea=ua;fa=R;break}}}R=f[fa>>2]|0;fa=f[R+16>>2]|0;if((J|0)<2)bb=fa;else bb=fa+(Y((f[c>>2]|0)+2|0,f[D>>2]|0)|0)|0;if((Q|0)==(f[(f[K>>2]|0)+8>>2]|0))cb=f[R+28>>2]|0;else cb=fa+(Y(f[D>>2]|0,ea)|0)|0;ea=bb;fa=cb-ea|0;cb=n+20|0;R=f[cb>>2]|0;if(!R)db=o+20|0;else{K=n+16|0;Q=n+4|0;c=n+8|0;J=o+8|0;ba=o+4|0;U=o+16|0;ca=o+20|0;Oa=R;while(1){R=f[K>>2]|0;aa=Oa+-1|0;Na=R+aa|0;$=f[Q>>2]|0;Ma=f[(f[$+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]|0;f[cb>>2]=aa;aa=f[c>>2]|0;Na=aa-$|0;if((1-Oa-R+((Na|0)==0?0:(Na<<8)+-1|0)|0)>>>0>2047){YDc(f[aa+-4>>2]|0);f[c>>2]=(f[c>>2]|0)+-4}aa=Ma;do if((Ma-ea|0)>>>0>=fa>>>0){Na=f[ba>>2]|0;R=(f[J>>2]|0)-Na|0;$=f[U>>2]|0;_=f[ca>>2]|0;if((((R|0)==0?0:(R<<8)+-1|0)|0)==(_+$|0)){Ona(o);eb=f[U>>2]|0;fb=f[ca>>2]|0;gb=f[ba>>2]|0}else{eb=$;fb=_;gb=Na}Na=fb+eb|0;f[(f[gb+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=Ma;f[ca>>2]=fb+1;Na=f[D>>2]|0;_=aa>>>0<bb>>>0?Na:0-Na|0;Na=aa+-1|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;$=f[Q>>2]|0;R=(f[c>>2]|0)-$|0;La=f[K>>2]|0;la=f[cb>>2]|0;if((((R|0)==0?0:(R<<8)+-1|0)|0)==(la+La|0)){Ona(n);hb=f[K>>2]|0;ib=f[cb>>2]|0;jb=f[Q>>2]|0}else{hb=La;ib=la;jb=$}$=ib+hb|0;f[(f[jb+($>>>10<<2)>>2]|0)+(($&1023)<<2)>>2]=Na;f[cb>>2]=ib+1}Na=aa+1|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;$=f[Q>>2]|0;la=(f[c>>2]|0)-$|0;La=f[K>>2]|0;R=f[cb>>2]|0;if((((la|0)==0?0:(la<<8)+-1|0)|0)==(R+La|0)){Ona(n);kb=f[K>>2]|0;lb=f[cb>>2]|0;mb=f[Q>>2]|0}else{kb=La;lb=R;mb=$}$=lb+kb|0;f[(f[mb+($>>>10<<2)>>2]|0)+(($&1023)<<2)>>2]=Na;f[cb>>2]=lb+1}Na=aa+_|0;if(!(b[aa+(_+-1)>>0]|0)){$=Na+-1|0;b[$>>0]=2;R=f[Q>>2]|0;La=(f[c>>2]|0)-R|0;la=f[K>>2]|0;ka=f[cb>>2]|0;if((((La|0)==0?0:(La<<8)+-1|0)|0)==(ka+la|0)){Ona(n);nb=f[K>>2]|0;ob=f[cb>>2]|0;pb=f[Q>>2]|0}else{nb=la;ob=ka;pb=R}R=ob+nb|0;f[(f[pb+(R>>>10<<2)>>2]|0)+((R&1023)<<2)>>2]=$;f[cb>>2]=ob+1}if(!(b[Na>>0]|0)){b[Na>>0]=2;$=f[Q>>2]|0;R=(f[c>>2]|0)-$|0;ka=f[K>>2]|0;la=f[cb>>2]|0;if((((R|0)==0?0:(R<<8)+-1|0)|0)==(la+ka|0)){Ona(n);qb=f[K>>2]|0;rb=f[cb>>2]|0;sb=f[Q>>2]|0}else{qb=ka;rb=la;sb=$}$=rb+qb|0;f[(f[sb+($>>>10<<2)>>2]|0)+(($&1023)<<2)>>2]=Na;f[cb>>2]=rb+1}if(!(b[aa+(_+1)>>0]|0)){Na=aa+_+1|0;b[Na>>0]=2;_=f[Q>>2]|0;$=(f[c>>2]|0)-_|0;la=f[K>>2]|0;ka=f[cb>>2]|0;if(((($|0)==0?0:($<<8)+-1|0)|0)==(ka+la|0)){Ona(n);tb=f[K>>2]|0;ub=f[cb>>2]|0;vb=f[Q>>2]|0}else{tb=la;ub=ka;vb=_}_=ub+tb|0;f[(f[vb+(_>>>10<<2)>>2]|0)+((_&1023)<<2)>>2]=Na;Na=ub+1|0;f[cb>>2]=Na;wb=Na}else V=202}else{Na=f[D>>2]|0;if(!(b[aa+~Na>>0]|0)){b[aa+(0-Na)+-1>>0]=2;_=f[D>>2]|0;ka=f[Q>>2]|0;la=(f[c>>2]|0)-ka|0;$=f[K>>2]|0;R=f[cb>>2]|0;if((((la|0)==0?0:(la<<8)+-1|0)|0)==(R+$|0)){Ona(n);xb=f[D>>2]|0;yb=f[K>>2]|0;zb=f[cb>>2]|0;Ab=f[Q>>2]|0}else{xb=_;yb=$;zb=R;Ab=ka}ka=zb+yb|0;f[(f[Ab+(ka>>>10<<2)>>2]|0)+((ka&1023)<<2)>>2]=aa+(0-_)+-1;f[cb>>2]=zb+1;Bb=xb}else Bb=Na;Na=aa+(0-Bb)|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;Na=f[D>>2]|0;_=f[Q>>2]|0;ka=(f[c>>2]|0)-_|0;R=f[K>>2]|0;$=f[cb>>2]|0;if((((ka|0)==0?0:(ka<<8)+-1|0)|0)==($+R|0)){Ona(n);Cb=f[D>>2]|0;Db=f[K>>2]|0;Eb=f[cb>>2]|0;Fb=f[Q>>2]|0}else{Cb=Na;Db=R;Eb=$;Fb=_}_=Eb+Db|0;f[(f[Fb+(_>>>10<<2)>>2]|0)+((_&1023)<<2)>>2]=aa+(0-Na);f[cb>>2]=Eb+1;Gb=Cb}else Gb=Bb;if(!(b[aa+(1-Gb)>>0]|0)){b[aa+(0-Gb)+1>>0]=2;Na=aa+(0-(f[D>>2]|0))+1|0;_=f[Q>>2]|0;$=(f[c>>2]|0)-_|0;R=f[K>>2]|0;ka=f[cb>>2]|0;if(((($|0)==0?0:($<<8)+-1|0)|0)==(ka+R|0)){Ona(n);Hb=f[K>>2]|0;Ib=f[cb>>2]|0;Jb=f[Q>>2]|0}else{Hb=R;Ib=ka;Jb=_}_=Ib+Hb|0;f[(f[Jb+(_>>>10<<2)>>2]|0)+((_&1023)<<2)>>2]=Na;f[cb>>2]=Ib+1}Na=aa+-1|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;_=f[Q>>2]|0;ka=(f[c>>2]|0)-_|0;R=f[K>>2]|0;$=f[cb>>2]|0;if((((ka|0)==0?0:(ka<<8)+-1|0)|0)==($+R|0)){Ona(n);Kb=f[K>>2]|0;Lb=f[cb>>2]|0;Mb=f[Q>>2]|0}else{Kb=R;Lb=$;Mb=_}_=Lb+Kb|0;f[(f[Mb+(_>>>10<<2)>>2]|0)+((_&1023)<<2)>>2]=Na;f[cb>>2]=Lb+1}Na=aa+1|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;_=f[Q>>2]|0;$=(f[c>>2]|0)-_|0;R=f[K>>2]|0;ka=f[cb>>2]|0;if(((($|0)==0?0:($<<8)+-1|0)|0)==(ka+R|0)){Ona(n);Nb=f[K>>2]|0;Ob=f[cb>>2]|0;Pb=f[Q>>2]|0}else{Nb=R;Ob=ka;Pb=_}_=Ob+Nb|0;f[(f[Pb+(_>>>10<<2)>>2]|0)+((_&1023)<<2)>>2]=Na;f[cb>>2]=Ob+1}Na=f[D>>2]|0;if(!(b[aa+(Na+-1)>>0]|0)){b[aa+Na+-1>>0]=2;_=f[D>>2]|0;ka=f[Q>>2]|0;R=(f[c>>2]|0)-ka|0;$=f[K>>2]|0;la=f[cb>>2]|0;if((((R|0)==0?0:(R<<8)+-1|0)|0)==(la+$|0)){Ona(n);Qb=f[D>>2]|0;Rb=f[K>>2]|0;Sb=f[cb>>2]|0;Tb=f[Q>>2]|0}else{Qb=_;Rb=$;Sb=la;Tb=ka}ka=Sb+Rb|0;f[(f[Tb+(ka>>>10<<2)>>2]|0)+((ka&1023)<<2)>>2]=aa+_+-1;f[cb>>2]=Sb+1;Ub=Qb}else Ub=Na;Na=aa+Ub|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;Na=f[D>>2]|0;_=f[Q>>2]|0;ka=(f[c>>2]|0)-_|0;la=f[K>>2]|0;$=f[cb>>2]|0;if((((ka|0)==0?0:(ka<<8)+-1|0)|0)==($+la|0)){Ona(n);Vb=f[D>>2]|0;Wb=f[K>>2]|0;Xb=f[cb>>2]|0;Yb=f[Q>>2]|0}else{Vb=Na;Wb=la;Xb=$;Yb=_}_=Xb+Wb|0;f[(f[Yb+(_>>>10<<2)>>2]|0)+((_&1023)<<2)>>2]=aa+Na;f[cb>>2]=Xb+1;Zb=Vb}else Zb=Ub;if(b[aa+(Zb+1)>>0]|0){V=202;break}b[aa+Zb+1>>0]=2;Na=aa+(f[D>>2]|0)+1|0;_=f[Q>>2]|0;$=(f[c>>2]|0)-_|0;la=f[K>>2]|0;ka=f[cb>>2]|0;if(((($|0)==0?0:($<<8)+-1|0)|0)==(ka+la|0)){Ona(n);_b=f[K>>2]|0;$b=f[cb>>2]|0;ac=f[Q>>2]|0}else{_b=la;$b=ka;ac=_}_=$b+_b|0;f[(f[ac+(_>>>10<<2)>>2]|0)+((_&1023)<<2)>>2]=Na;Na=$b+1|0;f[cb>>2]=Na;wb=Na}while(0);if((V|0)==202){V=0;wb=f[cb>>2]|0}if(!wb){db=ca;break}else Oa=wb}}if(f[db>>2]|0){wb=a+44|0;m6(wb);Oa=f[a+16>>2]|0;a=(f[Oa+16>>2]|0)+(f[Oa+20>>2]|0)|0;ca=f[Oa+4>>2]|0;cb=ca+(a>>>10<<2)|0;if((f[Oa+8>>2]|0)==(ca|0))bc=0;else bc=(f[cb>>2]|0)+((a&1023)<<2)|0;f[q>>2]=cb;f[q+4>>2]=bc;bc=f[o+4>>2]|0;cb=f[o+16>>2]|0;a=bc+(cb>>>10<<2)|0;ca=(f[o+8>>2]|0)==(bc|0);if(ca)cc=0;else cc=(f[a>>2]|0)+((cb&1023)<<2)|0;f[r>>2]=a;f[r+4>>2]=cc;cc=cb+(f[db>>2]|0)|0;db=bc+(cc>>>10<<2)|0;if(ca)dc=0;else dc=(f[db>>2]|0)+((cc&1023)<<2)|0;f[s>>2]=db;f[s+4>>2]=dc;f[i>>2]=f[q>>2];f[i+4>>2]=f[q+4>>2];f[h>>2]=f[r>>2];f[h+4>>2]=f[r+4>>2];f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2];Xna(t,Oa,i,h,g,0);n6(wb)}wb=f[p>>2]|0;if((wb|0)!=(P|0)){if(wb|0)ZDc(wb);f[p>>2]=P;f[M>>2]=264}Pna(o);Pna(n);n=f[m>>2]|0;if((n|0)!=(H|0)){if(n|0)ZDc(n);f[m>>2]=H;f[I>>2]=520}I=f[l>>2]|0;if((I|0)!=(F|0)){if(I|0)ZDc(I);f[l>>2]=F;f[G>>2]=520}G=k+36|0;F=f[G>>2]|0;if(F|0?(l=F+12|0,F=f[l>>2]|0,f[l>>2]=F+-1,(F|0)==1):0)_S(k);f[G>>2]=0;G=k+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[C>>2]|0)>0){G=f[E>>2]|0;E=0;do{f[G+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[C>>2]|0))}C=f[z>>2]|0;if((C|0)!=(y|0))g0(C);C=j+36|0;y=f[C>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)_S(j);f[C>>2]=0;C=j+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){C=f[x>>2]|0;x=0;do{f[C+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[B>>2]|0;if((v|0)==(A|0)){u=e;return}g0(v);u=e;return}function Xna(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;g=u;u=u+128|0;h=g+120|0;i=g+112|0;j=g+104|0;k=g+24|0;l=g+96|0;m=g+88|0;n=g+80|0;o=g+72|0;p=g+64|0;q=g+56|0;r=g+48|0;s=g+40|0;t=g+32|0;v=g+16|0;w=g+8|0;x=g;y=d;z=f[y>>2]|0;A=f[y+4>>2]|0;y=e;B=f[y>>2]|0;C=f[y+4>>2]|0;if((C|0)==(A|0))D=0;else D=(C-(f[B>>2]|0)>>2)+(B-z<<8)-(A-(f[z>>2]|0)>>2)|0;y=b+4|0;E=f[y>>2]|0;F=b+16|0;G=f[F>>2]|0;H=E+(G>>>10<<2)|0;I=b+8|0;J=f[I>>2]|0;K=J;L=E;if((J|0)==(E|0))M=0;else M=(f[H>>2]|0)+((G&1023)<<2)|0;N=f[c+4>>2]|0;if((N|0)==(M|0))O=0;else{P=f[c>>2]|0;O=(N-(f[P>>2]|0)>>2)+(P-H<<8)-(M-(f[H>>2]|0)>>2)|0}H=b+20|0;M=f[H>>2]|0;if(O>>>0<(M-O|0)>>>0){if(D>>>0>G>>>0){Yna(b,D-G|0);Q=f[F>>2]|0;R=f[y>>2]|0;S=f[I>>2]|0}else{Q=G;R=E;S=J}P=R+(Q>>>10<<2)|0;if((S|0)==(R|0))T=0;else T=(f[P>>2]|0)+((Q&1023)<<2)|0;R=P;S=T;if(D>>>0>O>>>0){if(O>>>0<D>>>1>>>0)if(!O){U=B;V=C}else{N=B;c=(C-(f[B>>2]|0)>>2)-O|0;if((c|0)>0){W=N+(c>>>10<<2)|0;X=(f[W>>2]|0)+((c&1023)<<2)|0;Y=W}else{W=1023-c|0;c=N+(((W|0)/-1024|0)<<2)|0;X=(f[c>>2]|0)+(1023-((W|0)%1024|0)<<2)|0;Y=c}U=Y;V=X}else{X=D-O|0;if(!X){U=z;V=A}else{Y=z;c=(A-(f[z>>2]|0)>>2)+X|0;if((c|0)>0){X=Y+(c>>>10<<2)|0;Z=(f[X>>2]|0)+((c&1023)<<2)|0;_=X}else{X=1023-c|0;c=Y+(((X|0)/-1024|0)<<2)|0;Z=(f[c>>2]|0)+(1023-((X|0)%1024|0)<<2)|0;_=c}U=_;V=Z}}Z=V;_=d+4|0;if((Z|0)==(f[_>>2]|0)){$=O;aa=Q;ba=R;ca=S;da=U;ea=V}else{c=U;X=R;Y=S;W=Z;Z=Q;N=f[H>>2]|0;while(1){fa=Y;ga=X;if((fa|0)==(f[ga>>2]|0)){ha=ga+-4|0;ia=ha;ja=(f[ha>>2]|0)+4096|0}else{ia=X;ja=fa}fa=ja+-4|0;Y=fa;ha=c;if((W|0)==(f[ha>>2]|0)){ga=ha+-4|0;ka=ga;la=(f[ga>>2]|0)+4096|0}else{ka=c;la=W}W=la+-4|0;f[fa>>2]=f[W>>2];Z=Z+-1|0;N=N+1|0;if((W|0)==(f[_>>2]|0))break;else{c=ka;X=ia}}f[F>>2]=Z;f[H>>2]=N;$=O;aa=Z;ba=ia;ca=Y;da=U;ea=V}}else{$=D;aa=Q;ba=R;ca=S;da=z;ea=A}if($|0){Q=(S-(f[P>>2]|0)>>2)+$|0;if((Q|0)>0){V=P+(Q>>>10<<2)|0;ma=(f[V>>2]|0)+((Q&1023)<<2)|0;na=V}else{V=1023-Q|0;Q=P+(((V|0)/-1024|0)<<2)|0;ma=(f[Q>>2]|0)+(1023-((V|0)%1024|0)<<2)|0;na=Q}Q=na;na=ma;if((ma|0)!=(T|0)){V=Q;U=ba;ba=ca;ca=ma;ma=aa;aa=f[H>>2]|0;while(1){Y=ba;ia=U;if((Y|0)==(f[ia>>2]|0)){Z=ia+-4|0;oa=Z;pa=(f[Z>>2]|0)+4096|0}else{oa=U;pa=Y}ba=pa+-4|0;Y=V;if((ca|0)==(f[Y>>2]|0)){Z=Y+-4|0;qa=Z;ra=(f[Z>>2]|0)+4096|0}else{qa=V;ra=ca}ca=ra+-4|0;f[ba>>2]=f[ca>>2];ma=ma+-1|0;aa=aa+1|0;if((ca|0)==(T|0))break;else{V=qa;U=oa}}f[F>>2]=ma;f[H>>2]=aa}if($>>>0<O>>>0){f[l>>2]=Q;f[l+4>>2]=na;na=m;f[na>>2]=R;f[na+4>>2]=S;na=(S-(f[P>>2]|0)>>2)+O|0;if((na|0)>0){Q=P+(na>>>10<<2)|0;f[m>>2]=Q;sa=(f[Q>>2]|0)+((na&1023)<<2)|0}else{Q=1023-na|0;na=P+(((Q|0)/-1024|0)<<2)|0;f[m>>2]=na;sa=(f[na>>2]|0)+(1023-((Q|0)%1024|0)<<2)|0}f[m+4>>2]=sa;f[n>>2]=R;f[n+4>>2]=S;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];Zna(k,j,i,h);ta=f[k>>2]|0;ua=f[k+4>>2]|0}else{ta=R;ua=S}S=o;f[S>>2]=da;f[S+4>>2]=ea;ea=e;S=f[ea+4>>2]|0;da=p;f[da>>2]=f[ea>>2];f[da+4>>2]=S;f[q>>2]=ta;f[q+4>>2]=ua;f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2];_na(k,j,i,h)}}else{q=K-L|0;L=((q|0)==0?0:(q<<8)+-1|0)-(M+G)|0;if(D>>>0>L>>>0){$na(b,D-L|0);va=f[H>>2]|0;wa=f[F>>2]|0;xa=f[y>>2]|0;ya=f[I>>2]|0}else{va=M;wa=G;xa=E;ya=J}J=wa+va|0;wa=xa+(J>>>10<<2)|0;if((ya|0)==(xa|0))za=0;else za=(f[wa>>2]|0)+((J&1023)<<2)|0;J=wa;xa=za;ya=va-O|0;if(D>>>0>ya>>>0){if(ya>>>0<D>>>1>>>0)if(!ya){Aa=z;Ba=A}else{E=z;G=(A-(f[z>>2]|0)>>2)+ya|0;if((G|0)>0){z=E+(G>>>10<<2)|0;Ca=(f[z>>2]|0)+((G&1023)<<2)|0;Da=z}else{z=1023-G|0;G=E+(((z|0)/-1024|0)<<2)|0;Ca=(f[G>>2]|0)+(1023-((z|0)%1024|0)<<2)|0;Da=G}Aa=Da;Ba=Ca}else{Ca=D-ya|0;if(!Ca){Aa=B;Ba=C}else{Da=B;G=(C-(f[B>>2]|0)>>2)-Ca|0;if((G|0)>0){Ca=Da+(G>>>10<<2)|0;Ea=(f[Ca>>2]|0)+((G&1023)<<2)|0;Fa=Ca}else{Ca=1023-G|0;G=Da+(((Ca|0)/-1024|0)<<2)|0;Ea=(f[G>>2]|0)+(1023-((Ca|0)%1024|0)<<2)|0;Fa=G}Aa=Fa;Ba=Ea}}Ea=Ba;Fa=e+4|0;if((Ea|0)==(f[Fa>>2]|0)){Ga=ya;Ha=va;Ia=J;Ja=xa;Ka=Aa;La=Ba}else{e=Aa;G=J;Ca=Ba;Da=xa;z=Ea;Ea=va;while(1){f[Da>>2]=f[Ca>>2];E=Da+4|0;if((E-(f[G>>2]|0)|0)==4096){A=G+4|0;Ma=A;Na=f[A>>2]|0}else{Ma=G;Na=E}E=z+4|0;if((E-(f[e>>2]|0)|0)==4096){A=e+4|0;Oa=A;Pa=f[A>>2]|0}else{Oa=e;Pa=E}Ea=Ea+1|0;z=Pa;if((z|0)==(f[Fa>>2]|0))break;else{e=Oa;G=Ma;Ca=Pa;Da=Na}}f[H>>2]=Ea;Ga=ya;Ha=Ea;Ia=Ma;Ja=Na;Ka=Aa;La=Ba}}else{Ga=D;Ha=va;Ia=J;Ja=xa;Ka=B;La=C}if(Ga|0){C=(xa-(f[wa>>2]|0)>>2)-Ga|0;if((C|0)>0){B=wa+(C>>>10<<2)|0;Qa=(f[B>>2]|0)+((C&1023)<<2)|0;Ra=B}else{B=1023-C|0;C=wa+(((B|0)/-1024|0)<<2)|0;Qa=(f[C>>2]|0)+(1023-((B|0)%1024|0)<<2)|0;Ra=C}C=Ra;Ra=Qa;if((Qa|0)!=(za|0)){B=C;va=Ia;Ia=Ra;D=Ja;Ja=Qa;Qa=Ha;while(1){f[D>>2]=f[Ia>>2];Ha=D+4|0;if((Ha-(f[va>>2]|0)|0)==4096){Ba=va+4|0;Sa=Ba;Ta=f[Ba>>2]|0}else{Sa=va;Ta=Ha}Ha=Ja+4|0;if((Ha-(f[B>>2]|0)|0)==4096){Ba=B+4|0;Ua=Ba;Va=f[Ba>>2]|0}else{Ua=B;Va=Ha}Qa=Qa+1|0;Ja=Va;if((Ja|0)==(za|0))break;else{B=Ua;va=Sa;Ia=Va;D=Ta}}f[H>>2]=Qa}if(Ga>>>0<ya>>>0){Ga=r;f[Ga>>2]=J;f[Ga+4>>2]=xa;Ga=(xa-(f[wa>>2]|0)>>2)-ya|0;if((Ga|0)>0){ya=wa+(Ga>>>10<<2)|0;f[r>>2]=ya;Wa=(f[ya>>2]|0)+((Ga&1023)<<2)|0}else{ya=1023-Ga|0;Ga=wa+(((ya|0)/-1024|0)<<2)|0;f[r>>2]=Ga;Wa=(f[Ga>>2]|0)+(1023-((ya|0)%1024|0)<<2)|0}f[r+4>>2]=Wa;f[s>>2]=C;f[s+4>>2]=Ra;f[t>>2]=J;f[t+4>>2]=xa;f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2];f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];aoa(k,j,i,h);Xa=f[k>>2]|0;Ya=f[k+4>>2]|0}else{Xa=J;Ya=xa}xa=d;d=f[xa+4>>2]|0;J=v;f[J>>2]=f[xa>>2];f[J+4>>2]=d;d=w;f[d>>2]=Ka;f[d+4>>2]=La;f[x>>2]=Xa;f[x+4>>2]=Ya;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2];f[i>>2]=f[w>>2];f[i+4>>2]=f[w+4>>2];f[h>>2]=f[x>>2];f[h+4>>2]=f[x+4>>2];boa(k,j,i,h)}}h=f[y>>2]|0;y=f[F>>2]|0;F=h+(y>>>10<<2)|0;if((f[I>>2]|0)==(h|0)){Za=0;_a=0}else{Za=0;_a=(f[F>>2]|0)+((y&1023)<<2)|0}y=a;f[y>>2]=Za|F;f[y+4>>2]=_a;if(!O){u=g;return}y=(_a-(f[F>>2]|0)>>2)+O|0;if((y|0)>0){O=F+(y>>>10<<2)|0;f[a>>2]=O;$a=(f[O>>2]|0)+((y&1023)<<2)|0}else{O=1023-y|0;y=F+(((O|0)/-1024|0)<<2)|0;f[a>>2]=y;$a=(f[y>>2]|0)+(1023-((O|0)%1024|0)<<2)|0}f[a+4>>2]=$a;u=g;return}function Yna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;c=u;u=u+16|0;d=c;e=a+8|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;j=(g|0)==(i|0);k=(j&1)+b|0;b=((k&1023|0)!=0&1)+(k>>>10)|0;k=i;i=g-k|0;l=a+16|0;m=f[l>>2]|0;n=(((i|0)==0?0:(i<<8)+-1|0)-((f[a+20>>2]|0)+m)|0)>>>10;o=b>>>0<n>>>0?b:n;n=b-o|0;if(!n){f[l>>2]=(o<<10)+m;if(!o){u=c;return}m=g+-4|0;f[d>>2]=f[m>>2];f[e>>2]=m;Sna(a,d);m=o+-1|0;if(!m){u=c;return}else p=m;do{m=(f[e>>2]|0)+-4|0;f[d>>2]=f[m>>2];f[e>>2]=m;Sna(a,d);p=p+-1|0}while((p|0)!=0);u=c;return}p=a+12|0;m=f[a>>2]|0;q=(f[p>>2]|0)-m|0;r=i>>2;if(n>>>0<=((q>>2)-r|0)>>>0){do if((k|0)!=(m|0)){i=n;while(1){s=VDc(4096)|0;f[d>>2]=s;Sna(a,d);i=i+-1|0;t=f[e>>2]|0;s=f[h>>2]|0;v=(f[l>>2]|0)+1024+(((t-s|0)==4)<<31>>31)|0;f[l>>2]=v;if(!i){w=25;break}if((s|0)==(f[a>>2]|0)){w=7;break}}if((w|0)==7){x=i;y=t;w=8;break}else if((w|0)==25){z=o;A=v;B=t;break}}else{x=n;y=g;w=8}while(0);do if((w|0)==8){g=o;t=x;v=y;a:while(1){m=VDc(4096)|0;k=f[p>>2]|0;s=k;C=v;do if((v|0)==(k|0)){D=f[h>>2]|0;E=f[a>>2]|0;F=E;if(D>>>0>E>>>0){G=D;H=((G-F>>2)+1|0)/-2|0;I=D+(H<<2)|0;J=C-G|0;G=J>>2;if(!G)K=D;else{fJc(I|0,D|0,J|0)|0;K=f[h>>2]|0}J=I+(G<<2)|0;f[e>>2]=J;f[h>>2]=K+(H<<2);L=J;break}J=s-F>>1;F=(J|0)==0?1:J;if(F>>>0>1073741823){w=17;break a}J=VDc(F<<2)|0;H=J;G=J+(F>>>2<<2)|0;I=G;M=J+(F<<2)|0;if((D|0)==(v|0)){N=I;O=E}else{E=G;G=I;F=D;do{f[E>>2]=f[F>>2];E=G+4|0;G=E;F=F+4|0}while((F|0)!=(v|0));N=G;O=f[a>>2]|0}f[a>>2]=H;f[h>>2]=I;f[e>>2]=N;f[p>>2]=M;if(!O)L=N;else{YDc(O);L=f[e>>2]|0}}else L=v;while(0);f[L>>2]=m;v=(f[e>>2]|0)+4|0;f[e>>2]=v;t=t+-1|0;g=g+1|0;if(!t){w=24;break}}if((w|0)==17){t=af(8)|0;bEc(t,503977);f[t>>2]=185532;ig(t|0,23696,1627)}else if((w|0)==24){z=g;A=f[l>>2]|0;B=v;break}}while(0);f[l>>2]=A+(z<<10);if(!z){u=c;return}A=B+-4|0;f[d>>2]=f[A>>2];f[e>>2]=A;Sna(a,d);A=z+-1|0;if(!A){u=c;return}else P=A;do{A=(f[e>>2]|0)+-4|0;f[d>>2]=f[A>>2];f[e>>2]=A;Sna(a,d);P=P+-1|0}while((P|0)!=0);u=c;return}P=(b<<10)+(j<<31>>31)|0;j=q>>1;q=r+n|0;r=j>>>0<q>>>0?q:j;do if(r)if(r>>>0>1073741823){j=af(8)|0;bEc(j,503977);f[j>>2]=185532;ig(j|0,23696,1627)}else{Q=VDc(r<<2)|0;break}else Q=0;while(0);j=Q;q=n;n=j;b=j;d=j;j=Q+(r<<2)|0;b:while(1){r=VDc(4096)|0;Q=d;A=d;do if((Q|0)==(j|0)){z=b;if(z>>>0>n>>>0){B=z+((((b-n>>2)+1|0)/-2|0)<<2)|0;L=d-b|0;O=L>>2;if(O|0)fJc(B|0,b|0,L|0)|0;L=B+(O<<2)|0;R=n;S=B;T=L;U=j;V=L;break}L=j-n>>1;B=(L|0)==0?1:L;if(B>>>0>1073741823){w=41;break b}L=VDc(B<<2)|0;O=L;N=L+(B>>>2<<2)|0;K=N;y=L+(B<<2)|0;if((z|0)==(Q|0))W=K;else{B=N;N=K;L=z;while(1){f[B>>2]=f[L>>2];B=N+4|0;z=B;L=L+4|0;if((L|0)==(Q|0)){W=z;break}else N=z}}N=W;if(!n){R=O;S=K;T=W;U=y;V=N}else{YDc(n);R=O;S=K;T=W;U=y;V=N}}else{R=n;S=b;T=d;U=j;V=A}while(0);f[V>>2]=r;d=T+4|0;q=q+-1|0;if(!q)break;else{n=R;b=S;j=U}}if((w|0)==41){w=af(8)|0;bEc(w,503977);f[w>>2]=185532;ig(w|0,23696,1627)}w=f[e>>2]|0;c:do if(!o){X=R;Y=S;Z=d;_=U;$=w}else{j=o;b=R;n=S;q=d;T=U;V=w;d:while(1){W=V+-4|0;A=q;Q=q;do if((A|0)==(T|0)){v=n;if(v>>>0>b>>>0){g=v+((((n-b>>2)+1|0)/-2|0)<<2)|0;N=q-n|0;L=N>>2;if(L|0)fJc(g|0,n|0,N|0)|0;N=g+(L<<2)|0;aa=b;ba=g;ca=N;da=T;ea=N;break}N=T-b>>1;g=(N|0)==0?1:N;if(g>>>0>1073741823)break d;N=VDc(g<<2)|0;L=N;B=N+(g>>>2<<2)|0;m=B;z=N+(g<<2)|0;if((v|0)==(A|0))fa=m;else{g=B;B=m;N=v;while(1){f[g>>2]=f[N>>2];g=B+4|0;v=g;N=N+4|0;if((N|0)==(A|0)){fa=v;break}else B=v}}B=fa;if(!b){aa=L;ba=m;ca=fa;da=z;ea=B}else{YDc(b);aa=L;ba=m;ca=fa;da=z;ea=B}}else{aa=b;ba=n;ca=q;da=T;ea=Q}while(0);f[ea>>2]=f[W>>2];Q=ca+4|0;A=(f[e>>2]|0)+-4|0;f[e>>2]=A;j=j+-1|0;if(!j){X=aa;Y=ba;Z=Q;_=da;$=A;break c}else{b=aa;n=ba;q=Q;T=da;V=A}}V=af(8)|0;bEc(V,503977);f[V>>2]=185532;ig(V|0,23696,1627)}while(0);da=f[h>>2]|0;e:do if((da|0)==($|0)){ga=X;ha=Y;ia=Z;ja=_}else{ba=da;aa=X;ca=Y;ea=Z;fa=_;f:while(1){w=ea;U=ea;do if((w|0)==(fa|0)){d=ca;if(d>>>0>aa>>>0){S=d+((((ca-aa>>2)+1|0)/-2|0)<<2)|0;R=ea-ca|0;o=R>>2;if(o|0)fJc(S|0,ca|0,R|0)|0;R=S+(o<<2)|0;ka=aa;la=S;ma=R;na=fa;oa=R;break}R=fa-aa>>1;S=(R|0)==0?1:R;if(S>>>0>1073741823)break f;R=VDc(S<<2)|0;o=R;V=R+(S>>>2<<2)|0;T=V;q=R+(S<<2)|0;if((d|0)==(w|0))pa=T;else{S=V;V=T;R=d;while(1){f[S>>2]=f[R>>2];S=V+4|0;d=S;R=R+4|0;if((R|0)==(w|0)){pa=d;break}else V=d}}V=pa;if(!aa){ka=o;la=T;ma=pa;na=q;oa=V}else{YDc(aa);ka=o;la=T;ma=pa;na=q;oa=V}}else{ka=aa;la=ca;ma=ea;na=fa;oa=U}while(0);f[oa>>2]=f[ba>>2];U=ma+4|0;ba=ba+4|0;if((ba|0)==(f[e>>2]|0)){ga=ka;ha=la;ia=U;ja=na;break e}else{aa=ka;ca=la;ea=U;fa=na}}fa=af(8)|0;bEc(fa,503977);f[fa>>2]=185532;ig(fa|0,23696,1627)}while(0);na=f[a>>2]|0;f[a>>2]=ga;f[h>>2]=ha;f[e>>2]=ia;f[p>>2]=ja;f[l>>2]=P+(f[l>>2]|0);if(!na){u=c;return}YDc(na);u=c;return}function Zna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[c+4>>2]|0;g=b+4|0;h=f[g>>2]|0;if((e|0)!=(h|0)?(i=f[c>>2]|0,c=f[b>>2]|0,j=(e-(f[i>>2]|0)>>2)+(i-c<<8)-(h-(f[c>>2]|0)>>2)|0,(j|0)>0):0){c=d;i=j;j=f[c>>2]|0;e=f[c+4>>2]|0;c=h;while(1){h=(f[f[b>>2]>>2]|0)+4096|0;k=h-c>>2;l=(k|0)>(i|0);m=l?c+(i<<2)|0:h;h=l?i:k;if((c|0)==(m|0)){n=j;o=e}else{k=m;l=c;p=e;q=j;r=e;while(1){s=q;t=(f[s>>2]|0)+4096-p>>2;u=l;v=k-u>>2;w=(v|0)>(t|0);x=w?t:v;v=l;l=w?l+(t<<2)|0:m;t=l-u|0;if(t|0)fJc(p|0,v|0,t|0)|0;if(!x){y=p;z=q;A=r}else{t=(r-(f[q>>2]|0)>>2)+x|0;if((t|0)>0){x=s+(t>>>10<<2)|0;B=(f[x>>2]|0)+((t&1023)<<2)|0;C=x}else{x=1023-t|0;t=s+(((x|0)/-1024|0)<<2)|0;B=(f[t>>2]|0)+(1023-((x|0)%1024|0)<<2)|0;C=t}y=B;z=C;A=B}if((l|0)==(m|0)){n=z;o=A;break}else{p=y;q=z;r=A}}}r=d;f[r>>2]=n;f[r+4>>2]=o;r=i-h|0;if(h|0){q=f[b>>2]|0;p=((f[g>>2]|0)-(f[q>>2]|0)>>2)+h|0;if((p|0)>0){m=q+(p>>>10<<2)|0;f[b>>2]=m;D=(f[m>>2]|0)+((p&1023)<<2)|0}else{m=1023-p|0;p=q+(((m|0)/-1024|0)<<2)|0;f[b>>2]=p;D=(f[p>>2]|0)+(1023-((m|0)%1024|0)<<2)|0}f[g>>2]=D}if((r|0)<=0){E=n;F=o;break}i=r;j=n;e=o;c=f[g>>2]|0}G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}g=d;E=f[g>>2]|0;F=f[g+4>>2]|0;G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}function _na(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[c+4>>2]|0;g=b+4|0;h=f[g>>2]|0;if((e|0)!=(h|0)?(i=f[c>>2]|0,c=f[b>>2]|0,j=(e-(f[i>>2]|0)>>2)+(i-c<<8)-(h-(f[c>>2]|0)>>2)|0,(j|0)>0):0){c=d;i=j;j=f[c>>2]|0;e=f[c+4>>2]|0;c=h;while(1){h=(f[f[b>>2]>>2]|0)+4096|0;k=h-c>>2;l=(k|0)>(i|0);m=l?c+(i<<2)|0:h;h=l?i:k;if((c|0)==(m|0)){n=j;o=e}else{k=m;l=c;p=e;q=j;r=e;while(1){s=q;t=(f[s>>2]|0)+4096-p>>2;u=l;v=k-u>>2;w=(v|0)>(t|0);x=w?t:v;v=l;l=w?l+(t<<2)|0:m;t=l-u|0;if(t|0)fJc(p|0,v|0,t|0)|0;if(!x){y=p;z=q;A=r}else{t=(r-(f[q>>2]|0)>>2)+x|0;if((t|0)>0){x=s+(t>>>10<<2)|0;B=(f[x>>2]|0)+((t&1023)<<2)|0;C=x}else{x=1023-t|0;t=s+(((x|0)/-1024|0)<<2)|0;B=(f[t>>2]|0)+(1023-((x|0)%1024|0)<<2)|0;C=t}y=B;z=C;A=B}if((l|0)==(m|0)){n=z;o=A;break}else{p=y;q=z;r=A}}}r=d;f[r>>2]=n;f[r+4>>2]=o;r=i-h|0;if(h|0){q=f[b>>2]|0;p=((f[g>>2]|0)-(f[q>>2]|0)>>2)+h|0;if((p|0)>0){m=q+(p>>>10<<2)|0;f[b>>2]=m;D=(f[m>>2]|0)+((p&1023)<<2)|0}else{m=1023-p|0;p=q+(((m|0)/-1024|0)<<2)|0;f[b>>2]=p;D=(f[p>>2]|0)+(1023-((m|0)%1024|0)<<2)|0}f[g>>2]=D}if((r|0)<=0){E=n;F=o;break}i=r;j=n;e=o;c=f[g>>2]|0}G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}g=d;E=f[g>>2]|0;F=f[g+4>>2]|0;G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}function $na(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;c=u;u=u+32|0;d=c;e=a+8|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;j=((g|0)==(i|0)&1)+b|0;b=((j&1023|0)!=0&1)+(j>>>10)|0;j=a+16|0;k=f[j>>2]|0;l=k>>>10;m=b>>>0<l>>>0?b:l;n=b-m|0;o=g;if(!n){f[j>>2]=k-(m<<10);if(!m){u=c;return}k=a+12|0;p=m;q=i;r=g;a:while(1){s=f[q>>2]|0;t=q+4|0;f[h>>2]=t;v=f[k>>2]|0;w=v;x=r;do if((r|0)==(v|0)){y=f[a>>2]|0;z=y;if(t>>>0>y>>>0){A=t;B=((A-z>>2)+1|0)/-2|0;C=t+(B<<2)|0;D=x-A|0;A=D>>2;if(!A)E=t;else{fJc(C|0,t|0,D|0)|0;E=f[h>>2]|0}D=C+(A<<2)|0;f[e>>2]=D;f[h>>2]=E+(B<<2);F=D;break}D=w-z>>1;z=(D|0)==0?1:D;if(z>>>0>1073741823){G=10;break a}D=VDc(z<<2)|0;B=D;A=D+(z>>>2<<2)|0;C=A;H=D+(z<<2)|0;if((t|0)==(r|0)){I=C;J=y}else{y=A;A=C;z=t;do{f[y>>2]=f[z>>2];y=A+4|0;A=y;z=z+4|0}while((z|0)!=(r|0));I=A;J=f[a>>2]|0}f[a>>2]=B;f[h>>2]=C;f[e>>2]=I;f[k>>2]=H;if(!J)F=I;else{YDc(J);F=f[e>>2]|0}}else F=r;while(0);f[F>>2]=s;t=(f[e>>2]|0)+4|0;f[e>>2]=t;w=p+-1|0;if(!w){G=92;break}p=w;q=f[h>>2]|0;r=t}if((G|0)==10){r=af(8)|0;bEc(r,503977);f[r>>2]=185532;ig(r|0,23696,1627)}else if((G|0)==92){u=c;return}}r=a+12|0;q=f[r>>2]|0;p=q-(f[a>>2]|0)|0;F=o-i>>2;if(n>>>0<=((p>>2)-F|0)>>>0){b:do if((q|0)!=(o|0)){i=n;J=q;I=g;c:while(1){k=J;E=VDc(4096)|0;t=I;do if((I|0)==(k|0)){w=f[h>>2]|0;x=f[a>>2]|0;v=x;if(w>>>0>x>>>0){z=w;y=((z-v>>2)+1|0)/-2|0;D=w+(y<<2)|0;K=t-z|0;z=K>>2;if(!z)L=w;else{fJc(D|0,w|0,K|0)|0;L=f[h>>2]|0}K=D+(z<<2)|0;f[e>>2]=K;f[h>>2]=L+(y<<2);M=K;break}K=J-v>>1;v=(K|0)==0?1:K;if(v>>>0>1073741823){G=28;break c}K=VDc(v<<2)|0;y=K;z=K+(v>>>2<<2)|0;D=z;N=K+(v<<2)|0;if((w|0)==(k|0)){O=D;P=x}else{x=z;z=D;v=w;do{f[x>>2]=f[v>>2];x=z+4|0;z=x;v=v+4|0}while((v|0)!=(k|0));O=z;P=f[a>>2]|0}f[a>>2]=y;f[h>>2]=D;f[e>>2]=O;f[r>>2]=N;if(!P)M=O;else{YDc(P);M=f[e>>2]|0}}else M=I;while(0);f[M>>2]=E;I=(f[e>>2]|0)+4|0;f[e>>2]=I;k=i+-1|0;if(!k){G=20;break}J=f[r>>2]|0;if((J|0)==(I|0)){Q=k;G=21;break b}else i=k}if((G|0)==20){R=m;S=f[j>>2]|0;T=I;break}else if((G|0)==28){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}}else{Q=n;G=21}while(0);if((G|0)==21){M=~(b>>>0>l>>>0?l:b);b=Q;do{l=VDc(4096)|0;f[d>>2]=l;Sna(a,d);b=b+-1|0;U=f[e>>2]|0;V=(f[j>>2]|0)+1024+(((U-(f[h>>2]|0)|0)==4)<<31>>31)|0;f[j>>2]=V}while((b|0)!=0);R=Q+-1-M|0;S=V;T=U}f[j>>2]=S-(R<<10);if(!R){u=c;return}S=R;R=T;d:while(1){T=f[h>>2]|0;U=f[T>>2]|0;V=T+4|0;f[h>>2]=V;T=f[r>>2]|0;M=T;Q=R;do if((R|0)==(T|0)){b=f[a>>2]|0;l=b;if(V>>>0>b>>>0){P=V;O=((P-l>>2)+1|0)/-2|0;L=V+(O<<2)|0;g=Q-P|0;P=g>>2;if(!P)W=V;else{fJc(L|0,V|0,g|0)|0;W=f[h>>2]|0}g=L+(P<<2)|0;f[e>>2]=g;f[h>>2]=W+(O<<2);X=g;break}g=M-l>>1;l=(g|0)==0?1:g;if(l>>>0>1073741823){G=46;break d}g=VDc(l<<2)|0;O=g;P=g+(l>>>2<<2)|0;L=P;q=g+(l<<2)|0;if((V|0)==(R|0)){Y=L;Z=b}else{b=P;P=L;l=V;do{f[b>>2]=f[l>>2];b=P+4|0;P=b;l=l+4|0}while((l|0)!=(R|0));Y=P;Z=f[a>>2]|0}f[a>>2]=O;f[h>>2]=L;f[e>>2]=Y;f[r>>2]=q;if(!Z)X=Y;else{YDc(Z);X=f[e>>2]|0}}else X=R;while(0);f[X>>2]=U;R=(f[e>>2]|0)+4|0;f[e>>2]=R;S=S+-1|0;if(!S){G=92;break}}if((G|0)==46){S=af(8)|0;bEc(S,503977);f[S>>2]=185532;ig(S|0,23696,1627)}else if((G|0)==92){u=c;return}}S=m<<10;R=p>>1;p=F+n|0;X=R>>>0<p>>>0?p:R;R=F-m|0;f[d+12>>2]=0;f[d+16>>2]=a+12;do if(X)if(X>>>0>1073741823){F=af(8)|0;bEc(F,503977);f[F>>2]=185532;ig(F|0,23696,1627)}else{_=VDc(X<<2)|0;break}else _=0;while(0);f[d>>2]=_;F=_+(R<<2)|0;R=d+8|0;f[R>>2]=F;p=d+4|0;f[p>>2]=F;Z=d+12|0;f[Z>>2]=_+(X<<2);X=n;n=F;e:do{F=VDc(4096)|0;_=f[Z>>2]|0;Y=_;W=n;do if((n|0)==(_|0)){V=f[p>>2]|0;M=f[d>>2]|0;Q=M;if(V>>>0>M>>>0){T=V;I=V+((((T-Q>>2)+1|0)/-2|0)<<2)|0;l=W-T|0;T=l>>2;if(T|0)fJc(I|0,V|0,l|0)|0;l=I+(T<<2)|0;f[R>>2]=l;f[p>>2]=I;$=l;break}l=Y-Q>>1;Q=(l|0)==0?1:l;if(Q>>>0>1073741823){G=66;break e}l=VDc(Q<<2)|0;I=l;T=l+(Q>>>2<<2)|0;b=T;E=l+(Q<<2)|0;if((V|0)==(n|0))aa=b;else{Q=T;T=b;l=V;while(1){f[Q>>2]=f[l>>2];Q=T+4|0;V=Q;l=l+4|0;if((l|0)==(n|0)){aa=V;break}else T=V}}f[d>>2]=I;f[p>>2]=b;f[R>>2]=aa;f[Z>>2]=E;T=aa;if(!M)$=T;else{YDc(M);$=T}}else $=n;while(0);f[$>>2]=F;n=(f[R>>2]|0)+4|0;f[R>>2]=n;X=X+-1|0}while((X|0)!=0);if((G|0)==66){G=af(8)|0;bEc(G,503977);f[G>>2]=185532;ig(G|0,23696,1627)}f:do if(m|0){G=m;X=n;$=f[h>>2]|0;g:while(1){aa=f[Z>>2]|0;Y=aa;W=X;do if((X|0)==(aa|0)){_=f[p>>2]|0;U=f[d>>2]|0;T=U;if(_>>>0>U>>>0){l=_;Q=_+((((l-T>>2)+1|0)/-2|0)<<2)|0;q=W-l|0;l=q>>2;if(l|0)fJc(Q|0,_|0,q|0)|0;q=Q+(l<<2)|0;f[R>>2]=q;f[p>>2]=Q;ba=q;break}q=Y-T>>1;T=(q|0)==0?1:q;if(T>>>0>1073741823)break g;q=VDc(T<<2)|0;Q=q;l=q+(T>>>2<<2)|0;L=l;O=q+(T<<2)|0;if((_|0)==(X|0))ca=L;else{T=l;l=L;q=_;while(1){f[T>>2]=f[q>>2];T=l+4|0;_=T;q=q+4|0;if((q|0)==(X|0)){ca=_;break}else l=_}}f[d>>2]=Q;f[p>>2]=L;f[R>>2]=ca;f[Z>>2]=O;l=ca;if(!U)ba=l;else{YDc(U);ba=l}}else ba=X;while(0);f[ba>>2]=f[$>>2];X=(f[R>>2]|0)+4|0;f[R>>2]=X;$=(f[h>>2]|0)+4|0;f[h>>2]=$;G=G+-1|0;if(!G)break f}G=af(8)|0;bEc(G,503977);f[G>>2]=185532;ig(G|0,23696,1627)}while(0);ba=f[e>>2]|0;while(1){da=f[h>>2]|0;if((ba|0)==(da|0))break;ca=ba+-4|0;Tna(d,ca);ba=ca}ca=da;da=f[a>>2]|0;f[a>>2]=f[d>>2];f[d>>2]=da;f[h>>2]=f[p>>2];f[p>>2]=ca;p=f[e>>2]|0;f[e>>2]=f[R>>2];f[R>>2]=p;e=f[r>>2]|0;f[r>>2]=f[Z>>2];f[Z>>2]=e;f[j>>2]=(f[j>>2]|0)-S;S=p;if((S|0)!=(ba|0))f[R>>2]=S+(~((S+-4-ca|0)>>>2)<<2);if(da|0)YDc(da);u=c;return}function aoa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=c+4|0;g=f[e>>2]|0;h=f[b+4>>2]|0;if((g|0)!=(h|0)?(i=f[c>>2]|0,j=f[b>>2]|0,b=(g-(f[i>>2]|0)>>2)+(i-j<<8)-(h-(f[j>>2]|0)>>2)|0,(b|0)>0):0){j=b;b=f[c>>2]|0;h=g;while(1){if((h|0)==(f[b>>2]|0)){g=b+-4|0;f[c>>2]=g;i=(f[g>>2]|0)+4096|0;f[e>>2]=i;k=i;l=g}else{k=h;l=b}g=k+-4|0;f[e>>2]=g;i=f[l>>2]|0;m=k-i>>2;n=(m|0)>(j|0);o=n?k+(0-j<<2)|0:i;i=n?j:m;m=d;n=f[m>>2]|0;p=f[m+4>>2]|0;m=g;if((k|0)==(o|0)){q=n;r=p}else{s=o;t=k;u=n;n=p;while(1){p=u;v=u;w=n-(f[v>>2]|0)|0;x=w>>2;y=x+-1|0;if((w|0)>4){w=p+(y>>>10<<2)|0;z=(f[w>>2]|0)+((y&1023)<<2)|0;A=w}else{w=1024-x|0;x=p+(((w|0)/-1024|0)<<2)|0;z=(f[x>>2]|0)+(1023-((w|0)%1024|0)<<2)|0;A=x}x=z+4|0;w=x-(f[A>>2]|0)>>2;y=t;B=y-s>>2;C=(B|0)>(w|0);D=C?w:B;t=C?t+(0-w<<2)|0:o;w=y-t|0;y=w>>2;if(y|0)fJc(x+(0-y<<2)|0,t|0,w|0)|0;if(!D){E=u;F=n}else{w=(n-(f[v>>2]|0)>>2)-D|0;if((w|0)>0){D=p+(w>>>10<<2)|0;G=(f[D>>2]|0)+((w&1023)<<2)|0;H=D}else{D=1023-w|0;w=p+(((D|0)/-1024|0)<<2)|0;G=(f[w>>2]|0)+(1023-((D|0)%1024|0)<<2)|0;H=w}E=H;F=G}if((t|0)==(o|0)){q=E;r=F;break}else{u=E;n=F}}}n=d;f[n>>2]=q;f[n+4>>2]=r;j=j-i|0;n=i+-1|0;if(!n){I=l;J=g}else{u=(m-(f[l>>2]|0)>>2)-n|0;if((u|0)>0){n=l+(u>>>10<<2)|0;f[c>>2]=n;K=(f[n>>2]|0)+((u&1023)<<2)|0;L=n}else{n=1023-u|0;u=l+(((n|0)/-1024|0)<<2)|0;f[c>>2]=u;K=(f[u>>2]|0)+(1023-((n|0)%1024|0)<<2)|0;L=u}f[e>>2]=K;I=L;J=K}if((j|0)<=0){M=q;N=r;break}else{b=I;h=J}}O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}J=d;M=f[J>>2]|0;N=f[J+4>>2]|0;O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}function boa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=c+4|0;g=f[e>>2]|0;h=f[b+4>>2]|0;if((g|0)!=(h|0)?(i=f[c>>2]|0,j=f[b>>2]|0,b=(g-(f[i>>2]|0)>>2)+(i-j<<8)-(h-(f[j>>2]|0)>>2)|0,(b|0)>0):0){j=b;b=f[c>>2]|0;h=g;while(1){if((h|0)==(f[b>>2]|0)){g=b+-4|0;f[c>>2]=g;i=(f[g>>2]|0)+4096|0;f[e>>2]=i;k=i;l=g}else{k=h;l=b}g=k+-4|0;f[e>>2]=g;i=f[l>>2]|0;m=k-i>>2;n=(m|0)>(j|0);o=n?k+(0-j<<2)|0:i;i=n?j:m;m=d;n=f[m>>2]|0;p=f[m+4>>2]|0;m=g;if((k|0)==(o|0)){q=n;r=p}else{s=o;t=k;u=n;n=p;while(1){p=u;v=u;w=n-(f[v>>2]|0)|0;x=w>>2;y=x+-1|0;if((w|0)>4){w=p+(y>>>10<<2)|0;z=(f[w>>2]|0)+((y&1023)<<2)|0;A=w}else{w=1024-x|0;x=p+(((w|0)/-1024|0)<<2)|0;z=(f[x>>2]|0)+(1023-((w|0)%1024|0)<<2)|0;A=x}x=z+4|0;w=x-(f[A>>2]|0)>>2;y=t;B=y-s>>2;C=(B|0)>(w|0);D=C?w:B;t=C?t+(0-w<<2)|0:o;w=y-t|0;y=w>>2;if(y|0)fJc(x+(0-y<<2)|0,t|0,w|0)|0;if(!D){E=u;F=n}else{w=(n-(f[v>>2]|0)>>2)-D|0;if((w|0)>0){D=p+(w>>>10<<2)|0;G=(f[D>>2]|0)+((w&1023)<<2)|0;H=D}else{D=1023-w|0;w=p+(((D|0)/-1024|0)<<2)|0;G=(f[w>>2]|0)+(1023-((D|0)%1024|0)<<2)|0;H=w}E=H;F=G}if((t|0)==(o|0)){q=E;r=F;break}else{u=E;n=F}}}n=d;f[n>>2]=q;f[n+4>>2]=r;j=j-i|0;n=i+-1|0;if(!n){I=l;J=g}else{u=(m-(f[l>>2]|0)>>2)-n|0;if((u|0)>0){n=l+(u>>>10<<2)|0;f[c>>2]=n;K=(f[n>>2]|0)+((u&1023)<<2)|0;L=n}else{n=1023-u|0;u=l+(((n|0)/-1024|0)<<2)|0;f[c>>2]=u;K=(f[u>>2]|0)+(1023-((n|0)%1024|0)<<2)|0;L=u}f[e>>2]=K;I=L;J=K}if((j|0)<=0){M=q;N=r;break}else{b=I;h=J}}O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}J=d;M=f[J>>2]|0;N=f[J+4>>2]|0;O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}function coa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;i=u;u=u+320|0;j=i+312|0;k=i+304|0;l=i+248|0;m=i+192|0;n=i+136|0;o=i+112|0;p=i+56|0;q=i+48|0;r=i;if((n$(a,-1)|0)!=2){f[j>>2]=0;f[j+4>>2]=0;s=tT(j,15)|0;t=269327;v=s+15|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,j,269072,269078,1061)}if((c$(a,-1)|0)!=3?(c$(a,-1)|0)!=19:0){f[j>>2]=0;f[j+4>>2]=0;s=tT(j,48)|0;t=269343;v=s+48|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,j,269072,269078,1062)}w=c$(c,-1)|0;if((w|0)!=(c$(a,-1)|0)){f[j>>2]=0;f[j+4>>2]=0;s=tT(j,24)|0;t=269392;v=s+24|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,j,269072,269078,1063)}if(!(m$(a,c)|0)){f[j>>2]=0;f[j+4>>2]=0;s=tT(j,17)|0;t=269417;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,j,269072,269078,1064)}t=e>g;x=t?e:g;y=t?g:e;b$(j,a,-1);f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];v$(d,k,0,-1,0,0);do if((d$(d)|0)==65536){k=f[d+4>>2]|0;f[l>>2]=f[k>>2];j=l+4|0;t=k+4|0;f[j>>2]=f[t>>2];w=l+8|0;f[w>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];z=f[k+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=w;w=l+48|0;A=l+44|0;f[A>>2]=w;f[w>>2]=0;f[l+52>>2]=0;if(z|0){w=z+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[t>>2]|0)<3){t=f[k+44>>2]|0;w=f[A>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2];break}else{f[j>>2]=0;ZS(l,k);break}}else a$(l,d,-1);while(0);do if((d$(a)|0)==65536){d=f[a+4>>2]|0;f[m>>2]=f[d>>2];k=m+4|0;j=d+4|0;f[k>>2]=f[j>>2];t=m+8|0;f[t>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];w=f[d+36>>2]|0;f[m+36>>2]=w;f[m+40>>2]=t;t=m+48|0;A=m+44|0;f[A>>2]=t;f[t>>2]=0;f[m+52>>2]=0;if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[j>>2]|0)<3){j=f[d+44>>2]|0;t=f[A>>2]|0;f[t>>2]=f[j>>2];f[t+4>>2]=f[j+4>>2];break}else{f[k>>2]=0;ZS(m,d);break}}else a$(m,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[n>>2]=f[a>>2];d=n+4|0;k=a+4|0;f[d>>2]=f[k>>2];j=n+8|0;f[j>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[n+36>>2]=t;f[n+40>>2]=j;j=n+48|0;A=n+44|0;f[A>>2]=j;f[j>>2]=0;f[n+52>>2]=0;if(t|0){j=t+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+44>>2]|0;j=f[A>>2]|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];break}else{f[d>>2]=0;ZS(n,a);break}}else a$(n,c,-1);while(0);if(h){e=y<32767.0?y:32767.0;g=x<32767.0?x:32767.0;B=e>0.0?e*e:e;if(g>0.0){C=g*g;D=B}else{C=g;D=B}}else{C=x;D=y}c=~~D;a=c-(+(c|0)>D&1)|0;c=~~C;d=c-(+(c|0)>C&1)|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[p>>2]=1124007936;c=p+4|0;k=p+8|0;j=p+40|0;s=c;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[j>>2]=k;k=p+48|0;s=p+44|0;f[s>>2]=k;f[k>>2]=0;f[p+52>>2]=0;v=z8()|0;A=A8()|0;t=(A|0)<(v|0)?A:v;v=(t|0)>1?t:1;t=m+8|0;A=f[t>>2]|0;if(((A|0)/(v|0)|0|0)<3){w=(A|0)/3|0;E=(w|0)>1?w:1}else E=v;f[q>>2]=0;f[q+4>>2]=A;doa(r,m,n,p,o,a,d,h);y8(q,r,+(E|0));f[r>>2]=57740;l6(r+44|0);E=f[p+12>>2]|0;h=o+20|0;d=f[h>>2]|0;if(d|0){a=o+16|0;A=o+4|0;v=o+8|0;w=0-E|0;z=~E;F=1-E|0;G=E+-1|0;H=E+1|0;I=d;while(1){d=f[a>>2]|0;J=I+-1|0;K=d+J|0;L=f[A>>2]|0;M=f[(f[L+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]|0;f[h>>2]=J;J=f[v>>2]|0;K=J-L|0;if((1-I-d+((K|0)==0?0:(K<<8)+-1|0)|0)>>>0>2047){YDc(f[J+-4>>2]|0);f[v>>2]=(f[v>>2]|0)+-4}J=M+w|0;if(!(b[M+z>>0]|0)){K=J+-1|0;b[K>>0]=2;d=f[A>>2]|0;L=(f[v>>2]|0)-d|0;N=f[a>>2]|0;O=f[h>>2]|0;if((((L|0)==0?0:(L<<8)+-1|0)|0)==(O+N|0)){Ona(o);P=f[a>>2]|0;Q=f[h>>2]|0;R=f[A>>2]|0}else{P=N;Q=O;R=d}d=Q+P|0;f[(f[R+(d>>>10<<2)>>2]|0)+((d&1023)<<2)>>2]=K;f[h>>2]=Q+1}if(!(b[J>>0]|0)){b[J>>0]=2;K=f[A>>2]|0;d=(f[v>>2]|0)-K|0;O=f[a>>2]|0;N=f[h>>2]|0;if((((d|0)==0?0:(d<<8)+-1|0)|0)==(N+O|0)){Ona(o);S=f[a>>2]|0;T=f[h>>2]|0;U=f[A>>2]|0}else{S=O;T=N;U=K}K=T+S|0;f[(f[U+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=T+1}if(!(b[M+F>>0]|0)){J=M+w+1|0;b[J>>0]=2;K=f[A>>2]|0;N=(f[v>>2]|0)-K|0;O=f[a>>2]|0;d=f[h>>2]|0;if((((N|0)==0?0:(N<<8)+-1|0)|0)==(d+O|0)){Ona(o);V=f[a>>2]|0;W=f[h>>2]|0;X=f[A>>2]|0}else{V=O;W=d;X=K}K=W+V|0;f[(f[X+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=W+1}J=M+-1|0;if(!(b[J>>0]|0)){b[J>>0]=2;K=f[A>>2]|0;d=(f[v>>2]|0)-K|0;O=f[a>>2]|0;N=f[h>>2]|0;if((((d|0)==0?0:(d<<8)+-1|0)|0)==(N+O|0)){Ona(o);Z=f[a>>2]|0;_=f[h>>2]|0;$=f[A>>2]|0}else{Z=O;_=N;$=K}K=_+Z|0;f[(f[$+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=_+1}J=M+1|0;if(!(b[J>>0]|0)){b[J>>0]=2;K=f[A>>2]|0;N=(f[v>>2]|0)-K|0;O=f[a>>2]|0;d=f[h>>2]|0;if((((N|0)==0?0:(N<<8)+-1|0)|0)==(d+O|0)){Ona(o);aa=f[a>>2]|0;ba=f[h>>2]|0;ca=f[A>>2]|0}else{aa=O;ba=d;ca=K}K=ba+aa|0;f[(f[ca+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=ba+1}J=M+E|0;if(!(b[M+G>>0]|0)){K=J+-1|0;b[K>>0]=2;d=f[A>>2]|0;O=(f[v>>2]|0)-d|0;N=f[a>>2]|0;L=f[h>>2]|0;if((((O|0)==0?0:(O<<8)+-1|0)|0)==(L+N|0)){Ona(o);da=f[a>>2]|0;ea=f[h>>2]|0;fa=f[A>>2]|0}else{da=N;ea=L;fa=d}d=ea+da|0;f[(f[fa+(d>>>10<<2)>>2]|0)+((d&1023)<<2)>>2]=K;f[h>>2]=ea+1}if(!(b[J>>0]|0)){b[J>>0]=2;K=f[A>>2]|0;d=(f[v>>2]|0)-K|0;L=f[a>>2]|0;N=f[h>>2]|0;if((((d|0)==0?0:(d<<8)+-1|0)|0)==(N+L|0)){Ona(o);ga=f[a>>2]|0;ha=f[h>>2]|0;ia=f[A>>2]|0}else{ga=L;ha=N;ia=K}K=ha+ga|0;f[(f[ia+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=ha+1}if(!(b[M+H>>0]|0)){J=M+E+1|0;b[J>>0]=2;M=f[A>>2]|0;K=(f[v>>2]|0)-M|0;N=f[a>>2]|0;L=f[h>>2]|0;if((((K|0)==0?0:(K<<8)+-1|0)|0)==(L+N|0)){Ona(o);ja=f[a>>2]|0;ka=f[h>>2]|0;la=f[A>>2]|0}else{ja=N;ka=L;la=M}M=ka+ja|0;f[(f[la+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=J;J=ka+1|0;f[h>>2]=J;ma=J}else ma=f[h>>2]|0;if(!ma)break;else I=ma}}ma=f[t>>2]|0;f[q>>2]=0;f[q+4>>2]=ma;f[r>>2]=57760;f[r+4>>2]=p;f[r+8>>2]=l;t=m+4|0;I=f[t>>2]|0;if((I|0)<3)na=Y(f[m+12>>2]|0,ma)|0;else{ma=f[m+40>>2]|0;h=0;ka=1;while(1){la=Y(f[ma+(h<<2)>>2]|0,ka)|0;h=h+1|0;if((h|0)==(I|0)){na=la;break}else ka=la}}y8(q,r,+(na>>>0)*.0000152587890625);na=p+36|0;r=f[na>>2]|0;if(r|0?(q=r+12|0,r=f[q>>2]|0,f[q>>2]=r+-1,(r|0)==1):0)_S(p);f[na>>2]=0;na=p+16|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[c>>2]|0)>0){na=f[j>>2]|0;j=0;do{f[na+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[c>>2]|0))}c=f[s>>2]|0;if((c|0)!=(k|0))g0(c);Pna(o);o=n+36|0;c=f[o>>2]|0;if(c|0?(k=c+12|0,c=f[k>>2]|0,f[k>>2]=c+-1,(c|0)==1):0)_S(n);f[o>>2]=0;o=n+16|0;c=n+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[c>>2]|0)>0){o=f[n+40>>2]|0;k=0;do{f[o+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[c>>2]|0))}c=f[n+44>>2]|0;if((c|0)!=(n+48|0))g0(c);c=m+36|0;n=f[c>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)_S(m);f[c>>2]=0;c=m+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[t>>2]|0)>0){c=f[m+40>>2]|0;n=0;do{f[c+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[t>>2]|0))}t=f[m+44>>2]|0;if((t|0)!=(m+48|0))g0(t);t=l+36|0;m=f[t>>2]|0;do if(m|0){n=m+12|0;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1)break;_S(l)}while(0);f[t>>2]=0;t=l+16|0;m=l+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[m>>2]|0)>0){t=f[l+40>>2]|0;c=0;do{f[t+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=i;return}g0(m);u=i;return}function doa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=u;u=u+144|0;l=k+120|0;m=k;n=k+64|0;o=k+8|0;f[a>>2]=57740;q=a+4|0;f[q>>2]=c;f[a+8>>2]=d;d=a+12|0;f[d>>2]=e;f[a+16>>2]=g;f[a+20>>2]=h;f[a+24>>2]=i;f[a+28>>2]=0;b[a+32>>0]=j&1;k6(a+44|0);j=f[q>>2]|0;i=(f[j+8>>2]|0)+2|0;h=(f[j+12>>2]|0)+2|0;j=e+4|0;if(!(((((f[j>>2]|0)<3?(f[e+8>>2]|0)==(i|0):0)?(f[e+12>>2]|0)==(h|0):0)?(f[e>>2]&4095|0)==0:0)?(f[e+16>>2]|0)!=0:0)){f[l>>2]=i;f[l+4>>2]=h;XS(e,2,l,0)}h=f[d>>2]|0;if((h|0)==(e|0))r=e;else{i=e+36|0;g=f[i>>2]|0;if(g|0){c=g+12|0;f[c>>2]=(f[c>>2]|0)+1}c=h+36|0;g=f[c>>2]|0;if(g|0?(s=g+12|0,g=f[s>>2]|0,f[s>>2]=g+-1,(g|0)==1):0)_S(h);f[c>>2]=0;g=h+16|0;s=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[s>>2]|0)>0){t=f[h+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0;w=f[s>>2]|0}while((v|0)<(w|0));f[h>>2]=f[e>>2];if((w|0)<3)x=18;else x=20}else{f[h>>2]=f[e>>2];x=18}if((x|0)==18){w=f[j>>2]|0;if((w|0)<3){f[s>>2]=w;f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];w=f[e+44>>2]|0;s=f[h+44>>2]|0;f[s>>2]=f[w>>2];f[s+4>>2]=f[w+4>>2]}else x=20}if((x|0)==20)ZS(h,e);f[g>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];f[c>>2]=f[i>>2];r=f[d>>2]|0}f[l>>2]=0;f[l+4>>2]=1;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;$S(n,r,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;l_(n,l,e0()|0)|0;r=n+36|0;i=f[r>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)_S(n);f[r>>2]=0;r=n+16|0;i=n+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[i>>2]|0)>0){r=f[n+40>>2]|0;c=0;do{f[r+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))g0(i);i=f[d>>2]|0;n=f[(f[q>>2]|0)+8>>2]|0;f[l>>2]=n+1;f[l+4>>2]=n+2;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;$S(o,i,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;l_(o,l,e0()|0)|0;l=o+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)_S(o);f[l>>2]=0;l=o+16|0;m=o+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[o+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[o+44>>2]|0;if((m|0)==(o+48|0)){y=f[d>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=0;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}g0(m);y=f[d>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=0;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}function eoa(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+144|0;i=h+88|0;j=h+32|0;k=h+16|0;l=h;O4(i,a,0,1,0,0);O4(j,c,0,1,0,0);c=i+40|0;a=f[c>>2]|0;m=f[a+-4>>2]|0;n=j+40|0;o=f[n>>2]|0;a:do if((m|0)==(f[o+-4>>2]|0)){if((m|0)==2){if((f[a>>2]|0)!=(f[o>>2]|0))break;if((f[a+4>>2]|0)!=(f[o+4>>2]|0))break}else if((m|0)>0){p=0;do{if((f[a+(p<<2)>>2]|0)!=(f[o+(p<<2)>>2]|0))break a;p=p+1|0}while((p|0)<(m|0))}if((f[i>>2]&7|0)==0?(f[j>>2]&4095|0)==0:0){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=i;p=l+8|0;f[p>>2]=0;f[p+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;Mna(k,l,d,e,g&255,(g|0)<0);p=j+36|0;q=f[p>>2]|0;if(q|0?(r=q+12|0,q=f[r>>2]|0,f[r>>2]=q+-1,(q|0)==1):0)_S(j);f[p>>2]=0;p=j+16|0;q=j+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[n>>2]|0;r=0;do{f[p+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[j+44>>2]|0;if((q|0)!=(j+48|0))g0(q);q=i+36|0;r=f[q>>2]|0;if(r|0?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)_S(i);f[q>>2]=0;q=i+16|0;r=i+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[r>>2]|0)>0){q=f[c>>2]|0;p=0;do{f[q+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[r>>2]|0))}r=f[i+44>>2]|0;if((r|0)==(i+48|0)){u=h;return}g0(r);u=h;return}}while(0);f[k>>2]=0;f[k+4>>2]=0;h=tT(k,67)|0;i=269435;c=h+67|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(c|0));z5(-215,k,269503,269078,1133)}function foa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;m=u;u=u+432|0;o=m+48|0;q=m+368|0;r=m+312|0;s=m+256|0;t=m+32|0;v=m+176|0;w=m+120|0;x=m+64|0;y=m+248|0;z=m;A=m+192|0;if(!((d|0)>-1&(e>0.0&g>=0.0))){f[o>>2]=0;f[o+4>>2]=0;B=tT(o,55)|0;C=269511;D=B+55|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,o,269567,269587,368)}if(!(r$(h)|0)){if(c$(h,-1)|0){f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,68)|0;B=F;C=269662;D=B+68|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,o,269567,269587,369)}if(!(m$(h,a)|0)){f[o>>2]=0;E=o+4|0;f[E>>2]=0;F=tT(o,68)|0;B=F;C=269662;D=B+68|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,o,269567,269587,369)}}do if((d$(a)|0)==65536){C=f[a+4>>2]|0;f[q>>2]=f[C>>2];F=q+4|0;E=C+4|0;f[F>>2]=f[E>>2];G=q+8|0;f[G>>2]=f[C+8>>2];f[q+12>>2]=f[C+12>>2];H=q+16|0;f[H>>2]=f[C+16>>2];f[q+20>>2]=f[C+20>>2];f[q+24>>2]=f[C+24>>2];f[q+28>>2]=f[C+28>>2];f[q+32>>2]=f[C+32>>2];I=f[C+36>>2]|0;f[q+36>>2]=I;f[q+40>>2]=G;G=q+48|0;J=q+44|0;f[J>>2]=G;f[G>>2]=0;f[q+52>>2]=0;if(I|0){G=I+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;G=f[J>>2]|0;f[G>>2]=f[E>>2];f[G+4>>2]=f[E+4>>2];K=H;break}else{f[F>>2]=0;ZS(q,C);K=H;break}}else{a$(q,a,-1);K=q+16|0}while(0);f[r>>2]=1124007936;a=r+4|0;H=r+8|0;C=r+40|0;B=a;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[C>>2]=H;H=r+48|0;F=r+44|0;f[F>>2]=H;f[H>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;E=s+4|0;G=s+8|0;J=s+40|0;B=E;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[J>>2]=G;G=s+48|0;I=s+44|0;f[I>>2]=G;f[G>>2]=0;f[s+52>>2]=0;if(f[K>>2]|0){L=f[q+4>>2]|0;if((L|0)<3)M=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{N=f[q+40>>2]|0;O=0;P=1;while(1){Q=Y(f[N+(O<<2)>>2]|0,P)|0;O=O+1|0;if((O|0)==(L|0)){M=Q;break}else P=Q}}if(!((L|0)==0|(M|0)==0)){if(k){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=q;k=t+8|0;f[k>>2]=0;f[k+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=r;Epa(o,t,i,j,l,4)}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=q;k=t+8|0;f[k>>2]=0;f[k+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=r;Bpa(o,t,i,j,4)}p[t>>3]=0.0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;ET(o,0,t,0,0,h);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;j=v+8|0;f[j>>2]=0;f[j+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=r;+Cxa(o,v,+p[t>>3]*e,0.0,3);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;t=v+8|0;f[t>>2]=0;f[t+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;f[x>>2]=1124007936;t=x+4|0;j=x+8|0;i=x+40|0;B=t;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[i>>2]=j;j=x+48|0;B=x+44|0;f[B>>2]=j;f[j>>2]=0;f[x+52>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=x;f[y>>2]=-1;f[y+4>>2]=-1;p[z>>3]=1797693134862315708145274.0e284;p[z+8>>3]=1797693134862315708145274.0e284;p[z+16>>3]=1797693134862315708145274.0e284;p[z+24>>3]=1797693134862315708145274.0e284;bka(o,v,w,y,1,0,z);y=x+36|0;D=f[y>>2]|0;if(D|0?(k=D+12|0,D=f[k>>2]|0,f[k>>2]=D+-1,(D|0)==1):0)_S(x);f[y>>2]=0;y=x+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[t>>2]|0)>0){y=f[i>>2]|0;i=0;do{f[y+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[t>>2]|0))}t=f[B>>2]|0;if((t|0)!=(j|0))g0(t);t=f[q+40>>2]|0;j=f[t+4>>2]|0;B=f[t>>2]|0;f[v>>2]=0;t=v+4|0;f[t>>2]=0;f[v+8>>2]=0;do if((d$(h)|0)==65536){i=f[h+4>>2]|0;f[w>>2]=f[i>>2];y=w+4|0;D=i+4|0;f[y>>2]=f[D>>2];k=w+8|0;f[k>>2]=f[i+8>>2];f[w+12>>2]=f[i+12>>2];f[w+16>>2]=f[i+16>>2];f[w+20>>2]=f[i+20>>2];f[w+24>>2]=f[i+24>>2];f[w+28>>2]=f[i+28>>2];f[w+32>>2]=f[i+32>>2];M=f[i+36>>2]|0;f[w+36>>2]=M;f[w+40>>2]=k;k=w+48|0;L=w+44|0;f[L>>2]=k;f[k>>2]=0;f[w+52>>2]=0;if(M|0){k=M+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[D>>2]|0)<3){D=f[i+44>>2]|0;k=f[L>>2]|0;f[k>>2]=f[D>>2];f[k+4>>2]=f[D+4>>2];break}else{f[y>>2]=0;ZS(w,i);break}}else a$(w,h,-1);while(0);h=B+-1|0;if((h|0)>1?(B=r+16|0,i=s+16|0,y=w+16|0,D=j+-1|0,j=v+8|0,k=w+44|0,(D|0)>1):0){L=1;do{M=(f[B>>2]|0)+(Y(f[f[F>>2]>>2]|0,L)|0)|0;P=(f[i>>2]|0)+(Y(f[f[I>>2]>>2]|0,L)|0)|0;O=f[y>>2]|0;if((O|0)!=0?(N=O+(Y(f[f[k>>2]>>2]|0,L)|0)|0,(N|0)!=0):0){O=1;do{Q=M+(O<<2)|0;e=+n[Q>>2];do if(e!=0.0){if(!(e==+n[P+(O<<2)>>2]))break;if(!(b[N+O>>0]|0))break;f[o>>2]=Q;R=f[t>>2]|0;if((R|0)==(f[j>>2]|0))goa(v,o);else{f[R>>2]=Q;f[t>>2]=(f[t>>2]|0)+4}}while(0);O=O+1|0}while((O|0)<(D|0))}else{S=1;T=52}if((T|0)==52)while(1){T=0;O=M+(S<<2)|0;e=+n[O>>2];do if(e!=0.0){if(!(e==+n[P+(S<<2)>>2]))break;f[o>>2]=O;N=f[t>>2]|0;if((N|0)==(f[j>>2]|0))goa(v,o);else{f[N>>2]=O;f[t>>2]=(f[t>>2]|0)+4}}while(0);S=S+1|0;if((S|0)>=(D|0))break;else T=52}L=L+1|0}while((L|0)<(h|0))}f[x>>2]=0;h=x+4|0;f[h>>2]=0;f[x+8>>2]=0;L=f[t>>2]|0;D=f[v>>2]|0;S=L-D>>2;do if(!S)u$(c);else{hoa(D,L,o);if(!(g>=1.0)){j=r+16|0;k=o+4|0;y=x+8|0;if((d|0)>0){i=0;do{B=(f[(f[v>>2]|0)+(i<<2)>>2]|0)-(f[j>>2]|0)|0;P=f[H>>2]|0;M=(B>>>0)/(P>>>0)|0;e=+((B-(Y(M,P)|0)|0)>>>2|0);l=+(M|0);n[o>>2]=e;n[k>>2]=l;M=f[h>>2]|0;if((M|0)==(f[y>>2]|0))ioa(x,o);else{n[M>>2]=e;n[M+4>>2]=l;f[h>>2]=M+8}i=i+1|0}while((i|0)!=(d|0)&i>>>0<S>>>0)}else{i=0;do{M=(f[(f[v>>2]|0)+(i<<2)>>2]|0)-(f[j>>2]|0)|0;P=f[H>>2]|0;B=(M>>>0)/(P>>>0)|0;l=+((M-(Y(B,P)|0)|0)>>>2|0);e=+(B|0);n[o>>2]=l;n[k>>2]=e;B=f[h>>2]|0;if((B|0)==(f[y>>2]|0))ioa(x,o);else{n[B>>2]=l;n[B+4>>2]=e;f[h>>2]=B+8}i=i+1|0}while(i>>>0<S>>>0)}}else{i=f[q+12>>2]|0;y=f[q+8>>2]|0;k=nrc(g)|0;j=(i+-1+k|0)/(k|0)|0;i=(y+-1+k|0)/(k|0)|0;joa(o,Y(i,j)|0);e=g*g;y=r+16|0;B=j+-1|0;P=i+-1|0;i=z+4|0;M=z+4|0;O=x+8|0;N=(d|0)>0;Q=0;R=0;while(1){U=(f[(f[v>>2]|0)+(Q<<2)>>2]|0)-(f[y>>2]|0)|0;V=f[H>>2]|0;W=(U>>>0)/(V>>>0)|0;X=(U-(Y(W,V)|0)|0)>>>2;V=(X|0)/(k|0)|0;U=(W|0)/(k|0)|0;Z=V+-1|0;_=U+-1|0;$=V+1|0;aa=U+1|0;ba=(Z|0)>0?Z:0;Z=(_|0)>0?_:0;_=($|0)<(B|0)?$:B;$=(aa|0)<(P|0)?aa:P;do if((Z|0)<=($|0)){aa=f[o>>2]|0;l=+(X|0);ca=+(W|0);if((ba|0)>(_|0)){da=l;ea=ca;fa=aa;T=80;break}else{ga=Z;ha=1}a:while(1){ia=Y(ga,j)|0;ja=ba;ka=ha;while(1){la=ja+ia|0;ma=f[aa+(la*12|0)+4>>2]|0;na=f[aa+(la*12|0)>>2]|0;la=na;if((ma|0)==(na|0))oa=ka;else{pa=ma-na>>3;na=0;ma=ka;while(1){qa=l-+n[la+(na<<3)>>2];ra=ca-+n[la+(na<<3)+4>>2];sa=qa*qa+ra*ra<e;ta=ma&(sa^1);na=na+1|0;if(sa){T=79;break a}if(na>>>0>=pa>>>0){oa=ta;break}else ma=ta}}if((ja|0)<(_|0)){ja=ja+1|0;ka=oa}else break}if((ga|0)<($|0)){ga=ga+1|0;ha=oa}else{T=72;break}}if((T|0)==72){T=0;if(oa){da=l;ea=ca;fa=aa;T=80;break}else{ua=R;break}}else if((T|0)==79){T=0;if(ta){da=l;ea=ca;fa=aa;T=80;break}else{ua=R;break}}}else{da=+(X|0);ea=+(W|0);fa=f[o>>2]|0;T=80}while(0);if((T|0)==80){T=0;W=(Y(U,j)|0)+V|0;n[z>>2]=da;n[i>>2]=ea;X=fa+(W*12|0)+4|0;$=f[X>>2]|0;if(($|0)==(f[fa+(W*12|0)+8>>2]|0))ioa(fa+(W*12|0)|0,z);else{n[$>>2]=da;n[$+4>>2]=ea;f[X>>2]=$+8}n[z>>2]=da;n[M>>2]=ea;$=f[h>>2]|0;if(($|0)==(f[O>>2]|0))ioa(x,z);else{n[$>>2]=da;n[$+4>>2]=ea;f[h>>2]=$+8}$=R+1|0;if(N&($|0)==(d|0))break;else ua=$}Q=Q+1|0;if(Q>>>0>=S>>>0)break;else R=ua}R=f[o>>2]|0;if(R|0){Q=o+4|0;N=f[Q>>2]|0;if((N|0)==(R|0))va=R;else{O=N;while(1){N=O+-12|0;f[Q>>2]=N;M=f[N>>2]|0;if(!M)wa=N;else{N=O+-8|0;i=f[N>>2]|0;if((i|0)!=(M|0))f[N>>2]=i+(~((i+-8-M|0)>>>3)<<3);YDc(M);wa=f[Q>>2]|0}if((wa|0)==(R|0))break;else O=wa}va=f[o>>2]|0}YDc(va)}}f[A>>2]=1124024333;O=A+4|0;f[O>>2]=2;R=A+8|0;Q=f[h>>2]|0;M=f[x>>2]|0;i=Q-M|0;f[R>>2]=i>>3;f[A+12>>2]=1;N=A+16|0;j=A+40|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;f[N+16>>2]=0;f[N+20>>2]=0;f[j>>2]=R;R=A+48|0;P=A+44|0;f[P>>2]=R;f[R>>2]=0;B=A+52|0;f[B>>2]=0;k=M;if((k|0)!=(Q|0)){f[B>>2]=8;f[R>>2]=8;f[N>>2]=k;f[A+20>>2]=k;k=M+i|0;f[A+24>>2]=k;f[A+28>>2]=k}if(X$(c)|0)xa=c$(c,-1)|0;else xa=5;LZ(A,c,xa,1.0,0.0);k=A+36|0;i=f[k>>2]|0;do if(i|0){M=i+12|0;B=f[M>>2]|0;f[M>>2]=B+-1;if((B|0)!=1)break;_S(A)}while(0);f[k>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[O>>2]|0)>0){i=f[j>>2]|0;B=0;do{f[i+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[O>>2]|0))}O=f[P>>2]|0;if((O|0)==(R|0))break;g0(O)}while(0);A=f[x>>2]|0;if(A|0){x=f[h>>2]|0;if((x|0)!=(A|0))f[h>>2]=x+(~((x+-8-A|0)>>>3)<<3);YDc(A)}A=w+36|0;x=f[A>>2]|0;if(x|0?(h=x+12|0,x=f[h>>2]|0,f[h>>2]=x+-1,(x|0)==1):0)_S(w);f[A>>2]=0;A=w+16|0;x=w+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[x>>2]|0)>0){A=f[w+40>>2]|0;h=0;do{f[A+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[x>>2]|0))}x=f[w+44>>2]|0;if((x|0)!=(w+48|0))g0(x);x=f[v>>2]|0;if(x|0){v=f[t>>2]|0;if((v|0)!=(x|0))f[t>>2]=v+(~((v+-4-x|0)>>>2)<<2);YDc(x)}}else T=20}else T=20;if((T|0)==20)u$(c);c=s+36|0;T=f[c>>2]|0;if(T|0?(x=T+12|0,T=f[x>>2]|0,f[x>>2]=T+-1,(T|0)==1):0)_S(s);f[c>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[E>>2]|0)>0){c=f[J>>2]|0;J=0;do{f[c+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[E>>2]|0))}E=f[I>>2]|0;if((E|0)!=(G|0))g0(E);E=r+36|0;G=f[E>>2]|0;if(G|0?(I=G+12|0,G=f[I>>2]|0,f[I>>2]=G+-1,(G|0)==1):0)_S(r);f[E>>2]=0;E=r+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[a>>2]|0)>0){E=f[C>>2]|0;C=0;do{f[E+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[a>>2]|0))}a=f[F>>2]|0;if((a|0)!=(H|0))g0(a);a=q+36|0;H=f[a>>2]|0;if(H|0?(F=H+12|0,H=f[F>>2]|0,f[F>>2]=H+-1,(H|0)==1):0)_S(q);f[a>>2]=0;a=q+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[a>>2]|0)>0){K=f[q+40>>2]|0;H=0;do{f[K+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[a>>2]|0))}a=f[q+44>>2]|0;if((a|0)==(q+48|0)){u=m;return}g0(a);u=m;return}function goa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function hoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=8;break a;break}case 4:{l=24;break a;break}case 5:{l=25;break a;break}case 1:case 0:{l=89;break a;break}default:{}}if((j|0)<124){l=27;break a}m=h+(((k|0)/2|0)<<2)|0;do if((j|0)>3996){o=(k|0)/4|0;p=loa(h,h+(o<<2)|0,m,m+(o<<2)|0,e,c)|0}else{o=f[m>>2]|0;q=f[h>>2]|0;r=+n[o>>2];s=+n[q>>2];t=o;u=q;if(!(r>s))if(r<s)v=0;else v=o>>>0>q>>>0;else v=1;w=f[e>>2]|0;x=+n[w>>2];y=w;if(!(x>r))if(x<r)z=0;else z=w>>>0>o>>>0;else z=1;if(!v){if(!z){p=0;break}f[m>>2]=y;f[e>>2]=t;o=f[m>>2]|0;w=f[h>>2]|0;r=+n[o>>2];x=+n[w>>2];A=w;B=o;if(!(r>x)?o>>>0<=w>>>0|r<x:0){p=1;break}f[h>>2]=B;f[m>>2]=A;p=2;break}if(z){f[h>>2]=y;f[e>>2]=u;p=1;break}f[h>>2]=t;f[m>>2]=u;t=f[e>>2]|0;x=+n[t>>2];y=t;if(!(x>s)?t>>>0<=q>>>0|x<s:0){p=1;break}f[m>>2]=y;f[e>>2]=u;p=2}while(0);C=f[h>>2]|0;k=f[m>>2]|0;s=+n[C>>2];x=+n[k>>2];if(s>x){D=e;E=p;break}if(C>>>0<=k>>>0|s<x)F=e;else{D=e;E=p;break}while(1){F=F+-4|0;if((h|0)==(F|0))break;G=f[F>>2]|0;r=+n[G>>2];if(r>x){l=67;break b}if(!(G>>>0<=k>>>0|r<x)){l=67;break b}}k=h+4|0;j=f[e>>2]|0;x=+n[j>>2];u=j;if(!(s>x)?C>>>0<=j>>>0|s<x:0){if((k|0)==(e|0)){l=89;break a}else H=k;while(1){I=f[H>>2]|0;x=+n[I>>2];if(s>x)break;if(!(C>>>0<=I>>>0|s<x))break;j=H+4|0;if((j|0)==(e|0)){l=89;break a}else H=j}f[H>>2]=u;f[e>>2]=I;J=H+4|0}else J=k;if((J|0)==(e|0)){l=89;break a}else{K=e;L=J}while(1){j=f[h>>2]|0;y=f[L>>2]|0;s=+n[j>>2];x=+n[y>>2];c:do if(s>x)M=L;else{q=L;r=x;t=y;while(1){if(!(j>>>0<=t>>>0|s<r)){M=q;break c}A=q+4|0;t=f[A>>2]|0;r=+n[t>>2];if(s>r){M=A;break}else q=A}}while(0);y=K;while(1){q=y;y=y+-4|0;N=f[y>>2]|0;x=+n[N>>2];if(s>x){y=y;continue}if(j>>>0<=N>>>0|s<x)break}if(M>>>0>=y>>>0){h=M;continue b}j=f[M>>2]|0;f[M>>2]=N;f[y>>2]=j;K=y;L=M+4|0}}if((l|0)==67){l=0;f[h>>2]=G;f[F>>2]=C;D=F;E=p+1|0}k=h+4|0;d:do if(k>>>0<D>>>0){u=m;j=D;q=k;t=E;while(1){A=f[u>>2]|0;s=+n[A>>2];B=q;while(1){O=f[B>>2]|0;x=+n[O>>2];if(!(x>s)?O>>>0<=A>>>0|x<s:0)break;B=B+4|0}y=O;w=j;do{w=w+-4|0;P=f[w>>2]|0;x=+n[P>>2];if(x>s)break}while(P>>>0<=A>>>0|x<s);if(B>>>0>w>>>0){Q=u;R=t;S=B;break d}f[B>>2]=P;f[w>>2]=y;u=(u|0)==(B|0)?w:u;j=w;q=B+4|0;t=t+1|0}}else{Q=m;R=E;S=k}while(0);do if((S|0)==(Q|0))T=R;else{k=f[Q>>2]|0;t=f[S>>2]|0;s=+n[k>>2];x=+n[t>>2];q=t;j=k;if(!(s>x)?!(k>>>0>t>>>0&!(s<x)):0){T=R;break}f[S>>2]=j;f[Q>>2]=q;T=R+1|0}while(0);if(!T){U=noa(h,S,c)|0;q=S+4|0;if(noa(q,a,c)|0){l=88;break}if(U){g=q;continue}}q=S;if((q-i|0)>=(b-q|0)){l=87;break}hoa(h,S,c);g=S+4|0}if((l|0)==87){l=0;hoa(S+4|0,a,c);d=h;a=S;continue}else if((l|0)==88){l=0;if(U){l=89;break}else{d=h;a=S;continue}}}if((l|0)==5){S=f[e>>2]|0;d=f[h>>2]|0;x=+n[S>>2];s=+n[d>>2];U=d;i=S;if(!(x>s)?S>>>0<=d>>>0|x<s:0)return;f[h>>2]=i;f[e>>2]=U;return}else if((l|0)==8){U=h+4|0;i=f[U>>2]|0;d=f[h>>2]|0;s=+n[i>>2];x=+n[d>>2];S=i;T=d;if(!(s>x))if(s<x)V=0;else V=i>>>0>d>>>0;else V=1;R=f[e>>2]|0;r=+n[R>>2];Q=R;if(!(r>s))if(r<s)W=0;else W=R>>>0>i>>>0;else W=1;if(!V){if(!W)return;f[U>>2]=Q;f[e>>2]=S;V=f[U>>2]|0;i=f[h>>2]|0;s=+n[V>>2];r=+n[i>>2];R=i;E=V;if(!(s>r)?V>>>0<=i>>>0|s<r:0)return;f[h>>2]=E;f[U>>2]=R;return}if(W){f[h>>2]=Q;f[e>>2]=T;return}f[h>>2]=S;f[U>>2]=T;S=f[e>>2]|0;r=+n[S>>2];Q=S;if(!(r>x)?S>>>0<=d>>>0|r<x:0)return;f[U>>2]=Q;f[e>>2]=T;return}else if((l|0)==24){koa(h,h+4|0,h+8|0,e,c)|0;return}else if((l|0)==25){loa(h,h+4|0,h+8|0,h+12|0,e,c)|0;return}else if((l|0)==27){moa(h,a,c);return}else if((l|0)==89)return}function ioa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;do{m=j;j=j+-8|0;k=n;n=n+-8|0;f[j>>2]=f[n>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function joa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)mCc(a);d=b*12|0;e=VDc(d)|0;f[a>>2]=e;g=e+(b*12|0)|0;f[a+8>>2]=g;XIc(e|0,0,d|0)|0;f[c>>2]=g;return}function koa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[b>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h>i))if(h<i)l=0;else l=e>>>0>g>>>0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o>h))if(o<h)q=0;else q=m>>>0>e>>>0;else q=1;do if(!l)if(q){f[b>>2]=p;f[c>>2]=j;r=f[b>>2]|0;s=f[a>>2]|0;h=+n[r>>2];o=+n[s>>2];t=s;u=r;if(!(h>o)?r>>>0<=s>>>0|h<o:0){v=1;w=e;x=j;break}f[a>>2]=u;f[b>>2]=t;t=f[c>>2]|0;v=2;w=t;x=t}else{v=0;w=m;x=p}else{if(q){f[a>>2]=p;f[c>>2]=k;v=1;w=g;x=k;break}f[a>>2]=j;f[b>>2]=k;t=f[c>>2]|0;o=+n[t>>2];u=t;if(!(o>i)?t>>>0<=g>>>0|o<i:0){v=1;w=t;x=u;break}f[b>>2]=u;f[c>>2]=k;v=2;w=g;x=k}while(0);k=f[d>>2]|0;i=+n[k>>2];o=+n[w>>2];g=k;if(!(i>o)?k>>>0<=w>>>0|i<o:0){y=v;return y|0}f[c>>2]=g;f[d>>2]=x;x=f[c>>2]|0;d=f[b>>2]|0;o=+n[x>>2];i=+n[d>>2];g=d;w=x;if(!(o>i)?x>>>0<=d>>>0|o<i:0){y=v+1|0;return y|0}f[b>>2]=w;f[c>>2]=g;g=f[b>>2]|0;c=f[a>>2]|0;i=+n[g>>2];o=+n[c>>2];w=c;d=g;if(!(i>o)?!(g>>>0>c>>>0&!(i<o)):0){y=v+2|0;return y|0}f[a>>2]=d;f[b>>2]=w;y=v+3|0;return y|0}function loa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0;h=koa(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=+n[g>>2];k=+n[i>>2];l=i;m=g;if(!(j>k)?g>>>0<=i>>>0|j<k:0){o=h;return o|0}f[d>>2]=m;f[e>>2]=l;l=f[d>>2]|0;e=f[c>>2]|0;k=+n[l>>2];j=+n[e>>2];m=e;i=l;if(!(k>j)?l>>>0<=e>>>0|k<j:0){o=h+1|0;return o|0}f[c>>2]=i;f[d>>2]=m;m=f[c>>2]|0;d=f[b>>2]|0;j=+n[m>>2];k=+n[d>>2];i=d;e=m;if(!(j>k)?m>>>0<=d>>>0|j<k:0){o=h+2|0;return o|0}f[b>>2]=e;f[c>>2]=i;i=f[b>>2]|0;c=f[a>>2]|0;k=+n[i>>2];j=+n[c>>2];e=c;d=i;if(!(k>j)?!(i>>>0>c>>>0&!(k<j)):0){o=h+3|0;return o|0}f[a>>2]=d;f[b>>2]=e;o=h+4|0;return o|0}function moa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h>i))if(h<i)l=0;else l=e>>>0>g>>>0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o>h))if(o<h)q=0;else q=m>>>0>e>>>0;else q=1;do if(!l)if(q){f[d>>2]=p;f[c>>2]=j;if(!(o>i)?m>>>0<=g>>>0|o<i:0){r=j;s=e;break}f[a>>2]=p;f[d>>2]=k;r=j;s=e}else{r=p;s=m}else{if(q){f[a>>2]=p;f[c>>2]=k;r=k;s=g;break}f[a>>2]=j;f[d>>2]=k;if(!(o>i)?m>>>0<=g>>>0|o<i:0){r=p;s=m;break}f[d>>2]=p;f[c>>2]=k;r=k;s=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{t=g;u=c;v=s;w=r}while(1){r=f[t>>2]|0;i=+n[r>>2];o=+n[v>>2];s=r;if(!(!(i>o)?r>>>0<=v>>>0|i<o:0)){f[t>>2]=w;a:do if((u|0)==(a|0))x=u;else{c=u;g=u;while(1){k=g;g=c+-4|0;p=f[g>>2]|0;o=+n[p>>2];d=p;if(!(i>o)?r>>>0<=p>>>0|i<o:0){x=k;break a}f[k>>2]=d;if((g|0)==(a|0)){x=g;break}else c=g}}while(0);f[x>>2]=s}r=t+4|0;if((r|0)==(b|0))break;g=f[t>>2]|0;c=t;t=r;v=g;w=g;u=c}return}function noa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=g;k=e;if(!(h>i)?e>>>0<=g>>>0|h<i:0){l=1;return l|0}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;i=+n[k>>2];h=+n[g>>2];e=k;m=g;if(!(i>h))if(i<h)o=0;else o=k>>>0>g>>>0;else o=1;p=f[d>>2]|0;q=+n[p>>2];r=p;if(!(q>i))if(q<i)s=0;else s=p>>>0>k>>>0;else s=1;if(!o){if(!s){l=1;return l|0}f[j>>2]=r;f[d>>2]=e;o=f[j>>2]|0;k=f[a>>2]|0;i=+n[o>>2];q=+n[k>>2];p=k;t=o;if(!(i>q)?o>>>0<=k>>>0|i<q:0){l=1;return l|0}f[a>>2]=t;f[j>>2]=p;l=1;return l|0}if(s){f[a>>2]=r;f[d>>2]=m;l=1;return l|0}f[a>>2]=e;f[j>>2]=m;e=f[d>>2]|0;q=+n[e>>2];r=e;if(!(q>h)?e>>>0<=g>>>0|q<h:0){l=1;return l|0}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{koa(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{loa(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;h=+n[d>>2];q=+n[r>>2];j=d;g=r;if(!(h>q))if(h<q)u=0;else u=d>>>0>r>>>0;else u=1;e=f[c>>2]|0;i=+n[e>>2];s=e;if(!(i>h))if(i<h)v=0;else v=e>>>0>d>>>0;else v=1;do if(!u)if(v){f[m>>2]=s;f[c>>2]=j;if(!(i>q)?e>>>0<=r>>>0|i<q:0){w=d;break}f[a>>2]=s;f[m>>2]=g;w=d}else w=e;else{if(v){f[a>>2]=s;f[c>>2]=g;w=r;break}f[a>>2]=j;f[m>>2]=g;if(!(i>q)?e>>>0<=r>>>0|i<q:0){w=e;break}f[m>>2]=s;f[c>>2]=g;w=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){x=1;y=0}else{g=r;s=0;m=c;e=w;while(1){j=f[g>>2]|0;q=+n[j>>2];i=+n[e>>2];v=j;if(!(q>i)?j>>>0<=e>>>0|q<i:0)z=s;else{f[g>>2]=f[m>>2];b:do if((m|0)==(a|0))A=m;else{d=m;u=m;while(1){p=u;u=d+-4|0;t=f[u>>2]|0;i=+n[t>>2];k=t;if(!(q>i)?j>>>0<=t>>>0|q<i:0){A=p;break b}f[p>>2]=k;if((u|0)==(a|0)){A=u;break}else d=u}}while(0);f[A>>2]=v;j=s+1|0;if((j|0)==8){x=0;y=(g+4|0)==(b|0);break a}else z=j}j=g+4|0;if((j|0)==(b|0)){x=1;y=0;break a}u=f[g>>2]|0;d=g;g=j;s=z;e=u;m=d}}while(0);l=y|x;return l|0}}return 0}function ooa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;foa(a,b,c,d,e,f,g,3,h,i);return}function poa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+48|0;e=d+32|0;g=d;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;m=a+48|0;n=a+44|0;f[n>>2]=m;f[m>>2]=0;f[a+52>>2]=0;m=c+16|0;o=(f[m>>2]|0)==0;q=f[c+4>>2]|0;if(!o){if((q|0)<3)r=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{s=f[c+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){if((f[c>>2]&4095|0)!=6){f[e>>2]=0;x=e+4|0;f[x>>2]=0;y=tT(e,72)|0;k=y;z=269731;l=k+72|0;do{b[k>>0]=b[z>>0]|0;k=k+1|0;z=z+1|0}while((k|0)<(l|0));z5(-5,e,269804,269808,96)}if((f[c+8>>2]|0)!=1){f[e>>2]=0;x=e+4|0;f[x>>2]=0;y=tT(e,72)|0;k=y;z=269731;l=k+72|0;do{b[k>>0]=b[z>>0]|0;k=k+1|0;z=z+1|0}while((k|0)<(l|0));z5(-5,e,269804,269808,96)}if((f[c+12>>2]|0)!=65){f[e>>2]=0;x=e+4|0;f[x>>2]=0;y=tT(e,72)|0;k=y;z=269731;l=k+72|0;do{b[k>>0]=b[z>>0]|0;k=k+1|0;z=z+1|0}while((k|0)<(l|0));z5(-5,e,269804,269808,96)}}else A=7}else A=7;if((A|0)==7){if(!((((q|0)<3?(f[c+8>>2]|0)==1:0)?(f[c+12>>2]|0)==65:0)?!((f[c>>2]&4095|0)!=6|o):0)){f[e>>2]=1;f[e+4>>2]=65;XS(c,2,e,6)}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=-1056833530;f[e+4>>2]=g;f[e+8>>2]=1;f[e+12>>2]=4;l_(c,e,e0()|0)|0}if((a|0)==(c|0))B=f[a+16>>2]|0;else{e=c+36|0;g=f[e>>2]|0;if(g|0){o=g+12|0;f[o>>2]=(f[o>>2]|0)+1}o=a+36|0;g=f[o>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)_S(a);f[o>>2]=0;g=a+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){q=f[j>>2]|0;j=0;do{f[q+(j<<2)>>2]=0;j=j+1|0;C=f[h>>2]|0}while((j|0)<(C|0));f[a>>2]=f[c>>2];if((C|0)<3)A=29;else A=31}else{f[a>>2]=f[c>>2];A=29}if((A|0)==29){C=f[c+4>>2]|0;if((C|0)<3){f[h>>2]=C;f[i>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];i=f[c+44>>2]|0;C=f[n>>2]|0;f[C>>2]=f[i>>2];f[C+4>>2]=f[i+4>>2]}else A=31}if((A|0)==31)ZS(a,c);A=f[m>>2]|0;f[g>>2]=A;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[o>>2]=f[e>>2];B=A}A=a+56|0;f[A>>2]=B;f[a+60>>2]=B+40;f[a+64>>2]=B+160;if(+p[B>>3]>0.0){qoa(a,0,0.0);D=f[A>>2]|0}else D=B;if(+p[D+8>>3]>0.0){qoa(a,1,0.0);E=f[A>>2]|0}else E=D;if(+p[E+16>>3]>0.0){qoa(a,2,0.0);F=f[A>>2]|0}else F=E;if(+p[F+24>>3]>0.0){qoa(a,3,0.0);G=f[A>>2]|0}else G=F;if(!(+p[G+32>>3]>0.0)){H=a+972|0;f[H>>2]=0;u=d;return}qoa(a,4,0.0);H=a+972|0;f[H>>2]=0;u=d;return}function qoa(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0.0,t=0,v=0.0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0;e=u;u=u+16|0;g=e;if(!(+p[(f[a+56>>2]|0)+(c<<3)>>3]>0.0)){u=e;return}h=(f[a+64>>2]|0)+(c*9<<3)|0;i=+p[h>>3];j=h+32|0;k=+p[j>>3];l=h+64|0;m=+p[l>>3];n=h+40|0;o=+p[n>>3];q=h+56|0;r=+p[q>>3];s=o*r;t=h+8|0;v=+p[t>>3];w=h+24|0;x=+p[w>>3];y=h+48|0;z=+p[y>>3];A=o*z;B=h+16|0;o=+p[B>>3];C=r*x;r=o*(C-k*z)+(i*(k*m-s)-v*(m*x-A));if(d>0.0&r<=1.0e-06){D=i+d;p[h>>3]=D;i=k+d;p[j>>3]=i;k=m+d;p[l>>3]=k;E=o*(C-i*z)+(D*(i*k-s)-v*(k*x-A))}else E=r;p[a+432+(c<<3)>>3]=E;if(!(E>2.220446049250313e-16)){f[g>>2]=0;f[g+4>>2]=0;F=tT(g,45)|0;G=269877;H=F+45|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,g,269923,269808,217)}r=1.0/E;p[a+72+(c*72|0)>>3]=r*(+p[j>>3]*+p[l>>3]-+p[n>>3]*+p[q>>3]);p[a+72+(c*72|0)+24>>3]=-(r*(+p[w>>3]*+p[l>>3]-+p[n>>3]*+p[y>>3]));p[a+72+(c*72|0)+48>>3]=r*(+p[w>>3]*+p[q>>3]-+p[j>>3]*+p[y>>3]);p[a+72+(c*72|0)+8>>3]=-(r*(+p[t>>3]*+p[l>>3]-+p[B>>3]*+p[q>>3]));p[a+72+(c*72|0)+32>>3]=r*(+p[h>>3]*+p[l>>3]-+p[B>>3]*+p[y>>3]);p[a+72+(c*72|0)+56>>3]=-(r*(+p[h>>3]*+p[q>>3]-+p[t>>3]*+p[y>>3]));p[a+72+(c*72|0)+16>>3]=r*(+p[t>>3]*+p[n>>3]-+p[B>>3]*+p[j>>3]);p[a+72+(c*72|0)+40>>3]=-(r*(+p[h>>3]*+p[n>>3]-+p[B>>3]*+p[w>>3]));p[a+72+(c*72|0)+64>>3]=r*(+p[h>>3]*+p[j>>3]-+p[t>>3]*+p[w>>3]);u=e;return}function roa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0;e=u;u=u+16|0;g=e;if(!(+p[(f[a+56>>2]|0)+(c<<3)>>3]>0.0)){h=0.0;u=e;return +h}i=+p[a+432+(c<<3)>>3];if(!(i>2.220446049250313e-16)){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,55)|0;k=269947;l=j+55|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,g,518189,269808,123)}g=(f[a+60>>2]|0)+(c*3<<3)|0;m=+p[d>>3]-+p[g>>3];n=+p[d+8>>3]-+p[g+8>>3];o=+p[d+16>>3]-+p[g+16>>3];h=1.0/+M(+i)*+V(+((m*(m*+p[a+72+(c*72|0)>>3]+n*+p[a+72+(c*72|0)+24>>3]+o*+p[a+72+(c*72|0)+48>>3])+n*(m*+p[a+72+(c*72|0)+8>>3]+n*+p[a+72+(c*72|0)+32>>3]+o*+p[a+72+(c*72|0)+56>>3])+o*(m*+p[a+72+(c*72|0)+16>>3]+n*+p[a+72+(c*72|0)+40>>3]+o*+p[a+72+(c*72|0)+64>>3]))*-.5));u=e;return +h}function soa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+972|0;if((f[e>>2]|0)<=0){f[d>>2]=0;f[d+4>>2]=0;g=tT(d,20)|0;h=270003;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));z5(-215,d,270024,269808,177)}d=a+56|0;h=a+60|0;g=a+64|0;i=0;do{j=f[a+952+(i<<2)>>2]|0;k=f[d>>2]|0;if(!j)p[k+(i<<3)>>3]=0.0;else{l=+(j|0);m=1.0/l;p[k+(i<<3)>>3]=l/+(f[e>>2]|0);k=(f[h>>2]|0)+(i*3<<3)|0;l=m*+p[a+472+(i*24|0)>>3];p[k>>3]=l;j=k+8|0;p[j>>3]=m*+p[a+472+(i*24|0)+8>>3];n=k+16|0;p[n>>3]=m*+p[a+472+(i*24|0)+16>>3];o=(f[g>>2]|0)+(i*9<<3)|0;p[o>>3]=m*+p[a+592+(i*72|0)>>3]-l*l;p[o+8>>3]=m*+p[a+592+(i*72|0)+8>>3]-+p[k>>3]*+p[j>>3];p[o+16>>3]=m*+p[a+592+(i*72|0)+16>>3]-+p[k>>3]*+p[n>>3];p[o+24>>3]=m*+p[a+592+(i*72|0)+24>>3]-+p[j>>3]*+p[k>>3];l=+p[j>>3];p[o+32>>3]=m*+p[a+592+(i*72|0)+32>>3]-l*l;p[o+40>>3]=m*+p[a+592+(i*72|0)+40>>3]-+p[j>>3]*+p[n>>3];p[o+48>>3]=m*+p[a+592+(i*72|0)+48>>3]-+p[n>>3]*+p[k>>3];p[o+56>>3]=m*+p[a+592+(i*72|0)+56>>3]-+p[n>>3]*+p[j>>3];l=+p[n>>3];p[o+64>>3]=m*+p[a+592+(i*72|0)+64>>3]-l*l;qoa(a,i,.01)}i=i+1|0}while((i|0)!=5);u=c;return}function toa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0.0,Mb=0.0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0;k=u;u=u+2544|0;l=k+2072|0;m=k+2016|0;o=k+2480|0;q=k+2424|0;r=k+2368|0;s=k+2296|0;t=k+2240|0;v=k+1984|0;w=k+1968|0;x=k+2224|0;y=k+1952|0;z=k+2168|0;A=k+976|0;B=k;C=k+2112|0;D=k+2352|0;do if((d$(a)|0)==65536){E=f[a+4>>2]|0;f[z>>2]=f[E>>2];F=z+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=z+8|0;f[H>>2]=f[E+8>>2];f[z+12>>2]=f[E+12>>2];f[z+16>>2]=f[E+16>>2];f[z+20>>2]=f[E+20>>2];f[z+24>>2]=f[E+24>>2];f[z+28>>2]=f[E+28>>2];f[z+32>>2]=f[E+32>>2];I=f[E+36>>2]|0;f[z+36>>2]=I;f[z+40>>2]=H;H=z+48|0;J=z+44|0;f[J>>2]=H;f[H>>2]=0;f[z+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[J>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[F>>2]=0;ZS(z,E);break}}else a$(z,a,-1);while(0);a=V$(c,-1)|0;c=V$(e,-1)|0;e=V$(g,-1)|0;g=z+16|0;if(!(f[g>>2]|0)){f[l>>2]=0;K=l+4|0;f[K>>2]=0;L=tT(l,14)|0;M=L;N=270036;O=M+14|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-5,l,270051,269808,542)}E=z+4|0;F=f[E>>2]|0;if((F|0)<3)P=Y(f[z+12>>2]|0,f[z+8>>2]|0)|0;else{G=f[z+40>>2]|0;H=0;J=1;while(1){I=Y(f[G+(H<<2)>>2]|0,J)|0;H=H+1|0;if((H|0)==(F|0)){P=I;break}else J=I}}if((F|0)==0|(P|0)==0){f[l>>2]=0;K=l+4|0;f[K>>2]=0;L=tT(l,14)|0;M=L;N=270036;O=M+14|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-5,l,270051,269808,542)}if((f[z>>2]&4095|0)!=16){f[l>>2]=0;f[l+4>>2]=0;M=tT(l,28)|0;N=270059;O=M+28|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-5,l,270051,269808,544)}poa(A,c);poa(B,e);e=z+40|0;c=f[e>>2]|0;L=f[c+4>>2]|0;K=f[c>>2]|0;f[C>>2]=1124007936;c=C+4|0;P=C+8|0;F=C+40|0;M=c;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[F>>2]=P;P=C+48|0;J=C+44|0;f[J>>2]=P;f[P>>2]=0;f[C+52>>2]=0;f[l>>2]=K;K=l+4|0;f[K>>2]=L;XS(C,2,l,4);L=j|1;if((L|0)==1){if(!j){H=f[e>>2]|0;G=f[H+4>>2]|0;I=f[H>>2]|0;f[D>>2]=f[d>>2];H=D+4|0;f[H>>2]=f[d+4>>2];Q=D+8|0;f[Q>>2]=f[d+8>>2];R=D+12|0;f[R>>2]=f[d+12>>2];if(!(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(I|0):0)?(f[a+12>>2]|0)==(G|0):0)?(f[a>>2]&4095|0)==0:0)?(f[a+16>>2]|0)!=0:0)){f[l>>2]=I;f[K>>2]=G;XS(a,2,l,0)}p[m>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;l_(a,l,e0()|0)|0;d=f[D>>2]|0;S=(d|0)>0?d:0;f[D>>2]=S;d=f[H>>2]|0;T=(d|0)>0?d:0;f[H>>2]=T;H=G-S|0;S=f[Q>>2]|0;f[Q>>2]=(H|0)<(S|0)?H:S;S=I-T|0;T=f[R>>2]|0;f[R>>2]=(S|0)<(T|0)?S:T;cT(o,a,D);p[m>>3]=3.0;D=m+8|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[D+16>>2]=0;f[D+20>>2]=0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=4;l_(o,l,e0()|0)|0;D=o+36|0;T=f[D>>2]|0;if(T|0?(S=T+12|0,T=f[S>>2]|0,f[S>>2]=T+-1,(T|0)==1):0)_S(o);f[D>>2]=0;D=o+16|0;T=o+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[T>>2]|0)>0){D=f[o+40>>2]|0;S=0;do{f[D+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[T>>2]|0))}T=f[o+44>>2]|0;if((T|0)!=(o+48|0))g0(T);U=z+8|0}else{T=z+8|0;uoa(f[T>>2]|0,f[z+12>>2]|0,a);U=T}f[m>>2]=1124007936;T=m+4|0;S=m+8|0;D=m+40|0;M=T;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[D>>2]=S;S=m+48|0;R=m+44|0;f[R>>2]=S;f[S>>2]=0;f[m+52>>2]=0;f[o>>2]=1124007936;I=o+4|0;H=o+8|0;Q=o+40|0;M=I;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[Q>>2]=H;H=o+48|0;G=o+44|0;f[G>>2]=H;f[H>>2]=0;f[o+52>>2]=0;f[q>>2]=0;d=q+4|0;f[d>>2]=0;f[q+8>>2]=0;f[r>>2]=0;X=r+4|0;f[X>>2]=0;f[r+8>>2]=0;Z=f[U>>2]|0;if((Z|0)<=0){f[l>>2]=0;_=l+4|0;f[_>>2]=0;$=tT(l,42)|0;M=$;N=270088;O=M+42|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,l,270131,269808,381)}aa=z+12|0;ba=a+16|0;ca=a+44|0;da=z+44|0;ea=l+4|0;fa=l+8|0;ga=r+8|0;ha=l+4|0;ia=l+8|0;ja=q+8|0;ka=Z;Z=f[aa>>2]|0;la=0;while(1){if((Z|0)>0){ma=0;do{na=(f[ba>>2]|0)+(Y(f[f[ca>>2]>>2]|0,la)|0)+ma|0;switch(b[na>>0]|0){case 2:case 0:{na=(f[g>>2]|0)+(Y(f[f[da>>2]>>2]|0,la)|0)|0;oa=+(h[na+(ma*3|0)>>0]|0);n[l>>2]=oa;n[ha>>2]=+(h[na+(ma*3|0)+1>>0]|0);n[ia>>2]=+(h[na+(ma*3|0)+2>>0]|0);na=f[d>>2]|0;if((na|0)==(f[ja>>2]|0))voa(q,l);else{n[na>>2]=oa;f[na+4>>2]=f[ha>>2];f[na+8>>2]=f[ia>>2];f[d>>2]=na+12}break}default:{na=(f[g>>2]|0)+(Y(f[f[da>>2]>>2]|0,la)|0)|0;oa=+(h[na+(ma*3|0)>>0]|0);n[l>>2]=oa;n[ea>>2]=+(h[na+(ma*3|0)+1>>0]|0);n[fa>>2]=+(h[na+(ma*3|0)+2>>0]|0);na=f[X>>2]|0;if((na|0)==(f[ga>>2]|0))voa(r,l);else{n[na>>2]=oa;f[na+4>>2]=f[ea>>2];f[na+8>>2]=f[fa>>2];f[X>>2]=na+12}}}ma=ma+1|0;pa=f[aa>>2]|0}while((ma|0)<(pa|0));qa=pa;ra=f[U>>2]|0}else{qa=Z;ra=ka}la=la+1|0;if((la|0)>=(ra|0))break;else{ka=ra;Z=qa}}qa=f[q>>2]|0;Z=f[d>>2]|0;ra=Z;ka=qa;if((qa|0)==(Z|0)){f[l>>2]=0;_=l+4|0;f[_>>2]=0;$=tT(l,42)|0;M=$;N=270088;O=M+42|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,l,270131,269808,381)}if((f[r>>2]|0)==(f[X>>2]|0)){f[l>>2]=0;_=l+4|0;f[_>>2]=0;$=tT(l,42)|0;M=$;N=270088;O=M+42|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,l,270131,269808,381)}Vj(s,(ra-ka|0)/12|0,3,5,qa,0);f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=s;qa=v+8|0;f[qa>>2]=0;f[qa+4>>2]=0;f[v>>2]=50397184;f[v+4>>2]=m;f[w>>2]=1;f[w+4>>2]=10;p[w+8>>3]=0.0;qa=e0()|0;f[l>>2]=f[w>>2];f[l+4>>2]=f[w+4>>2];f[l+8>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];+g2(t,5,v,l,0,2,qa);qa=f[r>>2]|0;Vj(t,((f[X>>2]|0)-qa|0)/12|0,3,5,qa,0);f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=t;qa=x+8|0;f[qa>>2]=0;f[qa+4>>2]=0;f[x>>2]=50397184;f[x+4>>2]=o;f[y>>2]=1;f[y+4>>2]=10;p[y+8>>3]=0.0;qa=e0()|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2];f[l+8>>2]=f[y+8>>2];f[l+12>>2]=f[y+12>>2];+g2(v,5,x,l,0,2,qa);XIc(A+472|0,0,504)|0;qa=f[q>>2]|0;x=(f[d>>2]|0)-qa|0;y=qa;if((x|0)>0){qa=f[m+16>>2]|0;w=f[R>>2]|0;ka=A+972|0;ra=(x>>>0)/12|0;x=0;do{$=qa+(Y(f[w>>2]|0,x)|0)|0;_=f[$>>2]|0;oa=+n[y+(x*12|0)>>2];sa=+n[y+(x*12|0)+4>>2];ta=+n[y+(x*12|0)+8>>2];$=A+472+(_*24|0)|0;p[$>>3]=oa+ +p[$>>3];$=A+472+(_*24|0)+8|0;p[$>>3]=sa+ +p[$>>3];$=A+472+(_*24|0)+16|0;p[$>>3]=ta+ +p[$>>3];$=A+592+(_*72|0)|0;p[$>>3]=oa*oa+ +p[$>>3];ua=oa*sa;$=A+592+(_*72|0)+8|0;p[$>>3]=ua+ +p[$>>3];va=oa*ta;$=A+592+(_*72|0)+16|0;p[$>>3]=va+ +p[$>>3];$=A+592+(_*72|0)+24|0;p[$>>3]=ua+ +p[$>>3];$=A+592+(_*72|0)+32|0;p[$>>3]=sa*sa+ +p[$>>3];ua=sa*ta;$=A+592+(_*72|0)+40|0;p[$>>3]=ua+ +p[$>>3];$=A+592+(_*72|0)+48|0;p[$>>3]=va+ +p[$>>3];$=A+592+(_*72|0)+56|0;p[$>>3]=ua+ +p[$>>3];$=A+592+(_*72|0)+64|0;p[$>>3]=ta*ta+ +p[$>>3];$=A+952+(_<<2)|0;f[$>>2]=(f[$>>2]|0)+1;f[ka>>2]=(f[ka>>2]|0)+1;x=x+1|0}while((x|0)<(ra|0))}soa(A);XIc(B+472|0,0,504)|0;ra=f[r>>2]|0;x=(f[X>>2]|0)-ra|0;ka=ra;if((x|0)>0){ra=f[o+16>>2]|0;y=f[G>>2]|0;w=B+972|0;qa=(x>>>0)/12|0;x=0;do{$=ra+(Y(f[y>>2]|0,x)|0)|0;_=f[$>>2]|0;ta=+n[ka+(x*12|0)>>2];ua=+n[ka+(x*12|0)+4>>2];va=+n[ka+(x*12|0)+8>>2];$=B+472+(_*24|0)|0;p[$>>3]=ta+ +p[$>>3];$=B+472+(_*24|0)+8|0;p[$>>3]=ua+ +p[$>>3];$=B+472+(_*24|0)+16|0;p[$>>3]=va+ +p[$>>3];$=B+592+(_*72|0)|0;p[$>>3]=ta*ta+ +p[$>>3];sa=ta*ua;$=B+592+(_*72|0)+8|0;p[$>>3]=sa+ +p[$>>3];oa=ta*va;$=B+592+(_*72|0)+16|0;p[$>>3]=oa+ +p[$>>3];$=B+592+(_*72|0)+24|0;p[$>>3]=sa+ +p[$>>3];$=B+592+(_*72|0)+32|0;p[$>>3]=ua*ua+ +p[$>>3];sa=ua*va;$=B+592+(_*72|0)+40|0;p[$>>3]=sa+ +p[$>>3];$=B+592+(_*72|0)+48|0;p[$>>3]=oa+ +p[$>>3];$=B+592+(_*72|0)+56|0;p[$>>3]=sa+ +p[$>>3];$=B+592+(_*72|0)+64|0;p[$>>3]=va*va+ +p[$>>3];$=B+952+(_<<2)|0;f[$>>2]=(f[$>>2]|0)+1;f[w>>2]=(f[w>>2]|0)+1;x=x+1|0}while((x|0)<(qa|0))}soa(B);qa=t+36|0;x=f[qa>>2]|0;if(x|0?(w=x+12|0,x=f[w>>2]|0,f[w>>2]=x+-1,(x|0)==1):0)_S(t);f[qa>>2]=0;qa=t+16|0;x=t+4|0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[x>>2]|0)>0){qa=f[t+40>>2]|0;w=0;do{f[qa+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[x>>2]|0))}x=f[t+44>>2]|0;if((x|0)!=(t+48|0))g0(x);x=s+36|0;w=f[x>>2]|0;if(w|0?(qa=w+12|0,w=f[qa>>2]|0,f[qa>>2]=w+-1,(w|0)==1):0)_S(s);f[x>>2]=0;x=s+16|0;w=s+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[w>>2]|0)>0){x=f[s+40>>2]|0;qa=0;do{f[x+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[w>>2]|0))}w=f[s+44>>2]|0;if((w|0)!=(s+48|0))g0(w);w=f[r>>2]|0;if(w|0){qa=f[X>>2]|0;if((qa|0)!=(w|0))f[X>>2]=qa+(~(((qa+-12-w|0)>>>0)/12|0)*12|0);YDc(w)}w=f[q>>2]|0;if(w|0){qa=f[d>>2]|0;if((qa|0)!=(w|0))f[d>>2]=qa+(~(((qa+-12-w|0)>>>0)/12|0)*12|0);YDc(w)}w=o+36|0;qa=f[w>>2]|0;do if(qa|0){d=qa+12|0;X=f[d>>2]|0;f[d>>2]=X+-1;if((X|0)!=1)break;_S(o)}while(0);f[w>>2]=0;w=o+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[I>>2]|0)>0){w=f[Q>>2]|0;Q=0;do{f[w+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[I>>2]|0))}I=f[G>>2]|0;if((I|0)!=(H|0))g0(I);I=m+36|0;H=f[I>>2]|0;do if(H|0){G=H+12|0;Q=f[G>>2]|0;f[G>>2]=Q+-1;if((Q|0)!=1)break;_S(m)}while(0);f[I>>2]=0;I=m+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[T>>2]|0)>0){I=f[D>>2]|0;D=0;do{f[I+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[T>>2]|0))}T=f[R>>2]|0;if((T|0)!=(S|0))g0(T)}if((i|0)>=1){T=(j|0)==3;j=T?1:i;i=z+8|0;if((L|0)==3)uoa(f[i>>2]|0,f[z+12>>2]|0,a);L=f[i>>2]|0;S=z+12|0;R=f[S>>2]|0;if((L|0)>0){D=(R|0)>0;I=f[g>>2]|0;H=f[z+44>>2]|0;Q=R+-1|0;G=0;va=0.0;while(1){a:do if(D){w=f[H>>2]|0;qa=I+(Y(w,G)|0)|0;X=I+(Y(w,G+-1|0)|0)|0;if((G|0)>0){wa=0;xa=va}else{w=0;sa=va;while(1){if((w|0)>0){d=w+-1|0;oa=+(h[qa+(w*3|0)>>0]|0)-+(h[qa+(d*3|0)>>0]|0);ua=+(h[qa+(w*3|0)+1>>0]|0)-+(h[qa+(d*3|0)+1>>0]|0);ta=+(h[qa+(w*3|0)+2>>0]|0)-+(h[qa+(d*3|0)+2>>0]|0);ya=sa+(oa*oa+0.0+ua*ua+ta*ta)}else ya=sa;w=w+1|0;if((w|0)==(R|0)){za=ya;break a}else sa=ya}}while(1){sa=+(h[qa+(wa*3|0)>>0]|0);ta=+(h[qa+(wa*3|0)+1>>0]|0);ua=+(h[qa+(wa*3|0)+2>>0]|0);if((wa|0)>0){w=wa+-1|0;oa=sa-+(h[qa+(w*3|0)>>0]|0);Aa=ta-+(h[qa+(w*3|0)+1>>0]|0);Ba=ua-+(h[qa+(w*3|0)+2>>0]|0);Ca=sa-+(h[X+(w*3|0)>>0]|0);Da=ta-+(h[X+(w*3|0)+1>>0]|0);Ea=ua-+(h[X+(w*3|0)+2>>0]|0);Fa=xa+(oa*oa+0.0+Aa*Aa+Ba*Ba)+(Ca*Ca+0.0+Da*Da+Ea*Ea)}else Fa=xa;Ea=sa-+(h[X+(wa*3|0)>>0]|0);Da=ta-+(h[X+(wa*3|0)+1>>0]|0);Ca=ua-+(h[X+(wa*3|0)+2>>0]|0);Ba=Fa+(Ea*Ea+0.0+Da*Da+Ca*Ca);w=wa;wa=wa+1|0;if((w|0)<(Q|0)){Ca=sa-+(h[X+(wa*3|0)>>0]|0);sa=ta-+(h[X+(wa*3|0)+1>>0]|0);ta=ua-+(h[X+(wa*3|0)+2>>0]|0);Ga=Ba+(Ca*Ca+0.0+sa*sa+ta*ta)}else Ga=Ba;if((wa|0)==(R|0)){za=Ga;break}else xa=Ga}}else za=va;while(0);G=G+1|0;if((G|0)==(L|0))break;else va=za}if(!(za<=2.220446049250313e-16))Ha=1.0/(za*2.0/+((Y(L,-3)|0)+2+(Y(R,(L<<2)+-3|0)|0)|0));else Ha=0.0}else Ha=0.0;f[q>>2]=1124007936;G=q+4|0;wa=q+8|0;Q=q+40|0;M=G;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[Q>>2]=wa;wa=q+48|0;I=q+44|0;f[I>>2]=wa;f[wa>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;H=r+4|0;D=r+8|0;X=r+40|0;M=H;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[X>>2]=D;qa=r+48|0;w=r+44|0;f[w>>2]=qa;f[qa>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;d=s+4|0;x=s+8|0;ka=s+40|0;M=d;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[ka>>2]=x;y=s+48|0;ra=s+44|0;f[ra>>2]=y;f[y>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;$=t+4|0;_=t+8|0;Z=t+40|0;M=$;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[Z>>2]=_;la=t+48|0;U=t+44|0;f[U>>2]=la;f[la>>2]=0;f[t+52>>2]=0;f[l>>2]=L;f[K>>2]=R;XS(q,2,l,6);R=f[i>>2]|0;L=f[S>>2]|0;pa=f[D>>2]|0;if((((f[H>>2]|0)<3&(pa|0)==(R|0)?(f[r+12>>2]|0)==(L|0):0)?(f[r>>2]&4095|0)==6:0)?(f[r+16>>2]|0)!=0:0){Ia=R;Ja=pa;Ka=L}else{f[l>>2]=R;f[K>>2]=L;XS(r,2,l,6);L=f[i>>2]|0;Ia=L;Ja=L;Ka=f[S>>2]|0}if(((((f[d>>2]|0)<3?(f[x>>2]|0)==(Ja|0):0)?(f[s+12>>2]|0)==(Ka|0):0)?(f[s>>2]&4095|0)==6:0)?(f[s+16>>2]|0)!=0:0){La=Ia;Ma=Ja;Na=Ka}else{f[l>>2]=Ja;f[K>>2]=Ka;XS(s,2,l,6);Ka=f[i>>2]|0;La=Ka;Ma=Ka;Na=f[S>>2]|0}if(((((f[$>>2]|0)<3?(f[_>>2]|0)==(Ma|0):0)?(f[t+12>>2]|0)==(Na|0):0)?(f[t>>2]&4095|0)==6:0)?(f[t+16>>2]|0)!=0:0){Oa=La;Pa=Ma}else{f[l>>2]=Ma;f[K>>2]=Na;XS(t,2,l,6);Na=f[i>>2]|0;Oa=Na;Pa=Na}if((Pa|0)>0){Na=z+44|0;K=q+16|0;Ma=r+16|0;La=s+16|0;_=t+16|0;Ka=f[S>>2]|0;Ja=(Ka|0)>0;Ia=0;do{if(Ja){x=(Ia|0)>0;L=f[g>>2]|0;R=f[f[Na>>2]>>2]|0;pa=L+(Y(R,Ia)|0)|0;D=L+(Y(R,Ia+-1|0)|0)|0;R=0;while(1){za=+(h[pa+(R*3|0)>>0]|0);va=+(h[pa+(R*3|0)+1>>0]|0);Ga=+(h[pa+(R*3|0)+2>>0]|0);L=R+-1|0;do if((R|0)>0){xa=za-+(h[pa+(L*3|0)>>0]|0);Fa=va-+(h[pa+(L*3|0)+1>>0]|0);ya=Ga-+(h[pa+(L*3|0)+2>>0]|0);Ba=+V(+-(Ha*(xa*xa+0.0+Fa*Fa+ya*ya)))*50.0;aa=(f[K>>2]|0)+(Y(f[f[I>>2]>>2]|0,Ia)|0)+(R<<3)|0;p[aa>>3]=Ba;if(x){Ba=za-+(h[D+(L*3|0)>>0]|0);ya=va-+(h[D+(L*3|0)+1>>0]|0);Fa=Ga-+(h[D+(L*3|0)+2>>0]|0);xa=+V(+-(Ha*(Ba*Ba+0.0+ya*ya+Fa*Fa)))*35.35533966440824;aa=(f[Ma>>2]|0)+(Y(f[f[w>>2]>>2]|0,Ia)|0)+(R<<3)|0;p[aa>>3]=xa;Qa=147;break}else{aa=(f[Ma>>2]|0)+(Y(f[f[w>>2]>>2]|0,Ia)|0)+(R<<3)|0;p[aa>>3]=0.0;Qa=146;break}}else{aa=(f[K>>2]|0)+(Y(f[f[I>>2]>>2]|0,Ia)|0)+(R<<3)|0;p[aa>>3]=0.0;aa=(f[Ma>>2]|0)+(Y(f[f[w>>2]>>2]|0,Ia)|0)+(R<<3)|0;p[aa>>3]=0.0;if(x)Qa=147;else Qa=146}while(0);do if((Qa|0)==146){Qa=0;L=(f[La>>2]|0)+(Y(f[f[ra>>2]>>2]|0,Ia)|0)+(R<<3)|0;p[L>>3]=0.0;Ra=R+1|0;Sa=0.0}else if((Qa|0)==147){Qa=0;xa=za-+(h[D+(R*3|0)>>0]|0);Fa=va-+(h[D+(R*3|0)+1>>0]|0);ya=Ga-+(h[D+(R*3|0)+2>>0]|0);Ba=+V(+-(Ha*(xa*xa+0.0+Fa*Fa+ya*ya)))*50.0;L=(f[La>>2]|0)+(Y(f[f[ra>>2]>>2]|0,Ia)|0)+(R<<3)|0;p[L>>3]=Ba;L=R+1|0;if((L|0)>=(Ka|0)){Ra=L;Sa=0.0;break}Ba=za-+(h[D+(L*3|0)>>0]|0);ya=va-+(h[D+(L*3|0)+1>>0]|0);Fa=Ga-+(h[D+(L*3|0)+2>>0]|0);Ra=L;Sa=+V(+-(Ha*(Ba*Ba+0.0+ya*ya+Fa*Fa)))*35.35533966440824}while(0);L=(f[_>>2]|0)+(Y(f[f[U>>2]>>2]|0,Ia)|0)+(R<<3)|0;p[L>>3]=Sa;if((Ra|0)<(Ka|0))R=Ra;else break}}Ia=Ia+1|0}while((Ia|0)!=(Pa|0))}b:do if((j|0)>0){Pa=z+44|0;Ia=a+16|0;Ra=a+44|0;Ka=l+8|0;_=l+16|0;La=C+16|0;Ma=l+8|0;K=l+16|0;Na=v+12|0;Ja=v+24|0;R=v+4|0;D=v+8|0;x=A+56|0;pa=l+8|0;L=l+16|0;aa=B+56|0;fa=l+8|0;ea=l+16|0;ga=q+16|0;da=r+16|0;ia=s+16|0;ha=t+16|0;ja=a+8|0;ca=a+12|0;ba=v+12|0;ma=v+16|0;na=A+472|0;Ta=B+472|0;Ua=0;Va=Oa;c:while(1){f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[v+28>>2]=0;if((Va|0)>0){Wa=Va;Xa=f[S>>2]|0;Ya=0;while(1){if((Xa|0)>0){Za=0;do{_a=(f[g>>2]|0)+(Y(f[f[Pa>>2]>>2]|0,Ya)|0)|0;Sa=+(h[_a+(Za*3|0)>>0]|0);Ha=+(h[_a+(Za*3|0)+1>>0]|0);Ga=+(h[_a+(Za*3|0)+2>>0]|0);_a=(f[Ia>>2]|0)+(Y(f[f[Ra>>2]>>2]|0,Ya)|0)+Za|0;switch(b[_a>>0]|0){case 2:case 0:{p[l>>3]=Sa;p[Ma>>3]=Ha;p[K>>3]=Ga;va=+roa(A,0,l);za=va>0.0?va:0.0;p[l>>3]=Sa;p[Ma>>3]=Ha;p[K>>3]=Ga;va=+roa(A,1,l);_a=va>za;Fa=_a?va:za;p[l>>3]=Sa;p[Ma>>3]=Ha;p[K>>3]=Ga;za=+roa(A,2,l);$a=za>Fa;va=$a?za:Fa;p[l>>3]=Sa;p[Ma>>3]=Ha;p[K>>3]=Ga;Fa=+roa(A,3,l);ab=Fa>va;p[l>>3]=Sa;p[Ma>>3]=Ha;p[K>>3]=Ga;za=+roa(A,4,l);bb=za>(ab?Fa:va)?4:ab?3:$a?2:_a&1;break}default:{p[l>>3]=Sa;p[Ka>>3]=Ha;p[_>>3]=Ga;va=+roa(B,0,l);Fa=va>0.0?va:0.0;p[l>>3]=Sa;p[Ka>>3]=Ha;p[_>>3]=Ga;va=+roa(B,1,l);_a=va>Fa;za=_a?va:Fa;p[l>>3]=Sa;p[Ka>>3]=Ha;p[_>>3]=Ga;Fa=+roa(B,2,l);$a=Fa>za;va=$a?Fa:za;p[l>>3]=Sa;p[Ka>>3]=Ha;p[_>>3]=Ga;za=+roa(B,3,l);ab=za>va;p[l>>3]=Sa;p[Ka>>3]=Ha;p[_>>3]=Ga;Ga=+roa(B,4,l);bb=Ga>(ab?za:va)?4:ab?3:$a?2:_a&1}}_a=(f[La>>2]|0)+(Y(f[f[J>>2]>>2]|0,Ya)|0)+(Za<<2)|0;f[_a>>2]=bb;Za=Za+1|0;cb=f[S>>2]|0}while((Za|0)<(cb|0));db=f[i>>2]|0;eb=cb}else{db=Wa;eb=Xa}Ya=Ya+1|0;if((Ya|0)>=(db|0)){fb=db;break}else{Wa=db;Xa=eb}}}else fb=Va;if(T)gb=fb;else{XIc(na|0,0,504)|0;XIc(Ta|0,0,504)|0;Xa=0;Wa=fb;while(1){if((Wa|0)>0){Ya=B+472+(Xa*24|0)|0;Za=B+472+(Xa*24|0)+8|0;_a=B+472+(Xa*24|0)+16|0;$a=B+592+(Xa*72|0)|0;ab=B+592+(Xa*72|0)+8|0;hb=B+592+(Xa*72|0)+16|0;ib=B+592+(Xa*72|0)+24|0;jb=B+592+(Xa*72|0)+32|0;kb=B+592+(Xa*72|0)+40|0;lb=B+592+(Xa*72|0)+48|0;mb=B+592+(Xa*72|0)+56|0;nb=A+472+(Xa*24|0)|0;ob=A+472+(Xa*24|0)+8|0;pb=A+472+(Xa*24|0)+16|0;qb=A+592+(Xa*72|0)|0;rb=A+592+(Xa*72|0)+8|0;sb=A+592+(Xa*72|0)+16|0;tb=A+592+(Xa*72|0)+24|0;ub=A+592+(Xa*72|0)+32|0;vb=A+592+(Xa*72|0)+40|0;wb=A+592+(Xa*72|0)+48|0;xb=A+592+(Xa*72|0)+56|0;yb=f[S>>2]|0;zb=(yb|0)>0;Ab=Wa;Bb=0;while(1){if(zb){Cb=f[La>>2]|0;Db=f[J>>2]|0;Eb=0;while(1){Fb=Cb+(Y(f[Db>>2]|0,Bb)|0)+(Eb<<2)|0;if((f[Fb>>2]|0)==(Xa|0)){Fb=(f[Ia>>2]|0)+(Y(f[f[Ra>>2]>>2]|0,Bb)|0)+Eb|0;switch(b[Fb>>0]|0){case 2:case 0:{Fb=(f[g>>2]|0)+(Y(f[f[Pa>>2]>>2]|0,Bb)|0)|0;va=+(h[Fb+(Eb*3|0)>>0]|0);za=+(h[Fb+(Eb*3|0)+1>>0]|0);Ga=+(h[Fb+(Eb*3|0)+2>>0]|0);p[nb>>3]=va+ +p[nb>>3];p[ob>>3]=za+ +p[ob>>3];p[pb>>3]=Ga+ +p[pb>>3];p[qb>>3]=va*va+ +p[qb>>3];Ha=va*za;p[rb>>3]=Ha+ +p[rb>>3];Sa=va*Ga;p[sb>>3]=Sa+ +p[sb>>3];p[tb>>3]=Ha+ +p[tb>>3];p[ub>>3]=za*za+ +p[ub>>3];Ha=za*Ga;p[vb>>3]=Ha+ +p[vb>>3];p[wb>>3]=Sa+ +p[wb>>3];p[xb>>3]=Ha+ +p[xb>>3];Gb=Ga*Ga;Hb=A;break}default:{Fb=(f[g>>2]|0)+(Y(f[f[Pa>>2]>>2]|0,Bb)|0)|0;Ga=+(h[Fb+(Eb*3|0)>>0]|0);Ha=+(h[Fb+(Eb*3|0)+1>>0]|0);Sa=+(h[Fb+(Eb*3|0)+2>>0]|0);p[Ya>>3]=Ga+ +p[Ya>>3];p[Za>>3]=Ha+ +p[Za>>3];p[_a>>3]=Sa+ +p[_a>>3];p[$a>>3]=Ga*Ga+ +p[$a>>3];za=Ga*Ha;p[ab>>3]=za+ +p[ab>>3];va=Ga*Sa;p[hb>>3]=va+ +p[hb>>3];p[ib>>3]=za+ +p[ib>>3];p[jb>>3]=Ha*Ha+ +p[jb>>3];za=Ha*Sa;p[kb>>3]=za+ +p[kb>>3];p[lb>>3]=va+ +p[lb>>3];p[mb>>3]=za+ +p[mb>>3];Gb=Sa*Sa;Hb=B}}Fb=Hb+592+(Xa*72|0)+64|0;p[Fb>>3]=Gb+ +p[Fb>>3];Fb=Hb+952+(Xa<<2)|0;f[Fb>>2]=(f[Fb>>2]|0)+1;Fb=Hb+972|0;f[Fb>>2]=(f[Fb>>2]|0)+1}Eb=Eb+1|0;if((Eb|0)>=(yb|0)){Ib=fb;break}}}else Ib=Ab;Bb=Bb+1|0;if((Bb|0)>=(Ib|0)){Jb=Ib;break}else Ab=Ib}}else Jb=Wa;Xa=Xa+1|0;if((Xa|0)==5)break;else Wa=Jb}soa(A);soa(B);gb=f[i>>2]|0}Wa=f[S>>2]|0;woa(v,Y(gb,Wa)|0);xoa(Na,((Y(gb+Wa|0,-3)|0)+(Y(Wa<<2,gb)|0)<<1)+6|0);p[Ja>>3]=0.0;Wa=f[i>>2]|0;if((Wa|0)>0){Xa=f[S>>2]|0;Ab=Wa;Wa=0;while(1){if((Xa|0)>0){Bb=(Wa|0)>0;yb=0;do{M=l;O=M+40|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));mb=f[R>>2]|0;if((mb|0)==(f[D>>2]|0)){yoa(v,l);Kb=f[R>>2]|0}else{M=mb;N=l;O=M+40|0;do{f[M>>2]=f[N>>2];M=M+4|0;N=N+4|0}while((M|0)<(O|0));lb=mb+40|0;f[R>>2]=lb;Kb=lb}lb=Kb-(f[v>>2]|0)|0;kb=(lb|0)/40|0;jb=kb+-1|0;ib=(f[g>>2]|0)+(Y(f[f[Pa>>2]>>2]|0,Wa)|0)|0;hb=(f[Ia>>2]|0)+(Y(f[f[Ra>>2]>>2]|0,Wa)|0)+yb|0;ab=b[hb>>0]|0;if((ab&-2)<<24>>24==2){Sa=+(h[ib+(yb*3|0)>>0]|0);za=+(h[ib+(yb*3|0)+1>>0]|0);va=+(h[ib+(yb*3|0)+2>>0]|0);Ha=+p[f[x>>2]>>3];p[l>>3]=Sa;p[pa>>3]=za;p[L>>3]=va;Ga=+roa(A,0,l);Fa=+p[(f[x>>2]|0)+8>>3];p[l>>3]=Sa;p[pa>>3]=za;p[L>>3]=va;ya=+roa(A,1,l);Ba=+p[(f[x>>2]|0)+16>>3];p[l>>3]=Sa;p[pa>>3]=za;p[L>>3]=va;xa=+roa(A,2,l);ta=+p[(f[x>>2]|0)+24>>3];p[l>>3]=Sa;p[pa>>3]=za;p[L>>3]=va;sa=+roa(A,3,l);Ca=+p[(f[x>>2]|0)+32>>3];p[l>>3]=Sa;p[pa>>3]=za;p[L>>3]=va;ua=-+W(+(Ha*Ga+0.0+Fa*ya+Ba*xa+ta*sa+Ca*+roa(A,4,l)));Ca=+p[f[aa>>2]>>3];p[l>>3]=Sa;p[fa>>3]=za;p[ea>>3]=va;sa=+roa(B,0,l);ta=+p[(f[aa>>2]|0)+8>>3];p[l>>3]=Sa;p[fa>>3]=za;p[ea>>3]=va;xa=+roa(B,1,l);Ba=+p[(f[aa>>2]|0)+16>>3];p[l>>3]=Sa;p[fa>>3]=za;p[ea>>3]=va;ya=+roa(B,2,l);Fa=+p[(f[aa>>2]|0)+24>>3];p[l>>3]=Sa;p[fa>>3]=za;p[ea>>3]=va;Ga=+roa(B,3,l);Ha=+p[(f[aa>>2]|0)+32>>3];p[l>>3]=Sa;p[fa>>3]=za;p[ea>>3]=va;Lb=ua;Mb=-+W(+(Ca*sa+0.0+ta*xa+Ba*ya+Fa*Ga+Ha*+roa(B,4,l)))}else{ib=ab<<24>>24==0;Lb=ib?0.0:450.0;Mb=ib?450.0:0.0}if((lb|0)<=0){Qa=193;break c}lb=f[v>>2]|0;if((((f[R>>2]|0)-lb|0)/40|0|0)<(kb|0)){Qa=193;break c}ib=lb+(jb*40|0)+24|0;Ha=+p[ib>>3];lb=Ha>0.0;Ga=lb?Mb:Mb-Ha;Fa=lb?Lb+Ha:Lb;p[Ja>>3]=+p[Ja>>3]+(Fa<Ga?Fa:Ga);p[ib>>3]=Fa-Ga;do if((yb|0)<=0){if(Bb)Qa=198}else{ib=(f[ga>>2]|0)+(Y(f[f[I>>2]>>2]|0,Wa)|0)+(yb<<3)|0;Ga=+p[ib>>3];ib=kb+-2|0;zoa(v,jb,ib,Ga,Ga);if(!Bb)break;lb=(f[da>>2]|0)+(Y(f[f[w>>2]>>2]|0,Wa)|0)+(yb<<3)|0;Ga=+p[lb>>3];zoa(v,jb,ib-(f[S>>2]|0)|0,Ga,Ga);Qa=198}while(0);do if((Qa|0)==198){Qa=0;mb=(f[ia>>2]|0)+(Y(f[f[ra>>2]>>2]|0,Wa)|0)+(yb<<3)|0;Ga=+p[mb>>3];zoa(v,jb,jb-(f[S>>2]|0)|0,Ga,Ga);mb=f[S>>2]|0;if((yb|0)>=(mb+-1|0))break;ib=(f[ha>>2]|0)+(Y(f[f[U>>2]>>2]|0,Wa)|0)+(yb<<3)|0;Ga=+p[ib>>3];zoa(v,jb,kb-mb|0,Ga,Ga)}while(0);yb=yb+1|0;Nb=f[S>>2]|0}while((yb|0)<(Nb|0));Ob=f[i>>2]|0;Pb=Nb}else{Ob=Ab;Pb=Xa}Wa=Wa+1|0;if((Wa|0)>=(Ob|0))break;else{Xa=Pb;Ab=Ob}}}+Aoa(v);Ab=f[ja>>2]|0;if((Ab|0)>0){Xa=f[ca>>2]|0;Wa=Ab;Ab=0;while(1){if((Xa|0)>0){yb=Xa;Bb=0;while(1){kb=(f[Ia>>2]|0)+(Y(f[f[Ra>>2]>>2]|0,Ab)|0)+Bb|0;if((b[kb>>0]&-2)<<24>>24==2){jb=(Y(yb,Ab)|0)+Bb|0;if((jb|0)<=-1){Qa=209;break c}mb=f[v>>2]|0;if((((f[R>>2]|0)-mb|0)/40|0|0)<=(jb|0)){Qa=209;break c}ib=(b[mb+(jb*40|0)+32>>0]|0)==0;jb=ib?m:o;f[jb>>2]=Bb;f[jb+4>>2]=Ab;b[kb>>0]=ib?3:2;Qb=f[ca>>2]|0}else Qb=yb;Bb=Bb+1|0;if((Bb|0)>=(Qb|0))break;else yb=Qb}Rb=f[ja>>2]|0;Sb=Qb}else{Rb=Wa;Sb=Xa}Ab=Ab+1|0;if((Ab|0)>=(Rb|0))break;else{Xa=Sb;Wa=Rb}}}Wa=f[ba>>2]|0;if(Wa|0){Xa=f[ma>>2]|0;if((Xa|0)!=(Wa|0))f[ma>>2]=Xa+(~((Xa+-16-Wa|0)>>>4)<<4);YDc(Wa)}Wa=f[v>>2]|0;if(Wa|0){Xa=f[R>>2]|0;if((Xa|0)!=(Wa|0))f[R>>2]=Xa+(~(((Xa+-40-Wa|0)>>>0)/40|0)*40|0);YDc(Wa)}Wa=Ua+1|0;if((Wa|0)>=(j|0))break b;Ua=Wa;Va=f[i>>2]|0}if((Qa|0)==193){f[l>>2]=0;f[l+4>>2]=0;M=tT(l,26)|0;N=270140;O=M+26|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,l,270167,270182,141)}else if((Qa|0)==209){f[l>>2]=0;f[l+4>>2]=0;M=tT(l,26)|0;N=270140;O=M+26|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,l,270251,270182,381)}}while(0);l=t+36|0;N=f[l>>2]|0;if(N|0?(M=N+12|0,N=f[M>>2]|0,f[M>>2]=N+-1,(N|0)==1):0)_S(t);f[l>>2]=0;l=t+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[$>>2]|0)>0){l=f[Z>>2]|0;Z=0;do{f[l+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[$>>2]|0))}$=f[U>>2]|0;if(($|0)!=(la|0))g0($);$=s+36|0;la=f[$>>2]|0;do if(la|0){U=la+12|0;Z=f[U>>2]|0;f[U>>2]=Z+-1;if((Z|0)!=1)break;_S(s)}while(0);f[$>>2]=0;$=s+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[d>>2]|0)>0){$=f[ka>>2]|0;ka=0;do{f[$+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[d>>2]|0))}d=f[ra>>2]|0;if((d|0)!=(y|0))g0(d);d=r+36|0;y=f[d>>2]|0;do if(y|0){ra=y+12|0;ka=f[ra>>2]|0;f[ra>>2]=ka+-1;if((ka|0)!=1)break;_S(r)}while(0);f[d>>2]=0;d=r+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[H>>2]|0)>0){d=f[X>>2]|0;X=0;do{f[d+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[H>>2]|0))}H=f[w>>2]|0;if((H|0)!=(qa|0))g0(H);H=q+36|0;qa=f[H>>2]|0;do if(qa|0){w=qa+12|0;X=f[w>>2]|0;f[w>>2]=X+-1;if((X|0)!=1)break;_S(q)}while(0);f[H>>2]=0;H=q+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[G>>2]|0)>0){H=f[Q>>2]|0;Q=0;do{f[H+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[G>>2]|0))}G=f[I>>2]|0;if((G|0)!=(wa|0))g0(G)}G=C+36|0;wa=f[G>>2]|0;if(wa|0?(I=wa+12|0,wa=f[I>>2]|0,f[I>>2]=wa+-1,(wa|0)==1):0)_S(C);f[G>>2]=0;G=C+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[c>>2]|0)>0){G=f[F>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[c>>2]|0))}c=f[J>>2]|0;if((c|0)!=(P|0))g0(c);c=B+36|0;P=f[c>>2]|0;if(P|0?(J=P+12|0,P=f[J>>2]|0,f[J>>2]=P+-1,(P|0)==1):0)_S(B);f[c>>2]=0;c=B+16|0;P=B+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[P>>2]|0)>0){c=f[B+40>>2]|0;J=0;do{f[c+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[P>>2]|0))}P=f[B+44>>2]|0;if((P|0)!=(B+48|0))g0(P);P=A+36|0;B=f[P>>2]|0;if(B|0?(J=B+12|0,B=f[J>>2]|0,f[J>>2]=B+-1,(B|0)==1):0)_S(A);f[P>>2]=0;P=A+16|0;B=A+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[B>>2]|0)>0){P=f[A+40>>2]|0;J=0;do{f[P+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[B>>2]|0))}B=f[A+44>>2]|0;if((B|0)!=(A+48|0))g0(B);B=z+36|0;A=f[B>>2]|0;if(A|0?(J=A+12|0,A=f[J>>2]|0,f[J>>2]=A+-1,(A|0)==1):0)_S(z);f[B>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[E>>2]|0)>0){g=f[e>>2]|0;e=0;do{f[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[E>>2]|0))}E=f[z+44>>2]|0;if((E|0)==(z+48|0)){u=k;return}g0(E);u=k;return}function uoa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;i=f[d+16>>2]|0;if(!i){f[g>>2]=0;j=g+4|0;f[j>>2]=0;k=tT(g,13)|0;l=k;m=270348;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-5,g,270362,269808,327)}o=f[d+4>>2]|0;if((o|0)<3)p=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{q=f[d+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if((o|0)==0|(p|0)==0){f[g>>2]=0;j=g+4|0;f[j>>2]=0;k=tT(g,13)|0;l=k;m=270348;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-5,g,270362,269808,327)}if(f[d>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,27)|0;m=270372;n=l+27|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-5,g,270362,269808,329)}if((f[d+12>>2]|0)!=(c|0)){f[g>>2]=0;v=g+4|0;f[v>>2]=0;w=tT(g,43)|0;l=w;m=270400;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-5,g,270362,269808,331)}if((f[d+8>>2]|0)!=(a|0)){f[g>>2]=0;v=g+4|0;f[v>>2]=0;w=tT(g,43)|0;l=w;m=270400;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-5,g,270362,269808,331)}if(!((a|0)>0&(c|0)>0)){u=e;return}w=f[f[d+44>>2]>>2]|0;d=0;a:while(1){v=i+(Y(w,d)|0)|0;k=0;do{if((h[v+k>>0]|0)>=4){x=20;break a}k=k+1|0}while((k|0)<(c|0));d=d+1|0;if((d|0)>=(a|0)){x=19;break}}if((x|0)==19){u=e;return}else if((x|0)==20){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,75)|0;m=270444;n=l+75|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-5,g,270362,269808,339)}}function voa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/12|0;h=g+1|0;i=e;j=d;if(h>>>0>357913941)mCc(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/12|0;l=k<<1;m=k>>>0<178956970?(l>>>0<h>>>0?h:l):357913941;do if(m)if(m>>>0>357913941){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{n=VDc(m*12|0)|0;break}else n=0;while(0);l=n+(g*12|0)|0;h=n+(m*12|0)|0;f[l>>2]=f[b>>2];f[n+(g*12|0)+4>>2]=f[b+4>>2];f[n+(g*12|0)+8>>2]=f[b+8>>2];b=l+12|0;if((j|0)==(i|0))o=l;else{g=j;j=l;while(1){l=j+-12|0;n=g;g=g+-12|0;f[l>>2]=f[g>>2];f[j+-8>>2]=f[n+-8>>2];f[j+-4>>2]=f[n+-4>>2];if((g|0)==(i|0)){o=l;break}else j=l}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;YDc(e);return}function woa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[a>>2]|0;if((((f[c>>2]|0)-d|0)/40|0)>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>107374182){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=VDc(b*40|0)|0;i=h+(((g|0)/40|0)*40|0)|0;j=i+(((g|0)/-40|0)*40|0)|0;if((g|0)>0)dJc(j|0,d|0,g|0)|0;f[a>>2]=j;f[e>>2]=i;f[c>>2]=h+(b*40|0);if(!d)return;YDc(d);return}function xoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>4;i=VDc(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;YDc(d);return}function yoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/40|0;h=g+1|0;if(h>>>0>107374182)mCc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/40|0;k=j<<1;l=j>>>0<53687091?(k>>>0<h>>>0?h:k):107374182;do if(l)if(l>>>0>107374182){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l*40|0)|0;break}else m=0;while(0);k=m+(g*40|0)|0;g=m+(l*40|0)|0;l=k;m=b;b=l+40|0;do{f[l>>2]=f[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(b|0));m=k+(((e|0)/-40|0)*40|0)|0;if((e|0)>0)dJc(m|0,d|0,e|0)|0;f[a>>2]=m;f[c>>2]=k+40;f[i>>2]=g;if(!d)return;YDc(d);return}
function xVb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;g=u;u=u+480|0;h=g+448|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;o=g+240|0;p=g+200|0;q=g+160|0;r=g+120|0;s=g+80|0;t=g+40|0;v=g;if(!d)w=(f[a+40>>2]|0)+4|0;else w=d+4|0;x=f[w>>2]|0;w=a+4|0;y=f[w>>2]|0;z=VDc(12)|0;fEc(z,x);f[h>>2]=z;x=y+76|0;A=f[x>>2]|0;if((A|0)==(f[y+80>>2]|0))mVb(y+72|0,h);else{f[A>>2]=z;f[x>>2]=(f[x>>2]|0)+4}x=f[h>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0)B=f[x+4>>2]|0;else B=z&255;if(B|0)pEc(x,1,46)|0;B=c+144|0;z=f[B>>2]|0;A=b[z+11>>0]|0;y=A<<24>>24<0;tEc(x,y?f[z>>2]|0:z,y?f[z+4>>2]|0:A&255)|0;tXb(a,f[B>>2]|0,x,c);A=f[w>>2]|0;z=f[B>>2]|0;B=VDc(12)|0;fEc(B,z);f[h>>2]=B;z=A+76|0;y=f[z>>2]|0;if((y|0)==(f[A+80>>2]|0))mVb(A+72|0,h);else{f[y>>2]=B;f[z>>2]=(f[z>>2]|0)+4}f[e>>2]=f[h>>2];z=e+4|0;f[z>>2]=x;f[e+8>>2]=f[a+40>>2];f[e+12>>2]=d;b[e+84>>0]=0;b[e+85>>0]=0;x=c+100|0;B=f[x>>2]|0;f[e+56>>2]=B;y=e+24|0;A=f[w>>2]|0;C=B*28|0;if(!C){D=0;E=B}else{B=VDc(C)|0;f[h>>2]=B;C=A+124|0;F=f[C>>2]|0;if((F|0)==(f[A+128>>2]|0))f6(A+120|0,h);else{f[F>>2]=B;f[C>>2]=(f[C>>2]|0)+4}D=f[h>>2]|0;E=f[x>>2]|0}f[y>>2]=D;if((E|0)>0?(E=c+108|0,KXb(a,f[(f[E>>2]|0)+4>>2]|0,e,D),(f[x>>2]|0)>1):0){D=1;do{KXb(a,f[(f[E>>2]|0)+4+(D<<2)>>2]|0,e,(f[y>>2]|0)+(D*28|0)|0);D=D+1|0}while((D|0)<(f[x>>2]|0))}x=c+20|0;D=f[x>>2]|0;y=e+52|0;f[y>>2]=D;E=e+20|0;C=f[w>>2]|0;B=D*88|0;if(!B){G=0;H=D}else{D=VDc(B)|0;f[h>>2]=D;B=C+124|0;F=f[B>>2]|0;if((F|0)==(f[C+128>>2]|0))f6(C+120|0,h);else{f[F>>2]=D;f[B>>2]=(f[B>>2]|0)+4}G=f[h>>2]|0;H=f[x>>2]|0}f[E>>2]=G;if((H|0)>0?(H=c+28|0,AVb(a,f[(f[H>>2]|0)+4>>2]|0,e,G,0),(f[x>>2]|0)>1):0){G=1;do{AVb(a,f[(f[H>>2]|0)+4+(G<<2)>>2]|0,e,(f[E>>2]|0)+(G*88|0)|0,0);G=G+1|0}while((G|0)<(f[x>>2]|0))}x=c+36|0;G=f[x>>2]|0;f[e+60>>2]=G;H=e+28|0;B=f[w>>2]|0;D=G*88|0;if(!D){I=0;J=G}else{G=VDc(D)|0;f[h>>2]=G;D=B+124|0;F=f[D>>2]|0;if((F|0)==(f[B+128>>2]|0))f6(B+120|0,h);else{f[F>>2]=G;f[D>>2]=(f[D>>2]|0)+4}I=f[h>>2]|0;J=f[x>>2]|0}f[H>>2]=I;if((J|0)>0?(J=c+44|0,xVb(a,f[(f[J>>2]|0)+4>>2]|0,e,I),(f[x>>2]|0)>1):0){I=1;do{xVb(a,f[(f[J>>2]|0)+4+(I<<2)>>2]|0,e,(f[H>>2]|0)+(I*88|0)|0);I=I+1|0}while((I|0)<(f[x>>2]|0))}x=c+52|0;I=f[x>>2]|0;f[e+64>>2]=I;H=e+32|0;J=f[w>>2]|0;D=I*48|0;if(!D){K=0;L=I}else{I=VDc(D)|0;f[h>>2]=I;D=J+124|0;G=f[D>>2]|0;if((G|0)==(f[J+128>>2]|0))f6(J+120|0,h);else{f[G>>2]=I;f[D>>2]=(f[D>>2]|0)+4}K=f[h>>2]|0;L=f[x>>2]|0}f[H>>2]=K;if((L|0)>0?(L=c+60|0,yVb(a,f[(f[L>>2]|0)+4>>2]|0,e,K),(f[x>>2]|0)>1):0){K=1;do{yVb(a,f[(f[L>>2]|0)+4+(K<<2)>>2]|0,e,(f[H>>2]|0)+(K*48|0)|0);K=K+1|0}while((K|0)<(f[x>>2]|0))}x=c+68|0;K=f[x>>2]|0;H=e+68|0;f[H>>2]=K;L=e+36|0;D=f[w>>2]|0;I=K*12|0;if(!I){M=0;N=K}else{K=VDc(I)|0;f[h>>2]=K;I=D+124|0;G=f[I>>2]|0;if((G|0)==(f[D+128>>2]|0))f6(D+120|0,h);else{f[G>>2]=K;f[I>>2]=(f[I>>2]|0)+4}M=f[h>>2]|0;N=f[x>>2]|0}f[L>>2]=M;a:do if((N|0)>0){I=c+76|0;K=0;G=M;while(1){D=f[(f[I>>2]|0)+4+(K<<2)>>2]|0;J=G+(K*12|0)|0;F=f[D+20>>2]|0;f[J>>2]=F;B=f[D+24>>2]|0;C=G+(K*12|0)+4|0;f[C>>2]=B;if((F|0)<1){kVb(a,f[z>>2]|0,D,1,484456);O=f[J>>2]|0;P=f[C>>2]|0}else{O=F;P=B}if((O|0)>=(P|0))kVb(a,f[z>>2]|0,D,1,484501);if(!(f[D+8>>2]&1))f[G+(K*12|0)+8>>2]=0;else{B=f[z>>2]|0;F=f[D+16>>2]|0;LXb(a,B,B,F|0?F:527720,J)}J=K+1|0;if((J|0)>=(f[x>>2]|0))break a;K=J;G=f[L>>2]|0}}while(0);x=c+84|0;P=f[x>>2]|0;f[e+72>>2]=P;O=e+40|0;M=f[w>>2]|0;N=P*88|0;if(!N){Q=0;R=P}else{P=VDc(N)|0;f[h>>2]=P;N=M+124|0;G=f[N>>2]|0;if((G|0)==(f[M+128>>2]|0))f6(M+120|0,h);else{f[G>>2]=P;f[N>>2]=(f[N>>2]|0)+4}Q=f[h>>2]|0;R=f[x>>2]|0}f[O>>2]=Q;if((R|0)>0?(R=c+92|0,AVb(a,f[(f[R>>2]|0)+4>>2]|0,e,Q,1),(f[x>>2]|0)>1):0){Q=1;do{AVb(a,f[(f[R>>2]|0)+4+(Q<<2)>>2]|0,e,(f[O>>2]|0)+(Q*88|0)|0,1);Q=Q+1|0}while((Q|0)<(f[x>>2]|0))}x=c+116|0;Q=f[x>>2]|0;O=e+76|0;f[O>>2]=Q;R=e+44|0;N=f[w>>2]|0;P=Q<<3;if(!P){S=0;T=Q}else{Q=VDc(P)|0;f[h>>2]=Q;P=N+124|0;G=f[P>>2]|0;if((G|0)==(f[N+128>>2]|0))f6(N+120|0,h);else{f[G>>2]=Q;f[P>>2]=(f[P>>2]|0)+4}S=f[h>>2]|0;T=f[x>>2]|0}f[R>>2]=S;b:do if((T|0)>0){P=c+124|0;Q=0;G=S;N=T;while(1){M=f[(f[P>>2]|0)+4+(Q<<2)>>2]|0;K=f[M+16>>2]|0;f[G+(Q<<3)>>2]=K;f[G+(Q<<3)+4>>2]=f[M+20>>2];if((K|0)<1){kVb(a,f[z>>2]|0,M,1,484563);U=f[x>>2]|0}else U=N;M=Q+1|0;if((M|0)>=(U|0))break b;Q=M;G=f[R>>2]|0;N=U}}while(0);U=c+132|0;T=f[U>>2]|0;f[e+80>>2]=T;S=f[w>>2]|0;N=T<<2;if(!N)V=0;else{G=VDc(N)|0;f[h>>2]=G;N=S+124|0;Q=f[N>>2]|0;if((Q|0)==(f[S+128>>2]|0))f6(S+120|0,h);else{f[Q>>2]=G;f[N>>2]=(f[N>>2]|0)+4}V=f[h>>2]|0}N=e+48|0;f[N>>2]=V;if((T|0)>0){V=c+140|0;G=0;do{Q=f[w>>2]|0;S=f[(f[V>>2]|0)+4+(G<<2)>>2]|0;P=VDc(12)|0;fEc(P,S);f[h>>2]=P;S=Q+76|0;M=f[S>>2]|0;if((M|0)==(f[Q+80>>2]|0))mVb(Q+72|0,h);else{f[M>>2]=P;f[S>>2]=(f[S>>2]|0)+4}f[(f[N>>2]|0)+(G<<2)>>2]=f[h>>2];G=G+1|0}while((G|0)<(T|0))}if(!(f[c+8>>2]&2))f[e+16>>2]=0;else{T=f[c+148>>2]|0;G=f[z>>2]|0;MXb(a,G,G,T|0?T:528152,e)}T=f[z>>2]|0;G=f[e>>2]|0;f[i>>2]=1;f[i+4>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];vXb(a,T,d,G,c,h)|0;G=f[x>>2]|0;if((G|0)>0){d=c+124|0;T=j+8|0;i=j+4|0;e=k+8|0;N=k+4|0;V=l+8|0;w=l+4|0;S=m+8|0;P=m+4|0;M=o+4|0;Q=p+4|0;K=q+4|0;I=r+4|0;J=s+4|0;F=t+4|0;B=h+11|0;D=0;C=G;while(1){G=f[d>>2]|0;A=f[G+4+(D<<2)>>2]|0;W=D;D=D+1|0;c:do if((D|0)<(C|0)){Y=A+20|0;Z=A+16|0;_=D;$=G;aa=C;while(1){ba=f[$+4+(_<<2)>>2]|0;ca=f[ba+16>>2]|0;do if((f[Y>>2]|0)>(ca|0)){da=ba+20|0;if((f[da>>2]|0)<=(f[Z>>2]|0)){ea=aa;break}fa=f[z>>2]|0;ga=f[$+4+(W<<2)>>2]|0;ha=amc(ca,T)|0;f[j>>2]=ha;ia=Mpc(ha)|0;f[i>>2]=ia;ia=amc((f[da>>2]|0)+-1|0,e)|0;f[k>>2]=ia;da=Mpc(ia)|0;f[N>>2]=da;da=amc(f[Z>>2]|0,V)|0;f[l>>2]=da;ia=Mpc(da)|0;f[w>>2]=ia;ia=amc((f[Y>>2]|0)+-1|0,S)|0;f[m>>2]=ia;da=Mpc(ia)|0;f[P>>2]=da;f[o>>2]=0;f[M>>2]=-1;f[p>>2]=0;f[Q>>2]=-1;f[q>>2]=0;f[K>>2]=-1;f[r>>2]=0;f[I>>2]=-1;f[s>>2]=0;f[J>>2]=-1;f[t>>2]=0;f[F>>2]=-1;Jhc(h,483913,j,k,l,m,o,p,q,r,s,t);lVb(a,fa,ga,1,h);if((b[B>>0]|0)<0)YDc(f[h>>2]|0);ea=f[x>>2]|0}else ea=aa;while(0);ca=_+1|0;if((ca|0)>=(ea|0)){ja=ea;break c}_=ca;$=f[d>>2]|0;aa=ea}}else ja=C;while(0);if((D|0)>=(ja|0))break;else C=ja}}ja=h+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;n[ja>>2]=1.0;if((f[U>>2]|0)>0){C=c+140|0;D=h+4|0;ea=h+12|0;d=h+8|0;x=k+4|0;B=l+4|0;F=m+4|0;J=o+4|0;I=p+4|0;K=q+4|0;Q=r+4|0;M=s+4|0;P=t+4|0;S=v+4|0;w=j+11|0;V=0;do{N=f[(f[C>>2]|0)+4+(V<<2)>>2]|0;d:do if(EXb(h,N)|0){e=b[N+11>>0]|0;i=e<<24>>24<0;f[k>>2]=i?f[N>>2]|0:N;f[x>>2]=i?f[N+4>>2]|0:e&255;f[l>>2]=0;f[B>>2]=-1;f[m>>2]=0;f[F>>2]=-1;f[o>>2]=0;f[J>>2]=-1;f[p>>2]=0;f[I>>2]=-1;f[q>>2]=0;f[K>>2]=-1;f[r>>2]=0;f[Q>>2]=-1;f[s>>2]=0;f[M>>2]=-1;f[t>>2]=0;f[P>>2]=-1;f[v>>2]=0;f[S>>2]=-1;Jhc(j,484607,k,l,m,o,p,q,r,s,t,v);lVb(a,N,c,0,j);if((b[w>>0]|0)<0)YDc(f[j>>2]|0)}else{e=b[N+11>>0]|0;i=e<<24>>24<0;T=i?f[N>>2]|0:N;W=b[T>>0]|0;if(!(W<<24>>24))ka=0;else{G=T;A=0;aa=W;while(1){$=(A*5|0)+(aa<<24>>24)|0;G=G+1|0;aa=b[G>>0]|0;if(!(aa<<24>>24)){ka=$;break}else A=$}}A=f[D>>2]|0;aa=(A|0)==0;e:do if(aa)la=0;else{G=A+-1|0;$=(G&A|0)==0;do if($)ma=G&ka;else{if(ka>>>0<A>>>0){ma=ka;break}ma=(ka>>>0)%(A>>>0)|0}while(0);_=f[(f[h>>2]|0)+(ma<<2)>>2]|0;if(!_){la=ma;break}Y=f[_>>2]|0;if(!Y){la=ma;break}_=i?f[N+4>>2]|0:e&255;Z=(_|0)==0;if($){if(Z){ca=Y;while(1){ba=f[ca+4>>2]|0;if(!((ba|0)==(ka|0)|(ba&G|0)==(ma|0))){la=ma;break e}ba=b[ca+8+11>>0]|0;if(!((ba<<24>>24<0?f[ca+12>>2]|0:ba&255)|0))break d;ca=f[ca>>2]|0;if(!ca){la=ma;break e}}}else na=Y;while(1){ca=f[na+4>>2]|0;if(!((ca|0)==(ka|0)|(ca&G|0)==(ma|0))){la=ma;break e}ca=na+8|0;$=b[ca+11>>0]|0;ba=$<<24>>24<0;ga=$&255;do if(((ba?f[na+12>>2]|0:ga)|0)==(_|0)){$=f[ca>>2]|0;if(ba)if(!(Arc($,T,_)|0))break d;else break;if(($&255)<<24>>24!=W<<24>>24)break;$=ca;fa=ga;da=T;do{fa=fa+-1|0;$=$+1|0;if(!fa)break d;da=da+1|0}while((b[$>>0]|0)==(b[da>>0]|0))}while(0);na=f[na>>2]|0;if(!na){la=ma;break e}}}if(Z){G=Y;while(1){ga=f[G+4>>2]|0;if((ga|0)!=(ka|0)){if(ga>>>0<A>>>0)oa=ga;else oa=(ga>>>0)%(A>>>0)|0;if((oa|0)!=(ma|0)){la=ma;break e}}ga=b[G+8+11>>0]|0;if(!((ga<<24>>24<0?f[G+12>>2]|0:ga&255)|0))break d;G=f[G>>2]|0;if(!G){la=ma;break e}}}else pa=Y;while(1){G=f[pa+4>>2]|0;if((G|0)!=(ka|0)){if(G>>>0<A>>>0)qa=G;else qa=(G>>>0)%(A>>>0)|0;if((qa|0)!=(ma|0)){la=ma;break e}}G=pa+8|0;Z=b[G+11>>0]|0;ga=Z<<24>>24<0;ca=Z&255;do if(((ga?f[pa+12>>2]|0:ca)|0)==(_|0)){Z=f[G>>2]|0;if(ga)if(!(Arc(Z,T,_)|0))break d;else break;if((Z&255)<<24>>24!=W<<24>>24)break;Z=G;ba=ca;da=T;do{ba=ba+-1|0;Z=Z+1|0;if(!ba)break d;da=da+1|0}while((b[Z>>0]|0)==(b[da>>0]|0))}while(0);pa=f[pa>>2]|0;if(!pa){la=ma;break}}}while(0);T=VDc(20)|0;fEc(T+8|0,N);f[T+4>>2]=ka;f[T>>2]=0;ra=+(((f[ea>>2]|0)+1|0)>>>0);sa=+n[ja>>2];do if(aa|ra>+(A>>>0)*sa){W=(A>>>0<3|(A+-1&A|0)!=0)&1|A<<1;e=~~+X(+(ra/sa))>>>0;YUb(h,W>>>0<e>>>0?e:W);W=f[D>>2]|0;e=W+-1|0;if(!(e&W)){ta=W;ua=e&ka;break}if(ka>>>0<W>>>0){ta=W;ua=ka;break}ta=W;ua=(ka>>>0)%(W>>>0)|0}else{ta=A;ua=la}while(0);A=(f[h>>2]|0)+(ua<<2)|0;aa=f[A>>2]|0;do if(!aa){f[T>>2]=f[d>>2];f[d>>2]=T;f[A>>2]=d;W=f[T>>2]|0;if(!W)break;e=f[W+4>>2]|0;W=ta+-1|0;do if(!(W&ta))va=e&W;else{if(e>>>0<ta>>>0){va=e;break}va=(e>>>0)%(ta>>>0)|0}while(0);wa=(f[h>>2]|0)+(va<<2)|0;xa=168}else{f[T>>2]=f[aa>>2];wa=aa;xa=168}while(0);if((xa|0)==168){xa=0;f[wa>>2]=T}f[ea>>2]=(f[ea>>2]|0)+1}while(0);V=V+1|0}while((V|0)<(f[U>>2]|0))}if((f[y>>2]|0)>0){U=c+28|0;V=k+4|0;ea=l+4|0;wa=m+4|0;xa=o+4|0;va=p+4|0;ta=q+4|0;d=r+4|0;ua=s+4|0;la=t+4|0;ka=v+4|0;D=j+11|0;ja=c+124|0;ma=k+4|0;pa=l+8|0;qa=l+4|0;oa=m+4|0;na=o+4|0;w=p+4|0;S=q+4|0;P=r+4|0;M=s+4|0;Q=t+4|0;K=v+4|0;I=j+11|0;J=c+76|0;F=k+8|0;B=k+4|0;x=l+8|0;C=l+4|0;N=m+4|0;aa=o+8|0;A=o+4|0;e=p+4|0;W=q+4|0;i=r+4|0;_=s+4|0;Y=t+4|0;ca=v+4|0;G=j+11|0;ga=0;do{da=f[E>>2]|0;Z=da+(ga*88|0)|0;ba=f[H>>2]|0;if((ba|0)>0){$=da+(ga*88|0)+40|0;fa=da+(ga*88|0)+4|0;ia=0;ha=ba;while(1){ba=f[L>>2]|0;ya=f[ba+(ia*12|0)>>2]|0;za=f[$>>2]|0;do if((ya|0)>(za|0))Aa=ha;else{Ba=ba+(ia*12|0)+4|0;if((za|0)>=(f[Ba>>2]|0)){Aa=ha;break}Ca=f[fa>>2]|0;Da=f[(f[J>>2]|0)+4+(ia<<2)>>2]|0;Ea=amc(ya,F)|0;f[k>>2]=Ea;Fa=Mpc(Ea)|0;f[B>>2]=Fa;Fa=amc((f[Ba>>2]|0)+-1|0,x)|0;f[l>>2]=Fa;Ba=Mpc(Fa)|0;f[C>>2]=Ba;Ba=f[Z>>2]|0;Fa=b[Ba+11>>0]|0;Ea=Fa<<24>>24<0;f[m>>2]=Ea?f[Ba>>2]|0:Ba;f[N>>2]=Ea?f[Ba+4>>2]|0:Fa&255;Fa=amc(f[$>>2]|0,aa)|0;f[o>>2]=Fa;Ba=Mpc(Fa)|0;f[A>>2]=Ba;f[p>>2]=0;f[e>>2]=-1;f[q>>2]=0;f[W>>2]=-1;f[r>>2]=0;f[i>>2]=-1;f[s>>2]=0;f[_>>2]=-1;f[t>>2]=0;f[Y>>2]=-1;f[v>>2]=0;f[ca>>2]=-1;Jhc(j,484651,k,l,m,o,p,q,r,s,t,v);lVb(a,Ca,Da,1,j);if((b[G>>0]|0)<0)YDc(f[j>>2]|0);Aa=f[H>>2]|0}while(0);ia=ia+1|0;if((ia|0)>=(Aa|0))break;else ha=Aa}}ha=f[O>>2]|0;if((ha|0)>0){ia=da+(ga*88|0)+40|0;$=da+(ga*88|0)+4|0;fa=0;ya=ha;while(1){ha=f[R>>2]|0;za=f[ia>>2]|0;do if((f[ha+(fa<<3)>>2]|0)>(za|0))Ga=ya;else{if((za|0)>=(f[ha+(fa<<3)+4>>2]|0)){Ga=ya;break}ba=f[$>>2]|0;T=f[(f[ja>>2]|0)+4+(fa<<2)>>2]|0;Da=f[Z>>2]|0;Ca=b[Da+11>>0]|0;Ba=Ca<<24>>24<0;f[k>>2]=Ba?f[Da>>2]|0:Da;f[ma>>2]=Ba?f[Da+4>>2]|0:Ca&255;Ca=amc(za,pa)|0;f[l>>2]=Ca;Da=Mpc(Ca)|0;f[qa>>2]=Da;f[m>>2]=0;f[oa>>2]=-1;f[o>>2]=0;f[na>>2]=-1;f[p>>2]=0;f[w>>2]=-1;f[q>>2]=0;f[S>>2]=-1;f[r>>2]=0;f[P>>2]=-1;f[s>>2]=0;f[M>>2]=-1;f[t>>2]=0;f[Q>>2]=-1;f[v>>2]=0;f[K>>2]=-1;Jhc(j,484702,k,l,m,o,p,q,r,s,t,v);lVb(a,ba,T,1,j);if((b[I>>0]|0)<0)YDc(f[j>>2]|0);Ga=f[O>>2]|0}while(0);fa=fa+1|0;if((fa|0)>=(Ga|0)){Ha=Z;break}else ya=Ga}}else Ha=Z;if(EXb(h,f[Ha>>2]|0)|0?(ya=f[da+(ga*88|0)+4>>2]|0,fa=f[(f[U>>2]|0)+4+(ga<<2)>>2]|0,$=f[Ha>>2]|0,ia=b[$+11>>0]|0,za=ia<<24>>24<0,f[k>>2]=za?f[$>>2]|0:$,f[V>>2]=za?f[$+4>>2]|0:ia&255,f[l>>2]=0,f[ea>>2]=-1,f[m>>2]=0,f[wa>>2]=-1,f[o>>2]=0,f[xa>>2]=-1,f[p>>2]=0,f[va>>2]=-1,f[q>>2]=0,f[ta>>2]=-1,f[r>>2]=0,f[d>>2]=-1,f[s>>2]=0,f[ua>>2]=-1,f[t>>2]=0,f[la>>2]=-1,f[v>>2]=0,f[ka>>2]=-1,Jhc(j,484738,k,l,m,o,p,q,r,s,t,v),lVb(a,ya,fa,0,j),(b[D>>0]|0)<0):0)YDc(f[j>>2]|0);ga=ga+1|0}while((ga|0)<(f[y>>2]|0))}y=f[H>>2]|0;if((y|0)>0){ga=c+76|0;c=k+8|0;D=k+4|0;ka=l+8|0;la=l+4|0;ua=m+8|0;d=m+4|0;ta=o+8|0;va=o+4|0;xa=p+4|0;wa=q+4|0;ea=r+4|0;V=s+4|0;Ha=t+4|0;U=v+4|0;Ga=j+11|0;I=k+8|0;K=k+4|0;Q=l+8|0;M=l+4|0;P=m+8|0;S=m+4|0;w=o+8|0;na=o+4|0;oa=p+4|0;qa=q+4|0;pa=r+4|0;ma=s+4|0;ja=t+4|0;Aa=v+4|0;G=j+11|0;ca=0;Y=y;while(1){y=f[L>>2]|0;_=y+(ca*12|0)|0;i=f[O>>2]|0;if((i|0)>0){W=y+(ca*12|0)+4|0;e=0;A=i;while(1){i=f[R>>2]|0;aa=i+(e<<3)|0;do if((f[W>>2]|0)>(f[aa>>2]|0)){N=i+(e<<3)+4|0;C=f[_>>2]|0;if((f[N>>2]|0)<=(C|0)){Ia=A;break}x=f[z>>2]|0;B=f[(f[ga>>2]|0)+4+(ca<<2)>>2]|0;F=amc(C,I)|0;f[k>>2]=F;C=Mpc(F)|0;f[K>>2]=C;C=amc((f[W>>2]|0)+-1|0,Q)|0;f[l>>2]=C;F=Mpc(C)|0;f[M>>2]=F;F=amc(f[aa>>2]|0,P)|0;f[m>>2]=F;C=Mpc(F)|0;f[S>>2]=C;C=amc((f[N>>2]|0)+-1|0,w)|0;f[o>>2]=C;N=Mpc(C)|0;f[na>>2]=N;f[p>>2]=0;f[oa>>2]=-1;f[q>>2]=0;f[qa>>2]=-1;f[r>>2]=0;f[pa>>2]=-1;f[s>>2]=0;f[ma>>2]=-1;f[t>>2]=0;f[ja>>2]=-1;f[v>>2]=0;f[Aa>>2]=-1;Jhc(j,484767,k,l,m,o,p,q,r,s,t,v);lVb(a,x,B,1,j);if((b[G>>0]|0)<0)YDc(f[j>>2]|0);Ia=f[O>>2]|0}else Ia=A;while(0);e=e+1|0;if((e|0)>=(Ia|0))break;else A=Ia}Ja=f[H>>2]|0}else Ja=Y;A=ca;ca=ca+1|0;if((ca|0)<(Ja|0)){e=y+(A*12|0)+4|0;W=ca;da=Ja;while(1){Z=f[L>>2]|0;aa=f[Z+(W*12|0)>>2]|0;do if((f[e>>2]|0)>(aa|0)){i=Z+(W*12|0)+4|0;if((f[i>>2]|0)<=(f[_>>2]|0)){Ka=da;break}B=f[z>>2]|0;x=f[(f[ga>>2]|0)+4+(A<<2)>>2]|0;N=amc(aa,c)|0;f[k>>2]=N;C=Mpc(N)|0;f[D>>2]=C;C=amc((f[i>>2]|0)+-1|0,ka)|0;f[l>>2]=C;i=Mpc(C)|0;f[la>>2]=i;i=amc(f[_>>2]|0,ua)|0;f[m>>2]=i;C=Mpc(i)|0;f[d>>2]=C;C=amc((f[e>>2]|0)+-1|0,ta)|0;f[o>>2]=C;i=Mpc(C)|0;f[va>>2]=i;f[p>>2]=0;f[xa>>2]=-1;f[q>>2]=0;f[wa>>2]=-1;f[r>>2]=0;f[ea>>2]=-1;f[s>>2]=0;f[V>>2]=-1;f[t>>2]=0;f[Ha>>2]=-1;f[v>>2]=0;f[U>>2]=-1;Jhc(j,484831,k,l,m,o,p,q,r,s,t,v);lVb(a,B,x,1,j);if((b[Ga>>0]|0)<0)YDc(f[j>>2]|0);Ka=f[H>>2]|0}else Ka=da;while(0);W=W+1|0;if((W|0)>=(Ka|0)){La=Ka;break}else da=Ka}}else La=Ja;if((ca|0)>=(La|0))break;else Y=La}}La=f[h+8>>2]|0;if(La|0){Y=La;do{La=Y;Y=f[Y>>2]|0;ca=La+8|0;if((b[ca+11>>0]|0)<0)YDc(f[ca>>2]|0);YDc(La)}while((Y|0)!=0)}Y=f[h>>2]|0;f[h>>2]=0;if(!Y){u=g;return}YDc(Y);u=g;return}function yVb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;g=u;u=u+480|0;h=g+448|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;o=g+240|0;p=g+200|0;q=g+160|0;r=g+120|0;s=g+80|0;t=g+40|0;v=g;if(!d)w=(f[a+40>>2]|0)+4|0;else w=d+4|0;x=f[w>>2]|0;w=a+4|0;y=f[w>>2]|0;z=VDc(12)|0;fEc(z,x);f[h>>2]=z;x=y+76|0;A=f[x>>2]|0;if((A|0)==(f[y+80>>2]|0))mVb(y+72|0,h);else{f[A>>2]=z;f[x>>2]=(f[x>>2]|0)+4}x=f[h>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0)B=f[x+4>>2]|0;else B=z&255;if(B|0)pEc(x,1,46)|0;B=c+64|0;z=f[B>>2]|0;A=b[z+11>>0]|0;y=A<<24>>24<0;tEc(x,y?f[z>>2]|0:z,y?f[z+4>>2]|0:A&255)|0;tXb(a,f[B>>2]|0,x,c);A=f[w>>2]|0;z=f[B>>2]|0;B=VDc(12)|0;fEc(B,z);f[h>>2]=B;z=A+76|0;y=f[z>>2]|0;if((y|0)==(f[A+80>>2]|0))mVb(A+72|0,h);else{f[y>>2]=B;f[z>>2]=(f[z>>2]|0)+4}f[e>>2]=f[h>>2];z=e+4|0;f[z>>2]=x;f[e+8>>2]=f[a+40>>2];f[e+12>>2]=d;b[e+20>>0]=0;b[e+21>>0]=0;B=c+20|0;y=f[B>>2]|0;if(!y){kVb(a,x,c,0,483813);C=f[B>>2]|0}else C=y;y=e+24|0;f[y>>2]=C;x=e+28|0;A=f[w>>2]|0;D=C*20|0;if(!D){E=0;F=C}else{C=VDc(D)|0;f[h>>2]=C;D=A+124|0;G=f[D>>2]|0;if((G|0)==(f[A+128>>2]|0))f6(A+120|0,h);else{f[G>>2]=C;f[D>>2]=(f[D>>2]|0)+4}E=f[h>>2]|0;F=f[B>>2]|0}f[x>>2]=E;if((F|0)>0?(F=c+28|0,BXb(a,f[(f[F>>2]|0)+4>>2]|0,e,E),(f[B>>2]|0)>1):0){E=1;do{BXb(a,f[(f[F>>2]|0)+4+(E<<2)>>2]|0,e,(f[x>>2]|0)+(E*20|0)|0);E=E+1|0}while((E|0)<(f[B>>2]|0))}B=c+36|0;E=f[B>>2]|0;F=e+32|0;f[F>>2]=E;D=e+40|0;C=f[w>>2]|0;G=E<<3;if(!G){H=0;I=E}else{E=VDc(G)|0;f[h>>2]=E;G=C+124|0;A=f[G>>2]|0;if((A|0)==(f[C+128>>2]|0))f6(C+120|0,h);else{f[A>>2]=E;f[G>>2]=(f[G>>2]|0)+4}H=f[h>>2]|0;I=f[B>>2]|0}f[D>>2]=H;a:do if((I|0)>0){G=c+44|0;E=0;A=H;C=I;while(1){J=f[(f[G>>2]|0)+4+(E<<2)>>2]|0;K=f[J+16>>2]|0;f[A+(E<<3)>>2]=K;L=f[J+20>>2]|0;f[A+(E<<3)+4>>2]=L;if((K|0)>(L|0)){kVb(a,f[z>>2]|0,J,1,483852);M=f[B>>2]|0}else M=C;J=E+1|0;if((J|0)>=(M|0))break a;E=J;A=f[D>>2]|0;C=M}}while(0);M=c+52|0;I=f[M>>2]|0;f[e+36>>2]=I;H=f[w>>2]|0;C=I<<2;if(!C)N=0;else{A=VDc(C)|0;f[h>>2]=A;C=H+124|0;E=f[C>>2]|0;if((E|0)==(f[H+128>>2]|0))f6(H+120|0,h);else{f[E>>2]=A;f[C>>2]=(f[C>>2]|0)+4}N=f[h>>2]|0}C=e+44|0;f[C>>2]=N;if((I|0)>0){N=c+60|0;A=0;do{E=f[w>>2]|0;H=f[(f[N>>2]|0)+4+(A<<2)>>2]|0;G=VDc(12)|0;fEc(G,H);f[h>>2]=G;H=E+76|0;J=f[H>>2]|0;if((J|0)==(f[E+80>>2]|0))mVb(E+72|0,h);else{f[J>>2]=G;f[H>>2]=(f[H>>2]|0)+4}f[(f[C>>2]|0)+(A<<2)>>2]=f[h>>2];A=A+1|0}while((A|0)<(I|0))}CXb(a,c,e);if(!(f[c+8>>2]&2))f[e+16>>2]=0;else{I=f[c+68>>2]|0;A=f[z>>2]|0;DXb(a,A,A,I|0?I:528320,e)}I=f[z>>2]|0;A=f[e>>2]|0;f[i>>2]=4;f[i+4>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];vXb(a,I,d,A,c,h)|0;A=f[B>>2]|0;if((A|0)>0){d=c+44|0;I=j+8|0;i=j+4|0;e=k+8|0;C=k+4|0;N=l+8|0;w=l+4|0;H=m+8|0;G=m+4|0;J=o+4|0;E=p+4|0;L=q+4|0;K=r+4|0;O=s+4|0;P=t+4|0;Q=h+11|0;R=0;S=A;while(1){A=f[d>>2]|0;T=f[A+4+(R<<2)>>2]|0;U=R;R=R+1|0;b:do if((R|0)<(S|0)){V=T+20|0;W=T+16|0;Y=R;Z=A;_=S;while(1){$=f[Z+4+(Y<<2)>>2]|0;aa=f[$+16>>2]|0;do if((f[V>>2]|0)>(aa|0)){ba=$+20|0;if((f[ba>>2]|0)<=(f[W>>2]|0)){ca=_;break}da=f[z>>2]|0;ea=f[Z+4+(U<<2)>>2]|0;fa=amc(aa,I)|0;f[j>>2]=fa;ga=Mpc(fa)|0;f[i>>2]=ga;ga=amc((f[ba>>2]|0)+-1|0,e)|0;f[k>>2]=ga;ba=Mpc(ga)|0;f[C>>2]=ba;ba=amc(f[W>>2]|0,N)|0;f[l>>2]=ba;ga=Mpc(ba)|0;f[w>>2]=ga;ga=amc((f[V>>2]|0)+-1|0,H)|0;f[m>>2]=ga;ba=Mpc(ga)|0;f[G>>2]=ba;f[o>>2]=0;f[J>>2]=-1;f[p>>2]=0;f[E>>2]=-1;f[q>>2]=0;f[L>>2]=-1;f[r>>2]=0;f[K>>2]=-1;f[s>>2]=0;f[O>>2]=-1;f[t>>2]=0;f[P>>2]=-1;Jhc(h,483913,j,k,l,m,o,p,q,r,s,t);lVb(a,da,ea,1,h);if((b[Q>>0]|0)<0)YDc(f[h>>2]|0);ca=f[B>>2]|0}else ca=_;while(0);aa=Y+1|0;if((aa|0)>=(ca|0)){ha=ca;break b}Y=aa;Z=f[d>>2]|0;_=ca}}else ha=S;while(0);if((R|0)>=(ha|0))break;else S=ha}}ha=h+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;n[ha>>2]=1.0;if((f[M>>2]|0)>0){S=c+60|0;R=h+4|0;ca=h+12|0;d=h+8|0;B=k+4|0;Q=l+4|0;P=m+4|0;O=o+4|0;K=p+4|0;L=q+4|0;E=r+4|0;J=s+4|0;G=t+4|0;H=v+4|0;w=j+11|0;N=0;do{C=f[(f[S>>2]|0)+4+(N<<2)>>2]|0;c:do if(EXb(h,C)|0){e=b[C+11>>0]|0;i=e<<24>>24<0;f[k>>2]=i?f[C>>2]|0:C;f[B>>2]=i?f[C+4>>2]|0:e&255;f[l>>2]=0;f[Q>>2]=-1;f[m>>2]=0;f[P>>2]=-1;f[o>>2]=0;f[O>>2]=-1;f[p>>2]=0;f[K>>2]=-1;f[q>>2]=0;f[L>>2]=-1;f[r>>2]=0;f[E>>2]=-1;f[s>>2]=0;f[J>>2]=-1;f[t>>2]=0;f[G>>2]=-1;f[v>>2]=0;f[H>>2]=-1;Jhc(j,483983,k,l,m,o,p,q,r,s,t,v);lVb(a,C,c,0,j);if((b[w>>0]|0)<0)YDc(f[j>>2]|0)}else{e=b[C+11>>0]|0;i=e<<24>>24<0;I=i?f[C>>2]|0:C;z=b[I>>0]|0;if(!(z<<24>>24))ia=0;else{U=I;A=0;T=z;while(1){_=(A*5|0)+(T<<24>>24)|0;U=U+1|0;T=b[U>>0]|0;if(!(T<<24>>24)){ia=_;break}else A=_}}A=f[R>>2]|0;T=(A|0)==0;d:do if(T)ja=0;else{U=A+-1|0;_=(U&A|0)==0;do if(_)ka=U&ia;else{if(ia>>>0<A>>>0){ka=ia;break}ka=(ia>>>0)%(A>>>0)|0}while(0);Z=f[(f[h>>2]|0)+(ka<<2)>>2]|0;if(!Z){ja=ka;break}Y=f[Z>>2]|0;if(!Y){ja=ka;break}Z=i?f[C+4>>2]|0:e&255;V=(Z|0)==0;if(_){if(V){W=Y;while(1){aa=f[W+4>>2]|0;if(!((aa|0)==(ia|0)|(aa&U|0)==(ka|0))){ja=ka;break d}aa=b[W+8+11>>0]|0;if(!((aa<<24>>24<0?f[W+12>>2]|0:aa&255)|0))break c;W=f[W>>2]|0;if(!W){ja=ka;break d}}}else la=Y;while(1){W=f[la+4>>2]|0;if(!((W|0)==(ia|0)|(W&U|0)==(ka|0))){ja=ka;break d}W=la+8|0;_=b[W+11>>0]|0;aa=_<<24>>24<0;$=_&255;do if(((aa?f[la+12>>2]|0:$)|0)==(Z|0)){_=f[W>>2]|0;if(aa)if(!(Arc(_,I,Z)|0))break c;else break;if((_&255)<<24>>24!=z<<24>>24)break;_=W;ea=$;da=I;do{ea=ea+-1|0;_=_+1|0;if(!ea)break c;da=da+1|0}while((b[_>>0]|0)==(b[da>>0]|0))}while(0);la=f[la>>2]|0;if(!la){ja=ka;break d}}}if(V){U=Y;while(1){$=f[U+4>>2]|0;if(($|0)!=(ia|0)){if($>>>0<A>>>0)ma=$;else ma=($>>>0)%(A>>>0)|0;if((ma|0)!=(ka|0)){ja=ka;break d}}$=b[U+8+11>>0]|0;if(!(($<<24>>24<0?f[U+12>>2]|0:$&255)|0))break c;U=f[U>>2]|0;if(!U){ja=ka;break d}}}else na=Y;while(1){U=f[na+4>>2]|0;if((U|0)!=(ia|0)){if(U>>>0<A>>>0)oa=U;else oa=(U>>>0)%(A>>>0)|0;if((oa|0)!=(ka|0)){ja=ka;break d}}U=na+8|0;V=b[U+11>>0]|0;$=V<<24>>24<0;W=V&255;do if((($?f[na+12>>2]|0:W)|0)==(Z|0)){V=f[U>>2]|0;if($)if(!(Arc(V,I,Z)|0))break c;else break;if((V&255)<<24>>24!=z<<24>>24)break;V=U;aa=W;da=I;do{aa=aa+-1|0;V=V+1|0;if(!aa)break c;da=da+1|0}while((b[V>>0]|0)==(b[da>>0]|0))}while(0);na=f[na>>2]|0;if(!na){ja=ka;break}}}while(0);I=VDc(20)|0;fEc(I+8|0,C);f[I+4>>2]=ia;f[I>>2]=0;pa=+(((f[ca>>2]|0)+1|0)>>>0);qa=+n[ha>>2];do if(T|pa>+(A>>>0)*qa){z=(A>>>0<3|(A+-1&A|0)!=0)&1|A<<1;e=~~+X(+(pa/qa))>>>0;YUb(h,z>>>0<e>>>0?e:z);z=f[R>>2]|0;e=z+-1|0;if(!(e&z)){ra=z;sa=e&ia;break}if(ia>>>0<z>>>0){ra=z;sa=ia;break}ra=z;sa=(ia>>>0)%(z>>>0)|0}else{ra=A;sa=ja}while(0);A=(f[h>>2]|0)+(sa<<2)|0;T=f[A>>2]|0;do if(!T){f[I>>2]=f[d>>2];f[d>>2]=I;f[A>>2]=d;z=f[I>>2]|0;if(!z)break;e=f[z+4>>2]|0;z=ra+-1|0;do if(!(z&ra))ta=e&z;else{if(e>>>0<ra>>>0){ta=e;break}ta=(e>>>0)%(ra>>>0)|0}while(0);ua=(f[h>>2]|0)+(ta<<2)|0;va=122}else{f[I>>2]=f[T>>2];ua=T;va=122}while(0);if((va|0)==122){va=0;f[ua>>2]=I}f[ca>>2]=(f[ca>>2]|0)+1}while(0);N=N+1|0}while((N|0)<(f[M>>2]|0))}if((f[y>>2]|0)>0){M=c+28|0;N=k+4|0;ca=l+4|0;ua=m+4|0;va=o+4|0;ta=p+4|0;ra=q+4|0;d=r+4|0;sa=s+4|0;ja=t+4|0;ia=v+4|0;R=j+11|0;ha=c+44|0;c=k+4|0;ka=l+8|0;na=l+4|0;oa=m+4|0;ma=o+4|0;la=p+4|0;w=q+4|0;H=r+4|0;G=s+4|0;J=t+4|0;E=v+4|0;L=j+11|0;K=0;do{O=f[x>>2]|0;P=O+(K*20|0)|0;Q=f[F>>2]|0;if((Q|0)>0){B=O+(K*20|0)+8|0;S=O+(K*20|0)+4|0;C=0;T=Q;while(1){Q=f[D>>2]|0;A=f[B>>2]|0;do if((f[Q+(C<<3)>>2]|0)>(A|0))wa=T;else{if((A|0)>(f[Q+(C<<3)+4>>2]|0)){wa=T;break}e=f[S>>2]|0;z=f[(f[ha>>2]|0)+4+(C<<2)>>2]|0;i=f[P>>2]|0;Z=b[i+11>>0]|0;Y=Z<<24>>24<0;f[k>>2]=Y?f[i>>2]|0:i;f[c>>2]=Y?f[i+4>>2]|0:Z&255;Z=amc(A,ka)|0;f[l>>2]=Z;i=Mpc(Z)|0;f[na>>2]=i;f[m>>2]=0;f[oa>>2]=-1;f[o>>2]=0;f[ma>>2]=-1;f[p>>2]=0;f[la>>2]=-1;f[q>>2]=0;f[w>>2]=-1;f[r>>2]=0;f[H>>2]=-1;f[s>>2]=0;f[G>>2]=-1;f[t>>2]=0;f[J>>2]=-1;f[v>>2]=0;f[E>>2]=-1;Jhc(j,484027,k,l,m,o,p,q,r,s,t,v);lVb(a,e,z,1,j);if((b[L>>0]|0)<0)YDc(f[j>>2]|0);wa=f[F>>2]|0}while(0);C=C+1|0;if((C|0)>=(wa|0)){xa=P;break}else T=wa}}else xa=P;if(EXb(h,f[xa>>2]|0)|0?(T=f[O+(K*20|0)+4>>2]|0,C=f[(f[M>>2]|0)+4+(K<<2)>>2]|0,S=f[xa>>2]|0,B=b[S+11>>0]|0,A=B<<24>>24<0,f[k>>2]=A?f[S>>2]|0:S,f[N>>2]=A?f[S+4>>2]|0:B&255,f[l>>2]=0,f[ca>>2]=-1,f[m>>2]=0,f[ua>>2]=-1,f[o>>2]=0,f[va>>2]=-1,f[p>>2]=0,f[ta>>2]=-1,f[q>>2]=0,f[ra>>2]=-1,f[r>>2]=0,f[d>>2]=-1,f[s>>2]=0,f[sa>>2]=-1,f[t>>2]=0,f[ja>>2]=-1,f[v>>2]=0,f[ia>>2]=-1,Jhc(j,484068,k,l,m,o,p,q,r,s,t,v),lVb(a,T,C,0,j),(b[R>>0]|0)<0):0)YDc(f[j>>2]|0);K=K+1|0}while((K|0)<(f[y>>2]|0))}y=f[h+8>>2]|0;if(y|0){K=y;do{y=K;K=f[K>>2]|0;j=y+8|0;if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);YDc(y)}while((K|0)!=0)}K=f[h>>2]|0;f[h>>2]=0;if(!K){u=g;return}YDc(K);u=g;return}function zVb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;g=d+8|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+40|0;l=f[(f[k>>2]|0)+4>>2]|0;m=VDc(12)|0;fEc(m,l);f[g>>2]=m;l=j+76|0;n=f[l>>2]|0;if((n|0)==(f[j+80>>2]|0))mVb(j+72|0,g);else{f[n>>2]=m;f[l>>2]=(f[l>>2]|0)+4}l=f[g>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0)o=f[l+4>>2]|0;else o=m&255;if(o|0)pEc(l,1,46)|0;o=c+32|0;m=f[o>>2]|0;n=b[m+11>>0]|0;j=n<<24>>24<0;tEc(l,j?f[m>>2]|0:m,j?f[m+4>>2]|0:n&255)|0;tXb(a,f[o>>2]|0,l,c);n=f[i>>2]|0;m=f[o>>2]|0;o=VDc(12)|0;fEc(o,m);f[g>>2]=o;m=n+76|0;j=f[m>>2]|0;if((j|0)==(f[n+80>>2]|0))mVb(n+72|0,g);else{f[j>>2]=o;f[m>>2]=(f[m>>2]|0)+4}f[e>>2]=f[g>>2];m=e+4|0;f[m>>2]=l;f[e+8>>2]=f[k>>2];k=c+20|0;l=f[k>>2]|0;f[e+20>>2]=l;o=e+16|0;j=f[i>>2]|0;i=l*52|0;if(!i){p=0;q=l}else{l=VDc(i)|0;f[g>>2]=l;i=j+124|0;n=f[i>>2]|0;if((n|0)==(f[j+128>>2]|0))f6(j+120|0,g);else{f[n>>2]=l;f[i>>2]=(f[i>>2]|0)+4}p=f[g>>2]|0;q=f[k>>2]|0}f[o>>2]=p;if((q|0)>0?(q=c+28|0,yXb(a,f[(f[q>>2]|0)+4>>2]|0,e,p),(f[k>>2]|0)>1):0){p=1;do{yXb(a,f[(f[q>>2]|0)+4+(p<<2)>>2]|0,e,(f[o>>2]|0)+(p*52|0)|0);p=p+1|0}while((p|0)<(f[k>>2]|0))}if(!(f[c+8>>2]&2)){f[e+12>>2]=0;r=f[m>>2]|0;s=f[e>>2]|0;f[h>>2]=6;t=h+4|0;f[t>>2]=e;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];vXb(a,r,0,s,c,g)|0;u=d;return}else{k=f[c+36>>2]|0;p=f[m>>2]|0;zXb(a,p,p,k|0?k:528432,e);r=f[m>>2]|0;s=f[e>>2]|0;f[h>>2]=6;t=h+4|0;f[t>>2]=e;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];vXb(a,r,0,s,c,g)|0;u=d;return}}function AVb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;h=u;u=u+448|0;i=h+424|0;j=h+400|0;k=h+360|0;l=h+320|0;m=h+280|0;o=h+240|0;q=h+200|0;r=h+160|0;s=h+120|0;t=h+80|0;v=h+40|0;w=h;x=h+416|0;if(!d)y=(f[a+40>>2]|0)+4|0;else y=d+4|0;z=f[y>>2]|0;y=a+4|0;A=f[y>>2]|0;B=VDc(12)|0;fEc(B,z);f[i>>2]=B;z=A+76|0;E=f[z>>2]|0;if((E|0)==(f[A+80>>2]|0))mVb(A+72|0,i);else{f[E>>2]=B;f[z>>2]=(f[z>>2]|0)+4}z=f[i>>2]|0;B=b[z+11>>0]|0;if(B<<24>>24<0)F=f[z+4>>2]|0;else F=B&255;if(F|0)pEc(z,1,46)|0;F=c+16|0;B=f[F>>2]|0;E=b[B+11>>0]|0;A=E<<24>>24<0;tEc(z,A?f[B>>2]|0:B,A?f[B+4>>2]|0:E&255)|0;tXb(a,f[F>>2]|0,z,c);E=f[y>>2]|0;B=f[F>>2]|0;A=VDc(12)|0;fEc(A,B);f[i>>2]=A;B=E+76|0;G=f[B>>2]|0;if((G|0)==(f[E+80>>2]|0))mVb(E+72|0,i);else{f[G>>2]=A;f[B>>2]=(f[B>>2]|0)+4}f[e>>2]=f[i>>2];B=e+4|0;f[B>>2]=z;f[e+20>>2]=f[a+40>>2];z=e+40|0;f[z>>2]=f[c+40>>2];A=e+38|0;b[A>>0]=g&1;fEc(j,f[F>>2]|0);G=j+11|0;E=b[G>>0]|0;H=E<<24>>24<0;I=f[j>>2]|0;K=j+4|0;L=f[K>>2]|0;M=H?I+L|0:j+(E&255)|0;N=H?I:j;if((N|0)==(M|0)){O=L;P=E}else{E=N;do{N=b[E>>0]|0;if((N+-65&255)<26)b[E>>0]=(N&255)+32;E=E+1|0}while((E|0)!=(M|0));O=f[K>>2]|0;P=b[G>>0]|0}K=f[F>>2]|0;M=P<<24>>24<0;E=P&255;P=M?O:E;O=b[K+11>>0]|0;N=O<<24>>24<0;a:do if((P|0)==((N?f[K+4>>2]|0:O&255)|0)){L=f[j>>2]|0;I=M?L:j;H=N?f[K>>2]|0:K;Q=(P|0)==0;b:do if(M){if(!Q?Arc(I,H,P)|0:0){R=29;break a}}else if(!Q){if((L&255)<<24>>24==(b[H>>0]|0)){S=j;T=E;U=H}else{R=29;break a}while(1){T=T+-1|0;S=S+1|0;if(!T)break b;U=U+1|0;if((b[S>>0]|0)!=(b[U>>0]|0)){R=29;break a}}}while(0);V=f[e>>2]|0;W=K}else R=29;while(0);if((R|0)==29){K=f[y>>2]|0;U=VDc(12)|0;fEc(U,j);f[i>>2]=U;S=K+76|0;T=f[S>>2]|0;if((T|0)==(f[K+80>>2]|0))mVb(K+72|0,i);else{f[T>>2]=U;f[S>>2]=(f[S>>2]|0)+4}V=f[i>>2]|0;W=f[F>>2]|0}f[e+8>>2]=V;V=f[y>>2]|0;dWb(k,W,1);W=VDc(12)|0;fEc(W,k);f[i>>2]=W;S=V+76|0;U=f[S>>2]|0;if((U|0)==(f[V+80>>2]|0))mVb(V+72|0,i);else{f[U>>2]=W;f[S>>2]=(f[S>>2]|0)+4}f[e+12>>2]=f[i>>2];if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);S=c+8|0;W=e+37|0;if(!(f[S>>2]&16)){b[W>>0]=0;U=f[y>>2]|0;V=f[F>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;F=V+11|0;T=b[F>>0]|0;K=V+4|0;mEc(k,T<<24>>24<0?f[K>>2]|0:T&255);T=b[F>>0]|0;if((T<<24>>24<0?f[K>>2]|0:T&255)|0){E=0;P=0;M=T;while(1){T=b[(M<<24>>24<0?f[V>>2]|0:V)+P>>0]|0;do if(T<<24>>24!=95)if(E){N=T<<24>>24;vEc(k,((T+-97&255)<26?N+224|0:N)&255);X=0;break}else{vEc(k,T);X=0;break}else X=1;while(0);P=P+1|0;M=b[F>>0]|0;if(P>>>0>=(M<<24>>24<0?f[K>>2]|0:M&255)>>>0)break;else E=X}}X=VDc(12)|0;fEc(X,k);f[i>>2]=X;E=U+76|0;M=f[E>>2]|0;if((M|0)==(f[U+80>>2]|0))mVb(U+72|0,i);else{f[M>>2]=X;f[E>>2]=(f[E>>2]|0)+4}f[e+16>>2]=f[i>>2];if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0)}else{b[W>>0]=1;W=f[y>>2]|0;E=f[c+32>>2]|0;X=VDc(12)|0;fEc(X,E);f[i>>2]=X;E=W+76|0;M=f[E>>2]|0;if((M|0)==(f[W+80>>2]|0))mVb(W+72|0,i);else{f[M>>2]=X;f[E>>2]=(f[E>>2]|0)+4}f[e+16>>2]=f[i>>2]}E=e+28|0;f[E>>2]=f[c+52>>2];X=f[c+48>>2]|0;M=e+32|0;f[M>>2]=X;if((X|0)==2&(b[A>>0]|0)!=0)kVb(a,f[B>>2]|0,c,2,482994);A=e+48|0;f[A>>2]=0;X=e+56|0;f[X>>2]=0;f[e+60>>2]=0;f[e+64>>2]=0;f[e+72>>2]=0;W=e+24|0;f[W>>2]=0;U=e+80|0;f[U>>2]=0;f[e+76>>2]=0;K=f[S>>2]|0;P=e+36|0;b[P>>0]=K>>>3&1;if((K&8|0)!=0?(f[M>>2]|0)==3:0){kVb(a,f[B>>2]|0,c,4,483042);Y=f[S>>2]|0}else Y=K;c:do if(Y&512|0){if(!(Y&8)){K=f[W>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=e;DTb(K,i)}switch(f[161216+(f[E>>2]<<2)>>2]|0){case 1:{f[U>>2]=0;break c;break}case 2:{K=U;f[K>>2]=0;f[K+4>>2]=0;break c;break}case 3:{f[U>>2]=0;break c;break}case 4:{K=U;f[K>>2]=0;f[K+4>>2]=0;break c;break}case 6:{n[U>>2]=0.0;break c;break}case 5:{p[U>>3]=0.0;break c;break}case 7:{b[U>>0]=0;break c;break}case 8:{f[U>>2]=0;break c;break}case 9:{if((f[220804]|0)!=2){f[i>>2]=161028;f[i+4>>2]=125;b[i+8>>0]=0;DTb(883216,i);ZSb(i)}f[U>>2]=527320;break c;break}default:break c}}f[k>>2]=0;K=f[W>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=e;DTb(K,i)}d:do switch(f[161216+(f[E>>2]<<2)>>2]|0){case 1:{K=f[c+28>>2]|0;if((b[K+11>>0]|0)<0)Z=f[K>>2]|0;else Z=K;K=yrc(Z,k,0)|0;f[U>>2]=K;break}case 2:{K=f[c+28>>2]|0;if((b[K+11>>0]|0)<0)_=f[K>>2]|0;else _=K;K=xrc(_,k,0)|0;M=U;f[M>>2]=K;f[M+4>>2]=J;break}case 3:{M=f[c+28>>2]|0;if((b[M+11>>0]|0)<0)$=f[M>>2]|0;else $=M;M=Hqc($,k,0)|0;f[U>>2]=M;break}case 4:{M=f[c+28>>2]|0;if((b[M+11>>0]|0)<0)aa=f[M>>2]|0;else aa=M;M=wrc(aa,k,0)|0;K=U;f[K>>2]=M;f[K+4>>2]=J;break}case 6:{K=c+28|0;M=f[K>>2]|0;F=b[M+11>>0]|0;V=f[M+4>>2]|0;if(((F<<24>>24<0?V:F&255)|0)==3)if(!(EEc(M,0,-1,511981,3)|0))ba=D;else{T=f[K>>2]|0;ca=b[T+11>>0]|0;da=f[T+4>>2]|0;ea=T;R=86}else{ca=F;da=V;ea=M;R=86}do if((R|0)==86){if(((ca<<24>>24<0?da:ca&255)|0)==4){if(!(EEc(ea,0,-1,508047,4)|0)){ba=-D;break}M=f[K>>2]|0;fa=b[M+11>>0]|0;ga=f[M+4>>2]|0;ha=M}else{fa=ca;ga=da;ha=ea}if(((fa<<24>>24<0?ga:fa&255)|0)==3){if(!(EEc(ha,0,-1,513910,3)|0)){ba=C;break}M=f[K>>2]|0;ia=b[M+11>>0]|0;ja=M}else{ia=fa;ja=ha}if(ia<<24>>24<0)ka=f[ja>>2]|0;else ka=ja;ba=+dcc(+bcc(ka,k))}while(0);n[U>>2]=ba;break}case 5:{K=c+28|0;M=f[K>>2]|0;V=b[M+11>>0]|0;F=f[M+4>>2]|0;if(((V<<24>>24<0?F:V&255)|0)==3)if(!(EEc(M,0,-1,511981,3)|0))la=D;else{T=f[K>>2]|0;ma=b[T+11>>0]|0;na=f[T+4>>2]|0;oa=T;R=100}else{ma=V;na=F;oa=M;R=100}do if((R|0)==100){if(((ma<<24>>24<0?na:ma&255)|0)==4){if(!(EEc(oa,0,-1,508047,4)|0)){la=-D;break}M=f[K>>2]|0;pa=b[M+11>>0]|0;qa=f[M+4>>2]|0;ra=M}else{pa=ma;qa=na;ra=oa}if(((pa<<24>>24<0?qa:pa&255)|0)==3){if(!(EEc(ra,0,-1,513910,3)|0)){la=C;break}M=f[K>>2]|0;sa=b[M+11>>0]|0;ta=M}else{sa=pa;ta=ra}if(sa<<24>>24<0)ua=f[ta>>2]|0;else ua=ta;la=+bcc(ua,k)}while(0);p[U>>3]=la;break}case 7:{K=c+28|0;M=f[K>>2]|0;F=b[M+11>>0]|0;V=f[M+4>>2]|0;do if(((F<<24>>24<0?V:F&255)|0)==4)if(!(EEc(M,0,-1,519053,4)|0)){b[U>>0]=1;break d}else{T=f[K>>2]|0;va=b[T+11>>0]|0;wa=f[T+4>>2]|0;xa=T;break}else{va=F;wa=V;xa=M}while(0);do if(((va<<24>>24<0?wa:va&255)|0)==5){if(EEc(xa,0,-1,519047,5)|0)break;b[U>>0]=0;break d}while(0);kVb(a,f[B>>2]|0,c,4,483085);break}case 8:{f[U>>2]=0;break}case 9:{M=f[W>>2]|0;if(M|0?(f[M>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=e;DTb(M,i)}M=f[y>>2]|0;if((f[E>>2]|0)!=12){V=f[c+28>>2]|0;F=VDc(12)|0;fEc(F,V);f[i>>2]=F;V=M+76|0;K=f[V>>2]|0;if((K|0)==(f[M+80>>2]|0))mVb(M+72|0,i);else{f[K>>2]=F;f[V>>2]=(f[V>>2]|0)+4}f[U>>2]=f[i>>2];break d}Ylc(l,f[c+28>>2]|0);V=VDc(12)|0;fEc(V,l);f[i>>2]=V;F=M+76|0;K=f[F>>2]|0;if((K|0)==(f[M+80>>2]|0))mVb(M+72|0,i);else{f[K>>2]=V;f[F>>2]=(f[F>>2]|0)+4}f[U>>2]=f[i>>2];if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);break}case 10:{kVb(a,f[B>>2]|0,c,4,482408);b[P>>0]=0;break}default:{}}while(0);F=f[k>>2]|0;do if(F|0){V=f[c+28>>2]|0;K=b[V+11>>0]|0;if(K<<24>>24<0)ya=f[V+4>>2]|0;else ya=K&255;if(ya|0?(b[F>>0]|0)==0:0)break;K=f[B>>2]|0;VHa(l,483124,V);jIa(i,l,502535);lVb(a,K,c,4,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while(0)}while(0);ya=f[z>>2]|0;do if((ya|0)>=1){if((ya|0)>536870911&(g^1)){z=f[B>>2]|0;P=amc(536870911,k+8|0)|0;f[k>>2]=P;U=Mpc(P)|0;f[k+4>>2]=U;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;Jhc(i,483196,k,l,m,o,q,r,s,t,v,w);lVb(a,z,c,1,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);break}if((ya+-19e3|0)>>>0<1e3?(z=f[B>>2]|0,U=amc(19e3,k+8|0)|0,f[k>>2]=U,P=Mpc(U)|0,f[k+4>>2]=P,P=amc(19999,l+8|0)|0,f[l>>2]=P,U=Mpc(P)|0,f[l+4>>2]=U,f[m>>2]=0,f[m+4>>2]=-1,f[o>>2]=0,f[o+4>>2]=-1,f[q>>2]=0,f[q+4>>2]=-1,f[r>>2]=0,f[r+4>>2]=-1,f[s>>2]=0,f[s+4>>2]=-1,f[t>>2]=0,f[t+4>>2]=-1,f[v>>2]=0,f[v+4>>2]=-1,f[w>>2]=0,f[w+4>>2]=-1,Jhc(i,483237,k,l,m,o,q,r,s,t,v,w),lVb(a,z,c,1,i),(b[i+11>>0]|0)<0):0)YDc(f[i>>2]|0)}else kVb(a,f[B>>2]|0,c,1,483155);while(0);ya=f[S>>2]|0;z=(ya&2|0)!=0;e:do if(g){if(z)za=ya;else{kVb(a,f[B>>2]|0,c,3,483326);za=f[S>>2]|0}f[X>>2]=d;if(!(za&128))Aa=0;else{kVb(a,f[B>>2]|0,c,9,483385);Aa=0}}else{if(z){kVb(a,f[B>>2]|0,c,3,483452);Ba=f[S>>2]|0}else Ba=ya;f[A>>2]=d;if(!(Ba&128))Aa=0;else{U=f[c+44>>2]|0;do if((U|0)>=0){if((U|0)>=(f[d+56>>2]|0))break;Aa=(f[d+24>>2]|0)+(U*28|0)|0;break e}while(0);P=f[B>>2]|0;E=amc(U,k+8|0)|0;f[k>>2]=E;y=Mpc(E)|0;f[k+4>>2]=y;y=f[d>>2]|0;E=b[y+11>>0]|0;W=E<<24>>24<0;f[l>>2]=W?f[y>>2]|0:y;f[l+4>>2]=W?f[y+4>>2]|0:E&255;f[m>>2]=0;f[m+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;Jhc(i,483511,k,l,m,o,q,r,s,t,v,w);lVb(a,P,c,9,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);Aa=0}}while(0);f[e+52>>2]=Aa;if(!(f[S>>2]&32))f[e+68>>2]=0;else{S=f[c+36>>2]|0;Aa=f[B>>2]|0;uXb(a,Aa,Aa,S|0?S:528208,e)}S=f[B>>2]|0;B=f[e>>2]|0;f[x>>2]=2;f[x+4>>2]=e;f[i>>2]=f[x>>2];f[i+4>>2]=f[x+4>>2];vXb(a,S,d,B,c,i)|0;if((b[G>>0]|0)>=0){u=h;return}YDc(f[j>>2]|0);u=h;return}function BVb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(96)|0;N2b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+84>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function CVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=b+84|0;if(!(f[d>>2]|0)){e=Y7b()|0;f[d>>2]=e}e=b+28|0;if((f[e>>2]|0)>0){d=b+68|0;g=c+44|0;h=0;do{hXb(a,(f[d>>2]|0)+(h*88|0)|0,f[(f[g>>2]|0)+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)<(f[e>>2]|0))}e=b+40|0;if((f[e>>2]|0)>0){h=b+80|0;g=c+92|0;d=0;do{iXb(a,(f[h>>2]|0)+(d*88|0)|0,f[(f[g>>2]|0)+4+(d<<2)>>2]|0);d=d+1|0}while((d|0)<(f[e>>2]|0))}e=b+32|0;if((f[e>>2]|0)>0){d=b+72|0;g=0;do{h=f[d>>2]|0;i=h+(g*48|0)+16|0;if(!(f[i>>2]|0)){j=e8b()|0;f[i>>2]=j}j=h+(g*48|0)+24|0;i=f[j>>2]|0;if((i|0)>0){k=h+(g*48|0)+28|0;h=0;l=i;while(1){i=(f[k>>2]|0)+(h*20|0)+16|0;if(!(f[i>>2]|0)){m=g8b()|0;f[i>>2]=m;n=f[j>>2]|0}else n=l;h=h+1|0;if((h|0)>=(n|0))break;else l=n}}g=g+1|0}while((g|0)<(f[e>>2]|0))}e=b+36|0;if((f[e>>2]|0)<=0)return;g=b+76|0;b=c+76|0;c=0;do{n=f[g>>2]|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;l=n+(c*24|0)+12|0;if(!(f[l>>2]|0)){h=i8b()|0;f[l>>2]=h}h=n+(c*24|0)+20|0;if((f[h>>2]|0)>0){l=n+(c*24|0)+16|0;n=d+28|0;d=0;do{jXb(a,(f[l>>2]|0)+(d*52|0)|0,f[(f[n>>2]|0)+4+(d<<2)>>2]|0);d=d+1|0}while((d|0)<(f[h>>2]|0))}c=c+1|0}while((c|0)<(f[e>>2]|0));return}function DVb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;f[a>>2]=b;k9b(a+12|0);if(f[a>>2]|0){u=c;return}rTb(d,3,475801,6223);oTb(c+24|0,mTb(d,481710)|0);sTb(d);u=c;return}function EVb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=(b[e+11>>0]|0)<0?f[e>>2]|0:e;e=d*65535|0;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){h=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=h;break}else k=h}}k=i+e|0;e=f[c+4>>2]|0;a:do if(e|0){i=e+-1|0;l=(i&e|0)==0;if(!l)if(k>>>0<e>>>0)m=k;else m=(k>>>0)%(e>>>0)|0;else m=i&k;j=f[(f[c>>2]|0)+(m<<2)>>2]|0;if(j|0?(h=f[j>>2]|0,h|0):0){b:do if(l){j=h;while(1){n=f[j+4>>2]|0;o=(k|0)==(n|0);if(!(o|(n&i|0)==(m|0)))break a;if((o?(f[j+8>>2]|0)==(d|0):0)?(Ioc(f[j+12>>2]|0,g)|0)==0:0){p=j;break b}j=f[j>>2]|0;if(!j)break a}}else{j=h;while(1){o=f[j+4>>2]|0;if((k|0)==(o|0)){if((f[j+8>>2]|0)==(d|0)?(Ioc(f[j+12>>2]|0,g)|0)==0:0){p=j;break b}}else{if(o>>>0<e>>>0)q=o;else q=(o>>>0)%(e>>>0)|0;if((q|0)!=(m|0))break a}j=f[j>>2]|0;if(!j)break a}}while(0);h=p+16|0;i=f[h+4>>2]|0;l=a;f[l>>2]=f[h>>2];f[l+4>>2]=i;return}}while(0);p=a;f[p>>2]=0;f[p+4>>2]=0;return}function FVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;d=u;u=u+240|0;e=d+32|0;g=d+8|0;h=d;i=d+200|0;j=d+226|0;k=d+192|0;l=d+176|0;m=d+136|0;n=d+96|0;o=d+84|0;p=d+72|0;q=d+60|0;r=d+48|0;s=d+196|0;t=d+188|0;v=d+152|0;w=d+225|0;x=d+112|0;y=d+224|0;z=a+8|0;A=f[z>>2]|0;if(!(f[A+20>>2]|0)){B=VDc(32)|0;f[e>>2]=B;f[e+8>>2]=-2147483616;f[e+4>>2]=24;C=B;D=478976;E=C+24|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+24>>0]=0;lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,A,7,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);F=0;u=d;return F|0}B=f[(f[(f[A+28>>2]|0)+4>>2]|0)+16>>2]|0;A=b[B+11>>0]|0;if(((A<<24>>24<0?f[B+4>>2]|0:A&255)|0)==20?(EEc(B,0,-1,476092,20)|0)==0:0){B=VDc(64)|0;f[e>>2]=B;f[e+8>>2]=-2147483584;f[e+4>>2]=57;C=B;D=479001;E=C+57|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+57>>0]=0;lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);F=0;u=d;return F|0}B=f[a>>2]|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);fWb(h,B,f[B>>2]|0,f[(f[e>>2]|0)+4>>2]|0,1);if((f[h>>2]|0)==1)G=f[h+4>>2]|0;else{mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);G=f[e>>2]|0}if(!G){rTb(i,3,475801,6330);oTb(j,mTb(i,479059)|0);sTb(i)}f[k>>2]=0;f[l>>2]=0;i=l+4|0;f[i>>2]=0;f[l+8>>2]=0;j=m+11|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;B=f[z>>2]|0;do if((f[B+20>>2]|0)>0){D=m+4|0;C=l+8|0;E=e+4|0;A=e+8|0;H=e+12|0;I=e+4|0;J=e+8|0;K=e+12|0;L=e+11|0;M=e+4|0;N=g+11|0;O=a+4|0;P=0;Q=G;R=B;S=0;T=0;U=G;while(1){V=f[(f[R+28>>2]|0)+4+(P<<2)>>2]|0;W=f[V+16>>2]|0;if(!((S<<24>>24<0?T:S&255)|0))X=V;else{uEc(m,518136)|0;X=f[(f[(f[z>>2]|0)+28>>2]|0)+4+(P<<2)>>2]|0}do if(b[X+20>>0]|0){VHa(g,517847,W);jIa(e,g,517845);V=b[L>>0]|0;Y=V<<24>>24<0;tEc(m,Y?f[e>>2]|0:e,Y?f[M>>2]|0:V&255)|0;if((b[L>>0]|0)<0)YDc(f[e>>2]|0);if((b[N>>0]|0)<0)YDc(f[g>>2]|0);V=f[a>>2]|0;gWb(g,V,W,f[O>>2]|0,0,1);if((f[g>>2]|0)==0?(Y=f[V>>2]|0,b[Y+22>>0]|0):0){hWb(e,Y,W,0);Y=e;V=f[Y+4>>2]|0;Z=g;f[Z>>2]=f[Y>>2];f[Z+4>>2]=V}V=g;Z=f[V>>2]|0;Y=f[V+4>>2]|0;V=h;f[V>>2]=Z;f[V+4>>2]=Y;if((Z|0)==2){f[k>>2]=Y;_=Y;break}else{_=f[k>>2]|0;break}}else{Y=b[W+11>>0]|0;Z=Y<<24>>24<0;tEc(m,Z?f[W>>2]|0:W,Z?f[W+4>>2]|0:Y&255)|0;EVb(e,f[(f[Q+8>>2]|0)+88>>2]|0,U,W);Y=(f[e>>2]|0)==2;Z=e;V=Y?f[Z+4>>2]|0:0;if(!((Y?f[Z>>2]|0:0)|0))$=0;else $=b[V+38>>0]|0?0:V;f[k>>2]=$;_=$}while(0);if(!_){aa=34;break}ba=f[_+48>>2]|0;if((ba|0)!=(Q|0)){aa=61;break}W=f[z>>2]|0;V=f[W+20>>2]|0;if((P|0)<(V+-1|0)){Z=f[_+24>>2]|0;if(Z|0?(f[Z>>2]|0)!=2:0){f[e>>2]=78728;f[I>>2]=1737;b[J>>0]=0;f[K>>2]=_;DTb(Z,e)}if((f[_+28>>2]|1|0)!=11){aa=77;break}Z=f[k>>2]|0;if((f[Z+32>>2]|0)==3){aa=83;break}Y=f[i>>2]|0;if((Y|0)==(f[C>>2]|0))jWb(l,k);else{f[Y>>2]=Z;f[i>>2]=(f[i>>2]|0)+4}Z=f[k>>2]|0;Y=f[Z+24>>2]|0;if(Y|0?(f[Y>>2]|0)!=2:0){f[e>>2]=78728;f[E>>2]=1737;b[A>>0]=0;f[H>>2]=Z;DTb(Y,e)}Y=f[Z+60>>2]|0;Z=f[z>>2]|0;ca=Y;da=f[Z+20>>2]|0;ea=Z;fa=Y}else{ca=Q;da=V;ea=W;fa=U}W=P+1|0;if((W|0)>=(da|0)){aa=97;break}P=W;Q=ca;R=ea;S=b[j>>0]|0;T=f[D>>2]|0;U=fa}if((aa|0)==34){U=f[a>>2]|0;if(b[(f[U>>2]|0)+22>>0]|0){iWb(0,f[z>>2]|0,c);ga=1;break}D=b[U+88+11>>0]|0;if(D<<24>>24<0)ha=f[U+92>>2]|0;else ha=D&255;if(!ha){VHa(g,479094,m);jIa(e,g,479284);lVb(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);ga=0;break}VHa(q,479094,m);jIa(p,q,479103);QJa(o,p,(f[a>>2]|0)+88|0);jIa(n,o,479123);gEc(r,m,1,-1,m);QJa(g,n,r);jIa(e,g,479246);lVb(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[r+11>>0]|0)<0)YDc(f[r>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);if((b[q+11>>0]|0)<0)YDc(f[q>>2]|0);ga=0;break}else if((aa|0)==61){if(b[ba+84>>0]|0){iWb(0,f[z>>2]|0,c);ga=1;break}VHa(o,479295,m);jIa(n,o,479310);QJa(g,n,f[Q>>2]|0);jIa(e,g,502535);lVb(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);ga=0;break}else if((aa|0)==77){VHa(g,479094,m);jIa(e,g,479353);lVb(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);ga=0;break}else if((aa|0)==83){VHa(g,479295,m);jIa(e,g,479389);lVb(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);ga=0;break}else if((aa|0)==97){ia=f[k>>2]|0;aa=98;break}}else{ia=0;aa=98}while(0);do if((aa|0)==98){if((f[ia+32>>2]|0)!=3?(f[s>>2]=f[l>>2],f[t>>2]=f[i>>2],z=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0,o=Mi[f[(f[z>>2]|0)+8>>2]&1023](z,c)|0,f[g>>2]=f[s>>2],f[e>>2]=f[t>>2],!(kWb(a,g,e,ia,m,o)|0)):0){ga=0;break}o=VDc(4)|0;f[o>>2]=0;if(lWb(a,f[k>>2]|0,o)|0){z=f[i>>2]|0;a:do if((z|0)==(f[l>>2]|0)){ja=o;ka=o;aa=123}else{n=g+16|0;ba=e+4|0;q=e+8|0;p=e+12|0;r=o;ha=z;fa=o;ea=o;ca=o;da=o;_=o;$=o;b:while(1){la=VDc(4)|0;f[la>>2]=0;ha=ha+-4|0;h=f[ha>>2]|0;X=f[h+24>>2]|0;if(X|0?(f[X>>2]|0)!=2:0){f[e>>2]=78728;f[ba>>2]=1737;b[q>>0]=0;f[p>>2]=h;DTb(X,e)}switch(f[h+28>>2]|0){case 11:{ESb(e,ujc(la,f[(f[ha>>2]|0)+40>>2]|0)|0);XRb(g,e);Gjc(r,g);if(b[n>>0]|0){rTb(v,3,475801,6459);oTb(w,mTb(nTb(mTb(mTb(v,479485)|0,479517)|0,m)|0,502535)|0);sTb(v)}YRb(g);break}case 10:{ojc(vjc(la,f[(f[ha>>2]|0)+40>>2]|0)|0,r);break}default:break b}if((r|0)!=(la|0))if(!r){ma=la;na=la;oa=la;pa=la;qa=la;ra=la;sa=la}else{if(f[r>>2]|0)ljc(r);YDc(fa);ma=la;na=la;oa=la;pa=la;qa=la;ra=la;sa=la}else{ma=r;na=$;oa=_;pa=da;qa=ca;ra=ea;sa=fa}if((ha|0)==(f[l>>2]|0)){ja=qa;ka=ma;aa=123;break a}else{r=ma;fa=sa;ea=ra;ca=qa;da=pa;_=oa;$=na}}rTb(x,3,475801,6472);$=mTb(x,479573)|0;_=f[ha>>2]|0;da=f[_+24>>2]|0;if(da|0?(f[da>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=_;DTb(da,e)}oTb(y,pTb($,f[_+28>>2]|0)|0);sTb(x);if(f[la>>2]|0)ljc(la);YDc(la);ta=0;ua=r;va=ca}while(0);if((aa|0)==123){z=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;ojc(Mi[f[(f[z>>2]|0)+12>>2]&1023](z,c)|0,ka);ta=1;ua=ka;va=ja}if(!ua){ga=ta;break}else{wa=ta;xa=ua;ya=va}}else{wa=0;xa=o;ya=o}if(f[xa>>2]|0)ljc(xa);YDc(ya);ga=wa}while(0);if((b[j>>0]|0)<0)YDc(f[m>>2]|0);m=f[l>>2]|0;if(m|0){l=f[i>>2]|0;if((l|0)!=(m|0))f[i>>2]=l+(~((l+-4-m|0)>>>2)<<2);YDc(m)}F=ga;u=d;return F|0}function GVb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g;i=f[a+8>>2]|0;if(!i){rTb(h,1,475801,3646);oTb(g+24|0,nTb(mTb(nTb(mTb(nTb(h,a+28|0)|0,517879)|0,b)|0,509015)|0,e)|0);sTb(h);u=g;return}else{Fh[f[(f[i>>2]|0)+12>>2]&255](i,a+28|0,b,c,d,e);u=g;return}}function HVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;j=c+28|0;if((f[j>>2]|0)>0){k=c+68|0;l=d+44|0;m=0;do{OVb(a,(f[k>>2]|0)+(m*88|0)|0,f[(f[l>>2]|0)+4+(m<<2)>>2]|0);m=m+1|0}while((m|0)<(f[j>>2]|0))}j=c+32|0;if((f[j>>2]|0)>0){m=c+72|0;l=d+60|0;k=0;do{PVb(a,(f[m>>2]|0)+(k*48|0)|0,f[(f[l>>2]|0)+4+(k<<2)>>2]|0);k=k+1|0}while((k|0)<(f[j>>2]|0))}j=c+36|0;if((f[j>>2]|0)>0){k=c+76|0;l=d+76|0;m=0;do{n=f[k>>2]|0;o=f[(f[l>>2]|0)+4+(m<<2)>>2]|0;p=n+(m*24|0)+8|0;q=f[p>>2]|0;do if((q|0?(r=q+84|0,s=f[r>>2]|0,(s|0)!=(Y7b()|0)):0)?(f[(f[r>>2]|0)+92>>2]|0)==3:0){r=f[(f[p>>2]|0)+84>>2]|0;if((b[r+84>>0]|0)==0?(b[r+85>>0]|0)==0:0)break;kVb(a,f[n+(m*24|0)+4>>2]|0,o,0,477055)}while(0);m=m+1|0}while((m|0)<(f[j>>2]|0))}j=c+40|0;if((f[j>>2]|0)>0){m=c+80|0;l=d+92|0;k=0;do{QVb(a,(f[m>>2]|0)+(k*88|0)|0,f[(f[l>>2]|0)+4+(k<<2)>>2]|0);k=k+1|0}while((k|0)<(f[j>>2]|0))}j=c+84|0;k=f[j>>2]|0;if(!((k|0)!=(Y7b()|0)?(f[(f[j>>2]|0)+92>>2]|0)==3:0))t=19;a:do if((t|0)==19?(j=c+16|0,(f[j>>2]|0)>0):0){k=c+12|0;l=c+52|0;m=g+4|0;o=g+8|0;n=g+12|0;p=0;while(1){q=f[k>>2]|0;if(q|0?(f[q>>2]|0)!=2:0){f[g>>2]=161436;f[m>>2]=1774;b[o>>0]=0;f[n>>2]=c;DTb(q,g)}q=f[(f[l>>2]|0)+(p<<2)>>2]|0;if((q|0?(r=q+84|0,q=f[r>>2]|0,(q|0)!=(Y7b()|0)):0)?(f[(f[r>>2]|0)+92>>2]|0)==3:0)break;r=p+1|0;if((r|0)<(f[j>>2]|0))p=r;else break a}j=f[c>>2]|0;n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=161436;f[g+4>>2]=1774;b[g+8>>0]=0;f[g+12>>2]=c;DTb(n,g)}VHa(i,477200,f[f[(f[l>>2]|0)+(p<<2)>>2]>>2]|0);jIa(h,i,477337);lVb(a,j,d,9,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0)}while(0);if((f[c+44>>2]|0)!=3){u=e;return}RVb(a,c,d);u=e;return}function IVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=u;u=u+80|0;g=e+60|0;h=e+48|0;i=e+32|0;j=e+16|0;k=e;l=h+4|0;f[l>>2]=0;m=h+8|0;f[m>>2]=0;n=h+4|0;f[h>>2]=n;o=c+60|0;if((f[o>>2]|0)>0){p=c+28|0;q=j+12|0;r=i+12|0;s=i+11|0;t=j+11|0;v=k+11|0;w=c+4|0;x=g+11|0;y=i+11|0;z=d+44|0;A=0;do{B=f[p>>2]|0;C=B+(A*88|0)|0;fEc(k,f[C>>2]|0);fEc(j,k);f[q>>2]=C;fEc(i,j);f[r>>2]=f[q>>2];D=LVb(h,g,i)|0;E=f[D>>2]|0;if(!E){F=VDc(32)|0;fEc(F+16|0,i);f[F+28>>2]=f[r>>2];G=f[g>>2]|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=G;f[D>>2]=F;G=f[f[h>>2]>>2]|0;if(!G)H=F;else{f[h>>2]=G;H=f[D>>2]|0}laa(f[l>>2]|0,H);f[m>>2]=(f[m>>2]|0)+1;I=F;J=1}else{I=E;J=0}if((b[s>>0]|0)<0)YDc(f[i>>2]|0);if((b[t>>0]|0)<0)YDc(f[j>>2]|0);if((b[v>>0]|0)<0)YDc(f[k>>2]|0);do if(!(J<<24>>24)){if((b[(f[(f[I+28>>2]|0)+16>>2]|0)+51>>0]|0)==0?(b[(f[B+(A*88|0)+16>>2]|0)+51>>0]|0)==0:0)break;E=f[w>>2]|0;VHa(i,476867,f[C>>2]|0);jIa(g,i,476892);lVb(a,E,d,0,g);if((b[x>>0]|0)<0)YDc(f[g>>2]|0);if((b[y>>0]|0)<0)YDc(f[i>>2]|0)}while(0);IVb(a,(f[p>>2]|0)+(A*88|0)|0,f[(f[z>>2]|0)+4+(A<<2)>>2]|0);A=A+1|0}while((A|0)<(f[o>>2]|0))}o=c+52|0;if((f[o>>2]|0)>0){A=c+20|0;z=c+4|0;p=g+11|0;y=i+11|0;x=0;do{w=MVb(h,f[(f[A>>2]|0)+(x*88|0)>>2]|0)|0;if((w|0)!=(n|0)?(I=f[w+28>>2]|0,b[(f[I+16>>2]|0)+51>>0]|0):0){w=f[z>>2]|0;VHa(i,476867,f[I>>2]|0);jIa(g,i,476941);lVb(a,w,d,0,g);if((b[p>>0]|0)<0)YDc(f[g>>2]|0);if((b[y>>0]|0)<0)YDc(f[i>>2]|0)}x=x+1|0}while((x|0)<(f[o>>2]|0))}o=c+64|0;if((f[o>>2]|0)>0){x=c+32|0;y=c+4|0;p=g+11|0;z=i+11|0;A=0;do{w=MVb(h,f[(f[x>>2]|0)+(A*48|0)>>2]|0)|0;if((w|0)!=(n|0)?(I=f[w+28>>2]|0,b[(f[I+16>>2]|0)+51>>0]|0):0){w=f[y>>2]|0;VHa(i,476867,f[I>>2]|0);jIa(g,i,476976);lVb(a,w,d,0,g);if((b[p>>0]|0)<0)YDc(f[g>>2]|0);if((b[z>>0]|0)<0)YDc(f[i>>2]|0)}A=A+1|0}while((A|0)<(f[o>>2]|0))}o=c+56|0;if((f[o>>2]|0)<=0){K=h;L=f[n>>2]|0;NVb(K,L);u=e;return}A=c+24|0;z=c+4|0;c=g+11|0;p=i+11|0;y=0;do{x=MVb(h,f[(f[A>>2]|0)+(y*28|0)>>2]|0)|0;if((x|0)!=(n|0)?(w=f[x+28>>2]|0,b[(f[w+16>>2]|0)+51>>0]|0):0){x=f[z>>2]|0;VHa(i,476867,f[w>>2]|0);jIa(g,i,477015);lVb(a,x,d,0,g);if((b[c>>0]|0)<0)YDc(f[g>>2]|0);if((b[p>>0]|0)<0)YDc(f[i>>2]|0)}y=y+1|0}while((y|0)<(f[o>>2]|0));K=h;L=f[n>>2]|0;NVb(K,L);u=e;return}function JVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;if(!(f[a+68>>2]|0)){u=d;return}i=g+4|0;f[i>>2]=0;j=g+8|0;f[j>>2]=0;k=g+4|0;f[g>>2]=k;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=VDc(32)|0;f[h>>2]=l;f[h+8>>2]=-2147483616;f[h+4>>2]=30;m=l;n=476604;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+30>>0]=0;l=kaa(g,e,h)|0;if(!(f[l>>2]|0)){p=VDc(28)|0;fEc(p+16|0,h);q=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=q;f[l>>2]=p;q=f[f[g>>2]>>2]|0;if(!q)r=p;else{f[g>>2]=q;r=f[l>>2]|0}laa(f[i>>2]|0,r);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=VDc(32)|0;f[h>>2]=r;f[h+8>>2]=-2147483616;f[h+4>>2]=27;m=r;n=476635;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[r+27>>0]=0;r=kaa(g,e,h)|0;if(!(f[r>>2]|0)){l=VDc(28)|0;fEc(l+16|0,h);q=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=q;f[r>>2]=l;q=f[f[g>>2]>>2]|0;if(!q)s=l;else{f[g>>2]=q;s=f[r>>2]|0}laa(f[i>>2]|0,s);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=VDc(32)|0;f[h>>2]=s;f[h+8>>2]=-2147483616;f[h+4>>2]=28;m=s;n=476663;o=m+28|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[s+28>>0]=0;s=kaa(g,e,h)|0;if(!(f[s>>2]|0)){r=VDc(28)|0;fEc(r+16|0,h);q=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=q;f[s>>2]=r;q=f[f[g>>2]>>2]|0;if(!q)t=r;else{f[g>>2]=q;t=f[s>>2]|0}laa(f[i>>2]|0,t);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=VDc(32)|0;f[h>>2]=t;f[h+8>>2]=-2147483616;f[h+4>>2]=27;m=t;n=476692;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[t+27>>0]=0;t=kaa(g,e,h)|0;if(!(f[t>>2]|0)){s=VDc(28)|0;fEc(s+16|0,h);q=f[e>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=q;f[t>>2]=s;q=f[f[g>>2]>>2]|0;if(!q)v=s;else{f[g>>2]=q;v=f[t>>2]|0}laa(f[i>>2]|0,v);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=VDc(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=32;m=v;n=476720;o=m+32|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[v+32>>0]=0;v=kaa(g,e,h)|0;if(!(f[v>>2]|0)){t=VDc(28)|0;fEc(t+16|0,h);q=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[v>>2]=t;q=f[f[g>>2]>>2]|0;if(!q)w=t;else{f[g>>2]=q;w=f[v>>2]|0}laa(f[i>>2]|0,w);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=VDc(48)|0;f[h>>2]=w;f[h+8>>2]=-2147483600;f[h+4>>2]=32;m=w;n=476720;o=m+32|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[w+32>>0]=0;w=kaa(g,e,h)|0;if(!(f[w>>2]|0)){v=VDc(28)|0;fEc(v+16|0,h);q=f[e>>2]|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=q;f[w>>2]=v;q=f[f[g>>2]>>2]|0;if(!q)x=v;else{f[g>>2]=q;x=f[w>>2]|0}laa(f[i>>2]|0,x);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=VDc(32)|0;f[h>>2]=x;f[h+8>>2]=-2147483616;f[h+4>>2]=30;m=x;n=476753;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[x+30>>0]=0;x=kaa(g,e,h)|0;if(!(f[x>>2]|0)){w=VDc(28)|0;fEc(w+16|0,h);q=f[e>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=q;f[x>>2]=w;q=f[f[g>>2]>>2]|0;if(!q)y=w;else{f[g>>2]=q;y=f[x>>2]|0}laa(f[i>>2]|0,y);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=VDc(32)|0;f[h>>2]=y;f[h+8>>2]=-2147483616;f[h+4>>2]=29;m=y;n=476784;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[y+29>>0]=0;y=kaa(g,e,h)|0;if(!(f[y>>2]|0)){x=VDc(28)|0;fEc(x+16|0,h);q=f[e>>2]|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=q;f[y>>2]=x;q=f[f[g>>2]>>2]|0;if(!q)z=x;else{f[g>>2]=q;z=f[y>>2]|0}laa(f[i>>2]|0,z);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=VDc(32)|0;f[h>>2]=z;f[h+8>>2]=-2147483616;f[h+4>>2]=29;m=z;n=476814;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[z+29>>0]=0;z=kaa(g,e,h)|0;if(!(f[z>>2]|0)){n=VDc(28)|0;fEc(n+16|0,h);m=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=m;f[z>>2]=n;m=f[f[g>>2]>>2]|0;if(!m)A=n;else{f[g>>2]=m;A=f[z>>2]|0}laa(f[i>>2]|0,A);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);j=f[a+60>>2]|0;A=a+64|0;if((j|0)!=(A|0)){i=h+11|0;z=e+11|0;m=j;while(1){j=m+16|0;n=f[j>>2]|0;o=f[n+40>>2]|0;a:do if((o|0)>0){y=0;q=n;while(1){if((KVb(g,f[(f[(f[q+80>>2]|0)+(y*88|0)+48>>2]|0)+4>>2]|0)|0)!=(k|0))break;x=y+1|0;w=f[j>>2]|0;v=f[w+40>>2]|0;if((x|0)<(v|0)){y=x;q=w}else{B=x;C=v;D=w;break a}}q=f[j>>2]|0;B=y;C=f[q+40>>2]|0;D=q}else{B=0;C=o;D=n}while(0);if((B|0)==(C|0)){VHa(h,476844,f[D>>2]|0);jIa(e,h,476852);if((b[i>>0]|0)<0)YDc(f[h>>2]|0);GVb(a,f[f[j>>2]>>2]|0,c,9,e);if((b[z>>0]|0)<0)YDc(f[e>>2]|0)}n=f[m+4>>2]|0;do if(!n){o=m+8|0;q=f[o>>2]|0;if((f[q>>2]|0)==(m|0)){E=q;break}else F=o;do{o=f[F>>2]|0;F=o+8|0;q=f[F>>2]|0}while((f[q>>2]|0)!=(o|0));E=q}else{y=n;while(1){q=f[y>>2]|0;if(!q)break;else y=q}E=y}while(0);if((E|0)==(A|0))break;else m=E}}jaa(g,f[k>>2]|0);u=d;return}function KVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function LVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function MVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function NVb(a,c){a=a|0;c=c|0;if(!c)return;NVb(a,f[c>>2]|0);NVb(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function OVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+416|0;g=e+400|0;h=e+360|0;i=e+320|0;j=e+280|0;k=e+240|0;l=e+200|0;m=e+160|0;n=e+120|0;o=e+80|0;p=e+40|0;q=e;r=c+52|0;if((f[r>>2]|0)>0){s=c+20|0;t=d+28|0;v=0;do{QVb(a,(f[s>>2]|0)+(v*88|0)|0,f[(f[t>>2]|0)+4+(v<<2)>>2]|0);v=v+1|0}while((v|0)<(f[r>>2]|0))}r=c+60|0;if((f[r>>2]|0)>0){v=c+28|0;t=d+44|0;s=0;do{OVb(a,(f[v>>2]|0)+(s*88|0)|0,f[(f[t>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[r>>2]|0))}r=c+64|0;if((f[r>>2]|0)>0){s=c+32|0;t=d+60|0;v=0;do{PVb(a,(f[s>>2]|0)+(v*48|0)|0,f[(f[t>>2]|0)+4+(v<<2)>>2]|0);v=v+1|0}while((v|0)<(f[r>>2]|0))}r=c+72|0;if((f[r>>2]|0)>0){v=c+40|0;t=d+92|0;s=0;do{QVb(a,(f[v>>2]|0)+(s*88|0)|0,f[(f[t>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[r>>2]|0))}r=(b[(f[c+16>>2]|0)+48>>0]|0)!=0;s=r?2147483647:536870911;t=r?0:0;r=c+68|0;v=f[r>>2]|0;if((v|0)<=0){u=e;return}w=c+36|0;x=UIc(s|0,t|0,1,0)|0;y=J;z=c+4|0;c=d+76|0;d=h+8|0;A=h+4|0;B=i+4|0;C=j+4|0;D=k+4|0;E=l+4|0;F=m+4|0;G=n+4|0;H=o+4|0;I=p+4|0;K=q+4|0;L=g+11|0;M=0;N=v;while(1){v=f[(f[w>>2]|0)+(M*12|0)+4>>2]|0;O=((v|0)<0)<<31>>31;if((O|0)>(y|0)|(O|0)==(y|0)&v>>>0>x>>>0){v=f[z>>2]|0;O=f[(f[c>>2]|0)+4+(M<<2)>>2]|0;P=$lc(s,t,d)|0;f[h>>2]=P;Q=Mpc(P)|0;f[A>>2]=Q;f[i>>2]=0;f[B>>2]=-1;f[j>>2]=0;f[C>>2]=-1;f[k>>2]=0;f[D>>2]=-1;f[l>>2]=0;f[E>>2]=-1;f[m>>2]=0;f[F>>2]=-1;f[n>>2]=0;f[G>>2]=-1;f[o>>2]=0;f[H>>2]=-1;f[p>>2]=0;f[I>>2]=-1;f[q>>2]=0;f[K>>2]=-1;Jhc(g,478931,h,i,j,k,l,m,n,o,p,q);lVb(a,v,O,1,g);if((b[L>>0]|0)<0)YDc(f[g>>2]|0);R=f[r>>2]|0}else R=N;M=M+1|0;if((M|0)>=(R|0))break;else N=R}u=e;return}function PVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+96|0;g=e+72|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e;m=e+84|0;n=c+24|0;o=c+16|0;p=f[o>>2]|0;if(f[p+24>>2]&1|0?b[p+48>>0]|0:0){u=e;return}p=g+4|0;f[p>>2]=0;q=g+8|0;f[q>>2]=0;r=g+4|0;f[g>>2]=r;a:do if((f[n>>2]|0)>0){s=c+28|0;t=i+11|0;v=j+11|0;w=k+11|0;x=c+4|0;y=h+11|0;z=0;A=0;B=0;while(1){C=f[s>>2]|0;D=C+(z*20|0)+8|0;E=f[D>>2]|0;do if(A){F=r;G=A;b:while(1){H=G;while(1){if((f[H+16>>2]|0)>=(E|0))break;I=f[H+4>>2]|0;if(!I){J=F;break b}else H=I}G=f[H>>2]|0;if(!G){J=H;break}else F=H}if((J|0)!=(r|0)?(E|0)>=(f[J+16>>2]|0):0){VHa(k,501908,f[C+(z*20|0)+4>>2]|0);jIa(j,k,478818);F=f[D>>2]|0;G=f[r>>2]|0;do if(G){I=p;K=G;L=G;while(1){M=f[K+16>>2]|0;if((F|0)<(M|0)){N=f[K>>2]|0;if(!N){O=18;break}else{P=K;Q=N}}else{if((M|0)>=(F|0)){O=22;break}R=K+4|0;M=f[R>>2]|0;if(!M){O=21;break}else{P=R;Q=M}}I=P;K=Q;L=Q}if((O|0)==18){O=0;S=K;T=K;O=24;break}else if((O|0)==21){O=0;S=R;T=K;O=24;break}else if((O|0)==22){O=0;U=I;V=K;W=L;O=23;break}}else{U=r;V=r;W=G;O=23}while(0);if((O|0)==23){O=0;if(!W){S=U;T=V;O=24}else X=W}if((O|0)==24){O=0;G=VDc(32)|0;f[G+16>>2]=F;H=G+20|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=T;f[S>>2]=G;H=f[f[g>>2]>>2]|0;if(!H)Y=G;else{f[g>>2]=H;Y=f[S>>2]|0}laa(f[p>>2]|0,Y);f[q>>2]=(f[q>>2]|0)+1;X=G}QJa(i,j,X+20|0);jIa(h,i,478850);if((b[t>>0]|0)<0)YDc(f[i>>2]|0);if((b[v>>0]|0)<0)YDc(f[j>>2]|0);if((b[w>>0]|0)<0)YDc(f[k>>2]|0);if(!(b[(f[o>>2]|0)+48>>0]|0))lVb(a,f[x>>2]|0,d,1,h);else{rTb(l,2,475801,6017);oTb(m,nTb(l,h)|0);sTb(l)}if((b[y>>0]|0)<0)YDc(f[h>>2]|0);break}G=f[C+(z*20|0)+4>>2]|0;H=p;M=A;N=B;while(1){Z=f[M+16>>2]|0;if((E|0)<(Z|0)){_=f[M>>2]|0;if(!_){O=43;break}else{$=M;aa=_}}else{if((Z|0)>=(E|0)){O=47;break}ba=M+4|0;Z=f[ba>>2]|0;if(!Z){O=46;break}else{$=ba;aa=Z}}H=$;M=aa;N=aa}if((O|0)==43){O=0;ca=M;da=M;ea=G;O=48;break}else if((O|0)==46){O=0;ca=ba;da=M;ea=G;O=48;break}else if((O|0)==47){O=0;if(!N){ca=H;da=M;ea=G;O=48;break}else{fa=N;ga=G;O=51;break}}}else{ca=r;da=r;ea=f[C+(z*20|0)+4>>2]|0;O=48}while(0);if((O|0)==48){O=0;C=VDc(32)|0;f[C+16>>2]=E;D=C+20|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=da;f[ca>>2]=C;D=f[f[g>>2]>>2]|0;if(!D)ha=C;else{f[g>>2]=D;ha=f[ca>>2]|0}laa(f[p>>2]|0,ha);f[q>>2]=(f[q>>2]|0)+1;fa=C;ga=ea;O=51}if((O|0)==51){O=0;iEc(fa+20|0,ga)|0}C=z+1|0;D=f[r>>2]|0;if((C|0)>=(f[n>>2]|0)){ia=D;break a}z=C;A=D;B=D}}else ia=0;while(0);eWb(g,ia);u=e;return}function QVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;if(b[(f[a>>2]|0)+21>>0]|0){if(!c){u=e;return}h=f[c+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(h,g)}if(!(f[c+60>>2]|0)){u=e;return}}h=c+68|0;if(b[(f[h>>2]|0)+53>>0]|0){i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(i,g)}if((f[c+28>>2]|0)!=11)kVb(a,f[c+4>>2]|0,d,2,478087)}do if(b[(f[h>>2]|0)+52>>0]|0){if((f[c+32>>2]|0)==3){i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(i,g)}if(((f[c+28>>2]|0)+-9|0)>>>0>3)break}kVb(a,f[c+4>>2]|0,d,2,478146)}while(0);h=c+48|0;i=f[h>>2]|0;do if((i|0?(j=f[i+16>>2]|0,(j|0)!=(_7b()|0)):0)?b[(f[(f[h>>2]|0)+16>>2]|0)+48>>0]|0:0){if(!(b[c+38>>0]|0)){kVb(a,f[c+4>>2]|0,d,0,478215);break}if((f[c+32>>2]|0)==1){j=f[c+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(j,g)}if((f[c+28>>2]|0)==11)break}kVb(a,f[c+4>>2]|0,d,2,503658)}while(0);i=f[c+20>>2]|0;do if(((i|0?(j=i+84|0,k=f[j>>2]|0,(k|0)!=(Y7b()|0)):0)?(f[(f[j>>2]|0)+92>>2]|0)==3:0)?(j=f[h>>2]|0,j|0):0){k=f[j+8>>2]|0;if((k|0?(j=k+84|0,k=f[j>>2]|0,(k|0)!=(Y7b()|0)):0)?(f[(f[j>>2]|0)+92>>2]|0)==3:0)break;kVb(a,f[c+4>>2]|0,d,3,478264)}while(0);h=f[c+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(h,g)}if(((f[c+28>>2]|0)==11?b[(f[(f[c+60>>2]|0)+16>>2]|0)+51>>0]|0:0)?!(bWb(a,c,d)|0):0)kVb(a,f[c+4>>2]|0,d,9,478430);cWb(a,c,d);u=e;return}function RVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=b+40|0;if((f[d>>2]|0)>0){e=b+80|0;g=c+92|0;h=0;do{SVb(a,(f[e>>2]|0)+(h*88|0)|0,f[(f[g>>2]|0)+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)<(f[d>>2]|0))}d=b+28|0;if((f[d>>2]|0)>0){h=b+68|0;g=c+44|0;e=0;do{TVb(a,(f[h>>2]|0)+(e*88|0)|0,f[(f[g>>2]|0)+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)<(f[d>>2]|0))}d=b+32|0;e=f[d>>2]|0;if((e|0)<=0)return;g=b+72|0;b=c+60|0;c=0;h=e;while(1){e=f[g>>2]|0;i=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if((f[e+(c*48|0)+24>>2]|0)>0?(f[(f[e+(c*48|0)+28>>2]|0)+8>>2]|0)!=0:0){kVb(a,f[e+(c*48|0)+4>>2]|0,i,9,477349);j=f[d>>2]|0}else j=h;c=c+1|0;if((c|0)>=(j|0))break;else h=j}return}function SVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e+48|0;h=e+36|0;i=e+24|0;j=e+12|0;k=e;if(b[c+38>>0]|0){l=f[(f[c+48>>2]|0)+4>>2]|0;if((f[220823]|0)!=2){f[g>>2]=161028;f[g+4>>2]=130;b[g+8>>0]=0;DTb(883292,g);ZSb(g)}m=KVb(f[220824]|0,l)|0;if((m|0)==((f[220824]|0)+4|0))kVb(a,f[c+4>>2]|0,d,9,477573)}if((f[c+32>>2]|0)==2)kVb(a,f[c+4>>2]|0,d,9,477633);if(b[c+36>>0]|0)kVb(a,f[c+4>>2]|0,d,9,477676);m=c+24|0;l=f[m>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(l,g)}l=c+28|0;if((f[l>>2]|0)==14){n=f[m>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(n,g)}n=c+64|0;if(f[n>>2]|0){o=f[m>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(o,g)}if((f[(f[(f[n>>2]|0)+8>>2]|0)+44>>2]|0)!=3){o=f[c+4>>2]|0;p=f[m>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(p,g)}VHa(k,477727,f[(f[n>>2]|0)+4>>2]|0);jIa(j,k,477739);QJa(i,j,f[(f[c+48>>2]|0)+4>>2]|0);jIa(h,i,477780);lVb(a,o,d,2,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0)}}}k=f[m>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(k,g)}if((f[l>>2]|0)!=10){u=e;return}kVb(a,f[c+4>>2]|0,d,2,477814);u=e;return}function TVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+96|0;g=e+72|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;n=c+60|0;if((f[n>>2]|0)>0){o=c+28|0;p=d+44|0;q=0;do{TVb(a,(f[o>>2]|0)+(q*88|0)|0,f[(f[p>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[n>>2]|0))}n=c+64|0;q=f[n>>2]|0;if((q|0)>0){p=c+32|0;o=d+60|0;r=0;s=q;while(1){q=f[p>>2]|0;t=f[(f[o>>2]|0)+4+(r<<2)>>2]|0;if((f[q+(r*48|0)+24>>2]|0)>0?(f[(f[q+(r*48|0)+28>>2]|0)+8>>2]|0)!=0:0){kVb(a,f[q+(r*48|0)+4>>2]|0,t,9,477349);v=f[n>>2]|0}else v=s;r=r+1|0;if((r|0)>=(v|0))break;else s=v}}v=c+52|0;if((f[v>>2]|0)>0){s=c+20|0;r=d+28|0;n=0;do{SVb(a,(f[s>>2]|0)+(n*88|0)|0,f[(f[r>>2]|0)+4+(n<<2)>>2]|0);n=n+1|0}while((n|0)<(f[v>>2]|0))}n=c+72|0;if((f[n>>2]|0)>0){r=c+40|0;s=d+92|0;o=0;do{SVb(a,(f[r>>2]|0)+(o*88|0)|0,f[(f[s>>2]|0)+4+(o<<2)>>2]|0);o=o+1|0}while((o|0)<(f[n>>2]|0))}if((f[c+68>>2]|0)>0)kVb(a,f[c+4>>2]|0,d,9,477394);if(b[(f[c+16>>2]|0)+48>>0]|0)kVb(a,f[c+4>>2]|0,d,9,477438);f[g+4>>2]=0;f[g+8>>2]=0;n=g+4|0;f[g>>2]=n;if((f[v>>2]|0)<=0){w=g;x=0;UVb(w,x);u=e;return}o=c+20|0;s=h+11|0;r=c+4|0;c=i+11|0;p=j+11|0;t=k+11|0;q=l+11|0;y=m+11|0;z=0;do{A=f[(f[o>>2]|0)+(z*88|0)>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=A+11|0;C=b[B>>0]|0;D=A+4|0;if((C<<24>>24<0?f[D>>2]|0:C&255)|0){E=0;F=C;do{C=b[(F<<24>>24<0?f[A>>2]|0:A)+E>>0]|0;do if(C<<24>>24!=95)if((C+-65&255)<26){vEc(h,(C&255)+32&255);break}else{vEc(h,C);break}while(0);E=E+1|0;F=b[B>>0]|0}while(E>>>0<(F<<24>>24<0?f[D>>2]|0:F&255)>>>0)}if((VVb(g,h)|0)!=(n|0)){F=f[r>>2]|0;VHa(m,477477,f[(f[o>>2]|0)+(z*88|0)>>2]|0);jIa(l,m,477513);D=WVb(g,h)|0;QJa(k,l,f[f[D>>2]>>2]|0);jIa(j,k,477538);jIa(i,j,477554);lVb(a,F,d,9,i);if((b[c>>0]|0)<0)YDc(f[i>>2]|0);if((b[p>>0]|0)<0)YDc(f[j>>2]|0);if((b[t>>0]|0)<0)YDc(f[k>>2]|0);if((b[q>>0]|0)<0)YDc(f[l>>2]|0);if((b[y>>0]|0)<0)YDc(f[m>>2]|0)}else{F=f[o>>2]|0;D=WVb(g,h)|0;f[D>>2]=F+(z*88|0)}if((b[s>>0]|0)<0)YDc(f[h>>2]|0);z=z+1|0}while((z|0)<(f[v>>2]|0));w=g;x=f[n>>2]|0;UVb(w,x);u=e;return}function UVb(a,c){a=a|0;c=c|0;if(!c)return;UVb(a,f[c>>2]|0);UVb(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function VVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function WVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=XVb(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=VDc(32)|0;fEc(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}laa(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function XVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function YVb(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+48|0;c=a+36|0;d=a+24|0;e=a+12|0;g=a;h=VDc(12)|0;i=h+4|0;f[i>>2]=0;f[h+8>>2]=0;f[h>>2]=i;f[220824]=h;i=e+8|0;j=e+4|0;k=d+11|0;l=e+11|0;m=g+11|0;n=g+5|0;o=d+11|0;p=e+11|0;q=0;r=h;while(1){h=VDc(32)|0;f[e>>2]=h;f[i>>2]=-2147483616;f[j>>2]=16;s=h;t=477950;v=s+16|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[h+16>>0]=0;t=f[161448+(q<<2)>>2]|0;jIa(d,e,t);s=kaa(r,c,d)|0;if(!(f[s>>2]|0)){v=VDc(28)|0;fEc(v+16|0,d);w=f[c>>2]|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=w;f[s>>2]=v;w=f[f[r>>2]>>2]|0;if(!w)x=v;else{f[r>>2]=w;x=f[s>>2]|0}laa(f[r+4>>2]|0,x);s=r+8|0;f[s>>2]=(f[s>>2]|0)+1}if((b[k>>0]|0)<0)YDc(f[d>>2]|0);if((b[l>>0]|0)<0)YDc(f[e>>2]|0);s=f[220824]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[m>>0]=5;b[g>>0]=b[477967]|0;b[g+1>>0]=b[477968]|0;b[g+2>>0]=b[477969]|0;b[g+3>>0]=b[477970]|0;b[g+4>>0]=b[477971]|0;b[n>>0]=0;jIa(e,g,477973);jIa(d,e,t);t=kaa(s,c,d)|0;if(!(f[t>>2]|0)){w=VDc(28)|0;fEc(w+16|0,d);v=f[c>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=v;f[t>>2]=w;v=f[f[s>>2]>>2]|0;if(!v)y=w;else{f[s>>2]=v;y=f[t>>2]|0}laa(f[s+4>>2]|0,y);t=s+8|0;f[t>>2]=(f[t>>2]|0)+1}if((b[o>>0]|0)<0)YDc(f[d>>2]|0);if((b[p>>0]|0)<0)YDc(f[e>>2]|0);if((b[m>>0]|0)<0)YDc(f[g>>2]|0);t=q+1|0;if(t>>>0>=8)break;q=t;r=f[220824]|0}iTb(131);u=a;return}function ZVb(a){a=a|0;_Vb(a);return}function _Vb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+112|0;d=c+64|0;e=c+88|0;g=c+48|0;h=c+36|0;i=c+24|0;j=c;k=c+100|0;l=a+20|0;if(!(b[(f[l>>2]|0)+49>>0]|0)){rTb(d,3,475801,6998);oTb(c+101|0,mTb(d,477857)|0);sTb(d)}d=f[a+72>>2]|0;if(d|0){m=a+28|0;$Vb(e,f[(f[l>>2]|0)+8>>2]|0,d,0);switch(f[e>>2]|0){case 1:{f[m>>2]=11;f[a+60>>2]=f[e+4>>2];break}case 4:{f[m>>2]=14;f[a+64>>2]=f[e+4>>2];break}default:{}}}m=a+64|0;d=f[m>>2]|0;if(!d){u=c;return}n=a+80|0;if(f[n>>2]|0){u=c;return}o=a+76|0;if(f[o>>2]|0){fEc(e,f[d+4>>2]|0);d=DEc(e,46,-1)|0;if((d|0)!=-1){gEc(i,e,0,d,e);jIa(h,i,518136);QJa(g,h,f[o>>2]|0);iEc(e,g)|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0)}else iEc(e,f[o>>2]|0)|0;$Vb(g,f[(f[l>>2]|0)+8>>2]|0,e,0);if((f[g>>2]|0)==5)f[n>>2]=f[g+4>>2];if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if(f[n>>2]|0){u=c;return}}e=f[m>>2]|0;if(!(f[e+24>>2]|0)){rTb(j,3,475801,7030);oTb(k,mTb(j,477908)|0);sTb(j);p=f[m>>2]|0}else p=e;f[n>>2]=f[p+28>>2];u=c;return}function $Vb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+12|0;h=e;fEc(g,d);d=g+11|0;i=b[d>>0]|0;j=i<<24>>24<0;if(((j?f[g+4>>2]|0:i&255)|0?(b[(j?f[g>>2]|0:g)>>0]|0)==46:0)?(gEc(h,g,1,-1,g),iEc(g,h)|0,(b[h+11>>0]|0)<0):0)YDc(f[h>>2]|0);RUb(a,f[c+16>>2]|0,c,g);if((b[d>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function aWb(){var a=0;a=f[220824]|0;if(!a)return;jaa(a,f[a+4>>2]|0);YDc(a);return}function bWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(i,g)}i=f[c+60>>2]|0;if(f[i+72>>2]|0){j=0;u=e;return j|0}if((f[c+32>>2]|0)!=3){j=0;u=e;return j|0}if(f[i+68>>2]|0){j=0;u=e;return j|0}if(f[i+60>>2]|0){j=0;u=e;return j|0}if(f[i+64>>2]|0){j=0;u=e;return j|0}if((f[i+52>>2]|0)!=2){j=0;u=e;return j|0}k=f[i>>2]|0;dWb(h,f[c>>2]|0,0);jIa(g,h,478654);l=b[k+11>>0]|0;m=l<<24>>24<0;n=l&255;l=m?f[k+4>>2]|0:n;o=b[g+11>>0]|0;p=o<<24>>24<0;a:do if((l|0)==((p?f[g+4>>2]|0:o&255)|0)){q=f[k>>2]|0;r=m?q:k;s=p?f[g>>2]|0:g;t=(l|0)==0;b:do if(m){if(!t?Arc(r,s,l)|0:0){v=1;break a}}else if(!t){if((q&255)<<24>>24==(b[s>>0]|0)){w=k;x=n;y=s}else{v=1;break a}while(1){x=x+-1|0;w=w+1|0;if(!x)break b;y=y+1|0;if((b[w>>0]|0)!=(b[y>>0]|0)){v=1;break a}}}while(0);v=(f[c+48>>2]|0)!=(f[i+12>>2]|0)}else v=1;while(0);if(p)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if(v){j=0;u=e;return j|0}v=f[i+20>>2]|0;i=v+88|0;if((f[v+32>>2]|0)!=1){j=0;u=e;return j|0}if((f[v+40>>2]|0)!=1){j=0;u=e;return j|0}h=f[v>>2]|0;p=b[h+11>>0]|0;if(((p<<24>>24<0?f[h+4>>2]|0:p&255)|0)!=3){j=0;u=e;return j|0}if(EEc(h,0,-1,498516,3)|0){j=0;u=e;return j|0}if((f[v+120>>2]|0)!=1){j=0;u=e;return j|0}if((f[v+128>>2]|0)!=2){j=0;u=e;return j|0}h=f[i>>2]|0;p=b[h+11>>0]|0;if(((p<<24>>24<0?f[h+4>>2]|0:p&255)|0)!=5){j=0;u=e;return j|0}if(EEc(h,0,-1,498520,5)|0){j=0;u=e;return j|0}h=f[v+24>>2]|0;do if(h|0){if((f[h>>2]|0)==2)break;f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=v;DTb(h,g)}while(0);switch(f[v+28>>2]|0){case 14:{kVb(a,f[c+4>>2]|0,d,2,478660);break}case 12:case 10:case 11:case 1:case 2:{kVb(a,f[c+4>>2]|0,d,2,478700);break}default:{}}h=v+112|0;p=f[h>>2]|0;do if(p|0){if((f[p>>2]|0)==2)break;f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=i;DTb(p,g)}while(0);if((f[v+116>>2]|0)!=14){j=1;u=e;return j|0}p=f[h>>2]|0;do if(p|0){if((f[p>>2]|0)==2)break;f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=i;DTb(p,g)}while(0);if(!(f[(f[(f[v+152>>2]|0)+28>>2]|0)+8>>2]|0)){j=1;u=e;return j|0}kVb(a,f[c+4>>2]|0,d,2,478766);j=1;u=e;return j|0}function cWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;h=f[(f[c+68>>2]|0)+56>>2]|0;if(!h){u=e;return}i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(i,g)}switch(f[c+28>>2]|0){case 16:case 6:case 18:case 3:case 4:break;default:{kVb(a,f[c+4>>2]|0,d,2,478577);u=e;return}}if((h+-1|0)>>>0<2){u=e;return}i=f[c+4>>2]|0;c=(V7b()|0)+28|0;VHa(g,478507,f[(f[c>>2]|0)+(h*20|0)>>2]|0);lVb(a,i,d,2,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);u=e;return}function dWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=c+11|0;g=b[e>>0]|0;h=c+4|0;mEc(a,g<<24>>24<0?f[h>>2]|0:g&255);g=b[e>>0]|0;if((g<<24>>24<0?f[h>>2]|0:g&255)|0){i=d^1;j=0;k=g;while(1){g=b[(k<<24>>24<0?f[c>>2]|0:c)+j>>0]|0;do if(g<<24>>24!=95)if(i){l=g<<24>>24;vEc(a,((g+-97&255)<26?l+224|0:l)&255);m=0;break}else{vEc(a,g);m=0;break}else m=1;while(0);j=j+1|0;k=b[e>>0]|0;if(j>>>0>=(k<<24>>24<0?f[h>>2]|0:k&255)>>>0)break;else i=m}}if(!d)return;d=b[a+11>>0]|0;m=d<<24>>24<0;if(m)n=f[a+4>>2]|0;else n=d&255;if(!n)return;if(m)o=f[a>>2]|0;else o=a;n=b[o>>0]|0;o=n<<24>>24;if(m)p=f[a>>2]|0;else p=a;b[p>>0]=(n+-65&255)<26?o+32|0:o;return}function eWb(a,c){a=a|0;c=c|0;if(!c)return;eWb(a,f[c>>2]|0);eWb(a,f[c+4>>2]|0);a=c+20|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function fWb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=u;u=u+16|0;i=h;if((f[c>>2]|0)!=(d|0)?(j=f[d>>2]|0,(j|0)!=0):0){dTb(j);k=j;l=0}else{k=0;l=1}j=d+16|0;m=f[j>>2]|0;n=e+11|0;f[i>>2]=(b[n>>0]|0)<0?f[e>>2]|0:e;o=SUb(m+132|0,i)|0;if(o){m=o+12|0;o=f[m>>2]|0;p=f[m+4>>2]|0;m=a;f[m>>2]=o;f[m+4>>2]=p;if(!o)q=7}else{o=a;f[o>>2]=0;f[o+4>>2]=0;q=7}if((q|0)==7){q=f[d+12>>2]|0;if(!q)r=0;else{fWb(i,c,q,e,1);q=i;c=f[q>>2]|0;o=f[q+4>>2]|0;q=a;f[q>>2]=c;f[q+4>>2]=o;r=(c|0)!=0}if(!(r|g^1)?TUb(d,e)|0:0){d=f[j>>2]|0;f[i>>2]=(b[n>>0]|0)<0?f[e>>2]|0:e;e=SUb(d+132|0,i)|0;if(!e){s=0;t=0}else{i=e+12|0;s=f[i>>2]|0;t=f[i+4>>2]|0}i=a;f[i>>2]=s;f[i+4>>2]=t}}if(l){u=h;return}eTb(k);u=h;return}function gWb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=u;u=u+48|0;j=i+28|0;k=i+16|0;l=i+8|0;m=i;f[c+72>>2]=0;n=c+88|0;o=n+11|0;if((b[o>>0]|0)<0){b[f[n>>2]>>0]=0;f[c+92>>2]=0}else{b[n>>0]=0;b[o>>0]=0}o=d+11|0;p=b[o>>0]|0;q=p<<24>>24<0;r=d+4|0;if((q?f[r>>2]|0:p&255)|0?(b[(q?f[d>>2]|0:d)>>0]|0)==46:0){gEc(j,d,1,-1,d);gXb(a,c,j,h);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);u=i;return}q=CEc(d,46,0)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if((q|0)!=-1){gEc(k,d,0,q,d);iEc(j,k)|0;if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0)}else iEc(j,d)|0;fEc(k,e);e=DEc(k,46,-1)|0;a:do if((e|0)==-1)s=22;else{q=k+11|0;p=k+4|0;t=j+11|0;v=j+4|0;b:do if((g|0)==1){w=e;while(1){yEc(k,w,-1)|0;x=b[q>>0]|0;y=x<<24>>24<0?f[p>>2]|0:x&255;pEc(k,1,46)|0;x=b[t>>0]|0;z=x<<24>>24<0;tEc(k,z?f[j>>2]|0:j,z?f[v>>2]|0:x&255)|0;gXb(l,c,k,h);x=f[l>>2]|0;c:do if(x|0){z=b[t>>0]|0;A=f[v>>2]|0;B=b[o>>0]|0;C=f[r>>2]|0;if((z<<24>>24<0?A:z&255)>>>0>=(B<<24>>24<0?C:B&255)>>>0)switch(x|0){case 1:case 4:{s=30;break b;break}default:break c}D=x+-1|0;if(D>>>0<8?(-87&255)>>>(D&255)&1:0){E=z;F=A;G=B;H=C;s=27;break b}}while(0);yEc(k,y,-1)|0;w=DEc(k,46,-1)|0;if((w|0)==-1){s=22;break a}}}else{w=e;while(1){yEc(k,w,-1)|0;x=b[q>>0]|0;C=x<<24>>24<0?f[p>>2]|0:x&255;pEc(k,1,46)|0;x=b[t>>0]|0;B=x<<24>>24<0;tEc(k,B?f[j>>2]|0:j,B?f[v>>2]|0:x&255)|0;gXb(l,c,k,h);x=f[l>>2]|0;if(x|0){B=b[t>>0]|0;A=f[v>>2]|0;z=b[o>>0]|0;D=f[r>>2]|0;if((B<<24>>24<0?A:B&255)>>>0>=(z<<24>>24<0?D:z&255)>>>0){s=30;break b}I=x+-1|0;if(I>>>0<8?(-87&255)>>>(I&255)&1:0){E=B;F=A;G=z;H=D;s=27;break b}}yEc(k,C,-1)|0;w=DEc(k,46,-1)|0;if((w|0)==-1){s=22;break a}}}while(0);if((s|0)==27){v=E<<24>>24<0?F:E&255;wEc(k,d,v,(G<<24>>24<0?H:G&255)-v|0)|0;gXb(m,c,k,h);v=m;t=f[v>>2]|0;p=f[v+4>>2]|0;v=l;f[v>>2]=t;f[v+4>>2]=p;if(!t)iEc(n,k)|0;v=a;f[v>>2]=t;f[v+4>>2]=p}else if((s|0)==30){p=l;v=f[p+4>>2]|0;t=a;f[t>>2]=f[p>>2];f[t+4>>2]=v}J=q}while(0);if((s|0)==22){gXb(a,c,d,h);J=k+11|0}if((b[J>>0]|0)<0)YDc(f[k>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);u=i;return}function hWb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+32|0;h=g+12|0;i=g;j=d+11|0;k=b[j>>0]|0;l=k<<24>>24<0;m=l?f[d+4>>2]|0:k&255;a:do if(m|0){k=l?f[d>>2]|0:d;n=0;o=0;while(1){p=b[k+n>>0]|0;do if(p<<24>>24>96)if(p<<24>>24<123)q=0;else break a;else{if(p<<24>>24>64)if(p<<24>>24<91|p<<24>>24==95){q=0;break}else break a;if(p<<24>>24>47)if(p<<24>>24<58){q=0;break}else break a;else if(o|p<<24>>24!=46)break a;else{q=1;break}}while(0);n=n+1|0;if(n>>>0>=m>>>0)break;else o=q}if(!q){o=c+16|0;n=f[o>>2]|0;if((b[k>>0]|0)==46){gEc(i,d,1,-1,d);p=VDc(12)|0;fEc(p,i);f[h>>2]=p;r=n+76|0;s=f[r>>2]|0;if((s|0)==(f[n+80>>2]|0))mVb(n+72|0,h);else{f[s>>2]=p;f[r>>2]=(f[r>>2]|0)+4}r=f[h>>2]|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);t=r}else{r=VDc(12)|0;fEc(r,d);f[h>>2]=r;p=n+76|0;s=f[p>>2]|0;if((s|0)==(f[n+80>>2]|0))mVb(n+72|0,h);else{f[s>>2]=r;f[p>>2]=(f[p>>2]|0)+4}t=f[h>>2]|0}p=DEc(t,46,-1)|0;if((p|0)==-1)if((f[220804]|0)==2){v=t;w=527320;x=527320}else{f[h>>2]=161028;f[h+4>>2]=125;b[h+8>>0]=0;DTb(883216,h);ZSb(h);v=t;w=527320;x=527320}else{r=f[o>>2]|0;gEc(i,t,0,p,t);s=VDc(12)|0;fEc(s,i);f[h>>2]=s;n=r+76|0;y=f[n>>2]|0;if((y|0)==(f[r+80>>2]|0))mVb(r+72|0,h);else{f[y>>2]=s;f[n>>2]=(f[n>>2]|0)+4}n=f[h>>2]|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);s=f[o>>2]|0;gEc(i,t,p+1|0,-1,t);p=VDc(12)|0;fEc(p,i);f[h>>2]=p;y=s+76|0;r=f[y>>2]|0;if((r|0)==(f[s+80>>2]|0))mVb(s+72|0,h);else{f[r>>2]=p;f[y>>2]=(f[y>>2]|0)+4}y=f[h>>2]|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);v=y;w=n;x=n}jIa(h,t,481654);n=sVb(c,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);f[n+4>>2]=x;if((e|0)!=1){f[n+28>>2]=1;y=f[o>>2]|0;p=VDc(88)|0;f[h>>2]=p;r=y+124|0;s=f[r>>2]|0;if((s|0)==(f[y+128>>2]|0))f6(y+120|0,h);else{f[s>>2]=p;f[r>>2]=(f[r>>2]|0)+4}r=f[h>>2]|0;f[n+68>>2]=r;z=r+12|0;A=z+76|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[r+4>>2]=t;f[r>>2]=v;f[r+8>>2]=n;k=_7b()|0;f[r+16>>2]=k;b[r+84>>0]=1;b[r+85>>0]=(b[((b[j>>0]|0)<0?f[d>>2]|0:d)>>0]|0)!=46&1;if((e|0)==2){f[r+68>>2]=1;k=f[o>>2]|0;p=VDc(12)|0;f[h>>2]=p;s=k+124|0;y=f[s>>2]|0;if((y|0)==(f[k+128>>2]|0))f6(k+120|0,h);else{f[y>>2]=p;f[s>>2]=(f[s>>2]|0)+4}s=f[h>>2]|0;f[r+36>>2]=s;f[s>>2]=1;f[s+4>>2]=536870912}f[a>>2]=1;f[a+4>>2]=r;u=g;return}f[n+32>>2]=1;s=f[o>>2]|0;p=VDc(48)|0;f[h>>2]=p;y=s+124|0;k=f[y>>2]|0;if((k|0)==(f[s+128>>2]|0))f6(s+120|0,h);else{f[k>>2]=p;f[y>>2]=(f[y>>2]|0)+4}y=f[h>>2]|0;f[n+72>>2]=y;z=y+12|0;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[y+4>>2]=t;f[y>>2]=v;f[y+8>>2]=n;r=e8b()|0;f[y+16>>2]=r;b[y+20>>0]=1;b[y+21>>0]=(b[((b[j>>0]|0)<0?f[d>>2]|0:d)>>0]|0)!=46&1;f[y+24>>2]=1;r=f[o>>2]|0;p=VDc(20)|0;f[h>>2]=p;k=r+124|0;s=f[k>>2]|0;if((s|0)==(f[r+128>>2]|0))f6(r+120|0,h);else{f[s>>2]=p;f[k>>2]=(f[k>>2]|0)+4}k=f[h>>2]|0;f[y+28>>2]=k;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;p=f[o>>2]|0;s=VDc(32)|0;f[i>>2]=s;f[i+8>>2]=-2147483616;f[i+4>>2]=17;z=s;r=481673;A=z+17|0;do{b[z>>0]=b[r>>0]|0;z=z+1|0;r=r+1|0}while((z|0)<(A|0));b[s+17>>0]=0;r=VDc(12)|0;fEc(r,i);f[h>>2]=r;n=p+76|0;B=f[n>>2]|0;if((B|0)==(f[p+80>>2]|0))mVb(p+72|0,h);else{f[B>>2]=r;f[n>>2]=(f[n>>2]|0)+4}f[k>>2]=f[h>>2];if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);n=b[x+11>>0]|0;if(n<<24>>24<0)C=f[w+4>>2]|0;else C=n&255;if(C){n=f[o>>2]|0;jIa(i,w,481691);r=VDc(12)|0;fEc(r,i);f[h>>2]=r;B=n+76|0;D=f[B>>2]|0;if((D|0)==(f[n+80>>2]|0))mVb(n+72|0,h);else{f[D>>2]=r;f[B>>2]=(f[B>>2]|0)+4}f[k+4>>2]=f[h>>2];if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0)}else f[k+4>>2]=f[k>>2];f[k+8>>2]=0;f[k+12>>2]=y;B=g8b()|0;f[k+16>>2]=B;f[a>>2]=4;f[a+4>>2]=y;u=g;return}}while(0);i=a;f[i>>2]=0;f[i+4>>2]=0;u=g;return}function iWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;e=a;g=a+8|0;h=a+24|0;i=a+48|0;mi[f[(f[d>>2]|0)+96>>2]&2047](e,d);j=f[e>>2]|0;k=VDc(32)|0;f[g>>2]=k;f[g+8>>2]=-2147483616;f[g+4>>2]=20;l=k;m=476092;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+20>>0]=0;EVb(e,f[(f[j+8>>2]|0)+88>>2]|0,j,g);j=(f[e>>2]|0)==2;k=e;e=j?f[k+4>>2]|0:0;if(!((j?f[k>>2]|0:0)|0))o=0;else o=b[e+38>>0]|0?0:e;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if(!o){rTb(h,3,475801,6491);oTb(i,mTb(h,481624)|0);sTb(h)}h=_i[f[(f[d>>2]|0)+92>>2]&1023](d)|0;i=hh[f[(f[h>>2]|0)+300>>2]&127](h,d,o,0)|0;mi[f[(f[i>>2]|0)+72>>2]&2047](i,c);u=a;return}function jWb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function kWb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+96|0;j=i+64|0;k=i+48|0;l=i;m=i+44|0;n=i+40|0;o=i+36|0;p=i+32|0;q=i+8|0;r=i+80|0;if((f[c>>2]|0)==(f[d>>2]|0)){s=f[h>>2]|0;t=e+40|0;if(!s){v=1;u=i;return v|0}w=f[s>>2]|0;x=w;y=(f[s+4>>2]|0)-w>>4;w=0;while(1){if((w|0)>=(y|0)){v=1;z=12;break}if((f[x+(w<<4)>>2]|0)==(f[t>>2]|0))break;else w=w+1|0}if((z|0)==12){u=i;return v|0}VHa(k,479094,g);jIa(j,k,481605);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[a+8>>2]|0,7,j);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);v=0;u=i;return v|0}w=j+4|0;t=j+8|0;x=j+12|0;y=0;a:while(1){s=f[h>>2]|0;if(!s)A=0;else A=(f[s+4>>2]|0)-(f[s>>2]|0)>>4;if((y|0)>=(A|0)){v=1;z=12;break}B=f[s>>2]|0;s=f[f[c>>2]>>2]|0;b:do if((f[B+(y<<4)>>2]|0)==(f[s+40>>2]|0)){C=f[s+24>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[j>>2]=78728;f[w>>2]=1737;b[t>>0]=0;f[x>>2]=s;DTb(C,j)}D=f[s+28>>2]|0;switch(D|0){case 11:break;case 10:{if((f[B+(y<<4)+4>>2]|0)!=4)break b;f[o>>2]=(f[c>>2]|0)+4;f[p>>2]=f[d>>2];C=f[B+(y<<4)+8>>2]|0;f[k>>2]=f[o>>2];f[j>>2]=f[p>>2];if(kWb(a,k,j,e,g,C)|0)break b;else{v=0;z=12;break a}break}default:{z=30;break a}}if((f[B+(y<<4)+4>>2]|0)==3){f[l>>2]=0;C=f[B+(y<<4)+8>>2]|0;E=b[C+11>>0]|0;F=E<<24>>24<0;if(xjc(l,F?f[C>>2]|0:C,F?f[C+4>>2]|0:E&255)|0?(f[m>>2]=(f[c>>2]|0)+4,f[n>>2]=f[d>>2],f[k>>2]=f[m>>2],f[j>>2]=f[n>>2],!(kWb(a,k,j,e,g,l)|0)):0)G=1;else G=0;if(f[l>>2]|0)ljc(l);if(G|0){v=0;z=12;break a}}}while(0);y=y+1|0}if((z|0)==12){u=i;return v|0}else if((z|0)==30){rTb(q,3,475801,6551);oTb(r,pTb(mTb(q,479573)|0,D)|0);sTb(q);v=0;u=i;return v|0}return 0}function lWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=u;u=u+112|0;g=e;h=e+88|0;i=e+76|0;j=e+64|0;k=e+52|0;l=e+40|0;m=e+28|0;o=e+16|0;q=c+24|0;r=f[q>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(r,g)}r=c+28|0;a:do switch(f[161216+(f[r>>2]<<2)>>2]|0){case 1:{t=a+8|0;v=f[t>>2]|0;w=f[v+8>>2]|0;if(w&8|0){x=v+48|0;y=f[x>>2]|0;z=f[x+4>>2]|0;if(!(z>>>0>0|(z|0)==0&y>>>0>2147483647)){z=f[c+40>>2]|0;x=f[q>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(x,g)}mWb(0,z,y,f[r>>2]|0,d);break a}VHa(h,479613,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}if(!(w&16)){VHa(h,479651,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}w=v+56|0;v=f[w>>2]|0;y=f[w+4>>2]|0;if(!((y|0)<-1|(y|0)==-1&v>>>0<2147483648)){y=f[c+40>>2]|0;w=f[q>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(w,g)}mWb(0,y,v,f[r>>2]|0,d);break a}VHa(h,479613,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}case 2:{t=a+8|0;v=f[t>>2]|0;y=f[v+8>>2]|0;if(!(y&8)){if(y&16|0){y=f[c+40>>2]|0;w=v+56|0;z=f[w>>2]|0;x=f[w+4>>2]|0;w=f[q>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(w,g)}nWb(0,y,z,x,f[r>>2]|0,d);break a}VHa(h,479730,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}else{x=v+48|0;v=f[x>>2]|0;z=f[x+4>>2]|0;if((z|0)>=0){x=f[c+40>>2]|0;y=f[q>>2]|0;if(y|0?(f[y>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(y,g)}nWb(0,x,v,z,f[r>>2]|0,d);break a}VHa(h,479692,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}break}case 3:{t=a+8|0;z=f[t>>2]|0;if(!(f[z+8>>2]&8)){VHa(h,479810,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}v=z+48|0;z=f[v>>2]|0;x=f[v+4>>2]|0;if(!(x>>>0>0|(x|0)==0&z>>>0>4294967295)){x=f[c+40>>2]|0;v=f[q>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(v,g)}oWb(0,x,z,f[r>>2]|0,d);break a}VHa(h,479771,f[c>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}case 4:{t=a+8|0;z=f[t>>2]|0;if(f[z+8>>2]&8|0){x=f[c+40>>2]|0;v=z+48|0;z=f[v>>2]|0;y=f[v+4>>2]|0;v=f[q>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(v,g)}pWb(0,x,z,y,f[r>>2]|0,d);break a}VHa(h,479865,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}case 6:{t=a+8|0;y=f[t>>2]|0;z=f[y+8>>2]|0;do if(!(z&32)){if(z&8|0){x=y+48|0;B=+((f[x>>2]|0)>>>0)+4294967296.0*+((f[x+4>>2]|0)>>>0);break}if(z&16|0){x=y+56|0;B=+((f[x>>2]|0)>>>0)+4294967296.0*+(f[x+4>>2]|0);break}VHa(h,479920,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}else B=+p[y+64>>3];while(0);sjc(d,f[c+40>>2]|0,(n[s>>2]=B,f[s>>2]|0));break}case 5:{y=a+8|0;t=f[y>>2]|0;z=f[t+8>>2]|0;do if(!(z&32)){if(z&8|0){x=t+48|0;C=+((f[x>>2]|0)>>>0)+4294967296.0*+((f[x+4>>2]|0)>>>0);break}if(z&16|0){x=t+56|0;C=+((f[x>>2]|0)>>>0)+4294967296.0*+(f[x+4>>2]|0);break}VHa(h,479960,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[y>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}else C=+p[t+64>>3];while(0);p[s>>3]=C;tjc(d,f[c+40>>2]|0,f[s>>2]|0,f[s+4>>2]|0);break}case 7:{t=a+8|0;y=f[t>>2]|0;if(!(f[y+8>>2]&1)){VHa(h,480001,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}z=f[y+32>>2]|0;y=b[z+11>>0]|0;x=f[z+4>>2]|0;if(((y<<24>>24<0?x:y&255)|0)==4)if(!(EEc(z,0,-1,519053,4)|0)){D=1;E=0}else{v=f[(f[t>>2]|0)+32>>2]|0;F=b[v+11>>0]|0;G=f[v+4>>2]|0;H=v;I=112}else{F=y;G=x;H=z;I=112}do if((I|0)==112){if(((F<<24>>24<0?G:F&255)|0)==5?(EEc(H,0,-1,519047,5)|0)==0:0){D=0;E=0;break}VHa(h,480047,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}while(0);rjc(d,f[c+40>>2]|0,D,E);break}case 8:{t=a+8|0;if(!(f[(f[t>>2]|0)+8>>2]&1)){VHa(h,480100,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}z=f[q>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(z,g)}z=c+64|0;x=f[z>>2]|0;y=f[(f[t>>2]|0)+32>>2]|0;v=x+8|0;w=f[(f[v>>2]|0)+8>>2]|0;if((f[220825]|0)!=2){f[g>>2]=161028;f[g+4>>2]=132;b[g+8>>0]=0;DTb(883300,g);ZSb(g)}if((w|0)==(f[220826]|0)){EVb(g,f[(f[v>>2]|0)+88>>2]|0,x,y);v=(f[g>>2]|0)==5;w=g;if((v?f[w>>2]|0:0)|0){J=v?f[w+4>>2]|0:0;I=154}}else{w=x+4|0;fEc(g,f[w>>2]|0);v=g+11|0;K=b[v>>0]|0;L=f[x>>2]|0;M=b[L+11>>0]|0;if(M<<24>>24<0)N=f[L+4>>2]|0;else N=M&255;oEc(g,(K<<24>>24<0?f[g+4>>2]|0:K&255)-N|0,0);K=b[y+11>>0]|0;M=K<<24>>24<0;tEc(g,M?f[y>>2]|0:y,M?f[y+4>>2]|0:K&255)|0;K=f[a>>2]|0;fWb(h,K,f[K>>2]|0,g,1);if((f[h>>2]|0)==5){K=f[h+4>>2]|0;if((f[K+12>>2]|0)==(x|0)){O=K;P=0}else{VHa(o,477727,f[w>>2]|0);jIa(m,o,480150);QJa(l,m,y);jIa(k,l,480173);QJa(j,k,f[c+4>>2]|0);jIa(i,j,480188);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);O=0;P=1}}else{O=0;P=0}if((b[v>>0]|0)<0)YDc(f[g>>2]|0);if(!P){J=O;I=154}else{A=0;u=e;return A|0}}if((I|0)==154?J|0:0){v=f[J+8>>2]|0;rjc(d,f[c+40>>2]|0,v,((v|0)<0)<<31>>31);break a}v=f[q>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(v,g)}VHa(m,477727,f[(f[z>>2]|0)+4>>2]|0);jIa(l,m,480150);QJa(k,l,y);jIa(j,k,480173);QJa(i,j,f[c+4>>2]|0);jIa(h,i,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);A=0;u=e;return A|0}case 9:{t=a+8|0;y=f[t>>2]|0;if(f[y+8>>2]&2|0){z=f[y+36>>2]|0;iEc(ujc(d,f[c+40>>2]|0)|0,z)|0;break a}VHa(h,480239,f[c+4>>2]|0);jIa(g,h,502535);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);A=0;u=e;return A|0}case 10:{if(!(rWb(a,c,d)|0)){A=0;u=e;return A|0}break}default:{}}while(0);A=1;u=e;return A|0}function mWb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=u;u=u+32|0;f=a;switch(d|0){case 5:{rjc(e,b,c,((c|0)<0)<<31>>31);u=a;return}case 15:{sjc(e,b,c);u=a;return}case 17:{rjc(e,b,c<<1^c>>31,0);u=a;return}default:{rTb(f,3,475801,6886);oTb(a+24|0,pTb(mTb(f,481567)|0,d)|0);sTb(f);u=a;return}}}function nWb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=u;u=u+32|0;g=a;switch(e|0){case 3:{rjc(f,b,c,d);u=a;return}case 16:{tjc(f,b,c,d);u=a;return}case 18:{h=jJc(c|0,d|0,1)|0;i=J;rjc(f,b,h^($Ic(c|0,d|0,63)|0),i^J);u=a;return}default:{rTb(g,3,475801,6908);oTb(a+24|0,pTb(mTb(g,481529)|0,e)|0);sTb(g);u=a;return}}}function oWb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=u;u=u+32|0;f=a;switch(d|0){case 13:{rjc(e,b,c,0);u=a;return}case 7:{sjc(e,b,c);u=a;return}default:{rTb(f,3,475801,6925);oTb(a+24|0,pTb(mTb(f,481490)|0,d)|0);sTb(f);u=a;return}}}function pWb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;a=u;u=u+32|0;g=a;switch(e|0){case 4:{rjc(f,b,c,d);u=a;return}case 6:{tjc(f,b,c,d);u=a;return}default:{rTb(g,3,475801,6942);oTb(a+24|0,pTb(mTb(g,481451)|0,e)|0);sTb(g);u=a;return}}}function qWb(){var a=0,c=0;a=VDc(52)|0;F8b(a);f[220827]=a;c=VDc(40)|0;dXb(c,a,0);f[220826]=c;b[c+21>>0]=1;b[c+20>>0]=0;iTb(133);return}function rWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+144|0;g=e+120|0;h=e+104|0;i=e+68|0;j=e+48|0;k=e+12|0;l=e;m=e+80|0;n=e+137|0;o=e+24|0;p=e+136|0;q=a+8|0;if(!(f[(f[q>>2]|0)+8>>2]&4)){VHa(l,479094,f[c+4>>2]|0);jIa(k,l,480287);QJa(j,k,f[c>>2]|0);jIa(i,j,480348);QJa(h,i,f[c>>2]|0);jIa(g,h,480420);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[q>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);r=0;u=e;return r|0}s=c+24|0;t=f[s>>2]|0;if(t|0?(f[t>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(t,g)}t=h9b(a+12|0,f[c+60>>2]|0)|0;v=_i[f[(f[t>>2]|0)+12>>2]&1023](t)|0;t=(v|0)==0;if(t){rTb(m,3,475801,6840);w=mTb(mTb(m,480435)|0,480473)|0;b[g>>0]=0;b[g+1>>0]=0;b[g+2>>0]=0;sWb(h,c,g);oTb(n,nTb(w,h)|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);sTb(m)}f[h>>2]=161488;m=h+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[i>>2]=161512;f[i+4>>2]=f[a>>2];Dic(j,0);f[j>>2]=h;f[j+4>>2]=i;if(djc(j,f[(f[q>>2]|0)+40>>2]|0,v)|0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;QSb(v,k)|0;i=f[s>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(i,g)}i=c+28|0;if((f[i>>2]|0)==11){iEc(ujc(d,f[c+40>>2]|0)|0,k)|0;x=k+11|0}else{w=f[s>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(w,g)}if((f[i>>2]|0)!=10){rTb(o,3,475801,6860);oTb(p,mTb(o,480549)|0);sTb(o)}o=vjc(d,f[c+40>>2]|0)|0;d=k+11|0;p=b[d>>0]|0;i=p<<24>>24<0;xjc(o,i?f[k>>2]|0:k,i?f[k+4>>2]|0:p&255)|0;x=d}if((b[x>>0]|0)<0)YDc(f[k>>2]|0);y=1}else{VHa(l,480506,f[c>>2]|0);jIa(k,l,480545);QJa(g,k,m);lVb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[q>>2]|0,8,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);y=0}Eic(j);f[h>>2]=161488;if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);if(t){r=y;u=e;return r|0}Yi[f[(f[v>>2]|0)+4>>2]&2047](v);r=y;u=e;return r|0}function sWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+400|0;g=e+360|0;h=e+320|0;i=e+280|0;j=e+240|0;k=e+200|0;l=e+160|0;m=e+120|0;n=e+80|0;o=e+40|0;p=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;q=c+38|0;if(!(b[q>>0]|0))r=0;else{s=f[(f[c+48>>2]|0)+4>>2]|0;t=b[s+11>>0]|0;v=t<<24>>24<0;f[g>>2]=v?f[s>>2]|0:s;f[g+4>>2]=v?f[s+4>>2]|0:t&255;f[h>>2]=0;f[h+4>>2]=-1;f[i>>2]=0;f[i+4>>2]=-1;f[j>>2]=0;f[j+4>>2]=-1;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;Khc(a,480762,g,h,i,j,k,l,m,n,o,p);r=1}zWb(c,r,0,a,d);if(!(b[q>>0]|0)){u=e;return}uEc(a,501845)|0;u=e;return}function tWb(a){a=a|0;YDc(a);return}function uWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+8|0;h=e;i=a+4|0;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);c=f[g>>2]|0;gWb(h,f[i>>2]|0,d,f[c+4>>2]|0,0,1);switch(f[h>>2]|0){case 2:{d=f[h+4>>2]|0;j=(b[d+38>>0]|0)==0?0:d;u=e;return j|0}case 1:{if(!(b[(f[c+16>>2]|0)+48>>0]|0)){j=0;u=e;return j|0}d=f[h+4>>2]|0;h=d+72|0;if((f[h>>2]|0)<=0){j=0;u=e;return j|0}i=d+40|0;a=g+4|0;k=g+8|0;l=g+12|0;m=g+4|0;n=g+8|0;o=g+12|0;p=0;while(1){q=f[i>>2]|0;r=q+(p*88|0)|0;if((f[q+(p*88|0)+48>>2]|0)==(c|0)){s=q+(p*88|0)+24|0;t=f[s>>2]|0;if(t|0?(f[t>>2]|0)!=2:0){f[g>>2]=78728;f[m>>2]=1737;b[n>>0]=0;f[o>>2]=r;DTb(t,g)}if((f[q+(p*88|0)+28>>2]|0)==11?(f[q+(p*88|0)+32>>2]|0)==1:0){t=f[s>>2]|0;if(t|0?(f[t>>2]|0)!=2:0){f[g>>2]=78728;f[a>>2]=1737;b[k>>0]=0;f[l>>2]=r;DTb(t,g)}if((f[q+(p*88|0)+60>>2]|0)==(d|0)){j=r;v=19;break}}}p=p+1|0;if((p|0)>=(f[h>>2]|0)){j=0;v=19;break}}if((v|0)==19){u=e;return j|0}break}default:{j=0;u=e;return j|0}}return 0}function vWb(a){a=a|0;var c=0;f[a>>2]=161488;c=a+4|0;if((b[c+11>>0]|0)>=0)return;YDc(f[c>>2]|0);return}function wWb(a){a=a|0;var c=0;f[a>>2]=161488;c=a+4|0;if((b[c+11>>0]|0)>=0){YDc(a);return}YDc(f[c>>2]|0);YDc(a);return}function xWb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;d=a+4|0;c=b[d+11>>0]|0;if(c<<24>>24<0)g=f[a+8>>2]|0;else g=c&255;if(g|0)uEc(d,480701)|0;g=b[e+11>>0]|0;c=g<<24>>24<0;tEc(d,c?f[e>>2]|0:e,c?f[e+4>>2]|0:g&255)|0;return}function yWb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function zWb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=u;u=u+576|0;i=h+536|0;j=h+524|0;k=h+512|0;l=h+472|0;m=h+400|0;n=h+360|0;o=h+320|0;p=h+280|0;q=h+240|0;r=h+200|0;s=h+160|0;t=h+120|0;v=h+80|0;w=h+40|0;x=h;y=c<<1;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(y>>>0>4294967279)dEc(j);if(y>>>0<11){b[j+11>>0]=y;if(!c)z=j;else{A=j;B=6}}else{C=y+16&-16;D=VDc(C)|0;f[j>>2]=D;f[j+8>>2]=C|-2147483648;f[j+4>>2]=y;A=D;B=6}if((B|0)==6){XIc(A|0,32,y|0)|0;z=A}b[z+y>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;y=a+24|0;z=f[y>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=a;DTb(z,i)}z=a+28|0;if((f[z>>2]|0)==11?(A=a+60|0,(b[(f[(f[A>>2]|0)+16>>2]|0)+51>>0]|0)!=0):0){D=f[y>>2]|0;if(D|0?(f[D>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=a;DTb(D,i)}AWb(m,f[(f[A>>2]|0)+20>>2]|0);D=m+11|0;C=b[D>>0]|0;E=C<<24>>24<0;f[l>>2]=E?f[m>>2]|0:m;f[l+4>>2]=E?f[m+4>>2]|0:C&255;C=f[y>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=a;DTb(C,i)}AWb(o,(f[(f[A>>2]|0)+20>>2]|0)+88|0);A=o+11|0;C=b[A>>0]|0;E=C<<24>>24<0;f[n>>2]=E?f[o>>2]|0:o;f[n+4>>2]=E?f[o+4>>2]|0:C&255;f[i>>2]=0;f[i+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;Khc(k,480776,l,n,i,p,q,r,s,t,v,w);if((b[A>>0]|0)<0)YDc(f[o>>2]|0);if((b[D>>0]|0)<0)YDc(f[m>>2]|0)}else B=23;if((B|0)==23?(AWb(i,a),iEc(k,i)|0,(b[i+11>>0]|0)<0):0)YDc(f[i>>2]|0);D=a+32|0;if((f[D>>2]|0)==1)if((d|0)!=1?(f[(f[a+20>>2]|0)+44>>2]|0)!=3:0)B=29;else B=34;else B=29;do if((B|0)==29){d=f[y>>2]|0;if(d|0?(f[d>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=a;DTb(d,i)}if((f[z>>2]|0)==11?b[(f[(f[a+60>>2]|0)+16>>2]|0)+51>>0]|0:0){B=34;break};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;nEc(l,f[161412+(f[D>>2]<<2)>>2]|0)|0;vEc(l,32);F=l}while(0);if((B|0)==34){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;F=l}D=m+4|0;d=m+20|0;A=d;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));A=m+56|0;b[A>>0]=b[g>>0]|0;b[A+1>>0]=b[g+1>>0]|0;b[A+2>>0]=b[g+2>>0]|0;A=m+60|0;fEc(A,j);if(!(b[g>>0]|0))G=0;else G=BWb(a,D)|0;b[m>>0]=G&1;CWb(m,e);G=j+11|0;D=b[G>>0]|0;C=D<<24>>24<0;f[n>>2]=C?f[j>>2]|0:j;f[n+4>>2]=C?f[j+4>>2]|0:D&255;D=l+11|0;C=b[D>>0]|0;E=C<<24>>24<0;f[o>>2]=E?f[l>>2]|0:F;f[o+4>>2]=E?f[l+4>>2]|0:C&255;C=k+11|0;E=b[C>>0]|0;F=E<<24>>24<0;f[p>>2]=F?f[k>>2]|0:k;f[p+4>>2]=F?f[k+4>>2]|0:E&255;E=f[y>>2]|0;if(E|0?(f[E>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=a;DTb(E,i)}if((f[z>>2]|0)==10){E=f[y>>2]|0;if(E|0?(f[E>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=a;DTb(E,i)}H=f[a+60>>2]|0}else H=a;E=f[H>>2]|0;H=b[E+11>>0]|0;F=H<<24>>24<0;f[q>>2]=F?f[E>>2]|0:E;f[q+4>>2]=F?f[E+4>>2]|0:H&255;H=amc(f[a+40>>2]|0,i+8|0)|0;f[i>>2]=H;E=Mpc(H)|0;f[i+4>>2]=E;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;Khc(e,480788,n,o,p,q,i,r,s,t,v,w);if(!(b[a+36>>0]|0))I=0;else{DWb(n,a,1);E=n+11|0;H=b[E>>0]|0;F=H<<24>>24<0;f[i>>2]=F?f[n>>2]|0:n;f[i+4>>2]=F?f[n+4>>2]|0:H&255;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;f[x>>2]=0;f[x+4>>2]=-1;Khc(e,480803,i,o,p,q,r,s,t,v,w,x);if((b[E>>0]|0)<0)YDc(f[n>>2]|0);I=1}if(!(b[a+37>>0]|0))J=I;else{if(I)uEc(e,518069)|0;else uEc(e,501906)|0;uEc(e,480818)|0;_lc(i,f[a+16>>2]|0);I=i+11|0;E=b[I>>0]|0;x=E<<24>>24<0;tEc(e,x?f[i>>2]|0:i,x?f[i+4>>2]|0:E&255)|0;if((b[I>>0]|0)<0)YDc(f[i>>2]|0);uEc(e,501908)|0;J=1};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;if(!(EWb(c,f[a+68>>2]|0,f[(f[a+20>>2]|0)+8>>2]|0,n)|0)){if(J)B=61}else{uEc(e,J?518069:517839)|0;J=b[n+11>>0]|0;I=J<<24>>24<0;tEc(e,I?f[n>>2]|0:n,I?f[n+4>>2]|0:J&255)|0;B=61}if((B|0)==61)uEc(e,517894)|0;B=f[y>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=a;DTb(B,i)}do if((f[z>>2]|0)==10){if(b[g+1>>0]|0){uEc(e,480832)|0;break}B=f[y>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=a;DTb(B,i)}FWb(f[a+60>>2]|0,c,e,g,0)}else uEc(e,480843)|0;while(0);GWb(m,e);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if((b[A+11>>0]|0)<0)YDc(f[A>>2]|0);A=m+44|0;n=f[A>>2]|0;if(n|0){e=m+48|0;g=f[e>>2]|0;if((g|0)==(n|0))K=n;else{c=g;while(1){g=c+-12|0;f[e>>2]=g;if((b[g+11>>0]|0)<0){YDc(f[g>>2]|0);L=f[e>>2]|0}else L=g;if((L|0)==(n|0))break;else c=L}K=f[A>>2]|0}YDc(K)}K=m+32|0;if((b[K+11>>0]|0)<0)YDc(f[K>>2]|0);if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);if((b[D>>0]|0)<0)YDc(f[l>>2]|0);if((b[C>>0]|0)<0)YDc(f[k>>2]|0);if((b[G>>0]|0)>=0){u=h;return}YDc(f[j>>2]|0);u=h;return}function AWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=c+24|0;h=f[g>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=c;DTb(h,e)}h=c+28|0;switch(f[h>>2]|0){case 11:{i=f[g>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=c;DTb(i,e)}VHa(a,518136,f[(f[c+60>>2]|0)+4>>2]|0);u=d;return}case 14:{i=f[g>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=c;DTb(i,e)}VHa(a,518136,f[(f[c+64>>2]|0)+4>>2]|0);u=d;return}default:{i=f[g>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=c;DTb(i,e)}e=f[161292+(f[h>>2]<<2)>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=Mpc(e)|0;if(h>>>0>4294967279)dEc(a);if(h>>>0<11){b[a+11>>0]=h;if(!h)j=a;else{k=a;l=21}}else{i=h+16&-16;c=VDc(i)|0;f[a>>2]=c;f[a+8>>2]=i|-2147483648;f[a+4>>2]=h;k=c;l=21}if((l|0)==21){dJc(k|0,e|0,h|0)|0;j=k}b[j+h>>0]=0;u=d;return}}}function BWb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;cXb(a,d);g=PWb(f[a+20>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);u=c;return g|0}function CWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;if(!(b[a>>0]|0)){u=d;return}g=a+44|0;h=a+48|0;i=f[g>>2]|0;if((f[h>>2]|0)!=(i|0)){j=e+11|0;k=e+4|0;l=0;m=i;do{HWb(e,a,m+(l*12|0)|0);i=b[j>>0]|0;n=i<<24>>24<0;tEc(c,n?f[e>>2]|0:e,n?f[k>>2]|0:i&255)|0;if((b[j>>0]|0)<0)YDc(f[e>>2]|0);uEc(c,502002)|0;l=l+1|0;m=f[g>>2]|0}while(l>>>0<(((f[h>>2]|0)-m|0)/12|0)>>>0)}m=a+20|0;h=b[m+11>>0]|0;if(h<<24>>24<0)o=f[a+24>>2]|0;else o=h&255;if(!o){u=d;return}HWb(e,a,m);m=e+11|0;a=b[m>>0]|0;o=a<<24>>24<0;tEc(c,o?f[e>>2]|0:e,o?f[e+4>>2]|0:a&255)|0;if((b[m>>0]|0)<0)YDc(f[e>>2]|0);u=d;return}function DWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+24|0;j=e+40|0;k=e+105|0;l=e;m=e+104|0;if(!(b[c+36>>0]|0)){rTb(h,3,475801,1934);oTb(e+106|0,mTb(mTb(h,481308)|0,481344)|0);sTb(h)}h=c+24|0;o=f[h>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(o,g)}o=c+28|0;do switch(f[161216+(f[o>>2]<<2)>>2]|0){case 1:{emc(a,f[c+80>>2]|0);u=e;return}case 2:{q=c+80|0;gmc(a,f[q>>2]|0,f[q+4>>2]|0);u=e;return}case 3:{fmc(a,f[c+80>>2]|0);u=e;return}case 4:{q=c+80|0;hmc(a,f[q>>2]|0,f[q+4>>2]|0);u=e;return}case 6:{kmc(a,+n[c+80>>2]);u=e;return}case 5:{imc(a,+p[c+80>>3]);u=e;return}case 7:{q=(b[c+80>>0]|0)!=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=q?4:5;b[a+11>>0]=r;dJc(a|0,(q?519053:519047)|0,r|0)|0;b[a+r>>0]=0;u=e;return}case 9:{if(d){_lc(i,f[c+80>>2]|0);VHa(g,501908,i);jIa(a,g,501908);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=e;return}r=f[h>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(r,g)}r=f[c+80>>2]|0;if((f[o>>2]|0)==12){_lc(a,r);u=e;return}else{fEc(a,r);u=e;return}break}case 8:{r=f[h>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(r,g)}fEc(a,f[f[c+80>>2]>>2]|0);u=e;return}case 10:{rTb(j,2,475801,1972);oTb(k,mTb(j,481361)|0);sTb(j);break}default:{}}while(0);rTb(l,3,475801,1975);oTb(m,mTb(l,481397)|0);sTb(l);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;u=e;return}function EWb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+64|0;h=g+24|0;i=g+12|0;j=g;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;if(aXb(a,c,d,i)|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=f[i>>2]|0;c=f[k>>2]|0;if((d|0)==(c|0)){l=j+11|0;m=j;n=0;o=0;p=0}else{a=h+4|0;q=d;do{if((q|0)!=(d|0))uEc(j,518069)|0;r=b[q+11>>0]|0;s=r<<24>>24<0;f[h>>2]=s?f[q>>2]|0:q;f[a>>2]=s?f[q+4>>2]|0:r&255;qmc(j,h);q=q+12|0}while((q|0)!=(c|0));c=j+11|0;l=c;m=j;n=b[c>>0]|0;o=f[j>>2]|0;p=f[j+4>>2]|0}c=n<<24>>24<0;tEc(e,c?o:j,c?p:n&255)|0;if((b[l>>0]|0)<0)YDc(f[m>>2]|0)}m=f[i>>2]|0;l=f[k>>2]|0;n=(m|0)!=(l|0);if(!m){u=g;return n|0}if((l|0)==(m|0))t=m;else{p=l;while(1){l=p+-12|0;f[k>>2]=l;if((b[l+11>>0]|0)<0){YDc(f[l>>2]|0);v=f[k>>2]|0}else v=l;if((v|0)==(m|0))break;else p=v}t=f[i>>2]|0}YDc(t);u=g;return n|0}function FWb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;h=u;u=u+576|0;i=h+528|0;j=h+512|0;k=h+440|0;l=h+400|0;m=h+360|0;n=h+320|0;o=h+280|0;p=h+240|0;q=h+200|0;r=h+160|0;s=h+120|0;t=h+80|0;v=h+40|0;w=h;x=a+16|0;if(b[(f[x>>2]|0)+51>>0]|0){u=h;return}y=c<<1;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(y>>>0>4294967279)dEc(j);if(y>>>0<11){b[j+11>>0]=y;if(!c)z=j;else{A=j;B=7}}else{C=y+16&-16;D=VDc(C)|0;f[j>>2]=D;f[j+8>>2]=C|-2147483648;f[j+4>>2]=y;A=D;B=7}if((B|0)==7){XIc(A|0,32,y|0)|0;z=A}b[z+y>>0]=0;y=c+1|0;z=k+4|0;A=k+20|0;D=A;C=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(C|0));D=k+56|0;b[D>>0]=b[e>>0]|0;b[D+1>>0]=b[e+1>>0]|0;b[D+2>>0]=b[e+2>>0]|0;D=k+60|0;fEc(D,j);if(!(b[e>>0]|0))E=0;else E=IWb(a,z)|0;b[k>>0]=E&1;CWb(k,d);if(g){g=b[j+11>>0]|0;E=g<<24>>24<0;f[i>>2]=E?f[j>>2]|0:j;f[i+4>>2]=E?f[j+4>>2]|0:g&255;g=f[a>>2]|0;E=b[g+11>>0]|0;z=E<<24>>24<0;f[l>>2]=z?f[g>>2]|0:g;f[l+4>>2]=z?f[g+4>>2]|0:E&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;Khc(d,480855,i,l,m,n,o,p,q,r,s,t)}uEc(d,501902)|0;JWb(y,f[x>>2]|0,f[(f[a+8>>2]|0)+8>>2]|0,d)|0;x=l+4|0;f[x>>2]=0;E=l+8|0;f[E>>2]=0;g=l+4|0;f[l>>2]=g;z=a+52|0;if((f[z>>2]|0)>0){C=a+20|0;F=i+4|0;G=i+8|0;H=i+12|0;I=i+4|0;J=i+8|0;K=i+12|0;L=0;do{M=f[C>>2]|0;N=M+(L*88|0)|0;O=f[M+(L*88|0)+24>>2]|0;if(O|0?(f[O>>2]|0)!=2:0){f[i>>2]=78728;f[I>>2]=1737;b[J>>0]=0;f[K>>2]=N;DTb(O,i)}if((f[M+(L*88|0)+28>>2]|0)==10){M=f[C>>2]|0;O=M+(L*88|0)|0;N=f[M+(L*88|0)+24>>2]|0;if(N|0?(f[N>>2]|0)!=2:0){f[i>>2]=78728;f[F>>2]=1737;b[G>>0]=0;f[H>>2]=O;DTb(N,i)}N=f[M+(L*88|0)+60>>2]|0;M=N;O=f[g>>2]|0;do if(O){P=x;Q=O;while(1){R=f[Q+16>>2]|0;if(N>>>0<R>>>0){S=f[Q>>2]|0;if(!S){B=27;break}else{T=Q;U=S}}else{if(R>>>0>=N>>>0){B=31;break}V=Q+4|0;R=f[V>>2]|0;if(!R){B=30;break}else{T=V;U=R}}P=T;Q=U}if((B|0)==27){B=0;W=Q;X=Q;break}else if((B|0)==30){B=0;W=V;X=Q;break}else if((B|0)==31){B=0;W=P;X=Q;break}}else{W=g;X=g}while(0);if(!(f[W>>2]|0)){N=VDc(20)|0;f[N+16>>2]=M;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=X;f[W>>2]=N;O=f[f[l>>2]>>2]|0;if(!O)Y=N;else{f[l>>2]=O;Y=f[W>>2]|0}laa(f[x>>2]|0,Y);f[E>>2]=(f[E>>2]|0)+1}}L=L+1|0}while((L|0)<(f[z>>2]|0))}L=a+72|0;if((f[L>>2]|0)>0){Y=a+40|0;W=i+4|0;X=i+8|0;V=i+12|0;U=i+4|0;T=i+8|0;H=i+12|0;G=0;do{F=f[Y>>2]|0;C=F+(G*88|0)|0;K=f[F+(G*88|0)+24>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[i>>2]=78728;f[U>>2]=1737;b[T>>0]=0;f[H>>2]=C;DTb(K,i)}if((f[F+(G*88|0)+28>>2]|0)==10){F=f[Y>>2]|0;K=F+(G*88|0)|0;C=f[F+(G*88|0)+24>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[i>>2]=78728;f[W>>2]=1737;b[X>>0]=0;f[V>>2]=K;DTb(C,i)}C=f[F+(G*88|0)+60>>2]|0;F=C;K=f[g>>2]|0;do if(K){J=x;I=K;while(1){O=f[I+16>>2]|0;if(C>>>0<O>>>0){N=f[I>>2]|0;if(!N){B=50;break}else{Z=I;_=N}}else{if(O>>>0>=C>>>0){B=54;break}$=I+4|0;O=f[$>>2]|0;if(!O){B=53;break}else{Z=$;_=O}}J=Z;I=_}if((B|0)==50){B=0;aa=I;ba=I;break}else if((B|0)==53){B=0;aa=$;ba=I;break}else if((B|0)==54){B=0;aa=J;ba=I;break}}else{aa=g;ba=g}while(0);if(!(f[aa>>2]|0)){C=VDc(20)|0;f[C+16>>2]=F;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=ba;f[aa>>2]=C;K=f[f[l>>2]>>2]|0;if(!K)ca=C;else{f[l>>2]=K;ca=f[aa>>2]|0}laa(f[x>>2]|0,ca);f[E>>2]=(f[E>>2]|0)+1}}G=G+1|0}while((G|0)<(f[L>>2]|0))}G=a+60|0;E=f[G>>2]|0;if((E|0)>0){ca=a+28|0;x=0;aa=E;while(1){E=(f[ca>>2]|0)+(x*88|0)|0;ba=f[g>>2]|0;a:do if(!ba)B=68;else{$=ba;while(1){_=f[$+16>>2]|0;if(E>>>0<_>>>0)da=$;else{if(_>>>0>=E>>>0){ea=aa;break a}da=$+4|0}$=f[da>>2]|0;if(!$){B=68;break}}}while(0);if((B|0)==68){B=0;FWb(E,y,d,e,1);ea=f[G>>2]|0}x=x+1|0;if((x|0)>=(ea|0))break;else aa=ea}}ea=a+64|0;if((f[ea>>2]|0)>0){aa=a+32|0;x=0;do{KWb((f[aa>>2]|0)+(x*48|0)|0,y,d,e);x=x+1|0}while((x|0)<(f[ea>>2]|0))}if((f[z>>2]|0)>0){ea=a+20|0;x=0;do{aa=f[ea>>2]|0;G=aa+(x*88|0)|0;B=f[aa+(x*88|0)+52>>2]|0;if(B){if((f[f[B+20>>2]>>2]|0)==(G|0))LWb(B,y,d,e)}else zWb(G,y,0,d,e);x=x+1|0}while((x|0)<(f[z>>2]|0))}z=a+68|0;if((f[z>>2]|0)>0){x=j+11|0;y=i+4|0;ea=j+4|0;G=a+36|0;B=m+8|0;aa=m+4|0;da=n+8|0;ca=n+4|0;ba=o+4|0;F=p+4|0;$=q+4|0;I=r+4|0;J=s+4|0;_=t+4|0;Z=v+4|0;V=0;do{X=b[x>>0]|0;W=X<<24>>24<0;f[i>>2]=W?f[j>>2]|0:j;f[y>>2]=W?f[ea>>2]|0:X&255;X=amc(f[(f[G>>2]|0)+(V*12|0)>>2]|0,B)|0;f[m>>2]=X;W=Mpc(X)|0;f[aa>>2]=W;W=amc((f[(f[G>>2]|0)+(V*12|0)+4>>2]|0)+-1|0,da)|0;f[n>>2]=W;X=Mpc(W)|0;f[ca>>2]=X;f[o>>2]=0;f[ba>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[$>>2]=-1;f[r>>2]=0;f[I>>2]=-1;f[s>>2]=0;f[J>>2]=-1;f[t>>2]=0;f[_>>2]=-1;f[v>>2]=0;f[Z>>2]=-1;Khc(d,480868,i,m,n,o,p,q,r,s,t,v);V=V+1|0}while((V|0)<(f[z>>2]|0))}if((f[L>>2]|0)>0){z=a+40|0;V=c+2|0;c=j+11|0;Z=i+4|0;_=j+4|0;J=m+4|0;I=n+4|0;$=o+4|0;F=p+4|0;ba=q+4|0;ca=r+4|0;da=s+4|0;G=t+4|0;aa=v+4|0;B=i+4|0;ea=m+4|0;y=n+4|0;x=o+4|0;X=p+4|0;W=q+4|0;Y=r+4|0;H=s+4|0;T=t+4|0;U=v+4|0;K=0;C=0;while(1){M=f[z>>2]|0;Q=f[M+(K*88|0)+48>>2]|0;if((Q|0)==(C|0)){fa=C;ga=M}else{if((K|0)>0){M=b[c>>0]|0;P=M<<24>>24<0;f[i>>2]=P?f[j>>2]|0:j;f[Z>>2]=P?f[_>>2]|0:M&255;f[m>>2]=0;f[J>>2]=-1;f[n>>2]=0;f[I>>2]=-1;f[o>>2]=0;f[$>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[ba>>2]=-1;f[r>>2]=0;f[ca>>2]=-1;f[s>>2]=0;f[da>>2]=-1;f[t>>2]=0;f[G>>2]=-1;f[v>>2]=0;f[aa>>2]=-1;Khc(d,480894,i,m,n,o,p,q,r,s,t,v);ha=f[(f[z>>2]|0)+(K*88|0)+48>>2]|0}else ha=Q;Q=b[c>>0]|0;M=Q<<24>>24<0;f[i>>2]=M?f[j>>2]|0:j;f[B>>2]=M?f[_>>2]|0:Q&255;Q=f[ha+4>>2]|0;M=b[Q+11>>0]|0;P=M<<24>>24<0;f[m>>2]=P?f[Q>>2]|0:Q;f[ea>>2]=P?f[Q+4>>2]|0:M&255;f[n>>2]=0;f[y>>2]=-1;f[o>>2]=0;f[x>>2]=-1;f[p>>2]=0;f[X>>2]=-1;f[q>>2]=0;f[W>>2]=-1;f[r>>2]=0;f[Y>>2]=-1;f[s>>2]=0;f[H>>2]=-1;f[t>>2]=0;f[T>>2]=-1;f[v>>2]=0;f[U>>2]=-1;Khc(d,480901,i,m,n,o,p,q,r,s,t,v);fa=ha;ga=f[z>>2]|0}zWb(ga+(K*88|0)|0,V,0,d,e);K=K+1|0;ia=f[L>>2]|0;if((K|0)>=(ia|0))break;else C=fa}if((ia|0)>0){ia=b[j+11>>0]|0;fa=ia<<24>>24<0;f[i>>2]=fa?f[j>>2]|0:j;f[i+4>>2]=fa?f[j+4>>2]|0:ia&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;Khc(d,480894,i,m,n,o,p,q,r,s,t,v)}}ia=a+76|0;if((f[ia>>2]|0)>0){fa=b[j+11>>0]|0;C=fa<<24>>24<0;f[i>>2]=C?f[j>>2]|0:j;f[i+4>>2]=C?f[j+4>>2]|0:fa&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;Khc(d,480919,i,m,n,o,p,q,r,s,t,v);if((f[ia>>2]|0)>0){fa=a+44|0;C=i+8|0;K=i+4|0;L=m+4|0;e=n+4|0;V=o+4|0;ga=p+4|0;z=q+4|0;ha=r+4|0;U=s+4|0;T=t+4|0;H=v+4|0;Y=i+8|0;W=i+4|0;X=m+8|0;x=m+4|0;y=n+4|0;ea=o+4|0;_=p+4|0;B=q+4|0;c=r+4|0;aa=s+4|0;G=t+4|0;da=v+4|0;ca=0;do{ba=f[fa>>2]|0;F=ba+(ca<<3)+4|0;$=f[ba+(ca<<3)>>2]|0;if((f[F>>2]|0)==($+1|0)){ba=amc($,C)|0;f[i>>2]=ba;I=Mpc(ba)|0;f[K>>2]=I;f[m>>2]=0;f[L>>2]=-1;f[n>>2]=0;f[e>>2]=-1;f[o>>2]=0;f[V>>2]=-1;f[p>>2]=0;f[ga>>2]=-1;f[q>>2]=0;f[z>>2]=-1;f[r>>2]=0;f[ha>>2]=-1;f[s>>2]=0;f[U>>2]=-1;f[t>>2]=0;f[T>>2]=-1;f[v>>2]=0;f[H>>2]=-1;Khc(d,480933,i,m,n,o,p,q,r,s,t,v)}else{I=amc($,Y)|0;f[i>>2]=I;$=Mpc(I)|0;f[W>>2]=$;$=amc((f[F>>2]|0)+-1|0,X)|0;f[m>>2]=$;F=Mpc($)|0;f[x>>2]=F;f[n>>2]=0;f[y>>2]=-1;f[o>>2]=0;f[ea>>2]=-1;f[p>>2]=0;f[_>>2]=-1;f[q>>2]=0;f[B>>2]=-1;f[r>>2]=0;f[c>>2]=-1;f[s>>2]=0;f[aa>>2]=-1;f[t>>2]=0;f[G>>2]=-1;f[v>>2]=0;f[da>>2]=-1;Khc(d,480938,i,m,n,o,p,q,r,s,t,v)}ca=ca+1|0}while((ca|0)<(f[ia>>2]|0))}ia=b[d+11>>0]|0;if(ia<<24>>24<0)ja=f[d+4>>2]|0;else ja=ia&255;AEc(d,ja+-2|0,2,480843)|0}ja=a+80|0;if((f[ja>>2]|0)>0){ia=j+11|0;ca=b[ia>>0]|0;da=ca<<24>>24<0;f[i>>2]=da?f[j>>2]|0:j;G=j+4|0;f[i+4>>2]=da?f[G>>2]|0:ca&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;Khc(d,480919,i,m,n,o,p,q,r,s,t,v);if((f[ja>>2]|0)>0){ca=a+48|0;a=m+11|0;da=i+4|0;aa=m+4|0;c=n+4|0;B=o+4|0;_=p+4|0;ea=q+4|0;y=r+4|0;x=s+4|0;X=t+4|0;W=v+4|0;Y=w+4|0;H=0;do{_lc(m,f[(f[ca>>2]|0)+(H<<2)>>2]|0);T=b[a>>0]|0;U=T<<24>>24<0;f[i>>2]=U?f[m>>2]|0:m;f[da>>2]=U?f[aa>>2]|0:T&255;f[n>>2]=0;f[c>>2]=-1;f[o>>2]=0;f[B>>2]=-1;f[p>>2]=0;f[_>>2]=-1;f[q>>2]=0;f[ea>>2]=-1;f[r>>2]=0;f[y>>2]=-1;f[s>>2]=0;f[x>>2]=-1;f[t>>2]=0;f[X>>2]=-1;f[v>>2]=0;f[W>>2]=-1;f[w>>2]=0;f[Y>>2]=-1;Khc(d,480949,i,n,o,p,q,r,s,t,v,w);if((b[a>>0]|0)<0)YDc(f[m>>2]|0);H=H+1|0}while((H|0)<(f[ja>>2]|0))}ja=b[d+11>>0]|0;if(ja<<24>>24<0)ka=f[d+4>>2]|0;else ka=ja&255;AEc(d,ka+-2|0,2,480843)|0;la=ia;ma=j;na=G}else{la=j+11|0;ma=j;na=j+4|0}G=b[la>>0]|0;ia=G<<24>>24<0;f[i>>2]=ia?f[ma>>2]|0:j;f[i+4>>2]=ia?f[na>>2]|0:G&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;Khc(d,480956,i,m,n,o,p,q,r,s,t,v);GWb(k,d);MWb(l,f[g>>2]|0);if((b[D+11>>0]|0)<0)YDc(f[D>>2]|0);D=k+44|0;g=f[D>>2]|0;if(g|0){l=k+48|0;d=f[l>>2]|0;if((d|0)==(g|0))oa=g;else{v=d;while(1){d=v+-12|0;f[l>>2]=d;if((b[d+11>>0]|0)<0){YDc(f[d>>2]|0);pa=f[l>>2]|0}else pa=d;if((pa|0)==(g|0))break;else v=pa}oa=f[D>>2]|0}YDc(oa)}oa=k+32|0;if((b[oa+11>>0]|0)<0)YDc(f[oa>>2]|0);if((b[A+11>>0]|0)<0)YDc(f[A>>2]|0);if((b[la>>0]|0)<0)YDc(f[ma>>2]|0);u=h;return}function GWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;if(!(b[a>>0]|0)){u=d;return}g=a+32|0;h=b[g+11>>0]|0;if(h<<24>>24<0)i=f[a+36>>2]|0;else i=h&255;if(!i){u=d;return}HWb(e,a,g);g=e+11|0;a=b[g>>0]|0;i=a<<24>>24<0;tEc(c,i?f[e>>2]|0:e,i?f[e+4>>2]|0:a&255)|0;if((b[g>>0]|0)<0)YDc(f[e>>2]|0);u=d;return}function HWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+432|0;g=e+412|0;h=e+400|0;i=e+360|0;j=e+320|0;k=e+280|0;l=e+240|0;m=e+200|0;n=e+160|0;o=e+120|0;p=e+80|0;q=e+40|0;r=e;fEc(g,d);Vlc(g);f[h>>2]=0;d=h+4|0;f[d>>2]=0;f[h+8>>2]=0;Wlc(g,502002,h);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;s=f[d>>2]|0;t=f[h>>2]|0;v=t;if((s|0)==(t|0)){w=s;x=v}else{s=c+60|0;t=s+11|0;y=i+4|0;z=c+64|0;c=j+4|0;A=k+4|0;B=l+4|0;C=m+4|0;D=n+4|0;E=o+4|0;F=p+4|0;G=q+4|0;H=r+4|0;I=0;J=v;while(1){v=J+(I*12|0)|0;K=b[t>>0]|0;L=K<<24>>24<0;f[i>>2]=L?f[s>>2]|0:s;f[y>>2]=L?f[z>>2]|0:K&255;K=b[v+11>>0]|0;L=K<<24>>24<0;f[j>>2]=L?f[v>>2]|0:v;f[c>>2]=L?f[J+(I*12|0)+4>>2]|0:K&255;f[k>>2]=0;f[A>>2]=-1;f[l>>2]=0;f[B>>2]=-1;f[m>>2]=0;f[C>>2]=-1;f[n>>2]=0;f[D>>2]=-1;f[o>>2]=0;f[E>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[G>>2]=-1;f[r>>2]=0;f[H>>2]=-1;Khc(a,480846,i,j,k,l,m,n,o,p,q,r);I=I+1|0;K=f[d>>2]|0;L=f[h>>2]|0;v=L;if(I>>>0>=((K-L|0)/12|0)>>>0){w=K;x=v;break}else J=v}}J=w;if(x|0){if((J|0)==(x|0))M=x;else{w=J;while(1){J=w+-12|0;f[d>>2]=J;if((b[J+11>>0]|0)<0){YDc(f[J>>2]|0);N=f[d>>2]|0}else N=J;if((N|0)==(x|0))break;else w=N}M=f[h>>2]|0}YDc(M)}if((b[g+11>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function IWb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;OWb(a,d);g=PWb(f[a+8>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);u=c;return g|0}function JWb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;g=u;u=u+432|0;h=g+412|0;i=g+400|0;j=g+360|0;k=g+320|0;l=g+280|0;m=g+240|0;n=g+200|0;o=g+160|0;p=g+120|0;q=g+80|0;r=g+40|0;s=g;t=a<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(t>>>0>4294967279)dEc(h);if(t>>>0<11){b[h+11>>0]=t;if(!a)v=h;else{w=h;x=6}}else{y=t+16&-16;z=VDc(y)|0;f[h>>2]=z;f[h+8>>2]=y|-2147483648;f[h+4>>2]=t;w=z;x=6}if((x|0)==6){XIc(w|0,32,t|0)|0;v=w}b[v+t>>0]=0;f[i>>2]=0;t=i+4|0;f[t>>2]=0;f[i+8>>2]=0;if(aXb(a,c,d,i)|0){d=f[t>>2]|0;c=f[i>>2]|0;a=c;if((d|0)==(c|0)){A=a;B=d}else{d=h+11|0;c=j+4|0;v=h+4|0;w=k+4|0;x=l+4|0;z=m+4|0;y=n+4|0;C=o+4|0;D=p+4|0;E=q+4|0;F=r+4|0;G=s+4|0;H=0;I=a;do{a=b[d>>0]|0;J=a<<24>>24<0;f[j>>2]=J?f[h>>2]|0:h;f[c>>2]=J?f[v>>2]|0:a&255;a=I+(H*12|0)|0;J=b[a+11>>0]|0;K=J<<24>>24<0;f[k>>2]=K?f[a>>2]|0:a;f[w>>2]=K?f[I+(H*12|0)+4>>2]|0:J&255;f[l>>2]=0;f[x>>2]=-1;f[m>>2]=0;f[z>>2]=-1;f[n>>2]=0;f[y>>2]=-1;f[o>>2]=0;f[C>>2]=-1;f[p>>2]=0;f[D>>2]=-1;f[q>>2]=0;f[E>>2]=-1;f[r>>2]=0;f[F>>2]=-1;f[s>>2]=0;f[G>>2]=-1;Khc(e,481250,j,k,l,m,n,o,p,q,r,s);H=H+1|0;L=f[t>>2]|0;J=f[i>>2]|0;I=J}while(H>>>0<((L-J|0)/12|0)>>>0);A=I;B=L}}else{A=f[i>>2]|0;B=f[t>>2]|0}if(A|0){if((B|0)==(A|0))M=A;else{L=B;while(1){I=L+-12|0;f[t>>2]=I;if((b[I+11>>0]|0)<0){YDc(f[I>>2]|0);N=f[t>>2]|0}else N=I;if((N|0)==(A|0))break;else L=N}M=f[i>>2]|0}YDc(M)}M=(A|0)!=(B|0);if((b[h+11>>0]|0)>=0){u=g;return M|0}YDc(f[h>>2]|0);u=g;return M|0}function KWb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;g=u;u=u+528|0;h=g+512|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;n=g+240|0;o=g+200|0;p=g+160|0;q=g+120|0;r=g+80|0;s=g+40|0;t=g;v=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(v>>>0>4294967279)dEc(h);if(v>>>0<11){b[h+11>>0]=v;if(!c)w=h;else{x=h;y=6}}else{z=v+16&-16;A=VDc(z)|0;f[h>>2]=A;f[h+8>>2]=z|-2147483648;f[h+4>>2]=v;x=A;y=6}if((y|0)==6){XIc(x|0,32,v|0)|0;w=x}b[w+v>>0]=0;v=c+1|0;c=i+4|0;w=i+20|0;x=w;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));x=i+56|0;b[x>>0]=b[e>>0]|0;b[x+1>>0]=b[e+1>>0]|0;b[x+2>>0]=b[e+2>>0]|0;x=i+60|0;fEc(x,h);if(!(b[e>>0]|0))B=0;else B=YWb(a,c)|0;b[i>>0]=B&1;CWb(i,d);B=h+11|0;c=b[B>>0]|0;y=c<<24>>24<0;f[j>>2]=y?f[h>>2]|0:h;A=h+4|0;f[j+4>>2]=y?f[A>>2]|0:c&255;c=f[a>>2]|0;y=b[c+11>>0]|0;z=y<<24>>24<0;f[k>>2]=z?f[c>>2]|0:c;f[k+4>>2]=z?f[c+4>>2]|0:y&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Khc(d,481221,j,k,l,m,n,o,p,q,r,s);JWb(v,f[a+16>>2]|0,f[(f[a+8>>2]|0)+8>>2]|0,d)|0;y=a+24|0;if((f[y>>2]|0)>0){c=a+28|0;z=0;do{ZWb((f[c>>2]|0)+(z*20|0)|0,v,d,e);z=z+1|0}while((z|0)<(f[y>>2]|0))}y=a+32|0;if((f[y>>2]|0)>0){z=b[B>>0]|0;e=z<<24>>24<0;f[j>>2]=e?f[h>>2]|0:h;f[j+4>>2]=e?f[A>>2]|0:z&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Khc(d,480919,j,k,l,m,n,o,p,q,r,s);if((f[y>>2]|0)>0){z=a+40|0;e=j+8|0;v=j+4|0;c=k+4|0;C=l+4|0;D=m+4|0;E=n+4|0;F=o+4|0;G=p+4|0;H=q+4|0;I=r+4|0;J=s+4|0;K=j+8|0;L=j+4|0;M=k+8|0;N=k+4|0;O=l+4|0;P=m+4|0;Q=n+4|0;R=o+4|0;S=p+4|0;T=q+4|0;U=r+4|0;V=s+4|0;W=0;do{X=f[z>>2]|0;Y=X+(W<<3)+4|0;Z=f[Y>>2]|0;_=f[X+(W<<3)>>2]|0;if((Z|0)==(_|0)){X=amc(Z,e)|0;f[j>>2]=X;Z=Mpc(X)|0;f[v>>2]=Z;f[k>>2]=0;f[c>>2]=-1;f[l>>2]=0;f[C>>2]=-1;f[m>>2]=0;f[D>>2]=-1;f[n>>2]=0;f[E>>2]=-1;f[o>>2]=0;f[F>>2]=-1;f[p>>2]=0;f[G>>2]=-1;f[q>>2]=0;f[H>>2]=-1;f[r>>2]=0;f[I>>2]=-1;f[s>>2]=0;f[J>>2]=-1;Khc(d,480933,j,k,l,m,n,o,p,q,r,s)}else{Z=amc(_,K)|0;f[j>>2]=Z;_=Mpc(Z)|0;f[L>>2]=_;_=amc(f[Y>>2]|0,M)|0;f[k>>2]=_;Y=Mpc(_)|0;f[N>>2]=Y;f[l>>2]=0;f[O>>2]=-1;f[m>>2]=0;f[P>>2]=-1;f[n>>2]=0;f[Q>>2]=-1;f[o>>2]=0;f[R>>2]=-1;f[p>>2]=0;f[S>>2]=-1;f[q>>2]=0;f[T>>2]=-1;f[r>>2]=0;f[U>>2]=-1;f[s>>2]=0;f[V>>2]=-1;Khc(d,480938,j,k,l,m,n,o,p,q,r,s)}W=W+1|0}while((W|0)<(f[y>>2]|0))}y=b[d+11>>0]|0;if(y<<24>>24<0)$=f[d+4>>2]|0;else $=y&255;AEc(d,$+-2|0,2,480843)|0}$=a+36|0;if((f[$>>2]|0)>0){y=b[B>>0]|0;W=y<<24>>24<0;f[j>>2]=W?f[h>>2]|0:h;f[j+4>>2]=W?f[A>>2]|0:y&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Khc(d,480919,j,k,l,m,n,o,p,q,r,s);if((f[$>>2]|0)>0){y=a+44|0;a=k+11|0;W=j+4|0;V=k+4|0;U=l+4|0;T=m+4|0;S=n+4|0;R=o+4|0;Q=p+4|0;P=q+4|0;O=r+4|0;N=s+4|0;M=t+4|0;L=0;do{_lc(k,f[(f[y>>2]|0)+(L<<2)>>2]|0);K=b[a>>0]|0;J=K<<24>>24<0;f[j>>2]=J?f[k>>2]|0:k;f[W>>2]=J?f[V>>2]|0:K&255;f[l>>2]=0;f[U>>2]=-1;f[m>>2]=0;f[T>>2]=-1;f[n>>2]=0;f[S>>2]=-1;f[o>>2]=0;f[R>>2]=-1;f[p>>2]=0;f[Q>>2]=-1;f[q>>2]=0;f[P>>2]=-1;f[r>>2]=0;f[O>>2]=-1;f[s>>2]=0;f[N>>2]=-1;f[t>>2]=0;f[M>>2]=-1;Khc(d,480949,j,l,m,n,o,p,q,r,s,t);if((b[a>>0]|0)<0)YDc(f[k>>2]|0);L=L+1|0}while((L|0)<(f[$>>2]|0))}$=b[d+11>>0]|0;if($<<24>>24<0)aa=f[d+4>>2]|0;else aa=$&255;AEc(d,aa+-2|0,2,480843)|0}aa=b[B>>0]|0;$=aa<<24>>24<0;f[j>>2]=$?f[h>>2]|0:h;f[j+4>>2]=$?f[A>>2]|0:aa&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Khc(d,480956,j,k,l,m,n,o,p,q,r,s);GWb(i,d);if((b[x+11>>0]|0)<0)YDc(f[x>>2]|0);x=i+44|0;d=f[x>>2]|0;if(d|0){s=i+48|0;r=f[s>>2]|0;if((r|0)==(d|0))ba=d;else{q=r;while(1){r=q+-12|0;f[s>>2]=r;if((b[r+11>>0]|0)<0){YDc(f[r>>2]|0);ca=f[s>>2]|0}else ca=r;if((ca|0)==(d|0))break;else q=ca}ba=f[x>>2]|0}YDc(ba)}ba=i+32|0;if((b[ba+11>>0]|0)<0)YDc(f[ba>>2]|0);if((b[w+11>>0]|0)<0)YDc(f[w>>2]|0);if((b[B>>0]|0)>=0){u=g;return}YDc(f[h>>2]|0);u=g;return}function LWb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+496|0;h=g+472|0;i=g+400|0;j=g+360|0;k=g+320|0;l=g+280|0;m=g+240|0;n=g+200|0;o=g+160|0;p=g+120|0;q=g+80|0;r=g+40|0;s=g;t=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(t>>>0>4294967279)dEc(h);if(t>>>0<11){b[h+11>>0]=t;if(!c)v=h;else{w=h;x=6}}else{y=t+16&-16;z=VDc(y)|0;f[h>>2]=z;f[h+8>>2]=y|-2147483648;f[h+4>>2]=t;w=z;x=6}if((x|0)==6){XIc(w|0,32,t|0)|0;v=w}b[v+t>>0]=0;t=c+1|0;c=i+4|0;v=i+20|0;w=v;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));w=i+56|0;b[w>>0]=b[e>>0]|0;b[w+1>>0]=b[e+1>>0]|0;b[w+2>>0]=b[e+2>>0]|0;w=i+60|0;fEc(w,h);if(!(b[e>>0]|0))A=0;else A=NWb(a,c)|0;b[i>>0]=A&1;CWb(i,d);A=h+11|0;c=b[A>>0]|0;x=c<<24>>24<0;f[j>>2]=x?f[h>>2]|0:h;z=h+4|0;f[j+4>>2]=x?f[z>>2]|0:c&255;c=f[a>>2]|0;x=b[c+11>>0]|0;y=x<<24>>24<0;f[k>>2]=y?f[c>>2]|0:c;f[k+4>>2]=y?f[c+4>>2]|0:x&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Khc(d,480961,j,k,l,m,n,o,p,q,r,s);JWb(t,f[a+24>>2]|0,f[(f[(f[a+8>>2]|0)+8>>2]|0)+8>>2]|0,d)|0;if(!(b[e+2>>0]|0)){uEc(d,502002)|0;x=a+16|0;if((f[x>>2]|0)>0){c=a+20|0;a=0;do{zWb(f[(f[c>>2]|0)+(a<<2)>>2]|0,t,1,d,e);a=a+1|0}while((a|0)<(f[x>>2]|0))}x=b[A>>0]|0;a=x<<24>>24<0;f[j>>2]=a?f[h>>2]|0:h;f[j+4>>2]=a?f[z>>2]|0:x&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Khc(d,480956,j,k,l,m,n,o,p,q,r,s)}else uEc(d,480974)|0;GWb(i,d);if((b[w+11>>0]|0)<0)YDc(f[w>>2]|0);w=i+44|0;d=f[w>>2]|0;if(d|0){s=i+48|0;r=f[s>>2]|0;if((r|0)==(d|0))B=d;else{q=r;while(1){r=q+-12|0;f[s>>2]=r;if((b[r+11>>0]|0)<0){YDc(f[r>>2]|0);C=f[s>>2]|0}else C=r;if((C|0)==(d|0))break;else q=C}B=f[w>>2]|0}YDc(B)}B=i+32|0;if((b[B+11>>0]|0)<0)YDc(f[B>>2]|0);if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[A>>0]|0)>=0){u=g;return}YDc(f[h>>2]|0);u=g;return}function MWb(a,b){a=a|0;b=b|0;if(!b)return;else{MWb(a,f[b>>2]|0);MWb(a,f[b+4>>2]|0);YDc(b);return}}function NWb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c+12|0;e=c;f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;h=a+8|0;OWb(f[h>>2]|0,e);i=f[g>>2]|0;j=e+8|0;k=f[j>>2]|0;if((i|0)==(k|0)){g6(e,166476);l=f[g>>2]|0;m=f[j>>2]|0}else{f[i>>2]=f[41619];j=i+4|0;f[g>>2]=j;l=j;m=k}k=f[h>>2]|0;j=(a-(f[k+24>>2]|0)|0)/28|0;f[d>>2]=j;if((l|0)==(m|0)){g6(e,d);n=f[h>>2]|0}else{f[l>>2]=j;f[g>>2]=l+4;n=k}k=PWb(f[n+8>>2]|0,e,b)|0;b=f[e>>2]|0;if(!b){u=c;return k|0}e=f[g>>2]|0;if((e|0)!=(b|0))f[g>>2]=e+(~((e+-4-b|0)>>>2)<<2);YDc(b);u=c;return k|0}function OWb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;if(!g){h=b+4|0;i=f[h>>2]|0;j=b+8|0;if((i|0)==(f[j>>2]|0)){g6(b,166448);k=f[e>>2]|0;l=a;if(!k){m=l;n=d;o=15}else{p=k+28|0;q=l;r=d}}else{f[i>>2]=f[41612];f[h>>2]=i+4;m=a;n=d;o=15}if((o|0)==15){p=(f[a+8>>2]|0)+68|0;q=m;r=n}n=(q-(f[p>>2]|0)|0)/88|0;f[d>>2]=n;p=f[h>>2]|0;if((p|0)==(f[j>>2]|0))g6(b,d);else{f[p>>2]=n;f[h>>2]=p+4}u=c;return}OWb(g,b);g=b+4|0;p=f[g>>2]|0;h=b+8|0;if((p|0)==(f[h>>2]|0))g6(b,166468);else{f[p>>2]=f[41617];f[g>>2]=p+4}p=f[e>>2]|0;if(!p)s=(f[a+8>>2]|0)+68|0;else s=p+28|0;p=(a-(f[s>>2]|0)|0)/88|0;f[d>>2]=p;s=f[g>>2]|0;if((s|0)==(f[h>>2]|0))g6(b,d);else{f[s>>2]=p;f[g>>2]=s+4}u=c;return}function PWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;if(!c){rTb(e,3,480982,166);oTb(g,mTb(e,481073)|0);sTb(e)}j=f[a+92>>2]|0;if(!j){k=0;u=d;return k|0}l=QWb(f[a+88>>2]|0,b,j)|0;if(!l){k=0;u=d;return k|0}j=f[l+32>>2]|0;if((j+-3|0)>>>0>=2){k=0;u=d;return k|0}b=f[l+40>>2]|0;f[c>>2]=f[b+4>>2];f[c+8>>2]=f[b+8>>2];f[c+4>>2]=f[b+4+(((j|0)==3?0:2)<<2)>>2];f[c+12>>2]=f[b+4+(j+-1<<2)>>2];iEc(c+16|0,f[l+64>>2]|0)|0;iEc(c+28|0,f[l+68>>2]|0)|0;j=f[l+60>>2]|0;b=(j|0)==0?0:j+4|0;f[h>>2]=b;f[i>>2]=b+(f[l+52>>2]<<2);f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];RWb(c+40|0,g,e);k=1;u=d;return k|0}function QWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e+24|0;h=e+16|0;i=e;f[h>>2]=a;f[h+4>>2]=d;d=a+136|0;if((f[d>>2]|0)!=2){f[g>>2]=161532;f[g+4>>2]=1775;b[g+8>>0]=0;f[g+12>>2]=h;DTb(d,g)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=f[c>>2]|0;h=f[c+4>>2]|0;if((d|0)!=(h|0)){c=g+8|0;j=g+4|0;k=c;l=d;do{if((l|0)!=(d|0))uEc(i,517915)|0;m=f[l>>2]|0;f[g>>2]=c;n=(cmc(m,c)|0)-k|0;f[j>>2]=n;qmc(i,g);l=l+4|0}while((l|0)!=(h|0))}h=TWb(a+140|0,i)|0;if(!h)o=0;else o=f[h+20>>2]|0;if((b[i+11>>0]|0)>=0){u=e;return o|0}YDc(f[i>>2]|0);u=e;return o|0}function RWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[c>>2]|0;c=f[d>>2]|0;d=c-e>>2;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=e;k=i;l=c;if(d>>>0<=((h-i|0)/12|0)>>>0){m=a+4|0;n=((f[m>>2]|0)-i|0)/12|0;o=d>>>0>n>>>0;p=o?j+(n<<2)|0:c;c=p;if((j|0)==(c|0))q=k;else{n=k;r=e;while(1){iEc(n,f[r>>2]|0)|0;r=r+4|0;s=n+12|0;if((r|0)==(c|0)){q=s;break}else n=s}}if(o){if((c|0)==(l|0))return;c=p;p=f[m>>2]|0;do{fEc(p,f[c>>2]|0);c=c+4|0;p=(f[m>>2]|0)+12|0;f[m>>2]=p}while((c|0)!=(l|0));return}c=f[m>>2]|0;if((c|0)==(q|0))return;else t=c;while(1){c=t+-12|0;f[m>>2]=c;if((b[c+11>>0]|0)<0){YDc(f[c>>2]|0);u=f[m>>2]|0}else u=c;if((u|0)==(q|0))break;else t=u}return}if(!i)v=h;else{h=a+4|0;u=f[h>>2]|0;if((u|0)==(k|0))w=i;else{i=u;while(1){u=i+-12|0;f[h>>2]=u;if((b[u+11>>0]|0)<0){YDc(f[u>>2]|0);x=f[h>>2]|0}else x=u;if((x|0)==(k|0))break;else i=x}w=f[a>>2]|0}YDc(w);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;v=0}if(d>>>0>357913941)mCc(a);h=(v|0)/12|0;v=h<<1;w=h>>>0<178956970?(v>>>0<d>>>0?d:v):357913941;if(w>>>0>357913941)mCc(a);v=VDc(w*12|0)|0;d=a+4|0;f[d>>2]=v;f[a>>2]=v;f[g>>2]=v+(w*12|0);if((j|0)==(l|0))return;j=e;e=v;do{fEc(e,f[j>>2]|0);j=j+4|0;e=(f[d>>2]|0)+12|0;f[d>>2]=e}while((j|0)!=(l|0));return}function SWb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+64|0;d=c+16|0;e=c;g=a+4|0;h=f[g>>2]|0;i=f[h+20>>2]|0;if((i|0)<=0){u=c;return}j=e+11|0;k=d+8|0;l=d+4|0;m=k;n=0;o=h;while(1){h=f[(f[o+28>>2]|0)+4+(n<<2)>>2]|0;p=(f[a>>2]|0)+140|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=f[h+24>>2]|0;r=(q|0)==0;s=r?0:q+4|0;t=r?0:q+4+(f[h+16>>2]<<2)|0;if((s|0)!=(t|0)){q=s;do{if((q|0)!=(s|0))uEc(e,517915)|0;r=f[q>>2]|0;f[d>>2]=k;v=(cmc(r,k)|0)-m|0;f[l>>2]=v;qmc(e,d);q=q+4|0}while((q|0)!=(t|0))}t=UWb(p,e)|0;f[t>>2]=h;if((b[j>>0]|0)<0)YDc(f[e>>2]|0);t=n+1|0;if((t|0)>=(i|0))break;n=t;o=f[g>>2]|0}u=c;return}function TWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(c|0)==(i|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(Arc(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(a|0)==(i|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(Arc(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function UWb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=TWb(a,b)|0;if(!e){g=VDc(24)|0;fEc(g+8|0,b);f[g+20>>2]=0;VWb(d,a,g);h=f[d>>2]|0;i=h+20|0;u=c;return i|0}else{h=e;i=h+20|0;u=c;return i|0}return 0}function VWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0;e=d+8|0;g=b[e+11>>0]|0;h=g<<24>>24<0;i=h?f[e>>2]|0:e;e=b[i>>0]|0;if(!(e<<24>>24))j=0;else{k=i;l=0;m=e;while(1){e=(l*5|0)+(m<<24>>24)|0;k=k+1|0;m=b[k>>0]|0;if(!(m<<24>>24)){j=e;break}else l=e}}l=d+4|0;f[l>>2]=j;m=c+4|0;k=f[m>>2]|0;e=(k|0)==0;a:do if(!e){o=k+-1|0;p=(o&k|0)==0;if(!p)if(j>>>0<k>>>0)q=j;else q=(j>>>0)%(k>>>0)|0;else q=o&j;r=f[(f[c>>2]|0)+(q<<2)>>2]|0;if((r|0)!=0?(s=f[r>>2]|0,(s|0)!=0):0){r=d+12|0;t=g&255;if(p){p=s;b:while(1){if((f[p+4>>2]&o|0)!=(q|0)){u=q;break a}v=p+8|0;w=b[v+11>>0]|0;x=w<<24>>24<0;y=w&255;w=x?f[p+12>>2]|0:y;do if((w|0)==((h?f[r>>2]|0:t)|0)){z=f[v>>2]|0;A=x?z:v;B=(w|0)==0;if(x){if(B){C=0;D=p;E=47;break b}if(!(Arc(A,i,w)|0)){C=0;D=p;E=47;break b}else break}if(B){C=0;D=p;E=47;break b}if((z&255)<<24>>24==(b[i>>0]|0)){z=v;B=y;A=i;do{B=B+-1|0;z=z+1|0;if(!B){C=0;D=p;E=47;break b}A=A+1|0}while((b[z>>0]|0)==(b[A>>0]|0))}}while(0);p=f[p>>2]|0;if(!p){u=q;break a}}if((E|0)==47){F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}}else H=s;c:while(1){p=f[H+4>>2]|0;if(p>>>0<k>>>0)I=p;else I=(p>>>0)%(k>>>0)|0;if((I|0)!=(q|0)){u=q;break a}p=H+8|0;o=b[p+11>>0]|0;y=o<<24>>24<0;v=o&255;o=y?f[H+12>>2]|0:v;do if((o|0)==((h?f[r>>2]|0:t)|0)){w=f[p>>2]|0;x=y?w:p;A=(o|0)==0;if(y){if(A){C=0;D=H;E=47;break c}if(!(Arc(x,i,o)|0)){C=0;D=H;E=47;break c}else break}if(A){C=0;D=H;E=47;break c}if((w&255)<<24>>24==(b[i>>0]|0)){w=p;A=v;x=i;do{A=A+-1|0;w=w+1|0;if(!A){C=0;D=H;E=47;break c}x=x+1|0}while((b[w>>0]|0)==(b[x>>0]|0))}}while(0);H=f[H>>2]|0;if(!H){u=q;break a}}if((E|0)==47){F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}}else u=q}else u=0;while(0);q=c+12|0;J=+(((f[q>>2]|0)+1|0)>>>0);K=+n[c+16>>2];do if(e|J>+(k>>>0)*K){E=(k>>>0<3|(k+-1&k|0)!=0)&1|k<<1;H=~~+X(+(J/K))>>>0;xUb(c,E>>>0<H>>>0?H:E);E=f[m>>2]|0;H=f[l>>2]|0;i=E+-1|0;if(!(i&E)){L=E;M=i&H;break}if(H>>>0<E>>>0){L=E;M=H}else{L=E;M=(H>>>0)%(E>>>0)|0}}else{L=k;M=u}while(0);u=f[(f[c>>2]|0)+(M<<2)>>2]|0;if(!u){k=c+8|0;f[d>>2]=f[k>>2];f[k>>2]=d;f[(f[c>>2]|0)+(M<<2)>>2]=k;k=f[d>>2]|0;if(!k)N=d;else{M=f[k+4>>2]|0;k=L+-1|0;if(k&L)if(M>>>0<L>>>0)O=M;else O=(M>>>0)%(L>>>0)|0;else O=M&k;f[(f[c>>2]|0)+(O<<2)>>2]=d;N=d}}else{f[d>>2]=f[u>>2];f[u>>2]=d;N=d}f[q>>2]=(f[q>>2]|0)+1;C=1;D=N;F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}function WWb(a){a=a|0;YDc(a);return}function XWb(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&2047](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function YWb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;$Wb(a,d);g=PWb(f[a+8>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b);u=c;return g|0}function ZWb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+528|0;h=g+512|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;n=g+240|0;o=g+200|0;p=g+160|0;q=g+120|0;r=g+80|0;s=g+40|0;t=g;v=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(v>>>0>4294967279)dEc(h);if(v>>>0<11){b[h+11>>0]=v;if(!c)w=h;else{x=h;y=6}}else{z=v+16&-16;A=VDc(z)|0;f[h>>2]=A;f[h+8>>2]=z|-2147483648;f[h+4>>2]=v;x=A;y=6}if((y|0)==6){XIc(x|0,32,v|0)|0;w=x}b[w+v>>0]=0;v=i+4|0;w=i+20|0;x=w;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));x=i+56|0;b[x>>0]=b[e>>0]|0;b[x+1>>0]=b[e+1>>0]|0;b[x+2>>0]=b[e+2>>0]|0;x=i+60|0;fEc(x,h);if(!(b[e>>0]|0))B=0;else B=_Wb(a,v)|0;b[i>>0]=B&1;CWb(i,d);B=h+11|0;v=b[B>>0]|0;e=v<<24>>24<0;f[j>>2]=e?f[h>>2]|0:h;f[j+4>>2]=e?f[h+4>>2]|0:v&255;v=f[a>>2]|0;e=b[v+11>>0]|0;y=e<<24>>24<0;f[k>>2]=y?f[v>>2]|0:v;f[k+4>>2]=y?f[v+4>>2]|0:e&255;e=amc(f[a+8>>2]|0,l+8|0)|0;f[l>>2]=e;v=Mpc(e)|0;f[l+4>>2]=v;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Khc(d,481234,j,k,l,m,n,o,p,q,r,s);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(EWb(c,f[a+16>>2]|0,f[(f[(f[a+12>>2]|0)+8>>2]|0)+8>>2]|0,j)|0){a=b[j+11>>0]|0;c=a<<24>>24<0;f[k>>2]=c?f[j>>2]|0:j;f[k+4>>2]=c?f[j+4>>2]|0:a&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;Khc(d,481244,k,l,m,n,o,p,q,r,s,t)}uEc(d,480843)|0;GWb(i,d);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[x+11>>0]|0)<0)YDc(f[x>>2]|0);x=i+44|0;j=f[x>>2]|0;if(j|0){d=i+48|0;t=f[d>>2]|0;if((t|0)==(j|0))C=j;else{s=t;while(1){t=s+-12|0;f[d>>2]=t;if((b[t+11>>0]|0)<0){YDc(f[t>>2]|0);D=f[d>>2]|0}else D=t;if((D|0)==(j|0))break;else s=D}C=f[x>>2]|0}YDc(C)}C=i+32|0;if((b[C+11>>0]|0)<0)YDc(f[C>>2]|0);if((b[w+11>>0]|0)<0)YDc(f[w>>2]|0);if((b[B>>0]|0)>=0){u=g;return}YDc(f[h>>2]|0);u=g;return}function _Wb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c+12|0;e=c;f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;h=a+12|0;$Wb(f[h>>2]|0,e);i=f[g>>2]|0;j=e+8|0;k=f[j>>2]|0;if((i|0)==(k|0)){g6(e,166480);l=f[g>>2]|0;m=f[j>>2]|0}else{f[i>>2]=f[41620];j=i+4|0;f[g>>2]=j;l=j;m=k}k=f[h>>2]|0;j=(a-(f[k+28>>2]|0)|0)/20|0;f[d>>2]=j;if((l|0)==(m|0)){g6(e,d);n=f[h>>2]|0}else{f[l>>2]=j;f[g>>2]=l+4;n=k}k=PWb(f[n+8>>2]|0,e,b)|0;b=f[e>>2]|0;if(!b){u=c;return k|0}e=f[g>>2]|0;if((e|0)!=(b|0))f[g>>2]=e+(~((e+-4-b|0)>>>2)<<2);YDc(b);u=c;return k|0}function $Wb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;if(!g){h=b+4|0;i=f[h>>2]|0;j=b+8|0;if((i|0)==(f[j>>2]|0)){g6(b,166452);k=f[e>>2]|0;l=a;if(!k){m=l;n=d;o=15}else{p=k+32|0;q=l;r=d}}else{f[i>>2]=f[41613];f[h>>2]=i+4;m=a;n=d;o=15}if((o|0)==15){p=(f[a+8>>2]|0)+72|0;q=m;r=n}n=(q-(f[p>>2]|0)|0)/48|0;f[d>>2]=n;p=f[h>>2]|0;if((p|0)==(f[j>>2]|0))g6(b,d);else{f[p>>2]=n;f[h>>2]=p+4}u=c;return}OWb(g,b);g=b+4|0;p=f[g>>2]|0;h=b+8|0;if((p|0)==(f[h>>2]|0))g6(b,166472);else{f[p>>2]=f[41618];f[g>>2]=p+4}p=f[e>>2]|0;if(!p)s=(f[a+8>>2]|0)+72|0;else s=p+32|0;p=(a-(f[s>>2]|0)|0)/48|0;f[d>>2]=p;s=f[g>>2]|0;if((s|0)==(f[h>>2]|0))g6(b,d);else{f[s>>2]=p;f[g>>2]=s+4}u=c;return}function aXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+64|0;h=g+48|0;i=g;j=g+24|0;mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);if((f[(f[(f[h>>2]|0)+8>>2]|0)+8>>2]|0)==(d|0)){k=bXb(a,c,e)|0;u=g;return k|0}mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);RUb(h,f[d+16>>2]|0,d,f[(f[h>>2]|0)+4>>2]|0);d=f[h+4>>2]|0;if((f[h>>2]|0)!=1|(d|0)==0){k=bXb(a,c,e)|0;u=g;return k|0}k9b(i);l=h9b(i,d)|0;d=_i[f[(f[l>>2]|0)+12>>2]&1023](l)|0;RSb(h,c);l=KSb(d,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if(l)m=d;else{rTb(j,2,475801,2297);l=mTb(j,481264)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);oTb(g+60|0,nTb(l,f[(f[h>>2]|0)+4>>2]|0)|0);sTb(j);m=c}c=bXb(a,m,e)|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);f9b(i);k=c;u=g;return k|0}function bXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=u;u=u+96|0;g=e+80|0;h=e+64|0;i=e+52|0;j=e;k=e+40|0;l=f[d>>2]|0;m=d+4|0;n=f[m>>2]|0;if((n|0)!=(l|0)){o=n;while(1){n=o+-12|0;f[m>>2]=n;if((b[n+11>>0]|0)<0){YDc(f[n>>2]|0);p=f[m>>2]|0}else p=n;if((p|0)==(l|0))break;else o=p}}p=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;f[h>>2]=0;o=h+4|0;f[o>>2]=0;f[h+8>>2]=0;Ti[f[(f[p>>2]|0)+64>>2]&511](p,c,h);l=f[o>>2]|0;n=f[h>>2]|0;q=n;if((l|0)==(n|0)){r=l;s=q}else{l=a+1|0;n=g+11|0;t=g+4|0;v=a<<1;a=d+8|0;w=j+11|0;x=k+11|0;y=g+11|0;z=i+11|0;A=j+11|0;B=k+11|0;C=g+4|0;D=g+8|0;E=g+12|0;F=0;G=q;while(1){q=f[G+(F<<2)>>2]|0;if((f[q+32>>2]|0)==3){H=hj[f[(f[p>>2]|0)+24>>2]&511](p,c,q)|0;if((H|0)>0){I=1;J=H;K=14}}else{I=0;J=1;K=14}if((K|0)==14){K=0;H=0;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=f[(f[h>>2]|0)+(F<<2)>>2]|0;L=f[q+24>>2]|0;if(L|0?(f[L>>2]|0)!=2:0){f[g>>2]=78728;f[C>>2]=1737;b[D>>0]=0;f[E>>2]=q;DTb(L,g)}if((f[q+28>>2]|1|0)==11){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;fjc(j);f[j>>2]=l;gjc(j,c,f[(f[h>>2]|0)+(F<<2)>>2]|0,I?H:-1,g);uEc(i,481302)|0;q=b[n>>0]|0;L=q<<24>>24<0;tEc(i,L?f[g>>2]|0:g,L?f[t>>2]|0:q&255)|0;pEc(i,v,32)|0;uEc(i,503084)|0;$hc(j);if((b[n>>0]|0)<0)YDc(f[g>>2]|0)}else hjc(c,f[(f[h>>2]|0)+(F<<2)>>2]|0,I?H:-1,i);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;q=f[(f[h>>2]|0)+(F<<2)>>2]|0;if(b[q+38>>0]|0){VHa(k,481305,f[q+4>>2]|0);jIa(j,k,517845);iEc(g,j)|0;if((b[A>>0]|0)<0)YDc(f[j>>2]|0);if((b[B>>0]|0)<0)YDc(f[k>>2]|0)}else iEc(g,f[q>>2]|0)|0;jIa(k,g,493001);QJa(j,k,i);q=f[m>>2]|0;if((q|0)==(f[a>>2]|0))e1(d,j);else{fEc(q,j);f[m>>2]=(f[m>>2]|0)+12}if((b[w>>0]|0)<0)YDc(f[j>>2]|0);if((b[x>>0]|0)<0)YDc(f[k>>2]|0);if((b[y>>0]|0)<0)YDc(f[g>>2]|0);if((b[z>>0]|0)<0)YDc(f[i>>2]|0);H=H+1|0}while((H|0)<(J|0))}F=F+1|0;H=f[o>>2]|0;q=f[h>>2]|0;L=q;if(F>>>0>=H-q>>2>>>0){r=H;s=L;break}else G=L}}G=r;r=(f[d>>2]|0)!=(f[m>>2]|0);if(!s){u=e;return r|0}if((G|0)!=(s|0))f[o>>2]=G+(~((G+-4-s|0)>>>2)<<2);YDc(s);u=e;return r|0}function cXb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=a+38|0;if(!(b[g>>0]|0)){h=a+48|0;OWb(f[h>>2]|0,c);i=c+4|0;j=f[i>>2]|0;k=c+8|0;if((j|0)==(f[k>>2]|0))g6(c,166460);else{f[j>>2]=f[41615];f[i>>2]=j+4}do if(b[g>>0]|0){j=f[a+56>>2]|0;l=a;if(!j){m=l-(f[(f[a+20>>2]|0)+80>>2]|0)|0;break}else{m=l-(f[j+40>>2]|0)|0;break}}else m=a-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);h=(m|0)/88|0;f[e>>2]=h;m=f[i>>2]|0;if((m|0)==(f[k>>2]|0))g6(c,e);else{f[m>>2]=h;f[i>>2]=m+4}u=d;return}m=a+56|0;i=f[m>>2]|0;if(!i){h=c+4|0;k=f[h>>2]|0;j=c+8|0;if((k|0)==(f[j>>2]|0)){g6(c,166456);if(!(b[g>>0]|0)){n=a-(f[(f[a+48>>2]|0)+20>>2]|0)|0;o=e}else{p=e;q=7}}else{f[k>>2]=f[41614];f[h>>2]=k+4;p=e;q=7}do if((q|0)==7){k=f[m>>2]|0;l=a;if(!k){n=l-(f[(f[a+20>>2]|0)+80>>2]|0)|0;o=p;break}else{n=l-(f[k+40>>2]|0)|0;o=p;break}}while(0);p=(n|0)/88|0;f[e>>2]=p;n=f[h>>2]|0;if((n|0)==(f[j>>2]|0))g6(c,e);else{f[n>>2]=p;f[h>>2]=n+4}u=d;return}OWb(i,c);i=c+4|0;n=f[i>>2]|0;h=c+8|0;if((n|0)==(f[h>>2]|0))g6(c,166464);else{f[n>>2]=f[41616];f[i>>2]=n+4}do if(b[g>>0]|0){n=f[m>>2]|0;p=a;if(!n){r=p-(f[(f[a+20>>2]|0)+80>>2]|0)|0;break}else{r=p-(f[n+40>>2]|0)|0;break}}else r=a-(f[(f[a+48>>2]|0)+20>>2]|0)|0;while(0);a=(r|0)/88|0;f[e>>2]=a;r=f[i>>2]|0;if((r|0)==(f[h>>2]|0))g6(c,e);else{f[r>>2]=a;f[i>>2]=r+4}u=d;return}function dXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;e=VDc(4)|0;tTb(e);f[a>>2]=e;f[a+4>>2]=c;f[a+8>>2]=d;f[a+12>>2]=0;d=VDc(232)|0;kUb(d);f[a+16>>2]=d;b[a+20>>0]=1;d=a+21|0;f[a+32>>2]=0;f[a+36>>2]=0;b[d>>0]=0;b[d+1>>0]=0;b[d+2>>0]=0;b[d+3>>0]=0;f[a+28>>2]=a+32;return}function eXb(){var a=0;a=f[220827]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220827]=0;a=f[220826]|0;if(!a){f[220826]=0;return}fXb(a);YDc(a);f[220826]=0;return}function fXb(a){a=a|0;var b=0;b=f[a>>2]|0;if(b|0){uTb(b);YDc(b)}jaa(a+28|0,f[a+32>>2]|0);b=f[a+16>>2]|0;if(!b)return;pUb(b);YDc(b);return}function gXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;fWb(h,c,f[c>>2]|0,d,e);e=f[h>>2]|0;if(!e){i=h;j=f[i+4>>2]|0;k=a;f[k>>2]=f[i>>2];f[k+4>>2]=j;u=g;return}if(!(b[(f[c>>2]|0)+20>>0]|0)){j=h;k=f[j+4>>2]|0;i=a;f[i>>2]=f[j>>2];f[i+4>>2]=k;u=g;return}switch(e|0){case 8:{l=h+4|0;m=14;break}case 1:{l=(f[h+4>>2]|0)+8|0;m=14;break}case 2:{l=(f[h+4>>2]|0)+20|0;m=14;break}case 3:{l=(f[(f[h+4>>2]|0)+8>>2]|0)+8|0;m=14;break}case 4:{l=(f[h+4>>2]|0)+8|0;m=14;break}case 5:{l=(f[(f[h+4>>2]|0)+12>>2]|0)+8|0;m=14;break}case 6:{l=(f[h+4>>2]|0)+8|0;m=14;break}case 7:{l=(f[(f[h+4>>2]|0)+8>>2]|0)+8|0;m=14;break}default:n=0}if((m|0)==14)n=f[l>>2]|0;l=n;m=f[c+40>>2]|0;a:do if((n|0)!=(m|0)){k=c+52|0;i=f[k>>2]|0;if(i|0){j=i;do{i=f[j+16>>2]|0;if(n>>>0<i>>>0)o=j;else{if(i>>>0>=n>>>0)break a;o=j+4|0}j=f[o>>2]|0}while((j|0)!=0)}b:do if((e|0)==8){j=m+4|0;i=f[j>>2]|0;p=b[i+11>>0]|0;q=d+11|0;r=b[q>>0]|0;s=r<<24>>24<0;t=d+4|0;v=s?f[t>>2]|0:r&255;do if((p<<24>>24<0?f[i+4>>2]|0:p&255)>>>0>=v>>>0?(EEc(i,0,v,s?f[d>>2]|0:d,v)|0)==0:0){r=f[j>>2]|0;w=b[r+11>>0]|0;x=w<<24>>24<0;if(x)y=f[r+4>>2]|0;else y=w&255;w=b[q>>0]|0;z=w<<24>>24<0?f[t>>2]|0:w&255;if((y|0)!=(z|0)){if(x)A=f[r>>2]|0;else A=r;if((b[A+z>>0]|0)!=46)break}z=h;r=f[z+4>>2]|0;x=a;f[x>>2]=f[z>>2];f[x+4>>2]=r;u=g;return}while(0);j=f[c+48>>2]|0;if((j|0)!=(k|0)){v=j;while(1){j=f[v+16>>2]|0;if((j|0?(s=j+4|0,j=f[s>>2]|0,i=b[j+11>>0]|0,p=b[q>>0]|0,r=p<<24>>24<0,x=r?f[t>>2]|0:p&255,(i<<24>>24<0?f[j+4>>2]|0:i&255)>>>0>=x>>>0):0)?(EEc(j,0,x,r?f[d>>2]|0:d,x)|0)==0:0){x=f[s>>2]|0;s=b[x+11>>0]|0;r=s<<24>>24<0;if(r)B=f[x+4>>2]|0;else B=s&255;s=b[q>>0]|0;j=s<<24>>24<0?f[t>>2]|0:s&255;if((B|0)==(j|0))break;if(r)C=f[x>>2]|0;else C=x;if((b[C+j>>0]|0)==46)break}j=f[v+4>>2]|0;if(!j){x=v+8|0;r=f[x>>2]|0;if((f[r>>2]|0)==(v|0))D=r;else{r=x;do{x=f[r>>2]|0;r=x+8|0;s=f[r>>2]|0}while((f[s>>2]|0)!=(x|0));D=s}}else{r=j;while(1){s=f[r>>2]|0;if(!s)break;else r=s}D=r}if((D|0)==(k|0))break b;else v=D}v=h;t=f[v+4>>2]|0;q=a;f[q>>2]=f[v>>2];f[q+4>>2]=t;u=g;return}}while(0);f[c+72>>2]=l;iEc(c+76|0,d)|0;k=a;f[k>>2]=0;f[k+4>>2]=0;u=g;return}while(0);d=c+60|0;l=c+64|0;D=f[l>>2]|0;if(D|0){C=l;B=D;c:while(1){A=B;while(1){if((f[A+16>>2]|0)>>>0>=n>>>0)break;y=f[A+4>>2]|0;if(!y){E=C;break c}else A=y}B=f[A>>2]|0;if(!B){E=A;break}else C=A}if((E|0)!=(l|0)?n>>>0>=(f[E+16>>2]|0)>>>0:0){n=f[E+4>>2]|0;if(!n){l=E+8|0;C=f[l>>2]|0;if((f[C>>2]|0)==(E|0))F=C;else{C=l;do{l=f[C>>2]|0;C=l+8|0;B=f[C>>2]|0}while((f[B>>2]|0)!=(l|0));F=B}}else{C=n;while(1){n=f[C>>2]|0;if(!n)break;else C=n}F=C}if((f[d>>2]|0)==(E|0))f[d>>2]=F;F=c+68|0;f[F>>2]=(f[F>>2]|0)+-1;uHa(D,E);YDc(E)}}E=h;h=f[E+4>>2]|0;D=a;f[D>>2]=f[E>>2];f[D+4>>2]=h;u=g;return}function hXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=u;u=u+448|0;g=e+424|0;h=e+412|0;i=e+400|0;j=e+360|0;k=e+320|0;l=e+280|0;m=e+240|0;n=e+200|0;o=e+160|0;p=e+120|0;q=e+80|0;r=e+40|0;s=e;t=c+16|0;if(!(f[t>>2]|0)){v=_7b()|0;f[t>>2]=v}v=c+60|0;if((f[v>>2]|0)>0){t=c+28|0;w=d+44|0;x=0;do{hXb(a,(f[t>>2]|0)+(x*88|0)|0,f[(f[w>>2]|0)+4+(x<<2)>>2]|0);x=x+1|0}while((x|0)<(f[v>>2]|0))}v=c+64|0;if((f[v>>2]|0)>0){x=c+32|0;w=0;do{t=f[x>>2]|0;y=t+(w*48|0)+16|0;if(!(f[y>>2]|0)){z=e8b()|0;f[y>>2]=z}z=t+(w*48|0)+24|0;y=f[z>>2]|0;if((y|0)>0){A=t+(w*48|0)+28|0;t=0;B=y;while(1){y=(f[A>>2]|0)+(t*20|0)+16|0;if(!(f[y>>2]|0)){C=g8b()|0;f[y>>2]=C;D=f[z>>2]|0}else D=B;t=t+1|0;if((t|0)>=(D|0))break;else B=D}}w=w+1|0}while((w|0)<(f[v>>2]|0))}v=c+52|0;if((f[v>>2]|0)>0){w=c+20|0;D=d+28|0;x=0;do{iXb(a,(f[w>>2]|0)+(x*88|0)|0,f[(f[D>>2]|0)+4+(x<<2)>>2]|0);x=x+1|0}while((x|0)<(f[v>>2]|0))}x=c+72|0;if((f[x>>2]|0)>0){D=c+40|0;w=d+92|0;B=0;do{iXb(a,(f[D>>2]|0)+(B*88|0)|0,f[(f[w>>2]|0)+4+(B<<2)>>2]|0);B=B+1|0}while((B|0)<(f[x>>2]|0))}x=c+68|0;B=f[x>>2]|0;if((B|0)>0){w=c+36|0;D=0;t=B;while(1){B=(f[w>>2]|0)+(D*12|0)+8|0;if(!(f[B>>2]|0)){z=W7b()|0;f[B>>2]=z;E=f[x>>2]|0}else E=t;D=D+1|0;if((D|0)>=(E|0))break;else t=E}}E=f[v>>2]|0;if((E|0)>0){t=c+20|0;D=c+4|0;x=d+28|0;w=j+4|0;z=k+4|0;B=l+4|0;A=m+4|0;C=n+4|0;y=o+4|0;F=p+4|0;G=q+4|0;H=r+4|0;I=s+4|0;J=i+11|0;K=g+11|0;L=h+11|0;M=c+24|0;N=0;O=E;while(1){P=f[t>>2]|0;Q=f[P+(N*88|0)+52>>2]|0;if(!Q)R=O;else{if((f[Q+16>>2]|0)>0?(S=N+-1|0,(f[P+(S*88|0)+52>>2]|0)!=(Q|0)):0){jIa(h,f[D>>2]|0,518136);QJa(g,h,f[(f[t>>2]|0)+(S*88|0)>>2]|0);P=f[(f[x>>2]|0)+4+(S<<2)>>2]|0;T=f[(f[t>>2]|0)+(S*88|0)>>2]|0;S=b[T+11>>0]|0;U=S<<24>>24<0;f[j>>2]=U?f[T>>2]|0:T;f[w>>2]=U?f[T+4>>2]|0:S&255;S=f[Q>>2]|0;T=b[S+11>>0]|0;U=T<<24>>24<0;f[k>>2]=U?f[S>>2]|0:S;f[z>>2]=U?f[S+4>>2]|0:T&255;f[l>>2]=0;f[B>>2]=-1;f[m>>2]=0;f[A>>2]=-1;f[n>>2]=0;f[C>>2]=-1;f[o>>2]=0;f[y>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[G>>2]=-1;f[r>>2]=0;f[H>>2]=-1;f[s>>2]=0;f[I>>2]=-1;Jhc(i,482827,j,k,l,m,n,o,p,q,r,s);lVb(a,g,P,9,i);if((b[J>>0]|0)<0)YDc(f[i>>2]|0);if((b[K>>0]|0)<0)YDc(f[g>>2]|0);if((b[L>>0]|0)<0)YDc(f[h>>2]|0);V=f[v>>2]|0}else V=O;P=(f[M>>2]|0)+(((Q-(f[(f[Q+8>>2]|0)+24>>2]|0)|0)/28|0)*28|0)+16|0;f[P>>2]=(f[P>>2]|0)+1;R=V}N=N+1|0;if((N|0)>=(R|0)){W=R;break}else O=R}}else W=E;E=c+56|0;if((f[E>>2]|0)>0){R=c+24|0;O=c+4|0;N=d+108|0;d=g+11|0;V=h+11|0;M=a+4|0;L=0;do{K=f[R>>2]|0;i=K+(L*28|0)+16|0;J=f[i>>2]|0;if(!J){jIa(h,f[O>>2]|0,518136);QJa(g,h,f[K+(L*28|0)>>2]|0);kVb(a,g,f[(f[N>>2]|0)+4+(L<<2)>>2]|0,0,482958);if((b[d>>0]|0)<0)YDc(f[g>>2]|0);if((b[V>>0]|0)<0)YDc(f[h>>2]|0);X=f[i>>2]|0}else X=J;J=f[M>>2]|0;s=X<<2;if(!s)Y=0;else{r=VDc(s)|0;f[g>>2]=r;s=J+124|0;q=f[s>>2]|0;if((q|0)==(f[J+128>>2]|0))f6(J+120|0,g);else{f[q>>2]=r;f[s>>2]=(f[s>>2]|0)+4}Y=f[g>>2]|0}f[K+(L*28|0)+20>>2]=Y;f[i>>2]=0;i=K+(L*28|0)+24|0;if(!(f[i>>2]|0)){K=c8b()|0;f[i>>2]=K}L=L+1|0}while((L|0)<(f[E>>2]|0));Z=f[v>>2]|0}else Z=W;if((Z|0)<=0){u=e;return}W=c+20|0;v=c+24|0;c=0;do{E=f[W>>2]|0;L=f[E+(c*88|0)+52>>2]|0;if(L|0){Y=f[v>>2]|0;g=(L-(f[(f[L+8>>2]|0)+24>>2]|0)|0)/28|0;L=Y+(g*28|0)+16|0;X=f[L>>2]|0;f[E+(c*88|0)+44>>2]=X;M=f[Y+(g*28|0)+20>>2]|0;f[L>>2]=X+1;f[M+(X<<2)>>2]=E+(c*88|0)}c=c+1|0}while((c|0)<(Z|0));u=e;return}function iXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=u;u=u+464|0;g=e+40|0;h=e;i=e+416|0;j=e+376|0;k=e+336|0;l=e+296|0;m=e+256|0;n=e+216|0;o=e+176|0;p=e+136|0;q=e+96|0;r=e+56|0;s=c+68|0;if(!(f[s>>2]|0)){t=a8b()|0;f[s>>2]=t}t=a+44|0;nXb(f[t>>2]|0,c);s=d+8|0;if(f[s>>2]&2|0){v=d+20|0;w=f[v>>2]|0;x=c+4|0;gWb(h,a,w,f[x>>2]|0,0,1);y=f[h>>2]|0;do if(!y){z=f[a>>2]|0;if(b[z+22>>0]|0?(hWb(g,z,w,2),z=g,A=f[z>>2]|0,B=f[z+4>>2]|0,z=h,f[z>>2]=A,f[z+4>>2]=B,A|0):0){C=A;break}kXb(a,f[x>>2]|0,d,3,f[v>>2]|0);u=e;return}else C=y;while(0);if((C|0)!=1){C=f[x>>2]|0;VHa(i,501908,f[v>>2]|0);jIa(g,i,481735);lVb(a,C,d,3,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=e;return}C=f[h+4>>2]|0;f[c+48>>2]=C;v=C;C=f[c+40>>2]|0;y=f[v+68>>2]|0;a:do if((y|0)>0){w=f[v+36>>2]|0;A=0;while(1){if((f[w+(A*12|0)>>2]|0)<=(C|0)?(f[w+(A*12|0)+4>>2]|0)>(C|0):0)break a;A=A+1|0;if((A|0)>=(y|0)){D=19;break}}}else D=19;while(0);if((D|0)==19?(y=f[x>>2]|0,x=f[v+4>>2]|0,v=b[x+11>>0]|0,A=v<<24>>24<0,f[i>>2]=A?f[x>>2]|0:x,f[i+4>>2]=A?f[x+4>>2]|0:v&255,v=amc(C,j+8|0)|0,f[j>>2]=v,C=Mpc(v)|0,f[j+4>>2]=C,f[k>>2]=0,f[k+4>>2]=-1,f[l>>2]=0,f[l+4>>2]=-1,f[m>>2]=0,f[m+4>>2]=-1,f[n>>2]=0,f[n+4>>2]=-1,f[o>>2]=0,f[o+4>>2]=-1,f[p>>2]=0,f[p+4>>2]=-1,f[q>>2]=0,f[q+4>>2]=-1,f[r>>2]=0,f[r+4>>2]=-1,Jhc(g,482260,i,j,k,l,m,n,o,p,q,r),lVb(a,y,d,1,g),(b[g+11>>0]|0)<0):0)YDc(f[g>>2]|0)}if(f[c+52>>2]|0?(f[c+32>>2]|0)!=1:0)kVb(a,f[c+4>>2]|0,d,0,482309);y=f[s>>2]|0;do if(!(y&4)){C=c+24|0;v=f[C>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(v,g)}v=c+28|0;if((f[v>>2]|1|0)!=11){x=f[C>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(x,g)}if((f[v>>2]|0)!=14)break}kVb(a,f[c+4>>2]|0,d,2,482563)}else{v=f[a>>2]|0;if(!(b[v+23>>0]|0)){x=f[d+36>>2]|0;E=(b[(x|0?x:528208)+55>>0]|0)!=0}else E=0;x=(b[v+21>>0]|0)!=0;v=x&(E^1);C=d+24|0;A=f[C>>2]|0;w=c+4|0;B=(f[d+52>>2]|0)==14|y>>>3&1;gWb(h,a,A,f[w>>2]|0,1,E|x^1);x=f[h>>2]|0;do if(!x){z=f[a>>2]|0;if(b[z+22>>0]|0?(hWb(g,z,A,B),z=g,F=f[z>>2]|0,G=f[z+4>>2]|0,z=h,f[z>>2]=F,f[z+4>>2]=G,F|0):0){H=F;break}if(!v){if(E){F=VDc(32)|0;f[i>>2]=F;f[i+8>>2]=-2147483616;f[i+4>>2]=21;G=F;z=482369;I=G+21|0;do{b[G>>0]=b[z>>0]|0;G=G+1|0;z=z+1|0}while((G|0)<(I|0));b[F+21>>0]=0;gXb(g,a,i,1);z=g;G=f[z>>2]|0;I=f[z+4>>2]|0;z=h;f[z>>2]=G;f[z+4>>2]=I;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if(G|0){H=G;break}}kXb(a,f[w>>2]|0,d,2,f[C>>2]|0);u=e;return}fEc(i,f[C>>2]|0);G=a+4|0;I=f[G>>2]|0;z=VDc(4)|0;f[z>>2]=0;f[g>>2]=z;J=I+100|0;K=f[J>>2]|0;if((K|0)==(f[I+104>>2]|0))qVb(I+96|0,g);else{f[K>>2]=z;f[J>>2]=(f[J>>2]|0)+4}f[c+24>>2]=f[g>>2];J=f[G>>2]|0;z=VDc(12)|0;fEc(z,i);f[g>>2]=z;K=J+76|0;I=f[K>>2]|0;if((I|0)==(f[J+80>>2]|0))mVb(J+72|0,g);else{f[I>>2]=z;f[K>>2]=(f[K>>2]|0)+4}f[c+72>>2]=f[g>>2];if(f[s>>2]&8|0){K=f[G>>2]|0;z=f[d+28>>2]|0;I=VDc(12)|0;fEc(I,z);f[g>>2]=I;z=K+76|0;J=f[z>>2]|0;if((J|0)==(f[K+80>>2]|0))mVb(K+72|0,g);else{f[J>>2]=I;f[z>>2]=(f[z>>2]|0)+4}f[c+76>>2]=f[g>>2]}oXb(f[t>>2]|0,c)|0;if(b[c+38>>0]|0)pXb(f[G>>2]|0,c)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=e;return}else H=x;while(0);if(!(f[s>>2]&512)){switch(H|0){case 1:{L=11;break}case 4:{L=14;break}default:{x=f[w>>2]|0;VHa(i,501908,f[C>>2]|0);jIa(g,i,482391);lVb(a,x,d,2,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=e;return}}f[c+28>>2]=L}x=c+24|0;v=f[x>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(v,g)}v=c+28|0;do if((f[v>>2]|1|0)!=11){B=f[x>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(B,g)}if((f[v>>2]|0)!=14){kVb(a,f[w>>2]|0,d,2,482522);break}if((f[h>>2]|0)!=4){B=f[w>>2]|0;VHa(i,501908,f[C>>2]|0);jIa(g,i,482444);lVb(a,B,d,2,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=e;return}B=c+64|0;f[B>>2]=f[h+4>>2];A=f[x>>2]|0;if(A|0?(f[A>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(A,g)}A=c+36|0;if(!(b[(f[B>>2]|0)+20>>0]|0)){if(b[A>>0]|0){G=d+28|0;if(!(qcc(f[G>>2]|0)|0)){kVb(a,f[w>>2]|0,d,4,482467);break}z=f[G>>2]|0;I=f[x>>2]|0;do if(I|0){if((f[I>>2]|0)==2)break;f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(I,g)}while(0);gWb(i,a,z,f[(f[B>>2]|0)+4>>2]|0,0,1);do if((f[i>>2]|0)==5){I=i+4|0;F=f[(f[I>>2]|0)+12>>2]|0;J=f[x>>2]|0;do if(J|0){if((f[J>>2]|0)==2)break;f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(J,g)}while(0);if((F|0)!=(f[B>>2]|0)){D=102;break}f[c+80>>2]=f[I>>2]}else D=102;while(0);if((D|0)==102){z=f[w>>2]|0;J=f[x>>2]|0;do if(J|0){if((f[J>>2]|0)==2)break;f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(J,g)}while(0);VHa(m,477727,f[(f[B>>2]|0)+4>>2]|0);jIa(l,m,480150);QJa(k,l,f[G>>2]|0);jIa(j,k,502535);lVb(a,z,d,4,j);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0)}break}}else b[A>>0]=0;J=f[x>>2]|0;if(J|0?(f[J>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(J,g)}if((f[(f[B>>2]|0)+24>>2]|0)>0){J=f[x>>2]|0;do if(J|0){if((f[J>>2]|0)==2)break;f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(J,g)}while(0);f[c+80>>2]=f[(f[B>>2]|0)+28>>2]}}else{if((f[h>>2]|0)==1){f[c+60>>2]=f[h+4>>2];if(!(b[c+36>>0]|0))break;kVb(a,f[w>>2]|0,d,4,482408);break}J=f[w>>2]|0;VHa(i,501908,f[C>>2]|0);jIa(g,i,481735);lVb(a,J,d,2,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=e;return}while(0)}while(0);if(oXb(f[t>>2]|0,c)|0){if(!(b[c+38>>0]|0)){u=e;return}D=a+4|0;if(pXb(f[D>>2]|0,c)|0){u=e;return}L=c+48|0;H=f[L>>2]|0;s=f[c+40>>2]|0;E=(f[D>>2]|0)+176|0;D=f[E>>2]|0;do if(D){y=E;C=D;b:while(1){w=C;while(1){x=f[w+16>>2]|0;if(x>>>0>=H>>>0){if(x>>>0>H>>>0)break;if((f[w+20>>2]|0)>=(s|0))break}x=f[w+4>>2]|0;if(!x){M=y;break b}else w=x}C=f[w>>2]|0;if(!C){M=w;break}else y=w}if((M|0)!=(E|0)?(y=f[M+16>>2]|0,y>>>0<=H>>>0):0){if(y>>>0>=H>>>0?(f[M+20>>2]|0)>(s|0):0){N=0;break}N=f[M+24>>2]|0}else N=0}else N=0;while(0);M=amc(s,h+8|0)|0;f[h>>2]=M;s=Mpc(M)|0;f[h+4>>2]=s;s=f[(f[L>>2]|0)+4>>2]|0;L=b[s+11>>0]|0;M=L<<24>>24<0;f[i>>2]=M?f[s>>2]|0:s;f[i+4>>2]=M?f[s+4>>2]|0:L&255;L=f[N+4>>2]|0;s=b[L+11>>0]|0;M=s<<24>>24<0;f[j>>2]=M?f[L>>2]|0:L;f[j+4>>2]=M?f[L+4>>2]|0:s&255;s=f[f[N+20>>2]>>2]|0;N=b[s+11>>0]|0;L=N<<24>>24<0;f[k>>2]=L?f[s>>2]|0:s;f[k+4>>2]=L?f[s+4>>2]|0:N&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;Jhc(g,482744,h,i,j,k,l,m,n,o,p,q);GVb(a,f[c+4>>2]|0,d,1,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);u=e;return}N=f[t>>2]|0;t=f[c+48>>2]|0;s=c+40|0;L=f[s>>2]|0;M=(t*65535|0)+L|0;H=f[N+80>>2]|0;c:do if(H){E=H+-1|0;D=(E&H|0)==0;if(!D)if(M>>>0<H>>>0)O=M;else O=(M>>>0)%(H>>>0)|0;else O=E&M;y=f[(f[N+76>>2]|0)+(O<<2)>>2]|0;if((y|0)!=0?(C=f[y>>2]|0,(C|0)!=0):0){d:do if(D){y=C;while(1){B=f[y+4>>2]|0;x=(M|0)==(B|0);if(!(x|(B&E|0)==(O|0))){P=0;break c}if((x?(f[y+8>>2]|0)==(t|0):0)?(f[y+12>>2]|0)==(L|0):0){Q=y;break d}y=f[y>>2]|0;if(!y){P=0;break c}}}else{y=C;while(1){w=f[y+4>>2]|0;if((M|0)==(w|0)){if((f[y+8>>2]|0)==(t|0)?(f[y+12>>2]|0)==(L|0):0){Q=y;break d}}else{if(w>>>0<H>>>0)R=w;else R=(w>>>0)%(H>>>0)|0;if((R|0)!=(O|0)){P=0;break c}}y=f[y>>2]|0;if(!y){P=0;break c}}}while(0);P=f[Q+16>>2]|0}else P=0}else P=0;while(0);if(!t){f[g+8>>2]=0;b[g+11>>0]=7;b[g>>0]=b[475890]|0;b[g+1>>0]=b[475891]|0;b[g+2>>0]=b[475892]|0;b[g+3>>0]=b[475893]|0;b[g+4>>0]=b[475894]|0;b[g+5>>0]=b[475895]|0;b[g+6>>0]=b[475896]|0;b[g+7>>0]=0}else fEc(g,f[t+4>>2]|0);t=f[c+4>>2]|0;if(!(b[c+38>>0]|0)){c=amc(f[s>>2]|0,i+8|0)|0;f[i>>2]=c;Q=Mpc(c)|0;f[i+4>>2]=Q;Q=g+11|0;c=b[Q>>0]|0;O=c<<24>>24<0;f[j>>2]=O?f[g>>2]|0:g;f[j+4>>2]=O?f[g+4>>2]|0:c&255;c=f[P>>2]|0;O=b[c+11>>0]|0;R=O<<24>>24<0;f[k>>2]=R?f[c>>2]|0:c;f[k+4>>2]=R?f[c+4>>2]|0:O&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;Jhc(h,482683,i,j,k,l,m,n,o,p,q,r);lVb(a,t,d,1,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);S=Q}else{Q=amc(f[s>>2]|0,i+8|0)|0;f[i>>2]=Q;s=Mpc(Q)|0;f[i+4>>2]=s;s=g+11|0;Q=b[s>>0]|0;O=Q<<24>>24<0;f[j>>2]=O?f[g>>2]|0:g;f[j+4>>2]=O?f[g+4>>2]|0:Q&255;Q=f[P+4>>2]|0;P=b[Q+11>>0]|0;O=P<<24>>24<0;f[k>>2]=O?f[Q>>2]|0:Q;f[k+4>>2]=O?f[Q+4>>2]|0:P&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;Jhc(h,482614,i,j,k,l,m,n,o,p,q,r);lVb(a,t,d,1,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);S=s}if((b[S>>0]|0)<0)YDc(f[g>>2]|0);u=e;return}function jXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+48|0;g=e+24|0;h=e+16|0;i=e;j=e+36|0;k=c+44|0;if(!(f[k>>2]|0)){l=k8b()|0;f[k>>2]=l}l=d+20|0;k=f[l>>2]|0;m=c+4|0;gWb(h,a,k,f[m>>2]|0,0,(b[(f[a>>2]|0)+21>>0]|0)==0);n=f[h>>2]|0;do if(!n){o=f[a>>2]|0;if(b[o+22>>0]|0?(hWb(g,o,k,0),o=g,p=f[o>>2]|0,q=f[o+4>>2]|0,o=h,f[o>>2]=p,f[o+4>>2]=q,p|0):0){r=p;s=9;break}if(!(b[(f[a>>2]|0)+21>>0]|0)){kXb(a,f[m>>2]|0,d,5,f[l>>2]|0);break}else{lXb(c+12|0,f[l>>2]|0,f[a+40>>2]|0);break}}else{r=n;s=9}while(0);do if((s|0)==9){if((r|0)==1){mXb(c+12|0,f[h+4>>2]|0);break}n=f[m>>2]|0;VHa(i,501908,f[l>>2]|0);jIa(g,i,481735);lVb(a,n,d,5,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0)}while(0);l=d+24|0;h=f[l>>2]|0;gWb(i,a,h,f[m>>2]|0,0,(b[(f[a>>2]|0)+21>>0]|0)==0);r=f[i>>2]|0;do if(!r){s=f[a>>2]|0;if(b[s+22>>0]|0?(hWb(g,s,h,0),s=g,n=f[s>>2]|0,k=f[s+4>>2]|0,s=i,f[s>>2]=n,f[s+4>>2]=k,n|0):0){t=n;break}if(!(b[(f[a>>2]|0)+21>>0]|0)){kXb(a,f[m>>2]|0,d,6,f[l>>2]|0);u=e;return}else{lXb(c+28|0,f[l>>2]|0,f[a+40>>2]|0);u=e;return}}else t=r;while(0);if((t|0)==1){mXb(c+28|0,f[i+4>>2]|0);u=e;return}i=f[m>>2]|0;VHa(j,501908,f[l>>2]|0);jIa(g,j,481735);lVb(a,i,d,6,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);u=e;return}function kXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+80|0;i=h+60|0;j=h+48|0;k=h+36|0;l=h+24|0;m=h+12|0;n=h;o=a+72|0;if(!(f[o>>2]|0)){p=a+88|0;q=b[p+11>>0]|0;if(q<<24>>24<0)r=f[a+92>>2]|0;else r=q&255;if(!r){VHa(j,501908,g);jIa(i,j,481992);lVb(a,c,d,e,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);u=h;return}else{s=p;t=q}}else{VHa(n,501908,a+76|0);jIa(m,n,482010);QJa(l,m,f[f[o>>2]>>2]|0);jIa(k,l,482037);QJa(j,k,a+28|0);jIa(i,j,482067);lVb(a,c,d,e,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);o=a+88|0;s=o;t=b[o+11>>0]|0}if(t<<24>>24<0)v=f[a+92>>2]|0;else v=t&255;if(!v){u=h;return}VHa(n,501908,g);jIa(m,n,482120);QJa(l,m,s);jIa(k,l,482139);QJa(j,k,g);jIa(i,j,479246);lVb(a,c,d,e,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);u=h;return}function lXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+192|0;g=e+168|0;h=e+144|0;i=e+120|0;j=e+96|0;k=e+72|0;l=e+48|0;m=e+174|0;n=e+24|0;o=e+173|0;p=e;q=e+172|0;if(f[a>>2]|0){rTb(h,3,475801,7105);oTb(e+178|0,mTb(h,481829)|0);sTb(h)}h=a+12|0;if(f[h>>2]|0){rTb(i,3,475801,7106);oTb(e+177|0,mTb(i,481806)|0);sTb(i)}i=a+4|0;if(f[i>>2]|0){rTb(j,3,475801,7107);oTb(e+176|0,mTb(j,481760)|0);sTb(j)}j=a+8|0;if(f[j>>2]|0){rTb(k,3,475801,7108);oTb(e+175|0,mTb(k,481783)|0);sTb(k)}if((d|0)!=0?(k=d+8|0,a=f[k>>2]|0,(a|0)!=0):0){r=k;s=a}else{rTb(l,3,475801,7109);oTb(m,mTb(l,481858)|0);sTb(l);l=d+8|0;r=l;s=f[l>>2]|0}if(!(b[s+21>>0]|0)){rTb(n,3,475801,7110);oTb(o,mTb(n,481894)|0);sTb(n)}if(b[d+49>>0]|0){rTb(p,3,475801,7111);oTb(q,mTb(p,481950)|0);sTb(p)}f[h>>2]=d;d=f[(f[r>>2]|0)+16>>2]|0;h=VDc(12)|0;fEc(h,c);f[g>>2]=h;c=d+76|0;p=f[c>>2]|0;if((p|0)==(f[d+80>>2]|0))mVb(d+72|0,g);else{f[p>>2]=h;f[c>>2]=(f[c>>2]|0)+4}f[i>>2]=f[g>>2];i=f[(f[r>>2]|0)+16>>2]|0;r=VDc(4)|0;f[r>>2]=0;f[g>>2]=r;c=i+100|0;h=f[c>>2]|0;if((h|0)==(f[i+104>>2]|0)){qVb(i+96|0,g);t=f[g>>2]|0;f[j>>2]=t;u=e;return}else{f[h>>2]=r;f[c>>2]=(f[c>>2]|0)+4;t=f[g>>2]|0;f[j>>2]=t;u=e;return}}function mXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;if(f[a+4>>2]|0){rTb(d,3,475801,7097);oTb(c+74|0,mTb(d,481760)|0);sTb(d)}if(f[a+8>>2]|0){rTb(e,3,475801,7098);oTb(c+73|0,mTb(e,481783)|0);sTb(e)}if(!(f[a+12>>2]|0)){f[a>>2]=b;u=c;return}rTb(g,3,475801,7099);oTb(c+72|0,mTb(g,481806)|0);sTb(g);f[a>>2]=b;u=c;return}function nXb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d+16|0;g=d+24|0;h=d+8|0;i=d;f[e>>2]=c;do if(b[c+38>>0]|0){j=f[c+56>>2]|0;if(!j){k=f[c+20>>2]|0;break}else{k=j;break}}else k=f[c+48>>2]|0;while(0);j=k;k=f[c+8>>2]|0;if((b[k+11>>0]|0)<0)l=f[k>>2]|0;else l=k;f[g>>2]=j;f[g+4>>2]=l;l=a+40|0;if(!(rXb(f[l>>2]|0,g,e)|0)){k=sXb(f[l>>2]|0,g)|0;f[h>>2]=k;rXb(a+20|0,g,h)|0}g=f[c+12>>2]|0;if((b[g+11>>0]|0)<0)m=f[g>>2]|0;else m=g;f[h>>2]=j;f[h+4>>2]=m;m=a+68|0;if(rXb(f[m>>2]|0,h,e)|0){u=d;return}e=sXb(f[m>>2]|0,h)|0;f[i>>2]=e;rXb(a+48|0,h,i)|0;u=d;return}function oXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0;c=b;d=f[b+48>>2]|0;e=f[b+40>>2]|0;b=a+76|0;g=(d*65535|0)+e|0;h=a+80|0;i=f[h>>2]|0;j=(i|0)==0;k=d;a:do if(!j){l=i+-1|0;m=(l&i|0)==0;if(!m)if(g>>>0<i>>>0)o=g;else o=(g>>>0)%(i>>>0)|0;else o=l&g;p=f[(f[b>>2]|0)+(o<<2)>>2]|0;if((p|0)!=0?(q=f[p>>2]|0,(q|0)!=0):0){if(m){m=q;while(1){p=f[m+4>>2]|0;if(!((p|0)==(g|0)|(p&l|0)==(o|0))){r=o;break a}if((f[m+8>>2]|0)==(k|0)?(f[m+12>>2]|0)==(e|0):0){s=0;break}m=f[m>>2]|0;if(!m){r=o;break a}}return s|0}else t=q;while(1){m=f[t+4>>2]|0;if((m|0)!=(g|0)){if(m>>>0<i>>>0)u=m;else u=(m>>>0)%(i>>>0)|0;if((u|0)!=(o|0)){r=o;break a}}if((f[t+8>>2]|0)==(k|0)?(f[t+12>>2]|0)==(e|0):0){s=0;break}t=f[t>>2]|0;if(!t){r=o;break a}}return s|0}else r=o}else r=0;while(0);o=VDc(20)|0;t=o+8|0;f[t>>2]=d;f[t+4>>2]=e;f[o+16>>2]=c;f[o+4>>2]=g;f[o>>2]=0;c=a+88|0;v=+(((f[c>>2]|0)+1|0)>>>0);w=+n[a+92>>2];do if(j|v>+(i>>>0)*w){e=(i>>>0<3|(i+-1&i|0)!=0)&1|i<<1;t=~~+X(+(v/w))>>>0;vUb(b,e>>>0<t>>>0?t:e);e=f[h>>2]|0;t=e+-1|0;if(!(t&e)){x=e;y=t&g;break}if(g>>>0<e>>>0){x=e;y=g}else{x=e;y=(g>>>0)%(e>>>0)|0}}else{x=i;y=r}while(0);r=(f[b>>2]|0)+(y<<2)|0;y=f[r>>2]|0;if(!y){i=a+84|0;f[o>>2]=f[i>>2];f[i>>2]=o;f[r>>2]=i;i=f[o>>2]|0;if(i|0){r=f[i+4>>2]|0;i=x+-1|0;if(i&x)if(r>>>0<x>>>0)z=r;else z=(r>>>0)%(x>>>0)|0;else z=r&i;A=(f[b>>2]|0)+(z<<2)|0;B=33}}else{f[o>>2]=f[y>>2];A=y;B=33}if((B|0)==33)f[A>>2]=o;f[c>>2]=(f[c>>2]|0)+1;s=1;return s|0}function pXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c;e=b;g=f[b+48>>2]|0;h=f[b+40>>2]|0;f[d>>2]=g;f[d+4>>2]=h;b=a+172|0;i=a+176|0;j=f[i>>2]|0;do if(j){k=g;l=a+176|0;m=j;a:while(1){n=f[m+16>>2]|0;do if(k>>>0>=n>>>0){if(n>>>0>=k>>>0){o=f[m+20>>2]|0;if((h|0)<(o|0)){p=7;break}if((o|0)>=(h|0)){p=12;break a}}q=m+4|0;o=f[q>>2]|0;if(!o){p=11;break a}else{r=q;s=o}}else p=7;while(0);if((p|0)==7){p=0;n=f[m>>2]|0;if(!n){p=8;break}else{r=m;s=n}}l=r;m=s}if((p|0)==8){t=m;v=m;break}else if((p|0)==11){t=q;v=m;break}else if((p|0)==12){t=l;v=m;break}}else{t=i;v=i}while(0);if(f[t>>2]|0){w=0;u=c;return w|0}i=VDc(28)|0;f[i+16>>2]=g;f[i+20>>2]=h;f[i+24>>2]=e;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=v;f[t>>2]=i;v=f[f[b>>2]>>2]|0;if(!v)x=i;else{f[b>>2]=v;x=f[t>>2]|0}laa(f[a+176>>2]|0,x);x=a+180|0;f[x>>2]=(f[x>>2]|0)+1;x=a+224|0;t=f[x>>2]|0;if((t|0)==(f[a+228>>2]|0)){qXb(a+220|0,d);w=1;u=c;return w|0}else{a=d;d=f[a+4>>2]|0;v=t;f[v>>2]=f[a>>2];f[v+4>>2]=d;f[x>>2]=(f[x>>2]|0)+8;w=1;u=c;return w|0}return 0}function qXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function rXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0;e=f[c>>2]|0;g=f[c+4>>2]|0;c=f[d>>2]|0;d=e*65535|0;h=g;i=b[h>>0]|0;j=e;if(!(i<<24>>24))k=0;else{l=h;m=0;o=i;while(1){i=(m*5|0)+(o<<24>>24)|0;l=l+1|0;o=b[l>>0]|0;if(!(o<<24>>24)){k=i;break}else m=i}}m=k+d|0;d=a+4|0;k=f[d>>2]|0;o=(k|0)==0;a:do if(!o){l=k+-1|0;i=(l&k|0)==0;if(!i)if(m>>>0<k>>>0)p=m;else p=(m>>>0)%(k>>>0)|0;else p=l&m;q=f[(f[a>>2]|0)+(p<<2)>>2]|0;if((q|0)!=0?(r=f[q>>2]|0,(r|0)!=0):0){if(i){i=r;while(1){q=f[i+4>>2]|0;if(!((q|0)==(m|0)|(q&l|0)==(p|0))){s=p;break a}if((f[i+8>>2]|0)==(j|0)?(Ioc(f[i+12>>2]|0,h)|0)==0:0){t=0;break}i=f[i>>2]|0;if(!i){s=p;break a}}return t|0}else u=r;while(1){i=f[u+4>>2]|0;if((i|0)!=(m|0)){if(i>>>0<k>>>0)v=i;else v=(i>>>0)%(k>>>0)|0;if((v|0)!=(p|0)){s=p;break a}}if((f[u+8>>2]|0)==(j|0)?(Ioc(f[u+12>>2]|0,h)|0)==0:0){t=0;break}u=f[u>>2]|0;if(!u){s=p;break a}}return t|0}else s=p}else s=0;while(0);p=VDc(20)|0;f[p+8>>2]=e;f[p+12>>2]=g;f[p+16>>2]=c;f[p+4>>2]=m;f[p>>2]=0;c=a+12|0;w=+(((f[c>>2]|0)+1|0)>>>0);x=+n[a+16>>2];do if(o|w>+(k>>>0)*x){g=(k>>>0<3|(k+-1&k|0)!=0)&1|k<<1;e=~~+X(+(w/x))>>>0;uUb(a,g>>>0<e>>>0?e:g);g=f[d>>2]|0;e=g+-1|0;if(!(e&g)){y=g;z=e&m;break}if(m>>>0<g>>>0){y=g;z=m}else{y=g;z=(m>>>0)%(g>>>0)|0}}else{y=k;z=s}while(0);s=(f[a>>2]|0)+(z<<2)|0;z=f[s>>2]|0;if(!z){k=a+8|0;f[p>>2]=f[k>>2];f[k>>2]=p;f[s>>2]=k;k=f[p>>2]|0;if(k|0){s=f[k+4>>2]|0;k=y+-1|0;if(k&y)if(s>>>0<y>>>0)A=s;else A=(s>>>0)%(y>>>0)|0;else A=s&k;B=(f[a>>2]|0)+(A<<2)|0;C=35}}else{f[p>>2]=f[z>>2];B=z;C=35}if((C|0)==35)f[B>>2]=p;f[c>>2]=(f[c>>2]|0)+1;t=1;return t|0}function sXb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[c>>2]|0;e=d*65535|0;g=f[c+4>>2]|0;c=b[g>>0]|0;h=d;if(!(c<<24>>24))i=0;else{d=g;j=0;k=c;while(1){c=(j*5|0)+(k<<24>>24)|0;d=d+1|0;k=b[d>>0]|0;if(!(k<<24>>24)){i=c;break}else j=c}}j=i+e|0;e=f[a+4>>2]|0;if(!e){l=0;return l|0}i=e+-1|0;k=(i&e|0)==0;if(!k)if(j>>>0<e>>>0)m=j;else m=(j>>>0)%(e>>>0)|0;else m=i&j;d=f[(f[a>>2]|0)+(m<<2)>>2]|0;if(!d){l=0;return l|0}a=f[d>>2]|0;if(!a){l=0;return l|0}a:do if(k){d=a;while(1){c=f[d+4>>2]|0;n=(c|0)==(j|0);if(!(n|(c&i|0)==(m|0))){l=0;o=24;break}if((n?(f[d+8>>2]|0)==(h|0):0)?(Ioc(f[d+12>>2]|0,g)|0)==0:0){p=d;break a}d=f[d>>2]|0;if(!d){l=0;o=24;break}}if((o|0)==24)return l|0}else{d=a;while(1){n=f[d+4>>2]|0;if((n|0)==(j|0)){if((f[d+8>>2]|0)==(h|0)?(Ioc(f[d+12>>2]|0,g)|0)==0:0){p=d;break a}}else{if(n>>>0<e>>>0)q=n;else q=(n>>>0)%(e>>>0)|0;if((q|0)!=(m|0)){l=0;o=24;break}}d=f[d>>2]|0;if(!d){l=0;o=24;break}}if((o|0)==24)return l|0}while(0);l=f[p+16>>2]|0;return l|0}function tXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+32|0;h=g+12|0;i=g;j=c+11|0;k=b[j>>0]|0;l=c+4|0;m=f[l>>2]|0;if(!((k<<24>>24<0?m:k&255)|0)){kVb(a,d,e,0,483770);u=g;return}n=h+11|0;o=i+11|0;p=0;q=k;k=m;while(1){m=b[(q<<24>>24<0?f[c>>2]|0:c)+p>>0]|0;do if(m<<24>>24<97)if(m<<24>>24<65)if((m+-48&255)>9){r=9;break}else{s=q;t=k;break}else if(m<<24>>24<91|m<<24>>24==95){s=q;t=k;break}else{r=9;break}else if(m<<24>>24>122)r=9;else{s=q;t=k}while(0);if((r|0)==9){r=0;VHa(i,501908,c);jIa(h,i,483784);lVb(a,d,e,0,h);if((b[n>>0]|0)<0)YDc(f[h>>2]|0);if((b[o>>0]|0)<0)YDc(f[i>>2]|0);s=b[j>>0]|0;t=f[l>>2]|0}p=p+1|0;if(p>>>0>=(s<<24>>24<0?t:s&255)>>>0)break;else{q=s;k=t}}u=g;return}function uXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(60)|0;$1b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+68>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function vXb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;i=u;u=u+112|0;j=i+96|0;k=i;l=i+72|0;m=i+108|0;n=i+56|0;o=i+44|0;p=i+32|0;q=i+20|0;r=i+8|0;if(!d)s=f[a+40>>2]|0;else s=d;d=a+4|0;t=f[d>>2]|0;v=h;h=f[v>>2]|0;w=f[v+4>>2]|0;v=c+11|0;f[j>>2]=(b[v>>0]|0)<0?f[c>>2]|0:c;x=j+4|0;f[x>>2]=h;f[x+4>>2]=w;if(wXb(t+132|0,j)|0){x=(b[v>>0]|0)<0?f[c>>2]|0:c;f[j>>2]=x;y=t+200|0;z=f[y>>2]|0;if((z|0)==(f[t+204>>2]|0))oVb(t+196|0,j);else{f[z>>2]=x;f[y>>2]=(f[y>>2]|0)+4}y=f[a+44>>2]|0;x=k;f[x>>2]=h;f[x+4>>2]=w;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];if(xXb(y,s,e,j)|0){A=1;u=i;return A|0}if(b[a+24>>0]|0){A=0;u=i;return A|0}rTb(l,2,475801,3991);oTb(m,mTb(nTb(mTb(l,501908)|0,c)|0,483578)|0);sTb(l);A=0;u=i;return A|0}l=f[d>>2]|0;f[j>>2]=(b[v>>0]|0)<0?f[c>>2]|0:c;v=SUb(l+132|0,j)|0;a:do if(!v)B=0;else{l=f[v+16>>2]|0;switch(f[v+12>>2]|0){case 8:{B=l;break a;break}case 1:{B=f[l+8>>2]|0;break a;break}case 2:{B=f[l+20>>2]|0;break a;break}case 3:{B=f[(f[l+8>>2]|0)+8>>2]|0;break a;break}case 4:{B=f[l+8>>2]|0;break a;break}case 5:{B=f[(f[l+12>>2]|0)+8>>2]|0;break a;break}case 6:{B=f[l+8>>2]|0;break a;break}case 7:{B=f[(f[l+8>>2]|0)+8>>2]|0;break a;break}default:{B=0;break a}}}while(0);if((B|0)!=(f[a+40>>2]|0)){VHa(p,501908,c);jIa(o,p,483739);QJa(n,o,f[B>>2]|0);jIa(j,n,502535);lVb(a,c,g,0,j);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);A=0;u=i;return A|0}B=DEc(c,46,-1)|0;if((B|0)==-1){VHa(n,501908,c);jIa(j,n,483691);lVb(a,c,g,0,j);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);A=0;u=i;return A|0}gEc(q,c,B+1|0,-1,c);VHa(p,501908,q);jIa(o,p,483713);gEc(r,c,0,B,c);QJa(n,o,r);jIa(j,n,502535);lVb(a,c,g,0,j);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if((b[r+11>>0]|0)<0)YDc(f[r>>2]|0);if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);if((b[q+11>>0]|0)<0)YDc(f[q>>2]|0);A=0;u=i;return A|0}function wXb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]|0;e=b[d>>0]|0;if(!(e<<24>>24))g=0;else{h=d;i=0;j=e;while(1){e=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=e;break}else i=e}}i=a+4|0;j=f[i>>2]|0;h=(j|0)==0;a:do if(!h){e=j+-1|0;k=(e&j|0)==0;if(!k)if(g>>>0<j>>>0)l=g;else l=(g>>>0)%(j>>>0)|0;else l=e&g;m=f[(f[a>>2]|0)+(l<<2)>>2]|0;if(!m)o=l;else{if(k){k=m;while(1){k=f[k>>2]|0;if(!k){o=l;break a}p=f[k+4>>2]|0;if(!((p|0)==(g|0)|(p&e|0)==(l|0))){o=l;break a}if(!(Ioc(f[k+8>>2]|0,d)|0)){q=0;break}}return q|0}else r=m;while(1){r=f[r>>2]|0;if(!r){o=l;break a}k=f[r+4>>2]|0;if((k|0)!=(g|0)){if(k>>>0<j>>>0)s=k;else s=(k>>>0)%(j>>>0)|0;if((s|0)!=(l|0)){o=l;break a}}if(!(Ioc(f[r+8>>2]|0,d)|0)){q=0;break}}return q|0}}else o=0;while(0);d=VDc(20)|0;r=d+8|0;f[r>>2]=f[c>>2];f[r+4>>2]=f[c+4>>2];f[r+8>>2]=f[c+8>>2];f[d+4>>2]=g;f[d>>2]=0;c=a+12|0;t=+(((f[c>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(h|t>+(j>>>0)*u){r=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;l=~~+X(+(t/u))>>>0;lUb(a,r>>>0<l>>>0?l:r);r=f[i>>2]|0;l=r+-1|0;if(!(l&r)){v=r;w=l&g;break}if(g>>>0<r>>>0){v=r;w=g}else{v=r;w=(g>>>0)%(r>>>0)|0}}else{v=j;w=o}while(0);o=(f[a>>2]|0)+(w<<2)|0;w=f[o>>2]|0;if(!w){j=a+8|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[o>>2]=j;j=f[d>>2]|0;if(j|0){o=f[j+4>>2]|0;j=v+-1|0;if(j&v)if(o>>>0<v>>>0)x=o;else x=(o>>>0)%(v>>>0)|0;else x=o&j;y=(f[a>>2]|0)+(x<<2)|0;z=32}}else{f[d>>2]=f[w>>2];y=w;z=32}if((z|0)==32)f[y>>2]=d;f[c>>2]=(f[c>>2]|0)+1;q=1;return q|0}function xXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0;g=c;h=(b[d+11>>0]|0)<0?f[d>>2]|0:d;d=h;i=e;e=f[i>>2]|0;j=f[i+4>>2]|0;i=g*65535|0;k=b[h>>0]|0;if(!(k<<24>>24))l=0;else{m=h;o=0;p=k;while(1){k=(o*5|0)+(p<<24>>24)|0;m=m+1|0;p=b[m>>0]|0;if(!(p<<24>>24)){l=k;break}else o=k}}o=l+i|0;i=a+4|0;l=f[i>>2]|0;p=(l|0)==0;a:do if(!p){m=l+-1|0;k=(m&l|0)==0;if(!k)if(o>>>0<l>>>0)q=o;else q=(o>>>0)%(l>>>0)|0;else q=m&o;r=f[(f[a>>2]|0)+(q<<2)>>2]|0;if((r|0)!=0?(s=f[r>>2]|0,(s|0)!=0):0){if(k){k=s;while(1){r=f[k+4>>2]|0;if(!((r|0)==(o|0)|(r&m|0)==(q|0))){t=q;break a}if((f[k+8>>2]|0)==(c|0)?(Ioc(f[k+12>>2]|0,h)|0)==0:0){u=0;break}k=f[k>>2]|0;if(!k){t=q;break a}}return u|0}else v=s;while(1){k=f[v+4>>2]|0;if((k|0)!=(o|0)){if(k>>>0<l>>>0)w=k;else w=(k>>>0)%(l>>>0)|0;if((w|0)!=(q|0)){t=q;break a}}if((f[v+8>>2]|0)==(c|0)?(Ioc(f[v+12>>2]|0,h)|0)==0:0){u=0;break}v=f[v>>2]|0;if(!v){t=q;break a}}return u|0}else t=q}else t=0;while(0);q=VDc(24)|0;f[q+8>>2]=g;f[q+12>>2]=d;d=q+16|0;f[d>>2]=e;f[d+4>>2]=j;f[q+4>>2]=o;f[q>>2]=0;j=a+12|0;x=+(((f[j>>2]|0)+1|0)>>>0);y=+n[a+16>>2];do if(p|x>+(l>>>0)*y){d=(l>>>0<3|(l+-1&l|0)!=0)&1|l<<1;e=~~+X(+(x/y))>>>0;tUb(a,d>>>0<e>>>0?e:d);d=f[i>>2]|0;e=d+-1|0;if(!(e&d)){z=d;A=e&o;break}if(o>>>0<d>>>0){z=d;A=o}else{z=d;A=(o>>>0)%(d>>>0)|0}}else{z=l;A=t}while(0);t=(f[a>>2]|0)+(A<<2)|0;A=f[t>>2]|0;if(!A){l=a+8|0;f[q>>2]=f[l>>2];f[l>>2]=q;f[t>>2]=l;l=f[q>>2]|0;if(l|0){t=f[l+4>>2]|0;l=z+-1|0;if(l&z)if(t>>>0<z>>>0)B=t;else B=(t>>>0)%(z>>>0)|0;else B=t&l;C=(f[a>>2]|0)+(B<<2)|0;D=35}}else{f[q>>2]=f[A>>2];C=A;D=35}if((D|0)==35)f[C>>2]=q;f[j>>2]=(f[j>>2]|0)+1;u=1;return u|0}function yXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;h=g+8|0;i=g;j=a+4|0;k=f[j>>2]|0;l=c+16|0;m=f[l>>2]|0;n=VDc(12)|0;fEc(n,m);f[h>>2]=n;m=k+76|0;o=f[m>>2]|0;if((o|0)==(f[k+80>>2]|0))mVb(k+72|0,h);else{f[o>>2]=n;f[m>>2]=(f[m>>2]|0)+4}f[e>>2]=f[h>>2];f[e+8>>2]=d;m=f[j>>2]|0;j=f[d+4>>2]|0;n=VDc(12)|0;fEc(n,j);f[h>>2]=n;j=m+76|0;o=f[j>>2]|0;if((o|0)==(f[m+80>>2]|0))mVb(m+72|0,h);else{f[o>>2]=n;f[j>>2]=(f[j>>2]|0)+4}j=f[h>>2]|0;pEc(j,1,46)|0;n=f[e>>2]|0;o=b[n+11>>0]|0;m=o<<24>>24<0;tEc(j,m?f[n>>2]|0:n,m?f[n+4>>2]|0:o&255)|0;o=e+4|0;f[o>>2]=j;tXb(a,f[l>>2]|0,j,c);j=e+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;if(!(f[c+8>>2]&8)){f[e+44>>2]=0;p=c+32|0;q=b[p>>0]|0;r=e+48|0;b[r>>0]=q;s=c+33|0;t=b[s>>0]|0;v=e+49|0;b[v>>0]=t;w=f[o>>2]|0;x=f[e>>2]|0;f[i>>2]=7;y=i+4|0;f[y>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];vXb(a,w,d,x,c,h)|0;u=g;return}else{j=f[c+28>>2]|0;l=f[o>>2]|0;AXb(a,l,l,j|0?j:528488,e);p=c+32|0;q=b[p>>0]|0;r=e+48|0;b[r>>0]=q;s=c+33|0;t=b[s>>0]|0;v=e+49|0;b[v>>0]=t;w=f[o>>2]|0;x=f[e>>2]|0;f[i>>2]=7;y=i+4|0;f[y>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];vXb(a,w,d,x,c,h)|0;u=g;return}}function zXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(52)|0;D0b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+12>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function AXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(56)|0;k0b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+44>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function BXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+112|0;h=g+88|0;i=g+60|0;j=g+80|0;k=g+72|0;l=g+48|0;m=g+36|0;n=g+24|0;o=g+12|0;p=g;q=a+4|0;r=f[q>>2]|0;s=c+16|0;t=f[s>>2]|0;v=VDc(12)|0;fEc(v,t);f[h>>2]=v;t=r+76|0;w=f[t>>2]|0;if((w|0)==(f[r+80>>2]|0))mVb(r+72|0,h);else{f[w>>2]=v;f[t>>2]=(f[t>>2]|0)+4}f[e>>2]=f[h>>2];t=e+8|0;f[t>>2]=f[c+24>>2];v=e+12|0;f[v>>2]=d;w=f[q>>2]|0;q=f[d+4>>2]|0;r=VDc(12)|0;fEc(r,q);f[h>>2]=r;q=w+76|0;x=f[q>>2]|0;if((x|0)==(f[w+80>>2]|0))mVb(w+72|0,h);else{f[x>>2]=r;f[q>>2]=(f[q>>2]|0)+4}q=f[h>>2]|0;r=b[q+11>>0]|0;if(r<<24>>24<0)y=f[q+4>>2]|0;else y=r&255;r=f[d>>2]|0;x=b[r+11>>0]|0;if(x<<24>>24<0)z=f[r+4>>2]|0;else z=x&255;oEc(q,y-z|0,0);z=f[e>>2]|0;y=b[z+11>>0]|0;x=y<<24>>24<0;tEc(q,x?f[z>>2]|0:z,x?f[z+4>>2]|0:y&255)|0;y=e+4|0;f[y>>2]=q;tXb(a,f[s>>2]|0,q,c);if(!(f[c+8>>2]&2))f[e+16>>2]=0;else{q=f[c+20>>2]|0;s=f[y>>2]|0;IXb(a,s,s,q|0?q:528376,e)}q=f[y>>2]|0;s=d+12|0;z=f[s>>2]|0;x=f[e>>2]|0;f[j>>2]=5;f[j+4>>2]=e;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];j=vXb(a,q,z,x,c,h)|0;x=a+44|0;z=f[x>>2]|0;q=f[e>>2]|0;f[k>>2]=5;f[k+4>>2]=e;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];if(j|(xXb(z,d,q,h)|0)^1){A=f[x>>2]|0;f[h>>2]=e;B=f[v>>2]|0;C=f[t>>2]|0;f[i>>2]=B;D=i+4|0;f[D>>2]=C;E=A+96|0;JXb(E,i,h)|0;u=g;return};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[s>>2]|0;if(!q)iEc(h,f[(f[a+40>>2]|0)+4>>2]|0)|0;else iEc(h,f[q+4>>2]|0)|0;q=h+11|0;s=b[q>>0]|0;if((s<<24>>24<0?f[h+4>>2]|0:s&255)|0){VHa(l,501908,h);jIa(i,l,501908);iEc(h,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}else nEc(h,484262)|0;s=f[y>>2]|0;VHa(p,484279,f[e>>2]|0);jIa(o,p,484411);QJa(n,o,h);jIa(m,n,484436);QJa(l,m,f[d>>2]|0);jIa(i,l,502535);lVb(a,s,c,0,i);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);if((b[m+11>>0]|0)<0)YDc(f[m>>2]|0);if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);if((b[q>>0]|0)<0)YDc(f[h>>2]|0);A=f[x>>2]|0;f[h>>2]=e;B=f[v>>2]|0;C=f[t>>2]|0;f[i>>2]=B;D=i+4|0;f[D>>2]=C;E=A+96|0;JXb(E,i,h)|0;u=g;return}function CXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;e=u;u=u+112|0;g=e+100|0;h=e+88|0;i=e+76|0;j=e+64|0;k=e+48|0;l=e+16|0;m=e+32|0;n=e;o=f[d>>2]|0;p=b[o+11>>0]|0;q=p<<24>>24<0;r=q?f[o>>2]|0:o;s=q?f[o+4>>2]|0:p&255;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if((s|0)>0){p=0;do{o=b[r+p>>0]|0;if(o<<24>>24!=95){q=o<<24>>24;vEc(h,((o+-65&255)<26?q+32|0:q)&255)}p=p+1|0}while((p|0)<(s|0))}s=i+4|0;f[s>>2]=0;p=i+8|0;f[p>>2]=0;r=i+4|0;f[i>>2]=r;q=d+24|0;do if((f[q>>2]|0)>0){o=d+28|0;t=h+11|0;v=h+4|0;w=g+11|0;x=g+8|0;y=g+4|0;z=l+12|0;A=k+12|0;B=k+11|0;C=l+11|0;D=m+11|0;E=k+11|0;F=l+11|0;G=n+11|0;H=d+8|0;I=c+28|0;J=g+11|0;K=j+11|0;L=0;a:while(1){M=f[o>>2]|0;N=M+(L*20|0)|0;O=f[N>>2]|0;P=b[O+11>>0]|0;Q=P<<24>>24<0;R=Q?f[O>>2]|0:O;S=Q?f[O+4>>2]|0:P&255;P=(S|0)==0;O=b[t>>0]|0;b:do if(P){T=0;U=0;V=O&255;W=26}else{Q=O&255;c:do if(O<<24>>24<0){X=f[v>>2]|0;Y=f[h>>2]|0;Z=0;_=0;while(1){if(_>>>0>=X>>>0){T=_;U=Z;V=Q;W=26;break b}$=b[R+Z>>0]|0;if($<<24>>24!=95){aa=$<<24>>24;if(((($+-65&255)<26?aa+32|0:aa)&255)<<24>>24==(b[Y+_>>0]|0))ba=_+1|0;else break c}else ba=_;aa=Z+1|0;if(aa>>>0<S>>>0){Z=aa;_=ba}else{T=ba;U=aa;V=Q;W=26;break b}}}else{_=0;Z=0;while(1){if(Z>>>0>=Q>>>0){T=Z;U=_;V=Q;W=26;break b}Y=b[R+_>>0]|0;if(Y<<24>>24!=95){X=Y<<24>>24;if((((Y+-65&255)<26?X+32|0:X)&255)<<24>>24==(b[h+Z>>0]|0))ca=Z+1|0;else break c}else ca=Z;X=_+1|0;if(X>>>0<S>>>0){_=X;Z=ca}else{T=ca;U=X;V=Q;W=26;break b}}}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(S>>>0>4294967279){W=20;break a}if(S>>>0<11){b[w>>0]=S;da=g}else{Q=S+16&-16;Z=VDc(Q)|0;f[g>>2]=Z;f[x>>2]=Q|-2147483648;f[y>>2]=S;da=Z}dJc(da|0,R|0,S|0)|0;b[da+S>>0]=0}while(0);do if((W|0)==26){W=0;if(T>>>0<(O<<24>>24<0?f[v>>2]|0:V)>>>0){if(!R){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(S>>>0>4294967279){W=31;break a}if(S>>>0<11){b[w>>0]=S;if(P)ea=g;else{fa=g;W=35}}else{Z=S+16&-16;Q=VDc(Z)|0;f[g>>2]=Q;f[x>>2]=Z|-2147483648;f[y>>2]=S;fa=Q;W=35}if((W|0)==35){W=0;dJc(fa|0,R|0,S|0)|0;ea=fa}b[ea+S>>0]=0;break}d:do if(U>>>0<S>>>0){Q=U;while(1){if((b[R+Q>>0]|0)!=95){ga=Q;break d}Z=Q+1|0;if(Z>>>0<S>>>0)Q=Z;else{ga=Z;break}}}else ga=U;while(0);if((S|0)==(ga|0)){if(!R){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(S>>>0>4294967279){W=43;break a}if(S>>>0<11){b[w>>0]=S;if(P)ha=g;else{ia=g;W=47}}else{Q=S+16&-16;Z=VDc(Q)|0;f[g>>2]=Z;f[x>>2]=Q|-2147483648;f[y>>2]=S;ia=Z;W=47}if((W|0)==47){W=0;dJc(ia|0,R|0,S|0)|0;ha=ia}b[ha+S>>0]=0;break}else{Z=R+ga|0;Q=S-ga|0;if(!Z){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(Q>>>0>4294967279){W=52;break a}if(Q>>>0<11){b[w>>0]=Q;if(!Q)ja=g;else{ka=g;W=56}}else{_=Q+16&-16;X=VDc(_)|0;f[g>>2]=X;f[x>>2]=_|-2147483648;f[y>>2]=Q;ka=X;W=56}if((W|0)==56){W=0;dJc(ka|0,Z|0,Q|0)|0;ja=ka}b[ja+Q>>0]=0;break}}while(0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;S=b[w>>0]|0;mEc(j,S<<24>>24<0?f[y>>2]|0:S&255);S=b[w>>0]|0;if(!((S<<24>>24<0?f[y>>2]|0:S&255)|0))la=S;else{R=1;P=0;O=S;while(1){S=b[(O<<24>>24<0?f[g>>2]|0:g)+P>>0]|0;do if(S<<24>>24!=95){Q=S<<24>>24;if(R){vEc(j,((S+-97&255)<26?Q+224|0:Q)&255);ma=0;break}else{vEc(j,((S+-65&255)<26?Q+32|0:Q)&255);ma=0;break}}else ma=1;while(0);P=P+1|0;S=b[w>>0]|0;if(P>>>0>=(S<<24>>24<0?f[y>>2]|0:S&255)>>>0){la=S;break}else{R=ma;O=S}}}if(la<<24>>24<0)YDc(f[g>>2]|0);fEc(m,j);fEc(l,m);f[z>>2]=N;fEc(k,l);f[A>>2]=f[z>>2];O=FXb(i,g,k)|0;R=f[O>>2]|0;if(!R){P=VDc(32)|0;fEc(P+16|0,k);f[P+28>>2]=f[A>>2];S=f[g>>2]|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=S;f[O>>2]=P;S=f[f[i>>2]>>2]|0;if(!S)na=P;else{f[i>>2]=S;na=f[O>>2]|0}laa(f[s>>2]|0,na);f[p>>2]=(f[p>>2]|0)+1;oa=P;pa=1}else{oa=R;pa=0}if((b[B>>0]|0)<0)YDc(f[k>>2]|0);if((b[C>>0]|0)<0)YDc(f[l>>2]|0);if((b[D>>0]|0)<0)YDc(f[m>>2]|0);e:do if(!(pa<<24>>24)){R=f[oa+28>>2]|0;P=f[R>>2]|0;O=f[N>>2]|0;S=b[P+11>>0]|0;Q=S<<24>>24<0;Z=S&255;S=Q?f[P+4>>2]|0:Z;X=b[O+11>>0]|0;_=X<<24>>24<0;do if((S|0)==((_?f[O+4>>2]|0:X&255)|0)){Y=f[P>>2]|0;aa=Q?Y:P;$=_?f[O>>2]|0:O;qa=(S|0)==0;if(Q){if(qa)break e;if(!(Arc(aa,$,S)|0))break e;else break}if(qa)break e;if((Y&255)<<24>>24==(b[$>>0]|0)){Y=P;qa=Z;aa=$;do{qa=qa+-1|0;Y=Y+1|0;if(!qa)break e;aa=aa+1|0}while((b[Y>>0]|0)==(b[aa>>0]|0))}}while(0);if((f[R+8>>2]|0)!=(f[M+(L*20|0)+8>>2]|0)){VHa(n,484097,j);jIa(l,n,484151);Z=GXb(i,j)|0;QJa(k,l,f[f[Z>>2]>>2]|0);jIa(g,k,484187);if((b[E>>0]|0)<0)YDc(f[k>>2]|0);if((b[F>>0]|0)<0)YDc(f[l>>2]|0);if((b[G>>0]|0)<0)YDc(f[n>>2]|0);Z=f[M+(L*20|0)+4>>2]|0;P=f[(f[I>>2]|0)+4+(L<<2)>>2]|0;if((f[(f[H>>2]|0)+44>>2]|0)==2)GVb(a,Z,P,0,g);else lVb(a,Z,P,0,g);if((b[J>>0]|0)<0)YDc(f[g>>2]|0)}}while(0);if((b[K>>0]|0)<0)YDc(f[j>>2]|0);L=L+1|0;if((L|0)>=(f[q>>2]|0)){W=101;break}}if((W|0)==20)dEc(g);else if((W|0)==31)dEc(g);else if((W|0)==43)dEc(g);else if((W|0)==52)dEc(g);else if((W|0)==101){ra=i;sa=t;ta=f[r>>2]|0;break}}else{ra=i;sa=h+11|0;ta=0}while(0);HXb(ra,ta);if((b[sa>>0]|0)>=0){u=e;return}YDc(f[h>>2]|0);u=e;return}function DXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(52)|0;o1b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function EXb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(c|0)==(i|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(Arc(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(a|0)==(i|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(Arc(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function FXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function GXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=FXb(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=VDc(32)|0;fEc(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}laa(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function HXb(a,c){a=a|0;c=c|0;if(!c)return;HXb(a,f[c>>2]|0);HXb(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function IXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(52)|0;W0b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function JXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=f[c>>2]|0;c=(b*65535|0)+e|0;g=a+4|0;h=f[g>>2]|0;i=(h|0)==0;j=b;a:do if(!i){k=h+-1|0;l=(k&h|0)==0;if(!l)if(c>>>0<h>>>0)m=c;else m=(c>>>0)%(h>>>0)|0;else m=k&c;o=f[(f[a>>2]|0)+(m<<2)>>2]|0;if((o|0)!=0?(p=f[o>>2]|0,(p|0)!=0):0){if(l){l=p;while(1){o=f[l+4>>2]|0;if(!((o|0)==(c|0)|(o&k|0)==(m|0))){q=m;break a}if((f[l+8>>2]|0)==(j|0)?(f[l+12>>2]|0)==(e|0):0){r=0;break}l=f[l>>2]|0;if(!l){q=m;break a}}return r|0}else s=p;while(1){l=f[s+4>>2]|0;if((l|0)!=(c|0)){if(l>>>0<h>>>0)t=l;else t=(l>>>0)%(h>>>0)|0;if((t|0)!=(m|0)){q=m;break a}}if((f[s+8>>2]|0)==(j|0)?(f[s+12>>2]|0)==(e|0):0){r=0;break}s=f[s>>2]|0;if(!s){q=m;break a}}return r|0}else q=m}else q=0;while(0);m=VDc(20)|0;s=m+8|0;f[s>>2]=b;f[s+4>>2]=e;f[m+16>>2]=d;f[m+4>>2]=c;f[m>>2]=0;d=a+12|0;u=+(((f[d>>2]|0)+1|0)>>>0);v=+n[a+16>>2];do if(i|u>+(h>>>0)*v){e=(h>>>0<3|(h+-1&h|0)!=0)&1|h<<1;s=~~+X(+(u/v))>>>0;wUb(a,e>>>0<s>>>0?s:e);e=f[g>>2]|0;s=e+-1|0;if(!(s&e)){w=e;x=s&c;break}if(c>>>0<e>>>0){w=e;x=c}else{w=e;x=(c>>>0)%(e>>>0)|0}}else{w=h;x=q}while(0);q=(f[a>>2]|0)+(x<<2)|0;x=f[q>>2]|0;if(!x){h=a+8|0;f[m>>2]=f[h>>2];f[h>>2]=m;f[q>>2]=h;h=f[m>>2]|0;if(h|0){q=f[h+4>>2]|0;h=w+-1|0;if(h&w)if(q>>>0<w>>>0)y=q;else y=(q>>>0)%(w>>>0)|0;else y=q&h;z=(f[a>>2]|0)+(y<<2)|0;A=33}}else{f[m>>2]=f[x>>2];z=x;A=33}if((A|0)==33)f[z>>2]=m;f[d>>2]=(f[d>>2]|0)+1;r=1;return r|0}function KXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g+8|0;i=g;j=a+4|0;k=f[j>>2]|0;l=f[d+4>>2]|0;m=VDc(12)|0;fEc(m,l);f[h>>2]=m;l=k+76|0;n=f[l>>2]|0;if((n|0)==(f[k+80>>2]|0))mVb(k+72|0,h);else{f[n>>2]=m;f[l>>2]=(f[l>>2]|0)+4}l=f[h>>2]|0;pEc(l,1,46)|0;m=c+16|0;n=f[m>>2]|0;k=b[n+11>>0]|0;o=k<<24>>24<0;tEc(l,o?f[n>>2]|0:n,o?f[n+4>>2]|0:k&255)|0;tXb(a,f[m>>2]|0,l,c);k=f[j>>2]|0;j=f[m>>2]|0;m=VDc(12)|0;fEc(m,j);f[h>>2]=m;j=k+76|0;n=f[j>>2]|0;if((n|0)==(f[k+80>>2]|0))mVb(k+72|0,h);else{f[n>>2]=m;f[j>>2]=(f[j>>2]|0)+4}j=f[h>>2]|0;f[e>>2]=j;m=e+4|0;f[m>>2]=l;f[e+8>>2]=d;f[e+16>>2]=0;f[e+20>>2]=0;if(!(f[c+8>>2]&2)){f[e+24>>2]=0;p=l;q=j;f[i>>2]=3;r=i+4|0;f[r>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];vXb(a,p,d,q,c,h)|0;u=g;return}else{j=f[c+20>>2]|0;NXb(a,l,l,j|0?j:528272,e);p=f[m>>2]|0;q=f[e>>2]|0;f[i>>2]=3;r=i+4|0;f[r>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];vXb(a,p,d,q,c,h)|0;u=g;return}}function LXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(48)|0;Y5b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+8>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function MXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(52)|0;t2b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function NXb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=VDc(48)|0;H1b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))iVb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}RSb(i,e);KSb(k,i)|0;if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);f[g+24>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;fEc(i,c);c=i+12|0;fEc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)mCc(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{p=VDc(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;fEc(a,i);fEc(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;fEc(n+-32|0,j);fEc(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)YDc(f[v>>2]|0);if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)YDc(t)}else{fEc(e,i);fEc(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);u=h;return}function OXb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c;if(!(b[a+49>>0]|0)){rTb(d,3,475801,7065);oTb(c+24|0,mTb(d,484902)|0);sTb(d)}d=a+16|0;e=f[d>>2]|0;if((e|0)<=0){u=c;return}g=a+56|0;h=a+8|0;i=a+52|0;a=0;j=e;while(1){e=f[(f[g>>2]|0)+(a<<2)>>2]|0;if(!e)k=j;else{l=eVb(f[h>>2]|0,e)|0;f[(f[i>>2]|0)+(a<<2)>>2]=l;k=f[d>>2]|0}a=a+1|0;if((a|0)>=(k|0))break;else j=k}u=c;return}function PXb(a){a=a|0;YDc(a);return}function QXb(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&2047](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function RXb(){var a=0;a=VDc(164)|0;sUb(a);f[220829]=a;iTb(134);return}function SXb(){var a=0;a=f[220829]|0;if(a|0){qUb(a);YDc(a)}f[220829]=0;return}function TXb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(152)|0;n7b(a);o=a}else{if(f[l+64>>2]|0)OQb(l,20720,152);a=MQb(l,152)|0;p7b(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function UXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+144|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==527320)WJa(e,i,c);else iEc(h,c)|0;c=a+52|0;if((f[c>>2]|0)>0){h=a+20|0;i=b+16|0;e=0;do{g=(f[h>>2]|0)+(e*88|0)|0;ZXb(g,YXb(i)|0);e=e+1|0}while((e|0)<(f[c>>2]|0))}c=a+56|0;if((f[c>>2]|0)>0){e=a+24|0;i=b+96|0;h=b+108|0;g=b+104|0;j=b+100|0;k=0;do{l=(f[e>>2]|0)+(k*28|0)|0;m=f[h>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[g>>2]|0)){p=o;q=19;break}else{r=o;s=m;q=20;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[g>>2]|0;q=19}while(0);if((q|0)==19){q=0;USb(i,p+1|0);m=f[h>>2]|0;r=f[m>>2]|0;s=m;q=20}if((q|0)==20){q=0;f[s>>2]=r+1;m=f[i>>2]|0;if(!m){n=VDc(24)|0;j5b(n);u=n}else{if(f[m+64>>2]|0)OQb(m,20672,24);n=MQb(m,24)|0;k5b(n,m);u=n}n=f[h>>2]|0;m=f[j>>2]|0;f[j>>2]=m+1;f[n+4+(m<<2)>>2]=u;t=u}iYb(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+60|0;if((f[c>>2]|0)>0){k=a+28|0;t=b+32|0;u=0;do{j=(f[k>>2]|0)+(u*88|0)|0;UXb(j,TXb(t)|0);u=u+1|0}while((u|0)<(f[c>>2]|0))}c=a+64|0;if((f[c>>2]|0)>0){u=a+32|0;t=b+48|0;k=0;do{j=(f[u>>2]|0)+(k*48|0)|0;WXb(j,VXb(t)|0);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+68|0;if((f[c>>2]|0)>0){k=b+64|0;t=b+76|0;u=b+72|0;j=b+68|0;h=a+36|0;i=0;do{r=f[t>>2]|0;do if(r){s=f[j>>2]|0;p=f[r>>2]|0;if((s|0)>=(p|0))if((p|0)==(f[u>>2]|0)){v=p;q=40;break}else{w=p;x=r;q=41;break}else{f[j>>2]=s+1;y=f[r+4+(s<<2)>>2]|0;break}}else{v=f[u>>2]|0;q=40}while(0);if((q|0)==40){q=0;USb(k,v+1|0);r=f[t>>2]|0;w=f[r>>2]|0;x=r;q=41}if((q|0)==41){q=0;f[x>>2]=w+1;r=f[k>>2]|0;if(!r){l=VDc(28)|0;S6b(l);z=l}else{if(f[r+64>>2]|0)OQb(r,20752,32);l=MQb(r,32)|0;U6b(l,r);z=l}l=f[t>>2]|0;r=f[j>>2]|0;f[j>>2]=r+1;f[l+4+(r<<2)>>2]=z;y=z}r=f[h>>2]|0;l=f[r+(i*12|0)>>2]|0;s=y+8|0;p=f[s>>2]|0;f[s>>2]=p|2;f[y+20>>2]=l;l=f[r+(i*12|0)+4>>2]|0;f[s>>2]=p|6;f[y+24>>2]=l;l=f[r+(i*12|0)+8>>2]|0;if((l|0)!=(W7b()|0)){f[s>>2]=f[s>>2]|1;s=y+16|0;r=f[s>>2]|0;if(!r){l7b(y);A=f[s>>2]|0}else A=r;X7b(A,l)}i=i+1|0}while((i|0)<(f[c>>2]|0))}c=a+72|0;if((f[c>>2]|0)>0){i=a+40|0;A=b+80|0;y=0;do{h=(f[i>>2]|0)+(y*88|0)|0;ZXb(h,YXb(A)|0);y=y+1|0}while((y|0)<(f[c>>2]|0))}c=a+76|0;if((f[c>>2]|0)>0){y=b+112|0;A=b+124|0;i=b+120|0;h=b+116|0;z=a+44|0;j=0;do{t=f[A>>2]|0;do if(t){k=f[h>>2]|0;w=f[t>>2]|0;if((k|0)>=(w|0))if((w|0)==(f[i>>2]|0)){B=w;q=62;break}else{C=w;D=t;q=63;break}else{f[h>>2]=k+1;E=f[t+4+(k<<2)>>2]|0;break}}else{B=f[i>>2]|0;q=62}while(0);if((q|0)==62){q=0;USb(y,B+1|0);t=f[A>>2]|0;C=f[t>>2]|0;D=t;q=63}if((q|0)==63){q=0;f[D>>2]=C+1;t=f[y>>2]|0;if(!t){k=VDc(24)|0;x6b(k);F=k}else{if(f[t+64>>2]|0)OQb(t,20736,24);k=MQb(t,24)|0;z6b(k,t);F=k}k=f[A>>2]|0;t=f[h>>2]|0;f[h>>2]=t+1;f[k+4+(t<<2)>>2]=F;E=F}t=f[z>>2]|0;k=f[t+(j<<3)>>2]|0;w=E+8|0;x=f[w>>2]|0;f[w>>2]=x|1;f[E+16>>2]=k;k=f[t+(j<<3)+4>>2]|0;f[w>>2]=x|3;f[E+20>>2]=k;j=j+1|0}while((j|0)<(f[c>>2]|0))}c=a+80|0;if((f[c>>2]|0)>0){j=a+48|0;E=b+128|0;z=0;do{F=f[(f[j>>2]|0)+(z<<2)>>2]|0;iEc(JLa(E)|0,F)|0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=a+16|0;a=f[c>>2]|0;if((a|0)==(_7b()|0))return;f[d>>2]=f[d>>2]|2;d=b+148|0;a=f[d>>2]|0;if(!a){w6b(b);G=f[d>>2]|0}else G=a;$7b(G,f[c>>2]|0);return}function VXb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(72)|0;Q4b(a);o=a}else{if(f[l+64>>2]|0)OQb(l,20640,72);a=MQb(l,72)|0;R4b(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function WXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+64|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==527320)WJa(e,i,c);else iEc(h,c)|0;c=a+24|0;if((f[c>>2]|0)>0){h=a+28|0;i=b+16|0;e=b+28|0;g=b+24|0;j=b+20|0;k=0;do{l=(f[h>>2]|0)+(k*20|0)|0;m=f[e>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[g>>2]|0)){p=o;q=16;break}else{r=o;s=m;q=17;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[g>>2]|0;q=16}while(0);if((q|0)==16){q=0;USb(i,p+1|0);m=f[e>>2]|0;r=f[m>>2]|0;s=m;q=17}if((q|0)==17){q=0;f[s>>2]=r+1;m=f[i>>2]|0;if(!m){n=VDc(28)|0;_3b(n);u=n}else{if(f[m+64>>2]|0)OQb(m,20624,32);n=MQb(m,32)|0;$3b(n,m);u=n}n=f[e>>2]|0;m=f[j>>2]|0;f[j>>2]=m+1;f[n+4+(m<<2)>>2]=u;t=u}hYb(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+32|0;if((f[c>>2]|0)>0){k=b+32|0;t=b+44|0;u=b+40|0;j=b+36|0;e=a+40|0;i=0;do{r=f[t>>2]|0;do if(r){s=f[j>>2]|0;p=f[r>>2]|0;if((s|0)>=(p|0))if((p|0)==(f[u>>2]|0)){v=p;q=31;break}else{w=p;x=r;q=32;break}else{f[j>>2]=s+1;y=f[r+4+(s<<2)>>2]|0;break}}else{v=f[u>>2]|0;q=31}while(0);if((q|0)==31){q=0;USb(k,v+1|0);r=f[t>>2]|0;w=f[r>>2]|0;x=r;q=32}if((q|0)==32){q=0;f[x>>2]=w+1;r=f[k>>2]|0;if(!r){l=VDc(24)|0;v4b(l);z=l}else{if(f[r+64>>2]|0)OQb(r,20656,24);l=MQb(r,24)|0;x4b(l,r);z=l}l=f[t>>2]|0;r=f[j>>2]|0;f[j>>2]=r+1;f[l+4+(r<<2)>>2]=z;y=z}r=f[e>>2]|0;l=f[r+(i<<3)>>2]|0;s=y+8|0;p=f[s>>2]|0;f[s>>2]=p|1;f[y+16>>2]=l;l=f[r+(i<<3)+4>>2]|0;f[s>>2]=p|3;f[y+20>>2]=l;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=a+36|0;if((f[c>>2]|0)>0){i=a+44|0;y=b+48|0;e=0;do{z=f[(f[i>>2]|0)+(e<<2)>>2]|0;iEc(JLa(y)|0,z)|0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=a+16|0;a=f[c>>2]|0;if((a|0)==(e8b()|0))return;f[d>>2]=f[d>>2]|2;d=b+68|0;a=f[d>>2]|0;if(!a){u4b(b);A=f[d>>2]|0}else A=a;f8b(A,f[c>>2]|0);return}function XXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+32|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==527320)WJa(e,i,c);else iEc(h,c)|0;c=a+20|0;if((f[c>>2]|0)>0){h=a+16|0;i=b+16|0;e=b+28|0;g=b+24|0;j=b+20|0;k=0;do{l=(f[h>>2]|0)+(k*52|0)|0;m=f[e>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[g>>2]|0)){p=o;q=15;break}else{r=o;s=m;q=16;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[g>>2]|0;q=15}while(0);if((q|0)==15){q=0;USb(i,p+1|0);m=f[e>>2]|0;r=f[m>>2]|0;s=m;q=16}if((q|0)==16){q=0;f[s>>2]=r+1;m=f[i>>2]|0;if(!m){n=VDc(36)|0;h3b(n);u=n}else{if(f[m+64>>2]|0)OQb(m,20592,40);n=MQb(m,40)|0;i3b(n,m);u=n}n=f[e>>2]|0;m=f[j>>2]|0;f[j>>2]=m+1;f[n+4+(m<<2)>>2]=u;t=u}aYb(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+12|0;a=f[c>>2]|0;if((a|0)==(i8b()|0))return;f[d>>2]=f[d>>2]|2;d=b+36|0;a=f[d>>2]|0;if(!a){D3b(b);v=f[d>>2]|0}else v=a;j8b(v,f[c>>2]|0);return}function YXb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(56)|0;E5b(a);o=a}else{if(f[l+64>>2]|0)OQb(l,20688,56);a=MQb(l,56)|0;F5b(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function ZXb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;i=c+16|0;j=c+4|0;k=f[j>>2]|0;l=k&-2;if(!(k&1))m=l;else m=f[l+4>>2]|0;l=f[i>>2]|0;if((l|0)==527320)WJa(i,m,g);else iEc(l,g)|0;g=f[a+40>>2]|0;l=f[h>>2]|0;f[h>>2]=l|64;f[c+40>>2]=g;do if(b[a+37>>0]|0){g=f[a+16>>2]|0;f[h>>2]=l|80;m=c+32|0;i=f[j>>2]|0;k=i&-2;if(!(i&1))n=k;else n=f[k+4>>2]|0;k=f[m>>2]|0;if((k|0)==527320){WJa(m,n,g);break}else{iEc(k,g)|0;break}}while(0);n=f[a+32>>2]|0;f[h>>2]=f[h>>2]|256;f[c+48>>2]=n;n=a+24|0;l=f[n>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(l,e)}l=a+28|0;g=f[l>>2]|0;k=f[h>>2]|512;f[h>>2]=k;m=c+52|0;f[m>>2]=g;g=a+38|0;if(b[g>>0]|0){i=a+48|0;if(!(b[(f[i>>2]|0)+85>>0]|0)){_Xb(c,518136);o=f[h>>2]|0}else o=k;f[h>>2]=o|2;o=c+20|0;k=f[j>>2]|0;p=k&-2;if(!(k&1))q=p;else q=f[p+4>>2]|0;p=f[o>>2]|0;if((p|0)==527320){WJa(o,q,527320);r=f[o>>2]|0}else r=p;p=f[(f[i>>2]|0)+4>>2]|0;i=b[p+11>>0]|0;o=i<<24>>24<0;tEc(r,o?f[p>>2]|0:p,o?f[p+4>>2]|0:i&255)|0}i=f[n>>2]|0;if(!i)s=0;else{if((f[i>>2]|0)!=2){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(i,e)}s=f[n>>2]|0}i=(s|0)==0;if((f[l>>2]|1|0)!=11){if(!i?(f[s>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(s,e)}if((f[l>>2]|0)==14){l=f[n>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(l,e)}l=a+64|0;if(!(b[(f[l>>2]|0)+21>>0]|0))$Xb(c,518136);f[h>>2]=f[h>>2]|4;p=c+24|0;o=f[j>>2]|0;r=o&-2;if(!(o&1))t=r;else t=f[r+4>>2]|0;r=f[p>>2]|0;if((r|0)==527320){WJa(p,t,527320);v=f[p>>2]|0}else v=r;r=f[n>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(r,e)}r=f[(f[l>>2]|0)+4>>2]|0;l=b[r+11>>0]|0;p=l<<24>>24<0;tEc(v,p?f[r>>2]|0:r,p?f[r+4>>2]|0:l&255)|0}}else{if(!i?(f[s>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(s,e)}s=a+60|0;if(b[(f[s>>2]|0)+84>>0]|0){f[m>>2]=1;f[h>>2]=f[h>>2]&-513}m=f[n>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(m,e)}if(!(b[(f[s>>2]|0)+85>>0]|0))$Xb(c,518136);f[h>>2]=f[h>>2]|4;m=c+24|0;i=f[j>>2]|0;l=i&-2;if(!(i&1))w=l;else w=f[l+4>>2]|0;l=f[m>>2]|0;if((l|0)==527320){WJa(m,w,527320);x=f[m>>2]|0}else x=l;l=f[n>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=a;DTb(l,e)}l=f[(f[s>>2]|0)+4>>2]|0;s=b[l+11>>0]|0;n=s<<24>>24<0;tEc(x,n?f[l>>2]|0:l,n?f[l+4>>2]|0:s&255)|0}if(b[a+36>>0]|0){DWb(e,a,0);f[h>>2]=f[h>>2]|8;s=c+28|0;l=f[j>>2]|0;j=l&-2;if(!(l&1))y=j;else y=f[j+4>>2]|0;j=f[s>>2]|0;if((j|0)==527320)WJa(s,y,e);else iEc(j,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0)}e=f[a+52>>2]|0;if(e|0?(b[g>>0]|0)==0:0){g=(e-(f[(f[e+8>>2]|0)+24>>2]|0)|0)/28|0;f[h>>2]=f[h>>2]|128;f[c+44>>2]=g}g=a+68|0;a=f[g>>2]|0;if((a|0)==(a8b()|0)){u=d;return}f[h>>2]=f[h>>2]|32;h=c+36|0;a=f[h>>2]|0;if(!a){D5b(c);z=f[h>>2]|0}else z=a;b8b(z,f[g>>2]|0);u=d;return}function _Xb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=Mpc(c)|0;if(g>>>0>4294967279)dEc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=VDc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){dJc(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+20|0;a=f[h>>2]|0;if((a|0)==527320)WJa(h,m,e);else iEc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function $Xb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|4;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=Mpc(c)|0;if(g>>>0>4294967279)dEc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=VDc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){dJc(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+24|0;a=f[h>>2]|0;if((a|0)==527320)WJa(h,m,e);else iEc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function aYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;i=c+16|0;j=c+4|0;k=f[j>>2]|0;l=k&-2;if(!(k&1))m=l;else m=f[l+4>>2]|0;l=f[i>>2]|0;if((l|0)==527320)WJa(i,m,g);else iEc(l,g)|0;g=a+12|0;l=a+20|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[e>>2]=161552;f[e+4>>2]=1776;b[e+8>>0]=0;f[e+12>>2]=g;DTb(m,e)}if(!(b[(f[g>>2]|0)+85>>0]|0))cYb(c,518136);f[h>>2]=f[h>>2]|2;m=c+20|0;i=f[j>>2]|0;k=i&-2;if(!(i&1))n=k;else n=f[k+4>>2]|0;k=f[m>>2]|0;if((k|0)==527320){WJa(m,n,527320);o=f[m>>2]|0}else o=k;k=f[l>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[e>>2]=161552;f[e+4>>2]=1776;b[e+8>>0]=0;f[e+12>>2]=g;DTb(k,e)}k=f[(f[g>>2]|0)+4>>2]|0;g=b[k+11>>0]|0;l=g<<24>>24<0;tEc(o,l?f[k>>2]|0:k,l?f[k+4>>2]|0:g&255)|0;g=a+28|0;k=a+36|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[e>>2]=161552;f[e+4>>2]=1776;b[e+8>>0]=0;f[e+12>>2]=g;DTb(l,e)}if(!(b[(f[g>>2]|0)+85>>0]|0))dYb(c,518136);f[h>>2]=f[h>>2]|4;l=c+24|0;o=f[j>>2]|0;j=o&-2;if(!(o&1))p=j;else p=f[j+4>>2]|0;j=f[l>>2]|0;if((j|0)==527320){WJa(l,p,527320);q=f[l>>2]|0}else q=j;j=f[k>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[e>>2]=161552;f[e+4>>2]=1776;b[e+8>>0]=0;f[e+12>>2]=g;DTb(j,e)}e=f[(f[g>>2]|0)+4>>2]|0;g=b[e+11>>0]|0;j=g<<24>>24<0;tEc(q,j?f[e>>2]|0:e,j?f[e+4>>2]|0:g&255)|0;g=a+44|0;e=f[g>>2]|0;if((e|0)!=(k8b()|0)){f[h>>2]=f[h>>2]|8;e=c+28|0;j=f[e>>2]|0;if(!j){g3b(c);r=f[e>>2]|0}else r=j;l8b(r,f[g>>2]|0)}if(b[a+48>>0]|0){f[h>>2]=f[h>>2]|16;b[c+32>>0]=1}if(!(b[a+49>>0]|0)){u=d;return}f[h>>2]=f[h>>2]|32;b[c+33>>0]=1;u=d;return}function bYb(a){a=a|0;eYb(a);return}function cYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=Mpc(c)|0;if(g>>>0>4294967279)dEc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=VDc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){dJc(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+20|0;a=f[h>>2]|0;if((a|0)==527320)WJa(h,m,e);else iEc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function dYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|4;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=Mpc(c)|0;if(g>>>0>4294967279)dEc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=VDc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){dJc(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+24|0;a=f[h>>2]|0;if((a|0)==527320)WJa(h,m,e);else iEc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function eYb(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c;e=c+24|0;g=a+12|0;if(!(b[(f[g>>2]|0)+49>>0]|0)){rTb(d,3,475801,7126);oTb(c+32|0,mTb(d,485247)|0);sTb(d)}if(f[a>>2]|0){u=c;return}d=f[a+4>>2]|0;if(!d){u=c;return}$Vb(e,f[(f[g>>2]|0)+8>>2]|0,d,0);if((f[e>>2]|0)==1)f[a>>2]=f[e+4>>2];u=c;return}function fYb(a){a=a|0;YDc(a);return}function gYb(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&2047](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hYb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+16|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==527320)WJa(e,i,c);else iEc(h,c)|0;c=f[a+8>>2]|0;f[d>>2]=f[d>>2]|4;f[b+24>>2]=c;c=a+16|0;a=f[c>>2]|0;if((a|0)==(g8b()|0))return;f[d>>2]=f[d>>2]|2;d=b+20|0;a=f[d>>2]|0;if(!a){Z3b(b);j=f[d>>2]|0}else j=a;h8b(j,f[c>>2]|0);return}function iYb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+16|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==527320)WJa(e,i,c);else iEc(h,c)|0;c=a+24|0;a=f[c>>2]|0;if((a|0)==(c8b()|0))return;f[d>>2]=f[d>>2]|2;d=b+20|0;a=f[d>>2]|0;if(!a){i5b(b);j=f[d>>2]|0}else j=a;d8b(j,f[c>>2]|0);return}function jYb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[a+84>>2]|0;if(!e){u=c;return}g=d+4|0;h=a+20|0;a=e;do{e=a+16|0;i=f[e>>2]|0;do if(b[i+38>>0]|0){j=f[i+56>>2]|0;if(!j){k=f[i+20>>2]|0;break}else{k=j;break}}else k=f[i+48>>2]|0;while(0);j=f[i+8>>2]|0;if((b[j+11>>0]|0)<0)l=f[j>>2]|0;else l=j;f[d>>2]=k;f[g>>2]=l;rXb(h,d,e)|0;a=f[a>>2]|0}while((a|0)!=0);u=c;return}function kYb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[220825]|0)==2){d=f[220826]|0;u=a;return d|0}f[c>>2]=161028;f[c+4>>2]=132;b[c+8>>0]=0;DTb(883300,c);ZSb(c);d=f[220826]|0;u=a;return d|0}function lYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[220825]|0)!=2){f[e>>2]=161028;f[e+4>>2]=132;b[e+8>>0]=0;DTb(883300,e);ZSb(e)}if(G8b(f[220827]|0,a,c)|0){u=d;return}rTb(g,3,475801,1394);oTb(d+36|0,mTb(g,485359)|0);sTb(g);u=d;return}function mYb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;RUb(d,f[a+16>>2]|0,a,b);u=c;return ((f[d>>2]|0)==1?f[d+4>>2]|0:0)|0}function nYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;RUb(e,f[a+16>>2]|0,a,c);if((f[e>>2]|0)!=2){g=0;u=d;return g|0}c=f[e+4>>2]|0;g=b[c+38>>0]|0?c:0;u=d;return g|0}function oYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[a>>2]|0;if(e){dTb(e);g=a+16|0;h=(f[g>>2]|0)+176|0;i=f[h>>2]|0;do if(i){j=h;k=i;a:while(1){l=k;while(1){m=f[l+16>>2]|0;if(m>>>0>=c>>>0){if(m>>>0>c>>>0)break;if((f[l+20>>2]|0)>=(d|0))break}m=f[l+4>>2]|0;if(!m){n=j;break a}else l=m}k=f[l>>2]|0;if(!k){n=l;break}else j=l}if((n|0)!=(h|0)?(j=f[n+16>>2]|0,j>>>0<=c>>>0):0){if(j>>>0>=c>>>0?(f[n+20>>2]|0)>(d|0):0){o=14;break}j=f[n+24>>2]|0;eTb(e);if(j|0){p=j;return p|0}}else o=14}else o=14;while(0);if((o|0)==14)eTb(e);e=f[a>>2]|0;if(!e){q=g;r=0;s=1}else{dTb(e);q=g;r=e;s=0}}else{q=a+16|0;r=0;s=1}e=f[q>>2]|0;g=e+44|0;if(!(f[g>>2]|0))t=e;else{n=e+40|0;h=f[n>>2]|0;if(h|0){i=h;do{h=i;i=f[i>>2]|0;j=h+8|0;if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);YDc(h)}while((i|0)!=0)}f[n>>2]=0;n=f[e+36>>2]|0;if(n|0){i=e+32|0;e=0;do{f[(f[i>>2]|0)+(e<<2)>>2]=0;e=e+1|0}while((e|0)!=(n|0))}f[g>>2]=0;t=f[q>>2]|0}g=t+24|0;if(!(f[g>>2]|0))u=t;else{n=t+20|0;e=f[n>>2]|0;if(e|0){i=e;do{e=i;i=f[i>>2]|0;h=e+8|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(e)}while((i|0)!=0)}f[n>>2]=0;n=f[t+16>>2]|0;if(n|0){i=t+12|0;t=0;do{f[(f[i>>2]|0)+(t<<2)>>2]=0;t=t+1|0}while((t|0)!=(n|0))}f[g>>2]=0;u=f[q>>2]|0}g=u+176|0;u=f[g>>2]|0;do if(u){n=g;t=u;b:while(1){i=t;while(1){e=f[i+16>>2]|0;if(e>>>0>=c>>>0){if(e>>>0>c>>>0)break;if((f[i+20>>2]|0)>=(d|0))break}e=f[i+4>>2]|0;if(!e){v=n;break b}else i=e}t=f[i>>2]|0;if(!t){v=i;break}else n=i}if((v|0)!=(g|0)?(n=f[v+16>>2]|0,n>>>0<=c>>>0):0){if(n>>>0>=c>>>0?(f[v+20>>2]|0)>(d|0):0){o=48;break}n=f[v+24>>2]|0;if(n){w=n;o=64}else o=48}else o=48}else o=48;while(0);c:do if((o|0)==48){v=f[a+12>>2]|0;if(v|0?(g=oYb(v,c,d)|0,g|0):0){w=g;o=64;break}do if(pYb(a,c,d)|0?(g=(f[q>>2]|0)+176|0,v=f[g>>2]|0,v|0):0){u=g;n=v;d:while(1){v=n;while(1){t=f[v+16>>2]|0;if(t>>>0>=c>>>0){if(t>>>0>c>>>0)break;if((f[v+20>>2]|0)>=(d|0))break}t=f[v+4>>2]|0;if(!t){x=u;break d}else v=t}n=f[v>>2]|0;if(!n){x=v;break}else u=v}if((x|0)!=(g|0)?(u=f[x+16>>2]|0,u>>>0<=c>>>0):0){if(u>>>0>=c>>>0?(f[x+20>>2]|0)>(d|0):0)break;u=f[x+24>>2]|0;if(u|0){w=u;o=64;break c}}}while(0);if(s){p=0;return p|0}else y=0}while(0);if((o|0)==64)if(s){p=w;return p|0}else y=w;eTb(r);p=y;return p|0}function pYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+144|0;g=e+140|0;h=e;i=a+4|0;if(!(f[i>>2]|0)){j=0;u=e;return j|0}N7b(h);k=f[i>>2]|0;do if(hh[f[(f[k>>2]|0)+16>>2]&127](k,f[c+4>>2]|0,d,h)|0){i=f[a+16>>2]|0;l=f[h+120>>2]|0;f[g>>2]=(b[l+11>>0]|0)<0?f[l>>2]|0:l;l=WUb(i+152|0,g)|0;if(l)if(f[l+12>>2]|0){m=0;break}m=(XUb(a,h)|0)!=0}else m=0;while(0);r7b(h);j=m;u=e;return j|0}function qYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[(f[a+8>>2]|0)+88>>2]|0;e=(a*65535|0)+c|0;g=f[d+80>>2]|0;if(!g)return 0;h=g+-1|0;i=(h&g|0)==0;if(!i)if(e>>>0<g>>>0)j=e;else j=(e>>>0)%(g>>>0)|0;else j=h&e;k=f[(f[d+76>>2]|0)+(j<<2)>>2]|0;if(!k)return 0;d=f[k>>2]|0;if(!d)return 0;a:do if(i){k=d;while(1){l=f[k+4>>2]|0;m=(e|0)==(l|0);if(!(m|(l&h|0)==(j|0))){n=23;break}if((m?(f[k+8>>2]|0)==(a|0):0)?(f[k+12>>2]|0)==(c|0):0){o=k;break a}k=f[k>>2]|0;if(!k){n=23;break}}if((n|0)==23)return 0}else{k=d;while(1){m=f[k+4>>2]|0;if((e|0)==(m|0)){if((f[k+8>>2]|0)==(a|0)?(f[k+12>>2]|0)==(c|0):0){o=k;break a}}else{if(m>>>0<g>>>0)p=m;else p=(m>>>0)%(g>>>0)|0;if((p|0)!=(j|0)){n=23;break}}k=f[k>>2]|0;if(!k){n=23;break}}if((n|0)==23)return 0}while(0);n=f[o+16>>2]|0;if(!n)return 0;else return (b[n+38>>0]|0?0:n)|0;return 0}function rYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[(f[a+8>>2]|0)+88>>2]|0;h=g+44|0;if((f[h>>2]|0)!=2){f[e>>2]=161572;f[e+4>>2]=1777;b[e+8>>0]=0;f[e+12>>2]=g;DTb(h,e)}h=(b[c+11>>0]|0)<0?f[c>>2]|0:c;f[e>>2]=a;f[e+4>>2]=h;h=sXb(g+20|0,e)|0;if(!h){u=d;return 0}else{u=d;return (b[h+38>>0]|0?0:h)|0}return 0}function sYb(a){a=a|0;YDc(a);return}function tYb(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&2047](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;EVb(e,f[(f[a+8>>2]|0)+88>>2]|0,a,c);c=(f[e>>2]|0)==2;a=e;e=c?f[a+4>>2]|0:0;if(!((c?f[a>>2]|0:0)|0)){g=0;u=d;return g|0}g=b[e+38>>0]|0?0:e;u=d;return g|0}function vYb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;EVb(d,f[(f[a+8>>2]|0)+88>>2]|0,a,b);b=(f[d>>2]|0)==5;a=d;u=c;return (((b?f[a>>2]|0:0)|0)==0?0:b?f[a+4>>2]|0:0)|0}function wYb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[(f[a+8>>2]|0)+88>>2]|0;d=(a*65535|0)+b|0;e=f[c+100>>2]|0;if(!e){g=0;return g|0}h=e+-1|0;i=(h&e|0)==0;if(!i)if(d>>>0<e>>>0)j=d;else j=(d>>>0)%(e>>>0)|0;else j=h&d;k=f[(f[c+96>>2]|0)+(j<<2)>>2]|0;if(!k){g=0;return g|0}c=f[k>>2]|0;if(!c){g=0;return g|0}a:do if(i){k=c;while(1){l=f[k+4>>2]|0;m=(d|0)==(l|0);if(!(m|(l&h|0)==(j|0))){g=0;n=22;break}if((m?(f[k+8>>2]|0)==(a|0):0)?(f[k+12>>2]|0)==(b|0):0){o=k;break a}k=f[k>>2]|0;if(!k){g=0;n=22;break}}if((n|0)==22)return g|0}else{k=c;while(1){m=f[k+4>>2]|0;if((d|0)==(m|0)){if((f[k+8>>2]|0)==(a|0)?(f[k+12>>2]|0)==(b|0):0){o=k;break a}}else{if(m>>>0<e>>>0)p=m;else p=(m>>>0)%(e>>>0)|0;if((p|0)!=(j|0)){g=0;n=22;break}}k=f[k>>2]|0;if(!k){g=0;n=22;break}}if((n|0)==22)return g|0}while(0);g=f[o+16>>2]|0;return g|0}function xYb(a,b){a=a|0;b=b|0;return yYb(f[(f[a+8>>2]|0)+88>>2]|0,a,b)|0}function yYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+48|0;g=e;h=e+36|0;i=e+24|0;j=e+12|0;k=c;l=(k*65535|0)+d|0;m=f[a+100>>2]|0;a:do if(m|0){n=m+-1|0;o=(n&m|0)==0;if(!o)if(l>>>0<m>>>0)p=l;else p=(l>>>0)%(m>>>0)|0;else p=n&l;q=f[(f[a+96>>2]|0)+(p<<2)>>2]|0;if(q|0?(r=f[q>>2]|0,r|0):0){b:do if(o){q=r;while(1){s=f[q+4>>2]|0;t=(l|0)==(s|0);if(!(t|(s&n|0)==(p|0)))break a;if((t?(f[q+8>>2]|0)==(c|0):0)?(f[q+12>>2]|0)==(d|0):0){v=q;break b}q=f[q>>2]|0;if(!q)break a}}else{q=r;while(1){t=f[q+4>>2]|0;if((l|0)==(t|0)){if((f[q+8>>2]|0)==(c|0)?(f[q+12>>2]|0)==(d|0):0){v=q;break b}}else{if(t>>>0<m>>>0)w=t;else w=(t>>>0)%(m>>>0)|0;if((w|0)!=(p|0))break a}q=f[q>>2]|0;if(!q)break a}}while(0);r=f[v+16>>2]|0;if(r|0){x=r;u=e;return x|0}}}while(0);v=a+160|0;dTb(v);p=a+116|0;w=a+120|0;a=f[w>>2]|0;c:do if(a){m=a+-1|0;r=(m&a|0)==0;if(!r)if(l>>>0<a>>>0)y=l;else y=(l>>>0)%(a>>>0)|0;else y=m&l;n=f[(f[p>>2]|0)+(y<<2)>>2]|0;if((n|0)!=0?(o=f[n>>2]|0,(o|0)!=0):0){d:do if(r){n=o;while(1){q=f[n+4>>2]|0;t=(q|0)==(l|0);if(!(t|(q&m|0)==(y|0))){z=42;break c}if((t?(f[n+8>>2]|0)==(c|0):0)?(f[n+12>>2]|0)==(d|0):0){A=n;break d}n=f[n>>2]|0;if(!n){z=42;break c}}}else{n=o;while(1){t=f[n+4>>2]|0;if((t|0)==(l|0)){if((f[n+8>>2]|0)==(c|0)?(f[n+12>>2]|0)==(d|0):0){A=n;break d}}else{if(t>>>0<a>>>0)B=t;else B=(t>>>0)%(a>>>0)|0;if((B|0)!=(y|0)){z=42;break c}}n=f[n>>2]|0;if(!n){z=42;break c}}}while(0);o=f[A+16>>2]|0;eTb(v);if(o|0){x=o;u=e;return x|0}}else z=42}else z=42;while(0);if((z|0)==42)eTb(v);dTb(v);A=f[w>>2]|0;e:do if(A){w=A+-1|0;y=(w&A|0)==0;if(!y)if(l>>>0<A>>>0)C=l;else C=(l>>>0)%(A>>>0)|0;else C=w&l;B=f[(f[p>>2]|0)+(C<<2)>>2]|0;if((B|0)!=0?(a=f[B>>2]|0,(a|0)!=0):0){f:do if(y){B=a;while(1){o=f[B+4>>2]|0;m=(o|0)==(l|0);if(!(m|(o&w|0)==(C|0))){z=65;break e}if((m?(f[B+8>>2]|0)==(c|0):0)?(f[B+12>>2]|0)==(d|0):0){D=B;break f}B=f[B>>2]|0;if(!B){z=65;break e}}}else{B=a;while(1){m=f[B+4>>2]|0;if((m|0)==(l|0)){if((f[B+8>>2]|0)==(c|0)?(f[B+12>>2]|0)==(d|0):0){D=B;break f}}else{if(m>>>0<A>>>0)E=m;else E=(m>>>0)%(A>>>0)|0;if((E|0)!=(C|0)){z=65;break e}}B=f[B>>2]|0;if(!B){z=65;break e}}}while(0);a=f[D+16>>2]|0;if(a)F=a;else z=65}else z=65}else z=65;while(0);if((z|0)==65){z=f[c>>2]|0;if((b[z+11>>0]|0)<0)G=f[z>>2]|0;else G=z;f[g>>2]=G;f[g+4>>2]=d;Rlc(h,485508,g);if((f[220825]|0)!=2){f[g>>2]=161028;f[g+4>>2]=132;b[g+8>>0]=0;DTb(883300,g);ZSb(g)}G=f[(f[220826]|0)+16>>2]|0;z=VDc(20)|0;f[g>>2]=z;D=G+124|0;C=f[D>>2]|0;if((C|0)==(f[G+128>>2]|0))f6(G+120|0,g);else{f[C>>2]=z;f[D>>2]=(f[D>>2]|0)+4}D=f[g>>2]|0;z=VDc(12)|0;fEc(z,h);f[g>>2]=z;C=G+76|0;E=f[C>>2]|0;A=G+80|0;if((E|0)==(f[A>>2]|0))mVb(G+72|0,g);else{f[E>>2]=z;f[C>>2]=(f[C>>2]|0)+4}f[D>>2]=f[g>>2];jIa(j,f[c+4>>2]|0,518136);QJa(i,j,h);z=VDc(12)|0;fEc(z,i);f[g>>2]=z;E=f[C>>2]|0;if((E|0)==(f[A>>2]|0))mVb(G+72|0,g);else{f[E>>2]=z;f[C>>2]=(f[C>>2]|0)+4}f[D+4>>2]=f[g>>2];if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);f[D+8>>2]=d;f[D+12>>2]=c;c=g8b()|0;f[D+16>>2]=c;f[g>>2]=k;f[g+4>>2]=d;f[i>>2]=D;JXb(p,g,i)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);F=D}eTb(v);x=F;u=e;return x|0}function zYb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+68>>2]|0;if((c|0)<=0){d=0;return d|0}e=f[a+36>>2]|0;a=0;while(1){g=e+(a*12|0)|0;if((f[g>>2]|0)<=(b|0)?(f[e+(a*12|0)+4>>2]|0)>(b|0):0){d=g;h=6;break}a=a+1|0;if((a|0)>=(c|0)){d=0;h=6;break}}if((h|0)==6)return d|0;return 0}function AYb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+76>>2]|0;if((c|0)<=0){d=0;return d|0}e=f[a+44>>2]|0;a=0;while(1){g=e+(a<<3)|0;if((f[g>>2]|0)<=(b|0)?(f[e+(a<<3)+4>>2]|0)>(b|0):0){d=g;h=6;break}a=a+1|0;if((a|0)>=(c|0)){d=0;h=6;break}}if((h|0)==6)return d|0;return 0}function BYb(a){a=a|0;return (b[(f[(f[a+60>>2]|0)+16>>2]|0)+51>>0]|0)!=0|0}function CYb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[a+24>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[d>>2]=78728;f[d+4>>2]=1737;b[d+8>>0]=0;f[d+12>>2]=a;DTb(e,d)}u=c;return f[a+80>>2]|0}function DYb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[a+24>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[d>>2]=78728;f[d+4>>2]=1737;b[d+8>>0]=0;f[d+12>>2]=a;DTb(e,d)}u=c;return f[a+60>>2]|0}function EYb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[a+24>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[d>>2]=78728;f[d+4>>2]=1737;b[d+8>>0]=0;f[d+12>>2]=a;DTb(e,d)}u=c;return f[a+64>>2]|0}function FYb(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[a+32>>2]|0)!=3){e=0;u=c;return e|0}g=f[a+24>>2]|0;if(g|0?(f[g>>2]|0)!=2:0){f[d>>2]=78728;f[d+4>>2]=1737;b[d+8>>0]=0;f[d+12>>2]=a;DTb(g,d)}if(((f[a+28>>2]|0)+-9|0)>>>0<=3){e=0;u=c;return e|0}d=f[a+68>>2]|0;g=(d|0)==0;if((f[(f[a+20>>2]|0)+44>>2]|0)==2){if(g){e=0;u=c;return e|0}e=(b[d+52>>0]|0)!=0;u=c;return e|0}if(g){e=1;u=c;return e|0}if(!(f[d+24>>2]&2)){e=1;u=c;return e|0}e=(b[d+52>>0]|0)!=0;u=c;return e|0}function GYb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=163108;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function HYb(a){a=a|0;GYb(a);YDc(a);return}function IYb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function JYb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(32)|0;S7b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20352,32);a=MQb(b,32)|0;T7b(a,b);c=a;return c|0}function KYb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function LYb(a){a=a|0;return f[a+4>>2]|0}function MYb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function NYb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0){d=1;e=4;break}c=c+-1|0;a=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){d=0;e=4;break}}if((e|0)==4)return d|0;return 0}function OYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;USb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=VDc(140)|0;N7b(a);y=a}else{if(f[o+64>>2]|0)OQb(o,20768,144);a=MQb(o,144)|0;O7b(a,o);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=VRb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}GRb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(LRb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=mNa(m)|0;else B=a&-2;if(!(Djc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function PYb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function QYb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function RYb(a){a=a|0;return f[a+12>>2]|0}function SYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Hjc(j&-2,g)|0;return s|0}function TYb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function UYb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,20352,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}Q7b(a+16|0,c+16|0);return}function VYb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function WYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528824;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function XYb(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220837]|0)!=2){f[c>>2]=161028;f[c+4>>2]=136;b[c+8>>0]=0;DTb(883348,c);ZSb(c)}d=VDc(48)|0;f[c>>2]=d;f[c+8>>2]=-2147483600;f[c+4>>2]=32;e=d;g=485533;h=e+32|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+32>>0]=0;Xbc(c,163208,163532,161584,0,528824,883320,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function YYb(){ZYb();lYb(485566,5968);rhc(485533,1778);return}function ZYb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220838]|0)!=2){f[c>>2]=161028;f[c+4>>2]=137;b[c+8>>0]=0;DTb(883352,c);ZSb(c)}if((f[220839]|0)!=2){f[c>>2]=161028;f[c+4>>2]=138;b[c+8>>0]=0;DTb(883356,c);ZSb(c)}if((f[220840]|0)!=2){f[c>>2]=161028;f[c+4>>2]=139;b[c+8>>0]=0;DTb(883360,c);ZSb(c)}if((f[220841]|0)!=2){f[c>>2]=161028;f[c+4>>2]=140;b[c+8>>0]=0;DTb(883364,c);ZSb(c)}if((f[220842]|0)!=2){f[c>>2]=161028;f[c+4>>2]=141;b[c+8>>0]=0;DTb(883368,c);ZSb(c)}if((f[220843]|0)!=2){f[c>>2]=161028;f[c+4>>2]=142;b[c+8>>0]=0;DTb(883372,c);ZSb(c)}if((f[220844]|0)!=2){f[c>>2]=161028;f[c+4>>2]=143;b[c+8>>0]=0;DTb(883376,c);ZSb(c)}if((f[220845]|0)!=2){f[c>>2]=161028;f[c+4>>2]=144;b[c+8>>0]=0;DTb(883380,c);ZSb(c)}if((f[220846]|0)!=2){f[c>>2]=161028;f[c+4>>2]=145;b[c+8>>0]=0;DTb(883384,c);ZSb(c)}if((f[220847]|0)!=2){f[c>>2]=161028;f[c+4>>2]=146;b[c+8>>0]=0;DTb(883388,c);ZSb(c)}if((f[220848]|0)!=2){f[c>>2]=161028;f[c+4>>2]=147;b[c+8>>0]=0;DTb(883392,c);ZSb(c)}if((f[220849]|0)!=2){f[c>>2]=161028;f[c+4>>2]=148;b[c+8>>0]=0;DTb(883396,c);ZSb(c)}if((f[220850]|0)!=2){f[c>>2]=161028;f[c+4>>2]=149;b[c+8>>0]=0;DTb(883400,c);ZSb(c)}if((f[220851]|0)!=2){f[c>>2]=161028;f[c+4>>2]=150;b[c+8>>0]=0;DTb(883404,c);ZSb(c)}if((f[220852]|0)!=2){f[c>>2]=161028;f[c+4>>2]=151;b[c+8>>0]=0;DTb(883408,c);ZSb(c)}if((f[220853]|0)!=2){f[c>>2]=161028;f[c+4>>2]=152;b[c+8>>0]=0;DTb(883412,c);ZSb(c)}if((f[220854]|0)!=2){f[c>>2]=161028;f[c+4>>2]=153;b[c+8>>0]=0;DTb(883416,c);ZSb(c)}if((f[220855]|0)!=2){f[c>>2]=161028;f[c+4>>2]=154;b[c+8>>0]=0;DTb(883420,c);ZSb(c)}if((f[220856]|0)!=2){f[c>>2]=161028;f[c+4>>2]=155;b[c+8>>0]=0;DTb(883424,c);ZSb(c)}if((f[220857]|0)!=2){f[c>>2]=161028;f[c+4>>2]=156;b[c+8>>0]=0;DTb(883428,c);ZSb(c)}if((f[220858]|0)!=2){f[c>>2]=161028;f[c+4>>2]=157;b[c+8>>0]=0;DTb(883432,c);ZSb(c)}if((f[220859]|0)!=2){f[c>>2]=161028;f[c+4>>2]=158;b[c+8>>0]=0;DTb(883436,c);ZSb(c)}if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}if((f[220861]|0)!=2){f[c>>2]=161028;f[c+4>>2]=160;b[c+8>>0]=0;DTb(883444,c);ZSb(c)}if((f[220862]|0)!=2){f[c>>2]=161028;f[c+4>>2]=161;b[c+8>>0]=0;DTb(883448,c);ZSb(c)}if((f[220863]|0)!=2){f[c>>2]=161028;f[c+4>>2]=162;b[c+8>>0]=0;DTb(883452,c);ZSb(c)}if((f[220864]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=163;b[c+8>>0]=0;DTb(883456,c);ZSb(c);u=a;return}function _Yb(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220836]|0)!=2){f[c>>2]=161028;f[c+4>>2]=135;b[c+8>>0]=0;DTb(883344,c);ZSb(c)}acc(528824,27);u=a;return}function $Yb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220839]|0)!=2){f[c>>2]=161028;f[c+4>>2]=138;b[c+8>>0]=0;DTb(883356,c);ZSb(c)}f[131834]=163108;f[131835]=0;f[131836]=0;f[131837]=0;f[131838]=0;f[131839]=0;f[131840]=0;f[131841]=0;zTb(527336);u=a;return}function aZb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220842]|0)!=2){f[c>>2]=161028;f[c+4>>2]=141;b[c+8>>0]=0;DTb(883368,c);ZSb(c)}if((f[220847]|0)!=2){f[c>>2]=161028;f[c+4>>2]=146;b[c+8>>0]=0;DTb(883388,c);ZSb(c)}if((f[220849]|0)!=2){f[c>>2]=161028;f[c+4>>2]=148;b[c+8>>0]=0;DTb(883396,c);ZSb(c)}if((f[220844]|0)!=2){f[c>>2]=161028;f[c+4>>2]=143;b[c+8>>0]=0;DTb(883376,c);ZSb(c)}if((f[220851]|0)!=2){f[c>>2]=161028;f[c+4>>2]=150;b[c+8>>0]=0;DTb(883404,c);ZSb(c)}if((f[220862]|0)!=2){f[c>>2]=161028;f[c+4>>2]=161;b[c+8>>0]=0;DTb(883448,c);ZSb(c)}f[131842]=166348;f[131843]=0;c=527376;d=c+112|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131872]=527320;f[131873]=527320;f[131874]=527320;c=527500;f[c>>2]=0;f[c+4>>2]=0;zTb(527368);f[131875]=528056;f[131876]=528712;u=a;return}function bZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220843]|0)!=2){f[c>>2]=161028;f[c+4>>2]=142;b[c+8>>0]=0;DTb(883372,c);ZSb(c)}f[131878]=166240;f[131879]=0;f[131880]=0;f[131881]=0;f[131882]=0;f[131883]=0;f[131884]=0;zTb(527512);f[131882]=527720;u=a;return}function cZb(){aTb(3005001,3005e3,491535);SQb();f[131886]=166132;f[131887]=0;f[131888]=0;f[131889]=0;f[131890]=0;f[131891]=0;zTb(527544);return}function dZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220844]|0)!=2){f[c>>2]=161028;f[c+4>>2]=143;b[c+8>>0]=0;DTb(883376,c);ZSb(c)}if((f[220847]|0)!=2){f[c>>2]=161028;f[c+4>>2]=146;b[c+8>>0]=0;DTb(883388,c);ZSb(c)}if((f[220840]|0)!=2){f[c>>2]=161028;f[c+4>>2]=139;b[c+8>>0]=0;DTb(883360,c);ZSb(c)}if((f[220845]|0)!=2){f[c>>2]=161028;f[c+4>>2]=144;b[c+8>>0]=0;DTb(883380,c);ZSb(c)}if((f[220852]|0)!=2){f[c>>2]=161028;f[c+4>>2]=151;b[c+8>>0]=0;DTb(883408,c);ZSb(c)}if((f[220841]|0)==2){f[131892]=166024;f[131893]=0;XIc(527576,0,136)|0;f[131928]=527320;f[131929]=0;zTb(527568);f[131929]=528152;u=a;return}f[c>>2]=161028;f[c+4>>2]=140;b[c+8>>0]=0;DTb(883364,c);ZSb(c);f[131892]=166024;f[131893]=0;XIc(527576,0,136)|0;f[131928]=527320;f[131929]=0;zTb(527568);f[131929]=528152;u=a;return}function eZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[131930]=165916;lkc(527724);f[131935]=0;f[131936]=0;f[131937]=0;f[131938]=0;f[131939]=0;f[131940]=0;f[131941]=0;zTb(527720);u=a;return}function fZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220853]|0)!=2){f[c>>2]=161028;f[c+4>>2]=152;b[c+8>>0]=0;DTb(883412,c);ZSb(c)}f[131942]=165808;f[131943]=0;f[131944]=0;f[131945]=0;f[131946]=527320;f[131947]=527320;f[131948]=527320;f[131949]=527320;f[131950]=527320;f[131951]=0;f[131952]=0;f[131953]=0;f[131954]=1;f[131955]=1;zTb(527768);f[131951]=528208;u=a;return}function gZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220854]|0)!=2){f[c>>2]=161028;f[c+4>>2]=153;b[c+8>>0]=0;DTb(883416,c);ZSb(c)}f[131956]=165700;f[131957]=0;f[131958]=0;f[131959]=0;f[131960]=527320;f[131961]=0;zTb(527824);f[131961]=528272;u=a;return}function hZb(){aTb(3005001,3005e3,491535);SQb();f[131962]=165592;f[131963]=0;f[131964]=0;f[131965]=0;f[131966]=0;f[131967]=0;zTb(527848);return}function iZb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220848]|0)!=2){f[c>>2]=161028;f[c+4>>2]=147;b[c+8>>0]=0;DTb(883392,c);ZSb(c)}if((f[220855]|0)!=2){f[c>>2]=161028;f[c+4>>2]=154;b[c+8>>0]=0;DTb(883420,c);ZSb(c)}if((f[220846]|0)!=2){f[c>>2]=161028;f[c+4>>2]=145;b[c+8>>0]=0;DTb(883384,c);ZSb(c)}f[131968]=165484;f[131969]=0;c=527880;d=c+56|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[131984]=527320;f[131985]=0;zTb(527872);f[131985]=528320;u=a;return}function jZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220856]|0)!=2){f[c>>2]=161028;f[c+4>>2]=155;b[c+8>>0]=0;DTb(883424,c);ZSb(c)}f[131986]=165376;f[131987]=0;f[131988]=0;f[131989]=0;f[131990]=527320;c=527964;f[c>>2]=0;f[c+4>>2]=0;zTb(527944);f[131991]=528376;u=a;return}function kZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220850]|0)!=2){f[c>>2]=161028;f[c+4>>2]=149;b[c+8>>0]=0;DTb(883400,c);ZSb(c)}if((f[220857]|0)!=2){f[c>>2]=161028;f[c+4>>2]=156;b[c+8>>0]=0;DTb(883428,c);ZSb(c)}f[131994]=165268;f[131995]=0;f[131996]=0;f[131997]=0;f[131998]=0;f[131999]=0;f[132e3]=0;f[132001]=0;f[132002]=527320;f[132003]=0;zTb(527976);f[132003]=528432;u=a;return}function lZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220858]|0)!=2){f[c>>2]=161028;f[c+4>>2]=157;b[c+8>>0]=0;DTb(883432,c);ZSb(c)}f[132004]=165160;f[132005]=0;f[132006]=0;f[132007]=0;f[132008]=527320;f[132009]=527320;f[132010]=527320;f[132011]=0;d[264024]=0;zTb(528016);f[132011]=528488;u=a;return}function mZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[132014]=165052;lkc(528060);f[132019]=0;f[132020]=0;f[132021]=0;f[132022]=0;f[132023]=0;f[132024]=0;f[132025]=0;f[132026]=527320;f[132027]=527320;f[132028]=527320;f[132029]=527320;f[132030]=527320;f[132031]=527320;f[132032]=527320;f[132033]=527320;f[132034]=0;f[132035]=0;b[528144]=0;f[132037]=1;zTb(528056);u=a;return}function nZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[132038]=164944;lkc(528156);f[132043]=0;f[132044]=0;f[132045]=0;f[132046]=0;f[132047]=0;f[132048]=0;f[132049]=0;f[132050]=0;zTb(528152);u=a;return}function oZb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[132052]=164836;lkc(528212);c=528228;d=c+40|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));zTb(528208);u=a;return}function pZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[132068]=164728;lkc(528276);f[132073]=0;f[132074]=0;f[132075]=0;f[132076]=0;f[132077]=0;f[132078]=0;f[132079]=0;zTb(528272);u=a;return}function qZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[132080]=164620;lkc(528324);f[132085]=0;f[132086]=0;f[132087]=0;f[132088]=0;f[132089]=0;f[132090]=0;f[132091]=0;d[264184]=0;zTb(528320);u=a;return}function rZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[132094]=164512;lkc(528380);f[132099]=0;f[132100]=0;f[132101]=0;f[132102]=0;f[132103]=0;f[132104]=0;f[132105]=0;b[528424]=0;zTb(528376);u=a;return}function sZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[132108]=164404;lkc(528436);f[132113]=0;f[132114]=0;f[132115]=0;f[132116]=0;f[132117]=0;f[132118]=0;f[132119]=0;b[528480]=0;zTb(528432);u=a;return}function tZb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220860]|0)!=2){f[c>>2]=161028;f[c+4>>2]=159;b[c+8>>0]=0;DTb(883440,c);ZSb(c)}f[132122]=164296;lkc(528492);c=528508;d=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));zTb(528488);u=a;return}function uZb(){aTb(3005001,3005e3,491535);SQb();f[132136]=164188;f[132137]=0;f[132138]=0;f[132139]=0;f[132140]=527320;b[528564]=0;zTb(528544);return}function vZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220859]|0)!=2){f[c>>2]=161028;f[c+4>>2]=158;b[c+8>>0]=0;DTb(883436,c);ZSb(c)}f[132142]=164080;f[132143]=0;f[132144]=0;f[132145]=0;f[132146]=0;f[132147]=0;f[132148]=0;f[132149]=0;f[132150]=527320;f[132151]=527320;f[132152]=527320;f[132154]=0;f[132155]=0;f[132156]=0;f[132157]=0;f[132158]=0;f[132159]=0;zTb(528568);u=a;return}function wZb(){aTb(3005001,3005e3,491535);SQb();f[132160]=163972;f[132161]=0;f[132168]=0;f[132169]=0;f[132170]=0;f[132172]=0;f[132173]=0;f[132174]=0;f[132175]=0;f[132162]=0;f[132163]=0;f[132164]=0;f[132165]=0;f[132166]=0;f[132176]=527320;f[132177]=527320;zTb(528640);return}function xZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220861]|0)!=2){f[c>>2]=161028;f[c+4>>2]=160;b[c+8>>0]=0;DTb(883444,c);ZSb(c)}f[132178]=163864;f[132179]=0;f[132180]=0;f[132181]=0;f[132182]=0;f[132183]=0;f[132184]=0;f[132185]=0;zTb(528712);u=a;return}function yZb(){var a=0;aTb(3005001,3005e3,491535);SQb();f[132186]=163756;f[132187]=0;f[132188]=0;f[132189]=0;f[132190]=0;f[132191]=0;f[132192]=0;f[132194]=527320;a=528780;f[a>>2]=0;f[a+4>>2]=0;zTb(528744);return}function zZb(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,491535);SQb();if((f[220863]|0)!=2){f[c>>2]=161028;f[c+4>>2]=162;b[c+8>>0]=0;DTb(883452,c);ZSb(c)}f[132198]=163648;f[132199]=0;f[132200]=0;f[132201]=0;f[132202]=0;f[132203]=0;f[132204]=0;f[132205]=0;zTb(528792);u=a;return}function AZb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=163648;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function BZb(a){a=a|0;AZb(a);YDc(a);return}function CZb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function DZb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(32)|0;l_b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20368,32);a=MQb(b,32)|0;m_b(a,b);c=a;return c|0}function EZb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function FZb(a){a=a|0;return f[a+4>>2]|0}function GZb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function HZb(a){a=a|0;return 1}function IZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;USb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=VDc(44)|0;SZb(a);y=a}else{if(f[o+64>>2]|0)OQb(o,20384,48);a=MQb(o,48)|0;UZb(a,o);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=VRb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}GRb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(LRb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=mNa(m)|0;else B=a&-2;if(!(Djc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function JZb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function KZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function LZb(a){a=a|0;return f[a+12>>2]|0}function MZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Hjc(j&-2,g)|0;return s|0}function NZb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function OZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,20368,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}RZb(a+16|0,c+16|0);return}function PZb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function QZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=529032;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function RZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{TZb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(44)|0;SZb(l);TZb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20384,48);l=MQb(i,48)|0;UZb(l,i);TZb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function SZb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=163756;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=528744?(f[220863]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=162;b[d+8>>0]=0;DTb(883452,d);ZSb(d)}f[a+12>>2]=0;f[a+32>>2]=527320;d=a+36|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function TZb(a,b){a=a|0;b=b|0;k_b(b,a);return}function UZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=163756;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=a+24|0;f[g>>2]=0;if(c|0){if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c}if((f[220863]|0)!=2){f[e>>2]=161028;f[e+4>>2]=162;b[e+8>>0]=0;DTb(883452,e);ZSb(e)}f[a+12>>2]=0;f[a+32>>2]=527320;e=a+36|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function VZb(a){a=a|0;var c=0,d=0;f[a>>2]=163756;c=f[a+32>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function WZb(a){a=a|0;VZb(a);YDc(a);return}function XZb(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function YZb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(44)|0;SZb(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20384,48);a=MQb(b,48)|0;UZb(a,b);c=a;return c|0}function ZZb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function _Zb(a){a=a|0;return f[a+4>>2]|0}function $Zb(a){a=a|0;var c=0,d=0,e=0,g=0;f[a+16>>2]=0;c=a+8|0;d=f[c>>2]|0;do if(d&1|0?(e=f[a+32>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&6|0){d=a+36|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function a_b(a){a=a|0;return 1}function b_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=c+4|0;e=a+16|0;g=a+20|0;h=a+24|0;i=a+8|0;j=a+32|0;k=a+4|0;l=a+36|0;m=a+40|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{switch((p&255)<<24>>24){case 10:break;case 8:{if(ySa(1,10,c,e)|0)continue a;else{t=0;q=46;break a}break}default:{s=p;break b}}o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;u=a&255}else{a=VRb(c)|0;if((a|0)>-1)u=a;else{t=0;q=46;break a}}a=ERb(c,u)|0;if((MRb(c)|0)>0)do{o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0){n=b[o>>0]|0;v=n&255;if(n<<24>>24>-1){f[c>>2]=o+1;w=v}else{x=v;q=16}}else{x=0;q=16}if((q|0)==16){q=0;v=HRb(c,x)|0;o=J;if((o|0)>-1|(o|0)==-1&v>>>0>4294967295)w=v;else{t=0;q=46;break a}}v=f[e>>2]|0;if((v|0)==(f[g>>2]|0)){KLa(e,v+1|0);y=f[e>>2]|0}else y=v;v=f[h>>2]|0;f[e>>2]=y+1;f[v+4+(y<<2)>>2]=w}while((MRb(c)|0)>0);FRb(c,a);continue a;break}case 2:{if((p&255|0)!=18){s=p;break b}f[i>>2]=f[i>>2]|1;v=f[k>>2]|0;o=v&-2;if(!(v&1))z=o;else z=f[o+4>>2]|0;o=f[j>>2]|0;if((o|0)==527320){WJa(j,z,527320);A=f[j>>2]|0}else A=o;if(fUb(c,A)|0)continue a;else{t=0;q=46;break a}break}case 3:{if((p&255|0)!=24){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0){v=b[o>>0]|0;n=v&255;if(v<<24>>24>-1){f[c>>2]=o+1;B=n}else{C=n;q=33}}else{C=0;q=33}if((q|0)==33){q=0;n=HRb(c,C)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)B=n;else{t=0;q=46;break a}}f[l>>2]=B;continue a;break}case 4:{if((p&255|0)!=32){s=p;break b}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){o=b[n>>0]|0;v=o&255;if(o<<24>>24>-1){f[c>>2]=n+1;D=v}else{E=v;q=39}}else{E=0;q=39}if((q|0)==39){q=0;v=HRb(c,E)|0;n=J;if((n|0)>-1|(n|0)==-1&v>>>0>4294967295)D=v;else{t=0;q=46;break a}}f[m>>2]=D;continue a;break}default:{s=p;break b}}}while(0);if(!s){t=1;q=46;break}v=f[k>>2]|0;if(!(v&1))F=mNa(k)|0;else F=v&-2;if(!(Djc(c,s,F)|0)){t=0;q=46;break}}if((q|0)==46)return t|0;return 0}function c_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=hUb(a+16|0)|0;if(!c)e=d;else{if((c|0)<0)g=11;else g=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=g+d|0}f[a+28>>2]=c;d=e+c|0;c=f[a+8>>2]|0;if(!(c&7)){h=d;i=a+12|0;f[i>>2]=h;return h|0}if(!(c&1))j=d;else{e=f[a+32>>2]|0;g=b[e+11>>0]|0;k=g<<24>>24<0?f[e+4>>2]|0:g&255;j=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=j;else{k=f[a+36>>2]|0;if((k|0)<0)m=11;else m=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+j|0}if(!(c&4)){h=l;i=a+12|0;f[i>>2]=h;return h|0}c=f[a+40>>2]|0;if((c|0)<0)n=11;else n=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=n+l|0;i=a+12|0;f[i>>2]=h;return h|0}function d_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{bSb(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else bSb(c,g);g=f[d>>2]|0;if((g|0)>0){d=a+24|0;o=c+8|0;e=c+4|0;h=0;do{i=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;n=((i|0)<0)<<31>>31;if((f[o>>2]|0)>9){k=f[e>>2]|0;j=i&255;if(i>>>0>127){l=k;m=j;p=i;q=n;while(1){b[l>>0]=m|-128;r=p;p=aJc(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=k;v=j}b[u>>0]=v;q=u+1-k|0;f[e>>2]=(f[e>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else cSb(c,i,n);h=h+1|0}while((h|0)!=(g|0))}}g=f[a+8>>2]|0;if(g&1|0)$Tb(2,f[a+32>>2]|0,c);if(g&2|0)MTb(3,f[a+36>>2]|0,c);if(g&4|0)MTb(4,f[a+40>>2]|0,c);g=f[a+4>>2]|0;if(!(g&1))return;Gjc(g&-2,c);return}function e_b(a){a=a|0;return f[a+12>>2]|0}function f_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=f[c>>2]|0;c=f[a+24>>2]|0;g=0;e=l+1|0;while(1){l=f[c+4+(g<<2)>>2]|0;i=l&255;if(l>>>0>127){h=e;j=i;k=l;n=((l|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;l=k;k=aJc(k|0,n|0,7)|0;o=h+1|0;p=k&255;if(!(n>>>0>0|(n|0)==0&l>>>0>16383)){q=o;r=p;break}else{h=o;j=p;n=J}}}else{q=e;r=i}b[q>>0]=r;n=q+1|0;g=g+1|0;if((g|0)>=(m|0)){s=n;break}else e=n}}else s=d;d=f[a+8>>2]|0;if(!(d&1))t=s;else{e=f[a+32>>2]|0;b[s>>0]=18;t=dSb(e,s+1|0)|0}if(!(d&2))u=t;else{s=f[a+36>>2]|0;b[t>>0]=24;e=t+1|0;t=s&255;if(s>>>0>127){m=e;g=t;q=s;r=((s|0)<0)<<31>>31;while(1){b[m>>0]=g|-128;s=q;q=aJc(q|0,r|0,7)|0;c=m+1|0;n=q&255;if(!(r>>>0>0|(r|0)==0&s>>>0>16383)){v=c;w=n;break}else{m=c;g=n;r=J}}}else{v=e;w=t}b[v>>0]=w;u=v+1|0}if(!(d&4))x=u;else{d=f[a+40>>2]|0;b[u>>0]=32;v=u+1|0;u=d&255;if(d>>>0>127){w=v;t=u;e=d;r=((d|0)<0)<<31>>31;while(1){b[w>>0]=t|-128;d=e;e=aJc(e|0,r|0,7)|0;g=w+1|0;m=e&255;if(!(r>>>0>0|(r|0)==0&d>>>0>16383)){y=g;z=m;break}else{w=g;t=m;r=J}}}else{y=v;z=u}b[y>>0]=z;x=y+1|0}y=f[a+4>>2]|0;if(!(y&1)){A=x;return A|0}A=Hjc(y&-2,x)|0;return A|0}function g_b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function h_b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20384,0)|0;if(!c){Ehc(b,a);return}else{k_b(a,c);return}}function i_b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function j_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=529024;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function k_b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){KLa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=f[b+8>>2]|0;if(!(g&7))return;do if(g&1|0){d=f[b+32>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+32|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==527320){WJa(e,j,d);break}else{iEc(i,d)|0;break}}while(0);if(g&2|0)f[a+36>>2]=f[b+36>>2];if(g&4|0)f[a+40>>2]=f[b+40>>2];b=a+8|0;f[b>>2]=f[b>>2]|g;return}function l_b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=163648;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528792?(f[220864]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=163;b[d+8>>0]=0;DTb(883456,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function m_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=163648;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[220864]|0)==2){g=a+12|0;f[g>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=163;b[e+8>>0]=0;DTb(883456,e);ZSb(e);g=a+12|0;f[g>>2]=0;u=d;return}function n_b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=163864;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function o_b(a){a=a|0;n_b(a);YDc(a);return}function p_b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function q_b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(32)|0;__b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20400,32);a=MQb(b,32)|0;$_b(a,b);c=a;return c|0}function r_b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function s_b(a){a=a|0;return f[a+4>>2]|0}function t_b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function u_b(a){a=a|0;return 1}function v_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;USb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=VDc(72)|0;F_b(a);y=a}else{if(f[o+64>>2]|0)OQb(o,20416,72);a=MQb(o,72)|0;H_b(a,o);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=VRb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}GRb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(LRb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=mNa(m)|0;else B=a&-2;if(!(Djc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function w_b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function x_b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function y_b(a){a=a|0;return f[a+12>>2]|0}function z_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Hjc(j&-2,g)|0;return s|0}function A_b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function B_b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,20400,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}E_b(a+16|0,c+16|0);return}function C_b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function D_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=529016;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function E_b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{G_b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(72)|0;F_b(l);G_b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20416,72);l=MQb(i,72)|0;H_b(l,i);G_b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function F_b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=163972;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528640?(f[220861]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=160;b[d+8>>0]=0;DTb(883444,d);ZSb(d)}f[a+12>>2]=0;f[a+64>>2]=527320;f[a+68>>2]=527320;u=c;return}function G_b(a,b){a=a|0;b=b|0;Z_b(b,a);return}function H_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=163972;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=a+24|0;f[g>>2]=0;if(!c){f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0}else{if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c;f[a+32>>2]=0;f[a+36>>2]=0;h=a+40|0;f[h>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);g=MQb(c,8)|0;f[h>>2]=g;f[g>>2]=c}f[a+48>>2]=c;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;if((f[220861]|0)==2){i=a+12|0;f[i>>2]=0;j=a+64|0;f[j>>2]=527320;k=a+68|0;f[k>>2]=527320;u=d;return}f[e>>2]=161028;f[e+4>>2]=160;b[e+8>>0]=0;DTb(883444,e);ZSb(e);i=a+12|0;f[i>>2]=0;j=a+64|0;f[j>>2]=527320;k=a+68|0;f[k>>2]=527320;u=d;return}function I_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=163972;c=f[a+64>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+68>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+60|0;d=f[c>>2]|0;if(d|0?(f[a+48>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[c>>2]=0;return}function J_b(a){a=a|0;I_b(a);YDc(a);return}function K_b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function L_b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(72)|0;F_b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20416,72);a=MQb(b,72)|0;H_b(a,b);c=a;return c|0}function M_b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function N_b(a){a=a|0;return f[a+4>>2]|0}function O_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a+16>>2]=0;f[a+32>>2]=0;c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0?(g=f[a+64>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&2|0?(e=f[a+68>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function P_b(a){a=a|0;return 1}function Q_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;d=c+4|0;e=a+16|0;g=a+20|0;h=a+24|0;i=a+32|0;j=a+36|0;k=a+40|0;l=a+8|0;m=a+64|0;n=a+4|0;o=a+68|0;p=a+48|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=a+1;s=r;t=6}else{u=r;t=5}}else{u=0;t=5}if((t|0)==5){t=0;r=WRb(c,u)|0;if((r+-1|0)>>>0<127){s=r;t=6}else v=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{switch((s&255)<<24>>24){case 10:break;case 8:{if(ySa(1,10,c,e)|0)continue a;else{w=0;t=58;break a}break}default:{v=s;break b}}r=f[c>>2]|0;if(r>>>0<(f[d>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;x=a&255}else{a=VRb(c)|0;if((a|0)>-1)x=a;else{w=0;t=58;break a}}a=ERb(c,x)|0;if((MRb(c)|0)>0)do{r=f[c>>2]|0;if(r>>>0<(f[d>>2]|0)>>>0){q=b[r>>0]|0;y=q&255;if(q<<24>>24>-1){f[c>>2]=r+1;z=y}else{A=y;t=16}}else{A=0;t=16}if((t|0)==16){t=0;y=HRb(c,A)|0;r=J;if((r|0)>-1|(r|0)==-1&y>>>0>4294967295)z=y;else{w=0;t=58;break a}}y=f[e>>2]|0;if((y|0)==(f[g>>2]|0)){KLa(e,y+1|0);B=f[e>>2]|0}else B=y;y=f[h>>2]|0;f[e>>2]=B+1;f[y+4+(B<<2)>>2]=z}while((MRb(c)|0)>0);FRb(c,a);continue a;break}case 2:{switch((s&255)<<24>>24){case 18:break;case 16:{if(ySa(1,18,c,i)|0)continue a;else{w=0;t=58;break a}break}default:{v=s;break b}}y=f[c>>2]|0;if(y>>>0<(f[d>>2]|0)>>>0?(r=b[y>>0]|0,r<<24>>24>-1):0){f[c>>2]=y+1;C=r&255}else{r=VRb(c)|0;if((r|0)>-1)C=r;else{w=0;t=58;break a}}r=ERb(c,C)|0;if((MRb(c)|0)>0)do{y=f[c>>2]|0;if(y>>>0<(f[d>>2]|0)>>>0){q=b[y>>0]|0;D=q&255;if(q<<24>>24>-1){f[c>>2]=y+1;E=D}else{F=D;t=31}}else{F=0;t=31}if((t|0)==31){t=0;D=HRb(c,F)|0;y=J;if((y|0)>-1|(y|0)==-1&D>>>0>4294967295)E=D;else{w=0;t=58;break a}}D=f[i>>2]|0;if((D|0)==(f[j>>2]|0)){KLa(i,D+1|0);G=f[i>>2]|0}else G=D;D=f[k>>2]|0;f[i>>2]=G+1;f[D+4+(G<<2)>>2]=E}while((MRb(c)|0)>0);FRb(c,r);continue a;break}case 3:{if((s&255|0)!=26){v=s;break b}f[l>>2]=f[l>>2]|1;a=f[n>>2]|0;D=a&-2;if(!(a&1))H=D;else H=f[D+4>>2]|0;D=f[m>>2]|0;if((D|0)==527320){WJa(m,H,527320);I=f[m>>2]|0}else I=D;if(fUb(c,I)|0)continue a;else{w=0;t=58;break a}break}case 4:{if((s&255|0)!=34){v=s;break b}f[l>>2]=f[l>>2]|2;D=f[n>>2]|0;a=D&-2;if(!(D&1))K=a;else K=f[a+4>>2]|0;a=f[o>>2]|0;if((a|0)==527320){WJa(o,K,527320);L=f[o>>2]|0}else L=a;if(fUb(c,L)|0)continue a;else{w=0;t=58;break a}break}case 6:{if((s&255|0)!=50){v=s;break b}if(fUb(c,JLa(p)|0)|0)continue a;else{w=0;t=58;break a}break}default:{v=s;break b}}}while(0);if(!v){w=1;t=58;break}a=f[n>>2]|0;if(!(a&1))M=mNa(n)|0;else M=a&-2;if(!(Djc(c,v,M)|0)){w=0;t=58;break}}if((t|0)==58)return w|0;return 0}function R_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=hUb(a+16|0)|0;if(!c)e=d;else{if((c|0)<0)g=11;else g=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=g+d|0}f[a+28>>2]=c;d=e+c|0;c=hUb(a+32|0)|0;if(!c)h=d;else{if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+d|0}f[a+44>>2]=c;d=f[a+52>>2]|0;i=h+c+d|0;if((d|0)>0){c=f[a+60>>2]|0;h=0;e=i;while(1){g=f[c+4+(h<<2)>>2]|0;j=b[g+11>>0]|0;k=j<<24>>24<0?f[g+4>>2]|0:j&255;j=k+e+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=j;break}else e=j}}else l=i;i=f[a+8>>2]|0;if(!(i&3)){m=l;n=a+12|0;f[n>>2]=m;return m|0}if(!(i&1))o=l;else{e=f[a+64>>2]|0;d=b[e+11>>0]|0;h=d<<24>>24<0?f[e+4>>2]|0:d&255;o=l+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2)){m=o;n=a+12|0;f[n>>2]=m;return m|0}i=f[a+68>>2]|0;h=b[i+11>>0]|0;l=h<<24>>24<0?f[i+4>>2]|0:h&255;m=o+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=a+12|0;f[n>>2]=m;return m|0}function S_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{bSb(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else bSb(c,g);g=f[d>>2]|0;if((g|0)>0){d=a+24|0;o=c+8|0;e=c+4|0;h=0;do{i=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;n=((i|0)<0)<<31>>31;if((f[o>>2]|0)>9){k=f[e>>2]|0;j=i&255;if(i>>>0>127){l=k;m=j;p=i;q=n;while(1){b[l>>0]=m|-128;r=p;p=aJc(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=k;v=j}b[u>>0]=v;q=u+1-k|0;f[e>>2]=(f[e>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else cSb(c,i,n);h=h+1|0}while((h|0)!=(g|0))}}g=a+32|0;if((f[g>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){o=c+4|0;b[f[o>>2]>>0]=18;f[o>>2]=(f[o>>2]|0)+1;o=(f[h>>2]|0)+-1|0;f[h>>2]=o;w=o}else{bSb(c,18);w=f[h>>2]|0}o=f[a+44>>2]|0;if((w|0)>4){w=c+4|0;e=f[w>>2]|0;if(o>>>0>127){u=o;v=e;while(1){b[v>>0]=u|128;d=u>>>7;q=v+1|0;if(u>>>0>16383){u=d;v=q}else{x=q;y=d;break}}}else{x=e;y=o}b[x>>0]=y;y=x+1-e|0;f[w>>2]=(f[w>>2]|0)+y;f[h>>2]=(f[h>>2]|0)-y}else bSb(c,o);o=f[g>>2]|0;if((o|0)>0){g=a+40|0;y=c+8|0;h=c+4|0;w=0;do{e=f[(f[g>>2]|0)+4+(w<<2)>>2]|0;x=((e|0)<0)<<31>>31;if((f[y>>2]|0)>9){v=f[h>>2]|0;u=e&255;if(e>>>0>127){d=v;q=u;m=e;l=x;while(1){b[d>>0]=q|-128;p=m;m=aJc(m|0,l|0,7)|0;t=d+1|0;s=m&255;if(!(l>>>0>0|(l|0)==0&p>>>0>16383)){z=t;A=s;break}else{d=t;q=s;l=J}}}else{z=v;A=u}b[z>>0]=A;l=z+1-v|0;f[h>>2]=(f[h>>2]|0)+l;f[y>>2]=(f[y>>2]|0)-l}else cSb(c,e,x);w=w+1|0}while((w|0)!=(o|0))}}o=f[a+8>>2]|0;if(o&1|0)$Tb(3,f[a+64>>2]|0,c);if(o&2|0)$Tb(4,f[a+68>>2]|0,c);o=f[a+52>>2]|0;if((o|0)>0){w=a+60|0;y=0;do{_Tb(6,f[(f[w>>2]|0)+4+(y<<2)>>2]|0,c);y=y+1|0}while((y|0)!=(o|0))}o=f[a+4>>2]|0;if(!(o&1))return;Gjc(o&-2,c);return}function T_b(a){a=a|0;return f[a+12>>2]|0}function U_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=f[c>>2]|0;c=f[a+24>>2]|0;g=0;e=l+1|0;while(1){l=f[c+4+(g<<2)>>2]|0;i=l&255;if(l>>>0>127){h=e;j=i;k=l;n=((l|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;l=k;k=aJc(k|0,n|0,7)|0;o=h+1|0;p=k&255;if(!(n>>>0>0|(n|0)==0&l>>>0>16383)){q=o;r=p;break}else{h=o;j=p;n=J}}}else{q=e;r=i}b[q>>0]=r;n=q+1|0;g=g+1|0;if((g|0)>=(m|0)){s=n;break}else e=n}}else s=d;d=a+32|0;if((f[d>>2]|0)>0){b[s>>0]=18;e=s+1|0;m=f[a+44>>2]|0;if(m>>>0>127){g=m;q=e;while(1){b[q>>0]=g|128;r=g>>>7;c=q+1|0;if(g>>>0>16383){g=r;q=c}else{t=c;u=r;break}}}else{t=e;u=m}b[t>>0]=u;u=f[d>>2]|0;d=f[a+40>>2]|0;m=0;e=t+1|0;while(1){t=f[d+4+(m<<2)>>2]|0;q=t&255;if(t>>>0>127){g=e;r=q;c=t;n=((t|0)<0)<<31>>31;while(1){b[g>>0]=r|-128;t=c;c=aJc(c|0,n|0,7)|0;j=g+1|0;h=c&255;if(!(n>>>0>0|(n|0)==0&t>>>0>16383)){v=j;w=h;break}else{g=j;r=h;n=J}}}else{v=e;w=q}b[v>>0]=w;n=v+1|0;m=m+1|0;if((m|0)>=(u|0)){x=n;break}else e=n}}else x=s;s=f[a+8>>2]|0;if(!(s&1))y=x;else{e=f[a+64>>2]|0;b[x>>0]=26;y=dSb(e,x+1|0)|0}if(!(s&2))z=y;else{s=f[a+68>>2]|0;b[y>>0]=34;z=dSb(s,y+1|0)|0}y=f[a+52>>2]|0;if((y|0)>0){s=a+60|0;x=0;e=z;while(1){u=f[(f[s>>2]|0)+4+(x<<2)>>2]|0;b[e>>0]=50;m=dSb(u,e+1|0)|0;x=x+1|0;if((x|0)==(y|0)){A=m;break}else e=m}}else A=z;z=f[a+4>>2]|0;if(!(z&1)){B=A;return B|0}B=Hjc(z&-2,A)|0;return B|0}function V_b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function W_b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20416,0)|0;if(!c){Ehc(b,a);return}else{Z_b(a,c);return}}function X_b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=529008;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z_b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){KLa(d,(f[d>>2]|0)+e|0);dJc((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+32|0;d=b+32|0;e=f[d>>2]|0;if(e|0){KLa(g,(f[g>>2]|0)+e|0);dJc((f[a+40>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}yNa(a+48|0,b+48|0);d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0){g=f[b+64>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+64|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==527320){WJa(e,j,g);break}else{iEc(i,g)|0;break}}while(0);if(!(d&2))return;d=f[b+68>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;b=a+68|0;a=f[c>>2]|0;c=a&-2;if(!(a&1))k=c;else k=f[c+4>>2]|0;c=f[b>>2]|0;if((c|0)==527320){WJa(b,k,d);return}else{iEc(c,d)|0;return}}function __b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=163864;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528712?(f[220862]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=161;b[d+8>>0]=0;DTb(883448,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function $_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=163864;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[220862]|0)==2){g=a+12|0;f[g>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=161;b[e+8>>0]=0;DTb(883448,e);ZSb(e);g=a+12|0;f[g>>2]=0;u=d;return}function a$b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=164080;Q$b(a);b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function b$b(a){a=a|0;a$b(a);YDc(a);return}function c$b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function d$b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(72)|0;O$b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20432,72);a=MQb(b,72)|0;P$b(a,b);c=a;return c|0}function e$b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function f$b(a){a=a|0;return f[a+4>>2]|0}function g$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&7|0){do if(d&1|0?(g=f[a+32>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0?(e=f[a+36>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&4|0?(g=f[a+40>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);if(d&56|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function h$b(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0){d=1;e=4;break}c=c+-1|0;a=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){d=0;e=4;break}}if((e|0)==4)return d|0;return 0}function i$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+16|0;j=a+28|0;k=a+24|0;l=a+20|0;m=e+4|0;n=a+8|0;o=a+32|0;q=a+4|0;r=a+48|0;t=e+8|0;v=a+56|0;w=e+8|0;x=a+64|0;y=a+36|0;z=a+40|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=a+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=WRb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;switch(C>>>3&536870911|0){case 2:{if((C&255|0)!=18){F=C;break b}B=f[j>>2]|0;do if(B){a=f[l>>2]|0;A=f[B>>2]|0;if((a|0)>=(A|0))if((A|0)==(f[k>>2]|0)){G=A;D=13;break}else{H=A;I=B;D=14;break}else{f[l>>2]=a+1;J=f[B+4+(a<<2)>>2]|0;break}}else{G=f[k>>2]|0;D=13}while(0);if((D|0)==13){D=0;USb(i,G+1|0);B=f[j>>2]|0;H=f[B>>2]|0;I=B;D=14}if((D|0)==14){D=0;f[I>>2]=H+1;B=f[i>>2]|0;if(!B){a=VDc(24)|0;t$b(a);K=a}else{if(f[B+64>>2]|0)OQb(B,20448,24);a=MQb(B,24)|0;v$b(a,B);K=a}a=f[j>>2]|0;B=f[l>>2]|0;f[l>>2]=B+1;f[a+4+(B<<2)>>2]=K;J=K}B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(a=b[B>>0]|0,a<<24>>24>-1):0){f[c>>2]=B+1;L=a&255}else{a=VRb(c)|0;if((a|0)>-1)L=a;else{M=0;D=72;break a}}GRb(e,c,L);if((f[m>>2]|0)<0){D=26;break a}if(!(Mi[f[(f[J>>2]|0)+44>>2]&1023](J,c)|0)){D=26;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{M=0;D=72;break a}break}case 3:{if((C&255|0)!=26){F=C;break b}f[n>>2]=f[n>>2]|1;a=f[q>>2]|0;B=a&-2;if(!(a&1))N=B;else N=f[B+4>>2]|0;B=f[o>>2]|0;if((B|0)==527320){WJa(o,N,527320);O=f[o>>2]|0}else O=B;if(fUb(c,O)|0)continue a;else{M=0;D=72;break a}break}case 4:{if((C&255|0)!=32){F=C;break b}f[n>>2]=f[n>>2]|8;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(a=b[B>>0]|0,a<<24>>24>-1):0){A=r;f[A>>2]=a&255;f[A+4>>2]=0;f[c>>2]=B+1;continue a}IRb(e,c);B=e;A=f[B+4>>2]|0;a=r;f[a>>2]=f[B>>2];f[a+4>>2]=A;if(!(b[t>>0]|0)){M=0;D=72;break a}else continue a;break}case 5:{if((C&255|0)!=40){F=C;break b}f[n>>2]=f[n>>2]|16;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){f[c>>2]=A+1;P=a&255;Q=0}else{IRb(e,c);a=e;if(!(b[w>>0]|0)){M=0;D=72;break a}else{P=f[a>>2]|0;Q=f[a+4>>2]|0}}a=v;f[a>>2]=P;f[a+4>>2]=Q;continue a;break}case 6:{if((C&255|0)!=49){F=C;break b}f[n>>2]=f[n>>2]|32;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>7){A=a;B=A;R=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=A+4|0;A=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=e;f[B>>2]=R;f[B+4>>2]=A;f[c>>2]=a+8;f[s>>2]=R;f[s+4>>2]=A;S=+p[s>>3]}else{if(!(URb(c,e)|0)){D=52;break a}S=+p[e>>3]}p[x>>3]=S;continue a;break}case 7:{if((C&255|0)!=58){F=C;break b}f[n>>2]=f[n>>2]|2;A=f[q>>2]|0;R=A&-2;if(!(A&1))T=R;else T=f[R+4>>2]|0;R=f[y>>2]|0;if((R|0)==527320){WJa(y,T,527320);U=f[y>>2]|0}else U=R;if(fUb(c,U)|0)continue a;else{M=0;D=72;break a}break}case 8:{if((C&255|0)!=66){F=C;break b}f[n>>2]=f[n>>2]|4;R=f[q>>2]|0;A=R&-2;if(!(R&1))V=A;else V=f[A+4>>2]|0;A=f[z>>2]|0;if((A|0)==527320){WJa(z,V,527320);W=f[z>>2]|0}else W=A;if(fUb(c,W)|0)continue a;else{M=0;D=72;break a}break}default:{F=C;break b}}}while(0);if(!F){M=1;D=72;break}A=f[q>>2]|0;if(!(A&1))X=mNa(q)|0;else X=A&-2;if(!(Djc(c,F,X)|0)){M=0;D=72;break}}if((D|0)==26){M=0;u=d;return M|0}else if((D|0)==52){M=0;u=d;return M|0}else if((D|0)==72){u=d;return M|0}return 0}function j$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+8>>2]|0;if(!(i&63)){k=g;l=a+12|0;f[l>>2]=k;return k|0}if(!(i&1))m=g;else{c=f[a+32>>2]|0;h=b[c+11>>0]|0;d=h<<24>>24<0?f[c+4>>2]|0:h&255;m=g+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2))n=m;else{d=f[a+36>>2]|0;g=b[d+11>>0]|0;h=g<<24>>24<0?f[d+4>>2]|0:g&255;n=m+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&4))o=n;else{h=f[a+40>>2]|0;m=b[h+11>>0]|0;g=m<<24>>24<0?f[h+4>>2]|0:m&255;o=n+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&8))p=o;else{g=a+48|0;n=iJc(f[g>>2]|1|0,f[g+4>>2]|0,1)|0;p=o+1+((((n^63)*9|0)+73|0)>>>6)|0}if(!(i&16))q=p;else{n=a+56|0;o=iJc(f[n>>2]|1|0,f[n+4>>2]|0,1)|0;q=p+1+((((o^63)*9|0)+73|0)>>>6)|0}k=i&32|0?q+9|0:q;l=a+12|0;f[l>>2]=k;return k|0}function k$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eUb(2,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+8>>2]|0;if(c&1|0)$Tb(3,f[a+32>>2]|0,b);if(c&8|0){e=a+48|0;PTb(4,f[e>>2]|0,f[e+4>>2]|0,b)}if(c&16|0){e=a+56|0;NTb(5,f[e>>2]|0,f[e+4>>2]|0,b)}if(c&32|0)XTb(6,+p[a+64>>3],b);if(c&2|0)bUb(7,f[a+36>>2]|0,b);if(c&4|0)$Tb(8,f[a+40>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function l$b(a){a=a|0;return f[a+12>>2]|0}function m$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=18;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;q=n+1|0;if(m>>>0>16383){m=o;n=q}else{r=q;t=o;break}}}else{r=k;t=l}b[r>>0]=t;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,r+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+8>>2]|0;if(!(j&1))u=g;else{e=f[a+32>>2]|0;b[g>>0]=26;u=dSb(e,g+1|0)|0}if(!(j&8))v=u;else{g=a+48|0;e=f[g>>2]|0;i=f[g+4>>2]|0;b[u>>0]=32;g=u+1|0;u=e&255;if(i>>>0>0|(i|0)==0&e>>>0>127){r=g;c=u;t=e;e=i;while(1){b[r>>0]=c|-128;i=t;t=aJc(t|0,e|0,7)|0;h=r+1|0;n=t&255;if(!(e>>>0>0|(e|0)==0&i>>>0>16383)){w=h;x=n;break}else{r=h;c=n;e=J}}}else{w=g;x=u}b[w>>0]=x;v=w+1|0}if(!(j&16))y=v;else{w=a+56|0;x=f[w>>2]|0;u=f[w+4>>2]|0;b[v>>0]=40;w=v+1|0;v=x&255;if(u>>>0>0|(u|0)==0&x>>>0>127){g=w;e=v;c=x;x=u;while(1){b[g>>0]=e|-128;u=c;c=aJc(c|0,x|0,7)|0;r=g+1|0;t=c&255;if(!(x>>>0>0|(x|0)==0&u>>>0>16383)){z=r;A=t;break}else{g=r;e=t;x=J}}}else{z=w;A=v}b[z>>0]=A;y=z+1|0}if(!(j&32))B=y;else{C=+p[a+64>>3];b[y>>0]=49;z=y+1|0;p[s>>3]=C;b[z>>0]=b[s>>0];b[z+1>>0]=b[s+1>>0];b[z+2>>0]=b[s+2>>0];b[z+3>>0]=b[s+3>>0];b[z+4>>0]=b[s+4>>0];b[z+5>>0]=b[s+5>>0];b[z+6>>0]=b[s+6>>0];b[z+7>>0]=b[s+7>>0];B=y+9|0}if(!(j&2))D=B;else{y=f[a+36>>2]|0;b[B>>0]=58;D=dSb(y,B+1|0)|0}if(!(j&4))E=D;else{j=f[a+40>>2]|0;b[D>>0]=66;E=dSb(j,D+1|0)|0}D=f[a+4>>2]|0;if(!(D&1)){F=E;return F|0}F=Hjc(D&-2,E)|0;return F|0}function n$b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function o$b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20432,0)|0;if(!c){Ehc(b,a);return}else{r$b(a,c);return}}function p$b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function q$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=529e3;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function r$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}s$b(a+16|0,b+16|0);d=f[b+8>>2]|0;if(!(d&63))return;do if(d&1|0){g=f[b+32>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+32|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==527320){WJa(e,j,g);break}else{iEc(i,g)|0;break}}while(0);do if(d&2|0){j=f[b+36>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+36|0;i=f[c>>2]|0;e=i&-2;if(!(i&1))k=e;else k=f[e+4>>2]|0;e=f[g>>2]|0;if((e|0)==527320){WJa(g,k,j);break}else{iEc(e,j)|0;break}}while(0);do if(d&4|0){k=f[b+40>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|4;j=a+40|0;e=f[c>>2]|0;g=e&-2;if(!(e&1))l=g;else l=f[g+4>>2]|0;g=f[j>>2]|0;if((g|0)==527320){WJa(j,l,k);break}else{iEc(g,k)|0;break}}while(0);if(d&8|0){l=b+48|0;c=f[l+4>>2]|0;k=a+48|0;f[k>>2]=f[l>>2];f[k+4>>2]=c}if(d&16|0){c=b+56|0;k=f[c+4>>2]|0;l=a+56|0;f[l>>2]=f[c>>2];f[l+4>>2]=k}if(d&32|0)p[a+64>>3]=+p[b+64>>3];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function s$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{u$b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(24)|0;t$b(l);u$b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20448,24);l=MQb(i,24)|0;v$b(l,i);u$b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function t$b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=164188;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=528544?(f[220859]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=158;b[d+8>>0]=0;DTb(883436,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;b[a+20>>0]=0;u=c;return}function u$b(a,b){a=a|0;b=b|0;N$b(b,a);return}function v$b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=164188;f[a+4>>2]=c;f[a+8>>2]=0;if((f[220859]|0)!=2){f[e>>2]=161028;f[e+4>>2]=158;b[e+8>>0]=0;DTb(883436,e);ZSb(e)}f[a+12>>2]=0;f[a+16>>2]=527320;b[a+20>>0]=0;u=d;return}function w$b(a){a=a|0;var c=0,d=0;f[a>>2]=164188;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function x$b(a){a=a|0;w$b(a);YDc(a);return}function y$b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function z$b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(24)|0;t$b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20448,24);a=MQb(b,24)|0;v$b(a,b);c=a;return c|0}function A$b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function B$b(a){a=a|0;return f[a+4>>2]|0}function C$b(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0?(d=f[a+16>>2]|0,(d|0)!=527320):0){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);b[a+20>>0]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function D$b(a){a=a|0;return (f[a+8>>2]&3|0)==3|0}function E$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;a=e+8|0;a:while(1){l=f[c>>2]|0;if(l>>>0<(f[g>>2]|0)>>>0){m=b[l>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=l+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=WRb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;switch(o>>>3&536870911|0){case 1:break;case 2:{if((o&255|0)!=16){r=o;break b}f[h>>2]=f[h>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(l=b[n>>0]|0,l<<24>>24>-1):0){f[c>>2]=n+1;s=l<<24>>24!=0}else{IRb(e,c);l=e;if(!(b[a>>0]|0)){t=0;p=25;break a}else s=(f[l>>2]|0)!=0|(f[l+4>>2]|0)!=0}b[k>>0]=s&1;continue a;break}default:{r=o;break b}}if((o&255|0)==10){f[h>>2]=f[h>>2]|1;l=f[j>>2]|0;n=l&-2;if(!(l&1))v=n;else v=f[n+4>>2]|0;n=f[i>>2]|0;if((n|0)==527320){WJa(i,v,527320);w=f[i>>2]|0}else w=n;if(fUb(c,w)|0)continue a;else{t=0;p=25;break a}}else r=o}while(0);if(!r){t=1;p=25;break}n=f[j>>2]|0;if(!(n&1))x=mNa(j)|0;else x=n&-2;if(!(Djc(c,r,x)|0)){t=0;p=25;break}}if((p|0)==25){u=d;return t|0}return 0}function F$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if((c&3|0)==3){e=f[a+16>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0?f[e+4>>2]|0:g&255;i=d+3+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=a+12|0;f[j>>2]=i;return i|0}if(!(c&1))k=0;else{h=f[a+16>>2]|0;g=b[h+11>>0]|0;e=g<<24>>24<0?f[h+4>>2]|0:g&255;k=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}i=(c&2|0?k+2|0:k)+d|0;j=a+12|0;f[j>>2]=i;return i|0}function G$b(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)$Tb(1,f[a+16>>2]|0,c);if(d&2|0)YTb(2,(b[a+20>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function H$b(a){a=a|0;return f[a+12>>2]|0}function I$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=dSb(g,d+1|0)|0}if(!(c&2))h=e;else{c=b[a+20>>0]|0;b[e>>0]=16;b[e+1>>0]=c;h=e+2|0}e=f[a+4>>2]|0;if(!(e&1)){i=h;return i|0}i=Hjc(e&-2,h)|0;return i|0}function J$b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function K$b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20448,0)|0;if(!c){Ehc(b,a);return}else{N$b(a,c);return}}function L$b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function M$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528992;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function N$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&3))return;do if(e&1|0){h=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==527320){WJa(g,k,h);break}else{iEc(j,h)|0;break}}while(0);if(e&2|0)b[a+20>>0]=b[c+20>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function O$b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=164080;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528568?(f[220860]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=159;b[d+8>>0]=0;DTb(883440,d);ZSb(d)}f[a+12>>2]=0;f[a+32>>2]=527320;f[a+36>>2]=527320;f[a+40>>2]=527320;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function P$b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=164080;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[220860]|0)!=2){f[e>>2]=161028;f[e+4>>2]=159;b[e+8>>0]=0;DTb(883440,e);ZSb(e)}f[a+12>>2]=0;f[a+32>>2]=527320;f[a+36>>2]=527320;f[a+40>>2]=527320;e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;u=d;return}function Q$b(a){a=a|0;var c=0;c=f[a+32>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+36>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+40>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function R$b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=164296;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function S$b(a){a=a|0;R$b(a);YDc(a);return}function T$b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function U$b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(56)|0;k0b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20464,56);a=MQb(b,56)|0;l0b(a,b);c=a;return c|0}function V$b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function W$b(a){a=a|0;return f[a+20>>2]|0}function X$b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;Clc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}b=a+24|0;if(f[b>>2]&3|0){c=a+48|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Y$b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function Z$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+32|0;m=e+4|0;n=a+4|0;o=a+20|0;p=a+52|0;a:while(1){b:while(1){a=f[c>>2]|0;q=f[g>>2]|0;do if(a>>>0<q>>>0){r=b[a>>0]|0;s=r&255;t=a+1|0;if(r<<24>>24>0){v=t;w=s}else{if(t>>>0>=q>>>0){x=s;y=8;break}r=h[t>>0]|0;if(((r^128)&s)>>>0<=127){x=s;y=8;break}v=a+2|0;w=s+-128+(r<<7)|0}f[c>>2]=v;z=w;y=10}else{x=0;y=8}while(0);if((y|0)==8){y=0;a=WRb(c,x)|0;if((a+-1|0)>>>0<16383){z=a;y=10}else A=a}c:do if((y|0)==10){y=0;switch(z>>>3&536870911|0){case 33:{if((z&255|0)!=8){A=z;break c}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;B=q<<24>>24!=0}else{IRb(e,c);q=e;if(!(b[k>>0]|0)){C=0;y=47;break a}else B=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0}b[j>>0]=B&1;continue b;break}case 34:{if((z&255|0)==16)break b;else{A=z;break c}break}case 999:{if((z&255|0)!=58){A=z;break c}q=j0b(l)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;D=r&255}else{r=VRb(c)|0;if((r|0)>-1)D=r;else{C=0;y=47;break a}}GRb(e,c,D);if((f[m>>2]|0)<0){y=35;break a}if(!(Mi[f[(f[q>>2]|0)+44>>2]&1023](q,c)|0)){y=35;break a}if(LRb(c,f[e>>2]|0)|0)continue b;else{C=0;y=47;break a}break}default:{A=z;break c}}}while(0);if(!A){C=1;y=47;break a}q=f[o>>2]|0;r=(q&1|0)==0;if(A>>>0>7999){if(r)E=mNa(o)|0;else E=q&-2;if(x9b(n,A,c,528488,E)|0)continue;else{C=0;y=47;break a}}else{if(r)F=mNa(o)|0;else F=q&-2;if(Djc(c,A,F)|0)continue;else{C=0;y=47;break a}}}q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0){r=b[q>>0]|0;a=r&255;if(r<<24>>24>-1){f[c>>2]=q+1;G=a}else{H=a;y=21}}else{H=0;y=21}if((y|0)==21){y=0;a=HRb(c,H)|0;q=J;if((q|0)>-1|(q|0)==-1&a>>>0>4294967295)G=a;else{C=0;y=47;break}}if(G>>>0<3){f[i>>2]=f[i>>2]|2;f[p>>2]=G;continue}a=f[o>>2]|0;if(!(a&1))I=mNa(o)|0;else I=a&-2;rjc(I,34,G,((G|0)<0)<<31>>31)}if((y|0)==35){C=0;u=d;return C|0}else if((y|0)==47){u=d;return C|0}return 0}function _$b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=Nlc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Jjc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b)e=c;else{d=a+44|0;g=0;h=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=c;break}else h=c}}h=f[a+24>>2]|0;if(!(h&3)){j=e;k=a+28|0;f[k>>2]=j;return j|0}b=h&1|0?e+3|0:e;if(!(h&2)){j=b;k=a+28|0;f[k>>2]=j;return j|0}h=f[a+52>>2]|0;if((h|0)<0)l=12;else l=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;j=l+b|0;k=a+28|0;f[k>>2]=j;return j|0}function $$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)YTb(33,(b[a+48>>0]|0)!=0,c);if(d&2|0)ZTb(34,f[a+52>>2]|0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eUb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Llc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function a0b(a){a=a|0;return f[a+28>>2]|0}function b0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=b[a+48>>0]|0;b[d>>0]=-120;b[d+1>>0]=2;b[d+2>>0]=h;g=d+3|0}if(!(e&2))i=g;else{e=f[a+52>>2]|0;b[g>>0]=-112;b[g+1>>0]=2;d=g+2|0;g=e&255;if(e>>>0>127){h=d;j=g;k=e;l=((e|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;e=k;k=aJc(k|0,l|0,7)|0;m=h+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&e>>>0>16383)){o=m;p=n;break}else{h=m;j=n;l=J}}}else{o=d;p=g}b[o>>0]=p;i=o+1|0}o=f[a+36>>2]|0;if(!o)q=i;else{p=a+44|0;g=0;d=i;while(1){i=f[(f[p>>2]|0)+4+(g<<2)>>2]|0;b[d>>0]=-70;b[d+1>>0]=62;l=d+2|0;j=_i[f[(f[i>>2]|0)+60>>2]&1023](i)|0;if(j>>>0>127){h=j;k=l;while(1){b[k>>0]=h|128;n=h>>>7;m=k+1|0;if(h>>>0>16383){h=n;k=m}else{r=m;s=n;break}}}else{r=l;s=j}b[r>>0]=s;k=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,r+1|0)|0;g=g+1|0;if((g|0)==(o|0)){q=k;break}else d=k}}d=B9b(a+4|0,1e3,536870912,c,q)|0;q=f[a+20>>2]|0;if(!(q&1)){t=d;return t|0}t=Hjc(q&-2,d)|0;return t|0}function c0b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function d0b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20464,0)|0;if(!c){Ehc(b,a);return}else{g0b(a,c);return}}function e0b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function f0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528984;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function g0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;Dlc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,c+32|0);e=f[c+24>>2]|0;if(!(e&3))return;if(e&1|0)b[a+48>>0]=b[c+48>>0]|0;if(e&2|0)f[a+52>>2]=f[c+52>>2];c=a+24|0;f[c>>2]=f[c>>2]|e;return}function h0b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{i0b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(72)|0;O$b(l);i0b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20432,72);l=MQb(i,72)|0;P$b(l,i);i0b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function i0b(a,b){a=a|0;b=b|0;r$b(b,a);return}function j0b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(72)|0;O$b(a);o=a}else{if(f[l+64>>2]|0)OQb(l,20432,72);a=MQb(l,72)|0;P$b(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function k0b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=164296;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528488?(f[220858]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=157;b[d+8>>0]=0;DTb(883432,d);ZSb(d)}f[a+28>>2]=0;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function l0b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=164296;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220858]|0)!=2){f[e>>2]=161028;f[e+4>>2]=157;b[e+8>>0]=0;DTb(883432,e);ZSb(e)}f[a+28>>2]=0;e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function m0b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=164404;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function n0b(a){a=a|0;m0b(a);YDc(a);return}function o0b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function p0b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(52)|0;D0b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20480,56);a=MQb(b,56)|0;E0b(a,b);c=a;return c|0}function q0b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function r0b(a){a=a|0;return f[a+20>>2]|0}function s0b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;Clc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}b[a+48>>0]=0;f[a+24>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function t0b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function u0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+32|0;m=e+4|0;n=a+4|0;o=a+20|0;a:while(1){a=f[c>>2]|0;p=f[g>>2]|0;do if(a>>>0<p>>>0){q=b[a>>0]|0;r=q&255;s=a+1|0;if(q<<24>>24>0){t=s;v=r}else{if(s>>>0>=p>>>0){w=r;x=7;break}q=h[s>>0]|0;if(((q^128)&r)>>>0<=127){w=r;x=7;break}t=a+2|0;v=r+-128+(q<<7)|0}f[c>>2]=t;y=v;x=9}else{w=0;x=7}while(0);if((x|0)==7){x=0;a=WRb(c,w)|0;if((a+-1|0)>>>0<16383){y=a;x=9}else z=a}b:do if((x|0)==9){x=0;switch(y>>>3&536870911|0){case 33:{if((y&255|0)!=8){z=y;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(p=b[a>>0]|0,p<<24>>24>-1):0){f[c>>2]=a+1;A=p<<24>>24!=0}else{IRb(e,c);p=e;if(!(b[k>>0]|0)){B=0;x=35;break a}else A=(f[p>>2]|0)!=0|(f[p+4>>2]|0)!=0}b[j>>0]=A&1;continue a;break}case 999:break;default:{z=y;break b}}if((y&255|0)==58){p=j0b(l)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;C=q&255}else{q=VRb(c)|0;if((q|0)>-1)C=q;else{B=0;x=35;break a}}GRb(e,c,C);if((f[m>>2]|0)<0){x=23;break a}if(!(Mi[f[(f[p>>2]|0)+44>>2]&1023](p,c)|0)){x=23;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;x=35;break a}}else z=y}while(0);if(!z){B=1;x=35;break}p=f[o>>2]|0;q=(p&1|0)==0;if(z>>>0>7999){if(q)D=mNa(o)|0;else D=p&-2;if(x9b(n,z,c,528432,D)|0)continue;else{B=0;x=35;break}}else{if(q)E=mNa(o)|0;else E=p&-2;if(Djc(c,z,E)|0)continue;else{B=0;x=35;break}}}if((x|0)==23){B=0;u=d;return B|0}else if((x|0)==35){u=d;return B|0}return 0}function v0b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=Nlc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Jjc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b){e=c;g=a+24|0;h=f[g>>2]|0;i=h&1;j=(i|0)!=0;k=e+3|0;l=j?k:e;m=a+28|0;f[m>>2]=l;return l|0}d=a+44|0;n=0;o=c;while(1){c=f[(f[d>>2]|0)+4+(n<<2)>>2]|0;p=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=p+o+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=n+1|0;if((n|0)==(b|0)){e=c;break}else o=c}g=a+24|0;h=f[g>>2]|0;i=h&1;j=(i|0)!=0;k=e+3|0;l=j?k:e;m=a+28|0;f[m>>2]=l;return l|0}function w0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if(f[a+24>>2]&1|0)YTb(33,(b[a+48>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eUb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Llc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function x0b(a){a=a|0;return f[a+28>>2]|0}function y0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a+24>>2]&1))e=d;else{g=b[a+48>>0]|0;b[d>>0]=-120;b[d+1>>0]=2;b[d+2>>0]=g;e=d+3|0}d=f[a+36>>2]|0;if(!d)h=e;else{g=a+44|0;i=0;j=e;while(1){e=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=-70;b[j+1>>0]=62;k=j+2|0;l=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,q+1|0)|0;i=i+1|0;if((i|0)==(d|0)){h=n;break}else j=n}}j=B9b(a+4|0,1e3,536870912,c,h)|0;h=f[a+20>>2]|0;if(!(h&1)){s=j;return s|0}s=Hjc(h&-2,j)|0;return s|0}function z0b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function A0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,20480,0)|0;if(!d){Ehc(c,a);return}Dlc(a+4|0,d+4|0);c=a+20|0;e=f[d+20>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,d+32|0);if(!(f[d+24>>2]&1))return;e=b[d+48>>0]|0;d=a+24|0;f[d>>2]=f[d>>2]|1;b[a+48>>0]=e;return}function B0b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function C0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528976;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function D0b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=164404;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528432?(f[220857]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=156;b[d+8>>0]=0;DTb(883428,d);ZSb(d)}f[a+28>>2]=0;b[a+48>>0]=0;u=c;return}function E0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=164404;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220857]|0)==2){g=a+28|0;f[g>>2]=0;h=a+48|0;b[h>>0]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=156;b[e+8>>0]=0;DTb(883428,e);ZSb(e);g=a+28|0;f[g>>2]=0;h=a+48|0;b[h>>0]=0;u=d;return}function F0b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=164512;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function G0b(a){a=a|0;F0b(a);YDc(a);return}function H0b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function I0b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(52)|0;W0b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20496,56);a=MQb(b,56)|0;X0b(a,b);c=a;return c|0}function J0b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function K0b(a){a=a|0;return f[a+20>>2]|0}function L0b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;Clc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}b[a+48>>0]=0;f[a+24>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function M0b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function N0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+32|0;m=e+4|0;n=a+4|0;o=a+20|0;a:while(1){a=f[c>>2]|0;p=f[g>>2]|0;do if(a>>>0<p>>>0){q=b[a>>0]|0;r=q&255;s=a+1|0;if(q<<24>>24>0){t=s;v=r}else{if(s>>>0>=p>>>0){w=r;x=7;break}q=h[s>>0]|0;if(((q^128)&r)>>>0<=127){w=r;x=7;break}t=a+2|0;v=r+-128+(q<<7)|0}f[c>>2]=t;y=v;x=9}else{w=0;x=7}while(0);if((x|0)==7){x=0;a=WRb(c,w)|0;if((a+-1|0)>>>0<16383){y=a;x=9}else z=a}b:do if((x|0)==9){x=0;switch(y>>>3&536870911|0){case 1:{if((y&255|0)!=8){z=y;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(p=b[a>>0]|0,p<<24>>24>-1):0){f[c>>2]=a+1;A=p<<24>>24!=0}else{IRb(e,c);p=e;if(!(b[k>>0]|0)){B=0;x=35;break a}else A=(f[p>>2]|0)!=0|(f[p+4>>2]|0)!=0}b[j>>0]=A&1;continue a;break}case 999:break;default:{z=y;break b}}if((y&255|0)==58){p=j0b(l)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;C=q&255}else{q=VRb(c)|0;if((q|0)>-1)C=q;else{B=0;x=35;break a}}GRb(e,c,C);if((f[m>>2]|0)<0){x=23;break a}if(!(Mi[f[(f[p>>2]|0)+44>>2]&1023](p,c)|0)){x=23;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;x=35;break a}}else z=y}while(0);if(!z){B=1;x=35;break}p=f[o>>2]|0;q=(p&1|0)==0;if(z>>>0>7999){if(q)D=mNa(o)|0;else D=p&-2;if(x9b(n,z,c,528376,D)|0)continue;else{B=0;x=35;break}}else{if(q)E=mNa(o)|0;else E=p&-2;if(Djc(c,z,E)|0)continue;else{B=0;x=35;break}}}if((x|0)==23){B=0;u=d;return B|0}else if((x|0)==35){u=d;return B|0}return 0}function O0b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=Nlc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Jjc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b){e=c;g=a+24|0;h=f[g>>2]|0;i=h&1;j=(i|0)!=0;k=e+2|0;l=j?k:e;m=a+28|0;f[m>>2]=l;return l|0}d=a+44|0;n=0;o=c;while(1){c=f[(f[d>>2]|0)+4+(n<<2)>>2]|0;p=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=p+o+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=n+1|0;if((n|0)==(b|0)){e=c;break}else o=c}g=a+24|0;h=f[g>>2]|0;i=h&1;j=(i|0)!=0;k=e+2|0;l=j?k:e;m=a+28|0;f[m>>2]=l;return l|0}function P0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if(f[a+24>>2]&1|0)YTb(1,(b[a+48>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eUb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Llc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function Q0b(a){a=a|0;return f[a+28>>2]|0}function R0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a+24>>2]&1))e=d;else{g=b[a+48>>0]|0;b[d>>0]=8;b[d+1>>0]=g;e=d+2|0}d=f[a+36>>2]|0;if(!d)h=e;else{g=a+44|0;i=0;j=e;while(1){e=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=-70;b[j+1>>0]=62;k=j+2|0;l=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,q+1|0)|0;i=i+1|0;if((i|0)==(d|0)){h=n;break}else j=n}}j=B9b(a+4|0,1e3,536870912,c,h)|0;h=f[a+20>>2]|0;if(!(h&1)){s=j;return s|0}s=Hjc(h&-2,j)|0;return s|0}function S0b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function T0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,20496,0)|0;if(!d){Ehc(c,a);return}Dlc(a+4|0,d+4|0);c=a+20|0;e=f[d+20>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,d+32|0);if(!(f[d+24>>2]&1))return;e=b[d+48>>0]|0;d=a+24|0;f[d>>2]=f[d>>2]|1;b[a+48>>0]=e;return}function U0b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function V0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528968;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function W0b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=164512;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528376?(f[220856]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=155;b[d+8>>0]=0;DTb(883424,d);ZSb(d)}f[a+28>>2]=0;b[a+48>>0]=0;u=c;return}function X0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=164512;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220856]|0)==2){g=a+28|0;f[g>>2]=0;h=a+48|0;b[h>>0]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=155;b[e+8>>0]=0;DTb(883424,e);ZSb(e);g=a+28|0;f[g>>2]=0;h=a+48|0;b[h>>0]=0;u=d;return}function Y0b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=164620;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function Z0b(a){a=a|0;Y0b(a);YDc(a);return}function _0b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function $0b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(52)|0;o1b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20512,56);a=MQb(b,56)|0;p1b(a,b);c=a;return c|0}function a1b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function b1b(a){a=a|0;return f[a+20>>2]|0}function c1b(a){a=a|0;var b=0,c=0,e=0,g=0,h=0;Clc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){e=f[a+44>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(c|0));f[b>>2]=0}d[a+48>>1]=0;f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function d1b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function e1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+49|0;m=e+8|0;n=a+32|0;o=e+4|0;p=a+4|0;q=a+20|0;a:while(1){a=f[c>>2]|0;r=f[g>>2]|0;do if(a>>>0<r>>>0){s=b[a>>0]|0;t=s&255;v=a+1|0;if(s<<24>>24>0){w=v;x=t}else{if(v>>>0>=r>>>0){y=t;z=7;break}s=h[v>>0]|0;if(((s^128)&t)>>>0<=127){y=t;z=7;break}w=a+2|0;x=t+-128+(s<<7)|0}f[c>>2]=w;A=x;z=9}else{y=0;z=7}while(0);if((z|0)==7){z=0;a=WRb(c,y)|0;if((a+-1|0)>>>0<16383){A=a;z=9}else B=a}b:do if((z|0)==9){z=0;switch(A>>>3&536870911|0){case 2:{if((A&255|0)!=16){B=A;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;C=r<<24>>24!=0}else{IRb(e,c);r=e;if(!(b[k>>0]|0)){D=0;z=41;break a}else C=(f[r>>2]|0)!=0|(f[r+4>>2]|0)!=0}b[j>>0]=C&1;continue a;break}case 3:{if((A&255|0)!=24){B=A;break b}f[i>>2]=f[i>>2]|2;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;E=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[m>>0]|0)){D=0;z=41;break a}else E=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[l>>0]=E&1;continue a;break}case 999:{if((A&255|0)!=58){B=A;break b}a=j0b(n)|0;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(s=b[r>>0]|0,s<<24>>24>-1):0){f[c>>2]=r+1;F=s&255}else{s=VRb(c)|0;if((s|0)>-1)F=s;else{D=0;z=41;break a}}GRb(e,c,F);if((f[o>>2]|0)<0){z=29;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){z=29;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{D=0;z=41;break a}break}default:{B=A;break b}}}while(0);if(!B){D=1;z=41;break}a=f[q>>2]|0;s=(a&1|0)==0;if(B>>>0>7999){if(s)G=mNa(q)|0;else G=a&-2;if(x9b(p,B,c,528320,G)|0)continue;else{D=0;z=41;break}}else{if(s)H=mNa(q)|0;else H=a&-2;if(Djc(c,B,H)|0)continue;else{D=0;z=41;break}}}if((z|0)==29){D=0;u=d;return D|0}else if((z|0)==41){u=d;return D|0}return 0}function f1b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=Nlc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Jjc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b)e=c;else{d=a+44|0;g=0;h=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=c;break}else h=c}}h=f[a+24>>2]|0;if(!(h&3)){j=e;k=a+28|0;f[k>>2]=j;return j|0}b=h&1|0?e+2|0:e;j=h&2|0?b+2|0:b;k=a+28|0;f[k>>2]=j;return j|0}function g1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)YTb(2,(b[a+48>>0]|0)!=0,c);if(d&2|0)YTb(3,(b[a+49>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eUb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Llc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function h1b(a){a=a|0;return f[a+28>>2]|0}function i1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=b[a+48>>0]|0;b[d>>0]=16;b[d+1>>0]=h;g=d+2|0}if(!(e&2))i=g;else{e=b[a+49>>0]|0;b[g>>0]=24;b[g+1>>0]=e;i=g+2|0}g=f[a+36>>2]|0;if(!g)j=i;else{e=a+44|0;d=0;h=i;while(1){i=f[(f[e>>2]|0)+4+(d<<2)>>2]|0;b[h>>0]=-70;b[h+1>>0]=62;k=h+2|0;l=_i[f[(f[i>>2]|0)+60>>2]&1023](i)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,q+1|0)|0;d=d+1|0;if((d|0)==(g|0)){j=n;break}else h=n}}h=B9b(a+4|0,1e3,536870912,c,j)|0;j=f[a+20>>2]|0;if(!(j&1)){s=h;return s|0}s=Hjc(j&-2,h)|0;return s|0}function j1b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function k1b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20512,0)|0;if(!c){Ehc(b,a);return}else{n1b(a,c);return}}function l1b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function m1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528960;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function n1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;Dlc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,c+32|0);e=f[c+24>>2]|0;if(!(e&3))return;if(e&1|0)b[a+48>>0]=b[c+48>>0]|0;if(e&2|0)b[a+49>>0]=b[c+49>>0]|0;c=a+24|0;f[c>>2]=f[c>>2]|e;return}function o1b(a){a=a|0;var c=0,e=0,g=0;c=u;u=u+16|0;e=c;f[a>>2]=164620;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;g=a+32|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((a|0)!=528320?(f[220855]|0)!=2:0){f[e>>2]=161028;f[e+4>>2]=154;b[e+8>>0]=0;DTb(883420,e);ZSb(e)}f[a+28>>2]=0;d[a+48>>1]=0;u=c;return}function p1b(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;f[a>>2]=164620;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220855]|0)==2){h=a+28|0;f[h>>2]=0;i=a+48|0;d[i>>1]=0;u=e;return}f[g>>2]=161028;f[g+4>>2]=154;b[g+8>>0]=0;DTb(883420,g);ZSb(g);h=a+28|0;f[h>>2]=0;i=a+48|0;d[i>>1]=0;u=e;return}function q1b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=164728;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function r1b(a){a=a|0;q1b(a);YDc(a);return}function s1b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function t1b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(48)|0;H1b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20528,48);a=MQb(b,48)|0;I1b(a,b);c=a;return c|0}function u1b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function v1b(a){a=a|0;return f[a+20>>2]|0}function w1b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;Clc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function x1b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function y1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+32|0;j=e+4|0;k=a+4|0;l=a+20|0;while(1){a=f[c>>2]|0;m=f[g>>2]|0;do if(a>>>0<m>>>0){n=b[a>>0]|0;o=n&255;p=a+1|0;if(n<<24>>24>0){q=p;r=o}else{if(p>>>0>=m>>>0){s=o;t=7;break}n=h[p>>0]|0;if(((n^128)&o)>>>0<=127){s=o;t=7;break}q=a+2|0;r=o+-128+(n<<7)|0}f[c>>2]=q;v=r;t=9}else{s=0;t=7}while(0);if((t|0)==7){t=0;a=WRb(c,s)|0;if((a+-1|0)>>>0<16383){v=a;t=9}else w=a}if((t|0)==9){t=0;if((v|0)==7994){a=j0b(i)|0;m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[c>>2]=m+1;x=n&255}else{n=VRb(c)|0;if((n|0)>-1)x=n;else{y=0;t=28;break}}GRb(e,c,x);if((f[j>>2]|0)<0){t=16;break}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){t=16;break}if(LRb(c,f[e>>2]|0)|0)continue;else{y=0;t=28;break}}else w=v}if(!w){y=1;t=28;break}a=f[l>>2]|0;n=(a&1|0)==0;if(w>>>0>7999){if(n)z=mNa(l)|0;else z=a&-2;if(x9b(k,w,c,528272,z)|0)continue;else{y=0;t=28;break}}else{if(n)A=mNa(l)|0;else A=a&-2;if(Djc(c,w,A)|0)continue;else{y=0;t=28;break}}}if((t|0)==16){y=0;u=d;return y|0}else if((t|0)==28){u=d;return y|0}return 0}function z1b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=Nlc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Jjc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b){e=c;g=a+28|0;f[g>>2]=e;return e|0}d=a+44|0;h=0;i=c;while(1){c=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=c;break}else i=c}g=a+28|0;f[g>>2]=e;return e|0}function A1b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+36>>2]|0;if(c|0){d=a+44|0;e=0;do{eUb(999,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}Llc(a+4|0,1e3,536870912,b);c=f[a+20>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function B1b(a){a=a|0;return f[a+28>>2]|0}function C1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+36>>2]|0;if(!e)g=d;else{h=a+44|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=-70;b[j+1>>0]=62;k=j+2|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=B9b(a+4|0,1e3,536870912,c,g)|0;g=f[a+20>>2]|0;if(!(g&1)){s=j;return s|0}s=Hjc(g&-2,j)|0;return s|0}function D1b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function E1b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,20528,0)|0;if(!c){Ehc(b,a);return}Dlc(a+4|0,c+4|0);b=a+20|0;d=f[c+20>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}h0b(a+32|0,c+32|0);return}function F1b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function G1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528952;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function H1b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=164728;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528272?(f[220854]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=153;b[d+8>>0]=0;DTb(883416,d);ZSb(d)}f[a+28>>2]=0;u=c;return}function I1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=164728;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220854]|0)==2){g=a+28|0;f[g>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=153;b[e+8>>0]=0;DTb(883416,e);ZSb(e);g=a+28|0;f[g>>2]=0;u=d;return}function J1b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=164836;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function K1b(a){a=a|0;J1b(a);YDc(a);return}function L1b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function M1b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(60)|0;$1b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20544,64);a=MQb(b,64)|0;a2b(a,b);c=a;return c|0}function N1b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function O1b(a){a=a|0;return f[a+20>>2]|0}function P1b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;Clc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}b=a+24|0;if(f[b>>2]&63|0){c=a+48|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0}f[b>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Q1b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function R1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=a+20|0;l=a+52|0;m=e+8|0;n=a+54|0;o=e+8|0;p=a+53|0;q=e+8|0;r=a+56|0;s=a+55|0;t=e+8|0;v=a+32|0;w=e+4|0;x=a+4|0;a:while(1){a=f[c>>2]|0;y=f[g>>2]|0;do if(a>>>0<y>>>0){z=b[a>>0]|0;A=z&255;B=a+1|0;if(z<<24>>24>0){C=B;D=A}else{if(B>>>0>=y>>>0){E=A;F=7;break}z=h[B>>0]|0;if(((z^128)&A)>>>0<=127){E=A;F=7;break}C=a+2|0;D=A+-128+(z<<7)|0}f[c>>2]=C;G=D;F=9}else{E=0;F=7}while(0);if((F|0)==7){F=0;a=WRb(c,E)|0;if((a+-1|0)>>>0<16383){G=a;F=9}else H=a}b:do if((F|0)==9){F=0;switch(G>>>3&536870911|0){case 1:{if((G&255|0)!=8){H=G;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){y=b[a>>0]|0;z=y&255;if(y<<24>>24>-1){f[c>>2]=a+1;I=z}else{K=z;F=14}}else{K=0;F=14}if((F|0)==14){F=0;z=HRb(c,K)|0;a=J;if((a|0)>-1|(a|0)==-1&z>>>0>4294967295)I=z;else{L=0;F=75;break a}}if(I>>>0<3){f[i>>2]=f[i>>2]|1;f[j>>2]=I;continue a}z=f[k>>2]|0;if(!(z&1))M=mNa(k)|0;else M=z&-2;rjc(M,1,I,((I|0)<0)<<31>>31);continue a;break}case 2:{if((G&255|0)!=16){H=G;break b}f[i>>2]=f[i>>2]|2;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(a=b[z>>0]|0,a<<24>>24>-1):0){f[c>>2]=z+1;N=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[m>>0]|0)){L=0;F=75;break a}else N=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[l>>0]=N&1;continue a;break}case 3:{if((G&255|0)!=24){H=G;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(z=b[a>>0]|0,z<<24>>24>-1):0){f[c>>2]=a+1;O=z<<24>>24!=0}else{IRb(e,c);z=e;if(!(b[o>>0]|0)){L=0;F=75;break a}else O=(f[z>>2]|0)!=0|(f[z+4>>2]|0)!=0}b[n>>0]=O&1;continue a;break}case 5:{if((G&255|0)!=40){H=G;break b}f[i>>2]=f[i>>2]|4;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(a=b[z>>0]|0,a<<24>>24>-1):0){f[c>>2]=z+1;P=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[q>>0]|0)){L=0;F=75;break a}else P=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[p>>0]=P&1;continue a;break}case 6:{if((G&255|0)!=48){H=G;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){z=b[a>>0]|0;y=z&255;if(z<<24>>24>-1){f[c>>2]=a+1;Q=y}else{R=y;F=43}}else{R=0;F=43}if((F|0)==43){F=0;y=HRb(c,R)|0;a=J;if((a|0)>-1|(a|0)==-1&y>>>0>4294967295)Q=y;else{L=0;F=75;break a}}if(Q>>>0<3){f[i>>2]=f[i>>2]|32;f[r>>2]=Q;continue a}y=f[k>>2]|0;if(!(y&1))S=mNa(k)|0;else S=y&-2;rjc(S,6,Q,((Q|0)<0)<<31>>31);continue a;break}case 10:{if((G&255|0)!=80){H=G;break b}f[i>>2]=f[i>>2]|16;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(a=b[y>>0]|0,a<<24>>24>-1):0){f[c>>2]=y+1;T=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[t>>0]|0)){L=0;F=75;break a}else T=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[s>>0]=T&1;continue a;break}case 999:{if((G&255|0)!=58){H=G;break b}a=j0b(v)|0;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(z=b[y>>0]|0,z<<24>>24>-1):0){f[c>>2]=y+1;U=z&255}else{z=VRb(c)|0;if((z|0)>-1)U=z;else{L=0;F=75;break a}}GRb(e,c,U);if((f[w>>2]|0)<0){F=63;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){F=63;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{L=0;F=75;break a}break}default:{H=G;break b}}}while(0);if(!H){L=1;F=75;break}a=f[k>>2]|0;z=(a&1|0)==0;if(H>>>0>7999){if(z)V=mNa(k)|0;else V=a&-2;if(x9b(x,H,c,528208,V)|0)continue;else{L=0;F=75;break}}else{if(z)W=mNa(k)|0;else W=a&-2;if(Djc(c,H,W)|0)continue;else{L=0;F=75;break}}}if((F|0)==63){L=0;u=d;return L|0}else if((F|0)==75){u=d;return L|0}return 0}function S1b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=Nlc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Jjc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b)e=c;else{d=a+44|0;g=0;h=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=c;break}else h=c}}h=f[a+24>>2]|0;if(!(h&63)){j=e;k=a+28|0;f[k>>2]=j;return j|0}if(!(h&1))l=e;else{b=f[a+48>>2]|0;if((b|0)<0)m=11;else m=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+e|0}e=h&2|0?l+2|0:l;l=h&4|0?e+2|0:e;e=h&8|0?l+2|0:l;l=h&16|0?e+2|0:e;if(!(h&32)){j=l;k=a+28|0;f[k>>2]=j;return j|0}h=f[a+56>>2]|0;if((h|0)<0)n=11;else n=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=n+l|0;k=a+28|0;f[k>>2]=j;return j|0}function T1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)ZTb(1,f[a+48>>2]|0,c);if(d&2|0)YTb(2,(b[a+52>>0]|0)!=0,c);if(d&8|0)YTb(3,(b[a+54>>0]|0)!=0,c);if(d&4|0)YTb(5,(b[a+53>>0]|0)!=0,c);if(d&32|0)ZTb(6,f[a+56>>2]|0,c);if(d&16|0)YTb(10,(b[a+55>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eUb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Llc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function U1b(a){a=a|0;return f[a+28>>2]|0}function V1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=f[a+48>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=aJc(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&2))r=g;else{p=b[a+52>>0]|0;b[g>>0]=16;b[g+1>>0]=p;r=g+2|0}if(!(e&8))s=r;else{g=b[a+54>>0]|0;b[r>>0]=24;b[r+1>>0]=g;s=r+2|0}if(!(e&4))t=s;else{r=b[a+53>>0]|0;b[s>>0]=40;b[s+1>>0]=r;t=s+2|0}if(!(e&32))u=t;else{s=f[a+56>>2]|0;b[t>>0]=48;r=t+1|0;t=s&255;if(s>>>0>127){g=r;p=t;q=s;d=((s|0)<0)<<31>>31;while(1){b[g>>0]=p|-128;s=q;q=aJc(q|0,d|0,7)|0;i=g+1|0;m=q&255;if(!(d>>>0>0|(d|0)==0&s>>>0>16383)){v=i;w=m;break}else{g=i;p=m;d=J}}}else{v=r;w=t}b[v>>0]=w;u=v+1|0}if(!(e&16))x=u;else{e=b[a+55>>0]|0;b[u>>0]=80;b[u+1>>0]=e;x=u+2|0}u=f[a+36>>2]|0;if(!u)y=x;else{e=a+44|0;v=0;w=x;while(1){x=f[(f[e>>2]|0)+4+(v<<2)>>2]|0;b[w>>0]=-70;b[w+1>>0]=62;t=w+2|0;r=_i[f[(f[x>>2]|0)+60>>2]&1023](x)|0;if(r>>>0>127){d=r;p=t;while(1){b[p>>0]=d|128;g=d>>>7;q=p+1|0;if(d>>>0>16383){d=g;p=q}else{z=q;A=g;break}}}else{z=t;A=r}b[z>>0]=A;p=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,z+1|0)|0;v=v+1|0;if((v|0)==(u|0)){y=p;break}else w=p}}w=B9b(a+4|0,1e3,536870912,c,y)|0;y=f[a+20>>2]|0;if(!(y&1)){B=w;return B|0}B=Hjc(y&-2,w)|0;return B|0}function W1b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function X1b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20544,0)|0;if(!c){Ehc(b,a);return}else{_1b(a,c);return}}function Y1b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Z1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528944;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function _1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;Dlc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,c+32|0);e=f[c+24>>2]|0;if(!(e&63))return;if(e&1|0)f[a+48>>2]=f[c+48>>2];if(e&2|0)b[a+52>>0]=b[c+52>>0]|0;if(e&4|0)b[a+53>>0]=b[c+53>>0]|0;if(e&8|0)b[a+54>>0]=b[c+54>>0]|0;if(e&16|0)b[a+55>>0]=b[c+55>>0]|0;if(e&32|0)f[a+56>>2]=f[c+56>>2];c=a+24|0;f[c>>2]=f[c>>2]|e;return}function $1b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=164836;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528208?(f[220853]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=152;b[d+8>>0]=0;DTb(883412,d);ZSb(d)}f[a+28>>2]=0;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;u=c;return}function a2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=164836;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220853]|0)==2){g=a+28|0;f[g>>2]=0;h=a+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=152;b[e+8>>0]=0;DTb(883412,e);ZSb(e);g=a+28|0;f[g>>2]=0;h=a+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;u=d;return}function b2b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=164944;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function c2b(a){a=a|0;b2b(a);YDc(a);return}function d2b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function e2b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(52)|0;t2b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20560,56);a=MQb(b,56)|0;u2b(a,b);c=a;return c|0}function f2b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function g2b(a){a=a|0;return f[a+20>>2]|0}function h2b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;Clc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+48>>2]=0;f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function i2b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function j2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+49|0;m=e+8|0;n=a+50|0;o=e+8|0;p=a+51|0;q=e+8|0;r=a+32|0;s=e+4|0;t=a+4|0;v=a+20|0;a:while(1){a=f[c>>2]|0;w=f[g>>2]|0;do if(a>>>0<w>>>0){x=b[a>>0]|0;y=x&255;z=a+1|0;if(x<<24>>24>0){A=z;B=y}else{if(z>>>0>=w>>>0){C=y;D=7;break}x=h[z>>0]|0;if(((x^128)&y)>>>0<=127){C=y;D=7;break}A=a+2|0;B=y+-128+(x<<7)|0}f[c>>2]=A;E=B;D=9}else{C=0;D=7}while(0);if((D|0)==7){D=0;a=WRb(c,C)|0;if((a+-1|0)>>>0<16383){E=a;D=9}else F=a}b:do if((D|0)==9){D=0;switch(E>>>3&536870911|0){case 1:{if((E&255|0)!=8){F=E;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(w=b[a>>0]|0,w<<24>>24>-1):0){f[c>>2]=a+1;G=w<<24>>24!=0}else{IRb(e,c);w=e;if(!(b[k>>0]|0)){H=0;D=53;break a}else G=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0}b[j>>0]=G&1;continue a;break}case 2:{if((E&255|0)!=16){F=E;break b}f[i>>2]=f[i>>2]|2;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(a=b[w>>0]|0,a<<24>>24>-1):0){f[c>>2]=w+1;I=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[m>>0]|0)){H=0;D=53;break a}else I=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[l>>0]=I&1;continue a;break}case 3:{if((E&255|0)!=24){F=E;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(w=b[a>>0]|0,w<<24>>24>-1):0){f[c>>2]=a+1;J=w<<24>>24!=0}else{IRb(e,c);w=e;if(!(b[o>>0]|0)){H=0;D=53;break a}else J=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0}b[n>>0]=J&1;continue a;break}case 7:{if((E&255|0)!=56){F=E;break b}f[i>>2]=f[i>>2]|8;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(a=b[w>>0]|0,a<<24>>24>-1):0){f[c>>2]=w+1;K=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[q>>0]|0)){H=0;D=53;break a}else K=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[p>>0]=K&1;continue a;break}case 999:{if((E&255|0)!=58){F=E;break b}a=j0b(r)|0;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(x=b[w>>0]|0,x<<24>>24>-1):0){f[c>>2]=w+1;L=x&255}else{x=VRb(c)|0;if((x|0)>-1)L=x;else{H=0;D=53;break a}}GRb(e,c,L);if((f[s>>2]|0)<0){D=41;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){D=41;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{H=0;D=53;break a}break}default:{F=E;break b}}}while(0);if(!F){H=1;D=53;break}a=f[v>>2]|0;x=(a&1|0)==0;if(F>>>0>7999){if(x)M=mNa(v)|0;else M=a&-2;if(x9b(t,F,c,528152,M)|0)continue;else{H=0;D=53;break}}else{if(x)N=mNa(v)|0;else N=a&-2;if(Djc(c,F,N)|0)continue;else{H=0;D=53;break}}}if((D|0)==41){H=0;u=d;return H|0}else if((D|0)==53){u=d;return H|0}return 0}function k2b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=Nlc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Jjc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b)e=c;else{d=a+44|0;g=0;h=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=c;break}else h=c}}h=f[a+24>>2]|0;if(!(h&15)){j=e;k=a+28|0;f[k>>2]=j;return j|0}b=h&1|0?e+2|0:e;e=h&2|0?b+2|0:b;b=h&4|0?e+2|0:e;j=h&8|0?b+2|0:b;k=a+28|0;f[k>>2]=j;return j|0}function l2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)YTb(1,(b[a+48>>0]|0)!=0,c);if(d&2|0)YTb(2,(b[a+49>>0]|0)!=0,c);if(d&4|0)YTb(3,(b[a+50>>0]|0)!=0,c);if(d&8|0)YTb(7,(b[a+51>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eUb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Llc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function m2b(a){a=a|0;return f[a+28>>2]|0}function n2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=b[a+48>>0]|0;b[d>>0]=8;b[d+1>>0]=h;g=d+2|0}if(!(e&2))i=g;else{d=b[a+49>>0]|0;b[g>>0]=16;b[g+1>>0]=d;i=g+2|0}if(!(e&4))j=i;else{g=b[a+50>>0]|0;b[i>>0]=24;b[i+1>>0]=g;j=i+2|0}if(!(e&8))k=j;else{e=b[a+51>>0]|0;b[j>>0]=56;b[j+1>>0]=e;k=j+2|0}j=f[a+36>>2]|0;if(!j)l=k;else{e=a+44|0;i=0;g=k;while(1){k=f[(f[e>>2]|0)+4+(i<<2)>>2]|0;b[g>>0]=-70;b[g+1>>0]=62;d=g+2|0;h=_i[f[(f[k>>2]|0)+60>>2]&1023](k)|0;if(h>>>0>127){m=h;n=d;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=d;r=h}b[q>>0]=r;n=hj[f[(f[k>>2]|0)+64>>2]&511](k,c,q+1|0)|0;i=i+1|0;if((i|0)==(j|0)){l=n;break}else g=n}}g=B9b(a+4|0,1e3,536870912,c,l)|0;l=f[a+20>>2]|0;if(!(l&1)){s=g;return s|0}s=Hjc(l&-2,g)|0;return s|0}function o2b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function p2b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20560,0)|0;if(!c){Ehc(b,a);return}else{s2b(a,c);return}}function q2b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function r2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528936;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function s2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;Dlc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,c+32|0);e=f[c+24>>2]|0;if(!(e&15))return;if(e&1|0)b[a+48>>0]=b[c+48>>0]|0;if(e&2|0)b[a+49>>0]=b[c+49>>0]|0;if(e&4|0)b[a+50>>0]=b[c+50>>0]|0;if(e&8|0)b[a+51>>0]=b[c+51>>0]|0;c=a+24|0;f[c>>2]=f[c>>2]|e;return}function t2b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=164944;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528152?(f[220852]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=151;b[d+8>>0]=0;DTb(883408,d);ZSb(d)}f[a+28>>2]=0;f[a+48>>2]=0;u=c;return}function u2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=164944;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220852]|0)==2){g=a+28|0;f[g>>2]=0;h=a+48|0;f[h>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=151;b[e+8>>0]=0;DTb(883408,e);ZSb(e);g=a+28|0;f[g>>2]=0;h=a+48|0;f[h>>2]=0;u=d;return}function v2b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=165052;P2b(a);b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function w2b(a){a=a|0;v2b(a);YDc(a);return}function x2b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function y2b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(96)|0;N2b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20576,96);a=MQb(b,96)|0;O2b(a,b);c=a;return c|0}function z2b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function A2b(a){a=a|0;return f[a+20>>2]|0}function B2b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;Clc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+24|0;d=f[c>>2]|0;do if(d&255|0){do if(d&1|0?(g=f[a+48>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0?(e=f[a+52>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0?(g=f[a+56>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&8|0?(e=f[a+60>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&16|0?(g=f[a+64>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&32|0?(e=f[a+68>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&64|0?(g=f[a+72>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&128|0?(e=f[a+76>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);if(d&65280|0){g=a+80|0;f[g>>2]=0;f[g+4>>2]=0}if(d&196608|0){b[a+88>>0]=0;f[a+92>>2]=1}f[c>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function C2b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function D2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=a+20|0;l=a+52|0;m=a+92|0;n=a+81|0;o=e+8|0;p=a+56|0;q=a+84|0;r=e+8|0;s=a+85|0;t=e+8|0;v=a+86|0;w=e+8|0;x=a+82|0;y=e+8|0;z=a+88|0;A=e+8|0;B=a+83|0;C=e+8|0;D=a+80|0;E=e+8|0;F=a+60|0;G=a+64|0;H=a+68|0;I=a+72|0;K=a+76|0;L=a+87|0;M=e+8|0;N=a+32|0;O=e+4|0;P=a+4|0;a:while(1){a=f[c>>2]|0;Q=f[g>>2]|0;do if(a>>>0<Q>>>0){R=b[a>>0]|0;S=R&255;T=a+1|0;if(R<<24>>24>0){U=T;V=S}else{if(T>>>0>=Q>>>0){W=S;X=7;break}R=h[T>>0]|0;if(((R^128)&S)>>>0<=127){W=S;X=7;break}U=a+2|0;V=S+-128+(R<<7)|0}f[c>>2]=U;Y=V;X=9}else{W=0;X=7}while(0);if((X|0)==7){X=0;a=WRb(c,W)|0;if((a+-1|0)>>>0<16383){Y=a;X=9}else Z=a}b:do if((X|0)==9){X=0;do switch(Y>>>3&536870911|0){case 1:{if((Y&255|0)!=10){Z=Y;break b}f[i>>2]=f[i>>2]|1;a=f[k>>2]|0;Q=a&-2;if(!(a&1))_=Q;else _=f[Q+4>>2]|0;Q=f[j>>2]|0;if((Q|0)==527320){WJa(j,_,527320);$=f[j>>2]|0}else $=Q;if(fUb(c,$)|0)continue a;else{aa=0;X=150;break a}break}case 8:{if((Y&255|0)!=66){Z=Y;break b}f[i>>2]=f[i>>2]|2;Q=f[k>>2]|0;a=Q&-2;if(!(Q&1))ba=a;else ba=f[a+4>>2]|0;a=f[l>>2]|0;if((a|0)==527320){WJa(l,ba,527320);ca=f[l>>2]|0}else ca=a;if(fUb(c,ca)|0)continue a;else{aa=0;X=150;break a}break}case 9:{if((Y&255|0)!=72){Z=Y;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){Q=b[a>>0]|0;R=Q&255;if(Q<<24>>24>-1){f[c>>2]=a+1;da=R}else{ea=R;X=28}}else{ea=0;X=28}if((X|0)==28){X=0;R=HRb(c,ea)|0;a=J;if((a|0)>-1|(a|0)==-1&R>>>0>4294967295)da=R;else{aa=0;X=150;break a}}if((da+-1|0)>>>0<3){f[i>>2]=f[i>>2]|131072;f[m>>2]=da;continue a}R=f[k>>2]|0;if(!(R&1))fa=mNa(k)|0;else fa=R&-2;rjc(fa,9,da,((da|0)<0)<<31>>31);continue a;break}case 10:{if((Y&255|0)!=80){Z=Y;break b}f[i>>2]=f[i>>2]|512;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;ga=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[o>>0]|0)){aa=0;X=150;break a}else ga=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[n>>0]=ga&1;continue a;break}case 11:{if((Y&255|0)!=90){Z=Y;break b}f[i>>2]=f[i>>2]|4;a=f[k>>2]|0;R=a&-2;if(!(a&1))ha=R;else ha=f[R+4>>2]|0;R=f[p>>2]|0;if((R|0)==527320){WJa(p,ha,527320);ia=f[p>>2]|0}else ia=R;if(fUb(c,ia)|0)continue a;else{aa=0;X=150;break a}break}case 16:{if((Y&255|0)!=128){Z=Y;break b}f[i>>2]=f[i>>2]|4096;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;ja=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[r>>0]|0)){aa=0;X=150;break a}else ja=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[q>>0]=ja&1;continue a;break}case 17:{if((Y&255|0)!=136){Z=Y;break b}f[i>>2]=f[i>>2]|8192;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;ka=R<<24>>24!=0}else{IRb(e,c);R=e;if(!(b[t>>0]|0)){aa=0;X=150;break a}else ka=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0}b[s>>0]=ka&1;continue a;break}case 18:{if((Y&255|0)!=144){Z=Y;break b}f[i>>2]=f[i>>2]|16384;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;la=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[w>>0]|0)){aa=0;X=150;break a}else la=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[v>>0]=la&1;continue a;break}case 20:{if((Y&255|0)!=160){Z=Y;break b}f[i>>2]=f[i>>2]|1024;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;ma=R<<24>>24!=0}else{IRb(e,c);R=e;if(!(b[y>>0]|0)){aa=0;X=150;break a}else ma=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0}b[x>>0]=ma&1;continue a;break}case 23:{if((Y&255|0)!=184){Z=Y;break b}f[i>>2]=f[i>>2]|65536;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;na=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[A>>0]|0)){aa=0;X=150;break a}else na=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[z>>0]=na&1;continue a;break}case 27:{if((Y&255|0)!=216){Z=Y;break b}f[i>>2]=f[i>>2]|2048;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;oa=R<<24>>24!=0}else{IRb(e,c);R=e;if(!(b[C>>0]|0)){aa=0;X=150;break a}else oa=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0}b[B>>0]=oa&1;continue a;break}case 31:{if((Y&255|0)!=248){Z=Y;break b}f[i>>2]=f[i>>2]|256;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;pa=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[E>>0]|0)){aa=0;X=150;break a}else pa=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[D>>0]=pa&1;continue a;break}case 36:{if((Y&255|0)!=34){Z=Y;break b}f[i>>2]=f[i>>2]|8;a=f[k>>2]|0;R=a&-2;if(!(a&1))qa=R;else qa=f[R+4>>2]|0;R=f[F>>2]|0;if((R|0)==527320){WJa(F,qa,527320);ra=f[F>>2]|0}else ra=R;if(fUb(c,ra)|0)continue a;else{aa=0;X=150;break a}break}case 37:{if((Y&255|0)!=42){Z=Y;break b}f[i>>2]=f[i>>2]|16;R=f[k>>2]|0;a=R&-2;if(!(R&1))sa=a;else sa=f[a+4>>2]|0;a=f[G>>2]|0;if((a|0)==527320){WJa(G,sa,527320);ta=f[G>>2]|0}else ta=a;if(fUb(c,ta)|0)continue a;else{aa=0;X=150;break a}break}case 39:{if((Y&255|0)!=58){Z=Y;break b}f[i>>2]=f[i>>2]|32;a=f[k>>2]|0;R=a&-2;if(!(a&1))ua=R;else ua=f[R+4>>2]|0;R=f[H>>2]|0;if((R|0)==527320){WJa(H,ua,527320);va=f[H>>2]|0}else va=R;if(fUb(c,va)|0)continue a;else{aa=0;X=150;break a}break}case 40:{if((Y&255|0)!=66){Z=Y;break b}f[i>>2]=f[i>>2]|64;R=f[k>>2]|0;a=R&-2;if(!(R&1))wa=a;else wa=f[a+4>>2]|0;a=f[I>>2]|0;if((a|0)==527320){WJa(I,wa,527320);xa=f[I>>2]|0}else xa=a;if(fUb(c,xa)|0)continue a;else{aa=0;X=150;break a}break}case 41:{if((Y&255|0)!=74){Z=Y;break b}f[i>>2]=f[i>>2]|128;a=f[k>>2]|0;R=a&-2;if(!(a&1))ya=R;else ya=f[R+4>>2]|0;R=f[K>>2]|0;if((R|0)==527320){WJa(K,ya,527320);za=f[K>>2]|0}else za=R;if(fUb(c,za)|0)continue a;else{aa=0;X=150;break a}break}case 42:{if((Y&255|0)!=80){Z=Y;break b}f[i>>2]=f[i>>2]|32768;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;Aa=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[M>>0]|0)){aa=0;X=150;break a}else Aa=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[L>>0]=Aa&1;continue a;break}case 999:{if((Y&255|0)!=58){Z=Y;break b}a=j0b(N)|0;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(Q=b[R>>0]|0,Q<<24>>24>-1):0){f[c>>2]=R+1;Ba=Q&255}else{Q=VRb(c)|0;if((Q|0)>-1)Ba=Q;else{aa=0;X=150;break a}}GRb(e,c,Ba);if((f[O>>2]|0)<0){X=138;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){X=138;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{aa=0;X=150;break a}break}default:{Z=Y;break b}}while(0)}while(0);if(!Z){aa=1;X=150;break}a=f[k>>2]|0;Q=(a&1|0)==0;if(Z>>>0>7999){if(Q)Ca=mNa(k)|0;else Ca=a&-2;if(x9b(P,Z,c,528056,Ca)|0)continue;else{aa=0;X=150;break}}else{if(Q)Da=mNa(k)|0;else Da=a&-2;if(Djc(c,Z,Da)|0)continue;else{aa=0;X=150;break}}}if((X|0)==138){aa=0;u=d;return aa|0}else if((X|0)==150){u=d;return aa|0}return 0}function E2b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=Nlc(a+4|0)|0;d=f[a+20>>2]|0;if(!(d&1))e=c;else e=(Jjc(d&-2)|0)+c|0;c=f[a+36>>2]|0;d=(c<<1)+e|0;if(!c)g=d;else{e=a+44|0;h=0;i=d;while(1){d=f[(f[e>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=d;break}else i=d}}i=f[a+24>>2]|0;if(i&255){if(!(i&1))k=g;else{c=f[a+48>>2]|0;h=b[c+11>>0]|0;e=h<<24>>24<0?f[c+4>>2]|0:h&255;k=g+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2))l=k;else{e=f[a+52>>2]|0;h=b[e+11>>0]|0;c=h<<24>>24<0?f[e+4>>2]|0:h&255;l=k+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&4))m=l;else{c=f[a+56>>2]|0;k=b[c+11>>0]|0;h=k<<24>>24<0?f[c+4>>2]|0:k&255;m=l+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&8))n=m;else{h=f[a+60>>2]|0;l=b[h+11>>0]|0;k=l<<24>>24<0?f[h+4>>2]|0:l&255;n=m+2+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&16))o=n;else{k=f[a+64>>2]|0;m=b[k+11>>0]|0;l=m<<24>>24<0?f[k+4>>2]|0:m&255;o=n+2+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&32))p=o;else{l=f[a+68>>2]|0;n=b[l+11>>0]|0;m=n<<24>>24<0?f[l+4>>2]|0:n&255;p=o+2+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&64))q=p;else{m=f[a+72>>2]|0;o=b[m+11>>0]|0;n=o<<24>>24<0?f[m+4>>2]|0:o&255;q=p+2+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&128))r=q;else{n=f[a+76>>2]|0;p=b[n+11>>0]|0;o=p<<24>>24<0?f[n+4>>2]|0:p&255;r=q+2+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0}}else r=g;if(!(i&65280))s=r;else{g=i&256|0?r+3|0:r;r=i&512|0?g+2|0:g;g=i&1024|0?r+3|0:r;r=i&2048|0?g+3|0:g;g=i&4096|0?r+3|0:r;r=i&8192|0?g+3|0:g;g=i&16384|0?r+3|0:r;s=i&32768|0?g+3|0:g}if(!(i&196608)){t=s;u=a+28|0;f[u>>2]=t;return t|0}g=i&65536|0?s+3|0:s;if(!(i&131072)){t=g;u=a+28|0;f[u>>2]=t;return t|0}i=f[a+92>>2]|0;if((i|0)<0)v=11;else v=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;t=v+g|0;u=a+28|0;f[u>>2]=t;return t|0}function F2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)$Tb(1,f[a+48>>2]|0,c);if(d&2|0)$Tb(8,f[a+52>>2]|0,c);if(d&131072|0)ZTb(9,f[a+92>>2]|0,c);if(d&512|0)YTb(10,(b[a+81>>0]|0)!=0,c);if(d&4|0)$Tb(11,f[a+56>>2]|0,c);if(d&4096|0)YTb(16,(b[a+84>>0]|0)!=0,c);if(d&8192|0)YTb(17,(b[a+85>>0]|0)!=0,c);if(d&16384|0)YTb(18,(b[a+86>>0]|0)!=0,c);if(d&1024|0)YTb(20,(b[a+82>>0]|0)!=0,c);if(d&65536|0)YTb(23,(b[a+88>>0]|0)!=0,c);if(d&2048|0)YTb(27,(b[a+83>>0]|0)!=0,c);if(d&256|0)YTb(31,(b[a+80>>0]|0)!=0,c);if(d&8|0)$Tb(36,f[a+60>>2]|0,c);if(d&16|0)$Tb(37,f[a+64>>2]|0,c);if(d&32|0)$Tb(39,f[a+68>>2]|0,c);if(d&64|0)$Tb(40,f[a+72>>2]|0,c);if(d&128|0)$Tb(41,f[a+76>>2]|0,c);if(d&32768|0)YTb(42,(b[a+87>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eUb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Llc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function G2b(a){a=a|0;return f[a+28>>2]|0}function H2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=f[a+48>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}if(!(e&2))i=g;else{d=f[a+52>>2]|0;b[g>>0]=66;i=dSb(d,g+1|0)|0}if(!(e&131072))j=i;else{g=f[a+92>>2]|0;b[i>>0]=72;d=i+1|0;i=g&255;if(g>>>0>127){h=d;k=i;l=g;m=((g|0)<0)<<31>>31;while(1){b[h>>0]=k|-128;g=l;l=aJc(l|0,m|0,7)|0;n=h+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&g>>>0>16383)){p=n;q=o;break}else{h=n;k=o;m=J}}}else{p=d;q=i}b[p>>0]=q;j=p+1|0}if(!(e&512))r=j;else{p=b[a+81>>0]|0;b[j>>0]=80;b[j+1>>0]=p;r=j+2|0}if(!(e&4))s=r;else{j=f[a+56>>2]|0;b[r>>0]=90;s=dSb(j,r+1|0)|0}if(!(e&4096))t=s;else{r=b[a+84>>0]|0;b[s>>0]=-128;b[s+1>>0]=1;b[s+2>>0]=r;t=s+3|0}if(!(e&8192))u=t;else{s=b[a+85>>0]|0;b[t>>0]=-120;b[t+1>>0]=1;b[t+2>>0]=s;u=t+3|0}if(!(e&16384))v=u;else{t=b[a+86>>0]|0;b[u>>0]=-112;b[u+1>>0]=1;b[u+2>>0]=t;v=u+3|0}if(!(e&1024))w=v;else{u=b[a+82>>0]|0;b[v>>0]=-96;b[v+1>>0]=1;b[v+2>>0]=u;w=v+3|0}if(!(e&65536))x=w;else{v=b[a+88>>0]|0;b[w>>0]=-72;b[w+1>>0]=1;b[w+2>>0]=v;x=w+3|0}if(!(e&2048))y=x;else{w=b[a+83>>0]|0;b[x>>0]=-40;b[x+1>>0]=1;b[x+2>>0]=w;y=x+3|0}if(!(e&256))z=y;else{x=b[a+80>>0]|0;b[y>>0]=-8;b[y+1>>0]=1;b[y+2>>0]=x;z=y+3|0}if(!(e&8))A=z;else{y=f[a+60>>2]|0;b[z>>0]=-94;b[z+1>>0]=2;A=dSb(y,z+2|0)|0}if(!(e&16))B=A;else{z=f[a+64>>2]|0;b[A>>0]=-86;b[A+1>>0]=2;B=dSb(z,A+2|0)|0}if(!(e&32))C=B;else{A=f[a+68>>2]|0;b[B>>0]=-70;b[B+1>>0]=2;C=dSb(A,B+2|0)|0}if(!(e&64))D=C;else{B=f[a+72>>2]|0;b[C>>0]=-62;b[C+1>>0]=2;D=dSb(B,C+2|0)|0}if(!(e&128))E=D;else{C=f[a+76>>2]|0;b[D>>0]=-54;b[D+1>>0]=2;E=dSb(C,D+2|0)|0}if(!(e&32768))F=E;else{e=b[a+87>>0]|0;b[E>>0]=-48;b[E+1>>0]=2;b[E+2>>0]=e;F=E+3|0}E=f[a+36>>2]|0;if(!E)G=F;else{e=a+44|0;D=0;C=F;while(1){F=f[(f[e>>2]|0)+4+(D<<2)>>2]|0;b[C>>0]=-70;b[C+1>>0]=62;B=C+2|0;A=_i[f[(f[F>>2]|0)+60>>2]&1023](F)|0;if(A>>>0>127){z=A;y=B;while(1){b[y>>0]=z|128;x=z>>>7;w=y+1|0;if(z>>>0>16383){z=x;y=w}else{H=w;I=x;break}}}else{H=B;I=A}b[H>>0]=I;y=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,H+1|0)|0;D=D+1|0;if((D|0)==(E|0)){G=y;break}else C=y}}C=B9b(a+4|0,1e3,536870912,c,G)|0;G=f[a+20>>2]|0;if(!(G&1)){K=C;return K|0}K=Hjc(G&-2,C)|0;return K|0}function I2b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function J2b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20576,0)|0;if(!c){Ehc(b,a);return}else{M2b(a,c);return}}function K2b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function L2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528928;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function M2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;Dlc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,c+32|0);e=f[c+24>>2]|0;do if(e&255|0){do if(e&1|0){h=f[c+48>>2]|0;g=a+24|0;f[g>>2]=f[g>>2]|1;g=a+48|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==527320){WJa(g,k,h);break}else{iEc(j,h)|0;break}}while(0);do if(e&2|0){h=f[c+52>>2]|0;j=a+24|0;f[j>>2]=f[j>>2]|2;j=a+52|0;g=f[d>>2]|0;i=g&-2;if(!(g&1))l=i;else l=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==527320){WJa(j,l,h);break}else{iEc(i,h)|0;break}}while(0);do if(e&4|0){h=f[c+56>>2]|0;i=a+24|0;f[i>>2]=f[i>>2]|4;i=a+56|0;j=f[d>>2]|0;g=j&-2;if(!(j&1))m=g;else m=f[g+4>>2]|0;g=f[i>>2]|0;if((g|0)==527320){WJa(i,m,h);break}else{iEc(g,h)|0;break}}while(0);do if(e&8|0){h=f[c+60>>2]|0;g=a+24|0;f[g>>2]=f[g>>2]|8;g=a+60|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))n=j;else n=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==527320){WJa(g,n,h);break}else{iEc(j,h)|0;break}}while(0);do if(e&16|0){h=f[c+64>>2]|0;j=a+24|0;f[j>>2]=f[j>>2]|16;j=a+64|0;g=f[d>>2]|0;i=g&-2;if(!(g&1))o=i;else o=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==527320){WJa(j,o,h);break}else{iEc(i,h)|0;break}}while(0);do if(e&32|0){h=f[c+68>>2]|0;i=a+24|0;f[i>>2]=f[i>>2]|32;i=a+68|0;j=f[d>>2]|0;g=j&-2;if(!(j&1))p=g;else p=f[g+4>>2]|0;g=f[i>>2]|0;if((g|0)==527320){WJa(i,p,h);break}else{iEc(g,h)|0;break}}while(0);do if(e&64|0){h=f[c+72>>2]|0;g=a+24|0;f[g>>2]=f[g>>2]|64;g=a+72|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))q=j;else q=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==527320){WJa(g,q,h);break}else{iEc(j,h)|0;break}}while(0);if(e&128|0){h=f[c+76>>2]|0;j=a+24|0;f[j>>2]=f[j>>2]|128;j=a+76|0;g=f[d>>2]|0;i=g&-2;if(!(g&1))r=i;else r=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==527320){WJa(j,r,h);break}else{iEc(i,h)|0;break}}}while(0);if(e&65280|0){if(e&256|0)b[a+80>>0]=b[c+80>>0]|0;if(e&512|0)b[a+81>>0]=b[c+81>>0]|0;if(e&1024|0)b[a+82>>0]=b[c+82>>0]|0;if(e&2048|0)b[a+83>>0]=b[c+83>>0]|0;if(e&4096|0)b[a+84>>0]=b[c+84>>0]|0;if(e&8192|0)b[a+85>>0]=b[c+85>>0]|0;if(e&16384|0)b[a+86>>0]=b[c+86>>0]|0;if(e&32768|0)b[a+87>>0]=b[c+87>>0]|0;r=a+24|0;f[r>>2]=f[r>>2]|e}if(!(e&196608))return;if(e&65536|0)b[a+88>>0]=b[c+88>>0]|0;if(e&131072|0)f[a+92>>2]=f[c+92>>2];c=a+24|0;f[c>>2]=f[c>>2]|e;return}function N2b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=165052;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=528056?(f[220851]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=150;b[d+8>>0]=0;DTb(883404,d);ZSb(d)}f[a+28>>2]=0;f[a+48>>2]=527320;f[a+52>>2]=527320;f[a+56>>2]=527320;f[a+60>>2]=527320;f[a+64>>2]=527320;f[a+68>>2]=527320;f[a+72>>2]=527320;f[a+76>>2]=527320;d=a+80|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+92>>2]=1;u=c;return}function O2b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=165052;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220851]|0)!=2){f[e>>2]=161028;f[e+4>>2]=150;b[e+8>>0]=0;DTb(883404,e);ZSb(e)}f[a+28>>2]=0;f[a+48>>2]=527320;f[a+52>>2]=527320;f[a+56>>2]=527320;f[a+60>>2]=527320;f[a+64>>2]=527320;f[a+68>>2]=527320;f[a+72>>2]=527320;f[a+76>>2]=527320;e=a+80|0;f[e>>2]=0;f[e+4>>2]=0;b[e+8>>0]=0;f[a+92>>2]=1;u=d;return}function P2b(a){a=a|0;var c=0;c=f[a+48>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+52>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+56>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+60>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+64>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+68>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+72>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+76>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function Q2b(a){a=a|0;var b=0,c=0;f[a>>2]=165160;j3b(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function R2b(a){a=a|0;Q2b(a);YDc(a);return}function S2b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function T2b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(36)|0;h3b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20592,40);a=MQb(b,40)|0;i3b(a,b);c=a;return c|0}function U2b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function V2b(a){a=a|0;return f[a+4>>2]|0}function W2b(a){a=a|0;var c=0,e=0,g=0,h=0;c=a+8|0;e=f[c>>2]|0;if(e&15|0){do if(e&1|0?(g=f[a+16>>2]|0,(g|0)!=527320):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);do if(e&2|0?(h=f[a+20>>2]|0,(h|0)!=527320):0){g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}while(0);do if(e&4|0?(g=f[a+24>>2]|0,(g|0)!=527320):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&8|0){e=f[a+28>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}}d[a+32>>1]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function X2b(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&8|0?(b=f[a+28>>2]|0,!(_i[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function Y2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;l=a+24|0;m=a+28|0;n=e+4|0;o=a+32|0;p=e+8|0;q=a+33|0;r=e+8|0;a:while(1){s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){t=b[s>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=s+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=WRb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=10){z=w;break b}f[h>>2]=f[h>>2]|1;v=f[j>>2]|0;s=v&-2;if(!(v&1))A=s;else A=f[s+4>>2]|0;s=f[i>>2]|0;if((s|0)==527320){WJa(i,A,527320);B=f[i>>2]|0}else B=s;if(fUb(c,B)|0)continue a;else{C=0;x=56;break a}break}case 2:{if((w&255|0)!=18){z=w;break b}f[h>>2]=f[h>>2]|2;s=f[j>>2]|0;v=s&-2;if(!(s&1))D=v;else D=f[v+4>>2]|0;v=f[k>>2]|0;if((v|0)==527320){WJa(k,D,527320);E=f[k>>2]|0}else E=v;if(fUb(c,E)|0)continue a;else{C=0;x=56;break a}break}case 3:{if((w&255|0)!=26){z=w;break b}f[h>>2]=f[h>>2]|4;v=f[j>>2]|0;s=v&-2;if(!(v&1))F=s;else F=f[s+4>>2]|0;s=f[l>>2]|0;if((s|0)==527320){WJa(l,F,527320);G=f[l>>2]|0}else G=s;if(fUb(c,G)|0)continue a;else{C=0;x=56;break a}break}case 4:{if((w&255|0)!=34){z=w;break b}f[h>>2]=f[h>>2]|8;s=f[m>>2]|0;if(!s){g3b(a);H=f[m>>2]|0}else H=s;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;I=v&255}else{v=VRb(c)|0;if((v|0)>-1)I=v;else{C=0;x=56;break a}}GRb(e,c,I);if((f[n>>2]|0)<0){x=37;break a}if(!(Mi[f[(f[H>>2]|0)+44>>2]&1023](H,c)|0)){x=37;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{C=0;x=56;break a}break}case 5:{if((w&255|0)!=40){z=w;break b}f[h>>2]=f[h>>2]|16;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(s=b[v>>0]|0,s<<24>>24>-1):0){f[c>>2]=v+1;J=s<<24>>24!=0}else{IRb(e,c);s=e;if(!(b[p>>0]|0)){C=0;x=56;break a}else J=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0}b[o>>0]=J&1;continue a;break}case 6:{if((w&255|0)!=48){z=w;break b}f[h>>2]=f[h>>2]|32;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;K=v<<24>>24!=0}else{IRb(e,c);v=e;if(!(b[r>>0]|0)){C=0;x=56;break a}else K=(f[v>>2]|0)!=0|(f[v+4>>2]|0)!=0}b[q>>0]=K&1;continue a;break}default:{z=w;break b}}}while(0);if(!z){C=1;x=56;break}v=f[j>>2]|0;if(!(v&1))L=mNa(j)|0;else L=v&-2;if(!(Djc(c,z,L)|0)){C=0;x=56;break}}if((x|0)==37){C=0;u=d;return C|0}else if((x|0)==56){u=d;return C|0}return 0}function Z2b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=a+8|0;e=f[c>>2]|0;if(!(e&63)){g=d;h=a+12|0;f[h>>2]=g;return g|0}if(!(e&1))i=d;else{j=f[a+16>>2]|0;k=b[j+11>>0]|0;l=k<<24>>24<0?f[j+4>>2]|0:k&255;i=d+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&2))m=i;else{l=f[a+20>>2]|0;d=b[l+11>>0]|0;k=d<<24>>24<0?f[l+4>>2]|0:d&255;m=i+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&4))n=m;else{k=f[a+24>>2]|0;i=b[k+11>>0]|0;d=i<<24>>24<0?f[k+4>>2]|0:i&255;n=m+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&8)){o=n;p=e}else{e=f[a+28>>2]|0;d=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=n+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;o=e;p=f[c>>2]|0}c=p&16|0?o+2|0:o;g=p&32|0?c+2|0:c;h=a+12|0;f[h>>2]=g;return g|0}function _2b(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)$Tb(1,f[a+16>>2]|0,c);if(d&2|0)$Tb(2,f[a+20>>2]|0,c);if(d&4|0)$Tb(3,f[a+24>>2]|0,c);if(d&8|0)eUb(4,f[a+28>>2]|0,c);if(d&16|0)YTb(5,(b[a+32>>0]|0)!=0,c);if(d&32|0)YTb(6,(b[a+33>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Gjc(d&-2,c);return}function $2b(a){a=a|0;return f[a+12>>2]|0}function a3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}if(!(e&2))i=g;else{d=f[a+20>>2]|0;b[g>>0]=18;i=dSb(d,g+1|0)|0}if(!(e&4))j=i;else{g=f[a+24>>2]|0;b[i>>0]=26;j=dSb(g,i+1|0)|0}if(!(e&8))k=j;else{i=f[a+28>>2]|0;b[j>>0]=34;g=j+1|0;j=_i[f[(f[i>>2]|0)+60>>2]&1023](i)|0;if(j>>>0>127){d=j;h=g;while(1){b[h>>0]=d|128;l=d>>>7;m=h+1|0;if(d>>>0>16383){d=l;h=m}else{n=m;o=l;break}}}else{n=g;o=j}b[n>>0]=o;k=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,n+1|0)|0}if(!(e&16))p=k;else{n=b[a+32>>0]|0;b[k>>0]=40;b[k+1>>0]=n;p=k+2|0}if(!(e&32))q=p;else{e=b[a+33>>0]|0;b[p>>0]=48;b[p+1>>0]=e;q=p+2|0}p=f[a+4>>2]|0;if(!(p&1)){r=q;return r|0}r=Hjc(p&-2,q)|0;return r|0}function b3b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function c3b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20592,0)|0;if(!c){Ehc(b,a);return}else{f3b(a,c);return}}function d3b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function e3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528920;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function f3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&63))return;do if(e&1|0){h=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==527320){WJa(g,k,h);break}else{iEc(j,h)|0;break}}while(0);do if(e&2|0){k=f[c+20>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|2;h=a+20|0;j=f[d>>2]|0;g=j&-2;if(!(j&1))l=g;else l=f[g+4>>2]|0;g=f[h>>2]|0;if((g|0)==527320){WJa(h,l,k);break}else{iEc(g,k)|0;break}}while(0);do if(e&4|0){l=f[c+24>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|4;k=a+24|0;g=f[d>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=f[k>>2]|0;if((h|0)==527320){WJa(k,m,l);break}else{iEc(h,l)|0;break}}while(0);if(e&8|0){m=a+8|0;f[m>>2]=f[m>>2]|8;m=a+28|0;d=f[m>>2]|0;if(!d){g3b(a);n=f[m>>2]|0}else n=d;d=f[c+28>>2]|0;g0b(n,d|0?d:528488)}if(e&16|0)b[a+32>>0]=b[c+32>>0]|0;if(e&32|0)b[a+33>>0]=b[c+33>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function g3b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(56)|0;k0b(c);e=c;g=a+28|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20464,56);c=MQb(d,56)|0;l0b(c,d);e=c;g=a+28|0;f[g>>2]=e;return}function h3b(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=165160;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=528016?(f[220850]|0)!=2:0){f[e>>2]=161028;f[e+4>>2]=149;b[e+8>>0]=0;DTb(883400,e);ZSb(e)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;e=a+28|0;f[e>>2]=0;d[e+4>>1]=0;u=c;return}function i3b(a,c){a=a|0;c=c|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[a>>2]=165160;f[a+4>>2]=c;f[a+8>>2]=0;if((f[220850]|0)!=2){f[g>>2]=161028;f[g+4>>2]=149;b[g+8>>0]=0;DTb(883400,g);ZSb(g)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;g=a+28|0;f[g>>2]=0;d[g+4>>1]=0;u=e;return}function j3b(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==528016)return;c=f[a+28>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function k3b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=165268;c=f[a+32>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=527976?(c=f[a+36>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[c>>2]=0;return}function l3b(a){a=a|0;k3b(a);YDc(a);return}function m3b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function n3b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(40)|0;F3b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20608,40);a=MQb(b,40)|0;G3b(a,b);c=a;return c|0}function o3b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function p3b(a){a=a|0;return f[a+4>>2]|0}function q3b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(g=f[a+32>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&2|0){d=f[a+36>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function r3b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=7;break}}if((g|0)==7)return e|0;if(f[a+8>>2]&2|0?(g=f[a+36>>2]|0,!(_i[f[(f[g>>2]|0)+32>>2]&1023](g)|0)):0){e=0;return e|0}e=1;return e|0}function s3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+32|0;j=a+4|0;k=a+16|0;l=a+28|0;m=a+24|0;n=a+20|0;o=e+4|0;p=a+36|0;q=e+4|0;a:while(1){r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){s=b[r>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=r+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=WRb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=10){y=v;break b}f[h>>2]=f[h>>2]|1;t=f[j>>2]|0;r=t&-2;if(!(t&1))z=r;else z=f[r+4>>2]|0;r=f[i>>2]|0;if((r|0)==527320){WJa(i,z,527320);A=f[i>>2]|0}else A=r;if(fUb(c,A)|0)continue a;else{B=0;w=51;break a}break}case 2:{if((v&255|0)!=18){y=v;break b}r=f[l>>2]|0;do if(r){t=f[n>>2]|0;s=f[r>>2]|0;if((t|0)>=(s|0))if((s|0)==(f[m>>2]|0)){C=s;w=20;break}else{D=s;E=r;w=21;break}else{f[n>>2]=t+1;F=f[r+4+(t<<2)>>2]|0;break}}else{C=f[m>>2]|0;w=20}while(0);if((w|0)==20){w=0;USb(k,C+1|0);r=f[l>>2]|0;D=f[r>>2]|0;E=r;w=21}if((w|0)==21){w=0;f[E>>2]=D+1;r=f[k>>2]|0;if(!r){t=VDc(36)|0;h3b(t);G=t}else{if(f[r+64>>2]|0)OQb(r,20592,40);t=MQb(r,40)|0;i3b(t,r);G=t}t=f[l>>2]|0;r=f[n>>2]|0;f[n>>2]=r+1;f[t+4+(r<<2)>>2]=G;F=G}r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(t=b[r>>0]|0,t<<24>>24>-1):0){f[c>>2]=r+1;H=t&255}else{t=VRb(c)|0;if((t|0)>-1)H=t;else{B=0;w=51;break a}}GRb(e,c,H);if((f[o>>2]|0)<0){w=33;break a}if(!(Mi[f[(f[F>>2]|0)+44>>2]&1023](F,c)|0)){w=33;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;w=51;break a}break}case 3:{if((v&255|0)!=26){y=v;break b}f[h>>2]=f[h>>2]|2;t=f[p>>2]|0;if(!t){D3b(a);I=f[p>>2]|0}else I=t;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(r=b[t>>0]|0,r<<24>>24>-1):0){f[c>>2]=t+1;J=r&255}else{r=VRb(c)|0;if((r|0)>-1)J=r;else{B=0;w=51;break a}}GRb(e,c,J);if((f[q>>2]|0)<0){w=44;break a}if(!(Mi[f[(f[I>>2]|0)+44>>2]&1023](I,c)|0)){w=44;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;w=51;break a}break}default:{y=v;break b}}}while(0);if(!y){B=1;w=51;break}r=f[j>>2]|0;if(!(r&1))K=mNa(j)|0;else K=r&-2;if(!(Djc(c,y,K)|0)){B=0;w=51;break}}if((w|0)==33){B=0;u=d;return B|0}else if((w|0)==44){B=0;u=d;return B|0}else if((w|0)==51){u=d;return B|0}return 0}function t3b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+8>>2]|0;if(!(i&3)){k=g;l=a+12|0;f[l>>2]=k;return k|0}if(!(i&1))m=g;else{c=f[a+32>>2]|0;h=b[c+11>>0]|0;d=h<<24>>24<0?f[c+4>>2]|0:h&255;m=g+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2)){k=m;l=a+12|0;f[l>>2]=k;return k|0}i=f[a+36>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;k=m+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=a+12|0;f[l>>2]=k;return k|0}function u3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+32>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{eUb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&2|0)eUb(3,f[a+36>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function v3b(a){a=a|0;return f[a+12>>2]|0}function w3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+32>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}d=f[a+20>>2]|0;if(!d)i=g;else{h=a+28|0;j=0;k=g;while(1){g=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;l=k+1|0;m=_i[f[(f[g>>2]|0)+60>>2]&1023](g)|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=l;s=m}b[r>>0]=s;o=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,r+1|0)|0;j=j+1|0;if((j|0)==(d|0)){i=o;break}else k=o}}if(!(e&2))t=i;else{e=f[a+36>>2]|0;b[i>>0]=26;k=i+1|0;i=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(i>>>0>127){d=i;j=k;while(1){b[j>>0]=d|128;r=d>>>7;s=j+1|0;if(d>>>0>16383){d=r;j=s}else{u=s;v=r;break}}}else{u=k;v=i}b[u>>0]=v;t=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,u+1|0)|0}u=f[a+4>>2]|0;if(!(u&1)){w=t;return w|0}w=Hjc(u&-2,t)|0;return w|0}function x3b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function y3b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20608,0)|0;if(!c){Ehc(b,a);return}else{B3b(a,c);return}}function z3b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function A3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528912;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function B3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}C3b(a+16|0,c+16|0);e=f[c+8>>2]|0;if(!(e&3))return;do if(e&1|0){h=f[c+32>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+32|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==527320){WJa(g,k,h);break}else{iEc(j,h)|0;break}}while(0);if(!(e&2))return;e=a+8|0;f[e>>2]=f[e>>2]|2;e=a+36|0;k=f[e>>2]|0;if(!k){D3b(a);l=f[e>>2]|0}else l=k;k=f[c+36>>2]|0;c=k|0?k:528432;Dlc(l+4|0,c+4|0);k=l+20|0;e=f[c+20>>2]|0;if(e&1|0){a=f[k>>2]|0;if(!(a&1))m=mNa(k)|0;else m=a&-2;ojc(m,e&-2)}h0b(l+32|0,c+32|0);if(!(f[c+24>>2]&1))return;e=b[c+48>>0]|0;c=l+24|0;f[c>>2]=f[c>>2]|1;b[l+48>>0]=e;return}function C3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{E3b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(36)|0;h3b(l);E3b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20592,40);l=MQb(i,40)|0;i3b(l,i);E3b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function D3b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(52)|0;D0b(c);e=c;g=a+36|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20480,56);c=MQb(d,56)|0;E0b(c,d);e=c;g=a+36|0;f[g>>2]=e;return}function E3b(a,b){a=a|0;b=b|0;f3b(b,a);return}function F3b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=165268;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=527976?(f[220849]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=148;b[d+8>>0]=0;DTb(883396,d);ZSb(d)}f[a+12>>2]=0;f[a+32>>2]=527320;f[a+36>>2]=0;u=c;return}function G3b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=165268;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[220849]|0)!=2){f[e>>2]=161028;f[e+4>>2]=148;b[e+8>>0]=0;DTb(883396,e);ZSb(e)}f[a+12>>2]=0;f[a+32>>2]=527320;f[a+36>>2]=0;u=d;return}function H3b(a){a=a|0;var c=0,d=0;f[a>>2]=165376;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=527944?(c=f[a+20>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function I3b(a){a=a|0;H3b(a);YDc(a);return}function J3b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function K3b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(28)|0;_3b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20624,32);a=MQb(b,32)|0;$3b(a,b);c=a;return c|0}function L3b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function M3b(a){a=a|0;return f[a+4>>2]|0}function N3b(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){d=f[a+20>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[a+24>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function O3b(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&2|0?(b=f[a+20>>2]|0,!(_i[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function P3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+24|0;l=a+20|0;m=e+4|0;a:while(1){n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=n+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=WRb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=10){t=q;break b}f[h>>2]=f[h>>2]|1;p=f[j>>2]|0;n=p&-2;if(!(p&1))v=n;else v=f[n+4>>2]|0;n=f[i>>2]|0;if((n|0)==527320){WJa(i,v,527320);w=f[i>>2]|0}else w=n;if(fUb(c,w)|0)continue a;else{x=0;r=36;break a}break}case 2:{if((q&255|0)!=16){t=q;break b}f[h>>2]=f[h>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){p=b[n>>0]|0;o=p&255;if(p<<24>>24>-1){f[c>>2]=n+1;y=o}else{z=o;r=18}}else{z=0;r=18}if((r|0)==18){r=0;o=HRb(c,z)|0;n=J;if((n|0)>-1|(n|0)==-1&o>>>0>4294967295)y=o;else{x=0;r=36;break a}}f[k>>2]=y;continue a;break}case 3:{if((q&255|0)!=26){t=q;break b}f[h>>2]=f[h>>2]|2;o=f[l>>2]|0;if(!o){Z3b(a);A=f[l>>2]|0}else A=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(n=b[o>>0]|0,n<<24>>24>-1):0){f[c>>2]=o+1;B=n&255}else{n=VRb(c)|0;if((n|0)>-1)B=n;else{x=0;r=36;break a}}GRb(e,c,B);if((f[m>>2]|0)<0){r=29;break a}if(!(Mi[f[(f[A>>2]|0)+44>>2]&1023](A,c)|0)){r=29;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{x=0;r=36;break a}break}default:{t=q;break b}}}while(0);if(!t){x=1;r=36;break}n=f[j>>2]|0;if(!(n&1))C=mNa(j)|0;else C=n&-2;if(!(Djc(c,t,C)|0)){x=0;r=36;break}}if((r|0)==29){x=0;u=d;return x|0}else if((r|0)==36){u=d;return x|0}return 0}function Q3b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=a+8|0;e=f[c>>2]|0;if(!(e&7)){g=d;h=a+12|0;f[h>>2]=g;return g|0}if(!(e&1))i=d;else{j=f[a+16>>2]|0;k=b[j+11>>0]|0;l=k<<24>>24<0?f[j+4>>2]|0:k&255;i=d+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&2)){m=i;n=e}else{e=f[a+20>>2]|0;l=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=i+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=e;n=f[c>>2]|0}if(!(n&4)){g=m;h=a+12|0;f[h>>2]=g;return g|0}n=f[a+24>>2]|0;if((n|0)<0)o=11;else o=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=o+m|0;h=a+12|0;f[h>>2]=g;return g|0}function R3b(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&4|0)MTb(2,f[a+24>>2]|0,b);if(c&2|0)eUb(3,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function S3b(a){a=a|0;return f[a+12>>2]|0}function T3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}if(!(e&4))i=g;else{d=f[a+24>>2]|0;b[g>>0]=16;h=g+1|0;g=d&255;if(d>>>0>127){j=h;k=g;l=d;m=((d|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;d=l;l=aJc(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&d>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=h;q=g}b[p>>0]=q;i=p+1|0}if(!(e&2))r=i;else{e=f[a+20>>2]|0;b[i>>0]=26;p=i+1|0;i=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(i>>>0>127){q=i;g=p;while(1){b[g>>0]=q|128;h=q>>>7;m=g+1|0;if(q>>>0>16383){q=h;g=m}else{s=m;t=h;break}}}else{s=p;t=i}b[s>>0]=t;r=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,s+1|0)|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=Hjc(s&-2,r)|0;return u|0}function U3b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function V3b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20624,0)|0;if(!c){Ehc(b,a);return}else{Y3b(a,c);return}}function W3b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function X3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528904;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Y3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&7))return;do if(e&1|0){h=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==527320){WJa(g,k,h);break}else{iEc(j,h)|0;break}}while(0);if(e&2|0){k=a+8|0;f[k>>2]=f[k>>2]|2;k=a+20|0;d=f[k>>2]|0;if(!d){Z3b(a);l=f[k>>2]|0}else l=d;d=f[c+20>>2]|0;k=d|0?d:528376;Dlc(l+4|0,k+4|0);d=l+20|0;h=f[k+20>>2]|0;if(h&1|0){j=f[d>>2]|0;if(!(j&1))m=mNa(d)|0;else m=j&-2;ojc(m,h&-2)}h0b(l+32|0,k+32|0);if(f[k+24>>2]&1|0){h=b[k+48>>0]|0;k=l+24|0;f[k>>2]=f[k>>2]|1;b[l+48>>0]=h}}if(e&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Z3b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(52)|0;W0b(c);e=c;g=a+20|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20496,56);c=MQb(d,56)|0;X0b(c,d);e=c;g=a+20|0;f[g>>2]=e;return}function _3b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=165376;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=527944?(f[220848]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=147;b[d+8>>0]=0;DTb(883392,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function $3b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=165376;f[a+4>>2]=c;f[a+8>>2]=0;if((f[220848]|0)!=2){f[e>>2]=161028;f[e+4>>2]=147;b[e+8>>0]=0;DTb(883392,e);ZSb(e)}f[a+12>>2]=0;f[a+16>>2]=527320;e=a+20|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function a4b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=165484;c=f[a+64>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=527872?(c=f[a+68>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+60|0;d=f[c>>2]|0;if(d|0?(f[a+48>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+44|0;i=f[c>>2]|0;if(i|0?(f[a+32>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+28|0;j=f[c>>2]|0;if(j|0?(f[a+16>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(k);f[c>>2]=0;return}function b4b(a){a=a|0;a4b(a);YDc(a);return}function c4b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function d4b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(72)|0;Q4b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20640,72);a=MQb(b,72)|0;R4b(a,b);c=a;return c|0}function e4b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function f4b(a){a=a|0;return f[a+4>>2]|0}function g4b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(g=f[a+64>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&2|0){d=f[a+68>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function h4b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=7;break}}if((g|0)==7)return e|0;if(f[a+8>>2]&2|0?(g=f[a+68>>2]|0,!(_i[f[(f[g>>2]|0)+32>>2]&1023](g)|0)):0){e=0;return e|0}e=1;return e|0}function i4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+64|0;j=a+4|0;k=a+16|0;l=a+28|0;m=a+24|0;n=a+20|0;o=e+4|0;p=a+68|0;q=e+4|0;r=a+32|0;s=a+44|0;t=a+40|0;v=a+36|0;w=e+4|0;x=a+48|0;a:while(1){y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>0){f[c>>2]=y+1;B=A;C=6}else{D=A;C=5}}else{D=0;C=5}if((C|0)==5){C=0;A=WRb(c,D)|0;if((A+-1|0)>>>0<127){B=A;C=6}else E=A}b:do if((C|0)==6){C=0;switch(B>>>3&536870911|0){case 1:{if((B&255|0)!=10){E=B;break b}f[h>>2]=f[h>>2]|1;A=f[j>>2]|0;y=A&-2;if(!(A&1))F=y;else F=f[y+4>>2]|0;y=f[i>>2]|0;if((y|0)==527320){WJa(i,F,527320);G=f[i>>2]|0}else G=y;if(fUb(c,G)|0)continue a;else{H=0;C=74;break a}break}case 2:{if((B&255|0)!=18){E=B;break b}y=f[l>>2]|0;do if(y){A=f[n>>2]|0;z=f[y>>2]|0;if((A|0)>=(z|0))if((z|0)==(f[m>>2]|0)){I=z;C=20;break}else{J=z;K=y;C=21;break}else{f[n>>2]=A+1;L=f[y+4+(A<<2)>>2]|0;break}}else{I=f[m>>2]|0;C=20}while(0);if((C|0)==20){C=0;USb(k,I+1|0);y=f[l>>2]|0;J=f[y>>2]|0;K=y;C=21}if((C|0)==21){C=0;f[K>>2]=J+1;y=f[k>>2]|0;if(!y){A=VDc(28)|0;_3b(A);M=A}else{if(f[y+64>>2]|0)OQb(y,20624,32);A=MQb(y,32)|0;$3b(A,y);M=A}A=f[l>>2]|0;y=f[n>>2]|0;f[n>>2]=y+1;f[A+4+(y<<2)>>2]=M;L=M}y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(A=b[y>>0]|0,A<<24>>24>-1):0){f[c>>2]=y+1;N=A&255}else{A=VRb(c)|0;if((A|0)>-1)N=A;else{H=0;C=74;break a}}GRb(e,c,N);if((f[o>>2]|0)<0){C=33;break a}if(!(Mi[f[(f[L>>2]|0)+44>>2]&1023](L,c)|0)){C=33;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{H=0;C=74;break a}break}case 3:{if((B&255|0)!=26){E=B;break b}f[h>>2]=f[h>>2]|2;A=f[p>>2]|0;if(!A){u4b(a);O=f[p>>2]|0}else O=A;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(y=b[A>>0]|0,y<<24>>24>-1):0){f[c>>2]=A+1;P=y&255}else{y=VRb(c)|0;if((y|0)>-1)P=y;else{H=0;C=74;break a}}GRb(e,c,P);if((f[q>>2]|0)<0){C=44;break a}if(!(Mi[f[(f[O>>2]|0)+44>>2]&1023](O,c)|0)){C=44;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{H=0;C=74;break a}break}case 4:{if((B&255|0)!=34){E=B;break b}y=f[s>>2]|0;do if(y){A=f[v>>2]|0;z=f[y>>2]|0;if((A|0)>=(z|0))if((z|0)==(f[t>>2]|0)){Q=z;C=52;break}else{R=z;S=y;C=53;break}else{f[v>>2]=A+1;T=f[y+4+(A<<2)>>2]|0;break}}else{Q=f[t>>2]|0;C=52}while(0);if((C|0)==52){C=0;USb(r,Q+1|0);y=f[s>>2]|0;R=f[y>>2]|0;S=y;C=53}if((C|0)==53){C=0;f[S>>2]=R+1;y=f[r>>2]|0;if(!y){A=VDc(24)|0;v4b(A);U=A}else{if(f[y+64>>2]|0)OQb(y,20656,24);A=MQb(y,24)|0;x4b(A,y);U=A}A=f[s>>2]|0;y=f[v>>2]|0;f[v>>2]=y+1;f[A+4+(y<<2)>>2]=U;T=U}y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(A=b[y>>0]|0,A<<24>>24>-1):0){f[c>>2]=y+1;V=A&255}else{A=VRb(c)|0;if((A|0)>-1)V=A;else{H=0;C=74;break a}}GRb(e,c,V);if((f[w>>2]|0)<0){C=65;break a}if(!(Mi[f[(f[T>>2]|0)+44>>2]&1023](T,c)|0)){C=65;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{H=0;C=74;break a}break}case 5:{if((B&255|0)!=42){E=B;break b}if(fUb(c,JLa(x)|0)|0)continue a;else{H=0;C=74;break a}break}default:{E=B;break b}}}while(0);if(!E){H=1;C=74;break}A=f[j>>2]|0;if(!(A&1))W=mNa(j)|0;else W=A&-2;if(!(Djc(c,E,W)|0)){H=0;C=74;break}}if((C|0)==33){H=0;u=d;return H|0}else if((C|0)==44){H=0;u=d;return H|0}else if((C|0)==65){H=0;u=d;return H|0}else if((C|0)==74){u=d;return H|0}return 0}function j4b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+44|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=f[a+52>>2]|0;i=d+k|0;if((d|0)>0){k=f[a+60>>2]|0;h=0;g=i;while(1){c=f[k+4+(h<<2)>>2]|0;e=b[c+11>>0]|0;j=e<<24>>24<0?f[c+4>>2]|0:e&255;e=j+g+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=e;break}else g=e}}else l=i;i=f[a+8>>2]|0;if(!(i&3)){m=l;n=a+12|0;f[n>>2]=m;return m|0}if(!(i&1))o=l;else{g=f[a+64>>2]|0;d=b[g+11>>0]|0;h=d<<24>>24<0?f[g+4>>2]|0:d&255;o=l+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2)){m=o;n=a+12|0;f[n>>2]=m;return m|0}i=f[a+68>>2]|0;h=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;m=o+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=a+12|0;f[n>>2]=m;return m|0}function k4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+64>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{eUb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&2|0)eUb(3,f[a+68>>2]|0,b);c=f[a+36>>2]|0;if(c|0){d=a+44|0;g=0;do{eUb(4,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+52>>2]|0;if((c|0)>0){g=a+60|0;d=0;do{_Tb(5,f[(f[g>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function l4b(a){a=a|0;return f[a+12>>2]|0}function m4b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+64>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}d=f[a+20>>2]|0;if(!d)i=g;else{h=a+28|0;j=0;k=g;while(1){g=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;l=k+1|0;m=_i[f[(f[g>>2]|0)+60>>2]&1023](g)|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=l;s=m}b[r>>0]=s;o=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,r+1|0)|0;j=j+1|0;if((j|0)==(d|0)){i=o;break}else k=o}}if(!(e&2))t=i;else{e=f[a+68>>2]|0;b[i>>0]=26;k=i+1|0;i=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(i>>>0>127){d=i;j=k;while(1){b[j>>0]=d|128;r=d>>>7;s=j+1|0;if(d>>>0>16383){d=r;j=s}else{u=s;v=r;break}}}else{u=k;v=i}b[u>>0]=v;t=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,u+1|0)|0}u=f[a+36>>2]|0;if(!u)w=t;else{e=a+44|0;v=0;i=t;while(1){t=f[(f[e>>2]|0)+4+(v<<2)>>2]|0;b[i>>0]=34;k=i+1|0;j=_i[f[(f[t>>2]|0)+60>>2]&1023](t)|0;if(j>>>0>127){d=j;r=k;while(1){b[r>>0]=d|128;s=d>>>7;h=r+1|0;if(d>>>0>16383){d=s;r=h}else{x=h;y=s;break}}}else{x=k;y=j}b[x>>0]=y;r=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;v=v+1|0;if((v|0)==(u|0)){w=r;break}else i=r}}i=f[a+52>>2]|0;if((i|0)>0){u=a+60|0;v=0;x=w;while(1){c=f[(f[u>>2]|0)+4+(v<<2)>>2]|0;b[x>>0]=42;y=dSb(c,x+1|0)|0;v=v+1|0;if((v|0)==(i|0)){z=y;break}else x=y}}else z=w;w=f[a+4>>2]|0;if(!(w&1)){A=z;return A|0}A=Hjc(w&-2,z)|0;return A|0}function n4b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function o4b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20640,0)|0;if(!c){Ehc(b,a);return}else{r4b(a,c);return}}function p4b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function q4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528896;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function r4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}s4b(a+16|0,b+16|0);t4b(a+32|0,b+32|0);yNa(a+48|0,b+48|0);d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0){g=f[b+64>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+64|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==527320){WJa(e,j,g);break}else{iEc(i,g)|0;break}}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+68|0;j=f[d>>2]|0;if(!j){u4b(a);k=f[d>>2]|0}else k=j;j=f[b+68>>2]|0;n1b(k,j|0?j:528320);return}function s4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{P4b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(28)|0;_3b(l);P4b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20624,32);l=MQb(i,32)|0;$3b(l,i);P4b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function t4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{w4b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(24)|0;v4b(l);w4b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20656,24);l=MQb(i,24)|0;x4b(l,i);w4b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function u4b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(52)|0;o1b(c);e=c;g=a+68|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20512,56);c=MQb(d,56)|0;p1b(c,d);e=c;g=a+68|0;f[g>>2]=e;return}function v4b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=165592;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=527848?(f[220846]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=145;b[d+8>>0]=0;DTb(883384,d);ZSb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function w4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=b+4|0;d=f[a+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[a+8>>2]|0;if(!(d&3))return;if(d&1|0)f[b+16>>2]=f[a+16>>2];if(d&2|0)f[b+20>>2]=f[a+20>>2];a=b+8|0;f[a>>2]=f[a>>2]|d;return}function x4b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=165592;f[a+4>>2]=c;f[a+8>>2]=0;if((f[220846]|0)!=2){f[e>>2]=161028;f[e+4>>2]=145;b[e+8>>0]=0;DTb(883384,e);ZSb(e)}f[a+12>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function y4b(a){a=a|0;var b=0,c=0;f[a>>2]=165592;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function z4b(a){a=a|0;var b=0,c=0;f[a>>2]=165592;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function A4b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function B4b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(24)|0;v4b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20656,24);a=MQb(b,24)|0;x4b(a,b);c=a;return c|0}function C4b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function D4b(a){a=a|0;return f[a+4>>2]|0}function E4b(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&3|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function F4b(a){a=a|0;return 1}function G4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=HRb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=24;break a}}f[g>>2]=p;continue a;break}case 2:{if((l&255|0)!=16){o=l;break b}f[e>>2]=f[e>>2]|2;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;s=a}else{t=a;m=17}}else{t=0;m=17}if((m|0)==17){m=0;a=HRb(c,t)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)s=a;else{r=0;m=24;break a}}f[h>>2]=s;continue a;break}default:{o=l;break b}}}while(0);if(!o){r=1;m=24;break}a=f[i>>2]|0;if(!(a&1))u=mNa(i)|0;else u=a&-2;if(!(Djc(c,o,u)|0)){r=0;m=24;break}}if((m|0)==24)return r|0;return 0}function H4b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function I4b(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)MTb(1,f[a+16>>2]|0,b);if(c&2|0)MTb(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function J4b(a){a=a|0;return f[a+12>>2]|0}function K4b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=f[a+20>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=aJc(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function L4b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function M4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,20656,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function N4b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function O4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528888;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function P4b(a,b){a=a|0;b=b|0;Y3b(b,a);return}function Q4b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=165484;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==527872;g=a+16|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220847]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=146;b[d+8>>0]=0;DTb(883388,d);ZSb(d)}f[a+12>>2]=0;f[a+64>>2]=527320;f[a+68>>2]=0;u=c;return}function R4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[a>>2]=165484;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=c;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;if((f[220847]|0)==2){g=a+12|0;f[g>>2]=0;h=a+64|0;f[h>>2]=527320;i=a+68|0;f[i>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=146;b[e+8>>0]=0;DTb(883388,e);ZSb(e);g=a+12|0;f[g>>2]=0;h=a+64|0;f[h>>2]=527320;i=a+68|0;f[i>>2]=0;u=d;return}function S4b(a){a=a|0;var c=0,d=0;f[a>>2]=165700;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=527824?(c=f[a+20>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function T4b(a){a=a|0;S4b(a);YDc(a);return}function U4b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function V4b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(24)|0;j5b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20672,24);a=MQb(b,24)|0;k5b(a,b);c=a;return c|0}function W4b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function X4b(a){a=a|0;return f[a+4>>2]|0}function Y4b(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){d=f[a+20>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function Z4b(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&2|0?(b=f[a+20>>2]|0,!(_i[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function _4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;l=e+4|0;a:while(1){m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=m+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=WRb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[j>>2]|0;m=o&-2;if(!(o&1))t=m;else t=f[m+4>>2]|0;m=f[i>>2]|0;if((m|0)==527320){WJa(i,t,527320);v=f[i>>2]|0}else v=m;if(fUb(c,v)|0)continue a;else{w=0;q=30;break a}break}case 2:break;default:{s=p;break b}}if((p&255|0)==18){f[h>>2]=f[h>>2]|2;m=f[k>>2]|0;if(!m){i5b(a);x=f[k>>2]|0}else x=m;m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0?(o=b[m>>0]|0,o<<24>>24>-1):0){f[c>>2]=m+1;y=o&255}else{o=VRb(c)|0;if((o|0)>-1)y=o;else{w=0;q=30;break a}}GRb(e,c,y);if((f[l>>2]|0)<0){q=23;break a}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=23;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{w=0;q=30;break a}}else s=p}while(0);if(!s){w=1;q=30;break}o=f[j>>2]|0;if(!(o&1))z=mNa(j)|0;else z=o&-2;if(!(Djc(c,s,z)|0)){w=0;q=30;break}}if((q|0)==23){w=0;u=d;return w|0}else if((q|0)==30){u=d;return w|0}return 0}function $4b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+20>>2]|0;k=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;e=h+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function a5b(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&2|0)eUb(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function b5b(a){a=a|0;return f[a+12>>2]|0}function c5b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}if(!(e&2))i=g;else{e=f[a+20>>2]|0;b[g>>0]=18;d=g+1|0;g=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(g>>>0>127){h=g;j=d;while(1){b[j>>0]=h|128;k=h>>>7;l=j+1|0;if(h>>>0>16383){h=k;j=l}else{m=l;n=k;break}}}else{m=d;n=g}b[m>>0]=n;i=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,m+1|0)|0}m=f[a+4>>2]|0;if(!(m&1)){o=i;return o|0}o=Hjc(m&-2,i)|0;return o|0}function d5b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function e5b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20672,0)|0;if(!c){Ehc(b,a);return}else{h5b(a,c);return}}function f5b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function g5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528880;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function h5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0){g=f[b+16>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+16|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==527320){WJa(e,j,g);break}else{iEc(i,g)|0;break}}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+20|0;j=f[d>>2]|0;if(!j){i5b(a);k=f[d>>2]|0}else k=j;j=f[b+20>>2]|0;b=j|0?j:528272;Dlc(k+4|0,b+4|0);j=k+20|0;d=f[b+20>>2]|0;if(d&1|0){a=f[j>>2]|0;if(!(a&1))l=mNa(j)|0;else l=a&-2;ojc(l,d&-2)}h0b(k+32|0,b+32|0);return}function i5b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(48)|0;H1b(c);e=c;g=a+20|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20528,48);c=MQb(d,48)|0;I1b(c,d);e=c;g=a+20|0;f[g>>2]=e;return}function j5b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=165700;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=527824?(f[220845]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=144;b[d+8>>0]=0;DTb(883380,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=0;u=c;return}function k5b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=165700;f[a+4>>2]=c;f[a+8>>2]=0;if((f[220845]|0)!=2){f[e>>2]=161028;f[e+4>>2]=144;b[e+8>>0]=0;DTb(883380,e);ZSb(e)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=0;u=d;return}function l5b(a){a=a|0;var b=0,c=0;f[a>>2]=165808;G5b(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function m5b(a){a=a|0;l5b(a);YDc(a);return}function n5b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function o5b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(56)|0;E5b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20688,56);a=MQb(b,56)|0;F5b(a,b);c=a;return c|0}function p5b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function q5b(a){a=a|0;return f[a+4>>2]|0}function r5b(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&63|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0?(g=f[a+20>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&4|0?(e=f[a+24>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&8|0?(g=f[a+28>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&16|0?(e=f[a+32>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&32|0){g=f[a+36>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}}if(d&192|0){g=a+40|0;f[g>>2]=0;f[g+4>>2]=0}if(d&768|0){f[a+48>>2]=1;f[a+52>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function s5b(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&32|0?(b=f[a+36>>2]|0,!(_i[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function t5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;l=a+40|0;m=a+48|0;n=a+52|0;o=a+24|0;p=a+28|0;q=a+36|0;r=e+4|0;s=a+44|0;t=a+32|0;a:while(1){v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){w=b[v>>0]|0;x=w&255;if(w<<24>>24>0){f[c>>2]=v+1;y=x;z=6}else{A=x;z=5}}else{A=0;z=5}if((z|0)==5){z=0;x=WRb(c,A)|0;if((x+-1|0)>>>0<127){y=x;z=6}else B=x}b:do if((z|0)==6){z=0;do switch(y>>>3&536870911|0){case 1:{if((y&255|0)!=10){B=y;break b}f[h>>2]=f[h>>2]|1;x=f[j>>2]|0;v=x&-2;if(!(x&1))C=v;else C=f[v+4>>2]|0;v=f[i>>2]|0;if((v|0)==527320){WJa(i,C,527320);D=f[i>>2]|0}else D=v;if(fUb(c,D)|0)continue a;else{E=0;z=92;break a}break}case 2:{if((y&255|0)!=18){B=y;break b}f[h>>2]=f[h>>2]|2;v=f[j>>2]|0;x=v&-2;if(!(v&1))F=x;else F=f[x+4>>2]|0;x=f[k>>2]|0;if((x|0)==527320){WJa(k,F,527320);G=f[k>>2]|0}else G=x;if(fUb(c,G)|0)continue a;else{E=0;z=92;break a}break}case 3:{if((y&255|0)!=24){B=y;break b}f[h>>2]=f[h>>2]|64;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){v=b[x>>0]|0;w=v&255;if(v<<24>>24>-1){f[c>>2]=x+1;H=w}else{I=w;z=25}}else{I=0;z=25}if((z|0)==25){z=0;w=HRb(c,I)|0;x=J;if((x|0)>-1|(x|0)==-1&w>>>0>4294967295)H=w;else{E=0;z=92;break a}}f[l>>2]=H;continue a;break}case 4:{if((y&255|0)!=32){B=y;break b}w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){x=b[w>>0]|0;v=x&255;if(x<<24>>24>-1){f[c>>2]=w+1;K=v}else{L=v;z=31}}else{L=0;z=31}if((z|0)==31){z=0;v=HRb(c,L)|0;w=J;if((w|0)>-1|(w|0)==-1&v>>>0>4294967295)K=v;else{E=0;z=92;break a}}if((K+-1|0)>>>0<3){f[h>>2]=f[h>>2]|256;f[m>>2]=K;continue a}v=f[j>>2]|0;if(!(v&1))M=mNa(j)|0;else M=v&-2;rjc(M,4,K,((K|0)<0)<<31>>31);continue a;break}case 5:{if((y&255|0)!=40){B=y;break b}v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){w=b[v>>0]|0;x=w&255;if(w<<24>>24>-1){f[c>>2]=v+1;N=x}else{O=x;z=42}}else{O=0;z=42}if((z|0)==42){z=0;x=HRb(c,O)|0;v=J;if((v|0)>-1|(v|0)==-1&x>>>0>4294967295)N=x;else{E=0;z=92;break a}}if((N+-1|0)>>>0<18){f[h>>2]=f[h>>2]|512;f[n>>2]=N;continue a}x=f[j>>2]|0;if(!(x&1))P=mNa(j)|0;else P=x&-2;rjc(P,5,N,((N|0)<0)<<31>>31);continue a;break}case 6:{if((y&255|0)!=50){B=y;break b}f[h>>2]=f[h>>2]|4;x=f[j>>2]|0;v=x&-2;if(!(x&1))Q=v;else Q=f[v+4>>2]|0;v=f[o>>2]|0;if((v|0)==527320){WJa(o,Q,527320);R=f[o>>2]|0}else R=v;if(fUb(c,R)|0)continue a;else{E=0;z=92;break a}break}case 7:{if((y&255|0)!=58){B=y;break b}f[h>>2]=f[h>>2]|8;v=f[j>>2]|0;x=v&-2;if(!(v&1))S=x;else S=f[x+4>>2]|0;x=f[p>>2]|0;if((x|0)==527320){WJa(p,S,527320);T=f[p>>2]|0}else T=x;if(fUb(c,T)|0)continue a;else{E=0;z=92;break a}break}case 8:{if((y&255|0)!=66){B=y;break b}f[h>>2]=f[h>>2]|32;x=f[q>>2]|0;if(!x){D5b(a);U=f[q>>2]|0}else U=x;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(v=b[x>>0]|0,v<<24>>24>-1):0){f[c>>2]=x+1;V=v&255}else{v=VRb(c)|0;if((v|0)>-1)V=v;else{E=0;z=92;break a}}GRb(e,c,V);if((f[r>>2]|0)<0){z=72;break a}if(!(Mi[f[(f[U>>2]|0)+44>>2]&1023](U,c)|0)){z=72;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{E=0;z=92;break a}break}case 9:{if((y&255|0)!=72){B=y;break b}f[h>>2]=f[h>>2]|128;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){x=b[v>>0]|0;w=x&255;if(x<<24>>24>-1){f[c>>2]=v+1;W=w}else{X=w;z=78}}else{X=0;z=78}if((z|0)==78){z=0;w=HRb(c,X)|0;v=J;if((v|0)>-1|(v|0)==-1&w>>>0>4294967295)W=w;else{E=0;z=92;break a}}f[s>>2]=W;continue a;break}case 10:{if((y&255|0)!=82){B=y;break b}f[h>>2]=f[h>>2]|16;w=f[j>>2]|0;v=w&-2;if(!(w&1))Y=v;else Y=f[v+4>>2]|0;v=f[t>>2]|0;if((v|0)==527320){WJa(t,Y,527320);Z=f[t>>2]|0}else Z=v;if(fUb(c,Z)|0)continue a;else{E=0;z=92;break a}break}default:{B=y;break b}}while(0)}while(0);if(!B){E=1;z=92;break}v=f[j>>2]|0;if(!(v&1))_=mNa(j)|0;else _=v&-2;if(!(Djc(c,B,_)|0)){E=0;z=92;break}}if((z|0)==72){E=0;u=d;return E|0}else if((z|0)==92){u=d;return E|0}return 0}function u5b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=a+8|0;e=f[c>>2]|0;if(e&255){if(!(e&1))g=d;else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0?f[h+4>>2]|0:i&255;g=d+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&2))k=g;else{j=f[a+20>>2]|0;i=b[j+11>>0]|0;h=i<<24>>24<0?f[j+4>>2]|0:i&255;k=g+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&4))l=k;else{h=f[a+24>>2]|0;g=b[h+11>>0]|0;i=g<<24>>24<0?f[h+4>>2]|0:g&255;l=k+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&8))m=l;else{i=f[a+28>>2]|0;k=b[i+11>>0]|0;g=k<<24>>24<0?f[i+4>>2]|0:k&255;m=l+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&16))n=m;else{g=f[a+32>>2]|0;l=b[g+11>>0]|0;k=l<<24>>24<0?f[g+4>>2]|0:l&255;n=m+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&32)){o=n;p=e}else{k=f[a+36>>2]|0;m=_i[f[(f[k>>2]|0)+48>>2]&1023](k)|0;k=n+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;o=k;p=f[c>>2]|0}if(!(p&64))q=o;else{c=f[a+40>>2]|0;if((c|0)<0)r=11;else r=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;q=r+o|0}if(!(p&128)){s=q;t=p}else{o=f[a+44>>2]|0;if((o|0)<0)u=11;else u=((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;s=u+q|0;t=p}}else{s=d;t=e}if(!(t&768)){v=s;w=a+12|0;f[w>>2]=v;return v|0}if(!(t&256))x=s;else{e=f[a+48>>2]|0;if((e|0)<0)y=11;else y=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;x=y+s|0}if(!(t&512)){v=x;w=a+12|0;f[w>>2]=v;return v|0}t=f[a+52>>2]|0;if((t|0)<0)z=11;else z=((((($(t|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;v=z+x|0;w=a+12|0;f[w>>2]=v;return v|0}function v5b(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+16>>2]|0,b);if(c&2|0)$Tb(2,f[a+20>>2]|0,b);if(c&64|0)MTb(3,f[a+40>>2]|0,b);if(c&256|0)ZTb(4,f[a+48>>2]|0,b);if(c&512|0)ZTb(5,f[a+52>>2]|0,b);if(c&4|0)$Tb(6,f[a+24>>2]|0,b);if(c&8|0)$Tb(7,f[a+28>>2]|0,b);if(c&32|0)eUb(8,f[a+36>>2]|0,b);if(c&128|0)MTb(9,f[a+44>>2]|0,b);if(c&16|0)$Tb(10,f[a+32>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function w5b(a){a=a|0;return f[a+12>>2]|0}function x5b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}if(!(e&2))i=g;else{d=f[a+20>>2]|0;b[g>>0]=18;i=dSb(d,g+1|0)|0}if(!(e&64))j=i;else{g=f[a+40>>2]|0;b[i>>0]=24;d=i+1|0;i=g&255;if(g>>>0>127){h=d;k=i;l=g;m=((g|0)<0)<<31>>31;while(1){b[h>>0]=k|-128;g=l;l=aJc(l|0,m|0,7)|0;n=h+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&g>>>0>16383)){p=n;q=o;break}else{h=n;k=o;m=J}}}else{p=d;q=i}b[p>>0]=q;j=p+1|0}if(!(e&256))r=j;else{p=f[a+48>>2]|0;b[j>>0]=32;q=j+1|0;j=p&255;if(p>>>0>127){i=q;d=j;m=p;k=((p|0)<0)<<31>>31;while(1){b[i>>0]=d|-128;p=m;m=aJc(m|0,k|0,7)|0;h=i+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=h;t=l;break}else{i=h;d=l;k=J}}}else{s=q;t=j}b[s>>0]=t;r=s+1|0}if(!(e&512))u=r;else{s=f[a+52>>2]|0;b[r>>0]=40;t=r+1|0;r=s&255;if(s>>>0>127){j=t;q=r;k=s;d=((s|0)<0)<<31>>31;while(1){b[j>>0]=q|-128;s=k;k=aJc(k|0,d|0,7)|0;i=j+1|0;m=k&255;if(!(d>>>0>0|(d|0)==0&s>>>0>16383)){v=i;w=m;break}else{j=i;q=m;d=J}}}else{v=t;w=r}b[v>>0]=w;u=v+1|0}if(!(e&4))x=u;else{v=f[a+24>>2]|0;b[u>>0]=50;x=dSb(v,u+1|0)|0}if(!(e&8))y=x;else{u=f[a+28>>2]|0;b[x>>0]=58;y=dSb(u,x+1|0)|0}if(!(e&32))z=y;else{x=f[a+36>>2]|0;b[y>>0]=66;u=y+1|0;y=_i[f[(f[x>>2]|0)+60>>2]&1023](x)|0;if(y>>>0>127){v=y;w=u;while(1){b[w>>0]=v|128;r=v>>>7;t=w+1|0;if(v>>>0>16383){v=r;w=t}else{A=t;B=r;break}}}else{A=u;B=y}b[A>>0]=B;z=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,A+1|0)|0}if(!(e&128))C=z;else{A=f[a+44>>2]|0;b[z>>0]=72;c=z+1|0;z=A&255;if(A>>>0>127){x=c;B=z;y=A;u=((A|0)<0)<<31>>31;while(1){b[x>>0]=B|-128;A=y;y=aJc(y|0,u|0,7)|0;w=x+1|0;v=y&255;if(!(u>>>0>0|(u|0)==0&A>>>0>16383)){D=w;E=v;break}else{x=w;B=v;u=J}}}else{D=c;E=z}b[D>>0]=E;C=D+1|0}if(!(e&16))F=C;else{e=f[a+32>>2]|0;b[C>>0]=82;F=dSb(e,C+1|0)|0}C=f[a+4>>2]|0;if(!(C&1)){G=F;return G|0}G=Hjc(C&-2,F)|0;return G|0}function y5b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function z5b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20688,0)|0;if(!c){Ehc(b,a);return}else{C5b(a,c);return}}function A5b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function B5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528872;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function C5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(d&255|0){do if(d&1|0){g=f[b+16>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+16|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==527320){WJa(e,j,g);break}else{iEc(i,g)|0;break}}while(0);do if(d&2|0){j=f[b+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[c>>2]|0;e=i&-2;if(!(i&1))k=e;else k=f[e+4>>2]|0;e=f[g>>2]|0;if((e|0)==527320){WJa(g,k,j);break}else{iEc(e,j)|0;break}}while(0);do if(d&4|0){k=f[b+24>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|4;j=a+24|0;e=f[c>>2]|0;g=e&-2;if(!(e&1))l=g;else l=f[g+4>>2]|0;g=f[j>>2]|0;if((g|0)==527320){WJa(j,l,k);break}else{iEc(g,k)|0;break}}while(0);do if(d&8|0){l=f[b+28>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|8;k=a+28|0;g=f[c>>2]|0;j=g&-2;if(!(g&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==527320){WJa(k,m,l);break}else{iEc(j,l)|0;break}}while(0);do if(d&16|0){m=f[b+32>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|16;l=a+32|0;j=f[c>>2]|0;k=j&-2;if(!(j&1))n=k;else n=f[k+4>>2]|0;k=f[l>>2]|0;if((k|0)==527320){WJa(l,n,m);break}else{iEc(k,m)|0;break}}while(0);if(d&32|0){n=a+8|0;f[n>>2]=f[n>>2]|32;n=a+36|0;c=f[n>>2]|0;if(!c){D5b(a);o=f[n>>2]|0}else o=c;c=f[b+36>>2]|0;_1b(o,c|0?c:528208)}if(d&64|0)f[a+40>>2]=f[b+40>>2];if(d&128|0)f[a+44>>2]=f[b+44>>2];c=a+8|0;f[c>>2]=f[c>>2]|d}if(!(d&768))return;if(d&256|0)f[a+48>>2]=f[b+48>>2];if(d&512|0)f[a+52>>2]=f[b+52>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function D5b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(60)|0;$1b(c);e=c;g=a+36|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20544,64);c=MQb(d,64)|0;a2b(c,d);e=c;g=a+36|0;f[g>>2]=e;return}function E5b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=165808;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=527768?(f[220844]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=143;b[d+8>>0]=0;DTb(883376,d);ZSb(d)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;f[a+28>>2]=527320;f[a+32>>2]=527320;d=a+36|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[a+48>>2]=1;f[a+52>>2]=1;u=c;return}function F5b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=165808;f[a+4>>2]=c;f[a+8>>2]=0;if((f[220844]|0)!=2){f[e>>2]=161028;f[e+4>>2]=143;b[e+8>>0]=0;DTb(883376,e);ZSb(e)}f[a+12>>2]=0;f[a+16>>2]=527320;f[a+20>>2]=527320;f[a+24>>2]=527320;f[a+28>>2]=527320;f[a+32>>2]=527320;e=a+36|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[a+48>>2]=1;f[a+52>>2]=1;u=d;return}function G5b(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+20>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+24>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+28>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+32>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==527768)return;c=f[a+36>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function H5b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=165916;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)ljc(h);YDc(c)}f[b>>2]=0;mkc(a+4|0);return}function I5b(a){a=a|0;H5b(a);YDc(a);return}function J5b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function K5b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(48)|0;Y5b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20704,48);a=MQb(b,48)|0;Z5b(a,b);c=a;return c|0}function L5b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function M5b(a){a=a|0;return f[a+20>>2]|0}function N5b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;Clc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function O5b(a){a=a|0;var b=0,c=0,d=0,e=0;if(!(Hlc(a+4|0)|0)){b=0;return b|0}c=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0){b=1;e=5;break}d=d+-1|0;a=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(!(_i[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){b=0;e=5;break}}if((e|0)==5)return b|0;return 0}function P5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+32|0;j=e+4|0;k=a+4|0;l=a+20|0;while(1){a=f[c>>2]|0;m=f[g>>2]|0;do if(a>>>0<m>>>0){n=b[a>>0]|0;o=n&255;p=a+1|0;if(n<<24>>24>0){q=p;r=o}else{if(p>>>0>=m>>>0){s=o;t=7;break}n=h[p>>0]|0;if(((n^128)&o)>>>0<=127){s=o;t=7;break}q=a+2|0;r=o+-128+(n<<7)|0}f[c>>2]=q;v=r;t=9}else{s=0;t=7}while(0);if((t|0)==7){t=0;a=WRb(c,s)|0;if((a+-1|0)>>>0<16383){v=a;t=9}else w=a}if((t|0)==9){t=0;if((v|0)==7994){a=j0b(i)|0;m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[c>>2]=m+1;x=n&255}else{n=VRb(c)|0;if((n|0)>-1)x=n;else{y=0;t=28;break}}GRb(e,c,x);if((f[j>>2]|0)<0){t=16;break}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){t=16;break}if(LRb(c,f[e>>2]|0)|0)continue;else{y=0;t=28;break}}else w=v}if(!w){y=1;t=28;break}a=f[l>>2]|0;n=(a&1|0)==0;if(w>>>0>7999){if(n)z=mNa(l)|0;else z=a&-2;if(x9b(k,w,c,527720,z)|0)continue;else{y=0;t=28;break}}else{if(n)A=mNa(l)|0;else A=a&-2;if(Djc(c,w,A)|0)continue;else{y=0;t=28;break}}}if((t|0)==16){y=0;u=d;return y|0}else if((t|0)==28){u=d;return y|0}return 0}function Q5b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=Nlc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Jjc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b){e=c;g=a+28|0;f[g>>2]=e;return e|0}d=a+44|0;h=0;i=c;while(1){c=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=c;break}else i=c}g=a+28|0;f[g>>2]=e;return e|0}function R5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+36>>2]|0;if(c|0){d=a+44|0;e=0;do{eUb(999,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}Llc(a+4|0,1e3,536870912,b);c=f[a+20>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function S5b(a){a=a|0;return f[a+28>>2]|0}function T5b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+36>>2]|0;if(!e)g=d;else{h=a+44|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=-70;b[j+1>>0]=62;k=j+2|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=B9b(a+4|0,1e3,536870912,c,g)|0;g=f[a+20>>2]|0;if(!(g&1)){s=j;return s|0}s=Hjc(g&-2,j)|0;return s|0}function U5b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function V5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,20704,0)|0;if(!c){Ehc(b,a);return}Dlc(a+4|0,c+4|0);b=a+20|0;d=f[c+20>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}h0b(a+32|0,c+32|0);return}function W5b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function X5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528864;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Y5b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=165916;lkc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=527720?(f[220843]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=142;b[d+8>>0]=0;DTb(883372,d);ZSb(d)}f[a+28>>2]=0;u=c;return}function Z5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=165916;hkc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[220843]|0)==2){g=a+28|0;f[g>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=142;b[e+8>>0]=0;DTb(883372,e);ZSb(e);g=a+28|0;f[g>>2]=0;u=d;return}function _5b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f[a>>2]=166024;c=f[a+144>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=527568?(c=f[a+148>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+140|0;d=f[c>>2]|0;if(d|0?(f[a+128>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+124|0;i=f[c>>2]|0;if(i|0?(f[a+112>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+108|0;j=f[c>>2]|0;if(j|0?(f[a+96>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+92|0;k=f[c>>2]|0;if(k|0?(f[a+80>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;YDc(l)}f[c>>2]=0;c=a+76|0;l=f[c>>2]|0;if(l|0?(f[a+64>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0)Yi[f[(f[i>>2]|0)+4>>2]&2047](i);j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;YDc(m)}f[c>>2]=0;c=a+60|0;m=f[c>>2]|0;if(m|0?(f[a+48>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0)Yi[f[(f[j>>2]|0)+4>>2]&2047](j);k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;YDc(n)}f[c>>2]=0;c=a+44|0;n=f[c>>2]|0;if(n|0?(f[a+32>>2]|0)==0:0){m=f[n>>2]|0;if((m|0)>0){l=0;do{k=f[n+4+(l<<2)>>2]|0;if(k|0)Yi[f[(f[k>>2]|0)+4>>2]&2047](k);l=l+1|0}while((l|0)!=(m|0));o=f[c>>2]|0}else o=n;YDc(o)}f[c>>2]=0;c=a+28|0;o=f[c>>2]|0;if(o|0?(f[a+16>>2]|0)==0:0){n=f[o>>2]|0;if((n|0)>0){m=0;do{l=f[o+4+(m<<2)>>2]|0;if(l|0)Yi[f[(f[l>>2]|0)+4>>2]&2047](l);m=m+1|0}while((m|0)!=(n|0));p=f[c>>2]|0}else p=o;YDc(p)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}p=a&-2;a=p;if((p|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(p);f[c>>2]=0;return}function $5b(a){a=a|0;_5b(a);YDc(a);return}function a6b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function b6b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(152)|0;n7b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20720,152);a=MQb(b,152)|0;p7b(a,b);c=a;return c|0}function c6b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function d6b(a){a=a|0;return f[a+4>>2]|0}function e6b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+68|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+76>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+84|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+92>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+100|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+108>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+116|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+124>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+132|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+140>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(e=f[a+144>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){d=f[a+148>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function f6b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=22;break}}if((g|0)==22)return e|0;c=a+44|0;b=f[a+36>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=22;break}}if((g|0)==22)return e|0;b=a+60|0;c=f[a+52>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=22;break}}if((g|0)==22)return e|0;c=a+76|0;b=f[a+68>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=22;break}}if((g|0)==22)return e|0;b=a+92|0;c=f[a+84>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=22;break}}if((g|0)==22)return e|0;c=a+108|0;b=f[a+100>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=22;break}}if((g|0)==22)return e|0;if(f[a+8>>2]&2|0?(g=f[a+148>>2]|0,!(_i[f[(f[g>>2]|0)+32>>2]&1023](g)|0)):0){e=0;return e|0}e=1;return e|0}function g6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+144|0;j=a+4|0;k=a+16|0;l=e+4|0;m=a+32|0;n=e+4|0;o=a+48|0;p=e+4|0;q=a+64|0;r=a+76|0;s=a+72|0;t=a+68|0;v=e+4|0;w=a+80|0;x=e+4|0;y=a+148|0;z=e+4|0;A=a+96|0;B=a+108|0;C=a+104|0;D=a+100|0;E=e+4|0;F=a+112|0;G=a+124|0;H=a+120|0;I=a+116|0;J=e+4|0;K=a+128|0;a:while(1){L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){M=b[L>>0]|0;N=M&255;if(M<<24>>24>0){f[c>>2]=L+1;O=N;P=6}else{Q=N;P=5}}else{Q=0;P=5}if((P|0)==5){P=0;N=WRb(c,Q)|0;if((N+-1|0)>>>0<127){O=N;P=6}else R=N}b:do if((P|0)==6){P=0;do switch(O>>>3&536870911|0){case 1:{if((O&255|0)!=10){R=O;break b}f[h>>2]=f[h>>2]|1;N=f[j>>2]|0;L=N&-2;if(!(N&1))S=L;else S=f[L+4>>2]|0;L=f[i>>2]|0;if((L|0)==527320){WJa(i,S,527320);T=f[i>>2]|0}else T=L;if(fUb(c,T)|0)continue a;else{U=0;P=131;break a}break}case 2:{if((O&255|0)!=18){R=O;break b}L=YXb(k)|0;N=f[c>>2]|0;if(N>>>0<(f[g>>2]|0)>>>0?(M=b[N>>0]|0,M<<24>>24>-1):0){f[c>>2]=N+1;V=M&255}else{M=VRb(c)|0;if((M|0)>-1)V=M;else{U=0;P=131;break a}}GRb(e,c,V);if((f[l>>2]|0)<0){P=21;break a}if(!(Mi[f[(f[L>>2]|0)+44>>2]&1023](L,c)|0)){P=21;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 3:{if((O&255|0)!=26){R=O;break b}L=TXb(m)|0;M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(N=b[M>>0]|0,N<<24>>24>-1):0){f[c>>2]=M+1;W=N&255}else{N=VRb(c)|0;if((N|0)>-1)W=N;else{U=0;P=131;break a}}GRb(e,c,W);if((f[n>>2]|0)<0){P=30;break a}if(!(Mi[f[(f[L>>2]|0)+44>>2]&1023](L,c)|0)){P=30;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 4:{if((O&255|0)!=34){R=O;break b}L=VXb(o)|0;N=f[c>>2]|0;if(N>>>0<(f[g>>2]|0)>>>0?(M=b[N>>0]|0,M<<24>>24>-1):0){f[c>>2]=N+1;X=M&255}else{M=VRb(c)|0;if((M|0)>-1)X=M;else{U=0;P=131;break a}}GRb(e,c,X);if((f[p>>2]|0)<0){P=39;break a}if(!(Mi[f[(f[L>>2]|0)+44>>2]&1023](L,c)|0)){P=39;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 5:{if((O&255|0)!=42){R=O;break b}L=f[r>>2]|0;do if(L){M=f[t>>2]|0;N=f[L>>2]|0;if((M|0)>=(N|0))if((N|0)==(f[s>>2]|0)){Y=N;P=47;break}else{Z=N;_=L;P=48;break}else{f[t>>2]=M+1;$=f[L+4+(M<<2)>>2]|0;break}}else{Y=f[s>>2]|0;P=47}while(0);if((P|0)==47){P=0;USb(q,Y+1|0);L=f[r>>2]|0;Z=f[L>>2]|0;_=L;P=48}if((P|0)==48){P=0;f[_>>2]=Z+1;L=f[q>>2]|0;if(!L){M=VDc(28)|0;S6b(M);aa=M}else{if(f[L+64>>2]|0)OQb(L,20752,32);M=MQb(L,32)|0;U6b(M,L);aa=M}M=f[r>>2]|0;L=f[t>>2]|0;f[t>>2]=L+1;f[M+4+(L<<2)>>2]=aa;$=aa}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(M=b[L>>0]|0,M<<24>>24>-1):0){f[c>>2]=L+1;ba=M&255}else{M=VRb(c)|0;if((M|0)>-1)ba=M;else{U=0;P=131;break a}}GRb(e,c,ba);if((f[v>>2]|0)<0){P=60;break a}if(!(Mi[f[(f[$>>2]|0)+44>>2]&1023]($,c)|0)){P=60;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 6:{if((O&255|0)!=50){R=O;break b}M=YXb(w)|0;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(N=b[L>>0]|0,N<<24>>24>-1):0){f[c>>2]=L+1;ca=N&255}else{N=VRb(c)|0;if((N|0)>-1)ca=N;else{U=0;P=131;break a}}GRb(e,c,ca);if((f[x>>2]|0)<0){P=69;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){P=69;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 7:{if((O&255|0)!=58){R=O;break b}f[h>>2]=f[h>>2]|2;M=f[y>>2]|0;if(!M){w6b(a);da=f[y>>2]|0}else da=M;M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(N=b[M>>0]|0,N<<24>>24>-1):0){f[c>>2]=M+1;ea=N&255}else{N=VRb(c)|0;if((N|0)>-1)ea=N;else{U=0;P=131;break a}}GRb(e,c,ea);if((f[z>>2]|0)<0){P=80;break a}if(!(Mi[f[(f[da>>2]|0)+44>>2]&1023](da,c)|0)){P=80;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 8:{if((O&255|0)!=66){R=O;break b}N=f[B>>2]|0;do if(N){M=f[D>>2]|0;L=f[N>>2]|0;if((M|0)>=(L|0))if((L|0)==(f[C>>2]|0)){fa=L;P=88;break}else{ga=L;ha=N;P=89;break}else{f[D>>2]=M+1;ia=f[N+4+(M<<2)>>2]|0;break}}else{fa=f[C>>2]|0;P=88}while(0);if((P|0)==88){P=0;USb(A,fa+1|0);N=f[B>>2]|0;ga=f[N>>2]|0;ha=N;P=89}if((P|0)==89){P=0;f[ha>>2]=ga+1;N=f[A>>2]|0;if(!N){M=VDc(24)|0;j5b(M);ja=M}else{if(f[N+64>>2]|0)OQb(N,20672,24);M=MQb(N,24)|0;k5b(M,N);ja=M}M=f[B>>2]|0;N=f[D>>2]|0;f[D>>2]=N+1;f[M+4+(N<<2)>>2]=ja;ia=ja}N=f[c>>2]|0;if(N>>>0<(f[g>>2]|0)>>>0?(M=b[N>>0]|0,M<<24>>24>-1):0){f[c>>2]=N+1;ka=M&255}else{M=VRb(c)|0;if((M|0)>-1)ka=M;else{U=0;P=131;break a}}GRb(e,c,ka);if((f[E>>2]|0)<0){P=101;break a}if(!(Mi[f[(f[ia>>2]|0)+44>>2]&1023](ia,c)|0)){P=101;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 9:{if((O&255|0)!=74){R=O;break b}M=f[G>>2]|0;do if(M){N=f[I>>2]|0;L=f[M>>2]|0;if((N|0)>=(L|0))if((L|0)==(f[H>>2]|0)){la=L;P=109;break}else{ma=L;na=M;P=110;break}else{f[I>>2]=N+1;oa=f[M+4+(N<<2)>>2]|0;break}}else{la=f[H>>2]|0;P=109}while(0);if((P|0)==109){P=0;USb(F,la+1|0);M=f[G>>2]|0;ma=f[M>>2]|0;na=M;P=110}if((P|0)==110){P=0;f[na>>2]=ma+1;M=f[F>>2]|0;if(!M){N=VDc(24)|0;x6b(N);pa=N}else{if(f[M+64>>2]|0)OQb(M,20736,24);N=MQb(M,24)|0;z6b(N,M);pa=N}N=f[G>>2]|0;M=f[I>>2]|0;f[I>>2]=M+1;f[N+4+(M<<2)>>2]=pa;oa=pa}M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(N=b[M>>0]|0,N<<24>>24>-1):0){f[c>>2]=M+1;qa=N&255}else{N=VRb(c)|0;if((N|0)>-1)qa=N;else{U=0;P=131;break a}}GRb(e,c,qa);if((f[J>>2]|0)<0){P=122;break a}if(!(Mi[f[(f[oa>>2]|0)+44>>2]&1023](oa,c)|0)){P=122;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 10:{if((O&255|0)!=82){R=O;break b}if(fUb(c,JLa(K)|0)|0)continue a;else{U=0;P=131;break a}break}default:{R=O;break b}}while(0)}while(0);if(!R){U=1;P=131;break}N=f[j>>2]|0;if(!(N&1))ra=mNa(j)|0;else ra=N&-2;if(!(Djc(c,R,ra)|0)){U=0;P=131;break}}if((P|0)==21){U=0;u=d;return U|0}else if((P|0)==30){U=0;u=d;return U|0}else if((P|0)==39){U=0;u=d;return U|0}else if((P|0)==60){U=0;u=d;return U|0}else if((P|0)==69){U=0;u=d;return U|0}else if((P|0)==80){U=0;u=d;return U|0}else if((P|0)==101){U=0;u=d;return U|0}else if((P|0)==122){U=0;u=d;return U|0}else if((P|0)==131){u=d;return U|0}return 0}function h6b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+44|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=f[a+52>>2]|0;i=d+k|0;if(!d)l=i;else{k=a+60|0;h=0;g=i;while(1){i=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;c=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;i=c+g+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=i;break}else g=i}}g=f[a+68>>2]|0;d=g+l|0;if(!g)m=d;else{l=a+76|0;h=0;k=d;while(1){d=f[(f[l>>2]|0)+4+(h<<2)>>2]|0;i=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=i+k+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(g|0)){m=d;break}else k=d}}k=f[a+84>>2]|0;g=k+m|0;if(!k)n=g;else{m=a+92|0;h=0;l=g;while(1){g=f[(f[m>>2]|0)+4+(h<<2)>>2]|0;d=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;g=d+l+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(k|0)){n=g;break}else l=g}}l=f[a+100>>2]|0;k=l+n|0;if(!l)o=k;else{n=a+108|0;h=0;m=k;while(1){k=f[(f[n>>2]|0)+4+(h<<2)>>2]|0;g=_i[f[(f[k>>2]|0)+48>>2]&1023](k)|0;k=g+m+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(l|0)){o=k;break}else m=k}}m=f[a+116>>2]|0;l=m+o|0;if(!m)p=l;else{o=a+124|0;h=0;n=l;while(1){l=f[(f[o>>2]|0)+4+(h<<2)>>2]|0;k=_i[f[(f[l>>2]|0)+48>>2]&1023](l)|0;l=k+n+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(m|0)){p=l;break}else n=l}}n=f[a+132>>2]|0;m=n+p|0;if((n|0)>0){p=f[a+140>>2]|0;h=0;o=m;while(1){l=f[p+4+(h<<2)>>2]|0;k=b[l+11>>0]|0;g=k<<24>>24<0?f[l+4>>2]|0:k&255;k=g+o+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(n|0)){q=k;break}else o=k}}else q=m;m=f[a+8>>2]|0;if(!(m&3)){r=q;s=a+12|0;f[s>>2]=r;return r|0}if(!(m&1))t=q;else{o=f[a+144>>2]|0;n=b[o+11>>0]|0;h=n<<24>>24<0?f[o+4>>2]|0:n&255;t=q+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(m&2)){r=t;s=a+12|0;f[s>>2]=r;return r|0}m=f[a+148>>2]|0;h=_i[f[(f[m>>2]|0)+48>>2]&1023](m)|0;r=t+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;s=a+12|0;f[s>>2]=r;return r|0}function i6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+144>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{eUb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+36>>2]|0;if(d|0){g=a+44|0;e=0;do{eUb(3,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+52>>2]|0;if(d|0){e=a+60|0;g=0;do{eUb(4,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+68>>2]|0;if(d|0){g=a+76|0;e=0;do{eUb(5,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+84>>2]|0;if(d|0){e=a+92|0;g=0;do{eUb(6,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&2|0)eUb(7,f[a+148>>2]|0,b);c=f[a+100>>2]|0;if(c|0){d=a+108|0;g=0;do{eUb(8,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+116>>2]|0;if(c|0){g=a+124|0;d=0;do{eUb(9,f[(f[g>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+132>>2]|0;if((c|0)>0){d=a+140|0;g=0;do{_Tb(10,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function j6b(a){a=a|0;return f[a+12>>2]|0}function k6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+144>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}d=f[a+20>>2]|0;if(!d)i=g;else{h=a+28|0;j=0;k=g;while(1){g=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;l=k+1|0;m=_i[f[(f[g>>2]|0)+60>>2]&1023](g)|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=l;s=m}b[r>>0]=s;o=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,r+1|0)|0;j=j+1|0;if((j|0)==(d|0)){i=o;break}else k=o}}k=f[a+36>>2]|0;if(!k)t=i;else{d=a+44|0;j=0;r=i;while(1){i=f[(f[d>>2]|0)+4+(j<<2)>>2]|0;b[r>>0]=26;s=r+1|0;h=_i[f[(f[i>>2]|0)+60>>2]&1023](i)|0;if(h>>>0>127){o=h;n=s;while(1){b[n>>0]=o|128;p=o>>>7;q=n+1|0;if(o>>>0>16383){o=p;n=q}else{u=q;v=p;break}}}else{u=s;v=h}b[u>>0]=v;n=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,u+1|0)|0;j=j+1|0;if((j|0)==(k|0)){t=n;break}else r=n}}r=f[a+52>>2]|0;if(!r)w=t;else{k=a+60|0;j=0;u=t;while(1){t=f[(f[k>>2]|0)+4+(j<<2)>>2]|0;b[u>>0]=34;v=u+1|0;d=_i[f[(f[t>>2]|0)+60>>2]&1023](t)|0;if(d>>>0>127){n=d;o=v;while(1){b[o>>0]=n|128;g=n>>>7;m=o+1|0;if(n>>>0>16383){n=g;o=m}else{x=m;y=g;break}}}else{x=v;y=d}b[x>>0]=y;o=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;j=j+1|0;if((j|0)==(r|0)){w=o;break}else u=o}}u=f[a+68>>2]|0;if(!u)z=w;else{r=a+76|0;j=0;x=w;while(1){w=f[(f[r>>2]|0)+4+(j<<2)>>2]|0;b[x>>0]=42;y=x+1|0;k=_i[f[(f[w>>2]|0)+60>>2]&1023](w)|0;if(k>>>0>127){o=k;n=y;while(1){b[n>>0]=o|128;i=o>>>7;h=n+1|0;if(o>>>0>16383){o=i;n=h}else{A=h;B=i;break}}}else{A=y;B=k}b[A>>0]=B;n=hj[f[(f[w>>2]|0)+64>>2]&511](w,c,A+1|0)|0;j=j+1|0;if((j|0)==(u|0)){z=n;break}else x=n}}x=f[a+84>>2]|0;if(!x)C=z;else{u=a+92|0;j=0;A=z;while(1){z=f[(f[u>>2]|0)+4+(j<<2)>>2]|0;b[A>>0]=50;B=A+1|0;r=_i[f[(f[z>>2]|0)+60>>2]&1023](z)|0;if(r>>>0>127){n=r;o=B;while(1){b[o>>0]=n|128;t=n>>>7;d=o+1|0;if(n>>>0>16383){n=t;o=d}else{D=d;E=t;break}}}else{D=B;E=r}b[D>>0]=E;o=hj[f[(f[z>>2]|0)+64>>2]&511](z,c,D+1|0)|0;j=j+1|0;if((j|0)==(x|0)){C=o;break}else A=o}}if(!(e&2))F=C;else{e=f[a+148>>2]|0;b[C>>0]=58;A=C+1|0;C=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(C>>>0>127){x=C;j=A;while(1){b[j>>0]=x|128;D=x>>>7;E=j+1|0;if(x>>>0>16383){x=D;j=E}else{G=E;H=D;break}}}else{G=A;H=C}b[G>>0]=H;F=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,G+1|0)|0}G=f[a+100>>2]|0;if(!G)I=F;else{e=a+108|0;H=0;C=F;while(1){F=f[(f[e>>2]|0)+4+(H<<2)>>2]|0;b[C>>0]=66;A=C+1|0;j=_i[f[(f[F>>2]|0)+60>>2]&1023](F)|0;if(j>>>0>127){x=j;D=A;while(1){b[D>>0]=x|128;E=x>>>7;u=D+1|0;if(x>>>0>16383){x=E;D=u}else{J=u;K=E;break}}}else{J=A;K=j}b[J>>0]=K;D=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,J+1|0)|0;H=H+1|0;if((H|0)==(G|0)){I=D;break}else C=D}}C=f[a+116>>2]|0;if(!C)L=I;else{G=a+124|0;H=0;J=I;while(1){I=f[(f[G>>2]|0)+4+(H<<2)>>2]|0;b[J>>0]=74;K=J+1|0;e=_i[f[(f[I>>2]|0)+60>>2]&1023](I)|0;if(e>>>0>127){D=e;x=K;while(1){b[x>>0]=D|128;z=D>>>7;r=x+1|0;if(D>>>0>16383){D=z;x=r}else{M=r;N=z;break}}}else{M=K;N=e}b[M>>0]=N;x=hj[f[(f[I>>2]|0)+64>>2]&511](I,c,M+1|0)|0;H=H+1|0;if((H|0)==(C|0)){L=x;break}else J=x}}J=f[a+132>>2]|0;if((J|0)>0){C=a+140|0;H=0;M=L;while(1){c=f[(f[C>>2]|0)+4+(H<<2)>>2]|0;b[M>>0]=82;N=dSb(c,M+1|0)|0;H=H+1|0;if((H|0)==(J|0)){O=N;break}else M=N}}else O=L;L=f[a+4>>2]|0;if(!(L&1)){P=O;return P|0}P=Hjc(L&-2,O)|0;return P|0}function l6b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function m6b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20720,0)|0;if(!c){Ehc(b,a);return}else{p6b(a,c);return}}function n6b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function o6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528856;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function p6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}q6b(a+16|0,b+16|0);r6b(a+32|0,b+32|0);s6b(a+48|0,b+48|0);t6b(a+64|0,b+64|0);q6b(a+80|0,b+80|0);u6b(a+96|0,b+96|0);v6b(a+112|0,b+112|0);yNa(a+128|0,b+128|0);d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0){g=f[b+144>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+144|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==527320){WJa(e,j,g);break}else{iEc(i,g)|0;break}}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+148|0;j=f[d>>2]|0;if(!j){w6b(a);k=f[d>>2]|0}else k=j;j=f[b+148>>2]|0;s2b(k,j|0?j:528152);return}function q6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{q7b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(56)|0;E5b(l);q7b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20688,56);l=MQb(i,56)|0;F5b(l,i);q7b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function r6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{o7b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(152)|0;n7b(l);o7b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20720,152);l=MQb(i,152)|0;p7b(l,i);o7b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function s6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{m7b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(72)|0;Q4b(l);m7b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20640,72);l=MQb(i,72)|0;R4b(l,i);m7b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function t6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{T6b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(28)|0;S6b(l);T6b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20752,32);l=MQb(i,32)|0;U6b(l,i);T6b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function u6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{R6b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(24)|0;j5b(l);R6b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20672,24);l=MQb(i,24)|0;k5b(l,i);R6b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function v6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{y6b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(24)|0;x6b(l);y6b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20736,24);l=MQb(i,24)|0;z6b(l,i);y6b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function w6b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(52)|0;t2b(c);e=c;g=a+148|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20560,56);c=MQb(d,56)|0;u2b(c,d);e=c;g=a+148|0;f[g>>2]=e;return}function x6b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=166132;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=527544?(f[220841]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=140;b[d+8>>0]=0;DTb(883364,d);ZSb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function y6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=b+4|0;d=f[a+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[a+8>>2]|0;if(!(d&3))return;if(d&1|0)f[b+16>>2]=f[a+16>>2];if(d&2|0)f[b+20>>2]=f[a+20>>2];a=b+8|0;f[a>>2]=f[a>>2]|d;return}function z6b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=166132;f[a+4>>2]=c;f[a+8>>2]=0;if((f[220841]|0)!=2){f[e>>2]=161028;f[e+4>>2]=140;b[e+8>>0]=0;DTb(883364,e);ZSb(e)}f[a+12>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function A6b(a){a=a|0;var b=0,c=0;f[a>>2]=166132;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function B6b(a){a=a|0;var b=0,c=0;f[a>>2]=166132;b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function C6b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function D6b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(24)|0;x6b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20736,24);a=MQb(b,24)|0;z6b(a,b);c=a;return c|0}function E6b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function F6b(a){a=a|0;return f[a+4>>2]|0}function G6b(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&3|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function H6b(a){a=a|0;return 1}function I6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=WRb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=HRb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=24;break a}}f[g>>2]=p;continue a;break}case 2:{if((l&255|0)!=16){o=l;break b}f[e>>2]=f[e>>2]|2;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;s=a}else{t=a;m=17}}else{t=0;m=17}if((m|0)==17){m=0;a=HRb(c,t)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)s=a;else{r=0;m=24;break a}}f[h>>2]=s;continue a;break}default:{o=l;break b}}}while(0);if(!o){r=1;m=24;break}a=f[i>>2]|0;if(!(a&1))u=mNa(i)|0;else u=a&-2;if(!(Djc(c,o,u)|0)){r=0;m=24;break}}if((m|0)==24)return r|0;return 0}function J6b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function K6b(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)MTb(1,f[a+16>>2]|0,b);if(c&2|0)MTb(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function L6b(a){a=a|0;return f[a+12>>2]|0}function M6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=f[a+20>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=aJc(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Hjc(r&-2,q)|0;return t|0}function N6b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function O6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,20736,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function P6b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Q6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528848;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function R6b(a,b){a=a|0;b=b|0;h5b(b,a);return}function S6b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=166240;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=527512?(f[220840]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=139;b[d+8>>0]=0;DTb(883360,d);ZSb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function T6b(a,b){a=a|0;b=b|0;k7b(b,a);return}function U6b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=166240;f[a+4>>2]=c;f[a+8>>2]=0;if((f[220840]|0)!=2){f[e>>2]=161028;f[e+4>>2]=139;b[e+8>>0]=0;DTb(883360,e);ZSb(e)}e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;u=d;return}function V6b(a){a=a|0;var b=0,c=0;f[a>>2]=166240;if((a|0)!=527512?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function W6b(a){a=a|0;V6b(a);YDc(a);return}function X6b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Y6b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(28)|0;S6b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20752,32);a=MQb(b,32)|0;U6b(a,b);c=a;return c|0}function Z6b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function _6b(a){a=a|0;return f[a+4>>2]|0}function $6b(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;c=f[b>>2]|0;if(c&1|0){d=f[a+16>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}if(c&6|0){c=a+20|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function a7b(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&1|0?(b=f[a+16>>2]|0,!(_i[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function b7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+24|0;k=a+16|0;l=e+4|0;m=a+4|0;a:while(1){n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=n+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=WRb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=8){t=q;break b}f[h>>2]=f[h>>2]|2;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){n=b[p>>0]|0;o=n&255;if(n<<24>>24>-1){f[c>>2]=p+1;v=o}else{w=o;r=11}}else{w=0;r=11}if((r|0)==11){r=0;o=HRb(c,w)|0;p=J;if((p|0)>-1|(p|0)==-1&o>>>0>4294967295)v=o;else{x=0;r=35;break a}}f[i>>2]=v;continue a;break}case 2:{if((q&255|0)!=16){t=q;break b}f[h>>2]=f[h>>2]|4;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){p=b[o>>0]|0;n=p&255;if(p<<24>>24>-1){f[c>>2]=o+1;y=n}else{z=n;r=17}}else{z=0;r=17}if((r|0)==17){r=0;n=HRb(c,z)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)y=n;else{x=0;r=35;break a}}f[j>>2]=y;continue a;break}case 3:{if((q&255|0)!=26){t=q;break b}f[h>>2]=f[h>>2]|1;n=f[k>>2]|0;if(!n){l7b(a);A=f[k>>2]|0}else A=n;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;B=o&255}else{o=VRb(c)|0;if((o|0)>-1)B=o;else{x=0;r=35;break a}}GRb(e,c,B);if((f[l>>2]|0)<0){r=28;break a}if(!(Mi[f[(f[A>>2]|0)+44>>2]&1023](A,c)|0)){r=28;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{x=0;r=35;break a}break}default:{t=q;break b}}}while(0);if(!t){x=1;r=35;break}o=f[m>>2]|0;if(!(o&1))C=mNa(m)|0;else C=o&-2;if(!(Djc(c,t,C)|0)){x=0;r=35;break}}if((r|0)==28){x=0;u=d;return x|0}else if((r|0)==35){u=d;return x|0}return 0}function c7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&7)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&1023](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2))k=h;else{b=f[a+20>>2]|0;if((b|0)<0)l=11;else l=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=l+h|0}if(!(i&4)){e=k;g=a+12|0;f[g>>2]=e;return e|0}i=f[a+24>>2]|0;if((i|0)<0)m=11;else m=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=m+k|0;g=a+12|0;f[g>>2]=e;return e|0}function d7b(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)MTb(1,f[a+20>>2]|0,b);if(c&4|0)MTb(2,f[a+24>>2]|0,b);if(c&1|0)eUb(3,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function e7b(a){a=a|0;return f[a+12>>2]|0}function f7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=f[a+20>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=aJc(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&4))r=g;else{p=f[a+24>>2]|0;b[g>>0]=16;q=g+1|0;g=p&255;if(p>>>0>127){d=q;i=g;m=p;k=((p|0)<0)<<31>>31;while(1){b[d>>0]=i|-128;p=m;m=aJc(m|0,k|0,7)|0;j=d+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=j;t=l;break}else{d=j;i=l;k=J}}}else{s=q;t=g}b[s>>0]=t;r=s+1|0}if(!(e&1))u=r;else{e=f[a+16>>2]|0;b[r>>0]=26;s=r+1|0;r=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(r>>>0>127){t=r;g=s;while(1){b[g>>0]=t|128;q=t>>>7;k=g+1|0;if(t>>>0>16383){t=q;g=k}else{v=k;w=q;break}}}else{v=s;w=r}b[v>>0]=w;u=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,v+1|0)|0}v=f[a+4>>2]|0;if(!(v&1)){x=u;return x|0}x=Hjc(v&-2,u)|0;return x|0}function g7b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function h7b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20752,0)|0;if(!c){Ehc(b,a);return}else{k7b(a,c);return}}function i7b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function j7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528840;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function k7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;e=f[g>>2]|0;if(!e){l7b(a);h=f[g>>2]|0}else h=e;e=f[b+16>>2]|0;g=e|0?e:527720;Dlc(h+4|0,g+4|0);e=h+20|0;c=f[g+20>>2]|0;if(c&1|0){i=f[e>>2]|0;if(!(i&1))j=mNa(e)|0;else j=i&-2;ojc(j,c&-2)}h0b(h+32|0,g+32|0)}if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function l7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(48)|0;Y5b(c);e=c;g=a+16|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20704,48);c=MQb(d,48)|0;Z5b(c,d);e=c;g=a+16|0;f[g>>2]=e;return}function m7b(a,b){a=a|0;b=b|0;r4b(b,a);return}function n7b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=166024;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==527568;g=a+16|0;h=g+128|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220842]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=141;b[d+8>>0]=0;DTb(883368,d);ZSb(d)}f[a+12>>2]=0;f[a+144>>2]=527320;f[a+148>>2]=0;u=c;return}function o7b(a,b){a=a|0;b=b|0;p6b(b,a);return}function p7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[a>>2]=166024;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=c;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=c;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=c;f[a+84>>2]=0;f[a+88>>2]=0;f[a+92>>2]=0;f[a+96>>2]=c;f[a+100>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=c;f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=c;f[a+132>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;if((f[220842]|0)==2){g=a+12|0;f[g>>2]=0;h=a+144|0;f[h>>2]=527320;i=a+148|0;f[i>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=141;b[e+8>>0]=0;DTb(883368,e);ZSb(e);g=a+12|0;f[g>>2]=0;h=a+144|0;f[h>>2]=527320;i=a+148|0;f[i>>2]=0;u=d;return}function q7b(a,b){a=a|0;b=b|0;C5b(b,a);return}function r7b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[a>>2]=166348;P7b(a);c=f[a+116>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+104>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+92|0;d=f[c>>2]|0;if(d|0?(f[a+80>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+76|0;i=f[c>>2]|0;if(i|0?(f[a+64>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=a+60|0;j=f[c>>2]|0;if(j|0?(f[a+48>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+44|0;k=f[c>>2]|0;if(k|0?(f[a+32>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;YDc(l)}f[c>>2]=0;c=a+28|0;l=f[c>>2]|0;if(l|0?(f[a+16>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;YDc(m)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}m=a&-2;a=m;if((m|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(m);f[c>>2]=0;return}function s7b(a){a=a|0;r7b(a);YDc(a);return}function t7b(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function u7b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(140)|0;N7b(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,20768,144);a=MQb(b,144)|0;O7b(a,b);c=a;return c|0}function v7b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function w7b(a){a=a|0;return f[a+4>>2]|0}function x7b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{i=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((g|0)!=(d|0));f[c>>2]=0}c=a+68|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+76>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((e|0)!=(d|0));f[c>>2]=0}c=a+84|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+92>>2]|0;g=0;do{i=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((g|0)!=(d|0));f[c>>2]=0}f[a+96>>2]=0;f[a+108>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&31|0){do if(d&1|0?(g=f[a+120>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0?(e=f[a+124>>2]|0,(e|0)!=527320):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0?(g=f[a+128>>2]|0,(g|0)!=527320):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&8|0){e=f[a+132>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}if(d&16|0){d=f[a+136>>2]|0;Yi[f[(f[d>>2]|0)+28>>2]&2047](d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function y7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=16;break}}if((g|0)==16)return e|0;c=a+60|0;b=f[a+52>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=16;break}}if((g|0)==16)return e|0;b=a+76|0;c=f[a+68>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=16;break}}if((g|0)==16)return e|0;c=a+92|0;b=f[a+84>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(_i[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=16;break}}if((g|0)==16)return e|0;if(f[a+8>>2]&8|0?(g=f[a+132>>2]|0,!(_i[f[(f[g>>2]|0)+32>>2]&1023](g)|0)):0){e=0;return e|0}e=1;return e|0}function z7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+120|0;j=a+4|0;k=a+124|0;l=a+16|0;m=a+32|0;n=e+4|0;o=a+48|0;p=e+4|0;q=a+64|0;r=a+76|0;s=a+72|0;t=a+68|0;v=e+4|0;w=a+80|0;x=e+4|0;y=a+132|0;z=e+4|0;A=a+136|0;B=e+4|0;C=a+96|0;D=a+100|0;E=a+104|0;F=a+108|0;G=a+112|0;H=a+116|0;I=a+128|0;a:while(1){K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0){L=b[K>>0]|0;M=L&255;if(L<<24>>24>0){f[c>>2]=K+1;N=M;O=6}else{P=M;O=5}}else{P=0;O=5}if((O|0)==5){O=0;M=WRb(c,P)|0;if((M+-1|0)>>>0<127){N=M;O=6}else Q=M}b:do if((O|0)==6){O=0;do switch(N>>>3&536870911|0){case 1:{if((N&255|0)!=10){Q=N;break b}f[h>>2]=f[h>>2]|1;M=f[j>>2]|0;K=M&-2;if(!(M&1))R=K;else R=f[K+4>>2]|0;K=f[i>>2]|0;if((K|0)==527320){WJa(i,R,527320);S=f[i>>2]|0}else S=K;if(fUb(c,S)|0)continue a;else{T=0;O=139;break a}break}case 2:{if((N&255|0)!=18){Q=N;break b}f[h>>2]=f[h>>2]|2;K=f[j>>2]|0;M=K&-2;if(!(K&1))U=M;else U=f[M+4>>2]|0;M=f[k>>2]|0;if((M|0)==527320){WJa(k,U,527320);V=f[k>>2]|0}else V=M;if(fUb(c,V)|0)continue a;else{T=0;O=139;break a}break}case 3:{if((N&255|0)!=26){Q=N;break b}if(fUb(c,JLa(l)|0)|0)continue a;else{T=0;O=139;break a}break}case 4:{if((N&255|0)!=34){Q=N;break b}M=TXb(m)|0;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(L=b[K>>0]|0,L<<24>>24>-1):0){f[c>>2]=K+1;W=L&255}else{L=VRb(c)|0;if((L|0)>-1)W=L;else{T=0;O=139;break a}}GRb(e,c,W);if((f[n>>2]|0)<0){O=30;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){O=30;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 5:{if((N&255|0)!=42){Q=N;break b}M=VXb(o)|0;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;X=K&255}else{K=VRb(c)|0;if((K|0)>-1)X=K;else{T=0;O=139;break a}}GRb(e,c,X);if((f[p>>2]|0)<0){O=39;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){O=39;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 6:{if((N&255|0)!=50){Q=N;break b}M=f[r>>2]|0;do if(M){K=f[t>>2]|0;L=f[M>>2]|0;if((K|0)>=(L|0))if((L|0)==(f[s>>2]|0)){Y=L;O=47;break}else{Z=L;_=M;O=48;break}else{f[t>>2]=K+1;$=f[M+4+(K<<2)>>2]|0;break}}else{Y=f[s>>2]|0;O=47}while(0);if((O|0)==47){O=0;USb(q,Y+1|0);M=f[r>>2]|0;Z=f[M>>2]|0;_=M;O=48}if((O|0)==48){O=0;f[_>>2]=Z+1;M=f[q>>2]|0;if(!M){K=VDc(40)|0;F3b(K);aa=K}else{if(f[M+64>>2]|0)OQb(M,20608,40);K=MQb(M,40)|0;G3b(K,M);aa=K}K=f[r>>2]|0;M=f[t>>2]|0;f[t>>2]=M+1;f[K+4+(M<<2)>>2]=aa;$=aa}M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(K=b[M>>0]|0,K<<24>>24>-1):0){f[c>>2]=M+1;ba=K&255}else{K=VRb(c)|0;if((K|0)>-1)ba=K;else{T=0;O=139;break a}}GRb(e,c,ba);if((f[v>>2]|0)<0){O=60;break a}if(!(Mi[f[(f[$>>2]|0)+44>>2]&1023]($,c)|0)){O=60;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 7:{if((N&255|0)!=58){Q=N;break b}K=YXb(w)|0;M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(L=b[M>>0]|0,L<<24>>24>-1):0){f[c>>2]=M+1;ca=L&255}else{L=VRb(c)|0;if((L|0)>-1)ca=L;else{T=0;O=139;break a}}GRb(e,c,ca);if((f[x>>2]|0)<0){O=69;break a}if(!(Mi[f[(f[K>>2]|0)+44>>2]&1023](K,c)|0)){O=69;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 8:{if((N&255|0)!=66){Q=N;break b}f[h>>2]=f[h>>2]|8;K=f[y>>2]|0;if(!K){K7b(a);da=f[y>>2]|0}else da=K;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(L=b[K>>0]|0,L<<24>>24>-1):0){f[c>>2]=K+1;ea=L&255}else{L=VRb(c)|0;if((L|0)>-1)ea=L;else{T=0;O=139;break a}}GRb(e,c,ea);if((f[z>>2]|0)<0){O=80;break a}if(!(Mi[f[(f[da>>2]|0)+44>>2]&1023](da,c)|0)){O=80;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 9:{if((N&255|0)!=74){Q=N;break b}f[h>>2]=f[h>>2]|16;L=f[A>>2]|0;if(!L){L7b(a);fa=f[A>>2]|0}else fa=L;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;ga=K&255}else{K=VRb(c)|0;if((K|0)>-1)ga=K;else{T=0;O=139;break a}}GRb(e,c,ga);if((f[B>>2]|0)<0){O=91;break a}if(!(Mi[f[(f[fa>>2]|0)+44>>2]&1023](fa,c)|0)){O=91;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 10:{switch((N&255)<<24>>24){case 80:break;case 82:{if(Afb(c,C)|0)continue a;else{T=0;O=139;break a}break}default:{Q=N;break b}}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0){L=b[K>>0]|0;M=L&255;if(L<<24>>24>-1){f[c>>2]=K+1;ha=M}else{ia=M;O=97}}else{ia=0;O=97}if((O|0)==97){O=0;M=HRb(c,ia)|0;K=J;if((K|0)>-1|(K|0)==-1&M>>>0>4294967295)ha=M;else{T=0;O=139;break a}}M=f[C>>2]|0;if((M|0)==(f[D>>2]|0)){KLa(C,M+1|0);ja=f[C>>2]|0}else ja=M;M=f[E>>2]|0;f[C>>2]=ja+1;f[M+4+(ja<<2)>>2]=ha;K=(f[D>>2]|0)-(f[C>>2]|0)|0;if((K|0)>0){ka=K;la=M}else continue a;while(1){M=f[c>>2]|0;K=f[g>>2]|0;if(M>>>0>=K>>>0)continue a;if((b[M>>0]|0)!=80)continue a;L=M+1|0;f[c>>2]=L;if(L>>>0<K>>>0){K=b[L>>0]|0;L=K&255;if(K<<24>>24>-1){f[c>>2]=M+2;ma=L;na=la}else{oa=L;O=105}}else{oa=0;O=105}if((O|0)==105){O=0;L=HRb(c,oa)|0;M=J;if(!((M|0)>-1|(M|0)==-1&L>>>0>4294967295)){T=0;O=139;break a}ma=L;na=f[E>>2]|0}L=f[C>>2]|0;f[C>>2]=L+1;f[na+4+(L<<2)>>2]=ma;if((ka|0)>1){ka=ka+-1|0;la=na}else continue a}break}case 11:{switch((N&255)<<24>>24){case 88:break;case 90:{if(Afb(c,F)|0)continue a;else{T=0;O=139;break a}break}default:{Q=N;break b}}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){M=b[L>>0]|0;K=M&255;if(M<<24>>24>-1){f[c>>2]=L+1;pa=K}else{qa=K;O=114}}else{qa=0;O=114}if((O|0)==114){O=0;K=HRb(c,qa)|0;L=J;if((L|0)>-1|(L|0)==-1&K>>>0>4294967295)pa=K;else{T=0;O=139;break a}}K=f[F>>2]|0;if((K|0)==(f[G>>2]|0)){KLa(F,K+1|0);ra=f[F>>2]|0}else ra=K;K=f[H>>2]|0;f[F>>2]=ra+1;f[K+4+(ra<<2)>>2]=pa;L=(f[G>>2]|0)-(f[F>>2]|0)|0;if((L|0)>0){sa=L;ta=K}else continue a;while(1){K=f[c>>2]|0;L=f[g>>2]|0;if(K>>>0>=L>>>0)continue a;if((b[K>>0]|0)!=88)continue a;M=K+1|0;f[c>>2]=M;if(M>>>0<L>>>0){L=b[M>>0]|0;M=L&255;if(L<<24>>24>-1){f[c>>2]=K+2;ua=M;va=ta}else{wa=M;O=122}}else{wa=0;O=122}if((O|0)==122){O=0;M=HRb(c,wa)|0;K=J;if(!((K|0)>-1|(K|0)==-1&M>>>0>4294967295)){T=0;O=139;break a}ua=M;va=f[H>>2]|0}M=f[F>>2]|0;f[F>>2]=M+1;f[va+4+(M<<2)>>2]=ua;if((sa|0)>1){sa=sa+-1|0;ta=va}else continue a}break}case 12:{if((N&255|0)!=98){Q=N;break b}f[h>>2]=f[h>>2]|4;M=f[j>>2]|0;K=M&-2;if(!(M&1))xa=K;else xa=f[K+4>>2]|0;K=f[I>>2]|0;if((K|0)==527320){WJa(I,xa,527320);ya=f[I>>2]|0}else ya=K;if(fUb(c,ya)|0)continue a;else{T=0;O=139;break a}break}default:{Q=N;break b}}while(0)}while(0);if(!Q){T=1;O=139;break}K=f[j>>2]|0;if(!(K&1))za=mNa(j)|0;else za=K&-2;if(!(Djc(c,Q,za)|0)){T=0;O=139;break}}if((O|0)==30){T=0;u=d;return T|0}else if((O|0)==39){T=0;u=d;return T|0}else if((O|0)==60){T=0;u=d;return T|0}else if((O|0)==69){T=0;u=d;return T|0}else if((O|0)==80){T=0;u=d;return T|0}else if((O|0)==91){T=0;u=d;return T|0}else if((O|0)==139){u=d;return T|0}return 0}function A7b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Jjc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if(!e)m=h;else{l=a+44|0;c=0;g=h;while(1){h=f[(f[l>>2]|0)+4+(c<<2)>>2]|0;d=_i[f[(f[h>>2]|0)+48>>2]&1023](h)|0;h=d+g+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=h;break}else g=h}}g=f[a+52>>2]|0;e=g+m|0;if(!g)n=e;else{m=a+60|0;c=0;l=e;while(1){e=f[(f[m>>2]|0)+4+(c<<2)>>2]|0;h=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=h+l+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(g|0)){n=e;break}else l=e}}l=f[a+68>>2]|0;g=l+n|0;if(!l)o=g;else{n=a+76|0;c=0;m=g;while(1){g=f[(f[n>>2]|0)+4+(c<<2)>>2]|0;e=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;g=e+m+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(l|0)){o=g;break}else m=g}}m=f[a+84>>2]|0;l=m+o|0;if(!m)p=l;else{o=a+92|0;c=0;n=l;while(1){l=f[(f[o>>2]|0)+4+(c<<2)>>2]|0;g=_i[f[(f[l>>2]|0)+48>>2]&1023](l)|0;l=g+n+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(m|0)){p=l;break}else n=l}}n=hUb(a+96|0)|0;m=f[a+96>>2]|0;c=hUb(a+108|0)|0;o=n+p+m+c+(f[a+108>>2]|0)|0;c=a+8|0;m=f[c>>2]|0;if(!(m&31)){q=o;r=a+12|0;f[r>>2]=q;return q|0}if(!(m&1))s=o;else{p=f[a+120>>2]|0;n=b[p+11>>0]|0;l=n<<24>>24<0?f[p+4>>2]|0:n&255;s=o+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(m&2))t=s;else{l=f[a+124>>2]|0;o=b[l+11>>0]|0;n=o<<24>>24<0?f[l+4>>2]|0:o&255;t=s+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(m&4))u=t;else{n=f[a+128>>2]|0;s=b[n+11>>0]|0;o=s<<24>>24<0?f[n+4>>2]|0:s&255;u=t+1+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(m&8)){v=u;w=m}else{m=f[a+132>>2]|0;o=_i[f[(f[m>>2]|0)+48>>2]&1023](m)|0;m=u+1+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0;v=m;w=f[c>>2]|0}if(!(w&16)){q=v;r=a+12|0;f[r>>2]=q;return q|0}w=f[a+136>>2]|0;c=_i[f[(f[w>>2]|0)+48>>2]&1023](w)|0;q=v+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=a+12|0;f[r>>2]=q;return q|0}function B7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)$Tb(1,f[a+120>>2]|0,b);if(c&2|0)$Tb(2,f[a+124>>2]|0,b);d=f[a+20>>2]|0;if((d|0)>0){e=a+28|0;g=0;do{_Tb(3,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+36>>2]|0;if(d|0){g=a+44|0;e=0;do{eUb(4,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+52>>2]|0;if(d|0){e=a+60|0;g=0;do{eUb(5,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+68>>2]|0;if(d|0){g=a+76|0;e=0;do{eUb(6,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+84>>2]|0;if(d|0){e=a+92|0;g=0;do{eUb(7,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&8|0)eUb(8,f[a+132>>2]|0,b);if(c&16|0)eUb(9,f[a+136>>2]|0,b);d=f[a+96>>2]|0;if((d|0)>0){g=a+104|0;e=0;do{MTb(10,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+108>>2]|0;if((d|0)>0){e=a+116|0;g=0;do{MTb(11,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&4|0)$Tb(12,f[a+128>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Gjc(c&-2,b);return}function C7b(a){a=a|0;return f[a+12>>2]|0}function D7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+120>>2]|0;b[d>>0]=10;g=dSb(h,d+1|0)|0}if(!(e&2))i=g;else{d=f[a+124>>2]|0;b[g>>0]=18;i=dSb(d,g+1|0)|0}g=f[a+20>>2]|0;if((g|0)>0){d=a+28|0;h=0;j=i;while(1){k=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;b[j>>0]=26;l=dSb(k,j+1|0)|0;h=h+1|0;if((h|0)==(g|0)){m=l;break}else j=l}}else m=i;i=f[a+36>>2]|0;if(!i)n=m;else{j=a+44|0;g=0;h=m;while(1){m=f[(f[j>>2]|0)+4+(g<<2)>>2]|0;b[h>>0]=34;d=h+1|0;l=_i[f[(f[m>>2]|0)+60>>2]&1023](m)|0;if(l>>>0>127){k=l;o=d;while(1){b[o>>0]=k|128;p=k>>>7;q=o+1|0;if(k>>>0>16383){k=p;o=q}else{r=q;s=p;break}}}else{r=d;s=l}b[r>>0]=s;o=hj[f[(f[m>>2]|0)+64>>2]&511](m,c,r+1|0)|0;g=g+1|0;if((g|0)==(i|0)){n=o;break}else h=o}}h=f[a+52>>2]|0;if(!h)t=n;else{i=a+60|0;g=0;r=n;while(1){n=f[(f[i>>2]|0)+4+(g<<2)>>2]|0;b[r>>0]=42;s=r+1|0;j=_i[f[(f[n>>2]|0)+60>>2]&1023](n)|0;if(j>>>0>127){o=j;k=s;while(1){b[k>>0]=o|128;p=o>>>7;q=k+1|0;if(o>>>0>16383){o=p;k=q}else{u=q;v=p;break}}}else{u=s;v=j}b[u>>0]=v;k=hj[f[(f[n>>2]|0)+64>>2]&511](n,c,u+1|0)|0;g=g+1|0;if((g|0)==(h|0)){t=k;break}else r=k}}r=f[a+68>>2]|0;if(!r)w=t;else{h=a+76|0;g=0;u=t;while(1){t=f[(f[h>>2]|0)+4+(g<<2)>>2]|0;b[u>>0]=50;v=u+1|0;i=_i[f[(f[t>>2]|0)+60>>2]&1023](t)|0;if(i>>>0>127){k=i;o=v;while(1){b[o>>0]=k|128;m=k>>>7;l=o+1|0;if(k>>>0>16383){k=m;o=l}else{x=l;y=m;break}}}else{x=v;y=i}b[x>>0]=y;o=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;g=g+1|0;if((g|0)==(r|0)){w=o;break}else u=o}}u=f[a+84>>2]|0;if(!u)z=w;else{r=a+92|0;g=0;x=w;while(1){w=f[(f[r>>2]|0)+4+(g<<2)>>2]|0;b[x>>0]=58;y=x+1|0;h=_i[f[(f[w>>2]|0)+60>>2]&1023](w)|0;if(h>>>0>127){o=h;k=y;while(1){b[k>>0]=o|128;n=o>>>7;j=k+1|0;if(o>>>0>16383){o=n;k=j}else{A=j;B=n;break}}}else{A=y;B=h}b[A>>0]=B;k=hj[f[(f[w>>2]|0)+64>>2]&511](w,c,A+1|0)|0;g=g+1|0;if((g|0)==(u|0)){z=k;break}else x=k}}if(!(e&8))C=z;else{x=f[a+132>>2]|0;b[z>>0]=66;u=z+1|0;z=_i[f[(f[x>>2]|0)+60>>2]&1023](x)|0;if(z>>>0>127){g=z;A=u;while(1){b[A>>0]=g|128;B=g>>>7;r=A+1|0;if(g>>>0>16383){g=B;A=r}else{D=r;E=B;break}}}else{D=u;E=z}b[D>>0]=E;C=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,D+1|0)|0}if(!(e&16))F=C;else{D=f[a+136>>2]|0;b[C>>0]=74;x=C+1|0;C=_i[f[(f[D>>2]|0)+60>>2]&1023](D)|0;if(C>>>0>127){E=C;z=x;while(1){b[z>>0]=E|128;u=E>>>7;A=z+1|0;if(E>>>0>16383){E=u;z=A}else{G=A;H=u;break}}}else{G=x;H=C}b[G>>0]=H;F=hj[f[(f[D>>2]|0)+64>>2]&511](D,c,G+1|0)|0}G=f[a+96>>2]|0;if(!G)I=F;else{c=f[a+104>>2]|0;D=0;H=F;while(1){F=f[c+4+(D<<2)>>2]|0;b[H>>0]=80;C=H+1|0;x=F&255;if(F>>>0>127){z=C;E=x;u=F;A=((F|0)<0)<<31>>31;while(1){b[z>>0]=E|-128;F=u;u=aJc(u|0,A|0,7)|0;g=z+1|0;B=u&255;if(!(A>>>0>0|(A|0)==0&F>>>0>16383)){K=g;L=z;M=B;break}else{z=g;E=B;A=J}}}else{K=C;L=H;M=x}b[K>>0]=M;A=L+2|0;D=D+1|0;if((D|0)>=(G|0)){I=A;break}else H=A}}H=f[a+108>>2]|0;if(!H)N=I;else{G=f[a+116>>2]|0;D=0;L=I;while(1){I=f[G+4+(D<<2)>>2]|0;b[L>>0]=88;M=L+1|0;K=I&255;if(I>>>0>127){c=M;A=K;E=I;z=((I|0)<0)<<31>>31;while(1){b[c>>0]=A|-128;I=E;E=aJc(E|0,z|0,7)|0;u=c+1|0;w=E&255;if(!(z>>>0>0|(z|0)==0&I>>>0>16383)){O=u;P=c;Q=w;break}else{c=u;A=w;z=J}}}else{O=M;P=L;Q=K}b[O>>0]=Q;z=P+2|0;D=D+1|0;if((D|0)>=(H|0)){N=z;break}else L=z}}if(!(e&4))R=N;else{e=f[a+128>>2]|0;b[N>>0]=98;R=dSb(e,N+1|0)|0}N=f[a+4>>2]|0;if(!(N&1)){S=R;return S|0}S=Hjc(N&-2,R)|0;return S|0}function E7b(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function F7b(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,20768,0)|0;if(!c){Ehc(b,a);return}else{I7b(a,c);return}}function G7b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function H7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220836]|0)!=2){f[d>>2]=161028;f[d+4>>2]=135;b[d+8>>0]=0;DTb(883344,d);ZSb(d)}d=528832;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function I7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}yNa(a+16|0,b+16|0);r6b(a+32|0,b+32|0);s6b(a+48|0,b+48|0);J7b(a+64|0,b+64|0);q6b(a+80|0,b+80|0);d=a+96|0;g=b+96|0;e=f[g>>2]|0;if(e|0){KLa(d,(f[d>>2]|0)+e|0);dJc((f[a+104>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+104>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+108|0;d=b+108|0;e=f[d>>2]|0;if(e|0){KLa(g,(f[g>>2]|0)+e|0);dJc((f[a+116>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+116>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=f[b+8>>2]|0;if(!(d&31))return;do if(d&1|0){g=f[b+120>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+120|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==527320){WJa(e,j,g);break}else{iEc(i,g)|0;break}}while(0);do if(d&2|0){j=f[b+124>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+124|0;i=f[c>>2]|0;e=i&-2;if(!(i&1))k=e;else k=f[e+4>>2]|0;e=f[g>>2]|0;if((e|0)==527320){WJa(g,k,j);break}else{iEc(e,j)|0;break}}while(0);do if(d&4|0){k=f[b+128>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|4;j=a+128|0;e=f[c>>2]|0;g=e&-2;if(!(e&1))l=g;else l=f[g+4>>2]|0;g=f[j>>2]|0;if((g|0)==527320){WJa(j,l,k);break}else{iEc(g,k)|0;break}}while(0);if(d&8|0){l=a+8|0;f[l>>2]=f[l>>2]|8;l=a+132|0;c=f[l>>2]|0;if(!c){K7b(a);m=f[l>>2]|0}else m=c;c=f[b+132>>2]|0;M2b(m,c|0?c:528056)}if(!(d&16))return;d=a+8|0;f[d>>2]=f[d>>2]|16;d=a+136|0;c=f[d>>2]|0;if(!c){L7b(a);n=f[d>>2]|0}else n=c;c=f[b+136>>2]|0;b=c|0?c:528712;c=n+4|0;d=f[b+4>>2]|0;if(d&1|0){a=f[c>>2]|0;if(!(a&1))o=mNa(c)|0;else o=a&-2;ojc(o,d&-2)}E_b(n+16|0,b+16|0);return}function J7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{M7b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(40)|0;F3b(l);M7b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20608,40);l=MQb(i,40)|0;G3b(l,i);M7b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function K7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(96)|0;N2b(c);e=c;g=a+132|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20576,96);c=MQb(d,96)|0;O2b(c,d);e=c;g=a+132|0;f[g>>2]=e;return}function L7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(32)|0;__b(c);e=c;g=a+136|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,20400,32);c=MQb(d,32)|0;$_b(c,d);e=c;g=a+136|0;f[g>>2]=e;return}function M7b(a,b){a=a|0;b=b|0;B3b(b,a);return}function N7b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=166348;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==527368;g=a+16|0;h=g+104|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[220839]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=138;b[d+8>>0]=0;DTb(883356,d);ZSb(d)}f[a+12>>2]=0;f[a+120>>2]=527320;f[a+124>>2]=527320;f[a+128>>2]=527320;d=a+132|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function O7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[a>>2]=166348;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=c;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=c;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=c;g=a+84|0;h=a+104|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;if(!c){f[a+108>>2]=0;f[a+112>>2]=0;f[a+116>>2]=0}else{if(f[c+64>>2]|0)OQb(c,23816,8);g=MQb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+108>>2]=0;f[a+112>>2]=0;g=a+116|0;f[g>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c}if((f[220839]|0)==2){i=a+12|0;f[i>>2]=0;j=a+120|0;f[j>>2]=527320;k=a+124|0;f[k>>2]=527320;l=a+128|0;f[l>>2]=527320;m=a+132|0;n=m;o=n;f[o>>2]=0;p=n+4|0;q=p;f[q>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=138;b[e+8>>0]=0;DTb(883356,e);ZSb(e);i=a+12|0;f[i>>2]=0;j=a+120|0;f[j>>2]=527320;k=a+124|0;f[k>>2]=527320;l=a+128|0;f[l>>2]=527320;m=a+132|0;n=m;o=n;f[o>>2]=0;p=n+4|0;q=p;f[q>>2]=0;u=d;return}function P7b(a){a=a|0;var c=0;c=f[a+120>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+124>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+128>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)==527368)return;c=f[a+132>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+136>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function Q7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{R7b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(140)|0;N7b(l);R7b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,20768,144);l=MQb(i,144)|0;O7b(l,i);R7b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function R7b(a,b){a=a|0;b=b|0;I7b(b,a);return}function S7b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=163108;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=527336?(f[220838]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=137;b[d+8>>0]=0;DTb(883352,d);ZSb(d)}f[a+12>>2]=0;u=c;return}function T7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=163108;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[220838]|0)==2){g=a+12|0;f[g>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=137;b[e+8>>0]=0;DTb(883352,e);ZSb(e);g=a+12|0;f[g>>2]=0;u=d;return}function U7b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220837]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=136;b[c+8>>0]=0;DTb(883348,c);ZSb(c);u=a;return}function V7b(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[220836]|0)==2){d=f[220834]|0;u=a;return d|0}f[c>>2]=161028;f[c+4>>2]=135;b[c+8>>0]=0;DTb(883344,c);ZSb(c);d=f[220834]|0;u=a;return d|0}function W7b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220843]|0)==2){u=a;return 527720}f[c>>2]=161028;f[c+4>>2]=142;b[c+8>>0]=0;DTb(883372,c);ZSb(c);u=a;return 527720}function X7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);Dlc(a+4|0,b+4|0);c=a+20|0;d=f[b+20>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}h0b(a+32|0,b+32|0);return}function Y7b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220851]|0)==2){u=a;return 528056}f[c>>2]=161028;f[c+4>>2]=150;b[c+8>>0]=0;DTb(883404,c);ZSb(c);u=a;return 528056}function Z7b(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);M2b(a,b);return}function _7b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220852]|0)==2){u=a;return 528152}f[c>>2]=161028;f[c+4>>2]=151;b[c+8>>0]=0;DTb(883408,c);ZSb(c);u=a;return 528152}function $7b(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);s2b(a,b);return}function a8b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220853]|0)==2){u=a;return 528208}f[c>>2]=161028;f[c+4>>2]=152;b[c+8>>0]=0;DTb(883412,c);ZSb(c);u=a;return 528208}function b8b(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);_1b(a,b);return}function c8b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220854]|0)==2){u=a;return 528272}f[c>>2]=161028;f[c+4>>2]=153;b[c+8>>0]=0;DTb(883416,c);ZSb(c);u=a;return 528272}function d8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);Dlc(a+4|0,b+4|0);c=a+20|0;d=f[b+20>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}h0b(a+32|0,b+32|0);return}function e8b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220855]|0)==2){u=a;return 528320}f[c>>2]=161028;f[c+4>>2]=154;b[c+8>>0]=0;DTb(883420,c);ZSb(c);u=a;return 528320}function f8b(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);n1b(a,b);return}function g8b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220856]|0)==2){u=a;return 528376}f[c>>2]=161028;f[c+4>>2]=155;b[c+8>>0]=0;DTb(883424,c);ZSb(c);u=a;return 528376}function h8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);Dlc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,c+32|0);if(!(f[c+24>>2]&1))return;e=b[c+48>>0]|0;c=a+24|0;f[c>>2]=f[c>>2]|1;b[a+48>>0]=e;return}function i8b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220857]|0)==2){u=a;return 528432}f[c>>2]=161028;f[c+4>>2]=156;b[c+8>>0]=0;DTb(883428,c);ZSb(c);u=a;return 528432}function j8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);Dlc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}h0b(a+32|0,c+32|0);if(!(f[c+24>>2]&1))return;e=b[c+48>>0]|0;c=a+24|0;f[c>>2]=f[c>>2]|1;b[a+48>>0]=e;return}function k8b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220858]|0)==2){u=a;return 528488}f[c>>2]=161028;f[c+4>>2]=157;b[c+8>>0]=0;DTb(883432,c);ZSb(c);u=a;return 528488}function l8b(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);g0b(a,b);return}function m8b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220862]|0)==2){u=a;return 528712}f[c>>2]=161028;f[c+4>>2]=161;b[c+8>>0]=0;DTb(883448,c);ZSb(c);u=a;return 528712}function n8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}E_b(a+16|0,b+16|0);return}function o8b(a,b){a=a|0;b=b|0;return 0}function p8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=166492;b=a+40|0;c=a+44|0;d=f[c>>2]|0;e=f[b>>2]|0;g=e;if((d|0)==(e|0)){h=d;i=g}else{d=0;e=g;while(1){YDc(f[e+(d<<2)>>2]|0);d=d+1|0;g=f[c>>2]|0;j=f[b>>2]|0;k=j;if(d>>>0>=g-j>>2>>>0){h=g;i=k;break}else e=k}}e=h;if(i|0){if((e|0)!=(i|0))f[c>>2]=e+(~((e+-4-i|0)>>>2)<<2);YDc(i)}D8b(a+28|0,f[a+32>>2]|0);E8b(a+16|0,f[a+20>>2]|0);E8b(a+4|0,f[a+8>>2]|0);return}function q8b(a){a=a|0;p8b(a);YDc(a);return}function r8b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=C8b(a+4|0,b)|0;b=(g|0)==(a+8|0)?e:g+28|0;g=f[b>>2]|0;if(!g){h=0;u=d;return h|0}h=MSb(c,g,f[b+4>>2]|0)|0;u=d;return h|0}function s8b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;A8b(e,a+4|0,b);b=f[e>>2]|0;if(!b){g=0;u=d;return g|0}g=MSb(c,b,f[e+4>>2]|0)|0;u=d;return g|0}function t8b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;x8b(g,a+4|0,b,c);c=f[g>>2]|0;if(!c){h=0;u=e;return h|0}h=MSb(d,c,f[g+4>>2]|0)|0;u=e;return h|0}function u8b(a,b,c){a=a|0;b=b|0;c=c|0;return v8b(a+4|0,b,c)|0}function v8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+32|0;g=e+16|0;h=e;fEc(h,c);fEc(g,h);f[g+12>>2]=0;i=a+28|0;j=w8b(a+24|0,g,f[i>>2]|0,i)|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((j|0)==(i|0)){k=0;u=e;return k|0}h=c+11|0;g=c+4|0;a=d+4|0;l=d+8|0;m=0;n=j;a:while(1){j=n+16|0;o=b[j+11>>0]|0;p=o<<24>>24<0;q=o&255;o=p?f[n+20>>2]|0:q;r=b[h>>0]|0;s=r<<24>>24<0;if((o|0)!=((s?f[g>>2]|0:r&255)|0)){k=m;t=24;break}r=f[j>>2]|0;v=p?r:j;w=s?f[c>>2]|0:c;s=(o|0)==0;b:do if(p){if(!s?Arc(v,w,o)|0:0){k=m;t=24;break a}}else if(!s){if((r&255)<<24>>24==(b[w>>0]|0)){x=j;y=q;z=w}else{k=m;t=24;break a}while(1){y=y+-1|0;x=x+1|0;if(!y)break b;z=z+1|0;if((b[x>>0]|0)!=(b[z>>0]|0)){k=m;t=24;break a}}}while(0);w=n+28|0;q=f[a>>2]|0;if((q|0)==(f[l>>2]|0))g6(d,w);else{f[q>>2]=f[w>>2];f[a>>2]=q+4}q=f[n+4>>2]|0;if(!q){w=n+8|0;j=f[w>>2]|0;if((f[j>>2]|0)==(n|0))A=j;else{j=w;do{w=f[j>>2]|0;j=w+8|0;r=f[j>>2]|0}while((f[r>>2]|0)!=(w|0));A=r}}else{j=q;while(1){r=f[j>>2]|0;if(!r)break;else j=r}A=j}if((A|0)==(i|0)){k=1;t=24;break}else{m=1;n=A}}if((t|0)==24){u=e;return k|0}return 0}function w8b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=b[c+11>>0]|0;h=a<<24>>24<0;i=h?f[c+4>>2]|0:a&255;a=f[c+12>>2]|0;j=h?f[c>>2]|0:c;c=e;e=d;a:while(1){d=e;while(1){h=d+16|0;k=b[h+11>>0]|0;l=k<<24>>24<0;m=l?f[d+20>>2]|0:k&255;k=i>>>0<m>>>0;n=k?i:m;if((n|0)!=0?(o=Arc(l?f[h>>2]|0:h,j,n)|0,(o|0)!=0):0){if((o|0)>=0)p=8}else p=6;if((p|0)==6?(p=0,m>>>0>=i>>>0):0)p=8;if((p|0)==8){p=0;o=m>>>0<i>>>0?m:i;if((o|0)!=0?(m=Arc(j,l?f[h>>2]|0:h,o)|0,(m|0)!=0):0){if((m|0)<0)break}else p=10;if((p|0)==10?(p=0,k):0)break;if((f[d+28>>2]|0)>=(a|0))break}k=f[d+4>>2]|0;if(!k){g=c;p=15;break a}else d=k}e=f[d>>2]|0;if(!e){g=d;p=15;break}else c=d}if((p|0)==15)return g|0;return 0}function x8b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+16|0;fEc(i,d);fEc(h,i);f[h+12>>2]=e;f[j>>2]=0;f[j+4>>2]=0;e=y8b(c+24|0,h)|0;d=(e|0)==(c+28|0)?j:e+32|0;e=f[d+4>>2]|0;j=a;f[j>>2]=f[d>>2];f[j+4>>2]=e;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)>=0){u=g;return}YDc(f[i>>2]|0);u=g;return}function y8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=z8b(a,c,f[d>>2]|0,d)|0;do if((e|0)!=(d|0)){a=e+16|0;g=b[a+11>>0]|0;h=g<<24>>24<0;i=h?f[e+20>>2]|0:g&255;g=b[c+11>>0]|0;j=g<<24>>24<0;k=j?f[c+4>>2]|0:g&255;g=i>>>0<k>>>0;l=g?i:k;if((l|0)!=0?(m=Arc(j?f[c>>2]|0:c,h?f[a>>2]|0:a,l)|0,(m|0)!=0):0){if((m|0)<0)break}else n=4;if((n|0)==4?k>>>0<i>>>0:0)break;m=k>>>0<i>>>0?k:i;if((m|0)!=0?(i=Arc(h?f[a>>2]|0:a,j?f[c>>2]|0:c,m)|0,(i|0)!=0):0){if((i|0)<0){o=e;return o|0}}else n=8;if((n|0)==8?g:0){o=e;return o|0}if((f[c+12>>2]|0)>=(f[e+28>>2]|0)){o=e;return o|0}}while(0);o=d;return o|0}function z8b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=b[c+11>>0]|0;h=a<<24>>24<0;i=h?f[c+4>>2]|0:a&255;a=f[c+12>>2]|0;j=h?f[c>>2]|0:c;c=e;e=d;a:while(1){d=e;while(1){h=d+16|0;k=b[h+11>>0]|0;l=k<<24>>24<0;m=l?f[d+20>>2]|0:k&255;k=i>>>0<m>>>0;n=k?i:m;if((n|0)!=0?(o=Arc(l?f[h>>2]|0:h,j,n)|0,(o|0)!=0):0){if((o|0)>=0)p=8}else p=6;if((p|0)==6?(p=0,m>>>0>=i>>>0):0)p=8;if((p|0)==8){p=0;o=m>>>0<i>>>0?m:i;if((o|0)!=0?(m=Arc(j,l?f[h>>2]|0:h,o)|0,(m|0)!=0):0){if((m|0)<0)break}else p=10;if((p|0)==10?(p=0,k):0)break;if((f[d+28>>2]|0)>=(a|0))break}k=f[d+4>>2]|0;if(!k){g=c;p=15;break a}else d=k}e=f[d>>2]|0;if(!e){g=d;p=15;break}else c=d}if((p|0)==15)return g|0;return 0}function A8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=c+16|0;g=f[e>>2]|0;a:do if(!g)h=e;else{i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d+4>>2]|0:i&255;i=j?f[d>>2]|0:d;j=e;l=g;while(1){m=l;while(1){n=m+16|0;o=b[n+11>>0]|0;p=o<<24>>24<0;q=p?f[m+20>>2]|0:o&255;o=q>>>0<k>>>0?q:k;if((o|0)!=0?(r=Arc(i,p?f[n>>2]|0:n,o)|0,(r|0)!=0):0){if((r|0)<0)break}else s=6;if((s|0)==6?(s=0,k>>>0<q>>>0):0)break;q=f[m+4>>2]|0;if(!q){h=j;break a}else m=q}l=f[m>>2]|0;if(!l){h=m;break}else j=m}}while(0);if((h|0)==(f[c+12>>2]|0))t=h;else{s=f[h>>2]|0;if(!s){g=h;while(1){h=f[g+8>>2]|0;if((f[h>>2]|0)==(g|0))g=h;else{u=h;break}}}else{g=s;while(1){s=f[g+4>>2]|0;if(!s){u=g;break}else g=s}}t=u}if((t|0)!=(e|0)?B8b(c,t+16|0,d)|0:0){d=t+28|0;t=f[d+4>>2]|0;c=a;f[c>>2]=f[d>>2];f[c+4>>2]=t;return}f[a>>2]=0;f[a+4>>2]=0;return}function B8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=c+11|0;e=b[a>>0]|0;g=e<<24>>24<0;h=c+4|0;i=e&255;e=g?f[h>>2]|0:i;j=d+11|0;k=b[j>>0]|0;l=k<<24>>24<0;m=l?f[d+4>>2]|0:k&255;a:do if((e|0)==(m|0)){k=f[c>>2]|0;n=g?k:c;o=l?f[d>>2]|0:d;p=(e|0)==0;if(g){if(p){q=1;return q|0}if(!(Arc(n,o,e)|0))q=1;else break;return q|0}if(p){q=1;return q|0}if((k&255)<<24>>24==(b[o>>0]|0)){k=c;p=i;n=o;while(1){p=p+-1|0;k=k+1|0;if(!p){q=1;break}n=n+1|0;if((b[k>>0]|0)!=(b[n>>0]|0))break a}return q|0}}while(0);if(m>>>0<e>>>0){q=0;return q|0}if(EEc(d,0,e,g?f[c>>2]|0:c,e)|0){q=0;return q|0}e=b[a>>0]|0;q=(b[((b[j>>0]|0)<0?f[d>>2]|0:d)+(e<<24>>24<0?f[h>>2]|0:e&255)>>0]|0)==46;return q|0}function C8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function D8b(a,c){a=a|0;c=c|0;if(!c)return;D8b(a,f[c>>2]|0);D8b(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function E8b(a,c){a=a|0;c=c|0;if(!c)return;E8b(a,f[c>>2]|0);E8b(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function F8b(a){a=a|0;f[a>>2]=166492;f[a+8>>2]=0;f[a+12>>2]=0;f[a+4>>2]=a+8;f[a+20>>2]=0;f[a+24>>2]=0;f[a+16>>2]=a+20;f[a+32>>2]=0;f[a+36>>2]=0;f[a+28>>2]=a+32;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;return}function G8b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+192|0;e=d+176|0;g=d+32|0;h=d+24|0;i=d;N7b(g);if(MSb(g,b,c)|0){f[h>>2]=b;f[h+4>>2]=c;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];j=H8b(a+4|0,g,e)|0;r7b(g);u=d;return j|0}else{rTb(i,2,492805,318);oTb(d+184|0,mTb(i,493083)|0);sTb(i);j=0;r7b(g);u=d;return j|0}return 0}function H8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+128|0;g=e+96|0;h=e+72|0;i=e+60|0;j=e+48|0;k=e+40|0;l=e+32|0;m=e+24|0;n=e+16|0;o=e+8|0;p=e;q=c+120|0;fEc(g,f[q>>2]|0);r=d;d=f[r>>2]|0;s=f[r+4>>2]|0;r=g+12|0;f[r>>2]=d;f[r+4>>2]=s;r=I8b(a,g)|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if(!r){rTb(h,2,492805,58);r=mTb(h,492903)|0;oTb(e+116|0,nTb(r,f[q>>2]|0)|0);sTb(h);t=0;u=e;return t|0}if(!(f[c+8>>2]&2)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;v=i+11|0;w=0;x=0}else{fEc(i,f[c+124>>2]|0);h=i+11|0;v=h;w=b[h>>0]|0;x=f[i+4>>2]|0}if((w<<24>>24<0?x:w&255)|0)vEc(i,46);w=c+36|0;a:do if((f[w>>2]|0)>0){x=c+44|0;h=j+11|0;q=0;while(1){QJa(j,i,f[(f[(f[x>>2]|0)+4+(q<<2)>>2]|0)+144>>2]|0);r=k;f[r>>2]=d;f[r+4>>2]=s;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];r=J8b(a,j,g)|0;if((b[h>>0]|0)<0)YDc(f[j>>2]|0);if(!r){y=0;break a}r=f[(f[x>>2]|0)+4+(q<<2)>>2]|0;z=l;f[z>>2]=d;f[z+4>>2]=s;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];q=q+1|0;if(!(K8b(a,r,g)|0)){y=0;break a}if((q|0)>=(f[w>>2]|0)){A=13;break}}}else A=13;while(0);b:do if((A|0)==13){w=c+52|0;if((f[w>>2]|0)>0){l=c+60|0;k=j+11|0;q=0;do{QJa(j,i,f[(f[(f[l>>2]|0)+4+(q<<2)>>2]|0)+64>>2]|0);x=m;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];x=J8b(a,j,g)|0;if((b[k>>0]|0)<0)YDc(f[j>>2]|0);q=q+1|0;if(!x){y=0;break b}}while((q|0)<(f[w>>2]|0))}w=c+84|0;if((f[w>>2]|0)>0){q=c+92|0;k=j+11|0;l=0;do{QJa(j,i,f[(f[(f[q>>2]|0)+4+(l<<2)>>2]|0)+16>>2]|0);x=n;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];x=J8b(a,j,g)|0;if((b[k>>0]|0)<0)YDc(f[j>>2]|0);if(!x){y=0;break b}x=f[(f[q>>2]|0)+4+(l<<2)>>2]|0;h=o;f[h>>2]=d;f[h+4>>2]=s;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];l=l+1|0;if(!(L8b(a,x,g)|0)){y=0;break b}}while((l|0)<(f[w>>2]|0))}w=c+68|0;if((f[w>>2]|0)>0){l=c+76|0;q=j+11|0;k=0;while(1){QJa(j,i,f[(f[(f[l>>2]|0)+4+(k<<2)>>2]|0)+32>>2]|0);x=p;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[p>>2];f[g+4>>2]=f[p+4>>2];x=J8b(a,j,g)|0;if((b[q>>0]|0)<0)YDc(f[j>>2]|0);k=k+1|0;if(!x){y=0;break b}if((k|0)>=(f[w>>2]|0)){y=1;break}}}else y=1}while(0);if((b[v>>0]|0)<0)YDc(f[i>>2]|0);t=y;u=e;return t|0}function I8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=O8b(a,d,b)|0;if(f[e>>2]|0){g=0;u=c;return g|0}h=VDc(36)|0;fEc(h+16|0,b);i=b+12|0;b=f[i+4>>2]|0;j=h+28|0;f[j>>2]=f[i>>2];f[j+4>>2]=b;b=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=b;f[e>>2]=h;b=f[f[a>>2]>>2]|0;if(!b)k=h;else{f[a>>2]=b;k=f[e>>2]|0}laa(f[a+4>>2]|0,k);k=a+8|0;f[k>>2]=(f[k>>2]|0)+1;g=1;u=c;return g|0}function J8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+144|0;g=e+124|0;h=e+104|0;i=e+100|0;j=e+96|0;k=e+72|0;l=e+130|0;m=e+24|0;n=e+129|0;o=e;p=e+128|0;q=e+48|0;r=b[c+11>>0]|0;s=r<<24>>24<0;t=s?f[c+4>>2]|0:r&255;a:do if(t|0){r=s?f[c>>2]|0:c;v=0;b:while(1){w=b[r+v>>0]|0;switch(w<<24>>24){case 95:case 46:break;default:{if(w<<24>>24<48)break b;if(w<<24>>24>57){if(w<<24>>24<65)break b;if(w<<24>>24>90&(w+-97&255)>25)break b}}}v=v+1|0;if(v>>>0>=t>>>0)break a}rTb(k,2,492805,95);oTb(l,nTb(mTb(k,493008)|0,c)|0);sTb(k);x=0;u=e;return x|0}while(0);k=a+16|0;l=f[k>>2]|0;c:do if(!l)y=k;else{v=s?f[c>>2]|0:c;r=k;w=l;while(1){z=w;while(1){A=z+16|0;B=b[A+11>>0]|0;C=B<<24>>24<0;D=C?f[z+20>>2]|0:B&255;B=D>>>0<t>>>0?D:t;if((B|0)!=0?(E=Arc(v,C?f[A>>2]|0:A,B)|0,(E|0)!=0):0){if((E|0)<0)break}else F=15;if((F|0)==15?(F=0,t>>>0<D>>>0):0)break;D=f[z+4>>2]|0;if(!D){y=r;break c}else z=D}w=f[z>>2]|0;if(!w){y=z;break}else r=z}}while(0);if((y|0)==(f[a+12>>2]|0))G=y;else{t=f[y>>2]|0;if(!t){F=y;while(1){y=f[F+8>>2]|0;if((f[y>>2]|0)==(F|0))F=y;else{H=y;break}}}else{F=t;while(1){t=f[F+4>>2]|0;if(!t){H=F;break}else F=t}}G=H}H=a+12|0;if((G|0)==(k|0)){fEc(h,c);F=h+12|0;t=d;y=f[t+4>>2]|0;l=F;f[l>>2]=f[t>>2];f[l+4>>2]=y;y=O8b(H,g,h)|0;if(!(f[y>>2]|0)){l=VDc(36)|0;fEc(l+16|0,h);t=F;F=f[t+4>>2]|0;s=l+28|0;f[s>>2]=f[t>>2];f[s+4>>2]=F;F=f[g>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=F;f[y>>2]=l;F=f[f[H>>2]>>2]|0;if(!F)I=l;else{f[H>>2]=F;I=f[y>>2]|0}laa(f[a+16>>2]|0,I);I=a+20|0;f[I>>2]=(f[I>>2]|0)+1}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);x=1;u=e;return x|0}I=G+16|0;if(B8b(a,I,c)|0){rTb(m,2,492805,111);oTb(n,mTb(nTb(mTb(nTb(mTb(m,493030)|0,c)|0,493044)|0,I)|0,502535)|0);sTb(m);x=0;u=e;return x|0}m=f[G+4>>2]|0;if(!m){I=G+8|0;n=f[I>>2]|0;if((f[n>>2]|0)==(G|0))J=n;else{n=I;do{I=f[n>>2]|0;n=I+8|0;G=f[n>>2]|0}while((f[G>>2]|0)!=(I|0));J=G}}else{n=m;while(1){m=f[n>>2]|0;if(!m)break;else n=m}J=n}n=J;if((J|0)!=(k|0)?(k=J+16|0,B8b(a,c,k)|0):0){rTb(o,2,492805,124);oTb(p,mTb(nTb(mTb(nTb(mTb(o,493030)|0,c)|0,493044)|0,k)|0,502535)|0);sTb(o);x=0;u=e;return x|0}fEc(q,c);c=q+12|0;o=d;d=f[o+4>>2]|0;k=c;f[k>>2]=f[o>>2];f[k+4>>2]=d;f[j>>2]=n;f[g>>2]=f[j>>2];j=P8b(H,g,h,i,q)|0;if(!(f[j>>2]|0)){i=VDc(36)|0;fEc(i+16|0,q);g=c;c=f[g+4>>2]|0;n=i+28|0;f[n>>2]=f[g>>2];f[n+4>>2]=c;c=f[h>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=c;f[j>>2]=i;c=f[f[H>>2]>>2]|0;if(!c)K=i;else{f[H>>2]=c;K=f[j>>2]|0}laa(f[a+16>>2]|0,K);K=a+20|0;f[K>>2]=(f[K>>2]|0)+1}if((b[q+11>>0]|0)<0)YDc(f[q>>2]|0);x=1;u=e;return x|0}function K8b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;i=b+36|0;a:do if((f[i>>2]|0)>0){j=b+44|0;k=c;l=f[k>>2]|0;m=f[k+4>>2]|0;k=0;while(1){n=f[(f[j>>2]|0)+4+(k<<2)>>2]|0;o=g;f[o>>2]=l;f[o+4>>2]=m;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];k=k+1|0;if(!(K8b(a,n,e)|0)){p=0;break}if((k|0)>=(f[i>>2]|0))break a}u=d;return p|0}while(0);i=b+84|0;if((f[i>>2]|0)<=0){p=1;u=d;return p|0}g=b+92|0;b=c;c=f[b>>2]|0;k=f[b+4>>2]|0;b=0;while(1){m=f[(f[g>>2]|0)+4+(b<<2)>>2]|0;l=h;f[l>>2]=c;f[l+4>>2]=k;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];b=b+1|0;if(!(L8b(a,m,e)|0)){p=0;q=9;break}if((b|0)>=(f[i>>2]|0)){p=1;q=9;break}}if((q|0)==9){u=d;return p|0}return 0}function L8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+96|0;g=e+56|0;h=e+40|0;i=e+24|0;j=e;k=c+20|0;l=f[k>>2]|0;m=b[l+11>>0]|0;n=m<<24>>24<0;if(n)o=f[l+4>>2]|0;else o=m&255;if(!o){p=1;u=e;return p|0}if(n)q=f[l>>2]|0;else q=l;if((b[q>>0]|0)!=46){p=1;u=e;return p|0}gEc(i,l,1,-1,l);l=c+40|0;q=f[l>>2]|0;fEc(h,i);n=h+12|0;f[n>>2]=q;fEc(g,h);f[g+12>>2]=f[n>>2];n=d;d=f[n+4>>2]|0;q=g+16|0;f[q>>2]=f[n>>2];f[q+4>>2]=d;d=M8b(a+24|0,g)|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);if(d){p=1;u=e;return p|0}rTb(j,2,492805,163);d=mTb(j,492937)|0;i=mTb(nTb(d,f[k>>2]|0)|0,501898)|0;k=mTb(nTb(i,f[c+16>>2]|0)|0,493001)|0;oTb(e+80|0,mTb(pTb(k,f[l>>2]|0)|0,493005)|0);sTb(j);p=0;u=e;return p|0}function M8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=N8b(a,d,b)|0;if(f[e>>2]|0){g=0;u=c;return g|0}h=VDc(40)|0;fEc(h+16|0,b);f[h+28>>2]=f[b+12>>2];i=b+16|0;b=f[i+4>>2]|0;j=h+32|0;f[j>>2]=f[i>>2];f[j+4>>2]=b;b=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=b;f[e>>2]=h;b=f[f[a>>2]>>2]|0;if(!b)k=h;else{f[a>>2]=b;k=f[e>>2]|0}laa(f[a+4>>2]|0,k);k=a+8|0;f[k>>2]=(f[k>>2]|0)+1;g=1;u=c;return g|0}function N8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=f[d+12>>2]|0;k=i?f[d>>2]|0:d;d=a+4|0;a=g;a:while(1){g=a+16|0;i=b[g+11>>0]|0;l=i<<24>>24<0;m=l?f[a+20>>2]|0:i&255;i=m>>>0<j>>>0;n=i?m:j;o=(n|0)==0;if(!o?(p=Arc(k,l?f[g>>2]|0:g,n)|0,(p|0)!=0):0)if((p|0)<0)q=13;else q=8;else if(j>>>0<m>>>0)q=13;else q=8;do if((q|0)==8){q=0;p=j>>>0<m>>>0;r=p?j:m;s=(r|0)==0;if(!s?(t=Arc(l?f[g>>2]|0:g,k,r)|0,(t|0)!=0):0)if((t|0)<0)q=16;else q=12;else if(i)q=15;else q=12;if((q|0)==12){q=0;if((e|0)<(f[a+28>>2]|0)){q=13;break}else q=15}if((q|0)==15){q=0;if(s)q=17;else q=16}if((q|0)==16){q=0;s=Arc(l?f[g>>2]|0:g,k,r)|0;if(s){if((s|0)>=0)q=19}else q=17}if((q|0)==17?(q=0,!i):0)q=19;if((q|0)==19){q=0;if(!o?(s=Arc(k,l?f[g>>2]|0:g,n)|0,(s|0)!=0):0){if((s|0)<0){q=26;break a}}else q=21;if((q|0)==21?(q=0,p):0){q=26;break a}if((f[a+28>>2]|0)>=(e|0)){q=26;break a}}u=a+4|0;p=f[u>>2]|0;if(!p){q=25;break a}else{v=u;w=p}}while(0);if((q|0)==13){q=0;n=f[a>>2]|0;if(!n){q=14;break}else{v=a;w=n}}d=v;a=w}if((q|0)==14){f[c>>2]=a;h=a;return h|0}else if((q|0)==25){f[c>>2]=a;h=u;return h|0}else if((q|0)==26){f[c>>2]=a;h=d;return h|0}return 0}function O8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function P8b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=i+16|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[i+20>>2]|0:k&255;k=b[g+11>>0]|0;n=k<<24>>24<0;o=n?f[g+4>>2]|0:k&255;k=m>>>0<o>>>0;p=k?m:o;if((p|0)!=0?(q=Arc(n?f[g>>2]|0:g,l?f[j>>2]|0:j,p)|0,(q|0)!=0):0){if((q|0)<0)break}else r=4;if((r|0)==4?o>>>0<m>>>0:0)break;q=o>>>0<m>>>0?o:m;if((q|0)!=0?(m=Arc(l?f[j>>2]|0:j,n?f[g>>2]|0:g,q)|0,(m|0)!=0):0){if((m|0)>=0)r=36}else r=20;if((r|0)==20?!k:0)r=36;if((r|0)==36){f[d>>2]=c;f[e>>2]=c;s=e;return s|0}k=i+4|0;m=f[k>>2]|0;if(!m){q=i+8|0;j=f[q>>2]|0;if((f[j>>2]|0)==(i|0))t=j;else{j=q;do{q=f[j>>2]|0;j=q+8|0;l=f[j>>2]|0}while((f[l>>2]|0)!=(q|0));t=l}}else{j=m;while(1){l=f[j>>2]|0;if(!l)break;else j=l}t=j}do if((t|0)!=(h|0)){m=t+16|0;l=b[m+11>>0]|0;q=l<<24>>24<0;p=q?f[t+20>>2]|0:l&255;l=p>>>0<o>>>0?p:o;if((l|0)!=0?(u=Arc(n?f[g>>2]|0:g,q?f[m>>2]|0:m,l)|0,(u|0)!=0):0){if((u|0)<0)break}else r=30;if((r|0)==30?o>>>0<p>>>0:0)break;s=O8b(a,d,g)|0;return s|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;s=k;return s|0}else{f[d>>2]=t;s=t;return s|0}}while(0);t=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))v=c;else{if(!t){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{w=e;break}}}else{h=t;while(1){k=f[h+4>>2]|0;if(!k){w=h;break}else h=k}}h=w;k=w+16|0;e=b[g+11>>0]|0;o=e<<24>>24<0;n=o?f[g+4>>2]|0:e&255;e=b[k+11>>0]|0;j=e<<24>>24<0;p=j?f[w+20>>2]|0:e&255;e=n>>>0<p>>>0?n:p;if((e|0)!=0?(u=Arc(j?f[k>>2]|0:k,o?f[g>>2]|0:g,e)|0,(u|0)!=0):0){if((u|0)<0){v=h;break}}else r=12;if((r|0)==12?p>>>0<n>>>0:0){v=h;break}s=O8b(a,d,g)|0;return s|0}while(0);if(!t){f[d>>2]=i;s=i;return s|0}else{i=v;f[d>>2]=i;s=i+4|0;return s|0}return 0}function Q8b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;c=u;u=u+16|0;d=c;f[a>>2]=166528;e=a+4|0;g=f[e>>2]|0;h=f[g+28>>2]|0;i=a+(f[g+12>>2]|0)|0;g=f[i>>2]|0;if(g&1|0?(j=g&-2,g=j,!((j|0)==0|(f[g+4>>2]|0)!=0)):0){if(f[g>>2]|0)ljc(g);YDc(j)}f[i>>2]=0;i=f[(f[e>>2]|0)+16>>2]|0;if((i|0)!=-1)mkc(a+i|0);i=h+52|0;j=f[i>>2]|0;if((j|0)<=0){u=c;return}g=h+20|0;h=d+4|0;k=d+8|0;l=d+12|0;m=d+4|0;n=d+8|0;o=d+12|0;p=d+4|0;q=d+8|0;r=d+12|0;s=d+4|0;t=d+8|0;v=d+12|0;w=d+4|0;x=d+8|0;y=d+12|0;z=d+4|0;A=d+8|0;B=d+12|0;C=0;D=j;do{j=f[g>>2]|0;E=j+(C*88|0)|0;F=f[j+(C*88|0)+52>>2]|0;G=f[e>>2]|0;a:do if(F){H=(F-(f[(f[F+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[a+((H<<2)+(f[G+8>>2]|0))>>2]|0)==(f[j+(C*88|0)+40>>2]|0)){I=a+(f[(f[G+32>>2]|0)+(H+D<<2)>>2]|0)|0;H=j+(C*88|0)+24|0;J=f[H>>2]|0;if(J|0?(f[J>>2]|0)!=2:0){f[d>>2]=78728;f[z>>2]=1737;b[A>>0]=0;f[B>>2]=E;DTb(J,d)}J=j+(C*88|0)+28|0;if((f[161216+(f[J>>2]<<2)>>2]|0)==9){K=f[e>>2]|0;L=f[I>>2]|0;if((L|0)==0?1:(L|0)==(f[(f[K+44>>2]|0)+(f[(f[K+32>>2]|0)+(C<<2)>>2]|0)>>2]|0))break;if((b[L+11>>0]|0)<0)YDc(f[L>>2]|0);YDc(L);break}L=f[H>>2]|0;if(L|0?(f[L>>2]|0)!=2:0){f[d>>2]=78728;f[w>>2]=1737;b[x>>0]=0;f[y>>2]=E;DTb(L,d)}if((f[161216+(f[J>>2]<<2)>>2]|0)==10?(J=f[I>>2]|0,J|0):0)Yi[f[(f[J>>2]|0)+4>>2]&2047](J)}}else{J=a+(f[(f[G+32>>2]|0)+(C<<2)>>2]|0)|0;I=j+(C*88|0)+24|0;L=f[I>>2]|0;H=(L|0)==0;if((f[j+(C*88|0)+32>>2]|0)!=3){if(!H?(f[L>>2]|0)!=2:0){f[d>>2]=78728;f[s>>2]=1737;b[t>>0]=0;f[v>>2]=E;DTb(L,d)}K=j+(C*88|0)+28|0;if((f[161216+(f[K>>2]<<2)>>2]|0)==9){M=f[e>>2]|0;N=f[J>>2]|0;if((N|0)==0?1:(N|0)==(f[(f[M+44>>2]|0)+(f[(f[M+32>>2]|0)+(C<<2)>>2]|0)>>2]|0))break;if((b[N+11>>0]|0)<0)YDc(f[N>>2]|0);YDc(N);break}N=f[I>>2]|0;if(N|0?(f[N>>2]|0)!=2:0){f[d>>2]=78728;f[p>>2]=1737;b[q>>0]=0;f[r>>2]=E;DTb(N,d)}if((f[161216+(f[K>>2]<<2)>>2]|0)!=10)break;K=f[(f[e>>2]|0)+44>>2]|0;if((K|0)==(a|0)|(K|0)==0)break;K=f[J>>2]|0;if(!K)break;Yi[f[(f[K>>2]|0)+4>>2]&2047](K);break}if(!H?(f[L>>2]|0)!=2:0){f[d>>2]=78728;f[m>>2]=1737;b[n>>0]=0;f[o>>2]=E;DTb(L,d)}L=j+(C*88|0)+28|0;do switch(f[161216+(f[L>>2]<<2)>>2]|0){case 1:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;YDc(H);break a;break}case 2:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;YDc(H);break a;break}case 3:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;YDc(H);break a;break}case 4:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;YDc(H);break a;break}case 5:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;YDc(H);break a;break}case 6:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;YDc(H);break a;break}case 7:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;YDc(H);break a;break}case 8:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;YDc(H);break a;break}case 9:{H=J+12|0;K=f[H>>2]|0;if(K|0?(f[J>>2]|0)==0:0){N=f[K>>2]|0;if((N|0)>0){M=0;do{O=f[K+4+(M<<2)>>2]|0;if(O|0){if((b[O+11>>0]|0)<0)YDc(f[O>>2]|0);YDc(O)}M=M+1|0}while((M|0)!=(N|0));P=f[H>>2]|0}else P=K;YDc(P)}f[H>>2]=0;break a;break}case 10:{N=f[I>>2]|0;if(N|0?(f[N>>2]|0)!=2:0){f[d>>2]=78728;f[h>>2]=1737;b[k>>0]=0;f[l>>2]=E;DTb(N,d)}if((f[L>>2]|0)==11?BYb(E)|0:0){Yi[f[f[J>>2]>>2]&2047](J);break a}N=J+12|0;M=f[N>>2]|0;if(M|0?(f[J>>2]|0)==0:0){O=f[M>>2]|0;if((O|0)>0){Q=0;do{R=f[M+4+(Q<<2)>>2]|0;if(R|0)Yi[f[(f[R>>2]|0)+4>>2]&2047](R);Q=Q+1|0}while((Q|0)!=(O|0));S=f[N>>2]|0}else S=M;YDc(S)}f[N>>2]=0;break a;break}default:break a}while(0)}while(0);C=C+1|0;D=f[i>>2]|0}while((C|0)<(D|0));u=c;return}function R8b(a){a=a|0;Q8b(a);YDc(a);return}function S8b(a){a=a|0;var b=0,c=0;b=a+4|0;a=VDc(f[f[b>>2]>>2]|0)|0;c=f[b>>2]|0;XIc(a|0,0,f[c>>2]|0)|0;f[a>>2]=166528;f[a+4>>2]=c;f[a+8>>2]=0;Z8b(a,1);return a|0}function T8b(a,b){a=a|0;b=b|0;var c=0;c=_i[f[(f[a>>2]|0)+12>>2]&1023](a)|0;if(!b)return c|0;Y8b(b,c);return c|0}function U8b(a){a=a|0;return 0}function V8b(a){a=a|0;return f[a+8>>2]|0}function W8b(a,b){a=a|0;b=b|0;f[a+8>>2]=b;return}function X8b(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;f[a>>2]=f[c+28>>2];f[a+4>>2]=f[c+40>>2];return}function Y8b(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function Z8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=a+4|0;h=f[g>>2]|0;i=f[h+28>>2]|0;j=i+56|0;if((f[j>>2]|0)>0){k=0;l=h;while(1){f[a+((f[l+8>>2]|0)+(k<<2))>>2]=0;k=k+1|0;m=f[g>>2]|0;if((k|0)>=(f[j>>2]|0)){n=m;break}else l=m}}else n=h;f[a+(f[n+12>>2]|0)>>2]=0;n=f[(f[g>>2]|0)+16>>2]|0;if((n|0)!=-1)lkc(a+n|0);n=i+52|0;if((f[n>>2]|0)<=0){u=d;return}h=i+20|0;i=e+4|0;l=e+8|0;j=e+12|0;k=e+4|0;m=e+8|0;o=e+12|0;q=0;do{r=f[h>>2]|0;s=r+(q*88|0)|0;t=a+(f[(f[(f[g>>2]|0)+32>>2]|0)+(q<<2)>>2]|0)|0;a:do if(!(f[r+(q*88|0)+52>>2]|0)){v=r+(q*88|0)+24|0;w=f[v>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[e>>2]=78728;f[k>>2]=1737;b[m>>0]=0;f[o>>2]=s;DTb(w,e)}w=r+(q*88|0)+28|0;do switch(f[161216+(f[w>>2]<<2)>>2]|0){case 1:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{f[t>>2]=f[r+(q*88|0)+80>>2];break a}break}case 2:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{x=r+(q*88|0)+80|0;y=f[x+4>>2]|0;z=t;f[z>>2]=f[x>>2];f[z+4>>2]=y;break a}break}case 3:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{f[t>>2]=f[r+(q*88|0)+80>>2];break a}break}case 4:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{y=r+(q*88|0)+80|0;z=f[y+4>>2]|0;x=t;f[x>>2]=f[y>>2];f[x+4>>2]=z;break a}break}case 5:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{p[t>>3]=+p[r+(q*88|0)+80>>3];break a}break}case 6:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{f[t>>2]=f[r+(q*88|0)+80>>2];break a}break}case 7:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{b[t>>0]=b[r+(q*88|0)+80>>0]|0;break a}break}case 8:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{z=(CYb(s)|0)+8|0;f[t>>2]=f[z>>2];break a}break}case 9:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;break a}z=f[g>>2]|0;x=f[z+44>>2]|0;if((x|0)==(a|0)|(x|0)==0)A=r+(q*88|0)+80|0;else A=x+(f[(f[z+32>>2]|0)+(q<<2)>>2]|0)|0;f[t>>2]=f[A>>2];break a;break}case 10:{if((f[r+(q*88|0)+32>>2]|0)!=3){f[t>>2]=0;break a}z=f[v>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[e>>2]=78728;f[i>>2]=1737;b[l>>0]=0;f[j>>2]=s;DTb(z,e)}if((f[w>>2]|0)==11?BYb(s)|0:0){z=f[(f[g>>2]|0)+20>>2]|0;if(c){x=f[(f[z>>2]|0)+8>>2]|0;y=DYb(s)|0;Xdc(t,Mi[x&1023](z,y)|0);break a}else{Xdc(t,_8b(z,DYb(s)|0)|0);break a}};f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;break a;break}default:break a}while(0)}while(0);q=q+1|0}while((q|0)<(f[n>>2]|0));u=d;return}function _8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=u;u=u+80|0;e=d+32|0;g=d+8|0;h=d+68|0;i=d;f[i>>2]=c;if(b[a+8>>0]|0?(j=f[(f[c+8>>2]|0)+8>>2]|0,(j|0)==(kYb()|0)):0){j=khc()|0;k=Mi[f[(f[j>>2]|0)+8>>2]&1023](j,c)|0;u=d;return k|0}c=$8b(f[a+12>>2]|0,i)|0;j=f[c>>2]|0;if(j|0){k=f[j+44>>2]|0;u=d;return k|0}j=VDc(52)|0;l=j+32|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[c>>2]=j;c=f[i>>2]|0;m=j+28|0;f[m>>2]=c;n=f[a+4>>2]|0;if(!n)o=f[(f[c+8>>2]|0)+8>>2]|0;else o=n;n=j+24|0;f[n>>2]=o;f[j+20>>2]=a;o=(f[c+56>>2]|0)+(f[c+52>>2]|0)|0;p=XDc(o>>>0>1073741823?-1:o<<2)|0;o=f[l>>2]|0;if((o|0)==(p|0))q=c;else{if(!o)r=c;else{ZDc(o);r=f[i>>2]|0}f[l>>2]=p;q=r}r=j+4|0;if((f[(f[q+8>>2]|0)+44>>2]|0)!=3){f[r>>2]=16;o=q+52|0;c=f[o>>2]|0;s=(((c+31|0)/32|0)<<2)+23|0;t=s-((s|0)%8|0)|0;s=XDc(c>>>0>1073741823?-1:c<<2)|0;if((f[o>>2]|0)>0){c=0;do{f[s+(c<<2)>>2]=c;c=c+1|0}while((c|0)<(f[o>>2]|0))}o=j+36|0;c=f[o>>2]|0;if((c|0)==(s|0)){v=t;w=q}else{if(!c)x=q;else{ZDc(c);x=f[i>>2]|0}f[o>>2]=s;v=t;w=x}}else{f[r>>2]=-1;v=16;w=q}q=f[w+56>>2]|0;if((q|0)>0){f[j+8>>2]=v;x=v+7+(q<<2)|0;y=x-((x|0)%8|0)|0}else y=v;v=j+16|0;if((f[w+68>>2]|0)>0){f[v>>2]=y;x=y+23|0;z=x-((x|0)%8|0)|0}else{f[v>>2]=-1;z=y}y=f[w+52>>2]|0;if((y|0)>0){x=e+4|0;t=e+8|0;s=e+12|0;o=e+4|0;c=e+8|0;A=e+12|0;B=0;C=z;D=w;while(1){E=f[D+20>>2]|0;F=E+(B*88|0)|0;if(!(f[E+(B*88|0)+52>>2]|0)){G=(f[E+(B*88|0)+32>>2]|0)==3;H=E+(B*88|0)+24|0;I=f[H>>2]|0;if(I|0?(f[I>>2]|0)!=2:0){f[e>>2]=78728;f[o>>2]=1737;b[c>>0]=0;f[A>>2]=F;DTb(I,e)}I=E+(B*88|0)+28|0;E=f[161216+(f[I>>2]<<2)>>2]|0;a:do if(G){switch(E|0){case 8:case 7:case 6:case 5:case 4:case 3:case 2:case 1:{J=12;K=48;break a;break}case 10:break;case 9:{J=16;K=48;break a;break}default:{K=47;break a}}L=f[H>>2]|0;if(L|0?(f[L>>2]|0)!=2:0){f[e>>2]=78728;f[x>>2]=1737;b[t>>0]=0;f[s>>2]=F;DTb(L,e)}if((f[I>>2]|0)==11){L=BYb(F)|0;M=L?36:16}else{J=16;K=48}}else switch(E|0){case 9:case 10:case 8:case 6:case 3:case 1:{J=4;K=48;break a;break}case 2:{J=8;K=48;break a;break}case 4:{J=8;K=48;break a;break}case 5:{J=8;K=48;break a;break}case 7:{J=1;K=48;break a;break}default:{K=47;break a}}while(0);if((K|0)==47){K=0;rTb(g,2,493156,162);oTb(h,mTb(g,504236)|0);sTb(g);J=0;K=48}if((K|0)==48){K=0;M=J}E=(M|0)<8?M:8;F=C+-1+E|0;I=F-((F|0)%(E|0)|0)|0;f[p+(B<<2)>>2]=I;N=I+M|0;O=f[i>>2]|0}else{N=C;O=D}B=B+1|0;P=f[O+52>>2]|0;if((B|0)>=(P|0))break;else{C=N;D=O}}Q=N;R=O;S=f[O+56>>2]|0;T=P}else{Q=z;R=w;S=q;T=y}y=R+56|0;q=Q+7|0;Q=q-((q|0)%8|0)|0;if((S|0)>0){q=R+52|0;f[p+(T<<2)>>2]=Q;T=f[y>>2]|0;w=Q+15|0;z=w-((w|0)%8|0)|0;if((T|0)>1){w=1;P=z;while(1){f[p+((f[q>>2]|0)+w<<2)>>2]=P;w=w+1|0;O=f[y>>2]|0;N=P+15|0;D=N-((N|0)%8|0)|0;if((w|0)>=(O|0)){U=D;V=O;break}else P=D}}else{U=z;V=T}}else{U=Q;V=S}S=j+12|0;f[S>>2]=U;Q=U+4|0;U=j+48|0;f[U>>2]=-1;f[j>>2]=Q;if((V|0)>0){V=e+4|0;T=e+8|0;z=e+12|0;P=0;w=Q;y=R;while(1){R=f[y+24>>2]|0;b:do if((f[R+(P*28|0)+16>>2]|0)>0){q=0;D=w;O=R;while(1){N=f[(f[O+(P*28|0)+20>>2]|0)+(q<<2)>>2]|0;C=f[N+24>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[e>>2]=78728;f[V>>2]=1737;b[T>>0]=0;f[z>>2]=N;DTb(C,e)}switch(f[161216+(f[N+28>>2]<<2)>>2]|0){case 9:case 10:case 8:case 6:case 3:case 1:{W=4;break}case 2:{W=8;break}case 4:{W=8;break}case 5:{W=8;break}case 7:{W=1;break}default:{rTb(g,2,493156,192);oTb(h,mTb(g,504236)|0);sTb(g);W=0}}C=W>>>0<8?W:8;B=D+-1+C|0;M=B-((B|0)%(C|0)|0)|0;do if(b[N+38>>0]|0){C=f[N+56>>2]|0;B=N;if(!C){X=B-(f[(f[N+20>>2]|0)+80>>2]|0)|0;break}else{X=B-(f[C+40>>2]|0)|0;break}}else X=N-(f[(f[N+48>>2]|0)+20>>2]|0)|0;while(0);f[p+(((X|0)/88|0)<<2)>>2]=M;N=M+W|0;q=q+1|0;C=f[i>>2]|0;O=f[C+24>>2]|0;if((q|0)>=(f[O+(P*28|0)+16>>2]|0)){Y=N;Z=C;break b}else D=N}}else{Y=w;Z=y}while(0);P=P+1|0;if((P|0)>=(f[Z+56>>2]|0)){_=Y;break}else{w=Y;y=Z}}}else _=Q;Q=_+7|0;_=Q-((Q|0)%8|0)|0;Q=VDc(_)|0;XIc(Q|0,0,_|0)|0;_=j+44|0;f[_>>2]=Q;f[Q>>2]=166528;f[Q+4>>2]=j;f[Q+8>>2]=0;Z8b(Q,0);if((f[(f[i>>2]|0)+56>>2]|0)>0)a9b(f[m>>2]|0,f[l>>2]|0,Q);f[e>>2]=f[_>>2];f[e+4>>2]=f[l>>2];f[e+8>>2]=f[j+36>>2];f[e+12>>2]=f[r>>2];f[e+16>>2]=f[S>>2];f[e+20>>2]=f[v>>2];f[e+24>>2]=f[j+8>>2];f[e+28>>2]=f[j>>2];f[e+32>>2]=f[U>>2];U=VDc(56)|0;Wbc(U,f[m>>2]|0,e,f[n>>2]|0,a);a=j+40|0;j=f[a>>2]|0;if((j|0)!=(U|0)){if(j|0)Yi[f[(f[j>>2]|0)+4>>2]&2047](j);f[a>>2]=U}b9b(Q);k=Q;u=d;return k|0}function $8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c;e=f[b>>2]|0;b=f[a+4>>2]|0;g=e;a:do if(b|0){h=b+-1|0;i=(h&b|0)==0;if(!i)if(e>>>0<b>>>0)j=e;else j=(e>>>0)%(b>>>0)|0;else j=h&e;k=f[(f[a>>2]|0)+(j<<2)>>2]|0;if(k|0?(l=f[k>>2]|0,l|0):0){b:do if(i){k=l;while(1){m=f[k+4>>2]|0;n=(m|0)==(e|0);if(!(n|(m&h|0)==(j|0)))break a;if(n?(f[k+8>>2]|0)==(g|0):0){o=k;break b}k=f[k>>2]|0;if(!k)break a}}else{k=l;while(1){n=f[k+4>>2]|0;if((n|0)==(e|0)){if((f[k+8>>2]|0)==(g|0)){o=k;break b}}else{if(n>>>0<b>>>0)p=n;else p=(n>>>0)%(b>>>0)|0;if((p|0)!=(j|0))break a}k=f[k>>2]|0;if(!k)break a}}while(0);q=o;r=q+12|0;u=c;return r|0}}while(0);o=VDc(16)|0;f[o+8>>2]=e;f[o+12>>2]=0;c9b(d,a,o);q=f[d>>2]|0;r=q+12|0;u=c;return r|0}function a9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+56|0;if((f[h>>2]|0)<=0){u=e;return}i=a+24|0;a=g+4|0;j=g+8|0;k=g+12|0;l=0;m=f[i>>2]|0;while(1){a:do if((f[m+(l*28|0)+16>>2]|0)>0){n=0;o=m;while(1){q=f[(f[o+(l*28|0)+20>>2]|0)+(n<<2)>>2]|0;do if(b[q+38>>0]|0){r=f[q+56>>2]|0;s=q;if(!r){t=s-(f[(f[q+20>>2]|0)+80>>2]|0)|0;break}else{t=s-(f[r+40>>2]|0)|0;break}}else t=q-(f[(f[q+48>>2]|0)+20>>2]|0)|0;while(0);r=d+(f[c+(((t|0)/88|0)<<2)>>2]|0)|0;s=f[q+24>>2]|0;if(s|0?(f[s>>2]|0)!=2:0){f[g>>2]=78728;f[a>>2]=1737;b[j>>0]=0;f[k>>2]=q;DTb(s,g)}do switch(f[161216+(f[q+28>>2]<<2)>>2]|0){case 1:{f[r>>2]=f[q+80>>2];break}case 2:{s=q+80|0;v=f[s+4>>2]|0;w=r;f[w>>2]=f[s>>2];f[w+4>>2]=v;break}case 3:{f[r>>2]=f[q+80>>2];break}case 4:{v=q+80|0;w=f[v+4>>2]|0;s=r;f[s>>2]=f[v>>2];f[s+4>>2]=w;break}case 5:{p[r>>3]=+p[q+80>>3];break}case 6:{f[r>>2]=f[q+80>>2];break}case 7:{b[r>>0]=b[q+80>>0]|0;break}case 8:{w=(CYb(q)|0)+8|0;f[r>>2]=f[w>>2];break}case 9:{f[r>>2]=0;f[r>>2]=f[q+80>>2];break}case 10:{f[r>>2]=0;break}default:{}}while(0);n=n+1|0;r=f[i>>2]|0;if((n|0)>=(f[r+(l*28|0)+16>>2]|0)){x=r;break a}else o=r}}else x=m;while(0);l=l+1|0;if((l|0)>=(f[h>>2]|0))break;else m=x}u=e;return}function b9b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+48|0;d=c+24|0;e=c;g=a+4|0;h=f[g>>2]|0;i=f[h+44>>2]|0;if((i|0)==(a|0)|(i|0)==0)j=h;else{rTb(e,3,493156,550);oTb(c+40|0,mTb(e,493250)|0);sTb(e);j=f[g>>2]|0}e=f[j+20>>2]|0;h=f[j+28>>2]|0;i=h+52|0;if((f[i>>2]|0)<=0){u=c;return}k=h+20|0;h=d+4|0;l=d+8|0;m=d+12|0;n=0;o=j;while(1){j=f[k>>2]|0;p=j+(n*88|0)|0;q=a+(f[(f[o+32>>2]|0)+(n<<2)>>2]|0)|0;r=f[j+(n*88|0)+24>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[d>>2]=78728;f[h>>2]=1737;b[l>>0]=0;f[m>>2]=p;DTb(r,d)}if((f[161216+(f[j+(n*88|0)+28>>2]<<2)>>2]|0)==10?(f[j+(n*88|0)+32>>2]|0)!=3:0){j=_8b(e,DYb(p)|0)|0;f[q>>2]=j}j=n+1|0;if((j|0)>=(f[i>>2]|0))break;n=j;o=f[g>>2]|0}u=c;return}function c9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0;e=f[d+8>>2]|0;g=d+4|0;f[g>>2]=e;h=c+4|0;i=f[h>>2]|0;j=(i|0)==0;k=e;a:do if(!j){l=i+-1|0;m=(l&i|0)==0;if(!m)if(e>>>0<i>>>0)o=e;else o=(e>>>0)%(i>>>0)|0;else o=l&e;p=f[(f[c>>2]|0)+(o<<2)>>2]|0;if(!p)q=o;else{if(m){m=p;while(1){r=f[m>>2]|0;if(!r){q=o;break a}if((f[r+4>>2]&l|0)!=(o|0)){q=o;break a}if((f[r+8>>2]|0)==(k|0)){s=0;t=r;break}else m=r}u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}else w=p;while(1){m=f[w>>2]|0;if(!m){q=o;break a}l=f[m+4>>2]|0;if(l>>>0<i>>>0)x=l;else x=(l>>>0)%(i>>>0)|0;if((x|0)!=(o|0)){q=o;break a}if((f[m+8>>2]|0)==(k|0)){s=0;t=m;break}else w=m}u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}}else q=0;while(0);w=c+12|0;y=+(((f[w>>2]|0)+1|0)>>>0);z=+n[c+16>>2];do if(j|y>+(i>>>0)*z){k=(i>>>0<3|(i+-1&i|0)!=0)&1|i<<1;o=~~+X(+(y/z))>>>0;d9b(c,k>>>0<o>>>0?o:k);k=f[h>>2]|0;o=f[g>>2]|0;x=k+-1|0;if(!(x&k)){A=k;B=x&o;break}if(o>>>0<k>>>0){A=k;B=o}else{A=k;B=(o>>>0)%(k>>>0)|0}}else{A=i;B=q}while(0);q=f[(f[c>>2]|0)+(B<<2)>>2]|0;if(!q){i=c+8|0;f[d>>2]=f[i>>2];f[i>>2]=d;f[(f[c>>2]|0)+(B<<2)>>2]=i;i=f[d>>2]|0;if(!i)C=d;else{B=f[i+4>>2]|0;i=A+-1|0;if(i&A)if(B>>>0<A>>>0)D=B;else D=(B>>>0)%(A>>>0)|0;else D=B&i;f[(f[c>>2]|0)+(D<<2)>>2]=d;C=d}}else{f[d>>2]=f[q>>2];f[q>>2]=d;C=d}f[w>>2]=(f[w>>2]|0)+1;s=1;t=C;u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}function d9b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){e9b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;e9b(a,d);return}function e9b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if((f[o>>2]|0)==(f[u+8>>2]|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if((f[w>>2]|0)==(f[z+8>>2]|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function f9b(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=166636;b=a+12|0;c=f[(f[b>>2]|0)+8>>2]|0;if(c|0){d=c;do{c=d+12|0;i9b(f[(f[c>>2]|0)+28>>2]|0,0,0);e=f[c>>2]|0;if(e|0){j9b(e);YDc(e)}d=f[d>>2]|0}while((d|0)!=0)}uTb(a+16|0);a=f[b>>2]|0;if(!a)return;b=f[a+8>>2]|0;if(b|0){d=b;do{b=d;d=f[d>>2]|0;YDc(b)}while((d|0)!=0)}d=f[a>>2]|0;f[a>>2]=0;if(d|0)YDc(d);YDc(a);return}function g9b(a){a=a|0;f9b(a);YDc(a);return}function h9b(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+16|0;dTb(c);d=_8b(a,b)|0;eTb(c);return d|0}function i9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;c=d;e=a+56|0;if((f[e>>2]|0)<=0){u=d;return}g=a+24|0;a=c+4|0;h=c+8|0;i=c+12|0;j=0;k=f[g>>2]|0;while(1){if((f[k+(j*28|0)+16>>2]|0)>0){l=0;m=k;while(1){n=f[(f[m+(j*28|0)+20>>2]|0)+(l<<2)>>2]|0;o=f[n+24>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[c>>2]=78728;f[a>>2]=1737;b[h>>0]=0;f[i>>2]=n;DTb(o,c)}l=l+1|0;o=f[g>>2]|0;if((l|0)>=(f[o+(j*28|0)+16>>2]|0)){p=o;break}else m=o}}else p=k;j=j+1|0;if((j|0)>=(f[e>>2]|0))break;else k=p}u=d;return}function j9b(a){a=a|0;var b=0;b=f[a+44>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+40>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+36>>2]|0;if(b|0)ZDc(b);b=f[a+32>>2]|0;if(!b)return;ZDc(b);return}function k9b(a){a=a|0;var c=0;f[a>>2]=166636;f[a+4>>2]=0;b[a+8>>0]=0;c=VDc(20)|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;n[c+16>>2]=1.0;f[a+12>>2]=c;tTb(a+16|0);return}function l9b(a){a=a|0;YDc(a);return}function m9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+40|0;j=oYb(f[a+4>>2]|0,f[a+12>>2]|0,c)|0;if(!j){k=0;u=e;return k|0}c=j+24|0;l=f[c>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=j;DTb(l,g)}l=j+28|0;b[d>>0]=f[l>>2];b[d+1>>0]=(f[j+32>>2]|0)==3&1;b[d+2>>0]=b[(f[j+68>>2]|0)+52>>0]|0;f[d+12>>2]=j;m=f[c>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=j;DTb(m,g)}if((f[161216+(f[l>>2]<<2)>>2]|0)==10){m=f[a+8>>2]|0;a=f[(f[m>>2]|0)+8>>2]|0;n=DYb(j)|0;o=Mi[a&1023](m,n)|0;f[d+4>>2]=o;if(o|0){k=1;u=e;return k|0}rTb(h,3,493358,303);o=mTb(mTb(h,493456)|0,493506)|0;oTb(i,nTb(o,f[j+4>>2]|0)|0);sTb(h);k=1;u=e;return k|0}h=f[c>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=j;DTb(h,g)}if((f[161216+(f[l>>2]<<2)>>2]|0)!=8){k=1;u=e;return k|0}f[d+4>>2]=546;l=EYb(j)|0;f[d+8>>2]=l;k=1;u=e;return k|0}function n9b(a,b){a=a|0;b=b|0;return (wYb(a,b)|0)!=0|0}function o9b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;j=a+4|0;if((i|0)==(j|0)){u=g;return}a=e+4|0;k=e+8|0;l=i;while(1){i=l+16|0;if(!(b[i+17>>0]|0)){if(!(b[i+18>>0]&1))m=7}else if((qkc(l+24|0)|0)>0)m=7;do if((m|0)==7){m=0;n=l+40|0;o=f[n>>2]|0;p=o;if(o|0){o=f[a>>2]|0;if((o|0)==(f[k>>2]|0)){jWb(e,n);break}else{f[o>>2]=p;f[a>>2]=(f[a>>2]|0)+4;break}}p=oYb(d,c,f[i>>2]|0)|0;f[h>>2]=p;o=f[a>>2]|0;if((o|0)==(f[k>>2]|0))jWb(e,h);else{f[o>>2]=p;f[a>>2]=(f[a>>2]|0)+4}}while(0);i=f[l+4>>2]|0;if(!i){p=l+8|0;o=f[p>>2]|0;if((f[o>>2]|0)==(l|0))q=o;else{o=p;do{p=f[o>>2]|0;o=p+8|0;n=f[o>>2]|0}while((f[n>>2]|0)!=(p|0));q=n}}else{o=i;while(1){n=f[o>>2]|0;if(!n)break;else o=n}q=o}if((q|0)==(j|0))break;else l=q}u=g;return}function p9b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=a+4|0;a=f[g>>2]|0;if(a|0){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(c=b[g+18>>0]|0,(c&1)==0):0){g=f[k+24>>2]|0;if(!(c&16)){l=g;return l|0}c=f[(f[g>>2]|0)+12>>2]|0;k=Mi[f[(f[e>>2]|0)+8>>2]&1023](e,d)|0;l=Mi[c&1023](g,k)|0;return l|0}}l=Mi[f[(f[e>>2]|0)+8>>2]&1023](e,d)|0;return l|0}function q9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+8|0;h=e;if(!(vkc(a,f[c+40>>2]|0,c,h)|0)){i=f[h>>2]|0;j=i+10|0;k=b[j>>0]|0;b[j>>0]=k&-16;j=f[i>>2]|0;if(!(k&16)){l=j;u=e;return l|0}k=f[(f[j>>2]|0)+16>>2]|0;i=f[(f[d>>2]|0)+8>>2]|0;m=DYb(c)|0;n=Mi[i&1023](d,m)|0;l=Mi[k&1023](j,n)|0;u=e;return l|0}n=f[c+24>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(n,g)}g=f[h>>2]|0;b[g+8>>0]=f[c+28>>2];b[g+9>>0]=0;b[g+11>>0]=0;g=f[(f[d>>2]|0)+8>>2]|0;n=DYb(c)|0;c=Mi[g&1023](d,n)|0;n=(f[h>>2]|0)+10|0;b[n>>0]=b[n>>0]&15;n=Mi[f[(f[c>>2]|0)+16>>2]&1023](c,f[a+12>>2]|0)|0;f[f[h>>2]>>2]=n;n=f[h>>2]|0;h=n+10|0;b[h>>0]=b[h>>0]&-16;l=f[n>>2]|0;u=e;return l|0}function r9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=c+40|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;if(!i){j=0;return j|0}else{k=h;l=i}a:while(1){i=l;while(1){if((f[i+16>>2]|0)>=(g|0))break;m=f[i+4>>2]|0;if(!m){n=k;break a}else i=m}l=f[i>>2]|0;if(!l){n=i;break}else k=i}if((n|0)==(h|0)){j=0;return j|0}k=n+16|0;if((g|0)<(f[k>>2]|0)){j=0;return j|0}g=n+24|0;n=f[g>>2]|0;if(b[k+18>>0]&16){k=f[(f[n>>2]|0)+32>>2]|0;l=f[(f[d>>2]|0)+8>>2]|0;m=DYb(c)|0;c=Mi[l&1023](d,m)|0;m=Mi[k&1023](n,c)|0;if((f[a+12>>2]|0)==0?(c=f[g>>2]|0,(c|0)!=0):0){Yi[f[(f[c>>2]|0)+4>>2]&2047](c);o=m}else o=m}else o=n;n=f[e>>2]|0;e=f[h>>2]|0;if(!e){j=o;return j|0}else{p=h;q=e}b:while(1){m=q;while(1){if((f[m+16>>2]|0)>=(n|0))break;c=f[m+4>>2]|0;if(!c){r=p;break b}else m=c}q=f[m>>2]|0;if(!q){r=m;break}else p=m}if((r|0)==(h|0)){j=o;return j|0}if((n|0)<(f[r+16>>2]|0)){j=o;return j|0}n=f[r+4>>2]|0;if(!n){h=r+8|0;p=f[h>>2]|0;if((f[p>>2]|0)==(r|0))s=p;else{p=h;do{h=f[p>>2]|0;p=h+8|0;q=f[p>>2]|0}while((f[q>>2]|0)!=(h|0));s=q}}else{p=n;while(1){n=f[p>>2]|0;if(!n)break;else p=n}s=p}if((f[a>>2]|0)==(r|0))f[a>>2]=s;s=a+8|0;f[s>>2]=(f[s>>2]|0)+-1;uHa(e,r);YDc(r);j=o;return j|0}function s9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+8|0;g=d;if(!(vkc(a,f[c+40>>2]|0,c,g)|0)){h=f[g>>2]|0;u=d;return h|0}i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=78728;f[e+4>>2]=1737;b[e+8>>0]=0;f[e+12>>2]=c;DTb(i,e)}e=f[g>>2]|0;b[e+8>>0]=f[c+28>>2];b[e+9>>0]=1;c=f[a+12>>2]|0;if(!c){a=VDc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;j=a;k=e}else{if(f[c+64>>2]|0)OQb(c,20856,16);e=NQb(c,16,1779)|0;f[e>>2]=c;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;j=e;k=f[g>>2]|0}f[k>>2]=j;h=f[g>>2]|0;u=d;return h|0}function t9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;YDc(g);f[b>>2]=0;return}function u9b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=s9b(a,b)|0;i=f[h>>2]|0;j=f[i+12>>2]|0;if((j|0?(k=i+4|0,l=f[k>>2]|0,(l|0)<(f[j>>2]|0)):0)?(f[k>>2]=l+1,k=f[j+4+(l<<2)>>2]|0,k|0):0){m=k;u=d;return m|0}if(!(f[i+4>>2]|0)){k=f[(f[c>>2]|0)+8>>2]|0;l=DYb(b)|0;b=Mi[k&1023](c,l)|0;if(!b){rTb(e,3,493358,268);oTb(g,mTb(e,493687)|0);sTb(e);n=b}else n=b}else n=f[(f[i+12>>2]|0)+4>>2]|0;i=Mi[f[(f[n>>2]|0)+16>>2]&1023](n,f[a+12>>2]|0)|0;v9b(f[h>>2]|0,i);m=i;u=d;return m|0}function v9b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+12|0;d=f[c>>2]|0;do if(d){e=f[d>>2]|0;g=f[a+8>>2]|0;h=a+4|0;i=f[h>>2]|0;if((e|0)<(g|0)){if((i|0)<(e|0)){j=d+4+(i<<2)|0;f[d+4+(e<<2)>>2]=f[j>>2];k=j}else k=d+4+(i<<2)|0;f[k>>2]=b;f[h>>2]=i+1;j=f[c>>2]|0;f[j>>2]=(f[j>>2]|0)+1;return}if((i|0)==(g|0)){l=h;m=g;n=9}else{if((e|0)==(g|0)){g=f[d+4+(i<<2)>>2]|0;if((g|0)==0|(f[a>>2]|0)!=0){o=h;p=d;break}Yi[f[(f[g>>2]|0)+4>>2]&2047](g);o=h;p=f[c>>2]|0;break}if((i|0)<(e|0)){f[d+4+(e<<2)>>2]=f[d+4+(i<<2)>>2];i=f[c>>2]|0;q=i;r=f[i>>2]|0}else{q=d;r=e}f[q>>2]=r+1;o=h;p=q}}else{l=a+4|0;m=f[a+8>>2]|0;n=9}while(0);if((n|0)==9){USb(a,m+1|0);m=f[c>>2]|0;f[m>>2]=(f[m>>2]|0)+1;o=l;p=m}m=f[o>>2]|0;f[o>>2]=m+1;f[p+4+(m<<2)>>2]=b;return}function w9b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=s9b(a,b)|0;v9b(f[d>>2]|0,c);return}function x9b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;h=g+24|0;i=g+16|0;j=g;f[i>>2]=168332;f[i+4>>2]=e;e=f[c+52>>2]|0;if(!e){f[h>>2]=168360;f[h+4>>2]=d;k=Jlc(a,b,c,h,i)|0;u=g;return k|0}else{l=f[c+56>>2]|0;mi[f[(f[d>>2]|0)+96>>2]&2047](h,d);d=f[h>>2]|0;f[j>>2]=166656;f[j+4>>2]=e;f[j+8>>2]=l;f[j+12>>2]=d;k=Jlc(a,b,c,j,i)|0;u=g;return k|0}return 0}function y9b(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[161216+(h[a+8>>0]<<2)>>2]|0;if(!(b[a+9>>0]|0))switch(c|0){case 9:{d=(RQb(f[a>>2]|0)|0)+12|0;return d|0}case 10:{if(!(b[a+10>>0]&16)){e=f[a>>2]|0;d=_i[f[(f[e>>2]|0)+84>>2]&1023](e)|0;return d|0}else{e=f[a>>2]|0;d=_i[f[(f[e>>2]|0)+44>>2]&1023](e)|0;return d|0}break}default:{d=0;return d|0}}do switch(c|0){case 1:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 2:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 3:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 4:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 6:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 5:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 7:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]|0)+16|0;return d|0}case 8:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 9:{e=f[a>>2]|0;g=f[e+8>>2]<<2;i=e+12|0;e=f[i>>2]|0;if(!e)j=g;else{if((f[e>>2]|0)>0){k=0;l=g;m=e;while(1){e=l+12+(RQb(f[m+4+(k<<2)>>2]|0)|0)|0;k=k+1|0;m=f[i>>2]|0;if((k|0)>=(f[m>>2]|0)){n=e;break}else l=e}}else n=g;j=n+4|0}d=j+16|0;return d|0}case 10:{l=f[a>>2]|0;m=f[l+8>>2]<<2;k=l+12|0;l=f[k>>2]|0;if(!l)o=m;else{if((f[l>>2]|0)>0){i=0;e=m;p=l;while(1){l=f[p+4+(i<<2)>>2]|0;q=(_i[f[(f[l>>2]|0)+84>>2]&1023](l)|0)+e|0;i=i+1|0;p=f[k>>2]|0;if((i|0)>=(f[p>>2]|0)){r=q;break}else e=q}}else r=m;o=r+4|0}d=o+16|0;return d|0}default:{d=0;return d|0}}while(0);return 0}function z9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+8>>2]<<5;c=f[a>>2]|0;d=a+4|0;if((c|0)==(d|0)){e=b;return e|0}else{g=b;h=c}while(1){c=(y9b(h+24|0)|0)+g|0;b=f[h+4>>2]|0;if(!b){a=h+8|0;i=f[a>>2]|0;if((f[i>>2]|0)==(h|0))j=i;else{i=a;do{a=f[i>>2]|0;i=a+8|0;k=f[i>>2]|0}while((f[k>>2]|0)!=(a|0));j=k}}else{i=b;while(1){k=f[i>>2]|0;if(!k)break;else i=k}j=i}if((j|0)==(d|0)){e=c;break}else{g=c;h=j}}return e|0}function A9b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0;g=u;u=u+32|0;h=g;i=g+24|0;if(!(b[a+9>>0]|0)){j=b[a+10>>0]|0;if(j&1){k=e;u=g;return k|0}do switch(b[a+8>>0]|0){case 5:{l=f[a>>2]|0;m=c<<3;if(m>>>0>127){n=m;o=e;while(1){b[o>>0]=n|128;q=n>>>7;r=o+1|0;if(n>>>0>16383){n=q;o=r}else{t=r;v=q;break}}}else{t=e;v=m}b[t>>0]=v;o=t+1|0;n=l&255;if(l>>>0>127){q=o;r=n;w=l;x=((l|0)<0)<<31>>31;while(1){b[q>>0]=r|-128;y=w;w=aJc(w|0,x|0,7)|0;z=q+1|0;A=w&255;if(!(x>>>0>0|(x|0)==0&y>>>0>16383)){B=z;C=A;break}else{q=z;r=A;x=J}}}else{B=o;C=n}b[B>>0]=C;k=B+1|0;u=g;return k|0}case 3:{x=a;r=f[x>>2]|0;q=f[x+4>>2]|0;x=c<<3;if(x>>>0>127){w=x;l=e;while(1){b[l>>0]=w|128;m=w>>>7;A=l+1|0;if(w>>>0>16383){w=m;l=A}else{D=A;E=m;break}}}else{D=e;E=x}b[D>>0]=E;l=D+1|0;w=r&255;if(q>>>0>0|(q|0)==0&r>>>0>127){n=l;o=w;m=r;A=q;while(1){b[n>>0]=o|-128;z=m;m=aJc(m|0,A|0,7)|0;y=n+1|0;F=m&255;if(!(A>>>0>0|(A|0)==0&z>>>0>16383)){G=y;H=F;break}else{n=y;o=F;A=J}}}else{G=l;H=w}b[G>>0]=H;k=G+1|0;u=g;return k|0}case 13:{A=f[a>>2]|0;o=c<<3;if(o>>>0>127){n=o;m=e;while(1){b[m>>0]=n|128;q=n>>>7;r=m+1|0;if(n>>>0>16383){n=q;m=r}else{I=r;K=q;break}}}else{I=e;K=o}b[I>>0]=K;m=I+1|0;if(A>>>0>127){n=A;w=m;while(1){b[w>>0]=n|128;l=n>>>7;q=w+1|0;if(n>>>0>16383){n=l;w=q}else{L=q;M=l;break}}}else{L=m;M=A}b[L>>0]=M;k=L+1|0;u=g;return k|0}case 4:{w=a;n=f[w>>2]|0;o=f[w+4>>2]|0;w=c<<3;if(w>>>0>127){l=w;q=e;while(1){b[q>>0]=l|128;r=l>>>7;x=q+1|0;if(l>>>0>16383){l=r;q=x}else{N=x;O=r;break}}}else{N=e;O=w}b[N>>0]=O;q=N+1|0;l=n&255;if(o>>>0>0|(o|0)==0&n>>>0>127){A=q;m=l;r=n;x=o;while(1){b[A>>0]=m|-128;F=r;r=aJc(r|0,x|0,7)|0;y=A+1|0;z=r&255;if(!(x>>>0>0|(x|0)==0&F>>>0>16383)){P=y;Q=z;break}else{A=y;m=z;x=J}}}else{P=q;Q=l}b[P>>0]=Q;k=P+1|0;u=g;return k|0}case 17:{x=f[a>>2]|0;m=c<<3;if(m>>>0>127){A=m;r=e;while(1){b[r>>0]=A|128;o=A>>>7;n=r+1|0;if(A>>>0>16383){A=o;r=n}else{R=n;S=o;break}}}else{R=e;S=m}b[R>>0]=S;r=R+1|0;A=x<<1^x>>31;if(A>>>0>127){l=A;q=r;while(1){b[q>>0]=l|128;o=l>>>7;n=q+1|0;if(l>>>0>16383){l=o;q=n}else{T=n;U=o;break}}}else{T=r;U=A}b[T>>0]=U;k=T+1|0;u=g;return k|0}case 18:{q=a;l=f[q>>2]|0;x=f[q+4>>2]|0;q=c<<3;if(q>>>0>127){m=q;o=e;while(1){b[o>>0]=m|128;n=m>>>7;w=o+1|0;if(m>>>0>16383){m=n;o=w}else{V=w;W=n;break}}}else{V=e;W=q}b[V>>0]=W;o=V+1|0;m=jJc(l|0,x|0,1)|0;A=J;r=$Ic(l|0,x|0,63)|0;n=m^r;r=A^J;A=n&255;if(r>>>0>0|(r|0)==0&n>>>0>127){m=o;w=A;z=n;n=r;while(1){b[m>>0]=w|-128;r=z;z=aJc(z|0,n|0,7)|0;y=m+1|0;F=z&255;if(!(n>>>0>0|(n|0)==0&r>>>0>16383)){X=y;Y=F;break}else{m=y;w=F;n=J}}}else{X=o;Y=A}b[X>>0]=Y;k=X+1|0;u=g;return k|0}case 7:{n=f[a>>2]|0;w=c<<3|5;if(w>>>0>127){m=w;z=e;while(1){b[z>>0]=m|128;x=m>>>7;l=z+1|0;if(m>>>0>16383){m=x;z=l}else{Z=l;_=x;break}}}else{Z=e;_=w}b[Z>>0]=_;z=Z+1|0;b[z>>0]=n;b[z+1>>0]=n>>8;b[z+2>>0]=n>>16;b[z+3>>0]=n>>24;k=Z+5|0;u=g;return k|0}case 6:{z=a;m=f[z>>2]|0;A=f[z+4>>2]|0;z=c<<3|1;if(z>>>0>127){o=z;x=e;while(1){b[x>>0]=o|128;l=o>>>7;q=x+1|0;if(o>>>0>16383){o=l;x=q}else{$=q;aa=l;break}}}else{$=e;aa=z}b[$>>0]=aa;x=$+1|0;o=x;b[o>>0]=m;b[o+1>>0]=m>>8;b[o+2>>0]=m>>16;b[o+3>>0]=m>>24;o=x+4|0;b[o>>0]=A;b[o+1>>0]=A>>8;b[o+2>>0]=A>>16;b[o+3>>0]=A>>24;k=$+9|0;u=g;return k|0}case 15:{o=f[a>>2]|0;x=c<<3|5;if(x>>>0>127){n=x;w=e;while(1){b[w>>0]=n|128;l=n>>>7;q=w+1|0;if(n>>>0>16383){n=l;w=q}else{ba=q;ca=l;break}}}else{ba=e;ca=x}b[ba>>0]=ca;w=ba+1|0;b[w>>0]=o;b[w+1>>0]=o>>8;b[w+2>>0]=o>>16;b[w+3>>0]=o>>24;k=ba+5|0;u=g;return k|0}case 16:{w=a;n=f[w>>2]|0;A=f[w+4>>2]|0;w=c<<3|1;if(w>>>0>127){m=w;z=e;while(1){b[z>>0]=m|128;l=m>>>7;q=z+1|0;if(m>>>0>16383){m=l;z=q}else{da=q;ea=l;break}}}else{da=e;ea=w}b[da>>0]=ea;z=da+1|0;m=z;b[m>>0]=n;b[m+1>>0]=n>>8;b[m+2>>0]=n>>16;b[m+3>>0]=n>>24;m=z+4|0;b[m>>0]=A;b[m+1>>0]=A>>8;b[m+2>>0]=A>>16;b[m+3>>0]=A>>24;k=da+9|0;u=g;return k|0}case 2:{m=f[a>>2]|0;z=c<<3|5;if(z>>>0>127){o=z;x=e;while(1){b[x>>0]=o|128;l=o>>>7;q=x+1|0;if(o>>>0>16383){o=l;x=q}else{fa=q;ga=l;break}}}else{fa=e;ga=z}b[fa>>0]=ga;x=fa+1|0;b[x>>0]=m;b[x+1>>0]=m>>8;b[x+2>>0]=m>>16;b[x+3>>0]=m>>24;k=fa+5|0;u=g;return k|0}case 1:{ha=+p[a>>3];x=c<<3|1;if(x>>>0>127){o=x;A=e;while(1){b[A>>0]=o|128;n=o>>>7;w=A+1|0;if(o>>>0>16383){o=n;A=w}else{ia=w;ja=n;break}}}else{ia=e;ja=x}b[ia>>0]=ja;A=ia+1|0;p[s>>3]=ha;b[A>>0]=b[s>>0];b[A+1>>0]=b[s+1>>0];b[A+2>>0]=b[s+2>>0];b[A+3>>0]=b[s+3>>0];b[A+4>>0]=b[s+4>>0];b[A+5>>0]=b[s+5>>0];b[A+6>>0]=b[s+6>>0];b[A+7>>0]=b[s+7>>0];k=ia+9|0;u=g;return k|0}case 8:{A=b[a>>0]|0;o=c<<3;if(o>>>0>127){m=o;z=e;while(1){b[z>>0]=m|128;n=m>>>7;w=z+1|0;if(m>>>0>16383){m=n;z=w}else{ka=w;la=n;break}}}else{ka=e;la=o}b[ka>>0]=la;b[ka+1>>0]=A;k=ka+2|0;u=g;return k|0}case 9:{z=f[a>>2]|0;m=c<<3|2;if(m>>>0>127){x=m;n=e;while(1){b[n>>0]=x|128;w=x>>>7;l=n+1|0;if(x>>>0>16383){x=w;n=l}else{ma=l;na=w;break}}}else{ma=e;na=m}b[ma>>0]=na;k=dSb(z,ma+1|0)|0;u=g;return k|0}case 12:{n=f[a>>2]|0;x=c<<3|2;if(x>>>0>127){A=x;o=e;while(1){b[o>>0]=A|128;w=A>>>7;l=o+1|0;if(A>>>0>16383){A=w;o=l}else{oa=l;pa=w;break}}}else{oa=e;pa=x}b[oa>>0]=pa;k=dSb(n,oa+1|0)|0;u=g;return k|0}case 14:{o=f[a>>2]|0;A=c<<3;if(A>>>0>127){z=A;m=e;while(1){b[m>>0]=z|128;w=z>>>7;l=m+1|0;if(z>>>0>16383){z=w;m=l}else{qa=l;ra=w;break}}}else{qa=e;ra=A}b[qa>>0]=ra;m=qa+1|0;z=o&255;if(o>>>0>127){n=m;x=z;w=o;l=((o|0)<0)<<31>>31;while(1){b[n>>0]=x|-128;q=w;w=aJc(w|0,l|0,7)|0;F=n+1|0;y=w&255;if(!(l>>>0>0|(l|0)==0&q>>>0>16383)){sa=F;ta=y;break}else{n=F;x=y;l=J}}}else{sa=m;ta=z}b[sa>>0]=ta;k=sa+1|0;u=g;return k|0}case 10:{l=f[a>>2]|0;x=c<<3;n=x|3;if(n>>>0>127){w=n;o=e;while(1){b[o>>0]=w|128;A=w>>>7;y=o+1|0;if(w>>>0>16383){w=A;o=y}else{ua=y;va=A;break}}}else{ua=e;va=n}b[ua>>0]=va;o=hj[f[(f[l>>2]|0)+64>>2]&511](l,0,ua+1|0)|0;w=x|4;if(w>>>0>127){z=w;m=o;while(1){b[m>>0]=z|128;A=z>>>7;y=m+1|0;if(z>>>0>16383){z=A;m=y}else{wa=y;xa=A;break}}}else{wa=o;xa=w}b[wa>>0]=xa;k=wa+1|0;u=g;return k|0}case 11:{m=f[a>>2]|0;if(j&16){k=hh[f[(f[m>>2]|0)+68>>2]&127](m,c,d,e)|0;u=g;return k|0}z=c<<3|2;if(z>>>0>127){x=z;l=e;while(1){b[l>>0]=x|128;n=x>>>7;A=l+1|0;if(x>>>0>16383){x=n;l=A}else{ya=A;za=n;break}}}else{ya=e;za=z}b[ya>>0]=za;l=ya+1|0;x=_i[f[(f[m>>2]|0)+60>>2]&1023](m)|0;if(x>>>0>127){w=x;o=l;while(1){b[o>>0]=w|128;n=w>>>7;A=o+1|0;if(w>>>0>16383){w=n;o=A}else{Aa=A;Ba=n;break}}}else{Aa=l;Ba=x}b[Aa>>0]=Ba;k=hj[f[(f[m>>2]|0)+64>>2]&511](m,d,Aa+1|0)|0;u=g;return k|0}default:{k=e;u=g;return k|0}}while(0)}if(b[a+11>>0]|0){Aa=a+12|0;if(!(f[Aa>>2]|0)){k=e;u=g;return k|0}Ba=c<<3|2;if(Ba>>>0>127){ya=Ba;za=e;while(1){b[za>>0]=ya|128;j=ya>>>7;wa=za+1|0;if(ya>>>0>16383){ya=j;za=wa}else{Ca=wa;Da=j;break}}}else{Ca=e;Da=Ba}b[Ca>>0]=Da;Da=Ca+1|0;Ca=f[Aa>>2]|0;Aa=Ca&255;if(Ca>>>0>127){Ba=Da;za=Aa;ya=Ca;j=((Ca|0)<0)<<31>>31;while(1){b[Ba>>0]=za|-128;Ca=ya;ya=aJc(ya|0,j|0,7)|0;wa=Ba+1|0;xa=ya&255;if(!(j>>>0>0|(j|0)==0&Ca>>>0>16383)){Ea=wa;Fa=xa;break}else{Ba=wa;za=xa;j=J}}}else{Ea=Da;Fa=Aa}b[Ea>>0]=Fa;Fa=Ea+1|0;do switch(b[a+8>>0]|0){case 5:{Ea=f[a>>2]|0;if((f[Ea>>2]|0)>0){Ga=Fa;Ha=0;Ia=Ea}else{k=Fa;u=g;return k|0}while(1){Ea=f[(f[Ia+8>>2]|0)+4+(Ha<<2)>>2]|0;Aa=Ea&255;if(Ea>>>0>127){Da=Ga;j=((Ea|0)<0)<<31>>31;za=Aa;Ba=Ea;while(1){b[Da>>0]=za|-128;Ea=Ba;Ba=aJc(Ba|0,j|0,7)|0;ya=Da+1|0;xa=Ba&255;if(!(j>>>0>0|(j|0)==0&Ea>>>0>16383)){Ja=ya;Ka=xa;break}else{Da=ya;j=J;za=xa}}}else{Ja=Ga;Ka=Aa}b[Ja>>0]=Ka;za=Ja+1|0;Ha=Ha+1|0;Ia=f[a>>2]|0;if((Ha|0)>=(f[Ia>>2]|0)){k=za;break}else Ga=za}u=g;return k|0}case 3:{m=f[a>>2]|0;if((f[m>>2]|0)>0){La=0;Ma=Fa;Na=m}else{k=Fa;u=g;return k|0}while(1){m=(f[Na+8>>2]|0)+8+(La<<3)|0;x=f[m>>2]|0;l=f[m+4>>2]|0;m=x&255;if(l>>>0>0|(l|0)==0&x>>>0>127){za=Ma;j=m;Da=x;x=l;while(1){b[za>>0]=j|-128;l=Da;Da=aJc(Da|0,x|0,7)|0;Ba=za+1|0;xa=Da&255;if(!(x>>>0>0|(x|0)==0&l>>>0>16383)){Oa=Ba;Pa=xa;break}else{za=Ba;j=xa;x=J}}}else{Oa=Ma;Pa=m}b[Oa>>0]=Pa;x=Oa+1|0;La=La+1|0;Na=f[a>>2]|0;if((La|0)>=(f[Na>>2]|0)){k=x;break}else Ma=x}u=g;return k|0}case 13:{x=f[a>>2]|0;if((f[x>>2]|0)>0){Qa=0;Ra=Fa;Sa=x}else{k=Fa;u=g;return k|0}while(1){x=f[(f[Sa+8>>2]|0)+4+(Qa<<2)>>2]|0;if(x>>>0>127){j=x;za=Ra;while(1){b[za>>0]=j|128;Da=j>>>7;Aa=za+1|0;if(j>>>0>16383){j=Da;za=Aa}else{Ta=Aa;Ua=Da;break}}}else{Ta=Ra;Ua=x}b[Ta>>0]=Ua;za=Ta+1|0;Qa=Qa+1|0;Sa=f[a>>2]|0;if((Qa|0)>=(f[Sa>>2]|0)){k=za;break}else Ra=za}u=g;return k|0}case 4:{za=f[a>>2]|0;if((f[za>>2]|0)>0){Va=0;Wa=Fa;Xa=za}else{k=Fa;u=g;return k|0}while(1){za=(f[Xa+8>>2]|0)+8+(Va<<3)|0;j=f[za>>2]|0;m=f[za+4>>2]|0;za=j&255;if(m>>>0>0|(m|0)==0&j>>>0>127){Da=Wa;Aa=za;xa=j;j=m;while(1){b[Da>>0]=Aa|-128;m=xa;xa=aJc(xa|0,j|0,7)|0;Ba=Da+1|0;l=xa&255;if(!(j>>>0>0|(j|0)==0&m>>>0>16383)){Ya=Ba;Za=l;break}else{Da=Ba;Aa=l;j=J}}}else{Ya=Wa;Za=za}b[Ya>>0]=Za;j=Ya+1|0;Va=Va+1|0;Xa=f[a>>2]|0;if((Va|0)>=(f[Xa>>2]|0)){k=j;break}else Wa=j}u=g;return k|0}case 17:{j=f[a>>2]|0;if((f[j>>2]|0)>0){_a=0;$a=Fa;ab=j}else{k=Fa;u=g;return k|0}while(1){j=f[(f[ab+8>>2]|0)+4+(_a<<2)>>2]|0;Aa=j<<1^j>>31;if(Aa>>>0>127){j=Aa;Da=$a;while(1){b[Da>>0]=j|128;xa=j>>>7;x=Da+1|0;if(j>>>0>16383){j=xa;Da=x}else{bb=x;cb=xa;break}}}else{bb=$a;cb=Aa}b[bb>>0]=cb;Da=bb+1|0;_a=_a+1|0;ab=f[a>>2]|0;if((_a|0)>=(f[ab>>2]|0)){k=Da;break}else $a=Da}u=g;return k|0}case 18:{Da=f[a>>2]|0;if((f[Da>>2]|0)>0){db=0;eb=Fa;fb=Da}else{k=Fa;u=g;return k|0}while(1){Da=(f[fb+8>>2]|0)+8+(db<<3)|0;j=f[Da>>2]|0;za=f[Da+4>>2]|0;Da=jJc(j|0,za|0,1)|0;xa=J;x=$Ic(j|0,za|0,63)|0;za=Da^x;x=xa^J;xa=za&255;if(x>>>0>0|(x|0)==0&za>>>0>127){Da=eb;j=xa;l=za;za=x;while(1){b[Da>>0]=j|-128;x=l;l=aJc(l|0,za|0,7)|0;Ba=Da+1|0;m=l&255;if(!(za>>>0>0|(za|0)==0&x>>>0>16383)){gb=Ba;hb=m;break}else{Da=Ba;j=m;za=J}}}else{gb=eb;hb=xa}b[gb>>0]=hb;za=gb+1|0;db=db+1|0;fb=f[a>>2]|0;if((db|0)>=(f[fb>>2]|0)){k=za;break}else eb=za}u=g;return k|0}case 7:{za=f[a>>2]|0;if((f[za>>2]|0)>0){ib=0;jb=Fa;kb=za}else{k=Fa;u=g;return k|0}while(1){za=f[(f[kb+8>>2]|0)+4+(ib<<2)>>2]|0;b[jb>>0]=za;b[jb+1>>0]=za>>8;b[jb+2>>0]=za>>16;b[jb+3>>0]=za>>24;za=jb+4|0;ib=ib+1|0;kb=f[a>>2]|0;if((ib|0)>=(f[kb>>2]|0)){k=za;break}else jb=za}u=g;return k|0}case 6:{za=f[a>>2]|0;if((f[za>>2]|0)>0){lb=0;mb=Fa;nb=za}else{k=Fa;u=g;return k|0}while(1){za=(f[nb+8>>2]|0)+8+(lb<<3)|0;j=f[za>>2]|0;Da=f[za+4>>2]|0;za=mb;l=za;b[l>>0]=j;b[l+1>>0]=j>>8;b[l+2>>0]=j>>16;b[l+3>>0]=j>>24;j=za+4|0;b[j>>0]=Da;b[j+1>>0]=Da>>8;b[j+2>>0]=Da>>16;b[j+3>>0]=Da>>24;Da=mb+8|0;lb=lb+1|0;nb=f[a>>2]|0;if((lb|0)>=(f[nb>>2]|0)){k=Da;break}else mb=Da}u=g;return k|0}case 15:{Da=f[a>>2]|0;if((f[Da>>2]|0)>0){ob=0;pb=Fa;qb=Da}else{k=Fa;u=g;return k|0}while(1){Da=f[(f[qb+8>>2]|0)+4+(ob<<2)>>2]|0;b[pb>>0]=Da;b[pb+1>>0]=Da>>8;b[pb+2>>0]=Da>>16;b[pb+3>>0]=Da>>24;Da=pb+4|0;ob=ob+1|0;qb=f[a>>2]|0;if((ob|0)>=(f[qb>>2]|0)){k=Da;break}else pb=Da}u=g;return k|0}case 16:{Da=f[a>>2]|0;if((f[Da>>2]|0)>0){rb=0;sb=Fa;tb=Da}else{k=Fa;u=g;return k|0}while(1){Da=(f[tb+8>>2]|0)+8+(rb<<3)|0;j=f[Da>>2]|0;za=f[Da+4>>2]|0;Da=sb;l=Da;b[l>>0]=j;b[l+1>>0]=j>>8;b[l+2>>0]=j>>16;b[l+3>>0]=j>>24;j=Da+4|0;b[j>>0]=za;b[j+1>>0]=za>>8;b[j+2>>0]=za>>16;b[j+3>>0]=za>>24;za=sb+8|0;rb=rb+1|0;tb=f[a>>2]|0;if((rb|0)>=(f[tb>>2]|0)){k=za;break}else sb=za}u=g;return k|0}case 2:{za=f[a>>2]|0;if((f[za>>2]|0)>0){ub=0;vb=Fa;wb=za}else{k=Fa;u=g;return k|0}while(1){za=f[(f[wb+8>>2]|0)+4+(ub<<2)>>2]|0;b[vb>>0]=za;b[vb+1>>0]=za>>8;b[vb+2>>0]=za>>16;b[vb+3>>0]=za>>24;za=vb+4|0;ub=ub+1|0;wb=f[a>>2]|0;if((ub|0)>=(f[wb>>2]|0)){k=za;break}else vb=za}u=g;return k|0}case 1:{za=f[a>>2]|0;if((f[za>>2]|0)>0){xb=0;yb=Fa;zb=za}else{k=Fa;u=g;return k|0}while(1){p[s>>3]=+p[(f[zb+8>>2]|0)+8+(xb<<3)>>3];b[yb>>0]=b[s>>0];b[yb+1>>0]=b[s+1>>0];b[yb+2>>0]=b[s+2>>0];b[yb+3>>0]=b[s+3>>0];b[yb+4>>0]=b[s+4>>0];b[yb+5>>0]=b[s+5>>0];b[yb+6>>0]=b[s+6>>0];b[yb+7>>0]=b[s+7>>0];za=yb+8|0;xb=xb+1|0;zb=f[a>>2]|0;if((xb|0)>=(f[zb>>2]|0)){k=za;break}else yb=za}u=g;return k|0}case 8:{za=f[a>>2]|0;if((f[za>>2]|0)>0){Ab=0;Bb=Fa;Cb=za}else{k=Fa;u=g;return k|0}while(1){b[Bb>>0]=b[(f[Cb+8>>2]|0)+4+Ab>>0]|0;za=Bb+1|0;Ab=Ab+1|0;Cb=f[a>>2]|0;if((Ab|0)>=(f[Cb>>2]|0)){k=za;break}else Bb=za}u=g;return k|0}case 14:{za=f[a>>2]|0;if((f[za>>2]|0)>0){Db=0;Eb=Fa;Fb=za}else{k=Fa;u=g;return k|0}while(1){za=f[(f[Fb+8>>2]|0)+4+(Db<<2)>>2]|0;j=za&255;if(za>>>0>127){Da=Eb;l=j;Aa=za;m=((za|0)<0)<<31>>31;while(1){b[Da>>0]=l|-128;za=Aa;Aa=aJc(Aa|0,m|0,7)|0;Ba=Da+1|0;x=Aa&255;if(!(m>>>0>0|(m|0)==0&za>>>0>16383)){Gb=Ba;Hb=x;break}else{Da=Ba;l=x;m=J}}}else{Gb=Eb;Hb=j}b[Gb>>0]=Hb;m=Gb+1|0;Db=Db+1|0;Fb=f[a>>2]|0;if((Db|0)>=(f[Fb>>2]|0)){k=m;break}else Eb=m}u=g;return k|0}case 11:case 10:case 12:case 9:{rTb(h,3,493358,498);oTb(i,mTb(h,504712)|0);sTb(h);k=Fa;u=g;return k|0}default:{k=Fa;u=g;return k|0}}while(0)}do switch(b[a+8>>0]|0){case 5:{Fa=f[a>>2]|0;if((f[Fa>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3;if(h>>>0>127){Ib=0;Jb=e;Kb=Fa}else{i=h&255;Eb=0;Fb=e;Db=Fa;while(1){Fa=f[(f[Db+8>>2]|0)+4+(Eb<<2)>>2]|0;b[Fb>>0]=i;Gb=Fb+1|0;Hb=Fa&255;if(Fa>>>0>127){Bb=Gb;Cb=Hb;Ab=Fa;yb=((Fa|0)<0)<<31>>31;while(1){b[Bb>>0]=Cb|-128;Fa=Ab;Ab=aJc(Ab|0,yb|0,7)|0;zb=Bb+1|0;xb=Ab&255;if(!(yb>>>0>0|(yb|0)==0&Fa>>>0>16383)){Lb=zb;Mb=xb;break}else{Bb=zb;Cb=xb;yb=J}}}else{Lb=Gb;Mb=Hb}b[Lb>>0]=Mb;yb=Lb+1|0;Eb=Eb+1|0;Db=f[a>>2]|0;if((Eb|0)>=(f[Db>>2]|0)){k=yb;break}else Fb=yb}u=g;return k|0}while(1){Fb=f[(f[Kb+8>>2]|0)+4+(Ib<<2)>>2]|0;Db=h;Eb=Jb;while(1){b[Eb>>0]=Db|128;i=Db;Db=Db>>>7;Nb=Eb+1|0;if(i>>>0<=16383)break;else Eb=Nb}b[Nb>>0]=Db;Hb=Eb+2|0;Gb=Fb&255;if(Fb>>>0>127){i=Hb;yb=Gb;Cb=Fb;Bb=((Fb|0)<0)<<31>>31;while(1){b[i>>0]=yb|-128;Ab=Cb;Cb=aJc(Cb|0,Bb|0,7)|0;j=i+1|0;xb=Cb&255;if(!(Bb>>>0>0|(Bb|0)==0&Ab>>>0>16383)){Ob=j;Pb=xb;break}else{i=j;yb=xb;Bb=J}}}else{Ob=Hb;Pb=Gb}b[Ob>>0]=Pb;Bb=Ob+1|0;Ib=Ib+1|0;Kb=f[a>>2]|0;if((Ib|0)>=(f[Kb>>2]|0)){k=Bb;break}else Jb=Bb}u=g;return k|0}case 3:{h=f[a>>2]|0;if((f[h>>2]|0)<=0){k=e;u=g;return k|0}Bb=c<<3;if(Bb>>>0>127){Qb=0;Rb=e;Sb=h}else{yb=Bb&255;i=0;Cb=e;Fb=h;while(1){h=(f[Fb+8>>2]|0)+8+(i<<3)|0;Eb=f[h>>2]|0;Db=f[h+4>>2]|0;b[Cb>>0]=yb;h=Cb+1|0;xb=Eb&255;if(Db>>>0>0|(Db|0)==0&Eb>>>0>127){j=h;Ab=xb;zb=Eb;Eb=Db;while(1){b[j>>0]=Ab|-128;Db=zb;zb=aJc(zb|0,Eb|0,7)|0;Fa=j+1|0;vb=zb&255;if(!(Eb>>>0>0|(Eb|0)==0&Db>>>0>16383)){Tb=Fa;Ub=vb;break}else{j=Fa;Ab=vb;Eb=J}}}else{Tb=h;Ub=xb}b[Tb>>0]=Ub;Eb=Tb+1|0;i=i+1|0;Fb=f[a>>2]|0;if((i|0)>=(f[Fb>>2]|0)){k=Eb;break}else Cb=Eb}u=g;return k|0}while(1){Cb=(f[Sb+8>>2]|0)+8+(Qb<<3)|0;Fb=f[Cb>>2]|0;i=f[Cb+4>>2]|0;Cb=Bb;yb=Rb;while(1){b[yb>>0]=Cb|128;Eb=Cb;Cb=Cb>>>7;Vb=yb+1|0;if(Eb>>>0<=16383)break;else yb=Vb}b[Vb>>0]=Cb;xb=yb+2|0;h=Fb&255;if(i>>>0>0|(i|0)==0&Fb>>>0>127){Eb=xb;Ab=h;j=Fb;zb=i;while(1){b[Eb>>0]=Ab|-128;Gb=j;j=aJc(j|0,zb|0,7)|0;Hb=Eb+1|0;vb=j&255;if(!(zb>>>0>0|(zb|0)==0&Gb>>>0>16383)){Wb=Hb;Xb=vb;break}else{Eb=Hb;Ab=vb;zb=J}}}else{Wb=xb;Xb=h}b[Wb>>0]=Xb;zb=Wb+1|0;Qb=Qb+1|0;Sb=f[a>>2]|0;if((Qb|0)>=(f[Sb>>2]|0)){k=zb;break}else Rb=zb}u=g;return k|0}case 13:{Bb=f[a>>2]|0;if((f[Bb>>2]|0)<=0){k=e;u=g;return k|0}zb=c<<3;if(zb>>>0>127){Yb=0;Zb=e;_b=Bb}else{Ab=zb&255;Eb=0;j=e;i=Bb;while(1){Bb=f[(f[i+8>>2]|0)+4+(Eb<<2)>>2]|0;b[j>>0]=Ab;Fb=j+1|0;if(Bb>>>0>127){yb=Bb;Cb=Fb;while(1){b[Cb>>0]=yb|128;vb=yb>>>7;Hb=Cb+1|0;if(yb>>>0>16383){yb=vb;Cb=Hb}else{$b=Hb;ac=vb;break}}}else{$b=Fb;ac=Bb}b[$b>>0]=ac;Cb=$b+1|0;Eb=Eb+1|0;i=f[a>>2]|0;if((Eb|0)>=(f[i>>2]|0)){k=Cb;break}else j=Cb}u=g;return k|0}while(1){j=f[(f[_b+8>>2]|0)+4+(Yb<<2)>>2]|0;i=zb;Eb=Zb;while(1){b[Eb>>0]=i|128;Ab=i;i=i>>>7;bc=Eb+1|0;if(Ab>>>0<=16383)break;else Eb=bc}b[bc>>0]=i;Bb=Eb+2|0;if(j>>>0>127){Fb=j;Ab=Bb;while(1){b[Ab>>0]=Fb|128;Cb=Fb>>>7;yb=Ab+1|0;if(Fb>>>0>16383){Fb=Cb;Ab=yb}else{cc=yb;dc=Cb;break}}}else{cc=Bb;dc=j}b[cc>>0]=dc;Ab=cc+1|0;Yb=Yb+1|0;_b=f[a>>2]|0;if((Yb|0)>=(f[_b>>2]|0)){k=Ab;break}else Zb=Ab}u=g;return k|0}case 4:{zb=f[a>>2]|0;if((f[zb>>2]|0)<=0){k=e;u=g;return k|0}Ab=c<<3;if(Ab>>>0>127){ec=0;fc=e;gc=zb}else{Fb=Ab&255;Eb=0;i=e;Cb=zb;while(1){zb=(f[Cb+8>>2]|0)+8+(Eb<<3)|0;yb=f[zb>>2]|0;h=f[zb+4>>2]|0;b[i>>0]=Fb;zb=i+1|0;xb=yb&255;if(h>>>0>0|(h|0)==0&yb>>>0>127){vb=zb;Hb=xb;Gb=yb;yb=h;while(1){b[vb>>0]=Hb|-128;h=Gb;Gb=aJc(Gb|0,yb|0,7)|0;Fa=vb+1|0;Db=Gb&255;if(!(yb>>>0>0|(yb|0)==0&h>>>0>16383)){hc=Fa;ic=Db;break}else{vb=Fa;Hb=Db;yb=J}}}else{hc=zb;ic=xb}b[hc>>0]=ic;yb=hc+1|0;Eb=Eb+1|0;Cb=f[a>>2]|0;if((Eb|0)>=(f[Cb>>2]|0)){k=yb;break}else i=yb}u=g;return k|0}while(1){i=(f[gc+8>>2]|0)+8+(ec<<3)|0;Cb=f[i>>2]|0;Eb=f[i+4>>2]|0;i=Ab;Fb=fc;while(1){b[Fb>>0]=i|128;yb=i;i=i>>>7;jc=Fb+1|0;if(yb>>>0<=16383)break;else Fb=jc}b[jc>>0]=i;xb=Fb+2|0;zb=Cb&255;if(Eb>>>0>0|(Eb|0)==0&Cb>>>0>127){yb=xb;Hb=zb;vb=Cb;Gb=Eb;while(1){b[yb>>0]=Hb|-128;j=vb;vb=aJc(vb|0,Gb|0,7)|0;Bb=yb+1|0;Db=vb&255;if(!(Gb>>>0>0|(Gb|0)==0&j>>>0>16383)){kc=Bb;lc=Db;break}else{yb=Bb;Hb=Db;Gb=J}}}else{kc=xb;lc=zb}b[kc>>0]=lc;Gb=kc+1|0;ec=ec+1|0;gc=f[a>>2]|0;if((ec|0)>=(f[gc>>2]|0)){k=Gb;break}else fc=Gb}u=g;return k|0}case 17:{Ab=f[a>>2]|0;if((f[Ab>>2]|0)<=0){k=e;u=g;return k|0}Gb=c<<3;if(Gb>>>0>127){mc=0;nc=e;oc=Ab}else{Hb=Gb&255;yb=0;vb=e;Eb=Ab;while(1){Ab=f[(f[Eb+8>>2]|0)+4+(yb<<2)>>2]|0;b[vb>>0]=Hb;Cb=vb+1|0;Fb=Ab<<1^Ab>>31;if(Fb>>>0>127){Ab=Fb;i=Cb;while(1){b[i>>0]=Ab|128;Db=Ab>>>7;Bb=i+1|0;if(Ab>>>0>16383){Ab=Db;i=Bb}else{pc=Bb;qc=Db;break}}}else{pc=Cb;qc=Fb}b[pc>>0]=qc;i=pc+1|0;yb=yb+1|0;Eb=f[a>>2]|0;if((yb|0)>=(f[Eb>>2]|0)){k=i;break}else vb=i}u=g;return k|0}while(1){vb=f[(f[oc+8>>2]|0)+4+(mc<<2)>>2]|0;Eb=Gb;yb=nc;while(1){b[yb>>0]=Eb|128;Hb=Eb;Eb=Eb>>>7;rc=yb+1|0;if(Hb>>>0<=16383)break;else yb=rc}b[rc>>0]=Eb;Fb=yb+2|0;Cb=vb<<1^vb>>31;if(Cb>>>0>127){Hb=Cb;i=Fb;while(1){b[i>>0]=Hb|128;Ab=Hb>>>7;zb=i+1|0;if(Hb>>>0>16383){Hb=Ab;i=zb}else{sc=zb;tc=Ab;break}}}else{sc=Fb;tc=Cb}b[sc>>0]=tc;i=sc+1|0;mc=mc+1|0;oc=f[a>>2]|0;if((mc|0)>=(f[oc>>2]|0)){k=i;break}else nc=i}u=g;return k|0}case 18:{Gb=f[a>>2]|0;if((f[Gb>>2]|0)<=0){k=e;u=g;return k|0}i=c<<3;if(i>>>0>127){uc=0;vc=e;wc=Gb}else{Hb=i&255;vb=0;yb=e;Eb=Gb;while(1){Gb=(f[Eb+8>>2]|0)+8+(vb<<3)|0;Ab=f[Gb>>2]|0;zb=f[Gb+4>>2]|0;b[yb>>0]=Hb;Gb=yb+1|0;xb=jJc(Ab|0,zb|0,1)|0;Db=J;Bb=$Ic(Ab|0,zb|0,63)|0;zb=xb^Bb;Bb=Db^J;Db=zb&255;if(Bb>>>0>0|(Bb|0)==0&zb>>>0>127){xb=Gb;Ab=Db;j=zb;zb=Bb;while(1){b[xb>>0]=Ab|-128;Bb=j;j=aJc(j|0,zb|0,7)|0;Fa=xb+1|0;h=j&255;if(!(zb>>>0>0|(zb|0)==0&Bb>>>0>16383)){xc=Fa;yc=h;break}else{xb=Fa;Ab=h;zb=J}}}else{xc=Gb;yc=Db}b[xc>>0]=yc;zb=xc+1|0;vb=vb+1|0;Eb=f[a>>2]|0;if((vb|0)>=(f[Eb>>2]|0)){k=zb;break}else yb=zb}u=g;return k|0}while(1){yb=(f[wc+8>>2]|0)+8+(uc<<3)|0;Eb=f[yb>>2]|0;vb=f[yb+4>>2]|0;yb=i;Hb=vc;while(1){b[Hb>>0]=yb|128;zb=yb;yb=yb>>>7;zc=Hb+1|0;if(zb>>>0<=16383)break;else Hb=zc}b[zc>>0]=yb;Db=Hb+2|0;Gb=jJc(Eb|0,vb|0,1)|0;zb=J;Ab=$Ic(Eb|0,vb|0,63)|0;xb=Gb^Ab;Ab=zb^J;zb=xb&255;if(Ab>>>0>0|(Ab|0)==0&xb>>>0>127){Gb=Db;j=zb;Cb=xb;xb=Ab;while(1){b[Gb>>0]=j|-128;Ab=Cb;Cb=aJc(Cb|0,xb|0,7)|0;Fb=Gb+1|0;h=Cb&255;if(!(xb>>>0>0|(xb|0)==0&Ab>>>0>16383)){Ac=Fb;Bc=h;break}else{Gb=Fb;j=h;xb=J}}}else{Ac=Db;Bc=zb}b[Ac>>0]=Bc;xb=Ac+1|0;uc=uc+1|0;wc=f[a>>2]|0;if((uc|0)>=(f[wc>>2]|0)){k=xb;break}else vc=xb}u=g;return k|0}case 7:{i=f[a>>2]|0;if((f[i>>2]|0)<=0){k=e;u=g;return k|0}xb=c<<3|5;if(xb>>>0>127){Cc=0;Dc=e;Ec=i}else{j=xb&255;Gb=0;Cb=e;vb=i;while(1){i=f[(f[vb+8>>2]|0)+4+(Gb<<2)>>2]|0;b[Cb>>0]=j;Eb=Cb+1|0;b[Eb>>0]=i;b[Eb+1>>0]=i>>8;b[Eb+2>>0]=i>>16;b[Eb+3>>0]=i>>24;i=Cb+5|0;Gb=Gb+1|0;vb=f[a>>2]|0;if((Gb|0)>=(f[vb>>2]|0)){k=i;break}else Cb=i}u=g;return k|0}while(1){Cb=f[(f[Ec+8>>2]|0)+4+(Cc<<2)>>2]|0;vb=xb;Gb=Dc;while(1){b[Gb>>0]=vb|128;j=vb;vb=vb>>>7;Fc=Gb+1|0;if(j>>>0<=16383)break;else Gb=Fc}b[Fc>>0]=vb;zb=Gb+2|0;b[zb>>0]=Cb;b[zb+1>>0]=Cb>>8;b[zb+2>>0]=Cb>>16;b[zb+3>>0]=Cb>>24;zb=Gb+6|0;Cc=Cc+1|0;Ec=f[a>>2]|0;if((Cc|0)>=(f[Ec>>2]|0)){k=zb;break}else Dc=zb}u=g;return k|0}case 6:{xb=f[a>>2]|0;if((f[xb>>2]|0)<=0){k=e;u=g;return k|0}zb=c<<3|1;if(zb>>>0>127){Gc=0;Hc=e;Ic=xb}else{Db=zb&255;j=0;i=e;Eb=xb;while(1){xb=(f[Eb+8>>2]|0)+8+(j<<3)|0;Hb=f[xb>>2]|0;yb=f[xb+4>>2]|0;b[i>>0]=Db;xb=i+1|0;h=xb;b[h>>0]=Hb;b[h+1>>0]=Hb>>8;b[h+2>>0]=Hb>>16;b[h+3>>0]=Hb>>24;Hb=xb+4|0;b[Hb>>0]=yb;b[Hb+1>>0]=yb>>8;b[Hb+2>>0]=yb>>16;b[Hb+3>>0]=yb>>24;yb=i+9|0;j=j+1|0;Eb=f[a>>2]|0;if((j|0)>=(f[Eb>>2]|0)){k=yb;break}else i=yb}u=g;return k|0}while(1){i=(f[Ic+8>>2]|0)+8+(Gc<<3)|0;Eb=f[i>>2]|0;j=f[i+4>>2]|0;i=zb;Db=Hc;while(1){b[Db>>0]=i|128;yb=i;i=i>>>7;Jc=Db+1|0;if(yb>>>0<=16383)break;else Db=Jc}b[Jc>>0]=i;Gb=Db+2|0;Cb=Gb;b[Cb>>0]=Eb;b[Cb+1>>0]=Eb>>8;b[Cb+2>>0]=Eb>>16;b[Cb+3>>0]=Eb>>24;Cb=Gb+4|0;b[Cb>>0]=j;b[Cb+1>>0]=j>>8;b[Cb+2>>0]=j>>16;b[Cb+3>>0]=j>>24;Cb=Db+10|0;Gc=Gc+1|0;Ic=f[a>>2]|0;if((Gc|0)>=(f[Ic>>2]|0)){k=Cb;break}else Hc=Cb}u=g;return k|0}case 15:{zb=f[a>>2]|0;if((f[zb>>2]|0)<=0){k=e;u=g;return k|0}Cb=c<<3|5;if(Cb>>>0>127){Kc=0;Lc=e;Mc=zb}else{Gb=Cb&255;vb=0;yb=e;Hb=zb;while(1){zb=f[(f[Hb+8>>2]|0)+4+(vb<<2)>>2]|0;b[yb>>0]=Gb;xb=yb+1|0;b[xb>>0]=zb;b[xb+1>>0]=zb>>8;b[xb+2>>0]=zb>>16;b[xb+3>>0]=zb>>24;zb=yb+5|0;vb=vb+1|0;Hb=f[a>>2]|0;if((vb|0)>=(f[Hb>>2]|0)){k=zb;break}else yb=zb}u=g;return k|0}while(1){yb=f[(f[Mc+8>>2]|0)+4+(Kc<<2)>>2]|0;Hb=Cb;vb=Lc;while(1){b[vb>>0]=Hb|128;Gb=Hb;Hb=Hb>>>7;Nc=vb+1|0;if(Gb>>>0<=16383)break;else vb=Nc}b[Nc>>0]=Hb;Db=vb+2|0;b[Db>>0]=yb;b[Db+1>>0]=yb>>8;b[Db+2>>0]=yb>>16;b[Db+3>>0]=yb>>24;Db=vb+6|0;Kc=Kc+1|0;Mc=f[a>>2]|0;if((Kc|0)>=(f[Mc>>2]|0)){k=Db;break}else Lc=Db}u=g;return k|0}case 16:{Cb=f[a>>2]|0;if((f[Cb>>2]|0)<=0){k=e;u=g;return k|0}Db=c<<3|1;if(Db>>>0>127){Oc=0;Pc=e;Qc=Cb}else{j=Db&255;Eb=0;i=e;Gb=Cb;while(1){Cb=(f[Gb+8>>2]|0)+8+(Eb<<3)|0;zb=f[Cb>>2]|0;xb=f[Cb+4>>2]|0;b[i>>0]=j;Cb=i+1|0;h=Cb;b[h>>0]=zb;b[h+1>>0]=zb>>8;b[h+2>>0]=zb>>16;b[h+3>>0]=zb>>24;zb=Cb+4|0;b[zb>>0]=xb;b[zb+1>>0]=xb>>8;b[zb+2>>0]=xb>>16;b[zb+3>>0]=xb>>24;xb=i+9|0;Eb=Eb+1|0;Gb=f[a>>2]|0;if((Eb|0)>=(f[Gb>>2]|0)){k=xb;break}else i=xb}u=g;return k|0}while(1){i=(f[Qc+8>>2]|0)+8+(Oc<<3)|0;Gb=f[i>>2]|0;Eb=f[i+4>>2]|0;i=Db;j=Pc;while(1){b[j>>0]=i|128;xb=i;i=i>>>7;Rc=j+1|0;if(xb>>>0<=16383)break;else j=Rc}b[Rc>>0]=i;vb=j+2|0;yb=vb;b[yb>>0]=Gb;b[yb+1>>0]=Gb>>8;b[yb+2>>0]=Gb>>16;b[yb+3>>0]=Gb>>24;yb=vb+4|0;b[yb>>0]=Eb;b[yb+1>>0]=Eb>>8;b[yb+2>>0]=Eb>>16;b[yb+3>>0]=Eb>>24;yb=j+10|0;Oc=Oc+1|0;Qc=f[a>>2]|0;if((Oc|0)>=(f[Qc>>2]|0)){k=yb;break}else Pc=yb}u=g;return k|0}case 2:{Db=f[a>>2]|0;if((f[Db>>2]|0)<=0){k=e;u=g;return k|0}yb=c<<3|5;if(yb>>>0>127){Sc=0;Tc=e;Uc=Db}else{vb=yb&255;Hb=0;xb=e;zb=Db;while(1){Db=f[(f[zb+8>>2]|0)+4+(Hb<<2)>>2]|0;b[xb>>0]=vb;Cb=xb+1|0;b[Cb>>0]=Db;b[Cb+1>>0]=Db>>8;b[Cb+2>>0]=Db>>16;b[Cb+3>>0]=Db>>24;Db=xb+5|0;Hb=Hb+1|0;zb=f[a>>2]|0;if((Hb|0)>=(f[zb>>2]|0)){k=Db;break}else xb=Db}u=g;return k|0}while(1){xb=f[(f[Uc+8>>2]|0)+4+(Sc<<2)>>2]|0;zb=yb;Hb=Tc;while(1){b[Hb>>0]=zb|128;vb=zb;zb=zb>>>7;Vc=Hb+1|0;if(vb>>>0<=16383)break;else Hb=Vc}b[Vc>>0]=zb;j=Hb+2|0;b[j>>0]=xb;b[j+1>>0]=xb>>8;b[j+2>>0]=xb>>16;b[j+3>>0]=xb>>24;j=Hb+6|0;Sc=Sc+1|0;Uc=f[a>>2]|0;if((Sc|0)>=(f[Uc>>2]|0)){k=j;break}else Tc=j}u=g;return k|0}case 1:{yb=f[a>>2]|0;if((f[yb>>2]|0)<=0){k=e;u=g;return k|0}j=c<<3|1;if(j>>>0>127){Wc=0;Xc=e;Yc=yb}else{Eb=j&255;Gb=0;i=e;vb=yb;while(1){ha=+p[(f[vb+8>>2]|0)+8+(Gb<<3)>>3];b[i>>0]=Eb;yb=i+1|0;p[s>>3]=ha;b[yb>>0]=b[s>>0];b[yb+1>>0]=b[s+1>>0];b[yb+2>>0]=b[s+2>>0];b[yb+3>>0]=b[s+3>>0];b[yb+4>>0]=b[s+4>>0];b[yb+5>>0]=b[s+5>>0];b[yb+6>>0]=b[s+6>>0];b[yb+7>>0]=b[s+7>>0];yb=i+9|0;Gb=Gb+1|0;vb=f[a>>2]|0;if((Gb|0)>=(f[vb>>2]|0)){k=yb;break}else i=yb}u=g;return k|0}while(1){ha=+p[(f[Yc+8>>2]|0)+8+(Wc<<3)>>3];i=j;vb=Xc;while(1){b[vb>>0]=i|128;Gb=i;i=i>>>7;Zc=vb+1|0;if(Gb>>>0<=16383)break;else vb=Zc}b[Zc>>0]=i;Hb=vb+2|0;p[s>>3]=ha;b[Hb>>0]=b[s>>0];b[Hb+1>>0]=b[s+1>>0];b[Hb+2>>0]=b[s+2>>0];b[Hb+3>>0]=b[s+3>>0];b[Hb+4>>0]=b[s+4>>0];b[Hb+5>>0]=b[s+5>>0];b[Hb+6>>0]=b[s+6>>0];b[Hb+7>>0]=b[s+7>>0];Hb=vb+10|0;Wc=Wc+1|0;Yc=f[a>>2]|0;if((Wc|0)>=(f[Yc>>2]|0)){k=Hb;break}else Xc=Hb}u=g;return k|0}case 8:{j=f[a>>2]|0;if((f[j>>2]|0)<=0){k=e;u=g;return k|0}Hb=c<<3;if(Hb>>>0>127){_c=0;$c=e;ad=j}else{xb=Hb&255;zb=0;Gb=e;Eb=j;while(1){j=b[(f[Eb+8>>2]|0)+4+zb>>0]|0;b[Gb>>0]=xb;b[Gb+1>>0]=j;j=Gb+2|0;zb=zb+1|0;Eb=f[a>>2]|0;if((zb|0)>=(f[Eb>>2]|0)){k=j;break}else Gb=j}u=g;return k|0}while(1){Gb=b[(f[ad+8>>2]|0)+4+_c>>0]|0;Eb=Hb;zb=$c;while(1){b[zb>>0]=Eb|128;xb=Eb;Eb=Eb>>>7;bd=zb+1|0;if(xb>>>0<=16383)break;else zb=bd}b[bd>>0]=Eb;b[zb+2>>0]=Gb;vb=zb+3|0;_c=_c+1|0;ad=f[a>>2]|0;if((_c|0)>=(f[ad>>2]|0)){k=vb;break}else $c=vb}u=g;return k|0}case 9:{Hb=f[a>>2]|0;if((f[Hb+4>>2]|0)<=0){k=e;u=g;return k|0}vb=c<<3|2;if(vb>>>0>127){cd=0;dd=e;ed=Hb}else{i=vb&255;xb=0;j=e;yb=Hb;while(1){Hb=f[(f[yb+12>>2]|0)+4+(xb<<2)>>2]|0;b[j>>0]=i;Db=dSb(Hb,j+1|0)|0;xb=xb+1|0;yb=f[a>>2]|0;if((xb|0)>=(f[yb+4>>2]|0)){k=Db;break}else j=Db}u=g;return k|0}while(1){j=f[(f[ed+12>>2]|0)+4+(cd<<2)>>2]|0;yb=vb;xb=dd;while(1){b[xb>>0]=yb|128;i=yb;yb=yb>>>7;fd=xb+1|0;if(i>>>0<=16383)break;else xb=fd}b[fd>>0]=yb;zb=dSb(j,xb+2|0)|0;cd=cd+1|0;ed=f[a>>2]|0;if((cd|0)>=(f[ed+4>>2]|0)){k=zb;break}else dd=zb}u=g;return k|0}case 12:{vb=f[a>>2]|0;if((f[vb+4>>2]|0)<=0){k=e;u=g;return k|0}zb=c<<3|2;if(zb>>>0>127){gd=0;hd=e;id=vb}else{Gb=zb&255;Eb=0;i=e;Db=vb;while(1){vb=f[(f[Db+12>>2]|0)+4+(Eb<<2)>>2]|0;b[i>>0]=Gb;Hb=dSb(vb,i+1|0)|0;Eb=Eb+1|0;Db=f[a>>2]|0;if((Eb|0)>=(f[Db+4>>2]|0)){k=Hb;break}else i=Hb}u=g;return k|0}while(1){i=f[(f[id+12>>2]|0)+4+(gd<<2)>>2]|0;Db=zb;Eb=hd;while(1){b[Eb>>0]=Db|128;Gb=Db;Db=Db>>>7;jd=Eb+1|0;if(Gb>>>0<=16383)break;else Eb=jd}b[jd>>0]=Db;xb=dSb(i,Eb+2|0)|0;gd=gd+1|0;id=f[a>>2]|0;if((gd|0)>=(f[id+4>>2]|0)){k=xb;break}else hd=xb}u=g;return k|0}case 14:{zb=f[a>>2]|0;if((f[zb>>2]|0)<=0){k=e;u=g;return k|0}xb=c<<3;if(xb>>>0>127){kd=0;ld=e;md=zb}else{j=xb&255;yb=0;Gb=e;Hb=zb;while(1){zb=f[(f[Hb+8>>2]|0)+4+(yb<<2)>>2]|0;b[Gb>>0]=j;vb=Gb+1|0;Cb=zb&255;if(zb>>>0>127){h=vb;Fb=Cb;Ab=zb;Fa=((zb|0)<0)<<31>>31;while(1){b[h>>0]=Fb|-128;zb=Ab;Ab=aJc(Ab|0,Fa|0,7)|0;Bb=h+1|0;wb=Ab&255;if(!(Fa>>>0>0|(Fa|0)==0&zb>>>0>16383)){nd=Bb;od=wb;break}else{h=Bb;Fb=wb;Fa=J}}}else{nd=vb;od=Cb}b[nd>>0]=od;Fa=nd+1|0;yb=yb+1|0;Hb=f[a>>2]|0;if((yb|0)>=(f[Hb>>2]|0)){k=Fa;break}else Gb=Fa}u=g;return k|0}while(1){Gb=f[(f[md+8>>2]|0)+4+(kd<<2)>>2]|0;Hb=xb;yb=ld;while(1){b[yb>>0]=Hb|128;j=Hb;Hb=Hb>>>7;pd=yb+1|0;if(j>>>0<=16383)break;else yb=pd}b[pd>>0]=Hb;Cb=yb+2|0;vb=Gb&255;if(Gb>>>0>127){j=Cb;Fa=vb;Fb=Gb;h=((Gb|0)<0)<<31>>31;while(1){b[j>>0]=Fa|-128;Ab=Fb;Fb=aJc(Fb|0,h|0,7)|0;Eb=j+1|0;i=Fb&255;if(!(h>>>0>0|(h|0)==0&Ab>>>0>16383)){qd=Eb;rd=i;break}else{j=Eb;Fa=i;h=J}}}else{qd=Cb;rd=vb}b[qd>>0]=rd;h=qd+1|0;kd=kd+1|0;md=f[a>>2]|0;if((kd|0)>=(f[md>>2]|0)){k=h;break}else ld=h}u=g;return k|0}case 10:{xb=f[a>>2]|0;if((f[xb+4>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3;Fa=h|3;j=h|4;h=j>>>0>127;if(Fa>>>0>127){sd=0;td=e;ud=xb}else{Fb=Fa&255;Gb=0;yb=e;Hb=xb;while(1){xb=f[(f[Hb+12>>2]|0)+4+(Gb<<2)>>2]|0;b[yb>>0]=Fb;i=hj[f[(f[xb>>2]|0)+64>>2]&511](xb,d,yb+1|0)|0;if(h){xb=j;Eb=i;while(1){b[Eb>>0]=xb|128;Ab=xb>>>7;Db=Eb+1|0;if(xb>>>0>16383){xb=Ab;Eb=Db}else{vd=Db;wd=Ab;break}}}else{vd=i;wd=j}b[vd>>0]=wd;Eb=vd+1|0;Gb=Gb+1|0;Hb=f[a>>2]|0;if((Gb|0)>=(f[Hb+4>>2]|0)){k=Eb;break}else yb=Eb}u=g;return k|0}while(1){yb=f[(f[ud+12>>2]|0)+4+(sd<<2)>>2]|0;Hb=Fa;Gb=td;while(1){b[Gb>>0]=Hb|128;Fb=Hb;Hb=Hb>>>7;xd=Gb+1|0;if(Fb>>>0<=16383)break;else Gb=xd}b[xd>>0]=Hb;i=hj[f[(f[yb>>2]|0)+64>>2]&511](yb,d,Gb+2|0)|0;if(h){Fb=j;Eb=i;while(1){b[Eb>>0]=Fb|128;xb=Fb>>>7;vb=Eb+1|0;if(Fb>>>0>16383){Fb=xb;Eb=vb}else{yd=vb;zd=xb;break}}}else{yd=i;zd=j}b[yd>>0]=zd;Eb=yd+1|0;sd=sd+1|0;ud=f[a>>2]|0;if((sd|0)>=(f[ud+4>>2]|0)){k=Eb;break}else td=Eb}u=g;return k|0}case 11:{j=f[a>>2]|0;if((f[j+4>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3|2;if(h>>>0>127){Ad=0;Bd=e;Cd=j}else{Fa=h&255;Eb=0;Fb=e;Gb=j;while(1){j=f[(f[Gb+12>>2]|0)+4+(Eb<<2)>>2]|0;b[Fb>>0]=Fa;yb=Fb+1|0;Hb=_i[f[(f[j>>2]|0)+60>>2]&1023](j)|0;if(Hb>>>0>127){xb=Hb;vb=yb;while(1){b[vb>>0]=xb|128;Cb=xb>>>7;Ab=vb+1|0;if(xb>>>0>16383){xb=Cb;vb=Ab}else{Dd=Ab;Ed=Cb;break}}}else{Dd=yb;Ed=Hb}b[Dd>>0]=Ed;vb=hj[f[(f[j>>2]|0)+64>>2]&511](j,d,Dd+1|0)|0;Eb=Eb+1|0;Gb=f[a>>2]|0;if((Eb|0)>=(f[Gb+4>>2]|0)){k=vb;break}else Fb=vb}u=g;return k|0}while(1){Fb=f[(f[Cd+12>>2]|0)+4+(Ad<<2)>>2]|0;Gb=h;Eb=Bd;while(1){b[Eb>>0]=Gb|128;Fa=Gb;Gb=Gb>>>7;Fd=Eb+1|0;if(Fa>>>0<=16383)break;else Eb=Fd}b[Fd>>0]=Gb;j=Eb+2|0;Hb=_i[f[(f[Fb>>2]|0)+60>>2]&1023](Fb)|0;if(Hb>>>0>127){yb=Hb;Fa=j;while(1){b[Fa>>0]=yb|128;vb=yb>>>7;xb=Fa+1|0;if(yb>>>0>16383){yb=vb;Fa=xb}else{Gd=xb;Hd=vb;break}}}else{Gd=j;Hd=Hb}b[Gd>>0]=Hd;Fa=hj[f[(f[Fb>>2]|0)+64>>2]&511](Fb,d,Gd+1|0)|0;Ad=Ad+1|0;Cd=f[a>>2]|0;if((Ad|0)>=(f[Cd+4>>2]|0)){k=Fa;break}else Bd=Fa}u=g;return k|0}default:{k=e;u=g;return k|0}}while(0);return 0}function B9b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=a+4|0;a=f[g>>2]|0;if(!a){h=e;return h|0}else{i=g;j=a}a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)==(g|0)){h=e;return h|0}else{m=e;n=l}while(1){l=f[n+16>>2]|0;if((l|0)>=(c|0)){h=m;o=14;break}e=A9b(n+24|0,l,d,m)|0;l=f[n+4>>2]|0;if(!l){i=n+8|0;j=f[i>>2]|0;if((f[j>>2]|0)==(n|0))p=j;else{j=i;do{i=f[j>>2]|0;j=i+8|0;b=f[j>>2]|0}while((f[b>>2]|0)!=(i|0));p=b}}else{j=l;while(1){a=f[j>>2]|0;if(!a)break;else j=a}p=j}if((p|0)==(g|0)){h=e;o=14;break}else{m=e;n=p}}if((o|0)==14)return h|0;return 0}function C9b(a){a=a|0;return}function D9b(a){a=a|0;YDc(a);return}function E9b(a,c){a=a|0;c=c|0;var d=0,e=0;if(!(b[473420]|0?1:(f[(f[(f[a+4>>2]|0)+8>>2]|0)+44>>2]|0)!=3)){d=ijc()|0;return d|0}e=f[c+(f[a+24>>2]|0)>>2]|0;if(!(e&1)){d=ijc()|0;return d|0}else{d=e&-2;return d|0}return 0}function F9b(a,b){a=a|0;b=b|0;var c=0,d=0;c=b+(f[a+24>>2]|0)|0;a=f[c>>2]|0;if(!(a&1)){d=mNa(c)|0;return d|0}else{d=a&-2;return d|0}return 0}function G9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;d=u;u=u+16|0;e=d;g=a+8|0;h=f[a+36>>2]|0;i=(qjc(Mi[f[(f[a>>2]|0)+8>>2]&1023](a,c)|0)|0)+h|0;h=f[a+28>>2]|0;if((h|0)==-1)j=i;else j=(z9b(c+h|0)|0)+i|0;i=a+52|0;if((f[i>>2]|0)<0){k=j;u=d;return k|0}h=a+4|0;l=a+12|0;m=a+32|0;a=e+4|0;n=e+8|0;o=e+12|0;p=e+4|0;q=e+8|0;r=e+12|0;s=e+4|0;t=e+8|0;v=e+12|0;w=0;x=j;while(1){j=f[(f[h>>2]|0)+20>>2]|0;y=j+(w*88|0)|0;a:do if((f[j+(w*88|0)+32>>2]|0)!=3){z=j+(w*88|0)+52|0;A=f[z>>2]|0;if(A|0?(f[c+((((A-(f[(f[A+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[m>>2]|0))>>2]|0)!=(f[j+(w*88|0)+40>>2]|0):0){B=x;break}A=f[j+(w*88|0)+24>>2]|0;if(A|0?(f[A>>2]|0)!=2:0){f[e>>2]=78728;f[s>>2]=1737;b[t>>0]=0;f[v>>2]=y;DTb(A,e)}switch(f[161216+(f[j+(w*88|0)+28>>2]<<2)>>2]|0){case 10:{A=f[g>>2]|0;if((A|0)==(c|0)){B=x;break a}C=f[z>>2]|0;do if(!C){D=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){E=f[j+(w*88|0)+56>>2]|0;F=y;if(!E){G=F-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{G=F-(f[E+40>>2]|0)|0;break}}else G=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);H=c;I=D+(((G|0)/88|0)<<2)|0}else{E=(C-(f[(f[C+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){H=c;I=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){F=f[j+(w*88|0)+56>>2]|0;J=y;if(!F){K=J-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{K=J-(f[F+40>>2]|0)|0;break}}else K=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);H=A;I=E+(((K|0)/88|0)<<2)|0}while(0);A=f[H+(f[I>>2]|0)>>2]|0;if(!A){B=x;break a}B=(_i[f[(f[A>>2]|0)+84>>2]&1023](A)|0)+x|0;break a;break}case 9:break;default:{B=x;break a}}A=f[g>>2]|0;C=f[l>>2]|0;D=(b[j+(w*88|0)+38>>0]|0)==0;do if(!D){F=f[j+(w*88|0)+56>>2]|0;J=y;if(!F){L=J-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{L=J-(f[F+40>>2]|0)|0;break}}else L=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);F=f[A+(f[C+(((L|0)/88|0)<<2)>>2]|0)>>2]|0;J=f[z>>2]|0;do if(!J){do if(!D){M=f[j+(w*88|0)+56>>2]|0;N=y;if(!M){O=N-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{O=N-(f[M+40>>2]|0)|0;break}}else O=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);P=(O|0)/88|0;Q=c}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){P=(f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+E|0;Q=c;break}do if(!D){E=f[j+(w*88|0)+56>>2]|0;M=y;if(!E){R=M-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{R=M-(f[E+40>>2]|0)|0;break}}else R=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);P=(R|0)/88|0;Q=A}while(0);A=f[Q+(f[C+(P<<2)>>2]|0)>>2]|0;if((A|0)==(F|0))B=x;else B=x+12+(RQb(A)|0)|0}else{A=j+(w*88|0)+24|0;D=f[A>>2]|0;if(D|0?(f[D>>2]|0)!=2:0){f[e>>2]=78728;f[p>>2]=1737;b[q>>0]=0;f[r>>2]=y;DTb(D,e)}D=j+(w*88|0)+28|0;do switch(f[161216+(f[D>>2]<<2)>>2]|0){case 1:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){E=f[j+(w*88|0)+56>>2]|0;M=y;if(!E){S=M-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{S=M-(f[E+40>>2]|0)|0;break}}else S=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);T=c;U=z+(((S|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){T=c;U=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){W=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{W=V-(f[N+40>>2]|0)|0;break}}else W=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);T=E;U=M+(((W|0)/88|0)<<2)|0}while(0);J=T+(f[U>>2]|0)|0;if(!(f[J+8>>2]|0))X=0;else X=(f[J+4>>2]<<2)+4|0;B=X+x|0;break a;break}case 2:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){Y=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Y=V-(f[N+40>>2]|0)|0;break}}else Y=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Z=c;_=z+(((Y|0)/88|0)<<2)|0}else{M=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){Z=c;_=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){$=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{$=V-(f[N+40>>2]|0)|0;break}}else $=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Z=M;_=E+((($|0)/88|0)<<2)|0}while(0);J=Z+(f[_>>2]|0)|0;if(!(f[J+8>>2]|0))aa=0;else aa=(f[J+4>>2]<<3)+8|0;B=aa+x|0;break a;break}case 3:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){ba=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ba=V-(f[N+40>>2]|0)|0;break}}else ba=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ca=c;da=z+(((ba|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){ca=c;da=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){ea=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ea=V-(f[N+40>>2]|0)|0;break}}else ea=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ca=E;da=M+(((ea|0)/88|0)<<2)|0}while(0);J=ca+(f[da>>2]|0)|0;if(!(f[J+8>>2]|0))fa=0;else fa=(f[J+4>>2]<<2)+4|0;B=fa+x|0;break a;break}case 4:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){ga=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ga=V-(f[N+40>>2]|0)|0;break}}else ga=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ha=c;ia=z+(((ga|0)/88|0)<<2)|0}else{M=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){ha=c;ia=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){ja=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ja=V-(f[N+40>>2]|0)|0;break}}else ja=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ha=M;ia=E+(((ja|0)/88|0)<<2)|0}while(0);J=ha+(f[ia>>2]|0)|0;if(!(f[J+8>>2]|0))ka=0;else ka=(f[J+4>>2]<<3)+8|0;B=ka+x|0;break a;break}case 5:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){la=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{la=V-(f[N+40>>2]|0)|0;break}}else la=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ma=c;na=z+(((la|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){ma=c;na=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){oa=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{oa=V-(f[N+40>>2]|0)|0;break}}else oa=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ma=E;na=M+(((oa|0)/88|0)<<2)|0}while(0);J=ma+(f[na>>2]|0)|0;if(!(f[J+8>>2]|0))pa=0;else pa=(f[J+4>>2]<<3)+8|0;B=pa+x|0;break a;break}case 6:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){qa=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{qa=V-(f[N+40>>2]|0)|0;break}}else qa=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ra=c;sa=z+(((qa|0)/88|0)<<2)|0}else{M=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){ra=c;sa=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){ta=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ta=V-(f[N+40>>2]|0)|0;break}}else ta=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ra=M;sa=E+(((ta|0)/88|0)<<2)|0}while(0);J=ra+(f[sa>>2]|0)|0;if(!(f[J+8>>2]|0))ua=0;else ua=(f[J+4>>2]<<2)+4|0;B=ua+x|0;break a;break}case 7:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){va=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{va=V-(f[N+40>>2]|0)|0;break}}else va=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);wa=c;xa=z+(((va|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){wa=c;xa=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){ya=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ya=V-(f[N+40>>2]|0)|0;break}}else ya=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);wa=E;xa=M+(((ya|0)/88|0)<<2)|0}while(0);J=wa+(f[xa>>2]|0)|0;if(!(f[J+8>>2]|0))za=0;else za=(f[J+4>>2]|0)+4|0;B=za+x|0;break a;break}case 8:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){Aa=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Aa=V-(f[N+40>>2]|0)|0;break}}else Aa=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Ba=c;Ca=z+(((Aa|0)/88|0)<<2)|0}else{M=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){Ba=c;Ca=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){Da=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Da=V-(f[N+40>>2]|0)|0;break}}else Da=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Ba=M;Ca=E+(((Da|0)/88|0)<<2)|0}while(0);J=Ba+(f[Ca>>2]|0)|0;if(!(f[J+8>>2]|0))Ea=0;else Ea=(f[J+4>>2]<<2)+4|0;B=Ea+x|0;break a;break}case 9:{J=f[j+(w*88|0)+52>>2]|0;do if(!J){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){Fa=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Fa=V-(f[N+40>>2]|0)|0;break}}else Fa=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Ga=c;Ha=z+(((Fa|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){Ga=c;Ha=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){N=f[j+(w*88|0)+56>>2]|0;V=y;if(!N){Ia=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Ia=V-(f[N+40>>2]|0)|0;break}}else Ia=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Ga=E;Ha=M+(((Ia|0)/88|0)<<2)|0}while(0);J=Ga+(f[Ha>>2]|0)|0;z=f[J+8>>2]<<2;N=J+12|0;J=f[N>>2]|0;if(!J)Ja=z;else{if((f[J>>2]|0)>0){V=0;Ka=z;La=J;while(1){J=Ka+12+(RQb(f[La+4+(V<<2)>>2]|0)|0)|0;V=V+1|0;La=f[N>>2]|0;if((V|0)>=(f[La>>2]|0)){Ma=J;break}else Ka=J}}else Ma=z;Ja=Ma+4|0}B=Ja+x|0;break a;break}case 10:{Ka=f[A>>2]|0;if(Ka|0?(f[Ka>>2]|0)!=2:0){f[e>>2]=78728;f[a>>2]=1737;b[n>>0]=0;f[o>>2]=y;DTb(Ka,e)}if((f[D>>2]|0)==11?BYb(y)|0:0){Ka=f[j+(w*88|0)+52>>2]|0;do if(!Ka){La=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){V=f[j+(w*88|0)+56>>2]|0;N=y;if(!V){Na=N-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Na=N-(f[V+40>>2]|0)|0;break}}else Na=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Oa=c;Pa=La+(((Na|0)/88|0)<<2)|0}else{M=(Ka-(f[(f[Ka+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){Oa=c;Pa=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){V=f[j+(w*88|0)+56>>2]|0;N=y;if(!V){Qa=N-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Qa=N-(f[V+40>>2]|0)|0;break}}else Qa=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Oa=M;Pa=E+(((Qa|0)/88|0)<<2)|0}while(0);B=(Tdc(Oa+(f[Pa>>2]|0)|0)|0)+x|0;break a}Ka=f[j+(w*88|0)+52>>2]|0;do if(!Ka){z=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){La=f[j+(w*88|0)+56>>2]|0;V=y;if(!La){Ra=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Ra=V-(f[La+40>>2]|0)|0;break}}else Ra=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Sa=c;Ta=z+(((Ra|0)/88|0)<<2)|0}else{E=(Ka-(f[(f[Ka+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[m>>2]|0))>>2]|0)==(f[j+(w*88|0)+40>>2]|0)){Sa=c;Ta=(f[l>>2]|0)+((f[(f[j+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[l>>2]|0;do if(b[j+(w*88|0)+38>>0]|0){La=f[j+(w*88|0)+56>>2]|0;V=y;if(!La){Ua=V-(f[(f[j+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Ua=V-(f[La+40>>2]|0)|0;break}}else Ua=y-(f[(f[j+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Sa=E;Ta=M+(((Ua|0)/88|0)<<2)|0}while(0);Ka=Sa+(f[Ta>>2]|0)|0;z=f[Ka+8>>2]<<2;La=Ka+12|0;Ka=f[La>>2]|0;if(!Ka)Va=z;else{if((f[Ka>>2]|0)>0){V=0;N=z;J=Ka;while(1){Ka=f[J+4+(V<<2)>>2]|0;Wa=(_i[f[(f[Ka>>2]|0)+84>>2]&1023](Ka)|0)+N|0;V=V+1|0;J=f[La>>2]|0;if((V|0)>=(f[J>>2]|0)){Xa=Wa;break}else N=Wa}}else Xa=z;Va=Xa+4|0}B=Va+x|0;break a;break}default:{B=x;break a}}while(0)}while(0);if((w|0)<(f[i>>2]|0)){w=w+1|0;x=B}else{k=B;break}}u=d;return k|0}function H9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=a+4|0;g=f[e>>2]|0;if((f[d+48>>2]|0)!=(g|0))lbc(g,d,496659,495017);if((f[d+32>>2]|0)==3)lbc(f[e>>2]|0,d,496659,495776);if(b[d+38>>0]|0){h=okc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0)|0;return h|0}e=f[d+52>>2]|0;if(!e){h=Dbc(a,c,d)|0;return h|0}else{h=(f[c+((((e-(f[(f[e+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0);return h|0}return 0}function I9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+40|0;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,496649,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,496649,494469);k=d+38|0;if(b[k>>0]|0){m=pkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0)|0;u=e;return m|0}l=d+24|0;n=f[l>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(n,g)}n=d+28|0;do switch(f[161216+(f[n>>2]<<2)>>2]|0){case 1:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){q=f[d+56>>2]|0;r=d;if(!q){s=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=r-(f[q+40>>2]|0)|0;break}}else s=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);t=c;v=p+(((s|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){t=c;v=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){y=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{y=x-(f[w+40>>2]|0)|0;break}}else y=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);t=q;v=r+(((y|0)/88|0)<<2)|0}while(0);m=f[t+(f[v>>2]|0)>>2]|0;u=e;return m|0}case 2:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){z=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{z=x-(f[w+40>>2]|0)|0;break}}else z=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);A=c;B=p+(((z|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){A=c;B=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){C=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{C=x-(f[w+40>>2]|0)|0;break}}else C=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);A=r;B=q+(((C|0)/88|0)<<2)|0}while(0);m=f[A+(f[B>>2]|0)>>2]|0;u=e;return m|0}case 3:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){D=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{D=x-(f[w+40>>2]|0)|0;break}}else D=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);E=c;F=p+(((D|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){E=c;F=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){G=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{G=x-(f[w+40>>2]|0)|0;break}}else G=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);E=q;F=r+(((G|0)/88|0)<<2)|0}while(0);m=f[E+(f[F>>2]|0)>>2]|0;u=e;return m|0}case 4:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){H=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{H=x-(f[w+40>>2]|0)|0;break}}else H=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);I=c;J=p+(((H|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){I=c;J=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){K=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{K=x-(f[w+40>>2]|0)|0;break}}else K=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);I=r;J=q+(((K|0)/88|0)<<2)|0}while(0);m=f[I+(f[J>>2]|0)>>2]|0;u=e;return m|0}case 5:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){L=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{L=x-(f[w+40>>2]|0)|0;break}}else L=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);M=c;N=p+(((L|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){M=c;N=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){O=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{O=x-(f[w+40>>2]|0)|0;break}}else O=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);M=q;N=r+(((O|0)/88|0)<<2)|0}while(0);m=f[M+(f[N>>2]|0)>>2]|0;u=e;return m|0}case 6:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){P=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{P=x-(f[w+40>>2]|0)|0;break}}else P=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Q=c;R=p+(((P|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){Q=c;R=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){S=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{S=x-(f[w+40>>2]|0)|0;break}}else S=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Q=r;R=q+(((S|0)/88|0)<<2)|0}while(0);m=f[Q+(f[R>>2]|0)>>2]|0;u=e;return m|0}case 7:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){T=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{T=x-(f[w+40>>2]|0)|0;break}}else T=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);U=c;V=p+(((T|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){U=c;V=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){W=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{W=x-(f[w+40>>2]|0)|0;break}}else W=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);U=q;V=r+(((W|0)/88|0)<<2)|0}while(0);m=f[U+(f[V>>2]|0)>>2]|0;u=e;return m|0}case 8:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){X=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{X=x-(f[w+40>>2]|0)|0;break}}else X=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Y=c;Z=p+(((X|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){Y=c;Z=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){_=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{_=x-(f[w+40>>2]|0)|0;break}}else _=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Y=r;Z=q+(((_|0)/88|0)<<2)|0}while(0);m=f[Y+(f[Z>>2]|0)>>2]|0;u=e;return m|0}case 10:case 9:{o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(o,g)}if((f[n>>2]|0)==11?BYb(d)|0:0){o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){$=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{$=x-(f[w+40>>2]|0)|0;break}}else $=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);aa=c;ba=p+((($|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){aa=c;ba=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){ca=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ca=x-(f[w+40>>2]|0)|0;break}}else ca=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);aa=q;ba=r+(((ca|0)/88|0)<<2)|0}while(0);o=(Rdc(aa+(f[ba>>2]|0)|0)|0)+4|0;m=f[o>>2]|0;u=e;return m|0}o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){da=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{da=x-(f[w+40>>2]|0)|0;break}}else da=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);ea=c;fa=p+(((da|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){ea=c;fa=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){ga=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ga=x-(f[w+40>>2]|0)|0;break}}else ga=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);ea=r;fa=q+(((ga|0)/88|0)<<2)|0}while(0);m=f[ea+(f[fa>>2]|0)+4>>2]|0;u=e;return m|0}default:{rTb(h,3,493760,747);oTb(i,mTb(h,504236)|0);sTb(h);m=0;u=e;return m|0}}while(0);return 0}function J9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=u;u=u+16|0;g=e;h=d+48|0;i=f[a+4>>2]|0;if((f[h>>2]|0)!=(i|0))lbc(i,d,496638,495017);i=d+38|0;if(b[i>>0]|0){rkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0);u=e;return}if((f[d+32>>2]|0)==3){j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(k,g)}k=d+28|0;do switch(f[161216+(f[k>>2]<<2)>>2]|0){case 1:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){n=f[d+56>>2]|0;o=d;if(!n){q=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=o-(f[n+40>>2]|0)|0;break}}else q=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);r=m+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[r>>2]|0)>>2]=0;u=e;return}case 2:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){v=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=t-(f[s+40>>2]|0)|0;break}}else v=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);w=o+(((v|0)/88|0)<<2)|0}else w=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[w>>2]|0)>>2]=0;u=e;return}case 3:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){x=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{x=t-(f[s+40>>2]|0)|0;break}}else x=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);y=m+(((x|0)/88|0)<<2)|0}else y=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[y>>2]|0)>>2]=0;u=e;return}case 4:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){z=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{z=t-(f[s+40>>2]|0)|0;break}}else z=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);A=o+(((z|0)/88|0)<<2)|0}else A=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[A>>2]|0)>>2]=0;u=e;return}case 5:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){B=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{B=t-(f[s+40>>2]|0)|0;break}}else B=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);C=m+(((B|0)/88|0)<<2)|0}else C=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[C>>2]|0)>>2]=0;u=e;return}case 6:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){D=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{D=t-(f[s+40>>2]|0)|0;break}}else D=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);E=o+(((D|0)/88|0)<<2)|0}else E=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[E>>2]|0)>>2]=0;u=e;return}case 7:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){F=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{F=t-(f[s+40>>2]|0)|0;break}}else F=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);G=m+(((F|0)/88|0)<<2)|0}else G=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[G>>2]|0)>>2]=0;u=e;return}case 8:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){H=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{H=t-(f[s+40>>2]|0)|0;break}}else H=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);I=o+(((H|0)/88|0)<<2)|0}else I=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[I>>2]|0)>>2]=0;u=e;return}case 9:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){J=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{J=t-(f[s+40>>2]|0)|0;break}}else J=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);K=m+(((J|0)/88|0)<<2)|0}else K=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[K>>2]|0)|0;o=n+4|0;s=f[o>>2]|0;if((s|0)<=0){u=e;return}t=f[n+12>>2]|0;n=0;do{L=f[t+4+(n<<2)>>2]|0;n=n+1|0;M=L+11|0;if((b[M>>0]|0)<0){b[f[L>>2]>>0]=0;f[L+4>>2]=0}else{b[L>>0]=0;b[M>>0]=0}}while((n|0)!=(s|0));f[o>>2]=0;u=e;return}case 10:{s=f[j>>2]|0;if(s|0?(f[s>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(s,g)}if((f[k>>2]|0)==11?BYb(d)|0:0){s=f[d+52>>2]|0;if(!s){n=f[a+12>>2]|0;do if(b[i>>0]|0){t=f[d+56>>2]|0;l=d;if(!t){N=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{N=l-(f[t+40>>2]|0)|0;break}}else N=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);O=n+(((N|0)/88|0)<<2)|0}else O=(f[a+12>>2]|0)+(((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;o=Sdc(c+(f[O>>2]|0)|0)|0;t=o+4|0;l=f[t>>2]|0;if((l|0)<=0){u=e;return}m=f[o+12>>2]|0;o=0;do{M=f[m+4+(o<<2)>>2]|0;o=o+1|0;Yi[f[(f[M>>2]|0)+28>>2]&2047](M)}while((o|0)!=(l|0));f[t>>2]=0;u=e;return}l=f[d+52>>2]|0;if(!l){o=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;s=d;if(!m){P=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{P=s-(f[m+40>>2]|0)|0;break}}else P=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);Q=o+(((P|0)/88|0)<<2)|0}else Q=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;t=c+(f[Q>>2]|0)|0;m=t+4|0;s=f[m>>2]|0;if((s|0)<=0){u=e;return}n=f[t+12>>2]|0;t=0;do{M=f[n+4+(t<<2)>>2]|0;t=t+1|0;Yi[f[(f[M>>2]|0)+28>>2]&2047](M)}while((t|0)!=(s|0));f[m>>2]=0;u=e;return}default:{u=e;return}}while(0)}Q=d+52|0;P=f[Q>>2]|0;if(P|0){if((f[c+((((P-(f[(f[P+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){u=e;return}Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,P);u=e;return}if(!(Dbc(a,c,d)|0)){u=e;return}P=a+20|0;O=f[P>>2]|0;if((O|0)!=-1){N=f[a+16>>2]|0;do if(b[i>>0]|0){k=f[d+56>>2]|0;j=d;if(!k){R=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{R=j-(f[k+40>>2]|0)|0;break}}else R=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);k=f[N+(((R|0)/88|0)<<2)>>2]|0;R=c+O+(k>>>5<<2)|0;f[R>>2]=f[R>>2]&~(1<<(k&31))}k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(k,g)}do switch(f[161216+(f[d+28>>2]<<2)>>2]|0){case 1:{g=f[d+80>>2]|0;k=f[Q>>2]|0;if(!k){R=f[a+12>>2]|0;do if(b[i>>0]|0){O=f[d+56>>2]|0;N=d;if(!O){S=N-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{S=N-(f[O+40>>2]|0)|0;break}}else S=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);T=R+(((S|0)/88|0)<<2)|0}else T=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[T>>2]|0)>>2]=g;u=e;return}case 2:{m=d+80|0;O=f[m>>2]|0;N=f[m+4>>2]|0;m=f[Q>>2]|0;if(!m){j=f[a+12>>2]|0;do if(b[i>>0]|0){K=f[d+56>>2]|0;J=d;if(!K){U=J-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{U=J-(f[K+40>>2]|0)|0;break}}else U=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);V=j+(((U|0)/88|0)<<2)|0}else V=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;g=c+(f[V>>2]|0)|0;f[g>>2]=O;f[g+4>>2]=N;u=e;return}case 3:{g=f[d+80>>2]|0;k=f[Q>>2]|0;if(!k){R=f[a+12>>2]|0;do if(b[i>>0]|0){K=f[d+56>>2]|0;J=d;if(!K){W=J-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{W=J-(f[K+40>>2]|0)|0;break}}else W=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);X=R+(((W|0)/88|0)<<2)|0}else X=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[X>>2]|0)>>2]=g;u=e;return}case 4:{N=d+80|0;O=f[N>>2]|0;m=f[N+4>>2]|0;N=f[Q>>2]|0;if(!N){j=f[a+12>>2]|0;do if(b[i>>0]|0){K=f[d+56>>2]|0;J=d;if(!K){Y=J-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{Y=J-(f[K+40>>2]|0)|0;break}}else Y=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);Z=j+(((Y|0)/88|0)<<2)|0}else Z=(f[a+12>>2]|0)+(((N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;g=c+(f[Z>>2]|0)|0;f[g>>2]=O;f[g+4>>2]=m;u=e;return}case 6:{g=f[d+80>>2]|0;k=f[Q>>2]|0;if(!k){R=f[a+12>>2]|0;do if(b[i>>0]|0){K=f[d+56>>2]|0;J=d;if(!K){_=J-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{_=J-(f[K+40>>2]|0)|0;break}}else _=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);$=R+(((_|0)/88|0)<<2)|0}else $=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[$>>2]|0)>>2]=g;u=e;return}case 5:{aa=+p[d+80>>3];m=f[Q>>2]|0;if(!m){O=f[a+12>>2]|0;do if(b[i>>0]|0){N=f[d+56>>2]|0;j=d;if(!N){ba=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ba=j-(f[N+40>>2]|0)|0;break}}else ba=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ca=O+(((ba|0)/88|0)<<2)|0}else ca=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;p[c+(f[ca>>2]|0)>>3]=aa;u=e;return}case 7:{g=b[d+80>>0]|0;k=f[Q>>2]|0;if(!k){R=f[a+12>>2]|0;do if(b[i>>0]|0){N=f[d+56>>2]|0;j=d;if(!N){da=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{da=j-(f[N+40>>2]|0)|0;break}}else da=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ea=R+(((da|0)/88|0)<<2)|0}else ea=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;b[c+(f[ea>>2]|0)>>0]=g;u=e;return}case 8:{m=(CYb(d)|0)+8|0;O=f[m>>2]|0;m=f[Q>>2]|0;if(!m){N=f[a+12>>2]|0;do if(b[i>>0]|0){j=f[d+56>>2]|0;K=d;if(!j){fa=K-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{fa=K-(f[j+40>>2]|0)|0;break}}else fa=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ga=N+(((fa|0)/88|0)<<2)|0}else ga=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[ga>>2]|0)>>2]=O;u=e;return}case 9:{g=f[a+8>>2]|0;k=f[a+12>>2]|0;R=(b[i>>0]|0)==0;do if(!R){j=f[d+56>>2]|0;K=d;if(!j){ha=K-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ha=K-(f[j+40>>2]|0)|0;break}}else ha=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);O=f[g+(f[k+(((ha|0)/88|0)<<2)>>2]|0)>>2]|0;m=f[Q>>2]|0;if(!m){do if(!R){N=f[d+56>>2]|0;j=d;if(!N){ia=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ia=j-(f[N+40>>2]|0)|0;break}}else ia=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ja=(ia|0)/88|0}else ja=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)|0;R=c+(f[k+(ja<<2)>>2]|0)|0;g=f[c+(f[a+24>>2]|0)>>2]|0;N=g&-2;if(!(g&1))ka=N;else ka=f[N+4>>2]|0;if((ka|0)==0?(N=f[R>>2]|0,!((N|0)==(O|0)|(N|0)==0)):0){if((b[N+11>>0]|0)<0)YDc(f[N>>2]|0);YDc(N)}f[R>>2]=O;u=e;return}case 10:{if((f[P>>2]|0)!=-1){R=f[Q>>2]|0;if(!R){N=f[a+12>>2]|0;do if(b[i>>0]|0){g=f[d+56>>2]|0;j=d;if(!g){la=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{la=j-(f[g+40>>2]|0)|0;break}}else la=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ma=N+(((la|0)/88|0)<<2)|0}else ma=(f[a+12>>2]|0)+(((R-(f[(f[R+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;O=f[c+(f[ma>>2]|0)>>2]|0;Yi[f[(f[O>>2]|0)+28>>2]&2047](O);u=e;return}O=f[c+(f[a+24>>2]|0)>>2]|0;k=O&-2;if(!(O&1))na=k;else na=f[k+4>>2]|0;if(!na){k=f[Q>>2]|0;if(!k){O=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;g=d;if(!m){oa=g-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{oa=g-(f[m+40>>2]|0)|0;break}}else oa=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);pa=O+(((oa|0)/88|0)<<2)|0}else pa=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;R=f[c+(f[pa>>2]|0)>>2]|0;if(R|0)Yi[f[(f[R>>2]|0)+4>>2]&2047](R)}R=f[Q>>2]|0;if(!R){N=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;g=d;if(!m){qa=g-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{qa=g-(f[m+40>>2]|0)|0;break}}else qa=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ra=N+(((qa|0)/88|0)<<2)|0}else ra=(f[a+12>>2]|0)+(((R-(f[(f[R+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[ra>>2]|0)>>2]=0;u=e;return}default:{u=e;return}}while(0)}function K9b(a,b,c){a=a|0;b=b|0;c=c|0;return (f[b+((((c-(f[(f[c+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=0|0}function L9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+32|0;i=d+8|0;j=d;d=f[c+((((j-(f[(f[i>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[h>>2]|0))>>2]|0;if(!d){u=e;return}k=qYb(f[a+4>>2]|0,d)|0;d=a+24|0;l=f[c+(f[d>>2]|0)>>2]|0;m=l&-2;if(!(l&1))n=m;else n=f[m+4>>2]|0;a:do if(!n){m=f[k+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=k;DTb(m,g)}switch(f[161216+(f[k+28>>2]<<2)>>2]|0){case 9:break;case 10:{m=f[k+52>>2]|0;if(!m){l=f[a+12>>2]|0;do if(b[k+38>>0]|0){o=f[k+56>>2]|0;p=k;if(!o){q=p-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{q=p-(f[o+40>>2]|0)|0;break}}else q=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);r=l+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[k+48>>2]|0)+52>>2]|0)<<2)|0;o=f[c+(f[r>>2]|0)>>2]|0;if(!o)break a;Yi[f[(f[o>>2]|0)+4>>2]&2047](o);break a;break}default:break a}o=f[a+8>>2]|0;p=f[a+12>>2]|0;s=(b[k+38>>0]|0)==0;do if(!s){t=f[k+56>>2]|0;v=k;if(!t){w=v-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{w=v-(f[t+40>>2]|0)|0;break}}else w=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);m=f[o+(f[p+(((w|0)/88|0)<<2)>>2]|0)>>2]|0;l=f[k+52>>2]|0;if(!l){t=f[a+20>>2]|0;if((t|0)!=-1){v=f[a+16>>2]|0;do if(!s){x=f[k+56>>2]|0;y=k;if(!x){z=y-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{z=y-(f[x+40>>2]|0)|0;break}}else z=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);o=f[v+(((z|0)/88|0)<<2)>>2]|0;x=c+t+(o>>>5<<2)|0;f[x>>2]=1<<(o&31)|f[x>>2]}do if(!s){x=f[k+56>>2]|0;o=k;if(!x){A=o-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{A=o-(f[x+40>>2]|0)|0;break}}else A=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);B=(A|0)/88|0}else{s=(l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0;f[c+((s<<2)+(f[h>>2]|0))>>2]=f[k+40>>2];B=s+(f[(f[k+48>>2]|0)+52>>2]|0)|0}s=f[c+(f[d>>2]|0)>>2]|0;t=s&-2;if(!(s&1))C=t;else C=f[t+4>>2]|0;if((C|0)==0?(t=f[c+(f[p+(B<<2)>>2]|0)>>2]|0,!((t|0)==(m|0)|(t|0)==0)):0){if((b[t+11>>0]|0)<0)YDc(f[t>>2]|0);YDc(t)}}while(0);f[c+((((j-(f[(f[i>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[h>>2]|0))>>2]=0;u=e;return}function M9b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b+((((c-(f[(f[c+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0;if(!d){e=0;return e|0}e=qYb(f[a+4>>2]|0,d)|0;return e|0}function N9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496627,495017);if((f[d+32>>2]|0)!=3)lbc(f[i>>2]|0,d,496627,494469);i=d+38|0;if(b[i>>0]|0){zlc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0);u=e;return}j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(k,g)}k=d+28|0;do switch(f[161216+(f[k>>2]<<2)>>2]|0){case 1:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){n=f[d+56>>2]|0;o=d;if(!n){p=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{p=o-(f[n+40>>2]|0)|0;break}}else p=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);q=m+(((p|0)/88|0)<<2)|0}else q=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[q>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+-1;u=e;return}case 2:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){t=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{t=s-(f[r+40>>2]|0)|0;break}}else t=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);v=o+(((t|0)/88|0)<<2)|0}else v=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=c+(f[v>>2]|0)|0;f[l>>2]=(f[l>>2]|0)+-1;u=e;return}case 3:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){w=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{w=s-(f[r+40>>2]|0)|0;break}}else w=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);x=m+(((w|0)/88|0)<<2)|0}else x=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[x>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+-1;u=e;return}case 4:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){y=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{y=s-(f[r+40>>2]|0)|0;break}}else y=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);z=o+(((y|0)/88|0)<<2)|0}else z=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=c+(f[z>>2]|0)|0;f[l>>2]=(f[l>>2]|0)+-1;u=e;return}case 5:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){A=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{A=s-(f[r+40>>2]|0)|0;break}}else A=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);B=m+(((A|0)/88|0)<<2)|0}else B=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[B>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+-1;u=e;return}case 6:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){C=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{C=s-(f[r+40>>2]|0)|0;break}}else C=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);D=o+(((C|0)/88|0)<<2)|0}else D=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=c+(f[D>>2]|0)|0;f[l>>2]=(f[l>>2]|0)+-1;u=e;return}case 7:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){E=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{E=s-(f[r+40>>2]|0)|0;break}}else E=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);F=m+(((E|0)/88|0)<<2)|0}else F=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[F>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+-1;u=e;return}case 8:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){G=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{G=s-(f[r+40>>2]|0)|0;break}}else G=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);H=o+(((G|0)/88|0)<<2)|0}else H=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=c+(f[H>>2]|0)|0;f[l>>2]=(f[l>>2]|0)+-1;u=e;return}case 9:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){I=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{I=s-(f[r+40>>2]|0)|0;break}}else I=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);J=m+(((I|0)/88|0)<<2)|0}else J=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[J>>2]|0)|0;o=f[n+12>>2]|0;r=n+4|0;n=(f[r>>2]|0)+-1|0;f[r>>2]=n;r=f[o+4+(n<<2)>>2]|0;n=r+11|0;if((b[n>>0]|0)<0){b[f[r>>2]>>0]=0;f[r+4>>2]=0;u=e;return}else{b[r>>0]=0;b[n>>0]=0;u=e;return}break}case 10:{n=f[j>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(n,g)}if((f[k>>2]|0)==11?BYb(d)|0:0){n=f[d+52>>2]|0;if(!n){r=f[a+12>>2]|0;do if(b[i>>0]|0){o=f[d+56>>2]|0;s=d;if(!o){K=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{K=s-(f[o+40>>2]|0)|0;break}}else K=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);L=r+(((K|0)/88|0)<<2)|0}else L=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=Sdc(c+(f[L>>2]|0)|0)|0;m=f[l+12>>2]|0;o=l+4|0;l=(f[o>>2]|0)+-1|0;f[o>>2]=l;o=f[m+4+(l<<2)>>2]|0;Yi[f[(f[o>>2]|0)+28>>2]&2047](o);u=e;return}o=f[d+52>>2]|0;if(!o){l=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;s=d;if(!m){M=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{M=s-(f[m+40>>2]|0)|0;break}}else M=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);N=l+(((M|0)/88|0)<<2)|0}else N=(f[a+12>>2]|0)+(((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[N>>2]|0)|0;r=f[n+12>>2]|0;m=n+4|0;n=(f[m>>2]|0)+-1|0;f[m>>2]=n;m=f[r+4+(n<<2)>>2]|0;Yi[f[(f[m>>2]|0)+28>>2]&2047](m);u=e;return}default:{u=e;return}}while(0)}function O9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496615,495017);if((f[d+32>>2]|0)!=3)lbc(f[i>>2]|0,d,496615,494469);j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(k,g)}k=d+28|0;if((f[161216+(f[k>>2]<<2)>>2]|0)!=10)nbc(f[i>>2]|0,d,496615,10);i=d+38|0;if(b[i>>0]|0){l=Alc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0)|0;u=e;return l|0}m=f[j>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(m,g)}if((f[k>>2]|0)==11?BYb(d)|0:0){k=f[d+52>>2]|0;if(!k){g=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;j=d;if(!m){n=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=j-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);o=g+(((n|0)/88|0)<<2)|0}else o=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;k=Sdc(c+(f[o>>2]|0)|0)|0;o=f[k+12>>2]|0;n=k+4|0;g=f[n>>2]|0;m=g+-1|0;f[n>>2]=m;n=o+4+(m<<2)|0;m=f[n>>2]|0;j=f[o>>2]|0;p=j+-1|0;f[o>>2]=p;if((g|0)<(j|0))f[n>>2]=f[o+4+(p<<2)>>2];if(!(f[k>>2]|0)){l=m;u=e;return l|0}k=zhc(m,0)|0;pbc(m,k);l=k;u=e;return l|0}k=f[d+52>>2]|0;if(!k){m=f[a+12>>2]|0;do if(b[i>>0]|0){p=f[d+56>>2]|0;o=d;if(!p){q=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=o-(f[p+40>>2]|0)|0;break}}else q=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);r=m+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;h=c+(f[r>>2]|0)|0;r=f[h+12>>2]|0;c=h+4|0;k=f[c>>2]|0;a=k+-1|0;f[c>>2]=a;c=r+4+(a<<2)|0;a=f[c>>2]|0;q=f[r>>2]|0;m=q+-1|0;f[r>>2]=m;if((k|0)<(q|0))f[c>>2]=f[r+4+(m<<2)>>2];if(!(f[h>>2]|0)){l=a;u=e;return l|0}h=zhc(a,0)|0;pbc(a,h);l=h;u=e;return l|0}function P9b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+64|0;e=d+48|0;g=d+24|0;h=d;if((b|0)==(c|0)){u=d;return}if((_i[f[(f[b>>2]|0)+92>>2]&1023](b)|0)!=(a|0)){rTb(g,3,493760,577);i=mTb(mTb(g,496179)|0,496542)|0;mi[f[(f[b>>2]|0)+96>>2]&2047](e,b);j=mTb(nTb(i,f[(f[e>>2]|0)+4>>2]|0)|0,496275)|0;oTb(d+57|0,mTb(nTb(j,f[(f[a+4>>2]|0)+4>>2]|0)|0,496345)|0);sTb(g)}if((_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0)!=(a|0)){rTb(h,3,493760,584);g=mTb(mTb(h,496424)|0,496578)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);j=mTb(nTb(g,f[(f[e>>2]|0)+4>>2]|0)|0,496275)|0;oTb(d+56|0,mTb(nTb(j,f[(f[a+4>>2]|0)+4>>2]|0)|0,496345)|0);sTb(h)}h=a+24|0;j=f[h>>2]|0;e=f[b+j>>2]|0;g=(e&1|0)==0;i=e&-2;if(g)k=i;else k=f[i+4>>2]|0;e=f[c+j>>2]|0;j=e&-2;if(!(e&1))l=j;else l=f[j+4>>2]|0;if((k|0)!=(l|0)){if(g)m=i;else m=f[i+4>>2]|0;i=Mi[f[(f[b>>2]|0)+16>>2]&1023](b,m)|0;mi[f[(f[i>>2]|0)+76>>2]&2047](i,c);mi[f[(f[c>>2]|0)+72>>2]&2047](c,b);Ti[f[(f[a>>2]|0)+52>>2]&511](a,b,i);m=f[b+(f[h>>2]|0)>>2]|0;h=m&-2;if(!(m&1))n=h;else n=f[h+4>>2]|0;if((i|0)==0|(n|0)!=0){u=d;return}Yi[f[(f[i>>2]|0)+4>>2]&2047](i);u=d;return}i=f[a+20>>2]|0;if((i|0)!=-1){n=b+i|0;h=c+i|0;i=a+4|0;m=f[i>>2]|0;g=f[m+52>>2]|0;if((g|0)>0){l=f[m+20>>2]|0;k=0;j=0;while(1){if((f[l+(k*88|0)+32>>2]|0)==3)o=j;else o=((f[l+(k*88|0)+52>>2]|0)==0&1)+j|0;k=k+1|0;if((k|0)>=(g|0))break;else j=o}j=(o+31|0)/32|0;if((o|0)>0){o=0;do{g=n+(o<<2)|0;k=h+(o<<2)|0;l=f[g>>2]|0;f[g>>2]=f[k>>2];f[k>>2]=l;o=o+1|0}while((o|0)<(j|0));p=i;q=m}else{p=i;q=m}}else{p=i;q=m}}else{m=a+4|0;p=m;q=f[m>>2]|0}m=a+52|0;i=f[m>>2]|0;if((i|0)<0)r=q;else{j=0;o=q;q=i;while(1){i=f[o+20>>2]|0;if(!(f[i+(j*88|0)+52>>2]|0)){Jbc(a,b,c,i+(j*88|0)|0);s=f[m>>2]|0;t=f[p>>2]|0}else{s=q;t=o}if((j|0)<(s|0)){j=j+1|0;o=t;q=s}else{r=t;break}}}t=f[r+56>>2]|0;if((t|0)>0?(Hbc(a,b,c,f[r+24>>2]|0),(t|0)!=1):0){r=1;do{Hbc(a,b,c,(f[(f[p>>2]|0)+24>>2]|0)+(r*28|0)|0);r=r+1|0}while((r|0)!=(t|0))}t=f[a+28>>2]|0;if((t|0)!=-1)Flc(b+t|0,c+t|0);t=Mi[f[(f[a>>2]|0)+12>>2]&1023](a,b)|0;b=Mi[f[(f[a>>2]|0)+12>>2]&1023](a,c)|0;c=f[t>>2]|0;f[t>>2]=f[b>>2];f[b>>2]=c;u=d;return}function Q9b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+64|0;h=g+48|0;i=g+24|0;j=g;if((c|0)==(d|0)){u=g;return}if((_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0)!=(a|0)){rTb(i,3,493760,651);k=mTb(mTb(i,496179)|0,496233)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);l=mTb(nTb(k,f[(f[h>>2]|0)+4>>2]|0)|0,496275)|0;oTb(g+61|0,mTb(nTb(l,f[(f[a+4>>2]|0)+4>>2]|0)|0,496345)|0);sTb(i)}if((_i[f[(f[d>>2]|0)+92>>2]&1023](d)|0)!=(a|0)){rTb(j,3,493760,658);i=mTb(mTb(j,496424)|0,496478)|0;mi[f[(f[d>>2]|0)+96>>2]&2047](h,d);l=mTb(nTb(i,f[(f[h>>2]|0)+4>>2]|0)|0,496275)|0;oTb(g+60|0,mTb(nTb(l,f[(f[a+4>>2]|0)+4>>2]|0)|0,496345)|0);sTb(j)}j=h+4|0;f[j>>2]=0;l=h+8|0;f[l>>2]=0;i=h+4|0;f[h>>2]=i;k=f[e>>2]|0;m=(f[e+4>>2]|0)-k|0;n=m>>2;if((m|0)>0){m=a+28|0;o=0;p=k;while(1){k=f[p+(o<<2)>>2]|0;a:do if(!(b[k+38>>0]|0)){q=k+52|0;r=f[q>>2]|0;if(!r){if((f[k+32>>2]|0)!=3)Ibc(a,c,d,k);Jbc(a,c,d,k);break}s=(r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0;t=f[i>>2]|0;do if(t){v=i;w=t;b:while(1){x=w;while(1){if((f[x+16>>2]|0)>=(s|0))break;y=f[x+4>>2]|0;if(!y){z=v;break b}else x=y}w=f[x>>2]|0;if(!w){z=x;break}else v=x}if((z|0)!=(i|0)?(s|0)>=(f[z+16>>2]|0):0)break a;else{A=j;B=t}while(1){v=f[B+16>>2]|0;if((s|0)<(v|0)){w=f[B>>2]|0;if(!w){C=23;break}else{D=B;E=w}}else{if((v|0)>=(s|0)){C=27;break}F=B+4|0;v=f[F>>2]|0;if(!v){C=26;break}else{D=F;E=v}}A=D;B=E}if((C|0)==23){C=0;G=B;H=B;break}else if((C|0)==26){C=0;G=F;H=B;break}else if((C|0)==27){C=0;G=A;H=B;break}}else{G=i;H=i}while(0);if(!(f[G>>2]|0)){t=VDc(20)|0;f[t+16>>2]=s;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=H;f[G>>2]=t;v=f[f[h>>2]>>2]|0;if(!v)I=t;else{f[h>>2]=v;I=f[G>>2]|0}laa(f[j>>2]|0,I);f[l>>2]=(f[l>>2]|0)+1;J=f[q>>2]|0}else J=r;Hbc(a,c,d,J)}else{v=f[m>>2]|0;Glc(c+v|0,d+v|0,f[k+40>>2]|0)}while(0);k=o+1|0;if((k|0)>=(n|0))break;o=k;p=f[e>>2]|0}K=f[i>>2]|0}else K=0;GFa(h,K);u=g;return}function R9b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,496174,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,496174,494469);k=d+38|0;if(b[k>>0]|0){Blc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}l=d+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(m,i)}m=d+28|0;do switch(f[161216+(f[m>>2]<<2)>>2]|0){case 1:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[k>>0]|0){q=f[d+56>>2]|0;r=d;if(!q){s=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=r-(f[q+40>>2]|0)|0;break}}else s=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);t=o+(((s|0)/88|0)<<2)|0}else t=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;q=f[c+(f[t>>2]|0)+8>>2]|0;r=q+4+(e<<2)|0;v=q+4+(g<<2)|0;q=f[r>>2]|0;f[r>>2]=f[v>>2];f[v>>2]=q;u=h;return}case 2:{q=f[d+52>>2]|0;if(!q){v=f[a+12>>2]|0;do if(b[k>>0]|0){r=f[d+56>>2]|0;w=d;if(!r){x=w-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{x=w-(f[r+40>>2]|0)|0;break}}else x=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);y=v+(((x|0)/88|0)<<2)|0}else y=(f[a+12>>2]|0)+(((q-(f[(f[q+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;n=f[c+(f[y>>2]|0)+8>>2]|0;o=n+8+(e<<3)|0;r=n+8+(g<<3)|0;n=o;w=f[n>>2]|0;z=f[n+4>>2]|0;n=r;A=f[n+4>>2]|0;B=o;f[B>>2]=f[n>>2];f[B+4>>2]=A;A=r;f[A>>2]=w;f[A+4>>2]=z;u=h;return}case 3:{z=f[d+52>>2]|0;if(!z){A=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;r=d;if(!w){C=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{C=r-(f[w+40>>2]|0)|0;break}}else C=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);D=A+(((C|0)/88|0)<<2)|0}else D=(f[a+12>>2]|0)+(((z-(f[(f[z+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;q=f[c+(f[D>>2]|0)+8>>2]|0;v=q+4+(e<<2)|0;w=q+4+(g<<2)|0;q=f[v>>2]|0;f[v>>2]=f[w>>2];f[w>>2]=q;u=h;return}case 4:{q=f[d+52>>2]|0;if(!q){w=f[a+12>>2]|0;do if(b[k>>0]|0){v=f[d+56>>2]|0;r=d;if(!v){E=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{E=r-(f[v+40>>2]|0)|0;break}}else E=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);F=w+(((E|0)/88|0)<<2)|0}else F=(f[a+12>>2]|0)+(((q-(f[(f[q+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;z=f[c+(f[F>>2]|0)+8>>2]|0;A=z+8+(e<<3)|0;v=z+8+(g<<3)|0;z=A;r=f[z>>2]|0;B=f[z+4>>2]|0;z=v;n=f[z+4>>2]|0;o=A;f[o>>2]=f[z>>2];f[o+4>>2]=n;n=v;f[n>>2]=r;f[n+4>>2]=B;u=h;return}case 5:{B=f[d+52>>2]|0;if(!B){n=f[a+12>>2]|0;do if(b[k>>0]|0){r=f[d+56>>2]|0;v=d;if(!r){G=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{G=v-(f[r+40>>2]|0)|0;break}}else G=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);H=n+(((G|0)/88|0)<<2)|0}else H=(f[a+12>>2]|0)+(((B-(f[(f[B+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;q=f[c+(f[H>>2]|0)+8>>2]|0;w=q+8+(e<<3)|0;r=q+8+(g<<3)|0;I=+p[w>>3];p[w>>3]=+p[r>>3];p[r>>3]=I;u=h;return}case 6:{r=f[d+52>>2]|0;if(!r){w=f[a+12>>2]|0;do if(b[k>>0]|0){q=f[d+56>>2]|0;v=d;if(!q){J=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{J=v-(f[q+40>>2]|0)|0;break}}else J=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);K=w+(((J|0)/88|0)<<2)|0}else K=(f[a+12>>2]|0)+(((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;B=f[c+(f[K>>2]|0)+8>>2]|0;n=B+4+(e<<2)|0;q=B+4+(g<<2)|0;B=f[n>>2]|0;f[n>>2]=f[q>>2];f[q>>2]=B;u=h;return}case 7:{B=f[d+52>>2]|0;if(!B){q=f[a+12>>2]|0;do if(b[k>>0]|0){n=f[d+56>>2]|0;v=d;if(!n){L=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{L=v-(f[n+40>>2]|0)|0;break}}else L=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);M=q+(((L|0)/88|0)<<2)|0}else M=(f[a+12>>2]|0)+(((B-(f[(f[B+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;r=f[c+(f[M>>2]|0)+8>>2]|0;w=r+4+e|0;n=r+4+g|0;r=b[w>>0]|0;b[w>>0]=b[n>>0]|0;b[n>>0]=r;u=h;return}case 8:{r=f[d+52>>2]|0;if(!r){n=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;v=d;if(!w){N=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{N=v-(f[w+40>>2]|0)|0;break}}else N=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);O=n+(((N|0)/88|0)<<2)|0}else O=(f[a+12>>2]|0)+(((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;B=f[c+(f[O>>2]|0)+8>>2]|0;q=B+4+(e<<2)|0;w=B+4+(g<<2)|0;B=f[q>>2]|0;f[q>>2]=f[w>>2];f[w>>2]=B;u=h;return}case 10:case 9:{B=f[l>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(B,i)}if((f[m>>2]|0)==11?BYb(d)|0:0){B=f[d+52>>2]|0;if(!B){w=f[a+12>>2]|0;do if(b[k>>0]|0){q=f[d+56>>2]|0;v=d;if(!q){P=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{P=v-(f[q+40>>2]|0)|0;break}}else P=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Q=w+(((P|0)/88|0)<<2)|0}else Q=(f[a+12>>2]|0)+(((B-(f[(f[B+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;r=(Sdc(c+(f[Q>>2]|0)|0)|0)+12|0;n=f[r>>2]|0;r=n+4+(e<<2)|0;q=n+4+(g<<2)|0;n=f[r>>2]|0;f[r>>2]=f[q>>2];f[q>>2]=n;u=h;return}n=f[d+52>>2]|0;if(!n){q=f[a+12>>2]|0;do if(b[k>>0]|0){r=f[d+56>>2]|0;v=d;if(!r){R=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{R=v-(f[r+40>>2]|0)|0;break}}else R=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);S=q+(((R|0)/88|0)<<2)|0}else S=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;B=f[c+(f[S>>2]|0)+12>>2]|0;w=B+4+(e<<2)|0;r=B+4+(g<<2)|0;B=f[w>>2]|0;f[w>>2]=f[r>>2];f[r>>2]=B;u=h;return}default:{u=h;return}}while(0)}function S9b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=c+4|0;i=f[h>>2]|0;if((i|0)!=(g|0))f[h>>2]=i+(~((i+-4-g|0)>>>2)<<2);if((f[a+8>>2]|0)==(b|0)){u=d;return}g=f[a+20>>2]|0;i=(g|0)==-1?0:b+g|0;g=f[a+16>>2]|0;j=b+(f[a+32>>2]|0)|0;k=a+4|0;Cbc(c,f[(f[k>>2]|0)+52>>2]|0);l=a+52|0;if((f[l>>2]|0)>=0){m=c+8|0;n=(i|0)==0;o=0;while(1){p=f[(f[k>>2]|0)+20>>2]|0;q=p+(o*88|0)|0;f[e>>2]=q;r=q;do if((f[p+(o*88|0)+32>>2]|0)==3){if((hj[f[(f[a>>2]|0)+24>>2]&511](a,b,q)|0)>0){s=f[h>>2]|0;if((s|0)==(f[m>>2]|0)){jWb(c,e);break}else{f[s>>2]=f[e>>2];f[h>>2]=(f[h>>2]|0)+4;break}}}else{s=f[p+(o*88|0)+52>>2]|0;if(s|0){if((f[j+(((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[p+(o*88|0)+40>>2]|0))break;s=f[h>>2]|0;if((s|0)==(f[m>>2]|0)){jWb(c,e);break}else{f[s>>2]=r;f[h>>2]=(f[h>>2]|0)+4;break}}if(n){if(!(Dbc(a,b,q)|0))break;s=f[h>>2]|0;if((s|0)==(f[m>>2]|0)){jWb(c,e);break}else{f[s>>2]=f[e>>2];f[h>>2]=(f[h>>2]|0)+4;break}}else{s=f[g+(o<<2)>>2]|0;if(!(1<<(s&31)&f[i+(s>>>5<<2)>>2]))break;s=f[h>>2]|0;if((s|0)==(f[m>>2]|0)){jWb(c,e);break}else{f[s>>2]=r;f[h>>2]=(f[h>>2]|0)+4;break}}}while(0);if((o|0)<(f[l>>2]|0))o=o+1|0;else break}}o=f[a+28>>2]|0;if((o|0)!=-1)o9b(b+o|0,f[k>>2]|0,f[a+44>>2]|0,c);Ebc(f[c>>2]|0,f[h>>2]|0);u=d;return}function T9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496128,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496128,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=1)nbc(f[i>>2]|0,d,496128,1);if(b[d+38>>0]|0){k=tkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[d+80>>2]|0)|0;u=e;return k|0}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=f[l+(f[m>>2]|0)>>2]|0;u=e;return k|0}function U9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496119,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496119,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=2)nbc(f[i>>2]|0,d,496119,2);if(b[d+38>>0]|0){i=d+80|0;g=Akc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[i>>2]|0,f[i+4>>2]|0)|0;k=J;l=g;J=k;u=e;return l|0}g=f[d+52>>2]|0;do if(g){i=(g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((i<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+i<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);h=m+(f[n>>2]|0)|0;k=f[h+4>>2]|0;l=f[h>>2]|0;J=k;u=e;return l|0}function V9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496109,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496109,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=3)nbc(f[i>>2]|0,d,496109,3);if(b[d+38>>0]|0){k=Gkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[d+80>>2]|0)|0;u=e;return k|0}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=f[l+(f[m>>2]|0)>>2]|0;u=e;return k|0}function W9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496099,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496099,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=4)nbc(f[i>>2]|0,d,496099,4);if(b[d+38>>0]|0){i=d+80|0;g=Mkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[i>>2]|0,f[i+4>>2]|0)|0;k=J;l=g;J=k;u=e;return l|0}g=f[d+52>>2]|0;do if(g){i=(g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((i<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+i<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);h=m+(f[n>>2]|0)|0;k=f[h+4>>2]|0;l=f[h>>2]|0;J=k;u=e;return l|0}function X9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496090,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496090,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=6)nbc(f[i>>2]|0,d,496090,6);if(b[d+38>>0]|0){k=+Skc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,+n[d+80>>2]);u=e;return +k}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=+n[l+(f[m>>2]|0)>>2];u=e;return +k}function Y9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496080,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496080,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=5)nbc(f[i>>2]|0,d,496080,5);if(b[d+38>>0]|0){k=+Ykc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,+p[d+80>>3]);u=e;return +k}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=+p[l+(f[m>>2]|0)>>3];u=e;return +k}function Z9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496072,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496072,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=7)nbc(f[i>>2]|0,d,496072,7);if(b[d+38>>0]|0){k=clc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,(b[d+80>>0]|0)!=0)|0;u=e;return k|0}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=(b[l+(f[m>>2]|0)>>0]|0)!=0;u=e;return k|0}function _9b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g;i=e+48|0;j=c+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,e,496062,495017);if((f[e+32>>2]|0)==3)lbc(f[j>>2]|0,e,496062,495776);k=f[e+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(k,h)}if((f[161216+(f[e+28>>2]<<2)>>2]|0)!=9)nbc(f[j>>2]|0,e,496062,9);if(b[e+38>>0]|0){fEc(a,plc(d+(f[c+28>>2]|0)|0,f[e+40>>2]|0,f[e+80>>2]|0)|0);u=g;return}j=f[e+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((h<<2)+(f[c+32>>2]|0))>>2]|0)==(f[e+40>>2]|0)){l=d;m=(f[c+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{l=f[c+8>>2]|0;m=(f[c+12>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=d;m=(f[c+12>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);fEc(a,f[l+(f[m>>2]|0)>>2]|0);u=g;return}function $9b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=hj[f[(f[a>>2]|0)+104>>2]&511](a,b,c)|0;return xYb(EYb(c)|0,d)|0}function aac(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496049,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496049,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=8)nbc(f[i>>2]|0,d,496049,8);if(b[d+38>>0]|0){i=c+(f[a+28>>2]|0)|0;g=f[d+40>>2]|0;j=(CYb(d)|0)+8|0;k=klc(i,g,f[j>>2]|0)|0;u=e;return k|0}j=f[d+52>>2]|0;do if(j){g=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=f[l+(f[m>>2]|0)>>2]|0;u=e;return k|0}function bac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,496038,495017);if((f[d+32>>2]|0)==3)lbc(f[j>>2]|0,d,496038,495776);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=10)nbc(f[j>>2]|0,d,496038,10);if(!e)l=f[a+48>>2]|0;else l=e;if(b[d+38>>0]|0){e=c+(f[a+28>>2]|0)|0;j=f[d+40>>2]|0;m=p9b(e,j,DYb(d)|0,l)|0;u=g;return m|0}l=f[d+52>>2]|0;do if(l){j=(l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((j<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){e=f[i>>2]|0;h=f[a+12>>2]|0;n=c;o=h+((f[e+52>>2]|0)+j<<2)|0;p=e;q=h;break}else{h=f[a+12>>2]|0;e=f[i>>2]|0;n=f[a+8>>2]|0;o=h+(((d-(f[e+20>>2]|0)|0)/88|0)<<2)|0;p=e;q=h;break}}else{h=f[a+12>>2]|0;e=f[i>>2]|0;n=c;o=h+(((d-(f[e+20>>2]|0)|0)/88|0)<<2)|0;p=e;q=h}while(0);c=f[n+(f[o>>2]|0)>>2]|0;if(c|0){m=c;u=g;return m|0}m=f[(f[a+8>>2]|0)+(f[q+(((d-(f[p+20>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;u=g;return m|0}function cac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))lbc(j,d,496019,495017);if((f[d+32>>2]|0)==3)lbc(f[i>>2]|0,d,496019,495776);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(j,g)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=9)nbc(f[i>>2]|0,d,496019,9);if(b[d+38>>0]|0){k=plc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[d+80>>2]|0)|0;u=e;return k|0}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=f[l+(f[m>>2]|0)>>2]|0;u=e;return k|0}function dac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+8|0;i=g;f[i>>2]=e;e=a+4|0;j=f[e>>2]|0;if((f[d+48>>2]|0)!=(j|0))lbc(j,d,496010,495017);if((f[d+32>>2]|0)==3)lbc(f[e>>2]|0,d,496010,495776);j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}k=d+28|0;if((f[161216+(f[k>>2]<<2)>>2]|0)!=1)nbc(f[e>>2]|0,d,496010,1);if(!(b[d+38>>0]|0)){vbc(a,c,d,i);u=g;return}e=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[j>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(c,h)}ukc(e,a,f[k>>2]&255,f[i>>2]|0,d);u=g;return}function eac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+8|0;j=h;k=j;f[k>>2]=e;f[k+4>>2]=g;g=a+4|0;k=f[g>>2]|0;if((f[d+48>>2]|0)!=(k|0))lbc(k,d,496001,495017);if((f[d+32>>2]|0)==3)lbc(f[g>>2]|0,d,496001,495776);k=d+24|0;e=f[k>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(e,i)}e=d+28|0;if((f[161216+(f[e>>2]<<2)>>2]|0)!=2)nbc(f[g>>2]|0,d,496001,2);if(!(b[d+38>>0]|0)){Bbc(a,c,d,j);u=h;return}g=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(c,i)}i=j;Bkc(g,a,f[e>>2]&255,f[i>>2]|0,f[i+4>>2]|0,d);u=h;return}function fac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+8|0;i=g;f[i>>2]=e;e=a+4|0;j=f[e>>2]|0;if((f[d+48>>2]|0)!=(j|0))lbc(j,d,495991,495017);if((f[d+32>>2]|0)==3)lbc(f[e>>2]|0,d,495991,495776);j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}k=d+28|0;if((f[161216+(f[k>>2]<<2)>>2]|0)!=3)nbc(f[e>>2]|0,d,495991,3);if(!(b[d+38>>0]|0)){Abc(a,c,d,i);u=g;return}e=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[j>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(c,h)}Hkc(e,a,f[k>>2]&255,f[i>>2]|0,d);u=g;return}function gac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+8|0;j=h;k=j;f[k>>2]=e;f[k+4>>2]=g;g=a+4|0;k=f[g>>2]|0;if((f[d+48>>2]|0)!=(k|0))lbc(k,d,495981,495017);if((f[d+32>>2]|0)==3)lbc(f[g>>2]|0,d,495981,495776);k=d+24|0;e=f[k>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(e,i)}e=d+28|0;if((f[161216+(f[e>>2]<<2)>>2]|0)!=4)nbc(f[g>>2]|0,d,495981,4);if(!(b[d+38>>0]|0)){zbc(a,c,d,j);u=h;return}g=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(c,i)}i=j;Nkc(g,a,f[e>>2]&255,f[i>>2]|0,f[i+4>>2]|0,d);u=h;return}function hac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;h=g+8|0;i=g;n[i>>2]=e;j=a+4|0;k=f[j>>2]|0;if((f[d+48>>2]|0)!=(k|0))lbc(k,d,495972,495017);if((f[d+32>>2]|0)==3)lbc(f[j>>2]|0,d,495972,495776);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=6)nbc(f[j>>2]|0,d,495972,6);if(!(b[d+38>>0]|0)){ybc(a,c,d,i);u=g;return}j=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(c,h)}Tkc(j,a,f[l>>2]&255,+n[i>>2],d);u=g;return}function iac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;h=g+8|0;i=g;p[i>>3]=e;j=a+4|0;k=f[j>>2]|0;if((f[d+48>>2]|0)!=(k|0))lbc(k,d,495962,495017);if((f[d+32>>2]|0)==3)lbc(f[j>>2]|0,d,495962,495776);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=5)nbc(f[j>>2]|0,d,495962,5);if(!(b[d+38>>0]|0)){xbc(a,c,d,i);u=g;return}j=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(c,h)}Zkc(j,a,f[l>>2]&255,+p[i>>3],d);u=g;return}function jac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g;i=g+16|0;b[i>>0]=e&1;e=a+4|0;j=f[e>>2]|0;if((f[d+48>>2]|0)!=(j|0))lbc(j,d,495954,495017);if((f[d+32>>2]|0)==3)lbc(f[e>>2]|0,d,495954,495776);j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}k=d+28|0;if((f[161216+(f[k>>2]<<2)>>2]|0)!=7)nbc(f[e>>2]|0,d,495954,7);if(!(b[d+38>>0]|0)){wbc(a,c,d,i);u=g;return}e=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[j>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(c,h)}dlc(e,a,f[k>>2]&255,(b[i>>0]|0)!=0,d);u=g;return}function kac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495944,495017);if((f[d+32>>2]|0)==3)lbc(f[j>>2]|0,d,495944,495776);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=9)nbc(f[j>>2]|0,d,495944,9);j=d+38|0;if(b[j>>0]|0){m=c+(f[a+28>>2]|0)|0;n=f[d+40>>2]|0;o=f[k>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(o,h)}iEc(qlc(m,n,f[l>>2]&255,d)|0,e)|0;u=g;return}l=a+12|0;n=f[l>>2]|0;m=d;h=f[(f[a+8>>2]|0)+(f[n+(((m-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;o=d+52|0;k=f[o>>2]|0;a:do if(!k){p=n;q=33}else{r=a+32|0;s=d+40|0;do if((f[c+((((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[r>>2]|0))>>2]|0)==(f[s>>2]|0)){t=k;v=n}else{Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,k);w=f[o>>2]|0;if(w|0){x=(w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0;f[c+((x<<2)+(f[r>>2]|0))>>2]=f[s>>2];y=f[l>>2]|0;f[c+(f[y+(x+(f[(f[i>>2]|0)+52>>2]|0)<<2)>>2]|0)>>2]=h;t=w;v=y;break}y=f[a+20>>2]|0;if((y|0)==-1)z=b[j>>0]|0;else{w=f[a+16>>2]|0;x=b[j>>0]|0;do if(x<<24>>24){A=f[d+56>>2]|0;if(!A){B=(f[d+20>>2]|0)+80|0;break}else{B=A+40|0;break}}else B=(f[i>>2]|0)+20|0;while(0);A=f[w+(((m-(f[B>>2]|0)|0)/88|0)<<2)>>2]|0;C=c+y+(A>>>5<<2)|0;f[C>>2]=1<<(A&31)|f[C>>2];z=x}C=f[l>>2]|0;do if(z<<24>>24){A=f[d+56>>2]|0;if(!A){D=(f[d+20>>2]|0)+80|0;break}else{D=A+40|0;break}}else D=(f[i>>2]|0)+20|0;while(0);f[c+(f[C+(((m-(f[D>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]=h;p=C;q=33;break a}while(0);x=(t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0;f[c+((x<<2)+(f[r>>2]|0))>>2]=f[s>>2];E=c;F=v+(x+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0}while(0);if((q|0)==33){q=f[a+20>>2]|0;if((q|0)==-1)G=b[j>>0]|0;else{v=f[a+16>>2]|0;t=b[j>>0]|0;do if(t<<24>>24){j=f[d+56>>2]|0;if(!j){H=(f[d+20>>2]|0)+80|0;break}else{H=j+40|0;break}}else H=(f[i>>2]|0)+20|0;while(0);j=f[v+(((m-(f[H>>2]|0)|0)/88|0)<<2)>>2]|0;H=c+q+(j>>>5<<2)|0;f[H>>2]=1<<(j&31)|f[H>>2];G=t}do if(G<<24>>24){t=f[d+56>>2]|0;if(!t){I=(f[d+20>>2]|0)+80|0;break}else{I=t+40|0;break}}else I=(f[i>>2]|0)+20|0;while(0);E=c;F=p+(((m-(f[I>>2]|0)|0)/88|0)<<2)|0}I=E+(f[F>>2]|0)|0;F=f[E+(f[a+24>>2]|0)>>2]|0;a=F&-2;if(!(F&1))J=a;else J=f[a+4>>2]|0;a=f[I>>2]|0;if((a|0)==(h|0)){WJa(I,J,e);u=g;return}else{iEc(a,e)|0;u=g;return}}function lac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[d+12>>2]|0;if((e|0)!=(EYb(c)|0))rbc(f[a+4>>2]|0,c,495936,d);ubc(a,b,c,f[d+8>>2]|0);return}function mac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;k=a+4|0;l=f[k>>2]|0;if((f[d+48>>2]|0)!=(l|0))lbc(l,d,495868,495017);if((f[d+32>>2]|0)==3)lbc(f[k>>2]|0,d,495868,495776);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=8)nbc(f[k>>2]|0,d,495868,8);if((f[(f[(f[k>>2]|0)+8>>2]|0)+44>>2]|0)==3){m=e;ubc(a,c,d,m);u=g;return}if(wYb(EYb(d)|0,e)|0){m=e;ubc(a,c,d,m);u=g;return}rTb(i,2,493760,1297);k=mTb(pTb(mTb(i,495881)|0,e)|0,495126)|0;oTb(j,nTb(k,f[d+4>>2]|0)|0);sTb(i);i=(CYb(d)|0)+8|0;m=f[i>>2]|0;ubc(a,c,d,m);u=g;return}function nac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495853,495017);if((f[d+32>>2]|0)==3)lbc(f[j>>2]|0,d,495853,495776);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=10)nbc(f[j>>2]|0,d,495853,10);if(!e)l=f[a+48>>2]|0;else l=e;e=d+38|0;if(b[e>>0]|0){m=q9b(c+(f[a+28>>2]|0)|0,d,l)|0;u=g;return m|0}l=d+52|0;j=f[l>>2]|0;h=a+12|0;k=f[h>>2]|0;n=f[i>>2]|0;if(!j){o=c+(f[k+(((d-(f[n+20>>2]|0)|0)/88|0)<<2)>>2]|0)|0;p=f[a+20>>2]|0;if((p|0)==-1)q=o;else{r=f[(f[a+16>>2]|0)+(((d-(f[n+20>>2]|0)|0)/88|0)<<2)>>2]|0;s=c+p+(r>>>5<<2)|0;f[s>>2]=1<<(r&31)|f[s>>2];q=o}}else{o=a+32|0;s=d+40|0;if((f[c+((((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[o>>2]|0))>>2]|0)==(f[s>>2]|0))q=c+(f[k+(((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[n+52>>2]|0)<<2)>>2]|0)|0;else{Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,j);j=f[l>>2]|0;if(!j){l=f[a+20>>2]|0;if((l|0)==-1)t=b[e>>0]|0;else{n=f[a+16>>2]|0;k=b[e>>0]|0;do if(k<<24>>24){r=f[d+56>>2]|0;p=d;if(!r){v=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=p-(f[r+40>>2]|0)|0;break}}else v=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);r=f[n+(((v|0)/88|0)<<2)>>2]|0;v=c+l+(r>>>5<<2)|0;f[v>>2]=1<<(r&31)|f[v>>2];t=k}k=f[h>>2]|0;do if(t<<24>>24){v=f[d+56>>2]|0;r=d;if(!v){w=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{w=r-(f[v+40>>2]|0)|0;break}}else w=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);x=k+(((w|0)/88|0)<<2)|0;y=t;z=k}else{k=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;f[c+((k<<2)+(f[o>>2]|0))>>2]=f[s>>2];s=f[h>>2]|0;x=s+(k+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;y=b[e>>0]|0;z=s}s=c+(f[x>>2]|0)|0;x=f[a+8>>2]|0;do if(y<<24>>24){k=f[d+56>>2]|0;o=d;if(!k){A=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{A=o-(f[k+40>>2]|0)|0;break}}else A=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);y=f[x+(f[z+(((A|0)/88|0)<<2)>>2]|0)>>2]|0;A=f[(f[y>>2]|0)+16>>2]|0;z=_i[f[(f[c>>2]|0)+20>>2]&1023](c)|0;x=Mi[A&1023](y,z)|0;f[s>>2]=x;q=s}}s=f[q>>2]|0;if(s|0){m=s;u=g;return m|0}s=f[a+8>>2]|0;a=f[h>>2]|0;do if(b[e>>0]|0){h=f[d+56>>2]|0;x=d;if(!h){B=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{B=x-(f[h+40>>2]|0)|0;break}}else B=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);i=f[s+(f[a+(((B|0)/88|0)<<2)>>2]|0)>>2]|0;B=f[(f[i>>2]|0)+16>>2]|0;a=_i[f[(f[c>>2]|0)+20>>2]&1023](c)|0;c=Mi[B&1023](i,a)|0;f[q>>2]=c;m=c;u=g;return m|0}function oac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(c|0?(e=_i[f[(f[c>>2]|0)+20>>2]&1023](c)|0,(e|0)!=(_i[f[(f[b>>2]|0)+20>>2]&1023](b)|0)):0){if((_i[f[(f[c>>2]|0)+20>>2]&1023](c)|0)==0?_i[f[(f[b>>2]|0)+20>>2]&1023](b)|0:0){Y8b(_i[f[(f[b>>2]|0)+20>>2]&1023](b)|0,c);tbc(a,b,c,d);return}e=hh[f[(f[a>>2]|0)+156>>2]&127](a,b,d,0)|0;mi[f[(f[e>>2]|0)+72>>2]&2047](e,c);return}tbc(a,b,c,d);return}function pac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=sbc(a,b,c,d)|0;d=f[b+(f[a+24>>2]|0)>>2]|0;a=d&-2;if(!(d&1))g=a;else g=f[a+4>>2]|0;if(!((e|0)!=0&(g|0)!=0)){h=e;return h|0}g=_i[f[(f[e>>2]|0)+12>>2]&1023](e)|0;mi[f[(f[g>>2]|0)+72>>2]&2047](g,e);h=g;return h|0}function qac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495744,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495744,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=1)nbc(f[j>>2]|0,d,495744,1);if(b[d+38>>0]|0){l=wkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=f[(f[m+(f[n>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;u=g;return l|0}function rac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495727,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495727,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=2)nbc(f[j>>2]|0,d,495727,2);if(b[d+38>>0]|0){j=Ckc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;l=J;m=j;J=l;u=g;return m|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){n=c;o=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{n=f[a+8>>2]|0;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{n=c;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);i=(f[n+(f[o>>2]|0)+8>>2]|0)+8+(e<<3)|0;l=f[i+4>>2]|0;m=f[i>>2]|0;J=l;u=g;return m|0}function sac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495709,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495709,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=3)nbc(f[j>>2]|0,d,495709,3);if(b[d+38>>0]|0){l=Ikc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=f[(f[m+(f[n>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;u=g;return l|0}function tac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495691,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495691,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=4)nbc(f[j>>2]|0,d,495691,4);if(b[d+38>>0]|0){j=Okc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;l=J;m=j;J=l;u=g;return m|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){n=c;o=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{n=f[a+8>>2]|0;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{n=c;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);i=(f[n+(f[o>>2]|0)+8>>2]|0)+8+(e<<3)|0;l=f[i+4>>2]|0;m=f[i>>2]|0;J=l;u=g;return m|0}function uac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495674,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495674,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=6)nbc(f[j>>2]|0,d,495674,6);if(b[d+38>>0]|0){l=+Ukc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e);u=g;return +l}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;o=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=+n[(f[m+(f[o>>2]|0)+8>>2]|0)+4+(e<<2)>>2];u=g;return +l}function vac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495656,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495656,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=5)nbc(f[j>>2]|0,d,495656,5);if(b[d+38>>0]|0){l=+_kc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e);u=g;return +l}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=+p[(f[m+(f[n>>2]|0)+8>>2]|0)+8+(e<<3)>>3];u=g;return +l}function wac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495640,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495640,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=7)nbc(f[j>>2]|0,d,495640,7);if(b[d+38>>0]|0){l=elc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=(b[(f[m+(f[n>>2]|0)+8>>2]|0)+4+e>>0]|0)!=0;u=g;return l|0}function xac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h;j=e+48|0;k=c+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,e,495622,495017);if((f[e+32>>2]|0)!=3)lbc(f[k>>2]|0,e,495622,494469);l=f[e+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=e;DTb(l,i)}if((f[161216+(f[e+28>>2]<<2)>>2]|0)!=9)nbc(f[k>>2]|0,e,495622,9);if(b[e+38>>0]|0){fEc(a,rlc(d+(f[c+28>>2]|0)|0,f[e+40>>2]|0,g)|0);u=h;return}k=f[e+52>>2]|0;do if(k){i=(k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((i<<2)+(f[c+32>>2]|0))>>2]|0)==(f[e+40>>2]|0)){m=d;n=(f[c+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+i<<2)|0;break}else{m=f[c+8>>2]|0;n=(f[c+12>>2]|0)+(((e-(f[(f[j>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=d;n=(f[c+12>>2]|0)+(((e-(f[(f[j>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);fEc(a,f[(f[m+(f[n>>2]|0)+12>>2]|0)+4+(g<<2)>>2]|0);u=h;return}function yac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=hh[f[(f[a>>2]|0)+204>>2]&127](a,b,c,d)|0;return xYb(EYb(c)|0,e)|0}function zac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495601,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495601,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=8)nbc(f[j>>2]|0,d,495601,8);if(b[d+38>>0]|0){l=mlc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=f[(f[m+(f[n>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;u=g;return l|0}function Aac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495582,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495582,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=10)nbc(f[j>>2]|0,d,495582,10);j=d+38|0;if(b[j>>0]|0){m=wlc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return m|0}n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(n,h)}if((f[l>>2]|0)==11?BYb(d)|0:0){l=f[d+52>>2]|0;do if(!l){h=f[a+12>>2]|0;do if(b[j>>0]|0){n=f[d+56>>2]|0;k=d;if(!n){o=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=k-(f[n+40>>2]|0)|0;break}}else o=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);p=c;q=h+(((o|0)/88|0)<<2)|0}else{n=(l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((n<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){p=c;q=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+n<<2)|0;break}n=f[a+8>>2]|0;k=f[a+12>>2]|0;do if(b[j>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){t=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{t=s-(f[r+40>>2]|0)|0;break}}else t=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);p=n;q=k+(((t|0)/88|0)<<2)|0}while(0);t=(Rdc(p+(f[q>>2]|0)|0)|0)+12|0;m=f[(f[t>>2]|0)+4+(e<<2)>>2]|0;u=g;return m|0}t=f[d+52>>2]|0;do if(!t){q=f[a+12>>2]|0;do if(b[j>>0]|0){p=f[d+56>>2]|0;l=d;if(!p){v=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=l-(f[p+40>>2]|0)|0;break}}else v=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);w=c;x=q+(((v|0)/88|0)<<2)|0}else{k=(t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((k<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){w=c;x=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+k<<2)|0;break}k=f[a+8>>2]|0;n=f[a+12>>2]|0;do if(b[j>>0]|0){p=f[d+56>>2]|0;l=d;if(!p){y=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{y=l-(f[p+40>>2]|0)|0;break}}else y=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);w=k;x=n+(((y|0)/88|0)<<2)|0}while(0);m=f[(f[w+(f[x>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;u=g;return m|0}function Bac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495555,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495555,494469);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=9)nbc(f[j>>2]|0,d,495555,9);if(b[d+38>>0]|0){l=rlc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=f[(f[m+(f[n>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;u=g;return l|0}function Cac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495538,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495538,494469);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(l,i)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=1)nbc(f[k>>2]|0,d,495538,1);if(b[d+38>>0]|0){xkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;f[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;u=h;return}function Dac(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+16|0;j=i;k=d+48|0;l=a+4|0;m=f[l>>2]|0;if((f[k>>2]|0)!=(m|0))lbc(m,d,495521,495017);if((f[d+32>>2]|0)!=3)lbc(f[l>>2]|0,d,495521,494469);m=f[d+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[j>>2]=78728;f[j+4>>2]=1737;b[j+8>>0]=0;f[j+12>>2]=d;DTb(m,j)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=2)nbc(f[l>>2]|0,d,495521,2);if(b[d+38>>0]|0){Dkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g,h);u=i;return}l=f[d+52>>2]|0;j=f[k>>2]|0;if(!l)n=(d-(f[j+20>>2]|0)|0)/88|0;else n=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[j+52>>2]|0)|0;j=(f[c+(f[(f[a+12>>2]|0)+(n<<2)>>2]|0)+8>>2]|0)+8+(e<<3)|0;f[j>>2]=g;f[j+4>>2]=h;u=i;return}function Eac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495503,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495503,494469);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(l,i)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=3)nbc(f[k>>2]|0,d,495503,3);if(b[d+38>>0]|0){Jkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;f[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;u=h;return}function Fac(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+16|0;j=i;k=d+48|0;l=a+4|0;m=f[l>>2]|0;if((f[k>>2]|0)!=(m|0))lbc(m,d,495485,495017);if((f[d+32>>2]|0)!=3)lbc(f[l>>2]|0,d,495485,494469);m=f[d+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[j>>2]=78728;f[j+4>>2]=1737;b[j+8>>0]=0;f[j+12>>2]=d;DTb(m,j)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=4)nbc(f[l>>2]|0,d,495485,4);if(b[d+38>>0]|0){Pkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g,h);u=i;return}l=f[d+52>>2]|0;j=f[k>>2]|0;if(!l)n=(d-(f[j+20>>2]|0)|0)/88|0;else n=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[j+52>>2]|0)|0;j=(f[c+(f[(f[a+12>>2]|0)+(n<<2)>>2]|0)+8>>2]|0)+8+(e<<3)|0;f[j>>2]=g;f[j+4>>2]=h;u=i;return}function Gac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495468,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495468,494469);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(l,i)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=6)nbc(f[k>>2]|0,d,495468,6);if(b[d+38>>0]|0){Vkc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;n[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;u=h;return}function Hac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495450,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495450,494469);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(l,i)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=5)nbc(f[k>>2]|0,d,495450,5);if(b[d+38>>0]|0){$kc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;p[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+8+(e<<3)>>3]=g;u=h;return}function Iac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495434,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495434,494469);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(l,i)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=7)nbc(f[k>>2]|0,d,495434,7);if(b[d+38>>0]|0){flc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;b[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+4+e>>0]=g&1;u=h;return}function Jac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495416,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495416,494469);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(l,i)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=9)nbc(f[k>>2]|0,d,495416,9);if(b[d+38>>0]|0){iEc(slc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0,g)|0;u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;iEc(f[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0,g)|0;u=h;return}function Kac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[g+12>>2]|0;if((h|0)!=(EYb(d)|0))rbc(f[a+4>>2]|0,d,495336,g);h=f[g+8>>2]|0;if(b[d+38>>0]|0){nlc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,h);return}g=f[d+52>>2]|0;i=f[d+48>>2]|0;if(!g)j=(d-(f[i+20>>2]|0)|0)/88|0;else j=((g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;f[(f[c+(f[(f[a+12>>2]|0)+(j<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=h;return}function Lac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+48|0;i=h+24|0;j=h;k=h+40|0;l=d+48|0;m=a+4|0;n=f[m>>2]|0;if((f[l>>2]|0)!=(n|0))lbc(n,d,495336,495017);if((f[d+32>>2]|0)!=3)lbc(f[m>>2]|0,d,495336,494469);n=f[d+24>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(n,i)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=8)nbc(f[m>>2]|0,d,495336,8);if((f[(f[(f[m>>2]|0)+8>>2]|0)+44>>2]|0)!=3?(wYb(EYb(d)|0,g)|0)==0:0){rTb(j,2,493760,1358);m=mTb(pTb(mTb(mTb(j,495352)|0,495409)|0,g)|0,495126)|0;oTb(k,nTb(m,f[d+4>>2]|0)|0);sTb(j);j=(CYb(d)|0)+8|0;o=f[j>>2]|0}else o=g;if(b[d+38>>0]|0){nlc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,o);u=h;return}g=f[d+52>>2]|0;j=f[l>>2]|0;if(!g)p=(d-(f[j+20>>2]|0)|0)/88|0;else p=((g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[j+52>>2]|0)|0;f[(f[c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=o;u=h;return}function Mac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495313,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495313,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=10)nbc(f[j>>2]|0,d,495313,10);j=d+38|0;if(b[j>>0]|0){m=xlc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return m|0}n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(n,h)}if((f[l>>2]|0)==11?BYb(d)|0:0){l=f[d+52>>2]|0;if(!l){h=f[a+12>>2]|0;do if(b[j>>0]|0){n=f[d+56>>2]|0;k=d;if(!n){o=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=k-(f[n+40>>2]|0)|0;break}}else o=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);p=h+(((o|0)/88|0)<<2)|0}else p=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;l=(Sdc(c+(f[p>>2]|0)|0)|0)+12|0;m=f[(f[l>>2]|0)+4+(e<<2)>>2]|0;u=g;return m|0}l=f[d+52>>2]|0;if(!l){p=f[a+12>>2]|0;do if(b[j>>0]|0){o=f[d+56>>2]|0;h=d;if(!o){q=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=h-(f[o+40>>2]|0)|0;break}}else q=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);r=p+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;m=f[(f[c+(f[r>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;u=g;return m|0}function Nac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495304,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495304,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=1)nbc(f[j>>2]|0,d,495304,1);if(b[d+38>>0]|0){j=c+(f[a+28>>2]|0)|0;m=f[d+40>>2]|0;n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(n,h)}ykc(j,m,f[l>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}l=f[d+52>>2]|0;m=f[i>>2]|0;if(!l)o=(d-(f[m+20>>2]|0)|0)/88|0;else o=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(o<<2)>>2]|0)|0;o=f[m>>2]|0;if((o|0)==(f[m+4>>2]|0)){KLa(m,o+1|0);p=f[m>>2]|0}else p=o;o=f[m+8>>2]|0;f[m>>2]=p+1;f[o+4+(p<<2)>>2]=e;u=g;return}function Oac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495295,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495295,494469);l=d+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(m,i)}m=d+28|0;if((f[161216+(f[m>>2]<<2)>>2]|0)!=2)nbc(f[k>>2]|0,d,495295,2);if(b[d+38>>0]|0){k=c+(f[a+28>>2]|0)|0;n=f[d+40>>2]|0;o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(o,i)}Ekc(k,n,f[m>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,g,d);u=h;return}m=f[d+52>>2]|0;n=f[j>>2]|0;if(!m)p=(d-(f[n+20>>2]|0)|0)/88|0;else p=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[n+52>>2]|0)|0;n=c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)|0;p=f[n>>2]|0;if((p|0)==(f[n+4>>2]|0)){UHa(n,p+1|0);q=f[n>>2]|0}else q=p;p=f[n+8>>2]|0;f[n>>2]=q+1;n=p+8+(q<<3)|0;f[n>>2]=e;f[n+4>>2]=g;u=h;return}function Pac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495285,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495285,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=3)nbc(f[j>>2]|0,d,495285,3);if(b[d+38>>0]|0){j=c+(f[a+28>>2]|0)|0;m=f[d+40>>2]|0;n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(n,h)}Kkc(j,m,f[l>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}l=f[d+52>>2]|0;m=f[i>>2]|0;if(!l)o=(d-(f[m+20>>2]|0)|0)/88|0;else o=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(o<<2)>>2]|0)|0;o=f[m>>2]|0;if((o|0)==(f[m+4>>2]|0)){OLa(m,o+1|0);p=f[m>>2]|0}else p=o;o=f[m+8>>2]|0;f[m>>2]=p+1;f[o+4+(p<<2)>>2]=e;u=g;return}function Qac(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495275,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495275,494469);l=d+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(m,i)}m=d+28|0;if((f[161216+(f[m>>2]<<2)>>2]|0)!=4)nbc(f[k>>2]|0,d,495275,4);if(b[d+38>>0]|0){k=c+(f[a+28>>2]|0)|0;n=f[d+40>>2]|0;o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(o,i)}Qkc(k,n,f[m>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,g,d);u=h;return}m=f[d+52>>2]|0;n=f[j>>2]|0;if(!m)p=(d-(f[n+20>>2]|0)|0)/88|0;else p=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[n+52>>2]|0)|0;n=c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)|0;p=f[n>>2]|0;if((p|0)==(f[n+4>>2]|0)){Hjb(n,p+1|0);q=f[n>>2]|0}else q=p;p=f[n+8>>2]|0;f[n>>2]=q+1;n=p+8+(q<<3)|0;f[n>>2]=e;f[n+4>>2]=g;u=h;return}function Rac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495266,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495266,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=6)nbc(f[j>>2]|0,d,495266,6);if(b[d+38>>0]|0){j=c+(f[a+28>>2]|0)|0;m=f[d+40>>2]|0;o=f[k>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(o,h)}Wkc(j,m,f[l>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}l=f[d+52>>2]|0;m=f[i>>2]|0;if(!l)p=(d-(f[m+20>>2]|0)|0)/88|0;else p=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)|0;p=f[m>>2]|0;if((p|0)==(f[m+4>>2]|0)){SHa(m,p+1|0);q=f[m>>2]|0}else q=p;p=f[m+8>>2]|0;f[m>>2]=q+1;n[p+4+(q<<2)>>2]=e;u=g;return}function Sac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495256,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495256,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=5)nbc(f[j>>2]|0,d,495256,5);if(b[d+38>>0]|0){j=c+(f[a+28>>2]|0)|0;m=f[d+40>>2]|0;n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(n,h)}alc(j,m,f[l>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}l=f[d+52>>2]|0;m=f[i>>2]|0;if(!l)o=(d-(f[m+20>>2]|0)|0)/88|0;else o=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(o<<2)>>2]|0)|0;o=f[m>>2]|0;if((o|0)==(f[m+4>>2]|0)){THa(m,o+1|0);q=f[m>>2]|0}else q=o;o=f[m+8>>2]|0;f[m>>2]=q+1;p[o+8+(q<<3)>>3]=e;u=g;return}function Tac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=e&1;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))lbc(l,d,495248,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495248,494469);l=d+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(m,h)}m=d+28|0;if((f[161216+(f[m>>2]<<2)>>2]|0)!=7)nbc(f[k>>2]|0,d,495248,7);if(b[d+38>>0]|0){k=c+(f[a+28>>2]|0)|0;n=f[d+40>>2]|0;o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(o,h)}glc(k,n,f[m>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}e=f[d+52>>2]|0;m=f[j>>2]|0;if(!e)p=(d-(f[m+20>>2]|0)|0)/88|0;else p=((e-(f[(f[e+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)|0;p=f[m>>2]|0;if((p|0)==(f[m+4>>2]|0)){zNa(m,p+1|0);q=f[m>>2]|0}else q=p;p=f[m+8>>2]|0;f[m>>2]=q+1;b[p+4+q>>0]=i;u=g;return}function Uac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495238,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495238,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=9)nbc(f[j>>2]|0,d,495238,9);if(!(b[d+38>>0]|0)){j=f[d+52>>2]|0;m=f[i>>2]|0;if(!j)n=(d-(f[m+20>>2]|0)|0)/88|0;else n=((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;iEc(JLa(c+(f[(f[a+12>>2]|0)+(n<<2)>>2]|0)|0)|0,e)|0;u=g;return}else{n=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(c,h)}iEc(tlc(n,a,f[l>>2]&255,d)|0,e)|0;u=g;return}}function Vac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[d+12>>2]|0;if((e|0)!=(EYb(c)|0))rbc(f[a+4>>2]|0,c,495063,d);qbc(a,b,c,f[d+8>>2]|0);return}function Wac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;k=a+4|0;l=f[k>>2]|0;if((f[d+48>>2]|0)!=(l|0))lbc(l,d,495063,495017);if((f[d+32>>2]|0)!=3)lbc(f[k>>2]|0,d,495063,494469);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=8)nbc(f[k>>2]|0,d,495063,8);if((f[(f[(f[k>>2]|0)+8>>2]|0)+44>>2]|0)==3){m=e;qbc(a,c,d,m);u=g;return}if(wYb(EYb(d)|0,e)|0){m=e;qbc(a,c,d,m);u=g;return}rTb(i,2,493760,1399);k=mTb(pTb(mTb(i,495071)|0,e)|0,495126)|0;oTb(j,nTb(k,f[d+4>>2]|0)|0);sTb(i);i=(CYb(d)|0)+8|0;m=f[i>>2]|0;qbc(a,c,d,m);u=g;return}function Xac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495052,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,495052,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=10)nbc(f[j>>2]|0,d,495052,10);if(!e)m=f[a+48>>2]|0;else m=e;e=d+38|0;if(b[e>>0]|0){n=u9b(c+(f[a+28>>2]|0)|0,d,m)|0;u=g;return n|0}j=f[k>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(j,h)}if((f[l>>2]|0)==11?BYb(d)|0:0){l=f[d+52>>2]|0;if(!l){h=f[a+12>>2]|0;do if(b[e>>0]|0){j=f[d+56>>2]|0;k=d;if(!j){o=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=k-(f[j+40>>2]|0)|0;break}}else o=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);p=h+(((o|0)/88|0)<<2)|0}else p=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;q=Sdc(c+(f[p>>2]|0)|0)|0}else{p=f[d+52>>2]|0;if(!p){l=f[a+12>>2]|0;do if(b[e>>0]|0){o=f[d+56>>2]|0;h=d;if(!o){r=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=h-(f[o+40>>2]|0)|0;break}}else r=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);s=l+(((r|0)/88|0)<<2)|0}else s=(f[a+12>>2]|0)+(((p-(f[(f[p+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;q=c+(f[s>>2]|0)|0}s=q+12|0;i=f[s>>2]|0;p=q+4|0;a=f[p>>2]|0;if((i|0)!=0?(a|0)<(f[i>>2]|0):0){r=a+1|0;f[p>>2]=r;l=f[i+4+(a<<2)>>2]|0;if(!l)t=r;else{n=l;u=g;return n|0}}else t=a;if(!t){t=f[(f[m>>2]|0)+8>>2]|0;a=DYb(d)|0;v=Mi[t&1023](m,a)|0}else v=f[i+4>>2]|0;i=f[(f[v>>2]|0)+16>>2]|0;a=_i[f[(f[c>>2]|0)+20>>2]&1023](c)|0;c=Mi[i&1023](v,a)|0;a=f[s>>2]|0;v=f[q+8>>2]|0;do if((a|0)!=0?(i=f[p>>2]|0,(i|0)!=(v|0)):0){m=f[a>>2]|0;if((m|0)==(v|0)){t=f[a+4+(i<<2)>>2]|0;if((t|0)==0|(f[q>>2]|0)!=0){w=a;break}Yi[f[(f[t>>2]|0)+4>>2]&2047](t);w=f[s>>2]|0;break}if((i|0)<(m|0)){f[a+4+(m<<2)>>2]=f[a+4+(i<<2)>>2];i=f[s>>2]|0;x=i;y=f[i>>2]|0}else{x=a;y=m}f[x>>2]=y+1;w=x}else z=45;while(0);if((z|0)==45){USb(q,v+1|0);v=f[s>>2]|0;f[v>>2]=(f[v>>2]|0)+1;w=v}v=f[p>>2]|0;f[p>>2]=v+1;f[w+4+(v<<2)>>2]=c;n=c;u=g;return n|0}function Yac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,494997,495017);if((f[d+32>>2]|0)!=3)lbc(f[j>>2]|0,d,494997,494469);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=10)nbc(f[j>>2]|0,d,494997,10);j=d+38|0;if(b[j>>0]|0){w9b(c+(f[a+28>>2]|0)|0,d,e);u=g;return}m=f[k>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(m,h)}if((f[l>>2]|0)==11?BYb(d)|0:0){l=f[d+52>>2]|0;if(!l){h=f[a+12>>2]|0;do if(b[j>>0]|0){m=f[d+56>>2]|0;k=d;if(!m){n=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=k-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);o=h+(((n|0)/88|0)<<2)|0}else o=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;p=Sdc(c+(f[o>>2]|0)|0)|0}else{o=f[d+52>>2]|0;if(!o){l=f[a+12>>2]|0;do if(b[j>>0]|0){n=f[d+56>>2]|0;h=d;if(!n){q=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=h-(f[n+40>>2]|0)|0;break}}else q=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);r=l+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;p=c+(f[r>>2]|0)|0}r=Bhc(e)|0;c=f[p>>2]|0;if(((c|0)==(r|0)?(r=p+12|0,i=f[r>>2]|0,i|0):0)?(o=f[i>>2]|0,(o|0)<(f[p+8>>2]|0)):0){a=p+4|0;q=f[a>>2]|0;if((q|0)<(o|0)){l=i+4+(q<<2)|0;f[i+4+(o<<2)>>2]=f[l>>2];s=l}else s=i+4+(q<<2)|0;f[s>>2]=e;f[a>>2]=q+1;q=f[r>>2]|0;f[q>>2]=(f[q>>2]|0)+1;u=g;return}obc(p,e,Ahc(e)|0,c);u=g;return}function Zac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;if((f[a+28>>2]|0)==-1){g=0;u=d;return g|0}h=a+44|0;i=nYb(f[h>>2]|0,c)|0;if(i){j=a+4|0;k=f[j>>2]|0;if((f[i+48>>2]|0)==(k|0)){g=i;u=d;return g|0}else{l=j;m=k}}else{k=a+4|0;l=k;m=f[k>>2]|0}if(!(b[(f[m+16>>2]|0)+48>>0]|0)){g=0;u=d;return g|0}m=mYb(f[h>>2]|0,c)|0;if(!m){g=0;u=d;return g|0}c=f[m+72>>2]|0;if((c|0)<=0){g=0;u=d;return g|0}h=m+40|0;k=e+4|0;a=e+8|0;j=e+12|0;i=0;while(1){n=f[h>>2]|0;o=n+(i*88|0)|0;if((f[n+(i*88|0)+48>>2]|0)==(f[l>>2]|0)){p=f[n+(i*88|0)+24>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[e>>2]=78728;f[k>>2]=1737;b[a>>0]=0;f[j>>2]=o;DTb(p,e)}if(((f[n+(i*88|0)+28>>2]|0)==11?(f[n+(i*88|0)+32>>2]|0)==1:0)?(DYb(o)|0)==(m|0):0){g=o;q=17;break}}i=i+1|0;if((i|0)>=(c|0)){g=0;q=17;break}}if((q|0)==17){u=d;return g|0}return 0}function _ac(a,b){a=a|0;b=b|0;var c=0;if((f[a+28>>2]|0)==-1){c=0;return c|0}c=oYb(f[a+44>>2]|0,f[a+4>>2]|0,b)|0;return c|0}function $ac(a){a=a|0;return (f[(f[(f[a+4>>2]|0)+8>>2]|0)+44>>2]|0)==3|0}function abc(a){a=a|0;return f[a+48>>2]|0}function bbc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+80|0;j=i+48|0;k=i+24|0;l=i+65|0;m=i;n=i+64|0;if((f[d+32>>2]|0)!=3)lbc(f[a+4>>2]|0,d,494947,494469);o=d+24|0;p=f[o>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[j>>2]=78728;f[j+4>>2]=1737;b[j+8>>0]=0;f[j+12>>2]=d;DTb(p,j)}p=d+28|0;if((f[161216+(f[p>>2]<<2)>>2]|0)!=(e|0))nbc(f[a+4>>2]|0,d,494973,e);if((g|0)>-1?(f[(f[d+68>>2]|0)+48>>2]|0)!=(g|0):0){rTb(k,3,493760,1692);oTb(l,mTb(mTb(k,494546)|0,494600)|0);sTb(k)}if(h|0?(DYb(d)|0)!=(h|0):0){rTb(m,3,493760,1694);oTb(n,mTb(mTb(m,494617)|0,494667)|0);sTb(m)}m=d+38|0;if(b[m>>0]|0){n=c+(f[a+28>>2]|0)|0;h=f[d+40>>2]|0;k=f[o>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[j>>2]=78728;f[j+4>>2]=1737;b[j+8>>0]=0;f[j+12>>2]=d;DTb(k,j)}k=f[p>>2]&255;q=ilc(n,h,k,FYb(d)|0,d)|0;u=i;return q|0}k=f[o>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[j>>2]=78728;f[j+4>>2]=1737;b[j+8>>0]=0;f[j+12>>2]=d;DTb(k,j)}if((f[p>>2]|0)==11?BYb(d)|0:0){p=f[a+12>>2]|0;do if(b[m>>0]|0){j=f[d+56>>2]|0;k=d;if(!j){r=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=k-(f[j+40>>2]|0)|0;break}}else r=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=Sdc(c+(f[p+(((r|0)/88|0)<<2)>>2]|0)|0)|0;u=i;return q|0}r=f[a+12>>2]|0;do if(b[m>>0]|0){a=f[d+56>>2]|0;p=d;if(!a){s=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=p-(f[a+40>>2]|0)|0;break}}else s=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=c+(f[r+(((s|0)/88|0)<<2)>>2]|0)|0;u=i;return q|0}function cbc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+80|0;j=i+48|0;k=i+24|0;l=i+65|0;m=i;n=i+64|0;if((f[d+32>>2]|0)!=3)lbc(f[a+4>>2]|0,d,494447,494469);o=d+24|0;p=f[o>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[j>>2]=78728;f[j+4>>2]=1737;b[j+8>>0]=0;f[j+12>>2]=d;DTb(p,j)}p=d+28|0;if((f[161216+(f[p>>2]<<2)>>2]|0)!=(e|0))nbc(f[a+4>>2]|0,d,494526,e);if((g|0)>-1?(f[(f[d+68>>2]|0)+48>>2]|0)!=(g|0):0){rTb(k,3,493760,1717);oTb(l,mTb(mTb(k,494546)|0,494600)|0);sTb(k)}if(h|0?(DYb(d)|0)!=(h|0):0){rTb(m,3,493760,1719);oTb(n,mTb(mTb(m,494617)|0,494667)|0);sTb(m)}m=d+38|0;if(b[m>>0]|0){n=c+(f[a+28>>2]|0)|0;h=f[d+40>>2]|0;k=f[o>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[j>>2]=78728;f[j+4>>2]=1737;b[j+8>>0]=0;f[j+12>>2]=d;DTb(k,j)}k=f[p>>2]&255;q=ilc(n,h,k,FYb(d)|0,d)|0;u=i;return q|0}k=f[o>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[j>>2]=78728;f[j+4>>2]=1737;b[j+8>>0]=0;f[j+12>>2]=d;DTb(k,j)}if((f[p>>2]|0)==11?BYb(d)|0:0){p=f[a+12>>2]|0;do if(b[m>>0]|0){j=f[d+56>>2]|0;k=d;if(!j){r=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=k-(f[j+40>>2]|0)|0;break}}else r=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=Rdc(c+(f[p+(((r|0)/88|0)<<2)>>2]|0)|0)|0;u=i;return q|0}r=f[a+12>>2]|0;do if(b[m>>0]|0){a=f[d+56>>2]|0;p=d;if(!a){s=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=p-(f[a+40>>2]|0)|0;break}}else s=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=c+(f[r+(((s|0)/88|0)<<2)>>2]|0)|0;u=i;return q|0}function dbc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+96|0;i=h+72|0;j=h+48|0;k=h+24|0;l=h+89|0;m=h;n=h+88|0;if((f[d+32>>2]|0)!=3){rTb(j,3,493760,2183);oTb(h+90|0,mTb(j,499570)|0);sTb(j)}j=d+24|0;o=f[j>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(o,i)}o=d+28|0;if((f[161216+(f[o>>2]<<2)>>2]|0)!=(e|0)){p=f[j>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(p,i)}if(!((e|0)==1?(f[161216+(f[o>>2]<<2)>>2]|0)==8:0)){rTb(k,3,493760,2186);oTb(l,mTb(mTb(mTb(mTb(k,494097)|0,494245)|0,494308)|0,494373)|0);sTb(k)}}if(g|0?(DYb(d)|0)!=(g|0):0){rTb(m,3,493760,2191);oTb(n,mTb(m,494389)|0);sTb(m)}if(!(b[d+38>>0]|0)){q=c+(f[(f[a+12>>2]|0)+(((d-(f[(f[d+48>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0)|0;u=h;return q|0}m=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[j>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(c,i)}i=f[o>>2]&255;q=ilc(m,a,i,FYb(d)|0,d)|0;u=h;return q|0}function ebc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+16|0;h=g;i=f[d+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(i,h)}if(!((f[d+28>>2]|0)==11?BYb(d)|0:0))lbc(f[a+4>>2]|0,d,494080,493734);h=f[d+52>>2]|0;if(!h){i=f[a+12>>2]|0;do if(b[d+38>>0]|0){j=f[d+56>>2]|0;k=d;if(!j){l=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{l=k-(f[j+40>>2]|0)|0;break}}else l=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);m=c;n=i+(((l|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=Mi[s&1023](p,e)|0;u=g;return t|0}l=(h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((l<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+l<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=Mi[s&1023](p,e)|0;u=g;return t|0}l=f[a+8>>2]|0;c=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;h=d;if(!a){v=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=h-(f[a+40>>2]|0)|0;break}}else v=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);m=l;n=c+(((v|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=Mi[s&1023](p,e)|0;u=g;return t|0}function fbc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+32|0;i=h+16|0;j=h;k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=d;DTb(k,i)}if(!((f[d+28>>2]|0)==11?BYb(d)|0:0))lbc(f[a+4>>2]|0,d,494055,493734);k=DYb(d)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;l=j+11|0;b[l>>0]=5;b[j>>0]=b[498520]|0;b[j+1>>0]=b[498521]|0;b[j+2>>0]=b[498522]|0;b[j+3>>0]=b[498523]|0;b[j+4>>0]=b[498524]|0;b[j+5>>0]=0;m=uYb(k,j)|0;k=f[m+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[i>>2]=78728;f[i+4>>2]=1737;b[i+8>>0]=0;f[i+12>>2]=m;DTb(k,i)}f[g+4>>2]=f[161216+(f[m+28>>2]<<2)>>2];if((b[l>>0]|0)<0)YDc(f[j>>2]|0);j=f[d+52>>2]|0;if(j|0){n=(f[a+12>>2]|0)+(((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)|0;o=f[n>>2]|0;p=c+o|0;q=f[p>>2]|0;r=q+12|0;s=f[r>>2]|0;t=hj[s&511](p,e,g)|0;u=h;return t|0}j=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){v=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=l-(f[a+40>>2]|0)|0;break}}else v=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);n=j+(((v|0)/88|0)<<2)|0;o=f[n>>2]|0;p=c+o|0;q=f[p>>2]|0;r=q+12|0;s=f[r>>2]|0;t=hj[s&511](p,e,g)|0;u=h;return t|0}function gbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=f[d+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(i,h)}if(!((f[d+28>>2]|0)==11?BYb(d)|0:0))lbc(f[a+4>>2]|0,d,494038,493734);h=f[d+52>>2]|0;if(h|0){j=(f[a+12>>2]|0)+(((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)|0;k=f[j>>2]|0;l=c+k|0;m=f[l>>2]|0;n=m+16|0;o=f[n>>2]|0;p=Mi[o&1023](l,e)|0;u=g;return p|0}h=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;i=d;if(!a){q=i-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=i-(f[a+40>>2]|0)|0;break}}else q=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);j=h+(((q|0)/88|0)<<2)|0;k=f[j>>2]|0;l=c+k|0;m=f[l>>2]|0;n=m+16|0;o=f[n>>2]|0;p=Mi[o&1023](l,e)|0;u=g;return p|0}function hbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g;i=f[e+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(i,h)}if(!((f[e+28>>2]|0)==11?BYb(e)|0:0))lbc(f[c+4>>2]|0,e,494027,493734);mbc(a,d,e);h=f[e+52>>2]|0;if(!h){i=f[c+12>>2]|0;do if(b[e+38>>0]|0){j=f[e+56>>2]|0;k=e;if(!j){l=k-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{l=k-(f[j+40>>2]|0)|0;break}}else l=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=d;n=i+(((l|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+24|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}l=(h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((l<<2)+(f[c+32>>2]|0))>>2]|0)==(f[e+40>>2]|0)){m=d;n=(f[c+12>>2]|0)+((f[(f[e+48>>2]|0)+52>>2]|0)+l<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+24|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}l=f[c+8>>2]|0;d=f[c+12>>2]|0;do if(b[e+38>>0]|0){c=f[e+56>>2]|0;h=e;if(!c){t=h-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{t=h-(f[c+40>>2]|0)|0;break}}else t=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=l;n=d+(((t|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+24|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}function ibc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g;i=f[e+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(i,h)}if(!((f[e+28>>2]|0)==11?BYb(e)|0:0))lbc(f[c+4>>2]|0,e,494018,493734);mbc(a,d,e);h=f[e+52>>2]|0;if(!h){i=f[c+12>>2]|0;do if(b[e+38>>0]|0){j=f[e+56>>2]|0;k=e;if(!j){l=k-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{l=k-(f[j+40>>2]|0)|0;break}}else l=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=d;n=i+(((l|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+28|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}l=(h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((l<<2)+(f[c+32>>2]|0))>>2]|0)==(f[e+40>>2]|0)){m=d;n=(f[c+12>>2]|0)+((f[(f[e+48>>2]|0)+52>>2]|0)+l<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+28|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}l=f[c+8>>2]|0;d=f[c+12>>2]|0;do if(b[e+38>>0]|0){c=f[e+56>>2]|0;h=e;if(!c){t=h-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{t=h-(f[c+40>>2]|0)|0;break}}else t=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=l;n=d+(((t|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+28|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}function jbc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e;h=f[d+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(h,g)}if(!((f[d+28>>2]|0)==11?BYb(d)|0:0))lbc(f[a+4>>2]|0,d,494008,493734);g=f[d+52>>2]|0;if(!g){h=f[a+12>>2]|0;do if(b[d+38>>0]|0){i=f[d+56>>2]|0;j=d;if(!i){k=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{k=j-(f[i+40>>2]|0)|0;break}}else k=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);l=c;m=h+(((k|0)/88|0)<<2)|0;n=f[m>>2]|0;o=l+n|0;p=f[o>>2]|0;q=p+32|0;r=f[q>>2]|0;s=_i[r&1023](o)|0;u=e;return s|0}k=(g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((k<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+k<<2)|0;n=f[m>>2]|0;o=l+n|0;p=f[o>>2]|0;q=p+32|0;r=f[q>>2]|0;s=_i[r&1023](o)|0;u=e;return s|0}k=f[a+8>>2]|0;c=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;g=d;if(!a){t=g-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{t=g-(f[a+40>>2]|0)|0;break}}else t=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);l=k;m=c+(((t|0)/88|0)<<2)|0;n=f[m>>2]|0;o=l+n|0;p=f[o>>2]|0;q=p+32|0;r=f[q>>2]|0;s=_i[r&1023](o)|0;u=e;return s|0}function kbc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=f[d+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(h,g)}if(!((f[d+28>>2]|0)==11?BYb(d)|0:0))lbc(f[a+4>>2]|0,d,493721,493734);g=f[d+52>>2]|0;if(g|0){i=(f[a+12>>2]|0)+(((g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)|0;j=f[i>>2]|0;k=c+j|0;u=e;return k|0}g=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;h=d;if(!a){l=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{l=h-(f[a+40>>2]|0)|0;break}}else l=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);i=g+(((l|0)/88|0)<<2)|0;j=f[i>>2]|0;k=c+j|0;u=e;return k|0}function lbc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;rTb(g,3,493760,101);h=mTb(mTb(mTb(g,493867)|0,c)|0,493954)|0;c=mTb(nTb(h,f[a+4>>2]|0)|0,493972)|0;oTb(e+24|0,mTb(mTb(nTb(c,f[b+4>>2]|0)|0,493990)|0,d)|0);sTb(g);u=e;return}function mbc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e+16|0;h=e;i=a+8|0;j=a+16|0;f[j>>2]=0;f[a+24>>2]=0;k=a+28|0;f[k>>2]=0;l=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;m=hj[f[(f[l>>2]|0)+364>>2]&511](l,c,d)|0;c=a+4|0;f[c>>2]=m;m=DYb(d)|0;l=h+4|0;f[l>>2]=0;f[l+4>>2]=0;l=h+11|0;b[l>>0]=3;b[h>>0]=b[498516]|0;b[h+1>>0]=b[498517]|0;b[h+2>>0]=b[498518]|0;b[h+3>>0]=0;n=uYb(m,h)|0;m=f[n+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=n;DTb(m,g)}m=f[161216+(f[n+28>>2]<<2)>>2]|0;n=f[j>>2]|0;if((n|0)!=(m|0)){if((n|0)==9?(n=f[i>>2]|0,n|0):0){if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);YDc(n)}f[j>>2]=m;if((m|0)==9){m=VDc(12)|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[i>>2]=m}}if((b[l>>0]|0)<0)YDc(f[h>>2]|0);l=DYb(d)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=h+11|0;b[d>>0]=5;b[h>>0]=b[498520]|0;b[h+1>>0]=b[498521]|0;b[h+2>>0]=b[498522]|0;b[h+3>>0]=b[498523]|0;b[h+4>>0]=b[498524]|0;b[h+5>>0]=0;m=uYb(l,h)|0;l=f[m+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=m;DTb(l,g)}f[k>>2]=f[161216+(f[m+28>>2]<<2)>>2];if((b[d>>0]|0)>=0){o=f[c>>2]|0;p=f[o>>2]|0;q=p+48|0;r=f[q>>2]|0;mi[r&2047](o,a);u=e;return}YDc(f[h>>2]|0);o=f[c>>2]|0;p=f[o>>2]|0;q=p+48|0;r=f[q>>2]|0;mi[r&2047](o,a);u=e;return}function nbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;rTb(i,3,493760,127);k=mTb(mTb(mTb(i,493867)|0,d)|0,493954)|0;d=mTb(nTb(k,f[a+4>>2]|0)|0,493972)|0;a=mTb(nTb(d,f[c+4>>2]|0)|0,494689)|0;d=mTb(mTb(a,f[167044+(e<<2)>>2]|0)|0,494769)|0;e=f[c+24>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=c;DTb(e,h)}oTb(j,mTb(d,f[167044+(f[161216+(f[c+28>>2]<<2)>>2]<<2)>>2]|0)|0);sTb(i);u=g;return}function obc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){e=zhc(b,d)|0;pbc(b,e);if((b|0)==0|(c|0)!=0)g=e;else{Yi[f[(f[b>>2]|0)+4>>2]&2047](b);g=e}}else g=b;else{Y8b(d,b);g=b}b=a+12|0;d=f[b>>2]|0;e=f[a+8>>2]|0;c=a+4|0;do if((d|0)!=0?(h=f[c>>2]|0,(h|0)!=(e|0)):0){i=f[d>>2]|0;if((i|0)==(e|0)){j=f[d+4+(h<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;break}Yi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0;break}if((h|0)<(i|0)){f[d+4+(i<<2)>>2]=f[d+4+(h<<2)>>2];h=f[b>>2]|0;l=h;m=f[h>>2]|0}else{l=d;m=i}f[l>>2]=m+1;k=l}else n=8;while(0);if((n|0)==8){USb(a,e+1|0);e=f[b>>2]|0;f[e>>2]=(f[e>>2]|0)+1;k=e}e=f[c>>2]|0;f[c>>2]=e+1;f[k+4+(e<<2)>>2]=g;return}function pbc(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+76>>2]&2047](b,a);return}function qbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g;if(b[d+38>>0]|0){i=c+(f[a+28>>2]|0)|0;j=f[d+40>>2]|0;k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(k,h)}olc(i,j,f[d+28>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}j=f[d+52>>2]|0;i=f[d+48>>2]|0;if(!j)l=(d-(f[i+20>>2]|0)|0)/88|0;else l=((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;i=c+(f[(f[a+12>>2]|0)+(l<<2)>>2]|0)|0;l=f[i>>2]|0;if((l|0)==(f[i+4>>2]|0)){KLa(i,l+1|0);m=f[i>>2]|0}else m=l;l=f[i+8>>2]|0;f[i>>2]=m+1;f[l+4+(m<<2)>>2]=e;u=g;return}function rbc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;rTb(g,3,493760,140);h=mTb(mTb(mTb(g,493867)|0,c)|0,493954)|0;c=mTb(nTb(h,f[a+4>>2]|0)|0,493972)|0;a=mTb(nTb(c,f[b+4>>2]|0)|0,495149)|0;c=(EYb(b)|0)+4|0;b=mTb(nTb(a,f[c>>2]|0)|0,495220)|0;oTb(e+24|0,nTb(b,f[d+4>>2]|0)|0);sTb(g);u=e;return}function sbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,d,495761,495017);k=d+32|0;if((f[k>>2]|0)==3)lbc(f[j>>2]|0,d,495761,495776);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(l,h)}if((f[161216+(f[d+28>>2]<<2)>>2]|0)!=10)nbc(f[j>>2]|0,d,495761,10);if(!e)m=f[a+48>>2]|0;else m=e;if(b[d+38>>0]|0){n=r9b(c+(f[a+28>>2]|0)|0,d,m)|0;u=g;return n|0}m=f[d+52>>2]|0;e=(m|0)==0;if((f[k>>2]|0)==3)if(e)o=21;else o=19;else if(e){e=f[a+20>>2]|0;if((e|0)==-1)o=21;else{k=f[(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0;j=c+e+(k>>>5<<2)|0;f[j>>2]=f[j>>2]&~(1<<(k&31));o=21}}else o=19;do if((o|0)==19){k=(m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0;j=c+((k<<2)+(f[a+32>>2]|0))|0;if((f[j>>2]|0)==(f[d+40>>2]|0)){f[j>>2]=0;p=c;q=(f[a+12>>2]|0)+(k+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;break}else{n=0;u=g;return n|0}}else if((o|0)==21){p=c;q=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);i=p+(f[q>>2]|0)|0;q=f[i>>2]|0;f[i>>2]=0;n=q;u=g;return n|0}function tbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g;i=e+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))lbc(k,e,495833,495017);if((f[e+32>>2]|0)==3)lbc(f[j>>2]|0,e,495833,495776);k=e+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(l,h)}l=e+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)!=10)nbc(f[j>>2]|0,e,495833,10);j=e+38|0;if(b[j>>0]|0){m=c+(f[a+28>>2]|0)|0;n=f[e+40>>2]|0;o=f[k>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(o,h)}vlc(m,n,f[l>>2]&255,e,d);u=g;return}l=e+52|0;n=f[l>>2]|0;m=(d|0)==0;if(n|0){Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,n);if(m){u=g;return}n=f[l>>2]|0;if(!n){h=f[a+12>>2]|0;do if(b[j>>0]|0){o=f[e+56>>2]|0;k=e;if(!o){p=k-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{p=k-(f[o+40>>2]|0)|0;break}}else p=e-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);q=h+(((p|0)/88|0)<<2)|0}else q=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[q>>2]|0)>>2]=d;q=f[l>>2]|0;f[c+((((q-(f[(f[q+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[e+40>>2];u=g;return}q=f[a+20>>2]|0;l=(q|0)==-1;if(m){if(!l){m=f[(f[a+16>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0;n=c+q+(m>>>5<<2)|0;f[n>>2]=f[n>>2]&~(1<<(m&31))}}else if(!l){l=f[(f[a+16>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0;m=c+q+(l>>>5<<2)|0;f[m>>2]=1<<(l&31)|f[m>>2]}m=c+(f[(f[a+12>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0)|0;i=f[c+(f[a+24>>2]|0)>>2]|0;a=i&-2;if(!(i&1))r=a;else r=f[a+4>>2]|0;if((r|0)==0?(r=f[m>>2]|0,r|0):0)Yi[f[(f[r>>2]|0)+4>>2]&2047](r);f[m>>2]=d;u=g;return}function ubc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+8|0;i=g;f[i>>2]=e;if(!(b[d+38>>0]|0)){vbc(a,c,d,i);u=g;return}e=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[d+24>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=d;DTb(c,h)}llc(e,a,f[d+28>>2]&255,f[i>>2]|0,d);u=g;return}function vbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=f[e>>2]|0;else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,h);j=f[g>>2]|0;k=f[e>>2]|0;if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=f[e>>2]|0}f[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>2]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;e=d;if(!m){n=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=e-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);f[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>2]=i;i=f[a+20>>2]|0;if((i|0)==-1)return;n=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){o=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[n+(((o|0)/88|0)<<2)>>2]|0;o=c+i+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function wbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=b[e>>0]|0;else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,h);j=f[g>>2]|0;k=b[e>>0]|0;if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=b[e>>0]|0}b[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>0]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;e=d;if(!m){n=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=e-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);b[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>0]=i;i=f[a+20>>2]|0;if((i|0)==-1)return;n=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){o=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[n+(((o|0)/88|0)<<2)>>2]|0;o=c+i+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function xbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=+p[e>>3];else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,h);j=f[g>>2]|0;k=+p[e>>3];if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=+p[e>>3]}p[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>3]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){e=f[d+56>>2]|0;h=d;if(!e){n=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=h-(f[e+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);p[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>3]=i;n=f[a+20>>2]|0;if((n|0)==-1)return;l=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;e=d;if(!a){o=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=e-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[l+(((o|0)/88|0)<<2)>>2]|0;o=c+n+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function ybc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=f[e>>2]|0;else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,h);j=f[g>>2]|0;k=f[e>>2]|0;if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=f[e>>2]|0}f[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>2]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;e=d;if(!m){n=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=e-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);f[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>2]=i;i=f[a+20>>2]|0;if((i|0)==-1)return;n=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){o=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[n+(((o|0)/88|0)<<2)>>2]|0;o=c+i+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function zbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=e;j=f[i>>2]|0;k=f[i+4>>2]|0}else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,h);i=f[g>>2]|0;l=e;m=f[l>>2]|0;n=f[l+4>>2]|0;if(!i){j=m;k=n;break}else{o=i;p=m;q=n}}else{n=e;o=h;p=f[n>>2]|0;q=f[n+4>>2]|0}n=c+(f[(f[a+12>>2]|0)+(((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;f[n>>2]=p;f[n+4>>2]=q;f[c+((((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);o=f[a+12>>2]|0;do if(b[d+38>>0]|0){q=f[d+56>>2]|0;p=d;if(!q){r=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=p-(f[q+40>>2]|0)|0;break}}else r=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=c+(f[o+(((r|0)/88|0)<<2)>>2]|0)|0;f[q>>2]=j;f[q+4>>2]=k;k=f[a+20>>2]|0;if((k|0)==-1)return;q=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;j=d;if(!a){s=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=j-(f[a+40>>2]|0)|0;break}}else s=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[q+(((s|0)/88|0)<<2)>>2]|0;s=c+k+(d>>>5<<2)|0;f[s>>2]=1<<(d&31)|f[s>>2];return}function Abc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=f[e>>2]|0;else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,h);j=f[g>>2]|0;k=f[e>>2]|0;if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=f[e>>2]|0}f[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>2]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;e=d;if(!m){n=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=e-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);f[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>2]=i;i=f[a+20>>2]|0;if((i|0)==-1)return;n=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){o=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[n+(((o|0)/88|0)<<2)>>2]|0;o=c+i+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function Bbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=e;j=f[i>>2]|0;k=f[i+4>>2]|0}else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,h);i=f[g>>2]|0;l=e;m=f[l>>2]|0;n=f[l+4>>2]|0;if(!i){j=m;k=n;break}else{o=i;p=m;q=n}}else{n=e;o=h;p=f[n>>2]|0;q=f[n+4>>2]|0}n=c+(f[(f[a+12>>2]|0)+(((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;f[n>>2]=p;f[n+4>>2]=q;f[c+((((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);o=f[a+12>>2]|0;do if(b[d+38>>0]|0){q=f[d+56>>2]|0;p=d;if(!q){r=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=p-(f[q+40>>2]|0)|0;break}}else r=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=c+(f[o+(((r|0)/88|0)<<2)>>2]|0)|0;f[q>>2]=j;f[q+4>>2]=k;k=f[a+20>>2]|0;if((k|0)==-1)return;q=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;j=d;if(!a){s=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=j-(f[a+40>>2]|0)|0;break}}else s=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[q+(((s|0)/88|0)<<2)>>2]|0;s=c+k+(d>>>5<<2)|0;f[s>>2]=1<<(d&31)|f[s>>2];return}function Cbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>2;i=VDc(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;YDc(d);return}function Dbc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+40|0;j=a+8|0;k=f[a+20>>2]|0;if((k|0)!=-1){l=c+k|0;k=f[a+16>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;o=d;if(!m){q=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=o-(f[m+40>>2]|0)|0;break}}else q=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);m=f[k+(((q|0)/88|0)<<2)>>2]|0;r=(1<<(m&31)&f[l+(m>>>5<<2)>>2]|0)!=0;u=e;return r|0}m=d+24|0;l=f[m>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(l,g)}l=d+28|0;if((f[161216+(f[l>>2]<<2)>>2]|0)==10){q=f[j>>2]|0;if((q|0)==(c|0)){r=0;u=e;return r|0}k=f[d+52>>2]|0;do if(!k){o=f[a+12>>2]|0;do if(b[d+38>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){v=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=t-(f[s+40>>2]|0)|0;break}}else v=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);w=c;x=o+(((v|0)/88|0)<<2)|0}else{s=(k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((s<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){w=c;x=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+s<<2)|0;break}s=f[a+12>>2]|0;do if(b[d+38>>0]|0){t=f[d+56>>2]|0;y=d;if(!t){z=y-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{z=y-(f[t+40>>2]|0)|0;break}}else z=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);w=q;x=s+(((z|0)/88|0)<<2)|0}while(0);r=(f[w+(f[x>>2]|0)>>2]|0)!=0;u=e;return r|0}x=f[m>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=d;DTb(x,g)}do switch(f[161216+(f[l>>2]<<2)>>2]|0){case 9:{g=f[d+52>>2]|0;do if(!g){x=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;w=d;if(!m){A=w-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{A=w-(f[m+40>>2]|0)|0;break}}else A=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);B=c;C=x+(((A|0)/88|0)<<2)|0}else{m=(g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){B=c;C=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){z=f[d+56>>2]|0;q=d;if(!z){D=q-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{D=q-(f[z+40>>2]|0)|0;break}}else D=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);B=m;C=w+(((D|0)/88|0)<<2)|0}while(0);g=f[B+(f[C>>2]|0)>>2]|0;s=b[g+11>>0]|0;if(s<<24>>24<0)E=f[g+4>>2]|0;else E=s&255;r=(E|0)!=0;u=e;return r|0}case 7:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){F=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{F=z-(f[x+40>>2]|0)|0;break}}else F=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);G=c;H=g+(((F|0)/88|0)<<2)|0}else{w=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((w<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){G=c;H=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+w<<2)|0;break}w=f[j>>2]|0;m=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){I=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{I=z-(f[x+40>>2]|0)|0;break}}else I=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);G=w;H=m+(((I|0)/88|0)<<2)|0}while(0);r=(b[G+(f[H>>2]|0)>>0]|0)!=0;u=e;return r|0}case 1:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){J=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{J=z-(f[x+40>>2]|0)|0;break}}else J=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);K=c;L=g+(((J|0)/88|0)<<2)|0}else{m=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){K=c;L=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){M=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{M=z-(f[x+40>>2]|0)|0;break}}else M=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);K=m;L=w+(((M|0)/88|0)<<2)|0}while(0);r=(f[K+(f[L>>2]|0)>>2]|0)!=0;u=e;return r|0}case 2:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){N=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{N=z-(f[x+40>>2]|0)|0;break}}else N=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);O=c;P=g+(((N|0)/88|0)<<2)|0}else{w=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((w<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){O=c;P=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+w<<2)|0;break}w=f[j>>2]|0;m=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){Q=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{Q=z-(f[x+40>>2]|0)|0;break}}else Q=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);O=w;P=m+(((Q|0)/88|0)<<2)|0}while(0);s=O+(f[P>>2]|0)|0;r=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0;u=e;return r|0}case 3:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){R=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{R=z-(f[x+40>>2]|0)|0;break}}else R=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);S=c;T=g+(((R|0)/88|0)<<2)|0}else{m=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){S=c;T=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){U=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{U=z-(f[x+40>>2]|0)|0;break}}else U=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);S=m;T=w+(((U|0)/88|0)<<2)|0}while(0);r=(f[S+(f[T>>2]|0)>>2]|0)!=0;u=e;return r|0}case 4:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){V=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{V=z-(f[x+40>>2]|0)|0;break}}else V=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);W=c;X=g+(((V|0)/88|0)<<2)|0}else{w=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((w<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){W=c;X=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+w<<2)|0;break}w=f[j>>2]|0;m=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){Y=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{Y=z-(f[x+40>>2]|0)|0;break}}else Y=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);W=w;X=m+(((Y|0)/88|0)<<2)|0}while(0);s=W+(f[X>>2]|0)|0;r=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0;u=e;return r|0}case 6:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){Z=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{Z=z-(f[x+40>>2]|0)|0;break}}else Z=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);_=c;$=g+(((Z|0)/88|0)<<2)|0}else{m=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){_=c;$=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){aa=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{aa=z-(f[x+40>>2]|0)|0;break}}else aa=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);_=m;$=w+(((aa|0)/88|0)<<2)|0}while(0);r=+n[_+(f[$>>2]|0)>>2]!=0.0;u=e;return r|0}case 5:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){ba=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ba=z-(f[x+40>>2]|0)|0;break}}else ba=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);ca=c;da=g+(((ba|0)/88|0)<<2)|0}else{w=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((w<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){ca=c;da=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+w<<2)|0;break}w=f[j>>2]|0;m=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){ea=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ea=z-(f[x+40>>2]|0)|0;break}}else ea=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);ca=w;da=m+(((ea|0)/88|0)<<2)|0}while(0);r=+p[ca+(f[da>>2]|0)>>3]!=0.0;u=e;return r|0}case 8:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){fa=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{fa=z-(f[x+40>>2]|0)|0;break}}else fa=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);ga=c;ha=g+(((fa|0)/88|0)<<2)|0}else{m=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){ga=c;ha=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){ia=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ia=z-(f[x+40>>2]|0)|0;break}}else ia=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);ga=m;ha=w+(((ia|0)/88|0)<<2)|0}while(0);r=(f[ga+(f[ha>>2]|0)>>2]|0)!=0;u=e;return r|0}default:{rTb(h,3,493760,2002);oTb(i,mTb(h,496137)|0);sTb(h);r=0;u=e;return r|0}}while(0);return 0}function Ebc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;c=a;a=b;a:while(1){b=a;d=a+-4|0;e=c;while(1){g=e;b:while(1){h=g;i=b-h|0;j=i>>2;switch(j|0){case 2:{k=5;break a;break}case 3:{k=7;break a;break}case 4:{k=15;break a;break}case 5:{k=27;break a;break}case 1:case 0:{k=87;break a;break}default:{}}if((i|0)<124){k=29;break a}l=g+(((j|0)/2|0)<<2)|0;do if((i|0)<=3996){m=f[l>>2]|0;n=f[g>>2]|0;o=f[m+40>>2]|0;p=f[n+40>>2]|0;q=f[d>>2]|0;r=(f[q+40>>2]|0)<(o|0);s=m;m=q;q=n;if((o|0)>=(p|0)){if(!r){t=0;break}f[l>>2]=m;f[d>>2]=s;o=f[l>>2]|0;n=f[g>>2]|0;if((f[o+40>>2]|0)>=(f[n+40>>2]|0)){t=1;break}f[g>>2]=o;f[l>>2]=n;t=2;break}if(r){f[g>>2]=m;f[d>>2]=q;t=1;break}f[g>>2]=s;f[l>>2]=q;s=f[d>>2]|0;if((f[s+40>>2]|0)<(p|0)){f[l>>2]=s;f[d>>2]=q;t=2}else t=1}else{q=(j|0)/4|0;t=Fbc(g,g+(q<<2)|0,l,l+(q<<2)|0,d)|0}while(0);u=f[g>>2]|0;j=f[u+40>>2]|0;i=f[(f[l>>2]|0)+40>>2]|0;if((j|0)<(i|0)){v=d;w=t;break}else x=d;while(1){x=x+-4|0;if((g|0)==(x|0))break;y=f[x>>2]|0;if((f[y+40>>2]|0)<(i|0)){k=69;break b}}i=g+4|0;q=f[d>>2]|0;s=q;if((j|0)<(f[q+40>>2]|0))z=i;else{if((i|0)==(d|0)){k=87;break a}else A=i;while(1){B=f[A>>2]|0;if((j|0)<(f[B+40>>2]|0))break;i=A+4|0;if((i|0)==(d|0)){k=87;break a}else A=i}f[A>>2]=s;f[d>>2]=B;z=A+4|0}if((z|0)==(d|0)){k=87;break a}else{C=d;D=z}while(1){j=f[(f[g>>2]|0)+40>>2]|0;i=D;while(1){E=f[i>>2]|0;F=i+4|0;if((j|0)<(f[E+40>>2]|0))break;else i=F}q=E;p=C;do{p=p+-4|0;G=f[p>>2]|0}while((j|0)<(f[G+40>>2]|0));if(i>>>0>=p>>>0){g=i;continue b}f[i>>2]=G;f[p>>2]=q;C=p;D=F}}if((k|0)==69){k=0;f[g>>2]=y;f[x>>2]=u;v=x;w=t+1|0}s=g+4|0;c:do if(s>>>0<v>>>0){j=l;m=v;r=s;n=w;while(1){o=f[(f[j>>2]|0)+40>>2]|0;H=r;while(1){I=f[H>>2]|0;J=H+4|0;if((f[I+40>>2]|0)<(o|0))H=J;else break}p=I;q=m;do{q=q+-4|0;K=f[q>>2]|0}while((f[K+40>>2]|0)>=(o|0));if(H>>>0>q>>>0){L=j;M=n;N=H;break c}f[H>>2]=K;f[q>>2]=p;j=(j|0)==(H|0)?q:j;m=q;r=J;n=n+1|0}}else{L=l;M=w;N=s}while(0);if((N|0)!=(L|0)?(s=f[L>>2]|0,n=f[N>>2]|0,(f[s+40>>2]|0)<(f[n+40>>2]|0)):0){f[N>>2]=s;f[L>>2]=n;O=M+1|0}else O=M;if(!O){P=Gbc(g,N)|0;n=N+4|0;if(Gbc(n,a)|0){k=86;break}if(P){e=n;continue}}n=N;if((n-h|0)>=(b-n|0)){k=85;break}Ebc(g,N);e=N+4|0}if((k|0)==85){k=0;Ebc(N+4|0,a);c=g;a=N;continue}else if((k|0)==86){k=0;if(P){k=87;break}else{c=g;a=N;continue}}}if((k|0)==5){N=f[d>>2]|0;c=f[g>>2]|0;if((f[N+40>>2]|0)>=(f[c+40>>2]|0))return;f[g>>2]=N;f[d>>2]=c;return}else if((k|0)==7){c=g+4|0;N=f[c>>2]|0;P=f[g>>2]|0;h=f[N+40>>2]|0;O=f[P+40>>2]|0;M=f[d>>2]|0;L=(f[M+40>>2]|0)<(h|0);w=N;N=M;M=P;if((h|0)>=(O|0)){if(!L)return;f[c>>2]=N;f[d>>2]=w;h=f[c>>2]|0;P=f[g>>2]|0;if((f[h+40>>2]|0)>=(f[P+40>>2]|0))return;f[g>>2]=h;f[c>>2]=P;return}if(L){f[g>>2]=N;f[d>>2]=M;return}f[g>>2]=w;f[c>>2]=M;w=f[d>>2]|0;if((f[w+40>>2]|0)>=(O|0))return;f[c>>2]=w;f[d>>2]=M;return}else if((k|0)==15){M=g+4|0;w=g+8|0;c=f[M>>2]|0;O=f[g>>2]|0;N=f[c+40>>2]|0;L=f[O+40>>2]|0;P=f[w>>2]|0;h=f[P+40>>2]|0;l=(h|0)<(N|0);J=c;K=P;I=O;do if((N|0)<(L|0)){if(l){f[g>>2]=K;f[w>>2]=I;Q=O;R=I;break}f[g>>2]=J;f[M>>2]=I;if((h|0)<(L|0)){f[M>>2]=K;f[w>>2]=I;Q=O;R=I}else{Q=P;R=K}}else if(l){f[M>>2]=K;f[w>>2]=J;if((h|0)<(L|0)){f[g>>2]=K;f[M>>2]=I;Q=c;R=J}else{Q=c;R=J}}else{Q=P;R=K}while(0);K=f[d>>2]|0;if((f[K+40>>2]|0)>=(f[Q+40>>2]|0))return;f[w>>2]=K;f[d>>2]=R;R=f[w>>2]|0;K=f[M>>2]|0;Q=f[R+40>>2]|0;if((Q|0)>=(f[K+40>>2]|0))return;P=R;f[M>>2]=P;f[w>>2]=K;K=f[g>>2]|0;if((Q|0)>=(f[K+40>>2]|0))return;f[g>>2]=P;f[M>>2]=K;return}else if((k|0)==27){Fbc(g,g+4|0,g+8|0,g+12|0,d)|0;return}else if((k|0)==29){d=g+8|0;K=g+4|0;M=f[K>>2]|0;P=f[g>>2]|0;Q=f[M+40>>2]|0;w=f[P+40>>2]|0;R=f[d>>2]|0;J=f[R+40>>2]|0;c=(J|0)<(Q|0);I=M;L=R;h=P;do if((Q|0)<(w|0)){if(c){f[g>>2]=L;f[d>>2]=h;S=P;break}f[g>>2]=I;f[K>>2]=h;if((J|0)<(w|0)){f[K>>2]=L;f[d>>2]=h;S=P}else S=R}else if(c){f[K>>2]=L;f[d>>2]=I;if((J|0)<(w|0)){f[g>>2]=L;f[K>>2]=h;S=M}else S=M}else S=R;while(0);R=g+12|0;if((R|0)==(a|0))return;else{T=R;U=d;V=S}while(1){S=f[T>>2]|0;d=f[S+40>>2]|0;R=S;if((d|0)<(f[V+40>>2]|0)){S=U;M=T;while(1){f[M>>2]=f[S>>2];if((S|0)==(g|0))break;h=S+-4|0;if((d|0)<(f[(f[h>>2]|0)+40>>2]|0)){K=S;S=h;M=K}else break}f[S>>2]=R}M=T+4|0;if((M|0)==(a|0))break;d=f[T>>2]|0;K=T;T=M;V=d;U=K}return}else if((k|0)==87)return}function Fbc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=f[b>>2]|0;h=f[a>>2]|0;i=f[g+40>>2]|0;j=f[h+40>>2]|0;k=f[c>>2]|0;l=(f[k+40>>2]|0)<(i|0);m=g;n=k;o=h;do if((i|0)<(j|0)){if(l){f[a>>2]=n;f[c>>2]=o;p=1;q=h;r=o;break}f[a>>2]=m;f[b>>2]=o;s=f[c>>2]|0;t=s;if((f[s+40>>2]|0)<(j|0)){f[b>>2]=t;f[c>>2]=o;p=2;q=h;r=o}else{p=1;q=s;r=t}}else if(l){f[b>>2]=n;f[c>>2]=m;t=f[b>>2]|0;s=f[a>>2]|0;if((f[t+40>>2]|0)<(f[s+40>>2]|0)){f[a>>2]=t;f[b>>2]=s;s=f[c>>2]|0;p=2;q=s;r=s}else{p=1;q=g;r=m}}else{p=0;q=k;r=n}while(0);n=f[d>>2]|0;if((f[n+40>>2]|0)<(f[q+40>>2]|0)){f[c>>2]=n;f[d>>2]=r;r=p+1|0;n=f[c>>2]|0;q=f[b>>2]|0;if((f[n+40>>2]|0)<(f[q+40>>2]|0)){f[b>>2]=n;f[c>>2]=q;q=f[b>>2]|0;n=f[a>>2]|0;if((f[q+40>>2]|0)<(f[n+40>>2]|0)){f[a>>2]=q;f[b>>2]=n;u=p+3|0}else u=p+2|0}else u=r}else u=p;p=f[e>>2]|0;r=f[d>>2]|0;if((f[p+40>>2]|0)>=(f[r+40>>2]|0)){v=u;return v|0}f[d>>2]=p;f[e>>2]=r;r=f[d>>2]|0;e=f[c>>2]|0;if((f[r+40>>2]|0)>=(f[e+40>>2]|0)){v=u+1|0;return v|0}f[c>>2]=r;f[d>>2]=e;e=f[c>>2]|0;d=f[b>>2]|0;if((f[e+40>>2]|0)>=(f[d+40>>2]|0)){v=u+2|0;return v|0}f[b>>2]=e;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;if((f[d+40>>2]|0)>=(f[c+40>>2]|0)){v=u+3|0;return v|0}f[a>>2]=d;f[b>>2]=c;v=u+4|0;return v|0}function Gbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;switch(b-a>>2|0){case 2:{c=b+-4|0;d=f[c>>2]|0;e=f[a>>2]|0;if((f[d+40>>2]|0)>=(f[e+40>>2]|0)){g=1;return g|0}f[a>>2]=d;f[c>>2]=e;g=1;return g|0}case 3:{e=a+4|0;c=b+-4|0;d=f[e>>2]|0;h=f[a>>2]|0;i=f[d+40>>2]|0;j=f[h+40>>2]|0;k=f[c>>2]|0;l=(f[k+40>>2]|0)<(i|0);m=d;d=k;k=h;if((i|0)>=(j|0)){if(!l){g=1;return g|0}f[e>>2]=d;f[c>>2]=m;i=f[e>>2]|0;h=f[a>>2]|0;if((f[i+40>>2]|0)>=(f[h+40>>2]|0)){g=1;return g|0}f[a>>2]=i;f[e>>2]=h;g=1;return g|0}if(l){f[a>>2]=d;f[c>>2]=k;g=1;return g|0}f[a>>2]=m;f[e>>2]=k;m=f[c>>2]|0;if((f[m+40>>2]|0)>=(j|0)){g=1;return g|0}f[e>>2]=m;f[c>>2]=k;g=1;return g|0}case 4:{k=a+4|0;c=a+8|0;m=b+-4|0;e=f[k>>2]|0;j=f[a>>2]|0;d=f[e+40>>2]|0;l=f[j+40>>2]|0;h=f[c>>2]|0;i=f[h+40>>2]|0;n=(i|0)<(d|0);o=e;p=h;q=j;do if((d|0)<(l|0)){if(n){f[a>>2]=p;f[c>>2]=q;r=j;s=q;break}f[a>>2]=o;f[k>>2]=q;if((i|0)<(l|0)){f[k>>2]=p;f[c>>2]=q;r=j;s=q}else{r=h;s=p}}else if(n){f[k>>2]=p;f[c>>2]=o;if((i|0)<(l|0)){f[a>>2]=p;f[k>>2]=q;r=e;s=o}else{r=e;s=o}}else{r=h;s=p}while(0);p=f[m>>2]|0;if((f[p+40>>2]|0)>=(f[r+40>>2]|0)){g=1;return g|0}f[c>>2]=p;f[m>>2]=s;s=f[c>>2]|0;m=f[k>>2]|0;p=f[s+40>>2]|0;if((p|0)>=(f[m+40>>2]|0)){g=1;return g|0}r=s;f[k>>2]=r;f[c>>2]=m;m=f[a>>2]|0;if((p|0)>=(f[m+40>>2]|0)){g=1;return g|0}f[a>>2]=r;f[k>>2]=m;g=1;return g|0}case 5:{Fbc(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;g=1;return g|0}case 1:case 0:{g=1;return g|0}default:{m=a+8|0;k=a+4|0;r=f[k>>2]|0;p=f[a>>2]|0;c=f[r+40>>2]|0;s=f[p+40>>2]|0;h=f[m>>2]|0;o=f[h+40>>2]|0;e=(o|0)<(c|0);q=r;l=h;i=p;do if((c|0)<(s|0)){if(e){f[a>>2]=l;f[m>>2]=i;t=p;break}f[a>>2]=q;f[k>>2]=i;if((o|0)<(s|0)){f[k>>2]=l;f[m>>2]=i;t=p}else t=h}else if(e){f[k>>2]=l;f[m>>2]=q;if((o|0)<(s|0)){f[a>>2]=l;f[k>>2]=i;t=r}else t=r}else t=h;while(0);h=a+12|0;a:do if((h|0)==(b|0)){u=1;v=0}else{r=h;i=0;k=m;l=t;while(1){s=f[r>>2]|0;o=f[s+40>>2]|0;q=s;if((o|0)<(f[l+40>>2]|0)){s=k;e=r;while(1){f[e>>2]=f[s>>2];if((s|0)==(a|0))break;p=s+-4|0;if((o|0)<(f[(f[p>>2]|0)+40>>2]|0)){c=s;s=p;e=c}else break}f[s>>2]=q;e=i+1|0;if((e|0)==8){u=0;v=(r+4|0)==(b|0);break a}else w=e}else w=i;e=r+4|0;if((e|0)==(b|0)){u=1;v=0;break a}o=f[r>>2]|0;c=r;r=e;i=w;l=o;k=c}}while(0);g=v|u;return g|0}}return 0}function Hbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;g=u;u=u+160|0;h=g+136|0;i=g+132|0;j=g+16|0;k=g+128|0;l=g+8|0;m=g+96|0;n=g;o=g+154|0;q=g+64|0;r=g+24|0;s=g+104|0;t=g+155|0;v=g+72|0;w=g+153|0;x=g+40|0;y=g+152|0;z=a+32|0;A=(((e-(f[(f[e+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[z>>2]|0)|0;B=f[c+A>>2]|0;C=f[d+A>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;A=(B|0)!=0;a:do if(A){D=qYb(f[a+4>>2]|0,B)|0;E=D+24|0;F=f[E>>2]|0;if(F|0?(f[F>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=D;DTb(F,h)}F=D+28|0;do switch(f[161216+(f[F>>2]<<2)>>2]|0){case 1:{G=f[D+52>>2]|0;do if(!G){H=f[a+12>>2]|0;do if(b[D+38>>0]|0){I=f[D+56>>2]|0;J=D;if(!I){K=J-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{K=J-(f[I+40>>2]|0)|0;break}}else K=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);L=c;M=H+(((K|0)/88|0)<<2)|0}else{I=(G-(f[(f[G+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){L=c;M=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[D+38>>0]|0){N=f[D+56>>2]|0;O=D;if(!N){P=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{P=O-(f[N+40>>2]|0)|0;break}}else P=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);L=I;M=J+(((P|0)/88|0)<<2)|0}while(0);f[i>>2]=f[L+(f[M>>2]|0)>>2];Q=0;R=D;break a;break}case 2:{G=f[D+52>>2]|0;do if(!G){H=f[a+12>>2]|0;do if(b[D+38>>0]|0){N=f[D+56>>2]|0;O=D;if(!N){S=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{S=O-(f[N+40>>2]|0)|0;break}}else S=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);T=c;U=H+(((S|0)/88|0)<<2)|0}else{J=(G-(f[(f[G+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){T=c;U=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[D+38>>0]|0){N=f[D+56>>2]|0;O=D;if(!N){V=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{V=O-(f[N+40>>2]|0)|0;break}}else V=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);T=J;U=I+(((V|0)/88|0)<<2)|0}while(0);G=T+(f[U>>2]|0)|0;H=f[G+4>>2]|0;N=j;f[N>>2]=f[G>>2];f[N+4>>2]=H;Q=0;R=D;break a;break}case 3:{H=f[D+52>>2]|0;do if(!H){N=f[a+12>>2]|0;do if(b[D+38>>0]|0){G=f[D+56>>2]|0;O=D;if(!G){W=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{W=O-(f[G+40>>2]|0)|0;break}}else W=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);X=c;Y=N+(((W|0)/88|0)<<2)|0}else{I=(H-(f[(f[H+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){X=c;Y=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[D+38>>0]|0){G=f[D+56>>2]|0;O=D;if(!G){Z=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{Z=O-(f[G+40>>2]|0)|0;break}}else Z=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);X=I;Y=J+(((Z|0)/88|0)<<2)|0}while(0);f[k>>2]=f[X+(f[Y>>2]|0)>>2];Q=0;R=D;break a;break}case 4:{H=f[D+52>>2]|0;do if(!H){N=f[a+12>>2]|0;do if(b[D+38>>0]|0){G=f[D+56>>2]|0;O=D;if(!G){_=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{_=O-(f[G+40>>2]|0)|0;break}}else _=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);$=c;aa=N+(((_|0)/88|0)<<2)|0}else{J=(H-(f[(f[H+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){$=c;aa=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[D+38>>0]|0){G=f[D+56>>2]|0;O=D;if(!G){ba=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ba=O-(f[G+40>>2]|0)|0;break}}else ba=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);$=J;aa=I+(((ba|0)/88|0)<<2)|0}while(0);H=$+(f[aa>>2]|0)|0;N=f[H+4>>2]|0;G=l;f[G>>2]=f[H>>2];f[G+4>>2]=N;Q=0;R=D;break a;break}case 6:{N=f[D+52>>2]|0;do if(!N){G=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ca=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ca=O-(f[H+40>>2]|0)|0;break}}else ca=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);da=c;ea=G+(((ca|0)/88|0)<<2)|0}else{I=(N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){da=c;ea=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){fa=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{fa=O-(f[H+40>>2]|0)|0;break}}else fa=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);da=I;ea=J+(((fa|0)/88|0)<<2)|0}while(0);f[m>>2]=f[da+(f[ea>>2]|0)>>2];Q=0;R=D;break a;break}case 5:{N=f[D+52>>2]|0;do if(!N){G=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ga=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ga=O-(f[H+40>>2]|0)|0;break}}else ga=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);ha=c;ia=G+(((ga|0)/88|0)<<2)|0}else{J=(N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){ha=c;ia=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ja=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ja=O-(f[H+40>>2]|0)|0;break}}else ja=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);ha=J;ia=I+(((ja|0)/88|0)<<2)|0}while(0);p[n>>3]=+p[ha+(f[ia>>2]|0)>>3];Q=0;R=D;break a;break}case 7:{N=f[D+52>>2]|0;do if(!N){G=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ka=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ka=O-(f[H+40>>2]|0)|0;break}}else ka=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);la=c;ma=G+(((ka|0)/88|0)<<2)|0}else{I=(N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){la=c;ma=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){na=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{na=O-(f[H+40>>2]|0)|0;break}}else na=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);la=I;ma=J+(((na|0)/88|0)<<2)|0}while(0);b[o>>0]=b[la+(f[ma>>2]|0)>>0]|0;Q=0;R=D;break a;break}case 8:{N=f[D+52>>2]|0;do if(!N){G=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){oa=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{oa=O-(f[H+40>>2]|0)|0;break}}else oa=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);pa=c;qa=G+(((oa|0)/88|0)<<2)|0}else{J=(N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){pa=c;qa=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ra=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ra=O-(f[H+40>>2]|0)|0;break}}else ra=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);pa=J;qa=I+(((ra|0)/88|0)<<2)|0}while(0);f[q>>2]=f[pa+(f[qa>>2]|0)>>2];Q=0;R=D;break a;break}case 10:{Q=hh[f[(f[a>>2]|0)+164>>2]&127](a,c,D,0)|0;R=D;break a;break}case 9:{ei[f[(f[a>>2]|0)+96>>2]&511](h,a,c,D);iEc(r,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);Q=0;R=D;break a;break}default:{rTb(s,3,493760,498);N=mTb(s,496521)|0;G=f[E>>2]|0;if(G|0?(f[G>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=D;DTb(G,h)}oTb(t,pTb(N,f[161216+(f[F>>2]<<2)>>2]|0)|0);sTb(s);Q=0;R=D;break a}}while(0)}else{Q=0;R=0}while(0);b:do if(!C)Ti[f[(f[a>>2]|0)+36>>2]&511](a,c,e);else{s=qYb(f[a+4>>2]|0,C)|0;t=s+24|0;qa=f[t>>2]|0;if(qa|0?(f[qa>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=s;DTb(qa,h)}qa=s+28|0;do switch(f[161216+(f[qa>>2]<<2)>>2]|0){case 1:{pa=f[s+52>>2]|0;do if(!pa){ra=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){sa=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{sa=ma-(f[oa+40>>2]|0)|0;break}}else sa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);ta=d;ua=ra+(((sa|0)/88|0)<<2)|0}else{I=(pa-(f[(f[pa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){ta=d;ua=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){va=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{va=ma-(f[oa+40>>2]|0)|0;break}}else va=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);ta=I;ua=J+(((va|0)/88|0)<<2)|0}while(0);vbc(a,c,s,ta+(f[ua>>2]|0)|0);break b;break}case 2:{pa=f[s+52>>2]|0;do if(!pa){ra=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){wa=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{wa=ma-(f[oa+40>>2]|0)|0;break}}else wa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);xa=d;ya=ra+(((wa|0)/88|0)<<2)|0}else{J=(pa-(f[(f[pa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){xa=d;ya=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){za=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{za=ma-(f[oa+40>>2]|0)|0;break}}else za=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);xa=J;ya=I+(((za|0)/88|0)<<2)|0}while(0);Bbc(a,c,s,xa+(f[ya>>2]|0)|0);break b;break}case 3:{pa=f[s+52>>2]|0;do if(!pa){ra=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Aa=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Aa=ma-(f[oa+40>>2]|0)|0;break}}else Aa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ba=d;Ca=ra+(((Aa|0)/88|0)<<2)|0}else{I=(pa-(f[(f[pa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Ba=d;Ca=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Da=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Da=ma-(f[oa+40>>2]|0)|0;break}}else Da=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ba=I;Ca=J+(((Da|0)/88|0)<<2)|0}while(0);Abc(a,c,s,Ba+(f[Ca>>2]|0)|0);break b;break}case 4:{pa=f[s+52>>2]|0;do if(!pa){ra=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Ea=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ea=ma-(f[oa+40>>2]|0)|0;break}}else Ea=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Fa=d;Ga=ra+(((Ea|0)/88|0)<<2)|0}else{J=(pa-(f[(f[pa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Fa=d;Ga=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Ha=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ha=ma-(f[oa+40>>2]|0)|0;break}}else Ha=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Fa=J;Ga=I+(((Ha|0)/88|0)<<2)|0}while(0);zbc(a,c,s,Fa+(f[Ga>>2]|0)|0);break b;break}case 6:{pa=f[s+52>>2]|0;do if(!pa){ra=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Ia=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ia=ma-(f[oa+40>>2]|0)|0;break}}else Ia=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ja=d;Ka=ra+(((Ia|0)/88|0)<<2)|0}else{I=(pa-(f[(f[pa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Ja=d;Ka=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){La=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{La=ma-(f[oa+40>>2]|0)|0;break}}else La=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ja=I;Ka=J+(((La|0)/88|0)<<2)|0}while(0);ybc(a,c,s,Ja+(f[Ka>>2]|0)|0);break b;break}case 5:{pa=f[s+52>>2]|0;do if(!pa){ra=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Ma=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ma=ma-(f[oa+40>>2]|0)|0;break}}else Ma=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Na=d;Oa=ra+(((Ma|0)/88|0)<<2)|0}else{J=(pa-(f[(f[pa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Na=d;Oa=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Pa=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Pa=ma-(f[oa+40>>2]|0)|0;break}}else Pa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Na=J;Oa=I+(((Pa|0)/88|0)<<2)|0}while(0);xbc(a,c,s,Na+(f[Oa>>2]|0)|0);break b;break}case 7:{pa=f[s+52>>2]|0;do if(!pa){ra=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Qa=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Qa=ma-(f[oa+40>>2]|0)|0;break}}else Qa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ra=d;Sa=ra+(((Qa|0)/88|0)<<2)|0}else{I=(pa-(f[(f[pa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Ra=d;Sa=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Ta=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ta=ma-(f[oa+40>>2]|0)|0;break}}else Ta=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ra=I;Sa=J+(((Ta|0)/88|0)<<2)|0}while(0);wbc(a,c,s,Ra+(f[Sa>>2]|0)|0);break b;break}case 8:{pa=f[s+52>>2]|0;do if(!pa){ra=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Ua=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ua=ma-(f[oa+40>>2]|0)|0;break}}else Ua=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Va=d;Wa=ra+(((Ua|0)/88|0)<<2)|0}else{J=(pa-(f[(f[pa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Va=d;Wa=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[s+38>>0]|0){oa=f[s+56>>2]|0;ma=s;if(!oa){Xa=ma-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Xa=ma-(f[oa+40>>2]|0)|0;break}}else Xa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Va=J;Wa=I+(((Xa|0)/88|0)<<2)|0}while(0);vbc(a,c,s,Va+(f[Wa>>2]|0)|0);break b;break}case 10:{pa=f[a>>2]|0;ra=f[pa+160>>2]|0;oa=hh[f[pa+164>>2]&127](a,d,s,0)|0;ei[ra&511](a,c,oa,s);break b;break}case 9:{oa=f[a>>2]|0;ra=f[oa+144>>2]|0;ei[f[oa+96>>2]&511](h,a,d,s);ei[ra&511](a,c,s,h);if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);break b;break}default:{rTb(v,3,493760,532);ra=mTb(v,496521)|0;oa=f[t>>2]|0;if(oa|0?(f[oa>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=s;DTb(oa,h)}oTb(w,pTb(ra,f[161216+(f[qa>>2]<<2)>>2]|0)|0);sTb(v);break b}}while(0)}while(0);c:do if(A){v=R+24|0;w=f[v>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=R;DTb(w,h)}w=R+28|0;do switch(f[161216+(f[w>>2]<<2)>>2]|0){case 1:{vbc(a,d,R,i);break c;break}case 2:{Bbc(a,d,R,j);break c;break}case 3:{Abc(a,d,R,k);break c;break}case 4:{zbc(a,d,R,l);break c;break}case 6:{ybc(a,d,R,m);break c;break}case 5:{xbc(a,d,R,n);break c;break}case 7:{wbc(a,d,R,o);break c;break}case 8:{vbc(a,d,R,q);break c;break}case 10:{ei[f[(f[a>>2]|0)+160>>2]&511](a,d,Q,R);break c;break}case 9:{ei[f[(f[a>>2]|0)+144>>2]&511](a,d,R,r);break c;break}default:{rTb(x,3,493760,564);c=mTb(x,496521)|0;Wa=f[v>>2]|0;if(Wa|0?(f[Wa>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=R;DTb(Wa,h)}oTb(y,pTb(c,f[161216+(f[w>>2]<<2)>>2]|0)|0);sTb(x);break c}}while(0)}else Ti[f[(f[a>>2]|0)+36>>2]&511](a,d,e);while(0);if((b[r+11>>0]|0)>=0){u=g;return}YDc(f[r>>2]|0);u=g;return}function Ibc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=a+20|0;if((f[g>>2]|0)==-1)return;h=Dbc(a,c,e)|0;i=Dbc(a,d,e)|0;j=f[g>>2]|0;k=(j|0)==-1;if(i){if(!k){i=f[a+16>>2]|0;do if(b[e+38>>0]|0){l=f[e+56>>2]|0;m=e;if(!l){n=m-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{n=m-(f[l+40>>2]|0)|0;break}}else n=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);l=f[i+(((n|0)/88|0)<<2)>>2]|0;n=c+j+(l>>>5<<2)|0;f[n>>2]=1<<(l&31)|f[n>>2]}}else if(!k){k=f[a+16>>2]|0;do if(b[e+38>>0]|0){n=f[e+56>>2]|0;l=e;if(!n){o=l-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[n+40>>2]|0)|0;break}}else o=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);n=f[k+(((o|0)/88|0)<<2)>>2]|0;o=c+j+(n>>>5<<2)|0;f[o>>2]=f[o>>2]&~(1<<(n&31))}n=f[g>>2]|0;g=(n|0)==-1;if(h){if(g)return;h=f[a+16>>2]|0;do if(b[e+38>>0]|0){o=f[e+56>>2]|0;j=e;if(!o){p=j-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{p=j-(f[o+40>>2]|0)|0;break}}else p=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);o=f[h+(((p|0)/88|0)<<2)>>2]|0;p=d+n+(o>>>5<<2)|0;f[p>>2]=1<<(o&31)|f[p>>2];return}else{if(g)return;g=f[a+16>>2]|0;do if(b[e+38>>0]|0){a=f[e+56>>2]|0;p=e;if(!a){q=p-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{q=p-(f[a+40>>2]|0)|0;break}}else q=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);e=f[g+(((q|0)/88|0)<<2)>>2]|0;q=d+n+(e>>>5<<2)|0;f[q>>2]=f[q>>2]&~(1<<(e&31));return}}function Jbc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0;g=u;u=u+80|0;h=g+48|0;i=g+24|0;j=g+65|0;k=g;l=g+64|0;m=(f[e+32>>2]|0)==3;n=e+24|0;o=f[n>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(o,h)}o=e+28|0;q=f[161216+(f[o>>2]<<2)>>2]|0;if(m)do switch(q|0){case 1:{m=f[e+52>>2]|0;if(!m){r=f[a+12>>2]|0;do if(b[e+38>>0]|0){s=f[e+56>>2]|0;t=e;if(!s){v=t-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{v=t-(f[s+40>>2]|0)|0;break}}else v=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);s=c+(f[r+(((v|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;w=e;if(!t){x=w-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{x=w-(f[t+40>>2]|0)|0;break}}else x=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);y=(x|0)/88|0;z=s;A=r}else{t=f[a+12>>2]|0;y=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;z=c+(f[t+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;A=t}Kbc(z,d+(f[A+(y<<2)>>2]|0)|0);u=g;return}case 2:{t=f[e+52>>2]|0;if(!t){w=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){D=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{D=C-(f[B+40>>2]|0)|0;break}}else D=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=c+(f[w+(((D|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){r=f[e+56>>2]|0;s=e;if(!r){E=s-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{E=s-(f[r+40>>2]|0)|0;break}}else E=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);F=(E|0)/88|0;G=m;H=w}else{r=f[a+12>>2]|0;F=((t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;G=c+(f[r+(((t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;H=r}Lbc(G,d+(f[H+(F<<2)>>2]|0)|0);u=g;return}case 3:{r=f[e+52>>2]|0;if(!r){s=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){I=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{I=C-(f[B+40>>2]|0)|0;break}}else I=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);t=c+(f[s+(((I|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){w=f[e+56>>2]|0;m=e;if(!w){J=m-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{J=m-(f[w+40>>2]|0)|0;break}}else J=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);K=(J|0)/88|0;L=t;M=s}else{w=f[a+12>>2]|0;K=((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;L=c+(f[w+(((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;M=w}Mbc(L,d+(f[M+(K<<2)>>2]|0)|0);u=g;return}case 4:{w=f[e+52>>2]|0;if(!w){m=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){N=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{N=C-(f[B+40>>2]|0)|0;break}}else N=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);r=c+(f[m+(((N|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){s=f[e+56>>2]|0;t=e;if(!s){O=t-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{O=t-(f[s+40>>2]|0)|0;break}}else O=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);P=(O|0)/88|0;Q=r;R=m}else{s=f[a+12>>2]|0;P=((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Q=c+(f[s+(((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;R=s}Nbc(Q,d+(f[R+(P<<2)>>2]|0)|0);u=g;return}case 6:{s=f[e+52>>2]|0;if(!s){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){S=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{S=C-(f[B+40>>2]|0)|0;break}}else S=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);w=c+(f[t+(((S|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){m=f[e+56>>2]|0;r=e;if(!m){T=r-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{T=r-(f[m+40>>2]|0)|0;break}}else T=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);U=(T|0)/88|0;V=w;W=t}else{m=f[a+12>>2]|0;U=((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;V=c+(f[m+(((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;W=m}Obc(V,d+(f[W+(U<<2)>>2]|0)|0);u=g;return}case 5:{m=f[e+52>>2]|0;if(!m){r=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){X=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{X=C-(f[B+40>>2]|0)|0;break}}else X=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);s=c+(f[r+(((X|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;w=e;if(!t){Y=w-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Y=w-(f[t+40>>2]|0)|0;break}}else Y=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Z=(Y|0)/88|0;_=s;$=r}else{t=f[a+12>>2]|0;Z=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;_=c+(f[t+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;$=t}Pbc(_,d+(f[$+(Z<<2)>>2]|0)|0);u=g;return}case 7:{t=f[e+52>>2]|0;if(!t){w=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){aa=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{aa=C-(f[B+40>>2]|0)|0;break}}else aa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=c+(f[w+(((aa|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){r=f[e+56>>2]|0;s=e;if(!r){ba=s-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ba=s-(f[r+40>>2]|0)|0;break}}else ba=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ca=(ba|0)/88|0;da=m;ea=w}else{r=f[a+12>>2]|0;ca=((t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;da=c+(f[r+(((t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;ea=r}Qbc(da,d+(f[ea+(ca<<2)>>2]|0)|0);u=g;return}case 8:{r=f[e+52>>2]|0;if(!r){s=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){fa=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{fa=C-(f[B+40>>2]|0)|0;break}}else fa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);t=c+(f[s+(((fa|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){w=f[e+56>>2]|0;m=e;if(!w){ga=m-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ga=m-(f[w+40>>2]|0)|0;break}}else ga=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ha=(ga|0)/88|0;ia=t;ja=s}else{w=f[a+12>>2]|0;ha=((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;ia=c+(f[w+(((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;ja=w}Kbc(ia,d+(f[ja+(ha<<2)>>2]|0)|0);u=g;return}case 9:{w=f[e+52>>2]|0;if(!w){m=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){ka=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ka=C-(f[B+40>>2]|0)|0;break}}else ka=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);r=c+(f[m+(((ka|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){s=f[e+56>>2]|0;t=e;if(!s){la=t-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{la=t-(f[s+40>>2]|0)|0;break}}else la=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ma=(la|0)/88|0;na=r;oa=m}else{s=f[a+12>>2]|0;ma=((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;na=c+(f[s+(((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;oa=s}s=d+(f[oa+(ma<<2)>>2]|0)|0;if((f[s>>2]|0)==(f[na>>2]|0)){t=na+12|0;B=s+12|0;C=f[t>>2]|0;f[t>>2]=f[B>>2];f[B>>2]=C;C=na+4|0;B=s+4|0;t=f[C>>2]|0;f[C>>2]=f[B>>2];f[B>>2]=t;t=na+8|0;B=s+8|0;C=f[t>>2]|0;f[t>>2]=f[B>>2];f[B>>2]=C;u=g;return}else{Rbc(na,s);u=g;return}break}case 10:{s=f[n>>2]|0;if(s|0?(f[s>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(s,h)}if((f[o>>2]|0)==11?BYb(e)|0:0){s=e+52|0;C=f[s>>2]|0;if(!C){B=f[a+12>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;pa=e;if(!t){qa=pa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{qa=pa-(f[t+40>>2]|0)|0;break}}else qa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ra=B+(((qa|0)/88|0)<<2)|0}else ra=(f[a+12>>2]|0)+(((C-(f[(f[C+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)|0;w=Sdc(c+(f[ra>>2]|0)|0)|0;m=f[s>>2]|0;if(!m){r=f[a+12>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;pa=e;if(!t){sa=pa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{sa=pa-(f[t+40>>2]|0)|0;break}}else sa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ta=r+(((sa|0)/88|0)<<2)|0}else ta=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)|0;s=Sdc(d+(f[ta>>2]|0)|0)|0;if((f[s>>2]|0)==(f[w>>2]|0)){C=w+12|0;B=s+12|0;t=f[C>>2]|0;f[C>>2]=f[B>>2];f[B>>2]=t;t=w+4|0;B=s+4|0;C=f[t>>2]|0;f[t>>2]=f[B>>2];f[B>>2]=C;C=w+8|0;B=s+8|0;t=f[C>>2]|0;f[C>>2]=f[B>>2];f[B>>2]=t;u=g;return}else{Sbc(w,s);u=g;return}}s=f[e+52>>2]|0;if(!s){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){ua=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ua=C-(f[B+40>>2]|0)|0;break}}else ua=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);w=c+(f[t+(((ua|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){m=f[e+56>>2]|0;r=e;if(!m){va=r-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{va=r-(f[m+40>>2]|0)|0;break}}else va=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);wa=(va|0)/88|0;xa=w;ya=t}else{m=f[a+12>>2]|0;wa=((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;xa=c+(f[m+(((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;ya=m}m=d+(f[ya+(wa<<2)>>2]|0)|0;if((f[m>>2]|0)==(f[xa>>2]|0)){r=xa+12|0;B=m+12|0;C=f[r>>2]|0;f[r>>2]=f[B>>2];f[B>>2]=C;C=xa+4|0;B=m+4|0;r=f[C>>2]|0;f[C>>2]=f[B>>2];f[B>>2]=r;r=xa+8|0;B=m+8|0;C=f[r>>2]|0;f[r>>2]=f[B>>2];f[B>>2]=C;u=g;return}else{Sbc(xa,m);u=g;return}break}default:{rTb(i,3,493760,377);m=mTb(i,496521)|0;C=f[n>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(C,h)}oTb(j,pTb(m,f[161216+(f[o>>2]<<2)>>2]|0)|0);sTb(i);u=g;return}}while(0);do switch(q|0){case 1:{i=f[e+52>>2]|0;if(!i){j=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;wa=e;if(!xa){za=wa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{za=wa-(f[xa+40>>2]|0)|0;break}}else za=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);s=c+(f[j+(((za|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;w=e;if(!t){Aa=w-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Aa=w-(f[t+40>>2]|0)|0;break}}else Aa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Ba=(Aa|0)/88|0;Ca=s;Da=j}else{t=f[a+12>>2]|0;Ba=((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Ca=c+(f[t+(((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;Da=t}t=d+(f[Da+(Ba<<2)>>2]|0)|0;w=f[Ca>>2]|0;f[Ca>>2]=f[t>>2];f[t>>2]=w;u=g;return}case 2:{w=f[e+52>>2]|0;if(!w){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;wa=e;if(!xa){Ea=wa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ea=wa-(f[xa+40>>2]|0)|0;break}}else Ea=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);i=c+(f[t+(((Ea|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){j=f[e+56>>2]|0;s=e;if(!j){Fa=s-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Fa=s-(f[j+40>>2]|0)|0;break}}else Fa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Ga=(Fa|0)/88|0;Ha=i;Ia=t}else{j=f[a+12>>2]|0;Ga=((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Ha=c+(f[j+(((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;Ia=j}j=d+(f[Ia+(Ga<<2)>>2]|0)|0;s=Ha;xa=f[s>>2]|0;wa=f[s+4>>2]|0;s=j;ya=f[s+4>>2]|0;va=Ha;f[va>>2]=f[s>>2];f[va+4>>2]=ya;ya=j;f[ya>>2]=xa;f[ya+4>>2]=wa;u=g;return}case 3:{wa=f[e+52>>2]|0;if(!wa){ya=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;j=e;if(!xa){Ja=j-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ja=j-(f[xa+40>>2]|0)|0;break}}else Ja=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);w=c+(f[ya+(((Ja|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;i=e;if(!t){Ka=i-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ka=i-(f[t+40>>2]|0)|0;break}}else Ka=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);La=(Ka|0)/88|0;Ma=w;Na=ya}else{t=f[a+12>>2]|0;La=((wa-(f[(f[wa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Ma=c+(f[t+(((wa-(f[(f[wa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;Na=t}t=d+(f[Na+(La<<2)>>2]|0)|0;i=f[Ma>>2]|0;f[Ma>>2]=f[t>>2];f[t>>2]=i;u=g;return}case 4:{i=f[e+52>>2]|0;if(!i){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;j=e;if(!xa){Oa=j-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Oa=j-(f[xa+40>>2]|0)|0;break}}else Oa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);wa=c+(f[t+(((Oa|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){ya=f[e+56>>2]|0;w=e;if(!ya){Pa=w-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Pa=w-(f[ya+40>>2]|0)|0;break}}else Pa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Qa=(Pa|0)/88|0;Ra=wa;Sa=t}else{ya=f[a+12>>2]|0;Qa=((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Ra=c+(f[ya+(((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;Sa=ya}ya=d+(f[Sa+(Qa<<2)>>2]|0)|0;w=Ra;xa=f[w>>2]|0;j=f[w+4>>2]|0;w=ya;va=f[w+4>>2]|0;s=Ra;f[s>>2]=f[w>>2];f[s+4>>2]=va;va=ya;f[va>>2]=xa;f[va+4>>2]=j;u=g;return}case 6:{j=f[e+52>>2]|0;if(!j){va=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;ya=e;if(!xa){Ta=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ta=ya-(f[xa+40>>2]|0)|0;break}}else Ta=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);i=c+(f[va+(((Ta|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;wa=e;if(!t){Ua=wa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ua=wa-(f[t+40>>2]|0)|0;break}}else Ua=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Va=(Ua|0)/88|0;Wa=va;Xa=i}else{t=f[a+12>>2]|0;Va=((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Wa=t;Xa=c+(f[t+(((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0}t=d+(f[Wa+(Va<<2)>>2]|0)|0;wa=f[Xa>>2]|0;f[Xa>>2]=f[t>>2];f[t>>2]=wa;u=g;return}case 5:{wa=f[e+52>>2]|0;if(!wa){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;ya=e;if(!xa){Ya=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ya=ya-(f[xa+40>>2]|0)|0;break}}else Ya=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);j=c+(f[t+(((Ya|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){i=f[e+56>>2]|0;va=e;if(!i){Za=va-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Za=va-(f[i+40>>2]|0)|0;break}}else Za=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);_a=(Za|0)/88|0;$a=j;ab=t}else{i=f[a+12>>2]|0;_a=((wa-(f[(f[wa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;$a=c+(f[i+(((wa-(f[(f[wa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;ab=i}i=d+(f[ab+(_a<<2)>>2]|0)|0;bb=+p[$a>>3];p[$a>>3]=+p[i>>3];p[i>>3]=bb;u=g;return}case 7:{i=f[e+52>>2]|0;if(!i){va=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;ya=e;if(!xa){cb=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{cb=ya-(f[xa+40>>2]|0)|0;break}}else cb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);wa=c+(f[va+(((cb|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;j=e;if(!t){db=j-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{db=j-(f[t+40>>2]|0)|0;break}}else db=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);eb=(db|0)/88|0;fb=va;gb=wa}else{t=f[a+12>>2]|0;eb=((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;fb=t;gb=c+(f[t+(((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0}t=d+(f[fb+(eb<<2)>>2]|0)|0;j=b[gb>>0]|0;b[gb>>0]=b[t>>0]|0;b[t>>0]=j;u=g;return}case 8:{j=f[e+52>>2]|0;if(!j){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;ya=e;if(!xa){hb=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{hb=ya-(f[xa+40>>2]|0)|0;break}}else hb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);i=c+(f[t+(((hb|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){wa=f[e+56>>2]|0;va=e;if(!wa){ib=va-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ib=va-(f[wa+40>>2]|0)|0;break}}else ib=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);jb=(ib|0)/88|0;kb=i;lb=t}else{wa=f[a+12>>2]|0;jb=((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;kb=c+(f[wa+(((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;lb=wa}wa=d+(f[lb+(jb<<2)>>2]|0)|0;va=f[kb>>2]|0;f[kb>>2]=f[wa>>2];f[wa>>2]=va;u=g;return}case 10:{va=f[a+24>>2]|0;wa=f[c+va>>2]|0;xa=wa&-2;if(!(wa&1))mb=xa;else mb=f[xa+4>>2]|0;xa=f[d+va>>2]|0;va=xa&-2;if(!(xa&1))nb=va;else nb=f[va+4>>2]|0;va=(mb|0)==(nb|0);xa=f[e+52>>2]|0;if(!xa){wa=f[a+12>>2]|0;do if(b[e+38>>0]|0){ya=f[e+56>>2]|0;s=e;if(!ya){ob=s-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ob=s-(f[ya+40>>2]|0)|0;break}}else ob=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);j=f[wa+(((ob|0)/88|0)<<2)>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;i=e;if(!t){pb=i-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{pb=i-(f[t+40>>2]|0)|0;break}}else pb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);qb=(pb|0)/88|0;rb=j;sb=wa}else{t=f[a+12>>2]|0;qb=((xa-(f[(f[xa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;rb=f[t+(((xa-(f[(f[xa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0;sb=t}t=c+rb|0;i=d+(f[sb+(qb<<2)>>2]|0)|0;if(va){ya=f[t>>2]|0;f[t>>2]=f[i>>2];f[i>>2]=ya;u=g;return}ya=f[t>>2]|0;s=(f[i>>2]|0)==0;if(!ya){if(s){u=g;return}w=f[i>>2]|0;ua=f[(f[w>>2]|0)+16>>2]|0;ta=_i[f[(f[c>>2]|0)+20>>2]&1023](c)|0;sa=Mi[ua&1023](w,ta)|0;f[t>>2]=sa;mi[f[(f[sa>>2]|0)+72>>2]&2047](sa,f[i>>2]|0);Ti[f[(f[a>>2]|0)+28>>2]&511](a,d,e);u=g;return}if(s){s=f[(f[ya>>2]|0)+16>>2]|0;sa=_i[f[(f[d>>2]|0)+20>>2]&1023](d)|0;ta=Mi[s&1023](ya,sa)|0;f[i>>2]=ta;mi[f[(f[ta>>2]|0)+72>>2]&2047](ta,f[t>>2]|0);Ti[f[(f[a>>2]|0)+28>>2]&511](a,c,e);u=g;return}else{ta=_i[f[(f[ya>>2]|0)+92>>2]&1023](ya)|0;Ti[f[(f[ta>>2]|0)+52>>2]&511](ta,f[t>>2]|0,f[i>>2]|0);u=g;return}break}case 9:{i=f[a+24>>2]|0;t=f[c+i>>2]|0;ta=t&-2;if(!(t&1))tb=ta;else tb=f[ta+4>>2]|0;ta=f[d+i>>2]|0;i=ta&-2;if(!(ta&1))ub=i;else ub=f[i+4>>2]|0;i=f[e+52>>2]|0;if(!i){ta=f[a+12>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;ya=e;if(!t){vb=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{vb=ya-(f[t+40>>2]|0)|0;break}}else vb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);va=f[ta+(((vb|0)/88|0)<<2)>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;wa=e;if(!xa){wb=wa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{wb=wa-(f[xa+40>>2]|0)|0;break}}else wb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);xb=(wb|0)/88|0;yb=va;zb=ta}else{xa=f[a+12>>2]|0;xb=((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;yb=f[xa+(((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0;zb=xa}xa=c+yb|0;wa=d+(f[zb+(xb<<2)>>2]|0)|0;if((tb|0)==(ub|0)){j=f[xa>>2]|0;f[xa>>2]=f[wa>>2];f[wa>>2]=j;u=g;return}j=f[a+8>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;ya=e;if(!t){Ab=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ab=ya-(f[t+40>>2]|0)|0;break}}else Ab=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);i=f[j+(f[zb+(((Ab|0)/88|0)<<2)>>2]|0)>>2]|0;fEc(h,f[xa>>2]|0);ta=f[wa>>2]|0;va=f[xa>>2]|0;if((va|0)==(i|0))WJa(xa,tb,ta);else iEc(va,ta)|0;ta=f[wa>>2]|0;if((ta|0)==(i|0))WJa(wa,ub,h);else iEc(ta,h)|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);u=g;return}default:{rTb(k,3,493760,446);ta=mTb(k,496521)|0;i=f[n>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=78728;f[h+4>>2]=1737;b[h+8>>0]=0;f[h+12>>2]=e;DTb(i,h)}oTb(l,pTb(ta,f[161216+(f[o>>2]<<2)>>2]|0)|0);sTb(k);u=g;return}}while(0)}function Kbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)OQb(m,23816,8);h=MQb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){KLa(d,m);m=f[d>>2]|0;dJc((f[k>>2]|0)+4+(m<<2)|0,(f[e>>2]|0)+4|0,f[a>>2]<<2|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){KLa(a,m);dJc((f[e>>2]|0)+4+(f[a>>2]<<2)|0,(f[i>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)YDc(n);u=c;return}function Lbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)OQb(m,23816,8);h=MQb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){UHa(d,m);m=f[d>>2]|0;dJc((f[k>>2]|0)+8+(m<<3)|0,(f[e>>2]|0)+8|0,f[a>>2]<<3|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){UHa(a,m);dJc((f[e>>2]|0)+8+(f[a>>2]<<3)|0,(f[i>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)YDc(n);u=c;return}function Mbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)OQb(m,23816,8);h=MQb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){OLa(d,m);m=f[d>>2]|0;dJc((f[k>>2]|0)+4+(m<<2)|0,(f[e>>2]|0)+4|0,f[a>>2]<<2|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){OLa(a,m);dJc((f[e>>2]|0)+4+(f[a>>2]<<2)|0,(f[i>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)YDc(n);u=c;return}function Nbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)OQb(m,23816,8);h=MQb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){Hjb(d,m);m=f[d>>2]|0;dJc((f[k>>2]|0)+8+(m<<3)|0,(f[e>>2]|0)+8|0,f[a>>2]<<3|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){Hjb(a,m);dJc((f[e>>2]|0)+8+(f[a>>2]<<3)|0,(f[i>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)YDc(n);u=c;return}function Obc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)OQb(m,23816,8);h=MQb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){SHa(d,m);m=f[d>>2]|0;dJc((f[k>>2]|0)+4+(m<<2)|0,(f[e>>2]|0)+4|0,f[a>>2]<<2|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){SHa(a,m);dJc((f[e>>2]|0)+4+(f[a>>2]<<2)|0,(f[i>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)YDc(n);u=c;return}function Pbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)OQb(m,23816,8);h=MQb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){THa(d,m);m=f[d>>2]|0;dJc((f[k>>2]|0)+8+(m<<3)|0,(f[e>>2]|0)+8|0,f[a>>2]<<3|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){THa(a,m);dJc((f[e>>2]|0)+8+(f[a>>2]<<3)|0,(f[i>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)YDc(n);u=c;return}function Qbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)OQb(m,23816,8);h=MQb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){zNa(d,m);m=f[d>>2]|0;dJc((f[k>>2]|0)+4+m|0,(f[e>>2]|0)+4|0,f[a>>2]|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){zNa(a,m);dJc((f[a>>2]|0)+((f[e>>2]|0)+4)|0,(f[i>>2]|0)+4|0,f[b>>2]|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)YDc(n);u=c;return}function Rbc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=e+4|0;f[g>>2]=0;h=e+8|0;f[h>>2]=0;i=e+12|0;f[i>>2]=0;Ubc(e,a);j=a+4|0;k=f[j>>2]|0;if((k|0)>0){l=f[a+12>>2]|0;m=0;do{n=f[l+4+(m<<2)>>2]|0;m=m+1|0;o=n+11|0;if((b[o>>0]|0)<0){b[f[n>>2]>>0]=0;f[n+4>>2]=0}else{b[n>>0]=0;b[o>>0]=0}}while((m|0)!=(k|0));f[j>>2]=0}Ubc(a,c);a=c+4|0;j=f[a>>2]|0;k=c+12|0;if((j|0)>0){m=f[k>>2]|0;l=0;do{o=f[m+4+(l<<2)>>2]|0;l=l+1|0;n=o+11|0;if((b[n>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0}else{b[o>>0]=0;b[n>>0]=0}}while((l|0)!=(j|0));f[a>>2]=0;p=0}else p=j;j=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=j;f[a>>2]=f[g>>2];f[g>>2]=p;p=c+8|0;c=f[p>>2]|0;f[p>>2]=f[h>>2];f[h>>2]=c;c=j;if(!((j|0)!=0&(f[e>>2]|0)==0)){u=d;return}e=j;j=f[c>>2]|0;if((j|0)>0){h=0;do{p=f[c+4+(h<<2)>>2]|0;if(p|0){if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);YDc(p)}h=h+1|0}while((h|0)!=(j|0));q=f[i>>2]|0}else q=e;YDc(q);u=d;return}function Sbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;f[d>>2]=f[b>>2];e=d+4|0;f[e>>2]=0;g=d+8|0;f[g>>2]=0;h=d+12|0;f[h>>2]=0;Tbc(d,a);i=a+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[a+12>>2]|0;l=0;do{m=f[k+4+(l<<2)>>2]|0;l=l+1|0;Yi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((l|0)!=(j|0));f[i>>2]=0}Tbc(a,b);a=b+4|0;i=f[a>>2]|0;j=b+12|0;if((i|0)>0){l=f[j>>2]|0;k=0;do{m=f[l+4+(k<<2)>>2]|0;k=k+1|0;Yi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((k|0)!=(i|0));f[a>>2]=0;n=0}else n=i;i=f[j>>2]|0;f[j>>2]=f[h>>2];f[h>>2]=i;f[a>>2]=f[e>>2];f[e>>2]=n;n=b+8|0;b=f[n>>2]|0;f[n>>2]=f[g>>2];f[g>>2]=b;b=i;if(!((i|0)!=0&(f[d>>2]|0)==0)){u=c;return}d=i;i=f[b>>2]|0;if((i|0)>0){g=0;do{n=f[b+4+(g<<2)>>2]|0;if(n|0)Yi[f[(f[n>>2]|0)+4>>2]&2047](n);g=g+1|0}while((g|0)!=(i|0));o=f[h>>2]|0}else o=d;YDc(o);u=c;return}function Tbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{pbc(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=zhc(h,i)|0;pbc(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function Ubc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{SSb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;SSb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)==(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,4984,16);l=NQb(i,16,1733)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;SSb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Vbc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=wYb(a,c)|0;if(g|0){h=f[g>>2]|0;u=d;return h|0}if((f[220804]|0)==2){h=527320;u=d;return h|0}f[e>>2]=161028;f[e+4>>2]=125;b[e+8>>0]=0;DTb(883216,e);ZSb(e);h=527320;u=d;return h|0}function Wbc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;f[a>>2]=166676;g=a+4|0;f[g>>2]=b;h=a+8|0;i=c;c=h+36|0;do{f[h>>2]=f[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(c|0));if(!d){i=kYb()|0;j=i;k=f[g>>2]|0}else{j=d;k=b}f[a+44>>2]=j;f[a+48>>2]=e;f[a+52>>2]=(f[k+52>>2]|0)+-1;return}function Xbc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+64|0;l=k;m=k+8|0;n=k+32|0;o=eVb(kYb()|0,a)|0;if(!o){rTb(m,3,493760,2329);oTb(k+56|0,mTb(m,496724)|0);sTb(m)}if(!g)p=khc()|0;else p=g;f[n>>2]=p;p=n+4|0;f[p>>2]=h;g=n+8|0;f[g>>2]=i;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;e=o+28|0;if((f[e>>2]|0)>0){d=o+68|0;c=0;do{Ybc(n,(f[d>>2]|0)+(c*88|0)|0);c=c+1|0}while((c|0)<(f[e>>2]|0))}e=f[o+32>>2]|0;if((e|0)>0){c=o+72|0;d=0;n=f[g>>2]|0;do{f[n>>2]=(f[c>>2]|0)+(d*48|0);n=n+4|0;d=d+1|0}while((d|0)<(e|0));f[g>>2]=n}if(b[(f[o+84>>2]|0)+84>>0]|0?(n=f[o+36>>2]|0,(n|0)>0):0){g=o+76|0;o=0;do{f[j+(o<<2)>>2]=(f[g>>2]|0)+(o*24|0);o=o+1|0}while((o|0)<(n|0))}n=Zbc()|0;o=f[p>>2]|0;dTb(n);f[l>>2]=h;f[l+4>>2]=o;o=n+8|0;h=f[o>>2]|0;if((h|0)==(f[n+12>>2]|0)){_bc(n+4|0,l);eTb(n);u=k;return}else{p=l;l=f[p+4>>2]|0;g=h;f[g>>2]=f[p>>2];f[g+4>>2]=l;f[o>>2]=(f[o>>2]|0)+8;eTb(n);u=k;return}}function Ybc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=b+60|0;if((f[c>>2]|0)>0){d=b+28|0;e=0;do{Ybc(a,(f[d>>2]|0)+(e*88|0)|0);e=e+1|0}while((e|0)<(f[c>>2]|0))}c=a+4|0;f[f[c>>2]>>2]=b;e=VDc(56)|0;d=a+16|0;g=f[a+20>>2]|0;h=a+12|0;i=f[h>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;l=f[i+8>>2]|0;i=f[f[d>>2]>>2]|0;m=g+(j<<2)|0;n=f[m>>2]|0;o=f[g+(j+1<<2)>>2]|0;p=f[g+(j+2<<2)>>2]|0;q=f[g+(j+3<<2)>>2]|0;r=f[g+(j+4<<2)>>2]|0;j=kYb()|0;s=f[a>>2]|0;f[e>>2]=166676;t=e+4|0;f[t>>2]=b;f[e+8>>2]=i;f[e+12>>2]=m+20;f[e+16>>2]=g+(k<<2);f[e+20>>2]=n;f[e+24>>2]=o;f[e+28>>2]=p;f[e+32>>2]=q;f[e+36>>2]=l;f[e+40>>2]=r;if(!j){r=kYb()|0;u=r;v=f[t>>2]|0}else{u=j;v=b}f[e+44>>2]=u;f[e+48>>2]=s;f[e+52>>2]=(f[v+52>>2]|0)+-1;v=f[c>>2]|0;f[v+4>>2]=e;e=f[b+64>>2]|0;if((e|0)<=0){w=v;x=f[h>>2]|0;y=x+12|0;f[h>>2]=y;z=f[d>>2]|0;A=z+4|0;f[d>>2]=A;B=w+8|0;f[c>>2]=B;return}v=b+32|0;b=a+8|0;a=0;s=f[b>>2]|0;do{f[s>>2]=(f[v>>2]|0)+(a*48|0);s=(f[b>>2]|0)+4|0;f[b>>2]=s;a=a+1|0}while((a|0)<(e|0));w=f[c>>2]|0;x=f[h>>2]|0;y=x+12|0;f[h>>2]=y;z=f[d>>2]|0;A=z+4|0;f[d>>2]=A;B=w+8|0;f[c>>2]=B;return}function Zbc(){var a=0,c=0;if(b[529040]|0){a=f[220865]|0;return a|0}if(!(MIc(529040)|0)){a=f[220865]|0;return a|0}c=VDc(16)|0;tTb(c);f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;iTb(164);f[220865]=c;a=f[220865]|0;return a|0}function _bc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function $bc(){var a=0,b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=Zbc()|0;if(!a)return;b=a+4|0;c=a+8|0;d=f[c>>2]|0;e=f[b>>2]|0;g=e;h=d;if((d|0)==(e|0)){i=g;j=h}else{k=0;l=g;g=h;h=e;e=d;while(1){d=f[l+(k<<3)>>2]|0;if(d>>>0<(f[l+(k<<3)+4>>2]|0)>>>0){m=d;d=h;n=l;while(1){o=f[m+4>>2]|0;if(!o){p=n;q=d}else{Yi[f[(f[o>>2]|0)+4>>2]&2047](o);o=f[b>>2]|0;p=o;q=o}m=m+8|0;if(m>>>0>=(f[p+(k<<3)+4>>2]|0)>>>0)break;else{d=q;n=p}}n=f[c>>2]|0;r=q;s=n;t=n}else{r=h;s=e;t=g}k=k+1|0;n=r;if(k>>>0>=s-r>>3>>>0){i=n;j=t;break}else{l=n;g=t;h=r;e=s}}}if(i|0){if((j|0)!=(i|0))f[c>>2]=j+(~((j+-8-i|0)>>>3)<<3);YDc(i)}uTb(a);YDc(a);return}function acc(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)>0)c=0;else return;do{d=f[a+(c<<3)+4>>2]|0;if(d|0)vhc(f[a+(c<<3)>>2]|0,f[d+8>>2]|0);c=c+1|0}while((c|0)!=(b|0));return}function bcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0.0;d=u;u=u+128|0;e=d;g=d+104|0;h=d+72|0;i=d+48|0;j=d+24|0;k=d+20|0;l=d+8|0;m=+qrc(a,k);n=(c|0)!=0;o=f[k>>2]|0;if(n)f[c>>2]=o;if((b[o>>0]|0)!=46){q=m;u=d;return +q}p[e>>3]=1.5;k=Aqc(g,496753,e)|0;if((b[g>>0]|0)!=49){rTb(h,3,496758,63);oTb(d+98|0,mTb(h,496846)|0);sTb(h)}if((b[g+(k+-1)>>0]|0)!=53){rTb(i,3,496758,64);oTb(d+97|0,mTb(i,496881)|0);sTb(i)}if((k|0)>=7){rTb(j,3,496758,65);oTb(d+96|0,mTb(j,496921)|0);sTb(j)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;mEc(l,k+-3+(Mpc(a)|0)|0);ccc(l,a,o)|0;tEc(l,g+1|0,k+-2|0)|0;uEc(l,o+1|0)|0;k=l+11|0;g=(b[k>>0]|0)<0?f[l>>2]|0:l;m=+qrc(g,e);j=f[e>>2]|0;e=g;g=b[k>>0]|0;if(n&(j-e|0)>(o-a|0)){o=g<<24>>24<0?f[l+4>>2]|0:g&255;n=a+((Mpc(a)|0)-(o+e)+j)|0;f[c>>2]=n}if(g<<24>>24<0)YDc(f[l>>2]|0);q=m;u=d;return +q}function ccc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=c;h=e;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[a+8>>2]&2147483647)+-1|0}else{l=j&255;m=10}n=d-g|0;if(!n){u=e;return a|0}if(k){k=f[a>>2]|0;o=k;p=f[a+4>>2]|0;q=k}else{o=a;p=j&255;q=a}if(q>>>0<=c>>>0&(o+p|0)>>>0>c>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(n>>>0>4294967279)dEc(h);if(n>>>0<11){b[h+11>>0]=n;r=h}else{p=n+16&-16;o=VDc(p)|0;f[h>>2]=o;f[h+8>>2]=p|-2147483648;f[h+4>>2]=n;r=o}if((c|0)==(d|0))s=r;else{o=r;p=c;while(1){b[o>>0]=b[p>>0]|0;p=p+1|0;if((p|0)==(d|0))break;else o=o+1|0}s=r+n|0}b[s>>0]=0;s=h+11|0;r=b[s>>0]|0;o=r<<24>>24<0;tEc(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:r&255)|0;if((b[s>>0]|0)<0)YDc(f[h>>2]|0);u=e;return a|0}if((m-l|0)>>>0<n>>>0){qEc(a,m,l+n-m|0,l,l,0,0);t=b[i>>0]|0}else t=j;if(t<<24>>24<0)v=f[a>>2]|0;else v=a;t=v+l|0;if((c|0)==(d|0))w=t;else{j=d+(l-g)|0;g=c;c=t;while(1){b[c>>0]=b[g>>0]|0;g=g+1|0;if((g|0)==(d|0))break;else c=c+1|0}w=v+j|0}b[w>>0]=0;w=l+n|0;if((b[i>>0]|0)<0){f[a+4>>2]=w;u=e;return a|0}else{b[i>>0]=w;u=e;return a|0}return 0}function dcc(a){a=+a;var b=0.0;if(!(a>3402823466385288598117041.0e14))if(a<-3402823466385288598117041.0e14)b=-D;else b=a;else b=D;return +b}function ecc(a){a=a|0;return}function fcc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=a+32|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=a+56|0;f[h>>2]=c;f[a+60>>2]=d;d=a+68|0;i=a+72|0;j=a+80|0;f[a+84>>2]=0;f[a+88>>2]=0;f[a+92>>2]=0;k=d+4|0;f[k>>2]=0;f[k+4>>2]=0;b[k+8>>0]=0;f[a+96>>2]=-1;b[a+100>>0]=0;f[a+104>>2]=0;b[a+108>>0]=1;b[a+109>>0]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a>>2]=0;f[g>>2]=0;f[d>>2]=0;f[a+76>>2]=0;k=c;while(1){if(!(hj[f[(f[k>>2]|0)+8>>2]&511](k,g,i)|0)){l=3;break}if(f[i>>2]|0){l=6;break}k=f[h>>2]|0}if((l|0)==3){f[i>>2]=0;b[j>>0]=1;m=0;n=a+64|0;b[n>>0]=m;u=e;return}else if((l|0)==6){l=f[g>>2]|0;f[d>>2]=l;m=b[l>>0]|0;n=a+64|0;b[n>>0]=m;u=e;return}}function gcc(a){a=a|0;var c=0,d=0,e=0;c=f[a+72>>2]|0;d=f[a+76>>2]|0;if((c|0)>(d|0)){e=f[a+56>>2]|0;mi[f[(f[e>>2]|0)+12>>2]&2047](e,c-d|0)}d=a+32|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);d=a+4|0;if((b[d+11>>0]|0)>=0)return;YDc(f[d>>2]|0);return}function hcc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+64|0;g=b[e>>0]|0;if(g<<24>>24==10){h=a+84|0;f[h>>2]=(f[h>>2]|0)+1;f[a+88>>2]=0}else{h=a+88|0;i=f[h>>2]|0;if(g<<24>>24==9)j=8-((i|0)%8|0)|0;else j=1;f[h>>2]=j+i}i=a+76|0;j=(f[i>>2]|0)+1|0;f[i>>2]=j;h=a+72|0;g=f[h>>2]|0;if((j|0)<(g|0)){b[e>>0]=b[(f[a+68>>2]|0)+j>>0]|0;u=c;return}j=a+80|0;if(b[j>>0]|0){b[e>>0]=0;u=c;return}k=f[a+92>>2]|0;if(k|0?(l=a+96|0,m=f[l>>2]|0,(g|0)>(m|0)):0){tEc(k,(f[a+68>>2]|0)+m|0,g-m|0)|0;f[l>>2]=0}f[d>>2]=0;l=a+68|0;f[l>>2]=0;f[i>>2]=0;i=a+56|0;while(1){a=f[i>>2]|0;if(!(hj[f[(f[a>>2]|0)+8>>2]&511](a,d,h)|0)){n=15;break}if(f[h>>2]|0){n=17;break}}if((n|0)==15){f[h>>2]=0;b[j>>0]=1;o=0}else if((n|0)==17){n=f[d>>2]|0;f[l>>2]=n;o=b[n>>0]|0}b[e>>0]=o;u=c;return}function icc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;g=a+64|0;h=a+109|0;i=e+8|0;j=e+4|0;k=a+60|0;l=a+84|0;m=a+88|0;n=e+11|0;o=e+8|0;p=e+4|0;q=e+11|0;r=e+8|0;s=e+4|0;t=e+11|0;v=e+8|0;w=e+4|0;x=e+11|0;a:while(1){y=b[g>>0]|0;switch(y<<24>>24|0){case 0:{z=3;break a;break}case 10:{if(!(b[h>>0]|0)){z=7;break a}hcc(a);continue a;break}case 92:{hcc(a);A=b[g>>0]|0;switch(A<<24>>24){case 34:case 39:case 63:case 92:case 118:case 116:case 114:case 110:case 102:case 98:case 97:{hcc(a);continue a;break}default:{}}if((A&-8)<<24>>24==48){hcc(a);continue a}switch(A<<24>>24){case 120:{hcc(a);A=b[g>>0]|0;b:do if((A+-48&255)>=10){switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{break b;break}default:{}}B=VDc(48)|0;f[e>>2]=B;f[i>>2]=-2147483600;f[j>>2]=40;C=B;D=497061;E=C+40|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+40>>0]=0;F=f[k>>2]|0;ei[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[n>>0]|0)<0)YDc(f[e>>2]|0);continue a}while(0);hcc(a);continue a;break}case 117:{hcc(a);A=b[g>>0]|0;if((A+-48&255)<10)z=24;else switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{z=24;break}default:{}}c:do if((z|0)==24){z=0;hcc(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}hcc(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}hcc(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}hcc(a);continue a}while(0);A=VDc(64)|0;f[e>>2]=A;f[o>>2]=-2147483584;f[p>>2]=48;C=A;D=497102;E=C+48|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[A+48>>0]=0;F=f[k>>2]|0;ei[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[q>>0]|0)<0)YDc(f[e>>2]|0);continue a;break}case 85:{hcc(a);d:do if((b[g>>0]|0)==48?(hcc(a),(b[g>>0]|0)==48):0){hcc(a);switch(b[g>>0]|0){case 48:{hcc(a);break}case 49:{hcc(a);break}default:break d}F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}hcc(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}hcc(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}hcc(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}hcc(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}hcc(a);continue a}while(0);A=VDc(64)|0;f[e>>2]=A;f[r>>2]=-2147483584;f[s>>2]=61;C=A;D=497151;E=C+61|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[A+61>>0]=0;F=f[k>>2]|0;ei[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[t>>0]|0)<0)YDc(f[e>>2]|0);continue a;break}default:{F=VDc(48)|0;f[e>>2]=F;f[v>>2]=-2147483600;f[w>>2]=42;C=F;D=497213;E=C+42|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[F+42>>0]=0;A=f[k>>2]|0;ei[f[(f[A>>2]|0)+8>>2]&511](A,f[l>>2]|0,f[m>>2]|0,e);if((b[x>>0]|0)<0)YDc(f[e>>2]|0);continue a}}break}default:{hcc(a);if(y<<24>>24==c<<24>>24){z=57;break a}else continue a}}}if((z|0)==3){c=VDc(32)|0;f[e>>2]=c;f[e+8>>2]=-2147483616;f[e+4>>2]=25;C=c;D=496989;E=C+25|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[c+25>>0]=0;c=f[k>>2]|0;ei[f[(f[c>>2]|0)+8>>2]&511](c,f[l>>2]|0,f[m>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);u=d;return}else if((z|0)==7){c=VDc(48)|0;f[e>>2]=c;f[e+8>>2]=-2147483600;f[e+4>>2]=45;C=c;D=497015;E=C+45|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[c+45>>0]=0;c=f[k>>2]|0;ei[f[(f[c>>2]|0)+8>>2]&511](c,f[l>>2]|0,f[m>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);u=d;return}else if((z|0)==57){u=d;return}}function jcc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+64|0;i=b[h>>0]|0;a:do if(c){switch(i<<24>>24){case 120:{hcc(a);break}case 88:{hcc(a);break}default:{if((i+-48&255)>=10){j=20;break a}if((i&-8)<<24>>24==48){do{hcc(a);k=b[h>>0]|0}while((k&-8)<<24>>24==48);l=k}else l=i;if((l+-48&255)>=10){m=0;break a}k=VDc(64)|0;f[g>>2]=k;f[g+8>>2]=-2147483584;f[g+4>>2]=52;n=k;o=497293;p=n+52|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[k+52>>0]=0;q=f[a+60>>2]|0;ei[f[(f[q>>2]|0)+8>>2]&511](q,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if(((b[h>>0]|0)+-48&255)>=10){m=0;break a}while(1){hcc(a);if(((b[h>>0]|0)+-48&255)>=10){m=0;break a}}}}k=b[h>>0]|0;b:do if((k+-48&255)>=10){switch(k<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{break b;break}default:{}}q=VDc(48)|0;f[g>>2]=q;f[g+8>>2]=-2147483600;f[g+4>>2]=36;n=q;o=497256;p=n+36|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+36>>0]=0;r=f[a+60>>2]|0;ei[f[(f[r>>2]|0)+8>>2]&511](r,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);m=0;break a}while(0);while(1){hcc(a);k=b[h>>0]|0;if((k+-48&255)<10)continue;switch(k<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{m=0;break a}}}}else j=20;while(0);c:do if((j|0)==20){if((i+-48&255)<10){do{hcc(a);l=b[h>>0]|0}while((l+-48&255)<10);s=l}else s=i;if(!d)if(s<<24>>24==46){hcc(a);l=b[h>>0]|0;if((l+-48&255)<10){do{hcc(a);c=b[h>>0]|0}while((c+-48&255)<10);t=1;v=c}else{t=1;v=l}}else{t=0;v=s}else{t=1;v=s}switch(v<<24>>24){case 101:{hcc(a);j=29;break}case 69:{hcc(a);j=29;break}default:w=t}d:do if((j|0)==29){switch(b[h>>0]|0){case 45:{hcc(a);break}case 43:{hcc(a);break}default:{}}if(((b[h>>0]|0)+-48&255)<10)while(1){hcc(a);if(((b[h>>0]|0)+-48&255)>=10){w=1;break d}}q=VDc(48)|0;f[g>>2]=q;f[g+8>>2]=-2147483600;f[g+4>>2]=33;n=q;o=497346;p=n+33|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+33>>0]=0;c=f[a+60>>2]|0;ei[f[(f[c>>2]|0)+8>>2]&511](c,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);w=1}while(0);if(!(b[a+100>>0]|0))m=w;else switch(b[h>>0]|0){case 102:{hcc(a);m=1;break c;break}case 70:{hcc(a);m=1;break c;break}default:{m=w;break c}}}while(0);w=b[h>>0]|0;if(w<<24>>24==95|((w&-33)+-65&255)<26?b[a+108>>0]|0:0){h=VDc(48)|0;f[g>>2]=h;f[g+8>>2]=-2147483600;f[g+4>>2]=41;n=h;o=497380;p=n+41|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[h+41>>0]=0;h=f[a+60>>2]|0;ei[f[(f[h>>2]|0)+8>>2]&511](h,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);x=m?4:3;u=e;return x|0}if(w<<24>>24!=46){x=m?4:3;u=e;return x|0}if(m){w=VDc(64)|0;f[g>>2]=w;f[g+8>>2]=-2147483584;f[g+4>>2]=62;n=w;o=497422;p=n+62|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[w+62>>0]=0;w=f[a+60>>2]|0;ei[f[(f[w>>2]|0)+8>>2]&511](w,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);x=m?4:3;u=e;return x|0}else{w=VDc(48)|0;f[g>>2]=w;f[g+8>>2]=-2147483600;f[g+4>>2]=39;n=w;o=497485;p=n+39|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[w+39>>0]=0;w=f[a+60>>2]|0;ei[f[(f[w>>2]|0)+8>>2]&511](w,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);x=m?4:3;u=e;return x|0}return 0}function kcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=a+84|0;h=f[g>>2]|0;i=a+88|0;j=(f[i>>2]|0)+-2|0;k=(c|0)!=0;if(k){l=a+92|0;f[l>>2]=c;m=a+76|0;n=a+96|0;f[n>>2]=f[m>>2];o=l;p=n;q=m}else{o=a+92|0;p=a+96|0;q=a+76|0}m=a+64|0;n=a+68|0;l=e+8|0;r=e+4|0;s=a+60|0;t=e+11|0;while(1){a:while(1){v=b[m>>0]|0;switch(v<<24>>24){case 10:{w=8;break a;break}case 42:{w=19;break a;break}case 47:{w=27;break a;break}case 0:{x=v;break a;break}default:{}}hcc(a)}if((w|0)==8){w=0;hcc(a);if(k){v=f[q>>2]|0;y=f[p>>2]|0;if((v|0)!=(y|0))tEc(f[o>>2]|0,(f[n>>2]|0)+y|0,v-y|0)|0;f[o>>2]=0;f[p>>2]=-1}y=b[m>>0]|0;v=y+-9<<24>>24;if((v&255)>23|(8388637>>>(v&255)&1|0)==0)z=y;else{do{hcc(a);y=b[m>>0]|0;v=y+-9<<24>>24}while(!((v&255)>23|(8388637>>>(v&255)&1|0)==0));z=y}if(z<<24>>24==42?(hcc(a),(b[m>>0]|0)==47):0){w=16;break}if(!k)continue;f[o>>2]=c;f[p>>2]=f[q>>2];continue}else if((w|0)==19){w=0;hcc(a);y=b[m>>0]|0;if(y<<24>>24==47){w=20;break}else x=y}else if((w|0)==27){w=0;hcc(a);y=b[m>>0]|0;if(y<<24>>24==42){v=VDc(64)|0;f[e>>2]=v;f[l>>2]=-2147483584;f[r>>2]=60;A=v;B=497525;C=A+60|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[v+60>>0]=0;D=f[s>>2]|0;ei[f[(f[D>>2]|0)+8>>2]&511](D,f[g>>2]|0,f[i>>2]|0,e);if((b[t>>0]|0)<0)YDc(f[e>>2]|0);continue}else x=y}if(!(x<<24>>24)){w=32;break}}if((w|0)==16){hcc(a);u=d;return}else if((w|0)==20){hcc(a);if(!k){u=d;return}a=f[q>>2]|0;x=f[p>>2]|0;if((a|0)!=(x|0))tEc(f[o>>2]|0,(f[n>>2]|0)+x|0,a-x|0)|0;f[o>>2]=0;f[p>>2]=-1;x=b[c+11>>0]|0;if(x<<24>>24<0)E=f[c+4>>2]|0;else E=x&255;yEc(c,E+-2|0,-1)|0;u=d;return}else if((w|0)==32){w=VDc(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=33;A=w;B=497586;C=A+33|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[w+33>>0]=0;w=f[s>>2]|0;ei[f[(f[w>>2]|0)+8>>2]&511](w,f[g>>2]|0,f[i>>2]|0,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);i=f[s>>2]|0;s=f[(f[i>>2]|0)+8>>2]|0;g=VDc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=23;A=g;B=497620;C=A+23|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[g+23>>0]=0;ei[s&511](i,h,j,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if(!k){u=d;return}k=f[q>>2]|0;q=f[p>>2]|0;if((k|0)!=(q|0))tEc(f[o>>2]|0,(f[n>>2]|0)+q|0,k-q|0)|0;f[o>>2]=0;f[p>>2]=-1;u=d;return}}function lcc(a){a=a|0;var c=0,d=0;switch(f[a+104>>2]|0){case 0:{c=a+64|0;if((b[c>>0]|0)!=47){d=3;return d|0}hcc(a);switch(b[c>>0]|0){case 47:{hcc(a);d=0;return d|0}case 42:{hcc(a);d=1;return d|0}default:{f[a>>2]=6;nEc(a+4|0,517940)|0;f[a+16>>2]=f[a+84>>2];c=f[a+88>>2]|0;f[a+20>>2]=c+-1;f[a+24>>2]=c;d=2;return d|0}}break}case 1:{if((b[a+64>>0]|0)!=35){d=3;return d|0}hcc(a);d=0;return d|0}default:{d=3;return d|0}}return 0}function mcc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+16|0;d=c;e=c+4|0;g=a+28|0;f[g>>2]=f[a>>2];h=a+4|0;iEc(a+32|0,h)|0;i=a+44|0;j=a+16|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];k=a+80|0;a:do if(!(b[k>>0]|0)){l=a+64|0;m=e+8|0;n=e+4|0;o=a+60|0;p=a+84|0;q=a+88|0;r=e+11|0;b:while(1){s=(b[l>>0]|0)+-9<<24>>24;if(!((s&255)>23|(8388639>>>(s&255)&1|0)==0))do{hcc(a);s=(b[l>>0]|0)+-9<<24>>24}while(!((s&255)>23|(8388639>>>(s&255)&1|0)==0));c:do switch(lcc(a)|0){case 2:{t=1;v=59;break b;break}case 0:{d:while(1){switch(b[l>>0]|0){case 0:{break c;break}case 10:{break d;break}default:{}}hcc(a)}hcc(a);break}case 1:{kcc(a,0);break}default:{if(b[k>>0]|0){v=54;break a}w=b[l>>0]|0;if(!((w+-1&255)<31|w<<24>>24==0))break b;s=VDc(48)|0;f[e>>2]=s;f[m>>2]=-2147483600;f[n>>2]=47;x=s;y=497644;z=x+47|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[s+47>>0]=0;A=f[o>>2]|0;ei[f[(f[A>>2]|0)+8>>2]&511](A,f[p>>2]|0,f[q>>2]|0,e);if((b[r>>0]|0)<0)YDc(f[e>>2]|0);hcc(a);while(1){A=b[l>>0]|0;if((A+-1&255)<31){hcc(a);continue}if(b[k>>0]|0){v=54;break a}if(A<<24>>24)break c;hcc(a)}}}while(0);if(b[k>>0]|0){v=54;break a}}if((v|0)==59){u=c;return t|0}f[a>>2]=0;r=h+11|0;if((b[r>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+8>>2]=0;B=b[l>>0]|0}else{b[h>>0]=0;b[r>>0]=0;B=w}f[j>>2]=f[p>>2];r=a+20|0;f[r>>2]=f[q>>2];n=a+92|0;f[n>>2]=h;m=a+76|0;s=a+96|0;f[s>>2]=f[m>>2];e:do if(B<<24>>24==95|((B&-33)+-65&255)<26){hcc(a);A=b[l>>0]|0;if(((A&-33)+-65&255)<26|(A<<24>>24==95|(A+-48&255)<10)){do{hcc(a);A=b[l>>0]|0}while(((A&-33)+-65&255)<26|(A<<24>>24==95|(A+-48&255)<10));C=2}else C=2}else{switch(B<<24>>24){case 48:{hcc(a);C=jcc(a,1,0)|0;break e;break}case 46:{hcc(a);D=1;E=b[l>>0]|0;break}default:{D=0;E=B}}if((E+-48&255)<10){hcc(a);F=1}else F=0;if(D){if(!F){C=6;break}if(((f[g>>2]|0)==2?(f[j>>2]|0)==(f[i>>2]|0):0)?(f[r>>2]|0)==(f[a+52>>2]|0):0){A=f[o>>2]|0;G=f[(f[A>>2]|0)+8>>2]|0;H=f[p>>2]|0;I=(f[q>>2]|0)+-2|0;J=VDc(64)|0;f[e>>2]=J;f[e+8>>2]=-2147483584;f[e+4>>2]=48;x=J;y=497692;z=x+48|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[J+48>>0]=0;ei[G&511](A,H,I,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0)}C=jcc(a,0,1)|0;break}if(F){C=jcc(a,0,0)|0;break}K=b[l>>0]|0;switch(K<<24>>24){case 34:{hcc(a);icc(a,34);C=5;break e;break}case 39:{hcc(a);icc(a,39);C=5;break e;break}default:{if(K<<24>>24<0?(L=f[o>>2]|0,M=f[(f[L>>2]|0)+8>>2]|0,N=f[p>>2]|0,O=f[q>>2]|0,f[d>>2]=K&255,Rlc(e,497741,d),ei[M&511](L,N,O,e),(b[e+11>>0]|0)<0):0)YDc(f[e>>2]|0);hcc(a);C=6;break e}}}while(0);f[a>>2]=C;p=f[m>>2]|0;o=f[s>>2]|0;if((p|0)!=(o|0))tEc(f[n>>2]|0,(f[a+68>>2]|0)+o|0,p-o|0)|0;f[n>>2]=0;f[s>>2]=-1;P=1;Q=f[q>>2]|0}else v=54;while(0);if((v|0)==54){f[a>>2]=1;v=h+11|0;if((b[v>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+8>>2]=0}else{b[h>>0]=0;b[v>>0]=0}f[j>>2]=f[a+84>>2];j=f[a+88>>2]|0;f[a+20>>2]=j;P=0;Q=j}f[a+24>>2]=Q;t=P;u=c;return t|0}function ncc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=(b[a+11>>0]|0)<0?f[a>>2]|0:a;a=b[g>>0]|0;a:do if(a<<24>>24==48){switch(b[g+1>>0]|0){case 88:case 120:break;default:{h=8;i=g;j=48;k=5;break a}}l=g+2|0;m=16;n=l;o=b[l>>0]|0;k=4}else{m=10;n=g;o=a;k=4}while(0);if((k|0)==4)if(!(o<<24>>24)){p=0;q=0}else{h=m;i=n;j=o;k=5}b:do if((k|0)==5){o=i;n=j;m=0;a=0;while(1){g=n<<24>>24;if((n+-48&255)>=10)if((n+-97&255)<26){r=-87;k=9}else s=(n+-65&255)<26?g+-55|0:-1;else{r=-48;k=9}if((k|0)==9){k=0;s=r+g|0}if(s>>>0>=h>>>0){t=0;k=15;break}g=((s|0)<0)<<31>>31;if(g>>>0>d>>>0|(g|0)==(d|0)&s>>>0>c>>>0){t=0;k=15;break}l=TIc(c|0,d|0,s|0,g|0)|0;u=cJc(l|0,J|0,h|0,0)|0;l=J;if(m>>>0>l>>>0|(m|0)==(l|0)&a>>>0>u>>>0){t=0;k=15;break}u=mJc(a|0,m|0,h|0,0)|0;l=UIc(s|0,g|0,u|0,J|0)|0;u=J;o=o+1|0;n=b[o>>0]|0;if(!(n<<24>>24)){p=l;q=u;break b}else{m=u;a=l}}if((k|0)==15)return t|0}while(0);k=e;f[k>>2]=p;f[k+4>>2]=q;t=1;return t|0}function occ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+48|0;d=c+36|0;e=c;g=c+24|0;h=c+40|0;i=a+11|0;j=(b[i>>0]|0)<0?f[a>>2]|0:a;k=+bcc(j,d);l=f[d>>2]|0;m=b[l>>0]|0;a:do switch(m<<24>>24){case 69:case 101:{n=l+1|0;f[d>>2]=n;o=b[n>>0]|0;switch(o<<24>>24){case 43:case 45:break;default:{p=n;q=o;break a}}o=l+2|0;f[d>>2]=o;p=o;q=b[o>>0]|0;break}default:{p=l;q=m}}while(0);switch(q<<24>>24){case 70:case 102:{q=p+1|0;f[d>>2]=q;r=q;break}default:r=p}p=b[i>>0]|0;if((r-j|0)==((p<<24>>24<0?f[a+4>>2]|0:p&255)|0)?(b[j>>0]|0)!=45:0){u=c;return +k}rTb(e,2,497778,919);j=mTb(e,497869)|0;_lc(g,a);oTb(h,nTb(j,g)|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);sTb(e);u=c;return +k}function pcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=u;u=u+48|0;e=d;g=d+32|0;h=d+8|0;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[a+4>>2]|0:j&255;if(!k){rTb(h,2,497778,1044);l=mTb(h,497954)|0;_lc(g,a);oTb(d+44|0,nTb(l,g)|0);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);sTb(h);u=d;return}h=b[c+11>>0]|0;if(h<<24>>24<0){m=f[c+4>>2]|0;n=(f[c+8>>2]&2147483647)+-1|0}else{m=h&255;n=10}h=m+k|0;if(h>>>0>n>>>0){mEc(c,h);o=b[i>>0]|0}else o=j;j=g+4|0;h=o<<24>>24<0?f[a>>2]|0:a;a:while(1){o=h+1|0;n=b[o>>0]|0;switch(n<<24>>24){case 0:{break a;break}case 92:{k=h+2|0;m=b[k>>0]|0;if(m<<24>>24){if((m&-8)<<24>>24==48){l=m<<24>>24;if((m+-48&255)>=10)if((m+-97&255)<26){p=-87;q=17}else r=(m+-65&255)<26?l+-55|0:-1;else{p=-48;q=17}if((q|0)==17){q=0;r=p+l|0}l=h+3|0;s=b[l>>0]|0;if((s&-8)<<24>>24==48){t=r<<3;v=s<<24>>24;if((s+-48&255)>=10)if((s+-97&255)<26){w=-87;q=22}else x=(s+-65&255)<26?v+-55|0:-1;else{w=-48;q=22}if((q|0)==22){q=0;x=w+v|0}y=x+t|0;z=l}else{y=r;z=k}l=z+1|0;t=b[l>>0]|0;if((t&-8)<<24>>24==48){v=y<<3;s=t<<24>>24;if((t+-48&255)>=10)if((t+-97&255)<26){A=-87;q=28}else B=(t+-65&255)<26?s+-55|0:-1;else{A=-48;q=28}if((q|0)==28){q=0;B=A+s|0}C=B+v|0;D=l}else{C=y;D=z}vEc(c,C&255);h=D;continue a}switch(m<<24>>24){case 120:{l=h+3|0;v=b[l>>0]|0;b:do if((v+-48&255)>=10){switch(v<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{E=0;F=k;break b}}s=v<<24>>24;if((v+-97&255)<26){G=-87;H=s;q=37}else{E=(v+-65&255)<26?s+-55|0:-1;F=l}}else{G=-48;H=v<<24>>24;q=37}while(0);if((q|0)==37){q=0;E=G+H|0;F=l}v=F+1|0;s=b[v>>0]|0;c:do if((s+-48&255)>=10){switch(s<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{I=E;J=F;break c}}t=E<<4;K=s<<24>>24;if((s+-97&255)<26){L=-87;M=t;N=K;q=43}else{O=t;P=(s+-65&255)<26?K+-55|0:-1;q=44}}else{L=-48;M=E<<4;N=s<<24>>24;q=43}while(0);if((q|0)==43){q=0;O=M;P=L+N|0;q=44}if((q|0)==44){q=0;I=P+O|0;J=v}vEc(c,I&255);h=J;continue a;break}case 85:case 117:{s=h+3|0;l=m<<24>>24==117?4:m<<24>>24==85?8:0;d:do if(l|0){K=s+l|0;t=s;Q=0;do{R=b[t>>0]|0;if(!(R<<24>>24))break d;S=Q<<4;T=R<<24>>24;if((R+-48&255)>=10)if((R+-97&255)<26){U=-87;q=52}else V=(R+-65&255)<26?T+-55|0:-1;else{U=-48;q=52}if((q|0)==52){q=0;V=U+T|0}Q=V+S|0;t=t+1|0}while(t>>>0<K>>>0);do if((((Q&-1024|0)==55296?(b[K>>0]|0)==92:0)?(b[K+1>>0]|0)==117:0)?(t=b[K+2>>0]|0,t<<24>>24!=0):0){S=t<<24>>24;if((t+-48&255)>=10)if((t+-97&255)<26){W=-87;q=61}else X=(t+-65&255)<26?S+-55|0:-1;else{W=-48;q=61}if((q|0)==61){q=0;X=W+S|0}S=b[K+3>>0]|0;if(S<<24>>24){t=X<<4;T=S<<24>>24;if((S+-48&255)>=10)if((S+-97&255)<26){Y=-87;q=66}else Z=(S+-65&255)<26?T+-55|0:-1;else{Y=-48;q=66}if((q|0)==66){q=0;Z=Y+T|0}T=b[K+4>>0]|0;if(T<<24>>24){S=Z+t<<4;t=T<<24>>24;do if((T+-48&255)<10){_=-48;q=71}else{if((T+-97&255)<26){_=-87;q=71;break}$=(T+-65&255)<26?t+-55|0:-1}while(0);if((q|0)==71){q=0;$=_+t|0}T=b[K+5>>0]|0;if(!(T<<24>>24)){aa=K;ba=Q;break}R=$+S<<4;ca=T<<24>>24;do if((T+-48&255)<10){da=-48;q=76}else{if((T+-97&255)<26){da=-87;q=76;break}ea=(T+-65&255)<26?ca+-55|0:-1}while(0);if((q|0)==76){q=0;ea=da+ca|0}T=ea+R|0;S=(T&-1024|0)==56320;aa=S?K+6|0:K;ba=S?(T+-56320|(Q<<10)+-56623104)+65536|0:Q}else{aa=K;ba=Q}}else{aa=K;ba=Q}}else{aa=K;ba=Q}while(0);if((aa|0)!=(k|0)){f[g>>2]=0;do if(ba>>>0>=128){if(ba>>>0<2048){Q=ba&63|ba<<2&7936|49280;f[g>>2]=Q;fa=2;ga=Q;q=89;break}if(ba>>>0<65536){Q=ba&63|ba<<2&16128|ba<<4&983040|14712960;f[g>>2]=Q;fa=3;ga=Q;q=89;break}if(ba>>>0<2097152){Q=ba&63|ba<<4&4128768|ba<<6&117440512|ba<<2&16128|-260013952;f[g>>2]=Q;fa=4;ga=Q;q=89;break}else{f[e>>2]=ba;Slc(c,498047,e);break}}else{f[g>>2]=ba;fa=1;ga=ba;q=89}while(0);if((q|0)==89){q=0;Q=wTb(ga)|0;f[g>>2]=Q;tEc(c,j+(0-fa)|0,fa)|0}h=aa+-1|0;continue a}}while(0);vEc(c,m);h=k;continue a;break}default:{do switch(m<<24>>24|0){case 97:{ha=7;break}case 98:{ha=8;break}case 102:{ha=12;break}case 110:{ha=10;break}case 114:{ha=13;break}case 116:{ha=9;break}case 118:{ha=11;break}case 92:{ha=92;break}case 63:{ha=63;break}case 39:{ha=39;break}case 34:{ha=34;break}default:ha=63}while(0);vEc(c,ha);h=k;continue a}}}break}default:{}}if(n<<24>>24==(b[((b[i>>0]|0)<0?f[a>>2]|0:a)>>0]|0)?(b[h+2>>0]|0)==0:0){h=o;continue}vEc(c,n);h=o}u=d;return}function qcc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=b[a+11>>0]|0;if(!((e<<24>>24<0?f[a+4>>2]|0:e&255)|0)){g=0;u=c;return g|0}e=rEc(a,0)|0;h=b[e>>0]|0;if(!(h<<24>>24==95|((h&-33)+-65&255)<26)){g=0;u=c;return g|0}gEc(d,a,1,-1,a);a=b[d+11>>0]|0;h=a<<24>>24<0;e=h?f[d+4>>2]|0:a&255;a:do if(!e)i=1;else{a=h?f[d>>2]|0:d;j=0;while(1){k=b[a+j>>0]|0;j=j+1|0;if(!(((k&-33)+-65&255)<26|(k<<24>>24==95|(k+-48&255)<10))){i=0;break a}if(j>>>0>=e>>>0){i=1;break}}}while(0);if(h)YDc(f[d>>2]|0);g=i;u=c;return g|0}function rcc(a){a=a|0;f[a>>2]=167096;uSb(a+16|0);return}function scc(a){a=a|0;f[a>>2]=167096;uSb(a+16|0);YDc(a);return}function tcc(a,b,c){a=a|0;b=b|0;c=c|0;return wSb(a+16|0,b,c)|0}function ucc(a,b){a=a|0;b=b|0;xSb(a+16|0,b);return}function vcc(a,b){a=a|0;b=b|0;return ySb(a+16|0,b)|0}function wcc(a){a=a|0;var b=0;b=zSb(a+16|0)|0;return b|0}function xcc(a){a=a|0;return}function ycc(a){a=a|0;YDc(a);return}function zcc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=a+4|0;ouc(f[d>>2]|0,b,c)|0;c=f[d>>2]|0;d=f[c+4>>2]|0;if((d|0)==0?(b=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+16>>2]|0,!((b&5|0)==0|(b&2|0)!=0)):0){e=-1;return e|0}e=d;return e|0}function Acc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;f[a>>2]=167096;d=a+4|0;f[d>>2]=167128;f[a+8>>2]=b;FSb(a+16|0,d,c);return}function Bcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=167152;b=f[a+8>>2]|0;if(b|0?(f[a+4>>2]|0)==0:0){c=b+12|0;d=f[c>>2]|0;if(d|0?(f[b>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}YDc(b)}uTb(a+12|0);return}function Ccc(a){a=a|0;Bcc(a);YDc(a);return}function Dcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+8>>2]|0;if(!b){c=0;return c|0}a=f[b+8>>2]<<2;d=b+12|0;b=f[d>>2]|0;if(!b){c=a;return c|0}if((f[b>>2]|0)>0){e=0;g=a;h=b;while(1){b=f[h+4+(e<<2)>>2]|0;i=(_i[f[(f[b>>2]|0)+84>>2]&1023](b)|0)+g|0;e=e+1|0;h=f[d>>2]|0;if((e|0)>=(f[h>>2]|0)){j=i;break}else g=i}}else j=a;c=j+4|0;return c|0}function Ecc(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;if(f[b>>2]|0)return;c=f[a+4>>2]|0;if(!c){a=VDc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;d=a}else{if(f[c+64>>2]|0)OQb(c,14656,16);a=NQb(c,16,1744)|0;f[a>>2]=c;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;d=a}f[b>>2]=d;return}function Fcc(a){a=a|0;return}function Gcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=u;u=u+16|0;c=b;f[a>>2]=167224;d=a+20|0;e=a+28|0;g=f[e>>2]|0;h=f[g+12>>2]|0;i=f[g+4>>2]|0;a:do if(i>>>0>h>>>0){j=f[g+16>>2]|0;k=h;while(1){l=f[j+(k<<2)>>2]|0;if(l|0)break;m=k+1|0;if(m>>>0<i>>>0)k=m;else{n=0;o=m;break a}}if((l|0)==(f[j+((k^1)<<2)>>2]|0)){n=f[(f[l>>2]|0)+16>>2]|0;o=k;break}else{n=l;o=k;break}}else{n=0;o=h}while(0);f[c>>2]=n;f[c+4>>2]=g;f[c+8>>2]=o;if(n|0){o=n;do{jdc((f[o+16>>2]|0)+16|0);kdc(c)|0;o=f[c>>2]|0}while((o|0)!=0)}idc(d);idc(d);if(f[d>>2]|0){Bcc(a);u=b;return}d=f[e>>2]|0;if(!d){Bcc(a);u=b;return}e=d+16|0;if(f[e>>2]|0?(Qdc(d),(f[d+20>>2]|0)==0):0)YDc(f[e>>2]|0);YDc(d);Bcc(a);u=b;return}function Hcc(a){a=a|0;Gcc(a);YDc(a);return}function Icc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=(_i[f[(f[a>>2]|0)+64>>2]&1023](a)|0)+8|0;$cc(d,f[e>>2]|0,b,0);u=c;return (f[d>>2]|0)!=0|0}function Jcc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;h=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;i=h+8|0;$cc(g,f[i>>2]|0,c,0);j=f[g>>2]|0;if(j|0){k=f[j+16>>2]|0;l=0;m=k+16|0;o=k+20|0;q=f[o>>2]|0;r=d+4|0;f[r>>2]=q;s=f[m>>2]|0;f[d>>2]=s;u=e;return l|0}k=ldc(f[i>>2]|0,c)|0;i=f[k>>2]|0;if(!i){j=mdc(h,c)|0;f[k>>2]=j;t=j}else t=i;i=t+16|0;j=a+32|0;a=f[j>>2]|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);a=f[g>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;k=g+11|0;b[k>>0]=5;b[g>>0]=b[498520]|0;b[g+1>>0]=b[498521]|0;b[g+2>>0]=b[498522]|0;b[g+3>>0]=b[498523]|0;b[g+4>>0]=b[498524]|0;b[g+5>>0]=0;c=uYb(a,g)|0;if((b[k>>0]|0)<0)YDc(f[g>>2]|0);k=c+24|0;a=f[k>>2]|0;if(a|0?(f[a>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(a,g)}a=c+28|0;h=t+20|0;f[h>>2]=f[161216+(f[a>>2]<<2)>>2];t=f[k>>2]|0;if(t|0?(f[t>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=c;DTb(t,g)}do switch(f[161216+(f[a>>2]<<2)>>2]|0){case 1:{g=VDc(4)|0;f[g>>2]=0;v=g;break}case 2:{g=VDc(8)|0;t=g;f[t>>2]=0;f[t+4>>2]=0;v=g;break}case 3:{g=VDc(4)|0;f[g>>2]=0;v=g;break}case 4:{g=VDc(8)|0;t=g;f[t>>2]=0;f[t+4>>2]=0;v=g;break}case 5:{g=VDc(8)|0;p[g>>3]=0.0;v=g;break}case 6:{g=VDc(4)|0;n[g>>2]=0.0;v=g;break}case 7:{g=VDc(1)|0;b[g>>0]=0;v=g;break}case 9:{g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g;break}case 8:{g=VDc(4)|0;f[g>>2]=0;v=g;break}case 10:{g=f[j>>2]|0;t=_i[f[(f[g>>2]|0)+92>>2]&1023](g)|0;g=hh[f[(f[t>>2]|0)+108>>2]&127](t,f[j>>2]|0,c,0)|0;v=_i[f[(f[g>>2]|0)+12>>2]&1023](g)|0;break}default:{l=1;m=i;o=h;q=f[o>>2]|0;r=d+4|0;f[r>>2]=q;s=f[m>>2]|0;f[d>>2]=s;u=e;return l|0}}while(0);f[i>>2]=v;l=1;m=i;o=h;q=f[o>>2]|0;r=d+4|0;f[r>>2]=q;s=f[m>>2]|0;f[d>>2]=s;u=e;return l|0}function Kcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=a+16|0;if((f[i>>2]|0)==1){j=a+12|0;dTb(j);if((f[i>>2]|0)==1){Yi[f[(f[a>>2]|0)+44>>2]&2047](a);f[i>>2]=2}eTb(j)}j=a+28|0;$cc(e,f[j>>2]|0,c,0);c=f[e>>2]|0;k=f[e+4>>2]|0;l=f[e+8>>2]|0;if(!c){m=0;u=d;return m|0}f[i>>2]=0;i=c+16|0;jdc((f[i>>2]|0)+16|0);f[h>>2]=c;f[h+4>>2]=k;f[h+8>>2]=l;if((f[a+20>>2]|0)==0?(a=f[i>>2]|0,a|0):0){if((f[a+8>>2]|0)==9?(i=f[a>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}YDc(a)};f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];kdc(h)|0;h=f[j>>2]|0;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];Bdc(h,e);m=1;u=d;return m|0}function Lcc(a,b,c){a=a|0;b=b|0;c=c|0;return (f[f[b>>2]>>2]|0)==(f[f[c>>2]>>2]|0)|0}function Mcc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=(_i[f[(f[a>>2]|0)+64>>2]&1023](a)|0)+8|0;d=f[c>>2]|0;c=f[d+12>>2]|0;e=f[d+4>>2]|0;a:do if(e>>>0>c>>>0){g=f[d+16>>2]|0;h=c;while(1){i=f[g+(h<<2)>>2]|0;if(i|0)break;j=h+1|0;if(j>>>0<e>>>0)h=j;else{k=0;l=j;break a}}if((i|0)==(f[g+((h^1)<<2)>>2]|0)){k=f[(f[i>>2]|0)+16>>2]|0;l=h;break}else{k=i;l=h;break}}else{k=0;l=c}while(0);c=f[b>>2]|0;f[c>>2]=k;f[c+4>>2]=d;f[c+8>>2]=l;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function Ncc(a,b){a=a|0;b=b|0;_i[f[(f[a>>2]|0)+64>>2]&1023](a)|0;a=f[b>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function Occ(a){a=a|0;var b=0;b=(_i[f[(f[a>>2]|0)+64>>2]&1023](a)|0)+8|0;return f[f[b>>2]>>2]|0}function Pcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=u;u=u+16|0;c=b;d=f[a+8>>2]|0;if(!d)e=12;else{g=f[d+8>>2]<<2;h=d+12|0;d=f[h>>2]|0;if(!d)i=g;else{if((f[d>>2]|0)>0){j=0;k=g;l=d;while(1){d=f[l+4+(j<<2)>>2]|0;m=(_i[f[(f[d>>2]|0)+84>>2]&1023](d)|0)+k|0;j=j+1|0;l=f[h>>2]|0;if((j|0)>=(f[l>>2]|0)){n=m;break}else k=m}}else n=g;i=n+4|0}e=i+12|0}i=f[a+28>>2]|0;a=f[i>>2]|0;if(!a){o=e;u=b;return o|0}n=f[i+12>>2]|0;g=f[i+4>>2]|0;a:do if(g>>>0>n>>>0){k=f[i+16>>2]|0;l=n;while(1){p=f[k+(l<<2)>>2]|0;if(p|0)break;j=l+1|0;if(j>>>0<g>>>0)l=j;else{q=0;r=j;break a}}if((p|0)==(f[k+((l^1)<<2)>>2]|0)){q=f[(f[p>>2]|0)+16>>2]|0;r=l;break}else{q=p;r=l;break}}else{q=0;r=n}while(0);f[c>>2]=q;f[c+4>>2]=i;f[c+8>>2]=r;r=a<<3;i=q;n=i+16|0;p=(kNa(f[n>>2]|0)|0)==9;g=a*12|0;j=(a<<4)+e+r+(p?g:0)|0;do switch(Pdc((f[n>>2]|0)+16|0)|0){case 1:{s=j+(a<<2)|0;break}case 2:{s=j+r|0;break}case 3:{s=j+(a<<2)|0;break}case 4:{s=j+r|0;break}case 5:{s=j+r|0;break}case 6:{s=j+(a<<2)|0;break}case 7:{s=j+a|0;break}case 9:{s=j+g|0;break}case 8:{s=j+(a<<2)|0;break}case 10:{if(!q)s=j;else{p=j;e=i;while(1){h=Odc((f[e+16>>2]|0)+16|0)|0;m=_i[f[(f[h>>2]|0)+92>>2]&1023](h)|0;d=(Mi[f[(f[m>>2]|0)+16>>2]&1023](m,h)|0)+p|0;_cc(c)|0;e=f[c>>2]|0;if(!e){s=d;break}else p=d}}break}default:s=j}while(0);o=s;u=b;return o|0}function Qcc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0.0;c=u;u=u+64|0;d=c+40|0;e=c;g=c+16|0;h=c+56|0;i=a+32|0;j=f[i>>2]|0;k=_i[f[(f[j>>2]|0)+92>>2]&1023](j)|0;j=f[i>>2]|0;mi[f[(f[j>>2]|0)+96>>2]&2047](d,j);j=f[d>>2]|0;l=d+4|0;f[l>>2]=0;f[l+4>>2]=0;l=d+11|0;b[l>>0]=3;b[d>>0]=b[498516]|0;b[d+1>>0]=b[498517]|0;b[d+2>>0]=b[498518]|0;b[d+3>>0]=0;m=uYb(j,d)|0;if((b[l>>0]|0)<0)YDc(f[d>>2]|0);l=f[i>>2]|0;mi[f[(f[l>>2]|0)+96>>2]&2047](d,l);l=f[d>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[498520]|0;b[d+1>>0]=b[498521]|0;b[d+2>>0]=b[498522]|0;b[d+3>>0]=b[498523]|0;b[d+4>>0]=b[498524]|0;b[d+5>>0]=0;n=uYb(l,d)|0;if((b[j>>0]|0)<0)YDc(f[d>>2]|0);j=a+8|0;l=f[j>>2]|0;if(!l){o=f[a+4>>2]|0;if(!o){p=VDc(16)|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;q=p}else{if(f[o+64>>2]|0)OQb(o,14656,16);p=NQb(o,16,1744)|0;f[p>>2]=o;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;q=p}f[j>>2]=q;r=q}else r=l;l=r+4|0;q=f[l>>2]|0;if((q|0)>0){p=f[r+12>>2]|0;r=0;do{o=f[p+4+(r<<2)>>2]|0;r=r+1|0;Yi[f[(f[o>>2]|0)+28>>2]&2047](o)}while((r|0)!=(q|0));f[l>>2]=0}l=f[a+28>>2]|0;a=f[l+12>>2]|0;q=f[l+4>>2]|0;a:do if(q>>>0>a>>>0){r=f[l+16>>2]|0;p=a;while(1){s=f[r+(p<<2)>>2]|0;if(s|0)break;o=p+1|0;if(o>>>0<q>>>0)p=o;else{t=0;v=o;break a}}if((s|0)==(f[r+((p^1)<<2)>>2]|0)){t=f[(f[s>>2]|0)+16>>2]|0;v=p;break}else{t=s;v=p;break}}else{t=0;v=a}while(0);f[e>>2]=t;f[e+4>>2]=l;f[e+8>>2]=v;if(!t){u=c;return}t=m+24|0;v=m+28|0;l=n+24|0;a=n+28|0;s=d+4|0;q=d+8|0;o=d+12|0;w=d+4|0;x=d+8|0;y=d+12|0;do{z=f[i>>2]|0;A=_i[f[(f[z>>2]|0)+12>>2]&1023](z)|0;z=f[j>>2]|0;B=Bhc(A)|0;C=f[z>>2]|0;if(((C|0)==(B|0)?(B=z+12|0,D=f[B>>2]|0,(D|0)!=0):0)?(E=f[D>>2]|0,(E|0)<(f[z+8>>2]|0)):0){F=z+4|0;G=f[F>>2]|0;if((G|0)<(E|0)){H=D+4+(G<<2)|0;f[D+4+(E<<2)>>2]=f[H>>2];I=H}else I=D+4+(G<<2)|0;f[I>>2]=A;f[F>>2]=G+1;G=f[B>>2]|0;f[G>>2]=(f[G>>2]|0)+1}else Edc(z,A,Ahc(A)|0,C);C=f[(f[e>>2]|0)+16>>2]|0;z=f[t>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[d>>2]=78728;f[w>>2]=1737;b[x>>0]=0;f[y>>2]=m;DTb(z,d)}switch(f[161216+(f[v>>2]<<2)>>2]|0){case 9:{z=f[(f[k>>2]|0)+144>>2]|0;G=PNa(C)|0;ei[z&511](k,A,m,G);break}case 2:{G=f[(f[k>>2]|0)+120>>2]|0;z=ddc(C)|0;gi[G&255](k,A,m,z,J);break}case 1:{z=f[(f[k>>2]|0)+116>>2]|0;G=edc(C)|0;ei[z&511](k,A,m,G);break}case 4:{G=f[(f[k>>2]|0)+128>>2]|0;z=fdc(C)|0;gi[G&255](k,A,m,z,J);break}case 3:{z=f[(f[k>>2]|0)+124>>2]|0;G=gdc(C)|0;ei[z&511](k,A,m,G);break}case 7:{G=f[(f[k>>2]|0)+140>>2]|0;z=hdc(C)|0;ei[G&511](k,A,m,z);break}case 10:case 8:case 6:case 5:{rTb(g,3,498526,284);oTb(h,mTb(g,504236)|0);sTb(g);break}default:{}}z=(f[(f[e>>2]|0)+16>>2]|0)+16|0;G=f[l>>2]|0;if(G|0?(f[G>>2]|0)!=2:0){f[d>>2]=78728;f[s>>2]=1737;b[q>>0]=0;f[o>>2]=n;DTb(G,d)}do switch(f[161216+(f[a>>2]<<2)>>2]|0){case 9:{G=f[(f[k>>2]|0)+144>>2]|0;C=Fdc(z)|0;ei[G&511](k,A,n,C);break}case 2:{C=f[(f[k>>2]|0)+120>>2]|0;G=Gdc(z)|0;gi[C&255](k,A,n,G,J);break}case 1:{G=f[(f[k>>2]|0)+116>>2]|0;C=Hdc(z)|0;ei[G&511](k,A,n,C);break}case 4:{C=f[(f[k>>2]|0)+128>>2]|0;G=Idc(z)|0;gi[C&255](k,A,n,G,J);break}case 3:{G=f[(f[k>>2]|0)+124>>2]|0;C=Jdc(z)|0;ei[G&511](k,A,n,C);break}case 7:{C=f[(f[k>>2]|0)+140>>2]|0;G=Kdc(z)|0;ei[C&511](k,A,n,G);break}case 5:{G=f[(f[k>>2]|0)+136>>2]|0;K=+Ldc(z);$h[G&63](k,A,n,K);break}case 6:{G=f[(f[k>>2]|0)+132>>2]|0;K=+Mdc(z);$h[G&63](k,A,n,K);break}case 8:{G=f[(f[k>>2]|0)+152>>2]|0;C=Ndc(z)|0;ei[G&511](k,A,n,C);break}case 10:{C=Odc(z)|0;G=hh[f[(f[k>>2]|0)+156>>2]&127](k,A,n,0)|0;mi[f[(f[G>>2]|0)+72>>2]&2047](G,C);break}default:{}}while(0);_cc(e)|0}while((f[e>>2]|0)!=0);u=c;return}function Rcc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0;c=u;u=u+64|0;d=c+40|0;e=c;g=c+16|0;h=c+56|0;i=a+20|0;j=a+32|0;k=f[j>>2]|0;l=_i[f[(f[k>>2]|0)+92>>2]&1023](k)|0;k=f[j>>2]|0;mi[f[(f[k>>2]|0)+96>>2]&2047](d,k);k=f[d>>2]|0;m=d+4|0;f[m>>2]=0;f[m+4>>2]=0;m=d+11|0;b[m>>0]=3;b[d>>0]=b[498516]|0;b[d+1>>0]=b[498517]|0;b[d+2>>0]=b[498518]|0;b[d+3>>0]=0;o=uYb(k,d)|0;if((b[m>>0]|0)<0)YDc(f[d>>2]|0);m=f[j>>2]|0;mi[f[(f[m>>2]|0)+96>>2]&2047](d,m);m=f[d>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[498520]|0;b[d+1>>0]=b[498521]|0;b[d+2>>0]=b[498522]|0;b[d+3>>0]=b[498523]|0;b[d+4>>0]=b[498524]|0;b[d+5>>0]=0;k=uYb(m,d)|0;if((b[j>>0]|0)<0)YDc(f[d>>2]|0);j=a+28|0;m=f[j>>2]|0;q=f[m+12>>2]|0;r=f[m+4>>2]|0;a:do if(r>>>0>q>>>0){s=f[m+16>>2]|0;t=q;while(1){v=f[s+(t<<2)>>2]|0;if(v|0)break;w=t+1|0;if(w>>>0<r>>>0)t=w;else{x=0;y=w;break a}}if((v|0)==(f[s+((t^1)<<2)>>2]|0)){x=f[(f[v>>2]|0)+16>>2]|0;y=t;break}else{x=v;y=t;break}}else{x=0;y=q}while(0);f[d>>2]=x;f[d+4>>2]=m;f[d+8>>2]=y;if(x|0){y=x;do{jdc((f[y+16>>2]|0)+16|0);kdc(d)|0;y=f[d>>2]|0}while((y|0)!=0)}idc(i);y=a+8|0;a=f[y>>2]|0;x=f[a+12>>2]|0;if(!(f[a+4>>2]|0)){u=c;return}a=e+8|0;m=o+24|0;q=o+28|0;v=k+24|0;r=k+28|0;w=d+11|0;z=d+4|0;A=d+8|0;B=d+12|0;C=d+4|0;D=d+8|0;E=d+12|0;F=d+11|0;G=d+4|0;H=d+8|0;I=d+12|0;K=(x|0)==0?0:x+4|0;do{f[a>>2]=0;x=f[m>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[d>>2]=78728;f[G>>2]=1737;b[H>>0]=0;f[I>>2]=o;DTb(x,d)}switch(f[161216+(f[q>>2]<<2)>>2]|0){case 9:{ei[f[(f[l>>2]|0)+96>>2]&511](d,l,f[K>>2]|0,o);if((f[a>>2]|0)==9)L=f[e>>2]|0;else{f[a>>2]=9;x=VDc(12)|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[e>>2]=x;L=x}iEc(L,d)|0;if((b[F>>0]|0)<0)YDc(f[d>>2]|0);break}case 2:{x=hj[f[(f[l>>2]|0)+72>>2]&511](l,f[K>>2]|0,o)|0;M=J;switch(f[a>>2]|0){case 2:break;case 9:{N=f[e>>2]|0;if(!N)O=33;else{if((b[N+11>>0]|0)<0)YDc(f[N>>2]|0);YDc(N);O=33}break}default:O=33}if((O|0)==33){O=0;f[a>>2]=2}N=e;f[N>>2]=x;f[N+4>>2]=M;break}case 1:{M=hj[f[(f[l>>2]|0)+68>>2]&511](l,f[K>>2]|0,o)|0;switch(f[a>>2]|0){case 1:break;case 9:{N=f[e>>2]|0;if(!N)O=40;else{if((b[N+11>>0]|0)<0)YDc(f[N>>2]|0);YDc(N);O=40}break}default:O=40}if((O|0)==40){O=0;f[a>>2]=1}f[e>>2]=M;break}case 4:{M=hj[f[(f[l>>2]|0)+80>>2]&511](l,f[K>>2]|0,o)|0;N=J;switch(f[a>>2]|0){case 4:break;case 9:{x=f[e>>2]|0;if(!x)O=47;else{if((b[x+11>>0]|0)<0)YDc(f[x>>2]|0);YDc(x);O=47}break}default:O=47}if((O|0)==47){O=0;f[a>>2]=4}x=e;f[x>>2]=M;f[x+4>>2]=N;break}case 3:{N=hj[f[(f[l>>2]|0)+76>>2]&511](l,f[K>>2]|0,o)|0;switch(f[a>>2]|0){case 3:break;case 9:{x=f[e>>2]|0;if(!x)O=54;else{if((b[x+11>>0]|0)<0)YDc(f[x>>2]|0);YDc(x);O=54}break}default:O=54}if((O|0)==54){O=0;f[a>>2]=3}f[e>>2]=N;break}case 7:{N=(hj[f[(f[l>>2]|0)+92>>2]&511](l,f[K>>2]|0,o)|0)&1;switch(f[a>>2]|0){case 7:break;case 9:{x=f[e>>2]|0;if(!x)O=61;else{if((b[x+11>>0]|0)<0)YDc(f[x>>2]|0);YDc(x);O=61}break}default:O=61}if((O|0)==61){O=0;f[a>>2]=7}b[e>>0]=N;break}case 10:case 8:case 6:case 5:{rTb(g,3,498526,366);oTb(h,mTb(g,504236)|0);sTb(g);break}default:{}}$cc(d,f[j>>2]|0,e,0);N=f[d>>2]|0;if(N|0)jdc((f[N+16>>2]|0)+16|0);N=ldc(f[j>>2]|0,e)|0;x=f[N>>2]|0;if(!x){M=mdc(i,e)|0;f[N>>2]=M;P=M}else P=x;x=f[v>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[d>>2]=78728;f[C>>2]=1737;b[D>>0]=0;f[E>>2]=k;DTb(x,d)}f[P+20>>2]=f[161216+(f[r>>2]<<2)>>2];x=f[v>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[d>>2]=78728;f[z>>2]=1737;b[A>>0]=0;f[B>>2]=k;DTb(x,d)}do switch(f[161216+(f[r>>2]<<2)>>2]|0){case 1:{x=VDc(4)|0;M=hj[f[(f[l>>2]|0)+68>>2]&511](l,f[K>>2]|0,k)|0;f[x>>2]=M;Q=x;O=87;break}case 2:{x=VDc(8)|0;M=hj[f[(f[l>>2]|0)+72>>2]&511](l,f[K>>2]|0,k)|0;N=x;f[N>>2]=M;f[N+4>>2]=J;Q=x;O=87;break}case 3:{x=VDc(4)|0;N=hj[f[(f[l>>2]|0)+76>>2]&511](l,f[K>>2]|0,k)|0;f[x>>2]=N;Q=x;O=87;break}case 4:{x=VDc(8)|0;N=hj[f[(f[l>>2]|0)+80>>2]&511](l,f[K>>2]|0,k)|0;M=x;f[M>>2]=N;f[M+4>>2]=J;Q=x;O=87;break}case 5:{x=VDc(8)|0;R=+Sh[f[(f[l>>2]|0)+88>>2]&31](l,f[K>>2]|0,k);p[x>>3]=R;Q=x;O=87;break}case 6:{x=VDc(4)|0;R=+Sh[f[(f[l>>2]|0)+84>>2]&31](l,f[K>>2]|0,k);n[x>>2]=R;Q=x;O=87;break}case 7:{x=VDc(1)|0;M=(hj[f[(f[l>>2]|0)+92>>2]&511](l,f[K>>2]|0,k)|0)&1;b[x>>0]=M;Q=x;O=87;break}case 9:{x=VDc(12)|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;ei[f[(f[l>>2]|0)+96>>2]&511](d,l,f[K>>2]|0,k);iEc(x,d)|0;if((b[w>>0]|0)<0)YDc(f[d>>2]|0);Q=x;O=87;break}case 8:{x=VDc(4)|0;M=hj[f[(f[l>>2]|0)+104>>2]&511](l,f[K>>2]|0,k)|0;f[x>>2]=M;Q=x;O=87;break}case 10:{x=hh[f[(f[l>>2]|0)+108>>2]&127](l,f[K>>2]|0,k,0)|0;M=_i[f[(f[x>>2]|0)+12>>2]&1023](x)|0;mi[f[(f[M>>2]|0)+72>>2]&2047](M,x);Q=M;O=87;break}default:{}}while(0);if((O|0)==87){O=0;f[P+16>>2]=Q}if((f[a>>2]|0)==9?(t=f[e>>2]|0,t|0):0){if((b[t+11>>0]|0)<0)YDc(f[t>>2]|0);YDc(t)}K=K+4|0;t=f[y>>2]|0;s=f[t+12>>2]|0}while((K|0)!=(((s|0)==0?0:s+4|0)+(f[t+4>>2]<<2)|0));u=c;return}function Scc(a,b){a=a|0;b=b|0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[b>>2]=a;return}function Tcc(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(!a)return;YDc(a);return}function Ucc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=f[d>>2]|0;g=f[c>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];e=c+8|0;g=kNa(d+8|0)|0;h=c+16|0;i=f[h>>2]|0;if((i|0)!=(g|0)){if((i|0)==9?(i=f[e>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}f[h>>2]=g;if((g|0)==9){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[e>>2]=g}}f[c+28>>2]=f[d+28>>2];mi[f[(f[a>>2]|0)+72>>2]&2047](a,c);return}function Vcc(a,b){a=a|0;b=b|0;_cc(f[b>>2]|0)|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function Wcc(a){a=a|0;var b=0,c=0,d=0;b=a+16|0;if((f[b>>2]|0)!=1){c=a+20|0;return c|0}d=a+12|0;dTb(d);if((f[b>>2]|0)==1){Yi[f[(f[a>>2]|0)+44>>2]&2047](a);f[b>>2]=2}eTb(d);c=a+20|0;return c|0}function Xcc(a){a=a|0;var b=0,c=0,d=0;b=a+16|0;if((f[b>>2]|0)!=1){f[b>>2]=0;c=a+20|0;return c|0}d=a+12|0;dTb(d);if((f[b>>2]|0)==1){Yi[f[(f[a>>2]|0)+44>>2]&2047](a);f[b>>2]=2}eTb(d);f[b>>2]=0;c=a+20|0;return c|0}function Ycc(a,b){a=a|0;b=b|0;var c=0;a=f[f[b>>2]>>2]|0;if(!a)return;c=a+16|0;Zcc(b+8|0,f[c>>2]|0);a=f[c>>2]|0;f[b+28>>2]=f[a+20>>2];f[b+24>>2]=f[a+16>>2];return}function Zcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;g=d+24|0;h=kNa(c)|0;i=a+8|0;j=f[i>>2]|0;a:do if((j|0)==(h|0)){switch(h|0){case 10:case 8:case 6:case 5:{k=10;break a;break}case 9:{k=11;break a;break}case 2:{k=12;break a;break}case 1:{k=13;break a;break}case 4:{k=14;break a;break}case 3:{k=15;break a;break}case 7:{k=16;break a;break}default:{}}u=d;return}else{if((j|0)==9?(l=f[a>>2]|0,l|0):0){if((b[l+11>>0]|0)<0)YDc(f[l>>2]|0);YDc(l)}f[i>>2]=h;switch(h|0){case 10:case 8:case 6:case 5:{k=10;break a;break}case 2:{k=12;break a;break}case 1:{k=13;break a;break}case 4:{k=14;break a;break}case 3:{k=15;break a;break}case 7:{k=16;break a;break}case 9:{l=VDc(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[a>>2]=l;k=11;break a;break}default:{u=d;return}}}while(0);if((k|0)==10){rTb(e,3,498207,501);oTb(g,mTb(e,503922)|0);sTb(e);u=d;return}else if((k|0)==11){iEc(f[a>>2]|0,f[c>>2]|0)|0;u=d;return}else if((k|0)==12){e=c;g=f[e+4>>2]|0;h=a;f[h>>2]=f[e>>2];f[h+4>>2]=g;u=d;return}else if((k|0)==13){f[a>>2]=f[c>>2];u=d;return}else if((k|0)==14){g=c;h=f[g+4>>2]|0;e=a;f[e>>2]=f[g>>2];f[e+4>>2]=h;u=d;return}else if((k|0)==15){f[a>>2]=f[c>>2];u=d;return}else if((k|0)==16){b[a>>0]=b[c>>0]|0;u=d;return}}function _cc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=u;u=u+32|0;c=b+8|0;d=b;e=f[a>>2]|0;g=f[e+24>>2]|0;if(g|0){f[a>>2]=g;u=b;return a|0}g=a+4|0;h=f[g>>2]|0;i=a+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=f[h+16>>2]|0;l=f[k+(j<<2)>>2]|0;a:do if((l|0)!=(e|0)){b:do if(l|0?(l|0)!=(f[k+((j^1)<<2)>>2]|0):0){m=l;while(1){m=f[m+24>>2]|0;if(!m)break b;if((m|0)==(e|0)){n=j;o=h;p=9;break a}}}while(0);$cc(c,h,e,d);m=f[c+8>>2]|0;f[i>>2]=m;q=f[g>>2]|0;r=f[q+16>>2]|0;s=f[r+(m<<2)>>2]|0;if((s|0)!=0?(s|0)==(f[r+((m^1)<<2)>>2]|0):0){t=f[d>>2]|0;v=f[t+4>>2]|0;if(!v){w=t+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(t|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;t=f[x>>2]|0}while((f[t>>2]|0)!=(w|0));y=t}}else{x=v;while(1){t=f[x>>2]|0;if(!t)break;else x=t}y=x}f[d>>2]=y;if((y|0)!=(s+4|0)){f[a>>2]=f[y+16>>2];break}v=m+2|0;f[a>>2]=0;f[i>>2]=v;t=f[q+4>>2]|0;if(t>>>0>v>>>0){w=v;while(1){z=f[r+(w<<2)>>2]|0;if(z|0)break;v=w+1|0;f[i>>2]=v;if(v>>>0<t>>>0)w=v;else break a}if((z|0)==(f[r+((w^1)<<2)>>2]|0))A=f[(f[z>>2]|0)+16>>2]|0;else A=z;f[a>>2]=A}}else{n=m;o=q;p=9}}else{n=j;o=h;p=9}while(0);c:do if((p|0)==9?(h=n+1|0,f[a>>2]=0,f[i>>2]=h,j=f[o+4>>2]|0,j>>>0>h>>>0):0){A=f[o+16>>2]|0;z=h;while(1){B=f[A+(z<<2)>>2]|0;if(B|0)break;h=z+1|0;f[i>>2]=h;if(h>>>0<j>>>0)z=h;else break c}if((B|0)==(f[A+((z^1)<<2)>>2]|0))C=f[(f[B>>2]|0)+16>>2]|0;else C=B;f[a>>2]=C}while(0);u=b;return a|0}function $cc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=adc(b,c)|0;g=(f[b+4>>2]|0)+-1&(f[b+8>>2]|0)+e;e=f[b+16>>2]|0;h=f[e+(g<<2)>>2]|0;a:do if(h){if((h|0)!=(f[e+((g^1)<<2)>>2]|0)){i=h;while(1){if(bdc(i,c)|0)break;j=f[i+24>>2]|0;if(!j){k=g;l=18;break a}else i=j}f[a>>2]=i;m=g;n=g;o=b;break}if((h|0)==(f[e+((g^1)<<2)>>2]|0)){j=g&-2;p=(f[e+(j<<2)>>2]|0)+4|0;q=f[p>>2]|0;if(q){r=p;s=q;b:while(1){q=s;while(1){if(!(cdc(f[q+16>>2]|0,c)|0))break;t=f[q+4>>2]|0;if(!t){u=r;break b}else q=t}s=f[q>>2]|0;if(!s){u=q;break}else r=q}if((u|0)!=(p|0)?(r=u+16|0,!(cdc(c,f[r>>2]|0)|0)):0){if(d|0)f[d>>2]=u;f[a>>2]=f[r>>2];m=j;n=j;o=b}else{k=j;l=18}}else{k=j;l=18}}else{k=g;l=18}}else{k=g;l=18}while(0);if((l|0)==18){f[a>>2]=0;m=k;n=0;o=0}f[a+4>>2]=o;f[a+8>>2]=n;f[a+12>>2]=m;return}function adc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;a=u;u=u+64|0;d=a+24|0;e=a;g=a+48|0;switch(kNa(c)|0){case 10:case 8:case 6:case 5:{rTb(d,3,498207,812);oTb(a+49|0,mTb(d,503922)|0);sTb(d);break}case 9:{d=PNa(c)|0;h=(b[d+11>>0]|0)<0?f[d>>2]|0:d;d=b[h>>0]|0;if(!(d<<24>>24)){i=0;u=a;return i|0}else{j=h;k=0;l=d}while(1){d=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=d;break}else k=d}u=a;return i|0}case 2:{k=ddc(c)|0;l=Y(k,1540483477)|0;k=Y(J,1540483477)|0;j=(Y((Y(l>>>24^l,1540483477)|0)^-561034072,1540483477)|0)^(Y(k>>>24^k,1540483477)|0);k=Y(j>>>13^j,1540483477)|0;i=k>>>15^k;u=a;return i|0}case 1:{i=edc(c)|0;u=a;return i|0}case 4:{k=fdc(c)|0;j=Y(k,1540483477)|0;k=Y(J,1540483477)|0;l=(Y((Y(j>>>24^j,1540483477)|0)^-561034072,1540483477)|0)^(Y(k>>>24^k,1540483477)|0);k=Y(l>>>13^l,1540483477)|0;i=k>>>15^k;u=a;return i|0}case 3:{i=gdc(c)|0;u=a;return i|0}case 7:{i=(hdc(c)|0)&1;u=a;return i|0}default:{}}rTb(e,3,498207,827);oTb(g,mTb(e,504236)|0);sTb(e);i=0;u=a;return i|0}function bdc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d;i=d+72|0;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){rTb(e,3,498207,468);oTb(d+74|0,mTb(e,498294)|0);sTb(e)}switch(kNa(a)|0){case 10:case 8:case 6:case 5:{rTb(g,3,498207,475);oTb(d+73|0,mTb(g,503922)|0);sTb(g);break}case 9:{g=f[a>>2]|0;e=f[c>>2]|0;j=b[g+11>>0]|0;k=j<<24>>24<0;l=j&255;j=k?f[g+4>>2]|0:l;m=b[e+11>>0]|0;n=m<<24>>24<0;if((j|0)!=((n?f[e+4>>2]|0:m&255)|0)){o=0;u=d;return o|0}m=f[g>>2]|0;p=k?m:g;q=n?f[e>>2]|0:e;e=(j|0)==0;if(k){if(e){o=1;u=d;return o|0}o=(Arc(p,q,j)|0)==0;u=d;return o|0}if(e){o=1;u=d;return o|0}if((m&255)<<24>>24==(b[q>>0]|0)){r=g;s=l;t=q}else{o=0;u=d;return o|0}while(1){s=s+-1|0;r=r+1|0;if(!s){o=1;v=19;break}t=t+1|0;if((b[r>>0]|0)!=(b[t>>0]|0)){o=0;v=19;break}}if((v|0)==19){u=d;return o|0}break}case 2:{v=a;t=c;o=(f[v>>2]|0)==(f[t>>2]|0)?(f[v+4>>2]|0)==(f[t+4>>2]|0):0;u=d;return o|0}case 1:{o=(f[a>>2]|0)==(f[c>>2]|0);u=d;return o|0}case 4:{t=a;v=c;o=(f[t>>2]|0)==(f[v>>2]|0)?(f[t+4>>2]|0)==(f[v+4>>2]|0):0;u=d;return o|0}case 3:{o=(f[a>>2]|0)==(f[c>>2]|0);u=d;return o|0}case 7:{o=(b[a>>0]|0)==(b[c>>0]|0);u=d;return o|0}default:{}}rTb(h,3,498207,490);oTb(i,mTb(h,504236)|0);sTb(h);o=0;u=d;return o|0}function cdc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d+24|0;g=d;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){rTb(e,3,498207,440);oTb(d+49|0,mTb(e,498294)|0);sTb(e)}switch(kNa(a)|0){case 10:case 8:case 6:case 5:{rTb(g,3,498207,447);oTb(d+48|0,mTb(g,503922)|0);sTb(g);i=0;u=d;return i|0}case 9:{g=f[a>>2]|0;e=f[c>>2]|0;j=b[e+11>>0]|0;k=j<<24>>24<0;l=k?f[e+4>>2]|0:j&255;j=b[g+11>>0]|0;m=j<<24>>24<0;n=m?f[g+4>>2]|0:j&255;j=l>>>0<n>>>0;o=j?l:n;if((o|0)!=0?(p=Arc(m?f[g>>2]|0:g,k?f[e>>2]|0:e,o)|0,(p|0)!=0):0)q=p;else q=n>>>0<l>>>0?-1:j&1;i=(q|0)<0;u=d;return i|0}case 2:{q=a;j=f[q+4>>2]|0;l=c;n=f[l+4>>2]|0;i=(j|0)<(n|0)|((j|0)==(n|0)?(f[q>>2]|0)>>>0<(f[l>>2]|0)>>>0:0);u=d;return i|0}case 1:{i=(f[a>>2]|0)<(f[c>>2]|0);u=d;return i|0}case 4:{l=a;q=f[l+4>>2]|0;n=c;j=f[n+4>>2]|0;i=q>>>0<j>>>0|((q|0)==(j|0)?(f[l>>2]|0)>>>0<(f[n>>2]|0)>>>0:0);u=d;return i|0}case 3:{i=(f[a>>2]|0)>>>0<(f[c>>2]|0)>>>0;u=d;return i|0}case 7:{i=(h[a>>0]|0)<(h[c>>0]|0);u=d;return i|0}default:{i=0;u=d;return i|0}}return 0}function ddc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+32|0;c=b;if((kNa(a)|0)==2){d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}rTb(c,3,498207,407);k=mTb(mTb(mTb(mTb(c,498321)|0,498494)|0,498376)|0,498398)|0;l=mTb(mTb(mTb(k,f[40344]|0)|0,502002)|0,498412)|0;k=161368+((kNa(a)|0)<<2)|0;oTb(b+24|0,mTb(l,f[k>>2]|0)|0);sTb(c);d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}function edc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((kNa(a)|0)==1){d=f[a>>2]|0;u=b;return d|0}rTb(c,3,498207,417);e=mTb(mTb(mTb(mTb(c,498321)|0,498472)|0,498376)|0,498398)|0;g=mTb(mTb(mTb(e,f[40343]|0)|0,502002)|0,498412)|0;e=161368+((kNa(a)|0)<<2)|0;oTb(b+24|0,mTb(g,f[e>>2]|0)|0);sTb(c);d=f[a>>2]|0;u=b;return d|0}function fdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+32|0;c=b;if((kNa(a)|0)==4){d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}rTb(c,3,498207,412);k=mTb(mTb(mTb(mTb(c,498321)|0,498449)|0,498376)|0,498398)|0;l=mTb(mTb(mTb(k,f[40346]|0)|0,502002)|0,498412)|0;k=161368+((kNa(a)|0)<<2)|0;oTb(b+24|0,mTb(l,f[k>>2]|0)|0);sTb(c);d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}function gdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((kNa(a)|0)==3){d=f[a>>2]|0;u=b;return d|0}rTb(c,3,498207,422);e=mTb(mTb(mTb(mTb(c,498321)|0,498426)|0,498376)|0,498398)|0;g=mTb(mTb(mTb(e,f[40345]|0)|0,502002)|0,498412)|0;e=161368+((kNa(a)|0)<<2)|0;oTb(b+24|0,mTb(g,f[e>>2]|0)|0);sTb(c);d=f[a>>2]|0;u=b;return d|0}function hdc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;if((kNa(a)|0)==7){e=b[a>>0]|0;g=e<<24>>24!=0;u=c;return g|0}rTb(d,3,498207,427);h=mTb(mTb(mTb(mTb(d,498321)|0,498355)|0,498376)|0,498398)|0;i=mTb(mTb(mTb(h,f[40349]|0)|0,502002)|0,498412)|0;h=161368+((kNa(a)|0)<<2)|0;oTb(c+24|0,mTb(i,f[h>>2]|0)|0);sTb(d);e=b[a>>0]|0;g=e<<24>>24!=0;u=c;return g|0}function idc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+48|0;d=c+28|0;e=c+16|0;g=c;h=a+8|0;i=f[h>>2]|0;j=f[i+12>>2]|0;k=f[i+4>>2]|0;if(k>>>0<=j>>>0){u=c;return}l=f[i+16>>2]|0;m=j;while(1){n=f[l+(m<<2)>>2]|0;if(n|0)break;j=m+1|0;if(j>>>0<k>>>0)m=j;else{o=19;break}}if((o|0)==19){u=c;return}if((n|0)==(f[l+((m^1)<<2)>>2]|0))p=f[(f[n>>2]|0)+16>>2]|0;else p=n;if(!p){u=c;return}n=g+4|0;l=g+8|0;o=p;p=i;i=m;while(1){f[g>>2]=o;f[n>>2]=p;f[l>>2]=i;if((f[a>>2]|0)==0?(m=f[o+16>>2]|0,m|0):0){if((f[m+8>>2]|0)==9?(k=f[m>>2]|0,k|0):0){if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);YDc(k)}YDc(m)};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];kdc(g)|0;m=f[h>>2]|0;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];Bdc(m,d);o=f[g>>2]|0;if(!o)break;else{p=f[n>>2]|0;i=f[l>>2]|0}}u=c;return}function jdc(a){a=a|0;var c=0;do switch(f[a+4>>2]|0){case 1:{c=f[a>>2]|0;if(!c)return;YDc(c);return}case 2:{c=f[a>>2]|0;if(!c)return;YDc(c);return}case 3:{c=f[a>>2]|0;if(!c)return;YDc(c);return}case 4:{c=f[a>>2]|0;if(!c)return;YDc(c);return}case 5:{c=f[a>>2]|0;if(!c)return;YDc(c);return}case 6:{c=f[a>>2]|0;if(!c)return;YDc(c);return}case 7:{c=f[a>>2]|0;if(!c)return;YDc(c);return}case 9:{c=f[a>>2]|0;if(!c)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}case 8:{c=f[a>>2]|0;if(!c)return;YDc(c);return}case 10:{c=f[a>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}default:return}while(0)}function kdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=u;u=u+32|0;c=b+8|0;d=b;e=f[a>>2]|0;g=f[e+24>>2]|0;if(g|0){f[a>>2]=g;u=b;return a|0}g=a+4|0;h=f[g>>2]|0;i=a+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=f[h+16>>2]|0;l=f[k+(j<<2)>>2]|0;a:do if((l|0)!=(e|0)){b:do if(l|0?(l|0)!=(f[k+((j^1)<<2)>>2]|0):0){m=l;while(1){m=f[m+24>>2]|0;if(!m)break b;if((m|0)==(e|0)){n=j;o=h;p=9;break a}}}while(0);$cc(c,h,e,d);m=f[c+8>>2]|0;f[i>>2]=m;q=f[g>>2]|0;r=f[q+16>>2]|0;s=f[r+(m<<2)>>2]|0;if((s|0)!=0?(s|0)==(f[r+((m^1)<<2)>>2]|0):0){t=f[d>>2]|0;v=f[t+4>>2]|0;if(!v){w=t+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(t|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;t=f[x>>2]|0}while((f[t>>2]|0)!=(w|0));y=t}}else{x=v;while(1){t=f[x>>2]|0;if(!t)break;else x=t}y=x}f[d>>2]=y;if((y|0)!=(s+4|0)){f[a>>2]=f[y+16>>2];break}v=m+2|0;f[a>>2]=0;f[i>>2]=v;t=f[q+4>>2]|0;if(t>>>0>v>>>0){w=v;while(1){z=f[r+(w<<2)>>2]|0;if(z|0)break;v=w+1|0;f[i>>2]=v;if(v>>>0<t>>>0)w=v;else break a}if((z|0)==(f[r+((w^1)<<2)>>2]|0))A=f[(f[z>>2]|0)+16>>2]|0;else A=z;f[a>>2]=A}}else{n=m;o=q;p=9}}else{n=j;o=h;p=9}while(0);c:do if((p|0)==9?(h=n+1|0,f[a>>2]=0,f[i>>2]=h,j=f[o+4>>2]|0,j>>>0>h>>>0):0){A=f[o+16>>2]|0;z=h;while(1){B=f[A+(z<<2)>>2]|0;if(B|0)break;h=z+1|0;f[i>>2]=h;if(h>>>0<j>>>0)z=h;else break c}if((B|0)==(f[A+((z^1)<<2)>>2]|0))C=f[(f[B>>2]|0)+16>>2]|0;else C=B;f[a>>2]=C}while(0);u=b;return a|0}function ldc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d;g=d+24|0;h=e+8|0;f[h>>2]=0;Zcc(e,c);f[e+16>>2]=0;rdc(g,a,e);a=(f[g>>2]|0)+16|0;if((f[h>>2]|0)!=9){u=d;return a|0}h=f[e>>2]|0;if(!h){u=d;return a|0}if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h);u=d;return a|0}function mdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;if(!c){d=VDc(24)|0;f[d+8>>2]=0;Zcc(d,b);f[d+16>>2]=0;f[d+20>>2]=0;e=d;return e|0}if(f[c+64>>2]|0)OQb(c,23824,24);d=MQb(c,24)|0;c=f[a>>2]|0;f[d+8>>2]=0;ndc(c,d);c=d+16|0;g=f[a>>2]|0;f[c>>2]=0;f[d+20>>2]=0;odc(g,c);Zcc(d,b);e=d;return e|0}function ndc(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1780);return}function odc(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1781);return}function pdc(a){a=a|0;return}function qdc(a){a=a|0;var c=0;if((f[a+8>>2]|0)!=9)return;c=f[a>>2]|0;if(!c)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function rdc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;$cc(g,c,d,0);i=f[g>>2]|0;if(i|0){j=f[g+4>>2]|0;k=f[g+8>>2]|0;f[a>>2]=i;f[a+4>>2]=j;f[a+8>>2]=k;b[a+12>>0]=0;u=e;return}k=(f[c>>2]|0)+1|0;j=f[c+4>>2]|0;i=j*12|0;l=i>>>4;if(l>>>0>k>>>0){if(j>>>0>8&i>>>6>>>0>=k>>>0){i=((k*5|0)>>>2)+1|0;k=1;while(1)if(i<<k>>>0<l>>>0)k=k+1|0;else break;l=j>>>k;k=l>>>0>8?l:8;if((k|0)!=(j|0)){sdc(c,k);m=11}}}else if(j>>>0<=134217728){sdc(c,j<<1);m=11}if((m|0)==11){$cc(h,c,d,0);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2]}m=f[g+12>>2]|0;g=f[c+20>>2]|0;if(!g)n=VDc(32)|0;else{if(f[g+64>>2]|0)OQb(g,23824,32);n=MQb(g,32)|0}f[n+8>>2]=0;Zcc(n,d);f[n+16>>2]=f[d+16>>2];tdc(h,c,m,n);f[c>>2]=(f[c>>2]|0)+1;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];b[a+12>>0]=1;u=e;return}function sdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+16|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;f[h>>2]=b;j=a+20|0;k=f[j>>2]|0;l=b<<2;if(!k)m=VDc(l)|0;else{b=l+7&-8;if(f[k+64>>2]|0)OQb(k,23824,b);m=MQb(k,b)|0}XIc(m|0,0,l|0)|0;f[e>>2]=m;m=a+12|0;e=f[m>>2]|0;f[m>>2]=f[h>>2];if(e>>>0<i>>>0){m=a+8|0;l=e;do{e=f[g+(l<<2)>>2]|0;do if(!e)n=l;else{if((e|0)==(f[g+((l^1)<<2)>>2]|0)){Adc(a,g,l);n=l+1|0;break}b=e;do{k=b;b=f[b+24>>2]|0;o=adc(a,k)|0;tdc(d,a,(f[h>>2]|0)+-1&(f[m>>2]|0)+o,k)}while((b|0)!=0);n=l}while(0);l=n+1|0}while(l>>>0<i>>>0)}if(f[j>>2]|0){u=c;return}YDc(g);u=c;return}function tdc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;h=f[b+16>>2]|0;i=h+(c<<2)|0;j=f[i>>2]|0;k=j;do if(!j){f[d+24>>2]=k;f[i>>2]=d;l=d;m=b;n=c}else{if((j|0)==(f[h+((c^1)<<2)>>2]|0)){vdc(a,b,c,d);u=e;return}o=j;p=0;do{p=p+1|0;o=f[o+24>>2]|0}while((o|0)!=0);if(p>>>0>7){udc(b,c);vdc(g,b,c,d);l=f[g>>2]|0;m=f[g+4>>2]|0;n=f[g+8>>2]|0;break}f[d+24>>2]=k;f[i>>2]=d;f[a>>2]=d;f[a+4>>2]=b;f[a+8>>2]=c;u=e;return}while(0);c=b+12|0;b=f[c>>2]|0;f[c>>2]=n>>>0<b>>>0?n:b;f[a>>2]=l;f[a+4>>2]=m;f[a+8>>2]=n;u=e;return}function udc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c+16|0;e=c;g=a+20|0;h=f[g>>2]|0;f[d>>2]=h;i=h;if(!h)j=VDc(16)|0;else{if(f[i+64>>2]|0)OQb(i,23824,16);j=MQb(i,16)|0}i=f[g>>2]|0;f[e+4>>2]=0;f[e+8>>2]=i;f[e+12>>2]=0;i=e+4|0;f[e>>2]=i;wdc(d,j,e);xdc(e,f[i>>2]|0);ydc(a,b,j)|0;i=b^1;ydc(a,i,j)|0;e=a+16|0;f[(f[e>>2]|0)+(i<<2)>>2]=j;f[(f[e>>2]|0)+(b<<2)>>2]=j;u=c;return}function vdc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f[d+24>>2]=0;e=f[(f[b+16>>2]|0)+(c<<2)>>2]|0;g=d;h=e+4|0;i=f[h>>2]|0;do if(i){j=e+4|0;k=i;while(1){l=k+16|0;if(cdc(d,f[l>>2]|0)|0){m=f[k>>2]|0;if(!m){n=6;break}else{o=k;p=m}}else{if(!(cdc(f[l>>2]|0,d)|0)){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==6){r=k;s=k;break}else if((n|0)==9){r=q;s=k;break}else if((n|0)==10){r=j;s=k;break}}else{r=h;s=h}while(0);h=f[r>>2]|0;if(h|0){t=h;u=c&-2;v=t+16|0;w=f[v>>2]|0;f[a>>2]=w;x=a+4|0;f[x>>2]=b;y=a+8|0;f[y>>2]=u;return}h=f[e+8>>2]|0;if(!h)z=VDc(20)|0;else{if(f[h+64>>2]|0)OQb(h,23824,24);z=MQb(h,24)|0}f[z+16>>2]=g;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=s;f[r>>2]=z;s=f[f[e>>2]>>2]|0;if(!s)A=z;else{f[e>>2]=s;A=f[r>>2]|0}laa(f[e+4>>2]|0,A);A=e+12|0;f[A>>2]=(f[A>>2]|0)+1;t=z;u=c&-2;v=t+16|0;w=f[v>>2]|0;f[a>>2]=w;x=a+4|0;f[x>>2]=b;y=a+8|0;f[y>>2]=u;return}function wdc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=u;u=u+16|0;d=a+12|0;e=a+8|0;g=a+4|0;h=a;f[b>>2]=0;i=f[c+8>>2]|0;j=b+4|0;f[j>>2]=0;f[b+8>>2]=i;i=b+12|0;f[i>>2]=0;k=b+4|0;f[b>>2]=k;l=f[c>>2]|0;m=c+4|0;if((l|0)==(m|0)){u=a;return}c=k;k=b+8|0;n=l;while(1){l=n+16|0;f[h>>2]=c;f[d>>2]=f[h>>2];o=zdc(b,d,e,g,l)|0;if(!(f[o>>2]|0)){p=f[k>>2]|0;if(!p)q=VDc(20)|0;else{if(f[p+64>>2]|0)OQb(p,23824,24);q=MQb(p,24)|0}f[q+16>>2]=f[l>>2];l=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=l;f[o>>2]=q;l=f[f[b>>2]>>2]|0;if(!l)r=q;else{f[b>>2]=l;r=f[o>>2]|0}laa(f[j>>2]|0,r);f[i>>2]=(f[i>>2]|0)+1}o=f[n+4>>2]|0;if(!o){l=n+8|0;p=f[l>>2]|0;if((f[p>>2]|0)==(n|0))s=p;else{p=l;do{l=f[p>>2]|0;p=l+8|0;t=f[p>>2]|0}while((f[t>>2]|0)!=(l|0));s=t}}else{p=o;while(1){t=f[p>>2]|0;if(!t)break;else p=t}s=p}if((s|0)==(m|0))break;else n=s}u=a;return}function xdc(a,b){a=a|0;b=b|0;if(!b)return;xdc(a,f[b>>2]|0);xdc(a,f[b+4>>2]|0);if(f[a+8>>2]|0)return;YDc(b);return}function ydc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=f[(f[a+16>>2]|0)+(b<<2)>>2]|0;if(!d){e=0;return e|0}b=c+4|0;a=c+8|0;g=c+4|0;h=c+12|0;i=d;d=0;while(1){j=i;k=f[b>>2]|0;do if(k){l=g;m=k;while(1){n=m+16|0;if(cdc(i,f[n>>2]|0)|0){o=f[m>>2]|0;if(!o){p=7;break}else{q=m;r=o}}else{if(!(cdc(f[n>>2]|0,i)|0)){p=11;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=10;break}else{q=s;r=n}}l=q;m=r}if((p|0)==7){p=0;t=m;u=m;break}else if((p|0)==10){p=0;t=s;u=m;break}else if((p|0)==11){p=0;t=l;u=m;break}}else{t=b;u=b}while(0);if(!(f[t>>2]|0)){k=f[a>>2]|0;if(!k)v=VDc(20)|0;else{if(f[k+64>>2]|0)OQb(k,23824,24);v=MQb(k,24)|0}f[v+16>>2]=j;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=u;f[t>>2]=v;k=f[f[c>>2]>>2]|0;if(!k)w=v;else{f[c>>2]=k;w=f[t>>2]|0}laa(f[g>>2]|0,w);f[h>>2]=(f[h>>2]|0)+1}k=d+1|0;n=i+24|0;i=f[n>>2]|0;f[n>>2]=0;if(!i){e=k;break}else d=k}return e|0}function zdc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=h+16|0,!(cdc(f[e>>2]|0,f[i>>2]|0)|0)):0){if(!(cdc(f[i>>2]|0,f[e>>2]|0)|0)){f[c>>2]=b;f[d>>2]=b;j=d;return j|0}d=f[h+4>>2]|0;if(!d){i=h+8|0;k=f[i>>2]|0;if((f[k>>2]|0)==(h|0))l=k;else{k=i;do{i=f[k>>2]|0;k=i+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(i|0));l=m}}else{k=d;while(1){d=f[k>>2]|0;if(!d)break;else k=d}l=k}if((l|0)!=(g|0)?!(cdc(f[e>>2]|0,f[l+16>>2]|0)|0):0){k=f[g>>2]|0;if(!k){f[c>>2]=g;j=g;return j|0}d=a+4|0;m=k;while(1){k=m+16|0;if(cdc(f[e>>2]|0,f[k>>2]|0)|0){i=f[m>>2]|0;if(!i){n=39;break}else{o=m;p=i}}else{if(!(cdc(f[k>>2]|0,f[e>>2]|0)|0)){n=43;break}q=m+4|0;k=f[q>>2]|0;if(!k){n=42;break}else{o=q;p=k}}d=o;m=p}if((n|0)==39){f[c>>2]=m;j=m;return j|0}else if((n|0)==42){f[c>>2]=m;j=q;return j|0}else if((n|0)==43){f[c>>2]=m;j=d;return j|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;j=h+4|0;return j|0}else{f[c>>2]=l;j=l;return j|0}}if((h|0)!=(f[a>>2]|0)){l=f[h>>2]|0;if(!l){d=h;while(1){m=f[d+8>>2]|0;if((f[m>>2]|0)==(d|0))d=m;else{r=m;break}}}else{d=l;while(1){l=f[d+4>>2]|0;if(!l){r=d;break}else d=l}}if(!(cdc(f[r+16>>2]|0,f[e>>2]|0)|0)){d=f[g>>2]|0;if(!d){f[c>>2]=g;j=g;return j|0}g=a+4|0;a=d;while(1){d=a+16|0;if(cdc(f[e>>2]|0,f[d>>2]|0)|0){l=f[a>>2]|0;if(!l){n=17;break}else{s=a;t=l}}else{if(!(cdc(f[d>>2]|0,f[e>>2]|0)|0)){n=21;break}u=a+4|0;d=f[u>>2]|0;if(!d){n=20;break}else{s=u;t=d}}g=s;a=t}if((n|0)==17){f[c>>2]=a;j=a;return j|0}else if((n|0)==20){f[c>>2]=a;j=u;return j|0}else if((n|0)==21){f[c>>2]=a;j=g;return j|0}}else v=r}else v=b;if(!(f[h>>2]|0)){f[c>>2]=h;j=h;return j|0}else{h=v;f[c>>2]=h;j=h+4|0;return j|0}return 0}function Adc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;g=f[b+(c<<2)>>2]|0;c=a+8|0;b=a+4|0;h=g+4|0;i=f[g>>2]|0;while(1){j=f[i+16>>2]|0;k=adc(a,j)|0;tdc(e,a,(f[b>>2]|0)+-1&(f[c>>2]|0)+k,j);j=f[i+4>>2]|0;if(!j){k=i+8|0;l=f[k>>2]|0;if((f[l>>2]|0)==(i|0))m=l;else{l=k;do{k=f[l>>2]|0;l=k+8|0;n=f[l>>2]|0}while((f[n>>2]|0)!=(k|0));m=n}}else{l=j;while(1){n=f[l>>2]|0;if(!n)break;else l=n}m=l}if((m|0)==(h|0))break;else i=m}m=f[a+20>>2]|0;xdc(g,f[h>>2]|0);if(m|0){u=d;return}YDc(g);u=d;return}function Bdc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+8|0;g=d;h=f[c+4>>2]|0;i=c+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=h+16|0;l=f[k>>2]|0;m=f[l+(j<<2)>>2]|0;n=f[c>>2]|0;a:do if((m|0)!=(n|0)){b:do if(m|0?(m|0)!=(f[l+((j^1)<<2)>>2]|0):0){c=m;while(1){c=f[c+24>>2]|0;if(!c)break b;if((c|0)==(n|0)){o=j;p=7;break a}}}while(0);$cc(e,h,n,g);c=f[e+8>>2]|0;f[i>>2]=c;q=f[k>>2]|0;r=f[q+(c<<2)>>2]|0;if(r){s=a+16|0;t=(f[s>>2]|0)+(c<<2)|0;if((r|0)==(f[q+((c^1)<<2)>>2]|0)){q=f[t>>2]|0;Ddc(q,(f[g>>2]|0)+16|0)|0;if(!(f[q+12>>2]|0)){r=c&-2;v=f[a+20>>2]|0;xdc(q,f[q+4>>2]|0);if(!v)YDc(q);f[(f[s>>2]|0)+((c|1)<<2)>>2]=0;f[(f[s>>2]|0)+(r<<2)>>2]=0;w=r;x=s}else{w=c;x=s}}else{y=t;z=s;A=c;p=9}}else{o=c;p=7}}else{o=j;p=7}while(0);if((p|0)==7){j=a+16|0;y=(f[j>>2]|0)+(o<<2)|0;z=j;A=o;p=9}if((p|0)==9){o=Cdc(a,n,f[y>>2]|0)|0;f[(f[z>>2]|0)+(A<<2)>>2]=o;w=A;x=z}if((f[n+8>>2]|0)==9?(z=f[n>>2]|0,z|0):0){if((b[z+11>>0]|0)<0)YDc(f[z>>2]|0);YDc(z)}if(!(f[a+20>>2]|0))YDc(n);f[a>>2]=(f[a>>2]|0)+-1;n=a+12|0;if((w|0)!=(f[n>>2]|0)){u=d;return}z=f[a+4>>2]|0;if(w>>>0>=z>>>0){u=d;return}a=f[x>>2]|0;x=w;while(1){if(f[a+(x<<2)>>2]|0){p=26;break}x=x+1|0;f[n>>2]=x;if(x>>>0>=z>>>0){p=26;break}}if((p|0)==26){u=d;return}}function Cdc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=c+24|0;e=f[d>>2]|0;if((c|0)==(b|0))return e|0;else{g=Cdc(a,b,e)|0;f[d>>2]=g;return c|0}return 0}function Ddc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if(!d){e=0;return e|0}else{g=c;h=d}a:while(1){d=h;while(1){if(!(cdc(f[d+16>>2]|0,f[b>>2]|0)|0))break;i=f[d+4>>2]|0;if(!i){j=g;break a}else d=i}h=f[d>>2]|0;if(!h){j=d;break}else g=d}if((j|0)==(c|0)){e=0;return e|0}if(cdc(f[b>>2]|0,f[j+16>>2]|0)|0){e=0;return e|0}b=f[j+4>>2]|0;if(!b){c=j+8|0;g=f[c>>2]|0;if((f[g>>2]|0)==(j|0))k=g;else{g=c;do{c=f[g>>2]|0;g=c+8|0;h=f[g>>2]|0}while((f[h>>2]|0)!=(c|0));k=h}}else{g=b;while(1){b=f[g>>2]|0;if(!b)break;else g=b}k=g}if((f[a>>2]|0)==(j|0))f[a>>2]=k;k=a+12|0;f[k>>2]=(f[k>>2]|0)+-1;uHa(f[a+4>>2]|0,j);if(f[a+8>>2]|0){e=1;return e|0}YDc(j);e=1;return e|0}function Edc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){e=zhc(b,d)|0;pbc(b,e);if((b|0)==0|(c|0)!=0)g=e;else{Yi[f[(f[b>>2]|0)+4>>2]&2047](b);g=e}}else g=b;else{Y8b(d,b);g=b}b=a+12|0;d=f[b>>2]|0;e=f[a+8>>2]|0;c=a+4|0;do if((d|0)!=0?(h=f[c>>2]|0,(h|0)!=(e|0)):0){i=f[d>>2]|0;if((i|0)==(e|0)){j=f[d+4+(h<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;break}Yi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0;break}if((h|0)<(i|0)){f[d+4+(i<<2)>>2]=f[d+4+(h<<2)>>2];h=f[b>>2]|0;l=h;m=f[h>>2]|0}else{l=d;m=i}f[l>>2]=m+1;k=l}else n=8;while(0);if((n|0)==8){USb(a,e+1|0);e=f[b>>2]|0;f[e>>2]=(f[e>>2]|0)+1;k=e}e=f[c>>2]|0;f[c>>2]=e+1;f[k+4+(e<<2)>>2]=g;return}function Fdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==9){d=f[a>>2]|0;u=b;return d|0}rTb(c,3,498207,639);e=mTb(mTb(mTb(mTb(c,498321)|0,498910)|0,498376)|0,498398)|0;g=mTb(mTb(mTb(e,f[40351]|0)|0,502002)|0,498412)|0;e=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(g,f[e>>2]|0)|0);sTb(c);d=f[a>>2]|0;u=b;return d|0}function Gdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==2){d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}rTb(c,3,498207,609);l=mTb(mTb(mTb(mTb(c,498321)|0,498883)|0,498376)|0,498398)|0;m=mTb(mTb(mTb(l,f[40344]|0)|0,502002)|0,498412)|0;l=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(m,f[l>>2]|0)|0);sTb(c);d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}function Hdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==1){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}rTb(c,3,498207,619);g=mTb(mTb(mTb(mTb(c,498321)|0,498856)|0,498376)|0,498398)|0;h=mTb(mTb(mTb(g,f[40343]|0)|0,502002)|0,498412)|0;g=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(h,f[g>>2]|0)|0);sTb(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function Idc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==4){d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}rTb(c,3,498207,614);l=mTb(mTb(mTb(mTb(c,498321)|0,498828)|0,498376)|0,498398)|0;m=mTb(mTb(mTb(l,f[40346]|0)|0,502002)|0,498412)|0;l=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(m,f[l>>2]|0)|0);sTb(c);d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}function Jdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==3){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}rTb(c,3,498207,624);g=mTb(mTb(mTb(mTb(c,498321)|0,498800)|0,498376)|0,498398)|0;h=mTb(mTb(mTb(g,f[40345]|0)|0,502002)|0,498412)|0;g=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(h,f[g>>2]|0)|0);sTb(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function Kdc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c;if((Pdc(a)|0)==7){e=f[a>>2]|0;g=b[e>>0]|0;h=g<<24>>24!=0;u=c;return h|0}rTb(d,3,498207,629);i=mTb(mTb(mTb(mTb(d,498321)|0,498774)|0,498376)|0,498398)|0;j=mTb(mTb(mTb(i,f[40349]|0)|0,502002)|0,498412)|0;i=161368+((Pdc(a)|0)<<2)|0;oTb(c+24|0,mTb(j,f[i>>2]|0)|0);sTb(d);e=f[a>>2]|0;g=b[e>>0]|0;h=g<<24>>24!=0;u=c;return h|0}function Ldc(a){a=a|0;var b=0,c=0,d=0,e=0.0,g=0,h=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==5){d=f[a>>2]|0;e=+p[d>>3];u=b;return +e}rTb(c,3,498207,649);g=mTb(mTb(mTb(mTb(c,498321)|0,498746)|0,498376)|0,498398)|0;h=mTb(mTb(mTb(g,f[40347]|0)|0,502002)|0,498412)|0;g=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(h,f[g>>2]|0)|0);sTb(c);d=f[a>>2]|0;e=+p[d>>3];u=b;return +e}function Mdc(a){a=a|0;var b=0,c=0,d=0,e=0.0,g=0,h=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==6){d=f[a>>2]|0;e=+n[d>>2];u=b;return +e}rTb(c,3,498207,644);g=mTb(mTb(mTb(mTb(c,498321)|0,498719)|0,498376)|0,498398)|0;h=mTb(mTb(mTb(g,f[40348]|0)|0,502002)|0,498412)|0;g=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(h,f[g>>2]|0)|0);sTb(c);d=f[a>>2]|0;e=+n[d>>2];u=b;return +e}function Ndc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==8){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}rTb(c,3,498207,634);g=mTb(mTb(mTb(mTb(c,498321)|0,498693)|0,498376)|0,498398)|0;h=mTb(mTb(mTb(g,f[40350]|0)|0,502002)|0,498412)|0;g=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(h,f[g>>2]|0)|0);sTb(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function Odc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((Pdc(a)|0)==10){d=f[a>>2]|0;u=b;return d|0}rTb(c,3,498207,655);e=mTb(mTb(mTb(mTb(c,498321)|0,498614)|0,498376)|0,498398)|0;g=mTb(mTb(mTb(e,f[40352]|0)|0,502002)|0,498412)|0;e=161368+((Pdc(a)|0)<<2)|0;oTb(b+24|0,mTb(g,f[e>>2]|0)|0);sTb(c);d=f[a>>2]|0;u=b;return d|0}function Pdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;d=b+24|0;e=a+4|0;g=f[e>>2]|0;if(g|0?f[a>>2]|0:0){h=g;u=b;return h|0}rTb(c,3,498207,683);oTb(d,mTb(mTb(c,498321)|0,498643)|0);sTb(c);h=f[e>>2]|0;u=b;return h|0}function Qdc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!(f[c>>2]|0)){d=0;f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}g=a+16|0;h=a+20|0;i=0;while(1){j=f[g>>2]|0;k=j+(i<<2)|0;l=f[k>>2]|0;a:do if(l){if((l|0)!=(f[j+((i^1)<<2)>>2]|0)){f[k>>2]=0;m=l;while(1){n=m;m=f[m+24>>2]|0;if((f[n+8>>2]|0)==9?(o=f[n>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)YDc(f[o>>2]|0);YDc(o)}if(!(f[h>>2]|0))YDc(n);if(!m){p=i;break a}}}if((l|0)==(f[j+((i^1)<<2)>>2]|0)){m=i+1|0;f[j+(m<<2)>>2]=0;f[(f[g>>2]|0)+(i<<2)>>2]=0;n=l+12|0;o=l+4|0;q=l+8|0;r=l+4|0;s=f[l>>2]|0;do{t=s;u=f[t+16>>2]|0;v=s;w=f[v+4>>2]|0;if(!w){x=v+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(v|0))z=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;A=f[y>>2]|0}while((f[A>>2]|0)!=(x|0));z=A}}else{y=w;while(1){A=f[y>>2]|0;if(!A)break;else y=A}z=y}w=f[t+4>>2]|0;if(!w){A=t+8|0;x=f[A>>2]|0;if((f[x>>2]|0)==(v|0))B=x;else{x=A;do{A=f[x>>2]|0;x=A+8|0;C=f[x>>2]|0}while((f[C>>2]|0)!=(A|0));B=C}}else{x=w;while(1){y=f[x>>2]|0;if(!y)break;else x=y}B=x}if((f[l>>2]|0)==(t|0))f[l>>2]=B;f[n>>2]=(f[n>>2]|0)+-1;uHa(f[o>>2]|0,v);if(!(f[q>>2]|0))YDc(s);s=z;if((f[u+8>>2]|0)==9?(w=f[u>>2]|0,w|0):0){if((b[w+11>>0]|0)<0)YDc(f[w>>2]|0);YDc(w)}if(!(f[h>>2]|0))YDc(u)}while((z|0)!=(r|0));s=f[h>>2]|0;xdc(l,f[r>>2]|0);if(!s){YDc(l);p=m}else p=m}else p=i}else p=i;while(0);i=p+1|0;l=f[c>>2]|0;if(i>>>0>=l>>>0){d=l;break}}f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}function Rdc(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+16|0;if(f[b>>2]|0){c=a+8|0;d=f[c>>2]|0;return d|0}e=a+12|0;dTb(e);if(!(f[b>>2]|0)){Yi[f[(f[a>>2]|0)+40>>2]&2047](a);f[b>>2]=2}eTb(e);c=a+8|0;d=f[c>>2]|0;return d|0}function Sdc(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+16|0;if(f[b>>2]|0){f[b>>2]=1;c=a+8|0;d=f[c>>2]|0;return d|0}e=a+12|0;dTb(e);if(!(f[b>>2]|0)){Yi[f[(f[a>>2]|0)+40>>2]&2047](a);f[b>>2]=2}eTb(e);f[b>>2]=1;c=a+8|0;d=f[c>>2]|0;return d|0}function Tdc(a){a=a|0;var b=0,c=0;b=a+12|0;dTb(b);c=_i[f[(f[a>>2]|0)+36>>2]&1023](a)|0;eTb(b);return c|0}function Udc(a){a=a|0;return (f[a+16>>2]|0)!=1|0}function Vdc(a){a=a|0;f[a+16>>2]=0;return}function Wdc(a){a=a|0;var b=0,c=0;b=a+16|0;if((f[b>>2]|0)!=1)return;c=a+12|0;dTb(c);if((f[b>>2]|0)==1){Yi[f[(f[a>>2]|0)+44>>2]&2047](a);f[b>>2]=2}eTb(c);return}function Xdc(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=167152;f[a+4>>2]=0;f[a+8>>2]=0;tTb(a+12|0);f[a+16>>2]=0;f[a>>2]=167224;c=a+20|0;f[c>>2]=0;f[a+24>>2]=0;Ydc(c);f[a+32>>2]=b;return}function Ydc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a>>2]|0;c=b;if(!b){d=VDc(24)|0;f[d>>2]=0;f[d+8>>2]=d;e=d+16|0;f[e>>2]=0;f[d+20>>2]=c;g=VDc(32)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;h=g;i=d;j=e;f[j>>2]=h;k=i+12|0;f[k>>2]=8;l=i+4|0;f[l>>2]=8;m=a+8|0;f[m>>2]=i;return}e=b+64|0;if(f[e>>2]|0)OQb(b,20968,24);d=NQb(b,24,1782)|0;f[d>>2]=0;f[d+8>>2]=d;g=d+16|0;f[g>>2]=0;f[d+20>>2]=c;if(f[e>>2]|0)OQb(b,23824,32);e=MQb(b,32)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;h=e;i=d;j=g;f[j>>2]=h;k=i+12|0;f[k>>2]=8;l=i+4|0;f[l>>2]=8;m=a+8|0;f[m>>2]=i;return}function Zdc(a){a=a|0;var b=0;b=a+16|0;if(!(f[b>>2]|0))return;Qdc(a);if(f[a+20>>2]|0)return;YDc(f[b>>2]|0);return}function _dc(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);fEc(a,f[(f[d>>2]|0)+4>>2]|0);u=c;return}function $dc(a){a=a|0;Dhc(a);return}function aec(a){a=a|0;return Fhc(a)|0}function bec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d+16|0;g=d;f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Hhc(c,e,g);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=f[g>>2]|0;i=f[h>>2]|0;if((c|0)==(i|0))j=c;else{k=e+4|0;l=c;do{if((l|0)!=(c|0))uEc(a,518069)|0;m=b[l+11>>0]|0;n=m<<24>>24<0;f[e>>2]=n?f[l>>2]|0:l;f[k>>2]=n?f[l+4>>2]|0:m&255;qmc(a,e);l=l+12|0}while((l|0)!=(i|0));j=f[g>>2]|0}if(!j){u=d;return}i=f[h>>2]|0;if((i|0)==(j|0))o=j;else{l=i;while(1){i=l+-12|0;f[h>>2]=i;if((b[i+11>>0]|0)<0){YDc(f[i>>2]|0);p=f[h>>2]|0}else p=i;if((p|0)==(j|0))break;else l=p}o=f[g>>2]|0}YDc(o);u=d;return}function cec(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function dec(a,b){a=a|0;b=b|0;return Kjc(b,a)|0}function eec(a){a=a|0;var b=0;b=ckc(a)|0;mi[f[(f[a>>2]|0)+88>>2]&2047](a,b);return b|0}function fec(a,b){a=a|0;b=b|0;var c=0;c=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;if(!c){Ojc(a,_i[f[(f[a>>2]|0)+60>>2]&1023](a)|0,b);return}else{TQb(a,(f[c+4>>2]|0)+20|0,(f[c>>2]|0)+-1|0,b);return}}function gec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d>>2]|0;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);if((f[d>>2]|0)==(g|0)){Chc(b,a);u=c;return}rTb(e,3,499170,80);h=mTb(mTb(e,499359)|0,499484)|0;i=mTb(nTb(h,f[g+4>>2]|0)|0,499475)|0;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);oTb(c+32|0,nTb(i,f[(f[d>>2]|0)+4>>2]|0)|0);sTb(e);Chc(b,a);u=c;return}function hec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d>>2]|0;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);if((f[d>>2]|0)==(g|0)){Ehc(b,a);u=c;return}rTb(e,3,499170,67);h=mTb(mTb(e,499359)|0,499414)|0;i=mTb(nTb(h,f[g+4>>2]|0)|0,499475)|0;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);oTb(c+32|0,nTb(i,f[(f[d>>2]|0)+4>>2]|0)|0);sTb(e);Ehc(b,a);u=c;return}function iec(a){a=a|0;Ghc(a);return}function jec(a){a=a|0;var b=0;b=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;return Mi[f[(f[b>>2]|0)+16>>2]&1023](b,a)|0}function kec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=u;u=u+48|0;c=b+24|0;d=b;rTb(d,3,499170,162);e=mTb(d,499256)|0;mi[f[(f[a>>2]|0)+96>>2]&2047](c,a);oTb(b+32|0,mTb(nTb(e,f[(f[c>>2]|0)+4>>2]|0)|0,499272)|0);sTb(d);u=b;return}function lec(a){a=a|0;return}function mec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+80|0;d=a+48|0;e=a+24|0;g=a;h=a+64|0;if((f[c+32>>2]|0)!=3){rTb(e,3,499170,406);oTb(a+65|0,mTb(e,499570)|0);sTb(e)}e=c+24|0;i=f[e>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[d>>2]=78728;f[d+4>>2]=1737;b[d+8>>0]=0;f[d+12>>2]=c;DTb(i,d)}i=c+28|0;do switch(f[161216+(f[i>>2]<<2)>>2]|0){case 1:{if((f[220866]|0)!=2){f[d>>2]=161028;f[d+4>>2]=165;b[d+8>>0]=0;DTb(883464,d);ZSb(d)}j=f[220867]|0;u=a;return j|0}case 3:{if((f[220868]|0)!=2){f[d>>2]=161028;f[d+4>>2]=166;b[d+8>>0]=0;DTb(883472,d);ZSb(d)}j=f[220869]|0;u=a;return j|0}case 2:{if((f[220870]|0)!=2){f[d>>2]=161028;f[d+4>>2]=167;b[d+8>>0]=0;DTb(883480,d);ZSb(d)}j=f[220871]|0;u=a;return j|0}case 4:{if((f[220872]|0)!=2){f[d>>2]=161028;f[d+4>>2]=168;b[d+8>>0]=0;DTb(883488,d);ZSb(d)}j=f[220873]|0;u=a;return j|0}case 6:{if((f[220874]|0)!=2){f[d>>2]=161028;f[d+4>>2]=169;b[d+8>>0]=0;DTb(883496,d);ZSb(d)}j=f[220875]|0;u=a;return j|0}case 5:{if((f[220876]|0)!=2){f[d>>2]=161028;f[d+4>>2]=170;b[d+8>>0]=0;DTb(883504,d);ZSb(d)}j=f[220877]|0;u=a;return j|0}case 7:{if((f[220878]|0)!=2){f[d>>2]=161028;f[d+4>>2]=171;b[d+8>>0]=0;DTb(883512,d);ZSb(d)}j=f[220879]|0;u=a;return j|0}case 8:{if((f[220866]|0)!=2){f[d>>2]=161028;f[d+4>>2]=165;b[d+8>>0]=0;DTb(883464,d);ZSb(d)}j=f[220867]|0;u=a;return j|0}case 9:{if((f[220880]|0)!=2){f[d>>2]=161028;f[d+4>>2]=172;b[d+8>>0]=0;DTb(883520,d);ZSb(d)}j=f[220881]|0;u=a;return j|0}case 10:{k=f[e>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[d>>2]=78728;f[d+4>>2]=1737;b[d+8>>0]=0;f[d+12>>2]=c;DTb(k,d)}if((f[i>>2]|0)==11?BYb(c)|0:0){if((f[220882]|0)!=2){f[d>>2]=161028;f[d+4>>2]=173;b[d+8>>0]=0;DTb(883528,d);ZSb(d)}j=f[220883]|0;u=a;return j|0}if((f[220884]|0)!=2){f[d>>2]=161028;f[d+4>>2]=174;b[d+8>>0]=0;DTb(883536,d);ZSb(d)}j=f[220885]|0;u=a;return j|0}default:{rTb(g,3,499170,434);oTb(h,mTb(g,499607)|0);sTb(g);j=0;u=a;return j|0}}while(0);return 0}function nec(){var a=0;a=VDc(4)|0;f[a>>2]=168112;f[220867]=a;return}function oec(){var a=0;a=VDc(4)|0;f[a>>2]=168024;f[220869]=a;return}function pec(){var a=0;a=VDc(4)|0;f[a>>2]=167936;f[220871]=a;return}function qec(){var a=0;a=VDc(4)|0;f[a>>2]=167848;f[220873]=a;return}function rec(){var a=0;a=VDc(4)|0;f[a>>2]=167760;f[220875]=a;return}function sec(){var a=0;a=VDc(4)|0;f[a>>2]=167672;f[220877]=a;return}function tec(){var a=0;a=VDc(4)|0;f[a>>2]=167584;f[220879]=a;return}function uec(){var a=0;a=VDc(4)|0;f[a>>2]=167492;f[220881]=a;return}function vec(){var a=0;a=VDc(4)|0;f[a>>2]=167400;f[220883]=a;return}function wec(){var a=0;a=VDc(4)|0;f[a>>2]=167308;f[220885]=a;return}function xec(a){a=a|0;return}function yec(a){a=a|0;YDc(a);return}function zec(a,b){a=a|0;b=b|0;return (f[b+4>>2]|0)==0|0}function Aec(a,b){a=a|0;b=b|0;return f[b+4>>2]|0}function Bec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+80>>2]&511](a,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0,d)|0}function Cec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=b+4|0;c=f[a>>2]|0;if((c|0)<=0)return;d=f[b+12>>2]|0;b=0;do{e=f[d+4+(b<<2)>>2]|0;b=b+1|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}while((b|0)!=(c|0));f[a>>2]=0;return}function Dec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,d,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0);return}function Eec(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,c,d);c=_i[f[(f[d>>2]|0)+24>>2]&1023](d)|0;a=f[b>>2]|0;if(((a|0)==(c|0)?(c=b+12|0,e=f[c>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[b+8>>2]|0)):0){h=b+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[c>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}Edc(b,d,_i[f[(f[d>>2]|0)+20>>2]&1023](d)|0,a);return}function Fec(a,b){a=a|0;b=b|0;var c=0;a=f[b+12>>2]|0;c=b+4|0;b=(f[c>>2]|0)+-1|0;f[c>>2]=b;c=f[a+4+(b<<2)>>2]|0;Yi[f[(f[c>>2]|0)+28>>2]&2047](c);return}function Gec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+12>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function Hec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;if((a|0)!=(c|0)){rTb(g,3,499630,358);oTb(e+24|0,mTb(g,499727)|0);sTb(g)}if((b|0)==(d|0)){u=e;return}if((f[d>>2]|0)==(f[b>>2]|0)){g=b+12|0;c=d+12|0;a=f[g>>2]|0;f[g>>2]=f[c>>2];f[c>>2]=a;a=b+4|0;c=d+4|0;g=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=g;g=b+8|0;c=d+8|0;a=f[g>>2]|0;f[g>>2]=f[c>>2];f[c>>2]=a;u=e;return}else{Sec(b,d);u=e;return}}function Iec(a,b){a=a|0;b=b|0;return 0}function Jec(a,b){a=a|0;b=b|0;return Mi[f[(f[a>>2]|0)+12>>2]&1023](a,b)|0}function Kec(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function Lec(a,b,c){a=a|0;b=b|0;c=c|0;return c+1|0}function Mec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (c|0)==(d|0)|0}function Nec(a,b,c){a=a|0;b=b|0;c=c|0;return}function Oec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hh[f[(f[a>>2]|0)+16>>2]&127](a,b,c,d)|0}function Pec(a,b){a=a|0;b=b|0;return _i[f[(f[b>>2]|0)+12>>2]&1023](b)|0}function Qec(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[(f[c>>2]|0)+72>>2]&2047](c,b);return}function Rec(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Sec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;f[d>>2]=f[b>>2];e=d+4|0;f[e>>2]=0;g=d+8|0;f[g>>2]=0;h=d+12|0;f[h>>2]=0;Tec(d,a);i=a+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[a+12>>2]|0;l=0;do{m=f[k+4+(l<<2)>>2]|0;l=l+1|0;Yi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((l|0)!=(j|0));f[i>>2]=0}Tec(a,b);a=b+4|0;i=f[a>>2]|0;j=b+12|0;if((i|0)>0){l=f[j>>2]|0;k=0;do{m=f[l+4+(k<<2)>>2]|0;k=k+1|0;Yi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((k|0)!=(i|0));f[a>>2]=0;n=0}else n=i;i=f[j>>2]|0;f[j>>2]=f[h>>2];f[h>>2]=i;f[a>>2]=f[e>>2];f[e>>2]=n;n=b+8|0;b=f[n>>2]|0;f[n>>2]=f[g>>2];f[g>>2]=b;b=i;if(!((i|0)!=0&(f[d>>2]|0)==0)){u=c;return}d=i;i=f[b>>2]|0;if((i|0)>0){g=0;do{n=f[b+4+(g<<2)>>2]|0;if(n|0)Yi[f[(f[n>>2]|0)+4>>2]&2047](n);g=g+1|0}while((g|0)!=(i|0));o=f[h>>2]|0}else o=d;YDc(o);u=c;return}function Tec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{pbc(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Mi[f[(f[h>>2]|0)+16>>2]&1023](h,i)|0;pbc(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function Uec(a){a=a|0;YDc(a);return}function Vec(a,b){a=a|0;b=b|0;a=(Rdc(b)|0)+4|0;return (f[a>>2]|0)==0|0}function Wec(a,b){a=a|0;b=b|0;a=(Rdc(b)|0)+4|0;return f[a>>2]|0}function Xec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[(f[a>>2]|0)+80>>2]|0;g=(Rdc(b)|0)+12|0;return hj[e&511](a,f[(f[g>>2]|0)+4+(c<<2)>>2]|0,d)|0}function Yec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=Sdc(b)|0;b=a+4|0;c=f[b>>2]|0;if((c|0)<=0)return;d=f[a+12>>2]|0;a=0;do{e=f[d+4+(a<<2)>>2]|0;a=a+1|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e)}while((a|0)!=(c|0));f[b>>2]=0;return}function Zec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[(f[a>>2]|0)+76>>2]|0;g=(Sdc(b)|0)+12|0;Ti[e&511](a,d,f[(f[g>>2]|0)+4+(c<<2)>>2]|0);return}function _ec(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,c,d);c=Sdc(b)|0;b=_i[f[(f[d>>2]|0)+24>>2]&1023](d)|0;a=f[c>>2]|0;if(((a|0)==(b|0)?(b=c+12|0,e=f[b>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[c+8>>2]|0)):0){h=c+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[b>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}Edc(c,d,_i[f[(f[d>>2]|0)+20>>2]&1023](d)|0,a);return}function $ec(a,b){a=a|0;b=b|0;var c=0;a=Sdc(b)|0;b=f[a+12>>2]|0;c=a+4|0;a=(f[c>>2]|0)+-1|0;f[c>>2]=a;c=f[b+4+(a<<2)>>2]|0;Yi[f[(f[c>>2]|0)+28>>2]&2047](c);return}function afc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=(Sdc(b)|0)+12|0;b=f[a>>2]|0;a=b+4+(c<<2)|0;c=b+4+(d<<2)|0;d=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=d;return}function bfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;if((a|0)!=(c|0)){rTb(g,3,499630,240);oTb(e+24|0,mTb(g,499727)|0);sTb(g)}g=Sdc(b)|0;b=Sdc(d)|0;if((g|0)==(b|0)){u=e;return}if((f[b>>2]|0)==(f[g>>2]|0)){d=g+12|0;c=b+12|0;a=f[d>>2]|0;f[d>>2]=f[c>>2];f[c>>2]=a;a=g+4|0;c=b+4|0;d=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=d;d=g+8|0;c=b+8|0;a=f[d>>2]|0;f[d>>2]=f[c>>2];f[c>>2]=a;u=e;return}else{Sec(g,b);u=e;return}}function cfc(a,b){a=a|0;b=b|0;return _i[f[(f[b>>2]|0)+12>>2]&1023](b)|0}function dfc(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[(f[c>>2]|0)+72>>2]&2047](c,b);return}function efc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function ffc(a){a=a|0;YDc(a);return}function gfc(a,b){a=a|0;b=b|0;return (f[b+4>>2]|0)==0|0}function hfc(a,b){a=a|0;b=b|0;return f[b+4>>2]|0}function ifc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+80>>2]&511](a,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0,d)|0}function jfc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;a=c+4|0;d=f[a>>2]|0;if((d|0)<=0)return;e=f[c+12>>2]|0;c=0;do{g=f[e+4+(c<<2)>>2]|0;c=c+1|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0}else{b[g>>0]=0;b[h>>0]=0}}while((c|0)!=(d|0));f[a>>2]=0;return}function kfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,d,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0);return}function lfc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,c,d);c=f[b>>2]|0;if(((c|0)==0?(a=b+12|0,e=f[a>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[b+8>>2]|0)):0){h=b+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[a>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}tfc(b,d,0,c);return}function mfc(a,c){a=a|0;c=c|0;var d=0;a=f[c+12>>2]|0;d=c+4|0;c=(f[d>>2]|0)+-1|0;f[d>>2]=c;d=f[a+4+(c<<2)>>2]|0;c=d+11|0;if((b[c>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;return}else{b[d>>0]=0;b[c>>0]=0;return}}function nfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+12>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function ofc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;if((a|0)==(d|0)){if((c|0)==(e|0)){u=g;return}if((f[e>>2]|0)==(f[c>>2]|0)){k=c+12|0;l=e+12|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;m=c+4|0;l=e+4|0;k=f[m>>2]|0;f[m>>2]=f[l>>2];f[l>>2]=k;k=c+8|0;l=e+8|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;u=g;return}else{sfc(c,e);u=g;return}};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;do if((i|0)!=(c|0))if(!(f[c>>2]|0)){m=c+12|0;f[i+12>>2]=f[m>>2];f[m>>2]=0;m=c+4|0;f[i+4>>2]=f[m>>2];f[m>>2]=0;m=c+8|0;f[i+8>>2]=f[m>>2];f[m>>2]=0;break}else{sfc(i,c);break}while(0);m=Mi[f[(f[d>>2]|0)+12>>2]&1023](d,e)|0;if((m|0)>0){l=h+11|0;k=h+11|0;n=j+11|0;o=0;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;fEc(j,hh[f[(f[d>>2]|0)+16>>2]&127](d,e,o,h)|0);if((b[l>>0]|0)<0)YDc(f[h>>2]|0);fEc(h,j);Ti[f[(f[a>>2]|0)+28>>2]&511](a,c,h);if((b[k>>0]|0)<0)YDc(f[h>>2]|0);if((b[n>>0]|0)<0)YDc(f[j>>2]|0);o=o+1|0}while((o|0)<(m|0))}m=Mi[f[(f[a>>2]|0)+12>>2]&1023](a,c)|0;mi[f[(f[d>>2]|0)+20>>2]&2047](d,e);c=i+12|0;a=f[c>>2]|0;if((m|0)>0){o=h+11|0;j=0;n=a;while(1){fEc(h,f[n+4+(j<<2)>>2]|0);Ti[f[(f[d>>2]|0)+28>>2]&511](d,e,h);if((b[o>>0]|0)<0)YDc(f[h>>2]|0);j=j+1|0;k=f[c>>2]|0;if((j|0)>=(m|0)){p=k;break}else n=k}}else p=a;if(p|0?(f[i>>2]|0)==0:0){i=f[p>>2]|0;if((i|0)>0){a=0;do{n=f[p+4+(a<<2)>>2]|0;if(n|0){if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);YDc(n)}a=a+1|0}while((a|0)!=(i|0));q=f[c>>2]|0}else q=p;YDc(q)}u=g;return}function pfc(a,b){a=a|0;b=b|0;b=VDc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;return b|0}function qfc(a,b,c){a=a|0;b=b|0;c=c|0;iEc(c,b)|0;return}function rfc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function sfc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=e+4|0;f[g>>2]=0;h=e+8|0;f[h>>2]=0;i=e+12|0;f[i>>2]=0;yNa(e,a);j=a+4|0;k=f[j>>2]|0;if((k|0)>0){l=f[a+12>>2]|0;m=0;do{n=f[l+4+(m<<2)>>2]|0;m=m+1|0;o=n+11|0;if((b[o>>0]|0)<0){b[f[n>>2]>>0]=0;f[n+4>>2]=0}else{b[n>>0]=0;b[o>>0]=0}}while((m|0)!=(k|0));f[j>>2]=0}yNa(a,c);a=c+4|0;j=f[a>>2]|0;k=c+12|0;if((j|0)>0){m=f[k>>2]|0;l=0;do{o=f[m+4+(l<<2)>>2]|0;l=l+1|0;n=o+11|0;if((b[n>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0}else{b[o>>0]=0;b[n>>0]=0}}while((l|0)!=(j|0));f[a>>2]=0;p=0}else p=j;j=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=j;f[a>>2]=f[g>>2];f[g>>2]=p;p=c+8|0;c=f[p>>2]|0;f[p>>2]=f[h>>2];f[h>>2]=c;c=j;if(!((j|0)!=0&(f[e>>2]|0)==0)){u=d;return}e=j;j=f[c>>2]|0;if((j|0)>0){h=0;do{p=f[c+4+(h<<2)>>2]|0;if(p|0){if((b[p+11>>0]|0)<0)YDc(f[p>>2]|0);YDc(p)}h=h+1|0}while((h|0)!=(j|0));q=f[i>>2]|0}else q=e;YDc(q);u=d;return}function tfc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;if(!((d|0)==0&(e|0)!=0))if((e|0)!=(d|0)){if(!e){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g}else{if(f[e+64>>2]|0)OQb(e,4984,16);g=NQb(e,16,1733)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g}iEc(h,c)|0;if((c|0)==0|(d|0)!=0)i=h;else{if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);i=h}}else i=c;else{XJa(e,c);i=c}ufc(a,i);return}function ufc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+12|0;e=f[d>>2]|0;g=f[a+8>>2]|0;h=a+4|0;do if((e|0)!=0?(i=f[h>>2]|0,(i|0)!=(g|0)):0){j=f[e>>2]|0;if((j|0)!=(g|0)){if((i|0)<(j|0)){f[e+4+(j<<2)>>2]=f[e+4+(i<<2)>>2];k=f[d>>2]|0;l=k;m=f[k>>2]|0}else{l=e;m=j}f[l>>2]=m+1;n=l;break}j=f[e+4+(i<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0)n=e;else{if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);YDc(j);n=f[d>>2]|0}}else o=3;while(0);if((o|0)==3){USb(a,g+1|0);g=f[d>>2]|0;f[g>>2]=(f[g>>2]|0)+1;n=g}g=f[h>>2]|0;f[h>>2]=g+1;f[n+4+(g<<2)>>2]=c;return}function vfc(a){a=a|0;YDc(a);return}function wfc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function xfc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function yfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+c|0,d)|0}function zfc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Afc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;g=(Mi[f[(f[a>>2]|0)+72>>2]&1023](a,e)|0)&1;b[(f[c+8>>2]|0)+4+d>>0]=g;return}function Bfc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=(Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0)&1;d=f[c>>2]|0;if((d|0)==(f[c+4>>2]|0)){zNa(c,d+1|0);g=f[c>>2]|0}else g=d;d=f[c+8>>2]|0;f[c>>2]=g+1;b[d+4+g>>0]=e;return}function Cfc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function Dfc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=f[c+8>>2]|0;c=a+4+d|0;d=a+4+e|0;e=b[c>>0]|0;b[c>>0]=b[d>>0]|0;b[d>>0]=e;return}function Efc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Qbc(b,d);u=e;return}rTb(f,3,499630,287);oTb(e+24|0,mTb(f,499727)|0);sTb(f);Qbc(b,d);u=e;return}function Ffc(a,c){a=a|0;c=c|0;return (b[c>>0]|0)!=0|0}function Gfc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Hfc(a){a=a|0;YDc(a);return}function Ifc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Jfc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Kfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function Lfc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Mfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;e=+ch[f[(f[a>>2]|0)+72>>2]&31](a,d);p[(f[b+8>>2]|0)+8+(c<<3)>>3]=e;return}function Nfc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0;d=+ch[f[(f[a>>2]|0)+72>>2]&31](a,c);c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){THa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;p[c+8+(e<<3)>>3]=d;return}function Ofc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function Pfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;e=+p[b>>3];p[b>>3]=+p[c>>3];p[c>>3]=e;return}function Qfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Pbc(b,d);u=e;return}rTb(f,3,499630,287);oTb(e+24|0,mTb(f,499727)|0);sTb(f);Pbc(b,d);u=e;return}function Rfc(a,b){a=a|0;b=b|0;return +(+p[b>>3])}function Sfc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Tfc(a){a=a|0;YDc(a);return}function Ufc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Vfc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Wfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function Xfc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Yfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;e=+ch[f[(f[a>>2]|0)+72>>2]&31](a,d);n[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function Zfc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0;d=+ch[f[(f[a>>2]|0)+72>>2]&31](a,c);c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){SHa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;n[c+4+(e<<2)>>2]=d;return}function _fc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function $fc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function agc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Obc(b,d);u=e;return}rTb(f,3,499630,287);oTb(e+24|0,mTb(f,499727)|0);sTb(f);Obc(b,d);u=e;return}function bgc(a,b){a=a|0;b=b|0;return +(+n[b>>2])}function cgc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function dgc(a){a=a|0;YDc(a);return}function egc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function fgc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function ggc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function hgc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function igc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;d=(f[b+8>>2]|0)+8+(c<<3)|0;f[d>>2]=e;f[d+4>>2]=J;return}function jgc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=J;a=f[b>>2]|0;if((a|0)==(f[b+4>>2]|0)){Hjb(b,a+1|0);e=f[b>>2]|0}else e=a;a=f[b+8>>2]|0;f[b>>2]=e+1;b=a+8+(e<<3)|0;f[b>>2]=d;f[b+4>>2]=c;return}function kgc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function lgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;d=b;a=f[d>>2]|0;e=f[d+4>>2]|0;d=c;g=f[d+4>>2]|0;h=b;f[h>>2]=f[d>>2];f[h+4>>2]=g;g=c;f[g>>2]=a;f[g+4>>2]=e;return}function mgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Nbc(b,d);u=e;return}rTb(f,3,499630,287);oTb(e+24|0,mTb(f,499727)|0);sTb(f);Nbc(b,d);u=e;return}function ngc(a,b){a=a|0;b=b|0;a=b;J=f[a+4>>2]|0;return f[a>>2]|0}function ogc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function pgc(a){a=a|0;YDc(a);return}function qgc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function rgc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function sgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function tgc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function ugc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;d=(f[b+8>>2]|0)+8+(c<<3)|0;f[d>>2]=e;f[d+4>>2]=J;return}function vgc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=J;a=f[b>>2]|0;if((a|0)==(f[b+4>>2]|0)){UHa(b,a+1|0);e=f[b>>2]|0}else e=a;a=f[b+8>>2]|0;f[b>>2]=e+1;b=a+8+(e<<3)|0;f[b>>2]=d;f[b+4>>2]=c;return}function wgc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function xgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;d=b;a=f[d>>2]|0;e=f[d+4>>2]|0;d=c;g=f[d+4>>2]|0;h=b;f[h>>2]=f[d>>2];f[h+4>>2]=g;g=c;f[g>>2]=a;f[g+4>>2]=e;return}function ygc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Lbc(b,d);u=e;return}rTb(f,3,499630,287);oTb(e+24|0,mTb(f,499727)|0);sTb(f);Lbc(b,d);u=e;return}function zgc(a,b){a=a|0;b=b|0;a=b;J=f[a+4>>2]|0;return f[a>>2]|0}function Agc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Bgc(a){a=a|0;YDc(a);return}function Cgc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Dgc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Egc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function Fgc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Ggc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;f[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function Hgc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){OLa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;f[c+4+(e<<2)>>2]=d;return}function Igc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function Jgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function Kgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Mbc(b,d);u=e;return}rTb(f,3,499630,287);oTb(e+24|0,mTb(f,499727)|0);sTb(f);Mbc(b,d);u=e;return}function Lgc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Mgc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Ngc(a){a=a|0;YDc(a);return}function Ogc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Pgc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Qgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function Rgc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Sgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;f[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function Tgc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){KLa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;f[c+4+(e<<2)>>2]=d;return}function Ugc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function Vgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function Wgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Kbc(b,d);u=e;return}rTb(f,3,499630,287);oTb(e+24|0,mTb(f,499727)|0);sTb(f);Kbc(b,d);u=e;return}function Xgc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Ygc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Zgc(a){a=a|0;return}function _gc(){iTb(175);return}function $gc(){var a=0;a=f[220867]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220867]=0;a=f[220869]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220869]=0;a=f[220871]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220871]=0;a=f[220873]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220873]=0;a=f[220875]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220875]=0;a=f[220877]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220877]=0;a=f[220879]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220879]=0;a=f[220881]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220881]=0;a=f[220885]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220885]=0;a=f[220883]|0;if(!a){f[220883]=0;return}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);f[220883]=0;return}function ahc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Hhc(a,e,c);if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function bhc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+64|0;d=c;Acc(d,b,-1);if(JSb(a,d)|0)e=(f[b+(f[(f[b>>2]|0)+-12>>2]|0)+16>>2]&2|0)!=0;else e=0;f[d>>2]=167096;uSb(d+16|0);xcc(d+4|0);u=c;return e|0}function chc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,1,-1,0)|0}function dhc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,2,-1,0)|0}function ehc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,3,-1,0)|0}function fhc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,4,-1,0)|0}function ghc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,6,-1,0)|0}function hhc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,5,-1,0)|0}function ihc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,7,-1,0)|0}function jhc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,9,0,0)|0}function khc(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[220886]|0)==2){d=f[220887]|0;u=a;return d|0}f[c>>2]=161028;f[c+4>>2]=176;b[c+8>>0]=0;DTb(883544,c);ZSb(c);d=f[220887]|0;u=a;return d|0}function lhc(){var a=0,b=0;a=VDc(48)|0;f[a>>2]=168200;b=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+20>>2]=1.0;tTb(a+24|0);b=a+28|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+44>>2]=1.0;f[220887]=a;iTb(177);return}function mhc(){var a=0;a=f[220887]|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nhc(a){a=a|0;var b=0,c=0;f[a>>2]=168200;b=f[a+36>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;YDc(b)}while((c|0)!=0)}c=a+28|0;b=f[c>>2]|0;f[c>>2]=0;if(b|0)YDc(b);uTb(a+24|0);b=f[a+12>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;YDc(b)}while((c|0)!=0)}c=a+4|0;a=f[c>>2]|0;f[c>>2]=0;if(!a)return;YDc(a);return}function ohc(a){a=a|0;nhc(a);YDc(a);return}function phc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+64|0;e=d+48|0;g=d+24|0;h=d+53|0;i=d;j=d+52|0;k=c;l=a+24|0;dTb(l);m=a+28|0;n=a+32|0;o=f[n>>2]|0;a:do if(o){p=o+-1|0;q=(p&o|0)==0;if(!q)if(k>>>0<o>>>0)r=k;else r=(k>>>0)%(o>>>0)|0;else r=p&k;s=f[(f[m>>2]|0)+(r<<2)>>2]|0;if((s|0)!=0?(t=f[s>>2]|0,(t|0)!=0):0){b:do if(q){s=t;while(1){v=f[s+4>>2]|0;w=(v|0)==(k|0);if(!(w|(v&p|0)==(r|0))){x=19;break a}if(w?(f[s+8>>2]|0)==(c|0):0){y=s;break b}s=f[s>>2]|0;if(!s){x=19;break a}}}else{s=t;while(1){w=f[s+4>>2]|0;if((w|0)==(k|0)){if((f[s+8>>2]|0)==(c|0)){y=s;break b}}else{if(w>>>0<o>>>0)z=w;else z=(w>>>0)%(o>>>0)|0;if((z|0)!=(r|0)){x=19;break a}}s=f[s>>2]|0;if(!s){x=19;break a}}}while(0);t=f[y+12>>2]|0;eTb(l);if(t|0){A=t;u=d;return A|0}}else x=19}else x=19;while(0);if((x|0)==19)eTb(l);y=c+8|0;r=f[(f[y>>2]|0)+8>>2]|0;if((r|0)!=(kYb()|0)){A=0;u=d;return A|0}r=f[f[y>>2]>>2]|0;if((b[r+11>>0]|0)<0)B=f[r>>2]|0;else B=r;f[e>>2]=B;B=qhc(a+4|0,e)|0;if(B){e=f[B+12>>2]|0;if(e|0){dTb(l);B=f[n>>2]|0;c:do if(B){a=B+-1|0;r=(a&B|0)==0;if(!r)if(k>>>0<B>>>0)C=k;else C=(k>>>0)%(B>>>0)|0;else C=a&k;z=f[(f[m>>2]|0)+(C<<2)>>2]|0;if((z|0)!=0?(o=f[z>>2]|0,(o|0)!=0):0){d:do if(r){z=o;while(1){t=f[z+4>>2]|0;p=(t|0)==(k|0);if(!(p|(t&a|0)==(C|0))){x=48;break c}if(p?(f[z+8>>2]|0)==(c|0):0){D=z;break d}z=f[z>>2]|0;if(!z){x=48;break c}}}else{z=o;while(1){p=f[z+4>>2]|0;if((p|0)==(k|0)){if((f[z+8>>2]|0)==(c|0)){D=z;break d}}else{if(p>>>0<B>>>0)E=p;else E=(p>>>0)%(B>>>0)|0;if((E|0)!=(C|0)){x=48;break c}}z=f[z>>2]|0;if(!z){x=48;break c}}}while(0);o=f[D+12>>2]|0;if(o)F=o;else x=48}else x=48}else x=48;while(0);e:do if((x|0)==48){Yi[e&2047](f[f[y>>2]>>2]|0);D=f[n>>2]|0;f:do if(D|0){C=D+-1|0;E=(C&D|0)==0;if(!E)if(k>>>0<D>>>0)G=k;else G=(k>>>0)%(D>>>0)|0;else G=C&k;B=f[(f[m>>2]|0)+(G<<2)>>2]|0;if(B|0?(o=f[B>>2]|0,o|0):0){g:do if(E){B=o;while(1){a=f[B+4>>2]|0;r=(a|0)==(k|0);if(!(r|(a&C|0)==(G|0)))break f;if(r?(f[B+8>>2]|0)==(c|0):0){H=B;break g}B=f[B>>2]|0;if(!B)break f}}else{B=o;while(1){r=f[B+4>>2]|0;if((r|0)==(k|0)){if((f[B+8>>2]|0)==(c|0)){H=B;break g}}else{if(r>>>0<D>>>0)I=r;else I=(r>>>0)%(D>>>0)|0;if((I|0)!=(G|0))break f}B=f[B>>2]|0;if(!B)break f}}while(0);o=f[H+12>>2]|0;if(o|0){F=o;break e}}}while(0);rTb(i,2,499170,361);D=mTb(mTb(i,501172)|0,501221)|0;oTb(j,nTb(D,f[c+4>>2]|0)|0);sTb(i);F=0}while(0);eTb(l);A=F;u=d;return A|0}}rTb(g,2,499170,344);F=mTb(g,501111)|0;oTb(h,nTb(F,f[f[y>>2]>>2]|0)|0);sTb(g);A=0;u=d;return A|0}function qhc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(c|0)==(e|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(Ioc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(a|0)==(e|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(Ioc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function rhc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[220886]|0)!=2){f[e>>2]=161028;f[e+4>>2]=176;b[e+8>>0]=0;DTb(883544,e);ZSb(e)}h=(f[220887]|0)+4|0;f[e>>2]=a;f[e+4>>2]=c;if(shc(h,e)|0){u=d;return}rTb(g,3,499170,309);oTb(d+36|0,mTb(mTb(g,501292)|0,a)|0);sTb(g);u=d;return}function shc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]|0;e=b[d>>0]|0;if(!(e<<24>>24))g=0;else{h=d;i=0;j=e;while(1){e=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=e;break}else i=e}}i=a+4|0;j=f[i>>2]|0;h=(j|0)==0;a:do if(!h){e=j+-1|0;k=(e&j|0)==0;if(!k)if(g>>>0<j>>>0)l=g;else l=(g>>>0)%(j>>>0)|0;else l=e&g;m=f[(f[a>>2]|0)+(l<<2)>>2]|0;if(!m)o=l;else{if(k){k=m;while(1){k=f[k>>2]|0;if(!k){o=l;break a}p=f[k+4>>2]|0;if(!((p|0)==(g|0)|(p&e|0)==(l|0))){o=l;break a}if(!(Ioc(f[k+8>>2]|0,d)|0)){q=0;break}}return q|0}else r=m;while(1){r=f[r>>2]|0;if(!r){o=l;break a}k=f[r+4>>2]|0;if((k|0)!=(g|0)){if(k>>>0<j>>>0)s=k;else s=(k>>>0)%(j>>>0)|0;if((s|0)!=(l|0)){o=l;break a}}if(!(Ioc(f[r+8>>2]|0,d)|0)){q=0;break}}return q|0}}else o=0;while(0);d=VDc(16)|0;r=c;c=f[r+4>>2]|0;l=d+8|0;f[l>>2]=f[r>>2];f[l+4>>2]=c;f[d+4>>2]=g;f[d>>2]=0;c=a+12|0;t=+(((f[c>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(h|t>+(j>>>0)*u){l=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;r=~~+X(+(t/u))>>>0;thc(a,l>>>0<r>>>0?r:l);l=f[i>>2]|0;r=l+-1|0;if(!(r&l)){v=l;w=r&g;break}if(g>>>0<l>>>0){v=l;w=g}else{v=l;w=(g>>>0)%(l>>>0)|0}}else{v=j;w=o}while(0);o=(f[a>>2]|0)+(w<<2)|0;w=f[o>>2]|0;if(!w){j=a+8|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[o>>2]=j;j=f[d>>2]|0;if(j|0){o=f[j+4>>2]|0;j=v+-1|0;if(j&v)if(o>>>0<v>>>0)x=o;else x=(o>>>0)%(v>>>0)|0;else x=o&j;y=(f[a>>2]|0)+(x<<2)|0;z=32}}else{f[d>>2]=f[w>>2];y=w;z=32}if((z|0)==32)f[y>>2]=d;f[c>>2]=(f[c>>2]|0)+1;q=1;return q|0}function thc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){uhc(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;uhc(a,d);return}function uhc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(Ioc(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(Ioc(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function vhc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[220886]|0)!=2){f[e>>2]=161028;f[e+4>>2]=176;b[e+8>>0]=0;DTb(883544,e);ZSb(e)}h=(f[220887]|0)+28|0;f[e>>2]=a;f[e+4>>2]=c;if(whc(h,e)|0){u=d;return}rTb(g,2,499170,324);e=mTb(g,501321)|0;oTb(d+36|0,nTb(e,f[a+4>>2]|0)|0);sTb(g);u=d;return}function whc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0;c=f[b>>2]|0;d=a+4|0;e=f[d>>2]|0;g=(e|0)==0;h=c;a:do if(!g){i=e+-1|0;j=(i&e|0)==0;if(!j)if(c>>>0<e>>>0)k=c;else k=(c>>>0)%(e>>>0)|0;else k=i&c;l=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!l)m=k;else{if(j){j=l;while(1){j=f[j>>2]|0;if(!j){m=k;break a}o=f[j+4>>2]|0;if(!((o|0)==(c|0)|(o&i|0)==(k|0))){m=k;break a}if((f[j+8>>2]|0)==(h|0)){p=0;break}}return p|0}else q=l;while(1){q=f[q>>2]|0;if(!q){m=k;break a}j=f[q+4>>2]|0;if((j|0)!=(c|0)){if(j>>>0<e>>>0)r=j;else r=(j>>>0)%(e>>>0)|0;if((r|0)!=(k|0)){m=k;break a}}if((f[q+8>>2]|0)==(h|0)){p=0;break}}return p|0}}else m=0;while(0);h=VDc(16)|0;q=b;b=f[q+4>>2]|0;k=h+8|0;f[k>>2]=f[q>>2];f[k+4>>2]=b;f[h+4>>2]=c;f[h>>2]=0;b=a+12|0;s=+(((f[b>>2]|0)+1|0)>>>0);t=+n[a+16>>2];do if(g|s>+(e>>>0)*t){k=(e>>>0<3|(e+-1&e|0)!=0)&1|e<<1;q=~~+X(+(s/t))>>>0;xhc(a,k>>>0<q>>>0?q:k);k=f[d>>2]|0;q=k+-1|0;if(!(q&k)){u=k;v=q&c;break}if(c>>>0<k>>>0){u=k;v=c}else{u=k;v=(c>>>0)%(k>>>0)|0}}else{u=e;v=m}while(0);m=(f[a>>2]|0)+(v<<2)|0;v=f[m>>2]|0;if(!v){e=a+8|0;f[h>>2]=f[e>>2];f[e>>2]=h;f[m>>2]=e;e=f[h>>2]|0;if(e|0){m=f[e+4>>2]|0;e=u+-1|0;if(e&u)if(m>>>0<u>>>0)w=m;else w=(m>>>0)%(u>>>0)|0;else w=m&e;x=(f[a>>2]|0)+(w<<2)|0;y=30}}else{f[h>>2]=f[v>>2];x=v;y=30}if((y|0)==30)f[x>>2]=h;f[b>>2]=(f[b>>2]|0)+1;p=1;return p|0}function xhc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=Jsc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){yhc(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=Jsc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;yhc(a,d);return}function yhc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{e=VDc(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)YDc(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if((f[o>>2]|0)==(f[u+8>>2]|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if((f[w>>2]|0)==(f[z+8>>2]|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function zhc(a,b){a=a|0;b=b|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,b)|0}function Ahc(a){a=a|0;return _i[f[(f[a>>2]|0)+20>>2]&1023](a)|0}function Bhc(a){a=a|0;return _i[f[(f[a>>2]|0)+24>>2]&1023](a)|0}function Chc(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Dhc(b);Ehc(a,b);return}function Dhc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=u;u=u+16|0;c=b;d=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;f[c>>2]=0;e=c+4|0;f[e>>2]=0;f[c+8>>2]=0;Ti[f[(f[d>>2]|0)+64>>2]&511](d,a,c);g=f[c>>2]|0;if((f[e>>2]|0)!=(g|0)){h=0;i=g;do{Ti[f[(f[d>>2]|0)+28>>2]&511](d,a,f[i+(h<<2)>>2]|0);h=h+1|0;i=f[c>>2]|0}while(h>>>0<(f[e>>2]|0)-i>>2>>>0)}i=Mi[f[(f[d>>2]|0)+12>>2]&1023](d,a)|0;if(f[i>>2]|0)ljc(i);i=f[c>>2]|0;if(!i){u=b;return}c=f[e>>2]|0;if((c|0)!=(i|0))f[e>>2]=c+(~((c+-4-i|0)>>>2)<<2);YDc(i);u=b;return}function Ehc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0;d=u;u=u+96|0;e=d+64|0;g=d+40|0;h=d+16|0;i=d;if((a|0)==(c|0)){rTb(g,3,501350,56);oTb(d+81|0,mTb(g,501443)|0);sTb(g)}mi[f[(f[a>>2]|0)+96>>2]&2047](e,a);g=f[e>>2]|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);if((f[e>>2]|0)!=(g|0)){rTb(h,3,501350,59);j=mTb(mTb(mTb(h,501475)|0,501529)|0,501573)|0;k=mTb(nTb(j,f[g+4>>2]|0)|0,501581)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);oTb(d+80|0,mTb(nTb(k,f[(f[e>>2]|0)+4>>2]|0)|0,517845)|0);sTb(h)}h=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;k=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;f[i>>2]=0;g=i+4|0;f[g>>2]=0;f[i+8>>2]=0;Ti[f[(f[h>>2]|0)+64>>2]&511](h,a,i);j=f[i>>2]|0;if((f[g>>2]|0)!=(j|0)){l=e+11|0;m=e+4|0;n=e+8|0;o=e+12|0;p=e+11|0;q=e+4|0;r=e+8|0;s=e+12|0;t=0;v=j;do{j=f[v+(t<<2)>>2]|0;a:do if((f[j+32>>2]|0)==3){w=hj[f[(f[h>>2]|0)+24>>2]&511](h,a,j)|0;if((w|0)>0){x=j+24|0;y=j+28|0;z=0;while(1){A=f[x>>2]|0;if(A|0?(f[A>>2]|0)!=2:0){f[e>>2]=78728;f[m>>2]=1737;b[n>>0]=0;f[o>>2]=j;DTb(A,e)}do switch(f[161216+(f[y>>2]<<2)>>2]|0){case 1:{A=f[(f[k>>2]|0)+260>>2]|0;B=hh[f[(f[h>>2]|0)+168>>2]&127](h,a,j,z)|0;ei[A&511](k,c,j,B);break}case 2:{B=f[(f[k>>2]|0)+264>>2]|0;A=hh[f[(f[h>>2]|0)+172>>2]&127](h,a,j,z)|0;gi[B&255](k,c,j,A,J);break}case 3:{A=f[(f[k>>2]|0)+268>>2]|0;B=hh[f[(f[h>>2]|0)+176>>2]&127](h,a,j,z)|0;ei[A&511](k,c,j,B);break}case 4:{B=f[(f[k>>2]|0)+272>>2]|0;A=hh[f[(f[h>>2]|0)+180>>2]&127](h,a,j,z)|0;gi[B&255](k,c,j,A,J);break}case 6:{A=f[(f[k>>2]|0)+276>>2]|0;C=+Ai[f[(f[h>>2]|0)+184>>2]&15](h,a,j,z);$h[A&63](k,c,j,C);break}case 5:{A=f[(f[k>>2]|0)+280>>2]|0;C=+Ai[f[(f[h>>2]|0)+188>>2]&15](h,a,j,z);$h[A&63](k,c,j,C);break}case 7:{A=f[(f[k>>2]|0)+284>>2]|0;B=hh[f[(f[h>>2]|0)+192>>2]&127](h,a,j,z)|0;ei[A&511](k,c,j,B);break}case 9:{B=f[(f[k>>2]|0)+288>>2]|0;gi[f[(f[h>>2]|0)+196>>2]&255](e,h,a,j,z);ei[B&511](k,c,j,e);if((b[l>>0]|0)<0)YDc(f[e>>2]|0);break}case 8:{B=f[(f[k>>2]|0)+292>>2]|0;A=hh[f[(f[h>>2]|0)+200>>2]&127](h,a,j,z)|0;ei[B&511](k,c,j,A);break}case 10:{A=hh[f[(f[k>>2]|0)+300>>2]&127](k,c,j,0)|0;B=f[(f[A>>2]|0)+76>>2]|0;D=hh[f[(f[h>>2]|0)+208>>2]&127](h,a,j,z)|0;mi[B&2047](A,D);break}default:{}}while(0);z=z+1|0;if((z|0)>=(w|0))break a}}}else{w=f[j+24>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[e>>2]=78728;f[q>>2]=1737;b[r>>0]=0;f[s>>2]=j;DTb(w,e)}do switch(f[161216+(f[j+28>>2]<<2)>>2]|0){case 1:{w=f[(f[k>>2]|0)+116>>2]|0;z=hj[f[(f[h>>2]|0)+68>>2]&511](h,a,j)|0;ei[w&511](k,c,j,z);break a;break}case 2:{z=f[(f[k>>2]|0)+120>>2]|0;w=hj[f[(f[h>>2]|0)+72>>2]&511](h,a,j)|0;gi[z&255](k,c,j,w,J);break a;break}case 3:{w=f[(f[k>>2]|0)+124>>2]|0;z=hj[f[(f[h>>2]|0)+76>>2]&511](h,a,j)|0;ei[w&511](k,c,j,z);break a;break}case 4:{z=f[(f[k>>2]|0)+128>>2]|0;w=hj[f[(f[h>>2]|0)+80>>2]&511](h,a,j)|0;gi[z&255](k,c,j,w,J);break a;break}case 6:{w=f[(f[k>>2]|0)+132>>2]|0;C=+Sh[f[(f[h>>2]|0)+84>>2]&31](h,a,j);$h[w&63](k,c,j,C);break a;break}case 5:{w=f[(f[k>>2]|0)+136>>2]|0;C=+Sh[f[(f[h>>2]|0)+88>>2]&31](h,a,j);$h[w&63](k,c,j,C);break a;break}case 7:{w=f[(f[k>>2]|0)+140>>2]|0;z=hj[f[(f[h>>2]|0)+92>>2]&511](h,a,j)|0;ei[w&511](k,c,j,z);break a;break}case 9:{z=f[(f[k>>2]|0)+144>>2]|0;ei[f[(f[h>>2]|0)+96>>2]&511](e,h,a,j);ei[z&511](k,c,j,e);if((b[p>>0]|0)<0)YDc(f[e>>2]|0);break a;break}case 8:{z=f[(f[k>>2]|0)+148>>2]|0;w=hj[f[(f[h>>2]|0)+100>>2]&511](h,a,j)|0;ei[z&511](k,c,j,w);break a;break}case 10:{w=hh[f[(f[k>>2]|0)+156>>2]&127](k,c,j,0)|0;z=f[(f[w>>2]|0)+76>>2]|0;y=hh[f[(f[h>>2]|0)+108>>2]&127](h,a,j,0)|0;mi[z&2047](w,y);break a;break}default:break a}while(0)}while(0);t=t+1|0;v=f[i>>2]|0}while(t>>>0<(f[g>>2]|0)-v>>2>>>0)}v=Mi[f[(f[k>>2]|0)+12>>2]&1023](k,c)|0;ojc(v,Mi[f[(f[h>>2]|0)+8>>2]&1023](h,a)|0);a=f[i>>2]|0;if(!a){u=d;return}i=f[g>>2]|0;if((i|0)!=(a|0))f[g>>2]=i+(~((i+-4-a|0)>>>2)<<2);YDc(a);u=d;return}function Fhc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;c=u;u=u+80|0;d=c+32|0;e=c+64|0;g=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);h=f[d>>2]|0;i=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;j=h+52|0;k=f[j>>2]|0;a:do if((k|0)>0){l=h+20|0;m=0;n=k;while(1){o=f[l>>2]|0;if((f[o+(m*88|0)+32>>2]|0)==2){if(!(hj[f[(f[i>>2]|0)+20>>2]&511](i,a,o+(m*88|0)|0)|0)){p=0;break}q=f[j>>2]|0}else q=n;m=m+1|0;if((m|0)>=(q|0))break a;else n=q}u=c;return p|0}while(0);f[e>>2]=0;q=e+4|0;f[q>>2]=0;f[e+8>>2]=0;Ti[f[(f[i>>2]|0)+64>>2]&511](i,a,e);j=f[e>>2]|0;k=j;if((f[q>>2]|0)==(j|0)){r=5;s=k}else{j=d+4|0;h=d+24|0;n=g+4|0;m=g+16|0;l=g+8|0;o=d+16|0;t=d+8|0;v=d+4|0;w=d+8|0;x=d+12|0;y=d+4|0;z=d+8|0;A=d+12|0;B=d+4|0;C=d+8|0;D=d+12|0;E=0;F=k;b:while(1){k=f[F+(E<<2)>>2]|0;G=k+24|0;H=f[G>>2]|0;if(H|0?(f[H>>2]|0)!=2:0){f[d>>2]=78728;f[B>>2]=1737;b[C>>0]=0;f[D>>2]=k;DTb(H,d)}H=k+28|0;do if((f[161216+(f[H>>2]<<2)>>2]|0)==10){I=f[G>>2]|0;if(I|0?(f[I>>2]|0)!=2:0){f[d>>2]=78728;f[y>>2]=1737;b[z>>0]=0;f[A>>2]=k;DTb(I,d)}if((f[H>>2]|0)==11?BYb(k)|0:0){I=(DYb(k)|0)+20|0;J=f[I>>2]|0;I=J+88|0;K=f[J+112>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[d>>2]=78728;f[v>>2]=1737;b[w>>0]=0;f[x>>2]=I;DTb(K,d)}if((f[161216+(f[J+116>>2]<<2)>>2]|0)!=10)break;J=hj[f[(f[i>>2]|0)+364>>2]&511](i,a,k)|0;if(Udc(J)|0){mbc(d,a,k);mbc(g,a,k);mi[f[(f[J>>2]|0)+24>>2]&2047](J,d);mi[f[(f[J>>2]|0)+28>>2]&2047](J,g);while(1){J=f[j>>2]|0;if(hj[f[(f[J>>2]|0)+20>>2]&511](J,d,g)|0){L=7;break}J=Odc(h)|0;if(!(_i[f[(f[J>>2]|0)+32>>2]&1023](J)|0)){L=1;break}J=f[j>>2]|0;mi[f[(f[J>>2]|0)+60>>2]&2047](J,d)}J=f[n>>2]|0;mi[f[(f[J>>2]|0)+52>>2]&2047](J,g);if((f[m>>2]|0)==9?(J=f[l>>2]|0,J|0):0){if((b[J+11>>0]|0)<0)YDc(f[J>>2]|0);YDc(J)}J=f[j>>2]|0;mi[f[(f[J>>2]|0)+52>>2]&2047](J,d);if((f[o>>2]|0)==9?(J=f[t>>2]|0,J|0):0){if((b[J+11>>0]|0)<0)YDc(f[J>>2]|0);YDc(J)}if((L|0)==7)break;else{M=L;break b}}}if((f[k+32>>2]|0)!=3){J=hh[f[(f[i>>2]|0)+108>>2]&127](i,a,k,0)|0;if(_i[f[(f[J>>2]|0)+32>>2]&1023](J)|0)break;else{M=1;break b}}J=hj[f[(f[i>>2]|0)+24>>2]&511](i,a,k)|0;if((J|0)>0){K=0;do{I=hh[f[(f[i>>2]|0)+208>>2]&127](i,a,k,K)|0;K=K+1|0;if(!(_i[f[(f[I>>2]|0)+32>>2]&1023](I)|0)){M=1;break b}}while((K|0)<(J|0))}}while(0);E=E+1|0;F=f[e>>2]|0;if(E>>>0>=(f[q>>2]|0)-F>>2>>>0){M=5;break}}r=M;s=f[e>>2]|0}e=(r|0)==5;if(s|0){r=f[q>>2]|0;if((r|0)!=(s|0))f[q>>2]=r+(~((r+-4-s|0)>>>2)<<2);YDc(s)}p=e;u=c;return p|0}function Ghc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+32|0;d=c+16|0;e=c;g=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;h=Mi[f[(f[g>>2]|0)+12>>2]&1023](g,a)|0;if(f[h>>2]|0)ljc(h);f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;Ti[f[(f[g>>2]|0)+64>>2]&511](g,a,e);i=f[h>>2]|0;j=f[e>>2]|0;k=j;if((i|0)==(j|0)){l=i;m=k}else{i=d+4|0;j=d+8|0;n=d+12|0;o=0;p=k;while(1){k=f[p+(o<<2)>>2]|0;q=f[k+24>>2]|0;if(q|0?(f[q>>2]|0)!=2:0){f[d>>2]=78728;f[i>>2]=1737;b[j>>0]=0;f[n>>2]=k;DTb(q,d)}do if((f[161216+(f[k+28>>2]<<2)>>2]|0)==10){if((f[k+32>>2]|0)!=3){q=hh[f[(f[g>>2]|0)+156>>2]&127](g,a,k,0)|0;Yi[f[(f[q>>2]|0)+80>>2]&2047](q);break}q=hj[f[(f[g>>2]|0)+24>>2]&511](g,a,k)|0;if((q|0)>0){r=0;do{s=hh[f[(f[g>>2]|0)+256>>2]&127](g,a,k,r)|0;Yi[f[(f[s>>2]|0)+80>>2]&2047](s);r=r+1|0}while((r|0)<(q|0))}}while(0);o=o+1|0;k=f[h>>2]|0;q=f[e>>2]|0;r=q;if(o>>>0>=k-q>>2>>>0){l=k;m=r;break}else p=r}}p=l;if(!m){u=c;return}if((p|0)!=(m|0))f[h>>2]=p+(~((p+-4-m|0)>>>2)<<2);YDc(m);u=c;return}function Hhc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+32|0;g=e+16|0;h=e;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);i=f[g>>2]|0;j=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;k=i+52|0;if((f[k>>2]|0)>0){l=i+20|0;i=d+4|0;m=d+8|0;n=g+11|0;o=0;do{p=f[l>>2]|0;if((f[p+(o*88|0)+32>>2]|0)==2?!(hj[f[(f[j>>2]|0)+20>>2]&511](j,a,p+(o*88|0)|0)|0):0){QJa(g,c,f[(f[l>>2]|0)+(o*88|0)>>2]|0);p=f[i>>2]|0;if((p|0)==(f[m>>2]|0))e1(d,g);else{fEc(p,g);f[i>>2]=(f[i>>2]|0)+12}if((b[n>>0]|0)<0)YDc(f[g>>2]|0)}o=o+1|0}while((o|0)<(f[k>>2]|0))}f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;Ti[f[(f[j>>2]|0)+64>>2]&511](j,a,h);o=f[k>>2]|0;n=f[h>>2]|0;i=n;if((o|0)==(n|0)){q=o;r=i}else{o=g+11|0;n=g+11|0;m=g+4|0;l=g+8|0;p=g+12|0;s=0;t=i;while(1){i=f[t+(s<<2)>>2]|0;v=f[i+24>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=78728;f[m>>2]=1737;b[l>>0]=0;f[p>>2]=i;DTb(v,g)}do if((f[161216+(f[i+28>>2]<<2)>>2]|0)==10){if((f[i+32>>2]|0)!=3){v=hh[f[(f[j>>2]|0)+108>>2]&127](j,a,i,0)|0;Ihc(g,c,i,-1);Hhc(v,g,d);if((b[n>>0]|0)<0)YDc(f[g>>2]|0);break}v=hj[f[(f[j>>2]|0)+24>>2]&511](j,a,i)|0;if((v|0)>0){w=0;do{x=hh[f[(f[j>>2]|0)+208>>2]&127](j,a,i,w)|0;Ihc(g,c,i,w);Hhc(x,g,d);if((b[o>>0]|0)<0)YDc(f[g>>2]|0);w=w+1|0}while((w|0)<(v|0))}}while(0);s=s+1|0;i=f[k>>2]|0;v=f[h>>2]|0;w=v;if(s>>>0>=i-v>>2>>>0){q=i;r=w;break}else t=w}}t=q;if(!r){u=e;return}if((t|0)!=(r|0))f[k>>2]=t+(~((t+-4-r|0)>>>2)<<2);YDc(r);u=e;return}function Ihc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;fEc(a,c);if(!(b[d+38>>0]|0)){c=f[d>>2]|0;i=b[c+11>>0]|0;j=i<<24>>24<0;tEc(a,j?f[c>>2]|0:c,j?f[c+4>>2]|0:i&255)|0}else{uEc(a,517847)|0;i=f[d+4>>2]|0;d=b[i+11>>0]|0;c=d<<24>>24<0;tEc(a,c?f[i>>2]|0:i,c?f[i+4>>2]|0:d&255)|0;uEc(a,517845)|0}if((e|0)==-1){uEc(a,518136)|0;u=g;return}uEc(a,501906)|0;emc(h,e);e=h+11|0;d=b[e>>0]|0;i=d<<24>>24<0;tEc(a,i?f[h>>2]|0:h,i?f[h+4>>2]|0:d&255)|0;if((b[e>>0]|0)<0)YDc(f[h>>2]|0);uEc(a,517894)|0;uEc(a,518136)|0;u=g;return}function Jhc(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;Khc(a,b,c,d,e,g,h,i,j,k,l,m);return}function Khc(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;o=u;u=u+128|0;p=o+76|0;q=o+40|0;r=o+64|0;s=o+24|0;t=o+121|0;v=o;w=o+120|0;f[p>>2]=d;f[p+4>>2]=e;f[p+8>>2]=g;f[p+12>>2]=h;f[p+16>>2]=i;f[p+20>>2]=j;f[p+24>>2]=k;f[p+28>>2]=l;f[p+32>>2]=m;f[p+36>>2]=n;f[p+40>>2]=0;n=0;m=0;a:while(1){b:do switch(b[c+m>>0]|0){case 0:{x=32;break a;break}case 36:{l=m+1|0;k=b[c+l>>0]|0;if((k+-48&255)<10){y=(k<<24>>24)+-48|0;j=f[(f[p+(y<<2)>>2]|0)+4>>2]|0;if((j|0)==-1){x=5;break a}else{z=l;A=j;break b}}else if(k<<24>>24==36){z=l;A=1;break b}else{x=20;break a}break}default:{z=m;A=1}}while(0);n=A+n|0;m=z+1|0}if((x|0)==5){rTb(q,2,501586,84);z=mTb(pTb(mTb(q,501681)|0,y)|0,501737)|0;y=0;m=d;while(1){if((f[m+4>>2]|0)==-1){B=y;break}d=y+1|0;m=f[p+(d<<2)>>2]|0;if(!m){B=d;break}else y=d}y=mTb(pTb(z,B)|0,501750)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;B=Mpc(c)|0;if(B>>>0>4294967279)dEc(s);if(B>>>0<11){b[s+11>>0]=B;if(!B)C=s;else{D=s;x=13}}else{z=B+16&-16;m=VDc(z)|0;f[s>>2]=m;f[s+8>>2]=z|-2147483648;f[s+4>>2]=B;D=m;x=13}if((x|0)==13){dJc(D|0,c|0,B|0)|0;C=D}b[C+B>>0]=0;_lc(r,s);oTb(t,mTb(nTb(y,r)|0,502535)|0);if((b[r+11>>0]|0)<0)YDc(f[r>>2]|0);if((b[s+11>>0]|0)<0)YDc(f[s>>2]|0);sTb(q);u=o;return}else if((x|0)==20){rTb(v,2,501586,97);q=mTb(v,501795)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;y=Mpc(c)|0;if(y>>>0>4294967279)dEc(s);if(y>>>0<11){b[s+11>>0]=y;if(!y)E=s;else{F=s;x=25}}else{t=y+16&-16;B=VDc(t)|0;f[s>>2]=B;f[s+8>>2]=t|-2147483648;f[s+4>>2]=y;F=B;x=25}if((x|0)==25){dJc(F|0,c|0,y|0)|0;E=F}b[E+y>>0]=0;_lc(r,s);oTb(w,mTb(nTb(q,r)|0,502535)|0);if((b[r+11>>0]|0)<0)YDc(f[r>>2]|0);if((b[s+11>>0]|0)<0)YDc(f[s>>2]|0);sTb(v);u=o;return}else if((x|0)==32){if(!n){u=o;return}x=a+11|0;v=b[x>>0]|0;if(v<<24>>24<0)G=f[a+4>>2]|0;else G=v&255;oEc(a,G+n|0,0);n=b[x>>0]|0;x=n<<24>>24<0;if(x)H=f[a+4>>2]|0;else H=n&255;do if(H)if(x){I=f[a>>2]|0;break}else{I=a;break}else I=0;while(0);a=0;x=I+G|0;c:while(1){G=b[c+a>>0]|0;d:do switch(G<<24>>24){case 0:{break c;break}case 36:{I=a+1|0;H=b[c+I>>0]|0;if((H+-48&255)<10){n=f[p+((H<<24>>24)+-48<<2)>>2]|0;v=n+4|0;dJc(x|0,f[n>>2]|0,f[v>>2]|0)|0;J=I;K=x+(f[v>>2]|0)|0;break d}if(H<<24>>24==36){b[x>>0]=36;J=I;K=x+1|0}else{J=a;K=x}break}default:{b[x>>0]=G;J=a;K=x+1|0}}while(0);a=J+1|0;x=K}u=o;return}}function Lhc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;d=u;u=u+16|0;c=d;if(!(b[e+38>>0]|0)){a=f[e+24>>2]|0;if(a|0?(f[a>>2]|0)!=2:0){f[c>>2]=78728;f[c+4>>2]=1737;b[c+8>>0]=0;f[c+12>>2]=e;DTb(a,c)}if((f[e+28>>2]|0)==10){a=DYb(e)|0;h=f[a>>2]|0;a=b[h+11>>0]|0;i=a<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,i?f[h>>2]|0:h,i?f[h+4>>2]|0:a&255);u=d;return}else{a=f[e>>2]|0;h=b[a+11>>0]|0;i=h<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,i?f[a>>2]|0:a,i?f[a+4>>2]|0:h&255);u=d;return}}Ti[f[(f[g>>2]|0)+8>>2]&511](g,501906,1);if(b[(f[(f[e+48>>2]|0)+16>>2]|0)+48>>0]|0){h=f[e+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[c>>2]=78728;f[c+4>>2]=1737;b[c+8>>0]=0;f[c+12>>2]=e;DTb(h,c)}if(((f[e+28>>2]|0)==11?(f[e+32>>2]|0)==1:0)?(c=f[e+56>>2]|0,(c|0)==(DYb(e)|0)):0){c=(DYb(e)|0)+4|0;h=f[c>>2]|0;c=b[h+11>>0]|0;a=c<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,a?f[h>>2]|0:h,a?f[h+4>>2]|0:c&255)}else j=10}else j=10;if((j|0)==10){j=f[e+4>>2]|0;e=b[j+11>>0]|0;c=e<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,c?f[j>>2]|0:j,c?f[j+4>>2]|0:e&255)}Ti[f[(f[g>>2]|0)+8>>2]&511](g,517894,1);u=d;return}function Mhc(a){a=a|0;return}function Nhc(a){a=a|0;YDc(a);return}function Ohc(a,b,c){a=a|0;b=b|0;c=c|0;a=f[(f[c>>2]|0)+8>>2]|0;if(b){Ti[a&511](c,519053,4);return}else{Ti[a&511](c,519047,5);return}}function Phc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=u;u=u+16|0;e=a;emc(e,c);c=e+11|0;g=b[c>>0]|0;h=g<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,h?f[e>>2]|0:e,h?f[e+4>>2]|0:g&255);if((b[c>>0]|0)>=0){u=a;return}YDc(f[e>>2]|0);u=a;return}function Qhc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=u;u=u+16|0;e=a;fmc(e,c);c=e+11|0;g=b[c>>0]|0;h=g<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,h?f[e>>2]|0:e,h?f[e+4>>2]|0:g&255);if((b[c>>0]|0)>=0){u=a;return}YDc(f[e>>2]|0);u=a;return}function Rhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;a=u;u=u+16|0;g=a;gmc(g,c,d);d=g+11|0;c=b[d>>0]|0;h=c<<24>>24<0;Ti[f[(f[e>>2]|0)+8>>2]&511](e,h?f[g>>2]|0:g,h?f[g+4>>2]|0:c&255);if((b[d>>0]|0)>=0){u=a;return}YDc(f[g>>2]|0);u=a;return}function Shc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;a=u;u=u+16|0;g=a;hmc(g,c,d);d=g+11|0;c=b[d>>0]|0;h=c<<24>>24<0;Ti[f[(f[e>>2]|0)+8>>2]&511](e,h?f[g>>2]|0:g,h?f[g+4>>2]|0:c&255);if((b[d>>0]|0)>=0){u=a;return}YDc(f[g>>2]|0);u=a;return}function Thc(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0;a=u;u=u+16|0;e=a;kmc(e,c);g=e+11|0;h=b[g>>0]|0;i=h<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,i?f[e>>2]|0:e,i?f[e+4>>2]|0:h&255);if((b[g>>0]|0)>=0){u=a;return}YDc(f[e>>2]|0);u=a;return}function Uhc(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0;a=u;u=u+16|0;e=a;imc(e,c);g=e+11|0;h=b[g>>0]|0;i=h<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,i?f[e>>2]|0:e,i?f[e+4>>2]|0:h&255);if((b[g>>0]|0)>=0){u=a;return}YDc(f[e>>2]|0);u=a;return}function Vhc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+16|0;e=a;Ti[f[(f[d>>2]|0)+8>>2]&511](d,501908,1);_lc(e,c);c=e+11|0;g=b[c>>0]|0;h=g<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,h?f[e>>2]|0:e,h?f[e+4>>2]|0:g&255);if((b[c>>0]|0)>=0){i=f[d>>2]|0;j=i+8|0;k=f[j>>2]|0;Ti[k&511](d,501908,1);u=a;return}YDc(f[e>>2]|0);i=f[d>>2]|0;j=i+8|0;k=f[j>>2]|0;Ti[k&511](d,501908,1);u=a;return}function Whc(a,b,c){a=a|0;b=b|0;c=c|0;Ti[f[(f[a>>2]|0)+36>>2]&511](a,b,c);return}function Xhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;c=b[d+11>>0]|0;a=c<<24>>24<0;Ti[f[(f[e>>2]|0)+8>>2]&511](e,a?f[d>>2]|0:d,a?f[d+4>>2]|0:c&255);return}function Yhc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;d=f[(f[g>>2]|0)+8>>2]|0;if(e){Ti[d&511](g,501898,3);return}else{Ti[d&511](g,501902,3);return}}function Zhc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;d=f[(f[g>>2]|0)+8>>2]|0;if(e){Ti[d&511](g,501842,2);return}else{Ti[d&511](g,501845,2);return}}function _hc(a){a=a|0;return}function $hc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+28|0;c=f[b>>2]|0;d=a+32|0;if((c|0)!=(d|0)){e=c;while(1){c=f[e+20>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[e+4>>2]|0;if(!c){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))i=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;j=f[h>>2]|0}while((f[j>>2]|0)!=(g|0));i=j}}else{h=c;while(1){j=f[h>>2]|0;if(!j)break;else h=j}i=h}if((i|0)==(d|0))break;else e=i}}aic(b,f[d>>2]|0);f[a+36>>2]=0;f[b>>2]=d;f[d>>2]=0;aic(b,0);b=f[a+24>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&2047](b);return}function aic(a,b){a=a|0;b=b|0;if(!b)return;else{aic(a,f[b>>2]|0);aic(a,f[b+4>>2]|0);YDc(b);return}}function bic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);h=f[g>>2]|0;i=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;j=f[h+4>>2]|0;h=Mpc(508057)|0;k=b[j+11>>0]|0;if((((h|0)==((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)?(EEc(j,0,-1,508057,h)|0)==0:0)?b[a+9>>0]|0:0)?cic(a,c,d)|0:0){u=e;return}f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;Ti[f[(f[i>>2]|0)+64>>2]&511](i,c,g);if(b[a+8>>0]|0)dic(f[g>>2]|0,f[h>>2]|0);j=f[g>>2]|0;k=j;if((f[h>>2]|0)==(j|0))l=k;else{j=0;m=k;while(1){eic(a,c,i,f[m+(j<<2)>>2]|0,d);j=j+1|0;k=f[g>>2]|0;n=k;if(j>>>0>=(f[h>>2]|0)-k>>2>>>0){l=n;break}else m=n}}if(!(b[a+7>>0]|0)){fic(a,Mi[f[(f[i>>2]|0)+8>>2]&1023](i,c)|0,d);o=f[g>>2]|0}else o=l;if(o|0){l=f[h>>2]|0;if((l|0)!=(o|0))f[h>>2]=l+(~((l+-4-o|0)>>>2)<<2);YDc(o)}u=e;return}function cic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+128|0;g=e+96|0;h=e+92|0;i=e+88|0;j=e+76|0;k=e+64|0;l=e+40|0;m=e+117|0;n=e+24|0;o=e;p=e+116|0;if(!(smc(c,h,i)|0)){q=0;u=e;return q|0}r=_i[f[(f[c>>2]|0)+92>>2]&1023](c)|0;ei[f[(f[r>>2]|0)+96>>2]&511](j,r,c,f[h>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;do if(rmc(j,k)|0){mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);h=mYb(f[(f[(f[g>>2]|0)+8>>2]|0)+8>>2]|0,k)|0;if(!h){rTb(l,1,502019,1820);oTb(m,mTb(nTb(mTb(l,502268)|0,j)|0,502280)|0);sTb(l);s=0;break}k9b(g);t=h9b(g,h)|0;h=_i[f[(f[t>>2]|0)+12>>2]&1023](t)|0;ei[f[(f[r>>2]|0)+96>>2]&511](n,r,c,f[i>>2]|0);if(KSb(h,n)|0){Ti[f[(f[d>>2]|0)+8>>2]&511](d,501906,1);t=b[j+11>>0]|0;v=t<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,v?f[j>>2]|0:j,v?f[j+4>>2]|0:t&255);Ti[f[(f[d>>2]|0)+8>>2]&511](d,517894,1);t=f[a+24>>2]|0;v=a+32|0;w=f[v>>2]|0;if(w){x=f[i>>2]|0;y=v;z=w;a:while(1){w=z;while(1){if((f[w+16>>2]|0)>>>0>=x>>>0)break;A=f[w+4>>2]|0;if(!A){B=y;break a}else w=A}z=f[w>>2]|0;if(!z){B=w;break}else y=w}if((B|0)!=(v|0)?x>>>0>=(f[B+16>>2]|0)>>>0:0)C=f[B+20>>2]|0;else C=t}else C=t;y=a+4|0;Fh[f[(f[C>>2]|0)+52>>2]&255](C,c,-1,0,(b[y>>0]|0)!=0,d);z=d+20|0;f[z>>2]=(f[z>>2]|0)+1;bic(a,h,d);gic(d);Fh[f[(f[C>>2]|0)+56>>2]&255](C,c,-1,0,(b[y>>0]|0)!=0,d);D=1}else{rTb(o,1,502019,1828);oTb(p,mTb(nTb(o,j)|0,502291)|0);sTb(o);D=0}if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);f9b(g);s=D}else s=0;while(0);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);if((b[j+11>>0]|0)<0)YDc(f[j>>2]|0);q=s;u=e;return q|0}
function Zxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=a+-8|0;h=d;while(1){i=h;b:while(1){j=i;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=5;break a;break}case 3:{m=9;break a;break}case 4:{m=27;break a;break}case 5:{m=28;break a;break}case 1:case 0:{m=107;break a;break}default:{}}if((k|0)<124){m=30;break a}o=i+(((l|0)/2|0)<<2)|0;do if((k|0)>3996){p=(l|0)/4|0;q=bya(i,i+(p<<2)|0,o,o+(p<<2)|0,e,c)|0}else{p=f[o>>2]|0;r=f[i>>2]|0;s=+n[p>>2];t=+n[r>>2];u=p;v=r;if(!(s<t))if(s==t)w=+n[p+4>>2]<+n[r+4>>2];else w=0;else w=1;x=f[e>>2]|0;y=+n[x>>2];z=x;if(!(y<s))if(y==s)A=+n[x+4>>2]<+n[p+4>>2];else A=0;else A=1;if(!w){if(!A){q=0;break}f[o>>2]=z;f[e>>2]=u;p=f[o>>2]|0;x=f[i>>2]|0;s=+n[p>>2];y=+n[x>>2];B=x;C=p;if(!(s<y)){if(!(s==y)){q=1;break}if(!(+n[p+4>>2]<+n[x+4>>2])){q=1;break}}f[i>>2]=C;f[o>>2]=B;q=2;break}if(A){f[i>>2]=z;f[e>>2]=v;q=1;break}f[i>>2]=u;f[o>>2]=v;u=f[e>>2]|0;y=+n[u>>2];z=u;if(!(y<t)){if(!(y==t)){q=1;break}if(!(+n[u+4>>2]<+n[r+4>>2])){q=1;break}}f[o>>2]=z;f[e>>2]=v;q=2}while(0);D=f[i>>2]|0;l=f[o>>2]|0;t=+n[D>>2];y=+n[l>>2];if(t<y){E=e;F=q;break}if(t==y?+n[D+4>>2]<+n[l+4>>2]:0){E=e;F=q;break}if((i|0)!=(g|0)){k=l+4|0;G=g;while(1){H=f[G>>2]|0;s=+n[H>>2];if(s<y){m=82;break b}if(s==y?+n[H+4>>2]<+n[k>>2]:0){m=82;break b}l=G+-4|0;if((i|0)==(l|0))break;else G=l}}k=i+4|0;l=f[e>>2]|0;y=+n[l>>2];v=l;do if(t<y)I=k;else{if(t==y?+n[D+4>>2]<+n[l+4>>2]:0){I=k;break}if((k|0)==(e|0)){m=107;break a}z=D+4|0;r=k;while(1){J=f[r>>2]|0;s=+n[J>>2];if(t<s)break;if(t==s?+n[z>>2]<+n[J+4>>2]:0)break;u=r+4|0;if((u|0)==(e|0)){m=107;break a}else r=u}f[r>>2]=v;f[e>>2]=J;I=r+4|0}while(0);if((I|0)==(e|0)){m=107;break a}else{K=e;L=I}while(1){v=f[i>>2]|0;k=f[L>>2]|0;t=+n[v>>2];y=+n[k>>2];c:do if(t<y)M=L;else{l=v+4|0;z=L;s=y;u=k;while(1){if(t==s?+n[l>>2]<+n[u+4>>2]:0){M=z;break c}B=z+4|0;u=f[B>>2]|0;s=+n[u>>2];if(t<s){M=B;break}else z=B}}while(0);k=v+4|0;r=K;while(1){z=r;r=r+-4|0;N=f[r>>2]|0;y=+n[N>>2];if(t<y){r=r;continue}if(!(t==y))break;if(!(+n[k>>2]<+n[N+4>>2]))break}if(M>>>0>=r>>>0){i=M;continue b}k=f[M>>2]|0;f[M>>2]=N;f[r>>2]=k;K=r;L=M+4|0}}if((m|0)==82){m=0;f[i>>2]=H;f[G>>2]=D;E=G;F=q+1|0}k=i+4|0;d:do if(k>>>0<E>>>0){v=o;z=E;u=k;l=F;while(1){B=f[v>>2]|0;t=+n[B>>2];C=B+4|0;B=u;while(1){O=f[B>>2]|0;y=+n[O>>2];if(!(y<t)){if(!(y==t))break;if(!(+n[O+4>>2]<+n[C>>2]))break}B=B+4|0}r=O;x=z+-4|0;p=f[x>>2]|0;y=+n[p>>2];e:do if(y<t)P=x;else{s=y;Q=p;R=x;while(1){if(s==t?+n[Q+4>>2]<+n[C>>2]:0){P=R;break e}S=R+-4|0;Q=f[S>>2]|0;s=+n[Q>>2];if(s<t){P=S;break}else R=S}}while(0);if(B>>>0>P>>>0){T=v;U=l;V=B;break d}f[B>>2]=f[P>>2];f[P>>2]=r;v=(v|0)==(B|0)?P:v;z=P;u=B+4|0;l=l+1|0}}else{T=o;U=F;V=k}while(0);do if((V|0)==(T|0))W=U;else{k=f[T>>2]|0;l=f[V>>2]|0;t=+n[k>>2];y=+n[l>>2];u=l;z=k;if(!(t<y)){if(!(t==y)){W=U;break}if(!(+n[k+4>>2]<+n[l+4>>2])){W=U;break}}f[V>>2]=z;f[T>>2]=u;W=U+1|0}while(0);if(!W){X=dya(i,V,c)|0;u=V+4|0;if(dya(u,a,c)|0){m=106;break}if(X){h=u;continue}}u=V;if((u-j|0)>=(b-u|0)){m=105;break}Zxa(i,V,c);h=V+4|0}if((m|0)==105){m=0;Zxa(V+4|0,a,c);d=i;a=V;continue}else if((m|0)==106){m=0;if(X){m=107;break}else{d=i;a=V;continue}}}if((m|0)==5){V=f[e>>2]|0;d=f[i>>2]|0;y=+n[V>>2];t=+n[d>>2];X=d;j=V;if(!(y<t)){if(!(y==t))return;if(!(+n[V+4>>2]<+n[d+4>>2]))return}f[i>>2]=j;f[e>>2]=X;return}else if((m|0)==9){X=i+4|0;j=f[X>>2]|0;d=f[i>>2]|0;t=+n[j>>2];y=+n[d>>2];V=j;W=d;if(!(t<y))if(t==y)Y=+n[j+4>>2]<+n[d+4>>2];else Y=0;else Y=1;U=f[e>>2]|0;s=+n[U>>2];T=U;if(!(s<t))if(s==t)Z=+n[U+4>>2]<+n[j+4>>2];else Z=0;else Z=1;if(!Y){if(!Z)return;f[X>>2]=T;f[e>>2]=V;Y=f[X>>2]|0;j=f[i>>2]|0;t=+n[Y>>2];s=+n[j>>2];U=j;F=Y;if(!(t<s)){if(!(t==s))return;if(!(+n[Y+4>>2]<+n[j+4>>2]))return}f[i>>2]=F;f[X>>2]=U;return}if(Z){f[i>>2]=T;f[e>>2]=W;return}f[i>>2]=V;f[X>>2]=W;V=f[e>>2]|0;s=+n[V>>2];T=V;if(!(s<y)){if(!(s==y))return;if(!(+n[V+4>>2]<+n[d+4>>2]))return}f[X>>2]=T;f[e>>2]=W;return}else if((m|0)==27){aya(i,i+4|0,i+8|0,e,c)|0;return}else if((m|0)==28){bya(i,i+4|0,i+8|0,i+12|0,e,c)|0;return}else if((m|0)==30){cya(i,a,c);return}else if((m|0)==107)return}function _xa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=(c|0)>(b|0)?1:-1;i=h+b|0;j=i+h|0;do if((b|0)!=(c|0)){k=f[a+(b<<2)>>2]|0;l=f[a+(c<<2)>>2]|0;if((f[k>>2]|0)==(f[l>>2]|0)?(f[k+4>>2]|0)==(f[l+4>>2]|0):0)break;f[d>>2]=b;l=d+4|0;f[l>>2]=i;k=d+8|0;f[k>>2]=j;m=h+c|0;a:do if((j|0)==(m|0))n=3;else{o=b;p=i;q=j;r=3;while(1){s=d+(r+-1<<2)|0;t=a+(o<<2)|0;u=f[a+(p<<2)>>2]|0;b:do if((o|0)!=(b|0)){v=u+4|0;w=q;while(1){x=f[v>>2]|0;y=f[a+(w<<2)>>2]|0;z=(f[y+4>>2]|0)-x|0;if((((z|0)>0&1)-(z>>>31)|0)!=(e|0))break;A=w+h|0;f[s>>2]=A;if((A|0)==(m|0)){n=r;break a}else w=A}v=f[u>>2]|0;A=f[t>>2]|0;B=v-(f[A>>2]|0)|0;C=x-(f[A+4>>2]|0)|0;A=(Y(C,(f[y>>2]|0)-v|0)|0)-(Y(B,z)|0)|0;if((C|B|0)==0?1:(((A|0)>0&1)-(A>>>31)|0)!=(g|0)){f[d+(r+-2<<2)>>2]=w;D=f[d+(r+-4<<2)>>2]|0;E=o;F=w;G=-1}else{H=p;I=w;J=15}}else{A=p;B=q;C=u;while(1){v=C+4|0;K=B;while(1){L=f[v>>2]|0;M=f[a+(K<<2)>>2]|0;N=(f[M+4>>2]|0)-L|0;if((((N|0)>0&1)-(N>>>31)|0)!=(e|0))break;O=K+h|0;f[s>>2]=O;if((O|0)==(m|0)){n=r;break a}else K=O}v=f[C>>2]|0;O=f[t>>2]|0;P=v-(f[O>>2]|0)|0;Q=L-(f[O+4>>2]|0)|0;O=(Y(Q,(f[M>>2]|0)-v|0)|0)-(Y(P,N)|0)|0;if(!((Q|P|0)==0?1:(((O|0)>0&1)-(O>>>31)|0)!=(g|0))){H=A;I=K;J=15;break b}f[l>>2]=K;O=K+h|0;f[k>>2]=O;if((O|0)==(m|0)){n=r;break a}else{A=K;B=O;C=M}}}while(0);if((J|0)==15){J=0;t=I+h|0;f[d+(r<<2)>>2]=t;D=H;E=I;F=t;G=1}t=r+G|0;if((F|0)==(m|0)){n=t;break}else{o=D;p=E;q=F;r=t}}}while(0);R=n+-1|0;return R|0}while(0);f[d>>2]=b;R=1;return R|0}function $xa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0;h=(c|0)>(b|0)?1:-1;i=h+b|0;j=i+h|0;do if((b|0)!=(c|0)){k=f[a+(b<<2)>>2]|0;l=f[a+(c<<2)>>2]|0;if(+n[k>>2]==+n[l>>2]?+n[k+4>>2]==+n[l+4>>2]:0)break;f[d>>2]=b;l=d+4|0;f[l>>2]=i;k=d+8|0;f[k>>2]=j;m=h+c|0;a:do if((j|0)==(m|0))o=3;else{p=b;q=i;r=j;s=3;while(1){t=d+(s+-1<<2)|0;u=a+(p<<2)|0;v=f[a+(q<<2)>>2]|0;w=+n[v+4>>2];b:do if((p|0)==(b|0)){x=q;y=r;z=w;A=v;while(1){B=y;while(1){C=f[a+(B<<2)>>2]|0;D=+n[C+4>>2];E=D-z;if(((E>0.0&1)-(E<0.0&1)|0)!=(e|0))break;F=B+h|0;f[t>>2]=F;if((F|0)==(m|0)){o=s;break a}else B=F}G=+n[A>>2];F=f[u>>2]|0;H=G-+n[F>>2];I=z-+n[F+4>>2];J=(+n[C>>2]-G)*I-E*H;if(((J>0.0&1)-(J<0.0&1)|0)==(g|0)?H!=0.0|I!=0.0:0){K=x;L=B;M=16;break b}f[l>>2]=B;F=B+h|0;f[k>>2]=F;if((F|0)==(m|0)){o=s;break a}else{x=B;y=F;z=D;A=C}}}else{A=r;while(1){N=f[a+(A<<2)>>2]|0;O=+n[N+4>>2]-w;if(((O>0.0&1)-(O<0.0&1)|0)!=(e|0))break;y=A+h|0;f[t>>2]=y;if((y|0)==(m|0)){o=s;break a}else A=y}z=+n[v>>2];y=f[u>>2]|0;I=z-+n[y>>2];H=w-+n[y+4>>2];J=(+n[N>>2]-z)*H-O*I;if(((J>0.0&1)-(J<0.0&1)|0)==(g|0)?I!=0.0|H!=0.0:0){K=q;L=A;M=16;break}f[d+(s+-2<<2)>>2]=A;P=f[d+(s+-4<<2)>>2]|0;Q=p;R=A;S=-1}while(0);if((M|0)==16){M=0;u=L+h|0;f[d+(s<<2)>>2]=u;P=K;Q=L;R=u;S=1}u=s+S|0;if((R|0)==(m|0)){o=u;break}else{p=P;q=Q;r=R;s=u}}}while(0);T=o+-1|0;return T|0}while(0);f[d>>2]=b;T=1;return T|0}function aya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[b>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h<i))if(h==i)l=+n[e+4>>2]<+n[g+4>>2];else l=0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o<h))if(o==h)q=+n[m+4>>2]<+n[e+4>>2];else q=0;else q=1;do if(!l)if(q){f[b>>2]=p;f[c>>2]=j;r=f[b>>2]|0;s=f[a>>2]|0;h=+n[r>>2];o=+n[s>>2];t=s;u=r;if(!(h<o)){if(!(h==o)){v=1;w=e;x=j;break}if(!(+n[r+4>>2]<+n[s+4>>2])){v=1;w=e;x=j;break}}f[a>>2]=u;f[b>>2]=t;t=f[c>>2]|0;v=2;w=t;x=t}else{v=0;w=m;x=p}else{if(q){f[a>>2]=p;f[c>>2]=k;v=1;w=g;x=k;break}f[a>>2]=j;f[b>>2]=k;t=f[c>>2]|0;o=+n[t>>2];u=t;if(!(o<i)){if(!(o==i)){v=1;w=t;x=u;break}if(!(+n[t+4>>2]<+n[g+4>>2])){v=1;w=t;x=u;break}}f[b>>2]=u;f[c>>2]=k;v=2;w=g;x=k}while(0);k=f[d>>2]|0;i=+n[k>>2];o=+n[w>>2];g=k;if(!(i<o)){if(!(i==o)){y=v;return y|0}if(!(+n[k+4>>2]<+n[w+4>>2])){y=v;return y|0}}f[c>>2]=g;f[d>>2]=x;x=v+1|0;d=f[c>>2]|0;g=f[b>>2]|0;o=+n[d>>2];i=+n[g>>2];w=g;k=d;if(!(o<i)){if(!(o==i)){y=x;return y|0}if(!(+n[d+4>>2]<+n[g+4>>2])){y=x;return y|0}}f[b>>2]=k;f[c>>2]=w;w=v+2|0;c=f[b>>2]|0;k=f[a>>2]|0;i=+n[c>>2];o=+n[k>>2];x=k;g=c;if(!(i<o)){if(!(i==o)){y=w;return y|0}if(!(+n[c+4>>2]<+n[k+4>>2])){y=w;return y|0}}f[a>>2]=g;f[b>>2]=x;y=v+3|0;return y|0}function bya(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0;h=aya(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=+n[g>>2];k=+n[i>>2];l=i;m=g;if(!(j<k)){if(!(j==k)){o=h;return o|0}if(!(+n[g+4>>2]<+n[i+4>>2])){o=h;return o|0}}f[d>>2]=m;f[e>>2]=l;l=h+1|0;e=f[d>>2]|0;m=f[c>>2]|0;k=+n[e>>2];j=+n[m>>2];i=m;g=e;if(!(k<j)){if(!(k==j)){o=l;return o|0}if(!(+n[e+4>>2]<+n[m+4>>2])){o=l;return o|0}}f[c>>2]=g;f[d>>2]=i;i=h+2|0;d=f[c>>2]|0;g=f[b>>2]|0;j=+n[d>>2];k=+n[g>>2];l=g;m=d;if(!(j<k)){if(!(j==k)){o=i;return o|0}if(!(+n[d+4>>2]<+n[g+4>>2])){o=i;return o|0}}f[b>>2]=m;f[c>>2]=l;l=h+3|0;c=f[b>>2]|0;m=f[a>>2]|0;k=+n[c>>2];j=+n[m>>2];i=m;g=c;if(!(k<j)){if(!(k==j)){o=l;return o|0}if(!(+n[c+4>>2]<+n[m+4>>2])){o=l;return o|0}}f[a>>2]=g;f[b>>2]=i;o=h+4|0;return o|0}function cya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h<i))if(h==i)l=+n[e+4>>2]<+n[g+4>>2];else l=0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o<h))if(o==h)q=+n[m+4>>2]<+n[e+4>>2];else q=0;else q=1;do if(!l)if(q){f[d>>2]=p;f[c>>2]=j;if(!(o<i)){if(!(o==i)){r=j;s=e;break}if(!(+n[m+4>>2]<+n[g+4>>2])){r=j;s=e;break}}f[a>>2]=p;f[d>>2]=k;r=j;s=e}else{r=p;s=m}else{if(q){f[a>>2]=p;f[c>>2]=k;r=k;s=g;break}f[a>>2]=j;f[d>>2]=k;if(!(o<i)){if(!(o==i)){r=p;s=m;break}if(!(+n[m+4>>2]<+n[g+4>>2])){r=p;s=m;break}}f[d>>2]=p;f[c>>2]=k;r=k;s=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{t=g;u=c;v=s;w=r}while(1){r=f[t>>2]|0;i=+n[r>>2];o=+n[v>>2];s=r;if(!(i<o)){if(i==o?(c=r+4|0,+n[c>>2]<+n[v+4>>2]):0){x=c;y=25}}else{x=r+4|0;y=25}if((y|0)==25){y=0;f[t>>2]=w;a:do if((u|0)==(a|0))z=u;else{r=u;c=u;while(1){g=c;c=r+-4|0;k=f[c>>2]|0;o=+n[k>>2];p=k;if(!(i<o)){if(!(i==o)){z=g;break a}if(!(+n[x>>2]<+n[k+4>>2])){z=g;break a}}f[g>>2]=p;if((c|0)==(a|0)){z=c;break}else r=c}}while(0);f[z>>2]=s}c=t+4|0;if((c|0)==(b|0))break;r=f[t>>2]|0;p=t;t=c;v=r;w=r;u=p}return}function dya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=g;k=e;if(!(h<i)){if(!(h==i)){l=1;return l|0}if(!(+n[e+4>>2]<+n[g+4>>2])){l=1;return l|0}}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;i=+n[k>>2];h=+n[g>>2];e=k;m=g;if(!(i<h))if(i==h)o=+n[k+4>>2]<+n[g+4>>2];else o=0;else o=1;p=f[d>>2]|0;q=+n[p>>2];r=p;if(!(q<i))if(q==i)s=+n[p+4>>2]<+n[k+4>>2];else s=0;else s=1;if(!o){if(!s){l=1;return l|0}f[j>>2]=r;f[d>>2]=e;o=f[j>>2]|0;k=f[a>>2]|0;i=+n[o>>2];q=+n[k>>2];p=k;t=o;if(!(i<q)){if(!(i==q)){l=1;return l|0}if(!(+n[o+4>>2]<+n[k+4>>2])){l=1;return l|0}}f[a>>2]=t;f[j>>2]=p;l=1;return l|0}if(s){f[a>>2]=r;f[d>>2]=m;l=1;return l|0}f[a>>2]=e;f[j>>2]=m;e=f[d>>2]|0;q=+n[e>>2];r=e;if(!(q<h)){if(!(q==h)){l=1;return l|0}if(!(+n[e+4>>2]<+n[g+4>>2])){l=1;return l|0}}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{aya(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{bya(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;h=+n[d>>2];q=+n[r>>2];j=d;g=r;if(!(h<q))if(h==q)u=+n[d+4>>2]<+n[r+4>>2];else u=0;else u=1;e=f[c>>2]|0;i=+n[e>>2];s=e;if(!(i<h))if(i==h)v=+n[e+4>>2]<+n[d+4>>2];else v=0;else v=1;do if(!u)if(v){f[m>>2]=s;f[c>>2]=j;if(!(i<q)){if(!(i==q)){w=d;break}if(!(+n[e+4>>2]<+n[r+4>>2])){w=d;break}}f[a>>2]=s;f[m>>2]=g;w=d}else w=e;else{if(v){f[a>>2]=s;f[c>>2]=g;w=r;break}f[a>>2]=j;f[m>>2]=g;if(!(i<q)){if(!(i==q)){w=e;break}if(!(+n[e+4>>2]<+n[r+4>>2])){w=e;break}}f[m>>2]=s;f[c>>2]=g;w=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){x=1;y=0}else{g=r;s=0;m=c;e=w;while(1){j=f[g>>2]|0;q=+n[j>>2];i=+n[e>>2];v=j;if(!(q<i))if(q==i?(d=j+4|0,+n[d>>2]<+n[e+4>>2]):0){z=d;A=49}else B=s;else{z=j+4|0;A=49}if((A|0)==49){A=0;f[g>>2]=f[m>>2];b:do if((m|0)==(a|0))C=m;else{j=m;d=m;while(1){u=d;d=j+-4|0;p=f[d>>2]|0;i=+n[p>>2];t=p;if(!(q<i)){if(!(q==i)){C=u;break b}if(!(+n[z>>2]<+n[p+4>>2])){C=u;break b}}f[u>>2]=t;if((d|0)==(a|0)){C=d;break}else j=d}}while(0);f[C>>2]=v;d=s+1|0;if((d|0)==8){x=0;y=(g+4|0)==(b|0);break a}else B=d}d=g+4|0;if((d|0)==(b|0)){x=1;y=0;break a}j=f[g>>2]|0;t=g;g=d;s=B;e=j;m=t}}while(0);l=y|x;return l|0}}return 0}function eya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[b>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=e;k=g;if((h|0)>=(i|0))if((h|0)==(i|0))l=(f[e+4>>2]|0)<(f[g+4>>2]|0);else l=0;else l=1;m=f[c>>2]|0;n=f[m>>2]|0;o=m;if((n|0)>=(h|0))if((n|0)==(h|0))p=(f[m+4>>2]|0)<(f[e+4>>2]|0);else p=0;else p=1;do if(!l)if(p){f[b>>2]=o;f[c>>2]=j;h=f[b>>2]|0;n=f[a>>2]|0;q=f[h>>2]|0;r=f[n>>2]|0;s=n;t=h;if((q|0)>=(r|0)){if((q|0)!=(r|0)){u=1;v=e;w=j;break}if((f[h+4>>2]|0)>=(f[n+4>>2]|0)){u=1;v=e;w=j;break}}f[a>>2]=t;f[b>>2]=s;s=f[c>>2]|0;u=2;v=s;w=s}else{u=0;v=m;w=o}else{if(p){f[a>>2]=o;f[c>>2]=k;u=1;v=g;w=k;break}f[a>>2]=j;f[b>>2]=k;s=f[c>>2]|0;t=f[s>>2]|0;n=s;if((t|0)>=(i|0)){if((t|0)!=(i|0)){u=1;v=s;w=n;break}if((f[s+4>>2]|0)>=(f[g+4>>2]|0)){u=1;v=s;w=n;break}}f[b>>2]=n;f[c>>2]=k;u=2;v=g;w=k}while(0);k=f[d>>2]|0;g=f[k>>2]|0;i=f[v>>2]|0;j=k;if((g|0)>=(i|0)){if((g|0)!=(i|0)){x=u;return x|0}if((f[k+4>>2]|0)>=(f[v+4>>2]|0)){x=u;return x|0}}f[c>>2]=j;f[d>>2]=w;w=u+1|0;d=f[c>>2]|0;j=f[b>>2]|0;v=f[d>>2]|0;k=f[j>>2]|0;i=j;g=d;if((v|0)>=(k|0)){if((v|0)!=(k|0)){x=w;return x|0}if((f[d+4>>2]|0)>=(f[j+4>>2]|0)){x=w;return x|0}}f[b>>2]=g;f[c>>2]=i;i=u+2|0;c=f[b>>2]|0;g=f[a>>2]|0;w=f[c>>2]|0;j=f[g>>2]|0;d=g;k=c;if((w|0)>=(j|0)){if((w|0)!=(j|0)){x=i;return x|0}if((f[c+4>>2]|0)>=(f[g+4>>2]|0)){x=i;return x|0}}f[a>>2]=k;f[b>>2]=d;x=u+3|0;return x|0}function fya(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=eya(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=f[g>>2]|0;k=f[i>>2]|0;l=i;m=g;if((j|0)>=(k|0)){if((j|0)!=(k|0)){n=h;return n|0}if((f[g+4>>2]|0)>=(f[i+4>>2]|0)){n=h;return n|0}}f[d>>2]=m;f[e>>2]=l;l=h+1|0;e=f[d>>2]|0;m=f[c>>2]|0;i=f[e>>2]|0;g=f[m>>2]|0;k=m;j=e;if((i|0)>=(g|0)){if((i|0)!=(g|0)){n=l;return n|0}if((f[e+4>>2]|0)>=(f[m+4>>2]|0)){n=l;return n|0}}f[c>>2]=j;f[d>>2]=k;k=h+2|0;d=f[c>>2]|0;j=f[b>>2]|0;l=f[d>>2]|0;m=f[j>>2]|0;e=j;g=d;if((l|0)>=(m|0)){if((l|0)!=(m|0)){n=k;return n|0}if((f[d+4>>2]|0)>=(f[j+4>>2]|0)){n=k;return n|0}}f[b>>2]=g;f[c>>2]=e;e=h+3|0;c=f[b>>2]|0;g=f[a>>2]|0;k=f[c>>2]|0;j=f[g>>2]|0;d=g;m=c;if((k|0)>=(j|0)){if((k|0)!=(j|0)){n=e;return n|0}if((f[c+4>>2]|0)>=(f[g+4>>2]|0)){n=e;return n|0}}f[a>>2]=m;f[b>>2]=d;n=h+4|0;return n|0}function gya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=e;k=g;if((h|0)>=(i|0))if((h|0)==(i|0))l=(f[e+4>>2]|0)<(f[g+4>>2]|0);else l=0;else l=1;m=f[c>>2]|0;n=f[m>>2]|0;o=m;if((n|0)>=(h|0))if((n|0)==(h|0))p=(f[m+4>>2]|0)<(f[e+4>>2]|0);else p=0;else p=1;do if(!l)if(p){f[d>>2]=o;f[c>>2]=j;if((n|0)>=(i|0)){if((n|0)!=(i|0)){q=j;r=e;break}if((f[m+4>>2]|0)>=(f[g+4>>2]|0)){q=j;r=e;break}}f[a>>2]=o;f[d>>2]=k;q=j;r=e}else{q=o;r=m}else{if(p){f[a>>2]=o;f[c>>2]=k;q=k;r=g;break}f[a>>2]=j;f[d>>2]=k;if((n|0)>=(i|0)){if((n|0)!=(i|0)){q=o;r=m;break}if((f[m+4>>2]|0)>=(f[g+4>>2]|0)){q=o;r=m;break}}f[d>>2]=o;f[c>>2]=k;q=k;r=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{s=g;t=c;u=r;v=q}while(1){q=f[s>>2]|0;r=f[q>>2]|0;c=f[u>>2]|0;g=q;if((r|0)>=(c|0)){if((r|0)==(c|0)?(c=q+4|0,(f[c>>2]|0)<(f[u+4>>2]|0)):0){w=c;x=25}}else{w=q+4|0;x=25}if((x|0)==25){x=0;f[s>>2]=v;a:do if((t|0)==(a|0))y=t;else{q=t;c=t;while(1){k=c;c=q+-4|0;o=f[c>>2]|0;d=f[o>>2]|0;m=o;if((r|0)>=(d|0)){if((r|0)!=(d|0)){y=k;break a}if((f[w>>2]|0)>=(f[o+4>>2]|0)){y=k;break a}}f[k>>2]=m;if((c|0)==(a|0)){y=c;break}else q=c}}while(0);f[y>>2]=g}r=s+4|0;if((r|0)==(b|0))break;c=f[s>>2]|0;q=s;s=r;u=c;v=c;t=q}return}function hya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=g;k=e;if((h|0)>=(i|0)){if((h|0)!=(i|0)){l=1;return l|0}if((f[e+4>>2]|0)>=(f[g+4>>2]|0)){l=1;return l|0}}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;e=f[k>>2]|0;i=f[g>>2]|0;h=k;m=g;if((e|0)>=(i|0))if((e|0)==(i|0))n=(f[k+4>>2]|0)<(f[g+4>>2]|0);else n=0;else n=1;o=f[d>>2]|0;p=f[o>>2]|0;q=o;if((p|0)>=(e|0))if((p|0)==(e|0))r=(f[o+4>>2]|0)<(f[k+4>>2]|0);else r=0;else r=1;if(!n){if(!r){l=1;return l|0}f[j>>2]=q;f[d>>2]=h;n=f[j>>2]|0;k=f[a>>2]|0;o=f[n>>2]|0;e=f[k>>2]|0;p=k;s=n;if((o|0)>=(e|0)){if((o|0)!=(e|0)){l=1;return l|0}if((f[n+4>>2]|0)>=(f[k+4>>2]|0)){l=1;return l|0}}f[a>>2]=s;f[j>>2]=p;l=1;return l|0}if(r){f[a>>2]=q;f[d>>2]=m;l=1;return l|0}f[a>>2]=h;f[j>>2]=m;h=f[d>>2]|0;q=f[h>>2]|0;r=h;if((q|0)>=(i|0)){if((q|0)!=(i|0)){l=1;return l|0}if((f[h+4>>2]|0)>=(f[g+4>>2]|0)){l=1;return l|0}}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{eya(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{fya(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;j=f[d>>2]|0;g=f[r>>2]|0;h=d;i=r;if((j|0)>=(g|0))if((j|0)==(g|0))t=(f[d+4>>2]|0)<(f[r+4>>2]|0);else t=0;else t=1;q=f[c>>2]|0;p=f[q>>2]|0;s=q;if((p|0)>=(j|0))if((p|0)==(j|0))u=(f[q+4>>2]|0)<(f[d+4>>2]|0);else u=0;else u=1;do if(!t)if(u){f[m>>2]=s;f[c>>2]=h;if((p|0)>=(g|0)){if((p|0)!=(g|0)){v=d;break}if((f[q+4>>2]|0)>=(f[r+4>>2]|0)){v=d;break}}f[a>>2]=s;f[m>>2]=i;v=d}else v=q;else{if(u){f[a>>2]=s;f[c>>2]=i;v=r;break}f[a>>2]=h;f[m>>2]=i;if((p|0)>=(g|0)){if((p|0)!=(g|0)){v=q;break}if((f[q+4>>2]|0)>=(f[r+4>>2]|0)){v=q;break}}f[m>>2]=s;f[c>>2]=i;v=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){w=1;x=0}else{i=r;s=0;m=c;q=v;while(1){g=f[i>>2]|0;p=f[g>>2]|0;h=f[q>>2]|0;u=g;if((p|0)>=(h|0))if((p|0)==(h|0)?(h=g+4|0,(f[h>>2]|0)<(f[q+4>>2]|0)):0){y=h;z=49}else A=s;else{y=g+4|0;z=49}if((z|0)==49){z=0;f[i>>2]=f[m>>2];b:do if((m|0)==(a|0))B=m;else{g=m;h=m;while(1){d=h;h=g+-4|0;t=f[h>>2]|0;j=f[t>>2]|0;k=t;if((p|0)>=(j|0)){if((p|0)!=(j|0)){B=d;break b}if((f[y>>2]|0)>=(f[t+4>>2]|0)){B=d;break b}}f[d>>2]=k;if((h|0)==(a|0)){B=h;break}else g=h}}while(0);f[B>>2]=u;p=s+1|0;if((p|0)==8){w=0;x=(i+4|0)==(b|0);break a}else A=p}p=i+4|0;if((p|0)==(b|0)){w=1;x=0;break a}h=f[i>>2]|0;g=i;i=p;s=A;q=h;m=g}}while(0);l=x|w;return l|0}}return 0}function iya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0;e=u;u=u+208|0;g=e+144|0;h=e+88|0;i=e+72|0;j=e;k=e+16|0;do if((d$(a)|0)==65536){l=f[a+4>>2]|0;f[g>>2]=f[l>>2];m=g+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=g+8|0;f[o>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];f[g+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[g+36>>2]=p;f[g+40>>2]=o;o=g+48|0;q=g+44|0;f[q>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[m>>2]=0;ZS(g,l);break}}else a$(g,a,-1);while(0);a=pT(g,2,4,1)|0;if((a|0)<=-1){f[h>>2]=0;f[h+4>>2]=0;r=tT(h,12)|0;s=287373;t=r+12|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,h,287386,287230,274)}if((a|0)>=4){do if((d$(c)|0)==65536){l=f[c+4>>2]|0;f[h>>2]=f[l>>2];m=h+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=h+8|0;f[o>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];q=f[l+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=o;o=h+48|0;p=h+44|0;f[p>>2]=o;f[o>>2]=0;f[h+52>>2]=0;if(q|0){o=q+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[p>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[m>>2]=0;ZS(h,l);break}}else a$(h,c,-1);while(0);c=pT(h,1,4,1)|0;if((c|0)<=0){f[i>>2]=0;f[i+4>>2]=0;r=tT(i,11)|0;s=287403;t=r+11|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,i,287386,287230,284)}l=f[g+16>>2]|0;m=h+16|0;n=f[m>>2]|0;o=h+44|0;f[i>>2]=0;p=i+4|0;f[p>>2]=0;f[i+8>>2]=0;if((c|0)>=3){q=f[n+4>>2]|0;v=f[n>>2]|0;w=f[n+8>>2]|0;x=(((w|0)>(q|0)&1)+((q|0)>(v|0)&1)+((v|0)>(w|0)&1)|0)!=2;w=c+-1|0;q=f[n+((x?0:w)<<2)>>2]|0;if(!((q|0)>-1&(q|0)<(a|0))){f[j>>2]=0;f[j+4>>2]=0;r=tT(j,29)|0;s=287415;t=r+29|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,287386,287230,300)}y=j+4|0;z=j+8|0;A=j+12|0;B=i+8|0;a:do if(x){C=0;D=q;while(1){E=D;D=f[n+(w-C<<2)>>2]|0;if(!((D|0)>-1&(D|0)<(a|0)))break;F=f[l+(E<<3)>>2]|0;G=f[l+(E<<3)+4>>2]|0;H=(f[l+(D<<3)>>2]|0)-F|0;I=+(H|0);J=(f[l+(D<<3)+4>>2]|0)-G|0;K=+(J|0);if(!(J|H))N=0.0;else N=1.0/+M(+(I*I+K*K));H=E+1|0;J=(H|0)<(a|0)?H:0;if((J|0)!=(D|0)){H=0;O=0.0;P=-1;Q=J;do{R=N*+L(+(I*+((f[l+(Q<<3)+4>>2]|0)-G|0)-K*+((f[l+(Q<<3)>>2]|0)-F|0)));J=R>O;P=J?Q:P;O=J?R:O;H=H|J;J=Q+1|0;Q=(J|0)<(a|0)?J:0}while((Q|0)!=(D|0));if(H){Q=nrc(O*256.0)|0;f[j>>2]=E;f[y>>2]=D;f[z>>2]=P;f[A>>2]=Q;Q=f[p>>2]|0;if((Q|0)==(f[B>>2]|0))axa(i,j);else{f[Q>>2]=E;f[Q+4>>2]=f[y>>2];f[Q+8>>2]=f[z>>2];f[Q+12>>2]=f[A>>2];f[p>>2]=Q+16}}}C=C+1|0;if((c|0)<=(C|0))break a}f[j>>2]=0;S=j+4|0;f[S>>2]=0;T=tT(j,29)|0;r=T;s=287445;t=r+29|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,287386,287230,305)}else{if((v|0)>-1&(v|0)<(a|0)){U=0;V=q;W=v}else{f[j>>2]=0;S=j+4|0;f[S>>2]=0;T=tT(j,29)|0;r=T;s=287445;t=r+29|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,287386,287230,305)}while(1){C=f[l+(V<<3)>>2]|0;D=f[l+(V<<3)+4>>2]|0;Q=(f[l+(W<<3)>>2]|0)-C|0;K=+(Q|0);F=(f[l+(W<<3)+4>>2]|0)-D|0;I=+(F|0);if(!(F|Q))X=0.0;else X=1.0/+M(+(K*K+I*I));Q=V+1|0;F=(Q|0)<(a|0)?Q:0;if((F|0)!=(W|0)){Q=0;R=0.0;G=-1;J=F;do{Y=X*+L(+(K*+((f[l+(J<<3)+4>>2]|0)-D|0)-I*+((f[l+(J<<3)>>2]|0)-C|0)));F=Y>R;G=F?J:G;R=F?Y:R;Q=Q|F;F=J+1|0;J=(F|0)<(a|0)?F:0}while((J|0)!=(W|0));if(Q){J=nrc(R*256.0)|0;f[j>>2]=V;f[y>>2]=W;f[z>>2]=G;f[A>>2]=J;J=f[p>>2]|0;if((J|0)==(f[B>>2]|0))axa(i,j);else{f[J>>2]=V;f[J+4>>2]=f[y>>2];f[J+8>>2]=f[z>>2];f[J+12>>2]=f[A>>2];f[p>>2]=J+16}}}U=U+1|0;if((c|0)<=(U|0))break a;J=f[n+(U<<2)>>2]|0;if(!((J|0)>-1&(J|0)<(a|0)))break;else{C=W;W=J;V=C}}f[j>>2]=0;S=j+4|0;f[S>>2]=0;T=tT(j,29)|0;r=T;s=287445;t=r+29|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,287386,287230,305)}while(0);f[k>>2]=1124024348;j=k+4|0;f[j>>2]=2;s=k+8|0;r=f[p>>2]|0;t=f[i>>2]|0;T=r-t|0;f[s>>2]=T>>4;f[k+12>>2]=1;S=k+16|0;V=k+40|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;f[S+16>>2]=0;f[S+20>>2]=0;f[V>>2]=s;s=k+48|0;W=k+44|0;f[W>>2]=s;f[s>>2]=0;a=k+52|0;f[a>>2]=0;U=t;if((U|0)!=(r|0)){f[a>>2]=16;f[s>>2]=16;f[S>>2]=U;f[k+20>>2]=U;U=t+T|0;f[k+24>>2]=U;f[k+28>>2]=U}h_(k,d);U=k+36|0;T=f[U>>2]|0;if(T|0?(t=T+12|0,T=f[t>>2]|0,f[t>>2]=T+-1,(T|0)==1):0)_S(k);f[U>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[j>>2]|0)>0){S=f[V>>2]|0;V=0;do{f[S+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[j>>2]|0))}j=f[W>>2]|0;if((j|0)!=(s|0))g0(j)}else u$(d);j=f[i>>2]|0;if(j|0){i=f[p>>2]|0;if((i|0)!=(j|0))f[p>>2]=i+(~((i+-16-j|0)>>>4)<<4);YDc(j)}j=h+36|0;i=f[j>>2]|0;if(i|0?(p=i+12|0,i=f[p>>2]|0,f[p>>2]=i+-1,(i|0)==1):0)_S(h);f[j>>2]=0;j=h+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){m=f[h+40>>2]|0;i=0;do{f[m+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)!=(h+48|0))g0(j)}else u$(d);d=g+36|0;j=f[d>>2]|0;if(j|0?(h=j+12|0,j=f[h>>2]|0,f[h>>2]=j+-1,(j|0)==1):0)_S(g);f[d>>2]=0;d=g+16|0;j=g+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[g+40>>2]|0;h=0;do{f[d+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)==(g+48|0)){u=e;return}g0(j);u=e;return}function jya(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0;c=u;u=u+64|0;d=c+8|0;e=c;do if((d$(a)|0)==65536){g=f[a+4>>2]|0;f[d>>2]=f[g>>2];h=d+4|0;i=g+4|0;f[h>>2]=f[i>>2];j=d+8|0;f[j>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[d+36>>2]=k;f[d+40>>2]=j;j=d+48|0;l=d+44|0;f[l>>2]=j;f[j>>2]=0;f[d+52>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[g+44>>2]|0;j=f[l>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];break}else{f[h>>2]=0;ZS(d,g);break}}else a$(d,a,-1);while(0);a=pT(d,2,-1,1)|0;g=f[d>>2]&7;if((a|0)<=-1){f[e>>2]=0;m=e+4|0;f[m>>2]=0;o=tT(e,50)|0;p=o;q=287300;r=p+50|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,e,287475,287230,392)}h=(g|0)==4;if((g|1|0)!=5){f[e>>2]=0;m=e+4|0;f[m>>2]=0;o=tT(e,50)|0;p=o;q=287300;r=p+50|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-215,e,287475,287230,392)}a:do if(a){e=f[d+16>>2]|0;if(h){q=((a<<1)+-2|0)%(a|0)|0;p=a+-1|0;r=f[e+(p<<3)>>2]|0;o=f[e+(p<<3)+4>>2]|0;p=r-(f[e+(q<<3)>>2]|0)|0;m=o-(f[e+(q<<3)+4>>2]|0)|0;q=0;g=0;i=r;r=o;while(1){o=i;i=f[e+(g<<3)>>2]|0;j=r;r=f[e+(g<<3)+4>>2]|0;l=p;p=i-o|0;o=m;m=r-j|0;j=Y(p,o)|0;o=Y(m,l)|0;q=((o|0)>(j|0)?1:(o|0)<(j|0)?2:3)|q;g=g+1|0;if((q|0)==3){t=0;break a}if((g|0)>=(a|0)){t=1;break}}}else{g=((a<<1)+-2|0)%(a|0)|0;q=a+-1|0;m=f[e+(q<<3)>>2]|0;p=f[e+(q<<3)+4>>2]|0;v=(f[s>>2]=p,+n[s>>2])-+n[e+(g<<3)+4>>2];w=(f[s>>2]=m,+n[s>>2])-+n[e+(g<<3)>>2];x=v;g=0;q=0;r=m;m=p;while(1){p=r;r=f[e+(q<<3)>>2]|0;i=m;m=f[e+(q<<3)+4>>2]|0;v=(f[s>>2]=r,+n[s>>2]);y=w;w=v-(f[s>>2]=p,+n[s>>2]);v=(f[s>>2]=m,+n[s>>2]);z=x;x=v-(f[s>>2]=i,+n[s>>2]);v=z*w;z=y*x;g=(z>v?1:z<v?2:3)|g;q=q+1|0;if((g|0)==3){t=0;break a}if((q|0)>=(a|0)){t=1;break}}}}else t=0;while(0);a=d+36|0;h=f[a>>2]|0;if(h|0?(q=h+12|0,h=f[q>>2]|0,f[q>>2]=h+-1,(h|0)==1):0)_S(d);f[a>>2]=0;a=d+16|0;h=d+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[d+40>>2]|0;q=0;do{f[a+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}h=f[d+44>>2]|0;if((h|0)==(d+48|0)){u=c;return t|0}g0(h);u=c;return t|0}function kya(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!((c|0)!=0&(d|0)!=0&(e|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,45)|0;k=287491;l=j+45|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));lya(-215,h,287537,47)}m=f[c>>2]|0;if((((m&-65536|0)==1111621632?(n=f[c+24>>2]|0,(n|0)>0):0)?(f[c+20>>2]|0)>0:0)?f[c+16>>2]|0:0){if((m&4088|0)==0&(n|0)==2){T0(c,h,2,0)|0;o=h}else o=c;c=f[o>>2]|0;h=c&4095;if((c&4094|0)!=12){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,87)|0;k=287589;l=j+87|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));lya(-210,i,287537,63)}n=f[o+24>>2]|0;if((n|0)!=1)if((c&16384|0)==0?1:(f[o+20>>2]|0)!=1){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,75)|0;j=q;k=287677;l=j+75|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));lya(-5,i,287537,68)}else{r=1;s=a&28672;t=h|s;v=c>>>3;w=v&511;x=w+1|0;y=c<<1;z=y&14;A=47696>>>z;B=A&3;C=x<<B;D=o+16|0;E=f[D>>2]|0;F=Y(r,n)|0;s7(t,88,C,E,F,d,e)|0;u=g;return d|0}if(!(c&16384)){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,75)|0;j=q;k=287677;l=j+75|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));lya(-5,i,287537,68)}r=f[o+20>>2]|0;s=a&28672;t=h|s;v=c>>>3;w=v&511;x=w+1|0;y=c<<1;z=y&14;A=47696>>>z;B=A&3;C=x<<B;D=o+16|0;E=f[D>>2]|0;F=Y(r,n)|0;s7(t,88,C,E,F,d,e)|0;u=g;return d|0}f[i>>2]=0;f[i+4>>2]=0;j=tT(i,33)|0;k=287555;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));lya(-5,i,287537,54);return 0}function lya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,287753,d);return}function mya(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=VDc(136)|0;r0(c);f[c>>2]=61052;p[c+8>>3]=b;f[c+16>>2]=d;f[c+20>>2]=e;f[c+24>>2]=1124007936;e=c+32|0;d=c+64|0;g=c+28|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[d>>2]=e;e=c+72|0;f[c+68>>2]=e;f[e>>2]=0;f[c+76>>2]=0;f[c+80>>2]=1124007936;e=c+88|0;d=c+120|0;g=c+84|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[d>>2]=e;e=c+128|0;f[c+124>>2]=e;f[e>>2]=0;f[c+132>>2]=0;e=VDc(16)|0;d=e+4|0;f[d>>2]=1;f[e>>2]=61116;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;Yi[f[(f[e>>2]|0)+8>>2]&2047](e);return}function nya(a){a=a|0;YDc(a);return}function oya(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pya(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=61052;b=a+80|0;c=a+116|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+96|0;b=a+84|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+120>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+124>>2]|0;if((b|0)!=(a+128|0))g0(b);b=a+24|0;d=a+60|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+40|0;b=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+64>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){j0(a);return}g0(b);j0(a);return}function qya(a){a=a|0;pya(a);YDc(a);return}function rya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;e=u;u=u+256|0;g=e+240|0;h=e+56|0;i=e+232|0;j=e+224|0;k=e+216|0;l=e+208|0;m=e+144|0;o=e+80|0;q=e;r=e+72|0;s=e+152|0;t=e+88|0;if(c$(c,-1)|0?(c$(c,-1)|0)!=2:0){f[g>>2]=0;f[g+4>>2]=0;v=tT(g,49)|0;w=287902;x=v+49|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));xya(-215,g,351)}y=(c$(c,-1)|0)==0;z=y?256:65536;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;b$(i,c,-1);y=a+16|0;if(!((f[i>>2]|0)%(f[y>>2]|0)|0)){b$(j,c,-1);i=a+20|0;A=f[i>>2]|0;if(!((f[j+4>>2]|0)%(A|0)|0)){b$(k,c,-1);j=f[k>>2]|0;k=f[y>>2]|0;b$(l,c,-1);B=(f[l+4>>2]|0)/(f[i>>2]|0)|0;l=c;C=f[l+4>>2]|0;D=h;f[D>>2]=f[l>>2];f[D+4>>2]=C;f[h+8>>2]=f[c+8>>2];E=f[c+12>>2]|0;F=(j|0)/(k|0)|0;G=B}else{H=i;I=A;J=8}}else{A=a+20|0;H=A;I=f[A>>2]|0;J=8}if((J|0)==8){J=a+24|0;A=g+8|0;f[A>>2]=0;f[A+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=J;b$(m,c,-1);A=f[m+4>>2]|0;m=f[H>>2]|0;i=f[y>>2]|0;b$(o,c,-1);B=f[o>>2]|0;o=f[y>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[q+28>>2]=0;q_(c,g,0,I-((A|0)%(m|0)|0)|0,0,i-((B|0)%(o|0)|0)|0,4,q);o=f[a+64>>2]|0;B=(f[o+4>>2]|0)/(f[y>>2]|0)|0;i=(f[o>>2]|0)/(f[H>>2]|0)|0;f[h>>2]=16842752;f[h+4>>2]=J;f[h+8>>2]=0;E=0;F=B;G=i}f[h+12>>2]=E;E=Y(G,F)|0;K=+(z+-1|0)/+(E|0);L=+p[a+8>>3];if(L>0.0){i=~~(L*+(E|0)/+(z|0));M=(i|0)>1?i:1}else M=0;do if((d$(c)|0)==65536){i=f[c+4>>2]|0;f[q>>2]=f[i>>2];E=q+4|0;B=i+4|0;f[E>>2]=f[B>>2];J=q+8|0;f[J>>2]=f[i+8>>2];f[q+12>>2]=f[i+12>>2];f[q+16>>2]=f[i+16>>2];f[q+20>>2]=f[i+20>>2];f[q+24>>2]=f[i+24>>2];f[q+28>>2]=f[i+28>>2];f[q+32>>2]=f[i+32>>2];H=f[i+36>>2]|0;f[q+36>>2]=H;o=q+40|0;f[o>>2]=J;J=q+48|0;m=q+44|0;f[m>>2]=J;f[J>>2]=0;f[q+52>>2]=0;if(H|0){J=H+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[B>>2]|0)<3){B=f[i+44>>2]|0;J=f[m>>2]|0;f[J>>2]=f[B>>2];f[J+4>>2]=f[B+4>>2];N=o;O=q;break}else{f[E>>2]=0;ZS(q,i);N=o;O=q;break}}else{a$(q,c,-1);N=q+40|0;O=q}while(0);o=f[N>>2]|0;i=f[o>>2]|0;f[r>>2]=f[o+4>>2];f[r+4>>2]=i;v$(d,r,f[O>>2]&4095,-1,0,0);do if((d$(d)|0)==65536){r=f[d+4>>2]|0;f[s>>2]=f[r>>2];i=s+4|0;o=r+4|0;f[i>>2]=f[o>>2];E=s+8|0;f[E>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];B=f[r+36>>2]|0;f[s+36>>2]=B;f[s+40>>2]=E;E=s+48|0;J=s+44|0;f[J>>2]=E;f[E>>2]=0;f[s+52>>2]=0;if(B|0){E=B+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[o>>2]|0)<3){o=f[r+44>>2]|0;E=f[J>>2]|0;f[E>>2]=f[o>>2];f[E+4>>2]=f[o+4>>2];break}else{f[i>>2]=0;ZS(s,r);break}}else a$(s,d,-1);while(0);do if((d$(h)|0)==65536){d=f[h+4>>2]|0;f[t>>2]=f[d>>2];r=t+4|0;i=d+4|0;f[r>>2]=f[i>>2];o=t+8|0;f[o>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];E=f[d+36>>2]|0;f[t+36>>2]=E;f[t+40>>2]=o;o=t+48|0;J=t+44|0;f[J>>2]=o;f[o>>2]=0;f[t+52>>2]=0;if(E|0){o=E+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[i>>2]|0)<3){i=f[d+44>>2]|0;o=f[J>>2]|0;f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];break}else{f[r>>2]=0;ZS(t,d);break}}else a$(t,h,-1);while(0);h=a+80|0;d=f[y>>2]|0;r=a+20|0;i=f[r>>2]|0;o=Y(i,d)|0;d=(c$(c,-1)|0)&4095;i=a+84|0;if(!(((((f[i>>2]|0)<3?(f[a+88>>2]|0)==(o|0):0)?(f[a+92>>2]|0)==(z|0):0)?(f[h>>2]&4095|0)==(d|0):0)?(f[a+96>>2]|0)!=0:0)){f[g>>2]=o;f[g+4>>2]=z;XS(h,2,g,d)}if(!(c$(c,-1)|0)){d=VDc(136)|0;f[d>>2]=61136;z=d+4|0;f[z>>2]=f[t>>2];o=d+8|0;J=t+4|0;E=f[J>>2]|0;f[o>>2]=E;B=d+12|0;f[B>>2]=f[t+8>>2];f[d+16>>2]=f[t+12>>2];f[d+20>>2]=f[t+16>>2];f[d+24>>2]=f[t+20>>2];f[d+28>>2]=f[t+24>>2];f[d+32>>2]=f[t+28>>2];f[d+36>>2]=f[t+32>>2];m=f[t+36>>2]|0;f[d+40>>2]=m;f[d+44>>2]=B;B=d+52|0;H=d+48|0;f[H>>2]=B;f[B>>2]=0;f[d+56>>2]=0;if(!m)P=E;else{E=m+12|0;f[E>>2]=(f[E>>2]|0)+1;P=f[J>>2]|0}if((P|0)<3){P=f[t+44>>2]|0;J=f[H>>2]|0;f[J>>2]=f[P>>2];f[J+4>>2]=f[P+4>>2]}else{f[o>>2]=0;ZS(z,t)}z=d+60|0;f[z>>2]=f[h>>2];o=d+64|0;P=f[i>>2]|0;f[o>>2]=P;J=d+68|0;f[J>>2]=f[a+88>>2];f[d+72>>2]=f[a+92>>2];f[d+76>>2]=f[a+96>>2];f[d+80>>2]=f[a+100>>2];f[d+84>>2]=f[a+104>>2];f[d+88>>2]=f[a+108>>2];f[d+92>>2]=f[a+112>>2];H=f[a+116>>2]|0;f[d+96>>2]=H;f[d+100>>2]=J;J=d+108|0;E=d+104|0;f[E>>2]=J;f[J>>2]=0;f[d+112>>2]=0;if(!H)Q=P;else{P=H+12|0;f[P>>2]=(f[P>>2]|0)+1;Q=f[i>>2]|0}if((Q|0)<3){Q=f[a+124>>2]|0;P=f[E>>2]|0;f[P>>2]=f[Q>>2];f[P+4>>2]=f[Q+4>>2]}else{f[o>>2]=0;ZS(z,h)}f[d+116>>2]=F;f[d+120>>2]=G;f[d+124>>2]=f[y>>2];f[d+128>>2]=M;n[d+132>>2]=K;z=VDc(16)|0;o=z+4|0;f[o>>2]=1;f[z>>2]=61156;f[z+8>>2]=d;Q=z;P=d;f[o>>2]=(f[o>>2]|0)+1;d=f[o>>2]|0;f[o>>2]=d+-1;if((d|0)==1){Yi[f[(f[z>>2]|0)+8>>2]&2047](z);R=Q;S=P}else{R=Q;S=P}}else{if((c$(c,-1)|0)!=2){f[g>>2]=0;f[g+4>>2]=0;v=tT(g,16)|0;w=287952;x=v+16|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));xya(-5,g,416)}w=VDc(136)|0;f[w>>2]=61176;v=w+4|0;f[v>>2]=f[t>>2];x=w+8|0;P=t+4|0;Q=f[P>>2]|0;f[x>>2]=Q;z=w+12|0;f[z>>2]=f[t+8>>2];f[w+16>>2]=f[t+12>>2];f[w+20>>2]=f[t+16>>2];f[w+24>>2]=f[t+20>>2];f[w+28>>2]=f[t+24>>2];f[w+32>>2]=f[t+28>>2];f[w+36>>2]=f[t+32>>2];d=f[t+36>>2]|0;f[w+40>>2]=d;f[w+44>>2]=z;z=w+52|0;o=w+48|0;f[o>>2]=z;f[z>>2]=0;f[w+56>>2]=0;if(!d)T=Q;else{Q=d+12|0;f[Q>>2]=(f[Q>>2]|0)+1;T=f[P>>2]|0}if((T|0)<3){T=f[t+44>>2]|0;P=f[o>>2]|0;f[P>>2]=f[T>>2];f[P+4>>2]=f[T+4>>2]}else{f[x>>2]=0;ZS(v,t)}v=w+60|0;f[v>>2]=f[h>>2];x=w+64|0;T=f[i>>2]|0;f[x>>2]=T;P=w+68|0;f[P>>2]=f[a+88>>2];f[w+72>>2]=f[a+92>>2];f[w+76>>2]=f[a+96>>2];f[w+80>>2]=f[a+100>>2];f[w+84>>2]=f[a+104>>2];f[w+88>>2]=f[a+108>>2];f[w+92>>2]=f[a+112>>2];o=f[a+116>>2]|0;f[w+96>>2]=o;f[w+100>>2]=P;P=w+108|0;Q=w+104|0;f[Q>>2]=P;f[P>>2]=0;f[w+112>>2]=0;if(!o)U=T;else{T=o+12|0;f[T>>2]=(f[T>>2]|0)+1;U=f[i>>2]|0}if((U|0)<3){U=f[a+124>>2]|0;T=f[Q>>2]|0;f[T>>2]=f[U>>2];f[T+4>>2]=f[U+4>>2]}else{f[x>>2]=0;ZS(v,h)}f[w+116>>2]=F;f[w+120>>2]=G;f[w+124>>2]=f[y>>2];f[w+128>>2]=M;n[w+132>>2]=K;M=VDc(16)|0;v=M+4|0;f[v>>2]=1;f[M>>2]=61196;f[M+8>>2]=w;x=M;U=w;f[v>>2]=(f[v>>2]|0)+1;w=f[v>>2]|0;f[v>>2]=w+-1;if((w|0)==1){Yi[f[(f[M>>2]|0)+8>>2]&2047](M);R=x;S=U}else{R=x;S=U}}U=Y(f[r>>2]|0,f[y>>2]|0)|0;f[g>>2]=0;f[g+4>>2]=U;y8(g,S,-1.0);do if(!(c$(c,-1)|0)){S=VDc(1268)|0;f[S>>2]=61216;U=S+4|0;f[U>>2]=f[O>>2];x=S+8|0;M=q+4|0;w=f[M>>2]|0;f[x>>2]=w;v=S+12|0;T=q+8|0;f[v>>2]=f[T>>2];Q=q+12|0;f[S+16>>2]=f[Q>>2];f[S+20>>2]=f[q+16>>2];f[S+24>>2]=f[q+20>>2];f[S+28>>2]=f[q+24>>2];f[S+32>>2]=f[q+28>>2];f[S+36>>2]=f[q+32>>2];o=f[q+36>>2]|0;f[S+40>>2]=o;f[S+44>>2]=v;v=S+52|0;P=S+48|0;f[P>>2]=v;f[v>>2]=0;f[S+56>>2]=0;if(!o)V=w;else{w=o+12|0;f[w>>2]=(f[w>>2]|0)+1;V=f[M>>2]|0}if((V|0)<3){M=f[q+44>>2]|0;w=f[P>>2]|0;f[w>>2]=f[M>>2];f[w+4>>2]=f[M+4>>2]}else{f[x>>2]=0;ZS(U,q)}U=S+60|0;f[U>>2]=f[s>>2];x=S+64|0;M=s+4|0;w=f[M>>2]|0;f[x>>2]=w;P=S+68|0;f[P>>2]=f[s+8>>2];f[S+72>>2]=f[s+12>>2];f[S+76>>2]=f[s+16>>2];f[S+80>>2]=f[s+20>>2];f[S+84>>2]=f[s+24>>2];f[S+88>>2]=f[s+28>>2];f[S+92>>2]=f[s+32>>2];o=f[s+36>>2]|0;f[S+96>>2]=o;f[S+100>>2]=P;P=S+108|0;v=S+104|0;f[v>>2]=P;f[P>>2]=0;f[S+112>>2]=0;if(!o)W=w;else{w=o+12|0;f[w>>2]=(f[w>>2]|0)+1;W=f[M>>2]|0}if((W|0)<3){M=f[s+44>>2]|0;w=f[v>>2]|0;f[w>>2]=f[M>>2];f[w+4>>2]=f[M+4>>2]}else{f[x>>2]=0;ZS(U,s)}U=S+116|0;f[U>>2]=f[h>>2];x=S+120|0;M=f[i>>2]|0;f[x>>2]=M;w=S+124|0;f[w>>2]=f[a+88>>2];f[S+128>>2]=f[a+92>>2];f[S+132>>2]=f[a+96>>2];f[S+136>>2]=f[a+100>>2];f[S+140>>2]=f[a+104>>2];f[S+144>>2]=f[a+108>>2];f[S+148>>2]=f[a+112>>2];v=f[a+116>>2]|0;f[S+152>>2]=v;f[S+156>>2]=w;w=S+164|0;o=S+160|0;f[o>>2]=w;f[w>>2]=0;f[S+168>>2]=0;if(!v)X=M;else{M=v+12|0;f[M>>2]=(f[M>>2]|0)+1;X=f[i>>2]|0}if((X|0)<3){M=f[a+124>>2]|0;v=f[o>>2]|0;f[v>>2]=f[M>>2];f[v+4>>2]=f[M+4>>2]}else{f[x>>2]=0;ZS(U,h)}f[S+172>>2]=F;f[S+176>>2]=G;U=S+180|0;x=f[y>>2]|0;f[U>>2]=x;f[S+184>>2]=f[r>>2];M=S+188|0;v=S+196|0;f[M>>2]=v;o=f[Q>>2]|0;Q=o<<2;f[S+192>>2]=Q;if(Q>>>0>264){P=XDc(Q>>>0>1073741823?-1:Q<<2)|0;f[M>>2]=P;Z=P}else Z=v;f[S+1252>>2]=Z;v=Z+(o<<2)|0;f[S+1256>>2]=v;P=v+(o<<2)|0;f[S+1260>>2]=P;M=P+(o<<2)|0;f[S+1264>>2]=M;Q=f[w>>2]|0;K=1.0/+(F|0);a:do if((o|0)>0){w=o+-1|0;d=0;z=x;while(1){L=K*+(d|0)+-.5;E=~~L;H=E-(+(E|0)>L&1)|0;E=H+1|0;_=L-+(H|0);n[P+(d<<2)>>2]=_;n[M+(d<<2)>>2]=1.0-_;J=z+-1|0;m=Y((H|0)>0?H:0,Q)|0;f[Z+(d<<2)>>2]=m;m=Y((J|0)<(E|0)?J:E,Q)|0;f[v+(d<<2)>>2]=m;if((d|0)==(w|0))break a;d=d+1|0;z=f[U>>2]|0}}while(0);U=VDc(16)|0;v=U+4|0;f[v>>2]=1;f[U>>2]=61236;f[U+8>>2]=S;Q=U;M=S;f[v>>2]=(f[v>>2]|0)+1;P=f[v>>2]|0;f[v>>2]=P+-1;if((P|0)==1){Yi[f[(f[U>>2]|0)+8>>2]&2047](U);$=T;aa=Q;ba=M}else{$=T;aa=Q;ba=M}}else{if((c$(c,-1)|0)!=2){$=q+8|0;aa=0;ba=0;break}M=VDc(1268)|0;f[M>>2]=61256;Q=M+4|0;f[Q>>2]=f[O>>2];U=M+8|0;P=q+4|0;v=f[P>>2]|0;f[U>>2]=v;x=M+12|0;o=q+8|0;f[x>>2]=f[o>>2];z=q+12|0;f[M+16>>2]=f[z>>2];f[M+20>>2]=f[q+16>>2];f[M+24>>2]=f[q+20>>2];f[M+28>>2]=f[q+24>>2];f[M+32>>2]=f[q+28>>2];f[M+36>>2]=f[q+32>>2];d=f[q+36>>2]|0;f[M+40>>2]=d;f[M+44>>2]=x;x=M+52|0;w=M+48|0;f[w>>2]=x;f[x>>2]=0;f[M+56>>2]=0;if(!d)ca=v;else{v=d+12|0;f[v>>2]=(f[v>>2]|0)+1;ca=f[P>>2]|0}if((ca|0)<3){P=f[q+44>>2]|0;v=f[w>>2]|0;f[v>>2]=f[P>>2];f[v+4>>2]=f[P+4>>2]}else{f[U>>2]=0;ZS(Q,q)}Q=M+60|0;f[Q>>2]=f[s>>2];U=M+64|0;P=s+4|0;v=f[P>>2]|0;f[U>>2]=v;w=M+68|0;f[w>>2]=f[s+8>>2];f[M+72>>2]=f[s+12>>2];f[M+76>>2]=f[s+16>>2];f[M+80>>2]=f[s+20>>2];f[M+84>>2]=f[s+24>>2];f[M+88>>2]=f[s+28>>2];f[M+92>>2]=f[s+32>>2];d=f[s+36>>2]|0;f[M+96>>2]=d;f[M+100>>2]=w;w=M+108|0;x=M+104|0;f[x>>2]=w;f[w>>2]=0;f[M+112>>2]=0;if(!d)da=v;else{v=d+12|0;f[v>>2]=(f[v>>2]|0)+1;da=f[P>>2]|0}if((da|0)<3){P=f[s+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[P>>2];f[v+4>>2]=f[P+4>>2]}else{f[U>>2]=0;ZS(Q,s)}Q=M+116|0;f[Q>>2]=f[h>>2];U=M+120|0;P=f[i>>2]|0;f[U>>2]=P;v=M+124|0;f[v>>2]=f[a+88>>2];f[M+128>>2]=f[a+92>>2];f[M+132>>2]=f[a+96>>2];f[M+136>>2]=f[a+100>>2];f[M+140>>2]=f[a+104>>2];f[M+144>>2]=f[a+108>>2];f[M+148>>2]=f[a+112>>2];x=f[a+116>>2]|0;f[M+152>>2]=x;f[M+156>>2]=v;v=M+164|0;d=M+160|0;f[d>>2]=v;f[v>>2]=0;f[M+168>>2]=0;if(!x)ea=P;else{P=x+12|0;f[P>>2]=(f[P>>2]|0)+1;ea=f[i>>2]|0}if((ea|0)<3){P=f[a+124>>2]|0;x=f[d>>2]|0;f[x>>2]=f[P>>2];f[x+4>>2]=f[P+4>>2]}else{f[U>>2]=0;ZS(Q,h)}f[M+172>>2]=F;f[M+176>>2]=G;Q=M+180|0;U=f[y>>2]|0;f[Q>>2]=U;f[M+184>>2]=f[r>>2];P=M+188|0;x=M+196|0;f[P>>2]=x;d=f[z>>2]|0;z=d<<2;f[M+192>>2]=z;if(z>>>0>264){w=XDc(z>>>0>1073741823?-1:z<<2)|0;f[P>>2]=w;fa=w}else fa=x;f[M+1252>>2]=fa;x=fa+(d<<2)|0;f[M+1256>>2]=x;w=x+(d<<2)|0;f[M+1260>>2]=w;P=w+(d<<2)|0;f[M+1264>>2]=P;z=(f[v>>2]|0)>>>1;K=1.0/+(F|0);b:do if((d|0)>0){v=d+-1|0;m=0;E=U;while(1){_=K*+(m|0)+-.5;J=~~_;H=J-(+(J|0)>_&1)|0;J=H+1|0;L=_-+(H|0);n[w+(m<<2)>>2]=L;n[P+(m<<2)>>2]=1.0-L;B=E+-1|0;A=Y((H|0)>0?H:0,z)|0;f[fa+(m<<2)>>2]=A;A=Y((B|0)<(J|0)?B:J,z)|0;f[x+(m<<2)>>2]=A;if((m|0)==(v|0))break b;m=m+1|0;E=f[Q>>2]|0}}while(0);Q=VDc(16)|0;x=Q+4|0;f[x>>2]=1;f[Q>>2]=61276;f[Q+8>>2]=M;z=Q;P=M;f[x>>2]=(f[x>>2]|0)+1;w=f[x>>2]|0;f[x>>2]=w+-1;if((w|0)==1){Yi[f[(f[Q>>2]|0)+8>>2]&2047](Q);$=o;aa=z;ba=P}else{$=o;aa=z;ba=P}}while(0);fa=f[$>>2]|0;f[g>>2]=0;f[g+4>>2]=fa;y8(g,ba,-1.0);ba=aa;if(aa|0?(g=ba+4|0,fa=f[g>>2]|0,f[g>>2]=fa+-1,(fa|0)==1):0)Yi[f[(f[aa>>2]|0)+8>>2]&2047](ba);ba=R;aa=ba+4|0;fa=f[aa>>2]|0;f[aa>>2]=fa+-1;if((fa|0)==1)Yi[f[(f[R>>2]|0)+8>>2]&2047](ba);ba=t+36|0;R=f[ba>>2]|0;if(R|0?(fa=R+12|0,R=f[fa>>2]|0,f[fa>>2]=R+-1,(R|0)==1):0)_S(t);f[ba>>2]=0;ba=t+16|0;R=t+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[R>>2]|0)>0){ba=f[t+40>>2]|0;fa=0;do{f[ba+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[R>>2]|0))}R=f[t+44>>2]|0;if((R|0)!=(t+48|0))g0(R);R=s+36|0;t=f[R>>2]|0;if(t|0?(fa=t+12|0,t=f[fa>>2]|0,f[fa>>2]=t+-1,(t|0)==1):0)_S(s);f[R>>2]=0;R=s+16|0;t=s+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[t>>2]|0)>0){R=f[s+40>>2]|0;fa=0;do{f[R+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))g0(t);t=q+36|0;s=f[t>>2]|0;if(s|0?(fa=s+12|0,s=f[fa>>2]|0,f[fa>>2]=s+-1,(s|0)==1):0)_S(q);f[t>>2]=0;t=q+16|0;s=q+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[N>>2]|0;N=0;do{f[t+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=e;return}g0(s);u=e;return}function sya(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function tya(a){a=a|0;return +(+p[a+8>>3])}function uya(a,b){a=a|0;b=b|0;f[a+16>>2]=f[b>>2];f[a+20>>2]=f[b+4>>2];return}function vya(a,b){a=a|0;b=b|0;var c=0;c=f[b+20>>2]|0;f[a>>2]=f[b+16>>2];f[a+4>>2]=c;return}function wya(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=a+80|0;d=a+116|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+96|0;b=a+84|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)<=0)return;d=f[a+120>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0));return}function xya(a,b,c){a=a|0;b=b|0;c=c|0;z5(a,b,440714,288585,c);return}function yya(a){a=a|0;YDc(a);return}function zya(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Aya(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=61256;b=a+188|0;c=f[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)ZDc(c);f[b>>2]=d;f[a+192>>2]=264}d=a+116|0;b=a+152|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(d);f[b>>2]=0;b=a+132|0;d=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+156>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+160>>2]|0;if((d|0)!=(a+164|0))g0(d);d=a+60|0;c=a+96|0;b=f[c>>2]|0;if(b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)_S(d);f[c>>2]=0;c=a+76|0;d=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[a+100>>2]|0;b=0;do{f[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[d>>2]|0))}d=f[a+104>>2]|0;if((d|0)!=(a+108|0))g0(d);d=a+4|0;b=a+40|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(d);f[b>>2]=0;b=a+20|0;d=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+44>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+48>>2]|0;if((d|0)==(a+52|0))return;g0(d);return}function Bya(a){a=a|0;Aya(a);YDc(a);return}function Cya(a,b){a=a|0;b=b|0;var c=0.0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;c=1.0/+(f[a+176>>2]|0);e=f[b>>2]|0;g=f[b+4>>2]|0;if((e|0)>=(g|0))return;b=f[a+20>>2]|0;h=f[f[a+48>>2]>>2]|0;i=f[a+76>>2]|0;k=f[f[a+104>>2]>>2]|0;l=(f[a+184>>2]|0)+-1|0;m=f[a+180>>2]|0;o=f[a+132>>2]|0;p=f[f[a+160>>2]>>2]|0;q=f[a+16>>2]|0;if((q|0)<=0)return;r=f[a+1252>>2]|0;s=f[a+1256>>2]|0;t=f[a+1264>>2]|0;u=f[a+1260>>2]|0;a=e;do{e=b+(Y(h,a)|0)|0;v=i+(Y(k,a)|0)|0;w=c*+(a|0)+-.5;x=~~w;y=x-(+(x|0)>w&1)|0;x=y+1|0;z=w-+(y|0);w=1.0-z;A=o+(Y(Y(m,(y|0)>0?y:0)|0,p)|0)|0;y=o+(Y(Y((l|0)<(x|0)?l:x,m)|0,p)|0)|0;x=0;do{B=j[e+(x<<1)>>1]|0;C=(f[r+(x<<2)>>2]|0)+B|0;D=(f[s+(x<<2)>>2]|0)+B|0;E=+n[t+(x<<2)>>2];F=+n[u+(x<<2)>>2];B=mrc(w*(+(j[A+(C<<1)>>1]|0)*E+ +(j[A+(D<<1)>>1]|0)*F)+z*(E*+(j[y+(C<<1)>>1]|0)+F*+(j[y+(D<<1)>>1]|0)))|0;d[v+(x<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;x=x+1|0}while((x|0)<(q|0));a=a+1|0}while((a|0)<(g|0));return}function Dya(a){a=a|0;YDc(a);return}function Eya(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fya(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=61216;b=a+188|0;c=f[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)ZDc(c);f[b>>2]=d;f[a+192>>2]=264}d=a+116|0;b=a+152|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(d);f[b>>2]=0;b=a+132|0;d=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+156>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+160>>2]|0;if((d|0)!=(a+164|0))g0(d);d=a+60|0;c=a+96|0;b=f[c>>2]|0;if(b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)_S(d);f[c>>2]=0;c=a+76|0;d=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[a+100>>2]|0;b=0;do{f[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[d>>2]|0))}d=f[a+104>>2]|0;if((d|0)!=(a+108|0))g0(d);d=a+4|0;b=a+40|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(d);f[b>>2]=0;b=a+20|0;d=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+44>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+48>>2]|0;if((d|0)==(a+52|0))return;g0(d);return}function Gya(a){a=a|0;Fya(a);YDc(a);return}function Hya(a,c){a=a|0;c=c|0;var d=0.0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0;d=1.0/+(f[a+176>>2]|0);e=f[c>>2]|0;g=c+4|0;c=f[g>>2]|0;if((e|0)>=(c|0))return;i=a+20|0;j=a+48|0;k=a+76|0;l=a+104|0;m=a+184|0;o=a+180|0;p=a+132|0;q=a+160|0;r=a+16|0;s=a+1252|0;t=a+1256|0;u=a+1264|0;v=a+1260|0;a=e;e=c;c=f[r>>2]|0;while(1){w=(f[i>>2]|0)+(Y(f[f[j>>2]>>2]|0,a)|0)|0;x=(f[k>>2]|0)+(Y(f[f[l>>2]>>2]|0,a)|0)|0;y=d*+(a|0)+-.5;z=~~y;A=z-(+(z|0)>y&1)|0;z=A+1|0;B=y-+(A|0);y=1.0-B;C=(f[m>>2]|0)+-1|0;D=f[o>>2]|0;E=Y(D,(A|0)>0?A:0)|0;A=f[p>>2]|0;F=f[f[q>>2]>>2]|0;G=A+(Y(E,F)|0)|0;E=A+(Y(Y((C|0)<(z|0)?C:z,D)|0,F)|0)|0;if((c|0)>0){F=0;do{D=h[w+F>>0]|0;z=(f[(f[s>>2]|0)+(F<<2)>>2]|0)+D|0;C=(f[(f[t>>2]|0)+(F<<2)>>2]|0)+D|0;H=+n[(f[u>>2]|0)+(F<<2)>>2];I=+n[(f[v>>2]|0)+(F<<2)>>2];D=mrc(y*(+(h[G+z>>0]|0)*H+ +(h[G+C>>0]|0)*I)+B*(H*+(h[E+z>>0]|0)+I*+(h[E+C>>0]|0)))|0;b[x+F>>0]=D>>>0<256?D:(D|0)>0?255:0;F=F+1|0;J=f[r>>2]|0}while((F|0)<(J|0));K=J;L=f[g>>2]|0}else{K=c;L=e}a=a+1|0;if((a|0)>=(L|0))break;else{e=L;c=K}}return}function Iya(a){a=a|0;YDc(a);return}function Jya(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Kya(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=61176;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Lya(a){a=a|0;Kya(a);YDc(a);return}function Mya(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0;c=u;u=u+262224|0;e=c+262200|0;g=c+262144|0;h=c;i=f[b>>2]|0;k=(f[a+108>>2]|0)>>>1;l=b+4|0;if((i|0)>=(f[l>>2]|0)){u=c;return}b=a+124|0;m=a+116|0;o=a+120|0;p=e+4|0;q=e+8|0;r=e+12|0;s=a+4|0;t=a+52|0;v=g+16|0;w=g+44|0;x=a+128|0;y=a+132|0;z=g+36|0;A=g+4|0;B=g+40|0;C=g+48|0;D=(f[a+76>>2]|0)+(Y(f[f[a+104>>2]>>2]|0,i)|0)|0;a=i;while(1){i=f[b>>2]|0;E=f[m>>2]|0;F=Y(E,(a|0)%(i|0)|0)|0;f[e>>2]=F;F=f[o>>2]|0;G=Y(F,(a|0)/(i|0)|0)|0;f[p>>2]=G;f[q>>2]=E;f[r>>2]=F;cT(g,s,e);XIc(h|0,0,262144)|0;F=f[r>>2]|0;E=(f[t>>2]|0)>>>1;G=f[v>>2]|0;i=F+-1|0;a:do if(F|0){H=f[q>>2]|0;I=H+-4|0;if((H|0)<4){J=(H|0)>0;K=G;L=i;while(1){if(J){M=0;do{N=h+((j[K+(M<<1)>>1]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;M=M+1|0}while((M|0)!=(H|0))}if(!L)break a;else{K=K+(E<<1)|0;L=L+-1|0}}}L=H&-4;K=(L|0)<(H|0);J=G;M=i;while(1){N=0;do{O=j[J+((N|1)<<1)>>1]|0;P=h+((j[J+(N<<1)>>1]|0)<<2)|0;f[P>>2]=(f[P>>2]|0)+1;P=h+(O<<2)|0;f[P>>2]=(f[P>>2]|0)+1;P=j[J+((N|3)<<1)>>1]|0;O=h+((j[J+((N|2)<<1)>>1]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;O=h+(P<<2)|0;f[O>>2]=(f[O>>2]|0)+1;N=N+4|0}while((N|0)<=(I|0));if(K){N=L;do{O=h+((j[J+(N<<1)>>1]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;N=N+1|0}while((N|0)!=(H|0))}if(!M)break;else{J=J+(E<<1)|0;M=M+-1|0}}}while(0);E=f[x>>2]|0;if((E|0)>0){i=0;G=0;while(1){F=h+(i<<2)|0;M=f[F>>2]|0;if((M|0)>(E|0)){f[F>>2]=E;Q=M+G-E|0}else Q=G;i=i+1|0;if((i|0)==65536)break;else G=Q}G=(Q|0)/65536|0;i=G<<16;E=0;do{M=h+(E<<2)|0;f[M>>2]=(f[M>>2]|0)+G;E=E+1|0}while((E|0)!=65536);E=Q-i|0;if(E|0?(G=65536/(E|0)|0,M=(G|0)>1?G:1,(E|0)>0):0){G=0;F=E;while(1){E=h+(G<<2)|0;f[E>>2]=(f[E>>2]|0)+1;G=G+M|0;if(!((F|0)>1&(G|0)<65536))break;else F=F+-1|0}}}R=+n[y>>2];F=0;G=0;do{F=(f[h+(G<<2)>>2]|0)+F|0;M=mrc(R*+(F|0))|0;d[D+(G<<1)>>1]=M>>>0<65536?M:(M|0)>0?65535:0;G=G+1|0}while((G|0)!=65536);G=f[z>>2]|0;if(G|0?(F=G+12|0,G=f[F>>2]|0,f[F>>2]=G+-1,(G|0)==1):0)_S(g);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){G=f[B>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[A>>2]|0))}F=f[w>>2]|0;if((F|0)!=(C|0))g0(F);a=a+1|0;if((a|0)>=(f[l>>2]|0))break;else D=D+(k<<1)|0}u=c;return}function Nya(a){a=a|0;YDc(a);return}function Oya(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Pya(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=61136;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Qya(a){a=a|0;Pya(a);YDc(a);return}function Rya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+1104|0;e=d+1080|0;g=d+1024|0;i=d;j=f[c>>2]|0;k=f[a+108>>2]|0;l=c+4|0;if((j|0)>=(f[l>>2]|0)){u=d;return}c=a+124|0;m=a+116|0;o=a+120|0;p=e+4|0;q=e+8|0;r=e+12|0;s=a+4|0;t=a+52|0;v=g+16|0;w=g+44|0;x=a+128|0;y=a+132|0;z=g+36|0;A=g+4|0;B=g+40|0;C=g+48|0;D=(f[a+76>>2]|0)+(Y(f[f[a+104>>2]>>2]|0,j)|0)|0;a=j;while(1){j=f[c>>2]|0;E=f[m>>2]|0;F=Y(E,(a|0)%(j|0)|0)|0;f[e>>2]=F;F=f[o>>2]|0;G=Y(F,(a|0)/(j|0)|0)|0;f[p>>2]=G;f[q>>2]=E;f[r>>2]=F;cT(g,s,e);XIc(i|0,0,1024)|0;F=f[r>>2]|0;E=f[t>>2]|0;if(F|0){G=f[q>>2]|0;j=(G|0)<4;H=G+-4|0;I=f[v>>2]|0;J=F;while(1){J=J+-1|0;if(j)K=0;else{F=0;while(1){L=h[I+(F|1)>>0]|0;M=i+((h[I+F>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=i+(L<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=h[I+(F|3)>>0]|0;L=i+((h[I+(F|2)>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=i+(M<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=F+4|0;if((L|0)>(H|0)){K=L;break}else F=L}}if((K|0)<(G|0)){F=K;do{L=i+((h[I+F>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;F=F+1|0}while((F|0)!=(G|0))}if(!J)break;else I=I+E|0}}E=f[x>>2]|0;if((E|0)>0){I=0;J=0;while(1){G=i+(I<<2)|0;H=f[G>>2]|0;if((H|0)>(E|0)){f[G>>2]=E;N=H+J-E|0}else N=J;I=I+1|0;if((I|0)==256)break;else J=N}J=(N|0)/256|0;I=J<<8;E=0;do{H=i+(E<<2)|0;f[H>>2]=(f[H>>2]|0)+J;E=E+1|0}while((E|0)!=256);E=N-I|0;if((E|0)!=0?(J=256/(E|0)|0,H=(J|0)>1?J:1,(E|0)>0):0){J=0;G=E;while(1){E=i+(J<<2)|0;f[E>>2]=(f[E>>2]|0)+1;J=J+H|0;if(!((G|0)>1&(J|0)<256)){O=0;P=0;break}else G=G+-1|0}}else{O=0;P=0}}else{O=0;P=0}do{O=(f[i+(P<<2)>>2]|0)+O|0;G=mrc(+n[y>>2]*+(O|0))|0;b[D+P>>0]=G>>>0<256?G:(G|0)>0?255:0;P=P+1|0}while((P|0)!=256);G=f[z>>2]|0;if(G|0?(J=G+12|0,G=f[J>>2]|0,f[J>>2]=G+-1,(G|0)==1):0)_S(g);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){G=f[B>>2]|0;J=0;do{f[G+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[A>>2]|0))}J=f[w>>2]|0;if((J|0)!=(C|0))g0(J);a=a+1|0;if((a|0)>=(f[l>>2]|0))break;else D=D+k|0}u=d;return}function Sya(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0.0,Ra=0,Sa=0;i=u;u=u+1584|0;j=i+536|0;k=i+472|0;l=i+224|0;m=i+408|0;o=i+352|0;p=i+528|0;q=i+296|0;r=i+464|0;s=i+272|0;t=i;v=i+256|0;do if((d$(a)|0)==65536){w=f[a+4>>2]|0;f[m>>2]=f[w>>2];x=m+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[w+8>>2];f[m+12>>2]=f[w+12>>2];f[m+16>>2]=f[w+16>>2];f[m+20>>2]=f[w+20>>2];f[m+24>>2]=f[w+24>>2];f[m+28>>2]=f[w+28>>2];f[m+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;ZS(m,w);break}}else a$(m,a,-1);while(0);f[o>>2]=1124007936;a=o+4|0;w=o+8|0;x=o+40|0;y=a;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[x>>2]=w;B=o+48|0;A=o+44|0;f[A>>2]=B;f[B>>2]=0;f[o+52>>2]=0;C=$$(d)|0;if(f[m>>2]&4095|0){f[j>>2]=0;f[j+4>>2]=0;y=tT(j,21)|0;D=288681;z=y+21|0;do{b[y>>0]=b[D>>0]|0;y=y+1|0;D=D+1|0}while((y|0)<(z|0));Tya(-215,j,288703,724)}E=m+40|0;F=f[E>>2]|0;G=f[F>>2]|0;f[p>>2]=f[F+4>>2];f[p+4>>2]=G;v$(c,p,5,-1,0,0);do if((d$(c)|0)==65536){p=f[c+4>>2]|0;f[q>>2]=f[p>>2];G=q+4|0;F=p+4|0;f[G>>2]=f[F>>2];H=q+8|0;f[H>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2];f[q+16>>2]=f[p+16>>2];f[q+20>>2]=f[p+20>>2];f[q+24>>2]=f[p+24>>2];f[q+28>>2]=f[p+28>>2];f[q+32>>2]=f[p+32>>2];I=f[p+36>>2]|0;f[q+36>>2]=I;f[q+40>>2]=H;H=q+48|0;J=q+44|0;f[J>>2]=H;f[H>>2]=0;f[q+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[F>>2]|0)<3){F=f[p+44>>2]|0;H=f[J>>2]|0;f[H>>2]=f[F>>2];f[H+4>>2]=f[F+4>>2];break}else{f[G>>2]=0;ZS(q,p);break}}else a$(q,c,-1);while(0);a:do if(C){if((h|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;y=tT(j,62)|0;D=288721;z=y+62|0;do{b[y>>0]=b[D>>0]|0;y=y+1|0;D=D+1|0}while((y|0)<(z|0));Tya(-215,j,288703,731)}c=f[E>>2]|0;p=f[c>>2]|0;f[r>>2]=f[c+4>>2];f[r+4>>2]=p;v$(d,r,4,-1,0,0);do if((d$(d)|0)==65536){p=f[d+4>>2]|0;f[j>>2]=f[p>>2];c=j+4|0;G=p+4|0;f[c>>2]=f[G>>2];F=j+8|0;f[F>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];f[j+32>>2]=f[p+32>>2];H=j+36|0;J=f[p+36>>2]|0;f[H>>2]=J;f[j+40>>2]=F;F=j+48|0;I=j+44|0;f[I>>2]=F;f[F>>2]=0;f[j+52>>2]=0;if(J|0){F=J+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[G>>2]|0)<3){G=f[p+44>>2]|0;F=f[I>>2]|0;f[F>>2]=f[G>>2];f[F+4>>2]=f[G+4>>2];K=H;break}else{f[c>>2]=0;ZS(j,p);K=H;break}}else{a$(j,d,-1);K=j+36|0}while(0);H=f[K>>2]|0;if(H|0){p=H+12|0;f[p>>2]=(f[p>>2]|0)+1}p=o+36|0;H=f[p>>2]|0;if(H|0?(c=H+12|0,H=f[c>>2]|0,f[c>>2]=H+-1,(H|0)==1):0)_S(o);f[p>>2]=0;H=o+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[a>>2]|0)>0){c=f[x>>2]|0;G=0;do{f[c+(G<<2)>>2]=0;G=G+1|0;L=f[a>>2]|0}while((G|0)<(L|0));f[o>>2]=f[j>>2];if((L|0)<3)M=37;else M=39}else{f[o>>2]=f[j>>2];M=37}if((M|0)==37){G=f[j+4>>2]|0;if((G|0)<3){f[a>>2]=G;f[w>>2]=f[j+8>>2];f[o+12>>2]=f[j+12>>2];G=f[j+44>>2]|0;c=f[A>>2]|0;f[c>>2]=f[G>>2];f[c+4>>2]=f[G+4>>2]}else M=39}if((M|0)==39)ZS(o,j);G=j+16|0;f[H>>2]=f[G>>2];f[o+20>>2]=f[j+20>>2];f[o+24>>2]=f[j+24>>2];f[o+28>>2]=f[j+28>>2];f[o+32>>2]=f[j+32>>2];c=f[K>>2]|0;f[p>>2]=c;if(c|0?(F=c+12|0,c=f[F>>2]|0,f[F>>2]=c+-1,(c|0)==1):0)_S(j);f[K>>2]=0;c=j+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[c>>2]|0)>0){G=f[j+40>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)!=(j+48|0))g0(c);f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;N=5;O=s}else{f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;switch(g|0){case 0:case 3:case 5:{N=g;O=s;break a;break}default:{}}f[j>>2]=0;f[j+4>>2]=0;y=tT(j,41)|0;D=288784;z=y+41|0;do{b[y>>0]=b[D>>0]|0;y=y+1|0;D=D+1|0}while((y|0)<(z|0));Tya(-201,j,288703,741)}while(0);O=(e|0)==1;if((e|2|0)!=3){g=(e|0)==2&C?5:N;if(!g){N=f[E>>2]|0;K=f[q+40>>2]|0;if(!((f[N>>2]|0)==(f[K>>2]|0)?(f[N+4>>2]|0)==(f[K+4>>2]|0):0)){f[j>>2]=0;f[j+4>>2]=0;y=tT(j,24)|0;D=288826;z=y+24|0;do{b[y>>0]=b[D>>0]|0;y=y+1|0;D=D+1|0}while((y|0)<(z|0));Tya(-215,j,288851,564)}if(f[m>>2]&4095|0){f[j>>2]=0;P=j+4|0;f[P>>2]=0;Q=tT(j,47)|0;y=Q;D=288865;z=y+47|0;do{b[y>>0]=b[D>>0]|0;y=y+1|0;D=D+1|0}while((y|0)<(z|0));Tya(-215,j,288851,566)}if((f[q>>2]&4095|0)!=5){f[j>>2]=0;P=j+4|0;f[P>>2]=0;Q=tT(j,47)|0;y=Q;D=288865;z=y+47|0;do{b[y>>0]=b[D>>0]|0;y=y+1|0;D=D+1|0}while((y|0)<(z|0));Tya(-215,j,288851,566)}Q=m+8|0;P=f[Q>>2]|0;K=m+12|0;N=f[K>>2]|0;w=P<<1;L=P*3|0;d=(P*12|0)+4+(P<<3)|0;r=N<<3;c=d>>>0<r>>>0?r:d;d=j+8|0;f[j>>2]=d;r=j+4|0;f[r>>2]=c;if(c>>>0>1032){F=XDc(c)|0;f[j>>2]=F;R=F}else R=d;F=R+(w<<2)+3&-4;c=F;G=F;F=(P|0)>0;if(F){p=0;do{S=+(Y(p,p)|0);n[R+(p<<2)>>2]=S;p=p+1|0}while((p|0)!=(P|0))}if((P|0)<(w|0)){p=P;do{n[R+(p<<2)>>2]=999999986991104.0;p=p+1|0}while((p|0)!=(w|0))}if(F){F=(w|0)>1?w:1;XIc(G|0,0,F<<2|0)|0;T=F}else T=0;if((T|0)<=(L|0)){F=T;while(1){f[c+(F<<2)>>2]=F-w;if((F|0)<(L|0))F=F+1|0;else break}}f[k>>2]=0;f[k+4>>2]=N;f[l>>2]=61296;f[l+4>>2]=m;f[l+8>>2]=q;F=f[Q>>2]|0;f[l+12>>2]=c+(F<<1<<2)+4;f[l+16>>2]=R;c=f[m+4>>2]|0;if((c|0)<3)U=Y(f[K>>2]|0,F)|0;else{F=f[E>>2]|0;K=0;Q=1;while(1){L=Y(f[F+(K<<2)>>2]|0,Q)|0;K=K+1|0;if((K|0)==(c|0)){U=L;break}else Q=L}}y8(k,l,+(U>>>0)*.0000152587890625);U=R+(N<<2)|0;n[R>>2]=0.0;n[U>>2]=0.0;if((N|0)>1){Q=1;do{n[U+(Q<<2)>>2]=.5/+(Q|0);S=+(Y(Q,Q)|0);n[R+(Q<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(N|0))}f[k>>2]=0;f[k+4>>2]=P;f[l>>2]=61316;f[l+4>>2]=q;f[l+8>>2]=R;f[l+12>>2]=U;y8(k,l,-1.0);U=f[j>>2]|0;if((U|0)!=(d|0)){if(U|0)ZDc(U);f[j>>2]=d;f[r>>2]=1032}}else{V=g;M=80}}else{V=C?5:3;M=80}if((M|0)==80){switch(e|0){case 3:{W=0;break}case 2:case 1:{W=O?1:2;break}default:{f[j>>2]=0;f[j+4>>2]=0;y=tT(j,73)|0;D=288913;z=y+73|0;do{b[y>>0]=b[D>>0]|0;y=y+1|0;D=D+1|0}while((y|0)<(z|0));Tya(-215,j,288703,784)}}switch(W+(V*10|0)|0){case 30:{n[s>>2]=1.0;X=1.0;Z=1;break}case 31:{n[s>>2]=1.0;X=2.0;Z=1;break}case 32:{n[s>>2]=.9549999833106995;X=1.3693000078201294;Z=1;break}case 50:{n[s>>2]=1.0;n[s+4>>2]=1.0;X=2.0;Z=2;break}case 51:{n[s>>2]=1.0;n[s+4>>2]=2.0;X=3.0;Z=2;break}case 52:{n[s>>2]=1.0;n[s+4>>2]=1.399999976158142;X=2.196899890899658;Z=2;break}default:{f[j>>2]=0;f[j+4>>2]=0;y=tT(j,19)|0;D=288987;z=y+19|0;do{b[y>>0]=b[D>>0]|0;y=y+1|0;D=D+1|0}while((y|0)<(z|0));Tya(-5,j,289007,445)}}n[s+(Z<<2)>>2]=X;Z=f[E>>2]|0;D=(V|0)==3;V=D?2:4;W=(f[Z>>2]|0)+V|0;O=(f[Z+4>>2]|0)+V|0;f[k>>2]=1124007936;V=k+4|0;Z=k+8|0;e=k+40|0;y=V;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[e>>2]=Z;Z=k+48|0;M=k+44|0;f[M>>2]=Z;f[Z>>2]=0;f[k+52>>2]=0;f[j>>2]=W;f[j+4>>2]=O;XS(k,2,j,4);b:do if(C){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[j>>2]=-1056833530;f[j+4>>2]=l;f[j+8>>2]=1;f[j+12>>2]=4;l_(o,j,e0()|0)|0;if(!h){sY(t,m,0.0);f[j>>2]=1124007936;O=j+4|0;W=j+8|0;g=j+40|0;y=O;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[g>>2]=W;r=j+48|0;d=j+44|0;f[d>>2]=r;f[r>>2]=0;f[j+52>>2]=0;U=f[t>>2]|0;ei[f[(f[U>>2]|0)+12>>2]&511](U,t,j,-1);$j(t);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;U=v+8|0;f[U>>2]=0;f[U+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=o;raa(l,v,8,4,0)|0;U=j+36|0;R=f[U>>2]|0;if(R|0?(P=R+12|0,R=f[P>>2]|0,f[P>>2]=R+-1,(R|0)==1):0)_S(j);f[U>>2]=0;U=j+16|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[O>>2]|0)>0){U=f[g>>2]|0;R=0;do{f[U+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[O>>2]|0))}O=f[d>>2]|0;if((O|0)!=(r|0))g0(O)}else{O=m+8|0;if((f[O>>2]|0)>0){R=m+12|0;U=f[m+16>>2]|0;g=f[m+44>>2]|0;W=f[o+16>>2]|0;P=0;N=1;Q=f[R>>2]|0;while(1){c=U+(Y(f[g>>2]|0,P)|0)|0;K=W+(Y(f[f[A>>2]>>2]|0,P)|0)|0;if((Q|0)>0){F=0;L=N;w=Q;while(1){if(!(b[c+F>>0]|0)){f[K+(F<<2)>>2]=L;_=L+1|0;$=f[R>>2]|0}else{_=L;$=w}F=F+1|0;if((F|0)>=($|0)){aa=_;ba=$;break}else{L=_;w=$}}}else{aa=N;ba=Q}P=P+1|0;if((P|0)>=(f[O>>2]|0))break;else{N=aa;Q=ba}}}}X=+n[s+4>>2];S=+n[s+8>>2];Q=mrc(+n[s>>2]*65536.0)|0;N=mrc(X*65536.0)|0;O=mrc(S*65536.0)|0;P=f[m+16>>2]|0;R=f[k+16>>2]|0;W=f[M>>2]|0;g=f[q+16>>2]|0;U=f[o+16>>2]|0;r=f[m+48>>2]|0;d=(f[Z>>2]|0)>>>2;w=(f[q+48>>2]|0)>>>2;L=(f[B>>2]|0)>>>2;F=f[E>>2]|0;K=f[F+4>>2]|0;c=f[F>>2]|0;F=f[e>>2]|0;T=f[F+4>>2]|0;G=f[F>>2]|0;if((T|0)>0){F=R+(Y(f[W>>2]|0,G+-1|0)|0)|0;p=0;do{f[R+(p<<2)>>2]=2147483647;f[F+(p<<2)>>2]=2147483647;p=p+1|0}while((p|0)!=(T|0));p=f[W>>2]|0;F=R+p|0;H=R+(Y(p,G+-2|0)|0)|0;p=0;do{f[F+(p<<2)>>2]=2147483647;f[H+(p<<2)>>2]=2147483647;p=p+1|0}while((p|0)!=(T|0))}if((c|0)>0){T=(K|0)>0;p=d<<1;H=L<<1;F=~H;G=1-H|0;W=-2-L|0;I=~L;J=1-L|0;ca=2-L|0;da=K+1|0;ea=0;do{fa=Y(ea,r)|0;ga=R+((Y(ea+2|0,d)|0)<<2)+8|0;ha=Y(ea,L)|0;f[ga+(K<<2)>>2]=2147483647;f[ga+-4>>2]=2147483647;f[ga+(da<<2)>>2]=2147483647;f[ga+-8>>2]=2147483647;ia=P+fa|0;fa=U+(ha<<2)|0;if(T){ha=0;do{if(!(b[ia+ha>>0]|0)){ja=0;ka=ga}else{la=ha-p|0;ma=(f[ga+(la+-1<<2)>>2]|0)+O|0;if(ma>>>0<2147483647){na=ma;oa=f[fa+(ha+F<<2)>>2]|0}else{na=2147483647;oa=0}ma=(f[ga+(la+1<<2)>>2]|0)+O|0;if(na>>>0>ma>>>0){pa=ma;qa=f[fa+(G+ha<<2)>>2]|0}else{pa=na;qa=oa}ma=ha-d|0;la=(f[ga+(ma+-2<<2)>>2]|0)+O|0;if(pa>>>0>la>>>0){ra=la;sa=f[fa+(W+ha<<2)>>2]|0}else{ra=pa;sa=qa}la=(f[ga+(ma+-1<<2)>>2]|0)+N|0;if(ra>>>0>la>>>0){ta=la;ua=f[fa+(ha+I<<2)>>2]|0}else{ta=ra;ua=sa}la=(f[ga+(ma<<2)>>2]|0)+Q|0;if(ta>>>0>la>>>0){va=la;wa=f[fa+(ha-L<<2)>>2]|0}else{va=ta;wa=ua}la=(f[ga+(ma+1<<2)>>2]|0)+N|0;if(va>>>0>la>>>0){xa=la;ya=f[fa+(J+ha<<2)>>2]|0}else{xa=va;ya=wa}la=(f[ga+(ma+2<<2)>>2]|0)+O|0;if(xa>>>0>la>>>0){za=la;Aa=f[fa+(ca+ha<<2)>>2]|0}else{za=xa;Aa=ya}la=ha+-1|0;ma=(f[ga+(la<<2)>>2]|0)+Q|0;if(za>>>0>ma>>>0){Ba=ma;Ca=f[fa+(la<<2)>>2]|0}else{Ba=za;Ca=Aa}f[ga+(ha<<2)>>2]=Ba;ja=Ca;ka=fa}f[ka+(ha<<2)>>2]=ja;ha=ha+1|0}while((ha|0)!=(K|0))}ea=ea+1|0}while((ea|0)!=(c|0));ea=p+-1|0;ca=H+-1|0;J=L+2|0;I=c;do{W=I;I=I+-1|0;G=g+((Y(I,w)|0)<<2)|0;F=R+((Y(W+1|0,d)|0)<<2)+8|0;P=U+((Y(I,L)|0)<<2)|0;if(T){da=K;do{r=da;da=da+-1|0;ha=F+(da<<2)|0;fa=f[ha>>2]|0;ga=P+(da<<2)|0;if(fa>>>0>Q>>>0){ia=(f[F+(r+p<<2)>>2]|0)+O|0;la=fa>>>0>ia>>>0;ma=la?ia:fa;ia=(f[F+(ea+da<<2)>>2]|0)+O|0;Da=ma>>>0>ia>>>0;Ea=Da?ia:ma;ma=da+d|0;ia=(f[F+(ma+2<<2)>>2]|0)+O|0;Fa=Ea>>>0>ia>>>0;Ga=Fa?ia:Ea;Ea=(f[F+(r+d<<2)>>2]|0)+N|0;ia=Ga>>>0>Ea>>>0;Ha=ia?Ea:Ga;Ga=(f[F+(ma<<2)>>2]|0)+Q|0;Ea=Ha>>>0>Ga>>>0;Ia=da+L|0;Ja=Ea?Ga:Ha;Ha=(f[F+(ma+-1<<2)>>2]|0)+N|0;Ga=Ja>>>0>Ha>>>0;Ka=Ga?Ha:Ja;Ja=(f[F+(ma+-2<<2)>>2]|0)+O|0;ma=Ka>>>0>Ja>>>0;Ha=ma?Ja:Ka;Ka=(f[F+(r<<2)>>2]|0)+Q|0;Ja=Ha>>>0>Ka>>>0;La=Ja?Ka:Ha;Ha=f[(Ja?P+(r<<2)|0:ma?P+(Ia+-2<<2)|0:Ga?P+(Ia+-1<<2)|0:Ea?P+(Ia<<2)|0:ia?P+(r+L<<2)|0:Fa?P+(J+da<<2)|0:Da?P+(ca+da<<2)|0:la?P+(r+H<<2)|0:ga)>>2]|0;f[ha>>2]=La;f[ga>>2]=Ha;Ma=La}else Ma=fa;n[G+(da<<2)>>2]=+((Ma>>>0<536870911?Ma:536870911)>>>0)*.0000152587890625}while((r|0)>1)}}while((W|0)>1)}}else{S=+n[s>>2];X=+n[s+4>>2];if(D){H=mrc(S*65536.0)|0;ca=mrc(X*65536.0)|0;J=f[m+16>>2]|0;L=f[k+16>>2]|0;Q=f[q+16>>2]|0;O=f[m+48>>2]|0;N=(f[Z>>2]|0)>>>2;d=(f[q+48>>2]|0)>>>2;ea=f[E>>2]|0;p=f[ea+4>>2]|0;K=f[ea>>2]|0;ea=f[e>>2]|0;T=f[ea+4>>2]|0;if((T|0)>0){I=L+(Y(f[f[M>>2]>>2]|0,(f[ea>>2]|0)+-1|0)|0)|0;ea=0;do{f[L+(ea<<2)>>2]=2147483647;f[I+(ea<<2)>>2]=2147483647;ea=ea+1|0}while((ea|0)!=(T|0))}if((K|0)<=0)break;T=(p|0)>0;if(T){ea=0;do{I=Y(ea,O)|0;ea=ea+1|0;U=L+((Y(ea,N)|0)<<2)+4|0;f[U+(p<<2)>>2]=2147483647;f[U+-4>>2]=2147483647;R=J+I|0;I=0;w=2147483647;while(1){if(!(b[R+I>>0]|0))Na=0;else{g=I-N|0;c=(f[U+(g+-1<<2)>>2]|0)+ca|0;da=(f[U+(g<<2)>>2]|0)+H|0;G=c>>>0>da>>>0?da:c;c=(f[U+(g+1<<2)>>2]|0)+ca|0;g=G>>>0>c>>>0?c:G;G=w+H|0;Na=g>>>0>G>>>0?G:g}f[U+(I<<2)>>2]=Na;I=I+1|0;if((I|0)==(p|0))break;else w=Na}}while((ea|0)!=(K|0))}else{ea=0;do{ea=ea+1|0;J=L+((Y(ea,N)|0)<<2)+4|0;f[J+(p<<2)>>2]=2147483647;f[J+-4>>2]=2147483647}while((ea|0)!=(K|0))}if(T)Oa=K;else break;while(1){ea=Oa;Oa=Oa+-1|0;J=Q+((Y(Oa,d)|0)<<2)|0;O=L+((Y(ea,N)|0)<<2)+4|0;w=p;do{I=w;w=w+-1|0;U=O+(w<<2)|0;R=f[U>>2]|0;if(R>>>0>H>>>0){W=w+N|0;g=(f[O+(I+N<<2)>>2]|0)+ca|0;G=R>>>0>g>>>0?g:R;g=(f[O+(W<<2)>>2]|0)+H|0;c=G>>>0>g>>>0?g:G;G=(f[O+(W+-1<<2)>>2]|0)+ca|0;W=c>>>0>G>>>0?G:c;c=(f[O+(I<<2)>>2]|0)+H|0;G=W>>>0>c>>>0?c:W;f[U>>2]=G;Pa=G}else Pa=R;n[J+(w<<2)>>2]=+((Pa>>>0<536870911?Pa:536870911)>>>0)*.0000152587890625}while((I|0)>1);if((ea|0)<=1)break b}}Qa=+n[s+8>>2];H=mrc(S*65536.0)|0;ca=mrc(X*65536.0)|0;N=mrc(Qa*65536.0)|0;p=f[m+16>>2]|0;L=f[k+16>>2]|0;d=f[M>>2]|0;Q=f[q+16>>2]|0;K=f[m+48>>2]|0;T=(f[Z>>2]|0)>>>2;w=(f[q+48>>2]|0)>>>2;J=f[E>>2]|0;O=f[J+4>>2]|0;I=f[J>>2]|0;J=f[e>>2]|0;R=f[J+4>>2]|0;G=f[J>>2]|0;if((R|0)>0){J=L+(Y(f[d>>2]|0,G+-1|0)|0)|0;U=0;do{f[L+(U<<2)>>2]=2147483647;f[J+(U<<2)>>2]=2147483647;U=U+1|0}while((U|0)!=(R|0));U=f[d>>2]|0;J=L+U|0;W=L+(Y(U,G+-2|0)|0)|0;U=0;do{f[J+(U<<2)>>2]=2147483647;f[W+(U<<2)>>2]=2147483647;U=U+1|0}while((U|0)!=(R|0))}if((I|0)>0){R=(O|0)>0;U=T<<1;W=O+1|0;if(R){J=0;do{G=Y(J,K)|0;d=L+((Y(J+2|0,T)|0)<<2)+8|0;f[d+(O<<2)>>2]=2147483647;f[d+-4>>2]=2147483647;f[d+(W<<2)>>2]=2147483647;f[d+-8>>2]=2147483647;c=p+G|0;G=0;do{if(!(b[c+G>>0]|0))Ra=0;else{g=G-U|0;da=(f[d+(g+-1<<2)>>2]|0)+N|0;P=(f[d+(g+1<<2)>>2]|0)+N|0;g=da>>>0>P>>>0?P:da;da=G-T|0;P=(f[d+(da+-2<<2)>>2]|0)+N|0;F=g>>>0>P>>>0?P:g;g=(f[d+(da+-1<<2)>>2]|0)+ca|0;P=F>>>0>g>>>0?g:F;F=(f[d+(da<<2)>>2]|0)+H|0;g=P>>>0>F>>>0?F:P;P=(f[d+(da+1<<2)>>2]|0)+ca|0;F=g>>>0>P>>>0?P:g;g=(f[d+(da+2<<2)>>2]|0)+N|0;da=F>>>0>g>>>0?g:F;F=(f[d+(G+-1<<2)>>2]|0)+H|0;Ra=da>>>0>F>>>0?F:da}f[d+(G<<2)>>2]=Ra;G=G+1|0}while((G|0)!=(O|0));J=J+1|0}while((J|0)!=(I|0))}else{J=0;do{p=L+((Y(J+2|0,T)|0)<<2)+8|0;f[p+(O<<2)>>2]=2147483647;f[p+-4>>2]=2147483647;f[p+(W<<2)>>2]=2147483647;f[p+-8>>2]=2147483647;J=J+1|0}while((J|0)!=(I|0))}J=U+-1|0;if(R){W=I;do{p=W;W=W+-1|0;K=Q+((Y(W,w)|0)<<2)|0;G=L+((Y(p+1|0,T)|0)<<2)+8|0;d=O;do{c=d;d=d+-1|0;ea=G+(d<<2)|0;da=f[ea>>2]|0;if(da>>>0>H>>>0){F=(f[G+(c+U<<2)>>2]|0)+N|0;g=da>>>0>F>>>0?F:da;F=(f[G+(J+d<<2)>>2]|0)+N|0;P=g>>>0>F>>>0?F:g;g=d+T|0;F=(f[G+(g+2<<2)>>2]|0)+N|0;r=P>>>0>F>>>0?F:P;P=(f[G+(c+T<<2)>>2]|0)+ca|0;F=r>>>0>P>>>0?P:r;r=(f[G+(g<<2)>>2]|0)+H|0;P=F>>>0>r>>>0?r:F;F=(f[G+(g+-1<<2)>>2]|0)+ca|0;r=P>>>0>F>>>0?F:P;P=(f[G+(g+-2<<2)>>2]|0)+N|0;g=r>>>0>P>>>0?P:r;r=(f[G+(c<<2)>>2]|0)+H|0;P=g>>>0>r>>>0?r:g;f[ea>>2]=P;Sa=P}else Sa=da;n[K+(d<<2)>>2]=+((Sa>>>0<536870911?Sa:536870911)>>>0)*.0000152587890625}while((c|0)>1)}while((p|0)>1)}}}while(0);Sa=k+36|0;Ra=f[Sa>>2]|0;if(Ra|0?(s=Ra+12|0,Ra=f[s>>2]|0,f[s>>2]=Ra+-1,(Ra|0)==1):0)_S(k);f[Sa>>2]=0;Sa=k+16|0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[V>>2]|0)>0){Sa=f[e>>2]|0;e=0;do{f[Sa+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[V>>2]|0))}V=f[M>>2]|0;if((V|0)!=(Z|0))g0(V)}V=q+36|0;Z=f[V>>2]|0;if(Z|0?(M=Z+12|0,Z=f[M>>2]|0,f[M>>2]=Z+-1,(Z|0)==1):0)_S(q);f[V>>2]=0;V=q+16|0;Z=q+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[Z>>2]|0)>0){V=f[q+40>>2]|0;M=0;do{f[V+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[Z>>2]|0))}Z=f[q+44>>2]|0;if((Z|0)!=(q+48|0))g0(Z);Z=o+36|0;q=f[Z>>2]|0;if(q|0?(M=q+12|0,q=f[M>>2]|0,f[M>>2]=q+-1,(q|0)==1):0)_S(o);f[Z>>2]=0;Z=o+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[a>>2]|0)>0){Z=f[x>>2]|0;x=0;do{f[Z+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}a=f[A>>2]|0;if((a|0)!=(B|0))g0(a);a=m+36|0;B=f[a>>2]|0;if(B|0?(A=B+12|0,B=f[A>>2]|0,f[A>>2]=B+-1,(B|0)==1):0)_S(m);f[a>>2]=0;a=m+16|0;B=m+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[B>>2]|0)>0){a=f[E>>2]|0;E=0;do{f[a+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[m+44>>2]|0;if((B|0)==(m+48|0)){u=i;return}g0(B);u=i;return}function Tya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,289075,d);return}function Uya(a){a=a|0;YDc(a);return}function Vya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;c=u;u=u+1040|0;d=c;e=f[b>>2]|0;g=f[b+4>>2]|0;b=f[a+4>>2]|0;h=f[b+12>>2]|0;i=(h*12|0)+24|0;j=d+8|0;f[d>>2]=j;k=d+4|0;f[k>>2]=i;if(i>>>0>1032){l=XDc(i)|0;f[d>>2]=l;m=l}else m=j;l=m+(h<<2)|0;i=l+(h<<2)+4+3&-4;a:do if((e|0)<(g|0)){o=f[b+16>>2]|0;p=f[b+44>>2]|0;q=l+4|0;r=(h|0)>0;s=a+8|0;if((h|0)<=1){t=e;while(1){v=o+(Y(f[p>>2]|0,t)|0)|0;f[i>>2]=0;n[l>>2]=-999999986991104.0;n[q>>2]=999999986991104.0;f[m>>2]=f[v>>2];if(r){w=f[s>>2]|0;x=0;y=0;while(1){z=+(x|0);A=y;while(1){B=A+1|0;if(+n[l+(B<<2)>>2]<z)A=B;else break}B=f[i+(A<<2)>>2]|0;C=x-B|0;z=+M(+(+n[w+(((C|0)>-1?C:0-C|0)<<2)>>2]+ +n[m+(B<<2)>>2]));n[v+(x<<2)>>2]=z;x=x+1|0;if((x|0)==(h|0))break;else y=A}}t=t+1|0;if((t|0)==(g|0))break a}}t=f[s>>2]|0;y=f[a+12>>2]|0;x=e;do{v=o+(Y(f[p>>2]|0,x)|0)|0;f[i>>2]=0;n[l>>2]=-999999986991104.0;n[q>>2]=999999986991104.0;f[m>>2]=f[v>>2];w=0;B=1;do{z=+n[v+(B<<2)>>2];n[m+(B<<2)>>2]=z;D=z+ +n[t+(B<<2)>>2];C=w;while(1){E=f[i+(C<<2)>>2]|0;F=(D-+n[v+(E<<2)>>2]-+n[t+(E<<2)>>2])*+n[y+(B-E<<2)>>2];if(F>+n[l+(C<<2)>>2])break;else C=C+-1|0}w=C+1|0;f[i+(w<<2)>>2]=B;n[l+(w<<2)>>2]=F;n[l+(C+2<<2)>>2]=999999986991104.0;B=B+1|0}while((B|0)!=(h|0));if(r){B=0;w=0;while(1){D=+(B|0);A=w;while(1){E=A+1|0;if(+n[l+(E<<2)>>2]<D)A=E;else break}C=f[i+(A<<2)>>2]|0;E=B-C|0;D=+M(+(+n[t+(((E|0)>-1?E:0-E|0)<<2)>>2]+ +n[m+(C<<2)>>2]));n[v+(B<<2)>>2]=D;B=B+1|0;if((B|0)==(h|0))break;else w=A}}x=x+1|0}while((x|0)!=(g|0))}while(0);if((m|0)==(j|0)){u=c;return}ZDc(m);f[d>>2]=j;f[k>>2]=1032;u=c;return}function Wya(a){a=a|0;YDc(a);return}function Xya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+1072|0;e=d;g=f[c>>2]|0;h=f[c+4>>2]|0;c=f[a+4>>2]|0;i=f[c+8>>2]|0;j=f[c+48>>2]|0;k=f[a+8>>2]|0;l=(f[k+48>>2]|0)>>>2;m=e+8|0;f[e>>2]=m;n=e+4|0;f[n>>2]=i;if(i>>>0>264){o=XDc(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=o;p=o}else p=m;if((g|0)<(h|0)?(o=i+-1|0,q=a+12|0,r=a+16|0,a=0-j|0,(i|0)>0):0){j=f[c+16>>2]|0;s=f[c+44>>2]|0;c=f[k+16>>2]|0;k=g;do{g=o;t=j+(Y(f[s>>2]|0,o)|0)+k|0;v=o;while(1){v=b[t>>0]|0?v+1|0:0;f[p+(g<<2)>>2]=v;if((g|0)<=0)break;else{g=g+-1|0;t=t+a|0}}t=f[q>>2]|0;g=f[r>>2]|0;v=c+(k<<2)|0;w=0;x=o;while(1){y=p+(w<<2)|0;x=x+1-(f[t+(x-(f[y>>2]|0)<<2)>>2]|0)|0;f[y>>2]=x;f[v>>2]=f[g+(x<<2)>>2];w=w+1|0;if((w|0)==(i|0))break;else v=v+(l<<2)|0}k=k+1|0}while((k|0)!=(h|0))}if((p|0)==(m|0)){u=d;return}ZDc(p);f[e>>2]=m;f[n>>2]=264;u=d;return}function Yya(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;i=u;u=u+384|0;j=i+128|0;k=i+120|0;l=i+64|0;m=i+56|0;n=i;if(!((d|0)==1&(g|0)==0)){Sya(a,c,e0()|0,d,e,1);u=i;return}do if((d$(a)|0)==65536){e=f[a+4>>2]|0;f[l>>2]=f[e>>2];d=l+4|0;g=e+4|0;f[d>>2]=f[g>>2];o=l+8|0;f[o>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];f[l+16>>2]=f[e+16>>2];f[l+20>>2]=f[e+20>>2];f[l+24>>2]=f[e+24>>2];f[l+28>>2]=f[e+28>>2];f[l+32>>2]=f[e+32>>2];p=f[e+36>>2]|0;f[l+36>>2]=p;f[l+40>>2]=o;o=l+48|0;q=l+44|0;f[q>>2]=o;f[o>>2]=0;f[l+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[g>>2]|0)<3){g=f[e+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];r=l;break}else{f[d>>2]=0;ZS(l,e);r=l;break}}else{a$(l,a,-1);r=l}while(0);if(f[r>>2]&4095|0){f[j>>2]=0;f[j+4>>2]=0;s=tT(j,21)|0;t=288681;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));Tya(-215,j,289149,692)}a=l+40|0;e=f[a>>2]|0;d=f[e>>2]|0;f[m>>2]=f[e+4>>2];f[m+4>>2]=d;v$(c,m,0,-1,0,0);do if((d$(c)|0)==65536){m=f[c+4>>2]|0;f[n>>2]=f[m>>2];d=n+4|0;e=m+4|0;f[d>>2]=f[e>>2];g=n+8|0;f[g>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];o=n+16|0;f[o>>2]=f[m+16>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[n+36>>2]=q;f[n+40>>2]=g;g=n+48|0;p=n+44|0;f[p>>2]=g;f[g>>2]=0;f[n+52>>2]=0;if(q|0){w=q+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[e>>2]|0)<3){e=f[m+44>>2]|0;w=f[p>>2]|0;f[w>>2]=f[e>>2];f[w+4>>2]=f[e+4>>2];x=o;y=g;break}else{f[d>>2]=0;ZS(n,m);x=o;y=g;break}}else{a$(n,c,-1);x=n+16|0;y=n+48|0}while(0);c=f[l+12>>2]|0;g=f[l+8>>2]|0;o=l+16|0;m=f[o>>2]|0;d=f[x>>2]|0;e=l+48|0;w=f[e>>2]|0;p=f[y>>2]|0;if(f[r>>2]&4095|0){f[k>>2]=0;z=k+4|0;f[z>>2]=0;A=tT(k,46)|0;s=A;t=289173;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));Tya(-215,k,289220,621)}if(f[n>>2]&4095|0){f[k>>2]=0;z=k+4|0;f[z>>2]=0;A=tT(k,46)|0;s=A;t=289173;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));Tya(-215,k,289220,621)}A=f[a>>2]|0;z=n+40|0;r=f[z>>2]|0;if((f[A>>2]|0)==(f[r>>2]|0)?(f[A+4>>2]|0)==(f[r+4>>2]|0):0)B=0;else{f[k>>2]=0;f[k+4>>2]=0;s=tT(k,24)|0;t=288826;v=s+24|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));Tya(-215,k,289220,622)}do{k=B;B=B+1|0;b[j+k>>0]=B>>>0<256?B:(k>>>31)+255|0}while((B|0)!=256);B=((b[m>>0]|0)!=0)<<31>>31;b[d>>0]=B;k=(c|0)>1;if(k){t=1;s=B;do{if(!(b[m+t>>0]|0))C=0;else C=h[j+(s&255)>>0]|0;s=C&255;b[d+t>>0]=s;t=t+1|0}while((t|0)!=(c|0))}do if((g|0)>1){t=0-p|0;s=Y(p,g+-1|0)|0;if(k){D=1;E=d;F=m}else{C=1;B=d;v=m;do{v=v+w|0;B=B+p|0;if(!(b[v>>0]|0))G=0;else G=h[j+(h[B+t>>0]|0)>>0]|0;b[B>>0]=G;C=C+1|0}while((C|0)!=(g|0));H=d+s|0;break}do{F=F+w|0;E=E+p|0;if(!(b[F>>0]|0))I=0;else I=h[j+(h[E+t>>0]|0)>>0]|0;b[E>>0]=I;C=I;B=1;while(1){if(!(b[F+B>>0]|0))J=0;else{v=h[E+(B-p)>>0]|0;J=h[j+((C|0)>(v|0)?v:C)>>0]|0}b[E+B>>0]=J;B=B+1|0;if((B|0)==(c|0))break;else C=J}D=D+1|0}while((D|0)!=(g|0));H=d+s|0}else H=d;while(0);d=c+-1|0;D=c+-2|0;c=(D|0)>-1;if(c){J=h[H+d>>0]|0;E=D;while(1){F=h[j+J>>0]|0;I=H+E|0;w=F-(h[I>>0]|0)+256|0;if(w>>>0<769)K=h[271964+w>>0]|0;else K=0;J=F-K|0;b[I>>0]=J;if((E|0)<=0)break;else E=E+-1|0}}E=g+-2|0;a:do if((E|0)>-1){g=0-p|0;J=p+d|0;if(c){L=E;M=H}else{K=E;I=H;while(1){I=I+g|0;F=b[j+(h[I+J>>0]|0)>>0]|0;w=I+d|0;G=b[w>>0]|0;b[w>>0]=(F&255)>(G&255)?G:F;if((K|0)<=0)break a;else K=K+-1|0}}while(1){M=M+g|0;K=b[j+(h[M+J>>0]|0)>>0]|0;I=M+d|0;s=b[I>>0]|0;F=(K&255)>(s&255)?s:K;b[I>>0]=F;I=F&255;F=D;while(1){K=h[M+(F+p)>>0]|0;s=b[j+(I>>>0>K>>>0?K:I)>>0]|0;K=M+F|0;G=b[K>>0]|0;w=(s&255)>(G&255)?G:s;b[K>>0]=w;if((F|0)>0){I=w&255;F=F+-1|0}else break}if((L|0)<=0)break;else L=L+-1|0}}while(0);L=n+36|0;M=f[L>>2]|0;if(M|0?(j=M+12|0,M=f[j>>2]|0,f[j>>2]=M+-1,(M|0)==1):0)_S(n);f[L>>2]=0;L=n+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[L>>2]|0)>0){x=f[z>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[L>>2]|0))}L=f[n+44>>2]|0;if((L|0)!=(y|0))g0(L);L=l+36|0;y=f[L>>2]|0;if(y|0?(n=y+12|0,y=f[n>>2]|0,f[n>>2]=y+-1,(y|0)==1):0)_S(l);f[L>>2]=0;L=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[L>>2]|0)>0){o=f[a>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[L>>2]|0))}L=f[l+44>>2]|0;if((L|0)!=(e|0))g0(L);u=i;return}function Zya(){var a=0,b=0,c=0,d=0,e=0;a=u;u=u+32|0;b=a+8|0;c=a;d=a+16|0;e=519840;f[e>>2]=1149814285;f[e+4>>2]=1071277473;e=519848;f[e>>2]=963447064;f[e+4>>2]=1071047319;e=519856;f[e>>2]=-768008872;f[e+4>>2]=1070012441;e=519864;f[e>>2]=-1494786058;f[e+4>>2]=1070282957;e=519872;f[e>>2]=963447064;f[e+4>>2]=1072095895;e=519880;f[e>>2]=-423037099;f[e+4>>2]=1068661162;e=519888;f[e>>2]=-959598773;f[e+4>>2]=1066650698;e=519896;f[e>>2]=-1259765448;f[e+4>>2]=1069450094;e=519904;f[e>>2]=1947784849;f[e+4>>2]=1072588866;e=519912;f[e>>2]=1090715535;f[e+4>>2]=1074392192;e=519920;f[e>>2]=-1724858866;f[e+4>>2]=-1074227158;e=519928;f[e>>2]=1480217529;f[e+4>>2]=-1075845121;e=519936;f[e>>2]=682521843;f[e+4>>2]=-1074854875;e=519944;f[e>>2]=596210180;f[e+4>>2]=1073611791;e=519952;f[e>>2]=-102254581;f[e+4>>2]=1067796179;e=519960;f[e>>2]=137164076;f[e+4>>2]=1068269029;e=519968;f[e>>2]=-1107483087;f[e+4>>2]=-1077273068;e=519976;f[e>>2]=-261408890;f[e+4>>2]=1072753342;e=519984;f[e>>2]=-1282855192;f[e+4>>2]=1072589346;e=519992;f[e>>2]=0;f[e+4>>2]=1072693248;e=52e4;f[e>>2]=1349925401;f[e+4>>2]=1072786313;Kmc(b,2048);Kmc(c,3);Rmc(d,b,c);f[220257]=f[d>>2];Kmc(881032,-134);Kmc(881036,220);Pmc(881040,881036,881032);Kmc(881044,-140);Kmc(881048,122);Pmc(881052,881048,881044);Vmc(b,809);Vmc(c,2e4);gnc(520008,b,c);Vmc(b,7827);Vmc(c,25e5);gnc(520016,b,c);Vmc(b,323);Vmc(c,25);gnc(520024,b,c);Vmc(b,12);Vmc(c,5);gnc(520032,b,c);Vmc(b,11);Vmc(c,200);gnc(520040,b,c);Kmc(b,216);Kmc(c,24389);Rmc(881056,b,c);Kmc(b,841);Kmc(c,108);Rmc(881060,b,c);Kmc(b,16);Kmc(c,116);Rmc(881064,b,c);Kmc(881068,255);u=a;return}function _ya(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;k=u;u=u+80|0;l=k+72|0;m=k+40|0;o=k;switch(h|0){case 0:{f[o>>2]=i;h=o+4|0;q=h;r=61328;s=q+36|0;do{f[q>>2]=f[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));if(!j){f[h>>2]=739;f[o+12>>2]=1689;f[o+16>>2]=296;f[o+24>>2]=871;f[o+28>>2]=3892;f[o+36>>2]=79}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=61372;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}case 2:{f[o>>2]=i;h=o+4|0;q=h;r=61328;s=q+36|0;do{f[q>>2]=f[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));if(!j){f[h>>2]=739;f[o+12>>2]=1689;f[o+16>>2]=296;f[o+24>>2]=871;f[o+28>>2]=3892;f[o+36>>2]=79}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=61392;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}default:{f[o>>2]=i;t=+p[64980];i=o+4|0;n[i>>2]=t;n[o+8>>2]=+p[64981];v=+p[64982];h=o+12|0;n[h>>2]=v;w=+p[64983];r=o+16|0;n[r>>2]=w;n[o+20>>2]=+p[64984];x=+p[64985];q=o+24|0;n[q>>2]=x;y=+p[64986];s=o+28|0;n[s>>2]=y;n[o+32>>2]=+p[64987];z=+p[64988];A=o+36|0;n[A>>2]=z;if(!j){n[i>>2]=v;n[h>>2]=t;n[r>>2]=x;n[q>>2]=w;n[s>>2]=z;n[A>>2]=y}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=61412;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}}}function $ya(a){a=a|0;YDc(a);return}function aza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;i=h*3|0;if((h|0)<=0){h=c;do h=h+1|0;while((h|0)<(d|0));return}h=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=h;h=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c>>2]|0;l=+n[c+4>>2];m=+n[c+8>>2];o=+n[c+12>>2];p=+n[c+16>>2];q=+n[c+20>>2];r=+n[c+24>>2];s=+n[c+28>>2];t=+n[c+32>>2];u=+n[c+36>>2];c=0;v=h;while(1){w=+n[v>>2];x=+n[v+4>>2];y=+n[v+8>>2];n[j+(c<<2)>>2]=l*w+m*x+o*y;n[j+(c+1<<2)>>2]=p*w+q*x+r*y;n[j+(c+2<<2)>>2]=s*w+t*x+u*y;c=c+3|0;if((c|0)>=(i|0))break;else v=v+(k<<2)|0}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;h=h+b|0}}return}function bza(a){a=a|0;YDc(a);return}function cza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){dza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function dza(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;p=f[a+32>>2]|0;q=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){r=0;s=b}else return;while(1){b=j[s>>1]|0;e=Y(b,h)|0;t=j[s+2>>1]|0;u=Y(t,i)|0;v=j[s+4>>1]|0;w=e+2048+u+(Y(v,k)|0)>>12;u=(Y(b,l)|0)+2048+(Y(t,m)|0)+(Y(v,n)|0)>>12;e=(Y(b,o)|0)+2048+(Y(t,p)|0)+(Y(v,q)|0)>>12;d[c+(r<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[c+(r+1<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[c+(r+2<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else s=s+(g<<1)|0}return}function eza(a){a=a|0;YDc(a);return}function fza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){gza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function gza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;p=f[a+32>>2]|0;q=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){r=0;s=c}else return;while(1){c=h[s>>0]|0;e=Y(c,i)|0;t=h[s+1>>0]|0;u=Y(t,j)|0;v=h[s+2>>0]|0;w=e+2048+u+(Y(v,k)|0)>>12;u=(Y(c,l)|0)+2048+(Y(t,m)|0)+(Y(v,n)|0)>>12;e=(Y(c,o)|0)+2048+(Y(t,p)|0)+(Y(v,q)|0)>>12;b[d+r>>0]=w>>>0<256?w:(w|0)>0?255:0;b[d+(r+1)>>0]=u>>>0<256?u:(u|0)>0?255:0;b[d+(r+2)>>0]=e>>>0<256?e:(e|0)>0?255:0;r=r+3|0;if((r|0)>=(a|0))break;else s=s+g|0}return}function hza(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0;k=u;u=u+80|0;l=k+72|0;m=k+44|0;o=k;q=j?2:0;switch(h|0){case 0:{f[o>>2]=i;f[o+4>>2]=q;h=o+8|0;r=h;s=61424;t=r+36|0;do{f[r>>2]=f[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));if(!j){f[h>>2]=228;f[o+32>>2]=13273;f[o+12>>2]=-836;f[o+36>>2]=-6296;f[o+16>>2]=4331;f[o+40>>2]=-2042}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=61468;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}case 2:{f[o>>2]=i;f[o+4>>2]=q;h=o+8|0;r=h;s=61424;t=r+36|0;do{f[r>>2]=f[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));if(!j){f[h>>2]=228;f[o+32>>2]=13273;f[o+12>>2]=-836;f[o+36>>2]=-6296;f[o+16>>2]=4331;f[o+40>>2]=-2042}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=61488;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}default:{f[o>>2]=i;f[o+4>>2]=q;v=+p[64989];q=o+8|0;n[q>>2]=v;w=+p[64990];i=o+12|0;n[i>>2]=w;x=+p[64991];h=o+16|0;n[h>>2]=x;n[o+20>>2]=+p[64992];n[o+24>>2]=+p[64993];n[o+28>>2]=+p[64994];y=+p[64995];s=o+32|0;n[s>>2]=y;z=+p[64996];r=o+36|0;n[r>>2]=z;A=+p[64997];t=o+40|0;n[t>>2]=A;if(!j){n[q>>2]=y;n[s>>2]=v;n[i>>2]=z;n[r>>2]=w;n[h>>2]=A;n[t>>2]=x}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=61508;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}}}function iza(a){a=a|0;YDc(a);return}function jza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){kza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function kza(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0.0;e=f[a>>2]|0;g=+n[a+8>>2];h=+n[a+12>>2];i=+n[a+16>>2];j=+n[a+20>>2];k=+n[a+24>>2];l=+n[a+28>>2];m=+n[a+32>>2];o=+n[a+36>>2];p=+n[a+40>>2];a=d*3|0;if((d|0)<=0)return;if((e|0)==4){d=0;q=c;while(1){r=+n[b+(d<<2)>>2];s=+n[b+(d+1<<2)>>2];t=+n[b+(d+2<<2)>>2];n[q>>2]=g*r+h*s+i*t;n[q+4>>2]=j*r+k*s+l*t;n[q+8>>2]=m*r+o*s+p*t;n[q+12>>2]=1.0;d=d+3|0;if((d|0)>=(a|0))break;else q=q+16|0}return}else{q=0;d=c;while(1){t=+n[b+(q<<2)>>2];s=+n[b+(q+1<<2)>>2];r=+n[b+(q+2<<2)>>2];n[d>>2]=g*t+h*s+i*r;n[d+4>>2]=j*t+k*s+l*r;n[d+8>>2]=m*t+o*s+p*r;q=q+3|0;if((q|0)>=(a|0))break;else d=d+(e<<2)|0}return}}function lza(a){a=a|0;YDc(a);return}function mza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){nza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function nza(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;h=f[a+8>>2]|0;i=f[a+12>>2]|0;k=f[a+16>>2]|0;l=f[a+20>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=f[a+32>>2]|0;p=f[a+36>>2]|0;q=f[a+40>>2]|0;a=e*3|0;if((e|0)<=0)return;if((g|0)==4){e=0;r=c;while(1){s=j[b+(e<<1)>>1]|0;t=Y(s,h)|0;u=j[b+(e+1<<1)>>1]|0;v=Y(u,i)|0;w=j[b+(e+2<<1)>>1]|0;x=t+2048+v+(Y(w,k)|0)>>12;v=(Y(s,l)|0)+2048+(Y(u,m)|0)+(Y(w,n)|0)>>12;t=(Y(s,o)|0)+2048+(Y(u,p)|0)+(Y(w,q)|0)>>12;d[r>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[r+2>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d[r+4>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[r+6>>1]=-1;e=e+3|0;if((e|0)>=(a|0))break;else r=r+8|0}return}else{r=0;e=c;while(1){c=j[b+(r<<1)>>1]|0;t=Y(c,h)|0;v=j[b+(r+1<<1)>>1]|0;x=Y(v,i)|0;w=j[b+(r+2<<1)>>1]|0;u=t+2048+x+(Y(w,k)|0)>>12;x=(Y(c,l)|0)+2048+(Y(v,m)|0)+(Y(w,n)|0)>>12;t=(Y(c,o)|0)+2048+(Y(v,p)|0)+(Y(w,q)|0)>>12;d[e>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[e+2>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[e+4>>1]=t>>>0<65536?t:(t|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else e=e+(g<<1)|0}return}}function oza(a){a=a|0;YDc(a);return}function pza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){qza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function qza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;i=f[a+8>>2]|0;j=f[a+12>>2]|0;k=f[a+16>>2]|0;l=f[a+20>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=f[a+32>>2]|0;p=f[a+36>>2]|0;q=f[a+40>>2]|0;a=e*3|0;if((e|0)<=0)return;if((g|0)==4){e=0;r=d;while(1){s=h[c+e>>0]|0;t=Y(s,i)|0;u=h[c+(e+1)>>0]|0;v=Y(u,j)|0;w=h[c+(e+2)>>0]|0;x=t+2048+v+(Y(w,k)|0)>>12;v=(Y(s,l)|0)+2048+(Y(u,m)|0)+(Y(w,n)|0)>>12;t=(Y(s,o)|0)+2048+(Y(u,p)|0)+(Y(w,q)|0)>>12;b[r>>0]=x>>>0<256?x:(x|0)>0?255:0;b[r+1>>0]=v>>>0<256?v:(v|0)>0?255:0;b[r+2>>0]=t>>>0<256?t:(t|0)>0?255:0;b[r+3>>0]=-1;e=e+3|0;if((e|0)>=(a|0))break;else r=r+4|0}return}else{r=0;e=d;while(1){d=h[c+r>>0]|0;t=Y(d,i)|0;v=h[c+(r+1)>>0]|0;x=Y(v,j)|0;w=h[c+(r+2)>>0]|0;u=t+2048+x+(Y(w,k)|0)>>12;x=(Y(d,l)|0)+2048+(Y(v,m)|0)+(Y(w,n)|0)>>12;t=(Y(d,o)|0)+2048+(Y(v,p)|0)+(Y(w,q)|0)>>12;b[e>>0]=u>>>0<256?u:(u|0)>0?255:0;b[e+1>>0]=x>>>0<256?x:(x|0)>0?255:0;b[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;r=r+3|0;if((r|0)>=(a|0))break;else e=e+g|0}return}}function rza(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0;n=u;u=u+112|0;o=n+96|0;p=n+68|0;q=n;r=k?2:0;k=(i|0)==0;if(l)if(k){sza(q,j,r,0,0,m);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=61528;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;y8(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else{tza(q,j,r,0,0,m);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=61548;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;y8(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else if(k){f[q>>2]=j;uza(q+4|0,3,r,0,0,m);f[q+56>>2]=j;f[q+60>>2]=r;vza();b[q+64>>0]=m&1;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=61568;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;y8(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else{uza(q,j,r,0,0,m);f[q+52>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=61588;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;y8(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}}function sza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+80|0;j=i+56|0;k=i+32|0;l=i+24|0;m=i+16|0;o=i+8|0;q=i;f[a>>2]=c;b[a+40>>0]=h&1;vza();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[129996];f[j+4>>2]=f[129997];f[j+8>>2]=f[129998];f[j+12>>2]=f[129999];f[j+16>>2]=f[13e4];f[j+20>>2]=f[130001]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}if((b[520248]|0)==0?MIc(520248)|0:0)Vmc(520256,4096);if((f[15400]|0)<=0){u=i;return}g=(e|0)==0;h=d^2;c=k+8|0;r=k+16|0;s=k+8|0;t=k+16|0;v=0;while(1){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;w=v*3|0;if(g){x=519840+(w<<3)|0;if((x|0)!=(k|0)){y=x;x=f[y+4>>2]|0;z=k;f[z>>2]=f[y>>2];f[z+4>>2]=x}x=w+1|0;z=519840+(x<<3)|0;if((z|0)!=(c|0)){y=z;z=f[y+4>>2]|0;A=c;f[A>>2]=f[y>>2];f[A+4>>2]=z}z=519840+(w+2<<3)|0;if((z|0)==(r|0))B=x;else{A=z;z=f[A+4>>2]|0;y=r;f[y>>2]=f[A>>2];f[y+4>>2]=z;B=x}}else{p[k>>3]=+n[e+(w<<2)>>2];x=w+1|0;p[s>>3]=+n[e+(x<<2)>>2];p[t>>3]=+n[e+(w+2<<2)>>2];B=x}fnc(m,520256,k);x=j+(v<<3)|0;gnc(l,m,x);z=Zmc(l)|0;f[a+4+(w+h<<2)>>2]=z;fnc(o,520256,c);gnc(l,o,x);z=Zmc(l)|0;y=a+4+(B<<2)|0;f[y>>2]=z;fnc(q,520256,r);gnc(l,q,x);x=Zmc(l)|0;f[a+4+(w+d<<2)>>2]=x;x=f[a+4+(w<<2)>>2]|0;if((x|0)<=-1){C=19;break}z=f[y>>2]|0;if((z|0)<=-1){C=19;break}y=f[a+4+(w+2<<2)>>2]|0;if((y|0)<=-1){C=19;break}if((z+x+y|0)>=8192){C=19;break}v=v+1|0;if((v|0)>=(f[15400]|0)){C=9;break}}if((C|0)==9){u=i;return}else if((C|0)==19){f[l>>2]=0;f[l+4>>2]=0;C=tT(l,128)|0;i=290075;v=C+128|0;do{b[C>>0]=b[i>>0]|0;C=C+1|0;i=i+1|0}while((C|0)<(v|0));z5(-215,l,290204,289780,1686)}}function tza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+128|0;j=i+116|0;k=i+64|0;l=i+40|0;m=i+32|0;o=i+24|0;q=i+104|0;r=i+96|0;t=i+16|0;v=i+8|0;w=i;x=i+92|0;y=i+88|0;f[a>>2]=c;c=a+40|0;b[c>>0]=h&1;h=a+44|0;f[h>>2]=d;f[j>>2]=3;vza();d=(e|0)!=0;z=(g|0)!=0;if(d|z)A=0;else A=b[c>>0]|0;b[a+41>>0]=A;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;if(z){p[k>>3]=+n[g>>2];p[k+8>>3]=+n[g+4>>2];p[k+16>>3]=+n[g+8>>2]}else{f[k>>2]=f[129996];f[k+4>>2]=f[129997];f[k+8>>2]=f[129998];f[k+12>>2]=f[129999];f[k+16>>2]=f[13e4];f[k+20>>2]=f[130001]}g=m;f[g>>2]=0;f[g+4>>2]=1072693248;gnc(l,m,k);m=l+8|0;f[m>>2]=0;f[m+4>>2]=1072693248;m=o;f[m>>2]=0;f[m+4>>2]=1072693248;gnc(l+16|0,o,k+16|0);if((f[j>>2]|0)<=0){u=i;return}k=q+4|0;o=q+8|0;m=0;while(1){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;g=l+(m<<3)|0;z=m*3|0;if(d){p[t>>3]=+n[e+(z<<2)>>2];fnc(v,g,t);anc(r,v);f[q>>2]=f[r>>2];A=z+1|0;p[t>>3]=+n[e+(A<<2)>>2];fnc(v,g,t);anc(r,v);f[k>>2]=f[r>>2];p[t>>3]=+n[e+(z+2<<2)>>2];fnc(v,g,t);anc(r,v);f[o>>2]=f[r>>2];B=A}else{fnc(w,g,519840+(z<<3)|0);anc(r,w);f[q>>2]=f[r>>2];A=z+1|0;fnc(w,g,519840+(A<<3)|0);anc(r,w);f[k>>2]=f[r>>2];fnc(w,g,519840+(z+2<<3)|0);anc(r,w);f[o>>2]=f[r>>2];B=A}A=f[q>>2]|0;f[a+4+((f[h>>2]^2)+z<<2)>>2]=A;g=f[k>>2]|0;f[a+4+(B<<2)>>2]=g;c=f[o>>2]|0;f[a+4+((f[h>>2]|0)+z<<2)>>2]=c;z=!((f[s>>2]=A,+n[s>>2])>=0.0);A=z|!((f[s>>2]=g,+n[s>>2])>=0.0);if(A|!((f[s>>2]=c,+n[s>>2])>=0.0)){C=12;break}Mmc(x,q,k);Mmc(y,x,o);Kmc(r,1024);if(!(Tmc(y,r)|0)){C=12;break}m=m+1|0;if((m|0)>=(f[j>>2]|0)){C=8;break}}if((C|0)==8){u=i;return}else if((C|0)==12){f[r>>2]=0;f[r+4>>2]=0;C=tT(r,93)|0;i=289927;j=C+93|0;do{b[C>>0]=b[i>>0]|0;C=C+1|0;i=i+1|0}while((C|0)<(j|0));z5(-215,r,290021,289780,1762)}}function uza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+128|0;j=i+112|0;k=i+48|0;l=i+100|0;m=i+104|0;o=i+96|0;q=i+40|0;r=i+92|0;s=i+32|0;t=i+24|0;v=i+16|0;w=i+8|0;x=i;y=i+88|0;z=i+84|0;A=i+80|0;B=i+76|0;C=i+72|0;f[a>>2]=c;b[a+48>>0]=h&1;vza();f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[j>>2]=0;a:do if((f[j>>2]|0)<3){if(g|0)while(1){p[k+(f[j>>2]<<3)>>3]=+n[g+(f[j>>2]<<2)>>2];f[j>>2]=(f[j>>2]|0)+1;if((f[j>>2]|0)>=3)break a}do{h=519984+(f[j>>2]<<3)|0;c=k+(f[j>>2]<<3)|0;if((h|0)!=(c|0)){D=h;h=f[D+4>>2]|0;E=c;f[E>>2]=f[D>>2];f[E+4>>2]=h}f[j>>2]=(f[j>>2]|0)+1}while((f[j>>2]|0)<3)}while(0);f[j>>2]=0;b:do if((f[j>>2]|0)<3){g=(e|0)==0;h=(d|0)==0;while(1){E=(f[j>>2]|0)*3|0;if(g){n[a+4+((f[j>>2]|0)*3<<2)>>2]=+p[519840+(E<<3)>>3];n[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]=+p[519840+(((f[j>>2]|0)*3|0)+1<<3)>>3];n[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]=+p[519840+(((f[j>>2]|0)*3|0)+2<<3)>>3]}else{f[a+4+((f[j>>2]|0)*3<<2)>>2]=f[e+(E<<2)>>2];f[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]=f[e+(((f[j>>2]|0)*3|0)+1<<2)>>2];f[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]=f[e+(((f[j>>2]|0)*3|0)+2<<2)>>2]}if(h){E=a+4+((f[j>>2]|0)*3<<2)|0;D=a+4+(((f[j>>2]|0)*3|0)+2<<2)|0;c=f[E>>2]|0;f[E>>2]=f[D>>2];f[D>>2]=c}if(!(+n[a+4+((f[j>>2]|0)*3<<2)>>2]>=0.0)){F=18;break}if(!(+n[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]>=0.0)){F=18;break}if(!(+n[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]>=0.0)){F=18;break}f[l>>2]=f[a+4+((f[j>>2]|0)*3<<2)>>2];f[m>>2]=f[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2];Mmc(o,l,m);f[q>>2]=f[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2];Mmc(r,o,q);n[s>>2]=1.5;if(!(Tmc(r,s)|0)){F=18;break}f[j>>2]=(f[j>>2]|0)+1;if((f[j>>2]|0)>=3)break b}if((F|0)==18){f[m>>2]=0;f[m+4>>2]=0;dJc(tT(m,158)|0,289608,158)|0;z5(-215,m,289767,289780,2840)}}while(0);F=k+8|0;Vmc(s,15);fnc(q,F,s);bnc(t,k,q);Vmc(w,3);fnc(v,k+16|0,w);bnc(x,t,v);anc(m,x);f[y>>2]=1065353216;f[v>>2]=872415232;x=Smc(m,v)|0;f[s>>2]=f[(x?m:v)>>2];Rmc(q,y,s);f[m>>2]=f[q>>2];Kmc(q,52);Qmc(z,m,q);anc(s,k);Qmc(A,z,s);f[a+40>>2]=f[A>>2];Kmc(q,117);Qmc(B,m,q);anc(s,F);Qmc(C,B,s);f[a+44>>2]=f[C>>2];C=q;f[C>>2]=0;f[C+4>>2]=1072693248;if(hnc(F,q)|0){u=i;return}else{f[q>>2]=0;f[q+4>>2]=0;i=tT(q,31)|0;F=289851;C=i+31|0;do{b[i>>0]=b[F>>0]|0;i=i+1|0;F=F+1|0}while((i|0)<(C|0));z5(-215,q,289767,289780,2854)}}function vza(){var a=0,c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0;a=u;u=u+14928|0;c=a+120|0;e=a+80|0;g=a+56|0;h=a+48|0;i=a+40|0;j=a+14912|0;k=a+32|0;l=a+24|0;m=a+16|0;o=a+14908|0;p=a+14904|0;q=a+14900|0;r=a+14896|0;s=a+14892|0;t=a+14888|0;v=a+14884|0;w=a+14880|0;x=a+14876|0;y=a+14872|0;z=a+14868|0;A=a+14864|0;B=a+14860|0;C=a+14856|0;D=a+14852|0;E=a+14848|0;F=a+14844|0;G=a+14840|0;H=a+13792|0;I=a+13784|0;K=a+12736|0;L=a+12732|0;M=a+12728|0;N=a+12724|0;O=a+12720|0;P=a+12716|0;Q=a+12712|0;R=a+12708|0;S=a+12704|0;T=a+12700|0;U=a+12696|0;V=a+12692|0;W=a+12688|0;X=a+12684|0;Z=a+12676|0;_=a+12664|0;$=a+12652|0;aa=a+12644|0;ba=a+12632|0;ca=a+12620|0;da=a+12612|0;ea=a+12596|0;fa=a+12588|0;ga=a+12580|0;ha=a+12572|0;ia=a+12564|0;ja=a+12560|0;ka=a+12552|0;la=a+12544|0;ma=a+12540|0;na=a+12532|0;oa=a+12528|0;pa=a+12524|0;qa=a+12520|0;ra=a+12516|0;sa=a+12512|0;ta=a+12508|0;ua=a+12504|0;va=a+12500|0;wa=a+12496|0;xa=a+12492|0;ya=a+12488|0;za=a+12484|0;Aa=a+12480|0;Ba=a+12476|0;Ca=a+12472|0;Da=a+8372|0;Ea=a+4272|0;Fa=a+172|0;Ga=a+168|0;Ha=a+12680|0;Ia=a+12672|0;Ja=a+12668|0;Ka=a+12660|0;La=a+12656|0;Ma=a+12648|0;Na=a+12640|0;Oa=a+12636|0;Pa=a+12628|0;Qa=a+12624|0;Ra=a+12616|0;Sa=a+12608|0;Ta=a+12604|0;Ua=a+12600|0;Va=a+12592|0;Wa=a+12584|0;Xa=a+12576|0;Ya=a+12568|0;Za=a+164|0;_a=a+8|0;$a=a;ab=a+12556|0;bb=a+160|0;cb=a+12548|0;db=a+156|0;eb=a+12536|0;if(b[1152660]|0){u=a;return}XIc(Da|0,0,4100)|0;XIc(Ea|0,0,4100)|0;XIc(Fa|0,0,4100)|0;f[Ha>>2]=1065353216;f[c>>2]=f[220257];Rmc(Ga,Ha,c);Ha=0;do{Kmc(e,Ha);Qmc(c,Ga,e);if(Tmc(c,881056)|0)jnc(e,c,881060,881064);else pnc(e,c);fb=Da+(Ha<<2)|0;if((e|0)!=(fb|0))f[fb>>2]=f[e>>2];Ha=Ha+1|0}while((Ha|0)!=1025);Ha=Eza(Da)|0;f[220269]=Ha;f[Ia>>2]=1065353216;n[e>>2]=1024.0;Rmc(c,Ia,e);f[Ga>>2]=f[c>>2];Ia=0;do{Kmc(e,Ia);Qmc(c,Ga,e);f[Ja>>2]=f[c>>2];Fza(e,Ja);Ha=Ea+(Ia<<2)|0;if((e|0)!=(Ha|0))f[Ha>>2]=f[e>>2];f[Ka>>2]=f[c>>2];Gza(e,Ka);Ha=Fa+(Ia<<2)|0;if((e|0)!=(Ha|0))f[Ha>>2]=f[e>>2];Ia=Ia+1|0}while((Ia|0)!=1025);Ia=Eza(Ea)|0;f[220268]=Ia;Ia=Eza(Fa)|0;f[220276]=Ia;if((b[520104]|0)==0?MIc(520104)|0:0)Kmc(881108,2040);Ia=0;do{Kmc(La,Ia);Rmc(c,La,881068);f[Ma>>2]=f[c>>2];Fza(g,Ma);Qmc(e,881108,g);Fa=(Ymc(e)|0)&65535;d[1124736+(Ia<<1)>>1]=Fa;d[1125248+(Ia<<1)>>1]=Ia<<3;Ia=Ia+1|0}while((Ia|0)!=256);if((b[520112]|0)==0?MIc(520112)|0:0){f[Na>>2]=1065353216;Kmc(c,4096);Rmc(881112,Na,c)}Na=0;do{Kmc(e,Na);Qmc(c,881112,e);f[Oa>>2]=f[c>>2];Gza(g,Oa);Qmc(e,881068,g);Ia=(Ymc(e)|0)&65535;d[1125760+(Na<<1)>>1]=Ia;Qmc(e,881068,c);Ia=(Xmc(e)|0)&65535;d[1133952+(Na<<1)>>1]=Ia;Na=Na+1|0}while((Na|0)!=4096);if((b[520120]|0)==0?MIc(520120)|0:0)n[220279]=1.0/(+n[220267]*8.0);if((b[520128]|0)==0?MIc(520128)|0:0)Kmc(881120,32768);Na=0;do{Kmc(e,Na);Qmc(c,881116,e);if(Tmc(c,881056)|0)jnc(g,c,881060,881064);else pnc(g,c);Qmc(e,881120,g);Oa=(Ymc(e)|0)&65535;d[1142144+(Na<<1)>>1]=Oa;Na=Na+1|0}while((Na|0)!=3072);Na=0;do{if((Na|0)<21){Kmc(Pa,Y(Na,2949120)|0);Kmc(e,414613);Rmc(c,Pa,e);Oa=Ymc(c)|0;Kmc(Qa,16384);Kmc(Ra,16);Kmc(g,116);Rmc(Sa,Ra,g);Kmc(Ta,Na*5|0);Kmc(i,1479);Rmc(h,Ta,i);Mmc(e,Sa,h);Qmc(c,Qa,e);gb=Oa;hb=Ymc(c)|0}else{Kmc(Ua,Y(Na,1638400)|0);Kmc(e,29580);Rmc(Va,Ua,e);Kmc(Wa,262144);Kmc(h,116);Rmc(g,Wa,h);Mmc(c,Va,g);Oa=Ymc(c)|0;Qmc(Xa,c,c);Qmc(Ya,Xa,c);Kmc(g,268435456);Rmc(e,Ya,g);gb=Ymc(e)|0;hb=Oa}Oa=Na<<1;d[1148288+(Oa<<1)>>1]=gb;d[1148288+((Oa|1)<<1)>>1]=hb;Na=Na+1|0}while((Na|0)!=256);Na=P5(147456)|0;hb=-8145;do{if((hb|0)<3391)ib=((hb*108|0)/841|0)+-290|0;else ib=(Y((Y(hb,hb)|0)>>>14,hb)|0)/16384|0;f[Na+(hb+8145<<2)>>2]=ib;hb=hb+1|0}while((hb|0)!=28719);f[220281]=Na;Vmc(e,15);fnc(c,519992,e);bnc(_a,519984,c);Vmc(h,3);fnc(g,52e4,h);bnc($a,_a,g);anc(Za,$a);f[ab>>2]=1065353216;f[g>>2]=872415232;$a=Smc(Za,g)|0;f[e>>2]=f[($a?Za:g)>>2];Rmc(c,ab,e);f[Za>>2]=f[c>>2];Kmc(c,52);Qmc(cb,Za,c);anc(e,519984);Qmc(bb,cb,e);Kmc(c,117);Qmc(eb,Za,c);anc(e,519992);Qmc(db,eb,e);f[e>>2]=1065353216;Kmc(g,4);Rmc(c,e,g);eb=P5(262144)|0;Za=P5(262144)|0;cb=P5(524288)|0;ab=0;do{Kmc(h,ab*100|0);Rmc(g,h,881068);$a=ab<<8;_a=0;do{Kmc(j,_a);Qmc(k,j,881040);Rmc(l,k,881068);Mmc(i,l,881032);Kmc(o,9);Qmc(q,g,bb);Mmc(p,i,q);Qmc(m,o,p);Kmc(q,16);Qmc(p,m,q);Na=Ymc(p)|0;f[eb+(_a+$a<<2)>>2]=Na;_a=_a+1|0}while((_a|0)!=256);jb=0;do{Kmc(r,jb);Qmc(s,r,881052);Rmc(t,s,881068);Mmc(i,t,881044);Qmc(q,g,db);Mmc(p,i,q);Rmc(m,c,p);_a=Smc(m,c)|0;Na=f[c>>2]|0;if(_a)f[m>>2]=Na;f[p>>2]=Na^-2147483648;if(Tmc(m,p)|0)f[m>>2]=f[c>>2]^-2147483648;Kmc(q,16777216);Qmc(p,m,q);Na=Ymc(p)|0;_a=jb+$a|0;f[Za+(_a<<2)>>2]=Na;hb=Y(Na,ab)|0;Na=mJc(hb|0,((hb|0)<0)<<31>>31|0,249600,0)|0;hb=cb+(_a<<3)|0;f[hb>>2]=Na;f[hb+4>>2]=J;jb=jb+1|0}while((jb|0)!=256);ab=ab+1|0}while((ab|0)!=256);f[220282]=eb;f[220283]=Za;f[220284]=cb;cb=c;Za=cb+36|0;do{f[cb>>2]=0;cb=cb+4|0}while((cb|0)<(Za|0));cb=e;Za=cb+36|0;do{f[cb>>2]=0;cb=cb+4|0}while((cb|0)<(Za|0));cb=h;f[cb>>2]=0;f[cb+4>>2]=1072693248;gnc(g,h,519984);h=g+8|0;f[h>>2]=0;f[h+4>>2]=1072693248;h=i;f[h>>2]=0;f[h+4>>2]=1072693248;gnc(g+16|0,i,52e4);i=0;do{h=i*3|0;cb=519840+(h<<3)|0;anc(j,cb);Za=h+2|0;eb=e+(Za<<2)|0;if((j|0)!=(eb|0))f[eb>>2]=f[j>>2];eb=h+1|0;ab=519840+(eb<<3)|0;anc(j,ab);jb=e+(eb<<2)|0;if((j|0)!=(jb|0))f[jb>>2]=f[j>>2];jb=519840+(Za<<3)|0;anc(j,jb);$a=e+(h<<2)|0;if((j|0)!=($a|0))f[$a>>2]=f[j>>2];$a=g+(i<<3)|0;fnc(k,jb,$a);anc(j,k);jb=c+(h<<2)|0;if((j|0)!=(jb|0))f[jb>>2]=f[j>>2];fnc(l,ab,$a);anc(j,l);ab=c+(eb<<2)|0;if((j|0)!=(ab|0))f[ab>>2]=f[j>>2];fnc(m,cb,$a);anc(j,m);$a=c+(Za<<2)|0;if((j|0)!=($a|0))f[$a>>2]=f[j>>2];i=i+1|0}while((i|0)!=3);f[j>>2]=f[c>>2];f[o>>2]=f[c+4>>2];f[p>>2]=f[c+8>>2];f[q>>2]=f[c+12>>2];f[r>>2]=f[c+16>>2];f[s>>2]=f[c+20>>2];f[t>>2]=f[c+24>>2];f[v>>2]=f[c+28>>2];f[w>>2]=f[c+32>>2];f[x>>2]=f[e>>2];f[y>>2]=f[e+4>>2];f[z>>2]=f[e+8>>2];f[A>>2]=f[e+12>>2];f[B>>2]=f[e+16>>2];f[C>>2]=f[e+20>>2];f[D>>2]=f[e+24>>2];f[E>>2]=f[e+28>>2];f[F>>2]=f[e+32>>2];if((b[520136]|0)==0?MIc(520136)|0:0)Kmc(881140,32);if((b[520144]|0)==0?MIc(520144)|0:0)Kmc(881144,116);if((b[520152]|0)==0?MIc(520152)|0:0)Kmc(881148,16);if((b[520160]|0)==0?MIc(520160)|0:0)Kmc(881152,500);if((b[520168]|0)==0?MIc(520168)|0:0)Kmc(881156,200);if((b[520176]|0)==0?MIc(520176)|0:0)Kmc(881160,100);if((b[520184]|0)==0?MIc(520184)|0:0)Kmc(881164,128);if((b[520192]|0)==0?MIc(520192)|0:0)Kmc(881168,256);if((b[520200]|0)==0?MIc(520200)|0:0)Kmc(881172,16384);if((b[520208]|0)==0?MIc(520208)|0:0){Kmc(G,24389);Kmc(H,27);Rmc(881176,G,H)}if((b[520216]|0)==0?MIc(520216)|0:0){Kmc(I,9);Kmc(H,4);Rmc(881180,I,H)}if((b[520224]|0)==0?MIc(520224)|0:0)Kmc(881184,15);if((b[520232]|0)==0?MIc(520232)|0:0)Kmc(881188,3);I=H+8|0;G=H+4|0;f[G>>2]=107811;e=XDc(215622)|0;f[H>>2]=e;e=K+8|0;f[K>>2]=e;c=K+4|0;f[c>>2]=107811;i=XDc(215622)|0;f[K>>2]=i;i=0;do{m=i*3|0;l=0;do{k=(l*99|0)+m|0;g=0;do{$a=k+(g*3267|0)|0;Kmc(M,i);Rmc(L,M,881140);Kmc(O,l);Rmc(N,O,881140);Kmc(Q,g);Rmc(P,Q,881140);f[S>>2]=f[L>>2];Fza(R,S);f[L>>2]=f[R>>2];f[T>>2]=f[N>>2];Fza(R,T);f[N>>2]=f[R>>2];f[U>>2]=f[P>>2];Fza(R,U);f[P>>2]=f[R>>2];Qmc(V,L,j);Qmc(W,N,o);Mmc(X,V,W);Qmc(Z,P,p);Mmc(R,X,Z);Qmc(_,L,q);Qmc(Z,N,r);Mmc($,_,Z);Qmc(aa,P,s);Mmc(W,$,aa);Qmc(ba,L,t);Qmc(aa,N,v);Mmc(ca,ba,aa);Qmc(da,P,w);Mmc(Z,ca,da);if(Smc(R,881056)|0)pnc(aa,R);else jnc(aa,R,881060,881064);if(Smc(W,881056)|0)pnc(da,W);else jnc(da,W,881060,881064);if(Smc(Z,881056)|0)pnc(ea,Z);else jnc(ea,Z,881060,881064);if(Smc(W,881056)|0){Qmc(ga,881144,da);Pmc(fa,ga,881148)}else Qmc(fa,881176,W);Pmc(ia,aa,da);Qmc(ha,881152,ia);Pmc(ja,da,ea);Qmc(ia,881156,ja);Qmc(ka,881172,fa);Rmc(ja,ka,881160);Za=(Ymc(ja)|0)&65535;d[(f[H>>2]|0)+($a<<1)>>1]=Za;Mmc(la,ha,881164);Qmc(ma,881172,la);Rmc(ja,ma,881168);Za=(Ymc(ja)|0)&65535;cb=$a+1|0;d[(f[H>>2]|0)+(cb<<1)>>1]=Za;Mmc(la,ia,881164);Qmc(na,881172,la);Rmc(ja,na,881168);Za=(Ymc(ja)|0)&65535;ab=$a+2|0;d[(f[H>>2]|0)+(ab<<1)>>1]=Za;Qmc(oa,L,x);Qmc(W,N,y);Mmc(pa,oa,W);Qmc(Z,P,z);Mmc(R,pa,Z);Qmc(qa,L,A);Qmc(Z,N,B);Mmc(ra,qa,Z);Qmc(aa,P,C);Mmc(W,ra,aa);Qmc(sa,L,D);Qmc(aa,N,E);Mmc(ta,sa,aa);Qmc(da,P,F);Mmc(Z,ta,da);if(Tmc(W,881056)|0)jnc(aa,W,881060,881064);else pnc(aa,W);Qmc(ua,aa,881144);Pmc(da,ua,881148);f[aa>>2]=f[da>>2];Kmc(va,52);Qmc(ha,881184,W);Mmc(wa,R,ha);Qmc(ia,881188,Z);Mmc(fa,wa,ia);n[ja>>2]=1.1920928955078125e-07;Za=Smc(fa,ja)|0;f[ea>>2]=f[(Za?fa:ja)>>2];Rmc(da,va,ea);Qmc(xa,R,da);Pmc(fa,xa,bb);Qmc(ea,aa,fa);Qmc(ya,881180,W);Qmc(za,ya,da);Pmc(ha,za,db);Qmc(fa,aa,ha);Qmc(Aa,881172,aa);Rmc(ha,Aa,881160);Za=(Ymc(ha)|0)&65535;d[(f[K>>2]|0)+($a<<1)>>1]=Za;Pmc(ia,ea,881032);Qmc(Ba,881172,ia);Rmc(ha,Ba,881040);Za=(Ymc(ha)|0)&65535;d[(f[K>>2]|0)+(cb<<1)>>1]=Za;Pmc(ia,fa,881044);Qmc(Ca,881172,ia);Rmc(ha,Ca,881052);Za=(Ymc(ha)|0)&65535;d[(f[K>>2]|0)+(ab<<1)>>1]=Za;g=g+1|0}while((g|0)<33);l=l+1|0}while((l|0)<33);i=i+1|0}while((i|0)<33);i=P5(1724976)|0;ha=P5(1724976)|0;Ca=f[H>>2]|0;ia=f[K>>2]|0;fa=0;do{Ba=fa*24|0;ea=0;do{Aa=(ea*792|0)+Ba|0;aa=ea;ea=ea+1|0;db=((ea|0)<32?ea:32)*99|0;za=aa*99|0;aa=0;do{da=Aa+(aa*26136|0)|0;ya=aa*3267|0;aa=aa+1|0;W=((aa|0)<32?aa:32)*3267|0;bb=0;do{xa=bb+fa|0;R=((xa|0)<32?xa:32)*3|0;xa=da+(bb<<2)|0;va=R+za|0;ja=va+ya|0;d[i+(xa<<1)>>1]=d[Ca+(ja<<1)>>1]|0;wa=ja+1|0;Z=xa+8|0;d[i+(Z<<1)>>1]=d[Ca+(wa<<1)>>1]|0;ua=ja+2|0;ta=xa+16|0;d[i+(ta<<1)>>1]=d[Ca+(ua<<1)>>1]|0;d[ha+(xa<<1)>>1]=d[ia+(ja<<1)>>1]|0;d[ha+(Z<<1)>>1]=d[ia+(wa<<1)>>1]|0;d[ha+(ta<<1)>>1]=d[ia+(ua<<1)>>1]|0;ua=va+W|0;va=xa|1;d[i+(va<<1)>>1]=d[Ca+(ua<<1)>>1]|0;ta=ua+1|0;wa=va+8|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;Z=ua+2|0;ja=va+16|0;d[i+(ja<<1)>>1]=d[Ca+(Z<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(ua<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;d[ha+(ja<<1)>>1]=d[ia+(Z<<1)>>1]|0;Z=R+db|0;R=xa|2;ja=Z+ya|0;d[i+(R<<1)>>1]=d[Ca+(ja<<1)>>1]|0;ta=ja+1|0;wa=R+8|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;ua=ja+2|0;va=R+16|0;d[i+(va<<1)>>1]=d[Ca+(ua<<1)>>1]|0;d[ha+(R<<1)>>1]=d[ia+(ja<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(ua<<1)>>1]|0;ua=Z+W|0;Z=xa|3;d[i+(Z<<1)>>1]=d[Ca+(ua<<1)>>1]|0;xa=ua+1|0;va=Z+8|0;d[i+(va<<1)>>1]=d[Ca+(xa<<1)>>1]|0;ta=ua+2|0;wa=Z+16|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;d[ha+(Z<<1)>>1]=d[ia+(ua<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(xa<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;bb=bb+1|0}while((bb|0)!=2)}while((aa|0)!=33)}while((ea|0)!=33);fa=fa+1|0}while((fa|0)!=33);fa=i;i=ha;ha=f[K>>2]|0;if((ha|0)!=(e|0)){if(ha|0)ZDc(ha);f[K>>2]=e;f[c>>2]=520}c=f[H>>2]|0;if((c|0)!=(I|0)){if(c|0)ZDc(c);f[H>>2]=I;f[G>>2]=520}f[130024]=fa;f[130025]=i;i=0;do{fa=i<<3;G=16-i<<16>>16;I=0;do{H=(I<<7)+fa|0;c=16-I<<16>>16;e=Y(c,G)|0;K=Y(I,G)|0;ha=Y(c,i)|0;c=Y(I,i)|0;ia=0;do{Ca=1059200+(H+(ia<<11)<<1)|0;ea=16-ia<<16>>16;Ba=(Y(ea,e)|0)&65535;d[Ca>>1]=Ba;Ba=(Y(ia,e)|0)&65535;d[Ca+2>>1]=Ba;Ba=(Y(ea,K)|0)&65535;d[Ca+4>>1]=Ba;Ba=(Y(ia,K)|0)&65535;d[Ca+6>>1]=Ba;Ba=(Y(ea,ha)|0)&65535;d[Ca+8>>1]=Ba;Ba=(Y(ia,ha)|0)&65535;d[Ca+10>>1]=Ba;Ba=(Y(ea,c)|0)&65535;d[Ca+12>>1]=Ba;Ba=(Y(ia,c)|0)&65535;d[Ca+14>>1]=Ba;ia=ia+1|0}while((ia|0)!=16);I=I+1|0}while((I|0)!=16);i=i+1|0}while((i|0)!=16);b[1152660]=1;u=a;return}function wza(a){a=a|0;YDc(a);return}function xza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){yza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function yza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=b[a+48>>0]|0?f[220268]|0:0;p=+n[a+4>>2];q=+n[a+8>>2];r=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=e*3|0;if((e|0)<=0){u=g;return}e=(o|0)==0;B=f[220269]|0;C=a+40|0;D=a+44|0;a=c;c=0;while(1){E=f[a>>2]|0;f[h>>2]=E;F=f[a+4>>2]|0;f[i>>2]=F;G=f[a+8>>2]|0;f[j>>2]=G;n[k>>2]=0.0;H=(f[s>>2]=E,+n[s>>2])<0.0?k:h;n[l>>2]=1.0;E=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[h>>2]=E;n[k>>2]=0.0;H=(f[s>>2]=F,+n[s>>2])<0.0?k:i;n[l>>2]=1.0;F=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[i>>2]=F;n[k>>2]=0.0;H=(f[s>>2]=G,+n[s>>2])<0.0?k:j;n[l>>2]=1.0;G=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[j>>2]=G;I=(f[s>>2]=E,+n[s>>2]);J=(f[s>>2]=F,+n[s>>2]);K=(f[s>>2]=G,+n[s>>2]);if(e){L=K;M=J;N=I}else{O=I*1024.0;G=~~O;F=(G|0)>0?G:0;G=(F|0)<1023?F:1023;I=O-+(G|0);F=o+(G<<2<<2)|0;O=+n[F>>2]+I*(+n[F+4>>2]+I*(+n[F+8>>2]+ +n[F+12>>2]*I));n[h>>2]=O;I=J*1024.0;F=~~I;G=(F|0)>0?F:0;F=(G|0)<1023?G:1023;J=I-+(F|0);G=o+(F<<2<<2)|0;I=+n[G>>2]+J*(+n[G+4>>2]+J*(+n[G+8>>2]+ +n[G+12>>2]*J));n[i>>2]=I;J=K*1024.0;G=~~J;F=(G|0)>0?G:0;G=(F|0)<1023?F:1023;K=J-+(G|0);F=o+(G<<2<<2)|0;J=+n[F>>2]+K*(+n[F+4>>2]+K*(+n[F+8>>2]+ +n[F+12>>2]*K));n[j>>2]=J;L=J;M=I;N=O}O=p*N+q*M+r*L;I=t*N+v*M+w*L;J=+n[220257]*I;F=~~J;G=(F|0)>0?F:0;F=(G|0)<1023?G:1023;K=J-+(F|0);G=B+(F<<2<<2)|0;J=(+n[G>>2]+K*(+n[G+4>>2]+K*(+n[G+8>>2]+ +n[G+12>>2]*K)))*116.0+-16.0;K=(x*N+y*M+z*L)*3.0+(O+I*15.0);P=52.0/(K<1.1920928955078125e-07?1.1920928955078125e-07:K);K=(O*P-+n[C>>2])*J;O=(I*2.25*P-+n[D>>2])*J;n[d+(c<<2)>>2]=J;n[d+(c+1<<2)>>2]=K;n[d+(c+2<<2)>>2]=O;c=c+3|0;if((c|0)>=(A|0))break;else a=a+(m<<2)|0}u=g;return}function zza(a){a=a|0;YDc(a);return}function Aza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){Bza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function Bza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0;g=u;u=u+3104|0;i=g;j=g+3088|0;k=g+3092|0;l=g+3084|0;m=g+3080|0;o=g+3076|0;p=g+3072|0;if(b[a+64>>0]|0){Cza(a+56|0,c,d,e);u=g;return}q=f[a>>2]|0;if((e|0)>0){r=a+4|0;a=c;c=d;d=0;while(1){s=e-d|0;t=(s|0)<256?s:256;if((b[520048]|0)==0?MIc(520048)|0:0){f[j>>2]=1065353216;Rmc(881080,j,881068)}v=t*3|0;w=(s|0)>0;if(w){x=+n[220270];s=0;y=a;while(1){n[i+(s<<2)>>2]=+(h[y>>0]|0)*x;n[i+(s+1<<2)>>2]=+(h[y+1>>0]|0)*x;n[i+(s+2<<2)>>2]=+(h[y+2>>0]|0)*x;s=s+3|0;z=y+q|0;if((s|0)>=(v|0)){A=z;break}else y=z}}else A=a;yza(r,i,i,t);if((b[520056]|0)==0?MIc(520056)|0:0){Kmc(k,100);Rmc(881084,881068,k)}if((b[520064]|0)==0?MIc(520064)|0:0)Rmc(881088,881068,881040);if((b[520072]|0)==0?MIc(520072)|0:0)Rmc(881092,881068,881052);if((b[520080]|0)==0?MIc(520080)|0:0){f[l>>2]=f[220258]^-2147483648;Qmc(m,l,881068);Rmc(881096,m,881040)}if((b[520088]|0)==0?MIc(520088)|0:0){f[o>>2]=f[220261]^-2147483648;Qmc(p,o,881068);Rmc(881100,p,881052)}if(w){y=0;do{s=mrc(+n[i+(y<<2)>>2]*+n[220271])|0;b[c+y>>0]=s>>>0<256?s:(s|0)>0?255:0;s=y+1|0;z=mrc(+n[i+(s<<2)>>2]*+n[220272]+ +n[220274])|0;b[c+s>>0]=z>>>0<256?z:(z|0)>0?255:0;z=y+2|0;s=mrc(+n[i+(z<<2)>>2]*+n[220273]+ +n[220275])|0;b[c+z>>0]=s>>>0<256?s:(s|0)>0?255:0;y=y+3|0}while((y|0)<(v|0))}d=d+256|0;if((d|0)>=(e|0))break;else{a=A;c=c+768|0}}}u=g;return}function Cza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;i=g+8|0;j=g+4|0;k=g;l=f[a>>2]|0;m=f[a+4>>2]|0;a=e*3|0;if((e|0)<=0){u=g;return}e=m^2;n=0;o=c;while(1){Dza((h[o+m>>0]|0)<<6,(h[o+1>>0]|0)<<6,(h[o+e>>0]|0)<<6,f[130025]|0,i,j,k);c=f[i>>2]|0;p=(c|0)/64|0;b[d+n>>0]=p>>>0<256?p:(c|0)>63?255:0;c=f[j>>2]|0;p=(c|0)/64|0;b[d+(n+1)>>0]=p>>>0<256?p:(c|0)>63?255:0;c=f[k>>2]|0;p=(c|0)/64|0;b[d+(n+2)>>0]=p>>>0<256?p:(c|0)>63?255:0;n=n+3|0;if((n|0)>=(a|0))break;else o=o+l|0}u=g;return}function Dza(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;j=u;u=u+96|0;k=j+64|0;l=j+32|0;m=j;n=e+(((b>>9)*792|0)+((a>>9)*24|0)+((c>>9)*26136|0)<<1)|0;f[k>>2]=d[n>>1];f[l>>2]=d[n+16>>1];f[m>>2]=d[n+32>>1];e=k+4|0;f[e>>2]=d[n+2>>1];o=l+4|0;f[o>>2]=d[n+18>>1];p=m+4|0;f[p>>2]=d[n+34>>1];q=k+8|0;f[q>>2]=d[n+4>>1];r=l+8|0;f[r>>2]=d[n+20>>1];s=m+8|0;f[s>>2]=d[n+36>>1];t=k+12|0;f[t>>2]=d[n+6>>1];v=l+12|0;f[v>>2]=d[n+22>>1];w=m+12|0;f[w>>2]=d[n+38>>1];x=k+16|0;f[x>>2]=d[n+8>>1];y=l+16|0;f[y>>2]=d[n+24>>1];z=m+16|0;f[z>>2]=d[n+40>>1];A=k+20|0;f[A>>2]=d[n+10>>1];B=l+20|0;f[B>>2]=d[n+26>>1];C=m+20|0;f[C>>2]=d[n+42>>1];D=k+24|0;f[D>>2]=d[n+12>>1];E=l+24|0;f[E>>2]=d[n+28>>1];F=m+24|0;f[F>>2]=d[n+44>>1];G=d[n+14>>1]|0;f[k+28>>2]=G;H=l+28|0;f[H>>2]=d[n+30>>1];I=m+28|0;f[I>>2]=d[n+46>>1];n=b<<2&1920|a>>>2&120|c<<6&30720;c=d[1059200+(n<<1)>>1]|0;a=d[1059200+((n|1)<<1)>>1]|0;b=d[1059200+((n|2)<<1)>>1]|0;J=d[1059200+((n|3)<<1)>>1]|0;K=d[1059200+((n|4)<<1)>>1]|0;L=d[1059200+((n|5)<<1)>>1]|0;M=d[1059200+((n|6)<<1)>>1]|0;N=d[1059200+((n|7)<<1)>>1]|0;n=Y(c,f[k>>2]|0)|0;k=(Y(a,f[e>>2]|0)|0)+n|0;n=k+(Y(b,f[q>>2]|0)|0)|0;q=n+(Y(J,f[t>>2]|0)|0)|0;t=q+(Y(K,f[x>>2]|0)|0)|0;x=t+(Y(L,f[A>>2]|0)|0)|0;A=x+(Y(M,f[D>>2]|0)|0)+(Y(N,G)|0)|0;f[g>>2]=A;A=Y(f[l>>2]|0,c)|0;l=(Y(f[o>>2]|0,a)|0)+A|0;A=l+(Y(f[r>>2]|0,b)|0)|0;r=A+(Y(f[v>>2]|0,J)|0)|0;v=r+(Y(f[y>>2]|0,K)|0)|0;y=v+(Y(f[B>>2]|0,L)|0)|0;B=y+(Y(f[E>>2]|0,M)|0)|0;E=B+(Y(f[H>>2]|0,N)|0)|0;f[h>>2]=E;E=Y(f[m>>2]|0,c)|0;c=(Y(f[p>>2]|0,a)|0)+E|0;E=c+(Y(f[s>>2]|0,b)|0)|0;b=E+(Y(f[w>>2]|0,J)|0)|0;J=b+(Y(f[z>>2]|0,K)|0)|0;K=J+(Y(L,f[C>>2]|0)|0)|0;C=K+(Y(M,f[F>>2]|0)|0)|0;F=C+(Y(N,f[I>>2]|0)|0)|0;f[i>>2]=F;f[g>>2]=(f[g>>2]|0)+2048>>12;f[h>>2]=(f[h>>2]|0)+2048>>12;f[i>>2]=(f[i>>2]|0)+2048>>12;u=j;return}function Eza(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;b=u;u=u+64|0;c=b+56|0;d=b+52|0;e=b+48|0;g=b+44|0;h=b+40|0;i=b+36|0;j=b+32|0;k=b+24|0;l=b+20|0;m=b+28|0;o=b+16|0;p=b+12|0;q=b+4|0;r=b+8|0;s=b;t=P5(16384)|0;Kmc(c,2);Kmc(d,3);Kmc(e,4);Kmc(g,0);n[t+4>>2]=0.0;n[t>>2]=0.0;v=1;do{w=v;v=v+1|0;Qmc(i,a+(w<<2)|0,c);Pmc(j,a+(v<<2)|0,i);x=w+-1|0;Mmc(k,j,a+(x<<2)|0);Qmc(h,k,d);f[l>>2]=1065353216;y=x<<2;Pmc(m,e,t+(y<<2)|0);Rmc(i,l,m);x=w<<2;w=t+(x<<2)|0;if((i|0)!=(w|0))f[w>>2]=f[i>>2];Pmc(o,h,t+((y|1)<<2)|0);Qmc(m,o,i);y=t+((x|1)<<2)|0;if((m|0)!=(y|0))f[y>>2]=f[m>>2]}while((v|0)!=1024);v=0;do{o=1024-v|0;l=o+-1|0;e=l<<2;k=t+((e|1)<<2)|0;j=t+(e<<2)|0;Qmc(i,j,g);Pmc(h,k,i);y=a+(l<<2)|0;Pmc(p,a+(o<<2)|0,y);Qmc(q,h,c);Mmc(r,g,q);Rmc(m,r,d);Pmc(i,p,m);Pmc(s,g,h);Rmc(m,s,d);if((y|0)!=(j|0))f[j>>2]=f[y>>2];if((i|0)!=(k|0))f[k>>2]=f[i>>2];k=t+((e|2)<<2)|0;if((h|0)!=(k|0))f[k>>2]=f[h>>2];k=t+((e|3)<<2)|0;if((m|0)!=(k|0))f[k>>2]=f[m>>2];f[g>>2]=f[h>>2];v=v+1|0}while((v|0)!=1024);u=b;return t|0}function Fza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+48|0;d=c+40|0;e=c+24|0;g=c+32|0;h=c+8|0;i=c+16|0;j=c;Lmc(d,b);if(inc(d,520008)|0){gnc(e,d,520024);anc(a,e);u=c;return}else{bnc(h,d,520040);d=j;f[d>>2]=0;f[d+4>>2]=1072693248;bnc(i,j,520040);gnc(g,h,i);onc(e,g,520032);anc(a,e);u=c;return}}function Gza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+64|0;d=c+56|0;e=c+40|0;g=c+48|0;h=c+24|0;i=c+16|0;j=c+32|0;k=c+8|0;l=c;Lmc(d,b);if(inc(d,520016)|0){fnc(e,d,520024);anc(a,e);u=c;return}else{b=h;f[b>>2]=0;f[b+4>>2]=1072693248;gnc(g,h,520032);onc(i,d,g);g=k;f[g>>2]=0;f[g+4>>2]=1072693248;bnc(j,k,520040);fnc(l,i,j);enc(e,l,520040);anc(a,e);u=c;return}}function Hza(a){a=a|0;YDc(a);return}function Iza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){Jza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function Jza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=f[a+44>>2]|0;p=b[a+40>>0]|0?f[220268]|0:0;q=+n[a+4>>2];r=+n[a+8>>2];s=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=e*3|0;if((b[a+41>>0]|0)!=0&(e|0)>0){e=o^2;a=f[130024]|0;B=0;C=c;while(1){D=+n[C+(o<<2)>>2];if(!(D<0.0))if(D>1.0)E=1.0;else E=D;else E=0.0;D=+n[C+4>>2];if(!(D<0.0))if(D>1.0)F=1.0;else F=D;else F=0.0;D=+n[C+(e<<2)>>2];if(!(D<0.0))if(D>1.0)G=1.0;else G=D;else G=0.0;H=mrc(E*16384.0)|0;I=mrc(F*16384.0)|0;Dza(H,I,mrc(G*16384.0)|0,a,h,i,j);D=+(f[i>>2]|0)*.00006103515625;J=+(f[j>>2]|0)*.00006103515625;n[d+(B<<2)>>2]=+(f[h>>2]|0)*.00006103515625*100.0;n[d+(B+1<<2)>>2]=D*256.0+-128.0;n[d+(B+2<<2)>>2]=J*256.0+-128.0;I=B+3|0;H=C+(m<<2)|0;if((I|0)<(A|0)){B=I;C=H}else{K=H;L=I;break}}}else{K=c;L=0}if((b[520240]|0)==0?MIc(520240)|0:0){Kmc(k,16);Kmc(h,116);Rmc(l,k,h);f[220298]=f[l>>2]}if((L|0)>=(A|0)){u=g;return}l=(p|0)==0;h=L;L=K;while(1){G=+n[L>>2];if(!(G<0.0))if(G>1.0)M=1.0;else M=G;else M=0.0;G=+n[L+4>>2];if(!(G<0.0))if(G>1.0)N=1.0;else N=G;else N=0.0;G=+n[L+8>>2];if(!(G<0.0))if(G>1.0)O=1.0;else O=G;else O=0.0;if(l){P=M;Q=N;R=O}else{G=M*1024.0;K=~~G;k=(K|0)>0?K:0;K=(k|0)<1023?k:1023;F=G-+(K|0);k=p+(K<<2<<2)|0;G=N*1024.0;K=~~G;c=(K|0)>0?K:0;K=(c|0)<1023?c:1023;E=G-+(K|0);c=p+(K<<2<<2)|0;G=O*1024.0;K=~~G;C=(K|0)>0?K:0;K=(C|0)<1023?C:1023;J=G-+(K|0);C=p+(K<<2<<2)|0;P=+n[k>>2]+F*(+n[k+4>>2]+F*(F*+n[k+12>>2]+ +n[k+8>>2]));Q=+n[c>>2]+E*(+n[c+4>>2]+E*(E*+n[c+12>>2]+ +n[c+8>>2]));R=+n[C>>2]+J*(+n[C+4>>2]+J*(J*+n[C+12>>2]+ +n[C+8>>2]))}J=s*R+(r*Q+q*P);E=w*R+(v*Q+t*P);F=z*R+(y*Q+x*P);if(J>.008856000378727913)S=+Z2(J);else S=J*7.7870001792907715+ +n[220298];C=E>.008856000378727913;if(C)T=+Z2(E);else T=E*7.7870001792907715+ +n[220298];if(F>.008856000378727913)U=+Z2(F);else U=F*7.7870001792907715+ +n[220298];n[d+(h<<2)>>2]=C?T*116.0+-16.0:E*903.2999877929688;n[d+(h+1<<2)>>2]=(S-T)*500.0;n[d+(h+2<<2)>>2]=(T-U)*200.0;h=h+3|0;if((h|0)>=(A|0))break;else L=L+(m<<2)|0}u=g;return}function Kza(a){a=a|0;YDc(a);return}function Lza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){Mza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function Mza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=b[a+40>>0]|0?1124736:1125248;i=f[a>>2]|0;k=f[a+4>>2]|0;l=f[a+8>>2]|0;m=f[a+12>>2]|0;n=f[a+16>>2]|0;o=f[a+20>>2]|0;p=f[a+24>>2]|0;q=f[a+28>>2]|0;r=f[a+32>>2]|0;s=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){t=0;u=c}else return;while(1){c=j[g+(h[u>>0]<<1)>>1]|0;e=j[g+(h[u+1>>0]<<1)>>1]|0;v=j[g+(h[u+2>>0]<<1)>>1]|0;w=1142144+((Y(c,k)|0)+2048+(Y(e,l)|0)+(Y(v,m)|0)>>12<<1)|0;x=1142144+((Y(c,n)|0)+2048+(Y(e,o)|0)+(Y(v,p)|0)>>12<<1)|0;y=j[x>>1]|0;x=1142144+((Y(c,q)|0)+2048+(Y(e,r)|0)+(Y(v,s)|0)>>12<<1)|0;v=(y*296|0)+-1320550>>15;e=(((j[w>>1]|0)-y|0)*500|0)+4210688>>15;w=((y-(j[x>>1]|0)|0)*200|0)+4210688>>15;b[d+t>>0]=v>>>0<256?v:(v|0)>0?255:0;b[d+(t+1)>>0]=e>>>0<256?e:(e|0)>0?255:0;b[d+(t+2)>>0]=w>>>0<256?w:(w|0)>0?255:0;t=t+3|0;if((t|0)>=(a|0))break;else u=u+i|0}return}function Nza(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0;n=u;u=u+144|0;o=n+136|0;p=n+104|0;q=n;r=k?2:0;k=(i|0)==0;if(l)if(k){Oza(q,3,r,0,0,m);Pza(q+56|0,j,r,0,0,m);f[q+100>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=61612;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;y8(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else{Oza(q,j,r,0,0,m);f[q+56>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=61632;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;y8(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else if(k){f[q>>2]=j;Qza(q+4|0,j,r,0,0,m);Rza(q+56|0,j,r,0,0,m);b[q+100>>0]=1;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=61652;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;y8(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else{Qza(q,j,r,0,0,m);f[q+52>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=61672;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;y8(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}}function Oza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+96|0;j=i+48|0;k=i+24|0;l=i+16|0;m=i+8|0;o=i;q=i+80|0;r=i+76|0;s=i+72|0;f[a>>2]=c;b[a+40>>0]=h&1;h=a+52|0;f[h>>2]=d;vza();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[129996];f[j+4>>2]=f[129997];f[j+8>>2]=f[129998];f[j+12>>2]=f[129999];f[j+16>>2]=f[13e4];f[j+20>>2]=f[130001]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}g=k+8|0;d=k+16|0;if(e|0){c=k+8|0;t=k+16|0;p[k>>3]=+n[e>>2];p[c>>3]=+n[e+12>>2];p[t>>3]=+n[e+24>>2];fnc(l,k,j);n[a+4+((f[h>>2]^2)*3<<2)>>2]=+p[l>>3];fnc(m,g,j);n[a+16>>2]=+p[m>>3];fnc(o,d,j);n[a+4+((f[h>>2]|0)*3<<2)>>2]=+p[o>>3];p[k>>3]=+n[e+4>>2];p[c>>3]=+n[e+16>>2];p[t>>3]=+n[e+28>>2];v=j+8|0;fnc(l,k,v);n[a+4+(((f[h>>2]^2)*3|0)+1<<2)>>2]=+p[l>>3];fnc(m,g,v);n[a+20>>2]=+p[m>>3];fnc(o,d,v);n[a+4+(((f[h>>2]|0)*3|0)+1<<2)>>2]=+p[o>>3];p[k>>3]=+n[e+8>>2];p[c>>3]=+n[e+20>>2];p[t>>3]=+n[e+32>>2];e=j+16|0;fnc(l,k,e);n[a+4+(((f[h>>2]^2)*3|0)+2<<2)>>2]=+p[l>>3];fnc(m,g,e);n[a+24>>2]=+p[m>>3];fnc(o,d,e);n[a+4+(((f[h>>2]|0)*3|0)+2<<2)>>2]=+p[o>>3];Kmc(q,8);w=f[q>>2]|0;x=a+44|0;f[x>>2]=w;Kmc(r,6);Kmc(k,29);Rmc(s,r,k);y=f[s>>2]|0;z=a+48|0;f[z>>2]=y;u=i;return}e=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;t=519912+(e<<3)|0;if((t|0)!=(k|0)){c=t;t=f[c+4>>2]|0;v=k;f[v>>2]=f[c>>2];f[v+4>>2]=t}t=e+3|0;v=519912+(t<<3)|0;if((v|0)!=(g|0)){c=v;v=f[c+4>>2]|0;A=g;f[A>>2]=f[c>>2];f[A+4>>2]=v}v=519912+(e+6<<3)|0;if((v|0)!=(d|0)){A=v;v=f[A+4>>2]|0;c=d;f[c>>2]=f[A>>2];f[c+4>>2]=v}v=j+(e<<3)|0;fnc(l,k,v);n[a+4+(((f[h>>2]^2)*3|0)+e<<2)>>2]=+p[l>>3];fnc(m,g,v);n[a+4+(t<<2)>>2]=+p[m>>3];fnc(o,d,v);n[a+4+(((f[h>>2]|0)*3|0)+e<<2)>>2]=+p[o>>3];e=e+1|0}while((e|0)!=3);Kmc(q,8);w=f[q>>2]|0;x=a+44|0;f[x>>2]=w;Kmc(r,6);Kmc(k,29);Rmc(s,r,k);y=f[s>>2]|0;z=a+48|0;f[z>>2]=y;u=i;return}function Pza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+80|0;j=i+56|0;k=i+32|0;l=i+24|0;m=i+16|0;o=i+8|0;q=i;f[a>>2]=c;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[129996];f[j+4>>2]=f[129997];f[j+8>>2]=f[129998];f[j+12>>2]=f[129999];f[j+16>>2]=f[13e4];f[j+20>>2]=f[130001]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}if((b[520304]|0)==0?MIc(520304)|0:0)Vmc(520312,4096);g=d*3|0;c=k+8|0;r=k+16|0;s=(d^2)*3|0;if(e|0){d=k+8|0;t=k+16|0;v=0;do{p[k>>3]=+n[e+(v<<2)>>2];w=v+3|0;p[d>>3]=+n[e+(w<<2)>>2];p[t>>3]=+n[e+(v+6<<2)>>2];fnc(m,520312,k);x=j+(v<<3)|0;fnc(l,m,x);y=Zmc(l)|0;f[a+4+(v+g<<2)>>2]=y;fnc(o,520312,c);fnc(l,o,x);y=Zmc(l)|0;f[a+4+(w<<2)>>2]=y;fnc(q,520312,r);fnc(l,q,x);x=Zmc(l)|0;f[a+4+(v+s<<2)>>2]=x;v=v+1|0}while((v|0)!=3);z=h?1125760:1133952;A=a+40|0;f[A>>2]=z;u=i;return}v=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;e=519912+(v<<3)|0;if((e|0)!=(k|0)){t=e;e=f[t+4>>2]|0;d=k;f[d>>2]=f[t>>2];f[d+4>>2]=e}e=v+3|0;d=519912+(e<<3)|0;if((d|0)!=(c|0)){t=d;d=f[t+4>>2]|0;x=c;f[x>>2]=f[t>>2];f[x+4>>2]=d}d=519912+(v+6<<3)|0;if((d|0)!=(r|0)){x=d;d=f[x+4>>2]|0;t=r;f[t>>2]=f[x>>2];f[t+4>>2]=d}fnc(m,520312,k);d=j+(v<<3)|0;fnc(l,m,d);t=Zmc(l)|0;f[a+4+(v+g<<2)>>2]=t;fnc(o,520312,c);fnc(l,o,d);t=Zmc(l)|0;f[a+4+(e<<2)>>2]=t;fnc(q,520312,r);fnc(l,q,d);d=Zmc(l)|0;f[a+4+(v+s<<2)>>2]=d;v=v+1|0}while((v|0)!=3);z=h?1125760:1133952;A=a+40|0;f[A>>2]=z;u=i;return}function Qza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+112|0;j=i+48|0;k=i+100|0;l=i+40|0;m=i+24|0;o=i+32|0;q=i+16|0;r=i+8|0;s=i;t=i+96|0;v=i+92|0;w=i+88|0;x=i+84|0;y=i+80|0;z=i+76|0;A=i+72|0;f[a>>2]=c;b[a+48>>0]=h&1;vza();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[129996];f[j+4>>2]=f[129997];f[j+8>>2]=f[129998];f[j+12>>2]=f[129999];f[j+16>>2]=f[13e4];f[j+20>>2]=f[130001]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}g=(d^2)*3|0;h=d*3|0;if(!e){anc(k,519912);d=f[k>>2]|0;anc(k,519936);c=f[k>>2]|0;anc(k,519960);B=f[k>>2]|0;f[a+4+(g<<2)>>2]=d;f[a+16>>2]=c;f[a+4+(h<<2)>>2]=B;anc(k,519920);B=f[k>>2]|0;anc(k,519944);c=f[k>>2]|0;anc(k,519968);d=f[k>>2]|0;f[a+4+(g+1<<2)>>2]=B;f[a+20>>2]=c;f[a+4+(h+1<<2)>>2]=d;anc(k,519928);d=f[k>>2]|0;anc(k,519952);c=f[k>>2]|0;anc(k,519976);C=f[k>>2]|0;D=c;E=d}else{d=f[e+12>>2]|0;c=f[e+24>>2]|0;f[a+4+(g<<2)>>2]=f[e>>2];f[a+16>>2]=d;f[a+4+(h<<2)>>2]=c;c=f[e+16>>2]|0;d=f[e+28>>2]|0;f[a+4+(g+1<<2)>>2]=f[e+4>>2];f[a+20>>2]=c;f[a+4+(h+1<<2)>>2]=d;C=f[e+32>>2]|0;D=f[e+20>>2]|0;E=f[e+8>>2]|0}f[a+4+(g+2<<2)>>2]=E;f[a+24>>2]=D;f[a+4+(h+2<<2)>>2]=C;C=j+8|0;Vmc(m,15);fnc(l,C,m);bnc(o,j,l);Vmc(r,3);fnc(q,j+16|0,r);bnc(s,o,q);anc(k,s);f[t>>2]=1065353216;f[q>>2]=872415232;s=Smc(k,q)|0;f[m>>2]=f[(s?k:q)>>2];Rmc(l,t,m);f[k>>2]=f[l>>2];Kmc(v,52);Qmc(w,v,k);anc(l,j);Qmc(x,w,l);f[a+40>>2]=f[x>>2];Kmc(y,117);Qmc(z,y,k);anc(l,C);Qmc(A,z,l);f[a+44>>2]=f[A>>2];A=l;f[A>>2]=0;f[A+4>>2]=1072693248;if(hnc(C,l)|0){u=i;return}else{f[l>>2]=0;f[l+4>>2]=0;i=tT(l,31)|0;C=289851;A=i+31|0;do{b[i>>0]=b[C>>0]|0;i=i+1|0;C=C+1|0}while((i|0)<(A|0));z5(-215,l,290302,289780,3179)}}function Rza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0;g=u;u=u+32|0;i=g+8|0;j=g;f[a>>2]=c;vza();if((b[520288]|0)==0?MIc(520288)|0:0)Vmc(520296,4096);c=d*3|0;k=i+8|0;l=i+16|0;m=(d^2)*3|0;if(!e){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=519912;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=519936;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=519960;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;fnc(j,520296,i);d=Zmc(j)|0;f[a+4+(c<<2)>>2]=d;fnc(j,520296,k);d=Zmc(j)|0;f[a+16>>2]=d;fnc(j,520296,l);d=Zmc(j)|0;f[a+4+(m<<2)>>2]=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=519920;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=519944;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=519968;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;fnc(j,520296,i);d=Zmc(j)|0;f[a+4+(c+1<<2)>>2]=d;fnc(j,520296,k);d=Zmc(j)|0;f[a+20>>2]=d;fnc(j,520296,l);d=Zmc(j)|0;f[a+4+(m+1<<2)>>2]=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=519928;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=519952;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=519976;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;fnc(j,520296,i);d=Zmc(j)|0;f[a+4+(c+2<<2)>>2]=d;fnc(j,520296,k);d=Zmc(j)|0;f[a+24>>2]=d;fnc(j,520296,l);d=Zmc(j)|0;f[a+4+(m+2<<2)>>2]=d;r=h?1125760:1133952;s=a+40|0;f[s>>2]=r;u=g;return}else{p[i>>3]=+n[e>>2];d=i+8|0;p[d>>3]=+n[e+12>>2];o=i+16|0;p[o>>3]=+n[e+24>>2];fnc(j,520296,i);q=Zmc(j)|0;f[a+4+(c<<2)>>2]=q;fnc(j,520296,k);q=Zmc(j)|0;f[a+16>>2]=q;fnc(j,520296,l);q=Zmc(j)|0;f[a+4+(m<<2)>>2]=q;p[i>>3]=+n[e+4>>2];p[d>>3]=+n[e+16>>2];p[o>>3]=+n[e+28>>2];fnc(j,520296,i);q=Zmc(j)|0;f[a+4+(c+1<<2)>>2]=q;fnc(j,520296,k);q=Zmc(j)|0;f[a+20>>2]=q;fnc(j,520296,l);q=Zmc(j)|0;f[a+4+(m+1<<2)>>2]=q;p[i>>3]=+n[e+8>>2];p[d>>3]=+n[e+20>>2];p[o>>3]=+n[e+32>>2];fnc(j,520296,i);i=Zmc(j)|0;f[a+4+(c+2<<2)>>2]=i;fnc(j,520296,k);k=Zmc(j)|0;f[a+24>>2]=k;fnc(j,520296,l);l=Zmc(j)|0;f[a+4+(m+2<<2)>>2]=l;r=h?1125760:1133952;s=a+40|0;f[s>>2]=r;u=g;return}}function Sza(a){a=a|0;YDc(a);return}function Tza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){Uza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function Uza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=b[a+48>>0]|0?f[220276]|0:0;p=+n[a+4>>2];q=+n[a+8>>2];r=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=+n[a+40>>2];B=+n[a+44>>2];a=e*3|0;if((e|0)<=0){u=g;return}e=(o|0)==0;C=(m|0)==4;D=d;d=0;while(1){E=+n[c+(d<<2)>>2];if(!(E>=8.0))F=E*.001107051968574524;else{G=(E+16.0)*.008620689623057842;F=G*(G*G)}G=(+n[c+(d+1<<2)>>2]+A*E)*3.0;H=.25/(B*E+ +n[c+(d+2<<2)>>2]);I=H>.25?.25:H;H=I<-.25?-.25:I;I=H*(G*(F*3.0));J=((E*156.0-G)*H+-5.0)*F;H=r*J+(q*F+p*I);n[h>>2]=H;G=w*J+(v*F+t*I);n[i>>2]=G;E=z*J+(y*F+x*I);n[j>>2]=E;n[k>>2]=0.0;K=H<0.0?k:h;n[l>>2]=1.0;L=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[h>>2]=L;n[k>>2]=0.0;K=G<0.0?k:i;n[l>>2]=1.0;M=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[i>>2]=M;n[k>>2]=0.0;K=E<0.0?k:j;n[l>>2]=1.0;N=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[j>>2]=N;if(e)O=L;else{E=(f[s>>2]=N,+n[s>>2]);G=(f[s>>2]=M,+n[s>>2]);H=(f[s>>2]=L,+n[s>>2])*1024.0;L=~~H;M=(L|0)>0?L:0;L=(M|0)<1023?M:1023;I=H-+(L|0);M=o+(L<<2<<2)|0;H=+n[M>>2]+I*(+n[M+4>>2]+I*(+n[M+8>>2]+ +n[M+12>>2]*I));n[h>>2]=H;I=G*1024.0;M=~~I;L=(M|0)>0?M:0;M=(L|0)<1023?L:1023;G=I-+(M|0);L=o+(M<<2<<2)|0;n[i>>2]=+n[L>>2]+G*(+n[L+4>>2]+G*(+n[L+8>>2]+ +n[L+12>>2]*G));G=E*1024.0;L=~~G;M=(L|0)>0?L:0;L=(M|0)<1023?M:1023;E=G-+(L|0);M=o+(L<<2<<2)|0;n[j>>2]=+n[M>>2]+E*(+n[M+4>>2]+E*(+n[M+8>>2]+ +n[M+12>>2]*E));O=(n[s>>2]=H,f[s>>2]|0)}f[D>>2]=O;f[D+4>>2]=f[i>>2];f[D+8>>2]=f[j>>2];if(C)n[D+12>>2]=1.0;d=d+3|0;if((d|0)>=(a|0))break;else D=D+(m<<2)|0}u=g;return}function Vza(a){a=a|0;YDc(a);return}function Wza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){Xza(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function Xza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;g=u;u=u+3088|0;i=g;j=g+3072|0;if(b[a+100>>0]|0){Yza(a+56|0,c,d,e);u=g;return}k=f[a>>2]|0;if((b[520264]|0)==0?MIc(520264)|0:0){Kmc(j,100);Rmc(881196,j,881068)}if((b[520272]|0)==0?MIc(520272)|0:0)Rmc(881200,881040,881068);if((b[520280]|0)==0?MIc(520280)|0:0)Rmc(881204,881052,881068);if((e|0)>0){j=a+4|0;a=(k|0)==4;l=c;c=d;d=0;m=~e;while(1){o=(Y((m|0)>-257?m:-257,-3)|0)+-19|0;p=((o|0)>16?o:16)+-1&-16;o=p+16|0;q=e-d|0;r=(q|0)<256?q:256;s=+n[220299];t=+n[220300];v=+n[220301];w=+n[220258];x=+n[220261];q=r*3|0;y=q+-48|0;if((y|0)>0){z=0;while(1){A=l+z|0;B=b[A+4>>0]|0;C=b[A+5>>0]|0;D=b[A+6>>0]|0;E=b[A+7>>0]|0;F=b[A+8>>0]|0;G=b[A+9>>0]|0;H=b[A+10>>0]|0;I=b[A+11>>0]|0;J=b[A+12>>0]|0;K=b[A+13>>0]|0;L=b[A+14>>0]|0;M=b[A+15>>0]|0;N=i+(z<<2)|0;O=w+t*+(h[A+1>>0]|0);P=x+v*+(h[A+2>>0]|0);Q=s*+(h[A+3>>0]|0)+0.0;n[N>>2]=s*+(h[A>>0]|0)+0.0;n[N+4>>2]=O;n[N+8>>2]=P;n[N+12>>2]=Q;n[N+16>>2]=w+t*+(B&255);n[N+20>>2]=x+v*+(C&255);n[N+24>>2]=s*+(D&255)+0.0;n[N+28>>2]=w+t*+(E&255);n[N+32>>2]=x+v*+(F&255);n[N+36>>2]=s*+(G&255)+0.0;n[N+40>>2]=w+t*+(H&255);n[N+44>>2]=x+v*+(I&255);n[N+48>>2]=s*+(J&255)+0.0;n[N+52>>2]=w+t*+(K&255);n[N+56>>2]=x+v*+(L&255);n[N+60>>2]=s*+(M&255)+0.0;M=A+16|0;L=b[M+4>>0]|0;K=b[M+5>>0]|0;J=b[M+6>>0]|0;I=b[M+7>>0]|0;H=b[M+8>>0]|0;G=b[M+9>>0]|0;F=b[M+10>>0]|0;E=b[M+11>>0]|0;D=b[M+12>>0]|0;C=b[M+13>>0]|0;B=b[M+14>>0]|0;R=b[M+15>>0]|0;Q=x+v*+(h[M+1>>0]|0);P=s*+(h[M+2>>0]|0)+0.0;O=w+t*+(h[M+3>>0]|0);n[N+64>>2]=w+t*+(h[M>>0]|0);n[N+68>>2]=Q;n[N+72>>2]=P;n[N+76>>2]=O;n[N+80>>2]=x+v*+(L&255);n[N+84>>2]=s*+(K&255)+0.0;n[N+88>>2]=w+t*+(J&255);n[N+92>>2]=x+v*+(I&255);n[N+96>>2]=s*+(H&255)+0.0;n[N+100>>2]=w+t*+(G&255);n[N+104>>2]=x+v*+(F&255);n[N+108>>2]=s*+(E&255)+0.0;n[N+112>>2]=w+t*+(D&255);n[N+116>>2]=x+v*+(C&255);n[N+120>>2]=s*+(B&255)+0.0;n[N+124>>2]=w+t*+(R&255);R=A+32|0;A=b[R+4>>0]|0;B=b[R+5>>0]|0;C=b[R+6>>0]|0;D=b[R+7>>0]|0;E=b[R+8>>0]|0;F=b[R+9>>0]|0;G=b[R+10>>0]|0;H=b[R+11>>0]|0;I=b[R+12>>0]|0;J=b[R+13>>0]|0;K=b[R+14>>0]|0;L=b[R+15>>0]|0;O=s*+(h[R+1>>0]|0)+0.0;P=w+t*+(h[R+2>>0]|0);Q=x+v*+(h[R+3>>0]|0);n[N+128>>2]=x+v*+(h[R>>0]|0);n[N+132>>2]=O;n[N+136>>2]=P;n[N+140>>2]=Q;n[N+144>>2]=s*+(A&255)+0.0;n[N+148>>2]=w+t*+(B&255);n[N+152>>2]=x+v*+(C&255);n[N+156>>2]=s*+(D&255)+0.0;n[N+160>>2]=w+t*+(E&255);n[N+164>>2]=x+v*+(F&255);n[N+168>>2]=s*+(G&255)+0.0;n[N+172>>2]=w+t*+(H&255);n[N+176>>2]=x+v*+(I&255);n[N+180>>2]=s*+(J&255)+0.0;n[N+184>>2]=w+t*+(K&255);n[N+188>>2]=x+v*+(L&255);L=z+48|0;if((L|0)<(y|0))z=L;else{S=L;break}}}else S=0;if((S|0)<(q|0)){v=+n[220299];x=+n[220300];t=+n[220258];w=+n[220301];s=+n[220261];z=S;do{n[i+(z<<2)>>2]=+(h[l+z>>0]|0)*v;y=z+1|0;n[i+(y<<2)>>2]=+(h[l+y>>0]|0)*x+t;y=z+2|0;n[i+(y<<2)>>2]=+(h[l+y>>0]|0)*w+s;z=z+3|0}while((z|0)<(q|0))}Uza(j,i,i,r);z=q+-16|0;if((q|0)>16){y=c+16|0;L=c;N=0;while(1){K=i+(N<<2)|0;s=+n[K+16>>2];w=+n[K+20>>2];t=+n[K+24>>2];x=+n[K+28>>2];v=+n[K+32>>2];Q=+n[K+36>>2];P=+n[K+40>>2];O=+n[K+44>>2];T=+n[K+48>>2];U=+n[K+52>>2];V=+n[K+56>>2];W=+n[K+60>>2];X=+n[K+4>>2]*255.0;Z=+n[K+8>>2]*255.0;_=+n[K+12>>2]*255.0;J=mrc(+n[K>>2]*255.0)|0;K=mrc(X)|0;I=mrc(Z)|0;H=mrc(_)|0;G=mrc(s*255.0)|0;F=mrc(w*255.0)|0;E=mrc(t*255.0)|0;D=mrc(x*255.0)|0;C=mrc(v*255.0)|0;B=mrc(Q*255.0)|0;A=mrc(P*255.0)|0;R=mrc(O*255.0)|0;M=mrc(T*255.0)|0;$=mrc(U*255.0)|0;aa=mrc(V*255.0)|0;ba=mrc(W*255.0)|0;ca=((J+32768|0)>>>0<65536?J:(J|0)>0?32767:32768)&65535;J=((C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768)&65535;C=((K+32768|0)>>>0<65536?K:(K|0)>0?32767:32768)&65535;K=((B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768)&65535;B=((I+32768|0)>>>0<65536?I:(I|0)>0?32767:32768)&65535;I=((A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768)&65535;A=((H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768)&65535;H=((R+32768|0)>>>0<65536?R:(R|0)>0?32767:32768)&65535;R=((G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768)&65535;G=((M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768)&65535;M=((F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768)&65535;F=(($+32768|0)>>>0<65536?$:($|0)>0?32767:32768)&65535;$=((E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768)&65535;E=((aa+32768|0)>>>0<65536?aa:(aa|0)>0?32767:32768)&65535;aa=((D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768)&65535;D=((ba+32768|0)>>>0<65536?ba:(ba|0)>0?32767:32768)&65535;b[L>>0]=ca>>>0<255?ca:255;b[L+1>>0]=C>>>0<255?C:255;b[L+2>>0]=B>>>0<255?B:255;b[L+3>>0]=A>>>0<255?A:255;b[L+4>>0]=R>>>0<255?R:255;b[L+5>>0]=M>>>0<255?M:255;b[L+6>>0]=$>>>0<255?$:255;b[L+7>>0]=aa>>>0<255?aa:255;b[L+8>>0]=J>>>0<255?J:255;b[L+9>>0]=K>>>0<255?K:255;b[L+10>>0]=I>>>0<255?I:255;b[L+11>>0]=H>>>0<255?H:255;b[L+12>>0]=G>>>0<255?G:255;b[L+13>>0]=F>>>0<255?F:255;b[L+14>>0]=E>>>0<255?E:255;b[L+15>>0]=D>>>0<255?D:255;N=N+16|0;if((N|0)>=(z|0))break;else L=L+16|0}da=y+p|0;ea=o}else{da=c;ea=0}if((ea|0)<(q|0))if(a){L=da;z=ea;while(1){N=mrc(+n[i+(z<<2)>>2]*255.0)|0;b[L>>0]=N>>>0<256?N:(N|0)>0?255:0;N=mrc(+n[i+(z+1<<2)>>2]*255.0)|0;b[L+1>>0]=N>>>0<256?N:(N|0)>0?255:0;N=mrc(+n[i+(z+2<<2)>>2]*255.0)|0;b[L+2>>0]=N>>>0<256?N:(N|0)>0?255:0;b[L+3>>0]=-1;z=z+3|0;N=L+4|0;if((z|0)>=(q|0)){fa=N;break}else L=N}}else{L=da;z=ea;while(1){o=mrc(+n[i+(z<<2)>>2]*255.0)|0;b[L>>0]=o>>>0<256?o:(o|0)>0?255:0;o=mrc(+n[i+(z+1<<2)>>2]*255.0)|0;b[L+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=mrc(+n[i+(z+2<<2)>>2]*255.0)|0;b[L+2>>0]=o>>>0<256?o:(o|0)>0?255:0;z=z+3|0;o=L+k|0;if((z|0)>=(q|0)){fa=o;break}else L=o}}else fa=da;d=d+256|0;if((d|0)>=(e|0))break;else{l=l+768|0;c=fa;m=m+256|0}}}u=g;return}function Yza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;k=f[a>>2]|0;l=e*3|0;if((e|0)<=0){u=g;return}if((k|0)==4){e=0;m=d;while(1){Zza(a,b[c+e>>0]|0,b[c+(e+1)>>0]|0,b[c+(e+2)>>0]|0,h,i,j);n=f[j>>2]|0;b[m>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[i>>2]|0;b[m+1>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[h>>2]|0;b[m+2>>0]=n>>>0<256?n:(n|0)>0?255:0;b[m+3>>0]=-1;e=e+3|0;if((e|0)>=(l|0))break;else m=m+4|0}u=g;return}else{m=0;e=d;while(1){Zza(a,b[c+m>>0]|0,b[c+(m+1)>>0]|0,b[c+(m+2)>>0]|0,h,i,j);d=f[j>>2]|0;b[e>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[i>>2]|0;b[e+1>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[h>>2]|0;b[e+2>>0]=d>>>0<256?d:(d|0)>0?255:0;m=m+3|0;if((m|0)>=(l|0))break;else e=e+k|0}u=g;return}}function Zza(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=b&255;b=d[1148288+(k<<1<<1)>>1]|0;l=k<<8;k=f[(f[220282]|0)+((l|c&255)<<2)>>2]|0;c=e&255|l;l=f[(f[220283]|0)+(c<<2)>>2]|0;e=mJc(l|0,((l|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;k=J;l=kJc(e|0,k|0,16384,0)|0;m=b&65535;n=Y(l,m)|0;l=(n|0)/16384|0;o=(f[220284]|0)+(c<<3)|0;c=f[o>>2]|0;p=f[o+4>>2]|0;o=mJc(e|0,k|0,-85,-1)|0;k=UIc(o|0,J|0,c|0,p|0)|0;p=kJc(k|0,J|0,16384,0)|0;k=UIc(p|0,J|0,-20889600,-1)|0;p=mJc(k|0,J|0,b&65535|0,0)|0;b=kJc(p|0,J|0,16384,0)|0;p=((b|0)/256|0)+((b|0)/65536|0)|0;b=(n|0)>16383?((l|0)<32768?l:32768):0;l=(p|0)>0?((p|0)<32768?p:32768):0;p=f[a+16>>2]|0;n=f[a+20>>2]|0;k=f[a+24>>2]|0;c=f[a+28>>2]|0;o=f[a+32>>2]|0;e=f[a+36>>2]|0;q=(Y(f[a+8>>2]|0,m)|0)+8192+(Y(b,f[a+4>>2]|0)|0)+(Y(l,f[a+12>>2]|0)|0)>>14;f[g>>2]=q;q=(Y(n,m)|0)+8192+(Y(b,p)|0)+(Y(l,k)|0)>>14;f[h>>2]=q;q=(Y(c,b)|0)+8192+(Y(o,m)|0)+(Y(l,e)|0)>>14;f[i>>2]=q;q=f[g>>2]|0;f[g>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[h>>2]|0;f[h>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[i>>2]|0;f[i>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[a+40>>2]|0;f[g>>2]=j[q+(f[g>>2]<<1)>>1];f[h>>2]=j[q+(f[h>>2]<<1)>>1];f[i>>2]=j[q+(f[i>>2]<<1)>>1];return}function _za(a){a=a|0;YDc(a);return}function $za(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){aAa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function aAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0;g=f[a>>2]|0;h=b[a+40>>0]|0?f[220276]|0:0;i=+n[a+4>>2];j=+n[a+8>>2];k=+n[a+12>>2];l=+n[a+16>>2];m=+n[a+20>>2];o=+n[a+24>>2];p=+n[a+28>>2];q=+n[a+32>>2];r=+n[a+36>>2];s=e*3|0;if((e|0)<=0)return;e=a+44|0;t=a+48|0;a=(h|0)==0;u=(g|0)==4;v=d;d=0;while(1){w=+n[c+(d<<2)>>2];if(!(w<=+n[e>>2])){x=(w+16.0)/116.0;y=x;z=x*(x*x)}else{x=w/903.2999877929688;y=x*7.7870001792907715+.13793103396892548;z=x}x=+n[c+(d+1<<2)>>2]/500.0+y;w=y-+n[c+(d+2<<2)>>2]/200.0;A=+n[t>>2];if(!(x<=A))B=x*(x*x);else B=(x+-.13793103396892548)/7.7870001792907715;if(!(w<=A))C=w*(w*w);else C=(w+-.13793103396892548)/7.7870001792907715;w=j*z+i*B+k*C;A=m*z+l*B+o*C;x=q*z+p*B+r*C;D=w<0.0?0.0:w>1.0?1.0:w;w=A<0.0?0.0:A>1.0?1.0:A;A=x<0.0?0.0:x>1.0?1.0:x;if(a){E=A;F=w;G=D}else{x=D*1024.0;H=~~x;I=(H|0)>0?H:0;H=(I|0)<1023?I:1023;D=x-+(H|0);I=h+(H<<2<<2)|0;x=w*1024.0;H=~~x;J=(H|0)>0?H:0;H=(J|0)<1023?J:1023;w=x-+(H|0);J=h+(H<<2<<2)|0;x=A*1024.0;H=~~x;K=(H|0)>0?H:0;H=(K|0)<1023?K:1023;A=x-+(H|0);K=h+(H<<2<<2)|0;E=+n[K>>2]+A*(+n[K+4>>2]+A*(A*+n[K+12>>2]+ +n[K+8>>2]));F=+n[J>>2]+w*(+n[J+4>>2]+w*(w*+n[J+12>>2]+ +n[J+8>>2]));G=+n[I>>2]+D*(+n[I+4>>2]+D*(D*+n[I+12>>2]+ +n[I+8>>2]))}n[v>>2]=G;n[v+4>>2]=F;n[v+8>>2]=E;if(u)n[v+12>>2]=1.0;d=d+3|0;if((d|0)>=(s|0))break;else v=v+(g<<2)|0}return}function bAa(a){a=a|0;YDc(a);return}function cAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){dAa((f[h>>2]|0)+56|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function dAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;k=f[a>>2]|0;l=e*3|0;if((e|0)<=0){u=g;return}if((k|0)==4){e=0;m=d;while(1){eAa(a,b[c+e>>0]|0,b[c+(e+1)>>0]|0,b[c+(e+2)>>0]|0,h,i,j);n=f[j>>2]|0;b[m>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[i>>2]|0;b[m+1>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[h>>2]|0;b[m+2>>0]=n>>>0<256?n:(n|0)>0?255:0;b[m+3>>0]=-1;e=e+3|0;if((e|0)>=(l|0))break;else m=m+4|0}u=g;return}else{m=0;e=d;while(1){eAa(a,b[c+m>>0]|0,b[c+(m+1)>>0]|0,b[c+(m+2)>>0]|0,h,i,j);d=f[j>>2]|0;b[e>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[i>>2]|0;b[e+1>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[h>>2]|0;b[e+2>>0]=d>>>0<256?d:(d|0)>0?255:0;m=m+3|0;if((m|0)>=(l|0))break;else e=e+k|0}u=g;return}}function eAa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0;i=(b&255)<<1;b=j[1148288+((i|1)<<1)>>1]|0;k=f[220281]|0;l=f[k+(((((c&255)*268435|0)+128|0)>>>13)+-4194+b+8145<<2)>>2]|0;c=f[k+(10484-((((d&255)*41943|0)+16|0)>>>9)+b+8145<<2)>>2]|0;b=j[1148288+(i<<1)>>1]|0;i=f[a+16>>2]|0;d=f[a+20>>2]|0;k=f[a+24>>2]|0;m=f[a+28>>2]|0;n=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(Y(f[a+4>>2]|0,l)|0)+8192+(Y(f[a+8>>2]|0,b)|0)+(Y(f[a+12>>2]|0,c)|0)>>14;f[e>>2]=p;p=(Y(i,l)|0)+8192+(Y(d,b)|0)+(Y(k,c)|0)>>14;f[g>>2]=p;p=(Y(m,l)|0)+8192+(Y(n,b)|0)+(Y(o,c)|0)>>14;f[h>>2]=p;p=f[e>>2]|0;f[e>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[g>>2]|0;f[g>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[h>>2]|0;f[h>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[a+40>>2]|0;f[e>>2]=j[p+(f[e>>2]<<1)>>1];f[g>>2]=j[p+(f[g>>2]<<1)>>1];f[h>>2]=j[p+(f[h>>2]<<1)>>1];return}function fAa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;Kwa(g,a,b,3);rza(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,1,d);Lwa(g);u=e;return}function gAa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;Kwa(g,a,b,3);rza(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,0,d);Lwa(g);u=e;return}function hAa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;Owa(h,a,b,i);Nza(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,1,e);Pwa(h);u=g;return}function iAa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;Owa(h,a,b,i);Nza(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,0,e);Pwa(h);u=g;return}function jAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+128|0;e=d;kAa(e,a,b,3);_ya(f[e+16>>2]|0,f[e+48>>2]|0,f[e+72>>2]|0,f[e+104>>2]|0,f[e+12>>2]|0,f[e+8>>2]|0,f[e+112>>2]|0,f[e+116>>2]|0,c);lAa(e);u=d;return}function kAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=x>>>3;n=(m&511)+1|0;f[a+116>>2]=n;y=x&7;z=a+112|0;f[z>>2]=y;if((m&510|0)!=2)e2(n,61684);if((e|0)!=3)e2(e,61712);switch(x&7){case 0:case 2:case 5:break;default:b2(y,61740)}y=c+4|0;x=d+4|0;if((f[y>>2]|0)!=(f[x>>2]|0)){do if((d$(c)|0)==65536){e=f[y>>2]|0;f[h>>2]=f[e>>2];n=h+4|0;m=e+4|0;f[n>>2]=f[m>>2];A=h+8|0;f[A>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];B=f[e+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=A;A=h+48|0;C=h+44|0;f[C>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[m>>2]|0)<3){m=f[e+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[m>>2];f[A+4>>2]=f[m+4>>2];break}else{f[n>>2]=0;ZS(h,e);break}}else a$(h,c,-1);while(0);y=h+36|0;e=f[y>>2]|0;if((a|0)==(h|0))D=e;else{if(e|0){n=e+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+36|0;e=f[n>>2]|0;if(e|0?(m=e+12|0,e=f[m>>2]|0,f[m>>2]=e+-1,(e|0)==1):0)_S(a);f[n>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[j>>2]|0)>0){m=f[l>>2]|0;A=0;do{f[m+(A<<2)>>2]=0;A=A+1|0;E=f[j>>2]|0}while((A|0)<(E|0));f[a>>2]=f[h>>2];if((E|0)<3)F=29;else F=31}else{f[a>>2]=f[h>>2];F=29}if((F|0)==29){E=f[h+4>>2]|0;if((E|0)<3){f[j>>2]=E;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;E=f[p>>2]|0;f[E>>2]=f[k>>2];f[E+4>>2]=f[k+4>>2]}else F=31}if((F|0)==31)ZS(a,h);f[e>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];e=f[y>>2]|0;f[n>>2]=e;D=e}if(D|0?(e=D+12|0,D=f[e>>2]|0,f[e>>2]=D+-1,(D|0)==1):0)_S(h);f[y>>2]=0;y=h+16|0;D=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[D>>2]|0)>0){y=f[h+40>>2]|0;e=0;do{f[y+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[D>>2]|0))}D=f[h+44>>2]|0;if((D|0)!=(h+48|0))g0(D)}else{D=h+8|0;f[D>>2]=0;f[D+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;D=f[c>>2]|0;f[t>>2]=l;f[w>>2]=D;f[i>>2]=l;f[i+4>>2]=D;v$(d,i,f[z>>2]&7|16,-1,0,0);do if((d$(d)|0)==65536){z=f[x>>2]|0;f[h>>2]=f[z>>2];i=h+4|0;D=z+4|0;f[i>>2]=f[D>>2];l=h+8|0;f[l>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];w=f[z+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[D>>2]|0)<3){D=f[z+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[D>>2];f[l+4>>2]=f[D+4>>2];break}else{f[i>>2]=0;ZS(h,z);break}}else a$(h,d,-1);while(0);d=h+36|0;x=f[d>>2]|0;if((o|0)==(h|0))G=x;else{if(x|0){z=x+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+92|0;x=f[z>>2]|0;if(x|0?(i=x+12|0,x=f[i>>2]|0,f[i>>2]=x+-1,(x|0)==1):0)_S(o);f[z>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;H=f[q>>2]|0}while((s|0)<(H|0));f[o>>2]=f[h>>2];if((H|0)<3)F=60;else F=62}else{f[o>>2]=f[h>>2];F=60}if((F|0)==60){H=f[h+4>>2]|0;if((H|0)<3){f[q>>2]=H;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;H=f[v>>2]|0;f[H>>2]=f[r>>2];f[H+4>>2]=f[r+4>>2]}else F=62}if((F|0)==62)ZS(o,h);f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[z>>2]=a;G=a}if(G|0?(a=G+12|0,G=f[a>>2]|0,f[a>>2]=G+-1,(G|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;G=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[G>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)==(h+48|0)){u=g;return}g0(G);u=g;return}function lAa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function mAa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+128|0;g=e;h=(c|0)<1?3:c;nAa(g,a,b,h);hza(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,h,d);oAa(g);u=e;return}function nAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=(x>>>3&511)+1|0;f[a+116>>2]=m;n=x&7;y=a+112|0;f[y>>2]=n;if((m|0)!=3)e2(m,61768);if((e+-3|0)>>>0>=2)e2(e,61796);switch(x&7){case 0:case 2:case 5:break;default:b2(n,61824)}n=c+4|0;x=d+4|0;if((f[n>>2]|0)!=(f[x>>2]|0)){do if((d$(c)|0)==65536){m=f[n>>2]|0;f[h>>2]=f[m>>2];z=h+4|0;A=m+4|0;f[z>>2]=f[A>>2];B=h+8|0;f[B>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];C=f[m+36>>2]|0;f[h+36>>2]=C;f[h+40>>2]=B;B=h+48|0;D=h+44|0;f[D>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[m+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;ZS(h,m);break}}else a$(h,c,-1);while(0);n=h+36|0;m=f[n>>2]|0;if((a|0)==(h|0))E=m;else{if(m|0){z=m+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+36|0;m=f[z>>2]|0;if(m|0?(A=m+12|0,m=f[A>>2]|0,f[A>>2]=m+-1,(m|0)==1):0)_S(a);f[z>>2]=0;m=a+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0;F=f[j>>2]|0}while((B|0)<(F|0));f[a>>2]=f[h>>2];if((F|0)<3)G=29;else G=31}else{f[a>>2]=f[h>>2];G=29}if((G|0)==29){F=f[h+4>>2]|0;if((F|0)<3){f[j>>2]=F;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;F=f[p>>2]|0;f[F>>2]=f[k>>2];f[F+4>>2]=f[k+4>>2]}else G=31}if((G|0)==31)ZS(a,h);f[m>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];m=f[n>>2]|0;f[z>>2]=m;E=m}if(E|0?(m=E+12|0,E=f[m>>2]|0,f[m>>2]=E+-1,(E|0)==1):0)_S(h);f[n>>2]=0;n=h+16|0;E=h+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[E>>2]|0)>0){n=f[h+40>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[E>>2]|0))}E=f[h+44>>2]|0;if((E|0)!=(h+48|0))g0(E)}else{E=h+8|0;f[E>>2]=0;f[E+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;E=f[c>>2]|0;f[t>>2]=l;f[w>>2]=E;f[i>>2]=l;f[i+4>>2]=E;v$(d,i,f[y>>2]&7|(e<<3)+-8,-1,0,0);do if((d$(d)|0)==65536){e=f[x>>2]|0;f[h>>2]=f[e>>2];y=h+4|0;i=e+4|0;f[y>>2]=f[i>>2];E=h+8|0;f[E>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=E;E=h+48|0;w=h+44|0;f[w>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(l|0){E=l+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;E=f[w>>2]|0;f[E>>2]=f[i>>2];f[E+4>>2]=f[i+4>>2];break}else{f[y>>2]=0;ZS(h,e);break}}else a$(h,d,-1);while(0);d=h+36|0;x=f[d>>2]|0;if((o|0)==(h|0))H=x;else{if(x|0){e=x+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+92|0;x=f[e>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)_S(o);f[e>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){y=f[s>>2]|0;s=0;do{f[y+(s<<2)>>2]=0;s=s+1|0;I=f[q>>2]|0}while((s|0)<(I|0));f[o>>2]=f[h>>2];if((I|0)<3)G=60;else G=62}else{f[o>>2]=f[h>>2];G=60}if((G|0)==60){I=f[h+4>>2]|0;if((I|0)<3){f[q>>2]=I;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;I=f[v>>2]|0;f[I>>2]=f[r>>2];f[I+4>>2]=f[r+4>>2]}else G=62}if((G|0)==62)ZS(o,h);f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[e>>2]=a;H=a}if(H|0?(a=H+12|0,H=f[a>>2]|0,f[a>>2]=H+-1,(H|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;H=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[H>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[H>>2]|0))}H=f[h+44>>2]|0;if((H|0)==(h+48|0)){u=g;return}g0(H);u=g;return}function oAa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function pAa(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+48|0;m=l+40|0;n=l+12|0;o=l;p=k?2:0;switch(h|0){case 0:{qAa(o,i,j,p);f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=61860;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=o;y8(m,n,+(Y(g,e)|0)*.0000152587890625);u=l;return}case 2:{rAa(o,i,j,p);f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=61880;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=o;y8(m,n,+(Y(g,e)|0)*.0000152587890625);u=l;return}default:{sAa(o,i,j,p);f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=61900;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=o;y8(m,n,+(Y(g,e)|0)*.0000152587890625);u=l;return}}}function qAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;if((c+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,24)|0;j=290948;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,290973,290981,70)}if((d+-3|0)>>>0<2){u=g;return}else{f[h>>2]=0;f[h+4>>2]=0;i=tT(h,24)|0;j=291052;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,290973,290981,71)}}function rAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;if((c+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,24)|0;j=290948;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,290973,290981,70)}if((d+-3|0)>>>0<2){u=g;return}else{f[h>>2]=0;f[h+4>>2]=0;i=tT(h,24)|0;j=291052;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,290973,290981,71)}}function sAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;if((c+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,24)|0;j=290948;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,290973,290981,70)}if((d+-3|0)>>>0<2){u=g;return}else{f[h>>2]=0;f[h+4>>2]=0;i=tT(h,24)|0;j=291052;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,290973,290981,71)}}function tAa(a){a=a|0;YDc(a);return}function uAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;if((h|0)<=0){i=c;do i=i+1|0;while((i|0)<(d|0));return}i=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=i;i=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c>>2]|0;l=f[c+4>>2]|0;m=f[c+8>>2]|0;c=m^2;if((l|0)==4)if((k|0)==4){o=j;p=0;q=i;while(1){r=f[q+4>>2]|0;s=f[q+8>>2]|0;f[o+(m<<2)>>2]=f[q>>2];f[o+4>>2]=r;f[o+(c<<2)>>2]=s;f[o+12>>2]=f[q+12>>2];p=p+1|0;if((p|0)==(h|0))break;else{o=o+16|0;q=q+16|0}}}else{q=j;o=0;p=i;while(1){s=f[p+4>>2]|0;r=f[p+8>>2]|0;f[q+(m<<2)>>2]=f[p>>2];f[q+4>>2]=s;f[q+(c<<2)>>2]=r;n[q+12>>2]=1.0;o=o+1|0;if((o|0)==(h|0))break;else{q=q+16|0;p=p+(k<<2)|0}}}else{p=j;q=0;o=i;while(1){r=f[o+4>>2]|0;s=f[o+8>>2]|0;f[p+(m<<2)>>2]=f[o>>2];f[p+4>>2]=r;f[p+(c<<2)>>2]=s;q=q+1|0;if((q|0)==(h|0))break;else{p=p+(l<<2)|0;o=o+(k<<2)|0}}}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;i=i+b|0}}return}function vAa(a){a=a|0;YDc(a);return}function wAa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[b>>2]|0;e=f[b+4>>2]|0;if((c|0)>=(e|0))return;b=f[a+8>>2]|0;g=f[a+16>>2]|0;h=a+24|0;i=f[a+20>>2]|0;if((i|0)<=0){j=c;do j=j+1|0;while((j|0)<(e|0));return}j=(f[a+12>>2]|0)+(Y(g,c)|0)|0;k=j;j=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[h>>2]|0;l=f[c>>2]|0;m=f[c+4>>2]|0;n=f[c+8>>2]|0;c=n^2;if((m|0)==4)if((l|0)==4){o=k;p=0;q=j;while(1){r=d[q+2>>1]|0;s=d[q+4>>1]|0;d[o+(n<<1)>>1]=d[q>>1]|0;d[o+2>>1]=r;d[o+(c<<1)>>1]=s;d[o+6>>1]=d[q+6>>1]|0;p=p+1|0;if((p|0)==(i|0))break;else{o=o+8|0;q=q+8|0}}}else{q=k;o=0;p=j;while(1){s=d[p+2>>1]|0;r=d[p+4>>1]|0;d[q+(n<<1)>>1]=d[p>>1]|0;d[q+2>>1]=s;d[q+(c<<1)>>1]=r;d[q+6>>1]=-1;o=o+1|0;if((o|0)==(i|0))break;else{q=q+8|0;p=p+(l<<1)|0}}}else{p=k;q=0;o=j;while(1){r=d[o+2>>1]|0;s=d[o+4>>1]|0;d[p+(n<<1)>>1]=d[o>>1]|0;d[p+2>>1]=r;d[p+(c<<1)>>1]=s;q=q+1|0;if((q|0)==(i|0))break;else{p=p+(m<<1)|0;o=o+(l<<1)|0}}}a=a+1|0;if((a|0)>=(e|0))break;else{k=k+g|0;j=j+b|0}}return}function xAa(a){a=a|0;YDc(a);return}function yAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;h=c+4|0;if((d|0)>=(f[h>>2]|0))return;c=(f[a+12>>2]|0)+(Y(f[g>>2]|0,d)|0)|0;i=a+24|0;j=a+20|0;k=c;c=(f[a+4>>2]|0)+(Y(f[e>>2]|0,d)|0)|0;a=d;while(1){d=f[i>>2]|0;l=f[j>>2]|0;m=f[d>>2]|0;n=f[d+4>>2]|0;o=f[d+8>>2]|0;a:do if((l|0)>0){d=o^2;if((n|0)!=4){p=k;q=0;r=c;while(1){s=b[r+1>>0]|0;t=b[r+2>>0]|0;b[p+o>>0]=b[r>>0]|0;b[p+1>>0]=s;b[p+d>>0]=t;q=q+1|0;if((q|0)==(l|0))break a;else{p=p+n|0;r=r+m|0}}}if((m|0)==4){r=k;p=0;q=c;while(1){t=b[q+1>>0]|0;s=b[q+2>>0]|0;b[r+o>>0]=b[q>>0]|0;b[r+1>>0]=t;b[r+d>>0]=s;b[r+3>>0]=b[q+3>>0]|0;p=p+1|0;if((p|0)==(l|0))break;else{r=r+4|0;q=q+4|0}}}else{q=k;r=0;p=c;while(1){s=b[p+1>>0]|0;t=b[p+2>>0]|0;b[q+o>>0]=b[p>>0]|0;b[q+1>>0]=s;b[q+d>>0]=t;b[q+3>>0]=-1;r=r+1|0;if((r|0)==(l|0))break;else{q=q+4|0;p=p+m|0}}}}while(0);a=a+1|0;if((a|0)>=(f[h>>2]|0))break;else{k=k+(f[g>>2]|0)|0;c=c+(f[e>>2]|0)|0}}return}function zAa(a){a=a|0;YDc(a);return}function AAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){BAa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function BAa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0;i=f[a+4>>2]|0;j=(f[a>>2]|0)==3;k=(g|0)>0;if((f[a+8>>2]|0)==6)if(j){if(!k)return;a=i^2;l=c;m=0;while(1){d[e+(m<<1)>>1]=(b[l+1>>0]&-4&255)<<3|(h[l+i>>0]|0)>>>3|(b[l+a>>0]&-8&255)<<8;m=m+1|0;if((m|0)==(g|0))break;else l=l+3|0}return}else{if(!k)return;l=i^2;m=c;a=0;while(1){d[e+(a<<1)>>1]=(b[m+1>>0]&-4&255)<<3|(h[m+i>>0]|0)>>>3|(b[m+l>>0]&-8&255)<<8;a=a+1|0;if((a|0)==(g|0))break;else m=m+4|0}return}else if(j){if(!k)return;j=i^2;m=c;a=0;while(1){d[e+(a<<1)>>1]=(b[m+1>>0]&-8&255)<<2|(h[m+i>>0]|0)>>>3|(b[m+j>>0]&-8&255)<<7;a=a+1|0;if((a|0)==(g|0))break;else m=m+3|0}return}else{if(!k)return;k=i^2;m=c;c=0;while(1){d[e+(c<<1)>>1]=(b[m+1>>0]&-8&255)<<2|(h[m+i>>0]|0)>>>3|(b[m+k>>0]&-8&255)<<7|(b[m+3>>0]|0?32768:0);c=c+1|0;if((c|0)==(g|0))break;else m=m+4|0}return}}function CAa(a){a=a|0;YDc(a);return}function DAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){EAa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function EAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=(e|0)>0;if((f[a+8>>2]|0)==6){if(!i)return;a=h^2;if((g|0)==4){k=0;l=d;while(1){m=j[c+(k<<1)>>1]|0;b[l+h>>0]=m<<3;b[l+1>>0]=m>>>3&252;b[l+a>>0]=m>>>8&248;b[l+3>>0]=-1;k=k+1|0;if((k|0)==(e|0))break;else l=l+4|0}return}else{l=0;k=d;while(1){m=j[c+(l<<1)>>1]|0;b[k+h>>0]=m<<3;b[k+1>>0]=m>>>3&252;b[k+a>>0]=m>>>8&248;l=l+1|0;if((l|0)==(e|0))break;else k=k+g|0}return}}else{if(!i)return;i=h^2;if((g|0)==4){k=0;l=d;while(1){a=j[c+(k<<1)>>1]|0;b[l+h>>0]=a<<3;b[l+1>>0]=a>>>2&248;b[l+i>>0]=a>>>7&248;b[l+3>>0]=a<<16>>31;k=k+1|0;if((k|0)==(e|0))break;else l=l+4|0}return}else{l=0;k=d;while(1){d=j[c+(l<<1)>>1]|0;b[k+h>>0]=d<<3;b[k+1>>0]=d>>>2&248;b[k+i>>0]=d>>>7&248;l=l+1|0;if((l|0)==(e|0))break;else k=k+g|0}return}}}function FAa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=u;u=u+3120|0;l=k+3104|0;m=k+3076|0;n=k;o=j?2:0;switch(h|0){case 0:{f[n>>2]=i;h=f[61952+((o^2)<<2)>>2]|0;p=f[61952+(o<<2)>>2]|0;o=0;q=0;r=8192;s=0;while(1){f[n+4+(s<<2)>>2]=o;f[n+4+(s+256<<2)>>2]=q;f[n+4+(s+512<<2)>>2]=r;s=s+1|0;if((s|0)==256)break;else{o=o+h|0;q=q+9617|0;r=r+p|0}}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=61972;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=n;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}case 2:{f[n>>2]=i;p=n+4|0;f[p>>2]=f[15488];f[p+4>>2]=f[15489];f[p+8>>2]=f[15490];if(!j){f[p>>2]=1868;f[n+12>>2]=4899}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=61992;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=n;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}default:{f[n>>2]=i;i=n+4|0;f[i>>2]=f[15501];f[i+4>>2]=f[15502];f[i+8>>2]=f[15503];if(!j){f[i>>2]=1038710997;f[n+12>>2]=1050220167}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=62024;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=n;y8(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}}}function GAa(a){a=a|0;YDc(a);return}function HAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;if((h|0)<=0){i=c;do i=i+1|0;while((i|0)<(d|0));return}i=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=i;i=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c>>2]|0;l=+n[c+4>>2];m=+n[c+8>>2];o=+n[c+12>>2];c=i;p=0;while(1){n[j+(p<<2)>>2]=l*+n[c>>2]+m*+n[c+4>>2]+o*+n[c+8>>2];p=p+1|0;if((p|0)==(h|0))break;else c=c+(k<<2)|0}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;i=i+b|0}}return}function IAa(a){a=a|0;YDc(a);return}function JAa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[b>>2]|0;e=f[b+4>>2]|0;if((c|0)>=(e|0))return;b=f[a+16>>2]|0;g=(f[a+12>>2]|0)+(Y(b,c)|0)|0;h=f[a+8>>2]|0;i=(f[a+4>>2]|0)+(Y(h,c)|0)|0;k=a+24|0;l=f[a+20>>2]|0;a=(l|0)>0;m=g;g=i;i=c;while(1){c=f[k>>2]|0;n=f[c>>2]|0;o=f[c+4>>2]|0;p=f[c+8>>2]|0;q=f[c+12>>2]|0;if(a){c=g;r=0;while(1){s=Y(j[c>>1]|0,o)|0;t=Y(j[c+2>>1]|0,p)|0;u=(s+8192+t+(Y(j[c+4>>1]|0,q)|0)|0)>>>14&65535;d[m+(r<<1)>>1]=u;r=r+1|0;if((r|0)==(l|0))break;else c=c+(n<<1)|0}}i=i+1|0;if((i|0)>=(e|0))break;else{m=m+b|0;g=g+h|0}}return}function KAa(a){a=a|0;YDc(a);return}function LAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;i=c+4|0;c=f[i>>2]|0;if((d|0)>=(c|0))return;j=f[g>>2]|0;k=(f[a+12>>2]|0)+(Y(j,d)|0)|0;l=f[e>>2]|0;m=a+24|0;n=a+20|0;o=k;k=(f[a+4>>2]|0)+(Y(l,d)|0)|0;a=d;d=c;c=j;j=l;while(1){l=f[m>>2]|0;p=f[n>>2]|0;q=f[l>>2]|0;if((p|0)>0){r=k;s=0;while(1){b[o+s>>0]=((f[l+4+((h[r+1>>0]|0|256)<<2)>>2]|0)+(f[l+4+((h[r>>0]|0)<<2)>>2]|0)+(f[l+4+((h[r+2>>0]|0|512)<<2)>>2]|0)|0)>>>14;s=s+1|0;if((s|0)==(p|0))break;else r=r+q|0}t=f[e>>2]|0;u=f[g>>2]|0;v=f[i>>2]|0}else{t=j;u=c;v=d}a=a+1|0;if((a|0)>=(v|0))break;else{o=o+u|0;k=k+t|0;d=v;c=u;j=t}}return}function MAa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+4|0;m=j;switch(h|0){case 0:{f[m>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=62044;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=m;y8(k,l,+(Y(g,e)|0)*.0000152587890625);u=j;return}case 2:{f[m>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=62064;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=m;y8(k,l,+(Y(g,e)|0)*.0000152587890625);u=j;return}default:{f[m>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=62084;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=m;y8(k,l,+(Y(g,e)|0)*.0000152587890625);u=j;return}}}function NAa(a){a=a|0;YDc(a);return}function OAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;if((h|0)<=0){i=c;do i=i+1|0;while((i|0)<(d|0));return}i=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=i;i=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){if((f[f[g>>2]>>2]|0)==3){c=j;k=0;while(1){l=f[i+(k<<2)>>2]|0;f[c+8>>2]=l;f[c+4>>2]=l;f[c>>2]=l;k=k+1|0;if((k|0)==(h|0))break;else c=c+12|0}}else{c=0;k=j;while(1){l=f[i+(c<<2)>>2]|0;f[k+8>>2]=l;f[k+4>>2]=l;f[k>>2]=l;n[k+12>>2]=1.0;c=c+1|0;if((c|0)==(h|0))break;else k=k+16|0}}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;i=i+b|0}}return}function PAa(a){a=a|0;YDc(a);return}function QAa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b>>2]|0;e=f[b+4>>2]|0;if((c|0)>=(e|0))return;b=f[a+8>>2]|0;g=f[a+16>>2]|0;h=a+24|0;i=f[a+20>>2]|0;if((i|0)<=0){j=c;do j=j+1|0;while((j|0)<(e|0));return}j=(f[a+12>>2]|0)+(Y(g,c)|0)|0;k=j;j=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){if((f[f[h>>2]>>2]|0)==3){c=k;l=0;while(1){m=d[j+(l<<1)>>1]|0;d[c+4>>1]=m;d[c+2>>1]=m;d[c>>1]=m;l=l+1|0;if((l|0)==(i|0))break;else c=c+6|0}}else{c=0;l=k;while(1){m=d[j+(c<<1)>>1]|0;d[l+4>>1]=m;d[l+2>>1]=m;d[l>>1]=m;d[l+6>>1]=-1;c=c+1|0;if((c|0)==(i|0))break;else l=l+8|0}}a=a+1|0;if((a|0)>=(e|0))break;else{k=k+g|0;j=j+b|0}}return}function RAa(a){a=a|0;YDc(a);return}function SAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;h=c+4|0;if((d|0)>=(f[h>>2]|0))return;c=(f[a+12>>2]|0)+(Y(f[g>>2]|0,d)|0)|0;i=a+24|0;j=a+20|0;k=c;c=(f[a+4>>2]|0)+(Y(f[e>>2]|0,d)|0)|0;a=d;while(1){d=f[j>>2]|0;l=(d|0)>0;if((f[f[i>>2]>>2]|0)==3){if(l){m=k;n=0;while(1){o=b[c+n>>0]|0;b[m+2>>0]=o;b[m+1>>0]=o;b[m>>0]=o;n=n+1|0;if((n|0)==(d|0))break;else m=m+3|0}}}else if(l){m=0;n=k;while(1){o=b[c+m>>0]|0;b[n+2>>0]=o;b[n+1>>0]=o;b[n>>0]=o;b[n+3>>0]=-1;m=m+1|0;if((m|0)==(d|0))break;else n=n+4|0}}a=a+1|0;if((a|0)>=(f[h>>2]|0))break;else{k=k+(f[g>>2]|0)|0;c=c+(f[e>>2]|0)|0}}return}function TAa(a){a=a|0;YDc(a);return}function UAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;h=c+4|0;if((d|0)>=(f[h>>2]|0))return;c=(f[a+12>>2]|0)+(Y(f[g>>2]|0,d)|0)|0;i=a+24|0;k=a+20|0;l=c;c=(f[a+4>>2]|0)+(Y(f[e>>2]|0,d)|0)|0;a=d;while(1){d=f[k>>2]|0;m=(d|0)>0;if((f[f[i>>2]>>2]|0)==6){if(m){n=0;do{o=j[c+(n<<1)>>1]|0;b[l+n>>0]=(((o>>>3&252)*9617|0)+8192+((o<<3&248)*1868|0)+((o>>>8&248)*4899|0)|0)>>>14;n=n+1|0}while((n|0)!=(d|0))}}else if(m){n=0;do{o=j[c+(n<<1)>>1]|0;b[l+n>>0]=(((o>>>2&248)*9617|0)+8192+((o<<3&248)*1868|0)+((o>>>7&248)*4899|0)|0)>>>14;n=n+1|0}while((n|0)!=(d|0))}a=a+1|0;if((a|0)>=(f[h>>2]|0))break;else{l=l+(f[g>>2]|0)|0;c=c+(f[e>>2]|0)|0}}return}function VAa(a){a=a|0;YDc(a);return}function WAa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[b>>2]|0;e=f[b+4>>2]|0;if((c|0)>=(e|0))return;b=f[a+16>>2]|0;g=(f[a+12>>2]|0)+(Y(b,c)|0)|0;i=f[a+8>>2]|0;j=(f[a+4>>2]|0)+(Y(i,c)|0)|0;k=a+24|0;l=f[a+20>>2]|0;a=(l|0)>0;m=g;g=j;j=c;while(1){if((f[f[k>>2]>>2]|0)==6){if(a){c=0;do{n=h[g+c>>0]|0;d[m+(c<<1)>>1]=n<<3&2016|n>>>3|n<<8&63488;c=c+1|0}while((c|0)!=(l|0))}}else if(a){c=0;do{n=(h[g+c>>0]|0)>>>3;d[m+(c<<1)>>1]=n<<5|n|n<<10;c=c+1|0}while((c|0)!=(l|0))}j=j+1|0;if((j|0)>=(e|0))break;else{m=m+b|0;g=g+i|0}}return}function XAa(a){a=a|0;YDc(a);return}function YAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;i=c+4|0;c=f[i>>2]|0;if((d|0)>=(c|0))return;j=f[g>>2]|0;k=(f[a+12>>2]|0)+(Y(j,d)|0)|0;l=f[e>>2]|0;m=a+20|0;n=k;k=(f[a+4>>2]|0)+(Y(l,d)|0)|0;a=d;d=c;c=j;j=l;while(1){l=f[m>>2]|0;if((l|0)>0){o=n;p=0;q=k;while(1){r=b[q+1>>0]|0;s=b[q+2>>0]|0;t=b[q+3>>0]|0;u=t&255;v=((((Y(u,h[q>>0]|0)|0)+128|0)>>>0)/255|0)&255;b[o>>0]=v;v=((((Y(u,r&255)|0)+128|0)>>>0)/255|0)&255;b[o+1>>0]=v;v=((((Y(u,s&255)|0)+128|0)>>>0)/255|0)&255;b[o+2>>0]=v;b[o+3>>0]=t;p=p+1|0;if((p|0)==(l|0))break;else{o=o+4|0;q=q+4|0}}w=f[e>>2]|0;x=f[g>>2]|0;y=f[i>>2]|0}else{w=j;x=c;y=d}a=a+1|0;if((a|0)>=(y|0))break;else{n=n+x|0;k=k+w|0;d=y;c=x;j=w}}return}function ZAa(a){a=a|0;YDc(a);return}function _Aa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;i=c+4|0;c=f[i>>2]|0;if((d|0)>=(c|0))return;j=f[g>>2]|0;k=(f[a+12>>2]|0)+(Y(j,d)|0)|0;l=f[e>>2]|0;m=a+20|0;n=k;k=(f[a+4>>2]|0)+(Y(l,d)|0)|0;a=d;d=c;c=j;j=l;while(1){l=f[m>>2]|0;if((l|0)>0){o=n;p=0;q=k;while(1){r=b[q+3>>0]|0;s=r&255;if(!(r<<24>>24)){b[o>>0]=0;t=0;u=0}else{v=b[q+2>>0]|0;w=b[q+1>>0]|0;x=(r&255)>>>1&255;b[o>>0]=((((h[q>>0]|0)*255|0)+x|0)>>>0)/(s>>>0)|0;t=(((((w&255)*255|0)+x|0)>>>0)/(s>>>0)|0)&255;u=((((v&255)*255|0)+x|0)>>>0)/(s>>>0)|0}b[o+1>>0]=t;b[o+2>>0]=u;b[o+3>>0]=r;p=p+1|0;if((p|0)==(l|0))break;else{o=o+4|0;q=q+4|0}}y=f[e>>2]|0;z=f[g>>2]|0;A=f[i>>2]|0}else{y=j;z=c;A=d}a=a+1|0;if((a|0)>=(A|0))break;else{n=n+z|0;k=k+y|0;d=A;c=z;j=y}}return}function $Aa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;aBa(g,a,b,c);pAa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,d);bBa(g);u=e;return}function aBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=x>>>3;n=(m&511)+1|0;f[a+116>>2]=n;y=x&7;z=a+112|0;f[z>>2]=y;if((m&510|0)!=2)e2(n,62176);if((e+-3|0)>>>0>=2)e2(e,62204);switch(x&7){case 0:case 2:case 5:break;default:b2(y,62232)}y=c+4|0;x=d+4|0;if((f[y>>2]|0)!=(f[x>>2]|0)){do if((d$(c)|0)==65536){n=f[y>>2]|0;f[h>>2]=f[n>>2];m=h+4|0;A=n+4|0;f[m>>2]=f[A>>2];B=h+8|0;f[B>>2]=f[n+8>>2];f[h+12>>2]=f[n+12>>2];f[h+16>>2]=f[n+16>>2];f[h+20>>2]=f[n+20>>2];f[h+24>>2]=f[n+24>>2];f[h+28>>2]=f[n+28>>2];f[h+32>>2]=f[n+32>>2];C=f[n+36>>2]|0;f[h+36>>2]=C;f[h+40>>2]=B;B=h+48|0;D=h+44|0;f[D>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[n+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[m>>2]=0;ZS(h,n);break}}else a$(h,c,-1);while(0);y=h+36|0;n=f[y>>2]|0;if((a|0)==(h|0))E=n;else{if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}m=a+36|0;n=f[m>>2]|0;if(n|0?(A=n+12|0,n=f[A>>2]|0,f[A>>2]=n+-1,(n|0)==1):0)_S(a);f[m>>2]=0;n=a+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0;F=f[j>>2]|0}while((B|0)<(F|0));f[a>>2]=f[h>>2];if((F|0)<3)G=29;else G=31}else{f[a>>2]=f[h>>2];G=29}if((G|0)==29){F=f[h+4>>2]|0;if((F|0)<3){f[j>>2]=F;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;F=f[p>>2]|0;f[F>>2]=f[k>>2];f[F+4>>2]=f[k+4>>2]}else G=31}if((G|0)==31)ZS(a,h);f[n>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];n=f[y>>2]|0;f[m>>2]=n;E=n}if(E|0?(n=E+12|0,E=f[n>>2]|0,f[n>>2]=E+-1,(E|0)==1):0)_S(h);f[y>>2]=0;y=h+16|0;E=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[E>>2]|0)>0){y=f[h+40>>2]|0;n=0;do{f[y+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[E>>2]|0))}E=f[h+44>>2]|0;if((E|0)!=(h+48|0))g0(E)}else{E=h+8|0;f[E>>2]=0;f[E+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;E=f[c>>2]|0;f[t>>2]=l;f[w>>2]=E;f[i>>2]=l;f[i+4>>2]=E;v$(d,i,f[z>>2]&7|(e<<3)+-8,-1,0,0);do if((d$(d)|0)==65536){e=f[x>>2]|0;f[h>>2]=f[e>>2];z=h+4|0;i=e+4|0;f[z>>2]=f[i>>2];E=h+8|0;f[E>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=E;E=h+48|0;w=h+44|0;f[w>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(l|0){E=l+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;E=f[w>>2]|0;f[E>>2]=f[i>>2];f[E+4>>2]=f[i+4>>2];break}else{f[z>>2]=0;ZS(h,e);break}}else a$(h,d,-1);while(0);d=h+36|0;x=f[d>>2]|0;if((o|0)==(h|0))H=x;else{if(x|0){e=x+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+92|0;x=f[e>>2]|0;if(x|0?(z=x+12|0,x=f[z>>2]|0,f[z>>2]=x+-1,(x|0)==1):0)_S(o);f[e>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){z=f[s>>2]|0;s=0;do{f[z+(s<<2)>>2]=0;s=s+1|0;I=f[q>>2]|0}while((s|0)<(I|0));f[o>>2]=f[h>>2];if((I|0)<3)G=60;else G=62}else{f[o>>2]=f[h>>2];G=60}if((G|0)==60){I=f[h+4>>2]|0;if((I|0)<3){f[q>>2]=I;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;I=f[v>>2]|0;f[I>>2]=f[r>>2];f[I+4>>2]=f[r+4>>2]}else G=62}if((G|0)==62)ZS(o,h);f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[e>>2]=a;H=a}if(H|0?(a=H+12|0,H=f[a>>2]|0,f[a>>2]=H+-1,(H|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;H=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[H>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[H>>2]|0))}H=f[h+44>>2]|0;if((H|0)==(h+48|0)){u=g;return}g0(H);u=g;return}function bBa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function cBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+176|0;g=e+168|0;h=e+140|0;i=e+128|0;j=e;dBa(j,a,b,2);b=f[j+16>>2]|0;a=f[j+48>>2]|0;k=f[j+72>>2]|0;l=f[j+104>>2]|0;m=f[j+12>>2]|0;n=f[j+8>>2]|0;f[i>>2]=f[j+116>>2];f[i+4>>2]=c?2:0;f[i+8>>2]=d;f[g>>2]=0;f[g+4>>2]=n;f[h>>2]=61920;f[h+4>>2]=b;f[h+8>>2]=a;f[h+12>>2]=k;f[h+16>>2]=l;f[h+20>>2]=m;f[h+24>>2]=i;y8(g,h,+(Y(n,m)|0)*.0000152587890625);eBa(j);u=e;return}function dBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=x>>>3;n=(m&511)+1|0;f[a+116>>2]=n;y=x&7;x=a+112|0;f[x>>2]=y;if((m&510|0)!=2)e2(n,62260);if((e|0)!=2)e2(e,62288);if(y|0)b2(y,62316);y=c+4|0;e=d+4|0;if((f[y>>2]|0)!=(f[e>>2]|0)){do if((d$(c)|0)==65536){n=f[y>>2]|0;f[h>>2]=f[n>>2];m=h+4|0;z=n+4|0;f[m>>2]=f[z>>2];A=h+8|0;f[A>>2]=f[n+8>>2];f[h+12>>2]=f[n+12>>2];f[h+16>>2]=f[n+16>>2];f[h+20>>2]=f[n+20>>2];f[h+24>>2]=f[n+24>>2];f[h+28>>2]=f[n+28>>2];f[h+32>>2]=f[n+32>>2];B=f[n+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=A;A=h+48|0;C=h+44|0;f[C>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[n+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[m>>2]=0;ZS(h,n);break}}else a$(h,c,-1);while(0);y=h+36|0;n=f[y>>2]|0;if((a|0)==(h|0))D=n;else{if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}m=a+36|0;n=f[m>>2]|0;if(n|0?(z=n+12|0,n=f[z>>2]|0,f[z>>2]=n+-1,(n|0)==1):0)_S(a);f[m>>2]=0;n=a+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0;E=f[j>>2]|0}while((A|0)<(E|0));f[a>>2]=f[h>>2];if((E|0)<3)F=29;else F=31}else{f[a>>2]=f[h>>2];F=29}if((F|0)==29){E=f[h+4>>2]|0;if((E|0)<3){f[j>>2]=E;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;E=f[p>>2]|0;f[E>>2]=f[k>>2];f[E+4>>2]=f[k+4>>2]}else F=31}if((F|0)==31)ZS(a,h);f[n>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];n=f[y>>2]|0;f[m>>2]=n;D=n}if(D|0?(n=D+12|0,D=f[n>>2]|0,f[n>>2]=D+-1,(D|0)==1):0)_S(h);f[y>>2]=0;y=h+16|0;D=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[D>>2]|0)>0){y=f[h+40>>2]|0;n=0;do{f[y+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[D>>2]|0))}D=f[h+44>>2]|0;if((D|0)!=(h+48|0))g0(D)}else{D=h+8|0;f[D>>2]=0;f[D+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;D=f[c>>2]|0;f[t>>2]=l;f[w>>2]=D;f[i>>2]=l;f[i+4>>2]=D;v$(d,i,f[x>>2]&7|8,-1,0,0);do if((d$(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;D=x+4|0;f[i>>2]=f[D>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[D>>2]|0)<3){D=f[x+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[D>>2];f[l+4>>2]=f[D+4>>2];break}else{f[i>>2]=0;ZS(h,x);break}}else a$(h,d,-1);while(0);d=h+36|0;e=f[d>>2]|0;if((o|0)==(h|0))G=e;else{if(e|0){x=e+12|0;f[x>>2]=(f[x>>2]|0)+1}x=a+92|0;e=f[x>>2]|0;if(e|0?(i=e+12|0,e=f[i>>2]|0,f[i>>2]=e+-1,(e|0)==1):0)_S(o);f[x>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;H=f[q>>2]|0}while((s|0)<(H|0));f[o>>2]=f[h>>2];if((H|0)<3)F=60;else F=62}else{f[o>>2]=f[h>>2];F=60}if((F|0)==60){H=f[h+4>>2]|0;if((H|0)<3){f[q>>2]=H;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;H=f[v>>2]|0;f[H>>2]=f[r>>2];f[H+4>>2]=f[r+4>>2]}else F=62}if((F|0)==62)ZS(o,h);f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[x>>2]=a;G=a}if(G|0?(a=G+12|0,G=f[a>>2]|0,f[a>>2]=G+-1,(G|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;G=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[G>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)==(h+48|0)){u=g;return}g0(G);u=g;return}function eBa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function fBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+176|0;h=g+168|0;i=g+140|0;j=g+128|0;k=g;l=(c|0)<1?3:c;gBa(k,a,b,l);b=f[k+16>>2]|0;a=f[k+48>>2]|0;c=f[k+72>>2]|0;m=f[k+104>>2]|0;n=f[k+12>>2]|0;o=f[k+8>>2]|0;f[j>>2]=l;f[j+4>>2]=d?2:0;f[j+8>>2]=e;f[h>>2]=0;f[h+4>>2]=o;f[i>>2]=61940;f[i+4>>2]=b;f[i+8>>2]=a;f[i+12>>2]=c;f[i+16>>2]=m;f[i+20>>2]=n;f[i+24>>2]=j;y8(h,i,+(Y(o,n)|0)*.0000152587890625);hBa(k);u=g;return}function gBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=(x>>>3&511)+1|0;f[a+116>>2]=m;n=x&7;x=a+112|0;f[x>>2]=n;if((m|0)!=2)e2(m,62344);if((e+-3|0)>>>0>=2)e2(e,62372);if(n|0)b2(n,62400);n=c+4|0;m=d+4|0;if((f[n>>2]|0)!=(f[m>>2]|0)){do if((d$(c)|0)==65536){y=f[n>>2]|0;f[h>>2]=f[y>>2];z=h+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=h+8|0;f[B>>2]=f[y+8>>2];f[h+12>>2]=f[y+12>>2];f[h+16>>2]=f[y+16>>2];f[h+20>>2]=f[y+20>>2];f[h+24>>2]=f[y+24>>2];f[h+28>>2]=f[y+28>>2];f[h+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[h+36>>2]=C;f[h+40>>2]=B;B=h+48|0;D=h+44|0;f[D>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;ZS(h,y);break}}else a$(h,c,-1);while(0);n=h+36|0;y=f[n>>2]|0;if((a|0)==(h|0))E=y;else{if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+36|0;y=f[z>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)_S(a);f[z>>2]=0;y=a+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0;F=f[j>>2]|0}while((B|0)<(F|0));f[a>>2]=f[h>>2];if((F|0)<3)G=29;else G=31}else{f[a>>2]=f[h>>2];G=29}if((G|0)==29){F=f[h+4>>2]|0;if((F|0)<3){f[j>>2]=F;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;F=f[p>>2]|0;f[F>>2]=f[k>>2];f[F+4>>2]=f[k+4>>2]}else G=31}if((G|0)==31)ZS(a,h);f[y>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];y=f[n>>2]|0;f[z>>2]=y;E=y}if(E|0?(y=E+12|0,E=f[y>>2]|0,f[y>>2]=E+-1,(E|0)==1):0)_S(h);f[n>>2]=0;n=h+16|0;E=h+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[E>>2]|0)>0){n=f[h+40>>2]|0;y=0;do{f[n+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[E>>2]|0))}E=f[h+44>>2]|0;if((E|0)!=(h+48|0))g0(E)}else{E=h+8|0;f[E>>2]=0;f[E+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;E=f[c>>2]|0;f[t>>2]=l;f[w>>2]=E;f[i>>2]=l;f[i+4>>2]=E;v$(d,i,f[x>>2]&7|(e<<3)+-8,-1,0,0);do if((d$(d)|0)==65536){e=f[m>>2]|0;f[h>>2]=f[e>>2];x=h+4|0;i=e+4|0;f[x>>2]=f[i>>2];E=h+8|0;f[E>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=E;E=h+48|0;w=h+44|0;f[w>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(l|0){E=l+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;E=f[w>>2]|0;f[E>>2]=f[i>>2];f[E+4>>2]=f[i+4>>2];break}else{f[x>>2]=0;ZS(h,e);break}}else a$(h,d,-1);while(0);d=h+36|0;m=f[d>>2]|0;if((o|0)==(h|0))H=m;else{if(m|0){e=m+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+92|0;m=f[e>>2]|0;if(m|0?(x=m+12|0,m=f[x>>2]|0,f[x>>2]=m+-1,(m|0)==1):0)_S(o);f[e>>2]=0;m=a+72|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[q>>2]|0)>0){x=f[s>>2]|0;s=0;do{f[x+(s<<2)>>2]=0;s=s+1|0;I=f[q>>2]|0}while((s|0)<(I|0));f[o>>2]=f[h>>2];if((I|0)<3)G=60;else G=62}else{f[o>>2]=f[h>>2];G=60}if((G|0)==60){I=f[h+4>>2]|0;if((I|0)<3){f[q>>2]=I;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;I=f[v>>2]|0;f[I>>2]=f[r>>2];f[I+4>>2]=f[r+4>>2]}else G=62}if((G|0)==62)ZS(o,h);f[m>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[e>>2]=a;H=a}if(H|0?(a=H+12|0,H=f[a>>2]|0,f[a>>2]=H+-1,(H|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;H=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[H>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[H>>2]|0))}H=f[h+44>>2]|0;if((H|0)==(h+48|0)){u=g;return}g0(H);u=g;return}function hBa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function iBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+128|0;e=d;jBa(e,a,b,1);FAa(f[e+16>>2]|0,f[e+48>>2]|0,f[e+72>>2]|0,f[e+104>>2]|0,f[e+12>>2]|0,f[e+8>>2]|0,f[e+112>>2]|0,f[e+116>>2]|0,c);kBa(e);u=d;return}function jBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=x>>>3;n=(m&511)+1|0;f[a+116>>2]=n;y=x&7;z=a+112|0;f[z>>2]=y;if((m&510|0)!=2)e2(n,62428);if((e|0)!=1)e2(e,62456);switch(x&7){case 0:case 2:case 5:break;default:b2(y,62484)}y=c+4|0;x=d+4|0;if((f[y>>2]|0)!=(f[x>>2]|0)){do if((d$(c)|0)==65536){e=f[y>>2]|0;f[h>>2]=f[e>>2];n=h+4|0;m=e+4|0;f[n>>2]=f[m>>2];A=h+8|0;f[A>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];B=f[e+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=A;A=h+48|0;C=h+44|0;f[C>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[m>>2]|0)<3){m=f[e+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[m>>2];f[A+4>>2]=f[m+4>>2];break}else{f[n>>2]=0;ZS(h,e);break}}else a$(h,c,-1);while(0);y=h+36|0;e=f[y>>2]|0;if((a|0)==(h|0))D=e;else{if(e|0){n=e+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+36|0;e=f[n>>2]|0;if(e|0?(m=e+12|0,e=f[m>>2]|0,f[m>>2]=e+-1,(e|0)==1):0)_S(a);f[n>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[j>>2]|0)>0){m=f[l>>2]|0;A=0;do{f[m+(A<<2)>>2]=0;A=A+1|0;E=f[j>>2]|0}while((A|0)<(E|0));f[a>>2]=f[h>>2];if((E|0)<3)F=29;else F=31}else{f[a>>2]=f[h>>2];F=29}if((F|0)==29){E=f[h+4>>2]|0;if((E|0)<3){f[j>>2]=E;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;E=f[p>>2]|0;f[E>>2]=f[k>>2];f[E+4>>2]=f[k+4>>2]}else F=31}if((F|0)==31)ZS(a,h);f[e>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];e=f[y>>2]|0;f[n>>2]=e;D=e}if(D|0?(e=D+12|0,D=f[e>>2]|0,f[e>>2]=D+-1,(D|0)==1):0)_S(h);f[y>>2]=0;y=h+16|0;D=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[D>>2]|0)>0){y=f[h+40>>2]|0;e=0;do{f[y+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[D>>2]|0))}D=f[h+44>>2]|0;if((D|0)!=(h+48|0))g0(D)}else{D=h+8|0;f[D>>2]=0;f[D+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;D=f[c>>2]|0;f[t>>2]=l;f[w>>2]=D;f[i>>2]=l;f[i+4>>2]=D;v$(d,i,f[z>>2]&7,-1,0,0);do if((d$(d)|0)==65536){z=f[x>>2]|0;f[h>>2]=f[z>>2];i=h+4|0;D=z+4|0;f[i>>2]=f[D>>2];l=h+8|0;f[l>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];w=f[z+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[D>>2]|0)<3){D=f[z+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[D>>2];f[l+4>>2]=f[D+4>>2];break}else{f[i>>2]=0;ZS(h,z);break}}else a$(h,d,-1);while(0);d=h+36|0;x=f[d>>2]|0;if((o|0)==(h|0))G=x;else{if(x|0){z=x+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+92|0;x=f[z>>2]|0;if(x|0?(i=x+12|0,x=f[i>>2]|0,f[i>>2]=x+-1,(x|0)==1):0)_S(o);f[z>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;H=f[q>>2]|0}while((s|0)<(H|0));f[o>>2]=f[h>>2];if((H|0)<3)F=60;else F=62}else{f[o>>2]=f[h>>2];F=60}if((F|0)==60){H=f[h+4>>2]|0;if((H|0)<3){f[q>>2]=H;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;H=f[v>>2]|0;f[H>>2]=f[r>>2];f[H+4>>2]=f[r+4>>2]}else F=62}if((F|0)==62)ZS(o,h);f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[z>>2]=a;G=a}if(G|0?(a=G+12|0,G=f[a>>2]|0,f[a>>2]=G+-1,(G|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;G=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[G>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)==(h+48|0)){u=g;return}g0(G);u=g;return}function kBa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function lBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+128|0;e=d;g=(c|0)<1?3:c;mBa(e,a,b,g);MAa(f[e+16>>2]|0,f[e+48>>2]|0,f[e+72>>2]|0,f[e+104>>2]|0,f[e+12>>2]|0,f[e+8>>2]|0,f[e+112>>2]|0,g);nBa(e);u=d;return}function mBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=x>>>3&511;n=m+1|0;f[a+116>>2]=n;y=x&7;z=a+112|0;f[z>>2]=y;if(m|0)e2(n,62512);if((e+-3|0)>>>0>=2)e2(e,62540);switch(x&7){case 0:case 2:case 5:break;default:b2(y,62568)}y=c+4|0;x=d+4|0;if((f[y>>2]|0)!=(f[x>>2]|0)){do if((d$(c)|0)==65536){n=f[y>>2]|0;f[h>>2]=f[n>>2];m=h+4|0;A=n+4|0;f[m>>2]=f[A>>2];B=h+8|0;f[B>>2]=f[n+8>>2];f[h+12>>2]=f[n+12>>2];f[h+16>>2]=f[n+16>>2];f[h+20>>2]=f[n+20>>2];f[h+24>>2]=f[n+24>>2];f[h+28>>2]=f[n+28>>2];f[h+32>>2]=f[n+32>>2];C=f[n+36>>2]|0;f[h+36>>2]=C;f[h+40>>2]=B;B=h+48|0;D=h+44|0;f[D>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[n+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[m>>2]=0;ZS(h,n);break}}else a$(h,c,-1);while(0);y=h+36|0;n=f[y>>2]|0;if((a|0)==(h|0))E=n;else{if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}m=a+36|0;n=f[m>>2]|0;if(n|0?(A=n+12|0,n=f[A>>2]|0,f[A>>2]=n+-1,(n|0)==1):0)_S(a);f[m>>2]=0;n=a+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0;F=f[j>>2]|0}while((B|0)<(F|0));f[a>>2]=f[h>>2];if((F|0)<3)G=29;else G=31}else{f[a>>2]=f[h>>2];G=29}if((G|0)==29){F=f[h+4>>2]|0;if((F|0)<3){f[j>>2]=F;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;F=f[p>>2]|0;f[F>>2]=f[k>>2];f[F+4>>2]=f[k+4>>2]}else G=31}if((G|0)==31)ZS(a,h);f[n>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];n=f[y>>2]|0;f[m>>2]=n;E=n}if(E|0?(n=E+12|0,E=f[n>>2]|0,f[n>>2]=E+-1,(E|0)==1):0)_S(h);f[y>>2]=0;y=h+16|0;E=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[E>>2]|0)>0){y=f[h+40>>2]|0;n=0;do{f[y+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[E>>2]|0))}E=f[h+44>>2]|0;if((E|0)!=(h+48|0))g0(E)}else{E=h+8|0;f[E>>2]=0;f[E+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;E=f[c>>2]|0;f[t>>2]=l;f[w>>2]=E;f[i>>2]=l;f[i+4>>2]=E;v$(d,i,f[z>>2]&7|(e<<3)+-8,-1,0,0);do if((d$(d)|0)==65536){e=f[x>>2]|0;f[h>>2]=f[e>>2];z=h+4|0;i=e+4|0;f[z>>2]=f[i>>2];E=h+8|0;f[E>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=E;E=h+48|0;w=h+44|0;f[w>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(l|0){E=l+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;E=f[w>>2]|0;f[E>>2]=f[i>>2];f[E+4>>2]=f[i+4>>2];break}else{f[z>>2]=0;ZS(h,e);break}}else a$(h,d,-1);while(0);d=h+36|0;x=f[d>>2]|0;if((o|0)==(h|0))H=x;else{if(x|0){e=x+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+92|0;x=f[e>>2]|0;if(x|0?(z=x+12|0,x=f[z>>2]|0,f[z>>2]=x+-1,(x|0)==1):0)_S(o);f[e>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){z=f[s>>2]|0;s=0;do{f[z+(s<<2)>>2]=0;s=s+1|0;I=f[q>>2]|0}while((s|0)<(I|0));f[o>>2]=f[h>>2];if((I|0)<3)G=60;else G=62}else{f[o>>2]=f[h>>2];G=60}if((G|0)==60){I=f[h+4>>2]|0;if((I|0)<3){f[q>>2]=I;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;I=f[v>>2]|0;f[I>>2]=f[r>>2];f[I+4>>2]=f[r+4>>2]}else G=62}if((G|0)==62)ZS(o,h);f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[e>>2]=a;H=a}if(H|0?(a=H+12|0,H=f[a>>2]|0,f[a>>2]=H+-1,(H|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;H=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[H>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[H>>2]|0))}H=f[h+44>>2]|0;if((H|0)==(h+48|0)){u=g;return}g0(H);u=g;return}function nBa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function oBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+176|0;e=d+160|0;g=d+132|0;h=d+128|0;i=d;pBa(i,a,b,1);b=f[i+16>>2]|0;a=f[i+48>>2]|0;j=f[i+72>>2]|0;k=f[i+104>>2]|0;l=f[i+12>>2]|0;m=f[i+8>>2]|0;f[h>>2]=c;f[e>>2]=0;f[e+4>>2]=m;f[g>>2]=62104;f[g+4>>2]=b;f[g+8>>2]=a;f[g+12>>2]=j;f[g+16>>2]=k;f[g+20>>2]=l;f[g+24>>2]=h;y8(e,g,+(Y(m,l)|0)*.0000152587890625);qBa(i);u=d;return}function pBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=(x>>>3&511)+1|0;f[a+116>>2]=m;n=x&7;x=a+112|0;f[x>>2]=n;if((m|0)!=2)e2(m,62596);if((e|0)!=1)e2(e,62624);if(n|0)b2(n,62652);n=c+4|0;e=d+4|0;if((f[n>>2]|0)!=(f[e>>2]|0)){do if((d$(c)|0)==65536){m=f[n>>2]|0;f[h>>2]=f[m>>2];y=h+4|0;z=m+4|0;f[y>>2]=f[z>>2];A=h+8|0;f[A>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];B=f[m+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=A;A=h+48|0;C=h+44|0;f[C>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[m+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;ZS(h,m);break}}else a$(h,c,-1);while(0);n=h+36|0;m=f[n>>2]|0;if((a|0)==(h|0))D=m;else{if(m|0){y=m+12|0;f[y>>2]=(f[y>>2]|0)+1}y=a+36|0;m=f[y>>2]|0;if(m|0?(z=m+12|0,m=f[z>>2]|0,f[z>>2]=m+-1,(m|0)==1):0)_S(a);f[y>>2]=0;m=a+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0;E=f[j>>2]|0}while((A|0)<(E|0));f[a>>2]=f[h>>2];if((E|0)<3)F=29;else F=31}else{f[a>>2]=f[h>>2];F=29}if((F|0)==29){E=f[h+4>>2]|0;if((E|0)<3){f[j>>2]=E;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;E=f[p>>2]|0;f[E>>2]=f[k>>2];f[E+4>>2]=f[k+4>>2]}else F=31}if((F|0)==31)ZS(a,h);f[m>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];m=f[n>>2]|0;f[y>>2]=m;D=m}if(D|0?(m=D+12|0,D=f[m>>2]|0,f[m>>2]=D+-1,(D|0)==1):0)_S(h);f[n>>2]=0;n=h+16|0;D=h+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[D>>2]|0)>0){n=f[h+40>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[D>>2]|0))}D=f[h+44>>2]|0;if((D|0)!=(h+48|0))g0(D)}else{D=h+8|0;f[D>>2]=0;f[D+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;D=f[c>>2]|0;f[t>>2]=l;f[w>>2]=D;f[i>>2]=l;f[i+4>>2]=D;v$(d,i,f[x>>2]&7,-1,0,0);do if((d$(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;D=x+4|0;f[i>>2]=f[D>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[D>>2]|0)<3){D=f[x+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[D>>2];f[l+4>>2]=f[D+4>>2];break}else{f[i>>2]=0;ZS(h,x);break}}else a$(h,d,-1);while(0);d=h+36|0;e=f[d>>2]|0;if((o|0)==(h|0))G=e;else{if(e|0){x=e+12|0;f[x>>2]=(f[x>>2]|0)+1}x=a+92|0;e=f[x>>2]|0;if(e|0?(i=e+12|0,e=f[i>>2]|0,f[i>>2]=e+-1,(e|0)==1):0)_S(o);f[x>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;H=f[q>>2]|0}while((s|0)<(H|0));f[o>>2]=f[h>>2];if((H|0)<3)F=60;else F=62}else{f[o>>2]=f[h>>2];F=60}if((F|0)==60){H=f[h+4>>2]|0;if((H|0)<3){f[q>>2]=H;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;H=f[v>>2]|0;f[H>>2]=f[r>>2];f[H+4>>2]=f[r+4>>2]}else F=62}if((F|0)==62)ZS(o,h);f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[x>>2]=a;G=a}if(G|0?(a=G+12|0,G=f[a>>2]|0,f[a>>2]=G+-1,(G|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;G=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[G>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)==(h+48|0)){u=g;return}g0(G);u=g;return}function qBa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function rBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+176|0;e=d+160|0;g=d+132|0;h=d+128|0;i=d;sBa(i,a,b,2);b=f[i+16>>2]|0;a=f[i+48>>2]|0;j=f[i+72>>2]|0;k=f[i+104>>2]|0;l=f[i+12>>2]|0;m=f[i+8>>2]|0;f[h>>2]=c;f[e>>2]=0;f[e+4>>2]=m;f[g>>2]=62124;f[g+4>>2]=b;f[g+8>>2]=a;f[g+12>>2]=j;f[g+16>>2]=k;f[g+20>>2]=l;f[g+24>>2]=h;y8(e,g,+(Y(m,l)|0)*.0000152587890625);tBa(i);u=d;return}function sBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=x>>>3&511;n=m+1|0;f[a+116>>2]=n;y=x&7;x=a+112|0;f[x>>2]=y;if(m|0)e2(n,62680);if((e|0)!=2)e2(e,62708);if(y|0)b2(y,62736);y=c+4|0;e=d+4|0;if((f[y>>2]|0)!=(f[e>>2]|0)){do if((d$(c)|0)==65536){n=f[y>>2]|0;f[h>>2]=f[n>>2];m=h+4|0;z=n+4|0;f[m>>2]=f[z>>2];A=h+8|0;f[A>>2]=f[n+8>>2];f[h+12>>2]=f[n+12>>2];f[h+16>>2]=f[n+16>>2];f[h+20>>2]=f[n+20>>2];f[h+24>>2]=f[n+24>>2];f[h+28>>2]=f[n+28>>2];f[h+32>>2]=f[n+32>>2];B=f[n+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=A;A=h+48|0;C=h+44|0;f[C>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[n+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[m>>2]=0;ZS(h,n);break}}else a$(h,c,-1);while(0);y=h+36|0;n=f[y>>2]|0;if((a|0)==(h|0))D=n;else{if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}m=a+36|0;n=f[m>>2]|0;if(n|0?(z=n+12|0,n=f[z>>2]|0,f[z>>2]=n+-1,(n|0)==1):0)_S(a);f[m>>2]=0;n=a+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0;E=f[j>>2]|0}while((A|0)<(E|0));f[a>>2]=f[h>>2];if((E|0)<3)F=29;else F=31}else{f[a>>2]=f[h>>2];F=29}if((F|0)==29){E=f[h+4>>2]|0;if((E|0)<3){f[j>>2]=E;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;E=f[p>>2]|0;f[E>>2]=f[k>>2];f[E+4>>2]=f[k+4>>2]}else F=31}if((F|0)==31)ZS(a,h);f[n>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];n=f[y>>2]|0;f[m>>2]=n;D=n}if(D|0?(n=D+12|0,D=f[n>>2]|0,f[n>>2]=D+-1,(D|0)==1):0)_S(h);f[y>>2]=0;y=h+16|0;D=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[D>>2]|0)>0){y=f[h+40>>2]|0;n=0;do{f[y+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[D>>2]|0))}D=f[h+44>>2]|0;if((D|0)!=(h+48|0))g0(D)}else{D=h+8|0;f[D>>2]=0;f[D+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;D=f[c>>2]|0;f[t>>2]=l;f[w>>2]=D;f[i>>2]=l;f[i+4>>2]=D;v$(d,i,f[x>>2]&7|8,-1,0,0);do if((d$(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;D=x+4|0;f[i>>2]=f[D>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[D>>2]|0)<3){D=f[x+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[D>>2];f[l+4>>2]=f[D+4>>2];break}else{f[i>>2]=0;ZS(h,x);break}}else a$(h,d,-1);while(0);d=h+36|0;e=f[d>>2]|0;if((o|0)==(h|0))G=e;else{if(e|0){x=e+12|0;f[x>>2]=(f[x>>2]|0)+1}x=a+92|0;e=f[x>>2]|0;if(e|0?(i=e+12|0,e=f[i>>2]|0,f[i>>2]=e+-1,(e|0)==1):0)_S(o);f[x>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;H=f[q>>2]|0}while((s|0)<(H|0));f[o>>2]=f[h>>2];if((H|0)<3)F=60;else F=62}else{f[o>>2]=f[h>>2];F=60}if((F|0)==60){H=f[h+4>>2]|0;if((H|0)<3){f[q>>2]=H;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;H=f[v>>2]|0;f[H>>2]=f[r>>2];f[H+4>>2]=f[r+4>>2]}else F=62}if((F|0)==62)ZS(o,h);f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[x>>2]=a;G=a}if(G|0?(a=G+12|0,G=f[a>>2]|0,f[a>>2]=G+-1,(G|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;G=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[G>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)==(h+48|0)){u=g;return}g0(G);u=g;return}function tBa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function uBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+176|0;d=c+160|0;e=c+128|0;g=c;vBa(g,a,b,4);b=f[g+16>>2]|0;a=f[g+48>>2]|0;h=f[g+72>>2]|0;i=f[g+104>>2]|0;j=f[g+12>>2]|0;k=f[g+8>>2]|0;f[d>>2]=0;f[d+4>>2]=k;f[e>>2]=62144;f[e+4>>2]=b;f[e+8>>2]=a;f[e+12>>2]=h;f[e+16>>2]=i;f[e+20>>2]=j;f[e+24>>2]=c+168;y8(d,e,+(Y(k,j)|0)*.0000152587890625);wBa(g);u=c;return}function vBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}x=c$(c,-1)|0;m=(x>>>3&511)+1|0;f[a+116>>2]=m;n=x&7;x=a+112|0;f[x>>2]=n;if((m|0)!=4)e2(m,62764);if((e|0)!=4)e2(e,62792);if(n|0)b2(n,62820);n=c+4|0;e=d+4|0;if((f[n>>2]|0)!=(f[e>>2]|0)){do if((d$(c)|0)==65536){m=f[n>>2]|0;f[h>>2]=f[m>>2];y=h+4|0;z=m+4|0;f[y>>2]=f[z>>2];A=h+8|0;f[A>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];B=f[m+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=A;A=h+48|0;C=h+44|0;f[C>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[m+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;ZS(h,m);break}}else a$(h,c,-1);while(0);n=h+36|0;m=f[n>>2]|0;if((a|0)==(h|0))D=m;else{if(m|0){y=m+12|0;f[y>>2]=(f[y>>2]|0)+1}y=a+36|0;m=f[y>>2]|0;if(m|0?(z=m+12|0,m=f[z>>2]|0,f[z>>2]=m+-1,(m|0)==1):0)_S(a);f[y>>2]=0;m=a+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0;E=f[j>>2]|0}while((A|0)<(E|0));f[a>>2]=f[h>>2];if((E|0)<3)F=29;else F=31}else{f[a>>2]=f[h>>2];F=29}if((F|0)==29){E=f[h+4>>2]|0;if((E|0)<3){f[j>>2]=E;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;E=f[p>>2]|0;f[E>>2]=f[k>>2];f[E+4>>2]=f[k+4>>2]}else F=31}if((F|0)==31)ZS(a,h);f[m>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];m=f[n>>2]|0;f[y>>2]=m;D=m}if(D|0?(m=D+12|0,D=f[m>>2]|0,f[m>>2]=D+-1,(D|0)==1):0)_S(h);f[n>>2]=0;n=h+16|0;D=h+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[D>>2]|0)>0){n=f[h+40>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[D>>2]|0))}D=f[h+44>>2]|0;if((D|0)!=(h+48|0))g0(D)}else{D=h+8|0;f[D>>2]=0;f[D+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;D=f[c>>2]|0;f[t>>2]=l;f[w>>2]=D;f[i>>2]=l;f[i+4>>2]=D;v$(d,i,f[x>>2]&7|24,-1,0,0);do if((d$(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;D=x+4|0;f[i>>2]=f[D>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[D>>2]|0)<3){D=f[x+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[D>>2];f[l+4>>2]=f[D+4>>2];break}else{f[i>>2]=0;ZS(h,x);break}}else a$(h,d,-1);while(0);d=h+36|0;e=f[d>>2]|0;if((o|0)==(h|0))G=e;else{if(e|0){x=e+12|0;f[x>>2]=(f[x>>2]|0)+1}x=a+92|0;e=f[x>>2]|0;if(e|0?(i=e+12|0,e=f[i>>2]|0,f[i>>2]=e+-1,(e|0)==1):0)_S(o);f[x>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;H=f[q>>2]|0}while((s|0)<(H|0));f[o>>2]=f[h>>2];if((H|0)<3)F=60;else F=62}else{f[o>>2]=f[h>>2];F=60}if((F|0)==60){H=f[h+4>>2]|0;if((H|0)<3){f[q>>2]=H;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;H=f[v>>2]|0;f[H>>2]=f[r>>2];f[H+4>>2]=f[r+4>>2]}else F=62}if((F|0)==62)ZS(o,h);f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[x>>2]=a;G=a}if(G|0?(a=G+12|0,G=f[a>>2]|0,f[a>>2]=G+-1,(G|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;G=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[G>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)==(h+48|0)){u=g;return}g0(G);u=g;return}function wBa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function xBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+176|0;d=c+160|0;e=c+128|0;g=c;vBa(g,a,b,4);b=f[g+16>>2]|0;a=f[g+48>>2]|0;h=f[g+72>>2]|0;i=f[g+104>>2]|0;j=f[g+12>>2]|0;k=f[g+8>>2]|0;f[d>>2]=0;f[d+4>>2]=k;f[e>>2]=62164;f[e+4>>2]=b;f[e+8>>2]=a;f[e+12>>2]=h;f[e+16>>2]=i;f[e+20>>2]=j;f[e+24>>2]=c+168;y8(d,e,+(Y(k,j)|0)*.0000152587890625);wBa(g);u=c;return}function yBa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0;m=u;u=u+80|0;n=m+64|0;o=m+32|0;p=m;q=k?2:0;switch(i|0){case 0:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;i=p+12|0;r=l?76052:76072;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];if(!k){r=p+20|0;s=f[i>>2]|0;f[i>>2]=f[r>>2];f[r>>2]=s}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=76100;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;y8(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}case 2:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;s=p+12|0;r=l?76112:76132;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];if(!k){r=p+20|0;i=f[s>>2]|0;f[s>>2]=f[r>>2];f[r>>2]=i}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=76160;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;y8(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}default:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;q=p+12|0;j=l?76172:76192;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];f[q+12>>2]=f[j+12>>2];f[q+16>>2]=f[j+16>>2];if(!k){k=p+20|0;j=f[q>>2]|0;f[q>>2]=f[k>>2];f[k>>2]=j}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=76220;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;y8(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}}}function zBa(a){a=a|0;YDc(a);return}function ABa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;d=f[c>>2]|0;e=f[c+4>>2]|0;if((d|0)>=(e|0))return;c=f[a+8>>2]|0;g=f[a+16>>2]|0;h=a+24|0;i=f[a+20>>2]|0;j=i*3|0;if((i|0)<=0){i=d;do i=i+1|0;while((i|0)<(e|0));return}i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;k=i;i=(f[a+4>>2]|0)+(Y(c,d)|0)|0;a=d;while(1){d=f[h>>2]|0;l=f[d>>2]|0;m=f[d+4>>2]|0;o=(b[d+8>>0]^1)&255;p=+n[d+12>>2];q=+n[d+16>>2];r=+n[d+20>>2];s=+n[d+24>>2];t=+n[d+28>>2];d=m^2;u=o+1|0;v=2-o|0;o=0;w=i;while(1){x=p*+n[w>>2]+q*+n[w+4>>2]+r*+n[w+8>>2];y=s*(+n[w+(d<<2)>>2]-x)+.5;z=t*(+n[w+(m<<2)>>2]-x)+.5;n[k+(o<<2)>>2]=x;n[k+(u+o<<2)>>2]=y;n[k+(v+o<<2)>>2]=z;o=o+3|0;if((o|0)>=(j|0))break;else w=w+(l<<2)|0}a=a+1|0;if((a|0)>=(e|0))break;else{k=k+g|0;i=i+c|0}}return}function BBa(a){a=a|0;YDc(a);return}function CBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){DBa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function DBa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[a>>2]|0;i=f[a+4>>2]|0;k=(b[a+8>>0]^1)&255;l=f[a+12>>2]|0;m=f[a+16>>2]|0;n=f[a+20>>2]|0;o=f[a+24>>2]|0;p=f[a+28>>2]|0;a=g*3|0;if((g|0)<=0)return;g=i^2;q=k+1|0;r=2-k|0;k=0;s=c;while(1){c=Y(j[s>>1]|0,l)|0;t=Y(j[s+2>>1]|0,m)|0;u=c+8192+t+(Y(j[s+4>>1]|0,n)|0)>>14;t=(Y((j[s+(g<<1)>>1]|0)-u|0,o)|0)+536879104>>14;c=(Y((j[s+(i<<1)>>1]|0)-u|0,p)|0)+536879104>>14;d[e+(k<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[e+(q+k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[e+(r+k<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;k=k+3|0;if((k|0)>=(a|0))break;else s=s+(h<<1)|0}return}function EBa(a){a=a|0;YDc(a);return}function FBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){GBa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function GBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=(b[a+8>>0]^1)&255;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;a=e*3|0;if((e|0)<=0)return;e=i^2;p=j+1|0;q=2-j|0;j=0;r=c;while(1){c=Y(h[r>>0]|0,k)|0;s=Y(h[r+1>>0]|0,l)|0;t=c+8192+s+(Y(h[r+2>>0]|0,m)|0)>>14;s=(Y((h[r+e>>0]|0)-t|0,n)|0)+2105344>>14;c=(Y((h[r+i>>0]|0)-t|0,o)|0)+2105344>>14;b[d+j>>0]=t>>>0<256?t:(t|0)>0?255:0;b[d+(p+j)>>0]=s>>>0<256?s:(s|0)>0?255:0;b[d+(q+j)>>0]=c>>>0<256?c:(c|0)>0?255:0;j=j+3|0;if((j|0)>=(a|0))break;else r=r+g|0}return}function HBa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0;m=u;u=u+64|0;n=m+56|0;o=m+28|0;p=m;q=k?2:0;switch(i|0){case 0:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;i=p+12|0;k=l?76232:76248;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];f[i+8>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=76272;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;y8(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}case 2:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;k=p+12|0;i=l?76284:76300;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=76324;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;y8(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}default:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;q=p+12|0;j=l?76336:76352;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];f[q+12>>2]=f[j+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=76376;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;y8(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}}}function IBa(a){a=a|0;YDc(a);return}function JBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){KBa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function KBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=(b[a+8>>0]^1)&255;j=+n[a+12>>2];k=+n[a+16>>2];l=+n[a+20>>2];m=+n[a+24>>2];a=e*3|0;if((e|0)<=0)return;e=i+1|0;o=2-i|0;i=h^2;if((g|0)==4){p=0;q=d;while(1){r=+n[c+(p<<2)>>2];s=+n[c+(o+p<<2)>>2]+-.5;t=+n[c+(e+p<<2)>>2]+-.5;n[q+(h<<2)>>2]=r+m*s;n[q+4>>2]=k*t+(r+l*s);n[q+(i<<2)>>2]=r+j*t;n[q+12>>2]=1.0;p=p+3|0;if((p|0)>=(a|0))break;else q=q+16|0}return}else{q=0;p=d;while(1){t=+n[c+(q<<2)>>2];r=+n[c+(o+q<<2)>>2]+-.5;s=+n[c+(e+q<<2)>>2]+-.5;n[p+(h<<2)>>2]=t+m*r;n[p+4>>2]=k*s+(t+l*r);n[p+(i<<2)>>2]=t+j*s;q=q+3|0;if((q|0)>=(a|0))break;else p=p+(g<<2)|0}return}}function LBa(a){a=a|0;YDc(a);return}function MBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){NBa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function NBa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=f[a>>2]|0;i=f[a+4>>2]|0;k=(b[a+8>>0]^1)&255;l=f[a+12>>2]|0;m=f[a+16>>2]|0;n=f[a+20>>2]|0;o=f[a+24>>2]|0;a=g*3|0;if((g|0)<=0)return;g=k+1|0;p=2-k|0;k=i^2;if((h|0)==4){q=0;r=e;while(1){s=j[c+(q<<1)>>1]|0;t=(j[c+(p+q<<1)>>1]|0)+-32768|0;u=((Y(t,o)|0)+8192>>14)+s|0;v=(j[c+(g+q<<1)>>1]|0)+-32768|0;w=((Y(v,m)|0)+8192+(Y(t,n)|0)>>14)+s|0;t=((Y(v,l)|0)+8192>>14)+s|0;d[r+(i<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[r+2>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[r+(k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[r+6>>1]=-1;q=q+3|0;if((q|0)>=(a|0))break;else r=r+8|0}return}else{r=0;q=e;while(1){e=j[c+(r<<1)>>1]|0;t=(j[c+(p+r<<1)>>1]|0)+-32768|0;w=((Y(t,o)|0)+8192>>14)+e|0;u=(j[c+(g+r<<1)>>1]|0)+-32768|0;s=((Y(u,m)|0)+8192+(Y(t,n)|0)>>14)+e|0;t=((Y(u,l)|0)+8192>>14)+e|0;d[q+(i<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[q+2>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[q+(k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else q=q+(h<<1)|0}return}}function OBa(a){a=a|0;YDc(a);return}function PBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){QBa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function QBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=(b[a+8>>0]^1)&255;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;a=e*3|0;if((e|0)<=0)return;e=j+1|0;o=2-j|0;j=i^2;if((g|0)==4){p=0;q=d;while(1){r=h[c+p>>0]|0;s=(h[c+(o+p)>>0]|0)+-128|0;t=((Y(s,n)|0)+8192>>14)+r|0;u=(h[c+(e+p)>>0]|0)+-128|0;v=((Y(u,l)|0)+8192+(Y(s,m)|0)>>14)+r|0;s=((Y(u,k)|0)+8192>>14)+r|0;b[q+i>>0]=t>>>0<256?t:(t|0)>0?255:0;b[q+1>>0]=v>>>0<256?v:(v|0)>0?255:0;b[q+j>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;p=p+3|0;if((p|0)>=(a|0))break;else q=q+4|0}return}else{q=0;p=d;while(1){d=h[c+q>>0]|0;s=(h[c+(o+q)>>0]|0)+-128|0;v=((Y(s,n)|0)+8192>>14)+d|0;t=(h[c+(e+q)>>0]|0)+-128|0;r=((Y(t,l)|0)+8192+(Y(s,m)|0)>>14)+d|0;s=((Y(t,k)|0)+8192>>14)+d|0;b[p+i>>0]=v>>>0<256?v:(v|0)>0?255:0;b[p+1>>0]=r>>>0<256?r:(r|0)>0?255:0;b[p+j>>0]=s>>>0<256?s:(s|0)>0?255:0;q=q+3|0;if((q|0)>=(a|0))break;else p=p+g|0}return}}function RBa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+48|0;n=m+8|0;o=m;switch((k?20:0)+(j*100|0)+l|0){case 300:{f[n>>2]=76396;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;SBa(n,o)}u=m;return}case 301:{f[n>>2]=76416;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;TBa(n,o)}u=m;return}case 320:{f[n>>2]=76436;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;UBa(n,o)}u=m;return}case 321:{f[n>>2]=76456;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;VBa(n,o)}u=m;return}case 400:{f[n>>2]=76476;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;WBa(n,o)}u=m;return}case 401:{f[n>>2]=76496;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;XBa(n,o)}u=m;return}case 420:{f[n>>2]=76516;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;YBa(n,o)}u=m;return}case 421:{f[n>>2]=76536;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;ZBa(n,o)}u=m;return}default:{f[n>>2]=0;f[n+4>>2]=0;m=tT(n,41)|0;o=369734;i=m+41|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(i|0));z5(-206,n,369776,369796,2404)}}}function SBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+3>>0]=a>>>0<256?a:(a|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function TBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+3>>0]=s>>>0<256?s:(s|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function UBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function VBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function WBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+3>>0]=-1;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+6>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+7>>0]=-1;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+3>>0]=-1;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+6>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function XBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+6>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+7>>0]=-1;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+6>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function YBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+3>>0]=-1;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+6>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+7>>0]=-1;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+3>>0]=-1;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+6>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function ZBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+6>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+7>>0]=-1;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+6>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function _Ba(a){a=a|0;YDc(a);return}function $Ba(a){a=a|0;YDc(a);return}function aCa(a){a=a|0;YDc(a);return}function bCa(a){a=a|0;YDc(a);return}function cCa(a){a=a|0;YDc(a);return}function dCa(a){a=a|0;YDc(a);return}function eCa(a){a=a|0;YDc(a);return}function fCa(a){a=a|0;YDc(a);return}function gCa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=u;u=u+48|0;m=l+8|0;n=l;o=a+(Y(h,c)|0)|0;p=(h|0)%4|0;q=a+(Y(((h|0)/4|0)+h|0,c)|0)+(Y((p|0)/2|0,(g|0)/2|0)|0)|0;r=(p|0)==2;p=(k|0)==1;k=p?q:o;s=p?o:q;q=r&p&1;o=r&(p^1)&1;switch(((i*10|0)+-30+(j?2:0)|0)>>>1&2147483647|0){case 0:{f[m>>2]=76556;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=s;f[m+28>>2]=c;f[m+32>>2]=q;f[m+36>>2]=o;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;y8(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;hCa(m,n)}u=l;return}case 1:{f[m>>2]=76576;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=s;f[m+28>>2]=c;f[m+32>>2]=q;f[m+36>>2]=o;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;y8(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;iCa(m,n)}u=l;return}case 5:{f[m>>2]=76596;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=s;f[m+28>>2]=c;f[m+32>>2]=q;f[m+36>>2]=o;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;y8(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;jCa(m,n)}u=l;return}case 6:{f[m>>2]=76616;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=s;f[m+28>>2]=c;f[m+32>>2]=q;f[m+36>>2]=o;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;y8(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;kCa(m,n)}u=l;return}default:{f[m>>2]=0;f[m+4>>2]=0;l=tT(m,41)|0;n=369734;h=l+41|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(h|0));z5(-206,m,370195,369796,2431)}}}function hCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+3>>0]=q>>>0<256?q:(q|0)>0?255:0;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+6|0;o=o+6|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function iCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+6|0;o=o+6|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function jCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;b[r+3>>0]=-1;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+6>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;b[r+7>>0]=-1;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+3>>0]=-1;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+6>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+7>>0]=-1;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+8|0;o=o+8|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function kCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;b[r+3>>0]=-1;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+6>>0]=q>>>0<256?q:(q|0)>0?255:0;b[r+7>>0]=-1;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+3>>0]=-1;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+6>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+7>>0]=-1;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+8|0;o=o+8|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function lCa(a){a=a|0;YDc(a);return}function mCa(a){a=a|0;YDc(a);return}function nCa(a){a=a|0;YDc(a);return}function oCa(a){a=a|0;YDc(a);return}function pCa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+40|0;n=l;o=d+(Y(h,e)|0)|0;f[n>>2]=76636;f[n+4>>2]=a;f[n+8>>2]=c;f[n+12>>2]=d;f[n+16>>2]=o;f[n+20>>2]=e;f[n+24>>2]=g;f[n+28>>2]=h;f[n+32>>2]=i;b[n+36>>0]=j&1;b[n+37>>0]=(k|0)==2&1;b[n+38>>0]=0;if((Y(h,g)|0)>76799){f[m>>2]=0;f[m+4>>2]=(h|0)/2|0;y8(m,n,-1.0);u=l;return}else{f[m>>2]=0;f[m+4>>2]=(h|0)/2|0;qCa(n,m);u=l;return}}function qCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=f[a+24>>2]|0;e=f[a+32>>2]|0;g=f[c>>2]|0;i=c+4|0;c=f[i>>2]|0;if((g|0)>=(c|0))return;j=a+4|0;k=a+8|0;l=a+36|0;m=a+12|0;n=a+20|0;o=a+38|0;p=a+16|0;q=(d|0)/2|0;r=(f[a+28>>2]|0)/2|0;s=a+37|0;a=Y(e,d)|0;d=(a|0)>0;t=e<<1;u=g;g=c;while(1){c=f[j>>2]|0;v=f[k>>2]|0;w=u<<1;x=c+(Y(v,w)|0)|0;y=x;z=x+1|0;A=x+2|0;x=c+(Y(v,w|1)|0)|0;v=x;c=x+1|0;B=x+2|0;x=(b[l>>0]|0)==0;C=f[n>>2]|0;D=(f[m>>2]|0)+(Y(C,w)|0)|0;w=f[p>>2]|0;if(!(b[o>>0]|0)){E=u+r|0;F=w+(Y(C,(u|0)/2|0)|0)+(Y((u|0)%2|0,q)|0)|0;G=w+(Y(C,(E|0)/2|0)|0)+(Y((E|0)%2|0,q)|0)|0}else{E=w+(Y(C,u)|0)|0;F=E;G=E+1|0}E=F;C=G;w=(b[s>>0]|0)==0;if(d){H=x?A:y;I=x?y:A;A=x?B:v;y=x?v:B;B=w?E:C;v=w?C:E;E=0;C=0;while(1){w=h[H+E>>0]|0;x=h[z+E>>0]|0;J=h[I+E>>0]|0;K=E+e|0;L=(w*269484|0)+17301504+(x*528482|0)+(J*102760|0)|0;M=((h[H+K>>0]|0)*269484|0)+17301504+((h[z+K>>0]|0)*528482|0)+((h[I+K>>0]|0)*102760|0)|0;N=((h[A+E>>0]|0)*269484|0)+17301504+((h[c+E>>0]|0)*528482|0)+((h[y+E>>0]|0)*102760|0)|0;O=((h[A+K>>0]|0)*269484|0)+17301504+((h[c+K>>0]|0)*528482|0)+((h[y+K>>0]|0)*102760|0)|0;K=L>>>20;P=C<<1;b[D+P>>0]=L>>>0<268435456?K:K|0?255:0;K=M>>>20;L=P|1;b[D+L>>0]=M>>>0<268435456?K:K|0?255:0;K=N>>>20;b[D+((f[n>>2]|0)+P)>>0]=N>>>0<268435456?K:K|0?255:0;K=O>>>20;b[D+(L+(f[n>>2]|0))>>0]=O>>>0<268435456?K:K|0?255:0;K=(Y(w,-155188)|0)+134742016+(Y(x,-305135)|0)+(J*460324|0)|0;O=(w*460324|0)+134742016+(Y(x,-385875)|0)+(Y(J,-74448)|0)|0;J=K>>20;K=O>>20;O=(b[o>>0]|0)==0?C:P;b[B+O>>0]=J>>>0<256?J:(J|0)>0?255:0;b[v+O>>0]=K>>>0<256?K:(K|0)>0?255:0;E=E+t|0;if((E|0)>=(a|0))break;else C=C+1|0}Q=f[i>>2]|0}else Q=g;u=u+1|0;if((u|0)>=(Q|0))break;else g=Q}return}function rCa(a){a=a|0;YDc(a);return}function sCa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0;m=u;u=u+32|0;n=m+8|0;o=m;do switch((j?200:0)+(i*1e3|0)+(k*10|0)+l|0){case 3e3:{f[n>>2]=76656;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;tCa(n,o)}u=m;return}case 3001:{f[n>>2]=76676;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;uCa(n,o)}u=m;return}case 3010:{f[n>>2]=76696;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;vCa(n,o)}u=m;return}case 3200:{f[n>>2]=76716;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;wCa(n,o)}u=m;return}case 3201:{f[n>>2]=76736;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;xCa(n,o)}u=m;return}case 3210:{f[n>>2]=76756;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;yCa(n,o)}u=m;return}case 4e3:{f[n>>2]=76776;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;zCa(n,o)}u=m;return}case 4001:{f[n>>2]=76796;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;ACa(n,o)}u=m;return}case 4010:{f[n>>2]=76816;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;BCa(n,o)}u=m;return}case 4200:{f[n>>2]=76836;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;CCa(n,o)}u=m;return}case 4201:{f[n>>2]=76856;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;DCa(n,o)}u=m;return}case 4210:{f[n>>2]=76876;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;y8(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;ECa(n,o)}u=m;return}default:{f[n>>2]=0;f[n+4>>2]=0;p=tT(n,41)|0;q=369734;r=p+41|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));z5(-206,n,370391,369796,2481)}}while(0)}function tCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function uCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function vCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function wCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function xCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function yCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function zCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function ACa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function BCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function CCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function DCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function ECa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function FCa(a){a=a|0;YDc(a);return}function GCa(a){a=a|0;YDc(a);return}function HCa(a){a=a|0;YDc(a);return}function ICa(a){a=a|0;YDc(a);return}function JCa(a){a=a|0;YDc(a);return}function KCa(a){a=a|0;YDc(a);return}function LCa(a){a=a|0;YDc(a);return}function MCa(a){a=a|0;YDc(a);return}function NCa(a){a=a|0;YDc(a);return}function OCa(a){a=a|0;YDc(a);return}function PCa(a){a=a|0;YDc(a);return}function QCa(a){a=a|0;YDc(a);return}function RCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;kAa(g,a,b,3);yBa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,d);lAa(g);u=e;return}function SCa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;nAa(h,a,b,i);HBa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,e);oAa(h);u=g;return}function TCa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+128|0;i=h;gBa(i,a,b,c);sCa(f[i+16>>2]|0,f[i+48>>2]|0,f[i+72>>2]|0,f[i+104>>2]|0,f[i+12>>2]|0,f[i+8>>2]|0,c,d,e,g);hBa(i);u=h;return}function UCa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;if((q$(a,-1)|0)==2?(p$(a,-1)|0)==0:0){aR(a,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;e=tT(g,45)|0;d=370939;c=e+45|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(c|0));z5(-215,g,370985,369796,2641)}function VCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;WCa(g,a,b,1);pCa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+116>>2]|0,c,d);XCa(g);u=e;return}function WCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}y=c$(c,-1)|0;z=y>>>3;A=(z&511)+1|0;f[a+116>>2]=A;B=y&7;y=a+112|0;f[y>>2]=B;if((z&510|0)!=2)e2(A,76888);if((e|0)!=1)e2(e,76916);if(B|0)b2(B,76944);B=c+4|0;e=d+4|0;if((f[B>>2]|0)!=(f[e>>2]|0)){do if((d$(c)|0)==65536){A=f[B>>2]|0;f[h>>2]=f[A>>2];z=h+4|0;C=A+4|0;f[z>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[A+8>>2];f[h+12>>2]=f[A+12>>2];f[h+16>>2]=f[A+16>>2];f[h+20>>2]=f[A+20>>2];f[h+24>>2]=f[A+24>>2];f[h+28>>2]=f[A+28>>2];f[h+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[z>>2]=0;ZS(h,A);break}}else a$(h,c,-1);while(0);B=h+36|0;A=f[B>>2]|0;if((a|0)==(h|0))G=A;else{if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+36|0;A=f[z>>2]|0;if(A|0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0)_S(a);f[z>>2]=0;A=a+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[j>>2]|0)>0){C=f[l>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0;H=f[j>>2]|0}while((D|0)<(H|0));f[a>>2]=f[h>>2];if((H|0)<3)I=29;else I=31}else{f[a>>2]=f[h>>2];I=29}if((I|0)==29){H=f[h+4>>2]|0;if((H|0)<3){f[j>>2]=H;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;H=f[p>>2]|0;f[H>>2]=f[k>>2];f[H+4>>2]=f[k+4>>2]}else I=31}if((I|0)==31)ZS(a,h);f[A>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];A=f[B>>2]|0;f[z>>2]=A;G=A}if(G|0?(A=G+12|0,G=f[A>>2]|0,f[A>>2]=G+-1,(G|0)==1):0)_S(h);f[B>>2]=0;B=h+16|0;G=h+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[G>>2]|0)>0){B=f[h+40>>2]|0;A=0;do{f[B+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)!=(h+48|0))g0(G)}else{G=h+8|0;f[G>>2]=0;f[G+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;G=f[c>>2]|0;if((G|l)&1|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,39)|0;x=371096;n=m+39|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,267)}x=((G|0)/2|0)*3|0;f[t>>2]=l;f[w>>2]=x;f[i>>2]=l;f[i+4>>2]=x;v$(d,i,f[y>>2]&7,-1,0,0);do if((d$(d)|0)==65536){y=f[e>>2]|0;f[h>>2]=f[y>>2];i=h+4|0;x=y+4|0;f[i>>2]=f[x>>2];l=h+8|0;f[l>>2]=f[y+8>>2];f[h+12>>2]=f[y+12>>2];f[h+16>>2]=f[y+16>>2];f[h+20>>2]=f[y+20>>2];f[h+24>>2]=f[y+24>>2];f[h+28>>2]=f[y+28>>2];f[h+32>>2]=f[y+32>>2];w=f[y+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[x>>2]|0)<3){x=f[y+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2];break}else{f[i>>2]=0;ZS(h,y);break}}else a$(h,d,-1);while(0);d=h+36|0;e=f[d>>2]|0;if((o|0)==(h|0))J=e;else{if(e|0){y=e+12|0;f[y>>2]=(f[y>>2]|0)+1}y=a+92|0;e=f[y>>2]|0;if(e|0?(i=e+12|0,e=f[i>>2]|0,f[i>>2]=e+-1,(e|0)==1):0)_S(o);f[y>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;K=f[q>>2]|0}while((s|0)<(K|0));f[o>>2]=f[h>>2];if((K|0)<3)I=62;else I=64}else{f[o>>2]=f[h>>2];I=62}if((I|0)==62){K=f[h+4>>2]|0;if((K|0)<3){f[q>>2]=K;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;K=f[v>>2]|0;f[K>>2]=f[r>>2];f[K+4>>2]=f[r+4>>2]}else I=64}if((I|0)==64)ZS(o,h);f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[y>>2]=a;J=a}if(J|0?(a=J+12|0,J=f[a>>2]|0,f[a>>2]=J+-1,(J|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;J=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[J>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[J>>2]|0))}J=f[h+44>>2]|0;if((J|0)==(h+48|0)){u=g;return}g0(J);u=g;return}function XCa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function YCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+208|0;d=c+8|0;e=c;g=c+80|0;h=c+24|0;ZCa(g,a,b,1);b=f[g+124>>2]|0;f[d>>2]=-2147483648;f[d+4>>2]=2147483647;f[e>>2]=0;f[e+4>>2]=b;$S(h,g,e,d);e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=g+56;h_(h,d);d=h+36|0;e=f[d>>2]|0;if(e|0?(b=e+12|0,e=f[b>>2]|0,f[b>>2]=e+-1,(e|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;e=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[h+40>>2]|0;b=0;do{f[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){_Ca(g);u=c;return}g0(e);_Ca(g);u=c;return}function ZCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}y=c$(c,-1)|0;z=y>>>3&511;A=z+1|0;f[a+116>>2]=A;B=y&7;y=a+112|0;f[y>>2]=B;if(z|0)e2(A,76972);if((e|0)!=1)e2(e,77e3);if(B|0)b2(B,77028);B=c+4|0;e=d+4|0;if((f[B>>2]|0)!=(f[e>>2]|0)){do if((d$(c)|0)==65536){A=f[B>>2]|0;f[h>>2]=f[A>>2];z=h+4|0;C=A+4|0;f[z>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[A+8>>2];f[h+12>>2]=f[A+12>>2];f[h+16>>2]=f[A+16>>2];f[h+20>>2]=f[A+20>>2];f[h+24>>2]=f[A+24>>2];f[h+28>>2]=f[A+28>>2];f[h+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[z>>2]=0;ZS(h,A);break}}else a$(h,c,-1);while(0);B=h+36|0;A=f[B>>2]|0;if((a|0)==(h|0))G=A;else{if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+36|0;A=f[z>>2]|0;if(A|0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0)_S(a);f[z>>2]=0;A=a+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[j>>2]|0)>0){C=f[l>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0;H=f[j>>2]|0}while((D|0)<(H|0));f[a>>2]=f[h>>2];if((H|0)<3)I=29;else I=31}else{f[a>>2]=f[h>>2];I=29}if((I|0)==29){H=f[h+4>>2]|0;if((H|0)<3){f[j>>2]=H;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;H=f[p>>2]|0;f[H>>2]=f[k>>2];f[H+4>>2]=f[k+4>>2]}else I=31}if((I|0)==31)ZS(a,h);f[A>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];A=f[B>>2]|0;f[z>>2]=A;G=A}if(G|0?(A=G+12|0,G=f[A>>2]|0,f[A>>2]=G+-1,(G|0)==1):0)_S(h);f[B>>2]=0;B=h+16|0;G=h+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[G>>2]|0)>0){B=f[h+40>>2]|0;A=0;do{f[B+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)!=(h+48|0))g0(G)}else{G=h+8|0;f[G>>2]=0;f[G+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;G=f[c>>2]|0;if((G|0)%3|0|l&1|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,39)|0;x=371590;n=m+39|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,271)}x=(G<<1|0)/3|0;f[t>>2]=l;f[w>>2]=x;f[i>>2]=l;f[i+4>>2]=x;v$(d,i,f[y>>2]&7,-1,0,0);do if((d$(d)|0)==65536){y=f[e>>2]|0;f[h>>2]=f[y>>2];i=h+4|0;x=y+4|0;f[i>>2]=f[x>>2];l=h+8|0;f[l>>2]=f[y+8>>2];f[h+12>>2]=f[y+12>>2];f[h+16>>2]=f[y+16>>2];f[h+20>>2]=f[y+20>>2];f[h+24>>2]=f[y+24>>2];f[h+28>>2]=f[y+28>>2];f[h+32>>2]=f[y+32>>2];w=f[y+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;t=h+44|0;f[t>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[x>>2]|0)<3){x=f[y+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2];break}else{f[i>>2]=0;ZS(h,y);break}}else a$(h,d,-1);while(0);d=h+36|0;e=f[d>>2]|0;if((o|0)==(h|0))J=e;else{if(e|0){y=e+12|0;f[y>>2]=(f[y>>2]|0)+1}y=a+92|0;e=f[y>>2]|0;if(e|0?(i=e+12|0,e=f[i>>2]|0,f[i>>2]=e+-1,(e|0)==1):0)_S(o);f[y>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){i=f[s>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0;K=f[q>>2]|0}while((s|0)<(K|0));f[o>>2]=f[h>>2];if((K|0)<3)I=62;else I=64}else{f[o>>2]=f[h>>2];I=62}if((I|0)==62){K=f[h+4>>2]|0;if((K|0)<3){f[q>>2]=K;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;K=f[v>>2]|0;f[K>>2]=f[r>>2];f[K+4>>2]=f[r+4>>2]}else I=64}if((I|0)==64)ZS(o,h);f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[y>>2]=a;J=a}if(J|0?(a=J+12|0,J=f[a>>2]|0,f[a>>2]=J+-1,(J|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;J=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[J>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[J>>2]|0))}J=f[h+44>>2]|0;if((J|0)==(h+48|0)){u=g;return}g0(J);u=g;return}function _Ca(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function $Ca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;aDa(h,a,b,i);gCa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+68>>2]|0,f[h+64>>2]|0,i,d,e);bDa(h);u=g;return}function aDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;p=a+44|0;f[p>>2]=o;f[o>>2]=0;f[a+52>>2]=0;o=a+56|0;f[o>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;v=a+100|0;f[v>>2]=t;f[t>>2]=0;f[a+108>>2]=0;t=a+120|0;f[t>>2]=0;w=a+124|0;f[w>>2]=0;if(r$(c)|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,13)|0;x=371005;n=m+13|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,250)}y=c$(c,-1)|0;z=y>>>3&511;A=z+1|0;f[a+116>>2]=A;B=y&7;y=a+112|0;f[y>>2]=B;if(z|0)e2(A,77056);if((e+-3|0)>>>0>=2)e2(e,77084);if(B|0)b2(B,77112);B=c+4|0;A=d+4|0;if((f[B>>2]|0)!=(f[A>>2]|0)){do if((d$(c)|0)==65536){z=f[B>>2]|0;f[h>>2]=f[z>>2];C=h+4|0;D=z+4|0;f[C>>2]=f[D>>2];E=h+8|0;f[E>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];F=f[z+36>>2]|0;f[h+36>>2]=F;f[h+40>>2]=E;E=h+48|0;G=h+44|0;f[G>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[z+44>>2]|0;E=f[G>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];break}else{f[C>>2]=0;ZS(h,z);break}}else a$(h,c,-1);while(0);B=h+36|0;z=f[B>>2]|0;if((a|0)==(h|0))H=z;else{if(z|0){C=z+12|0;f[C>>2]=(f[C>>2]|0)+1}C=a+36|0;z=f[C>>2]|0;if(z|0?(D=z+12|0,z=f[D>>2]|0,f[D>>2]=z+-1,(z|0)==1):0)_S(a);f[C>>2]=0;z=a+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){D=f[l>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0;I=f[j>>2]|0}while((E|0)<(I|0));f[a>>2]=f[h>>2];if((I|0)<3)J=29;else J=31}else{f[a>>2]=f[h>>2];J=29}if((J|0)==29){I=f[h+4>>2]|0;if((I|0)<3){f[j>>2]=I;f[k>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];k=f[h+44>>2]|0;I=f[p>>2]|0;f[I>>2]=f[k>>2];f[I+4>>2]=f[k+4>>2]}else J=31}if((J|0)==31)ZS(a,h);f[z>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];z=f[B>>2]|0;f[C>>2]=z;H=z}if(H|0?(z=H+12|0,H=f[z>>2]|0,f[z>>2]=H+-1,(H|0)==1):0)_S(h);f[B>>2]=0;B=h+16|0;H=h+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[H>>2]|0)>0){B=f[h+40>>2]|0;z=0;do{f[B+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[H>>2]|0))}H=f[h+44>>2]|0;if((H|0)!=(h+48|0))g0(H)}else{H=h+8|0;f[H>>2]=0;f[H+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;t$(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;H=f[c>>2]|0;if((H|0)%3|0|l&1|0){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,39)|0;x=371590;n=m+39|0;do{b[m>>0]=b[x>>0]|0;m=m+1|0;x=x+1|0}while((m|0)<(n|0));z5(-215,h,371019,371029,271)}x=(H<<1|0)/3|0;f[t>>2]=l;f[w>>2]=x;f[i>>2]=l;f[i+4>>2]=x;v$(d,i,f[y>>2]&7|(e<<3)+-8,-1,0,0);do if((d$(d)|0)==65536){e=f[A>>2]|0;f[h>>2]=f[e>>2];y=h+4|0;i=e+4|0;f[y>>2]=f[i>>2];x=h+8|0;f[x>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=x;x=h+48|0;w=h+44|0;f[w>>2]=x;f[x>>2]=0;f[h+52>>2]=0;if(l|0){x=l+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[i>>2];f[x+4>>2]=f[i+4>>2];break}else{f[y>>2]=0;ZS(h,e);break}}else a$(h,d,-1);while(0);d=h+36|0;A=f[d>>2]|0;if((o|0)==(h|0))K=A;else{if(A|0){e=A+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+92|0;A=f[e>>2]|0;if(A|0?(y=A+12|0,A=f[y>>2]|0,f[y>>2]=A+-1,(A|0)==1):0)_S(o);f[e>>2]=0;A=a+72|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[q>>2]|0)>0){y=f[s>>2]|0;s=0;do{f[y+(s<<2)>>2]=0;s=s+1|0;L=f[q>>2]|0}while((s|0)<(L|0));f[o>>2]=f[h>>2];if((L|0)<3)J=62;else J=64}else{f[o>>2]=f[h>>2];J=62}if((J|0)==62){L=f[h+4>>2]|0;if((L|0)<3){f[q>>2]=L;f[r>>2]=f[h+8>>2];f[a+68>>2]=f[h+12>>2];r=f[h+44>>2]|0;L=f[v>>2]|0;f[L>>2]=f[r>>2];f[L+4>>2]=f[r+4>>2]}else J=64}if((J|0)==64)ZS(o,h);f[A>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];a=f[d>>2]|0;f[e>>2]=a;K=a}if(K|0?(a=K+12|0,K=f[a>>2]|0,f[a>>2]=K+-1,(K|0)==1):0)_S(h);f[d>>2]=0;d=h+16|0;K=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[K>>2]|0)>0){d=f[h+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[K>>2]|0))}K=f[h+44>>2]|0;if((K|0)==(h+48|0)){u=g;return}g0(K);u=g;return}function bDa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))g0(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)_S(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;g0(d);return}function cDa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;aDa(h,a,b,i);b=f[h+16>>2]|0;a=f[h+48>>2]|0;c=f[h+64>>2]|0;RBa(b,b+(Y(c,a)|0)|0,a,f[h+72>>2]|0,f[h+104>>2]|0,f[h+68>>2]|0,c,i,d,e);bDa(h);u=g;return}function dDa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=u;u=u+432|0;g=e+368|0;h=e+320|0;i=e+264|0;j=e;k=e+248|0;l=e+192|0;f[g>>2]=1124007936;m=g+4|0;n=g+8|0;o=g+40|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;s=g+48|0;t=g+44|0;f[t>>2]=s;f[s>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;v=h+4|0;w=h+8|0;x=h+20|0;y=h+24|0;z=h+28|0;A=h+32|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[A>>2]=w;B=h+40|0;C=h+36|0;f[C>>2]=B;f[h+44>>2]=0;f[B>>2]=0;B=(d$(a)|0)==655360;if(B){e$(i,a,-1);D=i+24|0;E=f[D>>2]|0;if(E|0){F=E+8|0;f[F>>2]=(f[F>>2]|0)+1}F=f[y>>2]|0;if(F|0?(E=F+8|0,F=f[E>>2]|0,f[E>>2]=F+-1,(F|0)==1):0)HQ(h);if((f[v>>2]|0)>0){F=f[A>>2]|0;E=0;do{f[F+(E<<2)>>2]=0;E=E+1|0;G=f[v>>2]|0}while((E|0)<(G|0));f[y>>2]=0;f[h>>2]=f[i>>2];if((G|0)<3)H=12;else H=14}else{f[y>>2]=0;f[h>>2]=f[i>>2];H=12}if((H|0)==12){G=f[i+4>>2]|0;if((G|0)<3){f[v>>2]=G;f[w>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];w=f[i+36>>2]|0;G=f[C>>2]|0;f[G>>2]=f[w>>2];f[G+4>>2]=f[w+4>>2]}else H=14}if((H|0)==14)FQ(h,i);f[h+16>>2]=f[i+16>>2];if(!(f[x>>2]|0))f[x>>2]=f[i+20>>2];f[y>>2]=f[D>>2];f[z>>2]=f[i+28>>2];z=f[h>>2]|0;D=f[A>>2]|0;A=f[D+4>>2]|0;y=f[D>>2]|0;GQ(i);I=z;J=A;K=y}else{do if((d$(a)|0)==65536){y=f[a+4>>2]|0;f[i>>2]=f[y>>2];A=i+4|0;z=y+4|0;f[A>>2]=f[z>>2];D=i+8|0;f[D>>2]=f[y+8>>2];f[i+12>>2]=f[y+12>>2];f[i+16>>2]=f[y+16>>2];f[i+20>>2]=f[y+20>>2];f[i+24>>2]=f[y+24>>2];f[i+28>>2]=f[y+28>>2];f[i+32>>2]=f[y+32>>2];x=i+36|0;w=f[y+36>>2]|0;f[x>>2]=w;f[i+40>>2]=D;D=i+48|0;G=i+44|0;f[G>>2]=D;f[D>>2]=0;f[i+52>>2]=0;if(w|0){D=w+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[z>>2]|0)<3){z=f[y+44>>2]|0;D=f[G>>2]|0;f[D>>2]=f[z>>2];f[D+4>>2]=f[z+4>>2];M=x;break}else{f[A>>2]=0;ZS(i,y);M=x;break}}else{a$(i,a,-1);M=i+36|0}while(0);a=f[M>>2]|0;if(a|0){x=a+12|0;f[x>>2]=(f[x>>2]|0)+1}x=g+36|0;a=f[x>>2]|0;if(a|0?(y=a+12|0,a=f[y>>2]|0,f[y>>2]=a+-1,(a|0)==1):0)_S(g);f[x>>2]=0;a=g+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[m>>2]|0)>0){y=f[o>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;N=f[m>>2]|0}while((A|0)<(N|0));f[g>>2]=f[i>>2];if((N|0)<3)H=35;else H=37}else{f[g>>2]=f[i>>2];H=35}if((H|0)==35){N=f[i+4>>2]|0;if((N|0)<3){f[m>>2]=N;f[n>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];n=f[i+44>>2]|0;N=f[t>>2]|0;f[N>>2]=f[n>>2];f[N+4>>2]=f[n+4>>2]}else H=37}if((H|0)==37)ZS(g,i);n=i+16|0;f[a>>2]=f[n>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];a=f[M>>2]|0;f[x>>2]=a;x=f[g>>2]|0;N=f[o>>2]|0;A=f[N+4>>2]|0;y=f[N>>2]|0;if(a|0?(N=a+12|0,a=f[N>>2]|0,f[N>>2]=a+-1,(a|0)==1):0)_S(i);f[M>>2]=0;M=i+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[M>>2]|0)>0){n=f[i+40>>2]|0;a=0;do{f[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[M>>2]|0))}M=f[i+44>>2]|0;if((M|0)!=(i+48|0))g0(M);I=x;J=A;K=y}y=f[c>>2]|0;f[i>>2]=y;A=i+4|0;x=c+4|0;M=f[x>>2]|0;f[A>>2]=M;a=i+8|0;n=c+8|0;N=f[n>>2]|0;f[a>>2]=N;z=i+12|0;D=c+12|0;G=f[D>>2]|0;f[z>>2]=G;if(I&4088|0){f[j>>2]=0;f[j+4>>2]=0;I=tT(j,7)|0;b[I>>0]=b[372156]|0;b[I+1>>0]=b[372157]|0;b[I+2>>0]=b[372158]|0;b[I+3>>0]=b[372159]|0;b[I+4>>0]=b[372160]|0;b[I+5>>0]=b[372161]|0;b[I+6>>0]=b[372162]|0;eDa(-215,j,61)}if((G|0)<1|(N|0)<1){f[j>>2]=0;f[j+4>>2]=0;q=tT(j,35)|0;I=372164;r=q+35|0;do{b[q>>0]=b[I>>0]|0;q=q+1|0;I=I+1|0}while((q|0)<(r|0));eDa(-5,j,64)}I=(y|0)>0?y:0;q=(M|0)>0?M:0;r=y+N|0;w=((J|0)<(r|0)?J:r)-I|0;r=M+G|0;C=((K|0)<(r|0)?K:r)-q|0;r=(w|0)<1|(C|0)<1;f[c>>2]=r?0:I;f[x>>2]=r?0:q;f[n>>2]=r?0:w;f[D>>2]=r?0:C;C=f[d>>2]|0;if(!(C&2))O=1.0;else{P=+p[d+8>>3];O=P<0.0?0.0:P}r=nrc(O*O)|0;w=((r|0)<0)<<31>>31;if(!(C&1))Q=100;else{C=f[d+4>>2]|0;Q=(C|0)>1?C:1}C=(J|0)/2|0;d=(K|0)/2|0;q=k+8|0;I=k+12|0;v=k+4|0;E=j+8|0;F=j+16|0;R=k+8|0;S=k+12|0;T=k+4|0;U=l+36|0;V=l+16|0;W=l+4|0;X=l+40|0;Z=l+44|0;_=l+48|0;$=0;aa=y;y=M;M=N;N=G;while(1){G=(aa|0)>0?aa:0;ba=(y|0)>0?y:0;ca=M+aa|0;da=((J|0)<(ca|0)?J:ca)-G|0;ca=N+y|0;ea=((K|0)<(ca|0)?K:ca)-ba|0;ca=(da|0)<1|(ea|0)<1;fa=ca?0:ea;ga=ca?0:da;f[i>>2]=ca?0:G;f[A>>2]=ca?0:ba;f[a>>2]=ga;f[z>>2]=fa;if((ba|G|0)==0|ca?ca|(da|ea|0)==0:0){f[i>>2]=C;f[A>>2]=d}f[a>>2]=(ga|0)>1?ga:1;f[z>>2]=(fa|0)>1?fa:1;if(!B){cT(l,g,i);f[R>>2]=0;f[S>>2]=0;f[k>>2]=16842752;f[T>>2]=l;eka(j,k,0);fa=f[U>>2]|0;if(fa|0?(ga=fa+12|0,fa=f[ga>>2]|0,f[ga>>2]=fa+-1,(fa|0)==1):0)_S(l);f[U>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[W>>2]|0)>0){fa=f[X>>2]|0;ga=0;do{f[fa+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[W>>2]|0))}ga=f[Z>>2]|0;if((ga|0)!=(_|0))g0(ga)}else{CQ(l,h,i);f[q>>2]=0;f[I>>2]=0;f[k>>2]=17432576;f[v>>2]=l;eka(j,k,0);GQ(l)}O=+p[j>>3];if(+L(+O)<2.220446049250313e-16){H=71;break}ga=nrc(+p[E>>3]/O-+(f[n>>2]|0)*.5)|0;fa=nrc(+p[F>>3]/O-+(f[D>>2]|0)*.5)|0;ea=f[i>>2]|0;da=ea+ga|0;ga=f[a>>2]|0;ca=J-ga|0;G=(da|0)>0?da:0;da=(ca|0)<(G|0)?ca:G;G=f[A>>2]|0;ca=G+fa|0;fa=f[z>>2]|0;ba=K-fa|0;ha=(ca|0)>0?ca:0;ca=(ba|0)<(ha|0)?ba:ha;ha=da-ea|0;ea=ca-G|0;f[i>>2]=da;f[A>>2]=ca;if(0<(w|0)|(0==(w|0)?((Y(ea,ea)|0)+(Y(ha,ha)|0)|0)>>>0<r>>>0:0)){ia=da;ja=ca;ka=ga;la=fa;H=73;break}ha=$+1|0;if((ha|0)<(Q|0)){$=ha;aa=da;y=ca;M=ga;N=fa}else{ma=ha;na=da;oa=ca;pa=ga;qa=fa;break}}if((H|0)==71){ia=f[i>>2]|0;ja=f[A>>2]|0;ka=f[a>>2]|0;la=f[z>>2]|0;H=73}if((H|0)==73){ma=$;na=ia;oa=ja;pa=ka;qa=la}f[c>>2]=na;f[x>>2]=oa;f[n>>2]=pa;f[D>>2]=qa;GQ(h);h=g+36|0;qa=f[h>>2]|0;if(qa|0?(D=qa+12|0,qa=f[D>>2]|0,f[D>>2]=qa+-1,(qa|0)==1):0)_S(g);f[h>>2]=0;h=g+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[m>>2]|0)>0){h=f[o>>2]|0;o=0;do{f[h+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[m>>2]|0))}m=f[t>>2]|0;if((m|0)==(s|0)){u=e;return ma|0}g0(m);u=e;return ma|0}function eDa(a,b,c){a=a|0;b=b|0;c=c|0;z5(a,b,372200,372210,c);return}function fDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0;e=u;u=u+368|0;g=e;h=e+312|0;i=e+264|0;j=e+248|0;k=e+192|0;f[h>>2]=1124007936;l=h+4|0;m=h+8|0;o=h+40|0;q=l;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=m;q=h+48|0;r=h+44|0;f[r>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;s=i+4|0;t=i+8|0;v=i+20|0;w=i+24|0;x=i+28|0;y=i+32|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[y>>2]=t;z=i+40|0;A=i+36|0;f[A>>2]=z;f[i+44>>2]=0;f[z>>2]=0;z=(d$(b)|0)==655360;if(z){e$(g,b,-1);B=g+24|0;C=f[B>>2]|0;if(C|0){D=C+8|0;f[D>>2]=(f[D>>2]|0)+1}D=f[w>>2]|0;if(D|0?(C=D+8|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)HQ(i);if((f[s>>2]|0)>0){D=f[y>>2]|0;C=0;do{f[D+(C<<2)>>2]=0;C=C+1|0;E=f[s>>2]|0}while((C|0)<(E|0));f[w>>2]=0;f[i>>2]=f[g>>2];if((E|0)<3)F=12;else F=14}else{f[w>>2]=0;f[i>>2]=f[g>>2];F=12}if((F|0)==12){E=f[g+4>>2]|0;if((E|0)<3){f[s>>2]=E;f[t>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];t=f[g+36>>2]|0;E=f[A>>2]|0;f[E>>2]=f[t>>2];f[E+4>>2]=f[t+4>>2]}else F=14}if((F|0)==14)FQ(i,g);f[i+16>>2]=f[g+16>>2];if(!(f[v>>2]|0))f[v>>2]=f[g+20>>2];f[w>>2]=f[B>>2];f[x>>2]=f[g+28>>2];x=f[y>>2]|0;y=f[x+4>>2]|0;B=f[x>>2]|0;GQ(g);G=y;H=B}else{do if((d$(b)|0)==65536){B=f[b+4>>2]|0;f[g>>2]=f[B>>2];y=g+4|0;x=B+4|0;f[y>>2]=f[x>>2];w=g+8|0;f[w>>2]=f[B+8>>2];f[g+12>>2]=f[B+12>>2];f[g+16>>2]=f[B+16>>2];f[g+20>>2]=f[B+20>>2];f[g+24>>2]=f[B+24>>2];f[g+28>>2]=f[B+28>>2];f[g+32>>2]=f[B+32>>2];v=g+36|0;t=f[B+36>>2]|0;f[v>>2]=t;f[g+40>>2]=w;w=g+48|0;E=g+44|0;f[E>>2]=w;f[w>>2]=0;f[g+52>>2]=0;if(t|0){w=t+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[x>>2]|0)<3){x=f[B+44>>2]|0;w=f[E>>2]|0;f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2];I=v;break}else{f[y>>2]=0;ZS(g,B);I=v;break}}else{a$(g,b,-1);I=g+36|0}while(0);v=f[I>>2]|0;if(v|0){B=v+12|0;f[B>>2]=(f[B>>2]|0)+1}B=h+36|0;v=f[B>>2]|0;if(v|0?(y=v+12|0,v=f[y>>2]|0,f[y>>2]=v+-1,(v|0)==1):0)_S(h);f[B>>2]=0;v=h+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){y=f[o>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0;J=f[l>>2]|0}while((x|0)<(J|0));f[h>>2]=f[g>>2];if((J|0)<3)F=35;else F=37}else{f[h>>2]=f[g>>2];F=35}if((F|0)==35){J=f[g+4>>2]|0;if((J|0)<3){f[l>>2]=J;f[m>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];m=f[g+44>>2]|0;J=f[r>>2]|0;f[J>>2]=f[m>>2];f[J+4>>2]=f[m+4>>2]}else F=37}if((F|0)==37)ZS(h,g);F=g+16|0;f[v>>2]=f[F>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];v=f[I>>2]|0;f[B>>2]=v;B=f[o>>2]|0;m=f[B+4>>2]|0;J=f[B>>2]|0;if(v|0?(B=v+12|0,v=f[B>>2]|0,f[B>>2]=v+-1,(v|0)==1):0)_S(g);f[I>>2]=0;I=g+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[I>>2]|0)>0){F=f[g+40>>2]|0;v=0;do{f[F+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[I>>2]|0))}I=f[g+44>>2]|0;if((I|0)!=(g+48|0))g0(I);G=m;H=J};f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];dDa(b,c,g)|0;b=f[c>>2]|0;d=(b|0)<10?0:b+-10|0;f[c>>2]=d;b=c+4|0;J=f[b>>2]|0;m=(J|0)<10?0:J+-10|0;f[b>>2]=m;J=c+8|0;I=(f[J>>2]|0)+20|0;f[J>>2]=(d+I|0)>(G|0)?G-d|0:I;I=c+12|0;d=(f[I>>2]|0)+20|0;f[I>>2]=(m+d|0)>(H|0)?H-m|0:d;if(!z){cT(k,h,c);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=k;eka(g,j,0);z=k+36|0;d=f[z>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)_S(k);f[z>>2]=0;z=k+16|0;d=k+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[d>>2]|0)>0){z=f[k+40>>2]|0;m=0;do{f[z+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[d>>2]|0))}d=f[k+44>>2]|0;if((d|0)!=(k+48|0))g0(d)}else{CQ(k,i,c);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17432576;f[j+4>>2]=k;eka(g,j,0);GQ(k)}K=+p[g>>3];N=+p[g+88>>3];Q=+p[g+80>>3];R=+p[g+96>>3];if(+L(+K)<2.220446049250313e-16){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0}else{S=+p[g+16>>3];T=1.0/K;k=nrc(T*+p[g+8>>3]+ +(f[c>>2]|0))|0;g=nrc(T*S+ +(f[b>>2]|0))|0;S=N*T;K=T*Q-T*R;V=+U(+(S*2.0),+(K+ +M(+(S*(S*4.0)+K*K))));K=+O(+V);S=+P(+V);W=K*K;X=N*(K*2.0*S);N=S*S;Y=+M(+(T*(R*N+(Q*W+X))))*4.0;Z=+M(+(T*(R*W+(Q*N-X))))*4.0;if(Y<Z){_=1.5707963267948966-V;$=Y;aa=Z;ba=K;ca=S}else{_=V;$=Z;aa=Y;ba=S;ca=K}j=nrc(+L(+(ca*aa)))|0;d=nrc(+L(+(ba*$)))|0;m=((j|0)<(d|0)?d:j)+2|0;j=G-k<<1;d=(m|0)>(j|0)?j:m;m=nrc(+L(+(ba*aa)))|0;j=nrc(+L(+(ca*$)))|0;z=((m|0)<(j|0)?j:m)+2|0;m=H-g<<1;j=(z|0)>(m|0)?m:z;z=k-((d|0)/2|0)|0;k=(z|0)>0?z:0;f[c>>2]=k;c=g-((j|0)/2|0)|0;g=(c|0)>0?c:0;f[b>>2]=g;b=G-k|0;G=(b|0)>(d|0)?d:b;f[J>>2]=G;J=H-g|0;H=(J|0)>(j|0)?j:J;f[I>>2]=H;ca=aa;aa=$;$=(_+1.5707963267948966)*180.0/3.141592653589793;if($<0.0){_=$;while(1){ba=_+360.0;if(ba<0.0)_=ba;else{da=ba;break}}}else da=$;if(!(da>=360.0))ea=da;else{$=da;while(1){da=$+-360.0;if(!(da>=360.0)){ea=da;break}else $=da}}n[a>>2]=+(k|0)+ +(G|0)*.5;n[a+4>>2]=+(g|0)+ +(H|0)*.5;n[a+8>>2]=aa;n[a+12>>2]=ca;n[a+16>>2]=!(ea>=180.0)?ea:ea+-180.0}GQ(i);i=h+36|0;a=f[i>>2]|0;if(a|0?(H=a+12|0,a=f[H>>2]|0,f[H>>2]=a+-1,(a|0)==1):0)_S(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[l>>2]|0)>0){i=f[o>>2]|0;o=0;do{f[i+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)==(q|0)){u=e;return}g0(l);u=e;return}function gDa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77148;uT(a+184|0);b=a+72|0;c=a+108|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+88|0;b=a+76|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+112>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+116>>2]|0;if((b|0)!=(a+120|0))g0(b);b=a+16|0;d=a+52|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+32|0;b=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+56>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+60>>2]|0;if((b|0)==(a+64|0)){j0(a);return}g0(b);j0(a);return}function hDa(a){a=a|0;gDa(a);YDc(a);return}function iDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;s0(a,c);f[e>>2]=0;f[e+4>>2]=0;g=tT(e,4)|0;b[g>>0]=110;b[g+1>>0]=97;b[g+2>>0]=109;b[g+3>>0]=101;g=E_(c,e)|0;uT(e);i=E_(g,a+184|0)|0;f[e>>2]=0;f[e+4>>2]=0;g=tT(e,7)|0;b[g>>0]=b[372587]|0;b[g+1>>0]=b[372588]|0;b[g+2>>0]=b[372589]|0;b[g+3>>0]=b[372590]|0;b[g+4>>0]=b[372591]|0;b[g+5>>0]=b[372592]|0;b[g+6>>0]=b[372593]|0;g=E_(i,e)|0;uT(e);i=a+132|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(g,c+12|0,f[i>>2]|0);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,9)|0;l=372595;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=E_(g,e)|0;uT(e);g=a+136|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,f[g>>2]|0);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,15)|0;l=372605;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=E_(j,e)|0;uT(e);j=a+152|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}Q_(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,12)|0;l=372621;m=k+12|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));g=E_(i,e)|0;uT(e);i=a+144|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}R_(g,c+12|0,+p[i>>3]);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,15)|0;l=372634;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=E_(g,e)|0;uT(e);g=a+156|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}Q_(j,c+12|0,+n[g>>2]);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;i=tT(e,7)|0;b[i>>0]=b[372650]|0;b[i+1>>0]=b[372651]|0;b[i+2>>0]=b[372652]|0;b[i+3>>0]=b[372653]|0;b[i+4>>0]=b[372654]|0;b[i+5>>0]=b[372655]|0;b[i+6>>0]=b[372656]|0;i=E_(j,e)|0;uT(e);j=a+160|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}Q_(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=tT(e,6)|0;b[g>>0]=b[372658]|0;b[g+1>>0]=b[372659]|0;b[g+2>>0]=b[372660]|0;b[g+3>>0]=b[372661]|0;b[g+4>>0]=b[372662]|0;b[g+5>>0]=b[372663]|0;g=E_(i,e)|0;uT(e);i=a+164|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}Q_(g,c+12|0,+n[i>>2]);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;j=tT(e,6)|0;b[j>>0]=b[372665]|0;b[j+1>>0]=b[372666]|0;b[j+2>>0]=b[372667]|0;b[j+3>>0]=b[372668]|0;b[j+4>>0]=b[372669]|0;b[j+5>>0]=b[372670]|0;j=E_(g,e)|0;uT(e);g=a+168|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}Q_(j,c+12|0,+n[g>>2]);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,28)|0;l=372672;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=E_(j,e)|0;uT(e);j=a+172|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}Q_(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,13)|0;l=372701;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));g=E_(i,e)|0;uT(e);i=h[a+176>>0]|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(g,c+12|0,i);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,11)|0;l=372715;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=E_(g,e)|0;uT(e);g=h[a+177>>0]|0;if(_i[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}P_(j,c+12|0,g);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=tT(e,15)|0;l=372727;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=E_(j,e)|0;uT(e);j=a+180|0;if(!(_i[f[(f[c>>2]|0)+12>>2]&1023](i)|0)){u=d;return}a=c+32|0;if((f[a>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,30)|0;l=471427;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-2,e,518366,471458,1188)}Q_(i,c+12|0,+n[j>>2]);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function jDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+112|0;e=d;g=d+8|0;h=d+104|0;i=d+96|0;j=d+88|0;k=d+80|0;l=d+72|0;m=d+64|0;n=d+56|0;o=d+48|0;q=d+40|0;r=d+32|0;s=d+24|0;t=d+16|0;I_(g,c,372554);f[e>>2]=0;f[e+4>>2]=0;$_(g,e,e);g=f[e>>2]|0;v=f[a+184>>2]|0;if((g|0)!=(v|0)){w=(Ioc((g|0)==0?1154740:g,(v|0)==0?1154740:v)|0)==0;uT(e);if(!w){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,27)|0;v=372559;g=w+27|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(g|0));z5(-215,e,471667,372392,307)}}else uT(e);I_(h,c,372587);Y_(h,e,0);f[a+132>>2]=f[e>>2];I_(i,c,372595);Y_(i,e,0);f[a+136>>2]=f[e>>2];I_(j,c,372605);Z_(j,e,0.0);f[a+152>>2]=f[e>>2];I_(k,c,372621);__(k,e,0.0);p[a+144>>3]=+p[e>>3];I_(l,c,372634);Z_(l,e,0.0);f[a+156>>2]=f[e>>2];I_(m,c,372650);Z_(m,e,0.0);f[a+160>>2]=f[e>>2];I_(n,c,372658);Z_(n,e,0.0);f[a+164>>2]=f[e>>2];I_(o,c,372665);Z_(o,e,0.0);f[a+168>>2]=f[e>>2];I_(q,c,372672);Z_(q,e,0.0);f[a+172>>2]=f[e>>2];I_(r,c,372701);Y_(r,e,0);b[a+176>>0]=(f[e>>2]|0)!=0&1;I_(s,c,372715);Y_(s,e,0);s=f[e>>2]|0;b[a+177>>0]=s>>>0<256?s:(s|0)>0?255:0;I_(t,c,372727);Z_(t,e,0.0);f[a+180>>2]=f[e>>2];u=d;return}function kDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0;g=u;u=u+208|0;h=g+152|0;i=g+144|0;j=g+80|0;k=g+88|0;l=g+72|0;m=g;o=a+128|0;do if(!(e>=1.0|(f[o>>2]|0)==0)){b$(h,c,-1);if(!((f[h>>2]|0)!=(f[a+4>>2]|0)?1:(f[h+4>>2]|0)!=(f[a+8>>2]|0))?(q=c$(c,-1)|0,(q|0)==(f[a+12>>2]|0)):0)break;else{r=5;break}}else r=5;while(0);if((r|0)==5){b$(i,c,-1);ODa(a,i,c$(c,-1)|0)}do if((d$(c)|0)==65536){i=f[c+4>>2]|0;f[h>>2]=f[i>>2];r=h+4|0;q=i+4|0;f[r>>2]=f[q>>2];s=h+8|0;f[s>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[h+16>>2]=f[i+16>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];t=f[i+36>>2]|0;f[h+36>>2]=t;v=h+40|0;f[v>>2]=s;s=h+48|0;w=h+44|0;f[w>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[q>>2]|0)<3){q=f[i+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[q>>2];f[s+4>>2]=f[q+4>>2];x=v;break}else{f[r>>2]=0;ZS(h,i);x=v;break}}else{a$(h,c,-1);x=h+40|0}while(0);c=f[x>>2]|0;v=f[c>>2]|0;f[j>>2]=f[c+4>>2];f[j+4>>2]=v;v$(d,j,0,-1,0,0);do if((d$(d)|0)==65536){j=f[d+4>>2]|0;f[k>>2]=f[j>>2];v=k+4|0;c=j+4|0;f[v>>2]=f[c>>2];i=k+8|0;f[i>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];r=f[j+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=i;i=k+48|0;q=k+44|0;f[q>>2]=i;f[i>>2]=0;f[k+52>>2]=0;if(r|0){i=r+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[c>>2]|0)<3){c=f[j+44>>2]|0;i=f[q>>2]|0;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];break}else{f[v>>2]=0;ZS(k,j);break}}else a$(k,d,-1);while(0);d=f[o>>2]|0;j=d+1|0;f[o>>2]=j;if(e>=0.0&(d|0)>0)y=e;else{d=j<<1;j=f[a+132>>2]|0;y=1.0/+(((j|0)<(d|0)?j:d)|0)}if(!(y>=0.0)){f[l>>2]=0;f[l+4>>2]=0;d=tT(l,17)|0;j=372466;o=d+17|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(o|0));z5(-215,l,440714,372392,870)}j=h+8|0;d=f[j>>2]|0;f[l>>2]=0;f[l+4>>2]=d;o=f[a+32>>2]|0;v=f[a+136>>2]|0;c=Y(v<<3,d)|0;d=f[h+12>>2]|0;i=o+(Y(c,d)|0)|0;c=f[a+88>>2]|0;e=+p[a+144>>3];q=f[a+152>>2]|0;r=f[a+156>>2]|0;s=f[a+160>>2]|0;z=+n[a+164>>2];A=+n[a+168>>2];B=-(y*+n[a+172>>2]);w=f[a+180>>2]|0;t=b[a+176>>0]|0;C=b[a+177>>0]|0;f[m>>2]=77292;f[m+4>>2]=h;f[m+8>>2]=k;f[m+12>>2]=o;f[m+16>>2]=i;f[m+20>>2]=c;f[m+24>>2]=v;n[m+28>>2]=y;n[m+32>>2]=e;f[m+36>>2]=q;f[m+40>>2]=r;f[m+44>>2]=s;n[m+48>>2]=z>A?A:z;n[m+52>>2]=z<A?A:z;n[m+56>>2]=B;f[m+60>>2]=w;b[m+64>>0]=t;b[m+65>>0]=C;C=h+4|0;t=f[C>>2]|0;if((t|0)<3)D=Y(d,f[j>>2]|0)|0;else{j=f[x>>2]|0;d=0;w=1;while(1){s=Y(f[j+(d<<2)>>2]|0,w)|0;d=d+1|0;if((d|0)==(t|0)){D=s;break}else w=s}}y8(l,m,+(D>>>0)*.0000152587890625);D=k+36|0;m=f[D>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)_S(k);f[D>>2]=0;D=k+16|0;m=k+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[m>>2]|0)>0){D=f[k+40>>2]|0;l=0;do{f[D+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))g0(m);m=h+36|0;k=f[m>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(h);f[m>>2]=0;m=h+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[C>>2]|0)>0){m=f[x>>2]|0;x=0;do{f[m+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[C>>2]|0))}C=f[h+44>>2]|0;if((C|0)==(h+48|0)){u=g;return}g0(C);u=g;return}function lDa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;switch(f[a+12>>2]|0){case 0:{KDa(a,c);u=d;return}case 16:{LDa(a,c);u=d;return}case 5:{MDa(a,c);u=d;return}case 21:{NDa(a,c);u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;d=tT(e,94)|0;c=372278;a=d+94|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(a|0));z5(-215,e,372373,372392,929)}}}function mDa(a){a=a|0;return f[a+132>>2]|0}function nDa(a,b){a=a|0;b=b|0;f[a+132>>2]=b;return}function oDa(a){a=a|0;return f[a+136>>2]|0}function pDa(a,b){a=a|0;b=b|0;f[a+136>>2]=b;return}function qDa(a){a=a|0;return +(+n[a+152>>2])}function rDa(a,b){a=a|0;b=+b;n[a+152>>2]=b;return}function sDa(a){a=a|0;return +(+p[a+144>>3])}function tDa(a,b){a=a|0;b=+b;p[a+144>>3]=b;return}function uDa(a){a=a|0;return +(+n[a+156>>2])}function vDa(a,b){a=a|0;b=+b;n[a+156>>2]=b;return}function wDa(a){a=a|0;return +(+n[a+160>>2])}function xDa(a,b){a=a|0;b=+b;n[a+160>>2]=b;return}function yDa(a){a=a|0;return +(+n[a+164>>2])}function zDa(a,b){a=a|0;b=+b;n[a+164>>2]=b;return}function ADa(a){a=a|0;return +(+n[a+168>>2])}function BDa(a,b){a=a|0;b=+b;n[a+168>>2]=b;return}function CDa(a){a=a|0;return +(+n[a+172>>2])}function DDa(a,b){a=a|0;b=+b;n[a+172>>2]=b;return}function EDa(a){a=a|0;return (b[a+176>>0]|0)!=0|0}function FDa(a,c){a=a|0;c=c|0;var d=0;d=a+176|0;if((h[d>>0]|0|0)==(c&1|0))return;b[d>>0]=c&1;return}function GDa(a){a=a|0;return h[a+177>>0]|0|0}function HDa(a,c){a=a|0;c=c|0;b[a+177>>0]=c;return}function IDa(a){a=a|0;return +(+n[a+180>>2])}function JDa(a,b){a=a|0;b=+b;n[a+180>>2]=b;return}function KDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,M=0,N=0,O=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;m=f[a+12>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=l;f[e+4>>2]=j;XS(g,2,e,m&4095);k_(g,h)|0;h=f[a+32>>2]|0;m=Y(f[k>>2]|0,f[i>>2]|0)|0;i=a+136|0;k=h+((Y(m,f[i>>2]|0)|0)<<3)|0;m=f[p>>2]|0;if((m|0)>0){e=g+12|0;j=a+88|0;l=a+116|0;t=g+16|0;v=a+152|0;a=0;w=0;x=f[e>>2]|0;y=m;while(1){if((x|0)>0){m=0;z=a;do{A=(f[j>>2]|0)+(Y(f[f[l>>2]>>2]|0,w)|0)+m|0;B=b[A>>0]|0;A=(B&255)+z|0;if(!(B<<24>>24)){C=0.0;D=0.0}else{E=+n[v>>2];B=z;F=0.0;G=0.0;while(1){H=+n[h+(B<<3)>>2];I=G+H*+n[k+(B<<2)>>2];J=F+H;B=B+1|0;if(!(!(J>E)&(B|0)<(A|0))){C=J;D=I;break}else{F=J;G=I}}}A=+L(+C)>1.1920928955078125e-07;B=mrc(D*(A?1.0/C:0.0))|0;A=(f[t>>2]|0)+(Y(f[f[s>>2]>>2]|0,w)|0)+m|0;b[A>>0]=B>>>0<256?B:(B|0)>0?255:0;z=(f[i>>2]|0)+z|0;m=m+1|0;K=f[e>>2]|0}while((m|0)<(K|0));M=z;N=f[p>>2]|0;O=K}else{M=a;N=y;O=x}w=w+1|0;if((w|0)>=(N|0))break;else{a=M;x=O;y=N}}}h_(g,c);c=g+36|0;N=f[c>>2]|0;if(N|0?(y=N+12|0,N=f[y>>2]|0,f[y>>2]=N+-1,(N|0)==1):0)_S(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)==(r|0)){u=d;return}g0(o);u=d;return}function LDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;m=f[a+12>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=l;f[e+4>>2]=j;XS(g,2,e,m&4095);k_(g,h)|0;h=f[a+32>>2]|0;m=Y(f[k>>2]|0,f[i>>2]|0)|0;i=a+136|0;k=h+((Y(m,f[i>>2]|0)|0)<<3)|0;m=f[p>>2]|0;if((m|0)>0){e=g+12|0;j=a+88|0;l=a+116|0;t=g+16|0;v=a+152|0;a=0;w=0;x=m;m=f[e>>2]|0;while(1){if((m|0)>0){y=0;z=a;do{A=(f[j>>2]|0)+(Y(f[f[l>>2]>>2]|0,w)|0)+y|0;B=b[A>>0]|0;A=(B&255)+z|0;if(!(B<<24>>24)){C=0.0;D=0.0;E=0.0;F=0.0}else{G=+n[v>>2];B=z;H=0.0;I=0.0;J=0.0;K=0.0;while(1){M=+n[h+(B<<3)>>2];N=B*3|0;O=I+M*+n[k+(N<<2)>>2];P=J+M*+n[k+(N+1<<2)>>2];Q=K+M*+n[k+(N+2<<2)>>2];R=H+M;B=B+1|0;if(!(!(R>G)&(B|0)<(A|0))){C=R;D=O;E=P;F=Q;break}else{H=R;I=O;J=P;K=Q}}}A=+L(+C)>1.1920928955078125e-07;K=A?1.0/C:0.0;A=mrc(D*K)|0;B=mrc(E*K)|0;N=mrc(K*F)|0;S=(f[t>>2]|0)+(Y(f[f[s>>2]>>2]|0,w)|0)|0;b[S+(y*3|0)>>0]=A>>>0<256?A:(A|0)>0?255:0;b[S+(y*3|0)+1>>0]=B>>>0<256?B:(B|0)>0?255:0;b[S+(y*3|0)+2>>0]=N>>>0<256?N:(N|0)>0?255:0;z=(f[i>>2]|0)+z|0;y=y+1|0;T=f[e>>2]|0}while((y|0)<(T|0));U=z;V=T;W=f[p>>2]|0}else{U=a;V=m;W=x}w=w+1|0;if((w|0)>=(W|0))break;else{a=U;x=W;m=V}}}h_(g,c);c=g+36|0;V=f[c>>2]|0;if(V|0?(m=V+12|0,V=f[m>>2]|0,f[m>>2]=V+-1,(V|0)==1):0)_S(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)==(r|0)){u=d;return}g0(o);u=d;return}function MDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,M=0,N=0,O=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;m=f[a+12>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=l;f[e+4>>2]=j;XS(g,2,e,m&4095);k_(g,h)|0;h=f[a+32>>2]|0;m=Y(f[k>>2]|0,f[i>>2]|0)|0;i=a+136|0;k=h+((Y(m,f[i>>2]|0)|0)<<3)|0;m=f[p>>2]|0;if((m|0)>0){e=g+12|0;j=a+88|0;l=a+116|0;t=g+16|0;v=a+152|0;a=0;w=0;x=f[e>>2]|0;y=m;while(1){if((x|0)>0){m=0;z=a;do{A=(f[j>>2]|0)+(Y(f[f[l>>2]>>2]|0,w)|0)+m|0;B=b[A>>0]|0;A=(B&255)+z|0;if(!(B<<24>>24)){C=0.0;D=0.0}else{E=+n[v>>2];B=z;F=0.0;G=0.0;while(1){H=+n[h+(B<<3)>>2];I=G+H*+n[k+(B<<2)>>2];J=F+H;B=B+1|0;if(!(!(J>E)&(B|0)<(A|0))){C=J;D=I;break}else{F=J;G=I}}}A=+L(+C)>1.1920928955078125e-07;B=(f[t>>2]|0)+(Y(f[f[s>>2]>>2]|0,w)|0)+(m<<2)|0;n[B>>2]=D*(A?1.0/C:0.0);z=(f[i>>2]|0)+z|0;m=m+1|0;K=f[e>>2]|0}while((m|0)<(K|0));M=z;N=f[p>>2]|0;O=K}else{M=a;N=y;O=x}w=w+1|0;if((w|0)>=(N|0))break;else{a=M;x=O;y=N}}}h_(g,c);c=g+36|0;N=f[c>>2]|0;if(N|0?(y=N+12|0,N=f[y>>2]|0,f[y>>2]=N+-1,(N|0)==1):0)_S(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)==(r|0)){u=d;return}g0(o);u=d;return}function NDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;m=f[a+12>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=l;f[e+4>>2]=j;XS(g,2,e,m&4095);k_(g,h)|0;h=f[a+32>>2]|0;m=Y(f[k>>2]|0,f[i>>2]|0)|0;i=a+136|0;k=h+((Y(m,f[i>>2]|0)|0)<<3)|0;m=f[p>>2]|0;if((m|0)>0){e=g+12|0;j=a+88|0;l=a+116|0;t=g+16|0;v=a+152|0;a=0;w=0;x=m;m=f[e>>2]|0;while(1){if((m|0)>0){y=0;z=a;do{A=(f[j>>2]|0)+(Y(f[f[l>>2]>>2]|0,w)|0)+y|0;B=b[A>>0]|0;A=(B&255)+z|0;if(!(B<<24>>24)){C=0.0;D=0.0;E=0.0;F=0.0}else{G=+n[v>>2];B=z;H=0.0;I=0.0;J=0.0;K=0.0;while(1){M=+n[h+(B<<3)>>2];N=B*3|0;O=I+M*+n[k+(N<<2)>>2];P=J+M*+n[k+(N+1<<2)>>2];Q=K+M*+n[k+(N+2<<2)>>2];R=H+M;B=B+1|0;if(!(!(R>G)&(B|0)<(A|0))){C=R;D=O;E=P;F=Q;break}else{H=R;I=O;J=P;K=Q}}}A=+L(+C)>1.1920928955078125e-07;K=A?1.0/C:0.0;A=(f[t>>2]|0)+(Y(f[f[s>>2]>>2]|0,w)|0)|0;n[A+(y*12|0)>>2]=D*K;n[A+(y*12|0)+4>>2]=E*K;n[A+(y*12|0)+8>>2]=K*F;z=(f[i>>2]|0)+z|0;y=y+1|0;S=f[e>>2]|0}while((y|0)<(S|0));T=z;U=S;V=f[p>>2]|0}else{T=a;U=m;V=x}w=w+1|0;if((w|0)>=(V|0))break;else{a=T;x=V;m=U}}}h_(g,c);c=g+36|0;U=f[c>>2]|0;if(U|0?(m=U+12|0,U=f[m>>2]|0,f[m>>2]=U+-1,(U|0)==1):0)_S(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)==(r|0)){u=d;return}g0(o);u=d;return}function ODa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+32|0;g=e;h=f[c>>2]|0;i=a+4|0;f[i>>2]=h;j=f[c+4>>2]|0;c=a+8|0;f[c>>2]=j;f[a+12>>2]=d;f[a+128>>2]=0;k=d>>>3&511;if((k+1|0)>>>0>=513){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,22)|0;m=372503;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,372526,372392,192)}d=f[a+136>>2]|0;if((d|0)>=256){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,16)|0;m=372537;n=l+16|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,372526,372392,193)}m=a+16|0;l=Y(Y(Y(d,k+3|0)|0,j)|0,h)|0;if(((((f[a+20>>2]|0)<3?(f[a+24>>2]|0)==1:0)?(f[a+28>>2]|0)==(l|0):0)?(f[m>>2]&4095|0)==5:0)?(f[a+32>>2]|0)!=0:0){o=j;p=h}else{f[g>>2]=1;f[g+4>>2]=l;XS(m,2,g,5);o=f[c>>2]|0;p=f[i>>2]|0}i=a+72|0;if(((((f[a+76>>2]|0)<3?(f[a+80>>2]|0)==(o|0):0)?(f[a+84>>2]|0)==(p|0):0)?(f[i>>2]&4095|0)==0:0)?f[a+88>>2]|0:0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;k_(i,g)|0;u=e;return}f[g>>2]=o;f[g+4>>2]=p;XS(i,2,g,0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;k_(i,g)|0;u=e;return}function PDa(a){a=a|0;YDc(a);return}function QDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0.0,Qa=0.0,Ra=0,Sa=0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0,gb=0,hb=0;d=u;u=u+3248|0;e=d+3224|0;g=d+3168|0;i=d+2104|0;j=d+56|0;k=d;l=f[c>>2]|0;m=f[c+4>>2]|0;c=a+4|0;o=f[c>>2]|0;p=f[o+12>>2]|0;q=((f[o>>2]|0)>>>3&511)+1|0;r=Y(p,q)|0;s=i+8|0;f[i>>2]=s;t=i+4|0;f[t>>2]=r;if(r>>>0>264){v=XDc(r>>>0>1073741823?-1:r<<2)|0;f[i>>2]=v;w=v}else w=s;v=a+28|0;x=1.0-+n[v>>2];a:do if((l|0)<(m|0)){r=a+16|0;y=a+24|0;z=a+12|0;A=a+20|0;B=a+8|0;C=(p|0)>0;D=a+64|0;E=a+32|0;F=a+36|0;G=a+60|0;H=a+65|0;I=a+44|0;J=a+56|0;K=(q|0)==3;M=j+4|0;N=j+8|0;O=a+40|0;P=a+48|0;Q=a+52|0;R=e+4|0;S=g+4|0;T=(q<<3)+-3|0;U=e+8|0;V=e+4|0;W=g+36|0;X=g+16|0;Z=g+4|0;_=g+40|0;$=g+44|0;aa=g+48|0;ba=k+36|0;ca=k+16|0;da=k+4|0;ea=k+40|0;fa=k+44|0;ga=k+48|0;ha=l;ia=o;ja=w;while(1){if((f[ia>>2]&7|0)!=5){f[e>>2]=ha;f[R>>2]=ha+1;f[g>>2]=-2147483648;f[S>>2]=2147483647;$S(k,ia,e,g);Vj(g,1,p,T,ja,0);ka=U;f[ka>>2]=0;f[ka+4>>2]=0;f[e>>2]=-1040121856;f[V>>2]=g;LZ(k,e,5,1.0,0.0);ka=f[W>>2]|0;if(ka|0?(la=ka+12|0,ka=f[la>>2]|0,f[la>>2]=ka+-1,(ka|0)==1):0)_S(g);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){ka=f[_>>2]|0;la=0;do{f[ka+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Z>>2]|0))}la=f[$>>2]|0;if((la|0)!=(aa|0))g0(la);la=f[ba>>2]|0;if(la|0?(ka=la+12|0,la=f[ka>>2]|0,f[ka>>2]=la+-1,(la|0)==1):0)_S(k);f[ba>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[da>>2]|0)>0){la=f[ea>>2]|0;ka=0;do{f[la+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[da>>2]|0))}ka=f[fa>>2]|0;if((ka|0)==(ga|0))ma=ja;else{g0(ka);ma=ja}}else ma=(f[ia+16>>2]|0)+(Y(f[f[ia+44>>2]>>2]|0,ha)|0)|0;ka=Y(f[y>>2]|0,p)|0;la=(f[A>>2]|0)+(Y(ha,p)|0)|0;na=f[B>>2]|0;oa=(f[na+16>>2]|0)+(Y(f[f[na+44>>2]>>2]|0,ha)|0)|0;if(C){na=(f[z>>2]|0)+((Y(ka,ha)|0)<<3)|0;pa=0;qa=na;na=(f[r>>2]|0)+((Y(Y(ha,q)|0,ka)|0)<<2)|0;ka=ma;while(1){ra=la+pa|0;sa=b[ra>>0]|0;ta=sa&255;if(!(sa<<24>>24)){ua=0.0;va=ta;wa=0;xa=0}else{sa=ka+4|0;ya=ka+8|0;za=0;Aa=na;Ba=0.0;Ca=ta;ta=0;Da=0;Ea=+n[J>>2];while(1){Fa=x*+n[qa+(za<<3)>>2]+Ea;b:do if(!ta){Ga=qa+(za<<3)+4|0;Ha=+n[Ga>>2];if(K){Ia=+n[Aa>>2]-+n[ka>>2];n[j>>2]=Ia;Ja=+n[Aa+4>>2]-+n[sa>>2];n[M>>2]=Ja;Ka=+n[Aa+8>>2]-+n[ya>>2];n[N>>2]=Ka;La=Ka*Ka+(Ia*Ia+Ja*Ja)}else{Ma=0;Ja=0.0;while(1){Ia=+n[Aa+(Ma<<2)>>2]-+n[ka+(Ma<<2)>>2];n[j+(Ma<<2)>>2]=Ia;Ka=Ja+Ia*Ia;Ma=Ma+1|0;if((Ma|0)==(q|0)){La=Ka;break}else Ja=Ka}}if(Ba<+n[F>>2]?La<Ha*+n[E>>2]:0)Na=1;else Na=Da;if(La<Ha*+n[O>>2]){Ja=+n[v>>2];Ka=Fa+Ja;Ia=Ja/Ka;Ma=0;do{Oa=Aa+(Ma<<2)|0;n[Oa>>2]=+n[Oa>>2]-Ia*+n[j+(Ma<<2)>>2];Ma=Ma+1|0}while((Ma|0)!=(q|0));Ja=Ha+(La-Ha)*Ia;Pa=+n[P>>2];Qa=Ja<Pa?Pa:Ja;Ja=+n[Q>>2];n[Ga>>2]=Qa>Ja?Ja:Qa;if((za|0)>0){Ma=za;Oa=0;while(1){Ra=Ma;Ma=Ma+-1|0;Sa=qa+(Ma<<3)|0;if(Ka<+n[Sa>>2]){Ta=Ka;Ua=Oa;Va=1;Wa=Na;break b}Xa=qa+(Ra<<3)|0;Ya=Xa;Za=f[Ya>>2]|0;_a=f[Ya+4>>2]|0;Ya=Sa;$a=f[Ya+4>>2]|0;ab=Xa;f[ab>>2]=f[Ya>>2];f[ab+4>>2]=$a;$a=Sa;f[$a>>2]=Za;f[$a+4>>2]=_a;_a=Y(Ra,q)|0;$a=Y(Ma,q)|0;Za=0;do{Sa=na+(Za+_a<<2)|0;ab=na+(Za+$a<<2)|0;Ya=f[Sa>>2]|0;f[Sa>>2]=f[ab>>2];f[ab>>2]=Ya;Za=Za+1|0}while((Za|0)!=(q|0));Za=Oa+1|0;if((Ra|0)<=1){Ta=Ka;Ua=Za;Va=1;Wa=Na;break}else Oa=Za}}else{Ta=Ka;Ua=0;Va=1;Wa=Na}}else{Ta=Fa;Ua=0;Va=0;Wa=Na}}else{Ta=Fa;Ua=0;Va=1;Wa=Da}while(0);Ea=+n[J>>2];Oa=Ta<-Ea;Ma=(Oa<<31>>31)+Ca|0;Fa=Oa?0.0:Ta;n[qa+(za-Ua<<3)>>2]=Fa;Ia=Ba+Fa;za=za+1|0;if((za|0)>=(Ma|0)){ua=Ia;va=Ma;wa=Va;xa=Wa;break}else{Aa=Aa+(q<<2)|0;Ba=Ia;Ca=Ma;ta=Va;Da=Wa}}}Da=+L(+ua)>1.1920928955078125e-07;Ba=Da?1.0/ua:0.0;if((va|0)>0){Da=0;do{ta=qa+(Da<<3)|0;n[ta>>2]=Ba*+n[ta>>2];Da=Da+1|0}while((Da|0)!=(va|0))}c:do if(!wa?(Ba=+n[v>>2],Ba>0.0):0){Da=f[y>>2]|0;ta=(va|0)==(Da|0);Ca=((ta^1)&1)+va|0;Aa=ta?Da+-1|0:va;Da=qa+(Aa<<3)|0;if((Ca|0)!=1){n[Da>>2]=Ba;ta=Ca+-1|0;if((Ca|0)>1){za=0;do{ya=qa+(za<<3)|0;n[ya>>2]=x*+n[ya>>2];za=za+1|0}while((za|0)<(ta|0))}}else n[Da>>2]=1.0;ta=Y(Aa,q)|0;za=0;do{f[na+(za+ta<<2)>>2]=f[ka+(za<<2)>>2];za=za+1|0}while((za|0)!=(q|0));f[qa+(Aa<<3)+4>>2]=f[I>>2];if((Ca|0)>1){za=Ca;while(1){ta=za+-2|0;za=za+-1|0;Da=qa+(ta<<3)|0;if(+n[v>>2]<+n[Da>>2]){bb=Ca;break c}ya=qa+(za<<3)|0;sa=ya;Ma=f[sa>>2]|0;Oa=f[sa+4>>2]|0;sa=Da;Ga=f[sa+4>>2]|0;Za=ya;f[Za>>2]=f[sa>>2];f[Za+4>>2]=Ga;Ga=Da;f[Ga>>2]=Ma;f[Ga+4>>2]=Oa;Oa=Y(za,q)|0;Ga=Y(ta,q)|0;ta=0;do{Ma=na+(ta+Oa<<2)|0;Da=na+(ta+Ga<<2)|0;Za=f[Ma>>2]|0;f[Ma>>2]=f[Da>>2];f[Da>>2]=Za;ta=ta+1|0}while((ta|0)!=(q|0));if((za|0)<=1){bb=Ca;break}}}else bb=Ca}else bb=va;while(0);b[ra>>0]=bb;d:do if(!xa)if((b[D>>0]|0)!=0?(Ka=+n[E>>2],Ba=+n[F>>2],Ea=+n[G>>2],(bb|0)>0):0){za=0;Aa=na;Ia=0.0;ta=0;while(1){Fa=+n[qa+(ta<<3)>>2];Ha=+n[qa+(ta<<3)+4>>2];Ga=0;Qa=0.0;Ja=0.0;do{Pa=+n[Aa+(Ga<<2)>>2];Ja=Ja+ +n[ka+(Ga<<2)>>2]*Pa;Qa=Qa+Pa*Pa;Ga=Ga+1|0}while((Ga|0)!=(q|0));if(Qa==0.0){cb=255;break d}if(!(!(Ja<=Qa)|!(Ja>=Ea*Qa))){Pa=Ja/Qa;Ga=0;db=0.0;do{eb=Pa*+n[Aa+(Ga<<2)>>2]-+n[ka+(Ga<<2)>>2];db=db+eb*eb;Ga=Ga+1|0}while((Ga|0)!=(q|0));Ga=db<Pa*(Ka*Ha*Pa);fb=za|Ga;if(Ga)break;else gb=fb}else gb=za;Ia=Ia+Fa;if(Ia>Ba){cb=255;break d}ta=ta+1|0;if((ta|0)>=(bb|0)){cb=255;break d}else{za=gb;Aa=Aa+(q<<2)|0}}if(fb)cb=h[H>>0]|0;else cb=255}else cb=255;else cb=0;while(0);b[oa+pa>>0]=cb;pa=pa+1|0;ra=f[y>>2]|0;na=na+((Y(ra,q)|0)<<2)|0;if((pa|0)==(p|0))break;else{qa=qa+(ra<<3)|0;ka=ka+(q<<2)|0}}}ka=ha+1|0;qa=f[i>>2]|0;if((ka|0)>=(m|0)){hb=qa;break a}ha=ka;ia=f[c>>2]|0;ja=qa}}else hb=w;while(0);if((hb|0)==(s|0)){u=d;return}if(hb|0)ZDc(hb);f[i>>2]=s;f[t>>2]=264;u=d;return}function RDa(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;e=VDc(192)|0;SDa(e,b,c,d);d=VDc(16)|0;b=d+4|0;f[b>>2]=1;f[d>>2]=77312;f[d+8>>2]=e;f[a>>2]=d;f[a+4>>2]=e;f[b>>2]=(f[b>>2]|0)+1;e=f[b>>2]|0;f[b>>2]=e+-1;if((e|0)!=1)return;Yi[f[(f[d>>2]|0)+8>>2]&2047](d);return}function SDa(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=e&1;r0(a);f[a>>2]=77148;e=a+4|0;h=a+8|0;f[a+16>>2]=1124007936;i=a+24|0;j=a+56|0;k=a+20|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+64|0;f[a+60>>2]=i;f[i>>2]=0;f[a+68>>2]=0;f[a+72>>2]=1124007936;i=a+80|0;j=a+112|0;k=a+76|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+120|0;f[a+116>>2]=i;f[i>>2]=0;f[a+124>>2]=0;i=a+184|0;f[i>>2]=0;f[a+188>>2]=0;f[e>>2]=0;f[h>>2]=0;f[a+12>>2]=0;f[a+128>>2]=0;f[a+132>>2]=(c|0)>0?c:500;p[a+144>>3]=d>0.0?d:16.0;b[a+176>>0]=g;f[a+136>>2]=5;n[a+152>>2]=.8999999761581421;n[a+160>>2]=15.0;n[a+168>>2]=75.0;n[a+164>>2]=4.0;n[a+156>>2]=9.0;n[a+172>>2]=.05000000074505806;b[a+177>>0]=127;n[a+180>>2]=.5;uT(i);k=tT(i,25)|0;i=372867;l=k+25|0;do{b[k>>0]=b[i>>0]|0;k=k+1|0;i=i+1|0}while((k|0)<(l|0));return}function TDa(a){a=a|0;YDc(a);return}function UDa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function VDa(a){a=a|0;YDc(a);return}function WDa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0.0,Xa=0.0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0.0,db=0.0,eb=0,fb=0.0,gb=0.0,hb=0.0,ib=0,jb=0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0;e=u;u=u+1184|0;g=e+136|0;i=e+80|0;j=e+16|0;k=e+24|0;l=e;m=e+8|0;o=a+32|0;q=f[o>>2]|0;r=+(q+-1|0)*.5;s=a+36|0;t=f[s>>2]|0;v=+(t+-1|0)*.5;w=f[a+4>>2]|0;x=f[a+8>>2]|0;y=f[a+12>>2]|0;z=((f[w>>2]|0)>>>3&511)+1|0;A=z<<1;B=Y(Y(q*3|0,t)|0,z)|0;C=g+8|0;f[g>>2]=C;D=g+4|0;f[D>>2]=B;if(B>>>0>520){E=XDc(B>>>0>2147483647?-1:B<<1)|0;f[g>>2]=E;F=E}else F=C;f[j>>2]=q;f[j+4>>2]=t;CY(i,j,(z<<3)+-5|0,F,0);F=f[o>>2]|0;f[l>>2]=F;j=f[s>>2]|0;f[l+4>>2]=j;CY(k,l,(z<<4)+-5|0,(f[g>>2]|0)+((Y(Y(j,z)|0,F)|0)<<1)|0,0);F=f[c>>2]|0;j=c+4|0;a:do if((F|0)<(f[j>>2]|0)){c=a+16|0;l=a+56|0;t=a+60|0;q=a+64|0;E=a+20|0;B=a+24|0;G=a+28|0;H=y+12|0;I=y+8|0;J=y+48|0;K=w+48|0;N=x+48|0;O=w+16|0;P=y+16|0;Q=i+16|0;R=i+44|0;S=k+16|0;T=k+44|0;U=A|1;V=a+68|0;W=a+44|0;X=x+12|0;Z=x+8|0;_=x+16|0;$=a+48|0;aa=z<<5;ba=F;b:while(1){ca=f[c>>2]|0;da=f[l>>2]|0;ea=1.0/+(1<<da|0);fa=+n[ca+(ba<<3)>>2]*ea;ga=+n[ca+(ba<<3)+4>>2]*ea;if((da|0)==(f[t>>2]|0))if(!(f[q>>2]&4)){ha=fa;ia=ga;ja=f[E>>2]|0}else{ka=ea;la=17}else{ka=2.0;la=17}if((la|0)==17){la=0;ca=f[E>>2]|0;ha=ka*+n[ca+(ba<<3)>>2];ia=ka*+n[ca+(ba<<3)+4>>2];ja=ca}ca=ja+(ba<<3)|0;n[ca>>2]=ha;ma=ja+(ba<<3)+4|0;n[ma>>2]=ia;ea=fa-r;fa=ga-v;na=~~ea;oa=na-(+(na|0)>ea&1)|0;na=~~fa;pa=na-(+(na|0)>fa&1)|0;na=f[o>>2]|0;c:do if((((oa|0)>=(0-na|0)?(oa|0)<(f[H>>2]|0):0)?(qa=f[s>>2]|0,(pa|0)>=(0-qa|0)):0)?(pa|0)<(f[I>>2]|0):0){ga=ea-+(oa|0);ra=fa-+(pa|0);sa=1.0-ga;ta=1.0-ra;ua=mrc(sa*ta*16384.0)|0;va=mrc(ga*ta*16384.0)|0;wa=mrc(ra*sa*16384.0)|0;xa=16384-ua-va-wa|0;ya=((f[J>>2]|0)>>>0)/((1212424721>>>(f[y>>2]<<2&28)&15)>>>0)|0;za=((f[K>>2]|0)>>>0)/((1212424721>>>(f[w>>2]<<2&28)&15)>>>0)|0;Aa=((f[N>>2]|0)>>>0)/((1212424721>>>(f[x>>2]<<2&28)&15)>>>0)|0;if((qa|0)>0){Ba=Y(oa,z)|0;Ca=Y(oa,A)|0;Da=ya+A|0;Ea=ya+1|0;Fa=Da+1|0;Ga=f[O>>2]|0;Ha=f[P>>2]|0;Ia=f[Q>>2]|0;Ja=f[f[R>>2]>>2]|0;Ka=f[S>>2]|0;La=f[f[T>>2]>>2]|0;Ma=Y(na,z)|0;Na=(Ma|0)>0;sa=0.0;ra=0.0;ta=0.0;Oa=0;Pa=qa;while(1){Qa=Oa+pa|0;Ra=Ga+(Y(Qa,za)|0)+Ba|0;Sa=Ia+(Y(Ja,Oa)|0)|0;if(Na){Ta=Ka+(Y(La,Oa)|0)|0;Ua=0;Va=Ha+((Y(Qa,ya)|0)<<1)+(Ca<<1)|0;ga=sa;Wa=ra;Xa=ta;while(1){Qa=Y(h[Ra+Ua>>0]|0,ua)|0;Ya=Y(h[Ra+(Ua+z)>>0]|0,va)|0;Za=Ua+za|0;_a=Y(h[Ra+Za>>0]|0,wa)|0;$a=(Qa+256+Ya+_a+(Y(h[Ra+(Za+z)>>0]|0,xa)|0)|0)>>>9;Za=Y(d[Va>>1]|0,ua)|0;_a=Y(d[Va+(A<<1)>>1]|0,va)|0;Ya=Y(d[Va+(ya<<1)>>1]|0,wa)|0;Qa=Za+8192+_a+Ya+(Y(d[Va+(Da<<1)>>1]|0,xa)|0)>>14;Ya=Y(d[Va+2>>1]|0,ua)|0;_a=Y(d[Va+(U<<1)>>1]|0,va)|0;Za=Y(d[Va+(Ea<<1)>>1]|0,wa)|0;ab=Ya+8192+_a+Za+(Y(d[Va+(Fa<<1)>>1]|0,xa)|0)>>14;d[Sa+(Ua<<1)>>1]=$a;d[Ta>>1]=Qa;d[Ta+2>>1]=ab;ga=ga+ +(Y(Qa,Qa)|0);Wa=Wa+ +(Y(ab,Qa)|0);Xa=Xa+ +(Y(ab,ab)|0);Ua=Ua+1|0;if((Ua|0)>=(Ma|0))break;else{Ta=Ta+4|0;Va=Va+4|0}}bb=ga;cb=Wa;db=Xa;eb=f[s>>2]|0}else{bb=sa;cb=ra;db=ta;eb=Pa}Oa=Oa+1|0;if((Oa|0)>=(eb|0))break;else{sa=bb;ra=cb;ta=db;Pa=eb}}fb=bb;gb=cb;hb=db;ib=eb;jb=f[o>>2]|0}else{fb=0.0;gb=0.0;hb=0.0;ib=qa;jb=na}ta=fb*9.5367431640625e-07;ra=gb*9.5367431640625e-07;sa=hb*9.5367431640625e-07;kb=sa*ta-ra*ra;lb=ta-sa;mb=(sa+ta-+M(+(ra*(ra*4.0)+lb*lb)))/+(Y(ib<<1,jb)|0);Pa=f[G>>2]|0;if(Pa|0?f[q>>2]&8|0:0)n[Pa+(ba<<2)>>2]=mb;if(kb<1.1920928955078125e-07?1:mb<+n[V>>2]){if(da|0)break;Pa=f[B>>2]|0;if(!Pa)break;b[Pa+ba>>0]=0;break}mb=1.0/kb;Pa=f[W>>2]|0;d:do if((Pa|0)>0){Oa=0-jb|0;Ma=0-ib|0;xa=(ib|0)>0;Fa=Y(jb,z)|0;wa=(Fa|0)>0;Ea=0;kb=ha-r;lb=ia-v;nb=0.0;ob=0.0;e:while(1){va=~~kb;ua=va-(+(va|0)>kb&1)|0;va=~~lb;Da=va-(+(va|0)>lb&1)|0;if((ua|0)<(Oa|0))break;if((Da|0)<(Ma|0)?1:(ua|0)>=(f[X>>2]|0))break;if((Da|0)>=(f[Z>>2]|0))break;pb=kb-+(ua|0);qb=lb-+(Da|0);rb=1.0-pb;sb=1.0-qb;va=mrc(rb*sb*16384.0)|0;ya=mrc(pb*sb*16384.0)|0;za=mrc(rb*qb*16384.0)|0;Ca=16384-va-ya-za|0;do if(xa){Ha=f[_>>2]|0;La=Y(ua,z)|0;Ka=f[Q>>2]|0;Na=f[f[R>>2]>>2]|0;Ja=f[S>>2]|0;Ia=f[f[T>>2]>>2]|0;if(wa){tb=0.0;ub=0.0;vb=0}else{wb=0.0;xb=0.0;break}while(1){Ba=Ha+(Y(vb+Da|0,Aa)|0)+La|0;Ga=Ka+(Y(Na,vb)|0)|0;Va=Ja+(Y(Ia,vb)|0)|0;qb=tb;rb=ub;Ta=0;while(1){Ua=Y(h[Ba+Ta>>0]|0,va)|0;Sa=Y(h[Ba+(Ta+z)>>0]|0,ya)|0;Ra=Ta+Aa|0;ab=Y(h[Ba+Ra>>0]|0,za)|0;Qa=Ua+256+Sa+ab+(Y(h[Ba+(Ra+z)>>0]|0,Ca)|0)>>9;Ra=Qa-(d[Ga+(Ta<<1)>>1]|0)|0;rb=rb+ +(Y(Ra,d[Va>>1]|0)|0);qb=qb+ +(Y(Ra,d[Va+2>>1]|0)|0);Ta=Ta+1|0;if((Ta|0)>=(Fa|0))break;else Va=Va+4|0}vb=vb+1|0;if((vb|0)>=(ib|0)){wb=qb;xb=rb;break}else{tb=qb;ub=rb}}}else{wb=0.0;xb=0.0}while(0);sb=xb*9.5367431640625e-07;pb=wb*9.5367431640625e-07;yb=nb;nb=mb*(ra*pb-sa*sb);zb=ob;ob=mb*(ra*sb-ta*pb);kb=kb+nb;lb=lb+ob;Ab=r+kb;Bb=v+lb;n[ca>>2]=Ab;n[ma>>2]=Bb;pb=nb;sb=ob;if(pb*pb+sb*sb<=+p[$>>3])break d;do if((Ea|0)>0){if(!(+L(+(yb+nb))<.01))break;if(+L(+(zb+ob))<.01){la=59;break e}}while(0);Ea=Ea+1|0;if((Ea|0)>=(Pa|0))break d}if((la|0)==59){la=0;n[ca>>2]=Ab-nb*.5;n[ma>>2]=Bb-ob*.5;break}if(!da){Ea=f[B>>2]|0;if(!Ea){la=62;break b}b[Ea+ba>>0]=0}}while(0);Pa=f[B>>2]|0;if(!Pa){la=62;break b}qa=Pa+ba|0;if(((b[qa>>0]|0?(Pa=f[G>>2]|0,Pa|0):0)?(f[l>>2]|0)==0:0)?(f[q>>2]&8|0)==0:0){Ea=f[E>>2]|0;ta=+n[Ea+(ba<<3)>>2]-r;ra=+n[Ea+(ba<<3)+4>>2]-v;Ea=~~ta;Fa=Ea-(+(Ea|0)>ta&1)|0;Ea=~~ra;wa=Ea-(+(Ea|0)>ra&1)|0;Ea=f[o>>2]|0;do if((Fa|0)>=(0-Ea|0)){if((Fa|0)>=(f[X>>2]|0))break;xa=f[s>>2]|0;if((wa|0)<(0-xa|0))break;if((wa|0)>=(f[Z>>2]|0))break;mb=ta-+(Fa|0);sa=ra-+(wa|0);lb=1.0-mb;kb=1.0-sa;Ma=mrc(lb*kb*16384.0)|0;Oa=mrc(mb*kb*16384.0)|0;Ca=mrc(lb*sa*16384.0)|0;za=16384-Ma-Oa-Ca|0;do if((xa|0)>0){ya=f[_>>2]|0;va=Y(Fa,z)|0;Da=f[Q>>2]|0;ua=f[f[R>>2]>>2]|0;Ia=Y(Ea,z)|0;if((Ia|0)>0){Cb=0.0;Db=0}else{Eb=0.0;break}while(1){Ja=ya+(Y(Db+wa|0,Aa)|0)+va|0;Na=Da+(Y(ua,Db)|0)|0;sa=Cb;Ka=0;do{La=Y(h[Ja+Ka>>0]|0,Ma)|0;Ha=Y(h[Ja+(Ka+z)>>0]|0,Oa)|0;Va=Ka+Aa|0;Ta=Y(h[Ja+Va>>0]|0,Ca)|0;Ga=La+256+Ha+Ta+(Y(h[Ja+(Va+z)>>0]|0,za)|0)>>9;sa=sa+ +L(+(+(Ga-(d[Na+(Ka<<1)>>1]|0)|0)));Ka=Ka+1|0}while((Ka|0)<(Ia|0));Db=Db+1|0;if((Db|0)>=(xa|0)){Eb=sa;break}else Cb=sa}}else Eb=0.0;while(0);ob=Eb/+(Y(Y(aa,xa)|0,Ea)|0);n[Pa+(ba<<2)>>2]=ob;break c}while(0);b[qa>>0]=0}}else la=22;while(0);if((la|0)==22?(la=0,(da|0)==0):0){ma=f[B>>2]|0;if(ma|0)b[ma+ba>>0]=0;ma=f[G>>2]|0;if(ma|0)n[ma+(ba<<2)>>2]=0.0}ba=ba+1|0;if((ba|0)>=(f[j>>2]|0))break a}if((la|0)==62){f[m>>2]=0;f[m+4>>2]=0;ba=tT(m,14)|0;G=372893;B=ba+14|0;do{b[ba>>0]=b[G>>0]|0;ba=ba+1|0;G=G+1|0}while((ba|0)<(B|0));z5(-215,m,518189,372908,657)}}while(0);m=k+36|0;la=f[m>>2]|0;if(la|0?(j=la+12|0,la=f[j>>2]|0,f[j>>2]=la+-1,(la|0)==1):0)_S(k);f[m>>2]=0;m=k+16|0;la=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[la>>2]|0)>0){m=f[k+40>>2]|0;j=0;do{f[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[la>>2]|0))}la=f[k+44>>2]|0;if((la|0)!=(k+48|0))g0(la);la=i+36|0;k=f[la>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)_S(i);f[la>>2]=0;la=i+16|0;k=i+4|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[k>>2]|0)>0){la=f[i+40>>2]|0;j=0;do{f[la+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))g0(k);k=f[g>>2]|0;if((k|0)==(C|0)){u=e;return}if(k|0)ZDc(k);f[g>>2]=C;f[D>>2]=520;u=e;return}function XDa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;k=u;u=u+368|0;l=k+304|0;m=k+248|0;n=k+192|0;o=k+64|0;p=k+136|0;q=k+120|0;r=k+32|0;s=k;do if((d$(a)|0)==65536){t=f[a+4>>2]|0;f[m>>2]=f[t>>2];v=m+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[t+8>>2];f[m+12>>2]=f[t+12>>2];f[m+16>>2]=f[t+16>>2];f[m+20>>2]=f[t+20>>2];f[m+24>>2]=f[t+24>>2];f[m+28>>2]=f[t+28>>2];f[m+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=x;x=m+48|0;z=m+44|0;f[z>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];A=m;break}else{f[v>>2]=0;ZS(m,t);A=m;break}}else{a$(m,a,-1);A=m}while(0);if(f[A>>2]&7|0){f[l>>2]=0;B=l+4|0;f[B>>2]=0;C=tT(l,63)|0;D=C;E=373008;F=D+63|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,l,373072,372908,706)}if((f[d>>2]|0)<=2){f[l>>2]=0;B=l+4|0;f[B>>2]=0;C=tT(l,63)|0;D=C;E=373008;F=D+63|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,l,373072,372908,706)}a=d+4|0;if((f[a>>2]|0)<=2){f[l>>2]=0;B=l+4|0;f[B>>2]=0;C=tT(l,63)|0;D=C;E=373008;F=D+63|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,l,373072,372908,706)}E=g?2:1;Y$(c,1,Y(E,e+1|0)|0,0,-1,1,0);D=f[A>>2]|0;F=D<<1&8176|11;do if(j?(h&16|0)==0&(D&32768|0)!=0:0){f[l>>2]=0;C=l+4|0;f[C>>2]=0;f[n>>2]=0;B=n+4|0;f[B>>2]=0;jT(m,l,n);t=f[n>>2]|0;v=f[d>>2]|0;if((t|0)<(v|0)){G=38;break}w=f[B>>2]|0;B=f[a>>2]|0;if((w|0)<(B|0)){G=38;break}x=m+12|0;if((v+t+(f[x>>2]|0)|0)>(f[l>>2]|0)){G=38;break}t=m+8|0;if((B+w+(f[t>>2]|0)|0)>(f[C>>2]|0)){G=38;break}C=V$(c,0)|0;if((C|0)!=(m|0)){w=m+36|0;B=f[w>>2]|0;if(B|0){v=B+12|0;f[v>>2]=(f[v>>2]|0)+1}v=C+36|0;B=f[v>>2]|0;if(B|0?(z=B+12|0,B=f[z>>2]|0,f[z>>2]=B+-1,(B|0)==1):0)_S(C);f[v>>2]=0;B=C+16|0;z=C+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[z>>2]|0)>0){y=f[C+40>>2]|0;H=0;do{f[y+(H<<2)>>2]=0;H=H+1|0;I=f[z>>2]|0}while((H|0)<(I|0));f[C>>2]=f[A>>2];if((I|0)<3)G=29;else G=31}else{f[C>>2]=f[A>>2];G=29}if((G|0)==29){H=f[m+4>>2]|0;if((H|0)<3){f[z>>2]=H;f[C+8>>2]=f[t>>2];f[C+12>>2]=f[x>>2];H=f[m+44>>2]|0;y=f[C+44>>2]|0;f[y>>2]=f[H>>2];f[y+4>>2]=f[H+4>>2]}else G=31}if((G|0)==31)ZS(C,m);f[B>>2]=f[m+16>>2];f[C+20>>2]=f[m+20>>2];f[C+24>>2]=f[m+24>>2];f[C+28>>2]=f[m+28>>2];f[C+32>>2]=f[m+32>>2];f[v>>2]=f[w>>2]}}else G=38;while(0);if((G|0)==38){I=V$(c,0)|0;D=I+16|0;if(f[D>>2]|0){j=f[I+4>>2]|0;if((j|0)<3)J=Y(f[I+12>>2]|0,f[I+8>>2]|0)|0;else{H=f[I+40>>2]|0;y=0;K=1;while(1){L=Y(f[H+(y<<2)>>2]|0,K)|0;y=y+1|0;if((y|0)==(j|0)){J=L;break}else K=L}}if(!((j|0)==0|(J|0)==0)){J=f[a>>2]|0;j=f[d>>2]|0;kT(I,J,J,j,j)|0}}j=f[I>>2]|0;J=f[A>>2]|0;K=m+12|0;y=f[K>>2]|0;if(!((J^j)&4095)){H=f[d>>2]|0;if(!((f[I+12>>2]|0)==((H<<1)+y|0)?(f[I+8>>2]|0)==((f[a>>2]<<1)+(f[m+8>>2]|0)|0):0)){M=H;G=49}}else{M=f[d>>2]|0;G=49}do if((G|0)==49){H=(f[a>>2]<<1)+(f[m+8>>2]|0)|0;L=(M<<1)+y|0;N=J&4095;if((((f[I+4>>2]|0)<3?(f[I+8>>2]|0)==(H|0):0)?(f[I+12>>2]|0)==(L|0):0)?!((j&4095|0)!=(N|0)|(f[D>>2]|0)==0):0)break;f[l>>2]=H;f[l+4>>2]=L;XS(I,2,l,N)}while(0);if((h|0)==5){D=f[a>>2]|0;j=f[K>>2]|0;K=f[m+8>>2]|0;f[o>>2]=f[d>>2];f[o+4>>2]=D;f[o+8>>2]=j;f[o+12>>2]=K;cT(n,I,o);K=l+8|0;f[K>>2]=0;f[K+4>>2]=0;f[l>>2]=-1040121856;f[l+4>>2]=n;h_(m,l);K=n+36|0;j=f[K>>2]|0;if(j|0?(D=j+12|0,j=f[D>>2]|0,f[D>>2]=j+-1,(j|0)==1):0)_S(n);f[K>>2]=0;K=n+16|0;j=n+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[j>>2]|0)>0){K=f[n+40>>2]|0;D=0;do{f[K+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[j>>2]|0))}j=f[n+44>>2]|0;if((j|0)!=(n+48|0))g0(j)}else{f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=m;j=n+8|0;f[j>>2]=0;f[j+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=I;j=f[a>>2]|0;D=f[d>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;q_(l,n,j,j,D,D,h,o)}D=0-(f[a>>2]|0)|0;j=0-(f[d>>2]|0)|0;kT(I,D,D,j,j)|0}j=m+40|0;D=f[j>>2]|0;I=f[D>>2]|0;f[n>>2]=f[D+4>>2];D=n+4|0;f[D>>2]=I;I=V$(c,0)|0;f[o>>2]=f[I>>2];K=o+4|0;J=I+4|0;f[K>>2]=f[J>>2];y=o+8|0;f[y>>2]=f[I+8>>2];M=o+12|0;f[M>>2]=f[I+12>>2];N=o+16|0;f[N>>2]=f[I+16>>2];L=o+20|0;f[L>>2]=f[I+20>>2];H=o+24|0;f[H>>2]=f[I+24>>2];O=o+28|0;f[O>>2]=f[I+28>>2];P=o+32|0;f[P>>2]=f[I+32>>2];Q=o+36|0;R=f[I+36>>2]|0;f[Q>>2]=R;S=o+40|0;f[S>>2]=y;T=o+48|0;U=o+44|0;f[U>>2]=T;f[T>>2]=0;f[o+52>>2]=0;if(R|0){V=R+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[J>>2]|0)<3){J=f[I+44>>2]|0;V=f[U>>2]|0;f[V>>2]=f[J>>2];f[V+4>>2]=f[J+4>>2]}else{f[K>>2]=0;ZS(o,I)}f[p>>2]=f[o>>2];I=p+4|0;J=f[K>>2]|0;f[I>>2]=J;V=p+8|0;f[V>>2]=f[y>>2];R=p+12|0;f[R>>2]=f[M>>2];W=p+16|0;f[W>>2]=f[N>>2];X=p+20|0;f[X>>2]=f[L>>2];Z=p+24|0;f[Z>>2]=f[H>>2];_=p+28|0;f[_>>2]=f[O>>2];$=p+32|0;f[$>>2]=f[P>>2];aa=p+36|0;ba=f[Q>>2]|0;f[aa>>2]=ba;ca=p+40|0;f[ca>>2]=V;da=p+48|0;ea=p+44|0;f[ea>>2]=da;f[da>>2]=0;f[p+52>>2]=0;if(!ba)fa=J;else{J=ba+12|0;f[J>>2]=(f[J>>2]|0)+1;fa=f[K>>2]|0}if((fa|0)<3){fa=f[U>>2]|0;J=f[ea>>2]|0;f[J>>2]=f[fa>>2];f[J+4>>2]=f[fa+4>>2]}else{f[I>>2]=0;ZS(p,o)}a:do if((e|0)<0)ga=e;else{fa=q+4|0;J=q+8|0;ba=q+12|0;ha=(i|0)==5;ia=l+36|0;ja=l+16|0;ka=l+4|0;la=l+40|0;ma=l+44|0;na=l+48|0;oa=q+8|0;pa=q+12|0;qa=q+4|0;ra=r+8|0;sa=r+4|0;ta=i|16;ua=F&4091;va=l+4|0;wa=q+4|0;xa=q+8|0;ya=q+12|0;za=l+36|0;Aa=l+4|0;Ba=l+8|0;Ca=l+12|0;Da=l+44|0;Ea=l+16|0;Fa=l+20|0;Ga=l+24|0;Ha=l+28|0;Ia=l+32|0;Ja=l+40|0;Ka=l+48|0;La=l+8|0;Ma=l+12|0;Na=l+4|0;Oa=q+8|0;Pa=q+4|0;Qa=(h|0)==5;Ra=l+8|0;Sa=l+12|0;Ta=l+4|0;Ua=q+8|0;Va=q+4|0;Wa=h|16;Xa=0;while(1){if(Xa|0){Ya=V$(c,Y(Xa,E)|0)|0;Za=Ya+16|0;if(f[Za>>2]|0){_a=f[Ya+4>>2]|0;if((_a|0)<3)$a=Y(f[Ya+12>>2]|0,f[Ya+8>>2]|0)|0;else{ab=f[Ya+40>>2]|0;bb=0;cb=1;while(1){db=Y(f[ab+(bb<<2)>>2]|0,cb)|0;bb=bb+1|0;if((bb|0)==(_a|0)){$a=db;break}else cb=db}}if(!((_a|0)==0|($a|0)==0)){cb=f[a>>2]|0;bb=f[d>>2]|0;kT(Ya,cb,cb,bb,bb)|0}}bb=f[Ya>>2]|0;cb=f[A>>2]|0;ab=f[n>>2]|0;if(!((cb^bb)&4095)){db=f[d>>2]|0;if((f[Ya+12>>2]|0)==((db<<1)+ab|0)?(eb=f[a>>2]|0,fb=f[D>>2]|0,(f[Ya+8>>2]|0)==((eb<<1)+fb|0)):0){gb=db;hb=eb;ib=ab;jb=fb}else{kb=db;G=90}}else{kb=f[d>>2]|0;G=90}b:do if((G|0)==90){G=0;db=f[D>>2]|0;fb=f[a>>2]|0;eb=(fb<<1)+db|0;lb=(kb<<1)+ab|0;mb=cb&4095;do if((f[Ya+4>>2]|0)<3?(f[Ya+8>>2]|0)==(eb|0):0){if((f[Ya+12>>2]|0)!=(lb|0))break;if(!((bb&4095|0)!=(mb|0)|(f[Za>>2]|0)==0)){gb=kb;hb=fb;ib=ab;jb=db;break b}}while(0);f[l>>2]=eb;f[va>>2]=lb;XS(Ya,2,l,mb);gb=f[d>>2]|0;hb=f[a>>2]|0;ib=f[n>>2]|0;jb=f[D>>2]|0}while(0);f[q>>2]=gb;f[wa>>2]=hb;f[xa>>2]=ib;f[ya>>2]=jb;cT(l,Ya,q);ab=f[za>>2]|0;if(ab|0){Za=ab+12|0;f[Za>>2]=(f[Za>>2]|0)+1}Za=f[aa>>2]|0;if(Za|0?(ab=Za+12|0,Za=f[ab>>2]|0,f[ab>>2]=Za+-1,(Za|0)==1):0)_S(p);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[I>>2]|0)>0){Za=f[ca>>2]|0;ab=0;do{f[Za+(ab<<2)>>2]=0;ab=ab+1|0;nb=f[I>>2]|0}while((ab|0)<(nb|0));f[p>>2]=f[l>>2];if((nb|0)<3)G=105;else G=107}else{f[p>>2]=f[l>>2];G=105}do if((G|0)==105){G=0;ab=f[Aa>>2]|0;if((ab|0)>=3){G=107;break}f[I>>2]=ab;f[V>>2]=f[Ba>>2];f[R>>2]=f[Ca>>2];ab=f[Da>>2]|0;Za=f[ea>>2]|0;f[Za>>2]=f[ab>>2];f[Za+4>>2]=f[ab+4>>2]}while(0);if((G|0)==107){G=0;ZS(p,l)}f[W>>2]=f[Ea>>2];f[X>>2]=f[Fa>>2];f[Z>>2]=f[Ga>>2];f[_>>2]=f[Ha>>2];f[$>>2]=f[Ia>>2];ab=f[za>>2]|0;f[aa>>2]=ab;do if(ab|0){Za=ab+12|0;bb=f[Za>>2]|0;f[Za>>2]=bb+-1;if((bb|0)!=1)break;_S(l)}while(0);f[za>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[Aa>>2]|0)>0){ab=f[Ja>>2]|0;bb=0;do{f[ab+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[Aa>>2]|0))}bb=f[Da>>2]|0;if((bb|0)!=(Ka|0))g0(bb);f[La>>2]=0;f[Ma>>2]=0;f[l>>2]=16842752;f[Na>>2]=o;bb=Oa;f[bb>>2]=0;f[bb+4>>2]=0;f[q>>2]=33619968;f[Pa>>2]=p;tna(l,q,n,4);if(!Qa){f[Ra>>2]=0;f[Sa>>2]=0;f[l>>2]=16842752;f[Ta>>2]=p;bb=Ua;f[bb>>2]=0;f[bb+4>>2]=0;f[q>>2]=33619968;f[Va>>2]=Ya;bb=f[a>>2]|0;ab=f[d>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;q_(l,q,bb,bb,ab,ab,Wa,r)}ab=0-(f[a>>2]|0)|0;bb=0-(f[d>>2]|0)|0;kT(Ya,ab,ab,bb,bb)|0}if(g){bb=V$(c,(Y(Xa,E)|0)+1|0)|0;ab=bb+16|0;if(f[ab>>2]|0){Za=f[bb+4>>2]|0;if((Za|0)<3)ob=Y(f[bb+12>>2]|0,f[bb+8>>2]|0)|0;else{cb=f[bb+40>>2]|0;_a=0;db=1;while(1){fb=Y(f[cb+(_a<<2)>>2]|0,db)|0;_a=_a+1|0;if((_a|0)==(Za|0)){ob=fb;break}else db=fb}}if(!((Za|0)==0|(ob|0)==0)){db=f[a>>2]|0;_a=f[d>>2]|0;kT(bb,db,db,_a,_a)|0}}_a=f[bb>>2]&4095;db=f[n>>2]|0;if((_a|0)==(F|0)){cb=f[d>>2]|0;if((f[bb+12>>2]|0)==((cb<<1)+db|0)?(Ya=f[a>>2]|0,fb=f[D>>2]|0,(f[bb+8>>2]|0)==((Ya<<1)+fb|0)):0){pb=cb;qb=Ya;rb=db;sb=fb}else{tb=cb;G=131}}else{tb=f[d>>2]|0;G=131}c:do if((G|0)==131){G=0;cb=f[D>>2]|0;fb=f[a>>2]|0;Ya=(fb<<1)+cb|0;ub=(tb<<1)+db|0;do if((f[bb+4>>2]|0)<3){if((f[bb+8>>2]|0)!=(Ya|0))break;if((f[bb+12>>2]|0)!=(ub|0))break;if(!((_a|0)!=(ua|0)|(f[ab>>2]|0)==0)){pb=tb;qb=fb;rb=db;sb=cb;break c}}while(0);f[l>>2]=Ya;f[va>>2]=ub;XS(bb,2,l,ua);pb=f[d>>2]|0;qb=f[a>>2]|0;rb=f[n>>2]|0;sb=f[D>>2]|0}while(0);f[q>>2]=pb;f[fa>>2]=qb;f[J>>2]=rb;f[ba>>2]=sb;cT(l,bb,q);YDa(p,l);if(!ha){f[oa>>2]=0;f[pa>>2]=0;f[q>>2]=16842752;f[qa>>2]=l;db=ra;f[db>>2]=0;f[db+4>>2]=0;f[r>>2]=33619968;f[sa>>2]=bb;db=f[a>>2]|0;ab=f[d>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[s+28>>2]=0;q_(q,r,db,db,ab,ab,ta,s)}ab=0-(f[a>>2]|0)|0;db=0-(f[d>>2]|0)|0;kT(bb,ab,ab,db,db)|0;db=f[ia>>2]|0;do if(db|0){ab=db+12|0;_a=f[ab>>2]|0;f[ab>>2]=_a+-1;if((_a|0)!=1)break;_S(l)}while(0);f[ia>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[ka>>2]|0)>0){db=f[la>>2]|0;bb=0;do{f[db+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[ka>>2]|0))}bb=f[ma>>2]|0;if((bb|0)!=(na|0))g0(bb)}bb=((f[n>>2]|0)+1|0)/2|0;db=((f[D>>2]|0)+1|0)/2|0;f[n>>2]=bb;f[D>>2]=db;if((bb|0)<=(f[d>>2]|0))break;if((db|0)<=(f[a>>2]|0))break;db=f[aa>>2]|0;if(db|0){bb=db+12|0;f[bb>>2]=(f[bb>>2]|0)+1}bb=f[Q>>2]|0;if(bb|0?(db=bb+12|0,bb=f[db>>2]|0,f[db>>2]=bb+-1,(bb|0)==1):0)_S(o);f[Q>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[K>>2]|0)>0){bb=f[S>>2]|0;db=0;do{f[bb+(db<<2)>>2]=0;db=db+1|0;vb=f[K>>2]|0}while((db|0)<(vb|0));f[o>>2]=f[p>>2];if((vb|0)<3)G=160;else G=162}else{f[o>>2]=f[p>>2];G=160}do if((G|0)==160){G=0;db=f[I>>2]|0;if((db|0)>=3){G=162;break}f[K>>2]=db;f[y>>2]=f[V>>2];f[M>>2]=f[R>>2];db=f[ea>>2]|0;bb=f[U>>2]|0;f[bb>>2]=f[db>>2];f[bb+4>>2]=f[db+4>>2]}while(0);if((G|0)==162){G=0;ZS(o,p)}f[N>>2]=f[W>>2];f[L>>2]=f[X>>2];f[H>>2]=f[Z>>2];f[O>>2]=f[_>>2];f[P>>2]=f[$>>2];f[Q>>2]=f[aa>>2];if((Xa|0)<(e|0))Xa=Xa+1|0;else{ga=e;break a}}Y$(c,1,Y(Xa+1|0,E)|0,0,-1,1,0);ga=Xa}while(0);E=f[aa>>2]|0;if(E|0?(c=E+12|0,E=f[c>>2]|0,f[c>>2]=E+-1,(E|0)==1):0)_S(p);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[I>>2]|0)>0){W=f[ca>>2]|0;ca=0;do{f[W+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[I>>2]|0))}I=f[ea>>2]|0;if((I|0)!=(da|0))g0(I);I=f[Q>>2]|0;if(I|0?(da=I+12|0,I=f[da>>2]|0,f[da>>2]=I+-1,(I|0)==1):0)_S(o);f[Q>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[K>>2]|0)>0){N=f[S>>2]|0;S=0;do{f[N+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[K>>2]|0))}K=f[U>>2]|0;if((K|0)!=(T|0))g0(K);K=m+36|0;T=f[K>>2]|0;if(T|0?(U=T+12|0,T=f[U>>2]|0,f[U>>2]=T+-1,(T|0)==1):0)_S(m);f[K>>2]=0;K=m+16|0;T=m+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[T>>2]|0)>0){K=f[j>>2]|0;j=0;do{f[K+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[T>>2]|0))}T=f[m+44>>2]|0;if((T|0)==(m+48|0)){u=k;return ga|0}g0(T);u=k;return ga|0}function YDa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+1056|0;g=e;i=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a>>2]|0;m=(l>>>3&511)+1|0;n=Y(m,k)|0;if(l&7|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,14)|0;o=373096;p=l+14|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));z5(-215,g,373111,372908,60)}o=(m<<4)+4091&4091;if(!(((((f[c+4>>2]|0)<3?(f[c+8>>2]|0)==(i|0):0)?(f[c+12>>2]|0)==(k|0):0)?(f[c>>2]&4095|0)==(o|0):0)?(f[c+16>>2]|0)!=0:0)){f[g>>2]=i;f[g+4>>2]=k;XS(c,2,g,o)}o=(Y(m,k+2|0)|0)+15&-16;l=(o<<1)+64|0;p=g+8|0;f[g>>2]=p;q=g+4|0;f[q>>2]=l;if(l>>>0>520){r=XDc(l>>>0>2147483647?-1:l<<1)|0;f[g>>2]=r;s=r}else s=p;r=s+(m<<1)+15&-16;l=r+(o<<1)|0;if((i|0)>0){o=(i|0)!=1;t=o&1;v=i+-1|0;w=o?i+-2|0:0;o=(n|0)>0;x=(k|0)>1;y=x?m:0;z=Y(m,x?k+-2|0:0)|0;k=f[a+16>>2]|0;x=f[f[a+44>>2]>>2]|0;a=f[c+16>>2]|0;A=f[f[c+44>>2]>>2]|0;c=0;do{B=k+(Y(x,(c|0)>0?c+-1|0:t)|0)|0;C=k+(Y(x,c)|0)|0;D=c;c=c+1|0;E=k+(Y(x,(D|0)<(v|0)?c:w)|0)|0;F=a+(Y(A,D)|0)|0;if(o){D=0;do{G=h[B+D>>0]|0;H=h[E+D>>0]|0;d[r+(D<<1)>>1]=((H+G|0)*3|0)+((h[C+D>>0]|0)*10|0);d[l+(D<<1)>>1]=H-G;D=D+1|0}while((D|0)!=(n|0));I=0}else I=0;do{D=I+y|0;C=I-m|0;d[r+(C<<1)>>1]=d[r+(D<<1)>>1]|0;E=I+z|0;B=I+n|0;d[r+(B<<1)>>1]=d[r+(E<<1)>>1]|0;d[l+(C<<1)>>1]=d[l+(D<<1)>>1]|0;d[l+(B<<1)>>1]=d[l+(E<<1)>>1]|0;I=I+1|0}while((I|0)!=(m|0));if(o){E=0;do{B=E+m|0;D=E-m|0;C=(((d[l+(D<<1)>>1]|0)+(d[l+(B<<1)>>1]|0)|0)*3|0)+((d[l+(E<<1)>>1]|0)*10|0)&65535;G=E<<1;d[F+(G<<1)>>1]=(j[r+(B<<1)>>1]|0)-(j[r+(D<<1)>>1]|0);d[F+((G|1)<<1)>>1]=C;E=E+1|0}while((E|0)!=(n|0))}}while((c|0)!=(i|0))}if((s|0)==(p|0)){u=e;return}ZDc(s);f[g>>2]=p;f[q>>2]=520;u=e;return}function ZDa(a){a=a|0;YDc(a);return}function _Da(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $Da(a){a=a|0;j0(a);YDc(a);return}function aEa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0;j=u;u=u+560|0;k=j+504|0;l=j+448|0;m=j+440|0;o=j+384|0;q=j+328|0;r=j+272|0;s=j+244|0;t=j+232|0;v=j+176|0;w=j+120|0;x=j+264|0;y=j+256|0;z=j+32|0;A=j+104|0;B=j;do if((d$(e)|0)==65536){C=f[e+4>>2]|0;f[l>>2]=f[C>>2];D=l+4|0;E=C+4|0;f[D>>2]=f[E>>2];F=l+8|0;f[F>>2]=f[C+8>>2];f[l+12>>2]=f[C+12>>2];f[l+16>>2]=f[C+16>>2];f[l+20>>2]=f[C+20>>2];f[l+24>>2]=f[C+24>>2];f[l+28>>2]=f[C+28>>2];f[l+32>>2]=f[C+32>>2];G=f[C+36>>2]|0;f[l+36>>2]=G;f[l+40>>2]=F;F=l+48|0;H=l+44|0;f[H>>2]=F;f[F>>2]=0;f[l+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;F=f[H>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[D>>2]=0;ZS(l,C);break}}else a$(l,e,-1);while(0);e=a+12|0;if((f[e>>2]|0)<=-1){f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,56)|0;K=J;L=373226;M=K+56|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1228)}C=a+4|0;if((f[C>>2]|0)<=2){f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,56)|0;K=J;L=373226;M=K+56|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1228)}D=a+8|0;if((f[D>>2]|0)<=2){f[k>>2]=0;I=k+4|0;f[I>>2]=0;J=tT(k,56)|0;K=J;L=373226;M=K+56|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1228)}J=pT(l,2,5,1)|0;if((J|0)<=-1){f[k>>2]=0;f[k+4>>2]=0;K=tT(k,56)|0;L=373283;M=K+56|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1231)}if(J){I=a+32|0;if(!(f[I>>2]&4)){E=f[l+40>>2]|0;F=f[E>>2]|0;f[m>>2]=f[E+4>>2];f[m+4>>2]=F;v$(g,m,f[l>>2]&4095,-1,1,0)}do if((d$(g)|0)==65536){m=f[g+4>>2]|0;f[o>>2]=f[m>>2];F=o+4|0;E=m+4|0;f[F>>2]=f[E>>2];H=o+8|0;f[H>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];f[o+32>>2]=f[m+32>>2];G=f[m+36>>2]|0;f[o+36>>2]=G;f[o+40>>2]=H;H=o+48|0;N=o+44|0;f[N>>2]=H;f[H>>2]=0;f[o+52>>2]=0;if(G|0){H=G+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[E>>2]|0)<3){E=f[m+44>>2]|0;H=f[N>>2]|0;f[H>>2]=f[E>>2];f[H+4>>2]=f[E+4>>2];break}else{f[F>>2]=0;ZS(o,m);break}}else a$(o,g,-1);while(0);if((pT(o,2,5,1)|0)!=(J|0)){f[k>>2]=0;f[k+4>>2]=0;K=tT(k,50)|0;L=373340;M=K+50|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1245)}m=f[l+16>>2]|0;F=o+16|0;E=f[F>>2]|0;H=o+44|0;Y$(h,J,1,0,-1,1,0);do if((d$(h)|0)==65536){N=f[h+4>>2]|0;f[q>>2]=f[N>>2];G=q+4|0;O=N+4|0;f[G>>2]=f[O>>2];P=q+8|0;f[P>>2]=f[N+8>>2];f[q+12>>2]=f[N+12>>2];f[q+16>>2]=f[N+16>>2];f[q+20>>2]=f[N+20>>2];f[q+24>>2]=f[N+24>>2];f[q+28>>2]=f[N+28>>2];f[q+32>>2]=f[N+32>>2];Q=f[N+36>>2]|0;f[q+36>>2]=Q;f[q+40>>2]=P;P=q+48|0;R=q+44|0;f[R>>2]=P;f[P>>2]=0;f[q+52>>2]=0;if(Q|0){P=Q+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[O>>2]|0)<3){O=f[N+44>>2]|0;P=f[R>>2]|0;f[P>>2]=f[O>>2];f[P+4>>2]=f[O+4>>2];S=q;break}else{f[G>>2]=0;ZS(q,N);S=q;break}}else{a$(q,h,-1);S=q}while(0);f[r>>2]=1124007936;N=r+4|0;G=r+8|0;O=r+40|0;K=N;M=K+36|0;do{f[K>>2]=0;K=K+4|0}while((K|0)<(M|0));f[O>>2]=G;P=r+48|0;R=r+44|0;f[R>>2]=P;f[P>>2]=0;f[r+52>>2]=0;if(!(f[S>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;K=tT(k,24)|0;L=373391;M=K+24|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1252)}S=q+16|0;Q=f[S>>2]|0;T=q+44|0;if((J|0)>0)XIc(Q|0,1,J|0)|0;do if($$(i)|0){Y$(i,J,1,5,-1,1,0);do if((d$(i)|0)==65536){U=f[i+4>>2]|0;f[k>>2]=f[U>>2];V=k+4|0;W=U+4|0;f[V>>2]=f[W>>2];X=k+8|0;f[X>>2]=f[U+8>>2];f[k+12>>2]=f[U+12>>2];f[k+16>>2]=f[U+16>>2];f[k+20>>2]=f[U+20>>2];f[k+24>>2]=f[U+24>>2];f[k+28>>2]=f[U+28>>2];f[k+32>>2]=f[U+32>>2];Z=k+36|0;_=f[U+36>>2]|0;f[Z>>2]=_;f[k+40>>2]=X;X=k+48|0;$=k+44|0;f[$>>2]=X;f[X>>2]=0;f[k+52>>2]=0;if(_|0){X=_+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[W>>2]|0)<3){W=f[U+44>>2]|0;X=f[$>>2]|0;f[X>>2]=f[W>>2];f[X+4>>2]=f[W+4>>2];aa=Z;break}else{f[V>>2]=0;ZS(k,U);aa=Z;break}}else{a$(k,i,-1);aa=k+36|0}while(0);Z=f[aa>>2]|0;if(Z|0){U=Z+12|0;f[U>>2]=(f[U>>2]|0)+1}U=r+36|0;Z=f[U>>2]|0;if(Z|0?(V=Z+12|0,Z=f[V>>2]|0,f[V>>2]=Z+-1,(Z|0)==1):0)_S(r);f[U>>2]=0;Z=r+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[N>>2]|0)>0){V=f[O>>2]|0;W=0;do{f[V+(W<<2)>>2]=0;W=W+1|0;ba=f[N>>2]|0}while((W|0)<(ba|0));f[r>>2]=f[k>>2];if((ba|0)<3)ca=56;else ca=58}else{f[r>>2]=f[k>>2];ca=56}do if((ca|0)==56){W=f[k+4>>2]|0;if((W|0)>=3){ca=58;break}f[N>>2]=W;f[G>>2]=f[k+8>>2];f[r+12>>2]=f[k+12>>2];W=f[k+44>>2]|0;V=f[R>>2]|0;f[V>>2]=f[W>>2];f[V+4>>2]=f[W+4>>2]}while(0);if((ca|0)==58)ZS(r,k);W=k+16|0;f[Z>>2]=f[W>>2];f[r+20>>2]=f[k+20>>2];f[r+24>>2]=f[k+24>>2];f[r+28>>2]=f[k+28>>2];f[r+32>>2]=f[k+32>>2];V=f[aa>>2]|0;f[U>>2]=V;do if(V|0){X=V+12|0;$=f[X>>2]|0;f[X>>2]=$+-1;if(($|0)!=1)break;_S(k)}while(0);f[aa>>2]=0;V=k+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[V>>2]|0)>0){U=f[k+40>>2]|0;$=0;do{f[U+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[V>>2]|0))}V=f[k+44>>2]|0;if((V|0)!=(k+48|0))g0(V);if(!(f[r>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;K=tT(k,21)|0;L=373416;M=K+21|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1263)}else{da=f[Z>>2]|0;break}}else da=0;while(0);f[s>>2]=0;aa=s+4|0;f[aa>>2]=0;f[s+8>>2]=0;f[t>>2]=0;G=t+4|0;f[G>>2]=0;f[t+8>>2]=0;if((d$(c)|0)==327680){f$(c,s);ba=f[s>>2]|0;V=(f[aa>>2]|0)-ba|0;aa=((V|0)/56|0)+-1|0;$=ba;if((V|0)<=0){f[k>>2]=0;f[k+4>>2]=0;K=tT(k,12)|0;L=373438;M=K+12|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1278)}if(((aa|0)%2|0|0)==1?(V=f[$+56>>2]|0,(V&7|0)==3?((f[$>>2]|0)>>>2&1022|1|0)==(V>>>3&511|0):0):0){ea=2;fa=(aa|0)/2|0}else{ea=1;fa=aa}do if((fa|0)>0){f[k>>2]=0;aa=k+4|0;f[aa>>2]=0;f[v>>2]=0;V=v+4|0;f[V>>2]=0;jT($+(ea*56|0)|0,k,v);ba=f[v>>2]|0;U=f[C>>2]|0;if((ba|0)<(U|0)){f[w>>2]=0;ga=w+4|0;f[ga>>2]=0;ha=tT(w,187)|0;dJc(ha|0,373451,187)|0;z5(-215,w,374562,372908,1294)}W=f[V>>2]|0;V=f[D>>2]|0;if((W|0)<(V|0)){f[w>>2]=0;ga=w+4|0;f[ga>>2]=0;ha=tT(w,187)|0;dJc(ha|0,373451,187)|0;z5(-215,w,374562,372908,1294)}X=f[s>>2]|0;if((U+ba+(f[X+(ea*56|0)+12>>2]|0)|0)>(f[k>>2]|0)){f[w>>2]=0;ga=w+4|0;f[ga>>2]=0;ha=tT(w,187)|0;dJc(ha|0,373451,187)|0;z5(-215,w,374562,372908,1294)}if((V+W+(f[X+(ea*56|0)+8>>2]|0)|0)>(f[aa>>2]|0)){f[w>>2]=0;ga=w+4|0;f[ga>>2]=0;ha=tT(w,187)|0;dJc(ha|0,373451,187)|0;z5(-215,w,374562,372908,1294)}else break}while(0);if((fa|0)<(f[e>>2]|0)){f[e>>2]=fa;ia=ea;ja=fa}else{ia=ea;ja=fa}}else{ia=1;ja=-1}do if((d$(d)|0)==327680){f$(d,t);fa=f[t>>2]|0;ea=(f[G>>2]|0)-fa|0;ha=((ea|0)/56|0)+-1|0;ga=fa;if((ea|0)<=0){f[k>>2]=0;f[k+4>>2]=0;K=tT(k,12)|0;L=373639;M=K+12|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,k,374562,372908,1306)}do if(((ha|0)%2|0|0)==1){Z=f[ga+56>>2]|0;if(!((Z&7|0)==3?((f[ga>>2]|0)>>>2&1022|1|0)==(Z>>>3&511|0):0)){ka=1;la=ha;break}ka=2;la=(ha|0)/2|0}else{ka=1;la=ha}while(0);do if((la|0)>0){f[k>>2]=0;ha=k+4|0;f[ha>>2]=0;f[v>>2]=0;Z=v+4|0;f[Z>>2]=0;jT(ga+(ka*56|0)|0,k,v);ea=f[v>>2]|0;fa=f[C>>2]|0;if((ea|0)<(fa|0)){f[w>>2]=0;ma=w+4|0;f[ma>>2]=0;na=tT(w,187)|0;dJc(na|0,373652,187)|0;z5(-215,w,374562,372908,1322)}$=f[Z>>2]|0;Z=f[D>>2]|0;if(($|0)<(Z|0)){f[w>>2]=0;ma=w+4|0;f[ma>>2]=0;na=tT(w,187)|0;dJc(na|0,373652,187)|0;z5(-215,w,374562,372908,1322)}aa=f[t>>2]|0;if((fa+ea+(f[aa+(ka*56|0)+12>>2]|0)|0)>(f[k>>2]|0)){f[w>>2]=0;ma=w+4|0;f[ma>>2]=0;na=tT(w,187)|0;dJc(na|0,373652,187)|0;z5(-215,w,374562,372908,1322)}if((Z+$+(f[aa+(ka*56|0)+8>>2]|0)|0)>(f[ha>>2]|0)){f[w>>2]=0;ma=w+4|0;f[ma>>2]=0;na=tT(w,187)|0;dJc(na|0,373652,187)|0;z5(-215,w,374562,372908,1322)}else break}while(0);if((la|0)>=(f[e>>2]|0)){oa=ka;pa=la;break}f[e>>2]=la;oa=ka;pa=la}else{oa=1;pa=-1}while(0);if((ja|0)<0){ja=k+8|0;f[ja>>2]=0;f[ja+4>>2]=0;f[k>>2]=33882112;f[k+4>>2]=s;f[x>>2]=f[C>>2];f[x+4>>2]=f[D>>2];ja=XDa(c,k,x,f[e>>2]|0,0,4,0,1)|0;f[e>>2]=ja}if((pa|0)<0){pa=k+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[k>>2]=33882112;f[k+4>>2]=t;f[y>>2]=f[C>>2];f[y+4>>2]=f[D>>2];pa=XDa(d,k,y,f[e>>2]|0,0,4,0,1)|0;f[e>>2]=pa}pa=a+16|0;y=f[pa>>2]|0;d=a+20|0;if(!(y&1))qa=30;else{ja=f[d>>2]|0;x=(ja|0)>0?ja:0;qa=(x|0)<100?x:100}f[d>>2]=qa;qa=a+24|0;if(!(y&2))ra=.01;else{sa=+p[qa>>3];ta=sa<0.0?0.0:sa;ra=ta>10.0?10.0:ta}p[qa>>3]=ra*ra;f[v>>2]=1124007936;qa=v+4|0;y=v+8|0;d=v+40|0;K=qa;M=K+36|0;do{f[K>>2]=0;K=K+4|0}while((K|0)<(M|0));f[d>>2]=y;y=v+48|0;x=v+44|0;f[x>>2]=y;f[y>>2]=0;f[v+52>>2]=0;ja=(ia|0)==1;if(ja){c=f[s>>2]|0;la=(f[C>>2]<<1)+(f[c+12>>2]|0)|0;ka=f[c>>2]<<1&4080|11;f[k>>2]=(f[D>>2]<<1)+(f[c+8>>2]|0);f[k+4>>2]=la;XS(v,2,k,ka)}ka=f[e>>2]|0;a:do if((ka|0)>-1){la=k+4|0;c=k+8|0;na=k+40|0;ma=k+48|0;G=k+44|0;ga=k+52|0;ha=v+16|0;aa=A+4|0;$=A+8|0;Z=A+12|0;ea=z+36|0;fa=k+36|0;X=k+16|0;W=z+4|0;V=z+8|0;ba=z+12|0;U=k+12|0;_=z+44|0;ua=z+16|0;va=z+20|0;wa=k+20|0;xa=z+24|0;ya=k+24|0;za=z+28|0;Aa=k+28|0;Ba=z+32|0;Ca=k+32|0;Da=z+40|0;Ea=z+48|0;Fa=z+8|0;Ga=z+12|0;Ha=z+4|0;Ia=A+8|0;Ja=A+4|0;Ka=w+36|0;La=w+16|0;Ma=w+4|0;Na=w+40|0;Oa=w+44|0;Pa=w+48|0;Qa=w+4|0;Ra=a+40|0;Sa=z+32|0;Ta=z+36|0;Ua=z+40|0;Va=z+4|0;Wa=z+12|0;Xa=z+8|0;Ya=z+16|0;Za=z+20|0;_a=z+24|0;$a=z+28|0;ab=z+56|0;bb=z+60|0;cb=z+64|0;db=z+68|0;eb=ka;while(1){f[k>>2]=1124007936;K=la;M=K+36|0;do{f[K>>2]=0;K=K+4|0}while((K|0)<(M|0));f[na>>2]=c;f[G>>2]=ma;f[ma>>2]=0;f[ga>>2]=0;fb=Y(eb,ia)|0;do if(ja){gb=f[(f[s>>2]|0)+(fb*56|0)+40>>2]|0;hb=f[gb+4>>2]|0;ib=f[gb>>2]|0;Vj(w,(f[D>>2]<<1)+ib|0,(f[C>>2]<<1)+hb|0,f[v>>2]&4095,f[ha>>2]|0,0);gb=f[D>>2]|0;f[A>>2]=f[C>>2];f[aa>>2]=gb;f[$>>2]=hb;f[Z>>2]=ib;cT(z,w,A);ib=f[ea>>2]|0;if(ib|0){hb=ib+12|0;f[hb>>2]=(f[hb>>2]|0)+1}hb=f[fa>>2]|0;do if(hb|0){ib=hb+12|0;gb=f[ib>>2]|0;f[ib>>2]=gb+-1;if((gb|0)!=1)break;_S(k)}while(0);f[fa>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[la>>2]|0)>0){hb=f[na>>2]|0;gb=0;do{f[hb+(gb<<2)>>2]=0;gb=gb+1|0;jb=f[la>>2]|0}while((gb|0)<(jb|0));f[k>>2]=f[z>>2];if((jb|0)<3)ca=123;else ca=125}else{f[k>>2]=f[z>>2];ca=123}do if((ca|0)==123){ca=0;gb=f[W>>2]|0;if((gb|0)>=3){ca=125;break}f[la>>2]=gb;f[c>>2]=f[V>>2];f[U>>2]=f[ba>>2];gb=f[_>>2]|0;hb=f[G>>2]|0;f[hb>>2]=f[gb>>2];f[hb+4>>2]=f[gb+4>>2]}while(0);if((ca|0)==125){ca=0;ZS(k,z)}f[X>>2]=f[ua>>2];f[wa>>2]=f[va>>2];f[ya>>2]=f[xa>>2];f[Aa>>2]=f[za>>2];f[Ca>>2]=f[Ba>>2];gb=f[ea>>2]|0;f[fa>>2]=gb;do if(gb|0){hb=gb+12|0;ib=f[hb>>2]|0;f[hb>>2]=ib+-1;if((ib|0)!=1)break;_S(z)}while(0);f[ea>>2]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[W>>2]|0)>0){gb=f[Da>>2]|0;ib=0;do{f[gb+(ib<<2)>>2]=0;ib=ib+1|0}while((ib|0)<(f[W>>2]|0))}ib=f[_>>2]|0;if((ib|0)!=(Ea|0))g0(ib);YDa((f[s>>2]|0)+(fb*56|0)|0,k);f[Fa>>2]=0;f[Ga>>2]=0;f[z>>2]=16842752;f[Ha>>2]=k;ib=Ia;f[ib>>2]=0;f[ib+4>>2]=0;f[A>>2]=33619968;f[Ja>>2]=w;ib=f[D>>2]|0;gb=f[C>>2]|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;f[B+24>>2]=0;f[B+28>>2]=0;q_(z,A,ib,ib,gb,gb,16,B);gb=f[Ka>>2]|0;do if(gb|0){ib=gb+12|0;hb=f[ib>>2]|0;f[ib>>2]=hb+-1;if((hb|0)!=1)break;_S(w)}while(0);f[Ka>>2]=0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;if((f[Ma>>2]|0)>0){gb=f[Na>>2]|0;hb=0;do{f[gb+(hb<<2)>>2]=0;hb=hb+1|0}while((hb|0)<(f[Ma>>2]|0))}hb=f[Oa>>2]|0;if((hb|0)!=(Pa|0))g0(hb)}else{hb=fb+1|0;gb=f[s>>2]|0;ib=gb+(hb*56|0)|0;if((k|0)==(ib|0))break;kb=gb+(hb*56|0)+36|0;lb=f[kb>>2]|0;do if(lb|0){mb=lb+12|0;f[mb>>2]=(f[mb>>2]|0)+1;mb=f[fa>>2]|0;if(!mb)break;nb=mb+12|0;mb=f[nb>>2]|0;f[nb>>2]=mb+-1;if((mb|0)!=1)break;_S(k)}while(0);f[fa>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[la>>2]|0)>0){lb=f[na>>2]|0;mb=0;do{f[lb+(mb<<2)>>2]=0;mb=mb+1|0;ob=f[la>>2]|0}while((mb|0)<(ob|0));f[k>>2]=f[ib>>2];if((ob|0)<3)ca=153;else ca=155}else{f[k>>2]=f[ib>>2];ca=153}do if((ca|0)==153){ca=0;mb=f[gb+(hb*56|0)+4>>2]|0;if((mb|0)>=3){ca=155;break}f[la>>2]=mb;f[c>>2]=f[gb+(hb*56|0)+8>>2];f[U>>2]=f[gb+(hb*56|0)+12>>2];mb=f[gb+(hb*56|0)+44>>2]|0;lb=f[G>>2]|0;f[lb>>2]=f[mb>>2];f[lb+4>>2]=f[mb+4>>2]}while(0);if((ca|0)==155){ca=0;ZS(k,ib)}f[X>>2]=f[gb+(hb*56|0)+16>>2];f[wa>>2]=f[gb+(hb*56|0)+20>>2];f[ya>>2]=f[gb+(hb*56|0)+24>>2];f[Aa>>2]=f[gb+(hb*56|0)+28>>2];f[Ca>>2]=f[gb+(hb*56|0)+32>>2];f[fa>>2]=f[kb>>2]}while(0);mb=f[s>>2]|0;lb=f[mb+(fb*56|0)+40>>2]|0;nb=Y(eb,oa)|0;pb=f[t>>2]|0;qb=f[pb+(nb*56|0)+40>>2]|0;if(!((f[lb>>2]|0)==(f[qb>>2]|0)?(f[lb+4>>2]|0)==(f[qb+4>>2]|0):0)){ca=158;break}if((f[pb+(nb*56|0)>>2]^f[mb+(fb*56|0)>>2])&4095|0){ca=160;break}f[w>>2]=0;f[Qa>>2]=J;qb=f[C>>2]|0;lb=f[D>>2]|0;rb=f[e>>2]|0;sb=f[I>>2]|0;ra=+p[Ra>>3];f[z>>2]=77332;f[Va>>2]=mb+(fb*56|0);f[Wa>>2]=k;f[Xa>>2]=pb+(nb*56|0);f[Ya>>2]=m;f[Za>>2]=E;f[_a>>2]=Q;f[$a>>2]=da;f[Sa>>2]=qb;f[Ta>>2]=lb;f[Ua>>2]=f[pa>>2];f[Ua+4>>2]=f[pa+4>>2];f[Ua+8>>2]=f[pa+8>>2];f[Ua+12>>2]=f[pa+12>>2];f[ab>>2]=eb;f[bb>>2]=rb;f[cb>>2]=sb;n[db>>2]=ra;y8(w,z,-1.0);sb=f[fa>>2]|0;do if(sb|0){rb=sb+12|0;lb=f[rb>>2]|0;f[rb>>2]=lb+-1;if((lb|0)!=1)break;_S(k)}while(0);f[fa>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[la>>2]|0)>0){sb=f[na>>2]|0;fb=0;do{f[sb+(fb<<2)>>2]=0;fb=fb+1|0}while((fb|0)<(f[la>>2]|0))}fb=f[G>>2]|0;if((fb|0)!=(ma|0))g0(fb);if((eb|0)>0)eb=eb+-1|0;else break a}if((ca|0)==158){f[w>>2]=0;f[w+4>>2]=0;K=tT(w,68)|0;L=373840;M=K+68|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,w,374562,372908,1365)}else if((ca|0)==160){f[w>>2]=0;f[w+4>>2]=0;K=tT(w,68)|0;L=373909;M=K+68|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));z5(-215,w,374562,372908,1366)}}while(0);w=v+36|0;L=f[w>>2]|0;do if(L|0){K=L+12|0;M=f[K>>2]|0;f[K>>2]=M+-1;if((M|0)!=1)break;_S(v)}while(0);f[w>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[qa>>2]|0)>0){w=f[d>>2]|0;d=0;do{f[w+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[qa>>2]|0))}qa=f[x>>2]|0;if((qa|0)!=(y|0))g0(qa);mx(t);mx(s);s=r+36|0;t=f[s>>2]|0;do if(t|0){qa=t+12|0;y=f[qa>>2]|0;f[qa>>2]=y+-1;if((y|0)!=1)break;_S(r)}while(0);f[s>>2]=0;s=r+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[N>>2]|0)>0){s=f[O>>2]|0;O=0;do{f[s+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[N>>2]|0))}N=f[R>>2]|0;if((N|0)!=(P|0))g0(N);N=q+36|0;P=f[N>>2]|0;do if(P|0){R=P+12|0;O=f[R>>2]|0;f[R>>2]=O+-1;if((O|0)!=1)break;_S(q)}while(0);f[N>>2]=0;N=q+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[N>>2]|0)>0){S=f[q+40>>2]|0;P=0;do{f[S+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[N>>2]|0))}N=f[T>>2]|0;if((N|0)!=(q+48|0))g0(N);N=o+36|0;q=f[N>>2]|0;do if(q|0){T=q+12|0;P=f[T>>2]|0;f[T>>2]=P+-1;if((P|0)!=1)break;_S(o)}while(0);f[N>>2]=0;N=o+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[N>>2]|0)>0){F=f[o+40>>2]|0;q=0;do{f[F+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[N>>2]|0))}N=f[H>>2]|0;if((N|0)!=(o+48|0))g0(N)}else{u$(g);u$(h);u$(i)}i=l+36|0;h=f[i>>2]|0;if(h|0?(g=h+12|0,h=f[g>>2]|0,f[g>>2]=h+-1,(h|0)==1):0)_S(l);f[i>>2]=0;i=l+16|0;h=l+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[h>>2]|0)>0){i=f[l+40>>2]|0;g=0;do{f[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[l+44>>2]|0;if((h|0)==(l+48|0)){u=j;return}g0(h);u=j;return}function bEa(a,b){a=a|0;b=b|0;f[a>>2]=f[b+4>>2];f[a+4>>2]=f[b+8>>2];return}function cEa(a,b){a=a|0;b=b|0;f[a+4>>2]=f[b>>2];f[a+8>>2]=f[b+4>>2];return}function dEa(a){a=a|0;return f[a+12>>2]|0}function eEa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function fEa(a,b){a=a|0;b=b|0;var c=0;c=b+16|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];return}function gEa(a,b){a=a|0;b=b|0;var c=0;c=a+16|0;f[c>>2]=f[b>>2];f[c+4>>2]=f[b+4>>2];f[c+8>>2]=f[b+8>>2];f[c+12>>2]=f[b+12>>2];return}function hEa(a){a=a|0;return f[a+32>>2]|0}function iEa(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function jEa(a){a=a|0;return +(+p[a+40>>3])}function kEa(a,b){a=a|0;b=+b;p[a+40>>3]=b;return}function lEa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,q=0.0;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[j>>2]|0;o=f[j+4>>2]|0;q=+p[j+8>>3];j=VDc(48)|0;r0(j);f[j>>2]=77352;f[j+4>>2]=m;f[j+8>>2]=n;f[j+12>>2]=i;f[j+16>>2]=h;f[j+20>>2]=o;p[j+24>>3]=q;f[j+32>>2]=k;p[j+40>>3]=l;k=VDc(16)|0;o=k+4|0;f[o>>2]=1;f[k>>2]=77436;f[k+8>>2]=j;f[o>>2]=(f[o>>2]|0)+1;h=f[o>>2]|0;f[o>>2]=h+-1;if((h|0)==1)Yi[f[(f[k>>2]|0)+8>>2]&2047](k);Ii[f[(f[j>>2]|0)+32>>2]&127](j,a,b,c,d,e,g);g=f[o>>2]|0;f[o>>2]=g+-1;if((g|0)!=1)return;Yi[f[(f[k>>2]|0)+8>>2]&2047](k);return}function mEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nEa(a,b,c,d,500,.5,3);return}function nEa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0,vb=0,wb=0;j=u;u=u+656|0;k=j+16|0;l=j+600|0;m=j+544|0;o=j+488|0;q=j+472|0;r=j+460|0;t=j+448|0;v=j+376|0;w=j+392|0;x=j+320|0;y=j+232|0;z=j+176|0;A=j+152|0;B=j+136|0;C=j+312|0;D=j+304|0;E=j+296|0;F=j+288|0;G=j+72|0;H=j+168|0;I=j;K=j+124|0;N=j+112|0;O=j+100|0;P=j+88|0;f[l>>2]=1124007936;Q=l+4|0;R=l+8|0;S=l+40|0;T=Q;U=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(U|0));f[S>>2]=R;V=l+48|0;W=l+44|0;f[W>>2]=V;f[V>>2]=0;f[l+52>>2]=0;f[k>>2]=2;f[k+4>>2]=3;XS(l,2,k,6);do if((d$(c)|0)==65536){X=f[c+4>>2]|0;f[m>>2]=f[X>>2];Y=m+4|0;Z=X+4|0;f[Y>>2]=f[Z>>2];_=m+8|0;f[_>>2]=f[X+8>>2];f[m+12>>2]=f[X+12>>2];f[m+16>>2]=f[X+16>>2];f[m+20>>2]=f[X+20>>2];f[m+24>>2]=f[X+24>>2];f[m+28>>2]=f[X+28>>2];f[m+32>>2]=f[X+32>>2];$=f[X+36>>2]|0;f[m+36>>2]=$;f[m+40>>2]=_;_=m+48|0;aa=m+44|0;f[aa>>2]=_;f[_>>2]=0;f[m+52>>2]=0;if($|0){_=$+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[Z>>2]|0)<3){Z=f[X+44>>2]|0;_=f[aa>>2]|0;f[_>>2]=f[Z>>2];f[_+4>>2]=f[Z+4>>2];break}else{f[Y>>2]=0;ZS(m,X);break}}else a$(m,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[o>>2]=f[c>>2];X=o+4|0;Y=c+4|0;f[X>>2]=f[Y>>2];Z=o+8|0;f[Z>>2]=f[c+8>>2];f[o+12>>2]=f[c+12>>2];f[o+16>>2]=f[c+16>>2];f[o+20>>2]=f[c+20>>2];f[o+24>>2]=f[c+24>>2];f[o+28>>2]=f[c+28>>2];f[o+32>>2]=f[c+32>>2];_=f[c+36>>2]|0;f[o+36>>2]=_;f[o+40>>2]=Z;Z=o+48|0;aa=o+44|0;f[aa>>2]=Z;f[Z>>2]=0;f[o+52>>2]=0;if(_|0){Z=_+12|0;f[Z>>2]=(f[Z>>2]|0)+1}if((f[Y>>2]|0)<3){Y=f[c+44>>2]|0;Z=f[aa>>2]|0;f[Z>>2]=f[Y>>2];f[Z+4>>2]=f[Y+4>>2];break}else{f[X>>2]=0;ZS(o,c);break}}else a$(o,d,-1);while(0);f[q>>2]=0;d=q+4|0;f[d>>2]=0;f[q+8>>2]=0;f[r>>2]=0;c=r+4|0;f[c>>2]=0;f[r+8>>2]=0;f[t>>2]=0;X=t+4|0;f[X>>2]=0;f[t+8>>2]=0;f[v>>2]=0;Y=v+4|0;f[Y>>2]=0;f[v+8>>2]=0;if((i|0)<3){f[k>>2]=0;f[k+4>>2]=0;T=tT(k,44)|0;ba=374081;U=T+44|0;do{b[T>>0]=b[ba>>0]|0;T=T+1|0;ba=ba+1|0}while((T|0)<(U|0));z5(-5,k,374126,372908,1503)}if(h>1.0|h<0.0){f[k>>2]=0;f[k+4>>2]=0;T=tT(k,49)|0;ba=374149;U=T+49|0;do{b[T>>0]=b[ba>>0]|0;T=T+1|0;ba=ba+1|0}while((T|0)<(U|0));z5(-5,k,374126,372908,1506)}Z=m+40|0;aa=f[Z>>2]|0;_=o+40|0;$=f[_>>2]|0;if((f[aa>>2]|0)!=(f[$>>2]|0)?1:(f[aa+4>>2]|0)!=(f[$+4>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;T=tT(k,41)|0;ba=374199;U=T+41|0;do{b[T>>0]=b[ba>>0]|0;T=T+1|0;ba=ba+1|0}while((T|0)<(U|0));z5(-209,k,374126,372908,1509)}if((f[o>>2]^f[m>>2])&4095|0){f[k>>2]=0;f[k+4>>2]=0;T=tT(k,46)|0;ba=374817;U=T+46|0;do{b[T>>0]=b[ba>>0]|0;T=T+1|0;ba=ba+1|0}while((T|0)<(U|0));z5(-205,k,374126,372908,1512)}$=pT(m,2,-1,1)|0;do if(($|0)>0){lT(w,m,2,$);aa=k+8|0;f[aa>>2]=0;f[aa+4>>2]=0;f[k>>2]=-2113732595;f[k+4>>2]=q;LZ(w,k,5,1.0,0.0);aa=w+36|0;ca=f[aa>>2]|0;if(ca|0?(da=ca+12|0,ca=f[da>>2]|0,f[da>>2]=ca+-1,(ca|0)==1):0)_S(w);f[aa>>2]=0;aa=w+16|0;ca=w+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[ca>>2]|0)>0){aa=f[w+40>>2]|0;da=0;do{f[aa+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ca>>2]|0))}ca=f[w+44>>2]|0;if((ca|0)!=(w+48|0))g0(ca);lT(x,o,2,$);ca=k+8|0;f[ca>>2]=0;f[ca+4>>2]=0;f[k>>2]=-2113732595;f[k+4>>2]=r;LZ(x,k,5,1.0,0.0);ca=x+36|0;da=f[ca>>2]|0;if(da|0?(aa=da+12|0,da=f[aa>>2]|0,f[aa>>2]=da+-1,(da|0)==1):0)_S(x);f[ca>>2]=0;ca=x+16|0;da=x+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[da>>2]|0)>0){ca=f[x+40>>2]|0;aa=0;do{f[ca+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[da>>2]|0))}da=f[x+44>>2]|0;if((da|0)==(x+48|0)){ea=1.0;fa=$}else{g0(da);ea=1.0;fa=$}}else{da=f[m>>2]|0;if(da&7|0){f[k>>2]=0;f[k+4>>2]=0;T=tT(k,52)|0;ba=374271;U=T+52|0;do{b[T>>0]=b[ba>>0]|0;T=T+1|0;ba=ba+1|0}while((T|0)<(U|0));z5(-210,k,374126,372908,1592)}aa=da>>>3;switch(aa&511){case 0:case 2:case 3:break;default:{f[k>>2]=0;f[k+4>>2]=0;T=tT(k,29)|0;ba=374241;U=T+29|0;do{b[T>>0]=b[ba>>0]|0;T=T+1|0;ba=ba+1|0}while((T|0)<(U|0));z5(-215,k,374126,372908,1524)}}da=f[Z>>2]|0;ca=f[da+4>>2]|0;ga=f[da>>2]|0;ha=+(ca|0);ia=160.0/ha;ja=+(ga|0);ka=120.0/ja;la=ia<ka?ka:ia;ia=la>1.0?la:1.0;da=nrc(ha*ia)|0;ma=nrc(ja*ia)|0;na=(aa&511|0)!=0;if(na|((da|0)!=(ca|0)|(ma|0)!=(ga|0))){f[k>>2]=1124007936;ga=k+4|0;ca=k+8|0;oa=k+40|0;T=ga;U=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(U|0));f[oa>>2]=ca;aa=k+48|0;pa=k+44|0;f[pa>>2]=aa;f[aa>>2]=0;f[k+52>>2]=0;f[y>>2]=1124007936;qa=y+4|0;ra=y+8|0;sa=y+40|0;T=qa;U=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(U|0));f[sa>>2]=ra;ta=y+48|0;ua=y+44|0;f[ua>>2]=ta;f[ta>>2]=0;f[y+52>>2]=0;if(na){f[z>>2]=1124007936;va=z+4|0;wa=z+8|0;xa=z+40|0;T=va;U=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(U|0));f[xa>>2]=wa;na=z+48|0;ya=z+44|0;f[ya>>2]=na;f[na>>2]=0;f[z+52>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=m;za=B+8|0;f[za>>2]=0;f[za+4>>2]=0;f[B>>2]=33619968;f[B+4>>2]=z;Oga(A,B,6,0);f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=z;za=B+8|0;f[za>>2]=0;f[za+4>>2]=0;f[B>>2]=33619968;f[B+4>>2]=k;f[C>>2]=da;f[C+4>>2]=ma;nfa(A,B,C,0.0,0.0,3);f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=o;za=B+8|0;f[za>>2]=0;f[za+4>>2]=0;f[B>>2]=33619968;f[B+4>>2]=z;Oga(A,B,6,0);f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=z;za=B+8|0;f[za>>2]=0;f[za+4>>2]=0;f[B>>2]=33619968;f[B+4>>2]=y;f[D>>2]=da;f[D+4>>2]=ma;nfa(A,B,D,0.0,0.0,3);za=z+36|0;Aa=f[za>>2]|0;if(Aa|0?(Ba=Aa+12|0,Aa=f[Ba>>2]|0,f[Ba>>2]=Aa+-1,(Aa|0)==1):0)_S(z);f[za>>2]=0;za=z+16|0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[va>>2]|0)>0){za=f[xa>>2]|0;Aa=0;do{f[za+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[va>>2]|0))}va=f[ya>>2]|0;if((va|0)!=(na|0))g0(va)}else{f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=m;va=A+8|0;f[va>>2]=0;f[va+4>>2]=0;f[A>>2]=33619968;f[A+4>>2]=k;f[E>>2]=da;f[E+4>>2]=ma;nfa(z,A,E,0.0,0.0,3);f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=o;va=A+8|0;f[va>>2]=0;f[va+4>>2]=0;f[A>>2]=33619968;f[A+4>>2]=y;f[F>>2]=da;f[F+4>>2]=ma;nfa(z,A,F,0.0,0.0,3)}va=k+36|0;Aa=f[va>>2]|0;if(Aa|0){za=Aa+12|0;f[za>>2]=(f[za>>2]|0)+1}za=m+36|0;Aa=f[za>>2]|0;if(Aa|0?(xa=Aa+12|0,Aa=f[xa>>2]|0,f[xa>>2]=Aa+-1,(Aa|0)==1):0)_S(m);f[za>>2]=0;Aa=m+16|0;xa=m+4|0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[xa>>2]|0)>0){wa=f[Z>>2]|0;Ba=0;do{f[wa+(Ba<<2)>>2]=0;Ba=Ba+1|0;Ca=f[xa>>2]|0}while((Ba|0)<(Ca|0));f[m>>2]=f[k>>2];if((Ca|0)<3)Da=65;else Da=67}else{f[m>>2]=f[k>>2];Da=65}if((Da|0)==65){Ba=f[ga>>2]|0;if((Ba|0)<3){f[xa>>2]=Ba;f[m+8>>2]=f[ca>>2];f[m+12>>2]=f[k+12>>2];Ba=f[pa>>2]|0;wa=f[m+44>>2]|0;f[wa>>2]=f[Ba>>2];f[wa+4>>2]=f[Ba+4>>2]}else Da=67}if((Da|0)==67)ZS(m,k);Ba=k+16|0;f[Aa>>2]=f[Ba>>2];f[m+20>>2]=f[k+20>>2];f[m+24>>2]=f[k+24>>2];f[m+28>>2]=f[k+28>>2];f[m+32>>2]=f[k+32>>2];f[za>>2]=f[va>>2];wa=y+36|0;na=f[wa>>2]|0;if(na|0){ya=na+12|0;f[ya>>2]=(f[ya>>2]|0)+1}ya=o+36|0;na=f[ya>>2]|0;if(na|0?(Ea=na+12|0,na=f[Ea>>2]|0,f[Ea>>2]=na+-1,(na|0)==1):0)_S(o);f[ya>>2]=0;na=o+16|0;Ea=o+4|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[Ea>>2]|0)>0){Fa=f[_>>2]|0;Ga=0;do{f[Fa+(Ga<<2)>>2]=0;Ga=Ga+1|0;Ha=f[Ea>>2]|0}while((Ga|0)<(Ha|0));f[o>>2]=f[y>>2];if((Ha|0)<3)Da=78;else Da=80}else{f[o>>2]=f[y>>2];Da=78}if((Da|0)==78){Ga=f[qa>>2]|0;if((Ga|0)<3){f[Ea>>2]=Ga;f[o+8>>2]=f[ra>>2];f[o+12>>2]=f[y+12>>2];Ga=f[ua>>2]|0;Fa=f[o+44>>2]|0;f[Fa>>2]=f[Ga>>2];f[Fa+4>>2]=f[Ga+4>>2]}else Da=80}if((Da|0)==80)ZS(o,y);Ga=y+16|0;f[na>>2]=f[Ga>>2];f[o+20>>2]=f[y+20>>2];f[o+24>>2]=f[y+24>>2];f[o+28>>2]=f[y+28>>2];f[o+32>>2]=f[y+32>>2];Fa=f[wa>>2]|0;f[ya>>2]=Fa;do if(Fa|0){za=Fa+12|0;Aa=f[za>>2]|0;f[za>>2]=Aa+-1;if((Aa|0)!=1)break;_S(y)}while(0);f[wa>>2]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[qa>>2]|0)>0){Fa=f[sa>>2]|0;ya=0;do{f[Fa+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[qa>>2]|0))}qa=f[ua>>2]|0;if((qa|0)!=(ta|0))g0(qa);qa=f[va>>2]|0;do if(qa|0){ya=qa+12|0;Fa=f[ya>>2]|0;f[ya>>2]=Fa+-1;if((Fa|0)!=1)break;_S(k)}while(0);f[va>>2]=0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Ba+8>>2]=0;f[Ba+12>>2]=0;if((f[ga>>2]|0)>0){qa=f[oa>>2]|0;ta=0;do{f[qa+(ta<<2)>>2]=0;ta=ta+1|0}while((ta|0)<(f[ga>>2]|0))}ga=f[pa>>2]|0;if((ga|0)!=(aa|0))g0(ga)}ga=nrc(+(da|0)*15.0/+(ma|0))|0;ta=ga*15|0;qa=f[d>>2]|0;oa=f[q>>2]|0;Ba=qa-oa>>3;va=oa;oa=qa;if(ta>>>0<=Ba>>>0){if(ta>>>0<Ba>>>0?(qa=va+(ta<<3)|0,(oa|0)!=(qa|0)):0)f[d>>2]=oa+(~((oa+-8-qa|0)>>>3)<<3)}else HO(q,ta-Ba|0);Ba=f[c>>2]|0;qa=f[r>>2]|0;oa=Ba-qa>>3;va=qa;qa=Ba;if(ta>>>0<=oa>>>0){if(ta>>>0<oa>>>0?(Ba=va+(ta<<3)|0,(qa|0)!=(Ba|0)):0)f[c>>2]=qa+(~((qa+-8-Ba|0)>>>3)<<3)}else HO(r,ta-oa|0);oa=f[Y>>2]|0;Ba=f[v>>2]|0;qa=oa-Ba|0;va=Ba;Ba=oa;if(ta>>>0<=qa>>>0){if(ta>>>0<qa>>>0?(oa=va+ta|0,(Ba|0)!=(oa|0)):0)f[Y>>2]=oa}else y$(v,ta-qa|0);qa=(ga|0)>0;ja=+(da|0);ha=+(ga|0);oa=f[q>>2]|0;la=+(ma|0);if(qa){Ba=0;va=0;while(1){ka=la*(+(Ba|0)+.5)/15.0;ua=0;Fa=va;while(1){n[oa+(Fa<<3)>>2]=ja*(+(ua|0)+.5)/ha;n[oa+(Fa<<3)+4>>2]=ka;ua=ua+1|0;if((ua|0)==(ga|0))break;else Fa=Fa+1|0}Ba=Ba+1|0;if((Ba|0)==15)break;else va=ga+va|0}}f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=m;f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=o;f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=-2130509811;f[A+4>>2]=q;va=B+8|0;f[va>>2]=0;f[va+4>>2]=0;f[B>>2]=-2096955379;f[B+4>>2]=r;va=G+8|0;f[va>>2]=0;f[va+4>>2]=0;f[G>>2]=-2113732608;f[G+4>>2]=v;va=e0()|0;f[H>>2]=21;f[H+4>>2]=21;f[I>>2]=1;f[I+4>>2]=40;p[I+8>>3]=.1;f[k>>2]=f[I>>2];f[k+4>>2]=f[I+4>>2];f[k+8>>2]=f[I+8>>2];f[k+12>>2]=f[I+12>>2];lEa(y,z,A,B,G,va,H,3,k,0,.0001);if(qa){va=f[v>>2]|0;ga=0;Ba=0;while(1){if(!(b[va+ga>>0]|0))Ia=Ba;else{if((ga|0)>(Ba|0)){oa=f[q>>2]|0;f[oa+(Ba<<3)>>2]=f[oa+(ga<<3)>>2];f[oa+(Ba<<3)+4>>2]=f[oa+(ga<<3)+4>>2];oa=f[r>>2]|0;f[oa+(Ba<<3)>>2]=f[oa+(ga<<3)>>2];f[oa+(Ba<<3)+4>>2]=f[oa+(ga<<3)+4>>2]}Ia=Ba+1|0}ga=ga+1|0;if((ga|0)>=(ta|0)){Ja=Ia;break}else Ba=Ia}}else Ja=0;Ba=f[d>>2]|0;ta=f[q>>2]|0;ga=Ba-ta>>3;va=ta;ta=Ba;if(Ja>>>0<=ga>>>0){if(Ja>>>0<ga>>>0?(Ba=va+(Ja<<3)|0,(ta|0)!=(Ba|0)):0)f[d>>2]=ta+(~((ta+-8-Ba|0)>>>3)<<3)}else HO(q,Ja-ga|0);ga=f[c>>2]|0;Ba=f[r>>2]|0;ta=ga-Ba>>3;va=ga;if(Ja>>>0>ta>>>0){HO(r,Ja-ta|0);ea=ia;fa=Ja;break}if(Ja>>>0<ta>>>0?(ta=Ba+(Ja<<3)|0,(va|0)!=(ta|0)):0){f[c>>2]=va+(~((va+-8-ta|0)>>>3)<<3);ea=ia;fa=Ja}else{ea=ia;fa=Ja}}while(0);Ja=f[X>>2]|0;Ia=f[t>>2]|0;H=Ja-Ia>>2;G=Ia;Ia=Ja;if(fa>>>0<=H>>>0){if(fa>>>0<H>>>0?(Ja=G+(fa<<2)|0,(Ia|0)!=(Ja|0)):0)f[X>>2]=Ia+(~((Ia+-4-Ja|0)>>>2)<<2)}else lN(t,fa-H|0);if((fa|0)>=(i|0)){f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=-2130509811;f[y+4>>2]=r;Qxa(k,y);f[y>>2]=0;H=y+4|0;f[H>>2]=0;f[y+8>>2]=0;Ja=(i|0)==0;do if(!Ja)if(i>>>0>536870911)mCc(y);else{Ia=i<<3;G=VDc(Ia)|0;f[y>>2]=G;B=G+(i<<3)|0;f[y+8>>2]=B;XIc(G|0,0,Ia|0)|0;f[H>>2]=B;break}while(0);f[z>>2]=0;B=z+4|0;f[B>>2]=0;f[z+8>>2]=0;if(!Ja){Ia=i<<3;G=VDc(Ia)|0;f[z>>2]=G;I=G+(i<<3)|0;f[z+8>>2]=I;XIc(G|0,0,Ia|0)|0;f[B>>2]=I}a:do if((g|0)>0){I=A+4|0;Ia=A+8|0;G=i<<2;Ha=A+8|0;Ca=(i|0)>0;F=l+16|0;E=(fa|0)>0;ha=+(fa|0)*h;D=k+8|0;C=k+12|0;ba=K+4|0;$=N+4|0;x=(fa|0)==0;w=0;ta=0;va=-1;Ba=-1;while(1){f[A>>2]=0;f[I>>2]=0;f[Ia>>2]=0;if(Ja){Ka=0;La=0}else{ga=VDc(G)|0;f[A>>2]=ga;qa=ga+(i<<2)|0;f[Ha>>2]=qa;XIc(ga|0,0,G|0)|0;f[I>>2]=qa;Ka=ga;La=ga}b:do if(Ca){ga=f[q>>2]|0;qa=f[y>>2]|0;oa=qa+4|0;ma=La+4|0;da=qa+8|0;aa=qa+12|0;pa=La+8|0;Fa=qa+16|0;ua=qa+20|0;ya=f[r>>2]|0;sa=f[z>>2]|0;Ga=sa+4|0;wa=La+4|0;na=sa+8|0;ra=sa+12|0;Ea=La+8|0;Aa=sa+16|0;za=sa+20|0;ca=qa+8|0;xa=qa+16|0;Ma=0;Na=va;Oa=Ba;while(1){Pa=La+(Ma<<2)|0;Qa=(Ma|0)>0;Ra=Ma;Ma=Ma+1|0;Sa=(Ma|0)==(i|0);Ta=La+(Ra<<2)|0;Ua=0;Va=Na;Wa=Oa;c:while(1){Xa=mJc(Va|0,0,-130063606,0)|0;Ya=UIc(Xa|0,J|0,Wa|0,0)|0;if(x){Za=Va;_a=Wa;$a=0}else{Za=Ya;_a=J;$a=(Ya>>>0)%(fa>>>0)|0}f[Pa>>2]=$a;d:do if(Qa){Ya=f[Ta>>2]|0;Xa=ga+(Ya<<3)|0;ab=ga+(Ya<<3)+4|0;bb=ya+(Ya<<3)|0;cb=ya+(Ya<<3)+4|0;db=0;while(1){eb=f[La+(db<<2)>>2]|0;if((eb|0)==(Ya|0))break d;ja=+L(+(+n[Xa>>2]-+n[ga+(eb<<3)>>2]));if(ja+ +L(+(+n[ab>>2]-+n[ga+(eb<<3)+4>>2]))<1.1920928955078125e-07)break d;ja=+L(+(+n[bb>>2]-+n[ya+(eb<<3)>>2]));db=db+1|0;if(ja+ +L(+(+n[cb>>2]-+n[ya+(eb<<3)+4>>2]))<1.1920928955078125e-07)break d;if((db|0)>=(Ra|0)){Da=165;break}}}else Da=165;while(0);do if((Da|0)==165){Da=0;if(!Sa)break c;db=f[La>>2]|0;f[qa>>2]=f[ga+(db<<3)>>2];f[oa>>2]=f[ga+(db<<3)+4>>2];db=f[ma>>2]|0;f[da>>2]=f[ga+(db<<3)>>2];f[aa>>2]=f[ga+(db<<3)+4>>2];db=f[pa>>2]|0;f[Fa>>2]=f[ga+(db<<3)>>2];f[ua>>2]=f[ga+(db<<3)+4>>2];db=f[La>>2]|0;cb=f[ya+(db<<3)>>2]|0;f[sa>>2]=cb;bb=f[ya+(db<<3)+4>>2]|0;f[Ga>>2]=bb;db=f[wa>>2]|0;ab=f[ya+(db<<3)>>2]|0;f[na>>2]=ab;Xa=f[ya+(db<<3)+4>>2]|0;f[ra>>2]=Xa;db=f[Ea>>2]|0;Ya=f[ya+(db<<3)>>2]|0;f[Aa>>2]=Ya;eb=f[ya+(db<<3)+4>>2]|0;f[za>>2]=eb;ja=+n[qa>>2];la=+n[ca>>2]-ja;ka=+n[oa>>2];fb=+n[aa>>2]-ka;gb=+n[xa>>2]-ja;ja=+n[ua>>2]-ka;ka=(f[s>>2]=ab,+n[s>>2]);hb=(f[s>>2]=cb,+n[s>>2]);ib=ka-hb;ka=(f[s>>2]=Xa,+n[s>>2]);jb=(f[s>>2]=bb,+n[s>>2]);kb=ka-jb;ka=(f[s>>2]=Ya,+n[s>>2])-hb;hb=(f[s>>2]=eb,+n[s>>2])-jb;if(+L(+(la*ja-fb*gb))<+M(+(la*la+fb*fb))*.01*+M(+(gb*gb+ja*ja)))break;if(!(+L(+(ib*hb-kb*ka))<+M(+(ib*ib+kb*kb))*.01*+M(+(ka*ka+hb*hb))))break c}while(0);Ua=Ua+1|0;if((Ua|0)>=(g|0)){lb=15;mb=w;nb=Za;ob=_a;pb=La;qb=Ka;break b}else{Va=Za;Wa=_a}}if((Ma|0)>=(i|0)){rb=Za;sb=_a;Da=169;break}else{Na=Za;Oa=_a}}}else{rb=va;sb=Ba;Da=169}while(0);if((Da|0)==169){Da=0;oEa(K,y);oEa(N,z);pEa(K,N,3,l,e);Oa=f[N>>2]|0;if(Oa|0){Na=f[$>>2]|0;if((Na|0)!=(Oa|0))f[$>>2]=Na+(~((Na+-8-Oa|0)>>>3)<<3);YDc(Oa)}Oa=f[K>>2]|0;if(Oa|0){Na=f[ba>>2]|0;if((Na|0)!=(Oa|0))f[ba>>2]=Na+(~((Na+-8-Oa|0)>>>3)<<3);YDc(Oa)}Oa=f[F>>2]|0;if(E){Na=f[q>>2]|0;hb=+p[Oa+16>>3];Ma=f[r>>2]|0;ka=+p[Oa+24>>3];kb=+p[Oa+32>>3];ib=+p[Oa+40>>3];ua=f[t>>2]|0;ja=+p[Oa>>3];gb=+p[Oa+8>>3];Oa=0;xa=0;while(1){fb=+n[Na+(xa<<3)>>2];la=+n[Na+(xa<<3)+4>>2];jb=+L(+(hb+(ja*fb+gb*la)-+n[Ma+(xa<<3)>>2]));tb=+L(+(ib+(fb*ka+la*kb)-+n[Ma+(xa<<3)+4>>2]));aa=f[D>>2]|0;oa=f[C>>2]|0;if(jb+tb<+(((aa|0)<(oa|0)?oa:aa)|0)*.05){f[ua+(Oa<<2)>>2]=xa;ub=Oa+1|0}else ub=Oa;xa=xa+1|0;if((xa|0)==(fa|0)){vb=ub;break}else Oa=ub}}else vb=0;Oa=f[A>>2]|0;lb=!(+(vb|0)>=ha)?0:13;mb=vb;nb=rb;ob=sb;pb=Oa;qb=Oa}if(pb|0){Oa=f[I>>2]|0;if((Oa|0)!=(pb|0))f[I>>2]=Oa+(~((Oa+-4-pb|0)>>>2)<<2);YDc(qb)}ta=ta+1|0;if((lb|0)==13)break;if((ta|0)>=(g|0)){Da=188;break a}else{w=mb;va=nb;Ba=ob}}if((mb|0)<(fa|0)&(mb|0)>0){Ba=f[t>>2]|0;va=f[q>>2]|0;w=f[r>>2]|0;ta=0;do{I=f[Ba+(ta<<2)>>2]|0;f[va+(ta<<3)>>2]=f[va+(I<<3)>>2];f[va+(ta<<3)+4>>2]=f[va+(I<<3)+4>>2];f[w+(ta<<3)>>2]=f[w+(I<<3)>>2];f[w+(ta<<3)+4>>2]=f[w+(I<<3)+4>>2];ta=ta+1|0}while((ta|0)!=(mb|0))}oEa(O,q);oEa(P,r);pEa(O,P,mb,l,e);ta=f[P>>2]|0;if(ta|0){w=P+4|0;va=f[w>>2]|0;if((va|0)!=(ta|0))f[w>>2]=va+(~((va+-8-ta|0)>>>3)<<3);YDc(ta)}ta=f[O>>2]|0;if(ta|0){va=O+4|0;w=f[va>>2]|0;if((w|0)!=(ta|0))f[va>>2]=w+(~((w+-8-ta|0)>>>3)<<3);YDc(ta)}ta=f[F>>2]|0;w=ta+16|0;p[w>>3]=+p[w>>3]/ea;w=ta+(f[f[W>>2]>>2]|0)+16|0;p[w>>3]=+p[w>>3]/ea;f[a>>2]=f[l>>2];w=a+4|0;va=f[Q>>2]|0;f[w>>2]=va;Ba=a+8|0;f[Ba>>2]=f[R>>2];f[a+12>>2]=f[l+12>>2];f[a+16>>2]=ta;f[a+20>>2]=f[l+20>>2];f[a+24>>2]=f[l+24>>2];f[a+28>>2]=f[l+28>>2];f[a+32>>2]=f[l+32>>2];ta=f[l+36>>2]|0;f[a+36>>2]=ta;f[a+40>>2]=Ba;Ba=a+48|0;I=a+44|0;f[I>>2]=Ba;f[Ba>>2]=0;f[a+52>>2]=0;if(!ta)wb=va;else{va=ta+12|0;f[va>>2]=(f[va>>2]|0)+1;wb=f[Q>>2]|0}if((wb|0)<3){va=f[W>>2]|0;ta=f[I>>2]|0;f[ta>>2]=f[va>>2];f[ta+4>>2]=f[va+4>>2];break}else{f[w>>2]=0;ZS(a,l);break}}else Da=188;while(0);if((Da|0)==188){f[a>>2]=1124007936;Da=a+8|0;wb=a+40|0;T=a+4|0;U=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(U|0));f[wb>>2]=Da;Da=a+48|0;f[a+44>>2]=Da;f[Da>>2]=0;f[a+52>>2]=0}Da=f[z>>2]|0;if(Da|0){z=f[B>>2]|0;if((z|0)!=(Da|0))f[B>>2]=z+(~((z+-8-Da|0)>>>3)<<3);YDc(Da)}Da=f[y>>2]|0;if(Da|0){y=f[H>>2]|0;if((y|0)!=(Da|0))f[H>>2]=y+(~((y+-8-Da|0)>>>3)<<3);YDc(Da)}}else{f[a>>2]=1124007936;Da=a+8|0;y=a+40|0;T=a+4|0;U=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(U|0));f[y>>2]=Da;Da=a+48|0;f[a+44>>2]=Da;f[Da>>2]=0;f[a+52>>2]=0}a=f[v>>2]|0;if(a|0){if((f[Y>>2]|0)!=(a|0))f[Y>>2]=a;YDc(a)}a=f[t>>2]|0;if(a|0){t=f[X>>2]|0;if((t|0)!=(a|0))f[X>>2]=t+(~((t+-4-a|0)>>>2)<<2);YDc(a)}a=f[r>>2]|0;if(a|0){r=f[c>>2]|0;if((r|0)!=(a|0))f[c>>2]=r+(~((r+-8-a|0)>>>3)<<3);YDc(a)}a=f[q>>2]|0;if(a|0){q=f[d>>2]|0;if((q|0)!=(a|0))f[d>>2]=q+(~((q+-8-a|0)>>>3)<<3);YDc(a)}a=o+36|0;q=f[a>>2]|0;if(q|0?(d=q+12|0,q=f[d>>2]|0,f[d>>2]=q+-1,(q|0)==1):0)_S(o);f[a>>2]=0;a=o+16|0;q=o+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){a=f[_>>2]|0;_=0;do{f[a+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[q>>2]|0))}q=f[o+44>>2]|0;if((q|0)!=(o+48|0))g0(q);q=m+36|0;o=f[q>>2]|0;if(o|0?(_=o+12|0,o=f[_>>2]|0,f[_>>2]=o+-1,(o|0)==1):0)_S(m);f[q>>2]=0;q=m+16|0;o=m+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[o>>2]|0)>0){q=f[Z>>2]|0;Z=0;do{f[q+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))g0(o);o=l+36|0;m=f[o>>2]|0;do if(m|0){Z=m+12|0;q=f[Z>>2]|0;f[Z>>2]=q+-1;if((q|0)!=1)break;_S(l)}while(0);f[o>>2]=0;o=l+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[Q>>2]|0)>0){o=f[S>>2]|0;S=0;do{f[o+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[Q>>2]|0))}Q=f[W>>2]|0;if((Q|0)==(V|0)){u=j;return}g0(Q);u=j;return}function oEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=b+-8-g|0;a=g;g=h;while(1){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];a=a+8|0;if((a|0)==(b|0))break;else g=g+8|0}f[c>>2]=h+((d>>>3)+1<<3);return}function pEa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0;h=u;u=u+608|0;i=h+104|0;j=h+56|0;k=h;l=h+552|0;m=h+496|0;o=h+440|0;q=h+424|0;r=h+408|0;s=h+392|0;if(!(f[e>>2]&16384)){f[i>>2]=0;f[i+4>>2]=0;t=tT(i,16)|0;v=374324;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,i,374341,372908,1405)}if(g){XIc(i|0,0,288)|0;t=j;w=t+48|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[k>>2]=1124007942;g=k+4|0;f[g>>2]=2;v=k+8|0;f[v>>2]=6;f[k+12>>2]=6;x=k+16|0;f[x>>2]=i;f[k+20>>2]=i;y=k+24|0;z=k+40|0;A=y+8|0;f[A>>2]=0;f[A+4>>2]=0;f[z>>2]=v;v=k+48|0;A=k+44|0;f[A>>2]=v;f[v>>2]=48;f[k+52>>2]=8;f[k+28>>2]=i+288;f[y>>2]=i+288;WS(k);f[l>>2]=1124007942;y=l+4|0;f[y>>2]=2;B=l+8|0;f[B>>2]=6;f[l+12>>2]=1;C=l+16|0;f[C>>2]=j;f[l+20>>2]=j;D=l+24|0;E=l+40|0;F=D+8|0;f[F>>2]=0;f[F+4>>2]=0;f[E>>2]=B;B=l+48|0;F=l+44|0;f[F>>2]=B;f[B>>2]=8;f[l+52>>2]=8;f[l+28>>2]=j+48;f[D>>2]=j+48;WS(l);lT(m,e,1,6);if((d|0)>0){D=f[a>>2]|0;G=i+8|0;H=i+16|0;I=i+56|0;J=i+64|0;K=f[c>>2]|0;L=j+8|0;M=j+16|0;N=j+24|0;O=j+32|0;P=j+40|0;Q=0;R=+p[M>>3];S=+p[N>>3];T=+p[O>>3];U=+p[P>>3];V=+p[i>>3];W=+p[G>>3];X=+p[H>>3];Y=+p[I>>3];Z=+p[J>>3];_=+p[j>>3];$=+p[L>>3];do{aa=+n[D+(Q<<3)>>2];V=V+aa*aa;ba=+n[D+(Q<<3)+4>>2];W=W+ba*aa;X=X+aa;Y=Y+ba*ba;Z=Z+ba;ca=+n[K+(Q<<3)>>2];_=_+aa*ca;$=$+ba*ca;R=R+ca;ca=+n[K+(Q<<3)+4>>2];S=S+aa*ca;T=T+ba*ca;U=U+ca;Q=Q+1|0}while((Q|0)!=(d|0));p[i>>3]=V;p[G>>3]=W;p[H>>3]=X;p[I>>3]=Y;p[J>>3]=Z;p[j>>3]=_;p[L>>3]=$;p[M>>3]=R;p[N>>3]=S;p[O>>3]=T;p[P>>3]=U;da=W;ea=X;fa=Z;ga=V;ha=Y}else{da=+p[i+8>>3];ea=+p[i+16>>3];fa=+p[i+64>>3];ga=+p[i>>3];ha=+p[i+56>>3]}p[i+48>>3]=da;p[i+216>>3]=da;p[i+176>>3]=da;p[i+96>>3]=ea;p[i+264>>3]=ea;p[i+184>>3]=ea;p[i+104>>3]=fa;p[i+272>>3]=fa;p[i+232>>3]=fa;p[i+168>>3]=ga;p[i+224>>3]=ha;ha=+(d|0);p[i+112>>3]=ha;p[i+280>>3]=ha;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;P=r+8|0;f[P>>2]=0;f[P+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;oQ(o,q,r,2)|0;P=m+36|0;O=f[P>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)_S(m);f[P>>2]=0;P=m+16|0;O=m+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[O>>2]|0)>0){P=f[m+40>>2]|0;N=0;do{f[P+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[O>>2]|0))}O=f[m+44>>2]|0;if((O|0)!=(m+48|0))g0(O);O=l+36|0;N=f[O>>2]|0;if(N|0?(P=N+12|0,N=f[P>>2]|0,f[P>>2]=N+-1,(N|0)==1):0)_S(l);f[O>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[y>>2]|0)>0){C=f[E>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[y>>2]|0))}y=f[F>>2]|0;if((y|0)!=(B|0))g0(y);y=k+36|0;B=f[y>>2]|0;if(B|0?(F=B+12|0,B=f[F>>2]|0,f[F>>2]=B+-1,(B|0)==1):0)_S(k);f[y>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[g>>2]|0)>0){x=f[z>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[g>>2]|0))}g=f[A>>2]|0;if((g|0)!=(v|0))g0(g);u=h;return}else{t=i;w=t+128|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[l>>2]=1124007942;t=l+4|0;f[t>>2]=2;w=l+8|0;f[w>>2]=4;f[l+12>>2]=4;g=l+16|0;f[g>>2]=i;f[l+20>>2]=i;v=l+24|0;A=l+40|0;z=v+8|0;f[z>>2]=0;f[z+4>>2]=0;f[A>>2]=w;w=l+48|0;z=l+44|0;f[z>>2]=w;f[w>>2]=32;f[l+52>>2]=8;f[l+28>>2]=i+128;f[v>>2]=i+128;WS(l);f[m>>2]=1124007942;v=m+4|0;f[v>>2]=2;x=m+8|0;f[x>>2]=4;f[m+12>>2]=1;y=m+16|0;f[y>>2]=j;f[m+20>>2]=j;B=m+24|0;F=m+40|0;E=B+8|0;f[E>>2]=0;f[E+4>>2]=0;f[F>>2]=x;x=m+48|0;E=m+44|0;f[E>>2]=x;f[x>>2]=8;f[m+52>>2]=8;f[m+28>>2]=j+32;f[B>>2]=j+32;WS(m);f[o>>2]=1124007942;B=o+4|0;f[B>>2]=2;C=o+8|0;f[C>>2]=4;f[o+12>>2]=1;O=o+16|0;f[O>>2]=k;f[o+20>>2]=k;N=o+24|0;P=o+40|0;M=N+8|0;f[M>>2]=0;f[M+4>>2]=0;f[P>>2]=C;C=o+48|0;M=o+44|0;f[M>>2]=C;f[C>>2]=8;f[o+52>>2]=8;f[o+28>>2]=k+32;f[N>>2]=k+32;WS(o);if((d|0)>0){N=f[a>>2]|0;a=i+16|0;L=i+24|0;J=f[c>>2]|0;c=j+8|0;I=j+16|0;H=j+24|0;G=0;ha=+p[i>>3];ga=+p[a>>3];fa=+p[L>>3];ea=+p[j>>3];da=+p[c>>3];Y=+p[I>>3];V=+p[H>>3];do{Z=+n[N+(G<<3)>>2];X=+n[N+(G<<3)+4>>2];ha=ha+(Z*Z+X*X);ga=ga+Z;fa=fa+X;W=+n[J+(G<<3)>>2];U=+n[J+(G<<3)+4>>2];ea=ea+(Z*W+X*U);da=da+(Z*U-X*W);Y=Y+W;V=V+U;G=G+1|0}while((G|0)!=(d|0));p[i>>3]=ha;p[a>>3]=ga;p[L>>3]=fa;p[j>>3]=ea;p[c>>3]=da;p[I>>3]=Y;p[H>>3]=V;ia=ha;ja=fa;ka=ga}else{ia=+p[i>>3];ja=+p[i+24>>3];ka=+p[i+16>>3]}p[i+40>>3]=ia;ia=-ja;p[i+48>>3]=ia;p[i+72>>3]=ia;p[i+64>>3]=ka;p[i+56>>3]=ka;p[i+104>>3]=ka;ka=+(d|0);p[i+120>>3]=ka;p[i+80>>3]=ka;p[i+96>>3]=ja;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;i=s+8|0;f[i>>2]=0;f[i+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;oQ(q,r,s,2)|0;s=f[e+16>>2]|0;ja=+p[k>>3];p[s+32>>3]=ja;p[s>>3]=ja;e=k+8|0;p[s+8>>3]=-+p[e>>3];p[s+24>>3]=+p[e>>3];p[s+16>>3]=+p[k+16>>3];p[s+40>>3]=+p[k+24>>3];k=o+36|0;s=f[k>>2]|0;if(s|0?(e=s+12|0,s=f[e>>2]|0,f[e>>2]=s+-1,(s|0)==1):0)_S(o);f[k>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[B>>2]|0)>0){O=f[P>>2]|0;P=0;do{f[O+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[B>>2]|0))}B=f[M>>2]|0;if((B|0)!=(C|0))g0(B);B=m+36|0;C=f[B>>2]|0;if(C|0?(M=C+12|0,C=f[M>>2]|0,f[M>>2]=C+-1,(C|0)==1):0)_S(m);f[B>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[v>>2]|0)>0){y=f[F>>2]|0;F=0;do{f[y+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[v>>2]|0))}v=f[E>>2]|0;if((v|0)!=(x|0))g0(v);v=l+36|0;x=f[v>>2]|0;if(x|0?(E=x+12|0,x=f[E>>2]|0,f[E>>2]=x+-1,(x|0)==1):0)_S(l);f[v>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[t>>2]|0)>0){g=f[A>>2]|0;A=0;do{f[g+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[t>>2]|0))}t=f[z>>2]|0;if((t|0)!=(w|0))g0(t);u=h;return}}function qEa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;var m=0;m=VDc(48)|0;r0(m);f[m>>2]=77456;f[m+4>>2]=g;p[m+8>>3]=e;b[m+16>>0]=0;f[m+20>>2]=h;f[m+24>>2]=i;f[m+28>>2]=j;p[m+32>>3]=k;f[m+40>>2]=l;l=VDc(16)|0;j=l+4|0;f[j>>2]=1;f[l>>2]=77568;f[l+8>>2]=m;f[j>>2]=(f[j>>2]|0)+1;i=f[j>>2]|0;f[j>>2]=i+-1;if((i|0)==1)Yi[f[(f[l>>2]|0)+8>>2]&2047](l);ei[f[(f[m>>2]|0)+32>>2]&511](m,a,c,d);d=f[j>>2]|0;f[j>>2]=d+-1;if((d|0)!=1)return;Yi[f[(f[l>>2]|0)+8>>2]&2047](l);return}function rEa(a){a=a|0;YDc(a);return}function sEa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tEa(a){a=a|0;j0(a);YDc(a);return}function uEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0.0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0.0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0.0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0.0,ud=0.0,vd=0.0,wd=0,xd=0.0,yd=0.0,zd=0.0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0,Vd=0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0.0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0.0,ge=0,he=0,ie=0,je=0,ke=0;g=u;u=u+7024|0;h=g+2128|0;i=g+5960|0;j=g+1064|0;k=g;l=g+4896|0;m=g+3824|0;o=g+3752|0;q=g+3696|0;r=g+3688|0;s=g+3624|0;t=g+3560|0;v=g+3504|0;w=g+4888|0;x=g+3448|0;y=g+3816|0;z=g+3808|0;A=g+3336|0;B=g+3280|0;C=g+3224|0;D=g+3680|0;E=g+3616|0;do if((d$(c)|0)==65536){F=f[c+4>>2]|0;f[o>>2]=f[F>>2];G=o+4|0;H=F+4|0;f[G>>2]=f[H>>2];I=o+8|0;f[I>>2]=f[F+8>>2];f[o+12>>2]=f[F+12>>2];f[o+16>>2]=f[F+16>>2];f[o+20>>2]=f[F+20>>2];f[o+24>>2]=f[F+24>>2];f[o+28>>2]=f[F+28>>2];f[o+32>>2]=f[F+32>>2];J=f[F+36>>2]|0;f[o+36>>2]=J;f[o+40>>2]=I;I=o+48|0;K=o+44|0;f[K>>2]=I;f[I>>2]=0;f[o+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[F+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;ZS(o,F);break}}else a$(o,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[q>>2]=f[c>>2];F=q+4|0;G=c+4|0;f[F>>2]=f[G>>2];H=q+8|0;f[H>>2]=f[c+8>>2];f[q+12>>2]=f[c+12>>2];f[q+16>>2]=f[c+16>>2];f[q+20>>2]=f[c+20>>2];f[q+24>>2]=f[c+24>>2];f[q+28>>2]=f[c+28>>2];f[q+32>>2]=f[c+32>>2];I=f[c+36>>2]|0;f[q+36>>2]=I;K=q+40|0;f[K>>2]=H;H=q+48|0;J=q+44|0;f[J>>2]=H;f[H>>2]=0;f[q+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[c+44>>2]|0;H=f[J>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];L=K;break}else{f[F>>2]=0;ZS(q,c);L=K;break}}else{a$(q,d,-1);L=q+40|0}while(0);f[r>>2]=o;f[r+4>>2]=q;f[s>>2]=1124007936;d=s+4|0;K=s+8|0;c=s+40|0;F=d;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[c>>2]=K;H=s+48|0;J=s+44|0;f[J>>2]=H;f[H>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;I=t+4|0;M=t+8|0;N=t+40|0;F=I;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[N>>2]=M;O=t+48|0;P=t+44|0;f[P>>2]=O;f[O>>2]=0;f[t+52>>2]=0;f[v>>2]=1124007936;Q=v+4|0;R=v+8|0;S=v+40|0;F=Q;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[S>>2]=R;R=v+48|0;T=v+44|0;f[T>>2]=R;f[R>>2]=0;f[v+52>>2]=0;U=f[a+4>>2]|0;W=o+40|0;X=f[W>>2]|0;Z=f[X+4>>2]|0;_=f[X>>2]|0;X=f[L>>2]|0;if(!((_|0)==(f[X>>2]|0)?(Z|0)==(f[X+4>>2]|0):0)){f[h>>2]=0;$=h+4|0;f[$>>2]=0;aa=tT(h,110)|0;F=aa;ba=374451;G=F+110|0;do{b[F>>0]=b[ba>>0]|0;F=F+1|0;ba=ba+1|0}while((F|0)<(G|0));MEa(h,374562,1114)}X=(f[o>>2]|0)>>>3&511;if(!((X|0)==0?(X|0)==((f[q>>2]|0)>>>3&511|0):0)){f[h>>2]=0;$=h+4|0;f[$>>2]=0;aa=tT(h,110)|0;F=aa;ba=374451;G=F+110|0;do{b[F>>0]=b[ba>>0]|0;F=F+1|0;ba=ba+1|0}while((F|0)<(G|0));MEa(h,374562,1114)}X=a+8|0;if(!(+p[X>>3]<1.0)){f[h>>2]=0;$=h+4|0;f[$>>2]=0;aa=tT(h,110)|0;F=aa;ba=374451;G=F+110|0;do{b[F>>0]=b[ba>>0]|0;F=F+1|0;ba=ba+1|0}while((F|0)<(G|0));MEa(h,374562,1114)}f[w>>2]=Z;f[w+4>>2]=_;v$(e,w,13,-1,0,0);do if((d$(e)|0)==65536){w=f[e+4>>2]|0;f[x>>2]=f[w>>2];_=x+4|0;Z=w+4|0;f[_>>2]=f[Z>>2];aa=x+8|0;f[aa>>2]=f[w+8>>2];f[x+12>>2]=f[w+12>>2];f[x+16>>2]=f[w+16>>2];f[x+20>>2]=f[w+20>>2];f[x+24>>2]=f[w+24>>2];f[x+28>>2]=f[w+28>>2];f[x+32>>2]=f[w+32>>2];$=f[w+36>>2]|0;f[x+36>>2]=$;f[x+40>>2]=aa;aa=x+48|0;ca=x+44|0;f[ca>>2]=aa;f[aa>>2]=0;f[x+52>>2]=0;if($|0){aa=$+12|0;f[aa>>2]=(f[aa>>2]|0)+1}if((f[Z>>2]|0)<3){Z=f[w+44>>2]|0;aa=f[ca>>2]|0;f[aa>>2]=f[Z>>2];f[aa+4>>2]=f[Z+4>>2];break}else{f[_>>2]=0;ZS(x,w);break}}else a$(x,e,-1);while(0);if((U|0)>0){da=+p[X>>3];ea=+(f[o+12>>2]|0);fa=+(f[o+8>>2]|0);ga=1.0;e=0;while(1){ga=ga*da;if(ga*ea<32.0|ga*fa<32.0){ha=e;break}w=e+1|0;if((w|0)>=(U|0)){ha=w;break}else e=w}if((ha|0)>-1){ia=ha;ja=30}else ka=x+36|0}else{ia=0;ja=30}a:do if((ja|0)==30){ha=o+12|0;e=o+8|0;U=t+12|0;w=t+16|0;_=i+4|0;Z=s+16|0;aa=a+40|0;ca=h+8|0;$=h+12|0;la=h+4|0;ma=i+8|0;na=i+4|0;oa=y+4|0;pa=h+8|0;qa=h+4|0;ra=B+4|0;sa=B+8|0;ta=B+40|0;ua=B+48|0;va=B+44|0;wa=B+52|0;xa=C+4|0;ya=C+8|0;za=C+40|0;Aa=C+48|0;Ba=C+44|0;Ca=C+52|0;Da=h+8|0;Ea=h+4|0;Fa=h+8|0;Ga=h+12|0;Ha=h+4|0;Ia=i+8|0;Ja=i+4|0;Ka=D+4|0;La=h+8|0;Ma=h+12|0;Na=h+4|0;Oa=i+8|0;Pa=i+4|0;Qa=E+4|0;Ra=a+28|0;Sa=a+32|0;Ta=B+12|0;Ua=l+8|0;Va=l+4|0;Wa=m+8|0;Xa=m+4|0;Ya=h+4|0;Za=h+8|0;_a=h+40|0;$a=h+48|0;ab=h+44|0;bb=h+52|0;cb=i+8|0;db=i+12|0;eb=i+4|0;fb=h+16|0;gb=i+16|0;hb=i+44|0;ib=i+36|0;jb=i+4|0;kb=i+40|0;lb=i+48|0;mb=h+36|0;nb=B+16|0;ob=A+56|0;pb=a+24|0;qb=t+36|0;rb=s+36|0;sb=s+12|0;tb=t+20|0;ub=s+20|0;vb=t+24|0;wb=s+24|0;xb=t+28|0;yb=s+28|0;zb=t+32|0;Ab=s+32|0;Bb=C+36|0;Cb=C+16|0;Db=B+36|0;Eb=a+20|0;Fb=h+8|0;Gb=h+4|0;Hb=h+8|0;Ib=h+4|0;Jb=i+8|0;Kb=i+4|0;Lb=Jb;Mb=j+8|0;Nb=j+4|0;Ob=k+8|0;Pb=k+4|0;Qb=h+8|0;Rb=h+12|0;Sb=h+4|0;Tb=i+8|0;Ub=i+4|0;Vb=z+4|0;Wb=h+8|0;Xb=h+4|0;Yb=x+36|0;Zb=x+4|0;_b=x+8|0;$b=x+12|0;ac=x+44|0;bc=x+16|0;cc=x+20|0;dc=x+24|0;ec=x+28|0;fc=x+32|0;gc=A+4|0;hc=A+8|0;ic=A+40|0;jc=A+48|0;kc=A+44|0;lc=A+52|0;mc=A+56|0;nc=A+60|0;oc=A+64|0;pc=A+96|0;qc=A+104|0;rc=A+100|0;sc=A+108|0;tc=A+56|0;uc=A+92|0;vc=A+72|0;wc=A+60|0;xc=A+96|0;yc=A+100|0;zc=A+104|0;Ac=A+36|0;Bc=A+16|0;Cc=A+4|0;Dc=A+40|0;Ec=A+44|0;Fc=A+48|0;Gc=ia;b:while(1){Hc=(Gc|0)>0;if(Hc){fa=+p[X>>3];Ic=0;ga=1.0;while(1){ea=ga*fa;Ic=Ic+1|0;if((Ic|0)==(Gc|0)){Jc=ea;break}else ga=ea}}else Jc=1.0;ga=(1.0/Jc+-1.0)*.5;Ic=nrc(ga*5.0)|0|1;Kc=(Ic|0)>3?Ic:3;Ic=nrc(Jc*+(f[ha>>2]|0))|0;Lc=nrc(Jc*+(f[e>>2]|0))|0;do if(Hc){if(((f[I>>2]|0)<3?(f[M>>2]|0)==(Lc|0):0)&(f[U>>2]|0)==(Ic|0)?!((f[w>>2]|0)==0?1:(f[t>>2]&4095|0)!=13):0)break;f[i>>2]=Lc;f[_>>2]=Ic;XS(t,2,i,13)}else{Mc=f[Yb>>2]|0;if(Mc|0){Nc=Mc+12|0;f[Nc>>2]=(f[Nc>>2]|0)+1}Nc=f[qb>>2]|0;if(Nc|0?(Mc=Nc+12|0,Nc=f[Mc>>2]|0,f[Mc>>2]=Nc+-1,(Nc|0)==1):0)_S(t);f[qb>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[I>>2]|0)>0){Nc=f[N>>2]|0;Mc=0;do{f[Nc+(Mc<<2)>>2]=0;Mc=Mc+1|0;Oc=f[I>>2]|0}while((Mc|0)<(Oc|0));f[t>>2]=f[x>>2];if((Oc|0)<3)ja=50;else ja=52}else{f[t>>2]=f[x>>2];ja=50}if((ja|0)==50){ja=0;Mc=f[Zb>>2]|0;if((Mc|0)<3){f[I>>2]=Mc;f[M>>2]=f[_b>>2];f[U>>2]=f[$b>>2];Mc=f[ac>>2]|0;Nc=f[P>>2]|0;f[Nc>>2]=f[Mc>>2];f[Nc+4>>2]=f[Mc+4>>2]}else ja=52}if((ja|0)==52){ja=0;ZS(t,x)}f[w>>2]=f[bc>>2];f[tb>>2]=f[cc>>2];f[vb>>2]=f[dc>>2];f[xb>>2]=f[ec>>2];f[zb>>2]=f[fc>>2];f[qb>>2]=f[Yb>>2]}while(0);if(f[Z>>2]|0){Mc=f[d>>2]|0;if((Mc|0)<3)Pc=Y(f[sb>>2]|0,f[K>>2]|0)|0;else{Nc=f[c>>2]|0;Qc=0;Rc=1;while(1){Sc=Y(f[Nc+(Qc<<2)>>2]|0,Rc)|0;Qc=Qc+1|0;if((Qc|0)==(Mc|0)){Pc=Sc;break}else Rc=Sc}}if(!((Mc|0)==0|(Pc|0)==0)){f[Qb>>2]=0;f[Rb>>2]=0;f[h>>2]=16842752;f[Sb>>2]=s;Rc=Tb;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Ub>>2]=t;f[z>>2]=Ic;f[Vb>>2]=Lc;nfa(h,i,z,0.0,0.0,1);fa=1.0/+p[X>>3];Rc=Wb;f[Rc>>2]=0;f[Rc+4>>2]=0;f[h>>2]=33619968;f[Xb>>2]=t;LZ(t,h,-1,fa,0.0)}else ja=60}else ja=60;do if((ja|0)==60){ja=0;if(!(f[aa>>2]&4)){AY(h,Lc,Ic,13);Rc=f[h>>2]|0;ei[f[(f[Rc>>2]|0)+12>>2]&511](Rc,h,t,-1);$j(h);break}else{f[ca>>2]=0;f[$>>2]=0;f[h>>2]=16842752;f[la>>2]=x;Rc=ma;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[na>>2]=t;f[y>>2]=Ic;f[oa>>2]=Lc;nfa(h,i,y,0.0,0.0,3);Rc=pa;f[Rc>>2]=0;f[Rc+4>>2]=0;f[h>>2]=33619968;f[qa>>2]=t;LZ(t,h,-1,Jc,0.0);break}}while(0);f[A>>2]=1124007936;F=gc;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[ic>>2]=hc;f[kc>>2]=jc;f[jc>>2]=0;f[lc>>2]=0;f[mc>>2]=1124007936;F=nc;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[pc>>2]=oc;f[rc>>2]=qc;f[qc>>2]=0;f[sc>>2]=0;f[B>>2]=1124007936;F=ra;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[ta>>2]=sa;f[va>>2]=ua;f[ua>>2]=0;f[wa>>2]=0;f[C>>2]=1124007936;F=xa;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[za>>2]=ya;f[Ba>>2]=Aa;f[Aa>>2]=0;f[Ca>>2]=0;Mc=0;do{Rc=f[r+(Mc<<2)>>2]|0;Qc=Da;f[Qc>>2]=0;f[Qc+4>>2]=0;f[h>>2]=33619968;f[Ea>>2]=v;LZ(Rc,h,5,1.0,0.0);f[Fa>>2]=0;f[Ga>>2]=0;f[h>>2]=16842752;f[Ha>>2]=v;Rc=Ia;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Ja>>2]=v;f[D>>2]=Kc;f[Ka>>2]=Kc;Gfa(h,i,D,ga,ga,4);f[La>>2]=0;f[Ma>>2]=0;f[h>>2]=16842752;f[Na>>2]=v;Rc=Oa;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Pa>>2]=B;f[E>>2]=Ic;f[Qa>>2]=Lc;nfa(h,i,E,1.0,0.0,1);Rc=A+(Mc*56|0)|0;Qc=f[Ra>>2]|0;fa=+p[Sa>>3];if((f[B>>2]&4095|0)!=5)break b;Nc=f[Ta>>2]|0;Sc=f[sa>>2]|0;Tc=(Qc*6|0)+3|0;f[l>>2]=Ua;f[Va>>2]=Tc;if(Tc>>>0>264){Uc=XDc(Tc>>>0>1073741823?-1:Tc<<2)|0;f[l>>2]=Uc;Vc=Uc}else Vc=Ua;Uc=Qc<<1;Tc=(Nc+Uc|0)*3|0;f[m>>2]=Wa;f[Xa>>2]=Tc;if(Tc>>>0>264){Wc=XDc(Tc>>>0>1073741823?-1:Tc<<2)|0;f[m>>2]=Wc;Xc=Wc}else Xc=Wa;Wc=Vc+(Qc<<2)|0;Tc=Wc+(Uc<<2)+4|0;Yc=Tc+(Uc<<2)+4|0;Uc=Qc*3|0;Zc=Xc+(Uc<<2)|0;ea=fa<1.1920928955078125e-07?+(Qc|0)*.3:fa;_c=0-Qc|0;$c=(Qc|0)<(_c|0);if(!$c){fa=ea*(ea*2.0);ad=_c;ea=0.0;while(1){da=+V(+(+(Y(ad,0-ad|0)|0)/fa));n[Wc+(ad<<2)>>2]=da;ea=ea+da;if((ad|0)>=(Qc|0))break;else ad=ad+1|0}fa=1.0/ea;ad=_c;while(1){bd=Wc+(ad<<2)|0;da=fa*+n[bd>>2];n[bd>>2]=da;n[Tc+(ad<<2)>>2]=+(ad|0)*da;cd=+(Y(ad,ad)|0)*da;n[Yc+(ad<<2)>>2]=cd;if((ad|0)<(Qc|0))ad=ad+1|0;else break}}f[h>>2]=1124007936;F=Ya;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[_a>>2]=Za;f[ab>>2]=$a;f[$a>>2]=0;f[bb>>2]=0;f[i>>2]=6;f[_>>2]=6;XS(h,2,i,6);p[j>>3]=0.0;f[i>>2]=-1056833530;f[eb>>2]=j;f[cb>>2]=1;f[db>>2]=1;l_(h,i,e0()|0)|0;if($c){ad=f[fb>>2]|0;dd=ad;ed=ad}else{ad=f[fb>>2]|0;bd=f[f[ab>>2]>>2]|0;fd=ad+bd+8|0;gd=ad+(bd*3|0)+24|0;hd=ad+(bd*5|0)+40|0;bd=_c;while(1){fa=+n[Wc+(bd<<2)>>2];ea=+(bd|0);id=_c;while(1){cd=fa*+n[Wc+(id<<2)>>2];p[ad>>3]=+p[ad>>3]+cd;da=+(id|0);jd=da*(da*cd);p[fd>>3]=+p[fd>>3]+jd;p[gd>>3]=+p[gd>>3]+da*(da*jd);p[hd>>3]=ea*(ea*jd)+ +p[hd>>3];if((id|0)<(Qc|0))id=id+1|0;else break}if((bd|0)<(Qc|0))bd=bd+1|0;else{dd=ad;ed=ad;break}}}ad=f[f[ab>>2]>>2]|0;ea=+p[dd+ad+8>>3];bd=dd+(ad<<2)|0;p[bd>>3]=ea;hd=dd+(ad*3|0)|0;p[hd>>3]=ea;p[ed+32>>3]=ea;p[ed+24>>3]=ea;p[ed+(ad<<1)+16>>3]=ea;p[bd+32>>3]=+p[hd+24>>3];ea=+p[dd+(ad*5|0)+40>>3];p[bd+24>>3]=ea;p[hd+32>>3]=ea;yY(k,h,3);Hpa(i,k);$j(k);hd=f[gb>>2]|0;bd=f[f[hb>>2]>>2]|0;ea=+p[hd+bd+8>>3];fa=+p[hd+24>>3];jd=+p[hd+(bd*3|0)+24>>3];da=+p[hd+(bd*5|0)+40>>3];bd=f[ib>>2]|0;do if(bd|0){hd=bd+12|0;ad=f[hd>>2]|0;f[hd>>2]=ad+-1;if((ad|0)!=1)break;_S(i)}while(0);f[ib>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[jb>>2]|0)>0){bd=f[kb>>2]|0;ad=0;do{f[bd+(ad<<2)>>2]=0;ad=ad+1|0}while((ad|0)<(f[jb>>2]|0))}ad=f[hb>>2]|0;if((ad|0)!=(lb|0))g0(ad);ad=f[mb>>2]|0;do if(ad|0){bd=ad+12|0;hd=f[bd>>2]|0;f[bd>>2]=hd+-1;if((hd|0)!=1)break;_S(h)}while(0);f[mb>>2]=0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[Ya>>2]|0)>0){ad=f[_a>>2]|0;hd=0;do{f[ad+(hd<<2)>>2]=0;hd=hd+1|0}while((hd|0)<(f[Ya>>2]|0))}hd=f[ab>>2]|0;if((hd|0)!=($a|0))g0(hd);do if((f[A+(Mc*56|0)+4>>2]|0)<3){if((f[A+(Mc*56|0)+8>>2]|0)!=(Sc|0)){ja=103;break}if((f[A+(Mc*56|0)+12>>2]|0)!=(Nc|0)){ja=103;break}if((f[Rc>>2]&4095|0)!=37){ja=103;break}if(!(f[A+(Mc*56|0)+16>>2]|0))ja=103}else ja=103;while(0);if((ja|0)==103){ja=0;f[i>>2]=Sc;f[_>>2]=Nc;XS(Rc,2,i,37)}if((Sc|0)>0){hd=f[nb>>2]|0;ad=f[f[va>>2]>>2]|0;bd=f[A+(Mc*56|0)+16>>2]|0;gd=f[f[A+(Mc*56|0)+44>>2]>>2]|0;fd=(Nc|0)>0;_c=(Qc|0)<1;$c=(Qc|0)>0;id=Nc*3|0;kd=Sc+-1|0;ld=Qc+1|0;md=_c|fd^1;nd=0;do{cd=+n[Wc>>2];od=hd+(Y(nd,ad)|0)|0;pd=bd+(Y(nd,gd)|0)|0;do if(fd){qd=0;do{rd=qd*3|0;n[Zc+(rd<<2)>>2]=cd*+n[od+(qd<<2)>>2];n[Zc+(rd+2<<2)>>2]=0.0;n[Zc+(rd+1<<2)>>2]=0.0;qd=qd+1|0}while((qd|0)!=(Nc|0));if(md)break;else sd=1;do{td=+n[Wc+(sd<<2)>>2];ud=+n[Tc+(sd<<2)>>2];vd=+n[Yc+(sd<<2)>>2];qd=nd-sd|0;rd=hd+(Y((qd|0)>0?qd:0,ad)|0)|0;qd=sd+nd|0;wd=hd+(Y((kd|0)<(qd|0)?kd:qd,ad)|0)|0;qd=0;do{xd=+n[rd+(qd<<2)>>2];yd=+n[wd+(qd<<2)>>2];zd=xd+yd;Ad=qd*3|0;Bd=Zc+(Ad<<2)|0;Cd=Zc+(Ad+1<<2)|0;Dd=+n[Cd>>2]+ud*(yd-xd);Ed=Zc+(Ad+2<<2)|0;xd=vd*zd+ +n[Ed>>2];n[Bd>>2]=+n[Bd>>2]+td*zd;n[Cd>>2]=Dd;n[Ed>>2]=xd;qd=qd+1|0}while((qd|0)!=(Nc|0));sd=sd+1|0}while((sd|0)!=(ld|0))}while(0);if($c){od=0;do{f[Zc+(~od<<2)>>2]=f[Zc+(2-od<<2)>>2];qd=od+id|0;f[Zc+(qd<<2)>>2]=f[Zc+(qd+-3<<2)>>2];od=od+1|0}while((od|0)<(Uc|0))}c:do if(fd){od=0;td=cd;while(1){qd=od*3|0;vd=td*+n[Zc+(qd<<2)>>2];ud=td*+n[Zc+(qd+1<<2)>>2];xd=td*+n[Zc+(qd+2<<2)>>2];if(_c){Fd=0.0;Gd=xd;Hd=0.0;Id=ud;Jd=0.0;Kd=vd}else{Dd=0.0;zd=xd;xd=0.0;yd=ud;ud=0.0;Ld=vd;qd=1;while(1){wd=(qd+od|0)*3|0;vd=+n[Zc+(wd<<2)>>2];rd=(od-qd|0)*3|0;Md=+n[Zc+(rd<<2)>>2];Nd=vd+Md;Od=+n[Wc+(qd<<2)>>2];Pd=Ld+Nd*Od;Qd=xd+Nd*+n[Yc+(qd<<2)>>2];Nd=+n[Tc+(qd<<2)>>2];Rd=ud+(vd-Md)*Nd;Md=+n[Zc+(wd+1<<2)>>2];vd=+n[Zc+(rd+1<<2)>>2];Sd=yd+Od*(Md+vd);Td=Dd+Nd*(Md-vd);vd=zd+Od*(+n[Zc+(wd+2<<2)>>2]+ +n[Zc+(rd+2<<2)>>2]);qd=qd+1|0;if((qd|0)==(ld|0)){Fd=Td;Gd=vd;Hd=Qd;Id=Sd;Jd=Rd;Kd=Pd;break}else{Dd=Td;zd=vd;xd=Qd;yd=Sd;ud=Rd;Ld=Pd}}}qd=od*5|0;n[pd+(qd+1<<2)>>2]=ea*Jd;n[pd+(qd<<2)>>2]=ea*Id;Ld=fa*Kd;n[pd+(qd+3<<2)>>2]=Ld+jd*Hd;n[pd+(qd+2<<2)>>2]=Ld+jd*Gd;n[pd+(qd+4<<2)>>2]=da*Fd;qd=od+1|0;if((qd|0)==(Nc|0))break c;od=qd;td=+n[Wc>>2]}}while(0);nd=nd+1|0}while((nd|0)!=(Sc|0))}Sc=f[m>>2]|0;if((Sc|0)!=(Wa|0)){if(Sc|0)ZDc(Sc);f[m>>2]=Wa;f[Xa>>2]=264}Sc=f[l>>2]|0;if((Sc|0)!=(Ua|0)){if(Sc|0)ZDc(Sc);f[l>>2]=Ua;f[Va>>2]=264}Mc=Mc+1|0}while((Mc|0)<2);NEa(A,ob,t,C,0,f[M>>2]|0);Mc=f[pb>>2]|0;if((Mc|0)>0){Lc=0;Ic=Mc;do{Mc=f[Eb>>2]|0;Kc=(Lc|0)<(Ic+-1|0);Sc=f[U>>2]|0;nd=f[M>>2]|0;Wc=(Mc|0)/2|0;Nc=1024/(Sc|0)|0;ld=(Nc|0)<(Mc|0)?Mc:Nc;if(!(f[aa>>2]&256)){ga=1.0/+(Y(Mc,Mc)|0);Nc=(((Wc<<1)+Sc|0)*5|0)+10|0;f[h>>2]=Fb;f[Gb>>2]=Nc;if(Nc>>>0>136){Zc=XDc(Nc>>>0>536870911?-1:Nc<<3)|0;f[h>>2]=Zc;Ud=Zc}else Ud=Fb;Zc=(Wc*5|0)+5|0;Nc=Ud+(Zc<<3)|0;Tc=f[Cb>>2]|0;Yc=Sc*5|0;_c=(Sc|0)>0;if(_c){da=+(Wc+2|0);fd=0;do{p[Nc+(fd<<3)>>3]=da*+n[Tc+(fd<<2)>>2];fd=fd+1|0}while((fd|0)<(Yc|0))}fd=(Mc|0)>3;do if(fd){Uc=nd+-1|0;id=f[f[Ba>>2]>>2]|0;if(_c)Vd=1;else break;do{$c=Tc+(Y((Uc|0)<(Vd|0)?Uc:Vd,id)|0)|0;ad=0;do{kd=Nc+(ad<<3)|0;p[kd>>3]=+p[kd>>3]+ +n[$c+(ad<<2)>>2];ad=ad+1|0}while((ad|0)<(Yc|0));Vd=Vd+1|0}while((Vd|0)<(Wc|0))}while(0);if((nd|0)>0){id=nd+-1|0;Uc=(Zc|0)>0;da=+(Wc+2|0);ad=Nc+8|0;$c=Nc+16|0;kd=Nc+24|0;hd=Nc+32|0;md=0;gd=Tc;bd=0;while(1){Qc=(f[w>>2]|0)+(Y(f[f[P>>2]>>2]|0,bd)|0)|0;Rc=bd-Wc+-1|0;pd=f[f[Ba>>2]>>2]|0;od=gd+(Y(pd,(Rc|0)>0?Rc:0)|0)|0;Rc=bd+Wc|0;qd=gd+(Y(pd,(id|0)<(Rc|0)?id:Rc)|0)|0;if(_c){Rc=0;do{pd=Nc+(Rc<<3)|0;p[pd>>3]=+p[pd>>3]+(+n[qd+(Rc<<2)>>2]-+n[od+(Rc<<2)>>2]);Rc=Rc+1|0}while((Rc|0)<(Yc|0))}if(Uc){Rc=0;do{p[Nc+(~Rc<<3)>>3]=+p[Nc+(4-Rc<<3)>>3];od=Rc+Yc|0;p[Nc+(od<<3)>>3]=+p[Nc+(od+-5<<3)>>3];Rc=Rc+1|0}while((Rc|0)!=(Zc|0))}jd=da*+p[Nc>>3];fa=da*+p[ad>>3];ea=da*+p[$c>>3];cd=da*+p[kd>>3];td=da*+p[hd>>3];if(fd){Ld=jd;ud=fa;yd=ea;xd=td;zd=cd;Rc=1;while(1){od=Rc*5|0;Dd=Ld+ +p[Nc+(od<<3)>>3];Pd=ud+ +p[Nc+(od+1<<3)>>3];Rd=yd+ +p[Nc+(od+2<<3)>>3];Sd=zd+ +p[Nc+(od+3<<3)>>3];Qd=xd+ +p[Nc+(od+4<<3)>>3];Rc=Rc+1|0;if((Rc|0)>=(Wc|0)){Wd=Dd;Xd=Pd;Yd=Rd;Zd=Qd;_d=Sd;break}else{Ld=Dd;ud=Pd;yd=Rd;xd=Qd;zd=Sd}}}else{Wd=jd;Xd=fa;Yd=ea;Zd=td;_d=cd}if(_c){zd=Wd;xd=Xd;yd=Yd;ud=Zd;Ld=_d;Rc=0;do{od=(Rc+Wc|0)*5|0;qd=(Rc-Wc|0)*5|0;zd=zd+(+p[Nc+(od<<3)>>3]-+p[Nc+(qd+-5<<3)>>3]);xd=xd+(+p[Nc+(od+1<<3)>>3]-+p[Nc+(qd+-4<<3)>>3]);yd=yd+(+p[Nc+(od+2<<3)>>3]-+p[Nc+(qd+-3<<3)>>3]);Ld=Ld+(+p[Nc+(od+3<<3)>>3]-+p[Nc+(qd+-2<<3)>>3]);ud=ud+(+p[Nc+(od+4<<3)>>3]-+p[Nc+(qd+-1<<3)>>3]);Sd=ga*zd;Qd=ga*xd;Rd=ga*yd;Pd=ga*Ld;Dd=ga*ud;vd=1.0/(Sd*Rd-Qd*Qd+.001);qd=Rc<<1;n[Qc+(qd<<2)>>2]=vd*(Sd*Dd-Qd*Pd);n[Qc+((qd|1)<<2)>>2]=vd*(Rd*Pd-Qd*Dd);Rc=Rc+1|0}while((Rc|0)!=(Sc|0))}Rc=(bd|0)==(id|0)?nd:bd-Mc|0;do if(Kc){if((Rc|0)!=(nd|0)&(Rc|0)<(md+ld|0)){$d=md;break}NEa(A,ob,t,C,md,Rc);$d=Rc}else $d=md;while(0);Rc=bd+1|0;if((Rc|0)>=(nd|0))break;md=$d;gd=f[Cb>>2]|0;bd=Rc}ae=f[h>>2]|0}else ae=Ud;if((ae|0)!=(Fb|0)){if(ae|0)ZDc(ae);f[h>>2]=Fb;f[Gb>>2]=136}}else{ga=+(Wc|0)*.3;bd=Wc<<1;gd=((bd+Sc|0)*5|0)+26|0;f[h>>2]=Hb;f[Ib>>2]=gd;if(gd>>>0>264){md=XDc(gd>>>0>1073741823?-1:gd<<2)|0;f[h>>2]=md;be=md}else be=Hb;md=Sc*5|0;gd=md+16|0;f[i>>2]=Jb;f[Kb>>2]=gd;if(gd>>>0>264){id=XDc(gd>>>0>1073741823?-1:gd<<2)|0;f[i>>2]=id;ce=id}else ce=Lb;id=Wc*5|0;gd=id+21|0;f[j>>2]=Mb;f[Nb>>2]=gd;if(gd>>>0>264){Nc=XDc(gd>>>0>1073741823?-1:gd<<2)|0;f[j>>2]=Nc;de=Nc}else de=Mb;Nc=bd|1;f[k>>2]=Ob;f[Pb>>2]=Nc;if(Nc>>>0>264){bd=XDc(Nc>>>0>1073741823?-1:Nc<<2)|0;f[k>>2]=bd;ee=bd}else ee=Ob;bd=be+(id+5<<2)+15&-16;Nc=ce+15&-16;n[de>>2]=1.0;gd=(Mc|0)<2;if(gd)fe=1.0;else{da=ga*(ga*2.0);_c=1;ga=1.0;while(1){ud=+V(+(+(Y(_c,0-_c|0)|0)/da));n[de+(_c<<2)>>2]=ud;Ld=ga+ud*2.0;if((_c|0)<(Wc|0)){_c=_c+1|0;ga=Ld}else{fe=Ld;break}}}ga=1.0/fe;_c=(Mc|0)<-1;if(!_c){fd=0;while(1){hd=de+(fd<<2)|0;n[hd>>2]=ga*+n[hd>>2];if((fd|0)<(Wc|0))fd=fd+1|0;else break}}if((nd|0)>0){fd=(Sc|0)>0;hd=ee+(Wc<<2)|0;kd=(id|0)>0;$c=nd+-1|0;ad=0;Zc=0;while(1){Yc=(f[w>>2]|0)+(Y(f[f[P>>2]>>2]|0,ad)|0)|0;if(!_c){Uc=f[Cb>>2]|0;Tc=f[f[Ba>>2]>>2]|0;Rc=0;while(1){Qc=ad-Rc|0;qd=Uc+(Y((Qc|0)>0?Qc:0,Tc)|0)|0;f[ee+(Wc-Rc<<2)>>2]=qd;qd=Rc+ad|0;Qc=Uc+(Y(($c|0)<(qd|0)?$c:qd,Tc)|0)|0;f[ee+(Rc+Wc<<2)>>2]=Qc;if((Wc|0)>(Rc|0))Rc=Rc+1|0;else break}}d:do if(fd){Rc=f[hd>>2]|0;if(gd){Tc=0;while(1){n[bd+(Tc<<2)>>2]=+n[Rc+(Tc<<2)>>2]*+n[de>>2];Tc=Tc+1|0;if((Tc|0)>=(md|0))break d}}else ge=0;do{ga=+n[Rc+(ge<<2)>>2]*+n[de>>2];Tc=1;while(1){ga=ga+(+n[(f[ee+(Tc+Wc<<2)>>2]|0)+(ge<<2)>>2]+ +n[(f[ee+(Wc-Tc<<2)>>2]|0)+(ge<<2)>>2])*+n[de+(Tc<<2)>>2];if((Wc|0)<=(Tc|0))break;else Tc=Tc+1|0}n[bd+(ge<<2)>>2]=ga;ge=ge+1|0}while((ge|0)<(md|0))}while(0);if(kd){Rc=0;do{f[bd+(~Rc<<2)>>2]=f[bd+(4-Rc<<2)>>2];Tc=Rc+md|0;f[bd+(Tc<<2)>>2]=f[bd+(Tc+-5<<2)>>2];Rc=Rc+1|0}while((Rc|0)!=(id|0))}if(fd){if(gd){Rc=0;do{n[Nc+(Rc<<2)>>2]=+n[bd+(Rc<<2)>>2]*+n[de>>2];Rc=Rc+1|0}while((Rc|0)<(md|0));he=0}else{Rc=0;do{da=+n[bd+(Rc<<2)>>2]*+n[de>>2];Tc=1;while(1){Uc=Tc*5|0;da=da+ +n[de+(Tc<<2)>>2]*(+n[bd+(Rc-Uc<<2)>>2]+ +n[bd+(Uc+Rc<<2)>>2]);if((Tc|0)>=(Wc|0))break;else Tc=Tc+1|0}n[Nc+(Rc<<2)>>2]=da;Rc=Rc+1|0}while((Rc|0)<(md|0));he=0}do{Rc=he*5|0;Ld=+n[Nc+(Rc<<2)>>2];ud=+n[Nc+(Rc+1<<2)>>2];yd=+n[Nc+(Rc+2<<2)>>2];xd=+n[Nc+(Rc+3<<2)>>2];zd=+n[Nc+(Rc+4<<2)>>2];cd=1.0/(Ld*yd-ud*ud+.001);Rc=he<<1;n[Yc+(Rc<<2)>>2]=(Ld*zd-ud*xd)*cd;n[Yc+((Rc|1)<<2)>>2]=(yd*xd-ud*zd)*cd;he=he+1|0}while((he|0)!=(Sc|0))}Yc=(ad|0)==($c|0)?nd:ad-Mc|0;do if(Kc){if((Yc|0)!=(nd|0)&(Yc|0)<(Zc+ld|0)){ie=Zc;break}NEa(A,ob,t,C,Zc,Yc);ie=Yc}else ie=Zc;while(0);ad=ad+1|0;if((ad|0)>=(nd|0))break;else Zc=ie}je=f[k>>2]|0}else je=ee;if((je|0)!=(Ob|0)){if(je|0)ZDc(je);f[k>>2]=Ob;f[Pb>>2]=264}Zc=f[j>>2]|0;if((Zc|0)!=(Mb|0)){if(Zc|0)ZDc(Zc);f[j>>2]=Mb;f[Nb>>2]=264}Zc=f[i>>2]|0;if((Zc|0)!=(Jb|0)){if(Zc|0)ZDc(Zc);f[i>>2]=Jb;f[Kb>>2]=264}Zc=f[h>>2]|0;if((Zc|0)!=(Hb|0)){if(Zc|0)ZDc(Zc);f[h>>2]=Hb;f[Ib>>2]=264}}Lc=Lc+1|0;Ic=f[pb>>2]|0}while((Lc|0)<(Ic|0))}Ic=f[qb>>2]|0;if(Ic|0){Lc=Ic+12|0;f[Lc>>2]=(f[Lc>>2]|0)+1}Lc=f[rb>>2]|0;if(Lc|0?(Ic=Lc+12|0,Lc=f[Ic>>2]|0,f[Ic>>2]=Lc+-1,(Lc|0)==1):0)_S(s);f[rb>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[d>>2]|0)>0){Lc=f[c>>2]|0;Ic=0;do{f[Lc+(Ic<<2)>>2]=0;Ic=Ic+1|0;ke=f[d>>2]|0}while((Ic|0)<(ke|0));f[s>>2]=f[t>>2];if((ke|0)<3)ja=228;else ja=230}else{f[s>>2]=f[t>>2];ja=228}if((ja|0)==228){ja=0;Ic=f[I>>2]|0;if((Ic|0)<3){f[d>>2]=Ic;f[K>>2]=f[M>>2];f[sb>>2]=f[U>>2];Ic=f[P>>2]|0;Lc=f[J>>2]|0;f[Lc>>2]=f[Ic>>2];f[Lc+4>>2]=f[Ic+4>>2]}else ja=230}if((ja|0)==230){ja=0;ZS(s,t)}f[Z>>2]=f[w>>2];f[ub>>2]=f[tb>>2];f[wb>>2]=f[vb>>2];f[yb>>2]=f[xb>>2];f[Ab>>2]=f[zb>>2];f[rb>>2]=f[qb>>2];Ic=f[Bb>>2]|0;if(Ic|0?(Lc=Ic+12|0,Ic=f[Lc>>2]|0,f[Lc>>2]=Ic+-1,(Ic|0)==1):0)_S(C);f[Bb>>2]=0;f[Cb>>2]=0;f[Cb+4>>2]=0;f[Cb+8>>2]=0;f[Cb+12>>2]=0;if((f[xa>>2]|0)>0){Ic=f[za>>2]|0;Lc=0;do{f[Ic+(Lc<<2)>>2]=0;Lc=Lc+1|0}while((Lc|0)<(f[xa>>2]|0))}Lc=f[Ba>>2]|0;if((Lc|0)!=(Aa|0))g0(Lc);Lc=f[Db>>2]|0;do if(Lc|0){Ic=Lc+12|0;Zc=f[Ic>>2]|0;f[Ic>>2]=Zc+-1;if((Zc|0)!=1)break;_S(B)}while(0);f[Db>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[ra>>2]|0)>0){Lc=f[ta>>2]|0;Zc=0;do{f[Lc+(Zc<<2)>>2]=0;Zc=Zc+1|0}while((Zc|0)<(f[ra>>2]|0))}Zc=f[va>>2]|0;if((Zc|0)!=(ua|0))g0(Zc);Zc=f[uc>>2]|0;do if(Zc|0){Lc=Zc+12|0;Ic=f[Lc>>2]|0;f[Lc>>2]=Ic+-1;if((Ic|0)!=1)break;_S(tc)}while(0);f[uc>>2]=0;f[vc>>2]=0;f[vc+4>>2]=0;f[vc+8>>2]=0;f[vc+12>>2]=0;if((f[wc>>2]|0)>0){Zc=f[xc>>2]|0;Ic=0;do{f[Zc+(Ic<<2)>>2]=0;Ic=Ic+1|0}while((Ic|0)<(f[wc>>2]|0))}Ic=f[yc>>2]|0;if((Ic|0)!=(zc|0))g0(Ic);Ic=f[Ac>>2]|0;do if(Ic|0){Zc=Ic+12|0;Lc=f[Zc>>2]|0;f[Zc>>2]=Lc+-1;if((Lc|0)!=1)break;_S(A)}while(0);f[Ac>>2]=0;f[Bc>>2]=0;f[Bc+4>>2]=0;f[Bc+8>>2]=0;f[Bc+12>>2]=0;if((f[Cc>>2]|0)>0){Ic=f[Dc>>2]|0;Lc=0;do{f[Ic+(Lc<<2)>>2]=0;Lc=Lc+1|0}while((Lc|0)<(f[Cc>>2]|0))}Lc=f[Ec>>2]|0;if((Lc|0)!=(Fc|0))g0(Lc);if(Hc)Gc=Gc+-1|0;else{ka=Yb;break a}}f[h>>2]=0;f[h+4>>2]=0;F=tT(h,22)|0;ba=374567;G=F+22|0;do{b[F>>0]=b[ba>>0]|0;F=F+1|0;ba=ba+1|0}while((F|0)<(G|0));MEa(h,374590,120)}while(0);h=f[ka>>2]|0;if(h|0?(ba=h+12|0,h=f[ba>>2]|0,f[ba>>2]=h+-1,(h|0)==1):0)_S(x);f[ka>>2]=0;ka=x+16|0;h=x+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[h>>2]|0)>0){ka=f[x+40>>2]|0;ba=0;do{f[ka+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[h>>2]|0))}h=f[x+44>>2]|0;if((h|0)!=(x+48|0))g0(h);h=v+36|0;x=f[h>>2]|0;if(x|0?(ba=x+12|0,x=f[ba>>2]|0,f[ba>>2]=x+-1,(x|0)==1):0)_S(v);f[h>>2]=0;h=v+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[Q>>2]|0)>0){h=f[S>>2]|0;S=0;do{f[h+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[Q>>2]|0))}Q=f[T>>2]|0;if((Q|0)!=(R|0))g0(Q);Q=t+36|0;R=f[Q>>2]|0;if(R|0?(T=R+12|0,R=f[T>>2]|0,f[T>>2]=R+-1,(R|0)==1):0)_S(t);f[Q>>2]=0;Q=t+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[I>>2]|0)>0){Q=f[N>>2]|0;N=0;do{f[Q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[I>>2]|0))}I=f[P>>2]|0;if((I|0)!=(O|0))g0(I);I=s+36|0;O=f[I>>2]|0;if(O|0?(P=O+12|0,O=f[P>>2]|0,f[P>>2]=O+-1,(O|0)==1):0)_S(s);f[I>>2]=0;I=s+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[d>>2]|0)>0){I=f[c>>2]|0;c=0;do{f[I+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[J>>2]|0;if((d|0)!=(H|0))g0(d);d=q+36|0;H=f[d>>2]|0;do if(H|0){J=H+12|0;c=f[J>>2]|0;f[J>>2]=c+-1;if((c|0)!=1)break;_S(q)}while(0);f[d>>2]=0;d=q+16|0;H=q+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[H>>2]|0)>0){d=f[L>>2]|0;L=0;do{f[d+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[H>>2]|0))}H=f[q+44>>2]|0;if((H|0)!=(q+48|0))g0(H);H=o+36|0;q=f[H>>2]|0;do if(q|0){L=q+12|0;d=f[L>>2]|0;f[L>>2]=d+-1;if((d|0)!=1)break;_S(o)}while(0);f[H>>2]=0;H=o+16|0;q=o+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[q>>2]|0)>0){H=f[W>>2]|0;W=0;do{f[H+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[q>>2]|0))}q=f[o+44>>2]|0;if((q|0)==(o+48|0)){u=g;return}g0(q);u=g;return}function vEa(a){a=a|0;return}function wEa(a){a=a|0;return f[a+4>>2]|0}function xEa(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function yEa(a){a=a|0;return +(+p[a+8>>3])}function zEa(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function AEa(a){a=a|0;return (b[a+16>>0]|0)!=0|0}function BEa(a,c){a=a|0;c=c|0;b[a+16>>0]=c&1;return}function CEa(a){a=a|0;return f[a+20>>2]|0}function DEa(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function EEa(a){a=a|0;return f[a+24>>2]|0}function FEa(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function GEa(a){a=a|0;return f[a+28>>2]|0}function HEa(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function IEa(a){a=a|0;return +(+p[a+32>>3])}function JEa(a,b){a=a|0;b=+b;p[a+32>>3]=b;return}function KEa(a){a=a|0;return f[a+40>>2]|0}function LEa(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function MEa(a,b,c){a=a|0;b=b|0;c=c|0;z5(-215,a,b,374607,c);return}function NEa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0;h=u;u=u+16|0;i=h;j=f[c+12>>2]|0;k=f[c+8>>2]|0;l=f[b+16>>2]|0;m=(f[b+48>>2]|0)>>>2;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(k|0):0)?(f[d+12>>2]|0)==(j|0):0)?(f[d>>2]&4095|0)==37:0)?(f[d+16>>2]|0)!=0:0)){f[i>>2]=k;f[i+4>>2]=j;XS(d,2,i,37)}if((e|0)>=(g|0)){u=h;return}i=f[c+16>>2]|0;b=f[f[c+44>>2]>>2]|0;c=f[a+16>>2]|0;o=f[f[a+44>>2]>>2]|0;a=f[d+16>>2]|0;p=f[f[d+44>>2]>>2]|0;d=(j|0)>0;q=j+-1|0;r=k+-1|0;s=m+5|0;t=m+1|0;v=m+6|0;w=m+2|0;x=m+7|0;y=m+3|0;z=m+8|0;A=m+4|0;B=m+9|0;C=j+-10|0;D=k+-10|0;E=j+-5|0;F=k+-5|0;k=e;do{e=i+(Y(b,k)|0)|0;G=c+(Y(o,k)|0)|0;H=a+(Y(p,k)|0)|0;if(d){I=+(k|0);J=(k|0)<5;K=77580+(k<<2)|0;L=(k|0)<(F|0);M=77580+(r-k<<2)|0;N=(k+-5|0)>>>0>=D>>>0;O=0;do{P=O<<1;Q=+n[e+(P<<2)>>2];R=+n[e+((P|1)<<2)>>2];S=+(O|0)+Q;T=I+R;P=~~S;U=P-(+(P|0)>S&1)|0;P=~~T;V=P-(+(P|0)>T&1)|0;P=l+((Y(V,m)|0)<<2)+(U*5<<2)|0;W=S-+(U|0);S=T-+(V|0);if(U>>>0<q>>>0&V>>>0<r>>>0){T=1.0-W;X=1.0-S;Z=T*X;_=W*X;X=T*S;T=W*S;V=O*5|0;$=Z*+n[P>>2]+_*+n[P+20>>2]+X*+n[P+(m<<2)>>2]+T*+n[P+(s<<2)>>2];aa=(Z*+n[P+16>>2]+_*+n[P+36>>2]+X*+n[P+(A<<2)>>2]+T*+n[P+(B<<2)>>2]+ +n[G+(V+4<<2)>>2])*.25;ba=(Z*+n[P+12>>2]+_*+n[P+32>>2]+X*+n[P+(y<<2)>>2]+T*+n[P+(z<<2)>>2]+ +n[G+(V+3<<2)>>2])*.5;ca=(Z*+n[P+8>>2]+_*+n[P+28>>2]+X*+n[P+(w<<2)>>2]+T*+n[P+(x<<2)>>2]+ +n[G+(V+2<<2)>>2])*.5;da=Z*+n[P+4>>2]+_*+n[P+24>>2]+X*+n[P+(t<<2)>>2]+T*+n[P+(v<<2)>>2];ea=V}else{V=O*5|0;$=0.0;aa=+n[G+(V+4<<2)>>2]*.5;ba=+n[G+(V+3<<2)>>2];ca=+n[G+(V+2<<2)>>2];da=0.0;ea=V}V=ea+1|0;T=R*ca+Q*aa+(+n[G+(ea<<2)>>2]-$)*.5;X=Q*ba+R*aa+(+n[G+(V<<2)>>2]-da)*.5;if((O+-5|0)>>>0>=C>>>0|N){if((O|0)<5)fa=+n[77580+(O<<2)>>2];else fa=1.0;if((O|0)<(E|0))ga=1.0;else ga=+n[77580+(q-O<<2)>>2];if(J)ha=+n[K>>2];else ha=1.0;if(L)ia=1.0;else ia=+n[M>>2];R=fa*ga*ha*ia;ja=T*R;ka=aa*R;la=ba*R;ma=ca*R;na=X*R}else{ja=T;ka=aa;la=ba;ma=ca;na=X}X=ka*ka;n[H+(ea<<2)>>2]=ma*ma+X;n[H+(V<<2)>>2]=(ma+la)*ka;n[H+(ea+2<<2)>>2]=la*la+X;n[H+(ea+3<<2)>>2]=na*ka+ma*ja;n[H+(ea+4<<2)>>2]=na*la+ka*ja;O=O+1|0}while((O|0)!=(j|0))}k=k+1|0}while((k|0)!=(g|0));u=h;return}function OEa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0.0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0.0,$k=0,al=0.0,bl=0,cl=0,dl=0.0,el=0.0,fl=0.0,gl=0.0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0.0,nl=0.0,ol=0.0,pl=0.0,ql=0.0;i=u;u=u+5568|0;j=i+3264|0;k=i+3040|0;l=i+2816|0;m=i+2592|0;o=i+2144|0;q=i+1920|0;r=i+1472|0;t=i+1248|0;v=i+1024|0;w=i+800|0;x=i+576|0;y=i+352|0;z=i+5408|0;A=i+5352|0;B=i+128|0;C=i+5296|0;D=i+5240|0;E=i+5184|0;F=i+5128|0;G=i+5072|0;H=i+5016|0;I=i+4960|0;J=i+4904|0;K=i+4848|0;N=i+4792|0;Q=i+4736|0;R=i+4680|0;T=i+4624|0;U=i+4568|0;V=i+4512|0;W=i+4456|0;X=i+4400|0;Z=i+4344|0;_=i+4288|0;$=i+5560|0;aa=i+4232|0;ba=i+5552|0;ca=i+5544|0;da=i+4176|0;ea=i+2368|0;fa=i+4120|0;ga=i+1696|0;ha=i+4064|0;ia=i+4008|0;ja=i+3992|0;ka=i+5536|0;la=i+5528|0;ma=i+3936|0;na=i+3880|0;oa=i+3824|0;pa=i+3768|0;qa=i+3712|0;ra=i+3656|0;sa=i+3600|0;ta=i+3544|0;ua=i+3488|0;va=i+5520|0;wa=i+5512|0;xa=i+5504|0;ya=i+5496|0;za=i+5488|0;Aa=i+5480|0;Ba=i+5472|0;Ca=i+5464|0;Da=i+96|0;Ea=i+64|0;Fa=i+32|0;Ga=i;do if((d$(a)|0)==65536){Ha=f[a+4>>2]|0;f[H>>2]=f[Ha>>2];Ia=H+4|0;Ja=Ha+4|0;f[Ia>>2]=f[Ja>>2];Ka=H+8|0;f[Ka>>2]=f[Ha+8>>2];f[H+12>>2]=f[Ha+12>>2];f[H+16>>2]=f[Ha+16>>2];f[H+20>>2]=f[Ha+20>>2];f[H+24>>2]=f[Ha+24>>2];f[H+28>>2]=f[Ha+28>>2];f[H+32>>2]=f[Ha+32>>2];La=f[Ha+36>>2]|0;f[H+36>>2]=La;f[H+40>>2]=Ka;Ka=H+48|0;Ma=H+44|0;f[Ma>>2]=Ka;f[Ka>>2]=0;f[H+52>>2]=0;if(La|0){Ka=La+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[Ha+44>>2]|0;Ka=f[Ma>>2]|0;f[Ka>>2]=f[Ja>>2];f[Ka+4>>2]=f[Ja+4>>2];break}else{f[Ia>>2]=0;ZS(H,Ha);break}}else a$(H,a,-1);while(0);do if((d$(c)|0)==65536){a=f[c+4>>2]|0;f[I>>2]=f[a>>2];Ha=I+4|0;Ia=a+4|0;f[Ha>>2]=f[Ia>>2];Ja=I+8|0;f[Ja>>2]=f[a+8>>2];f[I+12>>2]=f[a+12>>2];f[I+16>>2]=f[a+16>>2];f[I+20>>2]=f[a+20>>2];f[I+24>>2]=f[a+24>>2];f[I+28>>2]=f[a+28>>2];f[I+32>>2]=f[a+32>>2];Ka=f[a+36>>2]|0;f[I+36>>2]=Ka;f[I+40>>2]=Ja;Ja=I+48|0;Ma=I+44|0;f[Ma>>2]=Ja;f[Ja>>2]=0;f[I+52>>2]=0;if(Ka|0){Ja=Ka+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}if((f[Ia>>2]|0)<3){Ia=f[a+44>>2]|0;Ja=f[Ma>>2]|0;f[Ja>>2]=f[Ia>>2];f[Ja+4>>2]=f[Ia+4>>2];break}else{f[Ha>>2]=0;ZS(I,a);break}}else a$(I,c,-1);while(0);do if((d$(d)|0)==65536){c=f[d+4>>2]|0;f[J>>2]=f[c>>2];a=J+4|0;Ha=c+4|0;f[a>>2]=f[Ha>>2];Ia=J+8|0;f[Ia>>2]=f[c+8>>2];f[J+12>>2]=f[c+12>>2];f[J+16>>2]=f[c+16>>2];f[J+20>>2]=f[c+20>>2];f[J+24>>2]=f[c+24>>2];f[J+28>>2]=f[c+28>>2];f[J+32>>2]=f[c+32>>2];Ja=f[c+36>>2]|0;f[J+36>>2]=Ja;f[J+40>>2]=Ia;Ia=J+48|0;Ma=J+44|0;f[Ma>>2]=Ia;f[Ia>>2]=0;f[J+52>>2]=0;if(Ja|0){Ia=Ja+12|0;f[Ia>>2]=(f[Ia>>2]|0)+1}if((f[Ha>>2]|0)<3){Ha=f[c+44>>2]|0;Ia=f[Ma>>2]|0;f[Ia>>2]=f[Ha>>2];f[Ia+4>>2]=f[Ha+4>>2];break}else{f[a>>2]=0;ZS(J,c);break}}else a$(J,d,-1);while(0);c=H+16|0;if(!(f[c>>2]|0)){f[j>>2]=0;Na=j+4|0;f[Na>>2]=0;Oa=tT(j,12)|0;Pa=Oa;Qa=374774;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,374787,325)}a=H+4|0;Ha=f[a>>2]|0;if((Ha|0)<3)Sa=Y(f[H+12>>2]|0,f[H+8>>2]|0)|0;else{Ia=f[H+40>>2]|0;Ma=0;Ja=1;while(1){Ka=Y(f[Ia+(Ma<<2)>>2]|0,Ja)|0;Ma=Ma+1|0;if((Ma|0)==(Ha|0)){Sa=Ka;break}else Ja=Ka}}if((Ha|0)==0|(Sa|0)==0){f[j>>2]=0;Na=j+4|0;f[Na>>2]=0;Oa=tT(j,12)|0;Pa=Oa;Qa=374774;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,374787,325)}Oa=I+16|0;if(!(f[Oa>>2]|0)){f[j>>2]=0;Ta=j+4|0;f[Ta>>2]=0;Ua=tT(j,12)|0;Pa=Ua;Qa=374804;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,374787,326)}Na=I+4|0;Sa=f[Na>>2]|0;if((Sa|0)<3)Va=Y(f[I+12>>2]|0,f[I+8>>2]|0)|0;else{Ha=f[I+40>>2]|0;Ja=0;Ma=1;while(1){Ia=Y(f[Ha+(Ja<<2)>>2]|0,Ma)|0;Ja=Ja+1|0;if((Ja|0)==(Sa|0)){Va=Ia;break}else Ma=Ia}}if((Sa|0)==0|(Va|0)==0){f[j>>2]=0;Ta=j+4|0;f[Ta>>2]=0;Ua=tT(j,12)|0;Pa=Ua;Qa=374804;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,374787,326)}Ua=J+16|0;if(f[Ua>>2]|0){Ta=f[J+4>>2]|0;if((Ta|0)<3)Wa=Y(f[J+12>>2]|0,f[J+8>>2]|0)|0;else{Va=f[J+40>>2]|0;Sa=0;Ma=1;while(1){Ja=Y(f[Va+(Sa<<2)>>2]|0,Ma)|0;Sa=Sa+1|0;if((Sa|0)==(Ta|0)){Wa=Ja;break}else Ma=Ja}}if((Ta|0)==0|(Wa|0)==0)Xa=42}else Xa=42;if((Xa|0)==42){Wa=(e|0)==3?3:2;Y$(d,Wa,3,5,-1,0,0);do if((d$(d)|0)==65536){Ta=f[d+4>>2]|0;f[j>>2]=f[Ta>>2];Ma=j+4|0;Sa=Ta+4|0;f[Ma>>2]=f[Sa>>2];Va=j+8|0;f[Va>>2]=f[Ta+8>>2];f[j+12>>2]=f[Ta+12>>2];f[j+16>>2]=f[Ta+16>>2];f[j+20>>2]=f[Ta+20>>2];f[j+24>>2]=f[Ta+24>>2];f[j+28>>2]=f[Ta+28>>2];f[j+32>>2]=f[Ta+32>>2];Ja=j+36|0;Ha=f[Ta+36>>2]|0;f[Ja>>2]=Ha;f[j+40>>2]=Va;Va=j+48|0;Ia=j+44|0;f[Ia>>2]=Va;f[Va>>2]=0;f[j+52>>2]=0;if(Ha|0){Va=Ha+12|0;f[Va>>2]=(f[Va>>2]|0)+1}if((f[Sa>>2]|0)<3){Sa=f[Ta+44>>2]|0;Va=f[Ia>>2]|0;f[Va>>2]=f[Sa>>2];f[Va+4>>2]=f[Sa+4>>2];Ya=Ja;break}else{f[Ma>>2]=0;ZS(j,Ta);Ya=Ja;break}}else{a$(j,d,-1);Ya=j+36|0}while(0);d=f[Ya>>2]|0;if(d|0){Ja=d+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}Ja=J+36|0;d=f[Ja>>2]|0;if(d|0?(Ta=d+12|0,d=f[Ta>>2]|0,f[Ta>>2]=d+-1,(d|0)==1):0)_S(J);f[Ja>>2]=0;d=J+4|0;f[Ua>>2]=0;f[Ua+4>>2]=0;f[Ua+8>>2]=0;f[Ua+12>>2]=0;if((f[d>>2]|0)>0){Ta=f[J+40>>2]|0;Ma=0;do{f[Ta+(Ma<<2)>>2]=0;Ma=Ma+1|0;Za=f[d>>2]|0}while((Ma|0)<(Za|0));f[J>>2]=f[j>>2];if((Za|0)<3)Xa=59;else Xa=61}else{f[J>>2]=f[j>>2];Xa=59}if((Xa|0)==59){Za=f[j+4>>2]|0;if((Za|0)<3){f[d>>2]=Za;f[J+8>>2]=f[j+8>>2];f[J+12>>2]=f[j+12>>2];Za=f[j+44>>2]|0;d=f[J+44>>2]|0;f[d>>2]=f[Za>>2];f[d+4>>2]=f[Za+4>>2]}else Xa=61}if((Xa|0)==61)ZS(J,j);Za=j+16|0;f[Ua>>2]=f[Za>>2];f[J+20>>2]=f[j+20>>2];f[J+24>>2]=f[j+24>>2];f[J+28>>2]=f[j+28>>2];f[J+32>>2]=f[j+32>>2];d=f[Ya>>2]|0;f[Ja>>2]=d;if(d|0?(Ja=d+12|0,d=f[Ja>>2]|0,f[Ja>>2]=d+-1,(d|0)==1):0)_S(j);f[Ya>>2]=0;Ya=j+4|0;f[Za>>2]=0;f[Za+4>>2]=0;f[Za+8>>2]=0;f[Za+12>>2]=0;if((f[Ya>>2]|0)>0){Za=f[j+40>>2]|0;d=0;do{f[Za+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[Ya>>2]|0))}Ya=f[j+44>>2]|0;if((Ya|0)!=(j+48|0))g0(Ya);GY(j,Wa,3,5);Wa=f[j>>2]|0;ei[f[(f[Wa>>2]|0)+12>>2]&511](Wa,j,J,-1);$j(j)}Wa=f[H>>2]|0;if((f[I>>2]^Wa)&4095|0){f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,46)|0;Qa=374817;Ra=Pa+46|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-205,j,374787,340)}switch(Wa&4095){case 5:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,35)|0;Qa=374864;Ra=Pa+35|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-210,j,374787,344)}}if((f[J>>2]&4095|0)!=5){f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,55)|0;Qa=374900;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-210,j,374787,347)}if((f[J+12>>2]|0)!=3){f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,13)|0;Qa=374956;Ra=Pa+13|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,374787,349)}Wa=J+8|0;Ya=f[Wa>>2]|0;if((Ya&-2|0)!=2){f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,29)|0;Qa=374970;Ra=Pa+29|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,374787,350)}switch(e|0){case 3:{Xa=83;break}case 2:case 1:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;dJc(tT(j,132)|0,375e3,132)|0;PEa(-215,j,374787,353)}}if((Xa|0)==83?(Ya|0)!=3:0){f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,12)|0;Qa=375133;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,374787,356)}Ya=f[g>>2]|0;d=(Ya&1|0)!=0;Za=(Ya&2|0)==0;if(Za&(d^1)){f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,72)|0;Qa=375146;Ra=Pa+72|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,374787,359)}if(d)_a=f[g+4>>2]|0;else _a=200;if(Za)$a=-1.0;else $a=+p[g+8>>3];switch(e|0){case 0:{ab=2;break}case 1:{ab=3;break}case 3:{ab=8;break}default:ab=6}g=f[H+12>>2]|0;Za=f[H+8>>2]|0;d=f[I+12>>2]|0;Ya=f[I+8>>2]|0;f[K>>2]=1124007936;Ja=K+4|0;Ma=K+8|0;Ta=K+40|0;Pa=Ja;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ta>>2]=Ma;Ma=K+48|0;Sa=K+44|0;f[Sa>>2]=Ma;f[Ma>>2]=0;f[K+52>>2]=0;f[j>>2]=1;Va=j+4|0;f[Va>>2]=g;XS(K,2,j,5);f[N>>2]=1124007936;Ia=N+4|0;Ha=N+8|0;Ka=N+40|0;Pa=Ia;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ka>>2]=Ha;Ha=N+48|0;La=N+44|0;f[La>>2]=Ha;f[Ha>>2]=0;f[N+52>>2]=0;f[j>>2]=Za;f[Va>>2]=1;XS(N,2,j,5);f[Q>>2]=1124007936;bb=Q+4|0;cb=Q+8|0;db=Q+40|0;Pa=bb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[db>>2]=cb;cb=Q+48|0;eb=Q+44|0;f[eb>>2]=cb;f[cb>>2]=0;f[Q+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(Q,2,j,5);f[R>>2]=1124007936;fb=R+4|0;gb=R+8|0;hb=R+40|0;Pa=fb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[hb>>2]=gb;gb=R+48|0;ib=R+44|0;f[ib>>2]=gb;f[gb>>2]=0;f[R+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(R,2,j,5);jb=K+16|0;kb=f[jb>>2]|0;lb=N+16|0;mb=f[lb>>2]|0;if((g|0)>0){nb=0;do{n[kb+(nb<<2)>>2]=+(nb|0);nb=nb+1|0}while((nb|0)!=(g|0))}if((Za|0)>0){nb=0;do{n[mb+(nb<<2)>>2]=+(nb|0);nb=nb+1|0}while((nb|0)!=(Za|0))}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=K;nb=k+8|0;f[nb>>2]=0;f[nb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=Q;o_(j,Za,1,k);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=N;nb=k+8|0;f[nb>>2]=0;f[nb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=R;o_(j,1,g,k);nb=K+36|0;mb=f[nb>>2]|0;do if(mb|0){kb=mb+12|0;ob=f[kb>>2]|0;f[kb>>2]=ob+-1;if((ob|0)!=1)break;_S(K)}while(0);f[nb>>2]=0;f[jb>>2]=0;f[jb+4>>2]=0;f[jb+8>>2]=0;f[jb+12>>2]=0;if((f[Ja>>2]|0)>0){mb=f[Ta>>2]|0;ob=0;do{f[mb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[Ja>>2]|0))}ob=N+36|0;mb=f[ob>>2]|0;do if(mb|0){kb=mb+12|0;pb=f[kb>>2]|0;f[kb>>2]=pb+-1;if((pb|0)!=1)break;_S(N)}while(0);f[ob>>2]=0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[Ia>>2]|0)>0){mb=f[Ka>>2]|0;pb=0;do{f[mb+(pb<<2)>>2]=0;pb=pb+1|0}while((pb|0)<(f[Ia>>2]|0))}f[T>>2]=1124007936;pb=T+4|0;mb=T+8|0;kb=T+40|0;Pa=pb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[kb>>2]=mb;qb=T+48|0;rb=T+44|0;f[rb>>2]=qb;f[qb>>2]=0;f[T+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(T,2,j,5);f[U>>2]=1124007936;sb=U+4|0;tb=U+8|0;ub=U+40|0;Pa=sb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ub>>2]=tb;tb=U+48|0;vb=U+44|0;f[vb>>2]=tb;f[tb>>2]=0;f[U+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(U,2,j,5);f[V>>2]=1124007936;wb=V+4|0;xb=V+8|0;yb=V+40|0;Pa=wb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[yb>>2]=xb;xb=V+48|0;zb=V+44|0;f[zb>>2]=xb;f[xb>>2]=0;f[V+52>>2]=0;f[j>>2]=Ya;f[Va>>2]=d;XS(V,2,j,5);f[W>>2]=1124007936;Ab=W+4|0;Bb=W+8|0;Cb=W+40|0;Pa=Ab;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Cb>>2]=Bb;Bb=W+48|0;Db=W+44|0;f[Db>>2]=Bb;f[Bb>>2]=0;f[W+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(W,2,j,5);f[X>>2]=1124007936;Eb=X+4|0;Fb=X+8|0;Gb=X+40|0;Pa=Eb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Gb>>2]=Fb;Fb=X+48|0;Hb=X+44|0;f[Hb>>2]=Fb;f[Fb>>2]=0;f[X+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(X,2,j,0);do if((d$(h)|0)==65536){Ib=f[h+4>>2]|0;f[Z>>2]=f[Ib>>2];Jb=Z+4|0;Kb=Ib+4|0;f[Jb>>2]=f[Kb>>2];Lb=Z+8|0;f[Lb>>2]=f[Ib+8>>2];f[Z+12>>2]=f[Ib+12>>2];f[Z+16>>2]=f[Ib+16>>2];f[Z+20>>2]=f[Ib+20>>2];f[Z+24>>2]=f[Ib+24>>2];f[Z+28>>2]=f[Ib+28>>2];f[Z+32>>2]=f[Ib+32>>2];Mb=f[Ib+36>>2]|0;f[Z+36>>2]=Mb;f[Z+40>>2]=Lb;Lb=Z+48|0;Nb=Z+44|0;f[Nb>>2]=Lb;f[Lb>>2]=0;f[Z+52>>2]=0;if(Mb|0){Lb=Mb+12|0;f[Lb>>2]=(f[Lb>>2]|0)+1}if((f[Kb>>2]|0)<3){Kb=f[Ib+44>>2]|0;Lb=f[Nb>>2]|0;f[Lb>>2]=f[Kb>>2];f[Lb+4>>2]=f[Kb+4>>2];break}else{f[Jb>>2]=0;ZS(Z,Ib);break}}else a$(Z,h,-1);while(0);f[_>>2]=1124007936;Ib=_+4|0;Jb=_+8|0;Kb=_+40|0;Pa=Ib;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Kb>>2]=Jb;Jb=_+48|0;Lb=_+44|0;f[Lb>>2]=Jb;f[Jb>>2]=0;f[_+52>>2]=0;if(r$(h)|0){EY(j,Ya,d,0);Nb=f[j>>2]|0;ei[f[(f[Nb>>2]|0)+12>>2]&511](Nb,j,_,-1);$j(j)}else{Nb=j+8|0;f[Nb>>2]=0;f[Nb+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=_;+Cxa(h,j,0.0,1.0,0)}h=j+8|0;f[h>>2]=0;f[h+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=U;LZ(H,j,f[U>>2]&4095,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=U;h=k+8|0;f[h>>2]=0;f[h+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=U;f[$>>2]=5;f[$+4>>2]=5;Gfa(j,k,$,0.0,0.0,4);f[aa>>2]=1124007936;$=aa+4|0;h=aa+8|0;Nb=aa+40|0;Pa=$;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Nb>>2]=h;h=aa+48|0;Mb=aa+44|0;f[Mb>>2]=h;f[h>>2]=0;f[aa+52>>2]=0;Ob=j+8|0;f[Ob>>2]=0;f[Ob+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;LZ(_,j,5,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=aa;Ob=k+8|0;f[Ob>>2]=0;f[Ob+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=aa;f[ba>>2]=5;f[ba+4>>2]=5;Gfa(j,k,ba,0.0,0.0,4);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;LZ(aa,j,-1,.5263157894736842,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=_;LZ(aa,j,f[_>>2]&4095,1.0,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;LZ(_,j,f[aa>>2]&4095,1.0,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=V;LZ(I,j,f[V>>2]&4095,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;ba=k+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=V;f[ca>>2]=5;f[ca+4>>2]=5;Gfa(j,k,ca,0.0,0.0,4);AY(ea,Ya,d,5);f[da>>2]=1124007936;ca=da+4|0;ba=da+8|0;Ob=da+40|0;Pa=ca;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ob>>2]=ba;ba=da+48|0;Pb=da+44|0;f[Pb>>2]=ba;f[ba>>2]=0;f[da+52>>2]=0;Qb=f[ea>>2]|0;ei[f[(f[Qb>>2]|0)+12>>2]&511](Qb,ea,da,-1);$j(ea);AY(ga,Ya,d,5);f[fa>>2]=1124007936;d=fa+4|0;Ya=fa+8|0;ea=fa+40|0;Pa=d;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ea>>2]=Ya;Ya=fa+48|0;Qb=fa+44|0;f[Qb>>2]=Ya;f[Ya>>2]=0;f[fa+52>>2]=0;Rb=f[ga>>2]|0;ei[f[(f[Rb>>2]|0)+12>>2]&511](Rb,ga,fa,-1);$j(ga);f[ha>>2]=1124007936;ga=ha+4|0;Rb=ha+8|0;Sb=ha+40|0;Pa=ga;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Sb>>2]=Rb;Tb=ha+48|0;Ub=ha+44|0;f[Ub>>2]=Tb;f[Tb>>2]=0;f[ha+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(ha,2,j,5);f[ia>>2]=1124007936;Vb=ia+4|0;Wb=ia+8|0;Xb=ia+40|0;Pa=Vb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Xb>>2]=Wb;Wb=ia+48|0;Yb=ia+44|0;f[Yb>>2]=Wb;f[Wb>>2]=0;f[ia+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(ia,2,j,5);n[ja>>2]=-.5;Zb=ja+4|0;n[Zb>>2]=0.0;_b=ja+8|0;n[_b>>2]=.5;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;$b=k+8|0;f[$b>>2]=0;f[$b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=da;f[l>>2]=-1056833531;f[l+4>>2]=ja;f[l+8>>2]=3;f[l+12>>2]=1;f[ka>>2]=-1;f[ka+4>>2]=-1;kwa(j,k,-1,l,ka,0.0,4);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;ka=k+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=fa;f[m>>2]=f[ja>>2];f[m+4>>2]=f[Zb>>2];f[m+8>>2]=f[_b>>2];f[l>>2]=-1056833531;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=3;f[la>>2]=-1;f[la+4>>2]=-1;kwa(j,k,-1,l,la,0.0,4);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=aa;zY(j,da,k,1.0);la=f[j>>2]|0;ei[f[(f[la>>2]|0)+12>>2]&511](la,j,da,-1);$j(j);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=aa;zY(j,fa,k,1.0);la=f[j>>2]|0;ei[f[(f[la>>2]|0)+12>>2]&511](la,j,fa,-1);$j(j);la=Y(g,ab)|0;f[ma>>2]=1124007936;_b=ma+4|0;Zb=ma+8|0;ja=ma+40|0;Pa=_b;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ja>>2]=Zb;ka=ma+48|0;$b=ma+44|0;f[$b>>2]=ka;f[ka>>2]=0;f[ma+52>>2]=0;f[j>>2]=Za;f[Va>>2]=la;XS(ma,2,j,5);f[na>>2]=1124007936;la=na+4|0;ac=na+8|0;bc=na+40|0;Pa=la;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[bc>>2]=ac;ac=na+48|0;cc=na+44|0;f[cc>>2]=ac;f[ac>>2]=0;f[na+52>>2]=0;f[j>>2]=ab;f[Va>>2]=ab;XS(na,2,j,5);f[oa>>2]=1124007936;dc=oa+4|0;ec=oa+8|0;fc=oa+40|0;Pa=dc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[fc>>2]=ec;ec=oa+48|0;gc=oa+44|0;f[gc>>2]=ec;f[ec>>2]=0;f[oa+52>>2]=0;f[j>>2]=ab;f[Va>>2]=ab;XS(oa,2,j,5);f[pa>>2]=1124007936;hc=pa+4|0;ic=pa+8|0;jc=pa+40|0;Pa=hc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[jc>>2]=ic;ic=pa+48|0;kc=pa+44|0;f[kc>>2]=ic;f[ic>>2]=0;f[pa+52>>2]=0;f[j>>2]=ab;f[Va>>2]=1;XS(pa,2,j,5);f[qa>>2]=1124007936;lc=qa+4|0;mc=qa+8|0;nc=qa+40|0;Pa=lc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[nc>>2]=mc;mc=qa+48|0;oc=qa+44|0;f[oc>>2]=mc;f[mc>>2]=0;f[qa+52>>2]=0;f[j>>2]=ab;f[Va>>2]=1;XS(qa,2,j,5);f[ra>>2]=1124007936;pc=ra+4|0;qc=ra+8|0;rc=ra+40|0;Pa=pc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[rc>>2]=qc;qc=ra+48|0;sc=ra+44|0;f[sc>>2]=qc;f[qc>>2]=0;f[ra+52>>2]=0;f[j>>2]=ab;f[Va>>2]=1;XS(ra,2,j,5);f[sa>>2]=1124007936;tc=sa+4|0;uc=sa+8|0;vc=sa+40|0;Pa=tc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[vc>>2]=uc;uc=sa+48|0;wc=sa+44|0;f[wc>>2]=uc;f[uc>>2]=0;f[sa+52>>2]=0;f[j>>2]=ab;f[Va>>2]=1;XS(sa,2,j,5);f[ta>>2]=1124007936;xc=ta+4|0;yc=ta+8|0;zc=ta+40|0;Pa=xc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[zc>>2]=yc;Ac=ta+48|0;Bc=ta+44|0;f[Bc>>2]=Ac;f[Ac>>2]=0;f[ta+52>>2]=0;f[j>>2]=ab;f[Va>>2]=1;XS(ta,2,j,5);f[ua>>2]=1124007936;ab=ua+4|0;Cc=ua+8|0;Dc=ua+40|0;Pa=ab;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Dc>>2]=Cc;Cc=ua+48|0;Ec=ua+44|0;f[Ec>>2]=Cc;f[Cc>>2]=0;f[ua+52>>2]=0;f[j>>2]=Za;f[Va>>2]=g;XS(ua,2,j,5);a:do if((_a|0)<1)Fc=-1.0;else{g=(e|0)==3;Va=j+8|0;Za=j+12|0;Gc=j+4|0;Hc=k+8|0;Ic=k+4|0;Jc=l+8|0;Kc=l+12|0;Lc=l+4|0;Mc=za+4|0;Nc=j+8|0;Oc=j+12|0;Pc=j+4|0;Qc=k+8|0;Rc=k+4|0;Sc=l+8|0;Tc=l+12|0;Uc=l+4|0;Vc=Aa+4|0;Wc=j+8|0;Xc=j+12|0;Yc=j+4|0;Zc=k+8|0;_c=k+4|0;$c=l+8|0;ad=l+12|0;bd=l+4|0;cd=Ba+4|0;dd=j+8|0;ed=j+12|0;fd=j+4|0;gd=k+8|0;hd=k+4|0;id=l+8|0;jd=l+12|0;kd=l+4|0;ld=Ca+4|0;md=j+8|0;nd=j+12|0;od=j+4|0;pd=k+4|0;qd=k+8|0;rd=k+12|0;sd=l+4|0;td=l+8|0;ud=l+12|0;vd=m+8|0;wd=m+12|0;xd=m+4|0;yd=j+8|0;zd=j+12|0;Ad=j+4|0;Bd=k+4|0;Cd=k+8|0;Dd=k+12|0;Ed=l+4|0;Fd=l+8|0;Gd=l+12|0;Hd=m+8|0;Id=m+12|0;Jd=m+4|0;Kd=j+8|0;Ld=j+12|0;Md=j+4|0;Nd=k+8|0;Od=k+12|0;Pd=k+4|0;Qd=l+8|0;Rd=l+4|0;Sd=m+8|0;Td=m+12|0;Ud=m+4|0;Vd=T+12|0;Wd=j+8|0;Xd=j+12|0;Yd=j+4|0;Zd=k+8|0;_d=k+12|0;$d=k+4|0;ae=l+8|0;be=l+4|0;ce=m+8|0;de=m+12|0;ee=m+4|0;fe=j+8|0;ge=j+12|0;he=j+4|0;ie=j+8|0;je=j+12|0;ke=j+4|0;le=j+8|0;me=j+12|0;ne=j+4|0;oe=j+8|0;pe=j+12|0;qe=j+4|0;re=j+8|0;se=j+12|0;te=j+4|0;ue=(e|0)==0;ve=(e|0)==1;we=(e|0)==2;xe=e>>>0<4;ye=ta+12|0;ze=ta+16|0;Ae=ma+12|0;Be=ha+12|0;Ce=m+8|0;De=m+12|0;Ee=m+4|0;Fe=j+4|0;Ge=k+4|0;He=o+36|0;Ie=o+16|0;Je=o+4|0;Ke=o+40|0;Le=o+44|0;Me=o+48|0;Ne=m+8|0;Oe=m+12|0;Pe=m+4|0;Qe=j+4|0;Re=k+4|0;Se=q+36|0;Te=q+16|0;Ue=q+4|0;Ve=q+40|0;We=q+44|0;Xe=q+48|0;Ye=m+8|0;Ze=m+12|0;_e=m+4|0;$e=j+4|0;af=k+4|0;bf=r+36|0;cf=r+16|0;df=r+4|0;ef=r+40|0;ff=r+44|0;gf=r+48|0;hf=m+8|0;jf=m+12|0;kf=m+4|0;lf=j+4|0;mf=k+4|0;nf=t+36|0;of=t+16|0;pf=t+4|0;qf=t+40|0;rf=t+44|0;sf=t+48|0;tf=j+4|0;uf=k+4|0;vf=l+8|0;wf=l+4|0;xf=m+36|0;yf=m+16|0;zf=m+4|0;Af=m+40|0;Bf=m+44|0;Cf=m+48|0;Df=j+4|0;Ef=k+4|0;Ff=l+8|0;Gf=l+4|0;Hf=m+36|0;If=m+16|0;Jf=m+4|0;Kf=m+40|0;Lf=m+44|0;Mf=m+48|0;Nf=q+8|0;Of=l+4|0;Pf=l+8|0;Qf=l+40|0;Rf=l+48|0;Sf=l+44|0;Tf=l+52|0;Uf=v+8|0;Vf=o+4|0;Wf=o+8|0;Xf=o+40|0;Yf=o+48|0;Zf=o+44|0;_f=o+52|0;$f=j+8|0;ag=j+12|0;bg=j+4|0;cg=k+8|0;dg=k+12|0;eg=k+4|0;fg=q+8|0;gg=q+4|0;hg=x+8|0;ig=q+4|0;jg=q+8|0;kg=q+40|0;lg=q+48|0;mg=q+44|0;ng=q+52|0;og=j+8|0;pg=j+12|0;qg=j+4|0;rg=k+8|0;sg=k+12|0;tg=k+4|0;ug=t+8|0;vg=t+4|0;wg=t+4|0;xg=t+8|0;yg=t+40|0;zg=t+48|0;Ag=t+44|0;Bg=t+52|0;Cg=v+4|0;Dg=v+8|0;Eg=v+40|0;Fg=v+48|0;Gg=v+44|0;Hg=v+52|0;Ig=j+8|0;Jg=j+12|0;Kg=j+4|0;Lg=k+8|0;Mg=k+12|0;Ng=k+4|0;Og=x+8|0;Pg=x+4|0;Qg=j+8|0;Rg=j+12|0;Sg=j+4|0;Tg=k+8|0;Ug=k+12|0;Vg=k+4|0;Wg=x+8|0;Xg=x+4|0;Yg=y+8|0;Zg=y+12|0;_g=y+4|0;$g=j+4|0;ah=k+4|0;bh=z+36|0;ch=z+16|0;dh=z+4|0;eh=z+40|0;fh=z+44|0;gh=z+48|0;hh=y+8|0;ih=y+12|0;jh=y+4|0;kh=j+4|0;lh=k+4|0;mh=A+36|0;nh=A+16|0;oh=A+4|0;ph=A+40|0;qh=A+44|0;rh=A+48|0;sh=k+8|0;th=k+12|0;uh=k+4|0;vh=C+8|0;wh=C+12|0;xh=C+4|0;yh=x+4|0;zh=x+8|0;Ah=x+40|0;Bh=x+48|0;Ch=x+44|0;Dh=x+52|0;Eh=C+8|0;Fh=C+12|0;Gh=C+4|0;Hh=j+4|0;Ih=k+4|0;Jh=D+36|0;Kh=D+16|0;Lh=D+4|0;Mh=D+40|0;Nh=D+44|0;Oh=D+48|0;Ph=o+36|0;Qh=o+16|0;Rh=q+36|0;Sh=q+16|0;Th=C+8|0;Uh=C+12|0;Vh=C+4|0;Wh=j+4|0;Xh=k+4|0;Yh=E+36|0;Zh=E+16|0;_h=E+4|0;$h=E+40|0;ai=E+44|0;bi=E+48|0;ci=C+8|0;di=C+12|0;fi=C+4|0;gi=j+4|0;hi=k+4|0;ii=F+36|0;ji=F+16|0;ki=F+4|0;li=F+40|0;mi=F+44|0;ni=F+48|0;oi=C+8|0;pi=C+12|0;qi=C+4|0;ri=j+4|0;si=k+4|0;ti=G+36|0;ui=G+16|0;vi=G+4|0;wi=G+40|0;xi=G+44|0;yi=G+48|0;zi=j+4|0;Ai=k+4|0;Bi=y+8|0;Ci=y+4|0;Di=C+36|0;Ei=C+16|0;Fi=C+4|0;Gi=C+40|0;Hi=C+44|0;Ii=C+48|0;Ji=j+4|0;Ki=k+4|0;Li=y+8|0;Mi=y+4|0;Ni=C+36|0;Oi=C+16|0;Pi=C+4|0;Qi=C+40|0;Ri=C+44|0;Si=C+48|0;Ti=x+36|0;Ui=x+16|0;Vi=v+36|0;Wi=v+16|0;Xi=t+36|0;Yi=t+16|0;Zi=l+36|0;_i=l+16|0;$i=j+4|0;aj=k+4|0;bj=l+8|0;cj=l+4|0;dj=m+36|0;ej=m+16|0;fj=m+4|0;gj=m+40|0;hj=m+44|0;ij=m+48|0;jj=j+4|0;kj=k+4|0;lj=l+8|0;mj=l+4|0;nj=m+36|0;oj=m+16|0;pj=m+4|0;qj=m+40|0;rj=m+44|0;sj=m+48|0;tj=l+4|0;uj=l+8|0;vj=l+40|0;wj=l+48|0;xj=l+44|0;yj=l+52|0;zj=o+4|0;Aj=o+8|0;Bj=o+40|0;Cj=o+48|0;Dj=o+44|0;Ej=o+52|0;Fj=v+8|0;Gj=v+12|0;Hj=v+4|0;Ij=x+8|0;Jj=x+12|0;Kj=x+4|0;Lj=j+4|0;Mj=k+4|0;Nj=y+36|0;Oj=y+16|0;Pj=y+4|0;Qj=y+40|0;Rj=y+44|0;Sj=y+48|0;Tj=j+4|0;Uj=k+4|0;Vj=r+8|0;Wj=r+4|0;Xj=t+36|0;Yj=t+16|0;Zj=t+4|0;_j=t+40|0;ak=t+44|0;bk=t+48|0;ck=j+4|0;dk=k+4|0;ek=r+8|0;fk=r+4|0;gk=t+36|0;hk=t+16|0;ik=t+4|0;jk=t+40|0;kk=t+44|0;lk=t+48|0;mk=o+36|0;nk=o+16|0;ok=l+36|0;pk=l+16|0;qk=j+8|0;rk=j+12|0;sk=j+4|0;tk=k+8|0;uk=k+4|0;vk=l+8|0;wk=l+12|0;xk=l+4|0;yk=va+4|0;zk=j+8|0;Ak=j+12|0;Bk=j+4|0;Ck=k+8|0;Dk=k+4|0;Ek=l+8|0;Fk=l+12|0;Gk=l+4|0;Hk=wa+4|0;Ik=j+8|0;Jk=j+12|0;Kk=j+4|0;Lk=k+8|0;Mk=k+4|0;Nk=l+8|0;Ok=l+12|0;Pk=l+4|0;Qk=xa+4|0;Rk=j+8|0;Sk=j+12|0;Tk=j+4|0;Uk=k+8|0;Vk=k+4|0;Wk=l+8|0;Xk=l+12|0;Yk=l+4|0;Zk=ya+4|0;_k=-1.0;$k=1;al=-$a;b:while(1){if(!(+L(+(_k-al))>=$a)){Fc=_k;break a}if(g){f[Va>>2]=0;f[Za>>2]=0;f[j>>2]=16842752;f[Gc>>2]=V;bl=Hc;f[bl>>2]=0;f[bl+4>>2]=0;f[k>>2]=33619968;f[Ic>>2]=W;f[Jc>>2]=0;f[Kc>>2]=0;f[l>>2]=16842752;f[Lc>>2]=J;bl=f[Cb>>2]|0;cl=f[bl>>2]|0;f[za>>2]=f[bl+4>>2];f[Mc>>2]=cl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;upa(j,k,l,za,17,0,m);f[Nc>>2]=0;f[Oc>>2]=0;f[j>>2]=16842752;f[Pc>>2]=da;cl=Qc;f[cl>>2]=0;f[cl+4>>2]=0;f[k>>2]=33619968;f[Rc>>2]=ha;f[Sc>>2]=0;f[Tc>>2]=0;f[l>>2]=16842752;f[Uc>>2]=J;cl=f[Sb>>2]|0;bl=f[cl>>2]|0;f[Aa>>2]=f[cl+4>>2];f[Vc>>2]=bl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;upa(j,k,l,Aa,17,0,m);f[Wc>>2]=0;f[Xc>>2]=0;f[j>>2]=16842752;f[Yc>>2]=fa;bl=Zc;f[bl>>2]=0;f[bl+4>>2]=0;f[k>>2]=33619968;f[_c>>2]=ia;f[$c>>2]=0;f[ad>>2]=0;f[l>>2]=16842752;f[bd>>2]=J;bl=f[Xb>>2]|0;cl=f[bl>>2]|0;f[Ba>>2]=f[bl+4>>2];f[cd>>2]=cl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;upa(j,k,l,Ba,17,0,m);f[dd>>2]=0;f[ed>>2]=0;f[j>>2]=16842752;f[fd>>2]=_;cl=gd;f[cl>>2]=0;f[cl+4>>2]=0;f[k>>2]=33619968;f[hd>>2]=X;f[id>>2]=0;f[jd>>2]=0;f[l>>2]=16842752;f[kd>>2]=J;cl=f[Gb>>2]|0;bl=f[cl>>2]|0;f[Ca>>2]=f[cl+4>>2];f[ld>>2]=bl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;upa(j,k,l,Ca,16,0,m)}else{f[qk>>2]=0;f[rk>>2]=0;f[j>>2]=16842752;f[sk>>2]=V;bl=tk;f[bl>>2]=0;f[bl+4>>2]=0;f[k>>2]=33619968;f[uk>>2]=W;f[vk>>2]=0;f[wk>>2]=0;f[l>>2]=16842752;f[xk>>2]=J;bl=f[Cb>>2]|0;cl=f[bl>>2]|0;f[va>>2]=f[bl+4>>2];f[yk>>2]=cl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;opa(j,k,l,va,17,0,m);f[zk>>2]=0;f[Ak>>2]=0;f[j>>2]=16842752;f[Bk>>2]=da;cl=Ck;f[cl>>2]=0;f[cl+4>>2]=0;f[k>>2]=33619968;f[Dk>>2]=ha;f[Ek>>2]=0;f[Fk>>2]=0;f[l>>2]=16842752;f[Gk>>2]=J;cl=f[Sb>>2]|0;bl=f[cl>>2]|0;f[wa>>2]=f[cl+4>>2];f[Hk>>2]=bl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;opa(j,k,l,wa,17,0,m);f[Ik>>2]=0;f[Jk>>2]=0;f[j>>2]=16842752;f[Kk>>2]=fa;bl=Lk;f[bl>>2]=0;f[bl+4>>2]=0;f[k>>2]=33619968;f[Mk>>2]=ia;f[Nk>>2]=0;f[Ok>>2]=0;f[l>>2]=16842752;f[Pk>>2]=J;bl=f[Xb>>2]|0;cl=f[bl>>2]|0;f[xa>>2]=f[bl+4>>2];f[Qk>>2]=cl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;opa(j,k,l,xa,17,0,m);f[Rk>>2]=0;f[Sk>>2]=0;f[j>>2]=16842752;f[Tk>>2]=_;cl=Uk;f[cl>>2]=0;f[cl+4>>2]=0;f[k>>2]=33619968;f[Vk>>2]=X;f[Wk>>2]=0;f[Xk>>2]=0;f[l>>2]=16842752;f[Yk>>2]=J;cl=f[Gb>>2]|0;bl=f[cl>>2]|0;f[ya>>2]=f[cl+4>>2];f[Zk>>2]=bl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;opa(j,k,l,ya,16,0,m)};f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;f[Da+16>>2]=0;f[Da+20>>2]=0;f[Da+24>>2]=0;f[Da+28>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;f[Ea+16>>2]=0;f[Ea+20>>2]=0;f[Ea+24>>2]=0;f[Ea+28>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;f[Fa+16>>2]=0;f[Fa+20>>2]=0;f[Fa+24>>2]=0;f[Fa+28>>2]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;f[Ga+16>>2]=0;f[Ga+20>>2]=0;f[Ga+24>>2]=0;f[Ga+28>>2]=0;f[md>>2]=0;f[nd>>2]=0;f[j>>2]=16842752;f[od>>2]=W;f[k>>2]=-1040056314;f[pd>>2]=Da;f[qd>>2]=1;f[rd>>2]=4;f[l>>2]=-1040056314;f[sd>>2]=Ea;f[td>>2]=1;f[ud>>2]=4;f[vd>>2]=0;f[wd>>2]=0;f[m>>2]=16842752;f[xd>>2]=X;F2(j,k,l,m);f[yd>>2]=0;f[zd>>2]=0;f[j>>2]=16842752;f[Ad>>2]=U;f[k>>2]=-1040056314;f[Bd>>2]=Fa;f[Cd>>2]=1;f[Dd>>2]=4;f[l>>2]=-1040056314;f[Ed>>2]=Ga;f[Fd>>2]=1;f[Gd>>2]=4;f[Hd>>2]=0;f[Id>>2]=0;f[m>>2]=16842752;f[Jd>>2]=X;F2(j,k,l,m);f[Kd>>2]=0;f[Ld>>2]=0;f[j>>2]=16842752;f[Md>>2]=W;f[k>>2]=-1056833530;f[Pd>>2]=Da;f[Nd>>2]=1;f[Od>>2]=4;bl=Qd;f[bl>>2]=0;f[bl+4>>2]=0;f[l>>2]=33619968;f[Rd>>2]=W;f[Sd>>2]=0;f[Td>>2]=0;f[m>>2]=16842752;f[Ud>>2]=X;oL(j,k,l,m,-1);AY(j,f[mb>>2]|0,f[Vd>>2]|0,f[T>>2]&4095);bl=f[j>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,j,T,-1);$j(j);f[Wd>>2]=0;f[Xd>>2]=0;f[j>>2]=16842752;f[Yd>>2]=U;f[k>>2]=-1056833530;f[$d>>2]=Fa;f[Zd>>2]=1;f[_d>>2]=4;bl=ae;f[bl>>2]=0;f[bl+4>>2]=0;f[l>>2]=33619968;f[be>>2]=T;f[ce>>2]=0;f[de>>2]=0;f[m>>2]=16842752;f[ee>>2]=X;oL(j,k,l,m,-1);f[fe>>2]=0;f[ge>>2]=0;f[j>>2]=16842752;f[he>>2]=X;dl=+(N2(j)|0);el=+p[Ga>>3];fl=+M(+(el*(dl*el)));f[ie>>2]=0;f[je>>2]=0;f[j>>2]=16842752;f[ke>>2]=X;el=+(N2(j)|0);dl=+p[Ea>>3];gl=+M(+(dl*(el*dl)));switch(e|0){case 2:{bl=f[Sb>>2]|0;cl=f[bl+4>>2]|0;hl=f[bl>>2]|0;bl=f[Xb>>2]|0;if(!((hl|0)==(f[bl>>2]|0)?(cl|0)==(f[bl+4>>2]|0):0)){Xa=137;break b}bl=f[db>>2]|0;if(!((hl|0)==(f[bl>>2]|0)?(cl|0)==(f[bl+4>>2]|0):0)){Xa=139;break b}bl=f[hb>>2]|0;if(!((hl|0)==(f[bl>>2]|0)?(cl|0)==(f[bl+4>>2]|0):0)){Xa=141;break b}if((f[Rb>>2]|0)!=(f[Zb>>2]|0)){Xa=143;break b}bl=f[Ae>>2]|0;cl=f[Be>>2]|0;if((bl|0)!=(cl*6|0)){Xa=145;break b}if((f[ma>>2]&4095|0)!=5){Xa=147;break b}f[Ce>>2]=0;f[De>>2]=0;f[m>>2]=16842752;f[Ee>>2]=Q;zY(l,ha,m,1.0);f[j>>2]=-2147483648;f[Fe>>2]=2147483647;f[k>>2]=0;f[Ge>>2]=cl;$S(o,ma,j,k);hl=f[l>>2]|0;ei[f[(f[hl>>2]|0)+12>>2]&511](hl,l,o,-1);hl=f[He>>2]|0;do if(hl|0){il=hl+12|0;jl=f[il>>2]|0;f[il>>2]=jl+-1;if((jl|0)!=1)break;_S(o)}while(0);f[He>>2]=0;f[Ie>>2]=0;f[Ie+4>>2]=0;f[Ie+8>>2]=0;f[Ie+12>>2]=0;if((f[Je>>2]|0)>0){hl=f[Ke>>2]|0;jl=0;do{f[hl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Je>>2]|0))}jl=f[Le>>2]|0;if((jl|0)!=(Me|0))g0(jl);$j(l);f[Ne>>2]=0;f[Oe>>2]=0;f[m>>2]=16842752;f[Pe>>2]=Q;zY(l,ia,m,1.0);jl=cl<<1;f[j>>2]=-2147483648;f[Qe>>2]=2147483647;f[k>>2]=cl;f[Re>>2]=jl;$S(q,ma,j,k);hl=f[l>>2]|0;ei[f[(f[hl>>2]|0)+12>>2]&511](hl,l,q,-1);hl=f[Se>>2]|0;do if(hl|0){il=hl+12|0;kl=f[il>>2]|0;f[il>>2]=kl+-1;if((kl|0)!=1)break;_S(q)}while(0);f[Se>>2]=0;f[Te>>2]=0;f[Te+4>>2]=0;f[Te+8>>2]=0;f[Te+12>>2]=0;if((f[Ue>>2]|0)>0){hl=f[Ve>>2]|0;kl=0;do{f[hl+(kl<<2)>>2]=0;kl=kl+1|0}while((kl|0)<(f[Ue>>2]|0))}kl=f[We>>2]|0;if((kl|0)!=(Xe|0))g0(kl);$j(l);f[Ye>>2]=0;f[Ze>>2]=0;f[m>>2]=16842752;f[_e>>2]=R;zY(l,ha,m,1.0);kl=cl*3|0;f[j>>2]=-2147483648;f[$e>>2]=2147483647;f[k>>2]=jl;f[af>>2]=kl;$S(r,ma,j,k);hl=f[l>>2]|0;ei[f[(f[hl>>2]|0)+12>>2]&511](hl,l,r,-1);hl=f[bf>>2]|0;do if(hl|0){il=hl+12|0;ll=f[il>>2]|0;f[il>>2]=ll+-1;if((ll|0)!=1)break;_S(r)}while(0);f[bf>>2]=0;f[cf>>2]=0;f[cf+4>>2]=0;f[cf+8>>2]=0;f[cf+12>>2]=0;if((f[df>>2]|0)>0){hl=f[ef>>2]|0;jl=0;do{f[hl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[df>>2]|0))}jl=f[ff>>2]|0;if((jl|0)!=(gf|0))g0(jl);$j(l);f[hf>>2]=0;f[jf>>2]=0;f[m>>2]=16842752;f[kf>>2]=R;zY(l,ia,m,1.0);jl=cl<<2;f[j>>2]=-2147483648;f[lf>>2]=2147483647;f[k>>2]=kl;f[mf>>2]=jl;$S(t,ma,j,k);hl=f[l>>2]|0;ei[f[(f[hl>>2]|0)+12>>2]&511](hl,l,t,-1);hl=f[nf>>2]|0;do if(hl|0){ll=hl+12|0;il=f[ll>>2]|0;f[ll>>2]=il+-1;if((il|0)!=1)break;_S(t)}while(0);f[nf>>2]=0;f[of>>2]=0;f[of+4>>2]=0;f[of+8>>2]=0;f[of+12>>2]=0;if((f[pf>>2]|0)>0){hl=f[qf>>2]|0;kl=0;do{f[hl+(kl<<2)>>2]=0;kl=kl+1|0}while((kl|0)<(f[pf>>2]|0))}kl=f[rf>>2]|0;if((kl|0)!=(sf|0))g0(kl);$j(l);kl=cl*5|0;f[j>>2]=-2147483648;f[tf>>2]=2147483647;f[k>>2]=jl;f[uf>>2]=kl;$S(m,ma,j,k);hl=vf;f[hl>>2]=0;f[hl+4>>2]=0;f[l>>2]=-1040121856;f[wf>>2]=m;h_(ha,l);hl=f[xf>>2]|0;do if(hl|0){il=hl+12|0;ll=f[il>>2]|0;f[il>>2]=ll+-1;if((ll|0)!=1)break;_S(m)}while(0);f[xf>>2]=0;f[yf>>2]=0;f[yf+4>>2]=0;f[yf+8>>2]=0;f[yf+12>>2]=0;if((f[zf>>2]|0)>0){hl=f[Af>>2]|0;jl=0;do{f[hl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[zf>>2]|0))}jl=f[Bf>>2]|0;if((jl|0)!=(Cf|0))g0(jl);f[j>>2]=-2147483648;f[Df>>2]=2147483647;f[k>>2]=kl;f[Ef>>2]=bl;$S(m,ma,j,k);jl=Ff;f[jl>>2]=0;f[jl+4>>2]=0;f[l>>2]=-1040121856;f[Gf>>2]=m;h_(ia,l);jl=f[Hf>>2]|0;do if(jl|0){hl=jl+12|0;cl=f[hl>>2]|0;f[hl>>2]=cl+-1;if((cl|0)!=1)break;_S(m)}while(0);f[Hf>>2]=0;f[If>>2]=0;f[If+4>>2]=0;f[If+8>>2]=0;f[If+12>>2]=0;if((f[Jf>>2]|0)>0){jl=f[Kf>>2]|0;bl=0;do{f[jl+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[Jf>>2]|0))}bl=f[Lf>>2]|0;if((bl|0)!=(Mf|0))g0(bl);break}case 3:{bl=f[Ua>>2]|0;jl=f[Sb>>2]|0;kl=f[jl+4>>2]|0;cl=f[jl>>2]|0;jl=f[Xb>>2]|0;if(!((cl|0)==(f[jl>>2]|0)?(kl|0)==(f[jl+4>>2]|0):0)){Xa=198;break b}jl=f[db>>2]|0;if(!((cl|0)==(f[jl>>2]|0)?(kl|0)==(f[jl+4>>2]|0):0)){Xa=200;break b}jl=f[hb>>2]|0;if(!((cl|0)==(f[jl>>2]|0)?(kl|0)==(f[jl+4>>2]|0):0)){Xa=202;break b}if((f[Rb>>2]|0)!=(f[Zb>>2]|0)){Xa=204;break b}jl=f[Ae>>2]|0;kl=f[Be>>2]|0;if((jl|0)!=(kl<<3|0)){Xa=206;break b}if((f[ma>>2]&4095|0)!=5){Xa=208;break b}if(!(f[J>>2]&16384)){Xa=210;break b}dl=+n[bl>>2];el=+n[bl+12>>2];ml=+n[bl+4>>2];nl=+n[bl+16>>2];ol=+n[bl+28>>2];pl=+n[bl+8>>2];ql=+n[bl+20>>2];nY(k,Q,+n[bl+24>>2]);nY(o,R,ol);eY(j,k,o);p[q>>3]=1.0;f[Nf>>2]=0;f[Nf+4>>2]=0;f[Nf+8>>2]=0;f[Nf+12>>2]=0;f[Nf+16>>2]=0;f[Nf+20>>2]=0;dY(m,j,q);f[l>>2]=1124007936;Pa=Of;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Qf>>2]=Pf;f[Sf>>2]=Rf;f[Rf>>2]=0;f[Tf>>2]=0;bl=f[m>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,m,l,-1);$j(m);$j(j);$j(o);$j(k);kY(q,Q);pY(k,q,dl);nY(t,R,ml);jY(j,k,t);p[v>>3]=pl;f[Uf>>2]=0;f[Uf+4>>2]=0;f[Uf+8>>2]=0;f[Uf+12>>2]=0;f[Uf+16>>2]=0;f[Uf+20>>2]=0;iY(r,j,v);f[o>>2]=1124007936;Pa=Vf;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Xf>>2]=Wf;f[Zf>>2]=Yf;f[Yf>>2]=0;f[_f>>2]=0;bl=f[r>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,r,o,-1);$j(r);$j(j);$j(t);$j(k);$j(q);f[$f>>2]=0;f[ag>>2]=0;f[j>>2]=16842752;f[bg>>2]=o;f[cg>>2]=0;f[dg>>2]=0;f[k>>2]=16842752;f[eg>>2]=l;bl=fg;f[bl>>2]=0;f[bl+4>>2]=0;f[q>>2]=33619968;f[gg>>2]=o;rL(j,k,q,1.0,-1);kY(t,Q);pY(k,t,el);nY(v,R,nl);jY(j,k,v);p[x>>3]=ql;f[hg>>2]=0;f[hg+4>>2]=0;f[hg+8>>2]=0;f[hg+12>>2]=0;f[hg+16>>2]=0;f[hg+20>>2]=0;iY(w,j,x);f[q>>2]=1124007936;Pa=ig;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[kg>>2]=jg;f[mg>>2]=lg;f[lg>>2]=0;f[ng>>2]=0;bl=f[w>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,w,q,-1);$j(w);$j(j);$j(v);$j(k);$j(t);f[og>>2]=0;f[pg>>2]=0;f[j>>2]=16842752;f[qg>>2]=q;f[rg>>2]=0;f[sg>>2]=0;f[k>>2]=16842752;f[tg>>2]=l;bl=ug;f[bl>>2]=0;f[bl+4>>2]=0;f[t>>2]=33619968;f[vg>>2]=q;rL(j,k,t,1.0,-1);f[t>>2]=1124007936;Pa=wg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[yg>>2]=xg;f[Ag>>2]=zg;f[zg>>2]=0;f[Bg>>2]=0;f[v>>2]=1124007936;Pa=Cg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Eg>>2]=Dg;f[Gg>>2]=Fg;f[Fg>>2]=0;f[Hg>>2]=0;f[Ig>>2]=0;f[Jg>>2]=0;f[j>>2]=16842752;f[Kg>>2]=ha;f[Lg>>2]=0;f[Mg>>2]=0;f[k>>2]=16842752;f[Ng>>2]=l;bl=Og;f[bl>>2]=0;f[bl+4>>2]=0;f[x>>2]=33619968;f[Pg>>2]=t;rL(j,k,x,1.0,-1);f[Qg>>2]=0;f[Rg>>2]=0;f[j>>2]=16842752;f[Sg>>2]=ia;f[Tg>>2]=0;f[Ug>>2]=0;f[k>>2]=16842752;f[Vg>>2]=l;bl=Wg;f[bl>>2]=0;f[bl+4>>2]=0;f[x>>2]=33619968;f[Xg>>2]=v;rL(j,k,x,1.0,-1);f[Yg>>2]=0;f[Zg>>2]=0;f[y>>2]=16842752;f[_g>>2]=Q;zY(x,t,y,1.0);f[j>>2]=-2147483648;f[$g>>2]=2147483647;f[k>>2]=0;f[ah>>2]=kl;$S(z,ma,j,k);bl=f[x>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,x,z,-1);bl=f[bh>>2]|0;do if(bl|0){cl=bl+12|0;hl=f[cl>>2]|0;f[cl>>2]=hl+-1;if((hl|0)!=1)break;_S(z)}while(0);f[bh>>2]=0;f[ch>>2]=0;f[ch+4>>2]=0;f[ch+8>>2]=0;f[ch+12>>2]=0;if((f[dh>>2]|0)>0){bl=f[eh>>2]|0;hl=0;do{f[bl+(hl<<2)>>2]=0;hl=hl+1|0}while((hl|0)<(f[dh>>2]|0))}hl=f[fh>>2]|0;if((hl|0)!=(gh|0))g0(hl);$j(x);f[hh>>2]=0;f[ih>>2]=0;f[y>>2]=16842752;f[jh>>2]=Q;zY(x,v,y,1.0);hl=kl<<1;f[j>>2]=-2147483648;f[kh>>2]=2147483647;f[k>>2]=kl;f[lh>>2]=hl;$S(A,ma,j,k);bl=f[x>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,x,A,-1);bl=f[mh>>2]|0;do if(bl|0){cl=bl+12|0;ll=f[cl>>2]|0;f[cl>>2]=ll+-1;if((ll|0)!=1)break;_S(A)}while(0);f[mh>>2]=0;f[nh>>2]=0;f[nh+4>>2]=0;f[nh+8>>2]=0;f[nh+12>>2]=0;if((f[oh>>2]|0)>0){bl=f[ph>>2]|0;ll=0;do{f[bl+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[oh>>2]|0))}ll=f[qh>>2]|0;if((ll|0)!=(rh|0))g0(ll);$j(x);f[sh>>2]=0;f[th>>2]=0;f[k>>2]=16842752;f[uh>>2]=t;zY(j,o,k,1.0);f[vh>>2]=0;f[wh>>2]=0;f[C>>2]=16842752;f[xh>>2]=v;zY(y,q,C,1.0);eY(B,j,y);f[x>>2]=1124007936;Pa=yh;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ah>>2]=zh;f[Ch>>2]=Bh;f[Bh>>2]=0;f[Dh>>2]=0;ll=f[B>>2]|0;ei[f[(f[ll>>2]|0)+12>>2]&511](ll,B,x,-1);$j(B);$j(y);$j(j);f[Eh>>2]=0;f[Fh>>2]=0;f[C>>2]=16842752;f[Gh>>2]=Q;zY(y,x,C,1.0);ll=kl*3|0;f[j>>2]=-2147483648;f[Hh>>2]=2147483647;f[k>>2]=hl;f[Ih>>2]=ll;$S(D,ma,j,k);bl=f[y>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,y,D,-1);bl=f[Jh>>2]|0;do if(bl|0){cl=bl+12|0;il=f[cl>>2]|0;f[cl>>2]=il+-1;if((il|0)!=1)break;_S(D)}while(0);f[Jh>>2]=0;f[Kh>>2]=0;f[Kh+4>>2]=0;f[Kh+8>>2]=0;f[Kh+12>>2]=0;if((f[Lh>>2]|0)>0){bl=f[Mh>>2]|0;hl=0;do{f[bl+(hl<<2)>>2]=0;hl=hl+1|0}while((hl|0)<(f[Lh>>2]|0))}hl=f[Nh>>2]|0;if((hl|0)!=(Oh|0))g0(hl);$j(y);hl=f[Ph>>2]|0;do if(hl|0){bl=hl+12|0;il=f[bl>>2]|0;f[bl>>2]=il+-1;if((il|0)!=1)break;_S(o)}while(0);f[Ph>>2]=0;f[Qh>>2]=0;f[Qh+4>>2]=0;f[Qh+8>>2]=0;f[Qh+12>>2]=0;if((f[Vf>>2]|0)>0){hl=f[Xf>>2]|0;il=0;do{f[hl+(il<<2)>>2]=0;il=il+1|0}while((il|0)<(f[Vf>>2]|0))}il=f[Rh>>2]|0;do if(il|0){hl=il+12|0;bl=f[hl>>2]|0;f[hl>>2]=bl+-1;if((bl|0)!=1)break;_S(q)}while(0);f[Rh>>2]=0;f[Sh>>2]=0;f[Sh+4>>2]=0;f[Sh+8>>2]=0;f[Sh+12>>2]=0;if((f[ig>>2]|0)>0){il=f[kg>>2]|0;bl=0;do{f[il+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[ig>>2]|0))}f[Th>>2]=0;f[Uh>>2]=0;f[C>>2]=16842752;f[Vh>>2]=R;zY(y,t,C,1.0);bl=kl<<2;f[j>>2]=-2147483648;f[Wh>>2]=2147483647;f[k>>2]=ll;f[Xh>>2]=bl;$S(E,ma,j,k);il=f[y>>2]|0;ei[f[(f[il>>2]|0)+12>>2]&511](il,y,E,-1);il=f[Yh>>2]|0;do if(il|0){hl=il+12|0;cl=f[hl>>2]|0;f[hl>>2]=cl+-1;if((cl|0)!=1)break;_S(E)}while(0);f[Yh>>2]=0;f[Zh>>2]=0;f[Zh+4>>2]=0;f[Zh+8>>2]=0;f[Zh+12>>2]=0;if((f[_h>>2]|0)>0){il=f[$h>>2]|0;ll=0;do{f[il+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[_h>>2]|0))}ll=f[ai>>2]|0;if((ll|0)!=(bi|0))g0(ll);$j(y);f[ci>>2]=0;f[di>>2]=0;f[C>>2]=16842752;f[fi>>2]=R;zY(y,v,C,1.0);ll=kl*5|0;f[j>>2]=-2147483648;f[gi>>2]=2147483647;f[k>>2]=bl;f[hi>>2]=ll;$S(F,ma,j,k);il=f[y>>2]|0;ei[f[(f[il>>2]|0)+12>>2]&511](il,y,F,-1);il=f[ii>>2]|0;do if(il|0){cl=il+12|0;hl=f[cl>>2]|0;f[cl>>2]=hl+-1;if((hl|0)!=1)break;_S(F)}while(0);f[ii>>2]=0;f[ji>>2]=0;f[ji+4>>2]=0;f[ji+8>>2]=0;f[ji+12>>2]=0;if((f[ki>>2]|0)>0){il=f[li>>2]|0;bl=0;do{f[il+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[ki>>2]|0))}bl=f[mi>>2]|0;if((bl|0)!=(ni|0))g0(bl);$j(y);f[oi>>2]=0;f[pi>>2]=0;f[C>>2]=16842752;f[qi>>2]=R;zY(y,x,C,1.0);bl=kl*6|0;f[j>>2]=-2147483648;f[ri>>2]=2147483647;f[k>>2]=ll;f[si>>2]=bl;$S(G,ma,j,k);il=f[y>>2]|0;ei[f[(f[il>>2]|0)+12>>2]&511](il,y,G,-1);il=f[ti>>2]|0;do if(il|0){hl=il+12|0;cl=f[hl>>2]|0;f[hl>>2]=cl+-1;if((cl|0)!=1)break;_S(G)}while(0);f[ti>>2]=0;f[ui>>2]=0;f[ui+4>>2]=0;f[ui+8>>2]=0;f[ui+12>>2]=0;if((f[vi>>2]|0)>0){il=f[wi>>2]|0;ll=0;do{f[il+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[vi>>2]|0))}ll=f[xi>>2]|0;if((ll|0)!=(yi|0))g0(ll);$j(y);ll=kl*7|0;f[j>>2]=-2147483648;f[zi>>2]=2147483647;f[k>>2]=bl;f[Ai>>2]=ll;$S(C,ma,j,k);il=Bi;f[il>>2]=0;f[il+4>>2]=0;f[y>>2]=-1040121856;f[Ci>>2]=C;h_(t,y);il=f[Di>>2]|0;do if(il|0){cl=il+12|0;hl=f[cl>>2]|0;f[cl>>2]=hl+-1;if((hl|0)!=1)break;_S(C)}while(0);f[Di>>2]=0;f[Ei>>2]=0;f[Ei+4>>2]=0;f[Ei+8>>2]=0;f[Ei+12>>2]=0;if((f[Fi>>2]|0)>0){il=f[Gi>>2]|0;bl=0;do{f[il+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[Fi>>2]|0))}bl=f[Hi>>2]|0;if((bl|0)!=(Ii|0))g0(bl);f[j>>2]=-2147483648;f[Ji>>2]=2147483647;f[k>>2]=ll;f[Ki>>2]=jl;$S(C,ma,j,k);bl=Li;f[bl>>2]=0;f[bl+4>>2]=0;f[y>>2]=-1040121856;f[Mi>>2]=C;h_(v,y);bl=f[Ni>>2]|0;do if(bl|0){il=bl+12|0;kl=f[il>>2]|0;f[il>>2]=kl+-1;if((kl|0)!=1)break;_S(C)}while(0);f[Ni>>2]=0;f[Oi>>2]=0;f[Oi+4>>2]=0;f[Oi+8>>2]=0;f[Oi+12>>2]=0;if((f[Pi>>2]|0)>0){bl=f[Qi>>2]|0;jl=0;do{f[bl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Pi>>2]|0))}jl=f[Ri>>2]|0;if((jl|0)!=(Si|0))g0(jl);jl=f[Ti>>2]|0;do if(jl|0){bl=jl+12|0;ll=f[bl>>2]|0;f[bl>>2]=ll+-1;if((ll|0)!=1)break;_S(x)}while(0);f[Ti>>2]=0;f[Ui>>2]=0;f[Ui+4>>2]=0;f[Ui+8>>2]=0;f[Ui+12>>2]=0;if((f[yh>>2]|0)>0){jl=f[Ah>>2]|0;ll=0;do{f[jl+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[yh>>2]|0))}ll=f[Ch>>2]|0;if((ll|0)!=(Bh|0))g0(ll);ll=f[Vi>>2]|0;do if(ll|0){jl=ll+12|0;bl=f[jl>>2]|0;f[jl>>2]=bl+-1;if((bl|0)!=1)break;_S(v)}while(0);f[Vi>>2]=0;f[Wi>>2]=0;f[Wi+4>>2]=0;f[Wi+8>>2]=0;f[Wi+12>>2]=0;if((f[Cg>>2]|0)>0){ll=f[Eg>>2]|0;bl=0;do{f[ll+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[Cg>>2]|0))}bl=f[Gg>>2]|0;if((bl|0)!=(Fg|0))g0(bl);bl=f[Xi>>2]|0;do if(bl|0){ll=bl+12|0;jl=f[ll>>2]|0;f[ll>>2]=jl+-1;if((jl|0)!=1)break;_S(t)}while(0);f[Xi>>2]=0;f[Yi>>2]=0;f[Yi+4>>2]=0;f[Yi+8>>2]=0;f[Yi+12>>2]=0;if((f[wg>>2]|0)>0){bl=f[yg>>2]|0;jl=0;do{f[bl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[wg>>2]|0))}jl=f[Ag>>2]|0;if((jl|0)!=(zg|0))g0(jl);jl=f[Rh>>2]|0;do if(jl|0){bl=jl+12|0;ll=f[bl>>2]|0;f[bl>>2]=ll+-1;if((ll|0)!=1)break;_S(q)}while(0);f[Rh>>2]=0;f[Sh>>2]=0;f[Sh+4>>2]=0;f[Sh+8>>2]=0;f[Sh+12>>2]=0;if((f[ig>>2]|0)>0){jl=f[kg>>2]|0;ll=0;do{f[jl+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[ig>>2]|0))}ll=f[mg>>2]|0;if((ll|0)!=(lg|0))g0(ll);ll=f[Ph>>2]|0;do if(ll|0){jl=ll+12|0;bl=f[jl>>2]|0;f[jl>>2]=bl+-1;if((bl|0)!=1)break;_S(o)}while(0);f[Ph>>2]=0;f[Qh>>2]=0;f[Qh+4>>2]=0;f[Qh+8>>2]=0;f[Qh+12>>2]=0;if((f[Vf>>2]|0)>0){ll=f[Xf>>2]|0;bl=0;do{f[ll+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[Vf>>2]|0))}bl=f[Zf>>2]|0;if((bl|0)!=(Yf|0))g0(bl);bl=f[Zi>>2]|0;do if(bl|0){ll=bl+12|0;jl=f[ll>>2]|0;f[ll>>2]=jl+-1;if((jl|0)!=1)break;_S(l)}while(0);f[Zi>>2]=0;f[_i>>2]=0;f[_i+4>>2]=0;f[_i+8>>2]=0;f[_i+12>>2]=0;if((f[Of>>2]|0)>0){bl=f[Qf>>2]|0;jl=0;do{f[bl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Of>>2]|0))}jl=f[Sf>>2]|0;if((jl|0)!=(Rf|0))g0(jl);break}case 0:{jl=f[Sb>>2]|0;bl=f[Xb>>2]|0;if(!((f[jl>>2]|0)==(f[bl>>2]|0)?(f[jl+4>>2]|0)==(f[bl+4>>2]|0):0)){Xa=337;break b}if((f[Rb>>2]|0)!=(f[Zb>>2]|0)){Xa=339;break b}bl=f[Ae>>2]|0;jl=f[Be>>2]|0;if((bl|0)!=(jl<<1|0)){Xa=341;break b}if((f[ma>>2]&4095|0)!=5){Xa=343;break b}f[j>>2]=-2147483648;f[$i>>2]=2147483647;f[k>>2]=0;f[aj>>2]=jl;$S(m,ma,j,k);ll=bj;f[ll>>2]=0;f[ll+4>>2]=0;f[l>>2]=-1040121856;f[cj>>2]=m;h_(ha,l);ll=f[dj>>2]|0;do if(ll|0){kl=ll+12|0;il=f[kl>>2]|0;f[kl>>2]=il+-1;if((il|0)!=1)break;_S(m)}while(0);f[dj>>2]=0;f[ej>>2]=0;f[ej+4>>2]=0;f[ej+8>>2]=0;f[ej+12>>2]=0;if((f[fj>>2]|0)>0){ll=f[gj>>2]|0;il=0;do{f[ll+(il<<2)>>2]=0;il=il+1|0}while((il|0)<(f[fj>>2]|0))}il=f[hj>>2]|0;if((il|0)!=(ij|0))g0(il);f[j>>2]=-2147483648;f[jj>>2]=2147483647;f[k>>2]=jl;f[kj>>2]=bl;$S(m,ma,j,k);il=lj;f[il>>2]=0;f[il+4>>2]=0;f[l>>2]=-1040121856;f[mj>>2]=m;h_(ia,l);il=f[nj>>2]|0;do if(il|0){ll=il+12|0;kl=f[ll>>2]|0;f[ll>>2]=kl+-1;if((kl|0)!=1)break;_S(m)}while(0);f[nj>>2]=0;f[oj>>2]=0;f[oj+4>>2]=0;f[oj+8>>2]=0;f[oj+12>>2]=0;if((f[pj>>2]|0)>0){il=f[qj>>2]|0;bl=0;do{f[il+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[pj>>2]|0))}bl=f[rj>>2]|0;if((bl|0)!=(sj|0))g0(bl);break}case 1:{bl=f[Ua>>2]|0;il=f[Sb>>2]|0;jl=f[il+4>>2]|0;kl=f[il>>2]|0;il=f[Xb>>2]|0;if(!((kl|0)==(f[il>>2]|0)?(jl|0)==(f[il+4>>2]|0):0)){Xa=362;break b}il=f[db>>2]|0;if(!((kl|0)==(f[il>>2]|0)?(jl|0)==(f[il+4>>2]|0):0)){Xa=364;break b}il=f[hb>>2]|0;if(!((kl|0)==(f[il>>2]|0)?(jl|0)==(f[il+4>>2]|0):0)){Xa=366;break b}if((f[Rb>>2]|0)!=(f[Zb>>2]|0)){Xa=368;break b}il=f[Ae>>2]|0;jl=f[Be>>2]|0;if((il|0)!=(jl*3|0)){Xa=370;break b}if((f[ma>>2]&4095|0)!=5){Xa=372;break b}if(!(f[J>>2]&16384)){Xa=374;break b}ql=+n[bl>>2];nl=+n[bl+12>>2];nY(k,Q,nl);lY(j,k);el=ql;nY(o,R,el);jY(m,j,o);f[l>>2]=1124007936;Pa=tj;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[vj>>2]=uj;f[xj>>2]=wj;f[wj>>2]=0;f[yj>>2]=0;bl=f[m>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,m,l,-1);$j(m);$j(o);$j(j);$j(k);nY(j,Q,el);nY(k,R,nl);jY(q,j,k);f[o>>2]=1124007936;Pa=zj;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Bj>>2]=Aj;f[Dj>>2]=Cj;f[Cj>>2]=0;f[Ej>>2]=0;bl=f[q>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,q,o,-1);$j(q);$j(k);$j(j);f[Fj>>2]=0;f[Gj>>2]=0;f[v>>2]=16842752;f[Hj>>2]=l;zY(t,ha,v,1.0);f[Ij>>2]=0;f[Jj>>2]=0;f[x>>2]=16842752;f[Kj>>2]=o;zY(w,ia,x,1.0);eY(r,t,w);f[j>>2]=-2147483648;f[Lj>>2]=2147483647;f[k>>2]=0;f[Mj>>2]=jl;$S(y,ma,j,k);bl=f[r>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,r,y,-1);bl=f[Nj>>2]|0;do if(bl|0){kl=bl+12|0;ll=f[kl>>2]|0;f[kl>>2]=ll+-1;if((ll|0)!=1)break;_S(y)}while(0);f[Nj>>2]=0;f[Oj>>2]=0;f[Oj+4>>2]=0;f[Oj+8>>2]=0;f[Oj+12>>2]=0;if((f[Pj>>2]|0)>0){bl=f[Qj>>2]|0;ll=0;do{f[bl+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[Pj>>2]|0))}ll=f[Rj>>2]|0;if((ll|0)!=(Sj|0))g0(ll);$j(r);$j(w);$j(t);ll=jl<<1;f[j>>2]=-2147483648;f[Tj>>2]=2147483647;f[k>>2]=jl;f[Uj>>2]=ll;$S(t,ma,j,k);bl=Vj;f[bl>>2]=0;f[bl+4>>2]=0;f[r>>2]=-1040121856;f[Wj>>2]=t;h_(ha,r);bl=f[Xj>>2]|0;do if(bl|0){kl=bl+12|0;hl=f[kl>>2]|0;f[kl>>2]=hl+-1;if((hl|0)!=1)break;_S(t)}while(0);f[Xj>>2]=0;f[Yj>>2]=0;f[Yj+4>>2]=0;f[Yj+8>>2]=0;f[Yj+12>>2]=0;if((f[Zj>>2]|0)>0){bl=f[_j>>2]|0;jl=0;do{f[bl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Zj>>2]|0))}jl=f[ak>>2]|0;if((jl|0)!=(bk|0))g0(jl);f[j>>2]=-2147483648;f[ck>>2]=2147483647;f[k>>2]=ll;f[dk>>2]=il;$S(t,ma,j,k);jl=ek;f[jl>>2]=0;f[jl+4>>2]=0;f[r>>2]=-1040121856;f[fk>>2]=t;h_(ia,r);jl=f[gk>>2]|0;do if(jl|0){bl=jl+12|0;hl=f[bl>>2]|0;f[bl>>2]=hl+-1;if((hl|0)!=1)break;_S(t)}while(0);f[gk>>2]=0;f[hk>>2]=0;f[hk+4>>2]=0;f[hk+8>>2]=0;f[hk+12>>2]=0;if((f[ik>>2]|0)>0){jl=f[jk>>2]|0;il=0;do{f[jl+(il<<2)>>2]=0;il=il+1|0}while((il|0)<(f[ik>>2]|0))}il=f[kk>>2]|0;if((il|0)!=(lk|0))g0(il);il=f[mk>>2]|0;do if(il|0){jl=il+12|0;ll=f[jl>>2]|0;f[jl>>2]=ll+-1;if((ll|0)!=1)break;_S(o)}while(0);f[mk>>2]=0;f[nk>>2]=0;f[nk+4>>2]=0;f[nk+8>>2]=0;f[nk+12>>2]=0;if((f[zj>>2]|0)>0){il=f[Bj>>2]|0;ll=0;do{f[il+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[zj>>2]|0))}ll=f[Dj>>2]|0;if((ll|0)!=(Cj|0))g0(ll);ll=f[ok>>2]|0;do if(ll|0){il=ll+12|0;jl=f[il>>2]|0;f[il>>2]=jl+-1;if((jl|0)!=1)break;_S(l)}while(0);f[ok>>2]=0;f[pk>>2]=0;f[pk+4>>2]=0;f[pk+8>>2]=0;f[pk+12>>2]=0;if((f[tj>>2]|0)>0){ll=f[vj>>2]|0;jl=0;do{f[ll+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[tj>>2]|0))}jl=f[xj>>2]|0;if((jl|0)!=(wj|0))g0(jl);break}default:{}}QEa(ma,ma,na);yY(j,na,0);jl=f[j>>2]|0;ei[f[(f[jl>>2]|0)+12>>2]&511](jl,j,oa,-1);$j(j);f[le>>2]=0;f[me>>2]=0;f[j>>2]=16842752;f[ne>>2]=W;nl=+zO(T,j);el=nl/(fl*gl);p[s>>3]=el;if(((f[s+4>>2]&2147483647)+((f[s>>2]|0)!=0&1)|0)>>>0>2146435072){Xa=417;break}QEa(ma,W,pa);QEa(ma,T,qa);mY(j,oa,pa);jl=f[j>>2]|0;ei[f[(f[jl>>2]|0)+12>>2]&511](jl,j,ra,-1);$j(j);f[oe>>2]=0;f[pe>>2]=0;f[j>>2]=16842752;f[qe>>2]=ra;ql=gl*gl-+zO(pa,j);f[re>>2]=0;f[se>>2]=0;f[j>>2]=16842752;f[te>>2]=ra;pl=nl-+zO(qa,j);if(pl<=0.0){Xa=419;break}oY(k,ql/pl,T);hY(j,k,W);jl=f[j>>2]|0;ei[f[(f[jl>>2]|0)+12>>2]&511](jl,j,ua,-1);$j(j);$j(k);QEa(ma,ua,sa);mY(j,oa,sa);jl=f[j>>2]|0;ei[f[(f[jl>>2]|0)+12>>2]&511](jl,j,ta,-1);$j(j);jl=f[J>>2]|0;if((jl&4095|0)!=5){Xa=421;break}ll=f[ta>>2]|0;if((ll&4095|0)!=5){Xa=423;break}if(!xe){Xa=425;break}il=f[Wa>>2]|0;do if(g){if(!((il|0)==3&(f[yc>>2]|0)==8)){Xa=428;break b}}else{hl=(il|0)==2;bl=f[yc>>2]|0;if(we)if(hl&(bl|0)==6)break;else{Xa=431;break b}if(ve)if(hl&(bl|0)==3)break;else{Xa=434;break b}else if(hl&(bl|0)==2)break;else{Xa=436;break b}}while(0);if((f[ye>>2]|0)!=1){Xa=438;break}if(!(jl&16384)){Xa=440;break}if(!(ll&16384)){Xa=442;break}il=f[Ua>>2]|0;bl=f[ze>>2]|0;if(ue){hl=il+8|0;n[hl>>2]=+n[bl>>2]+ +n[hl>>2];hl=il+20|0;n[hl>>2]=+n[bl+4>>2]+ +n[hl>>2]}if(we){n[il>>2]=+n[bl>>2]+ +n[il>>2];hl=il+12|0;n[hl>>2]=+n[bl+4>>2]+ +n[hl>>2];hl=il+4|0;n[hl>>2]=+n[bl+8>>2]+ +n[hl>>2];hl=il+16|0;n[hl>>2]=+n[bl+12>>2]+ +n[hl>>2];hl=il+8|0;n[hl>>2]=+n[bl+16>>2]+ +n[hl>>2];hl=il+20|0;n[hl>>2]=+n[bl+20>>2]+ +n[hl>>2]}if(g){n[il>>2]=+n[bl>>2]+ +n[il>>2];hl=il+12|0;n[hl>>2]=+n[bl+4>>2]+ +n[hl>>2];hl=il+24|0;n[hl>>2]=+n[bl+8>>2]+ +n[hl>>2];hl=il+4|0;n[hl>>2]=+n[bl+12>>2]+ +n[hl>>2];hl=il+16|0;n[hl>>2]=+n[bl+16>>2]+ +n[hl>>2];hl=il+28|0;n[hl>>2]=+n[bl+20>>2]+ +n[hl>>2];hl=il+8|0;n[hl>>2]=+n[bl+24>>2]+ +n[hl>>2];hl=il+20|0;n[hl>>2]=+n[bl+28>>2]+ +n[hl>>2]}if(ve){hl=il+12|0;gl=+n[bl>>2]+ +S(+(+n[hl>>2]));kl=il+8|0;n[kl>>2]=+n[bl+4>>2]+ +n[kl>>2];kl=il+20|0;n[kl>>2]=+n[bl+8>>2]+ +n[kl>>2];fl=+O(+gl);n[il+16>>2]=fl;n[il>>2]=fl;fl=+P(+gl);n[hl>>2]=fl;n[il+4>>2]=-fl}if(($k|0)<(_a|0)){fl=_k;_k=el;$k=$k+1|0;al=fl}else{Fc=el;break a}}switch(Xa|0){case 137:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,26)|0;Qa=375219;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375246,167);break}case 139:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,26)|0;Qa=375272;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375246,168);break}case 141:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,26)|0;Qa=375299;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375246,169);break}case 143:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,21)|0;Qa=375326;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375246,171);break}case 145:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,25)|0;Qa=375348;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375246,172);break}case 147:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,22)|0;Qa=375374;Ra=Pa+22|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375246,174);break}case 198:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,26)|0;Qa=375219;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375397,57);break}case 200:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,26)|0;Qa=375272;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375397,58);break}case 202:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,26)|0;Qa=375299;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375397,59);break}case 204:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,21)|0;Qa=375326;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375397,61);break}case 206:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,25)|0;Qa=375421;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375397,62);break}case 208:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,22)|0;Qa=375374;Ra=Pa+22|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375397,63);break}case 210:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,19)|0;Qa=375447;Ra=Pa+19|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375397,65);break}case 337:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,24)|0;Qa=375467;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375492,193);break}case 339:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,21)|0;Qa=375326;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375492,195);break}case 341:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,25)|0;Qa=375523;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375492,196);break}case 343:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,22)|0;Qa=375374;Ra=Pa+22|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375492,197);break}case 362:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,24)|0;Qa=375467;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375549,130);break}case 364:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,24)|0;Qa=375578;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375549,131);break}case 366:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,24)|0;Qa=375603;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375549,132);break}case 368:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,21)|0;Qa=375326;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375549,134);break}case 370:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,25)|0;Qa=375628;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375549,135);break}case 372:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,22)|0;Qa=375374;Ra=Pa+22|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375549,136);break}case 374:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,19)|0;Qa=375447;Ra=Pa+19|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375549,138);break}case 417:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,16)|0;Qa=375654;Ra=Pa+16|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-7,j,374787,525);break}case 419:{f[j>>2]=0;f[j+4>>2]=0;dJc(tT(j,132)|0,375671,132)|0;PEa(-7,j,374787,540);break}case 421:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,29)|0;Qa=375804;Ra=Pa+29|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,252);break}case 423:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,25)|0;Qa=375860;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,253);break}case 425:{f[j>>2]=0;f[j+4>>2]=0;dJc(tT(j,132)|0,375886,132)|0;PEa(-215,j,375834,256);break}case 428:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,40)|0;Qa=376019;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,259);break}case 431:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,40)|0;Qa=376060;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,261);break}case 434:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,40)|0;Qa=376101;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,263);break}case 436:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,40)|0;Qa=376142;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,265);break}case 438:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,16)|0;Qa=376183;Ra=Pa+16|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,267);break}case 440:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,25)|0;Qa=376200;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,269);break}case 442:{f[j>>2]=0;f[j+4>>2]=0;Pa=tT(j,21)|0;Qa=376226;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));PEa(-215,j,375834,270);break}}}while(0);j=ua+36|0;Qa=f[j>>2]|0;do if(Qa|0){Pa=Qa+12|0;Ra=f[Pa>>2]|0;f[Pa>>2]=Ra+-1;if((Ra|0)!=1)break;_S(ua)}while(0);f[j>>2]=0;j=ua+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[ab>>2]|0)>0){j=f[Dc>>2]|0;Dc=0;do{f[j+(Dc<<2)>>2]=0;Dc=Dc+1|0}while((Dc|0)<(f[ab>>2]|0))}ab=f[Ec>>2]|0;if((ab|0)!=(Cc|0))g0(ab);ab=ta+36|0;Cc=f[ab>>2]|0;do if(Cc|0){Ec=Cc+12|0;Dc=f[Ec>>2]|0;f[Ec>>2]=Dc+-1;if((Dc|0)!=1)break;_S(ta)}while(0);f[ab>>2]=0;ab=ta+16|0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[xc>>2]|0)>0){ab=f[zc>>2]|0;zc=0;do{f[ab+(zc<<2)>>2]=0;zc=zc+1|0}while((zc|0)<(f[xc>>2]|0))}xc=f[Bc>>2]|0;if((xc|0)!=(Ac|0))g0(xc);xc=sa+36|0;Ac=f[xc>>2]|0;do if(Ac|0){Bc=Ac+12|0;zc=f[Bc>>2]|0;f[Bc>>2]=zc+-1;if((zc|0)!=1)break;_S(sa)}while(0);f[xc>>2]=0;xc=sa+16|0;f[xc>>2]=0;f[xc+4>>2]=0;f[xc+8>>2]=0;f[xc+12>>2]=0;if((f[tc>>2]|0)>0){xc=f[vc>>2]|0;vc=0;do{f[xc+(vc<<2)>>2]=0;vc=vc+1|0}while((vc|0)<(f[tc>>2]|0))}tc=f[wc>>2]|0;if((tc|0)!=(uc|0))g0(tc);tc=ra+36|0;uc=f[tc>>2]|0;do if(uc|0){wc=uc+12|0;vc=f[wc>>2]|0;f[wc>>2]=vc+-1;if((vc|0)!=1)break;_S(ra)}while(0);f[tc>>2]=0;tc=ra+16|0;f[tc>>2]=0;f[tc+4>>2]=0;f[tc+8>>2]=0;f[tc+12>>2]=0;if((f[pc>>2]|0)>0){tc=f[rc>>2]|0;rc=0;do{f[tc+(rc<<2)>>2]=0;rc=rc+1|0}while((rc|0)<(f[pc>>2]|0))}pc=f[sc>>2]|0;if((pc|0)!=(qc|0))g0(pc);pc=qa+36|0;qc=f[pc>>2]|0;do if(qc|0){sc=qc+12|0;rc=f[sc>>2]|0;f[sc>>2]=rc+-1;if((rc|0)!=1)break;_S(qa)}while(0);f[pc>>2]=0;pc=qa+16|0;f[pc>>2]=0;f[pc+4>>2]=0;f[pc+8>>2]=0;f[pc+12>>2]=0;if((f[lc>>2]|0)>0){pc=f[nc>>2]|0;nc=0;do{f[pc+(nc<<2)>>2]=0;nc=nc+1|0}while((nc|0)<(f[lc>>2]|0))}lc=f[oc>>2]|0;if((lc|0)!=(mc|0))g0(lc);lc=pa+36|0;mc=f[lc>>2]|0;do if(mc|0){oc=mc+12|0;nc=f[oc>>2]|0;f[oc>>2]=nc+-1;if((nc|0)!=1)break;_S(pa)}while(0);f[lc>>2]=0;lc=pa+16|0;f[lc>>2]=0;f[lc+4>>2]=0;f[lc+8>>2]=0;f[lc+12>>2]=0;if((f[hc>>2]|0)>0){lc=f[jc>>2]|0;jc=0;do{f[lc+(jc<<2)>>2]=0;jc=jc+1|0}while((jc|0)<(f[hc>>2]|0))}hc=f[kc>>2]|0;if((hc|0)!=(ic|0))g0(hc);hc=oa+36|0;ic=f[hc>>2]|0;do if(ic|0){kc=ic+12|0;jc=f[kc>>2]|0;f[kc>>2]=jc+-1;if((jc|0)!=1)break;_S(oa)}while(0);f[hc>>2]=0;hc=oa+16|0;f[hc>>2]=0;f[hc+4>>2]=0;f[hc+8>>2]=0;f[hc+12>>2]=0;if((f[dc>>2]|0)>0){hc=f[fc>>2]|0;fc=0;do{f[hc+(fc<<2)>>2]=0;fc=fc+1|0}while((fc|0)<(f[dc>>2]|0))}dc=f[gc>>2]|0;if((dc|0)!=(ec|0))g0(dc);dc=na+36|0;ec=f[dc>>2]|0;do if(ec|0){gc=ec+12|0;fc=f[gc>>2]|0;f[gc>>2]=fc+-1;if((fc|0)!=1)break;_S(na)}while(0);f[dc>>2]=0;dc=na+16|0;f[dc>>2]=0;f[dc+4>>2]=0;f[dc+8>>2]=0;f[dc+12>>2]=0;if((f[la>>2]|0)>0){dc=f[bc>>2]|0;bc=0;do{f[dc+(bc<<2)>>2]=0;bc=bc+1|0}while((bc|0)<(f[la>>2]|0))}la=f[cc>>2]|0;if((la|0)!=(ac|0))g0(la);la=ma+36|0;ac=f[la>>2]|0;do if(ac|0){cc=ac+12|0;bc=f[cc>>2]|0;f[cc>>2]=bc+-1;if((bc|0)!=1)break;_S(ma)}while(0);f[la>>2]=0;la=ma+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[_b>>2]|0)>0){la=f[ja>>2]|0;ja=0;do{f[la+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[_b>>2]|0))}_b=f[$b>>2]|0;if((_b|0)!=(ka|0))g0(_b);_b=ia+36|0;ka=f[_b>>2]|0;do if(ka|0){$b=ka+12|0;ja=f[$b>>2]|0;f[$b>>2]=ja+-1;if((ja|0)!=1)break;_S(ia)}while(0);f[_b>>2]=0;_b=ia+16|0;f[_b>>2]=0;f[_b+4>>2]=0;f[_b+8>>2]=0;f[_b+12>>2]=0;if((f[Vb>>2]|0)>0){_b=f[Xb>>2]|0;Xb=0;do{f[_b+(Xb<<2)>>2]=0;Xb=Xb+1|0}while((Xb|0)<(f[Vb>>2]|0))}Vb=f[Yb>>2]|0;if((Vb|0)!=(Wb|0))g0(Vb);Vb=ha+36|0;Wb=f[Vb>>2]|0;do if(Wb|0){Yb=Wb+12|0;Xb=f[Yb>>2]|0;f[Yb>>2]=Xb+-1;if((Xb|0)!=1)break;_S(ha)}while(0);f[Vb>>2]=0;Vb=ha+16|0;f[Vb>>2]=0;f[Vb+4>>2]=0;f[Vb+8>>2]=0;f[Vb+12>>2]=0;if((f[ga>>2]|0)>0){Vb=f[Sb>>2]|0;Sb=0;do{f[Vb+(Sb<<2)>>2]=0;Sb=Sb+1|0}while((Sb|0)<(f[ga>>2]|0))}ga=f[Ub>>2]|0;if((ga|0)!=(Tb|0))g0(ga);ga=fa+36|0;Tb=f[ga>>2]|0;do if(Tb|0){Ub=Tb+12|0;Sb=f[Ub>>2]|0;f[Ub>>2]=Sb+-1;if((Sb|0)!=1)break;_S(fa)}while(0);f[ga>>2]=0;ga=fa+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[d>>2]|0)>0){ga=f[ea>>2]|0;ea=0;do{f[ga+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[d>>2]|0))}d=f[Qb>>2]|0;if((d|0)!=(Ya|0))g0(d);d=da+36|0;Ya=f[d>>2]|0;do if(Ya|0){Qb=Ya+12|0;ea=f[Qb>>2]|0;f[Qb>>2]=ea+-1;if((ea|0)!=1)break;_S(da)}while(0);f[d>>2]=0;d=da+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[ca>>2]|0)>0){d=f[Ob>>2]|0;Ob=0;do{f[d+(Ob<<2)>>2]=0;Ob=Ob+1|0}while((Ob|0)<(f[ca>>2]|0))}ca=f[Pb>>2]|0;if((ca|0)!=(ba|0))g0(ca);ca=aa+36|0;ba=f[ca>>2]|0;do if(ba|0){Pb=ba+12|0;Ob=f[Pb>>2]|0;f[Pb>>2]=Ob+-1;if((Ob|0)!=1)break;_S(aa)}while(0);f[ca>>2]=0;ca=aa+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[$>>2]|0)>0){ca=f[Nb>>2]|0;Nb=0;do{f[ca+(Nb<<2)>>2]=0;Nb=Nb+1|0}while((Nb|0)<(f[$>>2]|0))}$=f[Mb>>2]|0;if(($|0)!=(h|0))g0($);$=_+36|0;h=f[$>>2]|0;do if(h|0){Mb=h+12|0;Nb=f[Mb>>2]|0;f[Mb>>2]=Nb+-1;if((Nb|0)!=1)break;_S(_)}while(0);f[$>>2]=0;$=_+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[Ib>>2]|0)>0){$=f[Kb>>2]|0;Kb=0;do{f[$+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[Ib>>2]|0))}Ib=f[Lb>>2]|0;if((Ib|0)!=(Jb|0))g0(Ib);Ib=Z+36|0;Jb=f[Ib>>2]|0;do if(Jb|0){Lb=Jb+12|0;Kb=f[Lb>>2]|0;f[Lb>>2]=Kb+-1;if((Kb|0)!=1)break;_S(Z)}while(0);f[Ib>>2]=0;Ib=Z+16|0;Jb=Z+4|0;f[Ib>>2]=0;f[Ib+4>>2]=0;f[Ib+8>>2]=0;f[Ib+12>>2]=0;if((f[Jb>>2]|0)>0){Ib=f[Z+40>>2]|0;Kb=0;do{f[Ib+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[Jb>>2]|0))}Jb=f[Z+44>>2]|0;if((Jb|0)!=(Z+48|0))g0(Jb);Jb=X+36|0;Z=f[Jb>>2]|0;do if(Z|0){Kb=Z+12|0;Ib=f[Kb>>2]|0;f[Kb>>2]=Ib+-1;if((Ib|0)!=1)break;_S(X)}while(0);f[Jb>>2]=0;Jb=X+16|0;f[Jb>>2]=0;f[Jb+4>>2]=0;f[Jb+8>>2]=0;f[Jb+12>>2]=0;if((f[Eb>>2]|0)>0){Jb=f[Gb>>2]|0;Gb=0;do{f[Jb+(Gb<<2)>>2]=0;Gb=Gb+1|0}while((Gb|0)<(f[Eb>>2]|0))}Eb=f[Hb>>2]|0;if((Eb|0)!=(Fb|0))g0(Eb);Eb=W+36|0;Fb=f[Eb>>2]|0;do if(Fb|0){Hb=Fb+12|0;Gb=f[Hb>>2]|0;f[Hb>>2]=Gb+-1;if((Gb|0)!=1)break;_S(W)}while(0);f[Eb>>2]=0;Eb=W+16|0;f[Eb>>2]=0;f[Eb+4>>2]=0;f[Eb+8>>2]=0;f[Eb+12>>2]=0;if((f[Ab>>2]|0)>0){Eb=f[Cb>>2]|0;Cb=0;do{f[Eb+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[Ab>>2]|0))}Ab=f[Db>>2]|0;if((Ab|0)!=(Bb|0))g0(Ab);Ab=V+36|0;Bb=f[Ab>>2]|0;do if(Bb|0){Db=Bb+12|0;Cb=f[Db>>2]|0;f[Db>>2]=Cb+-1;if((Cb|0)!=1)break;_S(V)}while(0);f[Ab>>2]=0;Ab=V+16|0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=0;f[Ab+12>>2]=0;if((f[wb>>2]|0)>0){Ab=f[yb>>2]|0;yb=0;do{f[Ab+(yb<<2)>>2]=0;yb=yb+1|0}while((yb|0)<(f[wb>>2]|0))}wb=f[zb>>2]|0;if((wb|0)!=(xb|0))g0(wb);wb=U+36|0;xb=f[wb>>2]|0;do if(xb|0){zb=xb+12|0;yb=f[zb>>2]|0;f[zb>>2]=yb+-1;if((yb|0)!=1)break;_S(U)}while(0);f[wb>>2]=0;wb=U+16|0;f[wb>>2]=0;f[wb+4>>2]=0;f[wb+8>>2]=0;f[wb+12>>2]=0;if((f[sb>>2]|0)>0){wb=f[ub>>2]|0;ub=0;do{f[wb+(ub<<2)>>2]=0;ub=ub+1|0}while((ub|0)<(f[sb>>2]|0))}sb=f[vb>>2]|0;if((sb|0)!=(tb|0))g0(sb);sb=T+36|0;tb=f[sb>>2]|0;do if(tb|0){vb=tb+12|0;ub=f[vb>>2]|0;f[vb>>2]=ub+-1;if((ub|0)!=1)break;_S(T)}while(0);f[sb>>2]=0;sb=T+16|0;f[sb>>2]=0;f[sb+4>>2]=0;f[sb+8>>2]=0;f[sb+12>>2]=0;if((f[pb>>2]|0)>0){sb=f[kb>>2]|0;kb=0;do{f[sb+(kb<<2)>>2]=0;kb=kb+1|0}while((kb|0)<(f[pb>>2]|0))}pb=f[rb>>2]|0;if((pb|0)!=(qb|0))g0(pb);pb=R+36|0;qb=f[pb>>2]|0;do if(qb|0){rb=qb+12|0;kb=f[rb>>2]|0;f[rb>>2]=kb+-1;if((kb|0)!=1)break;_S(R)}while(0);f[pb>>2]=0;pb=R+16|0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[fb>>2]|0)>0){pb=f[hb>>2]|0;hb=0;do{f[pb+(hb<<2)>>2]=0;hb=hb+1|0}while((hb|0)<(f[fb>>2]|0))}fb=f[ib>>2]|0;if((fb|0)!=(gb|0))g0(fb);fb=Q+36|0;gb=f[fb>>2]|0;do if(gb|0){ib=gb+12|0;hb=f[ib>>2]|0;f[ib>>2]=hb+-1;if((hb|0)!=1)break;_S(Q)}while(0);f[fb>>2]=0;fb=Q+16|0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[bb>>2]|0)>0){fb=f[db>>2]|0;db=0;do{f[fb+(db<<2)>>2]=0;db=db+1|0}while((db|0)<(f[bb>>2]|0))}bb=f[eb>>2]|0;if((bb|0)!=(cb|0))g0(bb);bb=f[ob>>2]|0;do if(bb|0){cb=bb+12|0;eb=f[cb>>2]|0;f[cb>>2]=eb+-1;if((eb|0)!=1)break;_S(N)}while(0);f[ob>>2]=0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[Ia>>2]|0)>0){lb=f[Ka>>2]|0;Ka=0;do{f[lb+(Ka<<2)>>2]=0;Ka=Ka+1|0}while((Ka|0)<(f[Ia>>2]|0))}Ia=f[La>>2]|0;if((Ia|0)!=(Ha|0))g0(Ia);Ia=f[nb>>2]|0;do if(Ia|0){Ha=Ia+12|0;La=f[Ha>>2]|0;f[Ha>>2]=La+-1;if((La|0)!=1)break;_S(K)}while(0);f[nb>>2]=0;f[jb>>2]=0;f[jb+4>>2]=0;f[jb+8>>2]=0;f[jb+12>>2]=0;if((f[Ja>>2]|0)>0){jb=f[Ta>>2]|0;Ta=0;do{f[jb+(Ta<<2)>>2]=0;Ta=Ta+1|0}while((Ta|0)<(f[Ja>>2]|0))}Ja=f[Sa>>2]|0;if((Ja|0)!=(Ma|0))g0(Ja);Ja=J+36|0;Ma=f[Ja>>2]|0;do if(Ma|0){Sa=Ma+12|0;Ta=f[Sa>>2]|0;f[Sa>>2]=Ta+-1;if((Ta|0)!=1)break;_S(J)}while(0);f[Ja>>2]=0;Ja=J+4|0;f[Ua>>2]=0;f[Ua+4>>2]=0;f[Ua+8>>2]=0;f[Ua+12>>2]=0;if((f[Ja>>2]|0)>0){Ua=f[J+40>>2]|0;Ma=0;do{f[Ua+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[Ja>>2]|0))}Ja=f[J+44>>2]|0;if((Ja|0)!=(J+48|0))g0(Ja);Ja=I+36|0;J=f[Ja>>2]|0;do if(J|0){Ma=J+12|0;Ua=f[Ma>>2]|0;f[Ma>>2]=Ua+-1;if((Ua|0)!=1)break;_S(I)}while(0);f[Ja>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[Na>>2]|0)>0){Oa=f[I+40>>2]|0;Ja=0;do{f[Oa+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[Na>>2]|0))}Na=f[I+44>>2]|0;if((Na|0)!=(I+48|0))g0(Na);Na=H+36|0;I=f[Na>>2]|0;do if(I|0){Ja=I+12|0;Oa=f[Ja>>2]|0;f[Ja>>2]=Oa+-1;if((Oa|0)!=1)break;_S(H)}while(0);f[Na>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[H+40>>2]|0;Na=0;do{f[c+(Na<<2)>>2]=0;Na=Na+1|0}while((Na|0)<(f[a>>2]|0))}a=f[H+44>>2]|0;if((a|0)==(H+48|0)){u=i;return +Fc}g0(a);u=i;return +Fc}function PEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,376347,d);return}function QEa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;e=u;u=u+192|0;g=e+176|0;h=e+168|0;i=e+112|0;j=e+56|0;k=e;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,22)|0;m=376248;o=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));PEa(-215,g,376271,219)}p=f[a+12>>2]|0;q=f[c+12>>2]|0;if((p|0)%(q|0)|0|0){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,28)|0;m=376297;o=l+28|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));PEa(-215,g,376271,220)}r=f[d+16>>2]|0;if((p|0)!=(q|0)){s=d+8|0;if((f[s>>2]|0)<=0){u=e;return}t=g+4|0;v=h+4|0;w=i+8|0;x=i+12|0;y=i+4|0;z=j+36|0;A=j+16|0;B=j+4|0;C=j+40|0;D=j+44|0;E=j+48|0;F=0;do{G=Y(F,q)|0;H=F;F=F+1|0;I=Y(F,q)|0;f[g>>2]=-2147483648;f[t>>2]=2147483647;f[h>>2]=G;f[v>>2]=I;$S(j,a,g,h);f[w>>2]=0;f[x>>2]=0;f[i>>2]=16842752;f[y>>2]=j;J=+zO(c,i);n[r+(H<<2)>>2]=J;H=f[z>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)_S(j);f[z>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){H=f[C>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[B>>2]|0))}I=f[D>>2]|0;if((I|0)!=(E|0))g0(I)}while((F|0)<(f[s>>2]|0));u=e;return}s=d+12|0;F=f[s>>2]|0;E=d+8|0;if((F|0)!=(f[E>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,20)|0;m=376326;o=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));PEa(-215,g,376271,233)}m=(p|0)/(F|0)|0;f[i>>2]=1124007936;p=i+4|0;d=i+8|0;D=i+40|0;l=p;o=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(o|0));f[D>>2]=d;l=i+48|0;o=i+44|0;f[o>>2]=l;f[l>>2]=0;f[i+52>>2]=0;if((F|0)>0){F=g+4|0;B=h+4|0;C=j+36|0;A=i+36|0;z=i+16|0;y=j+4|0;x=j+8|0;w=j+12|0;v=i+12|0;t=j+44|0;q=j+16|0;I=j+20|0;H=i+20|0;G=j+24|0;K=i+24|0;L=j+28|0;M=i+28|0;N=j+32|0;O=i+32|0;P=j+40|0;Q=j+48|0;R=g+8|0;S=g+12|0;T=g+4|0;U=g+4|0;V=h+4|0;W=j+8|0;X=j+12|0;Z=j+4|0;_=k+36|0;$=k+16|0;aa=k+4|0;ba=k+40|0;ca=k+44|0;da=k+48|0;ea=0;do{fa=Y(ea,m)|0;ga=ea;ea=ea+1|0;ha=Y(ea,m)|0;f[g>>2]=-2147483648;f[F>>2]=2147483647;f[h>>2]=fa;f[B>>2]=ha;$S(j,a,g,h);ha=f[C>>2]|0;if(ha|0){fa=ha+12|0;f[fa>>2]=(f[fa>>2]|0)+1}fa=f[A>>2]|0;if(fa|0?(ha=fa+12|0,fa=f[ha>>2]|0,f[ha>>2]=fa+-1,(fa|0)==1):0)_S(i);f[A>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[p>>2]|0)>0){fa=f[D>>2]|0;ha=0;do{f[fa+(ha<<2)>>2]=0;ha=ha+1|0;ia=f[p>>2]|0}while((ha|0)<(ia|0));f[i>>2]=f[j>>2];if((ia|0)<3)ja=43;else ja=45}else{f[i>>2]=f[j>>2];ja=43}if((ja|0)==43){ja=0;ha=f[y>>2]|0;if((ha|0)<3){f[p>>2]=ha;f[d>>2]=f[x>>2];f[v>>2]=f[w>>2];ha=f[t>>2]|0;fa=f[o>>2]|0;f[fa>>2]=f[ha>>2];f[fa+4>>2]=f[ha+4>>2]}else ja=45}if((ja|0)==45){ja=0;ZS(i,j)}f[z>>2]=f[q>>2];f[H>>2]=f[I>>2];f[K>>2]=f[G>>2];f[M>>2]=f[L>>2];f[O>>2]=f[N>>2];ha=f[C>>2]|0;f[A>>2]=ha;if(ha|0?(fa=ha+12|0,ha=f[fa>>2]|0,f[fa>>2]=ha+-1,(ha|0)==1):0)_S(j);f[C>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[y>>2]|0)>0){ha=f[P>>2]|0;fa=0;do{f[ha+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[y>>2]|0))}fa=f[t>>2]|0;if((fa|0)!=(Q|0))g0(fa);f[R>>2]=0;f[S>>2]=0;f[g>>2]=16842752;f[T>>2]=i;J=+PO(g,4,e0()|0);fa=f[E>>2]|0;ha=r+((Y(fa+1|0,ga)|0)<<2)|0;n[ha>>2]=J*J;if((ea|0)<(f[s>>2]|0)){ha=ea;do{ka=Y(ha,m)|0;la=ha;ha=ha+1|0;ma=Y(ha,m)|0;f[g>>2]=-2147483648;f[U>>2]=2147483647;f[h>>2]=ka;f[V>>2]=ma;$S(k,c,g,h);f[W>>2]=0;f[X>>2]=0;f[j>>2]=16842752;f[Z>>2]=k;J=+zO(i,j);ma=r+((Y(f[s>>2]|0,ga)|0)+la<<2)|0;n[ma>>2]=J;ma=f[_>>2]|0;if(ma|0?(ka=ma+12|0,ma=f[ka>>2]|0,f[ka>>2]=ma+-1,(ma|0)==1):0)_S(k);f[_>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[aa>>2]|0)>0){ma=f[ba>>2]|0;ka=0;do{f[ma+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[aa>>2]|0))}ka=f[ca>>2]|0;if((ka|0)!=(da|0))g0(ka);ka=f[s>>2]|0;ma=r+((Y(ka,ga)|0)+la<<2)|0;na=r+((Y(ka,la)|0)+ga<<2)|0;f[na>>2]=f[ma>>2]}while((ha|0)<(ka|0));oa=f[E>>2]|0}else oa=fa}while((ea|0)<(oa|0));oa=f[A>>2]|0;if((oa|0)!=0?(ea=oa+12|0,oa=f[ea>>2]|0,f[ea>>2]=oa+-1,(oa|0)==1):0){_S(i);pa=A}else pa=A}else pa=i+36|0;f[pa>>2]=0;pa=i+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[p>>2]|0)>0){pa=f[D>>2]|0;D=0;do{f[pa+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[p>>2]|0))}p=f[o>>2]|0;if((p|0)!=(l|0))g0(p);u=e;return}function REa(a){a=a|0;f[a>>2]=77608;uT(a+24|0);uT(a+16|0);mx(a+4|0);j0(a);return}function SEa(a){a=a|0;REa(a);YDc(a);return}function TEa(a,b,c){a=a|0;b=b|0;c=c|0;return}function UEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f$(b,e);f$(c,g);f[h>>2]=0;c=h+4|0;f[c>>2]=0;f[h+8>>2]=0;b=f[i>>2]|0;j=f[e>>2]|0;k=b-j|0;if(!k){l=j;m=b}else{mFa(h,(k|0)/56|0);l=f[e>>2]|0;m=f[i>>2]|0}if((m|0)!=(l|0)){m=0;k=l;do{f[(f[h>>2]|0)+(m<<2)>>2]=k+(m*56|0);m=m+1|0;k=f[e>>2]|0}while(m>>>0<(((f[i>>2]|0)-k|0)/56|0)>>>0)}Ti[f[(f[a>>2]|0)+32>>2]&511](a,h,g);a=f[h>>2]|0;if(!a){mx(g);mx(e);u=d;return}h=f[c>>2]|0;if((h|0)!=(a|0))f[c>>2]=h+(~((h+-4-a|0)>>>2)<<2);YDc(a);mx(g);mx(e);u=d;return}function VEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function WEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kFa(a,b,c,d);return}function XEa(a,b){a=a|0;b=b|0;return -1}function YEa(a,b){a=a|0;b=b|0;return 0}function ZEa(a,b){a=a|0;b=b|0;return (b|0)==3|0}function _Ea(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;a=d+8|0;e=d;f[e>>2]=0;d=e+4|0;f[d>>2]=0;g=c+28|0;tT(e,(f[g>>2]|0)+19|0)|0;h=f[e>>2]|0;i=h;j=376539;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));l=f[g>>2]|0;if(l|0)dJc(h+19|0,f[c+24>>2]|0,l|0)|0;f[a>>2]=0;f[a+4>>2]=0;tT(a,(f[d>>2]|0)+23|0)|0;l=f[d>>2]|0;if(!l)m=0;else{dJc(f[a>>2]|0,f[e>>2]|0,l|0)|0;m=f[d>>2]|0}i=(f[a>>2]|0)+m|0;j=376501;k=i+23|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-213,a,376559,376410,3138)}function $Ea(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;a=d+8|0;e=d;f[e>>2]=0;d=e+4|0;f[d>>2]=0;g=c+28|0;tT(e,(f[g>>2]|0)+29|0)|0;h=f[e>>2]|0;i=h;j=376471;k=i+29|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));l=f[g>>2]|0;if(l|0)dJc(h+29|0,f[c+24>>2]|0,l|0)|0;f[a>>2]=0;f[a+4>>2]=0;tT(a,(f[d>>2]|0)+23|0)|0;l=f[d>>2]|0;if(!l)m=0;else{dJc(f[a>>2]|0,f[e>>2]|0,l|0)|0;m=f[d>>2]|0}i=(f[a>>2]|0)+m|0;j=376501;k=i+23|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-213,a,376525,376410,3145)}function aFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function bFa(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function cFa(a,b){a=a|0;b=b|0;return 0}function dFa(a,b){a=a|0;b=b|0;return 0}function eFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;a=u;u=u+64|0;d=a;f[d>>2]=1124007936;e=d+4|0;g=d+8|0;h=d+40|0;i=e;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;k=d+48|0;l=d+44|0;f[l>>2]=k;f[k>>2]=0;f[d+52>>2]=0;m=d+36|0;if((d|0)!=(b|0)){n=b+36|0;o=f[n>>2]|0;if(o|0?(p=o+12|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)_S(b);f[n>>2]=0;o=b+16|0;p=b+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[p>>2]|0)>0){q=f[b+40>>2]|0;r=0;do{f[q+(r<<2)>>2]=0;r=r+1|0;s=f[p>>2]|0}while((r|0)<(s|0));f[b>>2]=f[d>>2];if((s|0)<3)t=10;else t=12}else{f[b>>2]=f[d>>2];t=10}if((t|0)==10){s=f[e>>2]|0;if((s|0)<3){f[p>>2]=s;f[b+8>>2]=f[g>>2];f[b+12>>2]=f[d+12>>2];g=f[l>>2]|0;s=f[b+44>>2]|0;f[s>>2]=f[g>>2];f[s+4>>2]=f[g+4>>2]}else t=12}if((t|0)==12)ZS(b,d);f[o>>2]=f[d+16>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];b=f[m>>2]|0;f[n>>2]=b;if(b|0?(n=b+12|0,b=f[n>>2]|0,f[n>>2]=b+-1,(b|0)==1):0)_S(d)}f[m>>2]=0;m=d+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[e>>2]|0)>0){m=f[h>>2]|0;h=0;do{f[m+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[e>>2]|0))}e=f[l>>2]|0;if((e|0)!=(k|0))g0(e);f[d>>2]=1124007936;e=d+4|0;k=d+8|0;l=d+40|0;i=e;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[l>>2]=k;i=d+48|0;j=d+44|0;f[j>>2]=i;f[i>>2]=0;f[d+52>>2]=0;h=d+36|0;if((d|0)!=(c|0)){m=c+36|0;b=f[m>>2]|0;if(b|0?(n=b+12|0,b=f[n>>2]|0,f[n>>2]=b+-1,(b|0)==1):0)_S(c);f[m>>2]=0;b=c+16|0;n=c+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[n>>2]|0)>0){o=f[c+40>>2]|0;g=0;do{f[o+(g<<2)>>2]=0;g=g+1|0;v=f[n>>2]|0}while((g|0)<(v|0));f[c>>2]=f[d>>2];if((v|0)<3)t=30;else t=32}else{f[c>>2]=f[d>>2];t=30}if((t|0)==30){v=f[e>>2]|0;if((v|0)<3){f[n>>2]=v;f[c+8>>2]=f[k>>2];f[c+12>>2]=f[d+12>>2];k=f[j>>2]|0;v=f[c+44>>2]|0;f[v>>2]=f[k>>2];f[v+4>>2]=f[k+4>>2]}else t=32}if((t|0)==32)ZS(c,d);f[b>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[c+28>>2]=f[d+28>>2];f[c+32>>2]=f[d+32>>2];c=f[h>>2]|0;f[m>>2]=c;if(c|0?(m=c+12|0,c=f[m>>2]|0,f[m>>2]=c+-1,(c|0)==1):0)_S(d)}f[h>>2]=0;h=d+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[e>>2]|0)>0){h=f[l>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[e>>2]|0))}e=f[j>>2]|0;if((e|0)==(i|0)){u=a;return}g0(e);u=a;return}function fFa(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=f[(f[a>>2]|0)+76>>2]|0;f[c>>2]=0;f[c+4>>2]=0;Mi[d&1023](a,c)|0;a=f[c>>2]|0;if(!a){u=b;return}c=a+4|0;d=f[c>>2]|0;f[c>>2]=d+-1;if((d|0)!=1){u=b;return}Yi[f[(f[a>>2]|0)+8>>2]&2047](a);u=b;return}function gFa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;g=u;u=u+16|0;a=g;h=f[c>>2]|0;i=(f[c+4>>2]|0)-h|0;c=(i|0)/12|0;if(!i){f[a>>2]=0;f[a+4>>2]=0;i=tT(a,13)|0;j=452335;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,a,452925,376410,3366)}else{iFa(e,(c|0)>(d|0)?c:d,h);u=g;return 0}return 0}function hFa(a,b,c){a=a|0;b=b|0;c=c|0;J=0;return 0}function iFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;if(((e-g|0)/12|0)>>>0<b>>>0){if(!g)i=e;else{e=a+4|0;j=f[e>>2]|0;if((j|0)==(h|0))k=g;else{l=j;while(1){j=l+-12|0;f[e>>2]=j;m=f[j>>2]|0;if(!m)n=j;else{j=l+-8|0;o=f[j>>2]|0;if((o|0)!=(m|0))f[j>>2]=o+(~((o+-4-m|0)>>>2)<<2);YDc(m);n=f[e>>2]|0}if((n|0)==(h|0))break;else l=n}k=f[a>>2]|0}YDc(k);f[d>>2]=0;f[e>>2]=0;f[a>>2]=0;i=0}if(b>>>0>357913941)mCc(a);e=(i|0)/12|0;i=e<<1;k=e>>>0<178956970?(i>>>0<b>>>0?b:i):357913941;if(k>>>0>357913941)mCc(a);i=VDc(k*12|0)|0;e=a+4|0;f[e>>2]=i;f[a>>2]=i;f[d>>2]=i+(k*12|0);k=b;d=i;do{jFa(d,c);d=(f[e>>2]|0)+12|0;f[e>>2]=d;k=k+-1|0}while((k|0)!=0);return}k=a+4|0;d=((f[k>>2]|0)-g|0)/12|0;g=d>>>0<b>>>0;e=g?d:b;if(e|0){i=c+4|0;n=e;e=h;while(1){if((e|0)!=(c|0))xxa(e,f[c>>2]|0,f[i>>2]|0);n=n+-1|0;if(!n)break;else e=e+12|0}}if(g){g=b-d|0;d=f[k>>2]|0;do{jFa(d,c);d=(f[k>>2]|0)+12|0;f[k>>2]=d;g=g+-1|0}while((g|0)!=0);return}g=(f[a>>2]|0)+(b*12|0)|0;b=f[k>>2]|0;if((b|0)==(g|0))return;else p=b;while(1){b=p+-12|0;f[k>>2]=b;a=f[b>>2]|0;if(!a)q=b;else{b=p+-8|0;d=f[b>>2]|0;if((d|0)!=(a|0))f[b>>2]=d+(~((d+-4-a|0)>>>2)<<2);YDc(a);q=f[k>>2]|0}if((q|0)==(g|0))break;else p=q}return}function jFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;dJc(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function kFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+128|0;g=e+108|0;h=e+96|0;i=e+84|0;j=e+72|0;k=e+60|0;l=e+48|0;m=e+32|0;n=e+16|0;o=e;if((f[a+32>>2]|0)==2?(p$(b,-1)|0)==3:0){f[g>>2]=0;p=g+4|0;f[p>>2]=0;f[g+8>>2]=0;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;f[k>>2]=0;t=k+4|0;f[t>>2]=0;f[k+8>>2]=0;f[l>>2]=0;v=l+4|0;f[v>>2]=0;f[l+8>>2]=0;i$(b,j);i$(c,k);i$(d,l);w=((f[s>>2]|0)-(f[j>>2]|0)|0)/48|0;x=f[p>>2]|0;y=f[g>>2]|0;z=(x-y|0)/48|0;A=y;y=x;if(w>>>0<=z>>>0){if(w>>>0<z>>>0?(x=A+(w*48|0)|0,(y|0)!=(x|0)):0){A=y;do{y=A+-48|0;f[p>>2]=y;GQ(y);A=f[p>>2]|0}while((A|0)!=(x|0))}}else j$(g,w-z|0);z=f[j>>2]|0;if((f[s>>2]|0)!=(z|0)){w=m+8|0;x=m+12|0;A=m+4|0;y=n+8|0;B=n+4|0;C=0;D=z;do{f[w>>2]=0;f[x>>2]=0;f[m>>2]=17432576;f[A>>2]=D+(C*48|0);z=(f[g>>2]|0)+(C*48|0)|0;E=y;f[E>>2]=0;f[E+4>>2]=0;f[n>>2]=34209792;f[B>>2]=z;NZ(m,n);C=C+1|0;D=f[j>>2]|0}while(C>>>0<(((f[s>>2]|0)-D|0)/48|0)>>>0)}D=((f[t>>2]|0)-(f[k>>2]|0)|0)/48|0;C=f[q>>2]|0;B=f[h>>2]|0;y=(C-B|0)/48|0;A=B;B=C;if(D>>>0<=y>>>0){if(D>>>0<y>>>0?(C=A+(D*48|0)|0,(B|0)!=(C|0)):0){A=B;do{B=A+-48|0;f[q>>2]=B;GQ(B);A=f[q>>2]|0}while((A|0)!=(C|0))}}else j$(h,D-y|0);y=f[k>>2]|0;if((f[t>>2]|0)!=(y|0)){D=m+4|0;C=m+8|0;A=0;B=y;do{y=B;x=f[h>>2]|0;w=f[y+(A*48|0)+4>>2]|0;z=f[y+(A*48|0)+32>>2]|0;f[m>>2]=0;f[D>>2]=0;f[C>>2]=0;lFa(m,z,z+(w<<2)|0);EQ(x+(A*48|0)|0,m,5,0);x=f[m>>2]|0;if(x|0){w=f[D>>2]|0;if((w|0)!=(x|0))f[D>>2]=w+(~((w+-4-x|0)>>>2)<<2);YDc(x)}A=A+1|0;B=f[k>>2]|0}while(A>>>0<(((f[t>>2]|0)-B|0)/48|0)>>>0)}B=((f[v>>2]|0)-(f[l>>2]|0)|0)/48|0;A=f[r>>2]|0;D=f[i>>2]|0;C=(A-D|0)/48|0;x=D;D=A;if(B>>>0<=C>>>0){if(B>>>0<C>>>0?(A=x+(B*48|0)|0,(D|0)!=(A|0)):0){x=D;do{D=x+-48|0;f[r>>2]=D;GQ(D);x=f[r>>2]|0}while((x|0)!=(A|0))}}else j$(i,B-C|0);C=f[l>>2]|0;if((f[v>>2]|0)!=(C|0)){B=m+4|0;A=m+8|0;x=0;D=C;do{C=D;w=f[i>>2]|0;z=f[C+(x*48|0)+4>>2]|0;y=f[C+(x*48|0)+32>>2]|0;f[m>>2]=0;f[B>>2]=0;f[A>>2]=0;lFa(m,y,y+(z<<2)|0);EQ(w+(x*48|0)|0,m,5,0);w=f[m>>2]|0;if(w|0){z=f[B>>2]|0;if((z|0)!=(w|0))f[B>>2]=z+(~((z+-4-w|0)>>>2)<<2);YDc(w)}x=x+1|0;D=f[l>>2]|0}while(x>>>0<(((f[v>>2]|0)-D|0)/48|0)>>>0)}D=f[(f[a>>2]|0)+44>>2]|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=17498112;f[m+4>>2]=g;x=n+8|0;f[x>>2]=0;f[x+4>>2]=0;f[n>>2]=34275328;f[n+4>>2]=h;x=o+8|0;f[x>>2]=0;f[x+4>>2]=0;f[o>>2]=34275328;f[o+4>>2]=i;ei[D&511](a,m,n,o);o=f[h>>2]|0;if((f[q>>2]|0)!=(o|0)){D=m+8|0;x=m+12|0;B=m+4|0;A=n+8|0;w=n+4|0;z=0;y=o;do{f[D>>2]=0;f[x>>2]=0;f[m>>2]=17432576;f[B>>2]=y+(z*48|0);o=(f[k>>2]|0)+(z*48|0)|0;C=A;f[C>>2]=0;f[C+4>>2]=0;f[n>>2]=34209792;f[w>>2]=o;NZ(m,n);z=z+1|0;y=f[h>>2]|0}while(z>>>0<(((f[q>>2]|0)-y|0)/48|0)>>>0)}c0(c,k);c0(d,l);y=f[l>>2]|0;if(y|0){while(1){z=f[v>>2]|0;if((z|0)==(y|0))break;n=z+-48|0;f[v>>2]=n;GQ(n)}YDc(f[l>>2]|0)}l=f[k>>2]|0;if(l|0){while(1){v=f[t>>2]|0;if((v|0)==(l|0))break;y=v+-48|0;f[t>>2]=y;GQ(y)}YDc(f[k>>2]|0)}k=f[j>>2]|0;if(k|0){while(1){t=f[s>>2]|0;if((t|0)==(k|0))break;l=t+-48|0;f[s>>2]=l;GQ(l)}YDc(f[j>>2]|0)}s=f[i>>2]|0;if(s|0){while(1){k=f[r>>2]|0;if((k|0)==(s|0))break;l=k+-48|0;f[r>>2]=l;GQ(l)}YDc(f[i>>2]|0)}r=f[h>>2]|0;if(r|0){while(1){s=f[q>>2]|0;if((s|0)==(r|0))break;l=s+-48|0;f[q>>2]=l;GQ(l)}YDc(f[h>>2]|0)}q=f[g>>2]|0;if(q|0){while(1){r=f[p>>2]|0;if((r|0)==(q|0))break;l=r+-48|0;f[p>>2]=l;GQ(l)}YDc(f[g>>2]|0)}u=e;return}f[g>>2]=0;p=g+4|0;f[p>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(b,g);f$(c,h);f$(d,i);b=f[p>>2]|0;q=f[g>>2]|0;l=b-q|0;r=(l|0)/56|0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;if(!l){F=b;G=0}else{if(r>>>0>1073741823)mCc(j);b=VDc(r<<2)|0;f[s>>2]=b;f[j>>2]=b;f[j+8>>2]=b+(r<<2);l=r;r=b;do{f[r>>2]=0;r=(f[s>>2]|0)+4|0;f[s>>2]=r;l=l+-1|0}while((l|0)!=0);F=f[p>>2]|0;G=b}if((F|0)!=(q|0)?(f[G>>2]=q,q=f[g>>2]|0,(((f[p>>2]|0)-q|0)/56|0)>>>0>1):0){G=q;q=1;do{f[(f[j>>2]|0)+(q<<2)>>2]=G+(q*56|0);q=q+1|0;G=f[g>>2]|0}while(q>>>0<(((f[p>>2]|0)-G|0)/56|0)>>>0)}ei[f[(f[a>>2]|0)+40>>2]&511](a,j,h,i);d0(c,h);d0(d,i);d=f[j>>2]|0;if(d|0){j=f[s>>2]|0;if((j|0)!=(d|0))f[s>>2]=j+(~((j+-4-d|0)>>>2)<<2);YDc(d)}mx(i);mx(h);mx(g);u=e;return}function lFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=b;e=c-d>>2;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=i;if(e>>>0<=h-i>>2>>>0){k=a+4|0;l=(f[k>>2]|0)-i>>2;m=e>>>0>l>>>0;n=b+(l<<2)|0;l=m?n:c;o=l;p=o-d|0;q=p>>2;if(q|0)fJc(i|0,b|0,p|0)|0;p=j+(q<<2)|0;if(!m){m=f[k>>2]|0;if((m|0)==(p|0))return;f[k>>2]=m+(~((m+-4-p|0)>>>2)<<2);return}if((l|0)==(c|0))return;l=f[k>>2]|0;p=c+-4-o|0;o=n;n=l;while(1){f[n>>2]=f[o>>2];o=o+4|0;if((o|0)==(c|0))break;else n=n+4|0}f[k>>2]=l+((p>>>2)+1<<2);return}p=i;if(!i)r=h;else{h=a+4|0;l=f[h>>2]|0;if((l|0)!=(j|0))f[h>>2]=l+(~((l+-4-i|0)>>>2)<<2);YDc(p);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;r=0}if(e>>>0>1073741823)mCc(a);h=r>>1;p=r>>2>>>0<536870911?(h>>>0<e>>>0?e:h):1073741823;if(p>>>0>1073741823)mCc(a);h=VDc(p<<2)|0;e=a+4|0;f[e>>2]=h;f[a>>2]=h;f[g>>2]=h+(p<<2);if((b|0)==(c|0))return;p=c+-4-d|0;d=b;b=h;while(1){f[b>>2]=f[d>>2];d=d+4|0;if((d|0)==(c|0))break;else b=b+4|0}f[e>>2]=h+((p>>>2)+1<<2);return}function mFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)mCc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)dJc(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;YDc(d);return}function nFa(){var a=0;a=(I5(376662,0)|0)&1;b[1152661]=a;a=u6(376702,3)|0;f[220302]=a;a=(I5(376729,0)|0)&1;b[1152662]=a;a=(I5(376754,0)|0)&1;b[1152663]=a;a=(I5(376784,0)|0)&1;b[1152664]=a;return}function oFa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+16|0;k=j;f[a>>2]=1124007936;l=a+8|0;m=a+40|0;n=a+4|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+48|0;f[a+44>>2]=l;f[l>>2]=0;f[a+52>>2]=0;l=k+8|0;f[l>>2]=0;f[l+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=a;pFa(b,k,c,d,e,g,h,i);u=j;return}function pFa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;j=u;u=u+80|0;k=j+64|0;l=j+8|0;m=j;do if((d$(a)|0)==65536){n=f[a+4>>2]|0;f[l>>2]=f[n>>2];o=l+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=l+8|0;f[q>>2]=f[n+8>>2];f[l+12>>2]=f[n+12>>2];f[l+16>>2]=f[n+16>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[l+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[l+36>>2]=r;f[l+40>>2]=q;q=l+48|0;s=l+44|0;f[s>>2]=q;f[q>>2]=0;f[l+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;ZS(l,n);break}}else a$(l,a,-1);while(0);qFa(k,1,l);a=l+36|0;n=f[a>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)_S(l);f[a>>2]=0;a=l+16|0;n=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[n>>2]|0)>0){a=f[l+40>>2]|0;o=0;do{f[a+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)==(l+48|0)){t=l+8|0;f[t>>2]=0;v=l+12|0;f[v>>2]=0;f[l>>2]=17104896;w=l+4|0;f[w>>2]=k;x=f[d>>2]|0;f[m>>2]=x;y=m+4|0;z=d+4|0;A=f[z>>2]|0;f[y>>2]=A;rFa(l,b,c,m,e,g,h,i);mx(k);u=j;return}g0(n);t=l+8|0;f[t>>2]=0;v=l+12|0;f[v>>2]=0;f[l>>2]=17104896;w=l+4|0;f[w>>2]=k;x=f[d>>2]|0;f[m>>2]=x;y=m+4|0;z=d+4|0;A=f[z>>2]|0;f[y>>2]=A;rFa(l,b,c,m,e,g,h,i);mx(k);u=j;return}function qFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>76695844)mCc(a);e=VDc(b*56|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*56|0);a=c+4|0;g=c+8|0;h=c+12|0;i=c+16|0;j=c+20|0;k=c+24|0;l=c+28|0;m=c+32|0;n=c+36|0;o=c+44|0;p=b;b=e;do{f[b>>2]=f[c>>2];e=b+4|0;f[e>>2]=f[a>>2];q=b+8|0;f[q>>2]=f[g>>2];f[b+12>>2]=f[h>>2];f[b+16>>2]=f[i>>2];f[b+20>>2]=f[j>>2];f[b+24>>2]=f[k>>2];f[b+28>>2]=f[l>>2];f[b+32>>2]=f[m>>2];r=f[n>>2]|0;f[b+36>>2]=r;f[b+40>>2]=q;q=b+48|0;s=b+44|0;f[s>>2]=q;f[q>>2]=0;f[b+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[a>>2]|0)<3){q=f[o>>2]|0;r=f[s>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2]}else{f[e>>2]=0;ZS(b,c)}b=(f[d>>2]|0)+56|0;f[d>>2]=b;p=p+-1|0}while((p|0)!=0);return}function rFa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;k=u;u=u+592|0;l=k+536|0;m=k+480|0;n=k+416|0;o=k+392|0;q=k+472|0;r=k+408|0;s=k;t=k+336|0;v=k+112|0;w=k+56|0;x=(j|0)==5;switch(j|0){case 0:{y=3;break}case 5:break;default:c2(j,77708)}if((y|0)==3){if(!(d==1.0))a2(d,1.0,77736);if(!(+p[g>>3]==0.0)){f[l>>2]=0;z=l+4|0;f[z>>2]=0;A=tT(l,77)|0;B=A;C=376821;D=B+77|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,137)}if(!(+p[g+8>>3]==0.0)){f[l>>2]=0;z=l+4|0;f[z>>2]=0;A=tT(l,77)|0;B=A;C=376821;D=B+77|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,137)}if(!(+p[g+16>>3]==0.0)){f[l>>2]=0;z=l+4|0;f[z>>2]=0;A=tT(l,77)|0;B=A;C=376821;D=B+77|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,137)}if(!(+p[g+24>>3]==0.0)){f[l>>2]=0;z=l+4|0;f[z>>2]=0;A=tT(l,77)|0;B=A;C=376821;D=B+77|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,137)}}f[o>>2]=0;A=o+4|0;f[A>>2]=0;f[o+8>>2]=0;f$(a,o);a=f[o>>2]|0;z=f[A>>2]|0;if((a|0)==(z|0)){f[l>>2]=0;f[l+4>>2]=0;B=tT(l,15)|0;C=376914;D=B+15|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,142)}E=z-a|0;if(!E){F=(E|0)/56|0;G=a}else{E=e+4|0;z=l+8|0;H=l+12|0;I=l+4|0;J=m+8|0;K=m+4|0;L=q+4|0;M=l+4|0;N=l+8|0;O=l+12|0;P=m+36|0;Q=m+16|0;R=m+4|0;S=m+40|0;T=m+44|0;U=m+48|0;V=m+8|0;W=m+12|0;X=m+20|0;Z=m+24|0;_=m+28|0;$=m+32|0;aa=l+8|0;ba=l+12|0;ca=l+4|0;da=m+8|0;ea=m+4|0;fa=r+4|0;ga=l+8|0;ha=l+4|0;ia=g+8|0;ja=s+8|0;ka=g+16|0;la=s+16|0;ma=g+24|0;na=s+24|0;oa=l+8|0;pa=l+12|0;qa=l+4|0;ra=m+8|0;sa=m+12|0;ta=m+4|0;ua=n+8|0;va=n+4|0;wa=l+8|0;xa=l+4|0;ya=0;za=a;while(1){a=f[za+(ya*56|0)+40>>2]|0;Aa=f[a+4>>2]|0;Ba=f[a>>2]|0;a=f[e>>2]|0;Ca=f[E>>2]|0;if(!(Ca|a)){f[e>>2]=Aa;f[E>>2]=Ba;Da=Aa;Ea=Ba}else{Da=a;Ea=Ca}do if((Da|0)!=(Aa|0)|(Ea|0)!=(Ba|0)){if(!i){f[aa>>2]=0;f[ba>>2]=0;f[l>>2]=16842752;f[ca>>2]=za+(ya*56|0);Ca=da;f[Ca>>2]=0;f[Ca+4>>2]=0;f[m>>2]=33619968;f[ea>>2]=za+(ya*56|0);f[r>>2]=Da;f[fa>>2]=Ea;nfa(l,m,r,0.0,0.0,1);break}Fa=+(Da|0)/+(Aa|0);Ga=+(Ea|0)/+(Ba|0);f[z>>2]=0;f[H>>2]=0;f[l>>2]=16842752;f[I>>2]=za+(ya*56|0);Ca=J;f[Ca>>2]=0;f[Ca+4>>2]=0;f[m>>2]=33619968;f[K>>2]=za+(ya*56|0);f[q>>2]=0;f[L>>2]=0;Ha=Fa<Ga?Ga:Fa;nfa(l,m,q,Ha,Ha,1);Ca=f[o>>2]|0;a=f[e>>2]|0;Ia=f[E>>2]|0;Ja=~~(+((f[Ca+(ya*56|0)+8>>2]|0)-Ia|0)*.5);f[l>>2]=~~(+((f[Ca+(ya*56|0)+12>>2]|0)-a|0)*.5);f[M>>2]=Ja;f[N>>2]=a;f[O>>2]=Ia;cT(m,Ca+(ya*56|0)|0,l);Ca=f[o>>2]|0;Ia=Ca+(ya*56|0)|0;if((Ia|0)!=(m|0)){a=f[P>>2]|0;if(a|0){Ja=a+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}Ja=Ca+(ya*56|0)+36|0;a=f[Ja>>2]|0;if(a|0?(Ka=a+12|0,a=f[Ka>>2]|0,f[Ka>>2]=a+-1,(a|0)==1):0)_S(Ia);f[Ja>>2]=0;a=Ca+(ya*56|0)+16|0;Ka=Ca+(ya*56|0)+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[Ka>>2]|0)>0){La=f[Ca+(ya*56|0)+40>>2]|0;Ma=0;do{f[La+(Ma<<2)>>2]=0;Ma=Ma+1|0;Na=f[Ka>>2]|0}while((Ma|0)<(Na|0));f[Ia>>2]=f[m>>2];if((Na|0)<3)y=34;else y=36}else{f[Ia>>2]=f[m>>2];y=34}if((y|0)==34){y=0;Ma=f[R>>2]|0;if((Ma|0)<3){f[Ka>>2]=Ma;f[Ca+(ya*56|0)+8>>2]=f[V>>2];f[Ca+(ya*56|0)+12>>2]=f[W>>2];Ma=f[T>>2]|0;La=f[Ca+(ya*56|0)+44>>2]|0;f[La>>2]=f[Ma>>2];f[La+4>>2]=f[Ma+4>>2]}else y=36}if((y|0)==36){y=0;ZS(Ia,m)}f[a>>2]=f[Q>>2];f[Ca+(ya*56|0)+20>>2]=f[X>>2];f[Ca+(ya*56|0)+24>>2]=f[Z>>2];f[Ca+(ya*56|0)+28>>2]=f[_>>2];f[Ca+(ya*56|0)+32>>2]=f[$>>2];f[Ja>>2]=f[P>>2]}Ma=f[P>>2]|0;if(Ma|0?(La=Ma+12|0,Ma=f[La>>2]|0,f[La>>2]=Ma+-1,(Ma|0)==1):0)_S(m);f[P>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[R>>2]|0)>0){Ma=f[S>>2]|0;La=0;do{f[Ma+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[R>>2]|0))}La=f[T>>2]|0;if((La|0)!=(U|0))g0(La)}while(0);Ba=(f[o>>2]|0)+(ya*56|0)|0;if(x&(f[Ba>>2]&7|0)==0){Aa=ga;f[Aa>>2]=0;f[Aa+4>>2]=0;f[l>>2]=33619968;f[ha>>2]=Ba;LZ(Ba,l,5,1.0,0.0)}Ha=+p[g>>3];p[s>>3]=Ha;p[ja>>3]=+p[ia>>3];Fa=+p[ka>>3];p[la>>3]=Fa;p[na>>3]=+p[ma>>3];if(h){p[s>>3]=Fa;p[la>>3]=Ha}Ba=(f[o>>2]|0)+(ya*56|0)|0;f[oa>>2]=0;f[pa>>2]=0;f[l>>2]=16842752;f[qa>>2]=Ba;f[m>>2]=-1056833530;f[ta>>2]=s;f[ra>>2]=1;f[sa>>2]=4;Aa=ua;f[Aa>>2]=0;f[Aa+4>>2]=0;f[n>>2]=33619968;f[va>>2]=Ba;oL(l,m,n,e0()|0,-1);Ba=(f[o>>2]|0)+(ya*56|0)|0;Aa=wa;f[Aa>>2]=0;f[Aa+4>>2]=0;f[l>>2]=33619968;f[xa>>2]=Ba;LZ(Ba,l,-1,d,0.0);ya=ya+1|0;Ba=f[o>>2]|0;Aa=((f[A>>2]|0)-Ba|0)/56|0;La=Ba;if(ya>>>0>=Aa>>>0){F=Aa;G=La;break}else za=La}}f[m>>2]=f[G>>2];za=m+4|0;ya=G+4|0;f[za>>2]=f[ya>>2];A=m+8|0;f[A>>2]=f[G+8>>2];xa=m+12|0;f[xa>>2]=f[G+12>>2];wa=m+16|0;f[wa>>2]=f[G+16>>2];f[m+20>>2]=f[G+20>>2];f[m+24>>2]=f[G+24>>2];f[m+28>>2]=f[G+28>>2];f[m+32>>2]=f[G+32>>2];va=m+36|0;ua=f[G+36>>2]|0;f[va>>2]=ua;sa=m+40|0;f[sa>>2]=A;ra=m+48|0;ta=m+44|0;f[ta>>2]=ra;f[ra>>2]=0;f[m+52>>2]=0;if(ua|0){qa=ua+12|0;f[qa>>2]=(f[qa>>2]|0)+1}if((f[ya>>2]|0)<3){ya=f[G+44>>2]|0;qa=f[ta>>2]|0;f[qa>>2]=f[ya>>2];f[qa+4>>2]=f[ya+4>>2]}else{f[za>>2]=0;ZS(m,G)}G=(f[m>>2]|0)>>>3;ya=G&511;qa=ya+1|0;if((f[za>>2]|0)!=2){f[l>>2]=0;f[l+4>>2]=0;B=tT(l,16)|0;C=376930;D=B+16|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,176)}f[n>>2]=1124007936;ua=n+4|0;pa=n+8|0;oa=n+40|0;B=ua;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[oa>>2]=pa;la=n+48|0;ma=n+44|0;f[ma>>2]=la;f[la>>2]=0;f[n+52>>2]=0;if((G&510|0)==2){f[s>>2]=F;f[s+4>>2]=qa;f[s+8>>2]=f[A>>2];f[s+12>>2]=f[xa>>2];w$(c,4,s,j,-1,0,0);do if((d$(c)|0)==65536){qa=f[c+4>>2]|0;f[t>>2]=f[qa>>2];G=t+4|0;na=qa+4|0;f[G>>2]=f[na>>2];ka=t+8|0;f[ka>>2]=f[qa+8>>2];f[t+12>>2]=f[qa+12>>2];f[t+16>>2]=f[qa+16>>2];f[t+20>>2]=f[qa+20>>2];f[t+24>>2]=f[qa+24>>2];f[t+28>>2]=f[qa+28>>2];f[t+32>>2]=f[qa+32>>2];ia=f[qa+36>>2]|0;f[t+36>>2]=ia;f[t+40>>2]=ka;ka=t+48|0;ja=t+44|0;f[ja>>2]=ka;f[ka>>2]=0;f[t+52>>2]=0;if(ia|0){ka=ia+12|0;f[ka>>2]=(f[ka>>2]|0)+1}if((f[na>>2]|0)<3){na=f[qa+44>>2]|0;ka=f[ja>>2]|0;f[ka>>2]=f[na>>2];f[ka+4>>2]=f[na+4>>2];break}else{f[G>>2]=0;ZS(t,qa);break}}else a$(t,c,-1);while(0);f[v>>2]=1124007936;qa=v+4|0;G=v+8|0;na=v+40|0;B=qa;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[na>>2]=G;ka=v+48|0;ja=v+44|0;f[ja>>2]=ka;f[ka>>2]=0;f[v+52>>2]=0;f[v+56>>2]=1124007936;ka=v+64|0;ia=v+96|0;B=v+60|0;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[ia>>2]=ka;ka=v+104|0;f[v+100>>2]=ka;f[ka>>2]=0;f[v+108>>2]=0;f[v+112>>2]=1124007936;ka=v+116|0;ia=v+120|0;g=v+152|0;B=ka;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[g>>2]=ia;ha=v+160|0;ga=v+156|0;f[ga>>2]=ha;f[ha>>2]=0;f[v+164>>2]=0;f[v+168>>2]=1124007936;ha=v+176|0;x=v+208|0;B=v+172|0;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[x>>2]=ha;ha=v+216|0;f[v+212>>2]=ha;f[ha>>2]=0;f[v+220>>2]=0;do if(F){ha=n+12|0;x=t+16|0;U=t+44|0;T=l+36|0;R=l+16|0;S=l+4|0;Q=l+40|0;P=l+44|0;$=l+48|0;_=l+8|0;Z=l+12|0;X=l+20|0;W=l+24|0;V=l+28|0;Na=l+32|0;O=v+112|0;N=l+4|0;M=l+8|0;E=l+12|0;e=v+12|0;q=l+16|0;L=v+16|0;K=l+20|0;J=v+20|0;I=l+24|0;H=v+24|0;z=l+28|0;Ea=v+28|0;Da=l+32|0;r=v+32|0;fa=l+36|0;ea=v+36|0;da=l+40|0;ca=l+48|0;ba=l+44|0;aa=l+52|0;i=v+148|0;La=v+124|0;Aa=v+128|0;Ba=v+132|0;Ma=v+136|0;Ja=v+140|0;Ca=v+144|0;a=n+36|0;Ia=n+16|0;Ka=n+20|0;Oa=n+24|0;Pa=n+28|0;Qa=n+32|0;Ra=0;while(1){Sa=f[o>>2]|0;Ta=Sa+(Ra*56|0)|0;if((n|0)!=(Ta|0)){Ua=Sa+(Ra*56|0)+36|0;Va=f[Ua>>2]|0;if(Va|0){Wa=Va+12|0;f[Wa>>2]=(f[Wa>>2]|0)+1}Wa=f[a>>2]|0;if(Wa|0?(Va=Wa+12|0,Wa=f[Va>>2]|0,f[Va>>2]=Wa+-1,(Wa|0)==1):0)_S(n);f[a>>2]=0;f[Ia>>2]=0;f[Ia+4>>2]=0;f[Ia+8>>2]=0;f[Ia+12>>2]=0;if((f[ua>>2]|0)>0){Wa=f[oa>>2]|0;Va=0;do{f[Wa+(Va<<2)>>2]=0;Va=Va+1|0;Xa=f[ua>>2]|0}while((Va|0)<(Xa|0));f[n>>2]=f[Ta>>2];if((Xa|0)<3)y=77;else y=79}else{f[n>>2]=f[Ta>>2];y=77}if((y|0)==77){y=0;Va=f[Sa+(Ra*56|0)+4>>2]|0;if((Va|0)<3){f[ua>>2]=Va;f[pa>>2]=f[Sa+(Ra*56|0)+8>>2];f[ha>>2]=f[Sa+(Ra*56|0)+12>>2];Va=f[Sa+(Ra*56|0)+44>>2]|0;Wa=f[ma>>2]|0;f[Wa>>2]=f[Va>>2];f[Wa+4>>2]=f[Va+4>>2]}else y=79}if((y|0)==79){y=0;ZS(n,Ta)}f[Ia>>2]=f[Sa+(Ra*56|0)+16>>2];f[Ka>>2]=f[Sa+(Ra*56|0)+20>>2];f[Oa>>2]=f[Sa+(Ra*56|0)+24>>2];f[Pa>>2]=f[Sa+(Ra*56|0)+28>>2];f[Qa>>2]=f[Sa+(Ra*56|0)+32>>2];f[a>>2]=f[Ua>>2]}Va=f[n>>2]|0;if((Va&7|0)!=(p$(c,-1)|0)){y=82;break}Va=(f[n>>2]|0)>>>3;Wa=Va&511;if(!((f[ua>>2]|0)==2&(Va&510|0)==2)){y=84;break}Va=f[oa>>2]|0;Ya=f[sa>>2]|0;if((f[Va>>2]|0)==(f[Ya>>2]|0)?(f[Va+4>>2]|0)==(f[Ya+4>>2]|0):0)Za=0;else{y=86;break}while(1){Ya=f[U>>2]|0;Va=(f[x>>2]|0)+(Y(f[Ya>>2]|0,Ra)|0)|0;Vj(l,f[pa>>2]|0,f[ha>>2]|0,j,Va+(Y(f[Ya+4>>2]|0,Za)|0)|0,0);Ya=v+(Za*56|0)|0;Va=f[T>>2]|0;if((Ya|0)==(l|0))_a=Va;else{if(Va|0){$a=Va+12|0;f[$a>>2]=(f[$a>>2]|0)+1}$a=v+(Za*56|0)+36|0;Va=f[$a>>2]|0;do if(Va|0){ab=Va+12|0;bb=f[ab>>2]|0;f[ab>>2]=bb+-1;if((bb|0)!=1)break;_S(Ya)}while(0);f[$a>>2]=0;Va=v+(Za*56|0)+16|0;bb=v+(Za*56|0)+4|0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=0;f[Va+12>>2]=0;if((f[bb>>2]|0)>0){ab=f[v+(Za*56|0)+40>>2]|0;cb=0;do{f[ab+(cb<<2)>>2]=0;cb=cb+1|0;db=f[bb>>2]|0}while((cb|0)<(db|0));f[Ya>>2]=f[l>>2];if((db|0)<3)y=99;else y=101}else{f[Ya>>2]=f[l>>2];y=99}do if((y|0)==99){y=0;cb=f[S>>2]|0;if((cb|0)>=3){y=101;break}f[bb>>2]=cb;f[v+(Za*56|0)+8>>2]=f[_>>2];f[v+(Za*56|0)+12>>2]=f[Z>>2];cb=f[P>>2]|0;ab=f[v+(Za*56|0)+44>>2]|0;f[ab>>2]=f[cb>>2];f[ab+4>>2]=f[cb+4>>2]}while(0);if((y|0)==101){y=0;ZS(Ya,l)}f[Va>>2]=f[R>>2];f[v+(Za*56|0)+20>>2]=f[X>>2];f[v+(Za*56|0)+24>>2]=f[W>>2];f[v+(Za*56|0)+28>>2]=f[V>>2];f[v+(Za*56|0)+32>>2]=f[Na>>2];bb=f[T>>2]|0;f[$a>>2]=bb;_a=bb}if(_a|0?(bb=_a+12|0,cb=f[bb>>2]|0,f[bb>>2]=cb+-1,(cb|0)==1):0)_S(l);f[T>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[S>>2]|0)>0){cb=f[Q>>2]|0;bb=0;do{f[cb+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[S>>2]|0))}bb=f[P>>2]|0;if((bb|0)!=($|0))g0(bb);if((Za|0)<(Wa|0))Za=Za+1|0;else break}if(h){f[l>>2]=f[v>>2];Wa=f[qa>>2]|0;f[N>>2]=Wa;f[M>>2]=f[G>>2];f[E>>2]=f[e>>2];f[q>>2]=f[L>>2];f[K>>2]=f[J>>2];f[I>>2]=f[H>>2];f[z>>2]=f[Ea>>2];f[Da>>2]=f[r>>2];Ua=f[ea>>2]|0;f[fa>>2]=Ua;f[da>>2]=M;f[ba>>2]=ca;f[ca>>2]=0;f[aa>>2]=0;if(!Ua)eb=Wa;else{Wa=Ua+12|0;f[Wa>>2]=(f[Wa>>2]|0)+1;eb=f[qa>>2]|0}if((eb|0)<3){Wa=f[ja>>2]|0;Ua=f[ba>>2]|0;f[Ua>>2]=f[Wa>>2];f[Ua+4>>2]=f[Wa+4>>2]}else{f[N>>2]=0;ZS(l,v)}Wa=f[i>>2]|0;if(Wa|0){Ua=Wa+12|0;f[Ua>>2]=(f[Ua>>2]|0)+1}Ua=f[ea>>2]|0;do if(Ua|0){Wa=Ua+12|0;Sa=f[Wa>>2]|0;f[Wa>>2]=Sa+-1;if((Sa|0)!=1)break;_S(v)}while(0);f[ea>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[qa>>2]|0)>0){Ua=f[na>>2]|0;Sa=0;do{f[Ua+(Sa<<2)>>2]=0;Sa=Sa+1|0;fb=f[qa>>2]|0}while((Sa|0)<(fb|0));f[v>>2]=f[O>>2];if((fb|0)<3)y=127;else y=129}else{f[v>>2]=f[O>>2];y=127}do if((y|0)==127){y=0;Sa=f[ka>>2]|0;if((Sa|0)>=3){y=129;break}f[qa>>2]=Sa;f[G>>2]=f[ia>>2];f[e>>2]=f[La>>2];Sa=f[ga>>2]|0;Ua=f[ja>>2]|0;f[Ua>>2]=f[Sa>>2];f[Ua+4>>2]=f[Sa+4>>2]}while(0);if((y|0)==129){y=0;ZS(v,O)}f[L>>2]=f[Aa>>2];f[J>>2]=f[Ba>>2];f[H>>2]=f[Ma>>2];f[Ea>>2]=f[Ja>>2];f[r>>2]=f[Ca>>2];Sa=f[i>>2]|0;f[ea>>2]=Sa;Ua=f[fa>>2]|0;if(!Ua)gb=Sa;else{Sa=Ua+12|0;f[Sa>>2]=(f[Sa>>2]|0)+1;gb=f[i>>2]|0}do if(gb|0){Sa=gb+12|0;Ua=f[Sa>>2]|0;f[Sa>>2]=Ua+-1;if((Ua|0)!=1)break;_S(O)}while(0);f[i>>2]=0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[ka>>2]|0)>0){Ua=f[g>>2]|0;Sa=0;do{f[Ua+(Sa<<2)>>2]=0;Sa=Sa+1|0;hb=f[ka>>2]|0}while((Sa|0)<(hb|0));f[O>>2]=f[l>>2];if((hb|0)<3)y=140;else y=142}else{f[O>>2]=f[l>>2];y=140}do if((y|0)==140){y=0;Sa=f[N>>2]|0;if((Sa|0)>=3){y=142;break}f[ka>>2]=Sa;f[ia>>2]=f[M>>2];f[La>>2]=f[E>>2];Sa=f[ba>>2]|0;Ua=f[ga>>2]|0;f[Ua>>2]=f[Sa>>2];f[Ua+4>>2]=f[Sa+4>>2]}while(0);if((y|0)==142){y=0;ZS(O,l)}f[Aa>>2]=f[q>>2];f[Ba>>2]=f[K>>2];f[Ma>>2]=f[I>>2];f[Ja>>2]=f[z>>2];f[Ca>>2]=f[Da>>2];Sa=f[fa>>2]|0;f[i>>2]=Sa;do if(Sa|0){Ua=Sa+12|0;Wa=f[Ua>>2]|0;f[Ua>>2]=Wa+-1;if((Wa|0)!=1)break;_S(l)}while(0);f[fa>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[N>>2]|0)>0){Sa=f[da>>2]|0;Wa=0;do{f[Sa+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[N>>2]|0))}Wa=f[ba>>2]|0;if((Wa|0)!=(ca|0))g0(Wa)}PY(n,v);Ra=Ra+1|0;if(Ra>>>0>=F>>>0){y=153;break}}if((y|0)==82){f[l>>2]=0;f[l+4>>2]=0;B=tT(l,30)|0;C=376947;D=B+30|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,188)}else if((y|0)==84){f[l>>2]=0;f[l+4>>2]=0;B=tT(l,41)|0;C=376978;D=B+41|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,190)}else if((y|0)==86){f[l>>2]=0;f[l+4>>2]=0;B=tT(l,29)|0;C=377020;D=B+29|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,l,376899,376410,191)}else if((y|0)==153){Ra=v+204|0;ca=f[Ra>>2]|0;if(!ca){ib=Ra;break}ba=ca+12|0;ca=f[ba>>2]|0;f[ba>>2]=ca+-1;if((ca|0)!=1){ib=Ra;break}_S(v+168|0);ib=Ra;break}}else ib=v+204|0;while(0);f[ib>>2]=0;ib=v+184|0;ga=v+172|0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=0;f[ib+12>>2]=0;if((f[ga>>2]|0)>0){ib=f[v+208>>2]|0;ia=0;do{f[ib+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ga>>2]|0))}ga=f[v+212>>2]|0;if((ga|0)!=(v+216|0))g0(ga);ga=v+112|0;ia=v+148|0;ib=f[ia>>2]|0;if(ib|0?(ka=ib+12|0,ib=f[ka>>2]|0,f[ka>>2]=ib+-1,(ib|0)==1):0)_S(ga);f[ia>>2]=0;ia=v+128|0;ga=v+116|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[ga>>2]|0)>0){ia=f[v+152>>2]|0;ib=0;do{f[ia+(ib<<2)>>2]=0;ib=ib+1|0}while((ib|0)<(f[ga>>2]|0))}ga=f[v+156>>2]|0;if((ga|0)!=(v+160|0))g0(ga);ga=v+56|0;ib=v+92|0;ia=f[ib>>2]|0;if(ia|0?(ka=ia+12|0,ia=f[ka>>2]|0,f[ka>>2]=ia+-1,(ia|0)==1):0)_S(ga);f[ib>>2]=0;ib=v+72|0;ga=v+60|0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=0;f[ib+12>>2]=0;if((f[ga>>2]|0)>0){ib=f[v+96>>2]|0;ia=0;do{f[ib+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ga>>2]|0))}ga=f[v+100>>2]|0;if((ga|0)!=(v+104|0))g0(ga);ga=v+36|0;ia=f[ga>>2]|0;if(ia|0?(ib=ia+12|0,ia=f[ib>>2]|0,f[ib>>2]=ia+-1,(ia|0)==1):0)_S(v);f[ga>>2]=0;ga=v+16|0;ia=v+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ia>>2]|0)>0){ga=f[v+40>>2]|0;ib=0;do{f[ga+(ib<<2)>>2]=0;ib=ib+1|0}while((ib|0)<(f[ia>>2]|0))}ia=f[v+44>>2]|0;if((ia|0)!=(v+48|0))g0(ia);ia=t+36|0;ib=f[ia>>2]|0;do if(ib|0){ga=ib+12|0;ka=f[ga>>2]|0;f[ga>>2]=ka+-1;if((ka|0)!=1)break;_S(t)}while(0);f[ia>>2]=0;ia=t+16|0;ib=t+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[ib>>2]|0)>0){ia=f[t+40>>2]|0;ka=0;do{f[ia+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[ib>>2]|0))}ib=f[t+44>>2]|0;if((ib|0)!=(t+48|0))g0(ib)}else{if(ya|0){f[l>>2]=0;f[l+4>>2]=0;ya=tT(l,8)|0;ib=ya;b[ib>>0]=110;b[ib+1>>0]=99;b[ib+2>>0]=104;b[ib+3>>0]=32;ib=ya+4|0;b[ib>>0]=61;b[ib+1>>0]=61;b[ib+2>>0]=32;b[ib+3>>0]=49;z5(-215,l,376899,376410,202)}f[l>>2]=F;f[l+4>>2]=1;f[l+8>>2]=f[A>>2];f[l+12>>2]=f[xa>>2];w$(c,4,l,j,-1,0,0);do if((d$(c)|0)==65536){l=f[c+4>>2]|0;f[s>>2]=f[l>>2];xa=s+4|0;A=l+4|0;f[xa>>2]=f[A>>2];ib=s+8|0;f[ib>>2]=f[l+8>>2];f[s+12>>2]=f[l+12>>2];f[s+16>>2]=f[l+16>>2];f[s+20>>2]=f[l+20>>2];f[s+24>>2]=f[l+24>>2];f[s+28>>2]=f[l+28>>2];f[s+32>>2]=f[l+32>>2];ya=f[l+36>>2]|0;f[s+36>>2]=ya;f[s+40>>2]=ib;ib=s+48|0;ka=s+44|0;f[ka>>2]=ib;f[ib>>2]=0;f[s+52>>2]=0;if(ya|0){ib=ya+12|0;f[ib>>2]=(f[ib>>2]|0)+1}if((f[A>>2]|0)<3){A=f[l+44>>2]|0;ib=f[ka>>2]|0;f[ib>>2]=f[A>>2];f[ib+4>>2]=f[A+4>>2];break}else{f[xa>>2]=0;ZS(s,l);break}}else a$(s,c,-1);while(0);a:do if(F|0){l=t+4|0;xa=t+8|0;A=t+12|0;ib=t+16|0;ka=t+20|0;ya=t+24|0;ia=t+28|0;ga=t+32|0;hb=t+36|0;g=t+40|0;gb=t+48|0;ja=t+44|0;G=t+52|0;qa=s+16|0;fb=s+44|0;na=v+8|0;eb=v+4|0;h=w+36|0;Za=w+16|0;_a=w+4|0;db=w+40|0;pa=w+44|0;Xa=w+48|0;Ra=0;while(1){ca=f[o>>2]|0;ba=ca+(Ra*56|0)|0;f[t>>2]=f[ba>>2];N=ca+(Ra*56|0)+4|0;f[l>>2]=f[N>>2];f[xa>>2]=f[ca+(Ra*56|0)+8>>2];f[A>>2]=f[ca+(Ra*56|0)+12>>2];f[ib>>2]=f[ca+(Ra*56|0)+16>>2];f[ka>>2]=f[ca+(Ra*56|0)+20>>2];f[ya>>2]=f[ca+(Ra*56|0)+24>>2];f[ia>>2]=f[ca+(Ra*56|0)+28>>2];f[ga>>2]=f[ca+(Ra*56|0)+32>>2];da=f[ca+(Ra*56|0)+36>>2]|0;f[hb>>2]=da;f[g>>2]=xa;f[ja>>2]=gb;f[gb>>2]=0;f[G>>2]=0;if(da|0){q=da+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[N>>2]|0)<3){N=f[ca+(Ra*56|0)+44>>2]|0;ca=f[ja>>2]|0;f[ca>>2]=f[N>>2];f[ca+4>>2]=f[N+4>>2]}else{f[l>>2]=0;ZS(t,ba)}ba=f[t>>2]|0;if((ba&7|0)!=(p$(c,-1)|0)){y=187;break}if(!((f[l>>2]|0)==2&(f[t>>2]&4088|0)==0)){y=189;break}ba=f[g>>2]|0;N=f[sa>>2]|0;if(!((f[ba>>2]|0)==(f[N>>2]|0)?(f[ba+4>>2]|0)==(f[N+4>>2]|0):0)){y=191;break}Vj(w,f[xa>>2]|0,f[A>>2]|0,j,(f[qa>>2]|0)+(Y(f[f[fb>>2]>>2]|0,Ra)|0)|0,0);N=na;f[N>>2]=0;f[N+4>>2]=0;f[v>>2]=-1040121856;f[eb>>2]=w;h_(t,v);N=f[h>>2]|0;if(N|0?(ba=N+12|0,N=f[ba>>2]|0,f[ba>>2]=N+-1,(N|0)==1):0)_S(w);f[h>>2]=0;f[Za>>2]=0;f[Za+4>>2]=0;f[Za+8>>2]=0;f[Za+12>>2]=0;if((f[_a>>2]|0)>0){N=f[db>>2]|0;ba=0;do{f[N+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[_a>>2]|0))}ba=f[pa>>2]|0;if((ba|0)!=(Xa|0))g0(ba);ba=f[hb>>2]|0;do if(ba|0){N=ba+12|0;ca=f[N>>2]|0;f[N>>2]=ca+-1;if((ca|0)!=1)break;_S(t)}while(0);f[hb>>2]=0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=0;f[ib+12>>2]=0;if((f[l>>2]|0)>0){ba=f[g>>2]|0;ca=0;do{f[ba+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[l>>2]|0))}ca=f[ja>>2]|0;if((ca|0)!=(gb|0))g0(ca);Ra=Ra+1|0;if(Ra>>>0>=F>>>0)break a}if((y|0)==187){f[v>>2]=0;f[v+4>>2]=0;B=tT(v,30)|0;C=376947;D=B+30|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,v,376899,376410,210)}else if((y|0)==189){f[v>>2]=0;f[v+4>>2]=0;B=tT(v,29)|0;C=377050;D=B+29|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,v,376899,376410,212)}else if((y|0)==191){f[v>>2]=0;f[v+4>>2]=0;B=tT(v,29)|0;C=377020;D=B+29|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,v,376899,376410,213)}}while(0);v=s+36|0;C=f[v>>2]|0;if(C|0?(B=C+12|0,C=f[B>>2]|0,f[B>>2]=C+-1,(C|0)==1):0)_S(s);f[v>>2]=0;v=s+16|0;C=s+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[C>>2]|0)>0){v=f[s+40>>2]|0;B=0;do{f[v+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[C>>2]|0))}C=f[s+44>>2]|0;if((C|0)!=(s+48|0))g0(C)}C=n+36|0;s=f[C>>2]|0;if(s|0?(B=s+12|0,s=f[B>>2]|0,f[B>>2]=s+-1,(s|0)==1):0)_S(n);f[C>>2]=0;C=n+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[ua>>2]|0)>0){C=f[oa>>2]|0;oa=0;do{f[C+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[ua>>2]|0))}ua=f[ma>>2]|0;if((ua|0)!=(la|0))g0(ua);ua=f[va>>2]|0;if(ua|0?(la=ua+12|0,ua=f[la>>2]|0,f[la>>2]=ua+-1,(ua|0)==1):0)_S(m);f[va>>2]=0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[za>>2]|0)>0){wa=f[sa>>2]|0;sa=0;do{f[wa+(sa<<2)>>2]=0;sa=sa+1|0}while((sa|0)<(f[za>>2]|0))}za=f[ta>>2]|0;if((za|0)==(ra|0)){mx(o);u=k;return}g0(za);mx(o);u=k;return}function sFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+128|0;h=g;i=f[c+4>>2]|0;if((i|0)<=2){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,10)|0;k=445168;l=j+10|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,h,445179,452821,110)}k=f[c+40>>2]|0;j=2;do{f[h+(j+-2<<2)>>2]=f[k+(j<<2)>>2];j=j+1|0}while((j|0)!=(i|0));j=f[c+44>>2]|0;k=(f[c+16>>2]|0)+(Y(f[j>>2]|0,d)|0)|0;dT(a,i+-2|0,h,f[c>>2]&4095,k+(Y(f[j+4>>2]|0,e)|0)|0,0);u=g;return}function tFa(a){a=a|0;var b=0,c=0;b=VDc(188)|0;uFa(b);c=VDc(16)|0;f[c+4>>2]=1;f[c>>2]=77772;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;return}function uFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;c=u;u=u+640|0;d=c+428|0;e=c+216|0;g=c+8|0;h=c;i=a+4|0;j=a+20|0;k=a+24|0;f[k>>2]=0;l=a+28|0;f[l>>2]=0;m=a+24|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[j>>2]=m;n=a+32|0;o=a+36|0;f[o>>2]=0;p=a+40|0;f[p>>2]=0;q=a+36|0;f[n>>2]=q;f[a+48>>2]=0;f[a+52>>2]=0;f[a+44>>2]=a+48;f[a+60>>2]=0;f[a+64>>2]=0;f[a+56>>2]=a+60;f[a+72>>2]=0;f[a+76>>2]=0;f[a+68>>2]=a+72;f[a+88>>2]=0;f[a+92>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+100>>2]=a+104;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;f[a+132>>2]=1124007936;r=a+140|0;s=a+172|0;t=a+136|0;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=r;r=a+180|0;f[a+176>>2]=r;f[r>>2]=0;f[a+184>>2]=0;r=VDc(88)|0;r0(r);s=r+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[s+28>>2]=0;f[r>>2]=77792;s=r+36|0;t=s;v=t+48|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));b[s+48>>0]=0;s=VDc(16)|0;w=s+4|0;f[w>>2]=1;f[s>>2]=77900;f[s+8>>2]=r;f[w>>2]=(f[w>>2]|0)+1;x=f[a>>2]|0;f[a>>2]=s;f[i>>2]=r;if(x|0?(r=x+4|0,y=f[r>>2]|0,f[r>>2]=y+-1,(y|0)==1):0)Yi[f[(f[x>>2]|0)+8>>2]&2047](x);x=f[w>>2]|0;f[w>>2]=x+-1;if((x|0)==1)Yi[f[(f[s>>2]|0)+8>>2]&2047](s);f[g>>2]=-1;s=g+4|0;f[g+24>>2]=0;f[g+28>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[g+20>>2]=g+24;f[g+76>>2]=0;f[g+80>>2]=0;s=g+76|0;x=g+72|0;t=g+32|0;v=t+40|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[x>>2]=s;f[g+88>>2]=0;f[g+92>>2]=0;f[g+84>>2]=g+88;f[g+192>>2]=0;f[g+196>>2]=0;s=g+192|0;x=g+188|0;t=g+96|0;v=t+92|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[x>>2]=s;b[g+200>>0]=0;f[g+204>>2]=0;f[e>>2]=0;s=e+4|0;KFa(s,g);f[d>>2]=f[e>>2];x=d+4|0;KFa(x,s);w=f[m>>2]|0;do if(w){y=f[d>>2]|0;r=k;z=w;while(1){A=f[z+16>>2]|0;if((y|0)<(A|0)){B=f[z>>2]|0;if(!B){C=11;break}else{D=z;E=B}}else{if((A|0)>=(y|0)){C=15;break}F=z+4|0;A=f[F>>2]|0;if(!A){C=14;break}else{D=F;E=A}}r=D;z=E}if((C|0)==11){G=z;H=z;break}else if((C|0)==14){G=F;H=z;break}else if((C|0)==15){G=r;H=z;break}}else{G=m;H=m}while(0);m=f[G>>2]|0;if(!m){F=VDc(228)|0;f[F+16>>2]=f[d>>2];KFa(F+20|0,x);f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=H;f[G>>2]=F;H=f[f[j>>2]>>2]|0;if(!H)I=F;else{f[j>>2]=H;I=f[G>>2]|0}laa(f[k>>2]|0,I);f[l>>2]=(f[l>>2]|0)+1;J=F}else J=m;EFa(x);EFa(s);EFa(g);g=J+20|0;f[g>>2]=0;s=J+24|0;uT(s);x=tT(s,6)|0;b[x>>0]=b[377452]|0;b[x+1>>0]=b[377453]|0;b[x+2>>0]=b[377454]|0;b[x+3>>0]=b[377455]|0;b[x+4>>0]=b[377456]|0;b[x+5>>0]=b[377457]|0;x=f[i>>2]|0;m=x+16|0;if((s|0)!=(m|0)){uT(m);F=f[s>>2]|0;if(!F)K=0;else{l=F+-4|0;f[l>>2]=(f[l>>2]|0)+1;K=f[s>>2]|0}f[m>>2]=K;f[x+20>>2]=f[J+28>>2]}x=J+32|0;uT(x);t=tT(x,17)|0;x=377459;v=t+17|0;do{b[t>>0]=b[x>>0]|0;t=t+1|0;x=x+1|0}while((t|0)<(v|0));x=J+164|0;t=f[a>>2]|0;v=f[i>>2]|0;if(t|0){i=t+4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[x>>2]|0;f[x>>2]=t;f[J+168>>2]=v;if(i|0?(v=i+4|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[s>>2]|0;f[h>>2]=i;s=h+4|0;t=f[J+28>>2]|0;f[s>>2]=t;if(i){J=i+-4|0;f[J>>2]=(f[J>>2]|0)+1;J=f[h>>2]|0;i=f[s>>2]|0;s=f[g>>2]|0;f[e>>2]=J;v=e+4|0;f[v>>2]=i;if(J){x=J+-4|0;f[x>>2]=(f[x>>2]|0)+1;x=f[e>>2]|0;J=f[v>>2]|0;v=e+8|0;f[v>>2]=s;f[d>>2]=x;K=d+4|0;f[K>>2]=J;if(!x){L=s;M=d;N=K}else{J=x+-4|0;f[J>>2]=(f[J>>2]|0)+1;L=f[v>>2]|0;M=d;N=K}}else{O=s;P=i;C=33}}else{i=f[g>>2]|0;f[e>>2]=0;f[e+4>>2]=t;O=i;P=t;C=33}if((C|0)==33){f[e+8>>2]=O;f[d>>2]=0;t=d+4|0;f[t>>2]=P;L=O;M=d;N=t}t=d+8|0;f[t>>2]=L;O=f[q>>2]|0;a:do if(!O){Q=q;R=q}else{P=f[d>>2]|0;i=(P|0)==0?1154740:P;g=f[O+16>>2]|0;b:do if((P|0)!=(g|0)){s=o;K=O;v=g;while(1){J=(v|0)==0?1154740:v;if((Ioc(i,J)|0)<0){x=f[K>>2]|0;if(!x){C=41;break}else{S=K;T=x}}else{if((Ioc(J,i)|0)>=0){U=s;V=K;break b}W=K+4|0;J=f[W>>2]|0;if(!J){C=44;break}else{S=W;T=J}}v=f[T+16>>2]|0;if((P|0)==(v|0)){U=S;V=T;break b}else{s=S;K=T}}if((C|0)==41){Q=K;R=K;break a}else if((C|0)==44){Q=W;R=K;break a}}else{U=o;V=O}while(0);Q=U;R=V}while(0);if(f[Q>>2]|0){uT(d);uT(e);uT(h);X=a+112|0;f[X>>2]=0;Y=a+116|0;b[Y>>0]=0;Z=a+117|0;b[Z>>0]=1;_=a+80|0;f[_>>2]=0;$=a+84|0;f[$>>2]=0;aa=a+96|0;b[aa>>0]=0;u=c;return}V=VDc(28)|0;U=f[M>>2]|0;f[V+16>>2]=U;f[V+20>>2]=f[N>>2];if(!U)ba=L;else{L=U+-4|0;f[L>>2]=(f[L>>2]|0)+1;ba=f[t>>2]|0}f[V+24>>2]=ba;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=R;f[Q>>2]=V;R=f[f[n>>2]>>2]|0;if(!R)ca=V;else{f[n>>2]=R;ca=f[Q>>2]|0}laa(f[o>>2]|0,ca);f[p>>2]=(f[p>>2]|0)+1;uT(d);uT(e);uT(h);X=a+112|0;f[X>>2]=0;Y=a+116|0;b[Y>>0]=0;Z=a+117|0;b[Z>>0]=1;_=a+80|0;f[_>>2]=0;$=a+84|0;f[$>>2]=0;aa=a+96|0;b[aa>>0]=0;u=c;return}function vFa(a){a=a|0;YDc(a);return}function wFa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0){xFa(b);YDc(b)}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+132|0;c=a+168|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+148|0;b=a+136|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+172>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+176>>2]|0;if((b|0)!=(a+180|0))g0(b);b=f[a+120>>2]|0;if(b|0){d=a+124|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b)}yFa(a+100|0,f[a+104>>2]|0);uT(a+88|0);zFa(a+68|0,f[a+72>>2]|0);AFa(a+56|0,f[a+60>>2]|0);BFa(a+44|0,f[a+48>>2]|0);CFa(a+32|0,f[a+36>>2]|0);DFa(a+20|0,f[a+24>>2]|0);b=f[a+8>>2]|0;if(b|0){c=a+12|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);YDc(b)}b=f[a>>2]|0;if(!b){f[a>>2]=0;g=a+4|0;f[g>>2]=0;return}d=b+4|0;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1){f[a>>2]=0;g=a+4|0;f[g>>2]=0;return}Yi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;g=a+4|0;f[g>>2]=0;return}function yFa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;yFa(a,f[b>>2]|0);yFa(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0?(c=a+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[a>>2]|0)+8>>2]&2047](a);YDc(b);return}function zFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!b)return;zFa(a,f[b>>2]|0);zFa(a,f[b+4>>2]|0);a=b+24|0;c=b+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(a);f[c>>2]=0;c=b+40|0;a=b+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[b+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[b+68>>2]|0;if((a|0)!=(b+72|0))g0(a);YDc(b);return}function AFa(a,b){a=a|0;b=b|0;if(!b)return;else{AFa(a,f[b>>2]|0);AFa(a,f[b+4>>2]|0);YDc(b);return}}function BFa(a,b){a=a|0;b=b|0;if(!b)return;else{BFa(a,f[b>>2]|0);BFa(a,f[b+4>>2]|0);YDc(b);return}}function CFa(a,b){a=a|0;b=b|0;if(!b)return;CFa(a,f[b>>2]|0);CFa(a,f[b+4>>2]|0);uT(b+16|0);YDc(b);return}function DFa(a,b){a=a|0;b=b|0;if(!b)return;DFa(a,f[b>>2]|0);DFa(a,f[b+4>>2]|0);EFa(b+20|0);YDc(b);return}function EFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;FFa(a+188|0,f[a+192>>2]|0);mx(a+176|0);b=f[a+164>>2]|0;if(b|0){c=a+168|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}mx(a+152|0);b=a+144|0;d=f[b>>2]|0;if(d|0?(c=d+4|0,e=f[c>>2]|0,f[c>>2]=e+-1,(e|0)==1):0)Yi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;f[a+148>>2]=0;b=a+132|0;d=f[b>>2]|0;if(d|0){e=a+136|0;c=f[e>>2]|0;if((c|0)==(d|0))g=d;else{h=c;do{c=h+-8|0;f[e>>2]=c;i=f[c>>2]|0;if(i|0?(j=i+4|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);f[c>>2]=0;f[h+-4>>2]=0;h=f[e>>2]|0}while((h|0)!=(d|0));g=f[b>>2]|0}YDc(g)}g=a+120|0;b=f[g>>2]|0;if(b|0){d=a+124|0;h=f[d>>2]|0;if((h|0)==(b|0))l=b;else{e=h;do{h=e+-8|0;f[d>>2]=h;c=f[h>>2]|0;if(c|0?(i=c+4|0,k=f[i>>2]|0,f[i>>2]=k+-1,(k|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[h>>2]=0;f[e+-4>>2]=0;e=f[d>>2]|0}while((e|0)!=(b|0));l=f[g>>2]|0}YDc(l)}l=a+108|0;g=f[l>>2]|0;if(g|0){b=a+112|0;e=f[b>>2]|0;if((e|0)==(g|0))m=g;else{d=e;do{e=d+-8|0;f[b>>2]=e;h=f[e>>2]|0;if(h|0?(c=h+4|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)Yi[f[(f[h>>2]|0)+8>>2]&2047](h);f[e>>2]=0;f[d+-4>>2]=0;d=f[b>>2]|0}while((d|0)!=(g|0));m=f[l>>2]|0}YDc(m)}m=f[a+96>>2]|0;if(m|0){l=a+100|0;g=f[l>>2]|0;if((g|0)!=(m|0))f[l>>2]=g+(~((g+-8-m|0)>>>3)<<3);YDc(m)}GFa(a+84|0,f[a+88>>2]|0);GFa(a+72|0,f[a+76>>2]|0);m=f[a+60>>2]|0;if(!m){n=a+20|0;HFa(n);o=a+12|0;uT(o);p=a+4|0;uT(p);return}g=a+64|0;l=f[g>>2]|0;if((l|0)!=(m|0))f[g>>2]=l+(~((l+-8-m|0)>>>3)<<3);YDc(m);n=a+20|0;HFa(n);o=a+12|0;uT(o);p=a+4|0;uT(p);return}function FFa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;FFa(a,f[b>>2]|0);FFa(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0?(c=a+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[a>>2]|0)+8>>2]&2047](a);YDc(b);return}function GFa(a,b){a=a|0;b=b|0;if(!b)return;else{GFa(a,f[b>>2]|0);GFa(a,f[b+4>>2]|0);YDc(b);return}}function HFa(a){a=a|0;uT(a+32|0);uT(a+24|0);mx(a+12|0);IFa(a,f[a+4>>2]|0);return}function IFa(a,b){a=a|0;b=b|0;if(!b)return;IFa(a,f[b>>2]|0);IFa(a,f[b+4>>2]|0);JFa(b+24|0);uT(b+16|0);YDc(b);return}function JFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;switch(f[a>>2]|0){case 0:{b=f[a+4>>2]|0;if(!b)return;c=f[b>>2]|0;if(!((c|0)==(b+8|0)|(c|0)==0))ZDc(c);YDc(b);return}case 3:{b=f[a+4>>2]|0;if(!b)return;c=f[b>>2]|0;d=b+8|0;if((c|0)!=(d|0)){if(c|0){e=c+-4|0;g=f[e>>2]|0;if(g|0){h=c+(g<<3)|0;do{h=h+-8|0;uT(h)}while((h|0)!=(c|0))}ZDc(e)}f[b>>2]=d;f[b+4>>2]=1}uT(d);YDc(b);return}case 2:{b=f[a+4>>2]|0;if(!b)return;a=f[b>>2]|0;if(!((a|0)==(b+8|0)|(a|0)==0))ZDc(a);YDc(b);return}default:return}}function KFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;f[a>>2]=f[b>>2];i=f[b+4>>2]|0;f[a+4>>2]=i;f[a+8>>2]=f[b+8>>2];if(i|0){j=i+-4|0;f[j>>2]=(f[j>>2]|0)+1}j=f[b+12>>2]|0;f[a+12>>2]=j;f[a+16>>2]=f[b+16>>2];if(j|0){i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1}LFa(a+20|0,b+20|0);MFa(a+32|0,b+32|0);i=f[b+44>>2]|0;f[a+44>>2]=i;f[a+48>>2]=f[b+48>>2];if(i|0){j=i+-4|0;f[j>>2]=(f[j>>2]|0)+1}j=f[b+52>>2]|0;f[a+52>>2]=j;f[a+56>>2]=f[b+56>>2];if(j|0){i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1}NFa(a+60|0,b+60|0);i=a+72|0;j=a+76|0;f[j>>2]=0;k=a+80|0;f[k>>2]=0;l=a+76|0;f[i>>2]=l;m=f[b+72>>2]|0;n=b+76|0;if((m|0)!=(n|0)){o=l;l=m;while(1){m=l+16|0;f[h>>2]=o;f[d>>2]=f[h>>2];p=OFa(i,d,e,g,m)|0;if(!(f[p>>2]|0)){q=VDc(20)|0;f[q+16>>2]=f[m>>2];m=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=m;f[p>>2]=q;m=f[f[i>>2]>>2]|0;if(!m)r=q;else{f[i>>2]=m;r=f[p>>2]|0}laa(f[j>>2]|0,r);f[k>>2]=(f[k>>2]|0)+1}p=f[l+4>>2]|0;if(!p){m=l+8|0;q=f[m>>2]|0;if((f[q>>2]|0)==(l|0))s=q;else{q=m;do{m=f[q>>2]|0;q=m+8|0;t=f[q>>2]|0}while((f[t>>2]|0)!=(m|0));s=t}}else{q=p;while(1){t=f[q>>2]|0;if(!t)break;else q=t}s=q}if((s|0)==(n|0))break;else l=s}}s=a+84|0;l=a+88|0;f[l>>2]=0;n=a+92|0;f[n>>2]=0;k=a+88|0;f[s>>2]=k;r=f[b+84>>2]|0;j=b+88|0;if((r|0)!=(j|0)){i=k;k=r;while(1){r=k+16|0;f[h>>2]=i;f[d>>2]=f[h>>2];o=OFa(s,d,e,g,r)|0;if(!(f[o>>2]|0)){p=VDc(20)|0;f[p+16>>2]=f[r>>2];r=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=r;f[o>>2]=p;r=f[f[s>>2]>>2]|0;if(!r)v=p;else{f[s>>2]=r;v=f[o>>2]|0}laa(f[l>>2]|0,v);f[n>>2]=(f[n>>2]|0)+1}o=f[k+4>>2]|0;if(!o){r=k+8|0;p=f[r>>2]|0;if((f[p>>2]|0)==(k|0))w=p;else{p=r;do{r=f[p>>2]|0;p=r+8|0;t=f[p>>2]|0}while((f[t>>2]|0)!=(r|0));w=t}}else{p=o;while(1){q=f[p>>2]|0;if(!q)break;else p=q}w=p}if((w|0)==(j|0))break;else k=w}}NFa(a+96|0,b+96|0);PFa(a+108|0,b+108|0);PFa(a+120|0,b+120|0);PFa(a+132|0,b+132|0);w=f[b+144>>2]|0;f[a+144>>2]=w;f[a+148>>2]=f[b+148>>2];if(w|0){k=w+4|0;f[k>>2]=(f[k>>2]|0)+1}MFa(a+152|0,b+152|0);QFa(a+164|0,b+164|0);MFa(a+176|0,b+176|0);k=a+188|0;w=a+192|0;f[w>>2]=0;j=a+196|0;f[j>>2]=0;n=a+192|0;f[k>>2]=n;v=f[b+188>>2]|0;l=b+192|0;if((v|0)==(l|0)){x=a+200|0;y=b+200|0;z=y;A=z;B=f[A>>2]|0;C=z+4|0;D=C;E=f[D>>2]|0;F=x;G=F;f[G>>2]=B;H=F+4|0;I=H;f[I>>2]=E;u=c;return}s=n;n=v;while(1){v=n+16|0;f[h>>2]=s;f[d>>2]=f[h>>2];i=RFa(k,d,e,g,v)|0;if(!(f[i>>2]|0)){o=VDc(28)|0;f[o+16>>2]=f[v>>2];v=f[n+20>>2]|0;f[o+20>>2]=v;f[o+24>>2]=f[n+24>>2];if(v|0){q=v+4|0;f[q>>2]=(f[q>>2]|0)+1}q=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=q;f[i>>2]=o;q=f[f[k>>2]>>2]|0;if(!q)J=o;else{f[k>>2]=q;J=f[i>>2]|0}laa(f[w>>2]|0,J);f[j>>2]=(f[j>>2]|0)+1}i=f[n+4>>2]|0;if(!i){q=n+8|0;o=f[q>>2]|0;if((f[o>>2]|0)==(n|0))K=o;else{o=q;do{q=f[o>>2]|0;o=q+8|0;v=f[o>>2]|0}while((f[v>>2]|0)!=(q|0));K=v}}else{o=i;while(1){p=f[o>>2]|0;if(!p)break;else o=p}K=o}if((K|0)==(l|0))break;else n=K}x=a+200|0;y=b+200|0;z=y;A=z;B=f[A>>2]|0;C=z+4|0;D=C;E=f[D>>2]|0;F=x;G=F;f[G>>2]=B;H=F+4|0;I=H;f[I>>2]=E;u=c;return}function LFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;i=a+4|0;f[i>>2]=0;j=a+8|0;f[j>>2]=0;k=a+4|0;f[a>>2]=k;l=f[b>>2]|0;m=b+4|0;if((l|0)==(m|0)){u=c;return}b=k;k=l;while(1){l=k+16|0;f[h>>2]=b;f[d>>2]=f[h>>2];n=SFa(a,d,e,g,l)|0;if(!(f[n>>2]|0)){o=VDc(32)|0;p=f[l>>2]|0;f[o+16>>2]=p;f[o+20>>2]=f[k+20>>2];if(p|0){l=p+-4|0;f[l>>2]=(f[l>>2]|0)+1}TFa(o+24|0,k+24|0);l=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=l;f[n>>2]=o;l=f[f[a>>2]>>2]|0;if(!l)q=o;else{f[a>>2]=l;q=f[n>>2]|0}laa(f[i>>2]|0,q);f[j>>2]=(f[j>>2]|0)+1}n=f[k+4>>2]|0;if(!n){l=k+8|0;o=f[l>>2]|0;if((f[o>>2]|0)==(k|0))r=o;else{o=l;do{l=f[o>>2]|0;o=l+8|0;p=f[o>>2]|0}while((f[p>>2]|0)!=(l|0));r=p}}else{o=n;while(1){p=f[o>>2]|0;if(!p)break;else o=p}r=o}if((r|0)==(m|0))break;else k=r}u=c;return}function MFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/56|0;if(!e)return;if(g>>>0>76695844)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*56|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{f[g>>2]=f[d>>2];h=g+4|0;a=d+4|0;f[h>>2]=f[a>>2];e=g+8|0;f[e>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[g+16>>2]=f[d+16>>2];f[g+20>>2]=f[d+20>>2];f[g+24>>2]=f[d+24>>2];f[g+28>>2]=f[d+28>>2];f[g+32>>2]=f[d+32>>2];i=f[d+36>>2]|0;f[g+36>>2]=i;f[g+40>>2]=e;e=g+48|0;j=g+44|0;f[j>>2]=e;f[e>>2]=0;f[g+52>>2]=0;if(i|0){e=i+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+44>>2]|0;e=f[j>>2]|0;f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2]}else{f[h>>2]=0;ZS(g,d)}d=d+56|0;g=(f[c>>2]|0)+56|0;f[c>>2]=g}while((d|0)!=(b|0));return}function NFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;dJc(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>3<<3);return}function OFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function PFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{h=f[d>>2]|0;f[g>>2]=h;f[g+4>>2]=f[d+4>>2];if(h|0){a=h+4|0;f[a>>2]=(f[a>>2]|0)+1}d=d+8|0;g=(f[c>>2]|0)+8|0;f[c>>2]=g}while((d|0)!=(b|0));return}function QFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;dJc(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function RFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function SFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=a+4|0;h=f[b>>2]|0;b=h;do if((h|0)!=(g|0)){i=f[e>>2]|0;j=f[h+16>>2]|0;if((i|0)!=(j|0)){if((Ioc((i|0)==0?1154740:i,(j|0)==0?1154740:j)|0)<0)break;k=(i|0)==0?1154740:i;if((Ioc((j|0)==0?1154740:j,k)|0)<0){j=h+4|0;l=f[j>>2]|0;if(!l){m=h+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(h|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=l;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}do if((o|0)!=(g|0)){l=f[o+16>>2]|0;if((i|0)!=(l|0)?(Ioc(k,(l|0)==0?1154740:l)|0)<0:0)break;l=f[g>>2]|0;if(!l){f[c>>2]=g;q=g;return q|0}p=a+4|0;m=f[l+16>>2]|0;a:do if((i|0)!=(m|0)){r=p;s=l;t=m;while(1){u=(t|0)==0?1154740:t;if((Ioc(k,u)|0)<0){v=f[s>>2]|0;if(!v){w=41;break}else{x=s;y=v}}else{if((Ioc(u,k)|0)>=0){z=r;A=s;break a}B=s+4|0;u=f[B>>2]|0;if(!u){w=44;break}else{x=B;y=u}}t=f[y+16>>2]|0;if((i|0)==(t|0)){z=x;A=y;break a}else{r=x;s=y}}if((w|0)==41){f[c>>2]=s;q=s;return q|0}else if((w|0)==44){f[c>>2]=s;q=B;return q|0}}else{z=p;A=l}while(0);f[c>>2]=A;q=z;return q|0}while(0);if(!(f[h+4>>2]|0)){f[c>>2]=b;q=j;return q|0}else{f[c>>2]=o;q=o;return q|0}}}f[c>>2]=b;f[d>>2]=b;q=d;return q|0}while(0);d=f[h>>2]|0;do if((h|0)==(f[a>>2]|0))C=b;else{if(!d){o=h;while(1){z=f[o+8>>2]|0;if((f[z>>2]|0)==(o|0))o=z;else{D=z;break}}}else{o=d;while(1){j=f[o+4>>2]|0;if(!j){D=o;break}else o=j}}o=f[D+16>>2]|0;j=f[e>>2]|0;if((o|0)!=(j|0)?(Ioc((o|0)==0?1154740:o,(j|0)==0?1154740:j)|0)<0:0){C=D;break}o=f[g>>2]|0;if(!o){f[c>>2]=g;q=g;return q|0}z=a+4|0;A=(j|0)==0?1154740:j;B=f[o+16>>2]|0;b:do if((j|0)!=(B|0)){y=z;x=o;i=B;while(1){k=(i|0)==0?1154740:i;if((Ioc(A,k)|0)<0){n=f[x>>2]|0;if(!n){w=18;break}else{E=x;F=n}}else{if((Ioc(k,A)|0)>=0){G=y;H=x;break b}I=x+4|0;k=f[I>>2]|0;if(!k){w=21;break}else{E=I;F=k}}i=f[F+16>>2]|0;if((j|0)==(i|0)){G=E;H=F;break b}else{y=E;x=F}}if((w|0)==18){f[c>>2]=x;q=x;return q|0}else if((w|0)==21){f[c>>2]=x;q=I;return q|0}}else{G=z;H=o}while(0);f[c>>2]=H;q=G;return q|0}while(0);if(!d){f[c>>2]=h;q=h;return q|0}else{h=C;f[c>>2]=h;q=h+4|0;return q|0}return 0}function TFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[a>>2]=f[b>>2];switch(f[b>>2]|0){case 0:{c=VDc(16)|0;d=f[b+4>>2]|0;e=c+8|0;f[c>>2]=e;g=c+4|0;f[g>>2]=1;h=f[d+4>>2]|0;f[g>>2]=h;if(h>>>0<=1){if(h|0){i=e;j=5}}else{e=XDc(h>>>0>536870911?-1:h<<3)|0;f[c>>2]=e;i=e;j=5}if((j|0)==5){e=f[d>>2]|0;d=0;do{g=e+(d<<3)|0;k=f[g+4>>2]|0;l=i+(d<<3)|0;f[l>>2]=f[g>>2];f[l+4>>2]=k;d=d+1|0}while(d>>>0<h>>>0)}f[a+4>>2]=c;return}case 3:{c=VDc(16)|0;UFa(c,f[b+4>>2]|0);f[a+4>>2]=c;return}case 2:{c=VDc(16)|0;h=f[b+4>>2]|0;b=c+8|0;f[c>>2]=b;d=c+4|0;f[d>>2]=1;i=f[h+4>>2]|0;f[d>>2]=i;if(i>>>0<=1){if(i|0){m=b;j=12}}else{b=XDc(i>>>0>536870911?-1:i<<3)|0;f[c>>2]=b;m=b;j=12}if((j|0)==12){j=f[h>>2]|0;h=0;do{p[m+(h<<3)>>3]=+p[j+(h<<3)>>3];h=h+1|0}while(h>>>0<i>>>0)}f[a+4>>2]=c;return}default:return}}function UFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;f[c>>2]=0;f[a+12>>2]=0;f[a>>2]=c;d=a+4|0;f[d>>2]=1;e=f[b+4>>2]|0;f[d>>2]=e;if(e>>>0<=1)if(!e)return;else g=c;else{c=e<<3;h=XDc(e>>>0>536870911|c>>>0>4294967291?-1:c+4|0)|0;f[h>>2]=e;c=h+4|0;XIc(c|0,0,e<<3|0)|0;f[a>>2]=c;g=c}c=0;h=g;g=e;while(1){e=f[b>>2]|0;i=e+(c<<3)|0;j=h+(c<<3)|0;if((e|0)==(h|0))k=g;else{uT(j);l=f[i>>2]|0;if(!l)m=0;else{n=l+-4|0;f[n>>2]=(f[n>>2]|0)+1;m=f[i>>2]|0}f[j>>2]=m;f[h+(c<<3)+4>>2]=f[e+(c<<3)+4>>2];k=f[d>>2]|0}e=c+1|0;if(e>>>0>=k>>>0)break;c=e;h=f[a>>2]|0;g=k}return}function VFa(a){a=a|0;YDc(a);return}function WFa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function XFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=77792;mx(a+72|0);b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-32-b|0)>>>5)<<5);YDc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);YDc(b)}b=a+36|0;c=f[b>>2]|0;if(!c){REa(a);return}d=a+40|0;while(1){e=f[d>>2]|0;if((e|0)==(c|0))break;g=e+-8|0;f[d>>2]=g;uT(g)}YDc(f[b>>2]|0);REa(a);return}function YFa(a){a=a|0;XFa(a);YDc(a);return}function ZFa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;c=u;u=u+32|0;e=c+8|0;g=c;f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;f$(d,e);d=f[e>>2]|0;i=(f[h>>2]|0)-d|0;h=(i|0)/56|0;j=f[a+48>>2]|0;k=d;d=j;if((h|0)!=((f[a+52>>2]|0)-j>>3|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,37)|0;m=377800;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,453718,376410,591)}j=f[a+60>>2]|0;o=j;if((h|0)!=((f[a+64>>2]|0)-j>>5|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,30)|0;m=377838;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,453718,376410,591)}j=f[a+72>>2]|0;q=j;if((((f[a+76>>2]|0)-j|0)/56|0|0)!=(h|0)){f[g>>2]=0;f[g+4>>2]=0;l=tT(g,35)|0;m=377869;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,g,453718,376410,591)}g=a+84|0;b[g>>0]=1;if(!i){mx(e);u=c;return}else r=0;while(1){if((f[q+(r*56|0)+16>>2]|0)!=(f[k+(r*56|0)+16>>2]|0))break;if(+p[d+(r<<3)>>3]!=1.0)break;if(+p[o+(r<<5)>>3]!=0.0)break;if(+p[o+(r<<5)+8>>3]!=0.0)break;if(+p[o+(r<<5)+16>>3]!=0.0)break;if(+p[o+(r<<5)+24>>3]!=0.0)break;r=r+1|0;if(r>>>0>=h>>>0){s=9;break}}if((s|0)==9){mx(e);u=c;return}b[g>>0]=0;mx(e);u=c;return}function _Fa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;g=u;u=u+160|0;h=g+140|0;i=g+128|0;j=g+72|0;k=g+16|0;l=g;if((p$(d,-1)|0)==3){kFa(a,c,d,e);u=g;return}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f$(d,h);f$(e,i);e=a+72|0;d=a+76|0;c=f[e>>2]|0;a:do if((f[d>>2]|0)!=(c|0)){m=a+48|0;n=a+60|0;o=j+8|0;q=j+4|0;r=l+8|0;s=l+4|0;t=k+36|0;v=k+16|0;w=k+4|0;x=k+40|0;y=k+44|0;z=k+48|0;A=j+36|0;B=j+16|0;C=j+4|0;D=j+40|0;E=j+44|0;F=j+48|0;G=0;H=c;while(1){I=H;J=+p[(f[m>>2]|0)+(G<<3)>>3];K=f[n>>2]|0;L=K+(G<<5)|0;M=+p[L>>3];if(!(((M==0.0?+p[K+(G<<5)+8>>3]==0.0:0)?+p[K+(G<<5)+16>>3]==0.0:0)?+p[K+(G<<5)+24>>3]==0.0:0))N=10;if((N|0)==10?(N=0,(f[(f[I+(G*56|0)+40>>2]|0)+4>>2]|0)>=5):0){N=11;break}O=f[h>>2]|0;P=f[O+(G*56|0)>>2]&4095;if((P|0)!=5){N=16;break}if((f[(f[I+(G*56|0)+40>>2]|0)+4>>2]|0)>1){Q=f[(f[I+(G*56|0)+40>>2]|0)+4>>2]|0;if((Q|0)<4){R=1;S=M;do{T=S;S=+p[K+(G<<5)+(R<<3)>>3];U=S==T;R=R+1|0}while(U&(R|0)<(Q|0));V=U}else{Q=1;S=M;do{T=S;S=+p[K+(G<<5)+(Q<<3)>>3];R=S==T;Q=Q+1|0}while(R&(Q|0)<4);V=R}if(!V)if((f[f[I+(G*56|0)+40>>2]>>2]|0)>0){Q=0;R=f[I+(G*56|0)+40>>2]|0;U=I;W=H;while(1){if((f[R+4>>2]|0)>0){X=0;Y=U;do{sFa(j,Y+(G*56|0)|0,Q,X);sFa(k,(f[h>>2]|0)+(G*56|0)|0,Q,X);Z=r;f[Z>>2]=0;f[Z+4>>2]=0;f[l>>2]=33619968;f[s>>2]=k;LZ(j,l,5,J,-(J*+p[K+(G<<5)+(X<<3)>>3]));Z=f[t>>2]|0;if(Z|0?(_=Z+12|0,Z=f[_>>2]|0,f[_>>2]=Z+-1,(Z|0)==1):0)_S(k);f[t>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){Z=f[x>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[w>>2]|0))}_=f[y>>2]|0;if((_|0)!=(z|0))g0(_);_=f[A>>2]|0;do if(_|0){Z=_+12|0;$=f[Z>>2]|0;f[Z>>2]=$+-1;if(($|0)!=1)break;_S(j)}while(0);f[A>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){_=f[D>>2]|0;$=0;do{f[_+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[C>>2]|0))}$=f[E>>2]|0;if(($|0)!=(F|0))g0($);X=X+1|0;Y=f[e>>2]|0;aa=f[Y+(G*56|0)+40>>2]|0}while((X|0)<(f[aa+4>>2]|0));ba=aa;ca=Y;da=Y}else{ba=f[U+(G*56|0)+40>>2]|0;ca=W;da=U}Q=Q+1|0;if((Q|0)>=(f[ba>>2]|0)){ea=ca;break}else{R=ba;U=da;W=ca}}}else ea=H;else N=21}else N=21;if((N|0)==21){N=0;W=o;f[W>>2]=0;f[W+4>>2]=0;f[j>>2]=33619968;f[q>>2]=O+(G*56|0);LZ(I+(G*56|0)|0,j,5,J,-(J*+p[L>>3]));ea=f[e>>2]|0}G=G+1|0;if(G>>>0>=(((f[d>>2]|0)-ea|0)/56|0)>>>0)break a;else H=ea}if((N|0)==11){f[j>>2]=0;f[j+4>>2]=0;H=tT(j,46)|0;G=377607;q=H+46|0;do{b[H>>0]=b[G>>0]|0;H=H+1|0;G=G+1|0}while((H|0)<(q|0));z5(-215,j,453206,376410,459)}else if((N|0)==16)Y1(P,5,77912)}while(0);mx(i);mx(h);u=g;return}function $Fa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+36>>2]|0;d=f[a+40>>2]|0;a=c;e=d;a:do if((c|0)==(d|0))g=c;else{h=f[b>>2]|0;i=(h|0)==0?1154740:h;j=c;while(1){k=f[j>>2]|0;if((k|0)==(h|0)){g=j;break a}if(!(Ioc((k|0)==0?1154740:k,i)|0)){g=j;break a}j=j+8|0;if((j|0)==(d|0)){g=d;break}}}while(0);d=g-a>>3;return ((d|0)<(e-a>>3|0)?d:-1)|0}function aGa(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=((f[a+76>>2]|0)-(f[a+72>>2]|0)|0)==56;break}default:c=0}return c|0}function bGa(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function cGa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;a=g+16|0;h=g+8|0;i=g+4|0;j=g;k=f[c+4>>2]|0;l=f[c>>2]|0;if(((k-l|0)/12|0|0)==(d|0)){f[i>>2]=l;f[j>>2]=k;f[h>>2]=f[i>>2];f[a>>2]=f[j>>2];dGa(e,h,a);u=g;return 0}else{f[a>>2]=0;f[a+4>>2]=0;g=tT(a,32)|0;h=377574;e=g+32|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));z5(-215,a,452925,376410,580)}return 0}function dGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[b>>2]|0;e=f[c>>2]|0;g=(e-d|0)/12|0;h=a+8|0;i=f[h>>2]|0;j=f[a>>2]|0;k=d;d=j;l=e;if(g>>>0>((i-j|0)/12|0)>>>0){if(!j)m=i;else{i=a+4|0;n=f[i>>2]|0;if((n|0)==(d|0))o=j;else{p=n;while(1){n=p+-12|0;f[i>>2]=n;q=f[n>>2]|0;if(!q)r=n;else{n=p+-8|0;s=f[n>>2]|0;if((s|0)!=(q|0))f[n>>2]=s+(~((s+-4-q|0)>>>2)<<2);YDc(q);r=f[i>>2]|0}if((r|0)==(d|0))break;else p=r}o=f[a>>2]|0}YDc(o);f[h>>2]=0;f[i>>2]=0;f[a>>2]=0;m=0}if(g>>>0>357913941)mCc(a);i=(m|0)/12|0;m=i<<1;o=i>>>0<178956970?(m>>>0<g>>>0?g:m):357913941;if(o>>>0>357913941)mCc(a);m=VDc(o*12|0)|0;i=a+4|0;f[i>>2]=m;f[a>>2]=m;f[h>>2]=m+(o*12|0);o=f[b>>2]|0;b=f[c>>2]|0;if((o|0)==(b|0))return;c=m;m=o;do{jFa(c,m);m=m+12|0;c=(f[i>>2]|0)+12|0;f[i>>2]=c}while((m|0)!=(b|0));return}else{b=a+4|0;a=((f[b>>2]|0)-j|0)/12|0;j=g>>>0>a>>>0;g=j?k+(a*12|0)|0:e;if((k|0)==(g|0))t=d;else{e=d;d=k;while(1){if((e|0)!=(d|0))xxa(e,f[d>>2]|0,f[d+4>>2]|0);d=d+12|0;k=e+12|0;if((d|0)==(g|0)){t=k;break}else e=k}}if(j){if((g|0)==(l|0))return;j=f[b>>2]|0;e=g;do{jFa(j,e);e=e+12|0;j=(f[b>>2]|0)+12|0;f[b>>2]=j}while((e|0)!=(l|0));return}l=f[b>>2]|0;if((l|0)==(t|0))return;else u=l;while(1){l=u+-12|0;f[b>>2]=l;e=f[l>>2]|0;if(!e)v=l;else{l=u+-8|0;j=f[l>>2]|0;if((j|0)!=(e|0))f[l>>2]=j+(~((j+-4-e|0)>>>2)<<2);YDc(e);v=f[b>>2]|0}if((v|0)==(t|0))break;else u=v}return}}function eGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;d=u;u=u+16|0;c=d;f[c>>2]=0;f[c+4>>2]=0;d=tT(c,81)|0;a=377950;e=d+81|0;do{b[d>>0]=b[a>>0]|0;d=d+1|0;a=a+1|0}while((d|0)<(e|0));z5(-2,c,378032,376410,2431)}function fGa(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)Yi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[a+4>>2]=0;return}function gGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+640|0;h=g+428|0;i=g+216|0;j=g+208|0;k=g;l=a+4|0;a=f[l>>2]|0;m=a+36|0;n=f[m>>2]|0;do if(n){o=f[c>>2]|0;p=(o|0)==0?1154740:o;q=o;r=m;s=n;a:while(1){t=s;while(1){v=f[t+16>>2]|0;if((v|0)==(o|0))break;if((Ioc((v|0)==0?1154740:v,p)|0)>=0)break;v=f[t+4>>2]|0;if(!v){w=r;break a}else t=v}s=f[t>>2]|0;if(!s){w=t;break}else r=t}if((w|0)!=(m|0)){r=f[w+16>>2]|0;if((o|0)!=(r|0)?(Ioc(p,(r|0)==0?1154740:r)|0)<=-1:0){x=q;break}if((f[w+24>>2]|0)>-1){f[i>>2]=0;r=i+4|0;f[r>>2]=0;s=c+4|0;tT(i,(f[s>>2]|0)+7|0)|0;v=f[i>>2]|0;b[v>>0]=b[378055]|0;b[v+1>>0]=b[378056]|0;b[v+2>>0]=b[378057]|0;b[v+3>>0]=b[378058]|0;b[v+4>>0]=b[378059]|0;b[v+5>>0]=b[378060]|0;b[v+6>>0]=b[378061]|0;v=f[s>>2]|0;if(v|0)dJc((f[i>>2]|0)+7|0,f[c>>2]|0,v|0)|0;f[h>>2]=0;f[h+4>>2]=0;tT(h,(f[r>>2]|0)+18|0)|0;v=f[r>>2]|0;if(!v){y=0;z=f[h>>2]|0;A=z+y|0;B=A;C=378063;D=B+18|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-5,h,378082,376410,2485)}dJc(f[h>>2]|0,f[i>>2]|0,v|0)|0;y=f[r>>2]|0;z=f[h>>2]|0;A=z+y|0;B=A;C=378063;D=B+18|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-5,h,378082,376410,2485)}else x=q}else x=q}else x=f[c>>2]|0;while(0);C=a+112|0;B=(f[C>>2]|0)+1|0;f[C>>2]=B;C=a+32|0;f[j>>2]=x;D=j+4|0;A=f[c+4>>2]|0;f[D>>2]=A;if(x){y=x+-4|0;f[y>>2]=(f[y>>2]|0)+1;y=f[j>>2]|0;x=f[D>>2]|0;f[i>>2]=y;D=i+4|0;f[D>>2]=x;if(y){z=y+-4|0;f[z>>2]=(f[z>>2]|0)+1;z=f[i>>2]|0;y=f[D>>2]|0;D=i+8|0;f[D>>2]=B;f[h>>2]=z;w=h+4|0;f[w>>2]=y;if(!z){E=w;F=B;G=h}else{y=z+-4|0;f[y>>2]=(f[y>>2]|0)+1;E=w;F=f[D>>2]|0;G=h}}else{H=x;I=21}}else{f[i>>2]=0;f[i+4>>2]=A;H=A;I=21}if((I|0)==21){f[i+8>>2]=B;f[h>>2]=0;A=h+4|0;f[A>>2]=H;E=A;F=B;G=h}A=h+8|0;f[A>>2]=F;H=f[m>>2]|0;b:do if(!H){J=m;K=m}else{x=a+36|0;D=f[h>>2]|0;w=(D|0)==0?1154740:D;y=f[H+16>>2]|0;c:do if((D|0)!=(y|0)){z=x;n=H;r=y;while(1){v=(r|0)==0?1154740:r;if((Ioc(w,v)|0)<0){p=f[n>>2]|0;if(!p){I=29;break}else{L=n;M=p}}else{if((Ioc(v,w)|0)>=0){N=z;O=n;break c}P=n+4|0;v=f[P>>2]|0;if(!v){I=32;break}else{L=P;M=v}}r=f[M+16>>2]|0;if((D|0)==(r|0)){N=L;O=M;break c}else{z=L;n=M}}if((I|0)==29){J=n;K=n;break b}else if((I|0)==32){J=P;K=n;break b}}else{N=x;O=H}while(0);J=N;K=O}while(0);if(!(f[J>>2]|0)){O=VDc(28)|0;N=f[G>>2]|0;f[O+16>>2]=N;f[O+20>>2]=f[E>>2];if(!N)Q=F;else{F=N+-4|0;f[F>>2]=(f[F>>2]|0)+1;Q=f[A>>2]|0}f[O+24>>2]=Q;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=K;f[J>>2]=O;K=f[f[C>>2]>>2]|0;if(!K)R=O;else{f[C>>2]=K;R=f[J>>2]|0}laa(f[a+36>>2]|0,R);R=a+40|0;f[R>>2]=(f[R>>2]|0)+1}uT(h);uT(i);uT(j);j=f[l>>2]|0;l=j+20|0;hGa(k,B,c,d,e);f[i>>2]=B;e=i+4|0;KFa(e,k);f[h>>2]=f[i>>2];i=h+4|0;KFa(i,e);d=j+24|0;c=f[d>>2]|0;do if(c){R=f[h>>2]|0;a=j+24|0;J=c;while(1){K=f[J+16>>2]|0;if((R|0)<(K|0)){C=f[J>>2]|0;if(!C){I=46;break}else{S=J;T=C}}else{if((K|0)>=(R|0)){I=50;break}U=J+4|0;K=f[U>>2]|0;if(!K){I=49;break}else{S=U;T=K}}a=S;J=T}if((I|0)==46){V=J;W=J;break}else if((I|0)==49){V=U;W=J;break}else if((I|0)==50){V=a;W=J;break}}else{V=d;W=d}while(0);if(f[V>>2]|0){EFa(i);EFa(e);EFa(k);u=g;return B|0}d=VDc(228)|0;f[d+16>>2]=f[h>>2];KFa(d+20|0,i);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=W;f[V>>2]=d;W=f[f[l>>2]>>2]|0;if(!W)X=d;else{f[l>>2]=W;X=f[V>>2]|0}laa(f[j+24>>2]|0,X);X=j+28|0;f[X>>2]=(f[X>>2]|0)+1;EFa(i);EFa(e);EFa(k);u=g;return B|0}function hGa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=c;c=a+4|0;h=f[d>>2]|0;f[c>>2]=h;i=a+8|0;f[i>>2]=f[d+4>>2];if(h|0){d=h+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=a+12|0;h=f[e>>2]|0;f[d>>2]=h;j=a+16|0;f[j>>2]=f[e+4>>2];if(h|0){e=h+-4|0;f[e>>2]=(f[e>>2]|0)+1}LFa(a+20|0,g);MFa(a+32|0,g+12|0);e=a+44|0;h=f[g+24>>2]|0;f[e>>2]=h;k=a+48|0;f[k>>2]=f[g+28>>2];if(h|0){l=h+-4|0;f[l>>2]=(f[l>>2]|0)+1}l=a+52|0;h=f[g+32>>2]|0;f[l>>2]=h;m=a+56|0;f[m>>2]=f[g+36>>2];if(h|0){g=h+-4|0;f[g>>2]=(f[g>>2]|0)+1}f[a+60>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+72>>2]=a+76;f[a+88>>2]=0;f[a+92>>2]=0;f[a+84>>2]=a+88;g=a+188|0;f[a+192>>2]=0;f[a+196>>2]=0;h=a+192|0;n=a+96|0;o=n+92|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[g>>2]=h;b[a+200>>0]=0;f[a+204>>2]=0;uT(e);a=f[c>>2]|0;if(!a)p=0;else{h=a+-4|0;f[h>>2]=(f[h>>2]|0)+1;p=f[c>>2]|0}f[e>>2]=p;f[k>>2]=f[i>>2];uT(l);i=f[d>>2]|0;if(!i){q=0;f[l>>2]=q;r=f[j>>2]|0;f[m>>2]=r;return}k=i+-4|0;f[k>>2]=(f[k>>2]|0)+1;q=f[d>>2]|0;f[l>>2]=q;r=f[j>>2]|0;f[m>>2]=r;return}function iGa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=h+24|0;if((c|0)>=(e|0)){f[i>>2]=0;f[i+4>>2]=0;m=tT(i,22)|0;n=378091;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,i,385436,376410,1245)}n=a+24|0;a=f[n>>2]|0;if(!a){f[k>>2]=c;F5(i,378114,k);z5(-204,i,378151,376410,1170)}else{p=n;q=a}a:while(1){m=q;while(1){if((f[m+16>>2]|0)>=(c|0))break;o=f[m+4>>2]|0;if(!o){r=p;break a}else m=o}q=f[m>>2]|0;if(!q){r=m;break}else p=m}if((r|0)==(n|0)){f[k>>2]=c;F5(i,378114,k);z5(-204,i,378151,376410,1170)}if((f[r+16>>2]|0)>(c|0)){f[k>>2]=c;F5(i,378114,k);z5(-204,i,378151,376410,1170)}else{s=n;t=a}b:while(1){a=t;while(1){if((f[a+16>>2]|0)>=(e|0))break;k=f[a+4>>2]|0;if(!k){v=s;break b}else a=k}t=f[a>>2]|0;if(!t){v=a;break}else s=a}if((v|0)==(n|0)){f[j>>2]=e;F5(i,378114,j);z5(-204,i,378151,376410,1170)}if((f[v+16>>2]|0)>(e|0)){f[j>>2]=e;F5(i,378114,j);z5(-204,i,378151,376410,1170)}f[l>>2]=c;f[l+4>>2]=d;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];jGa(v+20|0,g,i);g=r+104|0;v=r+108|0;l=f[v>>2]|0;do if(l){c=r+108|0;j=l;while(1){n=f[j+16>>2]|0;if((n|0)>(d|0)){s=f[j>>2]|0;if(!s){w=23;break}else{x=j;y=s}}else{if((n|0)>=(d|0)){w=27;break}z=j+4|0;n=f[z>>2]|0;if(!n){w=26;break}else{x=z;y=n}}c=x;j=y}if((w|0)==23){A=j;B=j;break}else if((w|0)==26){A=z;B=j;break}else if((w|0)==27){A=c;B=j;break}}else{A=v;B=v}while(0);if(!(f[A>>2]|0)){v=VDc(20)|0;f[v+16>>2]=d;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=B;f[A>>2]=v;B=f[f[g>>2]>>2]|0;if(!B)C=v;else{f[g>>2]=B;C=f[A>>2]|0}laa(f[r+108>>2]|0,C);C=r+112|0;f[C>>2]=(f[C>>2]|0)+1}f[i>>2]=e;f[i+4>>2]=d;d=r+120|0;e=f[d>>2]|0;if((e|0)==(f[r+124>>2]|0)){kGa(r+116|0,i);u=h;return}else{r=i;i=f[r+4>>2]|0;C=e;f[C>>2]=f[r>>2];f[C+4>>2]=i;f[d>>2]=(f[d>>2]|0)+8;u=h;return}}function jGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=d+8|0;h=a+60|0;i=a+64|0;j=f[i>>2]|0;k=f[h>>2]|0;l=j-k>>3;m=k;do if((l|0)>(b|0)){k=m+(b<<3)|0;n=f[k>>2]|0;o=f[k+4>>2]|0;if((o|n|0)<0)p=m;else{if((n|0)==(f[c>>2]|0)?(o|0)==(f[c+4>>2]|0):0){p=m;break}o=f[a+4>>2]|0;f[e>>2]=b;f[e+4>>2]=(o|0)==0?1154740:o;F5(g,378164,e);z5(-2,g,378210,376410,1205)}}else{o=b+1|0;n=j;if(o>>>0>l>>>0){lGa(h,o-l|0);p=f[h>>2]|0;break}if(o>>>0<l>>>0?(k=m+(o<<3)|0,(n|0)!=(k|0)):0){f[i>>2]=n+(~((n+-8-k|0)>>>3)<<3);p=m}else p=m}while(0);m=c;c=f[m+4>>2]|0;i=p+(b<<3)|0;f[i>>2]=f[m>>2];f[i+4>>2]=c;u=d;return}function kGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function lGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){XIc(g|0,-1,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)mCc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;XIc(d|0,-1,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;YDc(h);return}function mGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;iGa(f[a+4>>2]|0,b,c,d,e);return}function nGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=d+8|0;f[a>>2]=-1;h=a+4|0;f[h>>2]=-1;i=(f[c+4>>2]|0)==0;a:do if(i){f[a>>2]=0;j=0}else{k=b+36|0;l=f[k>>2]|0;do if(l|0){m=f[c>>2]|0;n=(m|0)==0?1154740:m;o=k;p=l;b:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(m|0))break;if((Ioc((r|0)==0?1154740:r,n)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break b}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)!=(k|0)){o=f[s+16>>2]|0;if((m|0)!=(o|0)?(Ioc(n,(o|0)==0?1154740:o)|0)<=-1:0)break;o=f[s+24>>2]|0;f[a>>2]=o;if((o|0)>-1){j=o;break a}u=d;return}}while(0);f[a>>2]=-1;u=d;return}while(0);a=b+24|0;b=f[a>>2]|0;if(!b){f[e>>2]=j;F5(g,378114,e);z5(-204,g,378151,376410,1170)}else{t=a;v=b}c:while(1){b=v;while(1){if((f[b+16>>2]|0)>=(j|0))break;s=f[b+4>>2]|0;if(!s){w=t;break c}else b=s}v=f[b>>2]|0;if(!v){w=b;break}else t=b}if((w|0)==(a|0)){f[e>>2]=j;F5(g,378114,e);z5(-204,g,378151,376410,1170)}if((f[w+16>>2]|0)>(j|0)){f[e>>2]=j;F5(g,378114,e);z5(-204,g,378151,376410,1170)}if(i)x=0;else{oGa(g,w+20|0);w=g+4|0;i=f[w>>2]|0;e=Mi[f[(f[i>>2]|0)+52>>2]&1023](i,c)|0;c=f[g>>2]|0;if(c|0?(i=c+4|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[g>>2]=0;f[w>>2]=0;x=e}f[h>>2]=x;u=d;return}function oGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+32|0;e=d+24|0;g=d+16|0;h=d+8|0;i=d;j=c+144|0;k=c+148|0;l=f[k>>2]|0;if(l|0){m=f[j>>2]|0;f[a>>2]=m;f[a+4>>2]=l;if(!m){u=d;return}l=m+4|0;f[l>>2]=(f[l>>2]|0)+1;u=d;return}l=c+12|0;pGa(e,l,c+20|0);m=f[e>>2]|0;n=f[e+4>>2]|0;if(m|0){o=m+4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[j>>2]|0;f[j>>2]=m;f[k>>2]=n;if(o|0?(n=o+4|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)Yi[f[(f[o>>2]|0)+8>>2]&2047](o);o=f[e>>2]|0;if(o|0?(m=o+4|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)Yi[f[(f[o>>2]|0)+8>>2]&2047](o);o=f[k>>2]|0;if(o|0){k=f[j>>2]|0;f[a>>2]=k;f[a+4>>2]=o;if(!k){u=d;return}o=k+4|0;f[o>>2]=(f[o>>2]|0)+1;u=d;return}f[i>>2]=0;d=i+4|0;f[d>>2]=0;o=c+8|0;tT(i,(f[o>>2]|0)+20|0)|0;k=f[i>>2]|0;a=k;j=378224;n=a+20|0;do{b[a>>0]=b[j>>0]|0;a=a+1|0;j=j+1|0}while((a|0)<(n|0));m=f[o>>2]|0;if(m|0)dJc(k+20|0,f[c+4>>2]|0,m|0)|0;f[h>>2]=0;m=h+4|0;f[m>>2]=0;tT(h,(f[d>>2]|0)+11|0)|0;k=f[d>>2]|0;if(!k)p=0;else{dJc(f[h>>2]|0,f[i>>2]|0,k|0)|0;p=f[d>>2]|0}a=(f[h>>2]|0)+p|0;j=378245;n=a+11|0;do{b[a>>0]=b[j>>0]|0;a=a+1|0;j=j+1|0}while((a|0)<(n|0));f[g>>2]=0;j=g+4|0;f[j>>2]=0;a=c+16|0;tT(g,(f[a>>2]|0)+(f[m>>2]|0)|0)|0;c=f[m>>2]|0;if(c|0)dJc(f[g>>2]|0,f[h>>2]|0,c|0)|0;c=f[a>>2]|0;if(c|0)dJc((f[g>>2]|0)+(f[m>>2]|0)|0,f[l>>2]|0,c|0)|0;f[e>>2]=0;f[e+4>>2]=0;tT(e,(f[j>>2]|0)+1|0)|0;c=f[j>>2]|0;if(!c){q=0;r=f[e>>2]|0;s=r+q|0;b[s>>0]=34;z5(-2,e,378257,376410,412)}dJc(f[e>>2]|0,f[g>>2]|0,c|0)|0;q=f[j>>2]|0;r=f[e>>2]|0;s=r+q|0;b[s>>0]=34;z5(-2,e,378257,376410,412)}function pGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+8|0;h=e;i=qGa()|0;m6(i);j=f[c>>2]|0;if(!j){f[h>>2]=0;f[h+4>>2]=0}else{k=c+4|0;l=f[k>>2]|0;f[g>>2]=0;m=g+4|0;f[m>>2]=0;if(l|0?(dJc(tT(g,l)|0,j|0,l|0)|0,f[k>>2]|0):0){l=0;do{j=(Jqc(b[(f[c>>2]|0)+l>>0]|0)|0)&255;b[(f[g>>2]|0)+l>>0]=j;l=l+1|0}while(l>>>0<(f[k>>2]|0)>>>0)}k=f[g>>2]|0;f[h>>2]=k;f[h+4>>2]=f[m>>2];if(k|0){m=k+-4|0;f[m>>2]=(f[m>>2]|0)+1}uT(g)}m=(rGa()|0)+4|0;k=f[m>>2]|0;if(k){l=f[h>>2]|0;c=(l|0)==0?1154740:l;j=m;n=k;a:while(1){k=n;while(1){o=f[k+16>>2]|0;if((o|0)==(l|0))break;if((Ioc((o|0)==0?1154740:o,c)|0)>=0)break;o=f[k+4>>2]|0;if(!o){p=j;break a}else k=o}n=f[k>>2]|0;if(!n){p=k;break}else j=k}if((p|0)!=(m|0)){j=f[p+16>>2]|0;if((l|0)!=(j|0)?(Ioc(c,(j|0)==0?1154740:j)|0)<0:0)q=19;else r=p}else q=19}else q=19;if((q|0)==19)r=m;if((r|0)==((rGa()|0)+4|0)){f[a>>2]=0;f[a+4>>2]=0;uT(h);n6(i);u=e;return}m=f[r+28>>2]|0;if((f[r+24>>2]|0)==(m|0)){f[g>>2]=0;f[g+4>>2]=0;r=tT(g,19)|0;q=378274;p=r+19|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));z5(-215,g,378294,376410,3455)}mi[f[m+-4>>2]&2047](a,d);uT(h);n6(i);u=e;return}function qGa(){var a=0,b=0,c=0;if(f[220307]|0){a=f[220307]|0;return a|0}b=ymb()|0;m6(b);if(!(f[220307]|0)){c=VDc(4)|0;k6(c);f[220307]=c}n6(b);a=f[220307]|0;return a|0}function rGa(){var a=0,c=0;if(f[220303]|0){a=f[220303]|0;return a|0}c=qGa()|0;m6(c);if(!(f[220303]|0)){if((b[520320]|0)==0?MIc(520320)|0:0){f[220305]=0;f[220306]=0;f[220304]=881220;be(1731,881216,x|0)|0}f[220303]=881216;zmb()}n6(c);a=f[220303]|0;return a|0}function sGa(a){a=a|0;tGa(a,f[a+4>>2]|0);return}function tGa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;tGa(a,f[b>>2]|0);tGa(a,f[b+4>>2]|0);a=f[b+24>>2]|0;if(a|0){c=b+28|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~((d+-4-a|0)>>>2)<<2);YDc(a)}uT(b+16|0);YDc(b);return}function uGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+48|0;e=d;g=d+40|0;h=d+16|0;i=d+28|0;j=d+8|0;k=f[c>>2]|0;f[g>>2]=k;l=g+4|0;m=f[c+4>>2]|0;f[l>>2]=m;if(!k)n=m;else{m=k+-4|0;f[m>>2]=(f[m>>2]|0)+1;n=f[l>>2]|0}if(!n){vGa(h,b);n=h+4|0;m=f[n>>2]|0;k=m+-8|0;if((k|0)!=(g|0)){uT(g);c=f[k>>2]|0;if(!c)o=0;else{p=c+-4|0;f[p>>2]=(f[p>>2]|0)+1;o=f[k>>2]|0}f[g>>2]=o;f[l>>2]=f[m+-4>>2]}m=f[h>>2]|0;if(m|0){while(1){o=f[n>>2]|0;if((o|0)==(m|0))break;k=o+-8|0;f[n>>2]=k;uT(k)}YDc(f[h>>2]|0)}}h=b+4|0;nGa(e,f[h>>2]|0,g);f[i>>2]=0;b=i+4|0;f[b>>2]=0;f[i+8>>2]=0;n=VDc(8)|0;f[i>>2]=n;f[i+8>>2]=n+8;m=e;k=f[m+4>>2]|0;o=n;f[o>>2]=f[m>>2];f[o+4>>2]=k;f[b>>2]=n+8;wGa(f[h>>2]|0,i);n=f[h>>2]|0;yGa(n,xGa(n,g)|0,1);n=f[h>>2]|0;h=f[g>>2]|0;f[j>>2]=h;f[j+4>>2]=f[l>>2];if(h|0){l=h+-4|0;f[l>>2]=(f[l>>2]|0)+1}nGa(e,n,j);zGa(a,n,e);uT(j);j=f[i>>2]|0;if(!j){uT(g);u=d;return}i=f[b>>2]|0;if((i|0)!=(j|0))f[b>>2]=i+(~((i+-8-j|0)>>>3)<<3);YDc(j);uT(g);u=d;return}function vGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;J_(a,f[(f[d>>2]|0)+28>>2]|0);b=f[d>>2]|0;e=f[b+20>>2]|0;if((e|0)==(b+24|0))return;b=a+8|0;g=e;while(1){do if(f[g+20>>2]|0){e=g+24|0;h=f[c>>2]|0;if((h|0)==(f[b>>2]|0)){L_(a,e);break}i=f[e>>2]|0;f[h>>2]=i;f[h+4>>2]=f[g+28>>2];if(!i)j=h;else{h=i+-4|0;f[h>>2]=(f[h>>2]|0)+1;j=f[c>>2]|0}f[c>>2]=j+8}while(0);h=f[g+4>>2]|0;if(!h){i=g+8|0;e=f[i>>2]|0;if((f[e>>2]|0)==(g|0))k=e;else{e=i;do{i=f[e>>2]|0;e=i+8|0;l=f[e>>2]|0}while((f[l>>2]|0)!=(i|0));k=l}}else{e=h;while(1){l=f[e>>2]|0;if(!l)break;else e=l}k=e}if((k|0)==((f[d>>2]|0)+24|0))break;else g=k}return}function wGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+176|0;e=d+156|0;g=d;h=d+144|0;i=a+80|0;j=f[i>>2]|0;if(!j){k=f[220302]|0;f[i>>2]=k;l=k}else l=j;switch(l|0){case 3:{if((f[a+84>>2]|0)>>>0>=3){f[e>>2]=0;f[e+4>>2]=0;dJc(tT(e,164)|0,378850,164)|0;z5(-215,e,379015,376410,1072)}break}case 1:{if((f[a+84>>2]|0)>>>0>=2){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,118)|0;n=379024;o=m+118|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,379015,376410,1075)}break}case 2:{if((f[a+84>>2]|0)>>>0>=5){f[e>>2]=0;f[e+4>>2]=0;dJc(tT(e,254)|0,379143,254)|0;z5(-215,e,379015,376410,1081)}break}default:{}}j=a+116|0;a:do if(b[j>>0]|0?(k=f[a+12>>2]|0,p=f[a+8>>2]|0,q=f[c>>2]|0,r=p,s=k,(k-p|0)==((f[c+4>>2]|0)-q|0)):0){if((r|0)==(s|0)){u=d;return}p=r;r=q;while(1){if((f[p>>2]|0)!=(f[r>>2]|0))break a;if((f[p+4>>2]|0)!=(f[r+4>>2]|0))break a;p=p+8|0;if((p|0)==(s|0))break;else r=r+8|0}u=d;return}while(0);if((l|0)==3?(l=a+84|0,((f[l>>2]|0)+-1|0)>>>0<2):0){if((Imc()|0)>=3){r=g+64|0;s=g+8|0;f[s>>2]=45704;p=g+12|0;f[g>>2]=6980;f[r>>2]=7e3;f[g+4>>2]=0;auc(g+64|0,p);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=45684;f[r>>2]=45724;f[s>>2]=45704;fuc(p);f[p>>2]=45740;s=g+44|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[g+60>>2]=24;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G1(p,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);H1(g+8|0,379398,75)|0;I1(h,p);p=h+11|0;Jmc(3,(b[p>>0]|0)<0?f[h>>2]|0:h);if((b[p>>0]|0)<0)YDc(f[h>>2]|0);K1(g)}f[l>>2]=0}HGa(a);IGa(a,c);l=a+24|0;g=f[l>>2]|0;if(!g){f[e>>2]=0;t=e+4|0;f[t>>2]=0;v=tT(e,18)|0;m=v;n=379474;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,379015,376410,1116)}else{w=l;x=g}b:while(1){g=x;while(1){if((f[g+16>>2]|0)>=0)break;h=f[g+4>>2]|0;if(!h){y=w;break b}else g=h}x=f[g>>2]|0;if(!x){y=g;break}else w=g}if((y|0)==(l|0)){f[e>>2]=0;t=e+4|0;f[t>>2]=0;v=tT(e,18)|0;m=v;n=379474;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,379015,376410,1116)}if((f[y+16>>2]|0)>=1){f[e>>2]=0;t=e+4|0;f[t>>2]=0;v=tT(e,18)|0;m=v;n=379474;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,379015,376410,1116)}b[y+220>>0]=b[(f[a+4>>2]|0)+84>>0]|0;JGa(a);if((b[j>>0]|0)==0?(f[i>>2]|0)==1:0){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,39)|0;n=379493;o=m+39|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,e,379015,376410,1127)}b[j>>0]=1;j=a+8|0;if((j|0)==(c|0)){u=d;return}KGa(j,f[c>>2]|0,f[c+4>>2]|0);u=d;return}function xGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+32|0;e=d;g=d+16|0;h=d+8|0;i=a+36|0;j=f[i>>2]|0;do if(j|0){k=f[c>>2]|0;l=(k|0)==0?1154740:k;m=i;n=j;a:while(1){o=n;while(1){p=f[o+16>>2]|0;if((p|0)==(k|0))break;if((Ioc((p|0)==0?1154740:p,l)|0)>=0)break;p=f[o+4>>2]|0;if(!p){q=m;break a}else o=p}n=f[o>>2]|0;if(!n){q=o;break}else m=o}if((q|0)!=(i|0)){m=f[q+16>>2]|0;if((k|0)!=(m|0)?(Ioc(l,(m|0)==0?1154740:m)|0)<=-1:0)break;m=f[q+24>>2]|0;if((m|0)>=0){n=a+24|0;p=f[n>>2]|0;if(!p){f[e>>2]=m;F5(g,378114,e);z5(-204,g,378151,376410,1170)}else{r=n;s=p}b:while(1){p=s;while(1){if((f[p+16>>2]|0)>=(m|0))break;t=f[p+4>>2]|0;if(!t){v=r;break b}else p=t}s=f[p>>2]|0;if(!s){v=p;break}else r=p}if((v|0)==(n|0)){f[e>>2]=m;F5(g,378114,e);z5(-204,g,378151,376410,1170)}if((f[v+16>>2]|0)>(m|0)){f[e>>2]=m;F5(g,378114,e);z5(-204,g,378151,376410,1170)}else{u=d;return v+20|0}}}}while(0);f[h>>2]=0;v=h+4|0;f[v>>2]=0;d=c+4|0;tT(h,(f[d>>2]|0)+17|0)|0;e=f[h>>2]|0;r=e;s=378820;a=r+17|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(a|0));q=f[d>>2]|0;if(q|0)dJc(e+17|0,f[c>>2]|0,q|0)|0;f[g>>2]=0;f[g+4>>2]=0;tT(g,(f[v>>2]|0)+11|0)|0;q=f[v>>2]|0;if(!q){w=0;x=f[g>>2]|0;y=x+w|0;r=y;s=378838;a=r+11|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(a|0));z5(-2,g,378151,376410,1180)}dJc(f[g>>2]|0,f[h>>2]|0,q|0)|0;w=f[v>>2]|0;x=f[g>>2]|0;y=x+w|0;r=y;s=378838;a=r+11|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(a|0));z5(-2,g,378151,376410,1180);return 0}function yGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(c?(c=f[a+20>>2]|0,d=a+24|0,(c|0)!=(d|0)):0){e=c;while(1){f[e+224>>2]=0;c=f[e+4>>2]|0;if(!c){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))i=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;j=f[h>>2]|0}while((f[j>>2]|0)!=(g|0));i=j}}else{h=c;while(1){j=f[h>>2]|0;if(!j)break;else h=j}i=h}if((i|0)==(d|0))break;else e=i}}if(f[b+204>>2]|0)return;i=f[a+20>>2]|0;e=a+24|0;a:do if((i|0)!=(e|0)){d=i;while(1){c=d+20|0;if((f[c>>2]|0)>=(f[b>>2]|0))break a;if(!(f[d+224>>2]|0))BGa(a,c);c=f[d+4>>2]|0;if(!c){j=d+8|0;g=f[j>>2]|0;if((f[g>>2]|0)==(d|0))k=g;else{g=j;do{j=f[g>>2]|0;g=j+8|0;l=f[g>>2]|0}while((f[l>>2]|0)!=(j|0));k=l}}else{g=c;while(1){l=f[g>>2]|0;if(!l)break;else g=l}k=g}if((k|0)==(e|0))break;else d=k}}while(0);BGa(a,b);return}function zGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+48|0;g=e;h=e+32|0;i=e+16|0;if((f[d>>2]|0)<=-1){f[h>>2]=0;j=h+4|0;f[j>>2]=0;k=tT(h,24)|0;l=k;m=378314;n=l+24|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-204,h,382070,376410,2393)}o=d+4|0;if((f[o>>2]|0)<=-1){f[h>>2]=0;j=h+4|0;f[j>>2]=0;k=tT(h,24)|0;l=k;m=378314;n=l+24|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-204,h,382070,376410,2393)}k=AGa(c+20|0,d)|0;d=f[o>>2]|0;j=k+152|0;p=f[j>>2]|0;q=((f[k+156>>2]|0)-p|0)/56|0;if(d>>>0>=q>>>0){r=f[k+4>>2]|0;f[g>>2]=(r|0)==0?1154740:r;f[g+4>>2]=q;f[g+8>>2]=d;F5(h,378339,g);z5(-211,h,382070,376410,2400)}do if(f[c+84>>2]|0){g=f[k+108>>2]|0;if((g|0)==(f[k+112>>2]|0)){f[h>>2]=0;s=h+4|0;f[s>>2]=0;t=tT(h,75)|0;l=t;m=378397;n=l+75|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,h,382070,376410,2404)}q=f[g+(d<<3)+4>>2]|0;if(!q){f[h>>2]=0;s=h+4|0;f[s>>2]=0;t=tT(h,75)|0;l=t;m=378397;n=l+75|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z5(-215,h,382070,376410,2404)}else{Yi[f[(f[q>>2]|0)+8>>2]&2047](q);v=j;w=f[j>>2]|0;x=f[o>>2]|0;break}}else{v=j;w=p;x=d}while(0);d=w+(x*56|0)|0;p=f[d>>2]|0;if((p&7|0)==3){j=(f[v>>2]|0)+(x*56|0)|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=j;j=c+132|0;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=j;NZ(h,i);f[a>>2]=f[j>>2];i=a+4|0;h=c+136|0;v=f[h>>2]|0;f[i>>2]=v;o=a+8|0;f[o>>2]=f[c+140>>2];f[a+12>>2]=f[c+144>>2];f[a+16>>2]=f[c+148>>2];f[a+20>>2]=f[c+152>>2];f[a+24>>2]=f[c+156>>2];f[a+28>>2]=f[c+160>>2];f[a+32>>2]=f[c+164>>2];m=f[c+168>>2]|0;f[a+36>>2]=m;f[a+40>>2]=o;o=a+48|0;l=a+44|0;f[l>>2]=o;f[o>>2]=0;f[a+52>>2]=0;if(!m)y=v;else{v=m+12|0;f[v>>2]=(f[v>>2]|0)+1;y=f[h>>2]|0}if((y|0)<3){y=f[c+176>>2]|0;c=f[l>>2]|0;f[c>>2]=f[y>>2];f[c+4>>2]=f[y+4>>2];u=e;return}else{f[i>>2]=0;ZS(a,j);u=e;return}}else{f[a>>2]=p;p=a+4|0;j=w+(x*56|0)+4|0;f[p>>2]=f[j>>2];i=a+8|0;f[i>>2]=f[w+(x*56|0)+8>>2];f[a+12>>2]=f[w+(x*56|0)+12>>2];f[a+16>>2]=f[w+(x*56|0)+16>>2];f[a+20>>2]=f[w+(x*56|0)+20>>2];f[a+24>>2]=f[w+(x*56|0)+24>>2];f[a+28>>2]=f[w+(x*56|0)+28>>2];f[a+32>>2]=f[w+(x*56|0)+32>>2];y=f[w+(x*56|0)+36>>2]|0;f[a+36>>2]=y;f[a+40>>2]=i;i=a+48|0;c=a+44|0;f[c>>2]=i;f[i>>2]=0;f[a+52>>2]=0;if(y|0){i=y+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[j>>2]|0)<3){j=f[w+(x*56|0)+44>>2]|0;x=f[c>>2]|0;f[x>>2]=f[j>>2];f[x+4>>2]=f[j+4>>2];u=e;return}else{f[p>>2]=0;ZS(a,d);u=e;return}}}function AGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a+4|0;e=f[d>>2]|0;do if(e){g=f[c>>2]|0;h=a+4|0;i=e;j=e;while(1){k=f[i+16>>2]|0;if((g|0)<(k|0)){l=f[i>>2]|0;if(!l){m=6;break}else{n=i;o=l}}else{if((k|0)>=(g|0)){m=10;break}p=i+4|0;k=f[p>>2]|0;if(!k){m=9;break}else{n=p;o=k}}h=n;i=o;j=o}if((m|0)==6){q=i;r=i;break}else if((m|0)==9){q=p;r=i;break}else if((m|0)==10){s=h;t=i;u=j;m=12;break}}else{s=d;t=d;u=e;m=12}while(0);if((m|0)==12)if(!u){q=s;r=t}else{v=u;w=v+20|0;return w|0}u=VDc(228)|0;f[u+16>>2]=f[c>>2];f[u+20>>2]=-1;c=u+24|0;t=u+44|0;f[t>>2]=0;f[u+48>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[u+40>>2]=t;t=u+96|0;f[t>>2]=0;f[u+100>>2]=0;c=u+92|0;s=u+52|0;m=s+40|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(m|0));f[c>>2]=t;t=u+108|0;f[t>>2]=0;f[u+112>>2]=0;f[u+104>>2]=t;t=u+212|0;f[t>>2]=0;f[u+216>>2]=0;c=u+208|0;s=u+116|0;m=s+92|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(m|0));f[c>>2]=t;b[u+220>>0]=0;f[u+224>>2]=0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=r;f[q>>2]=u;r=f[f[a>>2]>>2]|0;if(!r)x=u;else{f[a>>2]=r;x=f[q>>2]|0}laa(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;v=u;w=v+20|0;return w|0}function BGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0;d=u;u=u+320|0;e=d+256|0;g=d+240|0;h=d+184|0;i=d+168|0;j=d+112|0;k=d+56|0;l=d;m=f[c+144>>2]|0;n=f[c+148>>2]|0;o=(m|0)==0;if(!o){p=m+4|0;f[p>>2]=(f[p>>2]|0)+1}p=h6()|0;q=J;a:do if(!(b[c+200>>0]|0)){r=a+80|0;s=c+192|0;t=f[s>>2]|0;v=f[r>>2]|0;if(t){w=s;x=t;b:while(1){t=x;while(1){if((f[t+16>>2]|0)>=(v|0))break;y=f[t+4>>2]|0;if(!y){z=w;break b}else t=y}x=f[t>>2]|0;if(!x){z=t;break}else w=t}if((z|0)!=(s|0)?(v|0)>=(f[z+16>>2]|0):0)A=z;else B=11}else B=11;if((B|0)==11)A=s;if((v|0)==3){if(((f[a+84>>2]|0)+-1|0)>>>0<2){CGa(g,c+120|0);w=c+108|0;CGa(h,w);CGa(i,c+132|0);x=n;y=f[(f[n>>2]|0)+44>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17498112;f[e+4>>2]=g;C=j+8|0;f[C>>2]=0;f[C+4>>2]=0;f[j>>2]=34275328;f[j+4>>2]=h;C=k+8|0;f[C>>2]=0;f[C+4>>2]=0;f[k>>2]=34275328;f[k+4>>2]=i;ei[y&511](x,e,j,k);if(b[1152662]|0?(y=h+4|0,C=f[h>>2]|0,(f[y>>2]|0)!=(C|0)):0){D=j+4|0;E=j+8|0;F=j+40|0;G=j+48|0;H=j+44|0;I=j+52|0;K=e+8|0;L=e+12|0;M=e+4|0;N=k+8|0;O=k+4|0;P=e+8|0;Q=e+12|0;R=e+4|0;S=e+8|0;T=e+12|0;U=e+4|0;V=x+16|0;x=k+4|0;W=k+8|0;X=j+36|0;Y=j+16|0;Z=k+4|0;_=k+8|0;$=e+36|0;aa=e+4|0;ba=e+8|0;ca=e+12|0;da=j+12|0;ea=e+44|0;fa=e+16|0;ga=e+20|0;ha=j+20|0;ia=e+24|0;ja=j+24|0;ka=e+28|0;la=j+28|0;ma=e+32|0;na=j+32|0;oa=e+40|0;pa=e+48|0;qa=0;ra=0;sa=C;while(1){C=sa+(ra*48|0)|0;f[j>>2]=1124007936;ta=D;ua=ta+36|0;do{f[ta>>2]=0;ta=ta+4|0}while((ta|0)<(ua|0));f[F>>2]=E;f[H>>2]=G;f[G>>2]=0;f[I>>2]=0;if((f[C>>2]&7|0)!=3){PQ(e,C,16777216);t=f[$>>2]|0;if(t|0){va=t+12|0;f[va>>2]=(f[va>>2]|0)+1}va=f[X>>2]|0;if(va|0?(t=va+12|0,va=f[t>>2]|0,f[t>>2]=va+-1,(va|0)==1):0)_S(j);f[X>>2]=0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[D>>2]|0)>0){va=f[F>>2]|0;t=0;do{f[va+(t<<2)>>2]=0;t=t+1|0;wa=f[D>>2]|0}while((t|0)<(wa|0));f[j>>2]=f[e>>2];if((wa|0)<3)B=34;else B=36}else{f[j>>2]=f[e>>2];B=34}if((B|0)==34){B=0;t=f[aa>>2]|0;if((t|0)<3){f[D>>2]=t;f[E>>2]=f[ba>>2];f[da>>2]=f[ca>>2];t=f[ea>>2]|0;va=f[H>>2]|0;f[va>>2]=f[t>>2];f[va+4>>2]=f[t+4>>2]}else B=36}if((B|0)==36){B=0;ZS(j,e)}f[Y>>2]=f[fa>>2];f[ha>>2]=f[ga>>2];f[ja>>2]=f[ia>>2];f[la>>2]=f[ka>>2];f[na>>2]=f[ma>>2];t=f[$>>2]|0;f[X>>2]=t;if(t|0?(va=t+12|0,t=f[va>>2]|0,f[va>>2]=t+-1,(t|0)==1):0)_S(e);f[$>>2]=0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[aa>>2]|0)>0){t=f[oa>>2]|0;va=0;do{f[t+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[aa>>2]|0))}va=f[ea>>2]|0;if((va|0)!=(pa|0))g0(va)}else{f[K>>2]=0;f[L>>2]=0;f[e>>2]=17432576;f[M>>2]=C;va=N;f[va>>2]=0;f[va+4>>2]=0;f[k>>2]=33619968;f[O>>2]=j;NZ(e,k)}f[P>>2]=0;f[Q>>2]=0;f[e>>2]=16842752;f[R>>2]=j;if(m3(e,1,0,-1797693134862315708145274.0e284,1797693134862315708145274.0e284)|0){f[S>>2]=0;f[T>>2]=0;f[e>>2]=16842752;f[U>>2]=j;if(m3(e,1,0,-1.0e6,1.0e6)|0)xa=qa;else{va=H1(884536,378549,42)|0;t=H1(suc(va,f[c>>2]|0)|0,378516,6)|0;va=f[V>>2]|0;ya=(va|0)==0?1154740:va;va=H1(t,ya,Mpc(ya)|0)|0;cuc(e,va+(f[(f[va>>2]|0)+-12>>2]|0)|0);ya=Hvc(e,885240)|0;t=Mi[f[(f[ya>>2]|0)+28>>2]&1023](ya,10)|0;Ivc(e);wuc(va,t)|0;iuc(va)|0;va=H1(tuc(H1(884536,378523,10)|0,ra)|0,378534,14)|0;t=f[D>>2]|0;ya=f[F>>2]|0;f[k>>2]=0;f[x>>2]=0;f[W>>2]=0;lFa(k,ya,ya+(t<<2)|0);t=DGa(va,k)|0;cuc(e,va+(f[(f[va>>2]|0)+-12>>2]|0)|0);va=Hvc(e,885240)|0;ya=Mi[f[(f[va>>2]|0)+28>>2]&1023](va,10)|0;Ivc(e);wuc(t,ya)|0;iuc(t)|0;t=f[k>>2]|0;if(t|0){ya=f[x>>2]|0;if((ya|0)!=(t|0))f[x>>2]=ya+(~((ya+-4-t|0)>>>2)<<2);YDc(t)}xa=1}}else{t=H1(884536,378473,42)|0;ya=H1(suc(t,f[c>>2]|0)|0,378516,6)|0;t=f[V>>2]|0;va=(t|0)==0?1154740:t;t=H1(ya,va,Mpc(va)|0)|0;cuc(e,t+(f[(f[t>>2]|0)+-12>>2]|0)|0);va=Hvc(e,885240)|0;ya=Mi[f[(f[va>>2]|0)+28>>2]&1023](va,10)|0;Ivc(e);wuc(t,ya)|0;iuc(t)|0;t=H1(tuc(H1(884536,378523,10)|0,ra)|0,378534,14)|0;ya=f[D>>2]|0;va=f[F>>2]|0;f[k>>2]=0;f[Z>>2]=0;f[_>>2]=0;lFa(k,va,va+(ya<<2)|0);ya=DGa(t,k)|0;cuc(e,t+(f[(f[t>>2]|0)+-12>>2]|0)|0);t=Hvc(e,885240)|0;va=Mi[f[(f[t>>2]|0)+28>>2]&1023](t,10)|0;Ivc(e);wuc(ya,va)|0;iuc(ya)|0;ya=f[k>>2]|0;if(ya|0){va=f[Z>>2]|0;if((va|0)!=(ya|0))f[Z>>2]=va+(~((va+-4-ya|0)>>>2)<<2);YDc(ya)}xa=1}ya=f[X>>2]|0;if(ya|0?(va=ya+12|0,ya=f[va>>2]|0,f[va>>2]=ya+-1,(ya|0)==1):0)_S(j);f[X>>2]=0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[D>>2]|0)>0){ya=f[F>>2]|0;va=0;do{f[ya+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[D>>2]|0))}va=f[H>>2]|0;if((va|0)!=(G|0))g0(va);ra=ra+1|0;za=f[y>>2]|0;Aa=f[h>>2]|0;sa=Aa;if(ra>>>0>=((za-Aa|0)/48|0)>>>0)break;else qa=xa}if(xa){qa=g+4|0;ra=f[g>>2]|0;if((f[qa>>2]|0)==(ra|0)){Ba=sa;Ca=za;Da=Aa}else{G=j+4|0;H=j+8|0;D=j+40|0;F=j+48|0;Y=j+44|0;X=j+52|0;Z=e+8|0;_=e+12|0;V=e+4|0;x=k+8|0;W=k+4|0;U=l+4|0;T=l+8|0;S=j+36|0;R=j+16|0;Q=k+36|0;P=k+16|0;O=k+4|0;N=k+40|0;M=k+44|0;L=k+48|0;K=e+36|0;pa=e+4|0;ea=e+8|0;aa=e+12|0;oa=j+12|0;fa=e+44|0;$=e+16|0;ma=e+20|0;na=j+20|0;ka=e+24|0;la=j+24|0;ia=e+28|0;ja=j+28|0;ga=e+32|0;ha=j+32|0;ca=e+40|0;da=e+48|0;ba=0;E=ra;do{ra=E+(ba*48|0)|0;f[j>>2]=1124007936;ta=G;ua=ta+36|0;do{f[ta>>2]=0;ta=ta+4|0}while((ta|0)<(ua|0));f[D>>2]=H;f[Y>>2]=F;f[F>>2]=0;f[X>>2]=0;if((f[ra>>2]&7|0)!=3){PQ(e,ra,16777216);I=f[K>>2]|0;if(I|0){v=I+12|0;f[v>>2]=(f[v>>2]|0)+1}v=f[S>>2]|0;if(v|0?(I=v+12|0,v=f[I>>2]|0,f[I>>2]=v+-1,(v|0)==1):0)_S(j);f[S>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[G>>2]|0)>0){v=f[D>>2]|0;I=0;do{f[v+(I<<2)>>2]=0;I=I+1|0;Ea=f[G>>2]|0}while((I|0)<(Ea|0));f[j>>2]=f[e>>2];if((Ea|0)<3)B=82;else B=84}else{f[j>>2]=f[e>>2];B=82}do if((B|0)==82){B=0;I=f[pa>>2]|0;if((I|0)>=3){B=84;break}f[G>>2]=I;f[H>>2]=f[ea>>2];f[oa>>2]=f[aa>>2];I=f[fa>>2]|0;v=f[Y>>2]|0;f[v>>2]=f[I>>2];f[v+4>>2]=f[I+4>>2]}while(0);if((B|0)==84){B=0;ZS(j,e)}f[R>>2]=f[$>>2];f[na>>2]=f[ma>>2];f[la>>2]=f[ka>>2];f[ja>>2]=f[ia>>2];f[ha>>2]=f[ga>>2];I=f[K>>2]|0;f[S>>2]=I;do if(I|0){v=I+12|0;va=f[v>>2]|0;f[v>>2]=va+-1;if((va|0)!=1)break;_S(e)}while(0);f[K>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[pa>>2]|0)>0){I=f[ca>>2]|0;va=0;do{f[I+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[pa>>2]|0))}va=f[fa>>2]|0;if((va|0)!=(da|0))g0(va)}else{f[Z>>2]=0;f[_>>2]=0;f[e>>2]=17432576;f[V>>2]=ra;va=x;f[va>>2]=0;f[va+4>>2]=0;f[k>>2]=33619968;f[W>>2]=j;NZ(e,k)}va=H1(tuc(H1(884368,378592,6)|0,ba)|0,517879,1)|0;E1(k,f[ra>>2]&4095);I=f[k>>2]|0;v=(I|0)==0?1154740:I;I=H1(H1(va,v,Mpc(v)|0)|0,517879,1)|0;v=f[G>>2]|0;va=f[D>>2]|0;f[l>>2]=0;f[U>>2]=0;f[T>>2]=0;lFa(l,va,va+(v<<2)|0);v=DGa(I,l)|0;cuc(e,I+(f[(f[I>>2]|0)+-12>>2]|0)|0);I=Hvc(e,885240)|0;va=Mi[f[(f[I>>2]|0)+28>>2]&1023](I,10)|0;Ivc(e);wuc(v,va)|0;iuc(v)|0;v=f[l>>2]|0;if(v|0){va=f[U>>2]|0;if((va|0)!=(v|0))f[U>>2]=va+(~((va+-4-v|0)>>>2)<<2);YDc(v)}uT(k);if(b[1152663]|0){lT(k,j,1,1);v=EGa(884368,k)|0;cuc(e,884368+(f[(f[221092]|0)+-12>>2]|0)|0);va=Hvc(e,885240)|0;I=Mi[f[(f[va>>2]|0)+28>>2]&1023](va,10)|0;Ivc(e);wuc(v,I)|0;iuc(v)|0;v=f[Q>>2]|0;do if(v|0){I=v+12|0;va=f[I>>2]|0;f[I>>2]=va+-1;if((va|0)!=1)break;_S(k)}while(0);f[Q>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[O>>2]|0)>0){v=f[N>>2]|0;ra=0;do{f[v+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[O>>2]|0))}ra=f[M>>2]|0;if((ra|0)!=(L|0))g0(ra)}ra=f[S>>2]|0;if(ra|0?(v=ra+12|0,ra=f[v>>2]|0,f[v>>2]=ra+-1,(ra|0)==1):0)_S(j);f[S>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[G>>2]|0)>0){ra=f[D>>2]|0;v=0;do{f[ra+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[G>>2]|0))}v=f[Y>>2]|0;if((v|0)!=(F|0))g0(v);ba=ba+1|0;E=f[g>>2]|0}while(ba>>>0<(((f[qa>>2]|0)-E|0)/48|0)>>>0);E=f[h>>2]|0;Ba=E;Ca=f[y>>2]|0;Da=E}if((Ca|0)!=(Da|0)){E=j+4|0;qa=j+8|0;ba=j+40|0;F=j+48|0;Y=j+44|0;G=j+52|0;D=e+8|0;R=e+12|0;S=e+4|0;L=k+8|0;M=k+4|0;O=l+4|0;N=l+8|0;P=j+36|0;Q=j+16|0;U=k+36|0;T=k+16|0;W=k+4|0;x=k+40|0;V=k+44|0;_=k+48|0;Z=e+36|0;da=e+4|0;fa=e+8|0;pa=e+12|0;ca=j+12|0;$=e+44|0;K=e+16|0;ga=e+20|0;ha=j+20|0;ia=e+24|0;ja=j+24|0;ka=e+28|0;la=j+28|0;ma=e+32|0;na=j+32|0;aa=e+40|0;oa=e+48|0;ea=0;H=Ba;do{X=H+(ea*48|0)|0;f[j>>2]=1124007936;ta=E;ua=ta+36|0;do{f[ta>>2]=0;ta=ta+4|0}while((ta|0)<(ua|0));f[ba>>2]=qa;f[Y>>2]=F;f[F>>2]=0;f[G>>2]=0;if((f[X>>2]&7|0)!=3){PQ(e,X,16777216);sa=f[Z>>2]|0;if(sa|0){v=sa+12|0;f[v>>2]=(f[v>>2]|0)+1}v=f[P>>2]|0;do if(v|0){sa=v+12|0;ra=f[sa>>2]|0;f[sa>>2]=ra+-1;if((ra|0)!=1)break;_S(j)}while(0);f[P>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[E>>2]|0)>0){v=f[ba>>2]|0;ra=0;do{f[v+(ra<<2)>>2]=0;ra=ra+1|0;Fa=f[E>>2]|0}while((ra|0)<(Fa|0));f[j>>2]=f[e>>2];if((Fa|0)<3)B=131;else B=133}else{f[j>>2]=f[e>>2];B=131}do if((B|0)==131){B=0;ra=f[da>>2]|0;if((ra|0)>=3){B=133;break}f[E>>2]=ra;f[qa>>2]=f[fa>>2];f[ca>>2]=f[pa>>2];ra=f[$>>2]|0;v=f[Y>>2]|0;f[v>>2]=f[ra>>2];f[v+4>>2]=f[ra+4>>2]}while(0);if((B|0)==133){B=0;ZS(j,e)}f[Q>>2]=f[K>>2];f[ha>>2]=f[ga>>2];f[ja>>2]=f[ia>>2];f[la>>2]=f[ka>>2];f[na>>2]=f[ma>>2];ra=f[Z>>2]|0;f[P>>2]=ra;do if(ra|0){v=ra+12|0;sa=f[v>>2]|0;f[v>>2]=sa+-1;if((sa|0)!=1)break;_S(e)}while(0);f[Z>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[da>>2]|0)>0){ra=f[aa>>2]|0;sa=0;do{f[ra+(sa<<2)>>2]=0;sa=sa+1|0}while((sa|0)<(f[da>>2]|0))}sa=f[$>>2]|0;if((sa|0)!=(oa|0))g0(sa)}else{f[D>>2]=0;f[R>>2]=0;f[e>>2]=17432576;f[S>>2]=X;sa=L;f[sa>>2]=0;f[sa+4>>2]=0;f[k>>2]=33619968;f[M>>2]=j;NZ(e,k)}sa=H1(tuc(H1(884368,378599,7)|0,ea)|0,517879,1)|0;E1(k,f[X>>2]&4095);ra=f[k>>2]|0;v=(ra|0)==0?1154740:ra;ra=H1(H1(sa,v,Mpc(v)|0)|0,517879,1)|0;v=f[E>>2]|0;sa=f[ba>>2]|0;f[l>>2]=0;f[O>>2]=0;f[N>>2]=0;lFa(l,sa,sa+(v<<2)|0);v=DGa(ra,l)|0;cuc(e,ra+(f[(f[ra>>2]|0)+-12>>2]|0)|0);ra=Hvc(e,885240)|0;sa=Mi[f[(f[ra>>2]|0)+28>>2]&1023](ra,10)|0;Ivc(e);wuc(v,sa)|0;iuc(v)|0;v=f[l>>2]|0;if(v|0){sa=f[O>>2]|0;if((sa|0)!=(v|0))f[O>>2]=sa+(~((sa+-4-v|0)>>>2)<<2);YDc(v)}uT(k);if(b[1152663]|0){lT(k,j,1,1);v=EGa(884368,k)|0;cuc(e,884368+(f[(f[221092]|0)+-12>>2]|0)|0);sa=Hvc(e,885240)|0;ra=Mi[f[(f[sa>>2]|0)+28>>2]&1023](sa,10)|0;Ivc(e);wuc(v,ra)|0;iuc(v)|0;v=f[U>>2]|0;do if(v|0){ra=v+12|0;sa=f[ra>>2]|0;f[ra>>2]=sa+-1;if((sa|0)!=1)break;_S(k)}while(0);f[U>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[W>>2]|0)>0){v=f[x>>2]|0;X=0;do{f[v+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[W>>2]|0))}X=f[V>>2]|0;if((X|0)!=(_|0))g0(X)}X=f[P>>2]|0;do if(X|0){v=X+12|0;sa=f[v>>2]|0;f[v>>2]=sa+-1;if((sa|0)!=1)break;_S(j)}while(0);f[P>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[E>>2]|0)>0){X=f[ba>>2]|0;sa=0;do{f[X+(sa<<2)>>2]=0;sa=sa+1|0}while((sa|0)<(f[E>>2]|0))}sa=f[Y>>2]|0;if((sa|0)!=(F|0))g0(sa);ea=ea+1|0;H=f[h>>2]|0}while(ea>>>0<(((f[y>>2]|0)-H|0)/48|0)>>>0)}H=i+4|0;y=f[i>>2]|0;if((f[H>>2]|0)!=(y|0)){ea=j+4|0;F=j+8|0;Y=j+40|0;E=j+48|0;ba=j+44|0;Q=j+52|0;P=e+8|0;_=e+12|0;V=e+4|0;W=k+8|0;x=k+4|0;T=k+4|0;U=k+8|0;O=j+36|0;N=j+16|0;M=l+36|0;L=l+16|0;S=l+4|0;R=l+40|0;D=l+44|0;oa=l+48|0;$=e+36|0;da=e+4|0;aa=e+8|0;K=e+12|0;Z=j+12|0;ma=e+44|0;na=e+16|0;ka=e+20|0;la=j+20|0;ia=e+24|0;ja=j+24|0;ga=e+28|0;ha=j+28|0;pa=e+32|0;ca=j+32|0;fa=e+40|0;qa=e+48|0;G=0;sa=y;do{y=sa+(G*48|0)|0;f[j>>2]=1124007936;ta=ea;ua=ta+36|0;do{f[ta>>2]=0;ta=ta+4|0}while((ta|0)<(ua|0));f[Y>>2]=F;f[ba>>2]=E;f[E>>2]=0;f[Q>>2]=0;if((f[y>>2]&7|0)!=3){PQ(e,y,16777216);X=f[$>>2]|0;if(X|0){v=X+12|0;f[v>>2]=(f[v>>2]|0)+1}v=f[O>>2]|0;do if(v|0){X=v+12|0;ra=f[X>>2]|0;f[X>>2]=ra+-1;if((ra|0)!=1)break;_S(j)}while(0);f[O>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[ea>>2]|0)>0){v=f[Y>>2]|0;ra=0;do{f[v+(ra<<2)>>2]=0;ra=ra+1|0;Ga=f[ea>>2]|0}while((ra|0)<(Ga|0));f[j>>2]=f[e>>2];if((Ga|0)<3)B=179;else B=181}else{f[j>>2]=f[e>>2];B=179}do if((B|0)==179){B=0;ra=f[da>>2]|0;if((ra|0)>=3){B=181;break}f[ea>>2]=ra;f[F>>2]=f[aa>>2];f[Z>>2]=f[K>>2];ra=f[ma>>2]|0;v=f[ba>>2]|0;f[v>>2]=f[ra>>2];f[v+4>>2]=f[ra+4>>2]}while(0);if((B|0)==181){B=0;ZS(j,e)}f[N>>2]=f[na>>2];f[la>>2]=f[ka>>2];f[ja>>2]=f[ia>>2];f[ha>>2]=f[ga>>2];f[ca>>2]=f[pa>>2];ra=f[$>>2]|0;f[O>>2]=ra;do if(ra|0){v=ra+12|0;X=f[v>>2]|0;f[v>>2]=X+-1;if((X|0)!=1)break;_S(e)}while(0);f[$>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[da>>2]|0)>0){ra=f[fa>>2]|0;X=0;do{f[ra+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[da>>2]|0))}X=f[ma>>2]|0;if((X|0)!=(qa|0))g0(X)}else{f[P>>2]=0;f[_>>2]=0;f[e>>2]=17432576;f[V>>2]=y;X=W;f[X>>2]=0;f[X+4>>2]=0;f[k>>2]=33619968;f[x>>2]=j;NZ(e,k)}X=H1(tuc(H1(884368,378607,9)|0,G)|0,517879,1)|0;ra=f[ea>>2]|0;v=f[Y>>2]|0;f[k>>2]=0;f[T>>2]=0;f[U>>2]=0;lFa(k,v,v+(ra<<2)|0);ra=DGa(X,k)|0;cuc(e,X+(f[(f[X>>2]|0)+-12>>2]|0)|0);X=Hvc(e,885240)|0;v=Mi[f[(f[X>>2]|0)+28>>2]&1023](X,10)|0;Ivc(e);wuc(ra,v)|0;iuc(ra)|0;ra=f[k>>2]|0;if(ra|0){v=f[T>>2]|0;if((v|0)!=(ra|0))f[T>>2]=v+(~((v+-4-ra|0)>>>2)<<2);YDc(ra)}if(b[1152663]|0){E1(k,f[y>>2]&4095);ra=f[k>>2]|0;v=(ra|0)==0?1154740:ra;ra=H1(H1(884368,v,Mpc(v)|0)|0,517879,1)|0;lT(l,j,1,1);v=EGa(ra,l)|0;cuc(e,ra+(f[(f[ra>>2]|0)+-12>>2]|0)|0);ra=Hvc(e,885240)|0;X=Mi[f[(f[ra>>2]|0)+28>>2]&1023](ra,10)|0;Ivc(e);wuc(v,X)|0;iuc(v)|0;v=f[M>>2]|0;do if(v|0){X=v+12|0;ra=f[X>>2]|0;f[X>>2]=ra+-1;if((ra|0)!=1)break;_S(l)}while(0);f[M>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[S>>2]|0)>0){v=f[R>>2]|0;y=0;do{f[v+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[S>>2]|0))}y=f[D>>2]|0;if((y|0)!=(oa|0))g0(y);uT(k)}y=f[O>>2]|0;do if(y|0){v=y+12|0;ra=f[v>>2]|0;f[v>>2]=ra+-1;if((ra|0)!=1)break;_S(j)}while(0);f[O>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[ea>>2]|0)>0){y=f[Y>>2]|0;ra=0;do{f[y+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[ea>>2]|0))}ra=f[ba>>2]|0;if((ra|0)!=(E|0))g0(ra);G=G+1|0;sa=f[i>>2]|0}while(G>>>0<(((f[H>>2]|0)-sa|0)/48|0)>>>0)}if(b[1152664]|0){f[e>>2]=0;f[e+4>>2]=0;sa=tT(e,5)|0;b[sa>>0]=b[378617]|0;b[sa+1>>0]=b[378618]|0;b[sa+2>>0]=b[378619]|0;b[sa+3>>0]=b[378620]|0;b[sa+4>>0]=b[378621]|0;z5(-215,e,378623,376410,2190)}}}FGa(w,h);sa=f[i>>2]|0;if(sa|0){H=i+4|0;while(1){G=f[H>>2]|0;if((G|0)==(sa|0))break;E=G+-48|0;f[H>>2]=E;GQ(E)}YDc(f[i>>2]|0)}H=f[h>>2]|0;if(H|0){sa=h+4|0;while(1){w=f[sa>>2]|0;if((w|0)==(H|0))break;E=w+-48|0;f[sa>>2]=E;GQ(E)}YDc(f[h>>2]|0)}sa=f[g>>2]|0;if(sa|0){H=g+4|0;while(1){E=f[H>>2]|0;if((E|0)==(sa|0))break;w=E+-48|0;f[H>>2]=w;GQ(w)}YDc(f[g>>2]|0)}Ha=p;Ia=q;break}}else if((A|0)!=(s|0)?(H=f[A+24>>2]|0,H|0):0){sa=f[A+20>>2]|0;f[e>>2]=sa;w=e+4|0;f[w>>2]=H;if(sa|0?(H=sa+4|0,f[H>>2]=(f[H>>2]|0)+1,(f[w>>2]|0)==0):0){f[g>>2]=0;f[g+4>>2]=0;ta=tT(g,13)|0;Ja=378645;ua=ta+13|0;do{b[ta>>0]=b[Ja>>0]|0;ta=ta+1|0;Ja=Ja+1|0}while((ta|0)<(ua|0));z5(-215,g,378623,376410,2270)}switch(f[r>>2]|0){case 1:{s=f[e>>2]|0;if(s|0?(w=s+4|0,H=f[w>>2]|0,f[w>>2]=H+-1,(H|0)==1):0)Yi[f[(f[s>>2]|0)+8>>2]&2047](s);Ha=p;Ia=q;break a;break}case 2:{wmb(e);break}default:{f[g>>2]=0;f[g+4>>2]=0;ta=tT(g,26)|0;Ja=378659;ua=ta+26|0;do{b[ta>>0]=b[Ja>>0]|0;ta=ta+1|0;Ja=Ja+1|0}while((ta|0)<(ua|0));z5(-213,g,378623,376410,2281)}}}r=c+120|0;s=f[r>>2]|0;H=(f[c+124>>2]|0)-s|0;w=H>>3;c:do if((H|0)>0){sa=0;E=s;while(1){G=f[E+(sa<<3)+4>>2]|0;if(G|0)Yi[f[(f[G>>2]|0)+8>>2]&2047](G);G=sa+1|0;if((G|0)>=(w|0))break c;sa=G;E=f[r>>2]|0}}while(0);r=c+164|0;w=c+168|0;s=f[w>>2]|0;H=f[r>>2]|0;E=s-H>>2;f[g>>2]=0;sa=g+4|0;f[sa>>2]=0;f[g+8>>2]=0;if(!E){Ka=H;La=0;Ma=s}else{if(E>>>0>76695844)mCc(g);s=E*56|0;H=VDc(s)|0;f[sa>>2]=H;f[g>>2]=H;f[g+8>>2]=H+(E*56|0);G=H+s|0;s=E;E=H;while(1){f[E>>2]=1124007936;ba=E+8|0;ea=E+40|0;ta=E+4|0;ua=ta+36|0;do{f[ta>>2]=0;ta=ta+4|0}while((ta|0)<(ua|0));f[ea>>2]=ba;Y=E+48|0;f[E+44>>2]=Y;f[Y>>2]=0;f[E+52>>2]=0;s=s+-1|0;if(!s)break;else E=E+56|0}f[sa>>2]=G;Ka=f[r>>2]|0;La=H;Ma=f[w>>2]|0}d:do if((Ma|0)!=(Ka|0)){E=0;s=Ma;Y=Ka;N=La;while(1){O=f[Y+(E<<2)>>2]|0;oa=N+(E*56|0)|0;if((oa|0)==(O|0)){Na=Y;Oa=s}else{D=O+36|0;S=f[D>>2]|0;if(S|0){R=S+12|0;f[R>>2]=(f[R>>2]|0)+1}R=N+(E*56|0)+36|0;S=f[R>>2]|0;if(S|0?(L=S+12|0,S=f[L>>2]|0,f[L>>2]=S+-1,(S|0)==1):0)_S(oa);f[R>>2]=0;S=N+(E*56|0)+16|0;L=N+(E*56|0)+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[L>>2]|0)>0){M=f[N+(E*56|0)+40>>2]|0;T=0;do{f[M+(T<<2)>>2]=0;T=T+1|0;Pa=f[L>>2]|0}while((T|0)<(Pa|0));f[oa>>2]=f[O>>2];if((Pa|0)<3)B=255;else B=257}else{f[oa>>2]=f[O>>2];B=255}if((B|0)==255){B=0;T=f[O+4>>2]|0;if((T|0)<3){f[L>>2]=T;f[N+(E*56|0)+8>>2]=f[O+8>>2];f[N+(E*56|0)+12>>2]=f[O+12>>2];T=f[O+44>>2]|0;M=f[N+(E*56|0)+44>>2]|0;f[M>>2]=f[T>>2];f[M+4>>2]=f[T+4>>2]}else B=257}if((B|0)==257){B=0;ZS(oa,O)}f[S>>2]=f[O+16>>2];f[N+(E*56|0)+20>>2]=f[O+20>>2];f[N+(E*56|0)+24>>2]=f[O+24>>2];f[N+(E*56|0)+28>>2]=f[O+28>>2];f[N+(E*56|0)+32>>2]=f[O+32>>2];f[R>>2]=f[D>>2];Na=f[r>>2]|0;Oa=f[w>>2]|0}T=E+1|0;if(T>>>0>=Oa-Na>>2>>>0)break d;E=T;s=Oa;Y=Na;N=f[g>>2]|0}}while(0);H=n;G=f[(f[n>>2]|0)+44>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=g;sa=c+152|0;N=h+8|0;f[N>>2]=0;f[N+4>>2]=0;f[h>>2]=33882112;f[h+4>>2]=sa;N=c+176|0;Y=i+8|0;f[Y>>2]=0;f[Y+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=N;ei[G&511](H,e,h,i);if(b[1152662]|0?(G=c+156|0,Y=f[sa>>2]|0,(f[G>>2]|0)!=(Y|0)):0){s=e+8|0;E=e+12|0;ba=e+4|0;ea=e+8|0;T=e+12|0;M=e+4|0;U=H+16|0;H=h+4|0;x=h+8|0;W=h+4|0;V=h+8|0;_=0;P=0;qa=Y;while(1){Y=qa+(_*56|0)|0;f[s>>2]=0;f[E>>2]=0;f[e>>2]=16842752;f[ba>>2]=Y;if(m3(e,1,0,-1797693134862315708145274.0e284,1797693134862315708145274.0e284)|0){f[ea>>2]=0;f[T>>2]=0;f[e>>2]=16842752;f[M>>2]=Y;if(m3(e,1,0,-1.0e6,1.0e6)|0)Qa=P;else{Y=H1(884536,378549,42)|0;ma=H1(suc(Y,f[c>>2]|0)|0,378516,6)|0;Y=f[U>>2]|0;da=(Y|0)==0?1154740:Y;Y=H1(ma,da,Mpc(da)|0)|0;cuc(e,Y+(f[(f[Y>>2]|0)+-12>>2]|0)|0);da=Hvc(e,885240)|0;ma=Mi[f[(f[da>>2]|0)+28>>2]&1023](da,10)|0;Ivc(e);wuc(Y,ma)|0;iuc(Y)|0;Y=H1(tuc(H1(884536,378523,10)|0,_)|0,378534,14)|0;ma=f[qa+(_*56|0)+4>>2]|0;da=f[qa+(_*56|0)+40>>2]|0;f[h>>2]=0;f[H>>2]=0;f[x>>2]=0;lFa(h,da,da+(ma<<2)|0);ma=DGa(Y,h)|0;cuc(e,Y+(f[(f[Y>>2]|0)+-12>>2]|0)|0);Y=Hvc(e,885240)|0;da=Mi[f[(f[Y>>2]|0)+28>>2]&1023](Y,10)|0;Ivc(e);wuc(ma,da)|0;iuc(ma)|0;ma=f[h>>2]|0;if(ma|0){da=f[H>>2]|0;if((da|0)!=(ma|0))f[H>>2]=da+(~((da+-4-ma|0)>>>2)<<2);YDc(ma)}Qa=1}}else{ma=H1(884536,378473,42)|0;da=H1(suc(ma,f[c>>2]|0)|0,378516,6)|0;ma=f[U>>2]|0;Y=(ma|0)==0?1154740:ma;ma=H1(da,Y,Mpc(Y)|0)|0;cuc(e,ma+(f[(f[ma>>2]|0)+-12>>2]|0)|0);Y=Hvc(e,885240)|0;da=Mi[f[(f[Y>>2]|0)+28>>2]&1023](Y,10)|0;Ivc(e);wuc(ma,da)|0;iuc(ma)|0;ma=H1(tuc(H1(884536,378523,10)|0,_)|0,378534,14)|0;da=f[qa+(_*56|0)+4>>2]|0;Y=f[qa+(_*56|0)+40>>2]|0;f[h>>2]=0;f[W>>2]=0;f[V>>2]=0;lFa(h,Y,Y+(da<<2)|0);da=DGa(ma,h)|0;cuc(e,ma+(f[(f[ma>>2]|0)+-12>>2]|0)|0);ma=Hvc(e,885240)|0;Y=Mi[f[(f[ma>>2]|0)+28>>2]&1023](ma,10)|0;Ivc(e);wuc(da,Y)|0;iuc(da)|0;da=f[h>>2]|0;if(da|0){Y=f[W>>2]|0;if((Y|0)!=(da|0))f[W>>2]=Y+(~((Y+-4-da|0)>>>2)<<2);YDc(da)}Qa=1}_=_+1|0;Ra=f[G>>2]|0;Sa=f[sa>>2]|0;qa=Sa;if(_>>>0>=((Ra-Sa|0)/56|0)>>>0)break;else P=Qa}if(Qa){P=f[r>>2]|0;if((f[w>>2]|0)==(P|0)){Ta=Ra;Ua=Sa;Va=qa}else{_=i+4|0;W=i+8|0;V=h+36|0;U=h+16|0;H=h+4|0;x=h+40|0;M=h+44|0;T=h+48|0;ea=0;ba=P;do{P=f[ba+(ea<<2)>>2]|0;E=tuc(H1(884368,378592,6)|0,ea)|0;if(P){s=H1(E,517879,1)|0;E1(h,f[P>>2]&4095);da=f[h>>2]|0;Y=(da|0)==0?1154740:da;da=H1(H1(s,Y,Mpc(Y)|0)|0,517879,1)|0;Y=f[P+4>>2]|0;s=f[P+40>>2]|0;f[i>>2]=0;f[_>>2]=0;f[W>>2]=0;lFa(i,s,s+(Y<<2)|0);Y=DGa(da,i)|0;cuc(e,da+(f[(f[da>>2]|0)+-12>>2]|0)|0);da=Hvc(e,885240)|0;s=Mi[f[(f[da>>2]|0)+28>>2]&1023](da,10)|0;Ivc(e);wuc(Y,s)|0;iuc(Y)|0;Y=f[i>>2]|0;if(Y|0){s=f[_>>2]|0;if((s|0)!=(Y|0))f[_>>2]=s+(~((s+-4-Y|0)>>>2)<<2);YDc(Y)}uT(h);if(b[1152663]|0){lT(h,P,1,1);P=EGa(884368,h)|0;cuc(e,884368+(f[(f[221092]|0)+-12>>2]|0)|0);Y=Hvc(e,885240)|0;s=Mi[f[(f[Y>>2]|0)+28>>2]&1023](Y,10)|0;Ivc(e);wuc(P,s)|0;iuc(P)|0;P=f[V>>2]|0;do if(P|0){s=P+12|0;Y=f[s>>2]|0;f[s>>2]=Y+-1;if((Y|0)!=1)break;_S(h)}while(0);f[V>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[H>>2]|0)>0){P=f[x>>2]|0;Y=0;do{f[P+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[H>>2]|0))}Y=f[M>>2]|0;if((Y|0)!=(T|0))g0(Y)}}else{Y=H1(E,378636,8)|0;cuc(e,Y+(f[(f[Y>>2]|0)+-12>>2]|0)|0);P=Hvc(e,885240)|0;s=Mi[f[(f[P>>2]|0)+28>>2]&1023](P,10)|0;Ivc(e);wuc(Y,s)|0;iuc(Y)|0}ea=ea+1|0;ba=f[r>>2]|0}while(ea>>>0<(f[w>>2]|0)-ba>>2>>>0);ba=f[sa>>2]|0;Ta=f[G>>2]|0;Ua=ba;Va=ba}if((Ta|0)!=(Ua|0)){ba=i+4|0;w=i+8|0;ea=h+36|0;r=h+16|0;T=h+4|0;M=h+40|0;H=h+44|0;x=h+48|0;U=0;V=Va;do{_=V+(U*56|0)|0;W=H1(tuc(H1(884368,378599,7)|0,U)|0,517879,1)|0;E1(h,f[_>>2]&4095);qa=f[h>>2]|0;Y=(qa|0)==0?1154740:qa;qa=H1(H1(W,Y,Mpc(Y)|0)|0,517879,1)|0;Y=f[V+(U*56|0)+4>>2]|0;W=f[V+(U*56|0)+40>>2]|0;f[i>>2]=0;f[ba>>2]=0;f[w>>2]=0;lFa(i,W,W+(Y<<2)|0);Y=DGa(qa,i)|0;cuc(e,qa+(f[(f[qa>>2]|0)+-12>>2]|0)|0);qa=Hvc(e,885240)|0;W=Mi[f[(f[qa>>2]|0)+28>>2]&1023](qa,10)|0;Ivc(e);wuc(Y,W)|0;iuc(Y)|0;Y=f[i>>2]|0;if(Y|0){W=f[ba>>2]|0;if((W|0)!=(Y|0))f[ba>>2]=W+(~((W+-4-Y|0)>>>2)<<2);YDc(Y)}uT(h);if(b[1152663]|0){lT(h,_,1,1);_=EGa(884368,h)|0;cuc(e,884368+(f[(f[221092]|0)+-12>>2]|0)|0);Y=Hvc(e,885240)|0;W=Mi[f[(f[Y>>2]|0)+28>>2]&1023](Y,10)|0;Ivc(e);wuc(_,W)|0;iuc(_)|0;_=f[ea>>2]|0;do if(_|0){W=_+12|0;Y=f[W>>2]|0;f[W>>2]=Y+-1;if((Y|0)!=1)break;_S(h)}while(0);f[ea>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[T>>2]|0)>0){_=f[M>>2]|0;E=0;do{f[_+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[T>>2]|0))}E=f[H>>2]|0;if((E|0)!=(x|0))g0(E)}U=U+1|0;V=f[sa>>2]|0}while(U>>>0<(((f[G>>2]|0)-V|0)/56|0)>>>0)}V=c+180|0;G=f[N>>2]|0;if((f[V>>2]|0)!=(G|0)){U=i+4|0;sa=i+8|0;x=h+36|0;H=h+16|0;T=h+4|0;M=h+40|0;r=h+44|0;ea=h+48|0;ba=0;w=G;do{G=w;E=G+(ba*56|0)|0;_=H1(tuc(H1(884368,378607,9)|0,ba)|0,517879,1)|0;E1(h,f[E>>2]&4095);Y=f[h>>2]|0;W=(Y|0)==0?1154740:Y;Y=H1(H1(_,W,Mpc(W)|0)|0,517879,1)|0;W=f[G+(ba*56|0)+4>>2]|0;_=f[G+(ba*56|0)+40>>2]|0;f[i>>2]=0;f[U>>2]=0;f[sa>>2]=0;lFa(i,_,_+(W<<2)|0);W=DGa(Y,i)|0;cuc(e,Y+(f[(f[Y>>2]|0)+-12>>2]|0)|0);Y=Hvc(e,885240)|0;_=Mi[f[(f[Y>>2]|0)+28>>2]&1023](Y,10)|0;Ivc(e);wuc(W,_)|0;iuc(W)|0;W=f[i>>2]|0;if(W|0){_=f[U>>2]|0;if((_|0)!=(W|0))f[U>>2]=_+(~((_+-4-W|0)>>>2)<<2);YDc(W)}uT(h);if(b[1152663]|0){lT(h,E,1,1);E=EGa(884368,h)|0;cuc(e,884368+(f[(f[221092]|0)+-12>>2]|0)|0);W=Hvc(e,885240)|0;_=Mi[f[(f[W>>2]|0)+28>>2]&1023](W,10)|0;Ivc(e);wuc(E,_)|0;iuc(E)|0;E=f[x>>2]|0;do if(E|0){_=E+12|0;W=f[_>>2]|0;f[_>>2]=W+-1;if((W|0)!=1)break;_S(h)}while(0);f[x>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[T>>2]|0)>0){E=f[M>>2]|0;W=0;do{f[E+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[T>>2]|0))}W=f[r>>2]|0;if((W|0)!=(ea|0))g0(W)}ba=ba+1|0;w=f[N>>2]|0}while(ba>>>0<(((f[V>>2]|0)-w|0)/56|0)>>>0)}if(b[1152664]|0){f[e>>2]=0;f[e+4>>2]=0;w=tT(e,5)|0;b[w>>0]=b[378617]|0;b[w+1>>0]=b[378618]|0;b[w+2>>0]=b[378619]|0;b[w+3>>0]=b[378620]|0;b[w+4>>0]=b[378621]|0;z5(-215,e,378623,376410,2256)}}}w=c+108|0;V=f[w>>2]|0;ba=(f[c+112>>2]|0)-V|0;N=ba>>3;e:do if((ba|0)>0){ea=0;r=V;while(1){T=f[r+(ea<<3)+4>>2]|0;if(T|0)Yi[f[(f[T>>2]|0)+12>>2]&2047](T);T=ea+1|0;if((T|0)>=(N|0))break e;ea=T;r=f[w>>2]|0}}while(0);mx(g);Ha=p;Ia=q}else{Ha=0;Ia=0}while(0);q=h6()|0;p=(Ha|0)==0&(Ia|0)==0;g=TIc(q|0,J|0,Ha|0,Ia|0)|0;Ia=(f[a+120>>2]|0)+(f[c>>2]<<3)|0;f[Ia>>2]=p?0:g;f[Ia+4>>2]=p?0:J;f[c+204>>2]=1;c=m;if(o){u=d;return}o=c+4|0;p=f[o>>2]|0;f[o>>2]=p+-1;if((p|0)!=1){u=d;return}Yi[f[(f[m>>2]|0)+8>>2]&2047](c);u=d;return}function CGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=(f[c+4>>2]|0)-(f[c>>2]|0)|0;h=g>>3;GGa(a,h);if((g|0)<=0){u=d;return}g=e+8|0;i=e+4|0;j=0;while(1){k=f[c>>2]|0;l=f[k+(j<<3)+4>>2]|0;if(!l)m=0;else m=bFc(l,14120,14176,0)|0;l=f[k+(j<<3)>>2]|0;k=(l|0)==0;if(!k){n=l+4|0;f[n>>2]=(f[n>>2]|0)+1}if(!m){o=8;break}n=m+64|0;if(!(b[n>>0]|0))p=m+12|0;else{q=f[m+60>>2]|0;r=m+12|0;s=g;f[s>>2]=0;f[s+4>>2]=0;f[e>>2]=34209792;f[i>>2]=r;h_(q,e);b[n>>0]=0;p=r}r=f[a>>2]|0;n=r+(j*48|0)|0;if((n|0)!=(p|0)){q=m+36|0;s=f[q>>2]|0;if(s|0){t=s+8|0;f[t>>2]=(f[t>>2]|0)+1}t=r+(j*48|0)+24|0;s=f[t>>2]|0;if(s|0?(v=s+8|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0)HQ(n);s=r+(j*48|0)+4|0;if((f[s>>2]|0)>0){v=f[r+(j*48|0)+32>>2]|0;w=0;do{f[v+(w<<2)>>2]=0;w=w+1|0;x=f[s>>2]|0}while((w|0)<(x|0));f[t>>2]=0;f[n>>2]=f[m+12>>2];if((x|0)<3)o=23;else o=25}else{f[t>>2]=0;f[n>>2]=f[m+12>>2];o=23}if((o|0)==23){o=0;w=f[m+16>>2]|0;if((w|0)<3){f[s>>2]=w;f[r+(j*48|0)+8>>2]=f[m+20>>2];f[r+(j*48|0)+12>>2]=f[m+24>>2];w=f[m+48>>2]|0;v=f[r+(j*48|0)+36>>2]|0;f[v>>2]=f[w>>2];f[v+4>>2]=f[w+4>>2]}else o=25}if((o|0)==25){o=0;FQ(n,p)}f[r+(j*48|0)+16>>2]=f[m+28>>2];w=r+(j*48|0)+20|0;if(!(f[w>>2]|0))f[w>>2]=f[m+32>>2];f[t>>2]=f[q>>2];f[r+(j*48|0)+28>>2]=f[m+40>>2]}w=l;if(!k?(v=w+4|0,y=f[v>>2]|0,f[v>>2]=y+-1,(y|0)==1):0)Yi[f[(f[l>>2]|0)+8>>2]&2047](w);j=j+1|0;if((j|0)>=(h|0)){o=33;break}}if((o|0)==8){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,20)|0;j=378725;m=h+20|0;do{b[h>>0]=b[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(m|0));z5(-215,e,378806,376410,287)}else if((o|0)==33){u=d;return}}function DGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+176|0;e=d+160|0;g=d+24|0;h=d+8|0;i=d;f[i>>2]=0;j=i+4|0;f[j>>2]=0;k=g+56|0;l=g+4|0;f[g>>2]=7676;f[k>>2]=7696;auc(g+56|0,l);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=46080;f[k>>2]=46100;fuc(l);f[l>>2]=45740;k=g+36|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G1(l,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);if(f[j>>2]|0){j=f[i>>2]|0;k=(j|0)==0?1154740:j;j=H1(g,k,Mpc(k)|0)|0;b[e>>0]=32;H1(j,e,1)|0}b[e>>0]=91;H1(g,e,1)|0;j=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;if(j|0){k=0;do{b[e>>0]=32;m=H1(g,e,1)|0;suc(m,f[(f[c>>2]|0)+(k<<2)>>2]|0)|0;k=k+1|0}while(k>>>0<j>>>0)}H1(g,378803,2)|0;I1(h,l);D3(g);g=h+11|0;l=b[g>>0]|0;j=l<<24>>24<0;H1(a,j?f[h>>2]|0:h,j?f[h+4>>2]|0:l&255)|0;if((b[g>>0]|0)>=0){uT(i);u=d;return a|0}YDc(f[h>>2]|0);uT(i);u=d;return a|0}function EGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c+8|0;e=c;p9(e,0);g=f[e+4>>2]|0;Ti[f[(f[g>>2]|0)+8>>2]&511](d,g,b);b=d+4|0;g=f[b>>2]|0;Yi[f[(f[g>>2]|0)+4>>2]&2047](g);g=f[b>>2]|0;h=_i[f[f[g>>2]>>2]&1023](g)|0;if(h|0){g=h;do{H1(a,g,Mpc(g)|0)|0;h=f[b>>2]|0;g=_i[f[f[h>>2]>>2]&1023](h)|0}while((g|0)!=0)}g=f[d>>2]|0;if(g|0?(h=g+4|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)Yi[f[(f[g>>2]|0)+8>>2]&2047](g);f[d>>2]=0;f[b>>2]=0;b=f[e>>2]|0;if(!b){u=c;return a|0}e=b+4|0;d=f[e>>2]|0;f[e>>2]=d+-1;if((d|0)!=1){u=c;return a|0}Yi[f[(f[b>>2]|0)+8>>2]&2047](b);u=c;return a|0}function FGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=(f[a+4>>2]|0)-g>>3;i=(f[c+4>>2]|0)-(f[c>>2]|0)|0;j=g;if((h|0)!=((i|0)/48|0|0)){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,31)|0;l=378686;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,378718,376410,298)}if((i|0)<=0){u=d;return}i=0;g=j;while(1){j=f[g+(i<<3)+4>>2]|0;if(!j)n=0;else n=bFc(j,14120,14176,0)|0;j=f[g+(i<<3)>>2]|0;o=(j|0)==0;if(!o){p=j+4|0;f[p>>2]=(f[p>>2]|0)+1}if(!n){q=11;break}p=f[c>>2]|0;r=p+(i*48|0)|0;s=n+12|0;if((s|0)!=(r|0)){t=p+(i*48|0)+24|0;v=f[t>>2]|0;if(v|0){w=v+8|0;f[w>>2]=(f[w>>2]|0)+1}w=n+36|0;v=f[w>>2]|0;if(v|0?(x=v+8|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0)HQ(s);v=n+16|0;if((f[v>>2]|0)>0){x=f[n+44>>2]|0;y=0;do{f[x+(y<<2)>>2]=0;y=y+1|0;z=f[v>>2]|0}while((y|0)<(z|0));f[w>>2]=0;f[s>>2]=f[r>>2];if((z|0)<3)q=23;else q=25}else{f[w>>2]=0;f[s>>2]=f[r>>2];q=23}if((q|0)==23){q=0;y=f[p+(i*48|0)+4>>2]|0;if((y|0)<3){f[v>>2]=y;f[n+20>>2]=f[p+(i*48|0)+8>>2];f[n+24>>2]=f[p+(i*48|0)+12>>2];y=f[p+(i*48|0)+36>>2]|0;x=f[n+48>>2]|0;f[x>>2]=f[y>>2];f[x+4>>2]=f[y+4>>2]}else q=25}if((q|0)==25){q=0;FQ(s,r)}f[n+28>>2]=f[p+(i*48|0)+16>>2];y=n+32|0;if(!(f[y>>2]|0))f[y>>2]=f[p+(i*48|0)+20>>2];f[w>>2]=f[t>>2];f[n+40>>2]=f[p+(i*48|0)+28>>2]}y=j;if(!o?(x=y+4|0,A=f[x>>2]|0,f[x>>2]=A+-1,(A|0)==1):0)Yi[f[(f[j>>2]|0)+8>>2]&2047](y);y=i+1|0;if((y|0)>=(h|0)){q=5;break}i=y;g=f[a>>2]|0}if((q|0)==5){u=d;return}else if((q|0)==11){f[e>>2]=0;f[e+4>>2]=0;k=tT(e,20)|0;l=378725;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,e,378718,376410,302)}}function GGa(a,b){a=a|0;b=b|0;var c=0,d=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>89478485)mCc(a);d=VDc(b*48|0)|0;f[c>>2]=d;f[a>>2]=d;f[a+8>>2]=d+(b*48|0);a=b;b=d;do{f[b>>2]=1124007936;d=b+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[b+32>>2]=b+8;d=b+40|0;f[b+36>>2]=d;f[b+44>>2]=0;f[d>>2]=0;b=(f[c>>2]|0)+48|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function HGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+20>>2]|0;d=a+24|0;if((c|0)!=(d|0)){e=c;while(1){if(f[e+20>>2]|0){c=f[e+184>>2]|0;g=e+188|0;h=f[g>>2]|0;if((h|0)!=(c|0))f[g>>2]=h+(~((h+-4-c|0)>>>2)<<2);c=f[e+172>>2]|0;h=e+176|0;g=f[h>>2]|0;if((g|0)!=(c|0)){i=g;do{g=i+-56|0;f[h>>2]=g;j=i+-20|0;k=f[j>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)_S(g);f[j>>2]=0;j=i+-40|0;g=i+-52|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[g>>2]|0)>0){j=f[i+-16>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i+-12>>2]|0;if((g|0)!=(i+-8|0))g0(g);i=f[h>>2]|0}while((i|0)!=(c|0))}c=f[e+196>>2]|0;i=e+200|0;h=f[i>>2]|0;if((h|0)!=(c|0)){g=h;do{h=g+-56|0;f[i>>2]=h;k=g+-20|0;j=f[k>>2]|0;if(j|0?(l=j+12|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)_S(h);f[k>>2]=0;k=g+-40|0;h=g+-52|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[h>>2]|0)>0){k=f[g+-16>>2]|0;j=0;do{f[k+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[g+-12>>2]|0;if((h|0)!=(g+-8|0))g0(h);g=f[i>>2]|0}while((g|0)!=(c|0))}}b[e+220>>0]=0;c=f[e+164>>2]|0;g=f[e+168>>2]|0;i=(c|0)==0;if(!i){h=c+4|0;f[h>>2]=(f[h>>2]|0)+1}if(!g){if(!i){m=c;n=36}}else{Yi[f[(f[g>>2]|0)+88>>2]&2047](g);h=bFc(g,14104,14224,0)|0;if(!i){g=c+4|0;f[g>>2]=(f[g>>2]|0)+1}if(h|0)b[h+81>>0]=1;h=c;if(!i){i=h+4|0;g=f[i>>2]|0;f[i>>2]=g+-1;if((g|0)==1){Yi[f[(f[c>>2]|0)+8>>2]&2047](h);m=h;n=36}else{m=h;n=36}}}if((n|0)==36?(n=0,h=m+4|0,g=f[h>>2]|0,f[h>>2]=g+-1,(g|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](m);c=f[e+4>>2]|0;if(!c){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))o=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;i=f[h>>2]|0}while((f[i>>2]|0)!=(g|0));o=i}}else{h=c;while(1){i=f[h>>2]|0;if(!i)break;else h=i}o=h}if((o|0)==(d|0))break;else e=o}}o=f[a+120>>2]|0;e=a+124|0;a=f[e>>2]|0;if((a|0)==(o|0))return;f[e>>2]=a+(~((a+-8-o|0)>>>3)<<3);return}function IGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=u;u=u+32|0;e=d+20|0;g=d+8|0;h=d;i=a+20|0;j=f[i>>2]|0;k=a+24|0;if((j|0)!=(k|0)){l=j;while(1){f[l+224>>2]=0;j=f[l+4>>2]|0;if(!j){m=l+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(l|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=j;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}if((o|0)==(k|0))break;else l=o}}f[e>>2]=0;o=AGa(i,e)|0;if((f[o+152>>2]|0)==(f[o+156>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;q=tT(e,30)|0;r=379811;s=q+30|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,e,379842,376410,2066)}f[e>>2]=0;o=e+4|0;f[o>>2]=0;f[e+8>>2]=0;l=a+80|0;j=a+84|0;p=g+4|0;m=g+8|0;t=e+8|0;v=0;while(1){f[g>>2]=0;w=AGa(i,g)|0;if(v>>>0>=(((f[w+156>>2]|0)-(f[w+152>>2]|0)|0)/56|0)>>>0){x=34;break}f[g>>2]=0;w=(AGa(i,g)|0)+152|0;y=f[w>>2]|0;w=y+(v*56|0)+4|0;z=f[w>>2]|0;if((z|0)<3)A=Y(f[y+(v*56|0)+12>>2]|0,f[y+(v*56|0)+8>>2]|0)|0;else{B=f[y+(v*56|0)+40>>2]|0;C=0;D=1;while(1){E=Y(f[B+(C<<2)>>2]|0,D)|0;C=C+1|0;if((C|0)==(z|0)){A=E;break}else D=E}}if(!A){x=17;break}if((f[l>>2]|0)==3?(f[j>>2]|0)==2:0){f[g>>2]=0;D=(AGa(i,g)|0)+152|0;XS((f[D>>2]|0)+(v*56|0)|0,f[w>>2]|0,f[y+(v*56|0)+40>>2]|0,3);F=f[w>>2]|0}else F=z;D=f[y+(v*56|0)+40>>2]|0;f[g>>2]=0;f[p>>2]=0;f[m>>2]=0;lFa(g,D,D+(F<<2)|0);G=f[o>>2]|0;if((G|0)==(f[t>>2]|0)){OGa(e,g);H=f[g>>2]|0}else{f[G>>2]=0;D=G+4|0;f[D>>2]=0;f[G+8>>2]=0;C=f[g>>2]|0;B=(f[p>>2]|0)-C|0;n=B>>2;if(n){if(n>>>0>1073741823){x=24;break}E=VDc(B)|0;f[D>>2]=E;f[G>>2]=E;f[G+8>>2]=E+(n<<2);n=f[g>>2]|0;B=(f[p>>2]|0)-n|0;if((B|0)>0){dJc(E|0,n|0,B|0)|0;f[D>>2]=E+(B>>>2<<2);I=f[o>>2]|0;J=n}else{I=G;J=n}}else{I=G;J=C}f[o>>2]=I+12;H=J}if(H|0){C=f[p>>2]|0;if((C|0)!=(H|0))f[p>>2]=C+(~((C+-4-H|0)>>>2)<<2);YDc(H)}v=v+1|0}if((x|0)==17){f[g>>2]=0;f[g+4>>2]=0;q=tT(g,11)|0;r=379857;s=q+11|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z5(-215,g,379842,376410,2071)}else if((x|0)==24)mCc(G);else if((x|0)==34){f[g+4>>2]=0;f[g+8>>2]=0;G=g+4|0;f[g>>2]=G;PGa(a,e,g);r=a+44|0;q=a+48|0;BFa(r,f[q>>2]|0);s=a+52|0;f[s>>2]=0;f[r>>2]=q;f[q>>2]=0;v=a+56|0;H=a+60|0;AFa(v,f[H>>2]|0);f[a+64>>2]=0;f[v>>2]=H;f[H>>2]=0;H=a+68|0;v=a+72|0;zFa(H,f[v>>2]|0);f[a+76>>2]=0;f[H>>2]=v;f[v>>2]=0;v=a+100|0;H=a+104|0;yFa(v,f[H>>2]|0);f[a+108>>2]=0;f[v>>2]=H;f[H>>2]=0;H=a+48|0;v=0;while(1){f[h>>2]=0;p=AGa(i,h)|0;if(v>>>0>=(((f[p+156>>2]|0)-(f[p+152>>2]|0)|0)/56|0)>>>0)break;p=f[q>>2]|0;J=(p|0)==0;a:do if(!J){I=q;t=p;b:while(1){F=t;while(1){m=f[F+16>>2]|0;if((m|0)>=0){if(m|0)break;if((f[F+20>>2]|0)>=(v|0))break}m=f[F+4>>2]|0;if(!m){K=I;break b}else F=m}t=f[F>>2]|0;if(!t){K=F;break}else I=F}do if((K|0)!=(q|0)?(I=f[K+16>>2]|0,(I|0)<=0):0){if((I|0)==0?(v|0)<(f[K+20>>2]|0):0)break;I=K+24|0;f[I>>2]=(f[I>>2]|0)+1;break a}while(0);if(!J){I=H;t=p;m=p;c:while(1){j=f[t+16>>2]|0;do if((j|0)<=0){if(!j){l=f[t+20>>2]|0;if((v|0)<(l|0)){x=55;break}if((l|0)>=(v|0)){x=60;break c}}L=t+4|0;l=f[L>>2]|0;if(!l){x=59;break c}else{M=L;N=l}}else x=55;while(0);if((x|0)==55){x=0;j=f[t>>2]|0;if(!j){x=56;break}else{M=t;N=j}}I=M;t=N;m=N}if((x|0)==56){x=0;O=t;P=t;x=62;break}else if((x|0)==59){x=0;O=L;P=t;x=62;break}else if((x|0)==60){x=0;Q=I;R=t;S=m;x=61;break}}else{Q=q;R=q;S=p;x=61}}else{Q=q;R=q;S=p;x=61}while(0);if((x|0)==61){x=0;if(!S){O=Q;P=R;x=62}else{T=S;x=65}}if((x|0)==62){x=0;p=VDc(28)|0;J=p+16|0;f[J>>2]=0;f[J+4>>2]=v;f[p+24>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=P;f[O>>2]=p;J=f[f[r>>2]>>2]|0;if(!J)U=p;else{f[r>>2]=J;U=f[O>>2]|0}laa(f[H>>2]|0,U);f[s>>2]=(f[s>>2]|0)+1;T=p;x=65}if((x|0)==65){x=0;f[T+24>>2]=1}v=v+1|0}v=f[i>>2]|0;if((v|0)!=(k|0)){T=v;while(1){v=T+80|0;s=T+84|0;U=f[s>>2]|0;H=f[v>>2]|0;if((U|0)!=(H|0)){O=0;P=H;H=U;while(1){U=P;S=U+(O<<3)|0;R=f[q>>2]|0;do if(R){Q=f[S>>2]|0;L=f[U+(O<<3)+4>>2]|0;N=q;M=R;d:while(1){K=M;while(1){p=f[K+16>>2]|0;if((p|0)>=(Q|0)){if((p|0)!=(Q|0))break;if((f[K+20>>2]|0)>=(L|0))break}p=f[K+4>>2]|0;if(!p){V=N;break d}else K=p}M=f[K>>2]|0;if(!M){V=K;break}else N=K}if((V|0)!=(q|0)?(N=f[V+16>>2]|0,(Q|0)>=(N|0)):0){if((Q|0)==(N|0)?(L|0)<(f[V+20>>2]|0):0){x=83;break}N=V+24|0;f[N>>2]=(f[N>>2]|0)+1;W=P;X=H}else x=83}else x=83;while(0);if((x|0)==83){x=0;R=QGa(r,S)|0;f[R>>2]=1;W=f[v>>2]|0;X=f[s>>2]|0}O=O+1|0;if(O>>>0>=X-W>>3>>>0)break;else{P=W;H=X}}}H=f[T+4>>2]|0;if(!H){P=T+8|0;O=f[P>>2]|0;if((f[O>>2]|0)==(T|0))Z=O;else{O=P;do{P=f[O>>2]|0;O=P+8|0;s=f[O>>2]|0}while((f[s>>2]|0)!=(P|0));Z=s}}else{O=H;while(1){s=f[O>>2]|0;if(!s)break;else O=s}Z=O}if((Z|0)==(k|0))break;else T=Z}}Z=c+4|0;T=f[Z>>2]|0;X=f[c>>2]|0;if((T|0)!=(X|0)){W=0;V=X;X=T;while(1){T=V;H=T+(W<<3)|0;s=f[q>>2]|0;do if(s){P=f[H>>2]|0;v=f[T+(W<<3)+4>>2]|0;R=q;U=s;e:while(1){m=U;while(1){t=f[m+16>>2]|0;if((t|0)>=(P|0)){if((t|0)!=(P|0))break;if((f[m+20>>2]|0)>=(v|0))break}t=f[m+4>>2]|0;if(!t){_=R;break e}else m=t}U=f[m>>2]|0;if(!U){_=m;break}else R=m}if((_|0)!=(q|0)?(R=f[_+16>>2]|0,(P|0)>=(R|0)):0){if((P|0)==(R|0)?(v|0)<(f[_+20>>2]|0):0){x=105;break}R=_+24|0;f[R>>2]=(f[R>>2]|0)+1;$=V;aa=X}else x=105}else x=105;while(0);if((x|0)==105){x=0;s=QGa(r,H)|0;f[s>>2]=1;$=f[c>>2]|0;aa=f[Z>>2]|0}W=W+1|0;if(W>>>0>=aa-$>>3>>>0)break;else{V=$;X=aa}}}aa=f[i>>2]|0;if((aa|0)!=(k|0)){i=aa;while(1){RGa(a,f[i+16>>2]|0,g);aa=f[i+4>>2]|0;if(!aa){X=i+8|0;$=f[X>>2]|0;if((f[$>>2]|0)==(i|0))ba=$;else{$=X;do{X=f[$>>2]|0;$=X+8|0;V=f[$>>2]|0}while((f[V>>2]|0)!=(X|0));ba=V}}else{$=aa;while(1){H=f[$>>2]|0;if(!H)break;else $=H}ba=$}if((ba|0)==(k|0))break;else i=ba}}ba=a+120|0;i=(f[a+112>>2]|0)+1|0;k=h;f[k>>2]=0;f[k+4>>2]=0;k=a+124|0;aa=f[k>>2]|0;H=f[ba>>2]|0;V=aa-H>>3;X=H;H=aa;if(i>>>0<=V>>>0){if(i>>>0<V>>>0?(aa=X+(i<<3)|0,(H|0)!=(aa|0)):0)f[k>>2]=H+(~((H+-8-aa|0)>>>3)<<3)}else SGa(ba,i-V|0,h);TGa(a,c);UGa(g,f[G>>2]|0);G=f[e>>2]|0;if(!G){u=d;return}g=f[o>>2]|0;if((g|0)==(G|0))ca=G;else{c=g;while(1){g=c+-12|0;f[o>>2]=g;a=f[g>>2]|0;if(!a)da=g;else{g=c+-8|0;h=f[g>>2]|0;if((h|0)!=(a|0))f[g>>2]=h+(~((h+-4-a|0)>>>2)<<2);YDc(a);da=f[o>>2]|0}if((da|0)==(G|0))break;else c=da}ca=f[e>>2]|0}YDc(ca);u=d;return}}function JGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;switch(f[a+80>>2]|0){case 3:{if((f[a+84>>2]|0)>>>0<3){u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;e=tT(d,76)|0;g=379533;h=e+76|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));z5(-215,d,379610,376410,1258)}break}case 1:{LGa(a);u=c;return}case 2:{MGa(a);u=c;return}default:{f[d>>2]=0;f[d+4>>2]=0;e=tT(d,26)|0;g=378659;h=e+26|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));z5(-213,d,379610,376410,1264)}}}function KGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>3;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>3>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>3;o=h>>>0>n>>>0;p=o?b+(n<<3)|0:c;c=p;n=c-e|0;e=n>>3;if(e|0)fJc(k|0,b|0,n|0)|0;n=l+(e<<3)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>3<<3);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-8-k|0)>>>3)<<3);YDc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>536870911)mCc(a);j=q>>2;n=q>>3>>>0<268435455?(j>>>0<h>>>0?h:j):536870911;if(n>>>0>536870911)mCc(a);j=VDc(n<<3)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<3);if((g|0)<=0)return;dJc(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>3<<3);return}function LGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;c=u;u=u+16|0;d=c+8|0;e=c;g=a+80|0;if((f[g>>2]|0)!=1){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,39)|0;i=379693;j=h+39|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-215,d,379733,376410,1270)}if(!(sMa()|0)){f[d>>2]=0;f[d+4>>2]=0;h=tT(d,12)|0;i=379751;j=h+12|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-215,d,379733,376410,1270)}k=a+20|0;l=f[k>>2]|0;m=l;f[d>>2]=m;n=a+24|0;if((m|0)==(n|0)){u=c;return}a=e+4|0;o=e+4|0;p=l;l=m;while(1){m=p;q=f[m+164>>2]|0;r=f[m+168>>2]|0;s=(q|0)==0;if(!s){t=q+4|0;f[t>>2]=(f[t>>2]|0)+1}if(Mi[f[(f[r>>2]|0)+56>>2]&1023](r,f[g>>2]|0)|0){t=f[d>>2]|0;v=f[t+164>>2]|0;w=f[t+168>>2]|0;x=(v|0)==0;if(!x){y=v+4|0;f[y>>2]=(f[y>>2]|0)+1}if(((((l|0)!=(f[k>>2]|0)?Mi[f[(f[w>>2]|0)+56>>2]&1023](w,f[g>>2]|0)|0:0)?(w=f[m+184>>2]|0,y=w,((f[m+188>>2]|0)-w|0)==4):0)?(w=f[t+172>>2]|0,((f[t+176>>2]|0)-w|0)==56):0)?(f[(f[y>>2]|0)+16>>2]|0)==(f[w+16>>2]|0):0){w=t+208|0;y=t+212|0;z=f[y>>2]|0;do if(z){A=f[g>>2]|0;B=t+212|0;C=z;D=z;while(1){E=f[C+16>>2]|0;if((A|0)<(E|0)){F=f[C>>2]|0;if(!F){G=23;break}else{H=C;I=F}}else{if((E|0)>=(A|0)){G=27;break}J=C+4|0;E=f[J>>2]|0;if(!E){G=26;break}else{H=J;I=E}}B=H;C=I;D=I}if((G|0)==23){G=0;K=C;L=C;G=30;break}else if((G|0)==26){G=0;K=J;L=C;G=30;break}else if((G|0)==27){G=0;M=B;N=C;O=D;G=29;break}}else{M=y;N=y;O=z;G=29}while(0);if((G|0)==29){G=0;if(!O){K=M;L=N;G=30}else P=O}if((G|0)==30){G=0;z=VDc(28)|0;f[z+16>>2]=f[g>>2];f[z+20>>2]=0;f[z+24>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=L;f[K>>2]=z;A=f[f[w>>2]>>2]|0;if(!A)Q=z;else{f[w>>2]=A;Q=f[K>>2]|0}laa(f[t+212>>2]|0,Q);A=t+216|0;f[A>>2]=(f[A>>2]|0)+1;P=z}if(!(f[P+24>>2]|0)){G=34;break}z=f[(f[r>>2]|0)+72>>2]|0;A=f[y>>2]|0;do if(A){E=f[g>>2]|0;F=t+212|0;R=A;S=A;while(1){T=f[R+16>>2]|0;if((E|0)<(T|0)){U=f[R>>2]|0;if(!U){G=40;break}else{V=R;W=U}}else{if((T|0)>=(E|0)){G=44;break}X=R+4|0;T=f[X>>2]|0;if(!T){G=43;break}else{V=X;W=T}}F=V;R=W;S=W}if((G|0)==40){G=0;Y=R;Z=R;G=47;break}else if((G|0)==43){G=0;Y=X;Z=R;G=47;break}else if((G|0)==44){G=0;_=F;$=R;aa=S;G=46;break}}else{_=y;$=y;aa=A;G=46}while(0);if((G|0)==46){G=0;if(!aa){Y=_;Z=$;G=47}else ba=aa}if((G|0)==47){G=0;A=VDc(28)|0;f[A+16>>2]=f[g>>2];f[A+20>>2]=0;f[A+24>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Z;f[Y>>2]=A;E=f[f[w>>2]>>2]|0;if(!E)ca=A;else{f[w>>2]=E;ca=f[Y>>2]|0}laa(f[t+212>>2]|0,ca);E=t+216|0;f[E>>2]=(f[E>>2]|0)+1;ba=A}Ti[z&511](e,r,ba+20|0);A=f[o>>2]|0;E=A;do if(!A)da=0;else{b[m+220>>0]=1;D=f[y>>2]|0;do if(D){C=f[g>>2]|0;B=t+212|0;T=D;U=D;while(1){ea=f[T+16>>2]|0;if((C|0)<(ea|0)){fa=f[T>>2]|0;if(!fa){G=56;break}else{ga=T;ha=fa}}else{if((ea|0)>=(C|0)){G=60;break}ia=T+4|0;ea=f[ia>>2]|0;if(!ea){G=59;break}else{ga=ia;ha=ea}}B=ga;T=ha;U=ha}if((G|0)==56){G=0;ja=T;ka=T;G=63;break}else if((G|0)==59){G=0;ja=ia;ka=T;G=63;break}else if((G|0)==60){G=0;la=B;ma=T;na=U;G=62;break}}else{la=y;ma=y;na=D;G=62}while(0);if((G|0)==62){G=0;if(!na){ja=la;ka=ma;G=63}else{oa=na;pa=E}}if((G|0)==63){G=0;D=VDc(28)|0;f[D+16>>2]=f[g>>2];f[D+20>>2]=0;f[D+24>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=ka;f[ja>>2]=D;S=f[f[w>>2]>>2]|0;if(!S)qa=D;else{f[w>>2]=S;qa=f[ja>>2]|0}laa(f[t+212>>2]|0,qa);S=t+216|0;f[S>>2]=(f[S>>2]|0)+1;oa=D;pa=f[o>>2]|0}D=oa+20|0;S=f[e>>2]|0;if(S|0){R=S+4|0;f[R>>2]=(f[R>>2]|0)+1}R=f[D>>2]|0;f[D>>2]=S;f[oa+24>>2]=pa;do if(R|0){S=R+4|0;D=f[S>>2]|0;f[S>>2]=D+-1;if((D|0)!=1)break;Yi[f[(f[R>>2]|0)+8>>2]&2047](R)}while(0);if((t|0)==(m|0)){da=10;break}NGa(t+128|0,f[m+128>>2]|0,f[m+132>>2]|0);da=10}while(0);t=f[e>>2]|0;do if(t|0){w=t+4|0;E=f[w>>2]|0;f[w>>2]=E+-1;if((E|0)!=1)break;Yi[f[(f[t>>2]|0)+8>>2]&2047](t)}while(0);if(!da)G=77}else G=77;if((G|0)==77){G=0;b[m+220>>0]=0;Ti[f[(f[r>>2]|0)+60>>2]&511](e,r,m+140|0);t=m+208|0;E=m+212|0;w=f[E>>2]|0;do if(w){y=m+212|0;A=w;z=w;while(1){R=f[A+16>>2]|0;if((R|0)>1){D=f[A>>2]|0;if(!D){G=82;break}else{ra=A;sa=D}}else{if((R|0)==1){G=86;break}ta=A+4|0;R=f[ta>>2]|0;if(!R){G=85;break}else{ra=ta;sa=R}}y=ra;A=sa;z=sa}if((G|0)==82){G=0;ua=A;va=A;G=89;break}else if((G|0)==85){G=0;ua=ta;va=A;G=89;break}else if((G|0)==86){G=0;wa=y;xa=A;ya=z;G=88;break}}else{wa=E;xa=E;ya=w;G=88}while(0);if((G|0)==88){G=0;if(!ya){ua=wa;va=xa;G=89}else za=ya}if((G|0)==89){G=0;w=VDc(28)|0;f[w+16>>2]=1;f[w+20>>2]=0;f[w+24>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=va;f[ua>>2]=w;E=f[f[t>>2]>>2]|0;if(!E)Aa=w;else{f[t>>2]=E;Aa=f[ua>>2]|0}laa(f[m+212>>2]|0,Aa);E=m+216|0;f[E>>2]=(f[E>>2]|0)+1;za=w}w=za+20|0;E=f[e>>2]|0;r=f[a>>2]|0;if(E|0){R=E+4|0;f[R>>2]=(f[R>>2]|0)+1}R=f[w>>2]|0;f[w>>2]=E;f[za+24>>2]=r;if(R|0?(r=R+4|0,E=f[r>>2]|0,f[r>>2]=E+-1,(E|0)==1):0)Yi[f[(f[R>>2]|0)+8>>2]&2047](R);R=f[e>>2]|0;if(R|0?(E=R+4|0,r=f[E>>2]|0,f[E>>2]=r+-1,(r|0)==1):0)Yi[f[(f[R>>2]|0)+8>>2]&2047](R);f[d>>2]=p}R=v;if(!x?(r=R+4|0,E=f[r>>2]|0,f[r>>2]=E+-1,(E|0)==1):0)Yi[f[(f[v>>2]|0)+8>>2]&2047](R)}else f[d>>2]=p;R=q;if(!s?(E=R+4|0,r=f[E>>2]|0,f[E>>2]=r+-1,(r|0)==1):0)Yi[f[(f[q>>2]|0)+8>>2]&2047](R);R=f[l+4>>2]|0;if(!R){r=l+8|0;E=f[r>>2]|0;if((f[E>>2]|0)==(p|0))Ba=E;else{E=r;do{r=f[E>>2]|0;E=r+8|0;w=f[E>>2]|0}while((f[w>>2]|0)!=(r|0));Ba=w}}else{E=R;while(1){q=f[E>>2]|0;if(!q)break;else E=q}Ba=E}if((Ba|0)==(n|0)){G=113;break}else{p=Ba;l=Ba}}if((G|0)==34){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,46)|0;i=379764;j=h+46|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-215,e,379733,376410,1302)}else if((G|0)==113){u=c;return}}function MGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if((f[a+80>>2]|0)!=2){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,49)|0;g=379622;h=e+49|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));z5(-215,d,379672,376410,1363)}if(vmb()|0){u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;e=tT(d,15)|0;g=425433;h=e+15|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));z5(-215,d,379672,376410,1363)}}function NGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=c-b>>3;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>g-h>>3>>>0){if(!h)j=g;else{g=a+4|0;k=f[g>>2]|0;if((k|0)==(i|0))l=h;else{m=k;do{k=m+-8|0;f[g>>2]=k;n=f[k>>2]|0;if(n|0?(o=n+4|0,p=f[o>>2]|0,f[o>>2]=p+-1,(p|0)==1):0)Yi[f[(f[n>>2]|0)+8>>2]&2047](n);f[k>>2]=0;f[m+-4>>2]=0;m=f[g>>2]|0}while((m|0)!=(i|0));l=f[a>>2]|0}YDc(l);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>536870911)mCc(a);g=j>>2;l=j>>3>>>0<268435455?(g>>>0<d>>>0?d:g):536870911;if(l>>>0>536870911)mCc(a);g=VDc(l<<3)|0;j=a+4|0;f[j>>2]=g;f[a>>2]=g;f[e>>2]=g+(l<<3);if((b|0)==(c|0))return;l=b;e=g;do{g=f[l>>2]|0;f[e>>2]=g;f[e+4>>2]=f[l+4>>2];if(g|0){m=g+4|0;f[m>>2]=(f[m>>2]|0)+1}l=l+8|0;e=(f[j>>2]|0)+8|0;f[j>>2]=e}while((l|0)!=(c|0));return}l=a+4|0;a=(f[l>>2]|0)-h>>3;h=d>>>0>a>>>0;d=b+(a<<3)|0;a=h?d:c;if((a|0)==(b|0))q=i;else{e=b;b=i;while(1){i=f[e>>2]|0;j=f[e+4>>2]|0;if(i|0){m=i+4|0;f[m>>2]=(f[m>>2]|0)+1}m=f[b>>2]|0;f[b>>2]=i;f[b+4>>2]=j;if(m|0?(j=m+4|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)Yi[f[(f[m>>2]|0)+8>>2]&2047](m);e=e+8|0;m=b+8|0;if((e|0)==(a|0)){q=m;break}else b=m}}if(h){if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{h=f[a>>2]|0;f[d>>2]=h;f[d+4>>2]=f[a+4>>2];if(h|0){b=h+4|0;f[b>>2]=(f[b>>2]|0)+1}a=a+8|0;d=(f[l>>2]|0)+8|0;f[l>>2]=d}while((a|0)!=(c|0));return}else{c=f[l>>2]|0;if((c|0)==(q|0))return;else r=c;do{c=r+-8|0;f[l>>2]=c;a=f[c>>2]|0;if(a|0?(d=a+4|0,b=f[d>>2]|0,f[d>>2]=b+-1,(b|0)==1):0)Yi[f[(f[a>>2]|0)+8>>2]&2047](a);f[c>>2]=0;f[r+-4>>2]=0;r=f[l>>2]|0}while((r|0)!=(q|0));return}}function OGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)mCc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{k=VDc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;jFa(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-12|0;jFa(e+-12|0,i);e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-4-b|0)>>>2)<<2);YDc(b)}}while((h|0)!=(g|0))}if(!m)return;YDc(m);return}function PGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=d+4|0;UGa(d,f[e>>2]|0);g=d+8|0;f[g>>2]=0;f[d>>2]=e;f[e>>2]=0;h=VDc(60)|0;i=h+16|0;j=h+20|0;f[h>>2]=0;f[h+4>>2]=0;k=h+8|0;l=i;m=l+40|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));b[i+40>>0]=0;f[k>>2]=e;f[e>>2]=h;f[d>>2]=h;laa(h,h);f[g>>2]=(f[g>>2]|0)+1;if((j|0)!=(c|0))vHa(j,f[c>>2]|0,f[c+4>>2]|0);c=f[a+20>>2]|0;j=a+24|0;if((c|0)==(j|0))return;else n=c;while(1){wHa(a,f[n+16>>2]|0,d);c=f[n+4>>2]|0;if(!c){g=n+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(n|0))o=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;e=f[h>>2]|0}while((f[e>>2]|0)!=(g|0));o=e}}else{h=c;while(1){e=f[h>>2]|0;if(!e)break;else h=e}o=h}if((o|0)==(j|0))break;else n=o}return}function QGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;j=d;a:while(1){k=f[i+16>>2]|0;do if((e|0)>=(k|0)){l=(e|0)==(k|0);if(l?(g|0)<(f[i+20>>2]|0):0){m=7;break}if((k|0)>=(e|0)){if(!l){m=14;break a}if((f[i+20>>2]|0)>=(g|0)){m=14;break a}}n=i+4|0;l=f[n>>2]|0;if(!l){m=13;break a}else{o=n;p=l}}else m=7;while(0);if((m|0)==7){m=0;k=f[i>>2]|0;if(!k){m=8;break}else{o=i;p=k}}h=o;i=p;j=p}if((m|0)==8){q=i;r=i;break}else if((m|0)==13){q=n;r=i;break}else if((m|0)==14){s=h;t=i;u=j;m=16;break}}else{s=c;t=c;u=d;m=16}while(0);if((m|0)==16)if(!u){q=s;r=t}else{v=u;w=v+24|0;return w|0}u=VDc(28)|0;t=b;b=f[t+4>>2]|0;s=u+16|0;f[s>>2]=f[t>>2];f[s+4>>2]=b;f[u+24>>2]=0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=r;f[q>>2]=u;r=f[f[a>>2]>>2]|0;if(!r)x=u;else{f[a>>2]=r;x=f[q>>2]|0}laa(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;v=u;w=v+24|0;return w|0}function RGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0;e=u;u=u+160|0;g=e;h=e+144|0;i=e+128|0;j=e+116|0;k=e+104|0;l=e+96|0;m=e+92|0;n=e+88|0;o=e+32|0;p=e+100|0;q=e+16|0;f[p>>2]=c;c=a+20|0;r=AGa(c,p)|0;s=r+204|0;if(f[s>>2]|0){u=e;return}t=r+60|0;v=r+64|0;w=f[t>>2]|0;x=(f[v>>2]|0)-w>>3;y=(x|0)==0;a:do if(y)z=r+76|0;else{A=r+72|0;B=r+76|0;C=r+76|0;D=r+80|0;E=0;F=w;while(1){G=F+(E<<3)|0;H=f[B>>2]|0;do if(H){I=f[G>>2]|0;J=C;K=H;while(1){L=f[K+16>>2]|0;if((I|0)<(L|0)){M=f[K>>2]|0;if(!M){N=11;break}else{O=K;P=M}}else{if((L|0)>=(I|0)){N=15;break}Q=K+4|0;L=f[Q>>2]|0;if(!L){N=14;break}else{O=Q;P=L}}J=O;K=P}if((N|0)==11){N=0;R=K;S=K;break}else if((N|0)==14){N=0;R=Q;S=K;break}else if((N|0)==15){N=0;R=J;S=K;break}}else{R=B;S=B}while(0);if(!(f[R>>2]|0)){H=VDc(20)|0;f[H+16>>2]=f[G>>2];f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=S;f[R>>2]=H;I=f[f[A>>2]>>2]|0;if(!I)T=H;else{f[A>>2]=I;T=f[R>>2]|0}laa(f[C>>2]|0,T);f[D>>2]=(f[D>>2]|0)+1}I=E+1|0;if((I|0)==(x|0)){z=B;break a}E=I;F=f[t>>2]|0}}while(0);T=f[r+72>>2]|0;if((T|0)!=(z|0)){R=T;while(1){RGa(a,f[R+16>>2]|0,d);T=f[R+4>>2]|0;if(!T){S=R+8|0;Q=f[S>>2]|0;if((f[Q>>2]|0)==(R|0))U=Q;else{Q=S;do{S=f[Q>>2]|0;Q=S+8|0;P=f[Q>>2]|0}while((f[P>>2]|0)!=(S|0));U=P}}else{Q=T;while(1){P=f[Q>>2]|0;if(!P)break;else Q=P}U=Q}if((U|0)==(z|0))break;else R=U}}b:do if(!(f[r>>2]|0)){U=a+4|0;R=f[U>>2]|0;z=(f[R+76>>2]|0)-(f[R+72>>2]|0)|0;R=(z|0)/56|0;T=r+120|0;P=r+124|0;S=f[P>>2]|0;O=f[T>>2]|0;w=S-O>>3;F=O;O=S;if(R>>>0<=w>>>0){if(R>>>0<w>>>0?(S=F+(R<<3)|0,(O|0)!=(S|0)):0){F=O;do{O=F+-8|0;f[P>>2]=O;E=f[O>>2]|0;if(E|0?(B=E+4|0,D=f[B>>2]|0,f[B>>2]=D+-1,(D|0)==1):0)Yi[f[(f[E>>2]|0)+8>>2]&2047](E);f[O>>2]=0;f[F+-4>>2]=0;F=f[P>>2]|0}while((F|0)!=(S|0))}}else iHa(T,R-w|0);if(z|0){S=g+4|0;F=0;do{ZGa(g,a,(f[(f[U>>2]|0)+72>>2]|0)+(F*56|0)|0);P=f[T>>2]|0;Q=P+(F<<3)|0;O=f[g>>2]|0;E=f[S>>2]|0;if(O|0){D=O+4|0;f[D>>2]=(f[D>>2]|0)+1}D=f[Q>>2]|0;f[Q>>2]=O;f[P+(F<<3)+4>>2]=E;if(D|0?(E=D+4|0,P=f[E>>2]|0,f[E>>2]=P+-1,(P|0)==1):0)Yi[f[(f[D>>2]|0)+8>>2]&2047](D);D=f[g>>2]|0;if(D|0?(P=D+4|0,E=f[P>>2]|0,f[P>>2]=E+-1,(E|0)==1):0)Yi[f[(f[D>>2]|0)+8>>2]&2047](D);F=F+1|0}while(F>>>0<R>>>0)}}else{R=r+164|0;F=r+168|0;S=f[F>>2]|0;T=f[R>>2]|0;U=S-T>>2;z=T;T=S;if(x>>>0<=U>>>0){if(x>>>0<U>>>0?(S=z+(x<<2)|0,(T|0)!=(S|0)):0)f[F>>2]=T+(~((T+-4-S|0)>>>2)<<2)}else mFa(R,x-U|0);U=r+120|0;S=r+124|0;T=f[S>>2]|0;F=f[U>>2]|0;z=T-F>>3;w=F;F=T;if(x>>>0<=z>>>0){if(x>>>0<z>>>0?(T=w+(x<<3)|0,(F|0)!=(T|0)):0){w=F;do{F=w+-8|0;f[S>>2]=F;D=f[F>>2]|0;if(D|0?(E=D+4|0,P=f[E>>2]|0,f[E>>2]=P+-1,(P|0)==1):0)Yi[f[(f[D>>2]|0)+8>>2]&2047](D);f[F>>2]=0;f[w+-4>>2]=0;w=f[S>>2]|0}while((w|0)!=(T|0))}}else iHa(U,x-z|0);if(!y){T=g+4|0;w=0;while(1){S=(f[t>>2]|0)+(w<<3)|0;F=f[S>>2]|0;D=f[S+4>>2]|0;S=g;f[S>>2]=F;f[S+4>>2]=D;if((F|D|0)<=-1)break;D=AGa(c,g)|0;f[(f[R>>2]|0)+(w<<2)>>2]=(f[D+152>>2]|0)+((f[T>>2]|0)*56|0);D=AGa(c,g)|0;F=f[T>>2]|0;S=f[D+108>>2]|0;D=f[U>>2]|0;P=D+(w<<3)|0;E=f[S+(F<<3)>>2]|0;O=f[S+(F<<3)+4>>2]|0;if(E|0){F=E+4|0;f[F>>2]=(f[F>>2]|0)+1}F=f[P>>2]|0;f[P>>2]=E;f[D+(w<<3)+4>>2]=O;if(F|0?(O=F+4|0,D=f[O>>2]|0,f[O>>2]=D+-1,(D|0)==1):0)Yi[f[(f[F>>2]|0)+8>>2]&2047](F);w=w+1|0;if(w>>>0>=x>>>0)break b}f[h>>2]=0;f[h+4>>2]=0;V=tT(h,12)|0;W=380564;X=V+12|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,h,380577,376410,1652)}}while(0);x=f[p>>2]|0;p=d+4|0;d=f[p>>2]|0;if(!d){f[g>>2]=0;Z=g+4|0;f[Z>>2]=0;_=tT(g,35)|0;V=_;W=380591;X=V+35|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,g,380577,376410,1661)}else{$=p;aa=d}c:while(1){d=aa;while(1){if((f[d+16>>2]|0)>=(x|0))break;c=f[d+4>>2]|0;if(!c){ba=$;break c}else d=c}aa=f[d>>2]|0;if(!aa){ba=d;break}else $=d}if((ba|0)==(p|0)){f[g>>2]=0;Z=g+4|0;f[Z>>2]=0;_=tT(g,35)|0;V=_;W=380591;X=V+35|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,g,380577,376410,1661)}if((f[ba+16>>2]|0)>(x|0)){f[g>>2]=0;Z=g+4|0;f[Z>>2]=0;_=tT(g,35)|0;V=_;W=380591;X=V+35|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,g,380577,376410,1661)}f[q>>2]=0;_=q+4|0;f[_>>2]=0;f[q+8>>2]=0;Z=a+44|0;if((f[a+80>>2]|0)==3)ca=(f[a+84>>2]|0)==2;else ca=0;x=r+152|0;p=r+176|0;$=ba+32|0;jHa(j,ba+44|0);aa=ba+36|0;c=((f[aa>>2]|0)-(f[$>>2]|0)|0)/12|0;g$(x,c>>>0>1?c:1);c=j+4|0;g$(p,((f[c>>2]|0)-(f[j>>2]|0)|0)/12|0);if((f[r+92>>2]|0)>>>0>(((f[aa>>2]|0)-(f[$>>2]|0)|0)/12|0)>>>0){f[g>>2]=0;f[g+4>>2]=0;V=tT(g,45)|0;W=380627;X=V+45|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,g,380673,376410,783)}if((b[ba+56>>0]|0)!=0?((f[r+168>>2]|0)-(f[r+164>>2]|0)|0)==4:0)da=(kHa(Z,f[r+60>>2]|0)|0)==1;else da=0;jHa(k,$);ba=k+4|0;f[l>>2]=f[ba>>2];f[m>>2]=f[j>>2];f[n>>2]=f[c>>2];f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];f[g>>2]=f[n>>2];lHa(k,i,h,g)|0;f[h>>2]=0;n=h+4|0;f[n>>2]=0;f[h+8>>2]=0;m=r+156|0;l=f[x>>2]|0;d:do if((f[m>>2]|0)!=(l|0)){y=h+8|0;w=0;U=l;T=0;R=0;while(1){z=U+(w*56|0)|0;f[g>>2]=z;if((T|0)==(R|0))mHa(h,g);else{f[T>>2]=z;f[n>>2]=(f[n>>2]|0)+4}z=w+1|0;F=f[x>>2]|0;if(z>>>0>=(((f[m>>2]|0)-F|0)/56|0)>>>0)break d;w=z;U=F;T=f[n>>2]|0;R=f[y>>2]|0}}while(0);l=r+180|0;y=f[p>>2]|0;e:do if((f[l>>2]|0)!=(y|0)){R=h+8|0;T=g+4|0;U=q+8|0;w=0;d=y;f:while(1){F=d+(w*56|0)|0;f[g>>2]=F;z=f[n>>2]|0;if((z|0)==(f[R>>2]|0))mHa(h,g);else{f[z>>2]=F;f[n>>2]=(f[n>>2]|0)+4}F=f[j>>2]|0;z=f[F+(w*12|0)+4>>2]|0;D=f[F+(w*12|0)>>2]|0;F=z-D|0;O=F>>2;E=D;do if((E|0)!=(z|0)){if((F|0)<=-4)break f;if((F|0)>0){D=0;P=1;do{P=Y(f[E+(D<<2)>>2]|0,P)|0;D=D+1|0}while((D|0)<(O|0));if(!P)break}D=(((f[m>>2]|0)-(f[x>>2]|0)|0)/56|0)+w|0;f[g>>2]=f[r>>2];f[T>>2]=D;D=f[_>>2]|0;if((D|0)==(f[U>>2]|0))kGa(q,g);else{K=g;J=f[K+4>>2]|0;S=D;f[S>>2]=f[K>>2];f[S+4>>2]=J;f[_>>2]=(f[_>>2]|0)+8}}while(0);w=w+1|0;d=f[p>>2]|0;if(w>>>0>=(((f[l>>2]|0)-d|0)/56|0)>>>0)break e}f[g>>2]=0;f[g+4>>2]=0;V=tT(g,70)|0;W=452744;X=V+70|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,g,452815,452821,161)}while(0);y=f[_>>2]|0;d=f[q>>2]|0;if((y|0)!=(d|0)){w=a+48|0;U=0;T=y;y=d;while(1){d=y;R=d+(U<<3)|0;O=f[w>>2]|0;do if(O){E=f[R>>2]|0;F=f[d+(U<<3)+4>>2]|0;z=w;G=O;g:while(1){J=G;while(1){S=f[J+16>>2]|0;if((S|0)>=(E|0)){if((S|0)!=(E|0))break;if((f[J+20>>2]|0)>=(F|0))break}S=f[J+4>>2]|0;if(!S){ea=z;break g}else J=S}G=f[J>>2]|0;if(!G){ea=J;break}else z=J}if((ea|0)!=(w|0)?(z=f[ea+16>>2]|0,(E|0)>=(z|0)):0){if((E|0)==(z|0)?(F|0)<(f[ea+20>>2]|0):0){N=109;break}z=ea+24|0;f[z>>2]=(f[z>>2]|0)+1;fa=y;ga=T}else N=109}else N=109;while(0);if((N|0)==109){N=0;O=QGa(Z,R)|0;f[O>>2]=1;fa=f[q>>2]|0;ga=f[_>>2]|0}U=U+1|0;if(U>>>0>=ga-fa>>3>>>0)break;else{T=ga;y=fa}}}fa=i+4|0;f[fa>>2]=0;y=i+8|0;f[y>>2]=0;ga=i+4|0;f[i>>2]=ga;f[o>>2]=0;T=f[k>>2]|0;do if((f[ba>>2]|0)!=(T|0)){U=T;ea=0;while(1){w=U;O=f[w+(ea*12|0)+4>>2]|0;d=f[w+(ea*12|0)>>2]|0;w=O-d|0;z=w>>2;G=d;if((G|0)!=(O|0)){if((w|0)<=-4){N=134;break}if((w|0)>0){w=0;O=1;while(1){d=Y(f[G+(w<<2)>>2]|0,O)|0;w=w+1|0;if((w|0)>=(z|0)){ha=d;break}else O=d}}else ha=1}else ha=0;O=f[ga>>2]|0;do if(O){z=fa;w=O;G=O;while(1){F=f[w+16>>2]|0;if((ha|0)<(F|0)){E=f[w>>2]|0;if(!E){N=140;break}else{ia=w;ja=E}}else{if((F|0)>=(ha|0)){N=144;break}ka=w+4|0;F=f[ka>>2]|0;if(!F){N=143;break}else{ia=ka;ja=F}}z=ia;w=ja;G=ja}if((N|0)==140){N=0;la=w;ma=w;N=146;break}else if((N|0)==143){N=0;la=ka;ma=w;N=146;break}else if((N|0)==144){N=0;na=z;oa=w;pa=G;N=145;break}}else{na=ga;oa=ga;pa=O;N=145}while(0);if((N|0)==145){N=0;if(!pa){la=na;ma=oa;N=146}else qa=pa}if((N|0)==146){N=0;O=VDc(32)|0;f[O+16>>2]=ha;f[O+20>>2]=0;f[O+24>>2]=0;f[O+28>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=ma;f[la>>2]=O;J=f[f[i>>2]>>2]|0;if(!J)ra=O;else{f[i>>2]=J;ra=f[la>>2]|0}laa(f[fa>>2]|0,ra);f[y>>2]=(f[y>>2]|0)+1;qa=O}O=qa+24|0;J=f[O>>2]|0;if((J|0)==(f[qa+28>>2]|0))g6(qa+20|0,o);else{f[J>>2]=f[o>>2];f[O>>2]=J+4}ea=(f[o>>2]|0)+1|0;f[o>>2]=ea;U=f[k>>2]|0;if(ea>>>0>=(((f[ba>>2]|0)-U|0)/12|0)>>>0){N=128;break}}if((N|0)==128){sa=f[i>>2]|0;break}else if((N|0)==134){f[g>>2]=0;f[g+4>>2]=0;V=tT(g,70)|0;W=452744;X=V+70|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,g,452815,452821,161)}}else sa=ga;while(0);h:do if((ga|0)!=(sa|0)){qa=g+4|0;y=da^1;ra=r+164|0;fa=o+36|0;la=o+16|0;ma=o+4|0;ha=o+40|0;pa=o+44|0;oa=o+48|0;na=r+60|0;ka=o+8|0;ja=o+12|0;ia=o+20|0;T=o+24|0;U=o+28|0;ea=o+32|0;R=ga;J=ga;i:while(1){O=R;F=0;while(1){ta=f[J>>2]|0;ua=(ta|0)==0;if(ua){E=O;while(1){d=f[E+8>>2]|0;if((f[d>>2]|0)==(E|0))E=d;else{va=d;break}}}else{E=ta;while(1){G=f[E+4>>2]|0;if(!G){va=E;break}else E=G}}E=va+20|0;if(F>>>0>=(f[E+4>>2]|0)-(f[E>>2]|0)>>2>>>0)break;if(ua){E=O;while(1){G=f[E+8>>2]|0;if((f[G>>2]|0)==(E|0))E=G;else{wa=G;break}}}else{E=ta;while(1){G=f[E+4>>2]|0;if(!G){wa=E;break}else E=G}}E=f[(f[wa+20>>2]|0)+(F<<2)>>2]|0;G=f[k>>2]|0;w=G+(E*12|0)|0;z=f[G+(E*12|0)+4>>2]|0;G=f[w>>2]|0;d=z-G|0;P=d>>2;S=G;do if((S|0)!=(z|0)){if((d|0)<=-4){N=167;break i}G=(d|0)>0;if(G){K=0;D=1;do{D=Y(f[S+(K<<2)>>2]|0,D)|0;K=K+1|0}while((K|0)<(P|0));if(!D)break}f[g>>2]=f[r>>2];f[qa>>2]=E;if(E>>>0>=(((f[aa>>2]|0)-(f[$>>2]|0)|0)/12|0)>>>0|y)oHa(Z,w,g,f[(f[h>>2]|0)+(E<<2)>>2]|0,ca);else{K=f[f[ra>>2]>>2]|0;Q=f[K+4>>2]|0;if((Q|0)<3)xa=Y(f[K+12>>2]|0,f[K+8>>2]|0)|0;else{B=f[K+40>>2]|0;C=0;A=1;while(1){I=Y(f[B+(C<<2)>>2]|0,A)|0;C=C+1|0;if((C|0)==(Q|0)){xa=I;break}else A=I}}if(G){A=0;Q=1;while(1){C=Y(f[S+(A<<2)>>2]|0,Q)|0;A=A+1|0;if((A|0)>=(P|0)){ya=C;break}else Q=C}}else ya=1;if((xa|0)!=(ya|0)){N=178;break i}nT(o,K,1,w);Q=f[x>>2]|0;A=Q+(E*56|0)|0;if((A|0)!=(o|0)){G=f[fa>>2]|0;if(G|0){C=G+12|0;f[C>>2]=(f[C>>2]|0)+1}C=Q+(E*56|0)+36|0;G=f[C>>2]|0;do if(G|0){B=G+12|0;D=f[B>>2]|0;f[B>>2]=D+-1;if((D|0)!=1)break;_S(A)}while(0);f[C>>2]=0;G=Q+(E*56|0)+16|0;K=Q+(E*56|0)+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[K>>2]|0)>0){D=f[Q+(E*56|0)+40>>2]|0;B=0;do{f[D+(B<<2)>>2]=0;B=B+1|0;za=f[K>>2]|0}while((B|0)<(za|0));f[A>>2]=f[o>>2];if((za|0)<3)N=190;else N=192}else{f[A>>2]=f[o>>2];N=190}do if((N|0)==190){N=0;B=f[ma>>2]|0;if((B|0)>=3){N=192;break}f[K>>2]=B;f[Q+(E*56|0)+8>>2]=f[ka>>2];f[Q+(E*56|0)+12>>2]=f[ja>>2];B=f[pa>>2]|0;D=f[Q+(E*56|0)+44>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2]}while(0);if((N|0)==192){N=0;ZS(A,o)}f[G>>2]=f[la>>2];f[Q+(E*56|0)+20>>2]=f[ia>>2];f[Q+(E*56|0)+24>>2]=f[T>>2];f[Q+(E*56|0)+28>>2]=f[U>>2];f[Q+(E*56|0)+32>>2]=f[ea>>2];f[C>>2]=f[fa>>2]}K=f[fa>>2]|0;do if(K|0){B=K+12|0;D=f[B>>2]|0;f[B>>2]=D+-1;if((D|0)!=1)break;_S(o)}while(0);f[fa>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[ma>>2]|0)>0){K=f[ha>>2]|0;C=0;do{f[K+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[ma>>2]|0))}C=f[pa>>2]|0;if((C|0)!=(oa|0))g0(C);nHa(Z,f[na>>2]|0,g)}}while(0);F=F+1|0}if(ua){F=O;while(1){E=f[F+8>>2]|0;if((f[E>>2]|0)==(F|0))F=E;else{Aa=E;break}}}else{F=ta;while(1){O=f[F+4>>2]|0;if(!O){Aa=F;break}else F=O}}if((Aa|0)==(f[i>>2]|0))break h;else{R=Aa;J=Aa}}if((N|0)==167){f[g>>2]=0;f[g+4>>2]=0;V=tT(g,70)|0;W=452744;X=V+70|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,g,452815,452821,161)}else if((N|0)==178){f[o>>2]=0;f[o+4>>2]=0;V=tT(o,49)|0;W=380695;X=V+49|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));z5(-215,o,380673,376410,834)}}while(0);pHa(i,f[ga>>2]|0);ga=f[h>>2]|0;if(ga|0){o=f[n>>2]|0;if((o|0)!=(ga|0))f[n>>2]=o+(~((o+-4-ga|0)>>>2)<<2);YDc(ga)}ga=f[k>>2]|0;if(ga|0){o=f[ba>>2]|0;if((o|0)==(ga|0))Ba=ga;else{n=o;while(1){o=n+-12|0;f[ba>>2]=o;W=f[o>>2]|0;if(!W)Ca=o;else{o=n+-8|0;Aa=f[o>>2]|0;if((Aa|0)!=(W|0))f[o>>2]=Aa+(~((Aa+-4-W|0)>>>2)<<2);YDc(W);Ca=f[ba>>2]|0}if((Ca|0)==(ga|0))break;else n=Ca}Ba=f[k>>2]|0}YDc(Ba)}Ba=f[j>>2]|0;if(Ba|0){k=f[c>>2]|0;if((k|0)==(Ba|0))Da=Ba;else{Ca=k;while(1){k=Ca+-12|0;f[c>>2]=k;n=f[k>>2]|0;if(!n)Ea=k;else{k=Ca+-8|0;ga=f[k>>2]|0;if((ga|0)!=(n|0))f[k>>2]=ga+(~((ga+-4-n|0)>>>2)<<2);YDc(n);Ea=f[c>>2]|0}if((Ea|0)==(Ba|0))break;else Ca=Ea}Da=f[j>>2]|0}YDc(Da)}Da=r+108|0;Ea=((f[m>>2]|0)-(f[x>>2]|0)|0)/56|0;Ca=r+112|0;Ba=f[Ca>>2]|0;c=f[Da>>2]|0;n=Ba-c>>3;ga=c;c=Ba;do if(Ea>>>0>n>>>0)iHa(Da,Ea-n|0);else{if(Ea>>>0>=n>>>0)break;Ba=ga+(Ea<<3)|0;if((c|0)==(Ba|0))break;else Fa=c;do{k=Fa+-8|0;f[Ca>>2]=k;ba=f[k>>2]|0;do if(ba|0){W=ba+4|0;Aa=f[W>>2]|0;f[W>>2]=Aa+-1;if((Aa|0)!=1)break;Yi[f[(f[ba>>2]|0)+8>>2]&2047](ba)}while(0);f[k>>2]=0;f[Fa+-4>>2]=0;Fa=f[Ca>>2]|0}while((Fa|0)!=(Ba|0))}while(0);Fa=f[x>>2]|0;if((f[m>>2]|0)!=(Fa|0)){Ca=g+4|0;c=0;Ea=Fa;do{ZGa(g,a,Ea+(c*56|0)|0);Fa=f[Da>>2]|0;ga=Fa+(c<<3)|0;n=f[g>>2]|0;Ba=f[Ca>>2]|0;if(n|0){ba=n+4|0;f[ba>>2]=(f[ba>>2]|0)+1}ba=f[ga>>2]|0;f[ga>>2]=n;f[Fa+(c<<3)+4>>2]=Ba;do if(ba|0){Ba=ba+4|0;Fa=f[Ba>>2]|0;f[Ba>>2]=Fa+-1;if((Fa|0)!=1)break;Yi[f[(f[ba>>2]|0)+8>>2]&2047](ba)}while(0);ba=f[g>>2]|0;do if(ba|0){Fa=ba+4|0;Ba=f[Fa>>2]|0;f[Fa>>2]=Ba+-1;if((Ba|0)!=1)break;Yi[f[(f[ba>>2]|0)+8>>2]&2047](ba)}while(0);c=c+1|0;Ea=f[x>>2]|0}while(c>>>0<(((f[m>>2]|0)-Ea|0)/56|0)>>>0)}Ea=r+132|0;m=((f[l>>2]|0)-(f[p>>2]|0)|0)/56|0;c=r+136|0;Ca=f[c>>2]|0;Da=f[Ea>>2]|0;ba=Ca-Da>>3;Ba=Da;Da=Ca;do if(m>>>0>ba>>>0)iHa(Ea,m-ba|0);else{if(m>>>0>=ba>>>0)break;Ca=Ba+(m<<3)|0;if((Da|0)==(Ca|0))break;else Ga=Da;do{Fa=Ga+-8|0;f[c>>2]=Fa;n=f[Fa>>2]|0;do if(n|0){ga=n+4|0;Aa=f[ga>>2]|0;f[ga>>2]=Aa+-1;if((Aa|0)!=1)break;Yi[f[(f[n>>2]|0)+8>>2]&2047](n)}while(0);f[Fa>>2]=0;f[Ga+-4>>2]=0;Ga=f[c>>2]|0}while((Ga|0)!=(Ca|0))}while(0);Ga=f[p>>2]|0;if((f[l>>2]|0)!=(Ga|0)){c=g+4|0;Da=0;m=Ga;do{ZGa(g,a,m+(Da*56|0)|0);Ga=f[Ea>>2]|0;Ba=Ga+(Da<<3)|0;ba=f[g>>2]|0;Ca=f[c>>2]|0;if(ba|0){n=ba+4|0;f[n>>2]=(f[n>>2]|0)+1}n=f[Ba>>2]|0;f[Ba>>2]=ba;f[Ga+(Da<<3)+4>>2]=Ca;do if(n|0){Ca=n+4|0;Ga=f[Ca>>2]|0;f[Ca>>2]=Ga+-1;if((Ga|0)!=1)break;Yi[f[(f[n>>2]|0)+8>>2]&2047](n)}while(0);n=f[g>>2]|0;do if(n|0){Ga=n+4|0;Ca=f[Ga>>2]|0;f[Ga>>2]=Ca+-1;if((Ca|0)!=1)break;Yi[f[(f[n>>2]|0)+8>>2]&2047](n)}while(0);Da=Da+1|0;m=f[p>>2]|0}while(Da>>>0<(((f[l>>2]|0)-m|0)/56|0)>>>0)}oGa(i,r);m=r+164|0;l=r+168|0;r=f[l>>2]|0;Da=f[m>>2]|0;p=r-Da>>2;f[j>>2]=0;c=j+4|0;f[c>>2]=0;f[j+8>>2]=0;if(!p){Ha=Da;Ia=0;Ja=r}else{if(p>>>0>76695844)mCc(j);r=p*56|0;Da=VDc(r)|0;f[c>>2]=Da;f[j>>2]=Da;f[j+8>>2]=Da+(p*56|0);Ea=Da+r|0;r=p;p=Da;while(1){f[p>>2]=1124007936;n=p+8|0;Ca=p+40|0;V=p+4|0;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[Ca>>2]=n;Ga=p+48|0;f[p+44>>2]=Ga;f[Ga>>2]=0;f[p+52>>2]=0;r=r+-1|0;if(!r)break;else p=p+56|0}f[c>>2]=Ea;Ha=f[m>>2]|0;Ia=Da;Ja=f[l>>2]|0}j:do if((Ja|0)!=(Ha|0)){Da=0;Ea=Ja;c=Ha;p=Ia;while(1){r=f[c+(Da<<2)>>2]|0;V=p+(Da*56|0)|0;if((V|0)==(r|0)){Ka=c;La=Ea}else{X=r+36|0;Ga=f[X>>2]|0;if(Ga|0){ba=Ga+12|0;f[ba>>2]=(f[ba>>2]|0)+1}ba=p+(Da*56|0)+36|0;Ga=f[ba>>2]|0;do if(Ga|0){Ba=Ga+12|0;k=f[Ba>>2]|0;f[Ba>>2]=k+-1;if((k|0)!=1)break;_S(V)}while(0);f[ba>>2]=0;Ga=p+(Da*56|0)+16|0;Fa=p+(Da*56|0)+4|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[Fa>>2]|0)>0){k=f[p+(Da*56|0)+40>>2]|0;Ba=0;do{f[k+(Ba<<2)>>2]=0;Ba=Ba+1|0;Ma=f[Fa>>2]|0}while((Ba|0)<(Ma|0));f[V>>2]=f[r>>2];if((Ma|0)<3)N=286;else N=288}else{f[V>>2]=f[r>>2];N=286}do if((N|0)==286){N=0;Ba=f[r+4>>2]|0;if((Ba|0)>=3){N=288;break}f[Fa>>2]=Ba;f[p+(Da*56|0)+8>>2]=f[r+8>>2];f[p+(Da*56|0)+12>>2]=f[r+12>>2];Ba=f[r+44>>2]|0;k=f[p+(Da*56|0)+44>>2]|0;f[k>>2]=f[Ba>>2];f[k+4>>2]=f[Ba+4>>2]}while(0);if((N|0)==288){N=0;ZS(V,r)}f[Ga>>2]=f[r+16>>2];f[p+(Da*56|0)+20>>2]=f[r+20>>2];f[p+(Da*56|0)+24>>2]=f[r+24>>2];f[p+(Da*56|0)+28>>2]=f[r+28>>2];f[p+(Da*56|0)+32>>2]=f[r+32>>2];f[ba>>2]=f[X>>2];Ka=f[m>>2]|0;La=f[l>>2]|0}Fa=Da+1|0;if(Fa>>>0>=La-Ka>>2>>>0)break j;Da=Fa;Ea=La;c=Ka;p=f[j>>2]|0}}while(0);Ka=i+4|0;La=f[Ka>>2]|0;l=f[(f[La>>2]|0)+36>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=17104896;f[g+4>>2]=j;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33882112;f[h+4>>2]=x;Ti[l&511](La,g,h);f[(f[Ka>>2]|0)+32>>2]=f[a+84>>2];mx(j);j=f[t>>2]|0;if((f[v>>2]|0)!=(j|0)){a=0;Ka=j;do{qHa(Z,Ka+(a<<3)|0);a=a+1|0;Ka=f[t>>2]|0}while(a>>>0<(f[v>>2]|0)-Ka>>3>>>0)}Ka=f[q>>2]|0;if((f[_>>2]|0)!=(Ka|0)){v=0;a=Ka;do{qHa(Z,a+(v<<3)|0);v=v+1|0;a=f[q>>2]|0}while(v>>>0<(f[_>>2]|0)-a>>3>>>0)}f[s>>2]=1;s=f[i>>2]|0;do if(s|0){i=s+4|0;a=f[i>>2]|0;f[i>>2]=a+-1;if((a|0)!=1)break;Yi[f[(f[s>>2]|0)+8>>2]&2047](s)}while(0);s=f[q>>2]|0;if(s|0){q=f[_>>2]|0;if((q|0)!=(s|0))f[_>>2]=q+(~((q+-8-s|0)>>>3)<<3);YDc(s)}u=e;return}function SGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=b;k=i;while(1){l=c;m=f[l+4>>2]|0;n=k;f[n>>2]=f[l>>2];f[n+4>>2]=m;j=j+-1|0;if(!j)break;else k=k+8|0}f[g>>2]=i+(b<<3);return}i=f[a>>2]|0;k=h-i|0;h=k>>3;j=h+b|0;if(j>>>0>536870911)mCc(a);m=e-i|0;e=m>>2;n=m>>3>>>0<268435455?(e>>>0<j>>>0?j:e):536870911;do if(n)if(n>>>0>536870911){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{o=VDc(n<<3)|0;break}else o=0;while(0);e=o+(h<<3)|0;j=o+(n<<3)|0;n=b;o=e;while(1){m=c;l=f[m+4>>2]|0;p=o;f[p>>2]=f[m>>2];f[p+4>>2]=l;n=n+-1|0;if(!n)break;else o=o+8|0}o=e+(0-h<<3)|0;if((k|0)>0)dJc(o|0,i|0,k|0)|0;f[a>>2]=o;f[g>>2]=e+(b<<3);f[d>>2]=j;if(!i)return;YDc(i);return}function TGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0;d=u;u=u+304|0;e=d+104|0;g=d+288|0;h=d+56|0;i=d+268|0;j=d+256|0;k=d;l=d+280|0;m=d+200|0;n=d+184|0;o=d+136|0;if(!(b[a+117>>0]|0)){u=d;return}p=a+80|0;if((f[p>>2]&-2|0)!=2){u=d;return}q=f[c>>2]|0;r=f[c+4>>2]|0;c=j+4|0;f[c>>2]=0;s=j+8|0;f[s>>2]=0;t=j+4|0;f[j>>2]=t;if((q|0)!=(r|0)){v=t;w=q;do{f[i>>2]=v;f[e>>2]=f[i>>2];q=VGa(j,e,g,h,w)|0;if(!(f[q>>2]|0)){x=VDc(24)|0;y=w;z=f[y+4>>2]|0;A=x+16|0;f[A>>2]=f[y>>2];f[A+4>>2]=z;z=f[g>>2]|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=z;f[q>>2]=x;z=f[f[j>>2]>>2]|0;if(!z)B=x;else{f[j>>2]=z;B=f[q>>2]|0}laa(f[c>>2]|0,B);f[s>>2]=(f[s>>2]|0)+1}w=w+8|0}while((w|0)!=(r|0))}r=a+20|0;w=f[r>>2]|0;s=a+24|0;a:do if((w|0)!=(s|0)){B=h+4|0;c=e+4|0;v=a+84|0;q=i+4|0;z=k+4|0;x=k+8|0;A=k+40|0;y=k+48|0;C=k+44|0;D=k+52|0;E=e+8|0;F=e+4|0;G=k+36|0;H=k+16|0;I=e+4|0;J=k+12|0;K=k+20|0;L=k+24|0;M=k+28|0;N=k+32|0;O=e+4|0;P=h+4|0;Q=h+8|0;R=h+20|0;S=h+24|0;T=h+28|0;U=h+32|0;V=h+40|0;W=h+36|0;X=h+44|0;Y=i+4|0;Z=i+8|0;_=i+8|0;$=k+4|0;aa=k+8|0;ba=k+40|0;ca=k+48|0;da=k+44|0;ea=k+52|0;fa=e+8|0;ga=e+4|0;ha=k+36|0;ia=k+16|0;ja=k+4|0;ka=k+8|0;la=k+8|0;ma=m+4|0;na=m+8|0;oa=m+32|0;pa=m+40|0;qa=m+36|0;ra=m+44|0;sa=e+8|0;ta=e+4|0;ua=m+24|0;va=m+12|0;wa=h+12|0;xa=m+16|0;ya=h+16|0;za=m+20|0;Aa=m+28|0;Ba=e+4|0;Ca=e+8|0;Da=e+12|0;Ea=e+16|0;Fa=e+20|0;Ga=e+24|0;Ha=e+28|0;Ia=k+4|0;Ja=m+40|0;Ka=n+4|0;La=o+24|0;Ma=o+4|0;Na=o+8|0;Oa=o+12|0;Pa=o+36|0;Qa=o+16|0;Ra=o+20|0;Sa=o+28|0;Ta=m+16|0;Ua=m+36|0;Va=m+4|0;Wa=m+44|0;Xa=m+48|0;Ya=m+8|0;Za=m+12|0;_a=m+20|0;$a=m+24|0;ab=m+28|0;bb=m+32|0;cb=k+12|0;db=k+20|0;eb=k+24|0;fb=k+28|0;gb=k+32|0;hb=e+4|0;ib=e+8|0;jb=i+4|0;kb=l+4|0;lb=w;b:while(1){f[g>>2]=f[lb+16>>2];mb=AGa(r,g)|0;nb=mb+200|0;c:do if(!(b[nb>>0]|0)){ob=mb+144|0;pb=mb+96|0;qb=mb+100|0;rb=f[pb>>2]|0;sb=rb;d:do if(((f[qb>>2]|0)-rb|0)==8){tb=f[g>>2]|0;ub=f[t>>2]|0;if(ub|0){vb=ub;do{ub=f[vb+16>>2]|0;do if((tb|0)<(ub|0))wb=19;else{xb=(tb|0)==(ub|0);if(xb?(f[vb+20>>2]|0)>0:0){wb=19;break}if((ub|0)>=(tb|0)){if(!xb)break d;if((f[vb+20>>2]|0)>=0)break d}yb=vb+4|0}while(0);if((wb|0)==19){wb=0;yb=vb}vb=f[yb>>2]|0}while((vb|0)!=0)}vb=AGa(r,sb)|0;f[h>>2]=f[f[pb>>2]>>2];f[B>>2]=0;tb=mb+148|0;ub=mb+108|0;xb=mb+152|0;zb=vb;while(1){vb=f[zb+144>>2]|0;f[e>>2]=vb;f[c>>2]=f[zb+148>>2];if(vb|0){Ab=vb+4|0;f[Ab>>2]=(f[Ab>>2]|0)+1}Ab=f[tb>>2]|0;if(Mi[f[(f[Ab>>2]|0)+80>>2]&1023](Ab,e)|0){b[zb+200>>0]=1;Ab=AGa(r,h)|0;if((mb|0)!=(Ab|0))XGa(xb,f[Ab+152>>2]|0,f[Ab+156>>2]|0);Ab=AGa(r,h)|0;if((mb|0)!=(Ab|0))NGa(ub,f[Ab+108>>2]|0,f[Ab+112>>2]|0);Ab=f[zb+96>>2]|0;if(((f[zb+100>>2]|0)-Ab|0)==8){f[i>>2]=f[Ab>>2];Ab=AGa(r,i)|0;vb=h;f[vb>>2]=f[i>>2];f[vb+4>>2]=0;Bb=0;Cb=Ab}else{Bb=6;Cb=0}}else{Bb=6;Cb=zb}Ab=f[e>>2]|0;if(Ab|0?(vb=Ab+4|0,Db=f[vb>>2]|0,f[vb>>2]=Db+-1,(Db|0)==1):0)Yi[f[(f[Ab>>2]|0)+8>>2]&2047](Ab);if((Cb|0)!=0&(Bb|0)==0)zb=Cb;else break}if((f[p>>2]|0)!=3)break c;if(((f[v>>2]|0)+-1|0)>>>0<2){if(!(iaa()|0))break c;zb=f[(f[tb>>2]|0)+24>>2]|0;if(((((zb|0)!=455045?(Ab=(zb|0)==0?1154740:zb,!((Ioc(Ab,455045)|0)==0|(zb|0)==425625)):0)?!((Ioc(Ab,425625)|0)==0|(zb|0)==454888):0)?!((Ioc(Ab,454888)|0)==0|(zb|0)==454781):0)?Ioc(Ab,454781)|0:0)break c}e:do if(!Cb)Eb=0;else{Ab=Cb;while(1){do if((((f[v>>2]|0)+-1|0)>>>0<2?(zb=f[Ab+12>>2]|0,(zb|0)!=393771):0)?(Db=(zb|0)==0?1154740:zb,!((Ioc(Db,393771)|0)==0|(zb|0)==425635)):0){if((Ioc(Db,425635)|0)==0|(zb|0)==425629)break;if((Ioc(Db,425629)|0)==0|(zb|0)==393726)break;if((Ioc(Db,393726)|0)==0|(zb|0)==451285)break;if(Ioc(Db,451285)|0){Eb=Ab;break e}}while(0);Db=f[Ab+148>>2]|0;if(!Db)Fb=0;else Fb=bFc(Db,14104,14192,0)|0;Db=f[Ab+144>>2]|0;f[e>>2]=Db;f[O>>2]=Fb;if(!Db)Gb=Fb;else{zb=Db+4|0;f[zb>>2]=(f[zb>>2]|0)+1;Gb=f[O>>2]|0}do if(!Gb){Hb=8;Ib=Ab}else{zb=f[tb>>2]|0;if(!(Mi[f[(f[zb>>2]|0)+76>>2]&1023](zb,e)|0)){Hb=8;Ib=Ab;break}b[Ab+200>>0]=1;zb=AGa(r,h)|0;if((mb|0)!=(zb|0))XGa(xb,f[zb+152>>2]|0,f[zb+156>>2]|0);zb=AGa(r,h)|0;if((mb|0)!=(zb|0))NGa(ub,f[zb+108>>2]|0,f[zb+112>>2]|0);zb=f[Ab+96>>2]|0;if(((f[Ab+100>>2]|0)-zb|0)!=8){Hb=8;Ib=0;break}f[i>>2]=f[zb>>2];zb=AGa(r,i)|0;Db=h;f[Db>>2]=f[i>>2];f[Db+4>>2]=0;Hb=0;Ib=zb}while(0);zb=f[e>>2]|0;do if(zb|0){Db=zb+4|0;vb=f[Db>>2]|0;f[Db>>2]=vb+-1;if((vb|0)!=1)break;Yi[f[(f[zb>>2]|0)+8>>2]&2047](zb)}while(0);if((Ib|0)!=0&(Hb|0)==0)Ab=Ib;else{Eb=Ib;break}}}while(0);do if(((f[v>>2]|0)+-1|0)>>>0<2){Ab=f[(f[tb>>2]|0)+24>>2]|0;if((Ab|0)!=455045?Ioc((Ab|0)==0?1154740:Ab,455045)|0:0)break;Ab=(Eb|0)!=0;if(Ab){zb=f[Eb+148>>2]|0;if(!zb)Jb=0;else Jb=bFc(zb,14104,14208,0)|0;zb=f[Eb+144>>2]|0;do if(!zb)Kb=0;else{vb=zb;Db=vb+4|0;f[Db>>2]=(f[Db>>2]|0)+1;f[Db>>2]=(f[Db>>2]|0)+1;Db=vb+4|0;Lb=f[Db>>2]|0;f[Db>>2]=Lb+-1;if((Lb|0)!=1){Kb=zb;break}Yi[f[(f[zb>>2]|0)+8>>2]&2047](vb);Kb=zb}while(0);f:do if(Jb|0){zb=f[t>>2]|0;if(zb|0){vb=f[h>>2]|0;Lb=f[B>>2]|0;Db=zb;do{zb=f[Db+16>>2]|0;do if((vb|0)<(zb|0))wb=86;else{Mb=(vb|0)==(zb|0);if(Mb?(Lb|0)<(f[Db+20>>2]|0):0){wb=86;break}if((zb|0)>=(vb|0)){if(!Mb)break f;if((f[Db+20>>2]|0)>=(Lb|0))break f}Nb=Db+4|0}while(0);if((wb|0)==86){wb=0;Nb=Db}Db=f[Nb>>2]|0}while((Db|0)!=0);if(!Ab)break}Db=Eb+60|0;Lb=f[Db>>2]|0;if(((f[Eb+64>>2]|0)-Lb|0)!=16)break;vb=Lb;while(1){Ob=AGa(r,vb)|0;if(!(b[Ob+200>>0]|0)){wb=98;break}Lb=f[Ob+60>>2]|0;if(((f[Ob+64>>2]|0)-Lb|0)!=8){wb=100;break}vb=Lb}if((wb|0)==98){wb=0;if((f[mb>>2]|0)==(f[Ob>>2]|0))Pb=1;else wb=100}if((wb|0)==100){wb=0;vb=(f[Db>>2]|0)+8|0;while(1){Qb=AGa(r,vb)|0;if(!(b[Qb+200>>0]|0))break;Lb=f[Qb+60>>2]|0;if(((f[Qb+64>>2]|0)-Lb|0)!=8){wb=430;break b}vb=Lb}if((f[mb>>2]|0)==(f[Qb>>2]|0))Pb=0;else{wb=430;break b}}vb=AGa(r,(f[Db>>2]|0)+(Pb<<3)|0)|0;Lb=Eb+96|0;zb=f[Lb>>2]|0;if(((f[Eb+100>>2]|0)-zb|0)!=8)break;if((f[vb>>2]|0)>=(f[mb>>2]|0))break;Mb=AGa(r,zb)|0;zb=h;f[zb>>2]=f[f[Lb>>2]>>2];f[zb+4>>2]=0;f[i>>2]=0;f[q>>2]=0;zb=f[Mb+148>>2]|0;if(!zb)Rb=0;else Rb=bFc(zb,14104,14192,0)|0;zb=f[Mb+144>>2]|0;Lb=Rb;if(!zb){f[i>>2]=zb;f[q>>2]=Lb;Sb=Rb}else{Tb=zb+4|0;f[Tb>>2]=(f[Tb>>2]|0)+1;f[Tb>>2]=(f[Tb>>2]|0)+1;Tb=f[i>>2]|0;f[i>>2]=zb;f[q>>2]=Lb;do if(Tb|0){Lb=Tb+4|0;Ub=f[Lb>>2]|0;f[Lb>>2]=Ub+-1;if((Ub|0)!=1)break;Yi[f[(f[Tb>>2]|0)+8>>2]&2047](Tb)}while(0);Tb=zb;Db=Tb+4|0;Ub=f[Db>>2]|0;f[Db>>2]=Ub+-1;if((Ub|0)==1)Yi[f[(f[zb>>2]|0)+8>>2]&2047](Tb);Sb=f[q>>2]|0}g:do if(Sb|0){Tb=f[t>>2]|0;if(Tb|0){Ub=f[h>>2]|0;Db=f[B>>2]|0;Lb=Tb;do{Tb=f[Lb+16>>2]|0;do if((Ub|0)<(Tb|0))wb=118;else{Vb=(Ub|0)==(Tb|0);if(Vb?(Db|0)<(f[Lb+20>>2]|0):0){wb=118;break}if((Tb|0)>=(Ub|0)){if(!Vb)break g;if((f[Lb+20>>2]|0)>=(Db|0))break g}Wb=Lb+4|0}while(0);if((wb|0)==118){wb=0;Wb=Lb}Lb=f[Wb>>2]|0}while((Lb|0)!=0)}Lb=f[Mb+12>>2]|0;do if((Lb|0)!=393771){Db=(Lb|0)==0?1154740:Lb;if((Ioc(Db,393771)|0)==0|(Lb|0)==425635)break;if((Ioc(Db,425635)|0)==0|(Lb|0)==451285)break;if(Ioc(Db,451285)|0)break g}while(0);Lb=f[tb>>2]|0;if(!(Mi[f[(f[Lb>>2]|0)+76>>2]&1023](Lb,i)|0))break;Lb=f[vb+108>>2]|0;Db=Lb;if(((f[vb+112>>2]|0)-Lb|0)!=8){wb=130;break b}Ub=mb+120|0;Tb=mb+124|0;Vb=f[Tb>>2]|0;Xb=Vb;if((Vb-(f[Ub>>2]|0)|0)!=8){wb=132;break b}if((Xb|0)==(f[mb+128>>2]|0))YGa(Ub,Db);else{Ub=f[Lb>>2]|0;f[Vb>>2]=Ub;f[Xb+4>>2]=f[Db+4>>2];if(!Ub)Yb=Xb;else{Xb=Ub+4|0;f[Xb>>2]=(f[Xb>>2]|0)+1;Yb=f[Tb>>2]|0}f[Tb>>2]=Yb+8}b[Eb+200>>0]=1;b[Mb+200>>0]=1;Tb=mb+156|0;Xb=f[xb>>2]|0;Ub=Xb;if(((f[Tb>>2]|0)-Xb|0)!=56){wb=139;break b}Xb=mb+112|0;if(((f[Xb>>2]|0)-(f[ub>>2]|0)|0)!=8){wb=141;break b}f[k>>2]=1124007936;Zb=z;_b=Zb+36|0;do{f[Zb>>2]=0;Zb=Zb+4|0}while((Zb|0)<(_b|0));f[A>>2]=x;f[C>>2]=y;f[y>>2]=0;f[D>>2]=0;Db=E;f[Db>>2]=0;f[Db+4>>2]=0;f[e>>2]=33619968;f[F>>2]=k;h_(Ub,e);Db=f[xb>>2]|0;if((Db|0)!=(k|0)){Vb=f[G>>2]|0;if(Vb|0){Lb=Vb+12|0;f[Lb>>2]=(f[Lb>>2]|0)+1}Lb=Db+36|0;Vb=f[Lb>>2]|0;do if(Vb|0){$b=Vb+12|0;ac=f[$b>>2]|0;f[$b>>2]=ac+-1;if((ac|0)!=1)break;_S(Db)}while(0);f[Lb>>2]=0;Vb=Db+16|0;Ub=Db+4|0;f[Vb>>2]=0;f[Vb+4>>2]=0;f[Vb+8>>2]=0;f[Vb+12>>2]=0;if((f[Ub>>2]|0)>0){ac=f[Db+40>>2]|0;$b=0;do{f[ac+($b<<2)>>2]=0;$b=$b+1|0;bc=f[Ub>>2]|0}while(($b|0)<(bc|0));f[Db>>2]=f[k>>2];if((bc|0)<3)wb=153;else wb=155}else{f[Db>>2]=f[k>>2];wb=153}do if((wb|0)==153){wb=0;$b=f[z>>2]|0;if(($b|0)>=3){wb=155;break}f[Ub>>2]=$b;f[Db+8>>2]=f[x>>2];f[Db+12>>2]=f[J>>2];$b=f[C>>2]|0;ac=f[Db+44>>2]|0;f[ac>>2]=f[$b>>2];f[ac+4>>2]=f[$b+4>>2]}while(0);if((wb|0)==155){wb=0;ZS(Db,k)}f[Vb>>2]=f[H>>2];f[Db+20>>2]=f[K>>2];f[Db+24>>2]=f[L>>2];f[Db+28>>2]=f[M>>2];f[Db+32>>2]=f[N>>2];f[Lb>>2]=f[G>>2]}Ub=f[G>>2]|0;do if(Ub|0){$b=Ub+12|0;ac=f[$b>>2]|0;f[$b>>2]=ac+-1;if((ac|0)!=1)break;_S(k)}while(0);f[G>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[z>>2]|0)>0){Ub=f[A>>2]|0;Lb=0;do{f[Ub+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[z>>2]|0))}Lb=f[C>>2]|0;if((Lb|0)!=(y|0))g0(Lb);ZGa(e,a,f[xb>>2]|0);Lb=f[ub>>2]|0;Ub=f[e>>2]|0;Db=f[I>>2]|0;if(Ub|0){Vb=Ub+4|0;f[Vb>>2]=(f[Vb>>2]|0)+1}Vb=f[Lb>>2]|0;f[Lb>>2]=Ub;f[Lb+4>>2]=Db;do if(Vb|0){Db=Vb+4|0;Lb=f[Db>>2]|0;f[Db>>2]=Lb+-1;if((Lb|0)!=1)break;Yi[f[(f[Vb>>2]|0)+8>>2]&2047](Vb)}while(0);Vb=f[e>>2]|0;do if(Vb|0){Lb=Vb+4|0;Db=f[Lb>>2]|0;f[Lb>>2]=Db+-1;if((Db|0)!=1)break;Yi[f[(f[Vb>>2]|0)+8>>2]&2047](Vb)}while(0);Vb=(Eb|0)==(mb|0);if(!Vb)XGa(Eb+152|0,f[xb>>2]|0,f[Tb>>2]|0);Db=(Mb|0)==(mb|0);if(!Db)XGa(Mb+152|0,f[xb>>2]|0,f[Tb>>2]|0);if(!Vb)NGa(Eb+108|0,f[ub>>2]|0,f[Xb>>2]|0);if(!Db)NGa(Mb+108|0,f[ub>>2]|0,f[Xb>>2]|0);Db=Mb+96|0;Vb=Mb+100|0;Lb=f[Db>>2]|0;if((f[Vb>>2]|0)==(Lb|0))break;else{cc=0;dc=Lb}do{Lb=AGa(r,dc+(cc<<3)|0)|0;Ub=f[Lb+64>>2]|0;ac=f[Lb+60>>2]|0;$b=ac;h:do if((Ub|0)!=(ac|0)){ec=f[h>>2]|0;fc=Ub-ac>>3;gc=0;while(1){if((f[$b+(gc<<3)>>2]|0)==(ec|0))break;hc=gc+1|0;if(hc>>>0<fc>>>0)gc=hc;else break h}f[(f[Lb+164>>2]|0)+(gc<<2)>>2]=f[xb>>2];fc=f[ub>>2]|0;ec=f[Lb+120>>2]|0;hc=ec+(gc<<3)|0;ic=f[fc>>2]|0;jc=f[fc+4>>2]|0;if(ic|0){fc=ic+4|0;f[fc>>2]=(f[fc>>2]|0)+1}fc=f[hc>>2]|0;f[hc>>2]=ic;f[ec+(gc<<3)+4>>2]=jc;if(!fc)break;jc=fc+4|0;ec=f[jc>>2]|0;f[jc>>2]=ec+-1;if((ec|0)!=1)break;Yi[f[(f[fc>>2]|0)+8>>2]&2047](fc)}while(0);cc=cc+1|0;dc=f[Db>>2]|0}while(cc>>>0<(f[Vb>>2]|0)-dc>>3>>>0)}while(0);Mb=f[i>>2]|0;do if(Mb|0){vb=Mb+4|0;zb=f[vb>>2]|0;f[vb>>2]=zb+-1;if((zb|0)!=1)break;Yi[f[(f[Mb>>2]|0)+8>>2]&2047](Mb)}while(0)}while(0);Ab=Kb;if(!Kb)break;Mb=Ab+4|0;zb=f[Mb>>2]|0;f[Mb>>2]=zb+-1;if((zb|0)!=1)break;Yi[f[(f[Kb>>2]|0)+8>>2]&2047](Ab)}}while(0)}while(0);if((f[p>>2]|0)==3){sb=mb+148|0;rb=f[sb>>2]|0;if(!rb)kc=0;else kc=bFc(rb,14104,14224,0)|0;rb=f[ob>>2]|0;ub=(rb|0)==0;if(!ub){xb=rb+4|0;f[xb>>2]=(f[xb>>2]|0)+1}i:do if(kc|0?(xb=f[pb>>2]|0,tb=f[qb>>2]|0,(xb|0)!=(tb|0)):0){Ab=tb-xb>>3;if(Ab|0){tb=0;do{if((f[xb+(tb<<3)+4>>2]|0)>0)break i;tb=tb+1|0}while(tb>>>0<Ab>>>0)}b[kc+81>>0]=0}while(0);qb=f[sb>>2]|0;if(!qb)lc=0;else lc=bFc(qb,14104,14240,0)|0;qb=f[ob>>2]|0;pb=(qb|0)==0;if(!pb){Ab=qb+4|0;f[Ab>>2]=(f[Ab>>2]|0)+1}if(((lc|0?(f[lc+36>>2]|0)==1:0)?(b[lc+40>>0]|0)==0:0)?(Ab=f[mb+152>>2]|0,tb=Ab,((f[mb+156>>2]|0)-Ab|0)==56):0){f[h>>2]=1124007936;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;f[P+24>>2]=0;f[U>>2]=Q;f[W>>2]=V;f[X>>2]=0;f[V>>2]=0;Ab=mb+108|0;do if((f[Ab>>2]|0)==(f[mb+112>>2]|0))wb=265;else{if((f[p>>2]|0)!=3){wb=265;break}if(((f[v>>2]|0)+-1|0)>>>0>=2){wb=265;break}xb=mb+60|0;zb=f[xb>>2]|0;Mb=(f[mb+64>>2]|0)-zb>>3;if(Mb|0){vb=1;Vb=0;Db=zb;while(1){zb=Db+(Vb<<3)|0;Xb=f[zb+4>>2]|0;Tb=e;f[Tb>>2]=f[zb>>2];f[Tb+4>>2]=Xb;while(1){mc=AGa(r,e)|0;if(!(b[mc+200>>0]|0))break;Xb=f[mc+60>>2]|0;if(((f[mc+64>>2]|0)-Xb|0)!=8)break;if(((f[mc+100>>2]|0)-(f[mc+96>>2]|0)|0)!=8)break;Tb=Xb;Xb=f[Tb+4>>2]|0;zb=e;f[zb>>2]=f[Tb>>2];f[zb+4>>2]=Xb}if(vb){oGa(l,mc);Xb=f[(f[kb>>2]|0)+24>>2]|0;if((Xb|0)==455045)nc=1;else nc=(Ioc((Xb|0)==0?1154740:Xb,455045)|0)==0;Xb=f[l>>2]|0;do if(Xb|0){zb=Xb+4|0;Tb=f[zb>>2]|0;f[zb>>2]=Tb+-1;if((Tb|0)!=1)break;Yi[f[(f[Xb>>2]|0)+8>>2]&2047](Xb)}while(0);f[l>>2]=0;f[kb>>2]=0;oc=nc}else oc=0;Xb=Vb+1|0;if(Xb>>>0>=Mb>>>0)break;vb=oc;Vb=Xb;Db=f[xb>>2]|0}if(!oc)break}f[e>>2]=0;f[hb>>2]=0;f[ib>>2]=0;CGa(i,Ab);_Ga(e,f[i>>2]|0,f[jb>>2]|0);xb=f[i>>2]|0;if(xb|0){while(1){Db=f[jb>>2]|0;if((Db|0)==(xb|0))break;Vb=Db+-48|0;f[jb>>2]=Vb;GQ(Vb)}YDc(f[i>>2]|0)}xb=f[e>>2]|0;if((h|0)!=(xb|0)){Vb=xb+24|0;Db=f[Vb>>2]|0;if(Db|0){vb=Db+8|0;f[vb>>2]=(f[vb>>2]|0)+1}vb=f[S>>2]|0;do if(vb|0){Db=vb+8|0;Mb=f[Db>>2]|0;f[Db>>2]=Mb+-1;if((Mb|0)!=1)break;HQ(h)}while(0);if((f[P>>2]|0)>0){vb=f[U>>2]|0;Mb=0;do{f[vb+(Mb<<2)>>2]=0;Mb=Mb+1|0;pc=f[P>>2]|0}while((Mb|0)<(pc|0));f[S>>2]=0;f[h>>2]=f[xb>>2];if((pc|0)<3)wb=254;else wb=256}else{f[S>>2]=0;f[h>>2]=f[xb>>2];wb=254}do if((wb|0)==254){wb=0;Mb=f[xb+4>>2]|0;if((Mb|0)>=3){wb=256;break}f[P>>2]=Mb;f[Q>>2]=f[xb+8>>2];f[wa>>2]=f[xb+12>>2];Mb=f[xb+36>>2]|0;vb=f[W>>2]|0;f[vb>>2]=f[Mb>>2];f[vb+4>>2]=f[Mb+4>>2]}while(0);if((wb|0)==256){wb=0;FQ(h,xb)}f[ya>>2]=f[xb+16>>2];if(!(f[R>>2]|0))f[R>>2]=f[xb+20>>2];f[S>>2]=f[Vb>>2];f[T>>2]=f[xb+28>>2];Mb=f[e>>2]|0;if(Mb|0){qc=Mb;wb=260}}else{qc=h;wb=260}if((wb|0)==260){wb=0;while(1){Mb=f[hb>>2]|0;if((Mb|0)==(qc|0))break;vb=Mb+-48|0;f[hb>>2]=vb;GQ(vb)}YDc(f[e>>2]|0)}wb=265}while(0);do if((wb|0)==265){wb=0;ob=tb+4|0;if((f[ob>>2]|0)!=4)break;sb=tb+40|0;if((f[f[sb>>2]>>2]|0)!=1)break;xb=mb+60|0;Vb=(f[mb+64>>2]|0)-(f[xb>>2]|0)|0;vb=Vb>>3;f[i>>2]=0;f[Y>>2]=0;f[Z>>2]=0;Mb=(vb|0)==0;j:do if(Mb)wb=279;else{if(vb>>>0>536870911){wb=269;break b}Db=VDc(Vb)|0;f[i>>2]=Db;Xb=Db+(vb<<3)|0;f[_>>2]=Xb;XIc(Db|0,-1,Vb|0)|0;f[Y>>2]=Xb;Xb=0;k:while(1){Db=(f[xb>>2]|0)+(Xb<<3)|0;Tb=f[Db+4>>2]|0;zb=e;f[zb>>2]=f[Db>>2];f[zb+4>>2]=Tb;while(1){rc=AGa(r,e)|0;if(!(b[rc+200>>0]|0))break;Tb=f[rc+60>>2]|0;if(((f[rc+64>>2]|0)-Tb|0)!=8)break k;if(((f[rc+100>>2]|0)-(f[rc+96>>2]|0)|0)!=8)break k;zb=Tb;Tb=f[zb+4>>2]|0;Db=e;f[Db>>2]=f[zb>>2];f[Db+4>>2]=Tb}if(((f[rc+100>>2]|0)-(f[rc+96>>2]|0)|0)!=8)break;Tb=e;Db=f[Tb+4>>2]|0;zb=(f[i>>2]|0)+(Xb<<3)|0;f[zb>>2]=f[Tb>>2];f[zb+4>>2]=Db;Xb=Xb+1|0;if(Xb>>>0>=vb>>>0){wb=279;break j}}}while(0);if((wb|0)==279){wb=0;f[k>>2]=1124007936;Zb=$;_b=Zb+36|0;do{f[Zb>>2]=0;Zb=Zb+4|0}while((Zb|0)<(_b|0));f[ba>>2]=aa;f[da>>2]=ca;f[ca>>2]=0;f[ea>>2]=0;xb=fa;f[xb>>2]=0;f[xb+4>>2]=0;f[e>>2]=33619968;f[ga>>2]=k;h_(tb,e);if((tb|0)!=(k|0)){xb=f[ha>>2]|0;if(xb|0){Vb=xb+12|0;f[Vb>>2]=(f[Vb>>2]|0)+1}Vb=tb+36|0;xb=f[Vb>>2]|0;do if(xb|0){Xb=xb+12|0;Db=f[Xb>>2]|0;f[Xb>>2]=Db+-1;if((Db|0)!=1)break;_S(tb)}while(0);f[Vb>>2]=0;xb=tb+16|0;f[xb>>2]=0;f[xb+4>>2]=0;f[xb+8>>2]=0;f[xb+12>>2]=0;if((f[ob>>2]|0)>0){Db=f[sb>>2]|0;Xb=0;do{f[Db+(Xb<<2)>>2]=0;Xb=Xb+1|0;sc=f[ob>>2]|0}while((Xb|0)<(sc|0));f[tb>>2]=f[k>>2];if((sc|0)<3)wb=290;else wb=292}else{f[tb>>2]=f[k>>2];wb=290}do if((wb|0)==290){wb=0;Xb=f[$>>2]|0;if((Xb|0)>=3){wb=292;break}f[ob>>2]=Xb;f[tb+8>>2]=f[aa>>2];f[tb+12>>2]=f[cb>>2];Xb=f[da>>2]|0;Db=f[tb+44>>2]|0;f[Db>>2]=f[Xb>>2];f[Db+4>>2]=f[Xb+4>>2]}while(0);if((wb|0)==292){wb=0;ZS(tb,k)}f[xb>>2]=f[ia>>2];f[tb+20>>2]=f[db>>2];f[tb+24>>2]=f[eb>>2];f[tb+28>>2]=f[fb>>2];f[tb+32>>2]=f[gb>>2];f[Vb>>2]=f[ha>>2]}ob=f[ha>>2]|0;do if(ob|0){Xb=ob+12|0;Db=f[Xb>>2]|0;f[Xb>>2]=Db+-1;if((Db|0)!=1)break;_S(k)}while(0);f[ha>>2]=0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[$>>2]|0)>0){ob=f[ba>>2]|0;Vb=0;do{f[ob+(Vb<<2)>>2]=0;Vb=Vb+1|0}while((Vb|0)<(f[$>>2]|0))}Vb=f[da>>2]|0;if((Vb|0)!=(ca|0))g0(Vb);do if((f[p>>2]|0)==3){if(((f[v>>2]|0)+-1|0)>>>0>=2)break;f[k>>2]=0;f[ja>>2]=0;f[ka>>2]=0;Vb=VDc(48)|0;f[k>>2]=Vb;ob=Vb+48|0;f[la>>2]=ob;f[Vb>>2]=1124007936;xb=Vb+4|0;f[xb>>2]=0;f[xb+4>>2]=0;f[xb+8>>2]=0;f[xb+12>>2]=0;f[xb+16>>2]=0;f[xb+20>>2]=0;f[xb+24>>2]=0;f[Vb+32>>2]=Vb+8;xb=Vb+40|0;f[Vb+36>>2]=xb;f[Vb+44>>2]=0;f[xb>>2]=0;f[ja>>2]=ob;f[m>>2]=1124007936;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;f[ma+16>>2]=0;f[ma+20>>2]=0;f[ma+24>>2]=0;f[oa>>2]=na;f[qa>>2]=pa;f[ra>>2]=0;f[pa>>2]=0;ob=sa;f[ob>>2]=0;f[ob+4>>2]=0;f[e>>2]=34209792;f[ta>>2]=m;NQ(h,e);ob=f[ua>>2]|0;if(ob|0){xb=ob+8|0;f[xb>>2]=(f[xb>>2]|0)+1}xb=f[S>>2]|0;do if(xb|0){ob=xb+8|0;Vb=f[ob>>2]|0;f[ob>>2]=Vb+-1;if((Vb|0)!=1)break;HQ(h)}while(0);if((f[P>>2]|0)>0){xb=f[U>>2]|0;Vb=0;do{f[xb+(Vb<<2)>>2]=0;Vb=Vb+1|0;tc=f[P>>2]|0}while((Vb|0)<(tc|0));f[S>>2]=0;f[h>>2]=f[m>>2];if((tc|0)<3)wb=314;else wb=316}else{f[S>>2]=0;f[h>>2]=f[m>>2];wb=314}do if((wb|0)==314){wb=0;Vb=f[ma>>2]|0;if((Vb|0)>=3){wb=316;break}f[P>>2]=Vb;f[Q>>2]=f[na>>2];f[wa>>2]=f[va>>2];Vb=f[qa>>2]|0;xb=f[W>>2]|0;f[xb>>2]=f[Vb>>2];f[xb+4>>2]=f[Vb+4>>2]}while(0);if((wb|0)==316){wb=0;FQ(h,m)}f[ya>>2]=f[xa>>2];if(!(f[R>>2]|0))f[R>>2]=f[za>>2];f[S>>2]=f[ua>>2];f[T>>2]=f[Aa>>2];GQ(m);Vb=f[k>>2]|0;if((Vb|0)!=(h|0)){xb=f[S>>2]|0;if(xb|0){ob=xb+8|0;f[ob>>2]=(f[ob>>2]|0)+1}ob=Vb+24|0;xb=f[ob>>2]|0;do if(xb|0){Db=xb+8|0;Xb=f[Db>>2]|0;f[Db>>2]=Xb+-1;if((Xb|0)!=1)break;HQ(Vb)}while(0);xb=Vb+4|0;if((f[xb>>2]|0)>0){Xb=f[Vb+32>>2]|0;Db=0;do{f[Xb+(Db<<2)>>2]=0;Db=Db+1|0;uc=f[xb>>2]|0}while((Db|0)<(uc|0));f[ob>>2]=0;f[Vb>>2]=f[h>>2];if((uc|0)<3)wb=330;else wb=332}else{f[ob>>2]=0;f[Vb>>2]=f[h>>2];wb=330}do if((wb|0)==330){wb=0;Db=f[P>>2]|0;if((Db|0)>=3){wb=332;break}f[xb>>2]=Db;f[Vb+8>>2]=f[Q>>2];f[Vb+12>>2]=f[wa>>2];Db=f[W>>2]|0;Xb=f[Vb+36>>2]|0;f[Xb>>2]=f[Db>>2];f[Xb+4>>2]=f[Db+4>>2]}while(0);if((wb|0)==332){wb=0;FQ(Vb,h)}f[Vb+16>>2]=f[ya>>2];xb=Vb+20|0;if(!(f[xb>>2]|0))f[xb>>2]=f[R>>2];f[ob>>2]=f[S>>2];f[Vb+28>>2]=f[T>>2]}FGa(Ab,k);xb=f[k>>2]|0;if(xb|0){while(1){Db=f[ja>>2]|0;if((Db|0)==(xb|0))break;Xb=Db+-48|0;f[ja>>2]=Xb;GQ(Xb)}YDc(f[k>>2]|0)}}while(0);f[e>>2]=-2147483648;f[Ba>>2]=2147483647;f[Ca>>2]=-2147483648;f[Da>>2]=2147483647;f[Ea>>2]=-2147483648;f[Fa>>2]=2147483647;f[Ga>>2]=-2147483648;f[Ha>>2]=2147483647;if(!Mb){xb=mb+164|0;Vb=0;ob=0;do{Xb=(f[i>>2]|0)+(ob<<3)|0;Db=f[Xb+4>>2]|0;sb=k;f[sb>>2]=f[Xb>>2];f[sb+4>>2]=Db;Db=AGa(r,k)|0;sb=Vb;Vb=(f[(f[(f[(f[xb>>2]|0)+(ob<<2)>>2]|0)+40>>2]|0)+4>>2]|0)+Vb|0;Xb=Ca;f[Xb>>2]=sb;f[Xb+4>>2]=Vb;aT(m,tb,e);Xb=f[Ia>>2]|0;sb=f[Db+152>>2]|0;zb=sb+(Xb*56|0)|0;if(!(f[m>>2]&16384)){wb=351;break b}Tb=f[Ja>>2]|0;Lb=f[Tb+-4>>2]|0;$b=sb+(Xb*56|0)+40|0;ac=f[$b>>2]|0;if((Lb|0)!=(f[ac+-4>>2]|0)){wb=351;break b}do if((Lb|0)==2){if((f[Tb>>2]|0)!=(f[ac>>2]|0)){wb=351;break b}if((f[Tb+4>>2]|0)!=(f[ac+4>>2]|0)){wb=351;break b}}else{if((Lb|0)>0)vc=0;else break;do{if((f[Tb+(vc<<2)>>2]|0)!=(f[ac+(vc<<2)>>2]|0)){wb=351;break b}vc=vc+1|0}while((vc|0)<(Lb|0))}while(0);if((zb|0)!=(m|0)){Lb=f[Ua>>2]|0;if(Lb|0){ac=Lb+12|0;f[ac>>2]=(f[ac>>2]|0)+1}ac=sb+(Xb*56|0)+36|0;Lb=f[ac>>2]|0;do if(Lb|0){Tb=Lb+12|0;Ub=f[Tb>>2]|0;f[Tb>>2]=Ub+-1;if((Ub|0)!=1)break;_S(zb)}while(0);f[ac>>2]=0;Lb=sb+(Xb*56|0)+16|0;Ub=sb+(Xb*56|0)+4|0;f[Lb>>2]=0;f[Lb+4>>2]=0;f[Lb+8>>2]=0;f[Lb+12>>2]=0;if((f[Ub>>2]|0)>0){Tb=f[$b>>2]|0;fc=0;do{f[Tb+(fc<<2)>>2]=0;fc=fc+1|0;wc=f[Ub>>2]|0}while((fc|0)<(wc|0));f[zb>>2]=f[m>>2];if((wc|0)<3)wb=363;else wb=365}else{f[zb>>2]=f[m>>2];wb=363}do if((wb|0)==363){wb=0;fc=f[Va>>2]|0;if((fc|0)>=3){wb=365;break}f[Ub>>2]=fc;f[sb+(Xb*56|0)+8>>2]=f[Ya>>2];f[sb+(Xb*56|0)+12>>2]=f[Za>>2];fc=f[Wa>>2]|0;Tb=f[sb+(Xb*56|0)+44>>2]|0;f[Tb>>2]=f[fc>>2];f[Tb+4>>2]=f[fc+4>>2]}while(0);if((wb|0)==365){wb=0;ZS(zb,m)}f[Lb>>2]=f[Ta>>2];f[sb+(Xb*56|0)+20>>2]=f[_a>>2];f[sb+(Xb*56|0)+24>>2]=f[$a>>2];f[sb+(Xb*56|0)+28>>2]=f[ab>>2];f[sb+(Xb*56|0)+32>>2]=f[bb>>2];f[ac>>2]=f[Ua>>2]}do if((f[p>>2]|0)==3){if(((f[v>>2]|0)+-1|0)>>>0>=2)break;Ub=Db+108|0;GGa(n,(f[Db+112>>2]|0)-(f[Ub>>2]|0)>>3);JQ(o,h,e);fc=f[Ia>>2]|0;Tb=f[n>>2]|0;$b=Tb+(fc*48|0)|0;if(($b|0)!=(o|0)){ec=f[La>>2]|0;if(ec|0){jc=ec+8|0;f[jc>>2]=(f[jc>>2]|0)+1}jc=Tb+(fc*48|0)+24|0;ec=f[jc>>2]|0;do if(ec|0){ic=ec+8|0;hc=f[ic>>2]|0;f[ic>>2]=hc+-1;if((hc|0)!=1)break;HQ($b)}while(0);ec=Tb+(fc*48|0)+4|0;if((f[ec>>2]|0)>0){hc=f[Tb+(fc*48|0)+32>>2]|0;ic=0;do{f[hc+(ic<<2)>>2]=0;ic=ic+1|0;xc=f[ec>>2]|0}while((ic|0)<(xc|0));f[jc>>2]=0;f[$b>>2]=f[o>>2];if((xc|0)<3)wb=380;else wb=382}else{f[jc>>2]=0;f[$b>>2]=f[o>>2];wb=380}do if((wb|0)==380){wb=0;ic=f[Ma>>2]|0;if((ic|0)>=3){wb=382;break}f[ec>>2]=ic;f[Tb+(fc*48|0)+8>>2]=f[Na>>2];f[Tb+(fc*48|0)+12>>2]=f[Oa>>2];ic=f[Pa>>2]|0;hc=f[Tb+(fc*48|0)+36>>2]|0;f[hc>>2]=f[ic>>2];f[hc+4>>2]=f[ic+4>>2]}while(0);if((wb|0)==382){wb=0;FQ($b,o)}f[Tb+(fc*48|0)+16>>2]=f[Qa>>2];ec=Tb+(fc*48|0)+20|0;if(!(f[ec>>2]|0))f[ec>>2]=f[Ra>>2];f[jc>>2]=f[La>>2];f[Tb+(fc*48|0)+28>>2]=f[Sa>>2]}GQ(o);FGa(Ub,n);ec=f[n>>2]|0;if(ec|0){while(1){ic=f[Ka>>2]|0;if((ic|0)==(ec|0))break;hc=ic+-48|0;f[Ka>>2]=hc;GQ(hc)}YDc(f[n>>2]|0)}}while(0);if((f[sb+(Xb*56|0)+16>>2]|0)!=(f[Ta>>2]|0)){wb=392;break b}Db=f[Ua>>2]|0;do if(Db|0){ac=Db+12|0;Lb=f[ac>>2]|0;f[ac>>2]=Lb+-1;if((Lb|0)!=1)break;_S(m)}while(0);f[Ua>>2]=0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[Va>>2]|0)>0){Db=f[Ja>>2]|0;Xb=0;do{f[Db+(Xb<<2)>>2]=0;Xb=Xb+1|0}while((Xb|0)<(f[Va>>2]|0))}Xb=f[Wa>>2]|0;if((Xb|0)!=(Xa|0))g0(Xb);ob=ob+1|0}while(ob>>>0<vb>>>0)}b[nb>>0]=1}vb=f[i>>2]|0;if(vb|0){ob=f[Y>>2]|0;if((ob|0)!=(vb|0))f[Y>>2]=ob+(~((ob+-8-vb|0)>>>3)<<3);YDc(vb)}}while(0);GQ(h)}tb=qb;if(!pb?(Ab=tb+4|0,vb=f[Ab>>2]|0,f[Ab>>2]=vb+-1,(vb|0)==1):0)Yi[f[(f[qb>>2]|0)+8>>2]&2047](tb);tb=rb;if(!ub?(vb=tb+4|0,Ab=f[vb>>2]|0,f[vb>>2]=Ab+-1,(Ab|0)==1):0)Yi[f[(f[rb>>2]|0)+8>>2]&2047](tb)}}while(0);nb=f[lb+4>>2]|0;if(!nb){mb=lb+8|0;tb=f[mb>>2]|0;if((f[tb>>2]|0)==(lb|0))yc=tb;else{tb=mb;do{mb=f[tb>>2]|0;tb=mb+8|0;Ab=f[tb>>2]|0}while((f[Ab>>2]|0)!=(mb|0));yc=Ab}}else{tb=nb;while(1){Ab=f[tb>>2]|0;if(!Ab)break;else tb=Ab}yc=tb}if((yc|0)==(s|0)){zc=t;break a}else lb=yc}if((wb|0)==130){f[e>>2]=0;f[e+4>>2]=0;Zb=tT(e,46)|0;Ac=379894;_b=Zb+46|0;do{b[Zb>>0]=b[Ac>>0]|0;Zb=Zb+1|0;Ac=Ac+1|0}while((Zb|0)<(_b|0));z5(-215,e,379883,376410,1870)}else if((wb|0)==132){f[e>>2]=0;f[e+4>>2]=0;Zb=tT(e,33)|0;Ac=379941;_b=Zb+33|0;do{b[Zb>>0]=b[Ac>>0]|0;Zb=Zb+1|0;Ac=Ac+1|0}while((Zb|0)<(_b|0));z5(-215,e,379883,376410,1870)}else if((wb|0)==139){f[e>>2]=0;f[e+4>>2]=0;Zb=tT(e,26)|0;Ac=379975;_b=Zb+26|0;do{b[Zb>>0]=b[Ac>>0]|0;Zb=Zb+1|0;Ac=Ac+1|0}while((Zb|0)<(_b|0));z5(-215,e,379883,376410,1891)}else if((wb|0)==141){f[e>>2]=0;f[e+4>>2]=0;Zb=tT(e,34)|0;Ac=380002;_b=Zb+34|0;do{b[Zb>>0]=b[Ac>>0]|0;Zb=Zb+1|0;Ac=Ac+1|0}while((Zb|0)<(_b|0));z5(-215,e,379883,376410,1891)}else if((wb|0)==269)mCc(i);else if((wb|0)==351){f[n>>2]=0;f[n+4>>2]=0;Zb=tT(n,68)|0;Ac=380037;_b=Zb+68|0;do{b[Zb>>0]=b[Ac>>0]|0;Zb=Zb+1|0;Ac=Ac+1|0}while((Zb|0)<(_b|0));z5(-215,n,379883,376410,2037)}else if((wb|0)==392){f[n>>2]=0;f[n+4>>2]=0;Zb=tT(n,37)|0;Ac=380106;_b=Zb+37|0;do{b[Zb>>0]=b[Ac>>0]|0;Zb=Zb+1|0;Ac=Ac+1|0}while((Zb|0)<(_b|0));z5(-215,n,379883,376410,2048)}else if((wb|0)==430){f[e>>2]=0;f[e+4>>2]=0;Zb=tT(e,13)|0;Ac=379869;_b=Zb+13|0;do{b[Zb>>0]=b[Ac>>0]|0;Zb=Zb+1|0;Ac=Ac+1|0}while((Zb|0)<(_b|0));z5(-215,e,379883,376410,1851)}}else zc=t;while(0);WGa(j,f[zc>>2]|0);u=d;return}function UGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!b)return;UGa(a,f[b>>2]|0);UGa(a,f[b+4>>2]|0);a=b+44|0;c=f[a>>2]|0;if(c|0){d=b+48|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-4-i|0)>>>2)<<2);YDc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[a>>2]|0}YDc(g)}g=b+32|0;a=f[g>>2]|0;if(a|0){j=b+36|0;h=f[j>>2]|0;if((h|0)==(a|0))l=a;else{c=h;while(1){h=c+-12|0;f[j>>2]=h;d=f[h>>2]|0;if(!d)m=h;else{h=c+-8|0;i=f[h>>2]|0;if((i|0)!=(d|0))f[h>>2]=i+(~((i+-4-d|0)>>>2)<<2);YDc(d);m=f[j>>2]|0}if((m|0)==(a|0))break;else c=m}l=f[g>>2]|0}YDc(l)}l=b+20|0;g=f[l>>2]|0;if(g|0){m=b+24|0;c=f[m>>2]|0;if((c|0)==(g|0))n=g;else{a=c;while(1){c=a+-12|0;f[m>>2]=c;j=f[c>>2]|0;if(!j)o=c;else{c=a+-8|0;d=f[c>>2]|0;if((d|0)!=(j|0))f[c>>2]=d+(~((d+-4-j|0)>>>2)<<2);YDc(j);o=f[m>>2]|0}if((o|0)==(g|0))break;else a=o}n=f[l>>2]|0}YDc(n)}YDc(b);return}function VGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=a+4|0;h=f[b>>2]|0;b=h;do if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){k=(i|0)==(j|0);if(k?(f[e+4>>2]|0)<(f[h+20>>2]|0):0)break;do if((j|0)>=(i|0)){if(k?(f[h+20>>2]|0)<(f[e+4>>2]|0):0)break;f[c>>2]=b;f[d>>2]=b;l=d;return l|0}while(0);k=h+4|0;j=f[k>>2]|0;if(!j){m=h+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(h|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=j;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}do if((o|0)!=(g|0)?(j=f[o+16>>2]|0,(i|0)>=(j|0)):0){if((i|0)==(j|0)?(f[e+4>>2]|0)<(f[o+20>>2]|0):0)break;j=f[g>>2]|0;if(!j){f[c>>2]=g;l=g;return l|0}p=f[e+4>>2]|0;m=a+4|0;q=j;a:while(1){j=f[q+16>>2]|0;do if((i|0)>=(j|0)){r=(i|0)==(j|0);if(r?(p|0)<(f[q+20>>2]|0):0){s=51;break}if((j|0)>=(i|0)){if(!r){s=58;break a}if((f[q+20>>2]|0)>=(p|0)){s=58;break a}}t=q+4|0;r=f[t>>2]|0;if(!r){s=57;break a}else{u=t;v=r}}else s=51;while(0);if((s|0)==51){s=0;j=f[q>>2]|0;if(!j){s=52;break}else{u=q;v=j}}m=u;q=v}if((s|0)==52){f[c>>2]=q;l=q;return l|0}else if((s|0)==57){f[c>>2]=q;l=t;return l|0}else if((s|0)==58){f[c>>2]=q;l=m;return l|0}}while(0);if(!(f[h+4>>2]|0)){f[c>>2]=b;l=k;return l|0}else{f[c>>2]=o;l=o;return l|0}}while(0);o=f[h>>2]|0;do if((h|0)!=(f[a>>2]|0)){if(!o){t=h;while(1){v=f[t+8>>2]|0;if((f[v>>2]|0)==(t|0))t=v;else{w=v;break}}}else{t=o;while(1){k=f[t+4>>2]|0;if(!k){w=t;break}else t=k}}t=w;k=f[w+16>>2]|0;v=f[e>>2]|0;if((k|0)>=(v|0)){if((k|0)==(v|0)?(f[w+20>>2]|0)<(f[e+4>>2]|0):0){x=t;break}k=f[g>>2]|0;if(!k){f[c>>2]=g;l=g;return l|0}u=f[e+4>>2]|0;d=a+4|0;i=k;b:while(1){k=f[i+16>>2]|0;do if((v|0)>=(k|0)){n=(v|0)==(k|0);if(n?(u|0)<(f[i+20>>2]|0):0){s=21;break}if((k|0)>=(v|0)){if(!n){s=28;break b}if((f[i+20>>2]|0)>=(u|0)){s=28;break b}}y=i+4|0;n=f[y>>2]|0;if(!n){s=27;break b}else{z=y;A=n}}else s=21;while(0);if((s|0)==21){s=0;k=f[i>>2]|0;if(!k){s=22;break}else{z=i;A=k}}d=z;i=A}if((s|0)==22){f[c>>2]=i;l=i;return l|0}else if((s|0)==27){f[c>>2]=i;l=y;return l|0}else if((s|0)==28){f[c>>2]=i;l=d;return l|0}}else x=t}else x=b;while(0);if(!o){f[c>>2]=h;l=h;return l|0}else{h=x;f[c>>2]=h;l=h+4|0;return l|0}return 0}function WGa(a,b){a=a|0;b=b|0;if(!b)return;else{WGa(a,f[b>>2]|0);WGa(a,f[b+4>>2]|0);YDc(b);return}}function XGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/56|0;e=a+8|0;g=f[a>>2]|0;h=g;if(d>>>0>(((f[e>>2]|0)-g|0)/56|0)>>>0){hHa(a);if(d>>>0>76695844)mCc(a);i=((f[e>>2]|0)-(f[a>>2]|0)|0)/56|0;j=i<<1;k=i>>>0<38347922?(j>>>0<d>>>0?d:j):76695844;if(k>>>0>76695844)mCc(a);j=VDc(k*56|0)|0;i=a+4|0;f[i>>2]=j;f[a>>2]=j;f[e>>2]=j+(k*56|0);if((b|0)==(c|0))return;k=b;e=j;do{f[e>>2]=f[k>>2];j=e+4|0;l=k+4|0;f[j>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[e+16>>2]=f[k+16>>2];f[e+20>>2]=f[k+20>>2];f[e+24>>2]=f[k+24>>2];f[e+28>>2]=f[k+28>>2];f[e+32>>2]=f[k+32>>2];n=f[k+36>>2]|0;f[e+36>>2]=n;f[e+40>>2]=m;m=e+48|0;o=e+44|0;f[o>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[k+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2]}else{f[j>>2]=0;ZS(e,k)}k=k+56|0;e=(f[i>>2]|0)+56|0;f[i>>2]=e}while((k|0)!=(c|0));return}k=a+4|0;a=((f[k>>2]|0)-g|0)/56|0;g=d>>>0>a>>>0;d=b+(a*56|0)|0;a=g?d:c;if((a|0)==(b|0))p=h;else{e=h;h=b;while(1){if((e|0)!=(h|0)){b=h+36|0;i=f[b>>2]|0;if(i|0){j=i+12|0;f[j>>2]=(f[j>>2]|0)+1}j=e+36|0;i=f[j>>2]|0;if(i|0?(l=i+12|0,i=f[l>>2]|0,f[l>>2]=i+-1,(i|0)==1):0)_S(e);f[j>>2]=0;i=e+16|0;l=e+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[l>>2]|0)>0){m=f[e+40>>2]|0;o=0;do{f[m+(o<<2)>>2]=0;o=o+1|0;q=f[l>>2]|0}while((o|0)<(q|0));f[e>>2]=f[h>>2];if((q|0)<3)r=14;else r=16}else{f[e>>2]=f[h>>2];r=14}if((r|0)==14){r=0;o=f[h+4>>2]|0;if((o|0)<3){f[l>>2]=o;f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];o=f[h+44>>2]|0;m=f[e+44>>2]|0;f[m>>2]=f[o>>2];f[m+4>>2]=f[o+4>>2]}else r=16}if((r|0)==16){r=0;ZS(e,h)}f[i>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];f[j>>2]=f[b>>2]}h=h+56|0;o=e+56|0;if((h|0)==(a|0)){p=o;break}else e=o}}if(g){if((a|0)==(c|0))return;a=d;d=f[k>>2]|0;do{f[d>>2]=f[a>>2];g=d+4|0;e=a+4|0;f[g>>2]=f[e>>2];h=d+8|0;f[h>>2]=f[a+8>>2];f[d+12>>2]=f[a+12>>2];f[d+16>>2]=f[a+16>>2];f[d+20>>2]=f[a+20>>2];f[d+24>>2]=f[a+24>>2];f[d+28>>2]=f[a+28>>2];f[d+32>>2]=f[a+32>>2];r=f[a+36>>2]|0;f[d+36>>2]=r;f[d+40>>2]=h;h=d+48|0;q=d+44|0;f[q>>2]=h;f[h>>2]=0;f[d+52>>2]=0;if(r|0){h=r+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[e>>2]|0)<3){e=f[a+44>>2]|0;h=f[q>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2]}else{f[g>>2]=0;ZS(d,a)}a=a+56|0;d=(f[k>>2]|0)+56|0;f[k>>2]=d}while((a|0)!=(c|0));return}c=f[k>>2]|0;if((c|0)==(p|0))return;else s=c;do{c=s+-56|0;f[k>>2]=c;a=s+-20|0;d=f[a>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)_S(c);f[a>>2]=0;a=s+-40|0;c=s+-52|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[c>>2]|0)>0){a=f[s+-16>>2]|0;d=0;do{f[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[s+-12>>2]|0;if((c|0)!=(s+-8|0))g0(c);s=f[k>>2]|0}while((s|0)!=(p|0));return}function YGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;l=f[b>>2]|0;f[e>>2]=l;f[m+(g<<3)+4>>2]=f[b+4>>2];if(!l){n=j;o=i}else{i=l+4|0;f[i>>2]=(f[i>>2]|0)+1;n=f[c>>2]|0;o=f[a>>2]|0}i=e+8|0;if((n|0)==(o|0)){p=h;q=n;r=n}else{l=n;n=h;h=e;do{e=l;l=l+-8|0;j=f[l>>2]|0;f[h+-8>>2]=j;f[h+-4>>2]=f[e+-4>>2];if(j|0){e=j+4|0;f[e>>2]=(f[e>>2]|0)+1}h=n+-8|0;n=h}while((l|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=i;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=d;d=d+-8|0;i=f[d>>2]|0;if(i|0?(c=i+4|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);f[d>>2]=0;f[r+-4>>2]=0}while((d|0)!=(k|0))}if(!q)return;YDc(q);return}function ZGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=c+80|0;if((f[j>>2]|0)==3?(f[c+84>>2]|0)==0:0){f[a>>2]=0;f[a+4>>2]=0;u=e;return}k=d+4|0;l=f[k>>2]|0;f[g>>2]=0;m=g+4|0;f[m>>2]=0;f[g+8>>2]=0;if(l|0){if(l>>>0>1073741823)mCc(g);n=l<<2;o=VDc(n)|0;f[g>>2]=o;p=o+(l<<2)|0;f[g+8>>2]=p;XIc(o|0,0,n|0)|0;f[m>>2]=p;p=f[d+40>>2]|0;n=0;do{f[o+(n<<2)>>2]=f[p+(n<<2)>>2];n=n+1|0}while((n|0)<(f[k>>2]|0))}k=f[d+16>>2]|0;n=c+100|0;p=c+104|0;o=f[p>>2]|0;if(o){l=k;q=p;r=o;a:while(1){s=r;while(1){if((f[s+16>>2]|0)>>>0>=l>>>0)break;t=f[s+4>>2]|0;if(!t){v=q;break a}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)!=(p|0)?l>>>0>=(f[v+16>>2]|0)>>>0:0){v=c+104|0;q=o;r=o;while(1){o=f[q+16>>2]|0;if(l>>>0<o>>>0){t=f[q>>2]|0;if(!t){w=q;x=24;break}else{y=q;z=t}}else{if(o>>>0>=l>>>0){x=23;break}o=q+4|0;t=f[o>>2]|0;if(!t){w=o;x=24;break}else{y=o;z=t}}v=y;q=z;r=z}if((x|0)==23)if(!r){w=v;x=24}else A=r;if((x|0)==24){r=VDc(28)|0;f[r+16>>2]=k;f[r+20>>2]=0;f[r+24>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=q;f[w>>2]=r;q=f[f[n>>2]>>2]|0;if(!q)B=r;else{f[n>>2]=q;B=f[w>>2]|0}laa(f[c+104>>2]|0,B);B=c+108|0;f[B>>2]=(f[B>>2]|0)+1;A=r}r=f[A+20>>2]|0;f[h>>2]=r;f[h+4>>2]=f[A+24>>2];if(r|0){A=r+4|0;f[A>>2]=(f[A>>2]|0)+1}b:do switch(f[j>>2]|0){case 3:{if(((f[c+84>>2]|0)+-1|0)>>>0<2){A=VDc(68)|0;$Ga(A,h,d);r=VDc(16)|0;f[r+4>>2]=1;f[r>>2]=77948;f[r+8>>2]=A;f[a>>2]=r;f[a+4>>2]=A;C=1;break b}else{f[i>>2]=0;f[i+4>>2]=0;D=tT(i,38)|0;E=380241;F=D+38|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,i,380280,376410,959)}break}case 1:{if(sMa()|0)C=0;else{f[i>>2]=0;f[i+4>>2]=0;D=tT(i,12)|0;E=379751;F=D+12|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-215,i,380280,376410,964)}break}case 2:{aHa(a,2,f[c+84>>2]|0,d);C=1;break}default:{f[i>>2]=0;f[i+4>>2]=0;D=tT(i,26)|0;E=378659;F=D+26|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));z5(-213,i,380280,376410,974)}}while(0);i=f[h>>2]|0;if(i|0?(E=i+4|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);if(!C)x=41}else x=41}else x=41;if((x|0)==41){aHa(h,f[j>>2]|0,f[c+84>>2]|0,d);d=f[p>>2]|0;do if(d){j=k;C=c+104|0;i=d;D=d;while(1){E=f[i+16>>2]|0;if(j>>>0<E>>>0){F=f[i>>2]|0;if(!F){x=46;break}else{G=i;H=F}}else{if(E>>>0>=j>>>0){x=50;break}I=i+4|0;E=f[I>>2]|0;if(!E){x=49;break}else{G=I;H=E}}C=G;i=H;D=H}if((x|0)==46){J=i;K=i;x=53;break}else if((x|0)==49){J=I;K=i;x=53;break}else if((x|0)==50){L=C;M=i;N=D;x=52;break}}else{L=p;M=p;N=d;x=52}while(0);if((x|0)==52)if(!N){J=L;K=M;x=53}else O=N;if((x|0)==53){x=VDc(28)|0;f[x+16>>2]=k;f[x+20>>2]=0;f[x+24>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=K;f[J>>2]=x;K=f[f[n>>2]>>2]|0;if(!K)P=x;else{f[n>>2]=K;P=f[J>>2]|0}laa(f[c+104>>2]|0,P);P=c+108|0;f[P>>2]=(f[P>>2]|0)+1;O=x}x=O+20|0;P=f[h>>2]|0;c=h+4|0;J=f[c>>2]|0;if(P|0){K=P+4|0;f[K>>2]=(f[K>>2]|0)+1}K=f[x>>2]|0;f[x>>2]=P;f[O+24>>2]=J;if(K|0?(J=K+4|0,O=f[J>>2]|0,f[J>>2]=O+-1,(O|0)==1):0)Yi[f[(f[K>>2]|0)+8>>2]&2047](K);K=f[h>>2]|0;f[a>>2]=K;f[a+4>>2]=f[c>>2];c=K;if(!K){Q=h;R=c}else{K=c+4|0;f[K>>2]=(f[K>>2]|0)+1;Q=h;R=f[h>>2]|0}if(R|0?(h=R+4|0,K=f[h>>2]|0,f[h>>2]=K+-1,(K|0)==1):0)Yi[f[(f[R>>2]|0)+8>>2]&2047](R);f[Q>>2]=0}Q=f[g>>2]|0;if(Q|0){g=f[m>>2]|0;if((g|0)!=(Q|0))f[m>>2]=g+(~((g+-4-Q|0)>>>2)<<2);YDc(Q)}u=e;return}function _Ga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=(c-b|0)/48|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>((g-h|0)/48|0)>>>0){if(!h)j=g;else{g=a+4|0;while(1){k=f[g>>2]|0;if((k|0)==(i|0))break;l=k+-48|0;f[g>>2]=l;GQ(l)}YDc(f[a>>2]|0);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>89478485)mCc(a);g=(j|0)/48|0;j=g<<1;l=g>>>0<44739242?(j>>>0<d>>>0?d:j):89478485;if(l>>>0>89478485)mCc(a);j=VDc(l*48|0)|0;g=a+4|0;f[g>>2]=j;f[a>>2]=j;f[e>>2]=j+(l*48|0);if((b|0)==(c|0))return;l=b;e=j;do{f[e>>2]=f[l>>2];j=e+4|0;k=l+4|0;f[j>>2]=f[k>>2];m=e+8|0;f[m>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[e+16>>2]=f[l+16>>2];f[e+20>>2]=f[l+20>>2];n=f[l+24>>2]|0;f[e+24>>2]=n;f[e+28>>2]=f[l+28>>2];f[e+32>>2]=m;m=e+40|0;o=e+36|0;f[o>>2]=m;f[e+44>>2]=0;f[m>>2]=0;if(n|0){m=n+8|0;f[m>>2]=(f[m>>2]|0)+1}if((f[k>>2]|0)<3){k=f[l+36>>2]|0;m=f[o>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2]}else{f[j>>2]=0;FQ(e,l)}l=l+48|0;e=(f[g>>2]|0)+48|0;f[g>>2]=e}while((l|0)!=(c|0));return}l=a+4|0;a=((f[l>>2]|0)-h|0)/48|0;h=d>>>0>a>>>0;d=b+(a*48|0)|0;a=h?d:c;if((a|0)==(b|0))p=i;else{e=i;i=b;while(1){if((e|0)!=(i|0)){b=i+24|0;g=f[b>>2]|0;if(g|0){j=g+8|0;f[j>>2]=(f[j>>2]|0)+1}j=e+24|0;g=f[j>>2]|0;if(g|0?(k=g+8|0,g=f[k>>2]|0,f[k>>2]=g+-1,(g|0)==1):0)HQ(e);g=e+4|0;if((f[g>>2]|0)>0){k=f[e+32>>2]|0;m=0;do{f[k+(m<<2)>>2]=0;m=m+1|0;q=f[g>>2]|0}while((m|0)<(q|0));f[j>>2]=0;f[e>>2]=f[i>>2];if((q|0)<3)r=14;else r=16}else{f[j>>2]=0;f[e>>2]=f[i>>2];r=14}if((r|0)==14){r=0;m=f[i+4>>2]|0;if((m|0)<3){f[g>>2]=m;f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];m=f[i+36>>2]|0;k=f[e+36>>2]|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2]}else r=16}if((r|0)==16){r=0;FQ(e,i)}f[e+16>>2]=f[i+16>>2];m=e+20|0;if(!(f[m>>2]|0))f[m>>2]=f[i+20>>2];f[j>>2]=f[b>>2];f[e+28>>2]=f[i+28>>2]}i=i+48|0;m=e+48|0;if((i|0)==(a|0)){p=m;break}else e=m}}if(!h){while(1){h=f[l>>2]|0;if((h|0)==(p|0))break;e=h+-48|0;f[l>>2]=e;GQ(e)}return}if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{f[d>>2]=f[a>>2];p=d+4|0;e=a+4|0;f[p>>2]=f[e>>2];h=d+8|0;f[h>>2]=f[a+8>>2];f[d+12>>2]=f[a+12>>2];f[d+16>>2]=f[a+16>>2];f[d+20>>2]=f[a+20>>2];i=f[a+24>>2]|0;f[d+24>>2]=i;f[d+28>>2]=f[a+28>>2];f[d+32>>2]=h;h=d+40|0;r=d+36|0;f[r>>2]=h;f[d+44>>2]=0;f[h>>2]=0;if(i|0){h=i+8|0;f[h>>2]=(f[h>>2]|0)+1}if((f[e>>2]|0)<3){e=f[a+36>>2]|0;h=f[r>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2]}else{f[p>>2]=0;FQ(d,a)}a=a+48|0;d=(f[l>>2]|0)+48|0;f[l>>2]=d}while((a|0)!=(c|0));return}function $Ga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+176|0;g=e+160|0;h=e+152|0;i=e+144|0;j=e+48|0;k=e+96|0;l=e;f[a+4>>2]=3;f[a+8>>2]=1;f[a>>2]=77968;m=a+12|0;f[m>>2]=1124007936;n=a+16|0;o=a+20|0;p=a+32|0;q=a+36|0;r=a+40|0;s=a+44|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[s>>2]=o;t=a+52|0;v=a+48|0;f[v>>2]=t;f[a+56>>2]=0;f[t>>2]=0;t=f[c+4>>2]|0;if(!t)w=0;else w=bFc(t,14120,14176,0)|0;t=f[c>>2]|0;c=(t|0)==0;if(!c){x=t+4|0;f[x>>2]=(f[x>>2]|0)+1}if(!w){f[g>>2]=0;f[g+4>>2]=0;x=tT(g,13)|0;y=380428;z=x+13|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,g,380442,376410,259)}y=a+60|0;f[y>>2]=d;f[i>>2]=1;d=i+4|0;x=w+12|0;z=f[w+16>>2]|0;if((z|0)<3)A=Y(f[w+24>>2]|0,f[w+20>>2]|0)|0;else{B=f[w+44>>2]|0;w=0;C=1;while(1){D=Y(f[B+(w<<2)>>2]|0,C)|0;w=w+1|0;if((w|0)==(z|0)){A=D;break}else C=D}}f[d>>2]=A;QQ(l,x,1,2,i);i=f[y>>2]|0;x=f[i+4>>2]|0;if((x|0)<3)E=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{A=f[i+40>>2]|0;i=0;d=1;while(1){C=Y(f[A+(i<<2)>>2]|0,d)|0;i=i+1|0;if((i|0)==(x|0)){E=C;break}else d=C}}f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=E;IQ(k,l,g,h);h=f[y>>2]|0;QQ(j,k,1,f[h+4>>2]|0,f[h+40>>2]|0);if((m|0)!=(j|0)){h=j+24|0;y=f[h>>2]|0;if(y|0){g=y+8|0;f[g>>2]=(f[g>>2]|0)+1}g=f[q>>2]|0;if(g|0?(y=g+8|0,g=f[y>>2]|0,f[y>>2]=g+-1,(g|0)==1):0)HQ(m);if((f[n>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0;F=f[n>>2]|0}while((s|0)<(F|0));f[q>>2]=0;f[m>>2]=f[j>>2];if((F|0)<3)G=26;else G=28}else{f[q>>2]=0;f[m>>2]=f[j>>2];G=26}if((G|0)==26){F=f[j+4>>2]|0;if((F|0)<3){f[n>>2]=F;f[o>>2]=f[j+8>>2];f[a+24>>2]=f[j+12>>2];o=f[j+36>>2]|0;F=f[v>>2]|0;f[F>>2]=f[o>>2];f[F+4>>2]=f[o+4>>2]}else G=28}if((G|0)==28)FQ(m,j);f[a+28>>2]=f[j+16>>2];if(!(f[p>>2]|0))f[p>>2]=f[j+20>>2];f[q>>2]=f[h>>2];f[r>>2]=f[j+28>>2]}GQ(j);GQ(k);GQ(l);b[a+64>>0]=0;a=t;if(c){u=e;return}c=a+4|0;l=f[c>>2]|0;f[c>>2]=l+-1;if((l|0)!=1){u=e;return}Yi[f[(f[t>>2]|0)+8>>2]&2047](a);u=e;return}function aHa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;switch(c|0){case 3:{if(!d){f[a>>2]=0;f[a+4>>2]=0;u=g;return}if((d+-1|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,25)|0;j=380285;k=i+25|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-213,h,380311,376410,880)}d=VDc(68)|0;f[d+4>>2]=3;f[d+8>>2]=1;f[d>>2]=77968;c=d+12|0;f[c>>2]=1124007936;l=d+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[d+44>>2]=d+20;l=d+52|0;f[d+48>>2]=l;f[d+56>>2]=0;f[l>>2]=0;l=h+8|0;f[l>>2]=0;f[l+4>>2]=0;f[h>>2]=34209792;f[h+4>>2]=c;h_(e,h);f[d+60>>2]=e;b[d+64>>0]=0;e=VDc(16)|0;f[e+4>>2]=1;f[e>>2]=77948;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;u=g;return}case 1:{if(!(sMa()|0)){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,12)|0;j=379751;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,380311,376410,884)}break}case 2:{if(!(vmb()|0)){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,15)|0;j=425433;k=i+15|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,h,380311,376410,891)}break}default:{f[h>>2]=0;f[h+4>>2]=0;i=tT(h,26)|0;j=378659;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-213,h,380311,376410,897)}}f[a>>2]=0;f[a+4>>2]=0;u=g;return}function bHa(a){a=a|0;f[a>>2]=77968;GQ(a+12|0);return}function cHa(a){a=a|0;f[a>>2]=77968;GQ(a+12|0);YDc(a);return}function dHa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;d=f[a+60>>2]|0;e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=33619968;f[c+4>>2]=d;NQ(a+12|0,c);u=b;return}function eHa(a){a=a|0;b[a+64>>0]=1;return}function fHa(a){a=a|0;YDc(a);return}function gHa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;do{d=g+-56|0;f[c>>2]=d;h=g+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)_S(d);f[h>>2]=0;h=g+-40|0;d=g+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[d>>2]|0)>0){h=f[g+-16>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[g+-12>>2]|0;if((d|0)!=(g+-8|0))g0(d);g=f[c>>2]|0}while((g|0)!=(b|0));e=f[a>>2]|0}YDc(e);f[a+8>>2]=0;f[c>>2]=0;f[a>>2]=0;return}function iHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){XIc(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;k=j+b|0;l=i;if(k>>>0>536870911)mCc(a);m=d-i|0;i=m>>2;d=m>>3>>>0<268435455?(i>>>0<k>>>0?k:i):536870911;do if(d)if(d>>>0>536870911){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{n=VDc(d<<3)|0;break}else n=0;while(0);i=n+(j<<3)|0;j=i;k=n+(d<<3)|0;XIc(i|0,0,b<<3|0)|0;d=i+(b<<3)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{i=g;g=g+-8|0;b=f[g>>2]|0;f[j+-8>>2]=b;f[j+-4>>2]=f[i+-4>>2];if(b|0){i=b+4|0;f[i>>2]=(f[i>>2]|0)+1}j=h+-8|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-8|0;d=f[c>>2]|0;if(d|0?(e=d+4|0,o=f[e>>2]|0,f[e>>2]=o+-1,(o|0)==1):0)Yi[f[(f[d>>2]|0)+8>>2]&2047](d);f[c>>2]=0;f[q+-4>>2]=0}while((c|0)!=(k|0))}if(!p)return;YDc(p);return}function jHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/12|0;if(!e)return;if(g>>>0>357913941)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*12|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{jFa(g,d);d=d+12|0;g=(f[c>>2]|0)+12|0;f[c>>2]=g}while((d|0)!=(b|0));return}function kHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;do if(h|0){i=f[c>>2]|0;j=f[c+4>>2]|0;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)>=(i|0)){if((n|0)!=(i|0))break;if((f[m+20>>2]|0)>=(j|0))break}n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)?(k=f[o+16>>2]|0,(i|0)>=(k|0)):0){if((i|0)==(k|0)?(j|0)<(f[o+20>>2]|0):0)break;k=o+24|0;l=f[k>>2]|0;n=f[k+4>>2]|0;k=a+4|0;p=f[k>>2]|0;if(p|0){q=k;r=p;b:while(1){p=r;while(1){s=f[p+16>>2]|0;if((s|0)>=(l|0)){if((s|0)!=(l|0))break;if((f[p+20>>2]|0)>=(n|0))break}s=f[p+4>>2]|0;if(!s){t=q;break b}else p=s}r=f[p>>2]|0;if(!r){t=p;break}else q=p}if((t|0)!=(k|0)?(q=f[t+16>>2]|0,(l|0)>=(q|0)):0){if((l|0)!=(q|0)){v=t+24|0;w=f[v>>2]|0;u=d;return w|0}if((n|0)>=(f[t+20>>2]|0)){v=t+24|0;w=f[v>>2]|0;u=d;return w|0}}}f[e>>2]=0;f[e+4>>2]=0;x=tT(e,25)|0;y=380786;z=x+25|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,e,380956,376410,676)}}while(0);f[e>>2]=0;f[e+4>>2]=0;x=tT(e,23)|0;y=380745;z=x+23|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-215,e,380956,376410,672);return 0}function lHa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(((h|0)/12|0)*12|0)|0;i=f[c>>2]|0;c=f[d>>2]|0;d=c-i|0;j=(d|0)/12|0;k=i;i=c;if((d|0)<=0){l=b;return l|0}d=a+8|0;m=f[d>>2]|0;n=a+4|0;o=f[n>>2]|0;p=o;if((j|0)<=((m-p|0)/12|0|0)){q=p-b|0;r=(q|0)/12|0;if((j|0)>(r|0)){s=k+(r*12|0)|0;r=s;if((s|0)==(i|0))t=o;else{u=o;v=s;while(1){jFa(u,v);v=v+12|0;s=(f[n>>2]|0)+12|0;f[n>>2]=s;if((v|0)==(i|0)){t=s;break}else u=s}}if((q|0)>0){w=r;x=t}else{l=b;return l|0}}else{w=c;x=o}c=x-(b+(j*12|0))|0;t=b+(((c|0)/12|0)*12|0)|0;if(t>>>0<o>>>0){r=t;q=x;do{jFa(q,r);r=r+12|0;q=(f[n>>2]|0)+12|0;f[n>>2]=q}while(r>>>0<o>>>0)}if(c|0){c=t;t=x;do{x=c;c=c+-12|0;o=t;t=t+-12|0;if((o|0)!=(x|0))xxa(t,f[c>>2]|0,f[x+-8>>2]|0)}while((c|0)!=(b|0))}c=w;if((k|0)==(c|0)){l=b;return l|0}else{y=b;z=k}while(1){if((y|0)!=(z|0))xxa(y,f[z>>2]|0,f[z+4>>2]|0);z=z+12|0;if((z|0)==(c|0)){l=b;break}else y=y+12|0}return l|0}y=((p-g|0)/12|0)+j|0;if(y>>>0>357913941)mCc(a);j=(m-g|0)/12|0;g=j<<1;m=j>>>0<178956970?(g>>>0<y>>>0?y:g):357913941;g=(h|0)/12|0;do if(m)if(m>>>0>357913941){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{A=VDc(m*12|0)|0;break}else A=0;while(0);h=A+(g*12|0)|0;g=h;y=A+(m*12|0)|0;if((k|0)==(i|0)){B=g;C=e}else{e=g;m=h;A=k;do{jFa(m,A);m=e+12|0;e=m;A=A+12|0}while((A|0)!=(i|0));B=e;C=f[a>>2]|0}if((C|0)==(b|0)){D=h;E=g}else{e=b;i=g;g=h;while(1){e=e+-12|0;jFa(g+-12|0,e);A=i+-12|0;m=A;if((e|0)==(C|0)){D=A;E=m;break}else{i=m;g=A}}}g=f[n>>2]|0;if((g|0)==(b|0)){F=B;G=D;H=b}else{D=b;b=B;i=B;do{jFa(i,D);D=D+12|0;i=b+12|0;b=i}while((D|0)!=(g|0));F=b;G=E;H=f[n>>2]|0}E=f[a>>2]|0;f[a>>2]=G;f[n>>2]=F;f[d>>2]=y;if((H|0)!=(E|0)){y=H;do{H=y;y=y+-12|0;d=f[y>>2]|0;if(d|0){F=H+-8|0;H=f[F>>2]|0;if((H|0)!=(d|0))f[F>>2]=H+(~((H+-4-d|0)>>>2)<<2);YDc(d)}}while((y|0)!=(E|0))}if(!E){l=h;return l|0}YDc(E);l=h;return l|0}function mHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function nHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+16|0;g=e;h=a+12|0;i=a+16|0;j=f[i>>2]|0;if(!j){f[g>>2]=0;k=g+4|0;f[k>>2]=0;l=tT(g,37)|0;m=l;n=380918;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,380912,376410,684)}p=f[d>>2]|0;q=d+4|0;r=f[q>>2]|0;s=i;t=j;a:while(1){v=t;while(1){w=f[v+16>>2]|0;if((w|0)>=(p|0)){if((w|0)!=(p|0))break;if((f[v+20>>2]|0)>=(r|0))break}w=f[v+4>>2]|0;if(!w){x=s;break a}else v=w}t=f[v>>2]|0;if(!t){x=v;break}else s=v}if((x|0)!=(i|0)?(s=f[x+16>>2]|0,(p|0)>=(s|0)):0){if((p|0)!=(s|0)){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,37)|0;m=z;n=380874;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,380912,376410,683)}if((r|0)>=(f[x+20>>2]|0)){f[g>>2]=0;y=g+4|0;f[y>>2]=0;z=tT(g,37)|0;m=z;n=380874;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,380912,376410,683)}}z=f[c>>2]|0;y=f[c+4>>2]|0;x=i;r=j;b:while(1){j=r;while(1){s=f[j+16>>2]|0;if((s|0)>=(z|0)){if((s|0)!=(z|0))break;if((f[j+20>>2]|0)>=(y|0))break}s=f[j+4>>2]|0;if(!s){A=x;break b}else j=s}r=f[j>>2]|0;if(!r){A=j;break}else x=j}if((A|0)==(i|0)){f[g>>2]=0;k=g+4|0;f[k>>2]=0;l=tT(g,37)|0;m=l;n=380918;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,380912,376410,684)}i=f[A+16>>2]|0;if((z|0)<(i|0)){f[g>>2]=0;k=g+4|0;f[k>>2]=0;l=tT(g,37)|0;m=l;n=380918;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,380912,376410,684)}if((z|0)==(i|0)?(y|0)<(f[A+20>>2]|0):0){f[g>>2]=0;k=g+4|0;f[k>>2]=0;l=tT(g,37)|0;m=l;n=380918;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));z5(-215,g,380912,376410,684)}g=sHa(h,c)|0;c=f[g>>2]|0;n=f[g+4>>2]|0;g=sHa(h,d)|0;f[g>>2]=c;f[g+4>>2]=n;g=a+4|0;h=f[g>>2]|0;if(!h){u=e;return}else{B=g;C=h}c:while(1){m=C;while(1){o=f[m+16>>2]|0;if((o|0)>=(c|0)){if((o|0)!=(c|0))break;if((f[m+20>>2]|0)>=(n|0))break}o=f[m+4>>2]|0;if(!o){D=B;break c}else m=o}C=f[m>>2]|0;if(!C){D=m;break}else B=m}if((D|0)==(g|0)){u=e;return}B=f[D+16>>2]|0;if((c|0)<(B|0)){u=e;return}if((c|0)==(B|0)?(n|0)<(f[D+20>>2]|0):0){u=e;return}D=f[d>>2]|0;d=f[q>>2]|0;q=g;B=h;d:while(1){C=B;while(1){j=f[C+16>>2]|0;if((j|0)>=(D|0)){if((j|0)!=(D|0))break;if((f[C+20>>2]|0)>=(d|0))break}j=f[C+4>>2]|0;if(!j){E=q;break d}else C=j}B=f[C>>2]|0;if(!B){E=C;break}else q=C}do if((E|0)!=(g|0)?(q=f[E+16>>2]|0,(D|0)>=(q|0)):0){if((D|0)==(q|0)?(d|0)<(f[E+20>>2]|0):0)break;q=f[E+24>>2]|0;B=a+4|0;m=h;j=h;e:while(1){o=f[m+16>>2]|0;do if((c|0)>=(o|0)){l=(c|0)==(o|0);if(l?(n|0)<(f[m+20>>2]|0):0){F=53;break}if((o|0)>=(c|0)){if(!l){F=58;break e}if((f[m+20>>2]|0)>=(n|0)){F=58;break e}}l=m+4|0;k=f[l>>2]|0;if(!k){G=l;F=59;break e}else{H=l;I=k}}else F=53;while(0);if((F|0)==53){F=0;o=f[m>>2]|0;if(!o){G=m;F=59;break}else{H=m;I=o}}B=H;m=I;j=I}if((F|0)==58)if(!j){G=B;F=59}else J=j;if((F|0)==59){C=VDc(28)|0;o=C+16|0;f[o>>2]=c;f[o+4>>2]=n;f[C+24>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=m;f[G>>2]=C;o=f[f[a>>2]>>2]|0;if(!o)K=C;else{f[a>>2]=o;K=f[G>>2]|0}laa(f[a+4>>2]|0,K);o=a+8|0;f[o>>2]=(f[o>>2]|0)+1;J=C}C=J+24|0;f[C>>2]=(f[C>>2]|0)+q;C=f[E+4>>2]|0;if(!C){o=E+8|0;k=f[o>>2]|0;if((f[k>>2]|0)==(E|0))L=k;else{k=o;do{o=f[k>>2]|0;k=o+8|0;l=f[k>>2]|0}while((f[l>>2]|0)!=(o|0));L=l}}else{k=C;while(1){q=f[k>>2]|0;if(!q)break;else k=q}L=k}if((f[a>>2]|0)==(E|0))f[a>>2]=L;C=a+8|0;f[C>>2]=(f[C>>2]|0)+-1;uHa(f[a+4>>2]|0,E);YDc(E);u=e;return}while(0);E=a+4|0;L=h;J=h;f:while(1){h=f[L+16>>2]|0;do if((c|0)>=(h|0)){K=(c|0)==(h|0);if(K?(n|0)<(f[L+20>>2]|0):0){F=75;break}if((h|0)>=(c|0)){if(!K){F=80;break f}if((f[L+20>>2]|0)>=(n|0)){F=80;break f}}K=L+4|0;G=f[K>>2]|0;if(!G){M=K;F=81;break f}else{N=K;O=G}}else F=75;while(0);if((F|0)==75){F=0;h=f[L>>2]|0;if(!h){M=L;F=81;break}else{N=L;O=h}}E=N;L=O;J=O}if((F|0)==80)if(!J){M=E;F=81}else P=J;if((F|0)==81){F=VDc(28)|0;J=F+16|0;f[J>>2]=c;f[J+4>>2]=n;f[F+24>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=L;f[M>>2]=F;L=f[f[a>>2]>>2]|0;if(!L)Q=F;else{f[a>>2]=L;Q=f[M>>2]|0}laa(f[a+4>>2]|0,Q);Q=a+8|0;f[Q>>2]=(f[Q>>2]|0)+1;P=F}F=P+24|0;f[F>>2]=(f[F>>2]|0)+1;u=e;return}function oHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;h=u;u=u+256|0;i=h+240|0;j=h+232|0;k=h+176|0;l=h;m=h+64|0;n=h+120|0;o=h+8|0;if(!(b[1152661]|0)){f[k>>2]=1124007936;p=k+4|0;q=k+8|0;r=k+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;v=k+48|0;w=k+44|0;f[w>>2]=v;f[v>>2]=0;f[k+52>>2]=0;f[l>>2]=-1;f[l+4>>2]=-1;x=f[c+4>>2]|0;y=f[c>>2]|0;z=x-y|0;A=z>>2;B=y;if((B|0)!=(x|0)){if((z|0)<=-4){f[i>>2]=0;f[i+4>>2]=0;s=tT(i,70)|0;x=452744;t=s+70|0;do{b[s>>0]=b[x>>0]|0;s=s+1|0;x=x+1|0}while((s|0)<(t|0));z5(-215,i,452815,452821,161)}if((z|0)>0){z=0;x=1;while(1){s=Y(f[B+(z<<2)>>2]|0,x)|0;z=z+1|0;if((z|0)>=(A|0)){C=s;break}else x=s}}else C=1}else C=0;x=f[a+24>>2]|0;A=a+28|0;if((x|0)!=(A|0)){z=a+4|0;B=k+36|0;s=k+16|0;t=k+12|0;y=k+20|0;D=k+24|0;E=k+28|0;F=k+32|0;G=2147483647;H=x;x=0;I=0;J=0;while(1){K=H+16|0;L=f[z>>2]|0;do if(L){M=f[K>>2]|0;N=f[H+20>>2]|0;O=z;P=L;a:while(1){Q=P;while(1){R=f[Q+16>>2]|0;if((R|0)>=(M|0)){if((R|0)!=(M|0))break;if((f[Q+20>>2]|0)>=(N|0))break}R=f[Q+4>>2]|0;if(!R){S=O;break a}else Q=R}P=f[Q>>2]|0;if(!P){S=Q;break}else O=Q}if((S|0)!=(z|0)?(O=f[S+16>>2]|0,(M|0)>=(O|0)):0){if((M|0)==(O|0)?(N|0)<(f[S+20>>2]|0):0){T=G;U=I;V=x;W=J;break}if(!(f[S+24>>2]|0)){O=H+24|0;P=H+28|0;R=f[P>>2]|0;X=(R|0)<3;if(X)Z=Y(f[H+36>>2]|0,f[H+32>>2]|0)|0;else{_=f[H+64>>2]|0;$=0;aa=1;while(1){ba=Y(f[_+($<<2)>>2]|0,aa)|0;$=$+1|0;if(($|0)==(R|0)){Z=ba;break}else aa=ba}}if(Z>>>0>=C>>>0){if(X)ca=Y(f[H+36>>2]|0,f[H+32>>2]|0)|0;else{aa=f[H+64>>2]|0;$=0;_=1;while(1){N=Y(f[aa+($<<2)>>2]|0,_)|0;$=$+1|0;if(($|0)==(R|0)){ca=N;break}else _=N}}if(ca>>>0<G>>>0){_=K;$=f[_+4>>2]|0;aa=l;f[aa>>2]=f[_>>2];f[aa+4>>2]=$;if((k|0)==(O|0)){da=R;ea=x;fa=I;ga=J}else{$=H+60|0;aa=f[$>>2]|0;if(!aa)ha=J;else{_=aa+12|0;f[_>>2]=(f[_>>2]|0)+1;ha=f[B>>2]|0}do if(ha|0){_=ha+12|0;aa=f[_>>2]|0;f[_>>2]=aa+-1;if((aa|0)!=1)break;_S(k)}while(0);f[B>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[p>>2]|0)>0){R=f[r>>2]|0;aa=0;do{f[R+(aa<<2)>>2]=0;aa=aa+1|0;ia=f[p>>2]|0}while((aa|0)<(ia|0));f[k>>2]=f[O>>2];if((ia|0)<3)ja=44;else ja=46}else{f[k>>2]=f[O>>2];ja=44}do if((ja|0)==44){ja=0;aa=f[P>>2]|0;if((aa|0)>=3){ja=46;break}f[p>>2]=aa;f[q>>2]=f[H+32>>2];f[t>>2]=f[H+36>>2];aa=f[H+68>>2]|0;R=f[w>>2]|0;f[R>>2]=f[aa>>2];f[R+4>>2]=f[aa+4>>2]}while(0);if((ja|0)==46){ja=0;ZS(k,O)}aa=f[H+40>>2]|0;f[s>>2]=aa;f[y>>2]=f[H+44>>2];f[D>>2]=f[H+48>>2];f[E>>2]=f[H+52>>2];f[F>>2]=f[H+56>>2];R=f[$>>2]|0;f[B>>2]=R;_=R;da=f[P>>2]|0;ea=_;fa=aa;ga=_}if((da|0)<3){T=Y(f[H+36>>2]|0,f[H+32>>2]|0)|0;U=fa;V=ea;W=ga;break}_=f[H+64>>2]|0;aa=0;R=1;while(1){X=Y(f[_+(aa<<2)>>2]|0,R)|0;aa=aa+1|0;if((aa|0)==(da|0)){T=X;U=fa;V=ea;W=ga;break}else R=X}}else{T=G;U=I;V=x;W=J}}else{T=G;U=I;V=x;W=J}}else{T=G;U=I;V=x;W=J}}else{T=G;U=I;V=x;W=J}}else{T=G;U=I;V=x;W=J}while(0);K=f[H+4>>2]|0;if(!K){L=H+8|0;R=f[L>>2]|0;if((f[R>>2]|0)==(H|0))ka=R;else{R=L;do{L=f[R>>2]|0;R=L+8|0;aa=f[R>>2]|0}while((f[aa>>2]|0)!=(L|0));ka=aa}}else{R=K;while(1){aa=f[R>>2]|0;if(!aa)break;else R=aa}ka=R}if((ka|0)==(A|0))break;else{G=T;H=ka;x=V;I=U;J=W}}if(U|0){U=f[p>>2]|0;if((U|0)<3)la=Y(f[k+12>>2]|0,f[q>>2]|0)|0;else{q=f[r>>2]|0;W=0;J=1;while(1){I=Y(f[q+(W<<2)>>2]|0,J)|0;W=W+1|0;if((W|0)==(U|0)){la=I;break}else J=I}}if(!((U|0)==0|(la|0)==0)){nHa(a,l,d);lT(o,k,1,1);f[i>>2]=-2147483648;f[i+4>>2]=2147483647;f[j>>2]=0;f[j+4>>2]=C;$S(n,o,i,j);nT(m,n,1,c);if((m|0)==(e|0)){ma=m+36|0;na=f[e+36>>2]|0}else{j=m+36|0;i=f[j>>2]|0;if(i|0){C=i+12|0;f[C>>2]=(f[C>>2]|0)+1}C=e+36|0;i=f[C>>2]|0;if(i|0?(l=i+12|0,i=f[l>>2]|0,f[l>>2]=i+-1,(i|0)==1):0)_S(e);f[C>>2]=0;i=e+16|0;l=e+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[l>>2]|0)>0){la=f[e+40>>2]|0;U=0;do{f[la+(U<<2)>>2]=0;U=U+1|0;oa=f[l>>2]|0}while((U|0)<(oa|0));f[e>>2]=f[m>>2];if((oa|0)<3)ja=76;else ja=78}else{f[e>>2]=f[m>>2];ja=76}if((ja|0)==76){oa=f[m+4>>2]|0;if((oa|0)<3){f[l>>2]=oa;f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];oa=f[m+44>>2]|0;l=f[e+44>>2]|0;f[l>>2]=f[oa>>2];f[l+4>>2]=f[oa+4>>2]}else ja=78}if((ja|0)==78)ZS(e,m);f[i>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[e+32>>2]=f[m+32>>2];i=f[j>>2]|0;f[C>>2]=i;ma=j;na=i}if(na|0?(i=na+12|0,na=f[i>>2]|0,f[i>>2]=na+-1,(na|0)==1):0)_S(m);f[ma>>2]=0;ma=m+16|0;na=m+4|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[na>>2]|0)>0){ma=f[m+40>>2]|0;i=0;do{f[ma+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[na>>2]|0))}na=f[m+44>>2]|0;if((na|0)!=(m+48|0))g0(na);na=n+36|0;m=f[na>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)_S(n);f[na>>2]=0;na=n+16|0;m=n+4|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[m>>2]|0)>0){na=f[n+40>>2]|0;i=0;do{f[na+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[n+44>>2]|0;if((m|0)!=(n+48|0))g0(m);m=o+36|0;n=f[m>>2]|0;if(n|0?(i=n+12|0,n=f[i>>2]|0,f[i>>2]=n+-1,(n|0)==1):0)_S(o);f[m>>2]=0;m=o+16|0;n=o+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){m=f[o+40>>2]|0;i=0;do{f[m+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[n>>2]|0))}n=f[o+44>>2]|0;if((n|0)!=(o+48|0))g0(n);n=k+36|0;o=f[n>>2]|0;do if(o|0){i=o+12|0;m=f[i>>2]|0;f[i>>2]=m+-1;if((m|0)!=1)break;_S(k)}while(0);f[n>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[p>>2]|0)>0){n=f[r>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[p>>2]|0))}o=f[w>>2]|0;if((o|0)!=(v|0))g0(o);u=h;return}}o=k+36|0;if((V|0)!=0?(n=V+12|0,V=f[n>>2]|0,f[n>>2]=V+-1,(V|0)==1):0){_S(k);pa=s;qa=o}else{pa=s;qa=o}}else{pa=k+16|0;qa=k+36|0}f[qa>>2]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[p>>2]|0)>0){pa=f[r>>2]|0;r=0;do{f[pa+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[w>>2]|0;if((p|0)!=(v|0))g0(p)}YS(e,c,g?3:5);rHa(a,d,e);u=h;return}function pHa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;pHa(a,f[b>>2]|0);pHa(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0){c=b+24|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~((d+-4-a|0)>>>2)<<2);YDc(a)}YDc(b);return}function qHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;do if(h|0){i=f[c>>2]|0;j=f[c+4>>2]|0;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)>=(i|0)){if((n|0)!=(i|0))break;if((f[m+20>>2]|0)>=(j|0))break}n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)?(k=f[o+16>>2]|0,(i|0)>=(k|0)):0){if((i|0)==(k|0)?(j|0)<(f[o+20>>2]|0):0)break;k=a+4|0;l=f[k>>2]|0;do if(l|0){n=f[o+24>>2]|0;p=f[o+28>>2]|0;q=k;r=l;b:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)>=(n|0)){if((t|0)!=(n|0))break;if((f[s+20>>2]|0)>=(p|0))break}t=f[s+4>>2]|0;if(!t){v=q;break b}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)!=(k|0)?(q=f[v+16>>2]|0,(n|0)>=(q|0)):0){if((n|0)==(q|0)?(p|0)<(f[v+20>>2]|0):0)break;q=v+24|0;r=f[q>>2]|0;if((r|0)>0){f[q>>2]=r+-1;u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;w=tT(e,17)|0;x=380812;y=w+17|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,e,380769,376410,708)}}}while(0);f[e>>2]=0;f[e+4>>2]=0;w=tT(e,25)|0;x=380786;y=w+25|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,e,380769,376410,707)}}while(0);f[e>>2]=0;f[e+4>>2]=0;w=tT(e,23)|0;x=380745;y=w+23|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z5(-215,e,380769,376410,704)}function rHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+24|0;i=a+28|0;j=f[i>>2]|0;if(j|0){k=f[c>>2]|0;l=f[c+4>>2]|0;m=i;n=j;a:while(1){j=n;while(1){o=f[j+16>>2]|0;if((o|0)>=(k|0)){if((o|0)!=(k|0))break;if((f[j+20>>2]|0)>=(l|0))break}o=f[j+4>>2]|0;if(!o){p=m;break a}else j=o}n=f[j>>2]|0;if(!n){p=j;break}else m=j}if((p|0)!=(i|0)?(i=f[p+16>>2]|0,(k|0)>=(i|0)):0){if((k|0)!=(i|0)){f[g>>2]=0;q=g+4|0;f[q>>2]=0;r=tT(g,35)|0;s=r;t=380830;v=s+35|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,380866,376410,859)}if((l|0)>=(f[p+20>>2]|0)){f[g>>2]=0;q=g+4|0;f[q>>2]=0;r=tT(g,35)|0;s=r;t=380830;v=s+35|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,380866,376410,859)}}}g=sHa(a+12|0,c)|0;a=c;t=f[a+4>>2]|0;s=g;f[s>>2]=f[a>>2];f[s+4>>2]=t;t=tHa(h,c)|0;if((t|0)==(d|0)){u=e;return}c=d+36|0;h=f[c>>2]|0;if(h|0){s=h+12|0;f[s>>2]=(f[s>>2]|0)+1}s=t+36|0;h=f[s>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)_S(t);f[s>>2]=0;h=t+16|0;a=t+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[a>>2]|0)>0){g=f[t+40>>2]|0;v=0;do{f[g+(v<<2)>>2]=0;v=v+1|0;w=f[a>>2]|0}while((v|0)<(w|0));f[t>>2]=f[d>>2];if((w|0)<3)x=25;else x=27}else{f[t>>2]=f[d>>2];x=25}if((x|0)==25){w=f[d+4>>2]|0;if((w|0)<3){f[a>>2]=w;f[t+8>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];w=f[d+44>>2]|0;a=f[t+44>>2]|0;f[a>>2]=f[w>>2];f[a+4>>2]=f[w+4>>2]}else x=27}if((x|0)==27)ZS(t,d);f[h>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];f[s>>2]=f[c>>2];u=e;return}function sHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;j=d;a:while(1){k=f[i+16>>2]|0;do if((e|0)>=(k|0)){l=(e|0)==(k|0);if(l?(g|0)<(f[i+20>>2]|0):0){m=7;break}if((k|0)>=(e|0)){if(!l){m=14;break a}if((f[i+20>>2]|0)>=(g|0)){m=14;break a}}n=i+4|0;l=f[n>>2]|0;if(!l){m=13;break a}else{o=n;p=l}}else m=7;while(0);if((m|0)==7){m=0;k=f[i>>2]|0;if(!k){m=8;break}else{o=i;p=k}}h=o;i=p;j=p}if((m|0)==8){q=i;r=i;break}else if((m|0)==13){q=n;r=i;break}else if((m|0)==14){s=h;t=i;u=j;m=16;break}}else{s=c;t=c;u=d;m=16}while(0);if((m|0)==16)if(!u){q=s;r=t}else{v=u;w=v+24|0;return w|0}u=VDc(32)|0;t=b;b=f[t+4>>2]|0;s=u+16|0;f[s>>2]=f[t>>2];f[s+4>>2]=b;f[u+24>>2]=-1;f[u+28>>2]=-1;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=r;f[q>>2]=u;r=f[f[a>>2]>>2]|0;if(!r)x=u;else{f[a>>2]=r;x=f[q>>2]|0}laa(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;v=u;w=v+24|0;return w|0}function tHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;j=d;a:while(1){k=f[i+16>>2]|0;do if((e|0)>=(k|0)){l=(e|0)==(k|0);if(l?(g|0)<(f[i+20>>2]|0):0){m=7;break}if((k|0)>=(e|0)){if(!l){m=14;break a}if((f[i+20>>2]|0)>=(g|0)){m=14;break a}}n=i+4|0;l=f[n>>2]|0;if(!l){m=13;break a}else{o=n;p=l}}else m=7;while(0);if((m|0)==7){m=0;k=f[i>>2]|0;if(!k){m=8;break}else{o=i;p=k}}h=o;i=p;j=p}if((m|0)==8){q=i;r=i;break}else if((m|0)==13){q=n;r=i;break}else if((m|0)==14){s=h;t=i;u=j;m=16;break}}else{s=c;t=c;u=d;m=16}while(0);if((m|0)==16)if(!u){q=s;r=t}else{v=u;w=v+24|0;return w|0}u=VDc(80)|0;t=b;b=f[t+4>>2]|0;s=u+16|0;f[s>>2]=f[t>>2];f[s+4>>2]=b;f[u+24>>2]=1124007936;b=u+32|0;s=u+64|0;t=u+28|0;m=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(m|0));f[s>>2]=b;b=u+72|0;f[u+68>>2]=b;f[b>>2]=0;f[u+76>>2]=0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=r;f[q>>2]=u;r=f[f[a>>2]>>2]|0;if(!r)x=u;else{f[a>>2]=r;x=f[q>>2]|0}laa(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;v=u;w=v+24|0;return w|0}function uHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[c>>2]|0;if(d){e=f[c+4>>2]|0;if(!e){g=c;h=d}else{d=e;while(1){e=f[d>>2]|0;if(!e){g=d;h=0;break}else d=e}}}else{g=c;h=0}d=g+4|0;e=f[(h|0?g:d)>>2]|0;h=(e|0)==0;i=g+8|0;if(!h)f[e+8>>2]=f[i>>2];j=f[i>>2]|0;if((f[j>>2]|0)==(g|0)){f[j>>2]=e;if((g|0)==(a|0)){k=e;l=0}else{m=j+4|0;n=10}}else{f[j+4>>2]=e;m=j;n=10}if((n|0)==10){k=a;l=f[m>>2]|0}m=g+12|0;a=(b[m>>0]|0)==0;if((g|0)==(c|0))o=k;else{j=c+8|0;p=f[j>>2]|0;f[i>>2]=p;f[((f[f[j>>2]>>2]|0)==(c|0)?p:p+4|0)>>2]=g;p=f[c>>2]|0;f[g>>2]=p;f[p+8>>2]=g;p=f[c+4>>2]|0;f[d>>2]=p;if(p|0)f[p+8>>2]=g;b[m>>0]=b[c+12>>0]|0;o=(k|0)==(c|0)?g:k}if(a|(o|0)==0)return;if(h){q=l;r=o}else{b[e+12>>0]=1;return}while(1){e=f[q+8>>2]|0;o=q+12|0;l=(b[o>>0]|0)!=0;if((f[e>>2]|0)==(q|0)){if(l){s=q;t=r}else{b[o>>0]=1;b[e+12>>0]=0;h=f[e>>2]|0;a=h+4|0;k=f[a>>2]|0;f[e>>2]=k;if(k|0)f[k+8>>2]=e;k=e+8|0;f[h+8>>2]=f[k>>2];g=f[k>>2]|0;f[((f[g>>2]|0)==(e|0)?g:g+4|0)>>2]=h;f[a>>2]=e;f[k>>2]=h;h=f[q+4>>2]|0;s=f[h>>2]|0;t=(r|0)==(h|0)?q:r}u=f[s>>2]|0;v=(u|0)==0;if(!v?(b[u+12>>0]|0)==0:0){n=50;break}h=f[s+4>>2]|0;if(h|0?(b[h+12>>0]|0)==0:0){n=49;break}b[s+12>>0]=0;h=f[s+8>>2]|0;w=h+12|0;if((h|0)==(t|0)|(b[w>>0]|0)==0){n=48;break}else{x=t;y=h}}else{if(l){z=q;A=r}else{b[o>>0]=1;b[e+12>>0]=0;o=e+4|0;l=f[o>>2]|0;h=f[l>>2]|0;f[o>>2]=h;if(h|0)f[h+8>>2]=e;h=e+8|0;f[l+8>>2]=f[h>>2];o=f[h>>2]|0;f[((f[o>>2]|0)==(e|0)?o:o+4|0)>>2]=l;f[l>>2]=e;f[h>>2]=l;l=f[q>>2]|0;z=f[l+4>>2]|0;A=(r|0)==(l|0)?q:r}B=f[z>>2]|0;if(B|0?(b[B+12>>0]|0)==0:0){n=31;break}l=f[z+4>>2]|0;if(l|0?(b[l+12>>0]|0)==0:0){C=l;n=32;break}b[z+12>>0]=0;l=f[z+8>>2]|0;if((l|0)==(A|0)){D=A;n=30;break}if(!(b[l+12>>0]|0)){D=l;n=30;break}else{x=A;y=l}}l=f[y+8>>2]|0;q=f[((f[l>>2]|0)==(y|0)?l+4|0:l)>>2]|0;r=x}if((n|0)==30){b[D+12>>0]=1;return}else if((n|0)==31){D=f[z+4>>2]|0;if(!D)n=33;else{C=D;n=32}}else if((n|0)==48){b[w>>0]=1;return}else if((n|0)==49)if(v)n=51;else n=50;if((n|0)==32)if(!(b[C+12>>0]|0)){E=z;F=C;n=36}else n=33;else if((n|0)==50)if(!(b[u+12>>0]|0)){G=s;H=u;n=54}else n=51;if((n|0)==33){b[B+12>>0]=1;b[z+12>>0]=0;u=B+4|0;C=f[u>>2]|0;f[z>>2]=C;if(C|0)f[C+8>>2]=z;C=z+8|0;f[B+8>>2]=f[C>>2];v=f[C>>2]|0;f[((f[v>>2]|0)==(z|0)?v:v+4|0)>>2]=B;f[u>>2]=z;f[C>>2]=B;E=B;F=z;n=36}else if((n|0)==51){z=s+4|0;B=f[z>>2]|0;b[B+12>>0]=1;b[s+12>>0]=0;C=f[B>>2]|0;f[z>>2]=C;if(C|0)f[C+8>>2]=s;C=s+8|0;f[B+8>>2]=f[C>>2];z=f[C>>2]|0;f[((f[z>>2]|0)==(s|0)?z:z+4|0)>>2]=B;f[B>>2]=s;f[C>>2]=B;G=B;H=s;n=54}if((n|0)==36){s=f[E+8>>2]|0;B=s+12|0;b[E+12>>0]=b[B>>0]|0;b[B>>0]=1;b[F+12>>0]=1;F=s+4|0;B=f[F>>2]|0;E=f[B>>2]|0;f[F>>2]=E;if(E|0)f[E+8>>2]=s;E=s+8|0;f[B+8>>2]=f[E>>2];F=f[E>>2]|0;f[((f[F>>2]|0)==(s|0)?F:F+4|0)>>2]=B;f[B>>2]=s;f[E>>2]=B;return}else if((n|0)==54){n=f[G+8>>2]|0;B=n+12|0;b[G+12>>0]=b[B>>0]|0;b[B>>0]=1;b[H+12>>0]=1;H=f[n>>2]|0;B=H+4|0;G=f[B>>2]|0;f[n>>2]=G;if(G|0)f[G+8>>2]=n;G=n+8|0;f[H+8>>2]=f[G>>2];E=f[G>>2]|0;f[((f[E>>2]|0)==(n|0)?E:E+4|0)>>2]=H;f[B>>2]=n;f[G>>2]=H;return}}function vHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/12|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>((g-h|0)/12|0)>>>0){if(!h)j=g;else{g=a+4|0;k=f[g>>2]|0;if((k|0)==(i|0))l=h;else{m=k;while(1){k=m+-12|0;f[g>>2]=k;n=f[k>>2]|0;if(!n)o=k;else{k=m+-8|0;p=f[k>>2]|0;if((p|0)!=(n|0))f[k>>2]=p+(~((p+-4-n|0)>>>2)<<2);YDc(n);o=f[g>>2]|0}if((o|0)==(i|0))break;else m=o}l=f[a>>2]|0}YDc(l);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>357913941)mCc(a);g=(j|0)/12|0;j=g<<1;l=g>>>0<178956970?(j>>>0<d>>>0?d:j):357913941;if(l>>>0>357913941)mCc(a);j=VDc(l*12|0)|0;g=a+4|0;f[g>>2]=j;f[a>>2]=j;f[e>>2]=j+(l*12|0);if((b|0)==(c|0))return;l=b;e=j;do{jFa(e,l);l=l+12|0;e=(f[g>>2]|0)+12|0;f[g>>2]=e}while((l|0)!=(c|0));return}else{l=a+4|0;a=((f[l>>2]|0)-h|0)/12|0;h=d>>>0>a>>>0;d=b+(a*12|0)|0;a=h?d:c;if((a|0)==(b|0))q=i;else{e=b;b=i;while(1){if((b|0)!=(e|0))xxa(b,f[e>>2]|0,f[e+4>>2]|0);e=e+12|0;i=b+12|0;if((e|0)==(a|0)){q=i;break}else b=i}}if(h){if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{jFa(d,a);a=a+12|0;d=(f[l>>2]|0)+12|0;f[l>>2]=d}while((a|0)!=(c|0));return}c=f[l>>2]|0;if((c|0)==(q|0))return;else r=c;while(1){c=r+-12|0;f[l>>2]=c;a=f[c>>2]|0;if(!a)s=c;else{c=r+-8|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~((d+-4-a|0)>>>2)<<2);YDc(a);s=f[l>>2]|0}if((s|0)==(q|0))break;else r=s}return}}function wHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=c;c=a+20|0;i=AGa(c,g)|0;j=i+60|0;k=f[g>>2]|0;l=d+4|0;m=f[l>>2]|0;do if(m){n=d+4|0;o=m;p=m;while(1){q=f[o+16>>2]|0;if((q|0)>(k|0)){r=f[o>>2]|0;if(!r){s=6;break}else{t=o;v=r}}else{if((q|0)>=(k|0)){s=10;break}w=o+4|0;q=f[w>>2]|0;if(!q){s=9;break}else{t=w;v=q}}n=t;o=v;p=v}if((s|0)==6){x=o;y=o;s=13;break}else if((s|0)==9){x=w;y=o;s=13;break}else if((s|0)==10){z=o;A=n;B=p;s=12;break}}else{z=l;A=l;B=m;s=12}while(0);if((s|0)==12)if(!B){x=A;y=z;s=13}else C=B;if((s|0)==13){B=VDc(60)|0;f[B+16>>2]=k;k=B+20|0;D=k;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[k+36>>0]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=y;f[x>>2]=B;y=f[f[d>>2]>>2]|0;if(!y)F=B;else{f[d>>2]=y;F=f[x>>2]|0}laa(f[d+4>>2]|0,F);F=d+8|0;f[F>>2]=(f[F>>2]|0)+1;C=B}if((f[C+20>>2]|0)==(f[C+24>>2]|0)?(C=i+64|0,i=f[j>>2]|0,(f[C>>2]|0)!=(i|0)):0){B=d+4|0;F=d+8|0;x=0;y=i;do{i=f[y+(x<<3)>>2]|0;k=f[l>>2]|0;if(k){z=l;A=k;a:while(1){m=A;while(1){if((f[m+16>>2]|0)>=(i|0))break;w=f[m+4>>2]|0;if(!w){G=z;break a}else m=w}A=f[m>>2]|0;if(!A){G=m;break}else z=m}if(((G|0)!=(l|0)?(f[G+16>>2]|0)<=(i|0):0)?(f[G+32>>2]|0)!=(f[G+36>>2]|0):0)H=k;else s=27}else s=27;if((s|0)==27){s=0;wHa(a,i,d);H=f[l>>2]|0}do if(H){z=B;A=H;p=H;while(1){n=f[A+16>>2]|0;if((n|0)>(i|0)){o=f[A>>2]|0;if(!o){s=32;break}else{I=A;J=o}}else{if((n|0)>=(i|0)){s=36;break}K=A+4|0;n=f[K>>2]|0;if(!n){s=35;break}else{I=K;J=n}}z=I;A=J;p=J}if((s|0)==32){s=0;L=A;M=A;s=38;break}else if((s|0)==35){s=0;L=K;M=A;s=38;break}else if((s|0)==36){s=0;N=A;O=z;P=p;s=37;break}}else{N=l;O=l;P=H;s=37}while(0);if((s|0)==37){s=0;if(!P){L=O;M=N;s=38}else{Q=P;R=H}}if((s|0)==38){s=0;k=VDc(60)|0;f[k+16>>2]=i;m=k+20|0;D=m;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[m+36>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=M;f[L>>2]=k;i=f[f[d>>2]>>2]|0;if(!i)S=k;else{f[d>>2]=i;S=f[L>>2]|0}laa(f[B>>2]|0,S);f[F>>2]=(f[F>>2]|0)+1;Q=k;R=f[l>>2]|0}i=(f[Q+32>>2]|0)+((f[(f[j>>2]|0)+(x<<3)+4>>2]|0)*12|0)|0;n=f[g>>2]|0;do if(R){o=B;w=R;v=R;while(1){t=f[w+16>>2]|0;if((t|0)>(n|0)){q=f[w>>2]|0;if(!q){s=45;break}else{T=w;U=q}}else{if((t|0)>=(n|0)){s=49;break}V=w+4|0;t=f[V>>2]|0;if(!t){s=48;break}else{T=V;U=t}}o=T;w=U;v=U}if((s|0)==45){s=0;W=w;X=w;s=51;break}else if((s|0)==48){s=0;W=V;X=w;s=51;break}else if((s|0)==49){s=0;Y=w;Z=o;_=v;s=50;break}}else{Y=l;Z=l;_=R;s=50}while(0);if((s|0)==50){s=0;if(!_){W=Z;X=Y;s=51}else $=_}if((s|0)==51){s=0;k=VDc(60)|0;f[k+16>>2]=n;m=k+20|0;D=m;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[m+36>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=X;f[W>>2]=k;n=f[f[d>>2]>>2]|0;if(!n)aa=k;else{f[d>>2]=n;aa=f[W>>2]|0}laa(f[B>>2]|0,aa);f[F>>2]=(f[F>>2]|0)+1;$=k}n=$+24|0;p=f[n>>2]|0;if((p|0)==(f[$+28>>2]|0))OGa($+20|0,i);else{jFa(p,i);f[n>>2]=(f[n>>2]|0)+12}x=x+1|0;y=f[j>>2]|0}while(x>>>0<(f[C>>2]|0)-y>>3>>>0)}y=f[g>>2]|0;C=f[l>>2]|0;do if(C){x=d+4|0;j=C;$=C;while(1){F=f[j+16>>2]|0;if((F|0)>(y|0)){aa=f[j>>2]|0;if(!aa){s=63;break}else{ba=j;ca=aa}}else{if((F|0)>=(y|0)){s=67;break}da=j+4|0;F=f[da>>2]|0;if(!F){s=66;break}else{ba=da;ca=F}}x=ba;j=ca;$=ca}if((s|0)==63){ea=j;fa=j;s=70;break}else if((s|0)==66){ea=da;fa=j;s=70;break}else if((s|0)==67){ga=j;ha=x;ia=$;s=69;break}}else{ga=l;ha=l;ia=C;s=69}while(0);if((s|0)==69)if(!ia){ea=ha;fa=ga;s=70}else{ja=ia;ka=y;la=C}if((s|0)==70){C=VDc(60)|0;f[C+16>>2]=y;y=C+20|0;D=y;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[y+36>>0]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=fa;f[ea>>2]=C;fa=f[f[d>>2]>>2]|0;if(!fa)ma=C;else{f[d>>2]=fa;ma=f[ea>>2]|0}laa(f[d+4>>2]|0,ma);ma=d+8|0;f[ma>>2]=(f[ma>>2]|0)+1;ja=C;ka=f[g>>2]|0;la=f[l>>2]|0}C=ja+20|0;do if(la){ja=d+4|0;ma=la;ea=la;while(1){fa=f[ma+16>>2]|0;if((fa|0)>(ka|0)){y=f[ma>>2]|0;if(!y){s=78;break}else{na=ma;oa=y}}else{if((fa|0)>=(ka|0)){s=82;break}pa=ma+4|0;fa=f[pa>>2]|0;if(!fa){s=81;break}else{na=pa;oa=fa}}ja=na;ma=oa;ea=oa}if((s|0)==78){qa=ma;ra=ma;s=85;break}else if((s|0)==81){qa=pa;ra=ma;s=85;break}else if((s|0)==82){sa=ma;ta=ja;ua=ea;s=84;break}}else{sa=l;ta=l;ua=la;s=84}while(0);if((s|0)==84)if(!ua){qa=ta;ra=sa;s=85}else{va=ua;wa=ka;xa=la}if((s|0)==85){la=VDc(60)|0;f[la+16>>2]=ka;ka=la+20|0;D=ka;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[ka+36>>0]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=ra;f[qa>>2]=la;ra=f[f[d>>2]>>2]|0;if(!ra)ya=la;else{f[d>>2]=ra;ya=f[qa>>2]|0}laa(f[d+4>>2]|0,ya);ya=d+8|0;f[ya>>2]=(f[ya>>2]|0)+1;va=la;wa=f[g>>2]|0;xa=f[l>>2]|0}la=va+32|0;do if(xa){va=d+4|0;ya=xa;qa=xa;while(1){ra=f[ya+16>>2]|0;if((ra|0)>(wa|0)){ka=f[ya>>2]|0;if(!ka){s=93;break}else{za=ya;Aa=ka}}else{if((ra|0)>=(wa|0)){s=97;break}Ba=ya+4|0;ra=f[Ba>>2]|0;if(!ra){s=96;break}else{za=Ba;Aa=ra}}va=za;ya=Aa;qa=Aa}if((s|0)==93){Ca=ya;Da=ya;s=100;break}else if((s|0)==96){Ca=Ba;Da=ya;s=100;break}else if((s|0)==97){Ea=ya;Fa=va;Ga=qa;s=99;break}}else{Ea=l;Fa=l;Ga=xa;s=99}while(0);if((s|0)==99)if(!Ga){Ca=Fa;Da=Ea;s=100}else Ha=Ga;if((s|0)==100){Ga=VDc(60)|0;f[Ga+16>>2]=wa;wa=Ga+20|0;D=wa;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[wa+36>>0]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=Da;f[Ca>>2]=Ga;Da=f[f[d>>2]>>2]|0;if(!Da)Ia=Ga;else{f[d>>2]=Da;Ia=f[Ca>>2]|0}laa(f[d+4>>2]|0,Ia);Ia=d+8|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Ha=Ga}Ga=(AGa(c,g)|0)+92|0;Ia=f[Ga>>2]|0;oGa(h,AGa(c,g)|0);c=f[h+4>>2]|0;Ga=_h[f[(f[c>>2]|0)+92>>2]&127](c,C,Ia,la,Ha+44|0)|0;Ha=f[g>>2]|0;g=f[l>>2]|0;do if(g){la=d+4|0;Ia=g;C=g;while(1){c=f[Ia+16>>2]|0;if((c|0)>(Ha|0)){Ca=f[Ia>>2]|0;if(!Ca){s=108;break}else{Ja=Ia;Ka=Ca}}else{if((c|0)>=(Ha|0)){s=112;break}La=Ia+4|0;c=f[La>>2]|0;if(!c){s=111;break}else{Ja=La;Ka=c}}la=Ja;Ia=Ka;C=Ka}if((s|0)==108){Ma=Ia;Na=Ia;s=115;break}else if((s|0)==111){Ma=La;Na=Ia;s=115;break}else if((s|0)==112){Oa=Ia;Pa=la;Qa=C;s=114;break}}else{Oa=l;Pa=l;Qa=g;s=114}while(0);if((s|0)==114)if(!Qa){Ma=Pa;Na=Oa;s=115}else Ra=Qa;if((s|0)==115){s=VDc(60)|0;f[s+16>>2]=Ha;Ha=s+20|0;D=Ha;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[Ha+36>>0]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=Na;f[Ma>>2]=s;Na=f[f[d>>2]>>2]|0;if(!Na)Sa=s;else{f[d>>2]=Na;Sa=f[Ma>>2]|0}laa(f[d+4>>2]|0,Sa);Sa=d+8|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Ra=s}b[Ra+56>>0]=Ga&1;Ga=f[h>>2]|0;if(!Ga){u=e;return}h=Ga+4|0;Ra=f[h>>2]|0;f[h>>2]=Ra+-1;if((Ra|0)!=1){u=e;return}Yi[f[(f[Ga>>2]|0)+8>>2]&2047](Ga);u=e;return}function xHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+208|0;g=e;h=e+184|0;i=e+192|0;j=e+168|0;k=e+104|0;l=e+112|0;m=e+40|0;n=e+48|0;o=e+32|0;p=e+16|0;q=f[d>>2]|0;f[h>>2]=q;r=h+4|0;s=f[d+4>>2]|0;f[r>>2]=s;if(!q)t=s;else{s=q+-4|0;f[s>>2]=(f[s>>2]|0)+1;t=f[r>>2]|0}if(!t){vGa(i,a);t=i+4|0;s=f[t>>2]|0;q=s+-8|0;if((q|0)!=(h|0)){uT(h);d=f[q>>2]|0;if(!d)v=0;else{w=d+-4|0;f[w>>2]=(f[w>>2]|0)+1;v=f[q>>2]|0}f[h>>2]=v;f[r>>2]=f[s+-4>>2]}s=f[i>>2]|0;if(s|0){while(1){v=f[t>>2]|0;if((v|0)==(s|0))break;q=v+-8|0;f[t>>2]=q;uT(q)}YDc(f[i>>2]|0)}}i=a+4|0;nGa(g,f[i>>2]|0,h);f[j>>2]=0;a=j+4|0;f[a>>2]=0;f[j+8>>2]=0;t=VDc(8)|0;f[j>>2]=t;f[j+8>>2]=t+8;s=g;q=f[s+4>>2]|0;v=t;f[v>>2]=f[s>>2];f[v+4>>2]=q;f[a>>2]=t+8;wGa(f[i>>2]|0,j);t=f[i>>2]|0;yGa(t,xGa(t,h)|0,1);nGa(k,f[i>>2]|0,h);t=AGa((f[i>>2]|0)+20|0,k)|0;a:do if((d$(c)|0)!=655360){if((d$(c)|0)==65536){k=f[i>>2]|0;q=f[h>>2]|0;f[o>>2]=q;f[o+4>>2]=f[r>>2];if(q|0){v=q+-4|0;f[v>>2]=(f[v>>2]|0)+1}nGa(g,k,o);zGa(n,k,g);b0(c,n);k=n+36|0;v=f[k>>2]|0;if(v|0?(q=v+12|0,v=f[q>>2]|0,f[q>>2]=v+-1,(v|0)==1):0)_S(n);f[k>>2]=0;k=n+16|0;v=n+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[v>>2]|0)>0){k=f[n+40>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[v>>2]|0))}v=f[n+44>>2]|0;if((v|0)!=(n+48|0))g0(v);uT(o);break}if((d$(c)|0)==327680){b:do if(f[(f[i>>2]|0)+84>>2]|0?(v=t+108|0,q=t+112|0,k=f[v>>2]|0,(f[q>>2]|0)!=(k|0)):0){s=0;w=k;while(1){k=f[w+(s<<3)+4>>2]|0;if(!k)break;Yi[f[(f[k>>2]|0)+8>>2]&2047](k);s=s+1|0;w=f[v>>2]|0;if(s>>>0>=(f[q>>2]|0)-w>>3>>>0)break b}f[g>>2]=0;f[g+4>>2]=0;w=tT(g,34)|0;q=380970;s=w+34|0;do{b[w>>0]=b[q>>0]|0;w=w+1|0;q=q+1|0}while((w|0)<(s|0));z5(-215,g,453206,376410,2571)}while(0);q=t+152|0;w=f[q>>2]|0;s=f[c+4>>2]|0;if((f[w>>2]&7|0)==5){if((s|0)==(q|0))break;XGa(s,w,f[t+156>>2]|0);break}g$(s,((f[t+156>>2]|0)-w|0)/56|0);w=s+4|0;v=f[s>>2]|0;if((f[w>>2]|0)==(v|0))break;k=g+8|0;d=g+12|0;x=g+4|0;y=n+8|0;z=n+4|0;A=0;B=v;while(1){v=(f[q>>2]|0)+(A*56|0)|0;f[k>>2]=0;f[d>>2]=0;f[g>>2]=16842752;f[x>>2]=v;v=y;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[z>>2]=B+(A*56|0);NZ(g,n);A=A+1|0;B=f[s>>2]|0;if(A>>>0>=(((f[w>>2]|0)-B|0)/56|0)>>>0)break a}}if((d$(c)|0)==720896){B=f[c+4>>2]|0;w=f[i>>2]|0;if((f[w+80>>2]|0)==3?(A=f[w+84>>2]|0,(A+-1|0)>>>0<2):0){switch(A|0){case 1:{CGa(g,t+108|0);if((B|0)!=(g|0))_Ga(B,f[g>>2]|0,f[g+4>>2]|0);A=f[g>>2]|0;if(A|0){w=g+4|0;while(1){s=f[w>>2]|0;if((s|0)==(A|0))break;z=s+-48|0;f[w>>2]=z;GQ(z)}YDc(f[g>>2]|0)}break a;break}case 2:break;default:break a}CGa(g,t+108|0);w=g+4|0;A=((f[w>>2]|0)-(f[g>>2]|0)|0)/48|0;z=B+4|0;s=f[z>>2]|0;y=f[B>>2]|0;x=(s-y|0)/48|0;d=y;y=s;if(A>>>0<=x>>>0){if(A>>>0<x>>>0?(s=d+(A*48|0)|0,(y|0)!=(s|0)):0){d=y;do{y=d+-48|0;f[z>>2]=y;GQ(y);d=f[z>>2]|0}while((d|0)!=(s|0))}}else j$(B,A-x|0);s=f[w>>2]|0;d=f[g>>2]|0;z=d;if((s|0)==(d|0)){C=s;D=z}else{s=n+8|0;d=n+12|0;y=n+4|0;k=p+8|0;q=p+4|0;v=0;E=z;while(1){f[s>>2]=0;f[d>>2]=0;f[n>>2]=17432576;f[y>>2]=E+(v*48|0);z=(f[B>>2]|0)+(v*48|0)|0;F=k;f[F>>2]=0;f[F+4>>2]=0;f[p>>2]=34209792;f[q>>2]=z;NZ(n,p);v=v+1|0;z=f[w>>2]|0;F=f[g>>2]|0;G=F;if(v>>>0>=((z-F|0)/48|0)>>>0){C=z;D=G;break}else E=G}}if(D|0){E=C;if((E|0)!=(D|0)){v=E;do{E=v+-48|0;f[w>>2]=E;GQ(E);v=f[w>>2]|0}while((v|0)!=(D|0))}YDc(f[g>>2]|0)}break}v=t+152|0;w=((f[t+156>>2]|0)-(f[v>>2]|0)|0)/56|0;E=B+4|0;q=f[E>>2]|0;k=f[B>>2]|0;y=(q-k|0)/48|0;d=k;k=q;if(w>>>0<=y>>>0)if(w>>>0<y>>>0?(s=d+(w*48|0)|0,(k|0)!=(s|0)):0){d=k;do{k=d+-48|0;f[E>>2]=k;GQ(k);d=f[E>>2]|0}while((d|0)!=(s|0));H=d}else H=q;else{j$(B,w-y|0);H=f[E>>2]|0}s=f[B>>2]|0;if((H|0)!=(s|0)){k=g+8|0;x=g+4|0;A=0;G=s;do{s=(f[v>>2]|0)+(A*56|0)|0;z=k;f[z>>2]=0;f[z+4>>2]=0;f[g>>2]=34209792;f[x>>2]=G+(A*48|0);h_(s,g);A=A+1|0;G=f[B>>2]|0}while(A>>>0<(((f[E>>2]|0)-G|0)/48|0)>>>0)}}}else{G=f[i>>2]|0;E=f[h>>2]|0;f[m>>2]=E;f[m+4>>2]=f[r>>2];if(E|0){A=E+-4|0;f[A>>2]=(f[A>>2]|0)+1}nGa(g,G,m);zGa(l,G,g);h_(l,c);G=l+36|0;A=f[G>>2]|0;if(A|0?(E=A+12|0,A=f[E>>2]|0,f[E>>2]=A+-1,(A|0)==1):0)_S(l);f[G>>2]=0;G=l+16|0;A=l+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){G=f[l+40>>2]|0;E=0;do{f[G+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[A>>2]|0))}A=f[l+44>>2]|0;if((A|0)!=(l+48|0))g0(A);uT(m)}while(0);m=f[j>>2]|0;if(!m){uT(h);u=e;return}j=f[a>>2]|0;if((j|0)!=(m|0))f[a>>2]=j+(~((j+-8-m|0)>>>3)<<3);YDc(m);uT(h);u=e;return}function yHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+96|0;e=d+16|0;g=d;h=d+80|0;i=d+24|0;f[h>>2]=0;j=h+4|0;f[j>>2]=0;f[h+8>>2]=0;k=c+4|0;l=f[c>>2]|0;if((f[k>>2]|0)==(l|0))m=a+4|0;else{n=a+4|0;a=h+8|0;o=0;p=l;do{nGa(g,f[n>>2]|0,p+(o<<3)|0);l=f[j>>2]|0;if((l|0)==(f[a>>2]|0))kGa(h,g);else{q=g;r=f[q+4>>2]|0;s=l;f[s>>2]=f[q>>2];f[s+4>>2]=r;f[j>>2]=(f[j>>2]|0)+8}o=o+1|0;p=f[c>>2]|0}while(o>>>0<(f[k>>2]|0)-p>>3>>>0);m=n}wGa(f[m>>2]|0,h);n=f[h>>2]|0;p=f[j>>2]|0;a:do if((n|0)!=(p|0)?(k=n+8|0,(k|0)!=(p|0)):0){o=n;c=k;k=f[n>>2]|0;while(1){a=o+4|0;r=o;s=c;while(1){q=f[s>>2]|0;if((k|0)<(q|0)){t=q;break}if((k|0)==(q|0)?(f[a>>2]|0)<(f[r+12>>2]|0):0){t=k;break}q=s+8|0;if((q|0)==(p|0)){v=o;break a}else{l=s;s=q;r=l}}c=s+8|0;if((c|0)==(p|0)){v=s;break}else{o=s;k=t}}}else v=n;while(0);n=f[v>>2]|0;v=f[m>>2]|0;t=v+24|0;p=f[t>>2]|0;if(!p){f[e>>2]=n;F5(g,378114,e);z5(-204,g,378151,376410,1170)}else{w=t;x=p}b:while(1){p=x;while(1){if((f[p+16>>2]|0)>=(n|0))break;k=f[p+4>>2]|0;if(!k){y=w;break b}else p=k}x=f[p>>2]|0;if(!x){y=p;break}else w=p}if((y|0)==(t|0)){f[e>>2]=n;F5(g,378114,e);z5(-204,g,378151,376410,1170)}if((f[y+16>>2]|0)>(n|0)){f[e>>2]=n;F5(g,378114,e);z5(-204,g,378151,376410,1170)}yGa(v,y+20|0,1);f[g>>2]=0;y=g+4|0;f[y>>2]=0;f[g+8>>2]=0;v=f[h>>2]|0;if((f[j>>2]|0)!=(v|0)){e=g+8|0;n=i+36|0;t=i+16|0;w=i+4|0;x=i+40|0;k=i+44|0;o=i+48|0;c=i+8|0;r=i+12|0;a=i+20|0;l=i+24|0;q=i+28|0;z=i+32|0;A=0;B=v;do{zGa(i,f[m>>2]|0,B+(A<<3)|0);v=f[y>>2]|0;if((v|0)==(f[e>>2]|0))Bxa(g,i);else{f[v>>2]=f[i>>2];C=v+4|0;f[C>>2]=f[w>>2];D=v+8|0;f[D>>2]=f[c>>2];f[v+12>>2]=f[r>>2];f[v+16>>2]=f[t>>2];f[v+20>>2]=f[a>>2];f[v+24>>2]=f[l>>2];f[v+28>>2]=f[q>>2];f[v+32>>2]=f[z>>2];E=f[n>>2]|0;f[v+36>>2]=E;f[v+40>>2]=D;D=v+48|0;F=v+44|0;f[F>>2]=D;f[D>>2]=0;f[v+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[w>>2]|0)<3){D=f[k>>2]|0;E=f[F>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[C>>2]=0;ZS(v,i)}f[y>>2]=(f[y>>2]|0)+56}v=f[n>>2]|0;if(v|0?(C=v+12|0,v=f[C>>2]|0,f[C>>2]=v+-1,(v|0)==1):0)_S(i);f[n>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){v=f[x>>2]|0;C=0;do{f[v+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[w>>2]|0))}C=f[k>>2]|0;if((C|0)!=(o|0))g0(C);A=A+1|0;B=f[h>>2]|0}while(A>>>0<(f[j>>2]|0)-B>>3>>>0)}B=f[b+4>>2]|0;if((B|0)!=(g|0))XGa(B,f[g>>2]|0,f[y>>2]|0);mx(g);g=f[h>>2]|0;if(!g){u=d;return}h=f[j>>2]|0;if((h|0)!=(g|0))f[j>>2]=h+(~((h+-8-g|0)>>>3)<<3);YDc(g);u=d;return}function zHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;i=(f[(f[a+4>>2]|0)+4>>2]|0)+36|0;f[g>>2]=f[b>>2];f[h>>2]=f[b+4>>2];f[e>>2]=f[g>>2];f[d>>2]=f[h>>2];AHa(i,e,d);u=c;return}function AHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=f[b>>2]|0;b=f[c>>2]|0;e=b-d>>3;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=d;k=i;l=b;if(e>>>0>h-i>>3>>>0){if(!i)m=h;else{h=a+4|0;while(1){n=f[h>>2]|0;if((n|0)==(k|0))break;o=n+-8|0;f[h>>2]=o;uT(o)}YDc(f[a>>2]|0);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;m=0}if(e>>>0>536870911)mCc(a);h=m>>2;o=m>>3>>>0<268435455?(h>>>0<e>>>0?e:h):536870911;if(o>>>0>536870911)mCc(a);h=VDc(o<<3)|0;m=a+4|0;f[m>>2]=h;f[a>>2]=h;f[g>>2]=h+(o<<3);if((j|0)==(l|0))return;o=d;d=j;g=h;while(1){h=f[d>>2]|0;f[g>>2]=h;f[g+4>>2]=f[d+4>>2];if(!h)p=d;else{n=h+-4|0;f[n>>2]=(f[n>>2]|0)+1;p=o}n=p+8|0;h=(f[m>>2]|0)+8|0;f[m>>2]=h;if((n|0)==(l|0))break;else{o=n;d=n;g=h}}return}g=a+4|0;a=(f[g>>2]|0)-i>>3;i=e>>>0>a>>>0;e=j+(a<<3)|0;a=i?e:b;if((j|0)==(a|0))q=k;else{b=k;k=j;while(1){if((k|0)!=(b|0)){uT(b);j=f[k>>2]|0;if(!j)r=0;else{d=j+-4|0;f[d>>2]=(f[d>>2]|0)+1;r=f[k>>2]|0}f[b>>2]=r;f[b+4>>2]=f[k+4>>2]}k=k+8|0;d=b+8|0;if((k|0)==(a|0)){q=d;break}else b=d}}if(!i){while(1){i=f[g>>2]|0;if((i|0)==(q|0))break;b=i+-8|0;f[g>>2]=b;uT(b)}return}q=f[c>>2]|0;if((a|0)==(q|0))return;c=e;e=a;a=f[g>>2]|0;while(1){b=f[e>>2]|0;f[a>>2]=b;f[a+4>>2]=f[e+4>>2];if(!b)s=e;else{i=b+-4|0;f[i>>2]=(f[i>>2]|0)+1;s=c}i=s+8|0;b=(f[g>>2]|0)+8|0;f[g>>2]=b;if((i|0)==(q|0))break;else{c=i;e=i;a=b}}return}function BHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=u;u=u+160|0;i=h;j=h+144|0;k=h+136|0;l=h+120|0;m=h+64|0;n=h+8|0;o=k+4|0;f[o>>2]=-1;f[k>>2]=0;q=a+4|0;a=(f[q>>2]|0)+24|0;r=f[a>>2]|0;if(!r){f[i>>2]=0;F5(j,378114,i);z5(-204,j,378151,376410,1170)}else{s=a;t=r}a:while(1){r=t;while(1){if((f[r+16>>2]|0)>=0)break;v=f[r+4>>2]|0;if(!v){w=s;break a}else r=v}t=f[r>>2]|0;if(!t){w=r;break}else s=r}if((w|0)==(a|0)){f[i>>2]=0;F5(j,378114,i);z5(-204,j,378151,376410,1170)}if((f[w+16>>2]|0)>0){f[i>>2]=0;F5(j,378114,i);z5(-204,j,378151,376410,1170)}i=d+4|0;if(!(f[i>>2]|0)){x=0;y=0}else{oGa(j,w+20|0);w=j+4|0;a=f[w>>2]|0;s=Mi[f[(f[a>>2]|0)+52>>2]&1023](a,d)|0;a=f[j>>2]|0;if(a|0?(t=a+4|0,v=f[t>>2]|0,f[t>>2]=v+-1,(v|0)==1):0)Yi[f[(f[a>>2]|0)+8>>2]&2047](a);f[j>>2]=0;f[w>>2]=0;x=s;y=f[k>>2]|0}f[o>>2]=x;if((y|x|0)<0){f[l>>2]=0;x=l+4|0;f[x>>2]=0;tT(l,(f[i>>2]|0)+16|0)|0;y=f[l>>2]|0;z=y;s=381005;A=z+16|0;do{b[z>>0]=b[s>>0]|0;z=z+1|0;s=s+1|0}while((z|0)<(A|0));w=f[i>>2]|0;if(w|0)dJc(y+16|0,f[d>>2]|0,w|0)|0;f[j>>2]=0;f[j+4>>2]=0;tT(j,(f[x>>2]|0)+11|0)|0;w=f[x>>2]|0;if(!w){B=0;C=f[j>>2]|0;D=C+B|0;z=D;s=378838;A=z+11|0;do{b[z>>0]=b[s>>0]|0;z=z+1|0;s=s+1|0}while((z|0)<(A|0));z5(-204,j,381022,376410,2727)}dJc(f[j>>2]|0,f[l>>2]|0,w|0)|0;B=f[x>>2]|0;C=f[j>>2]|0;D=C+B|0;z=D;s=378838;A=z+11|0;do{b[z>>0]=b[s>>0]|0;z=z+1|0;s=s+1|0}while((z|0)<(A|0));z5(-204,j,381022,376410,2727)}s=AGa((f[q>>2]|0)+20|0,k)|0;k=(f[o>>2]|0)+1|0;D=f[s+92>>2]|0;B=(k|0)<(D|0)?D:k;k=s+152|0;g$(k,B);D=s+108|0;C=s+112|0;s=f[C>>2]|0;x=f[D>>2]|0;w=s-x>>3;d=x;x=s;if(B>>>0<=w>>>0){if(B>>>0<w>>>0?(s=d+(B<<3)|0,(x|0)!=(s|0)):0){d=x;do{x=d+-8|0;f[C>>2]=x;y=f[x>>2]|0;if(y|0?(i=y+4|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)Yi[f[(f[y>>2]|0)+8>>2]&2047](y);f[x>>2]=0;f[d+-4>>2]=0;d=f[C>>2]|0}while((d|0)!=(s|0))}}else iHa(D,B-w|0);g$((f[(f[q>>2]|0)+4>>2]|0)+72|0,B);w=f[(f[q>>2]|0)+4>>2]|0;s=w+48|0;d=w+52|0;C=f[d>>2]|0;x=f[s>>2]|0;y=C-x>>3;a=x;x=C;if(B>>>0<=y>>>0)if(B>>>0<y>>>0?(C=a+(B<<3)|0,(x|0)!=(C|0)):0){f[d>>2]=x+(~((x+-8-C|0)>>>3)<<3);E=w}else E=w;else{cha(s,B-y|0);E=f[(f[q>>2]|0)+4>>2]|0}y=E+60|0;s=E+64|0;w=f[s>>2]|0;C=f[y>>2]|0;x=w-C>>5;d=C;C=w;if(B>>>0<=x>>>0)if(B>>>0<x>>>0?(w=d+(B<<5)|0,(C|0)!=(w|0)):0){f[s>>2]=C+(~((C+-32-w|0)>>>5)<<5);F=E}else F=E;else{CHa(y,B-x|0);F=f[(f[q>>2]|0)+4>>2]|0}x=f[o>>2]|0;B=f[F+72>>2]|0;F=f[B+(x*56|0)+4>>2]|0;y=f[B+(x*56|0)+40>>2]|0;f[l>>2]=0;x=l+4|0;f[x>>2]=0;f[l+8>>2]=0;lFa(l,y,y+(F<<2)|0);do if((d$(c)|0)==65536){F=f[c+4>>2]|0;f[m>>2]=f[F>>2];y=m+4|0;B=F+4|0;f[y>>2]=f[B>>2];E=m+8|0;f[E>>2]=f[F+8>>2];f[m+12>>2]=f[F+12>>2];f[m+16>>2]=f[F+16>>2];f[m+20>>2]=f[F+20>>2];f[m+24>>2]=f[F+24>>2];f[m+28>>2]=f[F+28>>2];f[m+32>>2]=f[F+32>>2];w=f[F+36>>2]|0;f[m+36>>2]=w;C=m+40|0;f[C>>2]=E;E=m+48|0;s=m+44|0;f[s>>2]=E;f[E>>2]=0;f[m+52>>2]=0;if(w|0){E=w+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[B>>2]|0)<3){B=f[F+44>>2]|0;E=f[s>>2]|0;f[E>>2]=f[B>>2];f[E+4>>2]=f[B+4>>2];G=y;H=C;break}else{f[y>>2]=0;ZS(m,F);G=y;H=C;break}}else{a$(m,c,-1);G=m+4|0;H=m+40|0}while(0);c=f[G>>2]|0;C=f[H>>2]|0;f[j>>2]=0;y=j+4|0;f[y>>2]=0;f[j+8>>2]=0;lFa(j,C,C+(c<<2)|0);c=f[x>>2]|0;C=f[l>>2]|0;F=f[y>>2]|0;B=f[j>>2]|0;E=C;s=c;w=B;d=F;b:do if((c-C|0)==(F-B|0))if((E|0)==(s|0))I=1;else{a=E;i=w;while(1){if((f[a>>2]|0)!=(f[i>>2]|0)){I=0;break b}a=a+4|0;if((a|0)==(s|0)){I=1;break}else i=i+4|0}}else I=0;while(0);s=B;if(B|0){if((d|0)!=(w|0))f[y>>2]=d+(~((d+-4-B|0)>>>2)<<2);YDc(s)}if(!I){f[n>>2]=1124007936;s=n+4|0;B=n+8|0;d=n+40|0;z=s;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[d>>2]=B;z=n+48|0;A=n+44|0;f[A>>2]=z;f[z>>2]=0;f[n+52>>2]=0;y=j+8|0;f[y>>2]=0;f[y+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=n;h_(m,j);y=f[o>>2]|0;w=f[k>>2]|0;E=w+(y*56|0)|0;F=n+36|0;if((E|0)!=(n|0)){C=f[F>>2]|0;if(C|0){c=C+12|0;f[c>>2]=(f[c>>2]|0)+1}c=w+(y*56|0)+36|0;C=f[c>>2]|0;if(C|0?(i=C+12|0,C=f[i>>2]|0,f[i>>2]=C+-1,(C|0)==1):0)_S(E);f[c>>2]=0;C=w+(y*56|0)+16|0;i=w+(y*56|0)+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[i>>2]|0)>0){a=f[w+(y*56|0)+40>>2]|0;r=0;do{f[a+(r<<2)>>2]=0;r=r+1|0;J=f[i>>2]|0}while((r|0)<(J|0));f[E>>2]=f[n>>2];if((J|0)<3)K=66;else K=68}else{f[E>>2]=f[n>>2];K=66}if((K|0)==66){J=f[s>>2]|0;if((J|0)<3){f[i>>2]=J;f[w+(y*56|0)+8>>2]=f[B>>2];f[w+(y*56|0)+12>>2]=f[n+12>>2];B=f[A>>2]|0;J=f[w+(y*56|0)+44>>2]|0;f[J>>2]=f[B>>2];f[J+4>>2]=f[B+4>>2]}else K=68}if((K|0)==68)ZS(E,n);f[C>>2]=f[n+16>>2];f[w+(y*56|0)+20>>2]=f[n+20>>2];f[w+(y*56|0)+24>>2]=f[n+24>>2];f[w+(y*56|0)+28>>2]=f[n+28>>2];f[w+(y*56|0)+32>>2]=f[n+32>>2];f[c>>2]=f[F>>2]}c=f[F>>2]|0;if(c|0?(y=c+12|0,c=f[y>>2]|0,f[y>>2]=c+-1,(c|0)==1):0)_S(n);f[F>>2]=0;F=n+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[s>>2]|0)>0){F=f[d>>2]|0;d=0;do{f[F+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[s>>2]|0))}s=f[A>>2]|0;if((s|0)!=(z|0))g0(s);s=f[o>>2]|0;z=f[k>>2]|0;k=z+(s*56|0)|0;A=f[(f[(f[q>>2]|0)+4>>2]|0)+72>>2]|0;d=A+(s*56|0)|0;if((A|0)!=(z|0)){F=z+(s*56|0)+36|0;n=f[F>>2]|0;if(n|0){c=n+12|0;f[c>>2]=(f[c>>2]|0)+1}c=A+(s*56|0)+36|0;n=f[c>>2]|0;do if(n|0){y=n+12|0;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break;_S(d)}while(0);f[c>>2]=0;n=A+(s*56|0)+16|0;w=A+(s*56|0)+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[w>>2]|0)>0){y=f[A+(s*56|0)+40>>2]|0;C=0;do{f[y+(C<<2)>>2]=0;C=C+1|0;L=f[w>>2]|0}while((C|0)<(L|0));f[d>>2]=f[k>>2];if((L|0)<3)K=89;else K=91}else{f[d>>2]=f[k>>2];K=89}do if((K|0)==89){L=f[z+(s*56|0)+4>>2]|0;if((L|0)>=3){K=91;break}f[w>>2]=L;f[A+(s*56|0)+8>>2]=f[z+(s*56|0)+8>>2];f[A+(s*56|0)+12>>2]=f[z+(s*56|0)+12>>2];L=f[z+(s*56|0)+44>>2]|0;C=f[A+(s*56|0)+44>>2]|0;f[C>>2]=f[L>>2];f[C+4>>2]=f[L+4>>2]}while(0);if((K|0)==91)ZS(d,k);f[n>>2]=f[z+(s*56|0)+16>>2];f[A+(s*56|0)+20>>2]=f[z+(s*56|0)+20>>2];f[A+(s*56|0)+24>>2]=f[z+(s*56|0)+24>>2];f[A+(s*56|0)+28>>2]=f[z+(s*56|0)+28>>2];f[A+(s*56|0)+32>>2]=f[z+(s*56|0)+32>>2];f[c>>2]=f[F>>2]}}else{F=(f[(f[(f[q>>2]|0)+4>>2]|0)+72>>2]|0)+((f[o>>2]|0)*56|0)|0;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=F;h_(m,j)}j=f[o>>2]|0;F=f[(f[D>>2]|0)+(j<<3)+4>>2]|0;if(!F)M=j;else{Yi[f[(f[F>>2]|0)+12>>2]&2047](F);M=f[o>>2]|0}o=f[(f[q>>2]|0)+4>>2]|0;p[(f[o+48>>2]|0)+(M<<3)>>3]=e;F=(f[o+60>>2]|0)+(M<<5)|0;f[F>>2]=f[g>>2];f[F+4>>2]=f[g+4>>2];f[F+8>>2]=f[g+8>>2];f[F+12>>2]=f[g+12>>2];f[F+16>>2]=f[g+16>>2];f[F+20>>2]=f[g+20>>2];f[F+24>>2]=f[g+24>>2];f[F+28>>2]=f[g+28>>2];g=(f[q>>2]|0)+116|0;b[g>>0]=I&(b[g>>0]|0)!=0&1;g=m+36|0;I=f[g>>2]|0;if(I|0?(q=I+12|0,I=f[q>>2]|0,f[q>>2]=I+-1,(I|0)==1):0)_S(m);f[g>>2]=0;g=m+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[G>>2]|0)>0){g=f[H>>2]|0;H=0;do{f[g+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[G>>2]|0))}G=f[m+44>>2]|0;if((G|0)!=(m+48|0))g0(G);G=f[l>>2]|0;if(!G){u=h;return}l=f[x>>2]|0;if((l|0)!=(G|0))f[x>>2]=l+(~((l+-4-G|0)>>>2)<<2);YDc(G);u=h;return}function CHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>5>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;i=(f[e>>2]|0)+32|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>5;g=i+b|0;if(g>>>0>134217727)mCc(a);j=d-h|0;h=j>>4;d=j>>5>>>0<67108863?(h>>>0<g>>>0?g:h):134217727;do if(d)if(d>>>0>134217727){h=af(8)|0;bEc(h,503977);f[h>>2]=185532;ig(h|0,23696,1627)}else{k=VDc(d<<5)|0;break}else k=0;while(0);h=k+(i<<5)|0;i=h;g=k+(d<<5)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;b=k+32|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-32-j|0;j=b;b=h;while(1){n=j;j=j+-32|0;p[b+-32>>3]=+p[j>>3];p[b+-24>>3]=+p[n+-24>>3];p[b+-16>>3]=+p[n+-16>>3];p[b+-8>>3]=+p[n+-8>>3];if((j|0)==(g|0))break;else b=b+-32|0}l=h+(~(i>>>5)<<5)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;YDc(m);return}function DHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;d=u;u=u+16|0;e=d;g=d+8|0;h=(c|0)==-1;if(h){i=f[a>>2]|0;switch(i|0){case 0:{j=f[a+4>>2]|0;k=j+4|0;l=j;m=j;n=j;break}case 3:{j=f[a+4>>2]|0;k=j+4|0;l=j;m=j;n=j;break}case 2:{j=f[a+4>>2]|0;k=j+4|0;l=j;m=j;n=j;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}if((f[k>>2]|0)==1){o=i;q=l;r=m;s=n}else t=15}else if((c|0)>-1){n=f[a>>2]|0;switch(n|0){case 0:{m=f[a+4>>2]|0;v=m+4|0;w=m;x=m;y=m;break}case 3:{m=f[a+4>>2]|0;v=m+4|0;w=m;x=m;y=m;break}case 2:{m=f[a+4>>2]|0;v=m+4|0;w=m;x=m;y=m;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}if((f[v>>2]|0)>(c|0)){o=n;q=w;r=x;s=y}else t=15}else t=15;if((t|0)==15){f[e>>2]=0;f[e+4>>2]=0;z=tT(e,56)|0;A=382656;B=z+56|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,e,382158,451988,88)}t=h?0:c;switch(o|0){case 0:{c=(f[q>>2]|0)+(t<<3)|0;C=f[c+4>>2]|0;D=f[c>>2]|0;J=C;u=d;return D|0}case 2:{E=+p[(f[r>>2]|0)+(t<<3)>>3];if(!(+jrc(E,e)==0.0)){f[g>>2]=0;f[g+4>>2]=0;z=tT(g,15)|0;A=381112;B=z+15|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,g,382158,451988,101)}C=+L(E)>=1.0?(E>0.0?~~+Z(+K(E/4294967296.0),4294967295.0)>>>0:~~+X((E-+(~~E>>>0))/4294967296.0)>>>0):0;D=~~E>>>0;J=C;u=d;return D|0}case 3:{g=f[(f[s>>2]|0)+(t<<3)>>2]|0;t=vrc((g|0)==0?1154740:g)|0;C=((t|0)<0)<<31>>31;D=t;J=C;u=d;return D|0}default:if((o|2|0)==2){C=0;D=0;J=C;u=d;return D|0}else{f[e>>2]=0;f[e+4>>2]=0;z=tT(e,33)|0;A=381128;B=z+33|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,e,382158,451988,111)}}return 0}function EHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if((f[c>>2]|0)!=3){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,10)|0;i=381031;j=h+10|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-215,g,382158,451988,178)}k=(d|0)==-1;if(k){l=f[c+4>>2]|0;if((f[l+4>>2]|0)==1)m=l;else n=7}else if((d|0)>-1?(l=f[c+4>>2]|0,(f[l+4>>2]|0)>(d|0)):0)m=l;else n=7;if((n|0)==7){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,69)|0;i=381042;j=h+69|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-215,g,382158,451988,179)}g=k?0:d;d=f[m>>2]|0;m=f[d+(g<<3)>>2]|0;f[a>>2]=m;f[a+4>>2]=f[d+(g<<3)+4>>2];if(!m){u=e;return}g=m+-4|0;f[g>>2]=(f[g>>2]|0)+1;u=e;return}function FHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;f[a>>2]=0;e=a+4|0;f[e>>2]=0;f[a+8>>2]=0;g=b+4|0;b=f[g>>2]|0;h=f[b+20>>2]|0;if((h|0)==(b+24|0)){u=c;return}b=a+8|0;i=h;while(1){h=f[i+16>>2]|0;f[d>>2]=h;do if(!(f[i+112>>2]|0)){j=f[e>>2]|0;if((j|0)==(f[b>>2]|0)){g6(a,d);break}else{f[j>>2]=h;f[e>>2]=j+4;break}}while(0);h=f[i+4>>2]|0;if(!h){j=i+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(i|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==((f[g>>2]|0)+24|0))break;else i=l}u=c;return}function GHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>536870911)mCc(a);d=b<<3;e=VDc(d)|0;f[a>>2]=e;g=e+(b<<3)|0;f[a+8>>2]=g;XIc(e|0,0,d|0)|0;f[c>>2]=g;return}function HHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=a+4|0;d=f[c>>2]|0;a:do if(!d){e=c;g=c;h=d;i=12}else{j=a+4|0;k=f[b>>2]|0;l=(k|0)==0?1154740:k;m=f[d+16>>2]|0;b:do if((k|0)!=(m|0)){n=j;o=d;p=m;q=d;while(1){r=(p|0)==0?1154740:p;if((Ioc(l,r)|0)<0){s=f[o>>2]|0;if(!s){i=6;break}else{t=o;u=s}}else{if((Ioc(r,l)|0)>=0){v=n;w=o;x=q;break b}y=o+4|0;r=f[y>>2]|0;if(!r){i=9;break}else{t=y;u=r}}p=f[u+16>>2]|0;if((k|0)==(p|0)){v=t;w=u;x=u;break b}else{n=t;o=u;q=u}}if((i|0)==6){z=o;A=o;break a}else if((i|0)==9){z=y;A=o;break a}}else{v=j;w=d;x=d}while(0);e=v;g=w;h=x;i=12}while(0);if((i|0)==12)if(!h){z=e;A=g}else{B=h;C=B+24|0;return C|0}h=VDc(28)|0;g=f[b>>2]|0;f[h+16>>2]=g;f[h+20>>2]=f[b+4>>2];if(g|0){b=g+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[h+24>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=A;f[z>>2]=h;A=f[f[a>>2]>>2]|0;if(!A)D=h;else{f[a>>2]=A;D=f[z>>2]|0}laa(f[a+4>>2]|0,D);D=a+8|0;f[D>>2]=(f[D>>2]|0)+1;B=h;C=B+24|0;return C|0}function IHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>3;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>3>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>3;o=h>>>0>n>>>0;p=o?b+(n<<3)|0:c;c=p;n=c-e|0;e=n>>3;if(e|0)fJc(k|0,b|0,n|0)|0;n=l+(e<<3)|0;if(o){o=d-c|0;if((o|0)<=0)return;dJc(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>3<<3);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-8-k|0)>>>3)<<3);YDc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>536870911)mCc(a);j=q>>2;n=q>>3>>>0<268435455?(j>>>0<h>>>0?h:j):536870911;if(n>>>0>536870911)mCc(a);j=VDc(n<<3)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<3);if((g|0)<=0)return;dJc(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>3<<3);return}function JHa(a){a=a|0;var b=0;r0(a);f[a>>2]=77608;b=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;return}function KHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=b+12|0;d=a+4|0;if((d|0)!=(c|0))XGa(d,f[c>>2]|0,f[b+16>>2]|0);c=b+24|0;d=a+16|0;if((c|0)!=(d|0)){uT(d);e=f[c>>2]|0;if(!e)g=0;else{h=e+-4|0;f[h>>2]=(f[h>>2]|0)+1;g=f[c>>2]|0}f[d>>2]=g;f[a+20>>2]=f[b+28>>2]}g=b+32|0;d=a+24|0;if((g|0)==(d|0))return;uT(d);c=f[g>>2]|0;if(!c)i=0;else{h=c+-4|0;f[h>>2]=(f[h>>2]|0)+1;i=f[g>>2]|0}f[d>>2]=i;f[a+28>>2]=f[b+36>>2];return}function LHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+36>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33882112;f[g+4>>2]=c;Ti[h&511](a,e,g);u=d;return}function MHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+64|0;e=d+40|0;g=d+28|0;h=d+32|0;i=d+8|0;j=d;f[g>>2]=c;c=qGa()|0;m6(c);k=f[a>>2]|0;if(!k){f[h>>2]=0;f[h+4>>2]=0}else{l=a+4|0;m=f[l>>2]|0;f[e>>2]=0;n=e+4|0;f[n>>2]=0;if(m|0?(dJc(tT(e,m)|0,k|0,m|0)|0,f[l>>2]|0):0){m=0;do{k=(Jqc(b[(f[a>>2]|0)+m>>0]|0)|0)&255;b[(f[e>>2]|0)+m>>0]=k;m=m+1|0}while(m>>>0<(f[l>>2]|0)>>>0)}l=f[e>>2]|0;f[h>>2]=l;f[h+4>>2]=f[n>>2];if(l|0){n=l+-4|0;f[n>>2]=(f[n>>2]|0)+1}uT(e)}n=(rGa()|0)+4|0;l=f[n>>2]|0;if(l){m=f[h>>2]|0;a=(m|0)==0?1154740:m;k=n;o=l;a:while(1){l=o;while(1){p=f[l+16>>2]|0;if((p|0)==(m|0))break;if((Ioc((p|0)==0?1154740:p,a)|0)>=0)break;p=f[l+4>>2]|0;if(!p){q=k;break a}else l=p}o=f[l>>2]|0;if(!o){q=l;break}else k=l}if((q|0)!=(n|0)){k=f[q+16>>2]|0;if((m|0)!=(k|0)?(Ioc(a,(k|0)==0?1154740:k)|0)<0:0)r=19;else s=q}else r=19}else r=19;if((r|0)==19)s=n;do if((s|0)!=((rGa()|0)+4|0)){n=s+24|0;q=s+28|0;k=f[q>>2]|0;a=f[g>>2]|0;m=a;if((f[k+-4>>2]|0)!=(a|0))if((k|0)==(f[s+32>>2]|0)){NHa(n,g);break}else{f[k>>2]=m;f[q>>2]=(f[q>>2]|0)+4;break}f[i>>2]=0;q=i+4|0;f[q>>2]=0;m=h+4|0;tT(i,(f[m>>2]|0)+7|0)|0;k=f[i>>2]|0;b[k>>0]=b[378055]|0;b[k+1>>0]=b[378056]|0;b[k+2>>0]=b[378057]|0;b[k+3>>0]=b[378058]|0;b[k+4>>0]=b[378059]|0;b[k+5>>0]=b[378060]|0;b[k+6>>0]=b[378061]|0;k=f[m>>2]|0;if(k|0)dJc((f[i>>2]|0)+7|0,f[h>>2]|0,k|0)|0;f[e>>2]=0;f[e+4>>2]=0;tT(e,(f[q>>2]|0)+24|0)|0;k=f[q>>2]|0;if(!k){t=0;v=f[e>>2]|0;w=v+t|0;x=w;y=381162;z=x+24|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-5,e,381187,376410,3420)}dJc(f[e>>2]|0,f[i>>2]|0,k|0)|0;t=f[q>>2]|0;v=f[e>>2]|0;w=v+t|0;x=w;y=381162;z=x+24|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));z5(-5,e,381187,376410,3420)}while(0);y=rGa()|0;x=f[h>>2]|0;f[j>>2]=x;z=j+4|0;f[z>>2]=f[h+4>>2];if(x|0){w=x+-4|0;f[w>>2]=(f[w>>2]|0)+1}w=VDc(4)|0;f[w>>2]=f[g>>2];g=f[j>>2]|0;f[i>>2]=g;x=i+4|0;f[x>>2]=f[z>>2];if(g|0){z=g+-4|0;f[z>>2]=(f[z>>2]|0)+1}z=i+8|0;f[z>>2]=0;g=i+12|0;f[g>>2]=0;f[i+16>>2]=0;t=VDc(4)|0;f[z>>2]=t;f[i+16>>2]=t+4;v=t+4|0;f[t>>2]=f[w>>2];f[g>>2]=v;s=f[i>>2]|0;f[e>>2]=s;q=e+4|0;f[q>>2]=f[x>>2];if(!s){A=g;B=t;C=v;D=t}else{t=s+-4|0;f[t>>2]=(f[t>>2]|0)+1;t=f[z>>2]|0;A=g;B=t;C=f[g>>2]|0;D=t}t=e+8|0;f[t>>2]=0;z=e+12|0;f[z>>2]=0;f[e+16>>2]=0;s=C-B|0;B=s>>2;if(B){if(B>>>0>1073741823)mCc(t);C=VDc(s)|0;f[z>>2]=C;f[t>>2]=C;f[e+16>>2]=C+(B<<2);B=(f[A>>2]|0)-D|0;A=C;if((B|0)>0){s=C+(B>>>2<<2)|0;dJc(C|0,D|0,B|0)|0;f[z>>2]=s;E=C;F=C;G=A;H=s}else{E=C;F=C;G=A;H=A}}else{E=0;F=0;G=0;H=0}A=y+4|0;C=f[A>>2]|0;b:do if(!C){I=A;J=A}else{s=y+4|0;B=f[e>>2]|0;D=(B|0)==0?1154740:B;v=f[C+16>>2]|0;c:do if((B|0)!=(v|0)){x=s;k=C;l=v;while(1){m=(l|0)==0?1154740:l;if((Ioc(D,m)|0)<0){n=f[k>>2]|0;if(!n){r=47;break}else{K=k;L=n}}else{if((Ioc(m,D)|0)>=0){M=x;N=k;break c}O=k+4|0;m=f[O>>2]|0;if(!m){r=50;break}else{K=O;L=m}}l=f[L+16>>2]|0;if((B|0)==(l|0)){M=K;N=L;break c}else{x=K;k=L}}if((r|0)==47){I=k;J=k;break b}else if((r|0)==50){I=O;J=k;break b}}else{M=s;N=C}while(0);I=M;J=N}while(0);if(!(f[I>>2]|0)){N=VDc(36)|0;M=f[e>>2]|0;f[N+16>>2]=M;f[N+20>>2]=f[q>>2];if(!M){P=z;Q=G;R=H;S=F}else{H=M+-4|0;f[H>>2]=(f[H>>2]|0)+1;H=f[t>>2]|0;P=z;Q=H;R=f[z>>2]|0;S=H}H=N+24|0;f[H>>2]=0;t=N+28|0;f[t>>2]=0;M=N+32|0;f[M>>2]=0;G=R-Q|0;Q=G>>2;if(Q|0){if(Q>>>0>1073741823)mCc(H);R=VDc(G)|0;f[t>>2]=R;f[H>>2]=R;f[M>>2]=R+(Q<<2);Q=(f[P>>2]|0)-S|0;if((Q|0)>0){dJc(R|0,S|0,Q|0)|0;f[t>>2]=R+(Q>>>2<<2)}}f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=J;f[I>>2]=N;J=f[f[y>>2]>>2]|0;if(!J)T=N;else{f[y>>2]=J;T=f[I>>2]|0}laa(f[y+4>>2]|0,T);T=y+8|0;f[T>>2]=(f[T>>2]|0)+1;T=f[e+8>>2]|0;U=T;V=T}else{U=F;V=E}if(U|0){E=f[z>>2]|0;if((E|0)!=(U|0))f[z>>2]=E+(~((E+-4-U|0)>>>2)<<2);YDc(V)}uT(e);e=f[i+8>>2]|0;if(!e){uT(i);YDc(w);uT(j);uT(h);n6(c);u=d;return}V=f[g>>2]|0;if((V|0)!=(e|0))f[g>>2]=V+(~((V+-4-e|0)>>>2)<<2);YDc(e);uT(i);YDc(w);uT(j);uT(h);n6(c);u=d;return}function NHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function OHa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+96|0;h=g+80|0;i=g+72|0;j=g+64|0;k=g+44|0;l=g+56|0;m=g+32|0;n=g+16|0;o=g+24|0;p=g+8|0;q=g;r=f[e>>2]|0;if(!r){f[i>>2]=0;f[i+4>>2]=0}else{s=e+4|0;t=f[s>>2]|0;f[h>>2]=0;v=h+4|0;f[v>>2]=0;if(t|0?(dJc(tT(h,t)|0,r|0,t|0)|0,f[s>>2]|0):0){t=0;do{r=(Jqc(b[(f[e>>2]|0)+t>>0]|0)|0)&255;b[(f[h>>2]|0)+t>>0]=r;t=t+1|0}while(t>>>0<(f[s>>2]|0)>>>0)}s=f[h>>2]|0;f[i>>2]=s;f[i+4>>2]=f[v>>2];if(s|0){v=s+-4|0;f[v>>2]=(f[v>>2]|0)+1}uT(h)}v=f[c>>2]|0;f[h>>2]=v;s=h+4|0;f[s>>2]=f[c+4>>2];if(v|0){c=v+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[d>>2]|0;f[j>>2]=c;v=j+4|0;f[v>>2]=f[d+4>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[s>>2]|0;a:do if((d|0)!=0?(c=d+-1|0,t=f[h>>2]|0,e=t,(c|0)>=0):0){r=t+c|0;while(1){if((b[r>>0]|0)==46)break;c=r+-1|0;if(c>>>0<t>>>0){w=-1;break a}else r=c}w=r-e|0}else w=-1;while(0);t=w+1|0;f[l>>2]=0;w=l+4|0;f[w>>2]=0;c=d>>>0<t>>>0?d:t;t=d-c|0;do if(!t){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=0;x=k;y=0}else{if(!c){d=(f[h>>2]|0)+-4|0;f[d>>2]=(f[d>>2]|0)+1;d=f[h>>2]|0;f[l>>2]=d;z=f[s>>2]|0;f[w>>2]=z;A=z;B=d}else{d=tT(l,t)|0;dJc(d|0,(f[h>>2]|0)+c|0,t|0)|0;A=f[w>>2]|0;B=f[l>>2]|0};f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(A>>>0>4294967279)dEc(k);if(A>>>0<11){b[k+11>>0]=A;if(!A){x=k;y=0;break}else C=k}else{d=A+16&-16;z=VDc(d)|0;f[k>>2]=z;f[k+8>>2]=d|-2147483648;f[k+4>>2]=A;C=z}dJc(C|0,B|0,A|0)|0;x=C;y=A}while(0);b[x+y>>0]=0;uT(l);l=f[v>>2]|0;b:do if((l|0)!=0?(y=l+-1|0,x=f[j>>2]|0,A=x,(y|0)>=0):0){C=x+y|0;while(1){if((b[C>>0]|0)==46)break;y=C+-1|0;if(y>>>0<x>>>0){D=-1;break b}else C=y}D=C-A|0}else D=-1;while(0);x=D+1|0;f[n>>2]=0;D=n+4|0;f[D>>2]=0;e=l>>>0<x>>>0?l:x;x=l-e|0;do if(!x){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[m+11>>0]=0;E=m;F=0}else{if(!e){l=(f[j>>2]|0)+-4|0;f[l>>2]=(f[l>>2]|0)+1;l=f[j>>2]|0;f[n>>2]=l;r=f[v>>2]|0;f[D>>2]=r;G=r;H=l}else{l=tT(n,x)|0;dJc(l|0,(f[j>>2]|0)+e|0,x|0)|0;G=f[D>>2]|0;H=f[n>>2]|0};f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if(G>>>0>4294967279)dEc(m);if(G>>>0<11){b[m+11>>0]=G;if(!G){E=m;F=0;break}else I=m}else{l=G+16&-16;r=VDc(l)|0;f[m>>2]=r;f[m+8>>2]=l|-2147483648;f[m+4>>2]=G;I=r}dJc(I|0,H|0,G|0)|0;E=I;F=G}while(0);b[E+F>>0]=0;uT(n);n=f[i>>2]|0;c:do if((n|0)!=381201?(Ioc((n|0)==0?1154740:n,381201)|0)!=0:0){F=k+11|0;E=b[F>>0]|0;G=k+4|0;if(((E<<24>>24<0?f[G>>2]|0:E&255)|0)==10?(EEc(k,0,-1,381207,10)|0)==0:0){J=57;break}E=m+11|0;I=b[E>>0]|0;H=m+4|0;if(((I<<24>>24<0?f[H>>2]|0:I&255)|0)==10?(EEc(m,0,-1,381207,10)|0)==0:0){J=57;break}I=b[F>>0]|0;if(((I<<24>>24<0?f[G>>2]|0:I&255)|0)==8?(EEc(k,0,-1,381218,8)|0)==0:0){J=57;break}I=b[E>>0]|0;if(((I<<24>>24<0?f[H>>2]|0:I&255)|0)==8?(EEc(m,0,-1,381218,8)|0)==0:0){J=57;break}I=f[i>>2]|0;do if((I|0)!=381227?Ioc((I|0)==0?1154740:I,381227)|0:0){D=b[F>>0]|0;if(((D<<24>>24<0?f[G>>2]|0:D&255)|0)==2?(EEc(k,0,-1,381238,2)|0)==0:0)break;D=b[E>>0]|0;if(((D<<24>>24<0?f[H>>2]|0:D&255)|0)==2?(EEc(m,0,-1,381238,2)|0)==0:0)break;D=b[F>>0]|0;if(((D<<24>>24<0?f[G>>2]|0:D&255)|0)==5?(EEc(k,0,-1,381241,5)|0)==0:0)break;D=b[E>>0]|0;if(((D<<24>>24<0?f[H>>2]|0:D&255)|0)==5?(EEc(m,0,-1,381241,5)|0)==0:0)break;D=f[i>>2]|0;do if((D|0)!=381247){if(!(Ioc((D|0)==0?1154740:D,381247)|0))break;x=b[F>>0]|0;e=f[G>>2]|0;if(((x<<24>>24<0?e:x&255)|0)==2){if(!(EEc(k,0,-1,381253,2)|0))break;K=b[F>>0]|0;L=f[G>>2]|0}else{K=x;L=e}if(((K<<24>>24<0?L:K&255)|0)==3?(EEc(k,0,-1,381256,3)|0)==0:0)break;e=b[E>>0]|0;x=f[H>>2]|0;if(((e<<24>>24<0?x:e&255)|0)==2){if(!(EEc(m,0,-1,381253,2)|0))break;M=b[E>>0]|0;N=f[H>>2]|0}else{M=e;N=x}if(((M<<24>>24<0?N:M&255)|0)==3?(EEc(m,0,-1,381256,3)|0)==0:0)break;x=f[i>>2]|0;do if((x|0)!=381260){if(!(Ioc((x|0)==0?1154740:x,381260)|0))break;e=b[F>>0]|0;if(((e<<24>>24<0?f[G>>2]|0:e&255)|0)==7?(EEc(k,0,-1,381268,7)|0)==0:0)break;e=b[E>>0]|0;if(((e<<24>>24<0?f[H>>2]|0:e&255)|0)==7?(EEc(m,0,-1,381268,7)|0)==0:0)break;e=b[F>>0]|0;if(((e<<24>>24<0?f[G>>2]|0:e&255)|0)==3?(EEc(k,0,-1,381276,3)|0)==0:0)break;e=b[E>>0]|0;if(((e<<24>>24<0?f[H>>2]|0:e&255)|0)==3?(EEc(m,0,-1,381276,3)|0)==0:0)break;e=f[i>>2]|0;do if((e|0)!=381280){if(!(Ioc((e|0)==0?1154740:e,381280)|0))break;r=b[F>>0]|0;if(((r<<24>>24<0?f[G>>2]|0:r&255)|0)==3?(EEc(k,0,-1,381285,3)|0)==0:0)break;r=b[E>>0]|0;if(((r<<24>>24<0?f[H>>2]|0:r&255)|0)==3?(EEc(m,0,-1,381285,3)|0)==0:0)break;r=b[F>>0]|0;if(((r<<24>>24<0?f[G>>2]|0:r&255)|0)==3?(EEc(k,0,-1,381289,3)|0)==0:0)break;r=b[E>>0]|0;if(((r<<24>>24<0?f[H>>2]|0:r&255)|0)==3?(EEc(m,0,-1,381289,3)|0)==0:0)break;r=f[i>>2]|0;do if((r|0)!=381293){if(!(Ioc((r|0)==0?1154740:r,381293)|0))break;l=b[F>>0]|0;if(((l<<24>>24<0?f[G>>2]|0:l&255)|0)==4?(EEc(k,0,-1,381293,4)|0)==0:0)break;f[p>>2]=0;l=p+4|0;f[l>>2]=0;tT(p,(f[s>>2]|0)+47|0)|0;y=f[p>>2]|0;B=y;w=381298;t=B+47|0;do{b[B>>0]=b[w>>0]|0;B=B+1|0;w=w+1|0}while((B|0)<(t|0));w=f[s>>2]|0;if(w|0)dJc(y+47|0,f[h>>2]|0,w|0)|0;w=f[v>>2]|0;f[q>>2]=0;B=q+4|0;f[B>>2]=0;do if(w|0){tT(q,w+2|0)|0;t=f[q>>2]|0;b[t>>0]=44;b[t+1>>0]=32;t=f[v>>2]|0;if(!t)break;dJc((f[q>>2]|0)+2|0,f[j>>2]|0,t|0)|0}while(0);f[o>>2]=0;f[o+4>>2]=0;tT(o,(f[B>>2]|0)+(f[l>>2]|0)|0)|0;w=f[l>>2]|0;if(w|0)dJc(f[o>>2]|0,f[p>>2]|0,w|0)|0;w=f[B>>2]|0;if(!w)z5(-2,o,381346,376410,3530);dJc((f[o>>2]|0)+(f[l>>2]|0)|0,f[q>>2]|0,w|0)|0;z5(-2,o,381346,376410,3530)}while(0);yIa(a,h);O=E;break c}while(0);e=b[F>>0]|0;if(!(((e<<24>>24<0?f[G>>2]|0:e&255)|0)==3?!(EEc(k,0,-1,381289,3)|0):0))J=120;do if((J|0)==120){e=b[E>>0]|0;if(((e<<24>>24<0?f[H>>2]|0:e&255)|0)!=3)eGa(0,0,0);if(!(EEc(m,0,-1,381285,3)|0))break;eGa(0,0,0)}while(0);e=f[h>>2]|0;f[h>>2]=f[j>>2];f[j>>2]=e;e=f[s>>2]|0;f[s>>2]=f[v>>2];f[v>>2]=e;eGa(0,0,0)}while(0);x=b[F>>0]|0;if(((x<<24>>24<0?f[G>>2]|0:x&255)|0)==3?(EEc(k,0,-1,381276,3)|0)==0:0)J=106;else J=104;do if((J|0)==104){x=b[E>>0]|0;if(((x<<24>>24<0?f[H>>2]|0:x&255)|0)!=7)break;if(!(EEc(m,0,-1,381268,7)|0))J=106}while(0);if((J|0)==106){x=f[h>>2]|0;f[h>>2]=f[j>>2];f[j>>2]=x;x=f[s>>2]|0;f[s>>2]=f[v>>2];f[v>>2]=x}$Ka(a,j,h);O=E;break c}while(0);FKa(a,(f[s>>2]|0)==0?j:h,1);O=E;break c}while(0);I=b[F>>0]|0;if(((I<<24>>24<0?f[G>>2]|0:I&255)|0)==5?(EEc(k,0,-1,381241,5)|0)==0:0)J=77;else J=75;if(((J|0)==75?(I=b[E>>0]|0,((I<<24>>24<0?f[H>>2]|0:I&255)|0)==2):0)?(EEc(m,0,-1,381238,2)|0)==0:0)J=77;if((J|0)==77){I=f[h>>2]|0;f[h>>2]=f[j>>2];f[j>>2]=I;I=f[s>>2]|0;f[s>>2]=f[v>>2];f[v>>2]=I}RIa(a,h,j);O=E}else J=57;while(0);if((J|0)==57){o=b[k+11>>0]|0;if(((o<<24>>24<0?f[k+4>>2]|0:o&255)|0)==8?(EEc(k,0,-1,381218,8)|0)==0:0)J=61;else J=59;if(((J|0)==59?(o=b[m+11>>0]|0,((o<<24>>24<0?f[m+4>>2]|0:o&255)|0)==10):0)?(EEc(m,0,-1,381207,10)|0)==0:0)J=61;if((J|0)==61){J=f[h>>2]|0;f[h>>2]=f[j>>2];f[j>>2]=J;J=f[s>>2]|0;f[s>>2]=f[v>>2];f[v>>2]=J}qLa(a,j,h);O=m+11|0}if((b[O>>0]|0)<0)YDc(f[m>>2]|0);if((b[k+11>>0]|0)>=0){uT(j);uT(h);uT(i);u=g;return}YDc(f[k>>2]|0);uT(j);uT(h);uT(i);u=g;return}function PHa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+16|0;h=g+8|0;i=g;j=f[c>>2]|0;if(j){k=c+4|0;l=f[k>>2]|0;f[h>>2]=0;m=h+4|0;f[m>>2]=0;if(l|0?(dJc(tT(h,l)|0,j|0,l|0)|0,f[k>>2]|0):0){l=0;do{j=(Jqc(b[(f[c>>2]|0)+l>>0]|0)|0)&255;b[(f[h>>2]|0)+l>>0]=j;l=l+1|0}while(l>>>0<(f[k>>2]|0)>>>0)}k=f[h>>2]|0;f[i>>2]=k;f[i+4>>2]=f[m>>2];if(k|0){m=k+-4|0;f[m>>2]=(f[m>>2]|0)+1}uT(h);m=f[i>>2]|0;if((m|0)!=381201){n=m;o=i;p=9}}else{f[i>>2]=0;f[i+4>>2]=0;n=0;o=i;p=9}if((p|0)==9?(p=(n|0)==0?1154740:n,Ioc(p,381201)|0):0){if((n|0)!=381227?Ioc(p,381227)|0:0){if((n|0)!=381260?Ioc(p,381260)|0:0){if((n|0)==381247){f[h>>2]=0;q=h+4|0;f[q>>2]=0;r=tT(h,33)|0;s=r;t=381354;v=s+33|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-213,h,381346,376410,3544)}if(!(Ioc(p,381247)|0)){f[h>>2]=0;q=h+4|0;f[q>>2]=0;r=tT(h,33)|0;s=r;t=381354;v=s+33|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-213,h,381346,376410,3544)}if((n|0)==381280){f[h>>2]=0;w=h+4|0;f[w>>2]=0;x=tT(h,51)|0;s=x;t=381388;v=s+51|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-213,h,381346,376410,3546)}if(!(Ioc(p,381280)|0)){f[h>>2]=0;w=h+4|0;f[w>>2]=0;x=tT(h,51)|0;s=x;t=381388;v=s+51|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-213,h,381346,376410,3546)}f[h>>2]=0;f[h+4>>2]=0;x=i+4|0;tT(h,(f[x>>2]|0)+49|0)|0;w=f[h>>2]|0;s=w;t=381440;v=s+49|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));t=f[x>>2]|0;if(!t)z5(-2,h,381346,376410,3547);dJc(w+49|0,f[o>>2]|0,t|0)|0;z5(-2,h,381346,376410,3547)}pLa(a,e,d);uT(i);u=g;return}_Ja(a,d,e);uT(i);u=g;return}DLa(a,e,d);uT(i);u=g;return}function QHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;d=u;u=u+224|0;e=d+200|0;g=d+128|0;h=d+144|0;i=d;j=d+72|0;k=d+16|0;l=c+128|0;m=f[l>>2]|0;n=b[m+11>>0]|0;if(n<<24>>24<0)o=f[m+4>>2]|0;else o=n&255;if((((o|0)==0?(f[c+28>>2]|0)==0:0)?(f[c+92>>2]|0)==0:0)?(f[c+76>>2]|0)==0:0){f[e>>2]=0;f[e+4>>2]=0;dJc(tT(e,147)|0,381490,147)|0;z5(-215,e,381638,381655,91)}o=f[c+140>>2]|0;f[a>>2]=1124007936;n=a+4|0;m=a+8|0;p=a+40|0;q=n;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=m;s=a+48|0;f[a+44>>2]=s;f[s>>2]=0;f[a+52>>2]=0;f[g>>2]=0;s=g+4|0;f[s>>2]=0;f[g+8>>2]=0;t=c+16|0;if((f[t>>2]|0)>0){v=c+24|0;w=g+8|0;x=0;y=0;z=0;while(1){A=f[(f[v>>2]|0)+8+(x<<3)>>2]|0;f[e>>2]=A;if((y|0)==(z|0))g6(g,e);else{f[y>>2]=A;f[s>>2]=y+4}A=x+1|0;if((A|0)>=(f[t>>2]|0))break;x=A;y=f[s>>2]|0;z=f[w>>2]|0}if((f[g>>2]|0)==(f[s>>2]|0))B=17}else B=17;if((B|0)==17){f[e>>2]=1;RHa(g,1,e)}a:do switch(o|0){case 1:{w=c+28|0;z=f[w>>2]|0;if(!z){y=f[l>>2]|0;if((b[y+11>>0]|0)<0)C=f[y>>2]|0;else C=y;eT(j,g,5,C,0);y=e+8|0;f[y>>2]=0;f[y+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;h_(j,e);y=j+36|0;x=f[y>>2]|0;if(x|0?(t=x+12|0,x=f[t>>2]|0,f[t>>2]=x+-1,(x|0)==1):0)_S(j);f[y>>2]=0;y=j+16|0;x=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[x>>2]|0)>0){y=f[j+40>>2]|0;t=0;do{f[y+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)==(j+48|0))break a;g0(x);break a}f[e>>2]=0;f[e+4>>2]=0;x=e+8|0;f[x>>2]=0;SHa(e,z);dJc((f[x>>2]|0)+4|0,(f[c+36>>2]|0)+4|0,f[w>>2]<<2|0)|0;f[e>>2]=f[w>>2];t=f[x>>2]|0;eT(h,g,5,(t|0)==0?0:t+4|0,0);t=i+8|0;f[t>>2]=0;f[t+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;h_(h,i);t=h+36|0;y=f[t>>2]|0;if(y|0?(v=y+12|0,y=f[v>>2]|0,f[v>>2]=y+-1,(y|0)==1):0)_S(h);f[t>>2]=0;t=h+16|0;y=h+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[y>>2]|0)>0){t=f[h+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)!=(h+48|0))g0(y);y=f[x>>2]|0;if(y|0?(f[y>>2]|0)==0:0)YDc(y);break}case 11:{f[e>>2]=0;f[e+4>>2]=0;y=e+8|0;f[y>>2]=0;v=c+92|0;t=f[v>>2]|0;if(!t){f[i>>2]=0;D=i+4|0;f[D>>2]=0;E=tT(i,14)|0;q=E;F=426686;r=q+14|0;do{b[q>>0]=b[F>>0]|0;q=q+1|0;F=F+1|0}while((q|0)<(r|0));z5(-215,i,381638,381655,115)}THa(e,t);dJc((f[y>>2]|0)+8|0,(f[c+100>>2]|0)+8|0,f[v>>2]<<3|0)|0;x=f[v>>2]|0;f[e>>2]=x;if(!x){f[i>>2]=0;D=i+4|0;f[D>>2]=0;E=tT(i,14)|0;q=E;F=426686;r=q+14|0;do{b[q>>0]=b[F>>0]|0;q=q+1|0;F=F+1|0}while((q|0)<(r|0));z5(-215,i,381638,381655,115)}v=f[y>>2]|0;eT(k,g,6,(v|0)==0?0:v+8|0,0);v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;LZ(k,i,5,1.0,0.0);v=k+36|0;t=f[v>>2]|0;if(t|0?(x=t+12|0,t=f[x>>2]|0,f[x>>2]=t+-1,(t|0)==1):0)_S(k);f[v>>2]=0;v=k+16|0;t=k+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[k+40>>2]|0;x=0;do{f[v+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[t>>2]|0))}t=f[k+44>>2]|0;if((t|0)!=(k+48|0))g0(t);t=f[y>>2]|0;if(t|0?(f[t>>2]|0)==0:0)YDc(t);break}case 7:{YS(a,g,4);t=f[a+16>>2]|0;x=c+76|0;v=f[x>>2]|0;if(!v){w=f[l>>2]|0;if((b[w+11>>0]|0)<0)G=f[w>>2]|0;else G=w;w=f[n>>2]|0;if((w|0)<3)H=Y(f[a+12>>2]|0,f[m>>2]|0)|0;else{z=f[p>>2]|0;A=0;I=1;while(1){K=Y(f[z+(A<<2)>>2]|0,I)|0;A=A+1|0;if((A|0)==(w|0)){H=K;break}else I=K}}if((H|0)<=0)break a;I=t;w=0;while(1){A=G+(w<<3)|0;z=f[A>>2]|0;y=UIc(z|0,f[A+4>>2]|0,-2147483648,0)|0;A=J;if(A>>>0>0|(A|0)==0&y>>>0>4294967295)break;f[I+(w<<2)>>2]=z;w=w+1|0;if((w|0)>=(H|0))break a}f[e>>2]=0;f[e+4>>2]=0;q=tT(e,32)|0;F=381731;r=q+32|0;do{b[q>>0]=b[F>>0]|0;q=q+1|0;F=F+1|0}while((q|0)<(r|0));z5(-211,e,381764,381655,82)}f[i>>2]=0;f[i+4>>2]=0;w=i+8|0;f[w>>2]=0;UHa(i,v);dJc((f[w>>2]|0)+8|0,(f[c+84>>2]|0)+8|0,f[x>>2]<<3|0)|0;f[i>>2]=f[x>>2];I=f[n>>2]|0;if((I|0)<3)L=Y(f[a+12>>2]|0,f[m>>2]|0)|0;else{z=f[p>>2]|0;y=0;A=1;while(1){K=Y(f[z+(y<<2)>>2]|0,A)|0;y=y+1|0;if((y|0)==(I|0)){L=K;break}else A=K}}A=f[w>>2]|0;b:do if((L|0)<=0){if(A|0)B=69}else{I=t;y=0;while(1){z=A+8+(y<<3)|0;x=f[z>>2]|0;v=UIc(x|0,f[z+4>>2]|0,-2147483648,0)|0;z=J;if(z>>>0>0|(z|0)==0&v>>>0>4294967295)break;f[I+(y<<2)>>2]=x;y=y+1|0;if((y|0)>=(L|0)){B=69;break b}}f[e>>2]=0;f[e+4>>2]=0;q=tT(e,32)|0;F=381731;r=q+32|0;do{b[q>>0]=b[F>>0]|0;q=q+1|0;F=F+1|0}while((q|0)<(r|0));z5(-211,e,381764,381655,82)}while(0);if((B|0)==69?(f[A>>2]|0)==0:0)YDc(A);break}default:{VHa(i,381784,Vbc(omb()|0,o)|0);f[e>>2]=0;f[e+4>>2]=0;t=i+11|0;w=b[t>>0]|0;y=w<<24>>24<0?f[i+4>>2]|0:w&255;if(!y)z5(-210,e,381638,381655,136);w=tT(e,y)|0;dJc(w|0,((b[t>>0]|0)<0?f[i>>2]|0:i)|0,y|0)|0;z5(-210,e,381638,381655,136)}}while(0);e=f[g>>2]|0;if(!e){u=d;return}g=f[s>>2]|0;if((g|0)!=(e|0))f[s>>2]=g+(~((g+-4-e|0)>>>2)<<2);YDc(e);u=d;return}function RHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>2>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>2;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=m;m=h;while(1){f[m>>2]=f[c>>2];j=j+-1|0;if(!j)break;else m=m+4|0}}if(!l){m=h+(b<<2)|0;if((n|0)==(m|0))return;else{o=i;p=n+(~((n+-4-m|0)>>>2)<<2)|0;break}}else{m=b-k|0;j=m;q=n;while(1){f[q>>2]=f[c>>2];j=j+-1|0;if(!j)break;else q=q+4|0}o=i;p=n+(m<<2)|0;break}}else{q=g;if(!g)r=e;else{j=a+4|0;k=f[j>>2]|0;if((k|0)!=(h|0))f[j>>2]=k+(~((k+-4-g|0)>>>2)<<2);YDc(q);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;r=0}if(b>>>0>1073741823)mCc(a);j=r>>1;q=r>>2>>>0<536870911?(j>>>0<b>>>0?b:j):1073741823;if(q>>>0>1073741823)mCc(a);j=VDc(q<<2)|0;k=a+4|0;f[k>>2]=j;f[a>>2]=j;f[d>>2]=j+(q<<2);q=b;l=j;while(1){f[l>>2]=f[c>>2];q=q+-1|0;if(!q)break;else l=l+4|0}o=k;p=j+(b<<2)|0}while(0);f[o>>2]=p;return}function SHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<2;if(!i)k=VDc(d+4|0)|0;else{b=d+11&-8;if(f[i+64>>2]|0)OQb(i,23816,b);k=MQb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)dJc(k+4|0,g+4|0,j<<2|0)|0;if(h)return;if(f[g>>2]|0)return;YDc(g);return}function THa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<3;if(!i)k=VDc(d+8|0)|0;else{b=d+15&-8;if(f[i+64>>2]|0)OQb(i,23816,b);k=MQb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)dJc(k+8|0,g+8|0,j<<3|0)|0;if(h)return;if(f[g>>2]|0)return;YDc(g);return}function UHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<3;if(!i)k=VDc(d+8|0)|0;else{b=d+15&-8;if(f[i+64>>2]|0)OQb(i,23816,b);k=MQb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)dJc(k+8|0,g+8|0,j<<3|0)|0;if(h)return;if(f[g>>2]|0)return;YDc(g);return}function VHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=Mpc(c)|0;g=b[d+11>>0]|0;h=g<<24>>24<0;i=h?f[d+4>>2]|0:g&255;g=i+e|0;if(g>>>0>4294967279)dEc(a);if(g>>>0<11){b[a+11>>0]=e;j=a}else{k=g+16&-16;g=VDc(k)|0;f[a>>2]=g;f[a+8>>2]=k|-2147483648;f[a+4>>2]=e;j=g}if(e|0)dJc(j|0,c|0,e|0)|0;b[j+e>>0]=0;tEc(a,h?f[d>>2]|0:d,i)|0;return}function WHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;c=u;u=u+432|0;e=c+420|0;g=c+408|0;h=c+264|0;i=c+208|0;j=c+136|0;k=c+68|0;l=c+56|0;m=c;$jb(h);n=a+4|0;f[n>>2]=0;o=a+8|0;f[o>>2]=0;f[a>>2]=a+4;p=d+36|0;if((f[p>>2]|0)<=0){rjb(h);u=c;return}q=d+44|0;d=h+128|0;r=h+124|0;s=m+4|0;t=i+4|0;v=m+8|0;w=i+8|0;x=m+12|0;y=i+12|0;z=m+16|0;A=i+16|0;B=m+20|0;C=i+20|0;D=m+24|0;E=i+24|0;F=m+28|0;G=i+28|0;H=m+32|0;I=i+32|0;J=m+36|0;K=i+36|0;L=m+40|0;M=m+48|0;N=m+44|0;O=m+52|0;P=i+44|0;Q=k+12|0;R=k+16|0;S=k+20|0;T=k+24|0;U=k+28|0;V=k+32|0;W=k+36|0;X=k+40|0;Y=k+44|0;Z=k+48|0;_=k+52|0;$=k+60|0;aa=k+56|0;ba=k+64|0;ca=j+12|0;da=j+16|0;ea=j+20|0;fa=j+24|0;ga=j+28|0;ha=j+32|0;ia=j+36|0;ja=j+40|0;ka=j+44|0;la=j+48|0;ma=j+52|0;na=j+60|0;oa=j+56|0;pa=j+64|0;qa=j+11|0;ra=k+11|0;sa=l+11|0;ta=i+40|0;ua=i+48|0;va=h+8|0;wa=0;do{umb(h,f[(f[q>>2]|0)+4+(wa<<2)>>2]|0);QHa(i,h);xa=f[d>>2]|0;ya=b[xa+11>>0]|0;za=ya<<24>>24<0;if(za)Aa=f[xa+4>>2]|0;else Aa=ya&255;if((Aa|0?(f[va>>2]=f[va>>2]&-3,(xa|0)!=527320):0)?(f[d>>2]=527320,xa|0):0){if(za)YDc(f[xa>>2]|0);YDc(xa)}fEc(l,f[r>>2]|0);f[m>>2]=f[i>>2];xa=f[t>>2]|0;f[s>>2]=xa;f[v>>2]=f[w>>2];f[x>>2]=f[y>>2];f[z>>2]=f[A>>2];f[B>>2]=f[C>>2];f[D>>2]=f[E>>2];f[F>>2]=f[G>>2];f[H>>2]=f[I>>2];za=f[K>>2]|0;f[J>>2]=za;f[L>>2]=v;f[N>>2]=M;f[M>>2]=0;f[O>>2]=0;if(!za)Ba=xa;else{xa=za+12|0;f[xa>>2]=(f[xa>>2]|0)+1;Ba=f[t>>2]|0}if((Ba|0)<3){xa=f[P>>2]|0;za=f[N>>2]|0;f[za>>2]=f[xa>>2];f[za+4>>2]=f[xa+4>>2]}else{f[s>>2]=0;ZS(m,i)}fEc(k,l);f[Q>>2]=f[m>>2];xa=f[s>>2]|0;f[R>>2]=xa;f[S>>2]=f[v>>2];f[T>>2]=f[x>>2];f[U>>2]=f[z>>2];f[V>>2]=f[B>>2];f[W>>2]=f[D>>2];f[X>>2]=f[F>>2];f[Y>>2]=f[H>>2];za=f[J>>2]|0;f[Z>>2]=za;f[_>>2]=S;f[aa>>2]=$;f[$>>2]=0;f[ba>>2]=0;if(!za)Ca=xa;else{xa=za+12|0;f[xa>>2]=(f[xa>>2]|0)+1;Ca=f[s>>2]|0}if((Ca|0)<3){xa=f[N>>2]|0;za=f[aa>>2]|0;f[za>>2]=f[xa>>2];f[za+4>>2]=f[xa+4>>2]}else{f[R>>2]=0;ZS(Q,m)}fEc(j,k);f[ca>>2]=f[Q>>2];xa=f[R>>2]|0;f[da>>2]=xa;f[ea>>2]=f[S>>2];f[fa>>2]=f[T>>2];f[ga>>2]=f[U>>2];f[ha>>2]=f[V>>2];f[ia>>2]=f[W>>2];f[ja>>2]=f[X>>2];f[ka>>2]=f[Y>>2];za=f[Z>>2]|0;f[la>>2]=za;f[ma>>2]=ea;f[oa>>2]=na;f[na>>2]=0;f[pa>>2]=0;if(!za)Da=xa;else{xa=za+12|0;f[xa>>2]=(f[xa>>2]|0)+1;Da=f[R>>2]|0}if((Da|0)<3){xa=f[aa>>2]|0;za=f[oa>>2]|0;f[za>>2]=f[xa>>2];f[za+4>>2]=f[xa+4>>2]}else{f[da>>2]=0;ZS(ca,Q)}xa=XHa(a,e,j)|0;if(!(f[xa>>2]|0)){YHa(g,a,j);za=f[g>>2]|0;f[g>>2]=0;ya=f[e>>2]|0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=ya;f[xa>>2]=za;ya=f[f[a>>2]>>2]|0;if(!ya)Ea=za;else{f[a>>2]=ya;Ea=f[xa>>2]|0}laa(f[n>>2]|0,Ea);f[o>>2]=(f[o>>2]|0)+1}xa=f[la>>2]|0;if(xa|0?(ya=xa+12|0,xa=f[ya>>2]|0,f[ya>>2]=xa+-1,(xa|0)==1):0)_S(ca);f[la>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[da>>2]|0)>0){xa=f[ma>>2]|0;ya=0;do{f[xa+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[da>>2]|0))}ya=f[oa>>2]|0;if((ya|0)!=(na|0))g0(ya);if((b[qa>>0]|0)<0)YDc(f[j>>2]|0);ya=f[Z>>2]|0;if(ya|0?(xa=ya+12|0,ya=f[xa>>2]|0,f[xa>>2]=ya+-1,(ya|0)==1):0)_S(Q);f[Z>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[R>>2]|0)>0){ya=f[_>>2]|0;xa=0;do{f[ya+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[R>>2]|0))}xa=f[aa>>2]|0;if((xa|0)!=($|0))g0(xa);if((b[ra>>0]|0)<0)YDc(f[k>>2]|0);xa=f[J>>2]|0;do if(xa|0){ya=xa+12|0;za=f[ya>>2]|0;f[ya>>2]=za+-1;if((za|0)!=1)break;_S(m)}while(0);f[J>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[s>>2]|0)>0){xa=f[L>>2]|0;za=0;do{f[xa+(za<<2)>>2]=0;za=za+1|0}while((za|0)<(f[s>>2]|0))}za=f[N>>2]|0;if((za|0)!=(M|0))g0(za);if((b[sa>>0]|0)<0)YDc(f[l>>2]|0);za=f[K>>2]|0;do if(za|0){xa=za+12|0;ya=f[xa>>2]|0;f[xa>>2]=ya+-1;if((ya|0)!=1)break;_S(i)}while(0);f[K>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[t>>2]|0)>0){za=f[ta>>2]|0;ya=0;do{f[za+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[t>>2]|0))}ya=f[P>>2]|0;if((ya|0)!=(ua|0))g0(ya);wa=wa+1|0}while((wa|0)<(f[p>>2]|0));rjb(h);u=c;return}function XHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function YHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=VDc(84)|0;e=b+4|0;b=d;fEc(d+16|0,c);g=d+28|0;h=c+12|0;f[g>>2]=f[h>>2];i=d+32|0;j=c+16|0;k=f[j>>2]|0;f[i>>2]=k;l=d+36|0;f[l>>2]=f[c+20>>2];f[d+40>>2]=f[c+24>>2];f[d+44>>2]=f[c+28>>2];f[d+48>>2]=f[c+32>>2];f[d+52>>2]=f[c+36>>2];f[d+56>>2]=f[c+40>>2];f[d+60>>2]=f[c+44>>2];m=f[c+48>>2]|0;f[d+64>>2]=m;f[d+68>>2]=l;l=d+76|0;n=d+72|0;f[n>>2]=l;f[l>>2]=0;f[d+80>>2]=0;if(!m)o=k;else{k=m+12|0;f[k>>2]=(f[k>>2]|0)+1;o=f[j>>2]|0}if((o|0)<3){o=f[c+56>>2]|0;c=f[n>>2]|0;f[c>>2]=f[o>>2];f[c+4>>2]=f[o+4>>2];f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}else{f[i>>2]=0;ZS(g,h);f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}}function ZHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if(!c)return;ZHa(a,f[c>>2]|0);ZHa(a,f[c+4>>2]|0);a=c+16|0;d=c+28|0;e=c+64|0;g=f[e>>2]|0;if(g|0?(h=g+12|0,g=f[h>>2]|0,f[h>>2]=g+-1,(g|0)==1):0)_S(d);f[e>>2]=0;e=c+44|0;d=c+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[d>>2]|0)>0){e=f[c+68>>2]|0;g=0;do{f[e+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[d>>2]|0))}d=f[c+72>>2]|0;if((d|0)!=(c+76|0))g0(d);if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function _Ha(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;c=u;u=u+368|0;e=c+224|0;g=c;h=c+208|0;i=c+152|0;j=c+136|0;k=c+128|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;l=a+12|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;l=d+52|0;if((f[l>>2]|0)<=0){u=c;return}m=d+60|0;o=g+88|0;q=h+11|0;r=h+4|0;s=g+28|0;t=e+4|0;v=g+36|0;w=e+4|0;x=e+4|0;y=e+4|0;z=d+68|0;d=e+4|0;A=e+8|0;B=i+4|0;C=j+4|0;D=e+8|0;E=e+4|0;F=e+4|0;G=e+4|0;H=e+4|0;I=g+92|0;K=e+4|0;L=e+4|0;M=e+4|0;N=e+4|0;O=g+8|0;P=g+16|0;Q=e+4|0;R=g+24|0;S=i+4|0;T=i+4|0;U=i+8|0;V=j+4|0;W=j+8|0;X=e+4|0;Y=k+4|0;Z=j+8|0;_=g+104|0;$=a+16|0;aa=a+20|0;ba=a+12|0;ca=i+36|0;da=i+16|0;ea=i+4|0;fa=i+40|0;ga=i+44|0;ha=i+48|0;ia=i+8|0;ja=i+12|0;ka=i+20|0;la=i+24|0;ma=i+28|0;na=i+32|0;oa=e+4|0;pa=e+4|0;qa=g+120|0;ra=g+112|0;sa=e+4|0;ta=0;a:while(1){pmb(g,f[(f[m>>2]|0)+4+(ta<<2)>>2]|0);fEc(h,f[o>>2]|0);ua=b[q>>0]|0;va=f[r>>2]|0;do if(((ua<<24>>24<0?va:ua&255)|0)==12){if(EEc(h,0,-1,381808,12)|0){wa=b[q>>0]|0;xa=f[r>>2]|0;ya=9;break}if((f[s>>2]|0)!=2){ya=7;break a}f[e>>2]=0;f[t>>2]=0;za=tT(e,8)|0;Aa=za;b[Aa>>0]=107;b[Aa+1>>0]=101;b[Aa+2>>0]=114;b[Aa+3>>0]=110;Aa=za+4|0;b[Aa>>0]=101;b[Aa+1>>0]=108;b[Aa+2>>0]=95;b[Aa+3>>0]=104;Aa=(f[v>>2]|0)+8|0;za=f[Aa>>2]|0;Ba=f[Aa+4>>2]|0;Aa=UIc(za|0,Ba|0,-2147483648,0)|0;Ca=J;f[i>>2]=Ca>>>0<1|(Ca|0)==1&Aa>>>0<0?za:(Ba|0)>0|(Ba|0)==0&za>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);f[e>>2]=0;f[w>>2]=0;za=tT(e,8)|0;Ba=za;b[Ba>>0]=107;b[Ba+1>>0]=101;b[Ba+2>>0]=114;b[Ba+3>>0]=110;Ba=za+4|0;b[Ba>>0]=101;b[Ba+1>>0]=108;b[Ba+2>>0]=95;b[Ba+3>>0]=119;Ba=(f[v>>2]|0)+16|0;za=f[Ba>>2]|0;Aa=f[Ba+4>>2]|0;Ba=UIc(za|0,Aa|0,-2147483648,0)|0;Ca=J;f[i>>2]=Ca>>>0<1|(Ca|0)==1&Ba>>>0<0?za:(Aa|0)>0|(Aa|0)==0&za>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e)}else{wa=ua;xa=va;ya=9}while(0);b:do if((ya|0)==9){ya=0;do if(((wa<<24>>24<0?xa:wa&255)|0)==7){if(EEc(h,0,-1,427173,7)|0){Da=b[q>>0]|0;Ea=f[r>>2]|0;break}if((f[s>>2]|0)!=2){ya=13;break a}f[e>>2]=0;f[x>>2]=0;va=tT(e,8)|0;ua=va;b[ua>>0]=115;b[ua+1>>0]=116;b[ua+2>>0]=114;b[ua+3>>0]=105;ua=va+4|0;b[ua>>0]=100;b[ua+1>>0]=101;b[ua+2>>0]=95;b[ua+3>>0]=104;ua=(f[v>>2]|0)+8|0;va=f[ua>>2]|0;za=f[ua+4>>2]|0;ua=UIc(va|0,za|0,-2147483648,0)|0;Aa=J;f[i>>2]=Aa>>>0<1|(Aa|0)==1&ua>>>0<0?va:(za|0)>0|(za|0)==0&va>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);f[e>>2]=0;f[y>>2]=0;va=tT(e,8)|0;za=va;b[za>>0]=115;b[za+1>>0]=116;b[za+2>>0]=114;b[za+3>>0]=105;za=va+4|0;b[za>>0]=100;b[za+1>>0]=101;b[za+2>>0]=95;b[za+3>>0]=119;za=(f[v>>2]|0)+16|0;va=f[za>>2]|0;ua=f[za+4>>2]|0;za=UIc(va|0,ua|0,-2147483648,0)|0;Aa=J;f[i>>2]=Aa>>>0<1|(Aa|0)==1&za>>>0<0?va:(ua|0)>0|(ua|0)==0&va>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);break b}else{Da=wa;Ea=xa}while(0);do if(((Da<<24>>24<0?Ea:Da&255)|0)==4){if(EEc(h,0,-1,381869,4)|0){Fa=b[q>>0]|0;Ga=f[r>>2]|0;break}va=f[z>>2]|0;ua=b[va+11>>0]|0;if(((ua<<24>>24<0?f[va+4>>2]|0:ua&255)|0)==3){ua=(EEc(va,0,-1,383054,3)|0)==0;va=f[s>>2]|0;if(ua){if(va&1|0){ya=22;break a}ua=(va|0)/2|0;f[e>>2]=0;f[d>>2]=0;f[A>>2]=0;aIa(e,va);if((va|0)>1){za=0;do{Aa=f[v>>2]|0;Ba=f[Aa+8+(za<<3)>>2]|0;f[i>>2]=Ba;Ca=f[d>>2]|0;Ha=f[D>>2]|0;if((Ca|0)==(Ha|0)){g6(e,i);Ia=f[v>>2]|0;Ja=f[d>>2]|0;Ka=f[D>>2]|0}else{f[Ca>>2]=Ba;Ba=Ca+4|0;f[d>>2]=Ba;Ia=Aa;Ja=Ba;Ka=Ha}Ha=f[Ia+8+(za+ua<<3)>>2]|0;f[i>>2]=Ha;if((Ja|0)==(Ka|0))g6(e,i);else{f[Ja>>2]=Ha;f[d>>2]=Ja+4}za=za+1|0}while((za|0)<(ua|0))}f[i>>2]=0;f[B>>2]=0;ua=tT(i,8)|0;za=ua;b[za>>0]=112;b[za+1>>0]=97;b[za+2>>0]=100;b[za+3>>0]=100;za=ua+4|0;b[za>>0]=105;b[za+1>>0]=110;b[za+2>>0]=103;b[za+3>>0]=115;za=f[e>>2]|0;ua=(f[d>>2]|0)-za|0;Ha=ua>>2;Ba=VDc(16)|0;Aa=Ba+8|0;f[Ba>>2]=Aa;f[Ba+4>>2]=Ha;if(Ha>>>0>1){Ca=XDc(Ha>>>0>536870911?-1:Ha<<3)|0;f[Ba>>2]=Ca;La=Ca}else La=Aa;f[j>>2]=0;f[C>>2]=Ba;if((ua|0)>0){ua=za;za=0;while(1){Ba=f[ua>>2]|0;Aa=La+(za<<3)|0;f[Aa>>2]=Ba;f[Aa+4>>2]=((Ba|0)<0)<<31>>31;za=za+1|0;if((za|0)==(Ha|0))break;else ua=ua+4|0}}bIa(a,i,j)|0;JFa(j);uT(i);ua=f[e>>2]|0;if(ua|0){Ha=f[d>>2]|0;if((Ha|0)!=(ua|0))f[d>>2]=Ha+(~((Ha+-4-ua|0)>>>2)<<2);YDc(ua)}break b}else Ma=va}else Ma=f[s>>2]|0;if((Ma|0)!=4){ya=41;break a}f[e>>2]=0;f[E>>2]=0;ua=tT(e,5)|0;b[ua>>0]=b[450421]|0;b[ua+1>>0]=b[450422]|0;b[ua+2>>0]=b[450423]|0;b[ua+3>>0]=b[450424]|0;b[ua+4>>0]=b[450425]|0;ua=(f[v>>2]|0)+8|0;Ha=f[ua>>2]|0;za=f[ua+4>>2]|0;ua=UIc(Ha|0,za|0,-2147483648,0)|0;Ba=J;f[i>>2]=Ba>>>0<1|(Ba|0)==1&ua>>>0<0?Ha:(za|0)>0|(za|0)==0&Ha>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);f[e>>2]=0;f[F>>2]=0;Ha=tT(e,5)|0;b[Ha>>0]=b[450415]|0;b[Ha+1>>0]=b[450416]|0;b[Ha+2>>0]=b[450417]|0;b[Ha+3>>0]=b[450418]|0;b[Ha+4>>0]=b[450419]|0;Ha=(f[v>>2]|0)+16|0;za=f[Ha>>2]|0;ua=f[Ha+4>>2]|0;Ha=UIc(za|0,ua|0,-2147483648,0)|0;Ba=J;f[i>>2]=Ba>>>0<1|(Ba|0)==1&Ha>>>0<0?za:(ua|0)>0|(ua|0)==0&za>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);f[e>>2]=0;f[G>>2]=0;za=tT(e,5)|0;b[za>>0]=b[450433]|0;b[za+1>>0]=b[450434]|0;b[za+2>>0]=b[450435]|0;b[za+3>>0]=b[450436]|0;b[za+4>>0]=b[450437]|0;za=(f[v>>2]|0)+24|0;ua=f[za>>2]|0;Ha=f[za+4>>2]|0;za=UIc(ua|0,Ha|0,-2147483648,0)|0;Ba=J;f[i>>2]=Ba>>>0<1|(Ba|0)==1&za>>>0<0?ua:(Ha|0)>0|(Ha|0)==0&ua>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);f[e>>2]=0;f[H>>2]=0;ua=tT(e,5)|0;b[ua>>0]=b[450427]|0;b[ua+1>>0]=b[450428]|0;b[ua+2>>0]=b[450429]|0;b[ua+3>>0]=b[450430]|0;b[ua+4>>0]=b[450431]|0;ua=(f[v>>2]|0)+32|0;Ha=f[ua>>2]|0;za=f[ua+4>>2]|0;ua=UIc(Ha|0,za|0,-2147483648,0)|0;Ba=J;f[i>>2]=Ba>>>0<1|(Ba|0)==1&ua>>>0<0?Ha:(za|0)>0|(za|0)==0&Ha>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);break b}else{Fa=Da;Ga=Ea}while(0);do if(((Fa<<24>>24<0?Ga:Fa&255)|0)==8){if(EEc(h,0,-1,381944,8)|0){Na=b[q>>0]|0;Oa=f[r>>2]|0;break}Ha=f[I>>2]|0;za=b[Ha+11>>0]|0;ua=f[Ha+4>>2]|0;if(((za<<24>>24<0?ua:za&255)|0)==10){if(EEc(Ha,0,-1,381953,10)|0){Ba=f[I>>2]|0;Pa=b[Ba+11>>0]|0;Qa=f[Ba+4>>2]|0;Ra=Ba;ya=49}}else{Pa=za;Qa=ua;Ra=Ha;ya=49}do if((ya|0)==49){ya=0;if(((Pa<<24>>24<0?Qa:Pa&255)|0)==10){if(!(EEc(Ra,0,-1,381964,10)|0))break;Ha=f[I>>2]|0;Sa=b[Ha+11>>0]|0;Ta=f[Ha+4>>2]|0;Ua=Ha}else{Sa=Pa;Ta=Qa;Ua=Ra}if(((Sa<<24>>24<0?Ta:Sa&255)|0)!=5)break b;if(EEc(Ua,0,-1,450782,5)|0)break b;f[e>>2]=0;f[L>>2]=0;Ha=tT(e,8)|0;ua=Ha;b[ua>>0]=112;b[ua+1>>0]=97;b[ua+2>>0]=100;b[ua+3>>0]=95;ua=Ha+4|0;b[ua>>0]=109;b[ua+1>>0]=111;b[ua+2>>0]=100;b[ua+3>>0]=101;dIa(a,e,450782)|0;uT(e);break b}while(0);f[e>>2]=0;f[K>>2]=0;va=tT(e,8)|0;ua=va;b[ua>>0]=112;b[ua+1>>0]=97;b[ua+2>>0]=100;b[ua+3>>0]=95;ua=va+4|0;b[ua>>0]=109;b[ua+1>>0]=111;b[ua+2>>0]=100;b[ua+3>>0]=101;cIa(a,e,450788)|0;uT(e);break b}else{Na=Fa;Oa=Ga}while(0);if(((Na<<24>>24<0?Oa:Na&255)|0)==9?(EEc(h,0,-1,381975,9)|0)==0:0){if((f[s>>2]|0)!=2){ya=59;break a}f[e>>2]=0;f[M>>2]=0;Va=tT(e,10)|0;Wa=387921;Xa=Va+10|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));ua=(f[v>>2]|0)+8|0;va=f[ua>>2]|0;Ha=f[ua+4>>2]|0;ua=UIc(va|0,Ha|0,-2147483648,0)|0;za=J;f[i>>2]=za>>>0<1|(za|0)==1&ua>>>0<0?va:(Ha|0)>0|(Ha|0)==0&va>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);f[e>>2]=0;f[N>>2]=0;Va=tT(e,10)|0;Wa=387910;Xa=Va+10|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));va=(f[v>>2]|0)+16|0;Ha=f[va>>2]|0;ua=f[va+4>>2]|0;va=UIc(Ha|0,ua|0,-2147483648,0)|0;za=J;f[i>>2]=za>>>0<1|(za|0)==1&va>>>0<0?Ha:(ua|0)>0|(ua|0)==0&Ha>>>0>0?2147483647:-2147483648;$Ha(a,e,i)|0;uT(e);break}Ya=f[O>>2]|0;if(Ya&64|0){Ha=ra;ua=f[Ha>>2]|0;va=UIc(ua|0,f[Ha+4>>2]|0,-2147483648,0)|0;Ha=J;if(Ha>>>0>0|(Ha|0)==0&va>>>0>4294967295){ya=63;break a}f[e>>2]=0;f[sa>>2]=0;va=b[q>>0]|0;Ha=va<<24>>24<0?f[r>>2]|0:va&255;if(Ha|0){va=tT(e,Ha)|0;dJc(va|0,((b[q>>0]|0)<0?f[h>>2]|0:h)|0,Ha|0)|0}f[i>>2]=ua;$Ha(a,e,i)|0;uT(e);break}if(Ya&128|0){f[e>>2]=0;f[pa>>2]=0;ua=b[q>>0]|0;Ha=ua<<24>>24<0?f[r>>2]|0:ua&255;if(Ha|0){ua=tT(e,Ha)|0;dJc(ua|0,((b[q>>0]|0)<0?f[h>>2]|0:h)|0,Ha|0)|0}f[i>>2]=f[qa>>2];eIa(a,e,i)|0;uT(e);break}if(Ya&2|0){f[e>>2]=0;f[oa>>2]=0;Ha=b[q>>0]|0;ua=Ha<<24>>24<0?f[r>>2]|0:Ha&255;if(ua|0){Ha=tT(e,ua)|0;dJc(Ha|0,((b[q>>0]|0)<0?f[h>>2]|0:h)|0,ua|0)|0}fIa(a,e,f[I>>2]|0)|0;uT(e);break}ua=f[P>>2]|0;if((ua|0)>0){f[e>>2]=0;f[Q>>2]=0;Ha=b[q>>0]|0;va=Ha<<24>>24<0?f[r>>2]|0:Ha&255;if(!va)Za=ua;else{ua=tT(e,va)|0;dJc(ua|0,((b[q>>0]|0)<0?f[h>>2]|0:h)|0,va|0)|0;Za=f[P>>2]|0}va=f[R>>2]|0;ua=VDc(16)|0;Ha=ua+8|0;f[ua>>2]=Ha;f[ua+4>>2]=Za;if(Za>>>0>1){za=XDc(Za>>>0>536870911?-1:Za<<3)|0;f[ua>>2]=za;_a=za}else _a=Ha;f[i>>2]=2;f[S>>2]=ua;if((Za|0)>0){ua=(va|0)==0?0:va+4|0;va=0;while(1){p[_a+(va<<3)>>3]=+n[ua>>2];va=va+1|0;if((va|0)==(Za|0))break;else ua=ua+4|0}}bIa(a,e,i)|0;JFa(i);uT(e);break}ua=f[s>>2]|0;if((ua|0)<=0){if(!(Ya&16)){ya=123;break a}va=f[_>>2]|0;qmb(e,va|0?va:526136);QHa(i,e);va=f[$>>2]|0;if((va|0)==(f[aa>>2]|0))Bxa(ba,i);else{f[va>>2]=f[i>>2];Ha=va+4|0;f[Ha>>2]=f[ea>>2];za=va+8|0;f[za>>2]=f[ia>>2];f[va+12>>2]=f[ja>>2];f[va+16>>2]=f[da>>2];f[va+20>>2]=f[ka>>2];f[va+24>>2]=f[la>>2];f[va+28>>2]=f[ma>>2];f[va+32>>2]=f[na>>2];Ba=f[ca>>2]|0;f[va+36>>2]=Ba;f[va+40>>2]=za;za=va+48|0;Aa=va+44|0;f[Aa>>2]=za;f[za>>2]=0;f[va+52>>2]=0;if(Ba|0){za=Ba+12|0;f[za>>2]=(f[za>>2]|0)+1}if((f[ea>>2]|0)<3){za=f[ga>>2]|0;Ba=f[Aa>>2]|0;f[Ba>>2]=f[za>>2];f[Ba+4>>2]=f[za+4>>2]}else{f[Ha>>2]=0;ZS(va,i)}f[$>>2]=(f[$>>2]|0)+56}va=f[ca>>2]|0;if(va|0?(Ha=va+12|0,va=f[Ha>>2]|0,f[Ha>>2]=va+-1,(va|0)==1):0)_S(i);f[ca>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ea>>2]|0)>0){va=f[fa>>2]|0;Ha=0;do{f[va+(Ha<<2)>>2]=0;Ha=Ha+1|0}while((Ha|0)<(f[ea>>2]|0))}Ha=f[ga>>2]|0;if((Ha|0)!=(ha|0))g0(Ha);rjb(e);break}f[i>>2]=0;f[T>>2]=0;f[U>>2]=0;UHa(i,ua);dJc((f[U>>2]|0)+8|0,(f[v>>2]|0)+8|0,f[s>>2]<<3|0)|0;Ha=f[s>>2]|0;f[i>>2]=Ha;f[j>>2]=0;f[V>>2]=0;f[W>>2]=0;if(!Ha)$a=0;else{if(Ha>>>0>1073741823){ya=86;break a}va=Ha<<2;za=VDc(va)|0;f[j>>2]=za;Ba=za+(Ha<<2)|0;f[Z>>2]=Ba;XIc(za|0,0,va|0)|0;f[V>>2]=Ba;Ba=f[U>>2]|0;va=0;while(1){Aa=Ba+8+(va<<3)|0;Ca=f[Aa>>2]|0;ab=UIc(Ca|0,f[Aa+4>>2]|0,-2147483648,0)|0;Aa=J;if(Aa>>>0>0|(Aa|0)==0&ab>>>0>4294967295){ya=89;break a}f[za+(va<<2)>>2]=Ca;va=va+1|0;if((va|0)>=(Ha|0)){$a=za;break}}}za=f[o>>2]|0;f[e>>2]=0;f[X>>2]=0;Ha=za+11|0;va=b[Ha>>0]|0;Ba=va<<24>>24<0?f[za+4>>2]|0:va&255;if(!Ba)bb=$a;else{va=tT(e,Ba)|0;dJc(va|0,((b[Ha>>0]|0)<0?f[za>>2]|0:za)|0,Ba|0)|0;bb=f[j>>2]|0}Ba=f[s>>2]|0;za=VDc(16)|0;Ha=za+8|0;f[za>>2]=Ha;f[za+4>>2]=Ba;if(Ba>>>0>1){va=XDc(Ba>>>0>536870911?-1:Ba<<3)|0;f[za>>2]=va;cb=va}else cb=Ha;f[k>>2]=0;f[Y>>2]=za;if((Ba|0)>0){za=bb;Ha=0;while(1){va=f[za>>2]|0;ua=cb+(Ha<<3)|0;f[ua>>2]=va;f[ua+4>>2]=((va|0)<0)<<31>>31;Ha=Ha+1|0;if((Ha|0)==(Ba|0))break;else za=za+4|0}}bIa(a,e,k)|0;JFa(k);uT(e);za=f[j>>2]|0;if(za|0){Ba=f[V>>2]|0;if((Ba|0)!=(za|0))f[V>>2]=Ba+(~((Ba+-4-za|0)>>>2)<<2);YDc(za)}za=f[U>>2]|0;do if(za|0){if(f[za>>2]|0)break;YDc(za)}while(0)}while(0);if((b[q>>0]|0)<0)YDc(f[h>>2]|0);dhb(g);ta=ta+1|0;if((ta|0)>=(f[l>>2]|0)){ya=132;break}}switch(ya|0){case 7:{f[e>>2]=0;f[e+4>>2]=0;Va=tT(e,32)|0;Wa=381821;Xa=Va+32|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-215,e,381854,381655,166);break}case 13:{f[e>>2]=0;f[e+4>>2]=0;Va=tT(e,32)|0;Wa=381821;Xa=Va+32|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-215,e,381854,381655,172);break}case 22:{f[e>>2]=0;f[e+4>>2]=0;Va=tT(e,36)|0;Wa=381874;Xa=Va+36|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-215,e,381854,381655,183);break}case 41:{f[e>>2]=0;f[e+4>>2]=0;Va=tT(e,32)|0;Wa=381911;Xa=Va+32|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-215,e,381854,381655,197);break}case 59:{f[e>>2]=0;f[e+4>>2]=0;Va=tT(e,32)|0;Wa=381821;Xa=Va+32|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-215,e,381854,381655,215);break}case 63:{f[e>>2]=0;f[e+4>>2]=0;Va=tT(e,32)|0;Wa=381731;Xa=Va+32|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-211,e,381854,381655,223);break}case 86:{mCc(j);break}case 89:{f[e>>2]=0;f[e+4>>2]=0;Va=tT(e,32)|0;Wa=381731;Xa=Va+32|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-211,e,381764,381655,82);break}case 123:{if(Ya&32|0){f[e>>2]=0;db=e+4|0;f[db>>2]=0;eb=tT(e,25)|0;Va=eb;Wa=381985;Xa=Va+25|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-213,e,381854,381655,256)}if((f[g+44>>2]|0)>0){f[e>>2]=0;db=e+4|0;f[db>>2]=0;eb=tT(e,25)|0;Va=eb;Wa=381985;Xa=Va+25|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-213,e,381854,381655,256)}if((f[g+60>>2]|0)>0){f[e>>2]=0;db=e+4|0;f[db>>2]=0;eb=tT(e,25)|0;Va=eb;Wa=381985;Xa=Va+25|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-213,e,381854,381655,256)}if((f[g+76>>2]|0)>0){f[e>>2]=0;db=e+4|0;f[db>>2]=0;eb=tT(e,25)|0;Va=eb;Wa=381985;Xa=Va+25|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-213,e,381854,381655,256)}else{f[e>>2]=0;f[e+4>>2]=0;Va=tT(e,26)|0;Wa=382011;Xa=Va+26|0;do{b[Va>>0]=b[Wa>>0]|0;Va=Va+1|0;Wa=Wa+1|0}while((Va|0)<(Xa|0));z5(-213,e,381854,381655,259)}break}case 132:{u=c;return}}}function $Ha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}o=f[c>>2]|0;f[e>>2]=0;p=VDc(16)|0;r=p+8|0;f[p>>2]=r;f[p+4>>2]=1;f[e+4>>2]=p;p=r;f[p>>2]=o;f[p+4>>2]=((o|0)<0)<<31>>31;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[i>>2]=0;t=VDc(16)|0;k=t+8|0;f[t>>2]=k;f[t+4>>2]=1;f[i+4>>2]=t;t=k;f[t>>2]=b;f[t+4>>2]=((b|0)<0)<<31>>31;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=24;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=27;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==24){v=z;w=z;break b}else if((D|0)==27){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function aIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=af(8)|0;bEc(g,503977);f[g>>2]=185532;ig(g|0,23696,1627)}g=(f[e>>2]|0)-d|0;h=g>>2;i=VDc(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)dJc(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;YDc(d);return}function bIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}TFa(e,c);gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}TFa(i,c);b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=24;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=27;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==24){v=z;w=z;break b}else if((D|0)==27){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function cIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=VDc(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;uT(p);o=Mpc(c)|0;if(o|0)dJc(tT(p,o)|0,c|0,o|0)|0;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=VDc(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;uT(t);b=Mpc(c)|0;if(b|0)dJc(tT(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function dIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=VDc(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;uT(p);o=Mpc(c)|0;if(o|0)dJc(tT(p,o)|0,c|0,o|0)|0;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=VDc(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;uT(t);b=Mpc(c)|0;if(b|0)dJc(tT(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function eIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;o=l;q=j;r=k;a:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)==(l|0))break;if((Ioc((t|0)==0?1154740:t,m)|0)>=0)break;t=f[s+4>>2]|0;if(!t){v=q;break a}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)==(j|0))w=o;else{q=f[v+16>>2]|0;if((l|0)!=(q|0)?(Ioc(m,(q|0)==0?1154740:q)|0)<=-1:0){w=o;break}x=+n[c>>2];f[e>>2]=2;q=VDc(16)|0;r=q+8|0;f[q>>2]=r;f[q+4>>2]=1;f[e+4>>2]=q;p[r>>3]=x;gIa(v+24|0,e)|0;JFa(e);u=d;return c|0}}else w=f[b>>2]|0;while(0);f[h>>2]=w;v=h+4|0;f[v>>2]=f[b+4>>2];if(w|0){b=w+-4|0;f[b>>2]=(f[b>>2]|0)+1}x=+n[c>>2];f[i>>2]=2;b=VDc(16)|0;w=b+8|0;f[b>>2]=w;f[b+4>>2]=1;f[i+4>>2]=b;p[w>>3]=x;w=f[h>>2]|0;f[g>>2]=w;b=g+4|0;f[b>>2]=f[v>>2];if(w|0){v=w+-4|0;f[v>>2]=(f[v>>2]|0)+1}v=g+8|0;TFa(v,i);w=f[g>>2]|0;f[e>>2]=w;k=e+4|0;f[k>>2]=f[b>>2];if(w|0){b=w+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=e+8|0;TFa(b,v);w=f[j>>2]|0;b:do if(!w){y=j;z=j}else{r=a+4|0;q=f[e>>2]|0;t=(q|0)==0?1154740:q;A=f[w+16>>2]|0;c:do if((q|0)!=(A|0)){B=r;C=w;D=A;while(1){E=(D|0)==0?1154740:D;if((Ioc(t,E)|0)<0){F=f[C>>2]|0;if(!F){G=24;break}else{H=C;I=F}}else{if((Ioc(E,t)|0)>=0){J=B;K=C;break c}L=C+4|0;E=f[L>>2]|0;if(!E){G=27;break}else{H=L;I=E}}D=f[I+16>>2]|0;if((q|0)==(D|0)){J=H;K=I;break c}else{B=H;C=I}}if((G|0)==24){y=C;z=C;break b}else if((G|0)==27){y=L;z=C;break b}}else{J=r;K=w}while(0);y=J;z=K}while(0);if(!(f[y>>2]|0)){K=VDc(32)|0;J=f[e>>2]|0;f[K+16>>2]=J;f[K+20>>2]=f[k>>2];if(J|0){k=J+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(K+24|0,b);f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=z;f[y>>2]=K;z=f[f[a>>2]>>2]|0;if(!z)M=K;else{f[a>>2]=z;M=f[y>>2]|0}laa(f[a+4>>2]|0,M);M=a+8|0;f[M>>2]=(f[M>>2]|0)+1}JFa(b);uT(e);JFa(v);uT(g);JFa(i);uT(h);u=d;return c|0}function fIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=a+4|0;m=f[l>>2]|0;do if(m){n=f[c>>2]|0;o=(n|0)==0?1154740:n;p=n;q=l;r=m;a:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)==(n|0))break;if((Ioc((t|0)==0?1154740:t,o)|0)>=0)break;t=f[s+4>>2]|0;if(!t){v=q;break a}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)==(l|0))w=p;else{q=f[v+16>>2]|0;if((n|0)!=(q|0)?(Ioc(o,(q|0)==0?1154740:q)|0)<=-1:0){w=p;break}f[h>>2]=0;q=h+4|0;f[q>>2]=0;r=d+11|0;t=b[r>>0]|0;x=t<<24>>24<0?f[d+4>>2]|0:t&255;if(x|0){t=tT(h,x)|0;dJc(t|0,((b[r>>0]|0)<0?f[d>>2]|0:d)|0,x|0)|0}f[g>>2]=3;x=VDc(16)|0;r=x+8|0;f[r>>2]=0;t=x+12|0;f[t>>2]=0;f[x>>2]=r;f[x+4>>2]=1;f[g+4>>2]=x;uT(r);x=f[h>>2]|0;if(!x)y=0;else{z=x+-4|0;f[z>>2]=(f[z>>2]|0)+1;y=f[h>>2]|0}f[r>>2]=y;f[t>>2]=f[q>>2];gIa(v+24|0,g)|0;JFa(g);uT(h);u=e;return d|0}}else w=f[c>>2]|0;while(0);f[i>>2]=w;v=i+4|0;f[v>>2]=f[c+4>>2];if(w|0){c=w+-4|0;f[c>>2]=(f[c>>2]|0)+1}f[k>>2]=0;c=k+4|0;f[c>>2]=0;w=d+11|0;y=b[w>>0]|0;m=y<<24>>24<0?f[d+4>>2]|0:y&255;if(m|0){y=tT(k,m)|0;dJc(y|0,((b[w>>0]|0)<0?f[d>>2]|0:d)|0,m|0)|0}f[j>>2]=3;m=VDc(16)|0;w=m+8|0;f[w>>2]=0;y=m+12|0;f[y>>2]=0;f[m>>2]=w;f[m+4>>2]=1;f[j+4>>2]=m;uT(w);m=f[k>>2]|0;if(!m)A=0;else{q=m+-4|0;f[q>>2]=(f[q>>2]|0)+1;A=f[k>>2]|0}f[w>>2]=A;f[y>>2]=f[c>>2];c=f[i>>2]|0;f[h>>2]=c;y=h+4|0;f[y>>2]=f[v>>2];if(c|0){v=c+-4|0;f[v>>2]=(f[v>>2]|0)+1}v=h+8|0;TFa(v,j);c=f[h>>2]|0;f[g>>2]=c;A=g+4|0;f[A>>2]=f[y>>2];if(c|0){y=c+-4|0;f[y>>2]=(f[y>>2]|0)+1}y=g+8|0;TFa(y,v);c=f[l>>2]|0;b:do if(!c){B=l;C=l}else{w=a+4|0;q=f[g>>2]|0;m=(q|0)==0?1154740:q;t=f[c+16>>2]|0;c:do if((q|0)!=(t|0)){r=w;z=c;x=t;while(1){D=(x|0)==0?1154740:x;if((Ioc(m,D)|0)<0){E=f[z>>2]|0;if(!E){F=32;break}else{G=z;H=E}}else{if((Ioc(D,m)|0)>=0){I=r;J=z;break c}K=z+4|0;D=f[K>>2]|0;if(!D){F=35;break}else{G=K;H=D}}x=f[H+16>>2]|0;if((q|0)==(x|0)){I=G;J=H;break c}else{r=G;z=H}}if((F|0)==32){B=z;C=z;break b}else if((F|0)==35){B=K;C=z;break b}}else{I=w;J=c}while(0);B=I;C=J}while(0);if(!(f[B>>2]|0)){J=VDc(32)|0;I=f[g>>2]|0;f[J+16>>2]=I;f[J+20>>2]=f[A>>2];if(I|0){A=I+-4|0;f[A>>2]=(f[A>>2]|0)+1}TFa(J+24|0,y);f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=C;f[B>>2]=J;C=f[f[a>>2]>>2]|0;if(!C)L=J;else{f[a>>2]=C;L=f[B>>2]|0}laa(f[a+4>>2]|0,L);L=a+8|0;f[L>>2]=(f[L>>2]|0)+1}JFa(y);uT(g);JFa(v);uT(h);JFa(j);uT(k);uT(i);u=e;return d|0}function gIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((b|0)==(a|0))return a|0;switch(f[b>>2]|0){case 0:{c=VDc(16)|0;d=f[b+4>>2]|0;e=c+8|0;f[c>>2]=e;g=c+4|0;f[g>>2]=1;h=f[d+4>>2]|0;f[g>>2]=h;if(h>>>0<=1){if(h|0){i=e;j=6}}else{e=XDc(h>>>0>536870911?-1:h<<3)|0;f[c>>2]=e;i=e;j=6}if((j|0)==6){e=f[d>>2]|0;d=0;do{g=e+(d<<3)|0;k=f[g+4>>2]|0;l=i+(d<<3)|0;f[l>>2]=f[g>>2];f[l+4>>2]=k;d=d+1|0}while(d>>>0<h>>>0)}JFa(a);f[a+4>>2]=c;break}case 3:{c=VDc(16)|0;UFa(c,f[b+4>>2]|0);JFa(a);f[a+4>>2]=c;break}case 2:{c=VDc(16)|0;h=f[b+4>>2]|0;d=c+8|0;f[c>>2]=d;i=c+4|0;f[i>>2]=1;e=f[h+4>>2]|0;f[i>>2]=e;if(e>>>0<=1){if(e|0){m=d;j=13}}else{d=XDc(e>>>0>536870911?-1:e<<3)|0;f[c>>2]=d;m=d;j=13}if((j|0)==13){j=f[h>>2]|0;h=0;do{p[m+(h<<3)>>3]=+p[j+(h<<3)>>3];h=h+1|0}while(h>>>0<e>>>0)}JFa(a);f[a+4>>2]=c;break}default:{}}f[a>>2]=f[b>>2];return a|0}function hIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;h=c+24|0;i=c+12|0;j=c;if((f[d+20>>2]|0)<=(g|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,31)|0;l=382038;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z5(-215,h,382070,381655,267)}l=d+28|0;d=iIa(e,f[(f[l>>2]|0)+4+(g<<2)>>2]|0)|0;if((d|0)==(e+4|0)){VHa(j,382078,f[(f[l>>2]|0)+4+(g<<2)>>2]|0);jIa(i,j,382084);f[h>>2]=0;f[h+4>>2]=0;j=i+11|0;g=b[j>>0]|0;l=g<<24>>24<0?f[i+4>>2]|0:g&255;if(!l)z5(-204,h,382070,381655,272);g=tT(h,l)|0;dJc(g|0,((b[j>>0]|0)<0?f[i>>2]|0:i)|0,l|0)|0;z5(-204,h,382070,381655,272)}h=d+28|0;f[a>>2]=f[h>>2];l=a+4|0;i=d+32|0;f[l>>2]=f[i>>2];j=a+8|0;f[j>>2]=f[d+36>>2];f[a+12>>2]=f[d+40>>2];f[a+16>>2]=f[d+44>>2];f[a+20>>2]=f[d+48>>2];f[a+24>>2]=f[d+52>>2];f[a+28>>2]=f[d+56>>2];f[a+32>>2]=f[d+60>>2];g=f[d+64>>2]|0;f[a+36>>2]=g;f[a+40>>2]=j;j=a+48|0;e=a+44|0;f[e>>2]=j;f[j>>2]=0;f[a+52>>2]=0;if(g|0){j=g+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[d+72>>2]|0;d=f[e>>2]|0;f[d>>2]=f[i>>2];f[d+4>>2]=f[i+4>>2];u=c;return}else{f[l>>2]=0;ZS(a,h);u=c;return}}function iIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function jIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=Mpc(d)|0;i=g?f[c>>2]|0:c;c=h+e|0;if(c>>>0>4294967279)dEc(a);if(c>>>0<11){b[a+11>>0]=h;j=a}else{g=c+16&-16;c=VDc(g)|0;f[a>>2]=c;f[a+8>>2]=g|-2147483648;f[a+4>>2]=h;j=c}if(!h){k=j+h|0;b[k>>0]=0;tEc(a,d,e)|0;return}dJc(j|0,i|0,h|0)|0;k=j+h|0;b[k>>0]=0;tEc(a,d,e)|0;return}function kIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=u;u=u+32|0;d=a+24|0;e=a+16|0;g=a+8|0;h=a;f[d>>2]=0;f[d+4>>2]=0;i=tT(d,8)|0;j=i;b[j>>0]=112;b[j+1>>0]=97;b[j+2>>0]=100;b[j+3>>0]=95;j=i+4|0;b[j>>0]=109;b[j+1>>0]=111;b[j+2>>0]=100;b[j+3>>0]=101;j=c+4|0;i=f[j>>2]|0;a:do if(i|0){k=f[d>>2]|0;l=(k|0)==0?1154740:k;m=i;while(1){n=f[m+16>>2]|0;if((k|0)==(n|0))break;o=(n|0)==0?1154740:n;if((Ioc(l,o)|0)<0)p=m;else{if((Ioc(o,l)|0)>=0)break;p=m+4|0}m=f[p>>2]|0;if(!m)break a}uT(d);q=1;u=a;return q|0}while(0);uT(d);f[d>>2]=0;f[d+4>>2]=0;p=tT(d,5)|0;b[p>>0]=b[387904]|0;b[p+1>>0]=b[387905]|0;b[p+2>>0]=b[387906]|0;b[p+3>>0]=b[387907]|0;b[p+4>>0]=b[387908]|0;p=f[j>>2]|0;b:do if(p|0){j=f[d>>2]|0;i=(j|0)==0?1154740:j;m=p;while(1){l=f[m+16>>2]|0;if((j|0)==(l|0))break;k=(l|0)==0?1154740:l;if((Ioc(i,k)|0)<0)r=m;else{if((Ioc(k,i)|0)>=0)break;r=m+4|0}m=f[r>>2]|0;if(!m)break b}uT(d);f[d>>2]=0;f[d+4>>2]=0;m=tT(d,5)|0;b[m>>0]=b[387904]|0;b[m+1>>0]=b[387905]|0;b[m+2>>0]=b[387906]|0;b[m+3>>0]=b[387907]|0;b[m+4>>0]=b[387908]|0;m=DHa(lIa(c,d)|0,-1)|0;f[e>>2]=0;f[e+4>>2]=0;i=tT(e,5)|0;b[i>>0]=b[450433]|0;b[i+1>>0]=b[450434]|0;b[i+2>>0]=b[450435]|0;b[i+3>>0]=b[450436]|0;b[i+4>>0]=b[450437]|0;i=DHa(lIa(c,e)|0,-1)|0;if((m|0)==(i|0)){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,5)|0;b[i>>0]=b[387898]|0;b[i+1>>0]=b[387899]|0;b[i+2>>0]=b[387900]|0;b[i+3>>0]=b[387901]|0;b[i+4>>0]=b[387902]|0;i=DHa(lIa(c,g)|0,-1)|0;f[h>>2]=0;f[h+4>>2]=0;m=tT(h,5)|0;b[m>>0]=b[450427]|0;b[m+1>>0]=b[450428]|0;b[m+2>>0]=b[450429]|0;b[m+3>>0]=b[450430]|0;b[m+4>>0]=b[450431]|0;m=DHa(lIa(c,h)|0,-1)|0;uT(h);uT(g);s=(i|0)!=(m|0)}else s=1;uT(e);uT(d);q=s;u=a;return q|0}while(0);uT(d);q=0;u=a;return q|0}function lIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d+8|0;g=d;h=a+4|0;a=f[h>>2]|0;if(a|0){i=f[c>>2]|0;j=(i|0)==0?1154740:i;k=h;l=a;a:while(1){a=l;while(1){m=f[a+16>>2]|0;if((m|0)==(i|0))break;if((Ioc((m|0)==0?1154740:m,j)|0)>=0)break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(h|0)){h=f[n+16>>2]|0;if((i|0)==(h|0)){o=n+24|0;u=d;return o|0}if((Ioc(j,(h|0)==0?1154740:h)|0)>=0){o=n+24|0;u=d;return o|0}}}f[g>>2]=0;o=g+4|0;f[o>>2]=0;d=c+4|0;tT(g,(f[d>>2]|0)+19|0)|0;n=f[g>>2]|0;h=n;j=382110;i=h+19|0;do{b[h>>0]=b[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(i|0));k=f[d>>2]|0;if(k|0)dJc(n+19|0,f[c>>2]|0,k|0)|0;f[e>>2]=0;f[e+4>>2]=0;tT(e,(f[o>>2]|0)+27|0)|0;k=f[o>>2]|0;if(!k){p=0;q=f[e>>2]|0;r=q+p|0;h=r;j=382130;i=h+27|0;do{b[h>>0]=b[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(i|0));z5(-204,e,382158,451988,333)}dJc(f[e>>2]|0,f[g>>2]|0,k|0)|0;p=f[o>>2]|0;q=f[e>>2]|0;r=q+p|0;h=r;j=382130;i=h+27|0;do{b[h>>0]=b[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(i|0));z5(-204,e,382158,451988,333);return 0}function mIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0.0,vl=0,wl=0.0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0,Gl=0,Hl=0,Il=0,Jl=0,Kl=0,Ll=0,Ml=0,Nl=0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0,$l=0,am=0,bm=0,cm=0,dm=0,em=0,fm=0,gm=0,hm=0,im=0,jm=0,km=0,lm=0,mm=0,nm=0,om=0,pm=0,qm=0,rm=0,sm=0,tm=0,um=0,vm=0,wm=0,xm=0,ym=0,zm=0,Am=0,Bm=0,Cm=0,Dm=0,Em=0,Fm=0,Gm=0,Hm=0,Im=0,Jm=0,Km=0,Lm=0,Mm=0,Nm=0,Om=0,Pm=0,Qm=0,Rm=0,Sm=0,Tm=0,Um=0;d=u;u=u+1536|0;e=d+1480|0;g=d+1424|0;h=d+1168|0;i=d+1144|0;j=d+1072|0;k=d+1048|0;l=d+976|0;m=d+928|0;o=d+1408|0;q=d+848|0;r=d+836|0;s=d+280|0;t=d+768|0;v=d+704|0;w=d+1400|0;x=d+1344|0;y=d;z=d+56|0;A=d+1336|0;B=d+636|0;C=d+568|0;D=d+504|0;E=d+1328|0;F=d+1272|0;G=d+1160|0;H=d+1088|0;I=d+1064|0;J=d+992|0;K=d+968|0;L=a+8|0;if(!(f[L>>2]&16)){f[e>>2]=0;f[e+4>>2]=0;M=tT(e,23)|0;N=382162;O=M+23|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,292)}P=f[a+64>>2]|0;rmb(h,P|0?P:526e3);WHa(i,0,h);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(f[L>>2]&1|0)iEc(j,f[a+48>>2]|0)|0;a=k+4|0;f[a>>2]=0;L=k+8|0;f[L>>2]=0;P=k+4|0;f[k>>2]=P;f[l>>2]=0;Q=l+4|0;f[Q>>2]=0;f[l+8>>2]=0;R=h+52|0;if((f[R>>2]|0)>0){S=h+60|0;T=i+4|0;U=e+4|0;V=l+8|0;W=m+12|0;X=g+12|0;Z=g+11|0;_=m+11|0;$=o+11|0;aa=0;do{ba=f[(f[(f[S>>2]|0)+4+(aa<<2)>>2]|0)+16>>2]|0;if((nIa(i,ba)|0)==(T|0)){f[e>>2]=0;f[U>>2]=0;ca=ba+11|0;da=b[ca>>0]|0;ea=da<<24>>24<0?f[ba+4>>2]|0:da&255;if(ea|0){da=tT(e,ea)|0;dJc(da|0,((b[ca>>0]|0)<0?f[ba>>2]|0:ba)|0,ea|0)|0}ea=f[Q>>2]|0;if((ea|0)==(f[V>>2]|0))L_(l,e);else{ca=f[e>>2]|0;f[ea>>2]=ca;f[ea+4>>2]=f[U>>2];if(!ca)fa=ea;else{ea=ca+-4|0;f[ea>>2]=(f[ea>>2]|0)+1;fa=f[Q>>2]|0}f[Q>>2]=fa+8}uT(e);fEc(o,ba);ba=f[Q>>2]|0;ea=f[l>>2]|0;fEc(m,o);ca=W;f[ca>>2]=0;f[ca+4>>2]=(ba-ea>>3)+-1;fEc(g,m);ea=W;ba=f[ea+4>>2]|0;ca=X;f[ca>>2]=f[ea>>2];f[ca+4>>2]=ba;ba=oIa(k,e,g)|0;if(!(f[ba>>2]|0)){ca=VDc(36)|0;fEc(ca+16|0,g);ea=X;da=f[ea+4>>2]|0;ga=ca+28|0;f[ga>>2]=f[ea>>2];f[ga+4>>2]=da;da=f[e>>2]|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=da;f[ba>>2]=ca;da=f[f[k>>2]>>2]|0;if(!da)ha=ca;else{f[k>>2]=da;ha=f[ba>>2]|0}laa(f[a>>2]|0,ha);f[L>>2]=(f[L>>2]|0)+1}if((b[Z>>0]|0)<0)YDc(f[g>>2]|0);if((b[_>>0]|0)<0)YDc(f[m>>2]|0);if((b[$>>0]|0)<0)YDc(f[o>>2]|0)}aa=aa+1|0}while((aa|0)<(f[R>>2]|0))}zHa(c,l);R=f[h+20>>2]|0;f[m+4>>2]=0;f[m+8>>2]=0;aa=m+4|0;f[m>>2]=aa;o=m+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;llb(q);a:do if((R|0)>0){o=h+28|0;$=m+12|0;_=e+12|0;Z=e+16|0;ha=m+24|0;X=e+24|0;W=e+28|0;fa=m+28|0;U=m+32|0;V=e+32|0;T=e+36|0;S=m+36|0;ba=q+36|0;da=q+44|0;ca=q+68|0;ga=r+11|0;ea=r+4|0;ia=e+4|0;ja=e+4|0;ka=K+4|0;la=t+4|0;ma=t+8|0;na=g+11|0;oa=g+12|0;pa=q+20|0;qa=q+28|0;ra=g+8|0;sa=g+4|0;ta=e+4|0;ua=e+4|0;va=e+4|0;wa=j+11|0;xa=j+4|0;ya=e+4|0;za=e+4|0;Aa=g+36|0;Ba=e+36|0;Ca=e+16|0;Da=e+4|0;Ea=e+40|0;Fa=g+4|0;Ga=g+8|0;Ha=e+8|0;Ia=g+12|0;Ja=e+12|0;Ka=g+44|0;La=e+44|0;Ma=g+16|0;Na=g+20|0;Oa=e+20|0;Pa=g+24|0;Qa=e+24|0;Ra=g+28|0;Sa=e+28|0;Ta=g+32|0;Ua=e+32|0;Va=g+40|0;Wa=g+48|0;Xa=g+4|0;Ya=e+48|0;Za=m+16|0;_a=m+20|0;$a=e+4|0;ab=e+8|0;bb=e+40|0;cb=e+48|0;db=e+44|0;eb=e+52|0;fb=g+36|0;gb=g+16|0;hb=g+4|0;ib=g+40|0;jb=g+44|0;kb=g+48|0;lb=g+36|0;mb=e+36|0;nb=e+16|0;ob=g+4|0;pb=g+8|0;qb=g+12|0;rb=e+12|0;sb=g+44|0;tb=g+16|0;ub=g+20|0;vb=e+20|0;wb=g+24|0;xb=e+24|0;yb=g+28|0;zb=e+28|0;Ab=g+32|0;Bb=e+32|0;Cb=g+40|0;Db=g+48|0;Eb=g+4|0;Fb=w+4|0;Gb=x+4|0;Hb=x+8|0;Ib=x+12|0;Jb=x+16|0;Kb=x+20|0;Lb=x+24|0;Mb=x+28|0;Nb=x+32|0;Ob=x+36|0;Pb=x+40|0;Qb=x+48|0;Rb=x+44|0;Sb=x+52|0;Tb=v+4|0;Ub=v+8|0;Vb=v+12|0;Wb=v+16|0;Xb=v+20|0;Yb=v+24|0;Zb=v+28|0;_b=v+32|0;$b=v+36|0;ac=v+40|0;bc=v+44|0;cc=v+48|0;dc=v+56|0;ec=v+52|0;fc=v+60|0;gc=t+11|0;hc=t+12|0;ic=t+16|0;jc=t+20|0;kc=t+24|0;lc=t+28|0;mc=t+32|0;nc=t+36|0;oc=t+40|0;pc=t+44|0;qc=t+48|0;rc=t+52|0;sc=t+60|0;tc=t+56|0;uc=t+64|0;vc=i+4|0;wc=i+8|0;xc=t+8|0;yc=t+4|0;zc=e+4|0;Ac=v+4|0;Bc=e+4|0;Cc=v+4|0;Dc=y+8|0;Ec=g+4|0;Fc=g+8|0;Gc=g+40|0;Hc=g+48|0;Ic=g+44|0;Jc=g+52|0;Kc=e+4|0;Lc=g+36|0;Mc=g+16|0;Nc=e+4|0;Oc=g+4|0;Pc=v+4|0;Qc=v+8|0;Rc=v+40|0;Sc=v+48|0;Tc=v+44|0;Uc=v+52|0;Vc=v+12|0;Wc=e+4|0;Xc=v+16|0;Yc=y+4|0;Zc=v+36|0;_c=v+20|0;$c=v+24|0;ad=v+28|0;bd=v+32|0;cd=g+12|0;dd=g+20|0;ed=g+24|0;fd=g+28|0;gd=g+32|0;hd=e+4|0;id=g+4|0;jd=e+4|0;kd=g+4|0;ld=e+4|0;md=g+4|0;nd=e+4|0;od=g+4|0;pd=e+4|0;qd=g+4|0;rd=t+4|0;sd=t+4|0;td=g+36|0;ud=g+16|0;vd=g+4|0;wd=g+40|0;xd=g+44|0;yd=g+48|0;zd=e+36|0;Ad=e+16|0;Bd=e+4|0;Cd=e+40|0;Dd=e+44|0;Ed=e+48|0;Fd=t+4|0;Gd=t+36|0;Hd=t+16|0;Id=t+4|0;Jd=t+40|0;Kd=t+44|0;Ld=t+48|0;Md=t+8|0;Nd=t+12|0;Od=t+20|0;Pd=t+24|0;Qd=t+28|0;Rd=t+32|0;Sd=t+4|0;Td=t+36|0;Ud=t+16|0;Vd=t+4|0;Wd=t+40|0;Xd=t+44|0;Yd=t+48|0;Zd=t+8|0;_d=t+12|0;$d=t+20|0;ae=t+24|0;be=t+28|0;ce=t+32|0;de=g+8|0;ee=g+12|0;fe=g+20|0;ge=g+24|0;he=g+28|0;ie=g+32|0;je=e+8|0;ke=e+12|0;le=e+20|0;me=e+24|0;ne=e+28|0;oe=e+32|0;pe=g+4|0;qe=g+8|0;re=g+12|0;se=g+4|0;te=t+8|0;ue=t+4|0;ve=g+36|0;we=g+16|0;xe=g+4|0;ye=g+40|0;ze=g+44|0;Ae=g+48|0;Be=g+8|0;Ce=g+12|0;De=g+20|0;Ee=g+24|0;Fe=g+28|0;Ge=g+32|0;He=g+4|0;Ie=g+4|0;Je=e+36|0;Ke=e+16|0;Le=e+4|0;Me=e+40|0;Ne=e+44|0;Oe=e+48|0;Pe=e+8|0;Qe=e+12|0;Re=e+20|0;Se=e+24|0;Te=e+28|0;Ue=e+32|0;Ve=t+4|0;We=g+4|0;Xe=g+8|0;Ye=g+40|0;Ze=g+48|0;_e=g+44|0;$e=g+52|0;af=g+36|0;bf=g+16|0;cf=g+4|0;df=g+4|0;ef=e+36|0;ff=e+16|0;gf=e+4|0;hf=e+40|0;jf=e+44|0;kf=e+48|0;lf=g+12|0;mf=g+20|0;nf=g+24|0;of=g+28|0;pf=g+32|0;qf=g+36|0;rf=e+36|0;sf=e+16|0;tf=e+4|0;uf=e+40|0;vf=g+4|0;wf=g+8|0;xf=e+8|0;yf=g+12|0;zf=e+12|0;Af=g+44|0;Bf=e+44|0;Cf=g+16|0;Df=g+20|0;Ef=e+20|0;Ff=g+24|0;Gf=e+24|0;Hf=g+28|0;If=e+28|0;Jf=g+32|0;Kf=e+32|0;Lf=g+40|0;Mf=g+48|0;Nf=g+4|0;Of=e+48|0;Pf=e+4|0;Qf=e+4|0;Rf=e+4|0;Sf=e+36|0;Tf=e+16|0;Uf=e+4|0;Vf=e+40|0;Wf=e+44|0;Xf=e+48|0;Yf=e+8|0;Zf=e+12|0;_f=e+20|0;$f=e+24|0;ag=e+28|0;bg=e+32|0;cg=e+4|0;dg=e+4|0;eg=e+36|0;fg=e+16|0;gg=e+4|0;hg=e+40|0;ig=e+44|0;jg=e+48|0;kg=e+8|0;lg=e+12|0;mg=e+20|0;ng=e+24|0;og=e+28|0;pg=e+32|0;qg=e+4|0;rg=g+4|0;sg=e+4|0;tg=y+4|0;ug=y+8|0;vg=t+4|0;wg=v+4|0;xg=v+4|0;yg=E+4|0;zg=F+4|0;Ag=B+4|0;Bg=F+8|0;Cg=B+8|0;Dg=F+12|0;Eg=B+12|0;Fg=F+16|0;Gg=B+16|0;Hg=F+20|0;Ig=B+20|0;Jg=F+24|0;Kg=B+24|0;Lg=F+28|0;Mg=B+28|0;Ng=F+32|0;Og=B+32|0;Pg=F+36|0;Qg=B+36|0;Rg=F+40|0;Sg=F+48|0;Tg=F+44|0;Ug=F+52|0;Vg=B+44|0;Wg=D+4|0;Xg=D+8|0;Yg=D+12|0;Zg=D+16|0;_g=D+20|0;$g=D+24|0;ah=D+28|0;bh=D+32|0;ch=D+36|0;dh=D+40|0;eh=D+44|0;fh=D+48|0;gh=D+56|0;hh=D+52|0;ih=D+60|0;jh=C+11|0;kh=C+12|0;lh=C+16|0;mh=C+20|0;nh=C+24|0;oh=C+28|0;ph=C+32|0;qh=C+36|0;rh=C+40|0;sh=C+44|0;th=C+48|0;uh=C+52|0;vh=C+60|0;wh=C+56|0;xh=C+64|0;yh=B+40|0;zh=B+48|0;Ah=t+36|0;Bh=t+16|0;Ch=t+40|0;Dh=t+44|0;Eh=t+48|0;Fh=C+8|0;Gh=C+4|0;Hh=y+8|0;Ih=g+4|0;Jh=g+8|0;Kh=e+8|0;Lh=e+4|0;Mh=G+4|0;Nh=H+4|0;Oh=y+4|0;Ph=H+8|0;Qh=y+8|0;Rh=H+12|0;Sh=y+12|0;Th=H+16|0;Uh=y+16|0;Vh=H+20|0;Wh=y+20|0;Xh=H+24|0;Yh=y+24|0;Zh=H+28|0;_h=y+28|0;$h=H+32|0;ai=y+32|0;bi=H+36|0;ci=y+36|0;di=H+40|0;fi=H+48|0;gi=H+44|0;hi=H+52|0;ii=y+44|0;ji=C+4|0;ki=C+8|0;li=C+12|0;mi=C+16|0;ni=C+20|0;oi=C+24|0;pi=C+28|0;qi=C+32|0;ri=C+36|0;si=C+40|0;ti=C+44|0;ui=C+48|0;vi=C+56|0;wi=C+52|0;xi=C+60|0;yi=B+11|0;zi=B+12|0;Ai=B+16|0;Bi=B+20|0;Ci=B+24|0;Di=B+28|0;Ei=B+32|0;Fi=B+36|0;Gi=B+40|0;Hi=B+44|0;Ii=B+48|0;Ji=B+52|0;Ki=B+60|0;Li=B+56|0;Mi=B+64|0;Ni=y+40|0;Oi=y+48|0;Pi=v+36|0;Qi=v+16|0;Ri=v+4|0;Si=v+40|0;Ti=v+44|0;Ui=v+48|0;Vi=B+8|0;Wi=B+4|0;Xi=t+36|0;Yi=t+16|0;Zi=t+4|0;_i=t+40|0;$i=t+44|0;aj=t+48|0;bj=e+4|0;cj=t+8|0;dj=t+12|0;ej=g+4|0;fj=e+4|0;gj=e+4|0;hj=v+4|0;ij=v+8|0;jj=t+4|0;kj=v+8|0;lj=t+4|0;mj=I+4|0;nj=J+4|0;oj=B+4|0;pj=J+8|0;qj=B+8|0;rj=J+12|0;sj=B+12|0;tj=J+16|0;uj=B+16|0;vj=J+20|0;wj=B+20|0;xj=J+24|0;yj=B+24|0;zj=J+28|0;Aj=B+28|0;Bj=J+32|0;Cj=B+32|0;Dj=J+36|0;Ej=B+36|0;Fj=J+40|0;Gj=J+48|0;Hj=J+44|0;Ij=J+52|0;Jj=B+44|0;Kj=D+4|0;Lj=D+8|0;Mj=D+12|0;Nj=D+16|0;Oj=D+20|0;Pj=D+24|0;Qj=D+28|0;Rj=D+32|0;Sj=D+36|0;Tj=D+40|0;Uj=D+44|0;Vj=D+48|0;Wj=D+56|0;Xj=D+52|0;Yj=D+60|0;Zj=C+11|0;_j=C+12|0;ak=C+16|0;bk=C+20|0;ck=C+24|0;dk=C+28|0;ek=C+32|0;fk=C+36|0;gk=C+40|0;hk=C+44|0;ik=C+48|0;jk=C+52|0;kk=C+60|0;lk=C+56|0;mk=C+64|0;nk=B+40|0;ok=B+48|0;pk=y+36|0;qk=y+16|0;rk=y+4|0;sk=y+40|0;tk=y+44|0;uk=y+48|0;vk=C+8|0;wk=C+4|0;xk=e+4|0;yk=g+4|0;zk=e+36|0;Ak=e+16|0;Bk=e+4|0;Ck=e+40|0;Dk=e+44|0;Ek=e+48|0;Fk=e+8|0;Gk=e+12|0;Hk=e+20|0;Ik=e+24|0;Jk=e+28|0;Kk=e+32|0;Lk=0;b:while(1){tmb(q,f[(f[o>>2]|0)+4+(Lk<<2)>>2]|0);_Ha(e,0,q);pIa(m,e)|0;XGa($,f[_>>2]|0,f[Z>>2]|0);uT(ha);Mk=f[X>>2]|0;if(!Mk)Nk=0;else{Ok=Mk+-4|0;f[Ok>>2]=(f[Ok>>2]|0)+1;Nk=f[X>>2]|0}f[ha>>2]=Nk;f[fa>>2]=f[W>>2];uT(U);Ok=f[V>>2]|0;if(!Ok)Pk=0;else{Mk=Ok+-4|0;f[Mk>>2]=(f[Mk>>2]|0)+1;Pk=f[V>>2]|0}f[U>>2]=Pk;f[S>>2]=f[T>>2];HFa(e);if((f[ba>>2]|0)<=0){Qk=35;break}Mk=f[(f[da>>2]|0)+4>>2]|0;uT(ha);Ok=Mk+11|0;Rk=b[Ok>>0]|0;Sk=Rk<<24>>24<0?f[Mk+4>>2]|0:Rk&255;if(Sk|0){Rk=tT(ha,Sk)|0;dJc(Rk|0,((b[Ok>>0]|0)<0?f[Mk>>2]|0:Mk)|0,Sk|0)|0}fEc(r,f[ca>>2]|0);uT(U);Sk=b[ga>>0]|0;Mk=f[ea>>2]|0;Ok=Sk<<24>>24<0?Mk:Sk&255;if(!Ok){Tk=Sk;Uk=Mk}else{Mk=tT(U,Ok)|0;dJc(Mk|0,((b[ga>>0]|0)<0?f[r>>2]|0:r)|0,Ok|0)|0;Tk=b[ga>>0]|0;Uk=f[ea>>2]|0}do if(((Tk<<24>>24<0?Uk:Tk&255)|0)==7)if(!(EEc(r,0,-1,383768,7)|0)){uT(U);Ok=tT(U,7)|0;b[Ok>>0]=b[454888]|0;b[Ok+1>>0]=b[454889]|0;b[Ok+2>>0]=b[454890]|0;b[Ok+3>>0]=b[454891]|0;b[Ok+4>>0]=b[454892]|0;b[Ok+5>>0]=b[454893]|0;b[Ok+6>>0]=b[454894]|0;f[e>>2]=0;f[ia>>2]=0;Ok=tT(e,4)|0;b[Ok>>0]=112;b[Ok+1>>0]=111;b[Ok+2>>0]=111;b[Ok+3>>0]=108;qIa(m,e,387037)|0;uT(e);f[e>>2]=0;f[ja>>2]=0;M=tT(e,9)|0;N=452699;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));Ok=(kIa(0,m)|0)&1;b[g>>0]=Ok;rIa(m,e,g)|0;uT(e);Qk=927;break}else{Vk=b[ga>>0]|0;Wk=f[ea>>2]|0;Qk=44;break}else{Vk=Tk;Wk=Uk;Qk=44}while(0);c:do if((Qk|0)==44){Qk=0;do if(((Vk<<24>>24<0?Wk:Vk&255)|0)==11){if(EEc(r,0,-1,382216,11)|0){Xk=b[ga>>0]|0;Yk=f[ea>>2]|0;break}uT(U);Ok=tT(U,7)|0;b[Ok>>0]=b[454888]|0;b[Ok+1>>0]=b[454889]|0;b[Ok+2>>0]=b[454890]|0;b[Ok+3>>0]=b[454891]|0;b[Ok+4>>0]=b[454892]|0;b[Ok+5>>0]=b[454893]|0;b[Ok+6>>0]=b[454894]|0;f[e>>2]=0;f[ta>>2]=0;Ok=tT(e,4)|0;b[Ok>>0]=112;b[Ok+1>>0]=111;b[Ok+2>>0]=111;b[Ok+3>>0]=108;qIa(m,e,387065)|0;uT(e);f[e>>2]=0;f[ua>>2]=0;M=tT(e,9)|0;N=452699;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));Ok=(kIa(0,m)|0)&1;b[g>>0]=Ok;rIa(m,e,g)|0;uT(e);f[e>>2]=0;f[va>>2]=0;M=tT(e,20)|0;N=452723;O=M+20|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));Ok=b[wa>>0]|0;if(((Ok<<24>>24<0?f[xa>>2]|0:Ok&255)|0)==7)Zk=(EEc(j,0,-1,382228,7)|0)==0;else Zk=0;b[g>>0]=Zk&1;rIa(m,e,g)|0;uT(e);Qk=927;break c}else{Xk=Vk;Yk=Wk}while(0);do if(((Xk<<24>>24<0?Yk:Xk&255)|0)==17)if(!(EEc(r,0,-1,382236,17)|0)){uT(U);Ok=tT(U,7)|0;b[Ok>>0]=b[454888]|0;b[Ok+1>>0]=b[454889]|0;b[Ok+2>>0]=b[454890]|0;b[Ok+3>>0]=b[454891]|0;b[Ok+4>>0]=b[454892]|0;b[Ok+5>>0]=b[454893]|0;b[Ok+6>>0]=b[454894]|0;f[e>>2]=0;f[ya>>2]=0;Ok=tT(e,4)|0;b[Ok>>0]=112;b[Ok+1>>0]=111;b[Ok+2>>0]=111;b[Ok+3>>0]=108;qIa(m,e,387065)|0;uT(e);f[e>>2]=0;f[za>>2]=0;M=tT(e,14)|0;N=454860;O=M+14|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[g>>0]=1;rIa(m,e,g)|0;uT(e);Qk=927;break c}else{_k=b[ga>>0]|0;$k=f[ea>>2]|0;break}else{_k=Xk;$k=Yk}while(0);if(((_k<<24>>24<0?$k:_k&255)|0)==3){if(EEc(r,0,-1,427390,3)|0){al=b[ga>>0]|0;bl=f[ea>>2]|0;Qk=57}}else{al=_k;bl=$k;Qk=57}do if((Qk|0)==57){Qk=0;if(((al<<24>>24<0?bl:al&255)|0)==3){if(!(EEc(r,0,-1,427624,3)|0))break;cl=b[ga>>0]|0;dl=f[ea>>2]|0}else{cl=al;dl=bl}do if(((cl<<24>>24<0?dl:cl&255)|0)==3){if(EEc(r,0,-1,428165,3)|0){el=b[ga>>0]|0;fl=f[ea>>2]|0;break}hIa(g,0,q,i,1);oY(s,-1.0,g);f[e>>2]=1124007936;M=$a;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[bb>>2]=ab;f[db>>2]=cb;f[cb>>2]=0;f[eb>>2]=0;Ok=f[s>>2]|0;ei[f[(f[Ok>>2]|0)+12>>2]&511](Ok,s,e,-1);$j(s);Ok=f[fb>>2]|0;do if(Ok|0){Mk=Ok+12|0;Sk=f[Mk>>2]|0;f[Mk>>2]=Sk+-1;if((Sk|0)!=1)break;_S(g)}while(0);f[fb>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[hb>>2]|0)>0){Ok=f[ib>>2]|0;Sk=0;do{f[Ok+(Sk<<2)>>2]=0;Sk=Sk+1|0}while((Sk|0)<(f[hb>>2]|0))}Sk=f[jb>>2]|0;if((Sk|0)!=(kb|0))g0(Sk);lT(g,e,1,1);Sk=f[lb>>2]|0;if(Sk|0){Ok=Sk+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1}Ok=f[mb>>2]|0;do if(Ok|0){Sk=Ok+12|0;Mk=f[Sk>>2]|0;f[Sk>>2]=Mk+-1;if((Mk|0)!=1)break;_S(e)}while(0);f[mb>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[$a>>2]|0)>0){Ok=f[bb>>2]|0;Mk=0;do{f[Ok+(Mk<<2)>>2]=0;Mk=Mk+1|0;gl=f[$a>>2]|0}while((Mk|0)<(gl|0));f[e>>2]=f[g>>2];if((gl|0)<3)Qk=127;else Qk=129}else{f[e>>2]=f[g>>2];Qk=127}do if((Qk|0)==127){Qk=0;Mk=f[ob>>2]|0;if((Mk|0)>=3){Qk=129;break}f[$a>>2]=Mk;f[ab>>2]=f[pb>>2];f[rb>>2]=f[qb>>2];Mk=f[sb>>2]|0;Ok=f[db>>2]|0;f[Ok>>2]=f[Mk>>2];f[Ok+4>>2]=f[Mk+4>>2]}while(0);if((Qk|0)==129){Qk=0;ZS(e,g)}f[nb>>2]=f[tb>>2];f[vb>>2]=f[ub>>2];f[xb>>2]=f[wb>>2];f[zb>>2]=f[yb>>2];f[Bb>>2]=f[Ab>>2];Mk=f[lb>>2]|0;f[mb>>2]=Mk;do if(Mk|0){Ok=Mk+12|0;Sk=f[Ok>>2]|0;f[Ok>>2]=Sk+-1;if((Sk|0)!=1)break;_S(g)}while(0);f[lb>>2]=0;f[tb>>2]=0;f[tb+4>>2]=0;f[tb+8>>2]=0;f[tb+12>>2]=0;if((f[ob>>2]|0)>0){Mk=f[Cb>>2]|0;Sk=0;do{f[Mk+(Sk<<2)>>2]=0;Sk=Sk+1|0}while((Sk|0)<(f[ob>>2]|0))}Sk=f[sb>>2]|0;if((Sk|0)!=(Db|0))g0(Sk);Sk=f[$a>>2]|0;if((Sk|0)<3)hl=Y(f[rb>>2]|0,f[ab>>2]|0)|0;else{Mk=f[bb>>2]|0;Ok=0;Rk=1;while(1){il=Y(f[Mk+(Ok<<2)>>2]|0,Rk)|0;Ok=Ok+1|0;if((Ok|0)==(Sk|0)){hl=il;break}else Rk=il}}uT(U);Rk=tT(U,5)|0;do if((hl|0)==1){b[Rk>>0]=b[451285]|0;b[Rk+1>>0]=b[451286]|0;b[Rk+2>>0]=b[451287]|0;b[Rk+3>>0]=b[451288]|0;b[Rk+4>>0]=b[451289]|0;f[g>>2]=0;f[Eb>>2]=0;Sk=tT(g,5)|0;b[Sk>>0]=b[440275]|0;b[Sk+1>>0]=b[440276]|0;b[Sk+2>>0]=b[440277]|0;b[Sk+3>>0]=b[440278]|0;b[Sk+4>>0]=b[440279]|0;eIa(m,g,f[nb>>2]|0)|0;uT(g)}else{b[Rk>>0]=b[425749]|0;b[Rk+1>>0]=b[425750]|0;b[Rk+2>>0]=b[425751]|0;b[Rk+3>>0]=b[425752]|0;b[Rk+4>>0]=b[425753]|0;Sk=f[Za>>2]|0;if((Sk|0)==(f[_a>>2]|0)){Bxa($,e);break}f[Sk>>2]=f[e>>2];Ok=Sk+4|0;f[Ok>>2]=f[$a>>2];Mk=Sk+8|0;f[Mk>>2]=f[ab>>2];f[Sk+12>>2]=f[rb>>2];f[Sk+16>>2]=f[nb>>2];f[Sk+20>>2]=f[vb>>2];f[Sk+24>>2]=f[xb>>2];f[Sk+28>>2]=f[zb>>2];f[Sk+32>>2]=f[Bb>>2];il=f[mb>>2]|0;f[Sk+36>>2]=il;f[Sk+40>>2]=Mk;Mk=Sk+48|0;jl=Sk+44|0;f[jl>>2]=Mk;f[Mk>>2]=0;f[Sk+52>>2]=0;if(il|0){Mk=il+12|0;f[Mk>>2]=(f[Mk>>2]|0)+1}if((f[$a>>2]|0)<3){Mk=f[db>>2]|0;il=f[jl>>2]|0;f[il>>2]=f[Mk>>2];f[il+4>>2]=f[Mk+4>>2]}else{f[Ok>>2]=0;ZS(Sk,e)}f[Za>>2]=(f[Za>>2]|0)+56}while(0);Rk=f[mb>>2]|0;do if(Rk|0){Sk=Rk+12|0;Ok=f[Sk>>2]|0;f[Sk>>2]=Ok+-1;if((Ok|0)!=1)break;_S(e)}while(0);f[mb>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[$a>>2]|0)>0){Rk=f[bb>>2]|0;Ok=0;do{f[Rk+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[$a>>2]|0))}Ok=f[db>>2]|0;if((Ok|0)!=(cb|0))g0(Ok);Qk=927;break c}else{el=cl;fl=dl}while(0);do if(((el<<24>>24<0?fl:el&255)|0)==8){if(EEc(r,0,-1,382254,8)|0){kl=b[ga>>0]|0;ll=f[ea>>2]|0;break}if(f[pa>>2]|0){Qk=165;break b}Ok=f[$>>2]|0;if(((f[Za>>2]|0)-Ok|0)!=56){Qk=167;break b}Rk=f[ha>>2]|0;f[w>>2]=Rk;f[Fb>>2]=f[fa>>2];if(!Rk)ml=Ok;else{Ok=Rk+-4|0;f[Ok>>2]=(f[Ok>>2]|0)+1;ml=f[$>>2]|0}f[x>>2]=f[ml>>2];Ok=ml+4|0;f[Gb>>2]=f[Ok>>2];f[Hb>>2]=f[ml+8>>2];f[Ib>>2]=f[ml+12>>2];f[Jb>>2]=f[ml+16>>2];f[Kb>>2]=f[ml+20>>2];f[Lb>>2]=f[ml+24>>2];f[Mb>>2]=f[ml+28>>2];f[Nb>>2]=f[ml+32>>2];Rk=f[ml+36>>2]|0;f[Ob>>2]=Rk;f[Pb>>2]=Hb;f[Rb>>2]=Qb;f[Qb>>2]=0;f[Sb>>2]=0;if(Rk|0){Sk=Rk+12|0;f[Sk>>2]=(f[Sk>>2]|0)+1}if((f[Ok>>2]|0)<3){Ok=f[ml+44>>2]|0;Sk=f[Rb>>2]|0;f[Sk>>2]=f[Ok>>2];f[Sk+4>>2]=f[Ok+4>>2]}else{f[Gb>>2]=0;ZS(x,ml)}Ok=f[w>>2]|0;f[v>>2]=Ok;f[Tb>>2]=f[Fb>>2];if(Ok|0){Sk=Ok+-4|0;f[Sk>>2]=(f[Sk>>2]|0)+1}f[Ub>>2]=f[x>>2];Sk=f[Gb>>2]|0;f[Vb>>2]=Sk;f[Wb>>2]=f[Hb>>2];f[Xb>>2]=f[Ib>>2];f[Yb>>2]=f[Jb>>2];f[Zb>>2]=f[Kb>>2];f[_b>>2]=f[Lb>>2];f[$b>>2]=f[Mb>>2];f[ac>>2]=f[Nb>>2];Ok=f[Ob>>2]|0;f[bc>>2]=Ok;f[cc>>2]=Wb;f[ec>>2]=dc;f[dc>>2]=0;f[fc>>2]=0;if(!Ok)nl=Sk;else{Sk=Ok+12|0;f[Sk>>2]=(f[Sk>>2]|0)+1;nl=f[Gb>>2]|0}if((nl|0)<3){Sk=f[Rb>>2]|0;Ok=f[ec>>2]|0;f[Ok>>2]=f[Sk>>2];f[Ok+4>>2]=f[Sk+4>>2]}else{f[Vb>>2]=0;ZS(Ub,x)}Sk=f[v>>2]|0;Ok=f[Tb>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;if(Ok>>>0>4294967279){Qk=183;break b}if(Ok>>>0<11){b[gc>>0]=Ok;if(!Ok)ol=t;else{pl=t;Qk=187}}else{Rk=Ok+16&-16;Mk=VDc(Rk)|0;f[t>>2]=Mk;f[xc>>2]=Rk|-2147483648;f[yc>>2]=Ok;pl=Mk;Qk=187}if((Qk|0)==187){Qk=0;dJc(pl|0,Sk|0,Ok|0)|0;ol=pl}b[ol+Ok>>0]=0;f[hc>>2]=f[Ub>>2];Ok=f[Vb>>2]|0;f[ic>>2]=Ok;f[jc>>2]=f[Wb>>2];f[kc>>2]=f[Xb>>2];f[lc>>2]=f[Yb>>2];f[mc>>2]=f[Zb>>2];f[nc>>2]=f[_b>>2];f[oc>>2]=f[$b>>2];f[pc>>2]=f[ac>>2];Sk=f[bc>>2]|0;f[qc>>2]=Sk;f[rc>>2]=jc;f[tc>>2]=sc;f[sc>>2]=0;f[uc>>2]=0;if(!Sk)ql=Ok;else{Ok=Sk+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1;ql=f[Vb>>2]|0}if((ql|0)<3){Ok=f[ec>>2]|0;Sk=f[tc>>2]|0;f[Sk>>2]=f[Ok>>2];f[Sk+4>>2]=f[Ok+4>>2]}else{f[ic>>2]=0;ZS(hc,Ub)}Ok=XHa(i,e,t)|0;if(!(f[Ok>>2]|0)){YHa(g,i,t);Sk=f[g>>2]|0;f[g>>2]=0;Mk=f[e>>2]|0;f[Sk>>2]=0;f[Sk+4>>2]=0;f[Sk+8>>2]=Mk;f[Ok>>2]=Sk;Mk=f[f[i>>2]>>2]|0;if(!Mk)rl=Sk;else{f[i>>2]=Mk;rl=f[Ok>>2]|0}laa(f[vc>>2]|0,rl);f[wc>>2]=(f[wc>>2]|0)+1}Ok=f[qc>>2]|0;do if(Ok|0){Mk=Ok+12|0;Sk=f[Mk>>2]|0;f[Mk>>2]=Sk+-1;if((Sk|0)!=1)break;_S(hc)}while(0);f[qc>>2]=0;f[lc>>2]=0;f[lc+4>>2]=0;f[lc+8>>2]=0;f[lc+12>>2]=0;if((f[ic>>2]|0)>0){Ok=f[rc>>2]|0;Sk=0;do{f[Ok+(Sk<<2)>>2]=0;Sk=Sk+1|0}while((Sk|0)<(f[ic>>2]|0))}Sk=f[tc>>2]|0;if((Sk|0)!=(sc|0))g0(Sk);if((b[gc>>0]|0)<0)YDc(f[t>>2]|0);Sk=f[bc>>2]|0;do if(Sk|0){Ok=Sk+12|0;Mk=f[Ok>>2]|0;f[Ok>>2]=Mk+-1;if((Mk|0)!=1)break;_S(Ub)}while(0);f[bc>>2]=0;f[Yb>>2]=0;f[Yb+4>>2]=0;f[Yb+8>>2]=0;f[Yb+12>>2]=0;if((f[Vb>>2]|0)>0){Sk=f[cc>>2]|0;Mk=0;do{f[Sk+(Mk<<2)>>2]=0;Mk=Mk+1|0}while((Mk|0)<(f[Vb>>2]|0))}Mk=f[ec>>2]|0;if((Mk|0)!=(dc|0))g0(Mk);uT(v);Mk=f[Ob>>2]|0;do if(Mk|0){Sk=Mk+12|0;Ok=f[Sk>>2]|0;f[Sk>>2]=Ok+-1;if((Ok|0)!=1)break;_S(x)}while(0);f[Ob>>2]=0;f[Jb>>2]=0;f[Jb+4>>2]=0;f[Jb+8>>2]=0;f[Jb+12>>2]=0;if((f[Gb>>2]|0)>0){Mk=f[Pb>>2]|0;Ok=0;do{f[Mk+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[Gb>>2]|0))}Ok=f[Rb>>2]|0;if((Ok|0)!=(Qb|0))g0(Ok);uT(w);break c}else{kl=el;ll=fl}while(0);do if(((kl<<24>>24<0?ll:kl&255)|0)==11){if(EEc(r,0,-1,382322,11)|0){sl=b[ga>>0]|0;tl=f[ea>>2]|0;break}f[e>>2]=0;f[zc>>2]=0;Ok=tT(e,5)|0;b[Ok>>0]=b[451291]|0;b[Ok+1>>0]=b[451292]|0;b[Ok+2>>0]=b[451293]|0;b[Ok+3>>0]=b[451294]|0;b[Ok+4>>0]=b[451295]|0;Ok=f[aa>>2]|0;d:do if(!Ok)ul=1.0;else{Mk=f[e>>2]|0;Sk=(Mk|0)==0?1154740:Mk;Rk=Ok;while(1){il=f[Rk+16>>2]|0;if((Mk|0)==(il|0))break;jl=(il|0)==0?1154740:il;if((Ioc(Sk,jl)|0)<0)vl=Rk;else{if((Ioc(jl,Sk)|0)>=0)break;vl=Rk+4|0}Rk=f[vl>>2]|0;if(!Rk){ul=1.0;break d}}f[g>>2]=0;f[id>>2]=0;Rk=tT(g,5)|0;b[Rk>>0]=b[451291]|0;b[Rk+1>>0]=b[451292]|0;b[Rk+2>>0]=b[451293]|0;b[Rk+3>>0]=b[451294]|0;b[Rk+4>>0]=b[451295]|0;wl=+tIa(lIa(m,g)|0,-1);uT(g);ul=wl}while(0);uT(e);n[t>>2]=ul;f[v>>2]=0;f[Ac>>2]=0;Ok=tT(v,5)|0;b[Ok>>0]=b[451291]|0;b[Ok+1>>0]=b[451292]|0;b[Ok+2>>0]=b[451293]|0;b[Ok+3>>0]=b[451294]|0;b[Ok+4>>0]=b[451295]|0;Ok=f[aa>>2]|0;do if(Ok|0){Rk=f[v>>2]|0;Sk=(Rk|0)==0?1154740:Rk;Mk=aa;jl=Ok;e:while(1){il=jl;while(1){xl=f[il+16>>2]|0;if((xl|0)==(Rk|0))break;if((Ioc((xl|0)==0?1154740:xl,Sk)|0)>=0)break;xl=f[il+4>>2]|0;if(!xl){yl=Mk;break e}else il=xl}jl=f[il>>2]|0;if(!jl){yl=il;break}else Mk=il}if((yl|0)==(aa|0))break;Mk=f[yl+16>>2]|0;if((Rk|0)!=(Mk|0)?(Ioc(Sk,(Mk|0)==0?1154740:Mk)|0)<0:0)break;f[g>>2]=yl;f[e>>2]=f[g>>2];uIa(m,e)|0}while(0);uT(v);f[e>>2]=0;f[Bc>>2]=0;Ok=tT(e,4)|0;b[Ok>>0]=98;b[Ok+1>>0]=105;b[Ok+2>>0]=97;b[Ok+3>>0]=115;Ok=f[aa>>2]|0;do if(Ok){Mk=f[e>>2]|0;jl=(Mk|0)==0?1154740:Mk;xl=Ok;while(1){zl=f[xl+16>>2]|0;if((Mk|0)==(zl|0)){Qk=255;break}Al=(zl|0)==0?1154740:zl;if((Ioc(jl,Al)|0)<0)Bl=xl;else{if((Ioc(Al,jl)|0)>=0){Qk=256;break}Bl=xl+4|0}xl=f[Bl>>2]|0;if(!xl){Qk=319;break}}if((Qk|0)==255){Qk=0;uT(e)}else if((Qk|0)==256){Qk=0;uT(e)}else if((Qk|0)==319){Qk=0;uT(e);Qk=320;break}uT(U);xl=tT(U,5)|0;b[xl>>0]=b[435704]|0;b[xl+1>>0]=b[435705]|0;b[xl+2>>0]=b[435706]|0;b[xl+3>>0]=b[435707]|0;b[xl+4>>0]=b[435708]|0;f[v>>2]=0;f[Cc>>2]=0;xl=tT(v,4)|0;b[xl>>0]=98;b[xl+1>>0]=105;b[xl+2>>0]=97;b[xl+3>>0]=115;xl=lIa(m,v)|0;switch(f[xl>>2]|0){case 0:{Cl=(f[xl+4>>2]|0)+4|0;break}case 3:{Cl=(f[xl+4>>2]|0)+4|0;break}case 2:{Cl=(f[xl+4>>2]|0)+4|0;break}default:{Qk=261;break b}}xl=f[Cl>>2]|0;p[y>>3]=+n[t>>2];f[Dc>>2]=0;f[Dc+4>>2]=0;f[Dc+8>>2]=0;f[Dc+12>>2]=0;f[Dc+16>>2]=0;f[Dc+20>>2]=0;f[g>>2]=1124007936;M=Ec;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[Gc>>2]=Fc;f[Ic>>2]=Hc;f[Hc>>2]=0;f[Jc>>2]=0;f[e>>2]=xl;f[Kc>>2]=1;XS(g,2,e,5);k_(g,y)|0;jl=f[Za>>2]|0;if((jl|0)==(f[_a>>2]|0))Bxa($,g);else{f[jl>>2]=f[g>>2];Mk=jl+4|0;f[Mk>>2]=f[Ec>>2];Sk=jl+8|0;f[Sk>>2]=f[Fc>>2];f[jl+12>>2]=f[cd>>2];f[jl+16>>2]=f[Mc>>2];f[jl+20>>2]=f[dd>>2];f[jl+24>>2]=f[ed>>2];f[jl+28>>2]=f[fd>>2];f[jl+32>>2]=f[gd>>2];Rk=f[Lc>>2]|0;f[jl+36>>2]=Rk;f[jl+40>>2]=Sk;Sk=jl+48|0;Al=jl+44|0;f[Al>>2]=Sk;f[Sk>>2]=0;f[jl+52>>2]=0;if(Rk|0){Sk=Rk+12|0;f[Sk>>2]=(f[Sk>>2]|0)+1}if((f[Ec>>2]|0)<3){Sk=f[Ic>>2]|0;Rk=f[Al>>2]|0;f[Rk>>2]=f[Sk>>2];f[Rk+4>>2]=f[Sk+4>>2]}else{f[Mk>>2]=0;ZS(jl,g)}f[Za>>2]=(f[Za>>2]|0)+56}jl=f[Lc>>2]|0;do if(jl|0){Mk=jl+12|0;Sk=f[Mk>>2]|0;f[Mk>>2]=Sk+-1;if((Sk|0)!=1)break;_S(g)}while(0);f[Lc>>2]=0;f[Mc>>2]=0;f[Mc+4>>2]=0;f[Mc+8>>2]=0;f[Mc+12>>2]=0;if((f[Ec>>2]|0)>0){jl=f[Gc>>2]|0;xl=0;do{f[jl+(xl<<2)>>2]=0;xl=xl+1|0}while((xl|0)<(f[Ec>>2]|0))}xl=f[Ic>>2]|0;if((xl|0)!=(Hc|0))g0(xl);uT(v);f[e>>2]=0;f[Nc>>2]=0;M=tT(e,9)|0;N=454939;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[g>>0]=1;rIa(m,e,g)|0;uT(e);f[g>>2]=0;f[Oc>>2]=0;xl=tT(g,4)|0;b[xl>>0]=98;b[xl+1>>0]=105;b[xl+2>>0]=97;b[xl+3>>0]=115;xl=lIa(m,g)|0;switch(f[xl>>2]|0){case 0:{Dl=(f[xl+4>>2]|0)+4|0;break}case 3:{Dl=(f[xl+4>>2]|0)+4|0;break}case 2:{Dl=(f[xl+4>>2]|0)+4|0;break}default:{Qk=282;break b}}xl=f[Dl>>2]|0;f[v>>2]=1124007936;M=Pc;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[Rc>>2]=Qc;f[Tc>>2]=Sc;f[Sc>>2]=0;f[Uc>>2]=0;f[e>>2]=1;f[Kc>>2]=xl;XS(v,2,e,5);uT(g);jl=0;while(1){El=f[Pc>>2]|0;if((El|0)<3)Fl=Y(f[Vc>>2]|0,f[Qc>>2]|0)|0;else{Sk=f[Rc>>2]|0;Mk=0;Rk=1;while(1){Al=Y(f[Sk+(Mk<<2)>>2]|0,Rk)|0;Mk=Mk+1|0;if((Mk|0)==(El|0)){Fl=Al;break}else Rk=Al}}if(jl>>>0>=Fl>>>0)break;f[e>>2]=0;f[Wc>>2]=0;Rk=tT(e,4)|0;b[Rk>>0]=98;b[Rk+1>>0]=105;b[Rk+2>>0]=97;b[Rk+3>>0]=115;wl=+tIa(lIa(m,e)|0,jl);n[(f[Xc>>2]|0)+(jl<<2)>>2]=wl;uT(e);jl=jl+1|0}jl=f[Za>>2]|0;if((jl|0)==(f[_a>>2]|0))Bxa($,v);else{f[jl>>2]=f[v>>2];xl=jl+4|0;f[xl>>2]=El;Rk=jl+8|0;f[Rk>>2]=f[Qc>>2];f[jl+12>>2]=f[Vc>>2];f[jl+16>>2]=f[Xc>>2];f[jl+20>>2]=f[_c>>2];f[jl+24>>2]=f[$c>>2];f[jl+28>>2]=f[ad>>2];f[jl+32>>2]=f[bd>>2];Mk=f[Zc>>2]|0;f[jl+36>>2]=Mk;f[jl+40>>2]=Rk;Rk=jl+48|0;Sk=jl+44|0;f[Sk>>2]=Rk;f[Rk>>2]=0;f[jl+52>>2]=0;if(Mk|0){Rk=Mk+12|0;f[Rk>>2]=(f[Rk>>2]|0)+1}if((f[Pc>>2]|0)<3){Rk=f[Tc>>2]|0;Mk=f[Sk>>2]|0;f[Mk>>2]=f[Rk>>2];f[Mk+4>>2]=f[Rk+4>>2]}else{f[xl>>2]=0;ZS(jl,v)}f[Za>>2]=(f[Za>>2]|0)+56}f[y>>2]=0;f[Yc>>2]=0;jl=tT(y,4)|0;b[jl>>0]=98;b[jl+1>>0]=105;b[jl+2>>0]=97;b[jl+3>>0]=115;jl=f[aa>>2]|0;do if(jl|0){xl=f[y>>2]|0;Rk=(xl|0)==0?1154740:xl;Mk=aa;Sk=jl;f:while(1){il=Sk;while(1){Al=f[il+16>>2]|0;if((Al|0)==(xl|0))break;if((Ioc((Al|0)==0?1154740:Al,Rk)|0)>=0)break;Al=f[il+4>>2]|0;if(!Al){Gl=Mk;break f}else il=Al}Sk=f[il>>2]|0;if(!Sk){Gl=il;break}else Mk=il}if((Gl|0)==(aa|0))break;Mk=f[Gl+16>>2]|0;if((xl|0)!=(Mk|0)?(Ioc(Rk,(Mk|0)==0?1154740:Mk)|0)<0:0)break;f[g>>2]=Gl;f[e>>2]=f[g>>2];uIa(m,e)|0}while(0);uT(y);jl=f[Zc>>2]|0;do if(jl|0){Mk=jl+12|0;Sk=f[Mk>>2]|0;f[Mk>>2]=Sk+-1;if((Sk|0)!=1)break;_S(v)}while(0);f[Zc>>2]=0;f[Xc>>2]=0;f[Xc+4>>2]=0;f[Xc+8>>2]=0;f[Xc+12>>2]=0;if((f[Pc>>2]|0)>0){jl=f[Rc>>2]|0;Sk=0;do{f[jl+(Sk<<2)>>2]=0;Sk=Sk+1|0}while((Sk|0)<(f[Pc>>2]|0))}Sk=f[Tc>>2]|0;if((Sk|0)!=(Sc|0))g0(Sk)}else{uT(e);Qk=320}while(0);if((Qk|0)==320){Qk=0;f[e>>2]=0;f[hd>>2]=0;Ok=tT(e,5)|0;b[Ok>>0]=b[451291]|0;b[Ok+1>>0]=b[451292]|0;b[Ok+2>>0]=b[451293]|0;b[Ok+3>>0]=b[451294]|0;b[Ok+4>>0]=b[451295]|0;eIa(m,e,t)|0;uT(e);uT(U);Ok=tT(U,5)|0;b[Ok>>0]=b[451285]|0;b[Ok+1>>0]=b[451286]|0;b[Ok+2>>0]=b[451287]|0;b[Ok+3>>0]=b[451288]|0;b[Ok+4>>0]=b[451289]|0}Qk=927;break c}else{sl=kl;tl=ll}while(0);do if(((sl<<24>>24<0?tl:sl&255)|0)==9)if(!(EEc(r,0,-1,382334,9)|0)){uT(U);Ok=tT(U,4)|0;b[Ok>>0]=82;b[Ok+1>>0]=101;b[Ok+2>>0]=76;b[Ok+3>>0]=85;f[e>>2]=0;f[jd>>2]=0;Ok=tT(e,5)|0;b[Ok>>0]=b[434804]|0;b[Ok+1>>0]=b[434805]|0;b[Ok+2>>0]=b[434806]|0;b[Ok+3>>0]=b[434807]|0;b[Ok+4>>0]=b[434808]|0;f[g>>2]=0;f[kd>>2]=0;M=tT(g,14)|0;N=454995;O=M+14|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));vIa(m,e,g);uT(g);uT(e);Qk=927;break c}else{Hl=b[ga>>0]|0;Il=f[ea>>2]|0;break}else{Hl=sl;Il=tl}while(0);do if(((Hl<<24>>24<0?Il:Hl&255)|0)==3)if(!(EEc(r,0,-1,425608,3)|0)){f[e>>2]=0;f[ld>>2]=0;Ok=tT(e,4)|0;b[Ok>>0]=115;b[Ok+1>>0]=105;b[Ok+2>>0]=122;b[Ok+3>>0]=101;f[g>>2]=0;f[md>>2]=0;M=tT(g,10)|0;N=434734;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));vIa(m,e,g);uT(g);uT(e);Qk=927;break c}else{Jl=b[ga>>0]|0;Kl=f[ea>>2]|0;break}else{Jl=Hl;Kl=Il}while(0);do if(((Jl<<24>>24<0?Kl:Jl&255)|0)==18){if(EEc(r,0,-1,387217,18)|0){Ll=b[ga>>0]|0;Ml=f[ea>>2]|0;break}if((f[pa>>2]|0)!=5){Qk=334;break b}uT(U);M=tT(U,9)|0;N=454964;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));f[e>>2]=0;f[nd>>2]=0;Ok=tT(e,7)|0;b[Ok>>0]=b[428696]|0;b[Ok+1>>0]=b[428697]|0;b[Ok+2>>0]=b[428698]|0;b[Ok+3>>0]=b[428699]|0;b[Ok+4>>0]=b[428700]|0;b[Ok+5>>0]=b[428701]|0;b[Ok+6>>0]=b[428702]|0;f[g>>2]=0;f[od>>2]=0;Ok=tT(g,3)|0;b[Ok>>0]=b[454985]|0;b[Ok+1>>0]=b[454986]|0;b[Ok+2>>0]=b[454987]|0;vIa(m,e,g);uT(g);uT(e);f[e>>2]=0;f[pd>>2]=0;Ok=tT(e,7)|0;b[Ok>>0]=b[382386]|0;b[Ok+1>>0]=b[382387]|0;b[Ok+2>>0]=b[382388]|0;b[Ok+3>>0]=b[382389]|0;b[Ok+4>>0]=b[382390]|0;b[Ok+5>>0]=b[382391]|0;b[Ok+6>>0]=b[382392]|0;f[g>>2]=0;f[qd>>2]=0;M=tT(g,16)|0;N=449544;O=M+16|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));vIa(m,e,g);uT(g);uT(e);hIa(e,0,q,i,3);hIa(g,0,q,i,4);Ok=f[Za>>2]|0;if((Ok|0)==(f[_a>>2]|0)){Bxa($,e);Nl=f[Za>>2]|0}else{f[Ok>>2]=f[e>>2];Sk=Ok+4|0;f[Sk>>2]=f[Bd>>2];jl=Ok+8|0;f[jl>>2]=f[je>>2];f[Ok+12>>2]=f[ke>>2];f[Ok+16>>2]=f[Ad>>2];f[Ok+20>>2]=f[le>>2];f[Ok+24>>2]=f[me>>2];f[Ok+28>>2]=f[ne>>2];f[Ok+32>>2]=f[oe>>2];Mk=f[zd>>2]|0;f[Ok+36>>2]=Mk;f[Ok+40>>2]=jl;jl=Ok+48|0;Al=Ok+44|0;f[Al>>2]=jl;f[jl>>2]=0;f[Ok+52>>2]=0;if(Mk|0){jl=Mk+12|0;f[jl>>2]=(f[jl>>2]|0)+1}if((f[Bd>>2]|0)<3){jl=f[Dd>>2]|0;Mk=f[Al>>2]|0;f[Mk>>2]=f[jl>>2];f[Mk+4>>2]=f[jl+4>>2]}else{f[Sk>>2]=0;ZS(Ok,e)}Ok=(f[Za>>2]|0)+56|0;f[Za>>2]=Ok;Nl=Ok}if((Nl|0)==(f[_a>>2]|0))Bxa($,g);else{f[Nl>>2]=f[g>>2];Ok=Nl+4|0;f[Ok>>2]=f[vd>>2];Sk=Nl+8|0;f[Sk>>2]=f[de>>2];f[Nl+12>>2]=f[ee>>2];f[Nl+16>>2]=f[ud>>2];f[Nl+20>>2]=f[fe>>2];f[Nl+24>>2]=f[ge>>2];f[Nl+28>>2]=f[he>>2];f[Nl+32>>2]=f[ie>>2];jl=f[td>>2]|0;f[Nl+36>>2]=jl;f[Nl+40>>2]=Sk;Sk=Nl+48|0;Mk=Nl+44|0;f[Mk>>2]=Sk;f[Sk>>2]=0;f[Nl+52>>2]=0;if(jl|0){Sk=jl+12|0;f[Sk>>2]=(f[Sk>>2]|0)+1}if((f[vd>>2]|0)<3){Sk=f[xd>>2]|0;jl=f[Mk>>2]|0;f[jl>>2]=f[Sk>>2];f[jl+4>>2]=f[Sk+4>>2]}else{f[Ok>>2]=0;ZS(Nl,g)}f[Za>>2]=(f[Za>>2]|0)+56}Ok=f[(f[qa>>2]|0)+8>>2]|0;Sk=b[Ok+11>>0]|0;if(Sk<<24>>24<0)Ol=f[Ok+4>>2]|0;else Ol=Sk&255;if(Ol){f[t>>2]=0;f[Sd>>2]=0;M=tT(t,10)|0;N=454974;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[v>>0]=1;rIa(m,t,v)|0;uT(t);hIa(t,0,q,i,1);Sk=f[Za>>2]|0;if((Sk|0)==(f[_a>>2]|0))Bxa($,t);else{f[Sk>>2]=f[t>>2];Ok=Sk+4|0;f[Ok>>2]=f[Vd>>2];jl=Sk+8|0;f[jl>>2]=f[Zd>>2];f[Sk+12>>2]=f[_d>>2];f[Sk+16>>2]=f[Ud>>2];f[Sk+20>>2]=f[$d>>2];f[Sk+24>>2]=f[ae>>2];f[Sk+28>>2]=f[be>>2];f[Sk+32>>2]=f[ce>>2];Mk=f[Td>>2]|0;f[Sk+36>>2]=Mk;f[Sk+40>>2]=jl;jl=Sk+48|0;Al=Sk+44|0;f[Al>>2]=jl;f[jl>>2]=0;f[Sk+52>>2]=0;if(Mk|0){jl=Mk+12|0;f[jl>>2]=(f[jl>>2]|0)+1}if((f[Vd>>2]|0)<3){jl=f[Xd>>2]|0;Mk=f[Al>>2]|0;f[Mk>>2]=f[jl>>2];f[Mk+4>>2]=f[jl+4>>2]}else{f[Ok>>2]=0;ZS(Sk,t)}f[Za>>2]=(f[Za>>2]|0)+56}Sk=f[Td>>2]|0;do if(Sk|0){Ok=Sk+12|0;jl=f[Ok>>2]|0;f[Ok>>2]=jl+-1;if((jl|0)!=1)break;_S(t)}while(0);f[Td>>2]=0;f[Ud>>2]=0;f[Ud+4>>2]=0;f[Ud+8>>2]=0;f[Ud+12>>2]=0;if((f[Vd>>2]|0)>0){Sk=f[Wd>>2]|0;jl=0;do{f[Sk+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Vd>>2]|0))}jl=f[Xd>>2]|0;if((jl|0)!=(Yd|0))g0(jl)}else{f[t>>2]=0;f[rd>>2]=0;M=tT(t,10)|0;N=454974;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[v>>0]=0;rIa(m,t,v)|0;uT(t)}jl=f[(f[qa>>2]|0)+12>>2]|0;Sk=b[jl+11>>0]|0;if(Sk<<24>>24<0)Pl=f[jl+4>>2]|0;else Pl=Sk&255;if(Pl){f[t>>2]=0;f[Fd>>2]=0;Sk=tT(t,8)|0;jl=Sk;b[jl>>0]=104;b[jl+1>>0]=97;b[jl+2>>0]=115;b[jl+3>>0]=95;jl=Sk+4|0;b[jl>>0]=98;b[jl+1>>0]=105;b[jl+2>>0]=97;b[jl+3>>0]=115;b[v>>0]=1;rIa(m,t,v)|0;uT(t);hIa(t,0,q,i,2);jl=f[Za>>2]|0;if((jl|0)==(f[_a>>2]|0))Bxa($,t);else{f[jl>>2]=f[t>>2];Sk=jl+4|0;f[Sk>>2]=f[Id>>2];Ok=jl+8|0;f[Ok>>2]=f[Md>>2];f[jl+12>>2]=f[Nd>>2];f[jl+16>>2]=f[Hd>>2];f[jl+20>>2]=f[Od>>2];f[jl+24>>2]=f[Pd>>2];f[jl+28>>2]=f[Qd>>2];f[jl+32>>2]=f[Rd>>2];Mk=f[Gd>>2]|0;f[jl+36>>2]=Mk;f[jl+40>>2]=Ok;Ok=jl+48|0;Al=jl+44|0;f[Al>>2]=Ok;f[Ok>>2]=0;f[jl+52>>2]=0;if(Mk|0){Ok=Mk+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1}if((f[Id>>2]|0)<3){Ok=f[Kd>>2]|0;Mk=f[Al>>2]|0;f[Mk>>2]=f[Ok>>2];f[Mk+4>>2]=f[Ok+4>>2]}else{f[Sk>>2]=0;ZS(jl,t)}f[Za>>2]=(f[Za>>2]|0)+56}jl=f[Gd>>2]|0;do if(jl|0){Sk=jl+12|0;Ok=f[Sk>>2]|0;f[Sk>>2]=Ok+-1;if((Ok|0)!=1)break;_S(t)}while(0);f[Gd>>2]=0;f[Hd>>2]=0;f[Hd+4>>2]=0;f[Hd+8>>2]=0;f[Hd+12>>2]=0;if((f[Id>>2]|0)>0){jl=f[Jd>>2]|0;Ok=0;do{f[jl+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[Id>>2]|0))}Ok=f[Kd>>2]|0;if((Ok|0)!=(Ld|0))g0(Ok)}else{f[t>>2]=0;f[sd>>2]=0;Ok=tT(t,8)|0;jl=Ok;b[jl>>0]=104;b[jl+1>>0]=97;b[jl+2>>0]=115;b[jl+3>>0]=95;jl=Ok+4|0;b[jl>>0]=98;b[jl+1>>0]=105;b[jl+2>>0]=97;b[jl+3>>0]=115;b[v>>0]=0;rIa(m,t,v)|0;uT(t)}jl=f[td>>2]|0;do if(jl|0){Ok=jl+12|0;Sk=f[Ok>>2]|0;f[Ok>>2]=Sk+-1;if((Sk|0)!=1)break;_S(g)}while(0);f[td>>2]=0;f[ud>>2]=0;f[ud+4>>2]=0;f[ud+8>>2]=0;f[ud+12>>2]=0;if((f[vd>>2]|0)>0){jl=f[wd>>2]|0;Sk=0;do{f[jl+(Sk<<2)>>2]=0;Sk=Sk+1|0}while((Sk|0)<(f[vd>>2]|0))}Sk=f[xd>>2]|0;if((Sk|0)!=(yd|0))g0(Sk);Sk=f[zd>>2]|0;do if(Sk|0){jl=Sk+12|0;Ok=f[jl>>2]|0;f[jl>>2]=Ok+-1;if((Ok|0)!=1)break;_S(e)}while(0);f[zd>>2]=0;f[Ad>>2]=0;f[Ad+4>>2]=0;f[Ad+8>>2]=0;f[Ad+12>>2]=0;if((f[Bd>>2]|0)>0){Sk=f[Cd>>2]|0;Ok=0;do{f[Sk+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[Bd>>2]|0))}Ok=f[Dd>>2]|0;if((Ok|0)!=(Ed|0))g0(Ok);Qk=927;break c}else{Ll=Jl;Ml=Kl}while(0);do if(((Ll<<24>>24<0?Ml:Ll&255)|0)==4){if(EEc(r,0,-1,382394,4)|0){Ql=b[ga>>0]|0;Rl=f[ea>>2]|0;break}if((f[pa>>2]|0)<=1){Qk=416;break b}uT(U);M=tT(U,12)|0;N=425612;O=M+12|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));hIa(e,0,q,i,1);f[g>>2]=0;f[pe>>2]=0;Ok=tT(g,6)|0;b[Ok>>0]=b[382428]|0;b[Ok+1>>0]=b[382429]|0;b[Ok+2>>0]=b[382430]|0;b[Ok+3>>0]=b[382431]|0;b[Ok+4>>0]=b[382432]|0;b[Ok+5>>0]=b[382433]|0;Ok=f[aa>>2]|0;do if(!Ok){uT(g);Sl=0}else{Sk=f[g>>2]|0;jl=(Sk|0)==0?1154740:Sk;Mk=Ok;while(1){Al=f[Mk+16>>2]|0;if((Sk|0)==(Al|0))break;zl=(Al|0)==0?1154740:Al;if((Ioc(jl,zl)|0)<0)Tl=Mk;else{if((Ioc(zl,jl)|0)>=0)break;Tl=Mk+4|0}Mk=f[Tl>>2]|0;if(!Mk){Qk=428;break}}if((Qk|0)==428){Qk=0;uT(g);Sl=0;break}f[t>>2]=0;f[Ve>>2]=0;Mk=tT(t,6)|0;b[Mk>>0]=b[382428]|0;b[Mk+1>>0]=b[382429]|0;b[Mk+2>>0]=b[382430]|0;b[Mk+3>>0]=b[382431]|0;b[Mk+4>>0]=b[382432]|0;b[Mk+5>>0]=b[382433]|0;Mk=DHa(lIa(m,t)|0,-1)|0;uT(t);uT(g);if(Mk|0){Sl=0;break}f[qe>>2]=0;f[re>>2]=0;f[g>>2]=16842752;f[se>>2]=e;Mk=te;f[Mk>>2]=0;f[Mk+4>>2]=0;f[t>>2]=33619968;f[ue>>2]=e;jR(g,t);Sl=1}while(0);Ok=f[Za>>2]|0;if((Ok|0)==(f[_a>>2]|0))Bxa($,e);else{f[Ok>>2]=f[e>>2];Mk=Ok+4|0;f[Mk>>2]=f[Le>>2];jl=Ok+8|0;f[jl>>2]=f[Pe>>2];f[Ok+12>>2]=f[Qe>>2];f[Ok+16>>2]=f[Ke>>2];f[Ok+20>>2]=f[Re>>2];f[Ok+24>>2]=f[Se>>2];f[Ok+28>>2]=f[Te>>2];f[Ok+32>>2]=f[Ue>>2];Sk=f[Je>>2]|0;f[Ok+36>>2]=Sk;f[Ok+40>>2]=jl;jl=Ok+48|0;zl=Ok+44|0;f[zl>>2]=jl;f[jl>>2]=0;f[Ok+52>>2]=0;if(Sk|0){jl=Sk+12|0;f[jl>>2]=(f[jl>>2]|0)+1}if((f[Le>>2]|0)<3){jl=f[Ne>>2]|0;Sk=f[zl>>2]|0;f[Sk>>2]=f[jl>>2];f[Sk+4>>2]=f[jl+4>>2]}else{f[Mk>>2]=0;ZS(Ok,e)}f[Za>>2]=(f[Za>>2]|0)+56}if((f[pa>>2]|0)==3){hIa(g,0,q,i,2);Ok=f[Za>>2]|0;if((Ok|0)==(f[_a>>2]|0))Bxa($,g);else{f[Ok>>2]=f[g>>2];Mk=Ok+4|0;f[Mk>>2]=f[xe>>2];jl=Ok+8|0;f[jl>>2]=f[Be>>2];f[Ok+12>>2]=f[Ce>>2];f[Ok+16>>2]=f[we>>2];f[Ok+20>>2]=f[De>>2];f[Ok+24>>2]=f[Ee>>2];f[Ok+28>>2]=f[Fe>>2];f[Ok+32>>2]=f[Ge>>2];Sk=f[ve>>2]|0;f[Ok+36>>2]=Sk;f[Ok+40>>2]=jl;jl=Ok+48|0;zl=Ok+44|0;f[zl>>2]=jl;f[jl>>2]=0;f[Ok+52>>2]=0;if(Sk|0){jl=Sk+12|0;f[jl>>2]=(f[jl>>2]|0)+1}if((f[xe>>2]|0)<3){jl=f[ze>>2]|0;Sk=f[zl>>2]|0;f[Sk>>2]=f[jl>>2];f[Sk+4>>2]=f[jl+4>>2]}else{f[Mk>>2]=0;ZS(Ok,g)}f[Za>>2]=(f[Za>>2]|0)+56}Ok=f[ve>>2]|0;do if(Ok|0){Mk=Ok+12|0;jl=f[Mk>>2]|0;f[Mk>>2]=jl+-1;if((jl|0)!=1)break;_S(g)}while(0);f[ve>>2]=0;f[we>>2]=0;f[we+4>>2]=0;f[we+8>>2]=0;f[we+12>>2]=0;if((f[xe>>2]|0)>0){Ok=f[ye>>2]|0;jl=0;do{f[Ok+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[xe>>2]|0))}jl=f[ze>>2]|0;if((jl|0)!=(Ae|0))g0(jl)}f[g>>2]=0;f[He>>2]=0;M=tT(g,10)|0;N=455057;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));$Ha(m,g,(f[(f[$>>2]|0)+40>>2]|0)+(Sl<<2)|0)|0;uT(g);f[g>>2]=0;f[Ie>>2]=0;M=tT(g,9)|0;N=454939;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[t>>0]=(f[pa>>2]|0)==3&1;rIa(m,g,t)|0;uT(g);jl=f[Je>>2]|0;do if(jl|0){Ok=jl+12|0;Mk=f[Ok>>2]|0;f[Ok>>2]=Mk+-1;if((Mk|0)!=1)break;_S(e)}while(0);f[Je>>2]=0;f[Ke>>2]=0;f[Ke+4>>2]=0;f[Ke+8>>2]=0;f[Ke+12>>2]=0;if((f[Le>>2]|0)>0){jl=f[Me>>2]|0;Mk=0;do{f[jl+(Mk<<2)>>2]=0;Mk=Mk+1|0}while((Mk|0)<(f[Le>>2]|0))}Mk=f[Ne>>2]|0;if((Mk|0)!=(Oe|0))g0(Mk);Qk=927;break c}else{Ql=Ll;Rl=Ml}while(0);do if(((Ql<<24>>24<0?Rl:Ql&255)|0)==6){if(EEc(r,0,-1,383469,6)|0){Ul=b[ga>>0]|0;Vl=f[ea>>2]|0;break}if((f[pa>>2]|0)!=2){Qk=468;break b}uT(U);M=tT(U,12)|0;N=425612;O=M+12|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));hIa(e,0,q,i,1);xY(z,e);f[g>>2]=1124007936;M=We;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[Ye>>2]=Xe;f[_e>>2]=Ze;f[Ze>>2]=0;f[$e>>2]=0;Mk=f[z>>2]|0;ei[f[(f[Mk>>2]|0)+12>>2]&511](Mk,z,g,-1);Mk=f[Za>>2]|0;if((Mk|0)==(f[_a>>2]|0))Bxa($,g);else{f[Mk>>2]=f[g>>2];jl=Mk+4|0;f[jl>>2]=f[We>>2];Ok=Mk+8|0;f[Ok>>2]=f[Xe>>2];f[Mk+12>>2]=f[lf>>2];f[Mk+16>>2]=f[bf>>2];f[Mk+20>>2]=f[mf>>2];f[Mk+24>>2]=f[nf>>2];f[Mk+28>>2]=f[of>>2];f[Mk+32>>2]=f[pf>>2];Sk=f[af>>2]|0;f[Mk+36>>2]=Sk;f[Mk+40>>2]=Ok;Ok=Mk+48|0;zl=Mk+44|0;f[zl>>2]=Ok;f[Ok>>2]=0;f[Mk+52>>2]=0;if(Sk|0){Ok=Sk+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1}if((f[We>>2]|0)<3){Ok=f[_e>>2]|0;Sk=f[zl>>2]|0;f[Sk>>2]=f[Ok>>2];f[Sk+4>>2]=f[Ok+4>>2]}else{f[jl>>2]=0;ZS(Mk,g)}f[Za>>2]=(f[Za>>2]|0)+56}Mk=f[af>>2]|0;do if(Mk|0){jl=Mk+12|0;Ok=f[jl>>2]|0;f[jl>>2]=Ok+-1;if((Ok|0)!=1)break;_S(g)}while(0);f[af>>2]=0;f[bf>>2]=0;f[bf+4>>2]=0;f[bf+8>>2]=0;f[bf+12>>2]=0;if((f[We>>2]|0)>0){Mk=f[Ye>>2]|0;Ok=0;do{f[Mk+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[We>>2]|0))}Ok=f[_e>>2]|0;if((Ok|0)!=(Ze|0))g0(Ok);$j(z);f[g>>2]=0;f[cf>>2]=0;M=tT(g,9)|0;N=454939;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[t>>0]=0;rIa(m,g,t)|0;uT(g);f[g>>2]=0;f[df>>2]=0;M=tT(g,10)|0;N=455057;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));$Ha(m,g,f[(f[$>>2]|0)+40>>2]|0)|0;uT(g);Ok=f[ef>>2]|0;do if(Ok|0){Mk=Ok+12|0;jl=f[Mk>>2]|0;f[Mk>>2]=jl+-1;if((jl|0)!=1)break;_S(e)}while(0);f[ef>>2]=0;f[ff>>2]=0;f[ff+4>>2]=0;f[ff+8>>2]=0;f[ff+12>>2]=0;if((f[gf>>2]|0)>0){Ok=f[hf>>2]|0;jl=0;do{f[Ok+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[gf>>2]|0))}jl=f[jf>>2]|0;if((jl|0)!=(kf|0))g0(jl);Qk=927;break c}else{Ul=Ql;Vl=Rl}while(0);do if(((Ul<<24>>24<0?Vl:Ul&255)|0)==3){if(EEc(r,0,-1,426428,3)|0){Wl=b[ga>>0]|0;Xl=f[ea>>2]|0;break}if((f[pa>>2]|0)!=2){Qk=498;break b}if((sIa(k,f[(f[qa>>2]|0)+8>>2]|0)|0)!=(P|0)){uT(U);jl=tT(U,7)|0;b[jl>>0]=b[454641]|0;b[jl+1>>0]=b[454642]|0;b[jl+2>>0]=b[454643]|0;b[jl+3>>0]=b[454644]|0;b[jl+4>>0]=b[454645]|0;b[jl+5>>0]=b[454646]|0;b[jl+6>>0]=b[454647]|0;f[e>>2]=0;f[Pf>>2]=0;M=tT(e,9)|0;N=445470;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));cIa(m,e,445480)|0;uT(e);Qk=927;break c}hIa(e,0,q,i,1);lT(g,e,1,1);jl=f[qf>>2]|0;if(jl|0){Ok=jl+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1}Ok=f[rf>>2]|0;do if(Ok|0){jl=Ok+12|0;Mk=f[jl>>2]|0;f[jl>>2]=Mk+-1;if((Mk|0)!=1)break;_S(e)}while(0);f[rf>>2]=0;f[sf>>2]=0;f[sf+4>>2]=0;f[sf+8>>2]=0;f[sf+12>>2]=0;if((f[tf>>2]|0)>0){Ok=f[uf>>2]|0;Mk=0;do{f[Ok+(Mk<<2)>>2]=0;Mk=Mk+1|0;Yl=f[tf>>2]|0}while((Mk|0)<(Yl|0));f[e>>2]=f[g>>2];if((Yl|0)<3)Qk=510;else Qk=512}else{f[e>>2]=f[g>>2];Qk=510}do if((Qk|0)==510){Qk=0;Mk=f[vf>>2]|0;if((Mk|0)>=3){Qk=512;break}f[tf>>2]=Mk;f[xf>>2]=f[wf>>2];f[zf>>2]=f[yf>>2];Mk=f[Af>>2]|0;Ok=f[Bf>>2]|0;f[Ok>>2]=f[Mk>>2];f[Ok+4>>2]=f[Mk+4>>2]}while(0);if((Qk|0)==512){Qk=0;ZS(e,g)}f[sf>>2]=f[Cf>>2];f[Ef>>2]=f[Df>>2];f[Gf>>2]=f[Ff>>2];f[If>>2]=f[Hf>>2];f[Kf>>2]=f[Jf>>2];Mk=f[qf>>2]|0;f[rf>>2]=Mk;do if(Mk|0){Ok=Mk+12|0;jl=f[Ok>>2]|0;f[Ok>>2]=jl+-1;if((jl|0)!=1)break;_S(g)}while(0);f[qf>>2]=0;f[Cf>>2]=0;f[Cf+4>>2]=0;f[Cf+8>>2]=0;f[Cf+12>>2]=0;if((f[vf>>2]|0)>0){Mk=f[Lf>>2]|0;jl=0;do{f[Mk+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[vf>>2]|0))}jl=f[Af>>2]|0;if((jl|0)!=(Mf|0))g0(jl);jl=f[tf>>2]|0;if((jl|0)<3)Zl=Y(f[zf>>2]|0,f[xf>>2]|0)|0;else{Mk=f[uf>>2]|0;Ok=0;Sk=1;while(1){zl=Y(f[Mk+(Ok<<2)>>2]|0,Sk)|0;Ok=Ok+1|0;if((Ok|0)==(jl|0)){Zl=zl;break}else Sk=zl}}if((Zl|0)==1){f[g>>2]=0;f[Nf>>2]=0;Sk=tT(g,5)|0;b[Sk>>0]=b[451291]|0;b[Sk+1>>0]=b[451292]|0;b[Sk+2>>0]=b[451293]|0;b[Sk+3>>0]=b[451294]|0;b[Sk+4>>0]=b[451295]|0;eIa(m,g,f[sf>>2]|0)|0;uT(g);uT(U);Sk=tT(U,5)|0;b[Sk>>0]=b[451285]|0;b[Sk+1>>0]=b[451286]|0;b[Sk+2>>0]=b[451287]|0;b[Sk+3>>0]=b[451288]|0;b[Sk+4>>0]=b[451289]|0}else{Sk=f[Za>>2]|0;if((Sk|0)==(f[_a>>2]|0))Bxa($,e);else{f[Sk>>2]=f[e>>2];Ok=Sk+4|0;f[Ok>>2]=jl;Mk=Sk+8|0;f[Mk>>2]=f[xf>>2];f[Sk+12>>2]=f[zf>>2];f[Sk+16>>2]=f[sf>>2];f[Sk+20>>2]=f[Ef>>2];f[Sk+24>>2]=f[Gf>>2];f[Sk+28>>2]=f[If>>2];f[Sk+32>>2]=f[Kf>>2];zl=f[rf>>2]|0;f[Sk+36>>2]=zl;f[Sk+40>>2]=Mk;Mk=Sk+48|0;Al=Sk+44|0;f[Al>>2]=Mk;f[Mk>>2]=0;f[Sk+52>>2]=0;if(zl|0){Mk=zl+12|0;f[Mk>>2]=(f[Mk>>2]|0)+1}if((f[tf>>2]|0)<3){Mk=f[Bf>>2]|0;zl=f[Al>>2]|0;f[zl>>2]=f[Mk>>2];f[zl+4>>2]=f[Mk+4>>2]}else{f[Ok>>2]=0;ZS(Sk,e)}f[Za>>2]=(f[Za>>2]|0)+56}uT(U);Sk=tT(U,5)|0;b[Sk>>0]=b[435704]|0;b[Sk+1>>0]=b[435705]|0;b[Sk+2>>0]=b[435706]|0;b[Sk+3>>0]=b[435707]|0;b[Sk+4>>0]=b[435708]|0}Sk=f[rf>>2]|0;do if(Sk|0){Ok=Sk+12|0;Mk=f[Ok>>2]|0;f[Ok>>2]=Mk+-1;if((Mk|0)!=1)break;_S(e)}while(0);f[rf>>2]=0;f[sf>>2]=0;f[sf+4>>2]=0;f[sf+8>>2]=0;f[sf+12>>2]=0;if((f[tf>>2]|0)>0){Sk=f[uf>>2]|0;jl=0;do{f[Sk+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[tf>>2]|0))}jl=f[Bf>>2]|0;if((jl|0)!=(Of|0))g0(jl);Qk=927;break c}else{Wl=Ul;Xl=Vl}while(0);do if(((Wl<<24>>24<0?Xl:Wl&255)|0)==4){if(EEc(r,0,-1,382464,4)|0){_l=b[ga>>0]|0;$l=f[ea>>2]|0;break}if((f[pa>>2]|0)<=1){Qk=550;break b}uT(U);M=tT(U,11)|0;N=455045;O=M+11|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));if((f[pa>>2]|0)>1){jl=1;do{hIa(e,0,q,i,jl);Sk=f[Za>>2]|0;if((Sk|0)==(f[_a>>2]|0))Bxa($,e);else{f[Sk>>2]=f[e>>2];Mk=Sk+4|0;f[Mk>>2]=f[Uf>>2];Ok=Sk+8|0;f[Ok>>2]=f[Yf>>2];f[Sk+12>>2]=f[Zf>>2];f[Sk+16>>2]=f[Tf>>2];f[Sk+20>>2]=f[_f>>2];f[Sk+24>>2]=f[$f>>2];f[Sk+28>>2]=f[ag>>2];f[Sk+32>>2]=f[bg>>2];zl=f[Sf>>2]|0;f[Sk+36>>2]=zl;f[Sk+40>>2]=Ok;Ok=Sk+48|0;Al=Sk+44|0;f[Al>>2]=Ok;f[Ok>>2]=0;f[Sk+52>>2]=0;if(zl|0){Ok=zl+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1}if((f[Uf>>2]|0)<3){Ok=f[Wf>>2]|0;zl=f[Al>>2]|0;f[zl>>2]=f[Ok>>2];f[zl+4>>2]=f[Ok+4>>2]}else{f[Mk>>2]=0;ZS(Sk,e)}f[Za>>2]=(f[Za>>2]|0)+56}Sk=f[Sf>>2]|0;do if(Sk|0){Mk=Sk+12|0;Ok=f[Mk>>2]|0;f[Mk>>2]=Ok+-1;if((Ok|0)!=1)break;_S(e)}while(0);f[Sf>>2]=0;f[Tf>>2]=0;f[Tf+4>>2]=0;f[Tf+8>>2]=0;f[Tf+12>>2]=0;if((f[Uf>>2]|0)>0){Sk=f[Vf>>2]|0;Ok=0;do{f[Sk+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[Uf>>2]|0))}Ok=f[Wf>>2]|0;if((Ok|0)!=(Xf|0))g0(Ok);jl=jl+1|0}while((jl|0)<(f[pa>>2]|0))}f[e>>2]=0;f[Qf>>2]=0;M=tT(e,10)|0;N=455057;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));$Ha(m,e,f[(f[$>>2]|0)+40>>2]|0)|0;uT(e);f[e>>2]=0;f[Rf>>2]=0;M=tT(e,9)|0;N=454939;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[g>>0]=(f[pa>>2]|0)==3&1;rIa(m,e,g)|0;uT(e);Qk=927;break c}else{_l=Wl;$l=Xl}while(0);do if(((_l<<24>>24<0?$l:_l&255)|0)==13){if(EEc(r,0,-1,382469,13)|0){am=b[ga>>0]|0;bm=f[ea>>2]|0;break}if((f[pa>>2]|0)<=1){Qk=574;break b}uT(U);M=tT(U,13)|0;N=425570;O=M+13|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));if((f[pa>>2]|0)>1){jl=1;do{hIa(e,0,q,i,jl);Ok=f[Za>>2]|0;if((Ok|0)==(f[_a>>2]|0))Bxa($,e);else{f[Ok>>2]=f[e>>2];Sk=Ok+4|0;f[Sk>>2]=f[gg>>2];Mk=Ok+8|0;f[Mk>>2]=f[kg>>2];f[Ok+12>>2]=f[lg>>2];f[Ok+16>>2]=f[fg>>2];f[Ok+20>>2]=f[mg>>2];f[Ok+24>>2]=f[ng>>2];f[Ok+28>>2]=f[og>>2];f[Ok+32>>2]=f[pg>>2];zl=f[eg>>2]|0;f[Ok+36>>2]=zl;f[Ok+40>>2]=Mk;Mk=Ok+48|0;Al=Ok+44|0;f[Al>>2]=Mk;f[Mk>>2]=0;f[Ok+52>>2]=0;if(zl|0){Mk=zl+12|0;f[Mk>>2]=(f[Mk>>2]|0)+1}if((f[gg>>2]|0)<3){Mk=f[ig>>2]|0;zl=f[Al>>2]|0;f[zl>>2]=f[Mk>>2];f[zl+4>>2]=f[Mk+4>>2]}else{f[Sk>>2]=0;ZS(Ok,e)}f[Za>>2]=(f[Za>>2]|0)+56}Ok=f[eg>>2]|0;do if(Ok|0){Sk=Ok+12|0;Mk=f[Sk>>2]|0;f[Sk>>2]=Mk+-1;if((Mk|0)!=1)break;_S(e)}while(0);f[eg>>2]=0;f[fg>>2]=0;f[fg+4>>2]=0;f[fg+8>>2]=0;f[fg+12>>2]=0;if((f[gg>>2]|0)>0){Ok=f[hg>>2]|0;Mk=0;do{f[Ok+(Mk<<2)>>2]=0;Mk=Mk+1|0}while((Mk|0)<(f[gg>>2]|0))}Mk=f[ig>>2]|0;if((Mk|0)!=(jg|0))g0(Mk);jl=jl+1|0}while((jl|0)<(f[pa>>2]|0))}f[e>>2]=0;f[cg>>2]=0;M=tT(e,10)|0;N=455057;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));$Ha(m,e,(f[(f[$>>2]|0)+40>>2]|0)+4|0)|0;uT(e);f[e>>2]=0;f[dg>>2]=0;M=tT(e,9)|0;N=454939;O=M+9|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[g>>0]=(f[pa>>2]|0)==3&1;rIa(m,e,g)|0;uT(e);Qk=927;break c}else{am=_l;bm=$l}while(0);do if(((am<<24>>24<0?bm:am&255)|0)==9)if(!(EEc(r,0,-1,383639,9)|0)){uT(U);jl=tT(U,7)|0;b[jl>>0]=b[454705]|0;b[jl+1>>0]=b[454706]|0;b[jl+2>>0]=b[454707]|0;b[jl+3>>0]=b[454708]|0;b[jl+4>>0]=b[454709]|0;b[jl+5>>0]=b[454710]|0;b[jl+6>>0]=b[454711]|0;f[e>>2]=0;f[qg>>2]=0;jl=tT(e,4)|0;b[jl>>0]=112;b[jl+1>>0]=101;b[jl+2>>0]=114;b[jl+3>>0]=109;f[g>>2]=0;f[rg>>2]=0;jl=tT(g,5)|0;b[jl>>0]=b[454713]|0;b[jl+1>>0]=b[454714]|0;b[jl+2>>0]=b[454715]|0;b[jl+3>>0]=b[454716]|0;b[jl+4>>0]=b[454717]|0;vIa(m,e,g);uT(g);uT(e);Qk=927;break c}else{cm=b[ga>>0]|0;dm=f[ea>>2]|0;break}else{cm=am;dm=bm}while(0);do if(((cm<<24>>24<0?dm:cm&255)|0)==9){if(EEc(r,0,-1,382483,9)|0){em=b[ga>>0]|0;fm=f[ea>>2]|0;break}if((f[pa>>2]|0)!=1){Qk=602;break b}hIa(t,0,q,i,0);f[e>>2]=0;f[sg>>2]=0;jl=tT(e,4)|0;b[jl>>0]=97;b[jl+1>>0]=120;b[jl+2>>0]=101;b[jl+3>>0]=115;TFa(v,lIa(m,e)|0);uT(e);f[y>>2]=0;f[tg>>2]=0;f[ug>>2]=0;g:do if((f[vg>>2]|0)>0){jl=0;Mk=0;Ok=0;while(1){Sk=(f[Ch>>2]|0)+(jl<<2)|0;if((Mk|0)==(Ok|0))g6(y,Sk);else{f[Mk>>2]=f[Sk>>2];f[tg>>2]=Mk+4}Sk=jl+1|0;if((Sk|0)>=(f[vg>>2]|0))break g;jl=Sk;Mk=f[tg>>2]|0;Ok=f[Hh>>2]|0}}while(0);switch(f[v>>2]|0){case 0:{gm=(f[wg>>2]|0)+4|0;break}case 3:{gm=(f[xg>>2]|0)+4|0;break}case 2:{gm=(f[xg>>2]|0)+4|0;break}default:{Qk=608;break b}}Ok=DHa(v,(f[gm>>2]|0)+-1|0)|0;if(Ok>>>0>(f[tg>>2]|0)-(f[y>>2]|0)>>2>>>0){Qk=615;break b}else hm=0;while(1){switch(f[v>>2]|0){case 0:{im=(f[wg>>2]|0)+4|0;break}case 3:{im=(f[xg>>2]|0)+4|0;break}case 2:{im=(f[xg>>2]|0)+4|0;break}default:{Qk=620;break b}}if((hm|0)>=(f[im>>2]|0))break;Ok=f[y>>2]|0;Mk=DHa(v,hm)|0;f[A>>2]=Ok+(Mk<<2);f[g>>2]=1;f[e>>2]=f[A>>2];wIa(y,e,g)|0;hm=hm+1|0}nT(B,t,0,y);Mk=f[ha>>2]|0;f[E>>2]=Mk;f[yg>>2]=f[fa>>2];if(Mk|0){Ok=Mk+-4|0;f[Ok>>2]=(f[Ok>>2]|0)+1}f[F>>2]=f[B>>2];Ok=f[Ag>>2]|0;f[zg>>2]=Ok;f[Bg>>2]=f[Cg>>2];f[Dg>>2]=f[Eg>>2];f[Fg>>2]=f[Gg>>2];f[Hg>>2]=f[Ig>>2];f[Jg>>2]=f[Kg>>2];f[Lg>>2]=f[Mg>>2];f[Ng>>2]=f[Og>>2];Mk=f[Qg>>2]|0;f[Pg>>2]=Mk;f[Rg>>2]=Bg;f[Tg>>2]=Sg;f[Sg>>2]=0;f[Ug>>2]=0;if(!Mk)jm=Ok;else{Ok=Mk+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1;jm=f[Ag>>2]|0}if((jm|0)<3){Ok=f[Vg>>2]|0;Mk=f[Tg>>2]|0;f[Mk>>2]=f[Ok>>2];f[Mk+4>>2]=f[Ok+4>>2]}else{f[zg>>2]=0;ZS(F,B)}Ok=f[E>>2]|0;f[D>>2]=Ok;f[Wg>>2]=f[yg>>2];if(Ok|0){Mk=Ok+-4|0;f[Mk>>2]=(f[Mk>>2]|0)+1}f[Xg>>2]=f[F>>2];Mk=f[zg>>2]|0;f[Yg>>2]=Mk;f[Zg>>2]=f[Bg>>2];f[_g>>2]=f[Dg>>2];f[$g>>2]=f[Fg>>2];f[ah>>2]=f[Hg>>2];f[bh>>2]=f[Jg>>2];f[ch>>2]=f[Lg>>2];f[dh>>2]=f[Ng>>2];Ok=f[Pg>>2]|0;f[eh>>2]=Ok;f[fh>>2]=Zg;f[hh>>2]=gh;f[gh>>2]=0;f[ih>>2]=0;if(!Ok)km=Mk;else{Mk=Ok+12|0;f[Mk>>2]=(f[Mk>>2]|0)+1;km=f[zg>>2]|0}if((km|0)<3){Mk=f[Tg>>2]|0;Ok=f[hh>>2]|0;f[Ok>>2]=f[Mk>>2];f[Ok+4>>2]=f[Mk+4>>2]}else{f[Yg>>2]=0;ZS(Xg,F)}Mk=f[D>>2]|0;Ok=f[Wg>>2]|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;if(Ok>>>0>4294967279){Qk=638;break b}if(Ok>>>0<11){b[jh>>0]=Ok;if(!Ok)lm=C;else{mm=C;Qk=642}}else{jl=Ok+16&-16;Sk=VDc(jl)|0;f[C>>2]=Sk;f[Fh>>2]=jl|-2147483648;f[Gh>>2]=Ok;mm=Sk;Qk=642}if((Qk|0)==642){Qk=0;dJc(mm|0,Mk|0,Ok|0)|0;lm=mm}b[lm+Ok>>0]=0;f[kh>>2]=f[Xg>>2];Ok=f[Yg>>2]|0;f[lh>>2]=Ok;f[mh>>2]=f[Zg>>2];f[nh>>2]=f[_g>>2];f[oh>>2]=f[$g>>2];f[ph>>2]=f[ah>>2];f[qh>>2]=f[bh>>2];f[rh>>2]=f[ch>>2];f[sh>>2]=f[dh>>2];Mk=f[eh>>2]|0;f[th>>2]=Mk;f[uh>>2]=mh;f[wh>>2]=vh;f[vh>>2]=0;f[xh>>2]=0;if(!Mk)nm=Ok;else{Ok=Mk+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1;nm=f[Yg>>2]|0}if((nm|0)<3){Ok=f[hh>>2]|0;Mk=f[wh>>2]|0;f[Mk>>2]=f[Ok>>2];f[Mk+4>>2]=f[Ok+4>>2]}else{f[lh>>2]=0;ZS(kh,Xg)}Ok=XHa(i,e,C)|0;if(!(f[Ok>>2]|0)){YHa(g,i,C);Mk=f[g>>2]|0;f[g>>2]=0;Sk=f[e>>2]|0;f[Mk>>2]=0;f[Mk+4>>2]=0;f[Mk+8>>2]=Sk;f[Ok>>2]=Mk;Sk=f[f[i>>2]>>2]|0;if(!Sk)om=Mk;else{f[i>>2]=Sk;om=f[Ok>>2]|0}laa(f[vc>>2]|0,om);f[wc>>2]=(f[wc>>2]|0)+1}Ok=f[th>>2]|0;do if(Ok|0){Sk=Ok+12|0;Mk=f[Sk>>2]|0;f[Sk>>2]=Mk+-1;if((Mk|0)!=1)break;_S(kh)}while(0);f[th>>2]=0;f[oh>>2]=0;f[oh+4>>2]=0;f[oh+8>>2]=0;f[oh+12>>2]=0;if((f[lh>>2]|0)>0){Ok=f[uh>>2]|0;Mk=0;do{f[Ok+(Mk<<2)>>2]=0;Mk=Mk+1|0}while((Mk|0)<(f[lh>>2]|0))}Mk=f[wh>>2]|0;if((Mk|0)!=(vh|0))g0(Mk);if((b[jh>>0]|0)<0)YDc(f[C>>2]|0);Mk=f[eh>>2]|0;do if(Mk|0){Ok=Mk+12|0;Sk=f[Ok>>2]|0;f[Ok>>2]=Sk+-1;if((Sk|0)!=1)break;_S(Xg)}while(0);f[eh>>2]=0;f[$g>>2]=0;f[$g+4>>2]=0;f[$g+8>>2]=0;f[$g+12>>2]=0;if((f[Yg>>2]|0)>0){Mk=f[fh>>2]|0;Sk=0;do{f[Mk+(Sk<<2)>>2]=0;Sk=Sk+1|0}while((Sk|0)<(f[Yg>>2]|0))}Sk=f[hh>>2]|0;if((Sk|0)!=(gh|0))g0(Sk);uT(D);Sk=f[Pg>>2]|0;do if(Sk|0){Mk=Sk+12|0;Ok=f[Mk>>2]|0;f[Mk>>2]=Ok+-1;if((Ok|0)!=1)break;_S(F)}while(0);f[Pg>>2]=0;f[Fg>>2]=0;f[Fg+4>>2]=0;f[Fg+8>>2]=0;f[Fg+12>>2]=0;if((f[zg>>2]|0)>0){Sk=f[Rg>>2]|0;Ok=0;do{f[Sk+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[zg>>2]|0))}Ok=f[Tg>>2]|0;if((Ok|0)!=(Sg|0))g0(Ok);uT(E);Ok=f[Qg>>2]|0;do if(Ok|0){Sk=Ok+12|0;Mk=f[Sk>>2]|0;f[Sk>>2]=Mk+-1;if((Mk|0)!=1)break;_S(B)}while(0);f[Qg>>2]=0;f[Gg>>2]=0;f[Gg+4>>2]=0;f[Gg+8>>2]=0;f[Gg+12>>2]=0;if((f[Ag>>2]|0)>0){Ok=f[yh>>2]|0;Mk=0;do{f[Ok+(Mk<<2)>>2]=0;Mk=Mk+1|0}while((Mk|0)<(f[Ag>>2]|0))}Mk=f[Vg>>2]|0;if((Mk|0)!=(zh|0))g0(Mk);Mk=f[y>>2]|0;if(Mk|0){Ok=f[tg>>2]|0;if((Ok|0)!=(Mk|0))f[tg>>2]=Ok+(~((Ok+-4-Mk|0)>>>2)<<2);YDc(Mk)}JFa(v);Mk=f[Ah>>2]|0;do if(Mk|0){Ok=Mk+12|0;Sk=f[Ok>>2]|0;f[Ok>>2]=Sk+-1;if((Sk|0)!=1)break;_S(t)}while(0);f[Ah>>2]=0;f[Bh>>2]=0;f[Bh+4>>2]=0;f[Bh+8>>2]=0;f[Bh+12>>2]=0;if((f[vg>>2]|0)>0){Mk=f[Ch>>2]|0;Sk=0;do{f[Mk+(Sk<<2)>>2]=0;Sk=Sk+1|0}while((Sk|0)<(f[vg>>2]|0))}Sk=f[Dh>>2]|0;if((Sk|0)!=(Eh|0))g0(Sk);break c}else{em=cm;fm=dm}while(0);do if(((em<<24>>24<0?fm:em&255)|0)==7){if(EEc(r,0,-1,426093,7)|0){pm=b[ga>>0]|0;qm=f[ea>>2]|0;break}do if((f[pa>>2]|0)!=2){f[e>>2]=0;f[fj>>2]=0;Sk=tT(e,5)|0;b[Sk>>0]=b[382569]|0;b[Sk+1>>0]=b[382570]|0;b[Sk+2>>0]=b[382571]|0;b[Sk+3>>0]=b[382572]|0;b[Sk+4>>0]=b[382573]|0;Sk=f[aa>>2]|0;if(!Sk){Qk=712;break b}Mk=f[e>>2]|0;Ok=(Mk|0)==0?1154740:Mk;jl=Sk;while(1){Sk=f[jl+16>>2]|0;if((Mk|0)==(Sk|0)){Qk=715;break}zl=(Sk|0)==0?1154740:Sk;if((Ioc(Ok,zl)|0)<0)rm=jl;else{if((Ioc(zl,Ok)|0)>=0){Qk=711;break}rm=jl+4|0}jl=f[rm>>2]|0;if(!jl){Qk=713;break b}}if((Qk|0)==711){Qk=0;uT(e)}else if((Qk|0)==715){Qk=0;uT(e)}if((f[pa>>2]|0)==2)break;f[e>>2]=0;f[gj>>2]=0;jl=tT(e,5)|0;b[jl>>0]=b[382569]|0;b[jl+1>>0]=b[382570]|0;b[jl+2>>0]=b[382571]|0;b[jl+3>>0]=b[382572]|0;b[jl+4>>0]=b[382573]|0;TFa(t,lIa(m,e)|0);uT(e);f[v>>2]=0;f[hj>>2]=0;f[ij>>2]=0;jl=0;while(1){switch(f[t>>2]|0){case 0:{sm=(f[jj>>2]|0)+4|0;break}case 3:{sm=(f[lj>>2]|0)+4|0;break}case 2:{sm=(f[lj>>2]|0)+4|0;break}default:{Qk=819;break b}}if((jl|0)>=(f[sm>>2]|0))break;Ok=DHa(t,jl)|0;f[e>>2]=Ok;Mk=f[hj>>2]|0;if((Mk|0)==(f[kj>>2]|0))g6(v,e);else{f[Mk>>2]=Ok;f[hj>>2]=Mk+4}jl=jl+1|0}if((sIa(k,f[(f[qa>>2]|0)+4>>2]|0)|0)==(P|0)){hIa(y,0,q,i,0);nT(B,y,0,v);jl=f[ha>>2]|0;f[I>>2]=jl;f[mj>>2]=f[fa>>2];if(jl|0){Mk=jl+-4|0;f[Mk>>2]=(f[Mk>>2]|0)+1}f[J>>2]=f[B>>2];Mk=f[oj>>2]|0;f[nj>>2]=Mk;f[pj>>2]=f[qj>>2];f[rj>>2]=f[sj>>2];f[tj>>2]=f[uj>>2];f[vj>>2]=f[wj>>2];f[xj>>2]=f[yj>>2];f[zj>>2]=f[Aj>>2];f[Bj>>2]=f[Cj>>2];jl=f[Ej>>2]|0;f[Dj>>2]=jl;f[Fj>>2]=pj;f[Hj>>2]=Gj;f[Gj>>2]=0;f[Ij>>2]=0;if(!jl)tm=Mk;else{Mk=jl+12|0;f[Mk>>2]=(f[Mk>>2]|0)+1;tm=f[oj>>2]|0}if((tm|0)<3){Mk=f[Jj>>2]|0;jl=f[Hj>>2]|0;f[jl>>2]=f[Mk>>2];f[jl+4>>2]=f[Mk+4>>2]}else{f[nj>>2]=0;ZS(J,B)}Mk=f[I>>2]|0;f[D>>2]=Mk;f[Kj>>2]=f[mj>>2];if(Mk|0){jl=Mk+-4|0;f[jl>>2]=(f[jl>>2]|0)+1}f[Lj>>2]=f[J>>2];jl=f[nj>>2]|0;f[Mj>>2]=jl;f[Nj>>2]=f[pj>>2];f[Oj>>2]=f[rj>>2];f[Pj>>2]=f[tj>>2];f[Qj>>2]=f[vj>>2];f[Rj>>2]=f[xj>>2];f[Sj>>2]=f[zj>>2];f[Tj>>2]=f[Bj>>2];Mk=f[Dj>>2]|0;f[Uj>>2]=Mk;f[Vj>>2]=Nj;f[Xj>>2]=Wj;f[Wj>>2]=0;f[Yj>>2]=0;if(!Mk)um=jl;else{jl=Mk+12|0;f[jl>>2]=(f[jl>>2]|0)+1;um=f[nj>>2]|0}if((um|0)<3){jl=f[Hj>>2]|0;Mk=f[Xj>>2]|0;f[Mk>>2]=f[jl>>2];f[Mk+4>>2]=f[jl+4>>2]}else{f[Mj>>2]=0;ZS(Lj,J)}jl=f[D>>2]|0;Mk=f[Kj>>2]|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;if(Mk>>>0>4294967279){Qk=841;break b}if(Mk>>>0<11){b[Zj>>0]=Mk;if(!Mk)vm=C;else{wm=C;Qk=845}}else{Ok=Mk+16&-16;zl=VDc(Ok)|0;f[C>>2]=zl;f[vk>>2]=Ok|-2147483648;f[wk>>2]=Mk;wm=zl;Qk=845}if((Qk|0)==845){Qk=0;dJc(wm|0,jl|0,Mk|0)|0;vm=wm}b[vm+Mk>>0]=0;f[_j>>2]=f[Lj>>2];Mk=f[Mj>>2]|0;f[ak>>2]=Mk;f[bk>>2]=f[Nj>>2];f[ck>>2]=f[Oj>>2];f[dk>>2]=f[Pj>>2];f[ek>>2]=f[Qj>>2];f[fk>>2]=f[Rj>>2];f[gk>>2]=f[Sj>>2];f[hk>>2]=f[Tj>>2];jl=f[Uj>>2]|0;f[ik>>2]=jl;f[jk>>2]=bk;f[lk>>2]=kk;f[kk>>2]=0;f[mk>>2]=0;if(!jl)xm=Mk;else{Mk=jl+12|0;f[Mk>>2]=(f[Mk>>2]|0)+1;xm=f[Mj>>2]|0}if((xm|0)<3){Mk=f[Xj>>2]|0;jl=f[lk>>2]|0;f[jl>>2]=f[Mk>>2];f[jl+4>>2]=f[Mk+4>>2]}else{f[ak>>2]=0;ZS(_j,Lj)}Mk=XHa(i,e,C)|0;if(!(f[Mk>>2]|0)){YHa(g,i,C);jl=f[g>>2]|0;f[g>>2]=0;zl=f[e>>2]|0;f[jl>>2]=0;f[jl+4>>2]=0;f[jl+8>>2]=zl;f[Mk>>2]=jl;zl=f[f[i>>2]>>2]|0;if(!zl)ym=jl;else{f[i>>2]=zl;ym=f[Mk>>2]|0}laa(f[vc>>2]|0,ym);f[wc>>2]=(f[wc>>2]|0)+1}Mk=f[ik>>2]|0;do if(Mk|0){zl=Mk+12|0;jl=f[zl>>2]|0;f[zl>>2]=jl+-1;if((jl|0)!=1)break;_S(_j)}while(0);f[ik>>2]=0;f[dk>>2]=0;f[dk+4>>2]=0;f[dk+8>>2]=0;f[dk+12>>2]=0;if((f[ak>>2]|0)>0){Mk=f[jk>>2]|0;jl=0;do{f[Mk+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[ak>>2]|0))}jl=f[lk>>2]|0;if((jl|0)!=(kk|0))g0(jl);if((b[Zj>>0]|0)<0)YDc(f[C>>2]|0);jl=f[Uj>>2]|0;do if(jl|0){Mk=jl+12|0;zl=f[Mk>>2]|0;f[Mk>>2]=zl+-1;if((zl|0)!=1)break;_S(Lj)}while(0);f[Uj>>2]=0;f[Pj>>2]=0;f[Pj+4>>2]=0;f[Pj+8>>2]=0;f[Pj+12>>2]=0;if((f[Mj>>2]|0)>0){jl=f[Vj>>2]|0;zl=0;do{f[jl+(zl<<2)>>2]=0;zl=zl+1|0}while((zl|0)<(f[Mj>>2]|0))}zl=f[Xj>>2]|0;if((zl|0)!=(Wj|0))g0(zl);uT(D);zl=f[Dj>>2]|0;do if(zl|0){jl=zl+12|0;Mk=f[jl>>2]|0;f[jl>>2]=Mk+-1;if((Mk|0)!=1)break;_S(J)}while(0);f[Dj>>2]=0;f[tj>>2]=0;f[tj+4>>2]=0;f[tj+8>>2]=0;f[tj+12>>2]=0;if((f[nj>>2]|0)>0){zl=f[Fj>>2]|0;Mk=0;do{f[zl+(Mk<<2)>>2]=0;Mk=Mk+1|0}while((Mk|0)<(f[nj>>2]|0))}Mk=f[Hj>>2]|0;if((Mk|0)!=(Gj|0))g0(Mk);uT(I);Mk=f[Ej>>2]|0;do if(Mk|0){zl=Mk+12|0;jl=f[zl>>2]|0;f[zl>>2]=jl+-1;if((jl|0)!=1)break;_S(B)}while(0);f[Ej>>2]=0;f[uj>>2]=0;f[uj+4>>2]=0;f[uj+8>>2]=0;f[uj+12>>2]=0;if((f[oj>>2]|0)>0){Mk=f[nk>>2]|0;jl=0;do{f[Mk+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[oj>>2]|0))}jl=f[Jj>>2]|0;if((jl|0)!=(ok|0))g0(jl);jl=f[pk>>2]|0;do if(jl|0){Mk=jl+12|0;zl=f[Mk>>2]|0;f[Mk>>2]=zl+-1;if((zl|0)!=1)break;_S(y)}while(0);f[pk>>2]=0;f[qk>>2]=0;f[qk+4>>2]=0;f[qk+8>>2]=0;f[qk+12>>2]=0;if((f[rk>>2]|0)>0){jl=f[sk>>2]|0;zl=0;do{f[jl+(zl<<2)>>2]=0;zl=zl+1|0}while((zl|0)<(f[rk>>2]|0))}zl=f[tk>>2]|0;if((zl|0)!=(uk|0))g0(zl);zm=9}else{f[e>>2]=0;f[xk>>2]=0;zl=tT(e,5)|0;b[zl>>0]=b[382569]|0;b[zl+1>>0]=b[382570]|0;b[zl+2>>0]=b[382571]|0;b[zl+3>>0]=b[382572]|0;b[zl+4>>0]=b[382573]|0;f[g>>2]=0;f[yk>>2]=0;zl=tT(g,3)|0;b[zl>>0]=b[431774]|0;b[zl+1>>0]=b[431775]|0;b[zl+2>>0]=b[431776]|0;vIa(m,e,g);uT(g);uT(e);zm=0}zl=f[v>>2]|0;if(zl|0){jl=f[hj>>2]|0;if((jl|0)!=(zl|0))f[hj>>2]=jl+(~((jl+-4-zl|0)>>>2)<<2);YDc(zl)}JFa(t);if(!zm){Qk=927;break c}else break c}while(0);hIa(t,0,q,i,1);if((f[t>>2]&4095|0)!=4){Qk=718;break b}if((sIa(k,f[(f[qa>>2]|0)+4>>2]|0)|0)==(P|0)){hIa(v,0,q,i,0);f[g>>2]=0;f[Ih>>2]=0;f[Jh>>2]=0;zl=Kh;f[zl>>2]=0;f[zl+4>>2]=0;f[e>>2]=-2113732604;f[Lh>>2]=g;h_(t,e);nT(y,v,0,g);zl=f[g>>2]|0;if(zl|0){jl=f[Ih>>2]|0;if((jl|0)!=(zl|0))f[Ih>>2]=jl+(~((jl+-4-zl|0)>>>2)<<2);YDc(zl)}zl=f[ha>>2]|0;f[G>>2]=zl;f[Mh>>2]=f[fa>>2];if(zl|0){jl=zl+-4|0;f[jl>>2]=(f[jl>>2]|0)+1}f[H>>2]=f[y>>2];jl=f[Oh>>2]|0;f[Nh>>2]=jl;f[Ph>>2]=f[Qh>>2];f[Rh>>2]=f[Sh>>2];f[Th>>2]=f[Uh>>2];f[Vh>>2]=f[Wh>>2];f[Xh>>2]=f[Yh>>2];f[Zh>>2]=f[_h>>2];f[$h>>2]=f[ai>>2];zl=f[ci>>2]|0;f[bi>>2]=zl;f[di>>2]=Ph;f[gi>>2]=fi;f[fi>>2]=0;f[hi>>2]=0;if(!zl)Am=jl;else{jl=zl+12|0;f[jl>>2]=(f[jl>>2]|0)+1;Am=f[Oh>>2]|0}if((Am|0)<3){jl=f[ii>>2]|0;zl=f[gi>>2]|0;f[zl>>2]=f[jl>>2];f[zl+4>>2]=f[jl+4>>2]}else{f[Nh>>2]=0;ZS(H,y)}jl=f[G>>2]|0;f[C>>2]=jl;f[ji>>2]=f[Mh>>2];if(jl|0){zl=jl+-4|0;f[zl>>2]=(f[zl>>2]|0)+1}f[ki>>2]=f[H>>2];zl=f[Nh>>2]|0;f[li>>2]=zl;f[mi>>2]=f[Ph>>2];f[ni>>2]=f[Rh>>2];f[oi>>2]=f[Th>>2];f[pi>>2]=f[Vh>>2];f[qi>>2]=f[Xh>>2];f[ri>>2]=f[Zh>>2];f[si>>2]=f[$h>>2];jl=f[bi>>2]|0;f[ti>>2]=jl;f[ui>>2]=mi;f[wi>>2]=vi;f[vi>>2]=0;f[xi>>2]=0;if(!jl)Bm=zl;else{zl=jl+12|0;f[zl>>2]=(f[zl>>2]|0)+1;Bm=f[Nh>>2]|0}if((Bm|0)<3){zl=f[gi>>2]|0;jl=f[wi>>2]|0;f[jl>>2]=f[zl>>2];f[jl+4>>2]=f[zl+4>>2]}else{f[li>>2]=0;ZS(ki,H)}zl=f[C>>2]|0;jl=f[ji>>2]|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;if(jl>>>0>4294967279){Qk=739;break b}if(jl>>>0<11){b[yi>>0]=jl;if(!jl)Cm=B;else{Dm=B;Qk=743}}else{Mk=jl+16&-16;Ok=VDc(Mk)|0;f[B>>2]=Ok;f[Vi>>2]=Mk|-2147483648;f[Wi>>2]=jl;Dm=Ok;Qk=743}if((Qk|0)==743){Qk=0;dJc(Dm|0,zl|0,jl|0)|0;Cm=Dm}b[Cm+jl>>0]=0;f[zi>>2]=f[ki>>2];jl=f[li>>2]|0;f[Ai>>2]=jl;f[Bi>>2]=f[mi>>2];f[Ci>>2]=f[ni>>2];f[Di>>2]=f[oi>>2];f[Ei>>2]=f[pi>>2];f[Fi>>2]=f[qi>>2];f[Gi>>2]=f[ri>>2];f[Hi>>2]=f[si>>2];zl=f[ti>>2]|0;f[Ii>>2]=zl;f[Ji>>2]=Bi;f[Li>>2]=Ki;f[Ki>>2]=0;f[Mi>>2]=0;if(!zl)Em=jl;else{jl=zl+12|0;f[jl>>2]=(f[jl>>2]|0)+1;Em=f[li>>2]|0}if((Em|0)<3){jl=f[wi>>2]|0;zl=f[Li>>2]|0;f[zl>>2]=f[jl>>2];f[zl+4>>2]=f[jl+4>>2]}else{f[Ai>>2]=0;ZS(zi,ki)}jl=XHa(i,e,B)|0;if(!(f[jl>>2]|0)){YHa(g,i,B);zl=f[g>>2]|0;f[g>>2]=0;Ok=f[e>>2]|0;f[zl>>2]=0;f[zl+4>>2]=0;f[zl+8>>2]=Ok;f[jl>>2]=zl;Ok=f[f[i>>2]>>2]|0;if(!Ok)Fm=zl;else{f[i>>2]=Ok;Fm=f[jl>>2]|0}laa(f[vc>>2]|0,Fm);f[wc>>2]=(f[wc>>2]|0)+1}jl=f[Ii>>2]|0;do if(jl|0){Ok=jl+12|0;zl=f[Ok>>2]|0;f[Ok>>2]=zl+-1;if((zl|0)!=1)break;_S(zi)}while(0);f[Ii>>2]=0;f[Di>>2]=0;f[Di+4>>2]=0;f[Di+8>>2]=0;f[Di+12>>2]=0;if((f[Ai>>2]|0)>0){jl=f[Ji>>2]|0;zl=0;do{f[jl+(zl<<2)>>2]=0;zl=zl+1|0}while((zl|0)<(f[Ai>>2]|0))}zl=f[Li>>2]|0;if((zl|0)!=(Ki|0))g0(zl);if((b[yi>>0]|0)<0)YDc(f[B>>2]|0);zl=f[ti>>2]|0;do if(zl|0){jl=zl+12|0;Ok=f[jl>>2]|0;f[jl>>2]=Ok+-1;if((Ok|0)!=1)break;_S(ki)}while(0);f[ti>>2]=0;f[oi>>2]=0;f[oi+4>>2]=0;f[oi+8>>2]=0;f[oi+12>>2]=0;if((f[li>>2]|0)>0){zl=f[ui>>2]|0;Ok=0;do{f[zl+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[li>>2]|0))}Ok=f[wi>>2]|0;if((Ok|0)!=(vi|0))g0(Ok);uT(C);Ok=f[bi>>2]|0;do if(Ok|0){zl=Ok+12|0;jl=f[zl>>2]|0;f[zl>>2]=jl+-1;if((jl|0)!=1)break;_S(H)}while(0);f[bi>>2]=0;f[Th>>2]=0;f[Th+4>>2]=0;f[Th+8>>2]=0;f[Th+12>>2]=0;if((f[Nh>>2]|0)>0){Ok=f[di>>2]|0;jl=0;do{f[Ok+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Nh>>2]|0))}jl=f[gi>>2]|0;if((jl|0)!=(fi|0))g0(jl);uT(G);jl=f[ci>>2]|0;do if(jl|0){Ok=jl+12|0;zl=f[Ok>>2]|0;f[Ok>>2]=zl+-1;if((zl|0)!=1)break;_S(y)}while(0);f[ci>>2]=0;f[Uh>>2]=0;f[Uh+4>>2]=0;f[Uh+8>>2]=0;f[Uh+12>>2]=0;if((f[Oh>>2]|0)>0){jl=f[Ni>>2]|0;zl=0;do{f[jl+(zl<<2)>>2]=0;zl=zl+1|0}while((zl|0)<(f[Oh>>2]|0))}zl=f[ii>>2]|0;if((zl|0)!=(Oi|0))g0(zl);zl=f[Pi>>2]|0;do if(zl|0){jl=zl+12|0;Ok=f[jl>>2]|0;f[jl>>2]=Ok+-1;if((Ok|0)!=1)break;_S(v)}while(0);f[Pi>>2]=0;f[Qi>>2]=0;f[Qi+4>>2]=0;f[Qi+8>>2]=0;f[Qi+12>>2]=0;if((f[Ri>>2]|0)>0){zl=f[Si>>2]|0;Ok=0;do{f[zl+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[Ri>>2]|0))}Ok=f[Ti>>2]|0;if((Ok|0)!=(Ui|0))g0(Ok);Gm=9}else{f[e>>2]=0;f[bj>>2]=0;Ok=tT(e,3)|0;b[Ok>>0]=b[431774]|0;b[Ok+1>>0]=b[431775]|0;b[Ok+2>>0]=b[431776]|0;Ok=f[Yi>>2]|0;zl=f[Zi>>2]|0;if((zl|0)<3)Hm=Y(f[dj>>2]|0,f[cj>>2]|0)|0;else{jl=f[_i>>2]|0;Mk=0;Sk=1;while(1){Al=Y(f[jl+(Mk<<2)>>2]|0,Sk)|0;Mk=Mk+1|0;if((Mk|0)==(zl|0)){Hm=Al;break}else Sk=Al}}Sk=VDc(16)|0;zl=Sk+8|0;f[Sk>>2]=zl;f[Sk+4>>2]=Hm;if(Hm>>>0>1){Mk=XDc(Hm>>>0>536870911?-1:Hm<<3)|0;f[Sk>>2]=Mk;Im=Mk}else Im=zl;f[g>>2]=0;f[ej>>2]=Sk;if((Hm|0)>0){Sk=Ok;zl=0;while(1){Mk=f[Sk>>2]|0;jl=Im+(zl<<3)|0;f[jl>>2]=Mk;f[jl+4>>2]=((Mk|0)<0)<<31>>31;zl=zl+1|0;if((zl|0)==(Hm|0))break;else Sk=Sk+4|0}}bIa(m,e,g)|0;JFa(g);uT(e);Gm=0}Sk=f[Xi>>2]|0;do if(Sk|0){zl=Sk+12|0;Ok=f[zl>>2]|0;f[zl>>2]=Ok+-1;if((Ok|0)!=1)break;_S(t)}while(0);f[Xi>>2]=0;f[Yi>>2]=0;f[Yi+4>>2]=0;f[Yi+8>>2]=0;f[Yi+12>>2]=0;if((f[Zi>>2]|0)>0){Sk=f[_i>>2]|0;Ok=0;do{f[Sk+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[Zi>>2]|0))}Ok=f[$i>>2]|0;if((Ok|0)!=(aj|0))g0(Ok);if(!Gm){Qk=927;break c}else break c}else{pm=em;qm=fm}while(0);do if(((pm<<24>>24<0?qm:pm&255)|0)==3){if(EEc(r,0,-1,383054,3)|0)break;uT(U);Ok=tT(U,7)|0;b[Ok>>0]=b[425755]|0;b[Ok+1>>0]=b[425756]|0;b[Ok+2>>0]=b[425757]|0;b[Ok+3>>0]=b[425758]|0;b[Ok+4>>0]=b[425759]|0;b[Ok+5>>0]=b[425760]|0;b[Ok+6>>0]=b[425761]|0;Qk=927;break c}while(0);if((f[pa>>2]|0)>0)Jm=0;else{Qk=927;break c}while(1){if((sIa(k,f[(f[qa>>2]|0)+4+(Jm<<2)>>2]|0)|0)==(P|0)){hIa(e,0,q,i,Jm);Ok=f[Za>>2]|0;if((Ok|0)==(f[_a>>2]|0))Bxa($,e);else{f[Ok>>2]=f[e>>2];Sk=Ok+4|0;f[Sk>>2]=f[Bk>>2];zl=Ok+8|0;f[zl>>2]=f[Fk>>2];f[Ok+12>>2]=f[Gk>>2];f[Ok+16>>2]=f[Ak>>2];f[Ok+20>>2]=f[Hk>>2];f[Ok+24>>2]=f[Ik>>2];f[Ok+28>>2]=f[Jk>>2];f[Ok+32>>2]=f[Kk>>2];Mk=f[zk>>2]|0;f[Ok+36>>2]=Mk;f[Ok+40>>2]=zl;zl=Ok+48|0;jl=Ok+44|0;f[jl>>2]=zl;f[zl>>2]=0;f[Ok+52>>2]=0;if(Mk|0){zl=Mk+12|0;f[zl>>2]=(f[zl>>2]|0)+1}if((f[Bk>>2]|0)<3){zl=f[Dk>>2]|0;Mk=f[jl>>2]|0;f[Mk>>2]=f[zl>>2];f[Mk+4>>2]=f[zl+4>>2]}else{f[Sk>>2]=0;ZS(Ok,e)}f[Za>>2]=(f[Za>>2]|0)+56}Ok=f[zk>>2]|0;do if(Ok|0){Sk=Ok+12|0;zl=f[Sk>>2]|0;f[Sk>>2]=zl+-1;if((zl|0)!=1)break;_S(e)}while(0);f[zk>>2]=0;f[Ak>>2]=0;f[Ak+4>>2]=0;f[Ak+8>>2]=0;f[Ak+12>>2]=0;if((f[Bk>>2]|0)>0){Ok=f[Ck>>2]|0;zl=0;do{f[Ok+(zl<<2)>>2]=0;zl=zl+1|0}while((zl|0)<(f[Bk>>2]|0))}zl=f[Dk>>2]|0;if((zl|0)!=(Ek|0))g0(zl)}Jm=Jm+1|0;if((Jm|0)>=(f[pa>>2]|0)){Qk=927;break c}}}while(0);if((sIa(k,f[(f[qa>>2]|0)+8>>2]|0)|0)!=(P|0)){uT(U);zl=tT(U,7)|0;b[zl>>0]=b[454641]|0;b[zl+1>>0]=b[454642]|0;b[zl+2>>0]=b[454643]|0;b[zl+3>>0]=b[454644]|0;b[zl+4>>0]=b[454645]|0;b[zl+5>>0]=b[454646]|0;b[zl+6>>0]=b[454647]|0;Qk=927;break}hIa(e,0,q,i,1);lT(g,e,1,1);zl=f[Aa>>2]|0;if(zl|0){Ok=zl+12|0;f[Ok>>2]=(f[Ok>>2]|0)+1}Ok=f[Ba>>2]|0;do if(Ok|0){zl=Ok+12|0;Sk=f[zl>>2]|0;f[zl>>2]=Sk+-1;if((Sk|0)!=1)break;_S(e)}while(0);f[Ba>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[Da>>2]|0)>0){Ok=f[Ea>>2]|0;Sk=0;do{f[Ok+(Sk<<2)>>2]=0;Sk=Sk+1|0;Km=f[Da>>2]|0}while((Sk|0)<(Km|0));f[e>>2]=f[g>>2];if((Km|0)<3)Qk=71;else Qk=73}else{f[e>>2]=f[g>>2];Qk=71}do if((Qk|0)==71){Qk=0;Sk=f[Fa>>2]|0;if((Sk|0)>=3){Qk=73;break}f[Da>>2]=Sk;f[Ha>>2]=f[Ga>>2];f[Ja>>2]=f[Ia>>2];Sk=f[Ka>>2]|0;Ok=f[La>>2]|0;f[Ok>>2]=f[Sk>>2];f[Ok+4>>2]=f[Sk+4>>2]}while(0);if((Qk|0)==73){Qk=0;ZS(e,g)}f[Ca>>2]=f[Ma>>2];f[Oa>>2]=f[Na>>2];f[Qa>>2]=f[Pa>>2];f[Sa>>2]=f[Ra>>2];f[Ua>>2]=f[Ta>>2];Sk=f[Aa>>2]|0;f[Ba>>2]=Sk;do if(Sk|0){Ok=Sk+12|0;zl=f[Ok>>2]|0;f[Ok>>2]=zl+-1;if((zl|0)!=1)break;_S(g)}while(0);f[Aa>>2]=0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[Ma+8>>2]=0;f[Ma+12>>2]=0;if((f[Fa>>2]|0)>0){Sk=f[Va>>2]|0;zl=0;do{f[Sk+(zl<<2)>>2]=0;zl=zl+1|0}while((zl|0)<(f[Fa>>2]|0))}zl=f[Ka>>2]|0;if((zl|0)!=(Wa|0))g0(zl);zl=f[Da>>2]|0;if((zl|0)<3)Lm=Y(f[Ja>>2]|0,f[Ha>>2]|0)|0;else{Sk=f[Ea>>2]|0;Ok=0;Mk=1;while(1){jl=Y(f[Sk+(Ok<<2)>>2]|0,Mk)|0;Ok=Ok+1|0;if((Ok|0)==(zl|0)){Lm=jl;break}else Mk=jl}}uT(U);Mk=tT(U,5)|0;do if((Lm|0)==1){b[Mk>>0]=b[451285]|0;b[Mk+1>>0]=b[451286]|0;b[Mk+2>>0]=b[451287]|0;b[Mk+3>>0]=b[451288]|0;b[Mk+4>>0]=b[451289]|0;f[g>>2]=0;f[Xa>>2]=0;zl=tT(g,5)|0;b[zl>>0]=b[440275]|0;b[zl+1>>0]=b[440276]|0;b[zl+2>>0]=b[440277]|0;b[zl+3>>0]=b[440278]|0;b[zl+4>>0]=b[440279]|0;eIa(m,g,f[Ca>>2]|0)|0;uT(g)}else{b[Mk>>0]=b[425749]|0;b[Mk+1>>0]=b[425750]|0;b[Mk+2>>0]=b[425751]|0;b[Mk+3>>0]=b[425752]|0;b[Mk+4>>0]=b[425753]|0;zl=f[Za>>2]|0;if((zl|0)==(f[_a>>2]|0)){Bxa($,e);break}f[zl>>2]=f[e>>2];Ok=zl+4|0;f[Ok>>2]=f[Da>>2];Sk=zl+8|0;f[Sk>>2]=f[Ha>>2];f[zl+12>>2]=f[Ja>>2];f[zl+16>>2]=f[Ca>>2];f[zl+20>>2]=f[Oa>>2];f[zl+24>>2]=f[Qa>>2];f[zl+28>>2]=f[Sa>>2];f[zl+32>>2]=f[Ua>>2];jl=f[Ba>>2]|0;f[zl+36>>2]=jl;f[zl+40>>2]=Sk;Sk=zl+48|0;Al=zl+44|0;f[Al>>2]=Sk;f[Sk>>2]=0;f[zl+52>>2]=0;if(jl|0){Sk=jl+12|0;f[Sk>>2]=(f[Sk>>2]|0)+1}if((f[Da>>2]|0)<3){Sk=f[La>>2]|0;jl=f[Al>>2]|0;f[jl>>2]=f[Sk>>2];f[jl+4>>2]=f[Sk+4>>2]}else{f[Ok>>2]=0;ZS(zl,e)}f[Za>>2]=(f[Za>>2]|0)+56}while(0);Mk=f[Ba>>2]|0;do if(Mk|0){zl=Mk+12|0;Ok=f[zl>>2]|0;f[zl>>2]=Ok+-1;if((Ok|0)!=1)break;_S(e)}while(0);f[Ba>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[Da>>2]|0)>0){Mk=f[Ea>>2]|0;Ok=0;do{f[Mk+(Ok<<2)>>2]=0;Ok=Ok+1|0}while((Ok|0)<(f[Da>>2]|0))}Ok=f[La>>2]|0;if((Ok|0)!=(Ya|0))g0(Ok);Qk=927}while(0);if((Qk|0)==927){Qk=0;Ok=gGa(c,ha,U,m)|0;Mk=f[ha>>2]|0;f[K>>2]=Mk;zl=f[fa>>2]|0;f[ka>>2]=zl;if(Mk){Sk=Mk+-4|0;f[Sk>>2]=(f[Sk>>2]|0)+1;Sk=f[K>>2]|0;Mk=f[ka>>2]|0;f[t>>2]=Sk;f[la>>2]=Mk;if(!Sk){Mm=Mk;Nm=Sk}else{Mk=Sk+-4|0;f[Mk>>2]=(f[Mk>>2]|0)+1;Mm=f[la>>2]|0;Nm=f[t>>2]|0}}else{f[t>>2]=0;f[la>>2]=zl;Mm=zl;Nm=0}zl=ma;f[zl>>2]=Ok;f[zl+4>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(Mm>>>0>4294967279){Qk=932;break}if(Mm>>>0<11){b[na>>0]=Mm;if(!Mm)Om=g;else{Pm=g;Qk=936}}else{zl=Mm+16&-16;Mk=VDc(zl)|0;f[g>>2]=Mk;f[ra>>2]=zl|-2147483648;f[sa>>2]=Mm;Pm=Mk;Qk=936}if((Qk|0)==936){Qk=0;dJc(Pm|0,Nm|0,Mm|0)|0;Om=Pm}b[Om+Mm>>0]=0;Mk=ma;zl=f[Mk+4>>2]|0;Sk=oa;f[Sk>>2]=f[Mk>>2];f[Sk+4>>2]=zl;zl=oIa(k,e,g)|0;if(!(f[zl>>2]|0)){Sk=VDc(36)|0;fEc(Sk+16|0,g);Mk=oa;jl=f[Mk+4>>2]|0;Al=Sk+28|0;f[Al>>2]=f[Mk>>2];f[Al+4>>2]=jl;jl=f[e>>2]|0;f[Sk>>2]=0;f[Sk+4>>2]=0;f[Sk+8>>2]=jl;f[zl>>2]=Sk;jl=f[f[k>>2]>>2]|0;if(!jl)Qm=Sk;else{f[k>>2]=jl;Qm=f[zl>>2]|0}laa(f[a>>2]|0,Qm);f[L>>2]=(f[L>>2]|0)+1}if((b[na>>0]|0)<0)YDc(f[g>>2]|0);uT(t);uT(K);if((f[pa>>2]|0)>0){zl=0;do{jl=sIa(k,f[(f[qa>>2]|0)+4+(zl<<2)>>2]|0)|0;if((jl|0)!=(P|0))mGa(c,f[jl+28>>2]|0,f[jl+32>>2]|0,Ok,zl);zl=zl+1|0}while((zl|0)<(f[pa>>2]|0))}}if((b[ga>>0]|0)<0)YDc(f[r>>2]|0);Lk=Lk+1|0;if((Lk|0)>=(R|0))break a}switch(Qk|0){case 35:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,29)|0;N=382186;O=M+29|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,324);break}case 165:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,28)|0;N=382263;O=M+28|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,384);break}case 167:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,29)|0;N=382292;O=M+29|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,385);break}case 183:{dEc(t);break}case 261:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278);break}case 282:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278);break}case 334:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,41)|0;N=382344;O=M+41|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-213,e,390086,381655,426);break}case 416:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,28)|0;N=382399;O=M+28|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,454);break}case 468:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,28)|0;N=382435;O=M+28|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,474);break}case 498:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,28)|0;N=382435;O=M+28|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,483);break}case 550:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,28)|0;N=382399;O=M+28|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,503);break}case 574:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,28)|0;N=382399;O=M+28|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,513);break}case 602:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,28)|0;N=382493;O=M+28|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,528);break}case 608:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278);break}case 615:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,46)|0;N=382522;O=M+46|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,536);break}case 620:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278);break}case 638:{dEc(C);break}case 712:{uT(e);f[e>>2]=0;Rm=e+4|0;f[Rm>>2]=0;Sm=tT(e,56)|0;M=Sm;N=382575;O=M+56|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,547);break}case 713:{uT(e);f[e>>2]=0;Rm=e+4|0;f[Rm>>2]=0;Sm=tT(e,56)|0;M=Sm;N=382575;O=M+56|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,547);break}case 718:{f[e>>2]=0;f[e+4>>2]=0;M=tT(e,23)|0;N=382632;O=M+23|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));z5(-215,e,390086,381655,551);break}case 739:{dEc(B);break}case 819:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278);break}case 841:{dEc(C);break}case 932:{dEc(g);break}}}while(0);xlb(q);HFa(m);m=f[l>>2]|0;if(m|0){while(1){q=f[Q>>2]|0;if((q|0)==(m|0))break;g=q+-8|0;f[Q>>2]=g;uT(g)}YDc(f[l>>2]|0)}xIa(k,f[P>>2]|0);if((b[j+11>>0]|0)>=0){Tm=i+4|0;Um=f[Tm>>2]|0;ZHa(i,Um);Olb(h);u=d;return}YDc(f[j>>2]|0);Tm=i+4|0;Um=f[Tm>>2]|0;ZHa(i,Um);Olb(h);u=d;return}function nIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function oIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function pIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;if((a|0)==(b|0)){u=c;return a|0}i=a+4|0;IFa(a,f[i>>2]|0);j=a+8|0;f[j>>2]=0;f[a>>2]=i;f[i>>2]=0;k=f[b>>2]|0;l=b+4|0;if((k|0)==(l|0)){u=c;return a|0}b=i;i=a+4|0;m=k;while(1){k=m+16|0;f[h>>2]=b;f[d>>2]=f[h>>2];n=SFa(a,d,e,g,k)|0;if(!(f[n>>2]|0)){o=VDc(32)|0;p=f[k>>2]|0;f[o+16>>2]=p;f[o+20>>2]=f[m+20>>2];if(p|0){k=p+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(o+24|0,m+24|0);k=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=k;f[n>>2]=o;k=f[f[a>>2]>>2]|0;if(!k)q=o;else{f[a>>2]=k;q=f[n>>2]|0}laa(f[i>>2]|0,q);f[j>>2]=(f[j>>2]|0)+1}n=f[m+4>>2]|0;if(!n){k=m+8|0;o=f[k>>2]|0;if((f[o>>2]|0)==(m|0))r=o;else{o=k;do{k=f[o>>2]|0;o=k+8|0;p=f[o>>2]|0}while((f[p>>2]|0)!=(k|0));r=p}}else{o=n;while(1){p=f[o>>2]|0;if(!p)break;else o=p}r=o}if((r|0)==(l|0))break;else m=r}u=c;return a|0}function qIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=VDc(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;uT(p);o=Mpc(c)|0;if(o|0)dJc(tT(p,o)|0,c|0,o|0)|0;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=VDc(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;uT(t);b=Mpc(c)|0;if(b|0)dJc(tT(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function rIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e+24|0;j=e;k=a+4|0;l=f[k>>2]|0;do if(l){m=f[c>>2]|0;n=(m|0)==0?1154740:m;o=m;p=k;q=l;a:while(1){r=q;while(1){s=f[r+16>>2]|0;if((s|0)==(m|0))break;if((Ioc((s|0)==0?1154740:s,n)|0)>=0)break;s=f[r+4>>2]|0;if(!s){t=p;break a}else r=s}q=f[r>>2]|0;if(!q){t=r;break}else p=r}if((t|0)==(k|0))v=o;else{p=f[t+16>>2]|0;if((m|0)!=(p|0)?(Ioc(n,(p|0)==0?1154740:p)|0)<=-1:0){v=o;break}p=b[d>>0]|0;f[g>>2]=0;q=VDc(16)|0;s=q+8|0;f[q>>2]=s;f[q+4>>2]=1;f[g+4>>2]=q;q=s;f[q>>2]=p&255;f[q+4>>2]=0;gIa(t+24|0,g)|0;JFa(g);u=e;return d|0}}else v=f[c>>2]|0;while(0);f[i>>2]=v;t=i+4|0;f[t>>2]=f[c+4>>2];if(v|0){c=v+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=b[d>>0]|0;f[j>>2]=0;v=VDc(16)|0;l=v+8|0;f[v>>2]=l;f[v+4>>2]=1;f[j+4>>2]=v;v=l;f[v>>2]=c&255;f[v+4>>2]=0;v=f[i>>2]|0;f[h>>2]=v;c=h+4|0;f[c>>2]=f[t>>2];if(v|0){t=v+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=h+8|0;TFa(t,j);v=f[h>>2]|0;f[g>>2]=v;l=g+4|0;f[l>>2]=f[c>>2];if(v|0){c=v+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=g+8|0;TFa(c,t);v=f[k>>2]|0;b:do if(!v){w=k;x=k}else{q=a+4|0;p=f[g>>2]|0;s=(p|0)==0?1154740:p;y=f[v+16>>2]|0;c:do if((p|0)!=(y|0)){z=q;A=v;B=y;while(1){C=(B|0)==0?1154740:B;if((Ioc(s,C)|0)<0){D=f[A>>2]|0;if(!D){E=24;break}else{F=A;G=D}}else{if((Ioc(C,s)|0)>=0){H=z;I=A;break c}J=A+4|0;C=f[J>>2]|0;if(!C){E=27;break}else{F=J;G=C}}B=f[G+16>>2]|0;if((p|0)==(B|0)){H=F;I=G;break c}else{z=F;A=G}}if((E|0)==24){w=A;x=A;break b}else if((E|0)==27){w=J;x=A;break b}}else{H=q;I=v}while(0);w=H;x=I}while(0);if(!(f[w>>2]|0)){I=VDc(32)|0;H=f[g>>2]|0;f[I+16>>2]=H;f[I+20>>2]=f[l>>2];if(H|0){l=H+-4|0;f[l>>2]=(f[l>>2]|0)+1}TFa(I+24|0,c);f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=x;f[w>>2]=I;x=f[f[a>>2]>>2]|0;if(!x)K=I;else{f[a>>2]=x;K=f[w>>2]|0}laa(f[a+4>>2]|0,K);K=a+8|0;f[K>>2]=(f[K>>2]|0)+1}JFa(c);uT(g);JFa(t);uT(h);JFa(j);uT(i);u=e;return d|0}function sIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function tIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;d=u;u=u+16|0;e=d;g=(c|0)==-1;if(g){h=f[a>>2]|0;switch(h|0){case 0:{i=f[a+4>>2]|0;j=i+4|0;k=i;l=i;m=i;break}case 3:{i=f[a+4>>2]|0;j=i+4|0;k=i;l=i;m=i;break}case 2:{i=f[a+4>>2]|0;j=i+4|0;k=i;l=i;m=i;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}if((f[j>>2]|0)==1){n=h;o=k;q=l;r=m}else s=15}else if((c|0)>-1){m=f[a>>2]|0;switch(m|0){case 0:{l=f[a+4>>2]|0;t=l+4|0;v=l;w=l;x=l;break}case 3:{l=f[a+4>>2]|0;t=l+4|0;v=l;w=l;x=l;break}case 2:{l=f[a+4>>2]|0;t=l+4|0;v=l;w=l;x=l;break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278)}}if((f[t>>2]|0)>(c|0)){n=m;o=v;q=w;r=x}else s=15}else s=15;if((s|0)==15){f[e>>2]=0;f[e+4>>2]=0;y=tT(e,56)|0;z=382656;A=y+56|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,e,382158,451988,142)}s=g?0:c;switch(n|0){case 2:{B=+p[(f[o>>2]|0)+(s<<3)>>3];u=d;return +B}case 0:{o=(f[q>>2]|0)+(s<<3)|0;B=+((f[o>>2]|0)>>>0)+4294967296.0*+(f[o+4>>2]|0);u=d;return +B}case 3:{o=f[(f[r>>2]|0)+(s<<3)>>2]|0;B=+zrc((o|0)==0?1154740:o);u=d;return +B}default:{f[e>>2]=0;f[e+4>>2]=0;y=tT(e,33)|0;z=382713;A=y+33|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,e,382158,451988,159)}}return +(0.0)}function uIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;b=f[c+4>>2]|0;if(!b){d=c+8|0;e=f[d>>2]|0;if((f[e>>2]|0)==(c|0))g=e;else{e=d;do{d=f[e>>2]|0;e=d+8|0;h=f[e>>2]|0}while((f[h>>2]|0)!=(d|0));g=h}}else{e=b;while(1){b=f[e>>2]|0;if(!b)break;else e=b}g=e}if((f[a>>2]|0)==(c|0))f[a>>2]=g;e=a+8|0;f[e>>2]=(f[e>>2]|0)+-1;uHa(f[a+4>>2]|0,c);JFa(c+24|0);uT(c+16|0);YDc(c);return g|0}function vIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d+4|0;g=d;h=a+4|0;i=f[h>>2]|0;if(!i){u=d;return}j=f[b>>2]|0;k=(j|0)==0?1154740:j;l=i;while(1){i=f[l+16>>2]|0;if((j|0)==(i|0))break;m=(i|0)==0?1154740:i;if((Ioc(k,m)|0)<0)n=l;else{if((Ioc(m,k)|0)>=0)break;n=l+4|0}l=f[n>>2]|0;if(!l){o=21;break}}if((o|0)==21){u=d;return}bIa(a,c,lIa(a,b)|0)|0;c=f[h>>2]|0;do if(c|0){o=f[b>>2]|0;l=(o|0)==0?1154740:o;n=h;k=c;a:while(1){j=k;while(1){m=f[j+16>>2]|0;if((m|0)==(o|0))break;if((Ioc((m|0)==0?1154740:m,l)|0)>=0)break;m=f[j+4>>2]|0;if(!m){p=n;break a}else j=m}k=f[j>>2]|0;if(!k){p=j;break}else n=j}if((p|0)!=(h|0)){n=f[p+16>>2]|0;if((o|0)!=(n|0)?(Ioc(l,(n|0)==0?1154740:n)|0)<0:0)break;f[g>>2]=p;f[e>>2]=f[g>>2];uIa(a,e)|0}}while(0);u=d;return}function wIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a>>2]|0;e=d;g=(f[b>>2]|0)-e|0;b=d+(g>>2<<2)|0;h=a+4|0;i=f[h>>2]|0;j=a+8|0;k=f[j>>2]|0;l=i;m=k;if(i>>>0<k>>>0){if((b|0)==(i|0)){f[b>>2]=f[c>>2];f[h>>2]=b+4;n=b;return n|0}k=l-(b+4)|0;o=k>>2;p=b+(o<<2)|0;if(p>>>0<i>>>0){q=(i+(0-o<<2)+~b|0)>>>2;r=p;p=i;while(1){f[p>>2]=f[r>>2];r=r+4|0;if(r>>>0>=i>>>0)break;else p=p+4|0}f[h>>2]=i+(q+1<<2)}if(o|0)fJc(i+(0-o<<2)|0,b|0,k|0)|0;if(b>>>0>c>>>0)s=c;else s=(f[h>>2]|0)>>>0>c>>>0?c+4|0:c;f[b>>2]=f[s>>2];n=b;return n|0}s=(l-e>>2)+1|0;if(s>>>0>1073741823)mCc(a);l=m-e|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<s>>>0?s:e):1073741823;e=b;s=g>>2;do if(m)if(m>>>0>1073741823){l=af(8)|0;bEc(l,503977);f[l>>2]=185532;ig(l|0,23696,1627)}else{l=VDc(m<<2)|0;t=l;u=l;break}else{t=0;u=0}while(0);l=t+(s<<2)|0;k=l;o=t+(m<<2)|0;do if((s|0)==(m|0)){if((g|0)>0){i=l+(((m+1|0)/-2|0)<<2)|0;v=o;w=i;x=i;y=d;break}i=m<<2>>1;q=(i|0)==0?1:i;if(q>>>0>1073741823){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}i=VDc(q<<2)|0;p=i+(q>>>2<<2)|0;r=p;z=i+(q<<2)|0;if(!t){v=z;w=r;x=p;y=d}else{YDc(u);v=z;w=r;x=p;y=f[a>>2]|0}}else{v=o;w=k;x=l;y=d}while(0);f[x>>2]=f[c>>2];c=x+4|0;x=w;w=e-y|0;d=x+(0-(w>>2)<<2)|0;if((w|0)>0)dJc(d|0,y|0,w|0)|0;w=(f[h>>2]|0)-e|0;if((w|0)>0){dJc(c|0,b|0,w|0)|0;A=c+(w>>>2<<2)|0}else A=c;c=f[a>>2]|0;f[a>>2]=d;f[h>>2]=A;f[j>>2]=v;if(!c){n=x;return n|0}YDc(c);n=x;return n|0}function xIa(a,c){a=a|0;c=c|0;if(!c)return;xIa(a,f[c>>2]|0);xIa(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function yIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+96|0;d=c;e=c+88|0;g=f[b>>2]|0;zIa(d,(g|0)==0?1154740:g);tFa(a);g=f[a>>2]|0;f[e>>2]=g;f[e+4>>2]=f[a+4>>2];if(g|0){a=g+4|0;f[a>>2]=(f[a>>2]|0)+1}mIa(d,e);fGa(e);ukb(d);u=c;return}function zIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+208|0;e=d+8|0;g=d;imb(a);h=e+112|0;i=e+8|0;f[i>>2]=78016;j=e+12|0;f[e>>2]=14284;f[h>>2]=14304;f[e+4>>2]=0;auc(e+112|0,j);f[e+184>>2]=0;f[e+188>>2]=-1;f[e>>2]=77996;f[h>>2]=78036;f[i>>2]=78016;AIa(j);i=e+76|0;if((f[i>>2]|0)==0?(k=yqc(c,429489)|0,f[i>>2]=k,(k|0)!=0):0)f[e+100>>2]=12;else{k=e+(f[(f[e>>2]|0)+-12>>2]|0)|0;$tc(k,f[k+16>>2]|4)}if(bhc(a,e)|0){f[e>>2]=77996;f[h>>2]=78036;f[e+8>>2]=78016;BIa(j);Ytc(e,78048);Lsc(h);u=d;return}else{f[g>>2]=0;f[g+4>>2]=0;d=tT(g,26)|0;h=382747;e=d+26|0;do{b[d>>0]=b[h>>0]|0;d=d+1|0;h=h+1|0}while((d|0)<(e|0));z5(-210,g,382774,381655,56)}}function AIa(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;e=c;fuc(a);f[a>>2]=78092;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;g=a+52|0;h=a+68|0;i=a+98|0;j=g;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d[g+44>>1]=0;b[g+46>>0]=0;g=a+4|0;JDc(e,g);j=MDc(e,887032)|0;Ivc(e);if(!j){l=f[a>>2]|0;m=l+12|0;n=f[m>>2]|0;hj[n&511](a,0,4096)|0;u=c;return}JDc(e,g);g=Hvc(e,887032)|0;f[h>>2]=g;Ivc(e);e=f[h>>2]|0;h=(_i[f[(f[e>>2]|0)+28>>2]&1023](e)|0)&1;b[i>>0]=h;l=f[a>>2]|0;m=l+12|0;n=f[m>>2]|0;hj[n&511](a,0,4096)|0;u=c;return}function BIa(a){a=a|0;var c=0,d=0;f[a>>2]=78092;c=a+64|0;d=f[c>>2]|0;if(d|0?(CIa(a)|0,(_pc(d)|0)==0):0)f[c>>2]=0;if(b[a+96>>0]|0?(c=f[a+32>>2]|0,c|0):0)ZDc(c);if(b[a+97>>0]|0?(c=f[a+56>>2]|0,c|0):0)ZDc(c);Qsc(a);return}function CIa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;e=a+64|0;if(!(f[e>>2]|0)){g=0;u=c;return g|0}h=a+68|0;i=f[h>>2]|0;if(!i){j=af(4)|0;KFc(j);ig(j|0,23728,1631)}j=a+92|0;k=f[j>>2]|0;do if(!(k&16)){if(k&8|0){l=a+80|0;m=f[l+4>>2]|0;n=d;f[n>>2]=f[l>>2];f[n+4>>2]=m;do if(!(b[a+98>>0]|0)){m=_i[f[(f[i>>2]|0)+24>>2]&1023](i)|0;n=a+36|0;l=f[n>>2]|0;o=(f[a+40>>2]|0)-l|0;if((m|0)>0){p=0;q=(Y((f[a+16>>2]|0)-(f[a+12>>2]|0)|0,m)|0)+o|0;break}m=f[a+12>>2]|0;if((m|0)==(f[a+16>>2]|0)){p=0;q=o}else{r=f[h>>2]|0;s=a+32|0;t=_h[f[(f[r>>2]|0)+32>>2]&127](r,d,f[s>>2]|0,l,m-(f[a+8>>2]|0)|0)|0;p=1;q=o-t+(f[n>>2]|0)-(f[s>>2]|0)|0}}else{p=0;q=(f[a+16>>2]|0)-(f[a+12>>2]|0)|0}while(0);if(uqc(f[e>>2]|0,0-q|0,1)|0){g=-1;u=c;return g|0}if(p){s=d;n=f[s+4>>2]|0;t=a+72|0;f[t>>2]=f[s>>2];f[t+4>>2]=n}n=f[a+32>>2]|0;f[a+40>>2]=n;f[a+36>>2]=n;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[j>>2]=0}}else{if((f[a+24>>2]|0)!=(f[a+20>>2]|0)?(Mi[f[(f[a>>2]|0)+52>>2]&1023](a,-1)|0)==-1:0){g=-1;u=c;return g|0}n=a+72|0;t=a+32|0;s=a+52|0;a:while(1){o=f[h>>2]|0;m=f[t>>2]|0;l=_h[f[(f[o>>2]|0)+20>>2]&127](o,n,m,m+(f[s>>2]|0)|0,d)|0;m=f[t>>2]|0;o=(f[d>>2]|0)-m|0;if((Npc(m,1,o,f[e>>2]|0)|0)!=(o|0)){g=-1;v=24;break}switch(l|0){case 1:break;case 2:{g=-1;v=24;break a;break}default:{v=10;break a}}}if((v|0)==10){if(!(aqc(f[e>>2]|0)|0))break;else g=-1;u=c;return g|0}else if((v|0)==24){u=c;return g|0}}while(0);g=0;u=c;return g|0}function DIa(a){a=a|0;BIa(a);YDc(a);return}function EIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;_i[f[(f[a>>2]|0)+24>>2]&1023](a)|0;d=Hvc(c,887032)|0;f[a+68>>2]=d;c=a+98|0;e=b[c>>0]|0;g=_i[f[(f[d>>2]|0)+28>>2]&1023](d)|0;b[c>>0]=g&1;if((e&255|0)==(g&1|0))return;e=a+8|0;c=a+96|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;e=(b[c>>0]|0)!=0;if(g){g=a+32|0;if(e?(d=f[g>>2]|0,d|0):0)ZDc(d);d=a+97|0;b[c>>0]=b[d>>0]|0;h=a+60|0;f[a+52>>2]=f[h>>2];i=a+56|0;f[g>>2]=f[i>>2];f[h>>2]=0;f[i>>2]=0;b[d>>0]=0;return}d=f[a+52>>2]|0;f[a+60>>2]=d;if(!e?(e=a+32|0,i=f[e>>2]|0,(i|0)!=(a+44|0)):0){f[a+56>>2]=i;b[a+97>>0]=0;i=XDc(d)|0;f[e>>2]=i;b[c>>0]=1;return}c=XDc(d)|0;f[a+56>>2]=c;b[a+97>>0]=1;return}function FIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=a+8|0;g=a+96|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;if(b[g>>0]|0?(e=f[a+32>>2]|0,e|0):0)ZDc(e);e=a+97|0;if(b[e>>0]|0?(h=f[a+56>>2]|0,h|0):0)ZDc(h);h=a+52|0;f[h>>2]=d;if(d>>>0>8){i=b[a+98>>0]|0;if((c|0)!=0&i<<24>>24!=0){j=0;k=c}else{j=1;k=XDc(d)|0}f[a+32>>2]=k;l=j;m=i}else{f[a+32>>2]=a+44;f[h>>2]=8;l=0;m=b[a+98>>0]|0}b[g>>0]=l;if(m<<24>>24){f[a+60>>2]=0;n=0;o=0;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}m=(d|0)>8?d:8;f[a+60>>2]=m;if((c|0)!=0&m>>>0>7){n=0;o=c;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}n=1;o=XDc(m)|0;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}function GIa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=f[b+68>>2]|0;if(!g){h=af(4)|0;KFc(h);ig(h|0,23728,1631)}h=_i[f[(f[g>>2]|0)+24>>2]&1023](g)|0;g=b+64|0;if((((f[g>>2]|0)!=0?!(((c|0)!=0|(d|0)!=0)&(h|0)<1):0)?e>>>0<3&(_i[f[(f[b>>2]|0)+24>>2]&1023](b)|0)==0:0)?(i=f[g>>2]|0,j=mJc(h|0,((h|0)<0)<<31>>31|0,c|0,d|0)|0,(uqc(i,(h|0)>0?j:0,e)|0)==0):0){e=Spc(f[g>>2]|0)|0;g=b+72|0;k=f[g>>2]|0;l=f[g+4>>2]|0;m=e;n=((e|0)<0)<<31>>31}else{k=0;l=0;m=-1;n=-1}e=a;f[e>>2]=k;f[e+4>>2]=l;l=a+8|0;f[l>>2]=m;f[l+4>>2]=n;return}function HIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;d=b+64|0;if(f[d>>2]|0?(_i[f[(f[b>>2]|0)+24>>2]&1023](b)|0)==0:0)if(!(uqc(f[d>>2]|0,f[c+8>>2]|0,0)|0)){d=c;e=f[d+4>>2]|0;g=b+72|0;f[g>>2]=f[d>>2];f[g+4>>2]=e;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];return}else{c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=-1;f[c+4>>2]=-1;return}c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=-1;f[c+4>>2]=-1;return}function IIa(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=u;u=u+16|0;d=c+4|0;e=c;g=a+64|0;if(!(f[g>>2]|0)){i=-1;u=c;return i|0}j=a+92|0;if(!(f[j>>2]&8)){f[a+24>>2]=0;f[a+20>>2]=0;f[a+28>>2]=0;k=(b[a+98>>0]|0)==0;l=f[(k?a+56|0:a+32|0)>>2]|0;m=l+(f[(k?a+60|0:a+52|0)>>2]|0)|0;f[a+8>>2]=l;l=a+12|0;f[l>>2]=m;f[a+16>>2]=m;f[j>>2]=8;n=1;o=l;p=m}else{m=a+12|0;n=0;o=m;p=f[m>>2]|0}if(!p){m=d+1|0;f[a+8>>2]=d;f[o>>2]=m;f[a+16>>2]=m;q=m}else q=p;p=a+16|0;if(n){r=f[p>>2]|0;s=0}else{n=f[p>>2]|0;m=(n-(f[a+8>>2]|0)|0)/2|0;r=n;s=m>>>0<4?m:4}do if((q|0)==(r|0)){m=a+8|0;fJc(f[m>>2]|0,q+(0-s)|0,s|0)|0;if(b[a+98>>0]|0){n=f[m>>2]|0;l=Qpc(n+s|0,1,(f[p>>2]|0)-s-n|0,f[g>>2]|0)|0;if(!l){t=-1;v=m;break}n=(f[m>>2]|0)+s|0;f[o>>2]=n;f[p>>2]=n+l;t=h[n>>0]|0;v=m;break}n=a+40|0;l=f[n>>2]|0;j=a+36|0;k=f[j>>2]|0;w=l;x=k;if((l|0)==(k|0)){y=a+32|0;z=x;A=w}else{l=a+32|0;fJc(f[l>>2]|0,k|0,w-x|0)|0;y=l;z=f[j>>2]|0;A=f[n>>2]|0}l=f[y>>2]|0;x=l+(A-z)|0;f[j>>2]=x;if((l|0)==(a+44|0))B=8;else B=f[a+52>>2]|0;w=l+B|0;f[n>>2]=w;l=a+60|0;k=(f[l>>2]|0)-s|0;C=w-x|0;w=a+72|0;D=w;E=f[D+4>>2]|0;F=a+80|0;f[F>>2]=f[D>>2];f[F+4>>2]=E;E=Qpc(x,1,C>>>0<k>>>0?C:k,f[g>>2]|0)|0;if(!E){t=-1;v=m}else{k=f[a+68>>2]|0;if(!k){C=af(4)|0;KFc(C);ig(C|0,23728,1631)}C=(f[j>>2]|0)+E|0;f[n>>2]=C;E=f[m>>2]|0;if((Ij[f[(f[k>>2]|0)+16>>2]&15](k,w,f[y>>2]|0,C,j,E+s|0,E+(f[l>>2]|0)|0,e)|0)!=3){l=f[e>>2]|0;E=(f[m>>2]|0)+s|0;if((l|0)==(E|0))G=-1;else{H=l;I=E;J=25}}else{E=f[y>>2]|0;l=f[n>>2]|0;f[m>>2]=E;H=l;I=E;J=25}if((J|0)==25){f[o>>2]=I;f[p>>2]=H;G=h[I>>0]|0}t=G;v=m}}else{t=h[q>>0]|0;v=a+8|0}while(0);if((f[v>>2]|0)==(d|0)){f[v>>2]=0;f[o>>2]=0;f[p>>2]=0}i=t;u=c;return i|0}function JIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+64>>2]|0)){d=-1;return d|0}e=a+12|0;g=f[e>>2]|0;if((f[a+8>>2]|0)>>>0>=g>>>0){d=-1;return d|0}if((c|0)==-1){f[e>>2]=g+-1;d=0;return d|0}if(!(f[a+88>>2]&16)){a=c&255;h=g+-1|0;if(a<<24>>24==(b[h>>0]|0)){i=a;j=h}else{d=-1;return d|0}}else{i=c&255;j=g+-1|0}f[e>>2]=j;b[j>>0]=i;d=c;return d|0}function KIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+16|0;e=d+8|0;g=d+4|0;h=d;i=a+64|0;if(!(f[i>>2]|0)){j=-1;u=d;return j|0}k=a+92|0;if(!(f[k>>2]&16)){f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;l=f[a+52>>2]|0;do if(l>>>0>8)if(!(b[a+98>>0]|0)){m=f[a+56>>2]|0;n=m+((f[a+60>>2]|0)+-1)|0;o=m;break}else{m=f[a+32>>2]|0;n=m+(l+-1)|0;o=m;break}else{n=0;o=0}while(0);f[a+24>>2]=o;l=a+20|0;f[l>>2]=o;m=a+28|0;f[m>>2]=n;f[k>>2]=16;p=l;q=m;r=m;s=l;t=o;v=n;w=o}else{o=a+20|0;n=f[o>>2]|0;l=a+28|0;p=o;q=l;r=l;s=o;t=n;v=f[l>>2]|0;w=n}n=(c|0)==-1;l=a+24|0;o=f[l>>2]|0;if(n){x=o;y=w}else{if(!o){f[l>>2]=e;f[s>>2]=e;f[q>>2]=e+1;z=e}else z=o;b[z>>0]=c;z=(f[l>>2]|0)+1|0;f[l>>2]=z;x=z;y=f[s>>2]|0}a:do if((x|0)==(y|0))A=32;else{b:do if(!(b[a+98>>0]|0)){z=a+32|0;o=f[z>>2]|0;f[g>>2]=o;e=a+68|0;w=f[e>>2]|0;if(!w){B=af(4)|0;KFc(B);ig(B|0,23728,1631)}m=o;o=a+72|0;k=a+52|0;C=Ij[f[(f[w>>2]|0)+12>>2]&15](w,o,y,x,h,m,m+(f[k>>2]|0)|0,g)|0;m=f[s>>2]|0;c:do if((f[h>>2]|0)!=(m|0)){w=C;D=m;while(1){if((w|0)==3){A=21;break}if((w|1|0)!=1)break c;E=f[z>>2]|0;F=(f[g>>2]|0)-E|0;if((Npc(E,1,F,f[i>>2]|0)|0)!=(F|0))break c;if((w|0)!=1){A=28;break}F=f[h>>2]|0;E=f[l>>2]|0;f[p>>2]=F;f[q>>2]=E;G=F;H=G+(E-F)|0;f[l>>2]=H;F=f[e>>2]|0;if(!F){A=19;break}E=f[z>>2]|0;w=Ij[f[(f[F>>2]|0)+12>>2]&15](F,o,G,H,h,E,E+(f[k>>2]|0)|0,g)|0;E=f[s>>2]|0;if((f[h>>2]|0)==(E|0))break c;else D=E}if((A|0)==19){B=af(4)|0;KFc(B);ig(B|0,23728,1631)}else if((A|0)==21){w=(f[l>>2]|0)-D|0;if((Npc(D,1,w,f[i>>2]|0)|0)!=(w|0))break}I=l;break b}while(0);J=-1;break a}else{k=x-y|0;if((Npc(y,1,k,f[i>>2]|0)|0)!=(k|0)){J=-1;break a}I=l}while(0);f[I>>2]=t;f[p>>2]=t;f[r>>2]=v;A=32}while(0);if((A|0)==32)J=n?0:c;j=J;u=d;return j|0}function LIa(a){a=a|0;var b=0;f[a>>2]=77996;b=a+112|0;f[b>>2]=78036;f[a+8>>2]=78016;BIa(a+12|0);Ytc(a,78048);Lsc(b);return}function MIa(a){a=a|0;var b=0;f[a>>2]=77996;b=a+112|0;f[b>>2]=78036;f[a+8>>2]=78016;BIa(a+12|0);Ytc(a,78048);Lsc(b);YDc(a);return}function NIa(a){a=a|0;var b=0;b=a+-8|0;f[b>>2]=77996;a=b+112|0;f[a>>2]=78036;f[b+8>>2]=78016;BIa(b+12|0);Ytc(b,78048);Lsc(a);return}function OIa(a){a=a|0;MIa(a+-8|0);return}function PIa(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[b>>2]=77996;a=b+112|0;f[a>>2]=78036;f[b+8>>2]=78016;BIa(b+12|0);Ytc(b,78048);Lsc(a);return}function QIa(a){a=a|0;MIa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function RIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+112|0;g=e+8|0;h=e;i=f[c>>2]|0;c=(i|0)==0?1154740:i;i=f[d>>2]|0;d=(i|0)==0?1154740:i;aRa(g);i=g+40|0;aRa(i);f[g+80>>2]=0;j=g+84|0;f[j>>2]=0;f[g+88>>2]=0;if(b[c>>0]|0)$Ja(c,g);if(b[d>>0]|0)dKa(d,i);tFa(a);d=f[a>>2]|0;f[h>>2]=d;f[h+4>>2]=f[a+4>>2];if(d|0){a=d+4|0;f[a>>2]=(f[a>>2]|0)+1}SIa(g,h);fGa(h);h=g+80|0;a=f[h>>2]|0;if(!a){mPa(i);mPa(g);u=e;return}while(1){d=f[j>>2]|0;if((d|0)==(a|0))break;c=d+-8|0;f[j>>2]=c;uT(c)}YDc(f[h>>2]|0);mPa(i);mPa(g);u=e;return}
function m5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+688|0;e=d+656|0;g=d+652|0;h=d+152|0;i=d+16|0;j=d+664|0;k=d+144|0;l=d+8|0;m=d;f[g>>2]=c;f[k>>2]=0;f[k+4>>2]=0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];q1(a,b,6,233284,e);b=Q0(c,i)|0;f[l>>2]=0;f[l+4>>2]=0;f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];q1(a,233301,13,0,e);w1(a,i,b,233307);r1(a);u1(a,233309,Y8(P0(c)|0,j)|0,0);f[m>>2]=0;f[m+4>>2]=0;f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];q1(a,391200,13,0,e);if((f[c+20>>2]|0)<=0){r1(a);r1(a);u=d;return}if(!(f[c+16>>2]|0)){r1(a);r1(a);u=d;return}E0(1,g,0,d+376|0,h,0)|0;g=h+16|0;c=h+8|0;do w1(a,f[g>>2]|0,f[c>>2]|0,j);while((H0(h)|0)!=0);r1(a);r1(a);u=d;return}function n5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,233527,d);return}function o5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[c>>2]|0;c=f[a>>2]|0;a=f[b>>2]|0;if((d|0)>0)e=0;else{g=0;return g|0}while(1){b=(f[c+(e<<2)>>2]|0)-(f[a+(e<<2)>>2]|0)|0;e=e+1|0;if(b|0){g=b;h=4;break}if((e|0)>=(d|0)){g=0;h=4;break}}if((h|0)==4)return g|0;return 0}function p5(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+32|0;i=h+8|0;j=h;k=h+16|0;l=m1(d,c)|0;if(l|0){c=_8(l,e)|0;if((c|0)==(f[a+28>>2]|0)){m=l;u=h;return m|0}else{f[k>>2]=0;f[k+4>>2]=0;n=tT(k,71)|0;o=234201;p=n+71|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-209,k,234273,595)}}l=f[a>>2]|0;c=l&4095;d=f[a+28>>2]|0;if((c|0)!=0|(d|0)==1){if(((l>>>3&511)+1<<(47696>>>(l<<1&14)&3)|0)!=(d|0)){f[k>>2]=0;f[k+4>>2]=0;n=tT(k,68)|0;o=234286;p=n+68|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));n5(-209,k,234273,601)}m=Y8(c,g)|0;u=h;return m|0}if((d|0)<=(e|0)){m=0;u=h;return m|0}c=d-e|0;if(!(c&3)){f[j>>2]=c>>>2;Aqc(g,234176,j)|0;m=g;u=h;return m|0}else{f[i>>2]=c;Aqc(g,234180,i)|0;m=g;u=h;return m|0}return 0}function q5(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+176|0;h=g+40|0;i=g+8|0;j=g;k=g+48|0;l=g+32|0;m=g+24|0;n=g+16|0;o=m1(d,234066)|0;do if(!o){d=f[c+4>>2]|0;if((d|0)<=(e|0)){u=g;return}p=f[c>>2]|0;if(((p&-65536|0)==1117323264?(d|0)==88&(p&4094|0)==12:0)?(f[c+28>>2]|0)==8:0){f[l>>2]=0;f[l+4>>2]=0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];q1(a,466640,14,0,h);s1(a,443329,f[c+56>>2]|0);s1(a,233745,f[c+60>>2]|0);s1(a,467281,f[c+64>>2]|0);s1(a,467287,f[c+68>>2]|0);r1(a);s1(a,234170,f[c+72>>2]|0);u=g;return}if((p&-53248|0)==1117327360?((p&4095|0)==0?(f[c+28>>2]|0)==1:0):0){f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=f[m>>2];f[h+4>>2]=f[m+4>>2];q1(a,233708,14,0,h);s1(a,443329,f[c+56>>2]|0);s1(a,233745,f[c+60>>2]|0);r1(a);u=g;return}p=d-e|0;if(!(p&3)){f[j>>2]=p>>>2;Aqc(k,234176,j)|0;q=k;break}else{f[i>>2]=p;Aqc(k,234180,i)|0;q=k;break}}else{p=_8(o,e)|0;if((p|0)>(f[c+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;p=tT(h,74)|0;d=234076;r=p+74|0;do{b[p>>0]=b[d>>0]|0;p=p+1|0;d=d+1|0}while((p|0)<(r|0));n5(-209,h,234151,533)}else q=o}while(0);u1(a,234066,q,0);f[n>>2]=0;f[n+4>>2]=0;f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];q1(a,234184,13,0,h);w1(a,c+56|0,1,q);r1(a);u=g;return}function r5(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+288|0;j=i+24|0;k=i;f[k>>2]=e;f[k+4>>2]=g;g=i+160|0;e=i+16|0;l=i+8|0;f[e>>2]=0;f[e+4>>2]=0;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];q1(a,c,6,233186,j);if((h|0)>-1)s1(a,234838,h);h=p5(d,233309,k,0,i+32|0)|0;b[g>>0]=0;c=f[d>>2]|0;if(c&16384|0){e=g+(Mpc(g)|0)|0;m=e;b[m>>0]=32;b[m+1>>0]=99;b[m+2>>0]=108;b[m+3>>0]=111;m=e+4|0;b[m>>0]=115;b[m+1>>0]=101;b[m+2>>0]=100;b[m+3>>0]=0}if(c&32768|0){m=g+(Mpc(g)|0)|0;b[m>>0]=b[234911]|0;b[m+1>>0]=b[234912]|0;b[m+2>>0]=b[234913]|0;b[m+3>>0]=b[234914]|0;b[m+4>>0]=b[234915]|0;b[m+5>>0]=b[234916]|0}if((c&12288|0)==4096){m=g+(Mpc(g)|0)|0;b[m>>0]=b[234917]|0;b[m+1>>0]=b[234918]|0;b[m+2>>0]=b[234919]|0;b[m+3>>0]=b[234920]|0;b[m+4>>0]=b[234921]|0;b[m+5>>0]=b[234922]|0;b[m+6>>0]=b[234923]|0}if((c&4095|0)==0?(f[d+28>>2]|0)!=1:0){c=g+(Mpc(g)|0)|0;m=234924;e=c+9|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(e|0))}u1(a,233997,g+((b[g>>0]|0)!=0&1)|0,1);s1(a,234933,f[d+24>>2]|0);u1(a,233309,h,0);q5(a,d,k,56);f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];q1(a,391200,13,0,j);j=d+52|0;d=f[j>>2]|0;if(!d){r1(a);r1(a);u=i;return}else n=d;while(1){w1(a,f[n+16>>2]|0,f[n+12>>2]|0,h);if((n|0)==(f[f[j>>2]>>2]|0)){o=15;break}n=f[n+4>>2]|0;if(!n){o=15;break}}if((o|0)==15){r1(a);r1(a);u=i;return}}function s5(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+48|0;j=i;f[j>>2]=0;f[j+4>>2]=40;f[j+16>>2]=b;f[j+12>>2]=0;f[j+8>>2]=0;f[j+20>>2]=c;f[j+24>>2]=d;f[j+36>>2]=h;f[j+28>>2]=e;f[j+32>>2]=g;A1(j);f[a>>2]=f[132940];u=i;return}function t5(a){a=a|0;f[a>>2]=46284;uT(a+32|0);uT(a+24|0);uT(a+16|0);uT(a+4|0);return}function u5(a){a=a|0;t5(a);YDc(a);return}function v5(a){a=a|0;var b=0;b=f[a+4>>2]|0;return ((b|0)==0?1154740:b)|0}function w5(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=46304;if((f[a+4>>2]|0)==-1){u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;c=tT(d,10)|0;a=235178;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));y5(-215,d,235189,1567)}}function x5(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=46304;if((f[a+4>>2]|0)==-1){YDc(a);u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;c=tT(d,10)|0;a=235178;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));y5(-215,d,235189,1567)}}function y5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,235207,d);return}function z5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+64|0;h=g+16|0;i=g+8|0;j=g;f[i>>2]=0;f[i+4>>2]=0;if(c|0?(g=Mpc(c)|0,g|0):0)dJc(tT(i,g)|0,c|0,g|0)|0;f[j>>2]=0;f[j+4>>2]=0;if(d|0?(g=Mpc(d)|0,g|0):0)dJc(tT(j,g)|0,d|0,g|0)|0;A5(h,a,b,i,j,e);B5(h)}function A5(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;f[a>>2]=46284;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=b;b=f[c>>2]|0;f[a+16>>2]=b;f[a+20>>2]=f[c+4>>2];if(b|0){c=b+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[d>>2]|0;f[a+24>>2]=c;f[a+28>>2]=f[d+4>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[e>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[e+4>>2];if(!d){h=a+40|0;f[h>>2]=g;E5(a);return}e=d+-4|0;f[e>>2]=(f[e>>2]|0)+1;h=a+40|0;f[h>>2]=g;E5(a);return}function B5(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+4144|0;d=c+32|0;e=c+8|0;g=c;h=c+40|0;c=f[132950]|0;if(!c){if(b[1149318]|0){i=f[a+12>>2]|0;do switch(i|0){case 0:{j=236079;break}case -1:{j=236069;break}case -2:{j=236051;break}case -3:{j=284827;break}case -4:{j=236031;break}case -5:{j=236018;break}case -7:{j=235991;break}case -8:{j=235976;break}case -201:{j=235946;break}case -27:{j=235933;break}case -202:{j=235907;break}case -13:{j=235887;break}case -203:{j=235852;break}case -204:{j=235821;break}case -17:{j=235774;break}case -205:{j=235734;break}case -209:{j=235696;break}case -211:{j=235655;break}case -210:{j=235610;break}case -24:{j=235583;break}case -15:{j=235560;break}case -206:{j=235520;break}case -207:{j=235490;break}case -208:{j=235464;break}case -212:{j=235450;break}case -213:{j=235410;break}case -214:{j=235378;break}case -215:{j=235361;break}case -216:{j=235345;break}case -217:{j=235332;break}case -218:{j=235314;break}case -219:{j=235298;break}default:{f[g>>2]=(i|0)>-1?235272:508586;f[g+4>>2]=i;Aqc(1149319,235279,g)|0;j=1149319}}while(0);g=f[a+16>>2]|0;if(!(f[a+28>>2]|0))k=236088;else{i=f[a+24>>2]|0;k=(i|0)==0?1154740:i}i=f[a+32>>2]|0;l=f[a+40>>2]|0;f[e>>2]=236155;f[e+4>>2]=j;f[e+8>>2]=(g|0)==0?1154740:g;f[e+12>>2]=k;f[e+16>>2]=(i|0)==0?1154740:i;f[e+20>>2]=l;C5(h,4096,236105,e)|0;aqc(f[44475]|0)|0;e=f[44350]|0;aqc(e)|0;f[d>>2]=h;eqc(e,236165,d)|0;aqc(e)|0}}else{e=f[a+24>>2]|0;d=f[a+16>>2]|0;h=f[a+32>>2]|0;xg[c&127](f[a+12>>2]|0,(e|0)==0?1154740:e,(d|0)==0?1154740:d,(h|0)==0?1154740:h,f[a+40>>2]|0,f[132951]|0)|0}if(!(b[1149575]|0)){m=af(44)|0;D5(m,a);ig(m|0,7776,73)}f[0]=0;aa();m=af(44)|0;D5(m,a);ig(m|0,7776,73)}function C5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=Opc(a,b,c,g)|0;u=e;return d|0}function D5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=46284;c=f[b+4>>2]|0;f[a+4>>2]=c;f[a+8>>2]=f[b+8>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}f[a+12>>2]=f[b+12>>2];d=f[b+16>>2]|0;f[a+16>>2]=d;f[a+20>>2]=f[b+20>>2];if(d|0){c=d+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[b+24>>2]|0;f[a+24>>2]=c;f[a+28>>2]=f[b+28>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[b+32>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[b+36>>2];if(!d){e=a+40|0;g=b+40|0;h=f[g>>2]|0;f[e>>2]=h;return}c=d+-4|0;f[c>>2]=(f[c>>2]|0)+1;e=a+40|0;g=b+40|0;h=f[g>>2]|0;f[e>>2]=h;return}function E5(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=u;u=u+288|0;d=c+88|0;e=c+80|0;g=c+48|0;h=c+40|0;i=c+8|0;j=c;k=c+272|0;l=c+128|0;m=c+120|0;n=a+16|0;o=a+20|0;p=f[o>>2]|0;a:do if((p|0)!=0?(q=f[n>>2]|0,r=q+p+-1|0,s=q,q>>>0<=r>>>0):0){t=q;while(1){if((b[t>>0]|0)==10)break;q=t+1|0;if(q>>>0>r>>>0){v=0;break a}else t=q}r=t-s|0;if((r|0)!=-1){q=l+64|0;w=l+8|0;f[w>>2]=45704;x=l+12|0;f[l>>2]=6980;f[q>>2]=7e3;f[l+4>>2]=0;auc(l+64|0,x);f[l+136>>2]=0;f[l+140>>2]=-1;f[l>>2]=45684;f[q>>2]=45724;f[w>>2]=45704;fuc(x);f[x>>2]=45740;w=l+44|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[l+60>>2]=24;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;G1(x,k);if((b[k+11>>0]|0)<0)YDc(f[k>>2]|0);w=l+8|0;q=m+4|0;y=0;z=r;b:do{r=H1(w,236169,2)|0;A=z-y|0;f[m>>2]=0;f[q>>2]=0;B=f[o>>2]|0;C=B>>>0<y>>>0?B:y;D=B-C|0;E=D>>>0>A>>>0?A:D;do if(E)if((E|0)==(B|0)){D=(f[n>>2]|0)+-4|0;f[D>>2]=(f[D>>2]|0)+1;D=f[n>>2]|0;f[m>>2]=D;f[q>>2]=f[o>>2];F=D;break}else{D=tT(m,E)|0;dJc(D|0,(f[n>>2]|0)+C|0,E|0)|0;F=f[m>>2]|0;break}else F=0;while(0);E=(F|0)==0?1154740:F;C=H1(r,E,Mpc(E)|0)|0;cuc(k,C+(f[(f[C>>2]|0)+-12>>2]|0)|0);E=Hvc(k,885240)|0;B=Mi[f[(f[E>>2]|0)+28>>2]&1023](E,10)|0;Ivc(k);wuc(C,B)|0;iuc(C)|0;uT(m);y=z+1|0;C=f[o>>2]|0;if((z+2|0)>>>0>C>>>0)break;B=f[n>>2]|0;E=B+C+-1|0;C=B+y|0;D=B;if(C>>>0>E>>>0)break;else G=C;while(1){if((b[G>>0]|0)==10)break;C=G+1|0;if(C>>>0>E>>>0)break b;else G=C}z=G-D|0}while((z|0)!=-1);z=H1(w,236169,2)|0;f[k>>2]=0;q=k+4|0;f[q>>2]=0;s=f[o>>2]|0;t=s>>>0<y>>>0?s:y;E=s-t|0;do if(E)if(!t){s=(f[n>>2]|0)+-4|0;f[s>>2]=(f[s>>2]|0)+1;s=f[n>>2]|0;f[k>>2]=s;f[q>>2]=f[o>>2];H=s;break}else{s=tT(k,E)|0;dJc(s|0,(f[n>>2]|0)+t|0,E|0)|0;H=f[k>>2]|0;break}else H=0;while(0);E=(H|0)==0?1154740:H;H1(z,E,Mpc(E)|0)|0;uT(k);if((b[(f[n>>2]|0)+((f[o>>2]|0)+-1)>>0]|0)!=10){cuc(k,w+(f[(f[w>>2]|0)+-12>>2]|0)|0);E=Hvc(k,885240)|0;t=Mi[f[(f[E>>2]|0)+28>>2]&1023](E,10)|0;Ivc(k);wuc(w,t)|0;iuc(w)|0}I1(k,x);uT(n);t=k+11|0;E=b[t>>0]|0;q=E<<24>>24<0?f[k+4>>2]|0:E&255;if(!q)I=E;else{E=tT(n,q)|0;dJc(E|0,((b[t>>0]|0)<0?f[k>>2]|0:k)|0,q|0)|0;I=b[t>>0]|0}if(I<<24>>24<0)YDc(f[k>>2]|0);K1(l);v=1}else v=0}else v=0;while(0);l=a+24|0;if(!(f[a+28>>2]|0)){I=f[a+32>>2]|0;o=(I|0)==0?1154740:I;I=f[a+40>>2]|0;H=f[a+12>>2]|0;do switch(H|0){case 0:{J=236079;break}case -1:{J=236069;break}case -2:{J=236051;break}case -3:{J=284827;break}case -4:{J=236031;break}case -5:{J=236018;break}case -7:{J=235991;break}case -8:{J=235976;break}case -201:{J=235946;break}case -27:{J=235933;break}case -202:{J=235907;break}case -13:{J=235887;break}case -203:{J=235852;break}case -204:{J=235821;break}case -17:{J=235774;break}case -205:{J=235734;break}case -209:{J=235696;break}case -211:{J=235655;break}case -210:{J=235610;break}case -24:{J=235583;break}case -15:{J=235560;break}case -206:{J=235520;break}case -207:{J=235490;break}case -208:{J=235464;break}case -212:{J=235450;break}case -213:{J=235410;break}case -214:{J=235378;break}case -215:{J=235361;break}case -216:{J=235345;break}case -217:{J=235332;break}case -218:{J=235314;break}case -219:{J=235298;break}default:{f[e>>2]=(H|0)>-1?235272:508586;f[e+4>>2]=H;Aqc(1149319,235279,e)|0;J=1149319}}while(0);e=f[n>>2]|0;f[d>>2]=236155;f[d+4>>2]=o;f[d+8>>2]=I;f[d+12>>2]=H;f[d+16>>2]=J;f[d+20>>2]=(e|0)==0?1154740:e;f[d+24>>2]=v?1154740:502002;F5(k,236279,d);d=a+4|0;if((k|0)!=(d|0)){uT(d);e=f[k>>2]|0;if(!e)K=0;else{J=e+-4|0;f[J>>2]=(f[J>>2]|0)+1;K=f[k>>2]|0}f[d>>2]=K;f[a+8>>2]=f[k+4>>2]}uT(k);u=c;return}if(v){v=f[a+32>>2]|0;K=(v|0)==0?1154740:v;v=f[a+40>>2]|0;d=f[a+12>>2]|0;do switch(d|0){case 0:{L=236079;break}case -1:{L=236069;break}case -2:{L=236051;break}case -3:{L=284827;break}case -4:{L=236031;break}case -5:{L=236018;break}case -7:{L=235991;break}case -8:{L=235976;break}case -201:{L=235946;break}case -27:{L=235933;break}case -202:{L=235907;break}case -13:{L=235887;break}case -203:{L=235852;break}case -204:{L=235821;break}case -17:{L=235774;break}case -205:{L=235734;break}case -209:{L=235696;break}case -211:{L=235655;break}case -210:{L=235610;break}case -24:{L=235583;break}case -15:{L=235560;break}case -206:{L=235520;break}case -207:{L=235490;break}case -208:{L=235464;break}case -212:{L=235450;break}case -213:{L=235410;break}case -214:{L=235378;break}case -215:{L=235361;break}case -216:{L=235345;break}case -217:{L=235332;break}case -218:{L=235314;break}case -219:{L=235298;break}default:{f[j>>2]=(d|0)>-1?235272:508586;f[j+4>>2]=d;Aqc(1149319,235279,j)|0;L=1149319}}while(0);j=f[l>>2]|0;J=f[n>>2]|0;f[i>>2]=236155;f[i+4>>2]=K;f[i+8>>2]=v;f[i+12>>2]=d;f[i+16>>2]=L;f[i+20>>2]=(j|0)==0?1154740:j;f[i+24>>2]=(J|0)==0?1154740:J;F5(k,236172,i);i=a+4|0;if((k|0)!=(i|0)){uT(i);J=f[k>>2]|0;if(!J)M=0;else{j=J+-4|0;f[j>>2]=(f[j>>2]|0)+1;M=f[k>>2]|0}f[i>>2]=M;f[a+8>>2]=f[k+4>>2]}uT(k);u=c;return}else{M=f[a+32>>2]|0;i=(M|0)==0?1154740:M;M=f[a+40>>2]|0;j=f[a+12>>2]|0;do switch(j|0){case 0:{N=236079;break}case -1:{N=236069;break}case -2:{N=236051;break}case -3:{N=284827;break}case -4:{N=236031;break}case -5:{N=236018;break}case -7:{N=235991;break}case -8:{N=235976;break}case -201:{N=235946;break}case -27:{N=235933;break}case -202:{N=235907;break}case -13:{N=235887;break}case -203:{N=235852;break}case -204:{N=235821;break}case -17:{N=235774;break}case -205:{N=235734;break}case -209:{N=235696;break}case -211:{N=235655;break}case -210:{N=235610;break}case -24:{N=235583;break}case -15:{N=235560;break}case -206:{N=235520;break}case -207:{N=235490;break}case -208:{N=235464;break}case -212:{N=235450;break}case -213:{N=235410;break}case -214:{N=235378;break}case -215:{N=235361;break}case -216:{N=235345;break}case -217:{N=235332;break}case -218:{N=235314;break}case -219:{N=235298;break}default:{f[h>>2]=(j|0)>-1?235272:508586;f[h+4>>2]=j;Aqc(1149319,235279,h)|0;N=1149319}}while(0);h=f[n>>2]|0;n=f[l>>2]|0;f[g>>2]=236155;f[g+4>>2]=i;f[g+8>>2]=M;f[g+12>>2]=j;f[g+16>>2]=N;f[g+20>>2]=(h|0)==0?1154740:h;f[g+24>>2]=(n|0)==0?1154740:n;F5(k,236225,g);g=a+4|0;if((k|0)!=(g|0)){uT(g);n=f[k>>2]|0;if(!n)O=0;else{h=n+-4|0;f[h>>2]=(f[h>>2]|0)+1;O=f[k>>2]|0}f[g>>2]=O;f[a+8>>2]=f[k+4>>2]}uT(k);u=c;return}}function F5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+1056|0;g=e+24|0;h=e+8|0;i=e;j=g+8|0;f[g>>2]=j;k=g+4|0;f[k>>2]=1024;f[h>>2]=d;l=f[k>>2]|0;m=Opc(f[g>>2]|0,l,c,h)|0;if((m|0)>-1){n=m;o=l}else{f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,44)|0;r=q;s=236317;t=r+44|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));y5(-215,i,236362,837)}while(1){if((n|0)<(o|0))break;l=n+1|0;m=f[k>>2]|0;if(m>>>0<l>>>0){v=f[g>>2]|0;if(l>>>0>1024)w=XDc(l)|0;else w=j;f[g>>2]=w;f[k>>2]=l;if((m|0)!=0&(w|0)!=(v|0)){b[w>>0]=b[v>>0]|0;if((m|0)!=1){b[w+1>>0]=b[v+1>>0]|0;if((m|0)==2)x=m;else{y=2;do{b[(f[g>>2]|0)+y>>0]=b[v+y>>0]|0;y=y+1|0}while((y|0)!=(m|0));x=m}}else x=1}else x=m;do{b[(f[g>>2]|0)+x>>0]=0;x=x+1|0}while((x|0)!=(l|0));if(!((v|0)==(j|0)|(v|0)==0))ZDc(v)}else f[k>>2]=l;f[h>>2]=d;m=f[k>>2]|0;y=Opc(f[g>>2]|0,m,c,h)|0;if((y|0)>-1){n=y;o=m}else{z=3;break}}if((z|0)==3){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,44)|0;r=q;s=236317;t=r+44|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));y5(-215,i,236362,837)}b[(f[g>>2]|0)+(o+-1)>>0]=0;o=f[g>>2]|0;f[a>>2]=0;f[a+4>>2]=0;if((n|0)!=0&(o|0)!=0){dJc(tT(a,n)|0,o|0,n|0)|0;A=f[g>>2]|0}else A=o;if((A|0)==(j|0)){u=e;return}if(A|0)ZDc(A);f[g>>2]=j;f[k>>2]=1024;u=e;return}function G5(){var a=0;a=H5()|0;f[132949]=a;a=(I5(236393,0)|0)&1;b[1149318]=a;XIc(1149576,0,512)|0;J5(1149576);XIc(1150089,0,512)|0;return}function H5(){var a=0,b=0,c=0,d=0,e=0;a=u;u=u+16|0;b=a;c=f[133466]|0;if(c|0){d=c;u=a;return d|0}c=VDc(4)|0;e=VDc(32)|0;eg(b|0)|0;Zd(b|0,1)|0;ng(e|0,b|0)|0;Pf(b|0)|0;f[e+28>>2]=1;f[c>>2]=e;f[133466]=c;d=c;u=a;return d|0}function I5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d+12|0;g=d;b[e>>0]=c&1;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=Mpc(a)|0;if(c>>>0>4294967279)dEc(g);if(c>>>0<11){b[g+11>>0]=c;if(!c)h=g;else{i=g;j=6}}else{k=c+16&-16;l=VDc(k)|0;f[g>>2]=l;f[g+8>>2]=k|-2147483648;f[g+4>>2]=c;i=l;j=6}if((j|0)==6){dJc(i|0,a|0,c|0)|0;h=i}b[h+c>>0]=0;c=L5(g,e)|0;if((b[g+11>>0]|0)>=0){u=d;return c|0}YDc(f[g>>2]|0);u=d;return c|0}function J5(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=c+4|0;if(jf(236412)|0){g=f[44350]|0;if((b[519824]|0)==0?MIc(519824)|0:0){f[132952]=0;f[132953]=0;dJc(tT(531808,4428)|0,236431,4428)|0;be(1713,531808,x|0)|0}h=f[132952]|0;f[d>>2]=(h|0)==0?1154740:h;eqc(g,240860,d)|0}XIc(531816,0,2048)|0;f[132955]=240896;f[132956]=240900;f[132957]=240904;f[132958]=240909;f[132959]=240914;f[132960]=240920;f[132961]=240927;f[132962]=240934;f[132963]=240941;f[132964]=240946;f[132965]=240950;f[132966]=240955;f[132967]=240960;f[132968]=240968;f[132969]=240977;f[132970]=240986;f[132971]=240995;f[132972]=241004;f[132973]=241015;f[132974]=241024;f[132975]=241035;f[133054]=241044;f[133154]=241049;f[133155]=241053;f[133210]=241058;b[a+200>>0]=0;b[a+201>>0]=0;f[e>>2]=0;K5(a,e,1);u=c;return}function K5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+32|0;k=e+24|0;l=jf(241069)|0;if(!l){u=e;return}if(!(b[l>>0]|0)){u=e;return}m=j+4|0;n=f[44350]|0;o=(d|0)>0;p=l;a:while(1){l=p;b:while(1){q=b[l>>0]|0;switch(q<<24>>24){case 0:{r=28;break a;break}case 44:case 59:break;default:{s=l;t=q;break b}}l=l+1|0}while(1){if(!(t<<24>>24==44^t<<24>>24!=59)){v=s;break}q=s+1|0;t=b[q>>0]|0;if(!(t<<24>>24)){v=q;break}else s=q}if((v|0)==(l|0)){p=l;continue}f[j>>2]=0;f[m>>2]=0;q=v-l|0;if(!q){r=13;break}dJc(tT(j,q)|0,l|0,q|0)|0;q=f[m>>2]|0;if(!q){r=13;break}w=f[j>>2]|0;x=(w|0)==0?1154740:w;y=0;while(1){z=531816+(y<<2)|0;A=f[z>>2]|0;if(A|0?(Mpc(A)|0)==(q|0):0){if((w|0)==(A|0)){r=18;break}if(!(Ioc(x,A)|0)){r=18;break}}B=y+1|0;if((B|0)<512)y=B;else{r=26;break}}if((r|0)==18){r=0;c:do if(o){w=0;while(1){if((f[c+(w<<2)>>2]|0)==(y|0))break;w=w+1|0;if((w|0)>=(d|0))break c}f[i>>2]=A;eqc(n,241120,i)|0}while(0);w=a+y|0;if(!(b[w>>0]|0)){q=f[z>>2]|0;f[h>>2]=q|0?q:241297;eqc(n,241313,h)|0}b[w>>0]=0}else if((r|0)==26){r=0;f[g>>2]=x;eqc(n,241395,g)|0}uT(j);p=v}if((r|0)==13){f[k>>2]=0;f[k+4>>2]=0;v=tT(k,18)|0;p=241088;j=v+18|0;do{b[v>>0]=b[p>>0]|0;v=v+1|0;p=p+1|0}while((v|0)<(j|0));y5(-215,k,241107,601)}else if((r|0)==28){u=e;return}}function L5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=jf(((b[a+11>>0]|0)<0?f[a>>2]|0:a)|0)|0;if(!g){h=(b[c>>0]|0)!=0;u=d;return h|0};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=Mpc(g)|0;if(c>>>0>4294967279)dEc(e);if(c>>>0<11){b[e+11>>0]=c;if(!c)i=e;else{j=e;k=7}}else{a=c+16&-16;l=VDc(a)|0;f[e>>2]=l;f[e+8>>2]=a|-2147483648;f[e+4>>2]=c;j=l;k=7}if((k|0)==7){dJc(j|0,g|0,c|0)|0;i=j}b[i+c>>0]=0;c=M5(e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);h=c;u=d;return h|0}function M5(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+16|0;d=c;e=a+11|0;g=b[e>>0]|0;h=a+4|0;i=f[h>>2]|0;do if(((g<<24>>24<0?i:g&255)|0)==1)if(!(EEc(a,0,-1,241496,1)|0)){j=1;u=c;return j|0}else{k=b[e>>0]|0;l=f[h>>2]|0;break}else{k=g;l=i}while(0);do if(((k<<24>>24<0?l:k&255)|0)==4)if(!(EEc(a,0,-1,502794,4)|0)){j=1;u=c;return j|0}else{m=b[e>>0]|0;n=f[h>>2]|0;break}else{m=k;n=l}while(0);do if(((m<<24>>24<0?n:m&255)|0)==4)if(!(EEc(a,0,-1,519053,4)|0)){j=1;u=c;return j|0}else{o=b[e>>0]|0;p=f[h>>2]|0;break}else{o=m;p=n}while(0);do if(((o<<24>>24<0?p:o&255)|0)==4)if(!(EEc(a,0,-1,241498,4)|0)){j=1;u=c;return j|0}else{q=b[e>>0]|0;r=f[h>>2]|0;break}else{q=o;r=p}while(0);do if(((q<<24>>24<0?r:q&255)|0)==1)if(!(EEc(a,0,-1,508558,1)|0)){j=0;u=c;return j|0}else{s=b[e>>0]|0;t=f[h>>2]|0;break}else{s=q;t=r}while(0);do if(((s<<24>>24<0?t:s&255)|0)==5)if(!(EEc(a,0,-1,502801,5)|0)){j=0;u=c;return j|0}else{v=b[e>>0]|0;w=f[h>>2]|0;break}else{v=s;w=t}while(0);do if(((v<<24>>24<0?w:v&255)|0)==5)if(!(EEc(a,0,-1,519047,5)|0)){j=0;u=c;return j|0}else{x=b[e>>0]|0;y=f[h>>2]|0;break}else{x=v;y=w}while(0);if(((x<<24>>24<0?y:x&255)|0)!=5){z=af(12)|0;fEc(d,a);fEc(z,d);ig(z|0,7800,1721)}if(!(EEc(a,0,-1,241503,5)|0)){j=0;u=c;return j|0}else{z=af(12)|0;fEc(d,a);fEc(z,d);ig(z|0,7800,1721)}return 0}function N5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+160|0;g=e+136|0;h=e;i=h+56|0;j=h+4|0;f[h>>2]=7676;f[i>>2]=7696;auc(h+56|0,j);f[h+128>>2]=0;f[h+132>>2]=-1;f[h>>2]=46080;f[i>>2]=46100;fuc(j);f[j>>2]=45740;i=h+36|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[h+52>>2]=16;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;G1(j,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);g=H1(h,241449,28)|0;i=b[d+11>>0]|0;k=i<<24>>24<0;l=H1(H1(g,k?f[d>>2]|0:d,k?f[d+4>>2]|0:i&255)|0,509015,2)|0;i=b[c+11>>0]|0;d=i<<24>>24<0;H1(l,d?f[c>>2]|0:c,d?f[c+4>>2]|0:i&255)|0;I1(a,j);D3(h);u=e;return}function O5(a){a=a|0;if((b[a+11>>0]|0)>=0)return;YDc(f[a>>2]|0);return}function P5(a){a=a|0;return f0(a)|0}function Q5(a){a=a|0;var b=0;f[a>>2]=46284;b=a+4|0;a=b+40|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function R5(a){a=a|0;return (b[(f[11580]|0)+a>>0]|0)!=0|0}function S5(){var a=0,b=0,c=0,d=0;if(f[133468]|0){a=f[133468]|0;return a|0}b=H5()|0;WIc(f[b>>2]|0)|0;if(!(f[133468]|0)){c=VDc(8)|0;f[c>>2]=46304;d=_5(U5()|0)|0;f[c+4>>2]=d;f[c>>2]=46332;f[133468]=c}VIc(f[b>>2]|0)|0;a=f[133468]|0;return a|0}function T5(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=a+4|0;if((f[e>>2]|0)==-1){f[d>>2]=0;f[d+4>>2]=0;g=tT(d,63)|0;h=241509;i=g+63|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));y5(-215,d,241573,1596)}d=U5()|0;h=V5(d,f[e>>2]|0)|0;if(h|0){j=h;u=c;return j|0}h=_i[f[(f[a>>2]|0)+8>>2]&1023](a)|0;a=U5()|0;W5(a,f[e>>2]|0,h);j=h;u=c;return j|0}function U5(){var a=0,b=0,c=0;if(f[133467]|0){a=f[133467]|0;return a|0}b=H5()|0;WIc(f[b>>2]|0)|0;if(!(f[133467]|0)){c=VDc(36)|0;Z5(c);f[133467]=c}VIc(f[b>>2]|0)|0;a=f[133467]|0;return a|0}function V5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;if((f[a+8>>2]|0)>>>0<=c>>>0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,22)|0;h=241581;i=g+22|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));y5(-215,e,241573,1489)}e=Bf(f[a>>2]|0)|0;if(!e){j=0;u=d;return j|0}a=f[e>>2]|0;if((f[e+4>>2]|0)-a>>2>>>0<=c>>>0){j=0;u=d;return j|0}j=f[a+(c<<2)>>2]|0;u=d;return j|0}function W5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e+8|0;h=e;if((f[a+8>>2]|0)>>>0<=c>>>0){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,22)|0;j=241581;k=i+22|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));y5(-215,g,241604,1521)}l=Bf(f[a>>2]|0)|0;f[h>>2]=l;if(!l){m=VDc(16)|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;n=VDc(128)|0;o=n;f[m>>2]=o;f[m+4>>2]=o;f[m+8>>2]=n+128;f[h>>2]=m;n=m;if(fg(f[a>>2]|0,m|0)|0){f[g>>2]=0;f[g+4>>2]=0;i=tT(g,39)|0;j=241612;k=i+39|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));y5(-215,g,241652,1377)}j=a+4|0;WIc(f[j>>2]|0)|0;i=a+24|0;k=a+28|0;o=f[k>>2]|0;f[m+12>>2]=o-(f[i>>2]|0)>>2;if((o|0)==(f[a+32>>2]|0))X5(i,h);else{f[o>>2]=n;f[k>>2]=(f[k>>2]|0)+4}VIc(f[j>>2]|0)|0;p=f[h>>2]|0}else p=l;if((f[p+4>>2]|0)-(f[p>>2]|0)>>2>>>0>c>>>0){q=p;r=f[q>>2]|0;s=r+(c<<2)|0;f[s>>2]=d;u=e;return}p=a+4|0;WIc(f[p>>2]|0)|0;a=f[h>>2]|0;l=c+1|0;f[g>>2]=0;j=a+4|0;k=f[j>>2]|0;n=f[a>>2]|0;o=k-n>>2;i=n;n=k;if(l>>>0<=o>>>0){if(l>>>0<o>>>0?(k=i+(l<<2)|0,(n|0)!=(k|0)):0)f[j>>2]=n+(~((n+-4-k|0)>>>2)<<2)}else Y5(a,l-o|0,g);VIc(f[p>>2]|0)|0;q=f[h>>2]|0;r=f[q>>2]|0;s=r+(c<<2)|0;f[s>>2]=d;u=e;return}function X5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function Y5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>2>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=f[c>>2];j=(f[g>>2]|0)+4|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>2;h=j+b|0;if(h>>>0>1073741823)mCc(a);k=e-i|0;i=k>>1;e=k>>2>>>0<536870911?(i>>>0<h>>>0?h:i):1073741823;do if(e)if(e>>>0>1073741823){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{l=VDc(e<<2)|0;break}else l=0;while(0);i=l+(j<<2)|0;j=l+(e<<2)|0;e=b;b=i;l=i;do{f[b>>2]=f[c>>2];b=l+4|0;l=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>2)<<2)|0;if((b|0)>0)dJc(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=l;f[d>>2]=j;if(!e)return;YDc(e);return}function Z5(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(!(nf(a|0,0)|0)){e=VDc(32)|0;eg(d|0)|0;Zd(d|0,1)|0;ng(e|0,d|0)|0;Pf(d|0)|0;f[e+28>>2]=1;f[a+4>>2]=e;e=a+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;e=VDc(128)|0;g=e;f[a+12>>2]=g;f[a+16>>2]=g;f[a+20>>2]=e+128;e=VDc(128)|0;g=e;f[a+24>>2]=g;f[a+28>>2]=g;f[a+32>>2]=e+128;u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;c=tT(d,38)|0;e=241660;a=c+38|0;do{b[c>>0]=b[e>>0]|0;c=c+1|0;e=e+1|0}while((c|0)<(a|0));y5(-215,d,241699,1365)}}function _5(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c;e=a+4|0;WIc(f[e>>2]|0)|0;g=a+8|0;h=f[g>>2]|0;i=a+12|0;j=a+16|0;k=f[j>>2]|0;l=f[i>>2]|0;m=l;n=k;if((h|0)!=(k-l>>2|0)){f[d>>2]=0;f[d+4>>2]=0;l=tT(d,31)|0;k=241714;o=l+31|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(o|0));y5(-215,d,241791,1444)}a:do if(h|0){k=0;while(1){p=m+(k<<2)|0;if(!(f[p>>2]|0))break;l=k+1|0;if(l>>>0<h>>>0)k=l;else break a}f[p>>2]=1;q=k;r=f[e>>2]|0;VIc(r|0)|0;u=c;return q|0}while(0);f[d>>2]=1;if((n|0)==(f[a+20>>2]|0))g6(i,d);else{f[n>>2]=1;f[j>>2]=n+4}n=f[g>>2]|0;f[g>>2]=n+1;q=n;r=f[e>>2]|0;VIc(r|0)|0;u=c;return q|0}function $5(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=46332;d6(a);f[a>>2]=46304;if((f[a+4>>2]|0)==-1){u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;c=tT(d,10)|0;a=235178;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));y5(-215,d,235189,1567)}}function a6(a){a=a|0;$5(a);YDc(a);return}function b6(a){a=a|0;var b=0;a=VDc(32)|0;b=a;f[b>>2]=-1;f[b+4>>2]=0;f[a+8>>2]=0;naa(a+12|0);f[a+16>>2]=-1;f[a+20>>2]=-1;f[a+24>>2]=-1;return a|0}function c6(a,b){a=a|0;b=b|0;if(!b)return;oaa(b+12|0);YDc(b);return}function d6(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+16|0;c=b;f[c>>2]=0;d=c+4|0;f[d>>2]=0;f[c+8>>2]=0;e=VDc(128)|0;g=e;f[c>>2]=g;f[d>>2]=g;f[c+8>>2]=e+128;e=U5()|0;g=a+4|0;e6(e,f[g>>2]|0,c,0);f[g>>2]=-1;g=f[d>>2]|0;e=f[c>>2]|0;h=e;if((g|0)==(e|0)){i=g;j=h}else{g=0;e=h;while(1){mi[f[(f[a>>2]|0)+12>>2]&2047](a,f[e+(g<<2)>>2]|0);g=g+1|0;h=f[d>>2]|0;k=f[c>>2]|0;l=k;if(g>>>0>=h-k>>2>>>0){i=h;j=l;break}else e=l}}e=i;if(!j){u=b;return}if((e|0)!=(j|0))f[d>>2]=e+(~((e+-4-j|0)>>>2)<<2);YDc(j);u=b;return}function e6(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=a+4|0;WIc(f[i>>2]|0)|0;j=f[a+8>>2]|0;k=a+12|0;if((j|0)!=((f[a+16>>2]|0)-(f[k>>2]|0)>>2|0)){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,31)|0;m=241714;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));y5(-215,h,241746,1465)}if(j>>>0<=c>>>0){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,22)|0;m=241581;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));y5(-215,h,241746,1466)}h=a+24|0;m=a+28|0;a=f[m>>2]|0;l=f[h>>2]|0;if((a|0)!=(l|0)){n=d+4|0;j=d+8|0;o=0;p=l;l=a;while(1){a=f[p+(o<<2)>>2]|0;if(((a|0)!=0?(q=f[a>>2]|0,(f[a+4>>2]|0)-q>>2>>>0>c>>>0):0)?(r=q+(c<<2)|0,q=f[r>>2]|0,s=q,(q|0)!=0):0){q=f[n>>2]|0;if((q|0)==(f[j>>2]|0))f6(d,r);else{f[q>>2]=s;f[n>>2]=(f[n>>2]|0)+4}f[(f[a>>2]|0)+(c<<2)>>2]=0;t=f[h>>2]|0;v=f[m>>2]|0}else{t=p;v=l}o=o+1|0;if(o>>>0>=v-t>>2>>>0)break;else{p=t;l=v}}}if(e){w=f[i>>2]|0;VIc(w|0)|0;u=g;return}f[(f[k>>2]|0)+(c<<2)>>2]=0;w=f[i>>2]|0;VIc(w|0)|0;u=g;return}function f6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function g6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function h6(){var a=0,b=0,c=0,d=0;a=u;u=u+16|0;b=a+8|0;Qe(b|0,a|0)|0;c=f[b>>2]|0;d=mJc(c|0,((c|0)<0)<<31>>31|0,1e6,0)|0;c=f[b+4>>2]|0;b=UIc(d|0,J|0,c|0,((c|0)<0)<<31>>31|0)|0;u=a;return b|0}function i6(){if(b[519824]|0)return 531808;if(!(MIc(519824)|0))return 531808;f[132952]=0;f[132953]=0;dJc(tT(531808,4428)|0,236431,4428)|0;be(1713,531808,x|0)|0;return 531808}function j6(){return 0}function k6(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=VDc(32)|0;eg(c|0)|0;Zd(c|0,1)|0;ng(d|0,c|0)|0;Pf(c|0)|0;f[d+28>>2]=1;f[a>>2]=d;u=b;return}function l6(a){a=a|0;var b=0,c=0;b=(f[a>>2]|0)+28|0;c=f[b>>2]|0;f[b>>2]=c+-1;if((c|0)==1?(c=f[a>>2]|0,c|0):0){Zf(c|0)|0;YDc(c)}f[a>>2]=0;return}function m6(a){a=a|0;WIc(f[a>>2]|0)|0;return}function n6(a){a=a|0;VIc(f[a>>2]|0)|0;return}function o6(a){a=a|0;var b=0;f[a>>2]=46304;b=_5(U5()|0)|0;f[a+4>>2]=b;return}function p6(){var a=0,b=0,c=0;if(!(f[133469]|0)){a=H5()|0;WIc(f[a>>2]|0)|0;if(!(f[133469]|0)){b=VDc(8)|0;f[b>>2]=46304;c=_5(U5()|0)|0;f[b+4>>2]=c;f[b>>2]=46356;f[133469]=b}VIc(f[a>>2]|0)|0}a=T5(f[133469]|0)|0;return f[a>>2]|0}function q6(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=46356;d6(a);f[a>>2]=46304;if((f[a+4>>2]|0)==-1){u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;c=tT(d,10)|0;a=235178;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));y5(-215,d,235189,1567)}}function r6(a){a=a|0;q6(a);YDc(a);return}function s6(a){a=a|0;var b=0;a=VDc(4)|0;b=f[133470]|0;f[133470]=b+1;f[a>>2]=b;return a|0}function t6(a,b){a=a|0;b=b|0;if(!b)return;YDc(b);return}function u6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=d+4|0;f[e>>2]=c;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=Mpc(a)|0;if(c>>>0>4294967279)dEc(g);if(c>>>0<11){b[g+11>>0]=c;if(!c)h=g;else{i=g;j=6}}else{k=c+16&-16;l=VDc(k)|0;f[g>>2]=l;f[g+8>>2]=k|-2147483648;f[g+4>>2]=c;i=l;j=6}if((j|0)==6){dJc(i|0,a|0,c|0)|0;h=i}b[h+c>>0]=0;c=v6(g,e)|0;if((b[g+11>>0]|0)>=0){u=d;return c|0}YDc(f[g>>2]|0);u=d;return c|0}function v6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=jf(((b[a+11>>0]|0)<0?f[a>>2]|0:a)|0)|0;if(!g){h=f[c>>2]|0;u=d;return h|0};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=Mpc(g)|0;if(c>>>0>4294967279)dEc(e);if(c>>>0<11){b[e+11>>0]=c;if(!c)i=e;else{j=e;k=7}}else{a=c+16&-16;l=VDc(a)|0;f[e>>2]=l;f[e+8>>2]=a|-2147483648;f[e+4>>2]=c;j=l;k=7}if((k|0)==7){dJc(j|0,g|0,c|0)|0;i=j}b[i+c>>0]=0;c=w6(e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);h=c;u=d;return h|0}function w6(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+48|0;d=c+40|0;e=c+24|0;g=c;h=c+12|0;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;l=a+4|0;m=k?f[l>>2]|0:j&255;a:do if(!m)n=0;else{j=k?f[a>>2]|0:a;o=0;while(1){if(((b[j+o>>0]|0)+-48|0)>>>0>=10){n=o;break a}p=o+1|0;if(p>>>0<m>>>0)o=p;else{n=p;break}}}while(0);gEc(e,a,0,n,a);f[d>>2]=0;f[d+4>>2]=0;m=e+11|0;k=b[m>>0]|0;o=k<<24>>24<0?f[e+4>>2]|0:k&255;if(!o)q=k;else{k=tT(d,o)|0;dJc(k|0,((b[m>>0]|0)<0?f[e>>2]|0:e)|0,o|0)|0;q=b[m>>0]|0}if(q<<24>>24<0)YDc(f[e>>2]|0);q=b[i>>0]|0;gEc(g,a,n,(q<<24>>24<0?f[l>>2]|0:q&255)-n|0,a);f[e>>2]=0;n=e+4|0;f[n>>2]=0;q=g+11|0;l=b[q>>0]|0;i=l<<24>>24<0?f[g+4>>2]|0:l&255;if(!i)r=l;else{l=tT(e,i)|0;dJc(l|0,((b[q>>0]|0)<0?f[g>>2]|0:g)|0,i|0)|0;r=b[q>>0]|0}if(r<<24>>24<0)YDc(f[g>>2]|0);g=f[d>>2]|0;r=vrc((g|0)==0?1154740:g)|0;if(!(f[n>>2]|0)){s=r;uT(e);uT(d);u=c;return s|0}n=f[e>>2]|0;if((((n|0)!=241846?(g=(n|0)==0?1154740:n,!((Ioc(g,241846)|0)==0|(n|0)==241849)):0)?!((Ioc(g,241849)|0)==0|(n|0)==241852):0)?Ioc(g,241852)|0:0){if((((n|0)!=241855?!((Ioc(g,241855)|0)==0|(n|0)==241858):0)?!((Ioc(g,241858)|0)==0|(n|0)==241861):0)?Ioc(g,241861)|0:0){g=af(12)|0;fEc(h,a);fEc(g,h);ig(g|0,7800,1721)}s=r<<10;uT(e);uT(d);u=c;return s|0}s=r<<20;uT(e);uT(d);u=c;return s|0}function x6(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+8|0;h=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=Mpc(c)|0;if(i>>>0>4294967279)dEc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{m=i+16&-16;n=VDc(m)|0;f[g>>2]=n;f[g+8>>2]=m|-2147483648;f[g+4>>2]=i;k=n;l=6}if((l|0)==6){dJc(k|0,c|0,i|0)|0;j=k}b[j+i>>0]=0;f[h>>2]=0;f[h+4>>2]=0;if(d|0?(i=Mpc(d)|0,i|0):0)dJc(tT(h,i)|0,d|0,i|0)|0;y6(a,g,h);uT(h);if((b[g+11>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function y6(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;h=jf(((b[c+11>>0]|0)<0?f[c>>2]|0:c)|0)|0;if(!h){c=f[d>>2]|0;f[a>>2]=c;f[a+4>>2]=f[d+4>>2];if(!c){u=e;return}d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1;u=e;return};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=Mpc(h)|0;if(d>>>0>4294967279)dEc(g);if(d>>>0<11){c=g+11|0;b[c>>0]=d;if(!d){i=g;j=c}else{k=g;l=c;m=7}}else{c=d+16&-16;n=VDc(c)|0;f[g>>2]=n;f[g+8>>2]=c|-2147483648;f[g+4>>2]=d;k=n;l=g+11|0;m=7}if((m|0)==7){dJc(k|0,h|0,d|0)|0;i=k;j=l}b[i+d>>0]=0;f[a>>2]=0;f[a+4>>2]=0;d=b[j>>0]|0;i=d<<24>>24<0?f[g+4>>2]|0:d&255;if(!i)o=d;else{d=tT(a,i)|0;dJc(d|0,((b[j>>0]|0)<0?f[g>>2]|0:g)|0,i|0)|0;o=b[j>>0]|0}if(o<<24>>24<0)YDc(f[g>>2]|0);u=e;return}function z6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/12|0;if(!e)return;if(g>>>0>357913941)mCc(a);h=VDc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*12|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{fEc(g,d);d=d+12|0;g=(f[c>>2]|0)+12|0;f[c>>2]=g}while((d|0)!=(b|0));return}function A6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){XIc(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)mCc(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=af(8)|0;bEc(d,503977);f[d>>2]=185532;ig(d|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;XIc(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)dJc(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;YDc(h);return}function B6(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;f[c>>2]=0;f[c+4>>2]=0;a=tT(c,44)|0;d=243342;e=a+44|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));z5(-216,c,243387,243401,107)}function C6(){B6();return 0}function D6(a){a=a|0;return f[46372+(a<<2)>>2]|0}function E6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;if(!c){i=(g|0)%4|0;switch(i|0){case 1:{j=f[d>>2]|0;k=e+-4|0;if((e|0)<4){l=a;m=j;n=0}else{o=g<<1;p=g*3|0;q=g<<2;r=e&-4;s=a;t=j;j=0;while(1){t=(h[s>>0]|0)+t+(h[s+g>>0]|0)+(h[s+o>>0]|0)+(h[s+p>>0]|0)|0;j=j+4|0;if((j|0)>(k|0))break;else s=s+q|0}l=a+(Y(r,g)|0)|0;m=t;n=r}if((n|0)<(e|0)){r=m;t=n;q=l;while(1){l=(h[q>>0]|0)+r|0;t=t+1|0;if((t|0)==(e|0)){u=l;v=e;break}else{r=l;q=q+g|0}}}else{u=m;v=n}f[d>>2]=u;w=v;break}case 2:{v=f[d>>2]|0;u=d+4|0;n=f[u>>2]|0;if((e|0)>0){m=n;q=v;r=0;t=a;while(1){l=(h[t>>0]|0)+q|0;s=(h[t+1>>0]|0)+m|0;r=r+1|0;if((r|0)==(e|0)){x=s;y=l;z=e;break}else{m=s;q=l;t=t+g|0}}}else{x=n;y=v;z=0}f[d>>2]=y;f[u>>2]=x;w=z;break}case 3:{z=f[d>>2]|0;x=d+4|0;u=f[x>>2]|0;y=d+8|0;v=f[y>>2]|0;if((e|0)>0){n=v;t=u;q=z;m=0;r=a;while(1){l=(h[r>>0]|0)+q|0;s=(h[r+1>>0]|0)+t|0;k=(h[r+2>>0]|0)+n|0;m=m+1|0;if((m|0)==(e|0)){A=k;B=s;C=l;D=e;break}else{n=k;t=s;q=l;r=r+g|0}}}else{A=v;B=u;C=z;D=0}f[d>>2]=C;f[x>>2]=B;f[y>>2]=A;w=D;break}default:w=0}if((i|0)<(g|0)){E=i;F=w}else{G=e;return G|0}while(1){w=d+(E<<2)|0;i=f[w>>2]|0;D=d+(E+1<<2)|0;A=f[D>>2]|0;y=d+(E+2<<2)|0;B=f[y>>2]|0;x=d+(E+3<<2)|0;C=f[x>>2]|0;if((F|0)<(e|0)){z=C;u=B;v=A;r=i;q=a+(Y(F,g)|0)+E|0;t=F;while(1){n=(h[q>>0]|0)+r|0;m=(h[q+1>>0]|0)+v|0;l=(h[q+2>>0]|0)+u|0;s=(h[q+3>>0]|0)+z|0;t=t+1|0;if((t|0)==(e|0)){H=s;I=l;J=m;K=n;L=e;break}else{z=s;u=l;v=m;r=n;q=q+g|0}}}else{H=C;I=B;J=A;K=i;L=F}f[w>>2]=K;f[D>>2]=J;f[y>>2]=I;f[x>>2]=H;E=E+4|0;if((E|0)>=(g|0)){G=e;break}else F=L}return G|0}switch(g|0){case 1:{L=f[d>>2]|0;if((e|0)>0){F=L;E=0;H=0;while(1){if(!(b[c+H>>0]|0)){M=F;N=E}else{M=(h[a+H>>0]|0)+F|0;N=E+1|0}H=H+1|0;if((H|0)==(e|0)){O=M;P=N;break}else{F=M;E=N}}}else{O=L;P=0}f[d>>2]=O;G=P;return G|0}case 3:{P=f[d>>2]|0;O=d+4|0;L=f[O>>2]|0;N=d+8|0;E=f[N>>2]|0;if((e|0)>0){M=E;F=L;H=P;I=0;J=0;K=a;while(1){if(!(b[c+I>>0]|0)){Q=M;R=F;S=H;T=J}else{Q=(h[K+2>>0]|0)+M|0;R=(h[K+1>>0]|0)+F|0;S=(h[K>>0]|0)+H|0;T=J+1|0}I=I+1|0;if((I|0)==(e|0)){U=Q;V=R;W=S;X=T;break}else{M=Q;F=R;H=S;J=T;K=K+3|0}}}else{U=E;V=L;W=P;X=0}f[d>>2]=W;f[O>>2]=V;f[N>>2]=U;G=X;return G|0}default:{if((e|0)<=0){G=0;return G|0}X=g+-4|0;if((g|0)<4){if((g|0)>0){Z=0;_=0;$=a}else{U=0;N=0;while(1){V=N+((b[c+U>>0]|0)!=0&1)|0;U=U+1|0;if((U|0)==(e|0)){G=V;break}else N=V}return G|0}while(1){if(!(b[c+Z>>0]|0))aa=_;else{N=0;do{U=d+(N<<2)|0;f[U>>2]=(f[U>>2]|0)+(h[$+N>>0]|0);N=N+1|0}while((N|0)!=(g|0));aa=_+1|0}Z=Z+1|0;if((Z|0)==(e|0)){G=aa;break}else{_=aa;$=$+g|0}}return G|0}$=g&-4;if(($|0)<(g|0)){ba=0;ca=0;da=a}else{aa=0;_=0;Z=a;while(1){if(!(b[c+aa>>0]|0))ea=_;else{a=0;do{N=d+(a<<2)|0;x=a|1;y=d+(x<<2)|0;D=(h[Z+x>>0]|0)+(f[y>>2]|0)|0;f[N>>2]=(h[Z+a>>0]|0)+(f[N>>2]|0);f[y>>2]=D;D=a|2;y=d+(D<<2)|0;N=a|3;x=d+(N<<2)|0;w=(h[Z+N>>0]|0)+(f[x>>2]|0)|0;f[y>>2]=(h[Z+D>>0]|0)+(f[y>>2]|0);f[x>>2]=w;a=a+4|0}while((a|0)<=(X|0));ea=_+1|0}aa=aa+1|0;if((aa|0)==(e|0)){G=ea;break}else{_=ea;Z=Z+g|0}}return G|0}while(1){if(!(b[c+ba>>0]|0))fa=ca;else{Z=0;do{ea=d+(Z<<2)|0;_=Z|1;aa=d+(_<<2)|0;a=(h[da+_>>0]|0)+(f[aa>>2]|0)|0;f[ea>>2]=(h[da+Z>>0]|0)+(f[ea>>2]|0);f[aa>>2]=a;a=Z|2;aa=d+(a<<2)|0;ea=Z|3;_=d+(ea<<2)|0;w=(h[da+ea>>0]|0)+(f[_>>2]|0)|0;f[aa>>2]=(h[da+a>>0]|0)+(f[aa>>2]|0);f[_>>2]=w;Z=Z+4|0}while((Z|0)<=(X|0));ga=$;do{Z=d+(ga<<2)|0;f[Z>>2]=(f[Z>>2]|0)+(h[da+ga>>0]|0);ga=ga+1|0}while((ga|0)!=(g|0));fa=ca+1|0}ba=ba+1|0;if((ba|0)==(e|0)){G=fa;break}else{ca=fa;da=da+g|0}}return G|0}}return 0}function F6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=f[d>>2]|0;j=e+-4|0;if((e|0)<4){k=a;l=i;m=0}else{n=g<<1;o=g*3|0;p=g<<2;q=e&-4;r=a;s=i;i=0;while(1){s=(b[r>>0]|0)+s+(b[r+g>>0]|0)+(b[r+n>>0]|0)+(b[r+o>>0]|0)|0;i=i+4|0;if((i|0)>(j|0))break;else r=r+p|0}k=a+(Y(q,g)|0)|0;l=s;m=q}if((m|0)<(e|0)){q=l;s=m;p=k;while(1){k=(b[p>>0]|0)+q|0;s=s+1|0;if((s|0)==(e|0)){t=k;u=e;break}else{q=k;p=p+g|0}}}else{t=l;u=m}f[d>>2]=t;v=u;break}case 2:{u=f[d>>2]|0;t=d+4|0;m=f[t>>2]|0;if((e|0)>0){l=m;p=u;q=0;s=a;while(1){k=(b[s>>0]|0)+p|0;r=(b[s+1>>0]|0)+l|0;q=q+1|0;if((q|0)==(e|0)){w=r;x=k;y=e;break}else{l=r;p=k;s=s+g|0}}}else{w=m;x=u;y=0}f[d>>2]=x;f[t>>2]=w;v=y;break}case 3:{y=f[d>>2]|0;w=d+4|0;t=f[w>>2]|0;x=d+8|0;u=f[x>>2]|0;if((e|0)>0){m=u;s=t;p=y;l=0;q=a;while(1){k=(b[q>>0]|0)+p|0;r=(b[q+1>>0]|0)+s|0;j=(b[q+2>>0]|0)+m|0;l=l+1|0;if((l|0)==(e|0)){z=j;A=r;B=k;C=e;break}else{m=j;s=r;p=k;q=q+g|0}}}else{z=u;A=t;B=y;C=0}f[d>>2]=B;f[w>>2]=A;f[x>>2]=z;v=C;break}default:v=0}if((h|0)<(g|0)){D=h;E=v}else{F=e;return F|0}while(1){v=d+(D<<2)|0;h=f[v>>2]|0;C=d+(D+1<<2)|0;z=f[C>>2]|0;x=d+(D+2<<2)|0;A=f[x>>2]|0;w=d+(D+3<<2)|0;B=f[w>>2]|0;if((E|0)<(e|0)){y=B;t=A;u=z;q=h;p=a+(Y(E,g)|0)+D|0;s=E;while(1){m=(b[p>>0]|0)+q|0;l=(b[p+1>>0]|0)+u|0;k=(b[p+2>>0]|0)+t|0;r=(b[p+3>>0]|0)+y|0;s=s+1|0;if((s|0)==(e|0)){G=r;H=k;I=l;J=m;K=e;break}else{y=r;t=k;u=l;q=m;p=p+g|0}}}else{G=B;H=A;I=z;J=h;K=E}f[v>>2]=J;f[C>>2]=I;f[x>>2]=H;f[w>>2]=G;D=D+4|0;if((D|0)>=(g|0)){F=e;break}else E=K}return F|0}switch(g|0){case 1:{K=f[d>>2]|0;if((e|0)>0){E=K;D=0;G=0;while(1){if(!(b[c+G>>0]|0)){L=E;M=D}else{L=(b[a+G>>0]|0)+E|0;M=D+1|0}G=G+1|0;if((G|0)==(e|0)){N=L;O=M;break}else{E=L;D=M}}}else{N=K;O=0}f[d>>2]=N;F=O;return F|0}case 3:{O=f[d>>2]|0;N=d+4|0;K=f[N>>2]|0;M=d+8|0;D=f[M>>2]|0;if((e|0)>0){L=D;E=K;G=O;H=0;I=0;J=a;while(1){if(!(b[c+H>>0]|0)){P=L;Q=E;R=G;S=I}else{P=(b[J+2>>0]|0)+L|0;Q=(b[J+1>>0]|0)+E|0;R=(b[J>>0]|0)+G|0;S=I+1|0}H=H+1|0;if((H|0)==(e|0)){T=P;U=Q;V=R;W=S;break}else{L=P;E=Q;G=R;I=S;J=J+3|0}}}else{T=D;U=K;V=O;W=0}f[d>>2]=V;f[N>>2]=U;f[M>>2]=T;F=W;return F|0}default:{if((e|0)<=0){F=0;return F|0}W=g+-4|0;if((g|0)<4){if((g|0)>0){X=0;Z=0;_=a}else{T=0;M=0;while(1){U=M+((b[c+T>>0]|0)!=0&1)|0;T=T+1|0;if((T|0)==(e|0)){F=U;break}else M=U}return F|0}while(1){if(!(b[c+X>>0]|0))$=Z;else{M=0;do{T=d+(M<<2)|0;f[T>>2]=(f[T>>2]|0)+(b[_+M>>0]|0);M=M+1|0}while((M|0)!=(g|0));$=Z+1|0}X=X+1|0;if((X|0)==(e|0)){F=$;break}else{Z=$;_=_+g|0}}return F|0}_=g&-4;if((_|0)<(g|0)){aa=0;ba=0;ca=a}else{$=0;Z=0;X=a;while(1){if(!(b[c+$>>0]|0))da=Z;else{a=0;do{M=d+(a<<2)|0;w=a|1;x=d+(w<<2)|0;C=(b[X+w>>0]|0)+(f[x>>2]|0)|0;f[M>>2]=(b[X+a>>0]|0)+(f[M>>2]|0);f[x>>2]=C;C=a|2;x=d+(C<<2)|0;M=a|3;w=d+(M<<2)|0;v=(b[X+M>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(b[X+C>>0]|0)+(f[x>>2]|0);f[w>>2]=v;a=a+4|0}while((a|0)<=(W|0));da=Z+1|0}$=$+1|0;if(($|0)==(e|0)){F=da;break}else{Z=da;X=X+g|0}}return F|0}while(1){if(!(b[c+aa>>0]|0))ea=ba;else{X=0;do{da=d+(X<<2)|0;Z=X|1;$=d+(Z<<2)|0;a=(b[ca+Z>>0]|0)+(f[$>>2]|0)|0;f[da>>2]=(b[ca+X>>0]|0)+(f[da>>2]|0);f[$>>2]=a;a=X|2;$=d+(a<<2)|0;da=X|3;Z=d+(da<<2)|0;v=(b[ca+da>>0]|0)+(f[Z>>2]|0)|0;f[$>>2]=(b[ca+a>>0]|0)+(f[$>>2]|0);f[Z>>2]=v;X=X+4|0}while((X|0)<=(W|0));fa=_;do{X=d+(fa<<2)|0;f[X>>2]=(f[X>>2]|0)+(b[ca+fa>>0]|0);fa=fa+1|0}while((fa|0)!=(g|0));ea=ba+1|0}aa=aa+1|0;if((aa|0)==(e|0)){F=ea;break}else{ba=ea;ca=ca+g|0}}return F|0}}return 0}function G6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=f[d>>2]|0;k=e+-4|0;if((e|0)<4){l=a;m=i;n=0}else{o=g<<1;p=g*3|0;q=g<<2;r=k>>>2;s=Y((r<<3)+8|0,g)|0;t=a;u=i;i=0;while(1){u=(j[t>>1]|0)+u+(j[t+(g<<1)>>1]|0)+(j[t+(o<<1)>>1]|0)+(j[t+(p<<1)>>1]|0)|0;i=i+4|0;if((i|0)>(k|0))break;else t=t+(q<<1)|0}l=a+s|0;m=u;n=(r<<2)+4|0}if((n|0)<(e|0)){r=m;u=n;s=l;while(1){l=(j[s>>1]|0)+r|0;u=u+1|0;if((u|0)==(e|0)){v=l;w=e;break}else{r=l;s=s+(g<<1)|0}}}else{v=m;w=n}f[d>>2]=v;x=w;break}case 2:{w=f[d>>2]|0;v=d+4|0;n=f[v>>2]|0;if((e|0)>0){m=n;s=w;r=0;u=a;while(1){l=(j[u>>1]|0)+s|0;q=(j[u+2>>1]|0)+m|0;r=r+1|0;if((r|0)==(e|0)){y=q;z=l;A=e;break}else{m=q;s=l;u=u+(g<<1)|0}}}else{y=n;z=w;A=0}f[d>>2]=z;f[v>>2]=y;x=A;break}case 3:{A=f[d>>2]|0;y=d+4|0;v=f[y>>2]|0;z=d+8|0;w=f[z>>2]|0;if((e|0)>0){n=w;u=v;s=A;m=0;r=a;while(1){l=(j[r>>1]|0)+s|0;q=(j[r+2>>1]|0)+u|0;t=(j[r+4>>1]|0)+n|0;m=m+1|0;if((m|0)==(e|0)){B=t;C=q;D=l;E=e;break}else{n=t;u=q;s=l;r=r+(g<<1)|0}}}else{B=w;C=v;D=A;E=0}f[d>>2]=D;f[y>>2]=C;f[z>>2]=B;x=E;break}default:x=0}if((h|0)<(g|0)){F=h;G=x}else{H=e;return H|0}while(1){x=d+(F<<2)|0;h=f[x>>2]|0;E=d+(F+1<<2)|0;B=f[E>>2]|0;z=d+(F+2<<2)|0;C=f[z>>2]|0;y=d+(F+3<<2)|0;D=f[y>>2]|0;if((G|0)<(e|0)){A=D;v=C;w=B;r=h;s=a+((Y(G,g)|0)<<1)+(F<<1)|0;u=G;while(1){n=(j[s>>1]|0)+r|0;m=(j[s+2>>1]|0)+w|0;l=(j[s+4>>1]|0)+v|0;q=(j[s+6>>1]|0)+A|0;u=u+1|0;if((u|0)==(e|0)){I=q;J=l;K=m;L=n;M=e;break}else{A=q;v=l;w=m;r=n;s=s+(g<<1)|0}}}else{I=D;J=C;K=B;L=h;M=G}f[x>>2]=L;f[E>>2]=K;f[z>>2]=J;f[y>>2]=I;F=F+4|0;if((F|0)>=(g|0)){H=e;break}else G=M}return H|0}switch(g|0){case 1:{M=f[d>>2]|0;if((e|0)>0){G=M;F=0;I=0;while(1){if(!(b[c+I>>0]|0)){N=G;O=F}else{N=(j[a+(I<<1)>>1]|0)+G|0;O=F+1|0}I=I+1|0;if((I|0)==(e|0)){P=N;Q=O;break}else{G=N;F=O}}}else{P=M;Q=0}f[d>>2]=P;H=Q;return H|0}case 3:{Q=f[d>>2]|0;P=d+4|0;M=f[P>>2]|0;O=d+8|0;F=f[O>>2]|0;if((e|0)>0){N=F;G=M;I=Q;J=0;K=0;L=a;while(1){if(!(b[c+J>>0]|0)){R=N;S=G;T=I;U=K}else{R=(j[L+4>>1]|0)+N|0;S=(j[L+2>>1]|0)+G|0;T=(j[L>>1]|0)+I|0;U=K+1|0}J=J+1|0;if((J|0)==(e|0)){V=R;W=S;X=T;Z=U;break}else{N=R;G=S;I=T;K=U;L=L+6|0}}}else{V=F;W=M;X=Q;Z=0}f[d>>2]=X;f[P>>2]=W;f[O>>2]=V;H=Z;return H|0}default:{if((e|0)<=0){H=0;return H|0}Z=g+-4|0;if((g|0)<4){if((g|0)>0){_=0;$=0;aa=a}else{V=0;O=0;while(1){W=O+((b[c+V>>0]|0)!=0&1)|0;V=V+1|0;if((V|0)==(e|0)){H=W;break}else O=W}return H|0}while(1){if(!(b[c+_>>0]|0))ba=$;else{O=0;do{V=d+(O<<2)|0;f[V>>2]=(f[V>>2]|0)+(j[aa+(O<<1)>>1]|0);O=O+1|0}while((O|0)!=(g|0));ba=$+1|0}_=_+1|0;if((_|0)==(e|0)){H=ba;break}else{$=ba;aa=aa+(g<<1)|0}}return H|0}aa=g&-4;if((aa|0)<(g|0)){ca=0;da=0;ea=a}else{ba=0;$=0;_=a;while(1){if(!(b[c+ba>>0]|0))fa=$;else{a=0;do{O=d+(a<<2)|0;y=a|1;z=d+(y<<2)|0;E=(j[_+(y<<1)>>1]|0)+(f[z>>2]|0)|0;f[O>>2]=(j[_+(a<<1)>>1]|0)+(f[O>>2]|0);f[z>>2]=E;E=a|2;z=d+(E<<2)|0;O=a|3;y=d+(O<<2)|0;x=(j[_+(O<<1)>>1]|0)+(f[y>>2]|0)|0;f[z>>2]=(j[_+(E<<1)>>1]|0)+(f[z>>2]|0);f[y>>2]=x;a=a+4|0}while((a|0)<=(Z|0));fa=$+1|0}ba=ba+1|0;if((ba|0)==(e|0)){H=fa;break}else{$=fa;_=_+(g<<1)|0}}return H|0}while(1){if(!(b[c+ca>>0]|0))ga=da;else{_=0;do{fa=d+(_<<2)|0;$=_|1;ba=d+($<<2)|0;a=(j[ea+($<<1)>>1]|0)+(f[ba>>2]|0)|0;f[fa>>2]=(j[ea+(_<<1)>>1]|0)+(f[fa>>2]|0);f[ba>>2]=a;a=_|2;ba=d+(a<<2)|0;fa=_|3;$=d+(fa<<2)|0;x=(j[ea+(fa<<1)>>1]|0)+(f[$>>2]|0)|0;f[ba>>2]=(j[ea+(a<<1)>>1]|0)+(f[ba>>2]|0);f[$>>2]=x;_=_+4|0}while((_|0)<=(Z|0));ha=aa;do{_=d+(ha<<2)|0;f[_>>2]=(f[_>>2]|0)+(j[ea+(ha<<1)>>1]|0);ha=ha+1|0}while((ha|0)!=(g|0));ga=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){H=ga;break}else{da=ga;ea=ea+(g<<1)|0}}return H|0}}return 0}function H6(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=f[e>>2]|0;k=g+-4|0;if((g|0)<4){l=a;m=j;n=0}else{o=h<<1;p=h*3|0;q=h<<2;r=k>>>2;s=Y((r<<3)+8|0,h)|0;t=a;u=j;j=0;while(1){u=(d[t>>1]|0)+u+(d[t+(h<<1)>>1]|0)+(d[t+(o<<1)>>1]|0)+(d[t+(p<<1)>>1]|0)|0;j=j+4|0;if((j|0)>(k|0))break;else t=t+(q<<1)|0}l=a+s|0;m=u;n=(r<<2)+4|0}if((n|0)<(g|0)){r=m;u=n;s=l;while(1){l=(d[s>>1]|0)+r|0;u=u+1|0;if((u|0)==(g|0)){v=l;w=g;break}else{r=l;s=s+(h<<1)|0}}}else{v=m;w=n}f[e>>2]=v;x=w;break}case 2:{w=f[e>>2]|0;v=e+4|0;n=f[v>>2]|0;if((g|0)>0){m=n;s=w;r=0;u=a;while(1){l=(d[u>>1]|0)+s|0;q=(d[u+2>>1]|0)+m|0;r=r+1|0;if((r|0)==(g|0)){y=q;z=l;A=g;break}else{m=q;s=l;u=u+(h<<1)|0}}}else{y=n;z=w;A=0}f[e>>2]=z;f[v>>2]=y;x=A;break}case 3:{A=f[e>>2]|0;y=e+4|0;v=f[y>>2]|0;z=e+8|0;w=f[z>>2]|0;if((g|0)>0){n=w;u=v;s=A;m=0;r=a;while(1){l=(d[r>>1]|0)+s|0;q=(d[r+2>>1]|0)+u|0;t=(d[r+4>>1]|0)+n|0;m=m+1|0;if((m|0)==(g|0)){B=t;C=q;D=l;E=g;break}else{n=t;u=q;s=l;r=r+(h<<1)|0}}}else{B=w;C=v;D=A;E=0}f[e>>2]=D;f[y>>2]=C;f[z>>2]=B;x=E;break}default:x=0}if((i|0)<(h|0)){F=i;G=x}else{H=g;return H|0}while(1){x=e+(F<<2)|0;i=f[x>>2]|0;E=e+(F+1<<2)|0;B=f[E>>2]|0;z=e+(F+2<<2)|0;C=f[z>>2]|0;y=e+(F+3<<2)|0;D=f[y>>2]|0;if((G|0)<(g|0)){A=D;v=C;w=B;r=i;s=a+((Y(G,h)|0)<<1)+(F<<1)|0;u=G;while(1){n=(d[s>>1]|0)+r|0;m=(d[s+2>>1]|0)+w|0;l=(d[s+4>>1]|0)+v|0;q=(d[s+6>>1]|0)+A|0;u=u+1|0;if((u|0)==(g|0)){I=q;J=l;K=m;L=n;M=g;break}else{A=q;v=l;w=m;r=n;s=s+(h<<1)|0}}}else{I=D;J=C;K=B;L=i;M=G}f[x>>2]=L;f[E>>2]=K;f[z>>2]=J;f[y>>2]=I;F=F+4|0;if((F|0)>=(h|0)){H=g;break}else G=M}return H|0}switch(h|0){case 1:{M=f[e>>2]|0;if((g|0)>0){G=M;F=0;I=0;while(1){if(!(b[c+I>>0]|0)){N=G;O=F}else{N=(d[a+(I<<1)>>1]|0)+G|0;O=F+1|0}I=I+1|0;if((I|0)==(g|0)){P=N;Q=O;break}else{G=N;F=O}}}else{P=M;Q=0}f[e>>2]=P;H=Q;return H|0}case 3:{Q=f[e>>2]|0;P=e+4|0;M=f[P>>2]|0;O=e+8|0;F=f[O>>2]|0;if((g|0)>0){N=F;G=M;I=Q;J=0;K=0;L=a;while(1){if(!(b[c+J>>0]|0)){R=N;S=G;T=I;U=K}else{R=(d[L+4>>1]|0)+N|0;S=(d[L+2>>1]|0)+G|0;T=(d[L>>1]|0)+I|0;U=K+1|0}J=J+1|0;if((J|0)==(g|0)){V=R;W=S;X=T;Z=U;break}else{N=R;G=S;I=T;K=U;L=L+6|0}}}else{V=F;W=M;X=Q;Z=0}f[e>>2]=X;f[P>>2]=W;f[O>>2]=V;H=Z;return H|0}default:{if((g|0)<=0){H=0;return H|0}Z=h+-4|0;if((h|0)<4){if((h|0)>0){_=0;$=0;aa=a}else{V=0;O=0;while(1){W=O+((b[c+V>>0]|0)!=0&1)|0;V=V+1|0;if((V|0)==(g|0)){H=W;break}else O=W}return H|0}while(1){if(!(b[c+_>>0]|0))ba=$;else{O=0;do{V=e+(O<<2)|0;f[V>>2]=(f[V>>2]|0)+(d[aa+(O<<1)>>1]|0);O=O+1|0}while((O|0)!=(h|0));ba=$+1|0}_=_+1|0;if((_|0)==(g|0)){H=ba;break}else{$=ba;aa=aa+(h<<1)|0}}return H|0}aa=h&-4;if((aa|0)<(h|0)){ca=0;da=0;ea=a}else{ba=0;$=0;_=a;while(1){if(!(b[c+ba>>0]|0))fa=$;else{a=0;do{O=e+(a<<2)|0;y=a|1;z=e+(y<<2)|0;E=(d[_+(y<<1)>>1]|0)+(f[z>>2]|0)|0;f[O>>2]=(d[_+(a<<1)>>1]|0)+(f[O>>2]|0);f[z>>2]=E;E=a|2;z=e+(E<<2)|0;O=a|3;y=e+(O<<2)|0;x=(d[_+(O<<1)>>1]|0)+(f[y>>2]|0)|0;f[z>>2]=(d[_+(E<<1)>>1]|0)+(f[z>>2]|0);f[y>>2]=x;a=a+4|0}while((a|0)<=(Z|0));fa=$+1|0}ba=ba+1|0;if((ba|0)==(g|0)){H=fa;break}else{$=fa;_=_+(h<<1)|0}}return H|0}while(1){if(!(b[c+ca>>0]|0))ga=da;else{_=0;do{fa=e+(_<<2)|0;$=_|1;ba=e+($<<2)|0;a=(d[ea+($<<1)>>1]|0)+(f[ba>>2]|0)|0;f[fa>>2]=(d[ea+(_<<1)>>1]|0)+(f[fa>>2]|0);f[ba>>2]=a;a=_|2;ba=e+(a<<2)|0;fa=_|3;$=e+(fa<<2)|0;x=(d[ea+(fa<<1)>>1]|0)+(f[$>>2]|0)|0;f[ba>>2]=(d[ea+(a<<1)>>1]|0)+(f[ba>>2]|0);f[$>>2]=x;_=_+4|0}while((_|0)<=(Z|0));ha=aa;do{_=e+(ha<<2)|0;f[_>>2]=(f[_>>2]|0)+(d[ea+(ha<<1)>>1]|0);ha=ha+1|0}while((ha|0)!=(h|0));ga=da+1|0}ca=ca+1|0;if((ca|0)==(g|0)){H=ga;break}else{da=ga;ea=ea+(h<<1)|0}}return H|0}}return 0}function I6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=e+-4|0;if((e|0)<4){k=a;l=i;m=0}else{n=g<<1;o=g*3|0;q=g<<2;r=j>>>2;s=Y((r<<4)+16|0,g)|0;t=a;u=i;v=0;while(1){u=u+ +((f[t+(g<<2)>>2]|0)+(f[t>>2]|0)+(f[t+(n<<2)>>2]|0)+(f[t+(o<<2)>>2]|0)|0);v=v+4|0;if((v|0)>(j|0))break;else t=t+(q<<2)|0}k=a+s|0;l=u;m=(r<<2)+4|0}if((m|0)<(e|0)){u=l;r=m;s=k;while(1){i=u+ +(f[s>>2]|0);r=r+1|0;if((r|0)==(e|0)){w=i;x=e;break}else{u=i;s=s+(g<<2)|0}}}else{w=l;x=m}p[d>>3]=w;y=x;break}case 2:{w=+p[d>>3];x=d+8|0;l=+p[x>>3];if((e|0)>0){u=l;i=w;m=0;s=a;while(1){z=i+ +(f[s>>2]|0);A=u+ +(f[s+4>>2]|0);m=m+1|0;if((m|0)==(e|0)){B=A;C=z;D=e;break}else{u=A;i=z;s=s+(g<<2)|0}}}else{B=l;C=w;D=0}p[d>>3]=C;p[x>>3]=B;y=D;break}case 3:{B=+p[d>>3];D=d+8|0;C=+p[D>>3];x=d+16|0;w=+p[x>>3];if((e|0)>0){l=w;i=C;u=B;s=0;m=a;while(1){z=u+ +(f[m>>2]|0);A=i+ +(f[m+4>>2]|0);E=l+ +(f[m+8>>2]|0);s=s+1|0;if((s|0)==(e|0)){F=E;G=A;H=z;I=e;break}else{l=E;i=A;u=z;m=m+(g<<2)|0}}}else{F=w;G=C;H=B;I=0}p[d>>3]=H;p[D>>3]=G;p[x>>3]=F;y=I;break}default:y=0}if((h|0)<(g|0)){J=h;K=y}else{L=e;return L|0}while(1){y=d+(J<<3)|0;F=+p[y>>3];h=d+(J+1<<3)|0;G=+p[h>>3];I=d+(J+2<<3)|0;H=+p[I>>3];x=d+(J+3<<3)|0;B=+p[x>>3];if((K|0)<(e|0)){C=B;w=H;u=G;i=F;D=a+((Y(K,g)|0)<<2)+(J<<2)|0;m=K;while(1){l=i+ +(f[D>>2]|0);z=u+ +(f[D+4>>2]|0);A=w+ +(f[D+8>>2]|0);E=C+ +(f[D+12>>2]|0);m=m+1|0;if((m|0)==(e|0)){M=E;N=A;O=z;P=l;Q=e;break}else{C=E;w=A;u=z;i=l;D=D+(g<<2)|0}}}else{M=B;N=H;O=G;P=F;Q=K}p[y>>3]=P;p[h>>3]=O;p[I>>3]=N;p[x>>3]=M;J=J+4|0;if((J|0)>=(g|0)){L=e;break}else K=Q}return L|0}switch(g|0){case 1:{M=+p[d>>3];if((e|0)>0){N=M;Q=0;K=0;while(1){if(!(b[c+K>>0]|0)){R=N;S=Q}else{R=N+ +(f[a+(K<<2)>>2]|0);S=Q+1|0}K=K+1|0;if((K|0)==(e|0)){T=R;U=S;break}else{N=R;Q=S}}}else{T=M;U=0}p[d>>3]=T;L=U;return L|0}case 3:{T=+p[d>>3];U=d+8|0;M=+p[U>>3];S=d+16|0;R=+p[S>>3];if((e|0)>0){N=R;O=M;P=T;Q=0;K=0;J=a;while(1){if(!(b[c+Q>>0]|0)){V=N;W=O;X=P;Z=K}else{V=N+ +(f[J+8>>2]|0);W=O+ +(f[J+4>>2]|0);X=P+ +(f[J>>2]|0);Z=K+1|0}Q=Q+1|0;if((Q|0)==(e|0)){_=V;$=W;aa=X;ba=Z;break}else{N=V;O=W;P=X;K=Z;J=J+12|0}}}else{_=R;$=M;aa=T;ba=0}p[d>>3]=aa;p[U>>3]=$;p[S>>3]=_;L=ba;return L|0}default:{if((e|0)<=0){L=0;return L|0}ba=g+-4|0;if((g|0)<4){if((g|0)>0){ca=0;da=0;ea=a}else{S=0;U=0;while(1){J=U+((b[c+S>>0]|0)!=0&1)|0;S=S+1|0;if((S|0)==(e|0)){L=J;break}else U=J}return L|0}while(1){if(!(b[c+ca>>0]|0))fa=da;else{U=0;do{S=d+(U<<3)|0;p[S>>3]=+p[S>>3]+ +(f[ea+(U<<2)>>2]|0);U=U+1|0}while((U|0)!=(g|0));fa=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){L=fa;break}else{da=fa;ea=ea+(g<<2)|0}}return L|0}ea=g&-4;if((ea|0)<(g|0)){ga=0;ha=0;ia=a}else{fa=0;da=0;ca=a;while(1){if(!(b[c+fa>>0]|0))ja=da;else{a=0;do{U=d+(a<<3)|0;x=a|1;I=d+(x<<3)|0;F=+p[I>>3]+ +(f[ca+(x<<2)>>2]|0);p[U>>3]=+p[U>>3]+ +(f[ca+(a<<2)>>2]|0);p[I>>3]=F;I=a|2;U=d+(I<<3)|0;x=a|3;h=d+(x<<3)|0;F=+p[h>>3]+ +(f[ca+(x<<2)>>2]|0);p[U>>3]=+p[U>>3]+ +(f[ca+(I<<2)>>2]|0);p[h>>3]=F;a=a+4|0}while((a|0)<=(ba|0));ja=da+1|0}fa=fa+1|0;if((fa|0)==(e|0)){L=ja;break}else{da=ja;ca=ca+(g<<2)|0}}return L|0}while(1){if(!(b[c+ga>>0]|0))ka=ha;else{ca=0;do{ja=d+(ca<<3)|0;da=ca|1;fa=d+(da<<3)|0;F=+p[fa>>3]+ +(f[ia+(da<<2)>>2]|0);p[ja>>3]=+p[ja>>3]+ +(f[ia+(ca<<2)>>2]|0);p[fa>>3]=F;fa=ca|2;ja=d+(fa<<3)|0;da=ca|3;a=d+(da<<3)|0;F=+p[a>>3]+ +(f[ia+(da<<2)>>2]|0);p[ja>>3]=+p[ja>>3]+ +(f[ia+(fa<<2)>>2]|0);p[a>>3]=F;ca=ca+4|0}while((ca|0)<=(ba|0));la=ea;do{ca=d+(la<<3)|0;p[ca>>3]=+p[ca>>3]+ +(f[ia+(la<<2)>>2]|0);la=la+1|0}while((la|0)!=(g|0));ka=ha+1|0}ga=ga+1|0;if((ga|0)==(e|0)){L=ka;break}else{ha=ka;ia=ia+(g<<2)|0}}return L|0}}return 0}function J6(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;if(!c){g=(f|0)%4|0;switch(g|0){case 1:{h=+p[d>>3];i=e+-4|0;if((e|0)<4){j=a;k=h;l=0}else{m=f<<1;o=f*3|0;q=f<<2;r=i>>>2;s=Y((r<<4)+16|0,f)|0;t=a;u=h;v=0;while(1){u=u+(+n[t>>2]+ +n[t+(f<<2)>>2]+ +n[t+(m<<2)>>2]+ +n[t+(o<<2)>>2]);v=v+4|0;if((v|0)>(i|0))break;else t=t+(q<<2)|0}j=a+s|0;k=u;l=(r<<2)+4|0}if((l|0)<(e|0)){u=k;r=l;s=j;while(1){h=u+ +n[s>>2];r=r+1|0;if((r|0)==(e|0)){w=h;x=e;break}else{u=h;s=s+(f<<2)|0}}}else{w=k;x=l}p[d>>3]=w;y=x;break}case 2:{w=+p[d>>3];x=d+8|0;k=+p[x>>3];if((e|0)>0){u=k;h=w;l=0;s=a;while(1){z=h+ +n[s>>2];A=u+ +n[s+4>>2];l=l+1|0;if((l|0)==(e|0)){B=A;C=z;D=e;break}else{u=A;h=z;s=s+(f<<2)|0}}}else{B=k;C=w;D=0}p[d>>3]=C;p[x>>3]=B;y=D;break}case 3:{B=+p[d>>3];D=d+8|0;C=+p[D>>3];x=d+16|0;w=+p[x>>3];if((e|0)>0){k=w;h=C;u=B;s=0;l=a;while(1){z=u+ +n[l>>2];A=h+ +n[l+4>>2];E=k+ +n[l+8>>2];s=s+1|0;if((s|0)==(e|0)){F=E;G=A;H=z;I=e;break}else{k=E;h=A;u=z;l=l+(f<<2)|0}}}else{F=w;G=C;H=B;I=0}p[d>>3]=H;p[D>>3]=G;p[x>>3]=F;y=I;break}default:y=0}if((g|0)<(f|0)){J=g;K=y}else{L=e;return L|0}while(1){y=d+(J<<3)|0;F=+p[y>>3];g=d+(J+1<<3)|0;G=+p[g>>3];I=d+(J+2<<3)|0;H=+p[I>>3];x=d+(J+3<<3)|0;B=+p[x>>3];if((K|0)<(e|0)){C=B;w=H;u=G;h=F;D=a+((Y(K,f)|0)<<2)+(J<<2)|0;l=K;while(1){k=h+ +n[D>>2];z=u+ +n[D+4>>2];A=w+ +n[D+8>>2];E=C+ +n[D+12>>2];l=l+1|0;if((l|0)==(e|0)){M=E;N=A;O=z;P=k;Q=e;break}else{C=E;w=A;u=z;h=k;D=D+(f<<2)|0}}}else{M=B;N=H;O=G;P=F;Q=K}p[y>>3]=P;p[g>>3]=O;p[I>>3]=N;p[x>>3]=M;J=J+4|0;if((J|0)>=(f|0)){L=e;break}else K=Q}return L|0}switch(f|0){case 1:{M=+p[d>>3];if((e|0)>0){N=M;Q=0;K=0;while(1){if(!(b[c+K>>0]|0)){R=N;S=Q}else{R=N+ +n[a+(K<<2)>>2];S=Q+1|0}K=K+1|0;if((K|0)==(e|0)){T=R;U=S;break}else{N=R;Q=S}}}else{T=M;U=0}p[d>>3]=T;L=U;return L|0}case 3:{T=+p[d>>3];U=d+8|0;M=+p[U>>3];S=d+16|0;R=+p[S>>3];if((e|0)>0){N=R;O=M;P=T;Q=0;K=0;J=a;while(1){if(!(b[c+Q>>0]|0)){V=N;W=O;X=P;Z=K}else{V=N+ +n[J+8>>2];W=O+ +n[J+4>>2];X=P+ +n[J>>2];Z=K+1|0}Q=Q+1|0;if((Q|0)==(e|0)){_=V;$=W;aa=X;ba=Z;break}else{N=V;O=W;P=X;K=Z;J=J+12|0}}}else{_=R;$=M;aa=T;ba=0}p[d>>3]=aa;p[U>>3]=$;p[S>>3]=_;L=ba;return L|0}default:{if((e|0)<=0){L=0;return L|0}ba=f+-4|0;if((f|0)<4){if((f|0)>0){ca=0;da=0;ea=a}else{S=0;U=0;while(1){J=U+((b[c+S>>0]|0)!=0&1)|0;S=S+1|0;if((S|0)==(e|0)){L=J;break}else U=J}return L|0}while(1){if(!(b[c+ca>>0]|0))fa=da;else{U=0;do{S=d+(U<<3)|0;p[S>>3]=+p[S>>3]+ +n[ea+(U<<2)>>2];U=U+1|0}while((U|0)!=(f|0));fa=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){L=fa;break}else{da=fa;ea=ea+(f<<2)|0}}return L|0}ea=f&-4;if((ea|0)<(f|0)){ga=0;ha=0;ia=a}else{fa=0;da=0;ca=a;while(1){if(!(b[c+fa>>0]|0))ja=da;else{a=0;do{U=d+(a<<3)|0;x=a|1;I=d+(x<<3)|0;F=+p[I>>3]+ +n[ca+(x<<2)>>2];p[U>>3]=+p[U>>3]+ +n[ca+(a<<2)>>2];p[I>>3]=F;I=a|2;U=d+(I<<3)|0;x=a|3;g=d+(x<<3)|0;F=+p[g>>3]+ +n[ca+(x<<2)>>2];p[U>>3]=+p[U>>3]+ +n[ca+(I<<2)>>2];p[g>>3]=F;a=a+4|0}while((a|0)<=(ba|0));ja=da+1|0}fa=fa+1|0;if((fa|0)==(e|0)){L=ja;break}else{da=ja;ca=ca+(f<<2)|0}}return L|0}while(1){if(!(b[c+ga>>0]|0))ka=ha;else{ca=0;do{ja=d+(ca<<3)|0;da=ca|1;fa=d+(da<<3)|0;F=+p[fa>>3]+ +n[ia+(da<<2)>>2];p[ja>>3]=+p[ja>>3]+ +n[ia+(ca<<2)>>2];p[fa>>3]=F;fa=ca|2;ja=d+(fa<<3)|0;da=ca|3;a=d+(da<<3)|0;F=+p[a>>3]+ +n[ia+(da<<2)>>2];p[ja>>3]=+p[ja>>3]+ +n[ia+(fa<<2)>>2];p[a>>3]=F;ca=ca+4|0}while((ca|0)<=(ba|0));la=ea;do{ca=d+(la<<3)|0;p[ca>>3]=+p[ca>>3]+ +n[ia+(la<<2)>>2];la=la+1|0}while((la|0)!=(f|0));ka=ha+1|0}ga=ga+1|0;if((ga|0)==(e|0)){L=ka;break}else{ha=ka;ia=ia+(f<<2)|0}}return L|0}}return 0}function K6(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0,S=0.0,T=0,U=0.0,V=0.0,W=0.0,X=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;if(!c){g=(f|0)%4|0;switch(g|0){case 1:{h=+p[d>>3];i=e+-4|0;if((e|0)<4){j=a;k=h;l=0}else{m=f<<1;n=f*3|0;o=f<<2;q=i>>>2;r=Y((q<<5)+32|0,f)|0;s=a;t=h;u=0;while(1){t=t+(+p[s>>3]+ +p[s+(f<<3)>>3]+ +p[s+(m<<3)>>3]+ +p[s+(n<<3)>>3]);u=u+4|0;if((u|0)>(i|0))break;else s=s+(o<<3)|0}j=a+r|0;k=t;l=(q<<2)+4|0}if((l|0)<(e|0)){t=k;q=l;r=j;while(1){h=t+ +p[r>>3];q=q+1|0;if((q|0)==(e|0)){v=h;w=e;break}else{t=h;r=r+(f<<3)|0}}}else{v=k;w=l}p[d>>3]=v;x=w;break}case 2:{v=+p[d>>3];w=d+8|0;k=+p[w>>3];if((e|0)>0){t=k;h=v;l=0;r=a;while(1){y=h+ +p[r>>3];z=t+ +p[r+8>>3];l=l+1|0;if((l|0)==(e|0)){A=z;B=y;C=e;break}else{t=z;h=y;r=r+(f<<3)|0}}}else{A=k;B=v;C=0}p[d>>3]=B;p[w>>3]=A;x=C;break}case 3:{A=+p[d>>3];C=d+8|0;B=+p[C>>3];w=d+16|0;v=+p[w>>3];if((e|0)>0){k=v;h=B;t=A;r=0;l=a;while(1){y=t+ +p[l>>3];z=h+ +p[l+8>>3];D=k+ +p[l+16>>3];r=r+1|0;if((r|0)==(e|0)){E=D;F=z;G=y;H=e;break}else{k=D;h=z;t=y;l=l+(f<<3)|0}}}else{E=v;F=B;G=A;H=0}p[d>>3]=G;p[C>>3]=F;p[w>>3]=E;x=H;break}default:x=0}if((g|0)<(f|0)){I=g;J=x}else{K=e;return K|0}while(1){x=d+(I<<3)|0;E=+p[x>>3];g=d+(I+1<<3)|0;F=+p[g>>3];H=d+(I+2<<3)|0;G=+p[H>>3];w=d+(I+3<<3)|0;A=+p[w>>3];if((J|0)<(e|0)){B=A;v=G;t=F;h=E;C=a+((Y(J,f)|0)<<3)+(I<<3)|0;l=J;while(1){k=h+ +p[C>>3];y=t+ +p[C+8>>3];z=v+ +p[C+16>>3];D=B+ +p[C+24>>3];l=l+1|0;if((l|0)==(e|0)){L=D;M=z;N=y;O=k;P=e;break}else{B=D;v=z;t=y;h=k;C=C+(f<<3)|0}}}else{L=A;M=G;N=F;O=E;P=J}p[x>>3]=O;p[g>>3]=N;p[H>>3]=M;p[w>>3]=L;I=I+4|0;if((I|0)>=(f|0)){K=e;break}else J=P}return K|0}switch(f|0){case 1:{L=+p[d>>3];if((e|0)>0){M=L;P=0;J=0;while(1){if(!(b[c+J>>0]|0)){Q=M;R=P}else{Q=M+ +p[a+(J<<3)>>3];R=P+1|0}J=J+1|0;if((J|0)==(e|0)){S=Q;T=R;break}else{M=Q;P=R}}}else{S=L;T=0}p[d>>3]=S;K=T;return K|0}case 3:{S=+p[d>>3];T=d+8|0;L=+p[T>>3];R=d+16|0;Q=+p[R>>3];if((e|0)>0){M=Q;N=L;O=S;P=0;J=0;I=a;while(1){if(!(b[c+P>>0]|0)){U=M;V=N;W=O;X=J}else{U=M+ +p[I+16>>3];V=N+ +p[I+8>>3];W=O+ +p[I>>3];X=J+1|0}P=P+1|0;if((P|0)==(e|0)){Z=U;_=V;$=W;aa=X;break}else{M=U;N=V;O=W;J=X;I=I+24|0}}}else{Z=Q;_=L;$=S;aa=0}p[d>>3]=$;p[T>>3]=_;p[R>>3]=Z;K=aa;return K|0}default:{if((e|0)<=0){K=0;return K|0}aa=f+-4|0;if((f|0)<4){if((f|0)>0){ba=0;ca=0;da=a}else{R=0;T=0;while(1){I=T+((b[c+R>>0]|0)!=0&1)|0;R=R+1|0;if((R|0)==(e|0)){K=I;break}else T=I}return K|0}while(1){if(!(b[c+ba>>0]|0))ea=ca;else{T=0;do{R=d+(T<<3)|0;p[R>>3]=+p[da+(T<<3)>>3]+ +p[R>>3];T=T+1|0}while((T|0)!=(f|0));ea=ca+1|0}ba=ba+1|0;if((ba|0)==(e|0)){K=ea;break}else{ca=ea;da=da+(f<<3)|0}}return K|0}da=f&-4;if((da|0)<(f|0)){fa=0;ga=0;ha=a}else{ea=0;ca=0;ba=a;while(1){if(!(b[c+ea>>0]|0))ia=ca;else{a=0;do{T=d+(a<<3)|0;w=a|1;H=d+(w<<3)|0;E=+p[H>>3]+ +p[ba+(w<<3)>>3];p[T>>3]=+p[T>>3]+ +p[ba+(a<<3)>>3];p[H>>3]=E;H=a|2;T=d+(H<<3)|0;w=a|3;g=d+(w<<3)|0;E=+p[g>>3]+ +p[ba+(w<<3)>>3];p[T>>3]=+p[T>>3]+ +p[ba+(H<<3)>>3];p[g>>3]=E;a=a+4|0}while((a|0)<=(aa|0));ia=ca+1|0}ea=ea+1|0;if((ea|0)==(e|0)){K=ia;break}else{ca=ia;ba=ba+(f<<3)|0}}return K|0}while(1){if(!(b[c+fa>>0]|0))ja=ga;else{ba=0;do{ia=d+(ba<<3)|0;ca=ba|1;ea=d+(ca<<3)|0;E=+p[ea>>3]+ +p[ha+(ca<<3)>>3];p[ia>>3]=+p[ia>>3]+ +p[ha+(ba<<3)>>3];p[ea>>3]=E;ea=ba|2;ia=d+(ea<<3)|0;ca=ba|3;a=d+(ca<<3)|0;E=+p[a>>3]+ +p[ha+(ca<<3)>>3];p[ia>>3]=+p[ia>>3]+ +p[ha+(ea<<3)>>3];p[a>>3]=E;ba=ba+4|0}while((ba|0)<=(aa|0));ka=da;do{ba=d+(ka<<3)|0;p[ba>>3]=+p[ha+(ka<<3)>>3]+ +p[ba>>3];ka=ka+1|0}while((ka|0)!=(f|0));ja=ga+1|0}fa=fa+1|0;if((fa|0)==(e|0)){K=ja;break}else{ga=ja;ha=ha+(f<<3)|0}}return K|0}}return 0}function L6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+1168|0;e=d+1112|0;g=d+1104|0;h=d+1096|0;i=d+1064|0;j=d;do if((d$(c)|0)==65536){k=f[c+4>>2]|0;f[e>>2]=f[k>>2];l=e+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=e+8|0;f[n>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[e+16>>2]=f[k+16>>2];f[e+20>>2]=f[k+20>>2];f[e+24>>2]=f[k+24>>2];f[e+28>>2]=f[k+28>>2];f[e+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=n;n=e+48|0;q=e+44|0;f[q>>2]=n;f[n>>2]=0;f[e+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];r=e;break}else{f[l>>2]=0;ZS(e,k);r=e;break}}else{a$(e,c,-1);r=e}while(0);c=f[r>>2]|0;r=c>>>3&511;k=r+1|0;l=c&7;c=f[46372+(l<<2)>>2]|0;if(!((l|0)!=7&k>>>0<5)){f[g>>2]=0;f[g+4>>2]=0;m=tT(g,20)|0;n=241864;q=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(q|0));z5(-215,g,454649,241885,617)}f[g>>2]=e;f[g+4>>2]=0;f[h>>2]=0;z2(i,g,h,-1);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;g=f[i+20>>2]|0;n=j+8|0;f[j>>2]=n;m=j+4|0;f[m>>2]=264;q=l>>>0<4;if(q){o=l>>>0<2?8388608:32768;l=(o|0)<(g|0)?o:g;f[m>>2]=k;XIc(n|0,0,(r<<2)+4|0)|0;r=f[e+4>>2]|0;if((r|0)>0){s=l;t=o;v=f[(f[e+44>>2]|0)+(r+-1<<2)>>2]|0;w=n}else{s=l;t=o;v=0;w=n}}else{s=g;t=0;v=0;w=a}o=i+16|0;a:do if((g|0)>0){l=0;r=0;while(1){if(l>>>0>=(f[o>>2]|0)>>>0)break a;x=l+1|0;y=f[h>>2]|0;if(q){z=0;A=r;B=y;while(1){C=g-z|0;D=(s|0)<(C|0)?s:C;_h[c&127](B,0,w,D,k)|0;C=D+A|0;if((C+s|0)<(t|0)?((D+z|0)<(g|0)?1:x>>>0<(f[o>>2]|0)>>>0):0)E=C;else{F=0;G=21}if((G|0)==21)while(1){G=0;C=w+(F<<2)|0;H=a+(F<<3)|0;p[H>>3]=+p[H>>3]+ +(f[C>>2]|0);f[C>>2]=0;F=F+1|0;if((F|0)==(k|0)){E=0;break}else G=21}C=Y(D,v)|0;B=(f[h>>2]|0)+C|0;f[h>>2]=B;z=z+s|0;if((g|0)<=(z|0)){I=E;break}else A=E}}else{A=0;z=r;B=y;while(1){C=g-A|0;H=(s|0)<(C|0)?s:C;_h[c&127](B,0,w,H,k)|0;C=H+z|0;J=Y(H,v)|0;B=(f[h>>2]|0)+J|0;f[h>>2]=B;A=A+s|0;if((g|0)<=(A|0)){I=C;break}else z=C}}A2(i)|0;l=x;r=I}}else{r=0;while(1){if(r>>>0>=(f[o>>2]|0)>>>0)break a;A2(i)|0;r=r+1|0}}while(0);i=f[j>>2]|0;if((i|0)!=(n|0)){if(i|0)ZDc(i);f[j>>2]=n;f[m>>2]=264}m=e+36|0;n=f[m>>2]|0;if(n|0?(j=n+12|0,n=f[j>>2]|0,f[j>>2]=n+-1,(n|0)==1):0)_S(e);f[m>>2]=0;m=e+16|0;n=e+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){m=f[e+40>>2]|0;j=0;do{f[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[n>>2]|0))}n=f[e+44>>2]|0;if((n|0)==(e+48|0)){u=d;return}g0(n);u=d;return}function M6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,q=0.0,r=0.0;f=u;u=u+1536|0;g=f+1024|0;h=f+512|0;i=f;if((d|0)<=0){u=f;return}j=e?1.0:.01745329238474369;e=0;do{k=d-e|0;l=(k|0)<128?k:128;m=(k|0)>0;if(m){k=0;do{o=k+e|0;n[g+(k<<2)>>2]=+p[a+(o<<3)>>3];n[h+(k<<2)>>2]=+p[b+(o<<3)>>3];k=k+1|0}while((k|0)<(l|0));if(m){k=0;do{q=+U(+(+n[g+(k<<2)>>2]),+(+n[h+(k<<2)>>2]))*180.0/3.141592653589793;r=q<0.0?q+360.0:q;n[i+(k<<2)>>2]=j*(!(r>=360.0)?r:r+-360.0);k=k+1|0}while((k|0)!=(l|0));if(m){k=0;do{p[c+(k+e<<3)>>3]=+n[i+(k<<2)>>2];k=k+1|0}while((k|0)<(l|0))}}}e=e+128|0}while((e|0)<(d|0));u=f;return}function N6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0;f=e?1.0:.01745329238474369;if((d|0)>0)g=0;else return;do{h=+U(+(+n[a+(g<<2)>>2]),+(+n[b+(g<<2)>>2]))*180.0/3.141592653589793;i=h<0.0?h+360.0:h;n[c+(g<<2)>>2]=f*(!(i>=360.0)?i:i+-360.0);g=g+1|0}while((g|0)!=(d|0));return}function O6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;M6(a,b,c,d,e);return}function P6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0;f=e?1.0:.01745329238474369;if((d|0)>0)g=0;else return;do{h=+U(+(+n[a+(g<<2)>>2]),+(+n[b+(g<<2)>>2]))*180.0/3.141592653589793;i=h<0.0?h+360.0:h;n[c+(g<<2)>>2]=f*(!(i>=360.0)?i:i+-360.0);g=g+1|0}while((g|0)!=(d|0));return}function Q6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0.0;if((d|0)>0)e=0;else return;do{f=+n[a+(e<<2)>>2];g=+n[b+(e<<2)>>2];h=+M(+(f*f+g*g));n[c+(e<<2)>>2]=h;e=e+1|0}while((e|0)!=(d|0));return}function R6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0.0;if((d|0)>0)e=0;else return;do{f=+p[a+(e<<3)>>3];g=+p[b+(e<<3)>>3];h=+M(+(f*f+g*g));p[c+(e<<3)>>3]=h;e=e+1|0}while((e|0)!=(d|0));return}function S6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=1.0/+M(+(+n[a+(d<<2)>>2]));n[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function T6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=1.0/+M(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function U6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+M(+(+n[a+(d<<2)>>2]));n[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function V6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+M(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function W6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+V(+(+n[a+(d<<2)>>2]));n[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function X6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+V(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function Y6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+W(+(+n[a+(d<<2)>>2]));n[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function Z6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+W(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function _6(a,b){a=+a;b=+b;var c=0.0;c=+U(+a,+b)*180.0/3.141592653589793;b=c<0.0?c+360.0:c;return +(!(b>=360.0)?b:b+-360.0)}function $6(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;f[c>>2]=0;f[c+4>>2]=0;a=tT(c,44)|0;d=243342;e=a+44|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));z5(-216,c,243387,243401,107)}function a7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$6()}function b7(a){a=a|0;return}function c7(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=h0(24)|0;if(!d){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,241947,92)}else{c=d+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[d>>2]=1116274688;f[d+16>>2]=(a|0)<1?65408:a+7&-8;u=b;return d|0}return 0}function d7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,241965,d);return}function e7(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,242035,121)}d=f[a+16>>2]|0;e=h0(24)|0;if(!e){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,241947,92)}else{c=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[e>>2]=1116274688;f[e+16>>2]=(d|0)<1?65408:d+7&-8;f[e+12>>2]=a;u=b;return e|0}return 0}function f7(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,242059,183)}c=f[a>>2]|0;f[a>>2]=0;if(!c){u=b;return}a=c+12|0;d=f[a>>2]|0;if(!d)e=0;else e=f[d+8>>2]|0;g=c+4|0;h=f[g>>2]|0;a:do if(!h)i=c+20|0;else{j=c+16|0;k=c+20|0;l=e;m=h;n=d;while(1){o=m+4|0;p=f[o>>2]|0;if(!n){q=m;r=p;while(1){i0(q);if(!r){i=k;break a}s=f[a>>2]|0;t=r+4|0;v=f[t>>2]|0;if(!s){w=r;r=v;q=w}else{x=r;y=v;z=t;A=s;break}}}else{x=m;y=p;z=o;A=n}if(!l){f[A+8>>2]=x;f[A+4>>2]=x;f[z>>2]=0;f[x>>2]=0;f[k>>2]=(f[j>>2]|0)+-8}else{f[x>>2]=l;r=l+4|0;q=f[r>>2]|0;f[z>>2]=q;if(q|0)f[q>>2]=x;f[r>>2]=x}if(!y){i=k;break}else{l=x;m=y;n=A}}}while(0);f[g>>2]=0;f[c+8>>2]=0;f[i>>2]=0;i0(c);u=b;return}function g7(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,242079,200)}c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;if(!c){f[a+8>>2]=e;if(!e)g=0;else g=(f[a+16>>2]|0)+-8|0;f[a+20>>2]=g;u=b;return}if(!e)h=a+20|0;else{g=a+16|0;i=a+20|0;j=c+8|0;k=c+4|0;l=f[c+8>>2]|0;c=e;while(1){e=c+4|0;m=f[e>>2]|0;if(!l){f[j>>2]=c;f[k>>2]=c;f[e>>2]=0;f[c>>2]=0;f[i>>2]=(f[g>>2]|0)+-8}else{f[c>>2]=l;n=l+4|0;o=f[n>>2]|0;f[e>>2]=o;if(o|0)f[o>>2]=c;f[n>>2]=c}if(!m){h=i;break}else{n=c;c=m;l=n}}}f[d>>2]=0;f[a+8>>2]=0;f[h>>2]=0;u=b;return}function h7(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;if((a|0)!=0&(b|0)!=0){f[b>>2]=f[a+8>>2];f[b+4>>2]=f[a+20>>2];u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;d7(-27,d,242097,276)}}function i7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;d7(-27,d,242117,288)}e=f[b+4>>2]|0;g=f[a+16>>2]|0;if((e|0)>(g|0)){f[d>>2]=0;f[d+4>>2]=0;d7(-201,d,242117,290)}d=f[b>>2]|0;b=a+8|0;f[b>>2]=d;h=a+20|0;f[h>>2]=e;if(d|0){u=c;return}d=f[a+4>>2]|0;f[b>>2]=d;f[h>>2]=(d|0)==0?0:g+-8|0;u=c;return}function j7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,20)|0;h=254626;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));d7(-27,e,242140,327)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,35)|0;h=242158;i=g+35|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));d7(-211,e,242140,330)}j=a+20|0;k=f[j>>2]|0;l=a+16|0;if(k>>>0>=c>>>0){m=k;n=a+8|0;o=f[n>>2]|0;p=f[l>>2]|0;q=o+p|0;r=0-m|0;s=q+r|0;t=m-c|0;v=t&-8;f[j>>2]=v;u=d;return s|0}if(((f[l>>2]|0)+-8&-8)>>>0<c>>>0){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,37)|0;h=242194;i=g+37|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));d7(-211,e,242140,338)}k7(a);m=f[j>>2]|0;n=a+8|0;o=f[n>>2]|0;p=f[l>>2]|0;q=o+p|0;r=0-m|0;s=q+r|0;t=m-c|0;v=t&-8;f[j>>2]=v;u=d;return s|0}function k7(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,242232,218)}d=a+8|0;e=f[d>>2]|0;if((e|0)!=0?(g=f[e+4>>2]|0,(g|0)!=0):0)h=g;else{g=f[a+12>>2]|0;do if(g){e=g+8|0;i=f[e>>2]|0;j=g+20|0;k=f[j>>2]|0;k7(g);l=f[e>>2]|0;m=f[g+16>>2]|0;if((k|0)>(m|0)){f[c>>2]=0;f[c+4>>2]=0;d7(-201,c,242117,290)}f[e>>2]=i;f[j>>2]=k;if(!i){k=f[g+4>>2]|0;f[e>>2]=k;f[j>>2]=(k|0)==0?0:m+-8|0;n=k;o=k}else{n=i;o=i}if((l|0)==(n|0)){f[g+4>>2]=0;f[e>>2]=0;f[j>>2]=0;p=l;break}j=l+4|0;f[n+4>>2]=f[j>>2];e=f[j>>2]|0;if(!e)p=l;else{f[e>>2]=o;p=l}}else p=h0(f[a+16>>2]|0)|0;while(0);f[p+4>>2]=0;o=f[d>>2]|0;f[p>>2]=o;if(!o){f[a+4>>2]=p;q=d}else q=o+4|0;f[q>>2]=p;p=f[(f[d>>2]|0)+4>>2]|0;if(!p){r=a+16|0;s=f[r>>2]|0;t=s+-8|0;v=a+20|0;f[v>>2]=t;u=b;return}else h=p}f[d>>2]=h;r=a+16|0;s=f[r>>2]|0;t=s+-8|0;v=a+20|0;f[v>>2]=t;u=b;return}function l7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=a;f[g>>2]=0;f[g+4>>2]=0;if((e|0)>-1)h=e;else h=Mpc(d)|0;f[a>>2]=h;e=j7(c,h+1|0)|0;f[a+4>>2]=e;dJc(e|0,d|0,h|0)|0;b[e+h>>0]=0;return}function m7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;if(!e){f[h>>2]=0;f[h+4>>2]=0;d7(-27,h,242250,377)}if(c>>>0<56|(d|0)==0){f[h>>2]=0;f[h+4>>2]=0;d7(-201,h,242250,379)}i=j7(e,c)|0;XIc(i|0,0,c|0)|0;f[i+4>>2]=c;f[i>>2]=a&65535|1117323264;c=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);a:do if(c|0){switch(a&4095){case 0:case 7:{break a;break}default:{}}if((c|0)!=(d|0)){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,110)|0;k=242262;l=j+110|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));d7(-201,h,242250,395)}}while(0);f[i+28>>2]=d;f[i+44>>2]=e;n7(i,1024/(d>>>0)|0);u=g;return i|0}function n7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;g=e+4|0;f[g>>2]=0;d7(-27,e,242373,415)}h=f[a+44>>2]|0;if(!h){f[e>>2]=0;g=e+4|0;f[g>>2]=0;d7(-27,e,242373,415)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;d7(-211,e,242373,417)}g=(f[h+16>>2]|0)+-28&-8;h=f[a+28>>2]|0;if(!c){i=1024/(h|0)|0;j=(i|0)>1?i:1}else j=c;if((Y(j,h)|0)<=(g|0)){k=j;l=a+40|0;f[l>>2]=k;u=d;return}j=(g|0)/(h|0)|0;if(!j){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,60)|0;g=242391;c=h+60|0;do{b[h>>0]=b[g>>0]|0;h=h+1|0;g=g+1|0}while((h|0)<(c|0));d7(-211,e,242373,433)}else{k=j;l=a+40|0;f[l>>2]=k;u=d;return}}function o7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+24>>2]|0;if(c>>>0<=b>>>0){d=((b|0)<0?c:0)+b|0;e=d-((d|0)>=(c|0)?c:0)|0;if(e>>>0<c>>>0)g=e;else{h=0;return h|0}}else g=b;b=f[a+52>>2]|0;if((g<<1|0)<=(c|0)){e=f[b+12>>2]|0;if((g|0)<(e|0)){i=b;j=g}else{d=b;k=g;l=e;while(1){e=f[d+4>>2]|0;m=k-l|0;l=f[e+12>>2]|0;if((m|0)<(l|0)){i=e;j=m;break}else{d=e;k=m}}}}else{k=c;c=b;do{c=f[c>>2]|0;k=k-(f[c+12>>2]|0)|0}while((g|0)<(k|0));i=c;j=g-k|0}h=(f[i+16>>2]|0)+(Y(f[a+28>>2]|0,j)|0)|0;return h|0}function p7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+48|0;e=d+8|0;g=d;if(!((a|0)!=0&(b|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242484,551)}g=f[a+28>>2]|0;h=c;c=f[h>>2]|0;i=f[h+4>>2]|0;h=f[a+24>>2]|0;if((i|0)==(c|0))j=0;else j=i-c+((c|0)<0?0-h|0:0)+((i|0)<1?h:0)|0;while(1)if((j|0)<0)j=j+h|0;else break;i=Y((j|0)>(h|0)?h:j,g)|0;if(!i){k=0;u=d;return k|0}j=e+4|0;h=e+8|0;l=e+20|0;m=e+12|0;n=j+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[e>>2]=32;f[j>>2]=a;j=f[a+52>>2]|0;if(!j){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0}else{a=f[j>>2]|0;n=f[j+16>>2]|0;f[m>>2]=n;o=(f[a+16>>2]|0)+(Y((f[a+12>>2]|0)+-1|0,g)|0)|0;f[e+28>>2]=o;f[e+24>>2]=f[j+8>>2];o=n;f[h>>2]=j;f[e+16>>2]=o;n=o+(Y(f[j+12>>2]|0,g)|0)|0;f[l>>2]=n}q7(e,c,0);c=i;i=b;e=f[m>>2]|0;n=f[l>>2]|0;while(1){j=n-e|0;o=(j|0)>(c|0)?c:j;dJc(i|0,e|0,o|0)|0;j=f[(f[h>>2]|0)+4>>2]|0;f[h>>2]=j;e=f[j+16>>2]|0;f[m>>2]=e;n=e+(Y(f[j+12>>2]|0,g)|0)|0;f[l>>2]=n;c=c-o|0;if((c|0)<=0){k=b;break}else i=i+o|0}u=d;return k|0}function q7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;g=e+4|0;f[g>>2]=0;d7(-27,e,242500,1045)}h=f[a+4>>2]|0;if(!h){f[e>>2]=0;g=e+4|0;f[g>>2]=0;d7(-27,e,242500,1045)}g=f[h+24>>2]|0;i=f[h+28>>2]|0;if(c|0){c=a+12|0;j=f[c>>2]|0;k=Y(i,b)|0;l=a+8|0;m=f[l>>2]|0;n=j+k|0;if((k|0)>0){o=a+20|0;p=f[o>>2]|0;if(n>>>0<p>>>0)q=n;else{r=j;s=m;t=k;v=p;do{t=t+r-v|0;s=f[s+4>>2]|0;r=f[s+16>>2]|0;p=Y(f[s+12>>2]|0,i)|0;v=r+p|0}while((t|0)>=(p|0));f[l>>2]=s;f[a+16>>2]=r;f[o>>2]=v;q=r+t|0}}else{t=a+16|0;r=f[t>>2]|0;if(n>>>0<r>>>0){v=j;j=m;m=k;k=r;do{m=m+v-k|0;j=f[j>>2]|0;k=f[j+16>>2]|0;v=k+(Y(f[j+12>>2]|0,i)|0)|0;w=v+m|0}while(w>>>0<k>>>0);f[l>>2]=j;f[t>>2]=k;f[a+20>>2]=v;q=w}else q=n}f[c>>2]=q;u=d;return}do if((b|0)<0)if((b|0)<(0-g|0)){f[e>>2]=0;f[e+4>>2]=0;d7(-211,e,242500,1055)}else{x=g+b|0;break}else if((g|0)<=(b|0)){q=b-g|0;if((q|0)<(g|0))x=q;else{f[e>>2]=0;f[e+4>>2]=0;d7(-211,e,242500,1062)}}else x=b;while(0);b=f[h+52>>2]|0;h=f[b+12>>2]|0;a:do if((x|0)<(h|0)){y=x;z=b;A=h}else{if((x<<1|0)>(g|0)){B=g;C=b}else{e=b;q=h;c=x;while(1){n=f[e+4>>2]|0;w=c-q|0;v=f[n+12>>2]|0;if((w|0)<(v|0)){y=w;z=n;A=v;break a}else{e=n;q=v;c=w}}}do{C=f[C>>2]|0;D=f[C+12>>2]|0;B=B-D|0}while((x|0)<(B|0));y=x-B|0;z=C;A=D}while(0);D=f[z+16>>2]|0;C=D+(Y(y,i)|0)|0;f[a+12>>2]=C;C=a+8|0;if((f[C>>2]|0)==(z|0)){u=d;return}f[C>>2]=z;f[a+16>>2]=D;z=D+(Y(A,i)|0)|0;f[a+20>>2]=z;u=d;return}function r7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;if(!b){f[e>>2]=0;g=e+4|0;f[g>>2]=0;d7(-27,e,242518,945)}h=b+4|0;i=b+8|0;j=b+12|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;if(!a){f[e>>2]=0;g=e+4|0;f[g>>2]=0;d7(-27,e,242518,945)}f[b>>2]=32;f[h>>2]=a;h=f[a+52>>2]|0;if(!h){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;u=d;return}e=f[h>>2]|0;g=f[h+16>>2]|0;f[j>>2]=g;k=f[e+16>>2]|0;l=f[a+28>>2]|0;a=k+(Y((f[e+12>>2]|0)+-1|0,l)|0)|0;m=b+28|0;f[m>>2]=a;f[b+24>>2]=f[h+8>>2];if(!c){n=h;o=g}else{f[j>>2]=a;f[m>>2]=g;n=e;o=k}f[i>>2]=n;f[b+16>>2]=o;i=o+(Y(f[n+12>>2]|0,l)|0)|0;f[b+20>>2]=i;u=d;return}function s7(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j;if((c|0)<56|(d|0)<1|(g|0)<0){f[k>>2]=0;f[k+4>>2]=0;d7(-201,k,242533,590)}if(!h){f[k>>2]=0;l=k+4|0;f[l>>2]=0;d7(-27,k,242533,593)}m=(g|0)>0;if(m&((e|0)==0|(i|0)==0)){f[k>>2]=0;l=k+4|0;f[l>>2]=0;d7(-27,k,242533,593)}XIc(h|0,0,c|0)|0;f[h+4>>2]=c;f[h>>2]=a&65535|1117323264;c=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);if(!((c|0)==(d|0)|((a&4095|0)==0|(c|0)==0))){f[k>>2]=0;f[k+4>>2]=0;c=tT(k,106)|0;a=242557;l=c+106|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(l|0));d7(-201,k,242533,607)}f[h+28>>2]=d;f[h+24>>2]=g;k=e+(Y(g,d)|0)|0;f[h+36>>2]=k;f[h+32>>2]=k;if(!m){u=j;return h|0}f[h+52>>2]=i;f[i+4>>2]=i;f[i>>2]=i;f[i+8>>2]=0;f[i+12>>2]=g;f[i+16>>2]=e;u=j;return h|0}function t7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;d7(-27,d,242664,820)}d=b+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[b>>2]=24;f[b+4>>2]=a;d=f[a+52>>2]|0;if(!d)e=0;else e=f[d>>2]|0;f[b+8>>2]=e;f[b+12>>2]=f[a+36>>2];f[b+20>>2]=f[a+32>>2];u=c;return}function u7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;if(!((d|0)!=0&(e|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;d7(-27,h,242683,838)}i=m7(a,b,c,d)|0;if(!i){f[h>>2]=0;f[h+4>>2]=0;d7(-27,h,242664,820)}h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e>>2]=24;f[e+4>>2]=i;d=f[i+52>>2]|0;if(!d)j=0;else j=f[d>>2]|0;f[h>>2]=j;f[e+12>>2]=f[i+36>>2];f[e+20>>2]=f[i+32>>2];u=g;return}function v7(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,242699,850)}c=f[a+4>>2]|0;d=f[a+12>>2]|0;f[c+36>>2]=d;e=f[a+8>>2]|0;if(!e){u=b;return}a=f[c+52>>2]|0;f[e+12>>2]=(d-(f[e+16>>2]|0)|0)/(f[c+28>>2]|0)|0;e=a;d=0;do{d=(f[e+12>>2]|0)+d|0;e=f[e+4>>2]|0}while((e|0)!=(a|0));f[c+24>>2]=d;u=b;return}function w7(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,242716,881)}c=f[a+4>>2]|0;d=a+12|0;e=f[d>>2]|0;f[c+36>>2]=e;g=f[a+8>>2]|0;a=e;if(!g){f[d>>2]=0;u=b;return c|0}e=f[c+52>>2]|0;f[g+12>>2]=(a-(f[g+16>>2]|0)|0)/(f[c+28>>2]|0)|0;g=e;h=0;do{h=(f[g+12>>2]|0)+h|0;g=f[g+4>>2]|0}while((g|0)!=(e|0));f[c+24>>2]=h;h=f[c+44>>2]|0;if(!h){f[d>>2]=0;u=b;return c|0}e=(f[h+8>>2]|0)+(f[h+16>>2]|0)|0;g=h+20|0;h=c+32|0;if((e+(0-(f[g>>2]|0))-(f[h>>2]|0)|0)>>>0>=8){f[d>>2]=0;u=b;return c|0}f[g>>2]=e-a&-8;f[h>>2]=a;f[d>>2]=0;u=b;return c|0}function x7(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;d=c+4|0;f[d>>2]=0;d7(-27,c,242730,912)}e=f[a+4>>2]|0;if(!e){f[c>>2]=0;d=c+4|0;f[d>>2]=0;d7(-27,c,242730,912)}c=a+12|0;d=f[c>>2]|0;g=e+36|0;f[g>>2]=d;h=a+8|0;i=f[h>>2]|0;j=e+52|0;if(i|0){k=f[j>>2]|0;f[i+12>>2]=(d-(f[i+16>>2]|0)|0)/(f[e+28>>2]|0)|0;i=k;d=0;do{d=(f[i+12>>2]|0)+d|0;i=f[i+4>>2]|0}while((i|0)!=(k|0));f[e+24>>2]=d}y7(e,0);f[h>>2]=f[f[j>>2]>>2];f[c>>2]=f[g>>2];f[a+20>>2]=f[e+32>>2];u=b;return}function y7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;d7(-27,e,242747,637)}g=a+48|0;h=f[g>>2]|0;if(!h){i=a+28|0;j=f[i>>2]|0;k=f[a+40>>2]|0;l=f[a+44>>2]|0;if((f[a+24>>2]|0)>=(k<<2|0))n7(a,k<<1);if(!l){f[e>>2]=0;f[e+4>>2]=0;m=tT(e,37)|0;n=242758;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));d7(-27,e,242747,650)}e=(f[l+8>>2]|0)+(f[l+16>>2]|0)|0;n=l+20|0;m=f[n>>2]|0;o=a+32|0;p=f[o>>2]|0;if((e+(0-m)-p|0)>>>0<8?!(c|0?1:(m|0)<(f[i>>2]|0)):0){q=(m|0)/(j|0)|0;r=p+(Y((q|0)>(k|0)?k:q,j)|0)|0;f[o>>2]=r;f[n>>2]=e-r&-8;u=d;return}r=(Y(k,j)|0)+24|0;do if((m|0)<(r|0))if((m|0)<((Y((k|0)>5?(k|0)/3|0:1,j)|0)+32|0)){k7(l);s=r;break}else{s=m-((m+-24|0)%(f[i>>2]|0)|0)|0;break}else s=r;while(0);r=j7(l,s)|0;f[r+16>>2]=r+20+7&-8;f[r+12>>2]=s+-24;f[r+4>>2]=0;f[r>>2]=0;t=r}else{f[g>>2]=f[h+4>>2];t=h}h=a+52|0;g=f[h>>2]|0;if(!g){f[h>>2]=t;v=t;w=t;x=t}else{f[t>>2]=f[g>>2];f[g>>2]=t;v=g;w=t;x=(f[t>>2]|0)+4|0}f[t+4>>2]=v;f[x>>2]=t;x=f[t+12>>2]|0;v=t+16|0;g=f[v>>2]|0;r=f[w>>2]|0;if(c){c=(x|0)/(f[a+28>>2]|0)|0;w=g+x|0;f[v>>2]=w;if((t|0)==(r|0)){f[a+36>>2]=w;f[a+32>>2]=w;y=f[h>>2]|0}else{f[h>>2]=t;y=t}f[t+8>>2]=c;h=f[t+4>>2]|0;if((h|0)==(y|0))z=y;else{w=h;do{f[w+8>>2]=(f[w+8>>2]|0)+c;w=f[w+4>>2]|0}while((w|0)!=(y|0));z=y}}else{f[a+36>>2]=g;f[a+32>>2]=g+x;if((t|0)==(r|0))A=0;else A=(f[r+12>>2]|0)+(f[r+8>>2]|0)|0;f[t+8>>2]=A;z=t}f[z+12>>2]=0;u=d;return}function z7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;d7(-27,d,242796,995)}d=a+8|0;e=f[d>>2]|0;g=f[(f[a+4>>2]|0)+28>>2]|0;if((b|0)>0){b=f[e+4>>2]|0;f[d>>2]=b;h=f[b+16>>2]|0;i=h;j=h;k=f[b+12>>2]|0}else{b=f[e>>2]|0;f[d>>2]=b;d=f[b+16>>2]|0;e=f[b+12>>2]|0;i=d+(Y(e+-1|0,g)|0)|0;j=d;k=e}f[a+12>>2]=i;f[a+16>>2]=j;i=j+(Y(k,g)|0)|0;f[a+20>>2]=i;u=c;return}function A7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;d7(-27,d,242831,1138)}d=f[a+28>>2]|0;e=a+36|0;g=f[e>>2]|0;if(g>>>0<(f[a+32>>2]|0)>>>0)h=g;else{y7(a,0);h=f[e>>2]|0}if(b|0)dJc(h|0,b|0,d|0)|0;b=(f[f[a+52>>2]>>2]|0)+12|0;f[b>>2]=(f[b>>2]|0)+1;b=a+24|0;f[b>>2]=(f[b>>2]|0)+1;f[e>>2]=h+d;u=c;return h|0}function B7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;d7(-27,d,242841,1169)}e=a+24|0;g=f[e>>2]|0;if((g|0)<1){f[d>>2]=0;f[d+4>>2]=0;d7(-201,d,242841,1171)}d=a+28|0;h=f[d>>2]|0;i=a+36|0;j=(f[i>>2]|0)+(0-h)|0;f[i>>2]=j;if(!b)k=g;else{dJc(b|0,j|0,h|0)|0;k=f[e>>2]|0}f[i>>2]=j;f[e>>2]=k+-1;k=a+52|0;h=f[k>>2]|0;b=f[h>>2]|0;g=b+12|0;l=(f[g>>2]|0)+-1|0;f[g>>2]=l;if(l|0){u=c;return}l=f[d>>2]|0;d=a+32|0;if((h|0)==(b|0)){m=f[d>>2]|0;n=h+16|0;o=(Y(f[h+8>>2]|0,l)|0)+(m-(f[n>>2]|0))|0;f[h+12>>2]=o;f[n>>2]=m+(0-o);f[k>>2]=0;f[d>>2]=0;f[i>>2]=0;f[e>>2]=0;p=h}else{f[g>>2]=(f[d>>2]|0)-j;j=f[b>>2]|0;g=(f[j+16>>2]|0)+(Y(f[j+12>>2]|0,l)|0)|0;f[i>>2]=g;f[d>>2]=g;g=b+4|0;f[j+4>>2]=f[g>>2];f[f[g>>2]>>2]=j;p=b}b=a+48|0;f[p+4>>2]=f[b>>2];f[b>>2]=p;u=c;return}function C7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+16|0;h=g;if(!a){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,21)|0;j=242850;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));d7(-27,h,242872,1459)}if((d|0)<0){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,38)|0;j=242887;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));d7(-201,h,242872,1461)}h=f[a+28>>2]|0;if(!e){if((d|0)<=0){u=g;return}e=a+32|0;j=a+36|0;i=a+52|0;k=a+24|0;l=d;m=c;while(1){n=f[j>>2]|0;o=((f[e>>2]|0)-n|0)/(h|0)|0;p=(o|0)>(l|0)?l:o;if((p|0)>0){o=(f[f[i>>2]>>2]|0)+12|0;f[o>>2]=(f[o>>2]|0)+p;f[k>>2]=(f[k>>2]|0)+p;o=l-p|0;q=Y(p,h)|0;if(!m){r=0;s=n}else{dJc(n|0,m|0,q|0)|0;r=m+q|0;s=f[j>>2]|0}f[j>>2]=s+q;if((o|0)>0){t=o;v=r}else break}else{t=l;v=m}y7(a,0);l=t;m=v}u=g;return}v=a+52|0;m=f[v>>2]|0;if((d|0)<=0){u=g;return}t=a+24|0;if(!c){l=m;r=d;while(1){if((l|0)!=0?(s=f[l+8>>2]|0,(s|0)!=0):0){w=l;x=s}else{y7(a,1);s=f[v>>2]|0;w=s;x=f[s+8>>2]|0}s=(x|0)>(r|0)?r:x;r=r-s|0;f[w+8>>2]=x-s;j=w+12|0;f[j>>2]=(f[j>>2]|0)+s;f[t>>2]=(f[t>>2]|0)+s;j=Y(s,h)|0;s=w+16|0;f[s>>2]=(f[s>>2]|0)+(0-j);if((r|0)<=0)break;else l=w}u=g;return}else{w=m;m=d;while(1){if((w|0)!=0?(d=f[w+8>>2]|0,(d|0)!=0):0){y=w;z=d}else{y7(a,1);d=f[v>>2]|0;y=d;z=f[d+8>>2]|0}d=(z|0)>(m|0)?m:z;m=m-d|0;f[y+8>>2]=z-d;l=y+12|0;f[l>>2]=(f[l>>2]|0)+d;f[t>>2]=(f[t>>2]|0)+d;l=Y(d,h)|0;d=y+16|0;r=(f[d>>2]|0)+(0-l)|0;f[d>>2]=r;dJc(r|0,c+(Y(m,h)|0)|0,l|0)|0;if((m|0)<=0)break;else w=y}u=g;return}}function D7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+16|0;h=g;if(!a){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,21)|0;j=242850;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));d7(-27,h,242926,1528)}if((d|0)<0){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,38)|0;j=242887;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));d7(-201,h,242926,1530)}h=a+24|0;j=f[h>>2]|0;i=(j|0)<(d|0)?j:d;if(!e){if(!c)l=0;else l=c+(Y(f[a+28>>2]|0,i)|0)|0;if((i|0)<=0){u=g;return}e=a+52|0;d=a+28|0;k=a+36|0;m=a+32|0;n=a+48|0;o=l;l=i;p=f[e>>2]|0;q=j;while(1){r=f[p>>2]|0;s=r+12|0;t=f[s>>2]|0;v=(t|0)>(l|0)?l:t;w=t-v|0;f[s>>2]=w;f[h>>2]=q-v;s=l-v|0;t=Y(f[d>>2]|0,v)|0;v=0-t|0;x=(f[k>>2]|0)+v|0;f[k>>2]=x;if(!o){y=0;z=r;A=w;B=p}else{w=o+v|0;dJc(w|0,x|0,t|0)|0;t=f[e>>2]|0;x=f[t>>2]|0;y=w;z=x;A=f[x+12>>2]|0;B=t}t=z+12|0;if(!A){x=f[d>>2]|0;if((B|0)==(z|0)){w=f[m>>2]|0;v=z+16|0;r=(Y(f[z+8>>2]|0,x)|0)+(w-(f[v>>2]|0))|0;f[t>>2]=r;f[v>>2]=w+(0-r);f[e>>2]=0;f[m>>2]=0;f[k>>2]=0;f[h>>2]=0;C=z+4|0;D=0}else{f[t>>2]=(f[m>>2]|0)-(f[k>>2]|0);t=f[z>>2]|0;r=(f[t+16>>2]|0)+(Y(f[t+12>>2]|0,x)|0)|0;f[k>>2]=r;f[m>>2]=r;r=z+4|0;f[t+4>>2]=f[r>>2];f[f[r>>2]>>2]=t;C=r;D=B}f[C>>2]=f[n>>2];f[n>>2]=z;E=D}else E=B;if((s|0)<=0)break;o=y;l=s;p=E;q=f[h>>2]|0}u=g;return}else{if((i|0)<=0){u=g;return}q=a+52|0;E=a+28|0;p=a+32|0;l=a+36|0;y=a+48|0;a=f[q>>2]|0;o=i;i=c;c=a;B=a;a=j;while(1){j=B+12|0;D=f[j>>2]|0;z=(D|0)>(o|0)?o:D;f[j>>2]=D-z;f[h>>2]=a-z;D=o-z|0;j=B+8|0;f[j>>2]=(f[j>>2]|0)+z;j=Y(f[E>>2]|0,z)|0;if(!i){F=0;G=B;H=c}else{dJc(i|0,f[B+16>>2]|0,j|0)|0;z=f[q>>2]|0;F=i+j|0;G=z;H=z}z=G+16|0;f[z>>2]=(f[z>>2]|0)+j;if(!(f[G+12>>2]|0)){j=f[H>>2]|0;z=f[E>>2]|0;if((H|0)==(j|0)){n=f[p>>2]|0;C=H+16|0;m=(Y(f[H+8>>2]|0,z)|0)+(n-(f[C>>2]|0))|0;f[H+12>>2]=m;f[C>>2]=n+(0-m);f[q>>2]=0;f[p>>2]=0;f[l>>2]=0;f[h>>2]=0;I=H+4|0;J=0}else{m=H+8|0;n=f[m>>2]|0;C=Y(n,z)|0;f[H+12>>2]=C;z=H+16|0;f[z>>2]=(f[z>>2]|0)+(0-C);f[m>>2]=0;m=H+4|0;C=f[m>>2]|0;z=C;if((C|0)!=(H|0)){k=C;do{e=k+8|0;f[e>>2]=(f[e>>2]|0)-n;k=f[k+4>>2]|0}while((k|0)!=(H|0))}f[q>>2]=z;f[j+4>>2]=z;f[f[m>>2]>>2]=j;I=m;J=C}f[I>>2]=f[y>>2];f[y>>2]=H;K=J;L=J}else{K=H;L=G}if((D|0)<=0)break;o=D;i=F;c=K;B=L;a=f[h>>2]|0}u=g;return}}function E7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!a){f[i>>2]=0;j=i+4|0;f[j>>2]=0;k=tT(i,23)|0;l=k;m=242951;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));d7(-5,i,242975,1610)}o=f[a>>2]|0;if((o&-65536|0)!=1117323264){f[i>>2]=0;j=i+4|0;f[j>>2]=0;k=tT(i,23)|0;l=k;m=242951;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));d7(-5,i,242975,1610)}if(!d){k=f[a+44>>2]|0;if(!k){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,20)|0;m=254626;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));d7(-27,i,242975,1616)}else p=k}else p=d;d=a+28|0;k=f[d>>2]|0;j=c;q=f[j>>2]|0;r=f[j+4>>2]|0;j=f[a+24>>2]|0;if((r|0)==(q|0))s=0;else s=r-q+((q|0)<0?0-j|0:0)+((r|0)<1?j:0)|0;while(1)if((s|0)<0)s=s+j|0;else break;r=(s|0)>(j|0)?j:s;if((q|0)>=0)if((q|0)<(j|0))t=q;else{v=q-j|0;w=14}else{v=j+q|0;w=14}if((w|0)==14){f[c>>2]=v;t=v}if(r>>>0>j>>>0){f[i>>2]=0;x=i+4|0;f[x>>2]=0;y=tT(i,18)|0;l=y;m=242986;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));d7(-211,i,242975,1627)}if((r|0)!=0&t>>>0>=j>>>0){f[i>>2]=0;x=i+4|0;f[x>>2]=0;y=tT(i,18)|0;l=y;m=242986;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));d7(-211,i,242975,1627)}i=m7(o,f[a+4>>2]|0,k,p)|0;if((r|0)<=0){u=g;return i|0}o=h+4|0;m=h+8|0;l=h+20|0;n=h+12|0;y=o+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[h>>2]=32;f[o>>2]=a;o=f[a+52>>2]|0;if(!o){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;z=n}else{a=f[o>>2]|0;y=f[o+16>>2]|0;f[n>>2]=y;x=f[d>>2]|0;d=(f[a+16>>2]|0)+(Y((f[a+12>>2]|0)+-1|0,x)|0)|0;f[h+28>>2]=d;f[h+24>>2]=f[o+8>>2];d=y;f[m>>2]=o;f[h+16>>2]=d;y=d+(Y(f[o+12>>2]|0,x)|0)|0;f[l>>2]=y;z=n}q7(h,t,0);t=f[z>>2]|0;h=((f[l>>2]|0)-t|0)/(k|0)|0;k=i+52|0;l=i+24|0;if(!e){A=0;B=0;C=r;D=h}else{e=r;r=h;h=t;while(1){t=(r|0)>(e|0)?e:r;C7(i,h,t,0);e=e-t|0;t=f[(f[m>>2]|0)+4>>2]|0;f[m>>2]=t;h=f[t+16>>2]|0;f[z>>2]=h;if((e|0)<=0)break;else r=f[t+12>>2]|0}u=g;return i|0}while(1){r=(D|0)>(C|0)?C:D;e=A;A=j7(p,20)|0;if(!B){f[A+4>>2]=A;f[A>>2]=A;f[k>>2]=A;E=A;F=0}else{f[A>>2]=e;f[A+4>>2]=B;f[B>>2]=A;f[e+4>>2]=A;E=B;F=(f[e+12>>2]|0)+(f[e+8>>2]|0)|0}f[A+8>>2]=F;f[A+16>>2]=f[z>>2];f[A+12>>2]=r;f[l>>2]=(f[l>>2]|0)+r;C=C-r|0;r=f[(f[m>>2]|0)+4>>2]|0;f[m>>2]=r;f[z>>2]=f[r+16>>2];if((C|0)<=0)break;else{B=E;D=f[r+12>>2]|0}}u=g;return i|0}function F7(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0;e=u;u=u+1744|0;g=e+1728|0;h=e+1696|0;i=e+1664|0;j=e+128|0;k=e+96|0;l=e+64|0;m=e+32|0;n=e;o=(a|0)!=0;if(!o){p=o?-5:-27;f[g>>2]=0;q=g+4|0;f[q>>2]=0;r=tT(g,18)|0;s=r;t=243005;v=s+18|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));d7(p,g,243024,1921)}if((f[a>>2]&-65536|0)!=1117323264){p=o?-5:-27;f[g>>2]=0;q=g+4|0;f[q>>2]=0;r=tT(g,18)|0;s=r;t=243005;v=s+18|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));d7(p,g,243024,1921)}if(!c){f[g>>2]=0;f[g+4>>2]=0;s=tT(g,21)|0;t=243034;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));d7(-27,g,243024,1924)}t=a+24|0;if((f[t>>2]|0)<2){u=e;return}s=f[a+28>>2]|0;v=s*7|0;p=h+4|0;r=h+8|0;q=h+16|0;o=h+20|0;w=h+12|0;x=p+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[h>>2]=32;f[p>>2]=a;x=f[a+52>>2]|0;if(!x){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;y=w;z=0;A=0;B=0}else{a=f[x>>2]|0;C=f[x+16>>2]|0;f[w>>2]=C;D=(f[a+16>>2]|0)+(Y((f[a+12>>2]|0)+-1|0,s)|0)|0;f[h+28>>2]=D;f[h+24>>2]=f[x+8>>2];D=C;f[r>>2]=x;f[q>>2]=D;a=D+(Y(f[x+12>>2]|0,s)|0)|0;f[o>>2]=a;y=w;z=x;A=C;B=a};f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];f[i+16>>2]=f[h+16>>2];f[i+20>>2]=f[h+20>>2];f[i+24>>2]=f[h+24>>2];f[i+28>>2]=f[h+28>>2];f[j>>2]=z;f[j+4>>2]=A;f[j+8>>2]=A;f[j+12>>2]=B;z=i+12|0;a=0-s|0;C=(f[z>>2]|0)+a|0;f[z>>2]=C;x=i+16|0;D=f[x>>2]|0;E=i+8|0;if(C>>>0<D>>>0){F=i+4|0;G=f[(f[F>>2]|0)+28>>2]|0;H=f[f[E>>2]>>2]|0;f[E>>2]=H;I=f[H+16>>2]|0;J=f[H+12>>2]|0;K=I+(Y(J+-1|0,G)|0)|0;f[z>>2]=K;f[x>>2]=I;L=I+(Y(J,G)|0)|0;G=i+20|0;f[G>>2]=L;M=I;N=K;O=E;P=G;Q=G;R=F;S=H;T=L}else{L=i+20|0;M=D;N=C;O=E;P=L;Q=L;R=i+4|0;S=f[E>>2]|0;T=f[L>>2]|0}L=N;N=M;f[j+16>>2]=S;f[j+20>>2]=L;f[j+24>>2]=N;f[j+28>>2]=T;M=i+24|0;C=i+28|0;D=l+4|0;H=l+8|0;F=l+12|0;G=l+16|0;K=l+20|0;I=l+24|0;J=l+28|0;U=m+12|0;V=h+24|0;W=(s|0)>0;X=k+12|0;Z=k+4|0;_=k+16|0;$=k+8|0;aa=k+24|0;ba=m+20|0;ca=n+12|0;da=n+20|0;ea=n+8|0;fa=n+4|0;ga=n+16|0;ha=m+8|0;ia=m+4|0;ja=m+16|0;ka=k+20|0;la=(s|0)<1;ma=W^1;na=(s|0)==1;oa=(s|0)==1;pa=(s|0)==1;qa=(s|0)==1;ra=0;sa=A;ta=A;A=B;B=S;S=L;L=N;N=T;a:while(1){T=f[j+(ra<<5)>>2]|0;f[r>>2]=T;f[y>>2]=sa;f[q>>2]=ta;f[o>>2]=A;f[O>>2]=B;f[z>>2]=S;f[x>>2]=L;f[Q>>2]=N;ua=ra+-1|0;va=T;T=B;b:while(1){if((va|0)==(T|0)){wa=f[z>>2]|0;xa=f[y>>2]|0;ya=wa+s-xa|0;za=wa;Aa=xa}else{xa=f[z>>2]|0;if(!xa){Ba=20;break a}wa=f[(f[R>>2]|0)+28>>2]|0;Ca=xa-(f[x>>2]|0)|0;if((wa|0)<33?(Da=wa+-1|0,(-2147450741>>>Da&1|0)!=0):0)Ea=Ca>>b[242452+Da>>0];else Ea=(Ca|0)/(wa|0)|0;wa=f[T+8>>2]|0;Ca=f[M>>2]|0;Da=f[w>>2]|0;if(!Da){Ba=26;break a}Fa=f[(f[p>>2]|0)+28>>2]|0;Ga=Da-(f[q>>2]|0)|0;if((Fa|0)<33?(Ha=Fa+-1|0,(-2147450741>>>Ha&1|0)!=0):0)Ia=Ga>>b[242452+Ha>>0];else Ia=(Ga|0)/(Fa|0)|0;ya=Y(Ea+1+wa-Ca-Ia-(f[va+8>>2]|0)+(f[V>>2]|0)|0,s)|0;za=xa;Aa=Da}if((ya|0)<=(v|0)){Ja=ua;Ka=va;La=Aa;Ba=33;break};f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[m+20>>2]=f[h+20>>2];f[m+24>>2]=f[h+24>>2];f[m+28>>2]=f[h+28>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[k+16>>2]=f[h+16>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];Da=f[R>>2]|0;xa=f[x>>2]|0;Ca=f[Q>>2]|0;wa=f[M>>2]|0;Fa=f[C>>2]|0;f[l>>2]=f[i>>2];f[D>>2]=Da;f[H>>2]=T;f[F>>2]=za;f[G>>2]=xa;f[K>>2]=Ca;f[I>>2]=wa;f[J>>2]=Fa;Fa=(ya|0)/(s|0)|0;do if((Fa|0)>40){Ca=Fa>>>3;Ga=f[U>>2]|0;q7(m,Ca,1);Ha=f[U>>2]|0;q7(m,Ca,1);Ma=f[U>>2]|0;Na=(hj[c&511](Ga,Ha,d)|0)<0;Oa=hj[c&511](Ha,Ma,d)|0;if(Na)if((Oa|0)<0)Pa=Ha;else{Na=(hj[c&511](Ga,Ma,d)|0)<0;Pa=Na?Ma:Ga}else if((Oa|0)>0)Pa=Ha;else{Ha=(hj[c&511](Ga,Ma,d)|0)<0;Pa=Ha?Ga:Ma}Ma=Fa>>>1;Ga=Ca*3|0;q7(m,Ma-Ga|0,1);Ha=f[U>>2]|0;q7(m,Ca,1);Oa=f[U>>2]|0;q7(m,Ca,1);Na=f[U>>2]|0;Qa=(hj[c&511](Ha,Oa,d)|0)<0;Ra=hj[c&511](Oa,Na,d)|0;if(Qa)if((Ra|0)<0)Sa=Oa;else{Qa=(hj[c&511](Ha,Na,d)|0)<0;Sa=Qa?Na:Ha}else if((Ra|0)>0)Sa=Oa;else{Oa=(hj[c&511](Ha,Na,d)|0)<0;Sa=Oa?Ha:Na}q7(m,Fa+-1-Ma-Ga|0,1);Ga=f[U>>2]|0;q7(m,Ca,1);Ma=f[U>>2]|0;q7(m,Ca,1);Ca=f[U>>2]|0;Na=(hj[c&511](Ga,Ma,d)|0)<0;Ha=hj[c&511](Ma,Ca,d)|0;if(Na){if((Ha|0)<0){Ta=Pa;Ua=Sa;Va=Ma;break}Na=(hj[c&511](Ga,Ca,d)|0)<0;Ta=Pa;Ua=Sa;Va=Na?Ca:Ga;break}else{if((Ha|0)>0){Ta=Pa;Ua=Sa;Va=Ma;break}Ma=(hj[c&511](Ga,Ca,d)|0)<0;Ta=Pa;Ua=Sa;Va=Ma?Ga:Ca;break}}else{Ca=f[U>>2]|0;Ga=(Fa|0)/2|0;q7(m,Ga,1);Ma=f[U>>2]|0;q7(m,Fa+-1-Ga|0,1);Ta=Ca;Ua=Ma;Va=f[U>>2]|0}while(0);Fa=(hj[c&511](Ta,Ua,d)|0)<0;Ma=hj[c&511](Ua,Va,d)|0;if(Fa)if((Ma|0)<0)Wa=Ua;else{Fa=(hj[c&511](Ta,Va,d)|0)<0;Wa=Fa?Va:Ta}else if((Ma|0)>0)Wa=Ua;else{Ma=(hj[c&511](Ta,Va,d)|0)<0;Wa=Ma?Ta:Va};f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];Ma=f[w>>2]|0;if((Wa|0)==(Ma|0)|ma)Xa=Ma;else{Fa=0;Ca=Ma;while(1){Ma=Wa+Fa|0;Ga=b[Ma>>0]|0;b[Ma>>0]=b[Ca+Fa>>0]|0;b[(f[w>>2]|0)+Fa>>0]=Ga;Fa=Fa+1|0;Ga=f[w>>2]|0;if((Fa|0)==(s|0)){Xa=Ga;break}else Ca=Ga}}Ca=Xa+s|0;f[w>>2]=Ca;Fa=f[o>>2]|0;if(Ca>>>0<Fa>>>0){Ya=Ca;Za=f[q>>2]|0;_a=Fa;$a=f[p>>2]|0;ab=f[r>>2]|0}else{Fa=f[p>>2]|0;Ca=f[Fa+28>>2]|0;Ga=f[(f[r>>2]|0)+4>>2]|0;f[r>>2]=Ga;Ma=f[Ga+16>>2]|0;Ha=f[Ga+12>>2]|0;f[w>>2]=Ma;f[q>>2]=Ma;Na=Ma+(Y(Ha,Ca)|0)|0;f[o>>2]=Na;Ya=Ma;Za=Ma;_a=Na;$a=Fa;ab=Ga}Ga=f[V>>2]|0;Fa=Da+28|0;Na=$a+28|0;Ma=0;Ca=Ya;Ha=xa;Oa=Za;Ra=_a;Qa=T;bb=ab;cb=za;db=Ya;eb=f[z>>2]|0;while(1){c:do if((db|0)==(eb|0)){fb=Ma;gb=Ca;hb=Oa;ib=Ra;jb=bb}else{if(W){kb=Ma;lb=Ca;mb=Oa;nb=Ra;ob=bb;pb=db}else{qb=Ma;rb=Ca;sb=Oa;tb=Ra;ub=bb;vb=db;while(1){wb=hj[c&511](vb,Xa,d)|0;if((wb|0)>=1){fb=qb;gb=rb;hb=sb;ib=tb;jb=ub;break c}do if(!wb){xb=rb+s|0;if(xb>>>0<tb>>>0){yb=1;zb=xb;Ab=sb;Bb=tb;Cb=ub;break}xb=f[ub+4>>2]|0;Db=f[xb+16>>2]|0;yb=1;zb=Db;Ab=Db;Bb=Db+(Y(f[xb+12>>2]|0,f[Na>>2]|0)|0)|0;Cb=xb}else{yb=qb;zb=rb;Ab=sb;Bb=tb;Cb=ub}while(0);wb=(f[w>>2]|0)+s|0;f[w>>2]=wb;if(wb>>>0<(f[o>>2]|0)>>>0)Eb=wb;else{wb=f[(f[p>>2]|0)+28>>2]|0;xb=f[(f[r>>2]|0)+4>>2]|0;f[r>>2]=xb;Db=f[xb+16>>2]|0;Fb=f[xb+12>>2]|0;f[w>>2]=Db;f[q>>2]=Db;xb=Db+(Y(Fb,wb)|0)|0;f[o>>2]=xb;Eb=Db}if((Eb|0)==(f[z>>2]|0)){fb=yb;gb=zb;hb=Ab;ib=Bb;jb=Cb;break c}else{qb=yb;rb=zb;sb=Ab;tb=Bb;ub=Cb;vb=Eb}}}while(1){vb=hj[c&511](pb,Xa,d)|0;if((vb|0)>=1){fb=kb;gb=lb;hb=mb;ib=nb;jb=ob;break c}do if(!vb){ub=f[w>>2]|0;do if((lb|0)!=(ub|0)){tb=b[lb>>0]|0;b[lb>>0]=b[ub>>0]|0;b[f[w>>2]>>0]=tb;if(pa)break;else Gb=1;do{tb=lb+Gb|0;sb=b[tb>>0]|0;b[tb>>0]=b[(f[w>>2]|0)+Gb>>0]|0;b[(f[w>>2]|0)+Gb>>0]=sb;Gb=Gb+1|0}while((Gb|0)!=(s|0))}while(0);ub=lb+s|0;if(ub>>>0<nb>>>0){Hb=1;Ib=ub;Jb=mb;Kb=nb;Lb=ob;break}ub=f[ob+4>>2]|0;sb=f[ub+16>>2]|0;Hb=1;Ib=sb;Jb=sb;Kb=sb+(Y(f[ub+12>>2]|0,f[Na>>2]|0)|0)|0;Lb=ub}else{Hb=kb;Ib=lb;Jb=mb;Kb=nb;Lb=ob}while(0);vb=(f[w>>2]|0)+s|0;f[w>>2]=vb;if(vb>>>0<(f[o>>2]|0)>>>0)Mb=vb;else{vb=f[(f[p>>2]|0)+28>>2]|0;ub=f[(f[r>>2]|0)+4>>2]|0;f[r>>2]=ub;sb=f[ub+16>>2]|0;tb=f[ub+12>>2]|0;f[w>>2]=sb;f[q>>2]=sb;ub=sb+(Y(tb,vb)|0)|0;f[o>>2]=ub;Mb=sb}if((Mb|0)==(f[z>>2]|0)){fb=Hb;gb=Ib;hb=Jb;ib=Kb;jb=Lb;break}else{kb=Hb;lb=Ib;mb=Jb;nb=Kb;ob=Lb;pb=Mb}}}while(0);sb=f[z>>2]|0;d:do if((f[w>>2]|0)==(sb|0)){Nb=fb;Ob=Ha;Pb=Qa;Qb=cb}else{if(W){Rb=fb;Sb=Ha;Tb=Qa;Ub=cb;Vb=sb}else{ub=fb;vb=Ha;tb=Qa;rb=cb;qb=sb;while(1){Db=hj[c&511](qb,Xa,d)|0;if((Db|0)<=-1){Nb=ub;Ob=vb;Pb=tb;Qb=rb;break d}do if(!Db){xb=rb+a|0;if(xb>>>0>=vb>>>0){Wb=1;Xb=vb;Yb=tb;Zb=xb;break}xb=f[tb>>2]|0;wb=f[xb+16>>2]|0;Wb=1;Xb=wb;Yb=xb;Zb=wb+(Y((f[xb+12>>2]|0)+-1|0,f[Fa>>2]|0)|0)|0}else{Wb=ub;Xb=vb;Yb=tb;Zb=rb}while(0);Db=(f[z>>2]|0)+a|0;f[z>>2]=Db;if(Db>>>0<(f[x>>2]|0)>>>0){xb=f[(f[R>>2]|0)+28>>2]|0;wb=f[f[E>>2]>>2]|0;f[E>>2]=wb;Fb=f[wb+16>>2]|0;_b=f[wb+12>>2]|0;wb=Fb+(Y(_b+-1|0,xb)|0)|0;f[z>>2]=wb;f[x>>2]=Fb;$b=Fb+(Y(_b,xb)|0)|0;f[P>>2]=$b;ac=wb}else ac=Db;if((f[w>>2]|0)==(ac|0)){Nb=Wb;Ob=Xb;Pb=Yb;Qb=Zb;break d}else{ub=Wb;vb=Xb;tb=Yb;rb=Zb;qb=ac}}}while(1){qb=hj[c&511](Vb,Xa,d)|0;if((qb|0)<=-1){Nb=Rb;Ob=Sb;Pb=Tb;Qb=Ub;break d}do if(!qb){rb=f[z>>2]|0;do if((Ub|0)!=(rb|0)){tb=b[Ub>>0]|0;b[Ub>>0]=b[rb>>0]|0;b[f[z>>2]>>0]=tb;if(oa)break;else bc=1;do{tb=Ub+bc|0;vb=b[tb>>0]|0;b[tb>>0]=b[(f[z>>2]|0)+bc>>0]|0;b[(f[z>>2]|0)+bc>>0]=vb;bc=bc+1|0}while((bc|0)!=(s|0))}while(0);rb=Ub+a|0;if(rb>>>0>=Sb>>>0){cc=1;dc=Sb;ec=Tb;fc=rb;break}rb=f[Tb>>2]|0;vb=f[rb+16>>2]|0;cc=1;dc=vb;ec=rb;fc=vb+(Y((f[rb+12>>2]|0)+-1|0,f[Fa>>2]|0)|0)|0}else{cc=Rb;dc=Sb;ec=Tb;fc=Ub}while(0);qb=(f[z>>2]|0)+a|0;f[z>>2]=qb;if(qb>>>0<(f[x>>2]|0)>>>0){rb=f[(f[R>>2]|0)+28>>2]|0;vb=f[f[E>>2]>>2]|0;f[E>>2]=vb;tb=f[vb+16>>2]|0;ub=f[vb+12>>2]|0;vb=tb+(Y(ub+-1|0,rb)|0)|0;f[z>>2]=vb;f[x>>2]=tb;Db=tb+(Y(ub,rb)|0)|0;f[P>>2]=Db;gc=vb}else gc=qb;if((f[w>>2]|0)==(gc|0)){Nb=cc;Ob=dc;Pb=ec;Qb=fc;break}else{Rb=cc;Sb=dc;Tb=ec;Ub=fc;Vb=gc}}}while(0);hc=f[w>>2]|0;sb=f[z>>2]|0;if((hc|0)==(sb|0)){Ba=123;break}do if(W){qb=b[hc>>0]|0;b[hc>>0]=b[sb>>0]|0;b[f[z>>2]>>0]=qb;qb=f[w>>2]|0;if(na){ic=qb;break}else{jc=qb;kc=1}while(1){qb=jc+kc|0;vb=b[qb>>0]|0;b[qb>>0]=b[(f[z>>2]|0)+kc>>0]|0;b[(f[z>>2]|0)+kc>>0]=vb;kc=kc+1|0;vb=f[w>>2]|0;if((kc|0)==(s|0)){ic=vb;break}else jc=vb}}else ic=hc;while(0);sb=ic+s|0;f[w>>2]=sb;if(sb>>>0<(f[o>>2]|0)>>>0)lc=sb;else{sb=f[(f[p>>2]|0)+28>>2]|0;vb=f[(f[r>>2]|0)+4>>2]|0;f[r>>2]=vb;qb=f[vb+16>>2]|0;Db=f[vb+12>>2]|0;f[w>>2]=qb;f[q>>2]=qb;vb=qb+(Y(Db,sb)|0)|0;f[o>>2]=vb;lc=qb}qb=f[z>>2]|0;vb=qb+a|0;f[z>>2]=vb;if(vb>>>0<(f[x>>2]|0)>>>0){sb=f[(f[R>>2]|0)+28>>2]|0;Db=f[f[E>>2]>>2]|0;f[E>>2]=Db;rb=f[Db+16>>2]|0;ub=f[Db+12>>2]|0;Db=rb+(Y(ub+-1|0,sb)|0)|0;f[z>>2]=Db;f[x>>2]=rb;tb=rb+(Y(ub,sb)|0)|0;f[P>>2]=tb;mc=Db}else mc=vb;if((lc|0)==(qb|0)){nc=gb;oc=hb;pc=jb;qc=lc;Ba=143;break}else{Ma=1;Ca=gb;Ha=Ob;Oa=hb;Ra=ib;Qa=Pb;bb=jb;cb=Qb;db=lc;eb=mc}}do if((Ba|0)==123){Ba=0;eb=hj[c&511](hc,Xa,d)|0;if(!eb){db=f[w>>2]|0;if(!((gb|0)==(db|0)|la)?(cb=b[gb>>0]|0,b[gb>>0]=b[db>>0]|0,b[f[w>>2]>>0]=cb,!qa):0){cb=1;do{db=gb+cb|0;bb=b[db>>0]|0;b[db>>0]=b[(f[w>>2]|0)+cb>>0]|0;b[(f[w>>2]|0)+cb>>0]=bb;cb=cb+1|0}while((cb|0)!=(s|0))}cb=gb+s|0;if(cb>>>0<ib>>>0){rc=1;sc=cb;tc=hb;uc=jb}else{cb=f[jb+4>>2]|0;bb=f[cb+16>>2]|0;rc=1;sc=bb;tc=bb;uc=cb}}else{rc=Nb;sc=gb;tc=hb;uc=jb}if((eb|0)<1){cb=(f[w>>2]|0)+s|0;f[w>>2]=cb;if(cb>>>0>=(f[o>>2]|0)>>>0){cb=f[(f[p>>2]|0)+28>>2]|0;bb=f[(f[r>>2]|0)+4>>2]|0;f[r>>2]=bb;db=f[bb+16>>2]|0;Qa=f[bb+12>>2]|0;f[w>>2]=db;f[q>>2]=db;bb=db+(Y(Qa,cb)|0)|0;f[o>>2]=bb}}else{bb=(f[z>>2]|0)+a|0;f[z>>2]=bb;if(bb>>>0<(f[x>>2]|0)>>>0){bb=f[(f[R>>2]|0)+28>>2]|0;cb=f[f[E>>2]>>2]|0;f[E>>2]=cb;Qa=f[cb+16>>2]|0;db=f[cb+12>>2]|0;cb=Qa+(Y(db+-1|0,bb)|0)|0;f[z>>2]=cb;f[x>>2]=Qa;cb=Qa+(Y(db,bb)|0)|0;f[P>>2]=cb}}if(!rc){f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];f[i+16>>2]=f[l+16>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];vc=6;wc=ua;break}else{nc=sc;oc=tc;pc=uc;qc=f[w>>2]|0;Ba=143;break}}while(0);do if((Ba|0)==143){Ba=0;if(!qc){Ba=144;break a}cb=f[(f[p>>2]|0)+28>>2]|0;bb=qc-(f[q>>2]|0)|0;if((cb|0)<33?(db=cb+-1|0,(-2147450741>>>db&1|0)!=0):0)xc=bb>>b[242452+db>>0];else xc=(bb|0)/(cb|0)|0;cb=(f[(f[r>>2]|0)+8>>2]|0)+xc-(f[V>>2]|0)|0;if(!cb)yc=f[t>>2]|0;else yc=cb;cb=f[X>>2]|0;if(!cb){Ba=152;break a}bb=f[(f[Z>>2]|0)+28>>2]|0;db=cb-(f[_>>2]|0)|0;do if((bb|0)<33){cb=bb+-1|0;if(!(-2147450741>>>cb&1)){Ba=156;break}zc=db>>b[242452+cb>>0]}else Ba=156;while(0);if((Ba|0)==156){Ba=0;zc=(db|0)/(bb|0)|0}eb=f[(f[$>>2]|0)+8>>2]|0;cb=f[aa>>2]|0;if(!nc){Ba=158;break a}Qa=f[Na>>2]|0;Ra=nc-oc|0;do if((Qa|0)<33){Oa=Qa+-1|0;if(!(-2147450741>>>Oa&1)){Ba=162;break}Ac=Ra>>b[242452+Oa>>0]}else Ba=162;while(0);if((Ba|0)==162){Ba=0;Ac=(Ra|0)/(Qa|0)|0}bb=Ac-Ga+(f[pc+8>>2]|0)|0;if(!bb)Bc=f[t>>2]|0;else Bc=bb;bb=yc-Bc|0;db=cb-(eb+zc)+Bc|0;Oa=(bb|0)>(db|0)?db:bb;do if((Oa|0)>0){f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];f[m+8>>2]=f[k+8>>2];f[m+12>>2]=f[k+12>>2];f[m+16>>2]=f[k+16>>2];f[m+20>>2]=f[k+20>>2];f[m+24>>2]=f[k+24>>2];f[m+28>>2]=f[k+28>>2];f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[n+8>>2]=f[h+8>>2];f[n+12>>2]=f[h+12>>2];f[n+16>>2]=f[h+16>>2];f[n+20>>2]=f[h+20>>2];f[n+24>>2]=f[h+24>>2];f[n+28>>2]=f[h+28>>2];q7(n,0-Oa|0,1);db=f[U>>2]|0;if(W){Ha=0;Ca=db;while(1){Ma=0;xa=Ca;do{Da=xa+Ma|0;qb=b[Da>>0]|0;b[Da>>0]=b[(f[ca>>2]|0)+Ma>>0]|0;b[(f[ca>>2]|0)+Ma>>0]=qb;Ma=Ma+1|0;xa=f[U>>2]|0}while((Ma|0)!=(s|0));Ma=xa+s|0;f[U>>2]=Ma;if(Ma>>>0<(f[ba>>2]|0)>>>0)Cc=Ma;else{Ma=f[(f[ia>>2]|0)+28>>2]|0;qb=f[(f[ha>>2]|0)+4>>2]|0;f[ha>>2]=qb;Da=f[qb+16>>2]|0;vb=f[qb+12>>2]|0;f[U>>2]=Da;f[ja>>2]=Da;qb=Da+(Y(vb,Ma)|0)|0;f[ba>>2]=qb;Cc=Da}Da=(f[ca>>2]|0)+s|0;f[ca>>2]=Da;if(Da>>>0>=(f[da>>2]|0)>>>0){Da=f[(f[fa>>2]|0)+28>>2]|0;qb=f[(f[ea>>2]|0)+4>>2]|0;f[ea>>2]=qb;Ma=f[qb+16>>2]|0;vb=f[qb+12>>2]|0;f[ca>>2]=Ma;f[ga>>2]=Ma;qb=Ma+(Y(vb,Da)|0)|0;f[da>>2]=qb}Ha=Ha+1|0;if((Ha|0)>=(Oa|0))break;else Ca=Cc}}else{Ca=(f[fa>>2]|0)+28|0;Ha=(f[ia>>2]|0)+28|0;qb=0;Da=db;vb=f[ba>>2]|0;Ma=f[ca>>2]|0;while(1){Db=Da+s|0;if(Db>>>0<vb>>>0){Dc=Db;Ec=vb}else{Db=f[Ha>>2]|0;tb=f[(f[ha>>2]|0)+4>>2]|0;f[ha>>2]=tb;sb=f[tb+16>>2]|0;ub=f[tb+12>>2]|0;f[ja>>2]=sb;tb=sb+(Y(ub,Db)|0)|0;f[ba>>2]=tb;Dc=sb;Ec=tb}tb=Ma+s|0;if(tb>>>0<(f[da>>2]|0)>>>0)Fc=tb;else{tb=f[Ca>>2]|0;sb=f[(f[ea>>2]|0)+4>>2]|0;f[ea>>2]=sb;Db=f[sb+16>>2]|0;ub=f[sb+12>>2]|0;f[ga>>2]=Db;sb=Db+(Y(ub,tb)|0)|0;f[da>>2]=sb;Fc=Db}qb=qb+1|0;if((qb|0)>=(Oa|0))break;else{Da=Dc;vb=Ec;Ma=Fc}}f[U>>2]=Dc;f[ca>>2]=Fc;break}}while(0);Oa=f[z>>2]|0;if(!Oa){Ba=182;break a}eb=f[(f[R>>2]|0)+28>>2]|0;cb=Oa-(f[x>>2]|0)|0;do if((eb|0)<33){Oa=eb+-1|0;if(!(-2147450741>>>Oa&1)){Ba=186;break}Gc=cb>>b[242452+Oa>>0]}else Ba=186;while(0);if((Ba|0)==186){Ba=0;Gc=(cb|0)/(eb|0)|0}Oa=f[(f[E>>2]|0)+8>>2]|0;Qa=f[M>>2]|0;Ra=f[F>>2]|0;if(!Ra){Ba=188;break a}Ma=f[(f[D>>2]|0)+28>>2]|0;vb=Ra-(f[G>>2]|0)|0;do if((Ma|0)<33){Ra=Ma+-1|0;if(!(-2147450741>>>Ra&1)){Ba=192;break}Hc=vb>>b[242452+Ra>>0]}else Ba=192;while(0);if((Ba|0)==192){Ba=0;Hc=(vb|0)/(Ma|0)|0}eb=(f[(f[H>>2]|0)+8>>2]|0)+Hc-(f[I>>2]|0)|0;if(!Qb){Ba=194;break a}cb=f[Fa>>2]|0;Ra=Qb-Ob|0;do if((cb|0)<33){Da=cb+-1|0;if(!(-2147450741>>>Da&1)){Ba=198;break}Ic=Ra>>b[242452+Da>>0]}else Ba=198;while(0);if((Ba|0)==198){Ba=0;Ic=(Ra|0)/(cb|0)|0}Ma=Ic-wa+(f[Pb+8>>2]|0)|0;vb=eb-Ma|0;Da=Qa-(Oa+Gc)+Ma|0;Ma=(vb|0)>(Da|0)?Da:vb;do if((Ma|0)>0){f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[m+20>>2]=f[h+20>>2];f[m+24>>2]=f[h+24>>2];f[m+28>>2]=f[h+28>>2];f[n>>2]=f[l>>2];f[n+4>>2]=f[l+4>>2];f[n+8>>2]=f[l+8>>2];f[n+12>>2]=f[l+12>>2];f[n+16>>2]=f[l+16>>2];f[n+20>>2]=f[l+20>>2];f[n+24>>2]=f[l+24>>2];f[n+28>>2]=f[l+28>>2];q7(n,1-Ma|0,1);vb=f[U>>2]|0;if(W){qb=0;Ca=vb;while(1){Ha=0;db=Ca;do{Db=db+Ha|0;sb=b[Db>>0]|0;b[Db>>0]=b[(f[ca>>2]|0)+Ha>>0]|0;b[(f[ca>>2]|0)+Ha>>0]=sb;Ha=Ha+1|0;db=f[U>>2]|0}while((Ha|0)!=(s|0));Ha=db+s|0;f[U>>2]=Ha;if(Ha>>>0<(f[ba>>2]|0)>>>0)Jc=Ha;else{Ha=f[(f[ia>>2]|0)+28>>2]|0;xa=f[(f[ha>>2]|0)+4>>2]|0;f[ha>>2]=xa;sb=f[xa+16>>2]|0;Db=f[xa+12>>2]|0;f[U>>2]=sb;f[ja>>2]=sb;xa=sb+(Y(Db,Ha)|0)|0;f[ba>>2]=xa;Jc=sb}sb=(f[ca>>2]|0)+s|0;f[ca>>2]=sb;if(sb>>>0>=(f[da>>2]|0)>>>0){sb=f[(f[fa>>2]|0)+28>>2]|0;xa=f[(f[ea>>2]|0)+4>>2]|0;f[ea>>2]=xa;Ha=f[xa+16>>2]|0;Db=f[xa+12>>2]|0;f[ca>>2]=Ha;f[ga>>2]=Ha;xa=Ha+(Y(Db,sb)|0)|0;f[da>>2]=xa}qb=qb+1|0;if((qb|0)>=(Ma|0))break;else Ca=Jc}}else{Ca=(f[fa>>2]|0)+28|0;qb=(f[ia>>2]|0)+28|0;xa=0;sb=vb;Db=f[ba>>2]|0;Ha=f[ca>>2]|0;while(1){tb=sb+s|0;if(tb>>>0<Db>>>0){Kc=tb;Lc=Db}else{tb=f[qb>>2]|0;ub=f[(f[ha>>2]|0)+4>>2]|0;f[ha>>2]=ub;rb=f[ub+16>>2]|0;wb=f[ub+12>>2]|0;f[ja>>2]=rb;ub=rb+(Y(wb,tb)|0)|0;f[ba>>2]=ub;Kc=rb;Lc=ub}ub=Ha+s|0;if(ub>>>0<(f[da>>2]|0)>>>0)Mc=ub;else{ub=f[Ca>>2]|0;rb=f[(f[ea>>2]|0)+4>>2]|0;f[ea>>2]=rb;tb=f[rb+16>>2]|0;wb=f[rb+12>>2]|0;f[ga>>2]=tb;rb=tb+(Y(wb,ub)|0)|0;f[da>>2]=rb;Mc=tb}xa=xa+1|0;if((xa|0)>=(Ma|0))break;else{sb=Kc;Db=Lc;Ha=Mc}}f[U>>2]=Kc;f[ca>>2]=Mc;break}}while(0);Ma=(Da|0)>1;if((bb|0)<=1){if(!Ma){vc=4;wc=ua;break}f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];f[i+16>>2]=f[l+16>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];q7(h,1-Da|0,1);vc=0;wc=ua;break}if(!Ma){f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];f[i+8>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];f[i+16>>2]=f[k+16>>2];f[i+20>>2]=f[k+20>>2];f[i+24>>2]=f[k+24>>2];f[i+28>>2]=f[k+28>>2];f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];q7(i,bb+-1|0,1);vc=0;wc=ua;break}Ma=ua+1|0;if((bb|0)>(Da|0)){f[j+(Ma<<5)>>2]=f[$>>2];f[j+(Ma<<5)+4>>2]=f[X>>2];f[j+(Ma<<5)+8>>2]=f[_>>2];f[j+(Ma<<5)+12>>2]=f[ka>>2];q7(k,bb+-1|0,1);f[j+(Ma<<5)+16>>2]=f[$>>2];f[j+(Ma<<5)+20>>2]=f[X>>2];f[j+(Ma<<5)+24>>2]=f[_>>2];f[j+(Ma<<5)+28>>2]=f[ka>>2];f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];f[i+16>>2]=f[l+16>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];q7(h,1-Da|0,1);vc=0;wc=Ma;break}else{f[j+(Ma<<5)+16>>2]=f[H>>2];f[j+(Ma<<5)+20>>2]=f[F>>2];f[j+(Ma<<5)+24>>2]=f[G>>2];f[j+(Ma<<5)+28>>2]=f[K>>2];q7(l,1-Da|0,1);f[j+(Ma<<5)>>2]=f[H>>2];f[j+(Ma<<5)+4>>2]=f[F>>2];f[j+(Ma<<5)+8>>2]=f[G>>2];f[j+(Ma<<5)+12>>2]=f[K>>2];f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];f[i+8>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];f[i+16>>2]=f[k+16>>2];f[i+20>>2]=f[k+20>>2];f[i+24>>2]=f[k+24>>2];f[i+28>>2]=f[k+28>>2];f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];q7(i,bb+-1|0,1);vc=0;wc=Ma;break}}while(0);switch(vc&7){case 6:{Ba=224;break b;break}case 0:break;default:if(vc|0){Nc=wc;break b}}ua=wc;va=f[r>>2]|0;T=f[E>>2]|0}if((Ba|0)==224){Ba=0;Ja=wc;Ka=f[r>>2]|0;La=f[w>>2]|0;Ba=33}e:do if((Ba|0)==33){Ba=0;T=f[p>>2]|0;va=f[q>>2]|0;ua=f[o>>2]|0;wa=La+s|0;if(wa>>>0<ua>>>0){Oc=wa;Pc=va;Qc=ua;Rc=Ka}else{ua=f[Ka+4>>2]|0;wa=f[ua+16>>2]|0;Oc=wa;Pc=wa;Qc=wa+(Y(f[ua+12>>2]|0,f[T+28>>2]|0)|0)|0;Rc=ua}ua=(f[z>>2]|0)+s|0;f[z>>2]=ua;if(ua>>>0>=(f[P>>2]|0)>>>0){ua=f[(f[R>>2]|0)+28>>2]|0;wa=f[(f[E>>2]|0)+4>>2]|0;f[E>>2]=wa;Fa=f[wa+16>>2]|0;Ga=f[wa+12>>2]|0;f[z>>2]=Fa;f[x>>2]=Fa;wa=Fa+(Y(Ga,ua)|0)|0;f[P>>2]=wa}wa=T+28|0;T=Oc;ua=va;va=Pc;Ga=Qc;Fa=Ka;Na=Rc;while(1){Ma=Ga;if(W){Oa=T;Qa=ua;eb=Fa;while(1){if((Oa|0)==(f[z>>2]|0)){Nc=Ja;break e}cb=(eb|0)==(Na|0)?Qa:va;f:do if((Oa|0)==(f[w>>2]|0)){Sc=cb;Tc=Na}else{Ra=cb;Ha=Na;Db=Oa;while(1){sb=Db+a|0;if(sb>>>0<Ra>>>0){xa=f[Ha>>2]|0;Ca=f[xa+16>>2]|0;Uc=Ca;Vc=xa;Wc=Ca+(Y((f[xa+12>>2]|0)+-1|0,f[wa>>2]|0)|0)|0}else{Uc=Ra;Vc=Ha;Wc=sb}if((hj[c&511](Wc,Db,d)|0)<1){Sc=Uc;Tc=Vc;break f}else Xc=0;do{sb=Wc+Xc|0;xa=b[sb>>0]|0;Ca=Db+Xc|0;b[sb>>0]=b[Ca>>0]|0;b[Ca>>0]=xa;Xc=Xc+1|0}while((Xc|0)!=(s|0));if((Wc|0)==(f[w>>2]|0)){Sc=Uc;Tc=Vc;break}else{Ra=Uc;Ha=Vc;Db=Wc}}}while(0);Oa=Oa+s|0;if(Oa>>>0>=Ma>>>0){Yc=Sc;Zc=Tc;break}else{Qa=Sc;eb=Tc}}}else{eb=T;Qa=ua;Oa=Fa;while(1){if((eb|0)==(f[z>>2]|0)){Nc=Ja;break e}bb=(Oa|0)==(Na|0)?Qa:va;if((eb|0)==(f[w>>2]|0)){_c=bb;$c=Na}else{Da=bb;bb=Na;cb=eb;while(1){Db=cb+a|0;if(Db>>>0<Da>>>0){Ha=f[bb>>2]|0;Ra=f[Ha+16>>2]|0;ad=Ra;bd=Ha;cd=Ra+(Y((f[Ha+12>>2]|0)+-1|0,f[wa>>2]|0)|0)|0}else{ad=Da;bd=bb;cd=Db}Db=(hj[c&511](cd,cb,d)|0)<1;if(Db|(cd|0)==(f[w>>2]|0)){_c=ad;$c=bd;break}else{Da=ad;bb=bd;cb=cd}}}eb=eb+s|0;if(eb>>>0>=Ma>>>0){Yc=_c;Zc=$c;break}else{Qa=_c;Oa=$c}}}Oa=f[Na+4>>2]|0;Qa=f[Oa+16>>2]|0;T=Qa;ua=Yc;va=Qa;Ga=Qa+(Y(f[Oa+12>>2]|0,f[wa>>2]|0)|0)|0;Fa=Zc;Na=Oa}}while(0);if((Nc|0)<=-1){Ba=227;break}ra=Nc;sa=f[j+(Nc<<5)+4>>2]|0;ta=f[j+(Nc<<5)+8>>2]|0;A=f[j+(Nc<<5)+12>>2]|0;B=f[j+(Nc<<5)+16>>2]|0;S=f[j+(Nc<<5)+20>>2]|0;L=f[j+(Nc<<5)+24>>2]|0;N=f[j+(Nc<<5)+28>>2]|0}if((Ba|0)==20){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242813,1020)}else if((Ba|0)==26){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242813,1020)}else if((Ba|0)==144){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242813,1020)}else if((Ba|0)==152){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242813,1020)}else if((Ba|0)==158){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242813,1020)}else if((Ba|0)==182){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242813,1020)}else if((Ba|0)==188){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242813,1020)}else if((Ba|0)==194){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,242813,1020)}else if((Ba|0)==227){u=e;return}}function G7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;if(!d){f[g>>2]=0;f[g+4>>2]=0;d7(-27,g,243056,2486)}if((b|0)>63&(c|0)>7&(c&3|0)==0){h=m7(a,b,c,d)|0;f[h>>2]=f[h>>2]&65535|1117257728;u=e;return h|0}else{f[g>>2]=0;f[g+4>>2]=0;d7(-201,g,243056,2490)}return 0}function H7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;d7(-27,e,243068,2507)}e=a+56|0;g=f[e>>2]|0;if(!g){h=a+24|0;i=f[h>>2]|0;j=f[a+28>>2]|0;y7(a,0);k=a+36|0;l=f[k>>2]|0;f[e>>2]=l;m=l+j|0;n=f[a+32>>2]|0;if(m>>>0>n>>>0){o=l;p=i}else{q=i;i=l;r=m;while(1){f[i>>2]=q|-2147483648;f[i+4>>2]=r;m=q+1|0;s=r+j|0;if(s>>>0>n>>>0){o=r;p=m;break}else{t=r;q=m;r=s;i=t}}}f[o+(0-j)+4>>2]=0;j=(f[f[a+52>>2]>>2]|0)+12|0;f[j>>2]=p-(f[h>>2]|0)+(f[j>>2]|0);f[h>>2]=p;f[k>>2]=n;v=l}else v=g;f[e>>2]=f[v+4>>2];e=f[v>>2]&67108863;if(b|0)dJc(v|0,b|0,f[a+28>>2]|0)|0;f[v>>2]=e;b=a+60|0;f[b>>2]=(f[b>>2]|0)+1;if(!c){u=d;return e|0}f[c>>2]=v;u=d;return e|0}function I7(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;d7(-27,c,242940,1596)}else{D7(a,0,f[a+24>>2]|0,0);f[a+56>>2]=0;f[a+60>>2]=0;u=b;return}}function J7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;if((c|0)<8|((b|0)<68|(d|0)<24)){f[h>>2]=0;f[h+4>>2]=0;d7(-201,h,243077,2586)}else{h=G7(a,b,c,e)|0;c=G7(0,64,d,e)|0;f[h+64>>2]=c;u=g;return h|0}return 0}function K7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;d7(-27,e,243091,2620)}e=a+56|0;g=f[e>>2]|0;if(!g){h=a+24|0;i=f[h>>2]|0;j=f[a+28>>2]|0;y7(a,0);k=a+36|0;l=f[k>>2]|0;f[e>>2]=l;m=l+j|0;n=f[a+32>>2]|0;if(m>>>0>n>>>0){o=l;p=i}else{q=i;i=l;r=m;while(1){f[i>>2]=q|-2147483648;f[i+4>>2]=r;m=q+1|0;s=r+j|0;if(s>>>0>n>>>0){o=r;p=m;break}else{t=r;q=m;r=s;i=t}}}f[o+(0-j)+4>>2]=0;j=(f[f[a+52>>2]>>2]|0)+12|0;f[j>>2]=p-(f[h>>2]|0)+(f[j>>2]|0);f[h>>2]=p;f[k>>2]=n;v=l}else v=g;g=v+4|0;f[e>>2]=f[g>>2];e=f[v>>2]&67108863;f[v>>2]=e;l=a+60|0;f[l>>2]=(f[l>>2]|0)+1;if(b|0)dJc(v+8|0,b+8|0,(f[a+28>>2]|0)+-8|0)|0;f[g>>2]=0;if(!c){u=d;return e|0}f[c>>2]=v;u=d;return e|0}function L7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0&(c|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;d7(-27,e,243105,2705)}if((b|0)==(c|0)){g=0;u=d;return g|0}if(!(f[a>>2]&16384)){a=(f[b>>2]&67108863)>>>0>(f[c>>2]&67108863)>>>0;h=a?c:b;i=a?b:c}else{h=b;i=c}c=f[h+4>>2]|0;if(!c){g=0;u=d;return g|0}else j=c;while(1){c=f[j+20>>2]|0;if((c|0)==(i|0)){g=j;k=9;break}j=f[j+8+(((h|0)==(c|0)&1)<<2)>>2]|0;if(!j){g=0;k=9;break}}if((k|0)==9){u=d;return g|0}return 0}function M7(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;h=u;u=u+16|0;i=h;if(!a){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,21)|0;k=243126;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));d7(-27,i,243148,2762)}if(!(f[a>>2]&16384)){m=(f[c>>2]&67108863)>>>0>(f[d>>2]&67108863)>>>0;o=m?d:c;p=m?c:d}else{o=c;p=d}d=L7(a,o,p)|0;if(d|0){if(!g){q=0;u=h;return q|0}f[g>>2]=d;q=0;u=h;return q|0}if((o|0)==(p|0)){d=p|0?-5:-27;f[i>>2]=0;f[i+4>>2]=0;j=tT(i,41)|0;k=243168;l=j+41|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));d7(d,i,243148,2782)}d=a+64|0;a=f[d>>2]|0;k=a+56|0;j=f[k>>2]|0;if(!j){if(!a){f[i>>2]=0;f[i+4>>2]=0;d7(-27,i,243068,2507)}i=a+24|0;l=f[i>>2]|0;c=f[a+28>>2]|0;y7(a,0);m=a+36|0;r=f[m>>2]|0;f[k>>2]=r;s=r+c|0;t=f[a+32>>2]|0;if(s>>>0>t>>>0){v=r;w=l}else{x=l;l=r;y=s;while(1){f[l>>2]=x|-2147483648;f[l+4>>2]=y;s=x+1|0;z=y+c|0;if(z>>>0>t>>>0){v=y;w=s;break}else{A=y;x=s;y=z;l=A}}}f[v+(0-c)+4>>2]=0;c=(f[f[a+52>>2]>>2]|0)+12|0;f[c>>2]=w-(f[i>>2]|0)+(f[c>>2]|0);f[i>>2]=w;f[m>>2]=t;B=r}else B=j;j=B+4|0;f[k>>2]=f[j>>2];f[B>>2]=f[B>>2]&67108863;k=a+60|0;f[k>>2]=(f[k>>2]|0)+1;f[B+16>>2]=o;f[B+20>>2]=p;k=o+4|0;f[B+8>>2]=f[k>>2];o=p+4|0;f[B+12>>2]=f[o>>2];f[o>>2]=B;f[k>>2]=B;k=(f[(f[d>>2]|0)+28>>2]|0)+-24|0;d=(k|0)>0;if(!e)if(d){XIc(B+24|0,0,k|0)|0;C=1.0}else C=1.0;else{if(d)dJc(B+24|0,e+24|0,k|0)|0;C=+n[e+4>>2]}n[j>>2]=C;if(!g){q=1;u=h;return q|0}f[g>>2]=B;q=1;u=h;return q|0}function N7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;g=e+4|0;f[g>>2]=0;h=tT(e,21)|0;i=h;j=243210;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));d7(-5,e,243232,3262)}if((f[a>>2]&-53248|0)!=1117261824){f[e>>2]=0;g=e+4|0;f[g>>2]=0;h=tT(e,21)|0;i=h;j=243210;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));d7(-5,e,243232,3262)}if(!c){h=f[a+44>>2]|0;if(!h){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,20)|0;j=254626;k=i+20|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));d7(-27,e,243232,3268)}else l=h}else l=c;c=a+28|0;h=f[c>>2]|0;j=a+64|0;i=f[(f[j>>2]|0)+28>>2]|0;k=a+24|0;g=h0(f[k>>2]<<2)|0;m=h0(f[k>>2]<<2)|0;n=a+4|0;o=f[n>>2]|0;if((h|0)<8|((i|0)<24|(o|0)<68)){f[e>>2]=0;f[e+4>>2]=0;d7(-201,e,243077,2586)}p=G7(f[a>>2]|0,o,h,l)|0;o=G7(0,64,i,l)|0;f[p+64>>2]=o;dJc(p+4624|0,a+4624|0,(f[n>>2]|0)+-68|0)|0;n=a+52|0;a=f[n>>2]|0;if(!a){q=0;r=0;s=0}else{o=f[a+16>>2]|0;q=a;r=o;s=o+(Y(f[a+12>>2]|0,f[c>>2]|0)|0)|0}if((f[k>>2]|0)>0){a=0;o=0;l=q;q=r;r=s;while(1){s=q;if((f[s>>2]|0)>-1){f[e>>2]=0;K7(p,q,e)|0;t=f[s>>2]|0;v=f[e>>2]|0;f[v>>2]=t;f[g+(o<<2)>>2]=t;f[s>>2]=o;f[m+(o<<2)>>2]=v;w=o+1|0}else w=o;v=q+h|0;if(v>>>0<r>>>0){x=l;y=v;z=r}else{v=f[l+4>>2]|0;s=f[v+16>>2]|0;x=v;y=s;z=s+(Y(f[v+12>>2]|0,f[c>>2]|0)|0)|0}a=a+1|0;if((a|0)>=(f[k>>2]|0))break;else{o=w;l=x;q=y;r=z}}}z=f[j>>2]|0;if(!z){f[e>>2]=0;f[e+4>>2]=0;d7(-27,e,242518,945)}r=f[z+52>>2]|0;if(!r){A=0;B=0;C=0}else{y=f[r+16>>2]|0;A=r;B=y;C=y+(Y(f[r+12>>2]|0,f[z+28>>2]|0)|0)|0}r=f[z+24>>2]|0;if((r|0)>0){y=z+28|0;z=0;q=A;A=B;B=C;while(1){C=A;x=A;if((f[x>>2]|0)>-1){f[e>>2]=0;M7(p,f[m+(f[f[C+16>>2]>>2]<<2)>>2]|0,f[m+(f[f[C+20>>2]>>2]<<2)>>2]|0,A,e)|0;f[f[e>>2]>>2]=f[x>>2]}x=C+i|0;if(x>>>0<B>>>0){D=q;E=x;F=B}else{x=f[q+4>>2]|0;C=f[x+16>>2]|0;D=x;E=C;F=C+(Y(f[x+12>>2]|0,f[y>>2]|0)|0)|0}z=z+1|0;x=f[(f[j>>2]|0)+24>>2]|0;if((z|0)>=(x|0)){G=x;break}else{q=D;A=E;B=F}}}else G=r;r=f[n>>2]|0;if(!r){H=0;I=0;J=0}else{n=f[r+16>>2]|0;H=r;I=n;J=n+(Y(f[r+12>>2]|0,f[c>>2]|0)|0)|0}if((G|0)>0){K=0;L=0;M=H;N=I;O=J}else{i0(g);i0(m);P=j6()|0;Q=(P|0)<0;R=Q?0:p;u=d;return R|0}while(1){J=N;if((f[J>>2]|0)>-1){f[J>>2]=f[g+(L<<2)>>2];S=L+1|0}else S=L;J=N+h|0;if(J>>>0<O>>>0){T=M;U=J;V=O}else{J=f[M+4>>2]|0;I=f[J+16>>2]|0;T=J;U=I;V=I+(Y(f[J+12>>2]|0,f[c>>2]|0)|0)|0}K=K+1|0;if((K|0)>=(G|0))break;else{L=S;M=T;N=U;O=V}}i0(g);i0(m);P=j6()|0;Q=(P|0)<0;R=Q?0:p;u=d;return R|0}function O7(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;if(!d){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,20)|0;i=254626;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));d7(-27,g,243245,3346)}i=m7(0,c,4,d)|0;if(!a){u=e;return i|0}d=a;a=0;while(1){c=f[d+20>>2]|0;if(c){h=a+1|0;if((h|0)==2147483647){k=d;l=2147483646;m=7}else{n=h;o=c}}else{k=d;l=a;m=7}a:do if((m|0)==7){while(1){m=0;p=f[k+12>>2]|0;if(p|0)break;c=l+-1|0;if((l|0)<1){n=c;o=0;break a}else{k=f[k+16>>2]|0;l=c;m=7}}n=l;o=(k|0)==0?0:p}while(0);f[g>>2]=d;A7(i,g)|0;if(!o)break;else{d=o;a=n}}u=e;return i|0}function P7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;d7(-27,e,243261,3443)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;d7(-211,e,243261,3446)}else{f[a>>2]=b;f[a+4>>2]=0;f[a+8>>2]=c;u=d;return}}function Q7(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,21)|0;g=243284;h=e+21|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));d7(-27,d,243306,3462)}d=f[a>>2]|0;g=a+4|0;e=f[g>>2]|0;a:do if(d){h=f[d+20>>2]|0;if((h|0)!=0?(i=e+1|0,(i|0)<(f[a+8>>2]|0)):0){j=h;k=i;break}else{l=d;m=e}while(1){n=f[l+12>>2]|0;if(n|0)break;i=m+-1|0;if((m|0)<1){j=0;k=i;break a}else{l=f[l+16>>2]|0;m=i}}if(!l){j=0;k=m}else{j=(f[a+8>>2]|0)==0?0:n;k=m}}else{j=d;k=e}while(0);f[a>>2]=j;f[g>>2]=k;u=c;return d|0}function R7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;d7(-27,e,243321,3392)}f[a+16>>2]=(b|0)!=(c|0)?b:0;c=b+20|0;b=f[c>>2]|0;f[a+12>>2]=b;if(!b){f[c>>2]=a;u=d;return}f[b+8>>2]=a;f[c>>2]=a;u=d;return}function S7(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;f[c>>2]=0;f[c+4>>2]=0;a=tT(c,44)|0;d=243342;e=a+44|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));z5(-216,c,243387,243401,107)}function T7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;S7()}function U7(a){a=a|0;return}function V7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;S7();return 0}function W7(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c+20|0;e=c+16|0;g=c+12|0;h=c+8|0;i=c;j=f[a+76>>2]|0;f[d>>2]=0;f[e>>2]=0;f[g>>2]=0;f[h>>2]=0;k=X7(a,j,2)|0;if(Arc(k,243489,5)|0)M8(a,243495,243507,243549,616);j=Y7(a,k,d,g,h)|0;a:do if(b[j>>0]|0){k=a+32|0;l=j;while(1){m=X7(a,l,0)|0;if(!(b[m>>0]|0))break a;n=Y7(a,m,d,g,h)|0;m=f[d>>2]|0;if(!((f[h>>2]|0)==1&(m|0)!=0)){o=8;break}if(Ioc(f[m+8>>2]|0,243623)|0){o=8;break}p=Y7(a,Z7(a,n,A7(f[k>>2]|0,0)|0,0)|0,e,g,h)|0;if(!((f[h>>2]|0)==2?(m|0)==(f[e>>2]|0):0)){o=10;break}l=X7(a,p,0)|0;if(!(b[l>>0]|0))break a}if((o|0)==8)M8(a,243495,243638,243549,646);else if((o|0)==10)M8(a,243495,243670,243549,652)}while(0);if(!(f[a+92>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;a=tT(i,18)|0;o=243703;e=a+18|0;do{b[a>>0]=b[o>>0]|0;a=a+1|0;o=o+1|0}while((a|0)<(e|0));_7(-215,i,243495,656)}else{u=c;return}}function X7(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=a+76|0;g=a+80|0;h=a+88|0;i=c;c=0;j=d;a:while(1){d=i+-1|0;b:do switch(j|0){case 1:{k=b[i>>0]|0;c:do if((k&255)>31|k<<24>>24==9){l=d;m=k;n=i;while(1){if((m<<24>>24==45?(b[l+2>>0]|0)==45:0)?(b[l+3>>0]|0)==62:0){o=l;p=45;q=n;break c}r=n+1|0;s=b[r>>0]|0;if((s&255)>31|s<<24>>24==9){t=n;m=s;n=r;l=t}else{o=n;p=s;q=r;break}}}else{o=d;p=k;q=i}while(0);k=p<<24>>24==45;u=(k^1)&1;v=c;w=k?o+4|0:q;break}case 3:{k=c;n=d;while(1){l=n+1|0;m=b[l>>0]|0;r=(m<<24>>24==60&1)+k+((m<<24>>24==62)<<31>>31)|0;if((r|0)<0){x=l;y=28;break a}if((m&255)>31|m<<24>>24==9){k=r;n=l}else{u=3;v=r;w=l;break}}break}default:{n=d;d:while(1){z=n+1|0;A=b[z>>0]|0;switch(A<<24>>24){case 9:case 32:{n=z;break}case 60:{break d;break}default:{y=18;break d}}}if((y|0)==18){y=0;if((A&255)>31){x=z;y=28;break a}else{u=j;v=c;w=z;break b}}if((b[n+2>>0]|0)!=33){x=z;y=28;break a}if((b[n+3>>0]|0)!=45){x=z;y=28;break a}if((b[n+4>>0]|0)!=45){x=z;y=28;break a}if(j|0){y=16;break a}u=1;v=c;w=n+5|0}}while(0);d=b[w>>0]|0;if((d&255)>31){i=w;c=v;j=u;continue}k=f[e>>2]|0;switch(d<<24>>24){case 13:case 10:case 0:break;default:{y=21;break a}}d=H8(a,k,(f[g>>2]|0)-k|0)|0;if(!d){y=27;break}k=d+((Mpc(d)|0)+-1)|0;switch(b[k>>0]|0){case 13:case 10:break;default:if(!(I8(a)|0)){y=25;break a}}f[h>>2]=(f[h>>2]|0)+1;i=d;c=v;j=u}if((y|0)==16)M8(a,244647,244664,243549,65);else if((y|0)==21)M8(a,244647,245998,243549,77);else if((y|0)==25)M8(a,244647,248156,243549,90);else if((y|0)==27){u=f[e>>2]|0;b[u>>0]=0;f[a+92>>2]=1;x=u;return x|0}else if((y|0)==28)return x|0;return 0}function Y7(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=u;u=u+16|0;i=h;switch(b[c>>0]|0){case 0:{M8(a,244292,244307,243549,471);break}case 60:{j=c+1|0;k=b[j>>0]|0;if(k<<24>>24==0?(j|0)==((f[a+80>>2]|0)+-1|0):0){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,98)|0;m=247728;n=l+98|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));_7(-215,i,244292,477)}a:do if(((k&-33)+-65&255)<26|(k+-48&255)<10){o=j;p=1}else switch(k<<24>>24){case 95:{o=j;p=1;break a;break}case 47:{o=c+2|0;p=2;break a;break}case 63:{o=c+2|0;p=4;break a;break}case 33:{o=c+2|0;p=5;break a;break}default:M8(a,244292,244363,243549,497)}while(0);c=a+80|0;j=(p|0)==4;k=(p|0)==1;q=i+8+4|0;r=(p|0)==2;s=a+16|0;t=b[o>>0]|0;if(((t&-33)+-65&255)<26|t<<24>>24==95){v=o;w=0;x=0;y=0;z=0}else M8(a,244292,244380,243549,504);b:while(1){o=v+-1|0;c:while(1){A=o+1|0;t=b[A>>0]|0;if((t+-48&255)<10|((t&-33)+-65&255)<26){o=A;continue}switch(t<<24>>24){case 45:case 95:{o=A;break}default:break c}}o=n1(a,v,A-v|0,1)|0;if(!o){B=19;break}if((b[A>>0]|0)==0?(A|0)==((f[c>>2]|0)+-1|0):0){B=22;break}if(!w){C=o;D=z;E=x;F=y}else{if(r){B=25;break}t=(y|0)!=0;if((z|0)>3|t^1){G=j7(f[s>>2]|0,44)|0;l=G+4|0;n=l+40|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));f[G>>2]=G+8;if(t){f[y+4>>2]=G;H=0;I=x;J=G}else{H=0;I=G;J=G}}else{H=z;I=x;J=y}f[(f[J>>2]|0)+(H<<1<<2)>>2]=f[o+8>>2];C=w;D=H;E=I;F=J}if(!F){K=A;L=D}else{if((b[A>>0]|0)!=61){M=X7(a,A,2)|0;if((b[M>>0]|0)==61)N=M;else{B=33;break}}else N=A;M=N+1|0;switch(b[M>>0]|0){case 39:case 34:{O=M;break}default:{P=X7(a,M,2)|0;switch(b[P>>0]|0){case 39:case 34:{O=P;break}default:{B=36;break b}}}}P=Z7(a,O,i,3)|0;f[(f[F>>2]|0)+((D<<1|1)<<2)>>2]=f[q>>2];K=P;L=D+1|0}P=b[K>>0]|0;if(P<<24>>24==62){B=39;break}v=X7(a,K,2)|0;M=b[v>>0]|0;if(M<<24>>24==62){B=41;break}if(j&M<<24>>24==63){B=45;break}if(M<<24>>24==47?k&(b[v+1>>0]|0)==62:0){B=50;break}switch(P<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:break;default:{B=53;break b}}if(!(((M&-33)+-65&255)<26|M<<24>>24==95)){B=14;break}else{w=C;x=E;y=F;z=L}}switch(B|0){case 14:{M8(a,244292,244380,243549,504);break}case 19:{f[i>>2]=0;f[i+4>>2]=0;B=tT(i,8)|0;L=B;b[L>>0]=97;b[L+1>>0]=116;b[L+2>>0]=116;b[L+3>>0]=114;L=B+4|0;b[L>>0]=110;b[L+1>>0]=97;b[L+2>>0]=109;b[L+3>>0]=101;_7(-215,i,244292,511);break}case 22:{f[i>>2]=0;f[i+4>>2]=0;l=tT(i,98)|0;m=247728;n=l+98|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));_7(-215,i,244292,513);break}case 25:{M8(a,244292,244426,243549,520);break}case 33:{M8(a,244292,244472,243549,546);break}case 36:{M8(a,244292,244513,243549,554);break}case 39:{if(j)M8(a,244292,244572,243549,575);else Q=K;break}case 41:{if(j)M8(a,244292,244572,243549,575);else Q=v;break}case 45:{if((b[v+1>>0]|0)!=62)M8(a,244292,244572,243549,582);R=4;S=v+2|0;f[d>>2]=C;f[g>>2]=R;f[e>>2]=E;u=h;return S|0}case 50:{R=3;S=v+2|0;f[d>>2]=C;f[g>>2]=R;f[e>>2]=E;u=h;return S|0}case 53:{M8(a,244292,244606,243549,594);break}}R=p;S=Q+1|0;f[d>>2]=C;f[g>>2]=R;f[e>>2]=E;u=h;return S|0}default:M8(a,244292,244337,243549,474)}return 0}function Z7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;g=u;u=u+4224|0;h=g+104|0;i=g;j=g+88|0;k=g+76|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;q=g+16|0;r=g+12|0;t=e&16;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;v=e&7;e=(v|0)==3;w=a+80|0;x=a+16|0;y=(v+-1|0)>>>0<4;z=d+8|0;A=a+92|0;B=j+4|0;C=j+8|0;D=j+8|0;E=i+11|0;F=i+4|0;G=j+11|0;H=j+4|0;I=k+4|0;J=k+8|0;K=a+76|0;L=k+8|0;M=c;c=1;N=1;a:while(1){O=b[M>>0]|0;switch(O<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{P=5;break}case 60:{Q=b[M+1>>0]|0;if(Q<<24>>24==33)if((b[M+2>>0]|0)==45)P=5;else{R=60;S=c;T=M;U=33;P=7}else{R=60;S=c;T=M;U=Q;P=7}break}default:{V=O;W=M;X=c;P=6}}if((P|0)==5){P=0;O=X7(a,M,0)|0;V=b[O>>0]|0;W=O;X=1;P=6}b:do if((P|0)==6){P=0;O=b[W+1>>0]|0;switch(V<<24>>24){case 0:case 60:{R=V;S=X;T=W;U=O;P=7;break b;break}default:{}}if(!X){P=86;break a}Q=f[d>>2]|0;if(!Q)Y=d;else{if((Q&7)>>>0<=4)N8(a,5,d);Q=A7(f[z>>2]|0,0)|0;f[Q+4>>2]=0;Y=Q}c:do if(!e){d:do if((V+-48&255)<10)Z=V;else switch(V<<24>>24){case 43:case 45:{if(O<<24>>24==46|(O+-48&255)<10){Z=V;break d}else{P=106;break c}break}case 46:{if((O+-48&255)<10|((O&-33)+-65&255)<26){Z=46;break d}else{P=106;break c}break}default:{P=106;break c}}while(0);Q=W+((V<<24>>24==43|Z<<24>>24==45)&1)|0;while(1){f[m>>2]=Q;_=b[Q>>0]|0;if((_+-48&255)<10)Q=Q+1|0;else break}switch(_<<24>>24){case 101:case 46:{$=+T8(a,W,m);f[Y>>2]=2;p[Y+8>>3]=$;break}default:{Q=yrc(W,m,0)|0;f[Y>>2]=1;f[Y+8>>2]=Q}}Q=f[m>>2]|0;if((Q|0)==(W|0)){P=102;break a}if((b[Q>>0]|0)==0?(Q|0)==((f[w>>2]|0)+-1|0):0){P=105;break a}else aa=Q}else P=106;while(0);if((P|0)==106){P=0;XIc(h|0,0,4112)|0;f[Y>>2]=3;O=V<<24>>24==34;Q=0;ba=O?W:W+-1|0;e:while(1){ca=ba+1|0;da=b[ca>>0]|0;if(da<<24>>24==0?(ca|0)==((f[w>>2]|0)+-1|0):0){P=109;break a}f:do if(!((da+-48&255)<10|((da&-33)+-65&255)<26)){if(da<<24>>24==34){P=112;break e}if((da&255)<32|da<<24>>24==60){P=118;break e}if(O)switch(da<<24>>24){case 62:case 39:{P=121;break a;break}case 38:break;default:{ea=Q;fa=da;ga=ca;break f}}else switch(da<<24>>24){case 62:case 39:{P=121;break a;break}case 9:case 10:case 11:case 12:case 13:case 32:{ha=ca;break e;break}case 38:break;default:{ea=Q;fa=da;ga=ca;break f}}ia=ba+2|0;if((b[ia>>0]|0)==35){ja=ba+3|0;ka=(b[ja>>0]|0)==120;la=yrc(ka?ba+4|0:ja,m,ka?16:10)|0;ka=f[m>>2]|0;if(!(la>>>0<256&(ka|0)!=0)){P=125;break a}if((b[ka>>0]|0)!=59){P=125;break a}ea=Q;fa=la&255;ga=ka;break}f[m>>2]=ia;ka=ia;do{ka=ka+1|0;f[m>>2]=ka;ma=b[ka>>0]|0}while((ma+-48&255)<10|((ma&-33)+-65&255)<26);if(ma<<24>>24!=59){P=130;break a}la=ka-ia|0;switch(la|0){case 2:{if(!(Arc(ia,244219,2)|0)){ea=Q;fa=60;ga=ka;break f}if(!(Arc(ia,244222,2)|0)){ea=Q;fa=62;ga=ka;break f}break}case 3:{if(!(Arc(ia,244225,3)|0)){ea=Q;fa=38;ga=ka;break f}break}case 4:{if(!(Arc(ia,244229,4)|0)){ea=Q;fa=39;ga=ka;break f}if(!(Arc(ia,244234,4)|0)){ea=Q;fa=34;ga=ka;break f}break}default:{}}ja=la+2|0;dJc(h+Q|0,ca|0,ja|0)|0;la=ja+Q|0;if((b[ka>>0]|0)==0?(ka|0)==((f[w>>2]|0)+-1|0):0){P=139;break a}else{ea=la;fa=59;ga=ka}}else{ea=Q;fa=da;ga=ca}while(0);b[h+ea>>0]=fa;if((ea|0)>4094){P=141;break a}else{Q=ea+1|0;ba=ga}}if((P|0)==112){P=0;if(!O){P=113;break a}ha=ba+2|0}else if((P|0)==118){P=0;if(O){P=119;break a}else ha=ca}l7(i,f[x>>2]|0,h,Q);da=Y+8|0;p[s>>3]=+p[i>>3];f[da>>2]=f[s>>2];f[da+4>>2]=f[s+4>>2];aa=ha}if(y){na=aa;oa=N;P=145;break a}else{pa=N;qa=0;ra=aa}}while(0);if((P|0)==7){P=0;f[n>>2]=0;f[o>>2]=0;f[q>>2]=0;f[r>>2]=0;if(!(U<<24>>24==47|R<<24>>24==0)){da=Y7(a,T,n,q,r)|0;switch(f[r>>2]|0){case 5:{P=9;break a;break}case 3:{P=10;break a;break}case 1:break;default:{P=11;break a}}la=f[q>>2]|0;if((la|0)!=0?(ja=m1(la,245870)|0,(ja|0)!=0):0)if(Ioc(ja,247459)|0)if(Ioc(ja,247467)|0)if(Ioc(ja,247463)|0)if(!(Ioc(ja,247471)|0)){sa=1;ta=0;ua=0}else{la=C1(ja)|0;sa=0;ta=(la|0)==0?0:16;ua=la}else{sa=0;ta=5;ua=0}else{sa=0;ta=6;ua=0}else{sa=0;ta=3;ua=0}else{sa=0;ta=0;ua=0}la=f[n>>2]|0;if((f[la+4>>2]|0)==1)va=(b[f[la+8>>2]>>0]|0)==95;else va=0;ja=f[d>>2]&7;if(ja>>>0>4){if(va^(ja|0)==5){P=24;break}}else N8(a,va?5:6,d);if(va)wa=A7(f[z>>2]|0,0)|0;else wa=o1(a,d,la,1)|0;if(!wa){P=29;break}if(sa){ja=X7(a,da,2)|0;xa=ja;f[h>>2]=xa;if((f[A>>2]|0)==0?(ya=b[ja>>0]|0,ya<<24>>24!=60):0){if((ya&255)>31){za=1;while(1){Aa=b[ja+za>>0]|0;if((Aa&255)>31)za=za+1|0;else{Ba=za;Ca=Aa;break}}}else{Ba=0;Ca=ya}za=ja+Ba|0;if(!(Ca<<24>>24)){P=37;break}Aa=za;f[h>>2]=Aa;Da=Ba;Ea=za;Fa=Aa}else{Da=0;Ea=ja;Fa=xa}Aa=ja+Da|0;if(ja>>>0<Ea>>>0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if((Fa-xa|0)<32){P=41;break}f[j>>2]=0;f[B>>2]=0;f[C>>2]=0;za=VDc(25)|0;f[j>>2]=za;Ga=za+25|0;f[D>>2]=Ga;Ha=za;Ia=Ha+25|0;do{b[Ha>>0]=32;Ha=Ha+1|0}while((Ha|0)<(Ia|0));f[B>>2]=Ga;x3(ja,za,0,32)|0;if(!(H3(j,i)|0)){P=44;break}xa=b[E>>0]|0;if(!((xa<<24>>24<0?f[F>>2]|0:xa&255)|0)){P=44;break}xa=ja+32|0;ya=f[j>>2]|0;if(ya|0){if((f[B>>2]|0)!=(ya|0))f[B>>2]=ya;YDc(ya)};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;mEc(j,131072);if((Da|0)>32){ya=Aa;Ja=Ea;Ka=xa;while(1){$7(j,Ka,ya)|0;Ka=X7(a,Ja,2)|0;f[h>>2]=Ka;do if(!(f[A>>2]|0)){xa=b[Ka>>0]|0;if(xa<<24>>24==60){La=Ka;break}if((xa&255)>31){Ma=Ka;while(1){Na=Ma+1|0;Oa=b[Na>>0]|0;if((Oa&255)>31)Ma=Na;else{Pa=Na;Qa=Oa;break}}}else{Pa=Ka;Qa=xa}if(!(Qa<<24>>24)){P=56;break a}f[h>>2]=Pa;La=Pa}else La=Ka;while(0);if(Ka>>>0>=La>>>0)break;else{ya=La;Ja=La}}}Ja=b[G>>0]|0;ya=Ja<<24>>24<0;Ka=ya?f[H>>2]|0:Ja&255;if(!Ka){P=60;break}if(!(y3(ya?f[j>>2]|0:j,0,Ka)|0)){P=60;break}Ka=b[G>>0]|0;ya=z3(Ka<<24>>24<0?f[H>>2]|0:Ka&255,1)|0;f[k>>2]=0;f[I>>2]=0;f[J>>2]=0;if(ya|0){if((ya|0)<0){P=63;break}Ka=VDc(ya)|0;f[I>>2]=Ka;f[k>>2]=Ka;f[L>>2]=Ka+ya;Ja=ya;ya=Ka;do{b[ya>>0]=0;ya=(f[I>>2]|0)+1|0;f[I>>2]=ya;Ja=Ja+-1|0}while((Ja|0)!=0)}Ja=b[G>>0]|0;ya=Ja<<24>>24<0;Ka=A3(ya?f[H>>2]|0:Ja&255,ya?f[j>>2]|0:j,0)|0;ya=f[k>>2]|0;N3(l,ya,(f[I>>2]|0)-ya|0);ya=b[G>>0]|0;Ja=ya<<24>>24<0;Aa=Ja?f[j>>2]|0:j;Q3(l,Aa,Aa+(Ja?f[H>>2]|0:ya&255)|0)|0;P3(l)|0;O3(l);ya=$8((b[E>>0]|0)<0?f[i>>2]|0:i,0)|0;if((Ka|0)%(ya|0)|0|0){P=67;break}f[wa>>2]=0;N8(a,5,wa);f4(f[k>>2]|0,(Ka|0)/(ya|0)|0,(b[E>>0]|0)<0?f[i>>2]|0:i,f[wa+8>>2]|0);ya=f[((f[A>>2]|0)==0?h:K)>>2]|0;Ka=f[k>>2]|0;if(Ka|0){if((f[I>>2]|0)!=(Ka|0))f[I>>2]=Ka;YDc(Ka)}if((b[G>>0]|0)<0)YDc(f[j>>2]|0);if((b[E>>0]|0)<0)YDc(f[i>>2]|0);Ra=ya}else Ra=Ea;Sa=X7(a,Ra,0)|0}else Sa=Z7(a,da,wa,ta)|0;if(!va)f[wa>>2]=f[wa>>2]|64;if(N)Ta=(f[wa>>2]&7)>>>0<5;else Ta=0;f[wa+4>>2]=ua;ya=Y7(a,Sa,o,q,r)|0;if((f[r>>2]|0)==2?(f[o>>2]|0)==(la|0):0){Ua=1;Va=Ta;Wa=1;Xa=ya}else{P=83;break}}else{Ua=0;Va=N;Wa=S;Xa=T}if(Ua){pa=Va;qa=Wa;ra=Xa}else{na=Xa;oa=Va;P=145;break}}M=ra;c=qa;N=pa}switch(P|0){case 9:{M8(a,243722,243739,243549,237);break}case 10:{M8(a,243722,243775,243549,239);break}case 11:{f[h>>2]=0;f[h+4>>2]=0;Ha=tT(h,30)|0;Ya=243804;Ia=Ha+30|0;do{b[Ha>>0]=b[Ya>>0]|0;Ha=Ha+1|0;Ya=Ya+1|0}while((Ha|0)<(Ia|0));_7(-215,h,243722,241);break}case 24:{M8(a,243722,va?243835:246492,243549,275);break}case 29:{f[h>>2]=0;f[h+4>>2]=0;va=tT(h,4)|0;b[va>>0]=101;b[va+1>>0]=108;b[va+2>>0]=101;b[va+3>>0]=109;_7(-215,h,243722,281);break}case 37:{M8(a,243866,247510,243549,115);break}case 41:{M8(a,243898,247551,243549,134);break}case 44:{M8(a,243898,247578,243549,139);break}case 56:{M8(a,243866,247510,243549,115);break}case 60:{M8(a,243898,247608,243549,155);break}case 63:{mCc(k);break}case 67:{M8(a,243898,243916,243549,173);break}case 83:{M8(a,243722,243951,243549,296);break}case 86:{M8(a,243722,243974,243549,302);break}case 102:{M8(a,243722,247662,243549,339);break}case 105:{f[h>>2]=0;f[h+4>>2]=0;Ha=tT(h,98)|0;Ya=247728;Ia=Ha+98|0;do{b[Ha>>0]=b[Ya>>0]|0;Ha=Ha+1|0;Ya=Ya+1|0}while((Ha|0)<(Ia|0));_7(-215,h,243722,342);break}case 109:{f[i>>2]=0;f[i+4>>2]=0;Ha=tT(i,98)|0;Ya=247728;Ia=Ha+98|0;do{b[Ha>>0]=b[Ya>>0]|0;Ha=Ha+1|0;Ya=Ya+1|0}while((Ha|0)<(Ia|0));_7(-215,i,243722,358);break}case 113:{M8(a,243722,244013,243549,364);break}case 119:{M8(a,243722,244066,243549,371);break}case 121:{M8(a,243722,244088,243549,376);break}case 125:{M8(a,243722,244139,243549,392);break}case 130:{M8(a,243722,244175,243549,401);break}case 139:{f[i>>2]=0;f[i+4>>2]=0;Ha=tT(i,98)|0;Ya=247728;Ia=Ha+98|0;do{b[Ha>>0]=b[Ya>>0]|0;Ha=Ha+1|0;Ya=Ya+1|0}while((Ha|0)<(Ia|0));_7(-215,i,243722,420);break}case 141:{M8(a,243722,247845,243549,425);break}case 145:{i=f[d>>2]|0;Ya=i&7;if(!Ya)if(v>>>0>4)P=148;else Za=i;else if(v>>>0>4&(Ya>>>0<5&(Ya|0)!=(v|0)))P=148;else Za=i;if((P|0)==148){N8(a,(v|0)==6?6:5,d);Za=f[d>>2]|0}P=Za&7;if(!((v|0)==0|(v|0)==(P|0)))M8(a,243722,244239,243549,447);if(P>>>0<5|oa^1){_a=Za|t;f[d>>2]=_a;u=g;return na|0}oa=f[z>>2]|0;f[oa>>2]=f[oa>>2]|256;_a=Za|t;f[d>>2]=_a;u=g;return na|0}}return 0}function _7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,243549,d);return}function $7(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=c;h=e;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[a+8>>2]&2147483647)+-1|0}else{l=j&255;m=10}n=d-g|0;if(!n){u=e;return a|0}if(k){k=f[a>>2]|0;o=k;p=f[a+4>>2]|0;q=k}else{o=a;p=j&255;q=a}if(q>>>0<=c>>>0&(o+p|0)>>>0>c>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(n>>>0>4294967279)dEc(h);if(n>>>0<11){b[h+11>>0]=n;r=h}else{p=n+16&-16;o=VDc(p)|0;f[h>>2]=o;f[h+8>>2]=p|-2147483648;f[h+4>>2]=n;r=o}if((c|0)==(d|0))s=r;else{o=r;p=c;while(1){b[o>>0]=b[p>>0]|0;p=p+1|0;if((p|0)==(d|0))break;else o=o+1|0}s=r+n|0}b[s>>0]=0;s=h+11|0;r=b[s>>0]|0;o=r<<24>>24<0;tEc(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:r&255)|0;if((b[s>>0]|0)<0)YDc(f[h>>2]|0);u=e;return a|0}if((m-l|0)>>>0<n>>>0){qEc(a,m,l+n-m|0,l,l,0,0);t=b[i>>0]|0}else t=j;if(t<<24>>24<0)v=f[a>>2]|0;else v=a;t=v+l|0;if((c|0)==(d|0))w=t;else{j=d+(l-g)|0;g=c;c=t;while(1){b[c>>0]=b[g>>0]|0;g=g+1|0;if((g|0)==(d|0))break;else c=c+1|0}w=v+j|0}b[w>>0]=0;w=l+n|0;if((b[i>>0]|0)<0){f[a+4>>2]=w;u=e;return a|0}else{b[i>>0]=w;u=e;return a|0}return 0}function a8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+80|0;h=g+48|0;i=g+8|0;j=g;k=d&15|32;if((d&7)>>>0<=4){f[j>>2]=0;f[j+4>>2]=0;l=tT(j,66)|0;m=244694;n=l+66|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));_7(-5,j,244761,762)}if((e|0)!=0?(b[e>>0]|0)!=0:0){f[i>>2]=245870;f[i+4>>2]=e;o=2}else o=0;f[i+(o<<2)>>2]=0;b8(a,c,1,i,0);i=a+44|0;f[h+20>>2]=f[i>>2]&-33;o=a+40|0;f[h+16>>2]=f[o>>2];e=a+48|0;m=e;l=f[m+4>>2]|0;n=h+8|0;f[n>>2]=f[m>>2];f[n+4>>2]=l;l=a+24|0;h7(f[l>>2]|0,h);A7(f[a+36>>2]|0,h)|0;f[o>>2]=(f[o>>2]|0)+2;if(!(d&8))P8(a)|0;f[i>>2]=k;if(!c){f[a+52>>2]=0;f[e>>2]=0;u=g;return}else{l7(j,f[l>>2]|0,c,-1);c=j;j=f[c+4>>2]|0;l=e;f[l>>2]=f[c>>2];f[l+4>>2]=j;u=g;return}}function b8(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;i=e;j=g;g=h;k=a+72|0;l=f[k>>2]|0;m=a+44|0;n=f[m>>2]|0;if(!c)o=0;else o=(b[c>>0]|0)==0?0:c;c=(d|0)==3;if((d|2|0)==3){p=n&7;if(p>>>0>4)if((p|0)==6^(o|0)!=0){f[g>>2]=0;f[g+4>>2]=0;q=tT(g,85)|0;r=248279;s=q+85|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));_7(-5,g,244784,682)}else t=n;else{f[a+12>>2]=0;t=o|0?38:37}if(!(t&32)){v=P8(a)|0;w=t}else{v=l;w=t}}else{v=l;w=n}if(o)if((b[o>>0]|0)==95?(b[o+1>>0]|0)==0:0){f[g>>2]=0;f[g+4>>2]=0;q=tT(g,33)|0;r=244799;s=q+33|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));_7(-5,g,244784,697)}else x=o;else x=244833;o=Mpc(x)|0;n=v+1|0;b[v>>0]=60;do if((d|0)==2)if(!e){b[n>>0]=47;y=v+2|0;break}else{f[g>>2]=0;f[g+4>>2]=0;q=tT(g,45)|0;r=244835;s=q+45|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));_7(-5,g,244784,704)}else y=n;while(0);n=b[x>>0]|0;if(!(((n&-33)+-65&255)<26|n<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;q=tT(g,35)|0;r=244881;s=q+35|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));_7(-5,g,244784,709)}n=O8(a,y,o)|0;a:do if((o|0)>0){y=0;b:while(1){v=b[x+y>>0]|0;if(!((v+-48&255)<10|((v&-33)+-65&255)<26))switch(v<<24>>24){case 45:case 95:break;default:break b}b[n+y>>0]=v;y=y+1|0;if((y|0)>=(o|0))break a}f[g>>2]=0;f[g+4>>2]=0;q=tT(g,74)|0;r=244917;s=q+74|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));_7(-5,g,244784,716)}while(0);g=n+o|0;o=i;i=j;while(1){if((o|0)!=0?(j=o,n=f[j>>2]|0,(n|0)!=0):0){r=j;j=g;q=n;while(1){n=Mpc(q)|0;s=r+4|0;x=Mpc(f[s>>2]|0)|0;y=O8(a,j,n+4+x|0)|0;v=y+1|0;b[y>>0]=32;dJc(v|0,f[r>>2]|0,n|0)|0;y=v+n|0;n=y+1|0;b[y>>0]=61;y=n+1|0;b[n>>0]=34;dJc(y|0,f[s>>2]|0,x|0)|0;s=y+x|0;x=s+1|0;b[s>>0]=34;r=r+8|0;q=f[r>>2]|0;if(!q){z=x;break}else j=x}}else z=g;if(!i)break;g=z;o=f[i>>2]|0;i=f[i+4>>2]|0}if(!c){A=z;B=A+1|0;b[A>>0]=62;f[k>>2]=B;C=w&-33;f[m>>2]=C;u=h;return}b[z>>0]=47;A=z+1|0;B=A+1|0;b[A>>0]=62;f[k>>2]=B;C=w&-33;f[m>>2]=C;u=h;return}function c8(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c+8|0;e=c;g=a+36|0;if(!(f[(f[g>>2]|0)+24>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,20)|0;i=244992;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));_7(-2,e,245013,804)}else{b8(a,f[a+52>>2]|0,2,0,0);B7(f[g>>2]|0,d);f[a+40>>2]=f[d+16>>2];f[a+44>>2]=f[d+20>>2];g=d+8|0;e=f[g+4>>2]|0;i=a+48|0;f[i>>2]=f[g>>2];f[i+4>>2]=e;i7(f[a+24>>2]|0,d);u=c;return}}function d8(a){a=a|0;var b=0;if(f[a+12>>2]|0)return;b=a+36|0;if((f[(f[b>>2]|0)+24>>2]|0)>0)do c8(a);while((f[(f[b>>2]|0)+24>>2]|0)>0);f[a+40>>2]=0;P8(a)|0;D8(a,245034);f[a+72>>2]=f[a+76>>2];return}function e8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;h=g;V8(a,0);switch(f[a+280>>2]|0){case 0:{U8(a,1);break}case 2:{f[h>>2]=0;f[h+4>>2]=0;i=tT(h,38)|0;j=245057;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));_7(-2,h,245096,845);break}default:{}}l=a+44|0;m=f[l>>2]&7;if((m|0)!=6?(n=(c|0)!=0,!(n&m>>>0<5)):0){m=a+72|0;o=f[m>>2]|0;p=f[a+76>>2]|0;q=o-p+e|0;if(n){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,49)|0;j=245114;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));_7(-5,h,245096,863)}f[l>>2]=5;if((q|0)>(f[a+84>>2]|0)?(q-(f[a+40>>2]|0)|0)>10:0)r=13;else r=11;do if((r|0)==11){if(o>>>0>p>>>0?(b[o+-1>>0]|0)==62:0){r=13;break}if(o>>>0>(p+(f[a+40>>2]|0)|0)>>>0?(b[o+-1>>0]|0)!=62:0){b[o>>0]=32;s=o+1|0}else s=o}while(0);if((r|0)==13)s=P8(a)|0;dJc(s|0,d|0,e|0)|0;f[m>>2]=s+e;u=g;return}b8(a,c,1,0,0);s=a+72|0;m=O8(a,f[s>>2]|0,e)|0;dJc(m|0,d|0,e|0)|0;f[s>>2]=m+e;b8(a,c,2,0,0);u=g;return}function f8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+128|0;e=C8(c,d,10)|0;e8(a,b,e,Mpc(e)|0);u=d;return}function g8(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+128|0;e=d;e8(a,b,e,Mpc(R8(e,c)|0)|0);u=d;return}function h8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+24608|0;h=g;i=g+16|0;j=g+8|0;if(!d){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,19)|0;l=248712;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));_7(-27,j,245164,904)}n=Mpc(d)|0;if((n|0)>4096){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,30)|0;l=248750;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));_7(-5,j,245164,908)}j=(e|0)!=0|(n|0)==0;if((!j?(b[d>>0]|0)==34:0)?(b[d+(n+-1)>>0]|0)==34:0){o=n;p=d;e8(a,c,p,o);u=g;return}e=j&1;j=i+1|0;b[i>>0]=34;if((n|0)>0){l=e;k=0;m=j;while(1){q=b[d+k>>0]|0;r=q&255;a:do if(q<<24>>24<0|q<<24>>24==32){b[m>>0]=q;s=m;t=1}else{b:do if((q&255)>=32){switch(q<<24>>24){case 34:case 38:case 39:case 60:case 62:{break b;break}default:{}}b[m>>0]=q;s=m;t=l;break a}while(0);v=m+1|0;b[m>>0]=38;switch(q<<24>>24){case 60:{b[v>>0]=108;b[v+1>>0]=116;w=3;break}case 62:{b[v>>0]=103;b[v+1>>0]=116;w=3;break}case 38:{b[v>>0]=b[244225]|0;b[v+1>>0]=b[244226]|0;b[v+2>>0]=b[244227]|0;w=4;break}case 39:{b[v>>0]=97;b[v+1>>0]=112;b[v+2>>0]=111;b[v+3>>0]=115;w=5;break}case 34:{b[v>>0]=113;b[v+1>>0]=117;b[v+2>>0]=111;b[v+3>>0]=116;w=5;break}default:{f[h>>2]=r;Aqc(v,245182,h)|0;w=5}}v=m+w|0;b[v>>0]=59;s=v;t=1}while(0);r=s+1|0;k=k+1|0;if((k|0)==(n|0)){x=r;y=t;break}else{l=t;m=r}}}else{x=j;y=e}if(!y){e=b[d>>0]|0;if((e+-48&255)<10){z=1;A=26}else switch(e<<24>>24){case 46:case 45:case 43:{z=1;A=26;break}default:{B=x;C=1}}}else{z=y;A=26}if((A|0)==26){b[x>>0]=34;B=x+1|0;C=(z|0)==0}b[B>>0]=0;o=(C<<31>>31)-i+B|0;p=i+(C&1)|0;e8(a,c,p,o);u=g;return}function i8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=e+8|0;if(!c){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,12)|0;j=248787;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));_7(-27,h,245189,986)}if(Erc(c,517977)|0){f[h>>2]=0;f[h+4>>2]=0;i=tT(h,49)|0;j=245208;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));_7(-5,h,245189,989)}h=Mpc(c)|0;j=Wpc(c,10)|0;i=(j|0)!=0;k=a+72|0;l=f[k>>2]|0;if((d|0)!=0&(i^1)?((f[a+80>>2]|0)-l|0)>=(h+5|0):0)if(l>>>0>((f[a+76>>2]|0)+(f[a+40>>2]|0)|0)>>>0){b[l>>0]=32;m=l+1|0}else m=l;else m=P8(a)|0;if(!i){i=O8(a,m,h+9|0)|0;f[g>>2]=c;Aqc(i,245263,g)|0;g=i+(Mpc(i)|0)|0;f[k>>2]=g;P8(a)|0;u=e;return};b[m>>0]=b[245258]|0;b[m+1>>0]=b[245259]|0;b[m+2>>0]=b[245260]|0;b[m+3>>0]=b[245261]|0;b[m+4>>0]=b[245262]|0;f[k>>2]=m+4;m=j;j=c;c=P8(a)|0;while(1){if(!m)break;g=m-j|0;i=g+1|0;h=O8(a,c,i)|0;dJc(h|0,j|0,i|0)|0;i=m+1|0;l=Wpc(i,10)|0;f[k>>2]=h+g;m=l;j=i;c=P8(a)|0}m=Mpc(j)|0;i=O8(a,c,m)|0;dJc(i|0,j|0,m|0)|0;f[k>>2]=i+m;m=P8(a)|0;b[m>>0]=45;b[m+1>>0]=45;b[m+2>>0]=62;b[m+3>>0]=0;f[k>>2]=m+3;P8(a)|0;u=e;return}function j8(a){a=a|0;var c=0,d=0;c=k8(a,f[a+76>>2]|0)|0;if(!c)return;d=a+92|0;if(f[d>>2]|0)return;switch(b[c>>0]|0){case 123:{l8(a,c,A7(f[a+32>>2]|0,0)|0)|0;break}case 91:{m8(a,c,A7(f[a+32>>2]|0,0)|0)|0;break}default:M8(a,245275,245288,245323,587)}if(!(f[d>>2]|0))return;else M8(a,245275,245398,245323,591)}function k8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=a+76|0;e=a+80|0;g=c;a:while(1){h=g;b:while(1){i=b[h>>0]|0;switch(i<<24>>24|0){case 13:case 10:case 0:{j=22;break b;break}case 47:{c=h+1|0;k=b[c>>0]|0;if(!(k<<24>>24)){l=f[d>>2]|0;m=H8(a,l,(f[e>>2]|0)-l|0)|0;if(!m){n=1;o=0;break b}p=m;q=b[m>>0]|0}else{p=c;q=k}switch(q<<24>>24){case 47:{r=p;s=47;j=8;break b;break}case 42:break;default:{j=20;break a}}k=p+1|0;while(1){c=b[k>>0]|0;if(!(c<<24>>24)){m=f[d>>2]|0;l=H8(a,m,(f[e>>2]|0)-m|0)|0;if(!l){n=1;o=0;break b}else{k=l;continue}}l=k+1|0;if(c<<24>>24!=42){k=l;continue}c=b[l>>0]|0;if(!(c<<24>>24)){m=f[d>>2]|0;t=H8(a,m,(f[e>>2]|0)-m|0)|0;if(!t){n=1;o=0;break b}u=t;v=b[t>>0]|0}else{u=l;v=c}if(v<<24>>24==47){w=u;break}else k=u}break}case 32:case 9:{w=h;break}default:{j=24;break a}}h=w+1|0}c:do if((j|0)==8)while(1){j=0;switch(s<<24>>24){case 13:case 10:{n=0;o=r;break c;break}case 0:{k=f[d>>2]|0;c=H8(a,k,(f[e>>2]|0)-k|0)|0;if(!c){n=1;o=0;break c}else x=c;break}default:x=r+1|0}r=x;s=b[x>>0]|0;j=8}else if((j|0)==22){j=0;c=f[d>>2]|0;k=H8(a,c,(f[e>>2]|0)-c|0)|0;n=(k|0)==0;o=k}while(0);if(n){j=26;break}else g=o}if((j|0)==20)M8(a,245949,245967,245323,79);else if((j|0)==24)if((i&255)>31){y=h;return y|0}else M8(a,245949,245998,245323,97);else if((j|0)==26){j=f[d>>2]|0;b[j>>0]=0;f[a+92>>2]=1;y=j;return y|0}return 0}function l8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;if(!c)M8(a,245734,245437,245323,490);if((b[c>>0]|0)!=123)M8(a,245734,245750,245323,493);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;N8(a,6,d);h=a+92|0;i=g+8+4|0;j=d+4|0;k=c;a:while(1){c=k8(a,k+1|0)|0;if(!c){l=43;break}if(f[h>>2]|0){m=c;l=44;break}do if((b[c>>0]|0)==34){n=c+1|0;o=c;while(1){p=o+1|0;q=b[p>>0]|0;if(!(q<<24>>24)){l=11;break a}r=q<<24>>24!=34;if((q&255)<32|r^1)break;else o=p}if(r){l=15;break a}q=k8(a,o+2|0)|0;if(!q){l=43;break a}if(f[h>>2]|0){l=43;break a}if((b[q>>0]|0)!=58){l=19;break a}if(o>>>0<=c>>>0){l=21;break a}s=p-n|0;if((s|0)==7?(Arc(n,245870,7)|0)==0:0){t=q+1|0;v=0}else{w=o1(a,d,n1(a,n,s,1)|0,1)|0;s=q+1|0;if(!(f[h>>2]|0)){t=s;v=w}else{m=s;l=44;break a}}s=k8(a,t)|0;if(!s){l=43;break a}if(f[h>>2]|0){m=s;l=44;break a}if(!v){w=n8(a,s,g)|0;if((f[g>>2]&7|0)!=3){l=32;break a}q=C1(f[i>>2]|0)|0;f[j>>2]=q;if(q|0)f[d>>2]=f[d>>2]|16;x=w;break}switch(b[s>>0]|0){case 91:{y=m8(a,s,v)|0;break}case 123:{y=l8(a,s,v)|0;break}default:y=n8(a,s,v)|0}f[v>>2]=f[v>>2]|64;x=y}else x=c;while(0);c=k8(a,x)|0;if(!c){l=43;break}if(f[h>>2]|0){m=c;l=44;break}switch(b[c>>0]|0){case 44:{k=c;break}case 125:{m=c;l=44;break a;break}default:{l=42;break a}}}if((l|0)==11)if((p|0)==((f[a+80>>2]|0)+-1|0)){f[g>>2]=0;f[g+4>>2]=0;p=tT(g,98)|0;k=247728;h=p+98|0;do{b[p>>0]=b[k>>0]|0;p=p+1|0;k=k+1|0}while((p|0)<(h|0));o8(-215,g,245785,129)}else M8(a,245785,245801,245323,133);else if((l|0)==15)M8(a,245785,245801,245323,133);else if((l|0)==19)M8(a,245785,245823,245323,142);else if((l|0)==21)M8(a,245785,245857,245323,146);else if((l|0)==32)M8(a,245734,245878,245323,529);else if((l|0)==42)M8(a,245734,245484,245323,553);else if((l|0)==43)M8(a,245734,245437,245323,557);else if((l|0)==44)if((b[m>>0]|0)==125){u=e;return m+1|0}else M8(a,245734,245913,245323,560);return 0}function m8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;if(!c)M8(a,245421,245437,245323,436);if((b[c>>0]|0)!=91)M8(a,245421,245449,245323,439);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;N8(a,5,d);e=a+92|0;g=d+8|0;d=c;a:while(1){c=k8(a,d+1|0)|0;if(!c){h=17;break}if(f[e>>2]|0){i=c;h=18;break}b:do if((b[c>>0]|0)==93)j=c;else{k=A7(f[g>>2]|0,0)|0;switch(b[c>>0]|0){case 91:{j=m8(a,c,k)|0;break b;break}case 123:{j=l8(a,c,k)|0;break b;break}default:{j=n8(a,c,k)|0;break b}}}while(0);c=k8(a,j)|0;if(!c){h=17;break}if(f[e>>2]|0){i=c;h=18;break}switch(b[c>>0]|0){case 44:{d=c;break}case 93:{i=c;h=18;break a;break}default:{h=16;break a}}}if((h|0)==16)M8(a,245421,245484,245323,473);else if((h|0)==17)M8(a,245421,245437,245323,477);else if((h|0)==18)if((b[i>>0]|0)==93)return i+1|0;else M8(a,245421,245505,245323,480);return 0}function n8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;e=u;u=u+96|0;g=e+68|0;h=e+72|0;i=e;j=e+56|0;k=e+12|0;l=k8(a,c)|0;f[g>>2]=l;if(!l)M8(a,245541,245398,245323,166);if(f[a+92>>2]|0)M8(a,245541,245398,245323,166);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;c=b[l>>0]|0;if(c<<24>>24!=34){a:do if((c+-48&255)<10)switch(c<<24>>24){case 45:case 43:{m=83;break}default:{n=c;o=l;m=81}}else{switch(c<<24>>24){case 45:case 43:{m=83;break a;break}case 46:{n=c;o=l;m=81;break a;break}default:{}}if(((c&-33)+-65&255)>=26)M8(a,245541,245715,245323,423);q=a+80|0;r=0;t=l;do{r=r+1|0;t=t+1|0;f[g>>2]=t;v=b[t>>0]|0;if(!(v<<24>>24)){m=101;break}}while(r>>>0<7&((v&-33)+-65&255)<26);if((m|0)==101?(t|0)==((f[q>>2]|0)+-1|0):0){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,98)|0;x=247728;y=w+98|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));o8(-215,h,245541,404)}if(r>>>0<=3)M8(a,245541,245715,245323,423);if(!(Arc(l,245665,4)|0))M8(a,245541,245670,245323,409);if(Arc(l,519053,4)|0){if(r>>>0<=4)M8(a,245541,245715,245323,423);if(!(Arc(l,519047,5)|0))z=0;else M8(a,245541,245715,245323,423)}else z=1;f[d+8>>2]=z;f[d>>2]=1;A=f[g>>2]|0;u=e;return A|0}while(0);if((m|0)==83){z=l+1|0;f[g>>2]=z;c=b[z>>0]|0;if(!(c<<24>>24))if((z|0)==((f[a+80>>2]|0)+-1|0)){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,98)|0;x=247728;y=w+98|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));o8(-215,h,245541,373)}else m=94;else{n=c;o=z;m=81}}b:do if((m|0)==81){c:do if((n+-48&255)<10){z=a+80|0;c=o;while(1){c=c+1|0;f[g>>2]=c;q=b[c>>0]|0;if(!(q<<24>>24))break;if((q+-48&255)>=10){B=q;break c}}if((c|0)!=((f[z>>2]|0)+-1|0)){m=94;break b}f[h>>2]=0;f[h+4>>2]=0;w=tT(h,98)|0;x=247728;y=w+98|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));o8(-215,h,245541,378)}else B=n;while(0);switch(B<<24>>24){case 101:case 46:break;default:{m=94;break b}}C=+T8(a,l,g);p[d+8>>3]=C;r=f[g>>2]|0;if((b[r>>0]|0)==0?(r|0)==((f[a+80>>2]|0)+-1|0):0){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,98)|0;x=247728;y=w+98|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));o8(-215,h,245541,383)}else{D=2;E=r}}while(0);if((m|0)==94){B=yrc(l,g,0)|0;f[d+8>>2]=B;B=f[g>>2]|0;if((b[B>>0]|0)==0?(B|0)==((f[a+80>>2]|0)+-1|0):0){f[h>>2]=0;f[h+4>>2]=0;w=tT(h,98)|0;x=247728;y=w+98|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));o8(-215,h,245541,389)}else{D=1;E=B}}f[d>>2]=D;if(l>>>0<E>>>0){A=f[g>>2]|0;u=e;return A|0}else M8(a,245541,247662,245323,394)}E=l+1|0;D=0;B=E;while(1){f[g>>2]=B;x=b[B>>0]|0;if((x+-48&255)<10|((x&-33)+-65&255)<26){if(D>>>0>=10){m=11;break}}else if(!(D>>>0<10&x<<24>>24==36)){m=10;break}D=D+1|0;B=B+1|0}if((m|0)==10?D>>>0>7:0)m=11;if((m|0)==11?(Arc(E,245559,8)|0)==0:0){D=l+9|0;f[g>>2]=D;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;mEc(h,131072);l=a+76|0;B=a+80|0;x=D;D=f[g>>2]|0;d:while(1){F=D;e:while(1){switch(b[F>>0]|0){case 34:{m=17;break d;break}case 13:case 10:{m=18;break d;break}case 0:{break e;break}default:{}}w=F+1|0;f[g>>2]=w;F=w}$7(h,x,F)|0;r=f[l>>2]|0;w=H8(a,r,(f[B>>2]|0)-r|0)|0;f[g>>2]=w;if(!w){m=16;break}else{x=w;D=w}}if((m|0)==16)M8(a,245541,245568,245323,196);else if((m|0)==17){$7(h,x,F)|0;F=f[g>>2]|0;if((b[F>>0]|0)!=34)M8(a,245541,245568,245323,223);f[g>>2]=F+1;F=h+11|0;x=b[F>>0]|0;D=x<<24>>24<0;B=h+4|0;l=f[B>>2]|0;w=x&255;x=D?l:w;do if(x>>>0>31){r=D?f[h>>2]|0:h;y=r+(D?l:w)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;n=j+4|0;f[n>>2]=0;f[j+8>>2]=0;o=VDc(25)|0;f[j>>2]=o;f[j+8>>2]=o+25;b[o>>0]=32;b[o+1>>0]=32;b[o+2>>0]=32;b[o+3>>0]=32;b[o+4>>0]=32;b[o+5>>0]=32;b[o+6>>0]=32;b[o+7>>0]=32;b[o+8>>0]=32;b[o+9>>0]=32;b[o+10>>0]=32;b[o+11>>0]=32;b[o+12>>0]=32;b[o+13>>0]=32;b[o+14>>0]=32;b[o+15>>0]=32;b[o+16>>0]=32;b[o+17>>0]=32;b[o+18>>0]=32;b[o+19>>0]=32;b[o+20>>0]=32;b[o+21>>0]=32;b[o+22>>0]=32;b[o+23>>0]=32;b[o+24>>0]=32;f[n>>2]=o+25;x3(r,f[j>>2]|0,0,32)|0;if(!(H3(j,i)|0))M8(a,245541,247578,245323,238);r=i+11|0;o=b[r>>0]|0;if(!((o<<24>>24<0?f[i+4>>2]|0:o&255)|0))M8(a,245541,247578,245323,238);o=f[j>>2]|0;if(o|0){if((f[n>>2]|0)!=(o|0))f[n>>2]=o;YDc(o)}o=b[F>>0]|0;if((o<<24>>24<0?f[B>>2]|0:o&255)>>>0>32){o=sEc(h,32)|0;n=y-o|0;if(!(y3(o,0,n)|0))M8(a,245541,247608,245323,247);z=z3(n,1)|0;f[j>>2]=0;c=j+4|0;f[c>>2]=0;f[j+8>>2]=0;if(z|0){if((z|0)<0)mCc(j);q=VDc(z)|0;f[c>>2]=q;f[j>>2]=q;f[j+8>>2]=q+z;t=z;z=q;do{b[z>>0]=0;z=(f[c>>2]|0)+1|0;f[c>>2]=z;t=t+-1|0}while((t|0)!=0)}t=A3(n,o,0)|0;z=f[j>>2]|0;N3(k,z,(f[c>>2]|0)-z|0);Q3(k,o,y)|0;P3(k)|0;O3(k);z=$8((b[r>>0]|0)<0?f[i>>2]|0:i,0)|0;if((t|0)%(z|0)|0|0)M8(a,245541,247629,245323,265);N8(a,13,d);f4(f[j>>2]|0,(t|0)/(z|0)|0,(b[r>>0]|0)<0?f[i>>2]|0:i,f[d+8>>2]|0);z=f[j>>2]|0;if(z|0){if((f[c>>2]|0)!=(z|0))f[c>>2]=z;YDc(z)}}else N8(a,13,d);if((b[r>>0]|0)<0)YDc(f[i>>2]|0)}else if(!x){N8(a,13,d);break}else M8(a,245541,247551,245323,285);while(0);if((b[F>>0]|0)<0)YDc(f[h>>2]|0);A=f[g>>2]|0;u=e;return A|0}else if((m|0)==18)M8(a,245541,245568,245323,211)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;mEc(h,131072);f[g>>2]=E;F=a+76|0;x=a+80|0;j=E;f:while(1){G=j;g:while(1){switch(b[G>>0]|0){case 34:{m=69;break f;break}case 13:case 10:{m=70;break f;break}case 92:{break g;break}case 0:{m=67;break g;break}default:{}}E=G+1|0;f[g>>2]=E;G=E}if((m|0)==67){m=0;$7(h,j,G)|0;r=f[F>>2]|0;c=H8(a,r,(f[x>>2]|0)-r|0)|0;f[g>>2]=c;if(!c){m=68;break}else{j=c;continue}}$7(h,j,G)|0;c=(f[g>>2]|0)+1|0;f[g>>2]=c;r=b[c>>0]|0;switch(r<<24>>24|0){case 117:{m=64;break f;break}case 39:case 34:case 92:{pEc(h,1,r)|0;break}case 110:{pEc(h,1,10)|0;break}case 114:{pEc(h,1,13)|0;break}case 116:{pEc(h,1,9)|0;break}case 98:{pEc(h,1,8)|0;break}case 102:{pEc(h,1,12)|0;break}default:{m=65;break f}}r=(f[g>>2]|0)+1|0;f[g>>2]=r;j=r}if((m|0)==64)M8(a,245541,245607,245323,313);else if((m|0)==65)M8(a,245541,245640,245323,314);else if((m|0)==68)M8(a,245541,245568,245323,327);else if((m|0)==69){$7(h,j,G)|0;G=f[g>>2]|0;if((b[G>>0]|0)!=34)M8(a,245541,245568,245323,354);f[g>>2]=G+1;G=h+11|0;j=b[G>>0]|0;x=j<<24>>24<0;l7(i,f[a+16>>2]|0,x?f[h>>2]|0:h,x?f[h+4>>2]|0:j&255);j=d+8|0;p[s>>3]=+p[i>>3];f[j>>2]=f[s>>2];f[j+4>>2]=f[s+4>>2];f[d>>2]=3;if((b[G>>0]|0)<0)YDc(f[h>>2]|0);A=f[g>>2]|0;u=e;return A|0}else if((m|0)==70)M8(a,245541,245568,245323,342);return 0}function o8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,245323,d);return}function p8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;V8(a,0);switch(f[a+280>>2]|0){case 0:{U8(a,1);break}case 2:{f[g>>2]=0;f[g+4>>2]=0;h=tT(g,36)|0;i=248230;j=h+36|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));o8(-2,g,246030,610);break}default:{}}if((c|0)!=0?(b[c>>0]|0)!=0:0){k=Mpc(c)|0;if(!k){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,19)|0;i=248365;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));o8(-5,g,246030,622)}if((k|0)>4096){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,19)|0;i=248385;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));o8(-5,g,246030,624)}else{l=k;m=c;n=1}}else{l=0;m=0;n=0}c=(d|0)!=0;if(c)o=Mpc(d)|0;else o=0;k=a+44|0;p=f[k>>2]|0;q=p&7;if(q>>>0>4)if(n^(q|0)==6){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,85)|0;i=248279;j=h+85|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));o8(-5,g,246030,636)}else r=p;else{f[a+12>>2]=0;r=n?38:37}p=(r&32|0)!=0;do if(!(r&8)){if(!p){q=a+72|0;s=f[q>>2]|0;b[s>>0]=44;b[s+1>>0]=10;b[s+2>>0]=0;s=a+76|0;D8(a,f[s>>2]|0);f[q>>2]=f[s>>2]}t=P8(a)|0}else{s=a+72|0;q=f[s>>2]|0;if(p)v=q;else{b[q>>0]=44;v=q+1|0}q=o+l-(f[a+76>>2]|0)+v|0;if((q|0)>(f[a+84>>2]|0)?(q-(f[a+40>>2]|0)|0)>10:0){f[s>>2]=v;t=P8(a)|0;break}b[v>>0]=32;t=v+1|0}while(0);if(n){n=b[m>>0]|0;if(!(((n&-33)+-65&255)<26|n<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,33)|0;i=248405;j=h+33|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));o8(-5,g,246030,678)}n=O8(a,t,l)|0;v=n+1|0;b[n>>0]=34;a:do if(l|0){n=0;b:while(1){p=b[m+n>>0]|0;b[v+n>>0]=p;if(!((p+-48&255)<10|((p&-33)+-65&255)<26))switch(p<<24>>24){case 32:case 45:case 95:break;default:break b}n=n+1|0;if(n>>>0>=l>>>0)break a}f[g>>2]=0;f[g+4>>2]=0;h=tT(g,80)|0;i=248439;j=h+80|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));o8(-5,g,246030,689)}while(0);g=v+l|0;l=g+1|0;b[g>>0]=34;g=l+1|0;b[l>>0]=58;b[g>>0]=32;w=g+1|0}else w=t;if(!c){x=w;y=a+72|0;f[y>>2]=x;z=r&-33;f[k>>2]=z;u=e;return}c=O8(a,w,o)|0;dJc(c|0,d|0,o|0)|0;x=c+o|0;y=a+72|0;f[y>>2]=x;z=r&-33;f[k>>2]=z;u=e;return}function q8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+5136|0;h=g+8|0;i=g+16|0;j=g;k=d&15|32;l=d&7;if(l>>>0<=4){f[j>>2]=0;f[j+4>>2]=0;d=tT(j,68)|0;m=248520;n=d+68|0;do{b[d>>0]=b[m>>0]|0;d=d+1|0;m=m+1|0}while((d|0)<(n|0));o8(-5,j,246043,718)}if((e|0)!=0?(b[e>>0]|0)!=0:0)if(!(Arc(e,247471,6)|0)){o=0;p=e;q=3;r=i}else{s=1;t=e;v=6}else{s=0;t=0;v=6}if((v|0)==6){b[i>>0]=(l|0)==6?123:91;o=s;p=t;q=k;r=i+1|0}b[r>>0]=0;p8(a,c,i);i=a+44|0;f[h>>2]=f[i>>2];A7(f[a+36>>2]|0,h)|0;f[i>>2]=q;q=a+40|0;f[q>>2]=(f[q>>2]|0)+4;if(!o){u=g;return}ei[f[a+244>>2]&511](a,245870,p,1);u=g;return}function r8(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;e=f[a+36>>2]|0;if(!(f[e+24>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;g=tT(d,44)|0;h=248636;i=g+44|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));o8(-2,d,246067,758)}f[d>>2]=0;h=a+44|0;g=f[h>>2]|0;B7(e,d);e=a+40|0;i=(f[e>>2]|0)+-4|0;f[e>>2]=i;f[h>>2]=f[d>>2]&-33;d=g&7;if(d>>>0<=4){u=c;return}h=a+72|0;if(!(g&8)){j=f[h>>2]|0;k=a+76|0;if(j>>>0<=((f[k>>2]|0)+(f[a+56>>2]|0)|0)>>>0){f[h>>2]=j+1;b[j>>0]=10;j=f[h>>2]|0;f[h>>2]=j+1;b[j>>0]=0;D8(a,f[k>>2]|0);f[h>>2]=f[k>>2]}P8(a)|0;l=k;m=f[e>>2]|0}else{l=a+76|0;m=i}i=f[h>>2]|0;if((g&32|0)==0?i>>>0>((f[l>>2]|0)+m|0)>>>0:0){b[i>>0]=32;n=i+1|0}else n=i;b[n>>0]=(d|0)==6?125:93;f[h>>2]=n+1;u=c;return}function s8(a){a=a|0;var b=0;if(f[a+12>>2]|0)return;b=a+36|0;if((f[(f[b>>2]|0)+24>>2]|0)>0)do r8(a);while((f[(f[b>>2]|0)+24>>2]|0)>0);f[a+40>>2]=4;P8(a)|0;f[a+72>>2]=f[a+76>>2];return}function t8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=u;u=u+128|0;p8(a,b,C8(c,d,10)|0);u=d;return}function u8(a,c,d){a=a|0;c=c|0;d=+d;var e=0,f=0,g=0;e=u;u=u+128|0;f=e;g=Mpc(R8(f,d)|0)|0;if(g|0?(b[f+(g+-1)>>0]|0)==46:0){b[f+g>>0]=48;b[f+(g+1)>>0]=0}p8(a,c,f);u=e;return}function v8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16416|0;h=g+8|0;i=g;if(!d){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,19)|0;k=248712;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));o8(-27,i,246089,833)}m=Mpc(d)|0;if((m|0)>4096){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,30)|0;k=248750;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));o8(-5,i,246089,837)}a:do if(!((e|0)!=0|(m|0)==0)?(i=b[d>>0]|0,i<<24>>24==(b[d+(m+-1)>>0]|0)):0){switch(i<<24>>24){case 39:case 34:{n=d;break}default:break a}p8(a,c,n);u=g;return}while(0);e=h+1|0;b[h>>0]=34;b:do if((m|0)>0){i=0;k=e;while(1){j=b[d+i>>0]|0;switch(j<<24>>24|0){case 39:case 34:case 92:{b[k>>0]=92;b[k+1>>0]=j;o=k+2|0;break}case 10:{b[k>>0]=92;b[k+1>>0]=110;o=k+2|0;break}case 13:{b[k>>0]=92;b[k+1>>0]=114;o=k+2|0;break}case 9:{b[k>>0]=92;b[k+1>>0]=116;o=k+2|0;break}case 8:{b[k>>0]=92;b[k+1>>0]=98;o=k+2|0;break}case 12:{b[k>>0]=92;b[k+1>>0]=102;o=k+2|0;break}default:{b[k>>0]=j;o=k+1|0}}i=i+1|0;if((i|0)==(m|0)){p=o;break b}else k=o}}else p=e;while(0);b[p>>0]=34;b[p+1>>0]=0;n=h;p8(a,c,n);u=g;return}function w8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if(!c){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,12)|0;i=248787;j=h+12|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));o8(-27,g,246108,875)}g=a+72|0;i=f[g>>2]|0;h=Wpc(c,10)|0;if(((d|0)!=0&(h|0)==0?(d=Mpc(c)|0,((f[a+80>>2]|0)-i|0)>=(d|0)):0)?(i|0)!=(f[a+76>>2]|0):0){b[i>>0]=32;k=0;l=i+1|0;m=c}else{k=h;l=P8(a)|0;m=c}while(1){b[l>>0]=47;b[l+1>>0]=47;n=l+3|0;b[l+2>>0]=32;if(!k)break;c=k-m|0;h=c+1|0;i=O8(a,n,h)|0;dJc(i|0,m|0,h|0)|0;f[g>>2]=i+c;c=k+1|0;i=Wpc(c,10)|0;k=i;l=P8(a)|0;m=c}l=Mpc(m)|0;k=O8(a,n,l)|0;dJc(k|0,m|0,l|0)|0;f[g>>2]=k+l;P8(a)|0;u=e;return}function x8(a){a=a|0;return}function y8(a,b,c){a=a|0;b=b|0;c=+c;if((f[a>>2]|0)==(f[a+4>>2]|0))return;mi[f[(f[b>>2]|0)+8>>2]&2047](b,a);return}function z8(){return 1}function A8(){return 1}function B8(){return 0}function C8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;d=c+23|0;b[d>>0]=0;c=d;d=(a|0)>-1?a:0-a|0;while(1){e=d;d=(d>>>0)/10|0;f=e+48+(Y(d,-10)|0)&255;g=c+-1|0;b[g>>0]=f;if(e>>>0<=9)break;else c=g}if((a|0)>=0){h=g;return h|0}g=c+-2|0;b[g>>0]=45;h=g;return h|0}function D8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=f[a+268>>2]|0;if(!g){h=f[a+64>>2]|0;if(h|0){Lpc(c,h)|0;u=d;return}h=f[a+68>>2]|0;if(!h){f[e>>2]=0;f[e+4>>2]=0;a=tT(e,25)|0;i=246152;j=a+25|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(j|0));z5(-2,e,246178,246186,41)}Enc(h,c)|0;u=d;return}else{h=Mpc(c)|0;e=c+h|0;if(!h){u=d;return}h=g+20|0;i=g+8|0;a=g+4|0;j=g+16|0;k=c;c=f[h>>2]|0;do{l=f[a>>2]|0;m=(f[i>>2]|0)-l|0;n=f[j>>2]|0;if((((m|0)==0?0:(m<<10)+-1|0)|0)==(n+c|0)){E8(g);o=f[j>>2]|0;p=f[h>>2]|0;q=f[a>>2]|0}else{o=n;p=c;q=l}l=p+o|0;b[(f[q+(l>>>12<<2)>>2]|0)+(l&4095)>>0]=b[k>>0]|0;c=(f[h>>2]|0)+1|0;f[h>>2]=c;k=k+1|0}while((k|0)!=(e|0));u=d;return}}function E8(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;b=u;u=u+32|0;c=b;d=a+16|0;e=f[d>>2]|0;if(e>>>0>4095){f[d>>2]=e+-4096;e=a+4|0;d=f[e>>2]|0;g=f[d>>2]|0;h=d+4|0;f[e>>2]=h;d=a+8|0;i=f[d>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;m=i;do if((i|0)==(k|0)){n=f[a>>2]|0;o=n;if(h>>>0>n>>>0){p=h;q=((p-o>>2)+1|0)/-2|0;r=h+(q<<2)|0;s=m-p|0;p=s>>2;if(!p)t=h;else{fJc(r|0,h|0,s|0)|0;t=f[e>>2]|0}s=r+(p<<2)|0;f[d>>2]=s;f[e>>2]=t+(q<<2);v=s;break}s=l-o>>1;o=(s|0)==0?1:s;if(o>>>0>1073741823){s=af(8)|0;bEc(s,503977);f[s>>2]=185532;ig(s|0,23696,1627)}s=VDc(o<<2)|0;q=s;p=s+(o>>>2<<2)|0;r=p;w=s+(o<<2)|0;if((h|0)==(i|0)){x=r;y=n}else{n=p;p=r;o=h;do{f[n>>2]=f[o>>2];n=p+4|0;p=n;o=o+4|0}while((o|0)!=(i|0));x=p;y=f[a>>2]|0}f[a>>2]=q;f[e>>2]=r;f[d>>2]=x;f[j>>2]=w;if(!y)v=x;else{YDc(y);v=f[d>>2]|0}}else v=i;while(0);f[v>>2]=g;f[d>>2]=(f[d>>2]|0)+4;u=b;return}d=a+8|0;g=f[d>>2]|0;v=a+4|0;i=f[v>>2]|0;y=g-i|0;x=a+12|0;j=f[x>>2]|0;e=f[a>>2]|0;h=j-e|0;l=g;t=j;m=i;k=e;if(y>>>0>=h>>>0){o=h>>1;n=(o|0)==0?1:o;f[c+12>>2]=0;f[c+16>>2]=a+12;if(n>>>0>1073741823){o=af(8)|0;bEc(o,503977);f[o>>2]=185532;ig(o|0,23696,1627)}o=y>>2;s=VDc(n<<2)|0;f[c>>2]=s;z=s+(o<<2)|0;A=c+8|0;f[A>>2]=z;B=c+4|0;f[B>>2]=z;C=s+(n<<2)|0;D=c+12|0;f[D>>2]=C;E=s;F=VDc(4096)|0;G=C;C=z;do if((o|0)==(n|0)){if(z>>>0>s>>>0){H=z+((((C-E>>2)+1|0)/-2|0)<<2)|0;f[A>>2]=H;f[B>>2]=H;I=H;break}H=G-E>>1;J=(H|0)==0?1:H;if(J>>>0>1073741823){H=af(8)|0;bEc(H,503977);f[H>>2]=185532;ig(H|0,23696,1627)}else{H=VDc(J<<2)|0;K=H+(J>>>2<<2)|0;L=K;f[c>>2]=H;f[B>>2]=L;f[A>>2]=L;f[D>>2]=H+(J<<2);YDc(s);I=K;break}}else I=z;while(0);f[I>>2]=F;f[A>>2]=(f[A>>2]|0)+4;F=f[d>>2]|0;while(1){M=f[v>>2]|0;if((F|0)==(M|0))break;I=F+-4|0;G8(c,I);F=I}I=M;M=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=M;f[v>>2]=f[B>>2];f[B>>2]=I;B=f[d>>2]|0;f[d>>2]=f[A>>2];f[A>>2]=B;z=f[x>>2]|0;f[x>>2]=f[D>>2];f[D>>2]=z;z=B;if((z|0)!=(F|0))f[A>>2]=z+(~((z+-4-I|0)>>>2)<<2);if(M|0)YDc(M);u=b;return}if((j|0)==(g|0)){j=VDc(4096)|0;f[c>>2]=j;F8(a,c);c=f[v>>2]|0;j=f[c>>2]|0;M=c+4|0;f[v>>2]=M;c=f[d>>2]|0;I=f[x>>2]|0;z=I;A=c;do if((c|0)==(I|0)){F=f[a>>2]|0;B=F;if(M>>>0>F>>>0){D=M;s=((D-B>>2)+1|0)/-2|0;E=M+(s<<2)|0;G=A-D|0;D=G>>2;if(!D)N=M;else{fJc(E|0,M|0,G|0)|0;N=f[v>>2]|0}G=E+(D<<2)|0;f[d>>2]=G;f[v>>2]=N+(s<<2);O=G;break}G=z-B>>1;B=(G|0)==0?1:G;if(B>>>0>1073741823){G=af(8)|0;bEc(G,503977);f[G>>2]=185532;ig(G|0,23696,1627)}G=VDc(B<<2)|0;s=G;D=G+(B>>>2<<2)|0;E=D;C=G+(B<<2)|0;if((M|0)==(c|0)){P=E;Q=F}else{F=D;D=E;B=M;do{f[F>>2]=f[B>>2];F=D+4|0;D=F;B=B+4|0}while((B|0)!=(c|0));P=D;Q=f[a>>2]|0}f[a>>2]=s;f[v>>2]=E;f[d>>2]=P;f[x>>2]=C;if(!Q)O=P;else{YDc(Q);O=f[d>>2]|0}}else O=c;while(0);f[O>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}else{j=VDc(4096)|0;O=g;do if((l|0)==(t|0)){if(m>>>0>k>>>0){g=((i-e>>2)+1|0)/-2|0;c=m+(g<<2)|0;Q=y>>2;if(!Q)R=m;else{fJc(c|0,i|0,y|0)|0;R=f[v>>2]|0}P=c+(Q<<2)|0;f[d>>2]=P;f[v>>2]=R+(g<<2);S=P;break}P=h>>1;g=(P|0)==0?1:P;if(g>>>0>1073741823){P=af(8)|0;bEc(P,503977);f[P>>2]=185532;ig(P|0,23696,1627)}P=VDc(g<<2)|0;Q=P;c=P+(g>>>2<<2)|0;M=c;z=P+(g<<2)|0;if((m|0)==(l|0)){T=M;U=k}else{g=c;c=M;P=m;do{f[g>>2]=f[P>>2];g=c+4|0;c=g;P=P+4|0}while((P|0)!=(l|0));T=c;U=f[a>>2]|0}f[a>>2]=Q;f[v>>2]=M;f[d>>2]=T;f[x>>2]=z;if(!U)S=T;else{YDc(U);S=f[d>>2]|0}}else S=O;while(0);f[S>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}}function F8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{fJc(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;bEc(m,503977);f[m>>2]=185532;ig(m|0,23696,1627)}m=VDc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{YDc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function G8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{fJc(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;bEc(m,503977);f[m>>2]=185532;ig(m|0,23696,1627)}m=VDc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{YDc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function H8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e;h=f[a+256>>2]|0;if(h|0){i=a+264|0;j=f[a+260>>2]|0;k=d+-1|0;l=f[i>>2]|0;m=0;while(1){if(!((m|0)<(k|0)&l>>>0<j>>>0)){n=l;o=m;break}p=l+1|0;q=b[h+l>>0]|0;r=m+1|0;if(!(q<<24>>24)){n=p;o=m;break}b[c+m>>0]=q;if(q<<24>>24==10){n=p;o=r;break}else{l=p;m=r}}b[c+o>>0]=0;f[i>>2]=n;if((d|0)>256?!((o+1|0)<(k|0)|(f[a>>2]&64|0)!=0):0){f[g>>2]=0;f[g+4>>2]=0;s=tT(g,72)|0;t=246256;v=s+72|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,246329,246186,63)}w=(o|0)>0?c:0;u=e;return w|0}o=f[a+64>>2]|0;if(o|0){k=mqc(c,d,o)|0;if(!((d|0)>256&(k|0)!=0)){w=k;u=e;return w|0}if(f[a>>2]&64|0){w=k;u=e;return w|0}if((Bqc(k,d)|0)>>>0<(d+-1|0)>>>0){w=k;u=e;return w|0}else{f[g>>2]=0;f[g+4>>2]=0;s=tT(g,83)|0;t=246337;v=s+83|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,246329,246186,72)}}k=f[a+68>>2]|0;if(!k){f[g>>2]=0;f[g+4>>2]=0;s=tT(g,25)|0;t=246152;v=s+25|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-2,g,246329,246186,88)}o=znc(k,c,d)|0;if(!((d|0)>256&(o|0)!=0)){w=o;u=e;return w|0}if(f[a>>2]&64|0){w=o;u=e;return w|0}if((Bqc(o,d)|0)>>>0<(d+-1|0)>>>0){w=o;u=e;return w|0}else{f[g>>2]=0;f[g+4>>2]=0;s=tT(g,83)|0;t=246337;v=s+83|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));z5(-215,g,246329,246186,83)}return 0}function I8(a){a=a|0;var b=0,c=0;if(f[a+256>>2]|0){b=(f[a+264>>2]|0)>>>0>=(f[a+260>>2]|0)>>>0&1;return b|0}c=f[a+64>>2]|0;if(c|0){b=Koc(c)|0;return b|0}c=f[a+68>>2]|0;if(!c){b=0;return b|0}b=vnc(c)|0;return b|0}function J8(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+64|0;d=f[c>>2]|0;if(!d){e=a+68|0;g=f[e>>2]|0;if(!g)h=e;else{qnc(g)|0;h=e}}else{_pc(d)|0;h=a+68|0}f[c>>2]=0;f[h>>2]=0;f[a+256>>2]=0;f[a+264>>2]=0;b[a+300>>0]=0;return}function K8(a){a=a|0;var b=0,c=0;b=f[a+64>>2]|0;if(!b){c=f[a+68>>2]|0;if(c|0)tnc(c)|0}else Fqc(b);f[a+264>>2]=0;return}function L8(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;if((c|0)<72){f[i>>2]=0;f[i+4>>2]=0;j=tT(i,25)|0;k=246421;l=j+25|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-201,i,246447,246186,133)}else{i=(g|0)<1?16:g;g=G7(a,c,d,e)|0;f[g+64>>2]=i;d=i<<2;i=j7(e,d)|0;f[g+68>>2]=i;XIc(i|0,0,d|0)|0;u=h;return g|0}return 0}function M8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g;i=g+16|0;g=f[a+88>>2]|0;f[h>>2]=f[a+60>>2];f[h+4>>2]=g;f[h+8>>2]=c;F5(i,246459,h);f[h>>2]=0;f[h+4>>2]=0;if(b|0?(c=Mpc(b)|0,c|0):0)dJc(tT(h,c)|0,b|0,c|0)|0;c=f[i>>2]|0;z5(-212,h,(c|0)==0?1154740:c,d,e)}function N8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=f[a+16>>2]|0;if((b&7|0)==6){if(f[c>>2]|0)M8(a,246470,246492,246186,162);a=G7(0,72,24,d)|0;f[a+64>>2]=16;e=j7(d,64)|0;f[a+68>>2]=e;g=e;e=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(e|0));f[c+8>>2]=a;h=c;i=a;f[h>>2]=b;n7(i,8);return}else{a=m7(0,56,16,d)|0;if(f[c>>2]&7|0)A7(a,c)|0;f[c+8>>2]=a;h=c;i=a;f[h>>2]=b;n7(i,8);return}}function O8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+80|0;e=f[d>>2]|0;if((b+c|0)>>>0<e>>>0){g=b;return g|0}h=a+76|0;i=f[h>>2]|0;j=b-i|0;b=((e-i|0)*3|0)/2|0;i=j+c|0;c=(i|0)<(b|0)?b:i;i=h0(c+256|0)|0;b=a+72|0;a=f[h>>2]|0;f[b>>2]=i+((f[b>>2]|0)-a);if((j|0)>0)dJc(i|0,a|0,j|0)|0;f[h>>2]=i;f[d>>2]=i+c;g=i+j|0;return g|0}function P8(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+72|0;d=f[c>>2]|0;e=a+76|0;g=f[e>>2]|0;h=a+56|0;i=f[h>>2]|0;if(d>>>0>(g+i|0)>>>0){b[d>>0]=10;b[d+1>>0]=0;D8(a,f[e>>2]|0);d=f[e>>2]|0;f[c>>2]=d;j=f[h>>2]|0;k=d}else{j=i;k=g}g=f[a+40>>2]|0;if((j|0)==(g|0)){l=k;m=j;n=l+m|0;f[c>>2]=n;return n|0}XIc(k|0,32,g|0)|0;f[h>>2]=g;l=f[e>>2]|0;m=g;n=l+m|0;f[c>>2]=n;return n|0}function Q8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=(c|0)!=0;if(g)uT(c);if(!a){f[e>>2]=0;f[e+4>>2]=0;h=tT(e,35)|0;i=246544;j=h+35|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));z5(-27,e,246580,246186,237)}i=a+300|0;if(b[i>>0]|0){h=a+64|0;a:do if(f[a+8>>2]|0){if(((f[h>>2]|0)==0?(f[a+68>>2]|0)==0:0)?(f[a+268>>2]|0)==0:0)break;j=a+36|0;k=f[j>>2]|0;if(k|0?(f[k+24>>2]|0)>0:0)do r1(a);while((f[(f[j>>2]|0)+24>>2]|0)>0);j=a+72|0;k=f[j>>2]|0;l=a+76|0;m=f[l>>2]|0;n=a+56|0;o=f[n>>2]|0;if(k>>>0>(m+o|0)>>>0){b[k>>0]=10;b[k+1>>0]=0;D8(a,f[l>>2]|0);k=f[l>>2]|0;f[j>>2]=k;p=f[n>>2]|0;q=k}else{p=o;q=m}m=f[a+40>>2]|0;if((p|0)==(m|0)){r=q;s=p}else{XIc(q|0,32,m|0)|0;f[n>>2]=m;r=f[l>>2]|0;s=m}f[j>>2]=r+s;switch(f[a+4>>2]|0){case 8:{D8(a,246589);break a;break}case 24:{D8(a,501845);break a;break}default:break a}}while(0);s=f[h>>2]|0;if(!s){r=a+68|0;q=f[r>>2]|0;if(!q)t=r;else{qnc(q)|0;t=r}}else{_pc(s)|0;t=a+68|0}f[h>>2]=0;f[t>>2]=0;f[a+256>>2]=0;f[a+264>>2]=0;b[i>>0]=0}i=f[a+268>>2]|0;if(!(g&(i|0)!=0)){u=d;return}g=f[i+4>>2]|0;a=f[i+16>>2]|0;t=g+(a>>>12<<2)|0;if((f[i+8>>2]|0)!=(g|0)){h=(f[t>>2]|0)+(a&4095)|0;s=a+(f[i+20>>2]|0)|0;i=g+(s>>>12<<2)|0;g=(f[i>>2]|0)+(s&4095)|0;s=h;f[e>>2]=0;a=e+4|0;f[a>>2]=0;if((g|0)!=(h|0)?(r=(i-t<<10)-s+g-(f[i>>2]|0)+(f[t>>2]|0)|0,(r|0)!=0):0){i=tT(e,r)|0;r=t;t=s;s=h;while(1){b[i>>0]=b[s>>0]|0;h=t+1|0;q=h;if((q-(f[r>>2]|0)|0)==4096){p=r+4|0;j=f[p>>2]|0;v=p;w=j;x=j}else{v=r;w=q;x=h}if((x|0)==(g|0)){y=e;z=a;break}else{i=i+1|0;r=v;t=w;s=x}}}else{y=e;z=a}}else{f[e>>2]=0;a=e+4|0;f[a>>2]=0;y=e;z=a}if((e|0)!=(c|0)){uT(c);a=f[y>>2]|0;if(!a)A=0;else{y=a+-4|0;f[y>>2]=(f[y>>2]|0)+1;A=f[e>>2]|0}f[c>>2]=A;f[c+4>>2]=f[z>>2]}uT(e);u=d;return}function R8(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;p[s>>3]=c;h=f[s+4>>2]|0;if((h&2146435072|0)==2146435072)if(((h&2147483647)+((f[s>>2]|0)!=0&1)|0)>>>0>2146435072){b[a>>0]=b[246618]|0;b[a+1>>0]=b[246619]|0;b[a+2>>0]=b[246620]|0;b[a+3>>0]=b[246621]|0;b[a+4>>0]=b[246622]|0;u=d;return a|0}else{kqc(a,(h|0)<0?246623:246629)|0;u=d;return a|0}h=nrc(c)|0;if(+(h|0)==c){f[g>>2]=h;Aqc(a,246608,g)|0;u=d;return a|0}p[e>>3]=c;Aqc(a,246612,e)|0;switch(b[a>>0]|0){case 45:case 43:{i=a+1|0;break}default:i=a}while(1){j=b[i>>0]|0;if((j+-48&255)<10)i=i+1|0;else break}if(j<<24>>24!=44){u=d;return a|0}b[i>>0]=46;u=d;return a|0}function S8(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;h=(n[s>>2]=c,f[s>>2]|0);if((h&2139095040|0)==2139095040)if((h&2147483647|0)==2139095040){kqc(a,(h|0)<0?246623:246629)|0;u=d;return a|0}else{b[a>>0]=b[246618]|0;b[a+1>>0]=b[246619]|0;b[a+2>>0]=b[246620]|0;b[a+3>>0]=b[246621]|0;b[a+4>>0]=b[246622]|0;u=d;return a|0}h=mrc(c)|0;if(+(h|0)==c){f[g>>2]=h;Aqc(a,246608,g)|0;u=d;return a|0}p[e>>3]=c;Aqc(a,246634,e)|0;switch(b[a>>0]|0){case 45:case 43:{i=a+1|0;break}default:i=a}while(1){j=b[i>>0]|0;if((j+-48&255)<10)i=i+1|0;else break}if(j<<24>>24!=44){u=d;return a|0}b[i>>0]=46;u=d;return a|0}function T8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0.0,g=0,h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0,p=0.0;e=+qrc(c,d);g=f[d>>2]|0;if((b[g>>0]|0)==46){b[g>>0]=44;h=+qrc(c,d);b[g>>0]=46;i=f[d>>2]|0;if(i>>>0>g>>>0){j=h;k=i}else{f[d>>2]=g;j=e;k=g}}else{j=e;k=g}if((k|0)!=(c|0)?((b[k>>0]&-33)+-65&255)>=26:0){l=j;return +l}k=b[c>>0]|0;switch(k<<24>>24){case 43:case 45:{g=c+1|0;m=k<<24>>24==45?-D:D;n=b[g>>0]|0;o=g;break}default:{m=D;n=k;o=c}}if(n<<24>>24!=46)M8(a,246639,246663,246186,350);n=b[o+1>>0]|0;if(((Lqc(n)|0)==73?(Lqc(b[o+2>>0]|0)|0)==78:0)?(Lqc(b[o+3>>0]|0)|0)==70:0)p=m;else{if((Lqc(n)|0)!=78)M8(a,246639,246663,246186,359);if((Lqc(b[o+2>>0]|0)|0)!=65)M8(a,246639,246663,246186,359);if((Lqc(b[o+3>>0]|0)|0)==78)p=C;else M8(a,246639,246663,246186,359)}f[d>>2]=o+4;l=p;return +l}function U8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=a+280|0;switch(f[g>>2]|0){case 0:{switch(c|0){case 2:{h=VDc(16)|0;R3(h,a);f[a+272>>2]=h;f[g>>2]=c;u=d;return}case 1:case 0:{f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,55)|0;j=246701;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-2,e,246757,246186,407)}}break}case 2:{switch(c|0){case 1:case 2:{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,49)|0;j=246780;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-2,e,246757,246186,416);break}case 0:{h=a+272|0;a=f[h>>2]|0;if(a|0){d4(a);YDc(a)}f[h>>2]=0;f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,55)|0;j=246701;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-2,e,246757,246186,423)}}break}case 1:{switch(c|0){case 1:case 2:{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,49)|0;j=246780;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-2,e,246757,246186,432);break}case 0:{f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,55)|0;j=246701;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-2,e,246757,246186,437)}}break}default:{f[e>>2]=0;f[e+4>>2]=0;i=tT(e,55)|0;j=246701;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-2,e,246757,246186,442)}}}function V8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+12|0;g=d;h=a+284|0;if(!(b[h>>0]|0)){u=d;return};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=a+292|0;j=f[i>>2]|0;k=a+288|0;l=f[k>>2]|0;if(l|0?b[l>>0]|0:0)nEc(e,l)|0;l=a+296|0;m=f[l>>2]|0;if(m|0?b[m>>0]|0:0)nEc(g,m)|0;m=f[k>>2]|0;if(m|0)ZDc(m);m=f[l>>2]|0;if(m|0)ZDc(m);f[k>>2]=0;f[i>>2]=0;f[l>>2]=0;b[h>>0]=0;h=f[a+228>>2]|0;l=e+11|0;i=(b[l>>0]|0)<0?f[e>>2]|0:e;if(c){ei[h&511](a,i,j,247471);if(f[a+280>>2]|0)U8(a,0);U8(a,2);n=g+11|0}else{c=g+11|0;ei[h&511](a,i,j,(b[c>>0]|0)<0?f[g>>2]|0:g);if(f[a+280>>2]|0)U8(a,0);U8(a,1);n=c}if((b[n>>0]|0)<0)YDc(f[g>>2]|0);if((b[l>>0]|0)<0)YDc(f[e>>2]|0);u=d;return}function W8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;i=a+284|0;if(b[i>>0]|0){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,36)|0;k=246830;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,h,246867,246186,496)}f[a+292>>2]=d;if(c|0){d=XDc((Mpc(c)|0)+1|0)|0;f[a+288>>2]=d;kqc(d,c)|0}if(!e){b[i>>0]=1;u=g;return}c=XDc((Mpc(e)|0)+1|0)|0;f[a+296>>2]=c;kqc(c,e)|0;b[i>>0]=1;u=g;return}function X8(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(a>>>0<9){u=c;return b[246930+a>>0]|0}else{f[d>>2]=0;f[d+4>>2]=0;a=tT(d,22)|0;c=246893;e=a+22|0;do{b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(e|0));z5(-215,d,246916,246186,522)}return 0}function Y8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=b[246930+(a&7)>>0]|0;f[e>>2]=(a>>>3&511)+1;f[e+4>>2]=g;Aqc(c,246939,e)|0;if(b[c+2>>0]|0){h=0;i=h&1;j=c+i|0;u=d;return j|0}h=(b[c>>0]|0)==49;i=h&1;j=c+i|0;u=d;return j|0}function Z8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+16|0;g=e;if(!a){h=0;u=e;return h|0}i=Mpc(a)|0;if(!i){h=0;u=e;return h|0}f[c>>2]=0;j=d<<1;a:do if((i|0)>0){d=~a;k=0;l=0;m=0;b:while(1){n=a+k|0;o=b[n>>0]|0;p=o<<24>>24;do if((o+-48&255)<10){if(((b[a+(k+1)>>0]|0)+-48&255)<10){f[g>>2]=0;q=yrc(n,g,10)|0;r=q;s=(f[g>>2]|0)+d|0}else{r=p+-48|0;s=k}if((r|0)<1){t=9;break b}else{v=l;w=s;x=r}}else{q=Zoc(246930,p,9)|0;if(!q){t=11;break b}y=q-246930|0;if(!m){f[c+(l<<2)>>2]=1;z=1}else z=m;f[c+(l+1<<2)>>2]=y;if((l|0)>0?(y|0)==(f[c+(l+-1<<2)>>2]|0):0){y=c+(l+-2<<2)|0;f[y>>2]=(f[y>>2]|0)+z;v=l;w=k;x=0;break}y=l+2|0;if((y|0)<(j|0)){v=y;w=k;x=0}else{t=18;break b}}while(0);f[c+(v<<2)>>2]=x;k=w+1|0;if((k|0)>=(i|0)){A=v;break a}else{l=v;m=x}}if((t|0)==9){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,31)|0;C=246944;D=B+31|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-5,g,246976,246186,567)}else if((t|0)==11){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,31)|0;C=246944;D=B+31|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-5,g,246992,246186,530)}else if((t|0)==18){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,32)|0;C=247008;D=B+32|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-5,g,246976,246186,583)}}else A=0;while(0);h=(A|0)/2|0;u=e;return h|0}function _8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+512|0;d=c;e=Z8(a,d,128)|0;a=e<<1;if((e|0)>0){e=b;g=0;while(1){h=f[d+((g|1)<<2)>>2]|0;i=(h>>>3&511)+1<<(47696>>>(h<<1&14)&3);h=(e+-1+i&0-i)+(Y(i,f[d+(g<<2)>>2]|0)|0)|0;g=g+2|0;if((g|0)>=(a|0)){j=h;break}else e=h}}else j=b;if(b|0){k=j;u=c;return k|0}b=f[d+4>>2]|0;d=(b>>>3&511)+1<<(47696>>>(b<<1&14)&3);k=j+-1+d&0-d;u=c;return k|0}function $8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+512|0;e=d;g=Z8(a,e,128)|0;h=g<<1;if((g|0)>0){g=c;i=0;while(1){j=f[e+((i|1)<<2)>>2]|0;k=(j>>>3&511)+1<<(47696>>>(j<<1&14)&3);j=(g+-1+k&0-k)+(Y(k,f[e+(i<<2)>>2]|0)|0)|0;i=i+2|0;if((i|0)>=(h|0)){l=j;break}else g=j}}else l=c;if(!c){c=f[e+4>>2]|0;e=(c>>>3&511)+1<<(47696>>>(c<<1&14)&3);m=l+-1+e&0-e}else m=l;l=b[a>>0]|0;if(!(l<<24>>24)){n=0;o=m+-1|0;p=o+n|0;q=0-n|0;r=p&q;u=d;return r|0}else{s=0;t=a;v=l}while(1){switch(v<<24>>24|0){case 117:{w=(s|0)==0?1:s;break}case 99:{w=(s|0)==0?1:s;break}case 119:{w=s>>>0>2?s:2;break}case 115:{w=s>>>0>2?s:2;break}case 105:{w=s>>>0>4?s:4;break}case 102:{w=s>>>0>4?s:4;break}case 100:{w=s>>>0>8?s:8;break}default:w=s}t=t+1|0;v=b[t>>0]|0;if(!(v<<24>>24)){n=w;break}else s=w}o=m+-1|0;p=o+n|0;q=0-n|0;r=p&q;u=d;return r|0}function a9(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+528|0;d=c+8|0;e=c;if((Z8(a,d,128)|0)==1?(a=f[d>>2]|0,(a|0)<=511):0){u=c;return f[d+4>>2]&7|(a<<3)+-8|0}f[e>>2]=0;f[e+4>>2]=0;a=tT(e,33)|0;d=247041;c=a+33|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(c|0));z5(-2,e,247075,246186,645);return 0}function b9(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=c9(a,f[a+76>>2]|0,0)|0;if(!c)return;d=a+92|0;e=a+32|0;g=0;h=c;a:while(1){b:do if(!g){c=h;c:while(1){i=b[c>>0]|0;switch(i<<24>>24){case 45:{break c;break}case 37:break;default:{j=c;k=i;l=20;break b}}if(((Arc(c,247101,5)|0)==0?Arc(c,247107,8)|0:0)?Arc(c,247116,8)|0:0){l=16;break a}b[c>>0]=0;i=c9(a,c,0)|0;if(!i){l=30;break a}else c=i}if(!(Arc(c,247097,3)|0)){m=c;l=19}else n=c}else{i=h;while(1){o=b[i>>0]|0;switch(o<<24>>24){case 37:{if(((Arc(i,247101,5)|0)==0?Arc(i,247107,8)|0:0)?Arc(i,247116,8)|0:0){l=16;break a}b[i>>0]=0;break}case 45:{if(!(Arc(i,247097,3)|0)){m=i;l=19;break b}break}default:{j=i;k=o;l=20;break b}}i=c9(a,i,0)|0;if(!i){l=30;break a}}}while(0);do if((l|0)==19){l=0;n=m+3|0}else if((l|0)==20){l=0;if((k+-48&255)<10|((k&-33)+-65&255)<26|k<<24>>24==95)if(g){l=22;break a}else{n=j;break}else if(!(f[d>>2]|0)){l=24;break a}else{n=j;break}}while(0);i=c9(a,n,0)|0;if(Arc(i,519369,3)|0){c=A7(f[e>>2]|0,0)|0;o=d9(a,i,c,0,0)|0;if((f[c>>2]&7)>>>0<=4){l=27;break}c=c9(a,o,0)|0;if(!c){l=30;break}else p=c}else p=i;if(f[d>>2]|0){l=30;break}h=c9(a,p+3|0,0)|0;if(!h){l=30;break}else g=1}if((l|0)==16)M8(a,247125,247137,247179,566);else if((l|0)==22)M8(a,247125,247253,247179,582);else if((l|0)==24)M8(a,247125,247314,247179,588);else if((l|0)==27)M8(a,247125,247344,247179,599);else if((l|0)==30)return}function c9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a+80|0;g=a+76|0;h=a+88|0;i=c;a:while(1){j=i;b:while(1){k=b[j>>0]|0;switch(k<<24>>24){case 35:{l=5;break b;break}case 32:break;default:break b}j=j+1|0}if((l|0)==5){l=0;b[j>>0]=0;i=j;continue}if((k&255)>31){l=7;break}switch(k<<24>>24){case 13:case 10:case 0:break;default:{l=16;break a}}c=f[g>>2]|0;m=H8(a,c,(f[e>>2]|0)-c|0)|0;if(!m){l=15;break}c=m+((Mpc(m)|0)+-1)|0;switch(b[c>>0]|0){case 13:case 10:break;default:if(!(I8(a)|0)){l=13;break a}}f[h>>2]=(f[h>>2]|0)+1;i=m}if((l|0)==7)if((j-(f[g>>2]|0)|0)<(d|0))M8(a,248139,248050,247179,31);else{n=j;return n|0}else if((l|0)==13)M8(a,248139,248156,247179,51);else if((l|0)==15){j=f[g>>2]|0;b[j+2>>0]=46;b[j+1>>0]=46;b[j>>0]=46;b[j+3>>0]=0;f[a+92>>2]=1;n=j;return n|0}else if((l|0)==16)M8(a,248139,k<<24>>24==9?248201:247827,247179,57);return 0}function d9(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0;h=u;u=u+5216|0;i=h;j=h+80|0;k=h+68|0;l=h+56|0;m=h+12|0;n=h+96|0;o=h+8|0;XIc(n|0,0,5120)|0;f[o>>2]=0;q=b[c>>0]|0;r=c+1|0;t=b[r>>0]|0;v=(e&8|0)!=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;a:do if(q<<24>>24==33){switch(t<<24>>24){case 94:case 33:{w=r;x=16;break}default:{w=c;x=0}}b:do if(t<<24>>24==60){e=w+1|0;y=e;c:while(1){z=y+1|0;A=b[z>>0]|0;if((A&255)<32){B=e;C=x;break b}switch(A<<24>>24){case 32:{B=e;C=x;break b;break}case 62:{break c;break}default:y=z}}if((z-e|0)>>>0>19?(Arc(e,247406,19)|0)==0:0){b[z>>0]=32;B=w+19|0;C=16}else{B=e;C=x}}else{B=w;C=x}while(0);f[o>>2]=B;y=B;do{y=y+1|0;f[o>>2]=y;D=b[y>>0]|0}while((D&255)>=33);A=B+1|0;E=y-A|0;if(!E)M8(a,247426,247443,247179,233);b[y>>0]=0;F=(C&16|0)!=0;do if(F|(E|0)!=3){if(!(F|(E|0)!=5)){G=(Arc(A,519340,5)|0)==0;H=D;I=0;J=G?2:C;break}if((E|0)!=6|F^1){if(!F){H=D;I=0;J=C;break}G=C1(A)|0;f[d+4>>2]=G;if(G|0){H=D;I=0;J=C;break}f[d>>2]=f[d>>2]&-17;H=D;I=0;J=C;break}if(!(Arc(A,247471,6)|0)){b[f[o>>2]>>0]=D;G=f[o>>2]|0;while(1){K=G+1|0;f[o>>2]=K;if((b[K>>0]|0)==32)G=K;else break}e=G+2|0;f[o>>2]=e;K=b[e>>0]|0;b[e>>0]=0;H=K;I=1;J=5}else{H=D;I=0;J=C}}else if(Arc(A,247459,3)|0)if(Arc(A,519294,3)|0)if(!(Arc(A,247463,3)|0)){H=D;I=0;J=5}else{K=(Arc(A,247467,3)|0)==0;H=D;I=0;J=K?6:C}else{H=D;I=0;J=1}else{H=D;I=0;J=3}while(0);b[f[o>>2]>>0]=H;A=c9(a,f[o>>2]|0,g)|0;F=b[A>>0]|0;d:do if(!(J&16)){switch(J|0){case 1:{L=A;M=87;break a;break}case 2:{N=A;M=86;break a;break}case 3:break;default:{M=34;break d}}switch(F<<24>>24){case 34:case 39:break;default:{O=A;P=3;M=144;break a}}if(!I){Q=F;R=H;S=A;T=3;M=79;break a}}else M=34;while(0);if((M|0)==34?!I:0){Q=F;R=H;S=A;T=J;M=79;break}E=a+76|0;y=A-(f[E>>2]|0)|0;K=c9(a,A,0)|0;e=K;f[i>>2]=e;U=a+92|0;do if((f[U>>2]|0)==0?(e-(f[E>>2]|0)|0)==(y|0):0){V=0;while(1){W=K+V|0;X=b[W>>0]|0;if((X&255)>31)V=V+1|0;else break}if(!(X<<24>>24))M8(a,247478,247510,247179,79);else{G=W;f[i>>2]=G;Y=V;Z=W;_=G;break}}else{Y=0;Z=K;_=e}while(0);A=K+Y|0;if(K>>>0<Z>>>0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if((_-e|0)<32)M8(a,247533,247551,247179,97);f[k>>2]=0;F=k+4|0;f[F>>2]=0;f[k+8>>2]=0;G=VDc(25)|0;f[k>>2]=G;$=G+25|0;f[k+8>>2]=$;aa=G;ba=aa+25|0;do{b[aa>>0]=32;aa=aa+1|0}while((aa|0)<(ba|0));f[F>>2]=$;x3(K,G,0,32)|0;if(!(H3(k,j)|0))M8(a,247533,247578,247179,102);e=j+11|0;ca=b[e>>0]|0;if(!((ca<<24>>24<0?f[j+4>>2]|0:ca&255)|0))M8(a,247533,247578,247179,102);ca=K+32|0;da=f[k>>2]|0;if(da|0){if((f[F>>2]|0)!=(da|0))f[F>>2]=da;YDc(da)};f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;mEc(k,131072);e:do if((Y|0)>32){da=A;ea=Z;fa=ca;while(1){$7(k,fa,da)|0;fa=c9(a,ea,0)|0;ga=fa;f[i>>2]=ga;if((f[U>>2]|0)==0?(ga-(f[E>>2]|0)|0)==(y|0):0){ga=fa;while(1){ha=b[ga>>0]|0;if((ha&255)>31)ga=ga+1|0;else break}if(!(ha<<24>>24))break;f[i>>2]=ga;ia=ga}else ia=fa;if(fa>>>0>=ia>>>0)break e;else{da=ia;ea=ia}}M8(a,247478,247510,247179,79)}while(0);y=k+11|0;ca=b[y>>0]|0;A=ca<<24>>24<0;F=k+4|0;K=A?f[F>>2]|0:ca&255;if(!K)M8(a,247533,247608,247179,118);if(!(y3(A?f[k>>2]|0:k,0,K)|0))M8(a,247533,247608,247179,118);K=b[y>>0]|0;A=z3(K<<24>>24<0?f[F>>2]|0:K&255,1)|0;f[l>>2]=0;K=l+4|0;f[K>>2]=0;f[l+8>>2]=0;if(A|0){if((A|0)<0)mCc(l);ca=VDc(A)|0;f[K>>2]=ca;f[l>>2]=ca;f[l+8>>2]=ca+A;G=A;A=ca;do{b[A>>0]=0;A=(f[K>>2]|0)+1|0;f[K>>2]=A;G=G+-1|0}while((G|0)!=0)}G=b[y>>0]|0;A=G<<24>>24<0;ca=A3(A?f[F>>2]|0:G&255,A?f[k>>2]|0:k,0)|0;A=f[l>>2]|0;N3(m,A,(f[K>>2]|0)-A|0);A=b[y>>0]|0;G=A<<24>>24<0;$=G?f[k>>2]|0:k;Q3(m,$,$+(G?f[F>>2]|0:A&255)|0)|0;P3(m)|0;O3(m);A=$8((b[e>>0]|0)<0?f[j>>2]|0:j,0)|0;if((ca|0)%(A|0)|0|0)M8(a,247533,247629,247179,136);f[d>>2]=0;N8(a,13,d);f4(f[l>>2]|0,(ca|0)/(A|0)|0,(b[e>>0]|0)<0?f[j>>2]|0:j,f[d+8>>2]|0);A=f[((f[U>>2]|0)==0?i:E)>>2]|0;ca=f[l>>2]|0;if(ca|0){if((f[K>>2]|0)!=(ca|0))f[K>>2]=ca;YDc(ca)}if((b[y>>0]|0)<0)YDc(f[k>>2]|0);if((b[e>>0]|0)<0)YDc(f[j>>2]|0);ja=A}else ja=Z;ka=ja;u=h;return ka|0}else{Q=q;R=t;S=c;T=0;M=79}while(0);f:do if((M|0)==79){g:do if((Q+-48&255)<10)la=Q;else{switch(Q<<24>>24){case 43:case 45:{if(R<<24>>24==46|(R+-48&255)<10){la=Q;break g}else M=117;break}case 46:{if((R+-48&255)<10|((R&-33)+-65&255)<26){la=46;break g}else ma=46;break}case 34:case 39:{f[d>>2]=3;h:do if(Q<<24>>24==39){c=0;t=S;while(1){q=t+1|0;ja=b[q>>0]|0;if(!((ja+-48&255)<10|((ja&-33)+-65&255)<26)?!(ja<<24>>24!=39&(ja&255)>31):0){if(ja<<24>>24!=39){M=99;break}Z=t+2|0;if((b[Z>>0]|0)==39){na=Z;oa=39}else{pa=Z;qa=c;break h}}else{na=q;oa=ja}b[n+c>>0]=oa;c=c+1|0;if((c|0)>=4096){M=115;break}else t=na}if((M|0)==99)M8(a,247426,247827,247179,353);else if((M|0)==115)M8(a,247426,247845,247179,400)}else{t=0;c=S;i:while(1){ga=c+1|0;ja=b[ga>>0]|0;j:do if((ja+-48&255)<10|((ja&-33)+-65&255)<26){ra=ga;sa=ja;M=105}else{switch(ja<<24>>24){case 34:{M=103;break i;break}case 92:break;default:if((ja&255)>31){ra=ga;sa=ja;M=105;break j}else{M=114;break i}}q=c+2|0;Z=b[q>>0]|0;switch(Z<<24>>24){case 39:{ra=q;sa=39;M=105;break j;break}case 92:case 34:{ra=q;sa=Z;M=105;break j;break}case 110:{ra=q;sa=10;M=105;break j;break}case 114:{ra=q;sa=13;M=105;break j;break}case 116:{ra=q;sa=9;M=105;break j;break}default:{k=Z<<24>>24==120;if(!k?!(Z<<24>>24<56&(Z+-48&255)<10):0){ta=t;ua=q;break j}Z=c+5|0;l=b[Z>>0]|0;b[Z>>0]=0;m=q+(k&1)|0;ia=yrc(m,o,k?8:16)|0;b[Z>>0]=l;l=f[o>>2]|0;Z=(l|0)==(m|0);ra=Z?q:l;sa=Z?120:ia&255;M=105;break j}}}while(0);if((M|0)==105){M=0;b[n+t>>0]=sa;ta=t+1|0;ua=ra}if((ta|0)<4096){t=ta;c=ua}else{M=115;break}}if((M|0)==103){pa=c+2|0;qa=t;break}else if((M|0)==114)M8(a,247426,247827,247179,396);else if((M|0)==115)M8(a,247426,247845,247179,400)}while(0);l7(i,f[a+16>>2]|0,n,qa);ja=d+8|0;p[s>>3]=+p[i>>3];f[ja>>2]=f[s>>2];f[ja+4>>2]=f[s+4>>2];ka=pa;u=h;return ka|0}default:M=117}k:do if((M|0)==117){ja=Q<<24>>24==91;switch(Q<<24>>24){case 91:case 123:break;default:if(Q<<24>>24==45&(v^1)){va=5;wa=S;break f}else{ma=Q;break k}}ga=((v^1)&1)+g|0;ia=Q<<24>>24==123?14:13;Z=ia&7;N8(a,(f[d+4>>2]|0?16:0)|Z,d);l=d+8|0;q=(Z|0)==6;Z=1;m=S+1|0;l:while(1){f[i>>2]=0;xa=c9(a,m,ga)|0;ya=b[xa>>0]|0;switch(ya<<24>>24){case 93:case 125:{M=120;break l;break}default:{}}if(!(f[(f[l>>2]|0)+24>>2]|0))za=xa;else{if(ya<<24>>24!=44){M=125;break}za=c9(a,xa+1|0,ga)|0}if(q){k=c9(a,f9(a,za,d,i)|0,ga)|0;ha=f[i>>2]|0;Aa=k;Ba=ha;Ca=ha}else{if((b[za>>0]|0)==93){Da=za;break}ha=A7(f[l>>2]|0,0)|0;f[i>>2]=ha;Aa=za;Ba=ha;Ca=ha}if(!Ba){M=132;break}ha=d9(a,Aa,Ba,ia,ga)|0;if(q)f[Ca>>2]=f[Ca>>2]|64;if(Z)Ea=(f[Ca>>2]&7)>>>0<5;else Ea=0;Z=Ea;m=ha}do if((M|0)==120)if((ya<<24>>24|0)==((ja?93:125)|0)){Da=xa+1|0;break}else M8(a,247426,247869,247179,423);else if((M|0)==125)M8(a,247426,247895,247179,431);else if((M|0)==132){f[j>>2]=0;f[j+4>>2]=0;m=tT(j,4)|0;b[m>>0]=101;b[m+1>>0]=108;b[m+2>>0]=101;b[m+3>>0]=109;e9(-215,j,247426,446)}while(0);ja=f[l>>2]|0;f[ja>>2]=f[ja>>2]|(Z?256:0);ka=Da;u=h;return ka|0}while(0);if(v){O=S;P=T;M=144;break f}switch(ma<<24>>24){case 63:{M8(a,247426,247926,247179,465);break}case 62:case 124:{M8(a,247426,247957,247179,467);break}default:{O=S;P=T;M=144;break f}}}while(0);e=S+((la<<24>>24==45|la<<24>>24==43)&1)|0;while(1){f[o>>2]=e;Fa=b[e>>0]|0;if((Fa+-48&255)<10)e=e+1|0;else break}switch(Fa<<24>>24){case 101:case 46:{N=S;M=86;break}default:{L=S;M=87}}}while(0);if((M|0)==86){Ga=+T8(a,N,o);f[d>>2]=2;p[d+8>>3]=Ga;Ha=N;M=88}else if((M|0)==87){N=yrc(L,o,0)|0;f[d>>2]=1;f[d+8>>2]=N;Ha=L;M=88}else if((M|0)==144){f[o>>2]=O;L=b[O>>0]|0;if((L&255)<=31)M8(a,247426,247827,247179,479);m:do if(v){N=L;S=O;while(1){switch(N<<24>>24){case 93:case 125:case 44:{Ia=N;Ja=S;break m;break}default:{}}Fa=S+1|0;f[o>>2]=Fa;la=b[Fa>>0]|0;if((la&255)>31){N=la;S=Fa}else{Ia=la;Ja=Fa;break m}}}else{if((P|0)==3){S=O;while(1){N=S+1|0;f[o>>2]=N;Fa=b[N>>0]|0;if((Fa&255)>31)S=N;else{Ia=Fa;Ja=N;break m}}}else{Ka=L;La=O}while(1){if(Ka<<24>>24==58){Ia=58;Ja=La;break m}S=La+1|0;f[o>>2]=S;N=b[S>>0]|0;if((N&255)>31){Ka=N;La=S}else{Ia=N;Ja=S;break}}}while(0);if((Ja|0)==(O|0))M8(a,247426,247827,247179,479);if(Ia<<24>>24==58&(v^1)){va=6;wa=O}else{f[d>>2]=3;v=Ja;while(1){Ja=v+-1|0;if(Ja>>>0<=O>>>0)break;if((b[Ja>>0]|0)==32)v=Ja;else break}l7(i,f[a+16>>2]|0,O,v-O|0);O=d+8|0;p[s>>3]=+p[i>>3];f[O>>2]=f[s>>2];f[O+4>>2]=f[s+4>>2];ka=f[o>>2]|0;u=h;return ka|0}}if((M|0)==88){O=f[o>>2]|0;if((O|0)==0|(O|0)==(Ha|0))M8(a,247426,247662,247179,331);if(b[O>>0]|0){ka=O;u=h;return ka|0}if((O|0)==((f[a+80>>2]|0)+-1|0)){f[i>>2]=0;f[i+4>>2]=0;aa=tT(i,98)|0;Ha=247728;ba=aa+98|0;do{b[aa>>0]=b[Ha>>0]|0;aa=aa+1|0;Ha=Ha+1|0}while((aa|0)<(ba|0));e9(-215,i,247426,334)}else{ka=O;u=h;return ka|0}}N8(a,(f[d+4>>2]|0?16:0)|va,d);O=a+76|0;Ha=wa-(f[O>>2]|0)|0;aa=Ha+1|0;ba=d+8|0;n:do if((va|0)!=6){o=1;v=wa;while(1){f[i>>2]=0;if((b[v>>0]|0)!=45){M=164;break}Ja=A7(f[ba>>2]|0,0)|0;f[i>>2]=Ja;if(!Ja){M=166;break}Ia=d9(a,c9(a,v+1|0,aa)|0,Ja,va,aa)|0;if(o)Ma=(f[Ja>>2]&7)>>>0<5;else Ma=0;Ja=c9(a,Ia,0)|0;Ia=Ja-(f[O>>2]|0)|0;if((Ia|0)!=(Ha|0)){Na=Ia;Oa=Ja;Pa=Ma;M=170;break n}if(!(Arc(Ja,519369,3)|0)){Qa=Ma;Ra=Ja;break n}else{o=Ma;v=Ja}}if((M|0)==164)M8(a,247426,248e3,247179,516);else if((M|0)==166){f[j>>2]=0;Sa=j+4|0;f[Sa>>2]=0;Ta=tT(j,4)|0;b[Ta>>0]=101;b[Ta+1>>0]=108;b[Ta+2>>0]=101;b[Ta+3>>0]=109;e9(-215,j,247426,520)}}else{v=1;o=wa;while(1){f[i>>2]=0;Ja=f9(a,o,d,i)|0;Ia=f[i>>2]|0;if(!Ia)break;La=d9(a,c9(a,Ja,aa)|0,Ia,6,aa)|0;Ja=f[Ia>>2]|0;f[Ia>>2]=Ja|64;Ia=v&(Ja&7)>>>0<5;Ja=c9(a,La,0)|0;La=Ja-(f[O>>2]|0)|0;if((La|0)!=(Ha|0)){Na=La;Oa=Ja;Pa=Ia;M=170;break n}if(!(Arc(Ja,519369,3)|0)){Qa=Ia;Ra=Ja;break n}else{v=Ia;o=Ja}}f[j>>2]=0;Sa=j+4|0;f[Sa>>2]=0;Ta=tT(j,4)|0;b[Ta>>0]=101;b[Ta+1>>0]=108;b[Ta+2>>0]=101;b[Ta+3>>0]=109;e9(-215,j,247426,520)}while(0);do if((M|0)==170)if((Na|0)<(Ha|0)){Qa=Pa;Ra=Oa;break}else M8(a,247426,248050,247179,533);while(0);a=f[ba>>2]|0;f[a>>2]=f[a>>2]|(Qa?256:0);ka=Ra;u=h;return ka|0}function e9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,247179,d);return}function f9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;if((b[c>>0]|0)==45)M8(a,248072,248087,247179,162);g=c+-1|0;while(1){h=g+1|0;i=b[h>>0]|0;j=i<<24>>24!=58;if((i&255)<32|j^1)break;else g=h}if(j)M8(a,248072,248114,247179,168);else k=h;while(1){h=k+-1|0;if((b[h>>0]|0)==32)k=h;else break}if((k|0)==(c|0))M8(a,248072,248126,247179,176);else{h=o1(a,d,n1(a,c,k-c|0,1)|0,1)|0;f[e>>2]=h;return g+2|0}return 0}function g9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;V8(a,0);switch(f[a+280>>2]|0){case 0:{U8(a,1);break}case 2:{f[g>>2]=0;f[g+4>>2]=0;h=tT(g,36)|0;i=248230;j=h+36|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));e9(-2,g,248267,628);break}default:{}}k=a+44|0;l=f[k>>2]|0;if(!c)m=0;else m=(b[c>>0]|0)==0?0:c;c=l&7;n=(m|0)!=0;if(c>>>0>4)if((c|0)==6^n){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,85)|0;i=248279;j=h+85|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));e9(-5,g,248267,645)}else o=l;else{f[a+12>>2]=0;o=n?38:37}if(n){l=Mpc(m)|0;if(!l){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,19)|0;i=248365;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));e9(-5,g,248267,657)}if((l|0)>4096){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,19)|0;i=248385;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));e9(-5,g,248267,660)}else p=l}else p=0;l=(d|0)!=0;if(l)q=Mpc(d)|0;else q=0;c=(o&8|0)==0;do if(c){r=P8(a)|0;if((o&7|0)!=6){s=r+1|0;b[r>>0]=45;if(l){b[s>>0]=32;t=r+2|0}else t=s}else t=r}else{r=a+72|0;s=f[r>>2]|0;if(!(o&32)){b[s>>0]=44;v=s+1|0}else v=s;s=q+p-(f[a+76>>2]|0)+v|0;if((s|0)>(f[a+84>>2]|0)?(s-(f[a+40>>2]|0)|0)>10:0){f[r>>2]=v;t=P8(a)|0;break}b[v>>0]=32;t=v+1|0}while(0);if(n){n=b[m>>0]|0;if(!(((n&-33)+-65&255)<26|n<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,33)|0;i=248405;j=h+33|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));e9(-5,g,248267,695)}n=O8(a,t,p)|0;a:do if((p|0)>0){v=0;b:while(1){r=b[m+v>>0]|0;b[n+v>>0]=r;if(!((r+-48&255)<10|((r&-33)+-65&255)<26))switch(r<<24>>24){case 32:case 45:case 95:break;default:break b}v=v+1|0;if((v|0)>=(p|0))break a}f[g>>2]=0;f[g+4>>2]=0;h=tT(g,80)|0;i=248439;j=h+80|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));e9(-5,g,248267,705)}while(0);g=n+p|0;p=g+1|0;b[g>>0]=58;if(l&c){b[p>>0]=32;w=p+1|0}else w=p}else w=t;if(!l){x=w;y=a+72|0;f[y>>2]=x;z=o&-33;f[k>>2]=z;u=e;return}l=O8(a,w,q)|0;dJc(l|0,d|0,q|0)|0;x=l+q|0;y=a+72|0;f[y>>2]=x;z=o&-33;f[k>>2]=z;u=e;return}function h9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+5152|0;h=g+8|0;i=g;j=g+24|0;k=g+32|0;l=g+16|0;if(!e)m=0;else m=(b[e>>0]|0)==0?0:e;e=d&15;n=e|32;o=d&7;if(o>>>0<=4){f[l>>2]=0;f[l+4>>2]=0;p=tT(l,68)|0;q=248520;r=p+68|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));e9(-5,l,248589,738)}l=(m|0)!=0;if(l?(Arc(m,247471,6)|0)==0:0){p=k;q=248612;r=p+11|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));s=5;t=k}else v=8;do if((v|0)==8){if(!(d&8)){if(!l){s=n;t=0;break}f[h>>2]=m;Aqc(k,248631,h)|0;s=n;t=k;break}q=(o|0)==6?123:91;p=e|40;if(l){f[i>>2]=m;f[i+4>>2]=q&255;Aqc(k,248623,i)|0;s=p;t=k;break}else{b[k>>0]=q;b[k+1>>0]=0;s=p;t=k;break}}while(0);g9(a,c,t);t=a+44|0;f[j>>2]=f[t>>2];A7(f[a+36>>2]|0,j)|0;f[t>>2]=s;t=a+40|0;if(f[j>>2]&8|0){u=g;return}f[t>>2]=(s>>>3&1)+3+(f[t>>2]|0);u=g;return}function i9(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c+8|0;e=c;f[d>>2]=0;g=a+44|0;h=f[g>>2]|0;i=f[a+36>>2]|0;if(!(f[i+24>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;j=tT(e,44)|0;k=248636;l=j+44|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));e9(-2,e,248681,785)}B7(i,d);i=h&8;if(!i){if(h&32|0){e=P8(a)|0;k=(h&7|0)==6?32123:23899;b[e>>0]=k;b[e+1>>0]=k>>8;m=a+72|0;n=e+2|0;o=9}}else{e=a+72|0;k=f[e>>2]|0;if((h&32|0)==0?k>>>0>((f[a+76>>2]|0)+(f[a+40>>2]|0)|0)>>>0:0){b[k>>0]=32;p=k+1|0}else p=k;b[p>>0]=(h&7|0)==6?125:93;m=e;n=p+1|0;o=9}if((o|0)==9)f[m>>2]=n;n=f[d>>2]|0;d=a+40|0;if(n&8|0){f[g>>2]=n;u=c;return}f[d>>2]=-3-(i>>>3)+(f[d>>2]|0);f[g>>2]=n;u=c;return}function j9(a){a=a|0;var b=0;if(f[a+12>>2]|0)return;b=a+36|0;if((f[(f[b>>2]|0)+24>>2]|0)>0)do i9(a);while((f[(f[b>>2]|0)+24>>2]|0)>0);f[a+40>>2]=0;P8(a)|0;D8(a,248702);D8(a,248707);f[a+72>>2]=f[a+76>>2];return}function k9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=u;u=u+128|0;g9(a,b,C8(c,d,10)|0);u=d;return}function l9(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=u;u=u+128|0;g9(a,b,R8(d,c)|0);u=d;return}function m9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+16416|0;h=g;i=g+16|0;j=g+8|0;if(!d){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,19)|0;l=248712;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));e9(-27,j,248732,849)}n=Mpc(d)|0;if((n|0)>4096){f[j>>2]=0;f[j+4>>2]=0;k=tT(j,30)|0;l=248750;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));e9(-5,j,248732,853)}if((e|0)!=0|(n|0)==0)o=1;else{e=b[d>>0]|0;a:do if(e<<24>>24==(b[d+(n+-1)>>0]|0)){switch(e<<24>>24){case 39:case 34:{p=d;break}default:break a}g9(a,c,p);u=g;return}while(0);o=e<<24>>24==32}e=o&1;j=i+1|0;b[i>>0]=34;if((n|0)>0){l=j;k=e;m=0;q=o;while(1){r=b[d+m>>0]|0;s=r+-48<<24>>24;b:do if(!q){t=(r&-33)+-65<<24>>24;if((s&255)<10|(t&255)<26){v=0;w=t}else{switch(r<<24>>24){case 32:case 40:case 41:case 43:case 45:case 47:case 59:case 95:{v=0;w=t;break b;break}default:{}}v=1;w=t}}else{v=k;w=(r&-33)+-65<<24>>24}while(0);c:do if((s&255)<10|(w&255)<26)x=24;else{if((r&255)>31){switch(r<<24>>24){case 34:case 39:case 92:break;default:{x=24;break c}}b[l>>0]=92;b[l+1>>0]=r;y=l+2|0;break}t=l+1|0;b[l>>0]=92;switch(r<<24>>24){case 10:{b[t>>0]=110;y=l+2|0;break c;break}case 13:{b[t>>0]=114;y=l+2|0;break c;break}case 9:{b[t>>0]=116;y=l+2|0;break c;break}default:{f[h>>2]=r<<24>>24;Aqc(t,248781,h)|0;y=l+4|0;break c}}}while(0);if((x|0)==24){x=0;b[l>>0]=r;y=l+1|0}m=m+1|0;s=(v|0)!=0;if((m|0)==(n|0)){z=y;A=v;B=s;break}else{l=y;k=v;q=s}}}else{z=j;A=e;B=o}if(!B){B=b[d>>0]|0;if((B+-48&255)<10){C=1;x=29}else switch(B<<24>>24){case 46:case 45:case 43:{C=1;x=29;break}default:{D=z;E=1}}}else{C=A;x=29}if((x|0)==29){b[z>>0]=34;D=z+1|0;E=(C|0)==0}b[D>>0]=0;p=i+(E&1)|0;g9(a,c,p);u=g;return}function n9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if(!c){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,12)|0;i=248787;j=h+12|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));e9(-27,g,248800,910)}g=Wpc(c,10)|0;i=a+72|0;h=f[i>>2]|0;if((!((d|0)==0|(g|0)!=0)?(d=Mpc(c)|0,((f[a+80>>2]|0)-h|0)>=(d|0)):0)?(h|0)!=(f[a+76>>2]|0):0){b[h>>0]=32;k=h+1|0;l=g;m=c}else{k=P8(a)|0;l=g;m=c}while(1){b[k>>0]=35;n=k+2|0;b[k+1>>0]=32;if(!l)break;c=l-m|0;g=c+1|0;h=O8(a,n,g)|0;dJc(h|0,m|0,g|0)|0;f[i>>2]=h+c;c=l+1|0;h=Wpc(c,10)|0;k=P8(a)|0;l=h;m=c}l=Mpc(m)|0;k=O8(a,n,l)|0;dJc(k|0,m|0,l|0)|0;f[i>>2]=k+l;P8(a)|0;u=e;return}function o9(a){a=a|0;return}function p9(a,b){a=a|0;b=b|0;var c=0,d=0;switch(b|0){case 0:{b=VDc(16)|0;f[b+4>>2]=8;f[b+8>>2]=16;f[b+12>>2]=1;f[b>>2]=46412;c=VDc(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=46444;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;Yi[f[(f[c>>2]|0)+8>>2]&2047](c);return}case 1:{c=VDc(16)|0;f[c+4>>2]=8;f[c+8>>2]=16;f[c+12>>2]=1;f[c>>2]=46464;b=VDc(16)|0;d=b+4|0;f[d>>2]=1;f[b>>2]=46496;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;Yi[f[(f[b>>2]|0)+8>>2]&2047](b);return}case 2:{b=VDc(16)|0;f[b+4>>2]=8;f[b+8>>2]=16;f[b+12>>2]=1;f[b>>2]=46516;c=VDc(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=46548;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;Yi[f[(f[c>>2]|0)+8>>2]&2047](c);return}case 3:{c=VDc(16)|0;f[c+4>>2]=8;f[c+8>>2]=16;f[c+12>>2]=1;f[c>>2]=46568;b=VDc(16)|0;d=b+4|0;f[d>>2]=1;f[b>>2]=46600;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;Yi[f[(f[b>>2]|0)+8>>2]&2047](b);return}case 4:{b=VDc(16)|0;f[b+4>>2]=8;f[b+8>>2]=16;f[b+12>>2]=1;f[b>>2]=46620;c=VDc(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=46652;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;Yi[f[(f[c>>2]|0)+8>>2]&2047](c);return}case 5:{c=VDc(16)|0;f[c+4>>2]=8;f[c+8>>2]=16;f[c+12>>2]=1;f[c>>2]=46672;b=VDc(16)|0;d=b+4|0;f[d>>2]=1;f[b>>2]=46704;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;Yi[f[(f[b>>2]|0)+8>>2]&2047](b);return}default:{b=VDc(16)|0;f[b+4>>2]=8;f[b+8>>2]=16;f[b+12>>2]=1;f[b>>2]=46412;c=VDc(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=46444;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;Yi[f[(f[c>>2]|0)+8>>2]&2047](c);return}}}function q9(a){a=a|0;YDc(a);return}function r9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function s9(a){a=a|0;YDc(a);return}function t9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+18|0;h=e+8|0;i=e;j=e+17|0;k=e+16|0;b[g>>0]=b[248921]|0;b[g+1>>0]=b[248922]|0;b[g+2>>0]=b[248923]|0;b[g+3>>0]=b[248924]|0;b[g+4>>0]=b[248925]|0;f[i>>2]=g;if((f[d+8>>2]|0)==1)l=1;else l=(f[c+12>>2]|0)==0&1;b[j>>0]=l;b[k>>0]=0;x9(h,248926,503084,d,i,j,k,(f[d>>2]&7|0)==6?c+8|0:c+4|0);c=f[h>>2]|0;f[a>>2]=c;f[a+4>>2]=f[h+4>>2];a=c;if(!c){m=h;n=a}else{c=a+4|0;f[c>>2]=(f[c>>2]|0)+1;m=h;n=f[h>>2]|0}if(!n){f[m>>2]=0;u=e;return}h=n+4|0;c=f[h>>2]|0;f[h>>2]=c+-1;if((c|0)!=1){f[m>>2]=0;u=e;return}Yi[f[(f[n>>2]|0)+8>>2]&2047](n);f[m>>2]=0;u=e;return}function u9(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function v9(a,b){a=a|0;b=b|0;f[a+8>>2]=b;return}function w9(a,b){a=a|0;b=b|0;f[a+12>>2]=b&1;return}function x9(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;k=u;u=u+80|0;l=k+64|0;m=k+56|0;n=k;o=VDc(156)|0;f[l>>2]=0;f[l+4>>2]=0;p=Mpc(c)|0;if(p|0)dJc(tT(l,p)|0,c|0,p|0)|0;f[m>>2]=0;f[m+4>>2]=0;p=Mpc(d)|0;if(p|0)dJc(tT(m,p)|0,d|0,p|0)|0;f[n>>2]=f[e>>2];p=n+4|0;d=e+4|0;c=f[d>>2]|0;f[p>>2]=c;q=n+8|0;f[q>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];r=n+16|0;f[r>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];s=n+36|0;t=f[e+36>>2]|0;f[s>>2]=t;v=n+40|0;f[v>>2]=q;q=n+48|0;w=n+44|0;f[w>>2]=q;f[q>>2]=0;f[n+52>>2]=0;if(!t)x=c;else{c=t+12|0;f[c>>2]=(f[c>>2]|0)+1;x=f[d>>2]|0}if((x|0)<3){x=f[e+44>>2]|0;d=f[w>>2]|0;f[d>>2]=f[x>>2];f[d+4>>2]=f[x+4>>2]}else{f[p>>2]=0;ZS(n,e)}y9(o,l,m,n,f[g>>2]|0,(b[h>>0]|0)!=0,(b[i>>0]|0)!=0,f[j>>2]|0);j=VDc(16)|0;f[j+4>>2]=1;f[j>>2]=46724;f[j+8>>2]=o;f[a>>2]=j;f[a+4>>2]=o;o=f[s>>2]|0;if(o|0?(a=o+12|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0)_S(n);f[s>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[p>>2]|0)>0){r=f[v>>2]|0;v=0;do{f[r+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[p>>2]|0))}p=f[w>>2]|0;if((p|0)==(q|0)){uT(m);uT(l);u=k;return}g0(p);uT(m);uT(l);u=k;return}function y9(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=u;u=u+16|0;l=k;m=k+8|0;n=h&1;h=i&1;f[a>>2]=46744;i=a+44|0;f[i>>2]=1124007936;o=a+48|0;p=a+52|0;q=a+84|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;t=a+92|0;v=a+88|0;f[v>>2]=t;f[t>>2]=0;f[a+96>>2]=0;t=a+124|0;w=a+128|0;x=a+132|0;y=a+136|0;z=e+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[z>>2]|0)>=3){f[m>>2]=0;f[m+4>>2]=0;r=tT(m,11)|0;A=249001;s=r+11|0;do{b[r>>0]=b[A>>0]|0;r=r+1|0;A=A+1|0}while((r|0)<(s|0));z5(-215,m,249013,249027,86)}if((t|0)!=(c|0)){uT(t);m=f[c>>2]|0;if(!m)B=0;else{A=m+-4|0;f[A>>2]=(f[A>>2]|0)+1;B=f[c>>2]|0}f[t>>2]=B;f[w>>2]=f[c+4>>2]}if((x|0)!=(d|0)){uT(x);c=f[d>>2]|0;if(!c)C=0;else{w=c+-4|0;f[w>>2]=(f[w>>2]|0)+1;C=f[d>>2]|0}f[x>>2]=C;f[y>>2]=f[d+4>>2]}if((i|0)!=(e|0)){d=e+36|0;y=f[d>>2]|0;if(y|0){C=y+12|0;f[C>>2]=(f[C>>2]|0)+1}C=a+80|0;y=f[C>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)_S(i);f[C>>2]=0;y=a+60|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[o>>2]|0)>0){x=f[q>>2]|0;q=0;do{f[x+(q<<2)>>2]=0;q=q+1|0;D=f[o>>2]|0}while((q|0)<(D|0));f[i>>2]=f[e>>2];if((D|0)<3)E=22;else E=24}else{f[i>>2]=f[e>>2];E=22}if((E|0)==22){D=f[z>>2]|0;if((D|0)<3){f[o>>2]=D;f[p>>2]=f[e+8>>2];f[a+56>>2]=f[e+12>>2];p=f[e+44>>2]|0;D=f[v>>2]|0;f[D>>2]=f[p>>2];f[D+4>>2]=f[p+4>>2]}else E=24}if((E|0)==24)ZS(i,e);f[y>>2]=f[e+16>>2];f[a+64>>2]=f[e+20>>2];f[a+68>>2]=f[e+24>>2];f[a+72>>2]=f[e+28>>2];f[a+76>>2]=f[e+32>>2];f[C>>2]=f[d>>2]}f[a+100>>2]=((f[e>>2]|0)>>>3&511)+1;e=a+140|0;b[e>>0]=b[g>>0]|0;b[e+1>>0]=b[g+1>>0]|0;b[e+2>>0]=b[g+2>>0]|0;b[e+3>>0]=b[g+3>>0]|0;b[e+4>>0]=b[g+4>>0]|0;f[a+108>>2]=0;b[a+104>>0]=n;b[a+105>>0]=h;f[a+120>>2]=0;f[a+116>>2]=0;f[a+112>>2]=0;h=a+4|0;if((j|0)<0){b[h>>0]=37;b[a+5>>0]=97;b[a+6>>0]=0}else{f[l>>2]=(j|0)<20?j:20;C5(h,8,249089,l)|0}switch(f[i>>2]&7){case 0:{F=1723;G=0;break}case 1:{F=1722;G=0;break}case 2:{F=1724;G=0;break}case 3:{F=1725;G=0;break}case 4:{F=1726;G=0;break}case 5:{F=1727;G=0;break}case 6:{F=1728;G=0;break}default:{F=1729;G=0}}f[a+148>>2]=F;f[a+152>>2]=G;u=k;return}function z9(a){a=a|0;YDc(a);return}function A9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+12>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function B9(a){a=a|0;b[a+12>>0]=0;return}function C9(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;p[c>>3]=+p[g+(f[a+120>>2]<<3)>>3];Aqc(a+12|0,a+4|0,c)|0;u=b;return}function D9(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;p[c>>3]=+n[g+(f[a+120>>2]<<2)>>2];Aqc(a+12|0,a+4|0,c)|0;u=b;return}function E9(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;f[c>>2]=f[g+(f[a+120>>2]<<2)>>2];Aqc(a+12|0,502165,c)|0;u=b;return}function F9(a){a=a|0;var b=0,c=0,e=0,g=0,h=0;b=u;u=u+16|0;c=b;e=f[a+88>>2]|0;g=(f[a+60>>2]|0)+(Y(f[e>>2]|0,f[a+112>>2]|0)|0)|0;h=g+(Y(f[e+4>>2]|0,f[a+116>>2]|0)|0)|0;f[c>>2]=d[h+(f[a+120>>2]<<1)>>1];Aqc(a+12|0,502165,c)|0;u=b;return}function G9(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;f[c>>2]=j[g+(f[a+120>>2]<<1)>>1];Aqc(a+12|0,502165,c)|0;u=b;return}function H9(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;f[c>>2]=h[g+(f[a+120>>2]|0)>>0];Aqc(a+12|0,249096,c)|0;u=b;return}function I9(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=f[a+88>>2]|0;g=(f[a+60>>2]|0)+(Y(f[e>>2]|0,f[a+112>>2]|0)|0)|0;h=g+(Y(f[e+4>>2]|0,f[a+116>>2]|0)|0)|0;f[d>>2]=b[h+(f[a+120>>2]|0)>>0];Aqc(a+12|0,249096,d)|0;u=c;return}function J9(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c+8|0;e=c;g=a+108|0;do switch(f[g>>2]|0){case 0:{f[a+112>>2]=0;if(f[a+60>>2]|0){h=f[a+48>>2]|0;if((h|0)<3)i=Y(f[a+56>>2]|0,f[a+52>>2]|0)|0;else{j=f[a+84>>2]|0;k=0;l=1;while(1){m=Y(f[j+(k<<2)>>2]|0,l)|0;k=k+1|0;if((k|0)==(h|0)){i=m;break}else l=m}}if(!((h|0)==0|(i|0)==0))n=b[a+105>>0]|0?2:3;else n=1}else n=1;f[g>>2]=n;l=f[a+124>>2]|0;o=(l|0)==0?1154740:l;u=c;return o|0}case 2:{f[g>>2]=3;l=a+112|0;if((f[l>>2]|0)<(f[a+52>>2]|0)){k=a+12|0;f[d>>2]=(f[a+120>>2]|0)+1;Aqc(k,249116,d)|0;o=k;u=c;return o|0}k=a+120|0;j=f[k>>2]|0;m=j+1|0;f[k>>2]=m;if((m|0)<(f[a+100>>2]|0)){f[l>>2]=0;l=a+12|0;f[e>>2]=j+2;Aqc(l,249100,e)|0;o=l;u=c;return o|0}else{f[g>>2]=1;l=a+12|0;b[l>>0]=0;o=l;u=c;return o|0}break}case 1:{f[g>>2]=8;l=f[a+132>>2]|0;o=(l|0)==0?1154740:l;u=c;return o|0}case 3:{f[a+116>>2]=0;f[g>>2]=5;if((f[a+112>>2]|0)>0?(l=a+128|0,(f[l>>2]|0)!=0):0){j=0;while(1){m=j+1|0;b[a+12+j>>0]=32;if(m>>>0<30?m>>>0<(f[l>>2]|0)>>>0:0)j=m;else{p=m;break}}}else p=0;j=b[a+140>>0]|0;if(!(j<<24>>24))if(!p){o=_i[f[f[a>>2]>>2]&1023](a)|0;u=c;return o|0}else q=p;else{b[a+12+p>>0]=j;q=p+1|0}b[a+12+q>>0]=0;o=a+12|0;u=c;return o|0}case 4:{f[g>>2]=9;j=a+112|0;l=(f[j>>2]|0)+1|0;f[j>>2]=l;j=b[a+141>>0]|0;if(j<<24>>24){h=a+12|0;b[h>>0]=j;b[a+13>>0]=(l|0)<(f[a+52>>2]|0)?44:0;b[a+14>>0]=0;o=h;u=c;return o|0}h=b[a+142>>0]|0;if(h<<24>>24?(l|0)<(f[a+52>>2]|0):0){l=a+12|0;b[l>>0]=h;b[a+13>>0]=0;o=l;u=c;return o|0}o=_i[f[f[a>>2]>>2]&1023](a)|0;u=c;return o|0}case 5:{f[g>>2]=7;if(!(b[a+105>>0]|0))f[a+120>>2]=0;if((f[a+100>>2]|0)>1?(l=b[a+143>>0]|0,l<<24>>24):0){h=a+12|0;b[h>>0]=l;b[a+13>>0]=0;o=h;u=c;return o|0}o=_i[f[f[a>>2]>>2]&1023](a)|0;u=c;return o|0}case 6:{h=a+116|0;l=(f[h>>2]|0)+1|0;f[h>>2]=l;f[g>>2]=(l|0)>=(f[a+56>>2]|0)?4:10;if((f[a+100>>2]|0)>1?(l=b[a+144>>0]|0,l<<24>>24):0){h=a+12|0;b[h>>0]=l;b[a+13>>0]=0;o=h;u=c;return o|0}o=_i[f[f[a>>2]>>2]&1023](a)|0;u=c;return o|0}case 7:{h=f[a+148>>2]|0;l=f[a+152>>2]|0;j=a+(l>>1)|0;if(!(l&1))r=h;else r=f[(f[j>>2]|0)+h>>2]|0;Yi[r&2047](j);f[g>>2]=6;if(b[a+105>>0]|0){o=a+12|0;u=c;return o|0}j=a+120|0;h=(f[j>>2]|0)+1|0;f[j>>2]=h;if((h|0)<(f[a+100>>2]|0))f[g>>2]=11;o=a+12|0;u=c;return o|0}case 11:{f[g>>2]=7;h=a+12|0;b[h>>0]=44;b[a+13>>0]=32;b[a+14>>0]=0;o=h;u=c;return o|0}case 9:{if((f[a+112>>2]|0)<(f[a+52>>2]|0)){f[g>>2]=3;h=a+12|0;b[h>>0]=b[a+104>>0]|0?32:10;b[a+13>>0]=0;o=h;u=c;return o|0}else{f[g>>2]=b[a+105>>0]|0?2:1;o=_i[f[f[a>>2]>>2]&1023](a)|0;u=c;return o|0}break}case 10:{f[g>>2]=5;h=a+12|0;b[h>>0]=44;b[a+13>>0]=32;b[a+14>>0]=0;o=h;u=c;return o|0}default:{o=0;u=c;return o|0}}while(0);return 0}function K9(a){a=a|0;f[a+108>>2]=0;return}function L9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=46744;uT(a+132|0);uT(a+124|0);b=a+44|0;c=a+80|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+60|0;b=a+48|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+84>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0))return;g0(b);return}function M9(a){a=a|0;L9(a);YDc(a);return}function N9(a){a=a|0;YDc(a);return}function O9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function P9(a){a=a|0;YDc(a);return}function Q9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e;h=e+26|0;i=e+16|0;j=e+8|0;k=e+25|0;l=e+24|0;b[h>>0]=b[249265]|0;b[h+1>>0]=b[249266]|0;b[h+2>>0]=b[249267]|0;b[h+3>>0]=b[249268]|0;b[h+4>>0]=b[249269]|0;if((f[d+12>>2]|0)==1){b[h+1>>0]=0;b[h>>0]=0}f[g>>2]=f[46760+((f[d>>2]&7)<<2)>>2];F5(j,249270,g);f[g>>2]=h;if((f[d+8>>2]|0)==1)m=1;else m=(f[c+12>>2]|0)==0&1;b[k>>0]=m;b[l>>0]=0;R9(i,249285,j,d,g,k,l,(f[d>>2]&7|0)==6?c+8|0:c+4|0);c=f[i>>2]|0;f[a>>2]=c;d=i+4|0;f[a+4>>2]=f[d>>2];a=c;if(!c){n=i;o=a}else{c=a+4|0;f[c>>2]=(f[c>>2]|0)+1;n=i;o=f[i>>2]|0}if(!o){f[n>>2]=0;f[d>>2]=0;uT(j);u=e;return}i=o+4|0;c=f[i>>2]|0;f[i>>2]=c+-1;if((c|0)!=1){f[n>>2]=0;f[d>>2]=0;uT(j);u=e;return}Yi[f[(f[o>>2]|0)+8>>2]&2047](o);f[n>>2]=0;f[d>>2]=0;uT(j);u=e;return}function R9(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;k=u;u=u+80|0;l=k+64|0;m=k+56|0;n=k;o=VDc(156)|0;f[l>>2]=0;f[l+4>>2]=0;p=Mpc(c)|0;if(p|0)dJc(tT(l,p)|0,c|0,p|0)|0;p=f[d>>2]|0;f[m>>2]=p;f[m+4>>2]=f[d+4>>2];if(p|0){d=p+-4|0;f[d>>2]=(f[d>>2]|0)+1}f[n>>2]=f[e>>2];d=n+4|0;p=e+4|0;c=f[p>>2]|0;f[d>>2]=c;q=n+8|0;f[q>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];r=n+16|0;f[r>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];s=n+36|0;t=f[e+36>>2]|0;f[s>>2]=t;v=n+40|0;f[v>>2]=q;q=n+48|0;w=n+44|0;f[w>>2]=q;f[q>>2]=0;f[n+52>>2]=0;if(!t)x=c;else{c=t+12|0;f[c>>2]=(f[c>>2]|0)+1;x=f[p>>2]|0}if((x|0)<3){x=f[e+44>>2]|0;p=f[w>>2]|0;f[p>>2]=f[x>>2];f[p+4>>2]=f[x+4>>2]}else{f[d>>2]=0;ZS(n,e)}y9(o,l,m,n,f[g>>2]|0,(b[h>>0]|0)!=0,(b[i>>0]|0)!=0,f[j>>2]|0);j=VDc(16)|0;f[j+4>>2]=1;f[j>>2]=46724;f[j+8>>2]=o;f[a>>2]=j;f[a+4>>2]=o;o=f[s>>2]|0;if(o|0?(a=o+12|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0)_S(n);f[s>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[d>>2]|0)>0){r=f[v>>2]|0;v=0;do{f[r+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[d>>2]|0))}d=f[w>>2]|0;if((d|0)==(q|0)){uT(m);uT(l);u=k;return}g0(d);uT(m);uT(l);u=k;return}function S9(a){a=a|0;YDc(a);return}function T9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function U9(a){a=a|0;YDc(a);return}function V9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+18|0;h=e+8|0;i=e;j=e+17|0;k=e+16|0;b[g>>0]=b[249265]|0;b[g+1>>0]=b[249266]|0;b[g+2>>0]=b[249267]|0;b[g+3>>0]=b[249268]|0;b[g+4>>0]=b[249269]|0;if((f[d+12>>2]|0)==1){b[g+1>>0]=0;b[g>>0]=0}f[i>>2]=g;if((f[d+8>>2]|0)==1)l=1;else l=(f[c+12>>2]|0)==0&1;b[j>>0]=l;b[k>>0]=0;x9(h,501906,517894,d,i,j,k,(f[d>>2]&7|0)==6?c+8|0:c+4|0);c=f[h>>2]|0;f[a>>2]=c;f[a+4>>2]=f[h+4>>2];a=c;if(!c){m=h;n=a}else{c=a+4|0;f[c>>2]=(f[c>>2]|0)+1;m=h;n=f[h>>2]|0}if(!n){f[m>>2]=0;u=e;return}h=n+4|0;c=f[h>>2]|0;f[h>>2]=c+-1;if((c|0)!=1){f[m>>2]=0;u=e;return}Yi[f[(f[n>>2]|0)+8>>2]&2047](n);f[m>>2]=0;u=e;return}function W9(a){a=a|0;YDc(a);return}function X9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Y9(a){a=a|0;YDc(a);return}function Z9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+48|0;g=e+34|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=e+33|0;m=e+32|0;b[g>>0]=0;b[g+1>>0]=0;b[g+2>>0]=0;b[g+3>>0]=0;b[g+4>>0]=0;f[i>>2]=0;f[i+4>>2]=0;n=d+8|0;o=f[n>>2]|0;f[j>>2]=0;f[j+4>>2]=0;if((o|0)>1){p=tT(j,1)|0;b[p>>0]=10;q=f[n>>2]|0}else q=o;f[k>>2]=g;if((q|0)==1)r=1;else r=(f[c+12>>2]|0)==0&1;b[l>>0]=r;b[m>>0]=0;_9(h,i,j,d,k,l,m,(f[d>>2]&7|0)==6?c+8|0:c+4|0);c=f[h>>2]|0;f[a>>2]=c;d=h+4|0;f[a+4>>2]=f[d>>2];a=c;if(!c){s=h;t=a}else{c=a+4|0;f[c>>2]=(f[c>>2]|0)+1;s=h;t=f[h>>2]|0}if(!t){f[s>>2]=0;f[d>>2]=0;uT(j);uT(i);u=e;return}h=t+4|0;c=f[h>>2]|0;f[h>>2]=c+-1;if((c|0)!=1){f[s>>2]=0;f[d>>2]=0;uT(j);uT(i);u=e;return}Yi[f[(f[t>>2]|0)+8>>2]&2047](t);f[s>>2]=0;f[d>>2]=0;uT(j);uT(i);u=e;return}function _9(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;k=u;u=u+80|0;l=k+64|0;m=k+56|0;n=k;o=VDc(156)|0;p=f[c>>2]|0;f[l>>2]=p;f[l+4>>2]=f[c+4>>2];if(p|0){c=p+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[d>>2]|0;f[m>>2]=c;f[m+4>>2]=f[d+4>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}f[n>>2]=f[e>>2];d=n+4|0;c=e+4|0;p=f[c>>2]|0;f[d>>2]=p;q=n+8|0;f[q>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];r=n+16|0;f[r>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];s=n+36|0;t=f[e+36>>2]|0;f[s>>2]=t;v=n+40|0;f[v>>2]=q;q=n+48|0;w=n+44|0;f[w>>2]=q;f[q>>2]=0;f[n+52>>2]=0;if(!t)x=p;else{p=t+12|0;f[p>>2]=(f[p>>2]|0)+1;x=f[c>>2]|0}if((x|0)<3){x=f[e+44>>2]|0;c=f[w>>2]|0;f[c>>2]=f[x>>2];f[c+4>>2]=f[x+4>>2]}else{f[d>>2]=0;ZS(n,e)}y9(o,l,m,n,f[g>>2]|0,(b[h>>0]|0)!=0,(b[i>>0]|0)!=0,f[j>>2]|0);j=VDc(16)|0;f[j+4>>2]=1;f[j>>2]=46724;f[j+8>>2]=o;f[a>>2]=j;f[a+4>>2]=o;o=f[s>>2]|0;if(o|0?(a=o+12|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0)_S(n);f[s>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[d>>2]|0)>0){r=f[v>>2]|0;v=0;do{f[r+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[d>>2]|0))}d=f[w>>2]|0;if((d|0)==(q|0)){uT(m);uT(l);u=k;return}g0(d);uT(m);uT(l);u=k;return}function $9(a){a=a|0;YDc(a);return}function aaa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function baa(a){a=a|0;YDc(a);return}function caa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+18|0;h=e+8|0;i=e;j=e+17|0;k=e+16|0;b[g>>0]=b[249620]|0;b[g+1>>0]=b[249621]|0;b[g+2>>0]=b[249622]|0;b[g+3>>0]=b[249623]|0;b[g+4>>0]=b[249624]|0;f[i>>2]=g;if((f[d+8>>2]|0)==1)l=1;else l=(f[c+12>>2]|0)==0&1;b[j>>0]=l;b[k>>0]=1;daa(h,1154740,1154740,d,i,j,k,(f[d>>2]&7|0)==6?c+8|0:c+4|0);c=f[h>>2]|0;f[a>>2]=c;f[a+4>>2]=f[h+4>>2];a=c;if(!c){m=h;n=a}else{c=a+4|0;f[c>>2]=(f[c>>2]|0)+1;m=h;n=f[h>>2]|0}if(!n){f[m>>2]=0;u=e;return}h=n+4|0;c=f[h>>2]|0;f[h>>2]=c+-1;if((c|0)!=1){f[m>>2]=0;u=e;return}Yi[f[(f[n>>2]|0)+8>>2]&2047](n);f[m>>2]=0;u=e;return}function daa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;k=u;u=u+80|0;l=k+64|0;m=k+56|0;n=k;o=VDc(156)|0;f[l>>2]=0;f[l+4>>2]=0;p=Mpc(c)|0;if(p|0)dJc(tT(l,p)|0,c|0,p|0)|0;f[m>>2]=0;f[m+4>>2]=0;p=Mpc(d)|0;if(p|0)dJc(tT(m,p)|0,d|0,p|0)|0;f[n>>2]=f[e>>2];p=n+4|0;d=e+4|0;c=f[d>>2]|0;f[p>>2]=c;q=n+8|0;f[q>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];r=n+16|0;f[r>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];s=n+36|0;t=f[e+36>>2]|0;f[s>>2]=t;v=n+40|0;f[v>>2]=q;q=n+48|0;w=n+44|0;f[w>>2]=q;f[q>>2]=0;f[n+52>>2]=0;if(!t)x=c;else{c=t+12|0;f[c>>2]=(f[c>>2]|0)+1;x=f[d>>2]|0}if((x|0)<3){x=f[e+44>>2]|0;d=f[w>>2]|0;f[d>>2]=f[x>>2];f[d+4>>2]=f[x+4>>2]}else{f[p>>2]=0;ZS(n,e)}y9(o,l,m,n,f[g>>2]|0,(b[h>>0]|0)!=0,(b[i>>0]|0)!=0,f[j>>2]|0);j=VDc(16)|0;f[j+4>>2]=1;f[j>>2]=46724;f[j+8>>2]=o;f[a>>2]=j;f[a+4>>2]=o;o=f[s>>2]|0;if(o|0?(a=o+12|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0)_S(n);f[s>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[p>>2]|0)>0){r=f[v>>2]|0;v=0;do{f[r+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[p>>2]|0))}p=f[w>>2]|0;if((p|0)==(q|0)){uT(m);uT(l);u=k;return}g0(p);uT(m);uT(l);u=k;return}function eaa(a){a=a|0;YDc(a);return}function faa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function gaa(a){a=a|0;YDc(a);return}function haa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+18|0;h=e+8|0;i=e;j=e+17|0;k=e+16|0;b[g>>0]=b[249620]|0;b[g+1>>0]=b[249621]|0;b[g+2>>0]=b[249622]|0;b[g+3>>0]=b[249623]|0;b[g+4>>0]=b[249624]|0;f[i>>2]=g;if((f[d+8>>2]|0)==1)l=1;else l=(f[c+12>>2]|0)==0&1;b[j>>0]=l;b[k>>0]=0;x9(h,501906,517894,d,i,j,k,(f[d>>2]&7|0)==6?c+8|0:c+4|0);c=f[h>>2]|0;f[a>>2]=c;f[a+4>>2]=f[h+4>>2];a=c;if(!c){m=h;n=a}else{c=a+4|0;f[c>>2]=(f[c>>2]|0)+1;m=h;n=f[h>>2]|0}if(!n){f[m>>2]=0;u=e;return}h=n+4|0;c=f[h>>2]|0;f[h>>2]=c+-1;if((c|0)!=1){f[m>>2]=0;u=e;return}Yi[f[(f[n>>2]|0)+8>>2]&2047](n);f[m>>2]=0;u=e;return}function iaa(){var a=0,b=0,c=0,d=0;a=(T5(S5()|0)|0)+16|0;b=f[a>>2]|0;if((b|0)>=0){c=b;d=(c|0)>0;return d|0}f[a>>2]=0;c=0;d=(c|0)>0;return d|0}function jaa(a,c){a=a|0;c=c|0;if(!c)return;jaa(a,f[c>>2]|0);jaa(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function kaa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function laa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c|0)==(a|0);b[c+12>>0]=d&1;if(d)return;else e=c;while(1){g=f[e+8>>2]|0;c=g+12|0;if(b[c>>0]|0){h=23;break}i=g+8|0;j=f[i>>2]|0;d=f[j>>2]|0;if((d|0)==(g|0)){k=f[j+4>>2]|0;if(!k){h=7;break}l=k+12|0;if(!(b[l>>0]|0))m=l;else{h=7;break}}else{if(!d){h=16;break}l=d+12|0;if(!(b[l>>0]|0))m=l;else{h=16;break}}b[c>>0]=1;c=(j|0)==(a|0);b[j+12>>0]=c&1;b[m>>0]=1;if(c){h=23;break}else e=j}if((h|0)==7){if((f[g>>2]|0)==(e|0)){n=g;o=j}else{m=g+4|0;a=f[m>>2]|0;c=f[a>>2]|0;f[m>>2]=c;if(!c)p=j;else{f[c+8>>2]=g;p=f[i>>2]|0}f[a+8>>2]=p;p=f[i>>2]|0;f[((f[p>>2]|0)==(g|0)?p:p+4|0)>>2]=a;f[a>>2]=g;f[i>>2]=a;n=a;o=f[a+8>>2]|0}b[n+12>>0]=1;b[o+12>>0]=0;n=f[o>>2]|0;a=n+4|0;p=f[a>>2]|0;f[o>>2]=p;if(p|0)f[p+8>>2]=o;p=o+8|0;f[n+8>>2]=f[p>>2];c=f[p>>2]|0;f[((f[c>>2]|0)==(o|0)?c:c+4|0)>>2]=n;f[a>>2]=o;f[p>>2]=n;return}else if((h|0)==16){if((f[g>>2]|0)==(e|0)){e=f[g>>2]|0;n=e+4|0;p=f[n>>2]|0;f[g>>2]=p;if(!p)q=j;else{f[p+8>>2]=g;q=f[i>>2]|0}f[e+8>>2]=q;q=f[i>>2]|0;f[((f[q>>2]|0)==(g|0)?q:q+4|0)>>2]=e;f[n>>2]=g;f[i>>2]=e;r=e;s=f[e+8>>2]|0}else{r=g;s=j}b[r+12>>0]=1;b[s+12>>0]=0;r=s+4|0;j=f[r>>2]|0;g=f[j>>2]|0;f[r>>2]=g;if(g|0)f[g+8>>2]=s;g=s+8|0;f[j+8>>2]=f[g>>2];r=f[g>>2]|0;f[((f[r>>2]|0)==(s|0)?r:r+4|0)>>2]=j;f[j>>2]=s;f[g>>2]=j;return}else if((h|0)==23)return}function maa(a){a=a|0;var c=0;c=f[a>>2]|0;f[a>>2]=c+-1;if((c|0)!=1)return;if((a|0)==0|(b[1149317]|0)!=0)return;c=a+4|0;if(f[c>>2]|0)f[c>>2]=0;c=f[a+12>>2]|0;if(c|0)maa(c);YDc(a);return}function naa(a){a=a|0;f[a>>2]=0;return}function oaa(a){a=a|0;var b=0;b=f[a>>2]|0;if(!b)return;maa(b);return}function paa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;YDc(d);return}function qaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return raa(a,b,c,d,-1)|0}function raa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+144|0;i=h+72|0;j=h+8|0;k=h+16|0;l=h+128|0;m=h;do if((d$(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];o=i+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[i+36>>2]=r;s=i+40|0;f[s>>2]=q;q=i+48|0;t=i+44|0;f[t>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];v=s;break}else{f[o>>2]=0;ZS(i,n);v=s;break}}else{a$(i,a,-1);v=i+40|0}while(0);a=f[v>>2]|0;s=f[a>>2]|0;f[j>>2]=f[a+4>>2];f[j+4>>2]=s;v$(c,j,e&7,-1,0,0);do if((d$(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];s=k+4|0;a=j+4|0;f[s>>2]=f[a>>2];n=k+8|0;f[n>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[k+36>>2]=o;f[k+40>>2]=n;n=k+48|0;p=k+44|0;f[p>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[a>>2]|0)<3){a=f[j+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[a>>2];f[n+4>>2]=f[a+4>>2];break}else{f[s>>2]=0;ZS(k,j);break}}else a$(k,c,-1);while(0);switch(e|0){case 4:case 2:break;default:{f[m>>2]=0;f[m+4>>2]=0;e=tT(m,37)|0;c=249748;j=e+37|0;do{b[e>>0]=b[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(j|0));taa(-210,m,249786,4004)}}m=saa(i,k,d,g,l)|0;l=k+36|0;g=f[l>>2]|0;if(g|0?(d=g+12|0,g=f[d>>2]|0,f[d>>2]=g+-1,(g|0)==1):0)_S(k);f[l>>2]=0;l=k+16|0;g=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[g>>2]|0)>0){l=f[k+40>>2]|0;d=0;do{f[l+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[g>>2]|0))}g=f[k+44>>2]|0;if((g|0)!=(k+48|0))g0(g);g=i+36|0;k=f[g>>2]|0;if(k|0?(d=k+12|0,k=f[d>>2]|0,f[d>>2]=k+-1,(k|0)==1):0)_S(i);f[g>>2]=0;g=i+16|0;k=i+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[k>>2]|0)>0){g=f[v>>2]|0;v=0;do{f[g+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)==(i+48|0)){u=h;return m|0}g0(k);u=h;return m|0}function saa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;i=h;j=h+13|0;k=h+12|0;l=h+11|0;m=h+10|0;n=h+9|0;o=h+8|0;p=f[c>>2]|0;if(p&4088|0){f[i>>2]=0;q=i+4|0;f[q>>2]=0;r=tT(i,38)|0;s=r;t=249887;v=s+38|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3927)}w=f[a>>2]|0;if(w&4088|0){f[i>>2]=0;q=i+4|0;f[q>>2]=0;r=tT(i,38)|0;s=r;t=249887;v=s+38|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3927)}r=(d|0)==8;q=(d|0)==4;switch(d|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;s=tT(i,38)|0;t=256198;v=s+38|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3928)}}x=(e|0)==1;y=(e|0)==0;z=(e|0)==-1;switch(e|0){case 0:case 1:case -1:break;default:{f[i>>2]=0;f[i+4>>2]=0;s=tT(i,67)|0;t=249951;v=s+67|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3929)}}e=p&7;A=B8()|0;B=z8()|0;if((w&6|1|0)!=1){f[i>>2]=0;f[i+4>>2]=0;s=tT(i,34)|0;t=250019;v=s+34|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3936)}if((A|0)!=0&(B|0)>1)C=((f[c+8>>2]|0)/(B|0)|0|0)>1;else C=0;B=(e|0)==0;a:do if(q|y){if(!B){switch(p&7){case 2:{D=(uaa(j,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=waa(l,a,c,d,g)|0;u=h;return D|0}else{D=vaa(k,a,c,d,g)|0;u=h;return D|0}}}else if(!(B|r&(x|z)^1)){switch(p&7){case 2:{D=(xaa(m,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=zaa(o,a,c,d,g)|0;u=h;return D|0}else{D=yaa(n,a,c,d,g)|0;u=h;return D|0}}while(0);f[i>>2]=0;f[i+4>>2]=0;s=tT(i,28)|0;t=250054;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-210,i,249926,3982);return 0}function taa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,249806,d);return}function uaa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;h=u;u=u+16|0;a=h;i=f[e+8>>2]|0;if((i|0)!=(f[c+8>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;k=tT(a,26)|0;l=250548;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));taa(-215,a,518189,656)}n=f[e+12>>2]|0;if((n|0)!=(f[c+12>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;k=tT(a,26)|0;l=250575;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));taa(-215,a,518189,657)}switch(g|0){case 4:case 8:break;default:{f[a>>2]=0;f[a+4>>2]=0;k=tT(a,38)|0;l=256198;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));taa(-215,a,518189,658)}}a=f0((Y(n,i)|0)+3&-2)|0;d[a>>1]=0;l=(i|0)>0;if((g|0)==8){if(!l){o=1;g0(a);u=h;return o|0}g=(n|0)>0;k=n+-1|0;m=f[c+16>>2]|0;p=f[f[c+44>>2]>>2]|0;q=f[e+16>>2]|0;r=f[f[e+44>>2]>>2]|0;s=0-p|0;t=0-r|0;v=1;w=0;while(1){x=m+(Y(p,w)|0)|0;y=x+s|0;z=q+(Y(r,w)|0)|0;A=z+t|0;if(g){B=(w|0)>0;C=0;D=v;while(1){a:do if(!(b[x+C>>0]|0)){d[z+(C<<1)>>1]=0;E=D}else{if(B){if(b[y+C>>0]|0){d[z+(C<<1)>>1]=d[A+(C<<1)>>1]|0;E=D;break}F=(C|0)>0;if((C|0)<(k|0)?(G=C+1|0,b[y+G>>0]|0):0){H=d[A+(G<<1)>>1]|0;do if(F){G=C+-1|0;if(!(b[y+G>>0]|0)){I=C+-1|0;if(!(b[x+I>>0]|0)){J=H;break}K=d[z+(I<<1)>>1]|0;I=K;while(1){L=d[a+((I&65535)<<1)>>1]|0;if((L&65535)<(I&65535))I=L;else break}if(K<<16>>16==H<<16>>16)M=I;else{L=H;while(1){N=d[a+((L&65535)<<1)>>1]|0;if((N&65535)<(L&65535))L=N;else break}N=(I&65535)>(L&65535)?L:I;O=H;do{P=a+((O&65535)<<1)|0;Q=O;O=d[P>>1]|0;d[P>>1]=N}while((O&65535)<(Q&65535));M=N}N=K;do{O=a+((N&65535)<<1)|0;I=N;N=d[O>>1]|0;d[O>>1]=M}while((N&65535)<(I&65535));J=M}else{N=d[A+(G<<1)>>1]|0;K=N;while(1){I=d[a+((K&65535)<<1)>>1]|0;if((I&65535)<(K&65535))K=I;else break}if(N<<16>>16==H<<16>>16)R=K;else{G=H;while(1){I=d[a+((G&65535)<<1)>>1]|0;if((I&65535)<(G&65535))G=I;else break}I=(K&65535)>(G&65535)?G:K;O=H;do{L=a+((O&65535)<<1)|0;Q=O;O=d[L>>1]|0;d[L>>1]=I}while((O&65535)<(Q&65535));R=I}I=N;do{O=a+((I&65535)<<1)|0;K=I;I=d[O>>1]|0;d[O>>1]=R}while((I&65535)<(K&65535));d[z+(C<<1)>>1]=R;E=D;break a}}else J=H;while(0);d[z+(C<<1)>>1]=J;E=D;break}if(F){H=C+-1|0;if(!(b[y+H>>0]|0))S=46;else{d[z+(C<<1)>>1]=d[A+(H<<1)>>1]|0;E=D;break}}}else if((C|0)>0)S=46;if((S|0)==46?(S=0,H=C+-1|0,b[x+H>>0]|0):0){d[z+(C<<1)>>1]=d[z+(H<<1)>>1]|0;E=D;break}d[z+(C<<1)>>1]=D;H=D&65535;d[a+(H<<1)>>1]=D;E=H+1&65535}while(0);C=C+1|0;if((C|0)==(n|0)){T=E;break}else D=E}}else T=v;w=w+1|0;if((w|0)==(i|0)){U=T;break}else v=T}}else{if(!l){o=1;g0(a);u=h;return o|0}T=(n|0)>0;v=f[c+16>>2]|0;w=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;E=f[f[e+44>>2]>>2]|0;S=0-w|0;J=0-E|0;R=0;M=1;while(1){k=v+(Y(w,R)|0)|0;g=k+S|0;t=c+(Y(E,R)|0)|0;r=t+J|0;b:do if(T){if((R|0)>0){V=0;W=M}else{q=0;s=M;while(1){do if(!(b[k+q>>0]|0)){d[t+(q<<1)>>1]=0;X=s}else{if((q|0)>0?(p=q+-1|0,b[k+p>>0]|0):0){d[t+(q<<1)>>1]=d[t+(p<<1)>>1]|0;X=s;break}d[t+(q<<1)>>1]=s;p=s&65535;d[a+(p<<1)>>1]=s;X=p+1&65535}while(0);q=q+1|0;if((q|0)==(n|0)){Z=X;break b}else s=X}}while(1){do if(!(b[k+V>>0]|0)){d[t+(V<<1)>>1]=0;_=W}else{s=(V|0)>0;if(!(b[g+V>>0]|0)){if(s?(q=V+-1|0,b[k+q>>0]|0):0){d[t+(V<<1)>>1]=d[t+(q<<1)>>1]|0;_=W;break}d[t+(V<<1)>>1]=W;q=W&65535;d[a+(q<<1)>>1]=W;_=q+1&65535;break}q=d[r+(V<<1)>>1]|0;if(s?(s=V+-1|0,(b[k+s>>0]|0)!=0):0){F=d[t+(s<<1)>>1]|0;s=F;while(1){p=d[a+((s&65535)<<1)>>1]|0;if((p&65535)<(s&65535))s=p;else break}if(F<<16>>16==q<<16>>16)$=s;else{p=q;while(1){m=d[a+((p&65535)<<1)>>1]|0;if((m&65535)<(p&65535))p=m;else break}m=(s&65535)>(p&65535)?p:s;D=q;do{C=a+((D&65535)<<1)|0;z=D;D=d[C>>1]|0;d[C>>1]=m}while((D&65535)<(z&65535));$=m}m=F;do{D=a+((m&65535)<<1)|0;s=m;m=d[D>>1]|0;d[D>>1]=$}while((m&65535)<(s&65535));aa=$}else aa=q;d[t+(V<<1)>>1]=aa;_=W}while(0);V=V+1|0;if((V|0)==(n|0)){Z=_;break}else W=_}}else Z=M;while(0);R=R+1|0;if((R|0)==(i|0)){U=Z;break}else M=Z}}if((U&65535)>1){Z=U&65535;U=1;M=1;while(1){R=a+(M<<1)|0;_=j[R>>1]|0;if(_>>>0<M>>>0){d[R>>1]=d[a+(_<<1)>>1]|0;ba=U}else{d[R>>1]=U;ba=(U&65535)+1&65535}M=M+1|0;if((M|0)==(Z|0)){ca=ba;break}else U=ba}}else ca=1;if(!l){o=ca;g0(a);u=h;return o|0}l=f[e+16>>2]|0;ba=f[f[e+44>>2]>>2]|0;e=0;do{U=l+(Y(ba,e)|0)|0;Z=U+(n<<1)|0;if((U|0)!=(Z|0)){M=U;do{d[M>>1]=d[a+(j[M>>1]<<1)>>1]|0;M=M+2|0}while((M|0)!=(Z|0))}e=e+1|0}while((e|0)!=(i|0));o=ca;g0(a);u=h;return o|0}function vaa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;g=u;u=u+16|0;a=g;h=f[d+8>>2]|0;if((h|0)!=(f[c+8>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;i=tT(a,26)|0;j=250548;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));taa(-215,a,518189,656)}l=f[d+12>>2]|0;if((l|0)!=(f[c+12>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;i=tT(a,26)|0;j=250575;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));taa(-215,a,518189,657)}switch(e|0){case 4:case 8:break;default:{f[a>>2]=0;f[a+4>>2]=0;i=tT(a,38)|0;j=256198;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));taa(-215,a,518189,658)}}a=f0((((Y(l,h)|0)+1|0)>>>1<<2)+4|0)|0;f[a>>2]=0;j=(h|0)>0;if((e|0)==8){if(!j){m=1;g0(a);u=g;return m|0}e=(l|0)>0;i=l+-1|0;k=f[c+16>>2]|0;n=f[c+44>>2]|0;o=f[d+16>>2]|0;p=f[d+44>>2]|0;q=1;r=0;while(1){s=f[n>>2]|0;t=k+(Y(s,r)|0)|0;v=t+(0-s)|0;s=f[p>>2]|0;w=o+(Y(s,r)|0)|0;x=w+(0-s)|0;if(e){s=(r|0)>0;y=0;z=q;while(1){a:do if(!(b[t+y>>0]|0)){f[w+(y<<2)>>2]=0;A=z}else{if(s){if(b[v+y>>0]|0){f[w+(y<<2)>>2]=f[x+(y<<2)>>2];A=z;break}B=(y|0)>0;if((y|0)<(i|0)?(C=y+1|0,b[v+C>>0]|0):0){D=f[x+(C<<2)>>2]|0;do if(B){C=y+-1|0;if(!(b[v+C>>0]|0)){E=y+-1|0;if(!(b[t+E>>0]|0)){F=D;break}G=f[w+(E<<2)>>2]|0;E=G;while(1){H=f[a+(E<<2)>>2]|0;if((H|0)<(E|0))E=H;else break}if((G|0)==(D|0))I=E;else{H=D;while(1){J=f[a+(H<<2)>>2]|0;if((J|0)<(H|0))H=J;else break}J=(E|0)>(H|0)?H:E;K=D;do{L=a+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=J}while((K|0)<(M|0));I=J}J=G;do{K=a+(J<<2)|0;E=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(E|0));F=I}else{J=f[x+(C<<2)>>2]|0;G=J;while(1){E=f[a+(G<<2)>>2]|0;if((E|0)<(G|0))G=E;else break}if((J|0)==(D|0))N=G;else{C=D;while(1){E=f[a+(C<<2)>>2]|0;if((E|0)<(C|0))C=E;else break}E=(G|0)>(C|0)?C:G;K=D;do{H=a+(K<<2)|0;M=K;K=f[H>>2]|0;f[H>>2]=E}while((K|0)<(M|0));N=E}E=J;do{K=a+(E<<2)|0;G=E;E=f[K>>2]|0;f[K>>2]=N}while((E|0)<(G|0));f[w+(y<<2)>>2]=N;A=z;break a}}else F=D;while(0);f[w+(y<<2)>>2]=F;A=z;break}if(B){D=y+-1|0;if(!(b[v+D>>0]|0))O=46;else{f[w+(y<<2)>>2]=f[x+(D<<2)>>2];A=z;break}}}else if((y|0)>0)O=46;if((O|0)==46?(O=0,D=y+-1|0,b[t+D>>0]|0):0){f[w+(y<<2)>>2]=f[w+(D<<2)>>2];A=z;break}f[w+(y<<2)>>2]=z;f[a+(z<<2)>>2]=z;A=z+1|0}while(0);y=y+1|0;if((y|0)==(l|0)){P=A;break}else z=A}}else P=q;r=r+1|0;if((r|0)==(h|0)){Q=P;break}else q=P}}else{if(!j){m=1;g0(a);u=g;return m|0}P=(l|0)>0;q=f[c+16>>2]|0;r=f[c+44>>2]|0;c=f[d+16>>2]|0;A=f[d+44>>2]|0;O=0;F=1;while(1){N=f[r>>2]|0;I=q+(Y(N,O)|0)|0;i=I+(0-N)|0;N=f[A>>2]|0;e=c+(Y(N,O)|0)|0;o=e+(0-N)|0;b:do if(P){if((O|0)>0){R=0;S=F}else{N=0;p=F;while(1){do if(!(b[I+N>>0]|0)){f[e+(N<<2)>>2]=0;T=p}else{if((N|0)>0?(k=N+-1|0,b[I+k>>0]|0):0){f[e+(N<<2)>>2]=f[e+(k<<2)>>2];T=p;break}f[e+(N<<2)>>2]=p;f[a+(p<<2)>>2]=p;T=p+1|0}while(0);N=N+1|0;if((N|0)==(l|0)){U=T;break b}else p=T}}while(1){do if(!(b[I+R>>0]|0)){f[e+(R<<2)>>2]=0;V=S}else{p=(R|0)>0;if(!(b[i+R>>0]|0)){if(p?(N=R+-1|0,b[I+N>>0]|0):0){f[e+(R<<2)>>2]=f[e+(N<<2)>>2];V=S;break}f[e+(R<<2)>>2]=S;f[a+(S<<2)>>2]=S;V=S+1|0;break}N=f[o+(R<<2)>>2]|0;if(p?(p=R+-1|0,(b[I+p>>0]|0)!=0):0){B=f[e+(p<<2)>>2]|0;p=B;while(1){k=f[a+(p<<2)>>2]|0;if((k|0)<(p|0))p=k;else break}if((B|0)==(N|0))W=p;else{k=N;while(1){n=f[a+(k<<2)>>2]|0;if((n|0)<(k|0))k=n;else break}n=(p|0)>(k|0)?k:p;z=N;do{y=a+(z<<2)|0;w=z;z=f[y>>2]|0;f[y>>2]=n}while((z|0)<(w|0));W=n}n=B;do{z=a+(n<<2)|0;p=n;n=f[z>>2]|0;f[z>>2]=W}while((n|0)<(p|0));X=W}else X=N;f[e+(R<<2)>>2]=X;V=S}while(0);R=R+1|0;if((R|0)==(l|0)){U=V;break}else S=V}}else U=F;while(0);O=O+1|0;if((O|0)==(h|0)){Q=U;break}else F=U}}if((Q|0)>1){U=1;F=1;while(1){O=a+(F<<2)|0;V=f[O>>2]|0;if((V|0)<(F|0)){f[O>>2]=f[a+(V<<2)>>2];Z=U}else{f[O>>2]=U;Z=U+1|0}F=F+1|0;if((F|0)==(Q|0)){_=Z;break}else U=Z}}else _=1;if(!j){m=_;g0(a);u=g;return m|0}j=f[d+16>>2]|0;Z=f[d+44>>2]|0;d=0;do{U=j+(Y(f[Z>>2]|0,d)|0)|0;Q=U+(l<<2)|0;if((U|0)!=(Q|0)){F=U;do{f[F>>2]=f[a+(f[F>>2]<<2)>>2];F=F+4|0}while((F|0)!=(Q|0))}d=d+1|0}while((d|0)!=(h|0));m=_;g0(a);u=g;return m|0}function waa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+48|0;h=a+32|0;i=a+24|0;j=a;k=f[c+8>>2]|0;l=d+8|0;if((k|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,26)|0;n=250083;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,578)}p=f[c+12>>2]|0;q=d+12|0;if((p|0)!=(f[q>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,26)|0;n=250110;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,579)}switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;m=tT(h,38)|0;n=256198;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,580)}}n=((Y(p,k)|0)+1|0)>>>1;m=f0(k<<2)|0;o=f0((n<<2)+4|0)|0;f[o>>2]=0;f[h>>2]=0;f[h+4>>2]=k;n=(k|0)/2|0;r=(z8()|0)<<2;s=(r|0)<(n|0)?r:n;t=+(((s|0)>1?s:1)|0);f[i>>2]=1;if((e|0)==8){f[j>>2]=46840;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=o;f[j+16>>2]=m;y8(h,j,t);Faa(d,o,m);if((k|0)>0){e=(p+1|0)/2|0;s=0;do{n=s+1|0;r=(Y((n|0)/2|0,e)|0)+1|0;v=f[m+(n<<2)>>2]|0;n=v+r|0;if((v|0)>0){v=r;do{r=o+(v<<2)|0;w=f[r>>2]|0;if((w|0)<(v|0))f[r>>2]=f[o+(w<<2)>>2];else{f[r>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}v=v+1|0}while((v|0)<(n|0))}s=f[m+(s<<2)>>2]|0}while((s|0)<(k|0))}}else{f[j>>2]=46860;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=o;f[j+16>>2]=m;y8(h,j,t);c=f[q>>2]|0;q=f[l>>2]|0;l=f[m>>2]|0;a:do if((l|0)<(q|0)){s=f[d+16>>2]|0;e=f[d+44>>2]|0;if((c|0)>0)x=l;else{n=l;while(1){n=f[m+(n<<2)>>2]|0;if((n|0)>=(q|0))break a}}do{n=f[e>>2]|0;v=s+(Y(n,x)|0)|0;r=v+(0-n)|0;n=0;do{w=v+(n<<2)|0;y=f[w>>2]|0;if((y|0)>0?(z=f[r+(n<<2)>>2]|0,(z|0)>0):0){A=z;while(1){B=f[o+(A<<2)>>2]|0;if((B|0)<(A|0))A=B;else break}if((z|0)==(y|0))C=A;else{B=y;while(1){D=f[o+(B<<2)>>2]|0;if((D|0)<(B|0))B=D;else break}D=(A|0)>(B|0)?B:A;E=y;do{F=o+(E<<2)|0;G=E;E=f[F>>2]|0;f[F>>2]=D}while((E|0)<(G|0));C=D}D=z;do{E=o+(D<<2)|0;y=D;D=f[E>>2]|0;f[E>>2]=C}while((D|0)<(y|0));f[w>>2]=C}n=n+1|0}while((n|0)!=(c|0));x=f[m+(x<<2)>>2]|0}while((x|0)<(q|0))}while(0);if((k|0)>0){q=0;do{x=(((Y(q,p)|0)+1|0)/2|0)+1|0;c=f[m+(q+1<<2)>>2]|0;C=c+x|0;if((c|0)>0){c=x;do{x=o+(c<<2)|0;l=f[x>>2]|0;if((l|0)<(c|0))f[x>>2]=f[o+(l<<2)>>2];else{f[x>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}c=c+1|0}while((c|0)<(C|0))}q=f[m+(q<<2)>>2]|0}while((q|0)<(k|0))}}q=XDc((k|0)>-1?k:-1)|0;f[j>>2]=46880;f[j+4>>2]=d;f[j+8>>2]=o;f[j+12>>2]=g;f[j+16>>2]=q;f[j+20>>2]=i;y8(h,j,t);ZDc(q);g0(m);g0(o);u=a;return f[i>>2]|0}function xaa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;h=u;u=u+16|0;a=h;i=f[c+8>>2]|0;k=e+8|0;if((i|0)!=(f[k>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;l=tT(a,26)|0;m=250083;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,a,518189,2589)}o=f[c+12>>2]|0;p=e+12|0;if((o|0)!=(f[p>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;l=tT(a,26)|0;m=250110;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,a,518189,2590)}if((g|0)!=8){f[a>>2]=0;f[a+4>>2]=0;l=tT(a,17)|0;m=250137;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,a,518189,2591)}a=f0((Y(((i+1|0)/2|0)<<1,(o+1|0)/2|0)|0)+2|0)|0;d[a>>1]=0;if((i|0)>0){m=c+16|0;l=c+44|0;n=e+16|0;g=e+44|0;q=(o|0)>0;r=1;s=0;while(1){t=f[f[l>>2]>>2]|0;v=(f[m>>2]|0)+(Y(t,s)|0)|0;w=0-t|0;x=v+w|0;y=x+w|0;w=v+t|0;t=f[f[g>>2]>>2]|0;z=(f[n>>2]|0)+(Y(t,s)|0)|0;A=0-t|0;t=z+A+A|0;if(q){A=(s|1|0)<(i|0);B=(s|0)>0;C=B^1;D=(s+-2|0)>-1;E=0;F=r;while(1){a:do if(!(b[v+E>>0]|0)){G=E|1;H=(G|0)<(o|0);if(A?b[w+E>>0]|0:0){I=E+-1|0;J=(E|0)>0;if(H?b[v+G>>0]|0:0){do if(J){if(b[v+I>>0]|0){do if(B){if(b[x+G>>0]|0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;L=E+-2|0;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}do if((L|0)>-1){if(!(b[x+L>>0]|0))break;if(b[y+I>>0]|0){d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}M=d[t+(E<<1)>>1]|0;N=d[z+(L<<1)>>1]|0;O=M;while(1){P=d[a+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(M<<16>>16==N<<16>>16)Q=O;else{P=N;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;S=N;do{T=a+((S&65535)<<1)|0;U=S;S=d[T>>1]|0;d[T>>1]=R}while((S&65535)<(U&65535));Q=R}R=M;do{S=a+((R&65535)<<1)|0;N=R;R=d[S>>1]|0;d[S>>1]=Q}while((R&65535)<(N&65535));d[z+(E<<1)>>1]=Q;K=F;break a}while(0);R=d[t+(E<<1)>>1]|0;M=d[z+(L<<1)>>1]|0;N=R;while(1){S=d[a+((N&65535)<<1)>>1]|0;if((S&65535)<(N&65535))N=S;else break}if(R<<16>>16==M<<16>>16)V=N;else{L=M;while(1){S=d[a+((L&65535)<<1)>>1]|0;if((S&65535)<(L&65535))L=S;else break}S=(N&65535)>(L&65535)?L:N;O=M;do{P=a+((O&65535)<<1)|0;U=O;O=d[P>>1]|0;d[P>>1]=S}while((O&65535)<(U&65535));V=S}S=R;do{O=a+((S&65535)<<1)|0;M=S;S=d[O>>1]|0;d[O>>1]=V}while((S&65535)<(M&65535));d[z+(E<<1)>>1]=V;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;R=d[z+(E+-2<<1)>>1]|0;M=S;while(1){O=d[a+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}if(S<<16>>16==R<<16>>16)W=M;else{O=R;while(1){N=d[a+((O&65535)<<1)>>1]|0;if((N&65535)<(O&65535))O=N;else break}N=(M&65535)>(O&65535)?O:M;L=R;do{U=a+((L&65535)<<1)|0;P=L;L=d[U>>1]|0;d[U>>1]=N}while((L&65535)<(P&65535));W=N}N=S;do{L=a+((N&65535)<<1)|0;R=N;N=d[L>>1]|0;d[L>>1]=W}while((N&65535)<(R&65535));d[z+(E<<1)>>1]=W;K=F;break a}N=E+2|0;if((N|0)>=(o|0))break;if(!(b[x+N>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[y+E>>0]|0)){S=d[t+(N<<1)>>1]|0;R=d[z+(E+-2<<1)>>1]|0;L=S;while(1){M=d[a+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(S<<16>>16==R<<16>>16)X=L;else{M=R;while(1){O=d[a+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}O=(L&65535)>(M&65535)?M:L;P=R;do{U=a+((P&65535)<<1)|0;T=P;P=d[U>>1]|0;d[U>>1]=O}while((P&65535)<(T&65535));X=O}O=S;do{P=a+((O&65535)<<1)|0;R=O;O=d[P>>1]|0;d[P>>1]=X}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=X;K=F;break a}O=E+-2|0;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(b[y+I>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}S=d[t+(N<<1)>>1]|0;R=d[z+(O<<1)>>1]|0;P=S;while(1){L=d[a+((P&65535)<<1)>>1]|0;if((L&65535)<(P&65535))P=L;else break}if(S<<16>>16==R<<16>>16)Z=P;else{L=R;while(1){M=d[a+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}M=(P&65535)>(L&65535)?L:P;T=R;do{U=a+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(_&65535));Z=M}M=S;do{T=a+((M&65535)<<1)|0;R=M;M=d[T>>1]|0;d[T>>1]=Z}while((M&65535)<(R&65535));d[z+(E<<1)>>1]=Z;K=F;break a}while(0);M=d[t+(N<<1)>>1]|0;S=d[z+(O<<1)>>1]|0;R=M;while(1){T=d[a+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}if(M<<16>>16==S<<16>>16)$=R;else{O=S;while(1){T=d[a+((O&65535)<<1)>>1]|0;if((T&65535)<(O&65535))O=T;else break}T=(R&65535)>(O&65535)?O:R;P=S;do{L=a+((P&65535)<<1)|0;_=P;P=d[L>>1]|0;d[L>>1]=T}while((P&65535)<(_&65535));$=T}T=M;do{P=a+((T&65535)<<1)|0;S=T;T=d[P>>1]|0;d[P>>1]=$}while((T&65535)<(S&65535));d[z+(E<<1)>>1]=$;K=F;break a}while(0);T=d[t+(N<<1)>>1]|0;M=d[z+(E+-2<<1)>>1]|0;S=T;while(1){P=d[a+((S&65535)<<1)>>1]|0;if((P&65535)<(S&65535))S=P;else break}if(T<<16>>16==M<<16>>16)aa=S;else{N=M;while(1){P=d[a+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}P=(S&65535)>(N&65535)?N:S;R=M;do{O=a+((R&65535)<<1)|0;_=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(_&65535));aa=P}P=T;do{R=a+((P&65535)<<1)|0;M=P;P=d[R>>1]|0;d[R>>1]=aa}while((P&65535)<(M&65535));d[z+(E<<1)>>1]=aa;K=F;break a}while(0);d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[w+I>>0]|0))break;do if(B){if(b[x+G>>0]|0){P=E+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[x+I>>0]|0){T=d[z+(P<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=T;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;R=M;while(1){S=d[a+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}if(M<<16>>16==T<<16>>16)ba=R;else{S=T;while(1){N=d[a+((S&65535)<<1)>>1]|0;if((N&65535)<(S&65535))S=N;else break}N=(R&65535)>(S&65535)?S:R;_=T;do{O=a+((_&65535)<<1)|0;L=_;_=d[O>>1]|0;d[O>>1]=N}while((_&65535)<(L&65535));ba=N}N=M;do{_=a+((N&65535)<<1)|0;T=N;N=d[_>>1]|0;d[_>>1]=ba}while((N&65535)<(T&65535));d[z+(E<<1)>>1]=ba;K=F;break a}if(!(b[x+P>>0]|0)){N=d[t+(E<<1)>>1]|0;M=d[z+(P<<1)>>1]|0;T=N;while(1){_=d[a+((T&65535)<<1)>>1]|0;if((_&65535)<(T&65535))T=_;else break}if(N<<16>>16==M<<16>>16)ca=T;else{_=M;while(1){R=d[a+((_&65535)<<1)>>1]|0;if((R&65535)<(_&65535))_=R;else break}R=(T&65535)>(_&65535)?_:T;S=M;do{L=a+((S&65535)<<1)|0;O=S;S=d[L>>1]|0;d[L>>1]=R}while((S&65535)<(O&65535));ca=R}R=N;do{S=a+((R&65535)<<1)|0;M=R;R=d[S>>1]|0;d[S>>1]=ca}while((R&65535)<(M&65535));d[z+(E<<1)>>1]=ca;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;R=d[z+(P<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=R;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=R;K=F;break a}N=d[t+(E<<1)>>1]|0;M=N;while(1){S=d[a+((M&65535)<<1)>>1]|0;if((S&65535)<(M&65535))M=S;else break}if(N<<16>>16==R<<16>>16)da=M;else{S=R;while(1){T=d[a+((S&65535)<<1)>>1]|0;if((T&65535)<(S&65535))S=T;else break}T=(M&65535)>(S&65535)?S:M;_=R;do{O=a+((_&65535)<<1)|0;L=_;_=d[O>>1]|0;d[O>>1]=T}while((_&65535)<(L&65535));da=T}T=N;do{_=a+((T&65535)<<1)|0;R=T;T=d[_>>1]|0;d[_>>1]=da}while((T&65535)<(R&65535));d[z+(E<<1)>>1]=da;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;R=T;while(1){_=d[a+((R&65535)<<1)>>1]|0;if((_&65535)<(R&65535))R=_;else break}if(T<<16>>16==N<<16>>16)ea=R;else{_=N;while(1){M=d[a+((_&65535)<<1)>>1]|0;if((M&65535)<(_&65535))_=M;else break}M=(R&65535)>(_&65535)?_:R;S=N;do{L=a+((S&65535)<<1)|0;O=S;S=d[L>>1]|0;d[L>>1]=M}while((S&65535)<(O&65535));ea=M}M=T;do{S=a+((M&65535)<<1)|0;N=M;M=d[S>>1]|0;d[S>>1]=ea}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=ea;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;T=d[z+(P<<1)>>1]|0;N=M;while(1){S=d[a+((N&65535)<<1)>>1]|0;if((S&65535)<(N&65535))N=S;else break}if(M<<16>>16==T<<16>>16)fa=N;else{P=T;while(1){S=d[a+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(N&65535)>(P&65535)?P:N;R=T;do{_=a+((R&65535)<<1)|0;O=R;R=d[_>>1]|0;d[_>>1]=S}while((R&65535)<(O&65535));fa=S}S=M;do{R=a+((S&65535)<<1)|0;T=S;S=d[R>>1]|0;d[R>>1]=fa}while((S&65535)<(T&65535));d[z+(E<<1)>>1]=fa;K=F;break a}S=E+2|0;do if(!((S|0)>=(o|0)|C)){if(!(b[x+S>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;M=E+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[x+I>>0]|0){T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}R=d[t+(S<<1)>>1]|0;N=R;while(1){P=d[a+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}if(R<<16>>16==T<<16>>16)ga=N;else{P=T;while(1){O=d[a+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(N&65535)>(P&65535)?P:N;_=T;do{L=a+((_&65535)<<1)|0;U=_;_=d[L>>1]|0;d[L>>1]=O}while((_&65535)<(U&65535));ga=O}O=R;do{_=a+((O&65535)<<1)|0;T=O;O=d[_>>1]|0;d[_>>1]=ga}while((O&65535)<(T&65535));d[z+(E<<1)>>1]=ga;K=F;break a}if(!(b[x+M>>0]|0)){O=d[t+(S<<1)>>1]|0;R=d[z+(M<<1)>>1]|0;T=O;while(1){_=d[a+((T&65535)<<1)>>1]|0;if((_&65535)<(T&65535))T=_;else break}if(O<<16>>16==R<<16>>16)ha=T;else{_=R;while(1){N=d[a+((_&65535)<<1)>>1]|0;if((N&65535)<(_&65535))_=N;else break}N=(T&65535)>(_&65535)?_:T;P=R;do{U=a+((P&65535)<<1)|0;L=P;P=d[U>>1]|0;d[U>>1]=N}while((P&65535)<(L&65535));ha=N}N=O;do{P=a+((N&65535)<<1)|0;R=N;N=d[P>>1]|0;d[P>>1]=ha}while((N&65535)<(R&65535));d[z+(E<<1)>>1]=ha;K=F;break a}if(!(b[y+I>>0]|0)){N=d[t+(S<<1)>>1]|0;O=d[z+(M<<1)>>1]|0;R=N;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}if(N<<16>>16==O<<16>>16)ia=R;else{P=O;while(1){T=d[a+((P&65535)<<1)>>1]|0;if((T&65535)<(P&65535))P=T;else break}T=(R&65535)>(P&65535)?P:R;_=O;do{L=a+((_&65535)<<1)|0;U=_;_=d[L>>1]|0;d[L>>1]=T}while((_&65535)<(U&65535));ia=T}T=N;do{_=a+((T&65535)<<1)|0;O=T;T=d[_>>1]|0;d[_>>1]=ia}while((T&65535)<(O&65535));d[z+(E<<1)>>1]=ia;K=F;break a}T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}N=d[t+(S<<1)>>1]|0;O=N;while(1){_=d[a+((O&65535)<<1)>>1]|0;if((_&65535)<(O&65535))O=_;else break}if(N<<16>>16==T<<16>>16)ja=O;else{_=T;while(1){R=d[a+((_&65535)<<1)>>1]|0;if((R&65535)<(_&65535))_=R;else break}R=(O&65535)>(_&65535)?_:O;P=T;do{U=a+((P&65535)<<1)|0;L=P;P=d[U>>1]|0;d[U>>1]=R}while((P&65535)<(L&65535));ja=R}R=N;do{P=a+((R&65535)<<1)|0;T=R;R=d[P>>1]|0;d[P>>1]=ja}while((R&65535)<(T&65535));d[z+(E<<1)>>1]=ja;K=F;break a}while(0);R=d[t+(S<<1)>>1]|0;N=d[z+(M<<1)>>1]|0;T=R;while(1){P=d[a+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}if(R<<16>>16==N<<16>>16)ka=T;else{M=N;while(1){P=d[a+((M&65535)<<1)>>1]|0;if((P&65535)<(M&65535))M=P;else break}P=(T&65535)>(M&65535)?M:T;O=N;do{_=a+((O&65535)<<1)|0;L=O;O=d[_>>1]|0;d[_>>1]=P}while((O&65535)<(L&65535));ka=P}P=R;do{O=a+((P&65535)<<1)|0;N=P;P=d[O>>1]|0;d[O>>1]=ka}while((P&65535)<(N&65535));d[z+(E<<1)>>1]=ka;K=F;break a}while(0);P=E+-2|0;if(!(b[x+E>>0]|0)){R=d[t+(S<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;O=R;while(1){T=d[a+((O&65535)<<1)>>1]|0;if((T&65535)<(O&65535))O=T;else break}if(R<<16>>16==N<<16>>16)la=O;else{T=N;while(1){M=d[a+((T&65535)<<1)>>1]|0;if((M&65535)<(T&65535))T=M;else break}M=(O&65535)>(T&65535)?T:O;L=N;do{_=a+((L&65535)<<1)|0;U=L;L=d[_>>1]|0;d[_>>1]=M}while((L&65535)<(U&65535));la=M}M=R;do{L=a+((M&65535)<<1)|0;N=M;M=d[L>>1]|0;d[L>>1]=la}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=la;K=F;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[x+I>>0]|0){M=d[t+(S<<1)>>1]|0;R=d[z+(P<<1)>>1]|0;N=M;while(1){L=d[a+((N&65535)<<1)>>1]|0;if((L&65535)<(N&65535))N=L;else break}if(M<<16>>16==R<<16>>16)ma=N;else{L=R;while(1){O=d[a+((L&65535)<<1)>>1]|0;if((O&65535)<(L&65535))L=O;else break}O=(N&65535)>(L&65535)?L:N;T=R;do{U=a+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=O}while((T&65535)<(_&65535));ma=O}O=M;do{T=a+((O&65535)<<1)|0;R=O;O=d[T>>1]|0;d[T>>1]=ma}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=ma;K=F;break a}if(!(b[x+P>>0]|0)){O=d[t+(E<<1)>>1]|0;M=d[t+(S<<1)>>1]|0;R=O;while(1){T=d[a+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}if(O<<16>>16==M<<16>>16)na=R;else{T=M;while(1){N=d[a+((T&65535)<<1)>>1]|0;if((N&65535)<(T&65535))T=N;else break}N=(R&65535)>(T&65535)?T:R;L=M;do{_=a+((L&65535)<<1)|0;U=L;L=d[_>>1]|0;d[_>>1]=N}while((L&65535)<(U&65535));na=N}N=O;do{L=a+((N&65535)<<1)|0;M=N;N=d[L>>1]|0;d[L>>1]=na}while((N&65535)<(M&65535));N=d[z+(P<<1)>>1]|0;O=na;while(1){M=d[a+((O&65535)<<1)>>1]|0;if((M&65535)<(O&65535))O=M;else break}if(na<<16>>16==N<<16>>16)oa=O;else{M=N;while(1){L=d[a+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}L=(O&65535)>(M&65535)?M:O;R=N;do{T=a+((R&65535)<<1)|0;U=R;R=d[T>>1]|0;d[T>>1]=L}while((R&65535)<(U&65535));oa=L}L=na;do{R=a+((L&65535)<<1)|0;N=L;L=d[R>>1]|0;d[R>>1]=oa}while((L&65535)<(N&65535));d[z+(E<<1)>>1]=oa;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;L=d[t+(S<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;R=L;while(1){O=d[a+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(L<<16>>16==N<<16>>16)pa=R;else{O=N;while(1){M=d[a+((O&65535)<<1)>>1]|0;if((M&65535)<(O&65535))O=M;else break}M=(R&65535)>(O&65535)?O:R;U=N;do{T=a+((U&65535)<<1)|0;_=U;U=d[T>>1]|0;d[T>>1]=M}while((U&65535)<(_&65535));pa=M}M=L;do{U=a+((M&65535)<<1)|0;N=M;M=d[U>>1]|0;d[U>>1]=pa}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=pa;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;L=d[t+(S<<1)>>1]|0;N=M;while(1){U=d[a+((N&65535)<<1)>>1]|0;if((U&65535)<(N&65535))N=U;else break}if(M<<16>>16==L<<16>>16)qa=N;else{U=L;while(1){R=d[a+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}R=(N&65535)>(U&65535)?U:N;O=L;do{_=a+((O&65535)<<1)|0;T=O;O=d[_>>1]|0;d[_>>1]=R}while((O&65535)<(T&65535));qa=R}R=M;do{O=a+((R&65535)<<1)|0;L=R;R=d[O>>1]|0;d[O>>1]=qa}while((R&65535)<(L&65535));R=d[z+(P<<1)>>1]|0;M=qa;while(1){L=d[a+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}if(qa<<16>>16==R<<16>>16)ra=M;else{L=R;while(1){O=d[a+((L&65535)<<1)>>1]|0;if((O&65535)<(L&65535))L=O;else break}O=(M&65535)>(L&65535)?L:M;N=R;do{U=a+((N&65535)<<1)|0;T=N;N=d[U>>1]|0;d[U>>1]=O}while((N&65535)<(T&65535));ra=O}O=qa;do{N=a+((O&65535)<<1)|0;R=O;O=d[N>>1]|0;d[N>>1]=ra}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=ra;K=F;break a}while(0);O=d[t+(E<<1)>>1]|0;R=d[t+(S<<1)>>1]|0;N=O;while(1){M=d[a+((N&65535)<<1)>>1]|0;if((M&65535)<(N&65535))N=M;else break}if(O<<16>>16==R<<16>>16)sa=N;else{M=R;while(1){L=d[a+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}L=(N&65535)>(M&65535)?M:N;T=R;do{U=a+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=L}while((T&65535)<(_&65535));sa=L}L=O;do{T=a+((L&65535)<<1)|0;R=L;L=d[T>>1]|0;d[T>>1]=sa}while((L&65535)<(R&65535));L=d[z+(P<<1)>>1]|0;O=sa;while(1){R=d[a+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}if(sa<<16>>16==L<<16>>16)ta=O;else{P=L;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;T=L;do{N=a+((T&65535)<<1)|0;M=T;T=d[N>>1]|0;d[N>>1]=R}while((T&65535)<(M&65535));ta=R}R=sa;do{T=a+((R&65535)<<1)|0;L=R;R=d[T>>1]|0;d[T>>1]=ta}while((R&65535)<(L&65535));d[z+(E<<1)>>1]=ta;K=F;break a}while(0);S=E+-2|0;if(!(b[x+E>>0]|0)){ua=S;break}do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(S<<1)>>1]|0;K=F;break a}if(!(b[x+S>>0]|0)){R=d[t+(E<<1)>>1]|0;L=d[z+(S<<1)>>1]|0;T=R;while(1){O=d[a+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(R<<16>>16==L<<16>>16)va=T;else{O=L;while(1){P=d[a+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(T&65535)>(O&65535)?O:T;M=L;do{N=a+((M&65535)<<1)|0;_=M;M=d[N>>1]|0;d[N>>1]=P}while((M&65535)<(_&65535));va=P}P=R;do{M=a+((P&65535)<<1)|0;L=P;P=d[M>>1]|0;d[M>>1]=va}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=va;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;d[z+(E<<1)>>1]=d[z+(S<<1)>>1]|0;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;R=d[z+(S<<1)>>1]|0;L=P;while(1){M=d[a+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(P<<16>>16==R<<16>>16)wa=L;else{M=R;while(1){T=d[a+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}T=(L&65535)>(M&65535)?M:L;O=R;do{_=a+((O&65535)<<1)|0;N=O;O=d[_>>1]|0;d[_>>1]=T}while((O&65535)<(N&65535));wa=T}T=P;do{O=a+((T&65535)<<1)|0;R=T;T=d[O>>1]|0;d[O>>1]=wa}while((T&65535)<(R&65535));d[z+(E<<1)>>1]=wa;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;P=d[z+(S<<1)>>1]|0;R=T;while(1){O=d[a+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(T<<16>>16==P<<16>>16)xa=R;else{S=P;while(1){O=d[a+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}O=(R&65535)>(S&65535)?S:R;L=P;do{M=a+((L&65535)<<1)|0;N=L;L=d[M>>1]|0;d[M>>1]=O}while((L&65535)<(N&65535));xa=O}O=T;do{L=a+((O&65535)<<1)|0;P=O;O=d[L>>1]|0;d[L>>1]=xa}while((O&65535)<(P&65535));d[z+(E<<1)>>1]=xa;K=F;break a}else ua=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(ua<<1)>>1]|0;K=F;break a}while(0);do if(B){if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}O=E+2|0;do if(!((O|0)>=(o|0)|C)){if(!(b[x+O>>0]|0))break;if(!(b[x+E>>0]|0)){d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;P=d[t+(O<<1)>>1]|0;L=T;while(1){R=d[a+((L&65535)<<1)>>1]|0;if((R&65535)<(L&65535))L=R;else break}if(T<<16>>16==P<<16>>16)ya=L;else{R=P;while(1){S=d[a+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(L&65535)>(R&65535)?R:L;N=P;do{M=a+((N&65535)<<1)|0;_=N;N=d[M>>1]|0;d[M>>1]=S}while((N&65535)<(_&65535));ya=S}S=T;do{N=a+((S&65535)<<1)|0;P=S;S=d[N>>1]|0;d[N>>1]=ya}while((S&65535)<(P&65535));d[z+(E<<1)>>1]=ya;K=F;break a}while(0);if(!(b[x+E>>0]|0))break;d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}while(0);d[z+(E<<1)>>1]=F;O=F&65535;d[a+(O<<1)>>1]=F;K=O+1&65535;break}if(J){if(b[w+I>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}if(b[v+I>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}}d[z+(E<<1)>>1]=F;O=F&65535;d[a+(O<<1)>>1]=F;K=O+1&65535;break}do if(H){if(!(b[v+G>>0]|0)){if(!A)break;if(!(b[w+G>>0]|0))break;d[z+(E<<1)>>1]=F;O=F&65535;d[a+(O<<1)>>1]=F;K=O+1&65535;break a}if(B){if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}O=E+2|0;do if(!((O|0)>=(o|0)|C)){if(!(b[x+O>>0]|0))break;if(!(b[x+E>>0]|0)){d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;T=d[t+(O<<1)>>1]|0;P=S;while(1){N=d[a+((P&65535)<<1)>>1]|0;if((N&65535)<(P&65535))P=N;else break}if(S<<16>>16==T<<16>>16)za=P;else{N=T;while(1){L=d[a+((N&65535)<<1)>>1]|0;if((L&65535)<(N&65535))N=L;else break}L=(P&65535)>(N&65535)?N:P;R=T;do{_=a+((R&65535)<<1)|0;M=R;R=d[_>>1]|0;d[_>>1]=L}while((R&65535)<(M&65535));za=L}L=S;do{R=a+((L&65535)<<1)|0;T=L;L=d[R>>1]|0;d[R>>1]=za}while((L&65535)<(T&65535));d[z+(E<<1)>>1]=za;K=F;break a}while(0);if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}}d[z+(E<<1)>>1]=F;O=F&65535;d[a+(O<<1)>>1]=F;K=O+1&65535;break a}while(0);d[z+(E<<1)>>1]=0;K=F}else{G=E+-1|0;H=(E|0)>0;if(H){if(b[v+G>>0]|0){I=E|1;J=(I|0)<(o|0);if(B&J?b[x+I>>0]|0:0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}do if(D){if(!(b[y+E>>0]|0))break;O=E+-2|0;if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(b[y+G>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}L=d[t+(E<<1)>>1]|0;S=d[z+(O<<1)>>1]|0;T=L;while(1){R=d[a+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(L<<16>>16==S<<16>>16)Aa=T;else{R=S;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;N=S;do{M=a+((N&65535)<<1)|0;_=N;N=d[M>>1]|0;d[M>>1]=P}while((N&65535)<(_&65535));Aa=P}P=L;do{N=a+((P&65535)<<1)|0;S=P;P=d[N>>1]|0;d[N>>1]=Aa}while((P&65535)<(S&65535));d[z+(E<<1)>>1]=Aa;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;L=d[z+(O<<1)>>1]|0;S=P;while(1){N=d[a+((S&65535)<<1)>>1]|0;if((N&65535)<(S&65535))S=N;else break}if(P<<16>>16==L<<16>>16)Ba=S;else{O=L;while(1){N=d[a+((O&65535)<<1)>>1]|0;if((N&65535)<(O&65535))O=N;else break}N=(S&65535)>(O&65535)?O:S;T=L;do{R=a+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=N}while((T&65535)<(_&65535));Ba=N}N=P;do{T=a+((N&65535)<<1)|0;L=N;N=d[T>>1]|0;d[T>>1]=Ba}while((N&65535)<(L&65535));d[z+(E<<1)>>1]=Ba;K=F;break a}while(0);N=d[t+(E<<1)>>1]|0;P=d[z+(E+-2<<1)>>1]|0;L=N;while(1){T=d[a+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(N<<16>>16==P<<16>>16)Ca=L;else{T=P;while(1){S=d[a+((T&65535)<<1)>>1]|0;if((S&65535)<(T&65535))T=S;else break}S=(L&65535)>(T&65535)?T:L;O=P;do{_=a+((O&65535)<<1)|0;R=O;O=d[_>>1]|0;d[_>>1]=S}while((O&65535)<(R&65535));Ca=S}S=N;do{O=a+((S&65535)<<1)|0;P=S;S=d[O>>1]|0;d[O>>1]=Ca}while((S&65535)<(P&65535));d[z+(E<<1)>>1]=Ca;K=F;break}if(J?b[v+I>>0]|0:0){S=E+2|0;do if(B&(S|0)<(o|0)){if(!(b[x+S>>0]|0))break;do if(D){if(!(b[y+I>>0]|0))break;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[y+E>>0]|0)){N=d[t+(S<<1)>>1]|0;P=d[z+(E+-2<<1)>>1]|0;O=N;while(1){L=d[a+((O&65535)<<1)>>1]|0;if((L&65535)<(O&65535))O=L;else break}if(N<<16>>16==P<<16>>16)Da=O;else{L=P;while(1){T=d[a+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}T=(O&65535)>(L&65535)?L:O;R=P;do{_=a+((R&65535)<<1)|0;M=R;R=d[_>>1]|0;d[_>>1]=T}while((R&65535)<(M&65535));Da=T}T=N;do{R=a+((T&65535)<<1)|0;P=T;T=d[R>>1]|0;d[R>>1]=Da}while((T&65535)<(P&65535));d[z+(E<<1)>>1]=Da;K=F;break a}T=E+-2|0;if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[z+(T<<1)>>1]|0;K=F;break a}do if((T|0)>-1){if(!(b[x+T>>0]|0))break;if(b[y+G>>0]|0){d[z+(E<<1)>>1]=d[z+(T<<1)>>1]|0;K=F;break a}N=d[t+(S<<1)>>1]|0;P=d[z+(T<<1)>>1]|0;R=N;while(1){O=d[a+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(N<<16>>16==P<<16>>16)Ea=R;else{O=P;while(1){L=d[a+((O&65535)<<1)>>1]|0;if((L&65535)<(O&65535))O=L;else break}L=(R&65535)>(O&65535)?O:R;M=P;do{_=a+((M&65535)<<1)|0;U=M;M=d[_>>1]|0;d[_>>1]=L}while((M&65535)<(U&65535));Ea=L}L=N;do{M=a+((L&65535)<<1)|0;P=L;L=d[M>>1]|0;d[M>>1]=Ea}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=Ea;K=F;break a}while(0);L=d[t+(S<<1)>>1]|0;N=d[z+(T<<1)>>1]|0;P=L;while(1){M=d[a+((P&65535)<<1)>>1]|0;if((M&65535)<(P&65535))P=M;else break}if(L<<16>>16==N<<16>>16)Fa=P;else{T=N;while(1){M=d[a+((T&65535)<<1)>>1]|0;if((M&65535)<(T&65535))T=M;else break}M=(P&65535)>(T&65535)?T:P;R=N;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=M}while((R&65535)<(U&65535));Fa=M}M=L;do{R=a+((M&65535)<<1)|0;N=M;M=d[R>>1]|0;d[R>>1]=Fa}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=Fa;K=F;break a}while(0);M=d[t+(S<<1)>>1]|0;L=d[z+(E+-2<<1)>>1]|0;N=M;while(1){R=d[a+((N&65535)<<1)>>1]|0;if((R&65535)<(N&65535))N=R;else break}if(M<<16>>16==L<<16>>16)Ga=N;else{R=L;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(N&65535)>(R&65535)?R:N;T=L;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=P}while((T&65535)<(O&65535));Ga=P}P=M;do{T=a+((P&65535)<<1)|0;L=P;P=d[T>>1]|0;d[T>>1]=Ga}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=Ga;K=F;break a}while(0);d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}if(A?b[w+G>>0]|0:0){S=E|1;I=(S|0)<(o|0);if(!(C|I^1)?b[x+S>>0]|0:0){J=E+-2|0;do if((J|0)>-1){if(!(b[v+J>>0]|0))break;if(b[x+G>>0]|0){P=d[z+(J<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=P;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;L=M;while(1){T=d[a+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(M<<16>>16==P<<16>>16)Ha=L;else{T=P;while(1){N=d[a+((T&65535)<<1)>>1]|0;if((N&65535)<(T&65535))T=N;else break}N=(L&65535)>(T&65535)?T:L;R=P;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=N}while((R&65535)<(U&65535));Ha=N}N=M;do{R=a+((N&65535)<<1)|0;P=N;N=d[R>>1]|0;d[R>>1]=Ha}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ha;K=F;break a}if(!(b[x+J>>0]|0)){N=d[t+(E<<1)>>1]|0;M=d[z+(J<<1)>>1]|0;P=N;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(N<<16>>16==M<<16>>16)Ia=P;else{R=M;while(1){L=d[a+((R&65535)<<1)>>1]|0;if((L&65535)<(R&65535))R=L;else break}L=(P&65535)>(R&65535)?R:P;T=M;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=L}while((T&65535)<(O&65535));Ia=L}L=N;do{T=a+((L&65535)<<1)|0;M=L;L=d[T>>1]|0;d[T>>1]=Ia}while((L&65535)<(M&65535));d[z+(E<<1)>>1]=Ia;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;L=d[z+(J<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}N=d[t+(E<<1)>>1]|0;M=N;while(1){T=d[a+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}if(N<<16>>16==L<<16>>16)Ja=M;else{T=L;while(1){P=d[a+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}P=(M&65535)>(T&65535)?T:M;R=L;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(U&65535));Ja=P}P=N;do{R=a+((P&65535)<<1)|0;L=P;P=d[R>>1]|0;d[R>>1]=Ja}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=Ja;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;N=d[z+(J<<1)>>1]|0;L=P;while(1){R=d[a+((L&65535)<<1)>>1]|0;if((R&65535)<(L&65535))L=R;else break}if(P<<16>>16==N<<16>>16)Ka=L;else{R=N;while(1){M=d[a+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(L&65535)>(R&65535)?R:L;T=N;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(O&65535));Ka=M}M=P;do{T=a+((M&65535)<<1)|0;N=M;M=d[T>>1]|0;d[T>>1]=Ka}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=Ka;K=F;break a}while(0);if(b[x+E>>0]|0){M=d[t+(E<<1)>>1]|0;P=d[z+(J<<1)>>1]|0;N=M;while(1){T=d[a+((N&65535)<<1)>>1]|0;if((T&65535)<(N&65535))N=T;else break}if(M<<16>>16==P<<16>>16)La=N;else{T=P;while(1){L=d[a+((T&65535)<<1)>>1]|0;if((L&65535)<(T&65535))T=L;else break}L=(N&65535)>(T&65535)?T:N;R=P;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=L}while((R&65535)<(U&65535));La=L}L=M;do{R=a+((L&65535)<<1)|0;P=L;L=d[R>>1]|0;d[R>>1]=La}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=La;K=F;break}L=d[t+(E<<1)>>1]|0;if(!(b[x+G>>0]|0)){M=d[z+(J<<1)>>1]|0;P=L;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(L<<16>>16==M<<16>>16)Ma=P;else{R=M;while(1){N=d[a+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(P&65535)>(R&65535)?R:P;T=M;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=N}while((T&65535)<(O&65535));Ma=N}N=L;do{T=a+((N&65535)<<1)|0;M=N;N=d[T>>1]|0;d[T>>1]=Ma}while((N&65535)<(M&65535));d[z+(E<<1)>>1]=Ma;K=F;break}do if(D){if(!(b[y+E>>0]|0))break;N=d[z+(J<<1)>>1]|0;M=L;while(1){T=d[a+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}if(L<<16>>16==N<<16>>16)Na=M;else{T=N;while(1){P=d[a+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}P=(M&65535)>(T&65535)?T:M;R=N;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(U&65535));Na=P}P=L;do{R=a+((P&65535)<<1)|0;N=P;P=d[R>>1]|0;d[R>>1]=Na}while((P&65535)<(N&65535));d[z+(E<<1)>>1]=Na;K=F;break a}while(0);P=d[t+(J<<1)>>1]|0;N=P;while(1){R=d[a+((N&65535)<<1)>>1]|0;if((R&65535)<(N&65535))N=R;else break}if(P<<16>>16==L<<16>>16)Oa=N;else{R=L;while(1){M=d[a+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(N&65535)>(R&65535)?R:N;T=L;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(O&65535));Oa=M}M=P;do{T=a+((M&65535)<<1)|0;L=M;M=d[T>>1]|0;d[T>>1]=Oa}while((M&65535)<(L&65535));M=d[z+(J<<1)>>1]|0;P=Oa;while(1){L=d[a+((P&65535)<<1)>>1]|0;if((L&65535)<(P&65535))P=L;else break}if(Oa<<16>>16==M<<16>>16)Pa=P;else{J=M;while(1){L=d[a+((J&65535)<<1)>>1]|0;if((L&65535)<(J&65535))J=L;else break}L=(P&65535)>(J&65535)?J:P;T=M;do{N=a+((T&65535)<<1)|0;R=T;T=d[N>>1]|0;d[N>>1]=L}while((T&65535)<(R&65535));Pa=L}L=Oa;do{T=a+((L&65535)<<1)|0;M=L;L=d[T>>1]|0;d[T>>1]=Pa}while((L&65535)<(M&65535));d[z+(E<<1)>>1]=Pa;K=F;break}if(I?b[v+S>>0]|0:0){L=E+2|0;do if(!((L|0)>=(o|0)|C)){if(!(b[x+L>>0]|0))break;M=E+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[x+G>>0]|0){do if(D){if(!(b[y+S>>0]|0))break;T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}P=d[t+(L<<1)>>1]|0;J=P;while(1){R=d[a+((J&65535)<<1)>>1]|0;if((R&65535)<(J&65535))J=R;else break}if(P<<16>>16==T<<16>>16)Qa=J;else{R=T;while(1){N=d[a+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(J&65535)>(R&65535)?R:J;O=T;do{U=a+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=N}while((O&65535)<(_&65535));Qa=N}N=P;do{O=a+((N&65535)<<1)|0;T=N;N=d[O>>1]|0;d[O>>1]=Qa}while((N&65535)<(T&65535));d[z+(E<<1)>>1]=Qa;K=F;break a}while(0);N=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=N;while(1){O=d[a+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(N<<16>>16==P<<16>>16)Ra=T;else{O=P;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(T&65535)>(O&65535)?O:T;R=P;do{_=a+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=J}while((R&65535)<(U&65535));Ra=J}J=N;do{R=a+((J&65535)<<1)|0;P=J;J=d[R>>1]|0;d[R>>1]=Ra}while((J&65535)<(P&65535));d[z+(E<<1)>>1]=Ra;K=F;break a}do if(D){if(!(b[y+S>>0]|0))break;if(!(b[x+M>>0]|0)){J=d[t+(L<<1)>>1]|0;N=d[z+(M<<1)>>1]|0;P=J;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(J<<16>>16==N<<16>>16)Sa=P;else{R=N;while(1){T=d[a+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}T=(P&65535)>(R&65535)?R:P;O=N;do{U=a+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=T}while((O&65535)<(_&65535));Sa=T}T=J;do{O=a+((T&65535)<<1)|0;N=T;T=d[O>>1]|0;d[O>>1]=Sa}while((T&65535)<(N&65535));d[z+(E<<1)>>1]=Sa;K=F;break a}if(!(b[y+G>>0]|0)){T=d[t+(L<<1)>>1]|0;J=d[z+(M<<1)>>1]|0;N=T;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(T<<16>>16==J<<16>>16)Ta=N;else{O=J;while(1){P=d[a+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(N&65535)>(O&65535)?O:N;R=J;do{_=a+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=P}while((R&65535)<(U&65535));Ta=P}P=T;do{R=a+((P&65535)<<1)|0;J=P;P=d[R>>1]|0;d[R>>1]=Ta}while((P&65535)<(J&65535));d[z+(E<<1)>>1]=Ta;K=F;break a}P=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}T=d[t+(L<<1)>>1]|0;J=T;while(1){R=d[a+((J&65535)<<1)>>1]|0;if((R&65535)<(J&65535))J=R;else break}if(T<<16>>16==P<<16>>16)Ua=J;else{R=P;while(1){N=d[a+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(J&65535)>(R&65535)?R:J;O=P;do{U=a+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=N}while((O&65535)<(_&65535));Ua=N}N=T;do{O=a+((N&65535)<<1)|0;P=N;N=d[O>>1]|0;d[O>>1]=Ua}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ua;K=F;break a}while(0);if(!(b[x+E>>0]|0)){N=d[t+(L<<1)>>1]|0;T=d[z+(M<<1)>>1]|0;P=N;while(1){O=d[a+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}if(N<<16>>16==T<<16>>16)Va=P;else{O=T;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(P&65535)>(O&65535)?O:P;R=T;do{_=a+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=J}while((R&65535)<(U&65535));Va=J}J=N;do{R=a+((J&65535)<<1)|0;T=J;J=d[R>>1]|0;d[R>>1]=Va}while((J&65535)<(T&65535));d[z+(E<<1)>>1]=Va;K=F;break a}if(!(b[x+M>>0]|0)){J=d[t+(E<<1)>>1]|0;N=d[t+(L<<1)>>1]|0;T=J;while(1){R=d[a+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(J<<16>>16==N<<16>>16)Wa=T;else{R=N;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;O=N;do{U=a+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=P}while((O&65535)<(_&65535));Wa=P}P=J;do{O=a+((P&65535)<<1)|0;N=P;P=d[O>>1]|0;d[O>>1]=Wa}while((P&65535)<(N&65535));P=d[z+(M<<1)>>1]|0;J=Wa;while(1){N=d[a+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}if(Wa<<16>>16==P<<16>>16)Xa=J;else{N=P;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}O=(J&65535)>(N&65535)?N:J;T=P;do{R=a+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=O}while((T&65535)<(_&65535));Xa=O}O=Wa;do{T=a+((O&65535)<<1)|0;P=O;O=d[T>>1]|0;d[T>>1]=Xa}while((O&65535)<(P&65535));d[z+(E<<1)>>1]=Xa;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;O=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=O;while(1){J=d[a+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}if(O<<16>>16==P<<16>>16)Ya=T;else{J=P;while(1){N=d[a+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}N=(T&65535)>(J&65535)?J:T;_=P;do{R=a+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=N}while((_&65535)<(U&65535));Ya=N}N=O;do{_=a+((N&65535)<<1)|0;P=N;N=d[_>>1]|0;d[_>>1]=Ya}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ya;K=F;break a}while(0);N=d[t+(E<<1)>>1]|0;O=d[t+(L<<1)>>1]|0;P=N;while(1){_=d[a+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(N<<16>>16==O<<16>>16)Za=P;else{_=O;while(1){T=d[a+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(P&65535)>(_&65535)?_:P;J=O;do{U=a+((J&65535)<<1)|0;R=J;J=d[U>>1]|0;d[U>>1]=T}while((J&65535)<(R&65535));Za=T}T=N;do{J=a+((T&65535)<<1)|0;O=T;T=d[J>>1]|0;d[J>>1]=Za}while((T&65535)<(O&65535));T=d[z+(M<<1)>>1]|0;N=Za;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(Za<<16>>16==T<<16>>16)_a=N;else{O=T;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(N&65535)>(O&65535)?O:N;P=T;do{_=a+((P&65535)<<1)|0;R=P;P=d[_>>1]|0;d[_>>1]=J}while((P&65535)<(R&65535));_a=J}J=Za;do{P=a+((J&65535)<<1)|0;T=J;J=d[P>>1]|0;d[P>>1]=_a}while((J&65535)<(T&65535));d[z+(E<<1)>>1]=_a;K=F;break a}while(0);if(b[x+E>>0]|0){do if(D){if(!(b[y+S>>0]|0))break;J=d[t+(L<<1)>>1]|0;T=d[z+(M<<1)>>1]|0;P=J;while(1){N=d[a+((P&65535)<<1)>>1]|0;if((N&65535)<(P&65535))P=N;else break}if(J<<16>>16==T<<16>>16)$a=P;else{N=T;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}O=(P&65535)>(N&65535)?N:P;R=T;do{_=a+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=O}while((R&65535)<(U&65535));$a=O}O=J;do{R=a+((O&65535)<<1)|0;T=O;O=d[R>>1]|0;d[R>>1]=$a}while((O&65535)<(T&65535));d[z+(E<<1)>>1]=$a;K=F;break a}while(0);O=d[t+(E<<1)>>1]|0;J=d[t+(L<<1)>>1]|0;T=O;while(1){R=d[a+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(O<<16>>16==J<<16>>16)ab=T;else{R=J;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;N=J;do{U=a+((N&65535)<<1)|0;_=N;N=d[U>>1]|0;d[U>>1]=P}while((N&65535)<(_&65535));ab=P}P=O;do{N=a+((P&65535)<<1)|0;J=P;P=d[N>>1]|0;d[N>>1]=ab}while((P&65535)<(J&65535));P=d[z+(M<<1)>>1]|0;O=ab;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}if(ab<<16>>16==P<<16>>16)bb=O;else{J=P;while(1){N=d[a+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}N=(O&65535)>(J&65535)?J:O;T=P;do{R=a+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=N}while((T&65535)<(_&65535));bb=N}N=ab;do{T=a+((N&65535)<<1)|0;P=N;N=d[T>>1]|0;d[T>>1]=bb}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=bb;K=F;break a}if(!(b[x+G>>0]|0)){N=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=N;while(1){O=d[a+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(N<<16>>16==P<<16>>16)cb=T;else{O=P;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(T&65535)>(O&65535)?O:T;_=P;do{R=a+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=J}while((_&65535)<(U&65535));cb=J}J=N;do{_=a+((J&65535)<<1)|0;P=J;J=d[_>>1]|0;d[_>>1]=cb}while((J&65535)<(P&65535));d[z+(E<<1)>>1]=cb;K=F;break a}do if(D){if(!(b[y+S>>0]|0))break;J=d[t+(L<<1)>>1]|0;if(b[y+E>>0]|0){N=d[z+(M<<1)>>1]|0;P=J;while(1){_=d[a+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(J<<16>>16==N<<16>>16)db=P;else{_=N;while(1){T=d[a+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(P&65535)>(_&65535)?_:P;O=N;do{U=a+((O&65535)<<1)|0;R=O;O=d[U>>1]|0;d[U>>1]=T}while((O&65535)<(R&65535));db=T}T=J;do{O=a+((T&65535)<<1)|0;N=T;T=d[O>>1]|0;d[O>>1]=db}while((T&65535)<(N&65535));d[z+(E<<1)>>1]=db;K=F;break a}T=d[t+(M<<1)>>1]|0;N=T;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(T<<16>>16==J<<16>>16)eb=N;else{O=J;while(1){P=d[a+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(N&65535)>(O&65535)?O:N;_=J;do{R=a+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=P}while((_&65535)<(U&65535));eb=P}P=T;do{_=a+((P&65535)<<1)|0;J=P;P=d[_>>1]|0;d[_>>1]=eb}while((P&65535)<(J&65535));P=d[z+(M<<1)>>1]|0;T=eb;while(1){J=d[a+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}if(eb<<16>>16==P<<16>>16)fb=T;else{J=P;while(1){_=d[a+((J&65535)<<1)>>1]|0;if((_&65535)<(J&65535))J=_;else break}_=(T&65535)>(J&65535)?J:T;N=P;do{O=a+((N&65535)<<1)|0;U=N;N=d[O>>1]|0;d[O>>1]=_}while((N&65535)<(U&65535));fb=_}_=eb;do{N=a+((_&65535)<<1)|0;P=_;_=d[N>>1]|0;d[N>>1]=fb}while((_&65535)<(P&65535));d[z+(E<<1)>>1]=fb;K=F;break a}while(0);_=d[t+(M<<1)>>1]|0;P=d[t+(L<<1)>>1]|0;N=_;while(1){T=d[a+((N&65535)<<1)>>1]|0;if((T&65535)<(N&65535))N=T;else break}if(_<<16>>16==P<<16>>16)gb=N;else{T=P;while(1){J=d[a+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}J=(N&65535)>(T&65535)?T:N;U=P;do{O=a+((U&65535)<<1)|0;R=U;U=d[O>>1]|0;d[O>>1]=J}while((U&65535)<(R&65535));gb=J}J=_;do{U=a+((J&65535)<<1)|0;P=J;J=d[U>>1]|0;d[U>>1]=gb}while((J&65535)<(P&65535));J=d[z+(M<<1)>>1]|0;_=gb;while(1){P=d[a+((_&65535)<<1)>>1]|0;if((P&65535)<(_&65535))_=P;else break}if(gb<<16>>16==J<<16>>16)hb=_;else{M=J;while(1){P=d[a+((M&65535)<<1)>>1]|0;if((P&65535)<(M&65535))M=P;else break}P=(_&65535)>(M&65535)?M:_;U=J;do{N=a+((U&65535)<<1)|0;T=U;U=d[N>>1]|0;d[N>>1]=P}while((U&65535)<(T&65535));hb=P}P=gb;do{U=a+((P&65535)<<1)|0;J=P;P=d[U>>1]|0;d[U>>1]=hb}while((P&65535)<(J&65535));d[z+(E<<1)>>1]=hb;K=F;break a}while(0);do if(B){L=E+-2|0;if(b[x+G>>0]|0){S=d[z+(L<<1)>>1]|0;do if((L|0)>-1){if(!(b[v+L>>0]|0))break;d[z+(E<<1)>>1]=S;K=F;break a}while(0);I=d[t+(L<<1)>>1]|0;P=I;while(1){J=d[a+((P&65535)<<1)>>1]|0;if((J&65535)<(P&65535))P=J;else break}if(I<<16>>16==S<<16>>16)ib=P;else{J=S;while(1){U=d[a+((J&65535)<<1)>>1]|0;if((U&65535)<(J&65535))J=U;else break}U=(P&65535)>(J&65535)?J:P;_=S;do{M=a+((_&65535)<<1)|0;T=_;_=d[M>>1]|0;d[M>>1]=U}while((_&65535)<(T&65535));ib=U}U=I;do{_=a+((U&65535)<<1)|0;S=U;U=d[_>>1]|0;d[_>>1]=ib}while((U&65535)<(S&65535));d[z+(E<<1)>>1]=ib;K=F;break a}if(!(b[x+E>>0]|0)){jb=L;break}do if((L|0)>-1){if(!(b[v+L>>0]|0))break;if(!(b[x+L>>0]|0)){U=d[t+(E<<1)>>1]|0;I=d[z+(L<<1)>>1]|0;S=U;while(1){_=d[a+((S&65535)<<1)>>1]|0;if((_&65535)<(S&65535))S=_;else break}if(U<<16>>16==I<<16>>16)kb=S;else{_=I;while(1){P=d[a+((_&65535)<<1)>>1]|0;if((P&65535)<(_&65535))_=P;else break}P=(S&65535)>(_&65535)?_:S;J=I;do{T=a+((J&65535)<<1)|0;M=J;J=d[T>>1]|0;d[T>>1]=P}while((J&65535)<(M&65535));kb=P}P=U;do{J=a+((P&65535)<<1)|0;I=P;P=d[J>>1]|0;d[J>>1]=kb}while((P&65535)<(I&65535));d[z+(E<<1)>>1]=kb;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;U=d[z+(L<<1)>>1]|0;I=P;while(1){J=d[a+((I&65535)<<1)>>1]|0;if((J&65535)<(I&65535))I=J;else break}if(P<<16>>16==U<<16>>16)lb=I;else{J=U;while(1){S=d[a+((J&65535)<<1)>>1]|0;if((S&65535)<(J&65535))J=S;else break}S=(I&65535)>(J&65535)?J:I;_=U;do{M=a+((_&65535)<<1)|0;T=_;_=d[M>>1]|0;d[M>>1]=S}while((_&65535)<(T&65535));lb=S}S=P;do{_=a+((S&65535)<<1)|0;U=S;S=d[_>>1]|0;d[_>>1]=lb}while((S&65535)<(U&65535));d[z+(E<<1)>>1]=lb;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;P=d[z+(L<<1)>>1]|0;U=S;while(1){_=d[a+((U&65535)<<1)>>1]|0;if((_&65535)<(U&65535))U=_;else break}if(S<<16>>16==P<<16>>16)mb=U;else{L=P;while(1){_=d[a+((L&65535)<<1)>>1]|0;if((_&65535)<(L&65535))L=_;else break}_=(U&65535)>(L&65535)?L:U;I=P;do{J=a+((I&65535)<<1)|0;T=I;I=d[J>>1]|0;d[J>>1]=_}while((I&65535)<(T&65535));mb=_}_=S;do{I=a+((_&65535)<<1)|0;P=_;_=d[I>>1]|0;d[I>>1]=mb}while((_&65535)<(P&65535));d[z+(E<<1)>>1]=mb;K=F;break a}else jb=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(jb<<1)>>1]|0;K=F;break}do if(B){_=E+-2|0;if(b[x+G>>0]|0){S=d[z+(_<<1)>>1]|0;do if((_|0)>-1){if(!(b[v+_>>0]|0))break;d[z+(E<<1)>>1]=S;K=F;break a}while(0);P=d[t+(_<<1)>>1]|0;I=P;while(1){U=d[a+((I&65535)<<1)>>1]|0;if((U&65535)<(I&65535))I=U;else break}if(P<<16>>16==S<<16>>16)nb=I;else{U=S;while(1){L=d[a+((U&65535)<<1)>>1]|0;if((L&65535)<(U&65535))U=L;else break}L=(I&65535)>(U&65535)?U:I;T=S;do{J=a+((T&65535)<<1)|0;M=T;T=d[J>>1]|0;d[J>>1]=L}while((T&65535)<(M&65535));nb=L}L=P;do{T=a+((L&65535)<<1)|0;S=L;L=d[T>>1]|0;d[T>>1]=nb}while((L&65535)<(S&65535));d[z+(E<<1)>>1]=nb;K=F;break a}if(!(b[x+E>>0]|0)){ob=_;break}do if((_|0)>-1){if(!(b[v+_>>0]|0))break;if(!(b[x+_>>0]|0)){L=d[t+(E<<1)>>1]|0;P=d[z+(_<<1)>>1]|0;S=L;while(1){T=d[a+((S&65535)<<1)>>1]|0;if((T&65535)<(S&65535))S=T;else break}if(L<<16>>16==P<<16>>16)pb=S;else{T=P;while(1){I=d[a+((T&65535)<<1)>>1]|0;if((I&65535)<(T&65535))T=I;else break}I=(S&65535)>(T&65535)?T:S;U=P;do{M=a+((U&65535)<<1)|0;J=U;U=d[M>>1]|0;d[M>>1]=I}while((U&65535)<(J&65535));pb=I}I=L;do{U=a+((I&65535)<<1)|0;P=I;I=d[U>>1]|0;d[U>>1]=pb}while((I&65535)<(P&65535));d[z+(E<<1)>>1]=pb;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[z+(_<<1)>>1]|0;K=F;break a}while(0);I=d[t+(E<<1)>>1]|0;L=d[z+(_<<1)>>1]|0;P=I;while(1){U=d[a+((P&65535)<<1)>>1]|0;if((U&65535)<(P&65535))P=U;else break}if(I<<16>>16==L<<16>>16)qb=P;else{U=L;while(1){S=d[a+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(P&65535)>(U&65535)?U:P;T=L;do{J=a+((T&65535)<<1)|0;M=T;T=d[J>>1]|0;d[J>>1]=S}while((T&65535)<(M&65535));qb=S}S=I;do{T=a+((S&65535)<<1)|0;L=S;S=d[T>>1]|0;d[T>>1]=qb}while((S&65535)<(L&65535));d[z+(E<<1)>>1]=qb;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;I=d[z+(_<<1)>>1]|0;L=S;while(1){T=d[a+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(S<<16>>16==I<<16>>16)rb=L;else{_=I;while(1){T=d[a+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(L&65535)>(_&65535)?_:L;P=I;do{U=a+((P&65535)<<1)|0;M=P;P=d[U>>1]|0;d[U>>1]=T}while((P&65535)<(M&65535));rb=T}T=S;do{P=a+((T&65535)<<1)|0;I=T;T=d[P>>1]|0;d[P>>1]=rb}while((T&65535)<(I&65535));d[z+(E<<1)>>1]=rb;K=F;break a}else ob=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(ob<<1)>>1]|0;K=F;break}}T=E|1;S=(T|0)<(o|0);if(!(C|S^1)?b[x+T>>0]|0:0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(H?b[x+G>>0]|0:0){I=d[t+(E<<1)>>1]|0;do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=I;K=F;break a}while(0);P=d[t+(E+-2<<1)>>1]|0;L=P;while(1){_=d[a+((L&65535)<<1)>>1]|0;if((_&65535)<(L&65535))L=_;else break}if(P<<16>>16==I<<16>>16)sb=L;else{_=I;while(1){M=d[a+((_&65535)<<1)>>1]|0;if((M&65535)<(_&65535))_=M;else break}M=(L&65535)>(_&65535)?_:L;U=I;do{J=a+((U&65535)<<1)|0;N=U;U=d[J>>1]|0;d[J>>1]=M}while((U&65535)<(N&65535));sb=M}M=P;do{U=a+((M&65535)<<1)|0;I=M;M=d[U>>1]|0;d[U>>1]=sb}while((M&65535)<(I&65535));d[z+(E<<1)>>1]=sb;K=F;break}d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(S?b[v+T>>0]|0:0){M=E+2|0;if(!((M|0)>=(o|0)|C)?b[x+M>>0]|0:0){if(b[x+E>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;d[z+(E<<1)>>1]=d[t+(M<<1)>>1]|0;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;P=d[t+(M<<1)>>1]|0;I=S;while(1){U=d[a+((I&65535)<<1)>>1]|0;if((U&65535)<(I&65535))I=U;else break}if(S<<16>>16==P<<16>>16)tb=I;else{U=P;while(1){L=d[a+((U&65535)<<1)>>1]|0;if((L&65535)<(U&65535))U=L;else break}L=(I&65535)>(U&65535)?U:I;_=P;do{N=a+((_&65535)<<1)|0;J=_;_=d[N>>1]|0;d[N>>1]=L}while((_&65535)<(J&65535));tb=L}L=S;do{_=a+((L&65535)<<1)|0;P=L;L=d[_>>1]|0;d[_>>1]=tb}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=tb;K=F;break}do if(H){if(!(b[x+G>>0]|0))break;do if(D){if(!(b[y+T>>0]|0))break;L=d[t+(M<<1)>>1]|0;if(b[y+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}S=d[t+(E+-2<<1)>>1]|0;P=S;while(1){_=d[a+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(S<<16>>16==L<<16>>16)ub=P;else{_=L;while(1){I=d[a+((_&65535)<<1)>>1]|0;if((I&65535)<(_&65535))_=I;else break}I=(P&65535)>(_&65535)?_:P;U=L;do{J=a+((U&65535)<<1)|0;N=U;U=d[J>>1]|0;d[J>>1]=I}while((U&65535)<(N&65535));ub=I}I=S;do{U=a+((I&65535)<<1)|0;L=I;I=d[U>>1]|0;d[U>>1]=ub}while((I&65535)<(L&65535));d[z+(E<<1)>>1]=ub;K=F;break a}while(0);I=d[t+(E+-2<<1)>>1]|0;S=d[t+(M<<1)>>1]|0;L=I;while(1){U=d[a+((L&65535)<<1)>>1]|0;if((U&65535)<(L&65535))L=U;else break}if(I<<16>>16==S<<16>>16)vb=L;else{U=S;while(1){P=d[a+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(L&65535)>(U&65535)?U:L;_=S;do{N=a+((_&65535)<<1)|0;J=_;_=d[N>>1]|0;d[N>>1]=P}while((_&65535)<(J&65535));vb=P}P=I;do{_=a+((P&65535)<<1)|0;S=P;P=d[_>>1]|0;d[_>>1]=vb}while((P&65535)<(S&65535));d[z+(E<<1)>>1]=vb;K=F;break a}while(0);d[z+(E<<1)>>1]=d[t+(M<<1)>>1]|0;K=F;break}if(B?b[x+E>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}do if(!(C|H^1)){if(!(b[x+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(E+-2<<1)>>1]|0;K=F;break a}while(0);d[z+(E<<1)>>1]=F;M=F&65535;d[a+(M<<1)>>1]=F;K=M+1&65535;break}if(B?b[x+E>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(!(C|H^1)?b[x+G>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E+-2<<1)>>1]|0;K=F;break}d[z+(E<<1)>>1]=F;M=F&65535;d[a+(M<<1)>>1]=F;K=M+1&65535}while(0);E=E+2|0;if((E|0)>=(o|0)){wb=K;break}else F=K}}else wb=r;s=s+2|0;if((s|0)>=(i|0))break;else r=wb}if((wb&65535)>1){r=wb&65535;wb=1;i=1;while(1){s=a+(i<<1)|0;K=j[s>>1]|0;if(K>>>0<i>>>0){d[s>>1]=d[a+(K<<1)>>1]|0;xb=wb}else{d[s>>1]=wb;xb=(wb&65535)+1&65535}i=i+1|0;if((i|0)==(r|0)){yb=xb;break}else wb=xb}}else yb=1}else yb=1;xb=f[k>>2]|0;k=f[p>>2]|0;p=(k&1|0)!=0;wb=(xb|0)>0;if(!(xb&1)){if(!p){if(!wb){g0(a);u=h;return yb|0}r=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;s=f[e+16>>2]|0;K=f[f[e+44>>2]>>2]|0;o=(k|0)>0;vb=0;do{ub=r+(Y(i,vb)|0)|0;tb=ub+i|0;sb=s+(Y(K,vb)|0)|0;ob=sb+K|0;if(o){rb=0;do{qb=sb+(rb<<1)|0;pb=d[qb>>1]|0;do if(pb<<16>>16){nb=d[a+((pb&65535)<<1)>>1]|0;d[qb>>1]=(b[ub+rb>>0]|0)==0?0:nb;jb=rb|1;d[sb+(jb<<1)>>1]=(b[ub+jb>>0]|0)==0?0:nb;d[ob+(rb<<1)>>1]=(b[tb+rb>>0]|0)==0?0:nb;mb=ob+(jb<<1)|0;if(!(b[tb+jb>>0]|0)){d[mb>>1]=0;break}else{d[mb>>1]=nb;break}}else{d[qb>>1]=0;nb=rb|1;d[sb+(nb<<1)>>1]=0;d[ob+(rb<<1)>>1]=0;d[ob+(nb<<1)>>1]=0}while(0);rb=rb+2|0}while((rb|0)<(k|0))}vb=vb+2|0}while((vb|0)<(xb|0));g0(a);u=h;return yb|0}if(!wb){g0(a);u=h;return yb|0}vb=f[c+16>>2]|0;o=f[f[c+44>>2]>>2]|0;K=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;i=(k|0)>0;r=0;do{rb=vb+(Y(o,r)|0)|0;ob=rb+o|0;sb=K+(Y(s,r)|0)|0;tb=sb+s|0;if(i){ub=0;do{qb=sb+(ub<<1)|0;pb=d[qb>>1]|0;do if(!(pb<<16>>16)){d[qb>>1]=0;d[tb+(ub<<1)>>1]=0;nb=ub|1;if((nb|0)<(k|0)){d[sb+(nb<<1)>>1]=0;d[tb+(nb<<1)>>1]=0}}else{nb=d[a+((pb&65535)<<1)>>1]|0;d[qb>>1]=(b[rb+ub>>0]|0)==0?0:nb;d[tb+(ub<<1)>>1]=(b[ob+ub>>0]|0)==0?0:nb;mb=ub|1;if((mb|0)<(k|0)){d[sb+(mb<<1)>>1]=(b[rb+mb>>0]|0)==0?0:nb;jb=tb+(mb<<1)|0;if(!(b[ob+mb>>0]|0)){d[jb>>1]=0;break}else{d[jb>>1]=nb;break}}}while(0);ub=ub+2|0}while((ub|0)<(k|0))}r=r+2|0}while((r|0)<(xb|0));g0(a);u=h;return yb|0}if(!p){if(!wb){g0(a);u=h;return yb|0}p=f[c+16>>2]|0;r=f[f[c+44>>2]>>2]|0;i=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;K=(k|0)>0;o=0;do{vb=p+(Y(r,o)|0)|0;ub=vb+r|0;ob=i+(Y(s,o)|0)|0;tb=ob+s|0;if(K){rb=o|1;sb=(rb|0)<(xb|0);qb=(rb|0)<(xb|0);rb=0;do{pb=ob+(rb<<1)|0;nb=d[pb>>1]|0;do if(!(nb<<16>>16)){d[pb>>1]=0;jb=rb|1;d[ob+(jb<<1)>>1]=0;if(sb){d[tb+(rb<<1)>>1]=0;d[tb+(jb<<1)>>1]=0}}else{jb=d[a+((nb&65535)<<1)>>1]|0;d[pb>>1]=(b[vb+rb>>0]|0)==0?0:jb;mb=rb|1;d[ob+(mb<<1)>>1]=(b[vb+mb>>0]|0)==0?0:jb;if(qb){d[tb+(rb<<1)>>1]=(b[ub+rb>>0]|0)==0?0:jb;lb=tb+(mb<<1)|0;if(!(b[ub+mb>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=jb;break}}}while(0);rb=rb+2|0}while((rb|0)<(k|0))}o=o+2|0}while((o|0)<(xb|0));g0(a);u=h;return yb|0}if(!wb){g0(a);u=h;return yb|0}wb=f[c+16>>2]|0;o=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;K=f[f[e+44>>2]>>2]|0;e=(k|0)>0;s=0;do{i=wb+(Y(o,s)|0)|0;r=i+o|0;p=c+(Y(K,s)|0)|0;rb=p+K|0;if(e){ub=s|1;tb=(ub|0)<(xb|0);qb=(ub|0)<(xb|0);vb=(ub|0)<(xb|0);ob=(ub|0)<(xb|0);ub=0;do{sb=p+(ub<<1)|0;pb=d[sb>>1]|0;do if(!(pb<<16>>16)){d[sb>>1]=0;nb=ub|1;if((nb|0)<(k|0)){d[p+(nb<<1)>>1]=0;if(!tb)break;d[rb+(ub<<1)>>1]=0;d[rb+(nb<<1)>>1]=0;break}else{if(!qb)break;d[rb+(ub<<1)>>1]=0;break}}else{nb=d[a+((pb&65535)<<1)>>1]|0;d[sb>>1]=(b[i+ub>>0]|0)==0?0:nb;jb=ub|1;if((jb|0)<(k|0)){d[p+(jb<<1)>>1]=(b[i+jb>>0]|0)==0?0:nb;if(!vb)break;d[rb+(ub<<1)>>1]=(b[r+ub>>0]|0)==0?0:nb;lb=rb+(jb<<1)|0;if(!(b[r+jb>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=nb;break}}else{if(!ob)break;lb=rb+(ub<<1)|0;if(!(b[r+ub>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=nb;break}}}while(0);ub=ub+2|0}while((ub|0)<(k|0))}s=s+2|0}while((s|0)<(xb|0));g0(a);u=h;return yb|0}function yaa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0;g=u;u=u+16|0;a=g;h=f[c+8>>2]|0;i=d+8|0;if((h|0)!=(f[i>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;j=tT(a,26)|0;k=250083;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));taa(-215,a,518189,2589)}m=f[c+12>>2]|0;n=d+12|0;if((m|0)!=(f[n>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;j=tT(a,26)|0;k=250110;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));taa(-215,a,518189,2590)}if((e|0)!=8){f[a>>2]=0;f[a+4>>2]=0;j=tT(a,17)|0;k=250137;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));taa(-215,a,518189,2591)}a=f0((Y(((h+1|0)/2|0)<<2,(m+1|0)/2|0)|0)+4|0)|0;f[a>>2]=0;if((h|0)>0){k=c+16|0;j=c+44|0;l=d+16|0;e=d+44|0;o=(m|0)>0;p=1;q=0;while(1){r=f[f[j>>2]>>2]|0;s=(f[k>>2]|0)+(Y(r,q)|0)|0;t=0-r|0;v=s+t|0;w=v+t|0;t=s+r|0;r=f[f[e>>2]>>2]|0;x=(f[l>>2]|0)+(Y(r,q)|0)|0;y=0-r|0;r=x+y+y|0;if(o){y=(q|1|0)<(h|0);z=(q|0)>0;A=z^1;B=(q+-2|0)>-1;C=0;D=p;while(1){a:do if(!(b[s+C>>0]|0)){E=C|1;F=(E|0)<(m|0);if(y?b[t+C>>0]|0:0){G=C+-1|0;H=(C|0)>0;if(F?b[s+E>>0]|0:0){do if(H){if(b[s+G>>0]|0){do if(z){if(b[v+E>>0]|0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;J=C+-2|0;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}do if((J|0)>-1){if(!(b[v+J>>0]|0))break;if(b[w+G>>0]|0){f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}K=f[r+(C<<2)>>2]|0;L=f[x+(J<<2)>>2]|0;M=K;while(1){N=f[a+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((K|0)==(L|0))O=M;else{N=L;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;Q=L;do{R=a+(Q<<2)|0;S=Q;Q=f[R>>2]|0;f[R>>2]=P}while((Q|0)<(S|0));O=P}P=K;do{Q=a+(P<<2)|0;L=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(L|0));f[x+(C<<2)>>2]=O;I=D;break a}while(0);P=f[r+(C<<2)>>2]|0;K=f[x+(J<<2)>>2]|0;L=P;while(1){Q=f[a+(L<<2)>>2]|0;if((Q|0)<(L|0))L=Q;else break}if((P|0)==(K|0))T=L;else{J=K;while(1){Q=f[a+(J<<2)>>2]|0;if((Q|0)<(J|0))J=Q;else break}Q=(L|0)>(J|0)?J:L;M=K;do{N=a+(M<<2)|0;S=M;M=f[N>>2]|0;f[N>>2]=Q}while((M|0)<(S|0));T=Q}Q=P;do{M=a+(Q<<2)|0;K=Q;Q=f[M>>2]|0;f[M>>2]=T}while((Q|0)<(K|0));f[x+(C<<2)>>2]=T;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;P=f[x+(C+-2<<2)>>2]|0;K=Q;while(1){M=f[a+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((Q|0)==(P|0))U=K;else{M=P;while(1){L=f[a+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}L=(K|0)>(M|0)?M:K;J=P;do{S=a+(J<<2)|0;N=J;J=f[S>>2]|0;f[S>>2]=L}while((J|0)<(N|0));U=L}L=Q;do{J=a+(L<<2)|0;P=L;L=f[J>>2]|0;f[J>>2]=U}while((L|0)<(P|0));f[x+(C<<2)>>2]=U;I=D;break a}L=C+2|0;if((L|0)>=(m|0))break;if(!(b[v+L>>0]|0))break;do if(B){if(!(b[w+E>>0]|0))break;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[w+C>>0]|0)){Q=f[r+(L<<2)>>2]|0;P=f[x+(C+-2<<2)>>2]|0;J=Q;while(1){K=f[a+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}if((Q|0)==(P|0))V=J;else{K=P;while(1){M=f[a+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(J|0)>(K|0)?K:J;N=P;do{S=a+(N<<2)|0;R=N;N=f[S>>2]|0;f[S>>2]=M}while((N|0)<(R|0));V=M}M=Q;do{N=a+(M<<2)|0;P=M;M=f[N>>2]|0;f[N>>2]=V}while((M|0)<(P|0));f[x+(C<<2)>>2]=V;I=D;break a}M=C+-2|0;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+G>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}Q=f[r+(L<<2)>>2]|0;P=f[x+(M<<2)>>2]|0;N=Q;while(1){J=f[a+(N<<2)>>2]|0;if((J|0)<(N|0))N=J;else break}if((Q|0)==(P|0))W=N;else{J=P;while(1){K=f[a+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}K=(N|0)>(J|0)?J:N;R=P;do{S=a+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(X|0));W=K}K=Q;do{R=a+(K<<2)|0;P=K;K=f[R>>2]|0;f[R>>2]=W}while((K|0)<(P|0));f[x+(C<<2)>>2]=W;I=D;break a}while(0);K=f[r+(L<<2)>>2]|0;Q=f[x+(M<<2)>>2]|0;P=K;while(1){R=f[a+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}if((K|0)==(Q|0))Z=P;else{M=Q;while(1){R=f[a+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(P|0)>(M|0)?M:P;N=Q;do{J=a+(N<<2)|0;X=N;N=f[J>>2]|0;f[J>>2]=R}while((N|0)<(X|0));Z=R}R=K;do{N=a+(R<<2)|0;Q=R;R=f[N>>2]|0;f[N>>2]=Z}while((R|0)<(Q|0));f[x+(C<<2)>>2]=Z;I=D;break a}while(0);R=f[r+(L<<2)>>2]|0;K=f[x+(C+-2<<2)>>2]|0;Q=R;while(1){N=f[a+(Q<<2)>>2]|0;if((N|0)<(Q|0))Q=N;else break}if((R|0)==(K|0))_=Q;else{L=K;while(1){N=f[a+(L<<2)>>2]|0;if((N|0)<(L|0))L=N;else break}N=(Q|0)>(L|0)?L:Q;P=K;do{M=a+(P<<2)|0;X=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(X|0));_=N}N=R;do{P=a+(N<<2)|0;K=N;N=f[P>>2]|0;f[P>>2]=_}while((N|0)<(K|0));f[x+(C<<2)>>2]=_;I=D;break a}while(0);f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[t+G>>0]|0))break;do if(z){if(b[v+E>>0]|0){N=C+-2|0;do if((N|0)>-1){if(!(b[s+N>>0]|0))break;if(b[v+G>>0]|0){R=f[x+(N<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=R;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;P=K;while(1){Q=f[a+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}if((K|0)==(R|0))$=P;else{Q=R;while(1){L=f[a+(Q<<2)>>2]|0;if((L|0)<(Q|0))Q=L;else break}L=(P|0)>(Q|0)?Q:P;X=R;do{M=a+(X<<2)|0;J=X;X=f[M>>2]|0;f[M>>2]=L}while((X|0)<(J|0));$=L}L=K;do{X=a+(L<<2)|0;R=L;L=f[X>>2]|0;f[X>>2]=$}while((L|0)<(R|0));f[x+(C<<2)>>2]=$;I=D;break a}if(!(b[v+N>>0]|0)){L=f[r+(C<<2)>>2]|0;K=f[x+(N<<2)>>2]|0;R=L;while(1){X=f[a+(R<<2)>>2]|0;if((X|0)<(R|0))R=X;else break}if((L|0)==(K|0))aa=R;else{X=K;while(1){P=f[a+(X<<2)>>2]|0;if((P|0)<(X|0))X=P;else break}P=(R|0)>(X|0)?X:R;Q=K;do{J=a+(Q<<2)|0;M=Q;Q=f[J>>2]|0;f[J>>2]=P}while((Q|0)<(M|0));aa=P}P=L;do{Q=a+(P<<2)|0;K=P;P=f[Q>>2]|0;f[Q>>2]=aa}while((P|0)<(K|0));f[x+(C<<2)>>2]=aa;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;P=f[x+(N<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=P;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=P;I=D;break a}L=f[r+(C<<2)>>2]|0;K=L;while(1){Q=f[a+(K<<2)>>2]|0;if((Q|0)<(K|0))K=Q;else break}if((L|0)==(P|0))ba=K;else{Q=P;while(1){R=f[a+(Q<<2)>>2]|0;if((R|0)<(Q|0))Q=R;else break}R=(K|0)>(Q|0)?Q:K;X=P;do{M=a+(X<<2)|0;J=X;X=f[M>>2]|0;f[M>>2]=R}while((X|0)<(J|0));ba=R}R=L;do{X=a+(R<<2)|0;P=R;R=f[X>>2]|0;f[X>>2]=ba}while((R|0)<(P|0));f[x+(C<<2)>>2]=ba;I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;P=R;while(1){X=f[a+(P<<2)>>2]|0;if((X|0)<(P|0))P=X;else break}if((R|0)==(L|0))ca=P;else{X=L;while(1){K=f[a+(X<<2)>>2]|0;if((K|0)<(X|0))X=K;else break}K=(P|0)>(X|0)?X:P;Q=L;do{J=a+(Q<<2)|0;M=Q;Q=f[J>>2]|0;f[J>>2]=K}while((Q|0)<(M|0));ca=K}K=R;do{Q=a+(K<<2)|0;L=K;K=f[Q>>2]|0;f[Q>>2]=ca}while((K|0)<(L|0));f[x+(C<<2)>>2]=ca;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;R=f[x+(N<<2)>>2]|0;L=K;while(1){Q=f[a+(L<<2)>>2]|0;if((Q|0)<(L|0))L=Q;else break}if((K|0)==(R|0))da=L;else{N=R;while(1){Q=f[a+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=(L|0)>(N|0)?N:L;P=R;do{X=a+(P<<2)|0;M=P;P=f[X>>2]|0;f[X>>2]=Q}while((P|0)<(M|0));da=Q}Q=K;do{P=a+(Q<<2)|0;R=Q;Q=f[P>>2]|0;f[P>>2]=da}while((Q|0)<(R|0));f[x+(C<<2)>>2]=da;I=D;break a}Q=C+2|0;do if(!((Q|0)>=(m|0)|A)){if(!(b[v+Q>>0]|0))break;do if(B){if(!(b[w+E>>0]|0))break;K=C+-2|0;do if((K|0)>-1){if(!(b[s+K>>0]|0))break;if(b[v+G>>0]|0){R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}P=f[r+(Q<<2)>>2]|0;L=P;while(1){N=f[a+(L<<2)>>2]|0;if((N|0)<(L|0))L=N;else break}if((P|0)==(R|0))ea=L;else{N=R;while(1){M=f[a+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(L|0)>(N|0)?N:L;X=R;do{J=a+(X<<2)|0;S=X;X=f[J>>2]|0;f[J>>2]=M}while((X|0)<(S|0));ea=M}M=P;do{X=a+(M<<2)|0;R=M;M=f[X>>2]|0;f[X>>2]=ea}while((M|0)<(R|0));f[x+(C<<2)>>2]=ea;I=D;break a}if(!(b[v+K>>0]|0)){M=f[r+(Q<<2)>>2]|0;P=f[x+(K<<2)>>2]|0;R=M;while(1){X=f[a+(R<<2)>>2]|0;if((X|0)<(R|0))R=X;else break}if((M|0)==(P|0))fa=R;else{X=P;while(1){L=f[a+(X<<2)>>2]|0;if((L|0)<(X|0))X=L;else break}L=(R|0)>(X|0)?X:R;N=P;do{S=a+(N<<2)|0;J=N;N=f[S>>2]|0;f[S>>2]=L}while((N|0)<(J|0));fa=L}L=M;do{N=a+(L<<2)|0;P=L;L=f[N>>2]|0;f[N>>2]=fa}while((L|0)<(P|0));f[x+(C<<2)>>2]=fa;I=D;break a}if(!(b[w+G>>0]|0)){L=f[r+(Q<<2)>>2]|0;M=f[x+(K<<2)>>2]|0;P=L;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}if((L|0)==(M|0))ga=P;else{N=M;while(1){R=f[a+(N<<2)>>2]|0;if((R|0)<(N|0))N=R;else break}R=(P|0)>(N|0)?N:P;X=M;do{J=a+(X<<2)|0;S=X;X=f[J>>2]|0;f[J>>2]=R}while((X|0)<(S|0));ga=R}R=L;do{X=a+(R<<2)|0;M=R;R=f[X>>2]|0;f[X>>2]=ga}while((R|0)<(M|0));f[x+(C<<2)>>2]=ga;I=D;break a}R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}L=f[r+(Q<<2)>>2]|0;M=L;while(1){X=f[a+(M<<2)>>2]|0;if((X|0)<(M|0))M=X;else break}if((L|0)==(R|0))ha=M;else{X=R;while(1){P=f[a+(X<<2)>>2]|0;if((P|0)<(X|0))X=P;else break}P=(M|0)>(X|0)?X:M;N=R;do{S=a+(N<<2)|0;J=N;N=f[S>>2]|0;f[S>>2]=P}while((N|0)<(J|0));ha=P}P=L;do{N=a+(P<<2)|0;R=P;P=f[N>>2]|0;f[N>>2]=ha}while((P|0)<(R|0));f[x+(C<<2)>>2]=ha;I=D;break a}while(0);P=f[r+(Q<<2)>>2]|0;L=f[x+(K<<2)>>2]|0;R=P;while(1){N=f[a+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(L|0))ia=R;else{K=L;while(1){N=f[a+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(R|0)>(K|0)?K:R;M=L;do{X=a+(M<<2)|0;J=M;M=f[X>>2]|0;f[X>>2]=N}while((M|0)<(J|0));ia=N}N=P;do{M=a+(N<<2)|0;L=N;N=f[M>>2]|0;f[M>>2]=ia}while((N|0)<(L|0));f[x+(C<<2)>>2]=ia;I=D;break a}while(0);N=C+-2|0;if(!(b[v+C>>0]|0)){P=f[r+(Q<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;M=P;while(1){R=f[a+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((P|0)==(L|0))ja=M;else{R=L;while(1){K=f[a+(R<<2)>>2]|0;if((K|0)<(R|0))R=K;else break}K=(M|0)>(R|0)?R:M;J=L;do{X=a+(J<<2)|0;S=J;J=f[X>>2]|0;f[X>>2]=K}while((J|0)<(S|0));ja=K}K=P;do{J=a+(K<<2)|0;L=K;K=f[J>>2]|0;f[J>>2]=ja}while((K|0)<(L|0));f[x+(C<<2)>>2]=ja;I=D;break a}do if((N|0)>-1){if(!(b[s+N>>0]|0))break;if(b[v+G>>0]|0){K=f[r+(Q<<2)>>2]|0;P=f[x+(N<<2)>>2]|0;L=K;while(1){J=f[a+(L<<2)>>2]|0;if((J|0)<(L|0))L=J;else break}if((K|0)==(P|0))ka=L;else{J=P;while(1){M=f[a+(J<<2)>>2]|0;if((M|0)<(J|0))J=M;else break}M=(L|0)>(J|0)?J:L;R=P;do{S=a+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=M}while((R|0)<(X|0));ka=M}M=K;do{R=a+(M<<2)|0;P=M;M=f[R>>2]|0;f[R>>2]=ka}while((M|0)<(P|0));f[x+(C<<2)>>2]=ka;I=D;break a}if(!(b[v+N>>0]|0)){M=f[r+(C<<2)>>2]|0;K=f[r+(Q<<2)>>2]|0;P=M;while(1){R=f[a+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}if((M|0)==(K|0))la=P;else{R=K;while(1){L=f[a+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(P|0)>(R|0)?R:P;J=K;do{X=a+(J<<2)|0;S=J;J=f[X>>2]|0;f[X>>2]=L}while((J|0)<(S|0));la=L}L=M;do{J=a+(L<<2)|0;K=L;L=f[J>>2]|0;f[J>>2]=la}while((L|0)<(K|0));L=f[x+(N<<2)>>2]|0;M=la;while(1){K=f[a+(M<<2)>>2]|0;if((K|0)<(M|0))M=K;else break}if((la|0)==(L|0))ma=M;else{K=L;while(1){J=f[a+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}J=(M|0)>(K|0)?K:M;P=L;do{R=a+(P<<2)|0;S=P;P=f[R>>2]|0;f[R>>2]=J}while((P|0)<(S|0));ma=J}J=la;do{P=a+(J<<2)|0;L=J;J=f[P>>2]|0;f[P>>2]=ma}while((J|0)<(L|0));f[x+(C<<2)>>2]=ma;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;J=f[r+(Q<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;P=J;while(1){M=f[a+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((J|0)==(L|0))na=P;else{M=L;while(1){K=f[a+(M<<2)>>2]|0;if((K|0)<(M|0))M=K;else break}K=(P|0)>(M|0)?M:P;S=L;do{R=a+(S<<2)|0;X=S;S=f[R>>2]|0;f[R>>2]=K}while((S|0)<(X|0));na=K}K=J;do{S=a+(K<<2)|0;L=K;K=f[S>>2]|0;f[S>>2]=na}while((K|0)<(L|0));f[x+(C<<2)>>2]=na;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;J=f[r+(Q<<2)>>2]|0;L=K;while(1){S=f[a+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}if((K|0)==(J|0))oa=L;else{S=J;while(1){P=f[a+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(L|0)>(S|0)?S:L;M=J;do{X=a+(M<<2)|0;R=M;M=f[X>>2]|0;f[X>>2]=P}while((M|0)<(R|0));oa=P}P=K;do{M=a+(P<<2)|0;J=P;P=f[M>>2]|0;f[M>>2]=oa}while((P|0)<(J|0));P=f[x+(N<<2)>>2]|0;K=oa;while(1){J=f[a+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}if((oa|0)==(P|0))pa=K;else{J=P;while(1){M=f[a+(J<<2)>>2]|0;if((M|0)<(J|0))J=M;else break}M=(K|0)>(J|0)?J:K;L=P;do{S=a+(L<<2)|0;R=L;L=f[S>>2]|0;f[S>>2]=M}while((L|0)<(R|0));pa=M}M=oa;do{L=a+(M<<2)|0;P=M;M=f[L>>2]|0;f[L>>2]=pa}while((M|0)<(P|0));f[x+(C<<2)>>2]=pa;I=D;break a}while(0);M=f[r+(C<<2)>>2]|0;P=f[r+(Q<<2)>>2]|0;L=M;while(1){K=f[a+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}if((M|0)==(P|0))qa=L;else{K=P;while(1){J=f[a+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}J=(L|0)>(K|0)?K:L;R=P;do{S=a+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=J}while((R|0)<(X|0));qa=J}J=M;do{R=a+(J<<2)|0;P=J;J=f[R>>2]|0;f[R>>2]=qa}while((J|0)<(P|0));J=f[x+(N<<2)>>2]|0;M=qa;while(1){P=f[a+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((qa|0)==(J|0))ra=M;else{N=J;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;R=J;do{L=a+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=P}while((R|0)<(K|0));ra=P}P=qa;do{R=a+(P<<2)|0;J=P;P=f[R>>2]|0;f[R>>2]=ra}while((P|0)<(J|0));f[x+(C<<2)>>2]=ra;I=D;break a}while(0);Q=C+-2|0;if(!(b[v+C>>0]|0)){sa=Q;break}do if((Q|0)>-1){if(!(b[s+Q>>0]|0))break;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(Q<<2)>>2];I=D;break a}if(!(b[v+Q>>0]|0)){P=f[r+(C<<2)>>2]|0;J=f[x+(Q<<2)>>2]|0;R=P;while(1){M=f[a+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((P|0)==(J|0))ta=R;else{M=J;while(1){N=f[a+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(R|0)>(M|0)?M:R;K=J;do{L=a+(K<<2)|0;X=K;K=f[L>>2]|0;f[L>>2]=N}while((K|0)<(X|0));ta=N}N=P;do{K=a+(N<<2)|0;J=N;N=f[K>>2]|0;f[K>>2]=ta}while((N|0)<(J|0));f[x+(C<<2)>>2]=ta;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;f[x+(C<<2)>>2]=f[x+(Q<<2)>>2];I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;P=f[x+(Q<<2)>>2]|0;J=N;while(1){K=f[a+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}if((N|0)==(P|0))ua=J;else{K=P;while(1){R=f[a+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}R=(J|0)>(K|0)?K:J;M=P;do{X=a+(M<<2)|0;L=M;M=f[X>>2]|0;f[X>>2]=R}while((M|0)<(L|0));ua=R}R=N;do{M=a+(R<<2)|0;P=R;R=f[M>>2]|0;f[M>>2]=ua}while((R|0)<(P|0));f[x+(C<<2)>>2]=ua;I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;N=f[x+(Q<<2)>>2]|0;P=R;while(1){M=f[a+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((R|0)==(N|0))va=P;else{Q=N;while(1){M=f[a+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}M=(P|0)>(Q|0)?Q:P;J=N;do{K=a+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=M}while((J|0)<(L|0));va=M}M=R;do{J=a+(M<<2)|0;N=M;M=f[J>>2]|0;f[J>>2]=va}while((M|0)<(N|0));f[x+(C<<2)>>2]=va;I=D;break a}else sa=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(sa<<2)>>2];I=D;break a}while(0);do if(z){if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}M=C+2|0;do if(!((M|0)>=(m|0)|A)){if(!(b[v+M>>0]|0))break;if(!(b[v+C>>0]|0)){f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;N=f[r+(M<<2)>>2]|0;J=R;while(1){P=f[a+(J<<2)>>2]|0;if((P|0)<(J|0))J=P;else break}if((R|0)==(N|0))wa=J;else{P=N;while(1){Q=f[a+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(J|0)>(P|0)?P:J;L=N;do{K=a+(L<<2)|0;X=L;L=f[K>>2]|0;f[K>>2]=Q}while((L|0)<(X|0));wa=Q}Q=R;do{L=a+(Q<<2)|0;N=Q;Q=f[L>>2]|0;f[L>>2]=wa}while((Q|0)<(N|0));f[x+(C<<2)>>2]=wa;I=D;break a}while(0);if(!(b[v+C>>0]|0))break;f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}while(0);f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break}if(H){if(b[t+G>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}if(b[s+G>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}}f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break}do if(F){if(!(b[s+E>>0]|0)){if(!y)break;if(!(b[t+E>>0]|0))break;f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break a}if(z){if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}M=C+2|0;do if(!((M|0)>=(m|0)|A)){if(!(b[v+M>>0]|0))break;if(!(b[v+C>>0]|0)){f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;R=f[r+(M<<2)>>2]|0;N=Q;while(1){L=f[a+(N<<2)>>2]|0;if((L|0)<(N|0))N=L;else break}if((Q|0)==(R|0))xa=N;else{L=R;while(1){J=f[a+(L<<2)>>2]|0;if((J|0)<(L|0))L=J;else break}J=(N|0)>(L|0)?L:N;P=R;do{X=a+(P<<2)|0;K=P;P=f[X>>2]|0;f[X>>2]=J}while((P|0)<(K|0));xa=J}J=Q;do{P=a+(J<<2)|0;R=J;J=f[P>>2]|0;f[P>>2]=xa}while((J|0)<(R|0));f[x+(C<<2)>>2]=xa;I=D;break a}while(0);if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}}f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break a}while(0);f[x+(C<<2)>>2]=0;I=D}else{E=C+-1|0;F=(C|0)>0;if(F){if(b[s+E>>0]|0){G=C|1;H=(G|0)<(m|0);if(z&H?b[v+G>>0]|0:0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}do if(B){if(!(b[w+C>>0]|0))break;M=C+-2|0;if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+E>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}J=f[r+(C<<2)>>2]|0;Q=f[x+(M<<2)>>2]|0;R=J;while(1){P=f[a+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((J|0)==(Q|0))ya=R;else{P=Q;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;L=Q;do{K=a+(L<<2)|0;X=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(X|0));ya=N}N=J;do{L=a+(N<<2)|0;Q=N;N=f[L>>2]|0;f[L>>2]=ya}while((N|0)<(Q|0));f[x+(C<<2)>>2]=ya;I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;J=f[x+(M<<2)>>2]|0;Q=N;while(1){L=f[a+(Q<<2)>>2]|0;if((L|0)<(Q|0))Q=L;else break}if((N|0)==(J|0))za=Q;else{M=J;while(1){L=f[a+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}L=(Q|0)>(M|0)?M:Q;R=J;do{P=a+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=L}while((R|0)<(X|0));za=L}L=N;do{R=a+(L<<2)|0;J=L;L=f[R>>2]|0;f[R>>2]=za}while((L|0)<(J|0));f[x+(C<<2)>>2]=za;I=D;break a}while(0);L=f[r+(C<<2)>>2]|0;N=f[x+(C+-2<<2)>>2]|0;J=L;while(1){R=f[a+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((L|0)==(N|0))Aa=J;else{R=N;while(1){Q=f[a+(R<<2)>>2]|0;if((Q|0)<(R|0))R=Q;else break}Q=(J|0)>(R|0)?R:J;M=N;do{X=a+(M<<2)|0;P=M;M=f[X>>2]|0;f[X>>2]=Q}while((M|0)<(P|0));Aa=Q}Q=L;do{M=a+(Q<<2)|0;N=Q;Q=f[M>>2]|0;f[M>>2]=Aa}while((Q|0)<(N|0));f[x+(C<<2)>>2]=Aa;I=D;break}if(H?b[s+G>>0]|0:0){Q=C+2|0;do if(z&(Q|0)<(m|0)){if(!(b[v+Q>>0]|0))break;do if(B){if(!(b[w+G>>0]|0))break;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[w+C>>0]|0)){L=f[r+(Q<<2)>>2]|0;N=f[x+(C+-2<<2)>>2]|0;M=L;while(1){J=f[a+(M<<2)>>2]|0;if((J|0)<(M|0))M=J;else break}if((L|0)==(N|0))Ba=M;else{J=N;while(1){R=f[a+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}R=(M|0)>(J|0)?J:M;P=N;do{X=a+(P<<2)|0;K=P;P=f[X>>2]|0;f[X>>2]=R}while((P|0)<(K|0));Ba=R}R=L;do{P=a+(R<<2)|0;N=R;R=f[P>>2]|0;f[P>>2]=Ba}while((R|0)<(N|0));f[x+(C<<2)>>2]=Ba;I=D;break a}R=C+-2|0;if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[x+(R<<2)>>2];I=D;break a}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+E>>0]|0){f[x+(C<<2)>>2]=f[x+(R<<2)>>2];I=D;break a}L=f[r+(Q<<2)>>2]|0;N=f[x+(R<<2)>>2]|0;P=L;while(1){M=f[a+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((L|0)==(N|0))Ca=P;else{M=N;while(1){J=f[a+(M<<2)>>2]|0;if((J|0)<(M|0))M=J;else break}J=(P|0)>(M|0)?M:P;K=N;do{X=a+(K<<2)|0;S=K;K=f[X>>2]|0;f[X>>2]=J}while((K|0)<(S|0));Ca=J}J=L;do{K=a+(J<<2)|0;N=J;J=f[K>>2]|0;f[K>>2]=Ca}while((J|0)<(N|0));f[x+(C<<2)>>2]=Ca;I=D;break a}while(0);J=f[r+(Q<<2)>>2]|0;L=f[x+(R<<2)>>2]|0;N=J;while(1){K=f[a+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((J|0)==(L|0))Da=N;else{R=L;while(1){K=f[a+(R<<2)>>2]|0;if((K|0)<(R|0))R=K;else break}K=(N|0)>(R|0)?R:N;P=L;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=K}while((P|0)<(S|0));Da=K}K=J;do{P=a+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=Da}while((K|0)<(L|0));f[x+(C<<2)>>2]=Da;I=D;break a}while(0);K=f[r+(Q<<2)>>2]|0;J=f[x+(C+-2<<2)>>2]|0;L=K;while(1){P=f[a+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((K|0)==(J|0))Ea=L;else{P=J;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(L|0)>(P|0)?P:L;R=J;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=N}while((R|0)<(M|0));Ea=N}N=K;do{R=a+(N<<2)|0;J=N;N=f[R>>2]|0;f[R>>2]=Ea}while((N|0)<(J|0));f[x+(C<<2)>>2]=Ea;I=D;break a}while(0);f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}if(y?b[t+E>>0]|0:0){Q=C|1;G=(Q|0)<(m|0);if(!(A|G^1)?b[v+Q>>0]|0:0){H=C+-2|0;do if((H|0)>-1){if(!(b[s+H>>0]|0))break;if(b[v+E>>0]|0){N=f[x+(H<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=N;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;J=K;while(1){R=f[a+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((K|0)==(N|0))Fa=J;else{R=N;while(1){L=f[a+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(J|0)>(R|0)?R:J;P=N;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=L}while((P|0)<(S|0));Fa=L}L=K;do{P=a+(L<<2)|0;N=L;L=f[P>>2]|0;f[P>>2]=Fa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Fa;I=D;break a}if(!(b[v+H>>0]|0)){L=f[r+(C<<2)>>2]|0;K=f[x+(H<<2)>>2]|0;N=L;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((L|0)==(K|0))Ga=N;else{P=K;while(1){J=f[a+(P<<2)>>2]|0;if((J|0)<(P|0))P=J;else break}J=(N|0)>(P|0)?P:N;R=K;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=J}while((R|0)<(M|0));Ga=J}J=L;do{R=a+(J<<2)|0;K=J;J=f[R>>2]|0;f[R>>2]=Ga}while((J|0)<(K|0));f[x+(C<<2)>>2]=Ga;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;J=f[x+(H<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}L=f[r+(C<<2)>>2]|0;K=L;while(1){R=f[a+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}if((L|0)==(J|0))Ha=K;else{R=J;while(1){N=f[a+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(K|0)>(R|0)?R:K;P=J;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(S|0));Ha=N}N=L;do{P=a+(N<<2)|0;J=N;N=f[P>>2]|0;f[P>>2]=Ha}while((N|0)<(J|0));f[x+(C<<2)>>2]=Ha;I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;L=f[x+(H<<2)>>2]|0;J=N;while(1){P=f[a+(J<<2)>>2]|0;if((P|0)<(J|0))J=P;else break}if((N|0)==(L|0))Ia=J;else{P=L;while(1){K=f[a+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(J|0)>(P|0)?P:J;R=L;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(M|0));Ia=K}K=N;do{R=a+(K<<2)|0;L=K;K=f[R>>2]|0;f[R>>2]=Ia}while((K|0)<(L|0));f[x+(C<<2)>>2]=Ia;I=D;break a}while(0);if(b[v+C>>0]|0){K=f[r+(C<<2)>>2]|0;N=f[x+(H<<2)>>2]|0;L=K;while(1){R=f[a+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((K|0)==(N|0))Ja=L;else{R=N;while(1){J=f[a+(R<<2)>>2]|0;if((J|0)<(R|0))R=J;else break}J=(L|0)>(R|0)?R:L;P=N;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=J}while((P|0)<(S|0));Ja=J}J=K;do{P=a+(J<<2)|0;N=J;J=f[P>>2]|0;f[P>>2]=Ja}while((J|0)<(N|0));f[x+(C<<2)>>2]=Ja;I=D;break}J=f[r+(C<<2)>>2]|0;if(!(b[v+E>>0]|0)){K=f[x+(H<<2)>>2]|0;N=J;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((J|0)==(K|0))Ka=N;else{P=K;while(1){L=f[a+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=K;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=L}while((R|0)<(M|0));Ka=L}L=J;do{R=a+(L<<2)|0;K=L;L=f[R>>2]|0;f[R>>2]=Ka}while((L|0)<(K|0));f[x+(C<<2)>>2]=Ka;I=D;break}do if(B){if(!(b[w+C>>0]|0))break;L=f[x+(H<<2)>>2]|0;K=J;while(1){R=f[a+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}if((J|0)==(L|0))La=K;else{R=L;while(1){N=f[a+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(K|0)>(R|0)?R:K;P=L;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(S|0));La=N}N=J;do{P=a+(N<<2)|0;L=N;N=f[P>>2]|0;f[P>>2]=La}while((N|0)<(L|0));f[x+(C<<2)>>2]=La;I=D;break a}while(0);N=f[r+(H<<2)>>2]|0;L=N;while(1){P=f[a+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((N|0)==(J|0))Ma=L;else{P=J;while(1){K=f[a+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(L|0)>(P|0)?P:L;R=J;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(M|0));Ma=K}K=N;do{R=a+(K<<2)|0;J=K;K=f[R>>2]|0;f[R>>2]=Ma}while((K|0)<(J|0));K=f[x+(H<<2)>>2]|0;N=Ma;while(1){J=f[a+(N<<2)>>2]|0;if((J|0)<(N|0))N=J;else break}if((Ma|0)==(K|0))Na=N;else{H=K;while(1){J=f[a+(H<<2)>>2]|0;if((J|0)<(H|0))H=J;else break}J=(N|0)>(H|0)?H:N;R=K;do{L=a+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=J}while((R|0)<(P|0));Na=J}J=Ma;do{R=a+(J<<2)|0;K=J;J=f[R>>2]|0;f[R>>2]=Na}while((J|0)<(K|0));f[x+(C<<2)>>2]=Na;I=D;break}if(G?b[s+Q>>0]|0:0){J=C+2|0;do if(!((J|0)>=(m|0)|A)){if(!(b[v+J>>0]|0))break;K=C+-2|0;do if((K|0)>-1){if(!(b[s+K>>0]|0))break;if(b[v+E>>0]|0){do if(B){if(!(b[w+Q>>0]|0))break;R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}N=f[r+(J<<2)>>2]|0;H=N;while(1){P=f[a+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((N|0)==(R|0))Oa=H;else{P=R;while(1){L=f[a+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(H|0)>(P|0)?P:H;M=R;do{S=a+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=L}while((M|0)<(X|0));Oa=L}L=N;do{M=a+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=Oa}while((L|0)<(R|0));f[x+(C<<2)>>2]=Oa;I=D;break a}while(0);L=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=L;while(1){M=f[a+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((L|0)==(N|0))Pa=R;else{M=N;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(R|0)>(M|0)?M:R;P=N;do{X=a+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=H}while((P|0)<(S|0));Pa=H}H=L;do{P=a+(H<<2)|0;N=H;H=f[P>>2]|0;f[P>>2]=Pa}while((H|0)<(N|0));f[x+(C<<2)>>2]=Pa;I=D;break a}do if(B){if(!(b[w+Q>>0]|0))break;if(!(b[v+K>>0]|0)){H=f[r+(J<<2)>>2]|0;L=f[x+(K<<2)>>2]|0;N=H;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((H|0)==(L|0))Qa=N;else{P=L;while(1){R=f[a+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(N|0)>(P|0)?P:N;M=L;do{S=a+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=R}while((M|0)<(X|0));Qa=R}R=H;do{M=a+(R<<2)|0;L=R;R=f[M>>2]|0;f[M>>2]=Qa}while((R|0)<(L|0));f[x+(C<<2)>>2]=Qa;I=D;break a}if(!(b[w+E>>0]|0)){R=f[r+(J<<2)>>2]|0;H=f[x+(K<<2)>>2]|0;L=R;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((R|0)==(H|0))Ra=L;else{M=H;while(1){N=f[a+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(L|0)>(M|0)?M:L;P=H;do{X=a+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=N}while((P|0)<(S|0));Ra=N}N=R;do{P=a+(N<<2)|0;H=N;N=f[P>>2]|0;f[P>>2]=Ra}while((N|0)<(H|0));f[x+(C<<2)>>2]=Ra;I=D;break a}N=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}R=f[r+(J<<2)>>2]|0;H=R;while(1){P=f[a+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((R|0)==(N|0))Sa=H;else{P=N;while(1){L=f[a+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(H|0)>(P|0)?P:H;M=N;do{S=a+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=L}while((M|0)<(X|0));Sa=L}L=R;do{M=a+(L<<2)|0;N=L;L=f[M>>2]|0;f[M>>2]=Sa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Sa;I=D;break a}while(0);if(!(b[v+C>>0]|0)){L=f[r+(J<<2)>>2]|0;R=f[x+(K<<2)>>2]|0;N=L;while(1){M=f[a+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}if((L|0)==(R|0))Ta=N;else{M=R;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(N|0)>(M|0)?M:N;P=R;do{X=a+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=H}while((P|0)<(S|0));Ta=H}H=L;do{P=a+(H<<2)|0;R=H;H=f[P>>2]|0;f[P>>2]=Ta}while((H|0)<(R|0));f[x+(C<<2)>>2]=Ta;I=D;break a}if(!(b[v+K>>0]|0)){H=f[r+(C<<2)>>2]|0;L=f[r+(J<<2)>>2]|0;R=H;while(1){P=f[a+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((H|0)==(L|0))Ua=R;else{P=L;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;M=L;do{S=a+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=N}while((M|0)<(X|0));Ua=N}N=H;do{M=a+(N<<2)|0;L=N;N=f[M>>2]|0;f[M>>2]=Ua}while((N|0)<(L|0));N=f[x+(K<<2)>>2]|0;H=Ua;while(1){L=f[a+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}if((Ua|0)==(N|0))Va=H;else{L=N;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(H|0)>(L|0)?L:H;R=N;do{P=a+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=M}while((R|0)<(X|0));Va=M}M=Ua;do{R=a+(M<<2)|0;N=M;M=f[R>>2]|0;f[R>>2]=Va}while((M|0)<(N|0));f[x+(C<<2)>>2]=Va;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;M=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=M;while(1){H=f[a+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}if((M|0)==(N|0))Wa=R;else{H=N;while(1){L=f[a+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}L=(R|0)>(H|0)?H:R;X=N;do{P=a+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=L}while((X|0)<(S|0));Wa=L}L=M;do{X=a+(L<<2)|0;N=L;L=f[X>>2]|0;f[X>>2]=Wa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Wa;I=D;break a}while(0);L=f[r+(C<<2)>>2]|0;M=f[r+(J<<2)>>2]|0;N=L;while(1){X=f[a+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((L|0)==(M|0))Xa=N;else{X=M;while(1){R=f[a+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(N|0)>(X|0)?X:N;H=M;do{S=a+(H<<2)|0;P=H;H=f[S>>2]|0;f[S>>2]=R}while((H|0)<(P|0));Xa=R}R=L;do{H=a+(R<<2)|0;M=R;R=f[H>>2]|0;f[H>>2]=Xa}while((R|0)<(M|0));R=f[x+(K<<2)>>2]|0;L=Xa;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((Xa|0)==(R|0))Ya=L;else{M=R;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(L|0)>(M|0)?M:L;N=R;do{X=a+(N<<2)|0;P=N;N=f[X>>2]|0;f[X>>2]=H}while((N|0)<(P|0));Ya=H}H=Xa;do{N=a+(H<<2)|0;R=H;H=f[N>>2]|0;f[N>>2]=Ya}while((H|0)<(R|0));f[x+(C<<2)>>2]=Ya;I=D;break a}while(0);if(b[v+C>>0]|0){do if(B){if(!(b[w+Q>>0]|0))break;H=f[r+(J<<2)>>2]|0;R=f[x+(K<<2)>>2]|0;N=H;while(1){L=f[a+(N<<2)>>2]|0;if((L|0)<(N|0))N=L;else break}if((H|0)==(R|0))Za=N;else{L=R;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(N|0)>(L|0)?L:N;P=R;do{X=a+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=M}while((P|0)<(S|0));Za=M}M=H;do{P=a+(M<<2)|0;R=M;M=f[P>>2]|0;f[P>>2]=Za}while((M|0)<(R|0));f[x+(C<<2)>>2]=Za;I=D;break a}while(0);M=f[r+(C<<2)>>2]|0;H=f[r+(J<<2)>>2]|0;R=M;while(1){P=f[a+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(H|0))_a=R;else{P=H;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;L=H;do{S=a+(L<<2)|0;X=L;L=f[S>>2]|0;f[S>>2]=N}while((L|0)<(X|0));_a=N}N=M;do{L=a+(N<<2)|0;H=N;N=f[L>>2]|0;f[L>>2]=_a}while((N|0)<(H|0));N=f[x+(K<<2)>>2]|0;M=_a;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}if((_a|0)==(N|0))$a=M;else{H=N;while(1){L=f[a+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}L=(M|0)>(H|0)?H:M;R=N;do{P=a+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=L}while((R|0)<(X|0));$a=L}L=_a;do{R=a+(L<<2)|0;N=L;L=f[R>>2]|0;f[R>>2]=$a}while((L|0)<(N|0));f[x+(C<<2)>>2]=$a;I=D;break a}if(!(b[v+E>>0]|0)){L=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=L;while(1){M=f[a+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((L|0)==(N|0))ab=R;else{M=N;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(R|0)>(M|0)?M:R;X=N;do{P=a+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=H}while((X|0)<(S|0));ab=H}H=L;do{X=a+(H<<2)|0;N=H;H=f[X>>2]|0;f[X>>2]=ab}while((H|0)<(N|0));f[x+(C<<2)>>2]=ab;I=D;break a}do if(B){if(!(b[w+Q>>0]|0))break;H=f[r+(J<<2)>>2]|0;if(b[w+C>>0]|0){L=f[x+(K<<2)>>2]|0;N=H;while(1){X=f[a+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((H|0)==(L|0))bb=N;else{X=L;while(1){R=f[a+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(N|0)>(X|0)?X:N;M=L;do{S=a+(M<<2)|0;P=M;M=f[S>>2]|0;f[S>>2]=R}while((M|0)<(P|0));bb=R}R=H;do{M=a+(R<<2)|0;L=R;R=f[M>>2]|0;f[M>>2]=bb}while((R|0)<(L|0));f[x+(C<<2)>>2]=bb;I=D;break a}R=f[r+(K<<2)>>2]|0;L=R;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((R|0)==(H|0))cb=L;else{M=H;while(1){N=f[a+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(L|0)>(M|0)?M:L;X=H;do{P=a+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=N}while((X|0)<(S|0));cb=N}N=R;do{X=a+(N<<2)|0;H=N;N=f[X>>2]|0;f[X>>2]=cb}while((N|0)<(H|0));N=f[x+(K<<2)>>2]|0;R=cb;while(1){H=f[a+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}if((cb|0)==(N|0))db=R;else{H=N;while(1){X=f[a+(H<<2)>>2]|0;if((X|0)<(H|0))H=X;else break}X=(R|0)>(H|0)?H:R;L=N;do{M=a+(L<<2)|0;S=L;L=f[M>>2]|0;f[M>>2]=X}while((L|0)<(S|0));db=X}X=cb;do{L=a+(X<<2)|0;N=X;X=f[L>>2]|0;f[L>>2]=db}while((X|0)<(N|0));f[x+(C<<2)>>2]=db;I=D;break a}while(0);X=f[r+(K<<2)>>2]|0;N=f[r+(J<<2)>>2]|0;L=X;while(1){R=f[a+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((X|0)==(N|0))eb=L;else{R=N;while(1){H=f[a+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}H=(L|0)>(R|0)?R:L;S=N;do{M=a+(S<<2)|0;P=S;S=f[M>>2]|0;f[M>>2]=H}while((S|0)<(P|0));eb=H}H=X;do{S=a+(H<<2)|0;N=H;H=f[S>>2]|0;f[S>>2]=eb}while((H|0)<(N|0));H=f[x+(K<<2)>>2]|0;X=eb;while(1){N=f[a+(X<<2)>>2]|0;if((N|0)<(X|0))X=N;else break}if((eb|0)==(H|0))fb=X;else{K=H;while(1){N=f[a+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(X|0)>(K|0)?K:X;S=H;do{L=a+(S<<2)|0;R=S;S=f[L>>2]|0;f[L>>2]=N}while((S|0)<(R|0));fb=N}N=eb;do{S=a+(N<<2)|0;H=N;N=f[S>>2]|0;f[S>>2]=fb}while((N|0)<(H|0));f[x+(C<<2)>>2]=fb;I=D;break a}while(0);do if(z){J=C+-2|0;if(b[v+E>>0]|0){Q=f[x+(J<<2)>>2]|0;do if((J|0)>-1){if(!(b[s+J>>0]|0))break;f[x+(C<<2)>>2]=Q;I=D;break a}while(0);G=f[r+(J<<2)>>2]|0;N=G;while(1){H=f[a+(N<<2)>>2]|0;if((H|0)<(N|0))N=H;else break}if((G|0)==(Q|0))gb=N;else{H=Q;while(1){S=f[a+(H<<2)>>2]|0;if((S|0)<(H|0))H=S;else break}S=(N|0)>(H|0)?H:N;X=Q;do{K=a+(X<<2)|0;R=X;X=f[K>>2]|0;f[K>>2]=S}while((X|0)<(R|0));gb=S}S=G;do{X=a+(S<<2)|0;Q=S;S=f[X>>2]|0;f[X>>2]=gb}while((S|0)<(Q|0));f[x+(C<<2)>>2]=gb;I=D;break a}if(!(b[v+C>>0]|0)){hb=J;break}do if((J|0)>-1){if(!(b[s+J>>0]|0))break;if(!(b[v+J>>0]|0)){S=f[r+(C<<2)>>2]|0;G=f[x+(J<<2)>>2]|0;Q=S;while(1){X=f[a+(Q<<2)>>2]|0;if((X|0)<(Q|0))Q=X;else break}if((S|0)==(G|0))ib=Q;else{X=G;while(1){N=f[a+(X<<2)>>2]|0;if((N|0)<(X|0))X=N;else break}N=(Q|0)>(X|0)?X:Q;H=G;do{R=a+(H<<2)|0;K=H;H=f[R>>2]|0;f[R>>2]=N}while((H|0)<(K|0));ib=N}N=S;do{H=a+(N<<2)|0;G=N;N=f[H>>2]|0;f[H>>2]=ib}while((N|0)<(G|0));f[x+(C<<2)>>2]=ib;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;S=f[x+(J<<2)>>2]|0;G=N;while(1){H=f[a+(G<<2)>>2]|0;if((H|0)<(G|0))G=H;else break}if((N|0)==(S|0))jb=G;else{H=S;while(1){Q=f[a+(H<<2)>>2]|0;if((Q|0)<(H|0))H=Q;else break}Q=(G|0)>(H|0)?H:G;X=S;do{K=a+(X<<2)|0;R=X;X=f[K>>2]|0;f[K>>2]=Q}while((X|0)<(R|0));jb=Q}Q=N;do{X=a+(Q<<2)|0;S=Q;Q=f[X>>2]|0;f[X>>2]=jb}while((Q|0)<(S|0));f[x+(C<<2)>>2]=jb;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;N=f[x+(J<<2)>>2]|0;S=Q;while(1){X=f[a+(S<<2)>>2]|0;if((X|0)<(S|0))S=X;else break}if((Q|0)==(N|0))kb=S;else{J=N;while(1){X=f[a+(J<<2)>>2]|0;if((X|0)<(J|0))J=X;else break}X=(S|0)>(J|0)?J:S;G=N;do{H=a+(G<<2)|0;R=G;G=f[H>>2]|0;f[H>>2]=X}while((G|0)<(R|0));kb=X}X=Q;do{G=a+(X<<2)|0;N=X;X=f[G>>2]|0;f[G>>2]=kb}while((X|0)<(N|0));f[x+(C<<2)>>2]=kb;I=D;break a}else hb=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(hb<<2)>>2];I=D;break}do if(z){X=C+-2|0;if(b[v+E>>0]|0){Q=f[x+(X<<2)>>2]|0;do if((X|0)>-1){if(!(b[s+X>>0]|0))break;f[x+(C<<2)>>2]=Q;I=D;break a}while(0);N=f[r+(X<<2)>>2]|0;G=N;while(1){S=f[a+(G<<2)>>2]|0;if((S|0)<(G|0))G=S;else break}if((N|0)==(Q|0))lb=G;else{S=Q;while(1){J=f[a+(S<<2)>>2]|0;if((J|0)<(S|0))S=J;else break}J=(G|0)>(S|0)?S:G;R=Q;do{H=a+(R<<2)|0;K=R;R=f[H>>2]|0;f[H>>2]=J}while((R|0)<(K|0));lb=J}J=N;do{R=a+(J<<2)|0;Q=J;J=f[R>>2]|0;f[R>>2]=lb}while((J|0)<(Q|0));f[x+(C<<2)>>2]=lb;I=D;break a}if(!(b[v+C>>0]|0)){mb=X;break}do if((X|0)>-1){if(!(b[s+X>>0]|0))break;if(!(b[v+X>>0]|0)){J=f[r+(C<<2)>>2]|0;N=f[x+(X<<2)>>2]|0;Q=J;while(1){R=f[a+(Q<<2)>>2]|0;if((R|0)<(Q|0))Q=R;else break}if((J|0)==(N|0))nb=Q;else{R=N;while(1){G=f[a+(R<<2)>>2]|0;if((G|0)<(R|0))R=G;else break}G=(Q|0)>(R|0)?R:Q;S=N;do{K=a+(S<<2)|0;H=S;S=f[K>>2]|0;f[K>>2]=G}while((S|0)<(H|0));nb=G}G=J;do{S=a+(G<<2)|0;N=G;G=f[S>>2]|0;f[S>>2]=nb}while((G|0)<(N|0));f[x+(C<<2)>>2]=nb;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[x+(X<<2)>>2];I=D;break a}while(0);G=f[r+(C<<2)>>2]|0;J=f[x+(X<<2)>>2]|0;N=G;while(1){S=f[a+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((G|0)==(J|0))ob=N;else{S=J;while(1){Q=f[a+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(N|0)>(S|0)?S:N;R=J;do{H=a+(R<<2)|0;K=R;R=f[H>>2]|0;f[H>>2]=Q}while((R|0)<(K|0));ob=Q}Q=G;do{R=a+(Q<<2)|0;J=Q;Q=f[R>>2]|0;f[R>>2]=ob}while((Q|0)<(J|0));f[x+(C<<2)>>2]=ob;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;G=f[x+(X<<2)>>2]|0;J=Q;while(1){R=f[a+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((Q|0)==(G|0))pb=J;else{X=G;while(1){R=f[a+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(J|0)>(X|0)?X:J;N=G;do{S=a+(N<<2)|0;K=N;N=f[S>>2]|0;f[S>>2]=R}while((N|0)<(K|0));pb=R}R=Q;do{N=a+(R<<2)|0;G=R;R=f[N>>2]|0;f[N>>2]=pb}while((R|0)<(G|0));f[x+(C<<2)>>2]=pb;I=D;break a}else mb=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(mb<<2)>>2];I=D;break}}R=C|1;Q=(R|0)<(m|0);if(!(A|Q^1)?b[v+R>>0]|0:0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(F?b[v+E>>0]|0:0){G=f[r+(C<<2)>>2]|0;do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=G;I=D;break a}while(0);N=f[r+(C+-2<<2)>>2]|0;J=N;while(1){X=f[a+(J<<2)>>2]|0;if((X|0)<(J|0))J=X;else break}if((N|0)==(G|0))qb=J;else{X=G;while(1){K=f[a+(X<<2)>>2]|0;if((K|0)<(X|0))X=K;else break}K=(J|0)>(X|0)?X:J;S=G;do{H=a+(S<<2)|0;L=S;S=f[H>>2]|0;f[H>>2]=K}while((S|0)<(L|0));qb=K}K=N;do{S=a+(K<<2)|0;G=K;K=f[S>>2]|0;f[S>>2]=qb}while((K|0)<(G|0));f[x+(C<<2)>>2]=qb;I=D;break}f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(Q?b[s+R>>0]|0:0){K=C+2|0;if(!((K|0)>=(m|0)|A)?b[v+K>>0]|0:0){if(b[v+C>>0]|0){do if(B){if(!(b[w+R>>0]|0))break;f[x+(C<<2)>>2]=f[r+(K<<2)>>2];I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;N=f[r+(K<<2)>>2]|0;G=Q;while(1){S=f[a+(G<<2)>>2]|0;if((S|0)<(G|0))G=S;else break}if((Q|0)==(N|0))rb=G;else{S=N;while(1){J=f[a+(S<<2)>>2]|0;if((J|0)<(S|0))S=J;else break}J=(G|0)>(S|0)?S:G;X=N;do{L=a+(X<<2)|0;H=X;X=f[L>>2]|0;f[L>>2]=J}while((X|0)<(H|0));rb=J}J=Q;do{X=a+(J<<2)|0;N=J;J=f[X>>2]|0;f[X>>2]=rb}while((J|0)<(N|0));f[x+(C<<2)>>2]=rb;I=D;break}do if(F){if(!(b[v+E>>0]|0))break;do if(B){if(!(b[w+R>>0]|0))break;J=f[r+(K<<2)>>2]|0;if(b[w+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}Q=f[r+(C+-2<<2)>>2]|0;N=Q;while(1){X=f[a+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((Q|0)==(J|0))sb=N;else{X=J;while(1){G=f[a+(X<<2)>>2]|0;if((G|0)<(X|0))X=G;else break}G=(N|0)>(X|0)?X:N;S=J;do{H=a+(S<<2)|0;L=S;S=f[H>>2]|0;f[H>>2]=G}while((S|0)<(L|0));sb=G}G=Q;do{S=a+(G<<2)|0;J=G;G=f[S>>2]|0;f[S>>2]=sb}while((G|0)<(J|0));f[x+(C<<2)>>2]=sb;I=D;break a}while(0);G=f[r+(C+-2<<2)>>2]|0;Q=f[r+(K<<2)>>2]|0;J=G;while(1){S=f[a+(J<<2)>>2]|0;if((S|0)<(J|0))J=S;else break}if((G|0)==(Q|0))tb=J;else{S=Q;while(1){N=f[a+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(J|0)>(S|0)?S:J;X=Q;do{L=a+(X<<2)|0;H=X;X=f[L>>2]|0;f[L>>2]=N}while((X|0)<(H|0));tb=N}N=G;do{X=a+(N<<2)|0;Q=N;N=f[X>>2]|0;f[X>>2]=tb}while((N|0)<(Q|0));f[x+(C<<2)>>2]=tb;I=D;break a}while(0);f[x+(C<<2)>>2]=f[r+(K<<2)>>2];I=D;break}if(z?b[v+C>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}do if(!(A|F^1)){if(!(b[v+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(C+-2<<2)>>2];I=D;break a}while(0);f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break}if(z?b[v+C>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(!(A|F^1)?b[v+E>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C+-2<<2)>>2];I=D;break}f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0}while(0);C=C+2|0;if((C|0)>=(m|0)){ub=I;break}else D=I}}else ub=p;q=q+2|0;if((q|0)>=(h|0))break;else p=ub}if((ub|0)>1){p=1;h=1;while(1){q=a+(h<<2)|0;I=f[q>>2]|0;if((I|0)<(h|0)){f[q>>2]=f[a+(I<<2)>>2];vb=p}else{f[q>>2]=p;vb=p+1|0}h=h+1|0;if((h|0)==(ub|0)){wb=vb;break}else p=vb}}else wb=1}else wb=1;vb=f[i>>2]|0;p=f[n>>2]|0;ub=(p&1|0)!=0;h=(vb|0)>0;if(!(vb&1)){if(!ub){if(!h){g0(a);u=g;return wb|0}q=f[c+16>>2]|0;I=f[c+44>>2]|0;m=f[d+16>>2]|0;tb=f[d+44>>2]|0;sb=0;rb=p;qb=vb;while(1){mb=f[I>>2]|0;pb=q+(Y(mb,sb)|0)|0;ob=pb+mb|0;mb=f[tb>>2]|0;nb=m+(Y(mb,sb)|0)|0;lb=nb+mb|0;if((rb|0)>0){mb=0;do{hb=nb+(mb<<2)|0;kb=f[hb>>2]|0;do if((kb|0)>0){jb=f[a+(kb<<2)>>2]|0;f[hb>>2]=(b[pb+mb>>0]|0)==0?0:jb;ib=mb|1;f[nb+(ib<<2)>>2]=(b[pb+ib>>0]|0)==0?0:jb;f[lb+(mb<<2)>>2]=(b[ob+mb>>0]|0)==0?0:jb;gb=lb+(ib<<2)|0;if(!(b[ob+ib>>0]|0)){f[gb>>2]=0;break}else{f[gb>>2]=jb;break}}else{f[hb>>2]=0;jb=mb|1;f[nb+(jb<<2)>>2]=0;f[lb+(mb<<2)>>2]=0;f[lb+(jb<<2)>>2]=0}while(0);mb=mb+2|0;xb=f[n>>2]|0}while((mb|0)<(xb|0));yb=f[i>>2]|0;zb=xb}else{yb=qb;zb=rb}sb=sb+2|0;if((sb|0)>=(yb|0))break;else{rb=zb;qb=yb}}g0(a);u=g;return wb|0}if(!h){g0(a);u=g;return wb|0}yb=f[c+16>>2]|0;qb=f[c+44>>2]|0;zb=f[d+16>>2]|0;rb=f[d+44>>2]|0;sb=0;xb=p;m=vb;while(1){tb=f[qb>>2]|0;q=yb+(Y(tb,sb)|0)|0;I=q+tb|0;tb=f[rb>>2]|0;mb=zb+(Y(tb,sb)|0)|0;lb=mb+tb|0;if((xb|0)>0){tb=0;do{nb=mb+(tb<<2)|0;ob=f[nb>>2]|0;do if((ob|0)>0){pb=f[a+(ob<<2)>>2]|0;f[nb>>2]=(b[q+tb>>0]|0)==0?0:pb;f[lb+(tb<<2)>>2]=(b[I+tb>>0]|0)==0?0:pb;hb=tb|1;if((hb|0)<(f[n>>2]|0)){f[mb+(hb<<2)>>2]=(b[q+hb>>0]|0)==0?0:pb;kb=lb+(hb<<2)|0;if(!(b[I+hb>>0]|0)){f[kb>>2]=0;break}else{f[kb>>2]=pb;break}}}else{f[nb>>2]=0;f[lb+(tb<<2)>>2]=0;pb=tb|1;if((pb|0)<(f[n>>2]|0)){f[mb+(pb<<2)>>2]=0;f[lb+(pb<<2)>>2]=0}}while(0);tb=tb+2|0;Ab=f[n>>2]|0}while((tb|0)<(Ab|0));Bb=f[i>>2]|0;Cb=Ab}else{Bb=m;Cb=xb}sb=sb+2|0;if((sb|0)>=(Bb|0))break;else{xb=Cb;m=Bb}}g0(a);u=g;return wb|0}if(!ub){if(!h){g0(a);u=g;return wb|0}ub=f[c+16>>2]|0;Bb=f[c+44>>2]|0;m=f[d+16>>2]|0;Cb=f[d+44>>2]|0;xb=0;sb=p;Ab=vb;while(1){zb=f[Bb>>2]|0;rb=ub+(Y(zb,xb)|0)|0;yb=rb+zb|0;zb=f[Cb>>2]|0;qb=m+(Y(zb,xb)|0)|0;tb=qb+zb|0;if((sb|0)>0){zb=xb|1;lb=0;do{mb=qb+(lb<<2)|0;I=f[mb>>2]|0;do if((I|0)>0){q=f[a+(I<<2)>>2]|0;f[mb>>2]=(b[rb+lb>>0]|0)==0?0:q;nb=lb|1;f[qb+(nb<<2)>>2]=(b[rb+nb>>0]|0)==0?0:q;if((zb|0)<(f[i>>2]|0)){f[tb+(lb<<2)>>2]=(b[yb+lb>>0]|0)==0?0:q;ob=tb+(nb<<2)|0;if(!(b[yb+nb>>0]|0)){f[ob>>2]=0;break}else{f[ob>>2]=q;break}}}else{f[mb>>2]=0;q=lb|1;f[qb+(q<<2)>>2]=0;if((zb|0)<(f[i>>2]|0)){f[tb+(lb<<2)>>2]=0;f[tb+(q<<2)>>2]=0}}while(0);lb=lb+2|0;Db=f[n>>2]|0}while((lb|0)<(Db|0));Eb=f[i>>2]|0;Fb=Db}else{Eb=Ab;Fb=sb}xb=xb+2|0;if((xb|0)>=(Eb|0))break;else{sb=Fb;Ab=Eb}}g0(a);u=g;return wb|0}if(!h){g0(a);u=g;return wb|0}h=f[c+16>>2]|0;Eb=f[c+44>>2]|0;c=f[d+16>>2]|0;Ab=f[d+44>>2]|0;d=0;Fb=p;p=vb;while(1){vb=f[Eb>>2]|0;sb=h+(Y(vb,d)|0)|0;xb=sb+vb|0;vb=f[Ab>>2]|0;Db=c+(Y(vb,d)|0)|0;m=Db+vb|0;if((Fb|0)>0){vb=d|1;Cb=0;do{ub=Db+(Cb<<2)|0;Bb=f[ub>>2]|0;do if((Bb|0)>0){lb=f[a+(Bb<<2)>>2]|0;f[ub>>2]=(b[sb+Cb>>0]|0)==0?0:lb;tb=Cb|1;if((tb|0)<(f[n>>2]|0)){f[Db+(tb<<2)>>2]=(b[sb+tb>>0]|0)==0?0:lb;if((vb|0)>=(f[i>>2]|0))break;f[m+(Cb<<2)>>2]=(b[xb+Cb>>0]|0)==0?0:lb;zb=m+(tb<<2)|0;if(!(b[xb+tb>>0]|0)){f[zb>>2]=0;break}else{f[zb>>2]=lb;break}}else{if((vb|0)>=(f[i>>2]|0))break;zb=m+(Cb<<2)|0;if(!(b[xb+Cb>>0]|0)){f[zb>>2]=0;break}else{f[zb>>2]=lb;break}}}else{f[ub>>2]=0;lb=Cb|1;if((lb|0)<(f[n>>2]|0)){f[Db+(lb<<2)>>2]=0;if((vb|0)>=(f[i>>2]|0))break;f[m+(Cb<<2)>>2]=0;f[m+(lb<<2)>>2]=0;break}else{if((vb|0)>=(f[i>>2]|0))break;f[m+(Cb<<2)>>2]=0;break}}while(0);Cb=Cb+2|0;Gb=f[n>>2]|0}while((Cb|0)<(Gb|0));Hb=f[i>>2]|0;Ib=Gb}else{Hb=p;Ib=Fb}d=d+2|0;if((d|0)>=(Hb|0))break;else{Fb=Ib;p=Hb}}g0(a);u=g;return wb|0}function zaa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+64|0;h=a+48|0;i=a+28|0;j=a;k=f[c+8>>2]|0;if((k|0)!=(f[d+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,26)|0;m=250083;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,h,518189,2526)}o=f[c+12>>2]|0;if((o|0)!=(f[d+12>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,26)|0;m=250110;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,h,518189,2527)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;l=tT(h,17)|0;m=250137;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,h,518189,2528)}m=(o+1|0)/2|0;o=f0(k<<2)|0;l=f0((Y(((k+1|0)/2|0)<<2,m)|0)+4|0)|0;f[l>>2]=0;f[h>>2]=0;f[h+4>>2]=k;n=(k|0)/2|0;e=(z8()|0)<<2;p=(e|0)<(n|0)?e:n;q=+(((p|0)>1?p:1)|0);f[i>>2]=46800;f[i+4>>2]=c;f[i+8>>2]=d;f[i+12>>2]=l;f[i+16>>2]=o;y8(h,i,q);Aaa(c,d,l,o);f[i>>2]=1;if((k|0)>0)r=0;else{s=(k|0)>-1;t=s?k:-1;v=XDc(t)|0;f[j>>2]=46820;w=j+4|0;f[w>>2]=c;x=j+8|0;f[x>>2]=d;y=j+12|0;f[y>>2]=l;z=j+16|0;f[z>>2]=g;A=j+20|0;f[A>>2]=v;B=j+24|0;f[B>>2]=i;y8(h,j,q);ZDc(v);g0(o);g0(l);C=f[i>>2]|0;u=a;return C|0}do{p=r+1|0;n=(Y((p|0)/2|0,m)|0)+1|0;e=f[o+(p<<2)>>2]|0;p=e+n|0;if((e|0)>0){e=n;do{n=l+(e<<2)|0;D=f[n>>2]|0;if((D|0)<(e|0))f[n>>2]=f[l+(D<<2)>>2];else{f[n>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}e=e+1|0}while((e|0)<(p|0))}r=f[o+(r<<2)>>2]|0}while((r|0)<(k|0));s=(k|0)>-1;t=s?k:-1;v=XDc(t)|0;f[j>>2]=46820;w=j+4|0;f[w>>2]=c;x=j+8|0;f[x>>2]=d;y=j+12|0;f[y>>2]=l;z=j+16|0;f[z>>2]=g;A=j+20|0;f[A>>2]=v;B=j+24|0;f[B>>2]=i;y8(h,j,q);ZDc(v);g0(o);g0(l);C=f[i>>2]|0;u=a;return C|0}function Aaa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[c+12>>2]|0;h=f[c+8>>2]|0;i=f[e>>2]|0;if((i|0)>=(h|0))return;j=(g|0)>0;k=g+-1|0;l=g+-2|0;m=f[c+16>>2]|0;n=f[c+44>>2]|0;c=f[a+16>>2]|0;o=f[a+44>>2]|0;a=i;do{i=f[n>>2]|0;p=m+(Y(i,a)|0)|0;q=0-i|0;i=p+q+q|0;q=f[o>>2]|0;r=c+(Y(q,a)|0)|0;s=r+(0-q)|0;if(j){q=0;do{t=p+(q<<2)|0;u=f[t>>2]|0;if((u|0)>0){if((((q|0)>1?(v=f[i+(q+-2<<2)>>2]|0,(v|0)>0):0)?(b[r+q>>0]|0)!=0:0)?(b[s+(q+-1)>>0]|0)!=0:0){w=v;while(1){x=f[d+(w<<2)>>2]|0;if((x|0)<(w|0))w=x;else break}if((v|0)==(u|0))y=w;else{x=u;while(1){z=f[d+(x<<2)>>2]|0;if((z|0)<(x|0))x=z;else break}z=(w|0)>(x|0)?x:w;A=u;do{B=d+(A<<2)|0;C=A;A=f[B>>2]|0;f[B>>2]=z}while((A|0)<(C|0));y=z}z=v;do{A=d+(z<<2)|0;w=z;z=f[A>>2]|0;f[A>>2]=y}while((z|0)<(w|0));f[t>>2]=y;D=y}else D=u;z=f[i+(q<<2)>>2]|0;a:do if((z|0)>0){v=b[r+q>>0]|0;w=v<<24>>24!=0;if((q|0)>=(k|0)){if(!w){E=D;break}if(!(b[s+q>>0]|0)){E=D;break}else F=z;while(1){A=f[d+(F<<2)>>2]|0;if((A|0)<(F|0))F=A;else break}if((z|0)==(D|0))G=F;else{A=D;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<(A|0))A=x;else break}x=(F|0)>(A|0)?A:F;C=D;do{B=d+(C<<2)|0;H=C;C=f[B>>2]|0;f[B>>2]=x}while((C|0)<(H|0));G=x}x=z;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=G}while((x|0)<(A|0));f[t>>2]=G;E=G;break}if(w?(b[s+q>>0]|0)!=0:0)I=z;else J=23;do if((J|0)==23){J=0;x=q|1;A=(b[r+x>>0]|0)!=0;if(A?b[s+q>>0]|0:0){I=z;break}if(v<<24>>24?b[s+x>>0]|0:0){I=z;break}if(!A){E=D;break a}if(!(b[s+x>>0]|0)){E=D;break a}else I=z}while(0);while(1){v=f[d+(I<<2)>>2]|0;if((v|0)<(I|0))I=v;else break}if((z|0)==(D|0))K=I;else{v=D;while(1){w=f[d+(v<<2)>>2]|0;if((w|0)<(v|0))v=w;else break}w=(I|0)>(v|0)?v:I;x=D;do{A=d+(x<<2)|0;C=x;x=f[A>>2]|0;f[A>>2]=w}while((x|0)<(C|0));K=w}w=z;do{x=d+(w<<2)|0;v=w;w=f[x>>2]|0;f[x>>2]=K}while((w|0)<(v|0));f[t>>2]=K;E=K}else E=D;while(0);if((((q|0)<(l|0)?(z=q+2|0,u=f[i+(z<<2)>>2]|0,(u|0)>0):0)?b[r+(q|1)>>0]|0:0)?b[s+z>>0]|0:0){z=u;while(1){w=f[d+(z<<2)>>2]|0;if((w|0)<(z|0))z=w;else break}if((u|0)==(E|0))L=z;else{w=E;while(1){v=f[d+(w<<2)>>2]|0;if((v|0)<(w|0))w=v;else break}v=(z|0)>(w|0)?w:z;x=E;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=v}while((x|0)<(A|0));L=v}v=u;do{x=d+(v<<2)|0;z=v;v=f[x>>2]|0;f[x>>2]=L}while((v|0)<(z|0));f[t>>2]=L}}q=q+2|0}while((q|0)<(g|0))}a=f[e+(a<<2)>>2]|0}while((a|0)<(h|0));return}function Baa(a){a=a|0;YDc(a);return}function Caa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=f[c+4>>2]|0;c=((d|0)%2|0)+d|0;d=a+8|0;g=f[d>>2]|0;h=(f[g+8>>2]&1|0)==0;i=f[g+12>>2]|0;j=(i&1|0)!=0;k=(e|0)<(c|0);if((e|0)>0){if(h){if(!j){if(!k)return;l=a+4|0;m=a+12|0;n=e;o=g;p=i;while(1){q=f[l>>2]|0;r=f[f[q+44>>2]>>2]|0;s=(f[q+16>>2]|0)+(Y(r,n)|0)|0;q=s+r|0;r=f[f[o+44>>2]>>2]|0;t=(f[o+16>>2]|0)+(Y(r,n)|0)|0;u=t+r|0;if((p|0)>0){r=0;do{v=t+(r<<2)|0;w=f[v>>2]|0;do if((w|0)>0){x=f[(f[m>>2]|0)+(w<<2)>>2]|0;f[v>>2]=(b[s+r>>0]|0)==0?0:x;y=r|1;f[t+(y<<2)>>2]=(b[s+y>>0]|0)==0?0:x;f[u+(r<<2)>>2]=(b[q+r>>0]|0)==0?0:x;z=u+(y<<2)|0;if(!(b[q+y>>0]|0)){f[z>>2]=0;break}else{f[z>>2]=x;break}}else{f[v>>2]=0;x=r|1;f[t+(x<<2)>>2]=0;f[u+(r<<2)>>2]=0;f[u+(x<<2)>>2]=0}while(0);r=r+2|0;v=f[d>>2]|0;w=f[v+12>>2]|0}while((r|0)<(w|0));A=w;B=v}else{A=p;B=o}n=n+2|0;if((n|0)>=(c|0))break;else{o=B;p=A}}return}if(!k)return;A=a+4|0;p=a+12|0;B=e;o=g;n=i;while(1){m=f[A>>2]|0;l=f[f[m+44>>2]>>2]|0;r=(f[m+16>>2]|0)+(Y(l,B)|0)|0;m=r+l|0;l=f[f[o+44>>2]>>2]|0;u=(f[o+16>>2]|0)+(Y(l,B)|0)|0;t=u+l|0;if((n|0)>0){l=0;do{q=u+(l<<2)|0;s=f[q>>2]|0;do if((s|0)>0){v=f[(f[p>>2]|0)+(s<<2)>>2]|0;f[q>>2]=(b[r+l>>0]|0)==0?0:v;f[t+(l<<2)>>2]=(b[m+l>>0]|0)==0?0:v;w=l|1;if((w|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[u+(w<<2)>>2]=(b[r+w>>0]|0)==0?0:v;x=t+(w<<2)|0;if(!(b[m+w>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=v;break}}}else{f[q>>2]=0;f[t+(l<<2)>>2]=0;v=l|1;if((v|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[u+(v<<2)>>2]=0;f[t+(v<<2)>>2]=0}}while(0);l=l+2|0;q=f[d>>2]|0;s=f[q+12>>2]|0}while((l|0)<(s|0));C=s;D=q}else{C=n;D=o}B=B+2|0;if((B|0)>=(c|0))break;else{o=D;n=C}}return}if(!j){if(!k)return;C=a+4|0;n=a+12|0;D=e;o=g;B=i;while(1){p=f[C>>2]|0;A=f[f[p+44>>2]>>2]|0;l=(f[p+16>>2]|0)+(Y(A,D)|0)|0;p=l+A|0;A=f[f[o+44>>2]>>2]|0;t=(f[o+16>>2]|0)+(Y(A,D)|0)|0;u=t+A|0;if((B|0)>0){A=D+1|0;m=0;do{r=t+(m<<2)|0;q=f[r>>2]|0;do if((q|0)>0){s=f[(f[n>>2]|0)+(q<<2)>>2]|0;f[r>>2]=(b[l+m>>0]|0)==0?0:s;v=m|1;f[t+(v<<2)>>2]=(b[l+v>>0]|0)==0?0:s;if((A|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[u+(m<<2)>>2]=(b[p+m>>0]|0)==0?0:s;x=u+(v<<2)|0;if(!(b[p+v>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=s;break}}}else{f[r>>2]=0;s=m|1;f[t+(s<<2)>>2]=0;if((A|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[u+(m<<2)>>2]=0;f[u+(s<<2)>>2]=0}}while(0);m=m+2|0;r=f[d>>2]|0;q=f[r+12>>2]|0}while((m|0)<(q|0));E=q;F=r}else{E=B;F=o}D=D+2|0;if((D|0)>=(c|0))break;else{o=F;B=E}}return}if(!k)return;E=a+4|0;B=a+12|0;F=e;o=g;D=i;while(1){n=f[E>>2]|0;C=f[f[n+44>>2]>>2]|0;m=(f[n+16>>2]|0)+(Y(C,F)|0)|0;n=m+C|0;C=f[f[o+44>>2]>>2]|0;u=(f[o+16>>2]|0)+(Y(C,F)|0)|0;A=u+C|0;if((D|0)>0){C=F+1|0;t=0;do{p=u+(t<<2)|0;l=f[p>>2]|0;do if((l|0)>0){r=f[(f[B>>2]|0)+(l<<2)>>2]|0;f[p>>2]=(b[m+t>>0]|0)==0?0:r;q=t|1;s=f[d>>2]|0;if((q|0)<(f[s+12>>2]|0)){f[u+(q<<2)>>2]=(b[m+q>>0]|0)==0?0:r;if((C|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[A+(t<<2)>>2]=(b[n+t>>0]|0)==0?0:r;x=A+(q<<2)|0;if(!(b[n+q>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=r;break}}else{if((C|0)>=(f[s+8>>2]|0))break;s=A+(t<<2)|0;if(!(b[n+t>>0]|0)){f[s>>2]=0;break}else{f[s>>2]=r;break}}}else{f[p>>2]=0;r=t|1;s=f[d>>2]|0;if((r|0)<(f[s+12>>2]|0)){f[u+(r<<2)>>2]=0;if((C|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[A+(t<<2)>>2]=0;f[A+(r<<2)>>2]=0;break}else{if((C|0)>=(f[s+8>>2]|0))break;f[A+(t<<2)>>2]=0;break}}while(0);t=t+2|0;p=f[d>>2]|0;l=f[p+12>>2]|0}while((t|0)<(l|0));G=l;H=p}else{G=D;H=o}F=F+2|0;if((F|0)>=(c|0))break;else{o=H;D=G}}return}else{if(h){if(!j){if(!k)return;h=a+4|0;G=a+12|0;D=e;H=g;o=i;while(1){F=f[h>>2]|0;B=f[f[F+44>>2]>>2]|0;E=(f[F+16>>2]|0)+(Y(B,D)|0)|0;F=E+B|0;B=f[f[H+44>>2]>>2]|0;t=(f[H+16>>2]|0)+(Y(B,D)|0)|0;A=t+B|0;if((o|0)>0){B=0;do{C=t+(B<<2)|0;u=f[C>>2]|0;do if((u|0)>0){n=f[(f[G>>2]|0)+(u<<2)>>2]|0;f[C>>2]=(b[E+B>>0]|0)==0?0:n;m=B|1;f[t+(m<<2)>>2]=(b[E+m>>0]|0)==0?0:n;f[A+(B<<2)>>2]=(b[F+B>>0]|0)==0?0:n;p=A+(m<<2)|0;if(!(b[F+m>>0]|0)){f[p>>2]=0;break}else{f[p>>2]=n;break}}else{f[C>>2]=0;n=B|1;f[t+(n<<2)>>2]=0;f[A+(B<<2)>>2]=0;f[A+(n<<2)>>2]=0}while(0);B=B+2|0;C=f[d>>2]|0;u=f[C+12>>2]|0}while((B|0)<(u|0));I=u;J=C}else{I=o;J=H}D=D+2|0;if((D|0)>=(c|0))break;else{H=J;o=I}}return}if(!k)return;I=a+4|0;o=a+12|0;J=e;H=g;D=i;while(1){G=f[I>>2]|0;h=f[f[G+44>>2]>>2]|0;B=(f[G+16>>2]|0)+(Y(h,J)|0)|0;G=B+h|0;h=f[f[H+44>>2]>>2]|0;A=(f[H+16>>2]|0)+(Y(h,J)|0)|0;t=A+h|0;if((D|0)>0){h=0;do{F=A+(h<<2)|0;E=f[F>>2]|0;do if((E|0)>0){C=f[(f[o>>2]|0)+(E<<2)>>2]|0;f[F>>2]=(b[B+h>>0]|0)==0?0:C;f[t+(h<<2)>>2]=(b[G+h>>0]|0)==0?0:C;u=h|1;if((u|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[A+(u<<2)>>2]=(b[B+u>>0]|0)==0?0:C;n=t+(u<<2)|0;if(!(b[G+u>>0]|0)){f[n>>2]=0;break}else{f[n>>2]=C;break}}}else{f[F>>2]=0;f[t+(h<<2)>>2]=0;C=h|1;if((C|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[A+(C<<2)>>2]=0;f[t+(C<<2)>>2]=0}}while(0);h=h+2|0;F=f[d>>2]|0;E=f[F+12>>2]|0}while((h|0)<(E|0));K=E;L=F}else{K=D;L=H}J=J+2|0;if((J|0)>=(c|0))break;else{H=L;D=K}}return}if(!j){if(!k)return;j=a+4|0;K=a+12|0;D=e;L=g;H=i;while(1){J=f[j>>2]|0;o=f[f[J+44>>2]>>2]|0;I=(f[J+16>>2]|0)+(Y(o,D)|0)|0;J=I+o|0;o=f[f[L+44>>2]>>2]|0;h=(f[L+16>>2]|0)+(Y(o,D)|0)|0;t=h+o|0;if((H|0)>0){o=D+1|0;A=0;do{G=h+(A<<2)|0;B=f[G>>2]|0;do if((B|0)>0){F=f[(f[K>>2]|0)+(B<<2)>>2]|0;f[G>>2]=(b[I+A>>0]|0)==0?0:F;E=A|1;f[h+(E<<2)>>2]=(b[I+E>>0]|0)==0?0:F;if((o|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[t+(A<<2)>>2]=(b[J+A>>0]|0)==0?0:F;C=t+(E<<2)|0;if(!(b[J+E>>0]|0)){f[C>>2]=0;break}else{f[C>>2]=F;break}}}else{f[G>>2]=0;F=A|1;f[h+(F<<2)>>2]=0;if((o|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[t+(A<<2)>>2]=0;f[t+(F<<2)>>2]=0}}while(0);A=A+2|0;G=f[d>>2]|0;B=f[G+12>>2]|0}while((A|0)<(B|0));M=B;N=G}else{M=H;N=L}D=D+2|0;if((D|0)>=(c|0))break;else{L=N;H=M}}return}if(!k)return;k=a+4|0;M=a+12|0;a=e;e=g;g=i;while(1){i=f[k>>2]|0;H=f[f[i+44>>2]>>2]|0;N=(f[i+16>>2]|0)+(Y(H,a)|0)|0;i=N+H|0;H=f[f[e+44>>2]>>2]|0;L=(f[e+16>>2]|0)+(Y(H,a)|0)|0;D=L+H|0;if((g|0)>0){H=a+1|0;K=0;do{j=L+(K<<2)|0;A=f[j>>2]|0;do if((A|0)>0){t=f[(f[M>>2]|0)+(A<<2)>>2]|0;f[j>>2]=(b[N+K>>0]|0)==0?0:t;o=K|1;h=f[d>>2]|0;if((o|0)<(f[h+12>>2]|0)){f[L+(o<<2)>>2]=(b[N+o>>0]|0)==0?0:t;if((H|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[D+(K<<2)>>2]=(b[i+K>>0]|0)==0?0:t;J=D+(o<<2)|0;if(!(b[i+o>>0]|0)){f[J>>2]=0;break}else{f[J>>2]=t;break}}else{if((H|0)>=(f[h+8>>2]|0))break;h=D+(K<<2)|0;if(!(b[i+K>>0]|0)){f[h>>2]=0;break}else{f[h>>2]=t;break}}}else{f[j>>2]=0;t=K|1;h=f[d>>2]|0;if((t|0)<(f[h+12>>2]|0)){f[L+(t<<2)>>2]=0;if((H|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[D+(K<<2)>>2]=0;f[D+(t<<2)>>2]=0;break}else{if((H|0)>=(f[h+8>>2]|0))break;f[D+(K<<2)>>2]=0;break}}while(0);K=K+2|0;j=f[d>>2]|0;A=f[j+12>>2]|0}while((K|0)<(A|0));O=A;P=j}else{O=g;P=e}a=a+2|0;if((a|0)>=(c|0))break;else{e=P;g=O}}return}}function Daa(a){a=a|0;YDc(a);return}function Eaa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=c+4|0;c=f[d>>2]|0;g=a+16|0;h=f[g>>2]|0;f[h+(e<<2)>>2]=((c|0)%2|0)+c;c=e+1|0;i=a+8|0;j=(Y(((f[(f[i>>2]|0)+12>>2]|0)+1|0)/2|0,(c|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+8>>2]|0;n=f[l+12>>2]|0;if((e|0)>=(f[d>>2]|0)){o=j;p=h;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}h=(n|0)>0;l=a+12|0;a=e;s=j;while(1){t=f[k>>2]|0;u=f[f[t+44>>2]>>2]|0;v=(f[t+16>>2]|0)+(Y(u,a)|0)|0;t=0-u|0;w=v+t|0;x=w+t|0;t=v+u|0;u=f[i>>2]|0;y=f[f[u+44>>2]>>2]|0;z=(f[u+16>>2]|0)+(Y(y,a)|0)|0;u=0-y|0;y=z+u+u|0;if(h){u=(a+1|0)<(m|0);A=(a|0)>(e|0);B=A^1;C=(a|0)>(c|0);D=0;E=s;while(1){a:do if(!(b[v+D>>0]|0)){F=D|1;G=(F|0)<(n|0);if(u?b[t+D>>0]|0:0){H=D+-1|0;I=(D|0)>0;if(G?b[v+F>>0]|0:0){if(I){if(b[v+H>>0]|0){do if(A){if(b[w+F>>0]|0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;K=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}do if((K|0)>-1){if(!(b[w+K>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}L=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;O=M;while(1){P=f[L+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((M|0)==(N|0))Q=O;else{P=N;while(1){R=f[L+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(O|0)>(P|0)?P:O;S=N;do{T=L+(S<<2)|0;U=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(U|0));Q=R}R=M;do{S=L+(R<<2)|0;N=R;R=f[S>>2]|0;f[S>>2]=Q}while((R|0)<(N|0));f[z+(D<<2)>>2]=Q;J=E;break a}while(0);R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[z+(K<<2)>>2]|0;N=L;while(1){S=f[R+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((L|0)==(M|0))V=N;else{K=M;while(1){S=f[R+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}S=(N|0)>(K|0)?K:N;O=M;do{P=R+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=S}while((O|0)<(U|0));V=S}S=L;do{O=R+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=V}while((S|0)<(M|0));f[z+(D<<2)>>2]=V;J=E;break a}while(0);S=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;M=R;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((R|0)==(L|0))W=M;else{O=L;while(1){N=f[S+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}N=(M|0)>(O|0)?O:M;K=L;do{U=S+(K<<2)|0;P=K;K=f[U>>2]|0;f[U>>2]=N}while((K|0)<(P|0));W=N}N=R;do{K=S+(N<<2)|0;L=N;N=f[K>>2]|0;f[K>>2]=W}while((N|0)<(L|0));f[z+(D<<2)>>2]=W;J=E;break a}N=D+2|0;if((N|0)>=(n|0))break;if(!(b[w+N>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;K=R;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((R|0)==(L|0))X=K;else{M=L;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;P=L;do{U=S+(P<<2)|0;T=P;P=f[U>>2]|0;f[U>>2]=O}while((P|0)<(T|0));X=O}O=R;do{P=S+(O<<2)|0;L=O;O=f[P>>2]|0;f[P>>2]=X}while((O|0)<(L|0));f[z+(D<<2)>>2]=X;J=E;break a}O=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}do if((O|0)>-1){if(!(b[w+O>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(O<<2)>>2]|0;P=R;while(1){K=f[S+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((R|0)==(L|0))Z=P;else{K=L;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(P|0)>(K|0)?K:P;T=L;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=M}while((T|0)<(_|0));Z=M}M=R;do{T=S+(M<<2)|0;L=M;M=f[T>>2]|0;f[T>>2]=Z}while((M|0)<(L|0));f[z+(D<<2)>>2]=Z;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(N<<2)>>2]|0;R=f[z+(O<<2)>>2]|0;L=S;while(1){T=f[M+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((S|0)==(R|0))$=L;else{O=R;while(1){T=f[M+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}T=(L|0)>(O|0)?O:L;P=R;do{K=M+(P<<2)|0;_=P;P=f[K>>2]|0;f[K>>2]=T}while((P|0)<(_|0));$=T}T=S;do{P=M+(T<<2)|0;R=T;T=f[P>>2]|0;f[P>>2]=$}while((T|0)<(R|0));f[z+(D<<2)>>2]=$;J=E;break a}while(0);T=f[l>>2]|0;M=f[y+(N<<2)>>2]|0;S=f[z+(D+-2<<2)>>2]|0;R=M;while(1){P=f[T+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(S|0))aa=R;else{N=S;while(1){P=f[T+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;L=S;do{O=T+(L<<2)|0;_=L;L=f[O>>2]|0;f[O>>2]=P}while((L|0)<(_|0));aa=P}P=M;do{L=T+(P<<2)|0;S=P;P=f[L>>2]|0;f[L>>2]=aa}while((P|0)<(S|0));f[z+(D<<2)>>2]=aa;J=E;break a}while(0);f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[t+H>>0]|0){do if(A){if(b[w+F>>0]|0){P=D+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=T;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=S;while(1){R=f[M+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((S|0)==(T|0))ba=L;else{R=T;while(1){N=f[M+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(L|0)>(R|0)?R:L;_=T;do{O=M+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=N}while((_|0)<(K|0));ba=N}N=S;do{_=M+(N<<2)|0;T=N;N=f[_>>2]|0;f[_>>2]=ba}while((N|0)<(T|0));f[z+(D<<2)>>2]=ba;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;T=M;while(1){_=f[N+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((M|0)==(S|0))ca=T;else{_=S;while(1){L=f[N+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(T|0)>(_|0)?_:T;R=S;do{K=N+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=L}while((R|0)<(O|0));ca=L}L=M;do{R=N+(L<<2)|0;S=L;L=f[R>>2]|0;f[R>>2]=ca}while((L|0)<(S|0));f[z+(D<<2)>>2]=ca;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;L=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=M;while(1){R=f[N+(S<<2)>>2]|0;if((R|0)<(S|0))S=R;else break}if((M|0)==(L|0))da=S;else{R=L;while(1){T=f[N+(R<<2)>>2]|0;if((T|0)<(R|0))R=T;else break}T=(S|0)>(R|0)?R:S;_=L;do{O=N+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=T}while((_|0)<(K|0));da=T}T=M;do{_=N+(T<<2)|0;L=T;T=f[_>>2]|0;f[_>>2]=da}while((T|0)<(L|0));f[z+(D<<2)>>2]=da;J=E;break a}while(0);T=f[l>>2]|0;N=f[y+(D<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;L=N;while(1){_=f[T+(L<<2)>>2]|0;if((_|0)<(L|0))L=_;else break}if((N|0)==(M|0))ea=L;else{_=M;while(1){S=f[T+(_<<2)>>2]|0;if((S|0)<(_|0))_=S;else break}S=(L|0)>(_|0)?_:L;R=M;do{K=T+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=S}while((R|0)<(O|0));ea=S}S=N;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ea}while((S|0)<(M|0));f[z+(D<<2)>>2]=ea;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;N=f[z+(P<<2)>>2]|0;M=T;while(1){R=f[S+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((T|0)==(N|0))fa=M;else{P=N;while(1){R=f[S+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(M|0)>(P|0)?P:M;L=N;do{_=S+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(O|0));fa=R}R=T;do{L=S+(R<<2)|0;N=R;R=f[L>>2]|0;f[L>>2]=fa}while((R|0)<(N|0));f[z+(D<<2)>>2]=fa;J=E;break a}R=D+2|0;do if(!((R|0)>=(n|0)|B)){if(!(b[w+R>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;S=D+-2|0;do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}N=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=L;while(1){P=f[N+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((L|0)==(T|0))ga=M;else{P=T;while(1){O=f[N+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(M|0)>(P|0)?P:M;_=T;do{K=N+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=O}while((_|0)<(U|0));ga=O}O=L;do{_=N+(O<<2)|0;T=O;O=f[_>>2]|0;f[_>>2]=ga}while((O|0)<(T|0));f[z+(D<<2)>>2]=ga;J=E;break a}if(!(b[w+S>>0]|0)){O=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;L=f[z+(S<<2)>>2]|0;T=N;while(1){_=f[O+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((N|0)==(L|0))ha=T;else{_=L;while(1){M=f[O+(_<<2)>>2]|0;if((M|0)<(_|0))_=M;else break}M=(T|0)>(_|0)?_:T;P=L;do{U=O+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=M}while((P|0)<(K|0));ha=M}M=N;do{P=O+(M<<2)|0;L=M;M=f[P>>2]|0;f[P>>2]=ha}while((M|0)<(L|0));f[z+(D<<2)>>2]=ha;J=E;break a}if(!(b[x+H>>0]|0)){M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=f[z+(S<<2)>>2]|0;L=O;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((O|0)==(N|0))ia=L;else{P=N;while(1){T=f[M+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(L|0)>(P|0)?P:L;_=N;do{K=M+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=T}while((_|0)<(U|0));ia=T}T=O;do{_=M+(T<<2)|0;N=T;T=f[_>>2]|0;f[_>>2]=ia}while((T|0)<(N|0));f[z+(D<<2)>>2]=ia;J=E;break a}T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=O;while(1){_=f[M+(N<<2)>>2]|0;if((_|0)<(N|0))N=_;else break}if((O|0)==(T|0))ja=N;else{_=T;while(1){L=f[M+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(N|0)>(_|0)?_:N;P=T;do{U=M+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=L}while((P|0)<(K|0));ja=L}L=O;do{P=M+(L<<2)|0;T=L;L=f[P>>2]|0;f[P>>2]=ja}while((L|0)<(T|0));f[z+(D<<2)>>2]=ja;J=E;break a}while(0);L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(S<<2)>>2]|0;T=M;while(1){P=f[L+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}if((M|0)==(O|0))ka=T;else{S=O;while(1){P=f[L+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(T|0)>(S|0)?S:T;N=O;do{_=L+(N<<2)|0;K=N;N=f[_>>2]|0;f[_>>2]=P}while((N|0)<(K|0));ka=P}P=M;do{N=L+(P<<2)|0;O=P;P=f[N>>2]|0;f[N>>2]=ka}while((P|0)<(O|0));f[z+(D<<2)>>2]=ka;J=E;break a}while(0);P=D+-2|0;if(!(b[w+D>>0]|0)){L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;N=M;while(1){T=f[L+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((M|0)==(O|0))la=N;else{T=O;while(1){S=f[L+(T<<2)>>2]|0;if((S|0)<(T|0))T=S;else break}S=(N|0)>(T|0)?T:N;K=O;do{_=L+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=S}while((K|0)<(U|0));la=S}S=M;do{K=L+(S<<2)|0;O=S;S=f[K>>2]|0;f[K>>2]=la}while((S|0)<(O|0));f[z+(D<<2)>>2]=la;J=E;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){S=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))ma=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));ma=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=ma}while((N|0)<(M|0));f[z+(D<<2)>>2]=ma;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=f[y+(R<<2)>>2]|0;M=S;while(1){T=f[N+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((S|0)==(L|0))na=M;else{T=L;while(1){O=f[N+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(M|0)>(T|0)?T:M;K=L;do{_=N+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=O}while((K|0)<(U|0));na=O}O=S;do{K=N+(O<<2)|0;L=O;O=f[K>>2]|0;f[K>>2]=na}while((O|0)<(L|0));O=f[z+(P<<2)>>2]|0;S=na;while(1){L=f[N+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((na|0)==(O|0))oa=S;else{L=O;while(1){K=f[N+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(S|0)>(L|0)?L:S;M=O;do{T=N+(M<<2)|0;U=M;M=f[T>>2]|0;f[T>>2]=K}while((M|0)<(U|0));oa=K}K=na;do{M=N+(K<<2)|0;O=K;K=f[M>>2]|0;f[M>>2]=oa}while((K|0)<(O|0));f[z+(D<<2)>>2]=oa;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;K=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;M=N;while(1){S=f[K+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((N|0)==(O|0))pa=M;else{S=O;while(1){L=f[K+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}L=(M|0)>(S|0)?S:M;U=O;do{T=K+(U<<2)|0;_=U;U=f[T>>2]|0;f[T>>2]=L}while((U|0)<(_|0));pa=L}L=N;do{U=K+(L<<2)|0;O=L;L=f[U>>2]|0;f[U>>2]=pa}while((L|0)<(O|0));f[z+(D<<2)>>2]=pa;J=E;break a}while(0);L=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;N=f[y+(R<<2)>>2]|0;O=K;while(1){U=f[L+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((K|0)==(N|0))qa=O;else{U=N;while(1){M=f[L+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=N;do{_=L+(S<<2)|0;T=S;S=f[_>>2]|0;f[_>>2]=M}while((S|0)<(T|0));qa=M}M=K;do{S=L+(M<<2)|0;N=M;M=f[S>>2]|0;f[S>>2]=qa}while((M|0)<(N|0));M=f[z+(P<<2)>>2]|0;K=qa;while(1){N=f[L+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}if((qa|0)==(M|0))ra=K;else{N=M;while(1){S=f[L+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}S=(K|0)>(N|0)?N:K;O=M;do{U=L+(O<<2)|0;T=O;O=f[U>>2]|0;f[U>>2]=S}while((O|0)<(T|0));ra=S}S=qa;do{O=L+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=ra}while((S|0)<(M|0));f[z+(D<<2)>>2]=ra;J=E;break a}while(0);S=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[y+(R<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))sa=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));sa=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=sa}while((N|0)<(M|0));N=f[z+(P<<2)>>2]|0;L=sa;while(1){M=f[S+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((sa|0)==(N|0))ta=L;else{P=N;while(1){M=f[S+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(L|0)>(P|0)?P:L;T=N;do{O=S+(T<<2)|0;K=T;T=f[O>>2]|0;f[O>>2]=M}while((T|0)<(K|0));ta=M}M=sa;do{T=S+(M<<2)|0;N=M;M=f[T>>2]|0;f[T>>2]=ta}while((M|0)<(N|0));f[z+(D<<2)>>2]=ta;J=E;break a}while(0);R=D+-2|0;if(!(b[w+D>>0]|0)){ua=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}if(!(b[w+R>>0]|0)){M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;N=f[z+(R<<2)>>2]|0;T=S;while(1){L=f[M+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}if((S|0)==(N|0))va=T;else{L=N;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(T|0)>(L|0)?L:T;K=N;do{O=M+(K<<2)|0;_=K;K=f[O>>2]|0;f[O>>2]=P}while((K|0)<(_|0));va=P}P=S;do{K=M+(P<<2)|0;N=P;P=f[K>>2]|0;f[K>>2]=va}while((P|0)<(N|0));f[z+(D<<2)>>2]=va;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);P=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;N=M;while(1){K=f[P+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((M|0)==(S|0))wa=N;else{K=S;while(1){T=f[P+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(N|0)>(K|0)?K:N;L=S;do{_=P+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=T}while((L|0)<(O|0));wa=T}T=M;do{L=P+(T<<2)|0;S=T;T=f[L>>2]|0;f[L>>2]=wa}while((T|0)<(S|0));f[z+(D<<2)>>2]=wa;J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(R<<2)>>2]|0;S=P;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((P|0)==(M|0))xa=S;else{R=M;while(1){L=f[T+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(S|0)>(R|0)?R:S;N=M;do{K=T+(N<<2)|0;O=N;N=f[K>>2]|0;f[K>>2]=L}while((N|0)<(O|0));xa=L}L=P;do{N=T+(L<<2)|0;M=L;L=f[N>>2]|0;f[N>>2]=xa}while((L|0)<(M|0));f[z+(D<<2)>>2]=xa;J=E;break a}else ua=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(ua<<2)>>2];J=E;break}}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}L=D+2|0;if(!((L|0)>=(n|0)|B)?b[w+L>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(L<<2)>>2]|0;N=P;while(1){S=f[T+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((P|0)==(M|0))ya=N;else{L=M;while(1){S=f[T+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(N|0)>(L|0)?L:N;R=M;do{O=T+(R<<2)|0;K=R;R=f[O>>2]|0;f[O>>2]=S}while((R|0)<(K|0));ya=S}S=P;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ya}while((S|0)<(M|0));f[z+(D<<2)>>2]=ya;J=E;break}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(I){if(b[t+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[v+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}do if(G){if(!(b[v+F>>0]|0)){if(!u)break;if(!(b[t+F>>0]|0))break;f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(S<<2)>>2]|0;R=P;while(1){N=f[T+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(M|0))za=R;else{S=M;while(1){N=f[T+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(R|0)>(S|0)?S:R;L=M;do{K=T+(L<<2)|0;O=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(O|0));za=N}N=P;do{L=T+(N<<2)|0;M=N;N=f[L>>2]|0;f[L>>2]=za}while((N|0)<(M|0));f[z+(D<<2)>>2]=za;J=E;break a}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}while(0);f[z+(D<<2)>>2]=0;J=E}else{F=D+-1|0;G=(D|0)>0;if(G){if(b[v+F>>0]|0){H=D|1;I=(H|0)<(n|0);if(A&I?b[w+H>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(C?b[x+D>>0]|0:0){N=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break}do if((N|0)>-1){if(!(b[w+N>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break a}T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(N<<2)>>2]|0;L=P;while(1){R=f[T+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((P|0)==(M|0))Aa=L;else{R=M;while(1){S=f[T+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}S=(L|0)>(R|0)?R:L;O=M;do{K=T+(O<<2)|0;_=O;O=f[K>>2]|0;f[K>>2]=S}while((O|0)<(_|0));Aa=S}S=P;do{O=T+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=Aa}while((S|0)<(M|0));f[z+(D<<2)>>2]=Aa;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;M=T;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((T|0)==(P|0))Ba=M;else{N=P;while(1){O=f[S+(N<<2)>>2]|0;if((O|0)<(N|0))N=O;else break}O=(M|0)>(N|0)?N:M;L=P;do{R=S+(L<<2)|0;_=L;L=f[R>>2]|0;f[R>>2]=O}while((L|0)<(_|0));Ba=O}O=T;do{L=S+(O<<2)|0;P=O;O=f[L>>2]|0;f[L>>2]=Ba}while((O|0)<(P|0));f[z+(D<<2)>>2]=Ba;J=E;break}O=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;P=S;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((S|0)==(T|0))Ca=P;else{L=T;while(1){M=f[O+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(P|0)>(L|0)?L:P;N=T;do{_=O+(N<<2)|0;R=N;N=f[_>>2]|0;f[_>>2]=M}while((N|0)<(R|0));Ca=M}M=S;do{N=O+(M<<2)|0;T=M;M=f[N>>2]|0;f[N>>2]=Ca}while((M|0)<(T|0));f[z+(D<<2)>>2]=Ca;J=E;break}if(I?b[v+H>>0]|0:0){M=D+2|0;if(A&(M|0)<(n|0)?b[w+M>>0]|0:0){do if(C){if(!(b[x+H>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;N=S;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((S|0)==(T|0))Da=N;else{P=T;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=T;do{_=O+(R<<2)|0;K=R;R=f[_>>2]|0;f[_>>2]=L}while((R|0)<(K|0));Da=L}L=S;do{R=O+(L<<2)|0;T=L;L=f[R>>2]|0;f[R>>2]=Da}while((L|0)<(T|0));f[z+(D<<2)>>2]=Da;J=E;break a}L=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}do if((L|0)>-1){if(!(b[w+L>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(L<<2)>>2]|0;R=S;while(1){N=f[O+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((S|0)==(T|0))Ea=R;else{N=T;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;K=T;do{_=O+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=P}while((K|0)<(U|0));Ea=P}P=S;do{K=O+(P<<2)|0;T=P;P=f[K>>2]|0;f[K>>2]=Ea}while((P|0)<(T|0));f[z+(D<<2)>>2]=Ea;J=E;break a}while(0);P=f[l>>2]|0;O=f[y+(M<<2)>>2]|0;S=f[z+(L<<2)>>2]|0;T=O;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((O|0)==(S|0))Fa=T;else{L=S;while(1){K=f[P+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(T|0)>(L|0)?L:T;R=S;do{N=P+(R<<2)|0;U=R;R=f[N>>2]|0;f[N>>2]=K}while((R|0)<(U|0));Fa=K}K=O;do{R=P+(K<<2)|0;S=K;K=f[R>>2]|0;f[R>>2]=Fa}while((K|0)<(S|0));f[z+(D<<2)>>2]=Fa;J=E;break a}while(0);H=f[l>>2]|0;I=f[y+(M<<2)>>2]|0;K=f[z+(D+-2<<2)>>2]|0;P=I;while(1){O=f[H+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}if((I|0)==(K|0))Ga=P;else{M=K;while(1){O=f[H+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(P|0)>(M|0)?M:P;S=K;do{R=H+(S<<2)|0;T=S;S=f[R>>2]|0;f[R>>2]=O}while((S|0)<(T|0));Ga=O}O=I;do{S=H+(O<<2)|0;K=O;O=f[S>>2]|0;f[S>>2]=Ga}while((O|0)<(K|0));f[z+(D<<2)>>2]=Ga;J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(u?b[t+F>>0]|0:0){O=D|1;H=(O|0)<(n|0);if(!(B|H^1)?b[w+O>>0]|0:0){I=D+-2|0;if((I|0)>-1?b[v+I>>0]|0:0){if(b[w+F>>0]|0){K=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=K;J=E;break a}while(0);S=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=P;while(1){T=f[S+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((P|0)==(K|0))Ha=M;else{T=K;while(1){R=f[S+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(M|0)>(T|0)?T:M;L=K;do{U=S+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Ha=R}R=P;do{L=S+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=Ha}while((R|0)<(K|0));f[z+(D<<2)>>2]=Ha;J=E;break}if(!(b[w+I>>0]|0)){R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=f[z+(I<<2)>>2]|0;K=S;while(1){L=f[R+(K<<2)>>2]|0;if((L|0)<(K|0))K=L;else break}if((S|0)==(P|0))Ia=K;else{L=P;while(1){M=f[R+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(K|0)>(L|0)?L:K;T=P;do{N=R+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=M}while((T|0)<(U|0));Ia=M}M=S;do{T=R+(M<<2)|0;P=M;M=f[T>>2]|0;f[T>>2]=Ia}while((M|0)<(P|0));f[z+(D<<2)>>2]=Ia;J=E;break}do if(C){if(!(b[x+F>>0]|0))break;M=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=S;while(1){T=f[R+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}if((S|0)==(M|0))Ja=P;else{T=M;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(P|0)>(T|0)?T:P;L=M;do{U=R+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=K}while((L|0)<(N|0));Ja=K}K=S;do{L=R+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=Ja}while((K|0)<(M|0));f[z+(D<<2)>>2]=Ja;J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;M=R;while(1){L=f[K+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}if((R|0)==(S|0))Ka=M;else{L=S;while(1){P=f[K+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(M|0)>(L|0)?L:M;T=S;do{N=K+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=P}while((T|0)<(U|0));Ka=P}P=R;do{T=K+(P<<2)|0;S=P;P=f[T>>2]|0;f[T>>2]=Ka}while((P|0)<(S|0));f[z+(D<<2)>>2]=Ka;J=E;break}if(b[w+D>>0]|0){P=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;S=K;while(1){T=f[P+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((K|0)==(R|0))La=S;else{T=R;while(1){M=f[P+(T<<2)>>2]|0;if((M|0)<(T|0))T=M;else break}M=(S|0)>(T|0)?T:S;L=R;do{U=P+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=M}while((L|0)<(N|0));La=M}M=K;do{L=P+(M<<2)|0;R=M;M=f[L>>2]|0;f[L>>2]=La}while((M|0)<(R|0));f[z+(D<<2)>>2]=La;J=E;break}if(!(b[w+F>>0]|0)){M=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;K=f[z+(I<<2)>>2]|0;R=P;while(1){L=f[M+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(K|0))Ma=R;else{L=K;while(1){S=f[M+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(R|0)>(L|0)?L:R;T=K;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=S}while((T|0)<(U|0));Ma=S}S=P;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Ma}while((S|0)<(K|0));f[z+(D<<2)>>2]=Ma;J=E;break}S=f[y+(D<<2)>>2]|0;M=f[l>>2]|0;do if(C){if(!(b[x+D>>0]|0))break;P=f[z+(I<<2)>>2]|0;K=S;while(1){T=f[M+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((S|0)==(P|0))Na=K;else{T=P;while(1){R=f[M+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(K|0)>(T|0)?T:K;L=P;do{U=M+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Na=R}R=S;do{L=M+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Na}while((R|0)<(P|0));f[z+(D<<2)>>2]=Na;J=E;break a}while(0);R=f[y+(I<<2)>>2]|0;P=R;while(1){L=f[M+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((R|0)==(S|0))Oa=P;else{L=S;while(1){K=f[M+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(P|0)>(L|0)?L:P;T=S;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=K}while((T|0)<(U|0));Oa=K}K=R;do{T=M+(K<<2)|0;S=K;K=f[T>>2]|0;f[T>>2]=Oa}while((K|0)<(S|0));K=f[z+(I<<2)>>2]|0;R=Oa;while(1){S=f[M+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}if((Oa|0)==(K|0))Pa=R;else{I=K;while(1){S=f[M+(I<<2)>>2]|0;if((S|0)<(I|0))I=S;else break}S=(R|0)>(I|0)?I:R;T=K;do{P=M+(T<<2)|0;L=T;T=f[P>>2]|0;f[P>>2]=S}while((T|0)<(L|0));Pa=S}S=Oa;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Pa}while((S|0)<(K|0));f[z+(D<<2)>>2]=Pa;J=E;break}if(H?b[v+O>>0]|0:0){S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){M=D+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+F>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;K=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}T=f[l>>2]|0;R=f[y+(S<<2)>>2]|0;I=R;while(1){L=f[T+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((R|0)==(K|0))Qa=I;else{L=K;while(1){P=f[T+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(I|0)>(L|0)?L:I;U=K;do{N=T+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=P}while((U|0)<(_|0));Qa=P}P=R;do{U=T+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=Qa}while((P|0)<(K|0));f[z+(D<<2)>>2]=Qa;J=E;break a}while(0);P=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;K=T;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((T|0)==(R|0))Ra=K;else{U=R;while(1){I=f[P+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(K|0)>(U|0)?U:K;L=R;do{_=P+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=I}while((L|0)<(N|0));Ra=I}I=T;do{L=P+(I<<2)|0;R=I;I=f[L>>2]|0;f[L>>2]=Ra}while((I|0)<(R|0));f[z+(D<<2)>>2]=Ra;J=E;break a}do if(C){if(!(b[x+O>>0]|0))break;if(!(b[w+M>>0]|0)){I=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;T=f[z+(M<<2)>>2]|0;R=P;while(1){L=f[I+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(T|0))Sa=R;else{L=T;while(1){K=f[I+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(R|0)>(L|0)?L:R;U=T;do{N=I+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=K}while((U|0)<(_|0));Sa=K}K=P;do{U=I+(K<<2)|0;T=K;K=f[U>>2]|0;f[U>>2]=Sa}while((K|0)<(T|0));f[z+(D<<2)>>2]=Sa;J=E;break a}if(!(b[x+F>>0]|0)){K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=f[z+(M<<2)>>2]|0;T=I;while(1){U=f[K+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((I|0)==(P|0))Ta=T;else{U=P;while(1){R=f[K+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(T|0)>(U|0)?U:T;L=P;do{_=K+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(N|0));Ta=R}R=I;do{L=K+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Ta}while((R|0)<(P|0));f[z+(D<<2)>>2]=Ta;J=E;break a}R=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=I;while(1){L=f[K+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((I|0)==(R|0))Ua=P;else{L=R;while(1){T=f[K+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}T=(P|0)>(L|0)?L:P;U=R;do{N=K+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=T}while((U|0)<(_|0));Ua=T}T=I;do{U=K+(T<<2)|0;R=T;T=f[U>>2]|0;f[U>>2]=Ua}while((T|0)<(R|0));f[z+(D<<2)>>2]=Ua;J=E;break a}while(0);if(!(b[w+D>>0]|0)){T=f[l>>2]|0;K=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;R=K;while(1){U=f[T+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}if((K|0)==(I|0))Va=R;else{U=I;while(1){P=f[T+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}P=(R|0)>(U|0)?U:R;L=I;do{_=T+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=P}while((L|0)<(N|0));Va=P}P=K;do{L=T+(P<<2)|0;I=P;P=f[L>>2]|0;f[L>>2]=Va}while((P|0)<(I|0));f[z+(D<<2)>>2]=Va;J=E;break a}if(!(b[w+M>>0]|0)){P=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;K=f[y+(S<<2)>>2]|0;I=T;while(1){L=f[P+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(K|0))Wa=I;else{L=K;while(1){R=f[P+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}R=(I|0)>(L|0)?L:I;U=K;do{N=P+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=R}while((U|0)<(_|0));Wa=R}R=T;do{U=P+(R<<2)|0;K=R;R=f[U>>2]|0;f[U>>2]=Wa}while((R|0)<(K|0));R=f[z+(M<<2)>>2]|0;T=Wa;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((Wa|0)==(R|0))Xa=T;else{K=R;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}U=(T|0)>(K|0)?K:T;I=R;do{L=P+(I<<2)|0;_=I;I=f[L>>2]|0;f[L>>2]=U}while((I|0)<(_|0));Xa=U}U=Wa;do{I=P+(U<<2)|0;R=U;U=f[I>>2]|0;f[I>>2]=Xa}while((U|0)<(R|0));f[z+(D<<2)>>2]=Xa;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;U=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;I=P;while(1){T=f[U+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}if((P|0)==(R|0))Ya=I;else{T=R;while(1){K=f[U+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(I|0)>(T|0)?T:I;_=R;do{L=U+(_<<2)|0;N=_;_=f[L>>2]|0;f[L>>2]=K}while((_|0)<(N|0));Ya=K}K=P;do{_=U+(K<<2)|0;R=K;K=f[_>>2]|0;f[_>>2]=Ya}while((K|0)<(R|0));f[z+(D<<2)>>2]=Ya;J=E;break a}while(0);K=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;P=f[y+(S<<2)>>2]|0;R=U;while(1){_=f[K+(R<<2)>>2]|0;if((_|0)<(R|0))R=_;else break}if((U|0)==(P|0))Za=R;else{_=P;while(1){I=f[K+(_<<2)>>2]|0;if((I|0)<(_|0))_=I;else break}I=(R|0)>(_|0)?_:R;T=P;do{N=K+(T<<2)|0;L=T;T=f[N>>2]|0;f[N>>2]=I}while((T|0)<(L|0));Za=I}I=U;do{T=K+(I<<2)|0;P=I;I=f[T>>2]|0;f[T>>2]=Za}while((I|0)<(P|0));I=f[z+(M<<2)>>2]|0;U=Za;while(1){P=f[K+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((Za|0)==(I|0))_a=U;else{P=I;while(1){T=f[K+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(U|0)>(P|0)?P:U;R=I;do{_=K+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=T}while((R|0)<(L|0));_a=T}T=Za;do{R=K+(T<<2)|0;I=T;T=f[R>>2]|0;f[R>>2]=_a}while((T|0)<(I|0));f[z+(D<<2)>>2]=_a;J=E;break a}while(0);if(b[w+D>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;H=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;K=f[z+(M<<2)>>2]|0;I=T;while(1){R=f[H+(I<<2)>>2]|0;if((R|0)<(I|0))I=R;else break}if((T|0)==(K|0))$a=I;else{R=K;while(1){U=f[H+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}U=(I|0)>(R|0)?R:I;P=K;do{L=H+(P<<2)|0;_=P;P=f[L>>2]|0;f[L>>2]=U}while((P|0)<(_|0));$a=U}U=T;do{P=H+(U<<2)|0;K=U;U=f[P>>2]|0;f[P>>2]=$a}while((U|0)<(K|0));f[z+(D<<2)>>2]=$a;J=E;break a}while(0);U=f[l>>2]|0;H=f[y+(D<<2)>>2]|0;T=f[y+(S<<2)>>2]|0;K=H;while(1){P=f[U+(K<<2)>>2]|0;if((P|0)<(K|0))K=P;else break}if((H|0)==(T|0))ab=K;else{P=T;while(1){I=f[U+(P<<2)>>2]|0;if((I|0)<(P|0))P=I;else break}I=(K|0)>(P|0)?P:K;R=T;do{_=U+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=I}while((R|0)<(L|0));ab=I}I=H;do{R=U+(I<<2)|0;T=I;I=f[R>>2]|0;f[R>>2]=ab}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;H=ab;while(1){T=f[U+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}if((ab|0)==(I|0))bb=H;else{T=I;while(1){R=f[U+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(H|0)>(T|0)?T:H;K=I;do{P=U+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=R}while((K|0)<(L|0));bb=R}R=ab;do{K=U+(R<<2)|0;I=R;R=f[K>>2]|0;f[K>>2]=bb}while((R|0)<(I|0));f[z+(D<<2)>>2]=bb;J=E;break}if(!(b[w+F>>0]|0)){R=f[l>>2]|0;U=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;K=U;while(1){H=f[R+(K<<2)>>2]|0;if((H|0)<(K|0))K=H;else break}if((U|0)==(I|0))cb=K;else{H=I;while(1){T=f[R+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}T=(K|0)>(H|0)?H:K;L=I;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=T}while((L|0)<(_|0));cb=T}T=U;do{L=R+(T<<2)|0;I=T;T=f[L>>2]|0;f[L>>2]=cb}while((T|0)<(I|0));f[z+(D<<2)>>2]=cb;J=E;break}do if(C){if(!(b[x+O>>0]|0))break;T=f[y+(S<<2)>>2]|0;R=f[l>>2]|0;if(b[x+D>>0]|0){U=f[z+(M<<2)>>2]|0;I=T;while(1){L=f[R+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(U|0))db=I;else{L=U;while(1){K=f[R+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(I|0)>(L|0)?L:I;H=U;do{_=R+(H<<2)|0;P=H;H=f[_>>2]|0;f[_>>2]=K}while((H|0)<(P|0));db=K}K=T;do{H=R+(K<<2)|0;U=K;K=f[H>>2]|0;f[H>>2]=db}while((K|0)<(U|0));f[z+(D<<2)>>2]=db;J=E;break a}K=f[y+(M<<2)>>2]|0;U=K;while(1){H=f[R+(U<<2)>>2]|0;if((H|0)<(U|0))U=H;else break}if((K|0)==(T|0))eb=U;else{H=T;while(1){I=f[R+(H<<2)>>2]|0;if((I|0)<(H|0))H=I;else break}I=(U|0)>(H|0)?H:U;L=T;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=I}while((L|0)<(_|0));eb=I}I=K;do{L=R+(I<<2)|0;T=I;I=f[L>>2]|0;f[L>>2]=eb}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;K=eb;while(1){T=f[R+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((eb|0)==(I|0))fb=K;else{T=I;while(1){L=f[R+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}L=(K|0)>(T|0)?T:K;U=I;do{H=R+(U<<2)|0;_=U;U=f[H>>2]|0;f[H>>2]=L}while((U|0)<(_|0));fb=L}L=eb;do{U=R+(L<<2)|0;I=L;L=f[U>>2]|0;f[U>>2]=fb}while((L|0)<(I|0));f[z+(D<<2)>>2]=fb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(M<<2)>>2]|0;R=f[y+(S<<2)>>2]|0;I=L;while(1){U=f[O+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}if((L|0)==(R|0))gb=I;else{S=R;while(1){U=f[O+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(I|0)>(S|0)?S:I;K=R;do{T=O+(K<<2)|0;_=K;K=f[T>>2]|0;f[T>>2]=U}while((K|0)<(_|0));gb=U}U=L;do{K=O+(U<<2)|0;R=U;U=f[K>>2]|0;f[K>>2]=gb}while((U|0)<(R|0));U=f[z+(M<<2)>>2]|0;L=gb;while(1){R=f[O+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((gb|0)==(U|0))hb=L;else{M=U;while(1){R=f[O+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(L|0)>(M|0)?M:L;K=U;do{I=O+(K<<2)|0;S=K;K=f[I>>2]|0;f[I>>2]=R}while((K|0)<(S|0));hb=R}R=gb;do{K=O+(R<<2)|0;U=R;R=f[K>>2]|0;f[K>>2]=hb}while((R|0)<(U|0));f[z+(D<<2)>>2]=hb;J=E;break}do if(A){R=D+-2|0;if(b[w+F>>0]|0){O=f[z+(R<<2)>>2]|0;do if((R|0)>-1){if(!(b[v+R>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);U=f[l>>2]|0;K=f[y+(R<<2)>>2]|0;L=K;while(1){M=f[U+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(O|0))ib=L;else{M=O;while(1){S=f[U+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}S=(L|0)>(M|0)?M:L;I=O;do{_=U+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=S}while((I|0)<(T|0));ib=S}S=K;do{I=U+(S<<2)|0;O=S;S=f[I>>2]|0;f[I>>2]=ib}while((S|0)<(O|0));f[z+(D<<2)>>2]=ib;J=E;break a}if(!(b[w+D>>0]|0)){jb=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(!(b[w+R>>0]|0)){S=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;K=f[z+(R<<2)>>2]|0;O=U;while(1){I=f[S+(O<<2)>>2]|0;if((I|0)<(O|0))O=I;else break}if((U|0)==(K|0))kb=O;else{I=K;while(1){L=f[S+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(O|0)>(I|0)?I:O;M=K;do{T=S+(M<<2)|0;_=M;M=f[T>>2]|0;f[T>>2]=L}while((M|0)<(_|0));kb=L}L=U;do{M=S+(L<<2)|0;K=L;L=f[M>>2]|0;f[M>>2]=kb}while((L|0)<(K|0));f[z+(D<<2)>>2]=kb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;U=f[z+(R<<2)>>2]|0;K=S;while(1){M=f[L+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((S|0)==(U|0))lb=K;else{M=U;while(1){O=f[L+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;I=U;do{_=L+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=O}while((I|0)<(T|0));lb=O}O=S;do{I=L+(O<<2)|0;U=O;O=f[I>>2]|0;f[I>>2]=lb}while((O|0)<(U|0));f[z+(D<<2)>>2]=lb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;U=L;while(1){I=f[O+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}if((L|0)==(S|0))mb=U;else{R=S;while(1){I=f[O+(R<<2)>>2]|0;if((I|0)<(R|0))R=I;else break}I=(U|0)>(R|0)?R:U;K=S;do{M=O+(K<<2)|0;T=K;K=f[M>>2]|0;f[M>>2]=I}while((K|0)<(T|0));mb=I}I=L;do{K=O+(I<<2)|0;S=I;I=f[K>>2]|0;f[K>>2]=mb}while((I|0)<(S|0));f[z+(D<<2)>>2]=mb;J=E;break a}else jb=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(jb<<2)>>2];J=E;break}if(A){I=D+-2|0;if(b[w+F>>0]|0){O=f[z+(I<<2)>>2]|0;do if((I|0)>-1){if(!(b[v+I>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(I<<2)>>2]|0;K=S;while(1){U=f[L+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((S|0)==(O|0))nb=K;else{U=O;while(1){R=f[L+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(K|0)>(U|0)?U:K;T=O;do{M=L+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=R}while((T|0)<(_|0));nb=R}R=S;do{T=L+(R<<2)|0;O=R;R=f[T>>2]|0;f[T>>2]=nb}while((R|0)<(O|0));f[z+(D<<2)>>2]=nb;J=E;break}if(!(b[w+D>>0]|0))ob=I;else{do if((I|0)>-1){if(!(b[v+I>>0]|0))break;if(!(b[w+I>>0]|0)){R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;O=L;while(1){T=f[R+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((L|0)==(S|0))pb=O;else{T=S;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(O|0)>(T|0)?T:O;U=S;do{_=R+(U<<2)|0;M=U;U=f[_>>2]|0;f[_>>2]=K}while((U|0)<(M|0));pb=K}K=L;do{U=R+(K<<2)|0;S=K;K=f[U>>2]|0;f[U>>2]=pb}while((K|0)<(S|0));f[z+(D<<2)>>2]=pb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(I<<2)>>2];J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(I<<2)>>2]|0;S=R;while(1){U=f[K+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((R|0)==(L|0))qb=S;else{U=L;while(1){O=f[K+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;T=L;do{M=K+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=O}while((T|0)<(_|0));qb=O}O=R;do{T=K+(O<<2)|0;L=O;O=f[T>>2]|0;f[T>>2]=qb}while((O|0)<(L|0));f[z+(D<<2)>>2]=qb;J=E;break a}while(0);O=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;L=K;while(1){T=f[O+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((K|0)==(R|0))rb=L;else{I=R;while(1){T=f[O+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}T=(L|0)>(I|0)?I:L;S=R;do{U=O+(S<<2)|0;_=S;S=f[U>>2]|0;f[U>>2]=T}while((S|0)<(_|0));rb=T}T=K;do{S=O+(T<<2)|0;R=T;T=f[S>>2]|0;f[S>>2]=rb}while((T|0)<(R|0));f[z+(D<<2)>>2]=rb;J=E;break}}else ob=D+-2|0;f[z+(D<<2)>>2]=f[z+(ob<<2)>>2];J=E;break}}T=D|1;O=(T|0)<(n|0);if(!(B|O^1)?b[w+T>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(G?b[w+F>>0]|0:0){K=f[y+(D<<2)>>2]|0;if(C?b[x+D>>0]|0:0){f[z+(D<<2)>>2]=K;J=E;break}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;L=S;while(1){I=f[R+(L<<2)>>2]|0;if((I|0)<(L|0))L=I;else break}if((S|0)==(K|0))sb=L;else{I=K;while(1){_=f[R+(I<<2)>>2]|0;if((_|0)<(I|0))I=_;else break}_=(L|0)>(I|0)?I:L;U=K;do{M=R+(U<<2)|0;H=U;U=f[M>>2]|0;f[M>>2]=_}while((U|0)<(H|0));sb=_}_=S;do{U=R+(_<<2)|0;K=_;_=f[U>>2]|0;f[U>>2]=sb}while((_|0)<(K|0));f[z+(D<<2)>>2]=sb;J=E;break}f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(O?b[v+T>>0]|0:0){_=D+2|0;if(!((_|0)>=(n|0)|B)?b[w+_>>0]|0:0){if(b[w+D>>0]|0){if(C?b[x+T>>0]|0:0){f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;K=f[y+(_<<2)>>2]|0;U=S;while(1){L=f[R+(U<<2)>>2]|0;if((L|0)<(U|0))U=L;else break}if((S|0)==(K|0))tb=U;else{O=K;while(1){L=f[R+(O<<2)>>2]|0;if((L|0)<(O|0))O=L;else break}L=(U|0)>(O|0)?O:U;I=K;do{H=R+(I<<2)|0;M=I;I=f[H>>2]|0;f[H>>2]=L}while((I|0)<(M|0));tb=L}L=S;do{I=R+(L<<2)|0;K=L;L=f[I>>2]|0;f[I>>2]=tb}while((L|0)<(K|0));f[z+(D<<2)>>2]=tb;J=E;break}if(G?b[w+F>>0]|0:0){do if(C){if(!(b[x+T>>0]|0))break;L=f[y+(_<<2)>>2]|0;if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;K=S;while(1){I=f[R+(K<<2)>>2]|0;if((I|0)<(K|0))K=I;else break}if((S|0)==(L|0))ub=K;else{I=L;while(1){U=f[R+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}U=(K|0)>(I|0)?I:K;O=L;do{M=R+(O<<2)|0;H=O;O=f[M>>2]|0;f[M>>2]=U}while((O|0)<(H|0));ub=U}U=S;do{O=R+(U<<2)|0;L=U;U=f[O>>2]|0;f[O>>2]=ub}while((U|0)<(L|0));f[z+(D<<2)>>2]=ub;J=E;break a}while(0);T=f[l>>2]|0;U=f[y+(D+-2<<2)>>2]|0;R=f[y+(_<<2)>>2]|0;S=U;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((U|0)==(R|0))vb=S;else{L=R;while(1){O=f[T+(L<<2)>>2]|0;if((O|0)<(L|0))L=O;else break}O=(S|0)>(L|0)?L:S;K=R;do{I=T+(K<<2)|0;H=K;K=f[I>>2]|0;f[I>>2]=O}while((K|0)<(H|0));vb=O}O=U;do{K=T+(O<<2)|0;R=O;O=f[K>>2]|0;f[K>>2]=vb}while((O|0)<(R|0));f[z+(D<<2)>>2]=vb;J=E;break}f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0}while(0);D=D+2|0;if((D|0)>=(n|0)){wb=J;break}else E=J}}else wb=s;a=a+2|0;if((a|0)>=(f[d>>2]|0))break;else s=wb}o=wb;p=f[g>>2]|0;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}function Faa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a+12>>2]|0;e=f[a+8>>2]|0;g=f[c>>2]|0;if((g|0)>=(e|0))return;h=f[a+16>>2]|0;i=f[a+44>>2]|0;a=(d|0)>0;j=d+-1|0;k=g;do{g=f[i>>2]|0;l=h+(Y(g,k)|0)|0;m=l+(0-g)|0;if(a){g=0;do{n=l+(g<<2)|0;o=f[n>>2]|0;if((o|0)>0){if((g|0)>0?(p=f[m+(g+-1<<2)>>2]|0,(p|0)>0):0){q=p;while(1){r=f[b+(q<<2)>>2]|0;if((r|0)<(q|0))q=r;else break}if((p|0)==(o|0))s=q;else{r=o;while(1){t=f[b+(r<<2)>>2]|0;if((t|0)<(r|0))r=t;else break}t=(q|0)>(r|0)?r:q;u=o;do{v=b+(u<<2)|0;w=u;u=f[v>>2]|0;f[v>>2]=t}while((u|0)<(w|0));s=t}t=p;do{u=b+(t<<2)|0;q=t;t=f[u>>2]|0;f[u>>2]=s}while((t|0)<(q|0));f[n>>2]=s;x=s}else x=o;if((g|0)<(j|0)?(t=f[m+(g+1<<2)>>2]|0,(t|0)>0):0){p=t;while(1){q=f[b+(p<<2)>>2]|0;if((q|0)<(p|0))p=q;else break}if((t|0)==(x|0))y=p;else{o=x;while(1){q=f[b+(o<<2)>>2]|0;if((q|0)<(o|0))o=q;else break}q=(p|0)>(o|0)?o:p;u=x;do{r=b+(u<<2)|0;w=u;u=f[r>>2]|0;f[r>>2]=q}while((u|0)<(w|0));y=q}q=t;do{u=b+(q<<2)|0;p=q;q=f[u>>2]|0;f[u>>2]=y}while((q|0)<(p|0));f[n>>2]=y;z=y}else z=x;q=f[m+(g<<2)>>2]|0;if((q|0)>0){t=q;while(1){p=f[b+(t<<2)>>2]|0;if((p|0)<(t|0))t=p;else break}if((q|0)==(z|0))A=t;else{p=z;while(1){u=f[b+(p<<2)>>2]|0;if((u|0)<(p|0))p=u;else break}u=(t|0)>(p|0)?p:t;o=z;do{w=b+(o<<2)|0;r=o;o=f[w>>2]|0;f[w>>2]=u}while((o|0)<(r|0));A=u}u=q;do{o=b+(u<<2)|0;t=u;u=f[o>>2]|0;f[o>>2]=A}while((u|0)<(t|0));f[n>>2]=A}}g=g+1|0}while((g|0)!=(d|0))}k=f[c+(k<<2)>>2]|0}while((k|0)<(e|0));return}function Gaa(a){a=a|0;YDc(a);return}function Haa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;d=f[b+4>>2]|0;b=(c|0)<(d|0);if((c|0)>0){if(!b)return;e=a+4|0;g=a+8|0;h=c;do{i=f[e>>2]|0;j=(f[i+16>>2]|0)+(Y(f[f[i+44>>2]>>2]|0,h)|0)|0;k=j+(f[i+12>>2]<<2)|0;if((j|0)!=(k|0)){i=f[g>>2]|0;l=j;do{f[l>>2]=f[i+(f[l>>2]<<2)>>2];l=l+4|0}while((l|0)!=(k|0))}h=h+1|0}while((h|0)!=(d|0));return}else{if(!b)return;b=a+4|0;h=a+8|0;a=c;do{c=f[b>>2]|0;g=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,a)|0)|0;e=g+(f[c+12>>2]<<2)|0;if((g|0)!=(e|0)){c=f[h>>2]|0;k=g;do{f[k>>2]=f[c+(f[k>>2]<<2)>>2];k=k+4|0}while((k|0)!=(e|0))}a=a+1|0}while((a|0)!=(d|0));return}}function Iaa(a){a=a|0;YDc(a);return}function Jaa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=a+8|0;h=f[g>>2]|0;i=(((Y(f[h+12>>2]|0,d)|0)+1|0)/2|0)+1|0;j=a+4|0;k=f[j>>2]|0;l=f[k+12>>2]|0;if((d|0)==(f[e>>2]|0)){m=i;n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}q=(l|0)>0;r=a+12|0;a=d;s=i;t=k;k=h;while(1){h=f[f[t+44>>2]>>2]|0;u=(f[t+16>>2]|0)+(Y(h,a)|0)|0;v=u+(0-h)|0;h=f[f[k+44>>2]>>2]|0;w=(f[k+16>>2]|0)+(Y(h,a)|0)|0;x=w+(0-h)|0;a:do if(q){if((a|0)>(d|0)){y=0;z=s}else{h=0;A=s;while(1){do if(!(b[u+h>>0]|0)){f[w+(h<<2)>>2]=0;B=A}else{if((h|0)>0?(C=h+-1|0,b[u+C>>0]|0):0){f[w+(h<<2)>>2]=f[w+(C<<2)>>2];B=A;break}f[w+(h<<2)>>2]=A;f[(f[r>>2]|0)+(A<<2)>>2]=A;B=A+1|0}while(0);h=h+1|0;if((h|0)==(l|0)){D=B;break a}else A=B}}while(1){do if(!(b[u+y>>0]|0)){f[w+(y<<2)>>2]=0;E=z}else{A=(y|0)>0;if(!(b[v+y>>0]|0)){if(A?(h=y+-1|0,b[u+h>>0]|0):0){f[w+(y<<2)>>2]=f[w+(h<<2)>>2];E=z;break}f[w+(y<<2)>>2]=z;f[(f[r>>2]|0)+(z<<2)>>2]=z;E=z+1|0;break}h=f[x+(y<<2)>>2]|0;if(A?(A=y+-1|0,(b[u+A>>0]|0)!=0):0){C=f[r>>2]|0;F=f[w+(A<<2)>>2]|0;A=F;while(1){G=f[C+(A<<2)>>2]|0;if((G|0)<(A|0))A=G;else break}if((F|0)==(h|0))H=A;else{G=h;while(1){I=f[C+(G<<2)>>2]|0;if((I|0)<(G|0))G=I;else break}I=(A|0)>(G|0)?G:A;J=h;do{K=C+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(L|0));H=I}I=F;do{J=C+(I<<2)|0;A=I;I=f[J>>2]|0;f[J>>2]=H}while((I|0)<(A|0));M=H}else M=h;f[w+(y<<2)>>2]=M;E=z}while(0);y=y+1|0;if((y|0)==(l|0)){D=E;break}else z=E}}else D=s;while(0);w=a+1|0;if((w|0)==(f[e>>2]|0)){m=D;break}a=w;s=D;t=f[j>>2]|0;k=f[g>>2]|0}n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}function Kaa(a){a=a|0;YDc(a);return}function Laa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=d+1|0;h=a+8|0;i=f[h>>2]|0;j=(Y(((f[i+12>>2]|0)+1|0)/2|0,(g|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+12>>2]|0;n=f[e>>2]|0;if((d|0)==(n|0)){o=j;p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}r=(m|0)>0;s=m+-1|0;t=a+12|0;a=d;u=j;v=n;n=l;l=i;while(1){i=f[f[n+44>>2]>>2]|0;w=(f[n+16>>2]|0)+(Y(i,a)|0)|0;x=w+(0-i)|0;i=f[f[l+44>>2]>>2]|0;y=(f[l+16>>2]|0)+(Y(i,a)|0)|0;z=y+(0-i)|0;if(r){i=(a|0)>(d|0);A=i^1;B=0;C=u;while(1){a:do if(!(b[w+B>>0]|0)){f[y+(B<<2)>>2]=0;D=C}else{if(i){if(b[x+B>>0]|0){f[y+(B<<2)>>2]=f[z+(B<<2)>>2];D=C;break}if(!((B|0)>=(s|0)|A)){E=B+1|0;if(!(b[x+E>>0]|0))F=0;else{do if((B|0)>0){G=B+-1|0;if(!(b[x+G>>0]|0)){H=f[z+(E<<2)>>2]|0;if(!(b[w+G>>0]|0)){I=H;break}J=f[t>>2]|0;K=f[y+(G<<2)>>2]|0;L=K;while(1){M=f[J+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(H|0))N=L;else{M=H;while(1){O=f[J+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(L|0)>(M|0)?M:L;P=H;do{Q=J+(P<<2)|0;R=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(R|0));N=O}O=K;do{P=J+(O<<2)|0;H=O;O=f[P>>2]|0;f[P>>2]=N}while((O|0)<(H|0));I=N}else{O=f[t>>2]|0;J=f[z+(G<<2)>>2]|0;K=f[z+(E<<2)>>2]|0;H=J;while(1){P=f[O+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((J|0)==(K|0))S=H;else{G=K;while(1){P=f[O+(G<<2)>>2]|0;if((P|0)<(G|0))G=P;else break}P=(H|0)>(G|0)?G:H;L=K;do{M=O+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=P}while((L|0)<(R|0));S=P}P=J;do{L=O+(P<<2)|0;K=P;P=f[L>>2]|0;f[L>>2]=S}while((P|0)<(K|0));f[y+(B<<2)>>2]=S;D=C;break a}}else I=f[z+(E<<2)>>2]|0;while(0);f[y+(B<<2)>>2]=I;D=C;break}}else F=A}else F=A;E=(B|0)>0;if(!(F|E^1)?(P=B+-1|0,b[x+P>>0]|0):0){f[y+(B<<2)>>2]=f[z+(P<<2)>>2];D=C;break}if(E?(E=B+-1|0,b[w+E>>0]|0):0){f[y+(B<<2)>>2]=f[y+(E<<2)>>2];D=C;break}f[y+(B<<2)>>2]=C;f[(f[t>>2]|0)+(C<<2)>>2]=C;D=C+1|0}while(0);B=B+1|0;if((B|0)==(m|0))break;else C=D}T=D;U=f[e>>2]|0}else{T=u;U=v}C=a+1|0;if((C|0)==(U|0)){o=T;break}a=C;u=T;v=U;n=f[k>>2]|0;l=f[h>>2]|0}p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}function Maa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Naa(a,b,c,d,e,f,-1)|0}function Naa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;j=u;u=u+272|0;k=j+208|0;l=j+144|0;m=j+152|0;n=j+8|0;o=j;do if((d$(a)|0)==65536){p=f[a+4>>2]|0;f[k>>2]=f[p>>2];q=k+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[k+36>>2]=t;v=k+40|0;f[v>>2]=s;s=k+48|0;w=k+44|0;f[w>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=v;break}else{f[q>>2]=0;ZS(k,p);x=v;break}}else{a$(k,a,-1);x=k+40|0}while(0);a=f[x>>2]|0;v=f[a>>2]|0;f[l>>2]=f[a+4>>2];f[l+4>>2]=v;v$(c,l,h&7,-1,0,0);do if((d$(c)|0)==65536){l=f[c+4>>2]|0;f[m>>2]=f[l>>2];v=m+4|0;a=l+4|0;f[v>>2]=f[a>>2];p=m+8|0;f[p>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];q=f[l+36>>2]|0;f[m+36>>2]=q;f[m+40>>2]=p;p=m+48|0;r=m+44|0;f[r>>2]=p;f[p>>2]=0;f[m+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[a>>2]|0)<3){a=f[l+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[a>>2];f[p+4>>2]=f[a+4>>2];break}else{f[v>>2]=0;ZS(m,l);break}}else a$(m,c,-1);while(0);f[n>>2]=d;f[n+4>>2]=1124007936;d=n+12|0;c=n+44|0;l=n+8|0;v=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(v|0));f[c>>2]=d;d=n+52|0;f[n+48>>2]=d;f[d>>2]=0;f[n+56>>2]=0;f[n+60>>2]=e;f[n+64>>2]=1124007936;e=n+72|0;d=n+104|0;l=n+68|0;v=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(v|0));f[d>>2]=e;e=n+112|0;f[n+108>>2]=e;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;switch(h|0){case 4:case 2:break;default:{f[o>>2]=0;f[o+4>>2]=0;l=tT(o,37)|0;h=249748;v=l+37|0;do{b[l>>0]=b[h>>0]|0;l=l+1|0;h=h+1|0}while((l|0)<(v|0));taa(-210,o,250602,4029)}}o=Oaa(k,m,g,i,n)|0;Paa(n);n=m+36|0;i=f[n>>2]|0;if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)_S(m);f[n>>2]=0;n=m+16|0;i=m+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[m+40>>2]|0;g=0;do{f[n+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[m+44>>2]|0;if((i|0)!=(m+48|0))g0(i);i=k+36|0;m=f[i>>2]|0;if(m|0?(g=m+12|0,m=f[g>>2]|0,f[g>>2]=m+-1,(m|0)==1):0)_S(k);f[i>>2]=0;i=k+16|0;m=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[m>>2]|0)>0){i=f[x>>2]|0;x=0;do{f[i+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)==(k+48|0)){u=j;return o|0}g0(m);u=j;return o|0}function Oaa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;i=h;j=h+13|0;k=h+12|0;l=h+11|0;m=h+10|0;n=h+9|0;o=h+8|0;p=f[c>>2]|0;if(p&4088|0){f[i>>2]=0;q=i+4|0;f[q>>2]=0;r=tT(i,38)|0;s=r;t=249887;v=s+38|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3927)}w=f[a>>2]|0;if(w&4088|0){f[i>>2]=0;q=i+4|0;f[q>>2]=0;r=tT(i,38)|0;s=r;t=249887;v=s+38|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3927)}r=(d|0)==8;q=(d|0)==4;switch(d|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;s=tT(i,38)|0;t=256198;v=s+38|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3928)}}x=(e|0)==1;y=(e|0)==0;z=(e|0)==-1;switch(e|0){case 0:case 1:case -1:break;default:{f[i>>2]=0;f[i+4>>2]=0;s=tT(i,67)|0;t=249951;v=s+67|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3929)}}e=p&7;A=B8()|0;B=z8()|0;if((w&6|1|0)!=1){f[i>>2]=0;f[i+4>>2]=0;s=tT(i,34)|0;t=250019;v=s+34|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-215,i,249926,3936)}if((A|0)!=0&(B|0)>1)C=((f[c+8>>2]|0)/(B|0)|0|0)>1;else C=0;B=(e|0)==0;a:do if(q|y){if(!B){switch(p&7){case 2:{D=(Qaa(j,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=Saa(l,a,c,d,g)|0;u=h;return D|0}else{D=Raa(k,a,c,d,g)|0;u=h;return D|0}}}else if(!(B|r&(x|z)^1)){switch(p&7){case 2:{D=(Taa(m,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=Vaa(o,a,c,d,g)|0;u=h;return D|0}else{D=Uaa(n,a,c,d,g)|0;u=h;return D|0}}while(0);f[i>>2]=0;f[i+4>>2]=0;s=tT(i,28)|0;t=250054;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));taa(-210,i,249926,3982);return 0}function Paa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+120>>2]|0;if(b|0){c=a+124|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);YDc(b)}b=a+64|0;d=a+100|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+80|0;b=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+104>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+108>>2]|0;if((b|0)!=(a+112|0))g0(b);b=a+4|0;c=a+40|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+20|0;b=a+8|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+44>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Qaa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0;a=u;u=u+16|0;i=a;k=f[e+8>>2]|0;if((k|0)!=(f[c+8>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,26)|0;m=250548;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,i,518189,656)}o=f[e+12>>2]|0;if((o|0)!=(f[c+12>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;l=tT(i,26)|0;m=250575;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,i,518189,657)}switch(g|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;l=tT(i,38)|0;m=256198;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));taa(-215,i,518189,658)}}i=f0((Y(o,k)|0)+3&-2)|0;d[i>>1]=0;m=(k|0)>0;if((g|0)==8)if(m){g=(o|0)>0;l=o+-1|0;n=f[c+16>>2]|0;q=f[f[c+44>>2]>>2]|0;r=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;t=0-q|0;v=0-s|0;w=1;x=0;while(1){y=n+(Y(q,x)|0)|0;z=y+t|0;A=r+(Y(s,x)|0)|0;B=A+v|0;if(g){C=(x|0)>0;D=0;E=w;while(1){a:do if(!(b[y+D>>0]|0)){d[A+(D<<1)>>1]=0;F=E}else{if(C){if(b[z+D>>0]|0){d[A+(D<<1)>>1]=d[B+(D<<1)>>1]|0;F=E;break}G=(D|0)>0;if((D|0)<(l|0)?(H=D+1|0,b[z+H>>0]|0):0){I=d[B+(H<<1)>>1]|0;do if(G){H=D+-1|0;if(!(b[z+H>>0]|0)){K=D+-1|0;if(!(b[y+K>>0]|0)){L=I;break}M=d[A+(K<<1)>>1]|0;K=M;while(1){N=d[i+((K&65535)<<1)>>1]|0;if((N&65535)<(K&65535))K=N;else break}if(M<<16>>16==I<<16>>16)O=K;else{N=I;while(1){P=d[i+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}P=(K&65535)>(N&65535)?N:K;Q=I;do{R=i+((Q&65535)<<1)|0;S=Q;Q=d[R>>1]|0;d[R>>1]=P}while((Q&65535)<(S&65535));O=P}P=M;do{Q=i+((P&65535)<<1)|0;K=P;P=d[Q>>1]|0;d[Q>>1]=O}while((P&65535)<(K&65535));L=O}else{P=d[B+(H<<1)>>1]|0;M=P;while(1){K=d[i+((M&65535)<<1)>>1]|0;if((K&65535)<(M&65535))M=K;else break}if(P<<16>>16==I<<16>>16)T=M;else{H=I;while(1){K=d[i+((H&65535)<<1)>>1]|0;if((K&65535)<(H&65535))H=K;else break}K=(M&65535)>(H&65535)?H:M;Q=I;do{N=i+((Q&65535)<<1)|0;S=Q;Q=d[N>>1]|0;d[N>>1]=K}while((Q&65535)<(S&65535));T=K}K=P;do{Q=i+((K&65535)<<1)|0;M=K;K=d[Q>>1]|0;d[Q>>1]=T}while((K&65535)<(M&65535));d[A+(D<<1)>>1]=T;F=E;break a}}else L=I;while(0);d[A+(D<<1)>>1]=L;F=E;break}if(G){I=D+-1|0;if(!(b[z+I>>0]|0))U=46;else{d[A+(D<<1)>>1]=d[B+(I<<1)>>1]|0;F=E;break}}}else if((D|0)>0)U=46;if((U|0)==46?(U=0,I=D+-1|0,b[y+I>>0]|0):0){d[A+(D<<1)>>1]=d[A+(I<<1)>>1]|0;F=E;break}d[A+(D<<1)>>1]=E;I=E&65535;d[i+(I<<1)>>1]=E;F=I+1&65535}while(0);D=D+1|0;if((D|0)==(o|0)){V=F;break}else E=F}}else V=w;x=x+1|0;if((x|0)==(k|0)){W=V;U=81;break}else w=V}}else U=80;else if(m){V=(o|0)>0;w=f[c+16>>2]|0;x=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;F=f[f[e+44>>2]>>2]|0;L=0-x|0;T=0-F|0;O=0;l=1;while(1){g=w+(Y(x,O)|0)|0;v=g+L|0;s=c+(Y(F,O)|0)|0;r=s+T|0;b:do if(V){if((O|0)>0){X=0;Z=l}else{t=0;q=l;while(1){do if(!(b[g+t>>0]|0)){d[s+(t<<1)>>1]=0;_=q}else{if((t|0)>0?(n=t+-1|0,b[g+n>>0]|0):0){d[s+(t<<1)>>1]=d[s+(n<<1)>>1]|0;_=q;break}d[s+(t<<1)>>1]=q;n=q&65535;d[i+(n<<1)>>1]=q;_=n+1&65535}while(0);t=t+1|0;if((t|0)==(o|0)){$=_;break b}else q=_}}while(1){do if(!(b[g+X>>0]|0)){d[s+(X<<1)>>1]=0;aa=Z}else{q=(X|0)>0;if(!(b[v+X>>0]|0)){if(q?(t=X+-1|0,b[g+t>>0]|0):0){d[s+(X<<1)>>1]=d[s+(t<<1)>>1]|0;aa=Z;break}d[s+(X<<1)>>1]=Z;t=Z&65535;d[i+(t<<1)>>1]=Z;aa=t+1&65535;break}t=d[r+(X<<1)>>1]|0;if(q?(q=X+-1|0,(b[g+q>>0]|0)!=0):0){G=d[s+(q<<1)>>1]|0;q=G;while(1){n=d[i+((q&65535)<<1)>>1]|0;if((n&65535)<(q&65535))q=n;else break}if(G<<16>>16==t<<16>>16)ba=q;else{n=t;while(1){E=d[i+((n&65535)<<1)>>1]|0;if((E&65535)<(n&65535))n=E;else break}E=(q&65535)>(n&65535)?n:q;D=t;do{A=i+((D&65535)<<1)|0;y=D;D=d[A>>1]|0;d[A>>1]=E}while((D&65535)<(y&65535));ba=E}E=G;do{D=i+((E&65535)<<1)|0;q=E;E=d[D>>1]|0;d[D>>1]=ba}while((E&65535)<(q&65535));ca=ba}else ca=t;d[s+(X<<1)>>1]=ca;aa=Z}while(0);X=X+1|0;if((X|0)==(o|0)){$=aa;break}else Z=aa}}else $=l;while(0);O=O+1|0;if((O|0)==(k|0)){W=$;U=81;break}else l=$}}else U=80;if((U|0)==80){Xaa(h,1);da=1}else if((U|0)==81){if((W&65535)>1){U=W&65535;W=1;$=1;while(1){l=i+($<<1)|0;O=j[l>>1]|0;if(O>>>0<$>>>0){d[l>>1]=d[i+(O<<1)>>1]|0;ea=W}else{d[l>>1]=W;ea=(W&65535)+1&65535}$=$+1|0;if(($|0)==(U|0)){fa=ea;break}else W=ea}}else fa=1;Xaa(h,fa&65535);if(m){m=f[e+16>>2]|0;ea=f[e+44>>2]|0;e=f[h+20>>2]|0;W=f[h+48>>2]|0;U=f[h+120>>2]|0;$=0;do{l=m+(Y(f[ea>>2]|0,$)|0)|0;O=l+(o<<1)|0;if((l|0)!=(O|0)){aa=(($|0)<0)<<31>>31;Z=l;l=0;while(1){X=d[i+(j[Z>>1]<<1)>>1]|0;d[Z>>1]=X;ca=X&65535;X=e+(Y(f[W>>2]|0,ca)|0)|0;ba=f[X>>2]|0;f[X>>2]=(ba|0)>(l|0)?l:ba;ba=X+8|0;_=f[ba>>2]|0;f[ba>>2]=(_|0)<(l|0)?l:_;_=X+4|0;ba=f[_>>2]|0;f[_>>2]=(ba|0)>($|0)?$:ba;ba=X+12|0;_=f[ba>>2]|0;f[ba>>2]=(_|0)<($|0)?$:_;_=X+16|0;f[_>>2]=(f[_>>2]|0)+1;_=U+(ca<<4)|0;X=_;ba=UIc(f[X>>2]|0,f[X+4>>2]|0,l|0,((l|0)<0)<<31>>31|0)|0;X=_;f[X>>2]=ba;f[X+4>>2]=J;X=U+(ca<<4)+8|0;ca=X;ba=UIc(f[ca>>2]|0,f[ca+4>>2]|0,$|0,aa|0)|0;ca=X;f[ca>>2]=ba;f[ca+4>>2]=J;Z=Z+2|0;if((Z|0)==(O|0))break;else l=l+1|0}}$=$+1|0}while(($|0)!=(k|0));da=fa}else da=fa}fa=h+12|0;if((f[fa>>2]|0)<=0){g0(i);u=a;return da|0}k=f[h+20>>2]|0;$=f[h+48>>2]|0;U=f[h+120>>2]|0;W=f[h+80>>2]|0;e=f[h+108>>2]|0;h=0;do{o=k+(Y(f[$>>2]|0,h)|0)|0;ea=o+8|0;f[ea>>2]=(f[ea>>2]|0)+1-(f[o>>2]|0);ea=o+12|0;f[ea>>2]=(f[ea>>2]|0)+1-(f[o+4>>2]|0);ea=W+(Y(f[e>>2]|0,h)|0)|0;ga=+((f[o+16>>2]|0)>>>0);o=U+(h<<4)|0;p[ea>>3]=(+((f[o>>2]|0)>>>0)+4294967296.0*+((f[o+4>>2]|0)>>>0))/ga;o=U+(h<<4)+8|0;p[ea+8>>3]=(+((f[o>>2]|0)>>>0)+4294967296.0*+((f[o+4>>2]|0)>>>0))/ga;h=h+1|0}while((h|0)<(f[fa>>2]|0));g0(i);u=a;return da|0}function Raa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0;a=u;u=u+16|0;h=a;i=f[d+8>>2]|0;if((i|0)!=(f[c+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,26)|0;k=250548;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));taa(-215,h,518189,656)}m=f[d+12>>2]|0;if((m|0)!=(f[c+12>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,26)|0;k=250575;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));taa(-215,h,518189,657)}switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;j=tT(h,38)|0;k=256198;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));taa(-215,h,518189,658)}}h=f0((((Y(m,i)|0)+1|0)>>>1<<2)+4|0)|0;f[h>>2]=0;k=(i|0)>0;if((e|0)==8)if(k){e=(m|0)>0;j=m+-1|0;l=f[c+16>>2]|0;n=f[c+44>>2]|0;o=f[d+16>>2]|0;q=f[d+44>>2]|0;r=1;s=0;while(1){t=f[n>>2]|0;v=l+(Y(t,s)|0)|0;w=v+(0-t)|0;t=f[q>>2]|0;x=o+(Y(t,s)|0)|0;y=x+(0-t)|0;if(e){t=(s|0)>0;z=0;A=r;while(1){a:do if(!(b[v+z>>0]|0)){f[x+(z<<2)>>2]=0;B=A}else{if(t){if(b[w+z>>0]|0){f[x+(z<<2)>>2]=f[y+(z<<2)>>2];B=A;break}C=(z|0)>0;if((z|0)<(j|0)?(D=z+1|0,b[w+D>>0]|0):0){E=f[y+(D<<2)>>2]|0;do if(C){D=z+-1|0;if(!(b[w+D>>0]|0)){F=z+-1|0;if(!(b[v+F>>0]|0)){G=E;break}H=f[x+(F<<2)>>2]|0;F=H;while(1){I=f[h+(F<<2)>>2]|0;if((I|0)<(F|0))F=I;else break}if((H|0)==(E|0))K=F;else{I=E;while(1){L=f[h+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(F|0)>(I|0)?I:F;M=E;do{N=h+(M<<2)|0;O=M;M=f[N>>2]|0;f[N>>2]=L}while((M|0)<(O|0));K=L}L=H;do{M=h+(L<<2)|0;F=L;L=f[M>>2]|0;f[M>>2]=K}while((L|0)<(F|0));G=K}else{L=f[y+(D<<2)>>2]|0;H=L;while(1){F=f[h+(H<<2)>>2]|0;if((F|0)<(H|0))H=F;else break}if((L|0)==(E|0))P=H;else{D=E;while(1){F=f[h+(D<<2)>>2]|0;if((F|0)<(D|0))D=F;else break}F=(H|0)>(D|0)?D:H;M=E;do{I=h+(M<<2)|0;O=M;M=f[I>>2]|0;f[I>>2]=F}while((M|0)<(O|0));P=F}F=L;do{M=h+(F<<2)|0;H=F;F=f[M>>2]|0;f[M>>2]=P}while((F|0)<(H|0));f[x+(z<<2)>>2]=P;B=A;break a}}else G=E;while(0);f[x+(z<<2)>>2]=G;B=A;break}if(C){E=z+-1|0;if(!(b[w+E>>0]|0))Q=46;else{f[x+(z<<2)>>2]=f[y+(E<<2)>>2];B=A;break}}}else if((z|0)>0)Q=46;if((Q|0)==46?(Q=0,E=z+-1|0,b[v+E>>0]|0):0){f[x+(z<<2)>>2]=f[x+(E<<2)>>2];B=A;break}f[x+(z<<2)>>2]=A;f[h+(A<<2)>>2]=A;B=A+1|0}while(0);z=z+1|0;if((z|0)==(m|0)){R=B;break}else A=B}}else R=r;s=s+1|0;if((s|0)==(i|0)){S=R;Q=81;break}else r=R}}else Q=80;else if(k){R=(m|0)>0;r=f[c+16>>2]|0;s=f[c+44>>2]|0;c=f[d+16>>2]|0;B=f[d+44>>2]|0;G=0;P=1;while(1){K=f[s>>2]|0;j=r+(Y(K,G)|0)|0;e=j+(0-K)|0;K=f[B>>2]|0;o=c+(Y(K,G)|0)|0;q=o+(0-K)|0;b:do if(R){if((G|0)>0){T=0;U=P}else{K=0;l=P;while(1){do if(!(b[j+K>>0]|0)){f[o+(K<<2)>>2]=0;V=l}else{if((K|0)>0?(n=K+-1|0,b[j+n>>0]|0):0){f[o+(K<<2)>>2]=f[o+(n<<2)>>2];V=l;break}f[o+(K<<2)>>2]=l;f[h+(l<<2)>>2]=l;V=l+1|0}while(0);K=K+1|0;if((K|0)==(m|0)){W=V;break b}else l=V}}while(1){do if(!(b[j+T>>0]|0)){f[o+(T<<2)>>2]=0;X=U}else{l=(T|0)>0;if(!(b[e+T>>0]|0)){if(l?(K=T+-1|0,b[j+K>>0]|0):0){f[o+(T<<2)>>2]=f[o+(K<<2)>>2];X=U;break}f[o+(T<<2)>>2]=U;f[h+(U<<2)>>2]=U;X=U+1|0;break}K=f[q+(T<<2)>>2]|0;if(l?(l=T+-1|0,(b[j+l>>0]|0)!=0):0){C=f[o+(l<<2)>>2]|0;l=C;while(1){n=f[h+(l<<2)>>2]|0;if((n|0)<(l|0))l=n;else break}if((C|0)==(K|0))Z=l;else{n=K;while(1){A=f[h+(n<<2)>>2]|0;if((A|0)<(n|0))n=A;else break}A=(l|0)>(n|0)?n:l;z=K;do{x=h+(z<<2)|0;v=z;z=f[x>>2]|0;f[x>>2]=A}while((z|0)<(v|0));Z=A}A=C;do{z=h+(A<<2)|0;l=A;A=f[z>>2]|0;f[z>>2]=Z}while((A|0)<(l|0));_=Z}else _=K;f[o+(T<<2)>>2]=_;X=U}while(0);T=T+1|0;if((T|0)==(m|0)){W=X;break}else U=X}}else W=P;while(0);G=G+1|0;if((G|0)==(i|0)){S=W;Q=81;break}else P=W}}else Q=80;if((Q|0)==80){Xaa(g,1);$=1}else if((Q|0)==81){if((S|0)>1){Q=1;W=1;while(1){P=h+(W<<2)|0;G=f[P>>2]|0;if((G|0)<(W|0)){f[P>>2]=f[h+(G<<2)>>2];aa=Q}else{f[P>>2]=Q;aa=Q+1|0}W=W+1|0;if((W|0)==(S|0)){ba=aa;break}else Q=aa}}else ba=1;Xaa(g,ba);if(k){k=f[d+16>>2]|0;aa=f[d+44>>2]|0;d=f[g+20>>2]|0;Q=f[g+48>>2]|0;S=f[g+120>>2]|0;W=0;do{P=k+(Y(f[aa>>2]|0,W)|0)|0;G=P+(m<<2)|0;if((P|0)!=(G|0)){X=((W|0)<0)<<31>>31;U=P;P=0;while(1){T=f[h+(f[U>>2]<<2)>>2]|0;f[U>>2]=T;_=d+(Y(f[Q>>2]|0,T)|0)|0;Z=f[_>>2]|0;f[_>>2]=(Z|0)>(P|0)?P:Z;Z=_+8|0;V=f[Z>>2]|0;f[Z>>2]=(V|0)<(P|0)?P:V;V=_+4|0;Z=f[V>>2]|0;f[V>>2]=(Z|0)>(W|0)?W:Z;Z=_+12|0;V=f[Z>>2]|0;f[Z>>2]=(V|0)<(W|0)?W:V;V=_+16|0;f[V>>2]=(f[V>>2]|0)+1;V=S+(T<<4)|0;_=V;Z=UIc(f[_>>2]|0,f[_+4>>2]|0,P|0,((P|0)<0)<<31>>31|0)|0;_=V;f[_>>2]=Z;f[_+4>>2]=J;_=S+(T<<4)+8|0;T=_;Z=UIc(f[T>>2]|0,f[T+4>>2]|0,W|0,X|0)|0;T=_;f[T>>2]=Z;f[T+4>>2]=J;U=U+4|0;if((U|0)==(G|0))break;else P=P+1|0}}W=W+1|0}while((W|0)!=(i|0));$=ba}else $=ba}ba=g+12|0;if((f[ba>>2]|0)<=0){g0(h);u=a;return $|0}i=f[g+20>>2]|0;W=f[g+48>>2]|0;S=f[g+120>>2]|0;Q=f[g+80>>2]|0;d=f[g+108>>2]|0;g=0;do{m=i+(Y(f[W>>2]|0,g)|0)|0;aa=m+8|0;f[aa>>2]=(f[aa>>2]|0)+1-(f[m>>2]|0);aa=m+12|0;f[aa>>2]=(f[aa>>2]|0)+1-(f[m+4>>2]|0);aa=Q+(Y(f[d>>2]|0,g)|0)|0;ca=+((f[m+16>>2]|0)>>>0);m=S+(g<<4)|0;p[aa>>3]=(+((f[m>>2]|0)>>>0)+4294967296.0*+((f[m+4>>2]|0)>>>0))/ca;m=S+(g<<4)+8|0;p[aa+8>>3]=(+((f[m>>2]|0)>>>0)+4294967296.0*+((f[m+4>>2]|0)>>>0))/ca;g=g+1|0}while((g|0)<(f[ba>>2]|0));g0(h);u=a;return $|0}function Saa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+48|0;h=a+32|0;i=a+24|0;j=a;k=f[c+8>>2]|0;l=d+8|0;if((k|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,26)|0;n=250083;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,578)}q=f[c+12>>2]|0;r=d+12|0;if((q|0)!=(f[r>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,26)|0;n=250110;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,579)}switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;m=tT(h,38)|0;n=256198;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,580)}}n=((Y(q,k)|0)+1|0)>>>1;s=f0(k<<2)|0;t=f0((n<<2)+4|0)|0;f[t>>2]=0;f[h>>2]=0;f[h+4>>2]=k;n=(k|0)/2|0;v=(z8()|0)<<2;w=(v|0)<(n|0)?v:n;x=+(((w|0)>1?w:1)|0);f[i>>2]=1;if((e|0)==8){f[j>>2]=46940;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=t;f[j+16>>2]=s;y8(h,j,x);cba(d,t,s);if((k|0)>0){e=(q+1|0)/2|0;w=0;do{n=w+1|0;v=(Y((n|0)/2|0,e)|0)+1|0;y=f[s+(n<<2)>>2]|0;n=y+v|0;if((y|0)>0){y=v;do{v=t+(y<<2)|0;z=f[v>>2]|0;if((z|0)<(y|0))f[v>>2]=f[t+(z<<2)>>2];else{f[v>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}y=y+1|0}while((y|0)<(n|0))}w=f[s+(w<<2)>>2]|0}while((w|0)<(k|0))}}else{f[j>>2]=46960;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=t;f[j+16>>2]=s;y8(h,j,x);c=f[r>>2]|0;r=f[l>>2]|0;w=f[s>>2]|0;a:do if((w|0)<(r|0)){e=f[d+16>>2]|0;n=f[d+44>>2]|0;if((c|0)>0)A=w;else{y=w;while(1){y=f[s+(y<<2)>>2]|0;if((y|0)>=(r|0))break a}}do{y=f[n>>2]|0;v=e+(Y(y,A)|0)|0;z=v+(0-y)|0;y=0;do{B=v+(y<<2)|0;C=f[B>>2]|0;if((C|0)>0?(D=f[z+(y<<2)>>2]|0,(D|0)>0):0){E=D;while(1){F=f[t+(E<<2)>>2]|0;if((F|0)<(E|0))E=F;else break}if((D|0)==(C|0))G=E;else{F=C;while(1){H=f[t+(F<<2)>>2]|0;if((H|0)<(F|0))F=H;else break}H=(E|0)>(F|0)?F:E;I=C;do{K=t+(I<<2)|0;L=I;I=f[K>>2]|0;f[K>>2]=H}while((I|0)<(L|0));G=H}H=D;do{I=t+(H<<2)|0;C=H;H=f[I>>2]|0;f[I>>2]=G}while((H|0)<(C|0));f[B>>2]=G}y=y+1|0}while((y|0)!=(c|0));A=f[s+(A<<2)>>2]|0}while((A|0)<(r|0))}while(0);if((k|0)>0){r=0;do{A=(((Y(r,q)|0)+1|0)/2|0)+1|0;c=f[s+(r+1<<2)>>2]|0;G=c+A|0;if((c|0)>0){c=A;do{A=t+(c<<2)|0;w=f[A>>2]|0;if((w|0)<(c|0))f[A>>2]=f[t+(w<<2)>>2];else{f[A>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}c=c+1|0}while((c|0)<(G|0))}r=f[s+(r<<2)>>2]|0}while((r|0)<(k|0))}}r=k*136|0;q=XDc(k>>>0>31580641|r>>>0>4294967291?-1:r+4|0)|0;f[q>>2]=k;r=q+4|0;if(k|0){G=r+(k*136|0)|0;k=r;do{f[k>>2]=0;f[k+4>>2]=1124007936;c=k+12|0;A=k+44|0;m=k+8|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[A>>2]=c;w=k+52|0;f[k+48>>2]=w;f[w>>2]=0;f[k+56>>2]=0;f[k+60>>2]=0;f[k+64>>2]=1124007936;w=k+72|0;e=k+104|0;m=k+68|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[e>>2]=w;c=k+112|0;f[k+108>>2]=c;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;k=k+136|0}while((k|0)!=(G|0))}Xaa(g,f[i>>2]|0);f[j>>2]=46980;f[j+4>>2]=d;f[j+8>>2]=t;f[j+12>>2]=g;f[j+16>>2]=r;f[j+20>>2]=i;y8(h,j,x);j=f[l>>2]|0;l=f[g+132>>2]|0;if((l|0)<(j|0)){h=g+20|0;d=g+48|0;G=g+120|0;k=l;l=f[i>>2]|0;while(1){if((l|0)>0){m=r+(k*136|0)+120|0;o=f[r+(k*136|0)+20>>2]|0;c=f[r+(k*136|0)+48>>2]|0;A=0;n=l;while(1){y=o+(Y(f[c>>2]|0,A)|0)|0;z=y+16|0;if((f[z>>2]|0)>0){v=(f[h>>2]|0)+(Y(f[f[d>>2]>>2]|0,A)|0)|0;H=f[v>>2]|0;D=f[y>>2]|0;f[v>>2]=(H|0)>(D|0)?D:H;H=v+8|0;f[H>>2]=f[((f[H>>2]|0)<(f[y+8>>2]|0)?y:v)+8>>2];H=v+4|0;f[H>>2]=f[((f[H>>2]|0)>(f[y+4>>2]|0)?y:v)+4>>2];H=v+12|0;f[H>>2]=f[((f[H>>2]|0)<(f[y+12>>2]|0)?y:v)+12>>2];y=v+16|0;f[y>>2]=(f[y>>2]|0)+(f[z>>2]|0);z=f[m>>2]|0;y=z+(A<<4)|0;v=f[G>>2]|0;H=v+(A<<4)|0;D=H;C=UIc(f[D>>2]|0,f[D+4>>2]|0,f[y>>2]|0,f[y+4>>2]|0)|0;y=H;f[y>>2]=C;f[y+4>>2]=J;y=z+(A<<4)+8|0;z=v+(A<<4)+8|0;v=z;C=UIc(f[v>>2]|0,f[v+4>>2]|0,f[y>>2]|0,f[y+4>>2]|0)|0;y=z;f[y>>2]=C;f[y+4>>2]=J;M=f[i>>2]|0}else M=n;A=A+1|0;if((A|0)>=(M|0)){N=M;break}else n=M}}else N=l;k=f[r+(k*136|0)+132>>2]|0;if((k|0)>=(j|0))break;else l=N}}N=g+12|0;if((f[N>>2]|0)>0){l=f[g+20>>2]|0;j=f[g+48>>2]|0;k=f[g+120>>2]|0;M=f[g+80>>2]|0;G=f[g+108>>2]|0;g=0;do{d=l+(Y(f[j>>2]|0,g)|0)|0;h=d+8|0;f[h>>2]=(f[h>>2]|0)+1-(f[d>>2]|0);h=d+12|0;f[h>>2]=(f[h>>2]|0)+1-(f[d+4>>2]|0);h=M+(Y(f[G>>2]|0,g)|0)|0;x=+((f[d+16>>2]|0)>>>0);d=k+(g<<4)|0;p[h>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/x;d=k+(g<<4)+8|0;p[h+8>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/x;g=g+1|0}while((g|0)<(f[N>>2]|0))}N=r+((f[q>>2]|0)*136|0)|0;if((r|0)==(N|0)){ZDc(q);g0(s);g0(t);O=f[i>>2]|0;u=a;return O|0}else P=N;do{P=P+-136|0;Paa(P)}while((P|0)!=(r|0));ZDc(q);g0(s);g0(t);O=f[i>>2]|0;u=a;return O|0}function Taa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0.0;a=u;u=u+16|0;i=a;k=f[c+8>>2]|0;l=e+8|0;if((k|0)!=(f[l>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;m=tT(i,26)|0;n=250083;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,i,518189,2589)}q=f[c+12>>2]|0;r=e+12|0;if((q|0)!=(f[r>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;m=tT(i,26)|0;n=250110;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,i,518189,2590)}if((g|0)!=8){f[i>>2]=0;f[i+4>>2]=0;m=tT(i,17)|0;n=250137;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,i,518189,2591)}i=f0((Y(((k+1|0)/2|0)<<1,(q+1|0)/2|0)|0)+2|0)|0;d[i>>1]=0;if((k|0)>0){n=c+16|0;m=c+44|0;o=e+16|0;g=e+44|0;s=(q|0)>0;t=1;v=0;while(1){w=f[f[m>>2]>>2]|0;x=(f[n>>2]|0)+(Y(w,v)|0)|0;y=0-w|0;z=x+y|0;A=z+y|0;y=x+w|0;w=f[f[g>>2]>>2]|0;B=(f[o>>2]|0)+(Y(w,v)|0)|0;C=0-w|0;w=B+C+C|0;if(s){C=(v|1|0)<(k|0);D=(v|0)>0;E=D^1;F=(v+-2|0)>-1;G=0;H=t;while(1){a:do if(!(b[x+G>>0]|0)){I=G|1;K=(I|0)<(q|0);if(C?b[y+G>>0]|0:0){L=G+-1|0;M=(G|0)>0;if(K?b[x+I>>0]|0:0){do if(M){if(b[x+L>>0]|0){do if(D){if(b[z+I>>0]|0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;O=G+-2|0;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}do if((O|0)>-1){if(!(b[z+O>>0]|0))break;if(b[A+L>>0]|0){d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}P=d[w+(G<<1)>>1]|0;Q=d[B+(O<<1)>>1]|0;R=P;while(1){S=d[i+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}if(P<<16>>16==Q<<16>>16)T=R;else{S=Q;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}U=(R&65535)>(S&65535)?S:R;V=Q;do{W=i+((V&65535)<<1)|0;X=V;V=d[W>>1]|0;d[W>>1]=U}while((V&65535)<(X&65535));T=U}U=P;do{V=i+((U&65535)<<1)|0;Q=U;U=d[V>>1]|0;d[V>>1]=T}while((U&65535)<(Q&65535));d[B+(G<<1)>>1]=T;N=H;break a}while(0);U=d[w+(G<<1)>>1]|0;P=d[B+(O<<1)>>1]|0;Q=U;while(1){V=d[i+((Q&65535)<<1)>>1]|0;if((V&65535)<(Q&65535))Q=V;else break}if(U<<16>>16==P<<16>>16)Z=Q;else{O=P;while(1){V=d[i+((O&65535)<<1)>>1]|0;if((V&65535)<(O&65535))O=V;else break}V=(Q&65535)>(O&65535)?O:Q;R=P;do{S=i+((R&65535)<<1)|0;X=R;R=d[S>>1]|0;d[S>>1]=V}while((R&65535)<(X&65535));Z=V}V=U;do{R=i+((V&65535)<<1)|0;P=V;V=d[R>>1]|0;d[R>>1]=Z}while((V&65535)<(P&65535));d[B+(G<<1)>>1]=Z;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;U=d[B+(G+-2<<1)>>1]|0;P=V;while(1){R=d[i+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(V<<16>>16==U<<16>>16)_=P;else{R=U;while(1){Q=d[i+((R&65535)<<1)>>1]|0;if((Q&65535)<(R&65535))R=Q;else break}Q=(P&65535)>(R&65535)?R:P;O=U;do{X=i+((O&65535)<<1)|0;S=O;O=d[X>>1]|0;d[X>>1]=Q}while((O&65535)<(S&65535));_=Q}Q=V;do{O=i+((Q&65535)<<1)|0;U=Q;Q=d[O>>1]|0;d[O>>1]=_}while((Q&65535)<(U&65535));d[B+(G<<1)>>1]=_;N=H;break a}Q=G+2|0;if((Q|0)>=(q|0))break;if(!(b[z+Q>>0]|0))break;do if(F){if(!(b[A+I>>0]|0))break;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[A+G>>0]|0)){V=d[w+(Q<<1)>>1]|0;U=d[B+(G+-2<<1)>>1]|0;O=V;while(1){P=d[i+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(V<<16>>16==U<<16>>16)$=O;else{P=U;while(1){R=d[i+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;S=U;do{X=i+((S&65535)<<1)|0;W=S;S=d[X>>1]|0;d[X>>1]=R}while((S&65535)<(W&65535));$=R}R=V;do{S=i+((R&65535)<<1)|0;U=R;R=d[S>>1]|0;d[S>>1]=$}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=$;N=H;break a}R=G+-2|0;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}do if((R|0)>-1){if(!(b[z+R>>0]|0))break;if(b[A+L>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}V=d[w+(Q<<1)>>1]|0;U=d[B+(R<<1)>>1]|0;S=V;while(1){O=d[i+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}if(V<<16>>16==U<<16>>16)aa=S;else{O=U;while(1){P=d[i+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(S&65535)>(O&65535)?O:S;W=U;do{X=i+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(ba&65535));aa=P}P=V;do{W=i+((P&65535)<<1)|0;U=P;P=d[W>>1]|0;d[W>>1]=aa}while((P&65535)<(U&65535));d[B+(G<<1)>>1]=aa;N=H;break a}while(0);P=d[w+(Q<<1)>>1]|0;V=d[B+(R<<1)>>1]|0;U=P;while(1){W=d[i+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}if(P<<16>>16==V<<16>>16)ca=U;else{R=V;while(1){W=d[i+((R&65535)<<1)>>1]|0;if((W&65535)<(R&65535))R=W;else break}W=(U&65535)>(R&65535)?R:U;S=V;do{O=i+((S&65535)<<1)|0;ba=S;S=d[O>>1]|0;d[O>>1]=W}while((S&65535)<(ba&65535));ca=W}W=P;do{S=i+((W&65535)<<1)|0;V=W;W=d[S>>1]|0;d[S>>1]=ca}while((W&65535)<(V&65535));d[B+(G<<1)>>1]=ca;N=H;break a}while(0);W=d[w+(Q<<1)>>1]|0;P=d[B+(G+-2<<1)>>1]|0;V=W;while(1){S=d[i+((V&65535)<<1)>>1]|0;if((S&65535)<(V&65535))V=S;else break}if(W<<16>>16==P<<16>>16)da=V;else{Q=P;while(1){S=d[i+((Q&65535)<<1)>>1]|0;if((S&65535)<(Q&65535))Q=S;else break}S=(V&65535)>(Q&65535)?Q:V;U=P;do{R=i+((U&65535)<<1)|0;ba=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(ba&65535));da=S}S=W;do{U=i+((S&65535)<<1)|0;P=S;S=d[U>>1]|0;d[U>>1]=da}while((S&65535)<(P&65535));d[B+(G<<1)>>1]=da;N=H;break a}while(0);d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[y+L>>0]|0))break;do if(D){if(b[z+I>>0]|0){S=G+-2|0;do if((S|0)>-1){if(!(b[x+S>>0]|0))break;if(b[z+L>>0]|0){W=d[B+(S<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=W;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;U=P;while(1){V=d[i+((U&65535)<<1)>>1]|0;if((V&65535)<(U&65535))U=V;else break}if(P<<16>>16==W<<16>>16)ea=U;else{V=W;while(1){Q=d[i+((V&65535)<<1)>>1]|0;if((Q&65535)<(V&65535))V=Q;else break}Q=(U&65535)>(V&65535)?V:U;ba=W;do{R=i+((ba&65535)<<1)|0;O=ba;ba=d[R>>1]|0;d[R>>1]=Q}while((ba&65535)<(O&65535));ea=Q}Q=P;do{ba=i+((Q&65535)<<1)|0;W=Q;Q=d[ba>>1]|0;d[ba>>1]=ea}while((Q&65535)<(W&65535));d[B+(G<<1)>>1]=ea;N=H;break a}if(!(b[z+S>>0]|0)){Q=d[w+(G<<1)>>1]|0;P=d[B+(S<<1)>>1]|0;W=Q;while(1){ba=d[i+((W&65535)<<1)>>1]|0;if((ba&65535)<(W&65535))W=ba;else break}if(Q<<16>>16==P<<16>>16)fa=W;else{ba=P;while(1){U=d[i+((ba&65535)<<1)>>1]|0;if((U&65535)<(ba&65535))ba=U;else break}U=(W&65535)>(ba&65535)?ba:W;V=P;do{O=i+((V&65535)<<1)|0;R=V;V=d[O>>1]|0;d[O>>1]=U}while((V&65535)<(R&65535));fa=U}U=Q;do{V=i+((U&65535)<<1)|0;P=U;U=d[V>>1]|0;d[V>>1]=fa}while((U&65535)<(P&65535));d[B+(G<<1)>>1]=fa;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;U=d[B+(S<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=U;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=U;N=H;break a}Q=d[w+(G<<1)>>1]|0;P=Q;while(1){V=d[i+((P&65535)<<1)>>1]|0;if((V&65535)<(P&65535))P=V;else break}if(Q<<16>>16==U<<16>>16)ga=P;else{V=U;while(1){W=d[i+((V&65535)<<1)>>1]|0;if((W&65535)<(V&65535))V=W;else break}W=(P&65535)>(V&65535)?V:P;ba=U;do{R=i+((ba&65535)<<1)|0;O=ba;ba=d[R>>1]|0;d[R>>1]=W}while((ba&65535)<(O&65535));ga=W}W=Q;do{ba=i+((W&65535)<<1)|0;U=W;W=d[ba>>1]|0;d[ba>>1]=ga}while((W&65535)<(U&65535));d[B+(G<<1)>>1]=ga;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;U=W;while(1){ba=d[i+((U&65535)<<1)>>1]|0;if((ba&65535)<(U&65535))U=ba;else break}if(W<<16>>16==Q<<16>>16)ha=U;else{ba=Q;while(1){P=d[i+((ba&65535)<<1)>>1]|0;if((P&65535)<(ba&65535))ba=P;else break}P=(U&65535)>(ba&65535)?ba:U;V=Q;do{O=i+((V&65535)<<1)|0;R=V;V=d[O>>1]|0;d[O>>1]=P}while((V&65535)<(R&65535));ha=P}P=W;do{V=i+((P&65535)<<1)|0;Q=P;P=d[V>>1]|0;d[V>>1]=ha}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=ha;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;W=d[B+(S<<1)>>1]|0;Q=P;while(1){V=d[i+((Q&65535)<<1)>>1]|0;if((V&65535)<(Q&65535))Q=V;else break}if(P<<16>>16==W<<16>>16)ia=Q;else{S=W;while(1){V=d[i+((S&65535)<<1)>>1]|0;if((V&65535)<(S&65535))S=V;else break}V=(Q&65535)>(S&65535)?S:Q;U=W;do{ba=i+((U&65535)<<1)|0;R=U;U=d[ba>>1]|0;d[ba>>1]=V}while((U&65535)<(R&65535));ia=V}V=P;do{U=i+((V&65535)<<1)|0;W=V;V=d[U>>1]|0;d[U>>1]=ia}while((V&65535)<(W&65535));d[B+(G<<1)>>1]=ia;N=H;break a}V=G+2|0;do if(!((V|0)>=(q|0)|E)){if(!(b[z+V>>0]|0))break;do if(F){if(!(b[A+I>>0]|0))break;P=G+-2|0;do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[z+L>>0]|0){W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}U=d[w+(V<<1)>>1]|0;Q=U;while(1){S=d[i+((Q&65535)<<1)>>1]|0;if((S&65535)<(Q&65535))Q=S;else break}if(U<<16>>16==W<<16>>16)ja=Q;else{S=W;while(1){R=d[i+((S&65535)<<1)>>1]|0;if((R&65535)<(S&65535))S=R;else break}R=(Q&65535)>(S&65535)?S:Q;ba=W;do{O=i+((ba&65535)<<1)|0;X=ba;ba=d[O>>1]|0;d[O>>1]=R}while((ba&65535)<(X&65535));ja=R}R=U;do{ba=i+((R&65535)<<1)|0;W=R;R=d[ba>>1]|0;d[ba>>1]=ja}while((R&65535)<(W&65535));d[B+(G<<1)>>1]=ja;N=H;break a}if(!(b[z+P>>0]|0)){R=d[w+(V<<1)>>1]|0;U=d[B+(P<<1)>>1]|0;W=R;while(1){ba=d[i+((W&65535)<<1)>>1]|0;if((ba&65535)<(W&65535))W=ba;else break}if(R<<16>>16==U<<16>>16)ka=W;else{ba=U;while(1){Q=d[i+((ba&65535)<<1)>>1]|0;if((Q&65535)<(ba&65535))ba=Q;else break}Q=(W&65535)>(ba&65535)?ba:W;S=U;do{X=i+((S&65535)<<1)|0;O=S;S=d[X>>1]|0;d[X>>1]=Q}while((S&65535)<(O&65535));ka=Q}Q=R;do{S=i+((Q&65535)<<1)|0;U=Q;Q=d[S>>1]|0;d[S>>1]=ka}while((Q&65535)<(U&65535));d[B+(G<<1)>>1]=ka;N=H;break a}if(!(b[A+L>>0]|0)){Q=d[w+(V<<1)>>1]|0;R=d[B+(P<<1)>>1]|0;U=Q;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}if(Q<<16>>16==R<<16>>16)la=U;else{S=R;while(1){W=d[i+((S&65535)<<1)>>1]|0;if((W&65535)<(S&65535))S=W;else break}W=(U&65535)>(S&65535)?S:U;ba=R;do{O=i+((ba&65535)<<1)|0;X=ba;ba=d[O>>1]|0;d[O>>1]=W}while((ba&65535)<(X&65535));la=W}W=Q;do{ba=i+((W&65535)<<1)|0;R=W;W=d[ba>>1]|0;d[ba>>1]=la}while((W&65535)<(R&65535));d[B+(G<<1)>>1]=la;N=H;break a}W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}Q=d[w+(V<<1)>>1]|0;R=Q;while(1){ba=d[i+((R&65535)<<1)>>1]|0;if((ba&65535)<(R&65535))R=ba;else break}if(Q<<16>>16==W<<16>>16)ma=R;else{ba=W;while(1){U=d[i+((ba&65535)<<1)>>1]|0;if((U&65535)<(ba&65535))ba=U;else break}U=(R&65535)>(ba&65535)?ba:R;S=W;do{X=i+((S&65535)<<1)|0;O=S;S=d[X>>1]|0;d[X>>1]=U}while((S&65535)<(O&65535));ma=U}U=Q;do{S=i+((U&65535)<<1)|0;W=U;U=d[S>>1]|0;d[S>>1]=ma}while((U&65535)<(W&65535));d[B+(G<<1)>>1]=ma;N=H;break a}while(0);U=d[w+(V<<1)>>1]|0;Q=d[B+(P<<1)>>1]|0;W=U;while(1){S=d[i+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}if(U<<16>>16==Q<<16>>16)na=W;else{P=Q;while(1){S=d[i+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(W&65535)>(P&65535)?P:W;R=Q;do{ba=i+((R&65535)<<1)|0;O=R;R=d[ba>>1]|0;d[ba>>1]=S}while((R&65535)<(O&65535));na=S}S=U;do{R=i+((S&65535)<<1)|0;Q=S;S=d[R>>1]|0;d[R>>1]=na}while((S&65535)<(Q&65535));d[B+(G<<1)>>1]=na;N=H;break a}while(0);S=G+-2|0;if(!(b[z+G>>0]|0)){U=d[w+(V<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;R=U;while(1){W=d[i+((R&65535)<<1)>>1]|0;if((W&65535)<(R&65535))R=W;else break}if(U<<16>>16==Q<<16>>16)oa=R;else{W=Q;while(1){P=d[i+((W&65535)<<1)>>1]|0;if((P&65535)<(W&65535))W=P;else break}P=(R&65535)>(W&65535)?W:R;O=Q;do{ba=i+((O&65535)<<1)|0;X=O;O=d[ba>>1]|0;d[ba>>1]=P}while((O&65535)<(X&65535));oa=P}P=U;do{O=i+((P&65535)<<1)|0;Q=P;P=d[O>>1]|0;d[O>>1]=oa}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=oa;N=H;break a}do if((S|0)>-1){if(!(b[x+S>>0]|0))break;if(b[z+L>>0]|0){P=d[w+(V<<1)>>1]|0;U=d[B+(S<<1)>>1]|0;Q=P;while(1){O=d[i+((Q&65535)<<1)>>1]|0;if((O&65535)<(Q&65535))Q=O;else break}if(P<<16>>16==U<<16>>16)pa=Q;else{O=U;while(1){R=d[i+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}R=(Q&65535)>(O&65535)?O:Q;W=U;do{X=i+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=R}while((W&65535)<(ba&65535));pa=R}R=P;do{W=i+((R&65535)<<1)|0;U=R;R=d[W>>1]|0;d[W>>1]=pa}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=pa;N=H;break a}if(!(b[z+S>>0]|0)){R=d[w+(G<<1)>>1]|0;P=d[w+(V<<1)>>1]|0;U=R;while(1){W=d[i+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}if(R<<16>>16==P<<16>>16)qa=U;else{W=P;while(1){Q=d[i+((W&65535)<<1)>>1]|0;if((Q&65535)<(W&65535))W=Q;else break}Q=(U&65535)>(W&65535)?W:U;O=P;do{ba=i+((O&65535)<<1)|0;X=O;O=d[ba>>1]|0;d[ba>>1]=Q}while((O&65535)<(X&65535));qa=Q}Q=R;do{O=i+((Q&65535)<<1)|0;P=Q;Q=d[O>>1]|0;d[O>>1]=qa}while((Q&65535)<(P&65535));Q=d[B+(S<<1)>>1]|0;R=qa;while(1){P=d[i+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}if(qa<<16>>16==Q<<16>>16)ra=R;else{P=Q;while(1){O=d[i+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(R&65535)>(P&65535)?P:R;U=Q;do{W=i+((U&65535)<<1)|0;X=U;U=d[W>>1]|0;d[W>>1]=O}while((U&65535)<(X&65535));ra=O}O=qa;do{U=i+((O&65535)<<1)|0;Q=O;O=d[U>>1]|0;d[U>>1]=ra}while((O&65535)<(Q&65535));d[B+(G<<1)>>1]=ra;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;O=d[w+(V<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;U=O;while(1){R=d[i+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(O<<16>>16==Q<<16>>16)sa=U;else{R=Q;while(1){P=d[i+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(U&65535)>(R&65535)?R:U;X=Q;do{W=i+((X&65535)<<1)|0;ba=X;X=d[W>>1]|0;d[W>>1]=P}while((X&65535)<(ba&65535));sa=P}P=O;do{X=i+((P&65535)<<1)|0;Q=P;P=d[X>>1]|0;d[X>>1]=sa}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=sa;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;O=d[w+(V<<1)>>1]|0;Q=P;while(1){X=d[i+((Q&65535)<<1)>>1]|0;if((X&65535)<(Q&65535))Q=X;else break}if(P<<16>>16==O<<16>>16)ta=Q;else{X=O;while(1){U=d[i+((X&65535)<<1)>>1]|0;if((U&65535)<(X&65535))X=U;else break}U=(Q&65535)>(X&65535)?X:Q;R=O;do{ba=i+((R&65535)<<1)|0;W=R;R=d[ba>>1]|0;d[ba>>1]=U}while((R&65535)<(W&65535));ta=U}U=P;do{R=i+((U&65535)<<1)|0;O=U;U=d[R>>1]|0;d[R>>1]=ta}while((U&65535)<(O&65535));U=d[B+(S<<1)>>1]|0;P=ta;while(1){O=d[i+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}if(ta<<16>>16==U<<16>>16)ua=P;else{O=U;while(1){R=d[i+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}R=(P&65535)>(O&65535)?O:P;Q=U;do{X=i+((Q&65535)<<1)|0;W=Q;Q=d[X>>1]|0;d[X>>1]=R}while((Q&65535)<(W&65535));ua=R}R=ta;do{Q=i+((R&65535)<<1)|0;U=R;R=d[Q>>1]|0;d[Q>>1]=ua}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=ua;N=H;break a}while(0);R=d[w+(G<<1)>>1]|0;U=d[w+(V<<1)>>1]|0;Q=R;while(1){P=d[i+((Q&65535)<<1)>>1]|0;if((P&65535)<(Q&65535))Q=P;else break}if(R<<16>>16==U<<16>>16)va=Q;else{P=U;while(1){O=d[i+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(Q&65535)>(P&65535)?P:Q;W=U;do{X=i+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=O}while((W&65535)<(ba&65535));va=O}O=R;do{W=i+((O&65535)<<1)|0;U=O;O=d[W>>1]|0;d[W>>1]=va}while((O&65535)<(U&65535));O=d[B+(S<<1)>>1]|0;R=va;while(1){U=d[i+((R&65535)<<1)>>1]|0;if((U&65535)<(R&65535))R=U;else break}if(va<<16>>16==O<<16>>16)wa=R;else{S=O;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}U=(R&65535)>(S&65535)?S:R;W=O;do{Q=i+((W&65535)<<1)|0;P=W;W=d[Q>>1]|0;d[Q>>1]=U}while((W&65535)<(P&65535));wa=U}U=va;do{W=i+((U&65535)<<1)|0;O=U;U=d[W>>1]|0;d[W>>1]=wa}while((U&65535)<(O&65535));d[B+(G<<1)>>1]=wa;N=H;break a}while(0);V=G+-2|0;if(!(b[z+G>>0]|0)){xa=V;break}do if((V|0)>-1){if(!(b[x+V>>0]|0))break;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(V<<1)>>1]|0;N=H;break a}if(!(b[z+V>>0]|0)){U=d[w+(G<<1)>>1]|0;O=d[B+(V<<1)>>1]|0;W=U;while(1){R=d[i+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(U<<16>>16==O<<16>>16)ya=W;else{R=O;while(1){S=d[i+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(W&65535)>(R&65535)?R:W;P=O;do{Q=i+((P&65535)<<1)|0;ba=P;P=d[Q>>1]|0;d[Q>>1]=S}while((P&65535)<(ba&65535));ya=S}S=U;do{P=i+((S&65535)<<1)|0;O=S;S=d[P>>1]|0;d[P>>1]=ya}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=ya;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;d[B+(G<<1)>>1]=d[B+(V<<1)>>1]|0;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;U=d[B+(V<<1)>>1]|0;O=S;while(1){P=d[i+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(S<<16>>16==U<<16>>16)za=O;else{P=U;while(1){W=d[i+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}W=(O&65535)>(P&65535)?P:O;R=U;do{ba=i+((R&65535)<<1)|0;Q=R;R=d[ba>>1]|0;d[ba>>1]=W}while((R&65535)<(Q&65535));za=W}W=S;do{R=i+((W&65535)<<1)|0;U=W;W=d[R>>1]|0;d[R>>1]=za}while((W&65535)<(U&65535));d[B+(G<<1)>>1]=za;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;S=d[B+(V<<1)>>1]|0;U=W;while(1){R=d[i+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(W<<16>>16==S<<16>>16)Aa=U;else{V=S;while(1){R=d[i+((V&65535)<<1)>>1]|0;if((R&65535)<(V&65535))V=R;else break}R=(U&65535)>(V&65535)?V:U;O=S;do{P=i+((O&65535)<<1)|0;Q=O;O=d[P>>1]|0;d[P>>1]=R}while((O&65535)<(Q&65535));Aa=R}R=W;do{O=i+((R&65535)<<1)|0;S=R;R=d[O>>1]|0;d[O>>1]=Aa}while((R&65535)<(S&65535));d[B+(G<<1)>>1]=Aa;N=H;break a}else xa=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(xa<<1)>>1]|0;N=H;break a}while(0);do if(D){if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}R=G+2|0;do if(!((R|0)>=(q|0)|E)){if(!(b[z+R>>0]|0))break;if(!(b[z+G>>0]|0)){d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;S=d[w+(R<<1)>>1]|0;O=W;while(1){U=d[i+((O&65535)<<1)>>1]|0;if((U&65535)<(O&65535))O=U;else break}if(W<<16>>16==S<<16>>16)Ba=O;else{U=S;while(1){V=d[i+((U&65535)<<1)>>1]|0;if((V&65535)<(U&65535))U=V;else break}V=(O&65535)>(U&65535)?U:O;Q=S;do{P=i+((Q&65535)<<1)|0;ba=Q;Q=d[P>>1]|0;d[P>>1]=V}while((Q&65535)<(ba&65535));Ba=V}V=W;do{Q=i+((V&65535)<<1)|0;S=V;V=d[Q>>1]|0;d[Q>>1]=Ba}while((V&65535)<(S&65535));d[B+(G<<1)>>1]=Ba;N=H;break a}while(0);if(!(b[z+G>>0]|0))break;d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}while(0);d[B+(G<<1)>>1]=H;R=H&65535;d[i+(R<<1)>>1]=H;N=R+1&65535;break}if(M){if(b[y+L>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}if(b[x+L>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}}d[B+(G<<1)>>1]=H;R=H&65535;d[i+(R<<1)>>1]=H;N=R+1&65535;break}do if(K){if(!(b[x+I>>0]|0)){if(!C)break;if(!(b[y+I>>0]|0))break;d[B+(G<<1)>>1]=H;R=H&65535;d[i+(R<<1)>>1]=H;N=R+1&65535;break a}if(D){if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}R=G+2|0;do if(!((R|0)>=(q|0)|E)){if(!(b[z+R>>0]|0))break;if(!(b[z+G>>0]|0)){d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;W=d[w+(R<<1)>>1]|0;S=V;while(1){Q=d[i+((S&65535)<<1)>>1]|0;if((Q&65535)<(S&65535))S=Q;else break}if(V<<16>>16==W<<16>>16)Ca=S;else{Q=W;while(1){O=d[i+((Q&65535)<<1)>>1]|0;if((O&65535)<(Q&65535))Q=O;else break}O=(S&65535)>(Q&65535)?Q:S;U=W;do{ba=i+((U&65535)<<1)|0;P=U;U=d[ba>>1]|0;d[ba>>1]=O}while((U&65535)<(P&65535));Ca=O}O=V;do{U=i+((O&65535)<<1)|0;W=O;O=d[U>>1]|0;d[U>>1]=Ca}while((O&65535)<(W&65535));d[B+(G<<1)>>1]=Ca;N=H;break a}while(0);if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}}d[B+(G<<1)>>1]=H;R=H&65535;d[i+(R<<1)>>1]=H;N=R+1&65535;break a}while(0);d[B+(G<<1)>>1]=0;N=H}else{I=G+-1|0;K=(G|0)>0;if(K){if(b[x+I>>0]|0){L=G|1;M=(L|0)<(q|0);if(D&M?b[z+L>>0]|0:0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}do if(F){if(!(b[A+G>>0]|0))break;R=G+-2|0;if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}do if((R|0)>-1){if(!(b[z+R>>0]|0))break;if(b[A+I>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}O=d[w+(G<<1)>>1]|0;V=d[B+(R<<1)>>1]|0;W=O;while(1){U=d[i+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(O<<16>>16==V<<16>>16)Da=W;else{U=V;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;Q=V;do{P=i+((Q&65535)<<1)|0;ba=Q;Q=d[P>>1]|0;d[P>>1]=S}while((Q&65535)<(ba&65535));Da=S}S=O;do{Q=i+((S&65535)<<1)|0;V=S;S=d[Q>>1]|0;d[Q>>1]=Da}while((S&65535)<(V&65535));d[B+(G<<1)>>1]=Da;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;O=d[B+(R<<1)>>1]|0;V=S;while(1){Q=d[i+((V&65535)<<1)>>1]|0;if((Q&65535)<(V&65535))V=Q;else break}if(S<<16>>16==O<<16>>16)Ea=V;else{R=O;while(1){Q=d[i+((R&65535)<<1)>>1]|0;if((Q&65535)<(R&65535))R=Q;else break}Q=(V&65535)>(R&65535)?R:V;W=O;do{U=i+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=Q}while((W&65535)<(ba&65535));Ea=Q}Q=S;do{W=i+((Q&65535)<<1)|0;O=Q;Q=d[W>>1]|0;d[W>>1]=Ea}while((Q&65535)<(O&65535));d[B+(G<<1)>>1]=Ea;N=H;break a}while(0);Q=d[w+(G<<1)>>1]|0;S=d[B+(G+-2<<1)>>1]|0;O=Q;while(1){W=d[i+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(Q<<16>>16==S<<16>>16)Fa=O;else{W=S;while(1){V=d[i+((W&65535)<<1)>>1]|0;if((V&65535)<(W&65535))W=V;else break}V=(O&65535)>(W&65535)?W:O;R=S;do{ba=i+((R&65535)<<1)|0;U=R;R=d[ba>>1]|0;d[ba>>1]=V}while((R&65535)<(U&65535));Fa=V}V=Q;do{R=i+((V&65535)<<1)|0;S=V;V=d[R>>1]|0;d[R>>1]=Fa}while((V&65535)<(S&65535));d[B+(G<<1)>>1]=Fa;N=H;break}if(M?b[x+L>>0]|0:0){V=G+2|0;do if(D&(V|0)<(q|0)){if(!(b[z+V>>0]|0))break;do if(F){if(!(b[A+L>>0]|0))break;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[A+G>>0]|0)){Q=d[w+(V<<1)>>1]|0;S=d[B+(G+-2<<1)>>1]|0;R=Q;while(1){O=d[i+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(Q<<16>>16==S<<16>>16)Ga=R;else{O=S;while(1){W=d[i+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}W=(R&65535)>(O&65535)?O:R;U=S;do{ba=i+((U&65535)<<1)|0;P=U;U=d[ba>>1]|0;d[ba>>1]=W}while((U&65535)<(P&65535));Ga=W}W=Q;do{U=i+((W&65535)<<1)|0;S=W;W=d[U>>1]|0;d[U>>1]=Ga}while((W&65535)<(S&65535));d[B+(G<<1)>>1]=Ga;N=H;break a}W=G+-2|0;if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[B+(W<<1)>>1]|0;N=H;break a}do if((W|0)>-1){if(!(b[z+W>>0]|0))break;if(b[A+I>>0]|0){d[B+(G<<1)>>1]=d[B+(W<<1)>>1]|0;N=H;break a}Q=d[w+(V<<1)>>1]|0;S=d[B+(W<<1)>>1]|0;U=Q;while(1){R=d[i+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(Q<<16>>16==S<<16>>16)Ha=U;else{R=S;while(1){O=d[i+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}O=(U&65535)>(R&65535)?R:U;P=S;do{ba=i+((P&65535)<<1)|0;X=P;P=d[ba>>1]|0;d[ba>>1]=O}while((P&65535)<(X&65535));Ha=O}O=Q;do{P=i+((O&65535)<<1)|0;S=O;O=d[P>>1]|0;d[P>>1]=Ha}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=Ha;N=H;break a}while(0);O=d[w+(V<<1)>>1]|0;Q=d[B+(W<<1)>>1]|0;S=O;while(1){P=d[i+((S&65535)<<1)>>1]|0;if((P&65535)<(S&65535))S=P;else break}if(O<<16>>16==Q<<16>>16)Ia=S;else{W=Q;while(1){P=d[i+((W&65535)<<1)>>1]|0;if((P&65535)<(W&65535))W=P;else break}P=(S&65535)>(W&65535)?W:S;U=Q;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=P}while((U&65535)<(X&65535));Ia=P}P=O;do{U=i+((P&65535)<<1)|0;Q=P;P=d[U>>1]|0;d[U>>1]=Ia}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=Ia;N=H;break a}while(0);P=d[w+(V<<1)>>1]|0;O=d[B+(G+-2<<1)>>1]|0;Q=P;while(1){U=d[i+((Q&65535)<<1)>>1]|0;if((U&65535)<(Q&65535))Q=U;else break}if(P<<16>>16==O<<16>>16)Ja=Q;else{U=O;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(Q&65535)>(U&65535)?U:Q;W=O;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=S}while((W&65535)<(R&65535));Ja=S}S=P;do{W=i+((S&65535)<<1)|0;O=S;S=d[W>>1]|0;d[W>>1]=Ja}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=Ja;N=H;break a}while(0);d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}if(C?b[y+I>>0]|0:0){V=G|1;L=(V|0)<(q|0);if(!(E|L^1)?b[z+V>>0]|0:0){M=G+-2|0;do if((M|0)>-1){if(!(b[x+M>>0]|0))break;if(b[z+I>>0]|0){S=d[B+(M<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=S;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;O=P;while(1){W=d[i+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(P<<16>>16==S<<16>>16)Ka=O;else{W=S;while(1){Q=d[i+((W&65535)<<1)>>1]|0;if((Q&65535)<(W&65535))W=Q;else break}Q=(O&65535)>(W&65535)?W:O;U=S;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=Q}while((U&65535)<(X&65535));Ka=Q}Q=P;do{U=i+((Q&65535)<<1)|0;S=Q;Q=d[U>>1]|0;d[U>>1]=Ka}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=Ka;N=H;break a}if(!(b[z+M>>0]|0)){Q=d[w+(G<<1)>>1]|0;P=d[B+(M<<1)>>1]|0;S=Q;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(Q<<16>>16==P<<16>>16)La=S;else{U=P;while(1){O=d[i+((U&65535)<<1)>>1]|0;if((O&65535)<(U&65535))U=O;else break}O=(S&65535)>(U&65535)?U:S;W=P;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=O}while((W&65535)<(R&65535));La=O}O=Q;do{W=i+((O&65535)<<1)|0;P=O;O=d[W>>1]|0;d[W>>1]=La}while((O&65535)<(P&65535));d[B+(G<<1)>>1]=La;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;O=d[B+(M<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}Q=d[w+(G<<1)>>1]|0;P=Q;while(1){W=d[i+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}if(Q<<16>>16==O<<16>>16)Ma=P;else{W=O;while(1){S=d[i+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}S=(P&65535)>(W&65535)?W:P;U=O;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(X&65535));Ma=S}S=Q;do{U=i+((S&65535)<<1)|0;O=S;S=d[U>>1]|0;d[U>>1]=Ma}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=Ma;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;Q=d[B+(M<<1)>>1]|0;O=S;while(1){U=d[i+((O&65535)<<1)>>1]|0;if((U&65535)<(O&65535))O=U;else break}if(S<<16>>16==Q<<16>>16)Na=O;else{U=Q;while(1){P=d[i+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(O&65535)>(U&65535)?U:O;W=Q;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(R&65535));Na=P}P=S;do{W=i+((P&65535)<<1)|0;Q=P;P=d[W>>1]|0;d[W>>1]=Na}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=Na;N=H;break a}while(0);if(b[z+G>>0]|0){P=d[w+(G<<1)>>1]|0;S=d[B+(M<<1)>>1]|0;Q=P;while(1){W=d[i+((Q&65535)<<1)>>1]|0;if((W&65535)<(Q&65535))Q=W;else break}if(P<<16>>16==S<<16>>16)Oa=Q;else{W=S;while(1){O=d[i+((W&65535)<<1)>>1]|0;if((O&65535)<(W&65535))W=O;else break}O=(Q&65535)>(W&65535)?W:Q;U=S;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=O}while((U&65535)<(X&65535));Oa=O}O=P;do{U=i+((O&65535)<<1)|0;S=O;O=d[U>>1]|0;d[U>>1]=Oa}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=Oa;N=H;break}O=d[w+(G<<1)>>1]|0;if(!(b[z+I>>0]|0)){P=d[B+(M<<1)>>1]|0;S=O;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(O<<16>>16==P<<16>>16)Pa=S;else{U=P;while(1){Q=d[i+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(S&65535)>(U&65535)?U:S;W=P;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=Q}while((W&65535)<(R&65535));Pa=Q}Q=O;do{W=i+((Q&65535)<<1)|0;P=Q;Q=d[W>>1]|0;d[W>>1]=Pa}while((Q&65535)<(P&65535));d[B+(G<<1)>>1]=Pa;N=H;break}do if(F){if(!(b[A+G>>0]|0))break;Q=d[B+(M<<1)>>1]|0;P=O;while(1){W=d[i+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}if(O<<16>>16==Q<<16>>16)Qa=P;else{W=Q;while(1){S=d[i+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}S=(P&65535)>(W&65535)?W:P;U=Q;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(X&65535));Qa=S}S=O;do{U=i+((S&65535)<<1)|0;Q=S;S=d[U>>1]|0;d[U>>1]=Qa}while((S&65535)<(Q&65535));d[B+(G<<1)>>1]=Qa;N=H;break a}while(0);S=d[w+(M<<1)>>1]|0;Q=S;while(1){U=d[i+((Q&65535)<<1)>>1]|0;if((U&65535)<(Q&65535))Q=U;else break}if(S<<16>>16==O<<16>>16)Ra=Q;else{U=O;while(1){P=d[i+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(Q&65535)>(U&65535)?U:Q;W=O;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(R&65535));Ra=P}P=S;do{W=i+((P&65535)<<1)|0;O=P;P=d[W>>1]|0;d[W>>1]=Ra}while((P&65535)<(O&65535));P=d[B+(M<<1)>>1]|0;S=Ra;while(1){O=d[i+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}if(Ra<<16>>16==P<<16>>16)Sa=S;else{M=P;while(1){O=d[i+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}O=(S&65535)>(M&65535)?M:S;W=P;do{Q=i+((W&65535)<<1)|0;U=W;W=d[Q>>1]|0;d[Q>>1]=O}while((W&65535)<(U&65535));Sa=O}O=Ra;do{W=i+((O&65535)<<1)|0;P=O;O=d[W>>1]|0;d[W>>1]=Sa}while((O&65535)<(P&65535));d[B+(G<<1)>>1]=Sa;N=H;break}if(L?b[x+V>>0]|0:0){O=G+2|0;do if(!((O|0)>=(q|0)|E)){if(!(b[z+O>>0]|0))break;P=G+-2|0;do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[z+I>>0]|0){do if(F){if(!(b[A+V>>0]|0))break;W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}S=d[w+(O<<1)>>1]|0;M=S;while(1){U=d[i+((M&65535)<<1)>>1]|0;if((U&65535)<(M&65535))M=U;else break}if(S<<16>>16==W<<16>>16)Ta=M;else{U=W;while(1){Q=d[i+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(M&65535)>(U&65535)?U:M;R=W;do{X=i+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=Q}while((R&65535)<(ba&65535));Ta=Q}Q=S;do{R=i+((Q&65535)<<1)|0;W=Q;Q=d[R>>1]|0;d[R>>1]=Ta}while((Q&65535)<(W&65535));d[B+(G<<1)>>1]=Ta;N=H;break a}while(0);Q=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=Q;while(1){R=d[i+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(Q<<16>>16==S<<16>>16)Ua=W;else{R=S;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(W&65535)>(R&65535)?R:W;U=S;do{ba=i+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=M}while((U&65535)<(X&65535));Ua=M}M=Q;do{U=i+((M&65535)<<1)|0;S=M;M=d[U>>1]|0;d[U>>1]=Ua}while((M&65535)<(S&65535));d[B+(G<<1)>>1]=Ua;N=H;break a}do if(F){if(!(b[A+V>>0]|0))break;if(!(b[z+P>>0]|0)){M=d[w+(O<<1)>>1]|0;Q=d[B+(P<<1)>>1]|0;S=M;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(M<<16>>16==Q<<16>>16)Va=S;else{U=Q;while(1){W=d[i+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}W=(S&65535)>(U&65535)?U:S;R=Q;do{X=i+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=W}while((R&65535)<(ba&65535));Va=W}W=M;do{R=i+((W&65535)<<1)|0;Q=W;W=d[R>>1]|0;d[R>>1]=Va}while((W&65535)<(Q&65535));d[B+(G<<1)>>1]=Va;N=H;break a}if(!(b[A+I>>0]|0)){W=d[w+(O<<1)>>1]|0;M=d[B+(P<<1)>>1]|0;Q=W;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(W<<16>>16==M<<16>>16)Wa=Q;else{R=M;while(1){S=d[i+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(Q&65535)>(R&65535)?R:Q;U=M;do{ba=i+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=S}while((U&65535)<(X&65535));Wa=S}S=W;do{U=i+((S&65535)<<1)|0;M=S;S=d[U>>1]|0;d[U>>1]=Wa}while((S&65535)<(M&65535));d[B+(G<<1)>>1]=Wa;N=H;break a}S=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}W=d[w+(O<<1)>>1]|0;M=W;while(1){U=d[i+((M&65535)<<1)>>1]|0;if((U&65535)<(M&65535))M=U;else break}if(W<<16>>16==S<<16>>16)Xa=M;else{U=S;while(1){Q=d[i+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(M&65535)>(U&65535)?U:M;R=S;do{X=i+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=Q}while((R&65535)<(ba&65535));Xa=Q}Q=W;do{R=i+((Q&65535)<<1)|0;S=Q;Q=d[R>>1]|0;d[R>>1]=Xa}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=Xa;N=H;break a}while(0);if(!(b[z+G>>0]|0)){Q=d[w+(O<<1)>>1]|0;W=d[B+(P<<1)>>1]|0;S=Q;while(1){R=d[i+((S&65535)<<1)>>1]|0;if((R&65535)<(S&65535))S=R;else break}if(Q<<16>>16==W<<16>>16)Ya=S;else{R=W;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(S&65535)>(R&65535)?R:S;U=W;do{ba=i+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=M}while((U&65535)<(X&65535));Ya=M}M=Q;do{U=i+((M&65535)<<1)|0;W=M;M=d[U>>1]|0;d[U>>1]=Ya}while((M&65535)<(W&65535));d[B+(G<<1)>>1]=Ya;N=H;break a}if(!(b[z+P>>0]|0)){M=d[w+(G<<1)>>1]|0;Q=d[w+(O<<1)>>1]|0;W=M;while(1){U=d[i+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(M<<16>>16==Q<<16>>16)Za=W;else{U=Q;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;R=Q;do{X=i+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=S}while((R&65535)<(ba&65535));Za=S}S=M;do{R=i+((S&65535)<<1)|0;Q=S;S=d[R>>1]|0;d[R>>1]=Za}while((S&65535)<(Q&65535));S=d[B+(P<<1)>>1]|0;M=Za;while(1){Q=d[i+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}if(Za<<16>>16==S<<16>>16)_a=M;else{Q=S;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}R=(M&65535)>(Q&65535)?Q:M;W=S;do{U=i+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=R}while((W&65535)<(ba&65535));_a=R}R=Za;do{W=i+((R&65535)<<1)|0;S=R;R=d[W>>1]|0;d[W>>1]=_a}while((R&65535)<(S&65535));d[B+(G<<1)>>1]=_a;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;R=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=R;while(1){M=d[i+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}if(R<<16>>16==S<<16>>16)$a=W;else{M=S;while(1){Q=d[i+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}Q=(W&65535)>(M&65535)?M:W;ba=S;do{U=i+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=Q}while((ba&65535)<(X&65535));$a=Q}Q=R;do{ba=i+((Q&65535)<<1)|0;S=Q;Q=d[ba>>1]|0;d[ba>>1]=$a}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=$a;N=H;break a}while(0);Q=d[w+(G<<1)>>1]|0;R=d[w+(O<<1)>>1]|0;S=Q;while(1){ba=d[i+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(Q<<16>>16==R<<16>>16)ab=S;else{ba=R;while(1){W=d[i+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(S&65535)>(ba&65535)?ba:S;M=R;do{X=i+((M&65535)<<1)|0;U=M;M=d[X>>1]|0;d[X>>1]=W}while((M&65535)<(U&65535));ab=W}W=Q;do{M=i+((W&65535)<<1)|0;R=W;W=d[M>>1]|0;d[M>>1]=ab}while((W&65535)<(R&65535));W=d[B+(P<<1)>>1]|0;Q=ab;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(ab<<16>>16==W<<16>>16)bb=Q;else{R=W;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(Q&65535)>(R&65535)?R:Q;S=W;do{ba=i+((S&65535)<<1)|0;U=S;S=d[ba>>1]|0;d[ba>>1]=M}while((S&65535)<(U&65535));bb=M}M=ab;do{S=i+((M&65535)<<1)|0;W=M;M=d[S>>1]|0;d[S>>1]=bb}while((M&65535)<(W&65535));d[B+(G<<1)>>1]=bb;N=H;break a}while(0);if(b[z+G>>0]|0){do if(F){if(!(b[A+V>>0]|0))break;M=d[w+(O<<1)>>1]|0;W=d[B+(P<<1)>>1]|0;S=M;while(1){Q=d[i+((S&65535)<<1)>>1]|0;if((Q&65535)<(S&65535))S=Q;else break}if(M<<16>>16==W<<16>>16)cb=S;else{Q=W;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}R=(S&65535)>(Q&65535)?Q:S;U=W;do{ba=i+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=R}while((U&65535)<(X&65535));cb=R}R=M;do{U=i+((R&65535)<<1)|0;W=R;R=d[U>>1]|0;d[U>>1]=cb}while((R&65535)<(W&65535));d[B+(G<<1)>>1]=cb;N=H;break a}while(0);R=d[w+(G<<1)>>1]|0;M=d[w+(O<<1)>>1]|0;W=R;while(1){U=d[i+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(R<<16>>16==M<<16>>16)db=W;else{U=M;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;Q=M;do{X=i+((Q&65535)<<1)|0;ba=Q;Q=d[X>>1]|0;d[X>>1]=S}while((Q&65535)<(ba&65535));db=S}S=R;do{Q=i+((S&65535)<<1)|0;M=S;S=d[Q>>1]|0;d[Q>>1]=db}while((S&65535)<(M&65535));S=d[B+(P<<1)>>1]|0;R=db;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}if(db<<16>>16==S<<16>>16)eb=R;else{M=S;while(1){Q=d[i+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}Q=(R&65535)>(M&65535)?M:R;W=S;do{U=i+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=Q}while((W&65535)<(ba&65535));eb=Q}Q=db;do{W=i+((Q&65535)<<1)|0;S=Q;Q=d[W>>1]|0;d[W>>1]=eb}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=eb;N=H;break a}if(!(b[z+I>>0]|0)){Q=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=Q;while(1){R=d[i+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(Q<<16>>16==S<<16>>16)fb=W;else{R=S;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(W&65535)>(R&65535)?R:W;ba=S;do{U=i+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=M}while((ba&65535)<(X&65535));fb=M}M=Q;do{ba=i+((M&65535)<<1)|0;S=M;M=d[ba>>1]|0;d[ba>>1]=fb}while((M&65535)<(S&65535));d[B+(G<<1)>>1]=fb;N=H;break a}do if(F){if(!(b[A+V>>0]|0))break;M=d[w+(O<<1)>>1]|0;if(b[A+G>>0]|0){Q=d[B+(P<<1)>>1]|0;S=M;while(1){ba=d[i+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(M<<16>>16==Q<<16>>16)gb=S;else{ba=Q;while(1){W=d[i+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(S&65535)>(ba&65535)?ba:S;R=Q;do{X=i+((R&65535)<<1)|0;U=R;R=d[X>>1]|0;d[X>>1]=W}while((R&65535)<(U&65535));gb=W}W=M;do{R=i+((W&65535)<<1)|0;Q=W;W=d[R>>1]|0;d[R>>1]=gb}while((W&65535)<(Q&65535));d[B+(G<<1)>>1]=gb;N=H;break a}W=d[w+(P<<1)>>1]|0;Q=W;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(W<<16>>16==M<<16>>16)hb=Q;else{R=M;while(1){S=d[i+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(Q&65535)>(R&65535)?R:Q;ba=M;do{U=i+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=S}while((ba&65535)<(X&65535));hb=S}S=W;do{ba=i+((S&65535)<<1)|0;M=S;S=d[ba>>1]|0;d[ba>>1]=hb}while((S&65535)<(M&65535));S=d[B+(P<<1)>>1]|0;W=hb;while(1){M=d[i+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}if(hb<<16>>16==S<<16>>16)ib=W;else{M=S;while(1){ba=d[i+((M&65535)<<1)>>1]|0;if((ba&65535)<(M&65535))M=ba;else break}ba=(W&65535)>(M&65535)?M:W;Q=S;do{R=i+((Q&65535)<<1)|0;X=Q;Q=d[R>>1]|0;d[R>>1]=ba}while((Q&65535)<(X&65535));ib=ba}ba=hb;do{Q=i+((ba&65535)<<1)|0;S=ba;ba=d[Q>>1]|0;d[Q>>1]=ib}while((ba&65535)<(S&65535));d[B+(G<<1)>>1]=ib;N=H;break a}while(0);ba=d[w+(P<<1)>>1]|0;S=d[w+(O<<1)>>1]|0;Q=ba;while(1){W=d[i+((Q&65535)<<1)>>1]|0;if((W&65535)<(Q&65535))Q=W;else break}if(ba<<16>>16==S<<16>>16)jb=Q;else{W=S;while(1){M=d[i+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}M=(Q&65535)>(W&65535)?W:Q;X=S;do{R=i+((X&65535)<<1)|0;U=X;X=d[R>>1]|0;d[R>>1]=M}while((X&65535)<(U&65535));jb=M}M=ba;do{X=i+((M&65535)<<1)|0;S=M;M=d[X>>1]|0;d[X>>1]=jb}while((M&65535)<(S&65535));M=d[B+(P<<1)>>1]|0;ba=jb;while(1){S=d[i+((ba&65535)<<1)>>1]|0;if((S&65535)<(ba&65535))ba=S;else break}if(jb<<16>>16==M<<16>>16)kb=ba;else{P=M;while(1){S=d[i+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(ba&65535)>(P&65535)?P:ba;X=M;do{Q=i+((X&65535)<<1)|0;W=X;X=d[Q>>1]|0;d[Q>>1]=S}while((X&65535)<(W&65535));kb=S}S=jb;do{X=i+((S&65535)<<1)|0;M=S;S=d[X>>1]|0;d[X>>1]=kb}while((S&65535)<(M&65535));d[B+(G<<1)>>1]=kb;N=H;break a}while(0);do if(D){O=G+-2|0;if(b[z+I>>0]|0){V=d[B+(O<<1)>>1]|0;do if((O|0)>-1){if(!(b[x+O>>0]|0))break;d[B+(G<<1)>>1]=V;N=H;break a}while(0);L=d[w+(O<<1)>>1]|0;S=L;while(1){M=d[i+((S&65535)<<1)>>1]|0;if((M&65535)<(S&65535))S=M;else break}if(L<<16>>16==V<<16>>16)lb=S;else{M=V;while(1){X=d[i+((M&65535)<<1)>>1]|0;if((X&65535)<(M&65535))M=X;else break}X=(S&65535)>(M&65535)?M:S;ba=V;do{P=i+((ba&65535)<<1)|0;W=ba;ba=d[P>>1]|0;d[P>>1]=X}while((ba&65535)<(W&65535));lb=X}X=L;do{ba=i+((X&65535)<<1)|0;V=X;X=d[ba>>1]|0;d[ba>>1]=lb}while((X&65535)<(V&65535));d[B+(G<<1)>>1]=lb;N=H;break a}if(!(b[z+G>>0]|0)){mb=O;break}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(!(b[z+O>>0]|0)){X=d[w+(G<<1)>>1]|0;L=d[B+(O<<1)>>1]|0;V=X;while(1){ba=d[i+((V&65535)<<1)>>1]|0;if((ba&65535)<(V&65535))V=ba;else break}if(X<<16>>16==L<<16>>16)nb=V;else{ba=L;while(1){S=d[i+((ba&65535)<<1)>>1]|0;if((S&65535)<(ba&65535))ba=S;else break}S=(V&65535)>(ba&65535)?ba:V;M=L;do{W=i+((M&65535)<<1)|0;P=M;M=d[W>>1]|0;d[W>>1]=S}while((M&65535)<(P&65535));nb=S}S=X;do{M=i+((S&65535)<<1)|0;L=S;S=d[M>>1]|0;d[M>>1]=nb}while((S&65535)<(L&65535));d[B+(G<<1)>>1]=nb;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;X=d[B+(O<<1)>>1]|0;L=S;while(1){M=d[i+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(S<<16>>16==X<<16>>16)ob=L;else{M=X;while(1){V=d[i+((M&65535)<<1)>>1]|0;if((V&65535)<(M&65535))M=V;else break}V=(L&65535)>(M&65535)?M:L;ba=X;do{P=i+((ba&65535)<<1)|0;W=ba;ba=d[P>>1]|0;d[P>>1]=V}while((ba&65535)<(W&65535));ob=V}V=S;do{ba=i+((V&65535)<<1)|0;X=V;V=d[ba>>1]|0;d[ba>>1]=ob}while((V&65535)<(X&65535));d[B+(G<<1)>>1]=ob;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;S=d[B+(O<<1)>>1]|0;X=V;while(1){ba=d[i+((X&65535)<<1)>>1]|0;if((ba&65535)<(X&65535))X=ba;else break}if(V<<16>>16==S<<16>>16)pb=X;else{O=S;while(1){ba=d[i+((O&65535)<<1)>>1]|0;if((ba&65535)<(O&65535))O=ba;else break}ba=(X&65535)>(O&65535)?O:X;L=S;do{M=i+((L&65535)<<1)|0;W=L;L=d[M>>1]|0;d[M>>1]=ba}while((L&65535)<(W&65535));pb=ba}ba=V;do{L=i+((ba&65535)<<1)|0;S=ba;ba=d[L>>1]|0;d[L>>1]=pb}while((ba&65535)<(S&65535));d[B+(G<<1)>>1]=pb;N=H;break a}else mb=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(mb<<1)>>1]|0;N=H;break}do if(D){ba=G+-2|0;if(b[z+I>>0]|0){V=d[B+(ba<<1)>>1]|0;do if((ba|0)>-1){if(!(b[x+ba>>0]|0))break;d[B+(G<<1)>>1]=V;N=H;break a}while(0);S=d[w+(ba<<1)>>1]|0;L=S;while(1){X=d[i+((L&65535)<<1)>>1]|0;if((X&65535)<(L&65535))L=X;else break}if(S<<16>>16==V<<16>>16)qb=L;else{X=V;while(1){O=d[i+((X&65535)<<1)>>1]|0;if((O&65535)<(X&65535))X=O;else break}O=(L&65535)>(X&65535)?X:L;W=V;do{M=i+((W&65535)<<1)|0;P=W;W=d[M>>1]|0;d[M>>1]=O}while((W&65535)<(P&65535));qb=O}O=S;do{W=i+((O&65535)<<1)|0;V=O;O=d[W>>1]|0;d[W>>1]=qb}while((O&65535)<(V&65535));d[B+(G<<1)>>1]=qb;N=H;break a}if(!(b[z+G>>0]|0)){rb=ba;break}do if((ba|0)>-1){if(!(b[x+ba>>0]|0))break;if(!(b[z+ba>>0]|0)){O=d[w+(G<<1)>>1]|0;S=d[B+(ba<<1)>>1]|0;V=O;while(1){W=d[i+((V&65535)<<1)>>1]|0;if((W&65535)<(V&65535))V=W;else break}if(O<<16>>16==S<<16>>16)sb=V;else{W=S;while(1){L=d[i+((W&65535)<<1)>>1]|0;if((L&65535)<(W&65535))W=L;else break}L=(V&65535)>(W&65535)?W:V;X=S;do{P=i+((X&65535)<<1)|0;M=X;X=d[P>>1]|0;d[P>>1]=L}while((X&65535)<(M&65535));sb=L}L=O;do{X=i+((L&65535)<<1)|0;S=L;L=d[X>>1]|0;d[X>>1]=sb}while((L&65535)<(S&65535));d[B+(G<<1)>>1]=sb;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[B+(ba<<1)>>1]|0;N=H;break a}while(0);L=d[w+(G<<1)>>1]|0;O=d[B+(ba<<1)>>1]|0;S=L;while(1){X=d[i+((S&65535)<<1)>>1]|0;if((X&65535)<(S&65535))S=X;else break}if(L<<16>>16==O<<16>>16)tb=S;else{X=O;while(1){V=d[i+((X&65535)<<1)>>1]|0;if((V&65535)<(X&65535))X=V;else break}V=(S&65535)>(X&65535)?X:S;W=O;do{M=i+((W&65535)<<1)|0;P=W;W=d[M>>1]|0;d[M>>1]=V}while((W&65535)<(P&65535));tb=V}V=L;do{W=i+((V&65535)<<1)|0;O=V;V=d[W>>1]|0;d[W>>1]=tb}while((V&65535)<(O&65535));d[B+(G<<1)>>1]=tb;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;L=d[B+(ba<<1)>>1]|0;O=V;while(1){W=d[i+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(V<<16>>16==L<<16>>16)ub=O;else{ba=L;while(1){W=d[i+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(O&65535)>(ba&65535)?ba:O;S=L;do{X=i+((S&65535)<<1)|0;P=S;S=d[X>>1]|0;d[X>>1]=W}while((S&65535)<(P&65535));ub=W}W=V;do{S=i+((W&65535)<<1)|0;L=W;W=d[S>>1]|0;d[S>>1]=ub}while((W&65535)<(L&65535));d[B+(G<<1)>>1]=ub;N=H;break a}else rb=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(rb<<1)>>1]|0;N=H;break}}W=G|1;V=(W|0)<(q|0);if(!(E|V^1)?b[z+W>>0]|0:0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(K?b[z+I>>0]|0:0){L=d[w+(G<<1)>>1]|0;do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=L;N=H;break a}while(0);S=d[w+(G+-2<<1)>>1]|0;O=S;while(1){ba=d[i+((O&65535)<<1)>>1]|0;if((ba&65535)<(O&65535))O=ba;else break}if(S<<16>>16==L<<16>>16)vb=O;else{ba=L;while(1){P=d[i+((ba&65535)<<1)>>1]|0;if((P&65535)<(ba&65535))ba=P;else break}P=(O&65535)>(ba&65535)?ba:O;X=L;do{M=i+((X&65535)<<1)|0;Q=X;X=d[M>>1]|0;d[M>>1]=P}while((X&65535)<(Q&65535));vb=P}P=S;do{X=i+((P&65535)<<1)|0;L=P;P=d[X>>1]|0;d[X>>1]=vb}while((P&65535)<(L&65535));d[B+(G<<1)>>1]=vb;N=H;break}d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(V?b[x+W>>0]|0:0){P=G+2|0;if(!((P|0)>=(q|0)|E)?b[z+P>>0]|0:0){if(b[z+G>>0]|0){do if(F){if(!(b[A+W>>0]|0))break;d[B+(G<<1)>>1]=d[w+(P<<1)>>1]|0;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;S=d[w+(P<<1)>>1]|0;L=V;while(1){X=d[i+((L&65535)<<1)>>1]|0;if((X&65535)<(L&65535))L=X;else break}if(V<<16>>16==S<<16>>16)wb=L;else{X=S;while(1){O=d[i+((X&65535)<<1)>>1]|0;if((O&65535)<(X&65535))X=O;else break}O=(L&65535)>(X&65535)?X:L;ba=S;do{Q=i+((ba&65535)<<1)|0;M=ba;ba=d[Q>>1]|0;d[Q>>1]=O}while((ba&65535)<(M&65535));wb=O}O=V;do{ba=i+((O&65535)<<1)|0;S=O;O=d[ba>>1]|0;d[ba>>1]=wb}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=wb;N=H;break}do if(K){if(!(b[z+I>>0]|0))break;do if(F){if(!(b[A+W>>0]|0))break;O=d[w+(P<<1)>>1]|0;if(b[A+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}V=d[w+(G+-2<<1)>>1]|0;S=V;while(1){ba=d[i+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(V<<16>>16==O<<16>>16)xb=S;else{ba=O;while(1){L=d[i+((ba&65535)<<1)>>1]|0;if((L&65535)<(ba&65535))ba=L;else break}L=(S&65535)>(ba&65535)?ba:S;X=O;do{M=i+((X&65535)<<1)|0;Q=X;X=d[M>>1]|0;d[M>>1]=L}while((X&65535)<(Q&65535));xb=L}L=V;do{X=i+((L&65535)<<1)|0;O=L;L=d[X>>1]|0;d[X>>1]=xb}while((L&65535)<(O&65535));d[B+(G<<1)>>1]=xb;N=H;break a}while(0);L=d[w+(G+-2<<1)>>1]|0;V=d[w+(P<<1)>>1]|0;O=L;while(1){X=d[i+((O&65535)<<1)>>1]|0;if((X&65535)<(O&65535))O=X;else break}if(L<<16>>16==V<<16>>16)yb=O;else{X=V;while(1){S=d[i+((X&65535)<<1)>>1]|0;if((S&65535)<(X&65535))X=S;else break}S=(O&65535)>(X&65535)?X:O;ba=V;do{Q=i+((ba&65535)<<1)|0;M=ba;ba=d[Q>>1]|0;d[Q>>1]=S}while((ba&65535)<(M&65535));yb=S}S=L;do{ba=i+((S&65535)<<1)|0;V=S;S=d[ba>>1]|0;d[ba>>1]=yb}while((S&65535)<(V&65535));d[B+(G<<1)>>1]=yb;N=H;break a}while(0);d[B+(G<<1)>>1]=d[w+(P<<1)>>1]|0;N=H;break}if(D?b[z+G>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}do if(!(E|K^1)){if(!(b[z+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(G+-2<<1)>>1]|0;N=H;break a}while(0);d[B+(G<<1)>>1]=H;P=H&65535;d[i+(P<<1)>>1]=H;N=P+1&65535;break}if(D?b[z+G>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(!(E|K^1)?b[z+I>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G+-2<<1)>>1]|0;N=H;break}d[B+(G<<1)>>1]=H;P=H&65535;d[i+(P<<1)>>1]=H;N=P+1&65535}while(0);G=G+2|0;if((G|0)>=(q|0)){zb=N;break}else H=N}}else zb=t;v=v+2|0;if((v|0)>=(k|0))break;else t=zb}if((zb&65535)>1){t=zb&65535;zb=1;k=1;while(1){v=i+(k<<1)|0;N=j[v>>1]|0;if(N>>>0<k>>>0){d[v>>1]=d[i+(N<<1)>>1]|0;Ab=zb}else{d[v>>1]=zb;Ab=(zb&65535)+1&65535}k=k+1|0;if((k|0)==(t|0)){Bb=Ab;break}else zb=Ab}}else Bb=1}else Bb=1;Xaa(h,Bb&65535);Ab=f[l>>2]|0;zb=f[r>>2]|0;t=(zb&1|0)!=0;k=(Ab|0)>0;b:do if(!(Ab&1)){if(!t){if(!k)break;v=c+16|0;N=c+44|0;q=e+16|0;yb=e+44|0;xb=h+20|0;wb=h+120|0;vb=h+48|0;rb=0;ub=zb;tb=Ab;while(1){sb=f[f[N>>2]>>2]|0;qb=(f[v>>2]|0)+(Y(sb,rb)|0)|0;mb=qb+sb|0;sb=f[f[yb>>2]>>2]|0;pb=(f[q>>2]|0)+(Y(sb,rb)|0)|0;ob=pb+sb|0;if((ub|0)>0){sb=((rb|0)<0)<<31>>31;nb=rb|1;lb=((nb|0)<0)<<31>>31;kb=0;do{jb=pb+(kb<<1)|0;ib=d[jb>>1]|0;do if(ib<<16>>16){hb=d[i+((ib&65535)<<1)>>1]|0;if(!(b[qb+kb>>0]|0)){d[jb>>1]=0;gb=f[xb>>2]|0;fb=f[gb>>2]|0;f[gb>>2]=(fb|0)>(kb|0)?kb:fb;fb=gb+8|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)<(kb|0)?kb:eb;eb=gb+4|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)>(rb|0)?rb:fb;fb=gb+12|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)<(rb|0)?rb:eb;eb=gb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=f[wb>>2]|0;fb=eb;db=UIc(f[fb>>2]|0,f[fb+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;fb=eb;f[fb>>2]=db;f[fb+4>>2]=J;Cb=eb+8|0;Db=gb;Eb=eb}else{d[jb>>1]=hb;eb=hb&65535;gb=f[xb>>2]|0;fb=gb+(Y(f[f[vb>>2]>>2]|0,eb)|0)|0;db=f[fb>>2]|0;f[fb>>2]=(db|0)>(kb|0)?kb:db;db=fb+8|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(kb|0)?kb:cb;cb=fb+4|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)>(rb|0)?rb:db;db=fb+12|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(rb|0)?rb:cb;cb=fb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=f[wb>>2]|0;fb=cb+(eb<<4)|0;db=fb;bb=UIc(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=fb;f[db>>2]=bb;f[db+4>>2]=J;Cb=cb+(eb<<4)+8|0;Db=gb;Eb=cb}cb=Cb;gb=UIc(f[cb>>2]|0,f[cb+4>>2]|0,rb|0,sb|0)|0;cb=Cb;f[cb>>2]=gb;f[cb+4>>2]=J;cb=kb|1;gb=pb+(cb<<1)|0;if(!(b[qb+cb>>0]|0)){d[gb>>1]=0;Fb=0;Gb=Db}else{d[gb>>1]=hb;gb=hb&65535;Fb=gb;Gb=Db+(Y(f[f[vb>>2]>>2]|0,gb)|0)|0}gb=f[Gb>>2]|0;f[Gb>>2]=(gb|0)>(cb|0)?cb:gb;gb=Gb+8|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(cb|0)?cb:eb;eb=Gb+4|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)>(rb|0)?rb:gb;gb=Gb+12|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(rb|0)?rb:eb;eb=Gb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(Fb<<4)|0;gb=eb;db=UIc(f[gb>>2]|0,f[gb+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;gb=eb;f[gb>>2]=db;f[gb+4>>2]=J;gb=Eb+(Fb<<4)+8|0;db=gb;eb=UIc(f[db>>2]|0,f[db+4>>2]|0,rb|0,sb|0)|0;db=gb;f[db>>2]=eb;f[db+4>>2]=J;db=ob+(kb<<1)|0;if(!(b[mb+kb>>0]|0)){d[db>>1]=0;Hb=0;Ib=Db}else{d[db>>1]=hb;db=hb&65535;Hb=db;Ib=Db+(Y(f[f[vb>>2]>>2]|0,db)|0)|0}db=f[Ib>>2]|0;f[Ib>>2]=(db|0)>(kb|0)?kb:db;db=Ib+8|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(kb|0)?kb:eb;eb=Ib+4|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(nb|0)?nb:db;db=Ib+12|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(nb|0)?nb:eb;eb=Ib+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(Hb<<4)|0;db=eb;gb=UIc(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=eb;f[db>>2]=gb;f[db+4>>2]=J;db=Eb+(Hb<<4)+8|0;gb=db;eb=UIc(f[gb>>2]|0,f[gb+4>>2]|0,nb|0,lb|0)|0;gb=db;f[gb>>2]=eb;f[gb+4>>2]=J;gb=ob+(cb<<1)|0;if(!(b[mb+cb>>0]|0)){d[gb>>1]=0;eb=f[Db>>2]|0;f[Db>>2]=(eb|0)>(cb|0)?cb:eb;eb=Db+8|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)<(cb|0)?cb:db;db=Db+4|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)>(nb|0)?nb:eb;eb=Db+12|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)<(nb|0)?nb:db;db=Db+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Eb;eb=UIc(f[db>>2]|0,f[db+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;db=Eb;f[db>>2]=eb;f[db+4>>2]=J;Jb=Eb+8|0;break}else{d[gb>>1]=hb;gb=hb&65535;hb=Db+(Y(f[f[vb>>2]>>2]|0,gb)|0)|0;db=f[hb>>2]|0;f[hb>>2]=(db|0)>(cb|0)?cb:db;db=hb+8|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(cb|0)?cb:eb;eb=hb+4|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(nb|0)?nb:db;db=hb+12|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(nb|0)?nb:eb;eb=hb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(gb<<4)|0;hb=eb;db=UIc(f[hb>>2]|0,f[hb+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;cb=eb;f[cb>>2]=db;f[cb+4>>2]=J;Jb=Eb+(gb<<4)+8|0;break}}else{d[jb>>1]=0;gb=kb|1;d[pb+(gb<<1)>>1]=0;d[ob+(kb<<1)>>1]=0;d[ob+(gb<<1)>>1]=0;cb=f[xb>>2]|0;db=f[cb>>2]|0;eb=(db|0)>(kb|0)?kb:db;db=cb+8|0;hb=f[db>>2]|0;bb=(hb|0)<(kb|0)?kb:hb;hb=cb+4|0;fb=f[hb>>2]|0;ab=(fb|0)>(rb|0)?rb:fb;fb=cb+12|0;$a=f[fb>>2]|0;_a=($a|0)<(rb|0)?rb:$a;$a=cb+16|0;Za=f[$a>>2]|0;Ya=f[wb>>2]|0;Xa=((kb|0)<0)<<31>>31;Wa=Ya;Va=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,Xa|0)|0;Wa=J;Ua=Ya+8|0;Ta=Ua;Sa=UIc(f[Ta>>2]|0,f[Ta+4>>2]|0,rb|0,sb|0)|0;Ta=J;Ra=(eb|0)>(gb|0)?gb:eb;eb=((gb|0)<0)<<31>>31;Qa=UIc(Va|0,Wa|0,gb|0,eb|0)|0;Wa=J;Va=UIc(Sa|0,Ta|0,rb|0,sb|0)|0;Ta=J;Sa=UIc(Qa|0,Wa|0,kb|0,Xa|0)|0;Xa=J;Wa=UIc(Va|0,Ta|0,nb|0,lb|0)|0;Ta=Ua;f[Ta>>2]=Wa;f[Ta+4>>2]=J;f[cb>>2]=(Ra|0)>(kb|0)?kb:Ra;f[db>>2]=(bb|0)<(gb|0)?gb:bb;f[hb>>2]=(ab|0)>(nb|0)?nb:ab;f[fb>>2]=(_a|0)<(nb|0)?nb:_a;f[$a>>2]=Za+4;Za=UIc(Sa|0,Xa|0,gb|0,eb|0)|0;eb=Ya;f[eb>>2]=Za;f[eb+4>>2]=J;Jb=Ua}while(0);jb=Jb;ib=UIc(f[jb>>2]|0,f[jb+4>>2]|0,nb|0,lb|0)|0;jb=Jb;f[jb>>2]=ib;f[jb+4>>2]=J;kb=kb+2|0;Kb=f[r>>2]|0}while((kb|0)<(Kb|0));Lb=f[l>>2]|0;Mb=Kb}else{Lb=tb;Mb=ub}rb=rb+2|0;if((rb|0)>=(Lb|0))break b;else{ub=Mb;tb=Lb}}}if(k){tb=h+20|0;ub=h+120|0;rb=h+48|0;wb=f[c+16>>2]|0;xb=f[c+44>>2]|0;vb=f[e+16>>2]|0;q=f[e+44>>2]|0;yb=0;v=zb;N=Ab;while(1){kb=f[xb>>2]|0;lb=wb+(Y(kb,yb)|0)|0;nb=lb+kb|0;kb=f[q>>2]|0;sb=vb+(Y(kb,yb)|0)|0;ob=sb+kb|0;if((v|0)>0){kb=((yb|0)<0)<<31>>31;pb=yb|1;mb=((pb|0)<0)<<31>>31;qb=0;do{jb=sb+(qb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;d[ob+(qb<<1)>>1]=0;I=f[tb>>2]|0;K=f[I>>2]|0;Ua=(K|0)>(qb|0)?qb:K;K=I+8|0;eb=f[K>>2]|0;Za=(eb|0)<(qb|0)?qb:eb;eb=I+4|0;Ya=f[eb>>2]|0;gb=(Ya|0)>(yb|0)?yb:Ya;Ya=I+12|0;Xa=f[Ya>>2]|0;Sa=(Xa|0)<(yb|0)?yb:Xa;Xa=I+16|0;$a=f[Xa>>2]|0;_a=f[ub>>2]|0;fb=((qb|0)<0)<<31>>31;ab=_a;hb=UIc(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,fb|0)|0;ab=J;bb=_a+8|0;db=bb;Ra=UIc(f[db>>2]|0,f[db+4>>2]|0,yb|0,kb|0)|0;db=J;f[I>>2]=Ua;f[K>>2]=Za;cb=(gb|0)>(pb|0)?pb:gb;f[eb>>2]=cb;gb=(Sa|0)<(pb|0)?pb:Sa;f[Ya>>2]=gb;f[Xa>>2]=$a+2;Sa=UIc(hb|0,ab|0,qb|0,fb|0)|0;fb=J;ab=_a;f[ab>>2]=Sa;f[ab+4>>2]=fb;ab=UIc(Ra|0,db|0,pb|0,mb|0)|0;db=J;Ra=bb;f[Ra>>2]=ab;f[Ra+4>>2]=db;Ra=qb|1;if((Ra|0)<(f[r>>2]|0)){d[sb+(Ra<<1)>>1]=0;d[ob+(Ra<<1)>>1]=0;hb=((Ra|0)<0)<<31>>31;Ta=UIc(Sa|0,fb|0,Ra|0,hb|0)|0;fb=J;Sa=UIc(ab|0,db|0,yb|0,kb|0)|0;db=J;f[I>>2]=(Ua|0)>(Ra|0)?Ra:Ua;f[K>>2]=(Za|0)<(Ra|0)?Ra:Za;f[eb>>2]=(cb|0)>(yb|0)?yb:cb;f[Ya>>2]=gb;f[Xa>>2]=$a+4;$a=UIc(Ta|0,fb|0,Ra|0,hb|0)|0;hb=_a;f[hb>>2]=$a;f[hb+4>>2]=J;hb=UIc(Sa|0,db|0,pb|0,mb|0)|0;db=bb;f[db>>2]=hb;f[db+4>>2]=J}}else{db=d[i+((ib&65535)<<1)>>1]|0;if(!(b[lb+qb>>0]|0)){d[jb>>1]=0;hb=f[tb>>2]|0;bb=f[hb>>2]|0;f[hb>>2]=(bb|0)>(qb|0)?qb:bb;bb=hb+8|0;Sa=f[bb>>2]|0;f[bb>>2]=(Sa|0)<(qb|0)?qb:Sa;Sa=hb+4|0;bb=f[Sa>>2]|0;f[Sa>>2]=(bb|0)>(yb|0)?yb:bb;bb=hb+12|0;Sa=f[bb>>2]|0;f[bb>>2]=(Sa|0)<(yb|0)?yb:Sa;Sa=hb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=f[ub>>2]|0;bb=Sa;$a=UIc(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;bb=Sa;f[bb>>2]=$a;f[bb+4>>2]=J;Nb=Sa+8|0;Ob=hb;Pb=Sa}else{d[jb>>1]=db;Sa=db&65535;hb=f[tb>>2]|0;bb=hb+(Y(f[f[rb>>2]>>2]|0,Sa)|0)|0;$a=f[bb>>2]|0;f[bb>>2]=($a|0)>(qb|0)?qb:$a;$a=bb+8|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)<(qb|0)?qb:_a;_a=bb+4|0;$a=f[_a>>2]|0;f[_a>>2]=($a|0)>(yb|0)?yb:$a;$a=bb+12|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)<(yb|0)?yb:_a;_a=bb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=f[ub>>2]|0;bb=_a+(Sa<<4)|0;$a=bb;Ra=UIc(f[$a>>2]|0,f[$a+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;$a=bb;f[$a>>2]=Ra;f[$a+4>>2]=J;Nb=_a+(Sa<<4)+8|0;Ob=hb;Pb=_a}_a=Nb;hb=UIc(f[_a>>2]|0,f[_a+4>>2]|0,yb|0,kb|0)|0;_a=Nb;f[_a>>2]=hb;f[_a+4>>2]=J;_a=ob+(qb<<1)|0;if(!(b[nb+qb>>0]|0)){d[_a>>1]=0;Qb=0;Rb=Ob}else{d[_a>>1]=db;_a=db&65535;Qb=_a;Rb=Ob+(Y(f[f[rb>>2]>>2]|0,_a)|0)|0}_a=f[Rb>>2]|0;f[Rb>>2]=(_a|0)>(qb|0)?qb:_a;_a=Rb+8|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(qb|0)?qb:hb;hb=Rb+4|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)>(pb|0)?pb:_a;_a=Rb+12|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(pb|0)?pb:hb;hb=Rb+16|0;f[hb>>2]=(f[hb>>2]|0)+1;hb=Pb+(Qb<<4)|0;_a=hb;Sa=UIc(f[_a>>2]|0,f[_a+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;_a=hb;f[_a>>2]=Sa;f[_a+4>>2]=J;_a=Pb+(Qb<<4)+8|0;Sa=_a;hb=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,pb|0,mb|0)|0;Sa=_a;f[Sa>>2]=hb;f[Sa+4>>2]=J;Sa=qb|1;if((Sa|0)<(f[r>>2]|0)){hb=sb+(Sa<<1)|0;if(!(b[lb+Sa>>0]|0)){d[hb>>1]=0;Sb=0;Tb=Ob}else{d[hb>>1]=db;hb=db&65535;Sb=hb;Tb=Ob+(Y(f[f[rb>>2]>>2]|0,hb)|0)|0}hb=f[Tb>>2]|0;f[Tb>>2]=(hb|0)>(Sa|0)?Sa:hb;hb=Tb+8|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)<(Sa|0)?Sa:_a;_a=Tb+4|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)>(yb|0)?yb:hb;hb=Tb+12|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)<(yb|0)?yb:_a;_a=Tb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=Pb+(Sb<<4)|0;hb=_a;$a=UIc(f[hb>>2]|0,f[hb+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;hb=_a;f[hb>>2]=$a;f[hb+4>>2]=J;hb=Pb+(Sb<<4)+8|0;$a=hb;_a=UIc(f[$a>>2]|0,f[$a+4>>2]|0,yb|0,kb|0)|0;$a=hb;f[$a>>2]=_a;f[$a+4>>2]=J;$a=ob+(Sa<<1)|0;if(!(b[nb+Sa>>0]|0)){d[$a>>1]=0;_a=f[Ob>>2]|0;f[Ob>>2]=(_a|0)>(Sa|0)?Sa:_a;_a=Ob+8|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(Sa|0)?Sa:hb;hb=Ob+4|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)>(pb|0)?pb:_a;_a=Ob+12|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(pb|0)?pb:hb;hb=Ob+16|0;f[hb>>2]=(f[hb>>2]|0)+1;hb=Pb;_a=UIc(f[hb>>2]|0,f[hb+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;hb=Pb;f[hb>>2]=_a;f[hb+4>>2]=J;hb=Pb+8|0;_a=hb;Ra=UIc(f[_a>>2]|0,f[_a+4>>2]|0,pb|0,mb|0)|0;_a=hb;f[_a>>2]=Ra;f[_a+4>>2]=J;break}else{d[$a>>1]=db;$a=db&65535;db=Ob+(Y(f[f[rb>>2]>>2]|0,$a)|0)|0;_a=f[db>>2]|0;f[db>>2]=(_a|0)>(Sa|0)?Sa:_a;_a=db+8|0;Ra=f[_a>>2]|0;f[_a>>2]=(Ra|0)<(Sa|0)?Sa:Ra;Ra=db+4|0;_a=f[Ra>>2]|0;f[Ra>>2]=(_a|0)>(pb|0)?pb:_a;_a=db+12|0;Ra=f[_a>>2]|0;f[_a>>2]=(Ra|0)<(pb|0)?pb:Ra;Ra=db+16|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Ra=Pb+($a<<4)|0;db=Ra;_a=UIc(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;Sa=Ra;f[Sa>>2]=_a;f[Sa+4>>2]=J;Sa=Pb+($a<<4)+8|0;$a=Sa;_a=UIc(f[$a>>2]|0,f[$a+4>>2]|0,pb|0,mb|0)|0;$a=Sa;f[$a>>2]=_a;f[$a+4>>2]=J;break}}}while(0);qb=qb+2|0;Ub=f[r>>2]|0}while((qb|0)<(Ub|0));Vb=f[l>>2]|0;Wb=Ub}else{Vb=N;Wb=v}yb=yb+2|0;if((yb|0)>=(Vb|0))break;else{v=Wb;N=Vb}}}}else{if(!t){if(!k)break;N=h+20|0;v=h+120|0;yb=h+48|0;rb=f[c+16>>2]|0;ub=f[c+44>>2]|0;tb=f[e+16>>2]|0;vb=f[e+44>>2]|0;q=0;wb=zb;xb=Ab;while(1){qb=f[ub>>2]|0;mb=rb+(Y(qb,q)|0)|0;pb=mb+qb|0;qb=f[vb>>2]|0;nb=tb+(Y(qb,q)|0)|0;ob=nb+qb|0;if((wb|0)>0){qb=((q|0)<0)<<31>>31;kb=q|1;lb=((kb|0)<0)<<31>>31;sb=0;do{jb=nb+(sb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;$a=sb|1;d[nb+($a<<1)>>1]=0;_a=f[N>>2]|0;Sa=f[_a>>2]|0;Ra=(Sa|0)>(sb|0)?sb:Sa;Sa=_a+8|0;db=f[Sa>>2]|0;hb=(db|0)<(sb|0)?sb:db;db=_a+4|0;bb=f[db>>2]|0;fb=(bb|0)>(q|0)?q:bb;bb=_a+12|0;Ta=f[bb>>2]|0;Xa=(Ta|0)<(q|0)?q:Ta;Ta=_a+16|0;gb=f[Ta>>2]|0;Ya=f[v>>2]|0;cb=((sb|0)<0)<<31>>31;eb=Ya;Za=UIc(f[eb>>2]|0,f[eb+4>>2]|0,sb|0,cb|0)|0;eb=J;K=Ya+8|0;Ua=K;I=UIc(f[Ua>>2]|0,f[Ua+4>>2]|0,q|0,qb|0)|0;Ua=J;ab=(Ra|0)>($a|0)?$a:Ra;f[_a>>2]=ab;Ra=(hb|0)<($a|0)?$a:hb;f[Sa>>2]=Ra;f[db>>2]=fb;f[bb>>2]=Xa;f[Ta>>2]=gb+2;hb=(($a|0)<0)<<31>>31;Wa=UIc(Za|0,eb|0,$a|0,hb|0)|0;eb=J;Za=Ya;f[Za>>2]=Wa;f[Za+4>>2]=eb;Za=UIc(I|0,Ua|0,q|0,qb|0)|0;Ua=J;I=K;f[I>>2]=Za;f[I+4>>2]=Ua;if((kb|0)<(f[l>>2]|0)){d[ob+(sb<<1)>>1]=0;d[ob+($a<<1)>>1]=0;I=UIc(Wa|0,eb|0,sb|0,cb|0)|0;cb=J;eb=UIc(Za|0,Ua|0,kb|0,lb|0)|0;Ua=J;f[_a>>2]=(ab|0)>(sb|0)?sb:ab;f[Sa>>2]=Ra;f[db>>2]=(fb|0)>(kb|0)?kb:fb;f[bb>>2]=(Xa|0)<(kb|0)?kb:Xa;f[Ta>>2]=gb+4;gb=UIc(I|0,cb|0,$a|0,hb|0)|0;hb=Ya;f[hb>>2]=gb;f[hb+4>>2]=J;hb=UIc(eb|0,Ua|0,kb|0,lb|0)|0;Ua=K;f[Ua>>2]=hb;f[Ua+4>>2]=J}}else{Ua=d[i+((ib&65535)<<1)>>1]|0;if(!(b[mb+sb>>0]|0)){d[jb>>1]=0;hb=f[N>>2]|0;K=f[hb>>2]|0;f[hb>>2]=(K|0)>(sb|0)?sb:K;K=hb+8|0;eb=f[K>>2]|0;f[K>>2]=(eb|0)<(sb|0)?sb:eb;eb=hb+4|0;K=f[eb>>2]|0;f[eb>>2]=(K|0)>(q|0)?q:K;K=hb+12|0;eb=f[K>>2]|0;f[K>>2]=(eb|0)<(q|0)?q:eb;eb=hb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=f[v>>2]|0;K=eb;gb=UIc(f[K>>2]|0,f[K+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;K=eb;f[K>>2]=gb;f[K+4>>2]=J;Xb=eb+8|0;Yb=hb;Zb=eb}else{d[jb>>1]=Ua;eb=Ua&65535;hb=f[N>>2]|0;K=hb+(Y(f[f[yb>>2]>>2]|0,eb)|0)|0;gb=f[K>>2]|0;f[K>>2]=(gb|0)>(sb|0)?sb:gb;gb=K+8|0;Ya=f[gb>>2]|0;f[gb>>2]=(Ya|0)<(sb|0)?sb:Ya;Ya=K+4|0;gb=f[Ya>>2]|0;f[Ya>>2]=(gb|0)>(q|0)?q:gb;gb=K+12|0;Ya=f[gb>>2]|0;f[gb>>2]=(Ya|0)<(q|0)?q:Ya;Ya=K+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[v>>2]|0;K=Ya+(eb<<4)|0;gb=K;$a=UIc(f[gb>>2]|0,f[gb+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;gb=K;f[gb>>2]=$a;f[gb+4>>2]=J;Xb=Ya+(eb<<4)+8|0;Yb=hb;Zb=Ya}Ya=Xb;hb=UIc(f[Ya>>2]|0,f[Ya+4>>2]|0,q|0,qb|0)|0;Ya=Xb;f[Ya>>2]=hb;f[Ya+4>>2]=J;Ya=sb|1;hb=nb+(Ya<<1)|0;if(!(b[mb+Ya>>0]|0)){d[hb>>1]=0;_b=0;$b=Yb}else{d[hb>>1]=Ua;hb=Ua&65535;_b=hb;$b=Yb+(Y(f[f[yb>>2]>>2]|0,hb)|0)|0}hb=f[$b>>2]|0;f[$b>>2]=(hb|0)>(Ya|0)?Ya:hb;hb=$b+8|0;eb=f[hb>>2]|0;f[hb>>2]=(eb|0)<(Ya|0)?Ya:eb;eb=$b+4|0;hb=f[eb>>2]|0;f[eb>>2]=(hb|0)>(q|0)?q:hb;hb=$b+12|0;eb=f[hb>>2]|0;f[hb>>2]=(eb|0)<(q|0)?q:eb;eb=$b+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Zb+(_b<<4)|0;hb=eb;gb=UIc(f[hb>>2]|0,f[hb+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;hb=eb;f[hb>>2]=gb;f[hb+4>>2]=J;hb=Zb+(_b<<4)+8|0;gb=hb;eb=UIc(f[gb>>2]|0,f[gb+4>>2]|0,q|0,qb|0)|0;gb=hb;f[gb>>2]=eb;f[gb+4>>2]=J;if((kb|0)<(f[l>>2]|0)){gb=ob+(sb<<1)|0;if(!(b[pb+sb>>0]|0)){d[gb>>1]=0;ac=0;bc=Yb}else{d[gb>>1]=Ua;gb=Ua&65535;ac=gb;bc=Yb+(Y(f[f[yb>>2]>>2]|0,gb)|0)|0}gb=f[bc>>2]|0;f[bc>>2]=(gb|0)>(sb|0)?sb:gb;gb=bc+8|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(sb|0)?sb:eb;eb=bc+4|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)>(kb|0)?kb:gb;gb=bc+12|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(kb|0)?kb:eb;eb=bc+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Zb+(ac<<4)|0;gb=eb;hb=UIc(f[gb>>2]|0,f[gb+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;gb=eb;f[gb>>2]=hb;f[gb+4>>2]=J;gb=Zb+(ac<<4)+8|0;hb=gb;eb=UIc(f[hb>>2]|0,f[hb+4>>2]|0,kb|0,lb|0)|0;hb=gb;f[hb>>2]=eb;f[hb+4>>2]=J;hb=ob+(Ya<<1)|0;if(!(b[pb+Ya>>0]|0)){d[hb>>1]=0;eb=f[Yb>>2]|0;f[Yb>>2]=(eb|0)>(Ya|0)?Ya:eb;eb=Yb+8|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)<(Ya|0)?Ya:gb;gb=Yb+4|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)>(kb|0)?kb:eb;eb=Yb+12|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)<(kb|0)?kb:gb;gb=Yb+16|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=Zb;eb=UIc(f[gb>>2]|0,f[gb+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;gb=Zb;f[gb>>2]=eb;f[gb+4>>2]=J;gb=Zb+8|0;eb=gb;$a=UIc(f[eb>>2]|0,f[eb+4>>2]|0,kb|0,lb|0)|0;eb=gb;f[eb>>2]=$a;f[eb+4>>2]=J;break}else{d[hb>>1]=Ua;hb=Ua&65535;Ua=Yb+(Y(f[f[yb>>2]>>2]|0,hb)|0)|0;eb=f[Ua>>2]|0;f[Ua>>2]=(eb|0)>(Ya|0)?Ya:eb;eb=Ua+8|0;$a=f[eb>>2]|0;f[eb>>2]=($a|0)<(Ya|0)?Ya:$a;$a=Ua+4|0;eb=f[$a>>2]|0;f[$a>>2]=(eb|0)>(kb|0)?kb:eb;eb=Ua+12|0;$a=f[eb>>2]|0;f[eb>>2]=($a|0)<(kb|0)?kb:$a;$a=Ua+16|0;f[$a>>2]=(f[$a>>2]|0)+1;$a=Zb+(hb<<4)|0;Ua=$a;eb=UIc(f[Ua>>2]|0,f[Ua+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;Ya=$a;f[Ya>>2]=eb;f[Ya+4>>2]=J;Ya=Zb+(hb<<4)+8|0;hb=Ya;eb=UIc(f[hb>>2]|0,f[hb+4>>2]|0,kb|0,lb|0)|0;hb=Ya;f[hb>>2]=eb;f[hb+4>>2]=J;break}}}while(0);sb=sb+2|0;cc=f[r>>2]|0}while((sb|0)<(cc|0));dc=f[l>>2]|0;ec=cc}else{dc=xb;ec=wb}q=q+2|0;if((q|0)>=(dc|0))break b;else{wb=ec;xb=dc}}}if(k){xb=h+20|0;wb=h+120|0;q=h+48|0;yb=f[c+16>>2]|0;v=f[c+44>>2]|0;N=f[e+16>>2]|0;tb=f[e+44>>2]|0;vb=0;rb=zb;ub=Ab;while(1){sb=f[v>>2]|0;lb=yb+(Y(sb,vb)|0)|0;kb=lb+sb|0;sb=f[tb>>2]|0;pb=N+(Y(sb,vb)|0)|0;ob=pb+sb|0;if((rb|0)>0){sb=((vb|0)<0)<<31>>31;qb=vb|1;mb=((qb|0)<0)<<31>>31;nb=0;do{jb=pb+(nb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;hb=f[xb>>2]|0;eb=f[hb>>2]|0;Ya=(eb|0)>(nb|0)?nb:eb;f[hb>>2]=Ya;eb=hb+8|0;$a=f[eb>>2]|0;Ua=($a|0)<(nb|0)?nb:$a;f[eb>>2]=Ua;$a=hb+4|0;gb=f[$a>>2]|0;K=(gb|0)>(vb|0)?vb:gb;f[$a>>2]=K;gb=hb+12|0;cb=f[gb>>2]|0;I=(cb|0)<(vb|0)?vb:cb;f[gb>>2]=I;cb=hb+16|0;Ta=f[cb>>2]|0;f[cb>>2]=Ta+1;Xa=f[wb>>2]|0;bb=((nb|0)<0)<<31>>31;fb=Xa;db=UIc(f[fb>>2]|0,f[fb+4>>2]|0,nb|0,bb|0)|0;fb=J;Ra=Xa;f[Ra>>2]=db;f[Ra+4>>2]=fb;Ra=Xa+8|0;Sa=Ra;ab=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,vb|0,sb|0)|0;Sa=J;_a=Ra;f[_a>>2]=ab;f[_a+4>>2]=Sa;_a=nb|1;if((_a|0)<(f[r>>2]|0)){d[pb+(_a<<1)>>1]=0;Za=(Ya|0)>(_a|0)?_a:Ya;f[hb>>2]=Za;Wa=(Ua|0)<(_a|0)?_a:Ua;f[eb>>2]=Wa;f[$a>>2]=K;f[gb>>2]=I;f[cb>>2]=Ta+2;Va=((_a|0)<0)<<31>>31;Qa=UIc(db|0,fb|0,_a|0,Va|0)|0;Pa=J;Oa=Xa;f[Oa>>2]=Qa;f[Oa+4>>2]=Pa;Oa=UIc(ab|0,Sa|0,vb|0,sb|0)|0;Na=J;Ma=Ra;f[Ma>>2]=Oa;f[Ma+4>>2]=Na;if((qb|0)>=(f[l>>2]|0))break;d[ob+(nb<<1)>>1]=0;d[ob+(_a<<1)>>1]=0;Ma=UIc(Qa|0,Pa|0,nb|0,bb|0)|0;Pa=J;Qa=UIc(Oa|0,Na|0,qb|0,mb|0)|0;Na=J;f[hb>>2]=(Za|0)>(nb|0)?nb:Za;f[eb>>2]=Wa;f[$a>>2]=(K|0)>(qb|0)?qb:K;f[gb>>2]=(I|0)<(qb|0)?qb:I;f[cb>>2]=Ta+4;Wa=UIc(Ma|0,Pa|0,_a|0,Va|0)|0;Va=Xa;f[Va>>2]=Wa;f[Va+4>>2]=J;Va=UIc(Qa|0,Na|0,qb|0,mb|0)|0;Na=Ra;f[Na>>2]=Va;f[Na+4>>2]=J;break}else{if((qb|0)>=(f[l>>2]|0))break;d[ob+(nb<<1)>>1]=0;f[hb>>2]=Ya;f[eb>>2]=Ua;f[$a>>2]=(K|0)>(qb|0)?qb:K;f[gb>>2]=(I|0)<(qb|0)?qb:I;f[cb>>2]=Ta+2;Ta=UIc(db|0,fb|0,nb|0,bb|0)|0;bb=Xa;f[bb>>2]=Ta;f[bb+4>>2]=J;bb=UIc(ab|0,Sa|0,qb|0,mb|0)|0;Sa=Ra;f[Sa>>2]=bb;f[Sa+4>>2]=J;break}}else{Sa=d[i+((ib&65535)<<1)>>1]|0;if(!(b[lb+nb>>0]|0)){d[jb>>1]=0;bb=f[xb>>2]|0;Ra=f[bb>>2]|0;f[bb>>2]=(Ra|0)>(nb|0)?nb:Ra;Ra=bb+8|0;ab=f[Ra>>2]|0;f[Ra>>2]=(ab|0)<(nb|0)?nb:ab;ab=bb+4|0;Ra=f[ab>>2]|0;f[ab>>2]=(Ra|0)>(vb|0)?vb:Ra;Ra=bb+12|0;ab=f[Ra>>2]|0;f[Ra>>2]=(ab|0)<(vb|0)?vb:ab;ab=bb+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=f[wb>>2]|0;Ra=ab;Ta=UIc(f[Ra>>2]|0,f[Ra+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ra=ab;f[Ra>>2]=Ta;f[Ra+4>>2]=J;fc=ab+8|0;gc=bb;hc=ab}else{d[jb>>1]=Sa;ab=Sa&65535;bb=f[xb>>2]|0;Ra=bb+(Y(f[f[q>>2]>>2]|0,ab)|0)|0;Ta=f[Ra>>2]|0;f[Ra>>2]=(Ta|0)>(nb|0)?nb:Ta;Ta=Ra+8|0;Xa=f[Ta>>2]|0;f[Ta>>2]=(Xa|0)<(nb|0)?nb:Xa;Xa=Ra+4|0;Ta=f[Xa>>2]|0;f[Xa>>2]=(Ta|0)>(vb|0)?vb:Ta;Ta=Ra+12|0;Xa=f[Ta>>2]|0;f[Ta>>2]=(Xa|0)<(vb|0)?vb:Xa;Xa=Ra+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[wb>>2]|0;Ra=Xa+(ab<<4)|0;Ta=Ra;fb=UIc(f[Ta>>2]|0,f[Ta+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ta=Ra;f[Ta>>2]=fb;f[Ta+4>>2]=J;fc=Xa+(ab<<4)+8|0;gc=bb;hc=Xa}Xa=fc;bb=UIc(f[Xa>>2]|0,f[Xa+4>>2]|0,vb|0,sb|0)|0;Xa=fc;f[Xa>>2]=bb;f[Xa+4>>2]=J;Xa=nb|1;if((Xa|0)>=(f[r>>2]|0)){if((qb|0)>=(f[l>>2]|0))break;bb=ob+(nb<<1)|0;if(!(b[kb+nb>>0]|0)){d[bb>>1]=0;ab=f[gc>>2]|0;f[gc>>2]=(ab|0)>(nb|0)?nb:ab;ab=gc+8|0;Ta=f[ab>>2]|0;f[ab>>2]=(Ta|0)<(nb|0)?nb:Ta;Ta=gc+4|0;ab=f[Ta>>2]|0;f[Ta>>2]=(ab|0)>(qb|0)?qb:ab;ab=gc+12|0;Ta=f[ab>>2]|0;f[ab>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=gc+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc;ab=UIc(f[Ta>>2]|0,f[Ta+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ta=hc;f[Ta>>2]=ab;f[Ta+4>>2]=J;Ta=hc+8|0;ab=Ta;fb=UIc(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,mb|0)|0;ab=Ta;f[ab>>2]=fb;f[ab+4>>2]=J;break}else{d[bb>>1]=Sa;bb=Sa&65535;ab=gc+(Y(f[f[q>>2]>>2]|0,bb)|0)|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)>(nb|0)?nb:fb;fb=ab+8|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(nb|0)?nb:Ta;Ta=ab+4|0;fb=f[Ta>>2]|0;f[Ta>>2]=(fb|0)>(qb|0)?qb:fb;fb=ab+12|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=ab+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc+(bb<<4)|0;ab=Ta;fb=UIc(f[ab>>2]|0,f[ab+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;ab=Ta;f[ab>>2]=fb;f[ab+4>>2]=J;ab=hc+(bb<<4)+8|0;bb=ab;fb=UIc(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=ab;f[bb>>2]=fb;f[bb+4>>2]=J;break}}bb=pb+(Xa<<1)|0;if(!(b[lb+Xa>>0]|0)){d[bb>>1]=0;ic=0;jc=gc}else{d[bb>>1]=Sa;bb=Sa&65535;ic=bb;jc=gc+(Y(f[f[q>>2]>>2]|0,bb)|0)|0}bb=f[jc>>2]|0;f[jc>>2]=(bb|0)>(Xa|0)?Xa:bb;bb=jc+8|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)<(Xa|0)?Xa:fb;fb=jc+4|0;bb=f[fb>>2]|0;f[fb>>2]=(bb|0)>(vb|0)?vb:bb;bb=jc+12|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)<(vb|0)?vb:fb;fb=jc+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=hc+(ic<<4)|0;bb=fb;ab=UIc(f[bb>>2]|0,f[bb+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;bb=fb;f[bb>>2]=ab;f[bb+4>>2]=J;bb=hc+(ic<<4)+8|0;ab=bb;fb=UIc(f[ab>>2]|0,f[ab+4>>2]|0,vb|0,sb|0)|0;ab=bb;f[ab>>2]=fb;f[ab+4>>2]=J;if((qb|0)<(f[l>>2]|0)){ab=ob+(nb<<1)|0;if(!(b[kb+nb>>0]|0)){d[ab>>1]=0;kc=0;lc=gc}else{d[ab>>1]=Sa;ab=Sa&65535;kc=ab;lc=gc+(Y(f[f[q>>2]>>2]|0,ab)|0)|0}ab=f[lc>>2]|0;f[lc>>2]=(ab|0)>(nb|0)?nb:ab;ab=lc+8|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)<(nb|0)?nb:fb;fb=lc+4|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)>(qb|0)?qb:ab;ab=lc+12|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)<(qb|0)?qb:fb;fb=lc+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=hc+(kc<<4)|0;ab=fb;bb=UIc(f[ab>>2]|0,f[ab+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;ab=fb;f[ab>>2]=bb;f[ab+4>>2]=J;ab=hc+(kc<<4)+8|0;bb=ab;fb=UIc(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=ab;f[bb>>2]=fb;f[bb+4>>2]=J;bb=ob+(Xa<<1)|0;if(!(b[kb+Xa>>0]|0)){d[bb>>1]=0;fb=f[gc>>2]|0;f[gc>>2]=(fb|0)>(Xa|0)?Xa:fb;fb=gc+8|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)<(Xa|0)?Xa:ab;ab=gc+4|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)>(qb|0)?qb:fb;fb=gc+12|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)<(qb|0)?qb:ab;ab=gc+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=hc;fb=UIc(f[ab>>2]|0,f[ab+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;ab=hc;f[ab>>2]=fb;f[ab+4>>2]=J;ab=hc+8|0;fb=ab;Ta=UIc(f[fb>>2]|0,f[fb+4>>2]|0,qb|0,mb|0)|0;fb=ab;f[fb>>2]=Ta;f[fb+4>>2]=J;break}else{d[bb>>1]=Sa;bb=Sa&65535;Sa=gc+(Y(f[f[q>>2]>>2]|0,bb)|0)|0;fb=f[Sa>>2]|0;f[Sa>>2]=(fb|0)>(Xa|0)?Xa:fb;fb=Sa+8|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(Xa|0)?Xa:Ta;Ta=Sa+4|0;fb=f[Ta>>2]|0;f[Ta>>2]=(fb|0)>(qb|0)?qb:fb;fb=Sa+12|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=Sa+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc+(bb<<4)|0;Sa=Ta;fb=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;Xa=Ta;f[Xa>>2]=fb;f[Xa+4>>2]=J;Xa=hc+(bb<<4)+8|0;bb=Xa;fb=UIc(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=Xa;f[bb>>2]=fb;f[bb+4>>2]=J;break}}}while(0);nb=nb+2|0;mc=f[r>>2]|0}while((nb|0)<(mc|0));nc=f[l>>2]|0;oc=mc}else{nc=ub;oc=rb}vb=vb+2|0;if((vb|0)>=(nc|0))break;else{rb=oc;ub=nc}}}}while(0);nc=h+12|0;if((f[nc>>2]|0)<=0){g0(i);u=a;return Bb|0}oc=f[h+20>>2]|0;mc=f[h+48>>2]|0;l=f[h+120>>2]|0;r=f[h+80>>2]|0;hc=f[h+108>>2]|0;h=0;do{gc=oc+(Y(f[mc>>2]|0,h)|0)|0;kc=gc+8|0;f[kc>>2]=(f[kc>>2]|0)+1-(f[gc>>2]|0);kc=gc+12|0;f[kc>>2]=(f[kc>>2]|0)+1-(f[gc+4>>2]|0);kc=r+(Y(f[hc>>2]|0,h)|0)|0;pc=+((f[gc+16>>2]|0)>>>0);gc=l+(h<<4)|0;p[kc>>3]=(+((f[gc>>2]|0)>>>0)+4294967296.0*+((f[gc+4>>2]|0)>>>0))/pc;gc=l+(h<<4)+8|0;p[kc+8>>3]=(+((f[gc>>2]|0)>>>0)+4294967296.0*+((f[gc+4>>2]|0)>>>0))/pc;h=h+1|0}while((h|0)<(f[nc>>2]|0));g0(i);u=a;return Bb|0}function Uaa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0.0;a=u;u=u+16|0;h=a;i=f[c+8>>2]|0;j=d+8|0;if((i|0)!=(f[j>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,26)|0;l=250083;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));taa(-215,h,518189,2589)}n=f[c+12>>2]|0;o=d+12|0;if((n|0)!=(f[o>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,26)|0;l=250110;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));taa(-215,h,518189,2590)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;k=tT(h,17)|0;l=250137;m=k+17|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));taa(-215,h,518189,2591)}h=f0((Y(((i+1|0)/2|0)<<2,(n+1|0)/2|0)|0)+4|0)|0;f[h>>2]=0;if((i|0)>0){l=c+16|0;k=c+44|0;m=d+16|0;e=d+44|0;q=(n|0)>0;r=1;s=0;while(1){t=f[f[k>>2]>>2]|0;v=(f[l>>2]|0)+(Y(t,s)|0)|0;w=0-t|0;x=v+w|0;y=x+w|0;w=v+t|0;t=f[f[e>>2]>>2]|0;z=(f[m>>2]|0)+(Y(t,s)|0)|0;A=0-t|0;t=z+A+A|0;if(q){A=(s|1|0)<(i|0);B=(s|0)>0;C=B^1;D=(s+-2|0)>-1;E=0;F=r;while(1){a:do if(!(b[v+E>>0]|0)){G=E|1;H=(G|0)<(n|0);if(A?b[w+E>>0]|0:0){I=E+-1|0;K=(E|0)>0;if(H?b[v+G>>0]|0:0){do if(K){if(b[v+I>>0]|0){do if(B){if(b[x+G>>0]|0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;M=E+-2|0;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}do if((M|0)>-1){if(!(b[x+M>>0]|0))break;if(b[y+I>>0]|0){f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}N=f[t+(E<<2)>>2]|0;O=f[z+(M<<2)>>2]|0;P=N;while(1){Q=f[h+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}if((N|0)==(O|0))R=P;else{Q=O;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}S=(P|0)>(Q|0)?Q:P;T=O;do{U=h+(T<<2)|0;V=T;T=f[U>>2]|0;f[U>>2]=S}while((T|0)<(V|0));R=S}S=N;do{T=h+(S<<2)|0;O=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(O|0));f[z+(E<<2)>>2]=R;L=F;break a}while(0);S=f[t+(E<<2)>>2]|0;N=f[z+(M<<2)>>2]|0;O=S;while(1){T=f[h+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((S|0)==(N|0))W=O;else{M=N;while(1){T=f[h+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}T=(O|0)>(M|0)?M:O;P=N;do{Q=h+(P<<2)|0;V=P;P=f[Q>>2]|0;f[Q>>2]=T}while((P|0)<(V|0));W=T}T=S;do{P=h+(T<<2)|0;N=T;T=f[P>>2]|0;f[P>>2]=W}while((T|0)<(N|0));f[z+(E<<2)>>2]=W;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;S=f[z+(E+-2<<2)>>2]|0;N=T;while(1){P=f[h+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((T|0)==(S|0))X=N;else{P=S;while(1){O=f[h+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(N|0)>(P|0)?P:N;M=S;do{V=h+(M<<2)|0;Q=M;M=f[V>>2]|0;f[V>>2]=O}while((M|0)<(Q|0));X=O}O=T;do{M=h+(O<<2)|0;S=O;O=f[M>>2]|0;f[M>>2]=X}while((O|0)<(S|0));f[z+(E<<2)>>2]=X;L=F;break a}O=E+2|0;if((O|0)>=(n|0))break;if(!(b[x+O>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[y+E>>0]|0)){T=f[t+(O<<2)>>2]|0;S=f[z+(E+-2<<2)>>2]|0;M=T;while(1){N=f[h+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((T|0)==(S|0))Z=M;else{N=S;while(1){P=f[h+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;Q=S;do{V=h+(Q<<2)|0;U=Q;Q=f[V>>2]|0;f[V>>2]=P}while((Q|0)<(U|0));Z=P}P=T;do{Q=h+(P<<2)|0;S=P;P=f[Q>>2]|0;f[Q>>2]=Z}while((P|0)<(S|0));f[z+(E<<2)>>2]=Z;L=F;break a}P=E+-2|0;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[y+I>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}T=f[t+(O<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;Q=T;while(1){M=f[h+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}if((T|0)==(S|0))_=Q;else{M=S;while(1){N=f[h+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(Q|0)>(M|0)?M:Q;U=S;do{V=h+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<($|0));_=N}N=T;do{U=h+(N<<2)|0;S=N;N=f[U>>2]|0;f[U>>2]=_}while((N|0)<(S|0));f[z+(E<<2)>>2]=_;L=F;break a}while(0);N=f[t+(O<<2)>>2]|0;T=f[z+(P<<2)>>2]|0;S=N;while(1){U=f[h+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((N|0)==(T|0))aa=S;else{P=T;while(1){U=f[h+(P<<2)>>2]|0;if((U|0)<(P|0))P=U;else break}U=(S|0)>(P|0)?P:S;Q=T;do{M=h+(Q<<2)|0;$=Q;Q=f[M>>2]|0;f[M>>2]=U}while((Q|0)<($|0));aa=U}U=N;do{Q=h+(U<<2)|0;T=U;U=f[Q>>2]|0;f[Q>>2]=aa}while((U|0)<(T|0));f[z+(E<<2)>>2]=aa;L=F;break a}while(0);U=f[t+(O<<2)>>2]|0;N=f[z+(E+-2<<2)>>2]|0;T=U;while(1){Q=f[h+(T<<2)>>2]|0;if((Q|0)<(T|0))T=Q;else break}if((U|0)==(N|0))ba=T;else{O=N;while(1){Q=f[h+(O<<2)>>2]|0;if((Q|0)<(O|0))O=Q;else break}Q=(T|0)>(O|0)?O:T;S=N;do{P=h+(S<<2)|0;$=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<($|0));ba=Q}Q=U;do{S=h+(Q<<2)|0;N=Q;Q=f[S>>2]|0;f[S>>2]=ba}while((Q|0)<(N|0));f[z+(E<<2)>>2]=ba;L=F;break a}while(0);f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[w+I>>0]|0))break;do if(B){if(b[x+G>>0]|0){Q=E+-2|0;do if((Q|0)>-1){if(!(b[v+Q>>0]|0))break;if(b[x+I>>0]|0){U=f[z+(Q<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=U;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;S=N;while(1){T=f[h+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((N|0)==(U|0))ca=S;else{T=U;while(1){O=f[h+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(S|0)>(T|0)?T:S;$=U;do{P=h+($<<2)|0;M=$;$=f[P>>2]|0;f[P>>2]=O}while(($|0)<(M|0));ca=O}O=N;do{$=h+(O<<2)|0;U=O;O=f[$>>2]|0;f[$>>2]=ca}while((O|0)<(U|0));f[z+(E<<2)>>2]=ca;L=F;break a}if(!(b[x+Q>>0]|0)){O=f[t+(E<<2)>>2]|0;N=f[z+(Q<<2)>>2]|0;U=O;while(1){$=f[h+(U<<2)>>2]|0;if(($|0)<(U|0))U=$;else break}if((O|0)==(N|0))da=U;else{$=N;while(1){S=f[h+($<<2)>>2]|0;if((S|0)<($|0))$=S;else break}S=(U|0)>($|0)?$:U;T=N;do{M=h+(T<<2)|0;P=T;T=f[M>>2]|0;f[M>>2]=S}while((T|0)<(P|0));da=S}S=O;do{T=h+(S<<2)|0;N=S;S=f[T>>2]|0;f[T>>2]=da}while((S|0)<(N|0));f[z+(E<<2)>>2]=da;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;S=f[z+(Q<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=S;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=S;L=F;break a}O=f[t+(E<<2)>>2]|0;N=O;while(1){T=f[h+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((O|0)==(S|0))ea=N;else{T=S;while(1){U=f[h+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}U=(N|0)>(T|0)?T:N;$=S;do{P=h+($<<2)|0;M=$;$=f[P>>2]|0;f[P>>2]=U}while(($|0)<(M|0));ea=U}U=O;do{$=h+(U<<2)|0;S=U;U=f[$>>2]|0;f[$>>2]=ea}while((U|0)<(S|0));f[z+(E<<2)>>2]=ea;L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;S=U;while(1){$=f[h+(S<<2)>>2]|0;if(($|0)<(S|0))S=$;else break}if((U|0)==(O|0))fa=S;else{$=O;while(1){N=f[h+($<<2)>>2]|0;if((N|0)<($|0))$=N;else break}N=(S|0)>($|0)?$:S;T=O;do{M=h+(T<<2)|0;P=T;T=f[M>>2]|0;f[M>>2]=N}while((T|0)<(P|0));fa=N}N=U;do{T=h+(N<<2)|0;O=N;N=f[T>>2]|0;f[T>>2]=fa}while((N|0)<(O|0));f[z+(E<<2)>>2]=fa;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;U=f[z+(Q<<2)>>2]|0;O=N;while(1){T=f[h+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((N|0)==(U|0))ga=O;else{Q=U;while(1){T=f[h+(Q<<2)>>2]|0;if((T|0)<(Q|0))Q=T;else break}T=(O|0)>(Q|0)?Q:O;S=U;do{$=h+(S<<2)|0;P=S;S=f[$>>2]|0;f[$>>2]=T}while((S|0)<(P|0));ga=T}T=N;do{S=h+(T<<2)|0;U=T;T=f[S>>2]|0;f[S>>2]=ga}while((T|0)<(U|0));f[z+(E<<2)>>2]=ga;L=F;break a}T=E+2|0;do if(!((T|0)>=(n|0)|C)){if(!(b[x+T>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;N=E+-2|0;do if((N|0)>-1){if(!(b[v+N>>0]|0))break;if(b[x+I>>0]|0){U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}S=f[t+(T<<2)>>2]|0;O=S;while(1){Q=f[h+(O<<2)>>2]|0;if((Q|0)<(O|0))O=Q;else break}if((S|0)==(U|0))ha=O;else{Q=U;while(1){P=f[h+(Q<<2)>>2]|0;if((P|0)<(Q|0))Q=P;else break}P=(O|0)>(Q|0)?Q:O;$=U;do{M=h+($<<2)|0;V=$;$=f[M>>2]|0;f[M>>2]=P}while(($|0)<(V|0));ha=P}P=S;do{$=h+(P<<2)|0;U=P;P=f[$>>2]|0;f[$>>2]=ha}while((P|0)<(U|0));f[z+(E<<2)>>2]=ha;L=F;break a}if(!(b[x+N>>0]|0)){P=f[t+(T<<2)>>2]|0;S=f[z+(N<<2)>>2]|0;U=P;while(1){$=f[h+(U<<2)>>2]|0;if(($|0)<(U|0))U=$;else break}if((P|0)==(S|0))ia=U;else{$=S;while(1){O=f[h+($<<2)>>2]|0;if((O|0)<($|0))$=O;else break}O=(U|0)>($|0)?$:U;Q=S;do{V=h+(Q<<2)|0;M=Q;Q=f[V>>2]|0;f[V>>2]=O}while((Q|0)<(M|0));ia=O}O=P;do{Q=h+(O<<2)|0;S=O;O=f[Q>>2]|0;f[Q>>2]=ia}while((O|0)<(S|0));f[z+(E<<2)>>2]=ia;L=F;break a}if(!(b[y+I>>0]|0)){O=f[t+(T<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;S=O;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}if((O|0)==(P|0))ja=S;else{Q=P;while(1){U=f[h+(Q<<2)>>2]|0;if((U|0)<(Q|0))Q=U;else break}U=(S|0)>(Q|0)?Q:S;$=P;do{M=h+($<<2)|0;V=$;$=f[M>>2]|0;f[M>>2]=U}while(($|0)<(V|0));ja=U}U=O;do{$=h+(U<<2)|0;P=U;U=f[$>>2]|0;f[$>>2]=ja}while((U|0)<(P|0));f[z+(E<<2)>>2]=ja;L=F;break a}U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}O=f[t+(T<<2)>>2]|0;P=O;while(1){$=f[h+(P<<2)>>2]|0;if(($|0)<(P|0))P=$;else break}if((O|0)==(U|0))ka=P;else{$=U;while(1){S=f[h+($<<2)>>2]|0;if((S|0)<($|0))$=S;else break}S=(P|0)>($|0)?$:P;Q=U;do{V=h+(Q<<2)|0;M=Q;Q=f[V>>2]|0;f[V>>2]=S}while((Q|0)<(M|0));ka=S}S=O;do{Q=h+(S<<2)|0;U=S;S=f[Q>>2]|0;f[Q>>2]=ka}while((S|0)<(U|0));f[z+(E<<2)>>2]=ka;L=F;break a}while(0);S=f[t+(T<<2)>>2]|0;O=f[z+(N<<2)>>2]|0;U=S;while(1){Q=f[h+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}if((S|0)==(O|0))la=U;else{N=O;while(1){Q=f[h+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=(U|0)>(N|0)?N:U;P=O;do{$=h+(P<<2)|0;M=P;P=f[$>>2]|0;f[$>>2]=Q}while((P|0)<(M|0));la=Q}Q=S;do{P=h+(Q<<2)|0;O=Q;Q=f[P>>2]|0;f[P>>2]=la}while((Q|0)<(O|0));f[z+(E<<2)>>2]=la;L=F;break a}while(0);Q=E+-2|0;if(!(b[x+E>>0]|0)){S=f[t+(T<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;P=S;while(1){U=f[h+(P<<2)>>2]|0;if((U|0)<(P|0))P=U;else break}if((S|0)==(O|0))ma=P;else{U=O;while(1){N=f[h+(U<<2)>>2]|0;if((N|0)<(U|0))U=N;else break}N=(P|0)>(U|0)?U:P;M=O;do{$=h+(M<<2)|0;V=M;M=f[$>>2]|0;f[$>>2]=N}while((M|0)<(V|0));ma=N}N=S;do{M=h+(N<<2)|0;O=N;N=f[M>>2]|0;f[M>>2]=ma}while((N|0)<(O|0));f[z+(E<<2)>>2]=ma;L=F;break a}do if((Q|0)>-1){if(!(b[v+Q>>0]|0))break;if(b[x+I>>0]|0){N=f[t+(T<<2)>>2]|0;S=f[z+(Q<<2)>>2]|0;O=N;while(1){M=f[h+(O<<2)>>2]|0;if((M|0)<(O|0))O=M;else break}if((N|0)==(S|0))na=O;else{M=S;while(1){P=f[h+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}P=(O|0)>(M|0)?M:O;U=S;do{V=h+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=P}while((U|0)<($|0));na=P}P=N;do{U=h+(P<<2)|0;S=P;P=f[U>>2]|0;f[U>>2]=na}while((P|0)<(S|0));f[z+(E<<2)>>2]=na;L=F;break a}if(!(b[x+Q>>0]|0)){P=f[t+(E<<2)>>2]|0;N=f[t+(T<<2)>>2]|0;S=P;while(1){U=f[h+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((P|0)==(N|0))oa=S;else{U=N;while(1){O=f[h+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;M=N;do{$=h+(M<<2)|0;V=M;M=f[$>>2]|0;f[$>>2]=O}while((M|0)<(V|0));oa=O}O=P;do{M=h+(O<<2)|0;N=O;O=f[M>>2]|0;f[M>>2]=oa}while((O|0)<(N|0));O=f[z+(Q<<2)>>2]|0;P=oa;while(1){N=f[h+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}if((oa|0)==(O|0))pa=P;else{N=O;while(1){M=f[h+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(P|0)>(N|0)?N:P;S=O;do{U=h+(S<<2)|0;V=S;S=f[U>>2]|0;f[U>>2]=M}while((S|0)<(V|0));pa=M}M=oa;do{S=h+(M<<2)|0;O=M;M=f[S>>2]|0;f[S>>2]=pa}while((M|0)<(O|0));f[z+(E<<2)>>2]=pa;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;M=f[t+(T<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;S=M;while(1){P=f[h+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((M|0)==(O|0))qa=S;else{P=O;while(1){N=f[h+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(S|0)>(P|0)?P:S;V=O;do{U=h+(V<<2)|0;$=V;V=f[U>>2]|0;f[U>>2]=N}while((V|0)<($|0));qa=N}N=M;do{V=h+(N<<2)|0;O=N;N=f[V>>2]|0;f[V>>2]=qa}while((N|0)<(O|0));f[z+(E<<2)>>2]=qa;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;M=f[t+(T<<2)>>2]|0;O=N;while(1){V=f[h+(O<<2)>>2]|0;if((V|0)<(O|0))O=V;else break}if((N|0)==(M|0))ra=O;else{V=M;while(1){S=f[h+(V<<2)>>2]|0;if((S|0)<(V|0))V=S;else break}S=(O|0)>(V|0)?V:O;P=M;do{$=h+(P<<2)|0;U=P;P=f[$>>2]|0;f[$>>2]=S}while((P|0)<(U|0));ra=S}S=N;do{P=h+(S<<2)|0;M=S;S=f[P>>2]|0;f[P>>2]=ra}while((S|0)<(M|0));S=f[z+(Q<<2)>>2]|0;N=ra;while(1){M=f[h+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}if((ra|0)==(S|0))sa=N;else{M=S;while(1){P=f[h+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}P=(N|0)>(M|0)?M:N;O=S;do{V=h+(O<<2)|0;U=O;O=f[V>>2]|0;f[V>>2]=P}while((O|0)<(U|0));sa=P}P=ra;do{O=h+(P<<2)|0;S=P;P=f[O>>2]|0;f[O>>2]=sa}while((P|0)<(S|0));f[z+(E<<2)>>2]=sa;L=F;break a}while(0);P=f[t+(E<<2)>>2]|0;S=f[t+(T<<2)>>2]|0;O=P;while(1){N=f[h+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}if((P|0)==(S|0))ta=O;else{N=S;while(1){M=f[h+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(O|0)>(N|0)?N:O;U=S;do{V=h+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=M}while((U|0)<($|0));ta=M}M=P;do{U=h+(M<<2)|0;S=M;M=f[U>>2]|0;f[U>>2]=ta}while((M|0)<(S|0));M=f[z+(Q<<2)>>2]|0;P=ta;while(1){S=f[h+(P<<2)>>2]|0;if((S|0)<(P|0))P=S;else break}if((ta|0)==(M|0))ua=P;else{Q=M;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}S=(P|0)>(Q|0)?Q:P;U=M;do{O=h+(U<<2)|0;N=U;U=f[O>>2]|0;f[O>>2]=S}while((U|0)<(N|0));ua=S}S=ta;do{U=h+(S<<2)|0;M=S;S=f[U>>2]|0;f[U>>2]=ua}while((S|0)<(M|0));f[z+(E<<2)>>2]=ua;L=F;break a}while(0);T=E+-2|0;if(!(b[x+E>>0]|0)){va=T;break}do if((T|0)>-1){if(!(b[v+T>>0]|0))break;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(T<<2)>>2];L=F;break a}if(!(b[x+T>>0]|0)){S=f[t+(E<<2)>>2]|0;M=f[z+(T<<2)>>2]|0;U=S;while(1){P=f[h+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((S|0)==(M|0))wa=U;else{P=M;while(1){Q=f[h+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(U|0)>(P|0)?P:U;N=M;do{O=h+(N<<2)|0;$=N;N=f[O>>2]|0;f[O>>2]=Q}while((N|0)<($|0));wa=Q}Q=S;do{N=h+(Q<<2)|0;M=Q;Q=f[N>>2]|0;f[N>>2]=wa}while((Q|0)<(M|0));f[z+(E<<2)>>2]=wa;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;f[z+(E<<2)>>2]=f[z+(T<<2)>>2];L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;S=f[z+(T<<2)>>2]|0;M=Q;while(1){N=f[h+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((Q|0)==(S|0))xa=M;else{N=S;while(1){U=f[h+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}U=(M|0)>(N|0)?N:M;P=S;do{$=h+(P<<2)|0;O=P;P=f[$>>2]|0;f[$>>2]=U}while((P|0)<(O|0));xa=U}U=Q;do{P=h+(U<<2)|0;S=U;U=f[P>>2]|0;f[P>>2]=xa}while((U|0)<(S|0));f[z+(E<<2)>>2]=xa;L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;Q=f[z+(T<<2)>>2]|0;S=U;while(1){P=f[h+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((U|0)==(Q|0))ya=S;else{T=Q;while(1){P=f[h+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}P=(S|0)>(T|0)?T:S;M=Q;do{N=h+(M<<2)|0;O=M;M=f[N>>2]|0;f[N>>2]=P}while((M|0)<(O|0));ya=P}P=U;do{M=h+(P<<2)|0;Q=P;P=f[M>>2]|0;f[M>>2]=ya}while((P|0)<(Q|0));f[z+(E<<2)>>2]=ya;L=F;break a}else va=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(va<<2)>>2];L=F;break a}while(0);do if(B){if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}P=E+2|0;do if(!((P|0)>=(n|0)|C)){if(!(b[x+P>>0]|0))break;if(!(b[x+E>>0]|0)){f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;Q=f[t+(P<<2)>>2]|0;M=U;while(1){S=f[h+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((U|0)==(Q|0))za=M;else{S=Q;while(1){T=f[h+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}T=(M|0)>(S|0)?S:M;O=Q;do{N=h+(O<<2)|0;$=O;O=f[N>>2]|0;f[N>>2]=T}while((O|0)<($|0));za=T}T=U;do{O=h+(T<<2)|0;Q=T;T=f[O>>2]|0;f[O>>2]=za}while((T|0)<(Q|0));f[z+(E<<2)>>2]=za;L=F;break a}while(0);if(!(b[x+E>>0]|0))break;f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}while(0);f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break}if(K){if(b[w+I>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}if(b[v+I>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}}f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break}do if(H){if(!(b[v+G>>0]|0)){if(!A)break;if(!(b[w+G>>0]|0))break;f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break a}if(B){if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}P=E+2|0;do if(!((P|0)>=(n|0)|C)){if(!(b[x+P>>0]|0))break;if(!(b[x+E>>0]|0)){f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;U=f[t+(P<<2)>>2]|0;Q=T;while(1){O=f[h+(Q<<2)>>2]|0;if((O|0)<(Q|0))Q=O;else break}if((T|0)==(U|0))Aa=Q;else{O=U;while(1){M=f[h+(O<<2)>>2]|0;if((M|0)<(O|0))O=M;else break}M=(Q|0)>(O|0)?O:Q;S=U;do{$=h+(S<<2)|0;N=S;S=f[$>>2]|0;f[$>>2]=M}while((S|0)<(N|0));Aa=M}M=T;do{S=h+(M<<2)|0;U=M;M=f[S>>2]|0;f[S>>2]=Aa}while((M|0)<(U|0));f[z+(E<<2)>>2]=Aa;L=F;break a}while(0);if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}}f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break a}while(0);f[z+(E<<2)>>2]=0;L=F}else{G=E+-1|0;H=(E|0)>0;if(H){if(b[v+G>>0]|0){I=E|1;K=(I|0)<(n|0);if(B&K?b[x+I>>0]|0:0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}do if(D){if(!(b[y+E>>0]|0))break;P=E+-2|0;if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[y+G>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}M=f[t+(E<<2)>>2]|0;T=f[z+(P<<2)>>2]|0;U=M;while(1){S=f[h+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((M|0)==(T|0))Ba=U;else{S=T;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;O=T;do{N=h+(O<<2)|0;$=O;O=f[N>>2]|0;f[N>>2]=Q}while((O|0)<($|0));Ba=Q}Q=M;do{O=h+(Q<<2)|0;T=Q;Q=f[O>>2]|0;f[O>>2]=Ba}while((Q|0)<(T|0));f[z+(E<<2)>>2]=Ba;L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;T=Q;while(1){O=f[h+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}if((Q|0)==(M|0))Ca=T;else{P=M;while(1){O=f[h+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(T|0)>(P|0)?P:T;U=M;do{S=h+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=O}while((U|0)<($|0));Ca=O}O=Q;do{U=h+(O<<2)|0;M=O;O=f[U>>2]|0;f[U>>2]=Ca}while((O|0)<(M|0));f[z+(E<<2)>>2]=Ca;L=F;break a}while(0);O=f[t+(E<<2)>>2]|0;Q=f[z+(E+-2<<2)>>2]|0;M=O;while(1){U=f[h+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((O|0)==(Q|0))Da=M;else{U=Q;while(1){T=f[h+(U<<2)>>2]|0;if((T|0)<(U|0))U=T;else break}T=(M|0)>(U|0)?U:M;P=Q;do{$=h+(P<<2)|0;S=P;P=f[$>>2]|0;f[$>>2]=T}while((P|0)<(S|0));Da=T}T=O;do{P=h+(T<<2)|0;Q=T;T=f[P>>2]|0;f[P>>2]=Da}while((T|0)<(Q|0));f[z+(E<<2)>>2]=Da;L=F;break}if(K?b[v+I>>0]|0:0){T=E+2|0;do if(B&(T|0)<(n|0)){if(!(b[x+T>>0]|0))break;do if(D){if(!(b[y+I>>0]|0))break;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[y+E>>0]|0)){O=f[t+(T<<2)>>2]|0;Q=f[z+(E+-2<<2)>>2]|0;P=O;while(1){M=f[h+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((O|0)==(Q|0))Ea=P;else{M=Q;while(1){U=f[h+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}U=(P|0)>(M|0)?M:P;S=Q;do{$=h+(S<<2)|0;N=S;S=f[$>>2]|0;f[$>>2]=U}while((S|0)<(N|0));Ea=U}U=O;do{S=h+(U<<2)|0;Q=U;U=f[S>>2]|0;f[S>>2]=Ea}while((U|0)<(Q|0));f[z+(E<<2)>>2]=Ea;L=F;break a}U=E+-2|0;if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[z+(U<<2)>>2];L=F;break a}do if((U|0)>-1){if(!(b[x+U>>0]|0))break;if(b[y+G>>0]|0){f[z+(E<<2)>>2]=f[z+(U<<2)>>2];L=F;break a}O=f[t+(T<<2)>>2]|0;Q=f[z+(U<<2)>>2]|0;S=O;while(1){P=f[h+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((O|0)==(Q|0))Fa=S;else{P=Q;while(1){M=f[h+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(S|0)>(P|0)?P:S;N=Q;do{$=h+(N<<2)|0;V=N;N=f[$>>2]|0;f[$>>2]=M}while((N|0)<(V|0));Fa=M}M=O;do{N=h+(M<<2)|0;Q=M;M=f[N>>2]|0;f[N>>2]=Fa}while((M|0)<(Q|0));f[z+(E<<2)>>2]=Fa;L=F;break a}while(0);M=f[t+(T<<2)>>2]|0;O=f[z+(U<<2)>>2]|0;Q=M;while(1){N=f[h+(Q<<2)>>2]|0;if((N|0)<(Q|0))Q=N;else break}if((M|0)==(O|0))Ga=Q;else{U=O;while(1){N=f[h+(U<<2)>>2]|0;if((N|0)<(U|0))U=N;else break}N=(Q|0)>(U|0)?U:Q;S=O;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=N}while((S|0)<(V|0));Ga=N}N=M;do{S=h+(N<<2)|0;O=N;N=f[S>>2]|0;f[S>>2]=Ga}while((N|0)<(O|0));f[z+(E<<2)>>2]=Ga;L=F;break a}while(0);N=f[t+(T<<2)>>2]|0;M=f[z+(E+-2<<2)>>2]|0;O=N;while(1){S=f[h+(O<<2)>>2]|0;if((S|0)<(O|0))O=S;else break}if((N|0)==(M|0))Ha=O;else{S=M;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(O|0)>(S|0)?S:O;U=M;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=Q}while((U|0)<(P|0));Ha=Q}Q=N;do{U=h+(Q<<2)|0;M=Q;Q=f[U>>2]|0;f[U>>2]=Ha}while((Q|0)<(M|0));f[z+(E<<2)>>2]=Ha;L=F;break a}while(0);f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}if(A?b[w+G>>0]|0:0){T=E|1;I=(T|0)<(n|0);if(!(C|I^1)?b[x+T>>0]|0:0){K=E+-2|0;do if((K|0)>-1){if(!(b[v+K>>0]|0))break;if(b[x+G>>0]|0){Q=f[z+(K<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=Q;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;M=N;while(1){U=f[h+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((N|0)==(Q|0))Ia=M;else{U=Q;while(1){O=f[h+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(M|0)>(U|0)?U:M;S=Q;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=O}while((S|0)<(V|0));Ia=O}O=N;do{S=h+(O<<2)|0;Q=O;O=f[S>>2]|0;f[S>>2]=Ia}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Ia;L=F;break a}if(!(b[x+K>>0]|0)){O=f[t+(E<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;Q=O;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((O|0)==(N|0))Ja=Q;else{S=N;while(1){M=f[h+(S<<2)>>2]|0;if((M|0)<(S|0))S=M;else break}M=(Q|0)>(S|0)?S:Q;U=N;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=M}while((U|0)<(P|0));Ja=M}M=O;do{U=h+(M<<2)|0;N=M;M=f[U>>2]|0;f[U>>2]=Ja}while((M|0)<(N|0));f[z+(E<<2)>>2]=Ja;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;M=f[z+(K<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}O=f[t+(E<<2)>>2]|0;N=O;while(1){U=f[h+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}if((O|0)==(M|0))Ka=N;else{U=M;while(1){Q=f[h+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}Q=(N|0)>(U|0)?U:N;S=M;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<(V|0));Ka=Q}Q=O;do{S=h+(Q<<2)|0;M=Q;Q=f[S>>2]|0;f[S>>2]=Ka}while((Q|0)<(M|0));f[z+(E<<2)>>2]=Ka;L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;O=f[z+(K<<2)>>2]|0;M=Q;while(1){S=f[h+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((Q|0)==(O|0))La=M;else{S=O;while(1){N=f[h+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(M|0)>(S|0)?S:M;U=O;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<(P|0));La=N}N=Q;do{U=h+(N<<2)|0;O=N;N=f[U>>2]|0;f[U>>2]=La}while((N|0)<(O|0));f[z+(E<<2)>>2]=La;L=F;break a}while(0);if(b[x+E>>0]|0){N=f[t+(E<<2)>>2]|0;Q=f[z+(K<<2)>>2]|0;O=N;while(1){U=f[h+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((N|0)==(Q|0))Ma=O;else{U=Q;while(1){M=f[h+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=Q;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=M}while((S|0)<(V|0));Ma=M}M=N;do{S=h+(M<<2)|0;Q=M;M=f[S>>2]|0;f[S>>2]=Ma}while((M|0)<(Q|0));f[z+(E<<2)>>2]=Ma;L=F;break}M=f[t+(E<<2)>>2]|0;if(!(b[x+G>>0]|0)){N=f[z+(K<<2)>>2]|0;Q=M;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((M|0)==(N|0))Na=Q;else{S=N;while(1){O=f[h+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(Q|0)>(S|0)?S:Q;U=N;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=O}while((U|0)<(P|0));Na=O}O=M;do{U=h+(O<<2)|0;N=O;O=f[U>>2]|0;f[U>>2]=Na}while((O|0)<(N|0));f[z+(E<<2)>>2]=Na;L=F;break}do if(D){if(!(b[y+E>>0]|0))break;O=f[z+(K<<2)>>2]|0;N=M;while(1){U=f[h+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}if((M|0)==(O|0))Oa=N;else{U=O;while(1){Q=f[h+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}Q=(N|0)>(U|0)?U:N;S=O;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<(V|0));Oa=Q}Q=M;do{S=h+(Q<<2)|0;O=Q;Q=f[S>>2]|0;f[S>>2]=Oa}while((Q|0)<(O|0));f[z+(E<<2)>>2]=Oa;L=F;break a}while(0);Q=f[t+(K<<2)>>2]|0;O=Q;while(1){S=f[h+(O<<2)>>2]|0;if((S|0)<(O|0))O=S;else break}if((Q|0)==(M|0))Pa=O;else{S=M;while(1){N=f[h+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(O|0)>(S|0)?S:O;U=M;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<(P|0));Pa=N}N=Q;do{U=h+(N<<2)|0;M=N;N=f[U>>2]|0;f[U>>2]=Pa}while((N|0)<(M|0));N=f[z+(K<<2)>>2]|0;Q=Pa;while(1){M=f[h+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}if((Pa|0)==(N|0))Qa=Q;else{K=N;while(1){M=f[h+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(Q|0)>(K|0)?K:Q;U=N;do{O=h+(U<<2)|0;S=U;U=f[O>>2]|0;f[O>>2]=M}while((U|0)<(S|0));Qa=M}M=Pa;do{U=h+(M<<2)|0;N=M;M=f[U>>2]|0;f[U>>2]=Qa}while((M|0)<(N|0));f[z+(E<<2)>>2]=Qa;L=F;break}if(I?b[v+T>>0]|0:0){M=E+2|0;do if(!((M|0)>=(n|0)|C)){if(!(b[x+M>>0]|0))break;N=E+-2|0;do if((N|0)>-1){if(!(b[v+N>>0]|0))break;if(b[x+G>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}Q=f[t+(M<<2)>>2]|0;K=Q;while(1){S=f[h+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}if((Q|0)==(U|0))Ra=K;else{S=U;while(1){O=f[h+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(K|0)>(S|0)?S:K;P=U;do{V=h+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=O}while((P|0)<($|0));Ra=O}O=Q;do{P=h+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=Ra}while((O|0)<(U|0));f[z+(E<<2)>>2]=Ra;L=F;break a}while(0);O=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=O;while(1){P=f[h+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((O|0)==(Q|0))Sa=U;else{P=Q;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(U|0)>(P|0)?P:U;S=Q;do{$=h+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=K}while((S|0)<(V|0));Sa=K}K=O;do{S=h+(K<<2)|0;Q=K;K=f[S>>2]|0;f[S>>2]=Sa}while((K|0)<(Q|0));f[z+(E<<2)>>2]=Sa;L=F;break a}do if(D){if(!(b[y+T>>0]|0))break;if(!(b[x+N>>0]|0)){K=f[t+(M<<2)>>2]|0;O=f[z+(N<<2)>>2]|0;Q=K;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((K|0)==(O|0))Ta=Q;else{S=O;while(1){U=f[h+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(Q|0)>(S|0)?S:Q;P=O;do{V=h+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=U}while((P|0)<($|0));Ta=U}U=K;do{P=h+(U<<2)|0;O=U;U=f[P>>2]|0;f[P>>2]=Ta}while((U|0)<(O|0));f[z+(E<<2)>>2]=Ta;L=F;break a}if(!(b[y+G>>0]|0)){U=f[t+(M<<2)>>2]|0;K=f[z+(N<<2)>>2]|0;O=U;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((U|0)==(K|0))Ua=O;else{P=K;while(1){Q=f[h+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(O|0)>(P|0)?P:O;S=K;do{$=h+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=Q}while((S|0)<(V|0));Ua=Q}Q=U;do{S=h+(Q<<2)|0;K=Q;Q=f[S>>2]|0;f[S>>2]=Ua}while((Q|0)<(K|0));f[z+(E<<2)>>2]=Ua;L=F;break a}Q=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}U=f[t+(M<<2)>>2]|0;K=U;while(1){S=f[h+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}if((U|0)==(Q|0))Va=K;else{S=Q;while(1){O=f[h+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(K|0)>(S|0)?S:K;P=Q;do{V=h+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=O}while((P|0)<($|0));Va=O}O=U;do{P=h+(O<<2)|0;Q=O;O=f[P>>2]|0;f[P>>2]=Va}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Va;L=F;break a}while(0);if(!(b[x+E>>0]|0)){O=f[t+(M<<2)>>2]|0;U=f[z+(N<<2)>>2]|0;Q=O;while(1){P=f[h+(Q<<2)>>2]|0;if((P|0)<(Q|0))Q=P;else break}if((O|0)==(U|0))Wa=Q;else{P=U;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(Q|0)>(P|0)?P:Q;S=U;do{$=h+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=K}while((S|0)<(V|0));Wa=K}K=O;do{S=h+(K<<2)|0;U=K;K=f[S>>2]|0;f[S>>2]=Wa}while((K|0)<(U|0));f[z+(E<<2)>>2]=Wa;L=F;break a}if(!(b[x+N>>0]|0)){K=f[t+(E<<2)>>2]|0;O=f[t+(M<<2)>>2]|0;U=K;while(1){S=f[h+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((K|0)==(O|0))Xa=U;else{S=O;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;P=O;do{V=h+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=Q}while((P|0)<($|0));Xa=Q}Q=K;do{P=h+(Q<<2)|0;O=Q;Q=f[P>>2]|0;f[P>>2]=Xa}while((Q|0)<(O|0));Q=f[z+(N<<2)>>2]|0;K=Xa;while(1){O=f[h+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}if((Xa|0)==(Q|0))Ya=K;else{O=Q;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}P=(K|0)>(O|0)?O:K;U=Q;do{S=h+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=P}while((U|0)<($|0));Ya=P}P=Xa;do{U=h+(P<<2)|0;Q=P;P=f[U>>2]|0;f[U>>2]=Ya}while((P|0)<(Q|0));f[z+(E<<2)>>2]=Ya;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;P=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=P;while(1){K=f[h+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}if((P|0)==(Q|0))Za=U;else{K=Q;while(1){O=f[h+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}O=(U|0)>(K|0)?K:U;$=Q;do{S=h+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=O}while(($|0)<(V|0));Za=O}O=P;do{$=h+(O<<2)|0;Q=O;O=f[$>>2]|0;f[$>>2]=Za}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Za;L=F;break a}while(0);O=f[t+(E<<2)>>2]|0;P=f[t+(M<<2)>>2]|0;Q=O;while(1){$=f[h+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((O|0)==(P|0))_a=Q;else{$=P;while(1){U=f[h+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(Q|0)>($|0)?$:Q;K=P;do{V=h+(K<<2)|0;S=K;K=f[V>>2]|0;f[V>>2]=U}while((K|0)<(S|0));_a=U}U=O;do{K=h+(U<<2)|0;P=U;U=f[K>>2]|0;f[K>>2]=_a}while((U|0)<(P|0));U=f[z+(N<<2)>>2]|0;O=_a;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((_a|0)==(U|0))$a=O;else{P=U;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(O|0)>(P|0)?P:O;Q=U;do{$=h+(Q<<2)|0;S=Q;Q=f[$>>2]|0;f[$>>2]=K}while((Q|0)<(S|0));$a=K}K=_a;do{Q=h+(K<<2)|0;U=K;K=f[Q>>2]|0;f[Q>>2]=$a}while((K|0)<(U|0));f[z+(E<<2)>>2]=$a;L=F;break a}while(0);if(b[x+E>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;K=f[t+(M<<2)>>2]|0;U=f[z+(N<<2)>>2]|0;Q=K;while(1){O=f[h+(Q<<2)>>2]|0;if((O|0)<(Q|0))Q=O;else break}if((K|0)==(U|0))ab=Q;else{O=U;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}P=(Q|0)>(O|0)?O:Q;S=U;do{$=h+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=P}while((S|0)<(V|0));ab=P}P=K;do{S=h+(P<<2)|0;U=P;P=f[S>>2]|0;f[S>>2]=ab}while((P|0)<(U|0));f[z+(E<<2)>>2]=ab;L=F;break a}while(0);P=f[t+(E<<2)>>2]|0;K=f[t+(M<<2)>>2]|0;U=P;while(1){S=f[h+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((P|0)==(K|0))bb=U;else{S=K;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;O=K;do{V=h+(O<<2)|0;$=O;O=f[V>>2]|0;f[V>>2]=Q}while((O|0)<($|0));bb=Q}Q=P;do{O=h+(Q<<2)|0;K=Q;Q=f[O>>2]|0;f[O>>2]=bb}while((Q|0)<(K|0));Q=f[z+(N<<2)>>2]|0;P=bb;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((bb|0)==(Q|0))cb=P;else{K=Q;while(1){O=f[h+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}O=(P|0)>(K|0)?K:P;U=Q;do{S=h+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=O}while((U|0)<($|0));cb=O}O=bb;do{U=h+(O<<2)|0;Q=O;O=f[U>>2]|0;f[U>>2]=cb}while((O|0)<(Q|0));f[z+(E<<2)>>2]=cb;L=F;break a}if(!(b[x+G>>0]|0)){O=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=O;while(1){P=f[h+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((O|0)==(Q|0))db=U;else{P=Q;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(U|0)>(P|0)?P:U;$=Q;do{S=h+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=K}while(($|0)<(V|0));db=K}K=O;do{$=h+(K<<2)|0;Q=K;K=f[$>>2]|0;f[$>>2]=db}while((K|0)<(Q|0));f[z+(E<<2)>>2]=db;L=F;break a}do if(D){if(!(b[y+T>>0]|0))break;K=f[t+(M<<2)>>2]|0;if(b[y+E>>0]|0){O=f[z+(N<<2)>>2]|0;Q=K;while(1){$=f[h+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((K|0)==(O|0))eb=Q;else{$=O;while(1){U=f[h+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(Q|0)>($|0)?$:Q;P=O;do{V=h+(P<<2)|0;S=P;P=f[V>>2]|0;f[V>>2]=U}while((P|0)<(S|0));eb=U}U=K;do{P=h+(U<<2)|0;O=U;U=f[P>>2]|0;f[P>>2]=eb}while((U|0)<(O|0));f[z+(E<<2)>>2]=eb;L=F;break a}U=f[t+(N<<2)>>2]|0;O=U;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((U|0)==(K|0))fb=O;else{P=K;while(1){Q=f[h+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(O|0)>(P|0)?P:O;$=K;do{S=h+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=Q}while(($|0)<(V|0));fb=Q}Q=U;do{$=h+(Q<<2)|0;K=Q;Q=f[$>>2]|0;f[$>>2]=fb}while((Q|0)<(K|0));Q=f[z+(N<<2)>>2]|0;U=fb;while(1){K=f[h+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}if((fb|0)==(Q|0))gb=U;else{K=Q;while(1){$=f[h+(K<<2)>>2]|0;if(($|0)<(K|0))K=$;else break}$=(U|0)>(K|0)?K:U;O=Q;do{P=h+(O<<2)|0;V=O;O=f[P>>2]|0;f[P>>2]=$}while((O|0)<(V|0));gb=$}$=fb;do{O=h+($<<2)|0;Q=$;$=f[O>>2]|0;f[O>>2]=gb}while(($|0)<(Q|0));f[z+(E<<2)>>2]=gb;L=F;break a}while(0);$=f[t+(N<<2)>>2]|0;Q=f[t+(M<<2)>>2]|0;O=$;while(1){U=f[h+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if(($|0)==(Q|0))hb=O;else{U=Q;while(1){K=f[h+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}K=(O|0)>(U|0)?U:O;V=Q;do{P=h+(V<<2)|0;S=V;V=f[P>>2]|0;f[P>>2]=K}while((V|0)<(S|0));hb=K}K=$;do{V=h+(K<<2)|0;Q=K;K=f[V>>2]|0;f[V>>2]=hb}while((K|0)<(Q|0));K=f[z+(N<<2)>>2]|0;$=hb;while(1){Q=f[h+($<<2)>>2]|0;if((Q|0)<($|0))$=Q;else break}if((hb|0)==(K|0))ib=$;else{N=K;while(1){Q=f[h+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=($|0)>(N|0)?N:$;V=K;do{O=h+(V<<2)|0;U=V;V=f[O>>2]|0;f[O>>2]=Q}while((V|0)<(U|0));ib=Q}Q=hb;do{V=h+(Q<<2)|0;K=Q;Q=f[V>>2]|0;f[V>>2]=ib}while((Q|0)<(K|0));f[z+(E<<2)>>2]=ib;L=F;break a}while(0);do if(B){M=E+-2|0;if(b[x+G>>0]|0){T=f[z+(M<<2)>>2]|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;f[z+(E<<2)>>2]=T;L=F;break a}while(0);I=f[t+(M<<2)>>2]|0;Q=I;while(1){K=f[h+(Q<<2)>>2]|0;if((K|0)<(Q|0))Q=K;else break}if((I|0)==(T|0))jb=Q;else{K=T;while(1){V=f[h+(K<<2)>>2]|0;if((V|0)<(K|0))K=V;else break}V=(Q|0)>(K|0)?K:Q;$=T;do{N=h+($<<2)|0;U=$;$=f[N>>2]|0;f[N>>2]=V}while(($|0)<(U|0));jb=V}V=I;do{$=h+(V<<2)|0;T=V;V=f[$>>2]|0;f[$>>2]=jb}while((V|0)<(T|0));f[z+(E<<2)>>2]=jb;L=F;break a}if(!(b[x+E>>0]|0)){kb=M;break}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(!(b[x+M>>0]|0)){V=f[t+(E<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;T=V;while(1){$=f[h+(T<<2)>>2]|0;if(($|0)<(T|0))T=$;else break}if((V|0)==(I|0))lb=T;else{$=I;while(1){Q=f[h+($<<2)>>2]|0;if((Q|0)<($|0))$=Q;else break}Q=(T|0)>($|0)?$:T;K=I;do{U=h+(K<<2)|0;N=K;K=f[U>>2]|0;f[U>>2]=Q}while((K|0)<(N|0));lb=Q}Q=V;do{K=h+(Q<<2)|0;I=Q;Q=f[K>>2]|0;f[K>>2]=lb}while((Q|0)<(I|0));f[z+(E<<2)>>2]=lb;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;V=f[z+(M<<2)>>2]|0;I=Q;while(1){K=f[h+(I<<2)>>2]|0;if((K|0)<(I|0))I=K;else break}if((Q|0)==(V|0))mb=I;else{K=V;while(1){T=f[h+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(I|0)>(K|0)?K:I;$=V;do{N=h+($<<2)|0;U=$;$=f[N>>2]|0;f[N>>2]=T}while(($|0)<(U|0));mb=T}T=Q;do{$=h+(T<<2)|0;V=T;T=f[$>>2]|0;f[$>>2]=mb}while((T|0)<(V|0));f[z+(E<<2)>>2]=mb;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;Q=f[z+(M<<2)>>2]|0;V=T;while(1){$=f[h+(V<<2)>>2]|0;if(($|0)<(V|0))V=$;else break}if((T|0)==(Q|0))nb=V;else{M=Q;while(1){$=f[h+(M<<2)>>2]|0;if(($|0)<(M|0))M=$;else break}$=(V|0)>(M|0)?M:V;I=Q;do{K=h+(I<<2)|0;U=I;I=f[K>>2]|0;f[K>>2]=$}while((I|0)<(U|0));nb=$}$=T;do{I=h+($<<2)|0;Q=$;$=f[I>>2]|0;f[I>>2]=nb}while(($|0)<(Q|0));f[z+(E<<2)>>2]=nb;L=F;break a}else kb=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(kb<<2)>>2];L=F;break}do if(B){$=E+-2|0;if(b[x+G>>0]|0){T=f[z+($<<2)>>2]|0;do if(($|0)>-1){if(!(b[v+$>>0]|0))break;f[z+(E<<2)>>2]=T;L=F;break a}while(0);Q=f[t+($<<2)>>2]|0;I=Q;while(1){V=f[h+(I<<2)>>2]|0;if((V|0)<(I|0))I=V;else break}if((Q|0)==(T|0))ob=I;else{V=T;while(1){M=f[h+(V<<2)>>2]|0;if((M|0)<(V|0))V=M;else break}M=(I|0)>(V|0)?V:I;U=T;do{K=h+(U<<2)|0;N=U;U=f[K>>2]|0;f[K>>2]=M}while((U|0)<(N|0));ob=M}M=Q;do{U=h+(M<<2)|0;T=M;M=f[U>>2]|0;f[U>>2]=ob}while((M|0)<(T|0));f[z+(E<<2)>>2]=ob;L=F;break a}if(!(b[x+E>>0]|0)){pb=$;break}do if(($|0)>-1){if(!(b[v+$>>0]|0))break;if(!(b[x+$>>0]|0)){M=f[t+(E<<2)>>2]|0;Q=f[z+($<<2)>>2]|0;T=M;while(1){U=f[h+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((M|0)==(Q|0))qb=T;else{U=Q;while(1){I=f[h+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(T|0)>(U|0)?U:T;V=Q;do{N=h+(V<<2)|0;K=V;V=f[N>>2]|0;f[N>>2]=I}while((V|0)<(K|0));qb=I}I=M;do{V=h+(I<<2)|0;Q=I;I=f[V>>2]|0;f[V>>2]=qb}while((I|0)<(Q|0));f[z+(E<<2)>>2]=qb;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[z+($<<2)>>2];L=F;break a}while(0);I=f[t+(E<<2)>>2]|0;M=f[z+($<<2)>>2]|0;Q=I;while(1){V=f[h+(Q<<2)>>2]|0;if((V|0)<(Q|0))Q=V;else break}if((I|0)==(M|0))rb=Q;else{V=M;while(1){T=f[h+(V<<2)>>2]|0;if((T|0)<(V|0))V=T;else break}T=(Q|0)>(V|0)?V:Q;U=M;do{K=h+(U<<2)|0;N=U;U=f[K>>2]|0;f[K>>2]=T}while((U|0)<(N|0));rb=T}T=I;do{U=h+(T<<2)|0;M=T;T=f[U>>2]|0;f[U>>2]=rb}while((T|0)<(M|0));f[z+(E<<2)>>2]=rb;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;I=f[z+($<<2)>>2]|0;M=T;while(1){U=f[h+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((T|0)==(I|0))sb=M;else{$=I;while(1){U=f[h+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(M|0)>($|0)?$:M;Q=I;do{V=h+(Q<<2)|0;N=Q;Q=f[V>>2]|0;f[V>>2]=U}while((Q|0)<(N|0));sb=U}U=T;do{Q=h+(U<<2)|0;I=U;U=f[Q>>2]|0;f[Q>>2]=sb}while((U|0)<(I|0));f[z+(E<<2)>>2]=sb;L=F;break a}else pb=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(pb<<2)>>2];L=F;break}}U=E|1;T=(U|0)<(n|0);if(!(C|T^1)?b[x+U>>0]|0:0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(H?b[x+G>>0]|0:0){I=f[t+(E<<2)>>2]|0;do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=I;L=F;break a}while(0);Q=f[t+(E+-2<<2)>>2]|0;M=Q;while(1){$=f[h+(M<<2)>>2]|0;if(($|0)<(M|0))M=$;else break}if((Q|0)==(I|0))tb=M;else{$=I;while(1){N=f[h+($<<2)>>2]|0;if((N|0)<($|0))$=N;else break}N=(M|0)>($|0)?$:M;V=I;do{K=h+(V<<2)|0;O=V;V=f[K>>2]|0;f[K>>2]=N}while((V|0)<(O|0));tb=N}N=Q;do{V=h+(N<<2)|0;I=N;N=f[V>>2]|0;f[V>>2]=tb}while((N|0)<(I|0));f[z+(E<<2)>>2]=tb;L=F;break}f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(T?b[v+U>>0]|0:0){N=E+2|0;if(!((N|0)>=(n|0)|C)?b[x+N>>0]|0:0){if(b[x+E>>0]|0){do if(D){if(!(b[y+U>>0]|0))break;f[z+(E<<2)>>2]=f[t+(N<<2)>>2];L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;Q=f[t+(N<<2)>>2]|0;I=T;while(1){V=f[h+(I<<2)>>2]|0;if((V|0)<(I|0))I=V;else break}if((T|0)==(Q|0))ub=I;else{V=Q;while(1){M=f[h+(V<<2)>>2]|0;if((M|0)<(V|0))V=M;else break}M=(I|0)>(V|0)?V:I;$=Q;do{O=h+($<<2)|0;K=$;$=f[O>>2]|0;f[O>>2]=M}while(($|0)<(K|0));ub=M}M=T;do{$=h+(M<<2)|0;Q=M;M=f[$>>2]|0;f[$>>2]=ub}while((M|0)<(Q|0));f[z+(E<<2)>>2]=ub;L=F;break}do if(H){if(!(b[x+G>>0]|0))break;do if(D){if(!(b[y+U>>0]|0))break;M=f[t+(N<<2)>>2]|0;if(b[y+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}T=f[t+(E+-2<<2)>>2]|0;Q=T;while(1){$=f[h+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((T|0)==(M|0))vb=Q;else{$=M;while(1){I=f[h+($<<2)>>2]|0;if((I|0)<($|0))$=I;else break}I=(Q|0)>($|0)?$:Q;V=M;do{K=h+(V<<2)|0;O=V;V=f[K>>2]|0;f[K>>2]=I}while((V|0)<(O|0));vb=I}I=T;do{V=h+(I<<2)|0;M=I;I=f[V>>2]|0;f[V>>2]=vb}while((I|0)<(M|0));f[z+(E<<2)>>2]=vb;L=F;break a}while(0);I=f[t+(E+-2<<2)>>2]|0;T=f[t+(N<<2)>>2]|0;M=I;while(1){V=f[h+(M<<2)>>2]|0;if((V|0)<(M|0))M=V;else break}if((I|0)==(T|0))wb=M;else{V=T;while(1){Q=f[h+(V<<2)>>2]|0;if((Q|0)<(V|0))V=Q;else break}Q=(M|0)>(V|0)?V:M;$=T;do{O=h+($<<2)|0;K=$;$=f[O>>2]|0;f[O>>2]=Q}while(($|0)<(K|0));wb=Q}Q=I;do{$=h+(Q<<2)|0;T=Q;Q=f[$>>2]|0;f[$>>2]=wb}while((Q|0)<(T|0));f[z+(E<<2)>>2]=wb;L=F;break a}while(0);f[z+(E<<2)>>2]=f[t+(N<<2)>>2];L=F;break}if(B?b[x+E>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}do if(!(C|H^1)){if(!(b[x+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(E+-2<<2)>>2];L=F;break a}while(0);f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break}if(B?b[x+E>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(!(C|H^1)?b[x+G>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E+-2<<2)>>2];L=F;break}f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0}while(0);E=E+2|0;if((E|0)>=(n|0)){xb=L;break}else F=L}}else xb=r;s=s+2|0;if((s|0)>=(i|0))break;else r=xb}if((xb|0)>1){r=1;i=1;while(1){s=h+(i<<2)|0;L=f[s>>2]|0;if((L|0)<(i|0)){f[s>>2]=f[h+(L<<2)>>2];yb=r}else{f[s>>2]=r;yb=r+1|0}i=i+1|0;if((i|0)==(xb|0)){zb=yb;break}else r=yb}}else zb=1}else zb=1;Xaa(g,zb);yb=f[j>>2]|0;r=f[o>>2]|0;xb=(r&1|0)!=0;i=(yb|0)>0;b:do if(!(yb&1)){if(!xb){if(!i)break;s=c+16|0;L=c+44|0;n=d+16|0;wb=d+44|0;vb=g+20|0;ub=g+120|0;tb=g+48|0;pb=0;sb=r;rb=yb;while(1){qb=f[f[L>>2]>>2]|0;ob=(f[s>>2]|0)+(Y(qb,pb)|0)|0;kb=ob+qb|0;qb=f[f[wb>>2]>>2]|0;nb=(f[n>>2]|0)+(Y(qb,pb)|0)|0;mb=nb+qb|0;if((sb|0)>0){qb=((pb|0)<0)<<31>>31;lb=pb|1;jb=((lb|0)<0)<<31>>31;ib=0;do{hb=nb+(ib<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){fb=f[h+(gb<<2)>>2]|0;if(!(b[ob+ib>>0]|0)){f[hb>>2]=0;eb=f[vb>>2]|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(ib|0)?ib:db;db=eb+8|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(ib|0)?ib:cb;cb=eb+4|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)>(pb|0)?pb:db;db=eb+12|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(pb|0)?pb:cb;cb=eb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=f[ub>>2]|0;db=cb;bb=UIc(f[db>>2]|0,f[db+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;db=cb;f[db>>2]=bb;f[db+4>>2]=J;Ab=cb+8|0;Bb=eb;Cb=cb}else{f[hb>>2]=fb;cb=f[vb>>2]|0;eb=cb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(ib|0)?ib:db;db=eb+8|0;bb=f[db>>2]|0;f[db>>2]=(bb|0)<(ib|0)?ib:bb;bb=eb+4|0;db=f[bb>>2]|0;f[bb>>2]=(db|0)>(pb|0)?pb:db;db=eb+12|0;bb=f[db>>2]|0;f[db>>2]=(bb|0)<(pb|0)?pb:bb;bb=eb+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=f[ub>>2]|0;eb=bb+(fb<<4)|0;db=eb;ab=UIc(f[db>>2]|0,f[db+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;db=eb;f[db>>2]=ab;f[db+4>>2]=J;Ab=bb+(fb<<4)+8|0;Bb=cb;Cb=bb}bb=Ab;cb=UIc(f[bb>>2]|0,f[bb+4>>2]|0,pb|0,qb|0)|0;bb=Ab;f[bb>>2]=cb;f[bb+4>>2]=J;bb=ib|1;cb=nb+(bb<<2)|0;if(!(b[ob+bb>>0]|0)){f[cb>>2]=0;Db=0;Eb=Bb}else{f[cb>>2]=fb;Db=fb;Eb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0}cb=f[Eb>>2]|0;f[Eb>>2]=(cb|0)>(bb|0)?bb:cb;cb=Eb+8|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)<(bb|0)?bb:db;db=Eb+4|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)>(pb|0)?pb:cb;cb=Eb+12|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)<(pb|0)?pb:db;db=Eb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(Db<<4)|0;cb=db;ab=UIc(f[cb>>2]|0,f[cb+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;cb=db;f[cb>>2]=ab;f[cb+4>>2]=J;cb=Cb+(Db<<4)+8|0;ab=cb;db=UIc(f[ab>>2]|0,f[ab+4>>2]|0,pb|0,qb|0)|0;ab=cb;f[ab>>2]=db;f[ab+4>>2]=J;ab=mb+(ib<<2)|0;if(!(b[kb+ib>>0]|0)){f[ab>>2]=0;Fb=0;Gb=Bb}else{f[ab>>2]=fb;Fb=fb;Gb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0}ab=f[Gb>>2]|0;f[Gb>>2]=(ab|0)>(ib|0)?ib:ab;ab=Gb+8|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(ib|0)?ib:db;db=Gb+4|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)>(lb|0)?lb:ab;ab=Gb+12|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(lb|0)?lb:db;db=Gb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(Fb<<4)|0;ab=db;cb=UIc(f[ab>>2]|0,f[ab+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;ab=db;f[ab>>2]=cb;f[ab+4>>2]=J;ab=Cb+(Fb<<4)+8|0;cb=ab;db=UIc(f[cb>>2]|0,f[cb+4>>2]|0,lb|0,jb|0)|0;cb=ab;f[cb>>2]=db;f[cb+4>>2]=J;cb=mb+(bb<<2)|0;if(!(b[kb+bb>>0]|0)){f[cb>>2]=0;db=f[Bb>>2]|0;f[Bb>>2]=(db|0)>(bb|0)?bb:db;db=Bb+8|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)<(bb|0)?bb:ab;ab=Bb+4|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)>(lb|0)?lb:db;db=Bb+12|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)<(lb|0)?lb:ab;ab=Bb+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=Cb;db=UIc(f[ab>>2]|0,f[ab+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;ab=Cb;f[ab>>2]=db;f[ab+4>>2]=J;Hb=Cb+8|0;break}else{f[cb>>2]=fb;cb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0;ab=f[cb>>2]|0;f[cb>>2]=(ab|0)>(bb|0)?bb:ab;ab=cb+8|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(bb|0)?bb:db;db=cb+4|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)>(lb|0)?lb:ab;ab=cb+12|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(lb|0)?lb:db;db=cb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(fb<<4)|0;cb=db;ab=UIc(f[cb>>2]|0,f[cb+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;bb=db;f[bb>>2]=ab;f[bb+4>>2]=J;Hb=Cb+(fb<<4)+8|0;break}}else{f[hb>>2]=0;fb=ib|1;f[nb+(fb<<2)>>2]=0;f[mb+(ib<<2)>>2]=0;f[mb+(fb<<2)>>2]=0;bb=f[vb>>2]|0;ab=f[bb>>2]|0;db=(ab|0)>(ib|0)?ib:ab;ab=bb+8|0;cb=f[ab>>2]|0;eb=(cb|0)<(ib|0)?ib:cb;cb=bb+4|0;$a=f[cb>>2]|0;_a=($a|0)>(pb|0)?pb:$a;$a=bb+12|0;Za=f[$a>>2]|0;Ya=(Za|0)<(pb|0)?pb:Za;Za=bb+16|0;Xa=f[Za>>2]|0;Wa=f[ub>>2]|0;Va=((ib|0)<0)<<31>>31;Ua=Wa;Ta=UIc(f[Ua>>2]|0,f[Ua+4>>2]|0,ib|0,Va|0)|0;Ua=J;Sa=Wa+8|0;Ra=Sa;Qa=UIc(f[Ra>>2]|0,f[Ra+4>>2]|0,pb|0,qb|0)|0;Ra=J;Pa=(db|0)>(fb|0)?fb:db;db=((fb|0)<0)<<31>>31;Oa=UIc(Ta|0,Ua|0,fb|0,db|0)|0;Ua=J;Ta=UIc(Qa|0,Ra|0,pb|0,qb|0)|0;Ra=J;Qa=UIc(Oa|0,Ua|0,ib|0,Va|0)|0;Va=J;Ua=UIc(Ta|0,Ra|0,lb|0,jb|0)|0;Ra=Sa;f[Ra>>2]=Ua;f[Ra+4>>2]=J;f[bb>>2]=(Pa|0)>(ib|0)?ib:Pa;f[ab>>2]=(eb|0)<(fb|0)?fb:eb;f[cb>>2]=(_a|0)>(lb|0)?lb:_a;f[$a>>2]=(Ya|0)<(lb|0)?lb:Ya;f[Za>>2]=Xa+4;Xa=UIc(Qa|0,Va|0,fb|0,db|0)|0;db=Wa;f[db>>2]=Xa;f[db+4>>2]=J;Hb=Sa}while(0);hb=Hb;gb=UIc(f[hb>>2]|0,f[hb+4>>2]|0,lb|0,jb|0)|0;hb=Hb;f[hb>>2]=gb;f[hb+4>>2]=J;ib=ib+2|0;Ib=f[o>>2]|0}while((ib|0)<(Ib|0));Jb=f[j>>2]|0;Kb=Ib}else{Jb=rb;Kb=sb}pb=pb+2|0;if((pb|0)>=(Jb|0))break b;else{sb=Kb;rb=Jb}}}if(i){rb=g+20|0;sb=g+120|0;pb=g+48|0;ub=f[c+16>>2]|0;vb=f[c+44>>2]|0;tb=f[d+16>>2]|0;n=f[d+44>>2]|0;wb=0;s=r;L=yb;while(1){ib=f[vb>>2]|0;jb=ub+(Y(ib,wb)|0)|0;lb=jb+ib|0;ib=f[n>>2]|0;qb=tb+(Y(ib,wb)|0)|0;mb=qb+ib|0;if((s|0)>0){ib=((wb|0)<0)<<31>>31;nb=wb|1;kb=((nb|0)<0)<<31>>31;ob=0;do{hb=qb+(ob<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){G=f[h+(gb<<2)>>2]|0;if(!(b[jb+ob>>0]|0)){f[hb>>2]=0;H=f[rb>>2]|0;Sa=f[H>>2]|0;f[H>>2]=(Sa|0)>(ob|0)?ob:Sa;Sa=H+8|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(ob|0)?ob:db;db=H+4|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(wb|0)?wb:Sa;Sa=H+12|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(wb|0)?wb:db;db=H+16|0;f[db>>2]=(f[db>>2]|0)+1;db=f[sb>>2]|0;Sa=db;Xa=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Sa=db;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Lb=db+8|0;Mb=H;Nb=db}else{f[hb>>2]=G;db=f[rb>>2]|0;H=db+(Y(f[f[pb>>2]>>2]|0,G)|0)|0;Sa=f[H>>2]|0;f[H>>2]=(Sa|0)>(ob|0)?ob:Sa;Sa=H+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(ob|0)?ob:Xa;Xa=H+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(wb|0)?wb:Sa;Sa=H+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(wb|0)?wb:Xa;Xa=H+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[sb>>2]|0;H=Xa+(G<<4)|0;Sa=H;Wa=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Sa=H;f[Sa>>2]=Wa;f[Sa+4>>2]=J;Lb=Xa+(G<<4)+8|0;Mb=db;Nb=Xa}Xa=Lb;db=UIc(f[Xa>>2]|0,f[Xa+4>>2]|0,wb|0,ib|0)|0;Xa=Lb;f[Xa>>2]=db;f[Xa+4>>2]=J;Xa=mb+(ob<<2)|0;if(!(b[lb+ob>>0]|0)){f[Xa>>2]=0;Ob=0;Pb=Mb}else{f[Xa>>2]=G;Ob=G;Pb=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0}Xa=f[Pb>>2]|0;f[Pb>>2]=(Xa|0)>(ob|0)?ob:Xa;Xa=Pb+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(ob|0)?ob:db;db=Pb+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Pb+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(nb|0)?nb:db;db=Pb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Nb+(Ob<<4)|0;Xa=db;Sa=UIc(f[Xa>>2]|0,f[Xa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Xa=db;f[Xa>>2]=Sa;f[Xa+4>>2]=J;Xa=Nb+(Ob<<4)+8|0;Sa=Xa;db=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,nb|0,kb|0)|0;Sa=Xa;f[Sa>>2]=db;f[Sa+4>>2]=J;Sa=ob|1;if((Sa|0)<(f[o>>2]|0)){db=qb+(Sa<<2)|0;if(!(b[jb+Sa>>0]|0)){f[db>>2]=0;Qb=0;Rb=Mb}else{f[db>>2]=G;Qb=G;Rb=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0}db=f[Rb>>2]|0;f[Rb>>2]=(db|0)>(Sa|0)?Sa:db;db=Rb+8|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)<(Sa|0)?Sa:Xa;Xa=Rb+4|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)>(wb|0)?wb:db;db=Rb+12|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)<(wb|0)?wb:Xa;Xa=Rb+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=Nb+(Qb<<4)|0;db=Xa;Wa=UIc(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;db=Xa;f[db>>2]=Wa;f[db+4>>2]=J;db=Nb+(Qb<<4)+8|0;Wa=db;Xa=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,wb|0,ib|0)|0;Wa=db;f[Wa>>2]=Xa;f[Wa+4>>2]=J;Wa=mb+(Sa<<2)|0;if(!(b[lb+Sa>>0]|0)){f[Wa>>2]=0;Xa=f[Mb>>2]|0;f[Mb>>2]=(Xa|0)>(Sa|0)?Sa:Xa;Xa=Mb+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(Sa|0)?Sa:db;db=Mb+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Mb+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(nb|0)?nb:db;db=Mb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Nb;Xa=UIc(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;db=Nb;f[db>>2]=Xa;f[db+4>>2]=J;db=Nb+8|0;Xa=db;H=UIc(f[Xa>>2]|0,f[Xa+4>>2]|0,nb|0,kb|0)|0;Xa=db;f[Xa>>2]=H;f[Xa+4>>2]=J;break}else{f[Wa>>2]=G;Wa=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)>(Sa|0)?Sa:Xa;Xa=Wa+8|0;H=f[Xa>>2]|0;f[Xa>>2]=(H|0)<(Sa|0)?Sa:H;H=Wa+4|0;Xa=f[H>>2]|0;f[H>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Wa+12|0;H=f[Xa>>2]|0;f[Xa>>2]=(H|0)<(nb|0)?nb:H;H=Wa+16|0;f[H>>2]=(f[H>>2]|0)+1;H=Nb+(G<<4)|0;Wa=H;Xa=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;Sa=H;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Sa=Nb+(G<<4)+8|0;G=Sa;Xa=UIc(f[G>>2]|0,f[G+4>>2]|0,nb|0,kb|0)|0;G=Sa;f[G>>2]=Xa;f[G+4>>2]=J;break}}}else{f[hb>>2]=0;f[mb+(ob<<2)>>2]=0;G=f[rb>>2]|0;Xa=f[G>>2]|0;Sa=G+8|0;H=f[Sa>>2]|0;Wa=G+4|0;db=f[Wa>>2]|0;fb=(db|0)>(wb|0)?wb:db;db=G+12|0;Va=f[db>>2]|0;Qa=(Va|0)<(wb|0)?wb:Va;Va=G+16|0;Za=f[Va>>2]|0;Ya=f[sb>>2]|0;$a=((ob|0)<0)<<31>>31;_a=Ya;cb=UIc(f[_a>>2]|0,f[_a+4>>2]|0,ob|0,$a|0)|0;_a=J;eb=Ya+8|0;ab=eb;Pa=UIc(f[ab>>2]|0,f[ab+4>>2]|0,wb|0,ib|0)|0;ab=J;f[G>>2]=(Xa|0)>(ob|0)?ob:Xa;f[Sa>>2]=(H|0)<(ob|0)?ob:H;f[Wa>>2]=(fb|0)>(nb|0)?nb:fb;f[db>>2]=(Qa|0)<(nb|0)?nb:Qa;f[Va>>2]=Za+2;Za=UIc(cb|0,_a|0,ob|0,$a|0)|0;$a=J;_a=Ya;f[_a>>2]=Za;f[_a+4>>2]=$a;_a=UIc(Pa|0,ab|0,nb|0,kb|0)|0;ab=J;Pa=eb;f[Pa>>2]=_a;f[Pa+4>>2]=ab;Pa=ob|1;if((Pa|0)<(f[o>>2]|0)){f[qb+(Pa<<2)>>2]=0;f[mb+(Pa<<2)>>2]=0;cb=f[G>>2]|0;Qa=f[Sa>>2]|0;fb=f[Wa>>2]|0;H=(fb|0)>(wb|0)?wb:fb;fb=f[db>>2]|0;Xa=(fb|0)<(wb|0)?wb:fb;fb=f[Va>>2]|0;bb=((Pa|0)<0)<<31>>31;Ra=UIc(Za|0,$a|0,Pa|0,bb|0)|0;$a=J;Za=UIc(_a|0,ab|0,wb|0,ib|0)|0;ab=J;f[G>>2]=(cb|0)>(Pa|0)?Pa:cb;f[Sa>>2]=(Qa|0)<(Pa|0)?Pa:Qa;f[Wa>>2]=(H|0)>(nb|0)?nb:H;f[db>>2]=(Xa|0)<(nb|0)?nb:Xa;f[Va>>2]=fb+2;fb=UIc(Ra|0,$a|0,Pa|0,bb|0)|0;bb=Ya;f[bb>>2]=fb;f[bb+4>>2]=J;bb=UIc(Za|0,ab|0,nb|0,kb|0)|0;ab=eb;f[ab>>2]=bb;f[ab+4>>2]=J}}while(0);ob=ob+2|0;Sb=f[o>>2]|0}while((ob|0)<(Sb|0));Tb=f[j>>2]|0;Ub=Sb}else{Tb=L;Ub=s}wb=wb+2|0;if((wb|0)>=(Tb|0))break;else{s=Ub;L=Tb}}}}else{if(!xb){if(!i)break;L=g+20|0;s=g+120|0;wb=g+48|0;sb=f[c+16>>2]|0;rb=f[c+44>>2]|0;pb=f[d+16>>2]|0;tb=f[d+44>>2]|0;n=0;ub=r;vb=yb;while(1){ob=f[rb>>2]|0;kb=sb+(Y(ob,n)|0)|0;nb=kb+ob|0;ob=f[tb>>2]|0;ib=pb+(Y(ob,n)|0)|0;mb=ib+ob|0;if((ub|0)>0){ob=((n|0)<0)<<31>>31;qb=n|1;lb=((qb|0)<0)<<31>>31;jb=0;do{hb=ib+(jb<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){ab=f[h+(gb<<2)>>2]|0;if(!(b[kb+jb>>0]|0)){f[hb>>2]=0;bb=f[L>>2]|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(jb|0)?jb:eb;eb=bb+8|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)<(jb|0)?jb:Za;Za=bb+4|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)>(n|0)?n:eb;eb=bb+12|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)<(n|0)?n:Za;Za=bb+16|0;f[Za>>2]=(f[Za>>2]|0)+1;Za=f[s>>2]|0;eb=Za;fb=UIc(f[eb>>2]|0,f[eb+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;eb=Za;f[eb>>2]=fb;f[eb+4>>2]=J;Vb=Za+8|0;Wb=bb;Xb=Za}else{f[hb>>2]=ab;Za=f[L>>2]|0;bb=Za+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(jb|0)?jb:eb;eb=bb+8|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)<(jb|0)?jb:fb;fb=bb+4|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)>(n|0)?n:eb;eb=bb+12|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)<(n|0)?n:fb;fb=bb+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=f[s>>2]|0;bb=fb+(ab<<4)|0;eb=bb;Ya=UIc(f[eb>>2]|0,f[eb+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;eb=bb;f[eb>>2]=Ya;f[eb+4>>2]=J;Vb=fb+(ab<<4)+8|0;Wb=Za;Xb=fb}fb=Vb;Za=UIc(f[fb>>2]|0,f[fb+4>>2]|0,n|0,ob|0)|0;fb=Vb;f[fb>>2]=Za;f[fb+4>>2]=J;fb=jb|1;Za=ib+(fb<<2)|0;if(!(b[kb+fb>>0]|0)){f[Za>>2]=0;Yb=0;Zb=Wb}else{f[Za>>2]=ab;Yb=ab;Zb=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0}Za=f[Zb>>2]|0;f[Zb>>2]=(Za|0)>(fb|0)?fb:Za;Za=Zb+8|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)<(fb|0)?fb:eb;eb=Zb+4|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)>(n|0)?n:Za;Za=Zb+12|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)<(n|0)?n:eb;eb=Zb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Xb+(Yb<<4)|0;Za=eb;Ya=UIc(f[Za>>2]|0,f[Za+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;Za=eb;f[Za>>2]=Ya;f[Za+4>>2]=J;Za=Xb+(Yb<<4)+8|0;Ya=Za;eb=UIc(f[Ya>>2]|0,f[Ya+4>>2]|0,n|0,ob|0)|0;Ya=Za;f[Ya>>2]=eb;f[Ya+4>>2]=J;if((qb|0)<(f[j>>2]|0)){Ya=mb+(jb<<2)|0;if(!(b[nb+jb>>0]|0)){f[Ya>>2]=0;_b=0;$b=Wb}else{f[Ya>>2]=ab;_b=ab;$b=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0}Ya=f[$b>>2]|0;f[$b>>2]=(Ya|0)>(jb|0)?jb:Ya;Ya=$b+8|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)<(jb|0)?jb:eb;eb=$b+4|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)>(qb|0)?qb:Ya;Ya=$b+12|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)<(qb|0)?qb:eb;eb=$b+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Xb+(_b<<4)|0;Ya=eb;Za=UIc(f[Ya>>2]|0,f[Ya+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;Ya=eb;f[Ya>>2]=Za;f[Ya+4>>2]=J;Ya=Xb+(_b<<4)+8|0;Za=Ya;eb=UIc(f[Za>>2]|0,f[Za+4>>2]|0,qb|0,lb|0)|0;Za=Ya;f[Za>>2]=eb;f[Za+4>>2]=J;Za=mb+(fb<<2)|0;if(!(b[nb+fb>>0]|0)){f[Za>>2]=0;eb=f[Wb>>2]|0;f[Wb>>2]=(eb|0)>(fb|0)?fb:eb;eb=Wb+8|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)<(fb|0)?fb:Ya;Ya=Wb+4|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)>(qb|0)?qb:eb;eb=Wb+12|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)<(qb|0)?qb:Ya;Ya=Wb+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=Xb;eb=UIc(f[Ya>>2]|0,f[Ya+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;Ya=Xb;f[Ya>>2]=eb;f[Ya+4>>2]=J;Ya=Xb+8|0;eb=Ya;bb=UIc(f[eb>>2]|0,f[eb+4>>2]|0,qb|0,lb|0)|0;eb=Ya;f[eb>>2]=bb;f[eb+4>>2]=J;break}else{f[Za>>2]=ab;Za=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)>(fb|0)?fb:eb;eb=Za+8|0;bb=f[eb>>2]|0;f[eb>>2]=(bb|0)<(fb|0)?fb:bb;bb=Za+4|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(qb|0)?qb:eb;eb=Za+12|0;bb=f[eb>>2]|0;f[eb>>2]=(bb|0)<(qb|0)?qb:bb;bb=Za+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=Xb+(ab<<4)|0;Za=bb;eb=UIc(f[Za>>2]|0,f[Za+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;fb=bb;f[fb>>2]=eb;f[fb+4>>2]=J;fb=Xb+(ab<<4)+8|0;ab=fb;eb=UIc(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,lb|0)|0;ab=fb;f[ab>>2]=eb;f[ab+4>>2]=J;break}}}else{f[hb>>2]=0;ab=jb|1;f[ib+(ab<<2)>>2]=0;eb=f[L>>2]|0;fb=f[eb>>2]|0;bb=(fb|0)>(jb|0)?jb:fb;fb=eb+8|0;Za=f[fb>>2]|0;Ya=(Za|0)<(jb|0)?jb:Za;Za=eb+4|0;Pa=f[Za>>2]|0;$a=eb+12|0;Ra=f[$a>>2]|0;Va=eb+16|0;Xa=f[Va>>2]|0;db=f[s>>2]|0;H=((jb|0)<0)<<31>>31;Wa=db;Qa=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,jb|0,H|0)|0;Wa=J;Sa=db+8|0;cb=Sa;G=UIc(f[cb>>2]|0,f[cb+4>>2]|0,n|0,ob|0)|0;cb=J;f[eb>>2]=(bb|0)>(ab|0)?ab:bb;f[fb>>2]=(Ya|0)<(ab|0)?ab:Ya;f[Za>>2]=(Pa|0)>(n|0)?n:Pa;f[$a>>2]=(Ra|0)<(n|0)?n:Ra;f[Va>>2]=Xa+2;Xa=((ab|0)<0)<<31>>31;Ra=UIc(Qa|0,Wa|0,ab|0,Xa|0)|0;Wa=J;Qa=db;f[Qa>>2]=Ra;f[Qa+4>>2]=Wa;Qa=UIc(G|0,cb|0,n|0,ob|0)|0;cb=J;G=Sa;f[G>>2]=Qa;f[G+4>>2]=cb;if((qb|0)<(f[j>>2]|0)){f[mb+(jb<<2)>>2]=0;f[mb+(ab<<2)>>2]=0;G=f[eb>>2]|0;Pa=(G|0)>(jb|0)?jb:G;G=f[fb>>2]|0;Ya=(G|0)<(jb|0)?jb:G;G=f[Za>>2]|0;bb=f[$a>>2]|0;_a=f[Va>>2]|0;Ua=UIc(Ra|0,Wa|0,jb|0,H|0)|0;H=J;Wa=UIc(Qa|0,cb|0,qb|0,lb|0)|0;cb=J;f[eb>>2]=(Pa|0)>(ab|0)?ab:Pa;f[fb>>2]=(Ya|0)<(ab|0)?ab:Ya;f[Za>>2]=(G|0)>(qb|0)?qb:G;f[$a>>2]=(bb|0)<(qb|0)?qb:bb;f[Va>>2]=_a+2;_a=UIc(Ua|0,H|0,ab|0,Xa|0)|0;Xa=db;f[Xa>>2]=_a;f[Xa+4>>2]=J;Xa=UIc(Wa|0,cb|0,qb|0,lb|0)|0;cb=Sa;f[cb>>2]=Xa;f[cb+4>>2]=J}}while(0);jb=jb+2|0;ac=f[o>>2]|0}while((jb|0)<(ac|0));bc=f[j>>2]|0;cc=ac}else{bc=vb;cc=ub}n=n+2|0;if((n|0)>=(bc|0))break b;else{ub=cc;vb=bc}}}if(i){vb=g+20|0;ub=g+120|0;n=g+48|0;s=f[c+16>>2]|0;L=f[c+44>>2]|0;wb=f[d+16>>2]|0;pb=f[d+44>>2]|0;tb=0;sb=r;rb=yb;while(1){jb=f[L>>2]|0;lb=s+(Y(jb,tb)|0)|0;qb=lb+jb|0;jb=f[pb>>2]|0;mb=wb+(Y(jb,tb)|0)|0;ob=mb+jb|0;if((sb|0)>0){jb=((tb|0)<0)<<31>>31;ib=tb|1;nb=((ib|0)<0)<<31>>31;kb=0;do{hb=mb+(kb<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){cb=f[h+(gb<<2)>>2]|0;if(!(b[lb+kb>>0]|0)){f[hb>>2]=0;Xa=f[vb>>2]|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Xa+8|0;Wa=f[Sa>>2]|0;f[Sa>>2]=(Wa|0)<(kb|0)?kb:Wa;Wa=Xa+4|0;Sa=f[Wa>>2]|0;f[Wa>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=Xa+12|0;Wa=f[Sa>>2]|0;f[Sa>>2]=(Wa|0)<(tb|0)?tb:Wa;Wa=Xa+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[ub>>2]|0;Sa=Wa;_a=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Sa=Wa;f[Sa>>2]=_a;f[Sa+4>>2]=J;dc=Wa+8|0;ec=Xa;fc=Wa}else{f[hb>>2]=cb;Wa=f[vb>>2]|0;Xa=Wa+(Y(f[f[n>>2]>>2]|0,cb)|0)|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Xa+8|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(kb|0)?kb:_a;_a=Xa+4|0;Sa=f[_a>>2]|0;f[_a>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=Xa+12|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(tb|0)?tb:_a;_a=Xa+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=f[ub>>2]|0;Xa=_a+(cb<<4)|0;Sa=Xa;db=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Sa=Xa;f[Sa>>2]=db;f[Sa+4>>2]=J;dc=_a+(cb<<4)+8|0;ec=Wa;fc=_a}_a=dc;Wa=UIc(f[_a>>2]|0,f[_a+4>>2]|0,tb|0,jb|0)|0;_a=dc;f[_a>>2]=Wa;f[_a+4>>2]=J;_a=kb|1;if((_a|0)>=(f[o>>2]|0)){if((ib|0)>=(f[j>>2]|0))break;Wa=ob+(kb<<2)|0;if(!(b[qb+kb>>0]|0)){f[Wa>>2]=0;Sa=f[ec>>2]|0;f[ec>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=ec+8|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(kb|0)?kb:db;db=ec+4|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(ib|0)?ib:Sa;Sa=ec+12|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(ib|0)?ib:db;db=ec+16|0;f[db>>2]=(f[db>>2]|0)+1;db=fc;Sa=UIc(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=fc;f[db>>2]=Sa;f[db+4>>2]=J;db=fc+8|0;Sa=db;Xa=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=db;f[Sa>>2]=Xa;f[Sa+4>>2]=J;break}else{f[Wa>>2]=cb;Wa=ec+(Y(f[f[n>>2]>>2]|0,cb)|0)|0;Sa=f[Wa>>2]|0;f[Wa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Wa+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(kb|0)?kb:Xa;Xa=Wa+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(ib|0)?ib:Sa;Sa=Wa+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(ib|0)?ib:Xa;Xa=Wa+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(cb<<4)|0;Wa=Xa;Sa=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Wa=Xa;f[Wa>>2]=Sa;f[Wa+4>>2]=J;Wa=fc+(cb<<4)+8|0;Sa=Wa;Xa=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=Wa;f[Sa>>2]=Xa;f[Sa+4>>2]=J;break}}Sa=mb+(_a<<2)|0;if(!(b[lb+_a>>0]|0)){f[Sa>>2]=0;gc=0;hc=ec}else{f[Sa>>2]=cb;gc=cb;hc=ec+(Y(f[f[n>>2]>>2]|0,cb)|0)|0}Sa=f[hc>>2]|0;f[hc>>2]=(Sa|0)>(_a|0)?_a:Sa;Sa=hc+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(_a|0)?_a:Xa;Xa=hc+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=hc+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(tb|0)?tb:Xa;Xa=hc+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(gc<<4)|0;Sa=Xa;Wa=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;Sa=Xa;f[Sa>>2]=Wa;f[Sa+4>>2]=J;Sa=fc+(gc<<4)+8|0;Wa=Sa;Xa=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,tb|0,jb|0)|0;Wa=Sa;f[Wa>>2]=Xa;f[Wa+4>>2]=J;if((ib|0)<(f[j>>2]|0)){Wa=ob+(kb<<2)|0;if(!(b[qb+kb>>0]|0)){f[Wa>>2]=0;ic=0;jc=ec}else{f[Wa>>2]=cb;ic=cb;jc=ec+(Y(f[f[n>>2]>>2]|0,cb)|0)|0}Wa=f[jc>>2]|0;f[jc>>2]=(Wa|0)>(kb|0)?kb:Wa;Wa=jc+8|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)<(kb|0)?kb:Xa;Xa=jc+4|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)>(ib|0)?ib:Wa;Wa=jc+12|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)<(ib|0)?ib:Xa;Xa=jc+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(ic<<4)|0;Wa=Xa;Sa=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Wa=Xa;f[Wa>>2]=Sa;f[Wa+4>>2]=J;Wa=fc+(ic<<4)+8|0;Sa=Wa;Xa=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=Wa;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Sa=ob+(_a<<2)|0;if(!(b[qb+_a>>0]|0)){f[Sa>>2]=0;Xa=f[ec>>2]|0;f[ec>>2]=(Xa|0)>(_a|0)?_a:Xa;Xa=ec+8|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)<(_a|0)?_a:Wa;Wa=ec+4|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)>(ib|0)?ib:Xa;Xa=ec+12|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)<(ib|0)?ib:Wa;Wa=ec+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=fc;Xa=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;Wa=fc;f[Wa>>2]=Xa;f[Wa+4>>2]=J;Wa=fc+8|0;Xa=Wa;db=UIc(f[Xa>>2]|0,f[Xa+4>>2]|0,ib|0,nb|0)|0;Xa=Wa;f[Xa>>2]=db;f[Xa+4>>2]=J;break}else{f[Sa>>2]=cb;Sa=ec+(Y(f[f[n>>2]>>2]|0,cb)|0)|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)>(_a|0)?_a:Xa;Xa=Sa+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(_a|0)?_a:db;db=Sa+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(ib|0)?ib:Xa;Xa=Sa+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(ib|0)?ib:db;db=Sa+16|0;f[db>>2]=(f[db>>2]|0)+1;db=fc+(cb<<4)|0;Sa=db;Xa=UIc(f[Sa>>2]|0,f[Sa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;_a=db;f[_a>>2]=Xa;f[_a+4>>2]=J;_a=fc+(cb<<4)+8|0;cb=_a;Xa=UIc(f[cb>>2]|0,f[cb+4>>2]|0,ib|0,nb|0)|0;cb=_a;f[cb>>2]=Xa;f[cb+4>>2]=J;break}}}else{f[hb>>2]=0;cb=f[vb>>2]|0;Xa=f[cb>>2]|0;f[cb>>2]=(Xa|0)>(kb|0)?kb:Xa;Xa=cb+8|0;_a=f[Xa>>2]|0;f[Xa>>2]=(_a|0)<(kb|0)?kb:_a;_a=cb+4|0;db=f[_a>>2]|0;f[_a>>2]=(db|0)>(tb|0)?tb:db;db=cb+12|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)<(tb|0)?tb:Sa;Sa=cb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Wa=f[ub>>2]|0;ab=((kb|0)<0)<<31>>31;H=Wa;Ua=UIc(f[H>>2]|0,f[H+4>>2]|0,kb|0,ab|0)|0;H=J;Va=Wa;f[Va>>2]=Ua;f[Va+4>>2]=H;Va=Wa+8|0;bb=Va;$a=UIc(f[bb>>2]|0,f[bb+4>>2]|0,tb|0,jb|0)|0;bb=J;G=Va;f[G>>2]=$a;f[G+4>>2]=bb;G=kb|1;if((G|0)<(f[o>>2]|0)){f[mb+(G<<2)>>2]=0;Za=f[cb>>2]|0;f[cb>>2]=(Za|0)>(G|0)?G:Za;Za=f[Xa>>2]|0;f[Xa>>2]=(Za|0)<(G|0)?G:Za;Za=f[_a>>2]|0;f[_a>>2]=(Za|0)>(tb|0)?tb:Za;Za=f[db>>2]|0;f[db>>2]=(Za|0)<(tb|0)?tb:Za;f[Sa>>2]=(f[Sa>>2]|0)+1;Za=((G|0)<0)<<31>>31;Ya=UIc(Ua|0,H|0,G|0,Za|0)|0;fb=J;Pa=Wa;f[Pa>>2]=Ya;f[Pa+4>>2]=fb;Pa=UIc($a|0,bb|0,tb|0,jb|0)|0;eb=J;Qa=Va;f[Qa>>2]=Pa;f[Qa+4>>2]=eb;if((ib|0)>=(f[j>>2]|0))break;f[ob+(kb<<2)>>2]=0;f[ob+(G<<2)>>2]=0;Qa=f[cb>>2]|0;Ra=(Qa|0)>(kb|0)?kb:Qa;Qa=f[Xa>>2]|0;Ta=(Qa|0)<(kb|0)?kb:Qa;Qa=f[_a>>2]|0;Oa=f[db>>2]|0;Na=f[Sa>>2]|0;Ma=UIc(Ya|0,fb|0,kb|0,ab|0)|0;fb=J;Ya=UIc(Pa|0,eb|0,ib|0,nb|0)|0;eb=J;f[cb>>2]=(Ra|0)>(G|0)?G:Ra;f[Xa>>2]=(Ta|0)<(G|0)?G:Ta;f[_a>>2]=(Qa|0)>(ib|0)?ib:Qa;f[db>>2]=(Oa|0)<(ib|0)?ib:Oa;f[Sa>>2]=Na+2;Na=UIc(Ma|0,fb|0,G|0,Za|0)|0;Za=Wa;f[Za>>2]=Na;f[Za+4>>2]=J;Za=UIc(Ya|0,eb|0,ib|0,nb|0)|0;eb=Va;f[eb>>2]=Za;f[eb+4>>2]=J;break}else{if((ib|0)>=(f[j>>2]|0))break;f[ob+(kb<<2)>>2]=0;eb=f[cb>>2]|0;f[cb>>2]=(eb|0)>(kb|0)?kb:eb;eb=f[Xa>>2]|0;f[Xa>>2]=(eb|0)<(kb|0)?kb:eb;eb=f[_a>>2]|0;f[_a>>2]=(eb|0)>(ib|0)?ib:eb;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(ib|0)?ib:eb;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=UIc(Ua|0,H|0,kb|0,ab|0)|0;ab=Wa;f[ab>>2]=Sa;f[ab+4>>2]=J;ab=UIc($a|0,bb|0,ib|0,nb|0)|0;bb=Va;f[bb>>2]=ab;f[bb+4>>2]=J;break}}while(0);kb=kb+2|0;kc=f[o>>2]|0}while((kb|0)<(kc|0));lc=f[j>>2]|0;mc=kc}else{lc=rb;mc=sb}tb=tb+2|0;if((tb|0)>=(lc|0))break;else{sb=mc;rb=lc}}}}while(0);lc=g+12|0;if((f[lc>>2]|0)<=0){g0(h);u=a;return zb|0}mc=f[g+20>>2]|0;kc=f[g+48>>2]|0;j=f[g+120>>2]|0;o=f[g+80>>2]|0;fc=f[g+108>>2]|0;g=0;do{ec=mc+(Y(f[kc>>2]|0,g)|0)|0;ic=ec+8|0;f[ic>>2]=(f[ic>>2]|0)+1-(f[ec>>2]|0);ic=ec+12|0;f[ic>>2]=(f[ic>>2]|0)+1-(f[ec+4>>2]|0);ic=o+(Y(f[fc>>2]|0,g)|0)|0;nc=+((f[ec+16>>2]|0)>>>0);ec=j+(g<<4)|0;p[ic>>3]=(+((f[ec>>2]|0)>>>0)+4294967296.0*+((f[ec+4>>2]|0)>>>0))/nc;ec=j+(g<<4)+8|0;p[ic+8>>3]=(+((f[ec>>2]|0)>>>0)+4294967296.0*+((f[ec+4>>2]|0)>>>0))/nc;g=g+1|0}while((g|0)<(f[lc>>2]|0));g0(h);u=a;return zb|0}function Vaa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;a=u;u=u+64|0;h=a+48|0;i=a+28|0;j=a;k=f[c+8>>2]|0;l=d+8|0;if((k|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,26)|0;n=250083;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,2526)}q=f[c+12>>2]|0;if((q|0)!=(f[d+12>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,26)|0;n=250110;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,2527)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;m=tT(h,17)|0;n=250137;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));taa(-215,h,518189,2528)}n=(q+1|0)/2|0;q=f0(k<<2)|0;e=f0((Y(((k+1|0)/2|0)<<2,n)|0)+4|0)|0;f[e>>2]=0;f[h>>2]=0;f[h+4>>2]=k;r=(k|0)/2|0;s=(z8()|0)<<2;t=(s|0)<(r|0)?s:r;v=+(((t|0)>1?t:1)|0);f[i>>2]=46900;f[i+4>>2]=c;f[i+8>>2]=d;f[i+12>>2]=e;f[i+16>>2]=q;y8(h,i,v);Waa(c,d,e,q);f[i>>2]=1;if((k|0)>0){t=0;do{r=t+1|0;s=(Y((r|0)/2|0,n)|0)+1|0;w=f[q+(r<<2)>>2]|0;r=w+s|0;if((w|0)>0){w=s;do{s=e+(w<<2)|0;x=f[s>>2]|0;if((x|0)<(w|0))f[s>>2]=f[e+(x<<2)>>2];else{f[s>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}w=w+1|0}while((w|0)<(r|0))}t=f[q+(t<<2)>>2]|0}while((t|0)<(k|0))}t=k*136|0;n=XDc(k>>>0>31580641|t>>>0>4294967291?-1:t+4|0)|0;f[n>>2]=k;t=n+4|0;if(k|0){r=t+(k*136|0)|0;k=t;do{f[k>>2]=0;f[k+4>>2]=1124007936;w=k+12|0;s=k+44|0;m=k+8|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[s>>2]=w;x=k+52|0;f[k+48>>2]=x;f[x>>2]=0;f[k+56>>2]=0;f[k+60>>2]=0;f[k+64>>2]=1124007936;x=k+72|0;y=k+104|0;m=k+68|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[y>>2]=x;w=k+112|0;f[k+108>>2]=w;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;k=k+136|0}while((k|0)!=(r|0))}Xaa(g,f[i>>2]|0);f[j>>2]=46920;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=e;f[j+16>>2]=g;f[j+20>>2]=t;f[j+24>>2]=i;y8(h,j,v);j=f[l>>2]|0;l=f[g+132>>2]|0;if((l|0)<(j|0)){h=g+20|0;d=g+48|0;c=g+120|0;r=l;l=f[i>>2]|0;while(1){if((l|0)>0){k=t+(r*136|0)+120|0;m=f[t+(r*136|0)+20>>2]|0;o=f[t+(r*136|0)+48>>2]|0;w=0;s=l;while(1){z=m+(Y(f[o>>2]|0,w)|0)|0;A=z+16|0;if((f[A>>2]|0)>0){B=(f[h>>2]|0)+(Y(f[f[d>>2]>>2]|0,w)|0)|0;C=f[B>>2]|0;D=f[z>>2]|0;f[B>>2]=(C|0)>(D|0)?D:C;C=B+8|0;f[C>>2]=f[((f[C>>2]|0)<(f[z+8>>2]|0)?z:B)+8>>2];C=B+4|0;f[C>>2]=f[((f[C>>2]|0)>(f[z+4>>2]|0)?z:B)+4>>2];C=B+12|0;f[C>>2]=f[((f[C>>2]|0)<(f[z+12>>2]|0)?z:B)+12>>2];z=B+16|0;f[z>>2]=(f[z>>2]|0)+(f[A>>2]|0);A=f[k>>2]|0;z=A+(w<<4)|0;B=f[c>>2]|0;C=B+(w<<4)|0;D=C;E=UIc(f[D>>2]|0,f[D+4>>2]|0,f[z>>2]|0,f[z+4>>2]|0)|0;z=C;f[z>>2]=E;f[z+4>>2]=J;z=A+(w<<4)+8|0;A=B+(w<<4)+8|0;B=A;E=UIc(f[B>>2]|0,f[B+4>>2]|0,f[z>>2]|0,f[z+4>>2]|0)|0;z=A;f[z>>2]=E;f[z+4>>2]=J;F=f[i>>2]|0}else F=s;w=w+1|0;if((w|0)>=(F|0)){G=F;break}else s=F}}else G=l;r=f[t+(r*136|0)+132>>2]|0;if((r|0)>=(j|0))break;else l=G}}G=g+12|0;if((f[G>>2]|0)>0){l=f[g+20>>2]|0;j=f[g+48>>2]|0;r=f[g+120>>2]|0;F=f[g+80>>2]|0;c=f[g+108>>2]|0;g=0;do{d=l+(Y(f[j>>2]|0,g)|0)|0;h=d+8|0;f[h>>2]=(f[h>>2]|0)+1-(f[d>>2]|0);h=d+12|0;f[h>>2]=(f[h>>2]|0)+1-(f[d+4>>2]|0);h=F+(Y(f[c>>2]|0,g)|0)|0;v=+((f[d+16>>2]|0)>>>0);d=r+(g<<4)|0;p[h>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/v;d=r+(g<<4)+8|0;p[h+8>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/v;g=g+1|0}while((g|0)<(f[G>>2]|0))}G=t+((f[n>>2]|0)*136|0)|0;if((t|0)==(G|0)){ZDc(n);g0(q);g0(e);H=f[i>>2]|0;u=a;return H|0}else I=G;do{I=I+-136|0;Paa(I)}while((I|0)!=(t|0));ZDc(n);g0(q);g0(e);H=f[i>>2]|0;u=a;return H|0}function Waa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[c+12>>2]|0;h=f[c+8>>2]|0;i=f[e>>2]|0;if((i|0)>=(h|0))return;j=(g|0)>0;k=g+-1|0;l=g+-2|0;m=f[c+16>>2]|0;n=f[c+44>>2]|0;c=f[a+16>>2]|0;o=f[a+44>>2]|0;a=i;do{i=f[n>>2]|0;p=m+(Y(i,a)|0)|0;q=0-i|0;i=p+q+q|0;q=f[o>>2]|0;r=c+(Y(q,a)|0)|0;s=r+(0-q)|0;if(j){q=0;do{t=p+(q<<2)|0;u=f[t>>2]|0;if((u|0)>0){if((((q|0)>1?(v=f[i+(q+-2<<2)>>2]|0,(v|0)>0):0)?(b[r+q>>0]|0)!=0:0)?(b[s+(q+-1)>>0]|0)!=0:0){w=v;while(1){x=f[d+(w<<2)>>2]|0;if((x|0)<(w|0))w=x;else break}if((v|0)==(u|0))y=w;else{x=u;while(1){z=f[d+(x<<2)>>2]|0;if((z|0)<(x|0))x=z;else break}z=(w|0)>(x|0)?x:w;A=u;do{B=d+(A<<2)|0;C=A;A=f[B>>2]|0;f[B>>2]=z}while((A|0)<(C|0));y=z}z=v;do{A=d+(z<<2)|0;w=z;z=f[A>>2]|0;f[A>>2]=y}while((z|0)<(w|0));f[t>>2]=y;D=y}else D=u;z=f[i+(q<<2)>>2]|0;a:do if((z|0)>0){v=b[r+q>>0]|0;w=v<<24>>24!=0;if((q|0)>=(k|0)){if(!w){E=D;break}if(!(b[s+q>>0]|0)){E=D;break}else F=z;while(1){A=f[d+(F<<2)>>2]|0;if((A|0)<(F|0))F=A;else break}if((z|0)==(D|0))G=F;else{A=D;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<(A|0))A=x;else break}x=(F|0)>(A|0)?A:F;C=D;do{B=d+(C<<2)|0;H=C;C=f[B>>2]|0;f[B>>2]=x}while((C|0)<(H|0));G=x}x=z;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=G}while((x|0)<(A|0));f[t>>2]=G;E=G;break}if(w?(b[s+q>>0]|0)!=0:0)I=z;else J=23;do if((J|0)==23){J=0;x=q|1;A=(b[r+x>>0]|0)!=0;if(A?b[s+q>>0]|0:0){I=z;break}if(v<<24>>24?b[s+x>>0]|0:0){I=z;break}if(!A){E=D;break a}if(!(b[s+x>>0]|0)){E=D;break a}else I=z}while(0);while(1){v=f[d+(I<<2)>>2]|0;if((v|0)<(I|0))I=v;else break}if((z|0)==(D|0))K=I;else{v=D;while(1){w=f[d+(v<<2)>>2]|0;if((w|0)<(v|0))v=w;else break}w=(I|0)>(v|0)?v:I;x=D;do{A=d+(x<<2)|0;C=x;x=f[A>>2]|0;f[A>>2]=w}while((x|0)<(C|0));K=w}w=z;do{x=d+(w<<2)|0;v=w;w=f[x>>2]|0;f[x>>2]=K}while((w|0)<(v|0));f[t>>2]=K;E=K}else E=D;while(0);if((((q|0)<(l|0)?(z=q+2|0,u=f[i+(z<<2)>>2]|0,(u|0)>0):0)?b[r+(q|1)>>0]|0:0)?b[s+z>>0]|0:0){z=u;while(1){w=f[d+(z<<2)>>2]|0;if((w|0)<(z|0))z=w;else break}if((u|0)==(E|0))L=z;else{w=E;while(1){v=f[d+(w<<2)>>2]|0;if((v|0)<(w|0))w=v;else break}v=(z|0)>(w|0)?w:z;x=E;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=v}while((x|0)<(A|0));L=v}v=u;do{x=d+(v<<2)|0;z=v;v=f[x>>2]|0;f[x>>2]=L}while((v|0)<(z|0));f[t>>2]=L}}q=q+2|0}while((q|0)<(g|0))}a=f[e+(a<<2)>>2]|0}while((a|0)<(h|0));return}function Xaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+80|0;d=c+64|0;e=c;g=c+56|0;h=f[a>>2]|0;f[d>>2]=5;f[d+4>>2]=b;v$(h,d,4,-1,0,0);d=f[a>>2]|0;do if((d$(d)|0)==65536){h=f[d+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;ZS(e,h);break}}else a$(e,d,-1);while(0);d=a+4|0;h=e+36|0;i=f[h>>2]|0;if((d|0)==(e|0))n=i;else{if(i|0){j=i+12|0;f[j>>2]=(f[j>>2]|0)+1}j=a+40|0;i=f[j>>2]|0;if(i|0?(k=i+12|0,i=f[k>>2]|0,f[k>>2]=i+-1,(i|0)==1):0)_S(d);f[j>>2]=0;i=a+20|0;k=a+8|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[k>>2]|0)>0){m=f[a+44>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0;o=f[k>>2]|0}while((l|0)<(o|0));f[d>>2]=f[e>>2];if((o|0)<3)p=19;else p=21}else{f[d>>2]=f[e>>2];p=19}if((p|0)==19){o=f[e+4>>2]|0;if((o|0)<3){f[k>>2]=o;f[a+12>>2]=f[e+8>>2];f[a+16>>2]=f[e+12>>2];o=f[e+44>>2]|0;k=f[a+48>>2]|0;f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2]}else p=21}if((p|0)==21)ZS(d,e);f[i>>2]=f[e+16>>2];f[a+24>>2]=f[e+20>>2];f[a+28>>2]=f[e+24>>2];f[a+32>>2]=f[e+28>>2];f[a+36>>2]=f[e+32>>2];i=f[h>>2]|0;f[j>>2]=i;n=i}if(n|0?(i=n+12|0,n=f[i>>2]|0,f[i>>2]=n+-1,(n|0)==1):0)_S(e);f[h>>2]=0;h=e+16|0;n=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[n>>2]|0)>0){h=f[e+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[n>>2]|0))}n=f[e+44>>2]|0;if((n|0)!=(e+48|0))g0(n);n=a+60|0;i=f[n>>2]|0;f[g>>2]=2;f[g+4>>2]=b;v$(i,g,6,-1,0,0);g=f[n>>2]|0;do if((d$(g)|0)==65536){n=f[g+4>>2]|0;f[e>>2]=f[n>>2];i=e+4|0;h=n+4|0;f[i>>2]=f[h>>2];j=e+8|0;f[j>>2]=f[n+8>>2];f[e+12>>2]=f[n+12>>2];f[e+16>>2]=f[n+16>>2];f[e+20>>2]=f[n+20>>2];f[e+24>>2]=f[n+24>>2];f[e+28>>2]=f[n+28>>2];f[e+32>>2]=f[n+32>>2];d=f[n+36>>2]|0;f[e+36>>2]=d;f[e+40>>2]=j;j=e+48|0;o=e+44|0;f[o>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if(d|0){j=d+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[h>>2]|0)<3){h=f[n+44>>2]|0;j=f[o>>2]|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];break}else{f[i>>2]=0;ZS(e,n);break}}else a$(e,g,-1);while(0);g=a+64|0;n=e+36|0;i=f[n>>2]|0;if((g|0)==(e|0))q=i;else{if(i|0){h=i+12|0;f[h>>2]=(f[h>>2]|0)+1}h=a+100|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)_S(g);f[h>>2]=0;i=a+80|0;j=a+68|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){o=f[a+104>>2]|0;d=0;do{f[o+(d<<2)>>2]=0;d=d+1|0;r=f[j>>2]|0}while((d|0)<(r|0));f[g>>2]=f[e>>2];if((r|0)<3)p=49;else p=51}else{f[g>>2]=f[e>>2];p=49}if((p|0)==49){r=f[e+4>>2]|0;if((r|0)<3){f[j>>2]=r;f[a+72>>2]=f[e+8>>2];f[a+76>>2]=f[e+12>>2];r=f[e+44>>2]|0;j=f[a+108>>2]|0;f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2]}else p=51}if((p|0)==51)ZS(g,e);f[i>>2]=f[e+16>>2];f[a+84>>2]=f[e+20>>2];f[a+88>>2]=f[e+24>>2];f[a+92>>2]=f[e+28>>2];f[a+96>>2]=f[e+32>>2];i=f[n>>2]|0;f[h>>2]=i;q=i}if(q|0?(i=q+12|0,q=f[i>>2]|0,f[i>>2]=q+-1,(q|0)==1):0)_S(e);f[n>>2]=0;n=e+16|0;q=e+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[q>>2]|0)>0){n=f[e+40>>2]|0;i=0;do{f[n+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}q=f[e+44>>2]|0;if((q|0)!=(e+48|0))g0(q);if((b|0)>0){q=f[a+20>>2]|0;i=f[a+48>>2]|0;n=0;do{h=q+(Y(f[i>>2]|0,n)|0)|0;f[h>>2]=2147483647;f[h+4>>2]=2147483647;f[h+8>>2]=-2147483648;f[h+12>>2]=-2147483648;f[h+16>>2]=0;n=n+1|0}while((n|0)!=(b|0))}n=a+120|0;i=a+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;a=f[i>>2]|0;q=f[n>>2]|0;h=a-q>>4;g=a;if(h>>>0<b>>>0){$aa(n,b-h|0,e);u=c;return}if(h>>>0<=b>>>0){u=c;return}h=q+(b<<4)|0;if((g|0)==(h|0)){u=c;return}f[i>>2]=g+(~((g+-16-h|0)>>>4)<<4);u=c;return}function Yaa(a){a=a|0;YDc(a);return}function Zaa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=f[c+4>>2]|0;c=((d|0)%2|0)+d|0;if((e|0)>0){d=a+20|0;_aa((f[d>>2]|0)+(e*136|0)|0,f[f[a+24>>2]>>2]|0);g=f[d>>2]|0;f[g+(e*136|0)+132>>2]=c;d=a+8|0;h=f[d>>2]|0;i=f[h+12>>2]|0;j=(i&1|0)!=0;k=(e|0)<(c|0);if(!(f[h+8>>2]&1)){if(!j){if(!k)return;l=a+4|0;m=a+12|0;n=g+(e*136|0)+20|0;o=g+(e*136|0)+120|0;p=g+(e*136|0)+20|0;q=g+(e*136|0)+48|0;r=g+(e*136|0)+48|0;s=g+(e*136|0)+48|0;t=g+(e*136|0)+20|0;u=g+(e*136|0)+48|0;v=g+(e*136|0)+120|0;w=g+(e*136|0)+20|0;x=g+(e*136|0)+120|0;y=e;z=h;A=i;while(1){B=f[l>>2]|0;C=f[f[B+44>>2]>>2]|0;D=(f[B+16>>2]|0)+(Y(C,y)|0)|0;B=D+C|0;C=f[f[z+44>>2]>>2]|0;E=(f[z+16>>2]|0)+(Y(C,y)|0)|0;F=E+C|0;if((A|0)>0){C=((y|0)<0)<<31>>31;G=y+1|0;H=((G|0)<0)<<31>>31;I=0;do{K=E+(I<<2)|0;L=f[K>>2]|0;do if((L|0)>0){M=f[(f[m>>2]|0)+(L<<2)>>2]|0;if(!(b[D+I>>0]|0)){f[K>>2]=0;N=f[n>>2]|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(I|0)?I:O;O=N+8|0;P=f[O>>2]|0;f[O>>2]=(P|0)<(I|0)?I:P;P=N+4|0;O=f[P>>2]|0;f[P>>2]=(O|0)>(y|0)?y:O;O=N+12|0;P=f[O>>2]|0;f[O>>2]=(P|0)<(y|0)?y:P;P=N+16|0;f[P>>2]=(f[P>>2]|0)+1;P=f[o>>2]|0;O=P;Q=UIc(f[O>>2]|0,f[O+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;O=P;f[O>>2]=Q;f[O+4>>2]=J;R=P+8|0;S=N;T=P}else{f[K>>2]=M;P=f[t>>2]|0;N=P+(Y(f[f[u>>2]>>2]|0,M)|0)|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(I|0)?I:O;O=N+8|0;Q=f[O>>2]|0;f[O>>2]=(Q|0)<(I|0)?I:Q;Q=N+4|0;O=f[Q>>2]|0;f[Q>>2]=(O|0)>(y|0)?y:O;O=N+12|0;Q=f[O>>2]|0;f[O>>2]=(Q|0)<(y|0)?y:Q;Q=N+16|0;f[Q>>2]=(f[Q>>2]|0)+1;Q=f[v>>2]|0;N=Q+(M<<4)|0;O=N;U=UIc(f[O>>2]|0,f[O+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;O=N;f[O>>2]=U;f[O+4>>2]=J;R=Q+(M<<4)+8|0;S=P;T=Q}Q=R;P=UIc(f[Q>>2]|0,f[Q+4>>2]|0,y|0,C|0)|0;Q=R;f[Q>>2]=P;f[Q+4>>2]=J;Q=I|1;P=E+(Q<<2)|0;if(!(b[D+Q>>0]|0)){f[P>>2]=0;V=0;W=S}else{f[P>>2]=M;V=M;W=S+(Y(f[f[s>>2]>>2]|0,M)|0)|0}P=f[W>>2]|0;f[W>>2]=(P|0)>(Q|0)?Q:P;P=W+8|0;O=f[P>>2]|0;f[P>>2]=(O|0)<(Q|0)?Q:O;O=W+4|0;P=f[O>>2]|0;f[O>>2]=(P|0)>(y|0)?y:P;P=W+12|0;O=f[P>>2]|0;f[P>>2]=(O|0)<(y|0)?y:O;O=W+16|0;f[O>>2]=(f[O>>2]|0)+1;O=T+(V<<4)|0;P=O;U=UIc(f[P>>2]|0,f[P+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;P=O;f[P>>2]=U;f[P+4>>2]=J;P=T+(V<<4)+8|0;U=P;O=UIc(f[U>>2]|0,f[U+4>>2]|0,y|0,C|0)|0;U=P;f[U>>2]=O;f[U+4>>2]=J;U=F+(I<<2)|0;if(!(b[B+I>>0]|0)){f[U>>2]=0;X=0;Z=S}else{f[U>>2]=M;X=M;Z=S+(Y(f[f[r>>2]>>2]|0,M)|0)|0}U=f[Z>>2]|0;f[Z>>2]=(U|0)>(I|0)?I:U;U=Z+8|0;O=f[U>>2]|0;f[U>>2]=(O|0)<(I|0)?I:O;O=Z+4|0;U=f[O>>2]|0;f[O>>2]=(U|0)>(G|0)?G:U;U=Z+12|0;O=f[U>>2]|0;f[U>>2]=(O|0)<(G|0)?G:O;O=Z+16|0;f[O>>2]=(f[O>>2]|0)+1;O=T+(X<<4)|0;U=O;P=UIc(f[U>>2]|0,f[U+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;U=O;f[U>>2]=P;f[U+4>>2]=J;U=T+(X<<4)+8|0;P=U;O=UIc(f[P>>2]|0,f[P+4>>2]|0,G|0,H|0)|0;P=U;f[P>>2]=O;f[P+4>>2]=J;P=F+(Q<<2)|0;O=f[p>>2]|0;if(!(b[B+Q>>0]|0)){f[P>>2]=0;U=f[O>>2]|0;f[O>>2]=(U|0)>(Q|0)?Q:U;U=O+8|0;N=f[U>>2]|0;f[U>>2]=(N|0)<(Q|0)?Q:N;N=O+4|0;U=f[N>>2]|0;f[N>>2]=(U|0)>(G|0)?G:U;U=O+12|0;N=f[U>>2]|0;f[U>>2]=(N|0)<(G|0)?G:N;N=O+16|0;f[N>>2]=(f[N>>2]|0)+1;N=T;U=UIc(f[N>>2]|0,f[N+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;N=T;f[N>>2]=U;f[N+4>>2]=J;_=T+8|0;break}else{f[P>>2]=M;P=O+(Y(f[f[q>>2]>>2]|0,M)|0)|0;O=f[P>>2]|0;f[P>>2]=(O|0)>(Q|0)?Q:O;O=P+8|0;N=f[O>>2]|0;f[O>>2]=(N|0)<(Q|0)?Q:N;N=P+4|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(G|0)?G:O;O=P+12|0;N=f[O>>2]|0;f[O>>2]=(N|0)<(G|0)?G:N;N=P+16|0;f[N>>2]=(f[N>>2]|0)+1;N=T+(M<<4)|0;P=N;O=UIc(f[P>>2]|0,f[P+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;Q=N;f[Q>>2]=O;f[Q+4>>2]=J;_=T+(M<<4)+8|0;break}}else{f[K>>2]=0;M=I|1;f[E+(M<<2)>>2]=0;f[F+(I<<2)>>2]=0;f[F+(M<<2)>>2]=0;Q=f[w>>2]|0;O=f[Q>>2]|0;N=(O|0)>(I|0)?I:O;O=Q+8|0;P=f[O>>2]|0;U=(P|0)<(I|0)?I:P;P=Q+4|0;$=f[P>>2]|0;aa=($|0)>(y|0)?y:$;$=Q+12|0;ba=f[$>>2]|0;ca=(ba|0)<(y|0)?y:ba;ba=Q+16|0;da=f[ba>>2]|0;ea=f[x>>2]|0;fa=((I|0)<0)<<31>>31;ga=ea;ha=UIc(f[ga>>2]|0,f[ga+4>>2]|0,I|0,fa|0)|0;ga=J;ia=ea+8|0;ja=ia;ka=UIc(f[ja>>2]|0,f[ja+4>>2]|0,y|0,C|0)|0;ja=J;la=(N|0)>(M|0)?M:N;N=((M|0)<0)<<31>>31;ma=UIc(ha|0,ga|0,M|0,N|0)|0;ga=J;ha=UIc(ka|0,ja|0,y|0,C|0)|0;ja=J;ka=UIc(ma|0,ga|0,I|0,fa|0)|0;fa=J;ga=UIc(ha|0,ja|0,G|0,H|0)|0;ja=ia;f[ja>>2]=ga;f[ja+4>>2]=J;f[Q>>2]=(la|0)>(I|0)?I:la;f[O>>2]=(U|0)<(M|0)?M:U;f[P>>2]=(aa|0)>(G|0)?G:aa;f[$>>2]=(ca|0)<(G|0)?G:ca;f[ba>>2]=da+4;da=UIc(ka|0,fa|0,M|0,N|0)|0;N=ea;f[N>>2]=da;f[N+4>>2]=J;_=ia}while(0);K=_;L=UIc(f[K>>2]|0,f[K+4>>2]|0,G|0,H|0)|0;K=_;f[K>>2]=L;f[K+4>>2]=J;I=I+2|0;K=f[d>>2]|0;L=f[K+12>>2]|0}while((I|0)<(L|0));na=L;oa=K}else{na=A;oa=z}y=y+2|0;if((y|0)>=(c|0))break;else{z=oa;A=na}}return}if(!k)return;na=a+4|0;A=a+12|0;oa=g+(e*136|0)+20|0;z=g+(e*136|0)+120|0;y=g+(e*136|0)+20|0;_=g+(e*136|0)+48|0;x=g+(e*136|0)+48|0;w=g+(e*136|0)+48|0;T=g+(e*136|0)+20|0;q=g+(e*136|0)+48|0;p=g+(e*136|0)+120|0;X=g+(e*136|0)+20|0;Z=g+(e*136|0)+120|0;r=e;S=h;V=i;while(1){W=f[na>>2]|0;s=f[f[W+44>>2]>>2]|0;R=(f[W+16>>2]|0)+(Y(s,r)|0)|0;W=R+s|0;s=f[f[S+44>>2]>>2]|0;v=(f[S+16>>2]|0)+(Y(s,r)|0)|0;u=v+s|0;if((V|0)>0){s=((r|0)<0)<<31>>31;t=r+1|0;o=((t|0)<0)<<31>>31;n=0;do{m=v+(n<<2)|0;l=f[m>>2]|0;do if((l|0)>0){I=f[(f[A>>2]|0)+(l<<2)>>2]|0;if(!(b[R+n>>0]|0)){f[m>>2]=0;H=f[oa>>2]|0;G=f[H>>2]|0;f[H>>2]=(G|0)>(n|0)?n:G;G=H+8|0;C=f[G>>2]|0;f[G>>2]=(C|0)<(n|0)?n:C;C=H+4|0;G=f[C>>2]|0;f[C>>2]=(G|0)>(r|0)?r:G;G=H+12|0;C=f[G>>2]|0;f[G>>2]=(C|0)<(r|0)?r:C;C=H+16|0;f[C>>2]=(f[C>>2]|0)+1;C=f[z>>2]|0;G=C;F=UIc(f[G>>2]|0,f[G+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;G=C;f[G>>2]=F;f[G+4>>2]=J;pa=C+8|0;qa=H;ra=C}else{f[m>>2]=I;C=f[T>>2]|0;H=C+(Y(f[f[q>>2]>>2]|0,I)|0)|0;G=f[H>>2]|0;f[H>>2]=(G|0)>(n|0)?n:G;G=H+8|0;F=f[G>>2]|0;f[G>>2]=(F|0)<(n|0)?n:F;F=H+4|0;G=f[F>>2]|0;f[F>>2]=(G|0)>(r|0)?r:G;G=H+12|0;F=f[G>>2]|0;f[G>>2]=(F|0)<(r|0)?r:F;F=H+16|0;f[F>>2]=(f[F>>2]|0)+1;F=f[p>>2]|0;H=F+(I<<4)|0;G=H;E=UIc(f[G>>2]|0,f[G+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;G=H;f[G>>2]=E;f[G+4>>2]=J;pa=F+(I<<4)+8|0;qa=C;ra=F}F=pa;C=UIc(f[F>>2]|0,f[F+4>>2]|0,r|0,s|0)|0;F=pa;f[F>>2]=C;f[F+4>>2]=J;F=u+(n<<2)|0;if(!(b[W+n>>0]|0)){f[F>>2]=0;sa=0;ta=qa}else{f[F>>2]=I;sa=I;ta=qa+(Y(f[f[w>>2]>>2]|0,I)|0)|0}F=f[ta>>2]|0;f[ta>>2]=(F|0)>(n|0)?n:F;F=ta+8|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(n|0)?n:C;C=ta+4|0;F=f[C>>2]|0;f[C>>2]=(F|0)>(t|0)?t:F;F=ta+12|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(t|0)?t:C;C=ta+16|0;f[C>>2]=(f[C>>2]|0)+1;C=ra+(sa<<4)|0;F=C;G=UIc(f[F>>2]|0,f[F+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;F=C;f[F>>2]=G;f[F+4>>2]=J;F=ra+(sa<<4)+8|0;G=F;C=UIc(f[G>>2]|0,f[G+4>>2]|0,t|0,o|0)|0;G=F;f[G>>2]=C;f[G+4>>2]=J;G=n|1;if((G|0)<(f[(f[d>>2]|0)+12>>2]|0)){C=v+(G<<2)|0;if(!(b[R+G>>0]|0)){f[C>>2]=0;ua=0;va=qa}else{f[C>>2]=I;ua=I;va=qa+(Y(f[f[x>>2]>>2]|0,I)|0)|0}C=f[va>>2]|0;f[va>>2]=(C|0)>(G|0)?G:C;C=va+8|0;F=f[C>>2]|0;f[C>>2]=(F|0)<(G|0)?G:F;F=va+4|0;C=f[F>>2]|0;f[F>>2]=(C|0)>(r|0)?r:C;C=va+12|0;F=f[C>>2]|0;f[C>>2]=(F|0)<(r|0)?r:F;F=va+16|0;f[F>>2]=(f[F>>2]|0)+1;F=ra+(ua<<4)|0;C=F;E=UIc(f[C>>2]|0,f[C+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;C=F;f[C>>2]=E;f[C+4>>2]=J;C=ra+(ua<<4)+8|0;E=C;F=UIc(f[E>>2]|0,f[E+4>>2]|0,r|0,s|0)|0;E=C;f[E>>2]=F;f[E+4>>2]=J;E=u+(G<<2)|0;F=f[y>>2]|0;if(!(b[W+G>>0]|0)){f[E>>2]=0;C=f[F>>2]|0;f[F>>2]=(C|0)>(G|0)?G:C;C=F+8|0;H=f[C>>2]|0;f[C>>2]=(H|0)<(G|0)?G:H;H=F+4|0;C=f[H>>2]|0;f[H>>2]=(C|0)>(t|0)?t:C;C=F+12|0;H=f[C>>2]|0;f[C>>2]=(H|0)<(t|0)?t:H;H=F+16|0;f[H>>2]=(f[H>>2]|0)+1;H=ra;C=UIc(f[H>>2]|0,f[H+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;H=ra;f[H>>2]=C;f[H+4>>2]=J;H=ra+8|0;C=H;B=UIc(f[C>>2]|0,f[C+4>>2]|0,t|0,o|0)|0;C=H;f[C>>2]=B;f[C+4>>2]=J;break}else{f[E>>2]=I;E=F+(Y(f[f[_>>2]>>2]|0,I)|0)|0;F=f[E>>2]|0;f[E>>2]=(F|0)>(G|0)?G:F;F=E+8|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(G|0)?G:C;C=E+4|0;F=f[C>>2]|0;f[C>>2]=(F|0)>(t|0)?t:F;F=E+12|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(t|0)?t:C;C=E+16|0;f[C>>2]=(f[C>>2]|0)+1;C=ra+(I<<4)|0;E=C;F=UIc(f[E>>2]|0,f[E+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;G=C;f[G>>2]=F;f[G+4>>2]=J;G=ra+(I<<4)+8|0;I=G;F=UIc(f[I>>2]|0,f[I+4>>2]|0,t|0,o|0)|0;I=G;f[I>>2]=F;f[I+4>>2]=J;break}}}else{f[m>>2]=0;f[u+(n<<2)>>2]=0;I=f[X>>2]|0;F=f[I>>2]|0;G=I+8|0;C=f[G>>2]|0;E=I+4|0;B=f[E>>2]|0;H=(B|0)>(r|0)?r:B;B=I+12|0;D=f[B>>2]|0;K=(D|0)<(r|0)?r:D;D=I+16|0;L=f[D>>2]|0;ia=f[Z>>2]|0;N=((n|0)<0)<<31>>31;da=ia;ea=UIc(f[da>>2]|0,f[da+4>>2]|0,n|0,N|0)|0;da=J;M=ia+8|0;fa=M;ka=UIc(f[fa>>2]|0,f[fa+4>>2]|0,r|0,s|0)|0;fa=J;f[I>>2]=(F|0)>(n|0)?n:F;f[G>>2]=(C|0)<(n|0)?n:C;f[E>>2]=(H|0)>(t|0)?t:H;f[B>>2]=(K|0)<(t|0)?t:K;f[D>>2]=L+2;L=UIc(ea|0,da|0,n|0,N|0)|0;N=J;da=ia;f[da>>2]=L;f[da+4>>2]=N;da=UIc(ka|0,fa|0,t|0,o|0)|0;fa=J;ka=M;f[ka>>2]=da;f[ka+4>>2]=fa;ka=n|1;if((ka|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[v+(ka<<2)>>2]=0;f[u+(ka<<2)>>2]=0;ea=f[I>>2]|0;K=f[G>>2]|0;H=f[E>>2]|0;C=(H|0)>(r|0)?r:H;H=f[B>>2]|0;F=(H|0)<(r|0)?r:H;H=f[D>>2]|0;ba=((ka|0)<0)<<31>>31;ca=UIc(L|0,N|0,ka|0,ba|0)|0;N=J;L=UIc(da|0,fa|0,r|0,s|0)|0;fa=J;f[I>>2]=(ea|0)>(ka|0)?ka:ea;f[G>>2]=(K|0)<(ka|0)?ka:K;f[E>>2]=(C|0)>(t|0)?t:C;f[B>>2]=(F|0)<(t|0)?t:F;f[D>>2]=H+2;H=UIc(ca|0,N|0,ka|0,ba|0)|0;ba=ia;f[ba>>2]=H;f[ba+4>>2]=J;ba=UIc(L|0,fa|0,t|0,o|0)|0;fa=M;f[fa>>2]=ba;f[fa+4>>2]=J}}while(0);n=n+2|0;m=f[d>>2]|0;l=f[m+12>>2]|0}while((n|0)<(l|0));wa=l;xa=m}else{wa=V;xa=S}r=r+2|0;if((r|0)>=(c|0))break;else{S=xa;V=wa}}return}if(!j){if(!k)return;j=a+4|0;wa=a+12|0;V=g+(e*136|0)+20|0;xa=g+(e*136|0)+120|0;S=g+(e*136|0)+20|0;r=g+(e*136|0)+48|0;Z=g+(e*136|0)+48|0;X=g+(e*136|0)+48|0;ra=g+(e*136|0)+20|0;_=g+(e*136|0)+48|0;y=g+(e*136|0)+120|0;ua=g+(e*136|0)+20|0;va=g+(e*136|0)+120|0;x=e;qa=h;sa=i;while(1){ta=f[j>>2]|0;w=f[f[ta+44>>2]>>2]|0;pa=(f[ta+16>>2]|0)+(Y(w,x)|0)|0;ta=pa+w|0;w=f[f[qa+44>>2]>>2]|0;p=(f[qa+16>>2]|0)+(Y(w,x)|0)|0;q=p+w|0;if((sa|0)>0){w=((x|0)<0)<<31>>31;T=x+1|0;z=((T|0)<0)<<31>>31;oa=0;do{A=p+(oa<<2)|0;na=f[A>>2]|0;do if((na|0)>0){n=f[(f[wa>>2]|0)+(na<<2)>>2]|0;if(!(b[pa+oa>>0]|0)){f[A>>2]=0;o=f[V>>2]|0;t=f[o>>2]|0;f[o>>2]=(t|0)>(oa|0)?oa:t;t=o+8|0;s=f[t>>2]|0;f[t>>2]=(s|0)<(oa|0)?oa:s;s=o+4|0;t=f[s>>2]|0;f[s>>2]=(t|0)>(x|0)?x:t;t=o+12|0;s=f[t>>2]|0;f[t>>2]=(s|0)<(x|0)?x:s;s=o+16|0;f[s>>2]=(f[s>>2]|0)+1;s=f[xa>>2]|0;t=s;u=UIc(f[t>>2]|0,f[t+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;t=s;f[t>>2]=u;f[t+4>>2]=J;ya=s+8|0;za=o;Aa=s}else{f[A>>2]=n;s=f[ra>>2]|0;o=s+(Y(f[f[_>>2]>>2]|0,n)|0)|0;t=f[o>>2]|0;f[o>>2]=(t|0)>(oa|0)?oa:t;t=o+8|0;u=f[t>>2]|0;f[t>>2]=(u|0)<(oa|0)?oa:u;u=o+4|0;t=f[u>>2]|0;f[u>>2]=(t|0)>(x|0)?x:t;t=o+12|0;u=f[t>>2]|0;f[t>>2]=(u|0)<(x|0)?x:u;u=o+16|0;f[u>>2]=(f[u>>2]|0)+1;u=f[y>>2]|0;o=u+(n<<4)|0;t=o;v=UIc(f[t>>2]|0,f[t+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;t=o;f[t>>2]=v;f[t+4>>2]=J;ya=u+(n<<4)+8|0;za=s;Aa=u}u=ya;s=UIc(f[u>>2]|0,f[u+4>>2]|0,x|0,w|0)|0;u=ya;f[u>>2]=s;f[u+4>>2]=J;u=oa|1;s=p+(u<<2)|0;if(!(b[pa+u>>0]|0)){f[s>>2]=0;Ba=0;Ca=za}else{f[s>>2]=n;Ba=n;Ca=za+(Y(f[f[X>>2]>>2]|0,n)|0)|0}s=f[Ca>>2]|0;f[Ca>>2]=(s|0)>(u|0)?u:s;s=Ca+8|0;t=f[s>>2]|0;f[s>>2]=(t|0)<(u|0)?u:t;t=Ca+4|0;s=f[t>>2]|0;f[t>>2]=(s|0)>(x|0)?x:s;s=Ca+12|0;t=f[s>>2]|0;f[s>>2]=(t|0)<(x|0)?x:t;t=Ca+16|0;f[t>>2]=(f[t>>2]|0)+1;t=Aa+(Ba<<4)|0;s=t;v=UIc(f[s>>2]|0,f[s+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;s=t;f[s>>2]=v;f[s+4>>2]=J;s=Aa+(Ba<<4)+8|0;v=s;t=UIc(f[v>>2]|0,f[v+4>>2]|0,x|0,w|0)|0;v=s;f[v>>2]=t;f[v+4>>2]=J;if((T|0)<(f[(f[d>>2]|0)+8>>2]|0)){v=q+(oa<<2)|0;if(!(b[ta+oa>>0]|0)){f[v>>2]=0;Da=0;Ea=za}else{f[v>>2]=n;Da=n;Ea=za+(Y(f[f[Z>>2]>>2]|0,n)|0)|0}v=f[Ea>>2]|0;f[Ea>>2]=(v|0)>(oa|0)?oa:v;v=Ea+8|0;t=f[v>>2]|0;f[v>>2]=(t|0)<(oa|0)?oa:t;t=Ea+4|0;v=f[t>>2]|0;f[t>>2]=(v|0)>(T|0)?T:v;v=Ea+12|0;t=f[v>>2]|0;f[v>>2]=(t|0)<(T|0)?T:t;t=Ea+16|0;f[t>>2]=(f[t>>2]|0)+1;t=Aa+(Da<<4)|0;v=t;s=UIc(f[v>>2]|0,f[v+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;v=t;f[v>>2]=s;f[v+4>>2]=J;v=Aa+(Da<<4)+8|0;s=v;t=UIc(f[s>>2]|0,f[s+4>>2]|0,T|0,z|0)|0;s=v;f[s>>2]=t;f[s+4>>2]=J;s=q+(u<<2)|0;t=f[S>>2]|0;if(!(b[ta+u>>0]|0)){f[s>>2]=0;v=f[t>>2]|0;f[t>>2]=(v|0)>(u|0)?u:v;v=t+8|0;o=f[v>>2]|0;f[v>>2]=(o|0)<(u|0)?u:o;o=t+4|0;v=f[o>>2]|0;f[o>>2]=(v|0)>(T|0)?T:v;v=t+12|0;o=f[v>>2]|0;f[v>>2]=(o|0)<(T|0)?T:o;o=t+16|0;f[o>>2]=(f[o>>2]|0)+1;o=Aa;v=UIc(f[o>>2]|0,f[o+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;o=Aa;f[o>>2]=v;f[o+4>>2]=J;o=Aa+8|0;v=o;W=UIc(f[v>>2]|0,f[v+4>>2]|0,T|0,z|0)|0;v=o;f[v>>2]=W;f[v+4>>2]=J;break}else{f[s>>2]=n;s=t+(Y(f[f[r>>2]>>2]|0,n)|0)|0;t=f[s>>2]|0;f[s>>2]=(t|0)>(u|0)?u:t;t=s+8|0;v=f[t>>2]|0;f[t>>2]=(v|0)<(u|0)?u:v;v=s+4|0;t=f[v>>2]|0;f[v>>2]=(t|0)>(T|0)?T:t;t=s+12|0;v=f[t>>2]|0;f[t>>2]=(v|0)<(T|0)?T:v;v=s+16|0;f[v>>2]=(f[v>>2]|0)+1;v=Aa+(n<<4)|0;s=v;t=UIc(f[s>>2]|0,f[s+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;u=v;f[u>>2]=t;f[u+4>>2]=J;u=Aa+(n<<4)+8|0;n=u;t=UIc(f[n>>2]|0,f[n+4>>2]|0,T|0,z|0)|0;n=u;f[n>>2]=t;f[n+4>>2]=J;break}}}else{f[A>>2]=0;n=oa|1;f[p+(n<<2)>>2]=0;t=f[ua>>2]|0;u=f[t>>2]|0;v=(u|0)>(oa|0)?oa:u;u=t+8|0;s=f[u>>2]|0;W=(s|0)<(oa|0)?oa:s;s=t+4|0;o=f[s>>2]|0;R=t+12|0;m=f[R>>2]|0;l=t+16|0;fa=f[l>>2]|0;ba=f[va>>2]|0;M=((oa|0)<0)<<31>>31;L=ba;H=UIc(f[L>>2]|0,f[L+4>>2]|0,oa|0,M|0)|0;L=J;ia=ba+8|0;ka=ia;N=UIc(f[ka>>2]|0,f[ka+4>>2]|0,x|0,w|0)|0;ka=J;f[t>>2]=(v|0)>(n|0)?n:v;f[u>>2]=(W|0)<(n|0)?n:W;f[s>>2]=(o|0)>(x|0)?x:o;f[R>>2]=(m|0)<(x|0)?x:m;f[l>>2]=fa+2;fa=((n|0)<0)<<31>>31;m=UIc(H|0,L|0,n|0,fa|0)|0;L=J;H=ba;f[H>>2]=m;f[H+4>>2]=L;H=UIc(N|0,ka|0,x|0,w|0)|0;ka=J;N=ia;f[N>>2]=H;f[N+4>>2]=ka;if((T|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[q+(oa<<2)>>2]=0;f[q+(n<<2)>>2]=0;N=f[t>>2]|0;o=(N|0)>(oa|0)?oa:N;N=f[u>>2]|0;W=(N|0)<(oa|0)?oa:N;N=f[s>>2]|0;v=f[R>>2]|0;ca=f[l>>2]|0;D=UIc(m|0,L|0,oa|0,M|0)|0;M=J;L=UIc(H|0,ka|0,T|0,z|0)|0;ka=J;f[t>>2]=(o|0)>(n|0)?n:o;f[u>>2]=(W|0)<(n|0)?n:W;f[s>>2]=(N|0)>(T|0)?T:N;f[R>>2]=(v|0)<(T|0)?T:v;f[l>>2]=ca+2;ca=UIc(D|0,M|0,n|0,fa|0)|0;fa=ba;f[fa>>2]=ca;f[fa+4>>2]=J;fa=UIc(L|0,ka|0,T|0,z|0)|0;ka=ia;f[ka>>2]=fa;f[ka+4>>2]=J}}while(0);oa=oa+2|0;A=f[d>>2]|0;na=f[A+12>>2]|0}while((oa|0)<(na|0));Fa=na;Ga=A}else{Fa=sa;Ga=qa}x=x+2|0;if((x|0)>=(c|0))break;else{qa=Ga;sa=Fa}}return}if(!k)return;k=a+4|0;Fa=a+12|0;sa=g+(e*136|0)+20|0;Ga=g+(e*136|0)+120|0;qa=g+(e*136|0)+20|0;x=g+(e*136|0)+48|0;va=g+(e*136|0)+48|0;ua=g+(e*136|0)+48|0;Aa=g+(e*136|0)+20|0;r=g+(e*136|0)+48|0;S=g+(e*136|0)+20|0;Da=g+(e*136|0)+48|0;Ea=g+(e*136|0)+120|0;Z=g+(e*136|0)+20|0;za=g+(e*136|0)+120|0;g=e;Ba=h;h=i;while(1){i=f[k>>2]|0;Ca=f[f[i+44>>2]>>2]|0;X=(f[i+16>>2]|0)+(Y(Ca,g)|0)|0;i=X+Ca|0;Ca=f[f[Ba+44>>2]>>2]|0;ya=(f[Ba+16>>2]|0)+(Y(Ca,g)|0)|0;y=ya+Ca|0;if((h|0)>0){Ca=((g|0)<0)<<31>>31;_=g+1|0;ra=((_|0)<0)<<31>>31;xa=0;do{V=ya+(xa<<2)|0;wa=f[V>>2]|0;do if((wa|0)>0){j=f[(f[Fa>>2]|0)+(wa<<2)>>2]|0;if(!(b[X+xa>>0]|0)){f[V>>2]=0;oa=f[sa>>2]|0;z=f[oa>>2]|0;f[oa>>2]=(z|0)>(xa|0)?xa:z;z=oa+8|0;T=f[z>>2]|0;f[z>>2]=(T|0)<(xa|0)?xa:T;T=oa+4|0;z=f[T>>2]|0;f[T>>2]=(z|0)>(g|0)?g:z;z=oa+12|0;T=f[z>>2]|0;f[z>>2]=(T|0)<(g|0)?g:T;T=oa+16|0;f[T>>2]=(f[T>>2]|0)+1;T=f[Ga>>2]|0;z=T;q=UIc(f[z>>2]|0,f[z+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;z=T;f[z>>2]=q;f[z+4>>2]=J;Ha=T+8|0;Ia=oa;Ja=T}else{f[V>>2]=j;T=f[S>>2]|0;oa=T+(Y(f[f[Da>>2]>>2]|0,j)|0)|0;z=f[oa>>2]|0;f[oa>>2]=(z|0)>(xa|0)?xa:z;z=oa+8|0;q=f[z>>2]|0;f[z>>2]=(q|0)<(xa|0)?xa:q;q=oa+4|0;z=f[q>>2]|0;f[q>>2]=(z|0)>(g|0)?g:z;z=oa+12|0;q=f[z>>2]|0;f[z>>2]=(q|0)<(g|0)?g:q;q=oa+16|0;f[q>>2]=(f[q>>2]|0)+1;q=f[Ea>>2]|0;oa=q+(j<<4)|0;z=oa;w=UIc(f[z>>2]|0,f[z+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;z=oa;f[z>>2]=w;f[z+4>>2]=J;Ha=q+(j<<4)+8|0;Ia=T;Ja=q}q=Ha;T=UIc(f[q>>2]|0,f[q+4>>2]|0,g|0,Ca|0)|0;q=Ha;f[q>>2]=T;f[q+4>>2]=J;q=xa|1;T=f[d>>2]|0;if((q|0)>=(f[T+12>>2]|0)){if((_|0)>=(f[T+8>>2]|0))break;T=y+(xa<<2)|0;z=f[Aa>>2]|0;if(!(b[i+xa>>0]|0)){f[T>>2]=0;w=f[z>>2]|0;f[z>>2]=(w|0)>(xa|0)?xa:w;w=z+8|0;oa=f[w>>2]|0;f[w>>2]=(oa|0)<(xa|0)?xa:oa;oa=z+4|0;w=f[oa>>2]|0;f[oa>>2]=(w|0)>(_|0)?_:w;w=z+12|0;oa=f[w>>2]|0;f[w>>2]=(oa|0)<(_|0)?_:oa;oa=z+16|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=Ja;w=UIc(f[oa>>2]|0,f[oa+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;oa=Ja;f[oa>>2]=w;f[oa+4>>2]=J;oa=Ja+8|0;w=oa;p=UIc(f[w>>2]|0,f[w+4>>2]|0,_|0,ra|0)|0;w=oa;f[w>>2]=p;f[w+4>>2]=J;break}else{f[T>>2]=j;T=z+(Y(f[f[r>>2]>>2]|0,j)|0)|0;z=f[T>>2]|0;f[T>>2]=(z|0)>(xa|0)?xa:z;z=T+8|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(xa|0)?xa:w;w=T+4|0;z=f[w>>2]|0;f[w>>2]=(z|0)>(_|0)?_:z;z=T+12|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(_|0)?_:w;w=T+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(j<<4)|0;T=w;z=UIc(f[T>>2]|0,f[T+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;T=w;f[T>>2]=z;f[T+4>>2]=J;T=Ja+(j<<4)+8|0;z=T;w=UIc(f[z>>2]|0,f[z+4>>2]|0,_|0,ra|0)|0;z=T;f[z>>2]=w;f[z+4>>2]=J;break}}z=ya+(q<<2)|0;if(!(b[X+q>>0]|0)){f[z>>2]=0;Ka=0;La=Ia}else{f[z>>2]=j;Ka=j;La=Ia+(Y(f[f[ua>>2]>>2]|0,j)|0)|0}z=f[La>>2]|0;f[La>>2]=(z|0)>(q|0)?q:z;z=La+8|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(q|0)?q:w;w=La+4|0;z=f[w>>2]|0;f[w>>2]=(z|0)>(g|0)?g:z;z=La+12|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(g|0)?g:w;w=La+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(Ka<<4)|0;z=w;T=UIc(f[z>>2]|0,f[z+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;z=w;f[z>>2]=T;f[z+4>>2]=J;z=Ja+(Ka<<4)+8|0;T=z;w=UIc(f[T>>2]|0,f[T+4>>2]|0,g|0,Ca|0)|0;T=z;f[T>>2]=w;f[T+4>>2]=J;if((_|0)<(f[(f[d>>2]|0)+8>>2]|0)){T=y+(xa<<2)|0;if(!(b[i+xa>>0]|0)){f[T>>2]=0;Ma=0;Na=Ia}else{f[T>>2]=j;Ma=j;Na=Ia+(Y(f[f[va>>2]>>2]|0,j)|0)|0}T=f[Na>>2]|0;f[Na>>2]=(T|0)>(xa|0)?xa:T;T=Na+8|0;w=f[T>>2]|0;f[T>>2]=(w|0)<(xa|0)?xa:w;w=Na+4|0;T=f[w>>2]|0;f[w>>2]=(T|0)>(_|0)?_:T;T=Na+12|0;w=f[T>>2]|0;f[T>>2]=(w|0)<(_|0)?_:w;w=Na+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(Ma<<4)|0;T=w;z=UIc(f[T>>2]|0,f[T+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;T=w;f[T>>2]=z;f[T+4>>2]=J;T=Ja+(Ma<<4)+8|0;z=T;w=UIc(f[z>>2]|0,f[z+4>>2]|0,_|0,ra|0)|0;z=T;f[z>>2]=w;f[z+4>>2]=J;z=y+(q<<2)|0;w=f[qa>>2]|0;if(!(b[i+q>>0]|0)){f[z>>2]=0;T=f[w>>2]|0;f[w>>2]=(T|0)>(q|0)?q:T;T=w+8|0;p=f[T>>2]|0;f[T>>2]=(p|0)<(q|0)?q:p;p=w+4|0;T=f[p>>2]|0;f[p>>2]=(T|0)>(_|0)?_:T;T=w+12|0;p=f[T>>2]|0;f[T>>2]=(p|0)<(_|0)?_:p;p=w+16|0;f[p>>2]=(f[p>>2]|0)+1;p=Ja;T=UIc(f[p>>2]|0,f[p+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;p=Ja;f[p>>2]=T;f[p+4>>2]=J;p=Ja+8|0;T=p;oa=UIc(f[T>>2]|0,f[T+4>>2]|0,_|0,ra|0)|0;T=p;f[T>>2]=oa;f[T+4>>2]=J;break}else{f[z>>2]=j;z=w+(Y(f[f[x>>2]>>2]|0,j)|0)|0;w=f[z>>2]|0;f[z>>2]=(w|0)>(q|0)?q:w;w=z+8|0;T=f[w>>2]|0;f[w>>2]=(T|0)<(q|0)?q:T;T=z+4|0;w=f[T>>2]|0;f[T>>2]=(w|0)>(_|0)?_:w;w=z+12|0;T=f[w>>2]|0;f[w>>2]=(T|0)<(_|0)?_:T;T=z+16|0;f[T>>2]=(f[T>>2]|0)+1;T=Ja+(j<<4)|0;z=T;w=UIc(f[z>>2]|0,f[z+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;q=T;f[q>>2]=w;f[q+4>>2]=J;q=Ja+(j<<4)+8|0;j=q;w=UIc(f[j>>2]|0,f[j+4>>2]|0,_|0,ra|0)|0;j=q;f[j>>2]=w;f[j+4>>2]=J;break}}}else{f[V>>2]=0;j=f[Z>>2]|0;w=f[j>>2]|0;f[j>>2]=(w|0)>(xa|0)?xa:w;w=j+8|0;q=f[w>>2]|0;f[w>>2]=(q|0)<(xa|0)?xa:q;q=j+4|0;T=f[q>>2]|0;f[q>>2]=(T|0)>(g|0)?g:T;T=j+12|0;z=f[T>>2]|0;f[T>>2]=(z|0)<(g|0)?g:z;z=j+16|0;f[z>>2]=(f[z>>2]|0)+1;oa=f[za>>2]|0;p=((xa|0)<0)<<31>>31;ta=oa;pa=UIc(f[ta>>2]|0,f[ta+4>>2]|0,xa|0,p|0)|0;ta=J;A=oa;f[A>>2]=pa;f[A+4>>2]=ta;A=oa+8|0;na=A;ka=UIc(f[na>>2]|0,f[na+4>>2]|0,g|0,Ca|0)|0;na=J;fa=A;f[fa>>2]=ka;f[fa+4>>2]=na;fa=xa|1;ia=f[d>>2]|0;if((fa|0)<(f[ia+12>>2]|0)){f[ya+(fa<<2)>>2]=0;L=f[j>>2]|0;f[j>>2]=(L|0)>(fa|0)?fa:L;L=f[w>>2]|0;f[w>>2]=(L|0)<(fa|0)?fa:L;L=f[q>>2]|0;f[q>>2]=(L|0)>(g|0)?g:L;L=f[T>>2]|0;f[T>>2]=(L|0)<(g|0)?g:L;f[z>>2]=(f[z>>2]|0)+1;L=((fa|0)<0)<<31>>31;ca=UIc(pa|0,ta|0,fa|0,L|0)|0;ba=J;n=oa;f[n>>2]=ca;f[n+4>>2]=ba;n=UIc(ka|0,na|0,g|0,Ca|0)|0;M=J;D=A;f[D>>2]=n;f[D+4>>2]=M;if((_|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[y+(xa<<2)>>2]=0;f[y+(fa<<2)>>2]=0;D=f[j>>2]|0;l=(D|0)>(xa|0)?xa:D;D=f[w>>2]|0;v=(D|0)<(xa|0)?xa:D;D=f[q>>2]|0;R=f[T>>2]|0;N=f[z>>2]|0;s=UIc(ca|0,ba|0,xa|0,p|0)|0;ba=J;ca=UIc(n|0,M|0,_|0,ra|0)|0;M=J;f[j>>2]=(l|0)>(fa|0)?fa:l;f[w>>2]=(v|0)<(fa|0)?fa:v;f[q>>2]=(D|0)>(_|0)?_:D;f[T>>2]=(R|0)<(_|0)?_:R;f[z>>2]=N+2;N=UIc(s|0,ba|0,fa|0,L|0)|0;L=oa;f[L>>2]=N;f[L+4>>2]=J;L=UIc(ca|0,M|0,_|0,ra|0)|0;M=A;f[M>>2]=L;f[M+4>>2]=J;break}else{if((_|0)>=(f[ia+8>>2]|0))break;f[y+(xa<<2)>>2]=0;ia=f[j>>2]|0;f[j>>2]=(ia|0)>(xa|0)?xa:ia;ia=f[w>>2]|0;f[w>>2]=(ia|0)<(xa|0)?xa:ia;ia=f[q>>2]|0;f[q>>2]=(ia|0)>(_|0)?_:ia;ia=f[T>>2]|0;f[T>>2]=(ia|0)<(_|0)?_:ia;f[z>>2]=(f[z>>2]|0)+1;z=UIc(pa|0,ta|0,xa|0,p|0)|0;p=oa;f[p>>2]=z;f[p+4>>2]=J;p=UIc(ka|0,na|0,_|0,ra|0)|0;na=A;f[na>>2]=p;f[na+4>>2]=J;break}}while(0);xa=xa+2|0;V=f[d>>2]|0;wa=f[V+12>>2]|0}while((xa|0)<(wa|0));Oa=wa;Pa=V}else{Oa=h;Pa=Ba}g=g+2|0;if((g|0)>=(c|0))break;else{Ba=Pa;h=Oa}}return}else{Oa=a+16|0;f[(f[Oa>>2]|0)+132>>2]=c;h=a+8|0;Pa=f[h>>2]|0;Ba=f[Pa+12>>2]|0;g=(Ba&1|0)!=0;d=(e|0)<(c|0);if(!(f[Pa+8>>2]&1)){if(!g){if(!d)return;za=a+4|0;Z=a+12|0;Ja=e;x=Pa;qa=Ba;while(1){Ma=f[za>>2]|0;Na=f[f[Ma+44>>2]>>2]|0;va=(f[Ma+16>>2]|0)+(Y(Na,Ja)|0)|0;Ma=va+Na|0;Na=f[f[x+44>>2]>>2]|0;Ia=(f[x+16>>2]|0)+(Y(Na,Ja)|0)|0;Ka=Ia+Na|0;if((qa|0)>0){Na=((Ja|0)<0)<<31>>31;La=Ja+1|0;ua=((La|0)<0)<<31>>31;r=0;do{Aa=Ia+(r<<2)|0;Ha=f[Aa>>2]|0;do if((Ha|0)>0){Ea=f[(f[Z>>2]|0)+(Ha<<2)>>2]|0;if(!(b[va+r>>0]|0)){f[Aa>>2]=0;Da=f[Oa>>2]|0;S=f[Da+20>>2]|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)>(r|0)?r:Ga;Ga=S+8|0;sa=f[Ga>>2]|0;f[Ga>>2]=(sa|0)<(r|0)?r:sa;sa=S+4|0;Ga=f[sa>>2]|0;f[sa>>2]=(Ga|0)>(Ja|0)?Ja:Ga;Ga=S+12|0;sa=f[Ga>>2]|0;f[Ga>>2]=(sa|0)<(Ja|0)?Ja:sa;sa=S+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa;S=UIc(f[Da>>2]|0,f[Da+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Da=sa;f[Da>>2]=S;f[Da+4>>2]=J;Qa=sa+8|0}else{f[Aa>>2]=Ea;sa=f[Oa>>2]|0;Da=(f[sa+20>>2]|0)+(Y(f[f[sa+48>>2]>>2]|0,Ea)|0)|0;S=f[Da>>2]|0;f[Da>>2]=(S|0)>(r|0)?r:S;S=Da+8|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)<(r|0)?r:Ga;Ga=Da+4|0;S=f[Ga>>2]|0;f[Ga>>2]=(S|0)>(Ja|0)?Ja:S;S=Da+12|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)<(Ja|0)?Ja:Ga;Ga=Da+16|0;f[Ga>>2]=(f[Ga>>2]|0)+1;Ga=f[sa+120>>2]|0;sa=Ga+(Ea<<4)|0;Da=sa;S=UIc(f[Da>>2]|0,f[Da+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Da=sa;f[Da>>2]=S;f[Da+4>>2]=J;Qa=Ga+(Ea<<4)+8|0}Ga=Qa;Da=UIc(f[Ga>>2]|0,f[Ga+4>>2]|0,Ja|0,Na|0)|0;Ga=Qa;f[Ga>>2]=Da;f[Ga+4>>2]=J;Ga=r|1;Da=Ia+(Ga<<2)|0;if(!(b[va+Ga>>0]|0)){f[Da>>2]=0;S=f[Oa>>2]|0;sa=f[S+20>>2]|0;Fa=f[sa>>2]|0;f[sa>>2]=(Fa|0)>(Ga|0)?Ga:Fa;Fa=sa+8|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ga|0)?Ga:k;k=sa+4|0;Fa=f[k>>2]|0;f[k>>2]=(Fa|0)>(Ja|0)?Ja:Fa;Fa=sa+12|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ja|0)?Ja:k;k=sa+16|0;f[k>>2]=(f[k>>2]|0)+1;k=f[S+120>>2]|0;S=k;sa=UIc(f[S>>2]|0,f[S+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;S=k;f[S>>2]=sa;f[S+4>>2]=J;Ra=k+8|0}else{f[Da>>2]=Ea;Da=f[Oa>>2]|0;k=(f[Da+20>>2]|0)+(Y(f[f[Da+48>>2]>>2]|0,Ea)|0)|0;S=f[k>>2]|0;f[k>>2]=(S|0)>(Ga|0)?Ga:S;S=k+8|0;sa=f[S>>2]|0;f[S>>2]=(sa|0)<(Ga|0)?Ga:sa;sa=k+4|0;S=f[sa>>2]|0;f[sa>>2]=(S|0)>(Ja|0)?Ja:S;S=k+12|0;sa=f[S>>2]|0;f[S>>2]=(sa|0)<(Ja|0)?Ja:sa;sa=k+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa+(Ea<<4)|0;k=Da;S=UIc(f[k>>2]|0,f[k+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;k=Da;f[k>>2]=S;f[k+4>>2]=J;Ra=sa+(Ea<<4)+8|0}sa=Ra;k=UIc(f[sa>>2]|0,f[sa+4>>2]|0,Ja|0,Na|0)|0;sa=Ra;f[sa>>2]=k;f[sa+4>>2]=J;sa=Ka+(r<<2)|0;if(!(b[Ma+r>>0]|0)){f[sa>>2]=0;k=f[Oa>>2]|0;S=f[k+20>>2]|0;Da=f[S>>2]|0;f[S>>2]=(Da|0)>(r|0)?r:Da;Da=S+8|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)<(r|0)?r:Fa;Fa=S+4|0;Da=f[Fa>>2]|0;f[Fa>>2]=(Da|0)>(La|0)?La:Da;Da=S+12|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)<(La|0)?La:Fa;Fa=S+16|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Fa=f[k+120>>2]|0;k=Fa;S=UIc(f[k>>2]|0,f[k+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;k=Fa;f[k>>2]=S;f[k+4>>2]=J;Sa=Fa+8|0}else{f[sa>>2]=Ea;sa=f[Oa>>2]|0;Fa=(f[sa+20>>2]|0)+(Y(f[f[sa+48>>2]>>2]|0,Ea)|0)|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)>(r|0)?r:k;k=Fa+8|0;S=f[k>>2]|0;f[k>>2]=(S|0)<(r|0)?r:S;S=Fa+4|0;k=f[S>>2]|0;f[S>>2]=(k|0)>(La|0)?La:k;k=Fa+12|0;S=f[k>>2]|0;f[k>>2]=(S|0)<(La|0)?La:S;S=Fa+16|0;f[S>>2]=(f[S>>2]|0)+1;S=f[sa+120>>2]|0;sa=S+(Ea<<4)|0;Fa=sa;k=UIc(f[Fa>>2]|0,f[Fa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Fa=sa;f[Fa>>2]=k;f[Fa+4>>2]=J;Sa=S+(Ea<<4)+8|0}S=Sa;Fa=UIc(f[S>>2]|0,f[S+4>>2]|0,La|0,ua|0)|0;S=Sa;f[S>>2]=Fa;f[S+4>>2]=J;S=Ka+(Ga<<2)|0;if(!(b[Ma+Ga>>0]|0)){f[S>>2]=0;Fa=f[Oa>>2]|0;k=f[Fa+20>>2]|0;sa=f[k>>2]|0;f[k>>2]=(sa|0)>(Ga|0)?Ga:sa;sa=k+8|0;Da=f[sa>>2]|0;f[sa>>2]=(Da|0)<(Ga|0)?Ga:Da;Da=k+4|0;sa=f[Da>>2]|0;f[Da>>2]=(sa|0)>(La|0)?La:sa;sa=k+12|0;Da=f[sa>>2]|0;f[sa>>2]=(Da|0)<(La|0)?La:Da;Da=k+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Fa+120>>2]|0;Fa=Da;k=UIc(f[Fa>>2]|0,f[Fa+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;Fa=Da;f[Fa>>2]=k;f[Fa+4>>2]=J;Ta=Da+8|0;break}else{f[S>>2]=Ea;S=f[Oa>>2]|0;Da=(f[S+20>>2]|0)+(Y(f[f[S+48>>2]>>2]|0,Ea)|0)|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)>(Ga|0)?Ga:Fa;Fa=Da+8|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ga|0)?Ga:k;k=Da+4|0;Fa=f[k>>2]|0;f[k>>2]=(Fa|0)>(La|0)?La:Fa;Fa=Da+12|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(La|0)?La:k;k=Da+16|0;f[k>>2]=(f[k>>2]|0)+1;k=f[S+120>>2]|0;S=k+(Ea<<4)|0;Da=S;Fa=UIc(f[Da>>2]|0,f[Da+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;Ga=S;f[Ga>>2]=Fa;f[Ga+4>>2]=J;Ta=k+(Ea<<4)+8|0;break}}else{f[Aa>>2]=0;Ea=r|1;f[Ia+(Ea<<2)>>2]=0;f[Ka+(r<<2)>>2]=0;f[Ka+(Ea<<2)>>2]=0;k=f[Oa>>2]|0;Ga=f[k+20>>2]|0;Fa=f[Ga>>2]|0;f[Ga>>2]=(Fa|0)>(r|0)?r:Fa;Fa=Ga+8|0;S=f[Fa>>2]|0;f[Fa>>2]=(S|0)<(r|0)?r:S;S=Ga+4|0;Fa=f[S>>2]|0;f[S>>2]=(Fa|0)>(Ja|0)?Ja:Fa;Fa=Ga+12|0;S=f[Fa>>2]|0;f[Fa>>2]=(S|0)<(Ja|0)?Ja:S;S=Ga+16|0;f[S>>2]=(f[S>>2]|0)+1;S=f[k+120>>2]|0;k=((r|0)<0)<<31>>31;Ga=S;Fa=UIc(f[Ga>>2]|0,f[Ga+4>>2]|0,r|0,k|0)|0;Ga=S;f[Ga>>2]=Fa;f[Ga+4>>2]=J;Ga=S+8|0;S=Ga;Fa=UIc(f[S>>2]|0,f[S+4>>2]|0,Ja|0,Na|0)|0;S=Ga;f[S>>2]=Fa;f[S+4>>2]=J;S=f[Oa>>2]|0;Fa=f[S+20>>2]|0;Ga=f[Fa>>2]|0;f[Fa>>2]=(Ga|0)>(Ea|0)?Ea:Ga;Ga=Fa+8|0;Da=f[Ga>>2]|0;f[Ga>>2]=(Da|0)<(Ea|0)?Ea:Da;Da=Fa+4|0;Ga=f[Da>>2]|0;f[Da>>2]=(Ga|0)>(Ja|0)?Ja:Ga;Ga=Fa+12|0;Da=f[Ga>>2]|0;f[Ga>>2]=(Da|0)<(Ja|0)?Ja:Da;Da=Fa+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[S+120>>2]|0;S=((Ea|0)<0)<<31>>31;Fa=Da;Ga=UIc(f[Fa>>2]|0,f[Fa+4>>2]|0,Ea|0,S|0)|0;Fa=Da;f[Fa>>2]=Ga;f[Fa+4>>2]=J;Fa=Da+8|0;Da=Fa;Ga=UIc(f[Da>>2]|0,f[Da+4>>2]|0,Ja|0,Na|0)|0;Da=Fa;f[Da>>2]=Ga;f[Da+4>>2]=J;Da=f[Oa>>2]|0;Ga=f[Da+20>>2]|0;Fa=f[Ga>>2]|0;f[Ga>>2]=(Fa|0)>(r|0)?r:Fa;Fa=Ga+8|0;sa=f[Fa>>2]|0;f[Fa>>2]=(sa|0)<(r|0)?r:sa;sa=Ga+4|0;Fa=f[sa>>2]|0;f[sa>>2]=(Fa|0)>(La|0)?La:Fa;Fa=Ga+12|0;sa=f[Fa>>2]|0;f[Fa>>2]=(sa|0)<(La|0)?La:sa;sa=Ga+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa;Ga=UIc(f[Da>>2]|0,f[Da+4>>2]|0,r|0,k|0)|0;k=sa;f[k>>2]=Ga;f[k+4>>2]=J;k=sa+8|0;sa=k;Ga=UIc(f[sa>>2]|0,f[sa+4>>2]|0,La|0,ua|0)|0;sa=k;f[sa>>2]=Ga;f[sa+4>>2]=J;sa=f[Oa>>2]|0;Ga=f[sa+20>>2]|0;k=f[Ga>>2]|0;f[Ga>>2]=(k|0)>(Ea|0)?Ea:k;k=Ga+8|0;Da=f[k>>2]|0;f[k>>2]=(Da|0)<(Ea|0)?Ea:Da;Da=Ga+4|0;k=f[Da>>2]|0;f[Da>>2]=(k|0)>(La|0)?La:k;k=Ga+12|0;Da=f[k>>2]|0;f[k>>2]=(Da|0)<(La|0)?La:Da;Da=Ga+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[sa+120>>2]|0;sa=Da;Ga=UIc(f[sa>>2]|0,f[sa+4>>2]|0,Ea|0,S|0)|0;S=Da;f[S>>2]=Ga;f[S+4>>2]=J;Ta=Da+8|0}while(0);Aa=Ta;Ha=UIc(f[Aa>>2]|0,f[Aa+4>>2]|0,La|0,ua|0)|0;Aa=Ta;f[Aa>>2]=Ha;f[Aa+4>>2]=J;r=r+2|0;Aa=f[h>>2]|0;Ha=f[Aa+12>>2]|0}while((r|0)<(Ha|0));Ua=Ha;Va=Aa}else{Ua=qa;Va=x}Ja=Ja+2|0;if((Ja|0)>=(c|0))break;else{x=Va;qa=Ua}}return}if(!d)return;Ua=a+4|0;qa=a+12|0;Va=e;x=Pa;Ja=Ba;while(1){Ta=f[Ua>>2]|0;Sa=f[f[Ta+44>>2]>>2]|0;Ra=(f[Ta+16>>2]|0)+(Y(Sa,Va)|0)|0;Ta=Ra+Sa|0;Sa=f[f[x+44>>2]>>2]|0;Qa=(f[x+16>>2]|0)+(Y(Sa,Va)|0)|0;Z=Qa+Sa|0;if((Ja|0)>0){Sa=((Va|0)<0)<<31>>31;za=Va+1|0;r=((za|0)<0)<<31>>31;ua=0;do{La=Qa+(ua<<2)|0;Na=f[La>>2]|0;do if((Na|0)>0){Ka=f[(f[qa>>2]|0)+(Na<<2)>>2]|0;if(!(b[Ra+ua>>0]|0)){f[La>>2]=0;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)>(ua|0)?ua:va;va=Ma+8|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)<(ua|0)?ua:Aa;Aa=Ma+4|0;va=f[Aa>>2]|0;f[Aa>>2]=(va|0)>(Va|0)?Va:va;va=Ma+12|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)<(Va|0)?Va:Aa;Aa=Ma+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Ia+120>>2]|0;Ia=Aa;Ma=UIc(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Aa;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Wa=Aa+8|0}else{f[La>>2]=Ka;Aa=f[Oa>>2]|0;Ia=(f[Aa+20>>2]|0)+(Y(f[f[Aa+48>>2]>>2]|0,Ka)|0)|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)>(ua|0)?ua:Ma;Ma=Ia+8|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)<(ua|0)?ua:va;va=Ia+4|0;Ma=f[va>>2]|0;f[va>>2]=(Ma|0)>(Va|0)?Va:Ma;Ma=Ia+12|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)<(Va|0)?Va:va;va=Ia+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Aa+120>>2]|0;Aa=va+(Ka<<4)|0;Ia=Aa;Ma=UIc(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Aa;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Wa=va+(Ka<<4)+8|0}va=Wa;Ia=UIc(f[va>>2]|0,f[va+4>>2]|0,Va|0,Sa|0)|0;va=Wa;f[va>>2]=Ia;f[va+4>>2]=J;va=Z+(ua<<2)|0;if(!(b[Ta+ua>>0]|0)){f[va>>2]=0;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;Aa=f[Ma>>2]|0;f[Ma>>2]=(Aa|0)>(ua|0)?ua:Aa;Aa=Ma+8|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)<(ua|0)?ua:Ha;Ha=Ma+4|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)>(za|0)?za:Aa;Aa=Ma+12|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)<(za|0)?za:Ha;Ha=Ma+16|0;f[Ha>>2]=(f[Ha>>2]|0)+1;Ha=f[Ia+120>>2]|0;Ia=Ha;Ma=UIc(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Ha;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Xa=Ha+8|0}else{f[va>>2]=Ka;va=f[Oa>>2]|0;Ha=(f[va+20>>2]|0)+(Y(f[f[va+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Ha>>2]|0;f[Ha>>2]=(Ia|0)>(ua|0)?ua:Ia;Ia=Ha+8|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)<(ua|0)?ua:Ma;Ma=Ha+4|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)>(za|0)?za:Ia;Ia=Ha+12|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)<(za|0)?za:Ma;Ma=Ha+16|0;f[Ma>>2]=(f[Ma>>2]|0)+1;Ma=f[va+120>>2]|0;va=Ma+(Ka<<4)|0;Ha=va;Ia=UIc(f[Ha>>2]|0,f[Ha+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ha=va;f[Ha>>2]=Ia;f[Ha+4>>2]=J;Xa=Ma+(Ka<<4)+8|0}Ma=Xa;Ha=UIc(f[Ma>>2]|0,f[Ma+4>>2]|0,za|0,r|0)|0;Ma=Xa;f[Ma>>2]=Ha;f[Ma+4>>2]=J;Ma=ua|1;if((Ma|0)<(f[(f[h>>2]|0)+12>>2]|0)){Ha=Qa+(Ma<<2)|0;if(!(b[Ra+Ma>>0]|0)){f[Ha>>2]=0;Ia=f[Oa>>2]|0;va=f[Ia+20>>2]|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)>(Ma|0)?Ma:Aa;Aa=va+8|0;Da=f[Aa>>2]|0;f[Aa>>2]=(Da|0)<(Ma|0)?Ma:Da;Da=va+4|0;Aa=f[Da>>2]|0;f[Da>>2]=(Aa|0)>(Va|0)?Va:Aa;Aa=va+12|0;Da=f[Aa>>2]|0;f[Aa>>2]=(Da|0)<(Va|0)?Va:Da;Da=va+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ia+120>>2]|0;Ia=Da;va=UIc(f[Ia>>2]|0,f[Ia+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Ia=Da;f[Ia>>2]=va;f[Ia+4>>2]=J;Ya=Da+8|0}else{f[Ha>>2]=Ka;Ha=f[Oa>>2]|0;Da=(f[Ha+20>>2]|0)+(Y(f[f[Ha+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(Ma|0)?Ma:Ia;Ia=Da+8|0;va=f[Ia>>2]|0;f[Ia>>2]=(va|0)<(Ma|0)?Ma:va;va=Da+4|0;Ia=f[va>>2]|0;f[va>>2]=(Ia|0)>(Va|0)?Va:Ia;Ia=Da+12|0;va=f[Ia>>2]|0;f[Ia>>2]=(va|0)<(Va|0)?Va:va;va=Da+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Ha+120>>2]|0;Ha=va+(Ka<<4)|0;Da=Ha;Ia=UIc(f[Da>>2]|0,f[Da+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Da=Ha;f[Da>>2]=Ia;f[Da+4>>2]=J;Ya=va+(Ka<<4)+8|0}va=Ya;Da=UIc(f[va>>2]|0,f[va+4>>2]|0,Va|0,Sa|0)|0;va=Ya;f[va>>2]=Da;f[va+4>>2]=J;va=Z+(Ma<<2)|0;if(!(b[Ta+Ma>>0]|0)){f[va>>2]=0;Da=f[Oa>>2]|0;Ia=f[Da+20>>2]|0;Ha=f[Ia>>2]|0;f[Ia>>2]=(Ha|0)>(Ma|0)?Ma:Ha;Ha=Ia+8|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)<(Ma|0)?Ma:Aa;Aa=Ia+4|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)>(za|0)?za:Ha;Ha=Ia+12|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)<(za|0)?za:Aa;Aa=Ia+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Da+120>>2]|0;Da=Aa;Ia=UIc(f[Da>>2]|0,f[Da+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Da=Aa;f[Da>>2]=Ia;f[Da+4>>2]=J;Da=Aa+8|0;Aa=Da;Ia=UIc(f[Aa>>2]|0,f[Aa+4>>2]|0,za|0,r|0)|0;Aa=Da;f[Aa>>2]=Ia;f[Aa+4>>2]=J;break}else{f[va>>2]=Ka;va=f[Oa>>2]|0;Aa=(f[va+20>>2]|0)+(Y(f[f[va+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Aa>>2]|0;f[Aa>>2]=(Ia|0)>(Ma|0)?Ma:Ia;Ia=Aa+8|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(Ma|0)?Ma:Da;Da=Aa+4|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(za|0)?za:Ia;Ia=Aa+12|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(za|0)?za:Da;Da=Aa+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[va+120>>2]|0;va=Da+(Ka<<4)|0;Aa=va;Ia=UIc(f[Aa>>2]|0,f[Aa+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Ma=va;f[Ma>>2]=Ia;f[Ma+4>>2]=J;Ma=Da+(Ka<<4)+8|0;Ka=Ma;Da=UIc(f[Ka>>2]|0,f[Ka+4>>2]|0,za|0,r|0)|0;Ka=Ma;f[Ka>>2]=Da;f[Ka+4>>2]=J;break}}}else{f[La>>2]=0;f[Z+(ua<<2)>>2]=0;Ka=f[Oa>>2]|0;Da=f[Ka+20>>2]|0;Ma=f[Da>>2]|0;f[Da>>2]=(Ma|0)>(ua|0)?ua:Ma;Ma=Da+8|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)<(ua|0)?ua:Ia;Ia=Da+4|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)>(Va|0)?Va:Ma;Ma=Da+12|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)<(Va|0)?Va:Ia;Ia=Da+16|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Ia=f[Ka+120>>2]|0;Ka=((ua|0)<0)<<31>>31;Da=Ia;Ma=UIc(f[Da>>2]|0,f[Da+4>>2]|0,ua|0,Ka|0)|0;Da=Ia;f[Da>>2]=Ma;f[Da+4>>2]=J;Da=Ia+8|0;Ia=Da;Ma=UIc(f[Ia>>2]|0,f[Ia+4>>2]|0,Va|0,Sa|0)|0;Ia=Da;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;Da=f[Ma>>2]|0;f[Ma>>2]=(Da|0)>(ua|0)?ua:Da;Da=Ma+8|0;va=f[Da>>2]|0;f[Da>>2]=(va|0)<(ua|0)?ua:va;va=Ma+4|0;Da=f[va>>2]|0;f[va>>2]=(Da|0)>(za|0)?za:Da;Da=Ma+12|0;va=f[Da>>2]|0;f[Da>>2]=(va|0)<(za|0)?za:va;va=Ma+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Ia+120>>2]|0;Ia=va;Ma=UIc(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,Ka|0)|0;Ka=va;f[Ka>>2]=Ma;f[Ka+4>>2]=J;Ka=va+8|0;va=Ka;Ma=UIc(f[va>>2]|0,f[va+4>>2]|0,za|0,r|0)|0;va=Ka;f[va>>2]=Ma;f[va+4>>2]=J;va=ua|1;if((va|0)<(f[(f[h>>2]|0)+12>>2]|0)){f[Qa+(va<<2)>>2]=0;f[Z+(va<<2)>>2]=0;Ma=f[Oa>>2]|0;Ka=f[Ma+20>>2]|0;Ia=f[Ka>>2]|0;f[Ka>>2]=(Ia|0)>(va|0)?va:Ia;Ia=Ka+8|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(va|0)?va:Da;Da=Ka+4|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(Va|0)?Va:Ia;Ia=Ka+12|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(Va|0)?Va:Da;Da=Ka+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ma+120>>2]|0;Ma=((va|0)<0)<<31>>31;Ka=Da;Ia=UIc(f[Ka>>2]|0,f[Ka+4>>2]|0,va|0,Ma|0)|0;Ka=Da;f[Ka>>2]=Ia;f[Ka+4>>2]=J;Ka=Da+8|0;Da=Ka;Ia=UIc(f[Da>>2]|0,f[Da+4>>2]|0,Va|0,Sa|0)|0;Da=Ka;f[Da>>2]=Ia;f[Da+4>>2]=J;Da=f[Oa>>2]|0;Ia=f[Da+20>>2]|0;Ka=f[Ia>>2]|0;f[Ia>>2]=(Ka|0)>(va|0)?va:Ka;Ka=Ia+8|0;Aa=f[Ka>>2]|0;f[Ka>>2]=(Aa|0)<(va|0)?va:Aa;Aa=Ia+4|0;Ka=f[Aa>>2]|0;f[Aa>>2]=(Ka|0)>(za|0)?za:Ka;Ka=Ia+12|0;Aa=f[Ka>>2]|0;f[Ka>>2]=(Aa|0)<(za|0)?za:Aa;Aa=Ia+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Da+120>>2]|0;Da=Aa;Ia=UIc(f[Da>>2]|0,f[Da+4>>2]|0,va|0,Ma|0)|0;Ma=Aa;f[Ma>>2]=Ia;f[Ma+4>>2]=J;Ma=Aa+8|0;Aa=Ma;Ia=UIc(f[Aa>>2]|0,f[Aa+4>>2]|0,za|0,r|0)|0;Aa=Ma;f[Aa>>2]=Ia;f[Aa+4>>2]=J}}while(0);ua=ua+2|0;La=f[h>>2]|0;Na=f[La+12>>2]|0}while((ua|0)<(Na|0));Za=Na;_a=La}else{Za=Ja;_a=x}Va=Va+2|0;if((Va|0)>=(c|0))break;else{x=_a;Ja=Za}}return}if(!g){if(!d)return;g=a+4|0;Za=a+12|0;Ja=e;_a=Pa;x=Ba;while(1){Va=f[g>>2]|0;Ya=f[f[Va+44>>2]>>2]|0;Xa=(f[Va+16>>2]|0)+(Y(Ya,Ja)|0)|0;Va=Xa+Ya|0;Ya=f[f[_a+44>>2]>>2]|0;Wa=(f[_a+16>>2]|0)+(Y(Ya,Ja)|0)|0;qa=Wa+Ya|0;if((x|0)>0){Ya=((Ja|0)<0)<<31>>31;Ua=Ja+1|0;ua=((Ua|0)<0)<<31>>31;r=0;do{za=Wa+(r<<2)|0;Sa=f[za>>2]|0;do if((Sa|0)>0){Z=f[(f[Za>>2]|0)+(Sa<<2)>>2]|0;if(!(b[Xa+r>>0]|0)){f[za>>2]=0;Qa=f[Oa>>2]|0;Ta=f[Qa+20>>2]|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)>(r|0)?r:Ra;Ra=Ta+8|0;La=f[Ra>>2]|0;f[Ra>>2]=(La|0)<(r|0)?r:La;La=Ta+4|0;Ra=f[La>>2]|0;f[La>>2]=(Ra|0)>(Ja|0)?Ja:Ra;Ra=Ta+12|0;La=f[Ra>>2]|0;f[Ra>>2]=(La|0)<(Ja|0)?Ja:La;La=Ta+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La;Ta=UIc(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Qa=La;f[Qa>>2]=Ta;f[Qa+4>>2]=J;$a=La+8|0}else{f[za>>2]=Z;La=f[Oa>>2]|0;Qa=(f[La+20>>2]|0)+(Y(f[f[La+48>>2]>>2]|0,Z)|0)|0;Ta=f[Qa>>2]|0;f[Qa>>2]=(Ta|0)>(r|0)?r:Ta;Ta=Qa+8|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)<(r|0)?r:Ra;Ra=Qa+4|0;Ta=f[Ra>>2]|0;f[Ra>>2]=(Ta|0)>(Ja|0)?Ja:Ta;Ta=Qa+12|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)<(Ja|0)?Ja:Ra;Ra=Qa+16|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Ra=f[La+120>>2]|0;La=Ra+(Z<<4)|0;Qa=La;Ta=UIc(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Qa=La;f[Qa>>2]=Ta;f[Qa+4>>2]=J;$a=Ra+(Z<<4)+8|0}Ra=$a;Qa=UIc(f[Ra>>2]|0,f[Ra+4>>2]|0,Ja|0,Ya|0)|0;Ra=$a;f[Ra>>2]=Qa;f[Ra+4>>2]=J;Ra=r|1;Qa=Wa+(Ra<<2)|0;if(!(b[Xa+Ra>>0]|0)){f[Qa>>2]=0;Ta=f[Oa>>2]|0;La=f[Ta+20>>2]|0;Na=f[La>>2]|0;f[La>>2]=(Na|0)>(Ra|0)?Ra:Na;Na=La+8|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)<(Ra|0)?Ra:Aa;Aa=La+4|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)>(Ja|0)?Ja:Na;Na=La+12|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)<(Ja|0)?Ja:Aa;Aa=La+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Ta+120>>2]|0;Ta=Aa;La=UIc(f[Ta>>2]|0,f[Ta+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Ta=Aa;f[Ta>>2]=La;f[Ta+4>>2]=J;ab=Aa+8|0}else{f[Qa>>2]=Z;Qa=f[Oa>>2]|0;Aa=(f[Qa+20>>2]|0)+(Y(f[f[Qa+48>>2]>>2]|0,Z)|0)|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)>(Ra|0)?Ra:Ta;Ta=Aa+8|0;La=f[Ta>>2]|0;f[Ta>>2]=(La|0)<(Ra|0)?Ra:La;La=Aa+4|0;Ta=f[La>>2]|0;f[La>>2]=(Ta|0)>(Ja|0)?Ja:Ta;Ta=Aa+12|0;La=f[Ta>>2]|0;f[Ta>>2]=(La|0)<(Ja|0)?Ja:La;La=Aa+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La+(Z<<4)|0;Aa=Qa;Ta=UIc(f[Aa>>2]|0,f[Aa+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Aa=Qa;f[Aa>>2]=Ta;f[Aa+4>>2]=J;ab=La+(Z<<4)+8|0}La=ab;Aa=UIc(f[La>>2]|0,f[La+4>>2]|0,Ja|0,Ya|0)|0;La=ab;f[La>>2]=Aa;f[La+4>>2]=J;if((Ua|0)<(f[(f[h>>2]|0)+8>>2]|0)){La=qa+(r<<2)|0;if(!(b[Va+r>>0]|0)){f[La>>2]=0;Aa=f[Oa>>2]|0;Ta=f[Aa+20>>2]|0;Qa=f[Ta>>2]|0;f[Ta>>2]=(Qa|0)>(r|0)?r:Qa;Qa=Ta+8|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)<(r|0)?r:Na;Na=Ta+4|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)>(Ua|0)?Ua:Qa;Qa=Ta+12|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)<(Ua|0)?Ua:Na;Na=Ta+16|0;f[Na>>2]=(f[Na>>2]|0)+1;Na=f[Aa+120>>2]|0;Aa=Na;Ta=UIc(f[Aa>>2]|0,f[Aa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Aa=Na;f[Aa>>2]=Ta;f[Aa+4>>2]=J;bb=Na+8|0}else{f[La>>2]=Z;La=f[Oa>>2]|0;Na=(f[La+20>>2]|0)+(Y(f[f[La+48>>2]>>2]|0,Z)|0)|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Na+8|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(r|0)?r:Ta;Ta=Na+4|0;Aa=f[Ta>>2]|0;f[Ta>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Na+12|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(Ua|0)?Ua:Ta;Ta=Na+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=f[La+120>>2]|0;La=Ta+(Z<<4)|0;Na=La;Aa=UIc(f[Na>>2]|0,f[Na+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Na=La;f[Na>>2]=Aa;f[Na+4>>2]=J;bb=Ta+(Z<<4)+8|0}Ta=bb;Na=UIc(f[Ta>>2]|0,f[Ta+4>>2]|0,Ua|0,ua|0)|0;Ta=bb;f[Ta>>2]=Na;f[Ta+4>>2]=J;Ta=qa+(Ra<<2)|0;if(!(b[Va+Ra>>0]|0)){f[Ta>>2]=0;Na=f[Oa>>2]|0;Aa=f[Na+20>>2]|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)>(Ra|0)?Ra:La;La=Aa+8|0;Qa=f[La>>2]|0;f[La>>2]=(Qa|0)<(Ra|0)?Ra:Qa;Qa=Aa+4|0;La=f[Qa>>2]|0;f[Qa>>2]=(La|0)>(Ua|0)?Ua:La;La=Aa+12|0;Qa=f[La>>2]|0;f[La>>2]=(Qa|0)<(Ua|0)?Ua:Qa;Qa=Aa+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[Na+120>>2]|0;Na=Qa;Aa=UIc(f[Na>>2]|0,f[Na+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Na=Qa;f[Na>>2]=Aa;f[Na+4>>2]=J;Na=Qa+8|0;Qa=Na;Aa=UIc(f[Qa>>2]|0,f[Qa+4>>2]|0,Ua|0,ua|0)|0;Qa=Na;f[Qa>>2]=Aa;f[Qa+4>>2]=J;break}else{f[Ta>>2]=Z;Ta=f[Oa>>2]|0;Qa=(f[Ta+20>>2]|0)+(Y(f[f[Ta+48>>2]>>2]|0,Z)|0)|0;Aa=f[Qa>>2]|0;f[Qa>>2]=(Aa|0)>(Ra|0)?Ra:Aa;Aa=Qa+8|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)<(Ra|0)?Ra:Na;Na=Qa+4|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Qa+12|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)<(Ua|0)?Ua:Na;Na=Qa+16|0;f[Na>>2]=(f[Na>>2]|0)+1;Na=f[Ta+120>>2]|0;Ta=Na+(Z<<4)|0;Qa=Ta;Aa=UIc(f[Qa>>2]|0,f[Qa+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Ra=Ta;f[Ra>>2]=Aa;f[Ra+4>>2]=J;Ra=Na+(Z<<4)+8|0;Z=Ra;Na=UIc(f[Z>>2]|0,f[Z+4>>2]|0,Ua|0,ua|0)|0;Z=Ra;f[Z>>2]=Na;f[Z+4>>2]=J;break}}}else{f[za>>2]=0;Z=r|1;f[Wa+(Z<<2)>>2]=0;Na=f[Oa>>2]|0;Ra=f[Na+20>>2]|0;Aa=f[Ra>>2]|0;f[Ra>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Ra+8|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(r|0)?r:Ta;Ta=Ra+4|0;Aa=f[Ta>>2]|0;f[Ta>>2]=(Aa|0)>(Ja|0)?Ja:Aa;Aa=Ra+12|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(Ja|0)?Ja:Ta;Ta=Ra+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=f[Na+120>>2]|0;Na=((r|0)<0)<<31>>31;Ra=Ta;Aa=UIc(f[Ra>>2]|0,f[Ra+4>>2]|0,r|0,Na|0)|0;Ra=Ta;f[Ra>>2]=Aa;f[Ra+4>>2]=J;Ra=Ta+8|0;Ta=Ra;Aa=UIc(f[Ta>>2]|0,f[Ta+4>>2]|0,Ja|0,Ya|0)|0;Ta=Ra;f[Ta>>2]=Aa;f[Ta+4>>2]=J;Ta=f[Oa>>2]|0;Aa=f[Ta+20>>2]|0;Ra=f[Aa>>2]|0;f[Aa>>2]=(Ra|0)>(Z|0)?Z:Ra;Ra=Aa+8|0;Qa=f[Ra>>2]|0;f[Ra>>2]=(Qa|0)<(Z|0)?Z:Qa;Qa=Aa+4|0;Ra=f[Qa>>2]|0;f[Qa>>2]=(Ra|0)>(Ja|0)?Ja:Ra;Ra=Aa+12|0;Qa=f[Ra>>2]|0;f[Ra>>2]=(Qa|0)<(Ja|0)?Ja:Qa;Qa=Aa+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[Ta+120>>2]|0;Ta=((Z|0)<0)<<31>>31;Aa=Qa;Ra=UIc(f[Aa>>2]|0,f[Aa+4>>2]|0,Z|0,Ta|0)|0;Aa=Qa;f[Aa>>2]=Ra;f[Aa+4>>2]=J;Aa=Qa+8|0;Qa=Aa;Ra=UIc(f[Qa>>2]|0,f[Qa+4>>2]|0,Ja|0,Ya|0)|0;Qa=Aa;f[Qa>>2]=Ra;f[Qa+4>>2]=J;if((Ua|0)<(f[(f[h>>2]|0)+8>>2]|0)){f[qa+(r<<2)>>2]=0;f[qa+(Z<<2)>>2]=0;Qa=f[Oa>>2]|0;Ra=f[Qa+20>>2]|0;Aa=f[Ra>>2]|0;f[Ra>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Ra+8|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)<(r|0)?r:La;La=Ra+4|0;Aa=f[La>>2]|0;f[La>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Ra+12|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)<(Ua|0)?Ua:La;La=Ra+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La;Ra=UIc(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,Na|0)|0;Na=La;f[Na>>2]=Ra;f[Na+4>>2]=J;Na=La+8|0;La=Na;Ra=UIc(f[La>>2]|0,f[La+4>>2]|0,Ua|0,ua|0)|0;La=Na;f[La>>2]=Ra;f[La+4>>2]=J;La=f[Oa>>2]|0;Ra=f[La+20>>2]|0;Na=f[Ra>>2]|0;f[Ra>>2]=(Na|0)>(Z|0)?Z:Na;Na=Ra+8|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)<(Z|0)?Z:Qa;Qa=Ra+4|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)>(Ua|0)?Ua:Na;Na=Ra+12|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)<(Ua|0)?Ua:Qa;Qa=Ra+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[La+120>>2]|0;La=Qa;Ra=UIc(f[La>>2]|0,f[La+4>>2]|0,Z|0,Ta|0)|0;Ta=Qa;f[Ta>>2]=Ra;f[Ta+4>>2]=J;Ta=Qa+8|0;Qa=Ta;Ra=UIc(f[Qa>>2]|0,f[Qa+4>>2]|0,Ua|0,ua|0)|0;Qa=Ta;f[Qa>>2]=Ra;f[Qa+4>>2]=J}}while(0);r=r+2|0;za=f[h>>2]|0;Sa=f[za+12>>2]|0}while((r|0)<(Sa|0));cb=Sa;db=za}else{cb=x;db=_a}Ja=Ja+2|0;if((Ja|0)>=(c|0))break;else{_a=db;x=cb}}return}if(!d)return;d=a+4|0;cb=a+12|0;a=e;e=Pa;Pa=Ba;while(1){Ba=f[d>>2]|0;x=f[f[Ba+44>>2]>>2]|0;db=(f[Ba+16>>2]|0)+(Y(x,a)|0)|0;Ba=db+x|0;x=f[f[e+44>>2]>>2]|0;_a=(f[e+16>>2]|0)+(Y(x,a)|0)|0;Ja=_a+x|0;if((Pa|0)>0){x=((a|0)<0)<<31>>31;bb=a+1|0;ab=((bb|0)<0)<<31>>31;$a=0;do{Za=_a+($a<<2)|0;g=f[Za>>2]|0;do if((g|0)>0){r=f[(f[cb>>2]|0)+(g<<2)>>2]|0;if(!(b[db+$a>>0]|0)){f[Za>>2]=0;ua=f[Oa>>2]|0;Ua=f[ua+20>>2]|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)>($a|0)?$a:qa;qa=Ua+8|0;Ya=f[qa>>2]|0;f[qa>>2]=(Ya|0)<($a|0)?$a:Ya;Ya=Ua+4|0;qa=f[Ya>>2]|0;f[Ya>>2]=(qa|0)>(a|0)?a:qa;qa=Ua+12|0;Ya=f[qa>>2]|0;f[qa>>2]=(Ya|0)<(a|0)?a:Ya;Ya=Ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[ua+120>>2]|0;ua=Ya;Ua=UIc(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;eb=Ya+8|0}else{f[Za>>2]=r;Ya=f[Oa>>2]|0;ua=(f[Ya+20>>2]|0)+(Y(f[f[Ya+48>>2]>>2]|0,r)|0)|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=ua+8|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)<($a|0)?$a:qa;qa=ua+4|0;Ua=f[qa>>2]|0;f[qa>>2]=(Ua|0)>(a|0)?a:Ua;Ua=ua+12|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)<(a|0)?a:qa;qa=ua+16|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=f[Ya+120>>2]|0;Ya=qa+(r<<4)|0;ua=Ya;Ua=UIc(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;eb=qa+(r<<4)+8|0}qa=eb;ua=UIc(f[qa>>2]|0,f[qa+4>>2]|0,a|0,x|0)|0;qa=eb;f[qa>>2]=ua;f[qa+4>>2]=J;qa=$a|1;ua=f[h>>2]|0;if((qa|0)>=(f[ua+12>>2]|0)){if((bb|0)>=(f[ua+8>>2]|0))break;ua=Ja+($a<<2)|0;if(!(b[Ba+$a>>0]|0)){f[ua>>2]=0;Ua=f[Oa>>2]|0;Ya=f[Ua+20>>2]|0;Wa=f[Ya>>2]|0;f[Ya>>2]=(Wa|0)>($a|0)?$a:Wa;Wa=Ya+8|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)<($a|0)?$a:Va;Va=Ya+4|0;Wa=f[Va>>2]|0;f[Va>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=Ya+12|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)<(bb|0)?bb:Va;Va=Ya+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[Ua+120>>2]|0;Ua=Va;Ya=UIc(f[Ua>>2]|0,f[Ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Ua=Va;f[Ua>>2]=Ya;f[Ua+4>>2]=J;Ua=Va+8|0;Va=Ua;Ya=UIc(f[Va>>2]|0,f[Va+4>>2]|0,bb|0,ab|0)|0;Va=Ua;f[Va>>2]=Ya;f[Va+4>>2]=J;break}else{f[ua>>2]=r;ua=f[Oa>>2]|0;Va=(f[ua+20>>2]|0)+(Y(f[f[ua+48>>2]>>2]|0,r)|0)|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)>($a|0)?$a:Ya;Ya=Va+8|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)<($a|0)?$a:Ua;Ua=Va+4|0;Ya=f[Ua>>2]|0;f[Ua>>2]=(Ya|0)>(bb|0)?bb:Ya;Ya=Va+12|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)<(bb|0)?bb:Ua;Ua=Va+16|0;f[Ua>>2]=(f[Ua>>2]|0)+1;Ua=f[ua+120>>2]|0;ua=Ua+(r<<4)|0;Va=ua;Ya=UIc(f[Va>>2]|0,f[Va+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Va=ua;f[Va>>2]=Ya;f[Va+4>>2]=J;Va=Ua+(r<<4)+8|0;Ua=Va;Ya=UIc(f[Ua>>2]|0,f[Ua+4>>2]|0,bb|0,ab|0)|0;Ua=Va;f[Ua>>2]=Ya;f[Ua+4>>2]=J;break}}Ua=_a+(qa<<2)|0;if(!(b[db+qa>>0]|0)){f[Ua>>2]=0;Ya=f[Oa>>2]|0;Va=f[Ya+20>>2]|0;ua=f[Va>>2]|0;f[Va>>2]=(ua|0)>(qa|0)?qa:ua;ua=Va+8|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)<(qa|0)?qa:Wa;Wa=Va+4|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)>(a|0)?a:ua;ua=Va+12|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)<(a|0)?a:Wa;Wa=Va+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[Ya+120>>2]|0;Ya=Wa;Va=UIc(f[Ya>>2]|0,f[Ya+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;Ya=Wa;f[Ya>>2]=Va;f[Ya+4>>2]=J;fb=Wa+8|0}else{f[Ua>>2]=r;Ua=f[Oa>>2]|0;Wa=(f[Ua+20>>2]|0)+(Y(f[f[Ua+48>>2]>>2]|0,r)|0)|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)>(qa|0)?qa:Ya;Ya=Wa+8|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)<(qa|0)?qa:Va;Va=Wa+4|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)>(a|0)?a:Ya;Ya=Wa+12|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)<(a|0)?a:Va;Va=Wa+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[Ua+120>>2]|0;Ua=Va+(r<<4)|0;Wa=Ua;Ya=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;Wa=Ua;f[Wa>>2]=Ya;f[Wa+4>>2]=J;fb=Va+(r<<4)+8|0}Va=fb;Wa=UIc(f[Va>>2]|0,f[Va+4>>2]|0,a|0,x|0)|0;Va=fb;f[Va>>2]=Wa;f[Va+4>>2]=J;if((bb|0)<(f[(f[h>>2]|0)+8>>2]|0)){Va=Ja+($a<<2)|0;if(!(b[Ba+$a>>0]|0)){f[Va>>2]=0;Wa=f[Oa>>2]|0;Ya=f[Wa+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=Ya+8|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<($a|0)?$a:ua;ua=Ya+4|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>(bb|0)?bb:Ua;Ua=Ya+12|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ya+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[Wa+120>>2]|0;Wa=ua;Ya=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Wa=ua;f[Wa>>2]=Ya;f[Wa+4>>2]=J;gb=ua+8|0}else{f[Va>>2]=r;Va=f[Oa>>2]|0;ua=(f[Va+20>>2]|0)+(Y(f[f[Va+48>>2]>>2]|0,r)|0)|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)>($a|0)?$a:Wa;Wa=ua+8|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)<($a|0)?$a:Ya;Ya=ua+4|0;Wa=f[Ya>>2]|0;f[Ya>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=ua+12|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)<(bb|0)?bb:Ya;Ya=ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[Va+120>>2]|0;Va=Ya+(r<<4)|0;ua=Va;Wa=UIc(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Va;f[ua>>2]=Wa;f[ua+4>>2]=J;gb=Ya+(r<<4)+8|0}Ya=gb;ua=UIc(f[Ya>>2]|0,f[Ya+4>>2]|0,bb|0,ab|0)|0;Ya=gb;f[Ya>>2]=ua;f[Ya+4>>2]=J;Ya=Ja+(qa<<2)|0;if(!(b[Ba+qa>>0]|0)){f[Ya>>2]=0;ua=f[Oa>>2]|0;Wa=f[ua+20>>2]|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)>(qa|0)?qa:Va;Va=Wa+8|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)<(qa|0)?qa:Ua;Ua=Wa+4|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)>(bb|0)?bb:Va;Va=Wa+12|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)<(bb|0)?bb:Ua;Ua=Wa+16|0;f[Ua>>2]=(f[Ua>>2]|0)+1;Ua=f[ua+120>>2]|0;ua=Ua;Wa=UIc(f[ua>>2]|0,f[ua+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;ua=Ua;f[ua>>2]=Wa;f[ua+4>>2]=J;ua=Ua+8|0;Ua=ua;Wa=UIc(f[Ua>>2]|0,f[Ua+4>>2]|0,bb|0,ab|0)|0;Ua=ua;f[Ua>>2]=Wa;f[Ua+4>>2]=J;break}else{f[Ya>>2]=r;Ya=f[Oa>>2]|0;Ua=(f[Ya+20>>2]|0)+(Y(f[f[Ya+48>>2]>>2]|0,r)|0)|0;Wa=f[Ua>>2]|0;f[Ua>>2]=(Wa|0)>(qa|0)?qa:Wa;Wa=Ua+8|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)<(qa|0)?qa:ua;ua=Ua+4|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=Ua+12|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ua+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[Ya+120>>2]|0;Ya=ua+(r<<4)|0;Ua=Ya;Wa=UIc(f[Ua>>2]|0,f[Ua+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;qa=Ya;f[qa>>2]=Wa;f[qa+4>>2]=J;qa=ua+(r<<4)+8|0;r=qa;ua=UIc(f[r>>2]|0,f[r+4>>2]|0,bb|0,ab|0)|0;r=qa;f[r>>2]=ua;f[r+4>>2]=J;break}}}else{f[Za>>2]=0;r=f[Oa>>2]|0;ua=f[r+20>>2]|0;qa=f[ua>>2]|0;f[ua>>2]=(qa|0)>($a|0)?$a:qa;qa=ua+8|0;Wa=f[qa>>2]|0;f[qa>>2]=(Wa|0)<($a|0)?$a:Wa;Wa=ua+4|0;qa=f[Wa>>2]|0;f[Wa>>2]=(qa|0)>(a|0)?a:qa;qa=ua+12|0;Wa=f[qa>>2]|0;f[qa>>2]=(Wa|0)<(a|0)?a:Wa;Wa=ua+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[r+120>>2]|0;r=(($a|0)<0)<<31>>31;ua=Wa;qa=UIc(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,r|0)|0;ua=Wa;f[ua>>2]=qa;f[ua+4>>2]=J;ua=Wa+8|0;Wa=ua;qa=UIc(f[Wa>>2]|0,f[Wa+4>>2]|0,a|0,x|0)|0;Wa=ua;f[Wa>>2]=qa;f[Wa+4>>2]=J;Wa=$a|1;qa=f[h>>2]|0;if((Wa|0)<(f[qa+12>>2]|0)){f[_a+(Wa<<2)>>2]=0;ua=f[Oa>>2]|0;Ya=f[ua+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>(Wa|0)?Wa:Ua;Ua=Ya+8|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)<(Wa|0)?Wa:Va;Va=Ya+4|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)>(a|0)?a:Ua;Ua=Ya+12|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)<(a|0)?a:Va;Va=Ya+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[ua+120>>2]|0;ua=((Wa|0)<0)<<31>>31;Ya=Va;Ua=UIc(f[Ya>>2]|0,f[Ya+4>>2]|0,Wa|0,ua|0)|0;Ya=Va;f[Ya>>2]=Ua;f[Ya+4>>2]=J;Ya=Va+8|0;Va=Ya;Ua=UIc(f[Va>>2]|0,f[Va+4>>2]|0,a|0,x|0)|0;Va=Ya;f[Va>>2]=Ua;f[Va+4>>2]=J;if((bb|0)>=(f[(f[h>>2]|0)+8>>2]|0))break;f[Ja+($a<<2)>>2]=0;f[Ja+(Wa<<2)>>2]=0;Va=f[Oa>>2]|0;Ua=f[Va+20>>2]|0;Ya=f[Ua>>2]|0;f[Ua>>2]=(Ya|0)>($a|0)?$a:Ya;Ya=Ua+8|0;Xa=f[Ya>>2]|0;f[Ya>>2]=(Xa|0)<($a|0)?$a:Xa;Xa=Ua+4|0;Ya=f[Xa>>2]|0;f[Xa>>2]=(Ya|0)>(bb|0)?bb:Ya;Ya=Ua+12|0;Xa=f[Ya>>2]|0;f[Ya>>2]=(Xa|0)<(bb|0)?bb:Xa;Xa=Ua+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[Va+120>>2]|0;Va=Xa;Ua=UIc(f[Va>>2]|0,f[Va+4>>2]|0,$a|0,r|0)|0;Va=Xa;f[Va>>2]=Ua;f[Va+4>>2]=J;Va=Xa+8|0;Xa=Va;Ua=UIc(f[Xa>>2]|0,f[Xa+4>>2]|0,bb|0,ab|0)|0;Xa=Va;f[Xa>>2]=Ua;f[Xa+4>>2]=J;Xa=f[Oa>>2]|0;Ua=f[Xa+20>>2]|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)>(Wa|0)?Wa:Va;Va=Ua+8|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)<(Wa|0)?Wa:Ya;Ya=Ua+4|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)>(bb|0)?bb:Va;Va=Ua+12|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)<(bb|0)?bb:Ya;Ya=Ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[Xa+120>>2]|0;Xa=Ya;Ua=UIc(f[Xa>>2]|0,f[Xa+4>>2]|0,Wa|0,ua|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;ua=Ya+8|0;Ya=ua;Ua=UIc(f[Ya>>2]|0,f[Ya+4>>2]|0,bb|0,ab|0)|0;Ya=ua;f[Ya>>2]=Ua;f[Ya+4>>2]=J;break}else{if((bb|0)>=(f[qa+8>>2]|0))break;f[Ja+($a<<2)>>2]=0;qa=f[Oa>>2]|0;Ya=f[qa+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=Ya+8|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<($a|0)?$a:ua;ua=Ya+4|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>(bb|0)?bb:Ua;Ua=Ya+12|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ya+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[qa+120>>2]|0;qa=ua;Ya=UIc(f[qa>>2]|0,f[qa+4>>2]|0,$a|0,r|0)|0;r=ua;f[r>>2]=Ya;f[r+4>>2]=J;r=ua+8|0;ua=r;Ya=UIc(f[ua>>2]|0,f[ua+4>>2]|0,bb|0,ab|0)|0;ua=r;f[ua>>2]=Ya;f[ua+4>>2]=J;break}}while(0);$a=$a+2|0;Za=f[h>>2]|0;g=f[Za+12>>2]|0}while(($a|0)<(g|0));hb=g;ib=Za}else{hb=Pa;ib=e}a=a+2|0;if((a|0)>=(c|0))break;else{e=ib;Pa=hb}}return}}function _aa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+80|0;d=c;e=c+16|0;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;j=e+48|0;k=e+44|0;f[k>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[d>>2]=b;f[d+4>>2]=5;XS(e,2,d,4);l=a+4|0;m=e+36|0;n=f[m>>2]|0;if((l|0)==(e|0))o=n;else{if(n|0){p=n+12|0;f[p>>2]=(f[p>>2]|0)+1}p=a+40|0;n=f[p>>2]|0;if(n|0?(q=n+12|0,n=f[q>>2]|0,f[q>>2]=n+-1,(n|0)==1):0)_S(l);f[p>>2]=0;n=a+20|0;q=a+8|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[q>>2]|0)>0){r=f[a+44>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0;t=f[q>>2]|0}while((s|0)<(t|0));f[l>>2]=f[e>>2];if((t|0)<3)v=12;else v=14}else{f[l>>2]=f[e>>2];v=12}if((v|0)==12){t=f[g>>2]|0;if((t|0)<3){f[q>>2]=t;f[a+12>>2]=f[h>>2];f[a+16>>2]=f[e+12>>2];h=f[k>>2]|0;t=f[a+48>>2]|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2]}else v=14}if((v|0)==14)ZS(l,e);f[n>>2]=f[e+16>>2];f[a+24>>2]=f[e+20>>2];f[a+28>>2]=f[e+24>>2];f[a+32>>2]=f[e+28>>2];f[a+36>>2]=f[e+32>>2];n=f[m>>2]|0;f[p>>2]=n;o=n}if(o|0?(n=o+12|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)_S(e);f[m>>2]=0;m=e+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[g>>2]|0)>0){m=f[i>>2]|0;i=0;do{f[m+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[k>>2]|0;if((g|0)!=(j|0))g0(g);if((b|0)>0){g=f[a+20>>2]|0;j=f[a+48>>2]|0;k=0;do{i=g+(Y(f[j>>2]|0,k)|0)|0;f[i>>2]=2147483647;f[i+4>>2]=2147483647;f[i+8>>2]=-2147483648;f[i+12>>2]=-2147483648;f[i+16>>2]=0;k=k+1|0}while((k|0)!=(b|0))}k=a+120|0;j=a+124|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;a=f[j>>2]|0;g=f[k>>2]|0;i=a-g>>4;m=a;if(i>>>0<b>>>0){$aa(k,b-i|0,d);u=c;return}if(i>>>0<=b>>>0){u=c;return}i=g+(b<<4)|0;if((m|0)==(i|0)){u=c;return}f[j>>2]=m+(~((m+-16-i|0)>>>4)<<4);u=c;return}function $aa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>4>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];f[j+12>>2]=f[c+12>>2];j=(f[g>>2]|0)+16|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>4;h=j+b|0;if(h>>>0>268435455)mCc(a);k=e-i|0;i=k>>3;e=k>>4>>>0<134217727?(i>>>0<h>>>0?h:i):268435455;do if(e)if(e>>>0>268435455){i=af(8)|0;bEc(i,503977);f[i>>2]=185532;ig(i|0,23696,1627)}else{l=VDc(e<<4)|0;break}else l=0;while(0);i=l+(j<<4)|0;j=l+(e<<4)|0;e=b;b=i;l=i;do{f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];b=l+16|0;l=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>4)<<4)|0;if((b|0)>0)dJc(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=l;f[d>>2]=j;if(!e)return;YDc(e);return}function aba(a){a=a|0;YDc(a);return}function bba(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=c+4|0;c=f[d>>2]|0;g=a+16|0;h=f[g>>2]|0;f[h+(e<<2)>>2]=((c|0)%2|0)+c;c=e+1|0;i=a+8|0;j=(Y(((f[(f[i>>2]|0)+12>>2]|0)+1|0)/2|0,(c|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+8>>2]|0;n=f[l+12>>2]|0;if((e|0)>=(f[d>>2]|0)){o=j;p=h;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}h=(n|0)>0;l=a+12|0;a=e;s=j;while(1){t=f[k>>2]|0;u=f[f[t+44>>2]>>2]|0;v=(f[t+16>>2]|0)+(Y(u,a)|0)|0;t=0-u|0;w=v+t|0;x=w+t|0;t=v+u|0;u=f[i>>2]|0;y=f[f[u+44>>2]>>2]|0;z=(f[u+16>>2]|0)+(Y(y,a)|0)|0;u=0-y|0;y=z+u+u|0;if(h){u=(a+1|0)<(m|0);A=(a|0)>(e|0);B=A^1;C=(a|0)>(c|0);D=0;E=s;while(1){a:do if(!(b[v+D>>0]|0)){F=D|1;G=(F|0)<(n|0);if(u?b[t+D>>0]|0:0){H=D+-1|0;I=(D|0)>0;if(G?b[v+F>>0]|0:0){if(I){if(b[v+H>>0]|0){do if(A){if(b[w+F>>0]|0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;K=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}do if((K|0)>-1){if(!(b[w+K>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}L=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;O=M;while(1){P=f[L+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((M|0)==(N|0))Q=O;else{P=N;while(1){R=f[L+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(O|0)>(P|0)?P:O;S=N;do{T=L+(S<<2)|0;U=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(U|0));Q=R}R=M;do{S=L+(R<<2)|0;N=R;R=f[S>>2]|0;f[S>>2]=Q}while((R|0)<(N|0));f[z+(D<<2)>>2]=Q;J=E;break a}while(0);R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[z+(K<<2)>>2]|0;N=L;while(1){S=f[R+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((L|0)==(M|0))V=N;else{K=M;while(1){S=f[R+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}S=(N|0)>(K|0)?K:N;O=M;do{P=R+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=S}while((O|0)<(U|0));V=S}S=L;do{O=R+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=V}while((S|0)<(M|0));f[z+(D<<2)>>2]=V;J=E;break a}while(0);S=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;M=R;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((R|0)==(L|0))W=M;else{O=L;while(1){N=f[S+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}N=(M|0)>(O|0)?O:M;K=L;do{U=S+(K<<2)|0;P=K;K=f[U>>2]|0;f[U>>2]=N}while((K|0)<(P|0));W=N}N=R;do{K=S+(N<<2)|0;L=N;N=f[K>>2]|0;f[K>>2]=W}while((N|0)<(L|0));f[z+(D<<2)>>2]=W;J=E;break a}N=D+2|0;if((N|0)>=(n|0))break;if(!(b[w+N>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;K=R;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((R|0)==(L|0))X=K;else{M=L;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;P=L;do{U=S+(P<<2)|0;T=P;P=f[U>>2]|0;f[U>>2]=O}while((P|0)<(T|0));X=O}O=R;do{P=S+(O<<2)|0;L=O;O=f[P>>2]|0;f[P>>2]=X}while((O|0)<(L|0));f[z+(D<<2)>>2]=X;J=E;break a}O=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}do if((O|0)>-1){if(!(b[w+O>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(O<<2)>>2]|0;P=R;while(1){K=f[S+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((R|0)==(L|0))Z=P;else{K=L;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(P|0)>(K|0)?K:P;T=L;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=M}while((T|0)<(_|0));Z=M}M=R;do{T=S+(M<<2)|0;L=M;M=f[T>>2]|0;f[T>>2]=Z}while((M|0)<(L|0));f[z+(D<<2)>>2]=Z;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(N<<2)>>2]|0;R=f[z+(O<<2)>>2]|0;L=S;while(1){T=f[M+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((S|0)==(R|0))$=L;else{O=R;while(1){T=f[M+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}T=(L|0)>(O|0)?O:L;P=R;do{K=M+(P<<2)|0;_=P;P=f[K>>2]|0;f[K>>2]=T}while((P|0)<(_|0));$=T}T=S;do{P=M+(T<<2)|0;R=T;T=f[P>>2]|0;f[P>>2]=$}while((T|0)<(R|0));f[z+(D<<2)>>2]=$;J=E;break a}while(0);T=f[l>>2]|0;M=f[y+(N<<2)>>2]|0;S=f[z+(D+-2<<2)>>2]|0;R=M;while(1){P=f[T+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(S|0))aa=R;else{N=S;while(1){P=f[T+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;L=S;do{O=T+(L<<2)|0;_=L;L=f[O>>2]|0;f[O>>2]=P}while((L|0)<(_|0));aa=P}P=M;do{L=T+(P<<2)|0;S=P;P=f[L>>2]|0;f[L>>2]=aa}while((P|0)<(S|0));f[z+(D<<2)>>2]=aa;J=E;break a}while(0);f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[t+H>>0]|0){do if(A){if(b[w+F>>0]|0){P=D+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=T;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=S;while(1){R=f[M+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((S|0)==(T|0))ba=L;else{R=T;while(1){N=f[M+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(L|0)>(R|0)?R:L;_=T;do{O=M+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=N}while((_|0)<(K|0));ba=N}N=S;do{_=M+(N<<2)|0;T=N;N=f[_>>2]|0;f[_>>2]=ba}while((N|0)<(T|0));f[z+(D<<2)>>2]=ba;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;T=M;while(1){_=f[N+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((M|0)==(S|0))ca=T;else{_=S;while(1){L=f[N+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(T|0)>(_|0)?_:T;R=S;do{K=N+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=L}while((R|0)<(O|0));ca=L}L=M;do{R=N+(L<<2)|0;S=L;L=f[R>>2]|0;f[R>>2]=ca}while((L|0)<(S|0));f[z+(D<<2)>>2]=ca;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;L=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=M;while(1){R=f[N+(S<<2)>>2]|0;if((R|0)<(S|0))S=R;else break}if((M|0)==(L|0))da=S;else{R=L;while(1){T=f[N+(R<<2)>>2]|0;if((T|0)<(R|0))R=T;else break}T=(S|0)>(R|0)?R:S;_=L;do{O=N+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=T}while((_|0)<(K|0));da=T}T=M;do{_=N+(T<<2)|0;L=T;T=f[_>>2]|0;f[_>>2]=da}while((T|0)<(L|0));f[z+(D<<2)>>2]=da;J=E;break a}while(0);T=f[l>>2]|0;N=f[y+(D<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;L=N;while(1){_=f[T+(L<<2)>>2]|0;if((_|0)<(L|0))L=_;else break}if((N|0)==(M|0))ea=L;else{_=M;while(1){S=f[T+(_<<2)>>2]|0;if((S|0)<(_|0))_=S;else break}S=(L|0)>(_|0)?_:L;R=M;do{K=T+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=S}while((R|0)<(O|0));ea=S}S=N;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ea}while((S|0)<(M|0));f[z+(D<<2)>>2]=ea;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;N=f[z+(P<<2)>>2]|0;M=T;while(1){R=f[S+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((T|0)==(N|0))fa=M;else{P=N;while(1){R=f[S+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(M|0)>(P|0)?P:M;L=N;do{_=S+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(O|0));fa=R}R=T;do{L=S+(R<<2)|0;N=R;R=f[L>>2]|0;f[L>>2]=fa}while((R|0)<(N|0));f[z+(D<<2)>>2]=fa;J=E;break a}R=D+2|0;do if(!((R|0)>=(n|0)|B)){if(!(b[w+R>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;S=D+-2|0;do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}N=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=L;while(1){P=f[N+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((L|0)==(T|0))ga=M;else{P=T;while(1){O=f[N+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(M|0)>(P|0)?P:M;_=T;do{K=N+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=O}while((_|0)<(U|0));ga=O}O=L;do{_=N+(O<<2)|0;T=O;O=f[_>>2]|0;f[_>>2]=ga}while((O|0)<(T|0));f[z+(D<<2)>>2]=ga;J=E;break a}if(!(b[w+S>>0]|0)){O=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;L=f[z+(S<<2)>>2]|0;T=N;while(1){_=f[O+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((N|0)==(L|0))ha=T;else{_=L;while(1){M=f[O+(_<<2)>>2]|0;if((M|0)<(_|0))_=M;else break}M=(T|0)>(_|0)?_:T;P=L;do{U=O+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=M}while((P|0)<(K|0));ha=M}M=N;do{P=O+(M<<2)|0;L=M;M=f[P>>2]|0;f[P>>2]=ha}while((M|0)<(L|0));f[z+(D<<2)>>2]=ha;J=E;break a}if(!(b[x+H>>0]|0)){M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=f[z+(S<<2)>>2]|0;L=O;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((O|0)==(N|0))ia=L;else{P=N;while(1){T=f[M+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(L|0)>(P|0)?P:L;_=N;do{K=M+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=T}while((_|0)<(U|0));ia=T}T=O;do{_=M+(T<<2)|0;N=T;T=f[_>>2]|0;f[_>>2]=ia}while((T|0)<(N|0));f[z+(D<<2)>>2]=ia;J=E;break a}T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=O;while(1){_=f[M+(N<<2)>>2]|0;if((_|0)<(N|0))N=_;else break}if((O|0)==(T|0))ja=N;else{_=T;while(1){L=f[M+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(N|0)>(_|0)?_:N;P=T;do{U=M+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=L}while((P|0)<(K|0));ja=L}L=O;do{P=M+(L<<2)|0;T=L;L=f[P>>2]|0;f[P>>2]=ja}while((L|0)<(T|0));f[z+(D<<2)>>2]=ja;J=E;break a}while(0);L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(S<<2)>>2]|0;T=M;while(1){P=f[L+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}if((M|0)==(O|0))ka=T;else{S=O;while(1){P=f[L+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(T|0)>(S|0)?S:T;N=O;do{_=L+(N<<2)|0;K=N;N=f[_>>2]|0;f[_>>2]=P}while((N|0)<(K|0));ka=P}P=M;do{N=L+(P<<2)|0;O=P;P=f[N>>2]|0;f[N>>2]=ka}while((P|0)<(O|0));f[z+(D<<2)>>2]=ka;J=E;break a}while(0);P=D+-2|0;if(!(b[w+D>>0]|0)){L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;N=M;while(1){T=f[L+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((M|0)==(O|0))la=N;else{T=O;while(1){S=f[L+(T<<2)>>2]|0;if((S|0)<(T|0))T=S;else break}S=(N|0)>(T|0)?T:N;K=O;do{_=L+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=S}while((K|0)<(U|0));la=S}S=M;do{K=L+(S<<2)|0;O=S;S=f[K>>2]|0;f[K>>2]=la}while((S|0)<(O|0));f[z+(D<<2)>>2]=la;J=E;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){S=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))ma=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));ma=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=ma}while((N|0)<(M|0));f[z+(D<<2)>>2]=ma;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=f[y+(R<<2)>>2]|0;M=S;while(1){T=f[N+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((S|0)==(L|0))na=M;else{T=L;while(1){O=f[N+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(M|0)>(T|0)?T:M;K=L;do{_=N+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=O}while((K|0)<(U|0));na=O}O=S;do{K=N+(O<<2)|0;L=O;O=f[K>>2]|0;f[K>>2]=na}while((O|0)<(L|0));O=f[z+(P<<2)>>2]|0;S=na;while(1){L=f[N+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((na|0)==(O|0))oa=S;else{L=O;while(1){K=f[N+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(S|0)>(L|0)?L:S;M=O;do{T=N+(M<<2)|0;U=M;M=f[T>>2]|0;f[T>>2]=K}while((M|0)<(U|0));oa=K}K=na;do{M=N+(K<<2)|0;O=K;K=f[M>>2]|0;f[M>>2]=oa}while((K|0)<(O|0));f[z+(D<<2)>>2]=oa;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;K=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;M=N;while(1){S=f[K+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((N|0)==(O|0))pa=M;else{S=O;while(1){L=f[K+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}L=(M|0)>(S|0)?S:M;U=O;do{T=K+(U<<2)|0;_=U;U=f[T>>2]|0;f[T>>2]=L}while((U|0)<(_|0));pa=L}L=N;do{U=K+(L<<2)|0;O=L;L=f[U>>2]|0;f[U>>2]=pa}while((L|0)<(O|0));f[z+(D<<2)>>2]=pa;J=E;break a}while(0);L=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;N=f[y+(R<<2)>>2]|0;O=K;while(1){U=f[L+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((K|0)==(N|0))qa=O;else{U=N;while(1){M=f[L+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=N;do{_=L+(S<<2)|0;T=S;S=f[_>>2]|0;f[_>>2]=M}while((S|0)<(T|0));qa=M}M=K;do{S=L+(M<<2)|0;N=M;M=f[S>>2]|0;f[S>>2]=qa}while((M|0)<(N|0));M=f[z+(P<<2)>>2]|0;K=qa;while(1){N=f[L+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}if((qa|0)==(M|0))ra=K;else{N=M;while(1){S=f[L+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}S=(K|0)>(N|0)?N:K;O=M;do{U=L+(O<<2)|0;T=O;O=f[U>>2]|0;f[U>>2]=S}while((O|0)<(T|0));ra=S}S=qa;do{O=L+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=ra}while((S|0)<(M|0));f[z+(D<<2)>>2]=ra;J=E;break a}while(0);S=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[y+(R<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))sa=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));sa=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=sa}while((N|0)<(M|0));N=f[z+(P<<2)>>2]|0;L=sa;while(1){M=f[S+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((sa|0)==(N|0))ta=L;else{P=N;while(1){M=f[S+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(L|0)>(P|0)?P:L;T=N;do{O=S+(T<<2)|0;K=T;T=f[O>>2]|0;f[O>>2]=M}while((T|0)<(K|0));ta=M}M=sa;do{T=S+(M<<2)|0;N=M;M=f[T>>2]|0;f[T>>2]=ta}while((M|0)<(N|0));f[z+(D<<2)>>2]=ta;J=E;break a}while(0);R=D+-2|0;if(!(b[w+D>>0]|0)){ua=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}if(!(b[w+R>>0]|0)){M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;N=f[z+(R<<2)>>2]|0;T=S;while(1){L=f[M+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}if((S|0)==(N|0))va=T;else{L=N;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(T|0)>(L|0)?L:T;K=N;do{O=M+(K<<2)|0;_=K;K=f[O>>2]|0;f[O>>2]=P}while((K|0)<(_|0));va=P}P=S;do{K=M+(P<<2)|0;N=P;P=f[K>>2]|0;f[K>>2]=va}while((P|0)<(N|0));f[z+(D<<2)>>2]=va;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);P=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;N=M;while(1){K=f[P+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((M|0)==(S|0))wa=N;else{K=S;while(1){T=f[P+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(N|0)>(K|0)?K:N;L=S;do{_=P+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=T}while((L|0)<(O|0));wa=T}T=M;do{L=P+(T<<2)|0;S=T;T=f[L>>2]|0;f[L>>2]=wa}while((T|0)<(S|0));f[z+(D<<2)>>2]=wa;J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(R<<2)>>2]|0;S=P;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((P|0)==(M|0))xa=S;else{R=M;while(1){L=f[T+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(S|0)>(R|0)?R:S;N=M;do{K=T+(N<<2)|0;O=N;N=f[K>>2]|0;f[K>>2]=L}while((N|0)<(O|0));xa=L}L=P;do{N=T+(L<<2)|0;M=L;L=f[N>>2]|0;f[N>>2]=xa}while((L|0)<(M|0));f[z+(D<<2)>>2]=xa;J=E;break a}else ua=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(ua<<2)>>2];J=E;break}}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}L=D+2|0;if(!((L|0)>=(n|0)|B)?b[w+L>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(L<<2)>>2]|0;N=P;while(1){S=f[T+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((P|0)==(M|0))ya=N;else{L=M;while(1){S=f[T+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(N|0)>(L|0)?L:N;R=M;do{O=T+(R<<2)|0;K=R;R=f[O>>2]|0;f[O>>2]=S}while((R|0)<(K|0));ya=S}S=P;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ya}while((S|0)<(M|0));f[z+(D<<2)>>2]=ya;J=E;break}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(I){if(b[t+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[v+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}do if(G){if(!(b[v+F>>0]|0)){if(!u)break;if(!(b[t+F>>0]|0))break;f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(S<<2)>>2]|0;R=P;while(1){N=f[T+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(M|0))za=R;else{S=M;while(1){N=f[T+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(R|0)>(S|0)?S:R;L=M;do{K=T+(L<<2)|0;O=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(O|0));za=N}N=P;do{L=T+(N<<2)|0;M=N;N=f[L>>2]|0;f[L>>2]=za}while((N|0)<(M|0));f[z+(D<<2)>>2]=za;J=E;break a}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}while(0);f[z+(D<<2)>>2]=0;J=E}else{F=D+-1|0;G=(D|0)>0;if(G){if(b[v+F>>0]|0){H=D|1;I=(H|0)<(n|0);if(A&I?b[w+H>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(C?b[x+D>>0]|0:0){N=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break}do if((N|0)>-1){if(!(b[w+N>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break a}T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(N<<2)>>2]|0;L=P;while(1){R=f[T+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((P|0)==(M|0))Aa=L;else{R=M;while(1){S=f[T+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}S=(L|0)>(R|0)?R:L;O=M;do{K=T+(O<<2)|0;_=O;O=f[K>>2]|0;f[K>>2]=S}while((O|0)<(_|0));Aa=S}S=P;do{O=T+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=Aa}while((S|0)<(M|0));f[z+(D<<2)>>2]=Aa;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;M=T;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((T|0)==(P|0))Ba=M;else{N=P;while(1){O=f[S+(N<<2)>>2]|0;if((O|0)<(N|0))N=O;else break}O=(M|0)>(N|0)?N:M;L=P;do{R=S+(L<<2)|0;_=L;L=f[R>>2]|0;f[R>>2]=O}while((L|0)<(_|0));Ba=O}O=T;do{L=S+(O<<2)|0;P=O;O=f[L>>2]|0;f[L>>2]=Ba}while((O|0)<(P|0));f[z+(D<<2)>>2]=Ba;J=E;break}O=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;P=S;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((S|0)==(T|0))Ca=P;else{L=T;while(1){M=f[O+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(P|0)>(L|0)?L:P;N=T;do{_=O+(N<<2)|0;R=N;N=f[_>>2]|0;f[_>>2]=M}while((N|0)<(R|0));Ca=M}M=S;do{N=O+(M<<2)|0;T=M;M=f[N>>2]|0;f[N>>2]=Ca}while((M|0)<(T|0));f[z+(D<<2)>>2]=Ca;J=E;break}if(I?b[v+H>>0]|0:0){M=D+2|0;if(A&(M|0)<(n|0)?b[w+M>>0]|0:0){do if(C){if(!(b[x+H>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;N=S;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((S|0)==(T|0))Da=N;else{P=T;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=T;do{_=O+(R<<2)|0;K=R;R=f[_>>2]|0;f[_>>2]=L}while((R|0)<(K|0));Da=L}L=S;do{R=O+(L<<2)|0;T=L;L=f[R>>2]|0;f[R>>2]=Da}while((L|0)<(T|0));f[z+(D<<2)>>2]=Da;J=E;break a}L=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}do if((L|0)>-1){if(!(b[w+L>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(L<<2)>>2]|0;R=S;while(1){N=f[O+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((S|0)==(T|0))Ea=R;else{N=T;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;K=T;do{_=O+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=P}while((K|0)<(U|0));Ea=P}P=S;do{K=O+(P<<2)|0;T=P;P=f[K>>2]|0;f[K>>2]=Ea}while((P|0)<(T|0));f[z+(D<<2)>>2]=Ea;J=E;break a}while(0);P=f[l>>2]|0;O=f[y+(M<<2)>>2]|0;S=f[z+(L<<2)>>2]|0;T=O;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((O|0)==(S|0))Fa=T;else{L=S;while(1){K=f[P+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(T|0)>(L|0)?L:T;R=S;do{N=P+(R<<2)|0;U=R;R=f[N>>2]|0;f[N>>2]=K}while((R|0)<(U|0));Fa=K}K=O;do{R=P+(K<<2)|0;S=K;K=f[R>>2]|0;f[R>>2]=Fa}while((K|0)<(S|0));f[z+(D<<2)>>2]=Fa;J=E;break a}while(0);H=f[l>>2]|0;I=f[y+(M<<2)>>2]|0;K=f[z+(D+-2<<2)>>2]|0;P=I;while(1){O=f[H+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}if((I|0)==(K|0))Ga=P;else{M=K;while(1){O=f[H+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(P|0)>(M|0)?M:P;S=K;do{R=H+(S<<2)|0;T=S;S=f[R>>2]|0;f[R>>2]=O}while((S|0)<(T|0));Ga=O}O=I;do{S=H+(O<<2)|0;K=O;O=f[S>>2]|0;f[S>>2]=Ga}while((O|0)<(K|0));f[z+(D<<2)>>2]=Ga;J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(u?b[t+F>>0]|0:0){O=D|1;H=(O|0)<(n|0);if(!(B|H^1)?b[w+O>>0]|0:0){I=D+-2|0;if((I|0)>-1?b[v+I>>0]|0:0){if(b[w+F>>0]|0){K=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=K;J=E;break a}while(0);S=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=P;while(1){T=f[S+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((P|0)==(K|0))Ha=M;else{T=K;while(1){R=f[S+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(M|0)>(T|0)?T:M;L=K;do{U=S+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Ha=R}R=P;do{L=S+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=Ha}while((R|0)<(K|0));f[z+(D<<2)>>2]=Ha;J=E;break}if(!(b[w+I>>0]|0)){R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=f[z+(I<<2)>>2]|0;K=S;while(1){L=f[R+(K<<2)>>2]|0;if((L|0)<(K|0))K=L;else break}if((S|0)==(P|0))Ia=K;else{L=P;while(1){M=f[R+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(K|0)>(L|0)?L:K;T=P;do{N=R+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=M}while((T|0)<(U|0));Ia=M}M=S;do{T=R+(M<<2)|0;P=M;M=f[T>>2]|0;f[T>>2]=Ia}while((M|0)<(P|0));f[z+(D<<2)>>2]=Ia;J=E;break}do if(C){if(!(b[x+F>>0]|0))break;M=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=S;while(1){T=f[R+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}if((S|0)==(M|0))Ja=P;else{T=M;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(P|0)>(T|0)?T:P;L=M;do{U=R+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=K}while((L|0)<(N|0));Ja=K}K=S;do{L=R+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=Ja}while((K|0)<(M|0));f[z+(D<<2)>>2]=Ja;J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;M=R;while(1){L=f[K+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}if((R|0)==(S|0))Ka=M;else{L=S;while(1){P=f[K+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(M|0)>(L|0)?L:M;T=S;do{N=K+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=P}while((T|0)<(U|0));Ka=P}P=R;do{T=K+(P<<2)|0;S=P;P=f[T>>2]|0;f[T>>2]=Ka}while((P|0)<(S|0));f[z+(D<<2)>>2]=Ka;J=E;break}if(b[w+D>>0]|0){P=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;S=K;while(1){T=f[P+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((K|0)==(R|0))La=S;else{T=R;while(1){M=f[P+(T<<2)>>2]|0;if((M|0)<(T|0))T=M;else break}M=(S|0)>(T|0)?T:S;L=R;do{U=P+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=M}while((L|0)<(N|0));La=M}M=K;do{L=P+(M<<2)|0;R=M;M=f[L>>2]|0;f[L>>2]=La}while((M|0)<(R|0));f[z+(D<<2)>>2]=La;J=E;break}if(!(b[w+F>>0]|0)){M=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;K=f[z+(I<<2)>>2]|0;R=P;while(1){L=f[M+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(K|0))Ma=R;else{L=K;while(1){S=f[M+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(R|0)>(L|0)?L:R;T=K;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=S}while((T|0)<(U|0));Ma=S}S=P;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Ma}while((S|0)<(K|0));f[z+(D<<2)>>2]=Ma;J=E;break}S=f[y+(D<<2)>>2]|0;M=f[l>>2]|0;do if(C){if(!(b[x+D>>0]|0))break;P=f[z+(I<<2)>>2]|0;K=S;while(1){T=f[M+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((S|0)==(P|0))Na=K;else{T=P;while(1){R=f[M+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(K|0)>(T|0)?T:K;L=P;do{U=M+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Na=R}R=S;do{L=M+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Na}while((R|0)<(P|0));f[z+(D<<2)>>2]=Na;J=E;break a}while(0);R=f[y+(I<<2)>>2]|0;P=R;while(1){L=f[M+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((R|0)==(S|0))Oa=P;else{L=S;while(1){K=f[M+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(P|0)>(L|0)?L:P;T=S;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=K}while((T|0)<(U|0));Oa=K}K=R;do{T=M+(K<<2)|0;S=K;K=f[T>>2]|0;f[T>>2]=Oa}while((K|0)<(S|0));K=f[z+(I<<2)>>2]|0;R=Oa;while(1){S=f[M+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}if((Oa|0)==(K|0))Pa=R;else{I=K;while(1){S=f[M+(I<<2)>>2]|0;if((S|0)<(I|0))I=S;else break}S=(R|0)>(I|0)?I:R;T=K;do{P=M+(T<<2)|0;L=T;T=f[P>>2]|0;f[P>>2]=S}while((T|0)<(L|0));Pa=S}S=Oa;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Pa}while((S|0)<(K|0));f[z+(D<<2)>>2]=Pa;J=E;break}if(H?b[v+O>>0]|0:0){S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){M=D+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+F>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;K=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}T=f[l>>2]|0;R=f[y+(S<<2)>>2]|0;I=R;while(1){L=f[T+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((R|0)==(K|0))Qa=I;else{L=K;while(1){P=f[T+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(I|0)>(L|0)?L:I;U=K;do{N=T+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=P}while((U|0)<(_|0));Qa=P}P=R;do{U=T+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=Qa}while((P|0)<(K|0));f[z+(D<<2)>>2]=Qa;J=E;break a}while(0);P=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;K=T;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((T|0)==(R|0))Ra=K;else{U=R;while(1){I=f[P+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(K|0)>(U|0)?U:K;L=R;do{_=P+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=I}while((L|0)<(N|0));Ra=I}I=T;do{L=P+(I<<2)|0;R=I;I=f[L>>2]|0;f[L>>2]=Ra}while((I|0)<(R|0));f[z+(D<<2)>>2]=Ra;J=E;break a}do if(C){if(!(b[x+O>>0]|0))break;if(!(b[w+M>>0]|0)){I=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;T=f[z+(M<<2)>>2]|0;R=P;while(1){L=f[I+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(T|0))Sa=R;else{L=T;while(1){K=f[I+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(R|0)>(L|0)?L:R;U=T;do{N=I+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=K}while((U|0)<(_|0));Sa=K}K=P;do{U=I+(K<<2)|0;T=K;K=f[U>>2]|0;f[U>>2]=Sa}while((K|0)<(T|0));f[z+(D<<2)>>2]=Sa;J=E;break a}if(!(b[x+F>>0]|0)){K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=f[z+(M<<2)>>2]|0;T=I;while(1){U=f[K+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((I|0)==(P|0))Ta=T;else{U=P;while(1){R=f[K+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(T|0)>(U|0)?U:T;L=P;do{_=K+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(N|0));Ta=R}R=I;do{L=K+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Ta}while((R|0)<(P|0));f[z+(D<<2)>>2]=Ta;J=E;break a}R=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=I;while(1){L=f[K+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((I|0)==(R|0))Ua=P;else{L=R;while(1){T=f[K+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}T=(P|0)>(L|0)?L:P;U=R;do{N=K+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=T}while((U|0)<(_|0));Ua=T}T=I;do{U=K+(T<<2)|0;R=T;T=f[U>>2]|0;f[U>>2]=Ua}while((T|0)<(R|0));f[z+(D<<2)>>2]=Ua;J=E;break a}while(0);if(!(b[w+D>>0]|0)){T=f[l>>2]|0;K=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;R=K;while(1){U=f[T+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}if((K|0)==(I|0))Va=R;else{U=I;while(1){P=f[T+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}P=(R|0)>(U|0)?U:R;L=I;do{_=T+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=P}while((L|0)<(N|0));Va=P}P=K;do{L=T+(P<<2)|0;I=P;P=f[L>>2]|0;f[L>>2]=Va}while((P|0)<(I|0));f[z+(D<<2)>>2]=Va;J=E;break a}if(!(b[w+M>>0]|0)){P=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;K=f[y+(S<<2)>>2]|0;I=T;while(1){L=f[P+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(K|0))Wa=I;else{L=K;while(1){R=f[P+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}R=(I|0)>(L|0)?L:I;U=K;do{N=P+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=R}while((U|0)<(_|0));Wa=R}R=T;do{U=P+(R<<2)|0;K=R;R=f[U>>2]|0;f[U>>2]=Wa}while((R|0)<(K|0));R=f[z+(M<<2)>>2]|0;T=Wa;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((Wa|0)==(R|0))Xa=T;else{K=R;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}U=(T|0)>(K|0)?K:T;I=R;do{L=P+(I<<2)|0;_=I;I=f[L>>2]|0;f[L>>2]=U}while((I|0)<(_|0));Xa=U}U=Wa;do{I=P+(U<<2)|0;R=U;U=f[I>>2]|0;f[I>>2]=Xa}while((U|0)<(R|0));f[z+(D<<2)>>2]=Xa;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;U=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;I=P;while(1){T=f[U+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}if((P|0)==(R|0))Ya=I;else{T=R;while(1){K=f[U+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(I|0)>(T|0)?T:I;_=R;do{L=U+(_<<2)|0;N=_;_=f[L>>2]|0;f[L>>2]=K}while((_|0)<(N|0));Ya=K}K=P;do{_=U+(K<<2)|0;R=K;K=f[_>>2]|0;f[_>>2]=Ya}while((K|0)<(R|0));f[z+(D<<2)>>2]=Ya;J=E;break a}while(0);K=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;P=f[y+(S<<2)>>2]|0;R=U;while(1){_=f[K+(R<<2)>>2]|0;if((_|0)<(R|0))R=_;else break}if((U|0)==(P|0))Za=R;else{_=P;while(1){I=f[K+(_<<2)>>2]|0;if((I|0)<(_|0))_=I;else break}I=(R|0)>(_|0)?_:R;T=P;do{N=K+(T<<2)|0;L=T;T=f[N>>2]|0;f[N>>2]=I}while((T|0)<(L|0));Za=I}I=U;do{T=K+(I<<2)|0;P=I;I=f[T>>2]|0;f[T>>2]=Za}while((I|0)<(P|0));I=f[z+(M<<2)>>2]|0;U=Za;while(1){P=f[K+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((Za|0)==(I|0))_a=U;else{P=I;while(1){T=f[K+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(U|0)>(P|0)?P:U;R=I;do{_=K+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=T}while((R|0)<(L|0));_a=T}T=Za;do{R=K+(T<<2)|0;I=T;T=f[R>>2]|0;f[R>>2]=_a}while((T|0)<(I|0));f[z+(D<<2)>>2]=_a;J=E;break a}while(0);if(b[w+D>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;H=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;K=f[z+(M<<2)>>2]|0;I=T;while(1){R=f[H+(I<<2)>>2]|0;if((R|0)<(I|0))I=R;else break}if((T|0)==(K|0))$a=I;else{R=K;while(1){U=f[H+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}U=(I|0)>(R|0)?R:I;P=K;do{L=H+(P<<2)|0;_=P;P=f[L>>2]|0;f[L>>2]=U}while((P|0)<(_|0));$a=U}U=T;do{P=H+(U<<2)|0;K=U;U=f[P>>2]|0;f[P>>2]=$a}while((U|0)<(K|0));f[z+(D<<2)>>2]=$a;J=E;break a}while(0);U=f[l>>2]|0;H=f[y+(D<<2)>>2]|0;T=f[y+(S<<2)>>2]|0;K=H;while(1){P=f[U+(K<<2)>>2]|0;if((P|0)<(K|0))K=P;else break}if((H|0)==(T|0))ab=K;else{P=T;while(1){I=f[U+(P<<2)>>2]|0;if((I|0)<(P|0))P=I;else break}I=(K|0)>(P|0)?P:K;R=T;do{_=U+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=I}while((R|0)<(L|0));ab=I}I=H;do{R=U+(I<<2)|0;T=I;I=f[R>>2]|0;f[R>>2]=ab}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;H=ab;while(1){T=f[U+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}if((ab|0)==(I|0))bb=H;else{T=I;while(1){R=f[U+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(H|0)>(T|0)?T:H;K=I;do{P=U+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=R}while((K|0)<(L|0));bb=R}R=ab;do{K=U+(R<<2)|0;I=R;R=f[K>>2]|0;f[K>>2]=bb}while((R|0)<(I|0));f[z+(D<<2)>>2]=bb;J=E;break}if(!(b[w+F>>0]|0)){R=f[l>>2]|0;U=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;K=U;while(1){H=f[R+(K<<2)>>2]|0;if((H|0)<(K|0))K=H;else break}if((U|0)==(I|0))cb=K;else{H=I;while(1){T=f[R+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}T=(K|0)>(H|0)?H:K;L=I;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=T}while((L|0)<(_|0));cb=T}T=U;do{L=R+(T<<2)|0;I=T;T=f[L>>2]|0;f[L>>2]=cb}while((T|0)<(I|0));f[z+(D<<2)>>2]=cb;J=E;break}do if(C){if(!(b[x+O>>0]|0))break;T=f[y+(S<<2)>>2]|0;R=f[l>>2]|0;if(b[x+D>>0]|0){U=f[z+(M<<2)>>2]|0;I=T;while(1){L=f[R+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(U|0))db=I;else{L=U;while(1){K=f[R+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(I|0)>(L|0)?L:I;H=U;do{_=R+(H<<2)|0;P=H;H=f[_>>2]|0;f[_>>2]=K}while((H|0)<(P|0));db=K}K=T;do{H=R+(K<<2)|0;U=K;K=f[H>>2]|0;f[H>>2]=db}while((K|0)<(U|0));f[z+(D<<2)>>2]=db;J=E;break a}K=f[y+(M<<2)>>2]|0;U=K;while(1){H=f[R+(U<<2)>>2]|0;if((H|0)<(U|0))U=H;else break}if((K|0)==(T|0))eb=U;else{H=T;while(1){I=f[R+(H<<2)>>2]|0;if((I|0)<(H|0))H=I;else break}I=(U|0)>(H|0)?H:U;L=T;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=I}while((L|0)<(_|0));eb=I}I=K;do{L=R+(I<<2)|0;T=I;I=f[L>>2]|0;f[L>>2]=eb}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;K=eb;while(1){T=f[R+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((eb|0)==(I|0))fb=K;else{T=I;while(1){L=f[R+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}L=(K|0)>(T|0)?T:K;U=I;do{H=R+(U<<2)|0;_=U;U=f[H>>2]|0;f[H>>2]=L}while((U|0)<(_|0));fb=L}L=eb;do{U=R+(L<<2)|0;I=L;L=f[U>>2]|0;f[U>>2]=fb}while((L|0)<(I|0));f[z+(D<<2)>>2]=fb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(M<<2)>>2]|0;R=f[y+(S<<2)>>2]|0;I=L;while(1){U=f[O+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}if((L|0)==(R|0))gb=I;else{S=R;while(1){U=f[O+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(I|0)>(S|0)?S:I;K=R;do{T=O+(K<<2)|0;_=K;K=f[T>>2]|0;f[T>>2]=U}while((K|0)<(_|0));gb=U}U=L;do{K=O+(U<<2)|0;R=U;U=f[K>>2]|0;f[K>>2]=gb}while((U|0)<(R|0));U=f[z+(M<<2)>>2]|0;L=gb;while(1){R=f[O+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((gb|0)==(U|0))hb=L;else{M=U;while(1){R=f[O+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(L|0)>(M|0)?M:L;K=U;do{I=O+(K<<2)|0;S=K;K=f[I>>2]|0;f[I>>2]=R}while((K|0)<(S|0));hb=R}R=gb;do{K=O+(R<<2)|0;U=R;R=f[K>>2]|0;f[K>>2]=hb}while((R|0)<(U|0));f[z+(D<<2)>>2]=hb;J=E;break}do if(A){R=D+-2|0;if(b[w+F>>0]|0){O=f[z+(R<<2)>>2]|0;do if((R|0)>-1){if(!(b[v+R>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);U=f[l>>2]|0;K=f[y+(R<<2)>>2]|0;L=K;while(1){M=f[U+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(O|0))ib=L;else{M=O;while(1){S=f[U+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}S=(L|0)>(M|0)?M:L;I=O;do{_=U+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=S}while((I|0)<(T|0));ib=S}S=K;do{I=U+(S<<2)|0;O=S;S=f[I>>2]|0;f[I>>2]=ib}while((S|0)<(O|0));f[z+(D<<2)>>2]=ib;J=E;break a}if(!(b[w+D>>0]|0)){jb=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(!(b[w+R>>0]|0)){S=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;K=f[z+(R<<2)>>2]|0;O=U;while(1){I=f[S+(O<<2)>>2]|0;if((I|0)<(O|0))O=I;else break}if((U|0)==(K|0))kb=O;else{I=K;while(1){L=f[S+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(O|0)>(I|0)?I:O;M=K;do{T=S+(M<<2)|0;_=M;M=f[T>>2]|0;f[T>>2]=L}while((M|0)<(_|0));kb=L}L=U;do{M=S+(L<<2)|0;K=L;L=f[M>>2]|0;f[M>>2]=kb}while((L|0)<(K|0));f[z+(D<<2)>>2]=kb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;U=f[z+(R<<2)>>2]|0;K=S;while(1){M=f[L+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((S|0)==(U|0))lb=K;else{M=U;while(1){O=f[L+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;I=U;do{_=L+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=O}while((I|0)<(T|0));lb=O}O=S;do{I=L+(O<<2)|0;U=O;O=f[I>>2]|0;f[I>>2]=lb}while((O|0)<(U|0));f[z+(D<<2)>>2]=lb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;U=L;while(1){I=f[O+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}if((L|0)==(S|0))mb=U;else{R=S;while(1){I=f[O+(R<<2)>>2]|0;if((I|0)<(R|0))R=I;else break}I=(U|0)>(R|0)?R:U;K=S;do{M=O+(K<<2)|0;T=K;K=f[M>>2]|0;f[M>>2]=I}while((K|0)<(T|0));mb=I}I=L;do{K=O+(I<<2)|0;S=I;I=f[K>>2]|0;f[K>>2]=mb}while((I|0)<(S|0));f[z+(D<<2)>>2]=mb;J=E;break a}else jb=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(jb<<2)>>2];J=E;break}if(A){I=D+-2|0;if(b[w+F>>0]|0){O=f[z+(I<<2)>>2]|0;do if((I|0)>-1){if(!(b[v+I>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(I<<2)>>2]|0;K=S;while(1){U=f[L+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((S|0)==(O|0))nb=K;else{U=O;while(1){R=f[L+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(K|0)>(U|0)?U:K;T=O;do{M=L+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=R}while((T|0)<(_|0));nb=R}R=S;do{T=L+(R<<2)|0;O=R;R=f[T>>2]|0;f[T>>2]=nb}while((R|0)<(O|0));f[z+(D<<2)>>2]=nb;J=E;break}if(!(b[w+D>>0]|0))ob=I;else{do if((I|0)>-1){if(!(b[v+I>>0]|0))break;if(!(b[w+I>>0]|0)){R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;O=L;while(1){T=f[R+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((L|0)==(S|0))pb=O;else{T=S;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(O|0)>(T|0)?T:O;U=S;do{_=R+(U<<2)|0;M=U;U=f[_>>2]|0;f[_>>2]=K}while((U|0)<(M|0));pb=K}K=L;do{U=R+(K<<2)|0;S=K;K=f[U>>2]|0;f[U>>2]=pb}while((K|0)<(S|0));f[z+(D<<2)>>2]=pb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(I<<2)>>2];J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(I<<2)>>2]|0;S=R;while(1){U=f[K+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((R|0)==(L|0))qb=S;else{U=L;while(1){O=f[K+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;T=L;do{M=K+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=O}while((T|0)<(_|0));qb=O}O=R;do{T=K+(O<<2)|0;L=O;O=f[T>>2]|0;f[T>>2]=qb}while((O|0)<(L|0));f[z+(D<<2)>>2]=qb;J=E;break a}while(0);O=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;L=K;while(1){T=f[O+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((K|0)==(R|0))rb=L;else{I=R;while(1){T=f[O+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}T=(L|0)>(I|0)?I:L;S=R;do{U=O+(S<<2)|0;_=S;S=f[U>>2]|0;f[U>>2]=T}while((S|0)<(_|0));rb=T}T=K;do{S=O+(T<<2)|0;R=T;T=f[S>>2]|0;f[S>>2]=rb}while((T|0)<(R|0));f[z+(D<<2)>>2]=rb;J=E;break}}else ob=D+-2|0;f[z+(D<<2)>>2]=f[z+(ob<<2)>>2];J=E;break}}T=D|1;O=(T|0)<(n|0);if(!(B|O^1)?b[w+T>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(G?b[w+F>>0]|0:0){K=f[y+(D<<2)>>2]|0;if(C?b[x+D>>0]|0:0){f[z+(D<<2)>>2]=K;J=E;break}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;L=S;while(1){I=f[R+(L<<2)>>2]|0;if((I|0)<(L|0))L=I;else break}if((S|0)==(K|0))sb=L;else{I=K;while(1){_=f[R+(I<<2)>>2]|0;if((_|0)<(I|0))I=_;else break}_=(L|0)>(I|0)?I:L;U=K;do{M=R+(U<<2)|0;H=U;U=f[M>>2]|0;f[M>>2]=_}while((U|0)<(H|0));sb=_}_=S;do{U=R+(_<<2)|0;K=_;_=f[U>>2]|0;f[U>>2]=sb}while((_|0)<(K|0));f[z+(D<<2)>>2]=sb;J=E;break}f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(O?b[v+T>>0]|0:0){_=D+2|0;if(!((_|0)>=(n|0)|B)?b[w+_>>0]|0:0){if(b[w+D>>0]|0){if(C?b[x+T>>0]|0:0){f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;K=f[y+(_<<2)>>2]|0;U=S;while(1){L=f[R+(U<<2)>>2]|0;if((L|0)<(U|0))U=L;else break}if((S|0)==(K|0))tb=U;else{O=K;while(1){L=f[R+(O<<2)>>2]|0;if((L|0)<(O|0))O=L;else break}L=(U|0)>(O|0)?O:U;I=K;do{H=R+(I<<2)|0;M=I;I=f[H>>2]|0;f[H>>2]=L}while((I|0)<(M|0));tb=L}L=S;do{I=R+(L<<2)|0;K=L;L=f[I>>2]|0;f[I>>2]=tb}while((L|0)<(K|0));f[z+(D<<2)>>2]=tb;J=E;break}if(G?b[w+F>>0]|0:0){do if(C){if(!(b[x+T>>0]|0))break;L=f[y+(_<<2)>>2]|0;if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;K=S;while(1){I=f[R+(K<<2)>>2]|0;if((I|0)<(K|0))K=I;else break}if((S|0)==(L|0))ub=K;else{I=L;while(1){U=f[R+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}U=(K|0)>(I|0)?I:K;O=L;do{M=R+(O<<2)|0;H=O;O=f[M>>2]|0;f[M>>2]=U}while((O|0)<(H|0));ub=U}U=S;do{O=R+(U<<2)|0;L=U;U=f[O>>2]|0;f[O>>2]=ub}while((U|0)<(L|0));f[z+(D<<2)>>2]=ub;J=E;break a}while(0);T=f[l>>2]|0;U=f[y+(D+-2<<2)>>2]|0;R=f[y+(_<<2)>>2]|0;S=U;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((U|0)==(R|0))vb=S;else{L=R;while(1){O=f[T+(L<<2)>>2]|0;if((O|0)<(L|0))L=O;else break}O=(S|0)>(L|0)?L:S;K=R;do{I=T+(K<<2)|0;H=K;K=f[I>>2]|0;f[I>>2]=O}while((K|0)<(H|0));vb=O}O=U;do{K=T+(O<<2)|0;R=O;O=f[K>>2]|0;f[K>>2]=vb}while((O|0)<(R|0));f[z+(D<<2)>>2]=vb;J=E;break}f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0}while(0);D=D+2|0;if((D|0)>=(n|0)){wb=J;break}else E=J}}else wb=s;a=a+2|0;if((a|0)>=(f[d>>2]|0))break;else s=wb}o=wb;p=f[g>>2]|0;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}function cba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a+12>>2]|0;e=f[a+8>>2]|0;g=f[c>>2]|0;if((g|0)>=(e|0))return;h=f[a+16>>2]|0;i=f[a+44>>2]|0;a=(d|0)>0;j=d+-1|0;k=g;do{g=f[i>>2]|0;l=h+(Y(g,k)|0)|0;m=l+(0-g)|0;if(a){g=0;do{n=l+(g<<2)|0;o=f[n>>2]|0;if((o|0)>0){if((g|0)>0?(p=f[m+(g+-1<<2)>>2]|0,(p|0)>0):0){q=p;while(1){r=f[b+(q<<2)>>2]|0;if((r|0)<(q|0))q=r;else break}if((p|0)==(o|0))s=q;else{r=o;while(1){t=f[b+(r<<2)>>2]|0;if((t|0)<(r|0))r=t;else break}t=(q|0)>(r|0)?r:q;u=o;do{v=b+(u<<2)|0;w=u;u=f[v>>2]|0;f[v>>2]=t}while((u|0)<(w|0));s=t}t=p;do{u=b+(t<<2)|0;q=t;t=f[u>>2]|0;f[u>>2]=s}while((t|0)<(q|0));f[n>>2]=s;x=s}else x=o;if((g|0)<(j|0)?(t=f[m+(g+1<<2)>>2]|0,(t|0)>0):0){p=t;while(1){q=f[b+(p<<2)>>2]|0;if((q|0)<(p|0))p=q;else break}if((t|0)==(x|0))y=p;else{o=x;while(1){q=f[b+(o<<2)>>2]|0;if((q|0)<(o|0))o=q;else break}q=(p|0)>(o|0)?o:p;u=x;do{r=b+(u<<2)|0;w=u;u=f[r>>2]|0;f[r>>2]=q}while((u|0)<(w|0));y=q}q=t;do{u=b+(q<<2)|0;p=q;q=f[u>>2]|0;f[u>>2]=y}while((q|0)<(p|0));f[n>>2]=y;z=y}else z=x;q=f[m+(g<<2)>>2]|0;if((q|0)>0){t=q;while(1){p=f[b+(t<<2)>>2]|0;if((p|0)<(t|0))t=p;else break}if((q|0)==(z|0))A=t;else{p=z;while(1){u=f[b+(p<<2)>>2]|0;if((u|0)<(p|0))p=u;else break}u=(t|0)>(p|0)?p:t;o=z;do{w=b+(o<<2)|0;r=o;o=f[w>>2]|0;f[w>>2]=u}while((o|0)<(r|0));A=u}u=q;do{o=b+(u<<2)|0;t=u;u=f[o>>2]|0;f[o>>2]=A}while((u|0)<(t|0));f[n>>2]=A}}g=g+1|0}while((g|0)!=(d|0))}k=f[c+(k<<2)>>2]|0}while((k|0)<(e|0));return}function dba(a){a=a|0;YDc(a);return}function eba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>0){b=a+16|0;_aa((f[b>>2]|0)+(c*136|0)|0,f[f[a+20>>2]>>2]|0);e=f[b>>2]|0;f[e+(c*136|0)+132>>2]=d;if((c|0)>=(d|0))return;b=a+4|0;g=a+8|0;h=e+(c*136|0)+20|0;i=e+(c*136|0)+48|0;j=e+(c*136|0)+120|0;e=c;do{k=f[b>>2]|0;l=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,e)|0)|0;m=l+(f[k+12>>2]<<2)|0;if((l|0)!=(m|0)){k=f[g>>2]|0;n=f[h>>2]|0;o=f[i>>2]|0;p=f[j>>2]|0;q=((e|0)<0)<<31>>31;r=0;s=l;while(1){l=f[k+(f[s>>2]<<2)>>2]|0;f[s>>2]=l;t=n+(Y(f[o>>2]|0,l)|0)|0;u=f[t>>2]|0;f[t>>2]=(u|0)>(r|0)?r:u;u=t+8|0;v=f[u>>2]|0;f[u>>2]=(v|0)<(r|0)?r:v;v=t+4|0;u=f[v>>2]|0;f[v>>2]=(u|0)>(e|0)?e:u;u=t+12|0;v=f[u>>2]|0;f[u>>2]=(v|0)<(e|0)?e:v;v=t+16|0;f[v>>2]=(f[v>>2]|0)+1;v=p+(l<<4)|0;t=v;u=UIc(f[t>>2]|0,f[t+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;t=v;f[t>>2]=u;f[t+4>>2]=J;t=p+(l<<4)+8|0;l=t;u=UIc(f[l>>2]|0,f[l+4>>2]|0,e|0,q|0)|0;l=t;f[l>>2]=u;f[l+4>>2]=J;s=s+4|0;if((s|0)==(m|0))break;else r=r+1|0}}e=e+1|0}while((e|0)!=(d|0));return}else{e=a+12|0;f[(f[e>>2]|0)+132>>2]=d;if((c|0)>=(d|0))return;j=a+4|0;i=a+8|0;a=c;do{c=f[j>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,a)|0)|0;g=h+(f[c+12>>2]<<2)|0;if((h|0)!=(g|0)){c=f[i>>2]|0;b=((a|0)<0)<<31>>31;r=h;h=0;while(1){m=f[c+(f[r>>2]<<2)>>2]|0;f[r>>2]=m;s=f[e>>2]|0;q=(f[s+20>>2]|0)+(Y(f[f[s+48>>2]>>2]|0,m)|0)|0;p=f[q>>2]|0;f[q>>2]=(p|0)>(h|0)?h:p;p=q+8|0;o=f[p>>2]|0;f[p>>2]=(o|0)<(h|0)?h:o;o=q+4|0;p=f[o>>2]|0;f[o>>2]=(p|0)>(a|0)?a:p;p=q+12|0;o=f[p>>2]|0;f[p>>2]=(o|0)<(a|0)?a:o;o=q+16|0;f[o>>2]=(f[o>>2]|0)+1;o=f[s+120>>2]|0;s=o+(m<<4)|0;q=s;p=UIc(f[q>>2]|0,f[q+4>>2]|0,h|0,((h|0)<0)<<31>>31|0)|0;q=s;f[q>>2]=p;f[q+4>>2]=J;q=o+(m<<4)+8|0;m=q;o=UIc(f[m>>2]|0,f[m+4>>2]|0,a|0,b|0)|0;m=q;f[m>>2]=o;f[m+4>>2]=J;r=r+4|0;if((r|0)==(g|0))break;else h=h+1|0}}a=a+1|0}while((a|0)!=(d|0));return}}function fba(a){a=a|0;YDc(a);return}function gba(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=a+8|0;h=f[g>>2]|0;i=(((Y(f[h+12>>2]|0,d)|0)+1|0)/2|0)+1|0;j=a+4|0;k=f[j>>2]|0;l=f[k+12>>2]|0;if((d|0)==(f[e>>2]|0)){m=i;n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}q=(l|0)>0;r=a+12|0;a=d;s=i;t=k;k=h;while(1){h=f[f[t+44>>2]>>2]|0;u=(f[t+16>>2]|0)+(Y(h,a)|0)|0;v=u+(0-h)|0;h=f[f[k+44>>2]>>2]|0;w=(f[k+16>>2]|0)+(Y(h,a)|0)|0;x=w+(0-h)|0;a:do if(q){if((a|0)>(d|0)){y=0;z=s}else{h=0;A=s;while(1){do if(!(b[u+h>>0]|0)){f[w+(h<<2)>>2]=0;B=A}else{if((h|0)>0?(C=h+-1|0,b[u+C>>0]|0):0){f[w+(h<<2)>>2]=f[w+(C<<2)>>2];B=A;break}f[w+(h<<2)>>2]=A;f[(f[r>>2]|0)+(A<<2)>>2]=A;B=A+1|0}while(0);h=h+1|0;if((h|0)==(l|0)){D=B;break a}else A=B}}while(1){do if(!(b[u+y>>0]|0)){f[w+(y<<2)>>2]=0;E=z}else{A=(y|0)>0;if(!(b[v+y>>0]|0)){if(A?(h=y+-1|0,b[u+h>>0]|0):0){f[w+(y<<2)>>2]=f[w+(h<<2)>>2];E=z;break}f[w+(y<<2)>>2]=z;f[(f[r>>2]|0)+(z<<2)>>2]=z;E=z+1|0;break}h=f[x+(y<<2)>>2]|0;if(A?(A=y+-1|0,(b[u+A>>0]|0)!=0):0){C=f[r>>2]|0;F=f[w+(A<<2)>>2]|0;A=F;while(1){G=f[C+(A<<2)>>2]|0;if((G|0)<(A|0))A=G;else break}if((F|0)==(h|0))H=A;else{G=h;while(1){I=f[C+(G<<2)>>2]|0;if((I|0)<(G|0))G=I;else break}I=(A|0)>(G|0)?G:A;J=h;do{K=C+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(L|0));H=I}I=F;do{J=C+(I<<2)|0;A=I;I=f[J>>2]|0;f[J>>2]=H}while((I|0)<(A|0));M=H}else M=h;f[w+(y<<2)>>2]=M;E=z}while(0);y=y+1|0;if((y|0)==(l|0)){D=E;break}else z=E}}else D=s;while(0);w=a+1|0;if((w|0)==(f[e>>2]|0)){m=D;break}a=w;s=D;t=f[j>>2]|0;k=f[g>>2]|0}n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}function hba(a){a=a|0;YDc(a);return}function iba(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=d+1|0;h=a+8|0;i=f[h>>2]|0;j=(Y(((f[i+12>>2]|0)+1|0)/2|0,(g|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+12>>2]|0;n=f[e>>2]|0;if((d|0)==(n|0)){o=j;p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}r=(m|0)>0;s=m+-1|0;t=a+12|0;a=d;u=j;v=n;n=l;l=i;while(1){i=f[f[n+44>>2]>>2]|0;w=(f[n+16>>2]|0)+(Y(i,a)|0)|0;x=w+(0-i)|0;i=f[f[l+44>>2]>>2]|0;y=(f[l+16>>2]|0)+(Y(i,a)|0)|0;z=y+(0-i)|0;if(r){i=(a|0)>(d|0);A=i^1;B=0;C=u;while(1){a:do if(!(b[w+B>>0]|0)){f[y+(B<<2)>>2]=0;D=C}else{if(i){if(b[x+B>>0]|0){f[y+(B<<2)>>2]=f[z+(B<<2)>>2];D=C;break}if(!((B|0)>=(s|0)|A)){E=B+1|0;if(!(b[x+E>>0]|0))F=0;else{do if((B|0)>0){G=B+-1|0;if(!(b[x+G>>0]|0)){H=f[z+(E<<2)>>2]|0;if(!(b[w+G>>0]|0)){I=H;break}J=f[t>>2]|0;K=f[y+(G<<2)>>2]|0;L=K;while(1){M=f[J+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(H|0))N=L;else{M=H;while(1){O=f[J+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(L|0)>(M|0)?M:L;P=H;do{Q=J+(P<<2)|0;R=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(R|0));N=O}O=K;do{P=J+(O<<2)|0;H=O;O=f[P>>2]|0;f[P>>2]=N}while((O|0)<(H|0));I=N}else{O=f[t>>2]|0;J=f[z+(G<<2)>>2]|0;K=f[z+(E<<2)>>2]|0;H=J;while(1){P=f[O+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((J|0)==(K|0))S=H;else{G=K;while(1){P=f[O+(G<<2)>>2]|0;if((P|0)<(G|0))G=P;else break}P=(H|0)>(G|0)?G:H;L=K;do{M=O+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=P}while((L|0)<(R|0));S=P}P=J;do{L=O+(P<<2)|0;K=P;P=f[L>>2]|0;f[L>>2]=S}while((P|0)<(K|0));f[y+(B<<2)>>2]=S;D=C;break a}}else I=f[z+(E<<2)>>2]|0;while(0);f[y+(B<<2)>>2]=I;D=C;break}}else F=A}else F=A;E=(B|0)>0;if(!(F|E^1)?(P=B+-1|0,b[x+P>>0]|0):0){f[y+(B<<2)>>2]=f[z+(P<<2)>>2];D=C;break}if(E?(E=B+-1|0,b[w+E>>0]|0):0){f[y+(B<<2)>>2]=f[y+(E<<2)>>2];D=C;break}f[y+(B<<2)>>2]=C;f[(f[t>>2]|0)+(C<<2)>>2]=C;D=C+1|0}while(0);B=B+1|0;if((B|0)==(m|0))break;else C=D}T=D;U=f[e>>2]|0}else{T=u;U=v}C=a+1|0;if((C|0)==(U|0)){o=T;break}a=C;u=T;v=U;n=f[k>>2]|0;l=f[h>>2]|0}p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}function jba(a,c,e,g,h,i,j,k,l,m,o,p){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;o=+o;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0;q=u;u=u+2464|0;r=q+1328|0;s=q+264|0;t=q;v=q+200|0;w=q+256|0;x=q+136|0;y=q+192|0;if(!((k|0)>0&(l|0)>0)?!(m>0.0&o>0.0):0){f[r>>2]=0;f[r+4>>2]=0;z=tT(r,73)|0;A=251049;B=z+73|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,r,251123,251130,3415)}if(m<2.220446049250313e-16|o<2.220446049250313e-16){C=+(g|0);D=+(h|0);E=+(k|0)/C;F=+(l|0)/D;G=D;H=C}else{E=m;F=o;G=+(h|0);H=+(g|0)}I=a&7;J=(a>>>3&511)+1|0;K=nrc(H*E)|0;M=nrc(G*F)|0;if((K|0)<1|(M|0)<1){f[r>>2]=0;f[r+4>>2]=0;z=tT(r,14)|0;A=251198;B=z+14|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,r,251123,251130,3427)}G=1.0/E;H=1.0/F;N=nrc(G)|0;O=nrc(H)|0;if(+L(+(G-+(N|0)))<2.220446049250313e-16)P=+L(+(H-+(O|0)))<2.220446049250313e-16;else P=0;f[w>>2]=g;f[w+4>>2]=h;CY(v,w,a,c,e);f[y>>2]=K;f[y+4>>2]=M;CY(x,y,a,i,j);a:do switch(p|0){case 5:{if(!((J|0)!=2&((O|0)==2&((N|0)==2&P))))if(I>>>0<5){nj[f[46992+(I<<2)>>2]&7](c,e,g,h,i,j,k,l,J,E,F);break a}else{f[r>>2]=0;f[r+4>>2]=0;z=tT(r,9)|0;A=251213;B=z+9|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,r,251123,251130,3567)}else{Q=3;R=33}break}case 0:{a=f[(f[v+40>>2]|0)+4>>2]|0;y=x+40|0;w=f[y>>2]|0;S=f[w+4>>2]|0;T=f[w>>2]|0;w=r+8|0;f[r>>2]=w;U=r+4|0;f[U>>2]=S;if(S>>>0>264){V=XDc(S>>>0>1073741823?-1:S<<2)|0;f[r>>2]=V;W=V}else W=w;V=f[v+4>>2]|0;if((V|0)>0)X=f[(f[v+44>>2]|0)+(V+-1<<2)>>2]|0;else X=0;V=X>>>2;if((S|0)>0){Z=a+-1|0;a=0;do{o=G*+(a|0);_=~~o;$=_-(+(_|0)>o&1)|0;_=Y((Z|0)<($|0)?Z:$,X)|0;f[W+(a<<2)>>2]=_;a=a+1|0}while((a|0)!=(S|0))}f[s>>2]=0;f[s+4>>2]=T;kba(t,v,x,W,V,H);S=f[x+4>>2]|0;if((S|0)<3)aa=Y(f[x+12>>2]|0,f[x+8>>2]|0)|0;else{a=f[y>>2]|0;Z=0;_=1;while(1){$=Y(f[a+(Z<<2)>>2]|0,_)|0;Z=Z+1|0;if((Z|0)==(S|0)){aa=$;break}else _=$}}y8(s,t,+(aa>>>0)*.0000152587890625);lba(t);_=f[r>>2]|0;if((_|0)!=(w|0)){if(_|0)ZDc(_);f[r>>2]=w;f[U>>2]=264}break}default:{Q=(p|0)==1&((O|0)==2&((N|0)==2&P))?3:p;R=33}}while(0);do if((R|0)==33){p=(Q|0)==3;if(H>=1.0&(G>=1.0&p)){if(P){t=Y(O,N)|0;aa=(e>>>0)/((1212424721>>>(f[v>>2]<<2&28)&15)>>>0)|0;W=t+(Y(K,J)|0)|0;X=r+8|0;f[r>>2]=X;l=r+4|0;f[l>>2]=W;if(W>>>0>264){k=XDc(W>>>0>1073741823?-1:W<<2)|0;f[r>>2]=k;ba=k}else ba=X;k=ba+(t<<2)|0;t=f[47024+(I<<2)>>2]|0;if(!(109>>>I&1)){f[s>>2]=0;f[s+4>>2]=0;z=tT(s,9)|0;A=251213;B=z+9|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,s,251123,251130,3602)}if((O|0)>0&(N|0)>0){U=0;w=0;while(1){W=Y(w,aa)|0;j=0;i=U;while(1){c=(Y(j,J)|0)+W|0;f[ba+(i<<2)>>2]=c;j=j+1|0;if((j|0)==(N|0))break;else i=i+1|0}w=w+1|0;if((w|0)==(O|0))break;else U=N+U|0}}if((K|0)>0){U=0;do{w=Y(U,J)|0;aa=Y(w,N)|0;i=0;do{f[k+(i+w<<2)>>2]=i+aa;i=i+1|0}while((i|0)!=(J|0));U=U+1|0}while((U|0)!=(K|0))}Fh[t&255](v,x,ba,k,N,O);U=f[r>>2]|0;if((U|0)!=(X|0)){if(U|0)ZDc(U);f[r>>2]=X;f[l>>2]=264}break}U=f[47056+(I<<2)>>2]|0;if(!((109>>>I&1|0)!=0&J>>>0<5)){f[r>>2]=0;f[r+4>>2]=0;z=tT(r,20)|0;A=251223;B=z+20|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,r,251123,251130,3621)}l=h+g<<1;X=r+8|0;f[r>>2]=X;k=r+4|0;f[k>>2]=l;if(l>>>0>93){t=XDc(l>>>0>357913941?-1:l*12|0)|0;f[r>>2]=t;ca=t}else ca=X;t=ca+((g<<1)*12|0)|0;l=mba(g,K,J,G,ca)|0;i=mba(h,M,1,H,t)|0;aa=M+1|0;w=s+8|0;f[s>>2]=w;j=s+4|0;f[j>>2]=aa;if(aa>>>0>264){W=XDc(aa>>>0>1073741823?-1:aa<<2)|0;f[s>>2]=W;da=W}else da=w;if((i|0)>0){W=0;aa=0;while(1){if((aa|0)!=0?(f[t+(aa*12|0)+4>>2]|0)==(f[t+((aa+-1|0)*12|0)+4>>2]|0):0)ea=W;else{f[da+(W<<2)>>2]=aa;ea=W+1|0}aa=aa+1|0;if((aa|0)==(i|0)){fa=ea;break}else W=ea}}else fa=0;f[da+(fa<<2)>>2]=i;Ii[U&127](v,x,ca,l,t,i,da);W=f[s>>2]|0;if((W|0)!=(w|0)){if(W|0)ZDc(W);f[s>>2]=w;f[j>>2]=264}W=f[r>>2]|0;if((W|0)!=(X|0)){if(W|0)ZDc(W);f[r>>2]=X;f[k>>2]=93}break}W=Y(K,J)|0;aa=(I|0)==0;c=(Q|0)==2;if(!c)if((Q|0)!=4)if((Q|2|0)==3){ga=2;ha=47120}else{f[r>>2]=0;f[r+4>>2]=0;z=tT(r,28)|0;A=270908;B=z+28|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-5,r,251123,251130,3659)}else{ga=8;ha=47088}else{ga=4;ha=47152}k=f[ha+(I<<2)>>2]|0;X=ga>>>1;if(!k){f[r>>2]=0;f[r+4>>2]=0;z=tT(r,9)|0;A=251213;B=z+9|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));z5(-215,r,251123,251130,3662)}j=W+M|0;w=ga<<2;i=Y(w|4,j)|0;t=r+8|0;f[r>>2]=t;l=r+4|0;f[l>>2]=i;if(i>>>0>1032){U=XDc(i)|0;f[r>>2]=U;ia=U}else ia=t;U=ia+(W<<2)|0;i=U+(M<<2)|0;_=Y(ga,W)|0;S=i+(_<<2)|0;Z=i+(_<<1)|0;z=s;B=z+64|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));if((K|0)>0){W=X+-1|0;_=s+4|0;a=s+8|0;y=s+12|0;V=Y(ga,J)|0;T=(Q|0)==4;$=g+-1|0;ja=0;ka=K;la=0;while(1){ma=Y(V,la)|0;na=ia+(j+ma<<2)|0;o=+(la|0);if(p){m=G*o;oa=~~m;pa=oa-(+(oa|0)>m&1)|0;m=+(la+1|0)-E*+(pa+1|0);oa=~~m;if(!(m<=0.0)){qa=m-+(oa-(+(oa|0)>m&1)|0);ra=pa}else{qa=0.0;ra=pa}}else{m=G*(o+.5)+-.5;pa=~~m;oa=pa-(+(pa|0)>m&1)|0;qa=m-+(oa|0);ra=oa}b:do if((ra|0)<(W|0)){oa=la+1|0;if((ra|0)<0){switch(Q|0){case 2:case 4:{sa=qa;ta=oa;ua=ra;break b;break}default:{}}sa=0.0;ta=oa;ua=0}else{sa=qa;ta=oa;ua=ra}}else{sa=qa;ta=ja;ua=ra}while(0);c:do if((ua+X|0)>=(g|0)){oa=(la|0)<(ka|0)?la:ka;if((ua|0)<($|0)){va=oa;wa=sa;xa=ua}else{switch(Q|0){case 2:case 4:{va=oa;wa=sa;xa=ua;break c;break}default:{}}va=oa;wa=0.0;xa=$}}else{va=ka;wa=sa;xa=ua}while(0);oa=Y(xa,J)|0;pa=Y(la,J)|0;ya=0;do{f[ia+(ya+pa<<2)>>2]=ya+oa;ya=ya+1|0}while((ya|0)!=(J|0));do if(!c)if(T){nba(wa,s);break}else{n[s>>2]=1.0-wa;n[_>>2]=wa;break}else{m=wa+1.0;o=m*(m*(3.75-m*.75)+-6.0)+3.0;n[s>>2]=o;m=wa*(wa*(wa*1.25+-2.25))+1.0;n[_>>2]=m;C=1.0-wa;D=C*(C*(C*1.25+-2.25))+1.0;n[a>>2]=D;n[y>>2]=1.0-o-m-D}while(0);if(aa){ya=0;do{oa=mrc(+n[s+(ya<<2)>>2]*2048.0)|0;d[i+(ya+ma<<1)>>1]=(oa+32768|0)>>>0<65536?oa:(oa|0)>0?32767:32768;ya=ya+1|0}while((ya|0)<(ga|0));if((ya|0)<(V|0)){oa=ya;do{pa=oa+ma|0;d[i+(pa<<1)>>1]=d[i+(pa-ga<<1)>>1]|0;oa=oa+1|0}while((oa|0)!=(V|0))}}else{dJc(na|0,s|0,w|0)|0;oa=0;do oa=oa+1|0;while((oa|0)<(ga|0));if((oa|0)<(V|0)){na=oa;do{ya=na+ma|0;f[i+(ya<<2)>>2]=f[i+(ya-ga<<2)>>2];na=na+1|0}while((na|0)!=(V|0))}}la=la+1|0;if((la|0)==(K|0)){za=ta;Aa=va;break}else{ja=ta;ka=va}}}else{za=0;Aa=K}if((M|0)>0){ka=s+4|0;ja=s+8|0;la=s+12|0;V=(Q|0)==4;y=Y(Y(K,w|4)|0,J)|0;a=0;do{_=Y(ga,a)|0;T=ia+(M+_<<2)+y|0;D=+(a|0);if(p){m=H*D;$=~~m;X=$-(+($|0)>m&1)|0;m=+(a+1|0)-F*+(X+1|0);$=~~m;if(!(m<=0.0)){Ba=m-+($-(+($|0)>m&1)|0);Ca=X}else{Ba=0.0;Ca=X}}else{m=H*(D+.5)+-.5;X=~~m;$=X-(+(X|0)>m&1)|0;Ba=m-+($|0);Ca=$}f[U+(a<<2)>>2]=Ca;do if(!c)if(V){nba(Ba,s);break}else{n[s>>2]=1.0-Ba;n[ka>>2]=Ba;break}else{m=Ba+1.0;D=m*(m*(3.75-m*.75)+-6.0)+3.0;n[s>>2]=D;m=Ba*(Ba*(Ba*1.25+-2.25))+1.0;n[ka>>2]=m;o=1.0-Ba;C=o*(o*(o*1.25+-2.25))+1.0;n[ja>>2]=C;n[la>>2]=1.0-D-m-C}while(0);if(aa){$=0;do{X=mrc(+n[s+($<<2)>>2]*2048.0)|0;d[Z+($+_<<1)>>1]=(X+32768|0)>>>0<65536?X:(X|0)>0?32767:32768;$=$+1|0}while(($|0)<(ga|0))}else dJc(T|0,s|0,w|0)|0;a=a+1|0}while((a|0)!=(M|0))}Li[k&127](v,x,ia,i,U,aa?Z:S,za,Aa,ga);a=f[r>>2]|0;if((a|0)!=(t|0)){if(a|0)ZDc(a);f[r>>2]=t;f[l>>2]=1032}}while(0);r=x+36|0;ga=f[r>>2]|0;if(ga|0?(Aa=ga+12|0,ga=f[Aa>>2]|0,f[Aa>>2]=ga+-1,(ga|0)==1):0)_S(x);f[r>>2]=0;r=x+16|0;ga=x+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[ga>>2]|0)>0){r=f[x+40>>2]|0;Aa=0;do{f[r+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[ga>>2]|0))}ga=f[x+44>>2]|0;if((ga|0)!=(x+48|0))g0(ga);ga=v+36|0;x=f[ga>>2]|0;if(x|0?(Aa=x+12|0,x=f[Aa>>2]|0,f[Aa>>2]=x+-1,(x|0)==1):0)_S(v);f[ga>>2]=0;ga=v+16|0;x=v+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[x>>2]|0)>0){ga=f[v+40>>2]|0;Aa=0;do{f[ga+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[x>>2]|0))}x=f[v+44>>2]|0;if((x|0)==(v+48|0)){u=q;return}g0(x);u=q;return}function kba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;f[a>>2]=47692;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;ZS(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;q=a+128|0;p[q>>3]=g;return}else{f[h>>2]=0;ZS(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;q=a+128|0;p[q>>3]=g;return}}function lba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47692;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function mba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((b|0)<=0){g=0;return g|0}h=+(a|0);i=a+-1|0;a=0;j=0;while(1){k=+(j|0)*d;l=k+d;m=h-k;o=m<d?m:d;p=~~k;q=(+(p|0)<k&1)+p|0;p=~~l;r=p-(+(p|0)>l&1)|0;p=(i|0)<(r|0)?i:r;r=(p|0)<(q|0)?p:q;m=+(r|0)-k;if(m>.001){s=Y(j,c)|0;f[e+(a*12|0)+4>>2]=s;s=Y(r+-1|0,c)|0;f[e+(a*12|0)>>2]=s;n[e+(a*12|0)+8>>2]=m/o;t=a+1|0}else t=a;if((p|0)>(q|0)){q=Y(j,c)|0;m=1.0/o;s=r;r=t;while(1){f[e+(r*12|0)+4>>2]=q;u=Y(s,c)|0;f[e+(r*12|0)>>2]=u;u=r+1|0;n[e+(r*12|0)+8>>2]=m;s=s+1|0;if((s|0)>=(p|0)){v=u;break}else r=u}}else v=t;m=l-+(p|0);if(m>.001){r=Y(j,c)|0;f[e+(v*12|0)+4>>2]=r;r=Y(p,c)|0;f[e+(v*12|0)>>2]=r;k=m>1.0?1.0:m;n[e+(v*12|0)+8>>2]=(o<k?o:k)/o;w=v+1|0}else w=v;j=j+1|0;if((j|0)==(b|0)){g=w;break}else a=w}return g|0}function nba(a,b){a=+a;b=b|0;var c=0.0,d=0.0,e=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0;if(a<1.1920928955078125e-07){f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;n[b+12>>2]=1.0;return}else{c=a+3.0;a=-c*3.141592653589793*.25;d=+P(+a);e=+O(+a);g=e*0.0;h=(d+g)/(a*a);a=-(c+-1.0)*3.141592653589793*.25;i=d*-.7071067811865476;j=e*-.7071067811865476;k=(i+j)/(a*a);a=-(c+-2.0)*3.141592653589793*.25;l=d*0.0;m=(l+e)/(a*a);a=-(c+-3.0)*3.141592653589793*.25;o=d*.7071067811865476;p=(o+j)/(a*a);a=-(c+-4.0)*3.141592653589793*.25;j=(g-d)/(a*a);a=-(c+-5.0)*3.141592653589793*.25;d=e*.7071067811865476;g=(o+d)/(a*a);a=-(c+-6.0)*3.141592653589793*.25;o=(l-e)/(a*a);a=-(c+-7.0)*3.141592653589793*.25;c=(i+d)/(a*a);a=1.0/(h+0.0+k+m+p+j+g+o+c);n[b>>2]=a*h;n[b+4>>2]=a*k;n[b+8>>2]=a*m;n[b+12>>2]=a*p;n[b+16>>2]=a*j;n[b+20>>2]=a*g;n[b+24>>2]=a*o;n[b+28>>2]=a*c;return}}function oba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Nba(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Oba(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Oba(o);u=k;return}function pba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Iba(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Jba(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Jba(o);u=k;return}function qba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Dba(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Eba(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Eba(o);u=k;return}function rba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;yba(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);zba(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);zba(o);u=k;return}function sba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;tba(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);uba(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);uba(o);u=k;return}function tba(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47192;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function uba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47192;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function vba(a){a=a|0;uba(a);YDc(a);return}function wba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0;c=u;u=u+1296|0;d=c+1288|0;e=c;g=c+1224|0;h=c+1160|0;i=c+1096|0;j=((f[a+4>>2]|0)>>>3&511)+1|0;k=a+140|0;l=(f[k>>2]|0)+15&-16;m=a+148|0;o=f[m>>2]|0;q=Y(l,o)|0;r=e+8|0;f[e>>2]=r;s=e+4|0;f[s>>2]=q;if(q>>>0>136){t=XDc(q>>>0>536870911?-1:q<<3)|0;f[e>>2]=t;v=t}else v=r;t=g;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((o|0)>0){XIc(i|0,-1,o<<2|0)|0;t=0;do{q=v+((Y(t,l)|0)<<3)|0;f[h+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(o|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=h+4|0;E=h+8|0;F=h+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=l<<3;l=(f[a+128>>2]|0)+((Y(t,o)|0)<<2)|0;a=t;t=o;while(1){if((t|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=o+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[i+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){dJc(f[h+(N<<2)>>2]|0,f[h+(O<<2)>>2]|0,J|0)|0;S=f[m>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[g+(N<<2)>>2]=P;f[i+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))xba(d,g+(K<<2)|0,h+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[k>>2]|0,j,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[k>>2]|0;U=+n[l>>2];V=+n[l+4>>2];W=+n[l+8>>2];X=+n[l+12>>2];N=f[h>>2]|0;o=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{p[M+(Z<<3)>>3]=U*+p[N+(Z<<3)>>3]+V*+p[o+(Z<<3)>>3]+W*+p[P+(Z<<3)>>3]+X*+p[R+(Z<<3)>>3];Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[m>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{l=l+(L<<2)|0;t=L}}_=f[e>>2]|0}else _=v;if((_|0)==(r|0)){u=c;return}if(_|0)ZDc(_);f[e>>2]=r;f[s>>2]=136;u=c;return}function xba(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((d|0)<=0)return;a=j<<1;m=0-(i<<2)|0;o=j<<1;q=j*3|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=k;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=A-j|0;if(B>>>0<h>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+j|0;else{E=D;break}while(1)if((E|0)<(h|0)){C=E;break}else E=E-j|0}F=+p[s+(C<<3)>>3]*+n[z>>2]+0.0;if(A>>>0<h>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+j|0;else{H=D;break}while(1)if((H|0)<(h|0)){G=H;break}else H=H-j|0}I=F+ +p[s+(G<<3)>>3]*+n[z+4>>2];D=o+B|0;if(D>>>0<h>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+j|0;else{K=A;break}while(1)if((K|0)<(h|0)){J=K;break}else K=K-j|0}F=I+ +p[s+(J<<3)>>3]*+n[z+8>>2];A=q+B|0;if(A>>>0<h>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+j|0;else{M=D;break}while(1)if((M|0)<(h|0)){L=M;break}else M=M-j|0}p[t+(y<<3)>>3]=F+ +p[s+(L<<3)>>3]*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(i|0))break;if((N|0)<(l|0)){P=N;Q=O}else{u=i;v=N;w=O;continue}while(1){z=f[e+(P<<2)>>2]|0;p[t+(P<<3)>>3]=+p[s+(z-j<<3)>>3]*+n[Q>>2]+ +p[s+(z<<3)>>3]*+n[Q+4>>2]+ +p[s+(z+j<<3)>>3]*+n[Q+8>>2]+ +p[s+(z+a<<3)>>3]*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(l|0)){P=z;Q=y}else{u=i;v=l;w=y;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=O+(m<<2)|0}return}function yba(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47212;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function zba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47212;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Aba(a){a=a|0;zba(a);YDc(a);return}function Bba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0;c=u;u=u+1264|0;d=c+1256|0;e=c+192|0;g=c+128|0;h=c+64|0;i=c;j=((f[a+4>>2]|0)>>>3&511)+1|0;k=a+140|0;l=(f[k>>2]|0)+15&-16;m=a+148|0;o=f[m>>2]|0;p=Y(l,o)|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=g;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(i|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,l)|0)<<2)|0;f[h+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=h+4|0;D=h+8|0;E=h+12|0;F=a+136|0;G=a+20|0;H=a+48|0;I=l<<2;l=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;J=s;K=0;L=s;M=0;while(1){N=o+M|0;O=f[F>>2]|0;P=(N|0)>-1?((N|0)<(O|0)?N:O+-1|0):0;O=(K|0)<(M|0)?M:K;a:do if((O|0)<(L|0)){N=O;while(1){if((N|0)<16?(P|0)==(f[i+(N<<2)>>2]|0):0)break;Q=N+1|0;if((Q|0)<(L|0))N=Q;else{R=L;S=Q;break a}}if((N|0)>(M|0)){dJc(f[h+(M<<2)>>2]|0,f[h+(N<<2)>>2]|0,I|0)|0;R=f[m>>2]|0;S=N}else{R=L;S=N}}else{R=L;S=O}while(0);J=(M|0)<(J|0)&(S|0)==(R|0)?M:J;O=(f[G>>2]|0)+(Y(f[f[H>>2]>>2]|0,P)|0)|0;f[g+(M<<2)>>2]=O;f[i+(M<<2)>>2]=P;M=M+1|0;if((M|0)>=(R|0))break;else{K=S;L=R}}if((R|0)>(J|0))Cba(d,g+(J<<2)|0,h+(J<<2)|0,R-J|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[k>>2]|0,j,f[y>>2]|0,f[z>>2]|0)}L=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;K=f[k>>2]|0;T=+n[l>>2];U=+n[l+4>>2];V=+n[l+8>>2];W=+n[l+12>>2];M=f[h>>2]|0;o=f[C>>2]|0;O=f[D>>2]|0;Q=f[E>>2]|0;if((K|0)>0){X=0;do{n[L+(X<<2)>>2]=T*+n[M+(X<<2)>>2]+U*+n[o+(X<<2)>>2]+V*+n[O+(X<<2)>>2]+W*+n[Q+(X<<2)>>2];X=X+1|0}while((X|0)!=(K|0))}a=a+1|0;K=f[m>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{l=l+(K<<2)|0;s=K}}Z=f[e>>2]|0}else Z=t;if((Z|0)==(q|0)){u=c;return}if(Z|0)ZDc(Z);f[e>>2]=q;f[r>>2]=264;u=c;return}function Cba(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;if((d|0)<=0)return;a=j<<1;m=0-(i<<2)|0;o=j<<1;p=j*3|0;q=g;g=0;while(1){r=f[b+(g<<2)>>2]|0;s=f[c+(g<<2)>>2]|0;t=k;u=0;v=q;a:while(1){if((t|0)>(u|0)){w=t-u<<2;x=u;y=v;while(1){z=f[e+(x<<2)>>2]|0;A=z-j|0;if(A>>>0<h>>>0)B=A;else{C=A;while(1)if((C|0)<0)C=C+j|0;else{D=C;break}while(1)if((D|0)<(h|0)){B=D;break}else D=D-j|0}E=+n[r+(B<<2)>>2]*+n[y>>2]+0.0;if(z>>>0<h>>>0)F=z;else{C=z;while(1)if((C|0)<0)C=C+j|0;else{G=C;break}while(1)if((G|0)<(h|0)){F=G;break}else G=G-j|0}H=E+ +n[r+(F<<2)>>2]*+n[y+4>>2];C=o+A|0;if(C>>>0<h>>>0)I=C;else{z=C;while(1)if((z|0)<0)z=z+j|0;else{J=z;break}while(1)if((J|0)<(h|0)){I=J;break}else J=J-j|0}E=H+ +n[r+(I<<2)>>2]*+n[y+8>>2];z=p+A|0;if(z>>>0<h>>>0)K=z;else{C=z;while(1)if((C|0)<0)C=C+j|0;else{L=C;break}while(1)if((L|0)<(h|0)){K=L;break}else L=L-j|0}n[s+(x<<2)>>2]=E+ +n[r+(K<<2)>>2]*+n[y+12>>2];x=x+1|0;if((x|0)==(t|0))break;else y=y+16|0}M=t;N=v+(w<<2)|0}else{M=u;N=v}if((t|0)==(i|0))break;if((M|0)<(l|0)){O=M;P=N}else{t=i;u=M;v=N;continue}while(1){y=f[e+(O<<2)>>2]|0;n[s+(O<<2)>>2]=+n[r+(y-j<<2)>>2]*+n[P>>2]+ +n[r+(y<<2)>>2]*+n[P+4>>2]+ +n[r+(y+j<<2)>>2]*+n[P+8>>2]+ +n[r+(y+a<<2)>>2]*+n[P+12>>2];y=O+1|0;x=P+16|0;if((y|0)<(l|0)){O=y;P=x}else{t=i;u=l;v=x;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else q=N+(m<<2)|0}return}function Dba(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47232;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function Eba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47232;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Fba(a){a=a|0;Eba(a);YDc(a);return}function Gba(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0;c=u;u=u+1264|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(m,p)|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=XDc(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){XIc(j|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,m)|0)<<2)|0;f[i+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=m<<2;m=(f[a+128>>2]|0)+((Y(t,p)|0)<<2)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[j+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){dJc(f[i+(N<<2)>>2]|0,f[i+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[h+(N<<2)>>2]=P;f[j+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))Hba(e,h+(K<<2)|0,i+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[l>>2]|0,k,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[l>>2]|0;U=+n[m>>2];V=+n[m+4>>2];W=+n[m+8>>2];X=+n[m+12>>2];N=f[i>>2]|0;p=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{_=mrc(U*+n[N+(Z<<2)>>2]+V*+n[p+(Z<<2)>>2]+W*+n[P+(Z<<2)>>2]+X*+n[R+(Z<<2)>>2])|0;d[M+(Z<<1)>>1]=(_+32768|0)>>>0<65536?_:(_|0)>0?32767:32768;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{m=m+(L<<2)|0;t=L}}$=f[g>>2]|0}else $=v;if(($|0)==(r|0)){u=c;return}if($|0)ZDc($);f[g>>2]=r;f[s>>2]=264;u=c;return}function Hba(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((e|0)<=0)return;a=k<<1;o=0-(j<<2)|0;p=k<<1;q=k*3|0;r=h;h=0;while(1){s=f[b+(h<<2)>>2]|0;t=f[c+(h<<2)>>2]|0;u=l;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=A-k|0;if(B>>>0<i>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+k|0;else{E=D;break}while(1)if((E|0)<(i|0)){C=E;break}else E=E-k|0}F=+(d[s+(C<<1)>>1]|0)*+n[z>>2]+0.0;if(A>>>0<i>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{H=D;break}while(1)if((H|0)<(i|0)){G=H;break}else H=H-k|0}I=F+ +(d[s+(G<<1)>>1]|0)*+n[z+4>>2];D=p+B|0;if(D>>>0<i>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+k|0;else{K=A;break}while(1)if((K|0)<(i|0)){J=K;break}else K=K-k|0}F=I+ +(d[s+(J<<1)>>1]|0)*+n[z+8>>2];A=q+B|0;if(A>>>0<i>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{M=D;break}while(1)if((M|0)<(i|0)){L=M;break}else M=M-k|0}n[t+(y<<2)>>2]=F+ +(d[s+(L<<1)>>1]|0)*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(j|0))break;if((N|0)<(m|0)){P=N;Q=O}else{u=j;v=N;w=O;continue}while(1){z=f[g+(P<<2)>>2]|0;n[t+(P<<2)>>2]=+(d[s+(z-k<<1)>>1]|0)*+n[Q>>2]+ +(d[s+(z<<1)>>1]|0)*+n[Q+4>>2]+ +(d[s+(z+k<<1)>>1]|0)*+n[Q+8>>2]+ +(d[s+(z+a<<1)>>1]|0)*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(m|0)){P=z;Q=y}else{u=j;v=m;w=y;continue a}}}h=h+1|0;if((h|0)==(e|0))break;else r=O+(o<<2)|0}return}function Iba(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47252;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function Jba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47252;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Kba(a){a=a|0;Jba(a);YDc(a);return}function Lba(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0;c=u;u=u+1264|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(m,p)|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=XDc(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){XIc(j|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,m)|0)<<2)|0;f[i+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=m<<2;m=(f[a+128>>2]|0)+((Y(t,p)|0)<<2)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[j+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){dJc(f[i+(N<<2)>>2]|0,f[i+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[h+(N<<2)>>2]=P;f[j+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))Mba(e,h+(K<<2)|0,i+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[l>>2]|0,k,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[l>>2]|0;U=+n[m>>2];V=+n[m+4>>2];W=+n[m+8>>2];X=+n[m+12>>2];N=f[i>>2]|0;p=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{_=mrc(U*+n[N+(Z<<2)>>2]+V*+n[p+(Z<<2)>>2]+W*+n[P+(Z<<2)>>2]+X*+n[R+(Z<<2)>>2])|0;d[M+(Z<<1)>>1]=_>>>0<65536?_:(_|0)>0?65535:0;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{m=m+(L<<2)|0;t=L}}$=f[g>>2]|0}else $=v;if(($|0)==(r|0)){u=c;return}if($|0)ZDc($);f[g>>2]=r;f[s>>2]=264;u=c;return}function Mba(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((d|0)<=0)return;a=k<<1;o=0-(i<<2)|0;p=k<<1;q=k*3|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=l;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=A-k|0;if(B>>>0<h>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+k|0;else{E=D;break}while(1)if((E|0)<(h|0)){C=E;break}else E=E-k|0}F=+(j[s+(C<<1)>>1]|0)*+n[z>>2]+0.0;if(A>>>0<h>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{H=D;break}while(1)if((H|0)<(h|0)){G=H;break}else H=H-k|0}I=F+ +(j[s+(G<<1)>>1]|0)*+n[z+4>>2];D=p+B|0;if(D>>>0<h>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+k|0;else{K=A;break}while(1)if((K|0)<(h|0)){J=K;break}else K=K-k|0}F=I+ +(j[s+(J<<1)>>1]|0)*+n[z+8>>2];A=q+B|0;if(A>>>0<h>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{M=D;break}while(1)if((M|0)<(h|0)){L=M;break}else M=M-k|0}n[t+(y<<2)>>2]=F+ +(j[s+(L<<1)>>1]|0)*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(i|0))break;if((N|0)<(m|0)){P=N;Q=O}else{u=i;v=N;w=O;continue}while(1){z=f[e+(P<<2)>>2]|0;n[t+(P<<2)>>2]=+(j[s+(z-k<<1)>>1]|0)*+n[Q>>2]+ +(j[s+(z<<1)>>1]|0)*+n[Q+4>>2]+ +(j[s+(z+k<<1)>>1]|0)*+n[Q+8>>2]+ +(j[s+(z+a<<1)>>1]|0)*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(m|0)){P=z;Q=y}else{u=i;v=m;w=y;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=O+(o<<2)|0}return}function Nba(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47272;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function Oba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47272;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Pba(a){a=a|0;Oba(a);YDc(a);return}function Qba(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=u;u=u+1264|0;g=e+1256|0;h=e+192|0;i=e+128|0;j=e+64|0;k=e;l=((f[a+4>>2]|0)>>>3&511)+1|0;m=a+140|0;n=(f[m>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(n,p)|0;r=h+8|0;f[h>>2]=r;s=h+4|0;f[s>>2]=q;if(q>>>0>264){t=XDc(q>>>0>1073741823?-1:q<<2)|0;f[h>>2]=t;v=t}else v=r;t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=j;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){XIc(k|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,n)|0)<<2)|0;f[j+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[c>>2]|0;q=c+4|0;if((t|0)<(f[q>>2]|0)){c=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=j+4|0;E=j+8|0;F=j+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=n<<2;n=(f[a+128>>2]|0)+((Y(t,p)|0)<<1)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[c>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[k+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){dJc(f[j+(N<<2)>>2]|0,f[j+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[i+(N<<2)>>2]=P;f[k+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))Rba(g,i+(K<<2)|0,j+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[m>>2]|0,l,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[m>>2]|0;N=d[n>>1]|0;p=d[n+2>>1]|0;P=d[n+4>>1]|0;R=d[n+6>>1]|0;U=f[j>>2]|0;V=f[D>>2]|0;W=f[E>>2]|0;X=f[F>>2]|0;if((L|0)>0){Z=0;do{_=Y(f[U+(Z<<2)>>2]|0,N)|0;$=Y(f[V+(Z<<2)>>2]|0,p)|0;aa=Y(f[W+(Z<<2)>>2]|0,P)|0;ba=_+2097152+$+aa+(Y(f[X+(Z<<2)>>2]|0,R)|0)>>22;b[M+Z>>0]=ba>>>0<256?ba:(ba|0)>0?255:0;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{n=n+(L<<1)|0;t=L}}ca=f[h>>2]|0}else ca=v;if((ca|0)==(r|0)){u=e;return}if(ca|0)ZDc(ca);f[h>>2]=r;f[s>>2]=264;u=e;return}function Rba(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((e|0)<=0)return;a=l<<1;o=0-(k<<2)|0;p=l<<1;q=l*3|0;r=i;i=0;while(1){s=f[b+(i<<2)>>2]|0;t=f[c+(i<<2)>>2]|0;u=m;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=A-l|0;if(B>>>0<j>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+l|0;else{E=D;break}while(1)if((E|0)<(j|0)){C=E;break}else E=E-l|0}D=Y(d[z>>1]|0,h[s+C>>0]|0)|0;if(A>>>0<j>>>0)F=A;else{G=A;while(1)if((G|0)<0)G=G+l|0;else{H=G;break}while(1)if((H|0)<(j|0)){F=H;break}else H=H-l|0}G=(Y(d[z+2>>1]|0,h[s+F>>0]|0)|0)+D|0;A=p+B|0;if(A>>>0<j>>>0)I=A;else{J=A;while(1)if((J|0)<0)J=J+l|0;else{K=J;break}while(1)if((K|0)<(j|0)){I=K;break}else K=K-l|0}J=(Y(d[z+4>>1]|0,h[s+I>>0]|0)|0)+G|0;D=q+B|0;if(D>>>0<j>>>0)L=D;else{A=D;while(1)if((A|0)<0)A=A+l|0;else{M=A;break}while(1)if((M|0)<(j|0)){L=M;break}else M=M-l|0}A=(Y(d[z+6>>1]|0,h[s+L>>0]|0)|0)+J|0;f[t+(y<<2)>>2]=A;y=y+1|0;if((y|0)==(u|0))break;else z=z+8|0}N=u;O=w+(x<<1)|0}else{N=v;O=w}if((u|0)==(k|0))break;if((N|0)<(n|0)){P=N;Q=O}else{u=k;v=N;w=O;continue}while(1){z=f[g+(P<<2)>>2]|0;y=Y(d[Q>>1]|0,h[s+(z-l)>>0]|0)|0;A=(Y(d[Q+2>>1]|0,h[s+z>>0]|0)|0)+y|0;y=A+(Y(d[Q+4>>1]|0,h[s+(z+l)>>0]|0)|0)|0;A=y+(Y(d[Q+6>>1]|0,h[s+(z+a)>>0]|0)|0)|0;f[t+(P<<2)>>2]=A;A=P+1|0;z=Q+8|0;if((A|0)<(n|0)){P=A;Q=z}else{u=k;v=n;w=z;continue a}}}i=i+1|0;if((i|0)==(e|0))break;else r=O+(o<<1)|0}return}function Sba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;tca(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);uca(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);uca(o);u=k;return}function Tba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;nca(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);oca(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);oca(o);u=k;return}function Uba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;hca(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);ica(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);ica(o);u=k;return}function Vba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;bca(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);cca(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);cca(o);u=k;return}function Wba(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Xba(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Yba(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Yba(o);u=k;return}function Xba(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47292;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function Yba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47292;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Zba(a){a=a|0;Yba(a);YDc(a);return}function _ba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1296|0;d=c+1289|0;e=c+1288|0;g=c;h=c+1224|0;i=c+1160|0;j=c+1096|0;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>136){s=XDc(p>>>0>536870911?-1:p<<3)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<3)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<3;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))$ba(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;aca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=136;u=c;return}function $ba(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((d|0)<2)m=0;else{k=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((l|0)<=0){o=(i|0)>0;q=0;r=h;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(o){v=0;do{w=f[e+(v<<2)>>2]|0;p[u+(v<<3)>>3]=+p[t+(w<<3)>>3];p[s+(v<<3)>>3]=+p[r+(w<<3)>>3];v=v+1|0}while((v|0)!=(i|0))}if((q|0)==(k|0)){m=k;break a}}}q=(l|0)<(i|0);r=0;s=h;o=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=o;o=f[c+(r<<2)>>2]|0;u=0;do{w=f[e+(u<<2)>>2]|0;x=u<<1;y=+n[g+(x<<2)>>2];z=+n[g+((x|1)<<2)>>2];x=w+j|0;A=y*+p[s+(w<<3)>>3]+z*+p[s+(x<<3)>>3];p[t+(u<<3)>>3]=y*+p[v+(w<<3)>>3]+z*+p[v+(x<<3)>>3];p[o+(u<<3)>>3]=A;u=u+1|0}while((u|0)!=(l|0));if(q){u=l;do{x=f[e+(u<<2)>>2]|0;p[t+(u<<3)>>3]=+p[v+(x<<3)>>3];p[o+(u<<3)>>3]=+p[s+(x<<3)>>3];u=u+1|0}while((u|0)!=(i|0))}}while((r|0)!=(k|0));m=k}while(0);if((m|0)>=(d|0))return;if((l|0)<=0){k=(i|0)>0;r=m;do{s=f[b+(r<<2)>>2]|0;o=f[c+(r<<2)>>2]|0;if(k){q=0;do{p[o+(q<<3)>>3]=+p[s+(f[e+(q<<2)>>2]<<3)>>3];q=q+1|0}while((q|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(l|0)<(i|0);k=m;do{m=f[b+(k<<2)>>2]|0;q=f[c+(k<<2)>>2]|0;s=0;do{o=f[e+(s<<2)>>2]|0;a=s<<1;p[q+(s<<3)>>3]=+p[m+(o<<3)>>3]*+n[g+(a<<2)>>2]+ +p[m+(o+j<<3)>>3]*+n[g+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(l|0));if(r){s=l;do{p[q+(s<<3)>>3]=+p[m+(f[e+(s<<2)>>2]<<3)>>3];s=s+1|0}while((s|0)!=(i|0))}k=k+1|0}while((k|0)!=(d|0));return}function aca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0.0,h=0.0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=+n[d>>2];h=+n[d+4>>2];d=f[b>>2]|0;a=f[b+4>>2]|0;b=e+-4|0;if((e|0)<4)i=0;else{j=0;do{k=j|1;l=g*+p[d+(k<<3)>>3]+h*+p[a+(k<<3)>>3];p[c+(j<<3)>>3]=g*+p[d+(j<<3)>>3]+h*+p[a+(j<<3)>>3];p[c+(k<<3)>>3]=l;k=j|2;m=j|3;l=g*+p[d+(m<<3)>>3]+h*+p[a+(m<<3)>>3];p[c+(k<<3)>>3]=g*+p[d+(k<<3)>>3]+h*+p[a+(k<<3)>>3];p[c+(m<<3)>>3]=l;j=j+4|0}while((j|0)<=(b|0));i=e&-4}if((i|0)<(e|0))o=i;else return;do{p[c+(o<<3)>>3]=g*+p[d+(o<<3)>>3]+h*+p[a+(o<<3)>>3];o=o+1|0}while((o|0)!=(e|0));return}function bca(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47312;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function cca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47312;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function dca(a){a=a|0;cca(a);YDc(a);return}function eca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))fca(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;gca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function fca(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;a:do if((d|0)<2)m=0;else{k=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((l|0)<=0){o=(i|0)>0;p=0;q=a;r=h;while(1){p=p+1|0;s=r;r=f[b+(p<<2)>>2]|0;t=q;q=f[c+(p<<2)>>2]|0;if(o){u=0;do{v=f[e+(u<<2)>>2]|0;f[t+(u<<2)>>2]=f[s+(v<<2)>>2];f[q+(u<<2)>>2]=f[r+(v<<2)>>2];u=u+1|0}while((u|0)!=(i|0))}if((p|0)==(k|0)){m=k;break a}}}p=(l|0)<(i|0);r=0;q=h;o=a;do{r=r+1|0;u=q;q=f[b+(r<<2)>>2]|0;s=o;o=f[c+(r<<2)>>2]|0;t=0;do{v=f[e+(t<<2)>>2]|0;w=t<<1;x=+n[g+(w<<2)>>2];y=+n[g+((w|1)<<2)>>2];w=v+j|0;z=x*+n[q+(v<<2)>>2]+y*+n[q+(w<<2)>>2];n[s+(t<<2)>>2]=x*+n[u+(v<<2)>>2]+y*+n[u+(w<<2)>>2];n[o+(t<<2)>>2]=z;t=t+1|0}while((t|0)!=(l|0));if(p){t=l;do{w=f[e+(t<<2)>>2]|0;f[s+(t<<2)>>2]=f[u+(w<<2)>>2];f[o+(t<<2)>>2]=f[q+(w<<2)>>2];t=t+1|0}while((t|0)!=(i|0))}}while((r|0)!=(k|0));m=k}while(0);if((m|0)>=(d|0))return;if((l|0)<=0){k=(i|0)>0;r=m;do{q=f[b+(r<<2)>>2]|0;o=f[c+(r<<2)>>2]|0;if(k){p=0;do{f[o+(p<<2)>>2]=f[q+(f[e+(p<<2)>>2]<<2)>>2];p=p+1|0}while((p|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(l|0)<(i|0);k=m;do{m=f[b+(k<<2)>>2]|0;p=f[c+(k<<2)>>2]|0;q=0;do{o=f[e+(q<<2)>>2]|0;a=q<<1;n[p+(q<<2)>>2]=+n[m+(o<<2)>>2]*+n[g+(a<<2)>>2]+ +n[m+(o+j<<2)>>2]*+n[g+((a|1)<<2)>>2];q=q+1|0}while((q|0)!=(l|0));if(r){q=l;do{f[p+(q<<2)>>2]=f[m+(f[e+(q<<2)>>2]<<2)>>2];q=q+1|0}while((q|0)!=(i|0))}k=k+1|0}while((k|0)!=(d|0));return}function gca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0.0,h=0.0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=+n[d>>2];h=+n[d+4>>2];d=f[b>>2]|0;a=f[b+4>>2]|0;b=e+-4|0;if((e|0)<4)i=0;else{j=0;do{k=j|1;l=g*+n[d+(k<<2)>>2]+h*+n[a+(k<<2)>>2];n[c+(j<<2)>>2]=g*+n[d+(j<<2)>>2]+h*+n[a+(j<<2)>>2];n[c+(k<<2)>>2]=l;k=j|2;m=j|3;l=g*+n[d+(m<<2)>>2]+h*+n[a+(m<<2)>>2];n[c+(k<<2)>>2]=g*+n[d+(k<<2)>>2]+h*+n[a+(k<<2)>>2];n[c+(m<<2)>>2]=l;j=j+4|0}while((j|0)<=(b|0));i=e&-4}if((i|0)<(e|0))o=i;else return;do{n[c+(o<<2)>>2]=g*+n[d+(o<<2)>>2]+h*+n[a+(o<<2)>>2];o=o+1|0}while((o|0)!=(e|0));return}function hca(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47332;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function ica(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47332;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function jca(a){a=a|0;ica(a);YDc(a);return}function kca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))lca(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;mca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function lca(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((e|0)<2)o=0;else{l=e+-1|0;i=f[b>>2]|0;a=f[c>>2]|0;if((m|0)<=0){p=(j|0)>0;q=0;r=i;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[g+(v<<2)>>2]|0;n[u+(v<<2)>>2]=+(d[t+(w<<1)>>1]|0);n[s+(v<<2)>>2]=+(d[r+(w<<1)>>1]|0);v=v+1|0}while((v|0)!=(j|0))}if((q|0)==(l|0)){o=l;break a}}}q=(m|0)<(j|0);r=0;s=i;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[g+(u<<2)>>2]|0;x=u<<1;y=+n[h+(x<<2)>>2];z=+n[h+((x|1)<<2)>>2];x=w+k|0;A=y*+(d[s+(w<<1)>>1]|0)+z*+(d[s+(x<<1)>>1]|0);n[t+(u<<2)>>2]=y*+(d[v+(w<<1)>>1]|0)+z*+(d[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=A;u=u+1|0}while((u|0)!=(m|0));if(q){u=m;do{x=f[g+(u<<2)>>2]|0;n[t+(u<<2)>>2]=+(d[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=+(d[s+(x<<1)>>1]|0);u=u+1|0}while((u|0)!=(j|0))}}while((r|0)!=(l|0));o=l}while(0);if((o|0)>=(e|0))return;if((m|0)<=0){l=(j|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(l){q=0;do{n[p+(q<<2)>>2]=+(d[s+(f[g+(q<<2)>>2]<<1)>>1]|0);q=q+1|0}while((q|0)!=(j|0))}r=r+1|0}while((r|0)!=(e|0));return}r=(m|0)<(j|0);l=o;do{o=f[b+(l<<2)>>2]|0;q=f[c+(l<<2)>>2]|0;s=0;do{p=f[g+(s<<2)>>2]|0;a=s<<1;n[q+(s<<2)>>2]=+(d[o+(p<<1)>>1]|0)*+n[h+(a<<2)>>2]+ +(d[o+(p+k<<1)>>1]|0)*+n[h+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(m|0));if(r){s=m;do{n[q+(s<<2)>>2]=+(d[o+(f[g+(s<<2)>>2]<<1)>>1]|0);s=s+1|0}while((s|0)!=(j|0))}l=l+1|0}while((l|0)!=(e|0));return}function mca(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0;h=+n[e>>2];i=+n[e+4>>2];e=f[b>>2]|0;a=f[b+4>>2]|0;b=g+-4|0;if((g|0)<4)j=0;else{k=0;do{l=k|1;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];o=mrc(h*+n[e+(k<<2)>>2]+i*+n[a+(k<<2)>>2])|0;d[c+(k<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=mrc(m)|0;d[c+(l<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=k|2;l=k|3;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];p=mrc(h*+n[e+(o<<2)>>2]+i*+n[a+(o<<2)>>2])|0;d[c+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=mrc(m)|0;d[c+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;k=k+4|0}while((k|0)<=(b|0));j=g&-4}if((j|0)<(g|0))q=j;else return;do{j=mrc(h*+n[e+(q<<2)>>2]+i*+n[a+(q<<2)>>2])|0;d[c+(q<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;q=q+1|0}while((q|0)!=(g|0));return}function nca(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47352;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function oca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47352;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function pca(a){a=a|0;oca(a);YDc(a);return}function qca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))rca(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;sca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function rca(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((d|0)<2)o=0;else{l=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((m|0)<=0){p=(i|0)>0;q=0;r=h;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[e+(v<<2)>>2]|0;n[u+(v<<2)>>2]=+(j[t+(w<<1)>>1]|0);n[s+(v<<2)>>2]=+(j[r+(w<<1)>>1]|0);v=v+1|0}while((v|0)!=(i|0))}if((q|0)==(l|0)){o=l;break a}}}q=(m|0)<(i|0);r=0;s=h;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[e+(u<<2)>>2]|0;x=u<<1;y=+n[g+(x<<2)>>2];z=+n[g+((x|1)<<2)>>2];x=w+k|0;A=y*+(j[s+(w<<1)>>1]|0)+z*+(j[s+(x<<1)>>1]|0);n[t+(u<<2)>>2]=y*+(j[v+(w<<1)>>1]|0)+z*+(j[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=A;u=u+1|0}while((u|0)!=(m|0));if(q){u=m;do{x=f[e+(u<<2)>>2]|0;n[t+(u<<2)>>2]=+(j[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=+(j[s+(x<<1)>>1]|0);u=u+1|0}while((u|0)!=(i|0))}}while((r|0)!=(l|0));o=l}while(0);if((o|0)>=(d|0))return;if((m|0)<=0){l=(i|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(l){q=0;do{n[p+(q<<2)>>2]=+(j[s+(f[e+(q<<2)>>2]<<1)>>1]|0);q=q+1|0}while((q|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(m|0)<(i|0);l=o;do{o=f[b+(l<<2)>>2]|0;q=f[c+(l<<2)>>2]|0;s=0;do{p=f[e+(s<<2)>>2]|0;a=s<<1;n[q+(s<<2)>>2]=+(j[o+(p<<1)>>1]|0)*+n[g+(a<<2)>>2]+ +(j[o+(p+k<<1)>>1]|0)*+n[g+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(m|0));if(r){s=m;do{n[q+(s<<2)>>2]=+(j[o+(f[e+(s<<2)>>2]<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0))}l=l+1|0}while((l|0)!=(d|0));return}function sca(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0;h=+n[e>>2];i=+n[e+4>>2];e=f[b>>2]|0;a=f[b+4>>2]|0;b=g+-4|0;if((g|0)<4)j=0;else{k=0;do{l=k|1;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];o=mrc(h*+n[e+(k<<2)>>2]+i*+n[a+(k<<2)>>2])|0;d[c+(k<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=mrc(m)|0;d[c+(l<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=k|2;l=k|3;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];p=mrc(h*+n[e+(o<<2)>>2]+i*+n[a+(o<<2)>>2])|0;d[c+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;p=mrc(m)|0;d[c+(l<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;k=k+4|0}while((k|0)<=(b|0));j=g&-4}if((j|0)<(g|0))q=j;else return;do{j=mrc(h*+n[e+(q<<2)>>2]+i*+n[a+(q<<2)>>2])|0;d[c+(q<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;q=q+1|0}while((q|0)!=(g|0));return}function tca(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47372;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function uca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47372;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function vca(a){a=a|0;uca(a);YDc(a);return}function wca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<1)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))xca(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;yca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<1)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function xca(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;a:do if((e|0)<2)o=0;else{m=e+-1|0;j=f[b>>2]|0;a=f[c>>2]|0;if((n|0)<=0){p=(k|0)>0;q=0;r=j;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[g+(v<<2)>>2]|0;f[u+(v<<2)>>2]=h[t+w>>0]<<11;f[s+(v<<2)>>2]=h[r+w>>0]<<11;v=v+1|0}while((v|0)!=(k|0))}if((q|0)==(m|0)){o=m;break a}}}q=(n|0)<(k|0);r=0;s=j;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[g+(u<<2)>>2]|0;x=u<<1;y=d[i+(x<<1)>>1]|0;z=d[i+((x|1)<<1)>>1]|0;x=Y(h[v+w>>0]|0,y)|0;A=w+l|0;B=(Y(h[v+A>>0]|0,z)|0)+x|0;x=Y(h[s+w>>0]|0,y)|0;y=(Y(h[s+A>>0]|0,z)|0)+x|0;f[t+(u<<2)>>2]=B;f[p+(u<<2)>>2]=y;u=u+1|0}while((u|0)!=(n|0));if(q){u=n;do{y=f[g+(u<<2)>>2]|0;f[t+(u<<2)>>2]=h[v+y>>0]<<11;f[p+(u<<2)>>2]=h[s+y>>0]<<11;u=u+1|0}while((u|0)!=(k|0))}}while((r|0)!=(m|0));o=m}while(0);if((o|0)>=(e|0))return;if((n|0)<=0){m=(k|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(m){q=0;do{f[p+(q<<2)>>2]=h[s+(f[g+(q<<2)>>2]|0)>>0]<<11;q=q+1|0}while((q|0)!=(k|0))}r=r+1|0}while((r|0)!=(e|0));return}r=(n|0)<(k|0);m=o;do{o=f[b+(m<<2)>>2]|0;q=f[c+(m<<2)>>2]|0;s=0;do{p=f[g+(s<<2)>>2]|0;a=s<<1;j=Y(d[i+(a<<1)>>1]|0,h[o+p>>0]|0)|0;u=(Y(d[i+((a|1)<<1)>>1]|0,h[o+(p+l)>>0]|0)|0)+j|0;f[q+(s<<2)>>2]=u;s=s+1|0}while((s|0)!=(n|0));if(r){s=n;do{f[q+(s<<2)>>2]=h[o+(f[g+(s<<2)>>2]|0)>>0]<<11;s=s+1|0}while((s|0)!=(k|0))}m=m+1|0}while((m|0)!=(e|0));return}function yca(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=d[g>>1]|0;i=d[g+2>>1]|0;g=f[c>>2]|0;j=f[c+4>>2]|0;c=h+-4|0;if((h|0)<4)k=0;else{l=a<<16>>16;m=i<<16>>16;n=0;do{o=(Y(f[g+(n<<2)>>2]>>4,l)|0)>>>16;p=(o+2+((Y(f[j+(n<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+n>>0]=p;p=n|1;o=(Y(f[g+(p<<2)>>2]>>4,l)|0)>>>16;q=(o+2+((Y(f[j+(p<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+p>>0]=q;q=n|2;p=(Y(f[g+(q<<2)>>2]>>4,l)|0)>>>16;o=(p+2+((Y(f[j+(q<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+q>>0]=o;o=n|3;q=(Y(f[g+(o<<2)>>2]>>4,l)|0)>>>16;p=(q+2+((Y(f[j+(o<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+o>>0]=p;n=n+4|0}while((n|0)<=(c|0));k=h&-4}if((k|0)>=(h|0))return;c=a<<16>>16;a=i<<16>>16;i=k;do{k=(Y(f[g+(i<<2)>>2]>>4,c)|0)>>>16;n=(k+2+((Y(f[j+(i<<2)>>2]>>4,a)|0)>>>16)|0)>>>2&255;b[e+i>>0]=n;i=i+1|0}while((i|0)!=(h|0));return}function zca(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;ada(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);bda(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);bda(o);u=k;return}function Aca(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Wca(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Xca(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Xca(o);u=k;return}function Bca(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Qca(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Rca(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Rca(o);u=k;return}function Cca(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Kca(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Lca(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Lca(o);u=k;return}function Dca(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Eca(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Fca(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;y8(n,o,y);Fca(o);u=k;return}function Eca(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47392;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function Fca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47392;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Gca(a){a=a|0;Fca(a);YDc(a);return}function Hca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1296|0;d=c+1289|0;e=c+1288|0;g=c;h=c+1224|0;i=c+1160|0;j=c+1096|0;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>136){s=XDc(p>>>0>536870911?-1:p<<3)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<3)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<3;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Ica(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Jca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=136;u=c;return}function Ica(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)<=0)return;a=j*3|0;m=j<<1;o=j<<2;q=0-(i<<3)|0;r=0;s=g;while(1){g=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=k;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,j)|0)+A|0;if(D>>>0<h>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+j|0;else{G=F;break}while(1)if((G|0)<(h|0)){E=G;break}else G=G-j|0}B=B+ +p[g+(E<<3)>>3]*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);p[t+(y<<3)>>3]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(i|0))break;if((H|0)<(l|0)){J=H;K=I}else{u=i;v=H;w=I;continue}while(1){z=f[e+(J<<2)>>2]|0;p[t+(J<<3)>>3]=+p[g+(z-a<<3)>>3]*+n[K>>2]+ +p[g+(z-m<<3)>>3]*+n[K+4>>2]+ +p[g+(z-j<<3)>>3]*+n[K+8>>2]+ +p[g+(z<<3)>>3]*+n[K+12>>2]+ +p[g+(z+j<<3)>>3]*+n[K+16>>2]+ +p[g+(z+m<<3)>>3]*+n[K+20>>2]+ +p[g+(z+a<<3)>>3]*+n[K+24>>2]+ +p[g+(z+o<<3)>>3]*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(l|0)){J=z;K=y}else{u=i;v=l;w=y;continue a}}}r=r+1|0;if((r|0)==(d|0))break;else s=I+(q<<2)|0}return}function Jca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0.0,o=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0;a=e+-4|0;if((e|0)<4)g=0;else{h=+n[d>>2];i=f[b>>2]|0;j=f[b+16>>2]|0;k=+n[d+4>>2];l=f[b+4>>2]|0;m=+n[d+8>>2];o=f[b+8>>2]|0;q=+n[d+12>>2];r=f[b+12>>2]|0;s=+n[d+16>>2];t=+n[d+20>>2];u=f[b+20>>2]|0;v=+n[d+24>>2];w=f[b+24>>2]|0;x=+n[d+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=h*+p[i+(A<<3)>>3]+k*+p[l+(A<<3)>>3]+m*+p[o+(A<<3)>>3]+q*+p[r+(A<<3)>>3]+s*+p[j+(A<<3)>>3]+t*+p[u+(A<<3)>>3]+v*+p[w+(A<<3)>>3]+x*+p[y+(A<<3)>>3];E=h*+p[i+(B<<3)>>3]+k*+p[l+(B<<3)>>3]+m*+p[o+(B<<3)>>3]+q*+p[r+(B<<3)>>3]+s*+p[j+(B<<3)>>3]+t*+p[u+(B<<3)>>3]+v*+p[w+(B<<3)>>3]+x*+p[y+(B<<3)>>3];F=h*+p[i+(C<<3)>>3]+k*+p[l+(C<<3)>>3]+m*+p[o+(C<<3)>>3]+q*+p[r+(C<<3)>>3]+s*+p[j+(C<<3)>>3]+t*+p[u+(C<<3)>>3]+v*+p[w+(C<<3)>>3]+x*+p[y+(C<<3)>>3];p[c+(z<<3)>>3]=h*+p[i+(z<<3)>>3]+k*+p[l+(z<<3)>>3]+m*+p[o+(z<<3)>>3]+q*+p[r+(z<<3)>>3]+s*+p[j+(z<<3)>>3]+t*+p[u+(z<<3)>>3]+v*+p[w+(z<<3)>>3]+x*+p[y+(z<<3)>>3];p[c+(A<<3)>>3]=D;p[c+(B<<3)>>3]=E;p[c+(C<<3)>>3]=F;z=z+4|0}while((z|0)<=(a|0));g=e&-4}if((g|0)>=(e|0))return;a=f[b>>2]|0;x=+n[d>>2];z=f[b+4>>2]|0;v=+n[d+4>>2];y=f[b+8>>2]|0;t=+n[d+8>>2];w=f[b+12>>2]|0;s=+n[d+12>>2];u=f[b+16>>2]|0;q=+n[d+16>>2];j=f[b+20>>2]|0;m=+n[d+20>>2];r=f[b+24>>2]|0;k=+n[d+24>>2];o=f[b+28>>2]|0;h=+n[d+28>>2];d=g;do{p[c+(d<<3)>>3]=+p[a+(d<<3)>>3]*x+ +p[z+(d<<3)>>3]*v+ +p[y+(d<<3)>>3]*t+ +p[w+(d<<3)>>3]*s+ +p[u+(d<<3)>>3]*q+ +p[j+(d<<3)>>3]*m+ +p[r+(d<<3)>>3]*k+ +p[o+(d<<3)>>3]*h;d=d+1|0}while((d|0)!=(e|0));return}function Kca(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47412;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function Lca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47412;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Mca(a){a=a|0;Lca(a);YDc(a);return}function Nca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Oca(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Pca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Oca(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;if((d|0)<=0)return;a=j*3|0;m=j<<1;o=j<<2;p=0-(i<<3)|0;q=0;r=g;while(1){g=f[b+(q<<2)>>2]|0;s=f[c+(q<<2)>>2]|0;t=k;u=0;v=r;a:while(1){if((t|0)>(u|0)){w=t-u<<3;x=u;y=v;while(1){z=f[e+(x<<2)>>2]|0;A=0.0;B=0;do{C=(Y(B+-3|0,j)|0)+z|0;if(C>>>0<h>>>0)D=C;else{E=C;while(1)if((E|0)<0)E=E+j|0;else{F=E;break}while(1)if((F|0)<(h|0)){D=F;break}else F=F-j|0}A=A+ +n[g+(D<<2)>>2]*+n[y+(B<<2)>>2];B=B+1|0}while((B|0)!=8);n[s+(x<<2)>>2]=A;x=x+1|0;if((x|0)==(t|0))break;else y=y+32|0}G=t;H=v+(w<<2)|0}else{G=u;H=v}if((t|0)==(i|0))break;if((G|0)<(l|0)){I=G;J=H}else{t=i;u=G;v=H;continue}while(1){y=f[e+(I<<2)>>2]|0;n[s+(I<<2)>>2]=+n[g+(y-a<<2)>>2]*+n[J>>2]+ +n[g+(y-m<<2)>>2]*+n[J+4>>2]+ +n[g+(y-j<<2)>>2]*+n[J+8>>2]+ +n[g+(y<<2)>>2]*+n[J+12>>2]+ +n[g+(y+j<<2)>>2]*+n[J+16>>2]+ +n[g+(y+m<<2)>>2]*+n[J+20>>2]+ +n[g+(y+a<<2)>>2]*+n[J+24>>2]+ +n[g+(y+o<<2)>>2]*+n[J+28>>2];y=I+1|0;x=J+32|0;if((y|0)<(l|0)){I=y;J=x}else{t=i;u=l;v=x;continue a}}}q=q+1|0;if((q|0)==(d|0))break;else r=H+(p<<2)|0}return}function Pca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;a=e+-4|0;if((e|0)<4)g=0;else{h=f[b>>2]|0;i=d+4|0;j=f[b+16>>2]|0;k=f[b+20>>2]|0;l=f[b+4>>2]|0;m=d+8|0;o=f[b+8>>2]|0;p=d+12|0;q=f[b+12>>2]|0;r=d+16|0;s=d+20|0;t=d+24|0;u=f[b+24>>2]|0;v=d+28|0;w=f[b+28>>2]|0;x=0;do{y=+n[d>>2];z=x|1;A=x|2;B=x|3;C=+n[i>>2];D=+n[m>>2];E=+n[p>>2];F=+n[r>>2];G=+n[s>>2];H=+n[t>>2];I=+n[v>>2];J=y*+n[h+(z<<2)>>2]+C*+n[l+(z<<2)>>2]+D*+n[o+(z<<2)>>2]+E*+n[q+(z<<2)>>2]+F*+n[j+(z<<2)>>2]+G*+n[k+(z<<2)>>2]+H*+n[u+(z<<2)>>2]+I*+n[w+(z<<2)>>2];K=y*+n[h+(A<<2)>>2]+C*+n[l+(A<<2)>>2]+D*+n[o+(A<<2)>>2]+E*+n[q+(A<<2)>>2]+F*+n[j+(A<<2)>>2]+G*+n[k+(A<<2)>>2]+H*+n[u+(A<<2)>>2]+I*+n[w+(A<<2)>>2];L=y*+n[h+(B<<2)>>2]+C*+n[l+(B<<2)>>2]+D*+n[o+(B<<2)>>2]+E*+n[q+(B<<2)>>2]+F*+n[j+(B<<2)>>2]+G*+n[k+(B<<2)>>2]+H*+n[u+(B<<2)>>2]+I*+n[w+(B<<2)>>2];n[c+(x<<2)>>2]=y*+n[h+(x<<2)>>2]+C*+n[l+(x<<2)>>2]+D*+n[o+(x<<2)>>2]+E*+n[q+(x<<2)>>2]+F*+n[j+(x<<2)>>2]+G*+n[k+(x<<2)>>2]+H*+n[u+(x<<2)>>2]+I*+n[w+(x<<2)>>2];n[c+(z<<2)>>2]=J;n[c+(A<<2)>>2]=K;n[c+(B<<2)>>2]=L;x=x+4|0}while((x|0)<=(a|0));g=e&-4}if((g|0)>=(e|0))return;a=f[b>>2]|0;x=f[b+4>>2]|0;w=d+4|0;u=f[b+8>>2]|0;k=d+8|0;j=f[b+12>>2]|0;q=d+12|0;o=f[b+16>>2]|0;l=d+16|0;h=f[b+20>>2]|0;v=d+20|0;t=f[b+24>>2]|0;s=d+24|0;r=f[b+28>>2]|0;b=d+28|0;p=g;do{n[c+(p<<2)>>2]=+n[a+(p<<2)>>2]*+n[d>>2]+ +n[x+(p<<2)>>2]*+n[w>>2]+ +n[u+(p<<2)>>2]*+n[k>>2]+ +n[j+(p<<2)>>2]*+n[q>>2]+ +n[o+(p<<2)>>2]*+n[l>>2]+ +n[h+(p<<2)>>2]*+n[v>>2]+ +n[t+(p<<2)>>2]*+n[s>>2]+ +n[r+(p<<2)>>2]*+n[b>>2];p=p+1|0}while((p|0)!=(e|0));return}function Qca(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47432;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function Rca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47432;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Sca(a){a=a|0;Rca(a);YDc(a);return}function Tca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Uca(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Vca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Uca(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((e|0)<=0)return;a=k*3|0;o=k<<1;p=k<<2;q=0-(j<<3)|0;r=0;s=h;while(1){h=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=l;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,k)|0)+A|0;if(D>>>0<i>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+k|0;else{G=F;break}while(1)if((G|0)<(i|0)){E=G;break}else G=G-k|0}B=B+ +(d[h+(E<<1)>>1]|0)*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);n[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(j|0))break;if((H|0)<(m|0)){J=H;K=I}else{u=j;v=H;w=I;continue}while(1){z=f[g+(J<<2)>>2]|0;n[t+(J<<2)>>2]=+(d[h+(z-a<<1)>>1]|0)*+n[K>>2]+ +(d[h+(z-o<<1)>>1]|0)*+n[K+4>>2]+ +(d[h+(z-k<<1)>>1]|0)*+n[K+8>>2]+ +(d[h+(z<<1)>>1]|0)*+n[K+12>>2]+ +(d[h+(z+k<<1)>>1]|0)*+n[K+16>>2]+ +(d[h+(z+o<<1)>>1]|0)*+n[K+20>>2]+ +(d[h+(z+a<<1)>>1]|0)*+n[K+24>>2]+ +(d[h+(z+p<<1)>>1]|0)*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(m|0)){J=z;K=y}else{u=j;v=m;w=y;continue a}}}r=r+1|0;if((r|0)==(e|0))break;else s=I+(q<<2)|0}return}function Vca(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0;a=g+-4|0;if((g|0)<4)h=0;else{i=+n[e>>2];j=f[b>>2]|0;k=+n[e+20>>2];l=f[b+20>>2]|0;m=+n[e+4>>2];o=f[b+4>>2]|0;p=+n[e+8>>2];q=f[b+8>>2]|0;r=+n[e+12>>2];s=f[b+12>>2]|0;t=+n[e+16>>2];u=f[b+16>>2]|0;v=+n[e+24>>2];w=f[b+24>>2]|0;x=+n[e+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=i*+n[j+(A<<2)>>2]+m*+n[o+(A<<2)>>2]+p*+n[q+(A<<2)>>2]+r*+n[s+(A<<2)>>2]+t*+n[u+(A<<2)>>2]+k*+n[l+(A<<2)>>2]+v*+n[w+(A<<2)>>2]+x*+n[y+(A<<2)>>2];E=i*+n[j+(B<<2)>>2]+m*+n[o+(B<<2)>>2]+p*+n[q+(B<<2)>>2]+r*+n[s+(B<<2)>>2]+t*+n[u+(B<<2)>>2]+k*+n[l+(B<<2)>>2]+v*+n[w+(B<<2)>>2]+x*+n[y+(B<<2)>>2];F=i*+n[j+(C<<2)>>2]+m*+n[o+(C<<2)>>2]+p*+n[q+(C<<2)>>2]+r*+n[s+(C<<2)>>2]+t*+n[u+(C<<2)>>2]+k*+n[l+(C<<2)>>2]+v*+n[w+(C<<2)>>2]+x*+n[y+(C<<2)>>2];G=mrc(i*+n[j+(z<<2)>>2]+m*+n[o+(z<<2)>>2]+p*+n[q+(z<<2)>>2]+r*+n[s+(z<<2)>>2]+t*+n[u+(z<<2)>>2]+k*+n[l+(z<<2)>>2]+v*+n[w+(z<<2)>>2]+x*+n[y+(z<<2)>>2])|0;d[c+(z<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=mrc(D)|0;d[c+(A<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=mrc(E)|0;d[c+(B<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=mrc(F)|0;d[c+(C<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;z=z+4|0}while((z|0)<=(a|0));h=g&-4}if((h|0)>=(g|0))return;a=f[b>>2]|0;x=+n[e>>2];z=f[b+4>>2]|0;v=+n[e+4>>2];y=f[b+8>>2]|0;k=+n[e+8>>2];w=f[b+12>>2]|0;t=+n[e+12>>2];l=f[b+16>>2]|0;r=+n[e+16>>2];u=f[b+20>>2]|0;p=+n[e+20>>2];s=f[b+24>>2]|0;m=+n[e+24>>2];q=f[b+28>>2]|0;i=+n[e+28>>2];e=h;do{h=mrc(+n[a+(e<<2)>>2]*x+ +n[z+(e<<2)>>2]*v+ +n[y+(e<<2)>>2]*k+ +n[w+(e<<2)>>2]*t+ +n[l+(e<<2)>>2]*r+ +n[u+(e<<2)>>2]*p+ +n[s+(e<<2)>>2]*m+ +n[q+(e<<2)>>2]*i)|0;d[c+(e<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;e=e+1|0}while((e|0)!=(g|0));return}function Wca(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47452;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function Xca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47452;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Yca(a){a=a|0;Xca(a);YDc(a);return}function Zca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))_ca(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;$ca(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function _ca(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)<=0)return;a=k*3|0;o=k<<1;p=k<<2;q=0-(i<<3)|0;r=0;s=g;while(1){g=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=l;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,k)|0)+A|0;if(D>>>0<h>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+k|0;else{G=F;break}while(1)if((G|0)<(h|0)){E=G;break}else G=G-k|0}B=B+ +(j[g+(E<<1)>>1]|0)*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);n[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(i|0))break;if((H|0)<(m|0)){J=H;K=I}else{u=i;v=H;w=I;continue}while(1){z=f[e+(J<<2)>>2]|0;n[t+(J<<2)>>2]=+(j[g+(z-a<<1)>>1]|0)*+n[K>>2]+ +(j[g+(z-o<<1)>>1]|0)*+n[K+4>>2]+ +(j[g+(z-k<<1)>>1]|0)*+n[K+8>>2]+ +(j[g+(z<<1)>>1]|0)*+n[K+12>>2]+ +(j[g+(z+k<<1)>>1]|0)*+n[K+16>>2]+ +(j[g+(z+o<<1)>>1]|0)*+n[K+20>>2]+ +(j[g+(z+a<<1)>>1]|0)*+n[K+24>>2]+ +(j[g+(z+p<<1)>>1]|0)*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(m|0)){J=z;K=y}else{u=i;v=m;w=y;continue a}}}r=r+1|0;if((r|0)==(d|0))break;else s=I+(q<<2)|0}return}function $ca(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0;a=g+-4|0;if((g|0)<4)h=0;else{i=+n[e>>2];j=f[b>>2]|0;k=+n[e+20>>2];l=f[b+20>>2]|0;m=+n[e+4>>2];o=f[b+4>>2]|0;p=+n[e+8>>2];q=f[b+8>>2]|0;r=+n[e+12>>2];s=f[b+12>>2]|0;t=+n[e+16>>2];u=f[b+16>>2]|0;v=+n[e+24>>2];w=f[b+24>>2]|0;x=+n[e+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=i*+n[j+(A<<2)>>2]+m*+n[o+(A<<2)>>2]+p*+n[q+(A<<2)>>2]+r*+n[s+(A<<2)>>2]+t*+n[u+(A<<2)>>2]+k*+n[l+(A<<2)>>2]+v*+n[w+(A<<2)>>2]+x*+n[y+(A<<2)>>2];E=i*+n[j+(B<<2)>>2]+m*+n[o+(B<<2)>>2]+p*+n[q+(B<<2)>>2]+r*+n[s+(B<<2)>>2]+t*+n[u+(B<<2)>>2]+k*+n[l+(B<<2)>>2]+v*+n[w+(B<<2)>>2]+x*+n[y+(B<<2)>>2];F=i*+n[j+(C<<2)>>2]+m*+n[o+(C<<2)>>2]+p*+n[q+(C<<2)>>2]+r*+n[s+(C<<2)>>2]+t*+n[u+(C<<2)>>2]+k*+n[l+(C<<2)>>2]+v*+n[w+(C<<2)>>2]+x*+n[y+(C<<2)>>2];G=mrc(i*+n[j+(z<<2)>>2]+m*+n[o+(z<<2)>>2]+p*+n[q+(z<<2)>>2]+r*+n[s+(z<<2)>>2]+t*+n[u+(z<<2)>>2]+k*+n[l+(z<<2)>>2]+v*+n[w+(z<<2)>>2]+x*+n[y+(z<<2)>>2])|0;d[c+(z<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=mrc(D)|0;d[c+(A<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=mrc(E)|0;d[c+(B<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=mrc(F)|0;d[c+(C<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;z=z+4|0}while((z|0)<=(a|0));h=g&-4}if((h|0)>=(g|0))return;a=f[b>>2]|0;x=+n[e>>2];z=f[b+4>>2]|0;v=+n[e+4>>2];y=f[b+8>>2]|0;k=+n[e+8>>2];w=f[b+12>>2]|0;t=+n[e+12>>2];l=f[b+16>>2]|0;r=+n[e+16>>2];u=f[b+20>>2]|0;p=+n[e+20>>2];s=f[b+24>>2]|0;m=+n[e+24>>2];q=f[b+28>>2]|0;i=+n[e+28>>2];e=h;do{h=mrc(+n[a+(e<<2)>>2]*x+ +n[z+(e<<2)>>2]*v+ +n[y+(e<<2)>>2]*k+ +n[w+(e<<2)>>2]*t+ +n[l+(e<<2)>>2]*r+ +n[u+(e<<2)>>2]*p+ +n[s+(e<<2)>>2]*m+ +n[q+(e<<2)>>2]*i)|0;d[c+(e<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;e=e+1|0}while((e|0)!=(g|0));return}function ada(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=47472;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;ZS(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;ZS(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;o=tT(p,18)|0;l=251352;n=o+18|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));z5(-215,p,251371,251130,1862)}}function bda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47472;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function cda(a){a=a|0;bda(a);YDc(a);return}function dda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=XDc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){XIc(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<1)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){dJc(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))eda(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;fda(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<1)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)ZDc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function eda(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((e|0)<=0)return;a=l*3|0;o=l<<1;p=l<<2;q=0-(k<<3)|0;r=0;s=i;while(1){i=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=m;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=0;C=0;do{D=(Y(C+-3|0,l)|0)+A|0;if(D>>>0<j>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+l|0;else{G=F;break}while(1)if((G|0)<(j|0)){E=G;break}else G=G-l|0}B=(Y(d[z+(C<<1)>>1]|0,h[i+E>>0]|0)|0)+B|0;C=C+1|0}while((C|0)!=8);f[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}H=u;I=w+(x<<1)|0}else{H=v;I=w}if((u|0)==(k|0))break;if((H|0)<(n|0)){J=H;K=I}else{u=k;v=H;w=I;continue}while(1){z=f[g+(J<<2)>>2]|0;y=Y(d[K>>1]|0,h[i+(z-a)>>0]|0)|0;C=(Y(d[K+2>>1]|0,h[i+(z-o)>>0]|0)|0)+y|0;y=C+(Y(d[K+4>>1]|0,h[i+(z-l)>>0]|0)|0)|0;C=y+(Y(d[K+6>>1]|0,h[i+z>>0]|0)|0)|0;y=C+(Y(d[K+8>>1]|0,h[i+(z+l)>>0]|0)|0)|0;C=y+(Y(d[K+10>>1]|0,h[i+(z+o)>>0]|0)|0)|0;y=C+(Y(d[K+12>>1]|0,h[i+(z+a)>>0]|0)|0)|0;C=y+(Y(d[K+14>>1]|0,h[i+(z+p)>>0]|0)|0)|0;f[t+(J<<2)>>2]=C;C=J+1|0;z=K+16|0;if((C|0)<(n|0)){J=C;K=z}else{u=k;v=n;w=z;continue a}}}r=r+1|0;if((r|0)==(e|0))break;else s=I+(q<<1)|0}return}function fda(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=h+-4|0;if((h|0)<4)i=0;else{j=g+2|0;k=c+4|0;l=g+4|0;m=c+8|0;n=g+6|0;o=c+12|0;p=g+8|0;q=c+16|0;r=g+10|0;s=c+20|0;t=g+12|0;u=c+24|0;v=g+14|0;w=c+28|0;x=0;do{y=d[g>>1]|0;z=f[c>>2]|0;A=Y(f[z+(x<<2)>>2]|0,y)|0;B=x|1;C=Y(f[z+(B<<2)>>2]|0,y)|0;D=x|2;E=Y(f[z+(D<<2)>>2]|0,y)|0;F=x|3;G=Y(f[z+(F<<2)>>2]|0,y)|0;y=d[j>>1]|0;z=f[k>>2]|0;H=(Y(f[z+(x<<2)>>2]|0,y)|0)+A|0;A=(Y(f[z+(B<<2)>>2]|0,y)|0)+C|0;C=(Y(f[z+(D<<2)>>2]|0,y)|0)+E|0;E=(Y(f[z+(F<<2)>>2]|0,y)|0)+G|0;G=d[l>>1]|0;y=f[m>>2]|0;z=(Y(f[y+(x<<2)>>2]|0,G)|0)+H|0;H=(Y(f[y+(B<<2)>>2]|0,G)|0)+A|0;A=(Y(f[y+(D<<2)>>2]|0,G)|0)+C|0;C=(Y(f[y+(F<<2)>>2]|0,G)|0)+E|0;E=d[n>>1]|0;G=f[o>>2]|0;y=(Y(f[G+(x<<2)>>2]|0,E)|0)+z|0;z=(Y(f[G+(B<<2)>>2]|0,E)|0)+H|0;H=(Y(f[G+(D<<2)>>2]|0,E)|0)+A|0;A=(Y(f[G+(F<<2)>>2]|0,E)|0)+C|0;C=d[p>>1]|0;E=f[q>>2]|0;G=(Y(f[E+(x<<2)>>2]|0,C)|0)+y|0;y=(Y(f[E+(B<<2)>>2]|0,C)|0)+z|0;z=(Y(f[E+(D<<2)>>2]|0,C)|0)+H|0;H=(Y(f[E+(F<<2)>>2]|0,C)|0)+A|0;A=d[r>>1]|0;C=f[s>>2]|0;E=(Y(f[C+(x<<2)>>2]|0,A)|0)+G|0;G=(Y(f[C+(B<<2)>>2]|0,A)|0)+y|0;y=(Y(f[C+(D<<2)>>2]|0,A)|0)+z|0;z=(Y(f[C+(F<<2)>>2]|0,A)|0)+H|0;H=d[t>>1]|0;A=f[u>>2]|0;C=(Y(f[A+(x<<2)>>2]|0,H)|0)+E|0;E=(Y(f[A+(B<<2)>>2]|0,H)|0)+G|0;G=(Y(f[A+(D<<2)>>2]|0,H)|0)+y|0;y=(Y(f[A+(F<<2)>>2]|0,H)|0)+z|0;z=d[v>>1]|0;H=f[w>>2]|0;A=(Y(f[H+(x<<2)>>2]|0,z)|0)+C|0;C=(Y(f[H+(B<<2)>>2]|0,z)|0)+E|0;E=(Y(f[H+(D<<2)>>2]|0,z)|0)+G|0;G=(Y(f[H+(F<<2)>>2]|0,z)|0)+y|0;y=A+2097152>>22;b[e+x>>0]=y>>>0<256?y:(y|0)>0?255:0;y=C+2097152>>22;b[e+B>>0]=y>>>0<256?y:(y|0)>0?255:0;y=E+2097152>>22;b[e+D>>0]=y>>>0<256?y:(y|0)>0?255:0;y=G+2097152>>22;b[e+F>>0]=y>>>0<256?y:(y|0)>0?255:0;x=x+4|0}while((x|0)<=(a|0));i=h&-4}if((i|0)>=(h|0))return;a=c+4|0;x=g+2|0;w=c+8|0;v=g+4|0;u=c+12|0;t=g+6|0;s=c+16|0;r=g+8|0;q=c+20|0;p=g+10|0;o=c+24|0;n=g+12|0;m=c+28|0;l=g+14|0;k=i;do{i=Y(d[g>>1]|0,f[(f[c>>2]|0)+(k<<2)>>2]|0)|0;j=Y(d[x>>1]|0,f[(f[a>>2]|0)+(k<<2)>>2]|0)|0;y=Y(d[v>>1]|0,f[(f[w>>2]|0)+(k<<2)>>2]|0)|0;F=Y(d[t>>1]|0,f[(f[u>>2]|0)+(k<<2)>>2]|0)|0;G=Y(d[r>>1]|0,f[(f[s>>2]|0)+(k<<2)>>2]|0)|0;D=Y(d[p>>1]|0,f[(f[q>>2]|0)+(k<<2)>>2]|0)|0;E=Y(d[n>>1]|0,f[(f[o>>2]|0)+(k<<2)>>2]|0)|0;B=i+2097152+j+y+F+G+D+E+(Y(d[l>>1]|0,f[(f[m>>2]|0)+(k<<2)>>2]|0)|0)>>22;b[e+k>>0]=B>>>0<256?B:(B|0)>0?255:0;k=k+1|0}while((k|0)!=(h|0));return}function gda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=47572;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}function hda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=47552;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}function ida(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=47532;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}function jda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=47512;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}function kda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=47492;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;y8(j,k,o);u=i;return}function lda(a){a=a|0;YDc(a);return}function mda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;c=u;u=u+1104|0;d=c;e=a+8|0;g=f[e>>2]|0;h=(f[g>>2]|0)>>>3;i=(h&511)+1|0;j=Y(i,f[(f[g+40>>2]|0)+4>>2]|0)|0;g=j<<1;k=d+8|0;f[d>>2]=k;l=d+4|0;f[l>>2]=g;if(g>>>0>136){m=XDc(g>>>0>536870911?-1:g<<3)|0;f[d>>2]=m;o=m}else o=k;m=f[a+12>>2]|0;g=f[a+20>>2]|0;q=o+(j<<3)|0;r=f[a+28>>2]|0;s=f[r+(f[b>>2]<<2)>>2]|0;t=f[r+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;r=f[(f[b>>2]|0)+(s*12|0)+4>>2]|0;v=(j|0)>0;if(v)XIc(q|0,0,j<<3|0)|0;a:do if((s|0)<(t|0)){w=f[b>>2]|0;x=f[a+4>>2]|0;y=f[x+16>>2]|0;z=f[f[x+44>>2]>>2]|0;x=h&65535;A=(g|0)>0;B=j<<3;C=r;D=s;while(1){E=+n[w+(D*12|0)+8>>2];F=f[w+(D*12|0)+4>>2]|0;G=y+(Y(z,f[w+(D*12|0)>>2]|0)|0)|0;if(v)XIc(o|0,0,B|0)|0;switch(x&511){case 0:{if(A){H=0;do{I=o+(f[m+(H*12|0)+4>>2]<<3)|0;p[I>>3]=+p[I>>3]+ +n[m+(H*12|0)+8>>2]*+p[G+(f[m+(H*12|0)>>2]<<3)>>3];H=H+1|0}while((H|0)!=(g|0))}break}case 1:{if(A){H=0;do{I=f[m+(H*12|0)>>2]|0;J=f[m+(H*12|0)+4>>2]|0;K=+n[m+(H*12|0)+8>>2];L=o+(J<<3)|0;M=o+(J+1<<3)|0;N=+p[M>>3]+K*+p[G+(I+1<<3)>>3];p[L>>3]=+p[L>>3]+K*+p[G+(I<<3)>>3];p[M>>3]=N;H=H+1|0}while((H|0)!=(g|0))}break}case 2:{if(A){H=0;do{M=f[m+(H*12|0)>>2]|0;I=f[m+(H*12|0)+4>>2]|0;N=+n[m+(H*12|0)+8>>2];L=o+(I<<3)|0;J=o+(I+1<<3)|0;K=+p[J>>3]+N*+p[G+(M+1<<3)>>3];O=o+(I+2<<3)|0;P=+p[O>>3]+N*+p[G+(M+2<<3)>>3];p[L>>3]=+p[L>>3]+N*+p[G+(M<<3)>>3];p[J>>3]=K;p[O>>3]=P;H=H+1|0}while((H|0)!=(g|0))}break}case 3:{if(A){H=0;do{O=f[m+(H*12|0)>>2]|0;J=f[m+(H*12|0)+4>>2]|0;P=+n[m+(H*12|0)+8>>2];M=o+(J<<3)|0;L=o+(J+1<<3)|0;K=+p[L>>3]+P*+p[G+(O+1<<3)>>3];p[M>>3]=+p[M>>3]+P*+p[G+(O<<3)>>3];p[L>>3]=K;L=o+(J+2<<3)|0;M=o+(J+3<<3)|0;K=+p[M>>3]+P*+p[G+(O+3<<3)>>3];p[L>>3]=+p[L>>3]+P*+p[G+(O+2<<3)>>3];p[M>>3]=K;H=H+1|0}while((H|0)!=(g|0))}break}default:if(A){H=0;do{M=f[m+(H*12|0)>>2]|0;O=f[m+(H*12|0)+4>>2]|0;K=+n[m+(H*12|0)+8>>2];L=0;do{J=o+(L+O<<3)|0;p[J>>3]=+p[J>>3]+K*+p[G+(L+M<<3)>>3];L=L+1|0}while((L|0)!=(i|0));H=H+1|0}while((H|0)!=(g|0))}}if((F|0)==(C|0))if(v){H=0;do{G=q+(H<<3)|0;p[G>>3]=+p[G>>3]+E*+p[o+(H<<3)>>3];H=H+1|0}while((H|0)!=(j|0));Q=C}else Q=C;else{H=f[e>>2]|0;G=(f[H+16>>2]|0)+(Y(f[f[H+44>>2]>>2]|0,C)|0)|0;if(v){H=0;do{L=q+(H<<3)|0;p[G+(H<<3)>>3]=+p[L>>3];p[L>>3]=E*+p[o+(H<<3)>>3];H=H+1|0}while((H|0)!=(j|0));Q=F}else Q=F}D=D+1|0;if((D|0)==(t|0)){R=Q;break a}else C=Q}}else R=r;while(0);r=f[e>>2]|0;e=(f[r+16>>2]|0)+(Y(f[f[r+44>>2]>>2]|0,R)|0)|0;if(v){v=0;do{p[e+(v<<3)>>3]=+p[q+(v<<3)>>3];v=v+1|0}while((v|0)!=(j|0))}j=f[d>>2]|0;if((j|0)==(k|0)){u=c;return}if(j|0)ZDc(j);f[d>>2]=k;f[l>>2]=136;u=c;return}function nda(a){a=a|0;YDc(a);return}function oda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;c=u;u=u+1072|0;d=c;e=a+8|0;g=f[e>>2]|0;h=(f[g>>2]|0)>>>3;i=(h&511)+1|0;j=Y(i,f[(f[g+40>>2]|0)+4>>2]|0)|0;g=j<<1;k=d+8|0;f[d>>2]=k;l=d+4|0;f[l>>2]=g;if(g>>>0>264){m=XDc(g>>>0>1073741823?-1:g<<2)|0;f[d>>2]=m;o=m}else o=k;m=f[a+12>>2]|0;g=f[a+20>>2]|0;p=o+(j<<2)|0;q=f[a+28>>2]|0;r=f[q+(f[b>>2]<<2)>>2]|0;s=f[q+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;q=f[(f[b>>2]|0)+(r*12|0)+4>>2]|0;t=(j|0)>0;if(t)XIc(p|0,0,j<<2|0)|0;a:do if((r|0)<(s|0)){v=f[b>>2]|0;w=f[a+4>>2]|0;x=f[w+16>>2]|0;y=f[f[w+44>>2]>>2]|0;w=h&65535;z=(g|0)>0;A=j<<2;B=q;C=r;while(1){D=+n[v+(C*12|0)+8>>2];E=f[v+(C*12|0)+4>>2]|0;F=x+(Y(y,f[v+(C*12|0)>>2]|0)|0)|0;if(t)XIc(o|0,0,A|0)|0;switch(w&511){case 0:{if(z){G=0;do{H=o+(f[m+(G*12|0)+4>>2]<<2)|0;n[H>>2]=+n[H>>2]+ +n[m+(G*12|0)+8>>2]*+n[F+(f[m+(G*12|0)>>2]<<2)>>2];G=G+1|0}while((G|0)!=(g|0))}break}case 1:{if(z){G=0;do{H=f[m+(G*12|0)>>2]|0;I=f[m+(G*12|0)+4>>2]|0;J=+n[m+(G*12|0)+8>>2];K=o+(I<<2)|0;L=o+(I+1<<2)|0;M=+n[L>>2]+J*+n[F+(H+1<<2)>>2];n[K>>2]=+n[K>>2]+J*+n[F+(H<<2)>>2];n[L>>2]=M;G=G+1|0}while((G|0)!=(g|0))}break}case 2:{if(z){G=0;do{L=f[m+(G*12|0)>>2]|0;H=f[m+(G*12|0)+4>>2]|0;M=+n[m+(G*12|0)+8>>2];K=o+(H<<2)|0;I=o+(H+1<<2)|0;J=+n[I>>2]+M*+n[F+(L+1<<2)>>2];N=o+(H+2<<2)|0;O=+n[N>>2]+M*+n[F+(L+2<<2)>>2];n[K>>2]=+n[K>>2]+M*+n[F+(L<<2)>>2];n[I>>2]=J;n[N>>2]=O;G=G+1|0}while((G|0)!=(g|0))}break}case 3:{if(z){G=0;do{N=f[m+(G*12|0)>>2]|0;I=f[m+(G*12|0)+4>>2]|0;O=+n[m+(G*12|0)+8>>2];L=o+(I<<2)|0;K=o+(I+1<<2)|0;J=+n[K>>2]+O*+n[F+(N+1<<2)>>2];n[L>>2]=+n[L>>2]+O*+n[F+(N<<2)>>2];n[K>>2]=J;K=o+(I+2<<2)|0;L=o+(I+3<<2)|0;J=+n[L>>2]+O*+n[F+(N+3<<2)>>2];n[K>>2]=+n[K>>2]+O*+n[F+(N+2<<2)>>2];n[L>>2]=J;G=G+1|0}while((G|0)!=(g|0))}break}default:if(z){G=0;do{L=f[m+(G*12|0)>>2]|0;N=f[m+(G*12|0)+4>>2]|0;J=+n[m+(G*12|0)+8>>2];K=0;do{I=o+(K+N<<2)|0;n[I>>2]=+n[I>>2]+J*+n[F+(K+L<<2)>>2];K=K+1|0}while((K|0)!=(i|0));G=G+1|0}while((G|0)!=(g|0))}}if((E|0)==(B|0))if(t){G=0;do{F=p+(G<<2)|0;n[F>>2]=+n[F>>2]+D*+n[o+(G<<2)>>2];G=G+1|0}while((G|0)!=(j|0));P=B}else P=B;else{G=f[e>>2]|0;F=(f[G+16>>2]|0)+(Y(f[f[G+44>>2]>>2]|0,B)|0)|0;if(t){G=0;do{K=p+(G<<2)|0;f[F+(G<<2)>>2]=f[K>>2];n[K>>2]=D*+n[o+(G<<2)>>2];G=G+1|0}while((G|0)!=(j|0));P=E}else P=E}C=C+1|0;if((C|0)==(s|0)){Q=P;break a}else B=P}}else Q=q;while(0);q=f[e>>2]|0;e=(f[q+16>>2]|0)+(Y(f[f[q+44>>2]>>2]|0,Q)|0)|0;if(t){t=0;do{f[e+(t<<2)>>2]=f[p+(t<<2)>>2];t=t+1|0}while((t|0)!=(j|0))}j=f[d>>2]|0;if((j|0)==(k|0)){u=c;return}if(j|0)ZDc(j);f[d>>2]=k;f[l>>2]=264;u=c;return}function pda(a){a=a|0;YDc(a);return}function qda(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;c=u;u=u+1072|0;e=c;g=a+8|0;h=f[g>>2]|0;i=(f[h>>2]|0)>>>3;j=(i&511)+1|0;k=Y(j,f[(f[h+40>>2]|0)+4>>2]|0)|0;h=k<<1;l=e+8|0;f[e>>2]=l;m=e+4|0;f[m>>2]=h;if(h>>>0>264){o=XDc(h>>>0>1073741823?-1:h<<2)|0;f[e>>2]=o;p=o}else p=l;o=f[a+12>>2]|0;h=f[a+20>>2]|0;q=p+(k<<2)|0;r=f[a+28>>2]|0;s=f[r+(f[b>>2]<<2)>>2]|0;t=f[r+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;r=f[(f[b>>2]|0)+(s*12|0)+4>>2]|0;v=(k|0)>0;if(v)XIc(q|0,0,k<<2|0)|0;a:do if((s|0)<(t|0)){w=f[b>>2]|0;x=f[a+4>>2]|0;y=f[x+16>>2]|0;z=f[f[x+44>>2]>>2]|0;x=i&65535;A=(h|0)>0;B=k<<2;C=s;D=r;while(1){E=+n[w+(C*12|0)+8>>2];F=f[w+(C*12|0)+4>>2]|0;G=y+(Y(z,f[w+(C*12|0)>>2]|0)|0)|0;if(v)XIc(p|0,0,B|0)|0;switch(x&511){case 0:{if(A){H=0;do{I=p+(f[o+(H*12|0)+4>>2]<<2)|0;n[I>>2]=+n[I>>2]+ +n[o+(H*12|0)+8>>2]*+(d[G+(f[o+(H*12|0)>>2]<<1)>>1]|0);H=H+1|0}while((H|0)!=(h|0))}break}case 1:{if(A){H=0;do{I=f[o+(H*12|0)>>2]|0;J=f[o+(H*12|0)+4>>2]|0;K=+n[o+(H*12|0)+8>>2];L=p+(J<<2)|0;M=p+(J+1<<2)|0;N=+n[M>>2]+K*+(d[G+(I+1<<1)>>1]|0);n[L>>2]=+n[L>>2]+K*+(d[G+(I<<1)>>1]|0);n[M>>2]=N;H=H+1|0}while((H|0)!=(h|0))}break}case 2:{if(A){H=0;do{M=f[o+(H*12|0)>>2]|0;I=f[o+(H*12|0)+4>>2]|0;N=+n[o+(H*12|0)+8>>2];L=p+(I<<2)|0;J=p+(I+1<<2)|0;K=+n[J>>2]+N*+(d[G+(M+1<<1)>>1]|0);O=p+(I+2<<2)|0;P=+n[O>>2]+N*+(d[G+(M+2<<1)>>1]|0);n[L>>2]=+n[L>>2]+N*+(d[G+(M<<1)>>1]|0);n[J>>2]=K;n[O>>2]=P;H=H+1|0}while((H|0)!=(h|0))}break}case 3:{if(A){H=0;do{O=f[o+(H*12|0)>>2]|0;J=f[o+(H*12|0)+4>>2]|0;P=+n[o+(H*12|0)+8>>2];M=p+(J<<2)|0;L=p+(J+1<<2)|0;K=+n[L>>2]+P*+(d[G+(O+1<<1)>>1]|0);n[M>>2]=+n[M>>2]+P*+(d[G+(O<<1)>>1]|0);n[L>>2]=K;L=p+(J+2<<2)|0;M=p+(J+3<<2)|0;K=+n[M>>2]+P*+(d[G+(O+3<<1)>>1]|0);n[L>>2]=+n[L>>2]+P*+(d[G+(O+2<<1)>>1]|0);n[M>>2]=K;H=H+1|0}while((H|0)!=(h|0))}break}default:if(A){H=0;do{M=f[o+(H*12|0)>>2]|0;O=f[o+(H*12|0)+4>>2]|0;K=+n[o+(H*12|0)+8>>2];L=0;do{J=p+(L+O<<2)|0;n[J>>2]=+n[J>>2]+K*+(d[G+(L+M<<1)>>1]|0);L=L+1|0}while((L|0)!=(j|0));H=H+1|0}while((H|0)!=(h|0))}}if((F|0)==(D|0))if(v){H=0;do{G=q+(H<<2)|0;n[G>>2]=+n[G>>2]+E*+n[p+(H<<2)>>2];H=H+1|0}while((H|0)!=(k|0));Q=D}else Q=D;else{H=f[g>>2]|0;G=(f[H+16>>2]|0)+(Y(f[f[H+44>>2]>>2]|0,D)|0)|0;if(v){H=0;do{L=q+(H<<2)|0;M=mrc(+n[L>>2])|0;d[G+(H<<1)>>1]=(M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768;n[L>>2]=E*+n[p+(H<<2)>>2];H=H+1|0}while((H|0)!=(k|0));Q=F}else Q=F}C=C+1|0;if((C|0)==(t|0)){R=Q;break a}else D=Q}}else R=r;while(0);r=f[g>>2]|0;g=(f[r+16>>2]|0)+(Y(f[f[r+44>>2]>>2]|0,R)|0)|0;if(v){v=0;do{R=mrc(+n[q+(v<<2)>>2])|0;d[g+(v<<1)>>1]=(R+32768|0)>>>0<65536?R:(R|0)>0?32767:32768;v=v+1|0}while((v|0)!=(k|0))}k=f[e>>2]|0;if((k|0)==(l|0)){u=c;return}if(k|0)ZDc(k);f[e>>2]=l;f[m>>2]=264;u=c;return}function rda(a){a=a|0;YDc(a);return}function sda(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0;c=u;u=u+1072|0;e=c;g=a+8|0;h=f[g>>2]|0;i=(f[h>>2]|0)>>>3;k=(i&511)+1|0;l=Y(k,f[(f[h+40>>2]|0)+4>>2]|0)|0;h=l<<1;m=e+8|0;f[e>>2]=m;o=e+4|0;f[o>>2]=h;if(h>>>0>264){p=XDc(h>>>0>1073741823?-1:h<<2)|0;f[e>>2]=p;q=p}else q=m;p=f[a+12>>2]|0;h=f[a+20>>2]|0;r=q+(l<<2)|0;s=f[a+28>>2]|0;t=f[s+(f[b>>2]<<2)>>2]|0;v=f[s+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;s=f[(f[b>>2]|0)+(t*12|0)+4>>2]|0;w=(l|0)>0;if(w)XIc(r|0,0,l<<2|0)|0;a:do if((t|0)<(v|0)){x=f[b>>2]|0;y=f[a+4>>2]|0;z=f[y+16>>2]|0;A=f[f[y+44>>2]>>2]|0;y=i&65535;B=(h|0)>0;C=l<<2;D=t;E=s;while(1){F=+n[x+(D*12|0)+8>>2];G=f[x+(D*12|0)+4>>2]|0;H=z+(Y(A,f[x+(D*12|0)>>2]|0)|0)|0;if(w)XIc(q|0,0,C|0)|0;switch(y&511){case 0:{if(B){I=0;do{J=q+(f[p+(I*12|0)+4>>2]<<2)|0;n[J>>2]=+n[J>>2]+ +n[p+(I*12|0)+8>>2]*+(j[H+(f[p+(I*12|0)>>2]<<1)>>1]|0);I=I+1|0}while((I|0)!=(h|0))}break}case 1:{if(B){I=0;do{J=f[p+(I*12|0)>>2]|0;K=f[p+(I*12|0)+4>>2]|0;L=+n[p+(I*12|0)+8>>2];M=q+(K<<2)|0;N=q+(K+1<<2)|0;O=+n[N>>2]+L*+(j[H+(J+1<<1)>>1]|0);n[M>>2]=+n[M>>2]+L*+(j[H+(J<<1)>>1]|0);n[N>>2]=O;I=I+1|0}while((I|0)!=(h|0))}break}case 2:{if(B){I=0;do{N=f[p+(I*12|0)>>2]|0;J=f[p+(I*12|0)+4>>2]|0;O=+n[p+(I*12|0)+8>>2];M=q+(J<<2)|0;K=q+(J+1<<2)|0;L=+n[K>>2]+O*+(j[H+(N+1<<1)>>1]|0);P=q+(J+2<<2)|0;Q=+n[P>>2]+O*+(j[H+(N+2<<1)>>1]|0);n[M>>2]=+n[M>>2]+O*+(j[H+(N<<1)>>1]|0);n[K>>2]=L;n[P>>2]=Q;I=I+1|0}while((I|0)!=(h|0))}break}case 3:{if(B){I=0;do{P=f[p+(I*12|0)>>2]|0;K=f[p+(I*12|0)+4>>2]|0;Q=+n[p+(I*12|0)+8>>2];N=q+(K<<2)|0;M=q+(K+1<<2)|0;L=+n[M>>2]+Q*+(j[H+(P+1<<1)>>1]|0);n[N>>2]=+n[N>>2]+Q*+(j[H+(P<<1)>>1]|0);n[M>>2]=L;M=q+(K+2<<2)|0;N=q+(K+3<<2)|0;L=+n[N>>2]+Q*+(j[H+(P+3<<1)>>1]|0);n[M>>2]=+n[M>>2]+Q*+(j[H+(P+2<<1)>>1]|0);n[N>>2]=L;I=I+1|0}while((I|0)!=(h|0))}break}default:if(B){I=0;do{N=f[p+(I*12|0)>>2]|0;P=f[p+(I*12|0)+4>>2]|0;L=+n[p+(I*12|0)+8>>2];M=0;do{K=q+(M+P<<2)|0;n[K>>2]=+n[K>>2]+L*+(j[H+(M+N<<1)>>1]|0);M=M+1|0}while((M|0)!=(k|0));I=I+1|0}while((I|0)!=(h|0))}}if((G|0)==(E|0))if(w){I=0;do{H=r+(I<<2)|0;n[H>>2]=+n[H>>2]+F*+n[q+(I<<2)>>2];I=I+1|0}while((I|0)!=(l|0));R=E}else R=E;else{I=f[g>>2]|0;H=(f[I+16>>2]|0)+(Y(f[f[I+44>>2]>>2]|0,E)|0)|0;if(w){I=0;do{M=r+(I<<2)|0;N=mrc(+n[M>>2])|0;d[H+(I<<1)>>1]=N>>>0<65536?N:(N|0)>0?65535:0;n[M>>2]=F*+n[q+(I<<2)>>2];I=I+1|0}while((I|0)!=(l|0));R=G}else R=G}D=D+1|0;if((D|0)==(v|0)){S=R;break a}else E=R}}else S=s;while(0);s=f[g>>2]|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,S)|0)|0;if(w){w=0;do{S=mrc(+n[r+(w<<2)>>2])|0;d[g+(w<<1)>>1]=S>>>0<65536?S:(S|0)>0?65535:0;w=w+1|0}while((w|0)!=(l|0))}l=f[e>>2]|0;if((l|0)==(m|0)){u=c;return}if(l|0)ZDc(l);f[e>>2]=m;f[o>>2]=264;u=c;return}function tda(a){a=a|0;YDc(a);return}function uda(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;d=u;u=u+1072|0;e=d;g=a+8|0;i=f[g>>2]|0;j=(f[i>>2]|0)>>>3;k=(j&511)+1|0;l=Y(k,f[(f[i+40>>2]|0)+4>>2]|0)|0;i=l<<1;m=e+8|0;f[e>>2]=m;o=e+4|0;f[o>>2]=i;if(i>>>0>264){p=XDc(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=p;q=p}else q=m;p=f[a+12>>2]|0;i=f[a+20>>2]|0;r=q+(l<<2)|0;s=f[a+28>>2]|0;t=f[s+(f[c>>2]<<2)>>2]|0;v=f[s+(f[c+4>>2]<<2)>>2]|0;c=a+16|0;s=f[(f[c>>2]|0)+(t*12|0)+4>>2]|0;w=(l|0)>0;if(w)XIc(r|0,0,l<<2|0)|0;a:do if((t|0)<(v|0)){x=a+4|0;y=j&65535;z=(i|0)>0;A=l<<2;B=s;C=t;while(1){D=f[c>>2]|0;E=+n[D+(C*12|0)+8>>2];F=f[D+(C*12|0)+4>>2]|0;G=f[x>>2]|0;H=(f[G+16>>2]|0)+(Y(f[f[G+44>>2]>>2]|0,f[D+(C*12|0)>>2]|0)|0)|0;if(w)XIc(q|0,0,A|0)|0;switch(y&511){case 0:{if(z){D=0;do{G=q+(f[p+(D*12|0)+4>>2]<<2)|0;n[G>>2]=+n[G>>2]+ +n[p+(D*12|0)+8>>2]*+(h[H+(f[p+(D*12|0)>>2]|0)>>0]|0);D=D+1|0}while((D|0)!=(i|0))}break}case 1:{if(z){D=0;do{G=f[p+(D*12|0)>>2]|0;I=f[p+(D*12|0)+4>>2]|0;J=+n[p+(D*12|0)+8>>2];K=q+(I<<2)|0;L=q+(I+1<<2)|0;M=+n[L>>2]+J*+(h[H+(G+1)>>0]|0);n[K>>2]=+n[K>>2]+J*+(h[H+G>>0]|0);n[L>>2]=M;D=D+1|0}while((D|0)!=(i|0))}break}case 2:{if(z){D=0;do{L=f[p+(D*12|0)>>2]|0;G=f[p+(D*12|0)+4>>2]|0;M=+n[p+(D*12|0)+8>>2];K=q+(G<<2)|0;I=q+(G+1<<2)|0;J=+n[I>>2]+M*+(h[H+(L+1)>>0]|0);N=q+(G+2<<2)|0;O=+n[N>>2]+M*+(h[H+(L+2)>>0]|0);n[K>>2]=+n[K>>2]+M*+(h[H+L>>0]|0);n[I>>2]=J;n[N>>2]=O;D=D+1|0}while((D|0)!=(i|0))}break}case 3:{if(z){D=0;do{N=f[p+(D*12|0)>>2]|0;I=f[p+(D*12|0)+4>>2]|0;O=+n[p+(D*12|0)+8>>2];L=q+(I<<2)|0;K=q+(I+1<<2)|0;J=+n[K>>2]+O*+(h[H+(N+1)>>0]|0);n[L>>2]=+n[L>>2]+O*+(h[H+N>>0]|0);n[K>>2]=J;K=q+(I+2<<2)|0;L=q+(I+3<<2)|0;J=+n[L>>2]+O*+(h[H+(N+3)>>0]|0);n[K>>2]=+n[K>>2]+O*+(h[H+(N+2)>>0]|0);n[L>>2]=J;D=D+1|0}while((D|0)!=(i|0))}break}default:if(z){D=0;do{L=f[p+(D*12|0)>>2]|0;N=f[p+(D*12|0)+4>>2]|0;J=+n[p+(D*12|0)+8>>2];K=0;do{I=q+(K+N<<2)|0;n[I>>2]=+n[I>>2]+J*+(h[H+(K+L)>>0]|0);K=K+1|0}while((K|0)!=(k|0));D=D+1|0}while((D|0)!=(i|0))}}if((F|0)==(B|0))if(w){D=0;do{H=r+(D<<2)|0;n[H>>2]=+n[H>>2]+E*+n[q+(D<<2)>>2];D=D+1|0}while((D|0)!=(l|0));P=B}else P=B;else{D=f[g>>2]|0;H=(f[D+16>>2]|0)+(Y(f[f[D+44>>2]>>2]|0,B)|0)|0;if(w){D=0;do{K=r+(D<<2)|0;L=mrc(+n[K>>2])|0;b[H+D>>0]=L>>>0<256?L:(L|0)>0?255:0;n[K>>2]=E*+n[q+(D<<2)>>2];D=D+1|0}while((D|0)!=(l|0));P=F}else P=F}C=C+1|0;if((C|0)==(v|0)){Q=P;break a}else B=P}}else Q=s;while(0);s=f[g>>2]|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,Q)|0)|0;if(w){w=0;do{Q=mrc(+n[r+(w<<2)>>2])|0;b[g+w>>0]=Q>>>0<256?Q:(Q|0)>0?255:0;w=w+1|0}while((w|0)!=(l|0))}l=f[e>>2]|0;if((l|0)==(m|0)){u=d;return}if(l|0)ZDc(l);f[e>>2]=m;f[o>>2]=264;u=d;return}function vda(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Sda(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}y8(i,j,+(m>>>0)*.0000152587890625);Tda(j);u=h;return}function wda(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Nda(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}y8(i,j,+(m>>>0)*.0000152587890625);Oda(j);u=h;return}function xda(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Ida(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}y8(i,j,+(m>>>0)*.0000152587890625);Jda(j);u=h;return}function yda(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Eda(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}y8(i,j,+(m>>>0)*.0000152587890625);Fda(j);u=h;return}function zda(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Ada(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}y8(i,j,+(m>>>0)*.0000152587890625);Bda(j);u=h;return}function Ada(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=47592;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;ZS(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;ZS(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Bda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47592;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Cda(a){a=a|0;Bda(a);YDc(a);return}function Dda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0;c=f[a+44>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;c=((f[a+4>>2]|0)>>>3&511)+1|0;g=a+116|0;h=f[g>>2]|0;i=a+120|0;j=f[i>>2]|0;k=Y(j,h)|0;l=Y((d|0)/(h|0)|0,c)|0;h=Y(c,f[(f[a+100>>2]|0)+4>>2]|0)|0;m=Y(c,d)|0;d=f[b>>2]|0;n=f[b+4>>2]|0;if((d|0)>=(n|0))return;b=f[a+76>>2]|0;o=f[a+108>>2]|0;q=a+20|0;r=a+48|0;s=a+128|0;t=k+-4|0;u=(k|0)<4;v=1.0/+(k|0);w=a+124|0;a=(h|0)>0;x=h<<3;y=k&-4;z=(y|0)<(k|0);A=(k|0)>0;B=d;D=0;while(1){E=b+(Y(o,d+D|0)|0)|0;F=b+(Y(o,B)|0)|0;G=Y(j,B)|0;H=(G+j|0)<=(e|0)?l:0;a:do if((G|0)<(e|0)){b:do if((H|0)>0){I=(f[q>>2]|0)+(Y(f[f[r>>2]>>2]|0,G)|0)|0;J=f[s>>2]|0;if(u){K=0;while(1){L=I+(f[J+(K<<2)>>2]<<3)|0;if(A){M=f[w>>2]|0;N=0.0;O=0;while(1){P=N+ +p[L+(f[M+(O<<2)>>2]<<3)>>3];O=O+1|0;if((O|0)==(k|0)){Q=P;break}else N=P}}else Q=0.0;p[F+(K<<3)>>3]=v*Q;K=K+1|0;if((K|0)==(H|0)){R=H;break b}}}K=f[w>>2]|0;O=0;do{M=I+(f[J+(O<<2)>>2]<<3)|0;N=0.0;L=0;do{N=N+(+p[M+(f[K+(L<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|1)<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|2)<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|3)<<2)>>2]<<3)>>3]);L=L+4|0}while((L|0)<=(t|0));if(z){P=N;L=y;while(1){S=P+ +p[M+(f[K+(L<<2)>>2]<<3)>>3];L=L+1|0;if((L|0)==(k|0)){T=S;break}else P=S}}else T=N;p[F+(O<<3)>>3]=v*T;O=O+1|0}while((O|0)!=(H|0));R=H}else R=0;while(0);if((R|0)<(h|0)){O=f[s>>2]|0;K=f[i>>2]|0;if((K|0)>0)U=R;else{J=R;while(1){I=F+(J<<3)|0;if((f[O+(J<<2)>>2]|0)>=(m|0))p[I>>3]=0.0;p[I>>3]=C;J=J+1|0;if((J|0)==(h|0))break a}}do{J=f[O+(U<<2)>>2]|0;c:do if((J|0)<(m|0)){I=0;L=0;P=0.0;while(1){M=I+G|0;if((M|0)>=(e|0)){V=L;W=P;break c}X=(f[q>>2]|0)+(Y(f[f[r>>2]>>2]|0,M)|0)+(J<<3)|0;M=Y(f[g>>2]|0,c)|0;if((M|0)>0){Z=0;_=L;S=P;while(1){$=S+ +p[X+(Z<<3)>>3];aa=_+1|0;Z=Z+c|0;if(!((Z+J|0)<(m|0)&(Z|0)<(M|0))){ba=aa;ca=$;break}else{_=aa;S=$}}}else{ba=L;ca=P}I=I+1|0;if((I|0)>=(K|0)){V=ba;W=ca;break}else{L=ba;P=ca}}}else{p[F+(U<<3)>>3]=0.0;V=0;W=0.0}while(0);p[F+(U<<3)>>3]=W/+(V|0);U=U+1|0}while((U|0)!=(h|0))}}else if(a)XIc(E|0,0,x|0)|0;while(0);B=B+1|0;if((B|0)>=(n|0))break;else D=D+1|0}return}function Eda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=47612;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;ZS(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;ZS(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Fda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47612;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Gda(a){a=a|0;Fda(a);YDc(a);return}function Hda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0;c=f[a+44>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;c=((f[a+4>>2]|0)>>>3&511)+1|0;g=a+116|0;h=f[g>>2]|0;i=a+120|0;j=f[i>>2]|0;k=Y(j,h)|0;l=1.0/+(k|0);m=Y((d|0)/(h|0)|0,c)|0;h=Y(c,f[(f[a+100>>2]|0)+4>>2]|0)|0;o=Y(c,d)|0;d=f[b>>2]|0;p=f[b+4>>2]|0;if((d|0)>=(p|0))return;b=f[a+76>>2]|0;q=f[a+108>>2]|0;r=a+20|0;s=a+48|0;t=a+128|0;u=k+-4|0;v=(k|0)<4;w=a+124|0;a=(h|0)>0;x=h<<2;y=k&-4;z=(y|0)<(k|0);A=(k|0)>0;B=d;D=0;while(1){E=b+(Y(q,d+D|0)|0)|0;F=b+(Y(q,B)|0)|0;G=Y(j,B)|0;H=(G+j|0)<=(e|0)?m:0;a:do if((G|0)<(e|0)){b:do if((H|0)>0){I=(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,G)|0)|0;J=f[t>>2]|0;if(v){K=0;while(1){L=I+(f[J+(K<<2)>>2]<<2)|0;if(A){M=f[w>>2]|0;N=0.0;O=0;while(1){P=N+ +n[L+(f[M+(O<<2)>>2]<<2)>>2];O=O+1|0;if((O|0)==(k|0)){Q=P;break}else N=P}}else Q=0.0;n[F+(K<<2)>>2]=l*Q;K=K+1|0;if((K|0)==(H|0)){R=H;break b}}}K=f[w>>2]|0;O=0;do{M=I+(f[J+(O<<2)>>2]<<2)|0;N=0.0;L=0;do{N=N+(+n[M+(f[K+(L<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|1)<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|2)<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|3)<<2)>>2]<<2)>>2]);L=L+4|0}while((L|0)<=(u|0));if(z){P=N;L=y;while(1){S=P+ +n[M+(f[K+(L<<2)>>2]<<2)>>2];L=L+1|0;if((L|0)==(k|0)){T=S;break}else P=S}}else T=N;n[F+(O<<2)>>2]=l*T;O=O+1|0}while((O|0)!=(H|0));R=H}else R=0;while(0);if((R|0)<(h|0)){O=f[t>>2]|0;K=f[i>>2]|0;if((K|0)>0)U=R;else{J=R;while(1){I=F+(J<<2)|0;if((f[O+(J<<2)>>2]|0)>=(o|0))n[I>>2]=0.0;n[I>>2]=C;J=J+1|0;if((J|0)==(h|0))break a}}do{J=f[O+(U<<2)>>2]|0;c:do if((J|0)<(o|0)){I=0;L=0;P=0.0;while(1){M=I+G|0;if((M|0)>=(e|0)){V=L;W=P;break c}X=(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,M)|0)+(J<<2)|0;M=Y(f[g>>2]|0,c)|0;if((M|0)>0){Z=0;_=L;S=P;while(1){$=S+ +n[X+(Z<<2)>>2];aa=_+1|0;Z=Z+c|0;if(!((Z+J|0)<(o|0)&(Z|0)<(M|0))){ba=aa;ca=$;break}else{_=aa;S=$}}}else{ba=L;ca=P}I=I+1|0;if((I|0)>=(K|0)){V=ba;W=ca;break}else{L=ba;P=ca}}}else{n[F+(U<<2)>>2]=0.0;V=0;W=0.0}while(0);n[F+(U<<2)>>2]=W/+(V|0);U=U+1|0}while((U|0)!=(h|0))}}else if(a)XIc(E|0,0,x|0)|0;while(0);B=B+1|0;if((B|0)>=(p|0))break;else D=D+1|0}return}function Ida(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=47632;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;ZS(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;ZS(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Jda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47632;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Kda(a){a=a|0;Jda(a);YDc(a);return}function Lda(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0,X=0,Z=0.0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0.0;e=u;u=u+32|0;g=e;h=f[a+44>>2]|0;i=f[h+4>>2]|0;j=f[h>>2]|0;h=(f[a+4>>2]|0)>>>3;k=(h&511)+1|0;l=a+116|0;m=f[l>>2]|0;n=a+120|0;o=f[n>>2]|0;p=Y(o,m)|0;q=1.0/+(p|0);r=Y((i|0)/(m|0)|0,k)|0;s=Y(k,f[(f[a+100>>2]|0)+4>>2]|0)|0;t=Y(k,i)|0;i=f[a+52>>2]|0;f[g>>2]=m;f[g+4>>2]=o;f[g+8>>2]=k;f[g+16>>2]=i;a:do if((m|0)==2&(o|0)==2){switch(h&511){case 2:case 0:{v=1;break a;break}default:{}}v=(k|0)==4&1}else v=0;while(0);b[g+12>>0]=v;v=f[c>>2]|0;h=c+4|0;if((v|0)>=(f[h>>2]|0)){u=e;return}c=a+76|0;m=a+108|0;i=a+20|0;w=a+48|0;x=a+128|0;y=p+-4|0;z=(p|0)<4;A=a+124|0;a=(s|0)>0;B=s<<1;D=p&-4;E=(D|0)<(p|0);F=(p|0)>0;G=v;v=o;while(1){o=(f[c>>2]|0)+(Y(f[m>>2]|0,G)|0)|0;H=Y(v,G)|0;I=(H+v|0)<=(j|0)?r:0;b:do if((H|0)<(j|0)){J=Mda(g,(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,H)|0)|0,o,I)|0;c:do if((J|0)<(I|0)){K=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,H)|0)|0;L=f[x>>2]|0;if(z){M=J;while(1){N=K+(f[L+(M<<2)>>2]<<1)|0;if(F){O=f[A>>2]|0;P=0.0;Q=0;while(1){R=P+ +(d[N+(f[O+(Q<<2)>>2]<<1)>>1]|0);Q=Q+1|0;if((Q|0)==(p|0)){S=R;break}else P=R}}else S=0.0;Q=mrc(q*S)|0;d[o+(M<<1)>>1]=(Q+32768|0)>>>0<65536?Q:(Q|0)>0?32767:32768;M=M+1|0;if((M|0)==(I|0)){T=I;break c}}}M=f[A>>2]|0;Q=J;do{O=K+(f[L+(Q<<2)>>2]<<1)|0;P=0.0;N=0;do{P=P+ +((d[O+(f[M+((N|1)<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+(N<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+((N|2)<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+((N|3)<<2)>>2]<<1)>>1]|0)|0);N=N+4|0}while((N|0)<=(y|0));if(E){R=P;N=D;while(1){U=R+ +(d[O+(f[M+(N<<2)>>2]<<1)>>1]|0);N=N+1|0;if((N|0)==(p|0)){V=U;break}else R=U}}else V=P;N=mrc(q*V)|0;d[o+(Q<<1)>>1]=(N+32768|0)>>>0<65536?N:(N|0)>0?32767:32768;Q=Q+1|0}while((Q|0)!=(I|0));T=I}else T=J;while(0);if((T|0)<(s|0)){J=f[x>>2]|0;Q=f[n>>2]|0;if((Q|0)>0)W=T;else{M=mrc(C)|0;L=((M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768)&65535;M=T;while(1){K=o+(M<<1)|0;if((f[J+(M<<2)>>2]|0)>=(t|0))d[K>>1]=0;d[K>>1]=L;M=M+1|0;if((M|0)==(s|0))break b}}do{M=f[J+(W<<2)>>2]|0;d:do if((M|0)<(t|0)){L=0;K=0;R=0.0;while(1){N=L+H|0;if((N|0)>=(j|0)){X=K;Z=R;break d}O=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,N)|0)+(M<<1)|0;N=Y(f[l>>2]|0,k)|0;if((N|0)>0){_=0;$=K;U=R;while(1){aa=U+ +(d[O+(_<<1)>>1]|0);ba=$+1|0;_=_+k|0;if(!((_+M|0)<(t|0)&(_|0)<(N|0))){ca=ba;da=aa;break}else{$=ba;U=aa}}}else{ca=K;da=R}L=L+1|0;if((L|0)>=(Q|0)){X=ca;Z=da;break}else{K=ca;R=da}}}else{d[o+(W<<1)>>1]=0;X=0;Z=0.0}while(0);M=mrc(Z/+(X|0))|0;d[o+(W<<1)>>1]=(M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768;W=W+1|0}while((W|0)!=(s|0))}}else if(a)XIc(o|0,0,B|0)|0;while(0);o=G+1|0;if((o|0)>=(f[h>>2]|0))break;G=o;v=f[n>>2]|0}u=e;return}function Mda(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(!(b[a+12>>0]|0)){j=0;u=h;return j|0}k=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((g|0)>0)l=0;else{j=0;u=h;return j|0}do{a=l<<1;m=a|1;d[e+(l<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;l=l+1|0}while((l|0)!=(g|0));j=g;u=h;return j|0}case 3:{if((g|0)>0)n=0;else{j=0;u=h;return j|0}while(1){l=n<<1;m=l+3|0;d[e+(n<<1)>>1]=((d[c+(l<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(l<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=l|1;a=l+4|0;d[e+(n+1<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)|0)>>>2;a=l+2|0;m=l+5|0;d[e+(n+2<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=n+3|0;if((m|0)<(g|0))n=m;else{j=m;break}}u=h;return j|0}case 4:{if((g|0)>0)o=0;else{j=0;u=h;return j|0}do{n=o<<1;m=n|4;d[e+(o<<1)>>1]=((d[c+(n<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=n|1;a=n|5;d[e+((o|1)<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)|0)>>>2;a=n|2;m=n|6;d[e+((o|2)<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=n|3;a=n|7;d[e+((o|3)<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)|0)>>>2;o=o+4|0}while((o|0)<(g|0));j=g+3&-4;u=h;return j|0}default:{f[i>>2]=0;f[i+4>>2]=0;j=tT(i,7)|0;b[j>>0]=b[253373]|0;b[j+1>>0]=b[253374]|0;b[j+2>>0]=b[253375]|0;b[j+3>>0]=b[253376]|0;b[j+4>>0]=b[253377]|0;b[j+5>>0]=b[253378]|0;b[j+6>>0]=b[253379]|0;z5(-215,i,518189,251130,2630)}}return 0}function Nda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=47652;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;ZS(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;ZS(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Oda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47652;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Pda(a){a=a|0;Oda(a);YDc(a);return}function Qda(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0,Z=0,_=0.0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0;e=u;u=u+32|0;g=e;h=f[a+44>>2]|0;i=f[h+4>>2]|0;k=f[h>>2]|0;h=(f[a+4>>2]|0)>>>3;l=(h&511)+1|0;m=a+116|0;n=f[m>>2]|0;o=a+120|0;p=f[o>>2]|0;q=Y(p,n)|0;r=1.0/+(q|0);s=Y((i|0)/(n|0)|0,l)|0;t=Y(l,f[(f[a+100>>2]|0)+4>>2]|0)|0;v=Y(l,i)|0;i=f[a+52>>2]|0;f[g>>2]=n;f[g+4>>2]=p;f[g+8>>2]=l;f[g+16>>2]=i;a:do if((n|0)==2&(p|0)==2){switch(h&511){case 2:case 0:{w=1;break a;break}default:{}}w=(l|0)==4&1}else w=0;while(0);b[g+12>>0]=w;w=f[c>>2]|0;h=c+4|0;if((w|0)>=(f[h>>2]|0)){u=e;return}c=a+76|0;n=a+108|0;i=a+20|0;x=a+48|0;y=a+128|0;z=q+-4|0;A=(q|0)<4;B=a+124|0;a=(t|0)>0;D=t<<1;E=q&-4;F=(E|0)<(q|0);G=(q|0)>0;H=w;w=p;while(1){p=(f[c>>2]|0)+(Y(f[n>>2]|0,H)|0)|0;I=Y(w,H)|0;J=(I+w|0)<=(k|0)?s:0;b:do if((I|0)<(k|0)){K=Rda(g,(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,I)|0)|0,p,J)|0;c:do if((K|0)<(J|0)){L=(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,I)|0)|0;M=f[y>>2]|0;if(A){N=K;while(1){O=L+(f[M+(N<<2)>>2]<<1)|0;if(G){P=f[B>>2]|0;Q=0.0;R=0;while(1){S=Q+ +(j[O+(f[P+(R<<2)>>2]<<1)>>1]|0);R=R+1|0;if((R|0)==(q|0)){T=S;break}else Q=S}}else T=0.0;R=mrc(r*T)|0;d[p+(N<<1)>>1]=R>>>0<65536?R:(R|0)>0?65535:0;N=N+1|0;if((N|0)==(J|0)){U=J;break c}}}N=f[B>>2]|0;R=K;do{P=L+(f[M+(R<<2)>>2]<<1)|0;Q=0.0;O=0;do{Q=Q+ +((j[P+(f[N+((O|1)<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+(O<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+((O|2)<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+((O|3)<<2)>>2]<<1)>>1]|0)|0);O=O+4|0}while((O|0)<=(z|0));if(F){S=Q;O=E;while(1){V=S+ +(j[P+(f[N+(O<<2)>>2]<<1)>>1]|0);O=O+1|0;if((O|0)==(q|0)){W=V;break}else S=V}}else W=Q;O=mrc(r*W)|0;d[p+(R<<1)>>1]=O>>>0<65536?O:(O|0)>0?65535:0;R=R+1|0}while((R|0)!=(J|0));U=J}else U=K;while(0);if((U|0)<(t|0)){K=f[y>>2]|0;R=f[o>>2]|0;if((R|0)>0)X=U;else{N=mrc(C)|0;M=(N>>>0<65536?N:(N|0)>0?65535:0)&65535;N=U;while(1){L=p+(N<<1)|0;if((f[K+(N<<2)>>2]|0)>=(v|0))d[L>>1]=0;d[L>>1]=M;N=N+1|0;if((N|0)==(t|0))break b}}do{N=f[K+(X<<2)>>2]|0;d:do if((N|0)<(v|0)){M=0;L=0;S=0.0;while(1){O=M+I|0;if((O|0)>=(k|0)){Z=L;_=S;break d}P=(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,O)|0)+(N<<1)|0;O=Y(f[m>>2]|0,l)|0;if((O|0)>0){$=0;aa=L;V=S;while(1){ba=V+ +(j[P+($<<1)>>1]|0);ca=aa+1|0;$=$+l|0;if(!(($+N|0)<(v|0)&($|0)<(O|0))){da=ca;ea=ba;break}else{aa=ca;V=ba}}}else{da=L;ea=S}M=M+1|0;if((M|0)>=(R|0)){Z=da;_=ea;break}else{L=da;S=ea}}}else{d[p+(X<<1)>>1]=0;Z=0;_=0.0}while(0);N=mrc(_/+(Z|0))|0;d[p+(X<<1)>>1]=N>>>0<65536?N:(N|0)>0?65535:0;X=X+1|0}while((X|0)!=(t|0))}}else if(a)XIc(p|0,0,D|0)|0;while(0);p=H+1|0;if((p|0)>=(f[h>>2]|0))break;H=p;w=f[o>>2]|0}u=e;return}function Rda(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+16|0;i=h;if(!(b[a+12>>0]|0)){k=0;u=h;return k|0}l=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((g|0)>0)m=0;else{k=0;u=h;return k|0}do{a=m<<1;n=a|1;d[e+(m<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;m=m+1|0}while((m|0)!=(g|0));k=g;u=h;return k|0}case 3:{if((g|0)>0)o=0;else{k=0;u=h;return k|0}while(1){m=o<<1;n=m+3|0;d[e+(o<<1)>>1]=((j[c+(m<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(m<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=m|1;a=m+4|0;d[e+(o+1<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)|0)>>>2;a=m+2|0;n=m+5|0;d[e+(o+2<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=o+3|0;if((n|0)<(g|0))o=n;else{k=n;break}}u=h;return k|0}case 4:{if((g|0)>0)p=0;else{k=0;u=h;return k|0}do{o=p<<1;n=o|4;d[e+(p<<1)>>1]=((j[c+(o<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=o|1;a=o|5;d[e+((p|1)<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)|0)>>>2;a=o|2;n=o|6;d[e+((p|2)<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=o|3;a=o|7;d[e+((p|3)<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)|0)>>>2;p=p+4|0}while((p|0)<(g|0));k=g+3&-4;u=h;return k|0}default:{f[i>>2]=0;f[i+4>>2]=0;k=tT(i,7)|0;b[k>>0]=b[253373]|0;b[k+1>>0]=b[253374]|0;b[k+2>>0]=b[253375]|0;b[k+3>>0]=b[253376]|0;b[k+4>>0]=b[253377]|0;b[k+5>>0]=b[253378]|0;b[k+6>>0]=b[253379]|0;z5(-215,i,518189,251130,2630)}}return 0}function Sda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=47672;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;ZS(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;ZS(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Tda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=47672;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))g0(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)_S(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;g0(b);return}function Uda(a){a=a|0;Tda(a);YDc(a);return}function Vda(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+32|0;e=d;g=f[a+44>>2]|0;i=f[g+4>>2]|0;j=f[g>>2]|0;g=(f[a+4>>2]|0)>>>3;k=(g&511)+1|0;l=a+116|0;m=f[l>>2]|0;n=a+120|0;o=f[n>>2]|0;p=Y(o,m)|0;q=1.0/+(p|0);r=Y((i|0)/(m|0)|0,k)|0;s=Y(k,f[(f[a+100>>2]|0)+4>>2]|0)|0;t=Y(k,i)|0;i=f[a+52>>2]|0;f[e>>2]=m;f[e+4>>2]=o;f[e+8>>2]=k;f[e+16>>2]=i;a:do if((m|0)==2&(o|0)==2){switch(g&511){case 2:case 0:{v=1;break a;break}default:{}}v=(k|0)==4&1}else v=0;while(0);b[e+12>>0]=v;v=f[c>>2]|0;g=c+4|0;if((v|0)>=(f[g>>2]|0)){u=d;return}c=a+76|0;m=a+108|0;i=a+20|0;w=a+48|0;x=a+128|0;y=p+-4|0;z=(p|0)<4;A=a+124|0;a=(s|0)>0;B=p&-4;C=(p|0)>0;D=(B|0)<(p|0);E=v;v=o;while(1){o=(f[c>>2]|0)+(Y(f[m>>2]|0,E)|0)|0;F=Y(v,E)|0;G=(F+v|0)<=(j|0)?r:0;if((F|0)<(j|0)){H=Wda(e,(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0,o,G)|0;b:do if((H|0)<(G|0)){if(z){I=H;while(1){J=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0;K=J+(f[(f[x>>2]|0)+(I<<2)>>2]|0)|0;if(C){J=f[A>>2]|0;L=0;M=0;while(1){N=(h[K+(f[J+(M<<2)>>2]|0)>>0]|0)+L|0;M=M+1|0;if((M|0)==(p|0)){O=N;break}else L=N}}else O=0;L=mrc(q*+(O|0))|0;b[o+I>>0]=L>>>0<256?L:(L|0)>0?255:0;I=I+1|0;if((I|0)==(G|0)){P=G;break b}}}else Q=H;do{I=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0;L=I+(f[(f[x>>2]|0)+(Q<<2)>>2]|0)|0;I=f[A>>2]|0;M=0;J=0;do{M=(h[L+(f[I+(J<<2)>>2]|0)>>0]|0)+M+(h[L+(f[I+((J|1)<<2)>>2]|0)>>0]|0)+(h[L+(f[I+((J|2)<<2)>>2]|0)>>0]|0)+(h[L+(f[I+((J|3)<<2)>>2]|0)>>0]|0)|0;J=J+4|0}while((J|0)<=(y|0));if(D){J=M;K=B;while(1){N=(h[L+(f[I+(K<<2)>>2]|0)>>0]|0)+J|0;K=K+1|0;if((K|0)==(p|0)){R=N;break}else J=N}}else R=M;J=mrc(q*+(R|0))|0;b[o+Q>>0]=J>>>0<256?J:(J|0)>0?255:0;Q=Q+1|0}while((Q|0)!=(G|0));P=G}else P=H;while(0);if((P|0)<(s|0)){H=P;do{G=f[(f[x>>2]|0)+(H<<2)>>2]|0;J=(G|0)<(t|0);if(!J)b[o+H>>0]=0;K=f[n>>2]|0;c:do if((K|0)<1|J^1){S=0;T=0}else{I=0;L=0;N=0;while(1){U=I+F|0;if((U|0)>=(j|0)){S=L;T=N;break c}V=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,U)|0)+G|0;U=Y(f[l>>2]|0,k)|0;if((U|0)>0){W=0;X=L;Z=N;while(1){_=(h[V+W>>0]|0)+Z|0;$=X+1|0;W=W+k|0;if(!((W+G|0)<(t|0)&(W|0)<(U|0))){aa=$;ba=_;break}else{X=$;Z=_}}}else{aa=L;ba=N}I=I+1|0;if((I|0)>=(K|0)){S=aa;T=ba;break}else{L=aa;N=ba}}}while(0);K=mrc(+(T|0)/+(S|0))|0;b[o+H>>0]=K>>>0<256?K:(K|0)>0?255:0;H=H+1|0}while((H|0)!=(s|0))}}else if(a)XIc(o|0,0,s|0)|0;H=E+1|0;if((H|0)>=(f[g>>2]|0))break;E=H;v=f[n>>2]|0}u=d;return}function Wda(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;i=g;if(!(b[a+12>>0]|0)){j=0;u=g;return j|0}k=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((e|0)>0)l=0;else{j=0;u=g;return j|0}do{a=l<<1;m=a|1;b[d+l>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;l=l+1|0}while((l|0)!=(e|0));j=e;u=g;return j|0}case 3:{if((e|0)>0)n=0;else{j=0;u=g;return j|0}while(1){l=n<<1;m=l+3|0;b[d+n>>0]=((h[c+l>>0]|0)+2+(h[c+m>>0]|0)+(h[k+l>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=l|1;a=l+4|0;b[d+(n+1)>>0]=((h[c+m>>0]|0)+2+(h[c+a>>0]|0)+(h[k+m>>0]|0)+(h[k+a>>0]|0)|0)>>>2;a=l+2|0;m=l+5|0;b[d+(n+2)>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=n+3|0;if((m|0)<(e|0))n=m;else{j=m;break}}u=g;return j|0}case 4:{if((e|0)>0)o=0;else{j=0;u=g;return j|0}do{n=o<<1;m=n|4;b[d+o>>0]=((h[c+n>>0]|0)+2+(h[c+m>>0]|0)+(h[k+n>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=n|1;a=n|5;b[d+(o|1)>>0]=((h[c+m>>0]|0)+2+(h[c+a>>0]|0)+(h[k+m>>0]|0)+(h[k+a>>0]|0)|0)>>>2;a=n|2;m=n|6;b[d+(o|2)>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=n|3;a=n|7;b[d+(o|3)>>0]=((h[c+m>>0]|0)+2+(h[c+a>>0]|0)+(h[k+m>>0]|0)+(h[k+a>>0]|0)|0)>>>2;o=o+4|0}while((o|0)<(e|0));j=e+3&-4;u=g;return j|0}default:{f[i>>2]=0;f[i+4>>2]=0;j=tT(i,7)|0;b[j>>0]=b[253373]|0;b[j+1>>0]=b[253374]|0;b[j+2>>0]=b[253375]|0;b[j+3>>0]=b[253376]|0;b[j+4>>0]=b[253377]|0;b[j+5>>0]=b[253378]|0;b[j+6>>0]=b[253379]|0;z5(-215,i,518189,251130,2630)}}return 0}function Xda(a){a=a|0;lba(a);YDc(a);return}function Yda(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=f[(f[a+100>>2]|0)+4>>2]|0;g=f[a+8>>2]|0;if((g|0)>0)h=f[(f[a+48>>2]|0)+(g+-1<<2)>>2]|0;else h=0;g=f[c>>2]|0;i=c+4|0;if((g|0)>=(f[i>>2]|0))return;c=a+76|0;j=a+108|0;k=a+128|0;l=(f[f[a+44>>2]>>2]|0)+-1|0;m=a+20|0;n=a+48|0;o=(e|0)>0;q=a+116|0;r=a+120|0;a=e+-2|0;s=(e|0)<2;t=e&-2;u=g;do{g=(f[c>>2]|0)+(Y(f[j>>2]|0,u)|0)|0;v=+(u|0)*+p[k>>3];w=~~v;x=w-(+(w|0)>v&1)|0;w=(f[m>>2]|0)+(Y((l|0)<(x|0)?l:x,f[f[n>>2]>>2]|0)|0)|0;switch(h|0){case 1:{if(s)y=0;else{x=0;do{z=f[q>>2]|0;A=x|1;B=b[w+(f[z+(A<<2)>>2]|0)>>0]|0;b[g+x>>0]=b[w+(f[z+(x<<2)>>2]|0)>>0]|0;b[g+A>>0]=B;x=x+2|0}while((x|0)<=(a|0));y=t}if((y|0)<(e|0)){x=y;do{b[g+x>>0]=b[w+(f[(f[q>>2]|0)+(x<<2)>>2]|0)>>0]|0;x=x+1|0}while((x|0)!=(e|0))}break}case 2:{if(o){x=f[q>>2]|0;B=0;do{d[g+(B<<1)>>1]=d[w+(f[x+(B<<2)>>2]|0)>>1]|0;B=B+1|0}while((B|0)!=(e|0))}break}case 3:{if(o){B=g;x=0;while(1){A=w+(f[(f[q>>2]|0)+(x<<2)>>2]|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;x=x+1|0;if((x|0)==(e|0))break;else B=B+3|0}}break}case 4:{if(o){B=f[q>>2]|0;x=0;do{f[g+(x<<2)>>2]=f[w+(f[B+(x<<2)>>2]|0)>>2];x=x+1|0}while((x|0)!=(e|0))}break}case 6:{if(o){x=f[q>>2]|0;B=g;A=0;while(1){z=w+(f[x+(A<<2)>>2]|0)|0;d[B>>1]=d[z>>1]|0;d[B+2>>1]=d[z+2>>1]|0;d[B+4>>1]=d[z+4>>1]|0;A=A+1|0;if((A|0)==(e|0))break;else B=B+6|0}}break}case 8:{if(o){B=f[q>>2]|0;A=g;x=0;while(1){z=w+(f[B+(x<<2)>>2]|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];x=x+1|0;if((x|0)==(e|0))break;else A=A+8|0}}break}case 12:{if(o){A=f[q>>2]|0;x=g;B=0;while(1){z=w+(f[A+(B<<2)>>2]|0)|0;f[x>>2]=f[z>>2];f[x+4>>2]=f[z+4>>2];f[x+8>>2]=f[z+8>>2];B=B+1|0;if((B|0)==(e|0))break;else x=x+12|0}}break}default:if(o){x=f[q>>2]|0;B=g;A=0;z=f[r>>2]|0;while(1){C=w+(f[x+(A<<2)>>2]|0)|0;if((z|0)>0){D=0;do{f[B+(D<<2)>>2]=f[C+(D<<2)>>2];D=D+1|0;E=f[r>>2]|0}while((D|0)<(E|0));F=E}else F=z;A=A+1|0;if((A|0)==(e|0))break;else{B=B+h|0;z=F}}}}u=u+1|0}while((u|0)<(f[i>>2]|0));return}function Zda(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?147:146;break}case 2:{t=(c|0)>2?149:148;break}case 3:{t=(c|0)>2?151:150;break}case 4:{t=(c|0)>2?153:152;break}default:t=(c|0)>2?155:154}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;gnc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;gnc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=i+h<<3;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=XDc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<2)|0;if((h|0)>0){F=0;do{kfa(q,F,D+(F<<2)|0,z+(F<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{kfa(r,w,C+(w<<2)|0,E+(w<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=47792;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;y8(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)ZDc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function _da(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?157:156;break}case 2:{t=(c|0)>2?159:158;break}case 3:{t=(c|0)>2?161:160;break}case 4:{t=(c|0)>2?163:162;break}default:t=(c|0)>2?165:164}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;gnc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;gnc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=XDc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{Zea(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{Zea(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=47772;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;y8(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)ZDc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function $da(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?167:166;break}case 2:{t=(c|0)>2?169:168;break}case 3:{t=(c|0)>2?171:170;break}case 4:{t=(c|0)>2?173:172;break}default:t=(c|0)>2?175:174}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;gnc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;gnc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=XDc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{Mea(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{Mea(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=47752;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;y8(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)ZDc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function aea(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?177:176;break}case 2:{t=(c|0)>2?179:178;break}case 3:{t=(c|0)>2?181:180;break}case 4:{t=(c|0)>2?183:182;break}default:t=(c|0)>2?185:184}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;gnc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;gnc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=XDc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{zea(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{zea(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=47732;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;y8(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)ZDc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function bea(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?187:186;break}case 2:{t=(c|0)>2?189:188;break}case 3:{t=(c|0)>2?191:190;break}case 4:{t=(c|0)>2?193:192;break}default:t=(c|0)>2?195:194}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;gnc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;gnc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*20|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=XDc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<3)|0;if((h|0)>0){F=0;do{mea(q,F,D+(F<<2)|0,z+(F<<1<<3)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{mea(r,w,C+(w<<2)|0,E+(w<<1<<3)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=47712;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;y8(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)ZDc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function cea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=f[a>>2]|0;if((g|0)>0){j=0;k=e;while(1){l=k;f[l>>2]=0;f[l+4>>2]=b;j=j+1|0;if((j|0)==(g|0))break;else k=k+8|0}m=d+(g<<1<<3)|0;n=g;o=e+(g<<3)|0}else{m=d;n=0;o=e}if((n|0)<(h|0)){e=m;m=n;d=o;while(1){g=a+(f[c+(m<<2)>>2]<<2)|0;k=e;j=f[k>>2]|0;b=f[k+4>>2]|0;k=f[g>>2]|0;l=(b|0)<0;p=(k|0)<0;q=TIc(0,0,j|0,b|0)|0;r=l?q:j;q=l?J:b;l=TIc(0,0,0,k|0)|0;l=J;s=p?l:k;l=k^b;b=mJc(s|0,0,r|0,0)|0;r=J;k=mJc(s|0,0,q|0,0)|0;q=J;s=UIc(k|0,0,r|0,0)|0;r=J|q;if(r>>>0>0|(r|0)==0&(s|k)>>>0>2147483647){k=aJc(j|0,l|0,63)|0;j=UIc(k|0,J|0,-1,2147483647)|0;t=J;u=j}else{j=(l|0)<0;l=TIc(0,0,b|0,s|0)|0;t=j?J:s;u=j?l:b}b=e+8|0;l=f[b>>2]|0;j=f[b+4>>2]|0;b=f[g+4>>2]|0;g=(j|0)<0;s=(b|0)<0;k=TIc(0,0,l|0,j|0)|0;r=g?k:l;k=g?J:j;g=TIc(0,0,0,b|0)|0;g=J;q=s?g:b;g=b^j;j=mJc(q|0,0,r|0,0)|0;r=J;b=mJc(q|0,0,k|0,0)|0;k=J;q=UIc(b|0,0,r|0,0)|0;r=J|k;if(r>>>0>0|(r|0)==0&(q|b)>>>0>2147483647){b=aJc(l|0,g|0,63)|0;l=UIc(b|0,J|0,-1,2147483647)|0;v=l;w=J}else{l=(g|0)<0;g=TIc(0,0,j|0,q|0)|0;v=l?g:j;w=l?J:q}q=UIc(v|0,w|0,u|0,t|0)|0;l=J;j=((l^t)&(l^w)|0)<0;g=d;f[g>>2]=j?-1:q;f[g+4>>2]=j?(l|2147483647)^-2147483648:l;m=m+1|0;if((m|0)==(h|0))break;else{e=e+16|0;d=d+8|0}}x=h;y=o+(h-n<<3)|0}else{x=n;y=o}o=f[a+(f[c+(i+-1<<2)>>2]<<2)>>2]|0;if((x|0)<(i|0)){z=x;A=y}else return;while(1){y=A;f[y>>2]=0;f[y+4>>2]=o;z=z+1|0;if((z|0)==(i|0))break;else A=A+8|0}return}function dea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;lea(a,b,c,d,e,f,g,h);return}function eea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=f[a>>2]|0;j=f[a+4>>2]|0;if((g|0)>0){k=g<<1;l=0;m=e;while(1){n=m;f[n>>2]=0;f[n+4>>2]=b;n=m+8|0;f[n>>2]=0;f[n+4>>2]=j;l=l+1|0;if((l|0)==(g|0))break;else m=m+16|0}o=d+(k<<3)|0;p=g;q=e+(k<<3)|0}else{o=d;p=0;q=e}if((p|0)<(h|0)){e=h-p|0;d=p;k=q;g=o;while(1){o=a+(f[c+(d<<2)>>2]<<1<<2)|0;m=g;l=f[m>>2]|0;j=f[m+4>>2]|0;m=f[o>>2]|0;b=(j|0)<0;n=(m|0)<0;r=TIc(0,0,l|0,j|0)|0;s=b?r:l;r=b?J:j;b=TIc(0,0,0,m|0)|0;b=J;t=n?b:m;b=m^j;j=mJc(t|0,0,s|0,0)|0;s=J;m=mJc(t|0,0,r|0,0)|0;r=J;t=UIc(m|0,0,s|0,0)|0;s=J|r;if(s>>>0>0|(s|0)==0&(t|m)>>>0>2147483647){m=aJc(l|0,b|0,63)|0;l=UIc(m|0,J|0,-1,2147483647)|0;u=l;v=J}else{l=(b|0)<0;b=TIc(0,0,j|0,t|0)|0;u=l?b:j;v=l?J:t}t=g+8|0;l=t;j=f[l>>2]|0;b=f[l+4>>2]|0;l=f[o+8>>2]|0;m=(b|0)<0;s=(l|0)<0;r=TIc(0,0,j|0,b|0)|0;n=m?r:j;r=m?J:b;m=TIc(0,0,0,l|0)|0;m=J;w=s?m:l;m=l^b;b=mJc(w|0,0,n|0,0)|0;n=J;l=mJc(w|0,0,r|0,0)|0;r=J;w=UIc(l|0,0,n|0,0)|0;n=J|r;if(n>>>0>0|(n|0)==0&(w|l)>>>0>2147483647){l=aJc(j|0,m|0,63)|0;j=UIc(l|0,J|0,-1,2147483647)|0;x=j;y=J}else{j=(m|0)<0;m=TIc(0,0,b|0,w|0)|0;x=j?m:b;y=j?J:w}w=UIc(x|0,y|0,u|0,v|0)|0;j=J;b=((j^v)&(j^y)|0)<0;m=k;f[m>>2]=b?-1:w;f[m+4>>2]=b?(j|2147483647)^-2147483648:j;j=g;b=f[j>>2]|0;m=f[j+4>>2]|0;j=f[o+4>>2]|0;w=(m|0)<0;l=(j|0)<0;n=TIc(0,0,b|0,m|0)|0;r=w?n:b;n=w?J:m;w=TIc(0,0,0,j|0)|0;w=J;s=l?w:j;w=j^m;m=mJc(s|0,0,r|0,0)|0;r=J;j=mJc(s|0,0,n|0,0)|0;n=J;s=UIc(j|0,0,r|0,0)|0;r=J|n;if(r>>>0>0|(r|0)==0&(s|j)>>>0>2147483647){j=aJc(b|0,w|0,63)|0;b=UIc(j|0,J|0,-1,2147483647)|0;z=b;A=J}else{b=(w|0)<0;w=TIc(0,0,m|0,s|0)|0;z=b?w:m;A=b?J:s}s=t;t=f[s>>2]|0;b=f[s+4>>2]|0;s=f[o+12>>2]|0;o=(b|0)<0;m=(s|0)<0;w=TIc(0,0,t|0,b|0)|0;j=o?w:t;w=o?J:b;o=TIc(0,0,0,s|0)|0;o=J;r=m?o:s;o=s^b;b=mJc(r|0,0,j|0,0)|0;j=J;s=mJc(r|0,0,w|0,0)|0;w=J;r=UIc(s|0,0,j|0,0)|0;j=J|w;if(j>>>0>0|(j|0)==0&(r|s)>>>0>2147483647){s=aJc(t|0,o|0,63)|0;t=UIc(s|0,J|0,-1,2147483647)|0;B=t;C=J}else{t=(o|0)<0;o=TIc(0,0,b|0,r|0)|0;B=t?o:b;C=t?J:r}r=UIc(B|0,C|0,z|0,A|0)|0;t=J;b=((t^A)&(t^C)|0)<0;o=k+8|0;f[o>>2]=b?-1:r;f[o+4>>2]=b?(t|2147483647)^-2147483648:t;d=d+1|0;if((d|0)==(h|0))break;else{k=k+16|0;g=g+16|0}}D=h;E=q+(e<<1<<3)|0}else{D=p;E=q}q=a+(f[c+(i+-1<<2)>>2]<<1<<2)|0;c=f[q>>2]|0;a=f[q+4>>2]|0;if((D|0)<(i|0)){F=E;G=D}else return;while(1){D=F;f[D>>2]=0;f[D+4>>2]=c;D=F+8|0;f[D>>2]=0;f[D+4>>2]=a;G=G+1|0;if((G|0)==(i|0))break;else F=F+16|0}return}function fea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;lea(a,b,c,d,e,f,g,h);return}function gea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;b=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;if((g|0)>0){l=g*3|0;m=0;n=e;while(1){o=n;f[o>>2]=0;f[o+4>>2]=b;o=n+8|0;f[o>>2]=0;f[o+4>>2]=j;o=n+16|0;f[o>>2]=0;f[o+4>>2]=k;m=m+1|0;if((m|0)==(g|0))break;else n=n+24|0}p=d+(g<<1<<3)|0;q=g;r=e+(l<<3)|0}else{p=d;q=0;r=e}if((q|0)<(h|0)){e=h-q|0;d=q;l=r;g=p;while(1){p=a+((f[c+(d<<2)>>2]|0)*3<<2)|0;n=g;m=f[n>>2]|0;k=f[n+4>>2]|0;n=f[p>>2]|0;j=(k|0)<0;b=(n|0)<0;o=TIc(0,0,m|0,k|0)|0;s=j?o:m;o=j?J:k;j=TIc(0,0,0,n|0)|0;j=J;t=b?j:n;j=n^k;k=mJc(t|0,0,s|0,0)|0;s=J;n=mJc(t|0,0,o|0,0)|0;o=J;t=UIc(n|0,0,s|0,0)|0;s=J|o;if(s>>>0>0|(s|0)==0&(t|n)>>>0>2147483647){n=aJc(m|0,j|0,63)|0;m=UIc(n|0,J|0,-1,2147483647)|0;u=m;v=J}else{m=(j|0)<0;j=TIc(0,0,k|0,t|0)|0;u=m?j:k;v=m?J:t}t=g+8|0;m=t;k=f[m>>2]|0;j=f[m+4>>2]|0;m=f[p+12>>2]|0;n=(j|0)<0;s=(m|0)<0;o=TIc(0,0,k|0,j|0)|0;b=n?o:k;o=n?J:j;n=TIc(0,0,0,m|0)|0;n=J;w=s?n:m;n=m^j;j=mJc(w|0,0,b|0,0)|0;b=J;m=mJc(w|0,0,o|0,0)|0;o=J;w=UIc(m|0,0,b|0,0)|0;b=J|o;if(b>>>0>0|(b|0)==0&(w|m)>>>0>2147483647){m=aJc(k|0,n|0,63)|0;k=UIc(m|0,J|0,-1,2147483647)|0;x=k;y=J}else{k=(n|0)<0;n=TIc(0,0,j|0,w|0)|0;x=k?n:j;y=k?J:w}w=UIc(x|0,y|0,u|0,v|0)|0;k=J;j=((k^v)&(k^y)|0)<0;n=l;f[n>>2]=j?-1:w;f[n+4>>2]=j?(k|2147483647)^-2147483648:k;k=g;j=f[k>>2]|0;n=f[k+4>>2]|0;k=f[p+4>>2]|0;w=(n|0)<0;m=(k|0)<0;b=TIc(0,0,j|0,n|0)|0;o=w?b:j;b=w?J:n;w=TIc(0,0,0,k|0)|0;w=J;s=m?w:k;w=k^n;n=mJc(s|0,0,o|0,0)|0;o=J;k=mJc(s|0,0,b|0,0)|0;b=J;s=UIc(k|0,0,o|0,0)|0;o=J|b;if(o>>>0>0|(o|0)==0&(s|k)>>>0>2147483647){k=aJc(j|0,w|0,63)|0;j=UIc(k|0,J|0,-1,2147483647)|0;z=j;A=J}else{j=(w|0)<0;w=TIc(0,0,n|0,s|0)|0;z=j?w:n;A=j?J:s}s=t;j=f[s>>2]|0;n=f[s+4>>2]|0;s=f[p+16>>2]|0;w=(n|0)<0;k=(s|0)<0;o=TIc(0,0,j|0,n|0)|0;b=w?o:j;o=w?J:n;w=TIc(0,0,0,s|0)|0;w=J;m=k?w:s;w=s^n;n=mJc(m|0,0,b|0,0)|0;b=J;s=mJc(m|0,0,o|0,0)|0;o=J;m=UIc(s|0,0,b|0,0)|0;b=J|o;if(b>>>0>0|(b|0)==0&(m|s)>>>0>2147483647){s=aJc(j|0,w|0,63)|0;j=UIc(s|0,J|0,-1,2147483647)|0;B=j;C=J}else{j=(w|0)<0;w=TIc(0,0,n|0,m|0)|0;B=j?w:n;C=j?J:m}m=UIc(B|0,C|0,z|0,A|0)|0;j=J;n=((j^A)&(j^C)|0)<0;w=l+8|0;f[w>>2]=n?-1:m;f[w+4>>2]=n?(j|2147483647)^-2147483648:j;j=g;n=f[j>>2]|0;w=f[j+4>>2]|0;j=f[p+8>>2]|0;m=(w|0)<0;s=(j|0)<0;b=TIc(0,0,n|0,w|0)|0;o=m?b:n;b=m?J:w;m=TIc(0,0,0,j|0)|0;m=J;k=s?m:j;m=j^w;w=mJc(k|0,0,o|0,0)|0;o=J;j=mJc(k|0,0,b|0,0)|0;b=J;k=UIc(j|0,0,o|0,0)|0;o=J|b;if(o>>>0>0|(o|0)==0&(k|j)>>>0>2147483647){j=aJc(n|0,m|0,63)|0;n=UIc(j|0,J|0,-1,2147483647)|0;D=n;E=J}else{n=(m|0)<0;m=TIc(0,0,w|0,k|0)|0;D=n?m:w;E=n?J:k}k=t;t=f[k>>2]|0;n=f[k+4>>2]|0;k=f[p+20>>2]|0;p=(n|0)<0;w=(k|0)<0;m=TIc(0,0,t|0,n|0)|0;j=p?m:t;m=p?J:n;p=TIc(0,0,0,k|0)|0;p=J;o=w?p:k;p=k^n;n=mJc(o|0,0,j|0,0)|0;j=J;k=mJc(o|0,0,m|0,0)|0;m=J;o=UIc(k|0,0,j|0,0)|0;j=J|m;if(j>>>0>0|(j|0)==0&(o|k)>>>0>2147483647){k=aJc(t|0,p|0,63)|0;t=UIc(k|0,J|0,-1,2147483647)|0;F=t;G=J}else{t=(p|0)<0;p=TIc(0,0,n|0,o|0)|0;F=t?p:n;G=t?J:o}o=UIc(F|0,G|0,D|0,E|0)|0;t=J;n=((t^E)&(t^G)|0)<0;p=l+16|0;f[p>>2]=n?-1:o;f[p+4>>2]=n?(t|2147483647)^-2147483648:t;d=d+1|0;if((d|0)==(h|0))break;else{l=l+24|0;g=g+16|0}}H=h;I=r+(e*3<<3)|0}else{H=q;I=r}r=a+((f[c+(i+-1<<2)>>2]|0)*3<<2)|0;c=f[r>>2]|0;a=f[r+4>>2]|0;q=f[r+8>>2]|0;if((H|0)<(i|0)){K=I;L=H}else return;while(1){H=K;f[H>>2]=0;f[H+4>>2]=c;H=K+8|0;f[H>>2]=0;f[H+4>>2]=a;H=K+16|0;f[H>>2]=0;f[H+4>>2]=q;L=L+1|0;if((L|0)==(i|0))break;else K=K+24|0}return}function hea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;lea(a,b,c,d,e,f,g,h);return}function iea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;b=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;l=f[a+12>>2]|0;if((g|0)>0){m=g<<2;n=0;o=e;while(1){p=o;f[p>>2]=0;f[p+4>>2]=b;p=o+8|0;f[p>>2]=0;f[p+4>>2]=j;p=o+16|0;f[p>>2]=0;f[p+4>>2]=k;p=o+24|0;f[p>>2]=0;f[p+4>>2]=l;n=n+1|0;if((n|0)==(g|0))break;else o=o+32|0}q=d+(g<<1<<3)|0;r=g;s=e+(m<<3)|0}else{q=d;r=0;s=e}if((r|0)<(h|0)){e=h-r|0;d=q;q=r;m=s;while(1){g=a+(f[c+(q<<2)>>2]<<2<<2)|0;o=d;n=f[o>>2]|0;l=f[o+4>>2]|0;o=f[g>>2]|0;k=(l|0)<0;j=(o|0)<0;b=TIc(0,0,n|0,l|0)|0;p=k?b:n;b=k?J:l;k=TIc(0,0,0,o|0)|0;k=J;t=j?k:o;k=o^l;l=mJc(t|0,0,p|0,0)|0;p=J;o=mJc(t|0,0,b|0,0)|0;b=J;t=UIc(o|0,0,p|0,0)|0;p=J|b;if(p>>>0>0|(p|0)==0&(t|o)>>>0>2147483647){o=aJc(n|0,k|0,63)|0;n=UIc(o|0,J|0,-1,2147483647)|0;u=n;v=J}else{n=(k|0)<0;k=TIc(0,0,l|0,t|0)|0;u=n?k:l;v=n?J:t}t=d+8|0;n=t;l=f[n>>2]|0;k=f[n+4>>2]|0;n=f[g+16>>2]|0;o=(k|0)<0;p=(n|0)<0;b=TIc(0,0,l|0,k|0)|0;j=o?b:l;b=o?J:k;o=TIc(0,0,0,n|0)|0;o=J;w=p?o:n;o=n^k;k=mJc(w|0,0,j|0,0)|0;j=J;n=mJc(w|0,0,b|0,0)|0;b=J;w=UIc(n|0,0,j|0,0)|0;j=J|b;if(j>>>0>0|(j|0)==0&(w|n)>>>0>2147483647){n=aJc(l|0,o|0,63)|0;l=UIc(n|0,J|0,-1,2147483647)|0;x=l;y=J}else{l=(o|0)<0;o=TIc(0,0,k|0,w|0)|0;x=l?o:k;y=l?J:w}w=UIc(x|0,y|0,u|0,v|0)|0;l=J;k=((l^v)&(l^y)|0)<0;o=m;f[o>>2]=k?-1:w;f[o+4>>2]=k?(l|2147483647)^-2147483648:l;l=d;k=f[l>>2]|0;o=f[l+4>>2]|0;l=f[g+4>>2]|0;w=(o|0)<0;n=(l|0)<0;j=TIc(0,0,k|0,o|0)|0;b=w?j:k;j=w?J:o;w=TIc(0,0,0,l|0)|0;w=J;p=n?w:l;w=l^o;o=mJc(p|0,0,b|0,0)|0;b=J;l=mJc(p|0,0,j|0,0)|0;j=J;p=UIc(l|0,0,b|0,0)|0;b=J|j;if(b>>>0>0|(b|0)==0&(p|l)>>>0>2147483647){l=aJc(k|0,w|0,63)|0;k=UIc(l|0,J|0,-1,2147483647)|0;z=k;A=J}else{k=(w|0)<0;w=TIc(0,0,o|0,p|0)|0;z=k?w:o;A=k?J:p}p=t;k=f[p>>2]|0;o=f[p+4>>2]|0;p=f[g+20>>2]|0;w=(o|0)<0;l=(p|0)<0;b=TIc(0,0,k|0,o|0)|0;j=w?b:k;b=w?J:o;w=TIc(0,0,0,p|0)|0;w=J;n=l?w:p;w=p^o;o=mJc(n|0,0,j|0,0)|0;j=J;p=mJc(n|0,0,b|0,0)|0;b=J;n=UIc(p|0,0,j|0,0)|0;j=J|b;if(j>>>0>0|(j|0)==0&(n|p)>>>0>2147483647){p=aJc(k|0,w|0,63)|0;k=UIc(p|0,J|0,-1,2147483647)|0;B=k;C=J}else{k=(w|0)<0;w=TIc(0,0,o|0,n|0)|0;B=k?w:o;C=k?J:n}n=UIc(B|0,C|0,z|0,A|0)|0;k=J;o=((k^A)&(k^C)|0)<0;w=m+8|0;f[w>>2]=o?-1:n;f[w+4>>2]=o?(k|2147483647)^-2147483648:k;k=d;o=f[k>>2]|0;w=f[k+4>>2]|0;k=f[g+8>>2]|0;n=(w|0)<0;p=(k|0)<0;j=TIc(0,0,o|0,w|0)|0;b=n?j:o;j=n?J:w;n=TIc(0,0,0,k|0)|0;n=J;l=p?n:k;n=k^w;w=mJc(l|0,0,b|0,0)|0;b=J;k=mJc(l|0,0,j|0,0)|0;j=J;l=UIc(k|0,0,b|0,0)|0;b=J|j;if(b>>>0>0|(b|0)==0&(l|k)>>>0>2147483647){k=aJc(o|0,n|0,63)|0;o=UIc(k|0,J|0,-1,2147483647)|0;D=o;E=J}else{o=(n|0)<0;n=TIc(0,0,w|0,l|0)|0;D=o?n:w;E=o?J:l}l=t;o=f[l>>2]|0;w=f[l+4>>2]|0;l=f[g+24>>2]|0;n=(w|0)<0;k=(l|0)<0;b=TIc(0,0,o|0,w|0)|0;j=n?b:o;b=n?J:w;n=TIc(0,0,0,l|0)|0;n=J;p=k?n:l;n=l^w;w=mJc(p|0,0,j|0,0)|0;j=J;l=mJc(p|0,0,b|0,0)|0;b=J;p=UIc(l|0,0,j|0,0)|0;j=J|b;if(j>>>0>0|(j|0)==0&(p|l)>>>0>2147483647){l=aJc(o|0,n|0,63)|0;o=UIc(l|0,J|0,-1,2147483647)|0;F=o;G=J}else{o=(n|0)<0;n=TIc(0,0,w|0,p|0)|0;F=o?n:w;G=o?J:p}p=UIc(F|0,G|0,D|0,E|0)|0;o=J;w=((o^E)&(o^G)|0)<0;n=m+16|0;f[n>>2]=w?-1:p;f[n+4>>2]=w?(o|2147483647)^-2147483648:o;o=d;w=f[o>>2]|0;n=f[o+4>>2]|0;o=f[g+12>>2]|0;p=(n|0)<0;l=(o|0)<0;j=TIc(0,0,w|0,n|0)|0;b=p?j:w;j=p?J:n;p=TIc(0,0,0,o|0)|0;p=J;k=l?p:o;p=o^n;n=mJc(k|0,0,b|0,0)|0;b=J;o=mJc(k|0,0,j|0,0)|0;j=J;k=UIc(o|0,0,b|0,0)|0;b=J|j;if(b>>>0>0|(b|0)==0&(k|o)>>>0>2147483647){o=aJc(w|0,p|0,63)|0;w=UIc(o|0,J|0,-1,2147483647)|0;H=w;I=J}else{w=(p|0)<0;p=TIc(0,0,n|0,k|0)|0;H=w?p:n;I=w?J:k}k=t;t=f[k>>2]|0;w=f[k+4>>2]|0;k=f[g+28>>2]|0;g=(w|0)<0;n=(k|0)<0;p=TIc(0,0,t|0,w|0)|0;o=g?p:t;p=g?J:w;g=TIc(0,0,0,k|0)|0;g=J;b=n?g:k;g=k^w;w=mJc(b|0,0,o|0,0)|0;o=J;k=mJc(b|0,0,p|0,0)|0;p=J;b=UIc(k|0,0,o|0,0)|0;o=J|p;if(o>>>0>0|(o|0)==0&(b|k)>>>0>2147483647){k=aJc(t|0,g|0,63)|0;t=UIc(k|0,J|0,-1,2147483647)|0;K=t;L=J}else{t=(g|0)<0;g=TIc(0,0,w|0,b|0)|0;K=t?g:w;L=t?J:b}b=UIc(K|0,L|0,H|0,I|0)|0;t=J;w=((t^I)&(t^L)|0)<0;g=m+24|0;f[g>>2]=w?-1:b;f[g+4>>2]=w?(t|2147483647)^-2147483648:t;q=q+1|0;if((q|0)==(h|0))break;else{d=d+16|0;m=m+32|0}}M=h;N=s+(e<<2<<3)|0}else{M=r;N=s}s=a+(f[c+(i+-1<<2)>>2]<<2<<2)|0;c=f[s>>2]|0;a=f[s+4>>2]|0;r=f[s+8>>2]|0;e=f[s+12>>2]|0;if((M|0)<(i|0)){O=N;P=M}else return;while(1){M=O;f[M>>2]=0;f[M+4>>2]=c;M=O+8|0;f[M>>2]=0;f[M+4>>2]=a;M=O+16|0;f[M>>2]=0;f[M+4>>2]=r;M=O+24|0;f[M>>2]=0;f[M+4>>2]=e;P=P+1|0;if((P|0)==(i|0))break;else O=O+32|0}return}function jea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;lea(a,b,c,d,e,f,g,h);return}function kea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;do if((g|0)>0){j=g<<1;if((b|0)<=0){k=d+(j<<3)|0;l=e;m=g;break}n=Y(g,b)|0;o=e;p=0;while(1){q=0;r=o;while(1){s=f[a+(q<<2)>>2]|0;t=r;f[t>>2]=0;f[t+4>>2]=s;q=q+1|0;if((q|0)==(b|0))break;else r=r+8|0}p=p+1|0;if((p|0)==(g|0))break;else o=o+(b<<3)|0}k=d+(j<<3)|0;l=e+(n<<3)|0;m=g}else{k=d;l=e;m=0}while(0);if((m|0)<(h|0)){e=(b|0)>0;d=k;k=m;g=l;while(1){o=a+((Y(f[c+(k<<2)>>2]|0,b)|0)<<2)|0;if(e){p=d+8|0;r=0;q=g;while(1){s=d;t=f[s>>2]|0;u=f[s+4>>2]|0;s=f[o+(r<<2)>>2]|0;v=(u|0)<0;w=(s|0)<0;x=TIc(0,0,t|0,u|0)|0;y=v?x:t;x=v?J:u;v=TIc(0,0,0,s|0)|0;v=J;z=w?v:s;v=s^u;u=mJc(z|0,0,y|0,0)|0;y=J;s=mJc(z|0,0,x|0,0)|0;x=J;z=UIc(s|0,0,y|0,0)|0;y=J|x;if(y>>>0>0|(y|0)==0&(z|s)>>>0>2147483647){s=aJc(t|0,v|0,63)|0;t=UIc(s|0,J|0,-1,2147483647)|0;A=t;B=J}else{t=(v|0)<0;v=TIc(0,0,u|0,z|0)|0;A=t?v:u;B=t?J:z}z=q;f[z>>2]=A;f[z+4>>2]=B;z=p;t=f[z>>2]|0;u=f[z+4>>2]|0;z=f[o+(r+b<<2)>>2]|0;v=(u|0)<0;s=(z|0)<0;y=TIc(0,0,t|0,u|0)|0;x=v?y:t;y=v?J:u;v=TIc(0,0,0,z|0)|0;v=J;w=s?v:z;v=z^u;u=mJc(w|0,0,x|0,0)|0;x=J;z=mJc(w|0,0,y|0,0)|0;y=J;w=UIc(z|0,0,x|0,0)|0;x=J|y;if(x>>>0>0|(x|0)==0&(w|z)>>>0>2147483647){z=aJc(t|0,v|0,63)|0;t=UIc(z|0,J|0,-1,2147483647)|0;C=t;D=J}else{t=(v|0)<0;v=TIc(0,0,u|0,w|0)|0;C=t?v:u;D=t?J:w}w=UIc(A|0,B|0,C|0,D|0)|0;t=J;u=((t^B)&(t^D)|0)<0;v=q;f[v>>2]=u?-1:w;f[v+4>>2]=u?(t|2147483647)^-2147483648:t;r=r+1|0;if((r|0)==(b|0))break;else q=q+8|0}E=g+(b<<3)|0}else E=g;k=k+1|0;if((k|0)==(h|0)){F=h;G=E;break}else{d=d+16|0;g=E}}}else{F=m;G=l}l=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<2)|0;if((F|0)<(i|0)&(b|0)>0){H=F;I=G}else return;while(1){G=0;F=I;while(1){c=f[l+(G<<2)>>2]|0;a=F;f[a>>2]=0;f[a+4>>2]=c;G=G+1|0;if((G|0)==(b|0))break;else F=F+8|0}H=H+1|0;if((H|0)==(i|0))break;else I=I+(b<<3)|0}return}function lea(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;do if((g|0)>0){j=g<<1;if((b|0)<=0){k=d+(j<<3)|0;l=e;m=g;break}n=Y(g,b)|0;o=e;p=0;while(1){q=0;r=o;while(1){s=f[a+(q<<2)>>2]|0;t=r;f[t>>2]=0;f[t+4>>2]=s;q=q+1|0;if((q|0)==(b|0))break;else r=r+8|0}p=p+1|0;if((p|0)==(g|0))break;else o=o+(b<<3)|0}k=d+(j<<3)|0;l=e+(n<<3)|0;m=g}else{k=d;l=e;m=0}while(0);if((m|0)<(h|0)){e=(b|0)>0;d=k;k=m;g=l;while(1){o=a+((Y(f[c+(k<<2)>>2]|0,b)|0)<<2)|0;if(e){p=d+8|0;r=0;q=g;while(1){s=d;t=f[s>>2]|0;u=f[s+4>>2]|0;do if(!((t|0)==0&(u|0)==0)){s=f[o+(r<<2)>>2]|0;v=(u|0)<0;w=(s|0)<0;x=TIc(0,0,t|0,u|0)|0;y=v?x:t;x=v?J:u;v=TIc(0,0,0,s|0)|0;v=J;z=w?v:s;v=s^u;s=mJc(z|0,0,y|0,0)|0;y=J;w=mJc(z|0,0,x|0,0)|0;x=J;z=UIc(w|0,0,y|0,0)|0;y=J|x;if(y>>>0>0|(y|0)==0&(z|w)>>>0>2147483647){w=aJc(t|0,v|0,63)|0;y=UIc(w|0,J|0,-1,2147483647)|0;A=y;B=J;break}else{y=(v|0)<0;v=TIc(0,0,s|0,z|0)|0;A=y?v:s;B=y?J:z;break}}else{A=0;B=0}while(0);t=q;f[t>>2]=A;f[t+4>>2]=B;t=p;u=f[t>>2]|0;z=f[t+4>>2]|0;do if(!((u|0)==0&(z|0)==0)){t=f[o+(r+b<<2)>>2]|0;y=(z|0)<0;s=(t|0)<0;v=TIc(0,0,u|0,z|0)|0;w=y?v:u;v=y?J:z;y=TIc(0,0,0,t|0)|0;y=J;x=s?y:t;y=t^z;t=mJc(x|0,0,w|0,0)|0;w=J;s=mJc(x|0,0,v|0,0)|0;v=J;x=UIc(s|0,0,w|0,0)|0;w=J|v;if(w>>>0>0|(w|0)==0&(x|s)>>>0>2147483647){s=aJc(u|0,y|0,63)|0;w=UIc(s|0,J|0,-1,2147483647)|0;C=w;D=J;break}else{w=(y|0)<0;y=TIc(0,0,t|0,x|0)|0;C=w?y:t;D=w?J:x;break}}else{C=0;D=0}while(0);u=UIc(A|0,B|0,C|0,D|0)|0;z=J;x=((z^B)&(z^D)|0)<0;w=q;f[w>>2]=x?-1:u;f[w+4>>2]=x?(z|2147483647)^-2147483648:z;r=r+1|0;if((r|0)==(b|0))break;else q=q+8|0}E=g+(b<<3)|0}else E=g;k=k+1|0;if((k|0)==(h|0)){F=h;G=E;break}else{d=d+16|0;g=E}}}else{F=m;G=l}l=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<2)|0;if((F|0)<(i|0)&(b|0)>0){H=F;I=G}else return;while(1){G=0;F=I;while(1){c=f[l+(G<<2)>>2]|0;a=F;f[a>>2]=0;f[a+4>>2]=c;G=G+1|0;if((G|0)==(b|0))break;else F=F+8|0}H=H+1|0;if((H|0)==(i|0))break;else I=I+(b<<3)|0}return}function mea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;Vmc(j,b);p[h>>3]=.5;bnc(g,j,h);fnc(k,a,g);p[l>>3]=.5;enc(i,k,l);k=_mc(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;Vmc(m,k);enc(l,i,m);Wmc(h,0,1);fnc(g,l,h);h=$mc(g)|0;g=J;l=d+8|0;f[l>>2]=h;f[l+4>>2]=g;l=TIc(0,1,h|0,g|0)|0;h=J;m=(h&g|0)<0;g=d;f[g>>2]=m?-1:l;f[g+4>>2]=m?(h|2147483647)^-2147483648:h;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function nea(a){a=a|0;YDc(a);return}
function SIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0,Gl=0,Hl=0,Il=0,Jl=0,Kl=0,Ll=0,Ml=0,Nl=0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0,$l=0,am=0,bm=0,cm=0,dm=0,em=0,fm=0,gm=0,hm=0,im=0,jm=0,km=0,lm=0,mm=0,nm=0,om=0,pm=0,qm=0,rm=0,sm=0,tm=0,um=0,vm=0,wm=0,xm=0,ym=0,zm=0,Am=0,Bm=0,Cm=0,Dm=0,Em=0,Fm=0,Gm=0,Hm=0,Im=0,Jm=0,Km=0,Lm=0,Mm=0,Nm=0,Om=0,Pm=0,Qm=0,Rm=0,Sm=0,Tm=0,Um=0,Vm=0,Wm=0,Xm=0,Ym=0,Zm=0,_m=0,$m=0,an=0,bn=0,cn=0,dn=0,en=0,fn=0,gn=0,hn=0,jn=0,kn=0,ln=0,mn=0,nn=0,on=0,pn=0,qn=0,rn=0,sn=0,tn=0,un=0,vn=0,wn=0,xn=0,yn=0,zn=0,An=0,Bn=0,Cn=0,Dn=0,En=0,Fn=0,Gn=0,Hn=0,In=0,Jn=0,Kn=0,Ln=0,Mn=0,Nn=0,On=0,Pn=0,Qn=0,Rn=0,Sn=0,Tn=0,Un=0,Vn=0,Wn=0,Xn=0,Yn=0,Zn=0,_n=0,$n=0,ao=0,bo=0,co=0,eo=0,fo=0,go=0,ho=0,io=0,jo=0,ko=0,lo=0,mo=0,no=0,oo=0,po=0,qo=0,ro=0,so=0,to=0,uo=0,vo=0,wo=0,xo=0,yo=0,zo=0,Ao=0,Bo=0,Co=0,Do=0,Eo=0,Fo=0,Go=0,Ho=0,Io=0,Jo=0,Ko=0,Lo=0,Mo=0,No=0,Oo=0,Po=0,Qo=0,Ro=0,So=0,To=0,Uo=0,Vo=0,Wo=0,Xo=0,Yo=0,Zo=0,_o=0,$o=0,ap=0,bp=0,cp=0,dp=0,ep=0,fp=0,gp=0,hp=0,ip=0,jp=0,kp=0,lp=0,mp=0,np=0,op=0,pp=0,qp=0,rp=0,sp=0,tp=0,up=0,vp=0,wp=0,xp=0,yp=0,zp=0,Ap=0,Bp=0,Cp=0,Dp=0,Ep=0,Fp=0,Gp=0,Hp=0,Ip=0,Jp=0,Kp=0,Lp=0,Mp=0,Np=0,Op=0,Pp=0,Qp=0,Rp=0,Sp=0,Tp=0,Up=0,Vp=0,Wp=0,Xp=0,Yp=0,Zp=0,_p=0,$p=0,aq=0,bq=0,cq=0,dq=0,eq=0,fq=0,gq=0,hq=0,iq=0,jq=0,kq=0,lq=0,mq=0,nq=0,oq=0,pq=0,qq=0,rq=0,sq=0,tq=0,uq=0,vq=0,wq=0,xq=0,yq=0,zq=0,Aq=0,Bq=0,Cq=0,Dq=0,Eq=0,Fq=0,Gq=0,Hq=0,Iq=0,Jq=0,Kq=0,Lq=0,Mq=0,Nq=0,Oq=0,Pq=0,Qq=0,Rq=0,Sq=0,Tq=0,Uq=0,Vq=0,Wq=0,Xq=0,Yq=0,Zq=0,_q=0,$q=0,ar=0,br=0,cr=0,dr=0,er=0,fr=0,gr=0,hr=0,ir=0,jr=0,kr=0,lr=0,mr=0,nr=0,or=0,pr=0,qr=0,rr=0,sr=0,tr=0,ur=0,vr=0,wr=0,xr=0,yr=0,zr=0,Ar=0,Br=0,Cr=0,Dr=0,Er=0,Fr=0,Gr=0,Hr=0,Ir=0,Jr=0,Kr=0,Lr=0,Mr=0,Nr=0,Or=0,Pr=0,Qr=0,Rr=0,Sr=0,Tr=0,Ur=0,Vr=0,Wr=0,Xr=0,Yr=0,Zr=0,_r=0,$r=0,as=0,bs=0,cs=0,ds=0,es=0,fs=0,gs=0,hs=0,is=0,js=0,ks=0,ls=0,ms=0,ns=0,os=0,ps=0,qs=0,rs=0,ss=0,ts=0,us=0,vs=0,ws=0,xs=0,ys=0,zs=0,As=0,Bs=0,Cs=0,Ds=0,Es=0,Fs=0,Gs=0,Hs=0,Is=0,Js=0,Ks=0,Ls=0,Ms=0,Ns=0,Os=0,Ps=0,Qs=0,Rs=0,Ss=0,Ts=0,Us=0,Vs=0,Ws=0,Xs=0,Ys=0,Zs=0,_s=0,$s=0,at=0,bt=0,ct=0,dt=0,et=0,ft=0,gt=0,ht=0,it=0,jt=0,kt=0,lt=0,mt=0,nt=0,ot=0,pt=0,qt=0,rt=0,st=0,tt=0,ut=0,vt=0,wt=0,xt=0,yt=0,zt=0,At=0,Bt=0,Ct=0,Dt=0,Et=0,Ft=0,Gt=0,Ht=0,It=0,Jt=0,Kt=0,Lt=0,Mt=0,Nt=0,Ot=0,Pt=0,Qt=0,Rt=0,St=0,Tt=0,Ut=0,Vt=0,Wt=0,Xt=0,Yt=0,Zt=0,_t=0,$t=0,au=0,bu=0,cu=0,du=0,eu=0,fu=0,gu=0,hu=0,iu=0,ju=0,ku=0,lu=0,mu=0,nu=0,ou=0,pu=0,qu=0,ru=0,su=0,tu=0,uu=0,vu=0,wu=0,xu=0,yu=0,zu=0,Au=0,Bu=0,Cu=0,Du=0,Eu=0,Fu=0,Gu=0,Hu=0,Iu=0,Ju=0,Ku=0,Lu=0,Mu=0.0,Nu=0,Ou=0,Pu=0,Qu=0,Ru=0,Su=0,Tu=0,Uu=0,Vu=0,Wu=0,Xu=0,Yu=0,Zu=0,_u=0,$u=0,av=0,bv=0,cv=0,dv=0,ev=0,fv=0,gv=0,hv=0,iv=0,jv=0,kv=0,lv=0,mv=0,nv=0,ov=0,pv=0,qv=0,rv=0,sv=0,tv=0,uv=0,vv=0,wv=0,xv=0,yv=0,zv=0,Av=0,Bv=0,Cv=0,Dv=0,Ev=0,Fv=0,Gv=0,Hv=0,Iv=0,Jv=0,Kv=0,Lv=0,Mv=0,Nv=0,Ov=0,Pv=0,Qv=0,Rv=0,Sv=0,Tv=0,Uv=0,Vv=0,Wv=0,Xv=0,Yv=0,Zv=0,_v=0,$v=0,aw=0,bw=0,cw=0,dw=0,ew=0,fw=0,gw=0,hw=0,iw=0,jw=0,kw=0,lw=0,mw=0,nw=0,ow=0,pw=0,qw=0,rw=0,sw=0,tw=0,uw=0,vw=0,ww=0,xw=0,yw=0,zw=0,Aw=0,Bw=0.0,Cw=0,Dw=0,Ew=0,Fw=0,Gw=0,Hw=0,Iw=0,Jw=0,Kw=0,Lw=0,Mw=0,Nw=0,Ow=0,Pw=0,Qw=0,Rw=0,Sw=0,Tw=0,Uw=0,Vw=0,Ww=0,Xw=0,Yw=0,Zw=0,_w=0,$w=0,ax=0,bx=0,dx=0,ex=0,fx=0,gx=0,hx=0,ix=0,jx=0,kx=0,lx=0,mx=0,nx=0,ox=0,px=0,qx=0,rx=0,sx=0,tx=0,ux=0,vx=0,wx=0,xx=0,yx=0,zx=0,Ax=0,Bx=0,Cx=0,Dx=0,Ex=0,Fx=0,Gx=0,Hx=0,Ix=0,Jx=0,Kx=0,Lx=0,Mx=0,Nx=0,Ox=0,Px=0,Qx=0,Rx=0,Sx=0,Tx=0,Ux=0,Vx=0,Wx=0,Xx=0,Yx=0,Zx=0,_x=0,$x=0,ay=0,by=0,cy=0,dy=0,ey=0,fy=0,gy=0,hy=0,iy=0,jy=0,ky=0,ly=0,my=0,ny=0,oy=0,py=0,qy=0,ry=0,sy=0,ty=0,uy=0,vy=0,wy=0,xy=0,yy=0,zy=0,Ay=0,By=0,Cy=0,Dy=0,Ey=0,Fy=0,Gy=0,Hy=0,Iy=0,Jy=0,Ky=0,Ly=0,My=0,Ny=0,Oy=0,Py=0,Qy=0,Ry=0,Sy=0,Ty=0,Uy=0,Vy=0,Wy=0,Xy=0,Yy=0,Zy=0,_y=0,$y=0,az=0,bz=0,cz=0,dz=0,ez=0,fz=0,gz=0,hz=0,iz=0,jz=0,kz=0,lz=0,mz=0,nz=0,oz=0,pz=0,qz=0,rz=0,sz=0,tz=0,uz=0,vz=0,wz=0,xz=0,yz=0,zz=0,Az=0,Bz=0,Cz=0,Dz=0,Ez=0,Fz=0,Gz=0,Hz=0,Iz=0,Jz=0,Kz=0,Lz=0,Mz=0,Nz=0,Oz=0,Pz=0,Qz=0,Rz=0,Sz=0,Tz=0,Uz=0,Vz=0,Wz=0,Xz=0,Yz=0,Zz=0,_z=0,$z=0,aA=0,bA=0,cA=0,dA=0,eA=0,fA=0,gA=0,hA=0,iA=0,jA=0,kA=0,lA=0,mA=0,nA=0,oA=0,pA=0,qA=0,rA=0,sA=0,tA=0,uA=0,vA=0,wA=0,xA=0,yA=0,zA=0,AA=0,BA=0,CA=0,DA=0,EA=0,FA=0,GA=0,HA=0,IA=0,JA=0,KA=0,LA=0,MA=0,NA=0,OA=0,PA=0,QA=0,RA=0,SA=0,TA=0,UA=0,VA=0,WA=0,XA=0,YA=0,ZA=0,_A=0,$A=0,aB=0,bB=0,cB=0,dB=0,eB=0,fB=0,gB=0,hB=0,iB=0,jB=0,kB=0,lB=0,mB=0,nB=0,oB=0,pB=0,qB=0,rB=0,sB=0,tB=0,uB=0,vB=0,wB=0,xB=0,yB=0,zB=0,AB=0,BB=0,CB=0,DB=0,EB=0,FB=0,GB=0,HB=0,IB=0,JB=0,KB=0,LB=0,MB=0,NB=0,OB=0,PB=0,QB=0,RB=0,SB=0,TB=0,UB=0,VB=0,WB=0,XB=0,YB=0,ZB=0,_B=0,$B=0,aC=0,bC=0,cC=0,dC=0,eC=0,fC=0,gC=0,hC=0,iC=0,jC=0,kC=0,lC=0,mC=0,nC=0,oC=0,pC=0,qC=0,rC=0,sC=0,tC=0,uC=0,vC=0,wC=0,xC=0,yC=0,zC=0,AC=0,BC=0,CC=0,DC=0,EC=0,FC=0,GC=0,HC=0,IC=0,JC=0,KC=0,LC=0,MC=0,NC=0,OC=0,PC=0,QC=0,RC=0,SC=0,TC=0,UC=0,VC=0;d=u;u=u+1968|0;e=d+504|0;g=d+224|0;h=d;i=d+1616|0;j=d+1188|0;k=d+1176|0;l=d+1164|0;m=d+1152|0;o=d+1140|0;q=d+1064|0;r=d+1056|0;s=d+1048|0;t=d+1008|0;v=d+952|0;w=d+896|0;x=d+840|0;y=d+1956|0;z=d+784|0;A=d+1944|0;B=d+1932|0;C=d+1920|0;D=d+1908|0;E=d+1888|0;F=d+1868|0;G=d+1848|0;H=d+1836|0;I=d+1824|0;J=d+1812|0;K=d+1800|0;L=d+280|0;M=d+1780|0;N=d+1760|0;O=d+1740|0;P=d+1728|0;Q=d+1720|0;R=d+1712|0;S=d+1696|0;T=d+1684|0;U=d+1672|0;V=d+1604|0;W=d+1592|0;X=d+1580|0;Z=d+1568|0;_=d+1556|0;$=d+1544|0;aa=d+1536|0;ba=d+1520|0;ca=d+1508|0;da=d+1496|0;ea=d+1484|0;fa=d+1472|0;ga=d+1460|0;ha=d+1448|0;ia=d+1392|0;ja=d+1336|0;ka=d+728|0;la=d+1320|0;ma=d+1308|0;na=d+1296|0;oa=d+1284|0;pa=d+1272|0;qa=d+1260|0;ra=d+1248|0;sa=d+1240|0;ta=d+1224|0;ua=d+1212|0;va=d+1200|0;Lob(a);wa=a+40|0;Lob(wa);if(!(_i[f[(f[wa>>2]|0)+48>>2]&1023](wa)|0))onb(a);xa=j+4|0;f[xa>>2]=0;ya=j+8|0;f[ya>>2]=0;za=j+4|0;f[j>>2]=za;Aa=(_i[f[(f[wa>>2]|0)+48>>2]&1023](wa)|0)!=0;Ba=Aa?wa:a;Aa=f[Ba+12>>2]|0;f[k+4>>2]=0;f[k+8>>2]=0;Ca=k+4|0;f[k>>2]=Ca;Da=(Aa|0)>0;if(Da){Ea=Ba+20|0;Fa=g+4|0;Ga=e+11|0;Ha=e+4|0;Ia=g+4|0;Ja=g+11|0;Ka=g+4|0;La=g+4|0;Ma=Aa;do{Na=Ma;Ma=Ma+-1|0;Oa=f[(f[Ea>>2]|0)+4+(Ma<<2)>>2]|0;fEc(e,f[Oa+60>>2]|0);Pa=TIa(Oa)|0;f[g>>2]=0;f[Fa>>2]=0;Qa=b[Ga>>0]|0;Ra=Qa<<24>>24<0?f[Ha>>2]|0:Qa&255;if(Ra|0){Qa=tT(g,Ra)|0;dJc(Qa|0,((b[Ga>>0]|0)<0?f[e>>2]|0:e)|0,Ra|0)|0}Ra=f[Ca>>2]|0;if(Ra){Qa=f[g>>2]|0;Sa=(Qa|0)==0?1154740:Qa;Ta=Ca;Ua=Ra;a:while(1){Ra=Ua;while(1){Va=f[Ra+16>>2]|0;if((Va|0)==(Qa|0))break;if((Ioc((Va|0)==0?1154740:Va,Sa)|0)>=0)break;Va=f[Ra+4>>2]|0;if(!Va){Wa=Ta;break a}else Ra=Va}Ua=f[Ra>>2]|0;if(!Ua){Wa=Ra;break}else Ta=Ra}if((Wa|0)!=(Ca|0)){Ta=f[Wa+16>>2]|0;if((Qa|0)!=(Ta|0)?(Ioc(Sa,(Ta|0)==0?1154740:Ta)|0)<0:0)Xa=17;else Ya=Wa}else Xa=17}else Xa=17;if((Xa|0)==17){Xa=0;Ya=Ca}uT(g);do if((Ya|0)!=(Ca|0)){Ta=Ya+24|0;Ua=f[Ta>>2]|0;if((Pa|0)!=2){if((Ua|0)==2){f[Ta>>2]=Pa;Za=Pa;break}if((Ua|0)==(Pa|0))Za=Pa;else{f[Ta>>2]=2;Za=2}}else Za=Ua}else{f[g>>2]=0;f[Ia>>2]=0;Ua=b[Ga>>0]|0;Ta=Ua<<24>>24<0?f[Ha>>2]|0:Ua&255;if(Ta|0){Ua=tT(g,Ta)|0;dJc(Ua|0,((b[Ga>>0]|0)<0?f[e>>2]|0:e)|0,Ta|0)|0}Ta=HHa(k,g)|0;f[Ta>>2]=Pa;uT(g);Za=Pa}while(0);Pa=Oa+12|0;if((f[Pa>>2]|0)>0){Sa=Oa+20|0;Qa=(Za|0)==2;Ta=0;do{Ua=f[(f[Sa>>2]|0)+4+(Ta<<2)>>2]|0;gEc(g,Ua,0,DEc(Ua,58,-1)|0,Ua);iEc(e,g)|0;if((b[Ja>>0]|0)<0)YDc(f[g>>2]|0);f[g>>2]=0;f[Ka>>2]=0;Ua=b[Ga>>0]|0;Va=Ua<<24>>24<0?f[Ha>>2]|0:Ua&255;if(Va|0){Ua=tT(g,Va)|0;dJc(Ua|0,((b[Ga>>0]|0)<0?f[e>>2]|0:e)|0,Va|0)|0}Va=f[Ca>>2]|0;if(Va){Ua=f[g>>2]|0;_a=(Ua|0)==0?1154740:Ua;$a=Ca;ab=Va;b:while(1){Va=ab;while(1){bb=f[Va+16>>2]|0;if((bb|0)==(Ua|0))break;if((Ioc((bb|0)==0?1154740:bb,_a)|0)>=0)break;bb=f[Va+4>>2]|0;if(!bb){cb=$a;break b}else Va=bb}ab=f[Va>>2]|0;if(!ab){cb=Va;break}else $a=Va}if((cb|0)!=(Ca|0)){$a=f[cb+16>>2]|0;if((Ua|0)!=($a|0)?(Ioc(_a,($a|0)==0?1154740:$a)|0)<0:0)Xa=46;else db=cb}else Xa=46}else Xa=46;if((Xa|0)==46){Xa=0;db=Ca}uT(g);do if((db|0)!=(Ca|0)){if(!Qa){$a=db+24|0;ab=f[$a>>2]|0;if((ab|0)==2){f[$a>>2]=Za;break}if((ab|0)!=(Za|0))f[$a>>2]=2}}else{f[g>>2]=0;f[La>>2]=0;$a=b[Ga>>0]|0;ab=$a<<24>>24<0?f[Ha>>2]|0:$a&255;if(ab|0){$a=tT(g,ab)|0;dJc($a|0,((b[Ga>>0]|0)<0?f[e>>2]|0:e)|0,ab|0)|0}ab=HHa(k,g)|0;f[ab>>2]=Za;uT(g)}while(0);Ta=Ta+1|0}while((Ta|0)<(f[Pa>>2]|0))}if((b[Ga>>0]|0)<0)YDc(f[e>>2]|0)}while((Na|0)>1)}f[l+4>>2]=0;f[l+8>>2]=0;Ga=l+4|0;f[l>>2]=Ga;f[m+4>>2]=0;f[m+8>>2]=0;Za=m+4|0;f[m>>2]=Za;UIa(a,l,j);UIa(wa,l,j);f[o+4>>2]=0;f[o+8>>2]=0;wa=o+4|0;f[o>>2]=wa;if(!Da){eb=a+80|0;zHa(c,eb);fb=f[wa>>2]|0;CFa(o,fb);gb=f[Za>>2]|0;qJa(m,gb);hb=f[Ga>>2]|0;CFa(l,hb);ib=f[Ca>>2]|0;CFa(k,ib);jb=f[za>>2]|0;rJa(j,jb);u=d;return}Da=Ba+20|0;Ha=q+60|0;La=r+4|0;db=q+64|0;cb=s+4|0;Ka=t+4|0;Ja=t+8|0;Ia=t+4|0;Ya=t+12|0;Wa=q+12|0;Fa=q+20|0;Ma=e+4|0;Ea=g+11|0;Pa=g+4|0;Ta=e+4|0;Qa=w+4|0;Sa=w+8|0;Oa=g+4|0;_a=e+4|0;Ua=g+4|0;ab=e+4|0;$a=y+4|0;Ra=y+8|0;bb=y+4|0;kb=e+4|0;lb=e+8|0;mb=g+16|0;nb=g+4|0;ob=g+8|0;pb=g+12|0;qb=x+4|0;rb=g+36|0;sb=g+40|0;tb=g+44|0;ub=g+48|0;vb=x+4|0;wb=e+4|0;xb=e+4|0;yb=z+4|0;zb=z+8|0;Ab=z+40|0;Bb=z+48|0;Cb=z+44|0;Db=z+52|0;Eb=A+4|0;Fb=A+8|0;Gb=A+4|0;Hb=e+4|0;Ib=e+8|0;Jb=g+4|0;Kb=g+8|0;Lb=g+12|0;Mb=z+12|0;Nb=z+16|0;Ob=g+16|0;Pb=g+36|0;Qb=g+40|0;Rb=g+44|0;Sb=g+48|0;Tb=e+4|0;Ub=e+4|0;Vb=z+36|0;Wb=Gb;Xb=bb;Yb=h+8|0;Zb=h+4|0;_b=q+24|0;$b=q+48|0;ac=g+8|0;bc=h+11|0;cc=e+4|0;dc=t+12|0;ec=g+4|0;fc=e+4|0;gc=e+4|0;hc=C+4|0;ic=C+8|0;jc=C+4|0;kc=jc;lc=D+4|0;mc=D+8|0;nc=D+4|0;oc=g+4|0;pc=h+4|0;qc=h+8|0;rc=h+40|0;sc=h+48|0;tc=h+44|0;uc=h+52|0;vc=e+8|0;wc=e+4|0;xc=h+16|0;yc=h+36|0;zc=E+4|0;Ac=e+4|0;Bc=e+44|0;Cc=E+8|0;Dc=E+12|0;Ec=E+16|0;Fc=F+4|0;Gc=F+8|0;Hc=F+12|0;Ic=F+16|0;Jc=e+8|0;Kc=e+12|0;Lc=G+4|0;Mc=h+4|0;Nc=h+44|0;Oc=G+8|0;Pc=G+12|0;Qc=G+16|0;Rc=h+36|0;Sc=h+16|0;Tc=h+40|0;Uc=h+48|0;Vc=e+36|0;Wc=e+16|0;Xc=e+40|0;Yc=e+48|0;Zc=h+8|0;_c=h+12|0;$c=e+4|0;ad=e+4|0;bd=e+4|0;cd=e+4|0;dd=h+4|0;ed=h+4|0;fd=e+4|0;gd=e+4|0;hd=e+11|0;id=e+11|0;jd=e+8|0;kd=e+4|0;ld=nc;md=e+8|0;nd=e+4|0;od=e+11|0;pd=v+11|0;qd=B+4|0;rd=B+8|0;sd=B+4|0;td=x+4|0;ud=x+8|0;vd=x+12|0;wd=x+16|0;xd=x+40|0;yd=x+44|0;zd=e+4|0;Ad=g+4|0;Bd=e+4|0;Cd=e+11|0;Dd=x+36|0;Ed=x+48|0;Fd=e+4|0;Gd=e+4|0;Hd=sd;Id=g+4|0;Jd=e+11|0;Kd=e+4|0;Ld=H+4|0;Md=H+8|0;Nd=H+4|0;Od=v+4|0;Pd=v+8|0;Qd=v+12|0;Rd=e+4|0;Sd=v+16|0;Td=e+4|0;Ud=e+11|0;Vd=v+36|0;Wd=v+40|0;Xd=v+44|0;Yd=v+48|0;Zd=e+4|0;_d=Nd;$d=e+4|0;ae=e+4|0;be=g+4|0;ce=e+11|0;de=e+4|0;ee=g+4|0;fe=e+11|0;ge=e+4|0;he=I+4|0;ie=I+8|0;je=I+4|0;ke=e+8|0;le=e+4|0;me=v+4|0;ne=v+8|0;oe=v+12|0;pe=e+4|0;qe=v+16|0;re=e+4|0;se=e+11|0;te=v+36|0;ue=v+40|0;ve=v+44|0;we=v+48|0;xe=e+4|0;ye=je;ze=h+8|0;Ae=h+4|0;Be=g+8|0;Ce=h+11|0;De=e+4|0;Ee=e+4|0;Fe=v+4|0;Ge=g+4|0;He=e+4|0;Ie=e+4|0;Je=J+4|0;Ke=J+8|0;Le=J+4|0;Me=Le;Ne=K+4|0;Oe=K+8|0;Pe=K+4|0;Qe=g+4|0;Re=g+8|0;Se=g+40|0;Te=g+48|0;Ue=g+44|0;Ve=g+52|0;We=h+4|0;Xe=h+8|0;Ye=h+40|0;Ze=h+48|0;_e=h+44|0;$e=h+52|0;af=e+8|0;bf=e+4|0;cf=h+36|0;df=h+16|0;ef=g+36|0;ff=g+16|0;gf=h+12|0;hf=h+20|0;jf=h+24|0;kf=h+28|0;lf=h+32|0;mf=e+4|0;nf=e+4|0;of=g+4|0;pf=e+4|0;qf=g+4|0;rf=M+4|0;sf=h+4|0;tf=h+44|0;uf=M+8|0;vf=M+12|0;wf=M+16|0;xf=N+4|0;yf=N+8|0;zf=N+12|0;Af=N+16|0;Bf=h+8|0;Cf=h+12|0;Df=O+4|0;Ef=i+4|0;Ff=i+44|0;Gf=O+8|0;Hf=O+12|0;If=O+16|0;Jf=i+36|0;Kf=i+16|0;Lf=i+40|0;Mf=i+48|0;Nf=h+36|0;Of=h+16|0;Pf=h+40|0;Qf=h+48|0;Rf=i+8|0;Sf=i+12|0;Tf=e+4|0;Uf=e+11|0;Vf=Pe;Wf=e+8|0;Xf=e+4|0;Yf=e+11|0;Zf=e+4|0;_f=e+4|0;$f=e+11|0;ag=v+11|0;bg=P+4|0;cg=P+8|0;dg=P+4|0;eg=w+4|0;fg=w+8|0;gg=w+12|0;hg=e+4|0;ig=e+8|0;jg=e+4|0;kg=e+12|0;lg=g+4|0;mg=h+4|0;ng=Q+4|0;og=g+11|0;pg=h+4|0;qg=g+4|0;rg=h+4|0;sg=i+4|0;tg=h+4|0;ug=h+12|0;vg=v+12|0;wg=h+11|0;xg=g+8|0;yg=e+4|0;zg=w+16|0;Ag=w+44|0;Bg=g+4|0;Cg=e+4|0;Dg=w+36|0;Eg=w+40|0;Fg=w+48|0;Gg=dg;Hg=i+8|0;Ig=i+4|0;Jg=g+8|0;Kg=i+11|0;Lg=e+8|0;Mg=e+4|0;Ng=e+11|0;Og=e+4|0;Pg=e+8|0;Qg=e+4|0;Rg=e+12|0;Sg=g+4|0;Tg=i+4|0;Ug=R+4|0;Vg=g+11|0;Wg=i+4|0;Xg=g+4|0;Yg=i+4|0;Zg=v+4|0;_g=i+4|0;$g=i+12|0;ah=h+12|0;bh=i+11|0;ch=g+8|0;dh=e+4|0;eh=h+11|0;fh=S+4|0;gh=S+8|0;hh=S+4|0;ih=v+16|0;jh=v+4|0;kh=v+8|0;lh=v+12|0;mh=e+4|0;nh=e+11|0;oh=v+36|0;ph=v+40|0;qh=v+44|0;rh=v+48|0;sh=e+4|0;th=g+4|0;uh=e+4|0;vh=e+11|0;wh=hh;xh=h+11|0;yh=h+5|0;zh=g+8|0;Ah=h+11|0;Bh=h+4|0;Ch=g+8|0;Dh=h+8|0;Eh=h+4|0;Fh=g+8|0;Gh=h+11|0;Hh=h+11|0;Ih=h+4|0;Jh=g+8|0;Kh=e+4|0;Lh=e+4|0;Mh=e+11|0;Nh=e+4|0;Oh=h+11|0;Ph=h+4|0;Qh=e+8|0;Rh=e+4|0;Sh=e+11|0;Th=e+4|0;Uh=e+4|0;Vh=h+11|0;Wh=h+4|0;Xh=e+4|0;Yh=h+11|0;Zh=h+5|0;_h=T+4|0;$h=T+8|0;ai=T+4|0;bi=e+11|0;ci=e+4|0;di=e+4|0;fi=g+4|0;gi=e+11|0;hi=e+4|0;ii=e+8|0;ji=e+4|0;ki=ai;li=e+4|0;mi=e+4|0;ni=e+11|0;oi=e+4|0;pi=e+4|0;qi=e+4|0;ri=e+11|0;si=h+11|0;ti=h+5|0;ui=g+8|0;vi=a+84|0;wi=a+88|0;xi=a+80|0;yi=e+11|0;zi=e+5|0;Ai=U+4|0;Bi=U+8|0;Ci=U+4|0;Di=g+4|0;Ei=e+4|0;Fi=e+11|0;Gi=Ci;Hi=V+4|0;Ii=V+8|0;Ji=V+4|0;Ki=W+4|0;Li=W+8|0;Mi=W+4|0;Ni=v+16|0;Oi=v+4|0;Pi=v+8|0;Qi=v+12|0;Ri=w+16|0;Si=w+4|0;Ti=w+8|0;Ui=w+12|0;Vi=e+11|0;Wi=v+44|0;Xi=w+44|0;Yi=e+8|0;Zi=e+4|0;$i=e+4|0;aj=g+4|0;bj=e+4|0;cj=g+4|0;dj=e+4|0;ej=e+11|0;fj=w+36|0;gj=w+40|0;hj=w+48|0;ij=v+36|0;jj=v+40|0;kj=v+48|0;lj=Mi;mj=Ji;nj=g+4|0;oj=e+11|0;pj=e+4|0;qj=X+4|0;rj=X+8|0;sj=X+4|0;tj=v+4|0;uj=v+8|0;vj=v+12|0;wj=g+4|0;xj=e+4|0;yj=g+4|0;zj=v+16|0;Aj=g+4|0;Bj=g+4|0;Cj=g+4|0;Dj=g+4|0;Ej=g+4|0;Fj=e+11|0;Gj=e+4|0;Hj=g+11|0;Ij=v+36|0;Jj=v+40|0;Kj=v+44|0;Lj=v+48|0;Mj=g+11|0;Nj=e+4|0;Oj=w+4|0;Pj=h+11|0;Qj=h+4|0;Rj=g+8|0;Sj=e+4|0;Tj=e+4|0;Uj=h+11|0;Wj=h+4|0;Xj=e+4|0;Yj=Z+4|0;Zj=Z+8|0;_j=Z+4|0;ak=t+16|0;bk=_j;ck=sj;dk=e+4|0;ek=e+4|0;fk=g+4|0;gk=e+11|0;hk=e+4|0;ik=h+8|0;jk=h+4|0;kk=g+8|0;lk=h+11|0;mk=_+4|0;nk=_+8|0;ok=_+4|0;pk=e+4|0;qk=$+4|0;rk=$+8|0;sk=$+4|0;tk=e+4|0;uk=w+4|0;vk=w+8|0;wk=w+40|0;xk=w+48|0;yk=w+44|0;zk=w+52|0;Ak=x+4|0;Bk=x+8|0;Ck=x+40|0;Dk=x+48|0;Ek=x+44|0;Fk=x+52|0;Gk=e+4|0;Hk=e+8|0;Ik=e+4|0;Jk=e+12|0;Kk=aa+4|0;Lk=g+11|0;Mk=h+4|0;Nk=g+4|0;Ok=h+4|0;Pk=i+4|0;Qk=h+4|0;Rk=h+12|0;Sk=v+12|0;Tk=h+11|0;Uk=g+8|0;Vk=h+11|0;Wk=h+7|0;Xk=g+8|0;Yk=e+4|0;Zk=x+36|0;_k=x+16|0;$k=w+36|0;al=w+16|0;bl=v+11|0;cl=e+4|0;dl=h+11|0;el=h+7|0;fl=x+12|0;gl=x+20|0;hl=x+24|0;il=x+28|0;jl=x+32|0;kl=w+12|0;ll=w+20|0;ml=w+24|0;nl=w+28|0;ol=w+32|0;pl=ba+4|0;ql=ba+8|0;rl=ba+4|0;sl=ca+4|0;tl=ca+8|0;ul=ca+4|0;vl=ul;wl=rl;xl=e+4|0;yl=sk;zl=e+4|0;Al=ok;Bl=e+8|0;Cl=e+4|0;Dl=e+11|0;El=e+4|0;Fl=e+4|0;Gl=v+4|0;Hl=e+4|0;Il=da+4|0;Jl=da+8|0;Kl=da+4|0;Ll=Kl;Ml=ea+4|0;Nl=ea+8|0;Ol=ea+4|0;Pl=e+4|0;Ql=e+4|0;Rl=e+4|0;Sl=e+4|0;Tl=e+4|0;Ul=fa+4|0;Vl=fa+8|0;Wl=fa+4|0;Xl=z+16|0;Yl=z+40|0;Zl=z+44|0;_l=z+12|0;$l=g+4|0;am=e+4|0;bm=e+4|0;cm=e+4|0;dm=e+11|0;em=z+36|0;fm=z+4|0;gm=z+48|0;hm=g+4|0;im=e+4|0;jm=e+4|0;km=Wl;lm=Ol;mm=h+8|0;nm=h+4|0;om=g+8|0;pm=h+11|0;qm=h+8|0;rm=h+4|0;sm=g+8|0;tm=h+11|0;um=v+4|0;vm=v+8|0;wm=v+40|0;xm=v+48|0;ym=v+44|0;zm=v+52|0;Am=w+4|0;Bm=w+8|0;Cm=w+40|0;Dm=w+48|0;Em=w+44|0;Fm=w+52|0;Gm=x+4|0;Hm=x+8|0;Im=x+40|0;Jm=x+48|0;Km=x+44|0;Lm=x+52|0;Mm=z+4|0;Nm=z+8|0;Om=z+40|0;Pm=z+48|0;Qm=z+44|0;Rm=z+52|0;Sm=ga+4|0;Tm=ga+8|0;Um=ga+4|0;Vm=ha+4|0;Wm=ha+8|0;Xm=ha+4|0;Ym=v+12|0;Zm=v+16|0;_m=e+4|0;$m=g+4|0;an=ia+36|0;bn=ia+16|0;cn=ia+4|0;dn=ia+40|0;en=ia+44|0;fn=ia+48|0;gn=e+4|0;hn=g+4|0;jn=ja+36|0;kn=ja+16|0;ln=ja+4|0;mn=ja+40|0;nn=ja+44|0;on=ja+48|0;pn=h+8|0;qn=h+4|0;rn=g+8|0;sn=h+11|0;tn=e+4|0;un=e+11|0;vn=z+36|0;wn=z+16|0;xn=x+36|0;yn=x+16|0;zn=w+36|0;An=w+16|0;Bn=v+36|0;Cn=e+8|0;Dn=e+4|0;En=e+11|0;Fn=e+4|0;Gn=ka+4|0;Hn=ka+8|0;In=ka+40|0;Jn=ka+48|0;Kn=ka+44|0;Ln=ka+52|0;Mn=la+4|0;Nn=la+8|0;On=la+4|0;Pn=ka+12|0;Qn=e+36|0;Rn=ka+36|0;Sn=ka+16|0;Tn=e+4|0;Un=e+8|0;Vn=e+12|0;Wn=e+44|0;Xn=e+16|0;Yn=e+20|0;Zn=ka+20|0;_n=e+24|0;$n=ka+24|0;ao=e+28|0;bo=ka+28|0;co=e+32|0;eo=ka+32|0;fo=e+40|0;go=e+48|0;ho=e+36|0;io=e+4|0;jo=e+8|0;ko=e+12|0;lo=e+44|0;mo=e+16|0;no=e+20|0;oo=e+24|0;po=e+28|0;qo=e+32|0;ro=e+40|0;so=e+48|0;to=On;uo=z+12|0;vo=z+20|0;wo=z+24|0;xo=z+28|0;yo=z+32|0;zo=x+12|0;Ao=x+20|0;Bo=x+24|0;Co=x+28|0;Do=x+32|0;Eo=w+12|0;Fo=w+20|0;Go=w+24|0;Ho=w+28|0;Io=w+32|0;Jo=Xm;Ko=Um;Lo=g+11|0;Mo=g+9|0;No=g+4|0;Oo=g+4|0;Po=e+4|0;Qo=h+8|0;Ro=h+4|0;So=h+11|0;To=ma+4|0;Uo=ma+8|0;Vo=ma+4|0;Wo=v+4|0;Xo=v+8|0;Yo=v+12|0;Zo=e+4|0;_o=v+16|0;$o=v+44|0;ap=e+4|0;bp=v+36|0;cp=v+40|0;dp=v+48|0;ep=Vo;fp=e+4|0;gp=h+8|0;hp=h+4|0;ip=g+8|0;jp=h+11|0;kp=e+4|0;lp=e+11|0;mp=e+4|0;np=h+8|0;op=h+4|0;pp=h+11|0;qp=e+4|0;rp=na+4|0;sp=na+8|0;tp=na+4|0;up=oa+4|0;vp=oa+8|0;wp=oa+4|0;xp=v+4|0;yp=v+8|0;zp=v+12|0;Ap=w+4|0;Bp=w+8|0;Cp=w+12|0;Dp=e+4|0;Ep=w+16|0;Fp=e+4|0;Gp=v+16|0;Hp=w+36|0;Ip=w+40|0;Jp=w+44|0;Kp=w+48|0;Lp=v+36|0;Mp=v+40|0;Np=v+44|0;Op=v+48|0;Pp=wp;Qp=tp;Rp=pa+4|0;Sp=pa+8|0;Tp=pa+4|0;Up=v+4|0;Vp=v+8|0;Wp=v+12|0;Xp=e+11|0;Yp=v+16|0;Zp=v+40|0;_p=v+44|0;$p=e+8|0;aq=e+12|0;bq=e+4|0;cq=g+8|0;dq=g+4|0;eq=e+4|0;fq=e+4|0;gq=e+4|0;hq=e+11|0;iq=v+36|0;jq=v+48|0;kq=e+8|0;lq=e+4|0;mq=Tp;nq=h+11|0;oq=h+8|0;pq=g+8|0;qq=h+11|0;rq=h+8|0;sq=g+8|0;tq=h+11|0;uq=h+4|0;vq=g+8|0;wq=h+11|0;xq=h+4|0;yq=g+8|0;zq=h+11|0;Aq=h+6|0;Bq=g+8|0;Cq=h+11|0;Dq=h+4|0;Eq=g+8|0;Fq=h+11|0;Gq=h+8|0;Hq=h+12|0;Iq=h+20|0;Jq=h+16|0;Kq=h+24|0;Lq=Kq+11|0;Mq=Kq+6|0;Nq=h+36|0;Oq=Nq+11|0;Pq=Nq+5|0;Qq=h+48|0;Rq=Qq+11|0;Sq=Qq+6|0;Tq=g+8|0;Uq=g+4|0;Vq=e+16|0;Wq=e+4|0;Xq=e+8|0;Yq=e+12|0;Zq=i+4|0;_q=e+36|0;$q=e+40|0;ar=e+44|0;br=e+48|0;cr=e+4|0;dr=e+11|0;er=e+11|0;fr=e+4|0;gr=h+11|0;hr=h+4|0;ir=e+4|0;jr=h+11|0;kr=h+6|0;lr=e+4|0;mr=h+11|0;nr=h+4|0;or=e+4|0;pr=h+11|0;qr=h+4|0;rr=e+4|0;sr=h+11|0;tr=h+8|0;ur=e+4|0;vr=h+11|0;wr=h+8|0;xr=h+11|0;yr=h+4|0;zr=g+8|0;Ar=e+4|0;Br=e+11|0;Cr=e+4|0;Dr=h+11|0;Er=h+4|0;Fr=qa+4|0;Gr=qa+8|0;Hr=qa+4|0;Ir=v+4|0;Jr=v+8|0;Kr=v+12|0;Lr=e+4|0;Mr=v+16|0;Nr=e+4|0;Or=v+40|0;Pr=v+44|0;Qr=e+4|0;Rr=e+11|0;Sr=e+11|0;Tr=v+36|0;Ur=v+48|0;Vr=Hr;Wr=ra+4|0;Xr=ra+8|0;Yr=ra+4|0;Zr=v+4|0;_r=v+8|0;$r=v+12|0;as=v+16|0;bs=v+40|0;cs=v+44|0;ds=e+4|0;es=e+4|0;fs=e+4|0;gs=e+11|0;hs=h+11|0;is=h+8|0;js=g+8|0;ks=h+11|0;ls=h+9|0;ms=g+8|0;ns=e+11|0;os=e+9|0;ps=e+4|0;qs=e+8|0;rs=e+4|0;ss=e+12|0;ts=sa+4|0;us=g+11|0;vs=h+4|0;ws=g+4|0;xs=h+4|0;ys=i+4|0;zs=h+4|0;As=i+11|0;Bs=h+12|0;Cs=h+11|0;Ds=i+8|0;Es=i+4|0;Fs=g+8|0;Gs=v+36|0;Hs=v+48|0;Is=e+11|0;Js=e+8|0;Ks=Yr;Ls=ta+4|0;Ms=ta+8|0;Ns=ta+4|0;Os=ua+4|0;Ps=ua+8|0;Qs=ua+4|0;Rs=v+4|0;Ss=v+8|0;Ts=v+12|0;Us=w+4|0;Vs=w+8|0;Ws=w+12|0;Xs=e+4|0;Ys=v+16|0;Zs=e+4|0;_s=w+16|0;$s=e+4|0;at=e+11|0;bt=w+36|0;ct=w+40|0;dt=w+44|0;et=w+48|0;ft=v+36|0;gt=v+40|0;ht=v+44|0;it=v+48|0;jt=Qs;kt=Ns;lt=e+11|0;mt=g+4|0;nt=e+4|0;ot=g+11|0;pt=e+8|0;qt=v+8|0;rt=e+4|0;st=e+8|0;tt=g+4|0;ut=g+4|0;vt=g+4|0;wt=g+4|0;xt=w+4|0;yt=w+8|0;zt=e+4|0;At=w+8|0;Bt=va+4|0;Ct=va+8|0;Dt=va+4|0;Et=t+20|0;Ft=x+36|0;Gt=x+16|0;Ht=x+4|0;It=x+40|0;Jt=x+44|0;Kt=x+48|0;Lt=x+8|0;Mt=x+12|0;Nt=x+20|0;Ot=x+24|0;Pt=x+28|0;Qt=x+32|0;Rt=Dt;St=e+11|0;Tt=h+8|0;Ut=h+8|0;Vt=h+48|0;Wt=Vt+11|0;Xt=h+36|0;Yt=Xt+11|0;Zt=h+24|0;_t=Zt+11|0;$t=h+12|0;au=$t+11|0;bu=h+11|0;cu=0;c:while(1){eRa(q,f[(f[Da>>2]|0)+4+(cu<<2)>>2]|0);du=f[Ha>>2]|0;f[r>>2]=0;f[La>>2]=0;eu=du+11|0;fu=b[eu>>0]|0;gu=fu<<24>>24<0?f[du+4>>2]|0:fu&255;if(gu|0){fu=tT(r,gu)|0;dJc(fu|0,((b[eu>>0]|0)<0?f[du>>2]|0:du)|0,gu|0)|0}gu=f[db>>2]|0;f[s>>2]=0;f[cb>>2]=0;du=gu+11|0;eu=b[du>>0]|0;fu=eu<<24>>24<0?f[gu+4>>2]|0:eu&255;if(fu|0){eu=tT(s,fu)|0;dJc(eu|0,((b[du>>0]|0)<0?f[gu>>2]|0:gu)|0,fu|0)|0}f[Ka>>2]=0;f[Ja>>2]=0;f[t>>2]=Ia;f[Ya>>2]=0;f[Ya+4>>2]=0;f[Ya+8>>2]=0;f[Ya+12>>2]=0;f[Ya+16>>2]=0;f[Ya+20>>2]=0;f[Ya+24>>2]=0;fu=f[za>>2]|0;if(fu){gu=f[r>>2]|0;du=(gu|0)==0?1154740:gu;eu=za;hu=fu;d:while(1){fu=hu;while(1){iu=f[fu+16>>2]|0;if((iu|0)==(gu|0))break;if((Ioc((iu|0)==0?1154740:iu,du)|0)>=0)break;iu=f[fu+4>>2]|0;if(!iu){ju=eu;break d}else fu=iu}hu=f[fu>>2]|0;if(!hu){ju=fu;break}else eu=fu}if((ju|0)!=(za|0)){eu=f[ju+16>>2]|0;if((gu|0)!=(eu|0)?(Ioc(du,(eu|0)==0?1154740:eu)|0)<=-1:0)Xa=75}else Xa=75}else Xa=75;e:do if((Xa|0)==75){Xa=0;eu=TIa(q)|0;f:do if((eu|0)==2){hu=f[Wa>>2]|0;if((hu|0)>0){Na=2;iu=0;while(1){ku=f[(f[Fa>>2]|0)+4+(iu<<2)>>2]|0;gEc(g,ku,0,DEc(ku,58,-1)|0,ku);f[e>>2]=0;f[Ma>>2]=0;ku=b[Ea>>0]|0;lu=ku<<24>>24<0?f[Pa>>2]|0:ku&255;if(lu|0){ku=tT(e,lu)|0;dJc(ku|0,((b[Ea>>0]|0)<0?f[g>>2]|0:g)|0,lu|0)|0}lu=f[Ca>>2]|0;if(lu){ku=f[e>>2]|0;mu=(ku|0)==0?1154740:ku;nu=Ca;ou=lu;g:while(1){lu=ou;while(1){pu=f[lu+16>>2]|0;if((pu|0)==(ku|0))break;if((Ioc((pu|0)==0?1154740:pu,mu)|0)>=0)break;pu=f[lu+4>>2]|0;if(!pu){qu=nu;break g}else lu=pu}ou=f[lu>>2]|0;if(!ou){qu=lu;break}else nu=lu}if((qu|0)!=(Ca|0)){nu=f[qu+16>>2]|0;if((ku|0)!=(nu|0)?(Ioc(mu,(nu|0)==0?1154740:nu)|0)<0:0)Xa=89;else ru=qu}else Xa=89}else Xa=89;if((Xa|0)==89){Xa=0;ru=Ca}uT(e);if((b[Ea>>0]|0)<0)YDc(f[g>>2]|0);if((ru|0)!=(Ca|0)){nu=f[ru+24>>2]|0;if((Na|0)!=2)if((nu|0)==(Na|0)|(nu|0)==2)su=Na;else{tu=2;break f}else su=nu}else su=Na;iu=iu+1|0;if((iu|0)>=(hu|0))break;else Na=su}if((su|0)!=2){tu=su;break}}Na=f[Ha>>2]|0;f[e>>2]=0;f[Ta>>2]=0;hu=Na+11|0;iu=b[hu>>0]|0;Va=iu<<24>>24<0?f[Na+4>>2]|0:iu&255;if(Va|0){iu=tT(e,Va)|0;dJc(iu|0,((b[hu>>0]|0)<0?f[Na>>2]|0:Na)|0,Va|0)|0}Va=f[Ca>>2]|0;if(Va){Na=f[e>>2]|0;hu=(Na|0)==0?1154740:Na;iu=Ca;nu=Va;h:while(1){Va=nu;while(1){ou=f[Va+16>>2]|0;if((ou|0)==(Na|0))break;if((Ioc((ou|0)==0?1154740:ou,hu)|0)>=0)break;ou=f[Va+4>>2]|0;if(!ou){uu=iu;break h}else Va=ou}nu=f[Va>>2]|0;if(!nu){uu=Va;break}else iu=Va}if((uu|0)!=(Ca|0)){iu=f[uu+16>>2]|0;if((Na|0)!=(iu|0)?(Ioc(hu,(iu|0)==0?1154740:iu)|0)<0:0)Xa=109;else vu=uu}else Xa=109}else Xa=109;if((Xa|0)==109){Xa=0;vu=Ca}uT(e);if((vu|0)==(Ca|0)){Xa=111;break c}tu=f[vu+24>>2]|0}else tu=eu;while(0);eu=HHa(k,r)|0;f[eu>>2]=tu;eu=f[s>>2]|0;if(((((eu|0)!=383010?(fu=(eu|0)==0?1154740:eu,!((Ioc(fu,383010)|0)==0|(eu|0)==383017)):0)?!((Ioc(fu,383017)|0)==0|(eu|0)==383032):0)?!((Ioc(fu,383032)|0)==0|(eu|0)==383054):0)?Ioc(fu,383054)|0:0){if(((eu|0)!=383309?!((Ioc(fu,383309)|0)==0|(eu|0)==427390):0)?Ioc(fu,427390)|0:0){do if((eu|0)==428165)wu=0;else{if(!(Ioc(fu,428165)|0)){wu=0;break}do if((eu|0)!=383469){if(!(Ioc(fu,383469)|0))break;do if((eu|0)!=426093){if(!(Ioc(fu,426093)|0))break;do if((eu|0)!=428347){if((Ioc(fu,428347)|0)==0|(eu|0)==383548)break;if(!(Ioc(fu,383548)|0))break;do if((eu|0)!=383639){if(!(Ioc(fu,383639)|0))break;if((eu|0)==426101)break e;if(!(Ioc(fu,426101)|0))break e;do if((eu|0)!=425608){if(!(Ioc(fu,425608)|0))break;do if((eu|0)==454781)xu=0;else{do if(!(Ioc(fu,454781)|0))yu=fu;else{if((eu|0)==383731){yu=383731;break}if(!(Ioc(fu,383731)|0)){yu=fu;break}do if((eu|0)!=383768){if(!(Ioc(fu,383768)|0))break;do if((eu|0)!=383776){if(!(Ioc(fu,383776)|0))break;do if((eu|0)!=383784){if(!(Ioc(fu,383784)|0))break;do if((eu|0)!=425543){if(!(Ioc(fu,425543)|0))break;do if((eu|0)!=425537){if(!(Ioc(fu,425537)|0))break;do if((eu|0)!=426428){if(!(Ioc(fu,426428)|0))break;do if((eu|0)!=428681){if(!(Ioc(fu,428681)|0))break;do if((eu|0)!=427135){if(!(Ioc(fu,427135)|0))break;do if((eu|0)!=384109){if(!(Ioc(fu,384109)|0))break;do if((eu|0)!=426432){if((Ioc(fu,426432)|0)==0|(eu|0)==426942)break;if(!(Ioc(fu,426942)|0))break;do if((eu|0)!=427642){if(!(Ioc(fu,427642)|0))break;do if((eu|0)!=384373){if(!(Ioc(fu,384373)|0))break;do if((eu|0)!=454837){if(!(Ioc(fu,454837)|0))break;do if((eu|0)!=425556){if(!(Ioc(fu,425556)|0))break;do if((eu|0)!=384389){if(!(Ioc(fu,384389)|0))break;do if((eu|0)!=384519){if(!(Ioc(fu,384519)|0))break;do if((eu|0)!=384531){if((Ioc(fu,384531)|0)==0|(eu|0)==387164)break;if((Ioc(fu,387164)|0)==0|(eu|0)==425655)break;if((Ioc(fu,425655)|0)==0|(eu|0)==384535)break;if((Ioc(fu,384535)|0)==0|(eu|0)==384540)break;if((Ioc(fu,384540)|0)==0|(eu|0)==429288)break;if((Ioc(fu,429288)|0)==0|(eu|0)==427991)break;if(!(Ioc(fu,427991)|0))break;Wdc(_b);aJa(v,$b);iu=f[qt>>2]|0;nu=f[iu+12>>2]|0;mu=f[iu+4>>2]|0;i:do if(mu>>>0>nu>>>0){ku=f[iu+16>>2]|0;ou=nu;while(1){zu=f[ku+(ou<<2)>>2]|0;if(zu|0)break;pu=ou+1|0;if(pu>>>0<mu>>>0)ou=pu;else{Au=0;Bu=pu;break i}}if((zu|0)==(f[ku+((ou^1)<<2)>>2]|0)){Au=f[(f[zu>>2]|0)+16>>2]|0;Bu=ou;break}else{Au=zu;Bu=ou;break}}else{Au=0;Bu=nu}while(0);f[e>>2]=Au;f[rt>>2]=iu;f[st>>2]=Bu;if(Au|0){nu=Au;do{if((f[(f[nu+12>>2]|0)+36>>2]|0)==2){mu=f[nu+12>>2]|0;f[g>>2]=0;f[tt>>2]=0;pu=mu+11|0;Cu=b[pu>>0]|0;Du=Cu<<24>>24<0?f[mu+4>>2]|0:Cu&255;if(!Du)Eu=nu;else{Cu=tT(g,Du)|0;dJc(Cu|0,((b[pu>>0]|0)<0?f[mu>>2]|0:mu)|0,Du|0)|0;Eu=f[e>>2]|0}Du=f[Eu+12>>2]|0;if((f[Du+36>>2]|0)==2)Fu=f[Du+24>>2]|0;else Fu=527320;fIa(t,g,Fu)|0;uT(g);Gu=f[e>>2]|0}else Gu=nu;if((f[(f[Gu+12>>2]|0)+36>>2]|0)==3){Du=f[Gu+12>>2]|0;f[g>>2]=0;f[ut>>2]=0;mu=Du+11|0;pu=b[mu>>0]|0;Cu=pu<<24>>24<0?f[Du+4>>2]|0:pu&255;if(!Cu)Hu=Gu;else{pu=tT(g,Cu)|0;dJc(pu|0,((b[mu>>0]|0)<0?f[Du>>2]|0:Du)|0,Cu|0)|0;Hu=f[e>>2]|0}Cu=f[Hu+12>>2]|0;if((f[Cu+36>>2]|0)==3){Du=Cu+24|0;Iu=f[Du>>2]|0;Ju=f[Du+4>>2]|0}else{Iu=0;Ju=0}Du=h;f[Du>>2]=Iu;f[Du+4>>2]=Ju;mJa(t,g,h)|0;uT(g);Ku=f[e>>2]|0}else Ku=Gu;if((f[(f[Ku+12>>2]|0)+36>>2]|0)==4){Du=f[Ku+12>>2]|0;f[g>>2]=0;f[vt>>2]=0;Cu=Du+11|0;mu=b[Cu>>0]|0;pu=mu<<24>>24<0?f[Du+4>>2]|0:mu&255;if(!pu)Lu=Ku;else{mu=tT(g,pu)|0;dJc(mu|0,((b[Cu>>0]|0)<0?f[Du>>2]|0:Du)|0,pu|0)|0;Lu=f[e>>2]|0}pu=f[Lu+12>>2]|0;if((f[pu+36>>2]|0)==4)Mu=+n[pu+24>>2];else Mu=0.0;n[h>>2]=Mu;eIa(t,g,h)|0;uT(g);Nu=f[e>>2]|0}else Nu=Ku;if((f[(f[Nu+12>>2]|0)+36>>2]|0)==5){pu=f[Nu+12>>2]|0;f[g>>2]=0;f[wt>>2]=0;Du=pu+11|0;Cu=b[Du>>0]|0;mu=Cu<<24>>24<0?f[pu+4>>2]|0:Cu&255;if(!mu)Ou=Nu;else{Cu=tT(g,mu)|0;dJc(Cu|0,((b[Du>>0]|0)<0?f[pu>>2]|0:pu)|0,mu|0)|0;Ou=f[e>>2]|0}mu=f[Ou+12>>2]|0;if((f[mu+36>>2]|0)==5)Pu=(b[mu+24>>0]|0)!=0;else Pu=0;b[h>>0]=Pu&1;rIa(t,g,h)|0;uT(g)}pJa(e)|0;nu=f[e>>2]|0}while((nu|0)!=0)}f[w>>2]=0;f[xt>>2]=0;f[yt>>2]=0;if((f[Wa>>2]|0)>0){nu=0;do{iu=f[(f[Fa>>2]|0)+4+(nu<<2)>>2]|0;f[e>>2]=0;f[zt>>2]=0;mu=iu+11|0;pu=b[mu>>0]|0;Du=pu<<24>>24<0?f[iu+4>>2]|0:pu&255;if(Du|0){pu=tT(e,Du)|0;dJc(pu|0,((b[mu>>0]|0)<0?f[iu>>2]|0:iu)|0,Du|0)|0}Du=f[Ga>>2]|0;do if(Du){iu=f[e>>2]|0;mu=(iu|0)==0?1154740:iu;pu=Ga;Cu=Du;j:while(1){Qu=Cu;while(1){Ru=f[Qu+16>>2]|0;if((Ru|0)==(iu|0))break;if((Ioc((Ru|0)==0?1154740:Ru,mu)|0)>=0)break;Ru=f[Qu+4>>2]|0;if(!Ru){Su=pu;break j}else Qu=Ru}Cu=f[Qu>>2]|0;if(!Cu){Su=Qu;break}else pu=Qu}if((Su|0)==(Ga|0)){Xa=2711;break}pu=f[Su+16>>2]|0;if((iu|0)==(pu|0)){Tu=Su;break}if((Ioc(mu,(pu|0)==0?1154740:pu)|0)>=0)Tu=Su;else Xa=2711}else Xa=2711;while(0);if((Xa|0)==2711){Xa=0;Tu=Ga}uT(e);do if((Tu|0)==(Ga|0)){Du=f[(f[Fa>>2]|0)+4+(nu<<2)>>2]|0;ou=f[xt>>2]|0;if((ou|0)==(f[At>>2]|0)){e1(w,Du);break}else{fEc(ou,Du);f[xt>>2]=(f[xt>>2]|0)+12;break}}else{f[Bt>>2]=0;f[Ct>>2]=0;f[va>>2]=Dt;Du=f[l>>2]|0;if((Du|0)!=(Ga|0)){ou=Du;while(1){Du=ou+16|0;f[i>>2]=Rt;f[e>>2]=f[i>>2];ku=XIa(va,e,g,h,Du)|0;if(!(f[ku>>2]|0)){pu=VDc(28)|0;Cu=f[Du>>2]|0;f[pu+16>>2]=Cu;f[pu+20>>2]=f[ou+20>>2];if(Cu|0){Du=Cu+-4|0;f[Du>>2]=(f[Du>>2]|0)+1}f[pu+24>>2]=f[ou+24>>2];Du=f[g>>2]|0;f[pu>>2]=0;f[pu+4>>2]=0;f[pu+8>>2]=Du;f[ku>>2]=pu;Du=f[f[va>>2]>>2]|0;if(!Du)Uu=pu;else{f[va>>2]=Du;Uu=f[ku>>2]|0}laa(f[Bt>>2]|0,Uu);f[Ct>>2]=(f[Ct>>2]|0)+1}ku=f[ou+4>>2]|0;do if(!ku){Du=ou+8|0;pu=f[Du>>2]|0;if((f[pu>>2]|0)==(ou|0)){Vu=pu;break}else Wu=Du;do{Du=f[Wu>>2]|0;Wu=Du+8|0;pu=f[Wu>>2]|0}while((f[pu>>2]|0)!=(Du|0));Vu=pu}else{pu=ku;while(1){Du=f[pu>>2]|0;if(!Du)break;else pu=Du}Vu=pu}while(0);if((Vu|0)==(Ga|0))break;else ou=Vu}}Vnb(x,YIa(a,q,va,nu,0)|0);CFa(va,f[Dt>>2]|0);ou=f[ak>>2]|0;if((ou|0)==(f[Et>>2]|0))Bxa(dc,x);else{f[ou>>2]=f[x>>2];mu=ou+4|0;f[mu>>2]=f[Ht>>2];iu=ou+8|0;f[iu>>2]=f[Lt>>2];f[ou+12>>2]=f[Mt>>2];f[ou+16>>2]=f[Gt>>2];f[ou+20>>2]=f[Nt>>2];f[ou+24>>2]=f[Ot>>2];f[ou+28>>2]=f[Pt>>2];f[ou+32>>2]=f[Qt>>2];ku=f[Ft>>2]|0;f[ou+36>>2]=ku;f[ou+40>>2]=iu;iu=ou+48|0;Qu=ou+44|0;f[Qu>>2]=iu;f[iu>>2]=0;f[ou+52>>2]=0;if(ku|0){iu=ku+12|0;f[iu>>2]=(f[iu>>2]|0)+1}if((f[Ht>>2]|0)<3){iu=f[Jt>>2]|0;ku=f[Qu>>2]|0;f[ku>>2]=f[iu>>2];f[ku+4>>2]=f[iu+4>>2]}else{f[mu>>2]=0;ZS(ou,x)}f[ak>>2]=(f[ak>>2]|0)+56}ou=f[Ft>>2]|0;do if(ou|0){mu=ou+12|0;iu=f[mu>>2]|0;f[mu>>2]=iu+-1;if((iu|0)!=1)break;_S(x)}while(0);f[Ft>>2]=0;f[Gt>>2]=0;f[Gt+4>>2]=0;f[Gt+8>>2]=0;f[Gt+12>>2]=0;if((f[Ht>>2]|0)>0){ou=f[It>>2]|0;iu=0;do{f[ou+(iu<<2)>>2]=0;iu=iu+1|0}while((iu|0)<(f[Ht>>2]|0))}iu=f[Jt>>2]|0;if((iu|0)!=(Kt|0))g0(iu)}while(0);nu=nu+1|0}while((nu|0)<(f[Wa>>2]|0))}nu=gGa(c,r,s,t)|0;iu=HHa(o,r)|0;f[iu>>2]=nu;iu=f[xt>>2]|0;ou=f[w>>2]|0;mu=ou;if((iu|0)==(ou|0)){Xu=iu;Yu=mu}else{iu=0;ou=mu;while(1){_Ia(e,ou+(iu*12|0)|0);$Ia(a,o,c,e,nu,iu);if((b[St>>0]|0)<0)YDc(f[e>>2]|0);iu=iu+1|0;mu=f[xt>>2]|0;ku=f[w>>2]|0;Qu=ku;if(iu>>>0>=((mu-ku|0)/12|0)>>>0){Xu=mu;Yu=Qu;break}else ou=Qu}}ou=Xu;if(Yu|0){if((ou|0)==(Yu|0))Zu=Yu;else{iu=ou;while(1){ou=iu+-12|0;f[xt>>2]=ou;if((b[ou+11>>0]|0)<0){YDc(f[ou>>2]|0);_u=f[xt>>2]|0}else _u=ou;if((_u|0)==(Yu|0))break;else iu=_u}Zu=f[w>>2]|0}YDc(Zu)}cJa(v);break e}while(0);iu=f[cb>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(iu>>>0>4294967279){Xa=2634;break c}if(iu>>>0<11){b[lt>>0]=iu;if(!iu)$u=e;else{av=e;Xa=2638}}else{ou=iu+16&-16;nu=VDc(ou)|0;f[e>>2]=nu;f[pt>>2]=ou|-2147483648;f[nt>>2]=iu;av=nu;Xa=2638}if((Xa|0)==2638){Xa=0;dJc(av|0,eu|0,iu|0)|0;$u=av}b[$u+iu>>0]=0;iu=f[s>>2]|0;k:do if((iu|0)==384531)Xa=2641;else{nu=(iu|0)==0?1154740:iu;if(!(Ioc(nu,384531)|0)){Xa=2641;break}do if((iu|0)!=387164){if(!(Ioc(nu,387164)|0))break;do if((iu|0)!=384535){if(!(Ioc(nu,384535)|0))break;do if((iu|0)!=427991){if(!(Ioc(nu,427991)|0))break;if((iu|0)!=384540?Ioc(nu,384540)|0:0)break k;nEc(e,425663)|0;break k}while(0);nEc(e,425629)|0;break k}while(0);nEc(e,393771)|0;break k}while(0);nEc(e,393726)|0}while(0);if((Xa|0)==2641){Xa=0;nEc(e,425667)|0}f[g>>2]=0;f[mt>>2]=0;iu=b[lt>>0]|0;nu=iu<<24>>24<0?f[nt>>2]|0:iu&255;if(nu|0){iu=tT(g,nu)|0;dJc(iu|0,((b[lt>>0]|0)<0?f[e>>2]|0:e)|0,nu|0)|0}nu=gGa(c,r,g,t)|0;uT(g);iu=HHa(o,r)|0;f[iu>>2]=nu;_Ia(g,f[(f[Fa>>2]|0)+4>>2]|0);iu=f[Wa>>2]|0;if((iu|0)>0){ou=0;do{$Ia(a,o,c,g,nu,ou);ou=ou+1|0}while((ou|0)!=(iu|0))}if((b[ot>>0]|0)<0)YDc(f[g>>2]|0);if((b[lt>>0]|0)<0)YDc(f[e>>2]|0);break e}while(0);if((f[Wa>>2]|0)!=3){Xa=2555;break c}f[Ls>>2]=0;f[Ms>>2]=0;f[ta>>2]=Ns;iu=f[l>>2]|0;if((iu|0)!=(Ga|0)){ou=iu;while(1){iu=ou+16|0;f[i>>2]=kt;f[e>>2]=f[i>>2];nu=XIa(ta,e,g,h,iu)|0;if(!(f[nu>>2]|0)){Qu=VDc(28)|0;mu=f[iu>>2]|0;f[Qu+16>>2]=mu;f[Qu+20>>2]=f[ou+20>>2];if(mu|0){iu=mu+-4|0;f[iu>>2]=(f[iu>>2]|0)+1}f[Qu+24>>2]=f[ou+24>>2];iu=f[g>>2]|0;f[Qu>>2]=0;f[Qu+4>>2]=0;f[Qu+8>>2]=iu;f[nu>>2]=Qu;iu=f[f[ta>>2]>>2]|0;if(!iu)bv=Qu;else{f[ta>>2]=iu;bv=f[nu>>2]|0}laa(f[Ls>>2]|0,bv);f[Ms>>2]=(f[Ms>>2]|0)+1}nu=f[ou+4>>2]|0;do if(!nu){iu=ou+8|0;Qu=f[iu>>2]|0;if((f[Qu>>2]|0)==(ou|0)){cv=Qu;break}else dv=iu;do{iu=f[dv>>2]|0;dv=iu+8|0;Qu=f[dv>>2]|0}while((f[Qu>>2]|0)!=(iu|0));cv=Qu}else{Qu=nu;while(1){iu=f[Qu>>2]|0;if(!iu)break;else Qu=iu}cv=Qu}while(0);if((cv|0)==(Ga|0))break;else ou=cv}}Vnb(v,YIa(a,q,ta,1,0)|0);CFa(ta,f[Ns>>2]|0);f[Os>>2]=0;f[Ps>>2]=0;f[ua>>2]=Qs;ou=f[l>>2]|0;if((ou|0)!=(Ga|0)){nu=ou;while(1){ou=nu+16|0;f[i>>2]=jt;f[e>>2]=f[i>>2];iu=XIa(ua,e,g,h,ou)|0;if(!(f[iu>>2]|0)){mu=VDc(28)|0;ku=f[ou>>2]|0;f[mu+16>>2]=ku;f[mu+20>>2]=f[nu+20>>2];if(ku|0){ou=ku+-4|0;f[ou>>2]=(f[ou>>2]|0)+1}f[mu+24>>2]=f[nu+24>>2];ou=f[g>>2]|0;f[mu>>2]=0;f[mu+4>>2]=0;f[mu+8>>2]=ou;f[iu>>2]=mu;ou=f[f[ua>>2]>>2]|0;if(!ou)ev=mu;else{f[ua>>2]=ou;ev=f[iu>>2]|0}laa(f[Os>>2]|0,ev);f[Ps>>2]=(f[Ps>>2]|0)+1}iu=f[nu+4>>2]|0;do if(!iu){ou=nu+8|0;mu=f[ou>>2]|0;if((f[mu>>2]|0)==(nu|0)){fv=mu;break}else gv=ou;do{ou=f[gv>>2]|0;gv=ou+8|0;mu=f[gv>>2]|0}while((f[mu>>2]|0)!=(ou|0));fv=mu}else{Qu=iu;while(1){mu=f[Qu>>2]|0;if(!mu)break;else Qu=mu}fv=Qu}while(0);if((fv|0)==(Ga|0))break;else nu=fv}}Vnb(w,YIa(a,q,ua,2,0)|0);CFa(ua,f[Qs>>2]|0);hv=f[Rs>>2]|0;iv=(hv|0)<3;if(iv)jv=Y(f[Ts>>2]|0,f[Ss>>2]|0)|0;else{nu=f[gt>>2]|0;iu=0;mu=1;while(1){ou=Y(f[nu+(iu<<2)>>2]|0,mu)|0;iu=iu+1|0;if((iu|0)==(hv|0)){jv=ou;break}else mu=ou}}if((jv|0)!=1){Xa=2587;break c}kv=f[v>>2]&4095;if((kv|0)!=5){Xa=2593;break c}lv=f[Us>>2]|0;mv=(lv|0)<3;if(mv)nv=Y(f[Ws>>2]|0,f[Vs>>2]|0)|0;else{mu=f[ct>>2]|0;iu=0;nu=1;while(1){ou=Y(f[mu+(iu<<2)>>2]|0,nu)|0;iu=iu+1|0;if((iu|0)==(lv|0)){nv=ou;break}else nu=ou}}if((nv|0)!=1){Xa=2599;break c}ov=f[w>>2]&4095;if((ov|0)!=5){Xa=2605;break c}f[e>>2]=0;f[Xs>>2]=0;pv=tT(e,9)|0;qv=438714;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));eIa(t,e,f[Ys>>2]|0)|0;uT(e);f[e>>2]=0;f[Zs>>2]=0;pv=tT(e,9)|0;qv=438724;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));eIa(t,e,f[_s>>2]|0)|0;uT(e);f[e>>2]=0;f[$s>>2]=0;nu=tT(e,5)|0;b[nu>>0]=b[425629]|0;b[nu+1>>0]=b[425630]|0;b[nu+2>>0]=b[425631]|0;b[nu+3>>0]=b[425632]|0;b[nu+4>>0]=b[425633]|0;nu=gGa(c,r,e,t)|0;uT(e);iu=HHa(o,r)|0;f[iu>>2]=nu;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,nu,0);if((b[at>>0]|0)<0)YDc(f[e>>2]|0);nu=f[bt>>2]|0;do if(nu|0){iu=nu+12|0;mu=f[iu>>2]|0;f[iu>>2]=mu+-1;if((mu|0)!=1)break;_S(w)}while(0);f[bt>>2]=0;f[_s>>2]=0;f[_s+4>>2]=0;f[_s+8>>2]=0;f[_s+12>>2]=0;if((f[Us>>2]|0)>0){nu=f[ct>>2]|0;mu=0;do{f[nu+(mu<<2)>>2]=0;mu=mu+1|0}while((mu|0)<(f[Us>>2]|0))}mu=f[dt>>2]|0;if((mu|0)!=(et|0))g0(mu);mu=f[ft>>2]|0;do if(mu|0){nu=mu+12|0;iu=f[nu>>2]|0;f[nu>>2]=iu+-1;if((iu|0)!=1)break;_S(v)}while(0);f[ft>>2]=0;f[Ys>>2]=0;f[Ys+4>>2]=0;f[Ys+8>>2]=0;f[Ys+12>>2]=0;if((f[Rs>>2]|0)>0){mu=f[gt>>2]|0;iu=0;do{f[mu+(iu<<2)>>2]=0;iu=iu+1|0}while((iu|0)<(f[Rs>>2]|0))}iu=f[ht>>2]|0;if((iu|0)!=(it|0))g0(iu);break e}while(0);f[Wr>>2]=0;f[Xr>>2]=0;f[ra>>2]=Yr;iu=f[l>>2]|0;if((iu|0)!=(Ga|0)){mu=iu;while(1){iu=mu+16|0;f[i>>2]=Ks;f[e>>2]=f[i>>2];nu=XIa(ra,e,g,h,iu)|0;if(!(f[nu>>2]|0)){ou=VDc(28)|0;ku=f[iu>>2]|0;f[ou+16>>2]=ku;f[ou+20>>2]=f[mu+20>>2];if(ku|0){iu=ku+-4|0;f[iu>>2]=(f[iu>>2]|0)+1}f[ou+24>>2]=f[mu+24>>2];iu=f[g>>2]|0;f[ou>>2]=0;f[ou+4>>2]=0;f[ou+8>>2]=iu;f[nu>>2]=ou;iu=f[f[ra>>2]>>2]|0;if(!iu)sv=ou;else{f[ra>>2]=iu;sv=f[nu>>2]|0}laa(f[Wr>>2]|0,sv);f[Xr>>2]=(f[Xr>>2]|0)+1}nu=f[mu+4>>2]|0;do if(!nu){iu=mu+8|0;ou=f[iu>>2]|0;if((f[ou>>2]|0)==(mu|0)){tv=ou;break}else uv=iu;do{iu=f[uv>>2]|0;uv=iu+8|0;ou=f[uv>>2]|0}while((f[ou>>2]|0)!=(iu|0));tv=ou}else{ou=nu;while(1){iu=f[ou>>2]|0;if(!iu)break;else ou=iu}tv=ou}while(0);if((tv|0)==(Ga|0))break;else mu=tv}}Vnb(v,YIa(a,q,ra,1,0)|0);CFa(ra,f[Yr>>2]|0);mu=f[v>>2]|0;if((mu&4095|0)!=4){Xa=2474;break c}nu=f[Zr>>2]|0;if((nu|0)<3)vv=Y(f[$r>>2]|0,f[_r>>2]|0)|0;else{iu=f[bs>>2]|0;ku=0;Du=1;while(1){Cu=Y(f[iu+(ku<<2)>>2]|0,Du)|0;ku=ku+1|0;if((ku|0)==(nu|0)){vv=Cu;break}else Du=Cu}}if((vv|0)!=2){Xa=2488;break c}Du=f[as>>2]|0;if((f[Du>>2]|0)!=1){Xa=2488;break c}do if(!(mu&16384)){nu=f[bs>>2]|0;if((f[nu>>2]|0)==1){Xa=2483;break}ku=f[f[cs>>2]>>2]|0;if((f[nu+4>>2]|0)==1){wv=Du+ku|0;break}else{nu=f[$r>>2]|0;iu=(nu+1|0)>>>0<3?nu:0;wv=Du+(Y(iu,ku)|0)+(1-(Y(iu,nu)|0)<<2)|0;break}}else Xa=2483;while(0);if((Xa|0)==2483){Xa=0;wv=Du+4|0}if((f[wv>>2]|0)!=2){Xa=2488;break c}f[e>>2]=0;f[ds>>2]=0;mu=tT(e,4)|0;b[mu>>0]=112;b[mu+1>>0]=111;b[mu+2>>0]=111;b[mu+3>>0]=108;qIa(t,e,454856)|0;uT(e);f[e>>2]=0;f[es>>2]=0;pv=tT(e,14)|0;qv=454860;rv=pv+14|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=1;rIa(t,e,g)|0;uT(e);f[e>>2]=0;f[fs>>2]=0;Du=tT(e,7)|0;b[Du>>0]=b[454888]|0;b[Du+1>>0]=b[454889]|0;b[Du+2>>0]=b[454890]|0;b[Du+3>>0]=b[454891]|0;b[Du+4>>0]=b[454892]|0;b[Du+5>>0]=b[454893]|0;b[Du+6>>0]=b[454894]|0;Du=gGa(c,r,e,t)|0;uT(e);mu=HHa(o,r)|0;f[mu>>2]=Du;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,Du,0);if((b[gs>>0]|0)<0)YDc(f[e>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[hs>>0]=8;Du=h;f[Du>>2]=1885693291;f[Du+4>>2]=1936550244;b[is>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[js>>2]|0,h,0);Du=(f[e>>2]|0)==0;cJa(g);if((b[hs>>0]|0)<0)YDc(f[h>>2]|0);do if(Du){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[ks>>0]=9;pv=h;qv=384464;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[ls>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[ms>>2]|0,h,0);mu=(f[e>>2]|0)==0;cJa(g);if((b[ks>>0]|0)<0)YDc(f[h>>2]|0);if(mu){Xa=2503;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ns>>0]=9;pv=e;qv=384464;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[os>>0]=0;Wdc(_b);mu=dJa($b,e)|0;nu=b[mu+8>>0]|0?(f[mu+20>>2]|0)==5:0;if((b[ns>>0]|0)<0)YDc(f[e>>2]|0);if(!nu)Xa=2503}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Is>>0]=8;nu=e;f[nu>>2]=1885693291;f[nu+4>>2]=1936550244;b[Js>>0]=0;Wdc(_b);nu=dJa($b,e)|0;mu=b[nu+8>>0]|0?(f[nu+20>>2]|0)==5:0;if((b[Is>>0]|0)<0)YDc(f[e>>2]|0);if(!mu)Xa=2503}while(0);if((Xa|0)==2503){Xa=0;f[ps>>2]=0;f[qs>>2]=0;f[e>>2]=rs;f[ss>>2]=0;f[ss+4>>2]=0;f[ss+8>>2]=0;f[ss+12>>2]=0;f[ss+16>>2]=0;f[ss+20>>2]=0;f[ss+24>>2]=0;f[sa>>2]=0;f[ts>>2]=0;tT(sa,(f[La>>2]|0)+8|0)|0;Du=f[La>>2]|0;if(!Du)xv=0;else{dJc(f[sa>>2]|0,f[r>>2]|0,Du|0)|0;xv=f[La>>2]|0}Du=(f[sa>>2]|0)+xv|0;mu=Du;b[mu>>0]=47;b[mu+1>>0]=102;b[mu+2>>0]=108;b[mu+3>>0]=97;mu=Du+4|0;b[mu>>0]=116;b[mu+1>>0]=116;b[mu+2>>0]=101;b[mu+3>>0]=110;mu=f[sa>>2]|0;Du=f[ts>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(Du>>>0>4294967279){Xa=2506;break c}if(Du>>>0<11){b[us>>0]=Du;if(!Du)yv=g;else{zv=g;Xa=2510}}else{nu=Du+16&-16;iu=VDc(nu)|0;f[g>>2]=iu;f[Fs>>2]=nu|-2147483648;f[ws>>2]=Du;zv=iu;Xa=2510}if((Xa|0)==2510){Xa=0;dJc(zv|0,mu|0,Du|0)|0;yv=zv}b[yv+Du>>0]=0;uT(sa);f[h>>2]=0;f[vs>>2]=0;Du=b[us>>0]|0;mu=Du<<24>>24<0?f[ws>>2]|0:Du&255;if(mu|0){Du=tT(h,mu)|0;dJc(Du|0,((b[us>>0]|0)<0?f[g>>2]|0:g)|0,mu|0)|0}mu=f[wa>>2]|0;do if(mu){Du=f[h>>2]|0;iu=(Du|0)==0?1154740:Du;nu=wa;ku=mu;l:while(1){Cu=ku;while(1){Ru=f[Cu+16>>2]|0;if((Ru|0)==(Du|0))break;if((Ioc((Ru|0)==0?1154740:Ru,iu)|0)>=0)break;Ru=f[Cu+4>>2]|0;if(!Ru){Av=nu;break l}else Cu=Ru}ku=f[Cu>>2]|0;if(!ku){Av=Cu;break}else nu=Cu}if((Av|0)==(wa|0)){Xa=2523;break}nu=f[Av+16>>2]|0;if((Du|0)==(nu|0)){Bv=Av;break}if((Ioc(iu,(nu|0)==0?1154740:nu)|0)>=0)Bv=Av;else Xa=2523}else Xa=2523;while(0);if((Xa|0)==2523){Xa=0;Bv=wa}uT(h);if((Bv|0)!=(wa|0)){Xa=2525;break c}f[h>>2]=0;f[xs>>2]=0;mu=b[us>>0]|0;nu=mu<<24>>24<0?f[ws>>2]|0:mu&255;if(nu|0){mu=tT(h,nu)|0;dJc(mu|0,((b[us>>0]|0)<0?f[g>>2]|0:g)|0,nu|0)|0}f[i>>2]=0;f[ys>>2]=0;nu=tT(i,7)|0;b[nu>>0]=b[428347]|0;b[nu+1>>0]=b[428348]|0;b[nu+2>>0]=b[428349]|0;b[nu+3>>0]=b[428350]|0;b[nu+4>>0]=b[428351]|0;b[nu+5>>0]=b[428352]|0;b[nu+6>>0]=b[428353]|0;nu=gGa(c,h,i,e)|0;uT(i);uT(h);f[h>>2]=0;f[zs>>2]=0;mu=b[us>>0]|0;ku=mu<<24>>24<0?f[ws>>2]|0:mu&255;if(ku|0){mu=tT(h,ku)|0;dJc(mu|0,((b[us>>0]|0)<0?f[g>>2]|0:g)|0,ku|0)|0}ku=HHa(o,h)|0;f[ku>>2]=nu;uT(h);ku=f[r>>2]|0;mu=f[La>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(mu>>>0>4294967279){Xa=2531;break c}if(mu>>>0<11){b[As>>0]=mu;if(!mu)Cv=i;else{Dv=i;Xa=2535}}else{ou=mu+16&-16;Ru=VDc(ou)|0;f[i>>2]=Ru;f[Ds>>2]=ou|-2147483648;f[Es>>2]=mu;Dv=Ru;Xa=2535}if((Xa|0)==2535){Xa=0;dJc(Dv|0,ku|0,mu|0)|0;Cv=Dv}b[Cv+mu>>0]=0;fEc(h,i);f[Bs>>2]=0;$Ia(a,o,c,h,nu,0);if((b[Cs>>0]|0)<0)YDc(f[h>>2]|0);if((b[As>>0]|0)<0)YDc(f[i>>2]|0);if((b[us>>0]|0)<0)YDc(f[g>>2]|0);HFa(e)}nu=f[Gs>>2]|0;do if(nu|0){mu=nu+12|0;ku=f[mu>>2]|0;f[mu>>2]=ku+-1;if((ku|0)!=1)break;_S(v)}while(0);f[Gs>>2]=0;f[as>>2]=0;f[as+4>>2]=0;f[as+8>>2]=0;f[as+12>>2]=0;if((f[Zr>>2]|0)>0){nu=f[bs>>2]|0;ku=0;do{f[nu+(ku<<2)>>2]=0;ku=ku+1|0}while((ku|0)<(f[Zr>>2]|0))}ku=f[cs>>2]|0;if((ku|0)!=(Hs|0))g0(ku);break e}while(0);if((f[Wa>>2]|0)!=3){Xa=2413;break c}f[Fr>>2]=0;f[Gr>>2]=0;f[qa>>2]=Hr;ku=f[l>>2]|0;if((ku|0)!=(Ga|0)){nu=ku;while(1){ku=nu+16|0;f[i>>2]=Vr;f[e>>2]=f[i>>2];mu=XIa(qa,e,g,h,ku)|0;if(!(f[mu>>2]|0)){Ru=VDc(28)|0;ou=f[ku>>2]|0;f[Ru+16>>2]=ou;f[Ru+20>>2]=f[nu+20>>2];if(ou|0){ku=ou+-4|0;f[ku>>2]=(f[ku>>2]|0)+1}f[Ru+24>>2]=f[nu+24>>2];ku=f[g>>2]|0;f[Ru>>2]=0;f[Ru+4>>2]=0;f[Ru+8>>2]=ku;f[mu>>2]=Ru;ku=f[f[qa>>2]>>2]|0;if(!ku)Ev=Ru;else{f[qa>>2]=ku;Ev=f[mu>>2]|0}laa(f[Fr>>2]|0,Ev);f[Gr>>2]=(f[Gr>>2]|0)+1}mu=f[nu+4>>2]|0;do if(!mu){ku=nu+8|0;Ru=f[ku>>2]|0;if((f[Ru>>2]|0)==(nu|0)){Fv=Ru;break}else Gv=ku;do{ku=f[Gv>>2]|0;Gv=ku+8|0;Ru=f[Gv>>2]|0}while((f[Ru>>2]|0)!=(ku|0));Fv=Ru}else{iu=mu;while(1){Du=f[iu>>2]|0;if(!Du)break;else iu=Du}Fv=iu}while(0);if((Fv|0)==(Ga|0))break;else nu=Fv}}Vnb(v,YIa(a,q,qa,2,0)|0);CFa(qa,f[Hr>>2]|0);Hv=f[v>>2]&4095;if((Hv|0)!=4){Xa=2428;break c}Iv=f[Ir>>2]|0;Jv=(Iv|0)<3;if(Jv)Kv=Y(f[Kr>>2]|0,f[Jr>>2]|0)|0;else{nu=f[Or>>2]|0;mu=0;Du=1;while(1){Ru=Y(f[nu+(mu<<2)>>2]|0,Du)|0;mu=mu+1|0;if((mu|0)==(Iv|0)){Kv=Ru;break}else Du=Ru}}if((Kv|0)!=2){Xa=2434;break c}f[e>>2]=0;f[Lr>>2]=0;Du=tT(e,6)|0;b[Du>>0]=b[467287]|0;b[Du+1>>0]=b[467288]|0;b[Du+2>>0]=b[467289]|0;b[Du+3>>0]=b[467290]|0;b[Du+4>>0]=b[467291]|0;b[Du+5>>0]=b[467292]|0;$Ha(t,e,f[Mr>>2]|0)|0;uT(e);f[e>>2]=0;f[Nr>>2]=0;Du=tT(e,5)|0;b[Du>>0]=b[467281]|0;b[Du+1>>0]=b[467282]|0;b[Du+2>>0]=b[467283]|0;b[Du+3>>0]=b[467284]|0;b[Du+4>>0]=b[467285]|0;Du=f[Mr>>2]|0;do if(!(f[v>>2]&16384)){mu=f[Or>>2]|0;if((f[mu>>2]|0)==1){Xa=2441;break}nu=f[f[Pr>>2]>>2]|0;if((f[mu+4>>2]|0)==1){Lv=Du+nu|0;break}else{mu=f[Kr>>2]|0;Ru=(mu+1|0)>>>0<3?mu:0;Lv=Du+(Y(Ru,nu)|0)+(1-(Y(Ru,mu)|0)<<2)|0;break}}else Xa=2441;while(0);if((Xa|0)==2441){Xa=0;Lv=Du+4|0}$Ha(t,e,Lv)|0;uT(e);f[e>>2]=0;f[Qr>>2]=0;pv=tT(e,13)|0;qv=425556;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));Du=gGa(c,r,e,t)|0;uT(e);mu=HHa(o,r)|0;f[mu>>2]=Du;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,Du,0);if((b[Rr>>0]|0)<0)YDc(f[e>>2]|0);_Ia(e,f[(f[Fa>>2]|0)+8>>2]|0);$Ia(a,o,c,e,Du,1);if((b[Sr>>0]|0)<0)YDc(f[e>>2]|0);Du=f[Tr>>2]|0;do if(Du|0){mu=Du+12|0;Ru=f[mu>>2]|0;f[mu>>2]=Ru+-1;if((Ru|0)!=1)break;_S(v)}while(0);f[Tr>>2]=0;f[Mr>>2]=0;f[Mr+4>>2]=0;f[Mr+8>>2]=0;f[Mr+12>>2]=0;if((f[Ir>>2]|0)>0){Du=f[Or>>2]|0;Ru=0;do{f[Du+(Ru<<2)>>2]=0;Ru=Ru+1|0}while((Ru|0)<(f[Ir>>2]|0))}Ru=f[Pr>>2]|0;if((Ru|0)!=(Ur|0))g0(Ru);break e}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[xr>>0]=4;f[h>>2]=1936291937;b[yr>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[zr>>2]|0,h,0);Ru=(f[e>>2]|0)==0;cJa(g);if((b[xr>>0]|0)<0)YDc(f[h>>2]|0);if(!Ru){f[e>>2]=0;f[Cr>>2]=0;Ru=tT(e,4)|0;b[Ru>>0]=97;b[Ru+1>>0]=120;b[Ru+2>>0]=105;b[Ru+3>>0]=115;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Dr>>0]=4;f[h>>2]=1936291937;b[Er>>0]=0;Wdc(_b);Ru=dJa($b,h)|0;Du=(f[Ru+20>>2]|0)==3;mu=Ru+8|0;Ru=Du?f[mu+4>>2]|0:0;nu=g;f[nu>>2]=Du?f[mu>>2]|0:0;f[nu+4>>2]=Ru;mJa(t,e,g)|0;if((b[Dr>>0]|0)<0)YDc(f[h>>2]|0);uT(e)}f[e>>2]=0;f[Ar>>2]=0;Ru=tT(e,7)|0;b[Ru>>0]=b[454837]|0;b[Ru+1>>0]=b[454838]|0;b[Ru+2>>0]=b[454839]|0;b[Ru+3>>0]=b[454840]|0;b[Ru+4>>0]=b[454841]|0;b[Ru+5>>0]=b[454842]|0;b[Ru+6>>0]=b[454843]|0;Ru=gGa(c,r,e,t)|0;uT(e);nu=HHa(o,r)|0;f[nu>>2]=Ru;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);nu=f[Wa>>2]|0;if((nu|0)>0){mu=0;do{$Ia(a,o,c,e,Ru,mu);mu=mu+1|0}while((mu|0)!=(nu|0))}if((b[Br>>0]|0)<0)YDc(f[e>>2]|0);break e}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[nq>>0]=8;nu=h;f[nu>>2]=1601071469;f[nu+4>>2]=1702521203;b[oq>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[pq>>2]|0,h,0);nu=(f[e>>2]|0)==0;cJa(g);if((b[nq>>0]|0)<0)YDc(f[h>>2]|0);if(!nu){f[e>>2]=0;f[ur>>2]=0;nu=tT(e,8)|0;mu=nu;b[mu>>0]=109;b[mu+1>>0]=105;b[mu+2>>0]=110;b[mu+3>>0]=95;mu=nu+4|0;b[mu>>0]=115;b[mu+1>>0]=105;b[mu+2>>0]=122;b[mu+3>>0]=101;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[vr>>0]=8;mu=h;f[mu>>2]=1601071469;f[mu+4>>2]=1702521203;b[wr>>0]=0;Wdc(_b);mu=dJa($b,h)|0;nu=(f[mu+20>>2]|0)==3;Ru=mu+8|0;mu=nu?f[Ru+4>>2]|0:0;Du=g;f[Du>>2]=nu?f[Ru>>2]|0:0;f[Du+4>>2]=mu;mJa(t,e,g)|0;if((b[vr>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[qq>>0]=8;mu=h;f[mu>>2]=1601724781;f[mu+4>>2]=1702521203;b[rq>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[sq>>2]|0,h,0);mu=(f[e>>2]|0)==0;cJa(g);if((b[qq>>0]|0)<0)YDc(f[h>>2]|0);if(!mu){f[e>>2]=0;f[rr>>2]=0;mu=tT(e,8)|0;Du=mu;b[Du>>0]=109;b[Du+1>>0]=97;b[Du+2>>0]=120;b[Du+3>>0]=95;Du=mu+4|0;b[Du>>0]=115;b[Du+1>>0]=105;b[Du+2>>0]=122;b[Du+3>>0]=101;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[sr>>0]=8;Du=h;f[Du>>2]=1601724781;f[Du+4>>2]=1702521203;b[tr>>0]=0;Wdc(_b);Du=dJa($b,h)|0;mu=(f[Du+20>>2]|0)==3;Ru=Du+8|0;Du=mu?f[Ru+4>>2]|0:0;nu=g;f[nu>>2]=mu?f[Ru>>2]|0:0;f[nu+4>>2]=Du;mJa(t,e,g)|0;if((b[sr>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[tq>>0]=4;f[h>>2]=1885957222;b[uq>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[vq>>2]|0,h,0);Du=(f[e>>2]|0)==0;cJa(g);if((b[tq>>0]|0)<0)YDc(f[h>>2]|0);if(!Du){f[e>>2]=0;f[or>>2]=0;Du=tT(e,4)|0;b[Du>>0]=102;b[Du+1>>0]=108;b[Du+2>>0]=105;b[Du+3>>0]=112;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[pr>>0]=4;f[h>>2]=1885957222;b[qr>>0]=0;Wdc(_b);Du=dJa($b,h)|0;b[g>>0]=(b[Du+8>>0]|0?(f[Du+20>>2]|0)==5:0)&1;rIa(t,e,g)|0;if((b[pr>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[wq>>0]=4;f[h>>2]=1885957219;b[xq>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[yq>>2]|0,h,0);Du=(f[e>>2]|0)==0;cJa(g);if((b[wq>>0]|0)<0)YDc(f[h>>2]|0);if(!Du){f[e>>2]=0;f[lr>>2]=0;Du=tT(e,4)|0;b[Du>>0]=99;b[Du+1>>0]=108;b[Du+2>>0]=105;b[Du+3>>0]=112;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[mr>>0]=4;f[h>>2]=1885957219;b[nr>>0]=0;Wdc(_b);Du=dJa($b,h)|0;b[g>>0]=(b[Du+8>>0]|0?(f[Du+20>>2]|0)==5:0)&1;rIa(t,e,g)|0;if((b[mr>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[zq>>0]=6;b[h>>0]=b[451876]|0;b[h+1>>0]=b[451877]|0;b[h+2>>0]=b[451878]|0;b[h+3>>0]=b[451879]|0;b[h+4>>0]=b[451880]|0;b[h+5>>0]=b[451881]|0;b[Aq>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Bq>>2]|0,h,0);Du=(f[e>>2]|0)==0;cJa(g);if((b[zq>>0]|0)<0)YDc(f[h>>2]|0);if(!Du){f[e>>2]=0;f[ir>>2]=0;Du=tT(e,6)|0;b[Du>>0]=b[451876]|0;b[Du+1>>0]=b[451877]|0;b[Du+2>>0]=b[451878]|0;b[Du+3>>0]=b[451879]|0;b[Du+4>>0]=b[451880]|0;b[Du+5>>0]=b[451881]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[jr>>0]=6;b[h>>0]=b[451876]|0;b[h+1>>0]=b[451877]|0;b[h+2>>0]=b[451878]|0;b[h+3>>0]=b[451879]|0;b[h+4>>0]=b[451880]|0;b[h+5>>0]=b[451881]|0;b[kr>>0]=0;Wdc(_b);Du=dJa($b,h)|0;n[g>>2]=(f[Du+20>>2]|0)==4?+n[Du+8>>2]:0.0;eIa(t,e,g)|0;if((b[jr>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Cq>>0]=4;f[h>>2]=1885697139;b[Dq>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Eq>>2]|0,h,0);Du=(f[e>>2]|0)==0;cJa(g);if((b[Cq>>0]|0)<0)YDc(f[h>>2]|0);if(!Du){f[e>>2]=0;f[fr>>2]=0;Du=tT(e,4)|0;b[Du>>0]=115;b[Du+1>>0]=116;b[Du+2>>0]=101;b[Du+3>>0]=112;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[gr>>0]=4;f[h>>2]=1885697139;b[hr>>0]=0;Wdc(_b);Du=dJa($b,h)|0;n[g>>2]=(f[Du+20>>2]|0)==4?+n[Du+8>>2]:0.0;eIa(t,e,g)|0;if((b[gr>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Fq>>0]=8;Du=h;f[Du>>2]=1769103734;f[Du+4>>2]=1701015137;b[Gq>>0]=0;f[Hq>>2]=0;f[Hq+4>>2]=0;f[Hq+8>>2]=0;Du=VDc(16)|0;f[Hq>>2]=Du;f[Iq>>2]=-2147483632;f[Jq>>2]=12;pv=Du;qv=452139;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Du+12>>0]=0;f[Kq>>2]=0;f[Kq+4>>2]=0;f[Kq+8>>2]=0;b[Lq>>0]=6;b[Kq>>0]=b[384382]|0;b[Kq+1>>0]=b[384383]|0;b[Kq+2>>0]=b[384384]|0;b[Kq+3>>0]=b[384385]|0;b[Kq+4>>0]=b[384386]|0;b[Kq+5>>0]=b[384387]|0;b[Mq>>0]=0;f[Nq>>2]=0;f[Nq+4>>2]=0;f[Nq+8>>2]=0;b[Oq>>0]=5;b[Nq>>0]=b[467281]|0;b[Nq+1>>0]=b[467282]|0;b[Nq+2>>0]=b[467283]|0;b[Nq+3>>0]=b[467284]|0;b[Nq+4>>0]=b[467285]|0;b[Pq>>0]=0;f[Qq>>2]=0;f[Qq+4>>2]=0;f[Qq+8>>2]=0;b[Rq>>0]=6;b[Qq>>0]=b[467287]|0;b[Qq+1>>0]=b[467288]|0;b[Qq+2>>0]=b[467289]|0;b[Qq+3>>0]=b[467290]|0;b[Qq+4>>0]=b[467291]|0;b[Qq+5>>0]=b[467292]|0;b[Sq>>0]=0;nu=0;do{Ru=h+(nu*12|0)|0;Wdc(_b);aJa(g,$b);bJa(e,f[Tq>>2]|0,Ru,0);mu=f[e>>2]|0;cJa(g);if(mu|0){Wdc(_b);mu=dJa($b,Ru)|0;Vnb(e,(f[mu+20>>2]|0)==8?f[mu+8>>2]|0:520944);f[g>>2]=0;f[Uq>>2]=0;mu=Ru+11|0;ku=b[mu>>0]|0;ou=ku<<24>>24<0?f[h+(nu*12|0)+4>>2]|0:ku&255;if(ou|0){ku=tT(g,ou)|0;dJc(ku|0,((b[mu>>0]|0)<0?f[Ru>>2]|0:Ru)|0,ou|0)|0}ou=f[Vq>>2]|0;Ru=f[Wq>>2]|0;if((Ru|0)<3)Mv=Y(f[Yq>>2]|0,f[Xq>>2]|0)|0;else{mu=f[$q>>2]|0;ku=0;Nv=1;while(1){Ov=Y(f[mu+(ku<<2)>>2]|0,Nv)|0;ku=ku+1|0;if((ku|0)==(Ru|0)){Mv=Ov;break}else Nv=Ov}}Nv=VDc(16)|0;Ru=Nv+8|0;f[Nv>>2]=Ru;f[Nv+4>>2]=Mv;if(Mv>>>0>1){ku=XDc(Mv>>>0>536870911?-1:Mv<<3)|0;f[Nv>>2]=ku;Pv=ku}else Pv=Ru;f[i>>2]=2;f[Zq>>2]=Nv;if((Mv|0)>0){Nv=ou;Ru=0;while(1){p[Pv+(Ru<<3)>>3]=+n[Nv>>2];Ru=Ru+1|0;if((Ru|0)==(Mv|0))break;else Nv=Nv+4|0}}bIa(t,g,i)|0;JFa(i);uT(g);Nv=f[_q>>2]|0;do if(Nv|0){Ru=Nv+12|0;ou=f[Ru>>2]|0;f[Ru>>2]=ou+-1;if((ou|0)!=1)break;_S(e)}while(0);f[_q>>2]=0;f[Vq>>2]=0;f[Vq+4>>2]=0;f[Vq+8>>2]=0;f[Vq+12>>2]=0;if((f[Wq>>2]|0)>0){Nv=f[$q>>2]|0;ou=0;do{f[Nv+(ou<<2)>>2]=0;ou=ou+1|0}while((ou|0)<(f[Wq>>2]|0))}ou=f[ar>>2]|0;if((ou|0)!=(br|0))g0(ou)}nu=nu+1|0}while((nu|0)<5);f[e>>2]=0;f[cr>>2]=0;nu=tT(e,8)|0;Du=nu;b[Du>>0]=80;b[Du+1>>0]=114;b[Du+2>>0]=105;b[Du+3>>0]=111;Du=nu+4|0;b[Du>>0]=114;b[Du+1>>0]=66;b[Du+2>>0]=111;b[Du+3>>0]=120;Du=gGa(c,r,e,t)|0;uT(e);nu=HHa(o,r)|0;f[nu>>2]=Du;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,Du,0);if((b[dr>>0]|0)<0)YDc(f[e>>2]|0);_Ia(e,f[(f[Fa>>2]|0)+8>>2]|0);$Ia(a,o,c,e,Du,1);if((b[er>>0]|0)<0)YDc(f[e>>2]|0);Du=HHa(k,r)|0;f[Du>>2]=2;if((b[Wt>>0]|0)<0)YDc(f[Vt>>2]|0);if((b[Yt>>0]|0)<0)YDc(f[Xt>>2]|0);if((b[_t>>0]|0)<0)YDc(f[Zt>>2]|0);if((b[au>>0]|0)<0)YDc(f[$t>>2]|0);if((b[bu>>0]|0)<0)YDc(f[h>>2]|0);break e}while(0);if((f[Wa>>2]|0)!=2){Xa=2233;break c}f[Rp>>2]=0;f[Sp>>2]=0;f[pa>>2]=Tp;Du=f[l>>2]|0;if((Du|0)!=(Ga|0)){nu=Du;while(1){Du=nu+16|0;f[i>>2]=mq;f[e>>2]=f[i>>2];ou=XIa(pa,e,g,h,Du)|0;if(!(f[ou>>2]|0)){Nv=VDc(28)|0;Ru=f[Du>>2]|0;f[Nv+16>>2]=Ru;f[Nv+20>>2]=f[nu+20>>2];if(Ru|0){Du=Ru+-4|0;f[Du>>2]=(f[Du>>2]|0)+1}f[Nv+24>>2]=f[nu+24>>2];Du=f[g>>2]|0;f[Nv>>2]=0;f[Nv+4>>2]=0;f[Nv+8>>2]=Du;f[ou>>2]=Nv;Du=f[f[pa>>2]>>2]|0;if(!Du)Qv=Nv;else{f[pa>>2]=Du;Qv=f[ou>>2]|0}laa(f[Rp>>2]|0,Qv);f[Sp>>2]=(f[Sp>>2]|0)+1}ou=f[nu+4>>2]|0;do if(!ou){Du=nu+8|0;Nv=f[Du>>2]|0;if((f[Nv>>2]|0)==(nu|0)){Rv=Nv;break}else Sv=Du;do{Du=f[Sv>>2]|0;Sv=Du+8|0;Nv=f[Sv>>2]|0}while((f[Nv>>2]|0)!=(Du|0));Rv=Nv}else{Nv=ou;while(1){Du=f[Nv>>2]|0;if(!Du)break;else Nv=Du}Rv=Nv}while(0);if((Rv|0)==(Ga|0))break;else nu=Rv}}Vnb(v,YIa(a,q,pa,1,0)|0);CFa(pa,f[Tp>>2]|0);if((f[v>>2]&4095|0)!=4){Xa=2248;break c}nu=f[Up>>2]|0;if((nu|0)<3)Tv=Y(f[Wp>>2]|0,f[Vp>>2]|0)|0;else{ou=f[Zp>>2]|0;Du=0;Ru=1;while(1){ku=Y(f[ou+(Du<<2)>>2]|0,Ru)|0;Du=Du+1|0;if((Du|0)==(nu|0)){Tv=ku;break}else Ru=ku}}Ru=f[r>>2]|0;nu=f[La>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(nu>>>0>4294967279){Xa=2254;break c}if(nu>>>0<11){b[Xp>>0]=nu;if(!nu)Uv=e;else{Vv=e;Xa=2258}}else{Du=nu+16&-16;ou=VDc(Du)|0;f[e>>2]=ou;f[kq>>2]=Du|-2147483648;f[lq>>2]=nu;Vv=ou;Xa=2258}if((Xa|0)==2258){Xa=0;dJc(Vv|0,Ru|0,nu|0)|0;Uv=Vv}b[Uv+nu>>0]=0;nu=(kJa(e,k)|0)==0;if((b[Xp>>0]|0)<0)YDc(f[e>>2]|0);if(nu&(Tv|0)>0){nu=f[Yp>>2]|0;Ru=f[Zp>>2]|0;ou=Ru+4|0;Du=f[_p>>2]|0;ku=0;do{mu=(f[v>>2]&16384|0)==0;do if(mu){if((f[Ru>>2]|0)==1){Xa=2265;break}Ov=f[Du>>2]|0;if((f[ou>>2]|0)==1){Wv=nu+(Y(Ov,ku)|0)|0;break}else{Xv=f[Wp>>2]|0;Yv=(ku|0)/(Xv|0)|0;Wv=nu+(Y(Yv,Ov)|0)+(ku-(Y(Yv,Xv)|0)<<2)|0;break}}else Xa=2265;while(0);if((Xa|0)==2265){Xa=0;Wv=nu+(ku<<2)|0}Xv=f[Wv>>2]|0;Yv=Xv+4|0;if(Yv>>>0>=8){Xa=2270;break c}do if(Xv)if((Xv|0)>0){Zv=((Xv>>>0)%3|0)+1|0;break}else{Zv=((Yv>>>0)%3|0)+1|0;break}else Zv=0;while(0);do if(mu){if((f[Ru>>2]|0)==1){Xa=2277;break}Yv=f[Du>>2]|0;if((f[ou>>2]|0)==1){_v=nu+(Y(Yv,ku)|0)|0;break}else{Xv=f[Wp>>2]|0;Ov=(ku|0)/(Xv|0)|0;_v=nu+(Y(Ov,Yv)|0)+(ku-(Y(Ov,Xv)|0)<<2)|0;break}}else Xa=2277;while(0);if((Xa|0)==2277){Xa=0;_v=nu+(ku<<2)|0}f[_v>>2]=Zv;ku=ku+1|0}while((ku|0)<(Tv|0))}f[$p>>2]=0;f[aq>>2]=0;f[e>>2]=16842752;f[bq>>2]=v;ku=cq;f[ku>>2]=0;f[ku+4>>2]=0;f[g>>2]=33619968;f[dq>>2]=v;sS(e,g,0);m:do if((Tv|0)>1){ku=f[Yp>>2]|0;nu=f[Zp>>2]|0;ou=nu+4|0;Du=f[_p>>2]|0;Ru=f[Wp>>2]|0;if(f[v>>2]&16384|0){mu=1;while(1){Xv=f[ku+(mu<<2)>>2]|0;Ov=mu+-1|0;if((Xv|0)!=((f[ku+(Ov<<2)>>2]|0)+1|0)){Xa=2311;break c}mu=mu+1|0;if((Y(f[ku+(Ov<<2)>>2]|0,Xv)|0)<=-1){Xa=2313;break c}if((mu|0)>=(Tv|0))break m}}mu=1;Xv=f[nu>>2]|0;while(1){do if((Xv|0)!=1){Ov=f[Du>>2]|0;if((f[ou>>2]|0)==1){$v=ku+(Y(Ov,mu)|0)|0;break}else{Yv=(mu|0)/(Ru|0)|0;$v=ku+(Y(Yv,Ov)|0)+(mu-(Y(Yv,Ru)|0)<<2)|0;break}}else $v=ku+(mu<<2)|0;while(0);Nv=f[$v>>2]|0;Yv=mu+-1|0;do if((Xv|0)!=1){Ov=f[Du>>2]|0;if((f[ou>>2]|0)==1){aw=ku+(Y(Ov,Yv)|0)|0;break}else{bw=(Yv|0)/(Ru|0)|0;aw=ku+(Y(bw,Ov)|0)+(Yv-(Y(bw,Ru)|0)<<2)|0;break}}else aw=ku+(Yv<<2)|0;while(0);if((Nv|0)!=((f[aw>>2]|0)+1|0)){Xa=2311;break c}do if((Xv|0)!=1){bw=f[Du>>2]|0;if((f[ou>>2]|0)==1){cw=ku+(Y(bw,mu)|0)|0;break}else{Ov=(mu|0)/(Ru|0)|0;cw=ku+(Y(Ov,bw)|0)+(mu-(Y(Ov,Ru)|0)<<2)|0;break}}else cw=ku+(mu<<2)|0;while(0);Nv=f[cw>>2]|0;do if((Xv|0)!=1){Ov=f[Du>>2]|0;if((f[ou>>2]|0)==1){dw=ku+(Y(Ov,Yv)|0)|0;ew=Xv;break}else{bw=(Yv|0)/(Ru|0)|0;dw=ku+(Y(bw,Ov)|0)+(Yv-(Y(bw,Ru)|0)<<2)|0;ew=Xv;break}}else{dw=ku+(Yv<<2)|0;ew=1}while(0);mu=mu+1|0;if((Y(f[dw>>2]|0,Nv)|0)<=-1){Xa=2313;break c}if((mu|0)>=(Tv|0))break;else Xv=ew}}while(0);f[e>>2]=0;f[eq>>2]=0;pv=tT(e,10)|0;qv=430294;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));$Ha(t,e,f[Yp>>2]|0)|0;uT(e);f[e>>2]=0;f[fq>>2]=0;Xv=tT(e,8)|0;mu=Xv;b[mu>>0]=101;b[mu+1>>0]=110;b[mu+2>>0]=100;b[mu+3>>0]=95;mu=Xv+4|0;b[mu>>0]=97;b[mu+1>>0]=120;b[mu+2>>0]=105;b[mu+3>>0]=115;mu=Tv+-1|0;Xv=f[Yp>>2]|0;do if(!(f[v>>2]&16384)){ku=f[Zp>>2]|0;if((f[ku>>2]|0)==1){Xa=2315;break}Ru=f[f[_p>>2]>>2]|0;if((f[ku+4>>2]|0)==1){fw=Xv+(Y(Ru,mu)|0)|0;break}else{ku=f[Wp>>2]|0;ou=(mu|0)/(ku|0)|0;fw=Xv+(Y(ou,Ru)|0)+(mu-(Y(ou,ku)|0)<<2)|0;break}}else Xa=2315;while(0);if((Xa|0)==2315){Xa=0;fw=Xv+(mu<<2)|0}$Ha(t,e,fw)|0;uT(e);f[e>>2]=0;f[gq>>2]=0;pv=tT(e,9)|0;qv=425739;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));mu=gGa(c,r,e,t)|0;uT(e);Xv=HHa(o,r)|0;f[Xv>>2]=mu;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,mu,0);if((b[hq>>0]|0)<0)YDc(f[e>>2]|0);mu=f[iq>>2]|0;do if(mu|0){Xv=mu+12|0;ku=f[Xv>>2]|0;f[Xv>>2]=ku+-1;if((ku|0)!=1)break;_S(v)}while(0);f[iq>>2]=0;f[Yp>>2]=0;f[Yp+4>>2]=0;f[Yp+8>>2]=0;f[Yp+12>>2]=0;if((f[Up>>2]|0)>0){mu=f[Zp>>2]|0;ku=0;do{f[mu+(ku<<2)>>2]=0;ku=ku+1|0}while((ku|0)<(f[Up>>2]|0))}ku=f[_p>>2]|0;if((ku|0)!=(jq|0))g0(ku);break e}while(0);switch(f[Wa>>2]|0){case 2:{f[To>>2]=0;f[Uo>>2]=0;f[ma>>2]=Vo;ku=f[l>>2]|0;if((ku|0)!=(Ga|0)){mu=ku;while(1){ku=mu+16|0;f[i>>2]=ep;f[e>>2]=f[i>>2];Xv=XIa(ma,e,g,h,ku)|0;if(!(f[Xv>>2]|0)){ou=VDc(28)|0;Ru=f[ku>>2]|0;f[ou+16>>2]=Ru;f[ou+20>>2]=f[mu+20>>2];if(Ru|0){ku=Ru+-4|0;f[ku>>2]=(f[ku>>2]|0)+1}f[ou+24>>2]=f[mu+24>>2];ku=f[g>>2]|0;f[ou>>2]=0;f[ou+4>>2]=0;f[ou+8>>2]=ku;f[Xv>>2]=ou;ku=f[f[ma>>2]>>2]|0;if(!ku)gw=ou;else{f[ma>>2]=ku;gw=f[Xv>>2]|0}laa(f[To>>2]|0,gw);f[Uo>>2]=(f[Uo>>2]|0)+1}Xv=f[mu+4>>2]|0;do if(!Xv){ku=mu+8|0;ou=f[ku>>2]|0;if((f[ou>>2]|0)==(mu|0)){hw=ou;break}else iw=ku;do{ku=f[iw>>2]|0;iw=ku+8|0;ou=f[iw>>2]|0}while((f[ou>>2]|0)!=(ku|0));hw=ou}else{ou=Xv;while(1){ku=f[ou>>2]|0;if(!ku)break;else ou=ku}hw=ou}while(0);if((hw|0)==(Ga|0))break;else mu=hw}}Vnb(v,YIa(a,q,ma,1,0)|0);CFa(ma,f[Vo>>2]|0);jw=f[v>>2]&4095;if((jw|0)!=4){Xa=2129;break c}kw=f[Wo>>2]|0;lw=(kw|0)<3;if(lw)mw=Y(f[Yo>>2]|0,f[Xo>>2]|0)|0;else{mu=f[cp>>2]|0;Xv=0;ku=1;while(1){Ru=Y(f[mu+(Xv<<2)>>2]|0,ku)|0;Xv=Xv+1|0;if((Xv|0)==(kw|0)){mw=Ru;break}else ku=Ru}}if((mw|0)!=2){Xa=2135;break c}f[e>>2]=0;f[Zo>>2]=0;ku=tT(e,6)|0;b[ku>>0]=b[467287]|0;b[ku+1>>0]=b[467288]|0;b[ku+2>>0]=b[467289]|0;b[ku+3>>0]=b[467290]|0;b[ku+4>>0]=b[467291]|0;b[ku+5>>0]=b[467292]|0;$Ha(t,e,f[_o>>2]|0)|0;uT(e);f[e>>2]=0;f[ap>>2]=0;ku=tT(e,5)|0;b[ku>>0]=b[467281]|0;b[ku+1>>0]=b[467282]|0;b[ku+2>>0]=b[467283]|0;b[ku+3>>0]=b[467284]|0;b[ku+4>>0]=b[467285]|0;$Ha(t,e,(f[_o>>2]|0)+4|0)|0;uT(e);ku=f[bp>>2]|0;do if(ku|0){Xv=ku+12|0;mu=f[Xv>>2]|0;f[Xv>>2]=mu+-1;if((mu|0)!=1)break;_S(v)}while(0);f[bp>>2]=0;f[_o>>2]=0;f[_o+4>>2]=0;f[_o+8>>2]=0;f[_o+12>>2]=0;if((f[Wo>>2]|0)>0){ku=f[cp>>2]|0;mu=0;do{f[ku+(mu<<2)>>2]=0;mu=mu+1|0}while((mu|0)<(f[Wo>>2]|0))}mu=f[$o>>2]|0;if((mu|0)!=(dp|0))g0(mu);break}case 3:{f[rp>>2]=0;f[sp>>2]=0;f[na>>2]=tp;mu=f[l>>2]|0;if((mu|0)!=(Ga|0)){ku=mu;while(1){mu=ku+16|0;f[i>>2]=Qp;f[e>>2]=f[i>>2];Xv=XIa(na,e,g,h,mu)|0;if(!(f[Xv>>2]|0)){Ru=VDc(28)|0;Du=f[mu>>2]|0;f[Ru+16>>2]=Du;f[Ru+20>>2]=f[ku+20>>2];if(Du|0){mu=Du+-4|0;f[mu>>2]=(f[mu>>2]|0)+1}f[Ru+24>>2]=f[ku+24>>2];mu=f[g>>2]|0;f[Ru>>2]=0;f[Ru+4>>2]=0;f[Ru+8>>2]=mu;f[Xv>>2]=Ru;mu=f[f[na>>2]>>2]|0;if(!mu)nw=Ru;else{f[na>>2]=mu;nw=f[Xv>>2]|0}laa(f[rp>>2]|0,nw);f[sp>>2]=(f[sp>>2]|0)+1}Xv=f[ku+4>>2]|0;do if(!Xv){mu=ku+8|0;Ru=f[mu>>2]|0;if((f[Ru>>2]|0)==(ku|0)){ow=Ru;break}else pw=mu;do{mu=f[pw>>2]|0;pw=mu+8|0;Ru=f[pw>>2]|0}while((f[Ru>>2]|0)!=(mu|0));ow=Ru}else{ou=Xv;while(1){Ru=f[ou>>2]|0;if(!Ru)break;else ou=Ru}ow=ou}while(0);if((ow|0)==(Ga|0))break;else ku=ow}}Vnb(v,YIa(a,q,na,1,0)|0);CFa(na,f[tp>>2]|0);f[up>>2]=0;f[vp>>2]=0;f[oa>>2]=wp;ku=f[l>>2]|0;if((ku|0)!=(Ga|0)){Xv=ku;while(1){ku=Xv+16|0;f[i>>2]=Pp;f[e>>2]=f[i>>2];Ru=XIa(oa,e,g,h,ku)|0;if(!(f[Ru>>2]|0)){mu=VDc(28)|0;Du=f[ku>>2]|0;f[mu+16>>2]=Du;f[mu+20>>2]=f[Xv+20>>2];if(Du|0){ku=Du+-4|0;f[ku>>2]=(f[ku>>2]|0)+1}f[mu+24>>2]=f[Xv+24>>2];ku=f[g>>2]|0;f[mu>>2]=0;f[mu+4>>2]=0;f[mu+8>>2]=ku;f[Ru>>2]=mu;ku=f[f[oa>>2]>>2]|0;if(!ku)qw=mu;else{f[oa>>2]=ku;qw=f[Ru>>2]|0}laa(f[up>>2]|0,qw);f[vp>>2]=(f[vp>>2]|0)+1}Ru=f[Xv+4>>2]|0;do if(!Ru){ku=Xv+8|0;mu=f[ku>>2]|0;if((f[mu>>2]|0)==(Xv|0)){rw=mu;break}else sw=ku;do{ku=f[sw>>2]|0;sw=ku+8|0;mu=f[sw>>2]|0}while((f[mu>>2]|0)!=(ku|0));rw=mu}else{ou=Ru;while(1){mu=f[ou>>2]|0;if(!mu)break;else ou=mu}rw=ou}while(0);if((rw|0)==(Ga|0))break;else Xv=rw}}Vnb(w,YIa(a,q,oa,2,0)|0);CFa(oa,f[wp>>2]|0);tw=f[v>>2]&4095;if((tw|0)!=4){Xa=2176;break c}uw=f[xp>>2]|0;vw=(uw|0)<3;if(vw)ww=Y(f[zp>>2]|0,f[yp>>2]|0)|0;else{Xv=f[Mp>>2]|0;Ru=0;mu=1;while(1){ku=Y(f[Xv+(Ru<<2)>>2]|0,mu)|0;Ru=Ru+1|0;if((Ru|0)==(uw|0)){ww=ku;break}else mu=ku}}if((ww|0)!=1){Xa=2182;break c}xw=f[w>>2]&4095;if((xw|0)!=4){Xa=2188;break c}yw=f[Ap>>2]|0;zw=(yw|0)<3;if(zw)Aw=Y(f[Cp>>2]|0,f[Bp>>2]|0)|0;else{mu=f[Ip>>2]|0;Ru=0;Xv=1;while(1){ku=Y(f[mu+(Ru<<2)>>2]|0,Xv)|0;Ru=Ru+1|0;if((Ru|0)==(yw|0)){Aw=ku;break}else Xv=ku}}if((Aw|0)!=1){Xa=2194;break c}f[e>>2]=0;f[Dp>>2]=0;pv=tT(e,13)|0;qv=441573;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));$Ha(t,e,f[Ep>>2]|0)|0;uT(e);f[e>>2]=0;f[Fp>>2]=0;pv=tT(e,13)|0;qv=441587;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));$Ha(t,e,f[Gp>>2]|0)|0;uT(e);Xv=f[Hp>>2]|0;do if(Xv|0){Ru=Xv+12|0;mu=f[Ru>>2]|0;f[Ru>>2]=mu+-1;if((mu|0)!=1)break;_S(w)}while(0);f[Hp>>2]=0;f[Ep>>2]=0;f[Ep+4>>2]=0;f[Ep+8>>2]=0;f[Ep+12>>2]=0;if((f[Ap>>2]|0)>0){Xv=f[Ip>>2]|0;mu=0;do{f[Xv+(mu<<2)>>2]=0;mu=mu+1|0}while((mu|0)<(f[Ap>>2]|0))}mu=f[Jp>>2]|0;if((mu|0)!=(Kp|0))g0(mu);mu=f[Lp>>2]|0;do if(mu|0){Xv=mu+12|0;Ru=f[Xv>>2]|0;f[Xv>>2]=Ru+-1;if((Ru|0)!=1)break;_S(v)}while(0);f[Lp>>2]=0;f[Gp>>2]=0;f[Gp+4>>2]=0;f[Gp+8>>2]=0;f[Gp+12>>2]=0;if((f[xp>>2]|0)>0){mu=f[Mp>>2]|0;Ru=0;do{f[mu+(Ru<<2)>>2]=0;Ru=Ru+1|0}while((Ru|0)<(f[xp>>2]|0))}Ru=f[Np>>2]|0;if((Ru|0)!=(Op|0))g0(Ru);break}default:{Xa=2216;break c}}Ru=f[s>>2]|0;do if((Ru|0)==426432)Xa=2219;else{if(!(Ioc((Ru|0)==0?1154740:Ru,426432)|0)){Xa=2219;break}f[e>>2]=0;f[qp>>2]=0;pv=tT(e,13)|0;qv=454593;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));oJa(t,e,441814)|0;uT(e)}while(0);if((Xa|0)==2219){Xa=0;f[e>>2]=0;f[fp>>2]=0;pv=tT(e,13)|0;qv=454593;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));nJa(t,e,454607)|0;uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Ru=VDc(16)|0;f[h>>2]=Ru;f[gp>>2]=-2147483632;f[hp>>2]=13;pv=Ru;qv=441881;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Ru+13>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[ip>>2]|0,h,0);mu=(f[e>>2]|0)==0;cJa(g);if((b[jp>>0]|0)<0)YDc(f[h>>2]|0);if(!mu){f[e>>2]=0;f[mp>>2]=0;pv=tT(e,13)|0;qv=441881;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Ru=VDc(16)|0;f[h>>2]=Ru;f[np>>2]=-2147483632;f[op>>2]=13;pv=Ru;qv=441881;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Ru+13>>0]=0;Wdc(_b);mu=dJa($b,h)|0;b[g>>0]=(b[mu+8>>0]|0?(f[mu+20>>2]|0)==5:0)&1;rIa(t,e,g)|0;if((b[pp>>0]|0)<0)YDc(f[h>>2]|0);uT(e)}f[e>>2]=0;f[kp>>2]=0;mu=tT(e,6)|0;b[mu>>0]=b[454574]|0;b[mu+1>>0]=b[454575]|0;b[mu+2>>0]=b[454576]|0;b[mu+3>>0]=b[454577]|0;b[mu+4>>0]=b[454578]|0;b[mu+5>>0]=b[454579]|0;mu=gGa(c,r,e,t)|0;uT(e);Xv=HHa(o,r)|0;f[Xv>>2]=mu;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,mu,0);if((b[lp>>0]|0)<0)YDc(f[e>>2]|0);break e}while(0);if((f[Wa>>2]|0)!=9){Xa=1879;break c};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;mu=VDc(16)|0;f[h>>2]=mu;f[mm>>2]=-2147483632;f[nm>>2]=11;pv=mu;qv=443843;rv=pv+11|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[mu+11>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[om>>2]|0,h,0);Xv=(f[e>>2]|0)==0;cJa(g);if((b[pm>>0]|0)<0)YDc(f[h>>2]|0);if(!Xv){f[e>>2]=0;f[Po>>2]=0;pv=tT(e,11)|0;qv=443843;rv=pv+11|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;mu=VDc(16)|0;f[h>>2]=mu;f[Qo>>2]=-2147483632;f[Ro>>2]=11;pv=mu;qv=443843;rv=pv+11|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[mu+11>>0]=0;Wdc(_b);Xv=dJa($b,h)|0;n[g>>2]=(f[Xv+20>>2]|0)==4?+n[Xv+8>>2]:0.0;eIa(t,e,g)|0;if((b[So>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Xv=VDc(16)|0;f[h>>2]=Xv;f[qm>>2]=-2147483632;f[rm>>2]=11;pv=Xv;qv=443843;rv=pv+11|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Xv+11>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[sm>>2]|0,h,0);mu=(f[e>>2]|0)==0;cJa(g);if((b[tm>>0]|0)<0)YDc(f[h>>2]|0);if(!mu){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[Lo>>0]=9;pv=g;qv=443855;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Mo>>0]=0;Wdc(_b);Xv=dJa($b,g)|0;Bw=(f[Xv+20>>2]|0)==4?+n[Xv+8>>2]:0.0;if((b[Lo>>0]|0)<0)YDc(f[g>>2]|0);n[e>>2]=Bw;if(Bw>=0.0){f[g>>2]=0;f[No>>2]=0;pv=tT(g,13)|0;qv=443865;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[h>>0]=1;rIa(t,g,h)|0;uT(g);f[g>>2]=0;f[Oo>>2]=0;pv=tT(g,9)|0;qv=443855;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));eIa(t,g,e)|0;uT(g)}}f[v>>2]=1124007936;pv=um;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[wm>>2]=vm;f[ym>>2]=xm;f[xm>>2]=0;f[zm>>2]=0;f[w>>2]=1124007936;pv=Am;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[Cm>>2]=Bm;f[Em>>2]=Dm;f[Dm>>2]=0;f[Fm>>2]=0;f[x>>2]=1124007936;pv=Gm;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[Im>>2]=Hm;f[Km>>2]=Jm;f[Jm>>2]=0;f[Lm>>2]=0;f[z>>2]=1124007936;pv=Mm;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[Om>>2]=Nm;f[Qm>>2]=Pm;f[Pm>>2]=0;f[Rm>>2]=0;f[Sm>>2]=0;f[Tm>>2]=0;f[ga>>2]=Um;Xv=f[l>>2]|0;if((Xv|0)!=(Ga|0)){mu=Xv;while(1){Xv=mu+16|0;f[i>>2]=Ko;f[e>>2]=f[i>>2];ku=XIa(ga,e,g,h,Xv)|0;if(!(f[ku>>2]|0)){Du=VDc(28)|0;nu=f[Xv>>2]|0;f[Du+16>>2]=nu;f[Du+20>>2]=f[mu+20>>2];if(nu|0){Xv=nu+-4|0;f[Xv>>2]=(f[Xv>>2]|0)+1}f[Du+24>>2]=f[mu+24>>2];Xv=f[g>>2]|0;f[Du>>2]=0;f[Du+4>>2]=0;f[Du+8>>2]=Xv;f[ku>>2]=Du;Xv=f[f[ga>>2]>>2]|0;if(!Xv)Cw=Du;else{f[ga>>2]=Xv;Cw=f[ku>>2]|0}laa(f[Sm>>2]|0,Cw);f[Tm>>2]=(f[Tm>>2]|0)+1}ku=f[mu+4>>2]|0;do if(!ku){Xv=mu+8|0;Du=f[Xv>>2]|0;if((f[Du>>2]|0)==(mu|0)){Dw=Du;break}else Ew=Xv;do{Xv=f[Ew>>2]|0;Ew=Xv+8|0;Du=f[Ew>>2]|0}while((f[Du>>2]|0)!=(Xv|0));Dw=Du}else{Du=ku;while(1){Xv=f[Du>>2]|0;if(!Xv)break;else Du=Xv}Dw=Du}while(0);if((Dw|0)==(Ga|0))break;else mu=Dw}}eJa(YIa(a,q,ga,4,0)|0,v);CFa(ga,f[Um>>2]|0);f[Vm>>2]=0;f[Wm>>2]=0;f[ha>>2]=Xm;mu=f[l>>2]|0;if((mu|0)!=(Ga|0)){ku=mu;while(1){mu=ku+16|0;f[i>>2]=Jo;f[e>>2]=f[i>>2];Ru=XIa(ha,e,g,h,mu)|0;if(!(f[Ru>>2]|0)){Xv=VDc(28)|0;nu=f[mu>>2]|0;f[Xv+16>>2]=nu;f[Xv+20>>2]=f[ku+20>>2];if(nu|0){mu=nu+-4|0;f[mu>>2]=(f[mu>>2]|0)+1}f[Xv+24>>2]=f[ku+24>>2];mu=f[g>>2]|0;f[Xv>>2]=0;f[Xv+4>>2]=0;f[Xv+8>>2]=mu;f[Ru>>2]=Xv;mu=f[f[ha>>2]>>2]|0;if(!mu)Fw=Xv;else{f[ha>>2]=mu;Fw=f[Ru>>2]|0}laa(f[Vm>>2]|0,Fw);f[Wm>>2]=(f[Wm>>2]|0)+1}Ru=f[ku+4>>2]|0;do if(!Ru){mu=ku+8|0;Xv=f[mu>>2]|0;if((f[Xv>>2]|0)==(ku|0)){Gw=Xv;break}else Hw=mu;do{mu=f[Hw>>2]|0;Hw=mu+8|0;Xv=f[Hw>>2]|0}while((f[Xv>>2]|0)!=(mu|0));Gw=Xv}else{Du=Ru;while(1){Xv=f[Du>>2]|0;if(!Xv)break;else Du=Xv}Gw=Du}while(0);if((Gw|0)==(Ga|0))break;else ku=Gw}}eJa(YIa(a,q,ha,8,0)|0,z);CFa(ha,f[Xm>>2]|0);ku=f[Ym>>2]|0;Ru=(ku|0)/4|0;Xv=f[Zm>>2]|0;mu=f[vm>>2]|0;do if((mu|0)>0){nu=Ru<<1;Yv=Ru*3|0;if((ku|0)>3)Iw=0;else break;do{bw=Y(ku,Iw)|0;Ov=0;do{Jw=Xv+(Ov+Ru+bw<<2)|0;Kw=Xv+(Ov+nu+bw<<2)|0;Lw=f[Jw>>2]|0;f[Jw>>2]=f[Kw>>2];f[Kw>>2]=Lw;Jw=Xv+(Ov+Yv+bw<<2)|0;f[Kw>>2]=f[Jw>>2];f[Jw>>2]=Lw;Ov=Ov+1|0}while((Ov|0)<(Ru|0));Iw=Iw+1|0}while((Iw|0)<(mu|0))}while(0);f[e>>2]=0;f[_m>>2]=mu-Ru;f[g>>2]=-2147483648;f[$m>>2]=2147483647;$S(ia,v,e,g);xY(h,ia);Xv=f[h>>2]|0;ei[f[(f[Xv>>2]|0)+12>>2]&511](Xv,h,x,-1);$j(h);Xv=f[an>>2]|0;do if(Xv|0){ku=Xv+12|0;Yv=f[ku>>2]|0;f[ku>>2]=Yv+-1;if((Yv|0)!=1)break;_S(ia)}while(0);f[an>>2]=0;f[bn>>2]=0;f[bn+4>>2]=0;f[bn+8>>2]=0;f[bn+12>>2]=0;if((f[cn>>2]|0)>0){Xv=f[dn>>2]|0;mu=0;do{f[Xv+(mu<<2)>>2]=0;mu=mu+1|0}while((mu|0)<(f[cn>>2]|0))}mu=f[en>>2]|0;if((mu|0)!=(fn|0))g0(mu);mu=f[vm>>2]|0;f[e>>2]=mu-Ru;f[gn>>2]=mu;f[g>>2]=-2147483648;f[hn>>2]=2147483647;$S(ja,v,e,g);xY(h,ja);mu=f[h>>2]|0;ei[f[(f[mu>>2]|0)+12>>2]&511](mu,h,w,-1);$j(h);mu=f[jn>>2]|0;do if(mu|0){Xv=mu+12|0;Yv=f[Xv>>2]|0;f[Xv>>2]=Yv+-1;if((Yv|0)!=1)break;_S(ja)}while(0);f[jn>>2]=0;f[kn>>2]=0;f[kn+4>>2]=0;f[kn+8>>2]=0;f[kn+12>>2]=0;if((f[ln>>2]|0)>0){mu=f[mn>>2]|0;Ru=0;do{f[mu+(Ru<<2)>>2]=0;Ru=Ru+1|0}while((Ru|0)<(f[ln>>2]|0))}Ru=f[nn>>2]|0;if((Ru|0)!=(on|0))g0(Ru);g$(dc,3);Ru=f[dc>>2]|0;if((Ru|0)==(w|0))Mw=w;else{mu=f[zn>>2]|0;if(mu|0){Yv=mu+12|0;f[Yv>>2]=(f[Yv>>2]|0)+1}Yv=Ru+36|0;mu=f[Yv>>2]|0;do if(mu|0){Xv=mu+12|0;ku=f[Xv>>2]|0;f[Xv>>2]=ku+-1;if((ku|0)!=1)break;_S(Ru)}while(0);f[Yv>>2]=0;mu=Ru+16|0;ku=Ru+4|0;f[mu>>2]=0;f[mu+4>>2]=0;f[mu+8>>2]=0;f[mu+12>>2]=0;if((f[ku>>2]|0)>0){Xv=f[Ru+40>>2]|0;nu=0;do{f[Xv+(nu<<2)>>2]=0;nu=nu+1|0;Nw=f[ku>>2]|0}while((nu|0)<(Nw|0));f[Ru>>2]=f[w>>2];if((Nw|0)<3)Xa=1952;else Xa=1954}else{f[Ru>>2]=f[w>>2];Xa=1952}do if((Xa|0)==1952){Xa=0;nu=f[Am>>2]|0;if((nu|0)>=3){Xa=1954;break}f[ku>>2]=nu;f[Ru+8>>2]=f[Bm>>2];f[Ru+12>>2]=f[Eo>>2];nu=f[Em>>2]|0;Xv=f[Ru+44>>2]|0;f[Xv>>2]=f[nu>>2];f[Xv+4>>2]=f[nu+4>>2]}while(0);if((Xa|0)==1954){Xa=0;ZS(Ru,w)}f[mu>>2]=f[An>>2];f[Ru+20>>2]=f[Fo>>2];f[Ru+24>>2]=f[Go>>2];f[Ru+28>>2]=f[Ho>>2];f[Ru+32>>2]=f[Io>>2];f[Yv>>2]=f[zn>>2];Mw=f[dc>>2]|0}ku=Mw+56|0;if((ku|0)==(x|0))Ow=Mw;else{nu=f[xn>>2]|0;if(nu|0){Xv=nu+12|0;f[Xv>>2]=(f[Xv>>2]|0)+1}Xv=Mw+92|0;nu=f[Xv>>2]|0;do if(nu|0){Ov=nu+12|0;bw=f[Ov>>2]|0;f[Ov>>2]=bw+-1;if((bw|0)!=1)break;_S(ku)}while(0);f[Xv>>2]=0;nu=Mw+72|0;Yv=Mw+60|0;f[nu>>2]=0;f[nu+4>>2]=0;f[nu+8>>2]=0;f[nu+12>>2]=0;if((f[Yv>>2]|0)>0){Ru=f[Mw+96>>2]|0;mu=0;do{f[Ru+(mu<<2)>>2]=0;mu=mu+1|0;Pw=f[Yv>>2]|0}while((mu|0)<(Pw|0));f[ku>>2]=f[x>>2];if((Pw|0)<3)Xa=1967;else Xa=1969}else{f[ku>>2]=f[x>>2];Xa=1967}do if((Xa|0)==1967){Xa=0;mu=f[Gm>>2]|0;if((mu|0)>=3){Xa=1969;break}f[Yv>>2]=mu;f[Mw+64>>2]=f[Hm>>2];f[Mw+68>>2]=f[zo>>2];mu=f[Km>>2]|0;Ru=f[Mw+100>>2]|0;f[Ru>>2]=f[mu>>2];f[Ru+4>>2]=f[mu+4>>2]}while(0);if((Xa|0)==1969){Xa=0;ZS(ku,x)}f[nu>>2]=f[yn>>2];f[Mw+76>>2]=f[Ao>>2];f[Mw+80>>2]=f[Bo>>2];f[Mw+84>>2]=f[Co>>2];f[Mw+88>>2]=f[Do>>2];f[Xv>>2]=f[xn>>2];Ow=f[dc>>2]|0}Yv=Ow+112|0;if((Yv|0)!=(z|0)){mu=f[vn>>2]|0;if(mu|0){Ru=mu+12|0;f[Ru>>2]=(f[Ru>>2]|0)+1}Ru=Ow+148|0;mu=f[Ru>>2]|0;do if(mu|0){bw=mu+12|0;Ov=f[bw>>2]|0;f[bw>>2]=Ov+-1;if((Ov|0)!=1)break;_S(Yv)}while(0);f[Ru>>2]=0;mu=Ow+128|0;Xv=Ow+116|0;f[mu>>2]=0;f[mu+4>>2]=0;f[mu+8>>2]=0;f[mu+12>>2]=0;if((f[Xv>>2]|0)>0){nu=f[Ow+152>>2]|0;ku=0;do{f[nu+(ku<<2)>>2]=0;ku=ku+1|0;Qw=f[Xv>>2]|0}while((ku|0)<(Qw|0));f[Yv>>2]=f[z>>2];if((Qw|0)<3)Xa=1982;else Xa=1984}else{f[Yv>>2]=f[z>>2];Xa=1982}do if((Xa|0)==1982){Xa=0;ku=f[Mm>>2]|0;if((ku|0)>=3){Xa=1984;break}f[Xv>>2]=ku;f[Ow+120>>2]=f[Nm>>2];f[Ow+124>>2]=f[uo>>2];ku=f[Qm>>2]|0;nu=f[Ow+156>>2]|0;f[nu>>2]=f[ku>>2];f[nu+4>>2]=f[ku+4>>2]}while(0);if((Xa|0)==1984){Xa=0;ZS(Yv,z)}f[mu>>2]=f[wn>>2];f[Ow+132>>2]=f[vo>>2];f[Ow+136>>2]=f[wo>>2];f[Ow+140>>2]=f[xo>>2];f[Ow+144>>2]=f[yo>>2];f[Ru>>2]=f[vn>>2]};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Xv=VDc(16)|0;f[h>>2]=Xv;f[pn>>2]=-2147483632;f[qn>>2]=12;pv=Xv;qv=443879;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Xv+12>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[rn>>2]|0,h,0);Ru=(f[e>>2]|0)==0;cJa(g);if((b[sn>>0]|0)<0)YDc(f[h>>2]|0);do if(!Ru){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;mu=VDc(16)|0;f[e>>2]=mu;f[Cn>>2]=-2147483632;f[Dn>>2]=12;pv=mu;qv=443879;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[mu+12>>0]=0;Wdc(_b);Yv=dJa($b,e)|0;ku=b[Yv+8>>0]|0?(f[Yv+20>>2]|0)==5:0;if((b[En>>0]|0)<0)YDc(f[e>>2]|0);if(!ku)break;f[e>>2]=0;f[Fn>>2]=0;pv=tT(e,12)|0;qv=443879;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=1;rIa(t,e,g)|0;uT(e);g$(dc,6);mu=0;do{f[ka>>2]=1124007936;pv=Gn;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[In>>2]=Hn;f[Kn>>2]=Jn;f[Jn>>2]=0;f[Ln>>2]=0;f[Mn>>2]=0;f[Nn>>2]=0;f[la>>2]=On;ku=f[l>>2]|0;if((ku|0)!=(Ga|0)){Yv=ku;while(1){ku=Yv+16|0;f[i>>2]=to;f[e>>2]=f[i>>2];nu=XIa(la,e,g,h,ku)|0;if(!(f[nu>>2]|0)){Ov=VDc(28)|0;bw=f[ku>>2]|0;f[Ov+16>>2]=bw;f[Ov+20>>2]=f[Yv+20>>2];if(bw|0){ku=bw+-4|0;f[ku>>2]=(f[ku>>2]|0)+1}f[Ov+24>>2]=f[Yv+24>>2];ku=f[g>>2]|0;f[Ov>>2]=0;f[Ov+4>>2]=0;f[Ov+8>>2]=ku;f[nu>>2]=Ov;ku=f[f[la>>2]>>2]|0;if(!ku)Rw=Ov;else{f[la>>2]=ku;Rw=f[nu>>2]|0}laa(f[Mn>>2]|0,Rw);f[Nn>>2]=(f[Nn>>2]|0)+1}nu=f[Yv+4>>2]|0;do if(!nu){ku=Yv+8|0;Ov=f[ku>>2]|0;if((f[Ov>>2]|0)==(Yv|0)){Sw=Ov;break}else Tw=ku;do{ku=f[Tw>>2]|0;Tw=ku+8|0;Ov=f[Tw>>2]|0}while((f[Ov>>2]|0)!=(ku|0));Sw=Ov}else{Nv=nu;while(1){Ov=f[Nv>>2]|0;if(!Ov)break;else Nv=Ov}Sw=Nv}while(0);if((Sw|0)==(Ga|0))break;else Yv=Sw}}eJa(YIa(a,q,la,mu+5|0,0)|0,ka);CFa(la,f[On>>2]|0);Yv=f[Gn>>2]|0;if((Yv|0)<3)Uw=Y(f[Pn>>2]|0,f[Hn>>2]|0)|0;else{nu=f[In>>2]|0;ou=0;Ov=1;while(1){ku=Y(f[nu+(ou<<2)>>2]|0,Ov)|0;ou=ou+1|0;if((ou|0)==(Yv|0)){Uw=ku;break}else Ov=ku}}lT(e,ka,1,Uw);Ov=f[Qn>>2]|0;if(Ov|0){Yv=Ov+12|0;f[Yv>>2]=(f[Yv>>2]|0)+1}Yv=f[Rn>>2]|0;do if(Yv|0){Ov=Yv+12|0;ou=f[Ov>>2]|0;f[Ov>>2]=ou+-1;if((ou|0)!=1)break;_S(ka)}while(0);f[Rn>>2]=0;f[Sn>>2]=0;f[Sn+4>>2]=0;f[Sn+8>>2]=0;f[Sn+12>>2]=0;if((f[Gn>>2]|0)>0){Yv=f[In>>2]|0;ou=0;do{f[Yv+(ou<<2)>>2]=0;ou=ou+1|0;Vw=f[Gn>>2]|0}while((ou|0)<(Vw|0));f[ka>>2]=f[e>>2];if((Vw|0)<3)Xa=2020;else Xa=2022}else{f[ka>>2]=f[e>>2];Xa=2020}do if((Xa|0)==2020){Xa=0;ou=f[Tn>>2]|0;if((ou|0)>=3){Xa=2022;break}f[Gn>>2]=ou;f[Hn>>2]=f[Un>>2];f[Pn>>2]=f[Vn>>2];ou=f[Wn>>2]|0;Yv=f[Kn>>2]|0;f[Yv>>2]=f[ou>>2];f[Yv+4>>2]=f[ou+4>>2]}while(0);if((Xa|0)==2022){Xa=0;ZS(ka,e)}f[Sn>>2]=f[Xn>>2];f[Zn>>2]=f[Yn>>2];f[$n>>2]=f[_n>>2];f[bo>>2]=f[ao>>2];f[eo>>2]=f[co>>2];ou=f[Qn>>2]|0;f[Rn>>2]=ou;do if(ou|0){Yv=ou+12|0;Ov=f[Yv>>2]|0;f[Yv>>2]=Ov+-1;if((Ov|0)!=1)break;_S(e)}while(0);f[Qn>>2]=0;f[Xn>>2]=0;f[Xn+4>>2]=0;f[Xn+8>>2]=0;f[Xn+12>>2]=0;if((f[Tn>>2]|0)>0){ou=f[fo>>2]|0;Ov=0;do{f[ou+(Ov<<2)>>2]=0;Ov=Ov+1|0}while((Ov|0)<(f[Tn>>2]|0))}Ov=f[Wn>>2]|0;if((Ov|0)!=(go|0))g0(Ov);oT(e,ka);Ov=f[ho>>2]|0;if(Ov|0){ou=Ov+12|0;f[ou>>2]=(f[ou>>2]|0)+1}ou=f[Rn>>2]|0;do if(ou|0){Ov=ou+12|0;Yv=f[Ov>>2]|0;f[Ov>>2]=Yv+-1;if((Yv|0)!=1)break;_S(ka)}while(0);f[Rn>>2]=0;f[Sn>>2]=0;f[Sn+4>>2]=0;f[Sn+8>>2]=0;f[Sn+12>>2]=0;if((f[Gn>>2]|0)>0){ou=f[In>>2]|0;Yv=0;do{f[ou+(Yv<<2)>>2]=0;Yv=Yv+1|0;Ww=f[Gn>>2]|0}while((Yv|0)<(Ww|0));f[ka>>2]=f[e>>2];if((Ww|0)<3)Xa=2041;else Xa=2043}else{f[ka>>2]=f[e>>2];Xa=2041}do if((Xa|0)==2041){Xa=0;Yv=f[io>>2]|0;if((Yv|0)>=3){Xa=2043;break}f[Gn>>2]=Yv;f[Hn>>2]=f[jo>>2];f[Pn>>2]=f[ko>>2];Yv=f[lo>>2]|0;ou=f[Kn>>2]|0;f[ou>>2]=f[Yv>>2];f[ou+4>>2]=f[Yv+4>>2]}while(0);if((Xa|0)==2043){Xa=0;ZS(ka,e)}f[Sn>>2]=f[mo>>2];f[Zn>>2]=f[no>>2];f[$n>>2]=f[oo>>2];f[bo>>2]=f[po>>2];f[eo>>2]=f[qo>>2];Yv=f[ho>>2]|0;f[Rn>>2]=Yv;do if(Yv|0){ou=Yv+12|0;Ov=f[ou>>2]|0;f[ou>>2]=Ov+-1;if((Ov|0)!=1)break;_S(e)}while(0);f[ho>>2]=0;f[mo>>2]=0;f[mo+4>>2]=0;f[mo+8>>2]=0;f[mo+12>>2]=0;if((f[io>>2]|0)>0){Yv=f[ro>>2]|0;Ov=0;do{f[Yv+(Ov<<2)>>2]=0;Ov=Ov+1|0}while((Ov|0)<(f[io>>2]|0))}Ov=f[lo>>2]|0;if((Ov|0)!=(so|0))g0(Ov);Ov=mu+3|0;Yv=f[dc>>2]|0;ou=Yv+(Ov*56|0)|0;if((ou|0)!=(ka|0)){nu=f[Rn>>2]|0;if(nu|0){ku=nu+12|0;f[ku>>2]=(f[ku>>2]|0)+1}ku=Yv+(Ov*56|0)+36|0;nu=f[ku>>2]|0;do if(nu|0){bw=nu+12|0;Du=f[bw>>2]|0;f[bw>>2]=Du+-1;if((Du|0)!=1)break;_S(ou)}while(0);f[ku>>2]=0;nu=Yv+(Ov*56|0)+16|0;Du=Yv+(Ov*56|0)+4|0;f[nu>>2]=0;f[nu+4>>2]=0;f[nu+8>>2]=0;f[nu+12>>2]=0;if((f[Du>>2]|0)>0){bw=f[Yv+(Ov*56|0)+40>>2]|0;Lw=0;do{f[bw+(Lw<<2)>>2]=0;Lw=Lw+1|0;Xw=f[Du>>2]|0}while((Lw|0)<(Xw|0));f[ou>>2]=f[ka>>2];if((Xw|0)<3)Xa=2063;else Xa=2065}else{f[ou>>2]=f[ka>>2];Xa=2063}do if((Xa|0)==2063){Xa=0;Lw=f[Gn>>2]|0;if((Lw|0)>=3){Xa=2065;break}f[Du>>2]=Lw;f[Yv+(Ov*56|0)+8>>2]=f[Hn>>2];f[Yv+(Ov*56|0)+12>>2]=f[Pn>>2];Lw=f[Kn>>2]|0;bw=f[Yv+(Ov*56|0)+44>>2]|0;f[bw>>2]=f[Lw>>2];f[bw+4>>2]=f[Lw+4>>2]}while(0);if((Xa|0)==2065){Xa=0;ZS(ou,ka)}f[nu>>2]=f[Sn>>2];f[Yv+(Ov*56|0)+20>>2]=f[Zn>>2];f[Yv+(Ov*56|0)+24>>2]=f[$n>>2];f[Yv+(Ov*56|0)+28>>2]=f[bo>>2];f[Yv+(Ov*56|0)+32>>2]=f[eo>>2];f[ku>>2]=f[Rn>>2]}Du=f[Rn>>2]|0;do if(Du|0){Lw=Du+12|0;bw=f[Lw>>2]|0;f[Lw>>2]=bw+-1;if((bw|0)!=1)break;_S(ka)}while(0);f[Rn>>2]=0;f[Sn>>2]=0;f[Sn+4>>2]=0;f[Sn+8>>2]=0;f[Sn+12>>2]=0;if((f[Gn>>2]|0)>0){Du=f[In>>2]|0;ku=0;do{f[Du+(ku<<2)>>2]=0;ku=ku+1|0}while((ku|0)<(f[Gn>>2]|0))}ku=f[Kn>>2]|0;if((ku|0)!=(Jn|0))g0(ku);mu=mu+1|0}while((mu|0)<3)}while(0);f[e>>2]=0;f[tn>>2]=0;Ru=tT(e,4)|0;b[Ru>>0]=76;b[Ru+1>>0]=83;b[Ru+2>>0]=84;b[Ru+3>>0]=77;Ru=gGa(c,r,e,t)|0;uT(e);Xv=HHa(o,r)|0;f[Xv>>2]=Ru;_Ia(e,f[(f[Fa>>2]|0)+8>>2]|0);$Ia(a,o,c,e,Ru,0);if((b[un>>0]|0)<0)YDc(f[e>>2]|0);Ru=HHa(k,r)|0;f[Ru>>2]=2;Ru=f[vn>>2]|0;do if(Ru|0){Xv=Ru+12|0;mu=f[Xv>>2]|0;f[Xv>>2]=mu+-1;if((mu|0)!=1)break;_S(z)}while(0);f[vn>>2]=0;f[wn>>2]=0;f[wn+4>>2]=0;f[wn+8>>2]=0;f[wn+12>>2]=0;if((f[Mm>>2]|0)>0){Ru=f[Om>>2]|0;mu=0;do{f[Ru+(mu<<2)>>2]=0;mu=mu+1|0}while((mu|0)<(f[Mm>>2]|0))}mu=f[Qm>>2]|0;if((mu|0)!=(Pm|0))g0(mu);mu=f[xn>>2]|0;do if(mu|0){Ru=mu+12|0;Xv=f[Ru>>2]|0;f[Ru>>2]=Xv+-1;if((Xv|0)!=1)break;_S(x)}while(0);f[xn>>2]=0;f[yn>>2]=0;f[yn+4>>2]=0;f[yn+8>>2]=0;f[yn+12>>2]=0;if((f[Gm>>2]|0)>0){mu=f[Im>>2]|0;Xv=0;do{f[mu+(Xv<<2)>>2]=0;Xv=Xv+1|0}while((Xv|0)<(f[Gm>>2]|0))}Xv=f[Km>>2]|0;if((Xv|0)!=(Jm|0))g0(Xv);Xv=f[zn>>2]|0;do if(Xv|0){mu=Xv+12|0;Ru=f[mu>>2]|0;f[mu>>2]=Ru+-1;if((Ru|0)!=1)break;_S(w)}while(0);f[zn>>2]=0;f[An>>2]=0;f[An+4>>2]=0;f[An+8>>2]=0;f[An+12>>2]=0;if((f[Am>>2]|0)>0){Xv=f[Cm>>2]|0;Ru=0;do{f[Xv+(Ru<<2)>>2]=0;Ru=Ru+1|0}while((Ru|0)<(f[Am>>2]|0))}Ru=f[Em>>2]|0;if((Ru|0)!=(Dm|0))g0(Ru);Ru=f[Bn>>2]|0;do if(Ru|0){Xv=Ru+12|0;mu=f[Xv>>2]|0;f[Xv>>2]=mu+-1;if((mu|0)!=1)break;_S(v)}while(0);f[Bn>>2]=0;f[Zm>>2]=0;f[Zm+4>>2]=0;f[Zm+8>>2]=0;f[Zm+12>>2]=0;if((f[um>>2]|0)>0){Ru=f[wm>>2]|0;mu=0;do{f[Ru+(mu<<2)>>2]=0;mu=mu+1|0}while((mu|0)<(f[um>>2]|0))}mu=f[ym>>2]|0;if((mu|0)!=(xm|0))g0(mu);break e}while(0);if((f[Wa>>2]|0)!=3){Xa=1784;break c}f[e>>2]=0;f[El>>2]=0;pv=tT(e,9)|0;qv=454939;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=0;rIa(t,e,g)|0;uT(e);g$(dc,1);f[e>>2]=0;f[Fl>>2]=0;mu=tT(e,7)|0;b[mu>>0]=b[383309]|0;b[mu+1>>0]=b[383310]|0;b[mu+2>>0]=b[383311]|0;b[mu+3>>0]=b[383312]|0;b[mu+4>>0]=b[383313]|0;b[mu+5>>0]=b[383314]|0;b[mu+6>>0]=b[383315]|0;VIa(v,Ba,r,e);uT(e);do if(((f[Gl>>2]|0)-(f[v>>2]|0)|0)==12){f[e>>2]=0;f[Hl>>2]=0;pv=tT(e,9)|0;qv=454939;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=1;rIa(t,e,g)|0;uT(e);g$(dc,2);mu=f[(f[v>>2]|0)+8>>2]|0;Ru=f[(f[Da>>2]|0)+4+(mu<<2)>>2]|0;f[Il>>2]=0;f[Jl>>2]=0;f[da>>2]=Kl;Xv=f[l>>2]|0;if((Xv|0)!=(Ga|0)){ku=Xv;while(1){Xv=ku+16|0;f[i>>2]=Ll;f[e>>2]=f[i>>2];Du=XIa(da,e,g,h,Xv)|0;if(!(f[Du>>2]|0)){Ov=VDc(28)|0;Yv=f[Xv>>2]|0;f[Ov+16>>2]=Yv;f[Ov+20>>2]=f[ku+20>>2];if(Yv|0){Xv=Yv+-4|0;f[Xv>>2]=(f[Xv>>2]|0)+1}f[Ov+24>>2]=f[ku+24>>2];Xv=f[g>>2]|0;f[Ov>>2]=0;f[Ov+4>>2]=0;f[Ov+8>>2]=Xv;f[Du>>2]=Ov;Xv=f[f[da>>2]>>2]|0;if(!Xv)Yw=Ov;else{f[da>>2]=Xv;Yw=f[Du>>2]|0}laa(f[Il>>2]|0,Yw);f[Jl>>2]=(f[Jl>>2]|0)+1}Du=f[ku+4>>2]|0;do if(!Du){Xv=ku+8|0;Ov=f[Xv>>2]|0;if((f[Ov>>2]|0)==(ku|0)){Zw=Ov;break}else _w=Xv;do{Xv=f[_w>>2]|0;_w=Xv+8|0;Ov=f[_w>>2]|0}while((f[Ov>>2]|0)!=(Xv|0));Zw=Ov}else{Ov=Du;while(1){Xv=f[Ov>>2]|0;if(!Xv)break;else Ov=Xv}Zw=Ov}while(0);if((Zw|0)==(Ga|0))break;else ku=Zw}}ku=YIa(a,Ru,da,-1,0)|0;eJa(ku,(f[dc>>2]|0)+56|0);CFa(da,f[Kl>>2]|0);fJa(Ba,mu,0);ku=f[v>>2]|0;Du=f[za>>2]|0;n:do if(!Du){$w=za;ax=za}else{Xv=f[ku>>2]|0;Yv=(Xv|0)==0?1154740:Xv;nu=f[Du+16>>2]|0;o:do if((Xv|0)!=(nu|0)){ou=xa;bw=Du;Lw=nu;while(1){Jw=(Lw|0)==0?1154740:Lw;if((Ioc(Yv,Jw)|0)<0){Kw=f[bw>>2]|0;if(!Kw){Xa=1804;break}else{bx=bw;dx=Kw}}else{if((Ioc(Jw,Yv)|0)>=0){ex=ou;fx=bw;break o}gx=bw+4|0;Jw=f[gx>>2]|0;if(!Jw){Xa=1807;break}else{bx=gx;dx=Jw}}Lw=f[dx+16>>2]|0;if((Xv|0)==(Lw|0)){ex=bx;fx=dx;break o}else{ou=bx;bw=dx}}if((Xa|0)==1804){Xa=0;$w=bw;ax=bw;break n}else if((Xa|0)==1807){Xa=0;$w=gx;ax=bw;break n}}else{ex=xa;fx=Du}while(0);$w=ex;ax=fx}while(0);if(f[$w>>2]|0)break;Du=VDc(24)|0;mu=f[ku>>2]|0;f[Du+16>>2]=mu;f[Du+20>>2]=f[ku+4>>2];if(mu|0){Ru=mu+-4|0;f[Ru>>2]=(f[Ru>>2]|0)+1}f[Du>>2]=0;f[Du+4>>2]=0;f[Du+8>>2]=ax;f[$w>>2]=Du;Ru=f[f[j>>2]>>2]|0;if(!Ru)hx=Du;else{f[j>>2]=Ru;hx=f[$w>>2]|0}laa(f[xa>>2]|0,hx);f[ya>>2]=(f[ya>>2]|0)+1}while(0);f[Ml>>2]=0;f[Nl>>2]=0;f[ea>>2]=Ol;Ru=f[l>>2]|0;if((Ru|0)!=(Ga|0)){Du=Ru;while(1){Ru=Du+16|0;f[i>>2]=lm;f[e>>2]=f[i>>2];mu=XIa(ea,e,g,h,Ru)|0;if(!(f[mu>>2]|0)){Xv=VDc(28)|0;Yv=f[Ru>>2]|0;f[Xv+16>>2]=Yv;f[Xv+20>>2]=f[Du+20>>2];if(Yv|0){Ru=Yv+-4|0;f[Ru>>2]=(f[Ru>>2]|0)+1}f[Xv+24>>2]=f[Du+24>>2];Ru=f[g>>2]|0;f[Xv>>2]=0;f[Xv+4>>2]=0;f[Xv+8>>2]=Ru;f[mu>>2]=Xv;Ru=f[f[ea>>2]>>2]|0;if(!Ru)ix=Xv;else{f[ea>>2]=Ru;ix=f[mu>>2]|0}laa(f[Ml>>2]|0,ix);f[Nl>>2]=(f[Nl>>2]|0)+1}mu=f[Du+4>>2]|0;do if(!mu){Ru=Du+8|0;Xv=f[Ru>>2]|0;if((f[Xv>>2]|0)==(Du|0)){jx=Xv;break}else kx=Ru;do{Ru=f[kx>>2]|0;kx=Ru+8|0;Xv=f[kx>>2]|0}while((f[Xv>>2]|0)!=(Ru|0));jx=Xv}else{Xv=mu;while(1){Ru=f[Xv>>2]|0;if(!Ru)break;else Xv=Ru}jx=Xv}while(0);if((jx|0)==(Ga|0))break;else Du=jx}}Du=YIa(a,q,ea,1,0)|0;gJa(Du,f[dc>>2]|0);CFa(ea,f[Ol>>2]|0);Du=f[(f[dc>>2]|0)+40>>2]|0;f[w>>2]=f[Du+8>>2];f[x>>2]=f[Du+12>>2];f[e>>2]=0;f[Pl>>2]=0;mu=tT(e,8)|0;ku=mu;b[ku>>0]=107;b[ku+1>>0]=101;b[ku+2>>0]=114;b[ku+3>>0]=110;ku=mu+4|0;b[ku>>0]=101;b[ku+1>>0]=108;b[ku+2>>0]=95;b[ku+3>>0]=104;$Ha(t,e,w)|0;uT(e);f[e>>2]=0;f[Ql>>2]=0;ku=tT(e,8)|0;mu=ku;b[mu>>0]=107;b[mu+1>>0]=101;b[mu+2>>0]=114;b[mu+3>>0]=110;mu=ku+4|0;b[mu>>0]=101;b[mu+1>>0]=108;b[mu+2>>0]=95;b[mu+3>>0]=119;$Ha(t,e,x)|0;uT(e);f[e>>2]=0;f[Rl>>2]=0;pv=tT(e,10)|0;qv=455057;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));$Ha(t,e,Du+4|0)|0;uT(e);iJa(t,q);jJa(t,q);f[e>>2]=0;f[Sl>>2]=0;mu=tT(e,8)|0;ku=mu;b[ku>>0]=115;b[ku+1>>0]=116;b[ku+2>>0]=114;b[ku+3>>0]=105;ku=mu+4|0;b[ku>>0]=100;b[ku+1>>0]=101;b[ku+2>>0]=95;b[ku+3>>0]=104;ku=DHa(lIa(t,e)|0,-1)|0;uT(e);f[e>>2]=0;f[Tl>>2]=0;mu=tT(e,8)|0;Ru=mu;b[Ru>>0]=115;b[Ru+1>>0]=116;b[Ru+2>>0]=114;b[Ru+3>>0]=105;Ru=mu+4|0;b[Ru>>0]=100;b[Ru+1>>0]=101;b[Ru+2>>0]=95;b[Ru+3>>0]=119;Ru=DHa(lIa(t,e)|0,-1)|0;uT(e);f[Ul>>2]=0;f[Vl>>2]=0;f[fa>>2]=Wl;mu=f[l>>2]|0;if((mu|0)!=(Ga|0)){Yv=mu;while(1){mu=Yv+16|0;f[i>>2]=km;f[e>>2]=f[i>>2];nu=XIa(fa,e,g,h,mu)|0;if(!(f[nu>>2]|0)){ou=VDc(28)|0;Lw=f[mu>>2]|0;f[ou+16>>2]=Lw;f[ou+20>>2]=f[Yv+20>>2];if(Lw|0){mu=Lw+-4|0;f[mu>>2]=(f[mu>>2]|0)+1}f[ou+24>>2]=f[Yv+24>>2];mu=f[g>>2]|0;f[ou>>2]=0;f[ou+4>>2]=0;f[ou+8>>2]=mu;f[nu>>2]=ou;mu=f[f[fa>>2]>>2]|0;if(!mu)lx=ou;else{f[fa>>2]=mu;lx=f[nu>>2]|0}laa(f[Ul>>2]|0,lx);f[Vl>>2]=(f[Vl>>2]|0)+1}nu=f[Yv+4>>2]|0;do if(!nu){mu=Yv+8|0;ou=f[mu>>2]|0;if((f[ou>>2]|0)==(Yv|0)){mx=ou;break}else nx=mu;do{mu=f[nx>>2]|0;nx=mu+8|0;ou=f[nx>>2]|0}while((f[ou>>2]|0)!=(mu|0));mx=ou}else{Xv=nu;while(1){ou=f[Xv>>2]|0;if(!ou)break;else Xv=ou}mx=Xv}while(0);if((mx|0)==(Ga|0))break;else Yv=mx}}Vnb(z,YIa(a,q,fa,0,0)|0);CFa(fa,f[Wl>>2]|0);Yv=f[Xl>>2]|0;do if(!(f[z>>2]&16384)){Du=f[Yl>>2]|0;do if((f[Du>>2]|0)!=1){nu=f[f[Zl>>2]>>2]|0;if((f[Du+4>>2]|0)==1){ox=Yv+nu|0;break}else{ou=f[_l>>2]|0;mu=(ou+1|0)>>>0<3?ou:0;ox=Yv+(Y(mu,nu)|0)+(1-(Y(mu,ou)|0)<<2)|0;break}}else ox=Yv+4|0;while(0);Du=f[ox>>2]|0;ou=f[Yl>>2]|0;if((f[ou>>2]|0)==1){px=Du;Xa=1849;break}mu=f[f[Zl>>2]>>2]|0;if((f[ou+4>>2]|0)==1){qx=Yv+(mu<<1)|0;rx=Du;break}else{ou=f[_l>>2]|0;nu=2/(ou|0)|0;qx=Yv+(Y(nu,mu)|0)+(2-(Y(nu,ou)|0)<<2)|0;rx=Du;break}}else{px=f[Yv+4>>2]|0;Xa=1849}while(0);if((Xa|0)==1849){Xa=0;qx=Yv+8|0;rx=px}Du=f[qx>>2]|0;f[g>>2]=0;f[$l>>2]=0;ou=tT(g,8)|0;nu=ou;b[nu>>0]=112;b[nu+1>>0]=97;b[nu+2>>0]=100;b[nu+3>>0]=95;nu=ou+4|0;b[nu>>0]=109;b[nu+1>>0]=111;b[nu+2>>0]=100;b[nu+3>>0]=101;EHa(e,lIa(t,g)|0,-1);nu=f[e>>2]|0;do if((nu|0)==450788){uT(e);uT(g);Xa=1856}else{ou=(Ioc((nu|0)==0?1154740:nu,450788)|0)==0;uT(e);uT(g);if(ou){Xa=1856;break}f[g>>2]=0;f[hm>>2]=0;ou=tT(g,8)|0;mu=ou;b[mu>>0]=112;b[mu+1>>0]=97;b[mu+2>>0]=100;b[mu+3>>0]=95;mu=ou+4|0;b[mu>>0]=109;b[mu+1>>0]=111;b[mu+2>>0]=100;b[mu+3>>0]=101;EHa(e,lIa(t,g)|0,-1);mu=f[e>>2]|0;if((mu|0)!=450782){ou=(Ioc((mu|0)==0?1154740:mu,450782)|0)==0;uT(e);uT(g);if(!ou)break}else{uT(e);uT(g)}f[e>>2]=0;f[im>>2]=0;ou=tT(e,5)|0;b[ou>>0]=b[434011]|0;b[ou+1>>0]=b[434012]|0;b[ou+2>>0]=b[434013]|0;b[ou+3>>0]=b[434014]|0;b[ou+4>>0]=b[434015]|0;f[g>>2]=(Du-(f[x>>2]|0)|0)%(Ru|0)|0;$Ha(t,e,g)|0;uT(e);f[e>>2]=0;f[jm>>2]=0;ou=tT(e,5)|0;b[ou>>0]=b[434005]|0;b[ou+1>>0]=b[434006]|0;b[ou+2>>0]=b[434007]|0;b[ou+3>>0]=b[434008]|0;b[ou+4>>0]=b[434009]|0;f[g>>2]=(rx-(f[w>>2]|0)|0)%(ku|0)|0;$Ha(t,e,g)|0;uT(e)}while(0);if((Xa|0)==1856){Xa=0;f[e>>2]=0;f[am>>2]=0;nu=tT(e,5)|0;b[nu>>0]=b[434011]|0;b[nu+1>>0]=b[434012]|0;b[nu+2>>0]=b[434013]|0;b[nu+3>>0]=b[434014]|0;b[nu+4>>0]=b[434015]|0;f[g>>2]=(Du+-1|0)%(Ru|0)|0;$Ha(t,e,g)|0;uT(e);f[e>>2]=0;f[bm>>2]=0;nu=tT(e,5)|0;b[nu>>0]=b[434005]|0;b[nu+1>>0]=b[434006]|0;b[nu+2>>0]=b[434007]|0;b[nu+3>>0]=b[434008]|0;b[nu+4>>0]=b[434009]|0;f[g>>2]=(rx+-1|0)%(ku|0)|0;$Ha(t,e,g)|0;uT(e)}f[e>>2]=0;f[cm>>2]=0;pv=tT(e,13)|0;qv=425570;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));ku=gGa(c,r,e,t)|0;uT(e);Ru=HHa(o,r)|0;f[Ru>>2]=ku;_Ia(e,f[(f[Fa>>2]|0)+12>>2]|0);$Ia(a,o,c,e,ku,0);if((b[dm>>0]|0)<0)YDc(f[e>>2]|0);ku=f[em>>2]|0;do if(ku|0){Ru=ku+12|0;Du=f[Ru>>2]|0;f[Ru>>2]=Du+-1;if((Du|0)!=1)break;_S(z)}while(0);f[em>>2]=0;f[Xl>>2]=0;f[Xl+4>>2]=0;f[Xl+8>>2]=0;f[Xl+12>>2]=0;if((f[fm>>2]|0)>0){ku=f[Yl>>2]|0;Du=0;do{f[ku+(Du<<2)>>2]=0;Du=Du+1|0}while((Du|0)<(f[fm>>2]|0))}Du=f[Zl>>2]|0;if((Du|0)!=(gm|0))g0(Du);Du=f[v>>2]|0;if(Du|0){while(1){ku=f[Gl>>2]|0;if((ku|0)==(Du|0))break;Ru=ku+-12|0;f[Gl>>2]=Ru;uT(Ru)}YDc(f[v>>2]|0)}break e}while(0);if((f[Wa>>2]|0)!=5){Xa=1611;break c}_Ia(v,f[(f[Fa>>2]|0)+4>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Du=VDc(16)|0;f[h>>2]=Du;f[ik>>2]=-2147483632;f[jk>>2]=11;pv=Du;qv=383940;rv=pv+11|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Du+11>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[kk>>2]|0,h,0);Ru=f[e>>2]|0;cJa(g);if(!Ru)sx=0;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ru=VDc(16)|0;f[e>>2]=Ru;f[Bl>>2]=-2147483632;f[Cl>>2]=11;pv=Ru;qv=383940;rv=pv+11|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Ru+11>>0]=0;Wdc(_b);Du=dJa($b,e)|0;ku=b[Du+8>>0]|0?(f[Du+20>>2]|0)==5:0;if((b[Dl>>0]|0)<0)YDc(f[e>>2]|0);sx=ku}if((b[lk>>0]|0)<0)YDc(f[h>>2]|0);g$(dc,2);f[mk>>2]=0;f[nk>>2]=0;f[_>>2]=ok;ku=f[l>>2]|0;if((ku|0)!=(Ga|0)){Du=ku;while(1){ku=Du+16|0;f[i>>2]=Al;f[e>>2]=f[i>>2];nu=XIa(_,e,g,h,ku)|0;if(!(f[nu>>2]|0)){Yv=VDc(28)|0;ou=f[ku>>2]|0;f[Yv+16>>2]=ou;f[Yv+20>>2]=f[Du+20>>2];if(ou|0){ku=ou+-4|0;f[ku>>2]=(f[ku>>2]|0)+1}f[Yv+24>>2]=f[Du+24>>2];ku=f[g>>2]|0;f[Yv>>2]=0;f[Yv+4>>2]=0;f[Yv+8>>2]=ku;f[nu>>2]=Yv;ku=f[f[_>>2]>>2]|0;if(!ku)tx=Yv;else{f[_>>2]=ku;tx=f[nu>>2]|0}laa(f[mk>>2]|0,tx);f[nk>>2]=(f[nk>>2]|0)+1}nu=f[Du+4>>2]|0;do if(!nu){ku=Du+8|0;Yv=f[ku>>2]|0;if((f[Yv>>2]|0)==(Du|0)){ux=Yv;break}else vx=ku;do{ku=f[vx>>2]|0;vx=ku+8|0;Yv=f[vx>>2]|0}while((f[Yv>>2]|0)!=(ku|0));ux=Yv}else{Yv=nu;while(1){ku=f[Yv>>2]|0;if(!ku)break;else Yv=ku}ux=Yv}while(0);if((ux|0)==(Ga|0))break;else Du=ux}}Du=YIa(a,q,_,1,0)|0;CFa(_,f[ok>>2]|0);Ru=f[Du+152>>2]|0;nu=b[Ru+11>>0]|0;if(nu<<24>>24<0)wx=f[Ru+4>>2]|0;else wx=nu&255;if(!wx){f[e>>2]=0;f[pk>>2]=0;pv=tT(e,10)|0;qv=454974;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=0;rIa(t,e,g)|0;uT(e)}else{g$(dc,(((f[ak>>2]|0)-(f[dc>>2]|0)|0)/56|0)+1|0);f[e>>2]=0;f[zl>>2]=0;pv=tT(e,10)|0;qv=454974;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=1;rIa(t,e,g)|0;uT(e);eJa(Du,(f[ak>>2]|0)+-56|0)}f[qk>>2]=0;f[rk>>2]=0;f[$>>2]=sk;nu=f[l>>2]|0;if((nu|0)!=(Ga|0)){Ru=nu;while(1){nu=Ru+16|0;f[i>>2]=yl;f[e>>2]=f[i>>2];ku=XIa($,e,g,h,nu)|0;if(!(f[ku>>2]|0)){ou=VDc(28)|0;mu=f[nu>>2]|0;f[ou+16>>2]=mu;f[ou+20>>2]=f[Ru+20>>2];if(mu|0){nu=mu+-4|0;f[nu>>2]=(f[nu>>2]|0)+1}f[ou+24>>2]=f[Ru+24>>2];nu=f[g>>2]|0;f[ou>>2]=0;f[ou+4>>2]=0;f[ou+8>>2]=nu;f[ku>>2]=ou;nu=f[f[$>>2]>>2]|0;if(!nu)xx=ou;else{f[$>>2]=nu;xx=f[ku>>2]|0}laa(f[qk>>2]|0,xx);f[rk>>2]=(f[rk>>2]|0)+1}ku=f[Ru+4>>2]|0;do if(!ku){nu=Ru+8|0;ou=f[nu>>2]|0;if((f[ou>>2]|0)==(Ru|0)){yx=ou;break}else zx=nu;do{nu=f[zx>>2]|0;zx=nu+8|0;ou=f[zx>>2]|0}while((f[ou>>2]|0)!=(nu|0));yx=ou}else{Yv=ku;while(1){ou=f[Yv>>2]|0;if(!ou)break;else Yv=ou}yx=Yv}while(0);if((yx|0)==(Ga|0))break;else Ru=yx}}Ru=YIa(a,q,$,2,0)|0;CFa($,f[sk>>2]|0);Du=f[Ru+152>>2]|0;ku=b[Du+11>>0]|0;if(ku<<24>>24<0)Ax=f[Du+4>>2]|0;else Ax=ku&255;if(!Ax){f[e>>2]=0;f[tk>>2]=0;ku=tT(e,8)|0;Du=ku;b[Du>>0]=104;b[Du+1>>0]=97;b[Du+2>>0]=115;b[Du+3>>0]=95;Du=ku+4|0;b[Du>>0]=98;b[Du+1>>0]=105;b[Du+2>>0]=97;b[Du+3>>0]=115;b[g>>0]=0;rIa(t,e,g)|0;uT(e)}else{g$(dc,(((f[ak>>2]|0)-(f[dc>>2]|0)|0)/56|0)+1|0);f[e>>2]=0;f[xl>>2]=0;Du=tT(e,8)|0;ku=Du;b[ku>>0]=104;b[ku+1>>0]=97;b[ku+2>>0]=115;b[ku+3>>0]=95;ku=Du+4|0;b[ku>>0]=98;b[ku+1>>0]=105;b[ku+2>>0]=97;b[ku+3>>0]=115;b[g>>0]=1;rIa(t,e,g)|0;uT(e);eJa(Ru,(f[ak>>2]|0)+-56|0)}f[w>>2]=1124007936;pv=uk;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[wk>>2]=vk;f[yk>>2]=xk;f[xk>>2]=0;f[zk>>2]=0;f[x>>2]=1124007936;pv=Ak;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[Ck>>2]=Bk;f[Ek>>2]=Dk;f[Dk>>2]=0;f[Fk>>2]=0;if(sx){Ru=f[dc>>2]|0;ku=Ru;if(((f[ak>>2]|0)-Ru|0)==112){Xa=1658;break c}Ru=f[ku+172>>2]|0;if((Ru|0)<3)Bx=Y(f[ku+180>>2]|0,f[ku+176>>2]|0)|0;else{Du=f[ku+208>>2]|0;ku=0;ou=1;while(1){nu=Y(f[Du+(ku<<2)>>2]|0,ou)|0;ku=ku+1|0;if((ku|0)==(Ru|0)){Bx=nu;break}else ou=nu}}AY(e,1,Bx,5);ou=f[e>>2]|0;ei[f[(f[ou>>2]|0)+12>>2]&511](ou,e,w,-1);$j(e);ou=f[dc>>2]|0;Ru=f[ou+172>>2]|0;if((Ru|0)<3)Cx=Y(f[ou+180>>2]|0,f[ou+176>>2]|0)|0;else{ku=f[ou+208>>2]|0;ou=0;Du=1;while(1){nu=Y(f[ku+(ou<<2)>>2]|0,Du)|0;ou=ou+1|0;if((ou|0)==(Ru|0)){Cx=nu;break}else Du=nu}}EY(e,1,Cx,5);Du=f[e>>2]|0;ei[f[(f[Du>>2]|0)+12>>2]&511](Du,e,x,-1);$j(e);f[Gk>>2]=0;f[Hk>>2]=0;f[e>>2]=Ik;f[Jk>>2]=0;f[Jk+4>>2]=0;f[Jk+8>>2]=0;f[Jk+12>>2]=0;f[Jk+16>>2]=0;f[Jk+20>>2]=0;f[Jk+24>>2]=0;f[aa>>2]=0;f[Kk>>2]=0;tT(aa,(f[La>>2]|0)+4|0)|0;Du=f[La>>2]|0;if(!Du)Dx=0;else{dJc(f[aa>>2]|0,f[r>>2]|0,Du|0)|0;Dx=f[La>>2]|0}Du=(f[aa>>2]|0)+Dx|0;b[Du>>0]=47;b[Du+1>>0]=77;b[Du+2>>0]=86;b[Du+3>>0]=78;Du=f[aa>>2]|0;Ru=f[Kk>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(Ru>>>0>4294967279){Xa=1670;break c}if(Ru>>>0<11){b[Lk>>0]=Ru;if(!Ru)Ex=g;else{Fx=g;Xa=1674}}else{ou=Ru+16&-16;ku=VDc(ou)|0;f[g>>2]=ku;f[Uk>>2]=ou|-2147483648;f[Nk>>2]=Ru;Fx=ku;Xa=1674}if((Xa|0)==1674){Xa=0;dJc(Fx|0,Du|0,Ru|0)|0;Ex=Fx}b[Ex+Ru>>0]=0;uT(aa);f[h>>2]=0;f[Mk>>2]=0;Ru=b[Lk>>0]|0;Du=Ru<<24>>24<0?f[Nk>>2]|0:Ru&255;if(Du|0){Ru=tT(h,Du)|0;dJc(Ru|0,((b[Lk>>0]|0)<0?f[g>>2]|0:g)|0,Du|0)|0}Du=f[wa>>2]|0;do if(Du){Ru=f[h>>2]|0;ku=(Ru|0)==0?1154740:Ru;ou=wa;nu=Du;p:while(1){mu=nu;while(1){Lw=f[mu+16>>2]|0;if((Lw|0)==(Ru|0))break;if((Ioc((Lw|0)==0?1154740:Lw,ku)|0)>=0)break;Lw=f[mu+4>>2]|0;if(!Lw){Gx=ou;break p}else mu=Lw}nu=f[mu>>2]|0;if(!nu){Gx=mu;break}else ou=mu}if((Gx|0)==(wa|0)){Xa=1687;break}ou=f[Gx+16>>2]|0;if((Ru|0)==(ou|0)){Hx=Gx;break}if((Ioc(ku,(ou|0)==0?1154740:ou)|0)>=0)Hx=Gx;else Xa=1687}else Xa=1687;while(0);if((Xa|0)==1687){Xa=0;Hx=wa}uT(h);if((Hx|0)!=(wa|0)){Xa=1689;break c}f[h>>2]=0;f[Ok>>2]=0;Du=b[Lk>>0]|0;ou=Du<<24>>24<0?f[Nk>>2]|0:Du&255;if(ou|0){Du=tT(h,ou)|0;dJc(Du|0,((b[Lk>>0]|0)<0?f[g>>2]|0:g)|0,ou|0)|0}f[i>>2]=0;f[Pk>>2]=0;ou=tT(i,3)|0;b[ou>>0]=b[425625]|0;b[ou+1>>0]=b[425626]|0;b[ou+2>>0]=b[425627]|0;ou=gGa(c,h,i,e)|0;uT(i);uT(h);f[h>>2]=0;f[Qk>>2]=0;Du=b[Lk>>0]|0;nu=Du<<24>>24<0?f[Nk>>2]|0:Du&255;if(nu|0){Du=tT(h,nu)|0;dJc(Du|0,((b[Lk>>0]|0)<0?f[g>>2]|0:g)|0,nu|0)|0}nu=HHa(o,h)|0;f[nu>>2]=ou;uT(h);$Ia(a,o,c,v,ou,0);fEc(h,g);f[Rk>>2]=0;iEc(v,h)|0;f[Sk>>2]=f[Rk>>2];if((b[Tk>>0]|0)<0)YDc(f[h>>2]|0);if((b[Lk>>0]|0)<0)YDc(f[g>>2]|0);HFa(e)}else{f[pl>>2]=0;f[ql>>2]=0;f[ba>>2]=rl;ou=f[l>>2]|0;if((ou|0)!=(Ga|0)){nu=ou;while(1){ou=nu+16|0;f[i>>2]=wl;f[e>>2]=f[i>>2];Du=XIa(ba,e,g,h,ou)|0;if(!(f[Du>>2]|0)){Yv=VDc(28)|0;Lw=f[ou>>2]|0;f[Yv+16>>2]=Lw;f[Yv+20>>2]=f[nu+20>>2];if(Lw|0){ou=Lw+-4|0;f[ou>>2]=(f[ou>>2]|0)+1}f[Yv+24>>2]=f[nu+24>>2];ou=f[g>>2]|0;f[Yv>>2]=0;f[Yv+4>>2]=0;f[Yv+8>>2]=ou;f[Du>>2]=Yv;ou=f[f[ba>>2]>>2]|0;if(!ou)Ix=Yv;else{f[ba>>2]=ou;Ix=f[Du>>2]|0}laa(f[pl>>2]|0,Ix);f[ql>>2]=(f[ql>>2]|0)+1}Du=f[nu+4>>2]|0;do if(!Du){ou=nu+8|0;Yv=f[ou>>2]|0;if((f[Yv>>2]|0)==(nu|0)){Jx=Yv;break}else Kx=ou;do{ou=f[Kx>>2]|0;Kx=ou+8|0;Yv=f[Kx>>2]|0}while((f[Yv>>2]|0)!=(ou|0));Jx=Yv}else{mu=Du;while(1){Yv=f[mu>>2]|0;if(!Yv)break;else mu=Yv}Jx=mu}while(0);if((Jx|0)==(Ga|0))break;else nu=Jx}}eJa(YIa(a,q,ba,3,0)|0,w);CFa(ba,f[rl>>2]|0);f[sl>>2]=0;f[tl>>2]=0;f[ca>>2]=ul;nu=f[l>>2]|0;if((nu|0)!=(Ga|0)){Du=nu;while(1){nu=Du+16|0;f[i>>2]=vl;f[e>>2]=f[i>>2];ku=XIa(ca,e,g,h,nu)|0;if(!(f[ku>>2]|0)){Ru=VDc(28)|0;Yv=f[nu>>2]|0;f[Ru+16>>2]=Yv;f[Ru+20>>2]=f[Du+20>>2];if(Yv|0){nu=Yv+-4|0;f[nu>>2]=(f[nu>>2]|0)+1}f[Ru+24>>2]=f[Du+24>>2];nu=f[g>>2]|0;f[Ru>>2]=0;f[Ru+4>>2]=0;f[Ru+8>>2]=nu;f[ku>>2]=Ru;nu=f[f[ca>>2]>>2]|0;if(!nu)Lx=Ru;else{f[ca>>2]=nu;Lx=f[ku>>2]|0}laa(f[sl>>2]|0,Lx);f[tl>>2]=(f[tl>>2]|0)+1}ku=f[Du+4>>2]|0;do if(!ku){nu=Du+8|0;Ru=f[nu>>2]|0;if((f[Ru>>2]|0)==(Du|0)){Mx=Ru;break}else Nx=nu;do{nu=f[Nx>>2]|0;Nx=nu+8|0;Ru=f[Nx>>2]|0}while((f[Ru>>2]|0)!=(nu|0));Mx=Ru}else{mu=ku;while(1){Ru=f[mu>>2]|0;if(!Ru)break;else mu=Ru}Mx=mu}while(0);if((Mx|0)==(Ga|0))break;else Du=Mx}}eJa(YIa(a,q,ca,4,0)|0,x);CFa(ca,f[ul>>2]|0)}Du=f[dc>>2]|0;if((Du|0)==(w|0))Ox=w;else{ku=f[$k>>2]|0;if(ku|0){Ru=ku+12|0;f[Ru>>2]=(f[Ru>>2]|0)+1}Ru=Du+36|0;ku=f[Ru>>2]|0;do if(ku|0){nu=ku+12|0;Yv=f[nu>>2]|0;f[nu>>2]=Yv+-1;if((Yv|0)!=1)break;_S(Du)}while(0);f[Ru>>2]=0;ku=Du+16|0;Yv=Du+4|0;f[ku>>2]=0;f[ku+4>>2]=0;f[ku+8>>2]=0;f[ku+12>>2]=0;if((f[Yv>>2]|0)>0){nu=f[Du+40>>2]|0;ou=0;do{f[nu+(ou<<2)>>2]=0;ou=ou+1|0;Px=f[Yv>>2]|0}while((ou|0)<(Px|0));f[Du>>2]=f[w>>2];if((Px|0)<3)Xa=1737;else Xa=1739}else{f[Du>>2]=f[w>>2];Xa=1737}do if((Xa|0)==1737){Xa=0;ou=f[uk>>2]|0;if((ou|0)>=3){Xa=1739;break}f[Yv>>2]=ou;f[Du+8>>2]=f[vk>>2];f[Du+12>>2]=f[kl>>2];ou=f[yk>>2]|0;nu=f[Du+44>>2]|0;f[nu>>2]=f[ou>>2];f[nu+4>>2]=f[ou+4>>2]}while(0);if((Xa|0)==1739){Xa=0;ZS(Du,w)}f[ku>>2]=f[al>>2];f[Du+20>>2]=f[ll>>2];f[Du+24>>2]=f[ml>>2];f[Du+28>>2]=f[nl>>2];f[Du+32>>2]=f[ol>>2];f[Ru>>2]=f[$k>>2];Ox=f[dc>>2]|0}Yv=Ox+56|0;if((Yv|0)!=(x|0)){ou=f[Zk>>2]|0;if(ou|0){nu=ou+12|0;f[nu>>2]=(f[nu>>2]|0)+1}nu=Ox+92|0;ou=f[nu>>2]|0;do if(ou|0){Lw=ou+12|0;Ov=f[Lw>>2]|0;f[Lw>>2]=Ov+-1;if((Ov|0)!=1)break;_S(Yv)}while(0);f[nu>>2]=0;ou=Ox+72|0;Ru=Ox+60|0;f[ou>>2]=0;f[ou+4>>2]=0;f[ou+8>>2]=0;f[ou+12>>2]=0;if((f[Ru>>2]|0)>0){Du=f[Ox+96>>2]|0;ku=0;do{f[Du+(ku<<2)>>2]=0;ku=ku+1|0;Qx=f[Ru>>2]|0}while((ku|0)<(Qx|0));f[Yv>>2]=f[x>>2];if((Qx|0)<3)Xa=1752;else Xa=1754}else{f[Yv>>2]=f[x>>2];Xa=1752}do if((Xa|0)==1752){Xa=0;ku=f[Ak>>2]|0;if((ku|0)>=3){Xa=1754;break}f[Ru>>2]=ku;f[Ox+64>>2]=f[Bk>>2];f[Ox+68>>2]=f[fl>>2];ku=f[Ek>>2]|0;Du=f[Ox+100>>2]|0;f[Du>>2]=f[ku>>2];f[Du+4>>2]=f[ku+4>>2]}while(0);if((Xa|0)==1754){Xa=0;ZS(Yv,x)}f[ou>>2]=f[_k>>2];f[Ox+76>>2]=f[gl>>2];f[Ox+80>>2]=f[hl>>2];f[Ox+84>>2]=f[il>>2];f[Ox+88>>2]=f[jl>>2];f[nu>>2]=f[Zk>>2]}f[Tt>>2]=0;b[Vk>>0]=7;b[h>>0]=b[428696]|0;b[h+1>>0]=b[428697]|0;b[h+2>>0]=b[428698]|0;b[h+3>>0]=b[428699]|0;b[h+4>>0]=b[428700]|0;b[h+5>>0]=b[428701]|0;b[h+6>>0]=b[428702]|0;b[Wk>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Xk>>2]|0,h,0);Ru=(f[e>>2]|0)==0;cJa(g);if((b[Vk>>0]|0)<0)YDc(f[h>>2]|0);if(!Ru){f[e>>2]=0;f[cl>>2]=0;Ru=tT(e,3)|0;b[Ru>>0]=b[454985]|0;b[Ru+1>>0]=b[454986]|0;b[Ru+2>>0]=b[454987]|0;f[Ut>>2]=0;b[dl>>0]=7;b[h>>0]=b[428696]|0;b[h+1>>0]=b[428697]|0;b[h+2>>0]=b[428698]|0;b[h+3>>0]=b[428699]|0;b[h+4>>0]=b[428700]|0;b[h+5>>0]=b[428701]|0;b[h+6>>0]=b[428702]|0;b[el>>0]=0;Wdc(_b);Ru=dJa($b,h)|0;n[g>>2]=(f[Ru+20>>2]|0)==4?+n[Ru+8>>2]:0.0;eIa(t,e,g)|0;if((b[dl>>0]|0)<0)YDc(f[h>>2]|0);uT(e)}f[e>>2]=0;f[Yk>>2]=0;pv=tT(e,9)|0;qv=454964;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));nu=gGa(c,r,e,t)|0;uT(e);ou=HHa(o,r)|0;f[ou>>2]=nu;$Ia(a,o,c,v,nu,0);nu=f[Zk>>2]|0;do if(nu|0){ou=nu+12|0;Yv=f[ou>>2]|0;f[ou>>2]=Yv+-1;if((Yv|0)!=1)break;_S(x)}while(0);f[Zk>>2]=0;f[_k>>2]=0;f[_k+4>>2]=0;f[_k+8>>2]=0;f[_k+12>>2]=0;if((f[Ak>>2]|0)>0){nu=f[Ck>>2]|0;Yv=0;do{f[nu+(Yv<<2)>>2]=0;Yv=Yv+1|0}while((Yv|0)<(f[Ak>>2]|0))}Yv=f[Ek>>2]|0;if((Yv|0)!=(Dk|0))g0(Yv);Yv=f[$k>>2]|0;do if(Yv|0){nu=Yv+12|0;ou=f[nu>>2]|0;f[nu>>2]=ou+-1;if((ou|0)!=1)break;_S(w)}while(0);f[$k>>2]=0;f[al>>2]=0;f[al+4>>2]=0;f[al+8>>2]=0;f[al+12>>2]=0;if((f[uk>>2]|0)>0){Yv=f[wk>>2]|0;ou=0;do{f[Yv+(ou<<2)>>2]=0;ou=ou+1|0}while((ou|0)<(f[uk>>2]|0))}ou=f[yk>>2]|0;if((ou|0)!=(xk|0))g0(ou);if((b[bl>>0]|0)<0)YDc(f[v>>2]|0);break e}while(0);ou=0;Yv=f[Wa>>2]|0;while(1){if((ou|0)>=(Yv|0)){Xa=1587;break}_Ia(e,f[(f[Fa>>2]|0)+4+(ou<<2)>>2]|0);f[g>>2]=0;f[nj>>2]=0;nu=b[oj>>0]|0;Ru=nu<<24>>24<0?f[pj>>2]|0:nu&255;if(Ru|0){nu=tT(g,Ru)|0;dJc(nu|0,((b[oj>>0]|0)<0?f[e>>2]|0:e)|0,Ru|0)|0}Ru=f[Ga>>2]|0;do if(Ru){nu=f[g>>2]|0;ku=(nu|0)==0?1154740:nu;Du=Ga;Ov=Ru;q:while(1){Lw=Ov;while(1){Jw=f[Lw+16>>2]|0;if((Jw|0)==(nu|0))break;if((Ioc((Jw|0)==0?1154740:Jw,ku)|0)>=0)break;Jw=f[Lw+4>>2]|0;if(!Jw){Rx=Du;break q}else Lw=Jw}Ov=f[Lw>>2]|0;if(!Ov){Rx=Lw;break}else Du=Lw}if((Rx|0)==(Ga|0)){Xa=1459;break}Du=f[Rx+16>>2]|0;if((nu|0)==(Du|0)){Sx=Rx;break}if((Ioc(ku,(Du|0)==0?1154740:Du)|0)>=0)Sx=Rx;else Xa=1459}else Xa=1459;while(0);if((Xa|0)==1459){Xa=0;Sx=Ga}uT(g);if((b[oj>>0]|0)<0)YDc(f[e>>2]|0);Yv=f[Wa>>2]|0;if((Sx|0)!=(Ga|0))break;else ou=ou+1|0}if((Xa|0)==1587){Xa=0;f[e>>2]=0;f[dk>>2]=0;pv=tT(e,9)|0;qv=445470;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));cIa(t,e,445480)|0;uT(e);f[e>>2]=0;f[ek>>2]=0;ou=tT(e,7)|0;b[ou>>0]=b[454641]|0;b[ou+1>>0]=b[454642]|0;b[ou+2>>0]=b[454643]|0;b[ou+3>>0]=b[454644]|0;b[ou+4>>0]=b[454645]|0;b[ou+5>>0]=b[454646]|0;b[ou+6>>0]=b[454647]|0;ou=gGa(c,r,e,t)|0;uT(e);Ru=HHa(o,r)|0;f[Ru>>2]=ou;if((f[Wa>>2]|0)>0)Tx=0;else break e;while(1){_Ia(e,f[(f[Fa>>2]|0)+4+(Tx<<2)>>2]|0);f[g>>2]=0;f[fk>>2]=0;Ru=b[gk>>0]|0;Du=Ru<<24>>24<0?f[hk>>2]|0:Ru&255;if(Du|0){Ru=tT(g,Du)|0;dJc(Ru|0,((b[gk>>0]|0)<0?f[e>>2]|0:e)|0,Du|0)|0}Du=f[wa>>2]|0;do if(Du){Ru=f[g>>2]|0;Ov=(Ru|0)==0?1154740:Ru;mu=wa;Jw=Du;r:while(1){Kw=Jw;while(1){Ux=f[Kw+16>>2]|0;if((Ux|0)==(Ru|0))break;if((Ioc((Ux|0)==0?1154740:Ux,Ov)|0)>=0)break;Ux=f[Kw+4>>2]|0;if(!Ux){Vx=mu;break r}else Kw=Ux}Jw=f[Kw>>2]|0;if(!Jw){Vx=Kw;break}else mu=Kw}if((Vx|0)==(wa|0)){Xa=1600;break}mu=f[Vx+16>>2]|0;if((Ru|0)==(mu|0)){Wx=Vx;break}if((Ioc(Ov,(mu|0)==0?1154740:mu)|0)>=0)Wx=Vx;else Xa=1600}else Xa=1600;while(0);if((Xa|0)==1600){Xa=0;Wx=wa}uT(g);if((Wx|0)==(wa|0)){Xa=1602;break c}$Ia(a,o,c,e,ou,Tx);if((b[gk>>0]|0)<0)YDc(f[e>>2]|0);Tx=Tx+1|0;if((Tx|0)>=(f[Wa>>2]|0))break e}}if((Yv|0)!=2){Xa=1464;break c}f[qj>>2]=0;f[rj>>2]=0;f[X>>2]=sj;ou=f[l>>2]|0;if((ou|0)!=(Ga|0)){Du=ou;while(1){ou=Du+16|0;f[i>>2]=ck;f[e>>2]=f[i>>2];mu=XIa(X,e,g,h,ou)|0;if(!(f[mu>>2]|0)){Jw=VDc(28)|0;ku=f[ou>>2]|0;f[Jw+16>>2]=ku;f[Jw+20>>2]=f[Du+20>>2];if(ku|0){ou=ku+-4|0;f[ou>>2]=(f[ou>>2]|0)+1}f[Jw+24>>2]=f[Du+24>>2];ou=f[g>>2]|0;f[Jw>>2]=0;f[Jw+4>>2]=0;f[Jw+8>>2]=ou;f[mu>>2]=Jw;ou=f[f[X>>2]>>2]|0;if(!ou)Xx=Jw;else{f[X>>2]=ou;Xx=f[mu>>2]|0}laa(f[qj>>2]|0,Xx);f[rj>>2]=(f[rj>>2]|0)+1}mu=f[Du+4>>2]|0;do if(!mu){ou=Du+8|0;Jw=f[ou>>2]|0;if((f[Jw>>2]|0)==(Du|0)){Yx=Jw;break}else Zx=ou;do{ou=f[Zx>>2]|0;Zx=ou+8|0;Jw=f[Zx>>2]|0}while((f[Jw>>2]|0)!=(ou|0));Yx=Jw}else{Ov=mu;while(1){Ru=f[Ov>>2]|0;if(!Ru)break;else Ov=Ru}Yx=Ov}while(0);if((Yx|0)==(Ga|0))break;else Du=Yx}}Vnb(v,YIa(a,q,X,-1,0)|0);CFa(X,f[sj>>2]|0);if((f[v>>2]&4095|0)!=5){Xa=1479;break c}Du=f[tj>>2]|0;if((Du|0)<3)_x=Y(f[vj>>2]|0,f[uj>>2]|0)|0;else{Yv=f[Jj>>2]|0;mu=0;Ru=1;while(1){Jw=Y(f[Yv+(mu<<2)>>2]|0,Ru)|0;mu=mu+1|0;if((mu|0)==(Du|0)){_x=Jw;break}else Ru=Jw}}if((_x|0)==1){f[g>>2]=0;f[wj>>2]=0;Ru=tT(g,7)|0;b[Ru>>0]=b[427628]|0;b[Ru+1>>0]=b[427629]|0;b[Ru+2>>0]=b[427630]|0;b[Ru+3>>0]=b[427631]|0;b[Ru+4>>0]=b[427632]|0;b[Ru+5>>0]=b[427633]|0;b[Ru+6>>0]=b[427634]|0;VIa(e,Ba,r,g);uT(g);Ru=f[e>>2]|0;if((Ru|0)==(f[xj>>2]|0)){f[g>>2]=0;f[yj>>2]=0;Du=tT(g,5)|0;b[Du>>0]=b[451291]|0;b[Du+1>>0]=b[451292]|0;b[Du+2>>0]=b[451293]|0;b[Du+3>>0]=b[451294]|0;b[Du+4>>0]=b[451295]|0;eIa(t,g,f[zj>>2]|0)|0;uT(g);f[g>>2]=0;f[Aj>>2]=0;Du=tT(g,5)|0;b[Du>>0]=b[451285]|0;b[Du+1>>0]=b[451286]|0;b[Du+2>>0]=b[451287]|0;b[Du+3>>0]=b[451288]|0;b[Du+4>>0]=b[451289]|0;Du=gGa(c,r,g,t)|0;uT(g);$x=Du}else{Du=f[Ru+8>>2]|0;Ru=f[(f[Da>>2]|0)+4+(Du<<2)>>2]|0;if((f[Ru+12>>2]|0)!=2){Xa=1487;break c}mu=f[(f[Ru+20>>2]|0)+4>>2]|0;f[g>>2]=0;f[Bj>>2]=0;Ru=mu+11|0;Yv=b[Ru>>0]|0;Jw=Yv<<24>>24<0?f[mu+4>>2]|0:Yv&255;if(!Jw)ay=0;else{Yv=tT(g,Jw)|0;dJc(Yv|0,((b[Ru>>0]|0)<0?f[mu>>2]|0:mu)|0,Jw|0)|0;ay=f[g>>2]|0}Jw=f[r>>2]|0;if((ay|0)==(Jw|0))by=1;else by=(Ioc((ay|0)==0?1154740:ay,(Jw|0)==0?1154740:Jw)|0)==0;uT(g);fJa(Ba,Du,(by^1)&1);Du=f[e>>2]|0;Jw=f[za>>2]|0;s:do if(!Jw){cy=za;dy=za}else{mu=f[Du>>2]|0;Ru=(mu|0)==0?1154740:mu;Yv=f[Jw+16>>2]|0;t:do if((mu|0)!=(Yv|0)){ou=xa;ku=Jw;nu=Yv;while(1){Lw=(nu|0)==0?1154740:nu;if((Ioc(Ru,Lw)|0)<0){Ux=f[ku>>2]|0;if(!Ux){Xa=1497;break}else{ey=ku;fy=Ux}}else{if((Ioc(Lw,Ru)|0)>=0){gy=ou;hy=ku;break t}iy=ku+4|0;Lw=f[iy>>2]|0;if(!Lw){Xa=1500;break}else{ey=iy;fy=Lw}}nu=f[fy+16>>2]|0;if((mu|0)==(nu|0)){gy=ey;hy=fy;break t}else{ou=ey;ku=fy}}if((Xa|0)==1497){Xa=0;cy=ku;dy=ku;break s}else if((Xa|0)==1500){Xa=0;cy=iy;dy=ku;break s}}else{gy=xa;hy=Jw}while(0);cy=gy;dy=hy}while(0);if(!(f[cy>>2]|0)){Jw=VDc(24)|0;mu=f[Du>>2]|0;f[Jw+16>>2]=mu;f[Jw+20>>2]=f[Du+4>>2];if(mu|0){Ru=mu+-4|0;f[Ru>>2]=(f[Ru>>2]|0)+1}f[Jw>>2]=0;f[Jw+4>>2]=0;f[Jw+8>>2]=dy;f[cy>>2]=Jw;Ru=f[f[j>>2]>>2]|0;if(!Ru)jy=Jw;else{f[j>>2]=Ru;jy=f[cy>>2]|0}laa(f[xa>>2]|0,jy);f[ya>>2]=(f[ya>>2]|0)+1}f[g>>2]=0;f[Cj>>2]=0;pv=tT(g,14)|0;qv=454995;rv=pv+14|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));eIa(t,g,f[zj>>2]|0)|0;uT(g);f[g>>2]=0;f[Dj>>2]=0;Du=tT(g,4)|0;b[Du>>0]=82;b[Du+1>>0]=101;b[Du+2>>0]=76;b[Du+3>>0]=85;Du=gGa(c,r,g,t)|0;uT(g);$x=Du}Du=f[e>>2]|0;if(Du|0){while(1){Ru=f[xj>>2]|0;if((Ru|0)==(Du|0))break;Jw=Ru+-12|0;f[xj>>2]=Jw;uT(Jw)}YDc(f[e>>2]|0)}ky=$x}else{cx(dc,1,v);f[e>>2]=0;f[Nj>>2]=0;Du=tT(e,3)|0;b[Du>>0]=b[427390]|0;b[Du+1>>0]=b[427391]|0;b[Du+2>>0]=b[427392]|0;VIa(w,Ba,r,e);uT(e);do if((f[w>>2]|0)!=(f[Oj>>2]|0)){f[e>>2]=0;f[Xj>>2]=0;pv=tT(e,9)|0;qv=454939;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=1;rIa(t,e,g)|0;uT(e);g$(dc,2);Du=f[(f[w>>2]|0)+8>>2]|0;Jw=f[(f[Da>>2]|0)+4+(Du<<2)>>2]|0;f[Yj>>2]=0;f[Zj>>2]=0;f[Z>>2]=_j;Ru=f[l>>2]|0;if((Ru|0)!=(Ga|0)){mu=Ru;while(1){Ru=mu+16|0;f[i>>2]=bk;f[e>>2]=f[i>>2];Yv=XIa(Z,e,g,h,Ru)|0;if(!(f[Yv>>2]|0)){ou=VDc(28)|0;nu=f[Ru>>2]|0;f[ou+16>>2]=nu;f[ou+20>>2]=f[mu+20>>2];if(nu|0){Ru=nu+-4|0;f[Ru>>2]=(f[Ru>>2]|0)+1}f[ou+24>>2]=f[mu+24>>2];Ru=f[g>>2]|0;f[ou>>2]=0;f[ou+4>>2]=0;f[ou+8>>2]=Ru;f[Yv>>2]=ou;Ru=f[f[Z>>2]>>2]|0;if(!Ru)ly=ou;else{f[Z>>2]=Ru;ly=f[Yv>>2]|0}laa(f[Yj>>2]|0,ly);f[Zj>>2]=(f[Zj>>2]|0)+1}Yv=f[mu+4>>2]|0;do if(!Yv){Ru=mu+8|0;ou=f[Ru>>2]|0;if((f[ou>>2]|0)==(mu|0)){my=ou;break}else ny=Ru;do{Ru=f[ny>>2]|0;ny=Ru+8|0;ou=f[ny>>2]|0}while((f[ou>>2]|0)!=(Ru|0));my=ou}else{Kw=Yv;while(1){ou=f[Kw>>2]|0;if(!ou)break;else Kw=ou}my=Kw}while(0);if((my|0)==(Ga|0))break;else mu=my}}mu=YIa(a,Jw,Z,-1,0)|0;eJa(mu,(f[ak>>2]|0)+-56|0);CFa(Z,f[_j>>2]|0);fJa(Ba,Du,0);mu=f[w>>2]|0;Yv=f[za>>2]|0;u:do if(!Yv){oy=za;py=za}else{ku=f[mu>>2]|0;ou=(ku|0)==0?1154740:ku;Ru=f[Yv+16>>2]|0;v:do if((ku|0)!=(Ru|0)){nu=xa;Ov=Yv;Lw=Ru;while(1){Ux=(Lw|0)==0?1154740:Lw;if((Ioc(ou,Ux)|0)<0){qy=f[Ov>>2]|0;if(!qy){Xa=1534;break}else{ry=Ov;sy=qy}}else{if((Ioc(Ux,ou)|0)>=0){ty=nu;uy=Ov;break v}vy=Ov+4|0;Ux=f[vy>>2]|0;if(!Ux){Xa=1537;break}else{ry=vy;sy=Ux}}Lw=f[sy+16>>2]|0;if((ku|0)==(Lw|0)){ty=ry;uy=sy;break v}else{nu=ry;Ov=sy}}if((Xa|0)==1534){Xa=0;oy=Ov;py=Ov;break u}else if((Xa|0)==1537){Xa=0;oy=vy;py=Ov;break u}}else{ty=xa;uy=Yv}while(0);oy=ty;py=uy}while(0);if(f[oy>>2]|0)break;Yv=VDc(24)|0;Du=f[mu>>2]|0;f[Yv+16>>2]=Du;f[Yv+20>>2]=f[mu+4>>2];if(Du|0){Jw=Du+-4|0;f[Jw>>2]=(f[Jw>>2]|0)+1}f[Yv>>2]=0;f[Yv+4>>2]=0;f[Yv+8>>2]=py;f[oy>>2]=Yv;Jw=f[f[j>>2]>>2]|0;if(!Jw)wy=Yv;else{f[j>>2]=Jw;wy=f[oy>>2]|0}laa(f[xa>>2]|0,wy);f[ya>>2]=(f[ya>>2]|0)+1}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Pj>>0]=4;f[h>>2]=1936291937;b[Qj>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Rj>>2]|0,h,0);Jw=(f[e>>2]|0)==0;cJa(g);if((b[Pj>>0]|0)<0)YDc(f[h>>2]|0);if(!Jw){f[e>>2]=0;f[Tj>>2]=0;Jw=tT(e,4)|0;b[Jw>>0]=97;b[Jw+1>>0]=120;b[Jw+2>>0]=105;b[Jw+3>>0]=115;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Uj>>0]=4;f[h>>2]=1936291937;b[Wj>>0]=0;Wdc(_b);Jw=dJa($b,h)|0;Yv=(f[Jw+20>>2]|0)==3;Du=Jw+8|0;Jw=Yv?f[Du+4>>2]|0:0;ku=g;f[ku>>2]=Yv?f[Du>>2]|0:0;f[ku+4>>2]=Jw;mJa(t,e,g)|0;if((b[Uj>>0]|0)<0)YDc(f[h>>2]|0);uT(e)}f[e>>2]=0;f[Sj>>2]=0;Jw=tT(e,5)|0;b[Jw>>0]=b[435704]|0;b[Jw+1>>0]=b[435705]|0;b[Jw+2>>0]=b[435706]|0;b[Jw+3>>0]=b[435707]|0;b[Jw+4>>0]=b[435708]|0;Jw=gGa(c,r,e,t)|0;uT(e);ku=f[w>>2]|0;if(ku|0){while(1){Du=f[Oj>>2]|0;if((Du|0)==(ku|0))break;Yv=Du+-12|0;f[Oj>>2]=Yv;uT(Yv)}YDc(f[w>>2]|0)}ky=Jw}ku=HHa(o,r)|0;f[ku>>2]=ky;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);f[g>>2]=0;f[Ej>>2]=0;ku=b[Fj>>0]|0;Yv=ku<<24>>24<0?f[Gj>>2]|0:ku&255;if(Yv|0){ku=tT(g,Yv)|0;dJc(ku|0,((b[Fj>>0]|0)<0?f[e>>2]|0:e)|0,Yv|0)|0}Yv=f[wa>>2]|0;do if(Yv){ku=f[g>>2]|0;Du=(ku|0)==0?1154740:ku;ou=wa;Ru=Yv;w:while(1){nu=Ru;while(1){Lw=f[nu+16>>2]|0;if((Lw|0)==(ku|0))break;if((Ioc((Lw|0)==0?1154740:Lw,Du)|0)>=0)break;Lw=f[nu+4>>2]|0;if(!Lw){xy=ou;break w}else nu=Lw}Ru=f[nu>>2]|0;if(!Ru){xy=nu;break}else ou=nu}if((xy|0)==(wa|0)){Xa=1568;break}ou=f[xy+16>>2]|0;if((ku|0)==(ou|0)){yy=xy;break}if((Ioc(Du,(ou|0)==0?1154740:ou)|0)>=0)yy=xy;else Xa=1568}else Xa=1568;while(0);if((Xa|0)==1568){Xa=0;yy=wa}uT(g);if((yy|0)==(wa|0)){_Ia(g,f[(f[Fa>>2]|0)+8>>2]|0);$Ia(a,o,c,g,ky,0);if((b[Hj>>0]|0)<0)YDc(f[g>>2]|0)}else{_Ia(g,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,g,ky,0);if((b[Mj>>0]|0)<0)YDc(f[g>>2]|0)}if((b[Fj>>0]|0)<0)YDc(f[e>>2]|0);Yv=f[Ij>>2]|0;do if(Yv|0){Jw=Yv+12|0;ou=f[Jw>>2]|0;f[Jw>>2]=ou+-1;if((ou|0)!=1)break;_S(v)}while(0);f[Ij>>2]=0;f[zj>>2]=0;f[zj+4>>2]=0;f[zj+8>>2]=0;f[zj+12>>2]=0;if((f[tj>>2]|0)>0){Yv=f[Jj>>2]|0;ou=0;do{f[Yv+(ou<<2)>>2]=0;ou=ou+1|0}while((ou|0)<(f[tj>>2]|0))}ou=f[Kj>>2]|0;if((ou|0)!=(Lj|0))g0(ou);break e}while(0);if((f[Wa>>2]|0)!=3){Xa=1348;break c}f[Hi>>2]=0;f[Ii>>2]=0;f[V>>2]=Ji;ou=f[l>>2]|0;if((ou|0)!=(Ga|0)){Yv=ou;while(1){ou=Yv+16|0;f[i>>2]=mj;f[e>>2]=f[i>>2];Jw=XIa(V,e,g,h,ou)|0;if(!(f[Jw>>2]|0)){Ru=VDc(28)|0;mu=f[ou>>2]|0;f[Ru+16>>2]=mu;f[Ru+20>>2]=f[Yv+20>>2];if(mu|0){ou=mu+-4|0;f[ou>>2]=(f[ou>>2]|0)+1}f[Ru+24>>2]=f[Yv+24>>2];ou=f[g>>2]|0;f[Ru>>2]=0;f[Ru+4>>2]=0;f[Ru+8>>2]=ou;f[Jw>>2]=Ru;ou=f[f[V>>2]>>2]|0;if(!ou)zy=Ru;else{f[V>>2]=ou;zy=f[Jw>>2]|0}laa(f[Hi>>2]|0,zy);f[Ii>>2]=(f[Ii>>2]|0)+1}Jw=f[Yv+4>>2]|0;do if(!Jw){ou=Yv+8|0;Ru=f[ou>>2]|0;if((f[Ru>>2]|0)==(Yv|0)){Ay=Ru;break}else By=ou;do{ou=f[By>>2]|0;By=ou+8|0;Ru=f[By>>2]|0}while((f[Ru>>2]|0)!=(ou|0));Ay=Ru}else{Du=Jw;while(1){ku=f[Du>>2]|0;if(!ku)break;else Du=ku}Ay=Du}while(0);if((Ay|0)==(Ga|0))break;else Yv=Ay}}Vnb(v,YIa(a,q,V,1,0)|0);CFa(V,f[Ji>>2]|0);f[Ki>>2]=0;f[Li>>2]=0;f[W>>2]=Mi;Yv=f[l>>2]|0;if((Yv|0)!=(Ga|0)){Jw=Yv;while(1){Yv=Jw+16|0;f[i>>2]=lj;f[e>>2]=f[i>>2];ku=XIa(W,e,g,h,Yv)|0;if(!(f[ku>>2]|0)){Ru=VDc(28)|0;ou=f[Yv>>2]|0;f[Ru+16>>2]=ou;f[Ru+20>>2]=f[Jw+20>>2];if(ou|0){Yv=ou+-4|0;f[Yv>>2]=(f[Yv>>2]|0)+1}f[Ru+24>>2]=f[Jw+24>>2];Yv=f[g>>2]|0;f[Ru>>2]=0;f[Ru+4>>2]=0;f[Ru+8>>2]=Yv;f[ku>>2]=Ru;Yv=f[f[W>>2]>>2]|0;if(!Yv)Cy=Ru;else{f[W>>2]=Yv;Cy=f[ku>>2]|0}laa(f[Ki>>2]|0,Cy);f[Li>>2]=(f[Li>>2]|0)+1}ku=f[Jw+4>>2]|0;do if(!ku){Yv=Jw+8|0;Ru=f[Yv>>2]|0;if((f[Ru>>2]|0)==(Jw|0)){Dy=Ru;break}else Ey=Yv;do{Yv=f[Ey>>2]|0;Ey=Yv+8|0;Ru=f[Ey>>2]|0}while((f[Ru>>2]|0)!=(Yv|0));Dy=Ru}else{Du=ku;while(1){Ru=f[Du>>2]|0;if(!Ru)break;else Du=Ru}Dy=Du}while(0);if((Dy|0)==(Ga|0))break;else Jw=Dy}}Vnb(w,YIa(a,q,W,2,0)|0);CFa(W,f[Mi>>2]|0);if(!(f[Ni>>2]|0)){Xa=1381;break c}Jw=f[Oi>>2]|0;ku=(Jw|0)<3;if(ku)Fy=Y(f[Qi>>2]|0,f[Pi>>2]|0)|0;else{Ru=f[jj>>2]|0;Yv=0;ou=1;while(1){mu=Y(f[Ru+(Yv<<2)>>2]|0,ou)|0;Yv=Yv+1|0;if((Yv|0)==(Jw|0)){Fy=mu;break}else ou=mu}}if((Jw|0)==0|(Fy|0)==0){Xa=1381;break c}if(!(f[Ri>>2]|0)){Xa=1388;break c}ou=f[Si>>2]|0;if((ou|0)<3)Gy=Y(f[Ui>>2]|0,f[Ti>>2]|0)|0;else{Yv=f[gj>>2]|0;Ru=0;mu=1;while(1){Lw=Y(f[Yv+(Ru<<2)>>2]|0,mu)|0;Ru=Ru+1|0;if((Ru|0)==(ou|0)){Gy=Lw;break}else mu=Lw}}if((ou|0)==0|(Gy|0)==0){Xa=1388;break c}Hy=f[v>>2]&4095;if((Hy|0)!=4){Xa=1390;break c}Iy=f[w>>2]&4095;if((Iy|0)!=4){Xa=1392;break c}if(ku)Jy=Y(f[Qi>>2]|0,f[Pi>>2]|0)|0;else{mu=f[jj>>2]|0;Ru=0;Yv=1;while(1){Lw=Y(f[mu+(Ru<<2)>>2]|0,Yv)|0;Ru=Ru+1|0;if((Ru|0)==(Jw|0)){Jy=Lw;break}else Yv=Lw}}do if((Jy|0)==4){Yv=f[r>>2]|0;Jw=f[La>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(Jw>>>0>4294967279){Xa=1399;break c}if(Jw>>>0<11){b[Vi>>0]=Jw;if(!Jw)Ky=e;else{Ly=e;Xa=1403}}else{Ru=Jw+16&-16;mu=VDc(Ru)|0;f[e>>2]=mu;f[Yi>>2]=Ru|-2147483648;f[Zi>>2]=Jw;Ly=mu;Xa=1403}if((Xa|0)==1403){Xa=0;dJc(Ly|0,Yv|0,Jw|0)|0;Ky=Ly}b[Ky+Jw>>0]=0;Jw=(kJa(e,k)|0)==0;if((b[Vi>>0]|0)<0)YDc(f[e>>2]|0);if(!Jw)break;Jw=f[Ni>>2]|0;Yv=(f[Wi>>2]|0)+4|0;mu=f[Yv>>2]|0;Ru=Jw+(mu<<1)|0;ku=Jw+(mu*3|0)|0;mu=f[Ru>>2]|0;f[Ru>>2]=f[ku>>2];f[ku>>2]=mu;mu=f[Yv>>2]|0;Yv=Jw+mu|0;ku=Jw+(mu<<1)|0;mu=f[Yv>>2]|0;f[Yv>>2]=f[ku>>2];f[ku>>2]=mu;mu=f[Ri>>2]|0;ku=(f[Xi>>2]|0)+4|0;Yv=f[ku>>2]|0;Jw=mu+(Yv<<1)|0;Ru=mu+(Yv*3|0)|0;Yv=f[Jw>>2]|0;f[Jw>>2]=f[Ru>>2];f[Ru>>2]=Yv;Yv=f[ku>>2]|0;ku=mu+Yv|0;Ru=mu+(Yv<<1)|0;Yv=f[ku>>2]|0;f[ku>>2]=f[Ru>>2];f[Ru>>2]=Yv}while(0);f[e>>2]=0;f[$i>>2]=0;Yv=tT(e,5)|0;b[Yv>>0]=b[436922]|0;b[Yv+1>>0]=b[436923]|0;b[Yv+2>>0]=b[436924]|0;b[Yv+3>>0]=b[436925]|0;b[Yv+4>>0]=b[436926]|0;Yv=f[Ni>>2]|0;Ru=f[Oi>>2]|0;if((Ru|0)<3)My=Y(f[Qi>>2]|0,f[Pi>>2]|0)|0;else{ku=f[jj>>2]|0;mu=0;Jw=1;while(1){ou=Y(f[ku+(mu<<2)>>2]|0,Jw)|0;mu=mu+1|0;if((mu|0)==(Ru|0)){My=ou;break}else Jw=ou}}Jw=VDc(16)|0;Ru=Jw+8|0;f[Jw>>2]=Ru;f[Jw+4>>2]=My;if(My>>>0>1){mu=XDc(My>>>0>536870911?-1:My<<3)|0;f[Jw>>2]=mu;Ny=mu}else Ny=Ru;f[g>>2]=0;f[aj>>2]=Jw;if((My|0)>0){Jw=Yv;Ru=0;while(1){mu=f[Jw>>2]|0;ku=Ny+(Ru<<3)|0;f[ku>>2]=mu;f[ku+4>>2]=((mu|0)<0)<<31>>31;Ru=Ru+1|0;if((Ru|0)==(My|0))break;else Jw=Jw+4|0}}bIa(t,e,g)|0;JFa(g);uT(e);f[e>>2]=0;f[bj>>2]=0;Jw=tT(e,4)|0;b[Jw>>0]=115;b[Jw+1>>0]=105;b[Jw+2>>0]=122;b[Jw+3>>0]=101;Jw=f[Ri>>2]|0;Ru=f[Si>>2]|0;if((Ru|0)<3)Oy=Y(f[Ui>>2]|0,f[Ti>>2]|0)|0;else{Yv=f[gj>>2]|0;mu=0;ku=1;while(1){ou=Y(f[Yv+(mu<<2)>>2]|0,ku)|0;mu=mu+1|0;if((mu|0)==(Ru|0)){Oy=ou;break}else ku=ou}}ku=VDc(16)|0;Ru=ku+8|0;f[ku>>2]=Ru;f[ku+4>>2]=Oy;if(Oy>>>0>1){mu=XDc(Oy>>>0>536870911?-1:Oy<<3)|0;f[ku>>2]=mu;Py=mu}else Py=Ru;f[g>>2]=0;f[cj>>2]=ku;if((Oy|0)>0){ku=Jw;Ru=0;while(1){mu=f[ku>>2]|0;Yv=Py+(Ru<<3)|0;f[Yv>>2]=mu;f[Yv+4>>2]=((mu|0)<0)<<31>>31;Ru=Ru+1|0;if((Ru|0)==(Oy|0))break;else ku=ku+4|0}}bIa(t,e,g)|0;JFa(g);uT(e);f[e>>2]=0;f[dj>>2]=0;ku=tT(e,5)|0;b[ku>>0]=b[425537]|0;b[ku+1>>0]=b[425538]|0;b[ku+2>>0]=b[425539]|0;b[ku+3>>0]=b[425540]|0;b[ku+4>>0]=b[425541]|0;ku=gGa(c,r,e,t)|0;uT(e);Ru=HHa(o,r)|0;f[Ru>>2]=ku;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,ku,0);if((b[ej>>0]|0)<0)YDc(f[e>>2]|0);ku=f[fj>>2]|0;do if(ku|0){Ru=ku+12|0;Jw=f[Ru>>2]|0;f[Ru>>2]=Jw+-1;if((Jw|0)!=1)break;_S(w)}while(0);f[fj>>2]=0;f[Ri>>2]=0;f[Ri+4>>2]=0;f[Ri+8>>2]=0;f[Ri+12>>2]=0;if((f[Si>>2]|0)>0){ku=f[gj>>2]|0;Jw=0;do{f[ku+(Jw<<2)>>2]=0;Jw=Jw+1|0}while((Jw|0)<(f[Si>>2]|0))}Jw=f[Xi>>2]|0;if((Jw|0)!=(hj|0))g0(Jw);Jw=f[ij>>2]|0;do if(Jw|0){ku=Jw+12|0;Ru=f[ku>>2]|0;f[ku>>2]=Ru+-1;if((Ru|0)!=1)break;_S(v)}while(0);f[ij>>2]=0;f[Ni>>2]=0;f[Ni+4>>2]=0;f[Ni+8>>2]=0;f[Ni+12>>2]=0;if((f[Oi>>2]|0)>0){Jw=f[jj>>2]|0;Ru=0;do{f[Jw+(Ru<<2)>>2]=0;Ru=Ru+1|0}while((Ru|0)<(f[Oi>>2]|0))}Ru=f[Wi>>2]|0;if((Ru|0)!=(kj|0))g0(Ru);break e}while(0);if((f[Wa>>2]|0)!=2){Xa=1322;break c}f[Ai>>2]=0;f[Bi>>2]=0;f[U>>2]=Ci;Ru=f[l>>2]|0;if((Ru|0)!=(Ga|0)){Jw=Ru;while(1){Ru=Jw+16|0;f[i>>2]=Gi;f[e>>2]=f[i>>2];ku=XIa(U,e,g,h,Ru)|0;if(!(f[ku>>2]|0)){mu=VDc(28)|0;Yv=f[Ru>>2]|0;f[mu+16>>2]=Yv;f[mu+20>>2]=f[Jw+20>>2];if(Yv|0){Ru=Yv+-4|0;f[Ru>>2]=(f[Ru>>2]|0)+1}f[mu+24>>2]=f[Jw+24>>2];Ru=f[g>>2]|0;f[mu>>2]=0;f[mu+4>>2]=0;f[mu+8>>2]=Ru;f[ku>>2]=mu;Ru=f[f[U>>2]>>2]|0;if(!Ru)Qy=mu;else{f[U>>2]=Ru;Qy=f[ku>>2]|0}laa(f[Ai>>2]|0,Qy);f[Bi>>2]=(f[Bi>>2]|0)+1}ku=f[Jw+4>>2]|0;do if(!ku){Ru=Jw+8|0;mu=f[Ru>>2]|0;if((f[mu>>2]|0)==(Jw|0)){Ry=mu;break}else Sy=Ru;do{Ru=f[Sy>>2]|0;Sy=Ru+8|0;mu=f[Sy>>2]|0}while((f[mu>>2]|0)!=(Ru|0));Ry=mu}else{mu=ku;while(1){Ru=f[mu>>2]|0;if(!Ru)break;else mu=Ru}Ry=mu}while(0);if((Ry|0)==(Ga|0))break;else Jw=Ry}}Jw=(YIa(a,q,U,0,0)|0)+48|0;ku=f[(f[Jw>>2]|0)+4>>2]|0;CFa(U,f[Ci>>2]|0);f[g>>2]=0;f[Di>>2]=0;Jw=tT(g,4)|0;b[Jw>>0]=97;b[Jw+1>>0]=120;b[Jw+2>>0]=105;b[Jw+3>>0]=115;Jw=ku+4|0;if(Jw>>>0>=8){Xa=1337;break c}do if(ku)if((ku|0)>0){Ty=((ku>>>0)%3|0)+1|0;break}else{Ty=((Jw>>>0)%3|0)+1|0;break}else Ty=0;while(0);f[h>>2]=Ty;$Ha(t,g,h)|0;uT(g);f[e>>2]=0;f[Ei>>2]=0;Jw=tT(e,5)|0;b[Jw>>0]=b[425537]|0;b[Jw+1>>0]=b[425538]|0;b[Jw+2>>0]=b[425539]|0;b[Jw+3>>0]=b[425540]|0;b[Jw+4>>0]=b[425541]|0;Jw=gGa(c,r,e,t)|0;uT(e);ku=HHa(o,r)|0;f[ku>>2]=Jw;_Ia(e,f[(f[Fa>>2]|0)+8>>2]|0);$Ia(a,o,c,e,Jw,0);if((b[Fi>>0]|0)<0)YDc(f[e>>2]|0);break e}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[si>>0]=5;b[h>>0]=b[383796]|0;b[h+1>>0]=b[383797]|0;b[h+2>>0]=b[383798]|0;b[h+3>>0]=b[383799]|0;b[h+4>>0]=b[383800]|0;b[ti>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[ui>>2]|0,h,0);Jw=f[e>>2]|0;cJa(g);if(!Jw)Uy=1;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[yi>>0]=5;b[e>>0]=b[383796]|0;b[e+1>>0]=b[383797]|0;b[e+2>>0]=b[383798]|0;b[e+3>>0]=b[383799]|0;b[e+4>>0]=b[383800]|0;b[zi>>0]=0;Wdc(_b);Jw=dJa($b,e)|0;ku=(f[Jw+20>>2]|0)!=6?1:(f[Jw+8>>2]|0)!=10;if((b[yi>>0]|0)<0)YDc(f[e>>2]|0);Uy=ku}if((b[si>>0]|0)<0)YDc(f[h>>2]|0);if(!Uy)break e;ku=f[vi>>2]|0;if((ku|0)==(f[wi>>2]|0))L_(xi,r);else{Jw=f[r>>2]|0;f[ku>>2]=Jw;f[ku+4>>2]=f[La>>2];if(!Jw)Vy=ku;else{ku=Jw+-4|0;f[ku>>2]=(f[ku>>2]|0)+1;Vy=f[vi>>2]|0}f[vi>>2]=Vy+8}ku=HHa(o,r)|0;f[ku>>2]=0;break e}while(0);f[e>>2]=0;f[oi>>2]=0;ku=tT(e,4)|0;b[ku>>0]=112;b[ku+1>>0]=111;b[ku+2>>0]=111;b[ku+3>>0]=108;qIa(t,e,454856)|0;uT(e);f[e>>2]=0;f[pi>>2]=0;pv=tT(e,20)|0;qv=452723;rv=pv+20|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=0;rIa(t,e,g)|0;uT(e);lJa(t,q);iJa(t,q);jJa(t,q);f[e>>2]=0;f[qi>>2]=0;ku=tT(e,7)|0;b[ku>>0]=b[454888]|0;b[ku+1>>0]=b[454889]|0;b[ku+2>>0]=b[454890]|0;b[ku+3>>0]=b[454891]|0;b[ku+4>>0]=b[454892]|0;b[ku+5>>0]=b[454893]|0;b[ku+6>>0]=b[454894]|0;ku=gGa(c,r,e,t)|0;uT(e);Jw=HHa(o,r)|0;f[Jw>>2]=ku;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);Jw=f[Wa>>2]|0;if((Jw|0)>0){Ru=0;do{$Ia(a,o,c,e,ku,Ru);Ru=Ru+1|0}while((Ru|0)!=(Jw|0))}if((b[ri>>0]|0)<0)YDc(f[e>>2]|0);break e}while(0);f[e>>2]=0;f[li>>2]=0;Jw=tT(e,4)|0;b[Jw>>0]=112;b[Jw+1>>0]=111;b[Jw+2>>0]=111;b[Jw+3>>0]=108;qIa(t,e,454907)|0;uT(e);lJa(t,q);iJa(t,q);jJa(t,q);f[e>>2]=0;f[mi>>2]=0;Jw=tT(e,7)|0;b[Jw>>0]=b[454888]|0;b[Jw+1>>0]=b[454889]|0;b[Jw+2>>0]=b[454890]|0;b[Jw+3>>0]=b[454891]|0;b[Jw+4>>0]=b[454892]|0;b[Jw+5>>0]=b[454893]|0;b[Jw+6>>0]=b[454894]|0;Jw=gGa(c,r,e,t)|0;uT(e);Ru=HHa(o,r)|0;f[Ru>>2]=Jw;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);Ru=f[Wa>>2]|0;if((Ru|0)>0){ku=0;do{$Ia(a,o,c,e,Jw,ku);ku=ku+1|0}while((ku|0)!=(Ru|0))}if((b[ni>>0]|0)<0)YDc(f[e>>2]|0);break e}while(0);if(!(Ioc(yu,454781)|0)){xu=0;break}xu=(f[Wa>>2]|0)+-1|0}while(0);f[_h>>2]=0;f[$h>>2]=0;f[T>>2]=ai;Ru=f[l>>2]|0;if((Ru|0)!=(Ga|0)){ku=Ru;while(1){Ru=ku+16|0;f[i>>2]=ki;f[e>>2]=f[i>>2];Jw=XIa(T,e,g,h,Ru)|0;if(!(f[Jw>>2]|0)){Yv=VDc(28)|0;ou=f[Ru>>2]|0;f[Yv+16>>2]=ou;f[Yv+20>>2]=f[ku+20>>2];if(ou|0){Ru=ou+-4|0;f[Ru>>2]=(f[Ru>>2]|0)+1}f[Yv+24>>2]=f[ku+24>>2];Ru=f[g>>2]|0;f[Yv>>2]=0;f[Yv+4>>2]=0;f[Yv+8>>2]=Ru;f[Jw>>2]=Yv;Ru=f[f[T>>2]>>2]|0;if(!Ru)Wy=Yv;else{f[T>>2]=Ru;Wy=f[Jw>>2]|0}laa(f[_h>>2]|0,Wy);f[$h>>2]=(f[$h>>2]|0)+1}Jw=f[ku+4>>2]|0;do if(!Jw){Ru=ku+8|0;Yv=f[Ru>>2]|0;if((f[Yv>>2]|0)==(ku|0)){Xy=Yv;break}else Yy=Ru;do{Ru=f[Yy>>2]|0;Yy=Ru+8|0;Yv=f[Yy>>2]|0}while((f[Yv>>2]|0)!=(Ru|0));Xy=Yv}else{Yv=Jw;while(1){Ru=f[Yv>>2]|0;if(!Ru)break;else Yv=Ru}Xy=Yv}while(0);if((Xy|0)==(Ga|0))break;else ku=Xy}}ku=(YIa(a,q,T,xu,0)|0)+48|0;Jw=f[(f[ku>>2]|0)+4>>2]|0;CFa(T,f[ai>>2]|0);f[v>>2]=Jw;Jw=f[r>>2]|0;ku=f[La>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(ku>>>0>4294967279){Xa=1249;break c}if(ku>>>0<11){b[bi>>0]=ku;if(!ku)Zy=e;else{_y=e;Xa=1253}}else{Ru=ku+16&-16;ou=VDc(Ru)|0;f[e>>2]=ou;f[ii>>2]=Ru|-2147483648;f[ji>>2]=ku;_y=ou;Xa=1253}if((Xa|0)==1253){Xa=0;dJc(_y|0,Jw|0,ku|0)|0;Zy=_y}b[Zy+ku>>0]=0;ku=(kJa(e,k)|0)==0;if((b[bi>>0]|0)<0)YDc(f[e>>2]|0);if(ku){ku=f[v>>2]|0;Jw=ku+4|0;if(Jw>>>0>=8){Xa=1258;break c}do if(ku)if((ku|0)>0){$y=((ku>>>0)%3|0)+1|0;break}else{$y=((Jw>>>0)%3|0)+1|0;break}else $y=0;while(0);f[v>>2]=$y}f[e>>2]=0;f[ci>>2]=0;Jw=tT(e,4)|0;b[Jw>>0]=97;b[Jw+1>>0]=120;b[Jw+2>>0]=105;b[Jw+3>>0]=115;$Ha(t,e,v)|0;uT(e);f[e>>2]=0;f[di>>2]=0;Jw=tT(e,6)|0;b[Jw>>0]=b[454781]|0;b[Jw+1>>0]=b[454782]|0;b[Jw+2>>0]=b[454783]|0;b[Jw+3>>0]=b[454784]|0;b[Jw+4>>0]=b[454785]|0;b[Jw+5>>0]=b[454786]|0;Jw=gGa(c,r,e,t)|0;uT(e);ku=HHa(o,r)|0;f[ku>>2]=Jw;ku=f[s>>2]|0;do if((ku|0)==454781){az=1;Xa=1266}else{ou=(Ioc((ku|0)==0?1154740:ku,454781)|0)==0;Ru=ou&1;if(ou){az=Ru;Xa=1266;break}bz=Ru;cz=(f[Wa>>2]|0)+-1|0}while(0);if((Xa|0)==1266){Xa=0;bz=az;cz=f[Wa>>2]|0}if((bz|0)<(cz|0)){ku=bz;do{_Ia(e,f[(f[Fa>>2]|0)+4+(ku<<2)>>2]|0);f[g>>2]=0;f[fi>>2]=0;Ru=b[gi>>0]|0;ou=Ru<<24>>24<0?f[hi>>2]|0:Ru&255;if(ou|0){Ru=tT(g,ou)|0;dJc(Ru|0,((b[gi>>0]|0)<0?f[e>>2]|0:e)|0,ou|0)|0}ou=f[wa>>2]|0;do if(ou){Ru=f[g>>2]|0;Lw=(Ru|0)==0?1154740:Ru;Kw=wa;Ux=ou;x:while(1){qy=Ux;while(1){dz=f[qy+16>>2]|0;if((dz|0)==(Ru|0))break;if((Ioc((dz|0)==0?1154740:dz,Lw)|0)>=0)break;dz=f[qy+4>>2]|0;if(!dz){ez=Kw;break x}else qy=dz}Ux=f[qy>>2]|0;if(!Ux){ez=qy;break}else Kw=qy}if((ez|0)==(wa|0)){Xa=1282;break}Kw=f[ez+16>>2]|0;if((Ru|0)==(Kw|0)){fz=ez;break}if((Ioc(Lw,(Kw|0)==0?1154740:Kw)|0)>=0)fz=ez;else Xa=1282}else Xa=1282;while(0);if((Xa|0)==1282){Xa=0;fz=wa}uT(g);if((fz|0)==(wa|0)){Xa=1284;break c}$Ia(a,o,c,e,Jw,ku-bz|0);if((b[gi>>0]|0)<0)YDc(f[e>>2]|0);ku=ku+1|0}while((ku|0)<(cz|0))}break e}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[xh>>0]=5;b[h>>0]=b[434804]|0;b[h+1>>0]=b[434805]|0;b[h+2>>0]=b[434806]|0;b[h+3>>0]=b[434807]|0;b[h+4>>0]=b[434808]|0;b[yh>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[zh>>2]|0,h,0);ku=(f[e>>2]|0)==0;cJa(g);if((b[xh>>0]|0)<0)YDc(f[h>>2]|0);if(!ku){f[e>>2]=0;f[Xh>>2]=0;ku=tT(e,5)|0;b[ku>>0]=b[434804]|0;b[ku+1>>0]=b[434805]|0;b[ku+2>>0]=b[434806]|0;b[ku+3>>0]=b[434807]|0;b[ku+4>>0]=b[434808]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Yh>>0]=5;b[h>>0]=b[434804]|0;b[h+1>>0]=b[434805]|0;b[h+2>>0]=b[434806]|0;b[h+3>>0]=b[434807]|0;b[h+4>>0]=b[434808]|0;b[Zh>>0]=0;Wdc(_b);ku=dJa($b,h)|0;n[g>>2]=(f[ku+20>>2]|0)==4?+n[ku+8>>2]:0.0;eIa(t,e,g)|0;if((b[Yh>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Ah>>0]=4;f[h>>2]=1635018082;b[Bh>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Ch>>2]|0,h,0);ku=(f[e>>2]|0)==0;cJa(g);if((b[Ah>>0]|0)<0)YDc(f[h>>2]|0);if(!ku){f[e>>2]=0;f[Uh>>2]=0;ku=tT(e,4)|0;b[ku>>0]=98;b[ku+1>>0]=101;b[ku+2>>0]=116;b[ku+3>>0]=97;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Vh>>0]=4;f[h>>2]=1635018082;b[Wh>>0]=0;Wdc(_b);ku=dJa($b,h)|0;n[g>>2]=(f[ku+20>>2]|0)==4?+n[ku+8>>2]:0.0;eIa(t,e,g)|0;if((b[Vh>>0]|0)<0)YDc(f[h>>2]|0);uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;ku=VDc(16)|0;f[h>>2]=ku;f[Dh>>2]=-2147483632;f[Eh>>2]=12;pv=ku;qv=383718;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[ku+12>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Fh>>2]|0,h,0);Jw=(f[e>>2]|0)==0;cJa(g);if((b[Gh>>0]|0)<0)YDc(f[h>>2]|0);if(!Jw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Jw=VDc(16)|0;f[e>>2]=Jw;f[Qh>>2]=-2147483632;f[Rh>>2]=12;pv=Jw;qv=383718;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Jw+12>>0]=0;Wdc(_b);ku=dJa($b,e)|0;ou=(f[ku+20>>2]|0)==3;Kw=f[ku+8>>2]|0;if((b[Sh>>0]|0)<0)YDc(f[e>>2]|0);f[e>>2]=0;f[Th>>2]=0;pv=tT(e,10)|0;qv=434734;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));f[g>>2]=ou?Kw<<1|1:1;$Ha(t,e,g)|0;uT(e)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Hh>>0]=4;f[h>>2]=1935763810;b[Ih>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Jh>>2]|0,h,0);Jw=(f[e>>2]|0)==0;cJa(g);if((b[Hh>>0]|0)<0)YDc(f[h>>2]|0);if(!Jw){f[e>>2]=0;f[Nh>>2]=0;Jw=tT(e,4)|0;b[Jw>>0]=98;b[Jw+1>>0]=105;b[Jw+2>>0]=97;b[Jw+3>>0]=115;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Oh>>0]=4;f[h>>2]=1935763810;b[Ph>>0]=0;Wdc(_b);Jw=dJa($b,h)|0;n[g>>2]=(f[Jw+20>>2]|0)==4?+n[Jw+8>>2]:0.0;eIa(t,e,g)|0;if((b[Oh>>0]|0)<0)YDc(f[h>>2]|0);uT(e)}f[e>>2]=0;f[Kh>>2]=0;pv=tT(e,12)|0;qv=434810;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=0;rIa(t,e,g)|0;uT(e);f[e>>2]=0;f[Lh>>2]=0;Kw=tT(e,3)|0;b[Kw>>0]=b[425608]|0;b[Kw+1>>0]=b[425609]|0;b[Kw+2>>0]=b[425610]|0;Kw=gGa(c,r,e,t)|0;uT(e);ou=HHa(o,r)|0;f[ou>>2]=Kw;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);ou=f[Wa>>2]|0;if((ou|0)>0){Jw=0;do{$Ia(a,o,c,e,Kw,Jw);Jw=Jw+1|0}while((Jw|0)!=(ou|0))}if((b[Mh>>0]|0)<0)YDc(f[e>>2]|0);break e}while(0);f[fh>>2]=0;f[gh>>2]=0;f[S>>2]=hh;ou=f[l>>2]|0;if((ou|0)!=(Ga|0)){Jw=ou;while(1){ou=Jw+16|0;f[i>>2]=wh;f[e>>2]=f[i>>2];Kw=XIa(S,e,g,h,ou)|0;if(!(f[Kw>>2]|0)){ku=VDc(28)|0;Ux=f[ou>>2]|0;f[ku+16>>2]=Ux;f[ku+20>>2]=f[Jw+20>>2];if(Ux|0){ou=Ux+-4|0;f[ou>>2]=(f[ou>>2]|0)+1}f[ku+24>>2]=f[Jw+24>>2];ou=f[g>>2]|0;f[ku>>2]=0;f[ku+4>>2]=0;f[ku+8>>2]=ou;f[Kw>>2]=ku;ou=f[f[S>>2]>>2]|0;if(!ou)gz=ku;else{f[S>>2]=ou;gz=f[Kw>>2]|0}laa(f[fh>>2]|0,gz);f[gh>>2]=(f[gh>>2]|0)+1}Kw=f[Jw+4>>2]|0;do if(!Kw){ou=Jw+8|0;ku=f[ou>>2]|0;if((f[ku>>2]|0)==(Jw|0)){hz=ku;break}else iz=ou;do{ou=f[iz>>2]|0;iz=ou+8|0;ku=f[iz>>2]|0}while((f[ku>>2]|0)!=(ou|0));hz=ku}else{ku=Kw;while(1){ou=f[ku>>2]|0;if(!ou)break;else ku=ou}hz=ku}while(0);if((hz|0)==(Ga|0))break;else Jw=hz}}Vnb(v,YIa(a,q,S,1,0)|0);CFa(S,f[hh>>2]|0);if((f[v>>2]&4095|0)!=4){Xa=1151;break c}Jw=f[ih>>2]|0;Kw=f[jh>>2]|0;if((Kw|0)<3)jz=Y(f[lh>>2]|0,f[kh>>2]|0)|0;else{ou=f[ph>>2]|0;Ux=0;Yv=1;while(1){dz=Y(f[ou+(Ux<<2)>>2]|0,Yv)|0;Ux=Ux+1|0;if((Ux|0)==(Kw|0)){jz=dz;break}else Yv=dz}}if((jz|0)==4){y:do switch(kJa(f[(f[Fa>>2]|0)+4>>2]|0,k)|0){case 0:{if(f[Jw>>2]|0){Xa=1164;break c}switch(f[Jw+4>>2]|0){case 3:{if((f[Jw+8>>2]|0)!=1){Xa=1164;break c}if((f[Jw+12>>2]|0)==2){kz=1;Xa=1172;break y}else{Xa=1164;break c}break}case 1:{if((f[Jw+8>>2]|0)!=2){Xa=1164;break c}if((f[Jw+12>>2]|0)==3){kz=0;Xa=1172;break y}else{Xa=1164;break c}break}default:{Xa=1164;break c}}break}case 1:{if(f[Jw>>2]|0){Xa=1171;break c}switch(f[Jw+4>>2]|0){case 2:{if((f[Jw+8>>2]|0)!=3){Xa=1171;break c}if((f[Jw+12>>2]|0)==1){kz=0;Xa=1172;break y}else{Xa=1171;break c}break}case 1:{if((f[Jw+8>>2]|0)!=2){Xa=1171;break c}if((f[Jw+12>>2]|0)==3){kz=1;Xa=1172;break y}else{Xa=1171;break c}break}default:{Xa=1171;break c}}break}default:{}}while(0);if((Xa|0)==1172){Xa=0;Yv=HHa(k,r)|0;f[Yv>>2]=kz}f[e>>2]=0;f[mh>>2]=0;Yv=tT(e,8)|0;Kw=Yv;b[Kw>>0]=73;b[Kw+1>>0]=100;b[Kw+2>>0]=101;b[Kw+3>>0]=110;Kw=Yv+4|0;b[Kw>>0]=116;b[Kw+1>>0]=105;b[Kw+2>>0]=116;b[Kw+3>>0]=121;Kw=gGa(c,r,e,t)|0;uT(e);Yv=HHa(o,r)|0;f[Yv>>2]=Kw;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,Kw,0);if((b[nh>>0]|0)<0)YDc(f[e>>2]|0)}else{f[e>>2]=0;f[sh>>2]=0;Kw=tT(e,5)|0;b[Kw>>0]=b[454713]|0;b[Kw+1>>0]=b[454714]|0;b[Kw+2>>0]=b[454715]|0;b[Kw+3>>0]=b[454716]|0;b[Kw+4>>0]=b[454717]|0;Kw=f[jh>>2]|0;if((Kw|0)<3)lz=Y(f[lh>>2]|0,f[kh>>2]|0)|0;else{Yv=f[ph>>2]|0;Ux=0;ou=1;while(1){dz=Y(f[Yv+(Ux<<2)>>2]|0,ou)|0;Ux=Ux+1|0;if((Ux|0)==(Kw|0)){lz=dz;break}else ou=dz}}ou=VDc(16)|0;Kw=ou+8|0;f[ou>>2]=Kw;f[ou+4>>2]=lz;if(lz>>>0>1){Ux=XDc(lz>>>0>536870911?-1:lz<<3)|0;f[ou>>2]=Ux;mz=Ux}else mz=Kw;f[g>>2]=0;f[th>>2]=ou;if((lz|0)>0){ou=Jw;Kw=0;while(1){Ux=f[ou>>2]|0;Yv=mz+(Kw<<3)|0;f[Yv>>2]=Ux;f[Yv+4>>2]=((Ux|0)<0)<<31>>31;Kw=Kw+1|0;if((Kw|0)==(lz|0))break;else ou=ou+4|0}}bIa(t,e,g)|0;JFa(g);uT(e);f[e>>2]=0;f[uh>>2]=0;ou=tT(e,7)|0;b[ou>>0]=b[454705]|0;b[ou+1>>0]=b[454706]|0;b[ou+2>>0]=b[454707]|0;b[ou+3>>0]=b[454708]|0;b[ou+4>>0]=b[454709]|0;b[ou+5>>0]=b[454710]|0;b[ou+6>>0]=b[454711]|0;ou=gGa(c,r,e,t)|0;uT(e);Kw=HHa(o,r)|0;f[Kw>>2]=ou;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,ou,0);if((b[vh>>0]|0)<0)YDc(f[e>>2]|0);ou=HHa(k,r)|0;f[ou>>2]=2}ou=f[oh>>2]|0;do if(ou|0){Kw=ou+12|0;Jw=f[Kw>>2]|0;f[Kw>>2]=Jw+-1;if((Jw|0)!=1)break;_S(v)}while(0);f[oh>>2]=0;f[ih>>2]=0;f[ih+4>>2]=0;f[ih+8>>2]=0;f[ih+12>>2]=0;if((f[jh>>2]|0)>0){ou=f[ph>>2]|0;Jw=0;do{f[ou+(Jw<<2)>>2]=0;Jw=Jw+1|0}while((Jw|0)<(f[jh>>2]|0))}Jw=f[qh>>2]|0;if((Jw|0)!=(rh|0))g0(Jw);break e}while(0);_Ia(h,f[(f[Fa>>2]|0)+4>>2]|0);lu=kJa(f[(f[Fa>>2]|0)+4>>2]|0,k)|0;Jw=f[s>>2]|0;do if((Jw|0)!=383548){if(!(Ioc((Jw|0)==0?1154740:Jw,383548)|0)){Xa=1083;break}if(!lu)Xa=1100}else Xa=1083;while(0);z:do if((Xa|0)==1083){Xa=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Jw=VDc(16)|0;f[i>>2]=Jw;f[Hg>>2]=-2147483632;f[Ig>>2]=12;pv=Jw;qv=383556;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Jw+12>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Jg>>2]|0,i,0);ou=(f[e>>2]|0)==0;cJa(g);if((b[Kg>>0]|0)<0)YDc(f[i>>2]|0);if(ou){Xa=1086;break c};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ou=VDc(16)|0;f[e>>2]=ou;f[Lg>>2]=-2147483632;f[Mg>>2]=12;pv=ou;qv=383556;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[ou+12>>0]=0;Wdc(_b);Jw=dJa($b,e)|0;if((b[Ng>>0]|0)<0)YDc(f[e>>2]|0);switch(lu|0){case 0:{Kw=(f[Jw+20>>2]|0)==1?f[Jw+8>>2]|0:520336;if((f[Kw+24>>2]|0)!=2){Xa=1093;break c}Ux=f[Kw+32>>2]|0;Kw=Ux+8|0;if(!((f[Kw>>2]|0)==1&(f[Kw+4>>2]|0)==0)){Xa=1093;break c}Kw=Ux+16|0;if((f[Kw>>2]|0)==2&(f[Kw+4>>2]|0)==0){Xa=1100;break z}else{Xa=1093;break c}break}case 1:{Kw=(f[Jw+20>>2]|0)==1?f[Jw+8>>2]|0:520336;if((f[Kw+24>>2]|0)!=2){Xa=1097;break c}Jw=f[Kw+32>>2]|0;Kw=Jw+8|0;if(!((f[Kw>>2]|0)==2&(f[Kw+4>>2]|0)==0)){Xa=1097;break c}Kw=Jw+16|0;if((f[Kw>>2]|0)==3&(f[Kw+4>>2]|0)==0)break z;else{Xa=1097;break c}break}default:{Xa=1098;break c}}}while(0);if((Xa|0)==1100){Xa=0;f[Og>>2]=0;f[Pg>>2]=0;f[e>>2]=Qg;f[Rg>>2]=0;f[Rg+4>>2]=0;f[Rg+8>>2]=0;f[Rg+12>>2]=0;f[Rg+16>>2]=0;f[Rg+20>>2]=0;f[Rg+24>>2]=0;f[g>>2]=0;f[Sg>>2]=0;lu=tT(g,5)|0;b[lu>>0]=b[454713]|0;b[lu+1>>0]=b[454714]|0;b[lu+2>>0]=b[454715]|0;b[lu+3>>0]=b[454716]|0;b[lu+4>>0]=b[454717]|0;lu=VDc(16)|0;f[lu>>2]=lu+8;f[lu+4>>2]=4;Kw=XDc(32)|0;f[lu>>2]=Kw;f[i>>2]=0;f[Tg>>2]=lu;lu=Kw;f[lu>>2]=0;f[lu+4>>2]=0;lu=Kw+8|0;f[lu>>2]=2;f[lu+4>>2]=0;lu=Kw+16|0;f[lu>>2]=3;f[lu+4>>2]=0;lu=Kw+24|0;f[lu>>2]=1;f[lu+4>>2]=0;bIa(e,g,i)|0;JFa(i);uT(g);f[R>>2]=0;f[Ug>>2]=0;tT(R,(f[La>>2]|0)+5|0)|0;lu=f[La>>2]|0;if(!lu)nz=0;else{dJc(f[R>>2]|0,f[r>>2]|0,lu|0)|0;nz=f[La>>2]|0}lu=(f[R>>2]|0)+nz|0;b[lu>>0]=b[383500]|0;b[lu+1>>0]=b[383501]|0;b[lu+2>>0]=b[383502]|0;b[lu+3>>0]=b[383503]|0;b[lu+4>>0]=b[383504]|0;lu=f[R>>2]|0;Kw=f[Ug>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(Kw>>>0>4294967279){Xa=1103;break c}if(Kw>>>0<11){b[Vg>>0]=Kw;if(!Kw)oz=g;else{pz=g;Xa=1107}}else{Jw=Kw+16&-16;Ux=VDc(Jw)|0;f[g>>2]=Ux;f[ch>>2]=Jw|-2147483648;f[Xg>>2]=Kw;pz=Ux;Xa=1107}if((Xa|0)==1107){Xa=0;dJc(pz|0,lu|0,Kw|0)|0;oz=pz}b[oz+Kw>>0]=0;uT(R);f[i>>2]=0;f[Wg>>2]=0;Kw=b[Vg>>0]|0;lu=Kw<<24>>24<0?f[Xg>>2]|0:Kw&255;if(lu|0){Kw=tT(i,lu)|0;dJc(Kw|0,((b[Vg>>0]|0)<0?f[g>>2]|0:g)|0,lu|0)|0}lu=f[wa>>2]|0;do if(lu){Kw=f[i>>2]|0;Ux=(Kw|0)==0?1154740:Kw;Jw=wa;Yv=lu;A:while(1){dz=Yv;while(1){qz=f[dz+16>>2]|0;if((qz|0)==(Kw|0))break;if((Ioc((qz|0)==0?1154740:qz,Ux)|0)>=0)break;qz=f[dz+4>>2]|0;if(!qz){rz=Jw;break A}else dz=qz}Yv=f[dz>>2]|0;if(!Yv){rz=dz;break}else Jw=dz}if((rz|0)==(wa|0)){Xa=1120;break}Jw=f[rz+16>>2]|0;if((Kw|0)==(Jw|0)){sz=rz;break}if((Ioc(Ux,(Jw|0)==0?1154740:Jw)|0)>=0)sz=rz;else Xa=1120}else Xa=1120;while(0);if((Xa|0)==1120){Xa=0;sz=wa}uT(i);if((sz|0)!=(wa|0)){Xa=1122;break c}f[i>>2]=0;f[Yg>>2]=0;lu=b[Vg>>0]|0;Jw=lu<<24>>24<0?f[Xg>>2]|0:lu&255;if(Jw|0){lu=tT(i,Jw)|0;dJc(lu|0,((b[Vg>>0]|0)<0?f[g>>2]|0:g)|0,Jw|0)|0}f[v>>2]=0;f[Zg>>2]=0;Jw=tT(v,7)|0;b[Jw>>0]=b[454705]|0;b[Jw+1>>0]=b[454706]|0;b[Jw+2>>0]=b[454707]|0;b[Jw+3>>0]=b[454708]|0;b[Jw+4>>0]=b[454709]|0;b[Jw+5>>0]=b[454710]|0;b[Jw+6>>0]=b[454711]|0;Jw=gGa(c,i,v,e)|0;uT(v);uT(i);f[i>>2]=0;f[_g>>2]=0;lu=b[Vg>>0]|0;Yv=lu<<24>>24<0?f[Xg>>2]|0:lu&255;if(Yv|0){lu=tT(i,Yv)|0;dJc(lu|0,((b[Vg>>0]|0)<0?f[g>>2]|0:g)|0,Yv|0)|0}Yv=HHa(o,i)|0;f[Yv>>2]=Jw;uT(i);$Ia(a,o,c,h,Jw,0);fEc(i,g);f[$g>>2]=0;iEc(h,i)|0;f[ah>>2]=f[$g>>2];if((b[bh>>0]|0)<0)YDc(f[i>>2]|0);if((b[Vg>>0]|0)<0)YDc(f[g>>2]|0);HFa(e)}f[e>>2]=0;f[dh>>2]=0;Jw=tT(e,7)|0;b[Jw>>0]=b[428347]|0;b[Jw+1>>0]=b[428348]|0;b[Jw+2>>0]=b[428349]|0;b[Jw+3>>0]=b[428350]|0;b[Jw+4>>0]=b[428351]|0;b[Jw+5>>0]=b[428352]|0;b[Jw+6>>0]=b[428353]|0;Jw=gGa(c,r,e,t)|0;uT(e);Yv=HHa(o,r)|0;f[Yv>>2]=Jw;$Ia(a,o,c,h,Jw,0);Jw=HHa(k,r)|0;f[Jw>>2]=3;if((b[eh>>0]|0)<0)YDc(f[h>>2]|0);break e}while(0);_Ia(v,f[(f[Fa>>2]|0)+4>>2]|0);Va=kJa(f[(f[Fa>>2]|0)+4>>2]|0,k)|0;Jw=f[(f[Fa>>2]|0)+8>>2]|0;f[e>>2]=0;f[Zf>>2]=0;Yv=Jw+11|0;lu=b[Yv>>0]|0;ou=lu<<24>>24<0?f[Jw+4>>2]|0:lu&255;if(ou|0){lu=tT(e,ou)|0;dJc(lu|0,((b[Yv>>0]|0)<0?f[Jw>>2]|0:Jw)|0,ou|0)|0}ou=f[Ga>>2]|0;do if(ou){Jw=f[e>>2]|0;Yv=(Jw|0)==0?1154740:Jw;lu=Ga;qz=ou;B:while(1){tz=qz;while(1){uz=f[tz+16>>2]|0;if((uz|0)==(Jw|0))break;if((Ioc((uz|0)==0?1154740:uz,Yv)|0)>=0)break;uz=f[tz+4>>2]|0;if(!uz){vz=lu;break B}else tz=uz}qz=f[tz>>2]|0;if(!qz){vz=tz;break}else lu=tz}if((vz|0)==(Ga|0)){Xa=993;break}lu=f[vz+16>>2]|0;if((Jw|0)==(lu|0)){wz=vz;break}if((Ioc(Yv,(lu|0)==0?1154740:lu)|0)>=0)wz=vz;else Xa=993}else Xa=993;while(0);if((Xa|0)==993){Xa=0;wz=Ga}uT(e);if((wz|0)!=(Ga|0)){f[bg>>2]=0;f[cg>>2]=0;f[P>>2]=dg;ou=f[l>>2]|0;if((ou|0)!=(Ga|0)){lu=ou;while(1){ou=lu+16|0;f[i>>2]=Gg;f[e>>2]=f[i>>2];qz=XIa(P,e,g,h,ou)|0;if(!(f[qz>>2]|0)){Ux=VDc(28)|0;Kw=f[ou>>2]|0;f[Ux+16>>2]=Kw;f[Ux+20>>2]=f[lu+20>>2];if(Kw|0){ou=Kw+-4|0;f[ou>>2]=(f[ou>>2]|0)+1}f[Ux+24>>2]=f[lu+24>>2];ou=f[g>>2]|0;f[Ux>>2]=0;f[Ux+4>>2]=0;f[Ux+8>>2]=ou;f[qz>>2]=Ux;ou=f[f[P>>2]>>2]|0;if(!ou)xz=Ux;else{f[P>>2]=ou;xz=f[qz>>2]|0}laa(f[bg>>2]|0,xz);f[cg>>2]=(f[cg>>2]|0)+1}qz=f[lu+4>>2]|0;do if(!qz){ou=lu+8|0;Ux=f[ou>>2]|0;if((f[Ux>>2]|0)==(lu|0)){yz=Ux;break}else zz=ou;do{ou=f[zz>>2]|0;zz=ou+8|0;Ux=f[zz>>2]|0}while((f[Ux>>2]|0)!=(ou|0));yz=Ux}else{tz=qz;while(1){Ux=f[tz>>2]|0;if(!Ux)break;else tz=Ux}yz=tz}while(0);if((yz|0)==(Ga|0))break;else lu=yz}}Vnb(w,YIa(a,q,P,1,0)|0);CFa(P,f[dg>>2]|0);lu=f[eg>>2]|0;qz=(lu|0)<3;if(qz)Az=Y(f[gg>>2]|0,f[fg>>2]|0)|0;else{Yv=f[Eg>>2]|0;Jw=0;Ux=1;while(1){ou=Y(f[Yv+(Jw<<2)>>2]|0,Ux)|0;Jw=Jw+1|0;if((Jw|0)==(lu|0)){Az=ou;break}else Ux=ou}}Ux=(Va|0)==0;do if(Ux&(Az|0)!=4){f[hg>>2]=0;f[ig>>2]=0;f[e>>2]=jg;f[kg>>2]=0;f[kg+4>>2]=0;f[kg+8>>2]=0;f[kg+12>>2]=0;f[kg+16>>2]=0;f[kg+20>>2]=0;f[kg+24>>2]=0;f[g>>2]=0;f[lg>>2]=0;Jw=tT(g,5)|0;b[Jw>>0]=b[454713]|0;b[Jw+1>>0]=b[454714]|0;b[Jw+2>>0]=b[454715]|0;b[Jw+3>>0]=b[454716]|0;b[Jw+4>>0]=b[454717]|0;Jw=VDc(16)|0;f[Jw>>2]=Jw+8;f[Jw+4>>2]=4;Yv=XDc(32)|0;f[Jw>>2]=Yv;f[h>>2]=0;f[mg>>2]=Jw;Jw=Yv;f[Jw>>2]=0;f[Jw+4>>2]=0;Jw=Yv+8|0;f[Jw>>2]=2;f[Jw+4>>2]=0;Jw=Yv+16|0;f[Jw>>2]=3;f[Jw+4>>2]=0;Jw=Yv+24|0;f[Jw>>2]=1;f[Jw+4>>2]=0;bIa(e,g,h)|0;JFa(h);uT(g);f[Q>>2]=0;f[ng>>2]=0;tT(Q,(f[La>>2]|0)+5|0)|0;Jw=f[La>>2]|0;if(!Jw)Bz=0;else{dJc(f[Q>>2]|0,f[r>>2]|0,Jw|0)|0;Bz=f[La>>2]|0}Jw=(f[Q>>2]|0)+Bz|0;b[Jw>>0]=b[383500]|0;b[Jw+1>>0]=b[383501]|0;b[Jw+2>>0]=b[383502]|0;b[Jw+3>>0]=b[383503]|0;b[Jw+4>>0]=b[383504]|0;Jw=f[Q>>2]|0;Yv=f[ng>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(Yv>>>0>4294967279){Xa=1016;break c}if(Yv>>>0<11){b[og>>0]=Yv;if(!Yv)Cz=g;else{Dz=g;Xa=1020}}else{ou=Yv+16&-16;Kw=VDc(ou)|0;f[g>>2]=Kw;f[xg>>2]=ou|-2147483648;f[qg>>2]=Yv;Dz=Kw;Xa=1020}if((Xa|0)==1020){Xa=0;dJc(Dz|0,Jw|0,Yv|0)|0;Cz=Dz}b[Cz+Yv>>0]=0;uT(Q);f[h>>2]=0;f[pg>>2]=0;Yv=b[og>>0]|0;Jw=Yv<<24>>24<0?f[qg>>2]|0:Yv&255;if(Jw|0){Yv=tT(h,Jw)|0;dJc(Yv|0,((b[og>>0]|0)<0?f[g>>2]|0:g)|0,Jw|0)|0}Jw=f[wa>>2]|0;do if(Jw){Yv=f[h>>2]|0;Kw=(Yv|0)==0?1154740:Yv;ou=wa;uz=Jw;C:while(1){Ez=uz;while(1){Fz=f[Ez+16>>2]|0;if((Fz|0)==(Yv|0))break;if((Ioc((Fz|0)==0?1154740:Fz,Kw)|0)>=0)break;Fz=f[Ez+4>>2]|0;if(!Fz){Gz=ou;break C}else Ez=Fz}uz=f[Ez>>2]|0;if(!uz){Gz=Ez;break}else ou=Ez}if((Gz|0)==(wa|0)){Xa=1033;break}ou=f[Gz+16>>2]|0;if((Yv|0)==(ou|0)){Hz=Gz;break}if((Ioc(Kw,(ou|0)==0?1154740:ou)|0)>=0)Hz=Gz;else Xa=1033}else Xa=1033;while(0);if((Xa|0)==1033){Xa=0;Hz=wa}uT(h);if((Hz|0)!=(wa|0)){Xa=1035;break c}f[h>>2]=0;f[rg>>2]=0;Jw=b[og>>0]|0;ou=Jw<<24>>24<0?f[qg>>2]|0:Jw&255;if(ou|0){Jw=tT(h,ou)|0;dJc(Jw|0,((b[og>>0]|0)<0?f[g>>2]|0:g)|0,ou|0)|0}f[i>>2]=0;f[sg>>2]=0;ou=tT(i,7)|0;b[ou>>0]=b[454705]|0;b[ou+1>>0]=b[454706]|0;b[ou+2>>0]=b[454707]|0;b[ou+3>>0]=b[454708]|0;b[ou+4>>0]=b[454709]|0;b[ou+5>>0]=b[454710]|0;b[ou+6>>0]=b[454711]|0;ou=gGa(c,h,i,e)|0;uT(i);uT(h);f[h>>2]=0;f[tg>>2]=0;Jw=b[og>>0]|0;uz=Jw<<24>>24<0?f[qg>>2]|0:Jw&255;if(uz|0){Jw=tT(h,uz)|0;dJc(Jw|0,((b[og>>0]|0)<0?f[g>>2]|0:g)|0,uz|0)|0}uz=HHa(o,h)|0;f[uz>>2]=ou;uT(h);$Ia(a,o,c,v,ou,0);fEc(h,g);f[ug>>2]=0;iEc(v,h)|0;f[vg>>2]=f[ug>>2];if((b[wg>>0]|0)<0)YDc(f[h>>2]|0);if((b[og>>0]|0)<0)YDc(f[g>>2]|0);HFa(e);Iz=1}else{if(qz)Jz=Y(f[gg>>2]|0,f[fg>>2]|0)|0;else{ou=f[Eg>>2]|0;uz=0;Jw=1;while(1){tz=Y(f[ou+(uz<<2)>>2]|0,Jw)|0;uz=uz+1|0;if((uz|0)==(lu|0)){Jz=tz;break}else Jw=tz}}if(!(Ux&(Jz|0)==4)){Iz=Va;break}Jw=f[zg>>2]|0;uz=(f[Ag>>2]|0)+4|0;ou=f[uz>>2]|0;tz=Jw+(ou<<1)|0;dz=Jw+(ou*3|0)|0;ou=f[tz>>2]|0;f[tz>>2]=f[dz>>2];f[dz>>2]=ou;ou=f[uz>>2]|0;uz=Jw+ou|0;dz=Jw+(ou<<1)|0;ou=f[uz>>2]|0;f[uz>>2]=f[dz>>2];f[dz>>2]=ou;Iz=0}while(0);f[e>>2]=0;f[yg>>2]=0;Ux=tT(e,3)|0;b[Ux>>0]=b[431774]|0;b[Ux+1>>0]=b[431775]|0;b[Ux+2>>0]=b[431776]|0;Ux=f[zg>>2]|0;lu=f[eg>>2]|0;if((lu|0)<3)Kz=Y(f[gg>>2]|0,f[fg>>2]|0)|0;else{qz=f[Eg>>2]|0;ou=0;dz=1;while(1){uz=Y(f[qz+(ou<<2)>>2]|0,dz)|0;ou=ou+1|0;if((ou|0)==(lu|0)){Kz=uz;break}else dz=uz}}dz=VDc(16)|0;lu=dz+8|0;f[dz>>2]=lu;f[dz+4>>2]=Kz;if(Kz>>>0>1){ou=XDc(Kz>>>0>536870911?-1:Kz<<3)|0;f[dz>>2]=ou;Lz=ou}else Lz=lu;f[g>>2]=0;f[Bg>>2]=dz;if((Kz|0)>0){dz=Ux;lu=0;while(1){ou=f[dz>>2]|0;qz=Lz+(lu<<3)|0;f[qz>>2]=ou;f[qz+4>>2]=((ou|0)<0)<<31>>31;lu=lu+1|0;if((lu|0)==(Kz|0))break;else dz=dz+4|0}}bIa(t,e,g)|0;JFa(g);uT(e);f[e>>2]=0;f[Cg>>2]=0;dz=tT(e,7)|0;b[dz>>0]=b[426093]|0;b[dz+1>>0]=b[426094]|0;b[dz+2>>0]=b[426095]|0;b[dz+3>>0]=b[426096]|0;b[dz+4>>0]=b[426097]|0;b[dz+5>>0]=b[426098]|0;b[dz+6>>0]=b[426099]|0;dz=gGa(c,r,e,t)|0;uT(e);lu=HHa(o,r)|0;f[lu>>2]=dz;$Ia(a,o,c,v,dz,0);dz=f[eg>>2]|0;if((dz|0)<3)Mz=Y(f[gg>>2]|0,f[fg>>2]|0)|0;else{lu=f[Eg>>2]|0;Ux=0;ou=1;while(1){qz=Y(f[lu+(Ux<<2)>>2]|0,ou)|0;Ux=Ux+1|0;if((Ux|0)==(dz|0)){Mz=qz;break}else ou=qz}}ou=HHa(k,r)|0;f[ou>>2]=(Mz|0)==2?3:Iz;ou=f[Dg>>2]|0;do if(ou|0){dz=ou+12|0;Ux=f[dz>>2]|0;f[dz>>2]=Ux+-1;if((Ux|0)!=1)break;_S(w)}while(0);f[Dg>>2]=0;f[zg>>2]=0;f[zg+4>>2]=0;f[zg+8>>2]=0;f[zg+12>>2]=0;if((f[eg>>2]|0)>0){ou=f[Eg>>2]|0;Ux=0;do{f[ou+(Ux<<2)>>2]=0;Ux=Ux+1|0}while((Ux|0)<(f[eg>>2]|0))}Ux=f[Ag>>2]|0;if((Ux|0)!=(Fg|0))g0(Ux)}else{f[e>>2]=0;f[_f>>2]=0;Ux=tT(e,7)|0;b[Ux>>0]=b[426093]|0;b[Ux+1>>0]=b[426094]|0;b[Ux+2>>0]=b[426095]|0;b[Ux+3>>0]=b[426096]|0;b[Ux+4>>0]=b[426097]|0;b[Ux+5>>0]=b[426098]|0;b[Ux+6>>0]=b[426099]|0;Ux=gGa(c,r,e,t)|0;uT(e);ou=HHa(o,r)|0;f[ou>>2]=Ux;$Ia(a,o,c,v,Ux,0);_Ia(e,f[(f[Fa>>2]|0)+8>>2]|0);$Ia(a,o,c,e,Ux,1);if((b[$f>>0]|0)<0)YDc(f[e>>2]|0);Ux=HHa(k,r)|0;f[Ux>>2]=Va}if((b[ag>>0]|0)<0)YDc(f[v>>2]|0);break e}while(0);if((f[Wa>>2]|0)!=2){Xa=812;break c};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;hu=VDc(32)|0;f[h>>2]=hu;f[ze>>2]=-2147483616;f[Ae>>2]=19;pv=hu;qv=446524;rv=pv+19|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[hu+19>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[Be>>2]|0,h,0);Na=f[e>>2]|0;cJa(g);if(!Na)Nz=0;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Na=VDc(32)|0;f[e>>2]=Na;f[Wf>>2]=-2147483616;f[Xf>>2]=19;pv=Na;qv=446524;rv=pv+19|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Na+19>>0]=0;Wdc(_b);hu=dJa($b,e)|0;Ux=b[hu+8>>0]|0?(f[hu+20>>2]|0)==5:0;if((b[Yf>>0]|0)<0)YDc(f[e>>2]|0);Nz=Ux}if((b[Ce>>0]|0)<0)YDc(f[h>>2]|0);f[e>>2]=0;f[De>>2]=0;pv=tT(e,9)|0;qv=454939;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=0;rIa(t,e,g)|0;uT(e);g$(dc,1);f[e>>2]=0;f[Ee>>2]=0;Na=tT(e,7)|0;b[Na>>0]=b[383309]|0;b[Na+1>>0]=b[383310]|0;b[Na+2>>0]=b[383311]|0;b[Na+3>>0]=b[383312]|0;b[Na+4>>0]=b[383313]|0;b[Na+5>>0]=b[383314]|0;b[Na+6>>0]=b[383315]|0;VIa(v,Ba,r,e);uT(e);Na=f[v>>2]|0;Ux=f[Fe>>2]|0;hu=Ux;ou=Na;if((Na|0)==(Ux|0)){f[g>>2]=0;f[Ge>>2]=0;Ux=tT(g,3)|0;b[Ux>>0]=b[427390]|0;b[Ux+1>>0]=b[427391]|0;b[Ux+2>>0]=b[427392]|0;VIa(e,Ba,r,g);WIa(v,f[e>>2]|0,f[He>>2]|0);Ux=f[e>>2]|0;if(Ux|0){while(1){Na=f[He>>2]|0;if((Na|0)==(Ux|0))break;dz=Na+-12|0;f[He>>2]=dz;uT(dz)}YDc(f[e>>2]|0)}uT(g);Oz=f[v>>2]|0;Pz=f[Fe>>2]|0}else{Oz=ou;Pz=hu}do if((Pz-Oz|0)==12){f[e>>2]=0;f[Ie>>2]=0;pv=tT(e,9)|0;qv=454939;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=1;rIa(t,e,g)|0;uT(e);g$(dc,2);Va=f[(f[v>>2]|0)+8>>2]|0;Ux=f[(f[Da>>2]|0)+4+(Va<<2)>>2]|0;f[Je>>2]=0;f[Ke>>2]=0;f[J>>2]=Le;dz=f[l>>2]|0;if((dz|0)!=(Ga|0)){Na=dz;while(1){dz=Na+16|0;f[i>>2]=Me;f[e>>2]=f[i>>2];lu=XIa(J,e,g,h,dz)|0;if(!(f[lu>>2]|0)){qz=VDc(28)|0;uz=f[dz>>2]|0;f[qz+16>>2]=uz;f[qz+20>>2]=f[Na+20>>2];if(uz|0){dz=uz+-4|0;f[dz>>2]=(f[dz>>2]|0)+1}f[qz+24>>2]=f[Na+24>>2];dz=f[g>>2]|0;f[qz>>2]=0;f[qz+4>>2]=0;f[qz+8>>2]=dz;f[lu>>2]=qz;dz=f[f[J>>2]>>2]|0;if(!dz)Qz=qz;else{f[J>>2]=dz;Qz=f[lu>>2]|0}laa(f[Je>>2]|0,Qz);f[Ke>>2]=(f[Ke>>2]|0)+1}lu=f[Na+4>>2]|0;do if(!lu){dz=Na+8|0;qz=f[dz>>2]|0;if((f[qz>>2]|0)==(Na|0)){Rz=qz;break}else Sz=dz;do{dz=f[Sz>>2]|0;Sz=dz+8|0;qz=f[Sz>>2]|0}while((f[qz>>2]|0)!=(dz|0));Rz=qz}else{Kw=lu;while(1){Yv=f[Kw>>2]|0;if(!Yv)break;else Kw=Yv}Rz=Kw}while(0);if((Rz|0)==(Ga|0))break;else Na=Rz}}Na=YIa(a,Ux,J,-1,0)|0;eJa(Na,(f[dc>>2]|0)+56|0);CFa(J,f[Le>>2]|0);fJa(Ba,Va,0);Na=f[v>>2]|0;lu=f[za>>2]|0;D:do if(!lu){Tz=za;Uz=za}else{Yv=f[Na>>2]|0;qz=(Yv|0)==0?1154740:Yv;dz=f[lu+16>>2]|0;E:do if((Yv|0)!=(dz|0)){uz=xa;Jw=lu;tz=dz;while(1){Fz=(tz|0)==0?1154740:tz;if((Ioc(qz,Fz)|0)<0){Vz=f[Jw>>2]|0;if(!Vz){Xa=844;break}else{Wz=Jw;Xz=Vz}}else{if((Ioc(Fz,qz)|0)>=0){Yz=uz;Zz=Jw;break E}_z=Jw+4|0;Fz=f[_z>>2]|0;if(!Fz){Xa=847;break}else{Wz=_z;Xz=Fz}}tz=f[Xz+16>>2]|0;if((Yv|0)==(tz|0)){Yz=Wz;Zz=Xz;break E}else{uz=Wz;Jw=Xz}}if((Xa|0)==844){Xa=0;Tz=Jw;Uz=Jw;break D}else if((Xa|0)==847){Xa=0;Tz=_z;Uz=Jw;break D}}else{Yz=xa;Zz=lu}while(0);Tz=Yz;Uz=Zz}while(0);if(!(f[Tz>>2]|0)){lu=VDc(24)|0;Va=f[Na>>2]|0;f[lu+16>>2]=Va;f[lu+20>>2]=f[Na+4>>2];if(Va|0){Ux=Va+-4|0;f[Ux>>2]=(f[Ux>>2]|0)+1}f[lu>>2]=0;f[lu+4>>2]=0;f[lu+8>>2]=Uz;f[Tz>>2]=lu;Ux=f[f[j>>2]>>2]|0;if(!Ux)$z=lu;else{f[j>>2]=Ux;$z=f[Tz>>2]|0}laa(f[xa>>2]|0,$z);f[ya>>2]=(f[ya>>2]|0)+1}if(!Nz){aA=0;break}Ux=f[dc>>2]|0;lu=f[Ux+60>>2]|0;if((lu|0)<3)bA=Y(f[Ux+68>>2]|0,f[Ux+64>>2]|0)|0;else{Va=f[Ux+96>>2]|0;Yv=0;qz=1;while(1){dz=Y(f[Va+(Yv<<2)>>2]|0,qz)|0;Yv=Yv+1|0;if((Yv|0)==(lu|0)){bA=dz;break}else qz=dz}}qz=f[Ux+72>>2]|0;if(bA&3|0){Xa=862;break c}if((bA|0)>0)cA=0;else{aA=1;break}do{lu=qz+(cA<<2)|0;Yv=qz+((cA|1)<<2)|0;Va=f[lu>>2]|0;f[lu>>2]=f[Yv>>2];f[Yv>>2]=Va;cA=cA+2|0}while((cA|0)<(bA|0));aA=1}else aA=Nz;while(0);f[w>>2]=-1;f[Ne>>2]=0;f[Oe>>2]=0;f[K>>2]=Pe;hu=f[l>>2]|0;if((hu|0)!=(Ga|0)){ou=hu;while(1){hu=ou+16|0;f[i>>2]=Vf;f[e>>2]=f[i>>2];qz=XIa(K,e,g,h,hu)|0;if(!(f[qz>>2]|0)){Ux=VDc(28)|0;Va=f[hu>>2]|0;f[Ux+16>>2]=Va;f[Ux+20>>2]=f[ou+20>>2];if(Va|0){hu=Va+-4|0;f[hu>>2]=(f[hu>>2]|0)+1}f[Ux+24>>2]=f[ou+24>>2];hu=f[g>>2]|0;f[Ux>>2]=0;f[Ux+4>>2]=0;f[Ux+8>>2]=hu;f[qz>>2]=Ux;hu=f[f[K>>2]>>2]|0;if(!hu)dA=Ux;else{f[K>>2]=hu;dA=f[qz>>2]|0}laa(f[Ne>>2]|0,dA);f[Oe>>2]=(f[Oe>>2]|0)+1}qz=f[ou+4>>2]|0;do if(!qz){hu=ou+8|0;Ux=f[hu>>2]|0;if((f[Ux>>2]|0)==(ou|0)){eA=Ux;break}else fA=hu;do{hu=f[fA>>2]|0;fA=hu+8|0;Ux=f[fA>>2]|0}while((f[Ux>>2]|0)!=(hu|0));eA=Ux}else{Ux=qz;while(1){hu=f[Ux>>2]|0;if(!hu)break;else Ux=hu}eA=Ux}while(0);if((eA|0)==(Ga|0))break;else ou=eA}}ou=YIa(a,q,K,-1,w)|0;CFa(K,f[Pe>>2]|0);eJa(ou,f[dc>>2]|0);Oob(ou);if((f[w>>2]|0)==1){xY(L,f[dc>>2]|0);f[g>>2]=1124007936;pv=Qe;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[Se>>2]=Re;f[Ue>>2]=Te;f[Te>>2]=0;f[Ve>>2]=0;ou=f[L>>2]|0;ei[f[(f[ou>>2]|0)+12>>2]&511](ou,L,g,-1);$j(L);f[h>>2]=1124007936;pv=We;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[Ye>>2]=Xe;f[_e>>2]=Ze;f[Ze>>2]=0;f[$e>>2]=0;ou=af;f[ou>>2]=0;f[ou+4>>2]=0;f[e>>2]=33619968;f[bf>>2]=h;h_(g,e);ou=f[dc>>2]|0;if((ou|0)!=(h|0)){qz=f[cf>>2]|0;if(qz|0){hu=qz+12|0;f[hu>>2]=(f[hu>>2]|0)+1}hu=ou+36|0;qz=f[hu>>2]|0;do if(qz|0){Va=qz+12|0;Yv=f[Va>>2]|0;f[Va>>2]=Yv+-1;if((Yv|0)!=1)break;_S(ou)}while(0);f[hu>>2]=0;qz=ou+16|0;Yv=ou+4|0;f[qz>>2]=0;f[qz+4>>2]=0;f[qz+8>>2]=0;f[qz+12>>2]=0;if((f[Yv>>2]|0)>0){Va=f[ou+40>>2]|0;lu=0;do{f[Va+(lu<<2)>>2]=0;lu=lu+1|0;gA=f[Yv>>2]|0}while((lu|0)<(gA|0));f[ou>>2]=f[h>>2];if((gA|0)<3)Xa=889;else Xa=891}else{f[ou>>2]=f[h>>2];Xa=889}do if((Xa|0)==889){Xa=0;lu=f[We>>2]|0;if((lu|0)>=3){Xa=891;break}f[Yv>>2]=lu;f[ou+8>>2]=f[Xe>>2];f[ou+12>>2]=f[gf>>2];lu=f[_e>>2]|0;Va=f[ou+44>>2]|0;f[Va>>2]=f[lu>>2];f[Va+4>>2]=f[lu+4>>2]}while(0);if((Xa|0)==891){Xa=0;ZS(ou,h)}f[qz>>2]=f[df>>2];f[ou+20>>2]=f[hf>>2];f[ou+24>>2]=f[jf>>2];f[ou+28>>2]=f[kf>>2];f[ou+32>>2]=f[lf>>2];f[hu>>2]=f[cf>>2]}Yv=f[cf>>2]|0;do if(Yv|0){lu=Yv+12|0;Va=f[lu>>2]|0;f[lu>>2]=Va+-1;if((Va|0)!=1)break;_S(h)}while(0);f[cf>>2]=0;f[df>>2]=0;f[df+4>>2]=0;f[df+8>>2]=0;f[df+12>>2]=0;if((f[We>>2]|0)>0){Yv=f[Ye>>2]|0;hu=0;do{f[Yv+(hu<<2)>>2]=0;hu=hu+1|0}while((hu|0)<(f[We>>2]|0))}hu=f[_e>>2]|0;if((hu|0)!=(Ze|0))g0(hu);hu=f[ef>>2]|0;do if(hu|0){Yv=hu+12|0;ou=f[Yv>>2]|0;f[Yv>>2]=ou+-1;if((ou|0)!=1)break;_S(g)}while(0);f[ef>>2]=0;f[ff>>2]=0;f[ff+4>>2]=0;f[ff+8>>2]=0;f[ff+12>>2]=0;if((f[Qe>>2]|0)>0){hu=f[Se>>2]|0;ou=0;do{f[hu+(ou<<2)>>2]=0;ou=ou+1|0}while((ou|0)<(f[Qe>>2]|0))}ou=f[Ue>>2]|0;if((ou|0)!=(Te|0))g0(ou)}f[e>>2]=0;f[mf>>2]=0;pv=tT(e,10)|0;qv=455057;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));$Ha(t,e,f[(f[dc>>2]|0)+40>>2]|0)|0;uT(e);do if(aA){ou=f[dc>>2]|0;if((f[ou+4>>2]|0)!=2){Xa=913;break c}if((f[f[ou+40>>2]>>2]|0)>0){hA=0;iA=ou}else break;do{ou=hA|1;f[e>>2]=hA;f[nf>>2]=ou;f[g>>2]=-2147483648;f[of>>2]=2147483647;$S(h,iA,e,g);hu=f[dc>>2]|0;f[e>>2]=ou;f[pf>>2]=ou+1;f[g>>2]=-2147483648;f[qf>>2]=2147483647;$S(i,hu,e,g);f[M>>2]=h;hu=f[sf>>2]|0;if((hu|0)>0)jA=f[(f[tf>>2]|0)+(hu+-1<<2)>>2]|0;else jA=0;f[rf>>2]=jA;f[uf>>2]=0;f[vf>>2]=0;f[wf>>2]=0;if(f[h>>2]&16384|0){ou=f[Of>>2]|0;f[vf>>2]=ou;if((hu|0)<3)kA=Y(f[Cf>>2]|0,f[Bf>>2]|0)|0;else{Yv=f[Pf>>2]|0;qz=0;Va=1;while(1){lu=Y(f[Yv+(qz<<2)>>2]|0,Va)|0;qz=qz+1|0;if((qz|0)==(hu|0)){kA=lu;break}else Va=lu}}Va=ou+(Y(kA,jA)|0)|0;f[wf>>2]=Va}C2(M,0,0);f[N>>2]=h;Va=f[sf>>2]|0;if((Va|0)>0)lA=f[(f[tf>>2]|0)+(Va+-1<<2)>>2]|0;else lA=0;f[xf>>2]=lA;f[yf>>2]=0;f[zf>>2]=0;f[Af>>2]=0;if(f[h>>2]&16384|0){hu=f[Of>>2]|0;f[zf>>2]=hu;if((Va|0)<3)mA=Y(f[Cf>>2]|0,f[Bf>>2]|0)|0;else{qz=f[Pf>>2]|0;Yv=0;Ux=1;while(1){lu=Y(f[qz+(Yv<<2)>>2]|0,Ux)|0;Yv=Yv+1|0;if((Yv|0)==(Va|0)){mA=lu;break}else Ux=lu}}Ux=hu+(Y(mA,lA)|0)|0;f[Af>>2]=Ux}C2(N,0,0);Ux=f[sf>>2]|0;if((Ux|0)<3)nA=Y(f[Cf>>2]|0,f[Bf>>2]|0)|0;else{Va=f[Pf>>2]|0;Yv=0;qz=1;while(1){ou=Y(f[Va+(Yv<<2)>>2]|0,qz)|0;Yv=Yv+1|0;if((Yv|0)==(Ux|0)){nA=ou;break}else qz=ou}}do if(!((nA|0)==0|(f[N>>2]|0)==0)){qz=Y(f[xf>>2]|0,nA)|0;Ux=(f[yf>>2]|0)+qz|0;f[yf>>2]=Ux;if(Ux>>>0>=(f[zf>>2]|0)>>>0?(f[Af>>2]|0)>>>0>Ux>>>0:0)break;f[yf>>2]=Ux+(0-qz);B2(N,nA,1)}while(0);f[O>>2]=i;qz=f[Ef>>2]|0;if((qz|0)>0)oA=f[(f[Ff>>2]|0)+(qz+-1<<2)>>2]|0;else oA=0;f[Df>>2]=oA;f[Gf>>2]=0;f[Hf>>2]=0;f[If>>2]=0;if(f[i>>2]&16384|0){Ux=f[Kf>>2]|0;f[Hf>>2]=Ux;if((qz|0)<3)pA=Y(f[Sf>>2]|0,f[Rf>>2]|0)|0;else{Yv=f[Lf>>2]|0;Va=0;hu=1;while(1){ou=Y(f[Yv+(Va<<2)>>2]|0,hu)|0;Va=Va+1|0;if((Va|0)==(qz|0)){pA=ou;break}else hu=ou}}hu=Ux+(Y(pA,oA)|0)|0;f[If>>2]=hu}C2(O,0,0);while(1){hu=f[M>>2]|0;if((hu|0)==(f[N>>2]|0)){qz=f[uf>>2]|0;if((qz|0)==(f[yf>>2]|0))break;else{qA=qz;rA=qz}}else{qz=f[uf>>2]|0;qA=qz;rA=qz}qz=f[Gf>>2]|0;Va=f[qA>>2]|0;f[qA>>2]=f[qz>>2];f[qz>>2]=Va;do if(hu|0){Va=f[rf>>2]|0;qz=rA+Va|0;f[uf>>2]=qz;if(qz>>>0<(f[wf>>2]|0)>>>0)break;f[uf>>2]=qz+(0-Va);B2(M,1,1)}while(0);if(!(f[O>>2]|0))continue;hu=f[Df>>2]|0;Jw=(f[Gf>>2]|0)+hu|0;f[Gf>>2]=Jw;if(Jw>>>0<(f[If>>2]|0)>>>0)continue;f[Gf>>2]=Jw+(0-hu);B2(O,1,1)}Ux=f[Jf>>2]|0;do if(Ux|0){hu=Ux+12|0;Jw=f[hu>>2]|0;f[hu>>2]=Jw+-1;if((Jw|0)!=1)break;_S(i)}while(0);f[Jf>>2]=0;f[Kf>>2]=0;f[Kf+4>>2]=0;f[Kf+8>>2]=0;f[Kf+12>>2]=0;if((f[Ef>>2]|0)>0){Ux=f[Lf>>2]|0;Jw=0;do{f[Ux+(Jw<<2)>>2]=0;Jw=Jw+1|0}while((Jw|0)<(f[Ef>>2]|0))}Jw=f[Ff>>2]|0;if((Jw|0)!=(Mf|0))g0(Jw);Jw=f[Nf>>2]|0;do if(Jw|0){Ux=Jw+12|0;hu=f[Ux>>2]|0;f[Ux>>2]=hu+-1;if((hu|0)!=1)break;_S(h)}while(0);f[Nf>>2]=0;f[Of>>2]=0;f[Of+4>>2]=0;f[Of+8>>2]=0;f[Of+12>>2]=0;if((f[sf>>2]|0)>0){Jw=f[Pf>>2]|0;hu=0;do{f[Jw+(hu<<2)>>2]=0;hu=hu+1|0}while((hu|0)<(f[sf>>2]|0))}hu=f[tf>>2]|0;if((hu|0)!=(Qf|0))g0(hu);hA=hA+2|0;iA=f[dc>>2]|0}while((hA|0)<(f[f[iA+40>>2]>>2]|0))}while(0);f[e>>2]=0;f[Tf>>2]=0;pv=tT(e,12)|0;qv=425612;rv=pv+12|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));hu=gGa(c,r,e,t)|0;uT(e);Jw=HHa(o,r)|0;f[Jw>>2]=hu;_Ia(e,f[(f[Fa>>2]|0)+4+(((f[w>>2]|0)==0&1)<<2)>>2]|0);$Ia(a,o,c,e,hu,0);if((b[Uf>>0]|0)<0)YDc(f[e>>2]|0);hu=HHa(k,r)|0;f[hu>>2]=3;hu=f[v>>2]|0;if(hu|0){while(1){Jw=f[Fe>>2]|0;if((Jw|0)==(hu|0))break;Ux=Jw+-12|0;f[Fe>>2]=Ux;uT(Ux)}YDc(f[v>>2]|0)}break e}while(0);while(1){if((wu|0)>=(f[Wa>>2]|0)){Xa=775;break c}_Ia(e,f[(f[Fa>>2]|0)+4+(wu<<2)>>2]|0);f[g>>2]=0;f[ee>>2]=0;eu=b[fe>>0]|0;fu=eu<<24>>24<0?f[ge>>2]|0:eu&255;if(fu|0){eu=tT(g,fu)|0;dJc(eu|0,((b[fe>>0]|0)<0?f[e>>2]|0:e)|0,fu|0)|0}fu=f[Ga>>2]|0;do if(fu){eu=f[g>>2]|0;hu=(eu|0)==0?1154740:eu;Ux=Ga;Jw=fu;F:while(1){Va=Jw;while(1){qz=f[Va+16>>2]|0;if((qz|0)==(eu|0))break;if((Ioc((qz|0)==0?1154740:qz,hu)|0)>=0)break;qz=f[Va+4>>2]|0;if(!qz){sA=Ux;break F}else Va=qz}Jw=f[Va>>2]|0;if(!Jw){sA=Va;break}else Ux=Va}if((sA|0)==(Ga|0)){Xa=771;break}Ux=f[sA+16>>2]|0;if((eu|0)==(Ux|0)){tA=sA;break}if((Ioc(hu,(Ux|0)==0?1154740:Ux)|0)>=0)tA=sA;else Xa=771}else Xa=771;while(0);if((Xa|0)==771){Xa=0;tA=Ga}uT(g);if((b[fe>>0]|0)<0)YDc(f[e>>2]|0);if((tA|0)==(Ga|0))wu=wu+1|0;else break}f[he>>2]=0;f[ie>>2]=0;f[I>>2]=je;fu=f[l>>2]|0;if((fu|0)!=(Ga|0)){Ux=fu;while(1){fu=Ux+16|0;f[i>>2]=ye;f[e>>2]=f[i>>2];Jw=XIa(I,e,g,h,fu)|0;if(!(f[Jw>>2]|0)){qz=VDc(28)|0;Yv=f[fu>>2]|0;f[qz+16>>2]=Yv;f[qz+20>>2]=f[Ux+20>>2];if(Yv|0){fu=Yv+-4|0;f[fu>>2]=(f[fu>>2]|0)+1}f[qz+24>>2]=f[Ux+24>>2];fu=f[g>>2]|0;f[qz>>2]=0;f[qz+4>>2]=0;f[qz+8>>2]=fu;f[Jw>>2]=qz;fu=f[f[I>>2]>>2]|0;if(!fu)uA=qz;else{f[I>>2]=fu;uA=f[Jw>>2]|0}laa(f[he>>2]|0,uA);f[ie>>2]=(f[ie>>2]|0)+1}Jw=f[Ux+4>>2]|0;do if(!Jw){fu=Ux+8|0;qz=f[fu>>2]|0;if((f[qz>>2]|0)==(Ux|0)){vA=qz;break}else wA=fu;do{fu=f[wA>>2]|0;wA=fu+8|0;qz=f[wA>>2]|0}while((f[qz>>2]|0)!=(fu|0));vA=qz}else{hu=Jw;while(1){eu=f[hu>>2]|0;if(!eu)break;else hu=eu}vA=hu}while(0);if((vA|0)==(Ga|0))break;else Ux=vA}}Vnb(v,YIa(a,q,I,-1,0)|0);CFa(I,f[je>>2]|0);if((f[v>>2]&4095|0)!=5){Xa=790;break c}Ux=ke;f[Ux>>2]=0;f[Ux+4>>2]=0;f[e>>2]=33619968;f[le>>2]=v;LZ(v,e,-1,-1.0,0.0);Ux=f[me>>2]|0;if((Ux|0)<3)xA=Y(f[oe>>2]|0,f[ne>>2]|0)|0;else{Jw=f[ue>>2]|0;eu=0;qz=1;while(1){fu=Y(f[Jw+(eu<<2)>>2]|0,qz)|0;eu=eu+1|0;if((eu|0)==(Ux|0)){xA=fu;break}else qz=fu}}if((xA|0)==1){f[e>>2]=0;f[pe>>2]=0;qz=tT(e,5)|0;b[qz>>0]=b[440275]|0;b[qz+1>>0]=b[440276]|0;b[qz+2>>0]=b[440277]|0;b[qz+3>>0]=b[440278]|0;b[qz+4>>0]=b[440279]|0;eIa(t,e,f[qe>>2]|0)|0;uT(e);f[e>>2]=0;f[re>>2]=0;qz=tT(e,5)|0;b[qz>>0]=b[451285]|0;b[qz+1>>0]=b[451286]|0;b[qz+2>>0]=b[451287]|0;b[qz+3>>0]=b[451288]|0;b[qz+4>>0]=b[451289]|0;qz=gGa(c,r,e,t)|0;uT(e);yA=qz}else{cx(dc,1,v);f[e>>2]=0;f[xe>>2]=0;qz=tT(e,5)|0;b[qz>>0]=b[425749]|0;b[qz+1>>0]=b[425750]|0;b[qz+2>>0]=b[425751]|0;b[qz+3>>0]=b[425752]|0;b[qz+4>>0]=b[425753]|0;qz=gGa(c,r,e,t)|0;uT(e);yA=qz}qz=HHa(o,r)|0;f[qz>>2]=yA;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,yA,0);if((b[se>>0]|0)<0)YDc(f[e>>2]|0);qz=f[te>>2]|0;do if(qz|0){Ux=qz+12|0;eu=f[Ux>>2]|0;f[Ux>>2]=eu+-1;if((eu|0)!=1)break;_S(v)}while(0);f[te>>2]=0;f[qe>>2]=0;f[qe+4>>2]=0;f[qe+8>>2]=0;f[qe+12>>2]=0;if((f[me>>2]|0)>0){qz=f[ue>>2]|0;eu=0;do{f[qz+(eu<<2)>>2]=0;eu=eu+1|0}while((eu|0)<(f[me>>2]|0))}eu=f[ve>>2]|0;if((eu|0)!=(we|0))g0(eu);break}eu=0;qz=f[Wa>>2]|0;while(1){if((eu|0)>=(qz|0)){Xa=735;break}_Ia(e,f[(f[Fa>>2]|0)+4+(eu<<2)>>2]|0);f[g>>2]=0;f[Id>>2]=0;Ux=b[Jd>>0]|0;Jw=Ux<<24>>24<0?f[Kd>>2]|0:Ux&255;if(Jw|0){Ux=tT(g,Jw)|0;dJc(Ux|0,((b[Jd>>0]|0)<0?f[e>>2]|0:e)|0,Jw|0)|0}Jw=f[Ga>>2]|0;do if(Jw){Ux=f[g>>2]|0;fu=(Ux|0)==0?1154740:Ux;Yv=Ga;ou=Jw;G:while(1){lu=ou;while(1){Na=f[lu+16>>2]|0;if((Na|0)==(Ux|0))break;if((Ioc((Na|0)==0?1154740:Na,fu)|0)>=0)break;Na=f[lu+4>>2]|0;if(!Na){zA=Yv;break G}else lu=Na}ou=f[lu>>2]|0;if(!ou){zA=lu;break}else Yv=lu}if((zA|0)==(Ga|0)){Xa=696;break}Yv=f[zA+16>>2]|0;if((Ux|0)==(Yv|0)){AA=zA;break}if((Ioc(fu,(Yv|0)==0?1154740:Yv)|0)>=0)AA=zA;else Xa=696}else Xa=696;while(0);if((Xa|0)==696){Xa=0;AA=Ga}uT(g);if((b[Jd>>0]|0)<0)YDc(f[e>>2]|0);qz=f[Wa>>2]|0;if((AA|0)!=(Ga|0))break;else eu=eu+1|0}if((Xa|0)==735){Xa=0;f[e>>2]=0;f[$d>>2]=0;pv=tT(e,9)|0;qv=445470;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));qIa(t,e,454649)|0;uT(e);f[e>>2]=0;f[ae>>2]=0;eu=tT(e,7)|0;b[eu>>0]=b[454641]|0;b[eu+1>>0]=b[454642]|0;b[eu+2>>0]=b[454643]|0;b[eu+3>>0]=b[454644]|0;b[eu+4>>0]=b[454645]|0;b[eu+5>>0]=b[454646]|0;b[eu+6>>0]=b[454647]|0;eu=gGa(c,r,e,t)|0;uT(e);Jw=HHa(o,r)|0;f[Jw>>2]=eu;if((f[Wa>>2]|0)>0)BA=0;else break;while(1){_Ia(e,f[(f[Fa>>2]|0)+4+(BA<<2)>>2]|0);f[g>>2]=0;f[be>>2]=0;Jw=b[ce>>0]|0;Yv=Jw<<24>>24<0?f[de>>2]|0:Jw&255;if(Yv|0){Jw=tT(g,Yv)|0;dJc(Jw|0,((b[ce>>0]|0)<0?f[e>>2]|0:e)|0,Yv|0)|0}Yv=f[wa>>2]|0;do if(Yv){Jw=f[g>>2]|0;ou=(Jw|0)==0?1154740:Jw;hu=wa;Va=Yv;H:while(1){Na=Va;while(1){dz=f[Na+16>>2]|0;if((dz|0)==(Jw|0))break;if((Ioc((dz|0)==0?1154740:dz,ou)|0)>=0)break;dz=f[Na+4>>2]|0;if(!dz){CA=hu;break H}else Na=dz}Va=f[Na>>2]|0;if(!Va){CA=Na;break}else hu=Na}if((CA|0)==(wa|0)){Xa=748;break}hu=f[CA+16>>2]|0;if((Jw|0)==(hu|0)){DA=CA;break}if((Ioc(ou,(hu|0)==0?1154740:hu)|0)>=0)DA=CA;else Xa=748}else Xa=748;while(0);if((Xa|0)==748){Xa=0;DA=wa}uT(g);if((DA|0)==(wa|0)){Xa=750;break c}$Ia(a,o,c,e,eu,BA);if((b[ce>>0]|0)<0)YDc(f[e>>2]|0);BA=BA+1|0;if((BA|0)>=(f[Wa>>2]|0))break e}}if((qz|0)!=2){Xa=701;break c}f[Ld>>2]=0;f[Md>>2]=0;f[H>>2]=Nd;eu=f[l>>2]|0;if((eu|0)!=(Ga|0)){Yv=eu;while(1){eu=Yv+16|0;f[i>>2]=_d;f[e>>2]=f[i>>2];hu=XIa(H,e,g,h,eu)|0;if(!(f[hu>>2]|0)){Va=VDc(28)|0;fu=f[eu>>2]|0;f[Va+16>>2]=fu;f[Va+20>>2]=f[Yv+20>>2];if(fu|0){eu=fu+-4|0;f[eu>>2]=(f[eu>>2]|0)+1}f[Va+24>>2]=f[Yv+24>>2];eu=f[g>>2]|0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=eu;f[hu>>2]=Va;eu=f[f[H>>2]>>2]|0;if(!eu)EA=Va;else{f[H>>2]=eu;EA=f[hu>>2]|0}laa(f[Ld>>2]|0,EA);f[Md>>2]=(f[Md>>2]|0)+1}hu=f[Yv+4>>2]|0;do if(!hu){eu=Yv+8|0;Va=f[eu>>2]|0;if((f[Va>>2]|0)==(Yv|0)){FA=Va;break}else GA=eu;do{eu=f[GA>>2]|0;GA=eu+8|0;Va=f[GA>>2]|0}while((f[Va>>2]|0)!=(eu|0));FA=Va}else{ou=hu;while(1){Jw=f[ou>>2]|0;if(!Jw)break;else ou=Jw}FA=ou}while(0);if((FA|0)==(Ga|0))break;else Yv=FA}}Vnb(v,YIa(a,q,H,-1,0)|0);CFa(H,f[Nd>>2]|0);if((f[v>>2]&4095|0)!=5){Xa=716;break c}Yv=f[Od>>2]|0;if((Yv|0)<3)HA=Y(f[Qd>>2]|0,f[Pd>>2]|0)|0;else{qz=f[Wd>>2]|0;hu=0;Jw=1;while(1){Va=Y(f[qz+(hu<<2)>>2]|0,Jw)|0;hu=hu+1|0;if((hu|0)==(Yv|0)){HA=Va;break}else Jw=Va}}if((HA|0)==1){f[e>>2]=0;f[Rd>>2]=0;Jw=tT(e,5)|0;b[Jw>>0]=b[440275]|0;b[Jw+1>>0]=b[440276]|0;b[Jw+2>>0]=b[440277]|0;b[Jw+3>>0]=b[440278]|0;b[Jw+4>>0]=b[440279]|0;eIa(t,e,f[Sd>>2]|0)|0;uT(e);f[e>>2]=0;f[Td>>2]=0;Jw=tT(e,5)|0;b[Jw>>0]=b[451285]|0;b[Jw+1>>0]=b[451286]|0;b[Jw+2>>0]=b[451287]|0;b[Jw+3>>0]=b[451288]|0;b[Jw+4>>0]=b[451289]|0;Jw=gGa(c,r,e,t)|0;uT(e);IA=Jw}else{cx(dc,1,v);f[e>>2]=0;f[Zd>>2]=0;Jw=tT(e,5)|0;b[Jw>>0]=b[425749]|0;b[Jw+1>>0]=b[425750]|0;b[Jw+2>>0]=b[425751]|0;b[Jw+3>>0]=b[425752]|0;b[Jw+4>>0]=b[425753]|0;Jw=gGa(c,r,e,t)|0;uT(e);IA=Jw}Jw=HHa(o,r)|0;f[Jw>>2]=IA;_Ia(e,f[(f[Fa>>2]|0)+4>>2]|0);$Ia(a,o,c,e,IA,0);if((b[Ud>>0]|0)<0)YDc(f[e>>2]|0);Jw=f[Vd>>2]|0;do if(Jw|0){Yv=Jw+12|0;hu=f[Yv>>2]|0;f[Yv>>2]=hu+-1;if((hu|0)!=1)break;_S(v)}while(0);f[Vd>>2]=0;f[Sd>>2]=0;f[Sd+4>>2]=0;f[Sd+8>>2]=0;f[Sd+12>>2]=0;if((f[Od>>2]|0)>0){Jw=f[Wd>>2]|0;hu=0;do{f[Jw+(hu<<2)>>2]=0;hu=hu+1|0}while((hu|0)<(f[Od>>2]|0))}hu=f[Xd>>2]|0;if((hu|0)!=(Yd|0))g0(hu);break}fEc(v,f[(f[Fa>>2]|0)+4>>2]|0);f[w>>2]=0;f[Qa>>2]=0;f[Sa>>2]=0;hu=f[s>>2]|0;if(!(((hu|0)!=383017?(Jw=(hu|0)==0?1154740:hu,!((Ioc(Jw,383017)|0)==0|(hu|0)==383054)):0)?(Ioc(Jw,383054)|0)!=0:0)){f[g>>2]=0;f[Oa>>2]=0;Jw=tT(g,6)|0;b[Jw>>0]=b[383010]|0;b[Jw+1>>0]=b[383011]|0;b[Jw+2>>0]=b[383012]|0;b[Jw+3>>0]=b[383013]|0;b[Jw+4>>0]=b[383014]|0;b[Jw+5>>0]=b[383015]|0;VIa(e,Ba,r,g);WIa(w,f[e>>2]|0,f[_a>>2]|0);Jw=f[e>>2]|0;if(Jw|0){while(1){hu=f[_a>>2]|0;if((hu|0)==(Jw|0))break;Yv=hu+-12|0;f[_a>>2]=Yv;uT(Yv)}YDc(f[e>>2]|0)}uT(g);if((f[w>>2]|0)==(f[Qa>>2]|0)){f[g>>2]=0;f[Ua>>2]=0;pv=tT(g,21)|0;qv=383032;rv=pv+21|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));VIa(e,Ba,r,g);WIa(w,f[e>>2]|0,f[ab>>2]|0);Jw=f[e>>2]|0;if(Jw|0){while(1){Yv=f[ab>>2]|0;if((Yv|0)==(Jw|0))break;hu=Yv+-12|0;f[ab>>2]=hu;uT(hu)}YDc(f[e>>2]|0)}uT(g)}}Jw=f[s>>2]|0;do if((Jw|0)!=383017?(hu=(Jw|0)==0?1154740:Jw,(Ioc(hu,383017)|0)!=0):0){if((Jw|0)!=383054?Ioc(hu,383054)|0:0){Xa=429;break}f[qd>>2]=0;f[rd>>2]=0;f[B>>2]=sd;hu=f[l>>2]|0;if((hu|0)!=(Ga|0)){Yv=hu;while(1){hu=Yv+16|0;f[i>>2]=Hd;f[e>>2]=f[i>>2];qz=XIa(B,e,g,h,hu)|0;if(!(f[qz>>2]|0)){Va=VDc(28)|0;eu=f[hu>>2]|0;f[Va+16>>2]=eu;f[Va+20>>2]=f[Yv+20>>2];if(eu|0){hu=eu+-4|0;f[hu>>2]=(f[hu>>2]|0)+1}f[Va+24>>2]=f[Yv+24>>2];hu=f[g>>2]|0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=hu;f[qz>>2]=Va;hu=f[f[B>>2]>>2]|0;if(!hu)JA=Va;else{f[B>>2]=hu;JA=f[qz>>2]|0}laa(f[qd>>2]|0,JA);f[rd>>2]=(f[rd>>2]|0)+1}qz=f[Yv+4>>2]|0;do if(!qz){hu=Yv+8|0;Va=f[hu>>2]|0;if((f[Va>>2]|0)==(Yv|0)){KA=Va;break}else LA=hu;do{hu=f[LA>>2]|0;LA=hu+8|0;Va=f[LA>>2]|0}while((f[Va>>2]|0)!=(hu|0));KA=Va}else{Na=qz;while(1){Va=f[Na>>2]|0;if(!Va)break;else Na=Va}KA=Na}while(0);if((KA|0)==(Ga|0))break;else Yv=KA}}Vnb(x,YIa(a,q,B,1,0)|0);CFa(B,f[sd>>2]|0);Yv=f[x>>2]|0;if((Yv&4095|0)!=4){Xa=288;break c}qz=f[td>>2]|0;if((qz|0)<3)MA=Y(f[vd>>2]|0,f[ud>>2]|0)|0;else{ou=f[xd>>2]|0;Va=0;hu=1;while(1){eu=Y(f[ou+(Va<<2)>>2]|0,hu)|0;Va=Va+1|0;if((Va|0)==(qz|0)){MA=eu;break}else hu=eu}}if((MA|0)==8){hu=f[wd>>2]|0;do if(!(Yv&16384)){qz=f[xd>>2]|0;do if((f[qz>>2]|0)!=1){Va=f[f[yd>>2]>>2]|0;if((f[qz+4>>2]|0)==1){NA=hu+(Va<<1)|0;break}else{ou=f[vd>>2]|0;eu=2/(ou|0)|0;NA=hu+(Y(eu,Va)|0)+(2-(Y(eu,ou)|0)<<2)|0;break}}else NA=hu+8|0;while(0);qz=f[xd>>2]|0;if((f[qz>>2]|0)==1){OA=NA;Xa=302;break}ou=f[f[yd>>2]>>2]|0;if((f[qz+4>>2]|0)==1){PA=NA;QA=hu+(ou*6|0)|0;break}else{qz=f[vd>>2]|0;eu=6/(qz|0)|0;PA=NA;QA=hu+(Y(eu,ou)|0)+(6-(Y(eu,qz)|0)<<2)|0;break}}else{OA=hu+8|0;Xa=302}while(0);if((Xa|0)==302){Xa=0;PA=OA;QA=hu+24|0}Yv=f[PA>>2]|0;f[PA>>2]=f[QA>>2];f[QA>>2]=Yv;do if(!(f[x>>2]&16384)){Yv=f[xd>>2]|0;do if((f[Yv>>2]|0)!=1){qz=f[f[yd>>2]>>2]|0;if((f[Yv+4>>2]|0)==1){RA=hu+(qz*3|0)|0;break}else{eu=f[vd>>2]|0;ou=3/(eu|0)|0;RA=hu+(Y(ou,qz)|0)+(3-(Y(ou,eu)|0)<<2)|0;break}}else RA=hu+12|0;while(0);Yv=f[xd>>2]|0;if((f[Yv>>2]|0)==1){SA=RA;Xa=314;break}eu=f[f[yd>>2]>>2]|0;if((f[Yv+4>>2]|0)==1){TA=RA;UA=hu+(eu*7|0)|0;break}else{Yv=f[vd>>2]|0;ou=7/(Yv|0)|0;TA=RA;UA=hu+(Y(ou,eu)|0)+(7-(Y(ou,Yv)|0)<<2)|0;break}}else{SA=hu+12|0;Xa=314}while(0);if((Xa|0)==314){Xa=0;TA=SA;UA=hu+28|0}Yv=f[TA>>2]|0;f[TA>>2]=f[UA>>2];f[UA>>2]=Yv;do if(!(f[x>>2]&16384)){Yv=f[xd>>2]|0;do if((f[Yv>>2]|0)!=1){ou=f[f[yd>>2]>>2]|0;if((f[Yv+4>>2]|0)==1){VA=hu+(ou<<2)|0;break}else{eu=f[vd>>2]|0;qz=4/(eu|0)|0;VA=hu+(Y(qz,ou)|0)+(4-(Y(qz,eu)|0)<<2)|0;break}}else VA=hu+16|0;while(0);Yv=f[xd>>2]|0;if((f[Yv>>2]|0)==1){WA=VA;Xa=326;break}eu=f[f[yd>>2]>>2]|0;if((f[Yv+4>>2]|0)==1){XA=VA;YA=hu+(eu*6|0)|0;break}else{Yv=f[vd>>2]|0;qz=6/(Yv|0)|0;XA=VA;YA=hu+(Y(qz,eu)|0)+(6-(Y(qz,Yv)|0)<<2)|0;break}}else{WA=hu+16|0;Xa=326}while(0);if((Xa|0)==326){Xa=0;XA=WA;YA=hu+24|0}Yv=f[XA>>2]|0;f[XA>>2]=f[YA>>2];f[YA>>2]=Yv;do if(!(f[x>>2]&16384)){Yv=f[xd>>2]|0;do if((f[Yv>>2]|0)!=1){qz=f[f[yd>>2]>>2]|0;if((f[Yv+4>>2]|0)==1){ZA=hu+(qz*5|0)|0;break}else{eu=f[vd>>2]|0;ou=5/(eu|0)|0;ZA=hu+(Y(ou,qz)|0)+(5-(Y(ou,eu)|0)<<2)|0;break}}else ZA=hu+20|0;while(0);Yv=f[xd>>2]|0;if((f[Yv>>2]|0)==1){_A=ZA;Xa=338;break}eu=f[f[yd>>2]>>2]|0;if((f[Yv+4>>2]|0)==1){$A=ZA;aB=hu+(eu*7|0)|0;break}else{Yv=f[vd>>2]|0;ou=7/(Yv|0)|0;$A=ZA;aB=hu+(Y(ou,eu)|0)+(7-(Y(ou,Yv)|0)<<2)|0;break}}else{_A=hu+20|0;Xa=338}while(0);if((Xa|0)==338){Xa=0;$A=_A;aB=hu+28|0}Yv=f[$A>>2]|0;f[$A>>2]=f[aB>>2];f[aB>>2]=Yv}Yv=f[w>>2]|0;ou=f[Qa>>2]|0;eu=ou;qz=Yv;do if((Yv|0)==(ou|0))Xa=375;else{Va=f[td>>2]|0;if((Va|0)<3)bB=Y(f[vd>>2]|0,f[ud>>2]|0)|0;else{fu=f[xd>>2]|0;Ux=0;lu=1;while(1){dz=Y(f[fu+(Ux<<2)>>2]|0,lu)|0;Ux=Ux+1|0;if((Ux|0)==(Va|0)){bB=dz;break}else lu=dz}}if((bB|0)!=8){Xa=375;break}lu=(f[x>>2]&16384|0)==0;Va=f[wd>>2]|0;do if(lu){Ux=f[xd>>2]|0;do if((f[Ux>>2]|0)!=1){fu=f[f[yd>>2]>>2]|0;if((f[Ux+4>>2]|0)==1){cB=Va+(fu<<2)|0;break}else{dz=f[vd>>2]|0;uz=4/(dz|0)|0;cB=Va+(Y(uz,fu)|0)+(4-(Y(uz,dz)|0)<<2)|0;break}}else cB=Va+16|0;while(0);Ux=f[cB>>2]|0;Na=f[xd>>2]|0;if((f[Na>>2]|0)==1){dB=Ux;Xa=357;break}dz=f[f[yd>>2]>>2]|0;if((f[Na+4>>2]|0)==1){eB=Va+(dz*5|0)|0;fB=Ux;break}else{Na=f[vd>>2]|0;uz=5/(Na|0)|0;eB=Va+(Y(uz,dz)|0)+(5-(Y(uz,Na)|0)<<2)|0;fB=Ux;break}}else{dB=f[Va+16>>2]|0;Xa=357}while(0);if((Xa|0)==357){Xa=0;eB=Va+20|0;fB=dB}if((fB|0)!=(f[eB>>2]|0)){Xa=375;break}do if(lu){Ux=f[xd>>2]|0;do if((f[Ux>>2]|0)!=1){Na=f[f[yd>>2]>>2]|0;if((f[Ux+4>>2]|0)==1){gB=Va+(Na*6|0)|0;break}else{uz=f[vd>>2]|0;dz=6/(uz|0)|0;gB=Va+(Y(dz,Na)|0)+(6-(Y(dz,uz)|0)<<2)|0;break}}else gB=Va+24|0;while(0);Ux=f[gB>>2]|0;uz=f[xd>>2]|0;if((f[uz>>2]|0)==1){hB=Ux;Xa=370;break}dz=f[f[yd>>2]>>2]|0;if((f[uz+4>>2]|0)==1){iB=Va+(dz*7|0)|0;jB=Ux;break}else{uz=f[vd>>2]|0;Na=7/(uz|0)|0;iB=Va+(Y(Na,dz)|0)+(7-(Y(Na,uz)|0)<<2)|0;jB=Ux;break}}else{hB=f[Va+24>>2]|0;Xa=370}while(0);if((Xa|0)==370){Xa=0;iB=Va+28|0;jB=hB}if((jB|0)!=(f[iB>>2]|0)){Xa=375;break}if((eu-qz|0)!=12){Xa=387;break c}f[e>>2]=0;f[Fd>>2]=0;lu=tT(e,5)|0;b[lu>>0]=b[387904]|0;b[lu+1>>0]=b[387905]|0;b[lu+2>>0]=b[387906]|0;b[lu+3>>0]=b[387907]|0;b[lu+4>>0]=b[387908]|0;lu=f[wd>>2]|0;do if(!(f[x>>2]&16384)){Ux=f[xd>>2]|0;if((f[Ux>>2]|0)==1){Xa=390;break}uz=f[f[yd>>2]>>2]|0;if((f[Ux+4>>2]|0)==1){kB=lu+(uz<<2)|0;break}else{Ux=f[vd>>2]|0;Na=4/(Ux|0)|0;kB=lu+(Y(Na,uz)|0)+(4-(Y(Na,Ux)|0)<<2)|0;break}}else Xa=390;while(0);if((Xa|0)==390){Xa=0;kB=lu+16|0}$Ha(t,e,kB)|0;uT(e);f[e>>2]=0;f[Gd>>2]=0;Va=tT(e,5)|0;b[Va>>0]=b[387898]|0;b[Va+1>>0]=b[387899]|0;b[Va+2>>0]=b[387900]|0;b[Va+3>>0]=b[387901]|0;b[Va+4>>0]=b[387902]|0;Va=f[wd>>2]|0;do if(!(f[x>>2]&16384)){Ux=f[xd>>2]|0;if((f[Ux>>2]|0)==1){Xa=396;break}Na=f[f[yd>>2]>>2]|0;if((f[Ux+4>>2]|0)==1){lB=Va+(Na*6|0)|0;break}else{Ux=f[vd>>2]|0;uz=6/(Ux|0)|0;lB=Va+(Y(uz,Na)|0)+(6-(Y(uz,Ux)|0)<<2)|0;break}}else Xa=396;while(0);if((Xa|0)==396){Xa=0;lB=Va+24|0}$Ha(t,e,lB)|0;uT(e);fRa(q,f[(f[Da>>2]|0)+4+(f[(f[w>>2]|0)+8>>2]<<2)>>2]|0);lu=f[w>>2]|0;Ux=f[za>>2]|0;I:do if(!Ux){mB=za;nB=za}else{uz=f[lu>>2]|0;Na=(uz|0)==0?1154740:uz;dz=f[Ux+16>>2]|0;J:do if((uz|0)!=(dz|0)){fu=xa;tz=Ux;Kw=dz;while(1){Fz=(Kw|0)==0?1154740:Kw;if((Ioc(Na,Fz)|0)<0){Vz=f[tz>>2]|0;if(!Vz){Xa=405;break}else{oB=tz;pB=Vz}}else{if((Ioc(Fz,Na)|0)>=0){qB=fu;rB=tz;break J}sB=tz+4|0;Fz=f[sB>>2]|0;if(!Fz){Xa=408;break}else{oB=sB;pB=Fz}}Kw=f[pB+16>>2]|0;if((uz|0)==(Kw|0)){qB=oB;rB=pB;break J}else{fu=oB;tz=pB}}if((Xa|0)==405){Xa=0;mB=tz;nB=tz;break I}else if((Xa|0)==408){Xa=0;mB=sB;nB=tz;break I}}else{qB=xa;rB=Ux}while(0);mB=qB;nB=rB}while(0);if(!(f[mB>>2]|0)){Ux=VDc(24)|0;Va=f[lu>>2]|0;f[Ux+16>>2]=Va;f[Ux+20>>2]=f[lu+4>>2];if(Va|0){uz=Va+-4|0;f[uz>>2]=(f[uz>>2]|0)+1}f[Ux>>2]=0;f[Ux+4>>2]=0;f[Ux+8>>2]=nB;f[mB>>2]=Ux;uz=f[f[j>>2]>>2]|0;if(!uz)tB=Ux;else{f[j>>2]=uz;tB=f[mB>>2]|0}laa(f[xa>>2]|0,tB);f[ya>>2]=(f[ya>>2]|0)+1}uz=f[Ha>>2]|0;uT(r);Ux=uz+11|0;Va=b[Ux>>0]|0;Na=Va<<24>>24<0?f[uz+4>>2]|0:Va&255;if(Na|0){Va=tT(r,Na)|0;dJc(Va|0,((b[Ux>>0]|0)<0?f[uz>>2]|0:uz)|0,Na|0)|0}Na=f[db>>2]|0;uT(s);uz=Na+11|0;Ux=b[uz>>0]|0;Va=Ux<<24>>24<0?f[Na+4>>2]|0:Ux&255;if(!Va){uB=0;break}Ux=tT(s,Va)|0;dJc(Ux|0,((b[uz>>0]|0)<0?f[Na>>2]|0:Na)|0,Va|0)|0;uB=0}while(0);if((Xa|0)==375){Xa=0;f[e>>2]=0;f[zd>>2]=0;qz=tT(e,8)|0;eu=qz;b[eu>>0]=112;b[eu+1>>0]=97;b[eu+2>>0]=100;b[eu+3>>0]=100;eu=qz+4|0;b[eu>>0]=105;b[eu+1>>0]=110;b[eu+2>>0]=103;b[eu+3>>0]=115;eu=f[wd>>2]|0;qz=f[td>>2]|0;if((qz|0)<3)vB=Y(f[vd>>2]|0,f[ud>>2]|0)|0;else{ou=f[xd>>2]|0;Yv=0;hu=1;while(1){Va=Y(f[ou+(Yv<<2)>>2]|0,hu)|0;Yv=Yv+1|0;if((Yv|0)==(qz|0)){vB=Va;break}else hu=Va}}hu=VDc(16)|0;qz=hu+8|0;f[hu>>2]=qz;f[hu+4>>2]=vB;if(vB>>>0>1){Yv=XDc(vB>>>0>536870911?-1:vB<<3)|0;f[hu>>2]=Yv;wB=Yv}else wB=qz;f[g>>2]=0;f[Ad>>2]=hu;if((vB|0)>0){hu=eu;qz=0;while(1){Yv=f[hu>>2]|0;ou=wB+(qz<<3)|0;f[ou>>2]=Yv;f[ou+4>>2]=((Yv|0)<0)<<31>>31;qz=qz+1|0;if((qz|0)==(vB|0))break;else hu=hu+4|0}}bIa(t,e,g)|0;JFa(g);uT(e);f[e>>2]=0;f[Bd>>2]=0;hu=tT(e,7)|0;b[hu>>0]=b[425755]|0;b[hu+1>>0]=b[425756]|0;b[hu+2>>0]=b[425757]|0;b[hu+3>>0]=b[425758]|0;b[hu+4>>0]=b[425759]|0;b[hu+5>>0]=b[425760]|0;b[hu+6>>0]=b[425761]|0;hu=gGa(c,r,e,t)|0;uT(e);qz=HHa(o,r)|0;f[qz>>2]=hu;_Ia(e,v);$Ia(a,o,c,e,hu,0);if((b[Cd>>0]|0)<0)YDc(f[e>>2]|0);uB=10}hu=f[Dd>>2]|0;do if(hu|0){qz=hu+12|0;eu=f[qz>>2]|0;f[qz>>2]=eu+-1;if((eu|0)!=1)break;_S(x)}while(0);f[Dd>>2]=0;f[wd>>2]=0;f[wd+4>>2]=0;f[wd+8>>2]=0;f[wd+12>>2]=0;if((f[td>>2]|0)>0){hu=f[xd>>2]|0;eu=0;do{f[hu+(eu<<2)>>2]=0;eu=eu+1|0}while((eu|0)<(f[td>>2]|0))}eu=f[yd>>2]|0;if((eu|0)!=(Ed|0))g0(eu);if(!uB)Xa=429}else Xa=133;while(0);if((Xa|0)==133){Xa=0;if((f[Wa>>2]|0)!=3){Xa=134;break c}f[$a>>2]=0;f[Ra>>2]=0;f[y>>2]=bb;Jw=f[l>>2]|0;if((Jw|0)!=(Ga|0)){eu=Jw;while(1){Jw=eu+16|0;f[i>>2]=Xb;f[e>>2]=f[i>>2];hu=XIa(y,e,g,h,Jw)|0;if(!(f[hu>>2]|0)){qz=VDc(28)|0;Yv=f[Jw>>2]|0;f[qz+16>>2]=Yv;f[qz+20>>2]=f[eu+20>>2];if(Yv|0){Jw=Yv+-4|0;f[Jw>>2]=(f[Jw>>2]|0)+1}f[qz+24>>2]=f[eu+24>>2];Jw=f[g>>2]|0;f[qz>>2]=0;f[qz+4>>2]=0;f[qz+8>>2]=Jw;f[hu>>2]=qz;Jw=f[f[y>>2]>>2]|0;if(!Jw)xB=qz;else{f[y>>2]=Jw;xB=f[hu>>2]|0}laa(f[$a>>2]|0,xB);f[Ra>>2]=(f[Ra>>2]|0)+1}hu=f[eu+4>>2]|0;do if(!hu){Jw=eu+8|0;qz=f[Jw>>2]|0;if((f[qz>>2]|0)==(eu|0)){yB=qz;break}else zB=Jw;do{Jw=f[zB>>2]|0;zB=Jw+8|0;qz=f[zB>>2]|0}while((f[qz>>2]|0)!=(Jw|0));yB=qz}else{lu=hu;while(1){qz=f[lu>>2]|0;if(!qz)break;else lu=qz}yB=lu}while(0);if((yB|0)==(Ga|0))break;else eu=yB}}eu=YIa(a,q,y,1,0)|0;f[e>>2]=0;f[kb>>2]=0;f[lb>>2]=0;ZIa(eu,e);if((f[eu+160>>2]|0)!=3){Xa=149;break c}if(((f[kb>>2]|0)-(f[e>>2]|0)|0)!=4){Xa=151;break c}Vnb(g,eu);if((f[g>>2]&4095|0)!=4){Xa=153;break c}eu=f[mb>>2]|0;hu=f[nb>>2]|0;if((hu|0)<3)AB=Y(f[pb>>2]|0,f[ob>>2]|0)|0;else{qz=f[sb>>2]|0;Jw=0;Yv=1;while(1){ou=Y(f[qz+(Jw<<2)>>2]|0,Yv)|0;Jw=Jw+1|0;if((Jw|0)==(hu|0)){AB=ou;break}else Yv=ou}}Yv=VDc(16)|0;hu=Yv+8|0;f[Yv>>2]=hu;f[Yv+4>>2]=AB;if(AB>>>0>1){Jw=XDc(AB>>>0>536870911?-1:AB<<3)|0;f[Yv>>2]=Jw;BB=Jw}else BB=hu;f[x>>2]=0;f[qb>>2]=Yv;if((AB|0)>0){Yv=eu;hu=0;while(1){Jw=f[Yv>>2]|0;qz=BB+(hu<<3)|0;f[qz>>2]=Jw;f[qz+4>>2]=((Jw|0)<0)<<31>>31;hu=hu+1|0;if((hu|0)==(AB|0))break;else Yv=Yv+4|0}}Yv=f[rb>>2]|0;do if(Yv|0){hu=Yv+12|0;eu=f[hu>>2]|0;f[hu>>2]=eu+-1;if((eu|0)!=1)break;_S(g)}while(0);f[rb>>2]=0;f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;f[mb+12>>2]=0;if((f[nb>>2]|0)>0){Yv=f[sb>>2]|0;eu=0;do{f[Yv+(eu<<2)>>2]=0;eu=eu+1|0}while((eu|0)<(f[nb>>2]|0))}eu=f[tb>>2]|0;if((eu|0)!=(ub|0))g0(eu);eu=f[e>>2]|0;if(eu|0){Yv=f[kb>>2]|0;if((Yv|0)!=(eu|0))f[kb>>2]=Yv+(~((Yv+-4-eu|0)>>>2)<<2);YDc(eu)}CFa(y,f[bb>>2]|0);switch(f[x>>2]|0){case 0:{CB=(f[vb>>2]|0)+4|0;break}case 3:{CB=(f[qb>>2]|0)+4|0;break}case 2:{CB=(f[qb>>2]|0)+4|0;break}default:{Xa=178;break c}}if((f[CB>>2]|0)!=2){Xa=180;break c}f[e>>2]=0;f[wb>>2]=0;pv=tT(e,10)|0;qv=387921;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));eu=DHa(x,0)|0;f[g>>2]=eu;$Ha(t,e,g)|0;uT(e);f[e>>2]=0;f[xb>>2]=0;pv=tT(e,10)|0;qv=387910;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));eu=DHa(x,1)|0;f[g>>2]=eu;$Ha(t,e,g)|0;uT(e);f[z>>2]=1124007936;pv=yb;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[Ab>>2]=zb;f[Cb>>2]=Bb;f[Bb>>2]=0;f[Db>>2]=0;f[Eb>>2]=0;f[Fb>>2]=0;f[A>>2]=Gb;eu=f[l>>2]|0;if((eu|0)!=(Ga|0)){Yv=eu;while(1){eu=Yv+16|0;f[i>>2]=Wb;f[e>>2]=f[i>>2];hu=XIa(A,e,g,h,eu)|0;if(!(f[hu>>2]|0)){Jw=VDc(28)|0;qz=f[eu>>2]|0;f[Jw+16>>2]=qz;f[Jw+20>>2]=f[Yv+20>>2];if(qz|0){eu=qz+-4|0;f[eu>>2]=(f[eu>>2]|0)+1}f[Jw+24>>2]=f[Yv+24>>2];eu=f[g>>2]|0;f[Jw>>2]=0;f[Jw+4>>2]=0;f[Jw+8>>2]=eu;f[hu>>2]=Jw;eu=f[f[A>>2]>>2]|0;if(!eu)DB=Jw;else{f[A>>2]=eu;DB=f[hu>>2]|0}laa(f[Eb>>2]|0,DB);f[Fb>>2]=(f[Fb>>2]|0)+1}hu=f[Yv+4>>2]|0;do if(!hu){eu=Yv+8|0;Jw=f[eu>>2]|0;if((f[Jw>>2]|0)==(Yv|0)){EB=Jw;break}else FB=eu;do{eu=f[FB>>2]|0;FB=eu+8|0;Jw=f[FB>>2]|0}while((f[Jw>>2]|0)!=(eu|0));EB=Jw}else{lu=hu;while(1){Jw=f[lu>>2]|0;if(!Jw)break;else lu=Jw}EB=lu}while(0);if((EB|0)==(Ga|0))break;else Yv=EB}}Yv=YIa(a,q,A,2,0)|0;f[e>>2]=0;f[Hb>>2]=0;f[Ib>>2]=0;ZIa(Yv,e);hu=f[e>>2]|0;Jw=((f[Hb>>2]|0)-hu|0)==16;eu=hu;if(Jw){hu=eu+8|0;qz=eu+12|0;ou=f[qz>>2]|0;f[qz>>2]=f[hu>>2];qz=eu+4|0;eu=f[qz>>2]|0;f[qz>>2]=ou;f[hu>>2]=eu}YS(z,e,5);Vnb(g,Yv);Yv=f[Jb>>2]|0;if((Yv|0)<3)GB=Y(f[Lb>>2]|0,f[Kb>>2]|0)|0;else{eu=f[Qb>>2]|0;hu=0;ou=1;while(1){qz=Y(f[eu+(hu<<2)>>2]|0,ou)|0;hu=hu+1|0;if((hu|0)==(Yv|0)){GB=qz;break}else ou=qz}}ou=f[yb>>2]|0;if((ou|0)<3)HB=Y(f[Mb>>2]|0,f[zb>>2]|0)|0;else{Yv=f[Ab>>2]|0;hu=0;eu=1;while(1){qz=Y(f[Yv+(hu<<2)>>2]|0,eu)|0;hu=hu+1|0;if((hu|0)==(ou|0)){HB=qz;break}else eu=qz}}if((GB|0)!=(HB|0)){Xa=205;break c}eu=f[Nb>>2]|0;ou=f[Ob>>2]|0;do if(Jw){hu=f[e>>2]|0;Yv=f[hu>>2]|0;qz=f[hu+4>>2]|0;Va=f[hu+8>>2]|0;Na=f[hu+12>>2]|0;hu=Y(Y(Y(qz,Yv)|0,Va)|0,Na)|0;if((Yv|0)<=0)break;uz=Y(Y(Va,qz)|0,Na)|0;Ux=(qz|0)>0;dz=(Va|0)>0;fu=(Na|0)>0;Kw=0;do{do if(Ux){Fz=Y(uz,Kw)|0;if(dz)IB=0;else break;do{Vz=Y(IB,Va)|0;JB=IB+Fz|0;if(fu){KB=0;do{LB=(Y(KB+Vz|0,Na)|0)+Fz|0;MB=Y(KB,Na)|0;NB=0;do{OB=LB+NB|0;PB=JB+(Y(NB+MB|0,qz)|0)|0;if((OB|0)>=(hu|0)){Xa=220;break c}if((PB|0)>=(hu|0)){Xa=221;break c}n[eu+(OB<<2)>>2]=+(f[ou+(PB<<2)>>2]|0);NB=NB+1|0}while((NB|0)<(Na|0));KB=KB+1|0}while((KB|0)<(Va|0))}IB=IB+1|0}while((IB|0)<(qz|0))}while(0);Kw=Kw+1|0}while((Kw|0)<(Yv|0))}else{if((GB|0)>0)QB=0;else break;do{n[eu+(QB<<2)>>2]=+(f[ou+(QB<<2)>>2]|0);QB=QB+1|0}while((QB|0)!=(GB|0))}while(0);ou=f[Pb>>2]|0;do if(ou|0){eu=ou+12|0;Jw=f[eu>>2]|0;f[eu>>2]=Jw+-1;if((Jw|0)!=1)break;_S(g)}while(0);f[Pb>>2]=0;f[Ob>>2]=0;f[Ob+4>>2]=0;f[Ob+8>>2]=0;f[Ob+12>>2]=0;if((f[Jb>>2]|0)>0){ou=f[Qb>>2]|0;Jw=0;do{f[ou+(Jw<<2)>>2]=0;Jw=Jw+1|0}while((Jw|0)<(f[Jb>>2]|0))}Jw=f[Rb>>2]|0;if((Jw|0)!=(Sb|0))g0(Jw);Jw=f[e>>2]|0;if(Jw|0){ou=f[Hb>>2]|0;if((ou|0)!=(Jw|0))f[Hb>>2]=ou+(~((ou+-4-Jw|0)>>>2)<<2);YDc(Jw)}CFa(A,f[Gb>>2]|0);f[e>>2]=0;f[Tb>>2]=0;Jw=tT(e,5)|0;b[Jw>>0]=b[387904]|0;b[Jw+1>>0]=b[387905]|0;b[Jw+2>>0]=b[387906]|0;b[Jw+3>>0]=b[387907]|0;b[Jw+4>>0]=b[387908]|0;eIa(t,e,f[Nb>>2]|0)|0;uT(e);f[e>>2]=0;f[Ub>>2]=0;Jw=tT(e,5)|0;b[Jw>>0]=b[387898]|0;b[Jw+1>>0]=b[387899]|0;b[Jw+2>>0]=b[387900]|0;b[Jw+3>>0]=b[387901]|0;b[Jw+4>>0]=b[387902]|0;Jw=f[Nb>>2]|0;do if(!(f[z>>2]&16384)){ou=f[Ab>>2]|0;if((f[ou>>2]|0)==1){Xa=237;break}eu=f[f[Cb>>2]>>2]|0;if((f[ou+4>>2]|0)==1){RB=Jw+(eu<<1)|0;break}else{ou=f[Mb>>2]|0;Yv=2/(ou|0)|0;RB=Jw+(Y(Yv,eu)|0)+(2-(Y(Yv,ou)|0)<<2)|0;break}}else Xa=237;while(0);if((Xa|0)==237){Xa=0;RB=Jw+8|0}eIa(t,e,RB)|0;uT(e);ou=f[w>>2]|0;if(((f[Qa>>2]|0)-ou|0)!=12){Xa=242;break c}fRa(q,f[(f[Da>>2]|0)+4+(f[ou+8>>2]<<2)>>2]|0);ou=f[w>>2]|0;Yv=f[za>>2]|0;K:do if(!Yv){SB=za;TB=za}else{eu=f[ou>>2]|0;Kw=(eu|0)==0?1154740:eu;qz=f[Yv+16>>2]|0;L:do if((eu|0)!=(qz|0)){Va=xa;Na=Yv;hu=qz;while(1){fu=(hu|0)==0?1154740:hu;if((Ioc(Kw,fu)|0)<0){dz=f[Na>>2]|0;if(!dz){Xa=248;break}else{UB=Na;VB=dz}}else{if((Ioc(fu,Kw)|0)>=0){WB=Va;XB=Na;break L}YB=Na+4|0;fu=f[YB>>2]|0;if(!fu){Xa=251;break}else{UB=YB;VB=fu}}hu=f[VB+16>>2]|0;if((eu|0)==(hu|0)){WB=UB;XB=VB;break L}else{Va=UB;Na=VB}}if((Xa|0)==248){Xa=0;SB=Na;TB=Na;break K}else if((Xa|0)==251){Xa=0;SB=YB;TB=Na;break K}}else{WB=xa;XB=Yv}while(0);SB=WB;TB=XB}while(0);if(!(f[SB>>2]|0)){Yv=VDc(24)|0;Jw=f[ou>>2]|0;f[Yv+16>>2]=Jw;f[Yv+20>>2]=f[ou+4>>2];if(Jw|0){eu=Jw+-4|0;f[eu>>2]=(f[eu>>2]|0)+1}f[Yv>>2]=0;f[Yv+4>>2]=0;f[Yv+8>>2]=TB;f[SB>>2]=Yv;eu=f[f[j>>2]>>2]|0;if(!eu)ZB=Yv;else{f[j>>2]=eu;ZB=f[SB>>2]|0}laa(f[xa>>2]|0,ZB);f[ya>>2]=(f[ya>>2]|0)+1}eu=f[Ha>>2]|0;uT(r);Yv=eu+11|0;Jw=b[Yv>>0]|0;Kw=Jw<<24>>24<0?f[eu+4>>2]|0:Jw&255;if(Kw|0){Jw=tT(r,Kw)|0;dJc(Jw|0,((b[Yv>>0]|0)<0?f[eu>>2]|0:eu)|0,Kw|0)|0}Kw=f[db>>2]|0;uT(s);eu=Kw+11|0;Yv=b[eu>>0]|0;Jw=Yv<<24>>24<0?f[Kw+4>>2]|0:Yv&255;if(Jw|0){Yv=tT(s,Jw)|0;dJc(Yv|0,((b[eu>>0]|0)<0?f[Kw>>2]|0:Kw)|0,Jw|0)|0}Jw=f[Vb>>2]|0;do if(Jw|0){Kw=Jw+12|0;eu=f[Kw>>2]|0;f[Kw>>2]=eu+-1;if((eu|0)!=1)break;_S(z)}while(0);f[Vb>>2]=0;f[Nb>>2]=0;f[Nb+4>>2]=0;f[Nb+8>>2]=0;f[Nb+12>>2]=0;if((f[yb>>2]|0)>0){Jw=f[Ab>>2]|0;ou=0;do{f[Jw+(ou<<2)>>2]=0;ou=ou+1|0}while((ou|0)<(f[yb>>2]|0))}ou=f[Cb>>2]|0;if((ou|0)!=(Bb|0))g0(ou);JFa(x);Xa=429}if((Xa|0)==429){Xa=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;ou=VDc(32)|0;f[h>>2]=ou;f[Yb>>2]=-2147483616;f[Zb>>2]=19;pv=ou;qv=446524;rv=pv+19|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[ou+19>>0]=0;Wdc(_b);aJa(g,$b);bJa(e,f[ac>>2]|0,h,0);Jw=f[e>>2]|0;cJa(g);if(!Jw)_B=0;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Jw=VDc(32)|0;f[e>>2]=Jw;f[md>>2]=-2147483616;f[nd>>2]=19;pv=Jw;qv=446524;rv=pv+19|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[Jw+19>>0]=0;Wdc(_b);ou=dJa($b,e)|0;eu=b[ou+8>>0]|0?(f[ou+20>>2]|0)==5:0;if((b[od>>0]|0)<0)YDc(f[e>>2]|0);_B=eu}if((b[bc>>0]|0)<0)YDc(f[h>>2]|0);f[e>>2]=0;f[cc>>2]=0;pv=tT(e,9)|0;qv=454939;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=0;rIa(t,e,g)|0;uT(e);g$(dc,1);f[g>>2]=0;f[ec>>2]=0;Jw=tT(g,7)|0;b[Jw>>0]=b[383309]|0;b[Jw+1>>0]=b[383310]|0;b[Jw+2>>0]=b[383311]|0;b[Jw+3>>0]=b[383312]|0;b[Jw+4>>0]=b[383313]|0;b[Jw+5>>0]=b[383314]|0;b[Jw+6>>0]=b[383315]|0;VIa(e,Ba,r,g);WIa(w,f[e>>2]|0,f[fc>>2]|0);Jw=f[e>>2]|0;if(Jw|0){while(1){eu=f[fc>>2]|0;if((eu|0)==(Jw|0))break;ou=eu+-12|0;f[fc>>2]=ou;uT(ou)}YDc(f[e>>2]|0)}uT(g);do if(((f[Qa>>2]|0)-(f[w>>2]|0)|0)==12){f[e>>2]=0;f[gc>>2]=0;pv=tT(e,9)|0;qv=454939;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));b[g>>0]=1;rIa(t,e,g)|0;uT(e);g$(dc,2);Jw=f[(f[w>>2]|0)+8>>2]|0;ou=f[(f[Da>>2]|0)+4+(Jw<<2)>>2]|0;f[hc>>2]=0;f[ic>>2]=0;f[C>>2]=jc;eu=f[l>>2]|0;if((eu|0)!=(Ga|0)){Kw=eu;while(1){eu=Kw+16|0;f[i>>2]=kc;f[e>>2]=f[i>>2];Yv=XIa(C,e,g,h,eu)|0;if(!(f[Yv>>2]|0)){qz=VDc(28)|0;Va=f[eu>>2]|0;f[qz+16>>2]=Va;f[qz+20>>2]=f[Kw+20>>2];if(Va|0){eu=Va+-4|0;f[eu>>2]=(f[eu>>2]|0)+1}f[qz+24>>2]=f[Kw+24>>2];eu=f[g>>2]|0;f[qz>>2]=0;f[qz+4>>2]=0;f[qz+8>>2]=eu;f[Yv>>2]=qz;eu=f[f[C>>2]>>2]|0;if(!eu)$B=qz;else{f[C>>2]=eu;$B=f[Yv>>2]|0}laa(f[hc>>2]|0,$B);f[ic>>2]=(f[ic>>2]|0)+1}Yv=f[Kw+4>>2]|0;do if(!Yv){eu=Kw+8|0;qz=f[eu>>2]|0;if((f[qz>>2]|0)==(Kw|0)){aC=qz;break}else bC=eu;do{eu=f[bC>>2]|0;bC=eu+8|0;qz=f[bC>>2]|0}while((f[qz>>2]|0)!=(eu|0));aC=qz}else{qz=Yv;while(1){eu=f[qz>>2]|0;if(!eu)break;else qz=eu}aC=qz}while(0);if((aC|0)==(Ga|0))break;else Kw=aC}}Kw=YIa(a,ou,C,-1,0)|0;eJa(Kw,(f[dc>>2]|0)+56|0);CFa(C,f[jc>>2]|0);fJa(Ba,Jw,0);Kw=f[w>>2]|0;Yv=f[za>>2]|0;M:do if(!Yv){cC=za;dC=za}else{Na=f[Kw>>2]|0;eu=(Na|0)==0?1154740:Na;Va=f[Yv+16>>2]|0;N:do if((Na|0)!=(Va|0)){hu=xa;fu=Yv;dz=Va;while(1){uz=(dz|0)==0?1154740:dz;if((Ioc(eu,uz)|0)<0){Ux=f[fu>>2]|0;if(!Ux){Xa=458;break}else{eC=fu;fC=Ux}}else{if((Ioc(uz,eu)|0)>=0){gC=hu;hC=fu;break N}iC=fu+4|0;uz=f[iC>>2]|0;if(!uz){Xa=461;break}else{eC=iC;fC=uz}}dz=f[fC+16>>2]|0;if((Na|0)==(dz|0)){gC=eC;hC=fC;break N}else{hu=eC;fu=fC}}if((Xa|0)==458){Xa=0;cC=fu;dC=fu;break M}else if((Xa|0)==461){Xa=0;cC=iC;dC=fu;break M}}else{gC=xa;hC=Yv}while(0);cC=gC;dC=hC}while(0);if(!(f[cC>>2]|0)){Yv=VDc(24)|0;Jw=f[Kw>>2]|0;f[Yv+16>>2]=Jw;f[Yv+20>>2]=f[Kw+4>>2];if(Jw|0){ou=Jw+-4|0;f[ou>>2]=(f[ou>>2]|0)+1}f[Yv>>2]=0;f[Yv+4>>2]=0;f[Yv+8>>2]=dC;f[cC>>2]=Yv;ou=f[f[j>>2]>>2]|0;if(!ou)jC=Yv;else{f[j>>2]=ou;jC=f[cC>>2]|0}laa(f[xa>>2]|0,jC);f[ya>>2]=(f[ya>>2]|0)+1}if(!_B){kC=0;break}ou=f[dc>>2]|0;Yv=f[ou+60>>2]|0;if((Yv|0)<3)lC=Y(f[ou+68>>2]|0,f[ou+64>>2]|0)|0;else{Jw=f[ou+96>>2]|0;Na=0;eu=1;while(1){Va=Y(f[Jw+(Na<<2)>>2]|0,eu)|0;Na=Na+1|0;if((Na|0)==(Yv|0)){lC=Va;break}else eu=Va}}eu=f[ou+72>>2]|0;if(lC&3|0){Xa=476;break c}if((lC|0)>0)mC=0;else{kC=1;break}do{Yv=eu+(mC<<2)|0;Na=eu+((mC|1)<<2)|0;Jw=f[Yv>>2]|0;f[Yv>>2]=f[Na>>2];f[Na>>2]=Jw;mC=mC+2|0}while((mC|0)<(lC|0));kC=1}else kC=_B;while(0);f[x>>2]=-1;f[lc>>2]=0;f[mc>>2]=0;f[D>>2]=nc;eu=f[l>>2]|0;if((eu|0)!=(Ga|0)){ou=eu;while(1){eu=ou+16|0;f[i>>2]=ld;f[e>>2]=f[i>>2];Jw=XIa(D,e,g,h,eu)|0;if(!(f[Jw>>2]|0)){Na=VDc(28)|0;Yv=f[eu>>2]|0;f[Na+16>>2]=Yv;f[Na+20>>2]=f[ou+20>>2];if(Yv|0){eu=Yv+-4|0;f[eu>>2]=(f[eu>>2]|0)+1}f[Na+24>>2]=f[ou+24>>2];eu=f[g>>2]|0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=eu;f[Jw>>2]=Na;eu=f[f[D>>2]>>2]|0;if(!eu)nC=Na;else{f[D>>2]=eu;nC=f[Jw>>2]|0}laa(f[lc>>2]|0,nC);f[mc>>2]=(f[mc>>2]|0)+1}Jw=f[ou+4>>2]|0;do if(!Jw){eu=ou+8|0;Na=f[eu>>2]|0;if((f[Na>>2]|0)==(ou|0)){oC=Na;break}else pC=eu;do{eu=f[pC>>2]|0;pC=eu+8|0;Na=f[pC>>2]|0}while((f[Na>>2]|0)!=(eu|0));oC=Na}else{Na=Jw;while(1){eu=f[Na>>2]|0;if(!eu)break;else Na=eu}oC=Na}while(0);if((oC|0)==(Ga|0))break;else ou=oC}}ou=YIa(a,q,D,-1,x)|0;CFa(D,f[nc>>2]|0);Jw=f[(f[Fa>>2]|0)+4+(f[x>>2]<<2)>>2]|0;f[g>>2]=0;f[oc>>2]=0;eu=Jw+11|0;Yv=b[eu>>0]|0;Kw=Yv<<24>>24<0?f[Jw+4>>2]|0:Yv&255;if(Kw|0){Yv=tT(g,Kw)|0;dJc(Yv|0,((b[eu>>0]|0)<0?f[Jw>>2]|0:Jw)|0,Kw|0)|0}Kw=f[Za>>2]|0;do if(!Kw)Xa=503;else{Jw=f[g>>2]|0;eu=(Jw|0)==0?1154740:Jw;Yv=Za;Va=Kw;O:while(1){hu=Va;while(1){dz=f[hu+16>>2]|0;if((dz|0)==(Jw|0))break;if((Ioc((dz|0)==0?1154740:dz,eu)|0)>=0)break;dz=f[hu+4>>2]|0;if(!dz){qC=Yv;break O}else hu=dz}Va=f[hu>>2]|0;if(!Va){qC=hu;break}else Yv=hu}if((qC|0)==(Za|0)){Xa=503;break}Yv=f[qC+16>>2]|0;if((Jw|0)!=(Yv|0)?(Ioc(eu,(Yv|0)==0?1154740:Yv)|0)<0:0){Xa=503;break}Yv=qC+24|0;Va=f[dc>>2]|0;if((Va|0)==(Yv|0))break;Na=qC+60|0;dz=f[Na>>2]|0;if(dz|0){qz=dz+12|0;f[qz>>2]=(f[qz>>2]|0)+1}qz=Va+36|0;dz=f[qz>>2]|0;do if(dz|0){uz=dz+12|0;Ux=f[uz>>2]|0;f[uz>>2]=Ux+-1;if((Ux|0)!=1)break;_S(Va)}while(0);f[qz>>2]=0;dz=Va+16|0;eu=Va+4|0;f[dz>>2]=0;f[dz+4>>2]=0;f[dz+8>>2]=0;f[dz+12>>2]=0;if((f[eu>>2]|0)>0){Jw=f[Va+40>>2]|0;Ux=0;do{f[Jw+(Ux<<2)>>2]=0;Ux=Ux+1|0;rC=f[eu>>2]|0}while((Ux|0)<(rC|0));f[Va>>2]=f[Yv>>2];if((rC|0)<3)Xa=609;else Xa=611}else{f[Va>>2]=f[Yv>>2];Xa=609}do if((Xa|0)==609){Xa=0;Ux=f[qC+28>>2]|0;if((Ux|0)>=3){Xa=611;break}f[eu>>2]=Ux;f[Va+8>>2]=f[qC+32>>2];f[Va+12>>2]=f[qC+36>>2];Ux=f[qC+68>>2]|0;Jw=f[Va+44>>2]|0;f[Jw>>2]=f[Ux>>2];f[Jw+4>>2]=f[Ux+4>>2]}while(0);if((Xa|0)==611){Xa=0;ZS(Va,Yv)}f[dz>>2]=f[qC+40>>2];f[Va+20>>2]=f[qC+44>>2];f[Va+24>>2]=f[qC+48>>2];f[Va+28>>2]=f[qC+52>>2];f[Va+32>>2]=f[qC+56>>2];f[qz>>2]=f[Na>>2]}while(0);do if((Xa|0)==503){Xa=0;gJa(ou,f[dc>>2]|0);Oob(ou);Kw=f[dc>>2]|0;eu=f[Kw+40>>2]|0;Ux=f[eu>>2]|0;Jw=eu+4|0;uz=f[Jw>>2]|0;lu=f[eu+8>>2]|0;Fz=f[eu+12>>2]|0;KB=f[s>>2]|0;if(!((KB|0)!=383032?(Ioc((KB|0)==0?1154740:KB,383032)|0)!=0:0)){if(kC){Xa=506;break c}f[h>>2]=1124007936;pv=pc;rv=pv+36|0;do{f[pv>>2]=0;pv=pv+4|0}while((pv|0)<(rv|0));f[rc>>2]=qc;f[tc>>2]=sc;f[sc>>2]=0;f[uc>>2]=0;Na=vc;f[Na>>2]=0;f[Na+4>>2]=0;f[e>>2]=33619968;f[wc>>2]=h;h_(Kw,e);Na=f[xc>>2]|0;qz=f[dc>>2]|0;Va=f[qz+16>>2]|0;do if((Ux|0)>0){dz=Y(Fz,lu)|0;Yv=(dz|0)>0;if((uz|0)>0)sC=0;else break;do{KB=Y(sC,uz)|0;if(Yv){JB=0;do{Vz=Y(dz,JB+KB|0)|0;tz=Y(dz,(Y(JB,Ux)|0)+sC|0)|0;NB=0;do{f[Va+(NB+tz<<2)>>2]=f[Na+(NB+Vz<<2)>>2];NB=NB+1|0}while((NB|0)!=(dz|0));JB=JB+1|0}while((JB|0)!=(uz|0))}sC=sC+1|0}while((sC|0)!=(Ux|0))}while(0);Na=Y(Ux,uz)|0;f[eu>>2]=Na;f[Jw>>2]=1;Na=f[qz+44>>2]|0;f[Na>>2]=f[Na+4>>2];Na=f[yc>>2]|0;do if(Na|0){Va=Na+12|0;Kw=f[Va>>2]|0;f[Va>>2]=Kw+-1;if((Kw|0)!=1)break;_S(h)}while(0);f[yc>>2]=0;f[xc>>2]=0;f[xc+4>>2]=0;f[xc+8>>2]=0;f[xc+12>>2]=0;if((f[pc>>2]|0)>0){Na=f[rc>>2]|0;qz=0;do{f[Na+(qz<<2)>>2]=0;qz=qz+1|0}while((qz|0)<(f[pc>>2]|0))}qz=f[tc>>2]|0;if((qz|0)!=(sc|0))g0(qz)}do if(kC){qz=Y(Y(lu,uz)|0,Fz)|0;if((Ux|0)>0)tC=0;else break;do{Na=f[dc>>2]|0;Vj(e,1,qz,5,(f[Na+16>>2]|0)+(Y(f[f[Na+44>>2]>>2]|0,tC)|0)|0,0);Na=f[dc>>2]|0;Vj(h,1,qz,5,(f[Na+16>>2]|0)+(Y(f[f[Na+44>>2]>>2]|0,tC|1)|0)|0,0);f[E>>2]=e;Na=f[Ac>>2]|0;if((Na|0)>0)uC=f[(f[Bc>>2]|0)+(Na+-1<<2)>>2]|0;else uC=0;f[zc>>2]=uC;f[Cc>>2]=0;f[Dc>>2]=0;f[Ec>>2]=0;if(f[e>>2]&16384|0){Jw=f[Wc>>2]|0;f[Dc>>2]=Jw;if((Na|0)<3)vC=Y(f[Kc>>2]|0,f[Jc>>2]|0)|0;else{eu=f[Xc>>2]|0;Kw=0;Va=1;while(1){dz=Y(f[eu+(Kw<<2)>>2]|0,Va)|0;Kw=Kw+1|0;if((Kw|0)==(Na|0)){vC=dz;break}else Va=dz}}Va=Jw+(Y(vC,uC)|0)|0;f[Ec>>2]=Va}C2(E,0,0);f[F>>2]=e;Va=f[Ac>>2]|0;if((Va|0)>0)wC=f[(f[Bc>>2]|0)+(Va+-1<<2)>>2]|0;else wC=0;f[Fc>>2]=wC;f[Gc>>2]=0;f[Hc>>2]=0;f[Ic>>2]=0;if(f[e>>2]&16384|0){Na=f[Wc>>2]|0;f[Hc>>2]=Na;if((Va|0)<3)xC=Y(f[Kc>>2]|0,f[Jc>>2]|0)|0;else{Kw=f[Xc>>2]|0;eu=0;dz=1;while(1){Yv=Y(f[Kw+(eu<<2)>>2]|0,dz)|0;eu=eu+1|0;if((eu|0)==(Va|0)){xC=Yv;break}else dz=Yv}}dz=Na+(Y(xC,wC)|0)|0;f[Ic>>2]=dz}C2(F,0,0);dz=f[Ac>>2]|0;if((dz|0)<3)yC=Y(f[Kc>>2]|0,f[Jc>>2]|0)|0;else{Va=f[Xc>>2]|0;eu=0;Kw=1;while(1){Jw=Y(f[Va+(eu<<2)>>2]|0,Kw)|0;eu=eu+1|0;if((eu|0)==(dz|0)){yC=Jw;break}else Kw=Jw}}do if(!((yC|0)==0|(f[F>>2]|0)==0)){Kw=Y(f[Fc>>2]|0,yC)|0;dz=(f[Gc>>2]|0)+Kw|0;f[Gc>>2]=dz;if(dz>>>0>=(f[Hc>>2]|0)>>>0?(f[Ic>>2]|0)>>>0>dz>>>0:0)break;f[Gc>>2]=dz+(0-Kw);B2(F,yC,1)}while(0);f[G>>2]=h;Kw=f[Mc>>2]|0;if((Kw|0)>0)zC=f[(f[Nc>>2]|0)+(Kw+-1<<2)>>2]|0;else zC=0;f[Lc>>2]=zC;f[Oc>>2]=0;f[Pc>>2]=0;f[Qc>>2]=0;if(f[h>>2]&16384|0){dz=f[Sc>>2]|0;f[Pc>>2]=dz;if((Kw|0)<3)AC=Y(f[_c>>2]|0,f[Zc>>2]|0)|0;else{eu=f[Tc>>2]|0;Va=0;Na=1;while(1){Jw=Y(f[eu+(Va<<2)>>2]|0,Na)|0;Va=Va+1|0;if((Va|0)==(Kw|0)){AC=Jw;break}else Na=Jw}}Na=dz+(Y(AC,zC)|0)|0;f[Qc>>2]=Na}C2(G,0,0);while(1){Na=f[E>>2]|0;if((Na|0)==(f[F>>2]|0)){Kw=f[Cc>>2]|0;if((Kw|0)==(f[Gc>>2]|0))break;else{BC=Kw;CC=Kw}}else{Kw=f[Cc>>2]|0;BC=Kw;CC=Kw}Kw=f[Oc>>2]|0;Va=f[BC>>2]|0;f[BC>>2]=f[Kw>>2];f[Kw>>2]=Va;do if(Na|0){Va=f[zc>>2]|0;Kw=CC+Va|0;f[Cc>>2]=Kw;if(Kw>>>0<(f[Ec>>2]|0)>>>0)break;f[Cc>>2]=Kw+(0-Va);B2(E,1,1)}while(0);if(!(f[G>>2]|0))continue;Na=f[Lc>>2]|0;Va=(f[Oc>>2]|0)+Na|0;f[Oc>>2]=Va;if(Va>>>0<(f[Qc>>2]|0)>>>0)continue;f[Oc>>2]=Va+(0-Na);B2(G,1,1)}dz=f[Rc>>2]|0;do if(dz|0){Na=dz+12|0;Va=f[Na>>2]|0;f[Na>>2]=Va+-1;if((Va|0)!=1)break;_S(h)}while(0);f[Rc>>2]=0;f[Sc>>2]=0;f[Sc+4>>2]=0;f[Sc+8>>2]=0;f[Sc+12>>2]=0;if((f[Mc>>2]|0)>0){dz=f[Tc>>2]|0;Va=0;do{f[dz+(Va<<2)>>2]=0;Va=Va+1|0}while((Va|0)<(f[Mc>>2]|0))}Va=f[Nc>>2]|0;if((Va|0)!=(Uc|0))g0(Va);Va=f[Vc>>2]|0;do if(Va|0){dz=Va+12|0;Na=f[dz>>2]|0;f[dz>>2]=Na+-1;if((Na|0)!=1)break;_S(e)}while(0);f[Vc>>2]=0;f[Wc>>2]=0;f[Wc+4>>2]=0;f[Wc+8>>2]=0;f[Wc+12>>2]=0;if((f[Ac>>2]|0)>0){Va=f[Xc>>2]|0;Na=0;do{f[Va+(Na<<2)>>2]=0;Na=Na+1|0}while((Na|0)<(f[Ac>>2]|0))}Na=f[Bc>>2]|0;if((Na|0)!=(Yc|0))g0(Na);tC=tC+2|0}while((tC|0)<(Ux|0))}while(0);Ux=f[dc>>2]|0;Fz=hJa(m,g)|0;if((Fz|0)==(Ux|0))break;uz=Ux+36|0;lu=f[uz>>2]|0;if(lu|0){qz=lu+12|0;f[qz>>2]=(f[qz>>2]|0)+1}qz=Fz+36|0;lu=f[qz>>2]|0;do if(lu|0){Na=lu+12|0;Va=f[Na>>2]|0;f[Na>>2]=Va+-1;if((Va|0)!=1)break;_S(Fz)}while(0);f[qz>>2]=0;lu=Fz+16|0;Va=Fz+4|0;f[lu>>2]=0;f[lu+4>>2]=0;f[lu+8>>2]=0;f[lu+12>>2]=0;if((f[Va>>2]|0)>0){Na=f[Fz+40>>2]|0;dz=0;do{f[Na+(dz<<2)>>2]=0;dz=dz+1|0;DC=f[Va>>2]|0}while((dz|0)<(DC|0));f[Fz>>2]=f[Ux>>2];if((DC|0)<3)Xa=594;else Xa=596}else{f[Fz>>2]=f[Ux>>2];Xa=594}do if((Xa|0)==594){Xa=0;dz=f[Ux+4>>2]|0;if((dz|0)>=3){Xa=596;break}f[Va>>2]=dz;f[Fz+8>>2]=f[Ux+8>>2];f[Fz+12>>2]=f[Ux+12>>2];dz=f[Ux+44>>2]|0;Na=f[Fz+44>>2]|0;f[Na>>2]=f[dz>>2];f[Na+4>>2]=f[dz+4>>2]}while(0);if((Xa|0)==596){Xa=0;ZS(Fz,Ux)}f[lu>>2]=f[Ux+16>>2];f[Fz+20>>2]=f[Ux+20>>2];f[Fz+24>>2]=f[Ux+24>>2];f[Fz+28>>2]=f[Ux+28>>2];f[Fz+32>>2]=f[Ux+32>>2];f[qz>>2]=f[uz>>2]}while(0);f[e>>2]=0;f[$c>>2]=0;ou=tT(e,8)|0;Va=ou;b[Va>>0]=107;b[Va+1>>0]=101;b[Va+2>>0]=114;b[Va+3>>0]=110;Va=ou+4|0;b[Va>>0]=101;b[Va+1>>0]=108;b[Va+2>>0]=95;b[Va+3>>0]=104;$Ha(t,e,(f[(f[dc>>2]|0)+40>>2]|0)+8|0)|0;uT(e);f[e>>2]=0;f[ad>>2]=0;Va=tT(e,8)|0;ou=Va;b[ou>>0]=107;b[ou+1>>0]=101;b[ou+2>>0]=114;b[ou+3>>0]=110;ou=Va+4|0;b[ou>>0]=101;b[ou+1>>0]=108;b[ou+2>>0]=95;b[ou+3>>0]=119;$Ha(t,e,(f[(f[dc>>2]|0)+40>>2]|0)+12|0)|0;uT(e);f[e>>2]=0;f[bd>>2]=0;pv=tT(e,10)|0;qv=455057;rv=pv+10|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));$Ha(t,e,f[(f[dc>>2]|0)+40>>2]|0)|0;uT(e);iJa(t,q);f[e>>2]=0;f[cd>>2]=0;ou=tT(e,5)|0;b[ou>>0]=b[387898]|0;b[ou+1>>0]=b[387899]|0;b[ou+2>>0]=b[387900]|0;b[ou+3>>0]=b[387901]|0;b[ou+4>>0]=b[387902]|0;ou=f[Ia>>2]|0;P:do if(ou){Va=f[e>>2]|0;dz=(Va|0)==0?1154740:Va;Na=ou;while(1){Kw=f[Na+16>>2]|0;if((Va|0)==(Kw|0)){Xa=633;break}eu=(Kw|0)==0?1154740:Kw;if((Ioc(dz,eu)|0)<0)EC=Na;else{if((Ioc(eu,dz)|0)>=0){Xa=634;break}EC=Na+4|0}Na=f[EC>>2]|0;if(!Na){Xa=621;break P}}if((Xa|0)==633){Xa=0;uT(e);break}else if((Xa|0)==634){Xa=0;uT(e);break}}else Xa=621;while(0);Q:do if((Xa|0)==621){Xa=0;f[h>>2]=0;f[dd>>2]=0;ou=tT(h,5)|0;b[ou>>0]=b[387904]|0;b[ou+1>>0]=b[387905]|0;b[ou+2>>0]=b[387906]|0;b[ou+3>>0]=b[387907]|0;b[ou+4>>0]=b[387908]|0;ou=f[Ia>>2]|0;do if(ou){Na=f[h>>2]|0;dz=(Na|0)==0?1154740:Na;Va=ou;while(1){uz=f[Va+16>>2]|0;if((Na|0)==(uz|0)){Xa=629;break}qz=(uz|0)==0?1154740:uz;if((Ioc(dz,qz)|0)<0)FC=Va;else{if((Ioc(qz,dz)|0)>=0){Xa=635;break}FC=Va+4|0}Va=f[FC>>2]|0;if(!Va){Xa=631;break}}if((Xa|0)==629){Xa=0;uT(h);uT(e);break Q}else if((Xa|0)==631){Xa=0;uT(h);uT(e);break}else if((Xa|0)==635){Xa=0;uT(h);uT(e);break Q}}else{uT(h);uT(e)}while(0);jJa(t,q)}while(0);f[h>>2]=0;f[ed>>2]=0;pv=tT(h,14)|0;qv=383356;rv=pv+14|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));VIa(e,Ba,r,h);WIa(w,f[e>>2]|0,f[fd>>2]|0);ou=f[e>>2]|0;if(ou|0){while(1){Va=f[fd>>2]|0;if((Va|0)==(ou|0))break;dz=Va+-12|0;f[fd>>2]=dz;uT(dz)}YDc(f[e>>2]|0)}uT(h);ou=f[w>>2]|0;dz=f[Qa>>2]|0;do if((ou|0)!=(dz|0)){if((dz-ou|0)!=12){Xa=642;break c}fJa(Ba,f[ou+8>>2]|0,0);Va=f[w>>2]|0;Na=f[za>>2]|0;R:do if(!Na){GC=za;HC=za}else{qz=f[Va>>2]|0;uz=(qz|0)==0?1154740:qz;Ux=f[Na+16>>2]|0;S:do if((qz|0)!=(Ux|0)){Fz=xa;lu=Na;eu=Ux;while(1){Kw=(eu|0)==0?1154740:eu;if((Ioc(uz,Kw)|0)<0){Jw=f[lu>>2]|0;if(!Jw){Xa=648;break}else{IC=lu;JC=Jw}}else{if((Ioc(Kw,uz)|0)>=0){KC=Fz;LC=lu;break S}MC=lu+4|0;Kw=f[MC>>2]|0;if(!Kw){Xa=651;break}else{IC=MC;JC=Kw}}eu=f[JC+16>>2]|0;if((qz|0)==(eu|0)){KC=IC;LC=JC;break S}else{Fz=IC;lu=JC}}if((Xa|0)==648){Xa=0;GC=lu;HC=lu;break R}else if((Xa|0)==651){Xa=0;GC=MC;HC=lu;break R}}else{KC=xa;LC=Na}while(0);GC=KC;HC=LC}while(0);if(f[GC>>2]|0)break;Na=VDc(24)|0;qz=f[Va>>2]|0;f[Na+16>>2]=qz;f[Na+20>>2]=f[Va+4>>2];if(qz|0){uz=qz+-4|0;f[uz>>2]=(f[uz>>2]|0)+1}f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=HC;f[GC>>2]=Na;uz=f[f[j>>2]>>2]|0;if(!uz)NC=Na;else{f[j>>2]=uz;NC=f[GC>>2]|0}laa(f[xa>>2]|0,NC);f[ya>>2]=(f[ya>>2]|0)+1}while(0);f[e>>2]=0;f[gd>>2]=0;pv=tT(e,11)|0;qv=455045;rv=pv+11|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));ou=gGa(c,r,e,t)|0;uT(e);dz=HHa(o,r)|0;f[dz>>2]=ou;_Ia(e,v);$Ia(a,o,c,e,ou,0);if((b[hd>>0]|0)<0)YDc(f[e>>2]|0);ou=f[r>>2]|0;dz=f[La>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(dz>>>0>4294967279){Xa=662;break c}if(dz>>>0<11){b[id>>0]=dz;if(!dz)OC=e;else{PC=e;Xa=666}}else{uz=dz+16&-16;Na=VDc(uz)|0;f[e>>2]=Na;f[jd>>2]=uz|-2147483648;f[kd>>2]=dz;PC=Na;Xa=666}if((Xa|0)==666){Xa=0;dJc(PC|0,ou|0,dz|0)|0;OC=PC}b[OC+dz>>0]=0;dz=(kJa(e,k)|0)==2;if((b[id>>0]|0)<0)YDc(f[e>>2]|0);if(dz){dz=HHa(k,r)|0;f[dz>>2]=0}uT(g)}dz=f[w>>2]|0;if(dz|0){while(1){ou=f[Qa>>2]|0;if((ou|0)==(dz|0))break;Na=ou+-12|0;f[Qa>>2]=Na;uT(Na)}YDc(f[w>>2]|0)}if((b[pd>>0]|0)<0)YDc(f[v>>2]|0)}while(0);HFa(t);uT(s);uT(r);vQa(q);cu=cu+1|0;if((cu|0)>=(Aa|0)){eb=xi;Xa=60;break}}switch(Xa|0){case 60:{zHa(c,eb);fb=f[wa>>2]|0;CFa(o,fb);gb=f[Za>>2]|0;qJa(m,gb);hb=f[Ga>>2]|0;CFa(l,hb);ib=f[Ca>>2]|0;CFa(k,ib);jb=f[za>>2]|0;rJa(j,jb);u=d;return}case 111:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,24)|0;qv=382881;rv=pv+24|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,382906,382930,654);break}case 134:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383058;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,760);break}case 149:{f[g>>2]=0;f[g+4>>2]=0;pv=tT(g,38)|0;qv=383082;rv=pv+38|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,g,383121,382930,307);break}case 151:{f[g>>2]=0;f[g+4>>2]=0;pv=tT(g,9)|0;qv=383131;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,g,383121,382930,308);break}case 153:{f[h>>2]=0;f[h+4>>2]=0;pv=tT(h,25)|0;qv=383141;rv=pv+25|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,h,383121,382930,311);break}case 178:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,467763,451988,278);break}case 180:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,20)|0;qv=383167;rv=pv+20|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,763);break}case 205:{f[h>>2]=0;f[h+4>>2]=0;pv=tT(h,28)|0;qv=383188;rv=pv+28|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,h,383217,382930,113);break}case 220:{f[h>>2]=0;f[h+4>>2]=0;pv=tT(h,13)|0;qv=383229;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,h,383217,382930,129);break}case 221:{f[h>>2]=0;f[h+4>>2]=0;pv=tT(h,13)|0;qv=383243;rv=pv+13|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,h,383217,382930,130);break}case 242:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383257;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,774);break}case 288:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,27)|0;qv=383281;rv=pv+27|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,783);break}case 387:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383257;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,814);break}case 476:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,19)|0;qv=383317;rv=pv+19|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,852);break}case 506:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,18)|0;qv=383337;rv=pv+18|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,876);break}case 642:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383257;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,927);break}case 662:{dEc(e);break}case 701:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,37)|0;qv=383371;rv=pv+37|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,950);break}case 716:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,25)|0;qv=383409;rv=pv+25|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,955);break}case 750:{VHa(h,383435,e);f[g>>2]=0;f[g+4>>2]=0;d=h+11|0;jb=b[d>>0]|0;j=jb<<24>>24<0?f[h+4>>2]|0:jb&255;if(!j)z5(-2,g,390086,382930,983);dJc(tT(g,j)|0,((b[d>>0]|0)<0?f[h>>2]|0:h)|0,j|0)|0;z5(-2,g,390086,382930,983);break}case 775:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,9)|0;qv=383459;rv=pv+9|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,996);break}case 790:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,25)|0;qv=383409;rv=pv+25|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,999);break}case 812:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383476;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1020);break}case 862:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,19)|0;qv=383317;rv=pv+19|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1050);break}case 913:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,30)|0;qv=386949;rv=pv+30|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1071);break}case 1016:{dEc(g);break}case 1035:{f[h>>2]=0;f[h+4>>2]=0;pv=tT(h,41)|0;qv=383506;rv=pv+41|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,h,390086,382930,1105);break}case 1086:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,35)|0;qv=383569;rv=pv+35|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1142);break}case 1093:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,33)|0;qv=383605;rv=pv+33|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-213,e,390086,382930,1147);break}case 1097:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,33)|0;qv=383605;rv=pv+33|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-213,e,390086,382930,1152);break}case 1098:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,33)|0;qv=383605;rv=pv+33|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-213,e,390086,382930,1155);break}case 1103:{dEc(g);break}case 1122:{f[i>>2]=0;f[i+4>>2]=0;pv=tT(i,41)|0;qv=383506;rv=pv+41|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,i,390086,382930,1164);break}case 1151:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383649;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1178);break}case 1164:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,44)|0;qv=383673;rv=pv+44|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-212,e,390086,382930,1200);break}case 1171:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,44)|0;qv=383673;rv=pv+44|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-212,e,390086,382930,1217);break}case 1249:{dEc(e);break}case 1258:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,20)|0;qv=383740;rv=pv+20|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,383761,382930,43);break}case 1284:{VHa(h,383435,e);f[g>>2]=0;f[g+4>>2]=0;j=h+11|0;d=b[j>>0]|0;jb=d<<24>>24<0?f[h+4>>2]|0:d&255;if(!jb)z5(-2,g,390086,382930,1281);dJc(tT(g,jb)|0,((b[j>>0]|0)<0?f[h>>2]|0:h)|0,jb|0)|0;z5(-2,g,390086,382930,1281);break}case 1322:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383476;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1326);break}case 1337:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,20)|0;qv=383740;rv=pv+20|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,383761,382930,43);break}case 1348:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383058;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1344);break}case 1381:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,15)|0;qv=383802;rv=pv+15|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1347);break}case 1388:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,14)|0;qv=383818;rv=pv+14|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1347);break}case 1390:{Y1(Hy,4,78148);break}case 1392:{Y1(Iy,4,78176);break}case 1399:{dEc(e);break}case 1464:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,37)|0;qv=383371;rv=pv+37|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1375);break}case 1479:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,27)|0;qv=383833;rv=pv+27|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1382);break}case 1487:{f[g>>2]=0;f[g+4>>2]=0;pv=tT(g,43)|0;qv=383861;rv=pv+43|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,g,390086,382930,1405);break}case 1602:{VHa(h,383435,e);f[g>>2]=0;f[g+4>>2]=0;Iy=h+11|0;Hy=b[Iy>>0]|0;jb=Hy<<24>>24<0?f[h+4>>2]|0:Hy&255;if(!jb)z5(-2,g,390086,382930,1463);dJc(tT(g,jb)|0,((b[Iy>>0]|0)<0?f[h>>2]|0:h)|0,jb|0)|0;z5(-2,g,390086,382930,1463);break}case 1611:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,34)|0;qv=383905;rv=pv+34|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-213,e,390086,382930,1478);break}case 1658:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,68)|0;qv=383952;rv=pv+68|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-213,e,390086,382930,1510);break}case 1670:{dEc(g);break}case 1689:{f[h>>2]=0;f[h+4>>2]=0;pv=tT(h,40)|0;qv=384021;rv=pv+40|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,h,390086,382930,1517);break}case 1784:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,46)|0;qv=384062;rv=pv+46|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-213,e,390086,382930,1548);break}case 1879:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,32)|0;qv=384119;rv=pv+32|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-213,e,390086,382930,1624);break}case 2129:{Y1(jw,4,78204);break}case 2135:{if(lw){QC=Y(f[Yo>>2]|0,f[Xo>>2]|0)|0;$1(QC,2,78232)}Xo=f[cp>>2]|0;cp=0;Yo=1;while(1){lw=Y(f[Xo+(cp<<2)>>2]|0,Yo)|0;cp=cp+1|0;if((cp|0)==(kw|0)){QC=lw;break}else Yo=lw}$1(QC,2,78232);break}case 2176:{Y1(tw,4,78260);break}case 2182:{if(vw){RC=Y(f[zp>>2]|0,f[yp>>2]|0)|0;$1(RC,1,78288)}yp=f[Mp>>2]|0;Mp=0;zp=1;while(1){vw=Y(f[yp+(Mp<<2)>>2]|0,zp)|0;Mp=Mp+1|0;if((Mp|0)==(uw|0)){RC=vw;break}else zp=vw}$1(RC,1,78288);break}case 2188:{Y1(xw,4,78316);break}case 2194:{if(zw){SC=Y(f[Cp>>2]|0,f[Bp>>2]|0)|0;$1(SC,1,78344)}Bp=f[Ip>>2]|0;Ip=0;Cp=1;while(1){zw=Y(f[Bp+(Ip<<2)>>2]|0,Cp)|0;Ip=Ip+1|0;if((Ip|0)==(yw|0)){SC=zw;break}else Cp=zw}$1(SC,1,78344);break}case 2216:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,50)|0;qv=384152;rv=pv+50|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1707);break}case 2233:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383476;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1727);break}case 2248:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,35)|0;qv=384203;rv=pv+35|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1729);break}case 2254:{dEc(e);break}case 2270:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,20)|0;qv=383740;rv=pv+20|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,383761,382930,43);break}case 2311:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,66)|0;qv=384239;rv=pv+66|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1739);break}case 2313:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,66)|0;qv=384306;rv=pv+66|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1741);break}case 2413:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383058;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1797);break}case 2428:{Y1(Hv,4,78372);break}case 2434:{if(Jv){TC=Y(f[Kr>>2]|0,f[Jr>>2]|0)|0;$1(TC,2,78400)}Jr=f[Or>>2]|0;Or=0;Kr=1;while(1){Jv=Y(f[Jr+(Or<<2)>>2]|0,Kr)|0;Or=Or+1|0;if((Or|0)==(Iv|0)){TC=Jv;break}else Kr=Jv}$1(TC,2,78400);break}case 2474:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,26)|0;qv=384394;rv=pv+26|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1814);break}case 2488:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,42)|0;qv=384421;rv=pv+42|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-213,e,390086,382930,1817);break}case 2506:{dEc(g);break}case 2525:{f[h>>2]=0;f[h+4>>2]=0;pv=tT(h,44)|0;qv=384474;rv=pv+44|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,h,390086,382930,1838);break}case 2531:{dEc(i);break}case 2555:{f[e>>2]=0;f[e+4>>2]=0;pv=tT(e,23)|0;qv=383058;rv=pv+23|0;do{b[pv>>0]=b[qv>>0]|0;pv=pv+1|0;qv=qv+1|0}while((pv|0)<(rv|0));z5(-215,e,390086,382930,1850);break}case 2587:{if(iv){UC=Y(f[Ts>>2]|0,f[Ss>>2]|0)|0;$1(UC,1,78428)}Ss=f[gt>>2]|0;gt=0;Ts=1;while(1){iv=Y(f[Ss+(gt<<2)>>2]|0,Ts)|0;gt=gt+1|0;if((gt|0)==(hv|0)){UC=iv;break}else Ts=iv}$1(UC,1,78428);break}case 2593:{Y1(kv,5,78456);break}case 2599:{if(mv){VC=Y(f[Ws>>2]|0,f[Vs>>2]|0)|0;$1(VC,1,78484)}Vs=f[ct>>2]|0;ct=0;Ws=1;while(1){mv=Y(f[Vs+(ct<<2)>>2]|0,Ws)|0;ct=ct+1|0;if((ct|0)==(lv|0)){VC=mv;break}else Ws=mv}$1(VC,1,78484);break}case 2605:{Y1(ov,5,78512);break}case 2634:{dEc(e);break}}}function TIa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=VDc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=11;i=h;j=386224;k=i+11|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+11>>0]=0;h=a+24|0;Wdc(h);l=a+48|0;aJa(e,l);bJa(d,f[e+8>>2]|0,g,0);a=(f[d>>2]|0)==0;cJa(e);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);if(a){m=2;u=c;return m|0}a=VDc(16)|0;f[e>>2]=a;f[e+8>>2]=-2147483632;f[e+4>>2]=11;i=a;j=386224;k=i+11|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[a+11>>0]=0;Wdc(h);h=dJa(l,e)|0;fEc(d,(f[h+20>>2]|0)==2?f[h+8>>2]|0:527320);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);h=d+11|0;l=b[h>>0]|0;a=d+4|0;j=f[a>>2]|0;if(((l<<24>>24<0?j:l&255)|0)==4)if(!(EEc(d,0,-1,386236,4)|0))n=0;else{o=b[h>>0]|0;p=f[a>>2]|0;q=9}else{o=l;p=j;q=9}do if((q|0)==9){if(((o<<24>>24<0?p:o&255)|0)==13){if(!(EEc(d,0,-1,386241,13)|0)){n=0;break}r=b[h>>0]|0;s=f[a>>2]|0}else{r=o;s=p}if(((r<<24>>24<0?s:r&255)|0)==4){if(!(EEc(d,0,-1,386255,4)|0)){n=1;break}t=b[h>>0]|0;v=f[a>>2]|0}else{t=r;v=s}if(((t<<24>>24<0?v:t&255)|0)==14?(EEc(d,0,-1,386260,14)|0)==0:0){n=1;break}VHa(g,386275,d);f[e>>2]=0;f[e+4>>2]=0;j=g+11|0;l=b[j>>0]|0;i=l<<24>>24<0?f[g+4>>2]|0:l&255;if(!i)z5(-212,e,386303,382930,262);l=tT(e,i)|0;dJc(l|0,((b[j>>0]|0)<0?f[g>>2]|0:g)|0,i|0)|0;z5(-212,e,386303,382930,262)}while(0);if((b[h>>0]|0)<0)YDc(f[d>>2]|0);m=n;u=c;return m|0}function UIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0.0,sb=0.0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0;e=u;u=u+240|0;g=e+176|0;h=e+120|0;i=e+112|0;j=e+104|0;k=e+32|0;l=e+16|0;m=e;o=e+96|0;p=e+88|0;q=a+12|0;if((f[q>>2]|0)<=0){u=e;return}r=a+20|0;a=i+4|0;s=j+4|0;t=g+4|0;v=c+4|0;w=k+11|0;x=k+4|0;y=h+8|0;z=g+4|0;A=g+4|0;B=g+4|0;C=g+11|0;D=g+5|0;E=h+11|0;F=h+5|0;G=k+11|0;H=k+5|0;I=g+4|0;J=g+8|0;K=g+12|0;L=h+4|0;M=h+8|0;N=h+12|0;O=g+16|0;P=h+16|0;Q=l+8|0;R=l+4|0;S=k+16|0;T=k+4|0;U=k+8|0;V=k+12|0;W=l+11|0;X=o+4|0;Z=m+4|0;_=m+8|0;$=l+4|0;aa=l+8|0;ba=c+4|0;ca=c+8|0;da=d+4|0;ea=d+4|0;fa=d+8|0;ga=k+36|0;ha=k+40|0;ia=k+44|0;ja=k+48|0;ka=h+36|0;la=h+40|0;ma=h+44|0;na=h+48|0;oa=g+36|0;pa=g+40|0;qa=g+44|0;ra=g+48|0;sa=l+8|0;ta=l+4|0;ua=g+11|0;va=g+4|0;wa=h+11|0;xa=h+5|0;ya=p+4|0;za=h+4|0;Aa=h+8|0;Ba=g+4|0;Ca=g+8|0;Da=0;a:while(1){Ea=f[(f[r>>2]|0)+4+(Da<<2)>>2]|0;Fa=f[Ea+60>>2]|0;f[i>>2]=0;f[a>>2]=0;Ga=Fa+11|0;Ha=b[Ga>>0]|0;Ia=Ha<<24>>24<0?f[Fa+4>>2]|0:Ha&255;if(Ia|0){Ha=tT(i,Ia)|0;dJc(Ha|0,((b[Ga>>0]|0)<0?f[Fa>>2]|0:Fa)|0,Ia|0)|0}Ia=f[Ea+64>>2]|0;f[j>>2]=0;f[s>>2]=0;Fa=Ia+11|0;Ga=b[Fa>>0]|0;Ha=Ga<<24>>24<0?f[Ia+4>>2]|0:Ga&255;if(Ha){Ga=tT(j,Ha)|0;dJc(Ga|0,((b[Fa>>0]|0)<0?f[Ia>>2]|0:Ia)|0,Ha|0)|0;Ha=f[j>>2]|0;if((Ha|0)==385736)Ja=9;else{Ka=Ha;Ja=8}}else{Ka=0;Ja=8}do if((Ja|0)==8){Ja=0;Ha=(Ka|0)==0?1154740:Ka;if(Ioc(Ha,385736)|0){if((Ka|0)!=426101?Ioc(Ha,426101)|0:0)break;Ha=Ea+24|0;Wdc(Ha);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[wa>>0]=5;b[h>>0]=b[498520]|0;b[h+1>>0]=b[498521]|0;b[h+2>>0]=b[498522]|0;b[h+3>>0]=b[498523]|0;b[h+4>>0]=b[498524]|0;b[xa>>0]=0;bJa(g,f[Ea+56>>2]|0,h,0);Ia=f[g>>2]|0;Wdc(Ha);if((b[wa>>0]|0)<0)YDc(f[h>>2]|0);if(Ia|0){Ia=f[i>>2]|0;f[p>>2]=Ia;Ha=f[a>>2]|0;f[ya>>2]=Ha;if(Ia){Fa=Ia+-4|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Fa=f[p>>2]|0;Ia=f[ya>>2]|0;f[h>>2]=Fa;f[za>>2]=Ia;if(Fa){Ga=Fa+-4|0;f[Ga>>2]=(f[Ga>>2]|0)+1;Ga=f[h>>2]|0;Fa=f[za>>2]|0;f[Aa>>2]=Da;f[g>>2]=Ga;f[Ba>>2]=Fa;if(!Ga)La=Da;else{Fa=Ga+-4|0;f[Fa>>2]=(f[Fa>>2]|0)+1;La=f[Aa>>2]|0}}else{Ma=Ia;Ja=159}}else{f[h>>2]=0;f[za>>2]=Ha;Ma=Ha;Ja=159}if((Ja|0)==159){Ja=0;f[Aa>>2]=Da;f[g>>2]=0;f[Ba>>2]=Ma;La=Da}f[Ca>>2]=La;Ha=f[v>>2]|0;b:do if(!Ha){Na=v;Oa=v}else{Ia=f[g>>2]|0;Fa=(Ia|0)==0?1154740:Ia;Ga=f[Ha+16>>2]|0;c:do if((Ia|0)!=(Ga|0)){Pa=ba;Qa=Ha;Ra=Ga;while(1){Sa=(Ra|0)==0?1154740:Ra;if((Ioc(Fa,Sa)|0)<0){Ta=f[Qa>>2]|0;if(!Ta){Ja=167;break}else{Ua=Qa;Va=Ta}}else{if((Ioc(Sa,Fa)|0)>=0){Wa=Pa;Xa=Qa;break c}Ya=Qa+4|0;Sa=f[Ya>>2]|0;if(!Sa){Ja=170;break}else{Ua=Ya;Va=Sa}}Ra=f[Va+16>>2]|0;if((Ia|0)==(Ra|0)){Wa=Ua;Xa=Va;break c}else{Pa=Ua;Qa=Va}}if((Ja|0)==167){Ja=0;Na=Qa;Oa=Qa;break b}else if((Ja|0)==170){Ja=0;Na=Ya;Oa=Qa;break b}}else{Wa=ba;Xa=Ha}while(0);Na=Wa;Oa=Xa}while(0);if(f[Na>>2]|0){Ja=178;break a}Ha=VDc(28)|0;Ia=f[g>>2]|0;f[Ha+16>>2]=Ia;f[Ha+20>>2]=f[Ba>>2];if(!Ia)Za=La;else{Fa=Ia+-4|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Za=f[Ca>>2]|0}f[Ha+24>>2]=Za;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=Oa;f[Na>>2]=Ha;Fa=f[f[c>>2]>>2]|0;if(!Fa)_a=Ha;else{f[c>>2]=Fa;_a=f[Na>>2]|0}laa(f[ba>>2]|0,_a);f[ca>>2]=(f[ca>>2]|0)+1;uT(g);uT(h);uT(p)}Fa=f[da>>2]|0;d:do if(!Fa){$a=da;ab=da}else{Ha=f[i>>2]|0;Ia=(Ha|0)==0?1154740:Ha;Ga=f[Fa+16>>2]|0;e:do if((Ha|0)!=(Ga|0)){Pa=ea;Ra=Fa;Sa=Ga;while(1){Ta=(Sa|0)==0?1154740:Sa;if((Ioc(Ia,Ta)|0)<0){bb=f[Ra>>2]|0;if(!bb){Ja=184;break}else{cb=Ra;db=bb}}else{if((Ioc(Ta,Ia)|0)>=0){eb=Pa;fb=Ra;break e}gb=Ra+4|0;Ta=f[gb>>2]|0;if(!Ta){Ja=187;break}else{cb=gb;db=Ta}}Sa=f[db+16>>2]|0;if((Ha|0)==(Sa|0)){eb=cb;fb=db;break e}else{Pa=cb;Ra=db}}if((Ja|0)==184){Ja=0;$a=Ra;ab=Ra;break d}else if((Ja|0)==187){Ja=0;$a=gb;ab=Ra;break d}}else{eb=ea;fb=Fa}while(0);$a=eb;ab=fb}while(0);if(!(f[$a>>2]|0)){Fa=VDc(24)|0;Ha=f[i>>2]|0;f[Fa+16>>2]=Ha;f[Fa+20>>2]=f[a>>2];if(Ha|0){Ia=Ha+-4|0;f[Ia>>2]=(f[Ia>>2]|0)+1}f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=ab;f[$a>>2]=Fa;Ia=f[f[d>>2]>>2]|0;if(!Ia)hb=Fa;else{f[d>>2]=Ia;hb=f[$a>>2]|0}laa(f[ea>>2]|0,hb);f[fa>>2]=(f[fa>>2]|0)+1}}else Ja=9}while(0);if((Ja|0)==9){Ja=0;if((f[Ea+12>>2]|0)!=3){Ja=11;break}Ia=Ea+20|0;Fa=0;do{Ha=f[(f[Ia>>2]|0)+4+(Fa<<2)>>2]|0;f[g>>2]=0;f[t>>2]=0;Ga=Ha+11|0;Pa=b[Ga>>0]|0;Sa=Pa<<24>>24<0?f[Ha+4>>2]|0:Pa&255;if(Sa|0){Pa=tT(g,Sa)|0;dJc(Pa|0,((b[Ga>>0]|0)<0?f[Ha>>2]|0:Ha)|0,Sa|0)|0}Sa=f[v>>2]|0;if(Sa){Ha=f[g>>2]|0;Ga=(Ha|0)==0?1154740:Ha;Pa=v;Qa=Sa;f:while(1){Sa=Qa;while(1){Ta=f[Sa+16>>2]|0;if((Ta|0)==(Ha|0))break;if((Ioc((Ta|0)==0?1154740:Ta,Ga)|0)>=0)break;Ta=f[Sa+4>>2]|0;if(!Ta){ib=Pa;break f}else Sa=Ta}Qa=f[Sa>>2]|0;if(!Qa){ib=Sa;break}else Pa=Sa}if((ib|0)!=(v|0)){Pa=f[ib+16>>2]|0;if((Ha|0)!=(Pa|0)?(Ioc(Ga,(Pa|0)==0?1154740:Pa)|0)<0:0)Ja=26;else jb=ib}else Ja=26}else Ja=26;if((Ja|0)==26){Ja=0;jb=v}uT(g);Fa=Fa+1|0;if((jb|0)==(v|0)){Ja=28;break a}}while((Fa|0)<3);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[w>>0]=4;f[k>>2]=1701080941;b[x>>0]=0;Fa=Ea+24|0;Wdc(Fa);Pa=Ea+48|0;aJa(h,Pa);bJa(g,f[y>>2]|0,k,0);Qa=f[g>>2]|0;cJa(h);if(!Qa)kb=0;else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[ua>>0]=4;f[g>>2]=1701080941;b[va>>0]=0;Wdc(Fa);Fa=dJa(Pa,g)|0;Pa=(f[Fa+20>>2]|0)==2?f[Fa+8>>2]|0:527320;Fa=b[Pa+11>>0]|0;if(((Fa<<24>>24<0?f[Pa+4>>2]|0:Fa&255)|0)==9)lb=(EEc(Pa,0,-1,385817,9)|0)==0;else lb=0;if((b[ua>>0]|0)<0)YDc(f[g>>2]|0);kb=lb}if((b[w>>0]|0)<0)YDc(f[k>>2]|0);if(!kb){Ja=37;break}Pa=f[(f[Ia>>2]|0)+4>>2]|0;f[g>>2]=0;f[z>>2]=0;Fa=Pa+11|0;Qa=b[Fa>>0]|0;Ta=Qa<<24>>24<0?f[Pa+4>>2]|0:Qa&255;if(Ta|0){Qa=tT(g,Ta)|0;dJc(Qa|0,((b[Fa>>0]|0)<0?f[Pa>>2]|0:Pa)|0,Ta|0)|0}Ta=HHa(c,g)|0;Pa=f[Ta>>2]|0;uT(g);Ta=f[(f[Ia>>2]|0)+8>>2]|0;f[g>>2]=0;f[A>>2]=0;Fa=Ta+11|0;Qa=b[Fa>>0]|0;bb=Qa<<24>>24<0?f[Ta+4>>2]|0:Qa&255;if(bb|0){Qa=tT(g,bb)|0;dJc(Qa|0,((b[Fa>>0]|0)<0?f[Ta>>2]|0:Ta)|0,bb|0)|0}bb=HHa(c,g)|0;Ta=f[bb>>2]|0;uT(g);bb=f[(f[Ia>>2]|0)+12>>2]|0;f[g>>2]=0;f[B>>2]=0;Fa=bb+11|0;Qa=b[Fa>>0]|0;mb=Qa<<24>>24<0?f[bb+4>>2]|0:Qa&255;if(mb|0){Qa=tT(g,mb)|0;dJc(Qa|0,((b[Fa>>0]|0)<0?f[bb>>2]|0:bb)|0,mb|0)|0}mb=HHa(c,g)|0;bb=f[mb>>2]|0;uT(g);mb=f[(f[r>>2]|0)+4+(Pa<<2)>>2]|0;Fa=mb+24|0;Wdc(Fa);Vdc(Fa);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[C>>0]=5;b[g>>0]=b[498520]|0;b[g+1>>0]=b[498521]|0;b[g+2>>0]=b[498522]|0;b[g+3>>0]=b[498523]|0;b[g+4>>0]=b[498524]|0;b[D>>0]=0;Fa=UJa(TJa(mb+48|0,g)|0)|0;if((b[C>>0]|0)<0)YDc(f[g>>2]|0);mb=Fa+160|0;if((f[mb>>2]|0)!=12){Ja=47;break}Qa=f[(f[r>>2]|0)+4+(Ta<<2)>>2]|0;Wdc(Qa+24|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[E>>0]=5;b[h>>0]=b[498520]|0;b[h+1>>0]=b[498521]|0;b[h+2>>0]=b[498522]|0;b[h+3>>0]=b[498523]|0;b[h+4>>0]=b[498524]|0;b[F>>0]=0;Ta=dJa(Qa+48|0,h)|0;Vnb(g,(f[Ta+20>>2]|0)==8?f[Ta+8>>2]|0:520944);if((b[E>>0]|0)<0)YDc(f[h>>2]|0);Ta=f[(f[r>>2]|0)+4+(bb<<2)>>2]|0;Wdc(Ta+24|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[G>>0]=5;b[k>>0]=b[498520]|0;b[k+1>>0]=b[498521]|0;b[k+2>>0]=b[498522]|0;b[k+3>>0]=b[498523]|0;b[k+4>>0]=b[498524]|0;b[H>>0]=0;bb=dJa(Ta+48|0,k)|0;Vnb(h,(f[bb+20>>2]|0)==8?f[bb+8>>2]|0:520944);if((b[G>>0]|0)<0)YDc(f[k>>2]|0);bb=f[I>>2]|0;if((bb|0)<3)nb=Y(f[K>>2]|0,f[J>>2]|0)|0;else{Ta=f[pa>>2]|0;Qa=0;ob=1;while(1){pb=Y(f[Ta+(Qa<<2)>>2]|0,ob)|0;Qa=Qa+1|0;if((Qa|0)==(bb|0)){nb=pb;break}else ob=pb}}if((nb|0)!=1){Ja=57;break}if((f[g>>2]&4095|0)!=5){Ja=59;break}ob=f[L>>2]|0;if((ob|0)<3)qb=Y(f[N>>2]|0,f[M>>2]|0)|0;else{bb=f[la>>2]|0;Qa=0;Ta=1;while(1){Ia=Y(f[bb+(Qa<<2)>>2]|0,Ta)|0;Qa=Qa+1|0;if((Qa|0)==(ob|0)){qb=Ia;break}else Ta=Ia}}if((qb|0)!=1){Ja=65;break}if((f[h>>2]&4095|0)!=5){Ja=67;break}Vnb(k,Fa);rb=+n[f[O>>2]>>2];sb=(+n[f[P>>2]>>2]-rb)/255.0;if(!(sb>=0.0)){Ja=69;break}Ta=Q;f[Ta>>2]=0;f[Ta+4>>2]=0;f[l>>2]=33619968;f[R>>2]=k;LZ(k,l,5,sb,sb*+(mrc(rb/sb)|0));f[mb>>2]=1;Ta=f[S>>2]|0;ob=f[T>>2]|0;if((ob|0)<3)tb=Y(f[V>>2]|0,f[U>>2]|0)|0;else{Qa=f[ha>>2]|0;bb=0;Ia=1;while(1){Ea=Y(f[Qa+(bb<<2)>>2]|0,Ia)|0;bb=bb+1|0;if((bb|0)==(ob|0)){tb=Ea;break}else Ia=Ea}}VJa(Fa,Ta,Y(1212424721>>>(f[k>>2]<<2&28)&15,tb)|0);Ia=f[(f[r>>2]|0)+4+(Pa<<2)>>2]|0;ob=f[i>>2]|0;bb=f[a>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if(bb>>>0>4294967279){Ja=75;break}if(bb>>>0<11){b[W>>0]=bb;if(!bb)ub=l;else{vb=l;Ja=79}}else{Qa=bb+16&-16;mb=VDc(Qa)|0;f[l>>2]=mb;f[sa>>2]=Qa|-2147483648;f[ta>>2]=bb;vb=mb;Ja=79}if((Ja|0)==79){Ja=0;dJc(vb|0,ob|0,bb|0)|0;ub=vb}b[ub+bb>>0]=0;bb=Ia+60|0;ob=f[Ia+4>>2]|0;Ia=ob&-2;if(!(ob&1))wb=Ia;else wb=f[Ia+4>>2]|0;Ia=f[bb>>2]|0;if((Ia|0)==527320)WJa(bb,wb,l);else iEc(Ia,l)|0;if((b[W>>0]|0)<0)YDc(f[l>>2]|0);Ia=f[i>>2]|0;f[o>>2]=Ia;bb=f[a>>2]|0;f[X>>2]=bb;do if(!Ia){f[m>>2]=0;f[Z>>2]=bb;xb=bb;Ja=91}else{ob=Ia+-4|0;f[ob>>2]=(f[ob>>2]|0)+1;ob=f[o>>2]|0;mb=f[X>>2]|0;f[m>>2]=ob;f[Z>>2]=mb;if(!ob){xb=mb;Ja=91;break}mb=ob+-4|0;f[mb>>2]=(f[mb>>2]|0)+1;mb=f[m>>2]|0;ob=f[Z>>2]|0;f[_>>2]=Pa;f[l>>2]=mb;f[$>>2]=ob;if(!mb){yb=Pa;break}ob=mb+-4|0;f[ob>>2]=(f[ob>>2]|0)+1;yb=f[_>>2]|0}while(0);if((Ja|0)==91){Ja=0;f[_>>2]=Pa;f[l>>2]=0;f[$>>2]=xb;yb=Pa}f[aa>>2]=yb;Ia=f[v>>2]|0;g:do if(!Ia){zb=v;Ab=v}else{bb=f[l>>2]|0;Ta=(bb|0)==0?1154740:bb;Fa=f[Ia+16>>2]|0;h:do if((bb|0)!=(Fa|0)){ob=ba;mb=Ia;Qa=Fa;while(1){Ea=(Qa|0)==0?1154740:Qa;if((Ioc(Ta,Ea)|0)<0){pb=f[mb>>2]|0;if(!pb){Ja=99;break}else{Bb=mb;Cb=pb}}else{if((Ioc(Ea,Ta)|0)>=0){Db=ob;Eb=mb;break h}Fb=mb+4|0;Ea=f[Fb>>2]|0;if(!Ea){Ja=102;break}else{Bb=Fb;Cb=Ea}}Qa=f[Cb+16>>2]|0;if((bb|0)==(Qa|0)){Db=Bb;Eb=Cb;break h}else{ob=Bb;mb=Cb}}if((Ja|0)==99){Ja=0;zb=mb;Ab=mb;break g}else if((Ja|0)==102){Ja=0;zb=Fb;Ab=mb;break g}}else{Db=ba;Eb=Ia}while(0);zb=Db;Ab=Eb}while(0);if(f[zb>>2]|0){Ja=110;break}Ia=VDc(28)|0;Pa=f[l>>2]|0;f[Ia+16>>2]=Pa;f[Ia+20>>2]=f[$>>2];if(!Pa)Gb=yb;else{bb=Pa+-4|0;f[bb>>2]=(f[bb>>2]|0)+1;Gb=f[aa>>2]|0}f[Ia+24>>2]=Gb;f[Ia>>2]=0;f[Ia+4>>2]=0;f[Ia+8>>2]=Ab;f[zb>>2]=Ia;bb=f[f[c>>2]>>2]|0;if(!bb)Hb=Ia;else{f[c>>2]=bb;Hb=f[zb>>2]|0}laa(f[ba>>2]|0,Hb);f[ca>>2]=(f[ca>>2]|0)+1;uT(l);uT(m);uT(o);bb=f[da>>2]|0;i:do if(!bb){Ib=da;Jb=da}else{Ia=f[i>>2]|0;Pa=(Ia|0)==0?1154740:Ia;Ta=f[bb+16>>2]|0;j:do if((Ia|0)!=(Ta|0)){Fa=ea;Ga=bb;Ha=Ta;while(1){ob=(Ha|0)==0?1154740:Ha;if((Ioc(Pa,ob)|0)<0){Qa=f[Ga>>2]|0;if(!Qa){Ja=115;break}else{Kb=Ga;Lb=Qa}}else{if((Ioc(ob,Pa)|0)>=0){Mb=Fa;Nb=Ga;break j}Ob=Ga+4|0;ob=f[Ob>>2]|0;if(!ob){Ja=118;break}else{Kb=Ob;Lb=ob}}Ha=f[Lb+16>>2]|0;if((Ia|0)==(Ha|0)){Mb=Kb;Nb=Lb;break j}else{Fa=Kb;Ga=Lb}}if((Ja|0)==115){Ja=0;Ib=Ga;Jb=Ga;break i}else if((Ja|0)==118){Ja=0;Ib=Ob;Jb=Ga;break i}}else{Mb=ea;Nb=bb}while(0);Ib=Mb;Jb=Nb}while(0);if(!(f[Ib>>2]|0)){bb=VDc(24)|0;Ia=f[i>>2]|0;f[bb+16>>2]=Ia;f[bb+20>>2]=f[a>>2];if(Ia|0){Pa=Ia+-4|0;f[Pa>>2]=(f[Pa>>2]|0)+1}f[bb>>2]=0;f[bb+4>>2]=0;f[bb+8>>2]=Jb;f[Ib>>2]=bb;Pa=f[f[d>>2]>>2]|0;if(!Pa)Pb=bb;else{f[d>>2]=Pa;Pb=f[Ib>>2]|0}laa(f[ea>>2]|0,Pb);f[fa>>2]=(f[fa>>2]|0)+1}Pa=f[ga>>2]|0;do if(Pa|0){bb=Pa+12|0;Ia=f[bb>>2]|0;f[bb>>2]=Ia+-1;if((Ia|0)!=1)break;_S(k)}while(0);f[ga>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[T>>2]|0)>0){Pa=f[ha>>2]|0;Ia=0;do{f[Pa+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[T>>2]|0))}Ia=f[ia>>2]|0;if((Ia|0)!=(ja|0))g0(Ia);Ia=f[ka>>2]|0;do if(Ia|0){Pa=Ia+12|0;bb=f[Pa>>2]|0;f[Pa>>2]=bb+-1;if((bb|0)!=1)break;_S(h)}while(0);f[ka>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[L>>2]|0)>0){Ia=f[la>>2]|0;bb=0;do{f[Ia+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[L>>2]|0))}bb=f[ma>>2]|0;if((bb|0)!=(na|0))g0(bb);bb=f[oa>>2]|0;do if(bb|0){Ia=bb+12|0;Pa=f[Ia>>2]|0;f[Ia>>2]=Pa+-1;if((Pa|0)!=1)break;_S(g)}while(0);f[oa>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[I>>2]|0)>0){bb=f[pa>>2]|0;Pa=0;do{f[bb+(Pa<<2)>>2]=0;Pa=Pa+1|0}while((Pa|0)<(f[I>>2]|0))}Pa=f[qa>>2]|0;if((Pa|0)!=(ra|0))g0(Pa)}uT(j);uT(i);Da=Da+1|0;if((Da|0)>=(f[q>>2]|0)){Ja=3;break}}switch(Ja|0){case 3:{u=e;return}case 11:{f[g>>2]=0;f[g+4>>2]=0;Qb=tT(g,23)|0;Rb=383058;Sb=Qb+23|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,g,385747,382930,575);break}case 28:{f[g>>2]=0;f[g+4>>2]=0;Qb=tT(g,55)|0;Rb=385761;Sb=Qb+55|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,g,385747,382930,577);break}case 37:{f[g>>2]=0;f[g+4>>2]=0;Qb=tT(g,77)|0;Rb=385827;Sb=Qb+77|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,g,385747,382930,579);break}case 47:{f[g>>2]=0;f[g+4>>2]=0;Qb=tT(g,40)|0;Rb=385905;Sb=Qb+40|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,g,385747,382930,588);break}case 57:{f[k>>2]=0;f[k+4>>2]=0;Qb=tT(k,17)|0;Rb=385946;Sb=Qb+17|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,k,385747,382930,593);break}case 59:{f[k>>2]=0;f[k+4>>2]=0;Qb=tT(k,56)|0;Rb=385964;Sb=Qb+56|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,k,385747,382930,593);break}case 65:{f[k>>2]=0;f[k+4>>2]=0;Qb=tT(k,17)|0;Rb=386021;Sb=Qb+17|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,k,385747,382930,593);break}case 67:{f[k>>2]=0;f[k+4>>2]=0;Qb=tT(k,56)|0;Rb=386039;Sb=Qb+56|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,k,385747,382930,593);break}case 69:{f[l>>2]=0;f[l+4>>2]=0;Qb=tT(l,15)|0;Rb=386096;Sb=Qb+15|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,l,385747,382930,599);break}case 75:{dEc(l);break}case 110:{uT(l);uT(m);uT(o);f[l>>2]=0;f[l+4>>2]=0;Qb=tT(l,58)|0;Rb=386112;Sb=Qb+58|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,l,385747,382930,607);break}case 178:{uT(g);uT(h);uT(p);f[g>>2]=0;f[g+4>>2]=0;Qb=tT(g,52)|0;Rb=386171;Sb=Qb+52|0;do{b[Qb>>0]=b[Rb>>0]|0;Qb=Qb+1|0;Rb=Rb+1|0}while((Qb|0)<(Sb|0));z5(-215,g,385747,382930,616);break}}}function VIa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g;k=g+16|0;f[a>>2]=0;l=a+4|0;f[l>>2]=0;f[a+8>>2]=0;m=c+12|0;n=f[m>>2]|0;if((n|0)<=0){u=g;return}o=c+20|0;c=h+4|0;p=i+11|0;q=i+4|0;r=e+4|0;s=j+12|0;t=i+4|0;v=j+11|0;w=j+4|0;x=i+8|0;y=a+8|0;z=k+11|0;A=i+4|0;B=0;C=n;while(1){n=f[(f[o>>2]|0)+4+(B<<2)>>2]|0;D=n+12|0;if((f[D>>2]|0)>0){E=n+20|0;F=n+60|0;G=n+64|0;n=0;do{_Ia(i,f[(f[E>>2]|0)+4+(n<<2)>>2]|0);f[h>>2]=0;f[c>>2]=0;H=b[p>>0]|0;I=H<<24>>24<0?f[q>>2]|0:H&255;if(!I)J=H;else{H=tT(h,I)|0;dJc(H|0,((b[p>>0]|0)<0?f[i>>2]|0:i)|0,I|0)|0;J=b[p>>0]|0}if(J<<24>>24<0)YDc(f[i>>2]|0);if(!(f[r>>2]|0))K=1;else{I=f[G>>2]|0;f[i>>2]=0;f[A>>2]=0;H=I+11|0;L=b[H>>0]|0;M=L<<24>>24<0?f[I+4>>2]|0:L&255;if(!M)N=0;else{L=tT(i,M)|0;dJc(L|0,((b[H>>0]|0)<0?f[I>>2]|0:I)|0,M|0)|0;N=f[i>>2]|0}M=f[e>>2]|0;if((M|0)==(N|0))O=1;else O=(Ioc((M|0)==0?1154740:M,(N|0)==0?1154740:N)|0)==0;uT(i);K=O}M=f[h>>2]|0;I=f[d>>2]|0;if((M|0)==(I|0))P=1;else P=(Ioc((M|0)==0?1154740:M,(I|0)==0?1154740:I)|0)==0;if(K&P){fEc(k,f[F>>2]|0);fEc(j,k);f[s>>2]=B;f[i>>2]=0;f[t>>2]=0;I=b[v>>0]|0;M=I<<24>>24<0?f[w>>2]|0:I&255;if(!M)Q=B;else{I=tT(i,M)|0;dJc(I|0,((b[v>>0]|0)<0?f[j>>2]|0:j)|0,M|0)|0;Q=f[s>>2]|0}f[x>>2]=Q;M=f[l>>2]|0;if((M|0)==(f[y>>2]|0))SJa(a,i);else{I=f[i>>2]|0;f[M>>2]=I;f[M+4>>2]=f[t>>2];if(!I){R=Q;S=M}else{H=I+-4|0;f[H>>2]=(f[H>>2]|0)+1;R=f[x>>2]|0;S=f[l>>2]|0}f[M+8>>2]=R;f[l>>2]=S+12}uT(i);if((b[v>>0]|0)<0)YDc(f[j>>2]|0);if((b[z>>0]|0)<0)YDc(f[k>>2]|0)}uT(h);n=n+1|0}while((n|0)<(f[D>>2]|0));T=f[m>>2]|0}else T=C;B=B+1|0;if((B|0)>=(T|0))break;else C=T}u=g;return}function WIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=(c-b|0)/12|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>((g-h|0)/12|0)>>>0){if(!h)j=g;else{g=a+4|0;while(1){k=f[g>>2]|0;if((k|0)==(i|0))break;l=k+-12|0;f[g>>2]=l;uT(l)}YDc(f[a>>2]|0);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>357913941)mCc(a);g=(j|0)/12|0;j=g<<1;l=g>>>0<178956970?(j>>>0<d>>>0?d:j):357913941;if(l>>>0>357913941)mCc(a);j=VDc(l*12|0)|0;g=a+4|0;f[g>>2]=j;f[a>>2]=j;f[e>>2]=j+(l*12|0);if((b|0)==(c|0))return;l=b;e=j;do{j=f[l>>2]|0;f[e>>2]=j;f[e+4>>2]=f[l+4>>2];if(j|0){k=j+-4|0;f[k>>2]=(f[k>>2]|0)+1}f[e+8>>2]=f[l+8>>2];l=l+12|0;e=(f[g>>2]|0)+12|0;f[g>>2]=e}while((l|0)!=(c|0));return}l=a+4|0;a=((f[l>>2]|0)-h|0)/12|0;h=d>>>0>a>>>0;d=b+(a*12|0)|0;a=h?d:c;if((a|0)==(b|0))m=i;else{e=b;b=i;while(1){if((e|0)!=(b|0)){uT(b);i=f[e>>2]|0;if(!i)n=0;else{g=i+-4|0;f[g>>2]=(f[g>>2]|0)+1;n=f[e>>2]|0}f[b>>2]=n;f[b+4>>2]=f[e+4>>2]}f[b+8>>2]=f[e+8>>2];e=e+12|0;g=b+12|0;if((e|0)==(a|0)){m=g;break}else b=g}}if(!h){while(1){h=f[l>>2]|0;if((h|0)==(m|0))break;b=h+-12|0;f[l>>2]=b;uT(b)}return}if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{m=f[a>>2]|0;f[d>>2]=m;f[d+4>>2]=f[a+4>>2];if(m|0){b=m+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[d+8>>2]=f[a+8>>2];a=a+12|0;d=(f[l>>2]|0)+12|0;f[l>>2]=d}while((a|0)!=(c|0));return}function XIa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=a+4|0;h=f[b>>2]|0;b=h;do if((h|0)!=(g|0)){i=f[e>>2]|0;j=f[h+16>>2]|0;if((i|0)!=(j|0)){if((Ioc((i|0)==0?1154740:i,(j|0)==0?1154740:j)|0)<0)break;k=(i|0)==0?1154740:i;if((Ioc((j|0)==0?1154740:j,k)|0)<0){j=h+4|0;l=f[j>>2]|0;if(!l){m=h+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(h|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=l;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}do if((o|0)!=(g|0)){l=f[o+16>>2]|0;if((i|0)!=(l|0)?(Ioc(k,(l|0)==0?1154740:l)|0)<0:0)break;l=f[g>>2]|0;if(!l){f[c>>2]=g;q=g;return q|0}p=a+4|0;m=f[l+16>>2]|0;a:do if((i|0)!=(m|0)){r=p;s=l;t=m;while(1){u=(t|0)==0?1154740:t;if((Ioc(k,u)|0)<0){v=f[s>>2]|0;if(!v){w=41;break}else{x=s;y=v}}else{if((Ioc(u,k)|0)>=0){z=r;A=s;break a}B=s+4|0;u=f[B>>2]|0;if(!u){w=44;break}else{x=B;y=u}}t=f[y+16>>2]|0;if((i|0)==(t|0)){z=x;A=y;break a}else{r=x;s=y}}if((w|0)==41){f[c>>2]=s;q=s;return q|0}else if((w|0)==44){f[c>>2]=s;q=B;return q|0}}else{z=p;A=l}while(0);f[c>>2]=A;q=z;return q|0}while(0);if(!(f[h+4>>2]|0)){f[c>>2]=b;q=j;return q|0}else{f[c>>2]=o;q=o;return q|0}}}f[c>>2]=b;f[d>>2]=b;q=d;return q|0}while(0);d=f[h>>2]|0;do if((h|0)==(f[a>>2]|0))C=b;else{if(!d){o=h;while(1){z=f[o+8>>2]|0;if((f[z>>2]|0)==(o|0))o=z;else{D=z;break}}}else{o=d;while(1){j=f[o+4>>2]|0;if(!j){D=o;break}else o=j}}o=f[D+16>>2]|0;j=f[e>>2]|0;if((o|0)!=(j|0)?(Ioc((o|0)==0?1154740:o,(j|0)==0?1154740:j)|0)<0:0){C=D;break}o=f[g>>2]|0;if(!o){f[c>>2]=g;q=g;return q|0}z=a+4|0;A=(j|0)==0?1154740:j;B=f[o+16>>2]|0;b:do if((j|0)!=(B|0)){y=z;x=o;i=B;while(1){k=(i|0)==0?1154740:i;if((Ioc(A,k)|0)<0){n=f[x>>2]|0;if(!n){w=18;break}else{E=x;F=n}}else{if((Ioc(k,A)|0)>=0){G=y;H=x;break b}I=x+4|0;k=f[I>>2]|0;if(!k){w=21;break}else{E=I;F=k}}i=f[F+16>>2]|0;if((j|0)==(i|0)){G=E;H=F;break b}else{y=E;x=F}}if((w|0)==18){f[c>>2]=x;q=x;return q|0}else if((w|0)==21){f[c>>2]=x;q=I;return q|0}}else{G=z;H=o}while(0);f[c>>2]=H;q=G;return q|0}while(0);if(!d){f[c>>2]=h;q=h;return q|0}else{h=C;f[c>>2]=h;q=h+4|0;return q|0}return 0}function YIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;h=u;u=u+80|0;i=h+64|0;j=h+48|0;k=h+36|0;l=h+24|0;m=h+12|0;n=h;if((e|0)==-1){o=c+12|0;if((f[o>>2]|0)<=0){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,38)|0;r=q;s=385539;t=r+38|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-2,i,385526,382930,530)}v=c+20|0;w=j+4|0;x=i+11|0;y=i+4|0;z=d+4|0;A=0;B=-1;while(1){_Ia(i,f[(f[v>>2]|0)+4+(A<<2)>>2]|0);f[j>>2]=0;f[w>>2]=0;C=b[x>>0]|0;D=C<<24>>24<0?f[y>>2]|0:C&255;if(D|0){C=tT(j,D)|0;dJc(C|0,((b[x>>0]|0)<0?f[i>>2]|0:i)|0,D|0)|0}D=f[z>>2]|0;if(D){C=f[j>>2]|0;E=(C|0)==0?1154740:C;F=z;G=D;a:while(1){D=G;while(1){H=f[D+16>>2]|0;if((H|0)==(C|0))break;if((Ioc((H|0)==0?1154740:H,E)|0)>=0)break;H=f[D+4>>2]|0;if(!H){I=F;break a}else D=H}G=f[D>>2]|0;if(!G){I=D;break}else F=D}if((I|0)!=(z|0)){F=f[I+16>>2]|0;if((C|0)!=(F|0)?(Ioc(E,(F|0)==0?1154740:F)|0)<0:0)J=16;else K=I}else J=16}else J=16;if((J|0)==16){J=0;K=z}uT(j);if((K|0)!=(z|0))if((B|0)==-1)L=A;else{J=19;break}else L=B;if((b[x>>0]|0)<0)YDc(f[i>>2]|0);A=A+1|0;if((A|0)>=(f[o>>2]|0))break;else B=L}if((J|0)==19){f[j>>2]=0;f[j+4>>2]=0;r=tT(j,31)|0;s=385494;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-2,j,385526,382930,522)}if((L|0)==-1){f[i>>2]=0;p=i+4|0;f[p>>2]=0;q=tT(i,38)|0;r=q;s=385539;t=r+38|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-2,i,385526,382930,530)}else M=L}else M=e;e=c+20|0;_Ia(i,f[(f[e>>2]|0)+4+(M<<2)>>2]|0);f[j>>2]=0;f[j+4>>2]=0;L=i+11|0;q=b[L>>0]|0;p=i+4|0;B=q<<24>>24<0?f[p>>2]|0:q&255;if(B|0){q=tT(j,B)|0;dJc(q|0,((b[L>>0]|0)<0?f[i>>2]|0:i)|0,B|0)|0}B=d+4|0;q=f[B>>2]|0;if(q){o=f[j>>2]|0;A=(o|0)==0?1154740:o;x=B;z=q;b:while(1){q=z;while(1){K=f[q+16>>2]|0;if((K|0)==(o|0))break;if((Ioc((K|0)==0?1154740:K,A)|0)>=0)break;K=f[q+4>>2]|0;if(!K){N=x;break b}else q=K}z=f[q>>2]|0;if(!z){N=q;break}else x=q}if((N|0)!=(B|0)){x=f[N+16>>2]|0;if((o|0)!=(x|0)?(Ioc(A,(x|0)==0?1154740:x)|0)<0:0)J=37;else O=N}else J=37}else J=37;if((J|0)==37)O=B;uT(j);if((O|0)==(B|0)){VHa(n,385578,f[(f[e>>2]|0)+4+(M<<2)>>2]|0);jIa(m,n,385586);QJa(l,m,f[c+60>>2]|0);jIa(k,l,385599);f[j>>2]=0;f[j+4>>2]=0;l=k+11|0;c=b[l>>0]|0;m=c<<24>>24<0?f[k+4>>2]|0:c&255;if(!m)z5(-2,j,385526,382930,535);c=tT(j,m)|0;dJc(c|0,((b[l>>0]|0)<0?f[k>>2]|0:k)|0,m|0)|0;z5(-2,j,385526,382930,535)}if(f[i+12>>2]|0){f[j>>2]=0;f[j+4>>2]=0;r=tT(j,24)|0;s=385611;t=r+24|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-2,j,385526,382930,537)}if(g|0)f[g>>2]=M;f[j>>2]=0;f[j+4>>2]=0;M=b[L>>0]|0;g=M<<24>>24<0?f[p>>2]|0:M&255;if(g|0){M=tT(j,g)|0;dJc(M|0,((b[L>>0]|0)<0?f[i>>2]|0:i)|0,g|0)|0}g=RJa(d,j)|0;d=f[g>>2]|0;uT(j);c:do if((d|0)<(f[a+12>>2]|0)?(g=f[(f[a+20>>2]|0)+4+(d<<2)>>2]|0,M=f[g+60>>2]|0,m=b[M+11>>0]|0,k=m<<24>>24<0,l=m&255,m=k?f[M+4>>2]|0:l,c=b[L>>0]|0,n=c<<24>>24<0,(m|0)==((n?f[p>>2]|0:c&255)|0)):0){c=f[M>>2]|0;e=k?c:M;B=n?f[i>>2]|0:i;n=(m|0)==0;d:do if(k){if(!n?Arc(e,B,m)|0:0){J=60;break c}}else if(!n){if((c&255)<<24>>24==(b[B>>0]|0)){P=M;Q=l;R=B}else{J=60;break c}while(1){Q=Q+-1|0;P=P+1|0;if(!Q)break d;R=R+1|0;if((b[P>>0]|0)!=(b[R>>0]|0)){J=60;break c}}}while(0);Wdc(g+24|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;B=j+11|0;b[B>>0]=5;b[j>>0]=b[498520]|0;b[j+1>>0]=b[498521]|0;b[j+2>>0]=b[498522]|0;b[j+3>>0]=b[498523]|0;b[j+4>>0]=b[498524]|0;b[j+5>>0]=0;l=dJa(g+48|0,j)|0;M=(f[l+20>>2]|0)==8?f[l+8>>2]|0:520944;if((b[B>>0]|0)<0)YDc(f[j>>2]|0);S=M}else J=60;while(0);if((J|0)==60){if((d|0)>=(f[a+52>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;r=tT(j,28)|0;s=385636;t=r+28|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,385526,382930,551)}J=f[(f[a+60>>2]|0)+4+(d<<2)>>2]|0;d=f[J+60>>2]|0;a=b[d+11>>0]|0;R=a<<24>>24<0;P=a&255;a=R?f[d+4>>2]|0:P;Q=b[L>>0]|0;M=Q<<24>>24<0;if((a|0)!=((M?f[p>>2]|0:Q&255)|0)){f[j>>2]=0;T=j+4|0;f[T>>2]=0;U=tT(j,46)|0;r=U;s=385665;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,385526,382930,551)}Q=f[d>>2]|0;p=R?Q:d;B=M?f[i>>2]|0:i;M=(a|0)==0;e:do if(R){if(!M?Arc(p,B,a)|0:0){f[j>>2]=0;T=j+4|0;f[T>>2]=0;U=tT(j,46)|0;r=U;s=385665;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,385526,382930,551)}}else if(!M){if((Q&255)<<24>>24==(b[B>>0]|0)){V=d;W=P;X=B}else{f[j>>2]=0;T=j+4|0;f[T>>2]=0;U=tT(j,46)|0;r=U;s=385665;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,385526,382930,551)}do{W=W+-1|0;V=V+1|0;if(!W)break e;X=X+1|0}while((b[V>>0]|0)==(b[X>>0]|0));f[j>>2]=0;T=j+4|0;f[T>>2]=0;U=tT(j,46)|0;r=U;s=385665;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));z5(-215,j,385526,382930,551)}while(0);Wdc(J+24|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;s=j+11|0;b[s>>0]=5;b[j>>0]=b[498520]|0;b[j+1>>0]=b[498521]|0;b[j+2>>0]=b[498522]|0;b[j+3>>0]=b[498523]|0;b[j+4>>0]=b[498524]|0;b[j+5>>0]=0;r=dJa(J+48|0,j)|0;J=(f[r+20>>2]|0)==8?f[r+8>>2]|0:520944;if((b[s>>0]|0)<0)YDc(f[j>>2]|0);S=J}if((b[L>>0]|0)>=0){u=h;return S|0}YDc(f[i>>2]|0);u=h;return S|0}function ZIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=c+4|0;i=f[h>>2]|0;j=g;if((i|0)==(g|0))k=i;else{l=i+(~((i+-4-j|0)>>>2)<<2)|0;f[h>>2]=l;k=l}l=k;if((a|0)==520944){f[e>>2]=0;m=e+4|0;f[m>>2]=0;n=tT(e,29)|0;o=n;p=385444;q=o+29|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-2,e,385474,382930,91)}i=f[a+156>>2]|0;if(!i){f[e>>2]=0;m=e+4|0;f[m>>2]=0;n=tT(e,29)|0;o=n;p=385444;q=o+29|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-2,e,385474,382930,91)}p=f[i+12>>2]|0;if(!p){f[e>>2]=1;switch(l-j>>2|0){case 0:{Zv(c,1,e);break}case 1:break;default:{e=g+4|0;if((k|0)!=(e|0))f[h>>2]=k+(~((k+-4-e|0)>>>2)<<2)}}u=d;return}e=l-j>>2;if(p>>>0<=e>>>0){if(p>>>0<e>>>0?(j=g+(p<<2)|0,(k|0)!=(j|0)):0)f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2)}else lN(c,p-e|0);if((p|0)<=0){u=d;return}e=f[i+20>>2]|0;i=f[c>>2]|0;c=0;do{f[i+(c<<2)>>2]=f[(f[e+4+(c<<2)>>2]|0)+16>>2];c=c+1|0}while((c|0)!=(p|0));u=d;return}function _Ia(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+160|0;e=d+140|0;g=d;fEc(a,c);h=a+12|0;f[h>>2]=0;i=b[c+11>>0]|0;j=i<<24>>24<0;k=j?f[c>>2]|0:c;l=j?f[c+4>>2]|0:i&255;if(!l){u=d;return}i=k+l|0;l=k;while(1){if((b[l>>0]|0)==58)break;j=l+1|0;if((j|0)==(i|0)){m=11;break}else l=j}if((m|0)==11){u=d;return}m=l-k|0;if((l|0)==(i|0)|(m|0)==-1){u=d;return}gEc(e,c,0,m,c);iEc(a,e)|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);gEc(e,c,m+1|0,-1,c);c=g+60|0;m=g+8|0;f[g>>2]=7732;f[c>>2]=7752;f[g+4>>2]=0;auc(g+60|0,m);f[g+132>>2]=0;f[g+136>>2]=-1;f[g>>2]=46136;f[c>>2]=46156;fuc(m);f[m>>2]=45740;c=g+40|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[g+56>>2]=8;G1(m,e);luc(g,h)|0;J3(g);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);u=d;return}function $Ia(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j>>2]=0;f[j+4>>2]=0;l=e+11|0;m=b[l>>0]|0;n=e+4|0;o=m<<24>>24<0?f[n>>2]|0:m&255;if(o|0){m=tT(j,o)|0;dJc(m|0,((b[l>>0]|0)<0?f[e>>2]|0:e)|0,o|0)|0}o=c+4|0;c=f[o>>2]|0;if(c){m=f[j>>2]|0;p=(m|0)==0?1154740:m;q=o;r=c;a:while(1){c=r;while(1){s=f[c+16>>2]|0;if((s|0)==(m|0))break;if((Ioc((s|0)==0?1154740:s,p)|0)>=0)break;s=f[c+4>>2]|0;if(!s){t=q;break a}else c=s}r=f[c>>2]|0;if(!r){t=c;break}else q=c}if((t|0)!=(o|0)){q=f[t+16>>2]|0;if((m|0)!=(q|0)?(Ioc(p,(q|0)==0?1154740:q)|0)<0:0)v=13;else w=t}else v=13}else v=13;if((v|0)==13)w=o;uT(j);if((w|0)==(o|0)){VHa(k,383435,e);f[j>>2]=0;f[j+4>>2]=0;o=k+11|0;v=b[o>>0]|0;t=v<<24>>24<0?f[k+4>>2]|0:v&255;if(!t)z5(-2,j,385436,382930,497);v=tT(j,t)|0;dJc(v|0,((b[o>>0]|0)<0?f[k>>2]|0:k)|0,t|0)|0;z5(-2,j,385436,382930,497)}t=a+80|0;k=f[t>>2]|0;o=a+84|0;a=f[o>>2]|0;b:do if((k|0)==(a|0))x=k;else{v=j+4|0;q=k;while(1){f[j>>2]=0;f[v>>2]=0;p=b[l>>0]|0;m=p<<24>>24<0?f[n>>2]|0:p&255;if(!m)y=0;else{p=tT(j,m)|0;dJc(p|0,((b[l>>0]|0)<0?f[e>>2]|0:e)|0,m|0)|0;y=f[j>>2]|0}m=f[q>>2]|0;if((m|0)==(y|0))break;p=(Ioc((m|0)==0?1154740:m,(y|0)==0?1154740:y)|0)==0;uT(j);if(p){x=q;break b}p=q+8|0;if((p|0)==(a|0)){x=a;break b}else q=p}uT(j);x=q}while(0);if((x|0)==(f[o>>2]|0)){z=f[e+12>>2]|0;A=w+24|0;B=f[A>>2]|0;mGa(d,B,z,g,h);u=i;return}else{z=x-(f[t>>2]|0)>>3;A=w+24|0;B=f[A>>2]|0;mGa(d,B,z,g,h);u=i;return}}function aJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;d=c+16|0;e=c;f[a>>2]=0;f[a+4>>2]=f[b+4>>2];AJa(a);g=f[b+8>>2]|0;b=f[g+12>>2]|0;h=f[g+4>>2]|0;a:do if(h>>>0>b>>>0){i=f[g+16>>2]|0;j=b;while(1){k=f[i+(j<<2)>>2]|0;if(k|0)break;l=j+1|0;if(l>>>0<h>>>0)j=l;else{m=0;n=l;break a}}if((k|0)==(f[i+((j^1)<<2)>>2]|0)){m=f[(f[k>>2]|0)+16>>2]|0;n=j;break}else{m=k;n=j;break}}else{m=0;n=b}while(0);f[e>>2]=m;f[e+4>>2]=g;f[e+8>>2]=n;if(!m){u=c;return}n=a+8|0;g=m;do{bJa(d,f[n>>2]|0,f[g+12>>2]|0,0);if(!(f[d>>2]|0)){m=f[(f[e>>2]|0)+12>>2]|0;lPa(BJa(a,m)|0,m+16|0)}pJa(e)|0;g=f[e>>2]|0}while((g|0)!=0);u=c;return}function bJa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d>>2]|0:d;l=b[k>>0]|0;if(!(l<<24>>24))m=0;else{n=k;o=0;p=l;while(1){q=(o*5|0)+(p<<24>>24)|0;n=n+1|0;p=b[n>>0]|0;if(!(p<<24>>24)){m=q;break}else o=q}}o=(f[c+4>>2]|0)+-1&(f[c+8>>2]|0)+m;m=f[c+16>>2]|0;p=f[m+(o<<2)>>2]|0;a:do if(!p)r=o;else{if((p|0)==(f[m+((o^1)<<2)>>2]|0)){if((p|0)!=(f[m+((o^1)<<2)>>2]|0)){r=o;break}n=o&-2;q=f[m+(n<<2)>>2]|0;f[h>>2]=d;s=q+4|0;t=zJa(q,h,f[s>>2]|0,s)|0;do if((t|0)!=(s|0)){q=f[h>>2]|0;v=t+16|0;w=f[v>>2]|0;x=b[w+11>>0]|0;y=x<<24>>24<0;z=y?f[w+4>>2]|0:x&255;x=b[q+11>>0]|0;A=x<<24>>24<0;B=A?f[q+4>>2]|0:x&255;x=z>>>0<B>>>0?z:B;C=w;if((x|0)!=0?(D=Arc(A?f[q>>2]|0:q,y?f[w>>2]|0:w,x)|0,(D|0)!=0):0){if((D|0)<0)break}else E=20;if((E|0)==20?B>>>0<z>>>0:0)break;if(!e)F=C;else{f[e>>2]=t;F=f[v>>2]|0}f[a>>2]=F;f[a+4>>2]=c;f[a+8>>2]=n;f[a+12>>2]=n;u=g;return}while(0);r=n;break}t=j?f[d+4>>2]|0:i&255;s=(t|0)==0;v=p;b:while(1){C=b[v+11>>0]|0;z=C<<24>>24<0;B=C&255;do if(((z?f[v+4>>2]|0:B)|0)==(t|0)){C=f[v>>2]|0;D=z?C:v;if(z){if(s)break b;if(!(Arc(D,k,t)|0))break b;else break}if(s)break b;if((C&255)<<24>>24==l<<24>>24){C=v;D=B;x=k;do{D=D+-1|0;C=C+1|0;if(!D)break b;x=x+1|0}while((b[C>>0]|0)==(b[x>>0]|0))}}while(0);B=f[v+16>>2]|0;if(!B){r=o;break a}else v=B}f[a>>2]=v;f[a+4>>2]=c;f[a+8>>2]=o;f[a+12>>2]=o;u=g;return}while(0);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=r;u=g;return}function cJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+48|0;c=b+24|0;d=b+12|0;e=b;g=a+8|0;h=f[g>>2]|0;i=f[h+12>>2]|0;j=f[h+4>>2]|0;a:do if(j>>>0>i>>>0){k=f[h+16>>2]|0;l=i;while(1){m=f[k+(l<<2)>>2]|0;if(m|0)break;n=l+1|0;if(n>>>0<j>>>0)l=n;else{o=0;p=n;break a}}if((m|0)==(f[k+((l^1)<<2)>>2]|0)){o=f[(f[m>>2]|0)+16>>2]|0;p=l;break}else{o=m;p=l;break}}else{o=0;p=i}while(0);f[e>>2]=o;f[e+4>>2]=h;f[e+8>>2]=p;if(o|0)do{f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];sJa(d,a,c);f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2];f[e+8>>2]=f[d+8>>2]}while((f[e>>2]|0)!=0);if(f[a>>2]|0){u=b;return}a=f[g>>2]|0;if(!a){u=b;return}g=a+16|0;if(f[g>>2]|0?(tJa(a),(f[a+20>>2]|0)==0):0)YDc(f[g>>2]|0);YDc(a);u=b;return}function dJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;bJa(d,f[a+8>>2]|0,b,0);a=f[d>>2]|0;if(a|0){g=a+12|0;h=f[g>>2]|0;i=h+16|0;u=c;return i|0}rTb(e,3,385092,1059);oTb(c+40|0,nTb(mTb(mTb(e,385173)|0,385201)|0,b)|0);sTb(e);g=a+12|0;h=f[g>>2]|0;i=h+16|0;u=c;return i|0}function eJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;switch(f[a+160>>2]|0){case 19:case 1:{f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;ZIa(a,e);j=f[e>>2]|0;k=((f[i>>2]|0)-j|0)==16;l=j;if(k){j=l+8|0;m=l+12|0;o=f[m>>2]|0;f[m>>2]=f[j>>2];m=l+4|0;l=f[m>>2]|0;f[m>>2]=o;f[j>>2]=l}YS(c,e,5);Vnb(g,a);l=g+4|0;j=f[l>>2]|0;if((j|0)<3)q=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{o=f[g+40>>2]|0;m=0;r=1;while(1){s=Y(f[o+(m<<2)>>2]|0,r)|0;m=m+1|0;if((m|0)==(j|0)){q=s;break}else r=s}}r=f[c+4>>2]|0;if((r|0)<3)t=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{j=f[c+40>>2]|0;m=0;o=1;while(1){s=Y(f[j+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)==(r|0)){t=s;break}else o=s}}if((q|0)!=(t|0)){f[h>>2]=0;f[h+4>>2]=0;v=tT(h,28)|0;w=383188;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,383217,382930,113)}t=f[c+16>>2]|0;o=g+16|0;r=f[o>>2]|0;a:do if(k){m=f[e>>2]|0;j=f[m>>2]|0;s=f[m+4>>2]|0;y=f[m+8>>2]|0;z=f[m+12>>2]|0;m=Y(Y(Y(s,j)|0,y)|0,z)|0;if((j|0)>0?(A=Y(Y(y,s)|0,z)|0,(s|0)>0):0){B=(y|0)<1|(z|0)<1;C=0;b:while(1){D=Y(A,C)|0;if(!B){E=0;do{F=Y(E,y)|0;G=E+D|0;H=0;do{I=(Y(H+F|0,z)|0)+D|0;J=Y(H,z)|0;K=0;do{L=I+K|0;M=G+(Y(K+J|0,s)|0)|0;if((L|0)>=(m|0)){N=28;break b}if((M|0)>=(m|0)){N=29;break b}f[t+(L<<2)>>2]=f[r+(M<<2)>>2];K=K+1|0}while((K|0)<(z|0));H=H+1|0}while((H|0)<(y|0));E=E+1|0}while((E|0)<(s|0))}C=C+1|0;if((C|0)>=(j|0))break a}if((N|0)==28){f[h>>2]=0;f[h+4>>2]=0;v=tT(h,13)|0;w=383229;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,383217,382930,129)}else if((N|0)==29){f[h>>2]=0;f[h+4>>2]=0;v=tT(h,13)|0;w=383243;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,383217,382930,130)}}}else if((q|0)>0){j=0;do{f[t+(j<<2)>>2]=f[r+(j<<2)>>2];j=j+1|0}while((j|0)!=(q|0))}while(0);q=g+36|0;r=f[q>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)_S(g);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){o=f[g+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[l>>2]|0))}l=f[g+44>>2]|0;if((l|0)!=(g+48|0))g0(l);l=f[e>>2]|0;if(l|0){q=f[i>>2]|0;if((q|0)!=(l|0))f[i>>2]=q+(~((q+-4-l|0)>>>2)<<2);YDc(l)}u=d;return}case 2:{f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;ZIa(a,e);q=f[e>>2]|0;i=((f[l>>2]|0)-q|0)==16;o=q;if(i){q=o+8|0;r=o+12|0;t=f[r>>2]|0;f[r>>2]=f[q>>2];r=o+4|0;o=f[r>>2]|0;f[r>>2]=t;f[q>>2]=o}YS(c,e,5);Vnb(g,a);a=g+4|0;o=f[a>>2]|0;if((o|0)<3)O=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{q=f[g+40>>2]|0;t=0;r=1;while(1){k=Y(f[q+(t<<2)>>2]|0,r)|0;t=t+1|0;if((t|0)==(o|0)){O=k;break}else r=k}}r=f[c+4>>2]|0;if((r|0)<3)P=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+40>>2]|0;t=0;q=1;while(1){k=Y(f[o+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)==(r|0)){P=k;break}else q=k}}if((O|0)!=(P|0)){f[h>>2]=0;f[h+4>>2]=0;v=tT(h,28)|0;w=383188;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,383217,382930,113)}P=f[c+16>>2]|0;c=g+16|0;q=f[c>>2]|0;c:do if(i){r=f[e>>2]|0;t=f[r>>2]|0;o=f[r+4>>2]|0;k=f[r+8>>2]|0;j=f[r+12>>2]|0;r=Y(Y(Y(o,t)|0,k)|0,j)|0;if((t|0)>0?(C=Y(Y(k,o)|0,j)|0,(o|0)>0):0){s=(k|0)<1|(j|0)<1;y=0;d:while(1){z=Y(C,y)|0;if(!s){m=0;do{B=Y(m,k)|0;A=m+z|0;E=0;do{D=(Y(E+B|0,j)|0)+z|0;H=Y(E,j)|0;G=0;do{F=D+G|0;K=A+(Y(G+H|0,o)|0)|0;if((F|0)>=(r|0)){N=70;break d}if((K|0)>=(r|0)){N=71;break d}n[P+(F<<2)>>2]=+p[q+(K<<3)>>3];G=G+1|0}while((G|0)<(j|0));E=E+1|0}while((E|0)<(k|0));m=m+1|0}while((m|0)<(o|0))}y=y+1|0;if((y|0)>=(t|0))break c}if((N|0)==70){f[h>>2]=0;f[h+4>>2]=0;v=tT(h,13)|0;w=383229;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,383217,382930,129)}else if((N|0)==71){f[h>>2]=0;f[h+4>>2]=0;v=tT(h,13)|0;w=383243;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,h,383217,382930,130)}}}else if((O|0)>0){t=0;do{n[P+(t<<2)>>2]=+p[q+(t<<3)>>3];t=t+1|0}while((t|0)!=(O|0))}while(0);O=g+36|0;q=f[O>>2]|0;if(q|0?(P=q+12|0,q=f[P>>2]|0,f[P>>2]=q+-1,(q|0)==1):0)_S(g);f[O>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+40>>2]|0;O=0;do{f[c+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))g0(a);a=f[e>>2]|0;if(a|0){g=f[l>>2]|0;if((g|0)!=(a|0))f[l>>2]=g+(~((g+-4-a|0)>>>2)<<2);YDc(a)}u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;v=tT(e,35)|0;w=426735;x=v+35|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-2,e,385077,382930,154)}}}function fJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+24|0;j=e+16|0;k=e;l=a+20|0;m=f[(f[(f[l>>2]|0)+4+(c<<2)>>2]|0)+60>>2]|0;f[g>>2]=0;f[g+4>>2]=0;n=m+11|0;o=b[n>>0]|0;p=o<<24>>24<0?f[m+4>>2]|0:o&255;if(p|0){o=tT(g,p)|0;dJc(o|0,((b[n>>0]|0)<0?f[m>>2]|0:m)|0,p|0)|0}f[i>>2]=0;f[i+4>>2]=0;VIa(h,a,g,i);uT(i);a=f[(f[(f[(f[l>>2]|0)+4+(c<<2)>>2]|0)+20>>2]|0)+4+(d<<2)>>2]|0;f[i>>2]=0;d=i+4|0;f[d>>2]=0;c=a+11|0;p=b[c>>0]|0;m=p<<24>>24<0?f[a+4>>2]|0:p&255;if(m|0){p=tT(i,m)|0;dJc(p|0,((b[c>>0]|0)<0?f[a>>2]|0:a)|0,m|0)|0}m=h+4|0;a=f[m>>2]|0;c=f[h>>2]|0;a:do if((a|0)!=(c|0)){p=j+4|0;n=k+11|0;o=k+8|0;q=k+4|0;r=0;s=a;t=c;b:while(1){v=f[(f[l>>2]|0)+4+(f[t+(r*12|0)+8>>2]<<2)>>2]|0;w=v+12|0;if((f[w>>2]|0)>0){x=v+20|0;v=0;do{y=f[(f[x>>2]|0)+4+(v<<2)>>2]|0;f[j>>2]=0;f[p>>2]=0;z=y+11|0;A=b[z>>0]|0;B=A<<24>>24<0?f[y+4>>2]|0:A&255;if(!B)C=0;else{A=tT(j,B)|0;dJc(A|0,((b[z>>0]|0)<0?f[y>>2]|0:y)|0,B|0)|0;C=f[j>>2]|0}B=f[g>>2]|0;if(!((C|0)!=(B|0)?(Ioc((C|0)==0?1154740:C,(B|0)==0?1154740:B)|0)!=0:0)){B=f[i>>2]|0;y=f[d>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(y>>>0>4294967279)break b;if(y>>>0<11){b[n>>0]=y;if(!y)D=k;else{E=k;F=20}}else{z=y+16&-16;A=VDc(z)|0;f[k>>2]=A;f[o>>2]=z|-2147483648;f[q>>2]=y;E=A;F=20}if((F|0)==20){F=0;dJc(E|0,B|0,y|0)|0;D=E}b[D+y>>0]=0;iEc(f[(f[x>>2]|0)+4+(v<<2)>>2]|0,k)|0;if((b[n>>0]|0)<0)YDc(f[k>>2]|0)}uT(j);v=v+1|0}while((v|0)<(f[w>>2]|0));G=f[h>>2]|0;H=f[m>>2]|0}else{G=t;H=s}r=r+1|0;if(r>>>0>=((H-G|0)/12|0)>>>0)break a;else{s=H;t=G}}dEc(k)}while(0);uT(i);i=f[h>>2]|0;if(!i){uT(g);u=e;return}while(1){k=f[m>>2]|0;if((k|0)==(i|0))break;G=k+-12|0;f[m>>2]=G;uT(G)}YDc(f[h>>2]|0);uT(g);u=e;return}function gJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;ZIa(a,e);switch(f[a+160>>2]|0){case 19:case 1:break;default:{f[g>>2]=0;f[g+4>>2]=0;j=tT(g,79)|0;k=384970;l=j+79|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,g,385050,382930,458)}}m=f[e>>2]|0;n=m;if(((f[i>>2]|0)-m|0)!=16){f[g>>2]=0;f[g+4>>2]=0;j=tT(g,9)|0;k=385067;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,g,385050,382930,459)}m=n+8|0;o=f[n>>2]|0;f[n>>2]=f[m>>2];f[m>>2]=o;o=n+4|0;m=n+12|0;p=f[m>>2]|0;f[m>>2]=f[o>>2];m=f[n>>2]|0;f[n>>2]=p;f[o>>2]=m;YS(c,e,5);Vnb(g,a);a=g+4|0;m=f[a>>2]|0;if((m|0)<3)q=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{o=f[g+40>>2]|0;p=0;n=1;while(1){r=Y(f[o+(p<<2)>>2]|0,n)|0;p=p+1|0;if((p|0)==(m|0)){q=r;break}else n=r}}n=f[c+4>>2]|0;if((n|0)<3)s=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{m=f[c+40>>2]|0;p=0;o=1;while(1){r=Y(f[m+(p<<2)>>2]|0,o)|0;p=p+1|0;if((p|0)==(n|0)){s=r;break}else o=r}}if((q|0)!=(s|0)){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,28)|0;k=383188;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,h,385050,382930,470)}s=f[c+16>>2]|0;c=g+16|0;q=f[c>>2]|0;o=f[e>>2]|0;n=f[o>>2]|0;p=f[o+4>>2]|0;m=f[o+8>>2]|0;r=f[o+12>>2]|0;o=Y(p,n)|0;t=Y(Y(o,m)|0,r)|0;a:do if((n|0)>0){v=(p|0)>0;w=(m|0)>0;x=(r|0)>0;y=0;b:while(1){if(v?(z=Y(y,p)|0,w):0){A=0;do{B=Y(A+z|0,m)|0;C=(Y(A,n)|0)+y|0;if(x){D=0;do{E=Y(B+D|0,r)|0;F=Y(D,r)|0;G=0;do{H=G+E|0;I=C+(Y(G+F|0,o)|0)|0;if((H|0)>=(t|0)){J=35;break b}if((I|0)>=(t|0)){J=36;break b}f[s+(H<<2)>>2]=f[q+(I<<2)>>2];G=G+1|0}while((G|0)<(r|0));D=D+1|0}while((D|0)<(m|0))}A=A+1|0}while((A|0)<(p|0))}y=y+1|0;if((y|0)>=(n|0))break a}if((J|0)==35){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,13)|0;k=383229;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,h,385050,382930,483)}else if((J|0)==36){f[h>>2]=0;f[h+4>>2]=0;j=tT(h,13)|0;k=383243;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));z5(-215,h,385050,382930,484)}}while(0);h=g+36|0;k=f[h>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)_S(g);f[h>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+40>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))g0(a);a=f[e>>2]|0;if(!a){u=d;return}e=f[i>>2]|0;if((e|0)!=(a|0))f[i>>2]=e+(~((e+-4-a|0)>>>2)<<2);YDc(a);u=d;return}function hJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=a+4|0;d=f[c>>2]|0;a:do if(!d){e=c;g=c;h=d;i=12}else{j=a+4|0;k=f[b>>2]|0;l=(k|0)==0?1154740:k;m=f[d+16>>2]|0;b:do if((k|0)!=(m|0)){n=j;o=d;p=m;q=d;while(1){r=(p|0)==0?1154740:p;if((Ioc(l,r)|0)<0){s=f[o>>2]|0;if(!s){i=6;break}else{t=o;u=s}}else{if((Ioc(r,l)|0)>=0){v=n;w=o;x=q;break b}y=o+4|0;r=f[y>>2]|0;if(!r){i=9;break}else{t=y;u=r}}p=f[u+16>>2]|0;if((k|0)==(p|0)){v=t;w=u;x=u;break b}else{n=t;o=u;q=u}}if((i|0)==6){z=o;A=o;break a}else if((i|0)==9){z=y;A=o;break a}}else{v=j;w=d;x=d}while(0);e=v;g=w;h=x;i=12}while(0);if((i|0)==12)if(!h){z=e;A=g}else{B=h;C=B+24|0;return C|0}h=VDc(80)|0;g=f[b>>2]|0;f[h+16>>2]=g;f[h+20>>2]=f[b+4>>2];if(g|0){b=g+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[h+24>>2]=1124007936;b=h+32|0;g=h+64|0;e=h+28|0;i=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));f[g>>2]=b;b=h+72|0;f[h+68>>2]=b;f[b>>2]=0;f[h+76>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=A;f[z>>2]=h;A=f[f[a>>2]>>2]|0;if(!A)D=h;else{f[a>>2]=A;D=f[z>>2]|0}laa(f[a+4>>2]|0,D);D=a+8|0;f[D>>2]=(f[D>>2]|0)+1;B=h;C=B+24|0;return C|0}function iJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[h+8>>2]=0;i=h+11|0;b[i>>0]=7;b[h>>0]=b[427173]|0;b[h+1>>0]=b[427174]|0;b[h+2>>0]=b[427175]|0;b[h+3>>0]=b[427176]|0;b[h+4>>0]=b[427177]|0;b[h+5>>0]=b[427178]|0;b[h+6>>0]=b[427179]|0;b[h+7>>0]=0;j=c+24|0;Wdc(j);k=c+48|0;aJa(g,k);bJa(e,f[g+8>>2]|0,h,0);l=(f[e>>2]|0)==0;cJa(g);if((b[i>>0]|0)<0)YDc(f[h>>2]|0);if(l){u=d;return}f[e+8>>2]=0;l=e+11|0;b[l>>0]=7;b[e>>0]=b[427173]|0;b[e+1>>0]=b[427174]|0;b[e+2>>0]=b[427175]|0;b[e+3>>0]=b[427176]|0;b[e+4>>0]=b[427177]|0;b[e+5>>0]=b[427178]|0;b[e+6>>0]=b[427179]|0;b[e+7>>0]=0;Wdc(j);j=dJa(k,e)|0;if((b[l>>0]|0)<0)YDc(f[e>>2]|0);l=(TIa(c)|0)==1;c=l?3:2;k=l?2:1;h=l?1:3;l=j+20|0;i=j+8|0;j=(f[l>>2]|0)==1?f[i>>2]|0:520336;if((f[j+24>>2]|0)!=4){f[e>>2]=0;m=e+4|0;f[m>>2]=0;n=tT(e,19)|0;o=n;p=384939;q=o+19|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-2,e,384959,382930,296)}r=f[j+32>>2]|0;j=r+8|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0)){f[e>>2]=0;m=e+4|0;f[m>>2]=0;n=tT(e,19)|0;o=n;p=384939;q=o+19|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-2,e,384959,382930,296)}j=r+8+(h<<3)|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0)){f[e>>2]=0;m=e+4|0;f[m>>2]=0;n=tT(e,19)|0;o=n;p=384939;q=o+19|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-2,e,384959,382930,296)}f[e>>2]=0;f[e+4>>2]=0;p=tT(e,8)|0;o=p;b[o>>0]=115;b[o+1>>0]=116;b[o+2>>0]=114;b[o+3>>0]=105;o=p+4|0;b[o>>0]=100;b[o+1>>0]=101;b[o+2>>0]=95;b[o+3>>0]=104;f[g>>2]=f[(f[((f[l>>2]|0)==1?f[i>>2]|0:520336)+32>>2]|0)+8+(k<<3)>>2];$Ha(a,e,g)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;k=tT(e,8)|0;o=k;b[o>>0]=115;b[o+1>>0]=116;b[o+2>>0]=114;b[o+3>>0]=105;o=k+4|0;b[o>>0]=100;b[o+1>>0]=101;b[o+2>>0]=95;b[o+3>>0]=119;f[g>>2]=f[(f[((f[l>>2]|0)==1?f[i>>2]|0:520336)+32>>2]|0)+8+(c<<3)>>2];$Ha(a,e,g)|0;uT(e);u=d;return}function jJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[h+8>>2]=0;i=h+11|0;b[i>>0]=7;b[h>>0]=b[440970]|0;b[h+1>>0]=b[440971]|0;b[h+2>>0]=b[440972]|0;b[h+3>>0]=b[440973]|0;b[h+4>>0]=b[440974]|0;b[h+5>>0]=b[440975]|0;b[h+6>>0]=b[440976]|0;b[h+7>>0]=0;j=c+24|0;Wdc(j);k=c+48|0;aJa(g,k);bJa(e,f[g+8>>2]|0,h,0);c=(f[e>>2]|0)==0;cJa(g);if((b[i>>0]|0)<0)YDc(f[h>>2]|0);if(c){u=d;return}f[e>>2]=0;f[e+4>>2]=0;c=tT(e,8)|0;h=c;b[h>>0]=112;b[h+1>>0]=97;b[h+2>>0]=100;b[h+3>>0]=95;h=c+4|0;b[h>>0]=109;b[h+1>>0]=111;b[h+2>>0]=100;b[h+3>>0]=101;f[g+8>>2]=0;h=g+11|0;b[h>>0]=7;b[g>>0]=b[440970]|0;b[g+1>>0]=b[440971]|0;b[g+2>>0]=b[440972]|0;b[g+3>>0]=b[440973]|0;b[g+4>>0]=b[440974]|0;b[g+5>>0]=b[440975]|0;b[g+6>>0]=b[440976]|0;b[g+7>>0]=0;Wdc(j);j=dJa(k,g)|0;fIa(a,e,(f[j+20>>2]|0)==2?f[j+8>>2]|0:527320)|0;if((b[h>>0]|0)<0)YDc(f[g>>2]|0);uT(e);u=d;return}function kJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+32|0;e=d+16|0;g=d;gEc(g,a,0,DEc(a,58,-1)|0,a);f[e>>2]=0;f[e+4>>2]=0;a=g+11|0;h=b[a>>0]|0;i=h<<24>>24<0?f[g+4>>2]|0:h&255;if(i|0){h=tT(e,i)|0;dJc(h|0,((b[a>>0]|0)<0?f[g>>2]|0:g)|0,i|0)|0}i=c+4|0;c=f[i>>2]|0;if(c){h=f[e>>2]|0;j=(h|0)==0?1154740:h;k=i;l=c;a:while(1){c=l;while(1){m=f[c+16>>2]|0;if((m|0)==(h|0))break;if((Ioc((m|0)==0?1154740:m,j)|0)>=0)break;m=f[c+4>>2]|0;if(!m){n=k;break a}else c=m}l=f[c>>2]|0;if(!l){n=c;break}else k=c}if((n|0)!=(i|0)){k=f[n+16>>2]|0;if((h|0)!=(k|0)?(Ioc(j,(k|0)==0?1154740:k)|0)<0:0)o=13;else p=n}else o=13}else o=13;if((o|0)==13)p=i;uT(e);if((b[a>>0]|0)<0)YDc(f[g>>2]|0);if((p|0)==(i|0)){q=2;u=d;return q|0}q=f[p+24>>2]|0;u=d;return q|0}function lJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=5;b[h>>0]=b[384906]|0;b[h+1>>0]=b[384907]|0;b[h+2>>0]=b[384908]|0;b[h+3>>0]=b[384909]|0;b[h+4>>0]=b[384910]|0;b[h+5>>0]=0;j=c+24|0;Wdc(j);k=c+48|0;aJa(g,k);bJa(e,f[g+8>>2]|0,h,0);l=(f[e>>2]|0)==0;cJa(g);if((b[i>>0]|0)<0)YDc(f[h>>2]|0);if(l){f[e>>2]=0;f[e+4>>2]=0;l=tT(e,8)|0;h=l;b[h>>0]=107;b[h+1>>0]=101;b[h+2>>0]=114;b[h+3>>0]=110;h=l+4|0;b[h>>0]=101;b[h+1>>0]=108;b[h+2>>0]=95;b[h+3>>0]=104;f[g>>2]=1;$Ha(a,e,g)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;h=tT(e,8)|0;l=h;b[l>>0]=107;b[l+1>>0]=101;b[l+2>>0]=114;b[l+3>>0]=110;l=h+4|0;b[l>>0]=101;b[l+1>>0]=108;b[l+2>>0]=95;b[l+3>>0]=119;f[g>>2]=1;$Ha(a,e,g)|0;uT(e);u=d;return};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;l=e+11|0;b[l>>0]=5;b[e>>0]=b[384906]|0;b[e+1>>0]=b[384907]|0;b[e+2>>0]=b[384908]|0;b[e+3>>0]=b[384909]|0;b[e+4>>0]=b[384910]|0;b[e+5>>0]=0;Wdc(j);j=dJa(k,e)|0;if((b[l>>0]|0)<0)YDc(f[e>>2]|0);l=(TIa(c)|0)==1;c=l?3:2;k=l?2:1;h=l?1:3;l=j+20|0;i=j+8|0;j=(f[l>>2]|0)==1?f[i>>2]|0:520336;if((f[j+24>>2]|0)!=4){f[e>>2]=0;m=e+4|0;f[m>>2]=0;n=tT(e,17)|0;o=n;p=384912;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-2,e,384930,382930,333)}r=f[j+32>>2]|0;j=r+8|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0)){f[e>>2]=0;m=e+4|0;f[m>>2]=0;n=tT(e,17)|0;o=n;p=384912;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-2,e,384930,382930,333)}j=r+8+(h<<3)|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0)){f[e>>2]=0;m=e+4|0;f[m>>2]=0;n=tT(e,17)|0;o=n;p=384912;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));z5(-2,e,384930,382930,333)}f[e>>2]=0;f[e+4>>2]=0;p=tT(e,8)|0;o=p;b[o>>0]=107;b[o+1>>0]=101;b[o+2>>0]=114;b[o+3>>0]=110;o=p+4|0;b[o>>0]=101;b[o+1>>0]=108;b[o+2>>0]=95;b[o+3>>0]=104;f[g>>2]=f[(f[((f[l>>2]|0)==1?f[i>>2]|0:520336)+32>>2]|0)+8+(k<<3)>>2];$Ha(a,e,g)|0;uT(e);f[e>>2]=0;f[e+4>>2]=0;k=tT(e,8)|0;o=k;b[o>>0]=107;b[o+1>>0]=101;b[o+2>>0]=114;b[o+3>>0]=110;o=k+4|0;b[o>>0]=101;b[o+1>>0]=108;b[o+2>>0]=95;b[o+3>>0]=119;f[g>>2]=f[(f[((f[l>>2]|0)==1?f[i>>2]|0:520336)+32>>2]|0)+8+(c<<3)>>2];$Ha(a,e,g)|0;uT(e);u=d;return}function mJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}o=c;p=f[o>>2]|0;r=f[o+4>>2]|0;f[e>>2]=0;o=VDc(16)|0;v=o+8|0;f[o>>2]=v;f[o+4>>2]=1;f[e+4>>2]=o;o=v;f[o>>2]=p;f[o+4>>2]=r;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=c;t=f[b>>2]|0;k=f[b+4>>2]|0;f[i>>2]=0;b=VDc(16)|0;r=b+8|0;f[b>>2]=r;f[b+4>>2]=1;f[i+4>>2]=b;b=r;f[b>>2]=t;f[b+4>>2]=k;k=f[h>>2]|0;f[g>>2]=k;b=g+4|0;f[b>>2]=f[s>>2];if(k|0){s=k+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);k=f[g>>2]|0;f[e>>2]=k;t=e+4|0;f[t>>2]=f[b>>2];if(k|0){b=k+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=e+8|0;TFa(b,s);k=f[j>>2]|0;b:do if(!k){w=j;x=j}else{r=a+4|0;o=f[e>>2]|0;p=(o|0)==0?1154740:o;v=f[k+16>>2]|0;c:do if((o|0)!=(v|0)){y=r;z=k;A=v;while(1){B=(A|0)==0?1154740:A;if((Ioc(p,B)|0)<0){C=f[z>>2]|0;if(!C){D=24;break}else{E=z;F=C}}else{if((Ioc(B,p)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=27;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((o|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==24){w=z;x=z;break b}else if((D|0)==27){w=I;x=z;break b}}else{G=r;H=k}while(0);w=G;x=H}while(0);if(!(f[w>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[t>>2];if(G|0){t=G+-4|0;f[t>>2]=(f[t>>2]|0)+1}TFa(H+24|0,b);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=x;f[w>>2]=H;x=f[f[a>>2]>>2]|0;if(!x)J=H;else{f[a>>2]=x;J=f[w>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(b);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function nJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=VDc(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;uT(p);o=Mpc(c)|0;if(o|0)dJc(tT(p,o)|0,c|0,o|0)|0;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=VDc(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;uT(t);b=Mpc(c)|0;if(b|0)dJc(tT(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function oJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=VDc(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;uT(p);o=Mpc(c)|0;if(o|0)dJc(tT(p,o)|0,c|0,o|0)|0;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=VDc(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;uT(t);b=Mpc(c)|0;if(b|0)dJc(tT(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function pJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=u;u=u+32|0;c=b+8|0;d=b;e=f[a>>2]|0;g=f[e+16>>2]|0;if(g|0){f[a>>2]=g;u=b;return a|0}g=a+4|0;h=f[g>>2]|0;i=a+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=f[h+16>>2]|0;l=f[k+(j<<2)>>2]|0;a:do if((l|0)!=(e|0)){b:do if(l|0?(l|0)!=(f[k+((j^1)<<2)>>2]|0):0){m=l;while(1){m=f[m+16>>2]|0;if(!m)break b;if((m|0)==(e|0)){n=j;o=h;p=9;break a}}}while(0);bJa(c,h,e,d);m=f[c+8>>2]|0;f[i>>2]=m;q=f[g>>2]|0;r=f[q+16>>2]|0;s=f[r+(m<<2)>>2]|0;if((s|0)!=0?(s|0)==(f[r+((m^1)<<2)>>2]|0):0){t=f[d>>2]|0;v=f[t+4>>2]|0;if(!v){w=t+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(t|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;t=f[x>>2]|0}while((f[t>>2]|0)!=(w|0));y=t}}else{x=v;while(1){t=f[x>>2]|0;if(!t)break;else x=t}y=x}f[d>>2]=y;if((y|0)!=(s+4|0)){f[a>>2]=f[y+16>>2];break}v=m+2|0;f[a>>2]=0;f[i>>2]=v;t=f[q+4>>2]|0;if(t>>>0>v>>>0){w=v;while(1){z=f[r+(w<<2)>>2]|0;if(z|0)break;v=w+1|0;f[i>>2]=v;if(v>>>0<t>>>0)w=v;else break a}if((z|0)==(f[r+((w^1)<<2)>>2]|0))A=f[(f[z>>2]|0)+16>>2]|0;else A=z;f[a>>2]=A}}else{n=m;o=q;p=9}}else{n=j;o=h;p=9}while(0);c:do if((p|0)==9?(h=n+1|0,f[a>>2]=0,f[i>>2]=h,j=f[o+4>>2]|0,j>>>0>h>>>0):0){A=f[o+16>>2]|0;z=h;while(1){B=f[A+(z<<2)>>2]|0;if(B|0)break;h=z+1|0;f[i>>2]=h;if(h>>>0<j>>>0)z=h;else break c}if((B|0)==(f[A+((z^1)<<2)>>2]|0))C=f[(f[B>>2]|0)+16>>2]|0;else C=B;f[a>>2]=C}while(0);u=b;return a|0}function qJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if(!b)return;qJa(a,f[b>>2]|0);qJa(a,f[b+4>>2]|0);a=b+16|0;c=b+24|0;d=b+60|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)_S(c);f[d>>2]=0;d=b+40|0;c=b+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[b+64>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[b+68>>2]|0;if((c|0)!=(b+72|0))g0(c);uT(a);YDc(b);return}function rJa(a,b){a=a|0;b=b|0;if(!b)return;rJa(a,f[b>>2]|0);rJa(a,f[b+4>>2]|0);uT(b+16|0);YDc(b);return}function sJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+12|0;h=e;if((f[c>>2]|0)==0?(i=f[(f[d>>2]|0)+12>>2]|0,i|0):0){ROa(i+16|0);if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)};f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[h+8>>2]=f[d+8>>2];vJa(d)|0;i=f[c+8>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];wJa(i,g);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];u=e;return}function tJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!(f[c>>2]|0)){d=0;f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}g=a+16|0;h=a+20|0;i=0;while(1){j=f[g>>2]|0;k=j+(i<<2)|0;l=f[k>>2]|0;a:do if(l){if((l|0)!=(f[j+((i^1)<<2)>>2]|0)){f[k>>2]=0;m=l;while(1){n=m;m=f[m+16>>2]|0;if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if(!(f[h>>2]|0))YDc(n);if(!m){o=i;break a}}}if((l|0)==(f[j+((i^1)<<2)>>2]|0)){m=i+1|0;f[j+(m<<2)>>2]=0;f[(f[g>>2]|0)+(i<<2)>>2]=0;n=l+12|0;p=l+4|0;q=l+8|0;r=l+4|0;s=f[l>>2]|0;do{t=s;u=f[t+16>>2]|0;v=s;w=f[v+4>>2]|0;if(!w){x=v+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(v|0))z=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;A=f[y>>2]|0}while((f[A>>2]|0)!=(x|0));z=A}}else{y=w;while(1){A=f[y>>2]|0;if(!A)break;else y=A}z=y}w=f[t+4>>2]|0;if(!w){A=t+8|0;x=f[A>>2]|0;if((f[x>>2]|0)==(v|0))B=x;else{x=A;do{A=f[x>>2]|0;x=A+8|0;C=f[x>>2]|0}while((f[C>>2]|0)!=(A|0));B=C}}else{x=w;while(1){y=f[x>>2]|0;if(!y)break;else x=y}B=x}if((f[l>>2]|0)==(t|0))f[l>>2]=B;f[n>>2]=(f[n>>2]|0)+-1;uHa(f[p>>2]|0,v);if(!(f[q>>2]|0))YDc(s);s=z;if((b[u+11>>0]|0)<0)YDc(f[u>>2]|0);if(!(f[h>>2]|0))YDc(u)}while((z|0)!=(r|0));s=f[h>>2]|0;uJa(l,f[r>>2]|0);if(!s){YDc(l);o=m}else o=m}else o=i}else o=i;while(0);i=o+1|0;l=f[c>>2]|0;if(i>>>0>=l>>>0){d=l;break}}f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}function uJa(a,b){a=a|0;b=b|0;if(!b)return;uJa(a,f[b>>2]|0);uJa(a,f[b+4>>2]|0);if(f[a+8>>2]|0)return;YDc(b);return}function vJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=u;u=u+32|0;c=b+8|0;d=b;e=f[a>>2]|0;g=f[e+16>>2]|0;if(g|0){f[a>>2]=g;u=b;return a|0}g=a+4|0;h=f[g>>2]|0;i=a+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=f[h+16>>2]|0;l=f[k+(j<<2)>>2]|0;a:do if((l|0)!=(e|0)){b:do if(l|0?(l|0)!=(f[k+((j^1)<<2)>>2]|0):0){m=l;while(1){m=f[m+16>>2]|0;if(!m)break b;if((m|0)==(e|0)){n=j;o=h;p=9;break a}}}while(0);bJa(c,h,e,d);m=f[c+8>>2]|0;f[i>>2]=m;q=f[g>>2]|0;r=f[q+16>>2]|0;s=f[r+(m<<2)>>2]|0;if((s|0)!=0?(s|0)==(f[r+((m^1)<<2)>>2]|0):0){t=f[d>>2]|0;v=f[t+4>>2]|0;if(!v){w=t+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(t|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;t=f[x>>2]|0}while((f[t>>2]|0)!=(w|0));y=t}}else{x=v;while(1){t=f[x>>2]|0;if(!t)break;else x=t}y=x}f[d>>2]=y;if((y|0)!=(s+4|0)){f[a>>2]=f[y+16>>2];break}v=m+2|0;f[a>>2]=0;f[i>>2]=v;t=f[q+4>>2]|0;if(t>>>0>v>>>0){w=v;while(1){z=f[r+(w<<2)>>2]|0;if(z|0)break;v=w+1|0;f[i>>2]=v;if(v>>>0<t>>>0)w=v;else break a}if((z|0)==(f[r+((w^1)<<2)>>2]|0))A=f[(f[z>>2]|0)+16>>2]|0;else A=z;f[a>>2]=A}}else{n=m;o=q;p=9}}else{n=j;o=h;p=9}while(0);c:do if((p|0)==9?(h=n+1|0,f[a>>2]=0,f[i>>2]=h,j=f[o+4>>2]|0,j>>>0>h>>>0):0){A=f[o+16>>2]|0;z=h;while(1){B=f[A+(z<<2)>>2]|0;if(B|0)break;h=z+1|0;f[i>>2]=h;if(h>>>0<j>>>0)z=h;else break c}if((B|0)==(f[A+((z^1)<<2)>>2]|0))C=f[(f[B>>2]|0)+16>>2]|0;else C=B;f[a>>2]=C}while(0);u=b;return a|0}function wJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+8|0;g=d;h=f[c+4>>2]|0;i=c+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=h+16|0;l=f[k>>2]|0;m=f[l+(j<<2)>>2]|0;n=f[c>>2]|0;a:do if((m|0)!=(n|0)){b:do if(m|0?(m|0)!=(f[l+((j^1)<<2)>>2]|0):0){c=m;while(1){c=f[c+16>>2]|0;if(!c)break b;if((c|0)==(n|0)){o=j;p=7;break a}}}while(0);bJa(e,h,n,g);c=f[e+8>>2]|0;f[i>>2]=c;q=f[k>>2]|0;r=f[q+(c<<2)>>2]|0;if(r){s=a+16|0;t=(f[s>>2]|0)+(c<<2)|0;if((r|0)==(f[q+((c^1)<<2)>>2]|0)){q=f[t>>2]|0;yJa(q,(f[g>>2]|0)+16|0)|0;if(!(f[q+12>>2]|0)){r=c&-2;v=f[a+20>>2]|0;uJa(q,f[q+4>>2]|0);if(!v)YDc(q);f[(f[s>>2]|0)+((c|1)<<2)>>2]=0;f[(f[s>>2]|0)+(r<<2)>>2]=0;w=r;x=s}else{w=c;x=s}}else{y=t;z=s;A=c;p=9}}else{o=c;p=7}}else{o=j;p=7}while(0);if((p|0)==7){j=a+16|0;y=(f[j>>2]|0)+(o<<2)|0;z=j;A=o;p=9}if((p|0)==9){o=xJa(a,n,f[y>>2]|0)|0;f[(f[z>>2]|0)+(A<<2)>>2]=o;w=A;x=z}if((b[n+11>>0]|0)<0)YDc(f[n>>2]|0);if(!(f[a+20>>2]|0))YDc(n);f[a>>2]=(f[a>>2]|0)+-1;n=a+12|0;if((w|0)!=(f[n>>2]|0)){u=d;return}z=f[a+4>>2]|0;if(w>>>0>=z>>>0){u=d;return}a=f[x>>2]|0;x=w;while(1){if(f[a+(x<<2)>>2]|0){p=23;break}x=x+1|0;f[n>>2]=x;if(x>>>0>=z>>>0){p=23;break}}if((p|0)==23){u=d;return}}function xJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=c+16|0;e=f[d>>2]|0;if((c|0)==(b|0))return e|0;else{g=xJa(a,b,e)|0;f[d>>2]=g;return c|0}return 0}function yJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=zJa(a,c,f[d>>2]|0,d)|0;if((e|0)==(d|0)){g=0;return g|0}d=f[c>>2]|0;c=f[e+16>>2]|0;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c+4>>2]|0:h&255;h=b[d+11>>0]|0;k=h<<24>>24<0;l=k?f[d+4>>2]|0:h&255;h=j>>>0<l>>>0?j:l;if((h|0)!=0?(m=Arc(k?f[d>>2]|0:d,i?f[c>>2]|0:c,h)|0,(m|0)!=0):0){if((m|0)<0){g=0;return g|0}}else n=4;if((n|0)==4?l>>>0<j>>>0:0){g=0;return g|0}j=f[e+4>>2]|0;if(!j){l=e+8|0;n=f[l>>2]|0;if((f[n>>2]|0)==(e|0))o=n;else{n=l;do{l=f[n>>2]|0;n=l+8|0;m=f[n>>2]|0}while((f[m>>2]|0)!=(l|0));o=m}}else{n=j;while(1){j=f[n>>2]|0;if(!j)break;else n=j}o=n}if((f[a>>2]|0)==(e|0))f[a>>2]=o;o=a+12|0;f[o>>2]=(f[o>>2]|0)+-1;uHa(f[a+4>>2]|0,e);if(f[a+8>>2]|0){g=1;return g|0}YDc(e);g=1;return g|0}function zJa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=f[c>>2]|0;c=b[a+11>>0]|0;h=c<<24>>24<0;i=h?f[a+4>>2]|0:c&255;if(h){h=e;c=d;a:while(1){j=c;while(1){k=f[j+16>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[k+4>>2]|0:l&255;l=i>>>0<n>>>0?i:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,f[a>>2]|0,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=7;if((p|0)==7?(p=0,n>>>0>=i>>>0):0)break;n=f[j+4>>2]|0;if(!n){g=h;p=17;break a}else j=n}c=f[j>>2]|0;if(!c){g=j;p=17;break}else h=j}if((p|0)==17)return g|0}else{h=e;e=d;b:while(1){d=e;while(1){c=f[d+16>>2]|0;n=b[c+11>>0]|0;o=n<<24>>24<0;l=o?f[c+4>>2]|0:n&255;n=i>>>0<l>>>0?i:l;if((n|0)!=0?(k=Arc(o?f[c>>2]|0:c,a,n)|0,(k|0)!=0):0){if((k|0)>=0)break}else p=13;if((p|0)==13?(p=0,l>>>0>=i>>>0):0)break;l=f[d+4>>2]|0;if(!l){g=h;p=17;break b}else d=l}e=f[d>>2]|0;if(!e){g=d;p=17;break}else h=d}if((p|0)==17)return g|0}return 0}function AJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a>>2]|0;c=b;if(!b){d=VDc(24)|0;f[d>>2]=0;f[d+8>>2]=d;e=d+16|0;f[e>>2]=0;f[d+20>>2]=c;g=VDc(32)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;h=g;i=d;j=e;f[j>>2]=h;k=i+12|0;f[k>>2]=8;l=i+4|0;f[l>>2]=8;m=a+8|0;f[m>>2]=i;return}e=b+64|0;if(f[e>>2]|0)OQb(b,14448,24);d=NQb(b,24,1732)|0;f[d>>2]=0;f[d+8>>2]=d;g=d+16|0;f[g>>2]=0;f[d+20>>2]=c;if(f[e>>2]|0)OQb(b,23824,32);e=MQb(b,32)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;h=e;i=d;j=g;f[j>>2]=h;k=i+12|0;f[k>>2]=8;l=i+4|0;f[l>>2]=8;m=a+8|0;f[m>>2]=i;return}function BJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[a+8>>2]|0;fEc(e,c);f[e+12>>2]=0;CJa(g,h,e);h=(f[g>>2]|0)+12|0;if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);e=f[h>>2]|0;if(e|0){i=e;j=i+16|0;u=d;return j|0}e=DJa(a,c)|0;f[h>>2]=e;i=e;j=i+16|0;u=d;return j|0}function CJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;bJa(g,c,d,0);i=f[g>>2]|0;if(i|0){j=f[g+4>>2]|0;k=f[g+8>>2]|0;f[a>>2]=i;f[a+4>>2]=j;f[a+8>>2]=k;b[a+12>>0]=0;u=e;return}k=(f[c>>2]|0)+1|0;j=f[c+4>>2]|0;i=j*12|0;l=i>>>4;if(l>>>0>k>>>0){if(j>>>0>8&i>>>6>>>0>=k>>>0){i=((k*5|0)>>>2)+1|0;k=1;while(1)if(i<<k>>>0<l>>>0)k=k+1|0;else break;l=j>>>k;k=l>>>0>8?l:8;if((k|0)!=(j|0)){GJa(c,k);m=11}}}else if(j>>>0<=134217728){GJa(c,j<<1);m=11}if((m|0)==11){bJa(h,c,d,0);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2]}m=f[g+12>>2]|0;g=f[c+20>>2]|0;if(!g)n=VDc(20)|0;else{if(f[g+64>>2]|0)OQb(g,23824,24);n=MQb(g,24)|0}fEc(n,d);f[n+12>>2]=f[d+12>>2];HJa(h,c,m,n);f[c>>2]=(f[c>>2]|0)+1;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];b[a+12>>0]=1;u=e;return}function DJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=VDc(40)|0;fEc(d,b);JNa(d+16|0);e=d;return e|0}if(f[c+64>>2]|0)OQb(c,23824,40);d=MQb(c,40)|0;c=f[a>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;EJa(c,d);KNa(d+16|0,f[a>>2]|0);iEc(d,b)|0;e=d;return e|0}function EJa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1733);return}function FJa(a){a=a|0;if((b[a+11>>0]|0)>=0)return;YDc(f[a>>2]|0);return}function GJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;i=a+4|0;j=f[i>>2]|0;f[i>>2]=c;k=a+20|0;l=f[k>>2]|0;m=c<<2;if(!l)n=VDc(m)|0;else{c=m+7&-8;if(f[l+64>>2]|0)OQb(l,23824,c);n=MQb(l,c)|0}XIc(n|0,0,m|0)|0;f[g>>2]=n;n=a+12|0;g=f[n>>2]|0;f[n>>2]=f[i>>2];if(g>>>0<j>>>0){n=a+8|0;m=g;do{g=f[h+(m<<2)>>2]|0;do if(!g)o=m;else{if((g|0)==(f[h+((m^1)<<2)>>2]|0)){OJa(a,h,m);o=m+1|0;break}c=g;do{l=c;c=f[c+16>>2]|0;p=(b[l+11>>0]|0)<0?f[l>>2]|0:l;q=b[p>>0]|0;if(!(q<<24>>24))r=0;else{s=p;p=0;t=q;while(1){q=(p*5|0)+(t<<24>>24)|0;s=s+1|0;t=b[s>>0]|0;if(!(t<<24>>24)){r=q;break}else p=q}}HJa(e,a,(f[i>>2]|0)+-1&(f[n>>2]|0)+r,l)}while((c|0)!=0);o=m}while(0);m=o+1|0}while(m>>>0<j>>>0)}if(f[k>>2]|0){u=d;return}YDc(h);u=d;return}function HJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;h=f[b+16>>2]|0;i=h+(c<<2)|0;j=f[i>>2]|0;k=j;do if(!j){f[d+16>>2]=k;f[i>>2]=d;l=d;m=b;n=c}else{if((j|0)==(f[h+((c^1)<<2)>>2]|0)){JJa(a,b,c,d);u=e;return}o=j;p=0;do{p=p+1|0;o=f[o+16>>2]|0}while((o|0)!=0);if(p>>>0>7){IJa(b,c);JJa(g,b,c,d);l=f[g>>2]|0;m=f[g+4>>2]|0;n=f[g+8>>2]|0;break}f[d+16>>2]=k;f[i>>2]=d;f[a>>2]=d;f[a+4>>2]=b;f[a+8>>2]=c;u=e;return}while(0);c=b+12|0;b=f[c>>2]|0;f[c>>2]=n>>>0<b>>>0?n:b;f[a>>2]=l;f[a+4>>2]=m;f[a+8>>2]=n;u=e;return}function IJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c+16|0;e=c;g=a+20|0;h=f[g>>2]|0;f[d>>2]=h;i=h;if(!h)j=VDc(16)|0;else{if(f[i+64>>2]|0)OQb(i,23824,16);j=MQb(i,16)|0}i=f[g>>2]|0;f[e+4>>2]=0;f[e+8>>2]=i;f[e+12>>2]=0;i=e+4|0;f[e>>2]=i;LJa(d,j,e);uJa(e,f[i>>2]|0);MJa(a,b,j)|0;i=b^1;MJa(a,i,j)|0;e=a+16|0;f[(f[e>>2]|0)+(i<<2)>>2]=j;f[(f[e>>2]|0)+(b<<2)>>2]=j;u=c;return}function JJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+4|0;h=e;f[d+16>>2]=0;i=f[(f[b+16>>2]|0)+(c<<2)>>2]|0;f[h>>2]=d;d=KJa(i,g,h)|0;j=f[d>>2]|0;if(j|0){k=j;l=c&-2;m=k+16|0;n=f[m>>2]|0;f[a>>2]=n;o=a+4|0;f[o>>2]=b;p=a+8|0;f[p>>2]=l;u=e;return}j=f[i+8>>2]|0;if(!j)q=VDc(20)|0;else{if(f[j+64>>2]|0)OQb(j,23824,24);q=MQb(j,24)|0}f[q+16>>2]=f[h>>2];h=f[g>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=h;f[d>>2]=q;h=f[f[i>>2]>>2]|0;if(!h)r=q;else{f[i>>2]=h;r=f[d>>2]|0}laa(f[i+4>>2]|0,r);r=i+12|0;f[r>>2]=(f[r>>2]|0)+1;k=q;l=c&-2;m=k+16|0;n=f[m>>2]|0;f[a>>2]=n;o=a+4|0;f[o>>2]=b;p=a+8|0;f[p>>2]=l;u=e;return}function KJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=a+4|0;g=f[e>>2]|0;h=a+4|0;if(!g){f[c>>2]=e;i=e;return i|0}e=f[d>>2]|0;d=b[e+11>>0]|0;a=d<<24>>24<0;j=f[e+4>>2]|0;k=d&255;d=a?j:k;a:do if(a){l=h;m=g;while(1){n=f[m+16>>2]|0;o=b[n+11>>0]|0;p=o<<24>>24<0;q=p?f[n+4>>2]|0:o&255;o=q>>>0<d>>>0?q:d;if((o|0)!=0?(r=Arc(f[e>>2]|0,p?f[n>>2]|0:n,o)|0,(r|0)!=0):0)if((r|0)<0)s=12;else s=7;else if(d>>>0<q>>>0)s=12;else s=7;if((s|0)==7){s=0;r=j>>>0<q>>>0?j:q;if((r|0)!=0?(o=Arc(p?f[n>>2]|0:n,f[e>>2]|0,r)|0,(o|0)!=0):0){if((o|0)>=0){t=l;u=m;s=27;break a}}else s=10;if((s|0)==10?(s=0,q>>>0>=j>>>0):0){t=l;u=m;s=27;break a}q=m+4|0;o=f[q>>2]|0;if(!o){v=m;w=q;s=26;break a}else{x=q;y=o}}else if((s|0)==12){s=0;o=f[m>>2]|0;if(!o){z=m;A=m;s=20;break a}else{x=m;y=o}}l=x;m=y}}else{m=h;l=g;while(1){o=f[l+16>>2]|0;q=b[o+11>>0]|0;r=q<<24>>24<0;n=r?f[o+4>>2]|0:q&255;q=n>>>0<d>>>0?n:d;if((q|0)!=0?(p=Arc(e,r?f[o>>2]|0:o,q)|0,(p|0)!=0):0)if((p|0)<0)s=19;else s=21;else if(d>>>0<n>>>0)s=19;else s=21;if((s|0)==19){s=0;p=f[l>>2]|0;if(!p){z=l;A=l;s=20;break a}else{B=l;C=p}}else if((s|0)==21){s=0;p=k>>>0<n>>>0?k:n;if((p|0)!=0?(q=Arc(r?f[o>>2]|0:o,e,p)|0,(q|0)!=0):0){if((q|0)>=0){t=m;u=l;s=27;break a}}else s=23;if((s|0)==23?(s=0,n>>>0>=k>>>0):0){t=m;u=l;s=27;break a}n=l+4|0;q=f[n>>2]|0;if(!q){v=l;w=n;s=26;break a}else{B=n;C=q}}m=B;l=C}}while(0);if((s|0)==20){f[c>>2]=z;i=A;return i|0}else if((s|0)==26){f[c>>2]=v;i=w;return i|0}else if((s|0)==27){f[c>>2]=u;i=t;return i|0}return 0}function LJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=u;u=u+16|0;d=a+12|0;e=a+8|0;g=a+4|0;h=a;f[b>>2]=0;i=f[c+8>>2]|0;j=b+4|0;f[j>>2]=0;f[b+8>>2]=i;i=b+12|0;f[i>>2]=0;k=b+4|0;f[b>>2]=k;l=f[c>>2]|0;m=c+4|0;if((l|0)==(m|0)){u=a;return}c=k;k=b+8|0;n=l;while(1){l=n+16|0;f[h>>2]=c;f[d>>2]=f[h>>2];o=NJa(b,d,e,g,l)|0;if(!(f[o>>2]|0)){p=f[k>>2]|0;if(!p)q=VDc(20)|0;else{if(f[p+64>>2]|0)OQb(p,23824,24);q=MQb(p,24)|0}f[q+16>>2]=f[l>>2];l=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=l;f[o>>2]=q;l=f[f[b>>2]>>2]|0;if(!l)r=q;else{f[b>>2]=l;r=f[o>>2]|0}laa(f[j>>2]|0,r);f[i>>2]=(f[i>>2]|0)+1}o=f[n+4>>2]|0;if(!o){l=n+8|0;p=f[l>>2]|0;if((f[p>>2]|0)==(n|0))s=p;else{p=l;do{l=f[p>>2]|0;p=l+8|0;t=f[p>>2]|0}while((f[t>>2]|0)!=(l|0));s=t}}else{p=o;while(1){t=f[p>>2]|0;if(!t)break;else p=t}s=p}if((s|0)==(m|0))break;else n=s}u=a;return}function MJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;h=f[(f[a+16>>2]|0)+(b<<2)>>2]|0;if(!h){i=0;u=d;return i|0}b=c+8|0;a=c+4|0;j=c+12|0;k=h;h=0;while(1){f[g>>2]=k;l=KJa(c,e,g)|0;if(!(f[l>>2]|0)){m=f[b>>2]|0;if(!m)n=VDc(20)|0;else{if(f[m+64>>2]|0)OQb(m,23824,24);n=MQb(m,24)|0}f[n+16>>2]=f[g>>2];m=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=m;f[l>>2]=n;m=f[f[c>>2]>>2]|0;if(!m)o=n;else{f[c>>2]=m;o=f[l>>2]|0}laa(f[a>>2]|0,o);f[j>>2]=(f[j>>2]|0)+1}l=h+1|0;m=k+16|0;k=f[m>>2]|0;f[m>>2]=0;if(!k){i=l;break}else h=l}u=d;return i|0}function NJa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=f[g>>2]|0;k=f[i+16>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[k+4>>2]|0:l&255;l=b[j+11>>0]|0;o=l<<24>>24<0;p=o?f[j+4>>2]|0:l&255;l=n>>>0<p>>>0;q=l?n:p;if((q|0)!=0?(r=Arc(o?f[j>>2]|0:j,m?f[k>>2]|0:k,q)|0,(r|0)!=0):0){if((r|0)<0)break}else s=4;if((s|0)==4?p>>>0<n>>>0:0)break;r=p>>>0<n>>>0?p:n;if((r|0)!=0?(n=Arc(m?f[k>>2]|0:k,o?f[j>>2]|0:j,r)|0,(n|0)!=0):0){if((n|0)>=0)s=36}else s=20;if((s|0)==20?!l:0)s=36;if((s|0)==36){f[d>>2]=c;f[e>>2]=c;t=e;return t|0}l=i+4|0;n=f[l>>2]|0;if(!n){r=i+8|0;k=f[r>>2]|0;if((f[k>>2]|0)==(i|0))u=k;else{k=r;do{r=f[k>>2]|0;k=r+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(r|0));u=m}}else{k=n;while(1){m=f[k>>2]|0;if(!m)break;else k=m}u=k}do if((u|0)!=(h|0)){n=f[u+16>>2]|0;m=b[n+11>>0]|0;r=m<<24>>24<0;q=r?f[n+4>>2]|0:m&255;m=q>>>0<p>>>0?q:p;if((m|0)!=0?(v=Arc(o?f[j>>2]|0:j,r?f[n>>2]|0:n,m)|0,(v|0)!=0):0){if((v|0)<0)break}else s=30;if((s|0)==30?p>>>0<q>>>0:0)break;t=KJa(a,d,g)|0;return t|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;t=l;return t|0}else{f[d>>2]=u;t=u;return t|0}}while(0);u=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))w=c;else{if(!u){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{x=e;break}}}else{h=u;while(1){l=f[h+4>>2]|0;if(!l){x=h;break}else h=l}}h=x;l=f[x+16>>2]|0;e=f[g>>2]|0;p=b[e+11>>0]|0;j=p<<24>>24<0;o=j?f[e+4>>2]|0:p&255;p=b[l+11>>0]|0;k=p<<24>>24<0;q=k?f[l+4>>2]|0:p&255;p=o>>>0<q>>>0?o:q;if((p|0)!=0?(v=Arc(k?f[l>>2]|0:l,j?f[e>>2]|0:e,p)|0,(v|0)!=0):0){if((v|0)<0){w=h;break}}else s=12;if((s|0)==12?q>>>0<o>>>0:0){w=h;break}t=KJa(a,d,g)|0;return t|0}while(0);if(!u){f[d>>2]=i;t=i;return t|0}else{i=w;f[d>>2]=i;t=i+4|0;return t|0}return 0}function OJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=f[c+(d<<2)>>2]|0;d=a+8|0;c=a+4|0;i=h+4|0;j=f[h>>2]|0;while(1){k=f[j+16>>2]|0;l=(b[k+11>>0]|0)<0?f[k>>2]|0:k;m=b[l>>0]|0;if(!(m<<24>>24))n=0;else{o=l;l=0;p=m;while(1){m=(l*5|0)+(p<<24>>24)|0;o=o+1|0;p=b[o>>0]|0;if(!(p<<24>>24)){n=m;break}else l=m}}HJa(g,a,(f[c>>2]|0)+-1&(f[d>>2]|0)+n,k);l=f[j+4>>2]|0;if(!l){p=j+8|0;o=f[p>>2]|0;if((f[o>>2]|0)==(j|0))q=o;else{o=p;do{p=f[o>>2]|0;o=p+8|0;m=f[o>>2]|0}while((f[m>>2]|0)!=(p|0));q=m}}else{o=l;while(1){k=f[o>>2]|0;if(!k)break;else o=k}q=o}if((q|0)==(i|0))break;else j=q}q=f[a+20>>2]|0;uJa(h,f[i>>2]|0);if(q|0){u=e;return}YDc(h);u=e;return}function PJa(a){a=a|0;var b=0;b=a+16|0;if(!(f[b>>2]|0))return;tJa(a);if(f[a+20>>2]|0)return;YDc(f[b>>2]|0);return}function QJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=g?f[c>>2]|0:c;c=j+h|0;if(c>>>0>4294967279)dEc(a);if(c>>>0<11){b[a+11>>0]=h;k=a}else{g=c+16&-16;c=VDc(g)|0;f[a>>2]=c;f[a+8>>2]=g|-2147483648;f[a+4>>2]=h;k=c}if(!h){l=k+h|0;b[l>>0]=0;m=f[d>>2]|0;n=i?m:d;tEc(a,n,j)|0;return}dJc(k|0,e|0,h|0)|0;l=k+h|0;b[l>>0]=0;m=f[d>>2]|0;n=i?m:d;tEc(a,n,j)|0;return}function RJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;a:do if(c|0){d=a+4|0;e=f[b>>2]|0;g=(e|0)==0?1154740:e;h=f[c+16>>2]|0;if((e|0)==(h|0)){i=d;j=f[i>>2]|0;k=j+24|0;return k|0}else{l=d;m=c;n=h}while(1){h=(n|0)==0?1154740:n;if((Ioc(g,h)|0)<0){d=f[m>>2]|0;if(!d)break a;else{o=m;p=d}}else{if((Ioc(h,g)|0)>=0){i=l;q=9;break}h=m+4|0;d=f[h>>2]|0;if(!d)break a;else{o=h;p=d}}n=f[p+16>>2]|0;if((e|0)==(n|0)){i=o;q=9;break}else{l=o;m=p}}if((q|0)==9){j=f[i>>2]|0;k=j+24|0;return k|0}}while(0);k=af(8)|0;bEc(k,385712);f[k>>2]=185552;ig(k|0,23712,1627);return 0}function SJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/12|0;h=g+1|0;i=e;j=d;if(h>>>0>357913941)mCc(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/12|0;e=l<<1;m=l>>>0<178956970?(e>>>0<h>>>0?h:e):357913941;do if(m)if(m>>>0>357913941){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{n=VDc(m*12|0)|0;break}else n=0;while(0);e=n+(g*12|0)|0;h=e;l=n+(m*12|0)|0;m=f[b>>2]|0;f[e>>2]=m;f[n+(g*12|0)+4>>2]=f[b+4>>2];if(!m){o=j;p=i;q=d}else{d=m+-4|0;f[d>>2]=(f[d>>2]|0)+1;d=f[c>>2]|0;o=d;p=f[a>>2]|0;q=d}f[n+(g*12|0)+8>>2]=f[b+8>>2];b=e+12|0;if((o|0)==(p|0)){r=h;s=o;t=q}else{q=o;o=h;h=e;do{e=q;q=q+-12|0;g=f[q>>2]|0;f[h+-12>>2]=g;f[h+-8>>2]=f[e+-8>>2];if(g|0){n=g+-4|0;f[n>>2]=(f[n>>2]|0)+1}f[h+-4>>2]=f[e+-4>>2];h=o+-12|0;o=h}while((q|0)!=(p|0));r=o;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=b;f[k>>2]=l;l=s;k=t;while(1){t=k;if((t|0)==(l|0))break;b=t+-12|0;uT(b);k=b}if(!s)return;YDc(s);return}function TJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;bJa(d,f[a+8>>2]|0,b,0);a=f[d>>2]|0;if(a|0){g=a+12|0;h=f[g>>2]|0;i=h+16|0;u=c;return i|0}rTb(e,3,385092,1064);oTb(c+40|0,nTb(mTb(mTb(e,385173)|0,385201)|0,b)|0);sTb(e);g=a+12|0;h=f[g>>2]|0;i=h+16|0;u=c;return i|0}function UJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;if((f[b>>2]|0)==8){c=f[a+8>>2]|0;return c|0}nNa(a);f[b>>2]=8;b=f[a+4>>2]|0;d=b&-2;if(!(b&1))e=d;else e=f[d+4>>2]|0;if(!e){d=VDc(172)|0;bTa(d);g=d}else{if(f[e+64>>2]|0)OQb(e,14936,176);d=MQb(e,176)|0;cTa(d,e);g=d}f[a+8>>2]=g;c=g;return c|0}function VJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(d>>>0>4294967279)dEc(g);if(d>>>0<11){b[g+11>>0]=d;if(!d)h=g;else{i=g;j=6}}else{k=d+16&-16;l=VDc(k)|0;f[g>>2]=l;f[g+8>>2]=k|-2147483648;f[g+4>>2]=d;i=l;j=6}if((j|0)==6){dJc(i|0,c|0,d|0)|0;h=i}b[h+d>>0]=0;d=f[a+4>>2]|0;h=d&-2;if(!(d&1))m=h;else m=f[h+4>>2]|0;h=a+152|0;a=f[h>>2]|0;if((a|0)==527320)WJa(h,m,g);else iEc(a,g)|0;if((b[g+11>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function WJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=VDc(12)|0;fEc(d,c);f[a>>2]=d;if(!b)return;XJa(b,d);return}function XJa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1734);return}function YJa(a){a=a|0;if(!a)return;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(a);return}function ZJa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+112|0;h=g+8|0;i=g;aRa(h);j=h+40|0;aRa(j);f[h+80>>2]=0;k=h+84|0;f[k>>2]=0;f[h+88>>2]=0;if((b|0)!=0&(c|0)!=0)cKa(b,c,h);if((d|0)!=0&(e|0)!=0)eKa(d,e,j);tFa(a);e=f[a>>2]|0;f[i>>2]=e;f[i+4>>2]=f[a+4>>2];if(e|0){a=e+4|0;f[a>>2]=(f[a>>2]|0)+1}SIa(h,i);fGa(i);i=h+80|0;a=f[i>>2]|0;if(!a){mPa(j);mPa(h);u=g;return}while(1){e=f[k>>2]|0;if((e|0)==(a|0))break;d=e+-8|0;f[k>>2]=d;uT(d)}YDc(f[i>>2]|0);mPa(j);mPa(h);u=g;return}function _Ja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[b>>2]|0;e=f[c>>2]|0;g=f[c+4>>2]|0;ZJa(a,d,(f[b+4>>2]|0)-d|0,(e|0)==(g|0)?0:e,g-e|0);return}function $Ja(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=u;u=u+176|0;e=d;aKa(e,386317,386391,42,392070,394277,kMa(a,c)|0);c=e+21|0;f=e+32|0;while(1){if(!(b[c>>0]|0))break;g=H1(f,386426,31)|0;H1(g,a,Mpc(a)|0)|0;bKa(e)}K1(e+24|0);u=d;return}function aKa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=g;f[a+12>>2]=h;f[a+16>>2]=e;b[a+20>>0]=i&1;b[a+21>>0]=1;i=a+24|0;e=a+88|0;h=a+32|0;f[h>>2]=45704;g=a+36|0;f[i>>2]=6980;f[e>>2]=7e3;f[a+28>>2]=0;auc(a+88|0,g);f[a+160>>2]=0;f[a+164>>2]=-1;f[i>>2]=45684;f[e>>2]=45724;f[h>>2]=45704;fuc(g);f[g>>2]=45740;h=a+68|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[a+84>>2]=24;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;G1(g,k);if((b[k+11>>0]|0)>=0){u=j;return}YDc(f[k>>2]|0);u=j;return}function bKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+48|0;d=c+40|0;e=c+32|0;g=c+24|0;h=c+16|0;i=c;b[a+21>>0]=0;j=f[a+12>>2]|0;if(!j){u=c;return}if(b[a+20>>0]|0){u=c;return}f[h>>2]=0;k=h+4|0;f[k>>2]=0;l=Mpc(j)|0;if(!l)m=0;else{dJc(tT(h,l)|0,j|0,l|0)|0;m=f[k>>2]|0}f[g>>2]=0;l=g+4|0;f[l>>2]=0;tT(g,m+8|0)|0;m=f[g>>2]|0;j=m;b[j>>0]=70;b[j+1>>0]=65;b[j+2>>0]=73;b[j+3>>0]=76;j=m+4|0;b[j>>0]=69;b[j+1>>0]=68;b[j+2>>0]=58;b[j+3>>0]=32;j=f[k>>2]|0;if(j|0)dJc((f[g>>2]|0)+8|0,f[h>>2]|0,j|0)|0;f[e>>2]=0;j=e+4|0;f[j>>2]=0;tT(e,(f[l>>2]|0)+2|0)|0;k=f[l>>2]|0;if(!k)n=0;else{dJc(f[e>>2]|0,f[g>>2]|0,k|0)|0;n=f[l>>2]|0}l=(f[e>>2]|0)+n|0;b[l>>0]=46;b[l+1>>0]=32;I1(i,a+36|0);f[d>>2]=0;f[d+4>>2]=0;l=i+11|0;n=b[l>>0]|0;k=n<<24>>24<0?f[i+4>>2]|0:n&255;tT(d,(f[j>>2]|0)+k|0)|0;n=f[j>>2]|0;if(n|0)dJc(f[d>>2]|0,f[e>>2]|0,n|0)|0;if(k|0)dJc((f[d>>2]|0)+(f[j>>2]|0)|0,((b[l>>0]|0)<0?f[i>>2]|0:i)|0,k|0)|0;z5(-2,d,f[a+4>>2]|0,f[a>>2]|0,f[a+16>>2]|0);uT(d);if((b[l>>0]|0)<0)YDc(f[i>>2]|0);uT(e);uT(g);uT(h);u=c;return}function cKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+176|0;f=e;aKa(f,386317,386458,48,392070,394355,mMa(a,c,d)|0);d=f+21|0;c=f+32|0;while(1){if(!(b[d>>0]|0))break;H1(c,386495,31)|0;bKa(f)}K1(f+24|0);u=e;return}function dKa(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=u;u=u+176|0;e=d;aKa(e,386317,386527,54,392070,394042,jMa(a,c)|0);c=e+21|0;f=e+32|0;while(1){if(!(b[c>>0]|0))break;g=H1(f,386426,31)|0;H1(g,a,Mpc(a)|0)|0;bKa(e)}K1(e+24|0);u=d;return}function eKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+176|0;f=e;aKa(f,386317,386560,60,392070,394152,lMa(a,c,d)|0);d=f+21|0;c=f+32|0;while(1){if(!(b[d>>0]|0))break;H1(c,386495,31)|0;bKa(f)}K1(f+24|0);u=e;return}function fKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;tFa(a);h=a+8|0;f[h>>2]=0;i=a+12|0;f[i>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+16>>2]=a+20;f[a+32>>2]=0;f[a+36>>2]=0;f[a+28>>2]=a+32;f[a+44>>2]=0;f[a+48>>2]=0;f[a+40>>2]=a+44;j=a+52|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=f[c>>2]|0;a=f[c+4>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(a>>>0>4294967279)dEc(g);if(a>>>0<11){b[g+11>>0]=a;if(!a)k=g;else{l=g;m=6}}else{c=a+16&-16;n=VDc(c)|0;f[g>>2]=n;f[g+8>>2]=c|-2147483648;f[g+4>>2]=a;l=n;m=6}if((m|0)==6){dJc(l|0,j|0,a|0)|0;k=l}b[k+a>>0]=0;a=Qob(g,393937,0)|0;if(!a){o=0;p=0;q=0;r=1}else{k=VDc(16)|0;f[k+4>>2]=1;f[k>>2]=78588;f[k+8>>2]=a;f[k+12>>2]=1735;l=k+4|0;f[l>>2]=(f[l>>2]|0)+1;o=k;p=k;q=k;r=0}k=f[h>>2]|0;f[h>>2]=o;f[i>>2]=a;if(k|0?(a=k+4|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0)Yi[f[(f[k>>2]|0)+8>>2]&2047](k);if(!r?(r=p+4|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)Yi[f[(f[p>>2]|0)+8>>2]&2047](q);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);q=f[i>>2]|0;if(!q){f[g>>2]=0;s=g+4|0;f[s>>2]=0;t=tT(g,29)|0;v=t;w=389230;x=v+29|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,g,389260,386595,141)}if(!(VKa(q)|0)){f[g>>2]=0;s=g+4|0;f[s>>2]=0;t=tT(g,29)|0;v=t;w=389230;x=v+29|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));z5(-215,g,389260,386595,141)}g=f[i>>2]|0;if(d){WKa(g);u=e;return}else{XKa(g);u=e;return}}function gKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c;e=c+8|0;g=a+12|0;switch(YKa(f[g>>2]|0)|0){case 4:{h=YKa(f[g>>2]|0)|0;jKa(a,h);i=a+16|0;j=a+20|0;k=f[j>>2]|0;do if(k){l=a+20|0;m=k;while(1){n=f[m+16>>2]|0;if((h|0)<(n|0)){o=f[m>>2]|0;if(!o){p=7;break}else{q=m;r=o}}else{if((n|0)>=(h|0)){p=11;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=10;break}else{q=s;r=n}}l=q;m=r}if((p|0)==7){t=m;v=m;break}else if((p|0)==10){t=s;v=m;break}else if((p|0)==11){t=l;v=m;break}}else{t=j;v=j}while(0);if(f[t>>2]|0){u=c;return}j=VDc(20)|0;f[j+16>>2]=h;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[i>>2]>>2]|0;if(!v)w=j;else{f[i>>2]=v;w=f[t>>2]|0}laa(f[a+20>>2]|0,w);w=a+24|0;f[w>>2]=(f[w>>2]|0)+1;u=c;return}case 1:{+_Ka(f[g>>2]|0);u=c;return}case 5:{YKa(f[g>>2]|0)|0;u=c;return}case 2:{w=YKa(f[g>>2]|0)|0;f[d>>2]=0;f[d+4>>2]=0;if(!w)x=0;else{XIc(tT(d,w)|0,0,w|0)|0;x=f[d>>2]|0}MKa(f[g>>2]|0,(x|0)==0?1154740:x,w)|0;uT(d);u=c;return}case 3:{kKa(a,-1);u=c;return}case 0:{u=c;return}default:{f[e>>2]=0;f[e+4>>2]=0;c=tT(e,20)|0;a=386673;d=c+20|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(d|0));z5(-213,e,386694,386595,1019)}}}function hKa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+52>>2]|0;if(b|0){c=a+56|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);YDc(b)}iKa(a+40|0,f[a+44>>2]|0);iKa(a+28|0,f[a+32>>2]|0);GFa(a+16|0,f[a+20>>2]|0);b=a+8|0;d=f[b>>2]|0;if(!d){f[b>>2]=0;e=a+12|0;f[e>>2]=0;fGa(a);return}c=d+4|0;g=f[c>>2]|0;f[c>>2]=g+-1;if((g|0)!=1){f[b>>2]=0;e=a+12|0;f[e>>2]=0;fGa(a);return}Yi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;e=a+12|0;f[e>>2]=0;fGa(a);return}function iKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!b)return;iKa(a,f[b>>2]|0);iKa(a,f[b+4>>2]|0);a=b+20|0;c=b+56|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)_S(a);f[c>>2]=0;c=b+36|0;a=b+24|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[b+60>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[b+64>>2]|0;if((a|0)!=(b+68|0))g0(a);YDc(b);return}function jKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0;d=u;u=u+736|0;e=d+712|0;g=d+720|0;h=d+704|0;i=d+692|0;j=d+680|0;k=d+672|0;l=d+616|0;m=d+560|0;o=d+504|0;q=d;r=d+232|0;s=d+488|0;t=d+8|0;v=d+480|0;w=d+472|0;x=d+464|0;y=d+456|0;f[e>>2]=c;z=a+16|0;A=a+20|0;B=f[A>>2]|0;a:do if(B|0){C=B;while(1){D=f[C+16>>2]|0;if((D|0)>(c|0))E=C;else{if((D|0)>=(c|0))break;E=C+4|0}C=f[E>>2]|0;if(!C)break a}u=d;return}while(0);lKa(g,a);f[h>>2]=0;E=h+4|0;f[E>>2]=0;c=mKa(g,386705,386712)|0;do if((c|0)>-1)nKa(a,f[e>>2]|0,c);else{B=mKa(g,386719,386712)|0;if((B|0)>-1){oKa(a,f[e>>2]|0,B);break}if(!(pKa(g,h)|0)){f[j>>2]=0;B=j+4|0;f[B>>2]=0;C=g+4|0;tT(j,(f[C>>2]|0)+25|0)|0;D=f[j>>2]|0;F=D;G=388716;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=f[C>>2]|0;if(I|0)dJc(D+25|0,f[g>>2]|0,I|0)|0;f[i>>2]=0;f[i+4>>2]=0;tT(i,(f[B>>2]|0)+1|0)|0;I=f[B>>2]|0;if(!I){K=0;L=f[i>>2]|0;M=L+K|0;b[M>>0]=34;z5(-213,i,386920,386595,992)}dJc(f[i>>2]|0,f[j>>2]|0,I|0)|0;K=f[B>>2]|0;L=f[i>>2]|0;M=L+K|0;b[M>>0]=34;z5(-213,i,386920,386595,992)}f[i+4>>2]=0;f[i+8>>2]=0;I=i+4|0;f[i>>2]=I;f[j+4>>2]=0;f[j+8>>2]=0;N=j+4|0;f[j>>2]=N;O=VDc(68)|0;f[l>>2]=0;P=l+4|0;f[P>>2]=0;Q=f[h>>2]|0;f[O>>2]=Q;f[O+4>>2]=f[E>>2];if(Q){R=Q+-4|0;f[R>>2]=(f[R>>2]|0)+1;R=f[l>>2]|0;Q=f[P>>2]|0;f[O+8>>2]=R;f[O+12>>2]=Q;if(R|0){Q=R+-4|0;f[Q>>2]=(f[Q>>2]|0)+1}}else{f[O+8>>2]=0;f[O+12>>2]=0}Q=O+20|0;f[Q>>2]=0;f[O+24>>2]=0;f[O+16>>2]=Q;F=O+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));B=VDc(16)|0;f[B+4>>2]=1;f[B>>2]=78548;f[B+8>>2]=O;f[k>>2]=B;B=k+4|0;f[B>>2]=O;uT(l);D=f[B>>2]|0;C=D+16|0;f[l>>2]=0;f[l+4>>2]=0;F=tT(l,11)|0;G=386727;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));$Ha(C,l,e)|0;uT(l);O=f[h>>2]|0;b:do if((((((((O|0)!=386739?(Q=(O|0)==0?1154740:O,!((Ioc(Q,386739)|0)==0|(O|0)==386750)):0)?!((Ioc(Q,386750)|0)==0|(O|0)==454781):0)?!((Ioc(Q,454781)|0)==0|(O|0)==386759):0)?!((Ioc(Q,386759)|0)==0|(O|0)==386771):0)?!((Ioc(Q,386771)|0)==0|(O|0)==386781):0)?!((Ioc(Q,386781)|0)==0|(O|0)==386793):0)?(Ioc(Q,386793)|0)!=0:0){if(((O|0)!=386844?!((Ioc(Q,386844)|0)==0|(O|0)==386863):0)?Ioc(Q,386863)|0:0){do if((O|0)!=386980){if(!(Ioc(Q,386980)|0))break;do if((O|0)!=386997){if((Ioc(Q,386997)|0)==0|(O|0)==387015)break;if(!(Ioc(Q,387015)|0))break;do if((O|0)!=387117){if(!(Ioc(Q,387117)|0))break;do if((O|0)!=426093){if((Ioc(Q,426093)|0)==0|(O|0)==387124)break;if(!(Ioc(Q,387124)|0))break;do if((O|0)!=393771){if(!(Ioc(Q,393771)|0))break;do if((O|0)!=387164){if(!(Ioc(Q,387164)|0))break;do if((O|0)!=425655){if(!(Ioc(Q,425655)|0))break;do if((O|0)!=387169){if((Ioc(Q,387169)|0)==0|(O|0)==387195)break;if((Ioc(Q,387195)|0)==0|(O|0)==387217)break;if(!(Ioc(Q,387217)|0))break;do if((O|0)!=425649){if(!(Ioc(Q,425649)|0))break;do if((O|0)!=387432){if((Ioc(Q,387432)|0)==0|(O|0)==429297)break;if(!(Ioc(Q,429297)|0))break;do if((O|0)!=429288){if((Ioc(Q,429288)|0)==0|(O|0)==387469)break;if(!(Ioc(Q,387469)|0))break;do if((O|0)!=425739){if(!(Ioc(Q,425739)|0))break;do if((O|0)!=425755){if(!(Ioc(Q,425755)|0))break;do if((O|0)!=387590){if(!(Ioc(Q,387590)|0))break;do if((O|0)!=387600){if(!(Ioc(Q,387600)|0))break;do if((O|0)!=387932){if(!(Ioc(Q,387932)|0))break;do if((O|0)!=388197){if(!(Ioc(Q,388197)|0))break;do if((O|0)!=388247){if(!(Ioc(Q,388247)|0))break;do if((O|0)!=388255){if(!(Ioc(Q,388255)|0))break;do if((O|0)!=388266){if(!(Ioc(Q,388266)|0))break;do if((O|0)!=427617){if((Ioc(Q,427617)|0)==0|(O|0)==388358)break;if((Ioc(Q,388358)|0)==0|(O|0)==451285)break;if(!(Ioc(Q,451285)|0))break;do if((O|0)!=388367){if(!(Ioc(Q,388367)|0))break;do if((O|0)!=388431){if((Ioc(Q,388431)|0)==0|(O|0)==388450)break;if(!(Ioc(Q,388450)|0))break;do if((O|0)!=388634){if(!(Ioc(Q,388634)|0))break;do if((O|0)!=388645){if(!(Ioc(Q,388645)|0))break;rKa(a,i,j);R=f[i>>2]|0;if((R|0)!=(I|0)){P=R;while(1){bIa(C,P+16|0,P+24|0)|0;R=f[P+4>>2]|0;do if(!R){S=P+8|0;T=f[S>>2]|0;if((f[T>>2]|0)==(P|0)){U=T;break}else V=S;do{S=f[V>>2]|0;V=S+8|0;T=f[V>>2]|0}while((f[T>>2]|0)!=(S|0));U=T}else{T=R;while(1){S=f[T>>2]|0;if(!S)break;else T=S}U=T}while(0);if((U|0)==(I|0))break;else P=U}}P=f[j>>2]|0;if((P|0)!=(N|0)){R=D+32|0;S=D+36|0;W=D+28|0;X=P;while(1){P=X+28|0;Z=f[R>>2]|0;if((Z|0)==(f[S>>2]|0))Bxa(W,P);else{f[Z>>2]=f[P>>2];_=Z+4|0;$=X+32|0;f[_>>2]=f[$>>2];aa=Z+8|0;f[aa>>2]=f[X+36>>2];f[Z+12>>2]=f[X+40>>2];f[Z+16>>2]=f[X+44>>2];f[Z+20>>2]=f[X+48>>2];f[Z+24>>2]=f[X+52>>2];f[Z+28>>2]=f[X+56>>2];f[Z+32>>2]=f[X+60>>2];ba=f[X+64>>2]|0;f[Z+36>>2]=ba;f[Z+40>>2]=aa;aa=Z+48|0;ca=Z+44|0;f[ca>>2]=aa;f[aa>>2]=0;f[Z+52>>2]=0;if(ba|0){aa=ba+12|0;f[aa>>2]=(f[aa>>2]|0)+1}if((f[$>>2]|0)<3){$=f[X+72>>2]|0;aa=f[ca>>2]|0;f[aa>>2]=f[$>>2];f[aa+4>>2]=f[$+4>>2]}else{f[_>>2]=0;ZS(Z,P)}f[R>>2]=(f[R>>2]|0)+56}P=f[X+4>>2]|0;do if(!P){Z=X+8|0;_=f[Z>>2]|0;if((f[_>>2]|0)==(X|0)){da=_;break}else ea=Z;do{Z=f[ea>>2]|0;ea=Z+8|0;_=f[ea>>2]|0}while((f[_>>2]|0)!=(Z|0));da=_}else{T=P;while(1){_=f[T>>2]|0;if(!_)break;else T=_}da=T}while(0);if((da|0)==(N|0))break;else X=da}}X=f[B>>2]|0;R=X+8|0;if((h|0)!=(R|0)){uT(R);W=f[h>>2]|0;if(!W)fa=0;else{S=W+-4|0;f[S>>2]=(f[S>>2]|0)+1;fa=f[h>>2]|0}f[R>>2]=fa;f[X+12>>2]=f[E>>2]}X=f[a+68>>2]|0;R=X+60|0;S=f[R>>2]|0;if((S|0)==(f[X+64>>2]|0)){qKa(X+56|0,k);break b}X=f[k>>2]|0;f[S>>2]=X;f[S+4>>2]=f[B>>2];if(!X)ga=S;else{S=X+4|0;f[S>>2]=(f[S>>2]|0)+1;ga=f[R>>2]|0}f[R>>2]=ga+8;break b}while(0);rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,12)|0;G=388670;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));R=f[I>>2]|0;if(!R){uT(l);f[l>>2]=0;ha=l+4|0;f[ha>>2]=0;ia=tT(l,32)|0;F=ia;G=388683;H=F+32|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,964)}S=f[l>>2]|0;X=(S|0)==0?1154740:S;W=R;while(1){P=f[W+16>>2]|0;if((S|0)==(P|0)){ja=1154;break}_=(P|0)==0?1154740:P;if((Ioc(X,_)|0)<0)ka=W;else{if((Ioc(_,X)|0)>=0){ja=1158;break}ka=W+4|0}W=f[ka>>2]|0;if(!W){ja=1156;break}}if((ja|0)==1154)uT(l);else if((ja|0)==1156){uT(l);f[l>>2]=0;ha=l+4|0;f[ha>>2]=0;ia=tT(l,32)|0;F=ia;G=388683;H=F+32|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,964)}else if((ja|0)==1158)uT(l);f[m>>2]=0;f[m+4>>2]=0;F=tT(m,12)|0;G=388670;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));W=DHa(lIa(i,m)|0,-1)|0;uT(m);f[l>>2]=W;W=(f[B>>2]|0)+8|0;uT(W);X=tT(W,6)|0;b[X>>0]=b[454574]|0;b[X+1>>0]=b[454575]|0;b[X+2>>0]=b[454576]|0;b[X+3>>0]=b[454577]|0;b[X+4>>0]=b[454578]|0;b[X+5>>0]=b[454579]|0;f[m>>2]=0;f[m+4>>2]=0;F=tT(m,13)|0;G=454593;H=F+13|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));nJa(C,m,454607)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;F=tT(m,11)|0;G=454581;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));$Ha(C,m,l)|0;uT(m);X=f[a+68>>2]|0;W=X+60|0;S=f[W>>2]|0;if((S|0)==(f[X+64>>2]|0))qKa(X+56|0,k);else{X=f[k>>2]|0;f[S>>2]=X;f[S+4>>2]=f[B>>2];if(!X)la=S;else{S=X+4|0;f[S>>2]=(f[S>>2]|0)+1;la=f[W>>2]|0}f[W>>2]=la+8}break b}while(0);rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,4)|0;b[W>>0]=115;b[W+1>>0]=105;b[W+2>>0]=122;b[W+3>>0]=101;W=f[I>>2]|0;if(!W){uT(l);f[l>>2]=0;ma=l+4|0;f[ma>>2]=0;na=tT(l,24)|0;F=na;G=387129;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,950)}S=f[l>>2]|0;X=(S|0)==0?1154740:S;R=W;while(1){_=f[R+16>>2]|0;if((S|0)==(_|0)){ja=1134;break}P=(_|0)==0?1154740:_;if((Ioc(X,P)|0)<0)oa=R;else{if((Ioc(P,X)|0)>=0){ja=1138;break}oa=R+4|0}R=f[oa>>2]|0;if(!R){ja=1136;break}}if((ja|0)==1134)uT(l);else if((ja|0)==1136){uT(l);f[l>>2]=0;ma=l+4|0;f[ma>>2]=0;na=tT(l,24)|0;F=na;G=387129;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,950)}else if((ja|0)==1138)uT(l);f[l>>2]=0;f[l+4>>2]=0;R=tT(l,4)|0;b[R>>0]=115;b[R+1>>0]=105;b[R+2>>0]=122;b[R+3>>0]=101;R=DHa(lIa(i,l)|0,-1)|0;uT(l);X=~R;S=(f[B>>2]|0)+8|0;uT(S);W=tT(S,5)|0;b[W>>0]=b[425537]|0;b[W+1>>0]=b[425538]|0;b[W+2>>0]=b[425539]|0;b[W+3>>0]=b[425540]|0;b[W+4>>0]=b[425541]|0;f[l>>2]=0;f[l+4>>2]=0;W=tT(l,5)|0;b[W>>0]=b[436922]|0;b[W+1>>0]=b[436923]|0;b[W+2>>0]=b[436924]|0;b[W+3>>0]=b[436925]|0;b[W+4>>0]=b[436926]|0;W=VDc(16)|0;f[W>>2]=W+8;f[W+4>>2]=4;S=XDc(32)|0;f[W>>2]=S;f[m>>2]=0;f[m+4>>2]=W;W=((R|0)<0)<<31>>31;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;P=S+16|0;f[P>>2]=R;f[P+4>>2]=W;P=S+24|0;f[P>>2]=R;f[P+4>>2]=W;bIa(C,l,m)|0;JFa(m);uT(l);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,3)|0;b[W>>0]=b[436928]|0;b[W+1>>0]=b[436929]|0;b[W+2>>0]=b[436930]|0;W=VDc(16)|0;f[W>>2]=W+8;f[W+4>>2]=4;P=XDc(32)|0;f[W>>2]=P;f[m>>2]=0;f[m+4>>2]=W;W=((X|0)<0)<<31>>31;f[P>>2]=-1;f[P+4>>2]=-1;f[P+8>>2]=-1;f[P+12>>2]=-1;R=P+16|0;f[R>>2]=X;f[R+4>>2]=W;R=P+24|0;f[R>>2]=X;f[R+4>>2]=W;bIa(C,l,m)|0;JFa(m);uT(l);W=f[a+68>>2]|0;R=W+60|0;X=f[R>>2]|0;if((X|0)==(f[W+64>>2]|0)){qKa(W+56|0,k);break b}W=f[k>>2]|0;f[X>>2]=W;f[X+4>>2]=f[B>>2];if(!W)pa=X;else{X=W+4|0;f[X>>2]=(f[X>>2]|0)+1;pa=f[R>>2]|0}f[R>>2]=pa+8;break b}while(0);rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;R=tT(l,5)|0;b[R>>0]=b[450415]|0;b[R+1>>0]=b[450416]|0;b[R+2>>0]=b[450417]|0;b[R+3>>0]=b[450418]|0;b[R+4>>0]=b[450419]|0;R=f[I>>2]|0;if(!R){uT(l);f[l>>2]=0;qa=l+4|0;f[qa>>2]=0;ra=tT(l,25)|0;F=ra;G=388475;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,920)}X=f[l>>2]|0;W=(X|0)==0?1154740:X;P=R;while(1){S=f[P+16>>2]|0;if((X|0)==(S|0)){ja=1069;break}_=(S|0)==0?1154740:S;if((Ioc(W,_)|0)<0)sa=P;else{if((Ioc(_,W)|0)>=0){ja=1073;break}sa=P+4|0}P=f[sa>>2]|0;if(!P){ja=1071;break}}if((ja|0)==1069)uT(l);else if((ja|0)==1071){uT(l);f[l>>2]=0;qa=l+4|0;f[qa>>2]=0;ra=tT(l,25)|0;F=ra;G=388475;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,920)}else if((ja|0)==1073)uT(l);f[l>>2]=0;f[l+4>>2]=0;P=tT(l,5)|0;b[P>>0]=b[450427]|0;b[P+1>>0]=b[450428]|0;b[P+2>>0]=b[450429]|0;b[P+3>>0]=b[450430]|0;b[P+4>>0]=b[450431]|0;P=f[I>>2]|0;if(!P){uT(l);f[l>>2]=0;ta=l+4|0;f[ta>>2]=0;ua=tT(l,25)|0;F=ua;G=388501;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,920)}W=f[l>>2]|0;X=(W|0)==0?1154740:W;R=P;while(1){_=f[R+16>>2]|0;if((W|0)==(_|0)){ja=1082;break}S=(_|0)==0?1154740:_;if((Ioc(X,S)|0)<0)va=R;else{if((Ioc(S,X)|0)>=0){ja=1086;break}va=R+4|0}R=f[va>>2]|0;if(!R){ja=1084;break}}if((ja|0)==1082)uT(l);else if((ja|0)==1084){uT(l);f[l>>2]=0;ta=l+4|0;f[ta>>2]=0;ua=tT(l,25)|0;F=ua;G=388501;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,920)}else if((ja|0)==1086)uT(l);f[l>>2]=0;f[l+4>>2]=0;R=tT(l,5)|0;b[R>>0]=b[450421]|0;b[R+1>>0]=b[450422]|0;b[R+2>>0]=b[450423]|0;b[R+3>>0]=b[450424]|0;b[R+4>>0]=b[450425]|0;R=f[I>>2]|0;if(!R){uT(l);f[l>>2]=0;wa=l+4|0;f[wa>>2]=0;xa=tT(l,25)|0;F=xa;G=388527;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,920)}X=f[l>>2]|0;W=(X|0)==0?1154740:X;P=R;while(1){S=f[P+16>>2]|0;if((X|0)==(S|0)){ja=1095;break}_=(S|0)==0?1154740:S;if((Ioc(W,_)|0)<0)ya=P;else{if((Ioc(_,W)|0)>=0){ja=1099;break}ya=P+4|0}P=f[ya>>2]|0;if(!P){ja=1097;break}}if((ja|0)==1095)uT(l);else if((ja|0)==1097){uT(l);f[l>>2]=0;wa=l+4|0;f[wa>>2]=0;xa=tT(l,25)|0;F=xa;G=388527;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,920)}else if((ja|0)==1099)uT(l);f[l>>2]=0;f[l+4>>2]=0;P=tT(l,5)|0;b[P>>0]=b[450433]|0;b[P+1>>0]=b[450434]|0;b[P+2>>0]=b[450435]|0;b[P+3>>0]=b[450436]|0;b[P+4>>0]=b[450437]|0;P=f[I>>2]|0;if(!P){uT(l);f[l>>2]=0;za=l+4|0;f[za>>2]=0;Aa=tT(l,25)|0;F=Aa;G=388553;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,920)}W=f[l>>2]|0;X=(W|0)==0?1154740:W;R=P;while(1){_=f[R+16>>2]|0;if((W|0)==(_|0)){ja=1108;break}S=(_|0)==0?1154740:_;if((Ioc(X,S)|0)<0)Ba=R;else{if((Ioc(S,X)|0)>=0){ja=1112;break}Ba=R+4|0}R=f[Ba>>2]|0;if(!R){ja=1110;break}}if((ja|0)==1108)uT(l);else if((ja|0)==1110){uT(l);f[l>>2]=0;za=l+4|0;f[za>>2]=0;Aa=tT(l,25)|0;F=Aa;G=388553;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,920)}else if((ja|0)==1112)uT(l);f[l>>2]=0;f[l+4>>2]=0;R=tT(l,5)|0;b[R>>0]=b[450421]|0;b[R+1>>0]=b[450422]|0;b[R+2>>0]=b[450423]|0;b[R+3>>0]=b[450424]|0;b[R+4>>0]=b[450425]|0;R=DHa(lIa(i,l)|0,-1)|0;X=J;uT(l);f[l>>2]=0;f[l+4>>2]=0;X=tT(l,5)|0;b[X>>0]=b[450415]|0;b[X+1>>0]=b[450416]|0;b[X+2>>0]=b[450417]|0;b[X+3>>0]=b[450418]|0;b[X+4>>0]=b[450419]|0;X=DHa(lIa(i,l)|0,-1)|0;W=J;uT(l);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,5)|0;b[W>>0]=b[450427]|0;b[W+1>>0]=b[450428]|0;b[W+2>>0]=b[450429]|0;b[W+3>>0]=b[450430]|0;b[W+4>>0]=b[450431]|0;W=DHa(lIa(i,l)|0,-1)|0;P=J;uT(l);f[l>>2]=0;f[l+4>>2]=0;P=tT(l,5)|0;b[P>>0]=b[450433]|0;b[P+1>>0]=b[450434]|0;b[P+2>>0]=b[450435]|0;b[P+3>>0]=b[450436]|0;b[P+4>>0]=b[450437]|0;P=DHa(lIa(i,l)|0,-1)|0;S=J;uT(l);if((X|R|W|P|0)<0){f[l>>2]=0;f[l+4>>2]=0;F=tT(l,54)|0;G=388579;H=F+54|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-213,l,386920,386595,926)}S=(f[B>>2]|0)+8|0;uT(S);_=tT(S,7)|0;b[_>>0]=b[425755]|0;b[_+1>>0]=b[425756]|0;b[_+2>>0]=b[425757]|0;b[_+3>>0]=b[425758]|0;b[_+4>>0]=b[425759]|0;b[_+5>>0]=b[425760]|0;b[_+6>>0]=b[425761]|0;_=VDc(24)|0;S=_;f[S>>2]=0;f[S+4>>2]=0;f[_+8>>2]=R;f[_+12>>2]=P;f[_+16>>2]=X;f[_+20>>2]=W;f[l>>2]=0;f[l+4>>2]=0;S=tT(l,8)|0;Z=S;b[Z>>0]=112;b[Z+1>>0]=97;b[Z+2>>0]=100;b[Z+3>>0]=100;Z=S+4|0;b[Z>>0]=105;b[Z+1>>0]=110;b[Z+2>>0]=103;b[Z+3>>0]=115;Z=VDc(16)|0;f[Z>>2]=Z+8;f[Z+4>>2]=6;S=XDc(48)|0;f[Z>>2]=S;f[m>>2]=0;f[m+4>>2]=Z;Z=f[_>>2]|0;$=S;f[$>>2]=Z;f[$+4>>2]=((Z|0)<0)<<31>>31;Z=f[_+4>>2]|0;$=S+8|0;f[$>>2]=Z;f[$+4>>2]=((Z|0)<0)<<31>>31;Z=f[_+8>>2]|0;$=S+16|0;f[$>>2]=Z;f[$+4>>2]=((Z|0)<0)<<31>>31;Z=f[_+12>>2]|0;$=S+24|0;f[$>>2]=Z;f[$+4>>2]=((Z|0)<0)<<31>>31;Z=f[_+16>>2]|0;$=S+32|0;f[$>>2]=Z;f[$+4>>2]=((Z|0)<0)<<31>>31;Z=f[_+20>>2]|0;$=S+40|0;f[$>>2]=Z;f[$+4>>2]=((Z|0)<0)<<31>>31;bIa(C,l,m)|0;JFa(m);uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,10)|0;G=435790;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[m>>2]=3;$Ha(C,l,m)|0;uT(l);W=f[h>>2]|0;if(!((W|0)!=388450?(Ioc((W|0)==0?1154740:W,388450)|0)!=0:0)){f[l>>2]=0;f[l+4>>2]=0;W=tT(l,4)|0;b[W>>0]=116;b[W+1>>0]=121;b[W+2>>0]=112;b[W+3>>0]=101;nJa(C,l,436127)|0;uT(l)}W=f[a+68>>2]|0;X=W+60|0;P=f[X>>2]|0;if((P|0)==(f[W+64>>2]|0))qKa(W+56|0,k);else{W=f[k>>2]|0;f[P>>2]=W;f[P+4>>2]=f[B>>2];if(!W)Ca=P;else{P=W+4|0;f[P>>2]=(f[P>>2]|0)+1;Ca=f[X>>2]|0}f[X>>2]=Ca+8}YDc(_);break b}while(0);rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,15)|0;G=388379;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));X=f[I>>2]|0;if(!X){uT(l);f[l>>2]=0;Da=l+4|0;f[Da>>2]=0;Ea=tT(l,35)|0;F=Ea;G=388395;H=F+35|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,911)}P=f[l>>2]|0;W=(P|0)==0?1154740:P;R=X;while(1){Z=f[R+16>>2]|0;if((P|0)==(Z|0)){ja=1048;break}$=(Z|0)==0?1154740:Z;if((Ioc(W,$)|0)<0)Fa=R;else{if((Ioc($,W)|0)>=0){ja=1052;break}Fa=R+4|0}R=f[Fa>>2]|0;if(!R){ja=1050;break}}if((ja|0)==1048)uT(l);else if((ja|0)==1050){uT(l);f[l>>2]=0;Da=l+4|0;f[Da>>2]=0;Ea=tT(l,35)|0;F=Ea;G=388395;H=F+35|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,911)}else if((ja|0)==1052)uT(l);R=(f[B>>2]|0)+8|0;uT(R);W=tT(R,5)|0;b[W>>0]=b[451285]|0;b[W+1>>0]=b[451286]|0;b[W+2>>0]=b[451287]|0;b[W+3>>0]=b[451288]|0;b[W+4>>0]=b[451289]|0;f[l>>2]=0;f[l+4>>2]=0;W=tT(l,5)|0;b[W>>0]=b[451291]|0;b[W+1>>0]=b[451292]|0;b[W+2>>0]=b[451293]|0;b[W+3>>0]=b[451294]|0;b[W+4>>0]=b[451295]|0;f[o>>2]=0;f[o+4>>2]=0;F=tT(o,15)|0;G=388379;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ga=+tIa(lIa(i,o)|0,-1);n[m>>2]=Ga;eIa(C,l,m)|0;uT(o);uT(l);W=f[a+68>>2]|0;R=W+60|0;P=f[R>>2]|0;if((P|0)==(f[W+64>>2]|0)){qKa(W+56|0,k);break b}W=f[k>>2]|0;f[P>>2]=W;f[P+4>>2]=f[B>>2];if(!W)Ha=P;else{P=W+4|0;f[P>>2]=(f[P>>2]|0)+1;Ha=f[R>>2]|0}f[R>>2]=Ha+8;break b}while(0);rKa(a,i,j);R=f[h>>2]|0;c:do if((R|0)==427617)ja=1014;else{P=(R|0)==0?1154740:R;if(!(Ioc(P,427617)|0)){ja=1014;break}do if((R|0)!=388358){if(!(Ioc(P,388358)|0))break;if((R|0)!=451285?Ioc(P,451285)|0:0)break c;f[m>>2]=0;f[m+4>>2]=0;W=tT(m,3)|0;b[W>>0]=b[388363]|0;b[W+1>>0]=b[388364]|0;b[W+2>>0]=b[388365]|0;W=f[I>>2]|0;do if(!W)Ia=1.0;else{X=f[m>>2]|0;$=(X|0)==0?1154740:X;Z=I;S=W;d:while(1){aa=S;while(1){ca=f[aa+16>>2]|0;if((ca|0)==(X|0))break;if((Ioc((ca|0)==0?1154740:ca,$)|0)>=0)break;ca=f[aa+4>>2]|0;if(!ca){Ja=Z;break d}else aa=ca}S=f[aa>>2]|0;if(!S){Ja=aa;break}else Z=aa}if((Ja|0)==(I|0)){Ia=1.0;break}Z=f[Ja+16>>2]|0;if((X|0)!=(Z|0)?(Ioc($,(Z|0)==0?1154740:Z)|0)<=-1:0){Ia=1.0;break}Ia=+tIa(Ja+24|0,-1)}while(0);n[l>>2]=Ia;uT(m);break c}while(0);n[l>>2]=.5}while(0);if((ja|0)==1014)n[l>>2]=2.0;R=(f[B>>2]|0)+8|0;uT(R);P=tT(R,5)|0;b[P>>0]=b[451285]|0;b[P+1>>0]=b[451286]|0;b[P+2>>0]=b[451287]|0;b[P+3>>0]=b[451288]|0;b[P+4>>0]=b[451289]|0;f[m>>2]=0;f[m+4>>2]=0;P=tT(m,5)|0;b[P>>0]=b[440269]|0;b[P+1>>0]=b[440270]|0;b[P+2>>0]=b[440271]|0;b[P+3>>0]=b[440272]|0;b[P+4>>0]=b[440273]|0;eIa(C,m,l)|0;uT(m);P=f[a+68>>2]|0;R=P+60|0;W=f[R>>2]|0;if((W|0)==(f[P+64>>2]|0))qKa(P+56|0,k);else{P=f[k>>2]|0;f[W>>2]=P;f[W+4>>2]=f[B>>2];if(!P)Ka=W;else{W=P+4|0;f[W>>2]=(f[W>>2]|0)+1;Ka=f[R>>2]|0}f[R>>2]=Ka+8}break b}while(0);R=(f[B>>2]|0)+8|0;uT(R);W=tT(R,3)|0;b[W>>0]=b[425608]|0;b[W+1>>0]=b[425609]|0;b[W+2>>0]=b[425610]|0;rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,5)|0;b[W>>0]=b[434804]|0;b[W+1>>0]=b[434805]|0;b[W+2>>0]=b[434806]|0;b[W+3>>0]=b[434807]|0;b[W+4>>0]=b[434808]|0;W=f[I>>2]|0;if(!W){uT(l);f[l>>2]=0;La=l+4|0;f[La>>2]=0;Ma=tT(l,25)|0;F=Ma;G=388285;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,881)}R=f[l>>2]|0;P=(R|0)==0?1154740:R;_=W;while(1){Z=f[_+16>>2]|0;if((R|0)==(Z|0)){ja=959;break}S=(Z|0)==0?1154740:Z;if((Ioc(P,S)|0)<0)Na=_;else{if((Ioc(S,P)|0)>=0){ja=963;break}Na=_+4|0}_=f[Na>>2]|0;if(!_){ja=961;break}}if((ja|0)==959)uT(l);else if((ja|0)==961){uT(l);f[l>>2]=0;La=l+4|0;f[La>>2]=0;Ma=tT(l,25)|0;F=Ma;G=388285;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,881)}else if((ja|0)==963)uT(l);f[l>>2]=0;f[l+4>>2]=0;_=tT(l,4)|0;b[_>>0]=98;b[_+1>>0]=101;b[_+2>>0]=116;b[_+3>>0]=97;_=f[I>>2]|0;if(!_){uT(l);f[l>>2]=0;Oa=l+4|0;f[Oa>>2]=0;Pa=tT(l,24)|0;F=Pa;G=388311;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,882)}P=f[l>>2]|0;R=(P|0)==0?1154740:P;W=_;while(1){S=f[W+16>>2]|0;if((P|0)==(S|0)){ja=972;break}Z=(S|0)==0?1154740:S;if((Ioc(R,Z)|0)<0)Qa=W;else{if((Ioc(Z,R)|0)>=0){ja=976;break}Qa=W+4|0}W=f[Qa>>2]|0;if(!W){ja=974;break}}if((ja|0)==972)uT(l);else if((ja|0)==974){uT(l);f[l>>2]=0;Oa=l+4|0;f[Oa>>2]=0;Pa=tT(l,24)|0;F=Pa;G=388311;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,882)}else if((ja|0)==976)uT(l);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,1)|0;b[W>>0]=107;W=f[I>>2]|0;if(!W){uT(l);f[l>>2]=0;Ra=l+4|0;f[Ra>>2]=0;Sa=tT(l,21)|0;F=Sa;G=388336;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,883)}R=f[l>>2]|0;P=(R|0)==0?1154740:R;_=W;while(1){Z=f[_+16>>2]|0;if((R|0)==(Z|0)){ja=985;break}S=(Z|0)==0?1154740:Z;if((Ioc(P,S)|0)<0)Ta=_;else{if((Ioc(S,P)|0)>=0){ja=989;break}Ta=_+4|0}_=f[Ta>>2]|0;if(!_){ja=987;break}}if((ja|0)==985)uT(l);else if((ja|0)==987){uT(l);f[l>>2]=0;Ra=l+4|0;f[Ra>>2]=0;Sa=tT(l,21)|0;F=Sa;G=388336;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,883)}else if((ja|0)==989)uT(l);f[l>>2]=0;f[l+4>>2]=0;_=tT(l,4)|0;b[_>>0]=115;b[_+1>>0]=105;b[_+2>>0]=122;b[_+3>>0]=101;_=f[I>>2]|0;if(!_){uT(l);f[l>>2]=0;Ua=l+4|0;f[Ua>>2]=0;Va=tT(l,24)|0;F=Va;G=387129;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,884)}P=f[l>>2]|0;R=(P|0)==0?1154740:P;W=_;while(1){S=f[W+16>>2]|0;if((P|0)==(S|0)){ja=998;break}Z=(S|0)==0?1154740:S;if((Ioc(R,Z)|0)<0)Wa=W;else{if((Ioc(Z,R)|0)>=0){ja=1002;break}Wa=W+4|0}W=f[Wa>>2]|0;if(!W){ja=1e3;break}}if((ja|0)==998)uT(l);else if((ja|0)==1e3){uT(l);f[l>>2]=0;Ua=l+4|0;f[Ua>>2]=0;Va=tT(l,24)|0;F=Va;G=387129;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,884)}else if((ja|0)==1002)uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,11)|0;G=434582;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));uKa(C,l,434594)|0;uT(l);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,5)|0;b[W>>0]=b[434804]|0;b[W+1>>0]=b[434805]|0;b[W+2>>0]=b[434806]|0;b[W+3>>0]=b[434807]|0;b[W+4>>0]=b[434808]|0;f[o>>2]=0;f[o+4>>2]=0;W=tT(o,5)|0;b[W>>0]=b[434804]|0;b[W+1>>0]=b[434805]|0;b[W+2>>0]=b[434806]|0;b[W+3>>0]=b[434807]|0;b[W+4>>0]=b[434808]|0;Ga=+tIa(lIa(i,o)|0,-1);n[m>>2]=Ga;eIa(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,4)|0;b[W>>0]=98;b[W+1>>0]=101;b[W+2>>0]=116;b[W+3>>0]=97;f[o>>2]=0;f[o+4>>2]=0;W=tT(o,4)|0;b[W>>0]=98;b[W+1>>0]=101;b[W+2>>0]=116;b[W+3>>0]=97;Ga=+tIa(lIa(i,o)|0,-1);n[m>>2]=Ga;eIa(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,4)|0;b[W>>0]=98;b[W+1>>0]=105;b[W+2>>0]=97;b[W+3>>0]=115;f[o>>2]=0;f[o+4>>2]=0;W=tT(o,1)|0;b[W>>0]=107;Ga=+tIa(lIa(i,o)|0,-1);n[m>>2]=Ga;eIa(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,10)|0;G=434734;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;W=tT(o,4)|0;b[W>>0]=115;b[W+1>>0]=105;b[W+2>>0]=122;b[W+3>>0]=101;W=DHa(lIa(i,o)|0,-1)|0;f[m>>2]=W;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,12)|0;G=434810;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));b[m>>0]=1;rIa(C,l,m)|0;uT(l);W=f[a+68>>2]|0;R=W+60|0;P=f[R>>2]|0;if((P|0)==(f[W+64>>2]|0)){qKa(W+56|0,k);break b}W=f[k>>2]|0;f[P>>2]=W;f[P+4>>2]=f[B>>2];if(!W)Xa=P;else{P=W+4|0;f[P>>2]=(f[P>>2]|0)+1;Xa=f[R>>2]|0}f[R>>2]=Xa+8;break b}while(0);R=(f[B>>2]|0)+8|0;uT(R);P=tT(R,7)|0;b[P>>0]=b[388247]|0;b[P+1>>0]=b[388248]|0;b[P+2>>0]=b[388249]|0;b[P+3>>0]=b[388250]|0;b[P+4>>0]=b[388251]|0;b[P+5>>0]=b[388252]|0;b[P+6>>0]=b[388253]|0;f[l>>2]=0;f[l+4>>2]=0;F=tT(l,11)|0;G=448299;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));b[m>>0]=1;rIa(C,l,m)|0;uT(l);P=f[a+68>>2]|0;R=P+60|0;W=f[R>>2]|0;if((W|0)==(f[P+64>>2]|0)){qKa(P+56|0,k);break b}P=f[k>>2]|0;f[W>>2]=P;f[W+4>>2]=f[B>>2];if(!P)Ya=W;else{W=P+4|0;f[W>>2]=(f[W>>2]|0)+1;Ya=f[R>>2]|0}f[R>>2]=Ya+8;break b}while(0);R=(f[B>>2]|0)+8|0;uT(R);W=tT(R,7)|0;b[W>>0]=b[388247]|0;b[W+1>>0]=b[388248]|0;b[W+2>>0]=b[388249]|0;b[W+3>>0]=b[388250]|0;b[W+4>>0]=b[388251]|0;b[W+5>>0]=b[388252]|0;b[W+6>>0]=b[388253]|0;W=f[a+68>>2]|0;R=W+60|0;P=f[R>>2]|0;if((P|0)==(f[W+64>>2]|0)){qKa(W+56|0,k);break b}W=f[k>>2]|0;f[P>>2]=W;f[P+4>>2]=f[B>>2];if(!W)Za=P;else{P=W+4|0;f[P>>2]=(f[P>>2]|0)+1;Za=f[R>>2]|0}f[R>>2]=Za+8;break b}while(0);rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;R=tT(l,7)|0;b[R>>0]=b[387057]|0;b[R+1>>0]=b[387058]|0;b[R+2>>0]=b[387059]|0;b[R+3>>0]=b[387060]|0;b[R+4>>0]=b[387061]|0;b[R+5>>0]=b[387062]|0;b[R+6>>0]=b[387063]|0;R=f[N>>2]|0;e:do if(!R)_a=0;else{P=f[l>>2]|0;W=(P|0)==0?1154740:P;_=R;while(1){Z=f[_+16>>2]|0;if((P|0)==(Z|0)){_a=1;break e}S=(Z|0)==0?1154740:Z;if((Ioc(W,S)|0)<0)$a=_;else{if((Ioc(S,W)|0)>=0){_a=1;break e}$a=_+4|0}_=f[$a>>2]|0;if(!_){_a=0;break}}}while(0);uT(l);if(!_a){f[l>>2]=0;f[l+4>>2]=0;F=tT(l,29)|0;G=388217;H=F+29|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,860)}f[l>>2]=0;f[l+4>>2]=0;F=tT(l,15)|0;G=387041;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[m>>2]=0;f[m+4>>2]=0;R=tT(m,7)|0;b[R>>0]=b[387057]|0;b[R+1>>0]=b[387058]|0;b[R+2>>0]=b[387059]|0;b[R+3>>0]=b[387060]|0;b[R+4>>0]=b[387061]|0;b[R+5>>0]=b[387062]|0;b[R+6>>0]=b[387063]|0;$Ha(C,l,sKa(j,m)|0)|0;uT(m);uT(l);R=f[a+68>>2]|0;_=R+60|0;W=f[_>>2]|0;if((W|0)==(f[R+64>>2]|0)){qKa(R+56|0,k);break b}R=f[k>>2]|0;f[W>>2]=R;f[W+4>>2]=f[B>>2];if(!R)ab=W;else{W=R+4|0;f[W>>2]=(f[W>>2]|0)+1;ab=f[_>>2]|0}f[_>>2]=ab+8;break b}while(0);rKa(a,i,j);_=(f[B>>2]|0)+8|0;uT(_);F=tT(_,13)|0;G=425570;H=F+13|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[l>>2]=0;f[l+4>>2]=0;_=tT(l,4)|0;b[_>>0]=112;b[_+1>>0]=97;b[_+2>>0]=100;b[_+3>>0]=87;_=f[I>>2]|0;if(!_){uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}W=f[l>>2]|0;R=(W|0)==0?1154740:W;P=_;while(1){_=f[P+16>>2]|0;if((W|0)==(_|0))break;S=(_|0)==0?1154740:_;if((Ioc(R,S)|0)<0)db=P;else{if((Ioc(S,R)|0)>=0)break;db=P+4|0}P=f[db>>2]|0;if(!P){ja=876;break}}if((ja|0)==876){uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}f[m>>2]=0;f[m+4>>2]=0;P=tT(m,4)|0;b[P>>0]=112;b[P+1>>0]=97;b[P+2>>0]=100;b[P+3>>0]=72;P=f[I>>2]|0;if(!P){uT(m);uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}R=f[m>>2]|0;W=(R|0)==0?1154740:R;S=P;while(1){P=f[S+16>>2]|0;if((R|0)==(P|0))break;_=(P|0)==0?1154740:P;if((Ioc(W,_)|0)<0)eb=S;else{if((Ioc(_,W)|0)>=0)break;eb=S+4|0}S=f[eb>>2]|0;if(!S){ja=878;break}}if((ja|0)==878){uT(m);uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}f[o>>2]=0;f[o+4>>2]=0;S=tT(o,2)|0;b[S>>0]=100;b[S+1>>0]=87;S=f[I>>2]|0;if(!S){uT(o);uT(m);uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}W=f[o>>2]|0;R=(W|0)==0?1154740:W;_=S;while(1){S=f[_+16>>2]|0;if((W|0)==(S|0))break;P=(S|0)==0?1154740:S;if((Ioc(R,P)|0)<0)fb=_;else{if((Ioc(P,R)|0)>=0)break;fb=_+4|0}_=f[fb>>2]|0;if(!_){ja=880;break}}if((ja|0)==880){uT(o);uT(m);uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}f[q>>2]=0;f[q+4>>2]=0;_=tT(q,2)|0;b[_>>0]=100;b[_+1>>0]=72;_=f[I>>2]|0;if(!_){uT(q);uT(o);uT(m);uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}R=f[q>>2]|0;W=(R|0)==0?1154740:R;P=_;while(1){_=f[P+16>>2]|0;if((R|0)==(_|0))break;S=(_|0)==0?1154740:_;if((Ioc(W,S)|0)<0)gb=P;else{if((Ioc(S,W)|0)>=0)break;gb=P+4|0}P=f[gb>>2]|0;if(!P){ja=882;break}}if((ja|0)==882){uT(q);uT(o);uT(m);uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}f[s>>2]=0;f[s+4>>2]=0;P=tT(s,4)|0;b[P>>0]=97;b[P+1>>0]=100;b[P+2>>0]=106;b[P+3>>0]=87;P=f[I>>2]|0;if(!P){uT(s);uT(q);uT(o);uT(m);uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}W=f[s>>2]|0;R=(W|0)==0?1154740:W;S=P;while(1){P=f[S+16>>2]|0;if((W|0)==(P|0))break;_=(P|0)==0?1154740:P;if((Ioc(R,_)|0)<0)hb=S;else{if((Ioc(_,R)|0)>=0)break;hb=S+4|0}S=f[hb>>2]|0;if(!S){ja=884;break}}if((ja|0)==884){uT(s);uT(q);uT(o);uT(m);uT(l);f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}f[v>>2]=0;f[v+4>>2]=0;S=tT(v,4)|0;b[S>>0]=97;b[S+1>>0]=100;b[S+2>>0]=106;b[S+3>>0]=72;S=f[I>>2]|0;f:do if(!S)ib=0;else{R=f[v>>2]|0;W=(R|0)==0?1154740:R;_=S;while(1){P=f[_+16>>2]|0;if((R|0)==(P|0))break;Z=(P|0)==0?1154740:P;if((Ioc(W,Z)|0)<0)jb=_;else{if((Ioc(Z,W)|0)>=0)break;jb=_+4|0}_=f[jb>>2]|0;if(!_){ib=0;break f}}f[w>>2]=0;f[w+4>>2]=0;_=tT(w,2)|0;b[_>>0]=107;b[_+1>>0]=87;_=f[I>>2]|0;g:do if(!_)kb=0;else{W=f[w>>2]|0;R=(W|0)==0?1154740:W;Z=_;while(1){P=f[Z+16>>2]|0;if((W|0)==(P|0))break;ca=(P|0)==0?1154740:P;if((Ioc(R,ca)|0)<0)lb=Z;else{if((Ioc(ca,R)|0)>=0)break;lb=Z+4|0}Z=f[lb>>2]|0;if(!Z){kb=0;break g}}f[x>>2]=0;f[x+4>>2]=0;Z=tT(x,2)|0;b[Z>>0]=107;b[Z+1>>0]=72;Z=f[I>>2]|0;h:do if(!Z)mb=0;else{R=f[x>>2]|0;W=(R|0)==0?1154740:R;ca=Z;while(1){P=f[ca+16>>2]|0;if((R|0)==(P|0))break;ba=(P|0)==0?1154740:P;if((Ioc(W,ba)|0)<0)nb=ca;else{if((Ioc(ba,W)|0)>=0)break;nb=ca+4|0}ca=f[nb>>2]|0;if(!ca){mb=0;break h}}f[y>>2]=0;f[y+4>>2]=0;F=tT(y,12)|0;G=386936;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));ca=f[I>>2]|0;i:do if(!ca)ob=0;else{W=f[y>>2]|0;R=(W|0)==0?1154740:W;ba=ca;while(1){P=f[ba+16>>2]|0;if((W|0)==(P|0)){ob=1;break i}pb=(P|0)==0?1154740:P;if((Ioc(R,pb)|0)<0)qb=ba;else{if((Ioc(pb,R)|0)>=0){ob=1;break i}qb=ba+4|0}ba=f[qb>>2]|0;if(!ba){ob=0;break}}}while(0);uT(y);mb=ob}while(0);uT(x);kb=mb}while(0);uT(w);ib=kb}while(0);uT(v);uT(s);uT(q);uT(o);uT(m);uT(l);if(!ib){f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;cb=tT(l,241)|0;dJc(cb|0,387955,241)|0;z5(-215,l,386920,386595,836)}f[l>>2]=0;f[l+4>>2]=0;S=tT(l,8)|0;_=S;b[_>>0]=107;b[_+1>>0]=101;b[_+2>>0]=114;b[_+3>>0]=110;_=S+4|0;b[_>>0]=101;b[_+1>>0]=108;b[_+2>>0]=95;b[_+3>>0]=119;f[o>>2]=0;f[o+4>>2]=0;_=tT(o,2)|0;b[_>>0]=107;b[_+1>>0]=87;_=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=_;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;_=tT(l,8)|0;S=_;b[S>>0]=107;b[S+1>>0]=101;b[S+2>>0]=114;b[S+3>>0]=110;S=_+4|0;b[S>>0]=101;b[S+1>>0]=108;b[S+2>>0]=95;b[S+3>>0]=104;f[o>>2]=0;f[o+4>>2]=0;S=tT(o,2)|0;b[S>>0]=107;b[S+1>>0]=72;S=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=S;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;S=tT(l,5)|0;b[S>>0]=b[387898]|0;b[S+1>>0]=b[387899]|0;b[S+2>>0]=b[387900]|0;b[S+3>>0]=b[387901]|0;b[S+4>>0]=b[387902]|0;f[o>>2]=0;f[o+4>>2]=0;S=tT(o,4)|0;b[S>>0]=112;b[S+1>>0]=97;b[S+2>>0]=100;b[S+3>>0]=87;S=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=S;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;S=tT(l,5)|0;b[S>>0]=b[387904]|0;b[S+1>>0]=b[387905]|0;b[S+2>>0]=b[387906]|0;b[S+3>>0]=b[387907]|0;b[S+4>>0]=b[387908]|0;f[o>>2]=0;f[o+4>>2]=0;S=tT(o,4)|0;b[S>>0]=112;b[S+1>>0]=97;b[S+2>>0]=100;b[S+3>>0]=72;S=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=S;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;S=tT(l,8)|0;_=S;b[_>>0]=115;b[_+1>>0]=116;b[_+2>>0]=114;b[_+3>>0]=105;_=S+4|0;b[_>>0]=100;b[_+1>>0]=101;b[_+2>>0]=95;b[_+3>>0]=119;f[o>>2]=0;f[o+4>>2]=0;_=tT(o,2)|0;b[_>>0]=100;b[_+1>>0]=87;_=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=_;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;_=tT(l,8)|0;S=_;b[S>>0]=115;b[S+1>>0]=116;b[S+2>>0]=114;b[S+3>>0]=105;S=_+4|0;b[S>>0]=100;b[S+1>>0]=101;b[S+2>>0]=95;b[S+3>>0]=104;f[o>>2]=0;f[o+4>>2]=0;S=tT(o,2)|0;b[S>>0]=100;b[S+1>>0]=72;S=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=S;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;S=tT(l,5)|0;b[S>>0]=b[434011]|0;b[S+1>>0]=b[434012]|0;b[S+2>>0]=b[434013]|0;b[S+3>>0]=b[434014]|0;b[S+4>>0]=b[434015]|0;f[o>>2]=0;f[o+4>>2]=0;S=tT(o,4)|0;b[S>>0]=97;b[S+1>>0]=100;b[S+2>>0]=106;b[S+3>>0]=87;S=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=S;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;S=tT(l,5)|0;b[S>>0]=b[434005]|0;b[S+1>>0]=b[434006]|0;b[S+2>>0]=b[434007]|0;b[S+3>>0]=b[434008]|0;b[S+4>>0]=b[434009]|0;f[o>>2]=0;f[o+4>>2]=0;S=tT(o,4)|0;b[S>>0]=97;b[S+1>>0]=100;b[S+2>>0]=106;b[S+3>>0]=72;S=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=S;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,10)|0;G=455057;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,12)|0;G=386936;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));S=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=S;$Ha(C,l,m)|0;uT(o);uT(l);S=D+28|0;f[l>>2]=0;f[l+4>>2]=0;_=tT(l,6)|0;b[_>>0]=b[386884]|0;b[_+1>>0]=b[386885]|0;b[_+2>>0]=b[386886]|0;b[_+3>>0]=b[386887]|0;b[_+4>>0]=b[386888]|0;b[_+5>>0]=b[386889]|0;_=sKa(j,l)|0;Z=_+4|0;ca=D+32|0;ba=f[ca>>2]|0;R=D+36|0;if((ba|0)==(f[R>>2]|0))Bxa(S,Z);else{f[ba>>2]=f[Z>>2];W=ba+4|0;pb=_+8|0;f[W>>2]=f[pb>>2];P=ba+8|0;f[P>>2]=f[_+12>>2];f[ba+12>>2]=f[_+16>>2];f[ba+16>>2]=f[_+20>>2];f[ba+20>>2]=f[_+24>>2];f[ba+24>>2]=f[_+28>>2];f[ba+28>>2]=f[_+32>>2];f[ba+32>>2]=f[_+36>>2];rb=f[_+40>>2]|0;f[ba+36>>2]=rb;f[ba+40>>2]=P;P=ba+48|0;sb=ba+44|0;f[sb>>2]=P;f[P>>2]=0;f[ba+52>>2]=0;if(rb|0){P=rb+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[pb>>2]|0)<3){pb=f[_+48>>2]|0;_=f[sb>>2]|0;f[_>>2]=f[pb>>2];f[_+4>>2]=f[pb+4>>2]}else{f[W>>2]=0;ZS(ba,Z)}f[ca>>2]=(f[ca>>2]|0)+56}uT(l);f[m>>2]=0;f[m+4>>2]=0;Z=tT(m,4)|0;b[Z>>0]=98;b[Z+1>>0]=105;b[Z+2>>0]=97;b[Z+3>>0]=115;Z=f[N>>2]|0;j:do if(!Z)tb=0;else{ba=f[m>>2]|0;W=(ba|0)==0?1154740:ba;pb=Z;while(1){_=f[pb+16>>2]|0;if((ba|0)==(_|0)){tb=1;break j}sb=(_|0)==0?1154740:_;if((Ioc(W,sb)|0)<0)ub=pb;else{if((Ioc(sb,W)|0)>=0){tb=1;break j}ub=pb+4|0}pb=f[ub>>2]|0;if(!pb){tb=0;break}}}while(0);uT(m);b[l>>0]=tb;f[m>>2]=0;f[m+4>>2]=0;F=tT(m,9)|0;G=454939;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));rIa(C,m,l)|0;uT(m);if(b[l>>0]|0){f[m>>2]=0;f[m+4>>2]=0;Z=tT(m,4)|0;b[Z>>0]=98;b[Z+1>>0]=105;b[Z+2>>0]=97;b[Z+3>>0]=115;Z=sKa(j,m)|0;pb=Z+4|0;W=f[ca>>2]|0;if((W|0)==(f[R>>2]|0))Bxa(S,pb);else{f[W>>2]=f[pb>>2];ba=W+4|0;sb=Z+8|0;f[ba>>2]=f[sb>>2];_=W+8|0;f[_>>2]=f[Z+12>>2];f[W+12>>2]=f[Z+16>>2];f[W+16>>2]=f[Z+20>>2];f[W+20>>2]=f[Z+24>>2];f[W+24>>2]=f[Z+28>>2];f[W+28>>2]=f[Z+32>>2];f[W+32>>2]=f[Z+36>>2];P=f[Z+40>>2]|0;f[W+36>>2]=P;f[W+40>>2]=_;_=W+48|0;rb=W+44|0;f[rb>>2]=_;f[_>>2]=0;f[W+52>>2]=0;if(P|0){_=P+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[sb>>2]|0)<3){sb=f[Z+48>>2]|0;Z=f[rb>>2]|0;f[Z>>2]=f[sb>>2];f[Z+4>>2]=f[sb+4>>2]}else{f[ba>>2]=0;ZS(W,pb)}f[ca>>2]=(f[ca>>2]|0)+56}uT(m)}pb=f[a+68>>2]|0;W=pb+60|0;ba=f[W>>2]|0;if((ba|0)==(f[pb+64>>2]|0))qKa(pb+56|0,k);else{pb=f[k>>2]|0;f[ba>>2]=pb;f[ba+4>>2]=f[B>>2];if(!pb)vb=ba;else{ba=pb+4|0;f[ba>>2]=(f[ba>>2]|0)+1;vb=f[W>>2]|0}f[W>>2]=vb+8}break b}while(0);rKa(a,i,j);W=(f[B>>2]|0)+8|0;uT(W);F=tT(W,11)|0;G=455045;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[l>>2]=0;f[l+4>>2]=0;W=tT(l,4)|0;b[W>>0]=112;b[W+1>>0]=97;b[W+2>>0]=100;b[W+3>>0]=87;W=f[I>>2]|0;if(!W){uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}ba=f[l>>2]|0;pb=(ba|0)==0?1154740:ba;sb=W;while(1){W=f[sb+16>>2]|0;if((ba|0)==(W|0))break;Z=(W|0)==0?1154740:W;if((Ioc(pb,Z)|0)<0)yb=sb;else{if((Ioc(Z,pb)|0)>=0)break;yb=sb+4|0}sb=f[yb>>2]|0;if(!sb){ja=755;break}}if((ja|0)==755){uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}f[m>>2]=0;f[m+4>>2]=0;sb=tT(m,4)|0;b[sb>>0]=112;b[sb+1>>0]=97;b[sb+2>>0]=100;b[sb+3>>0]=72;sb=f[I>>2]|0;if(!sb){uT(m);uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}pb=f[m>>2]|0;ba=(pb|0)==0?1154740:pb;Z=sb;while(1){sb=f[Z+16>>2]|0;if((pb|0)==(sb|0))break;W=(sb|0)==0?1154740:sb;if((Ioc(ba,W)|0)<0)zb=Z;else{if((Ioc(W,ba)|0)>=0)break;zb=Z+4|0}Z=f[zb>>2]|0;if(!Z){ja=757;break}}if((ja|0)==757){uT(m);uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}f[o>>2]=0;f[o+4>>2]=0;Z=tT(o,2)|0;b[Z>>0]=100;b[Z+1>>0]=87;Z=f[I>>2]|0;if(!Z){uT(o);uT(m);uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}ba=f[o>>2]|0;pb=(ba|0)==0?1154740:ba;W=Z;while(1){Z=f[W+16>>2]|0;if((ba|0)==(Z|0))break;sb=(Z|0)==0?1154740:Z;if((Ioc(pb,sb)|0)<0)Ab=W;else{if((Ioc(sb,pb)|0)>=0)break;Ab=W+4|0}W=f[Ab>>2]|0;if(!W){ja=759;break}}if((ja|0)==759){uT(o);uT(m);uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}f[q>>2]=0;f[q+4>>2]=0;W=tT(q,2)|0;b[W>>0]=100;b[W+1>>0]=72;W=f[I>>2]|0;if(!W){uT(q);uT(o);uT(m);uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}pb=f[q>>2]|0;ba=(pb|0)==0?1154740:pb;sb=W;while(1){W=f[sb+16>>2]|0;if((pb|0)==(W|0))break;Z=(W|0)==0?1154740:W;if((Ioc(ba,Z)|0)<0)Bb=sb;else{if((Ioc(Z,ba)|0)>=0)break;Bb=sb+4|0}sb=f[Bb>>2]|0;if(!sb){ja=761;break}}if((ja|0)==761){uT(q);uT(o);uT(m);uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}f[s>>2]=0;f[s+4>>2]=0;F=tT(s,9)|0;G=387626;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));sb=f[I>>2]|0;if(!sb){uT(s);uT(q);uT(o);uT(m);uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}ba=f[s>>2]|0;pb=(ba|0)==0?1154740:ba;Z=sb;while(1){sb=f[Z+16>>2]|0;if((ba|0)==(sb|0))break;W=(sb|0)==0?1154740:sb;if((Ioc(pb,W)|0)<0)Cb=Z;else{if((Ioc(W,pb)|0)>=0)break;Cb=Z+4|0}Z=f[Cb>>2]|0;if(!Z){ja=763;break}}if((ja|0)==763){uT(s);uT(q);uT(o);uT(m);uT(l);f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}f[v>>2]=0;f[v+4>>2]=0;F=tT(v,9)|0;G=387636;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Z=f[I>>2]|0;k:do if(!Z)Db=0;else{pb=f[v>>2]|0;ba=(pb|0)==0?1154740:pb;W=Z;while(1){sb=f[W+16>>2]|0;if((pb|0)==(sb|0))break;rb=(sb|0)==0?1154740:sb;if((Ioc(ba,rb)|0)<0)Eb=W;else{if((Ioc(rb,ba)|0)>=0)break;Eb=W+4|0}W=f[Eb>>2]|0;if(!W){Db=0;break k}}f[w>>2]=0;f[w+4>>2]=0;W=tT(w,2)|0;b[W>>0]=107;b[W+1>>0]=87;W=f[I>>2]|0;l:do if(!W)Fb=0;else{ba=f[w>>2]|0;pb=(ba|0)==0?1154740:ba;ca=W;while(1){S=f[ca+16>>2]|0;if((ba|0)==(S|0))break;R=(S|0)==0?1154740:S;if((Ioc(pb,R)|0)<0)Gb=ca;else{if((Ioc(R,pb)|0)>=0)break;Gb=ca+4|0}ca=f[Gb>>2]|0;if(!ca){Fb=0;break l}}f[x>>2]=0;f[x+4>>2]=0;ca=tT(x,2)|0;b[ca>>0]=107;b[ca+1>>0]=72;ca=f[I>>2]|0;m:do if(!ca)Hb=0;else{pb=f[x>>2]|0;ba=(pb|0)==0?1154740:pb;R=ca;while(1){S=f[R+16>>2]|0;if((pb|0)==(S|0))break;rb=(S|0)==0?1154740:S;if((Ioc(ba,rb)|0)<0)Ib=R;else{if((Ioc(rb,ba)|0)>=0)break;Ib=R+4|0}R=f[Ib>>2]|0;if(!R){Hb=0;break m}}f[y>>2]=0;f[y+4>>2]=0;F=tT(y,12)|0;G=386936;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));R=f[I>>2]|0;n:do if(!R)Jb=0;else{ba=f[y>>2]|0;pb=(ba|0)==0?1154740:ba;rb=R;while(1){S=f[rb+16>>2]|0;if((ba|0)==(S|0)){Jb=1;break n}sb=(S|0)==0?1154740:S;if((Ioc(pb,sb)|0)<0)Kb=rb;else{if((Ioc(sb,pb)|0)>=0){Jb=1;break n}Kb=rb+4|0}rb=f[Kb>>2]|0;if(!rb){Jb=0;break}}}while(0);uT(y);Hb=Jb}while(0);uT(x);Fb=Hb}while(0);uT(w);Db=Fb}while(0);uT(v);uT(s);uT(q);uT(o);uT(m);uT(l);if(!Db){f[l>>2]=0;wb=l+4|0;f[wb>>2]=0;xb=tT(l,251)|0;dJc(xb|0,387646,251)|0;z5(-215,l,386920,386595,803)}f[l>>2]=0;f[l+4>>2]=0;Z=tT(l,8)|0;W=Z;b[W>>0]=107;b[W+1>>0]=101;b[W+2>>0]=114;b[W+3>>0]=110;W=Z+4|0;b[W>>0]=101;b[W+1>>0]=108;b[W+2>>0]=95;b[W+3>>0]=119;f[o>>2]=0;f[o+4>>2]=0;W=tT(o,2)|0;b[W>>0]=107;b[W+1>>0]=87;W=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=W;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,8)|0;Z=W;b[Z>>0]=107;b[Z+1>>0]=101;b[Z+2>>0]=114;b[Z+3>>0]=110;Z=W+4|0;b[Z>>0]=101;b[Z+1>>0]=108;b[Z+2>>0]=95;b[Z+3>>0]=104;f[o>>2]=0;f[o+4>>2]=0;Z=tT(o,2)|0;b[Z>>0]=107;b[Z+1>>0]=72;Z=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=Z;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;Z=tT(l,5)|0;b[Z>>0]=b[387898]|0;b[Z+1>>0]=b[387899]|0;b[Z+2>>0]=b[387900]|0;b[Z+3>>0]=b[387901]|0;b[Z+4>>0]=b[387902]|0;f[o>>2]=0;f[o+4>>2]=0;Z=tT(o,4)|0;b[Z>>0]=112;b[Z+1>>0]=97;b[Z+2>>0]=100;b[Z+3>>0]=87;Z=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=Z;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;Z=tT(l,5)|0;b[Z>>0]=b[387904]|0;b[Z+1>>0]=b[387905]|0;b[Z+2>>0]=b[387906]|0;b[Z+3>>0]=b[387907]|0;b[Z+4>>0]=b[387908]|0;f[o>>2]=0;f[o+4>>2]=0;Z=tT(o,4)|0;b[Z>>0]=112;b[Z+1>>0]=97;b[Z+2>>0]=100;b[Z+3>>0]=72;Z=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=Z;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;Z=tT(l,8)|0;W=Z;b[W>>0]=115;b[W+1>>0]=116;b[W+2>>0]=114;b[W+3>>0]=105;W=Z+4|0;b[W>>0]=100;b[W+1>>0]=101;b[W+2>>0]=95;b[W+3>>0]=119;f[o>>2]=0;f[o+4>>2]=0;W=tT(o,2)|0;b[W>>0]=100;b[W+1>>0]=87;W=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=W;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,8)|0;Z=W;b[Z>>0]=115;b[Z+1>>0]=116;b[Z+2>>0]=114;b[Z+3>>0]=105;Z=W+4|0;b[Z>>0]=100;b[Z+1>>0]=101;b[Z+2>>0]=95;b[Z+3>>0]=104;f[o>>2]=0;f[o+4>>2]=0;Z=tT(o,2)|0;b[Z>>0]=100;b[Z+1>>0]=72;Z=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=Z;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,10)|0;G=387910;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,9)|0;G=387626;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Z=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=Z;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,10)|0;G=387921;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,9)|0;G=387636;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Z=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=Z;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,10)|0;G=455057;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,12)|0;G=386936;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Z=~~+tIa(lIa(i,o)|0,-1);f[m>>2]=Z;$Ha(C,l,m)|0;uT(o);uT(l);Z=D+28|0;f[l>>2]=0;f[l+4>>2]=0;W=tT(l,6)|0;b[W>>0]=b[386884]|0;b[W+1>>0]=b[386885]|0;b[W+2>>0]=b[386886]|0;b[W+3>>0]=b[386887]|0;b[W+4>>0]=b[386888]|0;b[W+5>>0]=b[386889]|0;W=sKa(j,l)|0;ca=W+4|0;R=D+32|0;rb=f[R>>2]|0;pb=D+36|0;if((rb|0)==(f[pb>>2]|0))Bxa(Z,ca);else{f[rb>>2]=f[ca>>2];ba=rb+4|0;sb=W+8|0;f[ba>>2]=f[sb>>2];S=rb+8|0;f[S>>2]=f[W+12>>2];f[rb+12>>2]=f[W+16>>2];f[rb+16>>2]=f[W+20>>2];f[rb+20>>2]=f[W+24>>2];f[rb+24>>2]=f[W+28>>2];f[rb+28>>2]=f[W+32>>2];f[rb+32>>2]=f[W+36>>2];_=f[W+40>>2]|0;f[rb+36>>2]=_;f[rb+40>>2]=S;S=rb+48|0;P=rb+44|0;f[P>>2]=S;f[S>>2]=0;f[rb+52>>2]=0;if(_|0){S=_+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[sb>>2]|0)<3){sb=f[W+48>>2]|0;W=f[P>>2]|0;f[W>>2]=f[sb>>2];f[W+4>>2]=f[sb+4>>2]}else{f[ba>>2]=0;ZS(rb,ca)}f[R>>2]=(f[R>>2]|0)+56}uT(l);f[m>>2]=0;f[m+4>>2]=0;ca=tT(m,4)|0;b[ca>>0]=98;b[ca+1>>0]=105;b[ca+2>>0]=97;b[ca+3>>0]=115;ca=f[N>>2]|0;o:do if(!ca)Lb=0;else{rb=f[m>>2]|0;ba=(rb|0)==0?1154740:rb;sb=ca;while(1){W=f[sb+16>>2]|0;if((rb|0)==(W|0)){Lb=1;break o}P=(W|0)==0?1154740:W;if((Ioc(ba,P)|0)<0)Mb=sb;else{if((Ioc(P,ba)|0)>=0){Lb=1;break o}Mb=sb+4|0}sb=f[Mb>>2]|0;if(!sb){Lb=0;break}}}while(0);uT(m);b[l>>0]=Lb;f[m>>2]=0;f[m+4>>2]=0;F=tT(m,9)|0;G=454939;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));rIa(C,m,l)|0;uT(m);if(b[l>>0]|0){f[m>>2]=0;f[m+4>>2]=0;ca=tT(m,4)|0;b[ca>>0]=98;b[ca+1>>0]=105;b[ca+2>>0]=97;b[ca+3>>0]=115;ca=sKa(j,m)|0;sb=ca+4|0;ba=f[R>>2]|0;if((ba|0)==(f[pb>>2]|0))Bxa(Z,sb);else{f[ba>>2]=f[sb>>2];rb=ba+4|0;P=ca+8|0;f[rb>>2]=f[P>>2];W=ba+8|0;f[W>>2]=f[ca+12>>2];f[ba+12>>2]=f[ca+16>>2];f[ba+16>>2]=f[ca+20>>2];f[ba+20>>2]=f[ca+24>>2];f[ba+24>>2]=f[ca+28>>2];f[ba+28>>2]=f[ca+32>>2];f[ba+32>>2]=f[ca+36>>2];S=f[ca+40>>2]|0;f[ba+36>>2]=S;f[ba+40>>2]=W;W=ba+48|0;_=ba+44|0;f[_>>2]=W;f[W>>2]=0;f[ba+52>>2]=0;if(S|0){W=S+12|0;f[W>>2]=(f[W>>2]|0)+1}if((f[P>>2]|0)<3){P=f[ca+48>>2]|0;ca=f[_>>2]|0;f[ca>>2]=f[P>>2];f[ca+4>>2]=f[P+4>>2]}else{f[rb>>2]=0;ZS(ba,sb)}f[R>>2]=(f[R>>2]|0)+56}uT(m)}sb=f[a+68>>2]|0;ba=sb+60|0;rb=f[ba>>2]|0;if((rb|0)==(f[sb+64>>2]|0))qKa(sb+56|0,k);else{sb=f[k>>2]|0;f[rb>>2]=sb;f[rb+4>>2]=f[B>>2];if(!sb)Nb=rb;else{rb=sb+4|0;f[rb>>2]=(f[rb>>2]|0)+1;Nb=f[ba>>2]|0}f[ba>>2]=Nb+8}break b}while(0);ba=f[a+68>>2]|0;rb=ba+60|0;sb=f[rb>>2]|0;if((sb|0)==(f[ba+64>>2]|0))qKa(ba+56|0,k);else{ba=f[k>>2]|0;f[sb>>2]=ba;f[sb+4>>2]=f[B>>2];if(!ba)Ob=sb;else{sb=ba+4|0;f[sb>>2]=(f[sb>>2]|0)+1;Ob=f[rb>>2]|0}f[rb>>2]=Ob+8}gKa(a);break b}while(0);rKa(a,i,j);rb=(f[B>>2]|0)+8|0;uT(rb);sb=tT(rb,7)|0;b[sb>>0]=b[425755]|0;b[sb+1>>0]=b[425756]|0;b[sb+2>>0]=b[425757]|0;b[sb+3>>0]=b[425758]|0;b[sb+4>>0]=b[425759]|0;b[sb+5>>0]=b[425760]|0;b[sb+6>>0]=b[425761]|0;f[l>>2]=0;f[l+4>>2]=0;sb=tT(l,3)|0;b[sb>>0]=b[453999]|0;b[sb+1>>0]=b[454e3]|0;b[sb+2>>0]=b[454001]|0;sb=f[I>>2]|0;if(!sb){uT(l);f[l>>2]=0;Pb=l+4|0;f[Pb>>2]=0;Qb=tT(l,50)|0;F=Qb;G=387484;H=F+50|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,764)}rb=f[l>>2]|0;ba=(rb|0)==0?1154740:rb;P=sb;while(1){ca=f[P+16>>2]|0;if((rb|0)==(ca|0))break;_=(ca|0)==0?1154740:ca;if((Ioc(ba,_)|0)<0)Rb=P;else{if((Ioc(_,ba)|0)>=0)break;Rb=P+4|0}P=f[Rb>>2]|0;if(!P){ja=609;break}}if((ja|0)==609){uT(l);f[l>>2]=0;Pb=l+4|0;f[Pb>>2]=0;Qb=tT(l,50)|0;F=Qb;G=387484;H=F+50|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,764)}f[m>>2]=0;f[m+4>>2]=0;P=tT(m,3)|0;b[P>>0]=b[431774]|0;b[P+1>>0]=b[431775]|0;b[P+2>>0]=b[431776]|0;P=f[I>>2]|0;if(!P){uT(m);uT(l);f[l>>2]=0;Pb=l+4|0;f[Pb>>2]=0;Qb=tT(l,50)|0;F=Qb;G=387484;H=F+50|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,764)}ba=f[m>>2]|0;rb=(ba|0)==0?1154740:ba;sb=P;while(1){_=f[sb+16>>2]|0;if((ba|0)==(_|0)){ja=613;break}ca=(_|0)==0?1154740:_;if((Ioc(rb,ca)|0)<0)Sb=sb;else{if((Ioc(ca,rb)|0)>=0){ja=607;break}Sb=sb+4|0}sb=f[Sb>>2]|0;if(!sb){ja=611;break}}if((ja|0)==607){uT(m);uT(l)}else if((ja|0)==611){uT(m);uT(l);f[l>>2]=0;Pb=l+4|0;f[Pb>>2]=0;Qb=tT(l,50)|0;F=Qb;G=387484;H=F+50|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,764)}else if((ja|0)==613){uT(m);uT(l)}f[l>>2]=0;f[l+4>>2]=0;sb=tT(l,5)|0;b[sb>>0]=b[387535]|0;b[sb+1>>0]=b[387536]|0;b[sb+2>>0]=b[387537]|0;b[sb+3>>0]=b[387538]|0;b[sb+4>>0]=b[387539]|0;sb=f[I>>2]|0;do if(!sb)uT(l);else{rb=f[l>>2]|0;ba=(rb|0)==0?1154740:rb;P=sb;while(1){ca=f[P+16>>2]|0;if((rb|0)==(ca|0))break;_=(ca|0)==0?1154740:ca;if((Ioc(ba,_)|0)<0)Tb=P;else{if((Ioc(_,ba)|0)>=0)break;Tb=P+4|0}P=f[Tb>>2]|0;if(!P){ja=625;break}}if((ja|0)==625){uT(l);break}f[m>>2]=0;f[m+4>>2]=0;P=tT(m,5)|0;b[P>>0]=b[387535]|0;b[P+1>>0]=b[387536]|0;b[P+2>>0]=b[387537]|0;b[P+3>>0]=b[387538]|0;b[P+4>>0]=b[387539]|0;P=DHa(lIa(i,m)|0,-1)|0;uT(m);uT(l);if((P|0)==1)break;f[l>>2]=0;f[l+4>>2]=0;F=tT(l,38)|0;G=387541;H=F+38|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-213,l,386920,386595,766)}while(0);f[l>>2]=0;f[l+4>>2]=0;sb=tT(l,5)|0;b[sb>>0]=b[498520]|0;b[sb+1>>0]=b[498521]|0;b[sb+2>>0]=b[498522]|0;b[sb+3>>0]=b[498523]|0;b[sb+4>>0]=b[498524]|0;sb=f[I>>2]|0;do if(!sb)uT(l);else{P=f[l>>2]|0;ba=(P|0)==0?1154740:P;rb=sb;while(1){_=f[rb+16>>2]|0;if((P|0)==(_|0)){ja=634;break}ca=(_|0)==0?1154740:_;if((Ioc(ba,ca)|0)<0)Ub=rb;else{if((Ioc(ca,ba)|0)>=0){ja=635;break}Ub=rb+4|0}rb=f[Ub>>2]|0;if(!rb){ja=638;break}}if((ja|0)==634)uT(l);else if((ja|0)==635)uT(l);else if((ja|0)==638){uT(l);break}f[l>>2]=0;f[l+4>>2]=0;rb=tT(l,5)|0;b[rb>>0]=b[498520]|0;b[rb+1>>0]=b[498521]|0;b[rb+2>>0]=b[498522]|0;b[rb+3>>0]=b[498523]|0;b[rb+4>>0]=b[498524]|0;f[o>>2]=0;f[o+4>>2]=0;rb=tT(o,5)|0;b[rb>>0]=b[498520]|0;b[rb+1>>0]=b[498521]|0;b[rb+2>>0]=b[498522]|0;b[rb+3>>0]=b[498523]|0;b[rb+4>>0]=b[498524]|0;Ga=+tIa(lIa(i,o)|0,-1);n[m>>2]=Ga;eIa(C,l,m)|0;uT(o);uT(l)}while(0);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,9)|0;G=387580;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));sb=f[I>>2]|0;do if(!sb)uT(l);else{rb=f[l>>2]|0;ba=(rb|0)==0?1154740:rb;P=sb;while(1){ca=f[P+16>>2]|0;if((rb|0)==(ca|0)){ja=647;break}_=(ca|0)==0?1154740:ca;if((Ioc(ba,_)|0)<0)Vb=P;else{if((Ioc(_,ba)|0)>=0){ja=648;break}Vb=P+4|0}P=f[Vb>>2]|0;if(!P){ja=651;break}}if((ja|0)==647)uT(l);else if((ja|0)==648)uT(l);else if((ja|0)==651){uT(l);break}f[l>>2]=0;f[l+4>>2]=0;F=tT(l,10)|0;G=435790;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,9)|0;G=387580;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));P=DHa(lIa(i,o)|0,-1)|0;f[m>>2]=P;$Ha(C,l,m)|0;uT(o);uT(l)}while(0);f[l>>2]=0;f[l+4>>2]=0;sb=tT(l,3)|0;b[sb>>0]=b[431774]|0;b[sb+1>>0]=b[431775]|0;b[sb+2>>0]=b[431776]|0;sb=DHa(lIa(i,l)|0,-1)|0;uT(l);f[l>>2]=0;f[l+4>>2]=0;P=tT(l,3)|0;b[P>>0]=b[453999]|0;b[P+1>>0]=b[454e3]|0;b[P+2>>0]=b[454001]|0;P=DHa(lIa(i,l)|0,-1)|0;uT(l);ba=sb<<1;f[l>>2]=0;rb=l+4|0;f[rb>>2]=0;f[l+8>>2]=0;if(ba>>>0>1073741823)mCc(l);_=sb<<3;sb=VDc(_)|0;f[l>>2]=sb;ca=sb+(ba<<2)|0;f[l+8>>2]=ca;XIc(sb|0,0,_|0)|0;f[rb>>2]=ca;ca=(P|0)>0;f[sb+((ca?-1:-2)+ba<<2)>>2]=ca?P:0-P|0;f[m>>2]=0;f[m+4>>2]=0;P=tT(m,8)|0;ca=P;b[ca>>0]=112;b[ca+1>>0]=97;b[ca+2>>0]=100;b[ca+3>>0]=100;ca=P+4|0;b[ca>>0]=105;b[ca+1>>0]=110;b[ca+2>>0]=103;b[ca+3>>0]=115;ca=f[l>>2]|0;P=(f[rb>>2]|0)-ca|0;ba=P>>2;sb=VDc(16)|0;_=sb+8|0;f[sb>>2]=_;f[sb+4>>2]=ba;if(ba>>>0>1){W=XDc(ba>>>0>536870911?-1:ba<<3)|0;f[sb>>2]=W;Wb=W}else Wb=_;f[o>>2]=0;f[o+4>>2]=sb;if((P|0)>0){P=ca;ca=0;while(1){sb=f[P>>2]|0;_=Wb+(ca<<3)|0;f[_>>2]=sb;f[_+4>>2]=((sb|0)<0)<<31>>31;ca=ca+1|0;if((ca|0)==(ba|0))break;else P=P+4|0}}bIa(C,m,o)|0;JFa(o);uT(m);P=f[a+68>>2]|0;ba=P+60|0;ca=f[ba>>2]|0;if((ca|0)==(f[P+64>>2]|0))qKa(P+56|0,k);else{P=f[k>>2]|0;f[ca>>2]=P;f[ca+4>>2]=f[B>>2];if(!P)Xb=ca;else{ca=P+4|0;f[ca>>2]=(f[ca>>2]|0)+1;Xb=f[ba>>2]|0}f[ba>>2]=Xb+8}ba=f[l>>2]|0;if(ba|0){ca=f[rb>>2]|0;if((ca|0)!=(ba|0))f[rb>>2]=ca+(~((ca+-4-ba|0)>>>2)<<2);YDc(ba)}break b}while(0);rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;ba=tT(l,1)|0;b[ba>>0]=112;ba=f[I>>2]|0;if(!ba){uT(l);f[l>>2]=0;Yb=l+4|0;f[Yb>>2]=0;Zb=tT(l,21)|0;F=Zb;G=387447;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,750)}ca=f[l>>2]|0;P=(ca|0)==0?1154740:ca;sb=ba;while(1){_=f[sb+16>>2]|0;if((ca|0)==(_|0)){ja=566;break}W=(_|0)==0?1154740:_;if((Ioc(P,W)|0)<0)_b=sb;else{if((Ioc(W,P)|0)>=0){ja=570;break}_b=sb+4|0}sb=f[_b>>2]|0;if(!sb){ja=568;break}}if((ja|0)==566)uT(l);else if((ja|0)==568){uT(l);f[l>>2]=0;Yb=l+4|0;f[Yb>>2]=0;Zb=tT(l,21)|0;F=Zb;G=387447;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,750)}else if((ja|0)==570)uT(l);f[l>>2]=0;f[l+4>>2]=0;sb=tT(l,1)|0;b[sb>>0]=112;f[o>>2]=0;f[o+4>>2]=0;sb=tT(o,1)|0;b[sb>>0]=112;Ga=+tIa(lIa(i,o)|0,-1);n[m>>2]=Ga;eIa(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;sb=tT(l,3)|0;b[sb>>0]=b[454985]|0;b[sb+1>>0]=b[454986]|0;b[sb+2>>0]=b[454987]|0;sb=f[I>>2]|0;do if(!sb)uT(l);else{P=f[l>>2]|0;ca=(P|0)==0?1154740:P;ba=sb;while(1){W=f[ba+16>>2]|0;if((P|0)==(W|0)){ja=579;break}_=(W|0)==0?1154740:W;if((Ioc(ca,_)|0)<0)$b=ba;else{if((Ioc(_,ca)|0)>=0){ja=580;break}$b=ba+4|0}ba=f[$b>>2]|0;if(!ba){ja=583;break}}if((ja|0)==579)uT(l);else if((ja|0)==580)uT(l);else if((ja|0)==583){uT(l);break}f[l>>2]=0;f[l+4>>2]=0;ba=tT(l,3)|0;b[ba>>0]=b[454985]|0;b[ba+1>>0]=b[454986]|0;b[ba+2>>0]=b[454987]|0;f[o>>2]=0;f[o+4>>2]=0;ba=tT(o,3)|0;b[ba>>0]=b[454985]|0;b[ba+1>>0]=b[454986]|0;b[ba+2>>0]=b[454987]|0;Ga=+tIa(lIa(i,o)|0,-1);n[m>>2]=Ga;eIa(C,l,m)|0;uT(o);uT(l)}while(0);sb=(f[B>>2]|0)+8|0;uT(sb);F=tT(sb,9)|0;G=425739;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));sb=f[a+68>>2]|0;ba=sb+60|0;ca=f[ba>>2]|0;if((ca|0)==(f[sb+64>>2]|0)){qKa(sb+56|0,k);break b}sb=f[k>>2]|0;f[ca>>2]=sb;f[ca+4>>2]=f[B>>2];if(!sb)ac=ca;else{ca=sb+4|0;f[ca>>2]=(f[ca>>2]|0)+1;ac=f[ba>>2]|0}f[ba>>2]=ac+8;break b}while(0);rKa(a,i,j);ba=(f[B>>2]|0)+8|0;uT(ba);ca=tT(ba,8)|0;ba=ca;b[ba>>0]=73;b[ba+1>>0]=100;b[ba+2>>0]=101;b[ba+3>>0]=110;ba=ca+4|0;b[ba>>0]=116;b[ba+1>>0]=105;b[ba+2>>0]=116;b[ba+3>>0]=121;ba=f[a+68>>2]|0;ca=ba+60|0;sb=f[ca>>2]|0;if((sb|0)==(f[ba+64>>2]|0)){qKa(ba+56|0,k);break b}ba=f[k>>2]|0;f[sb>>2]=ba;f[sb+4>>2]=f[B>>2];if(!ba)bc=sb;else{sb=ba+4|0;f[sb>>2]=(f[sb>>2]|0)+1;bc=f[ca>>2]|0}f[ca>>2]=bc+8;break b}while(0);rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;ca=tT(l,1)|0;b[ca>>0]=112;ca=f[I>>2]|0;if(!ca){uT(l);f[l>>2]=0;cc=l+4|0;f[cc>>2]=0;dc=tT(l,21)|0;F=dc;G=387447;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,722)}sb=f[l>>2]|0;ba=(sb|0)==0?1154740:sb;P=ca;while(1){rb=f[P+16>>2]|0;if((sb|0)==(rb|0)){ja=523;break}_=(rb|0)==0?1154740:rb;if((Ioc(ba,_)|0)<0)ec=P;else{if((Ioc(_,ba)|0)>=0){ja=527;break}ec=P+4|0}P=f[ec>>2]|0;if(!P){ja=525;break}}if((ja|0)==523)uT(l);else if((ja|0)==525){uT(l);f[l>>2]=0;cc=l+4|0;f[cc>>2]=0;dc=tT(l,21)|0;F=dc;G=387447;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,722)}else if((ja|0)==527)uT(l);f[l>>2]=0;f[l+4>>2]=0;P=tT(l,2)|0;b[P>>0]=118;b[P+1>>0]=50;P=f[I>>2]|0;do if(!P){uT(l);ja=540}else{ba=f[l>>2]|0;sb=(ba|0)==0?1154740:ba;ca=P;while(1){_=f[ca+16>>2]|0;if((ba|0)==(_|0))break;rb=(_|0)==0?1154740:_;if((Ioc(sb,rb)|0)<0)fc=ca;else{if((Ioc(rb,sb)|0)>=0)break;fc=ca+4|0}ca=f[fc>>2]|0;if(!ca){ja=539;break}}if((ja|0)==539){uT(l);ja=540;break}f[m>>2]=0;f[m+4>>2]=0;ca=tT(m,2)|0;b[ca>>0]=118;b[ca+1>>0]=50;ca=DHa(lIa(i,m)|0,-1)|0;sb=J;uT(m);uT(l);if(!((ca|0)!=0|(sb|0)!=0)){ja=540;break}sb=(f[B>>2]|0)+8|0;uT(sb);ca=tT(sb,8)|0;sb=ca;b[sb>>0]=73;b[sb+1>>0]=100;b[sb+2>>0]=101;b[sb+3>>0]=110;sb=ca+4|0;b[sb>>0]=116;b[sb+1>>0]=105;b[sb+2>>0]=116;b[sb+3>>0]=121}while(0);do if((ja|0)==540){f[m>>2]=0;f[m+4>>2]=0;P=tT(m,1)|0;b[P>>0]=112;Ga=1.0-+tIa(lIa(i,m)|0,-1);uT(m);n[l>>2]=Ga;if(Ga>0.0){P=(f[B>>2]|0)+8|0;uT(P);sb=tT(P,5)|0;b[sb>>0]=b[451285]|0;b[sb+1>>0]=b[451286]|0;b[sb+2>>0]=b[451287]|0;b[sb+3>>0]=b[451288]|0;b[sb+4>>0]=b[451289]|0;f[m>>2]=0;f[m+4>>2]=0;sb=tT(m,5)|0;b[sb>>0]=b[451291]|0;b[sb+1>>0]=b[451292]|0;b[sb+2>>0]=b[451293]|0;b[sb+3>>0]=b[451294]|0;b[sb+4>>0]=b[451295]|0;eIa(C,m,l)|0;uT(m);break}else{f[m>>2]=0;f[m+4>>2]=0;F=tT(m,9)|0;G=451199;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,m,386920,386595,732)}}while(0);sb=f[a+68>>2]|0;P=sb+60|0;ca=f[P>>2]|0;if((ca|0)==(f[sb+64>>2]|0)){qKa(sb+56|0,k);break b}sb=f[k>>2]|0;f[ca>>2]=sb;f[ca+4>>2]=f[B>>2];if(!sb)gc=ca;else{ca=sb+4|0;f[ca>>2]=(f[ca>>2]|0)+1;gc=f[P>>2]|0}f[P>>2]=gc+8;break b}while(0);rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;P=tT(l,6)|0;b[P>>0]=b[386884]|0;b[P+1>>0]=b[386885]|0;b[P+2>>0]=b[386886]|0;b[P+3>>0]=b[386887]|0;b[P+4>>0]=b[386888]|0;b[P+5>>0]=b[386889]|0;P=f[N>>2]|0;p:do if(!P)hc=0;else{ca=f[l>>2]|0;sb=(ca|0)==0?1154740:ca;ba=P;while(1){rb=f[ba+16>>2]|0;if((ca|0)==(rb|0)){hc=1;break p}_=(rb|0)==0?1154740:rb;if((Ioc(sb,_)|0)<0)ic=ba;else{if((Ioc(_,sb)|0)>=0){hc=1;break p}ic=ba+4|0}ba=f[ic>>2]|0;if(!ba){hc=0;break}}}while(0);uT(l);if(!hc){f[l>>2]=0;f[l+4>>2]=0;F=tT(l,28)|0;G=386891;H=F+28|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,699)}f[l>>2]=0;f[l+4>>2]=0;F=tT(l,12)|0;G=386936;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));P=~~+tIa(lIa(i,l)|0,-1);uT(l);do if(!P){f[l>>2]=0;f[l+4>>2]=0;ba=tT(l,6)|0;b[ba>>0]=b[386884]|0;b[ba+1>>0]=b[386885]|0;b[ba+2>>0]=b[386886]|0;b[ba+3>>0]=b[386887]|0;b[ba+4>>0]=b[386888]|0;b[ba+5>>0]=b[386889]|0;ba=sKa(j,l)|0;sb=f[ba+8>>2]|0;if((sb|0)<3)jc=Y(f[ba+16>>2]|0,f[ba+12>>2]|0)|0;else{ca=f[ba+44>>2]|0;ba=0;_=1;while(1){rb=Y(f[ca+(ba<<2)>>2]|0,_)|0;ba=ba+1|0;if((ba|0)==(sb|0)){jc=rb;break}else _=rb}}uT(l);if((jc|0)==1){f[m>>2]=0;f[m+4>>2]=0;_=tT(m,6)|0;b[_>>0]=b[386884]|0;b[_+1>>0]=b[386885]|0;b[_+2>>0]=b[386886]|0;b[_+3>>0]=b[386887]|0;b[_+4>>0]=b[386888]|0;b[_+5>>0]=b[386889]|0;_=(sKa(j,m)|0)+20|0;sb=f[f[_>>2]>>2]|0;uT(m);f[l>>2]=sb;f[m>>2]=0;f[m+4>>2]=0;F=tT(m,14)|0;G=454995;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));eIa(C,m,l)|0;uT(m);sb=(f[B>>2]|0)+8|0;uT(sb);_=tT(sb,4)|0;b[_>>0]=82;b[_+1>>0]=101;b[_+2>>0]=76;b[_+3>>0]=85;break}else{f[l>>2]=0;f[l+4>>2]=0;F=tT(l,42)|0;G=387389;H=F+42|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,710)}}else{f[l>>2]=0;f[l+4>>2]=0;_=tT(l,6)|0;b[_>>0]=b[386884]|0;b[_+1>>0]=b[386885]|0;b[_+2>>0]=b[386886]|0;b[_+3>>0]=b[386887]|0;b[_+4>>0]=b[386888]|0;b[_+5>>0]=b[386889]|0;_=sKa(j,l)|0;sb=f[_+8>>2]|0;if((sb|0)<3)kc=Y(f[_+16>>2]|0,f[_+12>>2]|0)|0;else{ba=f[_+44>>2]|0;_=0;ca=1;while(1){rb=Y(f[ba+(_<<2)>>2]|0,ca)|0;_=_+1|0;if((_|0)==(sb|0)){kc=rb;break}else ca=rb}}uT(l);if((kc|0)!=(P|0)){f[l>>2]=0;f[l+4>>2]=0;F=tT(l,55)|0;G=387333;H=F+55|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,704)}f[l>>2]=0;f[l+4>>2]=0;ca=tT(l,6)|0;b[ca>>0]=b[386884]|0;b[ca+1>>0]=b[386885]|0;b[ca+2>>0]=b[386886]|0;b[ca+3>>0]=b[386887]|0;b[ca+4>>0]=b[386888]|0;b[ca+5>>0]=b[386889]|0;ca=sKa(j,l)|0;sb=ca+4|0;_=D+32|0;ba=f[_>>2]|0;if((ba|0)==(f[D+36>>2]|0))Bxa(D+28|0,sb);else{f[ba>>2]=f[sb>>2];rb=ba+4|0;W=ca+8|0;f[rb>>2]=f[W>>2];S=ba+8|0;f[S>>2]=f[ca+12>>2];f[ba+12>>2]=f[ca+16>>2];f[ba+16>>2]=f[ca+20>>2];f[ba+20>>2]=f[ca+24>>2];f[ba+24>>2]=f[ca+28>>2];f[ba+28>>2]=f[ca+32>>2];f[ba+32>>2]=f[ca+36>>2];lc=f[ca+40>>2]|0;f[ba+36>>2]=lc;f[ba+40>>2]=S;S=ba+48|0;mc=ba+44|0;f[mc>>2]=S;f[S>>2]=0;f[ba+52>>2]=0;if(lc|0){S=lc+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[W>>2]|0)<3){W=f[ca+48>>2]|0;ca=f[mc>>2]|0;f[ca>>2]=f[W>>2];f[ca+4>>2]=f[W+4>>2]}else{f[rb>>2]=0;ZS(ba,sb)}f[_>>2]=(f[_>>2]|0)+56}uT(l);_=(f[B>>2]|0)+8|0;uT(_);F=tT(_,13)|0;G=425635;H=F+13|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0))}while(0);P=f[a+68>>2]|0;_=P+60|0;sb=f[_>>2]|0;if((sb|0)==(f[P+64>>2]|0)){qKa(P+56|0,k);break b}P=f[k>>2]|0;f[sb>>2]=P;f[sb+4>>2]=f[B>>2];if(!P)nc=sb;else{sb=P+4|0;f[sb>>2]=(f[sb>>2]|0)+1;nc=f[_>>2]|0}f[_>>2]=nc+8;break b}while(0);_=(f[B>>2]|0)+8|0;uT(_);F=tT(_,9)|0;G=454964;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;_=tT(l,3)|0;b[_>>0]=b[454985]|0;b[_+1>>0]=b[454986]|0;b[_+2>>0]=b[454987]|0;_=f[I>>2]|0;if(!_){uT(l);f[l>>2]=0;oc=l+4|0;f[oc>>2]=0;pc=tT(l,23)|0;F=pc;G=387236;H=F+23|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,641)}sb=f[l>>2]|0;P=(sb|0)==0?1154740:sb;ba=_;while(1){rb=f[ba+16>>2]|0;if((sb|0)==(rb|0)){ja=295;break}W=(rb|0)==0?1154740:rb;if((Ioc(P,W)|0)<0)qc=ba;else{if((Ioc(W,P)|0)>=0){ja=299;break}qc=ba+4|0}ba=f[qc>>2]|0;if(!ba){ja=297;break}}if((ja|0)==295)uT(l);else if((ja|0)==297){uT(l);f[l>>2]=0;oc=l+4|0;f[oc>>2]=0;pc=tT(l,23)|0;F=pc;G=387236;H=F+23|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,641)}else if((ja|0)==299)uT(l);f[m>>2]=0;f[m+4>>2]=0;ba=tT(m,3)|0;b[ba>>0]=b[454985]|0;b[ba+1>>0]=b[454986]|0;b[ba+2>>0]=b[454987]|0;Ga=+tIa(lIa(i,m)|0,-1);uT(m);n[l>>2]=Ga;f[m>>2]=0;f[m+4>>2]=0;ba=tT(m,3)|0;b[ba>>0]=b[454985]|0;b[ba+1>>0]=b[454986]|0;b[ba+2>>0]=b[454987]|0;eIa(C,m,l)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;F=tT(m,12)|0;G=387260;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));ba=f[N>>2]|0;q:do if(!ba)rc=0;else{P=f[m>>2]|0;sb=(P|0)==0?1154740:P;_=ba;while(1){W=f[_+16>>2]|0;if((P|0)==(W|0)){rc=1;break q}rb=(W|0)==0?1154740:W;if((Ioc(sb,rb)|0)<0)sc=_;else{if((Ioc(rb,sb)|0)>=0){rc=1;break q}sc=_+4|0}_=f[sc>>2]|0;if(!_){rc=0;break}}}while(0);uT(m);if(!rc){f[m>>2]=0;f[m+4>>2]=0;ba=tT(m,7)|0;b[ba>>0]=b[387273]|0;b[ba+1>>0]=b[387274]|0;b[ba+2>>0]=b[387275]|0;b[ba+3>>0]=b[387276]|0;b[ba+4>>0]=b[387277]|0;b[ba+5>>0]=b[387278]|0;b[ba+6>>0]=b[387279]|0;ba=f[I>>2]|0;if(!ba){uT(m);f[m>>2]=0;tc=m+4|0;f[tc>>2]=0;uc=tT(m,27)|0;F=uc;G=387281;H=F+27|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,m,386920,386595,651)}_=f[m>>2]|0;sb=(_|0)==0?1154740:_;P=ba;while(1){rb=f[P+16>>2]|0;if((_|0)==(rb|0)){ja=326;break}W=(rb|0)==0?1154740:rb;if((Ioc(sb,W)|0)<0)vc=P;else{if((Ioc(W,sb)|0)>=0){ja=330;break}vc=P+4|0}P=f[vc>>2]|0;if(!P){ja=328;break}}if((ja|0)==326)uT(m);else if((ja|0)==328){uT(m);f[m>>2]=0;tc=m+4|0;f[tc>>2]=0;uc=tT(m,27)|0;F=uc;G=387281;H=F+27|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,m,386920,386595,651)}else if((ja|0)==330)uT(m);P=D+28|0;f[o>>2]=0;f[o+4>>2]=0;sb=tT(o,7)|0;b[sb>>0]=b[387273]|0;b[sb+1>>0]=b[387274]|0;b[sb+2>>0]=b[387275]|0;b[sb+3>>0]=b[387276]|0;b[sb+4>>0]=b[387277]|0;b[sb+5>>0]=b[387278]|0;b[sb+6>>0]=b[387279]|0;sb=DHa(lIa(i,o)|0,-1)|0;AY(r,1,sb,5);f[m>>2]=1124007936;sb=m+4|0;_=m+8|0;ba=m+40|0;F=sb;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[ba>>2]=_;W=m+48|0;rb=m+44|0;f[rb>>2]=W;f[W>>2]=0;f[m+52>>2]=0;ca=f[r>>2]|0;ei[f[(f[ca>>2]|0)+12>>2]&511](ca,r,m,-1);ca=D+32|0;mc=f[ca>>2]|0;if((mc|0)==(f[D+36>>2]|0)){Bxa(P,m);wc=m+36|0}else{f[mc>>2]=f[m>>2];S=mc+4|0;f[S>>2]=f[sb>>2];lc=mc+8|0;f[lc>>2]=f[_>>2];f[mc+12>>2]=f[m+12>>2];f[mc+16>>2]=f[m+16>>2];f[mc+20>>2]=f[m+20>>2];f[mc+24>>2]=f[m+24>>2];f[mc+28>>2]=f[m+28>>2];f[mc+32>>2]=f[m+32>>2];xc=m+36|0;yc=f[xc>>2]|0;f[mc+36>>2]=yc;f[mc+40>>2]=lc;lc=mc+48|0;zc=mc+44|0;f[zc>>2]=lc;f[lc>>2]=0;f[mc+52>>2]=0;if(yc|0){lc=yc+12|0;f[lc>>2]=(f[lc>>2]|0)+1}if((f[sb>>2]|0)<3){lc=f[rb>>2]|0;yc=f[zc>>2]|0;f[yc>>2]=f[lc>>2];f[yc+4>>2]=f[lc+4>>2]}else{f[S>>2]=0;ZS(mc,m)}f[ca>>2]=(f[ca>>2]|0)+56;wc=xc}xc=f[wc>>2]|0;do if(xc|0){ca=xc+12|0;mc=f[ca>>2]|0;f[ca>>2]=mc+-1;if((mc|0)!=1)break;_S(m)}while(0);f[wc>>2]=0;xc=m+16|0;f[xc>>2]=0;f[xc+4>>2]=0;f[xc+8>>2]=0;f[xc+12>>2]=0;if((f[sb>>2]|0)>0){xc=f[ba>>2]|0;_=0;do{f[xc+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[sb>>2]|0))}sb=f[rb>>2]|0;if((sb|0)!=(W|0))g0(sb);$j(r);uT(o)}else{sb=D+28|0;f[m>>2]=0;f[m+4>>2]=0;F=tT(m,12)|0;G=387260;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));W=sKa(j,m)|0;rb=W+4|0;_=D+32|0;xc=f[_>>2]|0;if((xc|0)==(f[D+36>>2]|0))Bxa(sb,rb);else{f[xc>>2]=f[rb>>2];ba=xc+4|0;P=W+8|0;f[ba>>2]=f[P>>2];mc=xc+8|0;f[mc>>2]=f[W+12>>2];f[xc+12>>2]=f[W+16>>2];f[xc+16>>2]=f[W+20>>2];f[xc+20>>2]=f[W+24>>2];f[xc+24>>2]=f[W+28>>2];f[xc+28>>2]=f[W+32>>2];f[xc+32>>2]=f[W+36>>2];ca=f[W+40>>2]|0;f[xc+36>>2]=ca;f[xc+40>>2]=mc;mc=xc+48|0;S=xc+44|0;f[S>>2]=mc;f[mc>>2]=0;f[xc+52>>2]=0;if(ca|0){mc=ca+12|0;f[mc>>2]=(f[mc>>2]|0)+1}if((f[P>>2]|0)<3){P=f[W+48>>2]|0;W=f[S>>2]|0;f[W>>2]=f[P>>2];f[W+4>>2]=f[P+4>>2]}else{f[ba>>2]=0;ZS(xc,rb)}f[_>>2]=(f[_>>2]|0)+56}uT(m)}f[m>>2]=0;f[m+4>>2]=0;F=tT(m,11)|0;G=387309;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));sb=f[N>>2]|0;r:do if(!sb)Ac=0;else{_=f[m>>2]|0;rb=(_|0)==0?1154740:_;xc=sb;while(1){ba=f[xc+16>>2]|0;if((_|0)==(ba|0)){Ac=1;break r}P=(ba|0)==0?1154740:ba;if((Ioc(rb,P)|0)<0)Bc=xc;else{if((Ioc(P,rb)|0)>=0){Ac=1;break r}Bc=xc+4|0}xc=f[Bc>>2]|0;if(!xc){Ac=0;break}}}while(0);uT(m);do if(!Ac){f[m>>2]=0;f[m+4>>2]=0;F=tT(m,11)|0;G=387321;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));sb=f[N>>2]|0;s:do if(!sb)Cc=0;else{xc=f[m>>2]|0;rb=(xc|0)==0?1154740:xc;_=sb;while(1){P=f[_+16>>2]|0;if((xc|0)==(P|0)){Cc=1;break s}ba=(P|0)==0?1154740:P;if((Ioc(rb,ba)|0)<0)Dc=_;else{if((Ioc(ba,rb)|0)>=0){Cc=1;break s}Dc=_+4|0}_=f[Dc>>2]|0;if(!_){Cc=0;break}}}while(0);uT(m);if(Cc|0){sb=D+28|0;f[m>>2]=0;f[m+4>>2]=0;F=tT(m,11)|0;G=387321;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));_=sKa(j,m)|0;rb=_+4|0;xc=D+32|0;ba=f[xc>>2]|0;if((ba|0)==(f[D+36>>2]|0))Bxa(sb,rb);else{f[ba>>2]=f[rb>>2];P=ba+4|0;W=_+8|0;f[P>>2]=f[W>>2];S=ba+8|0;f[S>>2]=f[_+12>>2];f[ba+12>>2]=f[_+16>>2];f[ba+16>>2]=f[_+20>>2];f[ba+20>>2]=f[_+24>>2];f[ba+24>>2]=f[_+28>>2];f[ba+28>>2]=f[_+32>>2];f[ba+32>>2]=f[_+36>>2];mc=f[_+40>>2]|0;f[ba+36>>2]=mc;f[ba+40>>2]=S;S=ba+48|0;ca=ba+44|0;f[ca>>2]=S;f[S>>2]=0;f[ba+52>>2]=0;if(mc|0){S=mc+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[W>>2]|0)<3){W=f[_+48>>2]|0;_=f[ca>>2]|0;f[_>>2]=f[W>>2];f[_+4>>2]=f[W+4>>2]}else{f[P>>2]=0;ZS(ba,rb)}f[xc>>2]=(f[xc>>2]|0)+56}uT(m);rb=(f[xc>>2]|0)+-56|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=rb;ba=o+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=rb;d3(m,-2.0,o);rb=(f[xc>>2]|0)+-56|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=rb;p[q>>3]=+n[l>>2];f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;xc=s+8|0;f[xc>>2]=0;f[xc+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=rb;oL(m,o,s,e0()|0,-1);break}f[m>>2]=0;f[m+4>>2]=0;rb=tT(m,7)|0;b[rb>>0]=b[387273]|0;b[rb+1>>0]=b[387274]|0;b[rb+2>>0]=b[387275]|0;b[rb+3>>0]=b[387276]|0;b[rb+4>>0]=b[387277]|0;b[rb+5>>0]=b[387278]|0;b[rb+6>>0]=b[387279]|0;rb=f[I>>2]|0;if(!rb){uT(m);f[m>>2]=0;Ec=m+4|0;f[Ec>>2]=0;Fc=tT(m,27)|0;F=Fc;G=387281;H=F+27|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,m,386920,386595,667)}sb=f[m>>2]|0;xc=(sb|0)==0?1154740:sb;ba=rb;while(1){P=f[ba+16>>2]|0;if((sb|0)==(P|0)){ja=392;break}W=(P|0)==0?1154740:P;if((Ioc(xc,W)|0)<0)Gc=ba;else{if((Ioc(W,xc)|0)>=0){ja=396;break}Gc=ba+4|0}ba=f[Gc>>2]|0;if(!ba){ja=394;break}}if((ja|0)==392)uT(m);else if((ja|0)==394){uT(m);f[m>>2]=0;Ec=m+4|0;f[Ec>>2]=0;Fc=tT(m,27)|0;F=Fc;G=387281;H=F+27|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,m,386920,386595,667)}else if((ja|0)==396)uT(m);ba=D+28|0;f[o>>2]=0;f[o+4>>2]=0;xc=tT(o,7)|0;b[xc>>0]=b[387273]|0;b[xc+1>>0]=b[387274]|0;b[xc+2>>0]=b[387275]|0;b[xc+3>>0]=b[387276]|0;b[xc+4>>0]=b[387277]|0;b[xc+5>>0]=b[387278]|0;b[xc+6>>0]=b[387279]|0;xc=DHa(lIa(i,o)|0,-1)|0;EY(t,1,xc,5);f[m>>2]=1124007936;xc=m+4|0;sb=m+8|0;rb=m+40|0;F=xc;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[rb>>2]=sb;W=m+48|0;P=m+44|0;f[P>>2]=W;f[W>>2]=0;f[m+52>>2]=0;_=f[t>>2]|0;ei[f[(f[_>>2]|0)+12>>2]&511](_,t,m,-1);_=D+32|0;ca=f[_>>2]|0;if((ca|0)==(f[D+36>>2]|0)){Bxa(ba,m);Hc=m+36|0}else{f[ca>>2]=f[m>>2];S=ca+4|0;f[S>>2]=f[xc>>2];mc=ca+8|0;f[mc>>2]=f[sb>>2];f[ca+12>>2]=f[m+12>>2];f[ca+16>>2]=f[m+16>>2];f[ca+20>>2]=f[m+20>>2];f[ca+24>>2]=f[m+24>>2];f[ca+28>>2]=f[m+28>>2];f[ca+32>>2]=f[m+32>>2];lc=m+36|0;yc=f[lc>>2]|0;f[ca+36>>2]=yc;f[ca+40>>2]=mc;mc=ca+48|0;zc=ca+44|0;f[zc>>2]=mc;f[mc>>2]=0;f[ca+52>>2]=0;if(yc|0){mc=yc+12|0;f[mc>>2]=(f[mc>>2]|0)+1}if((f[xc>>2]|0)<3){mc=f[P>>2]|0;yc=f[zc>>2]|0;f[yc>>2]=f[mc>>2];f[yc+4>>2]=f[mc+4>>2]}else{f[S>>2]=0;ZS(ca,m)}f[_>>2]=(f[_>>2]|0)+56;Hc=lc}lc=f[Hc>>2]|0;do if(lc|0){_=lc+12|0;ca=f[_>>2]|0;f[_>>2]=ca+-1;if((ca|0)!=1)break;_S(m)}while(0);f[Hc>>2]=0;lc=m+16|0;f[lc>>2]=0;f[lc+4>>2]=0;f[lc+8>>2]=0;f[lc+12>>2]=0;if((f[xc>>2]|0)>0){lc=f[rb>>2]|0;sb=0;do{f[lc+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[xc>>2]|0))}xc=f[P>>2]|0;if((xc|0)!=(W|0))g0(xc);$j(t);uT(o)}else{xc=D+28|0;f[m>>2]=0;f[m+4>>2]=0;F=tT(m,11)|0;G=387309;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));W=sKa(j,m)|0;P=W+4|0;sb=D+32|0;lc=f[sb>>2]|0;if((lc|0)==(f[D+36>>2]|0))Bxa(xc,P);else{f[lc>>2]=f[P>>2];rb=lc+4|0;ba=W+8|0;f[rb>>2]=f[ba>>2];ca=lc+8|0;f[ca>>2]=f[W+12>>2];f[lc+12>>2]=f[W+16>>2];f[lc+16>>2]=f[W+20>>2];f[lc+20>>2]=f[W+24>>2];f[lc+24>>2]=f[W+28>>2];f[lc+28>>2]=f[W+32>>2];f[lc+32>>2]=f[W+36>>2];_=f[W+40>>2]|0;f[lc+36>>2]=_;f[lc+40>>2]=ca;ca=lc+48|0;S=lc+44|0;f[S>>2]=ca;f[ca>>2]=0;f[lc+52>>2]=0;if(_|0){ca=_+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[ba>>2]|0)<3){ba=f[W+48>>2]|0;W=f[S>>2]|0;f[W>>2]=f[ba>>2];f[W+4>>2]=f[ba+4>>2]}else{f[rb>>2]=0;ZS(lc,P)}f[sb>>2]=(f[sb>>2]|0)+56}uT(m)}while(0);f[m>>2]=0;f[m+4>>2]=0;sb=tT(m,6)|0;b[sb>>0]=b[386884]|0;b[sb+1>>0]=b[386885]|0;b[sb+2>>0]=b[386886]|0;b[sb+3>>0]=b[386887]|0;b[sb+4>>0]=b[386888]|0;b[sb+5>>0]=b[386889]|0;sb=f[N>>2]|0;t:do if(!sb)Ic=0;else{P=f[m>>2]|0;lc=(P|0)==0?1154740:P;rb=sb;while(1){ba=f[rb+16>>2]|0;if((P|0)==(ba|0)){Ic=1;break t}W=(ba|0)==0?1154740:ba;if((Ioc(lc,W)|0)<0)Jc=rb;else{if((Ioc(W,lc)|0)>=0){Ic=1;break t}Jc=rb+4|0}rb=f[Jc>>2]|0;if(!rb){Ic=0;break}}}while(0);uT(m);if(Ic|0){f[m>>2]=0;f[m+4>>2]=0;F=tT(m,10)|0;G=454974;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));b[o>>0]=1;rIa(C,m,o)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;sb=tT(m,6)|0;b[sb>>0]=b[386884]|0;b[sb+1>>0]=b[386885]|0;b[sb+2>>0]=b[386886]|0;b[sb+3>>0]=b[386887]|0;b[sb+4>>0]=b[386888]|0;b[sb+5>>0]=b[386889]|0;sb=sKa(j,m)|0;rb=sb+4|0;lc=D+32|0;P=f[lc>>2]|0;if((P|0)==(f[D+36>>2]|0))Bxa(D+28|0,rb);else{f[P>>2]=f[rb>>2];xc=P+4|0;W=sb+8|0;f[xc>>2]=f[W>>2];ba=P+8|0;f[ba>>2]=f[sb+12>>2];f[P+12>>2]=f[sb+16>>2];f[P+16>>2]=f[sb+20>>2];f[P+20>>2]=f[sb+24>>2];f[P+24>>2]=f[sb+28>>2];f[P+28>>2]=f[sb+32>>2];f[P+32>>2]=f[sb+36>>2];S=f[sb+40>>2]|0;f[P+36>>2]=S;f[P+40>>2]=ba;ba=P+48|0;ca=P+44|0;f[ca>>2]=ba;f[ba>>2]=0;f[P+52>>2]=0;if(S|0){ba=S+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[W>>2]|0)<3){W=f[sb+48>>2]|0;sb=f[ca>>2]|0;f[sb>>2]=f[W>>2];f[sb+4>>2]=f[W+4>>2]}else{f[xc>>2]=0;ZS(P,rb)}f[lc>>2]=(f[lc>>2]|0)+56}uT(m)}f[m>>2]=0;f[m+4>>2]=0;lc=tT(m,4)|0;b[lc>>0]=98;b[lc+1>>0]=105;b[lc+2>>0]=97;b[lc+3>>0]=115;lc=f[N>>2]|0;u:do if(!lc)Kc=0;else{rb=f[m>>2]|0;P=(rb|0)==0?1154740:rb;xc=lc;while(1){W=f[xc+16>>2]|0;if((rb|0)==(W|0)){Kc=1;break u}sb=(W|0)==0?1154740:W;if((Ioc(P,sb)|0)<0)Lc=xc;else{if((Ioc(sb,P)|0)>=0){Kc=1;break u}Lc=xc+4|0}xc=f[Lc>>2]|0;if(!xc){Kc=0;break}}}while(0);uT(m);if(Kc|0){f[m>>2]=0;f[m+4>>2]=0;lc=tT(m,8)|0;xc=lc;b[xc>>0]=104;b[xc+1>>0]=97;b[xc+2>>0]=115;b[xc+3>>0]=95;xc=lc+4|0;b[xc>>0]=98;b[xc+1>>0]=105;b[xc+2>>0]=97;b[xc+3>>0]=115;b[o>>0]=1;rIa(C,m,o)|0;uT(m);f[m>>2]=0;f[m+4>>2]=0;xc=tT(m,4)|0;b[xc>>0]=98;b[xc+1>>0]=105;b[xc+2>>0]=97;b[xc+3>>0]=115;xc=sKa(j,m)|0;lc=xc+4|0;P=D+32|0;rb=f[P>>2]|0;if((rb|0)==(f[D+36>>2]|0))Bxa(D+28|0,lc);else{f[rb>>2]=f[lc>>2];sb=rb+4|0;W=xc+8|0;f[sb>>2]=f[W>>2];ca=rb+8|0;f[ca>>2]=f[xc+12>>2];f[rb+12>>2]=f[xc+16>>2];f[rb+16>>2]=f[xc+20>>2];f[rb+20>>2]=f[xc+24>>2];f[rb+24>>2]=f[xc+28>>2];f[rb+28>>2]=f[xc+32>>2];f[rb+32>>2]=f[xc+36>>2];ba=f[xc+40>>2]|0;f[rb+36>>2]=ba;f[rb+40>>2]=ca;ca=rb+48|0;S=rb+44|0;f[S>>2]=ca;f[ca>>2]=0;f[rb+52>>2]=0;if(ba|0){ca=ba+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[W>>2]|0)<3){W=f[xc+48>>2]|0;xc=f[S>>2]|0;f[xc>>2]=f[W>>2];f[xc+4>>2]=f[W+4>>2]}else{f[sb>>2]=0;ZS(rb,lc)}f[P>>2]=(f[P>>2]|0)+56}uT(m)}P=f[h>>2]|0;lc=P;do if((P|0)==387195)ja=453;else{if(!(Ioc((P|0)==0?1154740:P,387195)|0)){ja=453;break}Mc=a+68|0}while(0);if((ja|0)==453){rb=VDc(68)|0;f[o>>2]=0;sb=o+4|0;f[sb>>2]=0;f[rb>>2]=lc;f[rb+4>>2]=f[E>>2];do if(!P){f[rb+8>>2]=0;f[rb+12>>2]=0}else{W=P+-4|0;f[W>>2]=(f[W>>2]|0)+1;W=f[o>>2]|0;xc=f[sb>>2]|0;f[rb+8>>2]=W;f[rb+12>>2]=xc;if(!W)break;xc=W+-4|0;f[xc>>2]=(f[xc>>2]|0)+1}while(0);sb=rb+20|0;f[sb>>2]=0;f[rb+24>>2]=0;f[rb+16>>2]=sb;F=rb+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));sb=VDc(16)|0;f[sb+4>>2]=1;f[sb>>2]=78548;f[sb+8>>2]=rb;f[m>>2]=sb;sb=m+4|0;f[sb>>2]=rb;uT(o);P=(f[sb>>2]|0)+8|0;uT(P);lc=tT(P,3)|0;b[lc>>0]=b[425625]|0;b[lc+1>>0]=b[425626]|0;b[lc+2>>0]=b[425627]|0;lc=a+68|0;P=f[lc>>2]|0;xc=P+60|0;W=f[xc>>2]|0;if((W|0)==(f[P+64>>2]|0))qKa(P+56|0,m);else{P=f[m>>2]|0;f[W>>2]=P;f[W+4>>2]=f[sb>>2];if(!P)Nc=W;else{W=P+4|0;f[W>>2]=(f[W>>2]|0)+1;Nc=f[xc>>2]|0}f[xc>>2]=Nc+8}xc=D+28|0;W=f[xc>>2]|0;p[q>>3]=0.0;f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;l_(W,o,e0()|0)|0;W=f[xc>>2]|0;p[q>>3]=1.0;f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;l_(W+56|0,o,e0()|0)|0;W=f[m>>2]|0;do if(W|0){xc=W+4|0;P=f[xc>>2]|0;f[xc>>2]=P+-1;if((P|0)!=1)break;Yi[f[(f[W>>2]|0)+8>>2]&2047](W)}while(0);Mc=lc}W=f[Mc>>2]|0;rb=W+60|0;P=f[rb>>2]|0;if((P|0)==(f[W+64>>2]|0))qKa(W+56|0,k);else{W=f[k>>2]|0;f[P>>2]=W;f[P+4>>2]=f[B>>2];if(!W)Oc=P;else{P=W+4|0;f[P>>2]=(f[P>>2]|0)+1;Oc=f[rb>>2]|0}f[rb>>2]=Oc+8}break b}while(0);rb=f[a+68>>2]|0;P=rb+56|0;W=VDc(68)|0;f[m>>2]=0;xc=m+4|0;f[xc>>2]=0;sb=tT(m,7)|0;b[sb>>0]=b[425655]|0;b[sb+1>>0]=b[425656]|0;b[sb+2>>0]=b[425657]|0;b[sb+3>>0]=b[425658]|0;b[sb+4>>0]=b[425659]|0;b[sb+5>>0]=b[425660]|0;b[sb+6>>0]=b[425661]|0;sb=f[h>>2]|0;f[W>>2]=sb;f[W+4>>2]=f[E>>2];if(sb|0){S=sb+-4|0;f[S>>2]=(f[S>>2]|0)+1}S=f[m>>2]|0;f[W+8>>2]=S;f[W+12>>2]=f[xc>>2];if(S|0){xc=S+-4|0;f[xc>>2]=(f[xc>>2]|0)+1}xc=W+20|0;f[xc>>2]=0;f[W+24>>2]=0;f[W+16>>2]=xc;F=W+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));xc=VDc(16)|0;f[xc+4>>2]=1;f[xc>>2]=78548;f[xc+8>>2]=W;f[l>>2]=xc;S=l+4|0;f[S>>2]=W;sb=rb+60|0;ca=f[sb>>2]|0;if((ca|0)==(f[rb+64>>2]|0))qKa(P,l);else{f[ca>>2]=xc;f[ca+4>>2]=W;ca=xc+4|0;f[ca>>2]=(f[ca>>2]|0)+1;f[sb>>2]=(f[sb>>2]|0)+8}sb=f[l>>2]|0;do if(sb|0){ca=sb+4|0;xc=f[ca>>2]|0;f[ca>>2]=xc+-1;if((xc|0)!=1)break;Yi[f[(f[sb>>2]|0)+8>>2]&2047](sb)}while(0);f[l>>2]=0;f[S>>2]=0;uT(m);gKa(a);break b}while(0);sb=f[a+68>>2]|0;W=sb+56|0;P=VDc(68)|0;f[m>>2]=0;rb=m+4|0;f[rb>>2]=0;xc=tT(m,4)|0;b[xc>>0]=84;b[xc+1>>0]=97;b[xc+2>>0]=110;b[xc+3>>0]=72;xc=f[h>>2]|0;f[P>>2]=xc;f[P+4>>2]=f[E>>2];if(xc|0){ca=xc+-4|0;f[ca>>2]=(f[ca>>2]|0)+1}ca=f[m>>2]|0;f[P+8>>2]=ca;f[P+12>>2]=f[rb>>2];if(ca|0){rb=ca+-4|0;f[rb>>2]=(f[rb>>2]|0)+1}rb=P+20|0;f[rb>>2]=0;f[P+24>>2]=0;f[P+16>>2]=rb;F=P+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));rb=VDc(16)|0;f[rb+4>>2]=1;f[rb>>2]=78548;f[rb+8>>2]=P;f[l>>2]=rb;ca=l+4|0;f[ca>>2]=P;xc=sb+60|0;ba=f[xc>>2]|0;if((ba|0)==(f[sb+64>>2]|0))qKa(W,l);else{f[ba>>2]=rb;f[ba+4>>2]=P;ba=rb+4|0;f[ba>>2]=(f[ba>>2]|0)+1;f[xc>>2]=(f[xc>>2]|0)+8}xc=f[l>>2]|0;do if(xc|0){ba=xc+4|0;rb=f[ba>>2]|0;f[ba>>2]=rb+-1;if((rb|0)!=1)break;Yi[f[(f[xc>>2]|0)+8>>2]&2047](xc)}while(0);f[l>>2]=0;f[ca>>2]=0;uT(m);gKa(a);break b}while(0);xc=f[a+68>>2]|0;P=xc+56|0;W=VDc(68)|0;f[m>>2]=0;sb=m+4|0;f[sb>>2]=0;rb=tT(m,4)|0;b[rb>>0]=82;b[rb+1>>0]=101;b[rb+2>>0]=76;b[rb+3>>0]=85;rb=f[h>>2]|0;f[W>>2]=rb;f[W+4>>2]=f[E>>2];if(rb|0){ba=rb+-4|0;f[ba>>2]=(f[ba>>2]|0)+1}ba=f[m>>2]|0;f[W+8>>2]=ba;f[W+12>>2]=f[sb>>2];if(ba|0){sb=ba+-4|0;f[sb>>2]=(f[sb>>2]|0)+1}sb=W+20|0;f[sb>>2]=0;f[W+24>>2]=0;f[W+16>>2]=sb;F=W+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));sb=VDc(16)|0;f[sb+4>>2]=1;f[sb>>2]=78548;f[sb+8>>2]=W;f[l>>2]=sb;ba=l+4|0;f[ba>>2]=W;rb=xc+60|0;_=f[rb>>2]|0;if((_|0)==(f[xc+64>>2]|0))qKa(P,l);else{f[_>>2]=sb;f[_+4>>2]=W;_=sb+4|0;f[_>>2]=(f[_>>2]|0)+1;f[rb>>2]=(f[rb>>2]|0)+8}rb=f[l>>2]|0;do if(rb|0){_=rb+4|0;sb=f[_>>2]|0;f[_>>2]=sb+-1;if((sb|0)!=1)break;Yi[f[(f[rb>>2]|0)+8>>2]&2047](rb)}while(0);f[l>>2]=0;f[ba>>2]=0;uT(m);gKa(a);break b}while(0);rb=(f[B>>2]|0)+8|0;uT(rb);W=tT(rb,7)|0;b[W>>0]=b[426093]|0;b[W+1>>0]=b[426094]|0;b[W+2>>0]=b[426095]|0;b[W+3>>0]=b[426096]|0;b[W+4>>0]=b[426097]|0;b[W+5>>0]=b[426098]|0;b[W+6>>0]=b[426099]|0;rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,4)|0;b[W>>0]=115;b[W+1>>0]=105;b[W+2>>0]=122;b[W+3>>0]=101;W=f[I>>2]|0;if(!W){uT(l);f[l>>2]=0;Pc=l+4|0;f[Pc>>2]=0;Qc=tT(l,24)|0;F=Qc;G=387129;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,610)}rb=f[l>>2]|0;P=(rb|0)==0?1154740:rb;xc=W;while(1){sb=f[xc+16>>2]|0;if((rb|0)==(sb|0)){ja=222;break}_=(sb|0)==0?1154740:sb;if((Ioc(P,_)|0)<0)Rc=xc;else{if((Ioc(_,P)|0)>=0){ja=226;break}Rc=xc+4|0}xc=f[Rc>>2]|0;if(!xc){ja=224;break}}if((ja|0)==222)uT(l);else if((ja|0)==224){uT(l);f[l>>2]=0;Pc=l+4|0;f[Pc>>2]=0;Qc=tT(l,24)|0;F=Qc;G=387129;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,610)}else if((ja|0)==226)uT(l);f[m>>2]=0;f[m+4>>2]=0;xc=tT(m,4)|0;b[xc>>0]=115;b[xc+1>>0]=105;b[xc+2>>0]=122;b[xc+3>>0]=101;TFa(l,lIa(i,m)|0);uT(m);f[m>>2]=0;f[m+4>>2]=0;xc=tT(m,3)|0;b[xc>>0]=b[431774]|0;b[xc+1>>0]=b[431775]|0;b[xc+2>>0]=b[431776]|0;bIa(C,m,l)|0;uT(m);f[o>>2]=0;f[o+4>>2]=0;F=tT(o,9)|0;G=387154;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));xc=f[I>>2]|0;do if(!xc)Sc=1;else{P=f[o>>2]|0;rb=(P|0)==0?1154740:P;W=I;_=xc;v:while(1){sb=_;while(1){mc=f[sb+16>>2]|0;if((mc|0)==(P|0))break;if((Ioc((mc|0)==0?1154740:mc,rb)|0)>=0)break;mc=f[sb+4>>2]|0;if(!mc){Tc=W;break v}else sb=mc}_=f[sb>>2]|0;if(!_){Tc=sb;break}else W=sb}if((Tc|0)==(I|0)){Sc=1;break}W=f[Tc+16>>2]|0;if((P|0)!=(W|0)?(Ioc(rb,(W|0)==0?1154740:W)|0)<=-1:0){Sc=1;break}W=DHa(Tc+24|0,-1)|0;Sc=(W|0)!=0|(J|0)!=0}while(0);uT(o);f[m>>2]=Sc&1;f[o>>2]=0;f[o+4>>2]=0;xc=tT(o,4)|0;b[xc>>0]=97;b[xc+1>>0]=120;b[xc+2>>0]=105;b[xc+3>>0]=115;$Ha(C,o,m)|0;uT(o);xc=f[a+68>>2]|0;W=xc+60|0;_=f[W>>2]|0;if((_|0)==(f[xc+64>>2]|0))qKa(xc+56|0,k);else{xc=f[k>>2]|0;f[_>>2]=xc;f[_+4>>2]=f[B>>2];if(!xc)Uc=_;else{_=xc+4|0;f[_>>2]=(f[_>>2]|0)+1;Uc=f[W>>2]|0}f[W>>2]=Uc+8}JFa(l);break b}while(0);W=(f[B>>2]|0)+8|0;uT(W);F=tT(W,12)|0;G=425612;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;W=tT(l,6)|0;b[W>>0]=b[386884]|0;b[W+1>>0]=b[386885]|0;b[W+2>>0]=b[386886]|0;b[W+3>>0]=b[386887]|0;b[W+4>>0]=b[386888]|0;b[W+5>>0]=b[386889]|0;W=f[N>>2]|0;w:do if(!W)Vc=0;else{_=f[l>>2]|0;xc=(_|0)==0?1154740:_;ba=W;while(1){ca=f[ba+16>>2]|0;if((_|0)==(ca|0)){Vc=1;break w}mc=(ca|0)==0?1154740:ca;if((Ioc(xc,mc)|0)<0)Wc=ba;else{if((Ioc(mc,xc)|0)>=0){Vc=1;break w}Wc=ba+4|0}ba=f[Wc>>2]|0;if(!ba){Vc=0;break}}}while(0);uT(l);if(!Vc){f[l>>2]=0;f[l+4>>2]=0;F=tT(l,28)|0;G=386891;H=F+28|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,593)}f[m>>2]=0;f[m+4>>2]=0;W=tT(m,6)|0;b[W>>0]=b[386884]|0;b[W+1>>0]=b[386885]|0;b[W+2>>0]=b[386886]|0;b[W+3>>0]=b[386887]|0;b[W+4>>0]=b[386888]|0;b[W+5>>0]=b[386889]|0;W=sKa(j,m)|0;ba=W+4|0;f[l>>2]=f[ba>>2];xc=l+4|0;_=W+8|0;f[xc>>2]=f[_>>2];mc=l+8|0;f[mc>>2]=f[W+12>>2];ca=l+12|0;f[ca>>2]=f[W+16>>2];yc=l+16|0;f[yc>>2]=f[W+20>>2];zc=l+20|0;f[zc>>2]=f[W+24>>2];Xc=l+24|0;f[Xc>>2]=f[W+28>>2];Yc=l+28|0;f[Yc>>2]=f[W+32>>2];Zc=l+32|0;f[Zc>>2]=f[W+36>>2];_c=l+36|0;$c=f[W+40>>2]|0;f[_c>>2]=$c;ad=l+40|0;f[ad>>2]=mc;bd=l+48|0;cd=l+44|0;f[cd>>2]=bd;f[bd>>2]=0;f[l+52>>2]=0;if($c|0){dd=$c+12|0;f[dd>>2]=(f[dd>>2]|0)+1}if((f[_>>2]|0)<3){_=f[W+48>>2]|0;W=f[cd>>2]|0;f[W>>2]=f[_>>2];f[W+4>>2]=f[_+4>>2]}else{f[xc>>2]=0;ZS(l,ba)}uT(m);ba=D+28|0;_=D+32|0;W=f[_>>2]|0;dd=D+36|0;if((W|0)==(f[dd>>2]|0))Bxa(ba,l);else{f[W>>2]=f[l>>2];$c=W+4|0;f[$c>>2]=f[xc>>2];ed=W+8|0;f[ed>>2]=f[mc>>2];f[W+12>>2]=f[ca>>2];f[W+16>>2]=f[yc>>2];f[W+20>>2]=f[zc>>2];f[W+24>>2]=f[Xc>>2];f[W+28>>2]=f[Yc>>2];f[W+32>>2]=f[Zc>>2];Zc=f[_c>>2]|0;f[W+36>>2]=Zc;f[W+40>>2]=ed;ed=W+48|0;Yc=W+44|0;f[Yc>>2]=ed;f[ed>>2]=0;f[W+52>>2]=0;if(Zc|0){ed=Zc+12|0;f[ed>>2]=(f[ed>>2]|0)+1}if((f[xc>>2]|0)<3){ed=f[cd>>2]|0;Zc=f[Yc>>2]|0;f[Zc>>2]=f[ed>>2];f[Zc+4>>2]=f[ed+4>>2]}else{f[$c>>2]=0;ZS(W,l)}f[_>>2]=(f[_>>2]|0)+56}f[o>>2]=0;f[o+4>>2]=0;W=tT(o,4)|0;b[W>>0]=98;b[W+1>>0]=105;b[W+2>>0]=97;b[W+3>>0]=115;W=f[N>>2]|0;x:do if(!W)fd=0;else{$c=f[o>>2]|0;ed=($c|0)==0?1154740:$c;Zc=W;while(1){Yc=f[Zc+16>>2]|0;if(($c|0)==(Yc|0)){fd=1;break x}Xc=(Yc|0)==0?1154740:Yc;if((Ioc(ed,Xc)|0)<0)gd=Zc;else{if((Ioc(Xc,ed)|0)>=0){fd=1;break x}gd=Zc+4|0}Zc=f[gd>>2]|0;if(!Zc){fd=0;break}}}while(0);uT(o);b[m>>0]=fd&1;if(fd){f[o>>2]=0;f[o+4>>2]=0;W=tT(o,4)|0;b[W>>0]=98;b[W+1>>0]=105;b[W+2>>0]=97;b[W+3>>0]=115;W=sKa(j,o)|0;Zc=W+4|0;ed=f[_>>2]|0;if((ed|0)==(f[dd>>2]|0))Bxa(ba,Zc);else{f[ed>>2]=f[Zc>>2];$c=ed+4|0;Xc=W+8|0;f[$c>>2]=f[Xc>>2];Yc=ed+8|0;f[Yc>>2]=f[W+12>>2];f[ed+12>>2]=f[W+16>>2];f[ed+16>>2]=f[W+20>>2];f[ed+20>>2]=f[W+24>>2];f[ed+24>>2]=f[W+28>>2];f[ed+28>>2]=f[W+32>>2];f[ed+32>>2]=f[W+36>>2];zc=f[W+40>>2]|0;f[ed+36>>2]=zc;f[ed+40>>2]=Yc;Yc=ed+48|0;ca=ed+44|0;f[ca>>2]=Yc;f[Yc>>2]=0;f[ed+52>>2]=0;if(zc|0){Yc=zc+12|0;f[Yc>>2]=(f[Yc>>2]|0)+1}if((f[Xc>>2]|0)<3){Xc=f[W+48>>2]|0;W=f[ca>>2]|0;f[W>>2]=f[Xc>>2];f[W+4>>2]=f[Xc+4>>2]}else{f[$c>>2]=0;ZS(ed,Zc)}f[_>>2]=(f[_>>2]|0)+56}uT(o)}f[o>>2]=0;f[o+4>>2]=0;F=tT(o,9)|0;G=454939;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));rIa(C,o,m)|0;uT(o);f[o>>2]=0;f[o+4>>2]=0;F=tT(o,10)|0;G=455057;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));$Ha(C,o,f[ad>>2]|0)|0;uT(o);_=f[a+68>>2]|0;ba=_+60|0;dd=f[ba>>2]|0;if((dd|0)==(f[_+64>>2]|0))qKa(_+56|0,k);else{_=f[k>>2]|0;f[dd>>2]=_;f[dd+4>>2]=f[B>>2];if(!_)hd=dd;else{dd=_+4|0;f[dd>>2]=(f[dd>>2]|0)+1;hd=f[ba>>2]|0}f[ba>>2]=hd+8}ba=f[_c>>2]|0;do if(ba|0){dd=ba+12|0;_=f[dd>>2]|0;f[dd>>2]=_+-1;if((_|0)!=1)break;_S(l)}while(0);f[_c>>2]=0;f[yc>>2]=0;f[yc+4>>2]=0;f[yc+8>>2]=0;f[yc+12>>2]=0;if((f[xc>>2]|0)>0){ba=f[ad>>2]|0;_=0;do{f[ba+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[xc>>2]|0))}xc=f[cd>>2]|0;if((xc|0)!=(bd|0))g0(xc);break b}while(0);xc=(f[B>>2]|0)+8|0;uT(xc);_=tT(xc,7)|0;b[_>>0]=b[454888]|0;b[_+1>>0]=b[454889]|0;b[_+2>>0]=b[454890]|0;b[_+3>>0]=b[454891]|0;b[_+4>>0]=b[454892]|0;b[_+5>>0]=b[454893]|0;b[_+6>>0]=b[454894]|0;rKa(a,i,j);_=f[h>>2]|0;if((_|0)!=386997?(Ioc((_|0)==0?1154740:_,386997)|0)!=0:0)id=_;else{f[l>>2]=0;f[l+4>>2]=0;_=tT(l,4)|0;b[_>>0]=112;b[_+1>>0]=111;b[_+2>>0]=111;b[_+3>>0]=108;qIa(C,l,387037)|0;uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,15)|0;G=387041;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[m>>2]=0;f[m+4>>2]=0;_=tT(m,7)|0;b[_>>0]=b[387057]|0;b[_+1>>0]=b[387058]|0;b[_+2>>0]=b[387059]|0;b[_+3>>0]=b[387060]|0;b[_+4>>0]=b[387061]|0;b[_+5>>0]=b[387062]|0;b[_+6>>0]=b[387063]|0;$Ha(C,l,sKa(j,m)|0)|0;uT(m);uT(l);id=f[h>>2]|0}if(!((id|0)!=387015?(Ioc((id|0)==0?1154740:id,387015)|0)!=0:0)){f[l>>2]=0;f[l+4>>2]=0;_=tT(l,4)|0;b[_>>0]=112;b[_+1>>0]=111;b[_+2>>0]=111;b[_+3>>0]=108;qIa(C,l,387065)|0;uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,20)|0;G=452723;H=F+20|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,17)|0;G=387069;H=F+17|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));_=f[I>>2]|0;y:do if(!_)ja=134;else{xc=f[o>>2]|0;ba=(xc|0)==0?1154740:xc;ad=_;while(1){yc=f[ad+16>>2]|0;if((xc|0)==(yc|0))break;_c=(yc|0)==0?1154740:yc;if((Ioc(ba,_c)|0)<0)jd=ad;else{if((Ioc(_c,ba)|0)>=0)break;jd=ad+4|0}ad=f[jd>>2]|0;if(!ad){ja=134;break y}}f[q>>2]=0;f[q+4>>2]=0;F=tT(q,17)|0;G=387069;H=F+17|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));ad=DHa(lIa(i,q)|0,-1)|0;b[m>>0]=((ad|0)!=0|(J|0)!=0)&1;rIa(C,l,m)|0;uT(q)}while(0);if((ja|0)==134){b[m>>0]=0;rIa(C,l,m)|0}uT(o);uT(l)}tKa(i,C);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,9)|0;G=452699;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));_=f[I>>2]|0;if(!_){uT(l);f[l>>2]=0;kd=l+4|0;f[kd>>2]=0;ld=tT(l,29)|0;F=ld;G=387087;H=F+29|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,583)}ad=f[l>>2]|0;ba=(ad|0)==0?1154740:ad;xc=_;while(1){bd=f[xc+16>>2]|0;if((ad|0)==(bd|0)){ja=144;break}cd=(bd|0)==0?1154740:bd;if((Ioc(ba,cd)|0)<0)md=xc;else{if((Ioc(cd,ba)|0)>=0){ja=148;break}md=xc+4|0}xc=f[md>>2]|0;if(!xc){ja=146;break}}if((ja|0)==144)uT(l);else if((ja|0)==146){uT(l);f[l>>2]=0;kd=l+4|0;f[kd>>2]=0;ld=tT(l,29)|0;F=ld;G=387087;H=F+29|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,583)}else if((ja|0)==148)uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,9)|0;G=452699;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,9)|0;G=452699;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));xc=DHa(lIa(i,o)|0,-1)|0;b[m>>0]=((xc|0)!=0|(J|0)!=0)&1;rIa(C,l,m)|0;uT(o);uT(l);xc=f[a+68>>2]|0;ba=xc+60|0;ad=f[ba>>2]|0;if((ad|0)==(f[xc+64>>2]|0)){qKa(xc+56|0,k);break b}xc=f[k>>2]|0;f[ad>>2]=xc;f[ad+4>>2]=f[B>>2];if(!xc)nd=ad;else{ad=xc+4|0;f[ad>>2]=(f[ad>>2]|0)+1;nd=f[ba>>2]|0}f[ba>>2]=nd+8;break b}while(0);rKa(a,i,j);break}Q=(f[B>>2]|0)+8|0;uT(Q);F=tT(Q,11)|0;G=455045;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));rKa(a,i,j);f[l>>2]=0;f[l+4>>2]=0;Q=tT(l,6)|0;b[Q>>0]=b[386884]|0;b[Q+1>>0]=b[386885]|0;b[Q+2>>0]=b[386886]|0;b[Q+3>>0]=b[386887]|0;b[Q+4>>0]=b[386888]|0;b[Q+5>>0]=b[386889]|0;Q=f[N>>2]|0;z:do if(!Q)od=0;else{ba=f[l>>2]|0;ad=(ba|0)==0?1154740:ba;xc=Q;while(1){_=f[xc+16>>2]|0;if((ba|0)==(_|0)){od=1;break z}cd=(_|0)==0?1154740:_;if((Ioc(ad,cd)|0)<0)pd=xc;else{if((Ioc(cd,ad)|0)>=0){od=1;break z}pd=xc+4|0}xc=f[pd>>2]|0;if(!xc){od=0;break}}}while(0);uT(l);if(!od){f[l>>2]=0;f[l+4>>2]=0;F=tT(l,28)|0;G=386891;H=F+28|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,l,386920,386595,524)}Q=D+28|0;f[l>>2]=0;f[l+4>>2]=0;xc=tT(l,6)|0;b[xc>>0]=b[386884]|0;b[xc+1>>0]=b[386885]|0;b[xc+2>>0]=b[386886]|0;b[xc+3>>0]=b[386887]|0;b[xc+4>>0]=b[386888]|0;b[xc+5>>0]=b[386889]|0;xc=sKa(j,l)|0;ad=xc+4|0;ba=D+32|0;cd=f[ba>>2]|0;_=D+36|0;if((cd|0)==(f[_>>2]|0))Bxa(Q,ad);else{f[cd>>2]=f[ad>>2];bd=cd+4|0;_c=xc+8|0;f[bd>>2]=f[_c>>2];yc=cd+8|0;f[yc>>2]=f[xc+12>>2];f[cd+12>>2]=f[xc+16>>2];f[cd+16>>2]=f[xc+20>>2];f[cd+20>>2]=f[xc+24>>2];f[cd+24>>2]=f[xc+28>>2];f[cd+28>>2]=f[xc+32>>2];f[cd+32>>2]=f[xc+36>>2];dd=f[xc+40>>2]|0;f[cd+36>>2]=dd;f[cd+40>>2]=yc;yc=cd+48|0;Zc=cd+44|0;f[Zc>>2]=yc;f[yc>>2]=0;f[cd+52>>2]=0;if(dd|0){yc=dd+12|0;f[yc>>2]=(f[yc>>2]|0)+1}if((f[_c>>2]|0)<3){_c=f[xc+48>>2]|0;xc=f[Zc>>2]|0;f[xc>>2]=f[_c>>2];f[xc+4>>2]=f[_c+4>>2]}else{f[bd>>2]=0;ZS(cd,ad)}f[ba>>2]=(f[ba>>2]|0)+56}uT(l);f[m>>2]=0;f[m+4>>2]=0;ad=tT(m,4)|0;b[ad>>0]=98;b[ad+1>>0]=105;b[ad+2>>0]=97;b[ad+3>>0]=115;ad=f[N>>2]|0;A:do if(!ad)qd=0;else{cd=f[m>>2]|0;bd=(cd|0)==0?1154740:cd;_c=ad;while(1){xc=f[_c+16>>2]|0;if((cd|0)==(xc|0)){qd=1;break A}Zc=(xc|0)==0?1154740:xc;if((Ioc(bd,Zc)|0)<0)rd=_c;else{if((Ioc(Zc,bd)|0)>=0){qd=1;break A}rd=_c+4|0}_c=f[rd>>2]|0;if(!_c){qd=0;break}}}while(0);uT(m);b[l>>0]=qd;f[m>>2]=0;f[m+4>>2]=0;F=tT(m,9)|0;G=454939;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));rIa(C,m,l)|0;uT(m);if(b[l>>0]|0){f[m>>2]=0;f[m+4>>2]=0;ad=tT(m,4)|0;b[ad>>0]=98;b[ad+1>>0]=105;b[ad+2>>0]=97;b[ad+3>>0]=115;ad=sKa(j,m)|0;_c=ad+4|0;bd=f[ba>>2]|0;if((bd|0)==(f[_>>2]|0))Bxa(Q,_c);else{f[bd>>2]=f[_c>>2];cd=bd+4|0;Zc=ad+8|0;f[cd>>2]=f[Zc>>2];xc=bd+8|0;f[xc>>2]=f[ad+12>>2];f[bd+12>>2]=f[ad+16>>2];f[bd+16>>2]=f[ad+20>>2];f[bd+20>>2]=f[ad+24>>2];f[bd+24>>2]=f[ad+28>>2];f[bd+28>>2]=f[ad+32>>2];f[bd+32>>2]=f[ad+36>>2];yc=f[ad+40>>2]|0;f[bd+36>>2]=yc;f[bd+40>>2]=xc;xc=bd+48|0;dd=bd+44|0;f[dd>>2]=xc;f[xc>>2]=0;f[bd+52>>2]=0;if(yc|0){xc=yc+12|0;f[xc>>2]=(f[xc>>2]|0)+1}if((f[Zc>>2]|0)<3){Zc=f[ad+48>>2]|0;ad=f[dd>>2]|0;f[ad>>2]=f[Zc>>2];f[ad+4>>2]=f[Zc+4>>2]}else{f[cd>>2]=0;ZS(bd,_c)}f[ba>>2]=(f[ba>>2]|0)+56}uT(m)}f[m>>2]=0;f[m+4>>2]=0;F=tT(m,10)|0;G=455057;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[q>>2]=0;f[q+4>>2]=0;F=tT(q,12)|0;G=386936;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));ba=DHa(lIa(i,q)|0,-1)|0;f[o>>2]=ba;$Ha(C,m,o)|0;uT(q);uT(m);tKa(i,C);ba=f[h>>2]|0;if(!((ba|0)!=386863?(Ioc((ba|0)==0?1154740:ba,386863)|0)!=0:0)){ba=f[Q>>2]|0;if((f[ba+4>>2]|0)!=2){f[m>>2]=0;f[m+4>>2]=0;F=tT(m,30)|0;G=386949;H=F+30|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));z5(-215,m,386920,386595,539)}_=f[(f[ba+40>>2]|0)+4>>2]|0;f[m>>2]=0;_c=m+4|0;f[_c>>2]=0;f[m+8>>2]=0;bd=VDc(16)|0;f[m>>2]=bd;cd=bd+16|0;f[m+8>>2]=cd;f[bd>>2]=0;f[bd+4>>2]=0;f[bd+8>>2]=0;f[bd+12>>2]=0;f[_c>>2]=cd;f[bd>>2]=f[f[(f[Q>>2]|0)+40>>2]>>2];f[o>>2]=0;f[o+4>>2]=0;bd=tT(o,8)|0;cd=bd;b[cd>>0]=107;b[cd+1>>0]=101;b[cd+2>>0]=114;b[cd+3>>0]=110;cd=bd+4|0;b[cd>>0]=101;b[cd+1>>0]=108;b[cd+2>>0]=95;b[cd+3>>0]=104;cd=DHa(lIa(C,o)|0,-1)|0;f[(f[m>>2]|0)+8>>2]=cd;uT(o);f[o>>2]=0;f[o+4>>2]=0;cd=tT(o,8)|0;bd=cd;b[bd>>0]=107;b[bd+1>>0]=101;b[bd+2>>0]=114;b[bd+3>>0]=110;bd=cd+4|0;b[bd>>0]=101;b[bd+1>>0]=108;b[bd+2>>0]=95;b[bd+3>>0]=119;bd=DHa(lIa(C,o)|0,-1)|0;f[(f[m>>2]|0)+12>>2]=bd;uT(o);bd=f[m>>2]|0;cd=(_|0)/(Y(f[bd+12>>2]|0,f[bd+8>>2]|0)|0)|0;f[bd+4>>2]=cd;nT(o,f[Q>>2]|0,1,m);cd=f[Q>>2]|0;bd=o+36|0;if((cd|0)!=(o|0)){_=f[bd>>2]|0;if(_|0){Zc=_+12|0;f[Zc>>2]=(f[Zc>>2]|0)+1}Zc=cd+36|0;_=f[Zc>>2]|0;do if(_|0){ad=_+12|0;dd=f[ad>>2]|0;f[ad>>2]=dd+-1;if((dd|0)!=1)break;_S(cd)}while(0);f[Zc>>2]=0;_=cd+16|0;Q=cd+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Q>>2]|0)>0){ba=f[cd+40>>2]|0;dd=0;do{f[ba+(dd<<2)>>2]=0;dd=dd+1|0;sd=f[Q>>2]|0}while((dd|0)<(sd|0));f[cd>>2]=f[o>>2];if((sd|0)<3)ja=91;else ja=93}else{f[cd>>2]=f[o>>2];ja=91}do if((ja|0)==91){dd=f[o+4>>2]|0;if((dd|0)>=3){ja=93;break}f[Q>>2]=dd;f[cd+8>>2]=f[o+8>>2];f[cd+12>>2]=f[o+12>>2];dd=f[o+44>>2]|0;ba=f[cd+44>>2]|0;f[ba>>2]=f[dd>>2];f[ba+4>>2]=f[dd+4>>2]}while(0);if((ja|0)==93)ZS(cd,o);f[_>>2]=f[o+16>>2];f[cd+20>>2]=f[o+20>>2];f[cd+24>>2]=f[o+24>>2];f[cd+28>>2]=f[o+28>>2];f[cd+32>>2]=f[o+32>>2];f[Zc>>2]=f[bd>>2]}Q=f[bd>>2]|0;do if(Q|0){dd=Q+12|0;ba=f[dd>>2]|0;f[dd>>2]=ba+-1;if((ba|0)!=1)break;_S(o)}while(0);f[bd>>2]=0;Q=o+16|0;Zc=o+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[Zc>>2]|0)>0){Q=f[o+40>>2]|0;cd=0;do{f[Q+(cd<<2)>>2]=0;cd=cd+1|0}while((cd|0)<(f[Zc>>2]|0))}Zc=f[o+44>>2]|0;if((Zc|0)!=(o+48|0))g0(Zc);Zc=f[m>>2]|0;if(Zc|0){cd=f[_c>>2]|0;if((cd|0)!=(Zc|0))f[_c>>2]=cd+(~((cd+-4-Zc|0)>>>2)<<2);YDc(Zc)}}Zc=f[a+68>>2]|0;cd=Zc+60|0;Q=f[cd>>2]|0;if((Q|0)==(f[Zc+64>>2]|0))qKa(Zc+56|0,k);else{Zc=f[k>>2]|0;f[Q>>2]=Zc;f[Q+4>>2]=f[B>>2];if(!Zc)td=Q;else{Q=Zc+4|0;f[Q>>2]=(f[Q>>2]|0)+1;td=f[cd>>2]|0}f[cd>>2]=td+8}}else ja=24;while(0);do if((ja|0)==24){D=a+68|0;O=f[D>>2]|0;cd=O+60|0;Q=f[cd>>2]|0;if((Q|0)==(f[O+64>>2]|0)){qKa(O+56|0,k);ud=B}else{Zc=f[k>>2]|0;f[Q>>2]=Zc;f[Q+4>>2]=f[B>>2];if(!Zc)vd=Q;else{Q=Zc+4|0;f[Q>>2]=(f[Q>>2]|0)+1;vd=f[cd>>2]|0}f[cd>>2]=vd+8;ud=B}f[D>>2]=f[ud>>2];rKa(a,i,j);f[D>>2]=O;O=f[h>>2]|0;if((O|0)!=386750?(D=(O|0)==0?1154740:O,Ioc(D,386750)|0):0){if((((O|0)!=454781?!((Ioc(D,454781)|0)==0|(O|0)==386771):0)?!((Ioc(D,386771)|0)==0|(O|0)==386781):0)?Ioc(D,386781)|0:0)break;f[l>>2]=0;f[l+4>>2]=0;F=tT(l,9)|0;G=386834;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,9)|0;G=386834;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));_c=DHa(lIa(i,o)|0,-1)|0;f[m>>2]=_c;$Ha(C,l,m)|0;uT(o);uT(l);break}f[l>>2]=0;f[l+4>>2]=0;F=tT(l,14)|0;G=386803;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,14)|0;G=386803;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));_c=DHa(lIa(i,o)|0,-1)|0;f[m>>2]=_c;$Ha(C,l,m)|0;uT(o);uT(l);f[l>>2]=0;f[l+4>>2]=0;F=tT(l,15)|0;G=386818;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=tT(o,15)|0;G=386818;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));_c=DHa(lIa(i,o)|0,-1)|0;f[m>>2]=_c;$Ha(C,l,m)|0;uT(o);uT(l)}while(0);C=f[k>>2]|0;if(C|0?(B=C+4|0,_c=f[B>>2]|0,f[B>>2]=_c+-1,(_c|0)==1):0)Yi[f[(f[C>>2]|0)+8>>2]&2047](C);vKa(j,f[N>>2]|0);IFa(i,f[I>>2]|0)}while(0);i=f[A>>2]|0;do if(i){j=f[e>>2]|0;k=a+20|0;l=i;while(1){o=f[l+16>>2]|0;if((j|0)<(o|0)){m=f[l>>2]|0;if(!m){ja=1211;break}else{wd=l;xd=m}}else{if((o|0)>=(j|0)){ja=1215;break}yd=l+4|0;o=f[yd>>2]|0;if(!o){ja=1214;break}else{wd=yd;xd=o}}k=wd;l=xd}if((ja|0)==1211){zd=l;Ad=l;break}else if((ja|0)==1214){zd=yd;Ad=l;break}else if((ja|0)==1215){zd=k;Ad=l;break}}else{zd=A;Ad=A}while(0);if(!(f[zd>>2]|0)){A=VDc(20)|0;f[A+16>>2]=f[e>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Ad;f[zd>>2]=A;Ad=f[f[z>>2]>>2]|0;if(!Ad)Bd=A;else{f[z>>2]=Ad;Bd=f[zd>>2]|0}laa(f[a+20>>2]|0,Bd);Bd=a+24|0;f[Bd>>2]=(f[Bd>>2]|0)+1}uT(h);uT(g);u=d;return}function kKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((b|0)<0)c=YKa(f[a+12>>2]|0)|0;else c=b;b=a+16|0;d=a+20|0;e=f[d>>2]|0;do if(e){g=e;do{h=f[g+16>>2]|0;if((c|0)<(h|0))i=g;else{if((h|0)>=(c|0)){j=25;break}i=g+4|0}g=f[i>>2]|0}while((g|0)!=0);if((j|0)==25)return;g=a+20|0;h=e;while(1){k=f[h+16>>2]|0;if((c|0)<(k|0)){l=f[h>>2]|0;if(!l){j=13;break}else{m=h;n=l}}else{if((k|0)>=(c|0)){j=17;break}o=h+4|0;k=f[o>>2]|0;if(!k){j=16;break}else{m=o;n=k}}g=m;h=n}if((j|0)==13){p=h;q=h;break}else if((j|0)==16){p=o;q=h;break}else if((j|0)==17){p=g;q=h;break}}else{p=d;q=d}while(0);if(!(f[p>>2]|0)){d=VDc(20)|0;f[d+16>>2]=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=q;f[p>>2]=d;q=f[f[b>>2]>>2]|0;if(!q)r=d;else{f[b>>2]=q;r=f[p>>2]|0}laa(f[a+20>>2]|0,r);r=a+24|0;f[r>>2]=(f[r>>2]|0)+1}r=YKa(f[a+12>>2]|0)|0;if((r|0)>0)s=0;else return;do{gKa(a);gKa(a);s=s+1|0}while((s|0)!=(r|0));return}function lKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=c+12|0;c=YKa(f[g>>2]|0)|0;f[e>>2]=0;h=e+4|0;f[h>>2]=0;if(!c)i=0;else{XIc(tT(e,c)|0,0,c|0)|0;i=f[e>>2]|0}MKa(f[g>>2]|0,(i|0)==0?1154740:i,c)|0;c=f[e>>2]|0;i=f[h>>2]|0;h=c;a:do if(i|0?(j=c+i|0,(i|0)>0):0){k=c;while(1){if((b[k>>0]|0)==86){if(k>>>0>=j>>>0)break a;l=k+1|0;if((b[l>>0]|0)==32)break;else m=l}else m=k+1|0;if(m>>>0<j>>>0)k=m;else break a}if(l>>>0<j>>>0&(k|0)==(c|0)){n=YKa(f[g>>2]|0)|0;f[a>>2]=0;f[a+4>>2]=0;if(!n)o=0;else{XIc(tT(a,n)|0,0,n|0)|0;o=f[a>>2]|0}MKa(f[g>>2]|0,(o|0)==0?1154740:o,n)|0;uT(e);u=d;return}}while(0);f[a>>2]=h;f[a+4>>2]=i;if(!c){uT(e);u=d;return}i=c+-4|0;f[i>>2]=(f[i>>2]|0)+1;uT(e);u=d;return}function mKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+48|0;g=e+32|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=f[a>>2]|0;m=a+4|0;n=f[m>>2]|0;o=l;if(!n){p=-1;u=e;return p|0}q=b[d>>0]|0;if(!(q<<24>>24)){p=-1;u=e;return p|0}r=l+n|0;if((n|0)>0)s=l;else{p=-1;u=e;return p|0}a:while(1){t=0;v=q;while(1){w=s+t|0;if(v<<24>>24!=(b[w>>0]|0))break;t=t+1|0;if(w>>>0>=r>>>0){p=-1;x=51;break a}v=b[d+t>>0]|0;if(!(v<<24>>24)){x=9;break a}}v=s+1|0;if(v>>>0<r>>>0)s=v;else{p=-1;x=51;break}}if((x|0)==9){if((s|0)!=(l|0)){p=-1;u=e;return p|0}s=Mpc(c)|0;b:do if(n>>>0>=s>>>0?(r=n-s|0,q=l+r|0,(r|0)>=0):0){c:do if(!s)y=q;else{r=q;while(1){v=0;while(1){if((b[c+v>>0]|0)!=(b[r+v>>0]|0)){z=v;break}t=v+1|0;if(t>>>0<s>>>0)v=t;else{z=t;break}}if((z|0)==(s|0)){y=r;break c}r=r+-1|0;if(r>>>0<l>>>0){A=-1;break b}}}while(0);A=y-o|0}else A=-1;while(0);o=Mpc(c)|0;if((A|0)!=(n-o|0)){p=-1;u=e;return p|0}A=Mpc(d)|0;d=n-A-o|0;f[g>>2]=0;o=g+4|0;f[o>>2]=0;c=n>>>0<A>>>0?n:A;A=n-c|0;y=A>>>0>d>>>0?d:A;if(y){if((y|0)==(n|0)){n=l+-4|0;f[n>>2]=(f[n>>2]|0)+1;n=f[a>>2]|0;f[g>>2]=n;f[o>>2]=f[m>>2];B=n}else{n=tT(g,y)|0;dJc(n|0,(f[a>>2]|0)+c|0,y|0)|0;B=f[g>>2]|0}if((B|0)==389153)C=6;else{D=B;x=25}}else{D=0;x=25}do if((x|0)==25)if(Ioc((D|0)==0?1154740:D,389153)|0)if(((D|0)!=389160?!((Ioc((D|0)==0?1154740:D,389160)|0)==0|(D|0)==389166):0)?(Ioc((D|0)==0?1154740:D,389166)|0)!=0:0)if((D|0)!=389171?(Ioc((D|0)==0?1154740:D,389171)|0)!=0:0)if((D|0)!=389176?(Ioc((D|0)==0?1154740:D,389176)|0)!=0:0)if((D|0)!=389181?(Ioc((D|0)==0?1154740:D,389181)|0)!=0:0)if((D|0)==389187)C=4;else{if(!(Ioc((D|0)==0?1154740:D,389187)|0)){C=4;break}if((D|0)==389191){C=12;break}if(!(Ioc((D|0)==0?1154740:D,389191)|0)){C=12;break}f[k>>2]=0;B=k+4|0;f[B>>2]=0;tT(k,(f[o>>2]|0)+14|0)|0;y=f[k>>2]|0;c=y;n=390316;l=c+14|0;do{b[c>>0]=b[n>>0]|0;c=c+1|0;n=n+1|0}while((c|0)<(l|0));A=f[o>>2]|0;if(A|0)dJc(y+14|0,f[g>>2]|0,A|0)|0;f[j>>2]=0;A=j+4|0;f[A>>2]=0;tT(j,(f[B>>2]|0)+18|0)|0;d=f[B>>2]|0;if(!d)E=0;else{dJc(f[j>>2]|0,f[k>>2]|0,d|0)|0;E=f[B>>2]|0}c=(f[j>>2]|0)+E|0;n=389196;l=c+18|0;do{b[c>>0]=b[n>>0]|0;c=c+1|0;n=n+1|0}while((c|0)<(l|0));f[i>>2]=0;n=i+4|0;f[n>>2]=0;tT(i,(f[m>>2]|0)+(f[A>>2]|0)|0)|0;c=f[A>>2]|0;if(c|0)dJc(f[i>>2]|0,f[j>>2]|0,c|0)|0;c=f[m>>2]|0;if(c|0)dJc((f[i>>2]|0)+(f[A>>2]|0)|0,f[a>>2]|0,c|0)|0;f[h>>2]=0;f[h+4>>2]=0;tT(h,(f[n>>2]|0)+1|0)|0;c=f[n>>2]|0;if(!c){F=0;G=f[h>>2]|0;H=G+F|0;b[H>>0]=34;z5(-213,h,389215,386595,232)}dJc(f[h>>2]|0,f[i>>2]|0,c|0)|0;F=f[n>>2]|0;G=f[h>>2]|0;H=G+F|0;b[H>>0]=34;z5(-213,h,389215,386595,232)}else C=3;else C=1;else C=0;else C=5;else C=6;while(0);uT(g);p=C;u=e;return p|0}else if((x|0)==51){u=e;return p|0}return 0}function nKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0;e=u;u=u+560|0;g=e+544|0;h=e+40|0;i=e;j=e+428|0;k=e+368|0;l=e+488|0;m=e+256|0;n=e+200|0;o=e+140|0;p=e+80|0;q=e+312|0;r=a+12|0;s=YKa(f[r>>2]|0)|0;t=h+8|0;f[h>>2]=t;v=h+4|0;w=s>>>0>4;f[v>>2]=s;if(w){x=XDc(s>>>0>536870911?-1:s<<3)|0;f[h>>2]=x;y=x}else y=t;x=i+8|0;f[i>>2]=x;z=i+4|0;f[z>>2]=s;if(w){A=XDc(s>>>0>536870911?-1:s<<3)|0;f[i>>2]=A}PKa(f[r>>2]|0,y,s)|0;PKa(f[r>>2]|0,f[i>>2]|0,s)|0;y=ZKa(f[r>>2]|0)|0;A=y+-1|0;y=YKa(f[r>>2]|0)|0;if(!((y|0)==4|(y|s|0)==0)){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,60)|0;C=388965;D=B+60|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,g,389026,386595,399)}if(!y){y=a+40|0;f[l>>2]=1124007936;E=l+4|0;F=l+8|0;G=l+40|0;B=E;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[G>>2]=F;F=l+48|0;H=l+44|0;f[H>>2]=F;f[F>>2]=0;f[l+52>>2]=0;f[k>>2]=c;I=k+4|0;f[I>>2]=1124007936;J=k+8|0;K=k+12|0;L=k+20|0;M=l+16|0;N=k+40|0;O=l+36|0;P=k+44|0;B=J;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[P>>2]=K;K=k+52|0;Q=k+48|0;f[Q>>2]=K;f[K>>2]=0;f[k+56>>2]=0;f[j>>2]=c;R=j+4|0;f[R>>2]=1124007936;S=j+8|0;T=j+12|0;U=j+20|0;V=j+40|0;W=j+44|0;B=S;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[W>>2]=T;T=j+52|0;X=j+48|0;f[X>>2]=T;f[T>>2]=0;f[j+56>>2]=0;Z=f[Q>>2]|0;f[T>>2]=f[Z>>2];f[j+56>>2]=f[Z+4>>2];Z=a+44|0;_=f[Z>>2]|0;do if(_){$=f[j>>2]|0;aa=a+44|0;ba=_;while(1){ca=f[ba+16>>2]|0;if(($|0)<(ca|0)){da=f[ba>>2]|0;if(!da){ea=13;break}else{fa=ba;ga=da}}else{if((ca|0)>=($|0)){ea=17;break}ha=ba+4|0;ca=f[ha>>2]|0;if(!ca){ea=16;break}else{fa=ha;ga=ca}}aa=fa;ba=ga}if((ea|0)==13){ia=ba;ja=ba;break}else if((ea|0)==16){ia=ha;ja=ba;break}else if((ea|0)==17){ia=aa;ja=ba;break}}else{ia=Z;ja=Z}while(0);if(!(f[ia>>2]|0)){CKa(g,y,j);Z=f[g>>2]|0;f[g>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=ja;f[ia>>2]=Z;ja=f[f[y>>2]>>2]|0;if(!ja)ka=Z;else{f[y>>2]=ja;ka=f[ia>>2]|0}laa(f[a+44>>2]|0,ka);ka=a+48|0;f[ka>>2]=(f[ka>>2]|0)+1;ka=f[V>>2]|0;if(ka|0?(ia=ka+12|0,ka=f[ia>>2]|0,f[ia>>2]=ka+-1,(ka|0)==1):0)_S(R)}f[V>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[S>>2]|0)>0){U=f[W>>2]|0;W=0;do{f[U+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[S>>2]|0))}S=f[X>>2]|0;if((S|0)!=(T|0))g0(S);S=f[N>>2]|0;if(S|0?(T=S+12|0,S=f[T>>2]|0,f[T>>2]=S+-1,(S|0)==1):0)_S(I);f[N>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[J>>2]|0)>0){L=f[P>>2]|0;P=0;do{f[L+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[J>>2]|0))}J=f[Q>>2]|0;if((J|0)!=(K|0))g0(J);J=f[O>>2]|0;if(J|0?(K=J+12|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0)_S(l);f[O>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[E>>2]|0)>0){M=f[G>>2]|0;G=0;do{f[M+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[H>>2]|0;if((E|0)!=(F|0))g0(E)}else{E=YKa(f[r>>2]|0)|0;r=a+16|0;F=a+20|0;H=f[F>>2]|0;a:do if(!H)ea=54;else{G=H;while(1){M=f[G+16>>2]|0;if((E|0)<(M|0))la=G;else{if((M|0)>=(E|0))break;la=G+4|0}G=f[la>>2]|0;if(!G){ea=54;break a}}G=a+32|0;ma=d;na=a+28|0;oa=G;pa=G}while(0);if((ea|0)==54){lKa(g,a);la=mKa(g,386719,386712)|0;if(!((la|0)>-1&(la|0)==(d|0))){f[j>>2]=0;f[j+4>>2]=0;B=tT(j,45)|0;C=389042;D=B+45|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-215,j,389026,386595,412)}oKa(a,E,d);d=a+28|0;la=a+32|0;H=f[la>>2]|0;do if(H){G=a+32|0;ba=H;aa=H;while(1){M=f[ba+16>>2]|0;if((E|0)<(M|0)){O=f[ba>>2]|0;if(!O){ea=61;break}else{qa=ba;ra=O}}else{if((M|0)>=(E|0)){ea=65;break}sa=ba+4|0;M=f[sa>>2]|0;if(!M){ea=64;break}else{qa=sa;ra=M}}G=qa;ba=ra;aa=ra}if((ea|0)==61){ta=ba;ua=ba;ea=68;break}else if((ea|0)==64){ta=sa;ua=ba;ea=68;break}else if((ea|0)==65){va=G;wa=ba;xa=aa;ea=67;break}}else{va=la;wa=la;xa=H;ea=67}while(0);if((ea|0)==67)if(!xa){ta=va;ua=wa;ea=68}else ya=xa;if((ea|0)==68){xa=VDc(76)|0;f[xa+16>>2]=E;f[xa+20>>2]=1124007936;wa=xa+28|0;va=xa+60|0;B=xa+24|0;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[va>>2]=wa;wa=xa+68|0;f[xa+64>>2]=wa;f[wa>>2]=0;f[xa+72>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=ua;f[ta>>2]=xa;ua=f[f[d>>2]>>2]|0;if(!ua)za=xa;else{f[d>>2]=ua;za=f[ta>>2]|0}laa(f[a+32>>2]|0,za);za=a+36|0;f[za>>2]=(f[za>>2]|0)+1;ya=xa}xa=f[ya+20>>2]&4095;ya=f[F>>2]|0;do if(ya){za=a+20|0;ta=ya;while(1){ua=f[ta+16>>2]|0;if((E|0)<(ua|0)){wa=f[ta>>2]|0;if(!wa){ea=76;break}else{Aa=ta;Ba=wa}}else{if((ua|0)>=(E|0)){ea=80;break}Ca=ta+4|0;ua=f[Ca>>2]|0;if(!ua){ea=79;break}else{Aa=Ca;Ba=ua}}za=Aa;ta=Ba}if((ea|0)==76){Da=ta;Ea=ta;break}else if((ea|0)==79){Da=Ca;Ea=ta;break}else if((ea|0)==80){Da=za;Ea=ta;break}}else{Da=F;Ea=F}while(0);if(!(f[Da>>2]|0)){F=VDc(20)|0;f[F+16>>2]=E;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=Ea;f[Da>>2]=F;Ea=f[f[r>>2]>>2]|0;if(!Ea)Fa=F;else{f[r>>2]=Ea;Fa=f[Da>>2]|0}laa(f[a+20>>2]|0,Fa);Fa=a+24|0;f[Fa>>2]=(f[Fa>>2]|0)+1}uT(g);ma=xa;na=d;oa=la;pa=la}la=f[f[i>>2]>>2]|0;d=f[f[h>>2]>>2]|0;xa=f[pa>>2]|0;Fa=a+32|0;do if(xa){Da=Fa;Ea=xa;r=xa;while(1){F=f[Ea+16>>2]|0;if((E|0)<(F|0)){Ca=f[Ea>>2]|0;if(!Ca){ea=92;break}else{Ga=Ea;Ha=Ca}}else{if((F|0)>=(E|0)){ea=96;break}Ia=Ea+4|0;F=f[Ia>>2]|0;if(!F){ea=95;break}else{Ga=Ia;Ha=F}}Da=Ga;Ea=Ha;r=Ha}if((ea|0)==92){Ja=Ea;Ka=Ea;ea=98;break}else if((ea|0)==95){Ja=Ia;Ka=Ea;ea=98;break}else if((ea|0)==96){La=Da;Ma=Ea;Na=r;ea=97;break}}else{La=Fa;Ma=oa;Na=xa;ea=97}while(0);if((ea|0)==97)if(!Na){Ja=La;Ka=Ma;ea=98}else Oa=Na;if((ea|0)==98){Na=VDc(76)|0;f[Na+16>>2]=E;f[Na+20>>2]=1124007936;Ma=Na+28|0;La=Na+60|0;B=Na+24|0;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[La>>2]=Ma;Ma=Na+68|0;f[Na+64>>2]=Ma;f[Ma>>2]=0;f[Na+72>>2]=0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=Ka;f[Ja>>2]=Na;Ka=f[f[a+28>>2]>>2]|0;if(!Ka)Pa=Na;else{f[na>>2]=Ka;Pa=f[Ja>>2]|0}laa(f[a+32>>2]|0,Pa);Pa=a+36|0;f[Pa>>2]=(f[Pa>>2]|0)+1;Oa=Na}Na=(Y(d,la)|0)+A|0;la=f[Oa+24>>2]|0;if((la|0)<3)Qa=Y(f[Oa+32>>2]|0,f[Oa+28>>2]|0)|0;else{d=f[Oa+60>>2]|0;Oa=0;Pa=1;while(1){Ja=Y(f[d+(Oa<<2)>>2]|0,Pa)|0;Oa=Oa+1|0;if((Oa|0)==(la|0)){Qa=Ja;break}else Pa=Ja}}if(Na>>>0>Qa>>>0){f[g>>2]=0;f[g+4>>2]=0;B=tT(g,64)|0;C=389088;D=B+64|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));z5(-201,g,389026,386595,422)}C=j+8|0;f[j>>2]=C;Qa=j+4|0;f[Qa>>2]=s;if(w){Na=XDc(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=Na;Ra=Na}else Ra=C;Na=k+8|0;f[k>>2]=Na;Pa=k+4|0;f[Pa>>2]=s;if(w){w=XDc(s>>>0>1073741823?-1:s<<2)|0;f[k>>2]=w;Sa=w}else Sa=Na;if((s|0)>0){w=f[h>>2]|0;la=f[i>>2]|0;Oa=(ma>>>3&511)+1<<(47696>>>(ma<<1&14)&3);d=s;do{Ja=d;d=d+-1|0;f[Ra+(d<<2)>>2]=f[w+(d<<3)>>2];Ka=Y(f[la+(d<<3)>>2]|0,Oa)|0;f[Sa+(d<<2)>>2]=Ka}while((Ja|0)>1)}d=f[pa>>2]|0;pa=a+32|0;do if(d){Oa=pa;la=d;w=d;while(1){Ja=f[la+16>>2]|0;if((E|0)<(Ja|0)){Ka=f[la>>2]|0;if(!Ka){ea=117;break}else{Ta=la;Ua=Ka}}else{if((Ja|0)>=(E|0)){ea=121;break}Va=la+4|0;Ja=f[Va>>2]|0;if(!Ja){ea=120;break}else{Ta=Va;Ua=Ja}}Oa=Ta;la=Ua;w=Ua}if((ea|0)==117){Wa=la;Xa=la;ea=123;break}else if((ea|0)==120){Wa=Va;Xa=la;ea=123;break}else if((ea|0)==121){Ya=Oa;Za=la;_a=w;ea=122;break}}else{Ya=pa;Za=oa;_a=d;ea=122}while(0);if((ea|0)==122)if(!_a){Wa=Ya;Xa=Za;ea=123}else{$a=_a;ab=Sa}if((ea|0)==123){Sa=VDc(76)|0;f[Sa+16>>2]=E;f[Sa+20>>2]=1124007936;E=Sa+28|0;_a=Sa+60|0;B=Sa+24|0;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[_a>>2]=E;E=Sa+68|0;f[Sa+64>>2]=E;f[E>>2]=0;f[Sa+72>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=Xa;f[Wa>>2]=Sa;Xa=f[f[a+28>>2]>>2]|0;if(!Xa)bb=Sa;else{f[na>>2]=Xa;bb=f[Wa>>2]|0}laa(f[a+32>>2]|0,bb);bb=a+36|0;f[bb>>2]=(f[bb>>2]|0)+1;$a=Sa;ab=f[k>>2]|0}dT(m,s,Ra,ma,(f[$a+36>>2]|0)+(Y((ma>>>3&511)+1<<(47696>>>(ma<<1&14)&3),A)|0)|0,ab);f[n>>2]=1124007936;ab=n+4|0;A=n+8|0;ma=n+40|0;B=ab;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[ma>>2]=A;B=n+48|0;D=n+44|0;f[D>>2]=B;f[B>>2]=0;f[n+52>>2]=0;$a=g+8|0;f[$a>>2]=0;f[$a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=n;LZ(m,g,5,1.0,0.0);$a=a+40|0;f[q>>2]=f[n>>2];Ra=q+4|0;s=f[ab>>2]|0;f[Ra>>2]=s;Sa=q+8|0;f[Sa>>2]=f[A>>2];A=q+12|0;f[A>>2]=f[n+12>>2];bb=q+16|0;Wa=n+16|0;f[bb>>2]=f[Wa>>2];Xa=q+20|0;f[Xa>>2]=f[n+20>>2];na=q+24|0;f[na>>2]=f[n+24>>2];E=q+28|0;f[E>>2]=f[n+28>>2];_a=q+32|0;f[_a>>2]=f[n+32>>2];Za=q+36|0;Ya=n+36|0;d=f[Ya>>2]|0;f[Za>>2]=d;oa=q+40|0;f[oa>>2]=Sa;pa=q+48|0;Va=q+44|0;f[Va>>2]=pa;f[pa>>2]=0;f[q+52>>2]=0;if(!d)cb=s;else{s=d+12|0;f[s>>2]=(f[s>>2]|0)+1;cb=f[ab>>2]|0}if((cb|0)<3){cb=f[D>>2]|0;s=f[Va>>2]|0;f[s>>2]=f[cb>>2];f[s+4>>2]=f[cb+4>>2]}else{f[Ra>>2]=0;ZS(q,n)}f[p>>2]=c;c=p+4|0;f[c>>2]=f[q>>2];cb=p+8|0;s=f[Ra>>2]|0;f[cb>>2]=s;d=p+12|0;f[d>>2]=f[Sa>>2];Sa=p+16|0;f[Sa>>2]=f[A>>2];A=p+20|0;f[A>>2]=f[bb>>2];Ua=p+24|0;f[Ua>>2]=f[Xa>>2];Xa=p+28|0;f[Xa>>2]=f[na>>2];na=p+32|0;f[na>>2]=f[E>>2];E=p+36|0;f[E>>2]=f[_a>>2];_a=p+40|0;Ta=f[Za>>2]|0;f[_a>>2]=Ta;r=p+44|0;f[r>>2]=d;Ea=p+52|0;Da=p+48|0;f[Da>>2]=Ea;f[Ea>>2]=0;f[p+56>>2]=0;if(!Ta)db=s;else{s=Ta+12|0;f[s>>2]=(f[s>>2]|0)+1;db=f[Ra>>2]|0}if((db|0)<3){db=f[Va>>2]|0;s=f[Da>>2]|0;f[s>>2]=f[db>>2];f[s+4>>2]=f[db+4>>2]}else{f[cb>>2]=0;ZS(c,q)}f[o>>2]=f[p>>2];p=o+4|0;f[p>>2]=f[c>>2];db=o+8|0;s=f[cb>>2]|0;f[db>>2]=s;Ta=o+12|0;f[Ta>>2]=f[d>>2];f[o+16>>2]=f[Sa>>2];Sa=o+20|0;f[Sa>>2]=f[A>>2];f[o+24>>2]=f[Ua>>2];f[o+28>>2]=f[Xa>>2];f[o+32>>2]=f[na>>2];f[o+36>>2]=f[E>>2];E=o+40|0;na=f[_a>>2]|0;f[E>>2]=na;Xa=o+44|0;f[Xa>>2]=Ta;Ta=o+52|0;Ua=o+48|0;f[Ua>>2]=Ta;f[Ta>>2]=0;f[o+56>>2]=0;if(!na)eb=s;else{s=na+12|0;f[s>>2]=(f[s>>2]|0)+1;eb=f[cb>>2]|0}if((eb|0)<3){eb=f[Da>>2]|0;s=f[Ua>>2]|0;f[s>>2]=f[eb>>2];f[s+4>>2]=f[eb+4>>2]}else{f[db>>2]=0;ZS(p,c)}eb=a+44|0;s=f[eb>>2]|0;do if(s){na=f[o>>2]|0;d=a+44|0;Ja=s;while(1){Ka=f[Ja+16>>2]|0;if((na|0)<(Ka|0)){Ma=f[Ja>>2]|0;if(!Ma){ea=147;break}else{fb=Ja;gb=Ma}}else{if((Ka|0)>=(na|0)){ea=151;break}hb=Ja+4|0;Ka=f[hb>>2]|0;if(!Ka){ea=150;break}else{fb=hb;gb=Ka}}d=fb;Ja=gb}if((ea|0)==147){ib=Ja;jb=Ja;break}else if((ea|0)==150){ib=hb;jb=Ja;break}else if((ea|0)==151){ib=d;jb=Ja;break}}else{ib=eb;jb=eb}while(0);if(!(f[ib>>2]|0)){CKa(g,$a,o);o=f[g>>2]|0;f[g>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=jb;f[ib>>2]=o;jb=f[f[$a>>2]>>2]|0;if(!jb)kb=o;else{f[$a>>2]=jb;kb=f[ib>>2]|0}laa(f[a+44>>2]|0,kb);kb=a+48|0;f[kb>>2]=(f[kb>>2]|0)+1}kb=f[E>>2]|0;do if(kb|0){a=kb+12|0;ib=f[a>>2]|0;f[a>>2]=ib+-1;if((ib|0)!=1)break;_S(p)}while(0);f[E>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[db>>2]|0)>0){Sa=f[Xa>>2]|0;Xa=0;do{f[Sa+(Xa<<2)>>2]=0;Xa=Xa+1|0}while((Xa|0)<(f[db>>2]|0))}db=f[Ua>>2]|0;if((db|0)!=(Ta|0))g0(db);db=f[_a>>2]|0;do if(db|0){Ta=db+12|0;Ua=f[Ta>>2]|0;f[Ta>>2]=Ua+-1;if((Ua|0)!=1)break;_S(c)}while(0);f[_a>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[cb>>2]|0)>0){A=f[r>>2]|0;r=0;do{f[A+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[cb>>2]|0))}cb=f[Da>>2]|0;if((cb|0)!=(Ea|0))g0(cb);cb=f[Za>>2]|0;do if(cb|0){Ea=cb+12|0;Da=f[Ea>>2]|0;f[Ea>>2]=Da+-1;if((Da|0)!=1)break;_S(q)}while(0);f[Za>>2]=0;f[bb>>2]=0;f[bb+4>>2]=0;f[bb+8>>2]=0;f[bb+12>>2]=0;if((f[Ra>>2]|0)>0){bb=f[oa>>2]|0;oa=0;do{f[bb+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[Ra>>2]|0))}Ra=f[Va>>2]|0;if((Ra|0)!=(pa|0))g0(Ra);Ra=f[Ya>>2]|0;do if(Ra|0){pa=Ra+12|0;Va=f[pa>>2]|0;f[pa>>2]=Va+-1;if((Va|0)!=1)break;_S(n)}while(0);f[Ya>>2]=0;f[Wa>>2]=0;f[Wa+4>>2]=0;f[Wa+8>>2]=0;f[Wa+12>>2]=0;if((f[ab>>2]|0)>0){Wa=f[ma>>2]|0;ma=0;do{f[Wa+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[ab>>2]|0))}ab=f[D>>2]|0;if((ab|0)!=(B|0))g0(ab);ab=m+36|0;B=f[ab>>2]|0;do if(B|0){D=B+12|0;ma=f[D>>2]|0;f[D>>2]=ma+-1;if((ma|0)!=1)break;_S(m)}while(0);f[ab>>2]=0;ab=m+16|0;B=m+4|0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[B>>2]|0)>0){ab=f[m+40>>2]|0;ma=0;do{f[ab+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[B>>2]|0))}B=f[m+44>>2]|0;if((B|0)!=(m+48|0))g0(B);B=f[k>>2]|0;if((B|0)!=(Na|0)){if(B|0)ZDc(B);f[k>>2]=Na;f[Pa>>2]=4}Pa=f[j>>2]|0;if((Pa|0)!=(C|0)){if(Pa|0)ZDc(Pa);f[j>>2]=C;f[Qa>>2]=4}}Qa=f[i>>2]|0;if((Qa|0)!=(x|0)){if(Qa|0)ZDc(Qa);f[i>>2]=x;f[z>>2]=4}z=f[h>>2]|0;if((z|0)==(t|0)){u=e;return}if(z|0)ZDc(z);f[h>>2]=t;f[v>>2]=4;u=e;return}function oKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+256|0;e=d+232|0;g=d+176|0;h=d+60|0;i=d;j=d+120|0;k=a+12|0;l=ZKa(f[k>>2]|0)|0;f[g>>2]=1124007936;m=g+4|0;n=g+8|0;o=g+40|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;q=g+48|0;r=g+44|0;f[r>>2]=q;f[q>>2]=0;f[g+52>>2]=0;switch(c|0){case 5:{f[e>>2]=1;f[e+4>>2]=l;XS(g,2,e,5);c=g+16|0;QKa(f[k>>2]|0,f[c>>2]|0,l)|0;s=c;break}case 6:{f[e>>2]=1;f[e+4>>2]=l;XS(g,2,e,6);c=g+16|0;RKa(f[k>>2]|0,f[c>>2]|0,l)|0;s=c;break}case 1:{f[e>>2]=1;f[e+4>>2]=l;XS(g,2,e,1);c=g+16|0;LKa(f[k>>2]|0,f[c>>2]|0,l)|0;s=c;break}case 0:{f[e>>2]=1;f[e+4>>2]=l;XS(g,2,e,0);c=g+16|0;LKa(f[k>>2]|0,f[c>>2]|0,l)|0;s=c;break}case 3:{f[e>>2]=1;f[e+4>>2]=l;XS(g,2,e,3);c=g+16|0;NKa(f[k>>2]|0,f[c>>2]|0,l)|0;s=c;break}case 4:{f[e>>2]=1;f[e+4>>2]=l;XS(g,2,e,4);c=g+16|0;OKa(f[k>>2]|0,f[c>>2]|0,l)|0;s=c;break}case 12:{f[e>>2]=1;f[e+4>>2]=l;XS(g,2,e,6);c=g+16|0;t=f[c>>2]|0;PKa(f[k>>2]|0,t,l)|0;if(!l)s=c;else{k=l;do{k=k+-1|0;l=t+(k<<3)|0;v=l;p[l>>3]=+((f[v>>2]|0)>>>0)+4294967296.0*+(f[v+4>>2]|0)}while((k|0)!=0);s=c}break}default:{f[e>>2]=0;f[e+4>>2]=0;z5(-3,e,388948,386595,290)}}c=a+28|0;f[j>>2]=f[g>>2];k=j+4|0;t=f[m>>2]|0;f[k>>2]=t;v=j+8|0;f[v>>2]=f[n>>2];n=j+12|0;f[n>>2]=f[g+12>>2];l=j+16|0;f[l>>2]=f[s>>2];w=j+20|0;f[w>>2]=f[g+20>>2];x=j+24|0;f[x>>2]=f[g+24>>2];y=j+28|0;f[y>>2]=f[g+28>>2];z=j+32|0;f[z>>2]=f[g+32>>2];A=j+36|0;B=g+36|0;C=f[B>>2]|0;f[A>>2]=C;D=j+40|0;f[D>>2]=v;E=j+48|0;F=j+44|0;f[F>>2]=E;f[E>>2]=0;f[j+52>>2]=0;if(!C)G=t;else{t=C+12|0;f[t>>2]=(f[t>>2]|0)+1;G=f[m>>2]|0}if((G|0)<3){G=f[r>>2]|0;t=f[F>>2]|0;f[t>>2]=f[G>>2];f[t+4>>2]=f[G+4>>2]}else{f[k>>2]=0;ZS(j,g)}f[i>>2]=b;b=i+4|0;f[b>>2]=f[j>>2];G=i+8|0;t=f[k>>2]|0;f[G>>2]=t;C=i+12|0;f[C>>2]=f[v>>2];v=i+16|0;f[v>>2]=f[n>>2];n=i+20|0;f[n>>2]=f[l>>2];H=i+24|0;f[H>>2]=f[w>>2];w=i+28|0;f[w>>2]=f[x>>2];x=i+32|0;f[x>>2]=f[y>>2];y=i+36|0;f[y>>2]=f[z>>2];z=i+40|0;I=f[A>>2]|0;f[z>>2]=I;J=i+44|0;f[J>>2]=C;K=i+52|0;L=i+48|0;f[L>>2]=K;f[K>>2]=0;f[i+56>>2]=0;if(!I)M=t;else{t=I+12|0;f[t>>2]=(f[t>>2]|0)+1;M=f[k>>2]|0}if((M|0)<3){M=f[F>>2]|0;t=f[L>>2]|0;f[t>>2]=f[M>>2];f[t+4>>2]=f[M+4>>2]}else{f[G>>2]=0;ZS(b,j)}f[h>>2]=f[i>>2];i=h+4|0;f[i>>2]=f[b>>2];M=h+8|0;t=f[G>>2]|0;f[M>>2]=t;I=h+12|0;f[I>>2]=f[C>>2];f[h+16>>2]=f[v>>2];v=h+20|0;f[v>>2]=f[n>>2];f[h+24>>2]=f[H>>2];f[h+28>>2]=f[w>>2];f[h+32>>2]=f[x>>2];f[h+36>>2]=f[y>>2];y=h+40|0;x=f[z>>2]|0;f[y>>2]=x;w=h+44|0;f[w>>2]=I;I=h+52|0;H=h+48|0;f[H>>2]=I;f[I>>2]=0;f[h+56>>2]=0;if(!x)N=t;else{t=x+12|0;f[t>>2]=(f[t>>2]|0)+1;N=f[G>>2]|0}if((N|0)<3){N=f[L>>2]|0;t=f[H>>2]|0;f[t>>2]=f[N>>2];f[t+4>>2]=f[N+4>>2]}else{f[M>>2]=0;ZS(i,b)}N=a+32|0;t=f[N>>2]|0;do if(t){x=f[h>>2]|0;C=a+32|0;O=t;while(1){P=f[O+16>>2]|0;if((x|0)<(P|0)){Q=f[O>>2]|0;if(!Q){R=31;break}else{S=O;T=Q}}else{if((P|0)>=(x|0)){R=35;break}U=O+4|0;P=f[U>>2]|0;if(!P){R=34;break}else{S=U;T=P}}C=S;O=T}if((R|0)==31){V=O;W=O;break}else if((R|0)==34){V=U;W=O;break}else if((R|0)==35){V=C;W=O;break}}else{V=N;W=N}while(0);if(!(f[V>>2]|0)){CKa(e,c,h);h=f[e>>2]|0;f[e>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=W;f[V>>2]=h;W=f[f[c>>2]>>2]|0;if(!W)X=h;else{f[c>>2]=W;X=f[V>>2]|0}laa(f[a+32>>2]|0,X);X=a+36|0;f[X>>2]=(f[X>>2]|0)+1}X=f[y>>2]|0;if(X|0?(a=X+12|0,X=f[a>>2]|0,f[a>>2]=X+-1,(X|0)==1):0)_S(i);f[y>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[M>>2]|0)>0){v=f[w>>2]|0;w=0;do{f[v+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[M>>2]|0))}M=f[H>>2]|0;if((M|0)!=(I|0))g0(M);M=f[z>>2]|0;if(M|0?(I=M+12|0,M=f[I>>2]|0,f[I>>2]=M+-1,(M|0)==1):0)_S(b);f[z>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[G>>2]|0)>0){n=f[J>>2]|0;J=0;do{f[n+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[G>>2]|0))}G=f[L>>2]|0;if((G|0)!=(K|0))g0(G);G=f[A>>2]|0;if(G|0?(K=G+12|0,G=f[K>>2]|0,f[K>>2]=G+-1,(G|0)==1):0)_S(j);f[A>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[D>>2]|0;D=0;do{f[l+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[k>>2]|0))}k=f[F>>2]|0;if((k|0)!=(E|0))g0(k);k=f[B>>2]|0;if(k|0?(E=k+12|0,k=f[E>>2]|0,f[E>>2]=k+-1,(k|0)==1):0)_S(g);f[B>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[m>>2]|0)>0){s=f[o>>2]|0;o=0;do{f[s+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[m>>2]|0))}m=f[r>>2]|0;if((m|0)==(q|0)){u=d;return}g0(m);u=d;return}function pKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=a+4|0;i=f[h>>2]|0;j=g+i|0;if((i|0)>0)k=g;else{l=0;u=d;return l|0}while(1){if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){m=g;n=16;break}o=k+1|0;if((b[o>>0]|0)==110){if(o>>>0>=j>>>0){m=g;n=16;break}p=k+2|0;if((b[p>>0]|0)==46){n=57;break}}}o=k+1|0;if(o>>>0<j>>>0)k=o;else{m=g;n=16;break}}if((n|0)==57)if(p>>>0<j>>>0&(k|0)==(g|0))q=78560;else{m=g;n=16}do if((n|0)==16){while(1){n=0;if((b[m>>0]|0)==99){if(m>>>0>=j>>>0){r=g;break}k=m+1|0;if((b[k>>0]|0)==117){if(k>>>0>=j>>>0){r=g;break}k=m+2|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){r=g;break}k=m+3|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){r=g;break}s=m+4|0;if((b[s>>0]|0)==46){n=54;break}}}}}k=m+1|0;if(k>>>0<j>>>0){m=k;n=16}else{r=g;break}}if((n|0)==54)if(s>>>0<j>>>0&(m|0)==(g|0)){q=78564;break}else r=g;while(1){if((b[r>>0]|0)==99){if(r>>>0>=j>>>0){t=g;break}k=r+1|0;if((b[k>>0]|0)==117){if(k>>>0>=j>>>0){t=g;break}k=r+2|0;if((b[k>>0]|0)==100){if(k>>>0>=j>>>0){t=g;break}k=r+3|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){t=g;break}k=r+4|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){t=g;break}v=r+5|0;if((b[v>>0]|0)==46){n=47;break}}}}}}k=r+1|0;if(k>>>0<j>>>0)r=k;else{t=g;break}}if((n|0)==47)if(v>>>0<j>>>0&(r|0)==(g|0)){q=78568;break}else t=g;while(1){if((b[t>>0]|0)==102){if(t>>>0>=j>>>0){l=0;n=15;break}k=t+1|0;if((b[k>>0]|0)==98){if(k>>>0>=j>>>0){l=0;n=15;break}k=t+2|0;if((b[k>>0]|0)==99){if(k>>>0>=j>>>0){l=0;n=15;break}k=t+3|0;if((b[k>>0]|0)==117){if(k>>>0>=j>>>0){l=0;n=15;break}k=t+4|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){l=0;n=15;break}k=t+5|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){l=0;n=15;break}w=t+6|0;if((b[w>>0]|0)==46){n=38;break}}}}}}}k=t+1|0;if(k>>>0<j>>>0)t=k;else{l=0;n=15;break}}if((n|0)==15){u=d;return l|0}else if((n|0)==38){if(w>>>0<j>>>0&(t|0)==(g|0)){q=78572;break}else l=0;u=d;return l|0}}while(0);t=Mpc(f[q>>2]|0)|0;f[e>>2]=0;q=e+4|0;f[q>>2]=0;j=i>>>0<t>>>0?i:t;t=i-j|0;do if(t|0)if(!j){i=g+-4|0;f[i>>2]=(f[i>>2]|0)+1;f[e>>2]=f[a>>2];f[q>>2]=f[h>>2];break}else{i=tT(e,t)|0;dJc(i|0,(f[a>>2]|0)+j|0,t|0)|0;break}while(0);if((e|0)!=(c|0)){uT(c);t=f[e>>2]|0;if(!t)x=0;else{j=t+-4|0;f[j>>2]=(f[j>>2]|0)+1;x=f[e>>2]|0}f[c>>2]=x;f[c+4>>2]=f[q>>2]}uT(e);l=1;u=d;return l|0}function qKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)mCc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=af(8)|0;bEc(e,503977);f[e>>2]=185532;ig(e|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;l=f[b>>2]|0;f[e>>2]=l;f[m+(g<<3)+4>>2]=f[b+4>>2];if(!l){n=j;o=i}else{i=l+4|0;f[i>>2]=(f[i>>2]|0)+1;n=f[c>>2]|0;o=f[a>>2]|0}i=e+8|0;if((n|0)==(o|0)){p=h;q=n;r=n}else{l=n;n=h;h=e;do{e=l;l=l+-8|0;j=f[l>>2]|0;f[h+-8>>2]=j;f[h+-4>>2]=f[e+-4>>2];if(j|0){e=j+4|0;f[e>>2]=(f[e>>2]|0)+1}h=n+-8|0;n=h}while((l|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=i;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=d;d=d+-8|0;i=f[d>>2]|0;if(i|0?(c=i+4|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);f[d>>2]=0;f[r+-4>>2]=0}while((d|0)!=(k|0))}if(!q)return;YDc(q);return}function rKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0.0,bc=0;e=u;u=u+336|0;g=e;h=e+320|0;i=e+248|0;j=e+172|0;k=e+240|0;l=e+112|0;m=e+56|0;n=a+12|0;o=YKa(f[n>>2]|0)|0;q=YKa(f[n>>2]|0)|0;if((o|0)!=3){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=tT(g,56)|0;t=s;v=388742;w=t+56|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,g,388799,386595,302)}o=a+16|0;x=a+20|0;y=f[x>>2]|0;do if(y){z=y;do{A=f[z+16>>2]|0;if((q|0)<(A|0))B=z;else{if((A|0)>=(q|0)){C=8;break}B=z+4|0}z=f[B>>2]|0}while((z|0)!=0);if((C|0)==8){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=tT(g,56)|0;t=s;v=388742;w=t+56|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));z5(-215,g,388799,386595,302)}z=a+20|0;A=y;while(1){D=f[A+16>>2]|0;if((q|0)<(D|0)){E=f[A>>2]|0;if(!E){C=13;break}else{F=A;G=E}}else{if((D|0)>=(q|0)){C=17;break}H=A+4|0;D=f[H>>2]|0;if(!D){C=16;break}else{F=H;G=D}}z=F;A=G}if((C|0)==13){I=A;J=A;break}else if((C|0)==16){I=H;J=A;break}else if((C|0)==17){I=z;J=A;break}}else{I=x;J=x}while(0);if(!(f[I>>2]|0)){x=VDc(20)|0;f[x+16>>2]=q;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=J;f[I>>2]=x;J=f[f[o>>2]>>2]|0;if(!J)K=x;else{f[o>>2]=J;K=f[I>>2]|0}laa(f[a+20>>2]|0,K);K=a+24|0;f[K>>2]=(f[K>>2]|0)+1}K=YKa(f[n>>2]|0)|0;if((K|0)<=0){u=e;return}I=h+4|0;J=a+68|0;o=a+40|0;x=a+44|0;q=a+28|0;H=a+32|0;G=a+32|0;F=a+36|0;y=g+4|0;v=g+8|0;s=g+40|0;r=g+48|0;B=g+44|0;D=g+52|0;E=i+8|0;L=i+4|0;M=g+16|0;N=g+12|0;O=i+4|0;P=g+36|0;Q=k+4|0;R=a+44|0;S=a+48|0;T=m+4|0;U=m+8|0;V=m+12|0;W=m+16|0;X=m+20|0;Z=m+24|0;_=m+28|0;$=m+32|0;aa=m+36|0;ba=m+40|0;ca=m+48|0;da=m+44|0;ea=m+52|0;fa=l+4|0;ga=l+8|0;ha=l+12|0;ia=l+16|0;ja=l+20|0;ka=l+24|0;la=l+28|0;ma=l+32|0;na=l+36|0;oa=l+40|0;pa=l+44|0;qa=l+52|0;ra=l+48|0;sa=l+56|0;ta=j+4|0;ua=j+8|0;va=j+12|0;wa=j+16|0;xa=j+20|0;ya=j+24|0;za=j+28|0;Aa=j+32|0;Ba=j+36|0;Ca=j+40|0;Da=j+44|0;Ea=j+48|0;Fa=j+52|0;Ga=j+60|0;Ha=j+56|0;Ia=j+64|0;Ja=i+4|0;Ka=i+8|0;La=i+12|0;Ma=i+16|0;Na=i+20|0;Oa=i+24|0;Pa=i+28|0;Qa=i+32|0;Ra=i+36|0;Sa=i+40|0;Ta=i+44|0;Ua=i+48|0;Va=i+52|0;Wa=i+60|0;Xa=i+56|0;Ya=i+64|0;Za=d+4|0;_a=d+4|0;$a=d+8|0;ab=g+4|0;bb=0;do{cb=TKa(f[n>>2]|0)|0;if((YKa(f[n>>2]|0)|0)==2){db=YKa(f[n>>2]|0)|0;f[h>>2]=0;f[I>>2]=0;if(!db)eb=0;else{XIc(tT(h,db)|0,0,db|0)|0;eb=f[h>>2]|0}MKa(f[n>>2]|0,(eb|0)==0?1154740:eb,db)|0;db=TKa(f[n>>2]|0)|0;a:do switch(YKa(f[n>>2]|0)|0){case 4:{fb=YKa(f[n>>2]|0)|0;gb=f[J>>2]|0;hb=(f[gb+60>>2]|0)-(f[gb+56>>2]|0)|0;jKa(a,fb);gb=f[x>>2]|0;b:do if(gb|0){ib=gb;while(1){jb=f[ib+16>>2]|0;if((fb|0)<(jb|0))kb=ib;else{if((jb|0)>=(fb|0))break;kb=ib+4|0}ib=f[kb>>2]|0;if(!ib)break b}ib=f[h>>2]|0;f[k>>2]=ib;f[Q>>2]=f[I>>2];if(!ib)lb=gb;else{jb=ib+-4|0;f[jb>>2]=(f[jb>>2]|0)+1;lb=f[x>>2]|0}do if(lb){jb=R;ib=lb;mb=lb;while(1){nb=f[ib+16>>2]|0;if((fb|0)<(nb|0)){ob=f[ib>>2]|0;if(!ob){C=42;break}else{pb=ib;qb=ob}}else{if((nb|0)>=(fb|0)){C=46;break}rb=ib+4|0;nb=f[rb>>2]|0;if(!nb){C=45;break}else{pb=rb;qb=nb}}jb=pb;ib=qb;mb=qb}if((C|0)==42){C=0;sb=ib;tb=ib;C=48;break}else if((C|0)==45){C=0;sb=rb;tb=ib;C=48;break}else if((C|0)==46){C=0;ub=jb;vb=ib;wb=mb;C=47;break}}else{ub=x;vb=x;wb=lb;C=47}while(0);if((C|0)==47){C=0;if(!wb){sb=ub;tb=vb;C=48}else xb=wb}if((C|0)==48){C=0;nb=VDc(76)|0;f[nb+16>>2]=fb;f[nb+20>>2]=1124007936;ob=nb+28|0;yb=nb+60|0;t=nb+24|0;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[yb>>2]=ob;zb=nb+68|0;f[nb+64>>2]=zb;f[zb>>2]=0;f[nb+72>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=tb;f[sb>>2]=nb;zb=f[f[o>>2]>>2]|0;if(!zb)Ab=nb;else{f[o>>2]=zb;Ab=f[sb>>2]|0}laa(f[R>>2]|0,Ab);f[S>>2]=(f[S>>2]|0)+1;xb=nb}zb=xb+20|0;f[m>>2]=f[zb>>2];Bb=xb+24|0;f[T>>2]=f[Bb>>2];f[U>>2]=f[xb+28>>2];f[V>>2]=f[xb+32>>2];f[W>>2]=f[xb+36>>2];f[X>>2]=f[xb+40>>2];f[Z>>2]=f[xb+44>>2];f[_>>2]=f[xb+48>>2];f[$>>2]=f[xb+52>>2];Cb=f[xb+56>>2]|0;f[aa>>2]=Cb;f[ba>>2]=U;f[da>>2]=ca;f[ca>>2]=0;f[ea>>2]=0;if(Cb|0){Db=Cb+12|0;f[Db>>2]=(f[Db>>2]|0)+1}if((f[Bb>>2]|0)<3){Bb=f[xb+64>>2]|0;Db=f[da>>2]|0;f[Db>>2]=f[Bb>>2];f[Db+4>>2]=f[Bb+4>>2]}else{f[T>>2]=0;ZS(m,zb)}f[l>>2]=fb;f[fa>>2]=f[m>>2];zb=f[T>>2]|0;f[ga>>2]=zb;f[ha>>2]=f[U>>2];f[ia>>2]=f[V>>2];f[ja>>2]=f[W>>2];f[ka>>2]=f[X>>2];f[la>>2]=f[Z>>2];f[ma>>2]=f[_>>2];f[na>>2]=f[$>>2];Bb=f[aa>>2]|0;f[oa>>2]=Bb;f[pa>>2]=ha;f[ra>>2]=qa;f[qa>>2]=0;f[sa>>2]=0;if(!Bb)Eb=zb;else{zb=Bb+12|0;f[zb>>2]=(f[zb>>2]|0)+1;Eb=f[T>>2]|0}if((Eb|0)<3){zb=f[da>>2]|0;Bb=f[ra>>2]|0;f[Bb>>2]=f[zb>>2];f[Bb+4>>2]=f[zb+4>>2]}else{f[ga>>2]=0;ZS(fa,m)}zb=f[k>>2]|0;f[j>>2]=zb;f[ta>>2]=f[Q>>2];if(zb|0){Bb=zb+-4|0;f[Bb>>2]=(f[Bb>>2]|0)+1}f[ua>>2]=f[l>>2];f[va>>2]=f[fa>>2];Bb=f[ga>>2]|0;f[wa>>2]=Bb;f[xa>>2]=f[ha>>2];f[ya>>2]=f[ia>>2];f[za>>2]=f[ja>>2];f[Aa>>2]=f[ka>>2];f[Ba>>2]=f[la>>2];f[Ca>>2]=f[ma>>2];f[Da>>2]=f[na>>2];zb=f[oa>>2]|0;f[Ea>>2]=zb;f[Fa>>2]=xa;f[Ha>>2]=Ga;f[Ga>>2]=0;f[Ia>>2]=0;if(!zb)Fb=Bb;else{Bb=zb+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1;Fb=f[ga>>2]|0}if((Fb|0)<3){Bb=f[ra>>2]|0;zb=f[Ha>>2]|0;f[zb>>2]=f[Bb>>2];f[zb+4>>2]=f[Bb+4>>2]}else{f[wa>>2]=0;ZS(va,fa)}Bb=f[j>>2]|0;f[i>>2]=Bb;f[Ja>>2]=f[ta>>2];if(Bb|0){zb=Bb+-4|0;f[zb>>2]=(f[zb>>2]|0)+1}f[Ka>>2]=f[ua>>2];f[La>>2]=f[va>>2];zb=f[wa>>2]|0;f[Ma>>2]=zb;f[Na>>2]=f[xa>>2];f[Oa>>2]=f[ya>>2];f[Pa>>2]=f[za>>2];f[Qa>>2]=f[Aa>>2];f[Ra>>2]=f[Ba>>2];f[Sa>>2]=f[Ca>>2];f[Ta>>2]=f[Da>>2];Bb=f[Ea>>2]|0;f[Ua>>2]=Bb;f[Va>>2]=Na;f[Xa>>2]=Wa;f[Wa>>2]=0;f[Ya>>2]=0;if(!Bb)Gb=zb;else{zb=Bb+12|0;f[zb>>2]=(f[zb>>2]|0)+1;Gb=f[wa>>2]|0}if((Gb|0)<3){zb=f[Ha>>2]|0;Bb=f[Xa>>2]|0;f[Bb>>2]=f[zb>>2];f[Bb+4>>2]=f[zb+4>>2]}else{f[Ma>>2]=0;ZS(La,va)}zb=f[Za>>2]|0;c:do if(!zb){Hb=Za;Ib=Za}else{Bb=f[i>>2]|0;Db=(Bb|0)==0?1154740:Bb;Cb=f[zb+16>>2]|0;d:do if((Bb|0)!=(Cb|0)){Jb=_a;Kb=zb;Lb=Cb;while(1){Mb=(Lb|0)==0?1154740:Lb;if((Ioc(Db,Mb)|0)<0){Nb=f[Kb>>2]|0;if(!Nb){C=80;break}else{Ob=Kb;Pb=Nb}}else{if((Ioc(Mb,Db)|0)>=0){Qb=Jb;Rb=Kb;break d}Sb=Kb+4|0;Mb=f[Sb>>2]|0;if(!Mb){C=83;break}else{Ob=Sb;Pb=Mb}}Lb=f[Pb+16>>2]|0;if((Bb|0)==(Lb|0)){Qb=Ob;Rb=Pb;break d}else{Jb=Ob;Kb=Pb}}if((C|0)==80){C=0;Hb=Kb;Ib=Kb;break c}else if((C|0)==83){C=0;Hb=Sb;Ib=Kb;break c}}else{Qb=_a;Rb=zb}while(0);Hb=Qb;Ib=Rb}while(0);if(!(f[Hb>>2]|0)){wKa(g,d,i);zb=f[g>>2]|0;f[g>>2]=0;f[zb>>2]=0;f[zb+4>>2]=0;f[zb+8>>2]=Ib;f[Hb>>2]=zb;nb=f[f[d>>2]>>2]|0;if(!nb)Tb=zb;else{f[d>>2]=nb;Tb=f[Hb>>2]|0}laa(f[_a>>2]|0,Tb);f[$a>>2]=(f[$a>>2]|0)+1}nb=f[Ua>>2]|0;do if(nb|0){zb=nb+12|0;ob=f[zb>>2]|0;f[zb>>2]=ob+-1;if((ob|0)!=1)break;_S(La)}while(0);f[Ua>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[Ma>>2]|0)>0){nb=f[Va>>2]|0;ob=0;do{f[nb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[Ma>>2]|0))}ob=f[Xa>>2]|0;if((ob|0)!=(Wa|0))g0(ob);uT(i);ob=f[Ea>>2]|0;do if(ob|0){nb=ob+12|0;zb=f[nb>>2]|0;f[nb>>2]=zb+-1;if((zb|0)!=1)break;_S(va)}while(0);f[Ea>>2]=0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[wa>>2]|0)>0){ob=f[Fa>>2]|0;zb=0;do{f[ob+(zb<<2)>>2]=0;zb=zb+1|0}while((zb|0)<(f[wa>>2]|0))}zb=f[Ha>>2]|0;if((zb|0)!=(Ga|0))g0(zb);uT(j);zb=f[oa>>2]|0;do if(zb|0){ob=zb+12|0;nb=f[ob>>2]|0;f[ob>>2]=nb+-1;if((nb|0)!=1)break;_S(fa)}while(0);f[oa>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[ga>>2]|0)>0){zb=f[pa>>2]|0;nb=0;do{f[zb+(nb<<2)>>2]=0;nb=nb+1|0}while((nb|0)<(f[ga>>2]|0))}nb=f[ra>>2]|0;if((nb|0)!=(qa|0))g0(nb);nb=f[aa>>2]|0;do if(nb|0){zb=nb+12|0;ob=f[zb>>2]|0;f[zb>>2]=ob+-1;if((ob|0)!=1)break;_S(m)}while(0);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[T>>2]|0)>0){nb=f[ba>>2]|0;ob=0;do{f[nb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[T>>2]|0))}ob=f[da>>2]|0;if((ob|0)!=(ca|0))g0(ob);uT(k);break a}while(0);gb=f[H>>2]|0;e:do if(gb|0){ob=gb;while(1){nb=f[ob+16>>2]|0;if((fb|0)<(nb|0))Ub=ob;else{if((nb|0)>=(fb|0))break;Ub=ob+4|0}ob=f[Ub>>2]|0;if(!ob)break e}ob=G;nb=gb;zb=gb;while(1){yb=f[nb+16>>2]|0;if((fb|0)<(yb|0)){Bb=f[nb>>2]|0;if(!Bb){Vb=nb;C=136;break}else{Wb=nb;Xb=Bb}}else{if((yb|0)>=(fb|0)){C=135;break}yb=nb+4|0;Bb=f[yb>>2]|0;if(!Bb){Vb=yb;C=136;break}else{Wb=yb;Xb=Bb}}ob=Wb;nb=Xb;zb=Xb}if((C|0)==135){C=0;if(!zb){Vb=ob;C=136}else Yb=zb}if((C|0)==136){C=0;Bb=VDc(76)|0;f[Bb+16>>2]=fb;f[Bb+20>>2]=1124007936;yb=Bb+28|0;Db=Bb+60|0;t=Bb+24|0;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[Db>>2]=yb;zb=Bb+68|0;f[Bb+64>>2]=zb;f[zb>>2]=0;f[Bb+72>>2]=0;f[Bb>>2]=0;f[Bb+4>>2]=0;f[Bb+8>>2]=nb;f[Vb>>2]=Bb;zb=f[f[q>>2]>>2]|0;if(!zb)Zb=Bb;else{f[q>>2]=zb;Zb=f[Vb>>2]|0}laa(f[G>>2]|0,Zb);f[F>>2]=(f[F>>2]|0)+1;Yb=Bb}zb=Yb+20|0;f[g>>2]=1124007936;t=y;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[s>>2]=v;f[B>>2]=r;f[r>>2]=0;f[D>>2]=0;Bb=E;f[Bb>>2]=0;f[Bb+4>>2]=0;f[i>>2]=33619968;f[L>>2]=g;LZ(zb,i,6,1.0,0.0);Bb=f[M>>2]|0;nb=f[y>>2]|0;if((nb|0)<3)_b=Y(f[N>>2]|0,f[v>>2]|0)|0;else{yb=f[s>>2]|0;Db=0;ob=1;while(1){Cb=Y(f[yb+(Db<<2)>>2]|0,ob)|0;Db=Db+1|0;if((Db|0)==(nb|0)){_b=Cb;break}else ob=Cb}}ob=VDc(16)|0;nb=ob+8|0;f[ob>>2]=nb;f[ob+4>>2]=_b;if(_b>>>0>1){Db=XDc(_b>>>0>536870911?-1:_b<<3)|0;f[ob>>2]=Db;$b=Db}else $b=nb;f[i>>2]=2;f[O>>2]=ob;if((_b|0)>0){ob=Bb;nb=0;while(1){p[$b+(nb<<3)>>3]=+p[ob>>3];nb=nb+1|0;if((nb|0)==(_b|0))break;else ob=ob+8|0}}bIa(c,h,i)|0;JFa(i);ob=f[P>>2]|0;if(ob|0?(nb=ob+12|0,ob=f[nb>>2]|0,f[nb>>2]=ob+-1,(ob|0)==1):0)_S(g);f[P>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[y>>2]|0)>0){ob=f[s>>2]|0;nb=0;do{f[ob+(nb<<2)>>2]=0;nb=nb+1|0}while((nb|0)<(f[y>>2]|0))}nb=f[B>>2]|0;if((nb|0)!=(r|0))g0(nb);break a}while(0);fb=f[J>>2]|0;gb=fb+60|0;nb=f[gb>>2]|0;if((nb-(f[fb+56>>2]|0)|0)>>>0>hb>>>0){fb=nb;nb=gb;do{gb=fb;ob=gb+-8|0;Bb=gb;do{gb=Bb+-8|0;f[nb>>2]=gb;Db=f[gb>>2]|0;if(Db|0?(yb=Db+4|0,zb=f[yb>>2]|0,f[yb>>2]=zb+-1,(zb|0)==1):0)Yi[f[(f[Db>>2]|0)+8>>2]&2047](Db);f[gb>>2]=0;f[Bb+-4>>2]=0;Bb=f[nb>>2]|0}while((Bb|0)!=(ob|0));ob=f[J>>2]|0;nb=ob+60|0;fb=f[nb>>2]|0}while((fb-(f[ob+56>>2]|0)|0)>>>0>hb>>>0)}break}case 1:{ac=+_Ka(f[n>>2]|0);p[g>>3]=ac;xKa(c,h,g)|0;break}case 2:{hb=YKa(f[n>>2]|0)|0;f[g>>2]=0;f[ab>>2]=0;if(!hb)bc=0;else{XIc(tT(g,hb)|0,0,hb|0)|0;bc=f[g>>2]|0}MKa(f[n>>2]|0,(bc|0)==0?1154740:bc,hb)|0;yKa(c,h,g)|0;uT(g);break}case 5:{hb=(YKa(f[n>>2]|0)|0)!=0&1;b[g>>0]=hb;rIa(c,h,g)|0;break}default:{SKa(f[n>>2]|0,db);gKa(a)}}while(0);uT(h)}else{SKa(f[n>>2]|0,cb);gKa(a);gKa(a)}bb=bb+1|0}while((bb|0)<(K|0));u=e;return}function sKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=a+4|0;d=f[c>>2]|0;a:do if(!d){e=c;g=c;h=d;i=12}else{j=a+4|0;k=f[b>>2]|0;l=(k|0)==0?1154740:k;m=f[d+16>>2]|0;b:do if((k|0)!=(m|0)){n=j;o=d;p=m;q=d;while(1){r=(p|0)==0?1154740:p;if((Ioc(l,r)|0)<0){s=f[o>>2]|0;if(!s){i=6;break}else{t=o;u=s}}else{if((Ioc(r,l)|0)>=0){v=n;w=o;x=q;break b}y=o+4|0;r=f[y>>2]|0;if(!r){i=9;break}else{t=y;u=r}}p=f[u+16>>2]|0;if((k|0)==(p|0)){v=t;w=u;x=u;break b}else{n=t;o=u;q=u}}if((i|0)==6){z=o;A=o;break a}else if((i|0)==9){z=y;A=o;break a}}else{v=j;w=d;x=d}while(0);e=v;g=w;h=x;i=12}while(0);if((i|0)==12)if(!h){z=e;A=g}else{B=h;C=B+24|0;return C|0}h=VDc(84)|0;g=f[b>>2]|0;f[h+16>>2]=g;f[h+20>>2]=f[b+4>>2];if(g|0){b=g+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[h+24>>2]=0;f[h+28>>2]=1124007936;b=h+36|0;g=h+68|0;e=h+32|0;i=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));f[g>>2]=b;b=h+76|0;f[h+72>>2]=b;f[b>>2]=0;f[h+80>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=A;f[z>>2]=h;A=f[f[a>>2]>>2]|0;if(!A)D=h;else{f[a>>2]=A;D=f[z>>2]|0}laa(f[a+4>>2]|0,D);D=a+8|0;f[D>>2]=(f[D>>2]|0)+1;B=h;C=B+24|0;return C|0}function tKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[e>>2]=0;f[e+4>>2]=0;i=tT(e,8)|0;j=i;b[j>>0]=107;b[j+1>>0]=101;b[j+2>>0]=114;b[j+3>>0]=110;j=i+4|0;b[j>>0]=101;b[j+1>>0]=108;b[j+2>>0]=95;b[j+3>>0]=104;f[h>>2]=0;f[h+4>>2]=0;j=tT(h,2)|0;b[j>>0]=107;b[j+1>>0]=72;j=DHa(lIa(a,h)|0,-1)|0;f[g>>2]=j;$Ha(c,e,g)|0;uT(h);uT(e);f[e>>2]=0;f[e+4>>2]=0;j=tT(e,8)|0;i=j;b[i>>0]=107;b[i+1>>0]=101;b[i+2>>0]=114;b[i+3>>0]=110;i=j+4|0;b[i>>0]=101;b[i+1>>0]=108;b[i+2>>0]=95;b[i+3>>0]=119;f[h>>2]=0;f[h+4>>2]=0;i=tT(h,2)|0;b[i>>0]=107;b[i+1>>0]=87;i=DHa(lIa(a,h)|0,-1)|0;f[g>>2]=i;$Ha(c,e,g)|0;uT(h);uT(e);f[e>>2]=0;f[e+4>>2]=0;i=tT(e,8)|0;j=i;b[j>>0]=115;b[j+1>>0]=116;b[j+2>>0]=114;b[j+3>>0]=105;j=i+4|0;b[j>>0]=100;b[j+1>>0]=101;b[j+2>>0]=95;b[j+3>>0]=104;f[h>>2]=0;f[h+4>>2]=0;j=tT(h,2)|0;b[j>>0]=100;b[j+1>>0]=72;j=DHa(lIa(a,h)|0,-1)|0;f[g>>2]=j;$Ha(c,e,g)|0;uT(h);uT(e);f[e>>2]=0;f[e+4>>2]=0;j=tT(e,8)|0;i=j;b[i>>0]=115;b[i+1>>0]=116;b[i+2>>0]=114;b[i+3>>0]=105;i=j+4|0;b[i>>0]=100;b[i+1>>0]=101;b[i+2>>0]=95;b[i+3>>0]=119;f[h>>2]=0;f[h+4>>2]=0;i=tT(h,2)|0;b[i>>0]=100;b[i+1>>0]=87;i=DHa(lIa(a,h)|0,-1)|0;f[g>>2]=i;$Ha(c,e,g)|0;uT(h);uT(e);f[e>>2]=0;f[e+4>>2]=0;i=tT(e,5)|0;b[i>>0]=b[387904]|0;b[i+1>>0]=b[387905]|0;b[i+2>>0]=b[387906]|0;b[i+3>>0]=b[387907]|0;b[i+4>>0]=b[387908]|0;f[h>>2]=0;f[h+4>>2]=0;i=tT(h,4)|0;b[i>>0]=112;b[i+1>>0]=97;b[i+2>>0]=100;b[i+3>>0]=72;i=a+4|0;a=f[i>>2]|0;do if(a){j=f[h>>2]|0;k=(j|0)==0?1154740:j;l=i;m=a;a:while(1){n=m;while(1){o=f[n+16>>2]|0;if((o|0)==(j|0))break;if((Ioc((o|0)==0?1154740:o,k)|0)>=0)break;o=f[n+4>>2]|0;if(!o){p=l;break a}else n=o}m=f[n>>2]|0;if(!m){p=n;break}else l=n}if((p|0)!=(i|0)){l=f[p+16>>2]|0;if((j|0)!=(l|0)?(Ioc(k,(l|0)==0?1154740:l)|0)<=-1:0){q=0;break}l=DHa(p+24|0,-1)|0;q=l}else q=0}else q=0;while(0);f[g>>2]=q;$Ha(c,e,g)|0;uT(h);uT(e);f[e>>2]=0;f[e+4>>2]=0;q=tT(e,5)|0;b[q>>0]=b[387898]|0;b[q+1>>0]=b[387899]|0;b[q+2>>0]=b[387900]|0;b[q+3>>0]=b[387901]|0;b[q+4>>0]=b[387902]|0;f[h>>2]=0;f[h+4>>2]=0;q=tT(h,4)|0;b[q>>0]=112;b[q+1>>0]=97;b[q+2>>0]=100;b[q+3>>0]=87;q=f[i>>2]|0;if(!q){r=0;f[g>>2]=r;$Ha(c,e,g)|0;uT(h);uT(e);u=d;return}p=f[h>>2]|0;a=(p|0)==0?1154740:p;l=i;m=q;b:while(1){q=m;while(1){o=f[q+16>>2]|0;if((o|0)==(p|0))break;if((Ioc((o|0)==0?1154740:o,a)|0)>=0)break;o=f[q+4>>2]|0;if(!o){s=l;break b}else q=o}m=f[q>>2]|0;if(!m){s=q;break}else l=q}if((s|0)==(i|0)){r=0;f[g>>2]=r;$Ha(c,e,g)|0;uT(h);uT(e);u=d;return}i=f[s+16>>2]|0;if((p|0)!=(i|0)?(Ioc(a,(i|0)==0?1154740:i)|0)<=-1:0){r=0;f[g>>2]=r;$Ha(c,e,g)|0;uT(h);uT(e);u=d;return}i=DHa(s+24|0,-1)|0;r=i;f[g>>2]=r;$Ha(c,e,g)|0;uT(h);uT(e);u=d;return}function uKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=VDc(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;uT(p);o=Mpc(c)|0;if(o|0)dJc(tT(p,o)|0,c|0,o|0)|0;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=VDc(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;uT(t);b=Mpc(c)|0;if(b|0)dJc(tT(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;TFa(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1154740:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(t);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function vKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if(!b)return;vKa(a,f[b>>2]|0);vKa(a,f[b+4>>2]|0);a=b+16|0;c=b+28|0;d=b+64|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)_S(c);f[d>>2]=0;d=b+44|0;c=b+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[b+68>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[b+72>>2]|0;if((c|0)!=(b+76|0))g0(c);uT(a);YDc(b);return}function wKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=VDc(84)|0;e=b+4|0;b=d;g=f[c>>2]|0;f[d+16>>2]=g;f[d+20>>2]=f[c+4>>2];if(g|0){h=g+-4|0;f[h>>2]=(f[h>>2]|0)+1}f[d+24>>2]=f[c+8>>2];h=d+28|0;g=c+12|0;f[h>>2]=f[g>>2];i=d+32|0;j=c+16|0;k=f[j>>2]|0;f[i>>2]=k;l=d+36|0;f[l>>2]=f[c+20>>2];f[d+40>>2]=f[c+24>>2];f[d+44>>2]=f[c+28>>2];f[d+48>>2]=f[c+32>>2];f[d+52>>2]=f[c+36>>2];f[d+56>>2]=f[c+40>>2];f[d+60>>2]=f[c+44>>2];m=f[c+48>>2]|0;f[d+64>>2]=m;f[d+68>>2]=l;l=d+76|0;n=d+72|0;f[n>>2]=l;f[l>>2]=0;f[d+80>>2]=0;if(!m)o=k;else{k=m+12|0;f[k>>2]=(f[k>>2]|0)+1;o=f[j>>2]|0}if((o|0)<3){o=f[c+56>>2]|0;c=f[n>>2]|0;f[c>>2]=f[o>>2];f[c+4>>2]=f[o+4>>2];f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}else{f[i>>2]=0;ZS(h,g);f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}}function xKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;q=k;a:while(1){r=q;while(1){s=f[r+16>>2]|0;if((s|0)==(l|0))break;if((Ioc((s|0)==0?1154740:s,m)|0)>=0)break;s=f[r+4>>2]|0;if(!s){t=o;break a}else r=s}q=f[r>>2]|0;if(!q){t=r;break}else o=r}if((t|0)==(j|0))v=n;else{o=f[t+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){v=n;break}w=+p[c>>3];f[e>>2]=2;o=VDc(16)|0;q=o+8|0;f[o>>2]=q;f[o+4>>2]=1;f[e+4>>2]=o;p[q>>3]=w;gIa(t+24|0,e)|0;JFa(e);u=d;return c|0}}else v=f[b>>2]|0;while(0);f[h>>2]=v;t=h+4|0;f[t>>2]=f[b+4>>2];if(v|0){b=v+-4|0;f[b>>2]=(f[b>>2]|0)+1}w=+p[c>>3];f[i>>2]=2;b=VDc(16)|0;v=b+8|0;f[b>>2]=v;f[b+4>>2]=1;f[i+4>>2]=b;p[v>>3]=w;v=f[h>>2]|0;f[g>>2]=v;b=g+4|0;f[b>>2]=f[t>>2];if(v|0){t=v+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=g+8|0;TFa(t,i);v=f[g>>2]|0;f[e>>2]=v;k=e+4|0;f[k>>2]=f[b>>2];if(v|0){b=v+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=e+8|0;TFa(b,t);v=f[j>>2]|0;b:do if(!v){x=j;y=j}else{q=a+4|0;o=f[e>>2]|0;s=(o|0)==0?1154740:o;z=f[v+16>>2]|0;c:do if((o|0)!=(z|0)){A=q;B=v;C=z;while(1){D=(C|0)==0?1154740:C;if((Ioc(s,D)|0)<0){E=f[B>>2]|0;if(!E){F=24;break}else{G=B;H=E}}else{if((Ioc(D,s)|0)>=0){I=A;J=B;break c}K=B+4|0;D=f[K>>2]|0;if(!D){F=27;break}else{G=K;H=D}}C=f[H+16>>2]|0;if((o|0)==(C|0)){I=G;J=H;break c}else{A=G;B=H}}if((F|0)==24){x=B;y=B;break b}else if((F|0)==27){x=K;y=B;break b}}else{I=q;J=v}while(0);x=I;y=J}while(0);if(!(f[x>>2]|0)){J=VDc(32)|0;I=f[e>>2]|0;f[J+16>>2]=I;f[J+20>>2]=f[k>>2];if(I|0){k=I+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(J+24|0,b);f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=y;f[x>>2]=J;y=f[f[a>>2]>>2]|0;if(!y)L=J;else{f[a>>2]=y;L=f[x>>2]|0}laa(f[a+4>>2]|0,L);L=a+8|0;f[L>>2]=(f[L>>2]|0)+1}JFa(b);uT(e);JFa(t);uT(g);JFa(i);uT(h);u=d;return c|0}function yKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=VDc(16)|0;p=o+8|0;f[p>>2]=0;r=o+12|0;f[r>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;if((p|0)!=(c|0)){uT(p);o=f[c>>2]|0;if(!o)v=0;else{w=o+-4|0;f[w>>2]=(f[w>>2]|0)+1;v=f[c>>2]|0}f[p>>2]=v;f[r>>2]=f[c+4>>2]}gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=VDc(16)|0;t=b+8|0;f[t>>2]=0;v=b+12|0;f[v>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;if((t|0)!=(c|0)){uT(t);b=f[c>>2]|0;if(!b)x=0;else{k=b+-4|0;f[k>>2]=(f[k>>2]|0)+1;x=f[c>>2]|0}f[t>>2]=x;f[v>>2]=f[c+4>>2]}v=f[h>>2]|0;f[g>>2]=v;x=g+4|0;f[x>>2]=f[s>>2];if(v|0){s=v+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);v=f[g>>2]|0;f[e>>2]=v;t=e+4|0;f[t>>2]=f[x>>2];if(v|0){x=v+-4|0;f[x>>2]=(f[x>>2]|0)+1}x=e+8|0;TFa(x,s);v=f[j>>2]|0;b:do if(!v){y=j;z=j}else{k=a+4|0;b=f[e>>2]|0;r=(b|0)==0?1154740:b;p=f[v+16>>2]|0;c:do if((b|0)!=(p|0)){w=k;o=v;A=p;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[o>>2]|0;if(!C){D=32;break}else{E=o;F=C}}else{if((Ioc(B,r)|0)>=0){G=w;H=o;break c}I=o+4|0;B=f[I>>2]|0;if(!B){D=35;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((b|0)==(A|0)){G=E;H=F;break c}else{w=E;o=F}}if((D|0)==32){y=o;z=o;break b}else if((D|0)==35){y=I;z=o;break b}}else{G=k;H=v}while(0);y=G;z=H}while(0);if(!(f[y>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[t>>2];if(G|0){t=G+-4|0;f[t>>2]=(f[t>>2]|0)+1}TFa(H+24|0,x);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=z;f[y>>2]=H;z=f[f[a>>2]>>2]|0;if(!z)J=H;else{f[a>>2]=z;J=f[y>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(x);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function zKa(a){a=a|0;YDc(a);return}function AKa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0){BKa(b);YDc(b)}Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function BKa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+56|0;c=f[b>>2]|0;if(c|0){d=a+60|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;do{e=h+-8|0;f[d>>2]=e;i=f[e>>2]|0;if(i|0?(j=i+4|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)Yi[f[(f[i>>2]|0)+8>>2]&2047](i);f[e>>2]=0;f[h+-4>>2]=0;h=f[d>>2]|0}while((h|0)!=(c|0));g=f[b>>2]|0}YDc(g)}HFa(a+16|0);uT(a+8|0);uT(a);return}function CKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=VDc(76)|0;e=b+4|0;b=d;f[d+16>>2]=f[c>>2];g=d+20|0;h=c+4|0;f[g>>2]=f[h>>2];i=d+24|0;j=c+8|0;k=f[j>>2]|0;f[i>>2]=k;l=d+28|0;f[l>>2]=f[c+12>>2];f[d+32>>2]=f[c+16>>2];f[d+36>>2]=f[c+20>>2];f[d+40>>2]=f[c+24>>2];f[d+44>>2]=f[c+28>>2];f[d+48>>2]=f[c+32>>2];f[d+52>>2]=f[c+36>>2];m=f[c+40>>2]|0;f[d+56>>2]=m;f[d+60>>2]=l;l=d+68|0;n=d+64|0;f[n>>2]=l;f[l>>2]=0;f[d+72>>2]=0;if(!m)o=k;else{k=m+12|0;f[k>>2]=(f[k>>2]|0)+1;o=f[j>>2]|0}if((o|0)<3){o=f[c+48>>2]|0;c=f[n>>2]|0;f[c>>2]=f[o>>2];f[c+4>>2]=f[o+4>>2];f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}else{f[i>>2]=0;ZS(g,h);f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}}function DKa(a){a=a|0;YDc(a);return}function EKa(a){a=a|0;Yi[f[a+12>>2]&2047](f[a+8>>2]|0);if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function FKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+96|0;e=d+16|0;g=d+8|0;h=d;i=f[b>>2]|0;f[g>>2]=i;f[g+4>>2]=f[b+4>>2];if(i|0){b=i+-4|0;f[b>>2]=(f[b>>2]|0)+1}fKa(e,g,c);uT(g);tFa(a);g=f[a>>2]|0;f[h>>2]=g;f[h+4>>2]=f[a+4>>2];if(g|0){a=g+4|0;f[a>>2]=(f[a>>2]|0)+1}GKa(e,h);fGa(h);hKa(e);u=d;return}function GKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a+64|0;if(f[h>>2]|0){f[e>>2]=0;f[e+4>>2]=0;i=tT(e,18)|0;j=389325;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));z5(-215,e,390086,386595,1227)}HKa(e,386739);j=f[e+4>>2]|0;f[h>>2]=j;i=a+68|0;f[i>>2]=j;SKa(f[a+12>>2]|0,0);gKa(a);j=f[c>>2]|0;k=f[c+4>>2]|0;if(j|0){c=j+4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[a>>2]|0;f[a>>2]=j;f[a+4>>2]=k;if(c|0?(k=c+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)Yi[f[(f[c>>2]|0)+8>>2]&2047](c);f[g>>2]=0;c=g+4|0;f[c>>2]=0;f[g+8>>2]=0;IKa(a,f[h>>2]|0,g,0,0)|0;f[h>>2]=0;f[i>>2]=0;i=f[g>>2]|0;if(i|0){g=f[c>>2]|0;if((g|0)!=(i|0))f[c>>2]=g+(~((g+-8-i|0)>>>3)<<3);YDc(i)}i=f[e>>2]|0;if(!i){u=d;return}e=i+4|0;g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)!=1){u=d;return}Yi[f[(f[i>>2]|0)+8>>2]&2047](i);u=d;return}function HKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c+8|0;e=c;g=VDc(68)|0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;i=Mpc(b)|0;if(!i){j=0;k=0}else{dJc(tT(d,i)|0,b|0,i|0)|0;j=f[d>>2]|0;k=f[h>>2]|0}f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[g>>2]=j;f[g+4>>2]=k;if(j){k=j+-4|0;f[k>>2]=(f[k>>2]|0)+1;k=f[e>>2]|0;j=f[h>>2]|0;f[g+8>>2]=k;f[g+12>>2]=j;if(k|0){j=k+-4|0;f[j>>2]=(f[j>>2]|0)+1}}else{f[g+8>>2]=0;f[g+12>>2]=0}j=g+20|0;f[j>>2]=0;f[g+24>>2]=0;f[g+16>>2]=j;j=g+28|0;k=j+40|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=VDc(16)|0;f[j+4>>2]=1;f[j>>2]=78548;f[j+8>>2]=g;f[a>>2]=j;f[a+4>>2]=g;uT(e);uT(d);u=c;return}function IKa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;h=u;u=u+176|0;i=h+88|0;j=h+136|0;k=h+48|0;l=h+8|0;m=h+120|0;n=h;o=h+112|0;p=h+104|0;if(!c){q=e;u=h;return q|0}r=c+8|0;if(f[c+12>>2]|0){JKa(i,a,r);s=gGa(a,i,r,c+16|0)|0;uT(i);mGa(a,e,g,s,0);f[i>>2]=s;f[i+4>>2]=c;r=d+4|0;t=f[r>>2]|0;if((t|0)==(f[d+8>>2]|0))KKa(d,i);else{v=i;w=f[v+4>>2]|0;x=t;f[x>>2]=f[v>>2];f[x+4>>2]=w;f[r>>2]=(f[r>>2]|0)+8}q=s;u=h;return q|0}s=f[c>>2]|0;if(((s|0)!=386739?(r=(s|0)==0?1154740:s,!((Ioc(r,386739)|0)==0|(s|0)==386793)):0)?Ioc(r,386793)|0:0){if((s|0)!=454781?Ioc(r,454781)|0:0){if((s|0)!=386781?Ioc(r,386781)|0:0){if((s|0)!=386750?Ioc(r,386750)|0:0){if((s|0)!=386759?Ioc(r,386759)|0:0){do if((s|0)!=386771){if(!(Ioc(r,386771)|0))break;do if((s|0)!=387590){if(!(Ioc(r,387590)|0))break;do if((s|0)!=388197){if(!(Ioc(r,388197)|0))break;f[i>>2]=0;f[i+4>>2]=0;w=c+4|0;tT(i,(f[w>>2]|0)+28|0)|0;x=f[i>>2]|0;y=x;z=389534;A=y+28|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));v=f[w>>2]|0;if(!v)z5(-3,i,389409,386595,1219);dJc(x+28|0,f[c>>2]|0,v|0)|0;z5(-3,i,389409,386595,1219)}while(0);v=c+16|0;f[i>>2]=0;f[i+4>>2]=0;y=tT(i,15)|0;z=387041;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));t=f[c+20>>2]|0;if(!t){uT(i);f[i>>2]=0;B=i+4|0;f[B>>2]=0;C=tT(i,37)|0;y=C;z=389453;A=y+37|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,i,389409,386595,1185)}D=f[i>>2]|0;E=(D|0)==0?1154740:D;F=t;while(1){G=f[F+16>>2]|0;if((D|0)==(G|0))break;H=(G|0)==0?1154740:G;if((Ioc(E,H)|0)<0)I=F;else{if((Ioc(H,E)|0)>=0)break;I=F+4|0}F=f[I>>2]|0;if(!F){J=118;break}}if((J|0)==118){uT(i);f[i>>2]=0;B=i+4|0;f[B>>2]=0;C=tT(i,37)|0;y=C;z=389453;A=y+37|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,i,389409,386595,1185)}uT(i);f[i>>2]=0;f[i+4>>2]=0;y=tT(i,15)|0;z=387041;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));F=DHa(lIa(v,i)|0,-1)|0;uT(i);E=d+4|0;D=f[d>>2]|0;a:do if((f[E>>2]|0)==(D|0)){K=-1;L=0}else{t=i+4|0;H=j+4|0;G=0;M=D;b:while(1){N=M;O=f[(f[N+(G<<3)+4>>2]|0)+8>>2]|0;if(!((O|0)!=454888?(Ioc((O|0)==0?1154740:O,454888)|0)!=0:0))J=123;c:do if((J|0)==123){J=0;O=f[N+(G<<3)+4>>2]|0;f[i>>2]=0;f[t>>2]=0;y=tT(i,15)|0;z=387041;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));P=f[O+20>>2]|0;d:do if(P|0){Q=f[i>>2]|0;R=(Q|0)==0?1154740:Q;S=P;while(1){T=f[S+16>>2]|0;if((Q|0)==(T|0))break;U=(T|0)==0?1154740:T;if((Ioc(R,U)|0)<0)V=S;else{if((Ioc(U,R)|0)>=0)break;V=S+4|0}S=f[V>>2]|0;if(!S)break d}S=f[(f[d>>2]|0)+(G<<3)+4>>2]|0;f[j>>2]=0;f[H>>2]=0;y=tT(j,15)|0;z=387041;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));R=DHa(lIa(S+16|0,j)|0,-1)|0;uT(j);uT(i);if((R|0)==(F|0))break b;else break c}while(0);uT(i)}while(0);N=G+1|0;M=f[d>>2]|0;if(N>>>0>=(f[E>>2]|0)-M>>3>>>0){K=-1;L=0;break a}else G=N}M=f[d>>2]|0;K=f[M+(G<<3)>>2]|0;L=f[M+(G<<3)+4>>2]|0}while(0);f[i>>2]=0;f[i+4>>2]=0;E=tT(i,8)|0;F=E;b[F>>0]=112;b[F+1>>0]=111;b[F+2>>0]=111;b[F+3>>0]=108;F=E+4|0;b[F>>0]=95;b[F+1>>0]=107;b[F+2>>0]=95;b[F+3>>0]=104;f[k>>2]=0;f[k+4>>2]=0;F=tT(k,8)|0;E=F;b[E>>0]=107;b[E+1>>0]=101;b[E+2>>0]=114;b[E+3>>0]=110;E=F+4|0;b[E>>0]=101;b[E+1>>0]=108;b[E+2>>0]=95;b[E+3>>0]=104;E=L+16|0;F=DHa(lIa(E,k)|0,-1)|0;f[j>>2]=F;$Ha(v,i,j)|0;uT(k);uT(i);f[i>>2]=0;f[i+4>>2]=0;F=tT(i,8)|0;D=F;b[D>>0]=112;b[D+1>>0]=111;b[D+2>>0]=111;b[D+3>>0]=108;D=F+4|0;b[D>>0]=95;b[D+1>>0]=107;b[D+2>>0]=95;b[D+3>>0]=119;f[k>>2]=0;f[k+4>>2]=0;D=tT(k,8)|0;F=D;b[F>>0]=107;b[F+1>>0]=101;b[F+2>>0]=114;b[F+3>>0]=110;F=D+4|0;b[F>>0]=101;b[F+1>>0]=108;b[F+2>>0]=95;b[F+3>>0]=119;F=DHa(lIa(E,k)|0,-1)|0;f[j>>2]=F;$Ha(v,i,j)|0;uT(k);uT(i);f[i>>2]=0;f[i+4>>2]=0;y=tT(i,13)|0;z=444927;A=y+13|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));f[k>>2]=0;f[k+4>>2]=0;F=tT(k,8)|0;D=F;b[D>>0]=115;b[D+1>>0]=116;b[D+2>>0]=114;b[D+3>>0]=105;D=F+4|0;b[D>>0]=100;b[D+1>>0]=101;b[D+2>>0]=95;b[D+3>>0]=104;D=DHa(lIa(E,k)|0,-1)|0;f[j>>2]=D;$Ha(v,i,j)|0;uT(k);uT(i);f[i>>2]=0;f[i+4>>2]=0;y=tT(i,13)|0;z=444913;A=y+13|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));f[k>>2]=0;f[k+4>>2]=0;D=tT(k,8)|0;F=D;b[F>>0]=115;b[F+1>>0]=116;b[F+2>>0]=114;b[F+3>>0]=105;F=D+4|0;b[F>>0]=100;b[F+1>>0]=101;b[F+2>>0]=95;b[F+3>>0]=119;F=DHa(lIa(E,k)|0,-1)|0;f[j>>2]=F;$Ha(v,i,j)|0;uT(k);uT(i);f[i>>2]=0;f[i+4>>2]=0;y=tT(i,10)|0;z=444902;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));f[k>>2]=0;f[k+4>>2]=0;F=tT(k,5)|0;b[F>>0]=b[387904]|0;b[F+1>>0]=b[387905]|0;b[F+2>>0]=b[387906]|0;b[F+3>>0]=b[387907]|0;b[F+4>>0]=b[387908]|0;F=DHa(lIa(E,k)|0,-1)|0;f[j>>2]=F;$Ha(v,i,j)|0;uT(k);uT(i);f[i>>2]=0;f[i+4>>2]=0;y=tT(i,10)|0;z=444891;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));f[k>>2]=0;f[k+4>>2]=0;F=tT(k,5)|0;b[F>>0]=b[387898]|0;b[F+1>>0]=b[387899]|0;b[F+2>>0]=b[387900]|0;b[F+3>>0]=b[387901]|0;b[F+4>>0]=b[387902]|0;F=DHa(lIa(E,k)|0,-1)|0;f[j>>2]=F;$Ha(v,i,j)|0;uT(k);uT(i);f[j>>2]=0;f[j+4>>2]=0;y=tT(j,17)|0;z=389491;A=y+17|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));JKa(i,a,j);uT(j);f[j>>2]=0;f[j+4>>2]=0;y=tT(j,9)|0;z=425674;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));E=gGa(a,i,j,v)|0;uT(j);mGa(a,e,0,E,0);if((K|0)==-1){f[j>>2]=0;f[j+4>>2]=0;y=tT(j,24)|0;z=389509;A=y+24|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,j,389409,386595,1212)}mGa(a,K,1,E,1);uT(i);q=E;u=h;return q|0}while(0);f[j>>2]=0;f[j+4>>2]=0;y=tT(j,14)|0;z=389438;A=y+14|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));JKa(i,a,j);uT(j);FHa(j,a);f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=k+4;v=k+12|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[l>>2]=0;f[l+4>>2]=0;y=tT(l,9)|0;z=445470;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));qIa(k,l,454649)|0;uT(l);f[l>>2]=0;f[l+4>>2]=0;v=tT(l,7)|0;b[v>>0]=b[454641]|0;b[v+1>>0]=b[454642]|0;b[v+2>>0]=b[454643]|0;b[v+3>>0]=b[454644]|0;b[v+4>>0]=b[454645]|0;b[v+5>>0]=b[454646]|0;b[v+6>>0]=b[454647]|0;v=gGa(a,i,l,k)|0;uT(l);F=a+56|0;D=f[F>>2]|0;if((f[a+52>>2]|0)==(D|0)){f[l>>2]=0;f[l+4>>2]=0;y=tT(l,29)|0;z=389379;A=y+29|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,l,389409,386595,1172)}M=D+-4|0;H=f[M>>2]|0;f[F>>2]=M;M=j+4|0;t=f[M>>2]|0;x=f[j>>2]|0;if(H>>>0>t-x>>2>>>0){f[l>>2]=0;f[l+4>>2]=0;y=tT(l,23)|0;z=389414;A=y+23|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,l,389409,386595,1175)}e:do if((H|0)>0){F=0;D=x;w=t;while(1){mGa(a,f[D+(F-H+(w-D>>2)<<2)>>2]|0,0,v,F);N=F+1|0;if((N|0)>=(H|0))break e;F=N;D=f[j>>2]|0;w=f[M>>2]|0}}while(0);f[l>>2]=v;f[l+4>>2]=c;H=d+4|0;t=f[H>>2]|0;if((t|0)==(f[d+8>>2]|0))KKa(d,l);else{x=l;w=f[x+4>>2]|0;D=t;f[D>>2]=f[x>>2];f[D+4>>2]=w;f[H>>2]=(f[H>>2]|0)+8}HFa(k);H=f[j>>2]|0;if(H|0){w=f[M>>2]|0;if((w|0)!=(H|0))f[M>>2]=w+(~((w+-4-H|0)>>>2)<<2);YDc(H)}uT(i);q=v;u=h;return q|0}while(0);FHa(i,a);f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;K=j+12|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;f[K+16>>2]=0;f[K+20>>2]=0;f[K+24>>2]=0;f[k>>2]=0;f[k+4>>2]=0;K=tT(k,4)|0;b[K>>0]=97;b[K+1>>0]=120;b[K+2>>0]=105;b[K+3>>0]=115;f[m>>2]=0;f[m+4>>2]=0;y=tT(m,9)|0;z=386834;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));K=DHa(lIa(c+16|0,m)|0,-1)|0;f[l>>2]=K+-1;$Ha(j,k,l)|0;uT(m);uT(k);f[l>>2]=0;f[l+4>>2]=0;y=tT(l,10)|0;z=389344;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));JKa(k,a,l);f[m>>2]=0;f[m+4>>2]=0;K=tT(m,6)|0;b[K>>0]=b[454781]|0;b[K+1>>0]=b[454782]|0;b[K+2>>0]=b[454783]|0;b[K+3>>0]=b[454784]|0;b[K+4>>0]=b[454785]|0;b[K+5>>0]=b[454786]|0;K=gGa(a,k,m,j)|0;uT(m);uT(k);uT(l);f[k>>2]=K;f[k+4>>2]=c;L=d+4|0;V=f[L>>2]|0;if((V|0)==(f[d+8>>2]|0))KKa(d,k);else{J=k;C=f[J+4>>2]|0;B=V;f[B>>2]=f[J>>2];f[B+4>>2]=C;f[L>>2]=(f[L>>2]|0)+8}L=a+56|0;C=f[L>>2]|0;if((f[a+52>>2]|0)==(C|0)){f[k>>2]=0;f[k+4>>2]=0;y=tT(k,29)|0;z=389379;A=y+29|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,k,389409,386595,1151)}B=C+-4|0;C=f[B>>2]|0;f[L>>2]=B;B=i+4|0;L=f[B>>2]|0;J=f[i>>2]|0;if(C>>>0>L-J>>2>>>0){f[k>>2]=0;f[k+4>>2]=0;y=tT(k,23)|0;z=389414;A=y+23|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));z5(-215,k,389409,386595,1154)}f:do if((C|0)>0){V=0;I=J;r=L;while(1){mGa(a,f[I+(V-C+(r-I>>2)<<2)>>2]|0,0,K,V);s=V+1|0;if((s|0)>=(C|0))break f;V=s;I=f[i>>2]|0;r=f[B>>2]|0}}while(0);HFa(j);C=f[i>>2]|0;if(C|0){L=f[B>>2]|0;if((L|0)!=(C|0))f[B>>2]=L+(~((L+-4-C|0)>>>2)<<2);YDc(C)}q=K;u=h;return q|0}K=a+72|0;f[K>>2]=(f[K>>2]|0)+1;K=c+56|0;C=c+60|0;L=f[C>>2]|0;B=f[K>>2]|0;if((L-B|0)>0){J=0;r=B;while(1){I=IKa(a,f[r+(J<<3)+4>>2]|0,d,e,g)|0;J=J+1|0;V=f[C>>2]|0;v=f[K>>2]|0;if((J|0)>=(V-v>>3|0)){W=I;X=v;Y=V;break}else r=v}}else{W=-1;X=B;Y=L}L=Y-X>>3;f[i>>2]=L;X=a+56|0;Y=f[X>>2]|0;if((Y|0)==(f[a+60>>2]|0))g6(a+52|0,i);else{f[Y>>2]=L;f[X>>2]=Y+4}q=W;u=h;return q|0}f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;W=j+12|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;f[W+16>>2]=0;f[W+20>>2]=0;f[W+24>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=k+4;W=k+12|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;f[W+16>>2]=0;f[W+20>>2]=0;f[W+24>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=l+4;W=l+12|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;f[W+16>>2]=0;f[W+20>>2]=0;f[W+24>>2]=0;f[m>>2]=0;f[m+4>>2]=0;W=tT(m,4)|0;b[W>>0]=97;b[W+1>>0]=120;b[W+2>>0]=105;b[W+3>>0]=115;W=c+16|0;f[o>>2]=0;f[o+4>>2]=0;y=tT(o,14)|0;z=386803;A=y+14|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Y=DHa(lIa(W,o)|0,-1)|0;f[n>>2]=Y+-1;$Ha(j,m,n)|0;uT(o);uT(m);f[m>>2]=0;f[m+4>>2]=0;Y=tT(m,4)|0;b[Y>>0]=97;b[Y+1>>0]=120;b[Y+2>>0]=105;b[Y+3>>0]=115;f[o>>2]=0;f[o+4>>2]=0;y=tT(o,15)|0;z=386818;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Y=DHa(lIa(W,o)|0,-1)|0;f[n>>2]=Y+-1;$Ha(k,m,n)|0;uT(o);uT(m);f[m>>2]=0;f[m+4>>2]=0;Y=tT(m,4)|0;b[Y>>0]=97;b[Y+1>>0]=120;b[Y+2>>0]=105;b[Y+3>>0]=115;f[o>>2]=0;f[o+4>>2]=0;Y=tT(o,4)|0;b[Y>>0]=97;b[Y+1>>0]=120;b[Y+2>>0]=105;b[Y+3>>0]=115;Y=DHa(lIa(j,o)|0,-1)|0;f[n>>2]=Y;$Ha(l,m,n)|0;uT(o);uT(m);f[m>>2]=0;f[m+4>>2]=0;Y=tT(m,8)|0;W=Y;b[W>>0]=110;b[W+1>>0]=117;b[W+2>>0]=109;b[W+3>>0]=95;W=Y+4|0;b[W>>0]=97;b[W+1>>0]=120;b[W+2>>0]=101;b[W+3>>0]=115;f[n>>2]=1;$Ha(l,m,n)|0;uT(m);f[n>>2]=0;f[n+4>>2]=0;y=tT(n,10)|0;z=389355;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));JKa(m,a,n);f[o>>2]=0;f[o+4>>2]=0;W=tT(o,5)|0;b[W>>0]=b[425537]|0;b[W+1>>0]=b[425538]|0;b[W+2>>0]=b[425539]|0;b[W+3>>0]=b[425540]|0;b[W+4>>0]=b[425541]|0;W=gGa(a,m,o,j)|0;uT(o);uT(m);uT(n);f[n>>2]=0;f[n+4>>2]=0;y=tT(n,12)|0;z=389366;A=y+12|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));JKa(m,a,n);f[o>>2]=0;f[o+4>>2]=0;Y=tT(o,7)|0;b[Y>>0]=b[426093]|0;b[Y+1>>0]=b[426094]|0;b[Y+2>>0]=b[426095]|0;b[Y+3>>0]=b[426096]|0;b[Y+4>>0]=b[426097]|0;b[Y+5>>0]=b[426098]|0;b[Y+6>>0]=b[426099]|0;Y=gGa(a,m,o,l)|0;uT(o);uT(m);uT(n);mGa(a,e,g,W,0);f[m>>2]=0;X=m+4|0;f[X>>2]=0;f[m+8>>2]=0;L=c+56|0;B=c+60|0;if(((f[B>>2]|0)-(f[L>>2]|0)|0)>0){r=m+8|0;J=0;do{mGa(a,W,J,Y,J);K=IKa(a,f[(f[L>>2]|0)+(J<<3)+4>>2]|0,d,Y,J)|0;f[i>>2]=K;C=f[X>>2]|0;if((C|0)==(f[r>>2]|0))g6(m,i);else{f[C>>2]=K;f[X>>2]=C+4}J=J+1|0}while((J|0)<((f[B>>2]|0)-(f[L>>2]|0)>>3|0))}f[o>>2]=0;f[o+4>>2]=0;y=tT(o,10)|0;z=389344;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));JKa(n,a,o);f[p>>2]=0;f[p+4>>2]=0;L=tT(p,6)|0;b[L>>0]=b[454781]|0;b[L+1>>0]=b[454782]|0;b[L+2>>0]=b[454783]|0;b[L+3>>0]=b[454784]|0;b[L+4>>0]=b[454785]|0;b[L+5>>0]=b[454786]|0;L=gGa(a,n,p,k)|0;uT(p);uT(n);uT(o);o=f[m>>2]|0;if((f[X>>2]|0)!=(o|0)){p=0;B=o;do{mGa(a,f[B+(p<<2)>>2]|0,0,L,p);p=p+1|0;B=f[m>>2]|0}while(p>>>0<(f[X>>2]|0)-B>>2>>>0)}f[n>>2]=L;f[n+4>>2]=c;B=d+4|0;p=f[B>>2]|0;if((p|0)==(f[d+8>>2]|0))KKa(d,n);else{o=n;J=f[o+4>>2]|0;r=p;f[r>>2]=f[o>>2];f[r+4>>2]=J;f[B>>2]=(f[B>>2]|0)+8}B=f[m>>2]|0;if(B|0){J=f[X>>2]|0;if((J|0)!=(B|0))f[X>>2]=J+(~((J+-4-B|0)>>>2)<<2);YDc(B)}HFa(l);HFa(k);HFa(j);q=L;u=h;return q|0}f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;L=j+12|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;f[L+24>>2]=0;f[k>>2]=0;f[k+4>>2]=0;L=tT(k,4)|0;b[L>>0]=97;b[L+1>>0]=120;b[L+2>>0]=105;b[L+3>>0]=115;f[m>>2]=0;f[m+4>>2]=0;y=tT(m,9)|0;z=386834;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));L=DHa(lIa(c+16|0,m)|0,-1)|0;f[l>>2]=L+-1;$Ha(j,k,l)|0;uT(m);uT(k);f[k>>2]=0;f[k+4>>2]=0;L=tT(k,7)|0;b[L>>0]=b[440970]|0;b[L+1>>0]=b[440971]|0;b[L+2>>0]=b[440972]|0;b[L+3>>0]=b[440973]|0;b[L+4>>0]=b[440974]|0;b[L+5>>0]=b[440975]|0;b[L+6>>0]=b[440976]|0;b[l>>0]=1;rIa(j,k,l)|0;uT(k);f[k>>2]=0;L=k+4|0;f[L>>2]=0;f[k+8>>2]=0;B=c+56|0;J=c+60|0;X=f[B>>2]|0;if(((f[J>>2]|0)-X|0)>0){r=k+8|0;o=0;p=X;do{X=IKa(a,f[p+(o<<3)+4>>2]|0,d,e,g)|0;f[i>>2]=X;Y=f[L>>2]|0;if((Y|0)==(f[r>>2]|0))g6(k,i);else{f[Y>>2]=X;f[L>>2]=Y+4}o=o+1|0;p=f[B>>2]|0}while((o|0)<((f[J>>2]|0)-p>>3|0))}f[m>>2]=0;f[m+4>>2]=0;y=tT(m,10)|0;z=389344;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));JKa(l,a,m);f[n>>2]=0;f[n+4>>2]=0;p=tT(n,6)|0;b[p>>0]=b[454781]|0;b[p+1>>0]=b[454782]|0;b[p+2>>0]=b[454783]|0;b[p+3>>0]=b[454784]|0;b[p+4>>0]=b[454785]|0;b[p+5>>0]=b[454786]|0;p=gGa(a,l,n,j)|0;uT(n);uT(l);uT(m);J=f[k>>2]|0;if((f[L>>2]|0)!=(J|0)){o=0;B=J;do{mGa(a,f[B+(o<<2)>>2]|0,0,p,o);o=o+1|0;B=f[k>>2]|0}while(o>>>0<(f[L>>2]|0)-B>>2>>>0)}f[l>>2]=p;f[l+4>>2]=c;B=d+4|0;o=f[B>>2]|0;if((o|0)==(f[d+8>>2]|0))KKa(d,l);else{J=l;r=f[J+4>>2]|0;Y=o;f[Y>>2]=f[J>>2];f[Y+4>>2]=r;f[B>>2]=(f[B>>2]|0)+8}B=f[k>>2]|0;if(B|0){r=f[L>>2]|0;if((r|0)!=(B|0))f[L>>2]=r+(~((r+-4-B|0)>>>2)<<2);YDc(B)}HFa(j);q=p;u=h;return q|0}f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;p=j+12|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[k>>2]=0;f[k+4>>2]=0;p=tT(k,4)|0;b[p>>0]=97;b[p+1>>0]=120;b[p+2>>0]=105;b[p+3>>0]=115;f[m>>2]=0;f[m+4>>2]=0;y=tT(m,9)|0;z=386834;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));p=DHa(lIa(c+16|0,m)|0,-1)|0;f[l>>2]=p+-1;$Ha(j,k,l)|0;uT(m);uT(k);f[k>>2]=0;p=k+4|0;f[p>>2]=0;f[k+8>>2]=0;B=c+56|0;r=c+60|0;L=f[B>>2]|0;if(((f[r>>2]|0)-L|0)>0){Y=k+8|0;J=0;o=L;do{L=IKa(a,f[o+(J<<3)+4>>2]|0,d,e,g)|0;f[i>>2]=L;X=f[p>>2]|0;if((X|0)==(f[Y>>2]|0))g6(k,i);else{f[X>>2]=L;f[p>>2]=X+4}J=J+1|0;o=f[B>>2]|0}while((J|0)<((f[r>>2]|0)-o>>3|0))}o=a+72|0;f[o>>2]=(f[o>>2]|0)+1;f[m>>2]=0;f[m+4>>2]=0;y=tT(m,10)|0;z=389344;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));JKa(l,a,m);f[n>>2]=0;f[n+4>>2]=0;z=tT(n,6)|0;b[z>>0]=b[454781]|0;b[z+1>>0]=b[454782]|0;b[z+2>>0]=b[454783]|0;b[z+3>>0]=b[454784]|0;b[z+4>>0]=b[454785]|0;b[z+5>>0]=b[454786]|0;z=gGa(a,l,n,j)|0;uT(n);uT(l);uT(m);m=f[k>>2]|0;if((f[p>>2]|0)!=(m|0)){n=0;y=m;do{mGa(a,f[y+(n<<2)>>2]|0,0,z,n);n=n+1|0;y=f[k>>2]|0}while(n>>>0<(f[p>>2]|0)-y>>2>>>0)}f[l>>2]=z;f[l+4>>2]=c;y=d+4|0;n=f[y>>2]|0;if((n|0)==(f[d+8>>2]|0))KKa(d,l);else{m=l;l=f[m+4>>2]|0;A=n;f[A>>2]=f[m>>2];f[A+4>>2]=l;f[y>>2]=(f[y>>2]|0)+8}y=f[k>>2]|0;if(y|0){k=f[p>>2]|0;if((k|0)!=(y|0))f[p>>2]=k+(~((k+-4-y|0)>>>2)<<2);YDc(y)}HFa(j);q=z;u=h;return q|0}z=c+56|0;j=c+60|0;c=f[z>>2]|0;if((f[j>>2]|0)==(c|0)){q=e;u=h;return q|0}else{Z=e;_=g;$=0;aa=c}while(1){c=IKa(a,f[aa+($<<3)+4>>2]|0,d,Z,_)|0;$=$+1|0;aa=f[z>>2]|0;if($>>>0>=(f[j>>2]|0)-aa>>3>>>0){q=c;break}else{Z=c;_=0}}u=h;return q|0}function JKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+176|0;g=e+160|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=c+72|0;f[l>>2]=(f[l>>2]|0)+1;c=h+56|0;m=h+4|0;f[h>>2]=7676;f[c>>2]=7696;auc(h+56|0,m);f[h+128>>2]=0;f[h+132>>2]=-1;f[h>>2]=46080;f[c>>2]=46100;fuc(m);f[m>>2]=45740;c=h+36|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[h+52>>2]=16;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;G1(m,g);if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);suc(h,f[l>>2]|0)|0;I1(g,m);f[k>>2]=0;m=k+4|0;f[m>>2]=0;l=g+11|0;c=b[l>>0]|0;n=c<<24>>24<0?f[g+4>>2]|0:c&255;if(!n)o=c;else{c=tT(k,n)|0;dJc(c|0,((b[l>>0]|0)<0?f[g>>2]|0:g)|0,n|0)|0;o=b[l>>0]|0}if(o<<24>>24<0)YDc(f[g>>2]|0);D3(h);f[j>>2]=0;h=j+4|0;f[h>>2]=0;tT(j,(f[m>>2]|0)+1|0)|0;b[f[j>>2]>>0]=108;g=f[m>>2]|0;if(g|0)dJc((f[j>>2]|0)+1|0,f[k>>2]|0,g|0)|0;f[i>>2]=0;g=i+4|0;f[g>>2]=0;tT(i,(f[h>>2]|0)+1|0)|0;m=f[h>>2]|0;if(!m)p=0;else{dJc(f[i>>2]|0,f[j>>2]|0,m|0)|0;p=f[h>>2]|0}b[(f[i>>2]|0)+p>>0]=95;f[a>>2]=0;f[a+4>>2]=0;p=d+4|0;tT(a,(f[p>>2]|0)+(f[g>>2]|0)|0)|0;h=f[g>>2]|0;if(h|0)dJc(f[a>>2]|0,f[i>>2]|0,h|0)|0;h=f[p>>2]|0;if(!h){uT(i);uT(j);uT(k);u=e;return}dJc((f[a>>2]|0)+(f[g>>2]|0)|0,f[d>>2]|0,h|0)|0;uT(i);uT(j);uT(k);u=e;return}function KKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)mCc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;bEc(k,503977);f[k>>2]=185532;ig(k|0,23696,1627)}else{m=VDc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)dJc(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;YDc(d);return}function LKa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+4>>2]&511](a,b,c)|0}function MKa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+8>>2]&511](a,b,c)|0}function NKa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+12>>2]&511](a,b,c)|0}function OKa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+16>>2]&511](a,b,c)|0}function PKa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+20>>2]&511](a,b,c)|0}function QKa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+24>>2]&511](a,b,c)|0}function RKa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+28>>2]&511](a,b,c)|0}function SKa(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+36>>2]&2047](a,b);return}function TKa(a){a=a|0;return _i[f[(f[a>>2]|0)+44>>2]&1023](a)|0}function UKa(a){a=a|0;Yi[f[(f[a>>2]|0)+52>>2]&2047](a);return}function VKa(a){a=a|0;return _i[f[f[a>>2]>>2]&1023](a)|0}function WKa(a){a=a|0;f[a+16>>2]=1;return}function XKa(a){a=a|0;f[a+16>>2]=0;return}function YKa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;hj[f[(f[a>>2]|0)+16>>2]&511](a,c,1)|0;u=b;return f[c>>2]|0}function ZKa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;hj[f[(f[a>>2]|0)+20>>2]&511](a,c,1)|0;a=c;J=f[a+4>>2]|0;u=b;return f[a>>2]|0}function _Ka(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;hj[f[(f[a>>2]|0)+28>>2]&511](a,c,1)|0;u=b;return +(+p[c>>3])}function $Ka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+416|0;g=e+224|0;h=e+36|0;i=e+24|0;j=e+12|0;k=e;l=f[c>>2]|0;m=g+108|0;n=g+8|0;f[g>>2]=14524;f[m>>2]=14544;f[g+4>>2]=0;auc(g+108|0,n);f[g+180>>2]=0;f[g+184>>2]=-1;f[g>>2]=78612;f[m>>2]=78632;AIa(n);o=g+72|0;if((f[o>>2]|0)==0?(p=yqc((l|0)==0?1154740:l,393937)|0,f[o>>2]=p,(p|0)!=0):0)f[g+96>>2]=8;else q=4;if((q|0)==4?(p=g+(f[(f[g>>2]|0)+-12>>2]|0)|0,$tc(p,f[p+16>>2]|4),(f[o>>2]|0)==0):0){o=f[c>>2]|0;p=f[c+4>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(p>>>0>4294967279)dEc(j);if(p>>>0<11){b[j+11>>0]=p;if(!p)r=j;else{s=j;q=10}}else{c=p+16&-16;l=VDc(c)|0;f[j>>2]=l;f[j+8>>2]=c|-2147483648;f[j+4>>2]=p;s=l;q=10}if((q|0)==10){dJc(s|0,o|0,p|0)|0;r=s}b[r+p>>0]=0;VHa(i,394083,j);f[h>>2]=0;f[h+4>>2]=0;p=i+11|0;r=b[p>>0]|0;s=r<<24>>24<0?f[i+4>>2]|0:r&255;if(!s)aLa(-212,h,389563,207);r=tT(h,s)|0;dJc(r|0,((b[p>>0]|0)<0?f[i>>2]|0:i)|0,s|0)|0;aLa(-212,h,389563,207)}f[h>>2]=0;f[h+4>>2]=0;s=f[d>>2]|0;if(s){p=(b[s>>0]|0)!=0;uT(h);if(p){p=f[d>>2]|0;s=h+108|0;r=h+8|0;f[h>>2]=14524;f[s>>2]=14544;f[h+4>>2]=0;auc(h+108|0,r);f[h+180>>2]=0;f[h+184>>2]=-1;f[h>>2]=78612;f[s>>2]=78632;AIa(r);o=h+72|0;if((f[o>>2]|0)==0?(l=yqc((p|0)==0?1154740:p,429489)|0,f[o>>2]=l,(l|0)!=0):0)f[h+96>>2]=12;else q=19;if((q|0)==19?(l=h+(f[(f[h>>2]|0)+-12>>2]|0)|0,$tc(l,f[l+16>>2]|4),(f[o>>2]|0)==0):0){o=f[d>>2]|0;l=f[d+4>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(l>>>0>4294967279)dEc(k);if(l>>>0<11){b[k+11>>0]=l;if(!l)t=k;else{v=k;q=25}}else{d=l+16&-16;p=VDc(d)|0;f[k>>2]=p;f[k+8>>2]=d|-2147483648;f[k+4>>2]=l;v=p;q=25}if((q|0)==25){dJc(v|0,o|0,l|0)|0;t=v}b[t+l>>0]=0;VHa(j,394083,k);f[i>>2]=0;f[i+4>>2]=0;k=j+11|0;l=b[k>>0]|0;t=l<<24>>24<0?f[j+4>>2]|0:l&255;if(!t)aLa(-212,i,389563,214);l=tT(i,t)|0;dJc(l|0,((b[k>>0]|0)<0?f[j>>2]|0:j)|0,t|0)|0;aLa(-212,i,389563,214)}bLa(a,g,h);f[h>>2]=78612;f[s>>2]=78632;BIa(r);Ctc(h,78644);Lsc(s);f[g>>2]=78612;f[m>>2]=78632;BIa(n);Ctc(g,78644);Lsc(m);u=e;return}}else uT(h);cLa(a,g);f[g>>2]=78612;f[m>>2]=78632;BIa(n);Ctc(g,78644);Lsc(m);u=e;return}function aLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,389586,d);return}function bLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+96|0;g=e+8|0;h=e;tFa(a);f[g+40>>2]=0;f[g+44>>2]=0;i=g+40|0;j=g+36|0;k=g;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;f[g+52>>2]=0;f[g+56>>2]=0;j=g+52|0;f[g+48>>2]=j;f[g+60>>2]=0;k=g+64|0;f[k>>2]=0;f[g+68>>2]=0;f[g+76>>2]=0;f[g+80>>2]=0;l=g+76|0;f[g+72>>2]=l;oBb(c,g);pBb(d,g);d=f[a>>2]|0;f[h>>2]=d;f[h+4>>2]=f[a+4>>2];if(d|0){a=d+4|0;f[a>>2]=(f[a>>2]|0)+1}gLa(g,h);fGa(h);CFa(g+72|0,f[l>>2]|0);l=g+60|0;h=f[l>>2]|0;if(h|0){a=f[k>>2]|0;if((a|0)==(h|0))m=h;else{d=a;while(1){a=d+-20|0;f[k>>2]=a;if((b[a+11>>0]|0)<0){YDc(f[a>>2]|0);n=f[k>>2]|0}else n=a;if((n|0)==(h|0))break;else d=n}m=f[l>>2]|0}YDc(m)}dLa(g+48|0,f[j>>2]|0);eLa(g+36|0,f[i>>2]|0);i=f[g+24>>2]|0;if(i|0){j=g+28|0;m=f[j>>2]|0;if((m|0)!=(i|0))f[j>>2]=m+(~((m+-4-i|0)>>>2)<<2);YDc(i)}i=g+12|0;m=f[i>>2]|0;if(!m){u=e;return}j=g+16|0;while(1){g=f[j>>2]|0;if((g|0)==(m|0))break;l=g+-76|0;f[j>>2]=l;fLa(l)}YDc(f[i>>2]|0);u=e;return}function cLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+96|0;e=d+8|0;g=d;tFa(a);f[e+40>>2]=0;f[e+44>>2]=0;h=e+40|0;i=e+36|0;j=e;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;f[e+52>>2]=0;f[e+56>>2]=0;i=e+52|0;f[e+48>>2]=i;f[e+60>>2]=0;j=e+64|0;f[j>>2]=0;f[e+68>>2]=0;f[e+76>>2]=0;f[e+80>>2]=0;k=e+76|0;f[e+72>>2]=k;oBb(c,e);c=f[a>>2]|0;f[g>>2]=c;f[g+4>>2]=f[a+4>>2];if(c|0){a=c+4|0;f[a>>2]=(f[a>>2]|0)+1}gLa(e,g);fGa(g);CFa(e+72|0,f[k>>2]|0);k=e+60|0;g=f[k>>2]|0;if(g|0){a=f[j>>2]|0;if((a|0)==(g|0))l=g;else{c=a;while(1){a=c+-20|0;f[j>>2]=a;if((b[a+11>>0]|0)<0){YDc(f[a>>2]|0);m=f[j>>2]|0}else m=a;if((m|0)==(g|0))break;else c=m}l=f[k>>2]|0}YDc(l)}dLa(e+48|0,f[i>>2]|0);eLa(e+36|0,f[h>>2]|0);h=f[e+24>>2]|0;if(h|0){i=e+28|0;l=f[i>>2]|0;if((l|0)!=(h|0))f[i>>2]=l+(~((l+-4-h|0)>>>2)<<2);YDc(h)}h=e+12|0;l=f[h>>2]|0;if(!l){u=d;return}i=e+16|0;while(1){e=f[i>>2]|0;if((e|0)==(l|0))break;k=e+-76|0;f[i>>2]=k;fLa(k)}YDc(f[h>>2]|0);u=d;return}function dLa(a,c){a=a|0;c=c|0;var d=0;if(!c)return;dLa(a,f[c>>2]|0);dLa(a,f[c+4>>2]|0);a=c+16|0;d=c+28|0;if((b[d+11>>0]|0)<0)YDc(f[d>>2]|0);if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function eLa(a,b){a=a|0;b=b|0;if(!b)return;else{eLa(a,f[b>>2]|0);eLa(a,f[b+4>>2]|0);dLa(b+20|0,f[b+24>>2]|0);YDc(b);return}}function fLa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;HFa(a+36|0);c=a+24|0;d=f[c>>2]|0;if(d|0){e=a+28|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;while(1){g=i+-12|0;f[e>>2]=g;if((b[g+11>>0]|0)<0){YDc(f[g>>2]|0);j=f[e>>2]|0}else j=g;if((j|0)==(d|0))break;else i=j}h=f[c>>2]|0}YDc(h)}h=a+12|0;if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);if((b[a+11>>0]|0)>=0)return;YDc(f[a>>2]|0);return}function gLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;d=u;u=u+208|0;e=d;g=d+192|0;h=d+172|0;i=d+160|0;j=d+72|0;k=d+64|0;l=d+56|0;m=d+16|0;n=d+4|0;o=d+148|0;p=a+12|0;q=a+16|0;r=(f[q>>2]|0)-(f[p>>2]|0)|0;s=(r|0)/76|0;t=a+72|0;v=a+76|0;CFa(t,f[v>>2]|0);f[a+80>>2]=0;f[t>>2]=v;f[v>>2]=0;v=a+60|0;w=f[v>>2]|0;x=a+64|0;y=f[x>>2]|0;if((y|0)==(w|0)){z=y;A=v;B=w}else{C=y;while(1){y=C+-20|0;f[x>>2]=y;if((b[y+11>>0]|0)<0){YDc(f[y>>2]|0);D=f[x>>2]|0}else D=y;if((D|0)==(w|0))break;else C=D}z=D;A=v;B=f[v>>2]|0}D=z;C=s+1|0;w=a+68|0;a=B;if((((f[w>>2]|0)-B|0)/20|0)>>>0<C>>>0){if(C>>>0>214748364){y=af(8)|0;bEc(y,503977);f[y>>2]=185532;ig(y|0,23696,1627)}y=VDc(C*20|0)|0;E=y+(((D-B|0)/20|0)*20|0)|0;B=E;F=y+(C*20|0)|0;if((z|0)==(a|0)){G=B;H=D;I=a}else{D=z;z=B;C=E;do{E=D;D=D+-20|0;fEc(C+-20|0,D);y=E+-8|0;E=f[y+4>>2]|0;J=C+-8|0;f[J>>2]=f[y>>2];f[J+4>>2]=E;C=z+-20|0;z=C}while((D|0)!=(a|0));G=z;H=f[A>>2]|0;I=f[x>>2]|0}f[A>>2]=G;f[x>>2]=B;f[w>>2]=F;F=H;if((I|0)!=(F|0)){B=I;do{B=B+-20|0;if((b[B+11>>0]|0)<0)YDc(f[B>>2]|0)}while((B|0)!=(F|0))}if(H|0)YDc(H)}f[g>>2]=0;H=g+4|0;f[H>>2]=0;f[g+8>>2]=0;F=VDc(8)|0;f[g>>2]=F;B=F+8|0;f[g+8>>2]=B;I=F;f[I>>2]=0;f[I+4>>2]=0;f[H>>2]=B;B=i+11|0;I=h+12|0;F=h+11|0;G=h+11|0;z=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[B>>0]=4;f[i>>2]=1635017060;b[i+4>>0]=0;fEc(h,i);f[I>>2]=0;f[h+16>>2]=0;a=f[x>>2]|0;D=f[w>>2]|0;C=D;if((a|0)==(D|0)){D=f[A>>2]|0;E=(a-D|0)/20|0;J=E+1|0;if(J>>>0>214748364)mCc(v);y=(C-D|0)/20|0;D=y<<1;C=y>>>0<107374182?(D>>>0<J>>>0?J:D):214748364;do if(C)if(C>>>0>214748364){D=af(8)|0;bEc(D,503977);f[D>>2]=185532;ig(D|0,23696,1627)}else{K=VDc(C*20|0)|0;break}else K=0;while(0);D=K+(E*20|0)|0;J=D;y=K+(C*20|0)|0;fEc(D,h);C=I;L=f[C+4>>2]|0;M=K+(E*20|0)+12|0;f[M>>2]=f[C>>2];f[M+4>>2]=L;L=D+20|0;M=f[v>>2]|0;C=f[x>>2]|0;if((C|0)==(M|0)){N=J;O=M;P=M}else{E=C;C=J;J=D;do{D=E;E=E+-20|0;fEc(J+-20|0,E);K=D+-8|0;D=f[K+4>>2]|0;Q=J+-8|0;f[Q>>2]=f[K>>2];f[Q+4>>2]=D;J=C+-20|0;C=J}while((E|0)!=(M|0));N=C;O=f[A>>2]|0;P=f[x>>2]|0}f[A>>2]=N;f[x>>2]=L;f[w>>2]=y;y=O;if((P|0)!=(y|0)){L=P;do{L=L+-20|0;if((b[L+11>>0]|0)<0)YDc(f[L>>2]|0)}while((L|0)!=(y|0))}if(O|0)YDc(O)}else{fEc(a,h);O=I;I=f[O+4>>2]|0;y=a+12|0;f[y>>2]=f[O>>2];f[y+4>>2]=I;f[x>>2]=(f[x>>2]|0)+20}if((b[F>>0]|0)<0)YDc(f[h>>2]|0);if((b[B>>0]|0)<0)YDc(f[i>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[G>>0]=4;f[h>>2]=1635017060;b[z>>0]=0;z=f[g>>2]|0;uT(z);G=tT(z,4)|0;z=f[h>>2]|0;b[G>>0]=z;b[G+1>>0]=z>>8;b[G+2>>0]=z>>16;b[G+3>>0]=z>>24;zHa(c,g);z=f[g>>2]|0;if(z|0){while(1){G=f[H>>2]|0;if((G|0)==(z|0))break;B=G+-8|0;f[H>>2]=B;uT(B)}YDc(f[g>>2]|0)}a:do if((r|0)>0){H=k+4|0;z=g+11|0;B=g+4|0;G=j+12|0;F=l+4|0;I=g+11|0;y=g+4|0;O=j+36|0;a=m+12|0;L=j+48|0;P=m+24|0;N=j+60|0;C=m+28|0;M=j+64|0;E=m+32|0;J=j+68|0;D=m+36|0;Q=j+72|0;K=j+24|0;R=j+28|0;S=n+11|0;T=n+4|0;U=o+11|0;V=g+11|0;W=g+4|0;X=h+11|0;Y=h+4|0;Z=h+12|0;_=h+16|0;$=h+11|0;aa=0;b:while(1){ba=f[p>>2]|0;if((((f[q>>2]|0)-ba|0)/76|0)>>>0<=aa>>>0){ca=53;break}hLa(j,ba+(aa*76|0)|0);fEc(g,j);f[k>>2]=0;f[H>>2]=0;ba=b[z>>0]|0;da=ba<<24>>24<0?f[B>>2]|0:ba&255;if(!da)ea=ba;else{ba=tT(k,da)|0;dJc(ba|0,((b[z>>0]|0)<0?f[g>>2]|0:g)|0,da|0)|0;ea=b[z>>0]|0}if(ea<<24>>24<0)YDc(f[g>>2]|0);fEc(g,G);f[l>>2]=0;f[F>>2]=0;da=b[I>>0]|0;ba=da<<24>>24<0?f[y>>2]|0:da&255;if(!ba)fa=da;else{da=tT(l,ba)|0;dJc(da|0,((b[I>>0]|0)<0?f[g>>2]|0:g)|0,ba|0)|0;fa=b[I>>0]|0}if(fa<<24>>24<0)YDc(f[g>>2]|0);LFa(m,O);MFa(a,L);ba=f[N>>2]|0;f[P>>2]=ba;f[C>>2]=f[M>>2];if(ba|0){da=ba+-4|0;f[da>>2]=(f[da>>2]|0)+1}da=f[J>>2]|0;f[E>>2]=da;f[D>>2]=f[Q>>2];if(da|0){ba=da+-4|0;f[ba>>2]=(f[ba>>2]|0)+1}ba=HHa(t,k)|0;da=f[ba>>2]|0;f[ba>>2]=da+1;if(da|0){f[e>>2]=da;F5(g,389582,e);n3(k,g)|0;uT(g)}da=gGa(c,k,l,m)|0;ba=f[R>>2]|0;ga=f[K>>2]|0;if((ba-ga|0)>0){ha=0;ia=ga;ga=ba;do{if(((ga-ia|0)/12|0)>>>0<=ha>>>0){ca=70;break b}fEc(n,ia+(ha*12|0)|0);fEc(o,j);ba=f[A>>2]|0;ja=(f[x>>2]|0)-ba|0;ka=ba;if((ja|0)<=0){ca=84;break b}ba=(ja>>>0)/20|0;ja=b[S>>0]|0;la=ja<<24>>24<0;ma=la?f[T>>2]|0:ja&255;ja=la?f[n>>2]|0:n;c:do if(ma){la=ba;d:while(1){na=la+-1|0;oa=ka+(na*20|0)|0;pa=b[oa+11>>0]|0;qa=pa<<24>>24<0;ra=pa&255;do if(((qa?f[ka+(na*20|0)+4>>2]|0:ra)|0)==(ma|0)){pa=f[oa>>2]|0;if(qa)if(!(Arc(pa,ja,ma)|0)){sa=na;break c}else break;if((pa&255)<<24>>24!=(b[ja>>0]|0))break;pa=oa;ta=ra;ua=ja;do{ta=ta+-1|0;pa=pa+1|0;if(!ta)break d;ua=ua+1|0}while((b[pa>>0]|0)==(b[ua>>0]|0))}while(0);if((la|0)>1)la=na;else{ca=84;break b}}if((la|0)<1){ca=84;break b}else sa=na}else{ra=ba;while(1){oa=ra;ra=ra+-1|0;qa=b[ka+(ra*20|0)+11>>0]|0;if(!((qa<<24>>24<0?f[ka+(ra*20|0)+4>>2]|0:qa&255)|0)){sa=ra;break c}if((oa|0)<=1){ca=84;break b}}}while(0);mGa(c,f[ka+(sa*20|0)+12>>2]|0,f[ka+(sa*20|0)+16>>2]|0,da,ha);if((b[U>>0]|0)<0)YDc(f[o>>2]|0);if((b[S>>0]|0)<0)YDc(f[n>>2]|0);ha=ha+1|0;ga=f[R>>2]|0;ia=f[K>>2]|0}while((ha|0)<((ga-ia|0)/12|0|0))}fEc(g,j);ia=f[A>>2]|0;ga=(f[x>>2]|0)-ia|0;ha=ia;e:do if((ga|0)>0){ia=(ga>>>0)/20|0;ba=b[V>>0]|0;ja=ba<<24>>24<0;ma=ja?f[W>>2]|0:ba&255;ba=ja?f[g>>2]|0:g;f:do if(!ma){ja=ia;while(1){ra=ja;ja=ja+-1|0;la=b[ha+(ja*20|0)+11>>0]|0;if(!((la<<24>>24<0?f[ha+(ja*20|0)+4>>2]|0:la&255)|0))break f;if((ra|0)<=1)break e}}else{ja=ia;while(1){ra=ja;ja=ja+-1|0;la=ha+(ja*20|0)|0;oa=b[la+11>>0]|0;qa=oa<<24>>24<0;ua=oa&255;do if(((qa?f[ha+(ja*20|0)+4>>2]|0:ua)|0)==(ma|0)){oa=f[la>>2]|0;if(qa)if(!(Arc(oa,ba,ma)|0))break f;else break;if((oa&255)<<24>>24!=(b[ba>>0]|0))break;oa=la;pa=ua;ta=ba;do{pa=pa+-1|0;oa=oa+1|0;if(!pa)break f;ta=ta+1|0}while((b[oa>>0]|0)==(b[ta>>0]|0))}while(0);if((ra|0)<=1)break e}}while(0);ba=f[K>>2]|0;if(((f[R>>2]|0)-ba|0)<=0){ca=119;break b}fEc(h,ba);ba=b[X>>0]|0;ma=ba<<24>>24<0;ia=ba&255;ba=ma?f[Y>>2]|0:ia;ka=b[V>>0]|0;ja=ka<<24>>24<0;g:do if((ba|0)==((ja?f[W>>2]|0:ka&255)|0)){ua=f[h>>2]|0;la=ma?ua:h;qa=ja?f[g>>2]|0:g;ta=(ba|0)==0;if(ma)if(!ta){oa=(Arc(la,qa,ba)|0)==0;YDc(ua);if(oa)break e;else{ca=119;break b}}else{YDc(ua);break e}if(ta)break e;if((ua&255)<<24>>24==(b[qa>>0]|0)){va=h;wa=ia;xa=qa}else{ca=110;break b}while(1){wa=wa+-1|0;va=va+1|0;if(!wa){ya=1;break g}xa=xa+1|0;if((b[va>>0]|0)!=(b[xa>>0]|0)){ya=0;break}}}else ya=0;while(0);if(ma){YDc(f[h>>2]|0);if(ya)break;else{ca=119;break b}}else if(ya)break;else{ca=119;break b}}while(0);fEc(h,g);f[Z>>2]=da;f[_>>2]=0;ha=f[x>>2]|0;ga=f[w>>2]|0;ia=ga;do if((ha|0)==(ga|0)){ba=f[A>>2]|0;ja=(ha-ba|0)/20|0;ka=ja+1|0;if(ka>>>0>214748364){ca=124;break b}qa=(ia-ba|0)/20|0;ba=qa<<1;ua=qa>>>0<107374182?(ba>>>0<ka>>>0?ka:ba):214748364;if(!ua)za=0;else{if(ua>>>0>214748364){ca=127;break b}za=VDc(ua*20|0)|0}ba=za+(ja*20|0)|0;ka=ba;qa=za+(ua*20|0)|0;fEc(ba,h);ua=Z;ta=f[ua+4>>2]|0;oa=za+(ja*20|0)+12|0;f[oa>>2]=f[ua>>2];f[oa+4>>2]=ta;ta=ba+20|0;oa=f[v>>2]|0;ua=f[x>>2]|0;if((ua|0)==(oa|0)){Aa=ka;Ba=oa;Ca=oa}else{ja=ua;ua=ka;ka=ba;do{ba=ja;ja=ja+-20|0;fEc(ka+-20|0,ja);la=ba+-8|0;ba=f[la+4>>2]|0;pa=ka+-8|0;f[pa>>2]=f[la>>2];f[pa+4>>2]=ba;ka=ua+-20|0;ua=ka}while((ja|0)!=(oa|0));Aa=ua;Ba=f[A>>2]|0;Ca=f[x>>2]|0}f[A>>2]=Aa;f[x>>2]=ta;f[w>>2]=qa;oa=Ba;if((Ca|0)!=(oa|0)){ja=Ca;do{ja=ja+-20|0;if((b[ja+11>>0]|0)<0)YDc(f[ja>>2]|0)}while((ja|0)!=(oa|0))}if(!Ba)break;YDc(Ba)}else{fEc(ha,h);oa=Z;ja=f[oa+4>>2]|0;qa=ha+12|0;f[qa>>2]=f[oa>>2];f[qa+4>>2]=ja;f[x>>2]=(f[x>>2]|0)+20}while(0);if((b[$>>0]|0)<0)YDc(f[h>>2]|0);if((b[V>>0]|0)<0)YDc(f[g>>2]|0);HFa(m);uT(l);uT(k);fLa(j);aa=aa+1|0;if((aa|0)>=(s|0))break a}if((ca|0)==53)nCc(p);else if((ca|0)==70)nCc(K);else if((ca|0)==84){VHa(i,390141,n);jIa(h,i,501908);f[g>>2]=0;f[g+4>>2]=0;aa=h+11|0;V=b[aa>>0]|0;$=V<<24>>24<0?f[h+4>>2]|0:V&255;if(!$)aLa(-204,g,390166,176);V=tT(g,$)|0;dJc(V|0,((b[aa>>0]|0)<0?f[h>>2]|0:h)|0,$|0)|0;aLa(-204,g,390166,176)}else if((ca|0)==110){f[h>>2]=0;Da=h+4|0;f[Da>>2]=0;Ea=tT(h,44)|0;Fa=Ea;Ga=390175;Ha=Fa+44|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));aLa(-5,h,390220,159)}else if((ca|0)==119){f[h>>2]=0;Da=h+4|0;f[Da>>2]=0;Ea=tT(h,44)|0;Fa=Ea;Ga=390175;Ha=Fa+44|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));aLa(-5,h,390220,159)}else if((ca|0)==124)mCc(v);else if((ca|0)==127){K=af(8)|0;bEc(K,503977);f[K>>2]=185532;ig(K|0,23696,1627)}}while(0);ca=f[v>>2]|0;v=f[x>>2]|0;if((v|0)==(ca|0)){u=d;return}else Ia=v;while(1){v=Ia+-20|0;f[x>>2]=v;if((b[v+11>>0]|0)<0){YDc(f[v>>2]|0);Ja=f[x>>2]|0}else Ja=v;if((Ja|0)==(ca|0))break;else Ia=Ja}u=d;return}function hLa(a,b){a=a|0;b=b|0;var c=0,d=0;fEc(a,b);fEc(a+12|0,b+12|0);z6(a+24|0,b+24|0);LFa(a+36|0,b+36|0);MFa(a+48|0,b+48|0);c=f[b+60>>2]|0;f[a+60>>2]=c;f[a+64>>2]=f[b+64>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[b+68>>2]|0;f[a+68>>2]=d;f[a+72>>2]=f[b+72>>2];if(!d)return;b=d+-4|0;f[b>>2]=(f[b>>2]|0)+1;return}function iLa(a){a=a|0;var b=0;f[a>>2]=78612;b=a+108|0;f[b>>2]=78632;BIa(a+8|0);Ctc(a,78644);Lsc(b);return}function jLa(a){a=a|0;var b=0;f[a>>2]=78612;b=a+108|0;f[b>>2]=78632;BIa(a+8|0);Ctc(a,78644);Lsc(b);YDc(a);return}function kLa(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[b>>2]=78612;a=b+108|0;f[a>>2]=78632;BIa(b+8|0);Ctc(b,78644);Lsc(a);return}function lLa(a){a=a|0;jLa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function mLa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+240|0;h=g+208|0;i=g+120|0;j=g+88|0;k=g;fuc(h);f[h>>2]=78664;f[h+8>>2]=b;f[h+12>>2]=b;f[h+16>>2]=b+c;f[i>>2]=182096;f[i+8>>2]=182116;f[i+4>>2]=0;c=f[45521]|0;b=i+c|0;auc(b,h);f[b+72>>2]=0;f[b+76>>2]=-1;if(!e){cLa(a,i);ytc(i);Qsc(h);u=g;return}else{fuc(j);f[j>>2]=78664;f[j+8>>2]=d;f[j+12>>2]=d;f[j+16>>2]=d+e;f[k>>2]=182096;f[k+8>>2]=182116;f[k+4>>2]=0;e=k+c|0;auc(e,j);f[e+72>>2]=0;f[e+76>>2]=-1;bLa(a,i,k);ytc(k);Qsc(j);ytc(i);Qsc(h);u=g;return}}function nLa(a){a=a|0;Qsc(a);return}function oLa(a){a=a|0;Qsc(a);YDc(a);return}function pLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[b>>2]|0;e=f[c>>2]|0;g=f[c+4>>2]|0;mLa(a,d,(f[b+4>>2]|0)-d|0,(e|0)==(g|0)?0:e,g-e|0);return}function qLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+240|0;g=e+8|0;h=e;i=f[c>>2]|0;c=f[d>>2]|0;d=(c|0)==0?1154740:c;ffb(g);c=g+104|0;ffb(c);f[g+208>>2]=0;j=g+212|0;f[j>>2]=0;f[g+216>>2]=0;f[g+224>>2]=0;f[g+228>>2]=0;k=g+224|0;f[g+220>>2]=k;nMa((i|0)==0?1154740:i,g);if(b[d>>0]|0)pMa(d,c);tFa(a);d=f[a>>2]|0;f[h>>2]=d;f[h+4>>2]=f[a+4>>2];if(d|0){a=d+4|0;f[a>>2]=(f[a>>2]|0)+1}rLa(g,h);fGa(h);CFa(g+220|0,f[k>>2]|0);k=g+208|0;h=f[k>>2]|0;if(!h){lfb(c);lfb(g);u=e;return}a=f[j>>2]|0;if((a|0)==(h|0))l=h;else{d=a;while(1){a=d+-20|0;f[j>>2]=a;if((b[a+11>>0]|0)<0){YDc(f[a>>2]|0);m=f[j>>2]|0}else m=a;if((m|0)==(h|0))break;else d=m}l=f[k>>2]|0}YDc(l);lfb(c);lfb(g);u=e;return}function rLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0;d=u;u=u+304|0;e=d+280|0;g=d+240|0;h=d+184|0;i=d+112|0;j=d+96|0;k=d;l=d+80|0;m=d+72|0;o=d+64|0;q=d+24|0;r=d+176|0;s=d+168|0;t=d+16|0;v=f[a+80>>2]|0;w=a+220|0;x=a+224|0;CFa(w,f[x>>2]|0);f[a+228>>2]=0;f[w>>2]=x;f[x>>2]=0;x=a+208|0;y=f[x>>2]|0;z=a+212|0;A=f[z>>2]|0;if((A|0)==(y|0)){B=A;C=x;D=y}else{E=A;while(1){A=E+-20|0;f[z>>2]=A;if((b[A+11>>0]|0)<0){YDc(f[A>>2]|0);F=f[z>>2]|0}else F=A;if((F|0)==(y|0))break;else E=F}B=F;C=x;D=f[x>>2]|0}F=B;E=v+1|0;y=a+216|0;A=D;if((((f[y>>2]|0)-D|0)/20|0)>>>0<E>>>0){if(E>>>0>214748364){G=af(8)|0;bEc(G,503977);f[G>>2]=185532;ig(G|0,23696,1627)}G=VDc(E*20|0)|0;H=G+(((F-D|0)/20|0)*20|0)|0;D=H;I=G+(E*20|0)|0;if((B|0)==(A|0)){K=D;L=F;M=A}else{F=B;B=D;E=H;do{H=F;F=F+-20|0;fEc(E+-20|0,F);G=H+-8|0;H=f[G+4>>2]|0;N=E+-8|0;f[N>>2]=f[G>>2];f[N+4>>2]=H;E=B+-20|0;B=E}while((F|0)!=(A|0));K=B;L=f[C>>2]|0;M=f[z>>2]|0}f[C>>2]=K;f[z>>2]=D;f[y>>2]=I;I=L;if((M|0)!=(I|0)){D=M;do{D=D+-20|0;if((b[D+11>>0]|0)<0)YDc(f[D>>2]|0)}while((D|0)!=(I|0))}if(L|0)YDc(L)}L=a+36|0;GHa(l,f[L>>2]|0);a:do if((f[L>>2]|0)>0){I=a+44|0;D=e+12|0;M=e+16|0;K=e+11|0;B=0;while(1){fEc(e,f[(f[I>>2]|0)+4+(B<<2)>>2]|0);f[D>>2]=0;f[M>>2]=B;A=f[z>>2]|0;F=f[y>>2]|0;E=F;if((A|0)==(F|0)){F=f[C>>2]|0;H=(A-F|0)/20|0;N=H+1|0;if(N>>>0>214748364){O=26;break}G=(E-F|0)/20|0;F=G<<1;E=G>>>0<107374182?(F>>>0<N>>>0?N:F):214748364;if(!E)P=0;else{if(E>>>0>214748364){O=29;break}P=VDc(E*20|0)|0}F=P+(H*20|0)|0;N=F;G=P+(E*20|0)|0;fEc(F,e);E=D;Q=f[E+4>>2]|0;R=P+(H*20|0)+12|0;f[R>>2]=f[E>>2];f[R+4>>2]=Q;Q=F+20|0;R=f[x>>2]|0;E=f[z>>2]|0;if((E|0)==(R|0)){S=N;T=R;U=R}else{H=E;E=N;N=F;do{F=H;H=H+-20|0;fEc(N+-20|0,H);V=F+-8|0;F=f[V+4>>2]|0;W=N+-8|0;f[W>>2]=f[V>>2];f[W+4>>2]=F;N=E+-20|0;E=N}while((H|0)!=(R|0));S=E;T=f[C>>2]|0;U=f[z>>2]|0}f[C>>2]=S;f[z>>2]=Q;f[y>>2]=G;R=T;if((U|0)!=(R|0)){H=U;do{H=H+-20|0;if((b[H+11>>0]|0)<0)YDc(f[H>>2]|0)}while((H|0)!=(R|0))}if(T|0)YDc(T)}else{fEc(A,e);R=D;H=f[R+4>>2]|0;G=A+12|0;f[G>>2]=f[R>>2];f[G+4>>2]=H;f[z>>2]=(f[z>>2]|0)+20}if((b[K>>0]|0)<0)YDc(f[e>>2]|0);H=f[(f[I>>2]|0)+4+(B<<2)>>2]|0;G=(f[l>>2]|0)+(B<<3)|0;uT(G);R=H+11|0;Q=b[R>>0]|0;E=Q<<24>>24<0?f[H+4>>2]|0:Q&255;if(E|0){Q=tT(G,E)|0;dJc(Q|0,((b[R>>0]|0)<0?f[H>>2]|0:H)|0,E|0)|0}B=B+1|0;if((B|0)>=(f[L>>2]|0))break a}if((O|0)==26)mCc(x);else if((O|0)==29){B=af(8)|0;bEc(B,503977);f[B>>2]=185532;ig(B|0,23696,1627)}}while(0);b:do if((v|0)>0){L=a+88|0;T=m+4|0;U=o+4|0;y=q+4|0;S=q+8|0;C=q+4|0;P=q+12|0;B=a+184|0;I=a+192|0;K=q+12|0;D=g+4|0;M=g+8|0;E=g+8|0;H=e+11|0;R=e+4|0;Q=j+8|0;G=j+12|0;N=j+4|0;F=k+8|0;W=k+4|0;V=i+36|0;X=i+16|0;Z=i+4|0;_=i+40|0;$=i+44|0;aa=i+48|0;ba=e+8|0;ca=e+4|0;da=h+36|0;ea=h+16|0;fa=h+4|0;ga=h+40|0;ha=h+44|0;ia=h+48|0;ja=l+4|0;ka=g+4|0;la=l+8|0;ma=g+4|0;na=g+4|0;oa=g+8|0;pa=g+4|0;qa=g+12|0;ra=h+4|0;sa=j+4|0;ta=r+4|0;ua=h+11|0;va=j+4|0;wa=h+4|0;xa=j+4|0;ya=k+4|0;za=j+8|0;Aa=j+12|0;Ba=j+4|0;Ca=j+8|0;Da=j+12|0;Ea=j+4|0;Fa=k+4|0;Ga=s+4|0;Ha=t+4|0;Ia=j+11|0;Ja=j+4|0;Ka=j+8|0;La=h+8|0;Ma=h+4|0;Na=g+4|0;Oa=i+4|0;Pa=0;c:while(1){Qa=f[(f[L>>2]|0)+4+(Pa<<2)>>2]|0;Ra=Qa+136|0;Sa=f[Ra>>2]|0;f[m>>2]=0;f[T>>2]=0;Ta=Sa+11|0;Ua=b[Ta>>0]|0;Va=Ua<<24>>24<0?f[Sa+4>>2]|0:Ua&255;if(Va|0){Ua=tT(m,Va)|0;dJc(Ua|0,((b[Ta>>0]|0)<0?f[Sa>>2]|0:Sa)|0,Va|0)|0}Va=f[Qa+140>>2]|0;f[o>>2]=0;f[U>>2]=0;Sa=Va+11|0;Ta=b[Sa>>0]|0;Ua=Ta<<24>>24<0?f[Va+4>>2]|0:Ta&255;if(Ua|0){Ta=tT(o,Ua)|0;dJc(Ta|0,((b[Sa>>0]|0)<0?f[Va>>2]|0:Va)|0,Ua|0)|0}f[y>>2]=0;f[S>>2]=0;f[q>>2]=C;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;f[P+24>>2]=0;sLa(Qa,q,0);Ua=f[Ra>>2]|0;Ra=f[B>>2]|0;d:do if(Ra){Va=f[I>>2]|0;Sa=b[Ua+11>>0]|0;Ta=Sa<<24>>24<0;Wa=Ta?f[Ua+4>>2]|0:Sa&255;Sa=(Wa|0)==0;if(Ta){if(Sa){Ta=0;while(1){Xa=f[Va+4+(Ta<<2)>>2]|0;Ya=f[Xa+136>>2]|0;Za=b[Ya+11>>0]|0;if(((Za<<24>>24<0?f[Ya+4>>2]|0:Za&255)|0)==0?f[Xa+80>>2]|0:0){_a=Ta;O=79;break d}Ta=Ta+1|0;if((Ta|0)==(Ra|0))break d}}else $a=0;do{Ta=f[Va+4+($a<<2)>>2]|0;Xa=f[Ta+136>>2]|0;Za=b[Xa+11>>0]|0;Ya=Za<<24>>24<0;ab=Za&255;e:do if(((Ya?f[Xa+4>>2]|0:ab)|0)==(Wa|0)){Za=f[Xa>>2]|0;bb=f[Ua>>2]|0;f:do if(Ya){if(Arc(Za,bb,Wa)|0)break e}else{if((Za&255)<<24>>24!=(b[bb>>0]|0))break e;cb=Xa;db=ab;eb=bb;while(1){db=db+-1|0;cb=cb+1|0;if(!db)break f;eb=eb+1|0;if((b[cb>>0]|0)!=(b[eb>>0]|0))break e}}while(0);if(f[Ta+80>>2]|0){_a=$a;O=79;break d}}while(0);$a=$a+1|0}while(($a|0)!=(Ra|0))}else{if(Sa){Ta=0;while(1){ab=f[Va+4+(Ta<<2)>>2]|0;Xa=f[ab+136>>2]|0;Ya=b[Xa+11>>0]|0;if(((Ya<<24>>24<0?f[Xa+4>>2]|0:Ya&255)|0)==0?f[ab+80>>2]|0:0){_a=Ta;O=79;break d}Ta=Ta+1|0;if((Ta|0)==(Ra|0))break d}}else fb=0;do{Ta=f[Va+4+(fb<<2)>>2]|0;Sa=f[Ta+136>>2]|0;ab=b[Sa+11>>0]|0;Ya=ab<<24>>24<0;Xa=ab&255;g:do if(((Ya?f[Sa+4>>2]|0:Xa)|0)==(Wa|0)){ab=f[Sa>>2]|0;h:do if(Ya){if(Arc(ab,Ua,Wa)|0)break g}else{if((ab&255)<<24>>24!=(b[Ua>>0]|0))break g;bb=Sa;Za=Xa;eb=Ua;while(1){Za=Za+-1|0;bb=bb+1|0;if(!Za)break h;eb=eb+1|0;if((b[bb>>0]|0)!=(b[eb>>0]|0))break g}}while(0);if(f[Ta+80>>2]|0){_a=fb;O=79;break d}}while(0);fb=fb+1|0}while((fb|0)!=(Ra|0))}}else{_a=0;O=79}while(0);i:do if((O|0)==79?(O=0,(_a|0)!=(Ra|0)):0){Ua=f[(f[I>>2]|0)+4+(_a<<2)>>2]|0;A=Ua+80|0;Wa=f[A>>2]|0;g$(K,Wa);Va=(Wa|0)>0;Ta=Ua+88|0;if(Va){Ua=0;do{Xa=f[(f[Ta>>2]|0)+4+(Ua<<2)>>2]|0;Sa=f[K>>2]|0;Ya=Sa+(Ua*56|0)|0;f[g>>2]=0;f[D>>2]=0;f[M>>2]=0;ab=f[Xa+8>>2]|0;j:do if(!(ab&60)){if(!(ab&2)){f[e>>2]=1;Zv(g,1,e);break}eb=f[Xa+84>>2]|0;bb=eb|0?eb:521128;eb=bb+16|0;if((f[eb>>2]|0)>0){Za=bb+24|0;bb=0;cb=0;db=0;while(1){gb=f[(f[Za>>2]|0)+8+(bb<<3)>>2]|0;f[e>>2]=gb;if((cb|0)==(db|0))g6(g,e);else{f[cb>>2]=gb;f[D>>2]=cb+4}gb=bb+1|0;if((gb|0)>=(f[eb>>2]|0))break j;bb=gb;cb=f[D>>2]|0;db=f[E>>2]|0}}}else{f[e>>2]=f[Xa+88>>2];g6(g,e);db=f[D>>2]|0;cb=f[E>>2]|0;bb=f[Xa+92>>2]|0;f[e>>2]=bb;if((db|0)==(cb|0)){g6(g,e);hb=f[D>>2]|0;ib=f[E>>2]|0}else{f[db>>2]=bb;bb=db+4|0;f[D>>2]=bb;hb=bb;ib=cb}cb=f[Xa+96>>2]|0;f[e>>2]=cb;if((hb|0)==(ib|0)){g6(g,e);jb=f[D>>2]|0;kb=f[E>>2]|0}else{f[hb>>2]=cb;cb=hb+4|0;f[D>>2]=cb;jb=cb;kb=ib}cb=f[Xa+100>>2]|0;f[e>>2]=cb;if((jb|0)==(kb|0))g6(g,e);else{f[jb>>2]=cb;f[D>>2]=jb+4}}while(0);ab=f[g>>2]|0;XS(Ya,(f[D>>2]|0)-ab>>2,ab,5);ab=f[Xa+16>>2]|0;do if(!ab){if((f[Xa+104>>2]|0)!=2){O=125;break c}fEc(e,f[Xa+80>>2]|0);cb=b[H>>0]|0;bb=cb<<24>>24<0;db=bb?f[R>>2]|0:cb&255;cb=f[Sa+(Ua*56|0)+4>>2]|0;if((cb|0)<3)lb=Y(f[Sa+(Ua*56|0)+12>>2]|0,f[Sa+(Ua*56|0)+8>>2]|0)|0;else{eb=f[Sa+(Ua*56|0)+40>>2]|0;Za=0;gb=1;while(1){mb=Y(f[eb+(Za<<2)>>2]|0,gb)|0;Za=Za+1|0;if((Za|0)==(cb|0)){lb=mb;break}else gb=mb}}if((db>>>1|0)!=(lb|0)){O=131;break c}gb=f[g>>2]|0;dT(i,(f[D>>2]|0)-gb>>2,gb,3,bb?f[e>>2]|0:e,0);f[Q>>2]=0;f[G>>2]=0;f[j>>2]=16842752;f[N>>2]=i;gb=F;f[gb>>2]=0;f[gb+4>>2]=0;f[k>>2]=33619968;f[W>>2]=Ya;NZ(j,k);gb=f[V>>2]|0;do if(gb|0){cb=gb+12|0;Za=f[cb>>2]|0;f[cb>>2]=Za+-1;if((Za|0)!=1)break;_S(i)}while(0);f[V>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){gb=f[_>>2]|0;bb=0;do{f[gb+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[Z>>2]|0))}bb=f[$>>2]|0;if((bb|0)!=(aa|0))g0(bb);if((b[H>>0]|0)<0)YDc(f[e>>2]|0)}else{bb=f[Sa+(Ua*56|0)+4>>2]|0;if((bb|0)<3)nb=Y(f[Sa+(Ua*56|0)+12>>2]|0,f[Sa+(Ua*56|0)+8>>2]|0)|0;else{gb=f[Sa+(Ua*56|0)+40>>2]|0;db=0;Za=1;while(1){cb=Y(f[gb+(db<<2)>>2]|0,Za)|0;db=db+1|0;if((db|0)==(bb|0)){nb=cb;break}else Za=cb}}if((ab|0)!=(nb|0)){O=115;break c}Za=f[Xa+24>>2]|0;dT(h,bb,f[Sa+(Ua*56|0)+40>>2]|0,5,(Za|0)==0?0:Za+4|0,0);Za=ba;f[Za>>2]=0;f[Za+4>>2]=0;f[e>>2]=33619968;f[ca>>2]=Ya;h_(h,e);Za=f[da>>2]|0;do if(Za|0){db=Za+12|0;gb=f[db>>2]|0;f[db>>2]=gb+-1;if((gb|0)!=1)break;_S(h)}while(0);f[da>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[fa>>2]|0)>0){Za=f[ga>>2]|0;bb=0;do{f[Za+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[fa>>2]|0))}bb=f[ha>>2]|0;if((bb|0)==(ia|0))break;g0(bb)}while(0);Ya=f[g>>2]|0;if(Ya|0){Sa=f[D>>2]|0;if((Sa|0)!=(Ya|0))f[D>>2]=Sa+(~((Sa+-4-Ya|0)>>>2)<<2);YDc(Ya)}Ua=Ua+1|0}while((Ua|0)<(Wa|0))}Ua=f[A>>2]|0;if((Ua|0)>0){Ya=f[Ta>>2]|0;Sa=0;do{Xa=f[Ya+4+(Sa<<2)>>2]|0;Sa=Sa+1|0;Yi[f[(f[Xa>>2]|0)+28>>2]&2047](Xa)}while((Sa|0)!=(Ua|0));f[A>>2]=0;ob=0}else ob=Ua;Sa=f[Ta>>2]|0;if(!Sa)pb=0;else pb=(f[Sa>>2]|0)-ob|0;if((Wa|0)!=(pb|0)){O=148;break c}if(Va){Ya=0;Xa=Sa;while(1){Sa=(f[Xa>>2]|0)+-1|0;f[Xa>>2]=Sa;ab=f[Xa+4+(Sa<<2)>>2]|0;if(ab|0)Yi[f[(f[ab>>2]|0)+4>>2]&2047](ab);ab=Ya+1|0;if((ab|0)==(Wa|0))break i;Ya=ab;Xa=f[Ta>>2]|0}}}while(0);Ra=HHa(w,m)|0;Ta=f[Ra>>2]|0;f[Ra>>2]=Ta+1;f[e>>2]=Ta;if(Ta|0){f[h>>2]=0;f[Ma>>2]=0;Ta=tT(h,1)|0;b[Ta>>0]=95;tLa(i,e);f[g>>2]=0;f[Na>>2]=0;tT(g,(f[Oa>>2]|0)+(f[Ma>>2]|0)|0)|0;Ta=f[Ma>>2]|0;if(Ta|0)dJc(f[g>>2]|0,f[h>>2]|0,Ta|0)|0;Ta=f[Oa>>2]|0;if(Ta|0)dJc((f[g>>2]|0)+(f[Ma>>2]|0)|0,f[i>>2]|0,Ta|0)|0;n3(m,g)|0;uT(g);uT(i);uT(h)}Ta=f[o>>2]|0;k:do if((Ta|0)!=390055?(Ra=(Ta|0)==0?1154740:Ta,(Ioc(Ra,390055)|0)!=0):0){do if((Ta|0)!=454964?(Ioc(Ra,454964)|0)!=0:0){if((Ta|0)!=390120?Ioc(Ra,390120)|0:0)break;uT(o);qb=tT(o,11)|0;rb=455045;sb=qb+11|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0))}else O=173;while(0);do if((O|0)==173){O=0;f[g>>2]=0;f[ma>>2]=0;qb=tT(g,16)|0;rb=449544;sb=qb+16|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));Ra=f[C>>2]|0;if(!Ra){uT(g);break}Xa=f[g>>2]|0;Ya=(Xa|0)==0?1154740:Xa;Wa=C;Va=Ra;l:while(1){Ra=Va;while(1){Ua=f[Ra+16>>2]|0;if((Ua|0)==(Xa|0))break;if((Ioc((Ua|0)==0?1154740:Ua,Ya)|0)>=0)break;Ua=f[Ra+4>>2]|0;if(!Ua){tb=Wa;break l}else Ra=Ua}Va=f[Ra>>2]|0;if(!Va){tb=Ra;break}else Wa=Ra}if((tb|0)==(C|0)){uT(g);break}Wa=f[tb+16>>2]|0;if((Xa|0)!=(Wa|0)?(Ioc(Ya,(Wa|0)==0?1154740:Wa)|0)<=-1:0){uT(g);break}Wa=DHa(tb+24|0,-1)|0;Va=(Wa|0)!=0|(J|0)!=0;uT(g);if(!Va){Va=Qa+20|0;if((f[Va>>2]|0)!=1){O=185;break c}if((f[Qa+36>>2]|0)!=1){O=187;break c}f[na>>2]=0;f[oa>>2]=0;f[g>>2]=pa;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;f[qa+16>>2]=0;f[qa+20>>2]=0;f[qa+24>>2]=0;f[h>>2]=0;f[ra>>2]=0;Wa=tT(h,3)|0;b[Wa>>0]=b[454985]|0;b[Wa+1>>0]=b[454986]|0;b[Wa+2>>0]=b[454987]|0;f[j>>2]=0;f[sa>>2]=0;Wa=tT(j,3)|0;b[Wa>>0]=b[454985]|0;b[Wa+1>>0]=b[454986]|0;b[Wa+2>>0]=b[454987]|0;Wa=f[C>>2]|0;do if(!Wa)ub=9.999999747378752e-06;else{Ua=f[j>>2]|0;A=(Ua|0)==0?1154740:Ua;ab=C;Sa=Wa;m:while(1){bb=Sa;while(1){Za=f[bb+16>>2]|0;if((Za|0)==(Ua|0))break;if((Ioc((Za|0)==0?1154740:Za,A)|0)>=0)break;Za=f[bb+4>>2]|0;if(!Za){vb=ab;break m}else bb=Za}Sa=f[bb>>2]|0;if(!Sa){vb=bb;break}else ab=bb}if((vb|0)==(C|0)){ub=9.999999747378752e-06;break}ab=f[vb+16>>2]|0;if((Ua|0)!=(ab|0)?(Ioc(A,(ab|0)==0?1154740:ab)|0)<=-1:0){ub=9.999999747378752e-06;break}ub=+tIa(vb+24|0,-1)}while(0);n[i>>2]=ub;eIa(g,h,i)|0;uT(j);uT(h);f[r>>2]=0;f[ta>>2]=0;tT(r,(f[T>>2]|0)+4|0)|0;Wa=f[T>>2]|0;if(!Wa)wb=0;else{dJc(f[r>>2]|0,f[m>>2]|0,Wa|0)|0;wb=f[T>>2]|0}Wa=(f[r>>2]|0)+wb|0;b[Wa>>0]=47;b[Wa+1>>0]=109;b[Wa+2>>0]=118;b[Wa+3>>0]=110;Wa=f[r>>2]|0;Ya=f[ta>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(Ya>>>0>4294967279){O=202;break c}if(Ya>>>0<11){b[ua>>0]=Ya;if(!Ya)xb=h;else{yb=h;O=206}}else{Xa=Ya+16&-16;ab=VDc(Xa)|0;f[h>>2]=ab;f[La>>2]=Xa|-2147483648;f[wa>>2]=Ya;yb=ab;O=206}if((O|0)==206){O=0;dJc(yb|0,Wa|0,Ya|0)|0;xb=yb}b[xb+Ya>>0]=0;uT(r);f[j>>2]=0;f[va>>2]=0;Ya=b[ua>>0]|0;Wa=Ya<<24>>24<0?f[wa>>2]|0:Ya&255;if(Wa|0){Ya=tT(j,Wa)|0;dJc(Ya|0,((b[ua>>0]|0)<0?f[h>>2]|0:h)|0,Wa|0)|0}Wa=HHa(w,j)|0;Ya=f[Wa>>2]|0;f[Wa>>2]=Ya+1;uT(j);f[i>>2]=Ya;if(Ya|0){f[k>>2]=0;f[Fa>>2]=0;Ya=tT(k,1)|0;b[Ya>>0]=95;tLa(t,i);f[s>>2]=0;f[Ga>>2]=0;tT(s,(f[Ha>>2]|0)+(f[Fa>>2]|0)|0)|0;Ya=f[Fa>>2]|0;if(Ya|0)dJc(f[s>>2]|0,f[k>>2]|0,Ya|0)|0;Ya=f[Ha>>2]|0;if(Ya|0)dJc((f[s>>2]|0)+(f[Fa>>2]|0)|0,f[t>>2]|0,Ya|0)|0;Ya=f[s>>2]|0;Wa=f[Ga>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(Wa>>>0>4294967279){O=215;break c}if(Wa>>>0<11){b[Ia>>0]=Wa;if(!Wa)zb=j;else{Ab=j;O=219}}else{ab=Wa+16&-16;Xa=VDc(ab)|0;f[j>>2]=Xa;f[Ka>>2]=ab|-2147483648;f[Ja>>2]=Wa;Ab=Xa;O=219}if((O|0)==219){O=0;dJc(Ab|0,Ya|0,Wa|0)|0;zb=Ab}b[zb+Wa>>0]=0;Wa=b[Ia>>0]|0;Ya=Wa<<24>>24<0;tEc(h,Ya?f[j>>2]|0:j,Ya?f[Ja>>2]|0:Wa&255)|0;if((b[Ia>>0]|0)<0)YDc(f[j>>2]|0);uT(s);uT(t);uT(k)}f[j>>2]=0;f[xa>>2]=0;Wa=b[ua>>0]|0;Ya=Wa<<24>>24<0?f[wa>>2]|0:Wa&255;if(Ya|0){Wa=tT(j,Ya)|0;dJc(Wa|0,((b[ua>>0]|0)<0?f[h>>2]|0:h)|0,Ya|0)|0}f[k>>2]=0;f[ya>>2]=0;Ya=tT(k,3)|0;b[Ya>>0]=b[425625]|0;b[Ya+1>>0]=b[425626]|0;b[Ya+2>>0]=b[425627]|0;Ya=gGa(c,j,k,g)|0;uT(k);uT(j);Wa=Qa+28|0;vLa(a,f[(f[Wa>>2]|0)+4>>2]|0,Ya,0,c);Xa=Qa+44|0;uLa(a,f[Va>>2]|0,f[Wa>>2]|0,f[Xa>>2]|0,Ya,0);iEc(f[(f[(f[(f[L>>2]|0)+4+(Pa<<2)>>2]|0)+28>>2]|0)+4>>2]|0,f[(f[Xa>>2]|0)+4>>2]|0)|0;Xa=f[P>>2]|0;p[k>>3]=0.0;f[j>>2]=-1056833530;f[Ba>>2]=k;f[za>>2]=1;f[Aa>>2]=1;l_(Xa,j,e0()|0)|0;Xa=f[P>>2]|0;p[k>>3]=1.0;f[j>>2]=-1056833530;f[Ea>>2]=k;f[Ca>>2]=1;f[Da>>2]=1;l_(Xa+56|0,j,e0()|0)|0;if((b[ua>>0]|0)<0)YDc(f[h>>2]|0);HFa(g)}}while(0);Xa=gGa(c,m,o,q)|0;Ya=Qa+20|0;Wa=f[Ya>>2]|0;if((Wa|0)>0){ab=Qa+28|0;Sa=0;do{vLa(a,f[(f[ab>>2]|0)+4+(Sa<<2)>>2]|0,Xa,Sa,c);Sa=Sa+1|0;Ra=f[Ya>>2]|0}while((Sa|0)<(Ra|0));Bb=Ra}else Bb=Wa;Sa=Qa+36|0;if((f[Sa>>2]|0)>0){ab=Qa+28|0;Ra=Qa+44|0;Za=0;gb=Bb;while(1){uLa(a,gb,f[ab>>2]|0,f[Ra>>2]|0,Xa,Za);db=Za+1|0;if((db|0)>=(f[Sa>>2]|0))break k;Za=db;gb=f[Ya>>2]|0}}}else O=161;while(0);if((O|0)==161?(O=0,Ta=Qa+36|0,(f[Ta>>2]|0)>0):0){Ya=Qa+20|0;gb=Qa+28|0;Za=Qa+44|0;Sa=0;do{uLa(a,f[Ya>>2]|0,f[gb>>2]|0,f[Za>>2]|0,0,Sa);Xa=f[ja>>2]|0;Ra=f[z>>2]|0;f[Ra+-4>>2]=Xa-(f[l>>2]|0)>>3;ab=Ra+-20|0;f[g>>2]=0;f[ka>>2]=0;Wa=ab+11|0;db=b[Wa>>0]|0;cb=db<<24>>24<0?f[Ra+-16>>2]|0:db&255;if(!cb)Cb=Xa;else{Xa=tT(g,cb)|0;dJc(Xa|0,((b[Wa>>0]|0)<0?f[ab>>2]|0:ab)|0,cb|0)|0;Cb=f[ja>>2]|0}if((Cb|0)==(f[la>>2]|0))L_(l,g);else{cb=f[g>>2]|0;f[Cb>>2]=cb;f[Cb+4>>2]=f[ka>>2];if(!cb)Db=Cb;else{ab=cb+-4|0;f[ab>>2]=(f[ab>>2]|0)+1;Db=f[ja>>2]|0}f[ja>>2]=Db+8}uT(g);Sa=Sa+1|0}while((Sa|0)<(f[Ta>>2]|0))}HFa(q);uT(o);uT(m);Pa=Pa+1|0;if((Pa|0)>=(v|0))break b}if((O|0)==115){f[e>>2]=0;f[e+4>>2]=0;qb=tT(e,42)|0;rb=389765;sb=qb+42|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));z5(-215,e,389808,389822,256)}else if((O|0)==125){f[e>>2]=0;f[e+4>>2]=0;qb=tT(e,40)|0;rb=389900;sb=qb+40|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));z5(-215,e,389808,389822,264)}else if((O|0)==131){f[i>>2]=0;f[i+4>>2]=0;qb=tT(i,43)|0;rb=389941;sb=qb+43|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));z5(-215,i,389808,389822,267)}else if((O|0)==148){f[e>>2]=0;f[e+4>>2]=0;qb=tT(e,44)|0;rb=389985;sb=qb+44|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));z5(-215,e,390030,389822,298)}else if((O|0)==185){f[g>>2]=0;f[g+4>>2]=0;qb=tT(g,24)|0;rb=390061;sb=qb+24|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));z5(-215,g,390086,389822,364)}else if((O|0)==187){f[g>>2]=0;f[g+4>>2]=0;qb=tT(g,21)|0;rb=390098;sb=qb+21|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));z5(-215,g,390086,389822,364)}else if((O|0)==202)dEc(h);else if((O|0)==215)dEc(j)}while(0);zHa(c,l);c=f[x>>2]|0;x=f[z>>2]|0;if((x|0)!=(c|0)){j=x;while(1){x=j+-20|0;f[z>>2]=x;if((b[x+11>>0]|0)<0){YDc(f[x>>2]|0);Eb=f[z>>2]|0}else Eb=x;if((Eb|0)==(c|0))break;else j=Eb}}Eb=f[l>>2]|0;if(!Eb){u=d;return}j=l+4|0;while(1){c=f[j>>2]|0;if((c|0)==(Eb|0))break;z=c+-8|0;f[j>>2]=z;uT(z)}YDc(f[l>>2]|0);u=d;return}function sLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;e=u;u=u+64|0;g=e+40|0;i=e;j=e+32|0;k=e+24|0;l=e+16|0;m=e+12|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);o=f[g>>2]|0;q=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;r=o+52|0;if((f[r>>2]|0)<=0){u=e;return}s=o+20|0;o=g+4|0;t=i+4|0;v=g+4|0;w=g+4|0;y=i+4|0;z=g+4|0;A=g+4|0;B=i+4|0;C=g+4|0;D=g+4|0;E=i+4|0;F=g+4|0;G=g+4|0;H=i+4|0;I=g+4|0;J=g+4|0;K=i+4|0;L=g+4|0;M=g+4|0;N=i+4|0;O=g+4|0;P=i+4|0;Q=g+4|0;R=i+11|0;S=j+4|0;T=i+4|0;U=g+4|0;V=g+4|0;W=g+8|0;X=g+12|0;Y=g+4|0;Z=g+8|0;_=g+12|0;$=j+4|0;aa=g+11|0;ba=g+4|0;ca=i+11|0;da=0;a:while(1){ea=f[s>>2]|0;fa=ea+(da*88|0)|0;if(!d){ga=f[fa>>2]|0;if((b[520328]|0)==0?MIc(520328)|0:0){f[220308]=0;f[220309]=0;f[220310]=0;b[881243]=6;b[881232]=b[390230]|0;b[881233]=b[390231]|0;b[881234]=b[390232]|0;b[881235]=b[390233]|0;b[881236]=b[390234]|0;b[881237]=b[390235]|0;b[881238]=0;be(1736,881232,x|0)|0}ha=b[ga+11>>0]|0;ia=ha<<24>>24<0?f[ga+4>>2]|0:ha&255;ha=b[881243]|0;ja=ha<<24>>24<0;ka=ja?f[220309]|0:ha&255;if(ia>>>0>=ka>>>0?(EEc(ga,ia-ka|0,ka,ja?f[220308]|0:881232,ka)|0)==0:0)la=10}else la=10;b:do if((la|0)==10){la=0;ka=Mi[f[(f[q>>2]|0)+8>>2]&1023](q,a)|0;ja=ea+(da*88|0)+32|0;ia=f[ja>>2]|0;switch(ia|0){case 2:break;case 1:{if(!(hj[f[(f[q>>2]|0)+20>>2]&511](q,a,fa)|0)){ma=f[ja>>2]|0;la=13}break}default:{ma=ia;la=13}}do if((la|0)==13){la=0;if((ma|0)==3?(hj[f[(f[q>>2]|0)+24>>2]&511](q,a,fa)|0)>0:0)break;if(!(f[ka>>2]|0))break b}while(0);ia=f[ka>>2]|0;c:do if(ia|0?(ga=f[ia>>2]|0,ha=(f[ia+4>>2]|0)-ga|0,na=ha>>4,oa=ga,(ha|0)>0):0){if((f[oa+4>>2]|0)==4){pa=0;qa=oa}else{la=19;break a}while(1){oa=qa+(pa<<4)+8|0;fEc(g,f[(f[f[f[oa>>2]>>2]>>2]|0)+8>>2]|0);fEc(i,f[(f[f[f[oa>>2]>>2]>>2]|0)+24>>2]|0);f[j>>2]=0;f[$>>2]=0;oa=b[aa>>0]|0;ha=oa<<24>>24<0?f[ba>>2]|0:oa&255;if(ha|0){oa=tT(j,ha)|0;dJc(oa|0,((b[aa>>0]|0)<0?f[g>>2]|0:g)|0,ha|0)|0}fIa(c,j,i)|0;uT(j);if((b[ca>>0]|0)<0)YDc(f[i>>2]|0);if((b[aa>>0]|0)<0)YDc(f[g>>2]|0);pa=pa+1|0;if((pa|0)>=(na|0))break c;qa=f[f[ka>>2]>>2]|0;if((f[qa+(pa<<4)+4>>2]|0)!=4){la=19;break a}}}while(0);ra=ea+(da*88|0)+24|0;ka=f[ra>>2]|0;if(ka|0?(f[ka>>2]|0)!=2:0){f[g>>2]=78728;f[Y>>2]=1737;b[Z>>0]=0;f[_>>2]=fa;DTb(ka,g)}sa=ea+(da*88|0)+28|0;if((f[161216+(f[sa>>2]<<2)>>2]|0)==10)if((f[ja>>2]|0)==3){sLa(hh[f[(f[q>>2]|0)+208>>2]&127](q,a,fa,0)|0,c,1);break}else{sLa(hh[f[(f[q>>2]|0)+108>>2]&127](q,a,fa,0)|0,c,1);break}ka=_i[f[(f[a>>2]|0)+92>>2]&1023](a)|0;ia=f[ra>>2]|0;if(ia|0?(f[ia>>2]|0)!=2:0){f[g>>2]=78728;f[V>>2]=1737;b[W>>0]=0;f[X>>2]=fa;DTb(ia,g)}ia=(f[ja>>2]|0)==3;na=f[fa>>2]|0;d:do switch(f[161216+(f[sa>>2]<<2)>>2]|0){case 1:{if(!ia){f[g>>2]=0;f[v>>2]=0;ha=na+11|0;oa=b[ha>>0]|0;ga=oa<<24>>24<0?f[na+4>>2]|0:oa&255;if(ga|0){oa=tT(g,ga)|0;dJc(oa|0,((b[ha>>0]|0)<0?f[na>>2]|0:na)|0,ga|0)|0}ga=hj[f[(f[ka>>2]|0)+68>>2]&511](ka,a,fa)|0;f[i>>2]=ga;$Ha(c,g,i)|0;uT(g);break d}ga=chc(ka,a,fa)|0;f[g>>2]=0;f[o>>2]=0;ha=na+11|0;oa=b[ha>>0]|0;ta=oa<<24>>24<0?f[na+4>>2]|0:oa&255;if(ta|0){oa=tT(g,ta)|0;dJc(oa|0,((b[ha>>0]|0)<0?f[na>>2]|0:na)|0,ta|0)|0}ta=f[ga+8>>2]|0;ha=f[ga>>2]|0;ga=VDc(16)|0;oa=ga+8|0;f[ga>>2]=oa;f[ga+4>>2]=ha;if(ha>>>0>1){ua=XDc(ha>>>0>536870911?-1:ha<<3)|0;f[ga>>2]=ua;va=ua}else va=oa;f[i>>2]=0;f[t>>2]=ga;if((ha|0)>0){ga=(ta|0)==0?0:ta+4|0;ta=0;while(1){oa=f[ga>>2]|0;ua=va+(ta<<3)|0;f[ua>>2]=oa;f[ua+4>>2]=((oa|0)<0)<<31>>31;ta=ta+1|0;if((ta|0)==(ha|0))break;else ga=ga+4|0}}bIa(c,g,i)|0;JFa(i);uT(g);break}case 3:{if(!ia){f[g>>2]=0;f[z>>2]=0;ga=na+11|0;ha=b[ga>>0]|0;ta=ha<<24>>24<0?f[na+4>>2]|0:ha&255;if(ta|0){ha=tT(g,ta)|0;dJc(ha|0,((b[ga>>0]|0)<0?f[na>>2]|0:na)|0,ta|0)|0}ta=hj[f[(f[ka>>2]|0)+76>>2]&511](ka,a,fa)|0;f[i>>2]=ta;wLa(c,g,i)|0;uT(g);break d}ta=ehc(ka,a,fa)|0;f[g>>2]=0;f[w>>2]=0;ga=na+11|0;ha=b[ga>>0]|0;oa=ha<<24>>24<0?f[na+4>>2]|0:ha&255;if(oa|0){ha=tT(g,oa)|0;dJc(ha|0,((b[ga>>0]|0)<0?f[na>>2]|0:na)|0,oa|0)|0}oa=f[ta+8>>2]|0;ga=f[ta>>2]|0;ta=VDc(16)|0;ha=ta+8|0;f[ta>>2]=ha;f[ta+4>>2]=ga;if(ga>>>0>1){ua=XDc(ga>>>0>536870911?-1:ga<<3)|0;f[ta>>2]=ua;wa=ua}else wa=ha;f[i>>2]=0;f[y>>2]=ta;if((ga|0)>0){ta=(oa|0)==0?0:oa+4|0;oa=0;while(1){ha=wa+(oa<<3)|0;f[ha>>2]=f[ta>>2];f[ha+4>>2]=0;oa=oa+1|0;if((oa|0)==(ga|0))break;else ta=ta+4|0}}bIa(c,g,i)|0;JFa(i);uT(g);break}case 2:{if(!ia){f[g>>2]=0;f[C>>2]=0;ta=na+11|0;ga=b[ta>>0]|0;oa=ga<<24>>24<0?f[na+4>>2]|0:ga&255;if(oa|0){ga=tT(g,oa)|0;dJc(ga|0,((b[ta>>0]|0)<0?f[na>>2]|0:na)|0,oa|0)|0}oa=hj[f[(f[ka>>2]|0)+68>>2]&511](ka,a,fa)|0;f[i>>2]=oa;$Ha(c,g,i)|0;uT(g);break d}oa=dhc(ka,a,fa)|0;f[g>>2]=0;f[A>>2]=0;ta=na+11|0;ga=b[ta>>0]|0;ha=ga<<24>>24<0?f[na+4>>2]|0:ga&255;if(ha|0){ga=tT(g,ha)|0;dJc(ga|0,((b[ta>>0]|0)<0?f[na>>2]|0:na)|0,ha|0)|0}ha=f[oa+8>>2]|0;ta=f[oa>>2]|0;oa=VDc(16)|0;ga=oa+8|0;f[oa>>2]=ga;f[oa+4>>2]=ta;if(ta>>>0>1){ua=XDc(ta>>>0>536870911?-1:ta<<3)|0;f[oa>>2]=ua;xa=ua}else xa=ga;f[i>>2]=0;f[B>>2]=oa;if((ta|0)>0){oa=(ha|0)==0?0:ha+8|0;ha=0;while(1){ga=oa;ua=f[ga+4>>2]|0;ya=xa+(ha<<3)|0;f[ya>>2]=f[ga>>2];f[ya+4>>2]=ua;ha=ha+1|0;if((ha|0)==(ta|0))break;else oa=oa+8|0}}bIa(c,g,i)|0;JFa(i);uT(g);break}case 4:{if(!ia){f[g>>2]=0;f[F>>2]=0;oa=na+11|0;ta=b[oa>>0]|0;ha=ta<<24>>24<0?f[na+4>>2]|0:ta&255;if(ha|0){ta=tT(g,ha)|0;dJc(ta|0,((b[oa>>0]|0)<0?f[na>>2]|0:na)|0,ha|0)|0}ha=hj[f[(f[ka>>2]|0)+76>>2]&511](ka,a,fa)|0;f[i>>2]=ha;wLa(c,g,i)|0;uT(g);break d}ha=fhc(ka,a,fa)|0;f[g>>2]=0;f[D>>2]=0;oa=na+11|0;ta=b[oa>>0]|0;ua=ta<<24>>24<0?f[na+4>>2]|0:ta&255;if(ua|0){ta=tT(g,ua)|0;dJc(ta|0,((b[oa>>0]|0)<0?f[na>>2]|0:na)|0,ua|0)|0}ua=f[ha+8>>2]|0;oa=f[ha>>2]|0;ha=VDc(16)|0;ta=ha+8|0;f[ha>>2]=ta;f[ha+4>>2]=oa;if(oa>>>0>1){ya=XDc(oa>>>0>536870911?-1:oa<<3)|0;f[ha>>2]=ya;za=ya}else za=ta;f[i>>2]=0;f[E>>2]=ha;if((oa|0)>0){ha=(ua|0)==0?0:ua+8|0;ua=0;while(1){ta=ha;ya=f[ta+4>>2]|0;ga=za+(ua<<3)|0;f[ga>>2]=f[ta>>2];f[ga+4>>2]=ya;ua=ua+1|0;if((ua|0)==(oa|0))break;else ha=ha+8|0}}bIa(c,g,i)|0;JFa(i);uT(g);break}case 7:{if(!ia){f[g>>2]=0;f[I>>2]=0;ha=na+11|0;oa=b[ha>>0]|0;ua=oa<<24>>24<0?f[na+4>>2]|0:oa&255;if(ua|0){oa=tT(g,ua)|0;dJc(oa|0,((b[ha>>0]|0)<0?f[na>>2]|0:na)|0,ua|0)|0}ua=(hj[f[(f[ka>>2]|0)+92>>2]&511](ka,a,fa)|0)&1;b[i>>0]=ua;rIa(c,g,i)|0;uT(g);break d}ua=ihc(ka,a,fa)|0;f[g>>2]=0;f[G>>2]=0;ha=na+11|0;oa=b[ha>>0]|0;ya=oa<<24>>24<0?f[na+4>>2]|0:oa&255;if(ya|0){oa=tT(g,ya)|0;dJc(oa|0,((b[ha>>0]|0)<0?f[na>>2]|0:na)|0,ya|0)|0}ya=f[ua+8>>2]|0;ha=f[ua>>2]|0;ua=VDc(16)|0;oa=ua+8|0;f[ua>>2]=oa;f[ua+4>>2]=ha;if(ha>>>0>1){ga=XDc(ha>>>0>536870911?-1:ha<<3)|0;f[ua>>2]=ga;Aa=ga}else Aa=oa;f[i>>2]=0;f[H>>2]=ua;if((ha|0)>0){ua=(ya|0)==0?0:ya+4|0;ya=0;while(1){oa=Aa+(ya<<3)|0;f[oa>>2]=h[ua>>0];f[oa+4>>2]=0;ya=ya+1|0;if((ya|0)==(ha|0))break;else ua=ua+1|0}}bIa(c,g,i)|0;JFa(i);uT(g);break}case 5:{if(!ia){f[g>>2]=0;f[L>>2]=0;ua=na+11|0;ha=b[ua>>0]|0;ya=ha<<24>>24<0?f[na+4>>2]|0:ha&255;if(ya|0){ha=tT(g,ya)|0;dJc(ha|0,((b[ua>>0]|0)<0?f[na>>2]|0:na)|0,ya|0)|0}Ba=+Sh[f[(f[ka>>2]|0)+88>>2]&31](ka,a,fa);p[i>>3]=Ba;xKa(c,g,i)|0;uT(g);break d}ya=hhc(ka,a,fa)|0;f[g>>2]=0;f[J>>2]=0;ua=na+11|0;ha=b[ua>>0]|0;oa=ha<<24>>24<0?f[na+4>>2]|0:ha&255;if(oa|0){ha=tT(g,oa)|0;dJc(ha|0,((b[ua>>0]|0)<0?f[na>>2]|0:na)|0,oa|0)|0}oa=f[ya+8>>2]|0;ua=f[ya>>2]|0;ya=VDc(16)|0;ha=ya+8|0;f[ya>>2]=ha;f[ya+4>>2]=ua;if(ua>>>0>1){ga=XDc(ua>>>0>536870911?-1:ua<<3)|0;f[ya>>2]=ga;Ca=ga}else Ca=ha;f[i>>2]=2;f[K>>2]=ya;if((ua|0)>0){ya=(oa|0)==0?0:oa+8|0;oa=0;while(1){p[Ca+(oa<<3)>>3]=+p[ya>>3];oa=oa+1|0;if((oa|0)==(ua|0))break;else ya=ya+8|0}}bIa(c,g,i)|0;JFa(i);uT(g);break}case 6:{if(!ia){f[g>>2]=0;f[O>>2]=0;ya=na+11|0;ua=b[ya>>0]|0;oa=ua<<24>>24<0?f[na+4>>2]|0:ua&255;if(oa|0){ua=tT(g,oa)|0;dJc(ua|0,((b[ya>>0]|0)<0?f[na>>2]|0:na)|0,oa|0)|0}Ba=+Sh[f[(f[ka>>2]|0)+84>>2]&31](ka,a,fa);n[i>>2]=Ba;eIa(c,g,i)|0;uT(g);break d}oa=ghc(ka,a,fa)|0;f[g>>2]=0;f[M>>2]=0;ya=na+11|0;ua=b[ya>>0]|0;ha=ua<<24>>24<0?f[na+4>>2]|0:ua&255;if(ha|0){ua=tT(g,ha)|0;dJc(ua|0,((b[ya>>0]|0)<0?f[na>>2]|0:na)|0,ha|0)|0}ha=f[oa+8>>2]|0;ya=f[oa>>2]|0;oa=VDc(16)|0;ua=oa+8|0;f[oa>>2]=ua;f[oa+4>>2]=ya;if(ya>>>0>1){ga=XDc(ya>>>0>536870911?-1:ya<<3)|0;f[oa>>2]=ga;Da=ga}else Da=ua;f[i>>2]=2;f[N>>2]=oa;if((ya|0)>0){oa=(ha|0)==0?0:ha+4|0;ha=0;while(1){p[Da+(ha<<3)>>3]=+n[oa>>2];ha=ha+1|0;if((ha|0)==(ya|0))break;else oa=oa+4|0}}bIa(c,g,i)|0;JFa(i);uT(g);break}case 9:{if(ia){oa=jhc(ka,a,fa,1)|0;f[i>>2]=0;f[P>>2]=0;ya=na+11|0;ha=b[ya>>0]|0;ua=ha<<24>>24<0?f[na+4>>2]|0:ha&255;if(ua|0){ha=tT(i,ua)|0;dJc(ha|0,((b[ya>>0]|0)<0?f[na>>2]|0:na)|0,ua|0)|0}ua=f[oa+12>>2]|0;f[k>>2]=(ua|0)==0?0:ua+4|0;ua=f[oa+4>>2]|0;f[g>>2]=f[k>>2];xLa(j,g,ua);bIa(c,i,j)|0;JFa(j);uT(i);break d}f[g>>2]=0;f[Q>>2]=0;ua=na+11|0;oa=b[ua>>0]|0;ya=oa<<24>>24<0?f[na+4>>2]|0:oa&255;if(ya|0){oa=tT(g,ya)|0;dJc(oa|0,((b[ua>>0]|0)<0?f[na>>2]|0:na)|0,ya|0)|0}ei[f[(f[ka>>2]|0)+96>>2]&511](i,ka,a,fa);fIa(c,g,i)|0;if((b[R>>0]|0)<0)YDc(f[i>>2]|0);uT(g);break}case 8:{if(!ia){f[g>>2]=0;f[U>>2]=0;ya=na+11|0;ua=b[ya>>0]|0;oa=ua<<24>>24<0?f[na+4>>2]|0:ua&255;if(oa|0){ua=tT(g,oa)|0;dJc(ua|0,((b[ya>>0]|0)<0?f[na>>2]|0:na)|0,oa|0)|0}oa=hj[f[(f[ka>>2]|0)+100>>2]&511](ka,a,fa)|0;fIa(c,g,f[oa>>2]|0)|0;uT(g);break d}oa=hj[f[(f[ka>>2]|0)+24>>2]&511](ka,a,fa)|0;GHa(i,oa);if((oa|0)>0){ya=0;do{ua=hh[f[(f[ka>>2]|0)+200>>2]&127](ka,a,fa,ya)|0;ha=f[ua>>2]|0;ua=(f[i>>2]|0)+(ya<<3)|0;uT(ua);ga=ha+11|0;ta=b[ga>>0]|0;Ea=ta<<24>>24<0?f[ha+4>>2]|0:ta&255;if(Ea|0){ta=tT(ua,Ea)|0;dJc(ta|0,((b[ga>>0]|0)<0?f[ha>>2]|0:ha)|0,Ea|0)|0}ya=ya+1|0}while((ya|0)<(oa|0))}f[j>>2]=0;f[S>>2]=0;ya=na+11|0;Ea=b[ya>>0]|0;ha=Ea<<24>>24<0?f[na+4>>2]|0:Ea&255;if(ha|0){Ea=tT(j,ha)|0;dJc(Ea|0,((b[ya>>0]|0)<0?f[na>>2]|0:na)|0,ha|0)|0}f[m>>2]=f[i>>2];f[g>>2]=f[m>>2];yLa(l,g,oa);bIa(c,j,l)|0;JFa(l);uT(j);ha=f[i>>2]|0;if(ha|0){while(1){ya=f[T>>2]|0;if((ya|0)==(ha|0))break;Ea=ya+-8|0;f[T>>2]=Ea;uT(Ea)}YDc(f[i>>2]|0)}break}default:{la=141;break a}}while(0)}while(0);da=da+1|0;if((da|0)>=(f[r>>2]|0)){la=3;break}}if((la|0)==3){u=e;return}else if((la|0)==19){f[g>>2]=0;f[g+4>>2]=0;Fa=tT(g,58)|0;Ga=390237;Ha=Fa+58|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));z5(-215,g,390296,389822,112)}else if((la|0)==141){la=f[ra>>2]|0;if(la|0?(f[la>>2]|0)!=2:0){f[g>>2]=78728;f[g+4>>2]=1737;b[g+8>>0]=0;f[g+12>>2]=fa;DTb(la,g)}g=f[161292+(f[sa>>2]<<2)>>2]|0;f[l>>2]=0;sa=l+4|0;f[sa>>2]=0;if((g|0)!=0?(la=Mpc(g)|0,(la|0)!=0):0){dJc(tT(l,la)|0,g|0,la|0)|0;Ia=(f[sa>>2]|0)+14|0}else Ia=14;f[j>>2]=0;la=j+4|0;f[la>>2]=0;tT(j,Ia)|0;Ia=f[j>>2]|0;Fa=Ia;Ga=390316;Ha=Fa+14|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));g=f[sa>>2]|0;if(g|0)dJc(Ia+14|0,f[l>>2]|0,g|0)|0;f[i>>2]=0;f[i+4>>2]=0;tT(i,(f[la>>2]|0)+13|0)|0;g=f[la>>2]|0;if(!g){Ja=0;Ka=f[i>>2]|0;La=Ka+Ja|0;Fa=La;Ga=390331;Ha=Fa+13|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));z5(-2,i,390345,389822,180)}dJc(f[i>>2]|0,f[j>>2]|0,g|0)|0;Ja=f[la>>2]|0;Ka=f[i>>2]|0;La=Ka+Ja|0;Fa=La;Ga=390331;Ha=Fa+13|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));z5(-2,i,390345,389822,180)}}function tLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+160|0;e=d+136|0;g=d;h=g+56|0;i=g+4|0;f[g>>2]=7676;f[h>>2]=7696;auc(g+56|0,i);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=46080;f[h>>2]=46100;fuc(i);f[i>>2]=45740;h=g+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G1(i,e);if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);suc(g,f[c>>2]|0)|0;I1(e,i);f[a>>2]=0;f[a+4>>2]=0;i=e+11|0;c=b[i>>0]|0;h=c<<24>>24<0?f[e+4>>2]|0:c&255;if(!h)j=c;else{c=tT(a,h)|0;dJc(c|0,((b[i>>0]|0)<0?f[e>>2]|0:e)|0,h|0)|0;j=b[i>>0]|0}if(j<<24>>24>=0){D3(g);u=d;return}YDc(f[e>>2]|0);D3(g);u=d;return}function uLa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i;k=f[e+4+(h<<2)>>2]|0;e=a+208|0;l=a+212|0;m=f[e>>2]|0;n=(f[l>>2]|0)-m|0;o=((n|0)/20|0)+-1|0;p=m;a:do if((n|0)>0){m=b[k+11>>0]|0;q=m<<24>>24<0;r=q?f[k+4>>2]|0:m&255;m=(r|0)==0;b:do if(q){s=o;while(1){t=p+(s*20|0)|0;v=b[t+11>>0]|0;w=v<<24>>24<0;x=v&255;do if(((w?f[p+(s*20|0)+4>>2]|0:x)|0)==(r|0)){v=f[t>>2]|0;y=w?v:t;z=f[k>>2]|0;if(w){if(m)break b;if(!(Arc(y,z,r)|0))break b;else break}if(m)break b;if((v&255)<<24>>24==(b[z>>0]|0)){v=t;y=x;A=z;do{y=y+-1|0;v=v+1|0;if(!y)break b;A=A+1|0}while((b[v>>0]|0)==(b[A>>0]|0))}}while(0);if((s|0)>0)s=s+-1|0;else break a}}else{s=o;while(1){x=p+(s*20|0)|0;t=b[x+11>>0]|0;w=t<<24>>24<0;A=t&255;do if(((w?f[p+(s*20|0)+4>>2]|0:A)|0)==(r|0)){t=f[x>>2]|0;v=w?t:x;if(w){if(m)break b;if(!(Arc(v,k,r)|0))break b;else break}if(m)break b;if((t&255)<<24>>24==(b[k>>0]|0)){t=x;v=A;y=k;do{v=v+-1|0;t=t+1|0;if(!v)break b;y=y+1|0}while((b[t>>0]|0)==(b[y>>0]|0))}}while(0);if((s|0)>0)s=s+-1|0;else break a}}while(0);do if((c|0)>(h|0)?(m=f[d+4+(h<<2)>>2]|0,s=b[m+11>>0]|0,A=s<<24>>24<0,x=s&255,((A?f[m+4>>2]|0:x)|0)==(r|0)):0){s=f[m>>2]|0;w=A?s:m;y=q?f[k>>2]|0:k;t=(r|0)==0;if(A){if(t)break a;if(!(Arc(w,y,r)|0))break a;else break}if(t)break a;if((s&255)<<24>>24==(b[y>>0]|0)){s=m;m=x;x=y;do{m=m+-1|0;s=s+1|0;if(!m)break a;x=x+1|0}while((b[s>>0]|0)==(b[x>>0]|0))}}while(0);f[j>>2]=0;f[j+4>>2]=0;r=tT(j,44)|0;q=390175;x=r+44|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(x|0));z5(-5,j,390220,389822,418)}while(0);fEc(j,k);k=j+12|0;f[k>>2]=g;f[j+16>>2]=h;h=f[l>>2]|0;g=a+216|0;a=f[g>>2]|0;d=a;if((h|0)==(a|0)){a=f[e>>2]|0;c=(h-a|0)/20|0;p=c+1|0;if(p>>>0>214748364)mCc(e);o=(d-a|0)/20|0;a=o<<1;d=o>>>0<107374182?(a>>>0<p>>>0?p:a):214748364;do if(d)if(d>>>0>214748364){a=af(8)|0;bEc(a,503977);f[a>>2]=185532;ig(a|0,23696,1627)}else{B=VDc(d*20|0)|0;break}else B=0;while(0);a=B+(c*20|0)|0;p=a;o=B+(d*20|0)|0;fEc(a,j);d=k;n=f[d+4>>2]|0;q=B+(c*20|0)+12|0;f[q>>2]=f[d>>2];f[q+4>>2]=n;n=a+20|0;q=f[e>>2]|0;d=f[l>>2]|0;if((d|0)==(q|0)){C=p;D=q;E=q}else{c=d;d=p;p=a;do{a=c;c=c+-20|0;fEc(p+-20|0,c);B=a+-8|0;a=f[B+4>>2]|0;r=p+-8|0;f[r>>2]=f[B>>2];f[r+4>>2]=a;p=d+-20|0;d=p}while((c|0)!=(q|0));C=d;D=f[e>>2]|0;E=f[l>>2]|0}f[e>>2]=C;f[l>>2]=n;f[g>>2]=o;o=D;if((E|0)!=(o|0)){g=E;do{g=g+-20|0;if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0)}while((g|0)!=(o|0))}if(D|0)YDc(D)}else{fEc(h,j);D=k;k=f[D+4>>2]|0;o=h+12|0;f[o>>2]=f[D>>2];f[o+4>>2]=k;f[l>>2]=(f[l>>2]|0)+20}if((b[j+11>>0]|0)>=0){u=i;return}YDc(f[j>>2]|0);u=i;return}function vLa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+32|0;i=h+24|0;j=h+12|0;k=h;l=f[a+208>>2]|0;m=(f[a+212>>2]|0)-l|0;a=l;a:do if((m|0)>0){l=b[c+11>>0]|0;n=l<<24>>24<0;o=n?f[c+4>>2]|0:l&255;l=n?f[c>>2]|0:c;n=(o|0)==0;p=(m>>>0)/20|0;b:while(1){q=p+-1|0;r=a+(q*20|0)|0;s=b[r+11>>0]|0;t=s<<24>>24<0;v=s&255;do if(((t?f[a+(q*20|0)+4>>2]|0:v)|0)==(o|0)){s=f[r>>2]|0;w=t?s:r;if(t){if(n)break b;if(!(Arc(w,l,o)|0))break b;else break}if(n)break b;if((s&255)<<24>>24==(b[l>>0]|0)){s=r;w=v;x=l;do{w=w+-1|0;s=s+1|0;if(!w){y=12;break b}x=x+1|0}while((b[s>>0]|0)==(b[x>>0]|0))}}while(0);if((p|0)>1)p=q;else break a}if((y|0)==12?(p|0)<1:0)break;mGa(g,f[a+(q*20|0)+12>>2]|0,f[a+(q*20|0)+16>>2]|0,d,e);u=h;return}while(0);VHa(k,390141,c);jIa(j,k,501908);f[i>>2]=0;f[i+4>>2]=0;k=j+11|0;c=b[k>>0]|0;h=c<<24>>24<0?f[j+4>>2]|0:c&255;if(!h)z5(-204,i,390166,389822,435);c=tT(i,h)|0;dJc(c|0,((b[k>>0]|0)<0?f[j>>2]|0:j)|0,h|0)|0;z5(-204,i,390166,389822,435)}function wLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1154740:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((Ioc((r|0)==0?1154740:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(Ioc(m,(o|0)==0?1154740:o)|0)<=-1:0){t=n;break}o=f[c>>2]|0;f[e>>2]=0;p=VDc(16)|0;r=p+8|0;f[p>>2]=r;f[p+4>>2]=1;f[e+4>>2]=p;p=r;f[p>>2]=o;f[p+4>>2]=0;gIa(s+24|0,e)|0;JFa(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[i>>2]=0;t=VDc(16)|0;k=t+8|0;f[t>>2]=k;f[t+4>>2]=1;f[i+4>>2]=t;t=k;f[t>>2]=b;f[t+4>>2]=0;t=f[h>>2]|0;f[g>>2]=t;b=g+4|0;f[b>>2]=f[s>>2];if(t|0){s=t+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;TFa(s,i);t=f[g>>2]|0;f[e>>2]=t;k=e+4|0;f[k>>2]=f[b>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=e+8|0;TFa(b,s);t=f[j>>2]|0;b:do if(!t){v=j;w=j}else{p=a+4|0;o=f[e>>2]|0;r=(o|0)==0?1154740:o;x=f[t+16>>2]|0;c:do if((o|0)!=(x|0)){y=p;z=t;A=x;while(1){B=(A|0)==0?1154740:A;if((Ioc(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=24;break}else{E=z;F=C}}else{if((Ioc(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=27;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((o|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==24){v=z;w=z;break b}else if((D|0)==27){v=I;w=z;break b}}else{G=p;H=t}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=VDc(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}TFa(H+24|0,b);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}laa(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}JFa(b);uT(e);JFa(s);uT(g);JFa(i);uT(h);u=d;return c|0}function xLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=VDc(16)|0;g=e+8|0;f[g>>2]=0;f[e+12>>2]=0;f[e>>2]=g;f[e+4>>2]=1;zLa(e,d);f[a>>2]=3;g=a+4|0;f[g>>2]=e;if((d|0)<=0)return;a=f[c>>2]|0;h=0;i=a;j=e;e=a;while(1){a=f[i>>2]|0;k=(f[j>>2]|0)+(h<<3)|0;uT(k);l=a+11|0;m=b[l>>0]|0;n=m<<24>>24<0?f[a+4>>2]|0:m&255;if(n|0){m=tT(k,n)|0;dJc(m|0,((b[l>>0]|0)<0?f[a>>2]|0:a)|0,n|0)|0}n=e+4|0;f[c>>2]=n;a=h+1|0;if((a|0)>=(d|0))break;h=a;i=n;j=f[g>>2]|0;e=n}return}function yLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=VDc(16)|0;e=d+8|0;f[e>>2]=0;f[d+12>>2]=0;f[d>>2]=e;f[d+4>>2]=1;zLa(d,c);f[a>>2]=3;e=a+4|0;f[e>>2]=d;if((c|0)<=0)return;a=0;g=d;d=f[b>>2]|0;while(1){h=f[g>>2]|0;i=h+(a<<3)|0;if((d|0)==(i|0))j=d;else{uT(i);k=f[d>>2]|0;if(!k){l=d;m=0}else{n=k+-4|0;f[n>>2]=(f[n>>2]|0)+1;l=f[b>>2]|0;m=f[d>>2]|0}f[i>>2]=m;f[h+(a<<3)+4>>2]=f[d+4>>2];j=l}h=j+8|0;f[b>>2]=h;i=a+1|0;if((i|0)>=(c|0))break;a=i;g=f[e>>2]|0;d=h}return}function zLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;if((f[c>>2]|0)>>>0>=b>>>0){f[c>>2]=b;return}d=f[a>>2]|0;e=a+8|0;if((d|0)!=(e|0)){if(d|0){g=d+-4|0;h=f[g>>2]|0;if(h|0){i=d+(h<<3)|0;do{i=i+-8|0;uT(i)}while((i|0)!=(d|0))}ZDc(g)}f[a>>2]=e;f[c>>2]=1}f[c>>2]=b;if(b>>>0<=1)return;c=b<<3;e=XDc(b>>>0>536870911|c>>>0>4294967291?-1:c+4|0)|0;f[e>>2]=b;c=e+4|0;XIc(c|0,0,b<<3|0)|0;f[a>>2]=c;return}function ALa(a){a=a|0;YDc(a);return}function BLa(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&2047](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function CLa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+240|0;i=h+8|0;j=h;ffb(i);k=i+104|0;ffb(k);f[i+208>>2]=0;l=i+212|0;f[l>>2]=0;f[i+216>>2]=0;f[i+224>>2]=0;f[i+228>>2]=0;m=i+224|0;f[i+220>>2]=m;oMa(c,d,i);if((e|0)!=0&(g|0)!=0)qMa(e,g,k);tFa(a);g=f[a>>2]|0;f[j>>2]=g;f[j+4>>2]=f[a+4>>2];if(g|0){a=g+4|0;f[a>>2]=(f[a>>2]|0)+1}rLa(i,j);fGa(j);CFa(i+220|0,f[m>>2]|0);m=i+208|0;j=f[m>>2]|0;if(!j){lfb(k);lfb(i);u=h;return}a=f[l>>2]|0;if((a|0)==(j|0))n=j;else{g=a;while(1){a=g+-20|0;f[l>>2]=a;if((b[a+11>>0]|0)<0){YDc(f[a>>2]|0);o=f[l>>2]|0}else o=a;if((o|0)==(j|0))break;else g=o}n=f[m>>2]|0}YDc(n);lfb(k);lfb(i);u=h;return}function DLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[b>>2]|0;e=f[c>>2]|0;g=f[c+4>>2]|0;CLa(a,d,(f[b+4>>2]|0)-d|0,(e|0)==(g|0)?0:e,g-e|0);return}function ELa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+112|0;e=d;ffb(e);FLa(a,e);Yi[f[(f[c>>2]|0)+28>>2]&2047](c);a=e+8|0;do if(f[a>>2]&1|0){g=f[e+92>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;h=c+92|0;i=f[h>>2]|0;if((i|0)==527320){GLa(h,g);break}else{iEc(i,g)|0;break}}while(0);g=e+20|0;if((f[g>>2]|0)>0){i=e+28|0;h=0;j=1;while(1){k=f[(f[i>>2]|0)+4+(h<<2)>>2]|0;l=j&(ILa(k,HLa(c)|0)|0);h=h+1|0;if((h|0)>=(f[g>>2]|0)){m=l;break}else j=l}}else m=1;j=e+36|0;if((f[j>>2]|0)>0){g=e+44|0;h=c+32|0;i=0;do{l=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;iEc(JLa(h)|0,l)|0;i=i+1|0}while((i|0)<(f[j>>2]|0))}j=e+48|0;if((f[j>>2]|0)>0){i=e+56|0;h=c+48|0;g=c+52|0;l=c+56|0;k=0;do{n=f[(f[i>>2]|0)+4+(k<<2)>>2]|0;o=f[h>>2]|0;if((o|0)==(f[g>>2]|0)){KLa(h,o+1|0);p=f[h>>2]|0}else p=o;o=f[l>>2]|0;f[h>>2]=p+1;f[o+4+(p<<2)>>2]=n;k=k+1|0}while((k|0)<(f[j>>2]|0))}if(!(f[a>>2]&4)){lfb(e);u=d;return m|0}a=b[e+100>>0]|0;j=c+8|0;f[j>>2]=f[j>>2]|4;b[c+100>>0]=a;lfb(e);u=d;return m|0}function FLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+192|0;e=d+168|0;g=d;Yi[f[(f[c>>2]|0)+28>>2]&2047](c);vgb(c,a);h=c+20|0;i=f[h>>2]|0;if((i|0)>0){j=f[c+28>>2]|0;k=0;do{l=f[j+4+(k<<2)>>2]|0;k=k+1|0;Yi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((k|0)!=(i|0));f[h>>2]=0}f[e+4>>2]=0;f[e+8>>2]=0;i=e+4|0;f[e>>2]=i;k=a+36|0;if((f[k>>2]|0)>0){j=a+44|0;l=0;do{m=TLa(e,f[(f[j>>2]|0)+4+(l<<2)>>2]|0)|0;f[m>>2]=-1;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=a+20|0;if((f[k>>2]|0)<=0){n=e;o=f[i>>2]|0;ULa(n,o);u=d;return}l=a+28|0;a=g+21|0;j=g+32|0;m=g+24|0;p=g+21|0;q=g+32|0;r=g+24|0;s=g+21|0;t=g+32|0;v=g+24|0;w=g+21|0;x=g+32|0;y=g+24|0;z=g+21|0;A=g+32|0;B=g+24|0;C=c+28|0;D=0;do{E=f[(f[l>>2]|0)+4+(D<<2)>>2]|0;F=f[E+164>>2]|0;G=(F|0?F:524600)+60|0;F=f[G>>2]|0;H=b[F+11>>0]|0;if(!(((H<<24>>24<0?f[F+4>>2]|0:H&255)|0)==7?!(EEc(F,0,-1,440970,7)|0):0))chb(HLa(c)|0,E);F=E+20|0;if((f[F>>2]|0)>0){H=E+28|0;I=0;do{J=f[(f[H>>2]|0)+4+(I<<2)>>2]|0;if((VLa(e,J)|0)==(i|0)){aKa(g,390497,392016,235,508568,0,1);K=J+11|0;L=J+4|0;while(1){if(!(b[a>>0]|0))break;M=H1(j,392039,19)|0;N=b[K>>0]|0;O=N<<24>>24<0;suc(H1(H1(M,O?f[J>>2]|0:J,O?f[L>>2]|0:N&255)|0,392059,10)|0,I)|0;bKa(g)}K1(m)}L=TLa(e,J)|0;K=f[L>>2]|0;if(((K|0)!=-1?(L=f[(f[l>>2]|0)+4+(K<<2)>>2]|0,K=L+164|0,N=f[K>>2]|0,O=f[(N|0?N:524600)+60>>2]|0,N=b[O+11>>0]|0,((N<<24>>24<0?f[O+4>>2]|0:N&255)|0)==7):0)?(EEc(O,0,-1,440970,7)|0)==0:0){O=f[G>>2]|0;N=b[O+11>>0]|0;M=f[O+4>>2]|0;if(((N<<24>>24<0?M:N&255)|0)==4)if(!(EEc(O,0,-1,390479,4)|0))P=1;else{Q=f[G>>2]|0;R=b[Q+11>>0]|0;S=f[Q+4>>2]|0;T=Q;U=30}else{R=N;S=M;T=O;U=30}if((U|0)==30){U=0;if(((R<<24>>24<0?S:R&255)|0)==4)P=(EEc(T,0,-1,390751,4)|0)==0;else P=0}aKa(g,390497,392016,247,392070,392076,P);while(1){if(!(b[p>>0]|0))break;O=H1(q,392141,66)|0;M=f[G>>2]|0;N=b[M+11>>0]|0;Q=N<<24>>24<0;H1(O,Q?f[M>>2]|0:M,Q?f[M+4>>2]|0:N&255)|0;bKa(g)}K1(r);aKa(g,390497,392016,251,392070,392208,(f[F>>2]|0)==1);while(1){if(!(b[s>>0]|0))break;H1(t,392241,40)|0;bKa(g)}K1(v);aKa(g,390497,392016,253,392070,392282,(f[L+20>>2]|0)==1);while(1){if(!(b[w>>0]|0))break;H1(x,392311,43)|0;bKa(g)}K1(y);aKa(g,390497,392016,255,392070,392355,(f[L+36>>2]|0)==1);while(1){if(!(b[z>>0]|0))break;H1(A,392381,47)|0;bKa(g)}K1(B);J=(f[h>>2]|0)+-1|0;N=f[(f[C>>2]|0)+4+(J<<2)>>2]|0;M=N+8|0;f[M>>2]=f[M>>2]|2;M=N+164|0;Q=f[M>>2]|0;if(!Q){O=VDc(196)|0;UXa(O);f[M>>2]=O;V=O;W=f[(f[C>>2]|0)+4+(J<<2)>>2]|0}else{V=Q;W=N}N=f[K>>2]|0;Q=f[(N|0?N:524600)+92>>2]|0;N=V+8|0;f[N>>2]=f[N>>2]|512;f[V+92>>2]=Q;iEc(f[(f[W+28>>2]|0)+4+(I<<2)>>2]|0,f[(f[L+28>>2]|0)+4>>2]|0)|0}I=I+1|0}while((I|0)<(f[F>>2]|0))}F=E+36|0;if((f[F>>2]|0)>0){I=E+44|0;G=0;do{H=TLa(e,f[(f[I>>2]|0)+4+(G<<2)>>2]|0)|0;f[H>>2]=D;G=G+1|0}while((G|0)<(f[F>>2]|0))}D=D+1|0}while((D|0)<(f[k>>2]|0));n=e;o=f[i>>2]|0;ULa(n,o);u=d;return}function GLa(a,b){a=a|0;b=b|0;var c=0;c=VDc(12)|0;fEc(c,b);f[a>>2]=c;return}function HLa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+16|0;c=a+28|0;d=f[c>>2]|0;do if(!d){e=a+20|0;g=f[a+24>>2]|0;h=6}else{i=a+20|0;j=f[i>>2]|0;k=f[d>>2]|0;if((j|0)>=(k|0))if((k|0)==(f[a+24>>2]|0)){e=i;g=k;h=6;break}else{l=i;m=k;n=d;break}f[i>>2]=j+1;o=f[d+4+(j<<2)>>2]|0;return o|0}while(0);if((h|0)==6){USb(b,g+1|0);g=f[c>>2]|0;l=e;m=f[g>>2]|0;n=g}f[n>>2]=m+1;m=f[b>>2]|0;if(!m){b=VDc(296)|0;h6a(b);p=b}else{if(f[m+64>>2]|0)OQb(m,15112,296);b=NQb(m,296,1738)|0;h6a(b);p=b}b=f[c>>2]|0;c=f[l>>2]|0;f[l>>2]=c+1;f[b+4+(c<<2)>>2]=p;o=p;return o|0}function ILa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0;d=u;u=u+176|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;g=tT(e,28)|0;h=390426;i=g+28|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));LLa(-215,e,390455,273)}Yi[f[(f[c>>2]|0)+28>>2]&2047](c);h=a+20|0;if((f[h>>2]|0)>0){g=a+28|0;i=c+16|0;j=0;do{k=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;iEc(JLa(i)|0,k)|0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=a+36|0;if((f[h>>2]|0)>0){j=a+44|0;i=c+32|0;g=0;do{k=f[(f[j>>2]|0)+4+(g<<2)>>2]|0;iEc(JLa(i)|0,k)|0;g=g+1|0}while((g|0)<(f[h>>2]|0))}if(!(f[a+8>>2]&2)){l=1;u=d;return l|0}h=f[a+164>>2]|0;g=h|0?h:524600;h=g+8|0;do if(f[h>>2]&1|0){i=f[g+56>>2]|0;j=c+8|0;f[j>>2]=f[j>>2]|1;j=c+160|0;k=f[j>>2]|0;if((k|0)==527320){GLa(j,i);break}else{iEc(k,i)|0;break}}while(0);i=f[g+60>>2]|0;if(f[h>>2]&2|0){k=MLa(i)|0;j=c+12|0;f[j>>2]=f[j>>2]|1;f[c+288>>2]=k}k=c+48|0;j=a+48|0;do if((c|0)!=(a|0))if((f[j>>2]|0)==(f[k>>2]|0)){m=c+60|0;n=a+60|0;o=f[m>>2]|0;f[m>>2]=f[n>>2];f[n>>2]=o;o=c+52|0;n=a+52|0;m=f[o>>2]|0;f[o>>2]=f[n>>2];f[n>>2]=m;m=c+56|0;n=a+56|0;o=f[m>>2]|0;f[m>>2]=f[n>>2];f[n>>2]=o;break}else{NLa(k,j);break}while(0);j=g+32|0;if((f[j>>2]|0)>0){k=g+40|0;a=c+64|0;o=c+68|0;n=c+72|0;m=0;p=f[a>>2]|0;do{q=f[(f[k>>2]|0)+4+(m<<2)>>2]|0;if((p|0)==(f[o>>2]|0)){SHa(a,p+1|0);r=f[a>>2]|0}else r=p;s=f[n>>2]|0;p=r+1|0;f[a>>2]=p;f[s+4+(r<<2)>>2]=q;m=m+1|0}while((m|0)<(f[j>>2]|0))}j=g+44|0;if((f[j>>2]|0)>0){m=g+52|0;r=c+76|0;p=c+80|0;a=c+84|0;n=0;o=f[r>>2]|0;do{k=f[(f[m>>2]|0)+4+(n<<2)>>2]|0;if((o|0)==(f[p>>2]|0)){SHa(r,o+1|0);t=f[r>>2]|0}else t=o;q=f[a>>2]|0;o=t+1|0;f[r>>2]=o;f[q+4+(t<<2)>>2]=k;n=n+1|0}while((n|0)<(f[j>>2]|0))}a:do if(!(f[h>>2]&256))v=1;else{j=i+11|0;n=b[j>>0]|0;t=i+4|0;o=f[t>>2]|0;do if(((n<<24>>24<0?o:n&255)|0)==4){if(EEc(i,0,-1,390479,4)|0){w=b[j>>0]|0;x=f[t>>2]|0;break}r=c+8|0;f[r>>2]=f[r>>2]|8;r=c+172|0;a=f[r>>2]|0;if(!a){p=VDc(120)|0;nYa(p);f[r>>2]=p;y=p}else y=a;a=f[g+88>>2]|0;p=y+8|0;f[p>>2]=f[p>>2]|4;f[y+72>>2]=a;v=1;break a}else{w=n;x=o}while(0);if(((w<<24>>24<0?x:w&255)|0)==12?(EEc(i,0,-1,390484,12)|0)==0:0){o=c+8|0;f[o>>2]=f[o>>2]|1024;o=c+200|0;n=f[o>>2]|0;if(!n){a=VDc(36)|0;xYa(a);f[o>>2]=a;z=a}else z=n;n=f[g+88>>2]|0;a=z+8|0;f[a>>2]=f[a>>2]|4;f[z+24>>2]=n;v=1;break}aKa(e,390497,390455,307,508580,0,1);n=e+21|0;a=e+32|0;while(1){if(!(b[n>>0]|0))break;o=H1(a,390569,44)|0;p=b[j>>0]|0;r=p<<24>>24<0;H1(o,r?f[i>>2]|0:i,r?f[t>>2]|0:p&255)|0;bKa(e)}K1(e+24|0);v=0}while(0);b:do if(!(f[h>>2]&8388608))A=v;else{z=i+11|0;w=b[z>>0]|0;x=i+4|0;y=f[x>>2]|0;do if(((w<<24>>24<0?y:w&255)|0)==4){if(EEc(i,0,-1,390479,4)|0){B=b[z>>0]|0;C=f[x>>2]|0;break}t=c+8|0;f[t>>2]=f[t>>2]|8;t=c+172|0;j=f[t>>2]|0;if(!j){a=VDc(120)|0;nYa(a);f[t>>2]=a;D=a}else D=j;j=b[g+144>>0]|0;a=D+8|0;f[a>>2]=f[a>>2]|4096;b[D+112>>0]=j;A=v;break b}else{B=w;C=y}while(0);if(((B<<24>>24<0?C:B&255)|0)==12?(EEc(i,0,-1,390484,12)|0)==0:0){y=c+8|0;f[y>>2]=f[y>>2]|1024;y=c+200|0;w=f[y>>2]|0;if(!w){j=VDc(36)|0;xYa(j);f[y>>2]=j;E=j}else E=w;w=b[g+144>>0]|0;j=E+8|0;f[j>>2]=f[j>>2]|16;b[E+29>>0]=w;A=v;break}aKa(e,390497,390455,319,508580,0,1);w=e+21|0;j=e+32|0;while(1){if(!(b[w>>0]|0))break;y=H1(j,390614,42)|0;a=b[z>>0]|0;t=a<<24>>24<0;H1(y,t?f[i>>2]|0:i,t?f[x>>2]|0:a&255)|0;bKa(e)}K1(e+24|0);A=0}while(0);c:do if(!(f[h>>2]&32))F=A;else{v=i+11|0;E=b[v>>0]|0;B=i+4|0;C=f[B>>2]|0;do if(((E<<24>>24<0?C:E&255)|0)==4){if(EEc(i,0,-1,390479,4)|0){G=b[v>>0]|0;H=f[B>>2]|0;break}D=c+8|0;f[D>>2]=f[D>>2]|8;D=c+172|0;x=f[D>>2]|0;if(!x){z=VDc(120)|0;nYa(z);f[D>>2]=z;I=z}else I=x;x=I+8|0;f[x>>2]=f[x>>2]|1;x=I+64|0;z=f[x>>2]|0;if(!z){D=VDc(48)|0;BWa(D);f[x>>2]=D;J=D}else J=z;z=f[g+76>>2]|0;sgb(J,z|0?z:521608);F=A;break c}else{G=E;H=C}while(0);if(((G<<24>>24<0?H:G&255)|0)==12?(EEc(i,0,-1,390484,12)|0)==0:0){C=c+8|0;f[C>>2]=f[C>>2]|1024;C=c+200|0;E=f[C>>2]|0;if(!E){z=VDc(36)|0;xYa(z);f[C>>2]=z;K=z}else K=E;E=K+8|0;f[E>>2]=f[E>>2]|1;E=K+16|0;z=f[E>>2]|0;if(!z){C=VDc(48)|0;BWa(C);f[E>>2]=C;L=C}else L=z;z=f[g+76>>2]|0;sgb(L,z|0?z:521608);F=A;break}aKa(e,390497,390455,331,508580,0,1);z=e+21|0;C=e+32|0;while(1){if(!(b[z>>0]|0))break;E=H1(C,390657,47)|0;D=b[v>>0]|0;x=D<<24>>24<0;H1(E,x?f[i>>2]|0:i,x?f[B>>2]|0:D&255)|0;bKa(e)}K1(e+24|0);F=0}while(0);d:do if(!(f[h>>2]&64))M=F;else{A=i+11|0;L=b[A>>0]|0;K=i+4|0;G=f[K>>2]|0;do if(((L<<24>>24<0?G:L&255)|0)==4){if(EEc(i,0,-1,390479,4)|0){N=b[A>>0]|0;O=f[K>>2]|0;break}H=c+8|0;f[H>>2]=f[H>>2]|8;H=c+172|0;J=f[H>>2]|0;if(!J){I=VDc(120)|0;nYa(I);f[H>>2]=I;P=I}else P=J;J=P+8|0;f[J>>2]=f[J>>2]|2;J=P+68|0;I=f[J>>2]|0;if(!I){H=VDc(48)|0;BWa(H);f[J>>2]=H;Q=H}else Q=I;I=f[g+80>>2]|0;sgb(Q,I|0?I:521608);M=F;break d}else{N=L;O=G}while(0);if(((N<<24>>24<0?O:N&255)|0)==12?(EEc(i,0,-1,390484,12)|0)==0:0){G=c+8|0;f[G>>2]=f[G>>2]|1024;G=c+200|0;L=f[G>>2]|0;if(!L){I=VDc(36)|0;xYa(I);f[G>>2]=I;R=I}else R=L;L=R+8|0;f[L>>2]=f[L>>2]|2;L=R+20|0;I=f[L>>2]|0;if(!I){G=VDc(48)|0;BWa(G);f[L>>2]=G;S=G}else S=I;I=f[g+80>>2]|0;sgb(S,I|0?I:521608);M=F;break}aKa(e,390497,390455,343,508580,0,1);I=e+21|0;G=e+32|0;while(1){if(!(b[I>>0]|0))break;L=H1(G,390705,45)|0;H=b[A>>0]|0;J=H<<24>>24<0;H1(L,J?f[i>>2]|0:i,J?f[K>>2]|0:H&255)|0;bKa(e)}K1(e+24|0);M=0}while(0);e:do if(!(f[h>>2]&512))T=M;else{F=i+11|0;S=b[F>>0]|0;R=i+4|0;N=f[R>>2]|0;do if(((S<<24>>24<0?N:S&255)|0)==4){if(EEc(i,0,-1,390479,4)|0){U=b[F>>0]|0;V=f[R>>2]|0;break}O=c+8|0;f[O>>2]=f[O>>2]|8;O=c+172|0;Q=f[O>>2]|0;if(!Q){P=VDc(120)|0;nYa(P);f[O>>2]=P;W=P}else W=Q;Q=f[g+92>>2]|0;P=W+16|0;O=f[P>>2]|0;if((O|0)==(f[W+20>>2]|0)){OLa(P,O+1|0);X=f[P>>2]|0}else X=O;O=f[W+24>>2]|0;f[P>>2]=X+1;f[O+4+(X<<2)>>2]=Q;T=M;break e}else{U=S;V=N}while(0);if(((U<<24>>24<0?V:U&255)|0)==4?(EEc(i,0,-1,390751,4)|0)==0:0){N=c+8|0;f[N>>2]=f[N>>2]|4096;N=c+208|0;S=f[N>>2]|0;if(!S){Q=VDc(68)|0;BYa(Q);f[N>>2]=Q;Y=Q}else Y=S;S=f[g+92>>2]|0;Q=Y+8|0;f[Q>>2]=f[Q>>2]|4;f[Y+24>>2]=S;T=M;break}aKa(e,390497,390455,353,508580,0,1);S=e+21|0;Q=e+32|0;while(1){if(!(b[S>>0]|0))break;N=H1(Q,390756,37)|0;O=b[F>>0]|0;P=O<<24>>24<0;H1(N,P?f[i>>2]|0:i,P?f[R>>2]|0:O&255)|0;bKa(e)}K1(e+24|0);T=0}while(0);f:do if(!(f[h>>2]&1024))Z=T;else{M=i+11|0;Y=b[M>>0]|0;U=i+4|0;V=f[U>>2]|0;do if(((Y<<24>>24<0?V:Y&255)|0)==4){if(EEc(i,0,-1,390479,4)|0){_=b[M>>0]|0;$=f[U>>2]|0;break}X=c+8|0;f[X>>2]=f[X>>2]|8;X=c+172|0;W=f[X>>2]|0;if(!W){R=VDc(120)|0;nYa(R);f[X>>2]=R;aa=R}else aa=W;W=f[g+96>>2]|0;R=aa+28|0;X=f[R>>2]|0;if((X|0)==(f[aa+32>>2]|0)){OLa(R,X+1|0);ba=f[R>>2]|0}else ba=X;X=f[aa+36>>2]|0;f[R>>2]=ba+1;f[X+4+(ba<<2)>>2]=W;Z=T;break f}else{_=Y;$=V}while(0);if(((_<<24>>24<0?$:_&255)|0)==4?(EEc(i,0,-1,390751,4)|0)==0:0){V=c+8|0;f[V>>2]=f[V>>2]|4096;V=c+208|0;Y=f[V>>2]|0;if(!Y){W=VDc(68)|0;BYa(W);f[V>>2]=W;ca=W}else ca=Y;Y=f[g+96>>2]|0;W=ca+8|0;f[W>>2]=f[W>>2]|2;f[ca+20>>2]=Y;Z=T;break}aKa(e,390497,390455,365,508580,0,1);Y=e+21|0;W=e+32|0;while(1){if(!(b[Y>>0]|0))break;V=H1(W,390794,44)|0;X=b[M>>0]|0;R=X<<24>>24<0;H1(V,R?f[i>>2]|0:i,R?f[U>>2]|0:X&255)|0;bKa(e)}K1(e+24|0);Z=0}while(0);do if(!(f[h>>2]&16777216))da=Z;else{T=i+11|0;ca=b[T>>0]|0;_=i+4|0;if(((ca<<24>>24<0?f[_>>2]|0:ca&255)|0)==4?(EEc(i,0,-1,390479,4)|0)==0:0){ca=c+8|0;f[ca>>2]=f[ca>>2]|8;ca=c+172|0;$=f[ca>>2]|0;if(!$){ba=VDc(120)|0;nYa(ba);f[ca>>2]=ba;ea=ba}else ea=$;$=f[g+148>>2]|0;ba=ea+8|0;f[ba>>2]=f[ba>>2]|8192;f[ea+116>>2]=$;da=Z;break}aKa(e,390497,390455,374,508580,0,1);$=e+21|0;ba=e+32|0;while(1){if(!(b[$>>0]|0))break;ca=H1(ba,390839,39)|0;aa=b[T>>0]|0;U=aa<<24>>24<0;H1(ca,U?f[i>>2]|0:i,U?f[_>>2]|0:aa&255)|0;bKa(e)}K1(e+24|0);da=0}while(0);g:do if(!(f[h>>2]&33554432))fa=da;else{Z=i+11|0;ea=b[Z>>0]|0;_=i+4|0;T=f[_>>2]|0;do if(((ea<<24>>24<0?T:ea&255)|0)==4){if(EEc(i,0,-1,390479,4)|0){ga=b[Z>>0]|0;ha=f[_>>2]|0;break}ba=c+8|0;f[ba>>2]=f[ba>>2]|8;ba=c+172|0;$=f[ba>>2]|0;if(!$){aa=VDc(120)|0;nYa(aa);f[ba>>2]=aa;ia=aa}else ia=$;$=f[g+152>>2]|0;aa=ia+40|0;ba=f[aa>>2]|0;if((ba|0)==(f[ia+44>>2]|0)){OLa(aa,ba+1|0);ja=f[aa>>2]|0}else ja=ba;ba=f[ia+48>>2]|0;f[aa>>2]=ja+1;f[ba+4+(ja<<2)>>2]=$;fa=da;break g}else{ga=ea;ha=T}while(0);do if(((ga<<24>>24<0?ha:ga&255)|0)==4){if(EEc(i,0,-1,390751,4)|0)break;T=c+8|0;f[T>>2]=f[T>>2]|4096;T=c+208|0;ea=f[T>>2]|0;if(!ea){$=VDc(68)|0;BYa($);f[T>>2]=$;ka=$}else ka=ea;ea=f[g+152>>2]|0;$=ka+8|0;f[$>>2]=f[$>>2]|2048;f[ka+60>>2]=ea;fa=da;break g}while(0);aKa(e,390497,390455,386,508580,0,1);ea=e+21|0;$=e+32|0;while(1){if(!(b[ea>>0]|0))break;T=H1($,390879,40)|0;ba=b[Z>>0]|0;aa=ba<<24>>24<0;H1(T,aa?f[i>>2]|0:i,aa?f[_>>2]|0:ba&255)|0;bKa(e)}K1(e+24|0);fa=0}while(0);h:do if(!(f[h>>2]&2048))la=fa;else{da=i+11|0;ka=b[da>>0]|0;ga=i+4|0;do if(((ka<<24>>24<0?f[ga>>2]|0:ka&255)|0)==4){if(EEc(i,0,-1,390751,4)|0)break;ha=f[g+100>>2]|0;switch(ha|0){case 0:{ja=c+8|0;f[ja>>2]=f[ja>>2]|4096;ja=c+208|0;ia=f[ja>>2]|0;if(!ia){_=VDc(68)|0;BYa(_);f[ja>>2]=_;ma=_}else ma=ia;ia=ma+8|0;f[ia>>2]=f[ia>>2]|1;f[ma+16>>2]=0;la=fa;break h;break}case 1:{ia=c+8|0;f[ia>>2]=f[ia>>2]|4096;ia=c+208|0;_=f[ia>>2]|0;if(!_){ja=VDc(68)|0;BYa(ja);f[ia>>2]=ja;na=ja}else na=_;_=na+8|0;f[_>>2]=f[_>>2]|1;f[na+16>>2]=1;la=fa;break h;break}case 2:{_=c+8|0;f[_>>2]=f[_>>2]|4096;_=c+208|0;ja=f[_>>2]|0;if(!ja){ia=VDc(68)|0;BYa(ia);f[_>>2]=ia;oa=ia}else oa=ja;ja=oa+8|0;f[ja>>2]=f[ja>>2]|1;f[oa+16>>2]=2;la=fa;break h;break}default:{aKa(e,390497,390455,407,508580,0,1);ja=e+21|0;ia=e+32|0;while(1){if(!(b[ja>>0]|0))break;suc(H1(ia,390920,20)|0,ha)|0;bKa(e)}K1(e+24|0);la=0;break h}}}while(0);aKa(e,390497,390455,411,508580,0,1);ka=e+21|0;ha=e+32|0;while(1){if(!(b[ka>>0]|0))break;ia=H1(ha,390941,38)|0;ja=b[da>>0]|0;_=ja<<24>>24<0;H1(ia,_?f[i>>2]|0:i,_?f[ga>>2]|0:ja&255)|0;bKa(e)}K1(e+24|0);la=0}while(0);i:do if(!(f[h>>2]&67108864))pa=la;else{fa=i+11|0;oa=b[fa>>0]|0;na=i+4|0;do if(((oa<<24>>24<0?f[na>>2]|0:oa&255)|0)==7){if(EEc(i,0,-1,390980,7)|0)break;ma=c+8|0;f[ma>>2]=f[ma>>2]|32;ma=c+180|0;ga=f[ma>>2]|0;if(!ga){da=VDc(24)|0;rYa(da);f[ma>>2]=da;qa=da}else qa=ga;ga=f[g+156>>2]|0;da=qa+8|0;f[da>>2]=f[da>>2]|1;f[qa+16>>2]=ga;pa=la;break i}while(0);aKa(e,390497,390455,420,508580,0,1);oa=e+21|0;ga=e+32|0;while(1){if(!(b[oa>>0]|0))break;da=H1(ga,390988,47)|0;ma=b[fa>>0]|0;ha=ma<<24>>24<0;H1(da,ha?f[i>>2]|0:i,ha?f[na>>2]|0:ma&255)|0;bKa(e)}K1(e+24|0);pa=0}while(0);j:do if(!(f[h>>2]&134217728))ra=pa;else{la=i+11|0;qa=b[la>>0]|0;na=i+4|0;do if(((qa<<24>>24<0?f[na>>2]|0:qa&255)|0)==3){if(EEc(i,0,-1,391036,3)|0)break;fa=c+8|0;f[fa>>2]=f[fa>>2]|2048;fa=c+204|0;ga=f[fa>>2]|0;if(!ga){oa=VDc(40)|0;zYa(oa);f[fa>>2]=oa;sa=oa}else sa=ga;ga=f[g+160>>2]|0;oa=sa+8|0;f[oa>>2]=f[oa>>2]|4;f[sa+24>>2]=ga;ra=pa;break j}while(0);aKa(e,390497,390455,429,508580,0,1);qa=e+21|0;ga=e+32|0;while(1){if(!(b[qa>>0]|0))break;oa=H1(ga,391040,44)|0;fa=b[la>>0]|0;ma=fa<<24>>24<0;H1(oa,ma?f[i>>2]|0:i,ma?f[na>>2]|0:fa&255)|0;bKa(e)}K1(e+24|0);ra=0}while(0);k:do if(!(f[h>>2]&268435456))ta=ra;else{pa=i+11|0;sa=b[pa>>0]|0;na=i+4|0;do if(((sa<<24>>24<0?f[na>>2]|0:sa&255)|0)==3){if(EEc(i,0,-1,391036,3)|0)break;la=c+8|0;f[la>>2]=f[la>>2]|2048;la=c+204|0;ga=f[la>>2]|0;if(!ga){qa=VDc(40)|0;zYa(qa);f[la>>2]=qa;ua=qa}else ua=ga;ga=f[g+164>>2]|0;qa=ua+8|0;f[qa>>2]=f[qa>>2]|8;f[ua+28>>2]=ga;ta=ra;break k}while(0);aKa(e,390497,390455,437,508580,0,1);sa=e+21|0;ga=e+32|0;while(1){if(!(b[sa>>0]|0))break;qa=H1(ga,391085,39)|0;la=b[pa>>0]|0;fa=la<<24>>24<0;H1(qa,fa?f[i>>2]|0:i,fa?f[na>>2]|0:la&255)|0;bKa(e)}K1(e+24|0);ta=0}while(0);ra=f[h>>2]|0;if(!(ra&536870912)){va=ta;wa=ra}else{ra=i+11|0;ua=b[ra>>0]|0;na=i+4|0;do if(((ua<<24>>24<0?f[na>>2]|0:ua&255)|0)==3){if(EEc(i,0,-1,391036,3)|0){xa=223;break}pa=c+8|0;f[pa>>2]=f[pa>>2]|2048;pa=c+204|0;ga=f[pa>>2]|0;if(!ga){sa=VDc(40)|0;zYa(sa);f[pa>>2]=sa;ya=sa}else ya=ga;ga=f[g+168>>2]|0;sa=ya+8|0;f[sa>>2]=f[sa>>2]|16;f[ya+32>>2]=ga;za=ta}else xa=223;while(0);if((xa|0)==223){aKa(e,390497,390455,445,508580,0,1);xa=e+21|0;ta=e+32|0;while(1){if(!(b[xa>>0]|0))break;ya=H1(ta,391125,38)|0;ua=b[ra>>0]|0;ga=ua<<24>>24<0;H1(ya,ga?f[i>>2]|0:i,ga?f[na>>2]|0:ua&255)|0;bKa(e)}K1(e+24|0);za=0}va=za;wa=f[h>>2]|0}l:do if((wa|0)<0){za=i+11|0;na=b[za>>0]|0;ra=i+4|0;do if(((na<<24>>24<0?f[ra>>2]|0:na&255)|0)==3){if(EEc(i,0,-1,391036,3)|0)break;ta=c+8|0;f[ta>>2]=f[ta>>2]|2048;ta=c+204|0;xa=f[ta>>2]|0;if(!xa){ua=VDc(40)|0;zYa(ua);f[ta>>2]=ua;Aa=ua}else Aa=xa;xa=f[g+176>>2]|0;ua=Aa+8|0;f[ua>>2]=f[ua>>2]|32;f[Aa+36>>2]=xa;Ba=va;break l}while(0);aKa(e,390497,390455,453,508580,0,1);na=e+21|0;xa=e+32|0;while(1){if(!(b[na>>0]|0))break;ua=H1(xa,391164,35)|0;ta=b[za>>0]|0;ga=ta<<24>>24<0;H1(ua,ga?f[i>>2]|0:i,ga?f[ra>>2]|0:ta&255)|0;bKa(e)}K1(e+24|0);Ba=0}else Ba=va;while(0);m:do if(!(f[h>>2]&4))Ca=Ba;else{va=i+11|0;Aa=b[va>>0]|0;wa=i+4|0;ra=f[wa>>2]|0;do if(((Aa<<24>>24<0?ra:Aa&255)|0)==4){if(EEc(i,0,-1,391200,4)|0){Da=b[va>>0]|0;Ea=f[wa>>2]|0;break}za=c+8|0;f[za>>2]=f[za>>2]|16;za=c+176|0;xa=f[za>>2]|0;if(!xa){na=VDc(52)|0;pYa(na);f[za>>2]=na;Fa=na}else Fa=xa;xa=f[g+64>>2]|0;na=Fa+8|0;f[na>>2]=f[na>>2]|1;na=Fa+16|0;za=f[na>>2]|0;if((za|0)==527320){GLa(na,xa);Ca=Ba;break m}else{iEc(za,xa)|0;Ca=Ba;break m}}else{Da=Aa;Ea=ra}while(0);do if(((Da<<24>>24<0?Ea:Da&255)|0)==9){if(EEc(i,0,-1,391205,9)|0){Ga=b[va>>0]|0;Ha=f[wa>>2]|0;break}ra=c+8|0;f[ra>>2]=f[ra>>2]|64;ra=c+184|0;Aa=f[ra>>2]|0;if(!Aa){xa=VDc(28)|0;sYa(xa);f[ra>>2]=xa;Ia=xa}else Ia=Aa;Aa=f[g+64>>2]|0;xa=Ia+8|0;f[xa>>2]=f[xa>>2]|1;xa=Ia+16|0;ra=f[xa>>2]|0;if((ra|0)==527320){GLa(xa,Aa);Ca=Ba;break m}else{iEc(ra,Aa)|0;Ca=Ba;break m}}else{Ga=Da;Ha=Ea}while(0);do if(((Ga<<24>>24<0?Ha:Ga&255)|0)==6){if(EEc(i,0,-1,391215,6)|0){Ja=b[va>>0]|0;Ka=f[wa>>2]|0;break}Aa=c+8|0;f[Aa>>2]=f[Aa>>2]|256;Aa=c+192|0;ra=f[Aa>>2]|0;if(!ra){xa=VDc(60)|0;uYa(xa);f[Aa>>2]=xa;La=xa}else La=ra;ra=f[g+64>>2]|0;xa=La+8|0;f[xa>>2]=f[xa>>2]|1;xa=La+16|0;Aa=f[xa>>2]|0;if((Aa|0)==527320){GLa(xa,ra);Ca=Ba;break m}else{iEc(Aa,ra)|0;Ca=Ba;break m}}else{Ja=Ga;Ka=Ha}while(0);do if(((Ja<<24>>24<0?Ka:Ja&255)|0)==11){if(EEc(i,0,-1,391222,11)|0){Ma=b[va>>0]|0;Na=f[wa>>2]|0;break}ra=c+8|0;f[ra>>2]=f[ra>>2]|8192;ra=c+212|0;Aa=f[ra>>2]|0;if(!Aa){xa=VDc(64)|0;DYa(xa);f[ra>>2]=xa;Oa=xa}else Oa=Aa;Aa=f[g+64>>2]|0;xa=Oa+8|0;f[xa>>2]=f[xa>>2]|1;xa=Oa+16|0;ra=f[xa>>2]|0;if((ra|0)==527320){GLa(xa,Aa);Ca=Ba;break m}else{iEc(ra,Aa)|0;Ca=Ba;break m}}else{Ma=Ja;Na=Ka}while(0);do if(((Ma<<24>>24<0?Na:Ma&255)|0)==13){if(EEc(i,0,-1,391234,13)|0)break;Aa=c+8|0;f[Aa>>2]=f[Aa>>2]|512;Aa=c+196|0;ra=f[Aa>>2]|0;if(!ra){xa=VDc(20)|0;wYa(xa);f[Aa>>2]=xa;Pa=xa}else Pa=ra;ra=f[g+64>>2]|0;xa=Pa+8|0;f[xa>>2]=f[xa>>2]|1;xa=Pa+16|0;Aa=f[xa>>2]|0;if((Aa|0)==527320){GLa(xa,ra);Ca=Ba;break m}else{iEc(Aa,ra)|0;Ca=Ba;break m}}while(0);aKa(e,390497,390455,473,508580,0,1);ra=e+21|0;Aa=e+32|0;while(1){if(!(b[ra>>0]|0))break;xa=H1(Aa,391248,40)|0;za=b[va>>0]|0;na=za<<24>>24<0;H1(xa,na?f[i>>2]|0:i,na?f[wa>>2]|0:za&255)|0;bKa(e)}K1(e+24|0);Ca=0}while(0);Ba=f[h>>2]|0;if(!(Ba&1073741824))Qa=Ba;else{Ba=c+8|0;f[Ba>>2]=f[Ba>>2]|33554432;Ba=c+260|0;Pa=f[Ba>>2]|0;if(!Pa){Ma=VDc(44)|0;TYa(Ma);f[Ba>>2]=Ma;Ra=Ma}else Ra=Pa;Pa=f[g+172>>2]|0;Ma=Ra+8|0;f[Ma>>2]=f[Ma>>2]|32;f[Ra+40>>2]=Pa;Qa=f[h>>2]|0}do if(Qa&8|0){Pa=c+8|0;f[Pa>>2]=f[Pa>>2]|33554432;Pa=c+260|0;Ra=f[Pa>>2]|0;if(!Ra){Ma=VDc(44)|0;TYa(Ma);f[Pa>>2]=Ma;Sa=Ma}else Sa=Ra;Ra=f[g+68>>2]|0;Ma=Sa+8|0;f[Ma>>2]=f[Ma>>2]|1;Ma=Sa+28|0;Pa=f[Ma>>2]|0;if((Pa|0)==527320){GLa(Ma,Ra);break}else{iEc(Pa,Ra)|0;break}}while(0);n:do if(!(f[h>>2]&4096))Ta=Ca;else{Sa=i+11|0;Qa=b[Sa>>0]|0;Ra=i+4|0;Pa=f[Ra>>2]|0;do if(((Qa<<24>>24<0?Pa:Qa&255)|0)==4){if(EEc(i,0,-1,391200,4)|0){Ua=b[Sa>>0]|0;Va=f[Ra>>2]|0;break}Ma=c+8|0;f[Ma>>2]=f[Ma>>2]|16;Ma=c+176|0;Ba=f[Ma>>2]|0;if(!Ba){Na=VDc(52)|0;pYa(Na);f[Ma>>2]=Na;Wa=Na}else Wa=Ba;Ba=f[g+104>>2]|0;Na=Wa+8|0;f[Na>>2]=f[Na>>2]|4;f[Wa+24>>2]=Ba;Ta=Ca;break n}else{Ua=Qa;Va=Pa}while(0);do if(((Ua<<24>>24<0?Va:Ua&255)|0)==9){if(EEc(i,0,-1,391205,9)|0){Xa=b[Sa>>0]|0;Ya=f[Ra>>2]|0;break}Pa=c+8|0;f[Pa>>2]=f[Pa>>2]|64;Pa=c+184|0;Qa=f[Pa>>2]|0;if(!Qa){Ba=VDc(28)|0;sYa(Ba);f[Pa>>2]=Ba;Za=Ba}else Za=Qa;Qa=f[g+104>>2]|0;Ba=Za+8|0;f[Ba>>2]=f[Ba>>2]|2;f[Za+20>>2]=Qa;Ta=Ca;break n}else{Xa=Ua;Ya=Va}while(0);do if(((Xa<<24>>24<0?Ya:Xa&255)|0)==6){if(EEc(i,0,-1,391215,6)|0){_a=b[Sa>>0]|0;$a=f[Ra>>2]|0;break}Qa=c+8|0;f[Qa>>2]=f[Qa>>2]|256;Qa=c+192|0;Ba=f[Qa>>2]|0;if(!Ba){Pa=VDc(60)|0;uYa(Pa);f[Qa>>2]=Pa;ab=Pa}else ab=Ba;Ba=f[g+104>>2]|0;Pa=ab+8|0;f[Pa>>2]=f[Pa>>2]|2048;f[ab+56>>2]=Ba;Ta=Ca;break n}else{_a=Xa;$a=Ya}while(0);do if(((_a<<24>>24<0?$a:_a&255)|0)==11){if(EEc(i,0,-1,391222,11)|0)break;Ba=c+8|0;f[Ba>>2]=f[Ba>>2]|8192;Ba=c+212|0;Pa=f[Ba>>2]|0;if(!Pa){Qa=VDc(64)|0;DYa(Qa);f[Ba>>2]=Qa;bb=Qa}else bb=Pa;Pa=f[g+104>>2]|0;Qa=bb+8|0;f[Qa>>2]=f[Qa>>2]|16;f[bb+32>>2]=Pa;Ta=Ca;break n}while(0);aKa(e,390497,390455,499,508580,0,1);Pa=e+21|0;Qa=e+32|0;while(1){if(!(b[Pa>>0]|0))break;Ba=H1(Qa,391289,43)|0;Na=b[Sa>>0]|0;Ma=Na<<24>>24<0;H1(Ba,Ma?f[i>>2]|0:i,Ma?f[Ra>>2]|0:Na&255)|0;bKa(e)}K1(e+24|0);Ta=0}while(0);Ca=f[h>>2]|0;if(!(Ca&8192))cb=Ca;else{Ca=c+8|0;f[Ca>>2]=f[Ca>>2]|33554432;Ca=c+260|0;bb=f[Ca>>2]|0;if(!bb){_a=VDc(44)|0;TYa(_a);f[Ca>>2]=_a;db=_a}else db=bb;bb=f[g+108>>2]|0;_a=db+8|0;f[_a>>2]=f[_a>>2]|2;f[db+32>>2]=bb;cb=f[h>>2]|0}if(!(cb&32768))eb=cb;else{cb=c+8|0;f[cb>>2]=f[cb>>2]|33554432;cb=c+260|0;bb=f[cb>>2]|0;if(!bb){db=VDc(44)|0;TYa(db);f[cb>>2]=db;fb=db}else fb=bb;bb=b[g+116>>0]|0;db=fb+8|0;f[db>>2]=f[db>>2]|4;b[fb+36>>0]=bb;eb=f[h>>2]|0}o:do if(!(eb&131072))gb=Ta;else{bb=i+11|0;fb=b[bb>>0]|0;db=i+4|0;cb=f[db>>2]|0;do if(((fb<<24>>24<0?cb:fb&255)|0)==4){if(EEc(i,0,-1,391200,4)|0){hb=b[bb>>0]|0;ib=f[db>>2]|0;break}_a=c+8|0;f[_a>>2]=f[_a>>2]|16;_a=c+176|0;Ca=f[_a>>2]|0;if(!Ca){$a=VDc(52)|0;pYa($a);f[_a>>2]=$a;jb=$a}else jb=Ca;Ca=f[g+120>>2]|0;$a=jb+8|0;f[$a>>2]=f[$a>>2]|16;f[jb+32>>2]=Ca;gb=Ta;break o}else{hb=fb;ib=cb}while(0);do if(((hb<<24>>24<0?ib:hb&255)|0)==6){if(EEc(i,0,-1,391215,6)|0)break;cb=c+8|0;f[cb>>2]=f[cb>>2]|256;cb=c+192|0;fb=f[cb>>2]|0;if(!fb){Ca=VDc(60)|0;uYa(Ca);f[cb>>2]=Ca;kb=Ca}else kb=fb;fb=f[g+120>>2]|0;Ca=kb+8|0;f[Ca>>2]=f[Ca>>2]|16;f[kb+32>>2]=fb;gb=Ta;break o}while(0);aKa(e,390497,390455,519,508580,0,1);fb=e+21|0;Ca=e+32|0;while(1){if(!(b[fb>>0]|0))break;cb=H1(Ca,391333,43)|0;$a=b[bb>>0]|0;_a=$a<<24>>24<0;H1(cb,_a?f[i>>2]|0:i,_a?f[db>>2]|0:$a&255)|0;bKa(e)}K1(e+24|0);gb=0}while(0);p:do if(!(f[h>>2]&65536))lb=gb;else{Ta=i+11|0;kb=b[Ta>>0]|0;hb=i+4|0;do if(((kb<<24>>24<0?f[hb>>2]|0:kb&255)|0)==6){if(EEc(i,0,-1,391215,6)|0)break;ib=c+8|0;f[ib>>2]=f[ib>>2]|256;ib=c+192|0;jb=f[ib>>2]|0;if(!jb){eb=VDc(60)|0;uYa(eb);f[ib>>2]=eb;mb=eb}else mb=jb;jb=b[g+117>>0]|0;eb=mb+8|0;f[eb>>2]=f[eb>>2]|32;b[mb+36>>0]=jb;lb=gb;break p}while(0);aKa(e,390497,390455,528,508580,0,1);kb=e+21|0;jb=e+32|0;while(1){if(!(b[kb>>0]|0))break;eb=H1(jb,391377,41)|0;ib=b[Ta>>0]|0;db=ib<<24>>24<0;H1(eb,db?f[i>>2]|0:i,db?f[hb>>2]|0:ib&255)|0;bKa(e)}K1(e+24|0);lb=0}while(0);q:do if(!(f[h>>2]&2097152))nb=lb;else{gb=i+11|0;mb=b[gb>>0]|0;hb=i+4|0;do if(((mb<<24>>24<0?f[hb>>2]|0:mb&255)|0)==6){if(EEc(i,0,-1,391215,6)|0)break;Ta=c+8|0;f[Ta>>2]=f[Ta>>2]|256;Ta=c+192|0;jb=f[Ta>>2]|0;if(!jb){kb=VDc(60)|0;uYa(kb);f[Ta>>2]=kb;ob=kb}else ob=jb;jb=f[g+136>>2]|0;kb=ob+8|0;f[kb>>2]=f[kb>>2]|128;f[ob+40>>2]=jb;nb=lb;break q}while(0);aKa(e,390497,390455,537,508580,0,1);mb=e+21|0;jb=e+32|0;while(1){if(!(b[mb>>0]|0))break;kb=H1(jb,391419,44)|0;Ta=b[gb>>0]|0;ib=Ta<<24>>24<0;H1(kb,ib?f[i>>2]|0:i,ib?f[hb>>2]|0:Ta&255)|0;bKa(e)}K1(e+24|0);nb=0}while(0);r:do if(!(f[h>>2]&16384))pb=nb;else{lb=i+11|0;ob=b[lb>>0]|0;hb=i+4|0;do if(((ob<<24>>24<0?f[hb>>2]|0:ob&255)|0)==6){if(EEc(i,0,-1,391215,6)|0)break;gb=c+8|0;f[gb>>2]=f[gb>>2]|256;gb=c+192|0;jb=f[gb>>2]|0;if(!jb){mb=VDc(60)|0;uYa(mb);f[gb>>2]=mb;qb=mb}else qb=jb;jb=f[g+112>>2]|0;mb=qb+8|0;f[mb>>2]=f[mb>>2]|256;f[qb+44>>2]=jb;pb=nb;break r}while(0);aKa(e,390497,390455,546,508580,0,1);ob=e+21|0;jb=e+32|0;while(1){if(!(b[ob>>0]|0))break;mb=H1(jb,391464,43)|0;gb=b[lb>>0]|0;Ta=gb<<24>>24<0;H1(mb,Ta?f[i>>2]|0:i,Ta?f[hb>>2]|0:gb&255)|0;bKa(e)}K1(e+24|0);pb=0}while(0);s:do if(!(f[h>>2]&4194304))rb=pb;else{nb=i+11|0;qb=b[nb>>0]|0;hb=i+4|0;do if(((qb<<24>>24<0?f[hb>>2]|0:qb&255)|0)==6){if(EEc(i,0,-1,391508,6)|0)break;lb=c+8|0;f[lb>>2]=f[lb>>2]|4;lb=c+168|0;jb=f[lb>>2]|0;if(!jb){ob=VDc(24)|0;mYa(ob);f[lb>>2]=ob;sb=ob}else sb=jb;jb=f[g+140>>2]|0;ob=sb+8|0;f[ob>>2]=f[ob>>2]|1;f[sb+16>>2]=jb;rb=pb;break s}while(0);aKa(e,390497,390455,555,508580,0,1);qb=e+21|0;jb=e+32|0;while(1){if(!(b[qb>>0]|0))break;ob=H1(jb,391515,44)|0;lb=b[nb>>0]|0;gb=lb<<24>>24<0;H1(ob,gb?f[i>>2]|0:i,gb?f[hb>>2]|0:lb&255)|0;bKa(e)}K1(e+24|0);rb=0}while(0);pb=g+12|0;t:do if(!(f[pb>>2]&1))tb=rb;else{sb=i+11|0;hb=b[sb>>0]|0;nb=i+4|0;do if(((hb<<24>>24<0?f[nb>>2]|0:hb&255)|0)==11){if(EEc(i,0,-1,391222,11)|0)break;jb=c+8|0;f[jb>>2]=f[jb>>2]|8192;jb=c+212|0;qb=f[jb>>2]|0;if(!qb){lb=VDc(64)|0;DYa(lb);f[jb>>2]=lb;ub=lb}else ub=qb;qb=f[g+180>>2]|0;lb=ub+8|0;f[lb>>2]=f[lb>>2]|1024;f[ub+52>>2]=qb;tb=rb;break t}while(0);aKa(e,390497,390455,564,508580,0,1);hb=e+21|0;qb=e+32|0;while(1){if(!(b[hb>>0]|0))break;lb=H1(qb,391560,50)|0;jb=b[sb>>0]|0;gb=jb<<24>>24<0;H1(lb,gb?f[i>>2]|0:i,gb?f[nb>>2]|0:jb&255)|0;bKa(e)}K1(e+24|0);tb=0}while(0);u:do if(!(f[pb>>2]&2))vb=tb;else{rb=i+11|0;ub=b[rb>>0]|0;nb=i+4|0;do if(((ub<<24>>24<0?f[nb>>2]|0:ub&255)|0)==11){if(EEc(i,0,-1,391222,11)|0)break;sb=c+8|0;f[sb>>2]=f[sb>>2]|8192;sb=c+212|0;qb=f[sb>>2]|0;if(!qb){hb=VDc(64)|0;DYa(hb);f[sb>>2]=hb;wb=hb}else wb=qb;qb=f[g+184>>2]|0;hb=wb+8|0;f[hb>>2]=f[hb>>2]|2048;f[wb+56>>2]=qb;vb=tb;break u}while(0);aKa(e,390497,390455,574,508580,0,1);ub=e+21|0;qb=e+32|0;while(1){if(!(b[ub>>0]|0))break;hb=H1(qb,391611,50)|0;sb=b[rb>>0]|0;jb=sb<<24>>24<0;H1(hb,jb?f[i>>2]|0:i,jb?f[nb>>2]|0:sb&255)|0;bKa(e)}K1(e+24|0);vb=0}while(0);v:do if(!(f[pb>>2]&4))xb=vb;else{tb=i+11|0;wb=b[tb>>0]|0;nb=i+4|0;do if(((wb<<24>>24<0?f[nb>>2]|0:wb&255)|0)==11){if(EEc(i,0,-1,391222,11)|0)break;rb=c+8|0;f[rb>>2]=f[rb>>2]|8192;rb=c+212|0;qb=f[rb>>2]|0;if(!qb){ub=VDc(64)|0;DYa(ub);f[rb>>2]=ub;yb=ub}else yb=qb;qb=f[g+188>>2]|0;ub=yb+8|0;f[ub>>2]=f[ub>>2]|4096;f[yb+60>>2]=qb;xb=vb;break v}while(0);aKa(e,390497,390455,584,508580,0,1);wb=e+21|0;qb=e+32|0;while(1){if(!(b[wb>>0]|0))break;ub=H1(qb,391662,49)|0;rb=b[tb>>0]|0;sb=rb<<24>>24<0;H1(ub,sb?f[i>>2]|0:i,sb?f[nb>>2]|0:rb&255)|0;bKa(e)}K1(e+24|0);xb=0}while(0);w:do if(!(f[h>>2]&262144))zb=xb;else{vb=i+11|0;yb=b[vb>>0]|0;pb=i+4|0;do if(((yb<<24>>24<0?f[pb>>2]|0:yb&255)|0)==11){if(EEc(i,0,-1,391222,11)|0)break;nb=c+8|0;f[nb>>2]=f[nb>>2]|8192;nb=c+212|0;tb=f[nb>>2]|0;if(!tb){qb=VDc(64)|0;DYa(qb);f[nb>>2]=qb;Ab=qb}else Ab=tb;tb=f[g+124>>2]|0;qb=Ab+8|0;f[qb>>2]=f[qb>>2]|256;f[Ab+44>>2]=tb;zb=xb;break w}while(0);aKa(e,390497,390455,594,508580,0,1);yb=e+21|0;tb=e+32|0;while(1){if(!(b[yb>>0]|0))break;qb=H1(tb,391712,49)|0;nb=b[vb>>0]|0;wb=nb<<24>>24<0;H1(qb,wb?f[i>>2]|0:i,wb?f[pb>>2]|0:nb&255)|0;bKa(e)}K1(e+24|0);zb=0}while(0);x:do if(!(f[h>>2]&16))Bb=zb;else{xb=i+11|0;Ab=b[xb>>0]|0;pb=i+4|0;do if(((Ab<<24>>24<0?f[pb>>2]|0:Ab&255)|0)==11){if(EEc(i,0,-1,391222,11)|0)break;vb=c+8|0;f[vb>>2]=f[vb>>2]|8192;vb=c+212|0;tb=f[vb>>2]|0;if(!tb){yb=VDc(64)|0;DYa(yb);f[vb>>2]=yb;Cb=yb}else Cb=tb;tb=f[g+72>>2]|0;yb=Cb+8|0;f[yb>>2]=f[yb>>2]|4;yb=Cb+24|0;vb=f[yb>>2]|0;if((vb|0)==525048){GLa(yb,tb);Bb=zb;break x}else{iEc(vb,tb)|0;Bb=zb;break x}}while(0);aKa(e,390497,390455,604,508580,0,1);Ab=e+21|0;tb=e+32|0;while(1){if(!(b[Ab>>0]|0))break;vb=H1(tb,391762,47)|0;yb=b[xb>>0]|0;nb=yb<<24>>24<0;H1(vb,nb?f[i>>2]|0:i,nb?f[pb>>2]|0:yb&255)|0;bKa(e)}K1(e+24|0);Bb=0}while(0);y:do if(!(f[h>>2]&128))Db=Bb;else{zb=i+11|0;Cb=b[zb>>0]|0;pb=i+4|0;do if(((Cb<<24>>24<0?f[pb>>2]|0:Cb&255)|0)==11){if(EEc(i,0,-1,391810,11)|0)break;xb=c+8|0;f[xb>>2]=f[xb>>2]|128;xb=c+188|0;tb=f[xb>>2]|0;if(!tb){Ab=VDc(20)|0;jXa(Ab);f[xb>>2]=Ab;Eb=Ab}else Eb=tb;tb=f[g+84>>2]|0;Ngb(Eb,tb|0?tb:523392);Db=Bb;break y}while(0);aKa(e,390497,390455,614,508580,0,1);Cb=e+21|0;tb=e+32|0;while(1){if(!(b[Cb>>0]|0))break;Ab=H1(tb,391822,51)|0;xb=b[zb>>0]|0;yb=xb<<24>>24<0;H1(Ab,yb?f[i>>2]|0:i,yb?f[pb>>2]|0:xb&255)|0;bKa(e)}K1(e+24|0);Db=0}while(0);l=(Db&1)!=0;u=d;return l|0}function JLa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=f[a+8>>2]|0;e=6}else{g=a+4|0;h=f[g>>2]|0;i=f[c>>2]|0;if((h|0)>=(i|0))if((i|0)==(f[a+8>>2]|0)){d=i;e=6;break}else{j=i;k=c;break}f[g>>2]=h+1;l=f[c+4+(h<<2)>>2]|0;return l|0}while(0);if((e|0)==6){USb(a,d+1|0);d=f[b>>2]|0;j=f[d>>2]|0;k=d}f[k>>2]=j+1;j=f[a>>2]|0;if(!j){d=VDc(12)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;m=d;n=k}else{if(f[j+64>>2]|0)OQb(j,4984,16);k=NQb(j,16,1733)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;m=k;n=f[b>>2]|0}b=a+4|0;a=f[b>>2]|0;f[b>>2]=a+1;f[n+4+(a<<2)>>2]=m;l=m;return l|0}function KLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<2;if(!i)k=VDc(d+4|0)|0;else{b=d+11&-8;if(f[i+64>>2]|0)OQb(i,23816,b);k=MQb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)dJc(k+4|0,g+4|0,j<<2|0)|0;if(h)return;if(f[g>>2]|0)return;YDc(g);return}function LLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;z5(a,b,c,390497,d);return}function MLa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;c=u;u=u+176|0;d=c;e=a+11|0;g=b[e>>0]|0;h=a+4|0;i=f[h>>2]|0;do if(((g<<24>>24<0?i:g&255)|0)==8)if(!(EEc(a,0,-1,391874,8)|0)){j=1;u=c;return j|0}else{k=b[e>>0]|0;l=f[h>>2]|0;break}else{k=g;l=i}while(0);do if(((k<<24>>24<0?l:k&255)|0)==4)if(!(EEc(a,0,-1,391883,4)|0)){j=2;u=c;return j|0}else{m=b[e>>0]|0;n=f[h>>2]|0;break}else{m=k;n=l}while(0);do if(((m<<24>>24<0?n:m&255)|0)==6)if(!(EEc(a,0,-1,391508,6)|0)){j=3;u=c;return j|0}else{o=b[e>>0]|0;p=f[h>>2]|0;break}else{o=m;p=n}while(0);do if(((o<<24>>24<0?p:o&255)|0)==4)if(!(EEc(a,0,-1,390479,4)|0)){j=4;u=c;return j|0}else{q=b[e>>0]|0;r=f[h>>2]|0;break}else{q=o;r=p}while(0);do if(((q<<24>>24<0?r:q&255)|0)==4)if(!(EEc(a,0,-1,391200,4)|0)){j=5;u=c;return j|0}else{s=b[e>>0]|0;t=f[h>>2]|0;break}else{s=q;t=r}while(0);do if(((s<<24>>24<0?t:s&255)|0)==7)if(!(EEc(a,0,-1,390980,7)|0)){j=6;u=c;return j|0}else{v=b[e>>0]|0;w=f[h>>2]|0;break}else{v=s;w=t}while(0);do if(((v<<24>>24<0?w:v&255)|0)==14)if(!(EEc(a,0,-1,391888,14)|0)){j=7;u=c;return j|0}else{x=b[e>>0]|0;y=f[h>>2]|0;break}else{x=v;y=w}while(0);do if(((x<<24>>24<0?y:x&255)|0)==7)if(!(EEc(a,0,-1,391903,7)|0)){j=8;u=c;return j|0}else{z=b[e>>0]|0;A=f[h>>2]|0;break}else{z=x;A=y}while(0);do if(((z<<24>>24<0?A:z&255)|0)==9)if(!(EEc(a,0,-1,391205,9)|0)){j=9;u=c;return j|0}else{B=b[e>>0]|0;C=f[h>>2]|0;break}else{B=z;C=A}while(0);do if(((B<<24>>24<0?C:B&255)|0)==11)if(!(EEc(a,0,-1,391810,11)|0)){j=10;u=c;return j|0}else{D=b[e>>0]|0;E=f[h>>2]|0;break}else{D=B;E=C}while(0);do if(((D<<24>>24<0?E:D&255)|0)==6)if(!(EEc(a,0,-1,391911,6)|0)){j=11;u=c;return j|0}else{F=b[e>>0]|0;G=f[h>>2]|0;break}else{F=D;G=E}while(0);do if(((F<<24>>24<0?G:F&255)|0)==6)if(!(EEc(a,0,-1,391215,6)|0)){j=12;u=c;return j|0}else{H=b[e>>0]|0;I=f[h>>2]|0;break}else{H=F;I=G}while(0);do if(((H<<24>>24<0?I:H&255)|0)==13)if(!(EEc(a,0,-1,391234,13)|0)){j=13;u=c;return j|0}else{J=b[e>>0]|0;K=f[h>>2]|0;break}else{J=H;K=I}while(0);do if(((J<<24>>24<0?K:J&255)|0)==12)if(!(EEc(a,0,-1,390484,12)|0)){j=14;u=c;return j|0}else{L=b[e>>0]|0;M=f[h>>2]|0;break}else{L=J;M=K}while(0);do if(((L<<24>>24<0?M:L&255)|0)==3)if(!(EEc(a,0,-1,391036,3)|0)){j=15;u=c;return j|0}else{N=b[e>>0]|0;O=f[h>>2]|0;break}else{N=L;O=M}while(0);do if(((N<<24>>24<0?O:N&255)|0)==25)if(!(EEc(a,0,-1,391918,25)|0)){j=16;u=c;return j|0}else{P=b[e>>0]|0;Q=f[h>>2]|0;break}else{P=N;Q=O}while(0);do if(((P<<24>>24<0?Q:P&255)|0)==4)if(!(EEc(a,0,-1,390751,4)|0)){j=17;u=c;return j|0}else{R=b[e>>0]|0;S=f[h>>2]|0;break}else{R=P;S=Q}while(0);do if(((R<<24>>24<0?S:R&255)|0)==4)if(!(EEc(a,0,-1,391944,4)|0)){j=18;u=c;return j|0}else{T=b[e>>0]|0;U=f[h>>2]|0;break}else{T=R;U=S}while(0);do if(((T<<24>>24<0?U:T&255)|0)==7)if(!(EEc(a,0,-1,391949,7)|0)){j=19;u=c;return j|0}else{V=b[e>>0]|0;W=f[h>>2]|0;break}else{V=T;W=U}while(0);do if(((V<<24>>24<0?W:V&255)|0)==7)if(!(EEc(a,0,-1,454214,7)|0)){j=20;u=c;return j|0}else{X=b[e>>0]|0;Y=f[h>>2]|0;break}else{X=V;Y=W}while(0);do if(((X<<24>>24<0?Y:X&255)|0)==12)if(!(EEc(a,0,-1,391957,12)|0)){j=21;u=c;return j|0}else{Z=b[e>>0]|0;_=f[h>>2]|0;break}else{Z=X;_=Y}while(0);do if(((Z<<24>>24<0?_:Z&255)|0)==5)if(!(EEc(a,0,-1,391970,5)|0)){j=22;u=c;return j|0}else{$=b[e>>0]|0;aa=f[h>>2]|0;break}else{$=Z;aa=_}while(0);do if((($<<24>>24<0?aa:$&255)|0)==4)if(!(EEc(a,0,-1,444266,4)|0)){j=23;u=c;return j|0}else{ba=b[e>>0]|0;ca=f[h>>2]|0;break}else{ba=$;ca=aa}while(0);do if(((ba<<24>>24<0?ca:ba&255)|0)==11){if(!(EEc(a,0,-1,391222,11)|0))j=24;else break;u=c;return j|0}while(0);aKa(d,390497,391976,673,508568,0,1);ba=d+21|0;ca=d+32|0;while(1){if(!(b[ba>>0]|0))break;aa=H1(ca,391995,20)|0;$=b[e>>0]|0;_=$<<24>>24<0;H1(aa,_?f[a>>2]|0:a,_?f[h>>2]|0:$&255)|0;bKa(d)}K1(d+24|0);j=0;u=c;return j|0}function NLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;f[d>>2]=f[b>>2];e=d+4|0;f[e>>2]=0;g=d+8|0;f[g>>2]=0;h=d+12|0;f[h>>2]=0;PLa(d,a);i=a+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[a+12>>2]|0;l=0;do{m=f[k+4+(l<<2)>>2]|0;l=l+1|0;Yi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((l|0)!=(j|0));f[i>>2]=0}PLa(a,b);a=b+4|0;i=f[a>>2]|0;j=b+12|0;if((i|0)>0){l=f[j>>2]|0;k=0;do{m=f[l+4+(k<<2)>>2]|0;k=k+1|0;Yi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((k|0)!=(i|0));f[a>>2]=0;n=0}else n=i;i=f[j>>2]|0;f[j>>2]=f[h>>2];f[h>>2]=i;f[a>>2]=f[e>>2];f[e>>2]=n;n=b+8|0;b=f[n>>2]|0;f[n>>2]=f[g>>2];f[g>>2]=b;b=i;if(!((i|0)!=0&(f[d>>2]|0)==0)){u=c;return}d=i;i=f[b>>2]|0;if((i|0)>0){g=0;do{n=f[b+4+(g<<2)>>2]|0;if(n|0)Yi[f[(f[n>>2]|0)+4>>2]&2047](n);g=g+1|0}while((g|0)!=(i|0));o=f[h>>2]|0}else o=d;YDc(o);u=c;return}function OLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<2;if(!i)k=VDc(d+4|0)|0;else{b=d+11&-8;if(f[i+64>>2]|0)OQb(i,23816,b);k=MQb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)dJc(k+4|0,g+4|0,j<<2|0)|0;if(h)return;if(f[g>>2]|0)return;YDc(g);return}function PLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{QLa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(108)|0;BXa(l);QLa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,15096,112);l=NQb(i,112,1739)|0;BXa(l);QLa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function QLa(a,b){a=a|0;b=b|0;RXa(b,a);return}function RLa(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function SLa(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function TLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=WLa(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=VDc(32)|0;fEc(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}laa(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function ULa(a,c){a=a|0;c=c|0;if(!c)return;ULa(a,f[c>>2]|0);ULa(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)YDc(f[a>>2]|0);YDc(c);return}function VLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=Arc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=Arc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function WLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=Arc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=Arc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function XLa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;b=u;u=u+64|0;c=b;d=a+20|0;if((f[d>>2]|0)<=0){e=0;u=b;return e|0}g=a+28|0;a=c+8|0;h=c+8|0;i=c+8|0;j=0;while(1){k=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;l=f[k+288>>2]|0;if((l|0)==5){m=f[k+176>>2]|0;xgb(c,m|0?m:522952);m=f[a>>2]|0;if(!(m&258))n=m&8|0?1:m>>>5&1;else n=1;V4a(c);if(n|0){e=1;o=18;break}m=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;p=f[m+288>>2]|0;q=m}else{p=l;q=k}if((p|0)==12){k=f[q+192>>2]|0;ygb(c,k|0?k:523440);k=f[h>>2]|0;if(!(k&1026))r=k&8|0?1:k>>>6&1;else r=1;_3a(c);if(r|0){e=1;o=18;break}k=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;s=f[k+288>>2]|0;t=k}else{s=p;t=q}if((s|0)==24){k=f[t+212>>2]|0;zgb(c,k|0?k:524208);k=f[i>>2]|0;if(!(k&514))v=k&32|0?1:k>>>6&1;else v=1;z2a(c);if(v|0){e=1;o=18;break}}j=j+1|0;if((j|0)>=(f[d>>2]|0)){e=0;o=18;break}}if((o|0)==18){u=b;return e|0}return 0}function YLa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=a+20|0;if((f[c>>2]|0)<=0)return;d=a+28|0;a=0;do{e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[e+288>>2]|0)==5){g=e+8|0;h=f[g>>2]|16;f[g>>2]=h;g=e+176|0;i=f[g>>2]|0;if(!i){j=VDc(52)|0;pYa(j);f[g>>2]=j;g=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;k=g;l=f[g+8>>2]|0;m=j}else{k=e;l=h;m=i}f[k+8>>2]=l|33554432;i=k+260|0;h=f[i>>2]|0;if(!h){e=VDc(44)|0;TYa(e);f[i>>2]=e;o=e}else o=h;h=m+8|0;e=f[h>>2]|0;if(!(e&256))p=e;else{e=m+44|0;i=f[e>>2]|0;j=o+8|0;f[j>>2]=f[j>>2]|32;f[o+40>>2]=i;n[e>>2]=1.0;e=f[h>>2]&-257;f[h>>2]=e;p=e}if(!(p&2))q=p;else{e=m+20|0;i=f[e>>2]|0;j=o+8|0;f[j>>2]=f[j>>2]|1;j=o+28|0;g=f[j>>2]|0;if((g|0)==527320)GLa(j,i);else iEc(g,i)|0;i=f[e>>2]|0;do if((i|0)!=527320){e=i+11|0;if((b[e>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[e>>0]=0;break}}while(0);i=f[h>>2]&-3;f[h>>2]=i;q=i}if(!(q&8))r=q;else{i=m+28|0;e=f[i>>2]|0;g=o+8|0;f[g>>2]=f[g>>2]|2;f[o+32>>2]=e;f[i>>2]=0;i=f[h>>2]&-9;f[h>>2]=i;r=i}if(r&32|0){i=m+36|0;e=b[i>>0]|0;g=o+8|0;f[g>>2]=f[g>>2]|4;b[o+36>>0]=e;b[i>>0]=0;f[h>>2]=f[h>>2]&-33}}i=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[i+288>>2]|0)==12){e=i+8|0;g=f[e>>2]|256;f[e>>2]=g;e=i+192|0;j=f[e>>2]|0;if(!j){s=VDc(60)|0;uYa(s);f[e>>2]=s;e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;t=s;u=e;v=f[e+8>>2]|0}else{t=j;u=i;v=g}f[u+8>>2]=v|33554432;g=u+260|0;i=f[g>>2]|0;if(!i){j=VDc(44)|0;TYa(j);f[g>>2]=j;w=j}else w=i;i=t+8|0;j=f[i>>2]|0;if(!(j&1024))x=j;else{j=t+52|0;g=f[j>>2]|0;e=w+8|0;f[e>>2]=f[e>>2]|32;f[w+40>>2]=g;n[j>>2]=1.0;j=f[i>>2]&-1025;f[i>>2]=j;x=j}if(!(x&2))y=x;else{j=t+20|0;g=f[j>>2]|0;e=w+8|0;f[e>>2]=f[e>>2]|1;e=w+28|0;s=f[e>>2]|0;if((s|0)==527320)GLa(e,g);else iEc(s,g)|0;g=f[j>>2]|0;do if((g|0)!=527320){j=g+11|0;if((b[j>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[j>>0]=0;break}}while(0);g=f[i>>2]&-3;f[i>>2]=g;y=g}if(!(y&8))z=y;else{g=t+28|0;h=f[g>>2]|0;j=w+8|0;f[j>>2]=f[j>>2]|2;f[w+32>>2]=h;f[g>>2]=0;g=f[i>>2]&-9;f[i>>2]=g;z=g}if(z&64|0){g=t+37|0;h=b[g>>0]|0;j=w+8|0;f[j>>2]=f[j>>2]|4;b[w+36>>0]=h;b[g>>0]=0;f[i>>2]=f[i>>2]&-65}}g=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[g+288>>2]|0)==24){h=g+8|0;j=f[h>>2]|8192;f[h>>2]=j;h=g+212|0;s=f[h>>2]|0;if(!s){e=VDc(64)|0;DYa(e);f[h>>2]=e;h=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;A=h;B=f[h+8>>2]|0;C=e}else{A=g;B=j;C=s}f[A+8>>2]=B|33554432;s=A+260|0;j=f[s>>2]|0;if(!j){g=VDc(44)|0;TYa(g);f[s>>2]=g;D=g}else D=j;j=C+8|0;g=f[j>>2]|0;if(!(g&512))E=g;else{g=C+48|0;s=f[g>>2]|0;e=D+8|0;f[e>>2]=f[e>>2]|32;f[D+40>>2]=s;n[g>>2]=1.0;g=f[j>>2]&-513;f[j>>2]=g;E=g}if(!(E&2))F=E;else{g=C+20|0;s=f[g>>2]|0;e=D+8|0;f[e>>2]=f[e>>2]|1;e=D+28|0;h=f[e>>2]|0;if((h|0)==527320)GLa(e,s);else iEc(h,s)|0;s=f[g>>2]|0;do if((s|0)!=527320){g=s+11|0;if((b[g>>0]|0)<0){b[f[s>>2]>>0]=0;f[s+4>>2]=0;break}else{b[s>>0]=0;b[g>>0]=0;break}}while(0);s=f[j>>2]&-3;f[j>>2]=s;F=s}if(!(F&32))G=F;else{s=C+36|0;i=f[s>>2]|0;g=D+8|0;f[g>>2]=f[g>>2]|2;f[D+32>>2]=i;f[s>>2]=0;s=f[j>>2]&-33;f[j>>2]=s;G=s}if(G&64|0){s=C+40|0;i=b[s>>0]|0;g=D+8|0;f[g>>2]=f[g>>2]|4;b[D+36>>0]=i;b[s>>0]=0;f[j>>2]=f[j>>2]&-65}}a=a+1|0}while((a|0)<(f[c>>2]|0));return}function ZLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+336|0;e=d+168|0;g=d;h=c+20|0;i=f[h>>2]|0;a:do if((i|0)>0){j=f[c+28>>2]|0;k=0;while(1){if(f[(f[j+4+(k<<2)>>2]|0)+8>>2]&2|0)break;k=k+1|0;if((k|0)>=(i|0)){l=1;break a}}aKa(e,390497,392429,744,508580,0,1);k=e+21|0;j=e+32|0;m=a+11|0;n=a+4|0;while(1){if(!(b[k>>0]|0))break;o=H1(H1(j,392448,60)|0,392509,18)|0;p=b[m>>0]|0;q=p<<24>>24<0;H1(o,q?f[a>>2]|0:a,q?f[n>>2]|0:p&255)|0;bKa(e)}K1(e+24|0);tgb(e,c);if(ELa(e,c)|0){aKa(g,390497,392429,752,508628,0,1);n=g+21|0;m=g+32|0;while(1){if(!(b[n>>0]|0))break;H1(H1(m,392636,54)|0,392691,16)|0;bKa(g)}K1(g+24|0);r=1}else{aKa(g,390497,392429,749,508580,0,1);m=g+21|0;n=g+32|0;while(1){if(!(b[m>>0]|0))break;H1(H1(n,392528,44)|0,392573,62)|0;bKa(g)}K1(g+24|0);r=0}aKa(g,390497,392429,755,508580,0,1);n=g+21|0;m=g+32|0;while(1){if(!(b[n>>0]|0))break;H1(H1(H1(H1(m,392708,49)|0,392758,61)|0,392820,62)|0,392883,64)|0;bKa(g)}K1(g+24|0);lfb(e);l=r}else l=1;while(0);if(XLa(c)|0){aKa(e,390497,392429,762,508580,0,1);r=e+21|0;g=e+32|0;i=a+11|0;m=a+4|0;while(1){if(!(b[r>>0]|0))break;n=H1(H1(g,392448,60)|0,392948,27)|0;j=b[i>>0]|0;k=j<<24>>24<0;H1(n,k?f[a>>2]|0:a,k?f[m>>2]|0:j&255)|0;bKa(e)}K1(e+24|0);YLa(c);aKa(e,390497,392429,765,508628,0,1);m=e+21|0;i=e+32|0;while(1){if(!(b[m>>0]|0))break;H1(H1(i,392636,54)|0,392976,31)|0;bKa(e)}K1(e+24|0);aKa(e,390497,392429,767,508580,0,1);i=e+21|0;m=e+32|0;while(1){if(!(b[i>>0]|0))break;H1(H1(m,393008,50)|0,393059,51)|0;bKa(e)}K1(e+24|0)}do if((f[h>>2]|0)>0){aKa(e,390497,392429,771,508580,0,1);m=e+21|0;i=e+32|0;g=a+11|0;r=a+4|0;while(1){if(!(b[m>>0]|0))break;j=H1(H1(i,392448,60)|0,393111,18)|0;k=b[g>>0]|0;n=k<<24>>24<0;H1(j,n?f[a>>2]|0:a,n?f[r>>2]|0:k&255)|0;bKa(e)}K1(e+24|0);if(_La(c)|0){aKa(e,390497,392429,778,508628,0,1);r=e+21|0;g=e+32|0;while(1){if(!(b[r>>0]|0))break;H1(H1(g,392636,54)|0,393179,16)|0;bKa(e)}K1(e+24|0);s=l;break}else{aKa(e,390497,392429,775,508580,0,1);g=e+21|0;r=e+32|0;while(1){if(!(b[g>>0]|0))break;H1(H1(r,392528,44)|0,393130,48)|0;bKa(e)}K1(e+24|0);s=0;break}}else s=l;while(0);l=c+80|0;if((f[l>>2]|0)<=0){u=d;return s|0}h=c+88|0;r=0;while(1){g=f[(f[(f[h>>2]|0)+4+(r<<2)>>2]|0)+140>>2]|0;i=b[g+11>>0]|0;if((((i<<24>>24<0?f[g+4>>2]|0:i&255)|0)==9?(EEc(g,0,-1,454964,9)|0)==0:0)?(f[(f[(f[h>>2]|0)+4+(r<<2)>>2]|0)+64>>2]|0)==3:0)break;r=r+1|0;if((r|0)>=(f[l>>2]|0)){t=58;break}}if((t|0)==58){u=d;return s|0}aKa(e,390497,392429,784,508628,0,1);t=e+21|0;l=e+32|0;r=a+11|0;h=a+4|0;while(1){if(!(b[t>>0]|0))break;g=H1(H1(l,393196,57)|0,393254,8)|0;i=b[r>>0]|0;m=i<<24>>24<0;H1(g,m?f[a>>2]|0:a,m?f[h>>2]|0:i&255)|0;bKa(e)}K1(e+24|0);$La(c);aKa(e,390497,392429,787,508628,0,1);c=e+21|0;h=e+32|0;while(1){if(!(b[c>>0]|0))break;H1(H1(h,393263,57)|0,393321,7)|0;bKa(e)}K1(e+24|0);u=d;return s|0}function _La(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=u;u=u+176|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=tT(d,17)|0;g=393329;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));LLa(-215,d,393347,795)}g=a+80|0;if((f[g>>2]|0)>0){aKa(d,390497,393347,798,508580,0,1);e=d+21|0;h=d+32|0;while(1){if(!(b[e>>0]|0))break;H1(H1(h,393360,60)|0,393421,46)|0;bKa(d)}K1(d+24|0);h=f[g>>2]|0;if((h|0)>0){e=f[a+88>>2]|0;i=0;do{j=f[e+4+(i<<2)>>2]|0;i=i+1|0;Yi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((i|0)!=(h|0));f[g>>2]=0;k=0}else k=0}else k=1;h=a+20|0;if((f[h>>2]|0)<=0){l=k;u=c;return l|0}i=a+28|0;e=a+76|0;j=a+88|0;m=a+84|0;n=d+21|0;o=d+32|0;p=d+24|0;q=0;r=k;while(1){k=f[(f[i>>2]|0)+4+(q<<2)>>2]|0;s=f[j>>2]|0;do if(s){t=f[g>>2]|0;v=f[s>>2]|0;if((t|0)>=(v|0))if((v|0)==(f[m>>2]|0)){w=v;x=23;break}else{y=v;z=s;x=24;break}else{f[g>>2]=t+1;A=f[s+4+(t<<2)>>2]|0;break}}else{w=f[m>>2]|0;x=23}while(0);if((x|0)==23){x=0;USb(e,w+1|0);s=f[j>>2]|0;y=f[s>>2]|0;z=s;x=24}if((x|0)==24){x=0;f[z>>2]=y+1;s=f[e>>2]|0;if(!s){t=VDc(368)|0;deb(t);B=t}else{if(f[s+64>>2]|0)OQb(s,15896,368);t=NQb(s,368,1740)|0;deb(t);B=t}t=f[j>>2]|0;s=f[g>>2]|0;f[g>>2]=s+1;f[t+4+(s<<2)>>2]=B;A=B}if(bMa(k,A)|0)C=r;else{aKa(d,390497,393347,806,508580,0,1);while(1){if(!(b[n>>0]|0))break;H1(suc(H1(o,393468,23)|0,q)|0,393492,8)|0;bKa(d)}K1(p);C=0}q=q+1|0;D=f[h>>2]|0;if((q|0)>=(D|0))break;else r=C}if((D|0)<=0){l=C;u=c;return l|0}r=f[a+28>>2]|0;a=0;do{q=f[r+4+(a<<2)>>2]|0;a=a+1|0;Yi[f[(f[q>>2]|0)+28>>2]&2047](q)}while((a|0)!=(D|0));f[h>>2]=0;l=C;u=c;return l|0}function $La(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+80|0;if((f[c>>2]|0)<=0)return;d=a+88|0;a=0;do{e=f[(f[(f[d>>2]|0)+4+(a<<2)>>2]|0)+140>>2]|0;g=b[e+11>>0]|0;if((((g<<24>>24<0?f[e+4>>2]|0:g&255)|0)==9?(EEc(e,0,-1,454964,9)|0)==0:0)?(e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0,g=e+64|0,(f[g>>2]|0)==3):0){h=f[e+72>>2]|0;e=f[h+4>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e);e=f[h+8>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e);e=f[h+12>>2]|0;Yi[f[(f[e>>2]|0)+28>>2]&2047](e);f[g>>2]=0}a=a+1|0}while((a|0)<(f[c>>2]|0));return}function aMa(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function bMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;d=u;u=u+176|0;e=d;g=d+8|0;if(!a){f[g>>2]=0;f[g+4>>2]=0;h=tT(g,23)|0;i=393501;j=h+23|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));LLa(-215,g,393525,839)}Yi[f[(f[c>>2]|0)+28>>2]&2047](c);i=a+20|0;if((f[i>>2]|0)>0){h=a+28|0;j=c+16|0;k=0;do{l=f[(f[h>>2]|0)+4+(k<<2)>>2]|0;iEc(JLa(j)|0,l)|0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=a+36|0;if((f[i>>2]|0)>0){k=a+44|0;j=c+32|0;h=0;do{l=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;iEc(JLa(j)|0,l)|0;h=h+1|0}while((h|0)<(f[i>>2]|0))}i=a+8|0;do if(f[i>>2]&1|0){h=f[a+160>>2]|0;j=c+8|0;f[j>>2]=f[j>>2]|1;j=c+136|0;k=f[j>>2]|0;if((k|0)==527320){GLa(j,h);break}else{iEc(k,h)|0;break}}while(0);h=a+92|0;if((f[h>>2]|0)>0){k=c+92|0;j=a+100|0;l=0;do{m=cMa(k)|0;wgb(m,f[(f[j>>2]|0)+4+(l<<2)>>2]|0);l=l+1|0}while((l|0)<(f[h>>2]|0))}h=a+108|0;if((f[h>>2]|0)>0){l=c+108|0;j=a+116|0;k=0;do{m=cMa(l)|0;wgb(m,f[(f[j>>2]|0)+4+(k<<2)>>2]|0);k=k+1|0}while((k|0)<(f[h>>2]|0))}if(f[a+12>>2]&1|0)eMa(c,dMa(f[a+288>>2]|0)|0);h=c+76|0;k=a+48|0;do if((h|0)!=(k|0))if((f[k>>2]|0)==(f[h>>2]|0)){j=c+88|0;l=a+60|0;m=f[j>>2]|0;f[j>>2]=f[l>>2];f[l>>2]=m;m=c+80|0;l=a+52|0;j=f[m>>2]|0;f[m>>2]=f[l>>2];f[l>>2]=j;j=c+84|0;l=a+56|0;m=f[j>>2]|0;f[j>>2]=f[l>>2];f[l>>2]=m;break}else{NLa(h,k);break}while(0);k=a+136|0;if((f[k>>2]|0)>0){h=c+64|0;m=c+72|0;l=a+144|0;j=0;do{if((f[h>>2]|0)<=(j|0))do fMa(c)|0;while((f[h>>2]|0)<=(j|0));n=f[(f[m>>2]|0)+4+(j<<2)>>2]|0;o=f[(f[l>>2]|0)+4+(j<<2)>>2]|0;p=n+8|0;f[p>>2]=f[p>>2]|1;p=n+16|0;n=f[p>>2]|0;if((n|0)==527320)GLa(p,o);else iEc(n,o)|0;j=j+1|0}while((j|0)<(f[k>>2]|0))}k=a+148|0;a:do if((f[k>>2]|0)>0){j=c+64|0;l=a+156|0;m=c+72|0;h=0;while(1){if((f[j>>2]|0)<=(h|0))do fMa(c)|0;while((f[j>>2]|0)<=(h|0));o=f[(f[l>>2]|0)+4+(h<<2)>>2]|0;if(o>>>0>=2)break;n=f[(f[m>>2]|0)+4+(h<<2)>>2]|0;p=n+8|0;f[p>>2]=f[p>>2]|2;f[n+20>>2]=o;o=h+1|0;if((o|0)<(f[k>>2]|0))h=o;else break a}aKa(g,390497,393525,877,508568,0,1);m=g+21|0;j=g+32|0;while(1){if(!(b[m>>0]|0))break;o=H1(j,393577,25)|0;suc(o,f[(f[l>>2]|0)+4+(h<<2)>>2]|0)|0;bKa(g)}K1(g+24|0);f[e>>2]=f[(f[l>>2]|0)+4+(h<<2)>>2];F5(g,393549,e);LLa(-2,g,393525,879)}while(0);e=a+64|0;if((f[e>>2]|0)>0){k=c+64|0;j=c+72|0;m=a+72|0;o=0;do{if((f[k>>2]|0)<=(o|0))do fMa(c)|0;while((f[k>>2]|0)<=(o|0));h=f[(f[j>>2]|0)+4+(o<<2)>>2]|0;l=f[(f[m>>2]|0)+4+(o<<2)>>2]|0;n=h+8|0;f[n>>2]=f[n>>2]|4;f[h+24>>2]=l;o=o+1|0}while((o|0)<(f[e>>2]|0))}e=a+76|0;if((f[e>>2]|0)>0){o=c+64|0;m=c+72|0;j=a+84|0;k=0;do{if((f[o>>2]|0)<=(k|0))do fMa(c)|0;while((f[o>>2]|0)<=(k|0));l=f[(f[m>>2]|0)+4+(k<<2)>>2]|0;h=f[(f[j>>2]|0)+4+(k<<2)>>2]|0;n=l+8|0;f[n>>2]=f[n>>2]|8;f[l+28>>2]=h;k=k+1|0}while((k|0)<(f[e>>2]|0))}e=a+120|0;if((f[e>>2]|0)>0){k=a+128|0;j=c+48|0;m=c+52|0;o=c+56|0;h=0;l=f[j>>2]|0;do{n=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;if((l|0)==(f[m>>2]|0)){SHa(j,l+1|0);q=f[j>>2]|0}else q=l;p=f[o>>2]|0;l=q+1|0;f[j>>2]=l;f[p+4+(q<<2)>>2]=n;h=h+1|0}while((h|0)<(f[e>>2]|0))}e=f[i>>2]|0;if(!(e&1048576))r=e;else{e=c+8|0;f[e>>2]=f[e>>2]|16;e=c+152|0;h=f[e>>2]|0;if(!h){q=VDc(28)|0;NYa(q);f[e>>2]=q;s=q}else s=h;h=f[a+240>>2]|0;Cgb(s,h|0?h:522624);r=f[i>>2]|0}if(!(r&65536))t=r;else{r=c+8|0;f[r>>2]=f[r>>2]|32;r=c+156|0;h=f[r>>2]|0;if(!h){s=VDc(28)|0;HYa(s);f[r>>2]=s;v=s}else v=h;h=f[a+224>>2]|0;Dgb(v,h|0?h:522656);t=f[i>>2]|0}if(!(t&4))w=t;else{t=c+8|0;f[t>>2]=f[t>>2]|64;t=c+160|0;h=f[t>>2]|0;if(!h){v=VDc(24)|0;mYa(v);f[t>>2]=v;x=v}else x=h;h=f[a+168>>2]|0;Egb(x,h|0?h:522688);w=f[i>>2]|0}if(!(w&536870912))y=w;else{w=c+8|0;f[w>>2]=f[w>>2]|128;w=c+164|0;h=f[w>>2]|0;if(!h){x=VDc(24)|0;YYa(x);f[w>>2]=x;z=x}else z=h;h=f[a+276>>2]|0;Fgb(z,h|0?h:522776);y=f[i>>2]|0}if(!(y&8))A=y;else{y=c+8|0;f[y>>2]=f[y>>2]|256;y=c+168|0;h=f[y>>2]|0;if(!h){z=VDc(120)|0;nYa(z);f[y>>2]=z;B=z}else B=h;h=f[a+172>>2]|0;Ggb(B,h|0?h:522800);A=f[i>>2]|0}if(!(A&16))C=A;else{A=c+8|0;f[A>>2]=f[A>>2]|512;A=c+172|0;h=f[A>>2]|0;if(!h){B=VDc(52)|0;pYa(B);f[A>>2]=B;D=B}else D=h;h=f[a+176>>2]|0;Hgb(D,h|0?h:522952);C=f[i>>2]|0}if(!(C&32))E=C;else{C=c+8|0;f[C>>2]=f[C>>2]|1024;C=c+176|0;h=f[C>>2]|0;if(!h){D=VDc(24)|0;rYa(D);f[C>>2]=D;F=D}else F=h;h=f[a+180>>2]|0;Igb(F,h|0?h:523080);E=f[i>>2]|0}if(!(E&524288))G=E;else{E=c+8|0;f[E>>2]=f[E>>2]|2048;E=c+180|0;h=f[E>>2]|0;if(!h){F=VDc(96)|0;LYa(F);f[E>>2]=F;H=F}else H=h;h=f[a+236>>2]|0;Jgb(H,h|0?h:523104);G=f[i>>2]|0}if(!(G&131072))I=G;else{G=c+8|0;f[G>>2]=f[G>>2]|4096;G=c+184|0;h=f[G>>2]|0;if(!h){H=VDc(36)|0;IYa(H);f[G>>2]=H;J=H}else J=h;h=f[a+228>>2]|0;Kgb(J,h|0?h:523200);I=f[i>>2]|0}if(!(I&1073741824))K=I;else{I=c+8|0;f[I>>2]=f[I>>2]|8192;I=c+188|0;h=f[I>>2]|0;if(!h){J=VDc(28)|0;ZYa(J);f[I>>2]=J;L=J}else L=h;h=f[a+280>>2]|0;Lgb(L,h|0?h:523304);K=f[i>>2]|0}if(!(K&64))M=K;else{K=c+8|0;f[K>>2]=f[K>>2]|16384;K=c+192|0;h=f[K>>2]|0;if(!h){L=VDc(28)|0;sYa(L);f[K>>2]=L;N=L}else N=h;h=f[a+184>>2]|0;Mgb(N,h|0?h:523360);M=f[i>>2]|0}if(!(M&128))O=M;else{M=c+8|0;f[M>>2]=f[M>>2]|32768;M=c+196|0;h=f[M>>2]|0;if(!h){N=VDc(20)|0;jXa(N);f[M>>2]=N;P=N}else P=h;h=f[a+188>>2]|0;Ngb(P,h|0?h:523392);O=f[i>>2]|0}if(!(O&2097152))Q=O;else{O=c+8|0;f[O>>2]=f[O>>2]|65536;O=c+200|0;h=f[O>>2]|0;if(!h){P=VDc(20)|0;OYa(P);f[O>>2]=P;R=P}else R=h;h=f[a+244>>2]|0;Ogb(R,h|0?h:523416);Q=f[i>>2]|0}if(!(Q&256))S=Q;else{Q=c+8|0;f[Q>>2]=f[Q>>2]|131072;Q=c+204|0;h=f[Q>>2]|0;if(!h){R=VDc(60)|0;uYa(R);f[Q>>2]=R;T=R}else T=h;h=f[a+192>>2]|0;Pgb(T,h|0?h:523440);S=f[i>>2]|0}if(!(S&512))U=S;else{S=c+8|0;f[S>>2]=f[S>>2]|262144;S=c+208|0;h=f[S>>2]|0;if(!h){T=VDc(20)|0;wYa(T);f[S>>2]=T;V=T}else V=h;h=f[a+196>>2]|0;Qgb(V,h|0?h:523504);U=f[i>>2]|0}if(!(U&1024))W=U;else{U=c+8|0;f[U>>2]=f[U>>2]|524288;U=c+212|0;h=f[U>>2]|0;if(!h){V=VDc(36)|0;xYa(V);f[U>>2]=V;X=V}else X=h;h=f[a+200>>2]|0;Rgb(X,h|0?h:523528);W=f[i>>2]|0}if(!(W&2048))Y=W;else{W=c+8|0;f[W>>2]=f[W>>2]|1048576;W=c+216|0;h=f[W>>2]|0;if(!h){X=VDc(40)|0;zYa(X);f[W>>2]=X;Z=X}else Z=h;h=f[a+204>>2]|0;Sgb(Z,h|0?h:523632);Y=f[i>>2]|0}if(!(Y&32768))_=Y;else{Y=c+8|0;f[Y>>2]=f[Y>>2]|2097152;Y=c+220|0;h=f[Y>>2]|0;if(!h){Z=VDc(32)|0;GYa(Z);f[Y>>2]=Z;$=Z}else $=h;h=f[a+220>>2]|0;Tgb($,h|0?h:523672);_=f[i>>2]|0}if(!(_&16777216))aa=_;else{_=c+8|0;f[_>>2]=f[_>>2]|4194304;_=c+224|0;h=f[_>>2]|0;if(!h){$=VDc(24)|0;SYa($);f[_>>2]=$;ba=$}else ba=h;h=f[a+256>>2]|0;Ugb(ba,h|0?h:523704);aa=f[i>>2]|0}if(!(aa&4096))ca=aa;else{aa=c+8|0;f[aa>>2]=f[aa>>2]|8388608;aa=c+228|0;h=f[aa>>2]|0;if(!h){ba=VDc(68)|0;BYa(ba);f[aa>>2]=ba;da=ba}else da=h;h=f[a+208>>2]|0;Vgb(da,h|0?h:523752);ca=f[i>>2]|0}if(!(ca&16384))ea=ca;else{ca=c+8|0;f[ca>>2]=f[ca>>2]|16777216;ca=c+232|0;h=f[ca>>2]|0;if(!h){da=VDc(28)|0;FYa(da);f[ca>>2]=da;fa=da}else fa=h;h=f[a+216>>2]|0;Wgb(fa,h|0?h:523824);ea=f[i>>2]|0}if(!(ea&4194304))ga=ea;else{ea=c+8|0;f[ea>>2]=f[ea>>2]|33554432;ea=c+236|0;h=f[ea>>2]|0;if(!h){fa=VDc(24)|0;PYa(fa);f[ea>>2]=fa;ha=fa}else ha=h;h=f[a+248>>2]|0;Xgb(ha,h|0?h:523952);ga=f[i>>2]|0}if(!(ga&134217728))ia=ga;else{ga=c+8|0;f[ga>>2]=f[ga>>2]|67108864;ga=c+240|0;h=f[ga>>2]|0;if(!h){ha=VDc(20)|0;WYa(ha);f[ga>>2]=ha;ja=ha}else ja=h;h=f[a+268>>2]|0;Ygb(ja,h|0?h:524048);ia=f[i>>2]|0}if(!(ia&268435456))ka=ia;else{ia=c+8|0;f[ia>>2]=f[ia>>2]|134217728;ia=c+244|0;h=f[ia>>2]|0;if(!h){ja=VDc(24)|0;XYa(ja);f[ia>>2]=ja;la=ja}else la=h;h=f[a+272>>2]|0;_gb(la,h|0?h:524112);ka=f[i>>2]|0}if(!(ka&8388608))ma=ka;else{ka=c+8|0;f[ka>>2]=f[ka>>2]|268435456;ka=c+248|0;h=f[ka>>2]|0;if(!h){la=VDc(36)|0;QYa(la);f[ka>>2]=la;na=la}else na=h;h=f[a+252>>2]|0;Zgb(na,h|0?h:524072);ma=f[i>>2]|0}if(!(ma&67108864))oa=ma;else{ma=c+8|0;f[ma>>2]=f[ma>>2]|536870912;ma=c+252|0;h=f[ma>>2]|0;if(!h){na=VDc(20)|0;VYa(na);f[ma>>2]=na;pa=na}else pa=h;h=f[a+264>>2]|0;$gb(pa,h|0?h:524136);oa=f[i>>2]|0}if(!(oa&262144))qa=oa;else{oa=c+8|0;f[oa>>2]=f[oa>>2]|1073741824;oa=c+256|0;h=f[oa>>2]|0;if(!h){pa=VDc(20)|0;KYa(pa);f[oa>>2]=pa;ra=pa}else ra=h;h=f[a+232>>2]|0;ahb(ra,h|0?h:524184);qa=f[i>>2]|0}if(!(qa&8192))sa=qa;else{qa=c+8|0;f[qa>>2]=f[qa>>2]|-2147483648;qa=c+260|0;h=f[qa>>2]|0;if(!h){ra=VDc(64)|0;DYa(ra);f[qa>>2]=ra;ta=ra}else ta=h;h=f[a+212>>2]|0;bhb(ta,h|0?h:524208);sa=f[i>>2]|0}if(!(sa&33554432))ua=sa;else{sa=c+8|0;f[sa>>2]=f[sa>>2]|4;sa=c+144|0;h=f[sa>>2]|0;if(!h){ta=VDc(44)|0;TYa(ta);f[sa>>2]=ta;va=ta}else va=h;h=f[a+260>>2]|0;Agb(va,h|0?h:522544);ua=f[i>>2]|0}if((ua|0)<0){h=c+8|0;f[h>>2]=f[h>>2]|8;h=c+148|0;c=f[h>>2]|0;if(!c){va=VDc(28)|0;_Ya(va);f[h>>2]=va;wa=va}else wa=c;c=f[a+284>>2]|0;Bgb(wa,c|0?c:522592);xa=f[i>>2]|0}else xa=ua;if(!(xa&2)){ya=1;u=d;return ya|0}aKa(g,390497,393525,1016,508580,0,1);xa=g+21|0;ua=g+32|0;while(1){if(!(b[xa>>0]|0))break;H1(ua,393603,44)|0;bKa(g)}K1(g+24|0);ya=0;u=d;return ya|0}function cMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){USb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=VDc(60)|0;P5a(a);o=a}else{if(f[l+64>>2]|0)OQb(l,15592,64);a=NQb(l,64,1741)|0;P5a(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function dMa(a){a=a|0;var c=0,d=0,e=0,f=0,g=0;c=u;u=u+176|0;d=c;do switch(a|0){case 0:{e=1154740;break}case 35:{e=425667;break}case 1:{e=393928;break}case 30:{e=393921;break}case 2:{e=393916;break}case 3:{e=454781;break}case 37:{e=393900;break}case 4:{e=455045;break}case 39:{e=425570;break}case 5:{e=393895;break}case 6:{e=429297;break}case 32:{e=393885;break}case 7:{e=393871;break}case 25:{e=454641;break}case 38:{e=428169;break}case 8:{e=428347;break}case 9:{e=393862;break}case 10:{e=393851;break}case 28:{e=393841;break}case 11:{e=393834;break}case 12:{e=393824;break}case 13:{e=393811;break}case 14:{e=425612;break}case 15:{e=425608;break}case 29:{e=393800;break}case 16:{e=393776;break}case 34:{e=425625;break}case 17:{e=454888;break}case 26:{e=451285;break}case 18:{e=393771;break}case 19:{e=425655;break}case 27:{e=393747;break}case 36:{e=425684;break}case 20:{e=454837;break}case 21:{e=393731;break}case 22:{e=425543;break}case 33:{e=425537;break}case 23:{e=393726;break}case 24:{e=393715;break}case 31:{e=393705;break}default:{aKa(d,390497,393648,1105,508568,0,1);f=d+21|0;g=d+32|0;while(1){if(!(b[f>>0]|0))break;suc(H1(g,393667,37)|0,a)|0;bKa(d)}K1(d+24|0);e=1154740}}while(0);u=c;return e|0}function eMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+140|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=Mpc(c)|0;if(a>>>0>4294967279)dEc(e);if(a>>>0<11){b[e+11>>0]=a;if(!a)h=e;else{i=e;j=6}}else{k=a+16&-16;l=VDc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=a;i=l;j=6}if((j|0)==6){dJc(i|0,c|0,a|0)|0;h=i}b[h+a>>0]=0;a=f[g>>2]|0;if((a|0)==527320)GLa(g,e);else iEc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function fMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+60|0;c=a+72|0;d=f[c>>2]|0;do if(!d){e=a+64|0;g=f[a+68>>2]|0;h=6}else{i=a+64|0;j=f[i>>2]|0;k=f[d>>2]|0;if((j|0)>=(k|0))if((k|0)==(f[a+68>>2]|0)){e=i;g=k;h=6;break}else{l=i;m=k;n=d;break}f[i>>2]=j+1;o=f[d+4+(j<<2)>>2]|0;return o|0}while(0);if((h|0)==6){USb(b,g+1|0);g=f[c>>2]|0;l=e;m=f[g>>2]|0;n=g}f[n>>2]=m+1;m=f[b>>2]|0;if(!m){b=VDc(32)|0;Ldb(b);p=b}else{if(f[m+64>>2]|0)OQb(m,15976,32);b=NQb(m,32,1742)|0;Ldb(b);p=b}b=f[c>>2]|0;c=f[l>>2]|0;f[l>>2]=c+1;f[b+4+(c<<2)>>2]=p;o=p;return o|0}function gMa(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function hMa(a){a=a|0;Yi[f[f[a>>2]>>2]&2047](a);return}function iMa(a,c){a=a|0;c=c|0;var e=0,g=0;e=u;u=u+64|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=a;a=g+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;d[a+12>>1]=0;f[g+28>>2]=2147483647;f[g+32>>2]=0;f[g+36>>2]=2147483647;a=f[40215]|0;f[g+40>>2]=a;f[g+44>>2]=a;b[g+48>>0]=1;f[g+52>>2]=0;f[g+56>>2]=0;JRb(g)|0;NRb(g,2147483647,536870912);a=ISb(c,g)|0;DRb(g);u=e;return a|0}function jMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+384|0;e=d+188|0;g=d;h=d+168|0;i=e+108|0;j=e+8|0;f[e>>2]=14524;f[i>>2]=14544;f[e+4>>2]=0;auc(e+108|0,j);f[e+180>>2]=0;f[e+184>>2]=-1;f[e>>2]=78612;f[i>>2]=78632;AIa(j);k=e+72|0;if((f[k>>2]|0)==0?(l=yqc(a,393937)|0,f[k>>2]=l,(l|0)!=0):0){f[e+96>>2]=8;m=l}else{l=e+(f[(f[e>>2]|0)+-12>>2]|0)|0;$tc(l,f[l+16>>2]|4);m=f[k>>2]|0}aKa(g,390497,393939,1121,392070,393961,(m|0)!=0);m=g+21|0;k=g+32|0;while(1){if(!(b[m>>0]|0))break;l=H1(k,393974,12)|0;H1(H1(l,a,Mpc(a)|0)|0,501908,1)|0;bKa(g)}K1(g+24|0);Acc(g,e,-1);Dic(h,1);a=Fic(h,g,c)|0;Eic(h);f[g>>2]=167096;uSb(g+16|0);xcc(g+4|0);f[e>>2]=78612;f[i>>2]=78632;BIa(j);Ctc(e,78644);Lsc(i);u=d;return a|0}function kMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+368|0;e=d+168|0;g=d;h=e+108|0;i=e+8|0;f[e>>2]=14524;f[h>>2]=14544;f[e+4>>2]=0;auc(e+108|0,i);f[e+180>>2]=0;f[e+184>>2]=-1;f[e>>2]=78612;f[h>>2]=78632;AIa(i);j=e+72|0;if((f[j>>2]|0)==0?(k=yqc(a,429489)|0,f[j>>2]=k,(k|0)!=0):0){f[e+96>>2]=12;l=k}else{k=e+(f[(f[e>>2]|0)+-12>>2]|0)|0;$tc(k,f[k+16>>2]|4);l=f[j>>2]|0}aKa(g,390497,393987,1132,392070,393961,(l|0)!=0);l=g+21|0;j=g+32|0;while(1){if(!(b[l>>0]|0))break;k=H1(j,393974,12)|0;H1(H1(k,a,Mpc(a)|0)|0,501908,1)|0;bKa(g)}K1(g+24|0);Acc(g,e,-1);a=iMa(g,c)|0;f[g>>2]=167096;uSb(g+16|0);xcc(g+4|0);f[e>>2]=78612;f[h>>2]=78632;BIa(i);Ctc(e,78644);Lsc(h);u=d;return a|0}function lMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;CSb(e,a,b,-1);b=ejc(e,c)|0;u=d;return b|0}function mMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;CSb(e,a,b,-1);b=iMa(e,c)|0;u=d;return b|0}function nMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+176|0;e=d;aKa(e,390497,394011,1151,392070,394042,jMa(a,c)|0);g=e+21|0;h=e+32|0;while(1){if(!(b[g>>0]|0))break;i=H1(h,394083,35)|0;H1(i,a,Mpc(a)|0)|0;bKa(e)}K1(e+24|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=Mpc(a)|0;if(h>>>0>4294967279)dEc(e);if(h>>>0<11){b[e+11>>0]=h;if(!h)j=e;else{k=e;l=8}}else{g=h+16&-16;i=VDc(g)|0;f[e>>2]=i;f[e+8>>2]=g|-2147483648;f[e+4>>2]=h;k=i;l=8}if((l|0)==8){dJc(k|0,a|0,h|0)|0;j=k}b[j+h>>0]=0;ZLa(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function oMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+192|0;g=e+168|0;h=e;CSb(g,a,c,-1);aKa(h,390497,394119,1158,392070,394152,ejc(g,d)|0);c=h+21|0;a=h+32|0;while(1){if(!(b[c>>0]|0))break;H1(a,394208,35)|0;bKa(h)}K1(h+24|0);h=VDc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=13;a=h;c=394194;i=a+13|0;do{b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(i|0));b[h+13>>0]=0;ZLa(g,d)|0;if((b[g+11>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function pMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+176|0;e=d;aKa(e,390497,394244,1165,392070,394277,kMa(a,c)|0);g=e+21|0;h=e+32|0;while(1){if(!(b[g>>0]|0))break;i=H1(h,394083,35)|0;H1(i,a,Mpc(a)|0)|0;bKa(e)}K1(e+24|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=Mpc(a)|0;if(h>>>0>4294967279)dEc(e);if(h>>>0<11){b[e+11>>0]=h;if(!h)j=e;else{k=e;l=8}}else{g=h+16&-16;i=VDc(g)|0;f[e>>2]=i;f[e+8>>2]=g|-2147483648;f[e+4>>2]=h;k=i;l=8}if((l|0)==8){dJc(k|0,a|0,h|0)|0;j=k}b[j+h>>0]=0;ZLa(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return}YDc(f[e>>2]|0);u=d;return}function qMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+192|0;g=e+168|0;h=e;CSb(g,a,c,-1);aKa(h,390497,394320,1172,392070,394355,iMa(g,d)|0);c=h+21|0;a=h+32|0;while(1){if(!(b[c>>0]|0))break;H1(a,394208,35)|0;bKa(h)}K1(h+24|0);h=VDc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=13;a=h;c=394194;i=a+13|0;do{b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(i|0));b[h+13>>0]=0;ZLa(g,d)|0;if((b[g+11>>0]|0)>=0){u=e;return}YDc(f[g>>2]|0);u=e;return}function rMa(a,b){a=a|0;b=b|0;return}function sMa(){return 0}function tMa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=78924;c=a+116|0;d=f[c>>2]|0;if(d|0?(f[a+104>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+100|0;i=f[c>>2]|0;if(i|0?(f[a+88>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;YDc(j)}f[c>>2]=0;c=f[a+80>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+64>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+48>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+32>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+20|0;j=f[c>>2]|0;if(j|0?(f[a+8>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)YDc(f[e>>2]|0);YDc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;YDc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(k);f[c>>2]=0;return}function uMa(a){a=a|0;tMa(a);YDc(a);return}function vMa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function wMa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(124)|0;ENa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14600,128);a=MQb(b,128)|0;FNa(a,b);c=a;return c|0}function xMa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function yMa(a){a=a|0;return f[a+4>>2]|0}function zMa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+24>>2]=0;f[a+40>>2]=0;f[a+56>>2]=0;f[a+72>>2]=0;c=a+92|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+100>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((e|0)!=(d|0));f[c>>2]=0}c=a+108|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+116>>2]|0;g=0;do{i=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((g|0)!=(d|0));f[c>>2]=0}c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function AMa(a){a=a|0;return 1}function BMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+24|0;k=a+28|0;l=a+32|0;m=e+8|0;n=a+40|0;o=a+44|0;p=a+48|0;q=a+56|0;r=a+60|0;s=a+64|0;t=e+8|0;v=a+72|0;w=a+76|0;x=a+80|0;y=a+88|0;z=a+100|0;A=a+96|0;B=a+92|0;C=e+4|0;D=a+104|0;E=a+116|0;F=a+112|0;G=a+108|0;H=e+4|0;I=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){K=b[a>>0]|0;L=K&255;if(K<<24>>24>0){f[c>>2]=a+1;M=L;N=6}else{O=L;N=5}}else{O=0;N=5}if((N|0)==5){N=0;L=WRb(c,O)|0;if((L+-1|0)>>>0<127){M=L;N=6}else P=L}b:do if((N|0)==6){N=0;switch(M>>>3&536870911|0){case 2:{if((M&255|0)!=18){P=M;break b}if(fUb(c,JLa(i)|0)|0)continue a;else{Q=0;N=130;break a}break}case 3:{switch((M&255)<<24>>24){case 26:break;case 24:{if(ePa(1,26,c,j)|0)continue a;else{Q=0;N=130;break a}break}default:{P=M;break b}}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(a=b[L>>0]|0,a<<24>>24>-1):0){f[c>>2]=L+1;R=a&255}else{a=VRb(c)|0;if((a|0)>-1)R=a;else{Q=0;N=130;break a}}a=ERb(c,R)|0;if((MRb(c)|0)>0)do{L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;S=K&255;T=0}else{IRb(e,c);K=e;if(!(b[m>>0]|0)){Q=0;N=130;break a}else{S=f[K>>2]|0;T=f[K+4>>2]|0}}K=f[j>>2]|0;if((K|0)==(f[k>>2]|0)){UHa(j,K+1|0);U=f[j>>2]|0}else U=K;K=f[l>>2]|0;f[j>>2]=U+1;L=K+8+(U<<3)|0;f[L>>2]=S;f[L+4>>2]=T}while((MRb(c)|0)>0);FRb(c,a);continue a;break}case 4:{switch((M&255)<<24>>24){case 34:break;case 37:{if(fPa(1,34,c,n)|0)continue a;else{Q=0;N=130;break a}break}default:{P=M;break b}}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;V=K&255}else{K=VRb(c)|0;if((K|0)>-1)V=K;else{Q=0;N=130;break a}}W=f[n>>2]|0;K=(V|0)/4|0;if((K<<2|0)!=(V|0)){Q=0;N=130;break a}L=ORb(c)|0;X=MRb(c)|0;if((((L|0)==-1|(X|0)<(L|0)?X:L)|0)>=(V|0)){L=W+K|0;if((f[n>>2]|0)<(L|0)?(SHa(n,L),X=f[n>>2]|0,Y=L-X|0,(Y<<2|0)>0):0)XIc((f[p>>2]|0)+((X<<2)+4)|0,0,(((Y|-1073741824|0)==-1073741824?1073741823:1073741822)+Y<<2)+8|0)|0;f[n>>2]=L;L=f[p>>2]|0;if(QRb(c,((L|0)==0?0:L+4|0)+(W<<2)|0,V)|0)continue a;else{N=36;break a}}if((V|0)>3)Z=0;else continue a;while(1){L=f[c>>2]|0;if(((f[g>>2]|0)-L|0)>3){Y=L;X=h[Y>>0]|h[Y+1>>0]<<8|h[Y+2>>0]<<16|h[Y+3>>0]<<24;f[e>>2]=X;f[c>>2]=L+4;_=X}else{if(!(TRb(c,e)|0)){N=45;break a}_=f[e>>2]|0}X=f[n>>2]|0;if((X|0)==(f[o>>2]|0)){SHa(n,X+1|0);$=f[n>>2]|0}else $=X;X=f[p>>2]|0;f[n>>2]=$+1;f[X+4+($<<2)>>2]=_;X=Z+1|0;if((X|0)<(K|0))Z=X;else continue a}break}case 5:{switch((M&255)<<24>>24){case 42:break;case 40:{if(gPa(1,42,c,q)|0)continue a;else{Q=0;N=130;break a}break}default:{P=M;break b}}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(a=b[K>>0]|0,a<<24>>24>-1):0){f[c>>2]=K+1;aa=a&255}else{a=VRb(c)|0;if((a|0)>-1)aa=a;else{Q=0;N=130;break a}}a=ERb(c,aa)|0;if((MRb(c)|0)>0)do{K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(X=b[K>>0]|0,X<<24>>24>-1):0){f[c>>2]=K+1;ba=X<<24>>24!=0}else{IRb(e,c);X=e;if(!(b[t>>0]|0)){Q=0;N=130;break a}else ba=(f[X>>2]|0)!=0|(f[X+4>>2]|0)!=0}X=f[q>>2]|0;if((X|0)==(f[r>>2]|0)){zNa(q,X+1|0);ca=f[q>>2]|0}else ca=X;X=f[s>>2]|0;f[q>>2]=ca+1;b[X+4+ca>>0]=ba&1}while((MRb(c)|0)>0);FRb(c,a);continue a;break}case 6:{switch((M&255)<<24>>24){case 50:break;case 48:{X=f[c>>2]|0;if(X>>>0<(f[g>>2]|0)>>>0){K=b[X>>0]|0;L=K&255;if(K<<24>>24>-1){f[c>>2]=X+1;da=L}else{ea=L;N=79}}else{ea=0;N=79}if((N|0)==79){N=0;L=HRb(c,ea)|0;X=J;if((X|0)>-1|(X|0)==-1&L>>>0>4294967295)da=L;else{Q=0;N=130;break a}}L=f[v>>2]|0;if((L|0)==(f[w>>2]|0)){KLa(v,L+1|0);fa=f[v>>2]|0}else fa=L;L=f[x>>2]|0;f[v>>2]=fa+1;f[L+4+(fa<<2)>>2]=da;continue a;break}default:{P=M;break b}}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){X=b[L>>0]|0;K=X&255;if(X<<24>>24>-1){f[c>>2]=L+1;ga=K}else{ha=K;N=66}}else{ha=0;N=66}if((N|0)==66){N=0;K=HRb(c,ha)|0;L=J;if((L|0)>-1|(L|0)==-1&K>>>0>4294967295)ga=K;else{Q=0;N=130;break a}}K=ERb(c,ga)|0;if((MRb(c)|0)>0)do{L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){X=b[L>>0]|0;Y=X&255;if(X<<24>>24>-1){f[c>>2]=L+1;ia=Y}else{ja=Y;N=71}}else{ja=0;N=71}if((N|0)==71){N=0;Y=HRb(c,ja)|0;L=J;if((L|0)>-1|(L|0)==-1&Y>>>0>4294967295)ia=Y;else{Q=0;N=130;break a}}Y=f[v>>2]|0;if((Y|0)==(f[w>>2]|0)){KLa(v,Y+1|0);ka=f[v>>2]|0}else ka=Y;Y=f[x>>2]|0;f[v>>2]=ka+1;f[Y+4+(ka<<2)>>2]=ia}while((MRb(c)|0)>0);FRb(c,K);continue a;break}case 7:{if((M&255|0)!=58){P=M;break b}a=f[z>>2]|0;do if(a){Y=f[B>>2]|0;L=f[a>>2]|0;if((Y|0)>=(L|0))if((L|0)==(f[A>>2]|0)){la=L;N=89;break}else{ma=L;na=a;N=90;break}else{f[B>>2]=Y+1;oa=f[a+4+(Y<<2)>>2]|0;break}}else{la=f[A>>2]|0;N=89}while(0);if((N|0)==89){N=0;USb(y,la+1|0);a=f[z>>2]|0;ma=f[a>>2]|0;na=a;N=90}if((N|0)==90){N=0;f[na>>2]=ma+1;a=f[y>>2]|0;if(!a){K=VDc(32)|0;ZRa(K);pa=K}else{if(f[a+64>>2]|0)OQb(a,14904,32);K=MQb(a,32)|0;_Ra(K,a);pa=K}K=f[z>>2]|0;a=f[B>>2]|0;f[B>>2]=a+1;f[K+4+(a<<2)>>2]=pa;oa=pa}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(K=b[a>>0]|0,K<<24>>24>-1):0){f[c>>2]=a+1;qa=K&255}else{K=VRb(c)|0;if((K|0)>-1)qa=K;else{Q=0;N=130;break a}}GRb(e,c,qa);if((f[C>>2]|0)<0){N=102;break a}if(!(Mi[f[(f[oa>>2]|0)+44>>2]&1023](oa,c)|0)){N=102;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Q=0;N=130;break a}break}case 8:{if((M&255|0)!=66){P=M;break b}K=f[E>>2]|0;do if(K){a=f[G>>2]|0;Y=f[K>>2]|0;if((a|0)>=(Y|0))if((Y|0)==(f[F>>2]|0)){ra=Y;N=110;break}else{sa=Y;ta=K;N=111;break}else{f[G>>2]=a+1;ua=f[K+4+(a<<2)>>2]|0;break}}else{ra=f[F>>2]|0;N=110}while(0);if((N|0)==110){N=0;USb(D,ra+1|0);K=f[E>>2]|0;sa=f[K>>2]|0;ta=K;N=111}if((N|0)==111){N=0;f[ta>>2]=sa+1;K=f[D>>2]|0;if(!K){a=VDc(172)|0;bTa(a);va=a}else{if(f[K+64>>2]|0)OQb(K,14936,176);a=MQb(K,176)|0;cTa(a,K);va=a}a=f[E>>2]|0;K=f[G>>2]|0;f[G>>2]=K+1;f[a+4+(K<<2)>>2]=va;ua=va}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(a=b[K>>0]|0,a<<24>>24>-1):0){f[c>>2]=K+1;wa=a&255}else{a=VRb(c)|0;if((a|0)>-1)wa=a;else{Q=0;N=130;break a}}GRb(e,c,wa);if((f[H>>2]|0)<0){N=123;break a}if(!(Mi[f[(f[ua>>2]|0)+44>>2]&1023](ua,c)|0)){N=123;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{Q=0;N=130;break a}break}default:{P=M;break b}}}while(0);if(!P){Q=1;N=130;break}a=f[I>>2]|0;if(!(a&1))xa=mNa(I)|0;else xa=a&-2;if(!(Djc(c,P,xa)|0)){Q=0;N=130;break}}if((N|0)==36){if((f[n>>2]|0)<=0){Q=0;u=d;return Q|0}f[n>>2]=W;Q=0;u=d;return Q|0}else if((N|0)==45){Q=0;u=d;return Q|0}else if((N|0)==102){Q=0;u=d;return Q|0}else if((N|0)==123){Q=0;u=d;return Q|0}else if((N|0)==130){u=d;return Q|0}return 0}function CMa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+20>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+24>>2]|0;if((e|0)>0){h=f[a+32>>2]|0;c=0;g=0;do{d=h+8+(g<<3)|0;j=iJc(f[d>>2]|1|0,f[d+4>>2]|0,1)|0;c=((((j^63)*9|0)+73|0)>>>6)+c|0;g=g+1|0}while((g|0)!=(e|0));if(c){if((c|0)<0)m=11;else m=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=c;o=m+l|0}else{n=0;o=l}}else{n=0;o=l}f[a+36>>2]=n;l=o+n|0;n=f[a+40>>2]<<2;if(!n)p=l;else{if((n|0)<0)q=11;else q=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;p=q+l|0}f[a+52>>2]=n;l=p+n|0;n=f[a+56>>2]|0;if(!n)r=l;else{if((n|0)<0)s=11;else s=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+l|0}f[a+68>>2]=n;l=r+n|0;n=f[a+72>>2]|0;if(n){r=f[a+80>>2]|0;s=0;p=0;do{q=f[r+4+(p<<2)>>2]|0;if((q|0)<0)t=10;else t=(((($(q|1|0)|0)^31)*9|0)+73|0)>>>6;s=t+s|0;p=p+1|0}while((p|0)!=(n|0));if(s){if((s|0)<0)u=11;else u=((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;v=s;w=u+l|0}else{v=0;w=l}}else{v=0;w=l}f[a+84>>2]=v;l=f[a+92>>2]|0;u=w+v+l|0;if(!l)x=u;else{v=a+100|0;w=0;s=u;while(1){u=f[(f[v>>2]|0)+4+(w<<2)>>2]|0;n=_i[f[(f[u>>2]|0)+48>>2]&1023](u)|0;u=n+s+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=w+1|0;if((w|0)==(l|0)){x=u;break}else s=u}}s=f[a+108>>2]|0;l=s+x|0;if(!s){y=l;z=a+120|0;f[z>>2]=y;return y|0}x=a+116|0;w=0;v=l;while(1){l=f[(f[x>>2]|0)+4+(w<<2)>>2]|0;u=_i[f[(f[l>>2]|0)+48>>2]&1023](l)|0;l=u+v+((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=w+1|0;if((w|0)==(s|0)){y=l;break}else v=l}z=a+120|0;f[z>>2]=y;return y|0}function DMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=f[a+12>>2]|0;if((d|0)>0){e=a+20|0;g=0;do{aUb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=a+24|0;if((f[d>>2]|0)>0){g=c+8|0;if((f[g>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=26;f[e>>2]=(f[e>>2]|0)+1;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;h=e}else{bSb(c,26);h=f[g>>2]|0}e=f[a+36>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=e}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else bSb(c,e);e=f[d>>2]|0;if((e|0)>0){d=a+32|0;o=c+8|0;g=c+4|0;h=0;do{i=(f[d>>2]|0)+8+(h<<3)|0;n=f[i>>2]|0;k=f[i+4>>2]|0;if((f[o>>2]|0)>9){i=f[g>>2]|0;j=n&255;if(k>>>0>0|(k|0)==0&n>>>0>127){l=i;m=j;p=n;q=k;while(1){b[l>>0]=m|-128;r=p;p=aJc(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=i;v=j}b[u>>0]=v;q=u+1-i|0;f[g>>2]=(f[g>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else cSb(c,n,k);h=h+1|0}while((h|0)!=(e|0))}}e=a+40|0;if((f[e>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){o=c+4|0;b[f[o>>2]>>0]=34;f[o>>2]=(f[o>>2]|0)+1;o=(f[h>>2]|0)+-1|0;f[h>>2]=o;w=o}else{bSb(c,34);w=f[h>>2]|0}o=f[a+52>>2]|0;if((w|0)>4){w=c+4|0;g=f[w>>2]|0;if(o>>>0>127){u=o;v=g;while(1){b[v>>0]=u|128;d=u>>>7;q=v+1|0;if(u>>>0>16383){u=d;v=q}else{x=q;y=d;break}}}else{x=g;y=o}b[x>>0]=y;y=x+1-g|0;f[w>>2]=(f[w>>2]|0)+y;f[h>>2]=(f[h>>2]|0)-y}else bSb(c,o);o=f[a+48>>2]|0;JTb((o|0)==0?0:o+4|0,f[e>>2]|0,c)}e=a+56|0;if((f[e>>2]|0)>0){o=c+8|0;if((f[o>>2]|0)>4){y=c+4|0;b[f[y>>2]>>0]=42;f[y>>2]=(f[y>>2]|0)+1;y=(f[o>>2]|0)+-1|0;f[o>>2]=y;z=y}else{bSb(c,42);z=f[o>>2]|0}y=f[a+68>>2]|0;if((z|0)>4){z=c+4|0;h=f[z>>2]|0;if(y>>>0>127){w=y;g=h;while(1){b[g>>0]=w|128;x=w>>>7;v=g+1|0;if(w>>>0>16383){w=x;g=v}else{A=v;B=x;break}}}else{A=h;B=y}b[A>>0]=B;B=A+1-h|0;f[z>>2]=(f[z>>2]|0)+B;f[o>>2]=(f[o>>2]|0)-B}else bSb(c,y);y=f[a+64>>2]|0;LTb((y|0)==0?0:y+4|0,f[e>>2]|0,c)}e=a+72|0;if((f[e>>2]|0)>0){y=c+8|0;if((f[y>>2]|0)>4){B=c+4|0;b[f[B>>2]>>0]=50;f[B>>2]=(f[B>>2]|0)+1;B=(f[y>>2]|0)+-1|0;f[y>>2]=B;C=B}else{bSb(c,50);C=f[y>>2]|0}B=f[a+84>>2]|0;if((C|0)>4){C=c+4|0;o=f[C>>2]|0;if(B>>>0>127){z=B;h=o;while(1){b[h>>0]=z|128;A=z>>>7;g=h+1|0;if(z>>>0>16383){z=A;h=g}else{D=g;E=A;break}}}else{D=o;E=B}b[D>>0]=E;E=D+1-o|0;f[C>>2]=(f[C>>2]|0)+E;f[y>>2]=(f[y>>2]|0)-E}else bSb(c,B);B=f[e>>2]|0;if((B|0)>0){e=a+80|0;E=c+8|0;y=c+4|0;C=0;do{o=f[(f[e>>2]|0)+4+(C<<2)>>2]|0;D=((o|0)<0)<<31>>31;if((f[E>>2]|0)>9){h=f[y>>2]|0;z=o&255;if(o>>>0>127){A=h;g=z;w=o;x=D;while(1){b[A>>0]=g|-128;v=w;w=aJc(w|0,x|0,7)|0;u=A+1|0;d=w&255;if(!(x>>>0>0|(x|0)==0&v>>>0>16383)){F=u;G=d;break}else{A=u;g=d;x=J}}}else{F=h;G=z}b[F>>0]=G;x=F+1-h|0;f[y>>2]=(f[y>>2]|0)+x;f[E>>2]=(f[E>>2]|0)-x}else cSb(c,o,D);C=C+1|0}while((C|0)!=(B|0))}}B=f[a+92>>2]|0;if(B|0){C=a+100|0;E=0;do{eUb(7,f[(f[C>>2]|0)+4+(E<<2)>>2]|0,c);E=E+1|0}while((E|0)!=(B|0))}B=f[a+108>>2]|0;if(B|0){E=a+116|0;C=0;do{eUb(8,f[(f[E>>2]|0)+4+(C<<2)>>2]|0,c);C=C+1|0}while((C|0)!=(B|0))}B=f[a+4>>2]|0;if(!((B&1|0)!=0&(b[473420]|0)!=0))return;Gjc(B&-2,c);return}function EMa(a){a=a|0;return f[a+120>>2]|0}function FMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;e=f[a+12>>2]|0;if((e|0)>0){g=a+20|0;h=d;i=0;while(1){j=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[h>>0]=18;k=dSb(j,h+1|0)|0;i=i+1|0;if((i|0)==(e|0)){l=k;break}else h=k}}else l=d;d=a+24|0;if((f[d>>2]|0)>0){b[l>>0]=26;h=l+1|0;e=f[a+36>>2]|0;if(e>>>0>127){i=e;g=h;while(1){b[g>>0]=i|128;k=i>>>7;j=g+1|0;if(i>>>0>16383){i=k;g=j}else{m=j;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=f[d>>2]|0;d=f[a+32>>2]|0;e=0;h=m+1|0;while(1){m=d+8+(e<<3)|0;g=f[m>>2]|0;i=f[m+4>>2]|0;m=g&255;if(i>>>0>0|(i|0)==0&g>>>0>127){k=h;j=m;o=g;g=i;while(1){b[k>>0]=j|-128;i=o;o=aJc(o|0,g|0,7)|0;p=k+1|0;q=o&255;if(!(g>>>0>0|(g|0)==0&i>>>0>16383)){r=p;s=q;break}else{k=p;j=q;g=J}}}else{r=h;s=m}b[r>>0]=s;g=r+1|0;e=e+1|0;if((e|0)>=(n|0)){t=g;break}else h=g}}else t=l;l=a+40|0;if((f[l>>2]|0)>0){b[t>>0]=34;h=t+1|0;n=f[a+52>>2]|0;if(n>>>0>127){e=n;r=h;while(1){b[r>>0]=e|128;s=e>>>7;d=r+1|0;if(e>>>0>16383){e=s;r=d}else{u=d;v=s;break}}}else{u=h;v=n}b[u>>0]=v;v=u+1|0;u=f[l>>2]<<2;dJc(v|0,(f[a+48>>2]|0)+4|0,u|0)|0;w=v+u|0}else w=t;t=a+56|0;if((f[t>>2]|0)>0){b[w>>0]=42;u=w+1|0;v=f[a+68>>2]|0;if(v>>>0>127){l=v;n=u;while(1){b[n>>0]=l|128;h=l>>>7;r=n+1|0;if(l>>>0>16383){l=h;n=r}else{x=r;y=h;break}}}else{x=u;y=v}b[x>>0]=y;y=f[t>>2]|0;t=f[a+64>>2]|0;v=0;u=x+1|0;while(1){b[u>>0]=b[t+4+v>>0]|0;x=u+1|0;v=v+1|0;if((v|0)>=(y|0)){z=x;break}else u=x}}else z=w;w=a+72|0;if((f[w>>2]|0)>0){b[z>>0]=50;u=z+1|0;y=f[a+84>>2]|0;if(y>>>0>127){v=y;t=u;while(1){b[t>>0]=v|128;x=v>>>7;n=t+1|0;if(v>>>0>16383){v=x;t=n}else{A=n;B=x;break}}}else{A=u;B=y}b[A>>0]=B;B=f[w>>2]|0;w=f[a+80>>2]|0;y=0;u=A+1|0;while(1){A=f[w+4+(y<<2)>>2]|0;t=A&255;if(A>>>0>127){v=u;x=t;n=A;l=((A|0)<0)<<31>>31;while(1){b[v>>0]=x|-128;A=n;n=aJc(n|0,l|0,7)|0;h=v+1|0;r=n&255;if(!(l>>>0>0|(l|0)==0&A>>>0>16383)){C=h;D=r;break}else{v=h;x=r;l=J}}}else{C=u;D=t}b[C>>0]=D;l=C+1|0;y=y+1|0;if((y|0)>=(B|0)){E=l;break}else u=l}}else E=z;z=f[a+92>>2]|0;if(!z)F=E;else{u=a+100|0;B=0;y=E;while(1){E=f[(f[u>>2]|0)+4+(B<<2)>>2]|0;b[y>>0]=58;C=y+1|0;D=_i[f[(f[E>>2]|0)+60>>2]&1023](E)|0;if(D>>>0>127){w=D;l=C;while(1){b[l>>0]=w|128;x=w>>>7;v=l+1|0;if(w>>>0>16383){w=x;l=v}else{G=v;H=x;break}}}else{G=C;H=D}b[G>>0]=H;l=hj[f[(f[E>>2]|0)+64>>2]&511](E,c,G+1|0)|0;B=B+1|0;if((B|0)==(z|0)){F=l;break}else y=l}}y=f[a+108>>2]|0;if(!y)I=F;else{z=a+116|0;B=0;G=F;while(1){F=f[(f[z>>2]|0)+4+(B<<2)>>2]|0;b[G>>0]=66;H=G+1|0;u=_i[f[(f[F>>2]|0)+60>>2]&1023](F)|0;if(u>>>0>127){l=u;w=H;while(1){b[w>>0]=l|128;t=l>>>7;x=w+1|0;if(l>>>0>16383){l=t;w=x}else{K=x;L=t;break}}}else{K=H;L=u}b[K>>0]=L;w=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,K+1|0)|0;B=B+1|0;if((B|0)==(y|0)){I=w;break}else G=w}}G=f[a+4>>2]|0;if(!((G&1|0)!=0&(b[473420]|0)!=0)){M=I;return M|0}M=Hjc(G&-2,I)|0;return M|0}function GMa(a){a=a|0;return 0}function HMa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function IMa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,14600,0)|0;if(!c){Ehc(b,a);return}else{qNa(a,c);return}}function JMa(a,b){a=a|0;b=b|0;f[a+120>>2]=b;return}function KMa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;mi[f[(f[a>>2]|0)+96>>2]&2047](c,a);u=b;return f[c+4>>2]|0}function LMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220311]|0)!=2){f[d>>2]=161028;f[d+4>>2]=3;b[d+8>>0]=0;DTb(881244,d);ZSb(d)}d=520616;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function MMa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220312]|0)!=2){f[c>>2]=161028;f[c+4>>2]=4;b[c+8>>0]=0;DTb(881248,c);ZSb(c)}d=VDc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=16;e=d;g=394399;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+16>>0]=0;Xbc(c,79024,79072,78740,0,520616,0,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function NMa(){OMa();lYb(394416,874);rhc(394399,1743);fTa();bSa();kTa();return}function OMa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220313]|0)!=2){f[c>>2]=161028;f[c+4>>2]=5;b[c+8>>0]=0;DTb(881252,c);ZSb(c)}if((f[220314]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=6;b[c+8>>0]=0;DTb(881256,c);ZSb(c);u=a;return}function PMa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220311]|0)!=2){f[c>>2]=161028;f[c+4>>2]=3;b[c+8>>0]=0;DTb(881244,c);ZSb(c)}acc(520616,4);u=a;return}function QMa(){var a=0,b=0;aTb(3005001,3005e3,395291);SQb();aSa();eTa();f[130084]=78924;f[130094]=0;f[130095]=0;f[130096]=0;f[130098]=0;f[130099]=0;f[130100]=0;f[130102]=0;f[130103]=0;f[130104]=0;f[130085]=0;f[130086]=0;f[130087]=0;f[130088]=0;f[130089]=0;f[130090]=0;f[130091]=0;f[130092]=0;a=520424;b=a+36|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(b|0));zTb(520336);return}function RMa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,395291);SQb();aSa();eTa();if((f[220313]|0)!=2){f[c>>2]=161028;f[c+4>>2]=5;b[c+8>>0]=0;DTb(881252,c);ZSb(c)}f[130116]=79096;f[130117]=0;f[130121]=0;f[130120]=0;zTb(520464);f[130137]=0;f[130135]=527320;f[130136]=0;f[130138]=0;f[130139]=0;f[130134]=79204;SMa(520560);zTb(520560);f[130122]=527320;c=520496;f[c>>2]=0;f[c+4>>2]=0;n[130126]=0.0;b[520508]=0;f[130128]=0;f[130129]=520848;f[130130]=520944;f[130131]=520336;f[130132]=520560;f[130133]=527320;f[130136]=520464;u=a;return}function SMa(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=79320;f[a+4>>2]=0;e=a+8|0;f[e>>2]=167152;f[a+12>>2]=0;f[a+16>>2]=0;tTb(a+20|0);f[a+24>>2]=0;f[e>>2]=79428;f[a+28>>2]=0;e=a+32|0;f[e>>2]=0;g=a+36|0;f[g>>2]=0;AJa(e);f[g>>2]=0;if((a|0)!=520560?(f[220314]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=6;b[d+8>>0]=0;DTb(881256,d);ZSb(d)}f[a+44>>2]=527320;f[a+48>>2]=0;u=c;return}function TMa(a){a=a|0;f[a>>2]=79428;cJa(a+24|0);Bcc(a);return}function UMa(a){a=a|0;f[a>>2]=79428;cJa(a+24|0);Bcc(a);YDc(a);return}function VMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;fEc(g,PNa(c)|0);bJa(e,f[a+32>>2]|0,g,0);a=(f[e>>2]|0)!=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}YDc(f[g>>2]|0);u=d;return a|0}function WMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e+16|0;h=e;i=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;fEc(h,PNa(c)|0);bJa(g,f[i+8>>2]|0,h,0);c=f[g>>2]|0;if(!c){j=1;k=BJa(i,h)|0}else{j=0;k=(f[c+12>>2]|0)+16|0}f[d>>2]=k;if((b[h+11>>0]|0)>=0){u=e;return j|0}YDc(f[h>>2]|0);u=e;return j|0}function XMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d+40|0;g=d+24|0;h=d;fEc(h,PNa(c)|0);c=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;bJa(e,f[c+8>>2]|0,h,0);a=f[e>>2]|0;i=f[e+4>>2]|0;j=f[e+8>>2]|0;if(!a)k=0;else{f[g>>2]=a;f[g+4>>2]=i;f[g+8>>2]=j;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];sJa(d+12|0,c,e);k=1}if((b[h+11>>0]|0)>=0){u=d;return k|0}YDc(f[h>>2]|0);u=d;return k|0}function YMa(a,b,c){a=a|0;b=b|0;c=c|0;return (f[f[b>>2]>>2]|0)==(f[f[c>>2]>>2]|0)|0}function ZMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=(_i[f[(f[a>>2]|0)+64>>2]&1023](a)|0)+8|0;d=f[c>>2]|0;c=f[d+12>>2]|0;e=f[d+4>>2]|0;a:do if(e>>>0>c>>>0){g=f[d+16>>2]|0;h=c;while(1){i=f[g+(h<<2)>>2]|0;if(i|0)break;j=h+1|0;if(j>>>0<e>>>0)h=j;else{k=0;l=j;break a}}if((i|0)==(f[g+((h^1)<<2)>>2]|0)){k=f[(f[i>>2]|0)+16>>2]|0;l=h;break}else{k=i;l=h;break}}else{k=0;l=c}while(0);c=f[b>>2]|0;f[c>>2]=k;f[c+4>>2]=d;f[c+8>>2]=l;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function _Ma(a,b){a=a|0;b=b|0;_i[f[(f[a>>2]|0)+64>>2]&1023](a)|0;a=f[b>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function $Ma(a){a=a|0;Wdc(a);return f[f[a+32>>2]>>2]|0}function aNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=u;u=u+16|0;c=b;d=f[a+8>>2]|0;if(!d)e=12;else{g=f[d+8>>2]<<2;h=d+12|0;d=f[h>>2]|0;if(!d)i=g;else{if((f[d>>2]|0)>0){j=0;k=g;l=d;while(1){d=f[l+4+(j<<2)>>2]|0;m=(_i[f[(f[d>>2]|0)+84>>2]&1023](d)|0)+k|0;j=j+1|0;l=f[h>>2]|0;if((j|0)>=(f[l>>2]|0)){n=m;break}else k=m}}else n=g;i=n+4|0}e=i+12|0}i=f[a+32>>2]|0;a=f[i+12>>2]|0;n=f[i+4>>2]|0;a:do if(n>>>0>a>>>0){g=f[i+16>>2]|0;k=a;while(1){o=f[g+(k<<2)>>2]|0;if(o|0)break;l=k+1|0;if(l>>>0<n>>>0)k=l;else{p=0;q=l;break a}}if((o|0)==(f[g+((k^1)<<2)>>2]|0)){p=f[(f[o>>2]|0)+16>>2]|0;q=k;break}else{p=o;q=k;break}}else{p=0;q=a}while(0);f[c>>2]=p;f[c+4>>2]=i;f[c+8>>2]=q;if(!p){r=e;u=b;return r|0}q=e;e=p;while(1){p=(f[e+12>>2]|0)+16|0;i=q+12+(_i[f[(f[p>>2]|0)+84>>2]&1023](p)|0)|0;vJa(c)|0;e=f[c>>2]|0;if(!e){r=i;break}else q=i}u=b;return r|0}function bNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;b=u;u=u+16|0;c=b;d=a+8|0;e=f[d>>2]|0;if(!e){g=f[a+4>>2]|0;if(!g){h=VDc(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}else{if(f[g+64>>2]|0)OQb(g,14656,16);h=NQb(g,16,1744)|0;f[h>>2]=g;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}f[d>>2]=i;j=i}else j=e;e=j+4|0;i=f[e>>2]|0;if((i|0)>0){d=f[j+12>>2]|0;h=0;do{g=f[d+4+(h<<2)>>2]|0;h=h+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((h|0)!=(i|0));f[e>>2]=0}i=f[a+32>>2]|0;h=f[i+12>>2]|0;d=f[i+4>>2]|0;a:do if(d>>>0>h>>>0){g=f[i+16>>2]|0;k=h;while(1){l=f[g+(k<<2)>>2]|0;if(l|0)break;m=k+1|0;if(m>>>0<d>>>0)k=m;else{n=0;o=m;break a}}if((l|0)==(f[g+((k^1)<<2)>>2]|0)){n=f[(f[l>>2]|0)+16>>2]|0;o=k;break}else{n=l;o=k;break}}else{n=0;o=h}while(0);f[c>>2]=n;f[c+4>>2]=i;f[c+8>>2]=o;if(!n){u=b;return}n=a+4|0;a=j+12|0;o=j+8|0;do{i=Mi[f[(f[130134]|0)+16>>2]&1023](520536,f[n>>2]|0)|0;h=i+12|0;l=f[h>>2]|0;d=f[j>>2]|0;if(((d|0)==(l|0)?(m=f[a>>2]|0,(m|0)!=0):0)?(p=f[m>>2]|0,(p|0)<(f[o>>2]|0)):0){q=f[e>>2]|0;if((q|0)<(p|0)){r=m+4+(q<<2)|0;f[m+4+(p<<2)>>2]=f[r>>2];s=r}else s=m+4+(q<<2)|0;f[s>>2]=i;f[e>>2]=q+1;q=f[a>>2]|0;f[q>>2]=(f[q>>2]|0)+1}else INa(j,i,l,d);d=f[(f[c>>2]|0)+12>>2]|0;l=i+16|0;f[l>>2]=f[l>>2]|1;q=i+4|0;m=f[q>>2]|0;if((m|0)==527320){WJa(q,f[h>>2]|0,527320);t=f[q>>2]|0}else t=m;iEc(t,d)|0;d=(f[(f[c>>2]|0)+12>>2]|0)+16|0;f[l>>2]=f[l>>2]|2;l=i+8|0;i=f[h>>2]|0;h=f[l>>2]|0;if(!h){if(!i){m=VDc(24)|0;JNa(m);v=m}else{if(f[i+64>>2]|0)OQb(i,14672,24);m=MQb(i,24)|0;KNa(m,i);v=m}f[l>>2]=v;w=v}else w=h;if((d|0)!=(w|0)){Yi[f[(f[w>>2]|0)+28>>2]&2047](w);lNa(w,d)}pJa(c)|0}while((f[c>>2]|0)!=0);u=b;return}function cNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+80|0;c=b+52|0;d=b+40|0;e=b;g=b+16|0;h=a+24|0;i=f[a+8>>2]|0;if(!i){rTb(g,3,456026,306);oTb(b+64|0,mTb(g,456117)|0);sTb(g)}g=f[a+32>>2]|0;a=f[g+12>>2]|0;j=f[g+4>>2]|0;a:do if(j>>>0>a>>>0){k=f[g+16>>2]|0;l=a;while(1){m=f[k+(l<<2)>>2]|0;if(m|0)break;n=l+1|0;if(n>>>0<j>>>0)l=n;else{o=0;p=n;break a}}if((m|0)==(f[k+((l^1)<<2)>>2]|0)){o=f[(f[m>>2]|0)+16>>2]|0;p=l;break}else{o=m;p=l;break}}else{o=0;p=a}while(0);f[e>>2]=o;f[e+4>>2]=g;f[e+8>>2]=p;if(o|0)do{f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];sJa(d,h,c);f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2];f[e+8>>2]=f[d+8>>2]}while((f[e>>2]|0)!=0);e=i+12|0;d=f[e>>2]|0;c=i+4|0;if(!(f[c>>2]|0)){u=b;return}i=(d|0)==0?0:d+4|0;do{d=f[i>>2]|0;o=_i[f[(f[d>>2]|0)+104>>2]&1023](d)|0;d=f[i>>2]|0;p=BJa(h,_i[f[(f[d>>2]|0)+100>>2]&1023](d)|0)|0;if((o|0)!=(p|0)){Yi[f[(f[p>>2]|0)+28>>2]&2047](p);lNa(p,o)}i=i+4|0;o=f[e>>2]|0}while((i|0)!=(((o|0)==0?0:o+4|0)+(f[c>>2]<<2)|0));u=b;return}function dNa(a,b){a=a|0;b=b|0;a=VDc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[b>>2]=a;return}function eNa(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(!a)return;YDc(a);return}function fNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=f[d>>2]|0;g=f[c>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];e=c+8|0;g=kNa(d+8|0)|0;h=c+16|0;i=f[h>>2]|0;if((i|0)!=(g|0)){if((i|0)==9?(i=f[e>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)YDc(f[i>>2]|0);YDc(i)}f[h>>2]=g;if((g|0)==9){g=VDc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[e>>2]=g}}f[c+28>>2]=f[d+28>>2];mi[f[(f[a>>2]|0)+72>>2]&2047](a,c);return}function gNa(a,b){a=a|0;b=b|0;pJa(f[b>>2]|0)|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function hNa(a){a=a|0;Wdc(a);return a+24|0}function iNa(a){a=a|0;Wdc(a);Vdc(a);return a+24|0}function jNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;a=f[f[b>>2]>>2]|0;if(!a)return;c=b+8|0;d=a+12|0;a=f[d>>2]|0;e=b+16|0;if((f[e>>2]|0)==9)g=f[c>>2]|0;else{f[e>>2]=9;e=VDc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[c>>2]=e;g=e}iEc(g,a)|0;f[b+24>>2]=(f[d>>2]|0)+16;return}function kNa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+32|0;c=b;d=a+8|0;a=f[d>>2]|0;if(a|0){e=a;u=b;return e|0}rTb(c,3,498207,372);oTb(b+24|0,mTb(mTb(mTb(c,498321)|0,395373)|0,395414)|0);sTb(c);e=f[d>>2]|0;u=b;return e|0}function lNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=c+20|0;do switch(f[e>>2]|0){case 2:{h=f[c+8>>2]|0;g=a+20|0;if((f[g>>2]|0)==2)i=a+8|0;else{nNa(a);f[g>>2]=2;g=a+8|0;f[g>>2]=527320;i=g}g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[i>>2]|0;if((j|0)==527320){WJa(i,k,h);return}else{iEc(j,h)|0;return}break}case 3:{h=c+8|0;j=f[h>>2]|0;g=f[h+4>>2]|0;h=a+20|0;if((f[h>>2]|0)!=3){nNa(a);f[h>>2]=3}h=a+8|0;f[h>>2]=j;f[h+4>>2]=g;return}case 4:{g=f[c+8>>2]|0;h=a+20|0;if((f[h>>2]|0)!=4){nNa(a);f[h>>2]=4}f[a+8>>2]=g;return}case 5:{g=b[c+8>>0]|0;h=a+20|0;if((f[h>>2]|0)!=5){nNa(a);f[h>>2]=5}b[a+8>>0]=g;return}case 6:{g=f[c+8>>2]|0;h=a+20|0;if((f[h>>2]|0)!=6){nNa(a);f[h>>2]=6}f[a+8>>2]=g;return}case 7:{cSa(oNa(a)|0,(f[e>>2]|0)==7?f[c+8>>2]|0:520848);return}case 8:{_Sa(UJa(a)|0,(f[e>>2]|0)==8?f[c+8>>2]|0:520944);return}case 1:{qNa(pNa(a)|0,(f[e>>2]|0)==1?f[c+8>>2]|0:520336);return}case 10:{sNa(rNa(a)|0,(f[e>>2]|0)==10?f[c+8>>2]|0:520560);return}case 9:{g=f[c+8>>2]|0;h=a+20|0;if((f[h>>2]|0)==9)l=a+8|0;else{nNa(a);f[h>>2]=9;h=a+8|0;f[h>>2]=527320;l=h}h=f[d>>2]|0;j=h&-2;if(!(h&1))m=j;else m=f[j+4>>2]|0;j=f[l>>2]|0;if((j|0)==527320){WJa(l,m,g);return}else{iEc(j,g)|0;return}break}default:return}while(0)}function mNa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(8)|0;b=c;f[b>>2]=0;f[b+4>>2]=0;e=c}else{if(f[d+64>>2]|0)OQb(d,14648,8);c=NQb(d,8,1745)|0;b=c;f[b>>2]=0;f[b+4>>2]=0;e=c}f[e>>2]=0;f[a>>2]=e|1;f[e+4>>2]=d;return e|0}function nNa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+20|0;switch(f[c>>2]|0){case 2:{d=f[a+4>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;if((g|0)==0?(g=f[a+8>>2]|0,!((g|0)==527320|(g|0)==0)):0){if((b[g+11>>0]|0)<0)YDc(f[g>>2]|0);YDc(g)}break}case 9:{g=f[a+4>>2]|0;e=g&-2;if(!(g&1))h=e;else h=f[e+4>>2]|0;if((h|0)==0?(h=f[a+8>>2]|0,!((h|0)==527320|(h|0)==0)):0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}break}case 10:{h=f[a+4>>2]|0;e=h&-2;if(!(h&1))i=e;else i=f[e+4>>2]|0;if((i|0)==0?(i=f[a+8>>2]|0,i|0):0)Yi[f[(f[i>>2]|0)+4>>2]&2047](i);break}case 1:{i=f[a+4>>2]|0;e=i&-2;if(!(i&1))j=e;else j=f[e+4>>2]|0;if((j|0)==0?(j=f[a+8>>2]|0,j|0):0)Yi[f[(f[j>>2]|0)+4>>2]&2047](j);break}case 8:{j=f[a+4>>2]|0;e=j&-2;if(!(j&1))k=e;else k=f[e+4>>2]|0;if((k|0)==0?(k=f[a+8>>2]|0,k|0):0)Yi[f[(f[k>>2]|0)+4>>2]&2047](k);break}case 7:{k=f[a+4>>2]|0;e=k&-2;if(!(k&1))l=e;else l=f[e+4>>2]|0;if((l|0)==0?(l=f[a+8>>2]|0,l|0):0)Yi[f[(f[l>>2]|0)+4>>2]&2047](l);break}default:{}}f[c>>2]=0;return}function oNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;if((f[b>>2]|0)==7){c=f[a+8>>2]|0;return c|0}nNa(a);f[b>>2]=7;b=f[a+4>>2]|0;d=b&-2;if(!(b&1))e=d;else e=f[d+4>>2]|0;if(!e){d=VDc(32)|0;ZRa(d);g=d}else{if(f[e+64>>2]|0)OQb(e,14904,32);d=MQb(e,32)|0;_Ra(d,e);g=d}f[a+8>>2]=g;c=g;return c|0}function pNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;if((f[b>>2]|0)==1){c=f[a+8>>2]|0;return c|0}nNa(a);f[b>>2]=1;b=f[a+4>>2]|0;d=b&-2;if(!(b&1))e=d;else e=f[d+4>>2]|0;if(!e){d=VDc(124)|0;ENa(d);g=d}else{if(f[e+64>>2]|0)OQb(e,14600,128);d=MQb(e,128)|0;FNa(d,e);g=d}f[a+8>>2]=g;c=g;return c|0}function qNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}yNa(a+8|0,b+8|0);d=a+24|0;g=b+24|0;e=f[g>>2]|0;if(e|0){UHa(d,(f[d>>2]|0)+e|0);dJc((f[a+32>>2]|0)+8+(f[d>>2]<<3)|0,(f[b+32>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+40|0;d=b+40|0;e=f[d>>2]|0;if(e|0){SHa(g,(f[g>>2]|0)+e|0);dJc((f[a+48>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+48>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+56|0;g=b+56|0;e=f[g>>2]|0;if(e|0){zNa(d,(f[d>>2]|0)+e|0);dJc((f[d>>2]|0)+((f[a+64>>2]|0)+4)|0,(f[b+64>>2]|0)+4|0,f[g>>2]|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+72|0;d=b+72|0;e=f[d>>2]|0;if(!e){h=a+88|0;i=b+88|0;ANa(h,i);j=a+104|0;k=b+104|0;BNa(j,k);return}KLa(g,(f[g>>2]|0)+e|0);dJc((f[a+80>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+80>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0);h=a+88|0;i=b+88|0;ANa(h,i);j=a+104|0;k=b+104|0;BNa(j,k);return}function rNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;if((f[b>>2]|0)==10){c=f[a+8>>2]|0;return c|0}nNa(a);f[b>>2]=10;b=f[a+4>>2]|0;d=b&-2;if(!(b&1))e=d;else e=f[d+4>>2]|0;if(!e){d=VDc(52)|0;SMa(d);g=d}else{if(f[e+64>>2]|0)OQb(e,14632,56);d=MQb(e,56)|0;uNa(d,e);g=d}f[a+8>>2]=g;c=g;return c|0}function sNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=a+8|0;Wdc(e);Wdc(c+8|0);tNa(a+28|0,c+28|0);Vdc(e);e=f[c+44>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)i=f[e+4>>2]|0;else i=c&255;if(!i)return;i=a+44|0;a=f[d>>2]|0;d=a&-2;if(!(a&1))j=d;else j=f[d+4>>2]|0;d=f[i>>2]|0;if((d|0)==527320){WJa(i,j,e);return}else{iEc(d,e)|0;return}}function tNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;e=f[b+12>>2]|0;b=f[e+12>>2]|0;g=f[e+4>>2]|0;a:do if(g>>>0>b>>>0){h=f[e+16>>2]|0;i=b;while(1){j=f[h+(i<<2)>>2]|0;if(j|0)break;k=i+1|0;if(k>>>0<g>>>0)i=k;else{l=0;m=k;break a}}if((j|0)==(f[h+((i^1)<<2)>>2]|0)){l=f[(f[j>>2]|0)+16>>2]|0;m=i;break}else{l=j;m=i;break}}else{l=0;m=b}while(0);f[d>>2]=l;f[d+4>>2]=e;f[d+8>>2]=m;if(!l){u=c;return}m=a+4|0;a=l;do{l=f[a+12>>2]|0;e=l+16|0;b=BJa(m,l)|0;if((e|0)!=(b|0)){Yi[f[(f[b>>2]|0)+28>>2]&2047](b);lNa(b,e)}pJa(d)|0;a=f[d>>2]|0}while((a|0)!=0);u=c;return}function uNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=79320;f[a+4>>2]=c;vNa(a+8|0,c);if((f[220314]|0)==2){g=a+44|0;f[g>>2]=527320;h=a+48|0;f[h>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=6;b[e+8>>0]=0;DTb(881256,e);ZSb(e);g=a+44|0;f[g>>2]=527320;h=a+48|0;f[h>>2]=0;u=d;return}function vNa(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=167152;f[a+4>>2]=b;f[a+8>>2]=0;c=a+12|0;tTb(c);f[a+16>>2]=0;wNa(b,c);f[a>>2]=79428;f[a+20>>2]=b;c=a+24|0;f[c>>2]=b;b=a+28|0;f[b>>2]=0;AJa(c);f[b>>2]=0;return}function wNa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1746);return}function xNa(a){a=a|0;uTb(a);return}function yNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{iEc(f[b+(i<<2)>>2]|0,f[d+4+(i<<2)>>2]|0)|0;i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;iEc(l,k)|0;f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)==(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,4984,16);l=NQb(i,16,1733)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;iEc(l,j)|0;f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function zNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(!h){i=f[g>>2]|0;j=d<<1;k=(j|0)<(b|0)?b:j;j=(k|0)>4?k:4;if(!i){l=j;m=5}else{k=j+11&-8;if(f[i+64>>2]|0)OQb(i,23816,k);n=MQb(i,k)|0;o=i;p=j}}else{j=d<<1;d=(j|0)<(b|0)?b:j;l=(d|0)>4?d:4;m=5}if((m|0)==5){n=VDc(l+4|0)|0;o=0;p=l}f[e>>2]=n;f[n>>2]=o;f[c>>2]=p;p=f[a>>2]|0;if((p|0)>0)dJc(n+4|0,g+4|0,p|0)|0;if(h)return;if(f[g>>2]|0)return;YDc(g);return}function ANa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{DNa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(32)|0;ZRa(l);DNa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,14904,32);l=MQb(i,32)|0;_Ra(l,i);DNa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function BNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{CNa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(172)|0;bTa(l);CNa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,14936,176);l=MQb(i,176)|0;cTa(l,i);CNa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function CNa(a,b){a=a|0;b=b|0;_Sa(b,a);return}function DNa(a,b){a=a|0;b=b|0;cSa(b,a);return}function ENa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=78924;e=a+4|0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;g=a+88|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;if((a|0)==520336){h=a+120|0;f[h>>2]=0;u=c;return}if((f[220313]|0)==2){h=a+120|0;f[h>>2]=0;u=c;return}f[d>>2]=161028;f[d+4>>2]=5;b[d+8>>0]=0;DTb(881252,d);ZSb(d);h=a+120|0;f[h>>2]=0;u=c;return}function FNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[a>>2]=78924;f[a+4>>2]=c;f[a+8>>2]=c;g=a+12|0;h=a+32|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;if(!c){f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0}else{if(f[c+64>>2]|0)OQb(c,23816,8);g=MQb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+40>>2]=0;f[a+44>>2]=0;g=a+48|0;f[g>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c;f[a+56>>2]=0;f[a+60>>2]=0;h=a+64|0;f[h>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);g=MQb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+72>>2]=0;f[a+76>>2]=0;g=a+80|0;f[g>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c}f[a+88>>2]=c;f[a+92>>2]=0;f[a+96>>2]=0;f[a+100>>2]=0;f[a+104>>2]=c;f[a+108>>2]=0;f[a+112>>2]=0;f[a+116>>2]=0;if((f[220313]|0)==2){i=a+120|0;f[i>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=5;b[e+8>>0]=0;DTb(881252,e);ZSb(e);i=a+120|0;f[i>>2]=0;u=d;return}function GNa(a){a=a|0;if(!(f[a>>2]|0))return;ljc(a);return}function HNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;YDc(g);f[b>>2]=0;return}function INa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){if(!d){e=VDc(24)|0;f[e+12>>2]=0;f[e+4>>2]=527320;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)OQb(d,14688,24);e=MQb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=527320;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=79204;MNa(b,g);if((b|0)==0|(c|0)!=0)i=g;else{Yi[f[(f[b>>2]|0)+4>>2]&2047](b);i=g}}else i=b;else{LNa(d,b);i=b}b=a+12|0;d=f[b>>2]|0;g=f[a+8>>2]|0;c=a+4|0;if(d|0?(e=f[c>>2]|0,(e|0)!=(g|0)):0){h=f[d>>2]|0;if((h|0)==(g|0)){j=f[d+4+(e<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}Yi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}else{if((e|0)<(h|0)){f[d+4+(h<<2)>>2]=f[d+4+(e<<2)>>2];e=f[b>>2]|0;o=e;p=f[e>>2]|0}else{o=d;p=h}f[o>>2]=p+1;k=o;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}}USb(a,g+1|0);g=f[b>>2]|0;f[g>>2]=(f[g>>2]|0)+1;k=g;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}function JNa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=79096;f[a+4>>2]=0;if((a|0)!=520464?(f[220314]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=6;b[d+8>>0]=0;DTb(881256,d);ZSb(d)}f[a+20>>2]=0;f[a+16>>2]=0;u=c;return}function KNa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=79096;f[a+4>>2]=c;if((f[220314]|0)!=2){f[e>>2]=161028;f[e+4>>2]=6;b[e+8>>0]=0;DTb(881256,e);ZSb(e)}f[a+20>>2]=0;f[a+16>>2]=0;u=d;return}function LNa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function MNa(a,b){a=a|0;b=b|0;NNa(b,a);return}function NNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=b+16|0;d=f[c>>2]|0;if(!d)return;if(!(d&1))e=d;else{d=a+4|0;g=a+12|0;if((f[d>>2]|0)==527320)WJa(d,f[g>>2]|0,527320);h=_i[f[(f[b>>2]|0)+100>>2]&1023](b)|0;i=f[d>>2]|0;if((i|0)==527320)WJa(d,f[g>>2]|0,h);else iEc(i,h)|0;h=a+16|0;f[h>>2]=f[h>>2]|1;e=f[c>>2]|0}if(!(e&2))return;e=a+8|0;c=f[a+12>>2]|0;if(!(f[e>>2]|0)){if(!c){h=VDc(24)|0;JNa(h);j=h}else{if(f[c+64>>2]|0)OQb(c,14672,24);h=MQb(c,24)|0;KNa(h,c);j=h}f[e>>2]=j}j=_i[f[(f[b>>2]|0)+104>>2]&1023](b)|0;lNa(f[e>>2]|0,j);j=a+16|0;f[j>>2]=f[j>>2]|2;return}function ONa(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function PNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((kNa(a)|0)==9){d=f[a>>2]|0;u=b;return d|0}rTb(c,3,498207,432);e=mTb(mTb(mTb(mTb(c,498321)|0,396255)|0,498376)|0,498398)|0;g=mTb(mTb(mTb(e,f[40351]|0)|0,502002)|0,498412)|0;e=161368+((kNa(a)|0)<<2)|0;oTb(b+24|0,mTb(g,f[e>>2]|0)|0);sTb(c);d=f[a>>2]|0;u=b;return d|0}function QNa(a){a=a|0;var c=0,d=0;f[a>>2]=79320;c=f[a+44>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+8|0;f[c>>2]=79428;cJa(a+32|0);Bcc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function RNa(a){a=a|0;QNa(a);YDc(a);return}function SNa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function TNa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(52)|0;SMa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14632,56);a=MQb(b,56)|0;uNa(a,b);c=a;return c|0}function UNa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function VNa(a){a=a|0;return f[a+4>>2]|0}function WNa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=a+8|0;Wdc(h);i=a+32|0;j=f[a+40>>2]|0;k=f[j+12>>2]|0;l=f[j+4>>2]|0;a:do if(l>>>0>k>>>0){m=f[j+16>>2]|0;n=k;while(1){o=f[m+(n<<2)>>2]|0;if(o|0)break;p=n+1|0;if(p>>>0<l>>>0)n=p;else{q=0;r=p;break a}}if((o|0)==(f[m+((n^1)<<2)>>2]|0)){q=f[(f[o>>2]|0)+16>>2]|0;r=n;break}else{q=o;r=n;break}}else{q=0;r=k}while(0);f[g>>2]=q;f[g+4>>2]=j;f[g+8>>2]=r;if(q|0)do{f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];sJa(e,i,d);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2]}while((f[g>>2]|0)!=0);Vdc(h);h=a+4|0;g=f[a+44>>2]|0;do if((g|0)!=527320){a=g+11|0;if((b[a>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[a>>0]=0;break}}while(0);g=f[h>>2]|0;if(!(g&1)){u=c;return}h=g&-2;if(!(f[h>>2]|0)){u=c;return}ljc(h);u=c;return}function XNa(a){a=a|0;return 1}function YNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=a+44|0;j=a+4|0;k=a+44|0;l=a+8|0;a=g+4|0;m=g+8|0;n=g+24|0;o=e+4|0;p=m+11|0;q=g+12|0;a:while(1){r=f[c>>2]|0;if(r>>>0<(f[h>>2]|0)>>>0){s=b[r>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=r+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=WRb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=10){y=v;break b}t=f[j>>2]|0;r=t&-2;if(!(t&1))z=r;else z=f[r+4>>2]|0;r=f[i>>2]|0;if((r|0)==527320){WJa(i,z,527320);A=f[i>>2]|0}else A=r;if(!(fUb(c,A)|0)){B=0;w=39;break a}r=f[k>>2]|0;t=b[r+11>>0]|0;if(t<<24>>24<0){C=f[r>>2]|0;D=f[r+4>>2]|0}else{C=r;D=t&255}if(gUb(C,D,0,396645)|0)continue a;else{B=0;w=39;break a}break}case 2:break;default:{y=v;break b}}if((v&255|0)==18){f[g>>2]=l;t=_i[f[(f[l>>2]|0)+68>>2]&1023](l)|0;f[a>>2]=t;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[n>>2]=0;t=f[c>>2]|0;if(t>>>0<(f[h>>2]|0)>>>0?(r=b[t>>0]|0,r<<24>>24>-1):0){f[c>>2]=t+1;E=r&255;w=23}else{r=VRb(c)|0;if((r|0)>-1){E=r;w=23}else F=6}do if((w|0)==23){w=0;GRb(e,c,E);if((f[o>>2]|0)>=0?MOa(g,c)|0:0){if(!(LRb(c,f[e>>2]|0)|0)){F=6;break}r=b[p>>0]|0;t=r<<24>>24<0;s=gUb(t?f[m>>2]|0:m,t?f[q>>2]|0:r&255,0,396681)|0;F=s?0:6;break}F=6}while(0);s=f[n>>2]|0;if(s|0)Yi[f[(f[s>>2]|0)+4>>2]&2047](s);if((b[p>>0]|0)<0)YDc(f[m>>2]|0);switch(F&7){case 0:{continue a;break}case 6:{B=0;w=39;break a;break}default:{w=38;break a}}}else y=v}while(0);if(!y){w=38;break}s=f[j>>2]|0;if(!(s&1))G=mNa(j)|0;else G=s&-2;if(!(Djc(c,y,G)|0)){B=0;w=39;break}}if((w|0)==38){B=1;u=d;return B|0}else if((w|0)==39){u=d;return B|0}return 0}function ZNa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;if((e&1|0)!=0&(b[473420]|0)!=0)g=Jjc(e&-2)|0;else g=0;e=a+8|0;Wdc(e);h=a+40|0;i=f[f[h>>2]>>2]|0;Wdc(e);j=i+g|0;g=f[h>>2]|0;h=f[g+12>>2]|0;i=f[g+4>>2]|0;a:do if(i>>>0>h>>>0){k=f[g+16>>2]|0;l=h;while(1){m=f[k+(l<<2)>>2]|0;if(m|0)break;n=l+1|0;if(n>>>0<i>>>0)l=n;else{o=0;p=n;break a}}if((m|0)==(f[k+((l^1)<<2)>>2]|0)){o=f[(f[m>>2]|0)+16>>2]|0;p=l;break}else{o=m;p=l;break}}else{o=0;p=h}while(0);f[d>>2]=o;f[d+4>>2]=g;f[d+8>>2]=p;p=a+28|0;g=j;j=0;while(1){Wdc(e);o=f[d>>2]|0;if(!o)break;if(!j){q=0;r=o}else{o=(_i[f[(f[j>>2]|0)+20>>2]&1023](j)|0)==0;q=o?j:0;r=f[d>>2]|0}o=f[r+12>>2]|0;h=o+16|0;m=f[p>>2]|0;if(!m){i=VDc(32)|0;f[i+12>>2]=0;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+20>>2]=0;s=i}else{if(f[m+64>>2]|0)OQb(m,14760,32);i=MQb(m,32)|0;n=m;f[i+12>>2]=n;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+20>>2]=n;s=i}f[s>>2]=79512;f[s+24>>2]=o;f[s+28>>2]=h;f[s+16>>2]=3;if((q|0)!=(s|0))if(!q)t=s;else{Yi[f[(f[q>>2]|0)+4>>2]&2047](q);t=s}else t=q;h=t+16|0;o=f[h>>2]|0;if(!(o&1)){v=0;w=o}else{o=_i[f[(f[t>>2]|0)+100>>2]&1023](t)|0;i=b[o+11>>0]|0;n=i<<24>>24<0?f[o+4>>2]|0:i&255;i=n+1+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;v=i;w=f[h>>2]|0}if(!(w&2))x=0;else{h=AOa(_i[f[(f[t>>2]|0)+104>>2]&1023](t)|0)|0;x=h+1+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=x+v|0;i=h+g+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;pJa(d)|0;g=i;j=t}if(j|0?(_i[f[(f[j>>2]|0)+20>>2]&1023](j)|0)==0:0)Yi[f[(f[j>>2]|0)+4>>2]&2047](j);j=f[a+44>>2]|0;t=b[j+11>>0]|0;d=t<<24>>24<0;if(d)y=f[j+4>>2]|0;else y=t&255;if(!y){z=g;A=a+48|0;f[A>>2]=z;u=c;return z|0}y=d?f[j+4>>2]|0:t&255;z=g+1+y+((((($(y|1|0)|0)^31)*9|0)+73|0)>>>6)|0;A=a+48|0;f[A>>2]=z;u=c;return z|0}function _Na(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+16|0;e=d;g=a+44|0;h=f[g>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;if(j)k=f[h+4>>2]|0;else k=i&255;if(k|0){if(j){l=f[h>>2]|0;m=f[h+4>>2]|0}else{l=h;m=i&255}gUb(l,m,1,396645)|0;$Tb(1,f[g>>2]|0,c)}g=a+8|0;Wdc(g);m=a+40|0;do if(f[f[m>>2]>>2]|0){if(!(b[c+18>>0]|0)){if(f[220805]|0)n=13}else if(b[c+19>>0]|0)n=13;if((n|0)==13?(Wdc(g),(f[f[m>>2]>>2]|0)>>>0>1):0){Wdc(g);l=f[f[m>>2]>>2]|0;i=XDc(l>>>0>1073741823?-1:l<<2)|0;Wdc(g);l=f[m>>2]|0;h=f[l+12>>2]|0;j=f[l+4>>2]|0;a:do if(j>>>0>h>>>0){k=f[l+16>>2]|0;o=h;while(1){p=f[k+(o<<2)>>2]|0;if(p|0)break;q=o+1|0;if(q>>>0<j>>>0)o=q;else{r=0;s=q;break a}}if((p|0)==(f[k+((o^1)<<2)>>2]|0)){r=f[(f[p>>2]|0)+16>>2]|0;s=o;break}else{r=p;s=o;break}}else{r=0;s=h}while(0);f[e>>2]=r;f[e+4>>2]=l;f[e+8>>2]=s;h=0;while(1){Wdc(g);j=f[e>>2]|0;if(!j)break;f[i+(h<<2)>>2]=f[j+12>>2];pJa(e)|0;h=h+1|0}fOa(i,i+(h<<2)|0,e);if(h|0){l=a+28|0;j=0;q=0;do{t=i+(j<<2)|0;v=f[t>>2]|0;w=v+16|0;x=f[l>>2]|0;if(!x){y=VDc(32)|0;f[y+12>>2]=0;f[y+4>>2]=527320;f[y+8>>2]=0;f[y+20>>2]=0;z=y}else{if(f[x+64>>2]|0)OQb(x,14760,32);y=MQb(x,32)|0;A=x;f[y+12>>2]=A;f[y+4>>2]=527320;f[y+8>>2]=0;f[y+20>>2]=A;z=y}f[z>>2]=79512;f[z+24>>2]=v;f[z+28>>2]=w;f[z+16>>2]=3;if((q|0)!=(z|0))if(!q)B=z;else{Yi[f[(f[q>>2]|0)+4>>2]&2047](q);B=z}else B=q;eUb(2,B,c);w=(_i[f[(f[B>>2]|0)+20>>2]&1023](B)|0)==0;q=w?B:0;w=f[t>>2]|0;t=b[w+11>>0]|0;if(t<<24>>24<0){C=f[w>>2]|0;D=f[w+4>>2]|0}else{C=w;D=t&255}gUb(C,D,1,396681)|0;j=j+1|0}while(j>>>0<h>>>0);if(q|0)Yi[f[(f[q>>2]|0)+4>>2]&2047](q)}ZDc(i);break}Wdc(g);h=f[m>>2]|0;j=f[h+12>>2]|0;l=f[h+4>>2]|0;b:do if(l>>>0>j>>>0){t=f[h+16>>2]|0;w=j;while(1){E=f[t+(w<<2)>>2]|0;if(E|0)break;v=w+1|0;if(v>>>0<l>>>0)w=v;else{F=0;G=v;break b}}if((E|0)==(f[t+((w^1)<<2)>>2]|0)){F=f[(f[E>>2]|0)+16>>2]|0;G=w;break}else{F=E;G=w;break}}else{F=0;G=j}while(0);f[e>>2]=F;f[e+4>>2]=h;f[e+8>>2]=G;j=a+28|0;l=0;while(1){Wdc(g);i=f[e>>2]|0;if(!i)break;q=f[i+12>>2]|0;i=q+16|0;o=f[j>>2]|0;if(!o){k=VDc(32)|0;f[k+12>>2]=0;f[k+4>>2]=527320;f[k+8>>2]=0;f[k+20>>2]=0;H=k}else{if(f[o+64>>2]|0)OQb(o,14760,32);k=MQb(o,32)|0;v=o;f[k+12>>2]=v;f[k+4>>2]=527320;f[k+8>>2]=0;f[k+20>>2]=v;H=k}f[H>>2]=79512;f[H+24>>2]=q;f[H+28>>2]=i;f[H+16>>2]=3;if((l|0)!=(H|0))if(!l)I=H;else{Yi[f[(f[l>>2]|0)+4>>2]&2047](l);I=H}else I=l;eUb(2,I,c);i=(_i[f[(f[I>>2]|0)+20>>2]&1023](I)|0)==0;q=f[(f[e>>2]|0)+12>>2]|0;k=b[q+11>>0]|0;if(k<<24>>24<0){J=f[q>>2]|0;K=f[q+4>>2]|0}else{J=q;K=k&255}gUb(J,K,1,396681)|0;pJa(e)|0;l=i?I:0}if(l|0)Yi[f[(f[l>>2]|0)+4>>2]&2047](l)}while(0);I=f[a+4>>2]|0;if(!((I&1|0)!=0&(b[473420]|0)!=0)){u=d;return}Gjc(I&-2,c);u=d;return}function $Na(a){a=a|0;return f[a+48>>2]|0}function aOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0;e=u;u=u+16|0;g=e;h=a+44|0;i=f[h>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;if(k)l=f[i+4>>2]|0;else l=j&255;if(!l)m=d;else{if(k){n=f[i>>2]|0;o=f[i+4>>2]|0}else{n=i;o=j&255}gUb(n,o,1,396645)|0;o=f[h>>2]|0;b[d>>0]=10;m=dSb(o,d+1|0)|0}d=a+8|0;Wdc(d);o=a+40|0;do if(f[f[o>>2]>>2]|0){if(c?(Wdc(d),(f[f[o>>2]>>2]|0)>>>0>1):0){Wdc(d);h=f[f[o>>2]>>2]|0;n=XDc(h>>>0>1073741823?-1:h<<2)|0;Wdc(d);h=f[o>>2]|0;j=f[h+12>>2]|0;i=f[h+4>>2]|0;a:do if(i>>>0>j>>>0){k=f[h+16>>2]|0;l=j;while(1){p=f[k+(l<<2)>>2]|0;if(p|0)break;q=l+1|0;if(q>>>0<i>>>0)l=q;else{r=0;s=q;break a}}if((p|0)==(f[k+((l^1)<<2)>>2]|0)){r=f[(f[p>>2]|0)+16>>2]|0;s=l;break}else{r=p;s=l;break}}else{r=0;s=j}while(0);f[g>>2]=r;f[g+4>>2]=h;f[g+8>>2]=s;j=0;while(1){Wdc(d);i=f[g>>2]|0;if(!i)break;f[n+(j<<2)>>2]=f[i+12>>2];pJa(g)|0;j=j+1|0}fOa(n,n+(j<<2)|0,g);if(j){h=a+28|0;i=0;q=m;t=0;do{v=n+(i<<2)|0;w=f[v>>2]|0;x=w+16|0;y=f[h>>2]|0;if(!y){z=VDc(32)|0;f[z+12>>2]=0;f[z+4>>2]=527320;f[z+8>>2]=0;f[z+20>>2]=0;A=z}else{if(f[y+64>>2]|0)OQb(y,14760,32);z=MQb(y,32)|0;B=y;f[z+12>>2]=B;f[z+4>>2]=527320;f[z+8>>2]=0;f[z+20>>2]=B;A=z}f[A>>2]=79512;f[A+24>>2]=w;f[A+28>>2]=x;f[A+16>>2]=3;if((t|0)!=(A|0))if(!t)C=A;else{Yi[f[(f[t>>2]|0)+4>>2]&2047](t);C=A}else C=t;b[q>>0]=18;x=q+1|0;w=C+16|0;z=f[w>>2]|0;if(!(z&1)){D=z;E=0}else{z=_i[f[(f[C>>2]|0)+100>>2]&1023](C)|0;B=b[z+11>>0]|0;y=B<<24>>24<0?f[z+4>>2]|0:B&255;B=y+1+((((($(y|1|0)|0)^31)*9|0)+73|0)>>>6)|0;D=f[w>>2]|0;E=B}if(!(D&2))F=0;else{B=_i[f[(f[C>>2]|0)+104>>2]&1023](C)|0;w=_i[f[(f[B>>2]|0)+60>>2]&1023](B)|0;F=w+1+((((($(w|1|0)|0)^31)*9|0)+73|0)>>>6)|0}w=F+E|0;if(w>>>0>127){B=w;y=x;while(1){b[y>>0]=B|128;z=B>>>7;G=y+1|0;if(B>>>0>16383){B=z;y=G}else{H=G;I=z;break}}}else{H=x;I=w}b[H>>0]=I;y=_i[f[(f[C>>2]|0)+100>>2]&1023](C)|0;b[H+1>>0]=10;B=dSb(y,H+2|0)|0;y=_i[f[(f[C>>2]|0)+104>>2]&1023](C)|0;b[B>>0]=18;l=B+1|0;B=_i[f[(f[y>>2]|0)+60>>2]&1023](y)|0;if(B>>>0>127){k=B;z=l;while(1){b[z>>0]=k|128;G=k>>>7;J=z+1|0;if(k>>>0>16383){k=G;z=J}else{K=J;L=G;break}}}else{K=l;L=B}b[K>>0]=L;q=hj[f[(f[y>>2]|0)+64>>2]&511](y,1,K+1|0)|0;z=(_i[f[(f[C>>2]|0)+20>>2]&1023](C)|0)==0;t=z?C:0;z=f[v>>2]|0;k=b[z+11>>0]|0;if(k<<24>>24<0){M=f[z>>2]|0;N=f[z+4>>2]|0}else{M=z;N=k&255}gUb(M,N,1,396681)|0;i=i+1|0}while(i>>>0<j>>>0);if(!t)O=q;else{Yi[f[(f[t>>2]|0)+4>>2]&2047](t);O=q}}else O=m;ZDc(n);P=O;break}Wdc(d);j=f[o>>2]|0;i=f[j+12>>2]|0;h=f[j+4>>2]|0;b:do if(h>>>0>i>>>0){k=f[j+16>>2]|0;z=i;while(1){Q=f[k+(z<<2)>>2]|0;if(Q|0)break;w=z+1|0;if(w>>>0<h>>>0)z=w;else{R=0;S=w;break b}}if((Q|0)==(f[k+((z^1)<<2)>>2]|0)){R=f[(f[Q>>2]|0)+16>>2]|0;S=z;break}else{R=Q;S=z;break}}else{R=0;S=i}while(0);f[g>>2]=R;f[g+4>>2]=j;f[g+8>>2]=S;i=a+28|0;h=m;n=0;while(1){Wdc(d);q=f[g>>2]|0;if(!q)break;t=f[q+12>>2]|0;q=t+16|0;v=f[i>>2]|0;if(!v){y=VDc(32)|0;f[y+12>>2]=0;f[y+4>>2]=527320;f[y+8>>2]=0;f[y+20>>2]=0;T=y}else{if(f[v+64>>2]|0)OQb(v,14760,32);y=MQb(v,32)|0;B=v;f[y+12>>2]=B;f[y+4>>2]=527320;f[y+8>>2]=0;f[y+20>>2]=B;T=y}f[T>>2]=79512;f[T+24>>2]=t;f[T+28>>2]=q;f[T+16>>2]=3;if((n|0)!=(T|0))if(!n)U=T;else{Yi[f[(f[n>>2]|0)+4>>2]&2047](n);U=T}else U=n;b[h>>0]=18;q=h+1|0;t=U+16|0;y=f[t>>2]|0;if(!(y&1)){V=y;W=0}else{y=_i[f[(f[U>>2]|0)+100>>2]&1023](U)|0;B=b[y+11>>0]|0;v=B<<24>>24<0?f[y+4>>2]|0:B&255;B=v+1+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0;V=f[t>>2]|0;W=B}if(!(V&2))X=0;else{B=_i[f[(f[U>>2]|0)+104>>2]&1023](U)|0;t=_i[f[(f[B>>2]|0)+60>>2]&1023](B)|0;X=t+1+((((($(t|1|0)|0)^31)*9|0)+73|0)>>>6)|0}t=X+W|0;if(t>>>0>127){B=t;v=q;while(1){b[v>>0]=B|128;y=B>>>7;l=v+1|0;if(B>>>0>16383){B=y;v=l}else{Y=l;Z=y;break}}}else{Y=q;Z=t}b[Y>>0]=Z;v=_i[f[(f[U>>2]|0)+100>>2]&1023](U)|0;b[Y+1>>0]=10;B=dSb(v,Y+2|0)|0;v=_i[f[(f[U>>2]|0)+104>>2]&1023](U)|0;b[B>>0]=18;z=B+1|0;B=_i[f[(f[v>>2]|0)+60>>2]&1023](v)|0;if(B>>>0>127){k=B;y=z;while(1){b[y>>0]=k|128;l=k>>>7;w=y+1|0;if(k>>>0>16383){k=l;y=w}else{_=w;aa=l;break}}}else{_=z;aa=B}b[_>>0]=aa;y=hj[f[(f[v>>2]|0)+64>>2]&511](v,c,_+1|0)|0;k=(_i[f[(f[U>>2]|0)+20>>2]&1023](U)|0)==0;t=f[(f[g>>2]|0)+12>>2]|0;q=b[t+11>>0]|0;if(q<<24>>24<0){ba=f[t>>2]|0;ca=f[t+4>>2]|0}else{ba=t;ca=q&255}gUb(ba,ca,1,396681)|0;pJa(g)|0;h=y;n=k?U:0}if(!n)P=h;else{Yi[f[(f[n>>2]|0)+4>>2]&2047](n);P=h}}else P=m;while(0);m=f[a+4>>2]|0;if(!((m&1|0)!=0&(b[473420]|0)!=0)){da=P;u=e;return da|0}da=Hjc(m&-2,P)|0;u=e;return da|0}function bOa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function cOa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,14632,0)|0;if(!c){Ehc(b,a);return}else{sNa(a,c);return}}function dOa(a,b){a=a|0;b=b|0;f[a+48>>2]=b;return}function eOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220311]|0)!=2){f[d>>2]=161028;f[d+4>>2]=3;b[d+8>>0]=0;DTb(881244,d);ZSb(d)}d=520640;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function fOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=a;a=c;a:while(1){c=a;g=a+-4|0;h=a+-8|0;i=e;while(1){j=i;b:while(1){k=j;l=c-k|0;m=l>>2;switch(m|0){case 2:{n=5;break a;break}case 3:{n=10;break a;break}case 4:{n=11;break a;break}case 5:{n=12;break a;break}case 1:case 0:{n=111;break a;break}default:{}}if((l|0)<124){n=14;break a}o=j+(((m|0)/2|0)<<2)|0;if((l|0)>3996){l=(m|0)/4|0;p=JOa(j,j+(l<<2)|0,o,o+(l<<2)|0,g,d)|0}else p=HOa(j,o,g,d)|0;q=f[j>>2]|0;l=f[o>>2]|0;m=b[l+11>>0]|0;r=m<<24>>24<0;s=r?f[l+4>>2]|0:m&255;m=b[q+11>>0]|0;t=m<<24>>24<0;u=t?f[q+4>>2]|0:m&255;m=s>>>0<u>>>0?s:u;if((m|0)!=0?(v=Arc(t?f[q>>2]|0:q,r?f[l>>2]|0:l,m)|0,(v|0)!=0):0){if((v|0)<0){w=g;x=p;break}}else n=20;if((n|0)==20?(n=0,u>>>0<s>>>0):0){w=g;x=p;break}if((j|0)!=(h|0))if(r){r=h;do{v=f[r>>2]|0;m=b[v+11>>0]|0;y=m<<24>>24<0;z=y?f[v+4>>2]|0:m&255;m=s>>>0<z>>>0?s:z;if((m|0)!=0?(A=Arc(y?f[v>>2]|0:v,f[l>>2]|0,m)|0,(A|0)!=0):0){if((A|0)<0){B=r;n=74;break b}}else n=27;if((n|0)==27?(n=0,z>>>0<s>>>0):0){B=r;n=74;break b}r=r+-4|0}while((j|0)!=(r|0))}else{r=h;do{z=f[r>>2]|0;A=b[z+11>>0]|0;m=A<<24>>24<0;v=m?f[z+4>>2]|0:A&255;A=s>>>0<v>>>0?s:v;if((A|0)!=0?(y=Arc(m?f[z>>2]|0:z,l,A)|0,(y|0)!=0):0){if((y|0)<0){B=r;n=74;break b}}else n=71;if((n|0)==71?(n=0,v>>>0<s>>>0):0){B=r;n=74;break b}r=r+-4|0}while((j|0)!=(r|0))}r=j+4|0;s=f[g>>2]|0;l=b[s+11>>0]|0;v=l<<24>>24<0;y=v?f[s+4>>2]|0:l&255;l=y>>>0<u>>>0?y:u;A=s;if((l|0)!=0?(z=Arc(t?f[q>>2]|0:q,v?f[s>>2]|0:s,l)|0,(z|0)!=0):0)if((z|0)<0)C=r;else n=33;else if(u>>>0<y>>>0)C=r;else n=33;if((n|0)==33){n=0;if((r|0)==(g|0)){n=111;break a}c:do if(t){y=r;while(1){z=f[y>>2]|0;l=b[z+11>>0]|0;s=l<<24>>24<0;v=s?f[z+4>>2]|0:l&255;l=v>>>0<u>>>0?v:u;if((l|0)!=0?(m=Arc(f[q>>2]|0,s?f[z>>2]|0:z,l)|0,(m|0)!=0):0){if((m|0)<0){D=y;break c}}else n=38;if((n|0)==38?(n=0,u>>>0<v>>>0):0){D=y;break c}y=y+4|0;if((y|0)==(g|0)){n=111;break a}}}else{y=r;while(1){v=f[y>>2]|0;m=b[v+11>>0]|0;l=m<<24>>24<0;z=l?f[v+4>>2]|0:m&255;m=z>>>0<u>>>0?z:u;if((m|0)!=0?(s=Arc(q,l?f[v>>2]|0:v,m)|0,(s|0)!=0):0){if((s|0)<0){D=y;break c}}else n=42;if((n|0)==42?(n=0,u>>>0<z>>>0):0){D=y;break c}y=y+4|0;if((y|0)==(g|0)){n=111;break a}}}while(0);u=f[D>>2]|0;f[D>>2]=A;f[g>>2]=u;C=D+4|0}if((C|0)==(g|0)){n=111;break a}else{E=g;F=C}while(1){u=f[j>>2]|0;r=b[u+11>>0]|0;t=r<<24>>24<0;y=t?f[u+4>>2]|0:r&255;d:do if(t){r=F;while(1){z=f[r>>2]|0;s=b[z+11>>0]|0;m=s<<24>>24<0;v=m?f[z+4>>2]|0:s&255;s=v>>>0<y>>>0?v:y;if((s|0)!=0?(l=Arc(f[u>>2]|0,m?f[z>>2]|0:z,s)|0,(l|0)!=0):0){if((l|0)<0){G=r;break d}}else n=51;if((n|0)==51?(n=0,y>>>0<v>>>0):0){G=r;break d}r=r+4|0}}else{r=F;while(1){v=f[r>>2]|0;l=b[v+11>>0]|0;s=l<<24>>24<0;z=s?f[v+4>>2]|0:l&255;l=z>>>0<y>>>0?z:y;if((l|0)!=0?(m=Arc(u,s?f[v>>2]|0:v,l)|0,(m|0)!=0):0){if((m|0)<0){G=r;break d}}else n=55;if((n|0)==55?(n=0,y>>>0<z>>>0):0){G=r;break d}r=r+4|0}}while(0);e:do if(t){r=E;while(1){z=r+-4|0;m=f[z>>2]|0;l=b[m+11>>0]|0;v=l<<24>>24<0;s=v?f[m+4>>2]|0:l&255;l=s>>>0<y>>>0?s:y;if(l|0?(H=Arc(f[u>>2]|0,v?f[m>>2]|0:m,l)|0,H|0):0)if((H|0)<0){r=z;continue}else{I=z;break e}if(y>>>0<s>>>0)r=z;else{I=z;break}}}else{r=E;while(1){z=r+-4|0;s=f[z>>2]|0;H=b[s+11>>0]|0;l=H<<24>>24<0;m=l?f[s+4>>2]|0:H&255;H=m>>>0<y>>>0?m:y;if(H|0?(v=Arc(u,l?f[s>>2]|0:s,H)|0,v|0):0)if((v|0)<0){r=z;continue}else{I=z;break e}if(y>>>0<m>>>0)r=z;else{I=z;break}}}while(0);if(G>>>0>=I>>>0){j=G;continue b}y=f[G>>2]|0;f[G>>2]=f[I>>2];f[I>>2]=y;E=I;F=G+4|0}}if((n|0)==74){n=0;f[j>>2]=f[B>>2];f[B>>2]=q;w=B;x=p+1|0}A=j+4|0;f:do if(A>>>0<w>>>0){y=o;u=w;t=A;r=x;while(1){z=f[y>>2]|0;m=b[z+11>>0]|0;v=m<<24>>24<0;H=v?f[z+4>>2]|0:m&255;g:do if(v){m=t;while(1){s=f[m>>2]|0;l=b[s+11>>0]|0;J=l<<24>>24<0;K=J?f[s+4>>2]|0:l&255;l=H>>>0<K>>>0?H:K;if((l|0)!=0?(L=Arc(J?f[s>>2]|0:s,f[z>>2]|0,l)|0,(L|0)!=0):0){if((L|0)>=0){M=m;break g}}else n=80;if((n|0)==80?(n=0,K>>>0>=H>>>0):0){M=m;break g}m=m+4|0}}else{m=t;while(1){K=f[m>>2]|0;L=b[K+11>>0]|0;l=L<<24>>24<0;s=l?f[K+4>>2]|0:L&255;L=H>>>0<s>>>0?H:s;if((L|0)!=0?(J=Arc(l?f[K>>2]|0:K,z,L)|0,(J|0)!=0):0){if((J|0)>=0){M=m;break g}}else n=84;if((n|0)==84?(n=0,s>>>0>=H>>>0):0){M=m;break g}m=m+4|0}}while(0);h:do if(v){m=u;while(1){s=m+-4|0;J=f[s>>2]|0;L=b[J+11>>0]|0;K=L<<24>>24<0;l=K?f[J+4>>2]|0:L&255;L=H>>>0<l>>>0?H:l;if(L|0?(N=Arc(K?f[J>>2]|0:J,f[z>>2]|0,L)|0,N|0):0)if((N|0)<0){O=s;break h}else{m=s;continue}if(l>>>0<H>>>0){O=s;break}else m=s}}else{m=u;while(1){s=m+-4|0;l=f[s>>2]|0;N=b[l+11>>0]|0;L=N<<24>>24<0;J=L?f[l+4>>2]|0:N&255;N=H>>>0<J>>>0?H:J;if(N|0?(K=Arc(L?f[l>>2]|0:l,z,N)|0,K|0):0)if((K|0)<0){O=s;break h}else{m=s;continue}if(J>>>0<H>>>0){O=s;break}else m=s}}while(0);if(M>>>0>O>>>0){P=y;Q=r;R=M;break f}H=f[M>>2]|0;f[M>>2]=f[O>>2];f[O>>2]=H;y=(y|0)==(M|0)?O:y;u=O;t=M+4|0;r=r+1|0}}else{P=o;Q=x;R=A}while(0);do if((R|0)==(P|0))S=Q;else{A=f[P>>2]|0;r=f[R>>2]|0;t=b[r+11>>0]|0;u=t<<24>>24<0;y=u?f[r+4>>2]|0:t&255;t=b[A+11>>0]|0;H=t<<24>>24<0;z=H?f[A+4>>2]|0:t&255;t=y>>>0<z>>>0?y:z;v=r;m=A;if((t|0)!=0?(s=Arc(H?f[A>>2]|0:A,u?f[r>>2]|0:r,t)|0,(s|0)!=0):0){if((s|0)>=0){S=Q;break}}else n=101;if((n|0)==101?(n=0,z>>>0>=y>>>0):0){S=Q;break}f[R>>2]=m;f[P>>2]=v;S=Q+1|0}while(0);if(!S){T=LOa(j,R,d)|0;v=R+4|0;if(LOa(v,a,d)|0){n=110;break}if(T){i=v;continue}}v=R;if((v-k|0)>=(c-v|0)){n=109;break}fOa(j,R,d);i=R+4|0}if((n|0)==109){n=0;fOa(R+4|0,a,d);e=j;a=R;continue}else if((n|0)==110){n=0;if(T){n=111;break}else{e=j;a=R;continue}}}if((n|0)==5){R=f[g>>2]|0;e=f[j>>2]|0;T=b[e+11>>0]|0;k=T<<24>>24<0;S=k?f[e+4>>2]|0:T&255;T=b[R+11>>0]|0;Q=T<<24>>24<0;P=Q?f[R+4>>2]|0:T&255;T=S>>>0<P>>>0?S:P;x=e;o=R;if((T|0)!=0?(M=Arc(Q?f[R>>2]|0:R,k?f[e>>2]|0:e,T)|0,(M|0)!=0):0){if((M|0)>=0)return}else n=7;if((n|0)==7?P>>>0>=S>>>0:0)return;f[j>>2]=o;f[g>>2]=x;return}else if((n|0)==10){HOa(j,j+4|0,g,d)|0;return}else if((n|0)==11){IOa(j,j+4|0,j+8|0,g,d)|0;return}else if((n|0)==12){JOa(j,j+4|0,j+8|0,j+12|0,g,d)|0;return}else if((n|0)==14){KOa(j,a,d);return}else if((n|0)==111)return}function gOa(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=79628;c=a+20|0;d=f[c>>2]|0;if(d&1|0?(e=d&-2,d=e,!((e|0)==0|(f[d+4>>2]|0)!=0)):0){if(f[d>>2]|0)ljc(d);YDc(e)}f[c>>2]=0;f[a>>2]=79744;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function hOa(a){a=a|0;gOa(a);YDc(a);return}function iOa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function jOa(a){a=a|0;a=VDc(24)|0;f[a+12>>2]=0;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a>>2]=79204;return a|0}function kOa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=VDc(24)|0;f[a+12>>2]=0;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;c=a;f[c>>2]=79204;return c|0}if(f[b+64>>2]|0)OQb(b,14688,24);a=MQb(b,24)|0;d=b;f[a+12>>2]=d;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=d;c=a;f[c>>2]=79204;return c|0}function lOa(a){a=a|0;return f[a+12>>2]|0}function mOa(a){a=a|0;return _i[f[(f[a>>2]|0)+20>>2]&1023](a)|0}function nOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+4>>2]|0;do if((c|0)!=527320){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+8>>2]|0;if(!c){e=a+16|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}Yi[f[(f[c>>2]|0)+28>>2]&2047](c);e=a+16|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}function oOa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&1023](b)|0}function pOa(a,b){a=a|0;b=b|0;NNa(a,b);return}function qOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+4|0;j=a+12|0;k=a+8|0;a=e+4|0;l=c+32|0;m=c+12|0;n=c+28|0;a:while(1){o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){p=b[o>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=o+1;r=q}else{s=q;t=5}}else{s=0;t=5}if((t|0)==5){t=0;r=WRb(c,s)|0}switch(r|0){case 0:{v=1;t=35;break a;break}case 10:{f[h>>2]=f[h>>2]|1;q=f[i>>2]|0;if((q|0)==527320){WJa(i,f[j>>2]|0,527320);w=f[i>>2]|0}else w=q;if(!(fUb(c,w)|0)){v=0;t=35;break a}q=f[h>>2]|1;f[h>>2]=q;o=f[c>>2]|0;if(o>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[o>>0]|0)!=18)continue a;f[c>>2]=o+1;x=q;break}case 18:{x=f[h>>2]|0;break}default:{if((r&7|0)==4){v=1;t=35;break a}if(ITb(c,r)|0)continue a;else{v=0;t=35;break a}}}f[h>>2]=x|2;q=f[j>>2]|0;o=f[k>>2]|0;if(!o){if(!q){p=VDc(24)|0;JNa(p);y=p}else{if(f[q+64>>2]|0)OQb(q,14672,24);p=MQb(q,24)|0;KNa(p,q);y=p}f[k>>2]=y;z=y}else z=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(p=b[o>>0]|0,p<<24>>24>-1):0){f[c>>2]=o+1;A=p&255}else{p=VRb(c)|0;if((p|0)>-1)A=p;else{v=0;t=35;break}}GRb(e,c,A);if((f[a>>2]|0)<0){t=27;break}if(!(BOa(z,c)|0)){t=27;break}if(!(LRb(c,f[e>>2]|0)|0)){v=0;t=35;break}f[h>>2]=f[h>>2]|2;if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[l>>2]|0){t=32;break}if((f[m>>2]|0)==(f[n>>2]|0)){t=32;break}}if((t|0)==27){v=0;u=d;return v|0}else if((t|0)==32){f[c+20>>2]=0;b[c+24>>0]=1;v=1;u=d;return v|0}else if((t|0)==35){u=d;return v|0}return 0}function rOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=AOa(_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0)|0;j=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function sOa(a,b){a=a|0;b=b|0;_Tb(1,_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0,b);eUb(2,_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0,b);return}function tOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0;a=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;j=a+1+((((($(a|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function uOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;b[d>>0]=10;g=dSb(e,d+1|0)|0;d=_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0;b[g>>0]=18;a=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(g>>>0>127){e=g;h=a;while(1){b[h>>0]=e|128;i=e>>>7;j=h+1|0;if(e>>>0>16383){e=i;h=j}else{k=j;l=i;break}}}else{k=a;l=g}b[k>>0]=l;return hj[f[(f[d>>2]|0)+64>>2]&511](d,c,k+1|0)|0}function vOa(a,b){a=a|0;b=b|0;hec(a,b);return}function wOa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (_i[f[(f[b>>2]|0)+84>>2]&1023](b)|0)+28|0}function xOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220311]|0)!=2){f[d>>2]=161028;f[d+4>>2]=3;b[d+8>>0]=0;DTb(881244,d);ZSb(d)}d=520632;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function yOa(a){a=a|0;return f[a+24>>2]|0}function zOa(a){a=a|0;return f[a+28>>2]|0}function AOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;do switch(f[a+20>>2]|0){case 2:{c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0?f[c+4>>2]|0:e&255;h=d+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 3:{g=a+8|0;h=d+1+(((((iJc(f[g>>2]|1|0,f[g+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 4:{h=d+5|0;i=a+16|0;f[i>>2]=h;return h|0}case 5:{h=d+2|0;i=a+16|0;f[i>>2]=h;return h|0}case 6:{g=f[a+8>>2]|0;if((g|0)<0)j=11;else j=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=j+d|0;i=a+16|0;f[i>>2]=h;return h|0}case 7:{g=f[a+8>>2]|0;e=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;h=d+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 8:{e=f[a+8>>2]|0;g=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;h=d+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 1:{g=f[a+8>>2]|0;e=_i[f[(f[g>>2]|0)+48>>2]&1023](g)|0;h=d+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 10:{e=f[a+8>>2]|0;g=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;h=d+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 9:{g=f[a+8>>2]|0;e=b[g+11>>0]|0;c=e<<24>>24<0?f[g+4>>2]|0:e&255;h=d+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}default:{h=d;i=a+16|0;f[i>>2]=h;return h|0}}while(0);return 0}function BOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+16|0;e=d;g=c+4|0;i=e+4|0;j=a+20|0;k=a+8|0;l=a+4|0;m=a+8|0;n=e+8|0;o=e+8|0;p=e+4|0;q=e+4|0;r=e+4|0;a:while(1){s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){t=b[s>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=s+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=WRb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;do switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=10){z=w;break b}v=pNa(a)|0;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(t=b[s>>0]|0,t<<24>>24>-1):0){f[c>>2]=s+1;A=t&255}else{t=VRb(c)|0;if((t|0)>-1)A=t;else{B=0;x=104;break a}}GRb(e,c,A);if((f[i>>2]|0)<0){x=14;break a}if(!(Mi[f[(f[v>>2]|0)+44>>2]&1023](v,c)|0)){x=14;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;x=104;break a}break}case 2:{if((w&255|0)!=18){z=w;break b}if((f[j>>2]|0)!=2){nNa(a);f[j>>2]=2;f[k>>2]=527320}v=f[l>>2]|0;t=v&-2;if(!(v&1))C=t;else C=f[t+4>>2]|0;t=f[k>>2]|0;if((t|0)==527320){WJa(k,C,527320);D=f[k>>2]|0}else D=t;if(fUb(c,D)|0)continue a;else{B=0;x=104;break a}break}case 3:{if((w&255|0)!=24){z=w;break b}nNa(a);t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(v=b[t>>0]|0,v<<24>>24>-1):0){f[c>>2]=t+1;E=v&255;F=0}else{IRb(e,c);v=e;if(!(b[n>>0]|0)){B=0;x=104;break a}else{E=f[v>>2]|0;F=f[v+4>>2]|0}}v=m;f[v>>2]=E;f[v+4>>2]=F;f[j>>2]=3;continue a;break}case 4:{if((w&255|0)!=37){z=w;break b}nNa(a);v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){t=v;s=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=s;f[c>>2]=v+4;G=s}else{if(!(TRb(c,e)|0)){x=36;break a}G=f[e>>2]|0}f[k>>2]=G;f[j>>2]=4;continue a;break}case 5:{if((w&255|0)!=40){z=w;break b}nNa(a);s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;H=v<<24>>24!=0}else{IRb(e,c);v=e;if(!(b[o>>0]|0)){B=0;x=104;break a}else H=(f[v>>2]|0)!=0|(f[v+4>>2]|0)!=0}b[k>>0]=H&1;f[j>>2]=5;continue a;break}case 6:{if((w&255|0)!=48){z=w;break b}v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){s=b[v>>0]|0;t=s&255;if(s<<24>>24>-1){f[c>>2]=v+1;I=t}else{K=t;x=48}}else{K=0;x=48}if((x|0)==48){x=0;t=HRb(c,K)|0;v=J;if((v|0)>-1|(v|0)==-1&t>>>0>4294967295)I=t;else{B=0;x=104;break a}}if((f[j>>2]|0)!=6){nNa(a);f[j>>2]=6}f[k>>2]=I;continue a;break}case 7:{if((w&255|0)!=58){z=w;break b}t=oNa(a)|0;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(s=b[v>>0]|0,s<<24>>24>-1):0){f[c>>2]=v+1;L=s&255}else{s=VRb(c)|0;if((s|0)>-1)L=s;else{B=0;x=104;break a}}GRb(e,c,L);if((f[p>>2]|0)<0){x=59;break a}if(!(Mi[f[(f[t>>2]|0)+44>>2]&1023](t,c)|0)){x=59;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;x=104;break a}break}case 8:{if((w&255|0)!=66){z=w;break b}t=UJa(a)|0;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;M=v&255}else{v=VRb(c)|0;if((v|0)>-1)M=v;else{B=0;x=104;break a}}GRb(e,c,M);if((f[q>>2]|0)<0){x=68;break a}if(!(Mi[f[(f[t>>2]|0)+44>>2]&1023](t,c)|0)){x=68;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;x=104;break a}break}case 9:{if((w&255|0)!=74){z=w;break b}if((f[j>>2]|0)!=9){nNa(a);f[j>>2]=9;f[k>>2]=527320}t=f[l>>2]|0;v=t&-2;if(!(t&1))N=v;else N=f[v+4>>2]|0;v=f[k>>2]|0;if((v|0)==527320){WJa(k,N,527320);O=f[k>>2]|0}else O=v;if(!(fUb(c,O)|0)){B=0;x=104;break a}v=(f[j>>2]|0)==9;if(v){t=f[k>>2]|0;P=t;Q=t}else{P=527320;Q=527320}if((b[Q+11>>0]|0)<0)R=f[P>>2]|0;else R=P;if(v){v=f[k>>2]|0;S=v;T=v}else{S=527320;T=527320}v=b[T+11>>0]|0;if(v<<24>>24<0)U=f[S+4>>2]|0;else U=v&255;if(gUb(R,U,0,396726)|0)continue a;else{B=0;x=104;break a}break}case 10:{if((w&255|0)!=82){z=w;break b}v=rNa(a)|0;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(s=b[t>>0]|0,s<<24>>24>-1):0){f[c>>2]=t+1;V=s&255}else{s=VRb(c)|0;if((s|0)>-1)V=s;else{B=0;x=104;break a}}GRb(e,c,V);if((f[r>>2]|0)<0){x=97;break a}if(!(Mi[f[(f[v>>2]|0)+44>>2]&1023](v,c)|0)){x=97;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{B=0;x=104;break a}break}default:{z=w;break b}}while(0)}while(0);if(!z){B=1;x=104;break}v=f[l>>2]|0;if(!(v&1))W=mNa(l)|0;else W=v&-2;if(!(Djc(c,z,W)|0)){B=0;x=104;break}}if((x|0)==14){B=0;u=d;return B|0}else if((x|0)==36){B=0;u=d;return B|0}else if((x|0)==59){B=0;u=d;return B|0}else if((x|0)==68){B=0;u=d;return B|0}else if((x|0)==97){B=0;u=d;return B|0}else if((x|0)==104){u=d;return B|0}return 0}function COa(a){a=a|0;var c=0;f[a>>2]=79744;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function DOa(a){a=a|0;var c=0;f[a>>2]=79744;if(f[a+12>>2]|0){YDc(a);return}c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c){YDc(a);return}Yi[f[(f[c>>2]|0)+4>>2]&2047](c);YDc(a);return}function EOa(a){a=a|0;return f[a+4>>2]|0}function FOa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (b|0?b:f[130136]|0)|0}function GOa(a){a=a|0;gOa(a);YDc(a);return}function HOa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=f[c>>2]|0;g=f[a>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0;j=g+4|0;k=i?f[j>>2]|0:h&255;h=b[e+11>>0]|0;l=h<<24>>24<0;m=l?f[e+4>>2]|0:h&255;h=k>>>0<m>>>0;n=h?k:m;o=e;p=g;if((n|0)!=0?(q=Arc(l?f[e>>2]|0:e,i?f[g>>2]|0:g,n)|0,(q|0)!=0):0)r=q;else r=m>>>0<k>>>0?-1:h&1;h=(r|0)<0;r=f[d>>2]|0;k=b[r+11>>0]|0;q=k<<24>>24<0;n=q?f[r+4>>2]|0:k&255;k=m>>>0<n>>>0;i=k?m:n;s=r;if((i|0)!=0?(t=Arc(q?f[r>>2]|0:r,l?f[e>>2]|0:e,i)|0,(t|0)!=0):0)u=t;else u=n>>>0<m>>>0?-1:k&1;k=(u|0)<0;if(!h){if(!k){v=0;return v|0}f[c>>2]=s;f[d>>2]=o;h=f[c>>2]|0;u=f[a>>2]|0;m=b[u+11>>0]|0;n=m<<24>>24<0;t=n?f[u+4>>2]|0:m&255;m=b[h+11>>0]|0;i=m<<24>>24<0;e=i?f[h+4>>2]|0:m&255;m=t>>>0<e>>>0?t:e;l=u;r=h;if((m|0)!=0?(q=Arc(i?f[h>>2]|0:h,n?f[u>>2]|0:u,m)|0,(q|0)!=0):0){if((q|0)>=0){v=1;return v|0}}else w=11;if((w|0)==11?e>>>0>=t>>>0:0){v=1;return v|0}f[a>>2]=r;f[c>>2]=l;v=2;return v|0}if(k){f[a>>2]=s;f[d>>2]=p;v=1;return v|0}f[a>>2]=o;f[c>>2]=p;o=f[d>>2]|0;a=b[g+11>>0]|0;s=a<<24>>24<0;k=s?f[j>>2]|0:a&255;a=b[o+11>>0]|0;j=a<<24>>24<0;l=j?f[o+4>>2]|0:a&255;a=k>>>0<l>>>0?k:l;r=o;if((a|0)!=0?(t=Arc(j?f[o>>2]|0:o,s?f[g>>2]|0:g,a)|0,(t|0)!=0):0){if((t|0)>=0){v=1;return v|0}}else w=18;if((w|0)==18?l>>>0>=k>>>0:0){v=1;return v|0}f[c>>2]=r;f[d>>2]=p;v=2;return v|0}function IOa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=HOa(a,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;l=k?f[i+4>>2]|0:j&255;j=b[g+11>>0]|0;m=j<<24>>24<0;n=m?f[g+4>>2]|0:j&255;j=l>>>0<n>>>0?l:n;o=i;p=g;if((j|0)!=0?(q=Arc(m?f[g>>2]|0:g,k?f[i>>2]|0:i,j)|0,(q|0)!=0):0){if((q|0)>=0){r=h;return r|0}}else s=3;if((s|0)==3?n>>>0>=l>>>0:0){r=h;return r|0}f[d>>2]=p;f[e>>2]=o;o=h+1|0;e=f[d>>2]|0;p=f[c>>2]|0;l=b[p+11>>0]|0;n=l<<24>>24<0;q=n?f[p+4>>2]|0:l&255;l=b[e+11>>0]|0;j=l<<24>>24<0;i=j?f[e+4>>2]|0:l&255;l=q>>>0<i>>>0?q:i;k=p;g=e;if((l|0)!=0?(m=Arc(j?f[e>>2]|0:e,n?f[p>>2]|0:p,l)|0,(m|0)!=0):0){if((m|0)>=0){r=o;return r|0}}else s=7;if((s|0)==7?i>>>0>=q>>>0:0){r=o;return r|0}f[c>>2]=g;f[d>>2]=k;k=h+2|0;d=f[c>>2]|0;g=f[a>>2]|0;o=b[g+11>>0]|0;q=o<<24>>24<0;i=q?f[g+4>>2]|0:o&255;o=b[d+11>>0]|0;m=o<<24>>24<0;l=m?f[d+4>>2]|0:o&255;o=i>>>0<l>>>0?i:l;p=g;n=d;if((o|0)!=0?(e=Arc(m?f[d>>2]|0:d,q?f[g>>2]|0:g,o)|0,(e|0)!=0):0){if((e|0)>=0){r=k;return r|0}}else s=11;if((s|0)==11?l>>>0>=i>>>0:0){r=k;return r|0}f[a>>2]=n;f[c>>2]=p;r=h+3|0;return r|0}function JOa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=IOa(a,c,d,e,h)|0;h=f[g>>2]|0;j=f[e>>2]|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[j+4>>2]|0:k&255;k=b[h+11>>0]|0;n=k<<24>>24<0;o=n?f[h+4>>2]|0:k&255;k=m>>>0<o>>>0?m:o;p=j;q=h;if((k|0)!=0?(r=Arc(n?f[h>>2]|0:h,l?f[j>>2]|0:j,k)|0,(r|0)!=0):0){if((r|0)>=0){s=i;return s|0}}else t=3;if((t|0)==3?o>>>0>=m>>>0:0){s=i;return s|0}f[e>>2]=q;f[g>>2]=p;p=i+1|0;g=f[e>>2]|0;q=f[d>>2]|0;m=b[q+11>>0]|0;o=m<<24>>24<0;r=o?f[q+4>>2]|0:m&255;m=b[g+11>>0]|0;k=m<<24>>24<0;j=k?f[g+4>>2]|0:m&255;m=r>>>0<j>>>0?r:j;l=q;h=g;if((m|0)!=0?(n=Arc(k?f[g>>2]|0:g,o?f[q>>2]|0:q,m)|0,(n|0)!=0):0){if((n|0)>=0){s=p;return s|0}}else t=7;if((t|0)==7?j>>>0>=r>>>0:0){s=p;return s|0}f[d>>2]=h;f[e>>2]=l;l=i+2|0;e=f[d>>2]|0;h=f[c>>2]|0;p=b[h+11>>0]|0;r=p<<24>>24<0;j=r?f[h+4>>2]|0:p&255;p=b[e+11>>0]|0;n=p<<24>>24<0;m=n?f[e+4>>2]|0:p&255;p=j>>>0<m>>>0?j:m;q=h;o=e;if((p|0)!=0?(g=Arc(n?f[e>>2]|0:e,r?f[h>>2]|0:h,p)|0,(g|0)!=0):0){if((g|0)>=0){s=l;return s|0}}else t=11;if((t|0)==11?m>>>0>=j>>>0:0){s=l;return s|0}f[c>>2]=o;f[d>>2]=q;q=i+3|0;d=f[c>>2]|0;o=f[a>>2]|0;l=b[o+11>>0]|0;j=l<<24>>24<0;m=j?f[o+4>>2]|0:l&255;l=b[d+11>>0]|0;g=l<<24>>24<0;p=g?f[d+4>>2]|0:l&255;l=m>>>0<p>>>0?m:p;h=o;r=d;if((l|0)!=0?(e=Arc(g?f[d>>2]|0:d,j?f[o>>2]|0:o,l)|0,(e|0)!=0):0){if((e|0)>=0){s=q;return s|0}}else t=15;if((t|0)==15?p>>>0>=m>>>0:0){s=q;return s|0}f[a>>2]=r;f[c>>2]=h;s=i+4|0;return s|0}function KOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=a+8|0;HOa(a,a+4|0,e,d)|0;d=a+12|0;if((d|0)==(c|0))return;else{g=d;h=e}while(1){e=f[g>>2]|0;d=f[h>>2]|0;i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d+4>>2]|0:i&255;i=b[e+11>>0]|0;l=i<<24>>24<0;m=e+4|0;n=l?f[m>>2]|0:i&255;i=k>>>0<n>>>0?k:n;o=e;p=d;if((i|0)!=0?(q=Arc(l?f[e>>2]|0:e,j?f[d>>2]|0:d,i)|0,(q|0)!=0):0){if((q|0)<0)r=7}else r=5;if((r|0)==5?(r=0,n>>>0<k>>>0):0)r=7;if((r|0)==7){r=0;f[g>>2]=p;a:do if((h|0)==(a|0))s=h;else{p=b[e+11>>0]|0;k=p<<24>>24<0;n=p&255;p=h;q=h;while(1){i=q;q=p+-4|0;d=f[q>>2]|0;j=b[d+11>>0]|0;l=j<<24>>24<0;t=l?f[d+4>>2]|0:j&255;j=k?f[m>>2]|0:n;u=t>>>0<j>>>0?t:j;v=d;if((u|0)!=0?(w=Arc(k?f[e>>2]|0:e,l?f[d>>2]|0:d,u)|0,(w|0)!=0):0){if((w|0)>=0){s=i;break a}}else r=11;if((r|0)==11?(r=0,j>>>0>=t>>>0):0){s=i;break a}f[i>>2]=v;if((q|0)==(a|0)){s=q;break}else p=q}}while(0);f[s>>2]=o}e=g+4|0;if((e|0)==(c|0))break;else{m=g;g=e;h=m}}return}function LOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;switch(c-a>>2|0){case 2:{e=c+-4|0;g=f[e>>2]|0;h=f[a>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;k=j?f[h+4>>2]|0:i&255;i=b[g+11>>0]|0;l=i<<24>>24<0;m=l?f[g+4>>2]|0:i&255;i=k>>>0<m>>>0?k:m;n=h;o=g;if((i|0)!=0?(p=Arc(l?f[g>>2]|0:g,j?f[h>>2]|0:h,i)|0,(p|0)!=0):0){if((p|0)>=0){q=1;return q|0}}else r=4;if((r|0)==4?m>>>0>=k>>>0:0){q=1;return q|0}f[a>>2]=o;f[e>>2]=n;q=1;return q|0}case 3:{HOa(a,a+4|0,c+-4|0,d)|0;q=1;return q|0}case 4:{IOa(a,a+4|0,a+8|0,c+-4|0,d)|0;q=1;return q|0}case 5:{JOa(a,a+4|0,a+8|0,a+12|0,c+-4|0,d)|0;q=1;return q|0}case 1:case 0:{q=1;return q|0}default:{n=a+8|0;HOa(a,a+4|0,n,d)|0;d=a+12|0;a:do if((d|0)==(c|0)){s=1;t=0}else{e=d;o=0;k=n;while(1){m=f[e>>2]|0;p=f[k>>2]|0;i=b[p+11>>0]|0;h=i<<24>>24<0;j=h?f[p+4>>2]|0:i&255;i=b[m+11>>0]|0;g=i<<24>>24<0;l=m+4|0;u=g?f[l>>2]|0:i&255;i=j>>>0<u>>>0?j:u;v=m;w=p;if((i|0)!=0?(x=Arc(g?f[m>>2]|0:m,h?f[p>>2]|0:p,i)|0,(x|0)!=0):0)if((x|0)<0)r=15;else y=o;else if(u>>>0<j>>>0)r=15;else y=o;if((r|0)==15){r=0;f[e>>2]=w;b:do if((k|0)==(a|0))z=k;else{w=b[m+11>>0]|0;j=w<<24>>24<0;u=w&255;w=k;x=k;while(1){x=x+-4|0;i=f[x>>2]|0;p=b[i+11>>0]|0;h=p<<24>>24<0;g=h?f[i+4>>2]|0:p&255;p=j?f[l>>2]|0:u;A=g>>>0<p>>>0?g:p;B=i;if((A|0)!=0?(C=Arc(j?f[m>>2]|0:m,h?f[i>>2]|0:i,A)|0,(C|0)!=0):0){if((C|0)>=0){z=w;break b}}else r=19;if((r|0)==19?(r=0,p>>>0>=g>>>0):0){z=w;break b}f[w>>2]=B;if((x|0)==(a|0)){z=x;break}else w=x}}while(0);f[z>>2]=v;m=o+1|0;if((m|0)==8){s=0;t=(e+4|0)==(c|0);break a}else y=m}m=e+4|0;if((m|0)==(c|0)){s=1;t=0;break}else{l=e;e=m;o=y;k=l}}}while(0);q=t|s;return q|0}}return 0}function MOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=f[c>>2]|0;j=c+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(b[i>>0]|0)==10:0){f[c>>2]=i+1;i=a+8|0;if(!(fUb(c,i)|0)){k=0;u=d;return k|0}l=f[c>>2]|0;if((((f[j>>2]|0)-l|0)>0?(b[l>>0]|0)==18:0)?(l=a+4|0,m=f[l>>2]|0,n=f[f[m+8>>2]>>2]|0,o=BJa(m,i)|0,m=a+20|0,f[m>>2]=o,(n|0)!=(f[f[(f[l>>2]|0)+8>>2]>>2]|0)):0){n=f[j>>2]|0;p=f[c>>2]|0;q=n-p|0;if((q|0)<1){PRb(c,1,q)|0;r=f[c>>2]|0;s=f[j>>2]|0;t=f[m>>2]|0}else{m=p+1|0;f[c>>2]=m;r=m;s=n;t=o}if(r>>>0<s>>>0?(s=b[r>>0]|0,s<<24>>24>-1):0){f[c>>2]=r+1;v=s&255;w=14}else w=13;if((w|0)==13?(s=VRb(c)|0,(s|0)>-1):0){v=s;w=14}do if(((w|0)==14?(GRb(e,c,v),(f[e+4>>2]|0)>=0):0)?BOa(t,c)|0:0){if(!(LRb(c,f[e>>2]|0)|0))break;do if((f[c>>2]|0)==(f[j>>2]|0)){if((f[c+32>>2]|0)==0?(f[c+12>>2]|0)!=(f[c+28>>2]|0):0)break;f[c+20>>2]=0;b[c+24>>0]=1;k=1;u=d;return k|0}while(0);k=NOa(a,c)|0;u=d;return k|0}while(0);j=f[l>>2]|0;bJa(e,f[j+8>>2]|0,i,0);i=f[e>>2]|0;l=f[e+4>>2]|0;t=f[e+8>>2]|0;if(i|0){f[g>>2]=i;f[g+4>>2]=l;f[g+8>>2]=t;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];sJa(h,j,e)}k=0;u=d;return k|0}}else w=26;if((w|0)==26?(f[e>>2]=0,f[e+4>>2]=0,f[e+8>>2]=0,iEc(a+8|0,e)|0,(b[e+11>>0]|0)<0):0)YDc(f[e>>2]|0);e=f[(f[a>>2]|0)+20>>2]|0;if(!e){w=VDc(24)|0;f[w+12>>2]=0;f[w+4>>2]=527320;f[w+8>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;x=w}else{if(f[e+64>>2]|0)OQb(e,14688,24);w=MQb(e,24)|0;j=e;f[w+12>>2]=j;f[w+4>>2]=527320;f[w+8>>2]=0;f[w+16>>2]=0;f[w+20>>2]=j;x=w}f[x>>2]=79204;w=a+24|0;j=f[w>>2]|0;if((j|0)==(x|0))y=x;else{if(j|0)Yi[f[(f[j>>2]|0)+4>>2]&2047](j);f[w>>2]=x;y=x}x=y+16|0;f[x>>2]=f[x>>2]|1;x=y+4|0;j=f[x>>2]|0;if((j|0)==527320){WJa(x,f[y+12>>2]|0,527320);z=f[x>>2]|0}else z=j;iEc(z,a+8|0)|0;z=f[w>>2]|0;j=Mi[f[(f[z>>2]|0)+44>>2]&1023](z,c)|0;if(j)OOa(a);a=f[w>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){k=j;u=d;return k|0}f[w>>2]=0;k=j;u=d;return k|0}function NOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+48|0;d=c;e=c+28|0;g=c+16|0;h=f[(f[a>>2]|0)+20>>2]|0;if(!h){i=VDc(24)|0;f[i+12>>2]=0;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=i}else{if(f[h+64>>2]|0)OQb(h,14688,24);i=MQb(h,24)|0;k=h;f[i+12>>2]=k;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+16>>2]=0;f[i+20>>2]=k;j=i}f[j>>2]=79204;i=a+24|0;k=f[i>>2]|0;if((k|0)==(j|0))l=j;else{if(k|0)Yi[f[(f[k>>2]|0)+4>>2]&2047](k);f[i>>2]=j;l=j}j=f[a+20>>2]|0;k=l+16|0;f[k>>2]=f[k>>2]|2;k=l+8|0;h=f[l+12>>2]|0;l=f[k>>2]|0;if(!l){if(!h){m=VDc(24)|0;JNa(m);n=m}else{if(f[h+64>>2]|0)OQb(h,14672,24);m=MQb(h,24)|0;KNa(m,h);n=m}f[k>>2]=n;o=n}else o=l;POa(o,j);j=f[a+4>>2]|0;o=a+8|0;bJa(d,f[j+8>>2]|0,o,0);l=f[d>>2]|0;n=f[d+4>>2]|0;k=f[d+8>>2]|0;if(l|0){f[e>>2]=l;f[e+4>>2]=n;f[e+8>>2]=k;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];sJa(g,j,d)}j=f[i>>2]|0;g=j+16|0;f[g>>2]=f[g>>2]|1;g=j+4|0;e=f[g>>2]|0;if((e|0)==527320){WJa(g,f[j+12>>2]|0,527320);p=f[g>>2]|0}else p=e;f[d>>2]=f[p>>2];f[d+4>>2]=f[p+4>>2];f[d+8>>2]=f[p+8>>2];f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];f[p+8>>2]=f[o+8>>2];f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];f[o+8>>2]=f[d+8>>2];d=f[i>>2]|0;o=Mi[f[(f[d>>2]|0)+44>>2]&1023](d,b)|0;if(o)OOa(a);a=f[i>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){u=c;return o|0}f[i>>2]=0;u=c;return o|0}function OOa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+24|0;c=f[b>>2]|0;d=a+8|0;iEc(d,_i[f[(f[c>>2]|0)+100>>2]&1023](c)|0)|0;c=BJa(f[a+4>>2]|0,d)|0;d=a+20|0;f[d>>2]=c;a=f[b>>2]|0;b=a+16|0;f[b>>2]=f[b>>2]|2;b=a+8|0;e=f[a+12>>2]|0;a=f[b>>2]|0;if(a|0){g=c;h=a;POa(g,h);return}if(!e){a=VDc(24)|0;JNa(a);i=a}else{if(f[e+64>>2]|0)OQb(e,14672,24);a=MQb(e,24)|0;KNa(a,e);i=a}f[b>>2]=i;g=f[d>>2]|0;h=i;POa(g,h);return}function POa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((b|0)==(a|0))return;c=a+4|0;d=f[c>>2]|0;e=(d&1|0)==0;g=d&-2;if(e)h=g;else h=f[g+4>>2]|0;d=f[b+4>>2]|0;i=d&-2;if(!(d&1))j=i;else j=f[i+4>>2]|0;if((h|0)==(j|0)){j=a+8|0;h=j;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b+8|0;k=h;l=f[k+4>>2]|0;m=j;f[m>>2]=f[k>>2];f[m+4>>2]=l;l=h;f[l>>2]=i;f[l+4>>2]=d;d=a+20|0;l=b+20|0;i=f[d>>2]|0;f[d>>2]=f[l>>2];f[l>>2]=i;i=b+4|0;l=f[c>>2]|0;d=f[i>>2]|0;if((d|l)&1|0){if(!(d&1)){h=mNa(i)|0;n=h;o=f[c>>2]|0}else{n=d&-2;o=l}if(!(o&1))p=mNa(c)|0;else p=o&-2;o=f[p>>2]|0;f[p>>2]=f[n>>2];f[n>>2]=o}o=a+16|0;n=b+16|0;p=f[o>>2]|0;f[o>>2]=f[n>>2];f[n>>2]=p;return}if(e)q=g;else q=f[g+4>>2]|0;g=Mi[f[(f[a>>2]|0)+16>>2]&1023](a,q)|0;lNa(g,b);Yi[f[(f[b>>2]|0)+28>>2]&2047](b);lNa(b,a);b=a+8|0;q=b;e=f[q>>2]|0;p=f[q+4>>2]|0;q=g+8|0;n=q;o=f[n+4>>2]|0;l=b;f[l>>2]=f[n>>2];f[l+4>>2]=o;o=q;f[o>>2]=e;f[o+4>>2]=p;p=a+20|0;o=g+20|0;e=f[p>>2]|0;f[p>>2]=f[o>>2];f[o>>2]=e;e=g+4|0;o=f[c>>2]|0;p=f[e>>2]|0;if(!((p|o)&1))r=o;else{if(!(p&1)){q=mNa(e)|0;s=q;t=f[c>>2]|0}else{s=p&-2;t=o}if(!(t&1))u=mNa(c)|0;else u=t&-2;t=f[u>>2]|0;f[u>>2]=f[s>>2];f[s>>2]=t;r=f[c>>2]|0}c=a+16|0;a=g+16|0;t=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=t;t=r&-2;if(!(r&1))v=t;else v=f[t+4>>2]|0;if(v|0)return;Yi[f[(f[g>>2]|0)+4>>2]&2047](g);return}function QOa(a){a=a|0;gOa(a);YDc(a);return}function ROa(a){a=a|0;var b=0,c=0;f[a>>2]=79096;if(f[a+20>>2]|0)nNa(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function SOa(a){a=a|0;ROa(a);YDc(a);return}function TOa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function UOa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(24)|0;JNa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14672,24);a=MQb(b,24)|0;KNa(a,b);c=a;return c|0}function VOa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function WOa(a){a=a|0;return f[a+4>>2]|0}function XOa(a){a=a|0;var b=0;nNa(a);b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function YOa(a){a=a|0;return 1}function ZOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;d=a+20|0;e=f[d>>2]|0;if((e|0)==1){eUb(1,f[a+8>>2]|0,c);g=f[d>>2]|0}else g=e;if((g|0)==2){bUb(2,f[a+8>>2]|0,c);h=f[d>>2]|0}else h=g;if((h|0)==3){g=a+8|0;NTb(3,f[g>>2]|0,f[g+4>>2]|0,c);i=f[d>>2]|0}else i=h;if((i|0)==4){WTb(4,+n[a+8>>2],c);j=f[d>>2]|0}else j=i;if((j|0)==5){YTb(5,(b[a+8>>0]|0)!=0,c);k=f[d>>2]|0}else k=j;if((k|0)==6){ZTb(6,f[a+8>>2]|0,c);l=f[d>>2]|0}else l=k;if((l|0)==7){eUb(7,f[a+8>>2]|0,c);m=f[d>>2]|0}else m=l;if((m|0)==8){eUb(8,f[a+8>>2]|0,c);o=f[d>>2]|0}else o=m;if((o|0)==9){m=a+8|0;l=f[m>>2]|0;k=b[l+11>>0]|0;if(k<<24>>24<0){p=f[l>>2]|0;q=f[l+4>>2]|0}else{p=l;q=k&255}gUb(p,q,1,396726)|0;if((f[d>>2]|0)==9)r=f[m>>2]|0;else r=527320;$Tb(9,r,c);s=f[d>>2]|0}else s=o;if((s|0)==10)eUb(10,f[a+8>>2]|0,c);s=f[a+4>>2]|0;if(!((s&1|0)!=0&(b[473420]|0)!=0))return;Gjc(s&-2,c);return}function _Oa(a){a=a|0;return f[a+16>>2]|0}function $Oa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=a+20|0;g=f[e>>2]|0;if((g|0)==1){h=f[a+8>>2]|0;b[d>>0]=10;i=d+1|0;j=_i[f[(f[h>>2]|0)+60>>2]&1023](h)|0;if(j>>>0>127){k=j;l=i;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=i;p=j}b[o>>0]=p;p=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,o+1|0)|0;q=p;r=f[e>>2]|0}else{q=d;r=g}if((r|0)==2){g=f[a+8>>2]|0;b[q>>0]=18;d=dSb(g,q+1|0)|0;s=d;t=f[e>>2]|0}else{s=q;t=r}if((t|0)==3){r=a+8|0;q=f[r>>2]|0;d=f[r+4>>2]|0;b[s>>0]=24;r=s+1|0;g=q&255;if(d>>>0>0|(d|0)==0&q>>>0>127){p=r;o=g;h=q;q=d;while(1){b[p>>0]=o|-128;d=h;h=aJc(h|0,q|0,7)|0;j=p+1|0;i=h&255;if(!(q>>>0>0|(q|0)==0&d>>>0>16383)){u=j;v=i;break}else{p=j;o=i;q=J}}}else{u=r;v=g}b[u>>0]=v;w=u+1|0;x=f[e>>2]|0}else{w=s;x=t}if((x|0)==4){t=f[a+8>>2]|0;b[w>>0]=37;s=w+1|0;b[s>>0]=t;b[s+1>>0]=t>>8;b[s+2>>0]=t>>16;b[s+3>>0]=t>>24;y=w+5|0;z=f[e>>2]|0}else{y=w;z=x}if((z|0)==5){x=b[a+8>>0]|0;b[y>>0]=40;b[y+1>>0]=x;A=y+2|0;B=f[e>>2]|0}else{A=y;B=z}if((B|0)==6){z=f[a+8>>2]|0;b[A>>0]=48;y=A+1|0;x=z&255;if(z>>>0>127){w=y;t=x;s=z;u=((z|0)<0)<<31>>31;while(1){b[w>>0]=t|-128;z=s;s=aJc(s|0,u|0,7)|0;v=w+1|0;g=s&255;if(!(u>>>0>0|(u|0)==0&z>>>0>16383)){C=v;D=g;break}else{w=v;t=g;u=J}}}else{C=y;D=x}b[C>>0]=D;E=C+1|0;F=f[e>>2]|0}else{E=A;F=B}if((F|0)==7){B=f[a+8>>2]|0;b[E>>0]=58;A=E+1|0;C=_i[f[(f[B>>2]|0)+60>>2]&1023](B)|0;if(C>>>0>127){D=C;x=A;while(1){b[x>>0]=D|128;y=D>>>7;u=x+1|0;if(D>>>0>16383){D=y;x=u}else{G=u;H=y;break}}}else{G=A;H=C}b[G>>0]=H;H=hj[f[(f[B>>2]|0)+64>>2]&511](B,c,G+1|0)|0;I=H;K=f[e>>2]|0}else{I=E;K=F}if((K|0)==8){F=f[a+8>>2]|0;b[I>>0]=66;E=I+1|0;H=_i[f[(f[F>>2]|0)+60>>2]&1023](F)|0;if(H>>>0>127){G=H;B=E;while(1){b[B>>0]=G|128;C=G>>>7;A=B+1|0;if(G>>>0>16383){G=C;B=A}else{L=A;M=C;break}}}else{L=E;M=H}b[L>>0]=M;M=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,L+1|0)|0;N=M;O=f[e>>2]|0}else{N=I;O=K}if((O|0)==9){K=a+8|0;I=f[K>>2]|0;M=b[I+11>>0]|0;if(M<<24>>24<0){P=f[I>>2]|0;Q=f[I+4>>2]|0}else{P=I;Q=M&255}gUb(P,Q,1,396726)|0;if((f[e>>2]|0)==9)R=f[K>>2]|0;else R=527320;b[N>>0]=74;K=dSb(R,N+1|0)|0;S=K;T=f[e>>2]|0}else{S=N;T=O}if((T|0)==10){T=f[a+8>>2]|0;b[S>>0]=82;O=S+1|0;N=_i[f[(f[T>>2]|0)+60>>2]&1023](T)|0;if(N>>>0>127){e=N;K=O;while(1){b[K>>0]=e|128;R=e>>>7;Q=K+1|0;if(e>>>0>16383){e=R;K=Q}else{U=Q;V=R;break}}}else{U=O;V=N}b[U>>0]=V;W=hj[f[(f[T>>2]|0)+64>>2]&511](T,c,U+1|0)|0}else W=S;S=f[a+4>>2]|0;if(!((S&1|0)!=0&(b[473420]|0)!=0)){X=W;return X|0}X=Hjc(S&-2,W)|0;return X|0}function aPa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function bPa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,14672,0)|0;if(!c){Ehc(b,a);return}else{lNa(a,c);return}}function cPa(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function dPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220311]|0)!=2){f[d>>2]=161028;f[d+4>>2]=3;b[d+8>>0]=0;DTb(881244,d);ZSb(d)}d=520624;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function ePa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;a=u;u=u+16|0;g=a;i=f[d>>2]|0;j=d+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=i+1;l=k&255;m=0}else{IRb(g,d);k=g;if(!(b[g+8>>0]|0)){n=0;u=a;return n|0}else{l=f[k>>2]|0;m=f[k+4>>2]|0}}k=f[e>>2]|0;i=e+4|0;o=f[i>>2]|0;if((k|0)==(o|0)){UHa(e,k+1|0);p=f[e>>2]|0;q=f[i>>2]|0}else{p=k;q=o}o=e+8|0;k=f[o>>2]|0;i=p+1|0;f[e>>2]=i;r=k+8+(p<<3)|0;f[r>>2]=l;f[r+4>>2]=m;m=q-i|0;if((m|0)<=0){n=1;u=a;return n|0}q=g+8|0;r=c&127|128;l=c>>>7&255;if(c>>>0<128){p=m;s=i;t=k;while(1){v=f[d>>2]|0;w=f[j>>2]|0;if(v>>>0>=w>>>0){n=1;x=27;break}if((h[v>>0]|0)!=(c|0)){n=1;x=27;break}y=v+1|0;f[d>>2]=y;if(y>>>0<w>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[d>>2]=v+2;z=s;A=t;B=w&255;C=0}else{IRb(g,d);w=g;if(!(b[q>>0]|0)){n=0;x=27;break}z=f[e>>2]|0;A=f[o>>2]|0;B=f[w>>2]|0;C=f[w+4>>2]|0}s=z+1|0;f[e>>2]=s;w=A+8+(z<<3)|0;f[w>>2]=B;f[w+4>>2]=C;if((p|0)<=1){n=1;x=27;break}else{p=p+-1|0;t=A}}if((x|0)==27){u=a;return n|0}}if(c>>>0<16384){D=m;E=i;F=k}else{n=1;u=a;return n|0}while(1){k=f[j>>2]|0;i=f[d>>2]|0;m=i;if((k-i|0)<=1){n=1;x=27;break}if((h[m>>0]|0)!=(r|0)){n=1;x=27;break}if((b[m+1>>0]|0)!=l<<24>>24){n=1;x=27;break}i=m+2|0;f[d>>2]=i;if(i>>>0<k>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=m+3;G=E;H=F;I=k&255;J=0}else{IRb(g,d);k=g;if(!(b[q>>0]|0)){n=0;x=27;break}G=f[e>>2]|0;H=f[o>>2]|0;I=f[k>>2]|0;J=f[k+4>>2]|0}E=G+1|0;f[e>>2]=E;k=H+8+(G<<3)|0;f[k>>2]=I;f[k+4>>2]=J;if((D|0)<=1){n=1;x=27;break}else{D=D+-1|0;F=H}}if((x|0)==27){u=a;return n|0}return 0}function fPa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;i=g;j=d+4|0;k=f[d>>2]|0;do if(((f[j>>2]|0)-k|0)>3){l=k;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;f[i>>2]=m;f[d>>2]=k+4;n=m}else{if(TRb(d,i)|0){n=f[i>>2]|0;break}o=0;u=g;return o|0}while(0);i=f[e>>2]|0;k=e+4|0;if((i|0)==(f[k>>2]|0)){SHa(e,i+1|0);p=f[e>>2]|0}else p=i;i=f[e+8>>2]|0;m=p+1|0;f[e>>2]=m;f[i+4+(p<<2)>>2]=n;n=f[d>>2]|0;p=(f[j>>2]|0)-n|0;if((p|0)<=0){o=1;u=g;return o|0}j=n;n=a+4|0;a=(f[k>>2]|0)-m|0;k=(p|0)/(n|0)|0;l=(k|0)<(a|0)?k:a;a:do if((l|0)>0){a=c&127|128;k=c>>>7&255;if(c>>>0<128){q=0;r=j;s=m;while(1){if((h[r>>0]|0)!=(c|0)){t=q;break a}v=r+1|0;w=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;v=s;s=s+1|0;f[e>>2]=s;f[i+4+(v<<2)>>2]=w;w=q+1|0;if((w|0)>=(l|0)){t=w;break a}else{q=w;r=r+5|0}}}if(c>>>0<16384){r=0;q=j;s=m;while(1){if((h[q>>0]|0)!=(a|0)){t=r;break a}if((b[q+1>>0]|0)!=k<<24>>24){t=r;break a}w=q+2|0;v=h[w>>0]|h[w+1>>0]<<8|h[w+2>>0]<<16|h[w+3>>0]<<24;w=s;s=s+1|0;f[e>>2]=s;f[i+4+(w<<2)>>2]=v;v=r+1|0;if((v|0)>=(l|0)){t=v;break}else{r=v;q=q+6|0}}}else t=0}else t=0;while(0);l=Y(t,n)|0;if((l|0)<=0){o=1;u=g;return o|0}if((p|0)<(l|0)){PRb(d,l,p)|0;o=1;u=g;return o|0}else{f[d>>2]=j+l;o=1;u=g;return o|0}return 0}function gPa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+16|0;g=a;i=f[d>>2]|0;j=d+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=i+1;l=k<<24>>24!=0}else{IRb(g,d);k=g;if(!(b[g+8>>0]|0)){m=0;u=a;return m|0}else l=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0}k=f[e>>2]|0;i=e+4|0;n=f[i>>2]|0;if((k|0)==(n|0)){zNa(e,k+1|0);o=f[e>>2]|0;p=f[i>>2]|0}else{o=k;p=n}n=e+8|0;k=f[n>>2]|0;i=o+1|0;f[e>>2]=i;b[k+4+o>>0]=l&1;l=p-i|0;if((l|0)<=0){m=1;u=a;return m|0}p=g+8|0;o=c&127|128;q=c>>>7&255;if(c>>>0<128){r=l;s=i;t=k;while(1){v=f[d>>2]|0;w=f[j>>2]|0;if(v>>>0>=w>>>0){m=1;x=27;break}if((h[v>>0]|0)!=(c|0)){m=1;x=27;break}y=v+1|0;f[d>>2]=y;if(y>>>0<w>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[d>>2]=v+2;z=w<<24>>24!=0;A=s;B=t}else{IRb(g,d);w=g;if(!(b[p>>0]|0)){m=0;x=27;break}z=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0;A=f[e>>2]|0;B=f[n>>2]|0}s=A+1|0;f[e>>2]=s;b[B+4+A>>0]=z&1;if((r|0)<=1){m=1;x=27;break}else{r=r+-1|0;t=B}}if((x|0)==27){u=a;return m|0}}if(c>>>0<16384){C=l;D=i;E=k}else{m=1;u=a;return m|0}while(1){k=f[j>>2]|0;i=f[d>>2]|0;l=i;if((k-i|0)<=1){m=1;x=27;break}if((h[l>>0]|0)!=(o|0)){m=1;x=27;break}if((b[l+1>>0]|0)!=q<<24>>24){m=1;x=27;break}i=l+2|0;f[d>>2]=i;if(i>>>0<k>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=l+3;F=k<<24>>24!=0;G=D;H=E}else{IRb(g,d);k=g;if(!(b[p>>0]|0)){m=0;x=27;break}F=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0;G=f[e>>2]|0;H=f[n>>2]|0}D=G+1|0;f[e>>2]=D;b[H+4+G>>0]=F&1;if((C|0)<=1){m=1;x=27;break}else{C=C+-1|0;E=H}}if((x|0)==27){u=a;return m|0}return 0}function hPa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220312]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=4;b[c+8>>0]=0;DTb(881248,c);ZSb(c);u=a;return}function iPa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220314]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=6;b[c+8>>0]=0;DTb(881256,c);ZSb(c);u=a;return}function jPa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220312]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=4;b[c+8>>0]=0;DTb(881248,c);ZSb(c);u=a;return}function kPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=79096;d=a+4|0;f[d>>2]=0;f[a+16>>2]=0;e=f[c+4>>2]|0;if(e&1|0)ojc(mNa(d)|0,e&-2);e=a+20|0;f[e>>2]=0;d=c+20|0;do switch(f[d>>2]|0){case 2:{g=f[c+8>>2]|0;nNa(a);f[e>>2]=2;h=a+8|0;f[h>>2]=527320;i=f[a+4>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,g);return}else{iEc(j,g)|0;return}break}case 3:{g=c+8|0;j=f[g>>2]|0;h=f[g+4>>2]|0;nNa(a);f[e>>2]=3;g=a+8|0;f[g>>2]=j;f[g+4>>2]=h;return}case 4:{h=f[c+8>>2]|0;nNa(a);f[e>>2]=4;f[a+8>>2]=h;return}case 5:{h=b[c+8>>0]|0;nNa(a);f[e>>2]=5;b[a+8>>0]=h;return}case 6:{h=f[c+8>>2]|0;nNa(a);f[e>>2]=6;f[a+8>>2]=h;return}case 7:{cSa(oNa(a)|0,(f[d>>2]|0)==7?f[c+8>>2]|0:520848);return}case 8:{_Sa(UJa(a)|0,(f[d>>2]|0)==8?f[c+8>>2]|0:520944);return}case 1:{qNa(pNa(a)|0,(f[d>>2]|0)==1?f[c+8>>2]|0:520336);return}case 10:{sNa(rNa(a)|0,(f[d>>2]|0)==10?f[c+8>>2]|0:520560);return}case 9:{h=f[c+8>>2]|0;nNa(a);f[e>>2]=9;g=a+8|0;f[g>>2]=527320;j=f[a+4>>2]|0;i=j&-2;if(!(j&1))l=i;else l=f[i+4>>2]|0;i=f[g>>2]|0;if((i|0)==527320){WJa(g,l,h);return}else{iEc(i,h)|0;return}break}default:return}while(0)}function lPa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);lNa(a,b);return}function mPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=79972;if((a|0)!=520648){b=f[a+24>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+28>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function nPa(a){a=a|0;mPa(a);YDc(a);return}function oPa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function pPa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(40)|0;aRa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14776,40);a=MQb(b,40)|0;bRa(a,b);c=a;return c|0}function qPa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function rPa(a){a=a|0;return f[a+4>>2]|0}function sPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+12|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+20>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}b=a+4|0;c=f[b>>2]|0;e=c&-2;if(!(c&1))h=e;else h=f[e+4>>2]|0;e=a+24|0;if((h|0)==0?(h=f[e>>2]|0,(h|0)!=0):0){Yi[f[(f[h>>2]|0)+4>>2]&2047](h);i=f[b>>2]|0}else i=c;f[e>>2]=0;e=i&-2;if(!(i&1))j=e;else j=f[e+4>>2]|0;e=a+28|0;if((j|0)==0?(j=f[e>>2]|0,(j|0)!=0):0){Yi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0}else k=i;f[e>>2]=0;f[a+32>>2]=0;if(!(k&1))return;a=k&-2;if(!(f[a>>2]|0))return;ljc(a);return}function tPa(a){a=a|0;return 1}function uPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=e+4|0;m=a+24|0;n=e+4|0;o=a+32|0;p=a+28|0;q=e+4|0;r=a+4|0;a:while(1){s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){t=b[s>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=s+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=WRb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=10){z=w;break b}v=f[i>>2]|0;do if(v){s=f[k>>2]|0;t=f[v>>2]|0;if((s|0)>=(t|0))if((t|0)==(f[j>>2]|0)){A=t;x=13;break}else{B=t;C=v;x=14;break}else{f[k>>2]=s+1;D=f[v+4+(s<<2)>>2]|0;break}}else{A=f[j>>2]|0;x=13}while(0);if((x|0)==13){x=0;USb(h,A+1|0);v=f[i>>2]|0;B=f[v>>2]|0;C=v;x=14}if((x|0)==14){x=0;f[C>>2]=B+1;v=f[h>>2]|0;if(!v){s=VDc(76)|0;KPa(s);E=s}else{if(f[v+64>>2]|0)OQb(v,14856,80);s=MQb(v,80)|0;UQa(s,v);E=s}s=f[i>>2]|0;v=f[k>>2]|0;f[k>>2]=v+1;f[s+4+(v<<2)>>2]=E;D=E}v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(s=b[v>>0]|0,s<<24>>24>-1):0){f[c>>2]=v+1;F=s&255}else{s=VRb(c)|0;if((s|0)>-1)F=s;else{G=0;x=61;break a}}GRb(e,c,F);if((f[l>>2]|0)<0){x=26;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){x=26;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{G=0;x=61;break a}break}case 2:{if((w&255|0)!=18){z=w;break b}s=f[m>>2]|0;if(!s){ZQa(a);H=f[m>>2]|0}else H=s;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;I=v&255}else{v=VRb(c)|0;if((v|0)>-1)I=v;else{G=0;x=61;break a}}GRb(e,c,I);if((f[n>>2]|0)<0){x=37;break a}if(!(Mi[f[(f[H>>2]|0)+44>>2]&1023](H,c)|0)){x=37;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{G=0;x=61;break a}break}case 3:{if((w&255|0)!=24){z=w;break b}v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){s=b[v>>0]|0;t=s&255;if(s<<24>>24>-1){f[c>>2]=v+1;K=t}else{L=t;x=43}}else{L=0;x=43}if((x|0)==43){x=0;t=HRb(c,L)|0;v=J;if((v|0)>-1|(v|0)==-1&t>>>0>4294967295)K=t;else{G=0;x=61;break a}}f[o>>2]=K;continue a;break}case 4:{if((w&255|0)!=34){z=w;break b}t=f[p>>2]|0;if(!t){_Qa(a);M=f[p>>2]|0}else M=t;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(v=b[t>>0]|0,v<<24>>24>-1):0){f[c>>2]=t+1;N=v&255}else{v=VRb(c)|0;if((v|0)>-1)N=v;else{G=0;x=61;break a}}GRb(e,c,N);if((f[q>>2]|0)<0){x=54;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){x=54;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{G=0;x=61;break a}break}default:{z=w;break b}}}while(0);if(!z){G=1;x=61;break}v=f[r>>2]|0;if(!(v&1))O=mNa(r)|0;else O=v&-2;if(!(Djc(c,z,O)|0)){G=0;x=61;break}}if((x|0)==26){G=0;u=d;return G|0}else if((x|0)==37){G=0;u=d;return G|0}else if((x|0)==54){G=0;u=d;return G|0}else if((x|0)==61){u=d;return G|0}return 0}function vPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+20|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}if((a|0)!=520648){i=f[a+24>>2]|0;if(!i)k=g;else{c=_i[f[(f[i>>2]|0)+48>>2]&1023](i)|0;k=g+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0}c=f[a+28>>2]|0;if(!c)l=k;else{i=_i[f[(f[c>>2]|0)+48>>2]&1023](c)|0;l=k+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}}else l=g;g=f[a+32>>2]|0;if(!g){m=l;n=a+36|0;f[n>>2]=m;return m|0}if((g|0)<0)o=11;else o=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;m=o+l|0;n=a+36|0;f[n>>2]=m;return m|0}function wPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{eUb(1,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=(a|0)==520648;if(!d?(g=f[a+24>>2]|0,g|0):0)eUb(2,g,c);g=f[a+32>>2]|0;if(g|0)MTb(3,g,c);if(!d?(d=f[a+28>>2]|0,d|0):0)eUb(4,d,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function xPa(a){a=a|0;return f[a+36>>2]|0}function yPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=f[a+12>>2]|0;if(!e)g=d;else{h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=(a|0)==520648;if(!j?(e=f[a+24>>2]|0,(e|0)!=0):0){b[g>>0]=18;i=g+1|0;q=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;if(q>>>0>127){r=q;h=i;while(1){b[h>>0]=r|128;n=r>>>7;m=h+1|0;if(r>>>0>16383){r=n;h=m}else{s=m;t=n;break}}}else{s=i;t=q}b[s>>0]=t;u=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,s+1|0)|0}else u=g;g=f[a+32>>2]|0;if(!g)v=u;else{b[u>>0]=24;s=u+1|0;u=g&255;if(g>>>0>127){e=s;t=u;q=g;i=((g|0)<0)<<31>>31;while(1){b[e>>0]=t|-128;g=q;q=aJc(q|0,i|0,7)|0;h=e+1|0;r=q&255;if(!(i>>>0>0|(i|0)==0&g>>>0>16383)){w=h;x=r;break}else{e=h;t=r;i=J}}}else{w=s;x=u}b[w>>0]=x;v=w+1|0}if(!j?(j=f[a+28>>2]|0,(j|0)!=0):0){b[v>>0]=34;w=v+1|0;x=_i[f[(f[j>>2]|0)+60>>2]&1023](j)|0;if(x>>>0>127){u=x;s=w;while(1){b[s>>0]=u|128;i=u>>>7;t=s+1|0;if(u>>>0>16383){u=i;s=t}else{y=t;z=i;break}}}else{y=w;z=x}b[y>>0]=z;A=hj[f[(f[j>>2]|0)+64>>2]&511](j,c,y+1|0)|0}else A=v;v=f[a+4>>2]|0;if(!((v&1|0)!=0&(b[473420]|0)!=0)){B=A;return B|0}B=Hjc(v&-2,A)|0;return B|0}function zPa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function APa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,14776,0)|0;if(!c){Ehc(b,a);return}else{XQa(a,c);return}}function BPa(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function CPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220315]|0)!=2){f[d>>2]=161028;f[d+4>>2]=7;b[d+8>>0]=0;DTb(881260,d);ZSb(d)}d=520792;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function DPa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220316]|0)!=2){f[c>>2]=161028;f[c+4>>2]=8;b[c+8>>0]=0;DTb(881264,c);ZSb(c)}d=VDc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=11;e=d;g=397061;h=e+11|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+11>>0]=0;Xbc(c,80072,80108,79852,0,520792,0,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function EPa(){FPa();lYb(397073,513);rhc(397061,1748);jPa();ZDb();DSa();return}function FPa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220317]|0)!=2){f[c>>2]=161028;f[c+4>>2]=9;b[c+8>>0]=0;DTb(881268,c);ZSb(c)}if((f[220318]|0)!=2){f[c>>2]=161028;f[c+4>>2]=10;b[c+8>>0]=0;DTb(881272,c);ZSb(c)}if((f[220319]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=11;b[c+8>>0]=0;DTb(881276,c);ZSb(c);u=a;return}function GPa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220315]|0)!=2){f[c>>2]=161028;f[c+4>>2]=7;b[c+8>>0]=0;DTb(881260,c);ZSb(c)}acc(520792,3);u=a;return}function HPa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,397587);SQb();if((f[220319]|0)!=2){f[c>>2]=161028;f[c+4>>2]=11;b[c+8>>0]=0;DTb(881276,c);ZSb(c)}CSa();YDb();f[130162]=79972;f[130163]=0;f[130164]=0;f[130165]=0;f[130166]=0;f[130167]=0;f[130168]=0;f[130169]=0;f[130170]=0;f[130171]=0;zTb(520648);f[130169]=520896;f[130168]=526592;u=a;return}function IPa(){aTb(3005001,3005e3,397587);SQb();iPa();f[130175]=0;f[130173]=527320;f[130176]=0;f[130177]=0;f[130172]=80320;f[130174]=520464;return}function JPa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,397587);SQb();if((f[220318]|0)!=2){f[c>>2]=161028;f[c+4>>2]=10;b[c+8>>0]=0;DTb(881272,c);ZSb(c)}KPa(520712);zTb(520712);u=a;return}function KPa(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=80128;e=a+4|0;g=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[g>>2]=167152;f[a+28>>2]=0;f[a+32>>2]=0;tTb(a+36|0);f[a+40>>2]=0;f[g>>2]=80236;f[a+44>>2]=0;g=a+48|0;f[g>>2]=0;e=a+52|0;f[e>>2]=0;AJa(g);f[e>>2]=0;if((a|0)!=520712?(f[220319]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=11;b[d+8>>0]=0;DTb(881276,d);ZSb(d)}f[a+60>>2]=527320;f[a+64>>2]=527320;f[a+68>>2]=527320;f[a+72>>2]=0;u=c;return}function LPa(a){a=a|0;f[a>>2]=80236;cJa(a+24|0);Bcc(a);return}function MPa(a){a=a|0;f[a>>2]=80236;cJa(a+24|0);Bcc(a);YDc(a);return}function NPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;fEc(g,PNa(c)|0);bJa(e,f[a+32>>2]|0,g,0);a=(f[e>>2]|0)!=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}YDc(f[g>>2]|0);u=d;return a|0}function OPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e+16|0;h=e;i=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;fEc(h,PNa(c)|0);bJa(g,f[i+8>>2]|0,h,0);c=f[g>>2]|0;if(!c){j=1;k=BJa(i,h)|0}else{j=0;k=(f[c+12>>2]|0)+16|0}f[d>>2]=k;if((b[h+11>>0]|0)>=0){u=e;return j|0}YDc(f[h>>2]|0);u=e;return j|0}function PPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d+40|0;g=d+24|0;h=d;fEc(h,PNa(c)|0);c=_i[f[(f[a>>2]|0)+68>>2]&1023](a)|0;bJa(e,f[c+8>>2]|0,h,0);a=f[e>>2]|0;i=f[e+4>>2]|0;j=f[e+8>>2]|0;if(!a)k=0;else{f[g>>2]=a;f[g+4>>2]=i;f[g+8>>2]=j;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];sJa(d+12|0,c,e);k=1}if((b[h+11>>0]|0)>=0){u=d;return k|0}YDc(f[h>>2]|0);u=d;return k|0}function QPa(a){a=a|0;Wdc(a);return f[f[a+32>>2]>>2]|0}function RPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=u;u=u+16|0;c=b;d=f[a+8>>2]|0;if(!d)e=12;else{g=f[d+8>>2]<<2;h=d+12|0;d=f[h>>2]|0;if(!d)i=g;else{if((f[d>>2]|0)>0){j=0;k=g;l=d;while(1){d=f[l+4+(j<<2)>>2]|0;m=(_i[f[(f[d>>2]|0)+84>>2]&1023](d)|0)+k|0;j=j+1|0;l=f[h>>2]|0;if((j|0)>=(f[l>>2]|0)){n=m;break}else k=m}}else n=g;i=n+4|0}e=i+12|0}i=f[a+32>>2]|0;a=f[i+12>>2]|0;n=f[i+4>>2]|0;a:do if(n>>>0>a>>>0){g=f[i+16>>2]|0;k=a;while(1){o=f[g+(k<<2)>>2]|0;if(o|0)break;l=k+1|0;if(l>>>0<n>>>0)k=l;else{p=0;q=l;break a}}if((o|0)==(f[g+((k^1)<<2)>>2]|0)){p=f[(f[o>>2]|0)+16>>2]|0;q=k;break}else{p=o;q=k;break}}else{p=0;q=a}while(0);f[c>>2]=p;f[c+4>>2]=i;f[c+8>>2]=q;if(!p){r=e;u=b;return r|0}q=e;e=p;while(1){p=(f[e+12>>2]|0)+16|0;i=q+12+(_i[f[(f[p>>2]|0)+84>>2]&1023](p)|0)|0;vJa(c)|0;e=f[c>>2]|0;if(!e){r=i;break}else q=i}u=b;return r|0}function SPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;b=u;u=u+16|0;c=b;d=a+8|0;e=f[d>>2]|0;if(!e){g=f[a+4>>2]|0;if(!g){h=VDc(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}else{if(f[g+64>>2]|0)OQb(g,14656,16);h=NQb(g,16,1744)|0;f[h>>2]=g;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}f[d>>2]=i;j=i}else j=e;e=j+4|0;i=f[e>>2]|0;if((i|0)>0){d=f[j+12>>2]|0;h=0;do{g=f[d+4+(h<<2)>>2]|0;h=h+1|0;Yi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((h|0)!=(i|0));f[e>>2]=0}i=f[a+32>>2]|0;h=f[i+12>>2]|0;d=f[i+4>>2]|0;a:do if(d>>>0>h>>>0){g=f[i+16>>2]|0;k=h;while(1){l=f[g+(k<<2)>>2]|0;if(l|0)break;m=k+1|0;if(m>>>0<d>>>0)k=m;else{n=0;o=m;break a}}if((l|0)==(f[g+((k^1)<<2)>>2]|0)){n=f[(f[l>>2]|0)+16>>2]|0;o=k;break}else{n=l;o=k;break}}else{n=0;o=h}while(0);f[c>>2]=n;f[c+4>>2]=i;f[c+8>>2]=o;if(!n){u=b;return}n=a+4|0;a=j+12|0;o=j+8|0;do{i=Mi[f[(f[130172]|0)+16>>2]&1023](520688,f[n>>2]|0)|0;h=i+12|0;l=f[h>>2]|0;d=f[j>>2]|0;if(((d|0)==(l|0)?(m=f[a>>2]|0,(m|0)!=0):0)?(p=f[m>>2]|0,(p|0)<(f[o>>2]|0)):0){q=f[e>>2]|0;if((q|0)<(p|0)){r=m+4+(q<<2)|0;f[m+4+(p<<2)>>2]=f[r>>2];s=r}else s=m+4+(q<<2)|0;f[s>>2]=i;f[e>>2]=q+1;q=f[a>>2]|0;f[q>>2]=(f[q>>2]|0)+1}else XPa(j,i,l,d);d=f[(f[c>>2]|0)+12>>2]|0;l=i+16|0;f[l>>2]=f[l>>2]|1;q=i+4|0;m=f[q>>2]|0;if((m|0)==527320){WJa(q,f[h>>2]|0,527320);t=f[q>>2]|0}else t=m;iEc(t,d)|0;d=(f[(f[c>>2]|0)+12>>2]|0)+16|0;f[l>>2]=f[l>>2]|2;l=i+8|0;i=f[h>>2]|0;h=f[l>>2]|0;if(!h){if(!i){m=VDc(24)|0;JNa(m);v=m}else{if(f[i+64>>2]|0)OQb(i,14672,24);m=MQb(i,24)|0;KNa(m,i);v=m}f[l>>2]=v;w=v}else w=h;lPa(w,d);pJa(c)|0}while((f[c>>2]|0)!=0);u=b;return}function TPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+80|0;c=b+52|0;d=b+40|0;e=b;g=b+16|0;h=a+24|0;i=f[a+8>>2]|0;if(!i){rTb(g,3,456026,306);oTb(b+64|0,mTb(g,456117)|0);sTb(g)}g=f[a+32>>2]|0;a=f[g+12>>2]|0;j=f[g+4>>2]|0;a:do if(j>>>0>a>>>0){k=f[g+16>>2]|0;l=a;while(1){m=f[k+(l<<2)>>2]|0;if(m|0)break;n=l+1|0;if(n>>>0<j>>>0)l=n;else{o=0;p=n;break a}}if((m|0)==(f[k+((l^1)<<2)>>2]|0)){o=f[(f[m>>2]|0)+16>>2]|0;p=l;break}else{o=m;p=l;break}}else{o=0;p=a}while(0);f[e>>2]=o;f[e+4>>2]=g;f[e+8>>2]=p;if(o|0)do{f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];sJa(d,h,c);f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2];f[e+8>>2]=f[d+8>>2]}while((f[e>>2]|0)!=0);e=i+12|0;d=f[e>>2]|0;c=i+4|0;if(!(f[c>>2]|0)){u=b;return}i=(d|0)==0?0:d+4|0;do{d=f[i>>2]|0;o=_i[f[(f[d>>2]|0)+104>>2]&1023](d)|0;d=f[i>>2]|0;lPa(BJa(h,_i[f[(f[d>>2]|0)+100>>2]&1023](d)|0)|0,o);i=i+4|0;o=f[e>>2]|0}while((i|0)!=(((o|0)==0?0:o+4|0)+(f[c>>2]<<2)|0));u=b;return}function UPa(a){a=a|0;Wdc(a);return a+24|0}function VPa(a){a=a|0;Wdc(a);Vdc(a);return a+24|0}function WPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;a=f[f[b>>2]>>2]|0;if(!a)return;c=b+8|0;d=a+12|0;a=f[d>>2]|0;e=b+16|0;if((f[e>>2]|0)==9)g=f[c>>2]|0;else{f[e>>2]=9;e=VDc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[c>>2]=e;g=e}iEc(g,a)|0;f[b+24>>2]=(f[d>>2]|0)+16;return}function XPa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){if(!d){e=VDc(24)|0;f[e+12>>2]=0;f[e+4>>2]=527320;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)OQb(d,14808,24);e=MQb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=527320;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=80320;ZPa(b,g);if((b|0)==0|(c|0)!=0)i=g;else{Yi[f[(f[b>>2]|0)+4>>2]&2047](b);i=g}}else i=b;else{YPa(d,b);i=b}b=a+12|0;d=f[b>>2]|0;g=f[a+8>>2]|0;c=a+4|0;if(d|0?(e=f[c>>2]|0,(e|0)!=(g|0)):0){h=f[d>>2]|0;if((h|0)==(g|0)){j=f[d+4+(e<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}Yi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}else{if((e|0)<(h|0)){f[d+4+(h<<2)>>2]=f[d+4+(e<<2)>>2];e=f[b>>2]|0;o=e;p=f[e>>2]|0}else{o=d;p=h}f[o>>2]=p+1;k=o;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}}USb(a,g+1|0);g=f[b>>2]|0;f[g>>2]=(f[g>>2]|0)+1;k=g;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}function YPa(a,b){a=a|0;b=b|0;if(!b)return;LQb(a,b,1747);return}function ZPa(a,b){a=a|0;b=b|0;_Pa(b,a);return}function _Pa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=b+16|0;d=f[c>>2]|0;if(!d)return;if(!(d&1))e=d;else{d=a+4|0;g=a+12|0;if((f[d>>2]|0)==527320)WJa(d,f[g>>2]|0,527320);h=_i[f[(f[b>>2]|0)+100>>2]&1023](b)|0;i=f[d>>2]|0;if((i|0)==527320)WJa(d,f[g>>2]|0,h);else iEc(i,h)|0;h=a+16|0;f[h>>2]=f[h>>2]|1;e=f[c>>2]|0}if(!(e&2))return;e=a+8|0;c=f[a+12>>2]|0;if(!(f[e>>2]|0)){if(!c){h=VDc(24)|0;JNa(h);j=h}else{if(f[c+64>>2]|0)OQb(c,14672,24);h=MQb(c,24)|0;KNa(h,c);j=h}f[e>>2]=j}j=_i[f[(f[b>>2]|0)+104>>2]&1023](b)|0;lNa(f[e>>2]|0,j);j=a+16|0;f[j>>2]=f[j>>2]|2;return}function $Pa(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=80436;c=a+20|0;d=f[c>>2]|0;if(d&1|0?(e=d&-2,d=e,!((e|0)==0|(f[d+4>>2]|0)!=0)):0){if(f[d>>2]|0)ljc(d);YDc(e)}f[c>>2]=0;f[a>>2]=80552;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function aQa(a){a=a|0;$Pa(a);YDc(a);return}function bQa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function cQa(a){a=a|0;a=VDc(24)|0;f[a+12>>2]=0;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a>>2]=80320;return a|0}function dQa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=VDc(24)|0;f[a+12>>2]=0;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;c=a;f[c>>2]=80320;return c|0}if(f[b+64>>2]|0)OQb(b,14808,24);a=MQb(b,24)|0;d=b;f[a+12>>2]=d;f[a+4>>2]=527320;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=d;c=a;f[c>>2]=80320;return c|0}function eQa(a){a=a|0;return f[a+12>>2]|0}function fQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+4>>2]|0;do if((c|0)!=527320){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+8>>2]|0;if(!c){e=a+16|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}Yi[f[(f[c>>2]|0)+28>>2]&2047](c);e=a+16|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}function gQa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&1023](b)|0}function hQa(a,b){a=a|0;b=b|0;_Pa(a,b);return}function iQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+4|0;j=a+12|0;k=a+8|0;a=e+4|0;l=c+32|0;m=c+12|0;n=c+28|0;a:while(1){o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){p=b[o>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=o+1;r=q}else{s=q;t=5}}else{s=0;t=5}if((t|0)==5){t=0;r=WRb(c,s)|0}switch(r|0){case 0:{v=1;t=35;break a;break}case 10:{f[h>>2]=f[h>>2]|1;q=f[i>>2]|0;if((q|0)==527320){WJa(i,f[j>>2]|0,527320);w=f[i>>2]|0}else w=q;if(!(fUb(c,w)|0)){v=0;t=35;break a}q=f[h>>2]|1;f[h>>2]=q;o=f[c>>2]|0;if(o>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[o>>0]|0)!=18)continue a;f[c>>2]=o+1;x=q;break}case 18:{x=f[h>>2]|0;break}default:{if((r&7|0)==4){v=1;t=35;break a}if(ITb(c,r)|0)continue a;else{v=0;t=35;break a}}}f[h>>2]=x|2;q=f[j>>2]|0;o=f[k>>2]|0;if(!o){if(!q){p=VDc(24)|0;JNa(p);y=p}else{if(f[q+64>>2]|0)OQb(q,14672,24);p=MQb(q,24)|0;KNa(p,q);y=p}f[k>>2]=y;z=y}else z=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(p=b[o>>0]|0,p<<24>>24>-1):0){f[c>>2]=o+1;A=p&255}else{p=VRb(c)|0;if((p|0)>-1)A=p;else{v=0;t=35;break}}GRb(e,c,A);if((f[a>>2]|0)<0){t=27;break}if(!(BOa(z,c)|0)){t=27;break}if(!(LRb(c,f[e>>2]|0)|0)){v=0;t=35;break}f[h>>2]=f[h>>2]|2;if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[l>>2]|0){t=32;break}if((f[m>>2]|0)==(f[n>>2]|0)){t=32;break}}if((t|0)==27){v=0;u=d;return v|0}else if((t|0)==32){f[c+20>>2]=0;b[c+24>>0]=1;v=1;u=d;return v|0}else if((t|0)==35){u=d;return v|0}return 0}function jQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=AOa(_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0)|0;j=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function kQa(a,b){a=a|0;b=b|0;_Tb(1,_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0,b);eUb(2,_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0,b);return}function lQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0;a=_i[f[(f[e>>2]|0)+60>>2]&1023](e)|0;j=a+1+((((($(a|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function mQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=_i[f[(f[a>>2]|0)+100>>2]&1023](a)|0;b[d>>0]=10;g=dSb(e,d+1|0)|0;d=_i[f[(f[a>>2]|0)+104>>2]&1023](a)|0;b[g>>0]=18;a=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(g>>>0>127){e=g;h=a;while(1){b[h>>0]=e|128;i=e>>>7;j=h+1|0;if(e>>>0>16383){e=i;h=j}else{k=j;l=i;break}}}else{k=a;l=g}b[k>>0]=l;return hj[f[(f[d>>2]|0)+64>>2]&511](d,c,k+1|0)|0}function nQa(a,b){a=a|0;b=b|0;hec(a,b);return}function oQa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (_i[f[(f[b>>2]|0)+84>>2]&1023](b)|0)+28|0}function pQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220315]|0)!=2){f[d>>2]=161028;f[d+4>>2]=7;b[d+8>>0]=0;DTb(881260,d);ZSb(d)}d=520800;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function qQa(a){a=a|0;return f[a+4>>2]|0}function rQa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (b|0?b:f[130174]|0)|0}function sQa(a){a=a|0;var c=0;f[a>>2]=80552;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function tQa(a){a=a|0;var c=0;f[a>>2]=80552;if(f[a+12>>2]|0){YDc(a);return}c=f[a+4>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+8>>2]|0;if(!c){YDc(a);return}Yi[f[(f[c>>2]|0)+4>>2]&2047](c);YDc(a);return}function uQa(a){a=a|0;$Pa(a);YDc(a);return}function vQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=80128;WQa(a);c=a+24|0;f[c>>2]=80236;cJa(a+48|0);Bcc(c);c=a+20|0;d=f[c>>2]|0;if(d|0?(f[a+8>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[c>>2]=0;return}function wQa(a){a=a|0;vQa(a);YDc(a);return}function xQa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function yQa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(76)|0;KPa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14856,80);a=MQb(b,80)|0;UQa(a,b);c=a;return c|0}function zQa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function AQa(a){a=a|0;return f[a+4>>2]|0}function BQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=a+12|0;i=f[h>>2]|0;if((i|0)>0){j=f[a+20>>2]|0;k=0;do{l=f[j+4+(k<<2)>>2]|0;k=k+1|0;m=l+11|0;if((b[m>>0]|0)<0){b[f[l>>2]>>0]=0;f[l+4>>2]=0}else{b[l>>0]=0;b[m>>0]=0}}while((k|0)!=(i|0));f[h>>2]=0}h=a+24|0;Wdc(h);i=a+48|0;k=f[a+56>>2]|0;j=f[k+12>>2]|0;m=f[k+4>>2]|0;a:do if(m>>>0>j>>>0){l=f[k+16>>2]|0;n=j;while(1){o=f[l+(n<<2)>>2]|0;if(o|0)break;p=n+1|0;if(p>>>0<m>>>0)n=p;else{q=0;r=p;break a}}if((o|0)==(f[l+((n^1)<<2)>>2]|0)){q=f[(f[o>>2]|0)+16>>2]|0;r=n;break}else{q=o;r=n;break}}else{q=0;r=j}while(0);f[g>>2]=q;f[g+4>>2]=k;f[g+8>>2]=r;if(q|0)do{f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];sJa(e,i,d);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2]}while((f[g>>2]|0)!=0);Vdc(h);h=a+4|0;g=f[a+60>>2]|0;do if((g|0)!=527320){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);g=f[a+64>>2]|0;do if((g|0)!=527320){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);g=f[a+68>>2]|0;do if((g|0)!=527320){a=g+11|0;if((b[a>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[a>>0]=0;break}}while(0);g=f[h>>2]|0;if(!(g&1)){u=c;return}h=g&-2;if(!(f[h>>2]|0)){u=c;return}ljc(h);u=c;return}function CQa(a){a=a|0;return 1}function DQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=a+60|0;j=a+4|0;k=a+60|0;l=a+64|0;m=a+64|0;n=a+8|0;o=a+12|0;p=a+20|0;q=a+68|0;r=a+68|0;s=a+24|0;a=g+4|0;t=g+8|0;v=g+24|0;w=e+4|0;x=t+11|0;y=g+12|0;a:while(1){z=f[c>>2]|0;if(z>>>0<(f[h>>2]|0)>>>0){A=b[z>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=z+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=WRb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;switch(C>>>3&536870911|0){case 1:{if((C&255|0)!=10){F=C;break b}B=f[j>>2]|0;z=B&-2;if(!(B&1))G=z;else G=f[z+4>>2]|0;z=f[i>>2]|0;if((z|0)==527320){WJa(i,G,527320);H=f[i>>2]|0}else H=z;if(!(fUb(c,H)|0)){I=0;D=67;break a}z=f[k>>2]|0;B=b[z+11>>0]|0;if(B<<24>>24<0){J=f[z>>2]|0;K=f[z+4>>2]|0}else{J=z;K=B&255}if(gUb(J,K,0,398368)|0)continue a;else{I=0;D=67;break a}break}case 2:{if((C&255|0)!=18){F=C;break b}B=f[j>>2]|0;z=B&-2;if(!(B&1))L=z;else L=f[z+4>>2]|0;z=f[l>>2]|0;if((z|0)==527320){WJa(l,L,527320);M=f[l>>2]|0}else M=z;if(!(fUb(c,M)|0)){I=0;D=67;break a}z=f[m>>2]|0;B=b[z+11>>0]|0;if(B<<24>>24<0){N=f[z>>2]|0;O=f[z+4>>2]|0}else{N=z;O=B&255}if(gUb(N,O,0,398399)|0)continue a;else{I=0;D=67;break a}break}case 3:{if((C&255|0)!=26){F=C;break b}if(!(fUb(c,JLa(n)|0)|0)){I=0;D=67;break a}B=f[(f[p>>2]|0)+4+((f[o>>2]|0)+-1<<2)>>2]|0;z=b[B+11>>0]|0;if(z<<24>>24<0){P=f[B>>2]|0;Q=f[B+4>>2]|0}else{P=B;Q=z&255}if(gUb(P,Q,0,398428)|0)continue a;else{I=0;D=67;break a}break}case 4:{if((C&255|0)!=34){F=C;break b}z=f[j>>2]|0;B=z&-2;if(!(z&1))R=B;else R=f[B+4>>2]|0;B=f[q>>2]|0;if((B|0)==527320){WJa(q,R,527320);S=f[q>>2]|0}else S=B;if(!(fUb(c,S)|0)){I=0;D=67;break a}B=f[r>>2]|0;z=b[B+11>>0]|0;if(z<<24>>24<0){T=f[B>>2]|0;U=f[B+4>>2]|0}else{T=B;U=z&255}if(gUb(T,U,0,398460)|0)continue a;else{I=0;D=67;break a}break}case 5:{if((C&255|0)!=42){F=C;break b}f[g>>2]=s;z=_i[f[(f[s>>2]|0)+68>>2]&1023](s)|0;f[a>>2]=z;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[v>>2]=0;z=f[c>>2]|0;if(z>>>0<(f[h>>2]|0)>>>0?(B=b[z>>0]|0,B<<24>>24>-1):0){f[c>>2]=z+1;V=B&255;D=51}else{B=VRb(c)|0;if((B|0)>-1){V=B;D=51}else W=6}do if((D|0)==51){D=0;GRb(e,c,V);if((f[w>>2]|0)>=0?RQa(g,c)|0:0){if(!(LRb(c,f[e>>2]|0)|0)){W=6;break}B=b[x>>0]|0;z=B<<24>>24<0;A=gUb(z?f[t>>2]|0:t,z?f[y>>2]|0:B&255,0,398493)|0;W=A?0:6;break}W=6}while(0);A=f[v>>2]|0;if(A|0)Yi[f[(f[A>>2]|0)+4>>2]&2047](A);if((b[x>>0]|0)<0)YDc(f[t>>2]|0);switch(W&7){case 0:{continue a;break}case 6:{I=0;D=67;break a;break}default:{D=66;break a}}break}default:{F=C;break b}}}while(0);if(!F){D=66;break}A=f[j>>2]|0;if(!(A&1))X=mNa(j)|0;else X=A&-2;if(!(Djc(c,F,X)|0)){I=0;D=67;break}}if((D|0)==66){I=1;u=d;return I|0}else if((D|0)==67){u=d;return I|0}return 0}function EQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;if((e&1|0)!=0&(b[473420]|0)!=0)g=Jjc(e&-2)|0;else g=0;e=f[a+12>>2]|0;h=e+g|0;if((e|0)>0){g=f[a+20>>2]|0;i=0;j=h;while(1){k=f[g+4+(i<<2)>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0?f[k+4>>2]|0:l&255;l=m+j+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(e|0)){n=l;break}else j=l}}else n=h;h=a+24|0;Wdc(h);j=a+56|0;e=f[f[j>>2]>>2]|0;Wdc(h);i=e+n|0;n=f[j>>2]|0;j=f[n+12>>2]|0;e=f[n+4>>2]|0;a:do if(e>>>0>j>>>0){g=f[n+16>>2]|0;l=j;while(1){o=f[g+(l<<2)>>2]|0;if(o|0)break;m=l+1|0;if(m>>>0<e>>>0)l=m;else{p=0;q=m;break a}}if((o|0)==(f[g+((l^1)<<2)>>2]|0)){p=f[(f[o>>2]|0)+16>>2]|0;q=l;break}else{p=o;q=l;break}}else{p=0;q=j}while(0);f[d>>2]=p;f[d+4>>2]=n;f[d+8>>2]=q;q=a+44|0;n=i;i=0;while(1){Wdc(h);p=f[d>>2]|0;if(!p)break;if(!i){r=0;s=p}else{p=(_i[f[(f[i>>2]|0)+20>>2]&1023](i)|0)==0;r=p?i:0;s=f[d>>2]|0}p=f[s+12>>2]|0;j=p+16|0;o=f[q>>2]|0;if(!o){e=VDc(32)|0;f[e+12>>2]=0;f[e+4>>2]=527320;f[e+8>>2]=0;f[e+20>>2]=0;t=e}else{if(f[o+64>>2]|0)OQb(o,14872,32);e=MQb(o,32)|0;m=o;f[e+12>>2]=m;f[e+4>>2]=527320;f[e+8>>2]=0;f[e+20>>2]=m;t=e}f[t>>2]=80668;f[t+24>>2]=p;f[t+28>>2]=j;f[t+16>>2]=3;if((r|0)!=(t|0))if(!r)v=t;else{Yi[f[(f[r>>2]|0)+4>>2]&2047](r);v=t}else v=r;j=v+16|0;p=f[j>>2]|0;if(!(p&1)){w=p;x=0}else{p=_i[f[(f[v>>2]|0)+100>>2]&1023](v)|0;e=b[p+11>>0]|0;m=e<<24>>24<0?f[p+4>>2]|0:e&255;e=m+1+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=f[j>>2]|0;x=e}if(!(w&2))y=0;else{e=AOa(_i[f[(f[v>>2]|0)+104>>2]&1023](v)|0)|0;y=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}e=y+x|0;j=e+n+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;pJa(d)|0;n=j;i=v}if(i|0?(_i[f[(f[i>>2]|0)+20>>2]&1023](i)|0)==0:0)Yi[f[(f[i>>2]|0)+4>>2]&2047](i);i=f[a+60>>2]|0;v=b[i+11>>0]|0;d=v<<24>>24<0;if(d)z=f[i+4>>2]|0;else z=v&255;if(!z)A=n;else{z=d?f[i+4>>2]|0:v&255;A=n+1+z+((((($(z|1|0)|0)^31)*9|0)+73|0)>>>6)|0}z=f[a+64>>2]|0;n=b[z+11>>0]|0;v=n<<24>>24<0;if(v)B=f[z+4>>2]|0;else B=n&255;if(!B)C=A;else{B=v?f[z+4>>2]|0:n&255;C=A+1+B+((((($(B|1|0)|0)^31)*9|0)+73|0)>>>6)|0}B=f[a+68>>2]|0;A=b[B+11>>0]|0;n=A<<24>>24<0;if(n)D=f[B+4>>2]|0;else D=A&255;if(!D){E=C;F=a+72|0;f[F>>2]=E;u=c;return E|0}D=n?f[B+4>>2]|0:A&255;E=C+1+D+((((($(D|1|0)|0)^31)*9|0)+73|0)>>>6)|0;F=a+72|0;f[F>>2]=E;u=c;return E|0}function FQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+16|0;e=d;g=a+60|0;h=f[g>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;if(j)k=f[h+4>>2]|0;else k=i&255;if(k|0){if(j){l=f[h>>2]|0;m=f[h+4>>2]|0}else{l=h;m=i&255}gUb(l,m,1,398368)|0;$Tb(1,f[g>>2]|0,c)}g=a+64|0;m=f[g>>2]|0;l=b[m+11>>0]|0;i=l<<24>>24<0;if(i)n=f[m+4>>2]|0;else n=l&255;if(n|0){if(i){o=f[m>>2]|0;p=f[m+4>>2]|0}else{o=m;p=l&255}gUb(o,p,1,398399)|0;$Tb(2,f[g>>2]|0,c)}g=f[a+12>>2]|0;if((g|0)>0){p=a+20|0;o=0;do{l=f[(f[p>>2]|0)+4+(o<<2)>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){q=f[l>>2]|0;r=f[l+4>>2]|0}else{q=l;r=m&255}gUb(q,r,1,398428)|0;_Tb(3,f[(f[p>>2]|0)+4+(o<<2)>>2]|0,c);o=o+1|0}while((o|0)!=(g|0))}g=a+68|0;o=f[g>>2]|0;p=b[o+11>>0]|0;r=p<<24>>24<0;if(r)s=f[o+4>>2]|0;else s=p&255;if(s|0){if(r){t=f[o>>2]|0;v=f[o+4>>2]|0}else{t=o;v=p&255}gUb(t,v,1,398460)|0;$Tb(4,f[g>>2]|0,c)}g=a+24|0;Wdc(g);v=a+56|0;do if(f[f[v>>2]>>2]|0){if(!(b[c+18>>0]|0)){if(f[220805]|0)w=35}else if(b[c+19>>0]|0)w=35;if((w|0)==35?(Wdc(g),(f[f[v>>2]>>2]|0)>>>0>1):0){Wdc(g);t=f[f[v>>2]>>2]|0;p=XDc(t>>>0>1073741823?-1:t<<2)|0;Wdc(g);t=f[v>>2]|0;o=f[t+12>>2]|0;r=f[t+4>>2]|0;a:do if(r>>>0>o>>>0){s=f[t+16>>2]|0;q=o;while(1){x=f[s+(q<<2)>>2]|0;if(x|0)break;m=q+1|0;if(m>>>0<r>>>0)q=m;else{y=0;z=m;break a}}if((x|0)==(f[s+((q^1)<<2)>>2]|0)){y=f[(f[x>>2]|0)+16>>2]|0;z=q;break}else{y=x;z=q;break}}else{y=0;z=o}while(0);f[e>>2]=y;f[e+4>>2]=t;f[e+8>>2]=z;o=0;while(1){Wdc(g);r=f[e>>2]|0;if(!r)break;f[p+(o<<2)>>2]=f[r+12>>2];pJa(e)|0;o=o+1|0}fOa(p,p+(o<<2)|0,e);if(o|0){t=a+44|0;r=0;m=0;do{l=p+(r<<2)|0;i=f[l>>2]|0;n=i+16|0;h=f[t>>2]|0;if(!h){j=VDc(32)|0;f[j+12>>2]=0;f[j+4>>2]=527320;f[j+8>>2]=0;f[j+20>>2]=0;A=j}else{if(f[h+64>>2]|0)OQb(h,14872,32);j=MQb(h,32)|0;k=h;f[j+12>>2]=k;f[j+4>>2]=527320;f[j+8>>2]=0;f[j+20>>2]=k;A=j}f[A>>2]=80668;f[A+24>>2]=i;f[A+28>>2]=n;f[A+16>>2]=3;if((m|0)!=(A|0))if(!m)B=A;else{Yi[f[(f[m>>2]|0)+4>>2]&2047](m);B=A}else B=m;eUb(5,B,c);n=(_i[f[(f[B>>2]|0)+20>>2]&1023](B)|0)==0;m=n?B:0;n=f[l>>2]|0;l=b[n+11>>0]|0;if(l<<24>>24<0){C=f[n>>2]|0;D=f[n+4>>2]|0}else{C=n;D=l&255}gUb(C,D,1,398493)|0;r=r+1|0}while(r>>>0<o>>>0);if(m|0)Yi[f[(f[m>>2]|0)+4>>2]&2047](m)}ZDc(p);break}Wdc(g);o=f[v>>2]|0;r=f[o+12>>2]|0;t=f[o+4>>2]|0;b:do if(t>>>0>r>>>0){l=f[o+16>>2]|0;n=r;while(1){E=f[l+(n<<2)>>2]|0;if(E|0)break;i=n+1|0;if(i>>>0<t>>>0)n=i;else{F=0;G=i;break b}}if((E|0)==(f[l+((n^1)<<2)>>2]|0)){F=f[(f[E>>2]|0)+16>>2]|0;G=n;break}else{F=E;G=n;break}}else{F=0;G=r}while(0);f[e>>2]=F;f[e+4>>2]=o;f[e+8>>2]=G;r=a+44|0;t=0;while(1){Wdc(g);p=f[e>>2]|0;if(!p)break;m=f[p+12>>2]|0;p=m+16|0;q=f[r>>2]|0;if(!q){s=VDc(32)|0;f[s+12>>2]=0;f[s+4>>2]=527320;f[s+8>>2]=0;f[s+20>>2]=0;H=s}else{if(f[q+64>>2]|0)OQb(q,14872,32);s=MQb(q,32)|0;i=q;f[s+12>>2]=i;f[s+4>>2]=527320;f[s+8>>2]=0;f[s+20>>2]=i;H=s}f[H>>2]=80668;f[H+24>>2]=m;f[H+28>>2]=p;f[H+16>>2]=3;if((t|0)!=(H|0))if(!t)I=H;else{Yi[f[(f[t>>2]|0)+4>>2]&2047](t);I=H}else I=t;eUb(5,I,c);p=(_i[f[(f[I>>2]|0)+20>>2]&1023](I)|0)==0;m=f[(f[e>>2]|0)+12>>2]|0;s=b[m+11>>0]|0;if(s<<24>>24<0){J=f[m>>2]|0;K=f[m+4>>2]|0}else{J=m;K=s&255}gUb(J,K,1,398493)|0;pJa(e)|0;t=p?I:0}if(t|0)Yi[f[(f[t>>2]|0)+4>>2]&2047](t)}while(0);I=f[a+4>>2]|0;if(!((I&1|0)!=0&(b[473420]|0)!=0)){u=d;return}Gjc(I&-2,c);u=d;return}function GQa(a){a=a|0;return f[a+72>>2]|0}function HQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+16|0;g=e;h=a+60|0;i=f[h>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;if(k)l=f[i+4>>2]|0;else l=j&255;if(!l)m=d;else{if(k){n=f[i>>2]|0;o=f[i+4>>2]|0}else{n=i;o=j&255}gUb(n,o,1,398368)|0;o=f[h>>2]|0;b[d>>0]=10;m=dSb(o,d+1|0)|0}d=a+64|0;o=f[d>>2]|0;h=b[o+11>>0]|0;n=h<<24>>24<0;if(n)p=f[o+4>>2]|0;else p=h&255;if(!p)q=m;else{if(n){r=f[o>>2]|0;s=f[o+4>>2]|0}else{r=o;s=h&255}gUb(r,s,1,398399)|0;s=f[d>>2]|0;b[m>>0]=18;q=dSb(s,m+1|0)|0}m=f[a+12>>2]|0;if((m|0)>0){s=a+20|0;d=0;r=q;while(1){h=f[(f[s>>2]|0)+4+(d<<2)>>2]|0;o=b[h+11>>0]|0;if(o<<24>>24<0){t=f[h>>2]|0;v=f[h+4>>2]|0}else{t=h;v=o&255}gUb(t,v,1,398428)|0;o=f[(f[s>>2]|0)+4+(d<<2)>>2]|0;b[r>>0]=26;h=dSb(o,r+1|0)|0;d=d+1|0;if((d|0)==(m|0)){w=h;break}else r=h}}else w=q;q=a+68|0;r=f[q>>2]|0;m=b[r+11>>0]|0;d=m<<24>>24<0;if(d)x=f[r+4>>2]|0;else x=m&255;if(!x)y=w;else{if(d){z=f[r>>2]|0;A=f[r+4>>2]|0}else{z=r;A=m&255}gUb(z,A,1,398460)|0;A=f[q>>2]|0;b[w>>0]=34;y=dSb(A,w+1|0)|0}w=a+24|0;Wdc(w);A=a+56|0;do if(f[f[A>>2]>>2]|0){if(c?(Wdc(w),(f[f[A>>2]>>2]|0)>>>0>1):0){Wdc(w);q=f[f[A>>2]>>2]|0;z=XDc(q>>>0>1073741823?-1:q<<2)|0;Wdc(w);q=f[A>>2]|0;m=f[q+12>>2]|0;r=f[q+4>>2]|0;a:do if(r>>>0>m>>>0){d=f[q+16>>2]|0;x=m;while(1){B=f[d+(x<<2)>>2]|0;if(B|0)break;s=x+1|0;if(s>>>0<r>>>0)x=s;else{C=0;D=s;break a}}if((B|0)==(f[d+((x^1)<<2)>>2]|0)){C=f[(f[B>>2]|0)+16>>2]|0;D=x;break}else{C=B;D=x;break}}else{C=0;D=m}while(0);f[g>>2]=C;f[g+4>>2]=q;f[g+8>>2]=D;m=0;while(1){Wdc(w);r=f[g>>2]|0;if(!r)break;f[z+(m<<2)>>2]=f[r+12>>2];pJa(g)|0;m=m+1|0}fOa(z,z+(m<<2)|0,g);if(m){q=a+44|0;r=0;s=y;v=0;do{t=z+(r<<2)|0;h=f[t>>2]|0;o=h+16|0;n=f[q>>2]|0;if(!n){p=VDc(32)|0;f[p+12>>2]=0;f[p+4>>2]=527320;f[p+8>>2]=0;f[p+20>>2]=0;E=p}else{if(f[n+64>>2]|0)OQb(n,14872,32);p=MQb(n,32)|0;j=n;f[p+12>>2]=j;f[p+4>>2]=527320;f[p+8>>2]=0;f[p+20>>2]=j;E=p}f[E>>2]=80668;f[E+24>>2]=h;f[E+28>>2]=o;f[E+16>>2]=3;if((v|0)!=(E|0))if(!v)F=E;else{Yi[f[(f[v>>2]|0)+4>>2]&2047](v);F=E}else F=v;b[s>>0]=42;o=s+1|0;h=F+16|0;p=f[h>>2]|0;if(!(p&1)){G=p;H=0}else{p=_i[f[(f[F>>2]|0)+100>>2]&1023](F)|0;j=b[p+11>>0]|0;n=j<<24>>24<0?f[p+4>>2]|0:j&255;j=n+1+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;G=f[h>>2]|0;H=j}if(!(G&2))I=0;else{j=_i[f[(f[F>>2]|0)+104>>2]&1023](F)|0;h=_i[f[(f[j>>2]|0)+60>>2]&1023](j)|0;I=h+1+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=I+H|0;if(h>>>0>127){j=h;n=o;while(1){b[n>>0]=j|128;p=j>>>7;i=n+1|0;if(j>>>0>16383){j=p;n=i}else{J=i;K=p;break}}}else{J=o;K=h}b[J>>0]=K;n=_i[f[(f[F>>2]|0)+100>>2]&1023](F)|0;b[J+1>>0]=10;j=dSb(n,J+2|0)|0;n=_i[f[(f[F>>2]|0)+104>>2]&1023](F)|0;b[j>>0]=18;x=j+1|0;j=_i[f[(f[n>>2]|0)+60>>2]&1023](n)|0;if(j>>>0>127){d=j;p=x;while(1){b[p>>0]=d|128;i=d>>>7;k=p+1|0;if(d>>>0>16383){d=i;p=k}else{L=k;M=i;break}}}else{L=x;M=j}b[L>>0]=M;s=hj[f[(f[n>>2]|0)+64>>2]&511](n,1,L+1|0)|0;p=(_i[f[(f[F>>2]|0)+20>>2]&1023](F)|0)==0;v=p?F:0;p=f[t>>2]|0;d=b[p+11>>0]|0;if(d<<24>>24<0){N=f[p>>2]|0;O=f[p+4>>2]|0}else{N=p;O=d&255}gUb(N,O,1,398493)|0;r=r+1|0}while(r>>>0<m>>>0);if(!v)P=s;else{Yi[f[(f[v>>2]|0)+4>>2]&2047](v);P=s}}else P=y;ZDc(z);Q=P;break}Wdc(w);m=f[A>>2]|0;r=f[m+12>>2]|0;q=f[m+4>>2]|0;b:do if(q>>>0>r>>>0){d=f[m+16>>2]|0;p=r;while(1){R=f[d+(p<<2)>>2]|0;if(R|0)break;h=p+1|0;if(h>>>0<q>>>0)p=h;else{S=0;T=h;break b}}if((R|0)==(f[d+((p^1)<<2)>>2]|0)){S=f[(f[R>>2]|0)+16>>2]|0;T=p;break}else{S=R;T=p;break}}else{S=0;T=r}while(0);f[g>>2]=S;f[g+4>>2]=m;f[g+8>>2]=T;r=a+44|0;q=y;z=0;while(1){Wdc(w);s=f[g>>2]|0;if(!s)break;v=f[s+12>>2]|0;s=v+16|0;t=f[r>>2]|0;if(!t){n=VDc(32)|0;f[n+12>>2]=0;f[n+4>>2]=527320;f[n+8>>2]=0;f[n+20>>2]=0;U=n}else{if(f[t+64>>2]|0)OQb(t,14872,32);n=MQb(t,32)|0;j=t;f[n+12>>2]=j;f[n+4>>2]=527320;f[n+8>>2]=0;f[n+20>>2]=j;U=n}f[U>>2]=80668;f[U+24>>2]=v;f[U+28>>2]=s;f[U+16>>2]=3;if((z|0)!=(U|0))if(!z)V=U;else{Yi[f[(f[z>>2]|0)+4>>2]&2047](z);V=U}else V=z;b[q>>0]=42;s=q+1|0;v=V+16|0;n=f[v>>2]|0;if(!(n&1)){W=n;X=0}else{n=_i[f[(f[V>>2]|0)+100>>2]&1023](V)|0;j=b[n+11>>0]|0;t=j<<24>>24<0?f[n+4>>2]|0:j&255;j=t+1+((((($(t|1|0)|0)^31)*9|0)+73|0)>>>6)|0;W=f[v>>2]|0;X=j}if(!(W&2))Y=0;else{j=_i[f[(f[V>>2]|0)+104>>2]&1023](V)|0;v=_i[f[(f[j>>2]|0)+60>>2]&1023](j)|0;Y=v+1+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0}v=Y+X|0;if(v>>>0>127){j=v;t=s;while(1){b[t>>0]=j|128;n=j>>>7;x=t+1|0;if(j>>>0>16383){j=n;t=x}else{Z=x;_=n;break}}}else{Z=s;_=v}b[Z>>0]=_;t=_i[f[(f[V>>2]|0)+100>>2]&1023](V)|0;b[Z+1>>0]=10;j=dSb(t,Z+2|0)|0;t=_i[f[(f[V>>2]|0)+104>>2]&1023](V)|0;b[j>>0]=18;p=j+1|0;j=_i[f[(f[t>>2]|0)+60>>2]&1023](t)|0;if(j>>>0>127){d=j;n=p;while(1){b[n>>0]=d|128;x=d>>>7;h=n+1|0;if(d>>>0>16383){d=x;n=h}else{aa=h;ba=x;break}}}else{aa=p;ba=j}b[aa>>0]=ba;n=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,aa+1|0)|0;d=(_i[f[(f[V>>2]|0)+20>>2]&1023](V)|0)==0;v=f[(f[g>>2]|0)+12>>2]|0;s=b[v+11>>0]|0;if(s<<24>>24<0){ca=f[v>>2]|0;da=f[v+4>>2]|0}else{ca=v;da=s&255}gUb(ca,da,1,398493)|0;pJa(g)|0;q=n;z=d?V:0}if(!z)Q=q;else{Yi[f[(f[z>>2]|0)+4>>2]&2047](z);Q=q}}else Q=y;while(0);y=f[a+4>>2]|0;if(!((y&1|0)!=0&(b[473420]|0)!=0)){ea=Q;u=e;return ea|0}ea=Hjc(y&-2,Q)|0;u=e;return ea|0}function IQa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function JQa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,14856,0)|0;if(!c){Ehc(b,a);return}else{MQa(a,c);return}}function KQa(a,b){a=a|0;b=b|0;f[a+72>>2]=b;return}function LQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220315]|0)!=2){f[d>>2]=161028;f[d+4>>2]=7;b[d+8>>0]=0;DTb(881260,d);ZSb(d)}d=520808;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function MQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}yNa(a+8|0,c+8|0);NQa(a+24|0,c+24|0);e=f[c+60>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+60|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+64>>2]|0;k=b[e+11>>0]|0;if(k<<24>>24<0)l=f[e+4>>2]|0;else l=k&255;do if(l|0){k=a+64|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==527320){WJa(k,m,e);break}else{iEc(j,e)|0;break}}while(0);e=f[c+68>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)n=f[e+4>>2]|0;else n=c&255;if(!n)return;n=a+68|0;a=f[d>>2]|0;d=a&-2;if(!(a&1))o=d;else o=f[d+4>>2]|0;d=f[n>>2]|0;if((d|0)==527320){WJa(n,o,e);return}else{iEc(d,e)|0;return}}function NQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;Wdc(a);Wdc(b);e=f[b+32>>2]|0;b=f[e+12>>2]|0;g=f[e+4>>2]|0;a:do if(g>>>0>b>>>0){h=f[e+16>>2]|0;i=b;while(1){j=f[h+(i<<2)>>2]|0;if(j|0)break;k=i+1|0;if(k>>>0<g>>>0)i=k;else{l=0;m=k;break a}}if((j|0)==(f[h+((i^1)<<2)>>2]|0)){l=f[(f[j>>2]|0)+16>>2]|0;m=i;break}else{l=j;m=i;break}}else{l=0;m=b}while(0);f[d>>2]=l;f[d+4>>2]=e;f[d+8>>2]=m;if(!l){Vdc(a);u=c;return}m=a+24|0;e=l;do{l=f[e+12>>2]|0;lPa(BJa(m,l)|0,l+16|0);pJa(d)|0;e=f[d>>2]|0}while((e|0)!=0);Vdc(a);u=c;return}function OQa(a){a=a|0;$Pa(a);YDc(a);return}function PQa(a){a=a|0;return f[a+24>>2]|0}function QQa(a){a=a|0;return f[a+28>>2]|0}function RQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=f[c>>2]|0;j=c+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(b[i>>0]|0)==10:0){f[c>>2]=i+1;i=a+8|0;if(!(fUb(c,i)|0)){k=0;u=d;return k|0}l=f[c>>2]|0;if((((f[j>>2]|0)-l|0)>0?(b[l>>0]|0)==18:0)?(l=a+4|0,m=f[l>>2]|0,n=f[f[m+8>>2]>>2]|0,o=BJa(m,i)|0,m=a+20|0,f[m>>2]=o,(n|0)!=(f[f[(f[l>>2]|0)+8>>2]>>2]|0)):0){n=f[j>>2]|0;p=f[c>>2]|0;q=n-p|0;if((q|0)<1){PRb(c,1,q)|0;r=f[c>>2]|0;s=f[j>>2]|0;t=f[m>>2]|0}else{m=p+1|0;f[c>>2]=m;r=m;s=n;t=o}if(r>>>0<s>>>0?(s=b[r>>0]|0,s<<24>>24>-1):0){f[c>>2]=r+1;v=s&255;w=14}else w=13;if((w|0)==13?(s=VRb(c)|0,(s|0)>-1):0){v=s;w=14}do if(((w|0)==14?(GRb(e,c,v),(f[e+4>>2]|0)>=0):0)?BOa(t,c)|0:0){if(!(LRb(c,f[e>>2]|0)|0))break;do if((f[c>>2]|0)==(f[j>>2]|0)){if((f[c+32>>2]|0)==0?(f[c+12>>2]|0)!=(f[c+28>>2]|0):0)break;f[c+20>>2]=0;b[c+24>>0]=1;k=1;u=d;return k|0}while(0);k=SQa(a,c)|0;u=d;return k|0}while(0);j=f[l>>2]|0;bJa(e,f[j+8>>2]|0,i,0);i=f[e>>2]|0;l=f[e+4>>2]|0;t=f[e+8>>2]|0;if(i|0){f[g>>2]=i;f[g+4>>2]=l;f[g+8>>2]=t;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];sJa(h,j,e)}k=0;u=d;return k|0}}else w=26;if((w|0)==26?(f[e>>2]=0,f[e+4>>2]=0,f[e+8>>2]=0,iEc(a+8|0,e)|0,(b[e+11>>0]|0)<0):0)YDc(f[e>>2]|0);e=f[(f[a>>2]|0)+20>>2]|0;if(!e){w=VDc(24)|0;f[w+12>>2]=0;f[w+4>>2]=527320;f[w+8>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;x=w}else{if(f[e+64>>2]|0)OQb(e,14808,24);w=MQb(e,24)|0;j=e;f[w+12>>2]=j;f[w+4>>2]=527320;f[w+8>>2]=0;f[w+16>>2]=0;f[w+20>>2]=j;x=w}f[x>>2]=80320;w=a+24|0;j=f[w>>2]|0;if((j|0)==(x|0))y=x;else{if(j|0)Yi[f[(f[j>>2]|0)+4>>2]&2047](j);f[w>>2]=x;y=x}x=y+16|0;f[x>>2]=f[x>>2]|1;x=y+4|0;j=f[x>>2]|0;if((j|0)==527320){WJa(x,f[y+12>>2]|0,527320);z=f[x>>2]|0}else z=j;iEc(z,a+8|0)|0;z=f[w>>2]|0;j=Mi[f[(f[z>>2]|0)+44>>2]&1023](z,c)|0;if(j)TQa(a);a=f[w>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){k=j;u=d;return k|0}f[w>>2]=0;k=j;u=d;return k|0}function SQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+48|0;d=c;e=c+28|0;g=c+16|0;h=f[(f[a>>2]|0)+20>>2]|0;if(!h){i=VDc(24)|0;f[i+12>>2]=0;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=i}else{if(f[h+64>>2]|0)OQb(h,14808,24);i=MQb(h,24)|0;k=h;f[i+12>>2]=k;f[i+4>>2]=527320;f[i+8>>2]=0;f[i+16>>2]=0;f[i+20>>2]=k;j=i}f[j>>2]=80320;i=a+24|0;k=f[i>>2]|0;if((k|0)==(j|0))l=j;else{if(k|0)Yi[f[(f[k>>2]|0)+4>>2]&2047](k);f[i>>2]=j;l=j}j=f[a+20>>2]|0;k=l+16|0;f[k>>2]=f[k>>2]|2;k=l+8|0;h=f[l+12>>2]|0;l=f[k>>2]|0;if(!l){if(!h){m=VDc(24)|0;JNa(m);n=m}else{if(f[h+64>>2]|0)OQb(h,14672,24);m=MQb(h,24)|0;KNa(m,h);n=m}f[k>>2]=n;o=n}else o=l;POa(o,j);j=f[a+4>>2]|0;o=a+8|0;bJa(d,f[j+8>>2]|0,o,0);l=f[d>>2]|0;n=f[d+4>>2]|0;k=f[d+8>>2]|0;if(l|0){f[e>>2]=l;f[e+4>>2]=n;f[e+8>>2]=k;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];sJa(g,j,d)}j=f[i>>2]|0;g=j+16|0;f[g>>2]=f[g>>2]|1;g=j+4|0;e=f[g>>2]|0;if((e|0)==527320){WJa(g,f[j+12>>2]|0,527320);p=f[g>>2]|0}else p=e;f[d>>2]=f[p>>2];f[d+4>>2]=f[p+4>>2];f[d+8>>2]=f[p+8>>2];f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];f[p+8>>2]=f[o+8>>2];f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];f[o+8>>2]=f[d+8>>2];d=f[i>>2]|0;o=Mi[f[(f[d>>2]|0)+44>>2]&1023](d,b)|0;if(o)TQa(a);a=f[i>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){u=c;return o|0}f[i>>2]=0;u=c;return o|0}function TQa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+24|0;c=f[b>>2]|0;d=a+8|0;iEc(d,_i[f[(f[c>>2]|0)+100>>2]&1023](c)|0)|0;c=BJa(f[a+4>>2]|0,d)|0;d=a+20|0;f[d>>2]=c;a=f[b>>2]|0;b=a+16|0;f[b>>2]=f[b>>2]|2;b=a+8|0;e=f[a+12>>2]|0;a=f[b>>2]|0;if(a|0){g=c;h=a;POa(g,h);return}if(!e){a=VDc(24)|0;JNa(a);i=a}else{if(f[e+64>>2]|0)OQb(e,14672,24);a=MQb(e,24)|0;KNa(a,e);i=a}f[b>>2]=i;g=f[d>>2]|0;h=i;POa(g,h);return}function UQa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=80128;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;VQa(a+24|0,c);if((f[220319]|0)!=2){f[e>>2]=161028;f[e+4>>2]=11;b[e+8>>0]=0;DTb(881276,e);ZSb(e)}f[a+60>>2]=527320;f[a+64>>2]=527320;f[a+68>>2]=527320;f[a+72>>2]=0;u=d;return}function VQa(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=167152;f[a+4>>2]=b;f[a+8>>2]=0;c=a+12|0;tTb(c);f[a+16>>2]=0;wNa(b,c);f[a>>2]=80236;f[a+20>>2]=b;c=a+24|0;f[c>>2]=b;b=a+28|0;f[b>>2]=0;AJa(c);f[b>>2]=0;return}function WQa(a){a=a|0;var c=0;c=f[a+60>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+64>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=f[a+68>>2]|0;if((c|0)==527320|(c|0)==0)return;if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c);return}function XQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}YQa(a+8|0,b+8|0);if((b|0)!=520648){d=b+24|0;g=f[d>>2]|0;if(g|0){e=a+24|0;c=f[e>>2]|0;if(!c){ZQa(a);h=f[d>>2]|0;i=f[e>>2]|0}else{h=g;i=c}_Db(i,h|0?h:526592)}h=b+28|0;i=f[h>>2]|0;if(i|0){c=a+28|0;g=f[c>>2]|0;if(!g){_Qa(a);j=f[h>>2]|0;k=f[c>>2]|0}else{j=i;k=g}ESa(k,j|0?j:520896)}}j=f[b+32>>2]|0;if(!j)return;f[a+32>>2]=j;return}function YQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{$Qa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(76)|0;KPa(l);$Qa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,14856,80);l=MQb(i,80)|0;UQa(l,i);$Qa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function ZQa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(44)|0;VDb(c);e=c;g=a+24|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,18880,48);c=MQb(d,48)|0;WDb(c,d);e=c;g=a+24|0;f[g>>2]=e;return}function _Qa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(36)|0;zSa(c);e=c;g=a+28|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,14920,40);c=MQb(d,40)|0;ASa(c,d);e=c;g=a+28|0;f[g>>2]=e;return}function $Qa(a,b){a=a|0;b=b|0;MQa(b,a);return}function aRa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=79972;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=520648?(f[220317]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=9;b[d+8>>0]=0;DTb(881268,d);ZSb(d)}d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function bRa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=79972;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;if((f[220317]|0)!=2){f[e>>2]=161028;f[e+4>>2]=9;b[e+8>>0]=0;DTb(881268,e);ZSb(e)}e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;u=d;return}function cRa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220316]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=8;b[c+8>>0]=0;DTb(881264,c);ZSb(c);u=a;return}function dRa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+48|0;c=b+24|0;d=b+12|0;e=b;g=a+24|0;Wdc(g);h=a+48|0;i=f[a+56>>2]|0;a=f[i+12>>2]|0;j=f[i+4>>2]|0;a:do if(j>>>0>a>>>0){k=f[i+16>>2]|0;l=a;while(1){m=f[k+(l<<2)>>2]|0;if(m|0)break;n=l+1|0;if(n>>>0<j>>>0)l=n;else{o=0;p=n;break a}}if((m|0)==(f[k+((l^1)<<2)>>2]|0)){o=f[(f[m>>2]|0)+16>>2]|0;p=l;break}else{o=m;p=l;break}}else{o=0;p=a}while(0);f[e>>2]=o;f[e+4>>2]=i;f[e+8>>2]=p;if(!o){Vdc(g);u=b;return}do{f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];sJa(d,h,c);f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2];f[e+8>>2]=f[d+8>>2]}while((f[e>>2]|0)!=0);Vdc(g);u=b;return}function eRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f[a>>2]=80128;d=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;yNa(a+8|0,c+8|0);e=a+24|0;f[e>>2]=167152;f[a+28>>2]=0;f[a+32>>2]=0;tTb(a+36|0);f[a+40>>2]=0;f[e>>2]=80236;f[a+44>>2]=0;g=a+48|0;f[g>>2]=0;h=a+52|0;f[h>>2]=0;AJa(g);f[h>>2]=0;f[a+72>>2]=0;h=f[c+4>>2]|0;if(h&1|0){g=f[d>>2]|0;if(!(g&1))i=mNa(d)|0;else i=g&-2;ojc(i,h&-2)}NQa(e,c+24|0);e=a+60|0;f[e>>2]=527320;h=f[c+60>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0)j=f[h+4>>2]|0;else j=i&255;if(j|0){j=f[a+4>>2]|0;i=j&-2;if(!(j&1))k=i;else k=f[i+4>>2]|0;WJa(e,k,h)}h=a+64|0;f[h>>2]=527320;k=f[c+64>>2]|0;e=b[k+11>>0]|0;if(e<<24>>24<0)l=f[k+4>>2]|0;else l=e&255;if(l|0){l=f[a+4>>2]|0;e=l&-2;if(!(l&1))m=e;else m=f[e+4>>2]|0;WJa(h,m,k)}k=a+68|0;f[k>>2]=527320;m=f[c+68>>2]|0;c=b[m+11>>0]|0;if(c<<24>>24<0)n=f[m+4>>2]|0;else n=c&255;if(!n)return;n=f[a+4>>2]|0;a=n&-2;if(!(n&1))o=a;else o=f[a+4>>2]|0;WJa(k,o,m);return}function fRa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);MQa(a,b);return}function gRa(a){a=a|0;var c=0,d=0;f[a>>2]=80840;c=f[a+8>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(d);f[c>>2]=0;return}function hRa(a){a=a|0;gRa(a);YDc(a);return}function iRa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function jRa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(32)|0;VRa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14888,32);a=MQb(b,32)|0;XRa(a,b);c=a;return c|0}function kRa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function lRa(a){a=a|0;return f[a+4>>2]|0}function mRa(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=527320){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;ljc(c);return}function nRa(a){a=a|0;return 1}function oRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=e+8|0;j=a+8|0;k=a+4|0;l=a+8|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=WRb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)!=8){r=o;break b}n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(a=b[n>>0]|0,a<<24>>24>-1):0){f[c>>2]=n+1;s=a&255;t=0}else{IRb(e,c);a=e;if(!(b[i>>0]|0)){v=0;p=29;break a}else{s=f[a>>2]|0;t=f[a+4>>2]|0}}a=h;f[a>>2]=s;f[a+4>>2]=t;continue a;break}case 2:break;default:{r=o;break b}}if((o&255|0)==18){a=f[k>>2]|0;n=a&-2;if(!(a&1))w=n;else w=f[n+4>>2]|0;n=f[j>>2]|0;if((n|0)==527320){WJa(j,w,527320);x=f[j>>2]|0}else x=n;if(!(fUb(c,x)|0)){v=0;p=29;break a}n=f[l>>2]|0;a=b[n+11>>0]|0;if(a<<24>>24<0){y=f[n>>2]|0;z=f[n+4>>2]|0}else{y=n;z=a&255}if(gUb(y,z,0,399216)|0)continue a;else{v=0;p=29;break a}}else r=o}while(0);if(!r){v=1;p=29;break}a=f[k>>2]|0;if(!(a&1))A=mNa(k)|0;else A=a&-2;if(!(Djc(c,r,A)|0)){v=0;p=29;break}}if((p|0)==29){u=d;return v|0}return 0}function pRa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=a+16|0;d=f[h>>2]|0;e=f[h+4>>2]|0;if((d|0)==0&(e|0)==0){j=i;k=a+24|0;f[k>>2]=j;return j|0}h=iJc(d|1|0,e|0,1)|0;j=i+1+((((h^63)*9|0)+73|0)>>>6)|0;k=a+24|0;f[k>>2]=j;return j|0}function qRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+16|0;e=f[d>>2]|0;g=f[d+4>>2]|0;if(!((e|0)==0&(g|0)==0))NTb(1,e,g,c);g=a+8|0;e=f[g>>2]|0;d=b[e+11>>0]|0;h=d<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=d&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=d&255}gUb(j,k,1,399216)|0;$Tb(2,f[g>>2]|0,c)}g=f[a+4>>2]|0;if(!((g&1|0)!=0&(b[473420]|0)!=0))return;Gjc(g&-2,c);return}function rRa(a){a=a|0;return f[a+24>>2]|0}function sRa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+16|0;e=f[c>>2]|0;g=f[c+4>>2]|0;if((e|0)==0&(g|0)==0)h=d;else{b[d>>0]=8;c=d+1|0;d=e&255;if(g>>>0>0|(g|0)==0&e>>>0>127){i=c;j=d;k=e;e=g;while(1){b[i>>0]=j|-128;g=k;k=aJc(k|0,e|0,7)|0;l=i+1|0;m=k&255;if(!(e>>>0>0|(e|0)==0&g>>>0>16383)){n=l;o=m;break}else{i=l;j=m;e=J}}}else{n=c;o=d}b[n>>0]=o;h=n+1|0}n=a+8|0;o=f[n>>2]|0;d=b[o+11>>0]|0;c=d<<24>>24<0;if(c)p=f[o+4>>2]|0;else p=d&255;if(!p)q=h;else{if(c){r=f[o>>2]|0;s=f[o+4>>2]|0}else{r=o;s=d&255}gUb(r,s,1,399216)|0;s=f[n>>2]|0;b[h>>0]=18;q=dSb(s,h+1|0)|0}h=f[a+4>>2]|0;if(!((h&1|0)!=0&(b[473420]|0)!=0)){t=q;return t|0}t=Hjc(h&-2,q)|0;return t|0}function tRa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function uRa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,14888,0)|0;if(!c){Ehc(b,a);return}else{YRa(a,c);return}}function vRa(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function wRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220320]|0)!=2){f[d>>2]=161028;f[d+4>>2]=12;b[d+8>>0]=0;DTb(881280,d);ZSb(d)}d=520880;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function xRa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220321]|0)!=2){f[c>>2]=161028;f[c+4>>2]=13;b[c+8>>0]=0;DTb(881284,c);ZSb(c)}d=VDc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=18;e=d;g=398841;h=e+18|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+18>>0]=0;Xbc(c,80940,80964,80776,0,520880,0,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function yRa(){zRa();lYb(398860,231);rhc(398841,1749);return}function zRa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220322]|0)!=2){f[c>>2]=161028;f[c+4>>2]=14;b[c+8>>0]=0;DTb(881288,c);ZSb(c)}if((f[220323]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=15;b[c+8>>0]=0;DTb(881292,c);ZSb(c);u=a;return}function ARa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220320]|0)!=2){f[c>>2]=161028;f[c+4>>2]=12;b[c+8>>0]=0;DTb(881280,c);ZSb(c)}acc(520880,2);u=a;return}function BRa(){var a=0;aTb(3005001,3005e3,399092);SQb();f[130204]=80840;f[130205]=0;f[130206]=527320;a=520832;f[a>>2]=0;f[a+4>>2]=0;f[130210]=0;zTb(520816);return}function CRa(){var a=0,c=0;a=u;u=u+16|0;c=a;aTb(3005001,3005e3,399092);SQb();if((f[220322]|0)!=2){f[c>>2]=161028;f[c+4>>2]=14;b[c+8>>0]=0;DTb(881288,c);ZSb(c)}f[130212]=80980;f[130213]=0;f[130214]=0;f[130215]=0;f[130216]=0;f[130217]=0;b[520872]=0;f[130219]=0;zTb(520848);u=a;return}function DRa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=80980;b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;YDc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(h);f[b>>2]=0;return}function ERa(a){a=a|0;DRa(a);YDc(a);return}function FRa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function GRa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(32)|0;ZRa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14904,32);a=MQb(b,32)|0;_Ra(a,b);c=a;return c|0}function HRa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function IRa(a){a=a|0;return f[a+4>>2]|0}function JRa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}b[a+24>>0]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;ljc(a);return}function KRa(a){a=a|0;return 1}function LRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=e+4|0;m=a+24|0;n=e+8|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=WRb(c,t)|0;if((q+-1|0)>>>0<127){r=q;s=6}else v=q}b:do if((s|0)==6){s=0;switch(r>>>3&536870911|0){case 2:break;case 3:{if((r&255|0)!=24){v=r;break b}q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0?(a=b[q>>0]|0,a<<24>>24>-1):0){f[c>>2]=q+1;w=a<<24>>24!=0}else{IRb(e,c);a=e;if(!(b[n>>0]|0)){x=0;s=39;break a}else w=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[m>>0]=w&1;continue a;break}default:{v=r;break b}}if((r&255|0)==18){a=f[i>>2]|0;do if(a){q=f[k>>2]|0;p=f[a>>2]|0;if((q|0)>=(p|0))if((p|0)==(f[j>>2]|0)){y=p;s=13;break}else{z=p;A=a;s=14;break}else{f[k>>2]=q+1;B=f[a+4+(q<<2)>>2]|0;break}}else{y=f[j>>2]|0;s=13}while(0);if((s|0)==13){s=0;USb(h,y+1|0);a=f[i>>2]|0;z=f[a>>2]|0;A=a;s=14}if((s|0)==14){s=0;f[A>>2]=z+1;a=f[h>>2]|0;if(!a){q=VDc(32)|0;VRa(q);C=q}else{if(f[a+64>>2]|0)OQb(a,14888,32);q=MQb(a,32)|0;XRa(q,a);C=q}q=f[i>>2]|0;a=f[k>>2]|0;f[k>>2]=a+1;f[q+4+(a<<2)>>2]=C;B=C}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;D=q&255}else{q=VRb(c)|0;if((q|0)>-1)D=q;else{x=0;s=39;break a}}GRb(e,c,D);if((f[l>>2]|0)<0){s=26;break a}if(!(Mi[f[(f[B>>2]|0)+44>>2]&1023](B,c)|0)){s=26;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{x=0;s=39;break a}}else v=r}while(0);if(!v){x=1;s=39;break}q=f[o>>2]|0;if(!(q&1))E=mNa(o)|0;else E=q&-2;if(!(Djc(c,v,E)|0)){x=0;s=39;break}}if((s|0)==26){x=0;u=d;return x|0}else if((s|0)==39){u=d;return x|0}return 0}function MRa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c){g=e;h=a+24|0;i=b[h>>0]|0;j=i<<24>>24!=0;k=g+2|0;l=j?k:g;m=a+28|0;f[m>>2]=l;return l|0}d=a+20|0;n=0;o=e;while(1){e=f[(f[d>>2]|0)+4+(n<<2)>>2]|0;p=_i[f[(f[e>>2]|0)+48>>2]&1023](e)|0;e=p+o+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=n+1|0;if((n|0)==(c|0)){g=e;break}else o=e}h=a+24|0;i=b[h>>0]|0;j=i<<24>>24!=0;k=g+2|0;l=j?k:g;m=a+28|0;f[m>>2]=l;return l|0}function NRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{eUb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}if(b[a+24>>0]|0)YTb(3,1,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[473420]|0)!=0))return;Gjc(d&-2,c);return}function ORa(a){a=a|0;return f[a+28>>2]|0}function PRa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=f[a+12>>2]|0;if(!e)g=d;else{h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=18;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&1023](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}if(!(b[a+24>>0]|0))s=g;else{b[g>>0]=24;b[g+1>>0]=1;s=g+2|0}g=f[a+4>>2]|0;if(!((g&1|0)!=0&(b[473420]|0)!=0)){t=s;return t|0}t=Hjc(g&-2,s)|0;return t|0}function QRa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function RRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=bFc(c,21e3,14904,0)|0;if(!d){Ehc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=mNa(c)|0;else h=g&-2;ojc(h,e&-2)}URa(a+8|0,d+8|0);if(!(b[d+24>>0]|0))return;b[a+24>>0]=1;return}function SRa(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function TRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220320]|0)!=2){f[d>>2]=161028;f[d+4>>2]=12;b[d+8>>0]=0;DTb(881280,d);ZSb(d)}d=520888;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function URa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=TSb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{WRa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=VDc(32)|0;VRa(l);WRa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)OQb(i,14888,32);l=MQb(i,32)|0;XRa(l,i);WRa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function VRa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=80840;f[a+4>>2]=0;if((a|0)!=520816?(f[220322]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=14;b[d+8>>0]=0;DTb(881288,d);ZSb(d)}f[a+8>>2]=527320;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=0;u=c;return}function WRa(a,b){a=a|0;b=b|0;YRa(b,a);return}function XRa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=80840;f[a+4>>2]=c;if((f[220322]|0)!=2){f[e>>2]=161028;f[e+4>>2]=14;b[e+8>>0]=0;DTb(881288,e);ZSb(e)}f[a+8>>2]=527320;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[a+24>>2]=0;u=d;return}function YRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,e);break}else{iEc(j,e)|0;break}}while(0);e=c+16|0;c=f[e>>2]|0;k=f[e+4>>2]|0;if((c|0)==0&(k|0)==0)return;e=a+16|0;f[e>>2]=c;f[e+4>>2]=k;return}function ZRa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=80980;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=520848?(f[220323]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=15;b[d+8>>0]=0;DTb(881292,d);ZSb(d)}b[a+24>>0]=0;f[a+28>>2]=0;u=c;return}function _Ra(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=80980;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;if((f[220323]|0)==2){g=a+24|0;b[g>>0]=0;h=a+28|0;f[h>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=15;b[e+8>>0]=0;DTb(881292,e);ZSb(e);g=a+24|0;b[g>>0]=0;h=a+28|0;f[h>>2]=0;u=d;return}function $Ra(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220321]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=13;b[c+8>>0]=0;DTb(881284,c);ZSb(c);u=a;return}function aSa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220323]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=15;b[c+8>>0]=0;DTb(881292,c);ZSb(c);u=a;return}function bSa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220321]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=13;b[c+8>>0]=0;DTb(881284,c);ZSb(c);u=a;return}function cSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}URa(a+8|0,c+8|0);if(!(b[c+24>>0]|0))return;b[a+24>>0]=1;return}function dSa(a){a=a|0;var b=0,c=0;f[a>>2]=81120;b=f[a+16>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function eSa(a){a=a|0;var b=0,c=0;f[a>>2]=81120;b=f[a+16>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function fSa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function gSa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(36)|0;zSa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14920,40);a=MQb(b,40)|0;ASa(a,b);c=a;return c|0}function hSa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function iSa(a){a=a|0;return f[a+4>>2]|0}function jSa(a){a=a|0;var b=0;f[a+8>>2]=0;b=a+24|0;f[b>>2]=0;f[b+4>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function kSa(a){a=a|0;return 1}function lSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=c+4|0;e=a+24|0;g=a+28|0;h=a+8|0;i=a+12|0;j=a+16|0;k=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=WRb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}b:do if((o|0)==6){o=0;switch(n>>>3&536870911|0){case 1:{if((n&255|0)!=8){q=n;break b}m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){a=b[m>>0]|0;l=a&255;if(a<<24>>24>-1){f[c>>2]=m+1;r=l}else{s=l;o=11}}else{s=0;o=11}if((o|0)==11){o=0;l=HRb(c,s)|0;m=J;if((m|0)>-1|(m|0)==-1&l>>>0>4294967295)r=l;else{t=0;o=39;break a}}f[e>>2]=r;continue a;break}case 2:{if((n&255|0)!=16){q=n;break b}l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){m=b[l>>0]|0;a=m&255;if(m<<24>>24>-1){f[c>>2]=l+1;u=a}else{v=a;o=17}}else{v=0;o=17}if((o|0)==17){o=0;a=HRb(c,v)|0;l=J;if((l|0)>-1|(l|0)==-1&a>>>0>4294967295)u=a;else{t=0;o=39;break a}}f[g>>2]=u;continue a;break}case 3:{switch((n&255)<<24>>24){case 26:break;case 24:{if(ySa(1,26,c,h)|0)continue a;else{t=0;o=39;break a}break}default:{q=n;break b}}a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0?(l=b[a>>0]|0,l<<24>>24>-1):0){f[c>>2]=a+1;w=l&255}else{l=VRb(c)|0;if((l|0)>-1)w=l;else{t=0;o=39;break a}}l=ERb(c,w)|0;if((MRb(c)|0)>0)do{a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;x=m&255;if(m<<24>>24>-1){f[c>>2]=a+1;y=x}else{z=x;o=28}}else{z=0;o=28}if((o|0)==28){o=0;x=HRb(c,z)|0;a=J;if((a|0)>-1|(a|0)==-1&x>>>0>4294967295)y=x;else{t=0;o=39;break a}}x=f[h>>2]|0;if((x|0)==(f[i>>2]|0)){KLa(h,x+1|0);A=f[h>>2]|0}else A=x;x=f[j>>2]|0;f[h>>2]=A+1;f[x+4+(A<<2)>>2]=y}while((MRb(c)|0)>0);FRb(c,l);continue a;break}default:{q=n;break b}}}while(0);if(!q){t=1;o=39;break}x=f[k>>2]|0;if(!(x&1))B=mNa(k)|0;else B=x&-2;if(!(Djc(c,q,B)|0)){t=0;o=39;break}}if((o|0)==39)return t|0;return 0}function mSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=hUb(a+8|0)|0;if(!c)e=d;else{if((c|0)<0)g=11;else g=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=g+d|0}f[a+20>>2]=c;d=e+c|0;c=f[a+24>>2]|0;if(!c)h=d;else{if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+d|0}d=f[a+28>>2]|0;if(!d){j=h;k=a+32|0;f[k>>2]=j;return j|0}if((d|0)<0)l=11;else l=((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=l+h|0;k=a+32|0;f[k>>2]=j;return j|0}function nSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[a+24>>2]|0;if(d|0)MTb(1,d,c);d=f[a+28>>2]|0;if(d|0)MTb(2,d,c);d=a+8|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=26;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{bSb(c,26);h=f[e>>2]|0}g=f[a+20>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else bSb(c,g);g=f[d>>2]|0;if((g|0)>0){d=a+16|0;o=c+8|0;e=c+4|0;h=0;do{i=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;n=((i|0)<0)<<31>>31;if((f[o>>2]|0)>9){k=f[e>>2]|0;j=i&255;if(i>>>0>127){l=k;m=j;p=i;q=n;while(1){b[l>>0]=m|-128;r=p;p=aJc(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=k;v=j}b[u>>0]=v;q=u+1-k|0;f[e>>2]=(f[e>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else cSb(c,i,n);h=h+1|0}while((h|0)!=(g|0))}}g=f[a+4>>2]|0;if(!((g&1|0)!=0&(b[473420]|0)!=0))return;Gjc(g&-2,c);return}function oSa(a){a=a|0;return f[a+32>>2]|0}function pSa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=f[a+24>>2]|0;if(!c)e=d;else{b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=aJc(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+28>>2]|0;if(!n)p=e;else{b[e>>0]=16;o=e+1|0;e=n&255;if(n>>>0>127){d=o;g=e;k=n;i=((n|0)<0)<<31>>31;while(1){b[d>>0]=g|-128;n=k;k=aJc(k|0,i|0,7)|0;h=d+1|0;j=k&255;if(!(i>>>0>0|(i|0)==0&n>>>0>16383)){q=h;r=j;break}else{d=h;g=j;i=J}}}else{q=o;r=e}b[q>>0]=r;p=q+1|0}q=a+8|0;if((f[q>>2]|0)>0){b[p>>0]=26;r=p+1|0;e=f[a+20>>2]|0;if(e>>>0>127){o=e;i=r;while(1){b[i>>0]=o|128;g=o>>>7;d=i+1|0;if(o>>>0>16383){o=g;i=d}else{s=d;t=g;break}}}else{s=r;t=e}b[s>>0]=t;t=f[q>>2]|0;q=f[a+16>>2]|0;e=0;r=s+1|0;while(1){s=f[q+4+(e<<2)>>2]|0;i=s&255;if(s>>>0>127){o=r;g=i;d=s;k=((s|0)<0)<<31>>31;while(1){b[o>>0]=g|-128;s=d;d=aJc(d|0,k|0,7)|0;j=o+1|0;h=d&255;if(!(k>>>0>0|(k|0)==0&s>>>0>16383)){u=j;v=h;break}else{o=j;g=h;k=J}}}else{u=r;v=i}b[u>>0]=v;k=u+1|0;e=e+1|0;if((e|0)>=(t|0)){w=k;break}else r=k}}else w=p;p=f[a+4>>2]|0;if(!((p&1|0)!=0&(b[473420]|0)!=0)){x=w;return x|0}x=Hjc(p&-2,w)|0;return x|0}function qSa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function rSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=bFc(b,21e3,14920,0)|0;if(!c){Ehc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=mNa(b)|0;else g=e&-2;ojc(g,d&-2)}d=a+8|0;g=c+8|0;e=f[g>>2]|0;if(e|0){KLa(d,(f[d>>2]|0)+e|0);dJc((f[a+16>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+16>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=f[c+24>>2]|0;if(g|0)f[a+24>>2]=g;g=f[c+28>>2]|0;if(!g)return;f[a+28>>2]=g;return}function sSa(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function tSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220324]|0)!=2){f[d>>2]=161028;f[d+4>>2]=16;b[d+8>>0]=0;DTb(881296,d);ZSb(d)}d=520936;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function uSa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220325]|0)!=2){f[c>>2]=161028;f[c+4>>2]=17;b[c+8>>0]=0;DTb(881300,c);ZSb(c)}d=VDc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=14;e=d;g=399304;h=e+14|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+14>>0]=0;Xbc(c,81220,81232,81080,0,520936,0,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function vSa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220326]|0)!=2){f[c>>2]=161028;f[c+4>>2]=18;b[c+8>>0]=0;DTb(881304,c);ZSb(c)}lYb(399319,169);rhc(399304,1750);u=a;return}function wSa(){var a=0;aTb(3005001,3005e3,399489);SQb();f[130224]=81120;f[130225]=0;f[130226]=0;f[130227]=0;f[130228]=0;a=520920;f[a>>2]=0;f[a+4>>2]=0;f[130232]=0;zTb(520896);return}function xSa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220324]|0)!=2){f[c>>2]=161028;f[c+4>>2]=16;b[c+8>>0]=0;DTb(881296,c);ZSb(c)}acc(520936,1);u=a;return}function ySa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;a=f[d>>2]|0;g=d+4|0;if(a>>>0<(f[g>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>-1){f[d>>2]=a+1;k=j}else{l=j;m=4}}else{l=0;m=4}if((m|0)==4){j=HRb(d,l)|0;l=J;if((l|0)>-1|(l|0)==-1&j>>>0>4294967295)k=j;else{n=0;return n|0}}j=f[e>>2]|0;l=e+4|0;if((j|0)==(f[l>>2]|0)){KLa(e,j+1|0);o=f[e>>2]|0}else o=j;j=e+8|0;a=f[j>>2]|0;f[e>>2]=o+1;f[a+4+(o<<2)>>2]=k;k=(f[l>>2]|0)-(f[e>>2]|0)|0;if((k|0)<=0){n=1;return n|0}l=c&127|128;o=c>>>7&255;if(c>>>0<128){i=k;p=a;while(1){q=f[d>>2]|0;r=f[g>>2]|0;if(q>>>0>=r>>>0){n=1;m=27;break}if((h[q>>0]|0)!=(c|0)){n=1;m=27;break}s=q+1|0;f[d>>2]=s;if(s>>>0<r>>>0){r=b[s>>0]|0;s=r&255;if(r<<24>>24>-1){f[d>>2]=q+2;t=s;u=p}else{v=s;m=13}}else{v=0;m=13}if((m|0)==13){m=0;s=HRb(d,v)|0;q=J;if(!((q|0)>-1|(q|0)==-1&s>>>0>4294967295)){n=0;m=27;break}t=s;u=f[j>>2]|0}s=f[e>>2]|0;f[e>>2]=s+1;f[u+4+(s<<2)>>2]=t;if((i|0)>1){i=i+-1|0;p=u}else{n=1;m=27;break}}if((m|0)==27)return n|0}if(c>>>0<16384){w=k;x=a}else{n=1;return n|0}while(1){a=f[g>>2]|0;k=f[d>>2]|0;c=k;if((a-k|0)<=1){n=1;m=27;break}if((h[c>>0]|0)!=(l|0)){n=1;m=27;break}if((b[c+1>>0]|0)!=o<<24>>24){n=1;m=27;break}k=c+2|0;f[d>>2]=k;if(k>>>0<a>>>0){a=b[k>>0]|0;k=a&255;if(a<<24>>24>-1){f[d>>2]=c+3;y=k;z=x}else{A=k;m=23}}else{A=0;m=23}if((m|0)==23){m=0;k=HRb(d,A)|0;c=J;if(!((c|0)>-1|(c|0)==-1&k>>>0>4294967295)){n=0;m=27;break}y=k;z=f[j>>2]|0}k=f[e>>2]|0;f[e>>2]=k+1;f[z+4+(k<<2)>>2]=y;if((w|0)>1){w=w+-1|0;x=z}else{n=1;m=27;break}}if((m|0)==27)return n|0;return 0}function zSa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=81120;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=520896?(f[220326]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=18;b[d+8>>0]=0;DTb(881304,d);ZSb(d)}d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[a+32>>2]=0;u=c;return}function ASa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;f[a>>2]=81120;f[a+4>>2]=c;f[a+8>>2]=0;f[a+12>>2]=0;g=a+16|0;f[g>>2]=0;if(c|0){if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c}if((f[220326]|0)==2){i=a+24|0;j=i;k=j;f[k>>2]=0;l=j+4|0;m=l;f[m>>2]=0;n=a+32|0;f[n>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=18;b[e+8>>0]=0;DTb(881304,e);ZSb(e);i=a+24|0;j=i;k=j;f[k>>2]=0;l=j+4|0;m=l;f[m>>2]=0;n=a+32|0;f[n>>2]=0;u=d;return}function BSa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220325]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=17;b[c+8>>0]=0;DTb(881300,c);ZSb(c);u=a;return}function CSa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220326]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=18;b[c+8>>0]=0;DTb(881304,c);ZSb(c);u=a;return}function DSa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220325]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=17;b[c+8>>0]=0;DTb(881300,c);ZSb(c);u=a;return}function ESa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=mNa(c)|0;else g=e&-2;ojc(g,d&-2)}d=a+8|0;g=b+8|0;e=f[g>>2]|0;if(e|0){KLa(d,(f[d>>2]|0)+e|0);dJc((f[a+16>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+16>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=f[b+24>>2]|0;if(g|0)f[a+24>>2]=g;g=f[b+28>>2]|0;if(!g)return;f[a+28>>2]=g;return}function FSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=81316;c=f[a+152>>2]|0;if(!((c|0)==527320|(c|0)==0)){if((b[c+11>>0]|0)<0)YDc(f[c>>2]|0);YDc(c)}if((a|0)!=520944?(c=f[a+156>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+144>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+128>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+112>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+96>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+80>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+68|0;d=f[c>>2]|0;if(d|0?(f[a+56>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)YDc(f[h>>2]|0);YDc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;YDc(i)}f[c>>2]=0;c=f[a+48>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+32>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=f[a+16>>2]|0;if(c|0?(f[c>>2]|0)==0:0)YDc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(i);f[c>>2]=0;return}function GSa(a){a=a|0;FSa(a);YDc(a);return}function HSa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function ISa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=VDc(172)|0;bTa(a);c=a;return c|0}if(f[b+64>>2]|0)OQb(b,14936,176);a=MQb(b,176)|0;cTa(a,b);c=a;return c|0}function JSa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function KSa(a){a=a|0;return f[a+4>>2]|0}function LSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a+8>>2]=0;f[a+24>>2]=0;f[a+40>>2]=0;c=a+60|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+68>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+72>>2]=0;f[a+88>>2]=0;f[a+104>>2]=0;f[a+120>>2]=0;f[a+136>>2]=0;c=a+4|0;d=f[a+152>>2]|0;do if((d|0)!=527320){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[c>>2]|0;g=d&-2;if(!(d&1))j=g;else j=f[g+4>>2]|0;g=a+156|0;if((j|0)==0?(j=f[g>>2]|0,(j|0)!=0):0){Yi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[c>>2]|0}else k=d;f[g>>2]=0;g=a+160|0;f[g>>2]=0;f[g+4>>2]=0;if(!(k&1))return;g=k&-2;if(!(f[g>>2]|0))return;ljc(g);return}function MSa(a){a=a|0;return 1}function NSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+160|0;j=a+156|0;k=e+4|0;l=a+164|0;m=a+152|0;n=a+4|0;o=a+8|0;q=a+12|0;r=a+16|0;t=a+24|0;v=a+28|0;w=a+32|0;x=a+40|0;y=a+44|0;z=a+48|0;A=a+56|0;B=a+72|0;C=a+76|0;D=a+80|0;E=a+88|0;F=a+92|0;G=a+96|0;H=e+8|0;I=a+104|0;K=a+108|0;L=a+112|0;M=e+8|0;N=a+120|0;O=a+124|0;P=a+128|0;Q=a+136|0;R=a+140|0;S=a+144|0;a:while(1){T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0){U=b[T>>0]|0;V=U&255;if(U<<24>>24>0){f[c>>2]=T+1;W=V;X=6}else{Y=V;X=5}}else{Y=0;X=5}if((X|0)==5){X=0;V=WRb(c,Y)|0;if((V+-1|0)>>>0<127){W=V;X=6}else Z=V}b:do if((X|0)==6){X=0;do switch(W>>>3&536870911|0){case 1:{if((W&255|0)!=8){Z=W;break b}V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0){T=b[V>>0]|0;U=T&255;if(T<<24>>24>-1){f[c>>2]=V+1;_=U}else{$=U;X=11}}else{$=0;X=11}if((X|0)==11){X=0;U=HRb(c,$)|0;V=J;if((V|0)>-1|(V|0)==-1&U>>>0>4294967295)_=U;else{aa=0;X=196;break a}}f[i>>2]=_;continue a;break}case 2:{if((W&255|0)!=18){Z=W;break b}U=f[j>>2]|0;if(!U){$Sa(a);ba=f[j>>2]|0}else ba=U;U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(V=b[U>>0]|0,V<<24>>24>-1):0){f[c>>2]=U+1;ca=V&255}else{V=VRb(c)|0;if((V|0)>-1)ca=V;else{aa=0;X=196;break a}}GRb(e,c,ca);if((f[k>>2]|0)<0){X=22;break a}if(!(Mi[f[(f[ba>>2]|0)+44>>2]&1023](ba,c)|0)){X=22;break a}if(LRb(c,f[e>>2]|0)|0)continue a;else{aa=0;X=196;break a}break}case 3:{if((W&255|0)!=24){Z=W;break b}V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0){U=b[V>>0]|0;T=U&255;if(U<<24>>24>-1){f[c>>2]=V+1;da=T}else{ea=T;X=28}}else{ea=0;X=28}if((X|0)==28){X=0;T=HRb(c,ea)|0;V=J;if((V|0)>-1|(V|0)==-1&T>>>0>4294967295)da=T;else{aa=0;X=196;break a}}f[l>>2]=da;continue a;break}case 4:{if((W&255|0)!=34){Z=W;break b}T=f[n>>2]|0;V=T&-2;if(!(T&1))fa=V;else fa=f[V+4>>2]|0;V=f[m>>2]|0;if((V|0)==527320){WJa(m,fa,527320);ga=f[m>>2]|0}else ga=V;if(fUb(c,ga)|0)continue a;else{aa=0;X=196;break a}break}case 5:{switch((W&255)<<24>>24){case 42:break;case 45:{if(fPa(1,42,c,o)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0?(T=b[V>>0]|0,T<<24>>24>-1):0){f[c>>2]=V+1;ha=T&255}else{T=VRb(c)|0;if((T|0)>-1)ha=T;else{aa=0;X=196;break a}}ia=f[o>>2]|0;T=(ha|0)/4|0;if((T<<2|0)!=(ha|0)){aa=0;X=196;break a}V=ORb(c)|0;U=MRb(c)|0;if((((V|0)==-1|(U|0)<(V|0)?U:V)|0)>=(ha|0)){V=ia+T|0;if((f[o>>2]|0)<(V|0)?(SHa(o,V),U=f[o>>2]|0,ja=V-U|0,(ja<<2|0)>0):0)XIc((f[r>>2]|0)+((U<<2)+4)|0,0,(((ja|-1073741824|0)==-1073741824?1073741823:1073741822)+ja<<2)+8|0)|0;f[o>>2]=V;V=f[r>>2]|0;if(QRb(c,((V|0)==0?0:V+4|0)+(ia<<2)|0,ha)|0)continue a;else{X=49;break a}}if((ha|0)>3)ka=0;else continue a;while(1){V=f[c>>2]|0;if(((f[g>>2]|0)-V|0)>3){ja=V;U=h[ja>>0]|h[ja+1>>0]<<8|h[ja+2>>0]<<16|h[ja+3>>0]<<24;f[e>>2]=U;f[c>>2]=V+4;la=U}else{if(!(TRb(c,e)|0)){X=58;break a}la=f[e>>2]|0}U=f[o>>2]|0;if((U|0)==(f[q>>2]|0)){SHa(o,U+1|0);ma=f[o>>2]|0}else ma=U;U=f[r>>2]|0;f[o>>2]=ma+1;f[U+4+(ma<<2)>>2]=la;U=ka+1|0;if((U|0)<(T|0))ka=U;else continue a}break}case 6:{switch((W&255)<<24>>24){case 50:break;case 49:{if(aTa(1,50,c,t)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0?(U=b[T>>0]|0,U<<24>>24>-1):0){f[c>>2]=T+1;na=U&255}else{U=VRb(c)|0;if((U|0)>-1)na=U;else{aa=0;X=196;break a}}oa=f[t>>2]|0;U=(na|0)/8|0;if((U<<3|0)!=(na|0)){aa=0;X=196;break a}T=ORb(c)|0;V=MRb(c)|0;if((((T|0)==-1|(V|0)<(T|0)?V:T)|0)>=(na|0)){T=oa+U|0;if((f[t>>2]|0)<(T|0)?(THa(t,T),V=f[t>>2]|0,ja=T-V|0,(ja<<3|0)>0):0)XIc((f[w>>2]|0)+((V<<3)+8)|0,0,(((ja|-536870912|0)==-536870912?536870911:536870910)+ja<<3)+16|0)|0;f[t>>2]=T;T=f[w>>2]|0;if(QRb(c,((T|0)==0?0:T+8|0)+(oa<<3)|0,na)|0)continue a;else{X=72;break a}}if((na|0)>7)pa=0;else continue a;while(1){T=f[c>>2]|0;if(((f[g>>2]|0)-T|0)>7){ja=T;V=ja;qa=h[V>>0]|h[V+1>>0]<<8|h[V+2>>0]<<16|h[V+3>>0]<<24;V=ja+4|0;ja=h[V>>0]|h[V+1>>0]<<8|h[V+2>>0]<<16|h[V+3>>0]<<24;V=e;f[V>>2]=qa;f[V+4>>2]=ja;f[c>>2]=T+8;f[s>>2]=qa;f[s+4>>2]=ja;ra=+p[s>>3]}else{if(!(URb(c,e)|0)){X=81;break a}ra=+p[e>>3]}ja=f[t>>2]|0;if((ja|0)==(f[v>>2]|0)){THa(t,ja+1|0);sa=f[t>>2]|0}else sa=ja;ja=f[w>>2]|0;f[t>>2]=sa+1;p[ja+8+(sa<<3)>>3]=ra;ja=pa+1|0;if((ja|0)<(U|0))pa=ja;else continue a}break}case 7:{switch((W&255)<<24>>24){case 58:break;case 56:{if(ySa(1,58,c,x)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(ja=b[U>>0]|0,ja<<24>>24>-1):0){f[c>>2]=U+1;ta=ja&255}else{ja=VRb(c)|0;if((ja|0)>-1)ta=ja;else{aa=0;X=196;break a}}ja=ERb(c,ta)|0;if((MRb(c)|0)>0)do{U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0){qa=b[U>>0]|0;T=qa&255;if(qa<<24>>24>-1){f[c>>2]=U+1;ua=T}else{va=T;X=92}}else{va=0;X=92}if((X|0)==92){X=0;T=HRb(c,va)|0;U=J;if((U|0)>-1|(U|0)==-1&T>>>0>4294967295)ua=T;else{aa=0;X=196;break a}}T=f[x>>2]|0;if((T|0)==(f[y>>2]|0)){KLa(x,T+1|0);wa=f[x>>2]|0}else wa=T;T=f[z>>2]|0;f[x>>2]=wa+1;f[T+4+(wa<<2)>>2]=ua}while((MRb(c)|0)>0);FRb(c,ja);continue a;break}case 8:{if((W&255|0)!=66){Z=W;break b}if(fUb(c,JLa(A)|0)|0)continue a;else{aa=0;X=196;break a}break}case 9:{switch((W&255)<<24>>24){case 74:break;case 77:{if(fPa(1,74,c,B)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0?(U=b[T>>0]|0,U<<24>>24>-1):0){f[c>>2]=T+1;xa=U&255}else{U=VRb(c)|0;if((U|0)>-1)xa=U;else{aa=0;X=196;break a}}ya=f[B>>2]|0;U=(xa|0)/4|0;if((U<<2|0)!=(xa|0)){aa=0;X=196;break a}T=ORb(c)|0;qa=MRb(c)|0;if((((T|0)==-1|(qa|0)<(T|0)?qa:T)|0)>=(xa|0)){T=ya+U|0;if((f[B>>2]|0)<(T|0)?(SHa(B,T),qa=f[B>>2]|0,V=T-qa|0,(V<<2|0)>0):0)XIc((f[D>>2]|0)+((qa<<2)+4)|0,0,(((V|-1073741824|0)==-1073741824?1073741823:1073741822)+V<<2)+8|0)|0;f[B>>2]=T;T=f[D>>2]|0;if(QRb(c,((T|0)==0?0:T+4|0)+(ya<<2)|0,xa)|0)continue a;else{X=112;break a}}if((xa|0)>3)za=0;else continue a;while(1){T=f[c>>2]|0;if(((f[g>>2]|0)-T|0)>3){V=T;qa=h[V>>0]|h[V+1>>0]<<8|h[V+2>>0]<<16|h[V+3>>0]<<24;f[e>>2]=qa;f[c>>2]=T+4;Aa=qa}else{if(!(TRb(c,e)|0)){X=121;break a}Aa=f[e>>2]|0}qa=f[B>>2]|0;if((qa|0)==(f[C>>2]|0)){SHa(B,qa+1|0);Ba=f[B>>2]|0}else Ba=qa;qa=f[D>>2]|0;f[B>>2]=Ba+1;f[qa+4+(Ba<<2)>>2]=Aa;qa=za+1|0;if((qa|0)<(U|0))za=qa;else continue a}break}case 10:{switch((W&255)<<24>>24){case 82:break;case 80:{if(ePa(1,82,c,E)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(ja=b[U>>0]|0,ja<<24>>24>-1):0){f[c>>2]=U+1;Ca=ja&255}else{ja=VRb(c)|0;if((ja|0)>-1)Ca=ja;else{aa=0;X=196;break a}}ja=ERb(c,Ca)|0;if((MRb(c)|0)>0)do{U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(qa=b[U>>0]|0,qa<<24>>24>-1):0){f[c>>2]=U+1;Da=qa&255;Ea=0}else{IRb(e,c);qa=e;if(!(b[H>>0]|0)){aa=0;X=196;break a}else{Da=f[qa>>2]|0;Ea=f[qa+4>>2]|0}}qa=f[E>>2]|0;if((qa|0)==(f[F>>2]|0)){UHa(E,qa+1|0);Fa=f[E>>2]|0}else Fa=qa;qa=f[G>>2]|0;f[E>>2]=Fa+1;U=qa+8+(Fa<<3)|0;f[U>>2]=Da;f[U+4>>2]=Ea}while((MRb(c)|0)>0);FRb(c,ja);continue a;break}case 11:{switch((W&255)<<24>>24){case 90:break;case 88:{if(gPa(1,90,c,I)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(qa=b[U>>0]|0,qa<<24>>24>-1):0){f[c>>2]=U+1;Ga=qa&255}else{qa=VRb(c)|0;if((qa|0)>-1)Ga=qa;else{aa=0;X=196;break a}}qa=ERb(c,Ga)|0;if((MRb(c)|0)>0)do{U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(T=b[U>>0]|0,T<<24>>24>-1):0){f[c>>2]=U+1;Ha=T<<24>>24!=0}else{IRb(e,c);T=e;if(!(b[M>>0]|0)){aa=0;X=196;break a}else Ha=(f[T>>2]|0)!=0|(f[T+4>>2]|0)!=0}T=f[I>>2]|0;if((T|0)==(f[K>>2]|0)){zNa(I,T+1|0);Ia=f[I>>2]|0}else Ia=T;T=f[L>>2]|0;f[I>>2]=Ia+1;b[T+4+Ia>>0]=Ha&1}while((MRb(c)|0)>0);FRb(c,qa);continue a;break}case 12:{switch((W&255)<<24>>24){case 98:break;case 97:{if(aTa(1,98,c,N)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(T=b[ja>>0]|0,T<<24>>24>-1):0){f[c>>2]=ja+1;Ja=T&255}else{T=VRb(c)|0;if((T|0)>-1)Ja=T;else{aa=0;X=196;break a}}Ka=f[N>>2]|0;T=(Ja|0)/8|0;if((T<<3|0)!=(Ja|0)){aa=0;X=196;break a}ja=ORb(c)|0;U=MRb(c)|0;if((((ja|0)==-1|(U|0)<(ja|0)?U:ja)|0)>=(Ja|0)){ja=Ka+T|0;if((f[N>>2]|0)<(ja|0)?(THa(N,ja),U=f[N>>2]|0,V=ja-U|0,(V<<3|0)>0):0)XIc((f[P>>2]|0)+((U<<3)+8)|0,0,(((V|-536870912|0)==-536870912?536870911:536870910)+V<<3)+16|0)|0;f[N>>2]=ja;ja=f[P>>2]|0;if(QRb(c,((ja|0)==0?0:ja+8|0)+(Ka<<3)|0,Ja)|0)continue a;else{X=165;break a}}if((Ja|0)>7)La=0;else continue a;while(1){ja=f[c>>2]|0;if(((f[g>>2]|0)-ja|0)>7){V=ja;U=V;Ma=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;U=V+4|0;V=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;U=e;f[U>>2]=Ma;f[U+4>>2]=V;f[c>>2]=ja+8;f[s>>2]=Ma;f[s+4>>2]=V;Na=+p[s>>3]}else{if(!(URb(c,e)|0)){X=174;break a}Na=+p[e>>3]}V=f[N>>2]|0;if((V|0)==(f[O>>2]|0)){THa(N,V+1|0);Oa=f[N>>2]|0}else Oa=V;V=f[P>>2]|0;f[N>>2]=Oa+1;p[V+8+(Oa<<3)>>3]=Na;V=La+1|0;if((V|0)<(T|0))La=V;else continue a}break}case 13:{switch((W&255)<<24>>24){case 106:break;case 104:{if(ySa(1,106,c,Q)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0?(qa=b[T>>0]|0,qa<<24>>24>-1):0){f[c>>2]=T+1;Pa=qa&255}else{qa=VRb(c)|0;if((qa|0)>-1)Pa=qa;else{aa=0;X=196;break a}}qa=ERb(c,Pa)|0;if((MRb(c)|0)>0)do{T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0){V=b[T>>0]|0;Ma=V&255;if(V<<24>>24>-1){f[c>>2]=T+1;Qa=Ma}else{Ra=Ma;X=185}}else{Ra=0;X=185}if((X|0)==185){X=0;Ma=HRb(c,Ra)|0;T=J;if((T|0)>-1|(T|0)==-1&Ma>>>0>4294967295)Qa=Ma;else{aa=0;X=196;break a}}Ma=f[Q>>2]|0;if((Ma|0)==(f[R>>2]|0)){KLa(Q,Ma+1|0);Sa=f[Q>>2]|0}else Sa=Ma;Ma=f[S>>2]|0;f[Q>>2]=Sa+1;f[Ma+4+(Sa<<2)>>2]=Qa}while((MRb(c)|0)>0);FRb(c,qa);continue a;break}default:{Z=W;break b}}while(0)}while(0);if(!Z){aa=1;X=196;break}Ma=f[n>>2]|0;if(!(Ma&1))Ta=mNa(n)|0;else Ta=Ma&-2;if(!(Djc(c,Z,Ta)|0)){aa=0;X=196;break}}switch(X|0){case 22:{aa=0;u=d;return aa|0}case 49:{if((f[o>>2]|0)<=0){aa=0;u=d;return aa|0}f[o>>2]=ia;aa=0;u=d;return aa|0}case 58:{aa=0;u=d;return aa|0}case 72:{if((f[t>>2]|0)<=0){aa=0;u=d;return aa|0}f[t>>2]=oa;aa=0;u=d;return aa|0}case 81:{aa=0;u=d;return aa|0}case 112:{if((f[B>>2]|0)<=0){aa=0;u=d;return aa|0}f[B>>2]=ya;aa=0;u=d;return aa|0}case 121:{aa=0;u=d;return aa|0}case 165:{if((f[N>>2]|0)<=0){aa=0;u=d;return aa|0}f[N>>2]=Ka;aa=0;u=d;return aa|0}case 174:{aa=0;u=d;return aa|0}case 196:{u=d;return aa|0}}return 0}function OSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[473420]|0)!=0)d=Jjc(c&-2)|0;else d=0;c=f[a+8>>2]<<2;if(!c)e=d;else{if((c|0)<0)g=10;else g=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;e=d+1+g|0}f[a+20>>2]=c;g=e+c|0;c=f[a+24>>2]<<3;if(!c)h=g;else{if((c|0)<0)i=10;else i=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;h=g+1+i|0}f[a+36>>2]=c;i=h+c|0;c=hUb(a+40|0)|0;if(!c)j=i;else{if((c|0)<0)k=10;else k=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;j=i+1+k|0}f[a+52>>2]=c;k=f[a+60>>2]|0;i=j+c+k|0;if((k|0)>0){c=f[a+68>>2]|0;j=0;h=i;while(1){g=f[c+4+(j<<2)>>2]|0;e=b[g+11>>0]|0;d=e<<24>>24<0?f[g+4>>2]|0:e&255;e=d+h+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=j+1|0;if((j|0)==(k|0)){l=e;break}else h=e}}else l=i;i=f[a+72>>2]<<2;if(!i)m=l;else{if((i|0)<0)n=10;else n=(((($(i|1|0)|0)^31)*9|0)+73|0)>>>6;m=l+1+n|0}f[a+84>>2]=i;n=m+i|0;i=f[a+88>>2]|0;if((i|0)>0){m=f[a+96>>2]|0;l=0;h=0;do{k=m+8+(h<<3)|0;j=iJc(f[k>>2]|1|0,f[k+4>>2]|0,1)|0;l=((((j^63)*9|0)+73|0)>>>6)+l|0;h=h+1|0}while((h|0)!=(i|0));if(l){if((l|0)<0)o=11;else o=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;p=l;q=o+n|0}else{p=0;q=n}}else{p=0;q=n}f[a+100>>2]=p;n=q+p|0;p=f[a+104>>2]|0;if(!p)r=n;else{if((p|0)<0)s=11;else s=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+n|0}f[a+116>>2]=p;n=r+p|0;p=f[a+120>>2]<<3;if(!p)t=n;else{if((p|0)<0)u=11;else u=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;t=u+n|0}f[a+132>>2]=p;n=t+p|0;p=hUb(a+136|0)|0;if(!p)v=n;else{if((p|0)<0)w=11;else w=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;v=w+n|0}f[a+148>>2]=p;n=v+p|0;p=f[a+152>>2]|0;v=b[p+11>>0]|0;w=v<<24>>24<0;if(w)x=f[p+4>>2]|0;else x=v&255;if(!x)y=n;else{x=w?f[p+4>>2]|0:v&255;y=n+1+x+((((($(x|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if((a|0)!=520944?(x=f[a+156>>2]|0,(x|0)!=0):0){n=_i[f[(f[x>>2]|0)+48>>2]&1023](x)|0;z=y+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else z=y;y=f[a+160>>2]|0;if(!y)A=z;else{if((y|0)<0)B=11;else B=((((($(y|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;A=B+z|0}z=f[a+164>>2]|0;if(!z){C=A;D=a+168|0;f[D>>2]=C;return C|0}if((z|0)<0)E=11;else E=((((($(z|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;C=E+A|0;D=a+168|0;f[D>>2]=C;return C|0}function PSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=f[a+160>>2]|0;if(d|0)ZTb(1,d,c);if((a|0)!=520944?(d=f[a+156>>2]|0,d|0):0)eUb(2,d,c);d=f[a+164>>2]|0;if(d|0)MTb(3,d,c);d=f[a+152>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;if(g|0)bUb(4,d,c);d=a+8|0;if((f[d>>2]|0)>0){g=c+8|0;if((f[g>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=42;f[e>>2]=(f[e>>2]|0)+1;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;h=e}else{bSb(c,42);h=f[g>>2]|0}e=f[a+20>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=e}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else bSb(c,e);e=f[a+16>>2]|0;JTb((e|0)==0?0:e+4|0,f[d>>2]|0,c)}d=a+24|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){o=c+4|0;b[f[o>>2]>>0]=50;f[o>>2]=(f[o>>2]|0)+1;o=(f[e>>2]|0)+-1|0;f[e>>2]=o;p=o}else{bSb(c,50);p=f[e>>2]|0}o=f[a+36>>2]|0;if((p|0)>4){p=c+4|0;g=f[p>>2]|0;if(o>>>0>127){h=o;i=g;while(1){b[i>>0]=h|128;n=h>>>7;k=i+1|0;if(h>>>0>16383){h=n;i=k}else{q=k;r=n;break}}}else{q=g;r=o}b[q>>0]=r;r=q+1-g|0;f[p>>2]=(f[p>>2]|0)+r;f[e>>2]=(f[e>>2]|0)-r}else bSb(c,o);o=f[a+32>>2]|0;KTb((o|0)==0?0:o+8|0,f[d>>2]|0,c)}d=a+40|0;if((f[d>>2]|0)>0){o=c+8|0;if((f[o>>2]|0)>4){r=c+4|0;b[f[r>>2]>>0]=58;f[r>>2]=(f[r>>2]|0)+1;r=(f[o>>2]|0)+-1|0;f[o>>2]=r;s=r}else{bSb(c,58);s=f[o>>2]|0}r=f[a+52>>2]|0;if((s|0)>4){s=c+4|0;e=f[s>>2]|0;if(r>>>0>127){p=r;g=e;while(1){b[g>>0]=p|128;q=p>>>7;i=g+1|0;if(p>>>0>16383){p=q;g=i}else{t=i;u=q;break}}}else{t=e;u=r}b[t>>0]=u;u=t+1-e|0;f[s>>2]=(f[s>>2]|0)+u;f[o>>2]=(f[o>>2]|0)-u}else bSb(c,r);r=f[d>>2]|0;if((r|0)>0){d=a+48|0;u=c+8|0;o=c+4|0;s=0;do{e=f[(f[d>>2]|0)+4+(s<<2)>>2]|0;t=((e|0)<0)<<31>>31;if((f[u>>2]|0)>9){g=f[o>>2]|0;p=e&255;if(e>>>0>127){q=g;i=p;h=e;n=t;while(1){b[q>>0]=i|-128;k=h;h=aJc(h|0,n|0,7)|0;j=q+1|0;l=h&255;if(!(n>>>0>0|(n|0)==0&k>>>0>16383)){v=j;w=l;break}else{q=j;i=l;n=J}}}else{v=g;w=p}b[v>>0]=w;n=v+1-g|0;f[o>>2]=(f[o>>2]|0)+n;f[u>>2]=(f[u>>2]|0)-n}else cSb(c,e,t);s=s+1|0}while((s|0)!=(r|0))}}r=f[a+60>>2]|0;if((r|0)>0){s=a+68|0;u=0;do{aUb(8,f[(f[s>>2]|0)+4+(u<<2)>>2]|0,c);u=u+1|0}while((u|0)!=(r|0))}r=a+72|0;if((f[r>>2]|0)>0){u=c+8|0;if((f[u>>2]|0)>4){s=c+4|0;b[f[s>>2]>>0]=74;f[s>>2]=(f[s>>2]|0)+1;s=(f[u>>2]|0)+-1|0;f[u>>2]=s;x=s}else{bSb(c,74);x=f[u>>2]|0}s=f[a+84>>2]|0;if((x|0)>4){x=c+4|0;o=f[x>>2]|0;if(s>>>0>127){v=s;w=o;while(1){b[w>>0]=v|128;d=v>>>7;n=w+1|0;if(v>>>0>16383){v=d;w=n}else{y=n;z=d;break}}}else{y=o;z=s}b[y>>0]=z;z=y+1-o|0;f[x>>2]=(f[x>>2]|0)+z;f[u>>2]=(f[u>>2]|0)-z}else bSb(c,s);s=f[a+80>>2]|0;JTb((s|0)==0?0:s+4|0,f[r>>2]|0,c)}r=a+88|0;if((f[r>>2]|0)>0){s=c+8|0;if((f[s>>2]|0)>4){z=c+4|0;b[f[z>>2]>>0]=82;f[z>>2]=(f[z>>2]|0)+1;z=(f[s>>2]|0)+-1|0;f[s>>2]=z;A=z}else{bSb(c,82);A=f[s>>2]|0}z=f[a+100>>2]|0;if((A|0)>4){A=c+4|0;u=f[A>>2]|0;if(z>>>0>127){x=z;o=u;while(1){b[o>>0]=x|128;y=x>>>7;w=o+1|0;if(x>>>0>16383){x=y;o=w}else{B=w;C=y;break}}}else{B=u;C=z}b[B>>0]=C;C=B+1-u|0;f[A>>2]=(f[A>>2]|0)+C;f[s>>2]=(f[s>>2]|0)-C}else bSb(c,z);z=f[r>>2]|0;if((z|0)>0){r=a+96|0;C=c+8|0;s=c+4|0;A=0;do{u=(f[r>>2]|0)+8+(A<<3)|0;B=f[u>>2]|0;o=f[u+4>>2]|0;if((f[C>>2]|0)>9){u=f[s>>2]|0;x=B&255;if(o>>>0>0|(o|0)==0&B>>>0>127){y=u;w=x;v=B;d=o;while(1){b[y>>0]=w|-128;n=v;v=aJc(v|0,d|0,7)|0;i=y+1|0;q=v&255;if(!(d>>>0>0|(d|0)==0&n>>>0>16383)){D=i;E=q;break}else{y=i;w=q;d=J}}}else{D=u;E=x}b[D>>0]=E;d=D+1-u|0;f[s>>2]=(f[s>>2]|0)+d;f[C>>2]=(f[C>>2]|0)-d}else cSb(c,B,o);A=A+1|0}while((A|0)!=(z|0))}}z=a+104|0;if((f[z>>2]|0)>0){A=c+8|0;if((f[A>>2]|0)>4){C=c+4|0;b[f[C>>2]>>0]=90;f[C>>2]=(f[C>>2]|0)+1;C=(f[A>>2]|0)+-1|0;f[A>>2]=C;F=C}else{bSb(c,90);F=f[A>>2]|0}C=f[a+116>>2]|0;if((F|0)>4){F=c+4|0;s=f[F>>2]|0;if(C>>>0>127){D=C;E=s;while(1){b[E>>0]=D|128;r=D>>>7;d=E+1|0;if(D>>>0>16383){D=r;E=d}else{G=d;H=r;break}}}else{G=s;H=C}b[G>>0]=H;H=G+1-s|0;f[F>>2]=(f[F>>2]|0)+H;f[A>>2]=(f[A>>2]|0)-H}else bSb(c,C);C=f[a+112>>2]|0;LTb((C|0)==0?0:C+4|0,f[z>>2]|0,c)}z=a+120|0;if((f[z>>2]|0)>0){C=c+8|0;if((f[C>>2]|0)>4){H=c+4|0;b[f[H>>2]>>0]=98;f[H>>2]=(f[H>>2]|0)+1;H=(f[C>>2]|0)+-1|0;f[C>>2]=H;I=H}else{bSb(c,98);I=f[C>>2]|0}H=f[a+132>>2]|0;if((I|0)>4){I=c+4|0;A=f[I>>2]|0;if(H>>>0>127){F=H;s=A;while(1){b[s>>0]=F|128;G=F>>>7;E=s+1|0;if(F>>>0>16383){F=G;s=E}else{K=E;L=G;break}}}else{K=A;L=H}b[K>>0]=L;L=K+1-A|0;f[I>>2]=(f[I>>2]|0)+L;f[C>>2]=(f[C>>2]|0)-L}else bSb(c,H);H=f[a+128>>2]|0;KTb((H|0)==0?0:H+8|0,f[z>>2]|0,c)}z=a+136|0;if((f[z>>2]|0)>0){H=c+8|0;if((f[H>>2]|0)>4){L=c+4|0;b[f[L>>2]>>0]=106;f[L>>2]=(f[L>>2]|0)+1;L=(f[H>>2]|0)+-1|0;f[H>>2]=L;M=L}else{bSb(c,106);M=f[H>>2]|0}L=f[a+148>>2]|0;if((M|0)>4){M=c+4|0;C=f[M>>2]|0;if(L>>>0>127){I=L;A=C;while(1){b[A>>0]=I|128;K=I>>>7;s=A+1|0;if(I>>>0>16383){I=K;A=s}else{N=s;O=K;break}}}else{N=C;O=L}b[N>>0]=O;O=N+1-C|0;f[M>>2]=(f[M>>2]|0)+O;f[H>>2]=(f[H>>2]|0)-O}else bSb(c,L);L=f[z>>2]|0;if((L|0)>0){z=a+144|0;O=c+8|0;H=c+4|0;M=0;do{C=f[(f[z>>2]|0)+4+(M<<2)>>2]|0;N=((C|0)<0)<<31>>31;if((f[O>>2]|0)>9){A=f[H>>2]|0;I=C&255;if(C>>>0>127){K=A;s=I;F=C;G=N;while(1){b[K>>0]=s|-128;E=F;F=aJc(F|0,G|0,7)|0;D=K+1|0;r=F&255;if(!(G>>>0>0|(G|0)==0&E>>>0>16383)){P=D;Q=r;break}else{K=D;s=r;G=J}}}else{P=A;Q=I}b[P>>0]=Q;G=P+1-A|0;f[H>>2]=(f[H>>2]|0)+G;f[O>>2]=(f[O>>2]|0)-G}else cSb(c,C,N);M=M+1|0}while((M|0)!=(L|0))}}L=f[a+4>>2]|0;if(!((L&1|0)!=0&(b[473420]|0)!=0))return;Gjc(L&-2,c);return}function QSa(a){a=a|0;return f[a+168>>2]|0}function RSa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=f[a+160>>2]|0;if(!e)g=d;else{b[d>>0]=8;h=d+1|0;d=e&255;if(e>>>0>127){i=h;j=d;k=e;l=((e|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;e=k;k=aJc(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&e>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;g=o+1|0}if((a|0)!=520944?(o=f[a+156>>2]|0,(o|0)!=0):0){b[g>>0]=18;p=g+1|0;d=_i[f[(f[o>>2]|0)+60>>2]&1023](o)|0;if(d>>>0>127){h=d;l=p;while(1){b[l>>0]=h|128;j=h>>>7;i=l+1|0;if(h>>>0>16383){h=j;l=i}else{q=i;r=j;break}}}else{q=p;r=d}b[q>>0]=r;s=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,q+1|0)|0}else s=g;g=f[a+164>>2]|0;if(!g)t=s;else{b[s>>0]=24;q=s+1|0;s=g&255;if(g>>>0>127){c=q;o=s;r=g;d=((g|0)<0)<<31>>31;while(1){b[c>>0]=o|-128;g=r;r=aJc(r|0,d|0,7)|0;p=c+1|0;l=r&255;if(!(d>>>0>0|(d|0)==0&g>>>0>16383)){u=p;v=l;break}else{c=p;o=l;d=J}}}else{u=q;v=s}b[u>>0]=v;t=u+1|0}u=f[a+152>>2]|0;v=b[u+11>>0]|0;if(v<<24>>24<0)w=f[u+4>>2]|0;else w=v&255;if(!w)x=t;else{b[t>>0]=34;x=dSb(u,t+1|0)|0}t=a+8|0;if((f[t>>2]|0)>0){b[x>>0]=42;u=x+1|0;w=f[a+20>>2]|0;if(w>>>0>127){v=w;s=u;while(1){b[s>>0]=v|128;q=v>>>7;d=s+1|0;if(v>>>0>16383){v=q;s=d}else{y=d;z=q;break}}}else{y=u;z=w}b[y>>0]=z;z=y+1|0;y=f[t>>2]<<2;dJc(z|0,(f[a+16>>2]|0)+4|0,y|0)|0;A=z+y|0}else A=x;x=a+24|0;if((f[x>>2]|0)>0){b[A>>0]=50;y=A+1|0;z=f[a+36>>2]|0;if(z>>>0>127){t=z;w=y;while(1){b[w>>0]=t|128;u=t>>>7;s=w+1|0;if(t>>>0>16383){t=u;w=s}else{B=s;C=u;break}}}else{B=y;C=z}b[B>>0]=C;C=B+1|0;B=f[x>>2]<<3;dJc(C|0,(f[a+32>>2]|0)+8|0,B|0)|0;D=C+B|0}else D=A;A=a+40|0;if((f[A>>2]|0)>0){b[D>>0]=58;B=D+1|0;C=f[a+52>>2]|0;if(C>>>0>127){x=C;z=B;while(1){b[z>>0]=x|128;y=x>>>7;w=z+1|0;if(x>>>0>16383){x=y;z=w}else{E=w;F=y;break}}}else{E=B;F=C}b[E>>0]=F;F=f[A>>2]|0;A=f[a+48>>2]|0;C=0;B=E+1|0;while(1){E=f[A+4+(C<<2)>>2]|0;z=E&255;if(E>>>0>127){x=B;y=z;w=E;t=((E|0)<0)<<31>>31;while(1){b[x>>0]=y|-128;E=w;w=aJc(w|0,t|0,7)|0;u=x+1|0;s=w&255;if(!(t>>>0>0|(t|0)==0&E>>>0>16383)){G=u;H=s;break}else{x=u;y=s;t=J}}}else{G=B;H=z}b[G>>0]=H;t=G+1|0;C=C+1|0;if((C|0)>=(F|0)){I=t;break}else B=t}}else I=D;D=f[a+60>>2]|0;if((D|0)>0){B=a+68|0;F=0;C=I;while(1){G=f[(f[B>>2]|0)+4+(F<<2)>>2]|0;b[C>>0]=66;H=dSb(G,C+1|0)|0;F=F+1|0;if((F|0)==(D|0)){K=H;break}else C=H}}else K=I;I=a+72|0;if((f[I>>2]|0)>0){b[K>>0]=74;C=K+1|0;D=f[a+84>>2]|0;if(D>>>0>127){F=D;B=C;while(1){b[B>>0]=F|128;H=F>>>7;G=B+1|0;if(F>>>0>16383){F=H;B=G}else{L=G;M=H;break}}}else{L=C;M=D}b[L>>0]=M;M=L+1|0;L=f[I>>2]<<2;dJc(M|0,(f[a+80>>2]|0)+4|0,L|0)|0;N=M+L|0}else N=K;K=a+88|0;if((f[K>>2]|0)>0){b[N>>0]=82;L=N+1|0;M=f[a+100>>2]|0;if(M>>>0>127){I=M;D=L;while(1){b[D>>0]=I|128;C=I>>>7;B=D+1|0;if(I>>>0>16383){I=C;D=B}else{O=B;P=C;break}}}else{O=L;P=M}b[O>>0]=P;P=f[K>>2]|0;K=f[a+96>>2]|0;M=0;L=O+1|0;while(1){O=K+8+(M<<3)|0;D=f[O>>2]|0;I=f[O+4>>2]|0;O=D&255;if(I>>>0>0|(I|0)==0&D>>>0>127){C=L;B=O;F=D;D=I;while(1){b[C>>0]=B|-128;I=F;F=aJc(F|0,D|0,7)|0;H=C+1|0;G=F&255;if(!(D>>>0>0|(D|0)==0&I>>>0>16383)){Q=H;R=G;break}else{C=H;B=G;D=J}}}else{Q=L;R=O}b[Q>>0]=R;D=Q+1|0;M=M+1|0;if((M|0)>=(P|0)){S=D;break}else L=D}}else S=N;N=a+104|0;if((f[N>>2]|0)>0){b[S>>0]=90;L=S+1|0;P=f[a+116>>2]|0;if(P>>>0>127){M=P;Q=L;while(1){b[Q>>0]=M|128;R=M>>>7;K=Q+1|0;if(M>>>0>16383){M=R;Q=K}else{T=K;U=R;break}}}else{T=L;U=P}b[T>>0]=U;U=f[N>>2]|0;N=f[a+112>>2]|0;P=0;L=T+1|0;while(1){b[L>>0]=b[N+4+P>>0]|0;T=L+1|0;P=P+1|0;if((P|0)>=(U|0)){V=T;break}else L=T}}else V=S;S=a+120|0;if((f[S>>2]|0)>0){b[V>>0]=98;L=V+1|0;U=f[a+132>>2]|0;if(U>>>0>127){P=U;N=L;while(1){b[N>>0]=P|128;T=P>>>7;Q=N+1|0;if(P>>>0>16383){P=T;N=Q}else{W=Q;X=T;break}}}else{W=L;X=U}b[W>>0]=X;X=W+1|0;W=f[S>>2]<<3;dJc(X|0,(f[a+128>>2]|0)+8|0,W|0)|0;Y=X+W|0}else Y=V;V=a+136|0;if((f[V>>2]|0)>0){b[Y>>0]=106;W=Y+1|0;X=f[a+148>>2]|0;if(X>>>0>127){S=X;U=W;while(1){b[U>>0]=S|128;L=S>>>7;N=U+1|0;if(S>>>0>16383){S=L;U=N}else{Z=N;_=L;break}}}else{Z=W;_=X}b[Z>>0]=_;_=f[V>>2]|0;V=f[a+144>>2]|0;X=0;W=Z+1|0;while(1){Z=f[V+4+(X<<2)>>2]|0;U=Z&255;if(Z>>>0>127){S=W;L=U;N=Z;P=((Z|0)<0)<<31>>31;while(1){b[S>>0]=L|-128;Z=N;N=aJc(N|0,P|0,7)|0;T=S+1|0;Q=N&255;if(!(P>>>0>0|(P|0)==0&Z>>>0>16383)){$=T;aa=Q;break}else{S=T;L=Q;P=J}}}else{$=W;aa=U}b[$>>0]=aa;P=$+1|0;X=X+1|0;if((X|0)>=(_|0)){ba=P;break}else W=P}}else ba=Y;Y=f[a+4>>2]|0;if(!((Y&1|0)!=0&(b[473420]|0)!=0)){ca=ba;return ca|0}ca=Hjc(Y&-2,ba)|0;return ca|0}function SSa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Yi[f[(f[a>>2]|0)+28>>2]&2047](a);mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function TSa(a,b){a=a|0;b=b|0;var c=0;c=bFc(b,21e3,14936,0)|0;if(!c){Ehc(b,a);return}else{_Sa(a,c);return}}function USa(a,b){a=a|0;b=b|0;f[a+168>>2]=b;return}function VSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[220327]|0)!=2){f[d>>2]=161028;f[d+4>>2]=19;b[d+8>>0]=0;DTb(881308,d);ZSb(d)}d=521120;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function WSa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220328]|0)!=2){f[c>>2]=161028;f[c+4>>2]=20;b[c+8>>0]=0;DTb(881312,c);ZSb(c)}d=VDc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=12;e=d;g=399603;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+12>>0]=0;Xbc(c,81416,81428,81236,0,521120,0,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function XSa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220329]|0)!=2){f[c>>2]=161028;f[c+4>>2]=21;b[c+8>>0]=0;DTb(881316,c);ZSb(c)}lYb(399616,495);rhc(399603,1751);bSa();kTa();u=a;return}function YSa(){aTb(3005001,3005e3,400112);SQb();aSa();f[130236]=81316;f[130242]=0;f[130243]=0;f[130244]=0;f[130246]=0;f[130247]=0;f[130248]=0;f[130258]=0;f[130259]=0;f[130260]=0;f[130262]=0;f[130263]=0;f[130264]=0;f[130266]=0;f[130267]=0;f[130268]=0;f[130270]=0;f[130271]=0;f[130272]=0;f[130237]=0;f[130238]=0;f[130239]=0;f[130240]=0;f[130250]=0;f[130251]=0;f[130252]=0;f[130253]=0;f[130254]=0;f[130255]=0;f[130256]=0;f[130274]=527320;f[130275]=0;f[130276]=0;f[130277]=0;f[130278]=0;zTb(520944);f[130275]=520848;return}function ZSa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220327]|0)!=2){f[c>>2]=161028;f[c+4>>2]=19;b[c+8>>0]=0;DTb(881308,c);ZSb(c)}acc(521120,1);u=a;return}function _Sa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=mNa(d)|0;else h=g&-2;ojc(h,e&-2)}e=a+8|0;h=c+8|0;g=f[h>>2]|0;if(g|0){SHa(e,(f[e>>2]|0)+g|0);dJc((f[a+16>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+16>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+24|0;e=c+24|0;g=f[e>>2]|0;if(g|0){THa(h,(f[h>>2]|0)+g|0);dJc((f[a+32>>2]|0)+8+(f[h>>2]<<3)|0,(f[c+32>>2]|0)+8|0,f[e>>2]<<3|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+40|0;h=c+40|0;g=f[h>>2]|0;if(g|0){KLa(e,(f[e>>2]|0)+g|0);dJc((f[a+48>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+48>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}yNa(a+56|0,c+56|0);h=a+72|0;e=c+72|0;g=f[e>>2]|0;if(g|0){SHa(h,(f[h>>2]|0)+g|0);dJc((f[a+80>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+80>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+88|0;h=c+88|0;g=f[h>>2]|0;if(g|0){UHa(e,(f[e>>2]|0)+g|0);dJc((f[a+96>>2]|0)+8+(f[e>>2]<<3)|0,(f[c+96>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+104|0;e=c+104|0;g=f[e>>2]|0;if(g|0){zNa(h,(f[h>>2]|0)+g|0);dJc((f[h>>2]|0)+((f[a+112>>2]|0)+4)|0,(f[c+112>>2]|0)+4|0,f[e>>2]|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+120|0;h=c+120|0;g=f[h>>2]|0;if(g|0){THa(e,(f[e>>2]|0)+g|0);dJc((f[a+128>>2]|0)+8+(f[e>>2]<<3)|0,(f[c+128>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+136|0;e=c+136|0;g=f[e>>2]|0;if(g|0){KLa(h,(f[h>>2]|0)+g|0);dJc((f[a+144>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+144>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+152>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+152|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==527320){WJa(h,k,e);break}else{iEc(j,e)|0;break}}while(0);if((c|0)!=520944?(e=c+156|0,k=f[e>>2]|0,k|0):0){d=a+156|0;i=f[d>>2]|0;if(!i){$Sa(a);l=f[e>>2]|0;m=f[d>>2]|0}else{l=k;m=i}cSa(m,l|0?l:520848)}l=f[c+160>>2]|0;if(l|0)f[a+160>>2]=l;l=f[c+164>>2]|0;if(!l)return;f[a+164>>2]=l;return}function $Sa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=VDc(32)|0;ZRa(c);e=c;g=a+156|0;f[g>>2]=e;return}if(f[d+64>>2]|0)OQb(d,14904,32);c=MQb(d,32)|0;_Ra(c,d);e=c;g=a+156|0;f[g>>2]=e;return}function aTa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;i=g;j=d+4|0;k=f[d>>2]|0;do if(((f[j>>2]|0)-k|0)>7){l=k;m=l;n=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;m=l+4|0;l=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;m=i;f[m>>2]=n;f[m+4>>2]=l;f[d>>2]=k+8;f[s>>2]=n;f[s+4>>2]=l;o=+p[s>>3]}else{if(URb(d,i)|0){o=+p[i>>3];break}q=0;u=g;return q|0}while(0);i=f[e>>2]|0;k=e+4|0;if((i|0)==(f[k>>2]|0)){THa(e,i+1|0);r=f[e>>2]|0}else r=i;i=f[e+8>>2]|0;l=r+1|0;f[e>>2]=l;p[i+8+(r<<3)>>3]=o;r=f[d>>2]|0;n=(f[j>>2]|0)-r|0;if((n|0)<=0){q=1;u=g;return q|0}j=r;r=a+8|0;a=(f[k>>2]|0)-l|0;k=(n|0)/(r|0)|0;m=(k|0)<(a|0)?k:a;a:do if((m|0)>0){a=c&127|128;k=c>>>7&255;if(c>>>0<128){t=0;v=j;w=l;while(1){if((h[v>>0]|0)!=(c|0)){x=t;break a}y=v+1|0;b[s>>0]=b[y>>0];b[s+1>>0]=b[y+1>>0];b[s+2>>0]=b[y+2>>0];b[s+3>>0]=b[y+3>>0];b[s+4>>0]=b[y+4>>0];b[s+5>>0]=b[y+5>>0];b[s+6>>0]=b[y+6>>0];b[s+7>>0]=b[y+7>>0];o=+p[s>>3];y=w;w=w+1|0;f[e>>2]=w;p[i+8+(y<<3)>>3]=o;y=t+1|0;if((y|0)>=(m|0)){x=y;break a}else{t=y;v=v+9|0}}}if(c>>>0<16384){v=0;t=j;w=l;while(1){if((h[t>>0]|0)!=(a|0)){x=v;break a}if((b[t+1>>0]|0)!=k<<24>>24){x=v;break a}y=t+2|0;b[s>>0]=b[y>>0];b[s+1>>0]=b[y+1>>0];b[s+2>>0]=b[y+2>>0];b[s+3>>0]=b[y+3>>0];b[s+4>>0]=b[y+4>>0];b[s+5>>0]=b[y+5>>0];b[s+6>>0]=b[y+6>>0];b[s+7>>0]=b[y+7>>0];o=+p[s>>3];y=w;w=w+1|0;f[e>>2]=w;p[i+8+(y<<3)>>3]=o;y=v+1|0;if((y|0)>=(m|0)){x=y;break}else{v=y;t=t+10|0}}}else x=0}else x=0;while(0);m=Y(x,r)|0;if((m|0)<=0){q=1;u=g;return q|0}if((n|0)<(m|0)){PRb(d,m,n)|0;q=1;u=g;return q|0}else{f[d>>2]=j+m;q=1;u=g;return q|0}return 0}function bTa(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=81316;e=a+4|0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;g=a+56|0;f[a+88>>2]=0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;f[a+144>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;if((a|0)!=520944?(f[220329]|0)!=2:0){f[d>>2]=161028;f[d+4>>2]=21;b[d+8>>0]=0;DTb(881316,d);ZSb(d)}f[a+152>>2]=527320;d=a+156|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function cTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=81316;f[a+4>>2]=c;f[a+8>>2]=0;f[a+12>>2]=0;g=a+16|0;f[g>>2]=0;h=(c|0)==0;if(h){f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0}else{if(f[c+64>>2]|0)OQb(c,23816,8);i=MQb(c,8)|0;f[g>>2]=i;f[i>>2]=c;f[a+24>>2]=0;f[a+28>>2]=0;i=a+32|0;f[i>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);g=MQb(c,8)|0;f[i>>2]=g;f[g>>2]=c;f[a+40>>2]=0;f[a+44>>2]=0;g=a+48|0;f[g>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);i=MQb(c,8)|0;f[g>>2]=i;f[i>>2]=c}f[a+56>>2]=c;i=a+60|0;g=a+80|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;if(h){f[a+88>>2]=0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;f[a+144>>2]=0}else{if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c;f[a+88>>2]=0;f[a+92>>2]=0;h=a+96|0;f[h>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);g=MQb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+104>>2]=0;f[a+108>>2]=0;g=a+112|0;f[g>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c;f[a+120>>2]=0;f[a+124>>2]=0;h=a+128|0;f[h>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);g=MQb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+136>>2]=0;f[a+140>>2]=0;g=a+144|0;f[g>>2]=0;if(f[c+64>>2]|0)OQb(c,23816,8);h=MQb(c,8)|0;f[g>>2]=h;f[h>>2]=c}if((f[220329]|0)==2){j=a+152|0;f[j>>2]=527320;k=a+156|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;u=d;return}f[e>>2]=161028;f[e+4>>2]=21;b[e+8>>0]=0;DTb(881316,e);ZSb(e);j=a+152|0;f[j>>2]=527320;k=a+156|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;u=d;return}function dTa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220328]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=20;b[c+8>>0]=0;DTb(881312,c);ZSb(c);u=a;return}function eTa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220329]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=21;b[c+8>>0]=0;DTb(881316,c);ZSb(c);u=a;return}function fTa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220328]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=20;b[c+8>>0]=0;DTb(881312,c);ZSb(c);u=a;return}function gTa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220332]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=22;b[c+8>>0]=0;DTb(881328,c);ZSb(c);u=a;return}function hTa(){lYb(400225,757);rhc(400983,1752);return}function iTa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[220333]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=23;b[c+8>>0]=0;DTb(881332,c);ZSb(c);u=a;return}function jTa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[220332]|0)!=2){f[c>>2]=161028;f[c+4>>2]=22;b[c+8>>0]=0;DTb(881328,c);ZSb(c)}d=VDc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=11;e=d;g=400983;h=e+11|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+11>>0]=0;Xbc(c,0,0,881324,0,0,881320,0);if((b[c+11>>0]|0)>=0){u=a;return}YDc(f[c>>2]|0);u=a;return}function kTa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[220332]|0)==2){u=a;return}f[c>>2]=161028;f[c+4>>2]=22;b[c+8>>0]=0;DTb(881328,c);ZSb(c);u=a;return}function lTa(a){a=a|0;var b=0,c=0;f[a>>2]=86772;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)ljc(a);YDc(c);f[b>>2]=0;return}function mTa(a){a=a|0;var b=0,c=0;f[a>>2]=86772;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)YDc(b);b=f[a+4>>2]|0;if(!(b&1)){YDc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){YDc(a);return}if(f[b>>2]|0)ljc(b);YDc(c);YDc(a);return}function nTa(a){a=a|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function oTa(a,b){a=a|0;b=b|0;a=VDc(32)|0;SXa(a);if(!b)return a|0;qgb(b,a);return a|0}function pTa(a){a=a|0;return 0}function qTa(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;ljc(a);return}function rTa(a){a=a|0;return 1}function sTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+20|0;j=a+24|0;k=e+8|0;l=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=WRb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;if((o&-8|0)==8){switch((o&255)<<24>>24){case 10:break;case 8:{if(ePa(1,10,c,h)|0)continue a;else{s=0;p=27;break a}break}default:{r=o;break b}}n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(a=b[n>>0]|0,a<<24>>24>-1):0){f[c>>2]=n+1;t=a&255}else{a=VRb(c)|0;if((a|0)>-1)t=a;else{s=0;p=27;break a}}a=ERb(c,t)|0;if((MRb(c)|0)>0)do{n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(m=b[n>>0]|0,m<<24>>24>-1):0){f[c>>2]=n+1;v=m&255;w=0}else{IRb(e,c);m=e;if(!(b[k>>0]|0)){s=0;p=27;break a}else{v=f[m>>2]|0;w=f[m+4>>2]|0}}m=f[h>>2]|0;if((m|0)==(f[i>>2]|0)){UHa(h,m+1|0);x=f[h>>2]|0}else x=m;m=f[j>>2]|0;f[h>>2]=x+1;n=m+8+(x<<3)|0;f[n>>2]=v;f[n+4>>2]=w}while((MRb(c)|0)>0);FRb(c,a);continue a}else r=o}while(0);if(!r){s=1;p=27;break}n=f[l>>2]|0;if(!(n&1))y=mNa(l)|0;else y=n&-2;if(!(Djc(c,r,y)|0)){s=0;p=27;break}}if((p|0)==27){u=d;return s|0}return 0}function tTa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Jjc(b&-2)|0;b=f[a+16>>2]|0;if((b|0)>0){d=f[a+24>>2]|0;e=0;g=0;do{h=d+8+(g<<3)|0;i=iJc(f[h>>2]|1|0,f[h+4>>2]|0,1)|0;e=((((i^63)*9|0)+73|0)>>>6)+e|0;g=g+1|0}while((g|0)!=(b|0));if(e){if((e|0)<0)j=11;else j=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=e;l=j+c|0}else{k=0;l=c}}else{k=0;l=c}f[a+28>>2]=k;c=l+k|0;f[a+12>>2]=c;return c|0}
function JGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e+8|0;h=e;a:do if((c-a|0)>1){i=(b[a>>0]|0)==76?a+1|0:a;switch(b[i>>0]|0){case 78:{j=$Hc(i,c,d)|0;k=(j|0)==(i|0)?a:j;break a;break}case 90:{j=aIc(i,c,d)|0;k=(j|0)==(i|0)?a:j;break a;break}default:{j=bIc(i,c,d)|0;if((j|0)==(i|0)){l=KGc(i,c,d)|0;if((l|0)==(i|0)|(l|0)==(c|0)){k=a;break a}if((b[l>>0]|0)!=73){k=a;break a}i=BGc(l,c,d)|0;if((i|0)==(l|0)){k=a;break a}l=d+4|0;m=f[l>>2]|0;if(((m-(f[d>>2]|0)|0)/24|0)>>>0<2){k=a;break a}CGc(g,m+-24|0);m=f[l>>2]|0;n=m+-24|0;o=m;while(1){if((o|0)==(n|0))break;p=o+-24|0;f[l>>2]=p;RFc(p);o=f[l>>2]|0}l=b[g+11>>0]|0;o=l<<24>>24<0;UFc(m+-48|0,o?f[g>>2]|0:g,o?f[g+4>>2]|0:l&255)|0;gGc(g);k=i;break a}if((j|0)==(c|0)){k=c;break a}if((b[j>>0]|0)!=73){k=j;break a}l=d+4|0;o=f[l>>2]|0;if((f[d>>2]|0)==(o|0)){k=a;break a}f[h>>2]=f[d+12>>2];tGc(g,o+-24|0,h);o=d+20|0;n=f[o>>2]|0;if(n>>>0<(f[d+24>>2]|0)>>>0){f[n>>2]=0;p=n+4|0;f[p>>2]=0;q=f[g+12>>2]|0;f[n+8>>2]=0;f[n+12>>2]=q;f[n>>2]=f[g>>2];q=g+4|0;f[p>>2]=f[q>>2];p=g+8|0;f[n+8>>2]=f[p>>2];f[p>>2]=0;f[q>>2]=0;f[g>>2]=0;f[o>>2]=(f[o>>2]|0)+16}else uGc(d+16|0,g);SFc(g);o=BGc(j,c,d)|0;if((o|0)==(j|0)){k=a;break a}q=f[l>>2]|0;if(((q-(f[d>>2]|0)|0)/24|0)>>>0<2){k=a;break a}CGc(g,q+-24|0);q=f[l>>2]|0;p=q+-24|0;n=q;while(1){if((n|0)==(p|0))break;r=n+-24|0;f[l>>2]=r;RFc(r);n=f[l>>2]|0}l=b[g+11>>0]|0;n=l<<24>>24<0;UFc(q+-48|0,n?f[g>>2]|0:g,n?f[g+4>>2]|0:l&255)|0;gGc(g);k=o;break a}}}else k=a;while(0);u=e;return k|0}function KGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e;a:do if((c-a|0)>1?(b[a>>0]|0)==83:0){h=b[a+1>>0]|0;i=a+2|0;j=d+16|0;switch(h|0){case 97:{EHc(g,519173);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);m=i;break a;break}case 98:{BHc(g,519188);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);m=i;break a;break}case 115:{DHc(g,518667);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);m=i;break a;break}case 105:{FHc(g,518763);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);m=i;break a;break}case 111:{FHc(g,518840);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);m=i;break a;break}case 100:{_Hc(g,518917);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);m=i;break a;break}case 95:{k=f[j>>2]|0;if((k|0)==(f[d+20>>2]|0)){m=a;break a}l=f[k+4>>2]|0;n=d+4|0;o=d+8|0;p=f[k>>2]|0;while(1){if((p|0)==(l|0)){m=i;break a}k=f[n>>2]|0;if((k|0)==(f[o>>2]|0))qGc(d,p);else{pGc(k,p);f[n>>2]=(f[n>>2]|0)+24}p=p+24|0}break}default:{p=(h+-48|0)>>>0<10;if(!p?(Kqc(h)|0)==0:0){m=a;break a}n=i;o=(p?-48:-55)+h|0;while(1){q=n+1|0;if((n|0)==(c|0)){m=a;break a}r=b[n>>0]|0;p=r<<24>>24;l=(p+-48|0)>>>0<10;if(!l?(Kqc(p)|0)==0:0)break;n=q;o=p+(o*36|0)+(l?-48:-55)|0}if(r<<24>>24!=95){m=a;break a}n=o+1|0;h=f[j>>2]|0;i=h;if(n>>>0>=(f[d+20>>2]|0)-h>>4>>>0){m=a;break a}h=f[i+(n<<4)+4>>2]|0;l=d+4|0;p=d+8|0;k=f[i+(n<<4)>>2]|0;while(1){if((k|0)==(h|0)){m=q;break a}n=f[l>>2]|0;if((n|0)==(f[p>>2]|0))qGc(d,k);else{pGc(n,k);f[l>>2]=(f[l>>2]|0)+24}k=k+24|0}}}}else m=a;while(0);u=e;return m|0}function LGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;a:do if((c-a|0)>3?(b[a>>0]|0)==68:0){switch(b[a+1>>0]|0){case 84:case 116:break;default:{k=a;break a}}l=a+2|0;m=OGc(l,c,d)|0;if((!((m|0)==(l|0)|(m|0)==(c|0))?(b[m>>0]|0)==69:0)?(l=d+4|0,n=f[l>>2]|0,(f[d>>2]|0)!=(n|0)):0){CGc(j,n+-24|0);nGc(j,0,519163)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];n=0;while(1){if((n|0)==3)break;f[j+(n<<2)>>2]=0;n=n+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];n=0;while(1){if((n|0)==3)break;f[i+(n<<2)>>2]=0;n=n+1|0}FGc(g,h);GGc((f[l>>2]|0)+-24|0,g);RFc(g);gGc(h);gGc(i);gGc(j);k=m+1|0}else k=a}else k=a;while(0);u=e;return k|0}function MGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+80|0;g=e+60|0;h=e+24|0;i=e+12|0;j=e;k=e+48|0;a:do if(((c-a|0)>3?(b[a>>0]|0)==68:0)?(b[a+1>>0]|0)==118:0){l=a+2|0;m=b[l>>0]|0;if((m+-49&255)>=9){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;n=0;while(1){if((n|0)==3)break;f[h+(n<<2)>>2]=0;n=n+1|0}b:do if(m<<24>>24!=95?(n=OGc(l,c,d)|0,(n|0)!=(l|0)):0){o=d+4|0;p=f[o>>2]|0;if((f[d>>2]|0)!=(p|0)){CGc(i,p+-24|0);p=h+11|0;if((b[p>>0]|0)<0){q=f[h>>2]|0;b[g>>0]=0;_tc(q,g);f[h+4>>2]=0}else{b[g>>0]=0;_tc(h,g);b[p>>0]=0}PGc(h);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];p=0;while(1){if((p|0)==3)break;f[i+(p<<2)>>2]=0;p=p+1|0}gGc(i);p=f[o>>2]|0;q=p+-24|0;r=p;while(1){if((r|0)==(q|0)){s=n;t=53;break b}p=r+-24|0;f[o>>2]=p;RFc(p);r=f[o>>2]|0}}}else{s=l;t=53}while(0);do if((t|0)==53){if((((s|0)!=(c|0)?(b[s>>0]|0)==95:0)?(m=s+1|0,(m|0)!=(c|0)):0)?(o=kGc(m,c,d)|0,(o|0)!=(m|0)):0){m=d+4|0;if((f[d>>2]|0)==(f[m>>2]|0))break;QGc(i,517885,h);oGc(i,517894)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];r=0;while(1){if((r|0)==3)break;f[i+(r<<2)>>2]=0;r=r+1|0}r=b[g+11>>0]|0;n=r<<24>>24<0;UFc((f[m>>2]|0)+-24|0,n?f[g>>2]|0:g,n?f[g+4>>2]|0:r&255)|0;gGc(g);gGc(i);v=o}else v=a;gGc(h);w=v;break a}while(0);gGc(h);w=a;break}r=NGc(l,c)|0;if(((r|0)!=(c|0)?(b[r>>0]|0)==95:0)?(n=r-l|0,q=r+1|0,(q|0)!=(c|0)):0){if((b[q>>0]|0)!=112){p=kGc(q,c,d)|0;if((p|0)==(q|0)){w=a;break}q=d+4|0;if((f[d>>2]|0)==(f[q>>2]|0)){w=a;break};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)dEc(j);if(n>>>0<11){b[j+11>>0]=n;x=j}else{y=n+16&-16;z=dGc(y)|0;f[j>>2]=z;f[j+8>>2]=y|-2147483648;f[j+4>>2]=n;x=z}etc(x,l,n)|0;b[g>>0]=0;_tc(x+n|0,g);nGc(j,0,517885)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];z=0;while(1){if((z|0)==3)break;f[j+(z<<2)>>2]=0;z=z+1|0}oGc(i,517894)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];z=0;while(1){if((z|0)==3)break;f[i+(z<<2)>>2]=0;z=z+1|0}z=b[h+11>>0]|0;y=z<<24>>24<0;UFc((f[q>>2]|0)+-24|0,y?f[h>>2]|0:h,y?f[h+4>>2]|0:z&255)|0;gGc(h);gGc(i);gGc(j);w=p;break}z=r+2|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)dEc(j);if(n>>>0<11){b[j+11>>0]=n;A=j}else{y=n+16&-16;B=dGc(y)|0;f[j>>2]=B;f[j+8>>2]=y|-2147483648;f[j+4>>2]=n;A=B}etc(A,l,n)|0;b[g>>0]=0;_tc(A+n|0,g);nGc(j,0,517896)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];B=0;while(1){if((B|0)==3)break;f[j+(B<<2)>>2]=0;B=B+1|0}oGc(i,517894)|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];B=0;while(1){if((B|0)==3)break;f[i+(B<<2)>>2]=0;B=B+1|0}FGc(h,k);B=d+4|0;n=f[B>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){HGc(n,h);f[B>>2]=(f[B>>2]|0)+24}else IGc(d,h);RFc(h);gGc(k);gGc(i);gGc(j);w=z}else w=a}else w=a;while(0);u=e;return w|0}function NGc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;a:do if((a|0)!=(c|0)?(d=(b[a>>0]|0)==110?a+1|0:a,(d|0)!=(c|0)):0){e=b[d>>0]|0;f=d+1|0;if(e<<24>>24!=48)if((e+-49&255)<9){e=f;while(1){if((e|0)==(c|0)){g=c;break a}if(((b[e>>0]|0)+-48|0)>>>0>=10){g=e;break a}e=e+1|0}}else g=a;else g=f}else g=a;while(0);return g|0}function OGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;e=u;u=u+208|0;g=e+176|0;h=e+112|0;i=e+88|0;j=e+64|0;k=e+48|0;l=e+160|0;m=e+36|0;n=e+148|0;o=e+136|0;p=e+124|0;q=e+24|0;r=e+12|0;s=e;t=c;v=t-a|0;a:do if((v|0)>1){w=a+2|0;if((v|0)>3?(b[a>>0]|0)==103:0){x=(b[a+1>>0]|0)==115;y=x?w:a;z=x}else{y=a;z=0}x=y+1|0;A=a+3|0;B=(w|0)!=(c|0);C=y+2|0;do switch(b[y>>0]|0){case 76:{D=RGc(a,c,d)|0;break a;break}case 84:{D=AGc(a,c,d)|0;break a;break}case 102:{D=SGc(a,c,d)|0;break a;break}case 97:{switch(b[x>>0]|0){case 97:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=Ztc(517849)|0;if(E>>>0>4294967279)dEc(h);if(E>>>0<11){b[h+11>>0]=E;F=h}else{G=E+16&-16;H=dGc(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;F=H}etc(F,517849,E)|0;b[g>>0]=0;_tc(F+E|0,g);E=TGc(w,c,h,d)|0;gGc(h);D=(E|0)==(w|0)?a:E;break a;break}case 100:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=Ztc(517867)|0;if(E>>>0>4294967279)dEc(h);if(E>>>0<11){b[h+11>>0]=E;I=h}else{H=E+16&-16;G=dGc(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;I=G}etc(I,517867,E)|0;b[g>>0]=0;_tc(I+E|0,g);E=UGc(w,c,h,d)|0;gGc(h);D=(E|0)==(w|0)?a:E;break a;break}case 110:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=Ztc(517867)|0;if(E>>>0>4294967279)dEc(h);if(E>>>0<11){b[h+11>>0]=E;J=h}else{G=E+16&-16;H=dGc(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;J=H}etc(J,517867,E)|0;b[g>>0]=0;_tc(J+E|0,g);E=TGc(w,c,h,d)|0;gGc(h);D=(E|0)==(w|0)?a:E;break a;break}case 78:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=Ztc(517910)|0;if(E>>>0>4294967279)dEc(h);if(E>>>0<11){b[h+11>>0]=E;K=h}else{H=E+16&-16;G=dGc(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;K=G}etc(K,517910,E)|0;b[g>>0]=0;_tc(K+E|0,g);E=TGc(w,c,h,d)|0;gGc(h);D=(E|0)==(w|0)?a:E;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=Ztc(517913)|0;if(E>>>0>4294967279)dEc(h);if(E>>>0<11){b[h+11>>0]=E;L=h}else{G=E+16&-16;H=dGc(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;L=H}etc(L,517913,E)|0;b[g>>0]=0;_tc(L+E|0,g);E=TGc(w,c,h,d)|0;gGc(h);D=(E|0)==(w|0)?a:E;break a;break}case 116:{D=VGc(a,c,d)|0;break a;break}case 122:{D=WGc(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 99:{switch(b[x>>0]|0){case 99:{D=XGc(a,c,d)|0;break a;break}case 108:{D=YGc(a,c,d)|0;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=Ztc(517915)|0;if(E>>>0>4294967279)dEc(h);if(E>>>0<11){b[h+11>>0]=E;M=h}else{H=E+16&-16;G=dGc(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;M=G}etc(M,517915,E)|0;b[g>>0]=0;_tc(M+E|0,g);E=TGc(w,c,h,d)|0;gGc(h);D=(E|0)==(w|0)?a:E;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=Ztc(517917)|0;if(E>>>0>4294967279)dEc(h);if(E>>>0<11){b[h+11>>0]=E;N=h}else{G=E+16&-16;H=dGc(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;N=H}etc(N,517917,E)|0;b[g>>0]=0;_tc(N+E|0,g);E=UGc(w,c,h,d)|0;gGc(h);D=(E|0)==(w|0)?a:E;break a;break}case 118:{D=ZGc(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 100:{switch(b[x>>0]|0){case 97:{E=OGc(C,c,d)|0;if((E|0)==(C|0)){D=a;break a}H=d+4|0;if((f[d>>2]|0)==(f[H>>2]|0)){D=a;break a};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b:do if(z){G=Ztc(517919)|0;if(G>>>0>4294967279)dEc(j);if(G>>>0<11){b[j+11>>0]=G;O=j}else{P=G+16&-16;Q=dGc(P)|0;f[j>>2]=Q;f[j+8>>2]=P|-2147483648;f[j+4>>2]=G;O=Q}etc(O,517919,G)|0;b[g>>0]=0;_tc(O+G|0,g)}else{G=0;while(1){if((G|0)==3)break b;f[j+(G<<2)>>2]=0;G=G+1|0}}while(0);oGc(j,517922)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];G=0;while(1){if((G|0)==3)break;f[j+(G<<2)>>2]=0;G=G+1|0}CGc(k,(f[H>>2]|0)+-24|0);G=b[k+11>>0]|0;Q=G<<24>>24<0;UFc(i,Q?f[k>>2]|0:k,Q?f[k+4>>2]|0:G&255)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];G=0;while(1){if((G|0)==3)break;f[i+(G<<2)>>2]=0;G=G+1|0}G=f[H>>2]|0;Q=G+-24|0;P=Q+11|0;if((b[P>>0]|0)<0){R=f[Q>>2]|0;b[g>>0]=0;_tc(R,g);f[G+-20>>2]=0}else{b[g>>0]=0;_tc(Q,g);b[P>>0]=0}PGc(Q);f[Q>>2]=f[h>>2];f[Q+4>>2]=f[h+4>>2];f[Q+8>>2]=f[h+8>>2];Q=0;while(1){if((Q|0)==3)break;f[h+(Q<<2)>>2]=0;Q=Q+1|0}gGc(h);gGc(k);gGc(i);gGc(j);D=E;break a;break}case 99:{D=_Gc(a,c,d)|0;break a;break}case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517865)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;S=h}else{H=Q+16&-16;P=dGc(H)|0;f[h>>2]=P;f[h+8>>2]=H|-2147483648;f[h+4>>2]=Q;S=P}etc(S,517865,Q)|0;b[g>>0]=0;_tc(S+Q|0,g);Q=UGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 108:{Q=OGc(C,c,d)|0;if((Q|0)==(C|0)){D=a;break a}P=d+4|0;if((f[d>>2]|0)==(f[P>>2]|0)){D=a;break a};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c:do if(z){H=Ztc(517919)|0;if(H>>>0>4294967279)dEc(j);if(H>>>0<11){b[j+11>>0]=H;T=j}else{G=H+16&-16;R=dGc(G)|0;f[j>>2]=R;f[j+8>>2]=G|-2147483648;f[j+4>>2]=H;T=R}etc(T,517919,H)|0;b[g>>0]=0;_tc(T+H|0,g)}else{H=0;while(1){if((H|0)==3)break c;f[j+(H<<2)>>2]=0;H=H+1|0}}while(0);oGc(j,517932)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];E=0;while(1){if((E|0)==3)break;f[j+(E<<2)>>2]=0;E=E+1|0}CGc(k,(f[P>>2]|0)+-24|0);E=b[k+11>>0]|0;H=E<<24>>24<0;UFc(i,H?f[k>>2]|0:k,H?f[k+4>>2]|0:E&255)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];E=0;while(1){if((E|0)==3)break;f[i+(E<<2)>>2]=0;E=E+1|0}E=f[P>>2]|0;H=E+-24|0;R=H+11|0;if((b[R>>0]|0)<0){G=f[H>>2]|0;b[g>>0]=0;_tc(G,g);f[E+-20>>2]=0}else{b[g>>0]=0;_tc(H,g);b[R>>0]=0}PGc(H);f[H>>2]=f[h>>2];f[H+4>>2]=f[h+4>>2];f[H+8>>2]=f[h+8>>2];H=0;while(1){if((H|0)==3)break;f[h+(H<<2)>>2]=0;H=H+1|0}gGc(h);gGc(k);gGc(i);gGc(j);D=Q;break a;break}case 110:{D=$Gc(a,c,d)|0;break a;break}case 115:{D=aHc(a,c,d)|0;break a;break}case 116:{D=bHc(a,c,d)|0;break a;break}case 118:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(517940)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;U=h}else{P=H+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;U=R}etc(U,517940,H)|0;b[g>>0]=0;_tc(U+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}case 86:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(517942)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;V=h}else{R=H+16&-16;P=dGc(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;V=P}etc(V,517942,H)|0;b[g>>0]=0;_tc(V+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 101:{switch(b[x>>0]|0){case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(517945)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;W=h}else{P=H+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;W=R}etc(W,517945,H)|0;b[g>>0]=0;_tc(W+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}case 79:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(517947)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;X=h}else{R=H+16&-16;P=dGc(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;X=P}etc(X,517947,H)|0;b[g>>0]=0;_tc(X+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}case 113:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(517950)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;Y=h}else{P=H+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;Y=R}etc(Y,517950,H)|0;b[g>>0]=0;_tc(Y+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 103:{switch(b[x>>0]|0){case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(517953)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;Z=h}else{R=H+16&-16;P=dGc(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;Z=P}etc(Z,517953,H)|0;b[g>>0]=0;_tc(Z+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(517883)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;_=h}else{P=H+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;_=R}etc(_,517883,H)|0;b[g>>0]=0;_tc(_+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 105:{if((b[x>>0]|0)!=120){D=a;break a}H=OGc(w,c,d)|0;if((H|0)==(w|0)){D=a;break a}R=OGc(H,c,d)|0;P=d+4|0;if((R|0)==(H|0)){H=f[P>>2]|0;E=H+-24|0;G=H;while(1){if((G|0)==(E|0)){D=a;break a}H=G+-24|0;f[P>>2]=H;RFc(H);G=f[P>>2]|0}}G=f[P>>2]|0;if(((G-(f[d>>2]|0)|0)/24|0)>>>0<2){D=a;break a}CGc(g,G+-24|0);G=f[P>>2]|0;E=G+-24|0;Q=G;while(1){if((Q|0)==(E|0))break;H=Q+-24|0;f[P>>2]=H;RFc(H);Q=f[P>>2]|0}CGc(h,G+-48|0);QGc(m,517847,h);oGc(m,517956)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];Q=0;while(1){if((Q|0)==3)break;f[m+(Q<<2)>>2]=0;Q=Q+1|0}Q=b[g+11>>0]|0;G=Q<<24>>24<0;UFc(k,G?f[g>>2]|0:g,G?f[g+4>>2]|0:Q&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];Q=0;while(1){if((Q|0)==3)break;f[k+(Q<<2)>>2]=0;Q=Q+1|0}oGc(j,517894)|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];Q=0;while(1){if((Q|0)==3)break;f[j+(Q<<2)>>2]=0;Q=Q+1|0}FGc(i,l);GGc((f[P>>2]|0)+-24|0,i);RFc(i);gGc(l);gGc(j);gGc(k);gGc(m);gGc(h);gGc(g);D=R;break a;break}case 108:{switch(b[x>>0]|0){case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517959)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;$=h}else{G=Q+16&-16;E=dGc(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;$=E}etc($,517959,Q)|0;b[g>>0]=0;_tc($+Q|0,g);Q=TGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517962)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;aa=h}else{E=Q+16&-16;G=dGc(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;aa=G}etc(aa,517962,Q)|0;b[g>>0]=0;_tc(aa+Q|0,g);Q=TGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517965)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;ba=h}else{G=Q+16&-16;E=dGc(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;ba=E}etc(ba,517965,Q)|0;b[g>>0]=0;_tc(ba+Q|0,g);Q=TGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517881)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;ca=h}else{E=Q+16&-16;G=dGc(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ca=G}etc(ca,517881,Q)|0;b[g>>0]=0;_tc(ca+Q|0,g);Q=TGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}default:{D=a;break a}}break}case 109:{switch(b[x>>0]|0){case 105:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517969)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;da=h}else{G=Q+16&-16;E=dGc(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;da=E}etc(da,517969,Q)|0;b[g>>0]=0;_tc(da+Q|0,g);Q=TGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 73:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517971)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;ea=h}else{E=Q+16&-16;G=dGc(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ea=G}etc(ea,517971,Q)|0;b[g>>0]=0;_tc(ea+Q|0,g);Q=TGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517865)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;fa=h}else{G=Q+16&-16;E=dGc(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;fa=E}etc(fa,517865,Q)|0;b[g>>0]=0;_tc(fa+Q|0,g);Q=TGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 76:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517974)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;ga=h}else{E=Q+16&-16;G=dGc(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ga=G}etc(ga,517974,Q)|0;b[g>>0]=0;_tc(ga+Q|0,g);Q=TGc(w,c,h,d)|0;gGc(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 109:{if(B?(b[w>>0]|0)==95:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=Ztc(517977)|0;if(Q>>>0>4294967279)dEc(h);if(Q>>>0<11){b[h+11>>0]=Q;ha=h}else{G=Q+16&-16;E=dGc(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;ha=E}etc(ha,517977,Q)|0;b[g>>0]=0;_tc(ha+Q|0,g);Q=UGc(A,c,h,d)|0;gGc(h);D=(Q|0)==(A|0)?a:Q;break a}Q=OGc(w,c,d)|0;if((Q|0)==(w|0)){D=a;break a}E=d+4|0;G=f[E>>2]|0;if((f[d>>2]|0)==(G|0)){D=a;break a}CGc(i,G+-24|0);nGc(i,0,517847)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];G=0;while(1){if((G|0)==3)break;f[i+(G<<2)>>2]=0;G=G+1|0}oGc(h,517980)|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[n+8>>2]=f[h+8>>2];G=0;while(1){if((G|0)==3)break;f[h+(G<<2)>>2]=0;G=G+1|0}FGc(g,n);GGc((f[E>>2]|0)+-24|0,g);RFc(g);gGc(n);gGc(h);gGc(i);D=Q;break a;break}default:{D=a;break a}}break}case 110:{switch(b[x>>0]|0){case 119:case 97:{D=cHc(a,c,d)|0;break a;break}case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(517984)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;ia=h}else{R=G+16&-16;P=dGc(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ia=P}etc(ia,517984,G)|0;b[g>>0]=0;_tc(ia+G|0,g);G=TGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}case 103:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(517969)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;ja=h}else{P=G+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;ja=R}etc(ja,517969,G)|0;b[g>>0]=0;_tc(ja+G|0,g);G=UGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(517987)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;ka=h}else{R=G+16&-16;P=dGc(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ka=P}etc(ka,517987,G)|0;b[g>>0]=0;_tc(ka+G|0,g);G=UGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}case 120:{G=dHc(w,c,d)|0;D=(G|0)==(w|0)?a:G;break a;break}default:{D=a;break a}}break}case 111:{switch(b[x>>0]|0){case 110:{D=$Gc(a,c,d)|0;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(517989)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;la=h}else{P=G+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;la=R}etc(la,517989,G)|0;b[g>>0]=0;_tc(la+G|0,g);G=TGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}case 114:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(517992)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;ma=h}else{R=G+16&-16;P=dGc(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ma=P}etc(ma,517992,G)|0;b[g>>0]=0;_tc(ma+G|0,g);G=TGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}case 82:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(517994)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;na=h}else{P=G+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;na=R}etc(na,517994,G)|0;b[g>>0]=0;_tc(na+G|0,g);G=TGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}default:{D=a;break a}}break}case 112:{switch(b[x>>0]|0){case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(517997)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;oa=h}else{R=G+16&-16;P=dGc(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;oa=P}etc(oa,517997,G)|0;b[g>>0]=0;_tc(oa+G|0,g);G=TGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(518001)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;pa=h}else{P=G+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;pa=R}etc(pa,518001,G)|0;b[g>>0]=0;_tc(pa+G|0,g);G=TGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}case 76:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(518003)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;qa=h}else{R=G+16&-16;P=dGc(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;qa=P}etc(qa,518003,G)|0;b[g>>0]=0;_tc(qa+G|0,g);G=TGc(w,c,h,d)|0;gGc(h);D=(G|0)==(w|0)?a:G;break a;break}case 112:{if(B?(b[w>>0]|0)==95:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=Ztc(518006)|0;if(G>>>0>4294967279)dEc(h);if(G>>>0<11){b[h+11>>0]=G;ra=h}else{P=G+16&-16;R=dGc(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;ra=R}etc(ra,518006,G)|0;b[g>>0]=0;_tc(ra+G|0,g);G=UGc(A,c,h,d)|0;gGc(h);D=(G|0)==(A|0)?a:G;break a}G=OGc(w,c,d)|0;if((G|0)==(w|0)){D=a;break a}R=d+4|0;P=f[R>>2]|0;if((f[d>>2]|0)==(P|0)){D=a;break a}CGc(i,P+-24|0);nGc(i,0,517847)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];P=0;while(1){if((P|0)==3)break;f[i+(P<<2)>>2]=0;P=P+1|0}oGc(h,518009)|0;f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];P=0;while(1){if((P|0)==3)break;f[h+(P<<2)>>2]=0;P=P+1|0}FGc(g,o);GGc((f[R>>2]|0)+-24|0,g);RFc(g);gGc(o);gGc(h);gGc(i);D=G;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;P=Ztc(518001)|0;if(P>>>0>4294967279)dEc(h);if(P>>>0<11){b[h+11>>0]=P;sa=h}else{Q=P+16&-16;E=dGc(Q)|0;f[h>>2]=E;f[h+8>>2]=Q|-2147483648;f[h+4>>2]=P;sa=E}etc(sa,518001,P)|0;b[g>>0]=0;_tc(sa+P|0,g);P=UGc(w,c,h,d)|0;gGc(h);D=(P|0)==(w|0)?a:P;break a;break}case 116:{D=eHc(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 113:{if((b[x>>0]|0)!=117){D=a;break a}P=OGc(w,c,d)|0;if((P|0)==(w|0)){D=a;break a}E=OGc(P,c,d)|0;if((E|0)==(P|0)){P=d+4|0;Q=f[P>>2]|0;H=Q+-24|0;ta=Q;while(1){if((ta|0)==(H|0)){D=a;break a}Q=ta+-24|0;f[P>>2]=Q;RFc(Q);ta=f[P>>2]|0}}P=OGc(E,c,d)|0;ta=d+4|0;if((P|0)==(E|0)){H=f[ta>>2]|0;G=H+-24|0;R=H;while(1){if((R|0)==(G|0))break;Q=R+-24|0;f[ta>>2]=Q;RFc(Q);R=f[ta>>2]|0}R=H+-48|0;E=G;while(1){if((E|0)==(R|0)){D=a;break a}Q=E+-24|0;f[ta>>2]=Q;RFc(Q);E=f[ta>>2]|0}}E=f[ta>>2]|0;if(((E-(f[d>>2]|0)|0)/24|0)>>>0<3){D=a;break a}CGc(g,E+-24|0);E=f[ta>>2]|0;R=E+-24|0;G=E;while(1){if((G|0)==(R|0))break;H=G+-24|0;f[ta>>2]=H;RFc(H);G=f[ta>>2]|0}CGc(h,E+-48|0);G=f[ta>>2]|0;R=G+-24|0;H=G;while(1){if((H|0)==(R|0))break;Q=H+-24|0;f[ta>>2]=Q;RFc(Q);H=f[ta>>2]|0}CGc(i,G+-48|0);QGc(s,517847,i);oGc(s,518013)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];H=0;while(1){if((H|0)==3)break;f[s+(H<<2)>>2]=0;H=H+1|0}H=b[h+11>>0]|0;G=H<<24>>24<0;UFc(r,G?f[h>>2]|0:h,G?f[h+4>>2]|0:H&255)|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];H=0;while(1){if((H|0)==3)break;f[r+(H<<2)>>2]=0;H=H+1|0}oGc(q,518019)|0;f[m>>2]=f[q>>2];f[m+4>>2]=f[q+4>>2];f[m+8>>2]=f[q+8>>2];H=0;while(1){if((H|0)==3)break;f[q+(H<<2)>>2]=0;H=H+1|0}H=b[g+11>>0]|0;G=H<<24>>24<0;UFc(m,G?f[g>>2]|0:g,G?f[g+4>>2]|0:H&255)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];H=0;while(1){if((H|0)==3)break;f[m+(H<<2)>>2]=0;H=H+1|0}oGc(k,517845)|0;f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];f[p+8>>2]=f[k+8>>2];H=0;while(1){if((H|0)==3)break;f[k+(H<<2)>>2]=0;H=H+1|0}FGc(j,p);GGc((f[ta>>2]|0)+-24|0,j);RFc(j);gGc(p);gGc(k);gGc(m);gGc(q);gGc(r);gGc(s);gGc(i);gGc(h);gGc(g);D=P;break a;break}case 114:{switch(b[x>>0]|0){case 99:{D=fHc(a,c,d)|0;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(518025)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;ua=h}else{G=H+16&-16;R=dGc(G)|0;f[h>>2]=R;f[h+8>>2]=G|-2147483648;f[h+4>>2]=H;ua=R}etc(ua,518025,H)|0;b[g>>0]=0;_tc(ua+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}case 77:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(518027)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;va=h}else{R=H+16&-16;G=dGc(R)|0;f[h>>2]=G;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;va=G}etc(va,518027,H)|0;b[g>>0]=0;_tc(va+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(518030)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;wa=h}else{G=H+16&-16;R=dGc(G)|0;f[h>>2]=R;f[h+8>>2]=G|-2147483648;f[h+4>>2]=H;wa=R}etc(wa,518030,H)|0;b[g>>0]=0;_tc(wa+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=Ztc(518033)|0;if(H>>>0>4294967279)dEc(h);if(H>>>0<11){b[h+11>>0]=H;xa=h}else{R=H+16&-16;G=dGc(R)|0;f[h>>2]=G;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;xa=G}etc(xa,518033,H)|0;b[g>>0]=0;_tc(xa+H|0,g);H=TGc(w,c,h,d)|0;gGc(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 115:{switch(b[x>>0]|0){case 99:{D=gHc(a,c,d)|0;break a;break}case 112:{D=hHc(a,c,d)|0;break a;break}case 114:{D=$Gc(a,c,d)|0;break a;break}case 116:{D=iHc(a,c,d)|0;break a;break}case 122:{D=jHc(a,c,d)|0;break a;break}case 90:{if((t-y|0)<=2){D=a;break a}switch(b[C>>0]|0){case 84:{D=kHc(a,c,d)|0;break a;break}case 102:{D=lHc(a,c,d)|0;break a;break}default:{D=a;break a}}break}default:{D=a;break a}}break}case 116:{switch(b[x>>0]|0){case 105:case 101:{D=mHc(a,c,d)|0;break a;break}case 114:{nHc(g,518037);H=d+4|0;G=f[H>>2]|0;if(G>>>0<(f[d+8>>2]|0)>>>0){HGc(G,g);f[H>>2]=(f[H>>2]|0)+24}else IGc(d,g);RFc(g);D=w;break a;break}case 119:{D=oHc(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{D=$Gc(a,c,d)|0;break a;break}default:{D=a;break a}}while(0)}else D=a;while(0);u=e;return D|0}function PGc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+11|0;d=b[c>>0]|0;if(d<<24>>24<0){e=f[a+4>>2]|0;g=(f[a+8>>2]&2147483647)+-1|0}else{e=d&255;g=10}h=e>>>0<11;i=h?10:(e+16&-16)+-1|0;a:do if((i|0)!=(g|0)){do if(h){j=f[a>>2]|0;if(d<<24>>24<0){k=0;l=j;m=a;n=12}else{etc(a,j,(d&255)+1|0)|0;eGc(j);n=14}}else{j=dGc(i+1|0)|0;if(i>>>0<=g>>>0&(j|0)==0)break a;o=b[c>>0]|0;if(o<<24>>24<0){k=1;l=f[a>>2]|0;m=j;n=12;break}else{etc(j,a,(o&255)+1|0)|0;p=j;n=13;break}}while(0);if((n|0)==12){etc(m,l,(f[a+4>>2]|0)+1|0)|0;eGc(l);if(k){p=m;n=13}else n=14}if((n|0)==13){f[a+8>>2]=i+1|-2147483648;f[a+4>>2]=e;f[a>>2]=p;break}else if((n|0)==14){b[c>>0]=e;break}}while(0);return}function QGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=0;while(1){if((h|0)==3)break;f[a+(h<<2)>>2]=0;h=h+1|0}h=Ztc(c)|0;i=d+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+h|0;if(j>>>0>4294967279)dEc(a);if(j>>>0<11){b[a+11>>0]=h;l=a}else{m=j+16&-16;j=dGc(m)|0;f[a>>2]=j;f[a+8>>2]=m|-2147483648;f[a+4>>2]=h;l=j}etc(l,c,h)|0;b[g>>0]=0;_tc(l+h|0,g);UFc(a,(b[i>>0]|0)<0?f[d>>2]|0:d,k)|0;u=e;return}function RGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+112|0;g=e+88|0;h=e+48|0;i=e+72|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;a:do if((c-a|0)>3?(b[a>>0]|0)==76:0){n=a+1|0;o=a+3|0;p=a+2|0;do switch(b[n>>0]|0){case 84:{q=a;break a;break}case 119:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519039)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;s=h}else{t=r+16&-16;v=dGc(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;s=v}etc(s,519039,r)|0;b[g>>0]=0;_tc(s+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 98:{if((b[o>>0]|0)!=69){q=a;break a}r=a+4|0;switch(b[p>>0]|0){case 48:{nHc(g,519047);v=d+4|0;t=f[v>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){HGc(t,g);f[v>>2]=(f[v>>2]|0)+24}else IGc(d,g);RFc(g);q=r;break a;break}case 49:{WHc(g,519053);v=d+4|0;t=f[v>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){HGc(t,g);f[v>>2]=(f[v>>2]|0)+24}else IGc(d,g);RFc(g);q=r;break a;break}default:{q=a;break a}}break}case 99:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519058)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;w=h}else{v=r+16&-16;t=dGc(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;w=t}etc(w,519058,r)|0;b[g>>0]=0;_tc(w+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 97:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519063)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;x=h}else{t=r+16&-16;v=dGc(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;x=v}etc(x,519063,r)|0;b[g>>0]=0;_tc(x+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 104:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519075)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;y=h}else{v=r+16&-16;t=dGc(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;y=t}etc(y,519075,r)|0;b[g>>0]=0;_tc(y+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519089)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;z=h}else{t=r+16&-16;v=dGc(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;z=v}etc(z,519089,r)|0;b[g>>0]=0;_tc(z+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519095)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;A=h}else{v=r+16&-16;t=dGc(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;A=t}etc(A,519095,r)|0;b[g>>0]=0;_tc(A+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 105:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(1154740)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;B=h}else{t=r+16&-16;v=dGc(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;B=v}etc(B,1154740,r)|0;b[g>>0]=0;_tc(B+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 106:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519110)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;C=h}else{v=r+16&-16;t=dGc(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;C=t}etc(C,519110,r)|0;b[g>>0]=0;_tc(C+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519112)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;D=h}else{t=r+16&-16;v=dGc(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;D=v}etc(D,519112,r)|0;b[g>>0]=0;_tc(D+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519114)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;E=h}else{v=r+16&-16;t=dGc(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;E=t}etc(E,519114,r)|0;b[g>>0]=0;_tc(E+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 120:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519117)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;F=h}else{t=r+16&-16;v=dGc(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;F=v}etc(F,519117,r)|0;b[g>>0]=0;_tc(F+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 121:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519120)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;G=h}else{v=r+16&-16;t=dGc(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;G=t}etc(G,519120,r)|0;b[g>>0]=0;_tc(G+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 110:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519124)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;H=h}else{t=r+16&-16;v=dGc(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;H=v}etc(H,519124,r)|0;b[g>>0]=0;_tc(H+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Ztc(519133)|0;if(r>>>0>4294967279)dEc(h);if(r>>>0<11){b[h+11>>0]=r;I=h}else{v=r+16&-16;t=dGc(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;I=t}etc(I,519133,r)|0;b[g>>0]=0;_tc(I+r|0,g);r=VHc(p,c,h,d)|0;gGc(h);q=(r|0)==(p|0)?a:r;break a;break}case 102:{r=XHc(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 100:{r=YHc(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 101:{r=ZHc(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 95:{if((b[p>>0]|0)!=90){q=a;break a}r=hGc(o,c,d)|0;if((r|0)==(o|0)|(r|0)==(c|0)){q=a;break a}q=(b[r>>0]|0)==69?r+1|0:a;break a;break}default:{r=kGc(n,c,d)|0;if((r|0)==(n|0)|(r|0)==(c|0)){q=a;break a}if((b[r>>0]|0)==69){q=r+1|0;break a}else J=r;while(1){K=J+1|0;if((J|0)==(c|0)){q=a;break a}L=b[J>>0]|0;if(((L<<24>>24)+-48|0)>>>0<10)J=K;else break}if(!((J|0)!=(r|0)&L<<24>>24==69)){q=a;break a}t=d+4|0;v=f[t>>2]|0;if((f[d>>2]|0)==(v|0)){q=a;break a}CGc(l,v+-24|0);nGc(l,0,517847)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];v=0;while(1){if((v|0)==3)break;f[l+(v<<2)>>2]=0;v=v+1|0}oGc(k,517845)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];v=0;while(1){if((v|0)==3)break;f[k+(v<<2)>>2]=0;v=v+1|0}f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;v=J-r|0;if(v>>>0>4294967279)dEc(m);if(v>>>0<11){b[m+11>>0]=v;M=m}else{N=v+16&-16;O=dGc(N)|0;f[m>>2]=O;f[m+8>>2]=N|-2147483648;f[m+4>>2]=v;M=O}O=r;N=M;while(1){if((O|0)==(J|0))break;_tc(N,O);O=O+1|0;N=N+1|0}b[g>>0]=0;_tc(M+v|0,g);N=b[m+11>>0]|0;O=N<<24>>24<0;UFc(j,O?f[m>>2]|0:m,O?f[m+4>>2]|0:N&255)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];N=0;while(1){if((N|0)==3)break;f[j+(N<<2)>>2]=0;N=N+1|0}FGc(h,i);GGc((f[t>>2]|0)+-24|0,h);RFc(h);gGc(i);gGc(m);gGc(j);gGc(k);gGc(l);q=K;break a}}while(0)}else q=a;while(0);u=e;return q|0}function SGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+80|0;g=e+64|0;h=e+60|0;i=e+24|0;j=e+48|0;k=e+12|0;l=e;a:do if((c-a|0)>2?(b[a>>0]|0)==102:0){m=a+2|0;switch(b[a+1>>0]|0){case 112:{n=lGc(m,c,h)|0;o=NGc(n,c)|0;if((o|0)!=(c|0)?(b[o>>0]|0)==95:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=o-n|0;if(p>>>0>4294967279)dEc(k);if(p>>>0<11){b[k+11>>0]=p;q=k}else{r=p+16&-16;s=dGc(r)|0;f[k>>2]=s;f[k+8>>2]=r|-2147483648;f[k+4>>2]=p;q=s}s=n;n=q;while(1){if((s|0)==(o|0))break;_tc(n,s);s=s+1|0;n=n+1|0}b[g>>0]=0;_tc(q+p|0,g);nGc(k,0,519036)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];n=0;while(1){if((n|0)==3)break;f[k+(n<<2)>>2]=0;n=n+1|0}FGc(i,j);n=d+4|0;p=f[n>>2]|0;if(p>>>0<(f[d+8>>2]|0)>>>0){HGc(p,i);f[n>>2]=(f[n>>2]|0)+24}else IGc(d,i);RFc(i);gGc(j);gGc(k);t=o+1|0}else t=a;v=t;break a;break}case 76:break;default:{v=a;break a}}n=NGc(m,c)|0;if((((n|0)!=(c|0)?(b[n>>0]|0)==112:0)?(p=lGc(n+1|0,c,h)|0,n=NGc(p,c)|0,(n|0)!=(c|0)):0)?(b[n>>0]|0)==95:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=n-p|0;if(s>>>0>4294967279)dEc(k);if(s>>>0<11){b[k+11>>0]=s;w=k}else{r=s+16&-16;x=dGc(r)|0;f[k>>2]=x;f[k+8>>2]=r|-2147483648;f[k+4>>2]=s;w=x}x=p;p=w;while(1){if((x|0)==(n|0))break;_tc(p,x);x=x+1|0;p=p+1|0}b[g>>0]=0;_tc(w+s|0,g);nGc(k,0,519036)|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];p=0;while(1){if((p|0)==3)break;f[k+(p<<2)>>2]=0;p=p+1|0}FGc(i,l);p=d+4|0;s=f[p>>2]|0;if(s>>>0<(f[d+8>>2]|0)>>>0){HGc(s,i);f[p>>2]=(f[p>>2]|0)+24}else IGc(d,i);RFc(i);gGc(l);gGc(k);y=n+1|0}else y=a;v=y}else v=a;while(0);u=e;return v|0}function TGc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+96|0;h=g+84|0;i=g+72|0;j=g+60|0;k=g+48|0;l=g+36|0;m=g+24|0;n=g+12|0;o=g;p=OGc(a,c,e)|0;a:do if((p|0)!=(a|0)){q=OGc(p,c,e)|0;r=e+4|0;if((q|0)==(p|0)){s=f[r>>2]|0;t=s+-24|0;v=s;while(1){if((v|0)==(t|0)){w=a;break a}s=v+-24|0;f[r>>2]=s;RFc(s);v=f[r>>2]|0}}v=f[r>>2]|0;if(((v-(f[e>>2]|0)|0)/24|0)>>>0>=2){CGc(i,v+-24|0);v=f[r>>2]|0;t=v+-24|0;s=v;while(1){if((s|0)==(t|0))break;x=s+-24|0;f[r>>2]=x;RFc(x);s=f[r>>2]|0}CGc(j,v+-48|0);s=f[r>>2]|0;t=s+-24|0;x=t+11|0;if((b[x>>0]|0)<0){y=f[t>>2]|0;b[h>>0]=0;_tc(y,h);f[s+-20>>2]=0}else{b[h>>0]=0;_tc(t,h);b[x>>0]=0}x=Ztc(517883)|0;s=d+11|0;y=b[s>>0]|0;z=d+4|0;if((x|0)==((y<<24>>24<0?f[z>>2]|0:y&255)|0)?(yGc(d,517883,x)|0)==0:0)HHc(t,40);QGc(o,517847,j);oGc(o,518133)|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];x=0;while(1){if((x|0)==3)break;f[o+(x<<2)>>2]=0;x=x+1|0}x=b[s>>0]|0;r=x<<24>>24<0;UFc(n,r?f[d>>2]|0:d,r?f[z>>2]|0:x&255)|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];x=0;while(1){if((x|0)==3)break;f[n+(x<<2)>>2]=0;x=x+1|0}oGc(m,517842)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];x=0;while(1){if((x|0)==3)break;f[m+(x<<2)>>2]=0;x=x+1|0}x=b[i+11>>0]|0;r=x<<24>>24<0;UFc(l,r?f[i>>2]|0:i,r?f[i+4>>2]|0:x&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];x=0;while(1){if((x|0)==3)break;f[l+(x<<2)>>2]=0;x=x+1|0}oGc(k,517845)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];x=0;while(1){if((x|0)==3)break;f[k+(x<<2)>>2]=0;x=x+1|0}x=b[h+11>>0]|0;r=x<<24>>24<0;UFc(t,r?f[h>>2]|0:h,r?f[h+4>>2]|0:x&255)|0;gGc(h);gGc(k);gGc(l);gGc(m);gGc(n);gGc(o);x=Ztc(517883)|0;r=b[s>>0]|0;if((x|0)==((r<<24>>24<0?f[z>>2]|0:r&255)|0)?(yGc(d,517883,x)|0)==0:0)HHc(t,41);gGc(j);gGc(i);w=q}else w=a}else w=a;while(0);u=g;return w|0}function UGc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+64|0;h=g+48|0;i=g+36|0;j=g+24|0;k=g+12|0;l=g;m=OGc(a,c,e)|0;if((m|0)!=(a|0)?(c=e+4|0,(f[e>>2]|0)!=(f[c>>2]|0)):0){EGc(k,d,517847);CGc(l,(f[c>>2]|0)+-24|0);d=b[l+11>>0]|0;e=d<<24>>24<0;UFc(k,e?f[l>>2]|0:l,e?f[l+4>>2]|0:d&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];d=0;while(1){if((d|0)==3)break;f[k+(d<<2)>>2]=0;d=d+1|0}oGc(j,517845)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];d=0;while(1){if((d|0)==3)break;f[j+(d<<2)>>2]=0;d=d+1|0}d=f[c>>2]|0;c=d+-24|0;e=c+11|0;if((b[e>>0]|0)<0){n=f[c>>2]|0;b[h>>0]=0;_tc(n,h);f[d+-20>>2]=0}else{b[h>>0]=0;_tc(c,h);b[e>>0]=0}PGc(c);f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}gGc(i);gGc(j);gGc(l);gGc(k);o=m}else o=a;u=g;return o|0}function VGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==97:0)?(b[a+1>>0]|0)==116:0)?(k=a+2|0,l=kGc(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){CGc(j,c+-24|0);nGc(j,0,519026)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}c=f[k>>2]|0;k=c+-24|0;d=k+11|0;if((b[d>>0]|0)<0){m=f[k>>2]|0;b[g>>0]=0;_tc(m,g);f[c+-20>>2]=0}else{b[g>>0]=0;_tc(k,g);b[d>>0]=0}PGc(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}gGc(h);gGc(i);gGc(j);n=l}else n=a;u=e;return n|0}function WGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==97:0)?(b[a+1>>0]|0)==122:0)?(k=a+2|0,l=OGc(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){CGc(j,c+-24|0);nGc(j,0,519026)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}c=f[k>>2]|0;k=c+-24|0;d=k+11|0;if((b[d>>0]|0)<0){m=f[k>>2]|0;b[g>>0]=0;_tc(m,g);f[c+-20>>2]=0}else{b[g>>0]=0;_tc(k,g);b[d>>0]=0}PGc(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}gGc(h);gGc(i);gGc(j);n=l}else n=a;u=e;return n|0}function XGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=kGc(n,c,d)|0,(o|0)!=(n|0)):0)?(n=OGc(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){CGc(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;RFc(q);p=f[o>>2]|0}CGc(m,c+-48|0);nGc(m,0,519014)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}oGc(l,518094)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;UFc(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}oGc(j,517845)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}FGc(h,i);GGc((f[o>>2]|0)+-24|0,h);RFc(h);gGc(i);gGc(j);gGc(k);gGc(l);gGc(m);gGc(g);r=n}else r=a;u=e;return r|0}function YGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+12|0;h=e;a:do if(((((c-a|0)>3?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==108:0)?(i=a+2|0,j=OGc(i,c,d)|0,!((j|0)==(i|0)|(j|0)==(c|0))):0)?(i=d+4|0,k=f[i>>2]|0,(f[d>>2]|0)!=(k|0)):0){l=k+-12|0;m=b[l+11>>0]|0;n=m<<24>>24<0;UFc(k+-24|0,n?f[l>>2]|0:l,n?f[k+-8>>2]|0:m&255)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}m=f[i>>2]|0;k=m+-12|0;n=k+11|0;if((b[n>>0]|0)<0){l=f[k>>2]|0;b[g>>0]=0;_tc(l,g);f[m+-8>>2]=0}else{b[g>>0]=0;_tc(k,g);b[n>>0]=0}PGc(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}gGc(h);oGc((f[i>>2]|0)+-24|0,517847)|0;k=g+11|0;n=g+4|0;m=j;while(1){if((b[m>>0]|0)==69)break;l=OGc(m,c,d)|0;if((l|0)==(m|0)|(l|0)==(c|0)){o=a;break a}p=f[i>>2]|0;if((f[d>>2]|0)==(p|0)){o=a;break a}CGc(g,p+-24|0);p=f[i>>2]|0;q=p+-24|0;r=p;while(1){if((r|0)==(q|0))break;s=r+-24|0;f[i>>2]=s;RFc(s);r=f[i>>2]|0}r=b[k>>0]|0;s=r<<24>>24<0;t=s?f[n>>2]|0:r&255;if(t|0){if((f[d>>2]|0)==(q|0)){v=26;break}UFc(p+-48|0,s?f[g>>2]|0:g,t)|0}gGc(g);m=l}if((v|0)==26){gGc(g);o=a;break}n=f[i>>2]|0;if((f[d>>2]|0)!=(n|0)){oGc(n+-24|0,517845)|0;o=m+1|0}else o=a}else o=a;while(0);u=e;return o|0}function ZGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;a:do if((((c-a|0)>2?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==118:0)?(n=d+63|0,o=b[n>>0]|0,b[n>>0]=0,p=a+2|0,q=kGc(p,c,d)|0,b[n>>0]=o,!((q|0)==(p|0)|(q|0)==(c|0))):0){if((b[q>>0]|0)!=95){p=OGc(q,c,d)|0;if((p|0)==(q|0)){r=a;break}else s=p}else{p=q+1|0;if((p|0)==(c|0)){r=a;break}q=b[p>>0]|0;b:do if(q<<24>>24==69){o=d+4|0;n=f[o>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;NHc(n);f[o>>2]=(f[o>>2]|0)+24;t=p;break}else{OHc(d);t=p;break}}else{o=p;n=q;while(1){if(n<<24>>24==69){t=o;break b}v=OGc(o,c,d)|0;w=(v|0)==(o|0)|(v|0)==(c|0);if(w){r=a;break a}x=b[(w?o:v)>>0]|0;o=v;n=x}}while(0);s=t+1|0}q=d+4|0;p=f[q>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0>=2){CGc(g,p+-24|0);p=f[q>>2]|0;n=p+-24|0;o=p;while(1){if((o|0)==(n|0))break;x=o+-24|0;f[q>>2]=x;RFc(x);o=f[q>>2]|0}CGc(m,p+-48|0);nGc(m,0,517847)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];o=0;while(1){if((o|0)==3)break;f[m+(o<<2)>>2]=0;o=o+1|0}oGc(l,519011)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];o=0;while(1){if((o|0)==3)break;f[l+(o<<2)>>2]=0;o=o+1|0}o=b[g+11>>0]|0;p=o<<24>>24<0;UFc(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:o&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];o=0;while(1){if((o|0)==3)break;f[k+(o<<2)>>2]=0;o=o+1|0}oGc(j,517845)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];o=0;while(1){if((o|0)==3)break;f[j+(o<<2)>>2]=0;o=o+1|0}FGc(h,i);GGc((f[q>>2]|0)+-24|0,h);RFc(h);gGc(i);gGc(j);gGc(k);gGc(l);gGc(m);gGc(g);r=s}else r=a}else r=a;while(0);u=e;return r|0}function _Gc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=kGc(n,c,d)|0,(o|0)!=(n|0)):0)?(n=OGc(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){CGc(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;RFc(q);p=f[o>>2]|0}CGc(m,c+-48|0);nGc(m,0,518997)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}oGc(l,518094)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;UFc(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}oGc(j,517845)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}FGc(h,i);GGc((f[o>>2]|0)+-24|0,h);RFc(h);gGc(i);gGc(j);gGc(k);gGc(l);gGc(m);gGc(g);r=n}else r=a;u=e;return r|0}function $Gc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+32|0;g=e+12|0;h=e;i=c;a:do if((i-a|0)>2){if((b[a>>0]|0)==103){j=(b[a+1>>0]|0)==115;k=j;l=j?a+2|0:a}else{k=0;l=a}j=rHc(l,c,d)|0;if((j|0)!=(l|0)){if(!k){m=j;break}n=f[d+4>>2]|0;if((f[d>>2]|0)==(n|0)){m=a;break}nGc(n+-24|0,0,517919)|0;m=j;break}if(((i-l|0)>2?(b[l>>0]|0)==115:0)?(b[l+1>>0]|0)==114:0){j=l+2|0;if((b[j>>0]|0)==78){n=l+3|0;o=sHc(n,c,d)|0;if((o|0)==(n|0)|(o|0)==(c|0)){m=a;break}n=BGc(o,c,d)|0;p=d+4|0;do if((n|0)==(o|0)){q=o;r=d}else{s=f[p>>2]|0;if(((s-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break a}CGc(g,s+-24|0);s=f[p>>2]|0;t=s+-24|0;v=s;while(1){if((v|0)==(t|0))break;w=v+-24|0;f[p>>2]=w;RFc(w);v=f[p>>2]|0}v=b[g+11>>0]|0;t=v<<24>>24<0;UFc(s+-48|0,t?f[g>>2]|0:g,t?f[g+4>>2]|0:v&255)|0;if((n|0)!=(c|0)){gGc(g);q=n;r=d;break}v=f[p>>2]|0;t=v+-24|0;w=v;while(1){if((w|0)==(t|0))break;v=w+-24|0;f[p>>2]=v;RFc(v);w=f[p>>2]|0}gGc(g);m=a;break a}while(0);n=h+11|0;o=h+4|0;w=q;while(1){if((b[w>>0]|0)==69)break;t=tHc(w,c,d)|0;if((t|0)==(w|0)|(t|0)==(c|0)){m=a;break a}s=f[p>>2]|0;if(((s-(f[r>>2]|0)|0)/24|0)>>>0<2){m=a;break a}CGc(g,s+-24|0);s=f[p>>2]|0;v=s+-24|0;x=s;while(1){if((x|0)==(v|0))break;s=x+-24|0;f[p>>2]=s;RFc(s);x=f[p>>2]|0}nGc(g,0,517919)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];x=0;while(1){if((x|0)==3)break;f[g+(x<<2)>>2]=0;x=x+1|0}x=b[n>>0]|0;v=x<<24>>24<0;UFc((f[p>>2]|0)+-24|0,v?f[h>>2]|0:h,v?f[o>>2]|0:x&255)|0;gGc(h);gGc(g);w=t}o=w+1|0;n=rHc(o,c,d)|0;if((n|0)==(o|0)){o=f[p>>2]|0;if((f[d>>2]|0)==(o|0)){m=a;break}x=o+-24|0;v=o;while(1){if((v|0)==(x|0)){m=a;break a}o=v+-24|0;f[p>>2]=o;RFc(o);v=f[p>>2]|0}}v=f[p>>2]|0;if(((v-(f[r>>2]|0)|0)/24|0)>>>0<2){m=a;break}CGc(g,v+-24|0);v=f[p>>2]|0;x=v+-24|0;w=v;while(1){if((w|0)==(x|0))break;v=w+-24|0;f[p>>2]=v;RFc(v);w=f[p>>2]|0}nGc(g,0,517919)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];w=0;while(1){if((w|0)==3)break;f[g+(w<<2)>>2]=0;w=w+1|0}w=b[h+11>>0]|0;x=w<<24>>24<0;UFc((f[p>>2]|0)+-24|0,x?f[h>>2]|0:h,x?f[h+4>>2]|0:w&255)|0;gGc(h);gGc(g);m=n;break}w=sHc(j,c,d)|0;if((w|0)!=(j|0)){x=BGc(w,c,d)|0;if((x|0)==(w|0))y=w;else{w=d+4|0;v=f[w>>2]|0;if(((v-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break}CGc(g,v+-24|0);v=f[w>>2]|0;o=v+-24|0;s=v;while(1){if((s|0)==(o|0))break;z=s+-24|0;f[w>>2]=z;RFc(z);s=f[w>>2]|0}w=b[g+11>>0]|0;s=w<<24>>24<0;UFc(v+-48|0,s?f[g>>2]|0:g,s?f[g+4>>2]|0:w&255)|0;gGc(g);y=x}w=rHc(y,c,d)|0;if((w|0)==(y|0)){s=d+4|0;o=f[s>>2]|0;if((f[d>>2]|0)==(o|0)){m=a;break}n=o+-24|0;p=o;while(1){if((p|0)==(n|0)){m=a;break a}o=p+-24|0;f[s>>2]=o;RFc(o);p=f[s>>2]|0}}s=d+4|0;p=f[s>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break}CGc(g,p+-24|0);p=f[s>>2]|0;n=p+-24|0;x=p;while(1){if((x|0)==(n|0))break;p=x+-24|0;f[s>>2]=p;RFc(p);x=f[s>>2]|0}nGc(g,0,517919)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];x=0;while(1){if((x|0)==3)break;f[g+(x<<2)>>2]=0;x=x+1|0}x=b[h+11>>0]|0;n=x<<24>>24<0;UFc((f[s>>2]|0)+-24|0,n?f[h>>2]|0:h,n?f[h+4>>2]|0:x&255)|0;gGc(h);gGc(g);m=w;break}x=tHc(j,c,d)|0;if(!((x|0)==(j|0)|(x|0)==(c|0))){if(k){n=d+4|0;p=f[n>>2]|0;if((f[d>>2]|0)==(p|0)){m=a;break}nGc(p+-24|0,0,517919)|0;A=n}else A=d+4|0;n=h+11|0;p=h+4|0;v=x;while(1){if((b[v>>0]|0)==69)break;x=tHc(v,c,d)|0;if((x|0)==(v|0)|(x|0)==(c|0)){m=a;break a}o=f[A>>2]|0;if(((o-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break a}CGc(g,o+-24|0);o=f[A>>2]|0;z=o+-24|0;B=o;while(1){if((B|0)==(z|0))break;o=B+-24|0;f[A>>2]=o;RFc(o);B=f[A>>2]|0}nGc(g,0,517919)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];B=0;while(1){if((B|0)==3)break;f[g+(B<<2)>>2]=0;B=B+1|0}B=b[n>>0]|0;z=B<<24>>24<0;UFc((f[A>>2]|0)+-24|0,z?f[h>>2]|0:h,z?f[p>>2]|0:B&255)|0;gGc(h);gGc(g);v=x}p=v+1|0;n=rHc(p,c,d)|0;if((n|0)==(p|0)){p=f[A>>2]|0;if((f[d>>2]|0)==(p|0)){m=a;break}j=p+-24|0;w=p;while(1){if((w|0)==(j|0)){m=a;break a}p=w+-24|0;f[A>>2]=p;RFc(p);w=f[A>>2]|0}}w=f[A>>2]|0;if(((w-(f[d>>2]|0)|0)/24|0)>>>0>=2){CGc(g,w+-24|0);w=f[A>>2]|0;j=w+-24|0;v=w;while(1){if((v|0)==(j|0))break;w=v+-24|0;f[A>>2]=w;RFc(w);v=f[A>>2]|0}nGc(g,0,517919)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];v=0;while(1){if((v|0)==3)break;f[g+(v<<2)>>2]=0;v=v+1|0}v=b[h+11>>0]|0;j=v<<24>>24<0;UFc((f[A>>2]|0)+-24|0,j?f[h>>2]|0:h,j?f[h+4>>2]|0:v&255)|0;gGc(h);gGc(g);m=n}else m=a}else m=a}else m=a}else m=a;while(0);u=e;return m|0}function aHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+12|0;h=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==115:0)?(i=a+2|0,j=OGc(i,c,d)|0,(j|0)!=(i|0)):0)?(i=OGc(j,c,d)|0,(i|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){CGc(g,c+-24|0);c=f[j>>2]|0;d=c+-24|0;k=c;while(1){if((k|0)==(d|0))break;c=k+-24|0;f[j>>2]=c;RFc(c);k=f[j>>2]|0}QGc(h,518138,g);k=b[h+11>>0]|0;d=k<<24>>24<0;UFc((f[j>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:k&255)|0;gGc(h);gGc(g);l=i}else l=a;u=e;return l|0}function bHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+12|0;h=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==116:0)?(i=a+2|0,j=OGc(i,c,d)|0,(j|0)!=(i|0)):0)?(i=$Gc(j,c,d)|0,(i|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){CGc(g,c+-24|0);c=f[j>>2]|0;d=c+-24|0;k=c;while(1){if((k|0)==(d|0))break;c=k+-24|0;f[j>>2]=c;RFc(c);k=f[j>>2]|0}QGc(h,518136,g);k=b[h+11>>0]|0;d=k<<24>>24<0;UFc((f[j>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:k&255)|0;gGc(h);gGc(g);l=i}else l=a;u=e;return l|0}function cHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+112|0;g=e+88|0;h=e+76|0;i=e+64|0;j=e+40|0;k=e+16|0;l=e;m=e+52|0;n=c;a:do if((n-a|0)>3){o=b[a>>0]|0;if(o<<24>>24==103){p=(b[a+1>>0]|0)==115;q=p?a+2|0:a;r=p;s=q;t=b[q>>0]|0}else{r=0;s=a;t=o}if(t<<24>>24==110){o=b[s+1>>0]|0;q=o<<24>>24==97;switch(o<<24>>24){case 97:case 119:break;default:{v=a;break a}}o=s+2|0;b:do if((o|0)!=(c|0)){p=0;w=o;while(1){if((b[w>>0]|0)==95)break;x=OGc(w,c,d)|0;y=(x|0)==(w|0);z=(x|0)==(c|0);if(y|z)break b;else{p=p|(y|z)^1;w=x}}x=w+1|0;z=kGc(x,c,d)|0;if(!((z|0)==(x|0)|(z|0)==(c|0))){x=b[z>>0]|0;c:do if(!((n-z|0)>2&x<<24>>24==112))if(x<<24>>24==69){A=0;B=z}else break b;else{if((b[z+1>>0]|0)!=105)break b;y=z+2|0;while(1){if((b[y>>0]|0)==69){A=1;B=y;break c}C=y;y=OGc(y,c,d)|0;if((y|0)==(C|0)|(y|0)==(c|0))break b}}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=0;while(1){if((z|0)==3)break;f[h+(z<<2)>>2]=0;z=z+1|0}d:do if(A){z=d+4|0;x=f[z>>2]|0;if((f[d>>2]|0)==(x|0)){D=a;E=1}else{CGc(i,x+-24|0);x=h+11|0;if((b[x>>0]|0)<0){w=f[h>>2]|0;b[g>>0]=0;_tc(w,g);f[h+4>>2]=0}else{b[g>>0]=0;_tc(h,g);b[x>>0]=0}PGc(h);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];x=0;while(1){if((x|0)==3)break;f[i+(x<<2)>>2]=0;x=x+1|0}gGc(i);x=f[z>>2]|0;w=x+-24|0;y=x;while(1){if((y|0)==(w|0)){F=z;G=d;H=w;I=31;break d}x=y+-24|0;f[z>>2]=x;RFc(x);y=f[z>>2]|0}}}else{z=d+4|0;F=z;G=d;H=f[z>>2]|0;I=31}while(0);if((I|0)==31)if((f[G>>2]|0)==(H|0)){D=a;E=1}else{CGc(i,H+-24|0);z=f[F>>2]|0;y=z+-24|0;w=z;while(1){if((w|0)==(y|0))break;x=w+-24|0;f[F>>2]=x;RFc(x);w=f[F>>2]|0}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;w=0;while(1){if((w|0)==3)break;f[j+(w<<2)>>2]=0;w=w+1|0}e:do if(p)if((f[G>>2]|0)==(y|0)){J=a;K=1}else{CGc(k,z+-48|0);w=j+11|0;if((b[w>>0]|0)<0){x=f[j>>2]|0;b[g>>0]=0;_tc(x,g);f[j+4>>2]=0}else{b[g>>0]=0;_tc(j,g);b[w>>0]=0}PGc(j);f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];w=0;while(1){if((w|0)==3)break;f[k+(w<<2)>>2]=0;w=w+1|0}gGc(k);w=f[F>>2]|0;x=w+-24|0;C=w;while(1){if((C|0)==(x|0)){I=49;break e}w=C+-24|0;f[F>>2]=w;RFc(w);C=f[F>>2]|0}}else I=49;while(0);if((I|0)==49){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=0;while(1){if((z|0)==3)break;f[g+(z<<2)>>2]=0;z=z+1|0}if(r)pHc(g,517919);if(q)oGc(g,518129)|0;else oGc(g,517879)|0;if(p){QGc(l,517847,j);oGc(l,518133)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];z=0;while(1){if((z|0)==3)break;f[l+(z<<2)>>2]=0;z=z+1|0}z=b[k+11>>0]|0;p=z<<24>>24<0;UFc(g,p?f[k>>2]|0:k,p?f[k+4>>2]|0:z&255)|0;gGc(k);gGc(l)}z=b[i+11>>0]|0;p=z<<24>>24<0;UFc(g,p?f[i>>2]|0:i,p?f[i+4>>2]|0:z&255)|0;if(A){QGc(l,517842,h);oGc(l,517845)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];z=0;while(1){if((z|0)==3)break;f[l+(z<<2)>>2]=0;z=z+1|0}z=b[k+11>>0]|0;p=z<<24>>24<0;UFc(g,p?f[k>>2]|0:k,p?f[k+4>>2]|0:z&255)|0;gGc(k);gGc(l)};f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];z=0;while(1){if((z|0)==3)break;f[g+(z<<2)>>2]=0;z=z+1|0}FGc(k,m);z=f[F>>2]|0;if(z>>>0<(f[d+8>>2]|0)>>>0){HGc(z,k);f[F>>2]=(f[F>>2]|0)+24}else IGc(d,k);RFc(k);gGc(m);gGc(g);J=B+1|0;K=0}gGc(j);gGc(i);D=J;E=K}gGc(h);if(!E){v=D;break a}}}while(0);v=a}else v=a}else v=a;while(0);u=e;return v|0}function dHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;k=OGc(a,c,d)|0;if((k|0)!=(a|0)?(c=d+4|0,l=f[c>>2]|0,(f[d>>2]|0)!=(l|0)):0){CGc(j,l+-24|0);nGc(j,0,518118)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];l=0;while(1){if((l|0)==3)break;f[j+(l<<2)>>2]=0;l=l+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];l=0;while(1){if((l|0)==3)break;f[i+(l<<2)>>2]=0;l=l+1|0}l=f[c>>2]|0;c=l+-24|0;d=c+11|0;if((b[d>>0]|0)<0){m=f[c>>2]|0;b[g>>0]=0;_tc(m,g);f[l+-20>>2]=0}else{b[g>>0]=0;_tc(c,g);b[d>>0]=0}PGc(c);f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];c=0;while(1){if((c|0)==3)break;f[h+(c<<2)>>2]=0;c=c+1|0}gGc(h);gGc(i);gGc(j);n=k}else n=a;u=e;return n|0}function eHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if((((((c-a|0)>2?(b[a>>0]|0)==112:0)?(b[a+1>>0]|0)==116:0)?(h=a+2|0,i=OGc(h,c,d)|0,(i|0)!=(h|0)):0)?(h=OGc(i,c,d)|0,(h|0)!=(i|0)):0)?(i=d+4|0,c=f[i>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){CGc(g,c+-24|0);c=f[i>>2]|0;d=c+-24|0;j=c;while(1){if((j|0)==(d|0))break;k=j+-24|0;f[i>>2]=k;RFc(k);j=f[i>>2]|0}oGc(c+-48|0,518115)|0;c=b[g+11>>0]|0;j=c<<24>>24<0;UFc((f[i>>2]|0)+-24|0,j?f[g>>2]|0:g,j?f[g+4>>2]|0:c&255)|0;gGc(g);l=h}else l=a;u=e;return l|0}function fHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==114:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=kGc(n,c,d)|0,(o|0)!=(n|0)):0)?(n=OGc(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){CGc(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;RFc(q);p=f[o>>2]|0}CGc(m,c+-48|0);nGc(m,0,518097)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}oGc(l,518094)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;UFc(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}oGc(j,517845)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}FGc(h,i);GGc((f[o>>2]|0)+-24|0,h);RFc(h);gGc(i);gGc(j);gGc(k);gGc(l);gGc(m);gGc(g);r=n}else r=a;u=e;return r|0}function gHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=kGc(n,c,d)|0,(o|0)!=(n|0)):0)?(n=OGc(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){CGc(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;RFc(q);p=f[o>>2]|0}CGc(m,c+-48|0);nGc(m,0,518081)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}oGc(l,518094)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;UFc(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}oGc(j,517845)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}FGc(h,i);GGc((f[o>>2]|0)+-24|0,h);RFc(h);gGc(i);gGc(j);gGc(k);gGc(l);gGc(m);gGc(g);r=n}else r=a;u=e;return r|0}function hHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;if(((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==112:0){e=a+2|0;f=OGc(e,c,d)|0;g=(f|0)==(e|0)?a:f}else g=a;return g|0}function iHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==116:0)?(k=a+2|0,l=kGc(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){CGc(j,c+-24|0);nGc(j,0,518072)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}FGc(g,h);GGc((f[k>>2]|0)+-24|0,g);RFc(g);gGc(h);gGc(i);gGc(j);m=l}else m=a;u=e;return m|0}function jHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==122:0)?(k=a+2|0,l=OGc(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){CGc(j,c+-24|0);nGc(j,0,518072)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}FGc(g,h);GGc((f[k>>2]|0)+-24|0,g);RFc(g);gGc(h);gGc(i);gGc(j);m=l}else m=a;u=e;return m|0}function kHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+12|0;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==90:0)?(k=a+2|0,(b[k>>0]|0)==84):0)?(l=d+4|0,m=((f[l>>2]|0)-(f[d>>2]|0)|0)/24|0,n=AGc(k,c,d)|0,c=((f[l>>2]|0)-(f[d>>2]|0)|0)/24|0,(n|0)!=(k|0)):0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=Ztc(518058)|0;if(k>>>0>4294967279)dEc(h);if(k>>>0<11){b[h+11>>0]=k;o=h}else{p=k+16&-16;q=dGc(p)|0;f[h>>2]=q;f[h+8>>2]=p|-2147483648;f[h+4>>2]=k;o=q}etc(o,518058,k)|0;b[g>>0]=0;_tc(o+k|0,g);a:do if((m|0)!=(c|0)){CGc(g,(f[d>>2]|0)+(m*24|0)|0);k=b[g+11>>0]|0;o=k<<24>>24<0;UFc(h,o?f[g>>2]|0:g,o?f[g+4>>2]|0:k&255)|0;gGc(g);k=g+11|0;o=g+4|0;q=m;while(1){p=q+1|0;if((p|0)==(c|0))break a;CGc(i,(f[d>>2]|0)+(p*24|0)|0);nGc(i,0,518069)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];r=0;while(1){if((r|0)==3)break;f[i+(r<<2)>>2]=0;r=r+1|0}r=b[k>>0]|0;s=r<<24>>24<0;UFc(h,s?f[g>>2]|0:g,s?f[o>>2]|0:r&255)|0;gGc(g);gGc(i);q=p}}while(0);oGc(h,517845)|0;i=c;while(1){if((i|0)==(m|0))break;c=f[l>>2]|0;q=c+-24|0;o=c;while(1){if((o|0)==(q|0))break;c=o+-24|0;f[l>>2]=c;RFc(c);o=f[l>>2]|0}i=i+-1|0}f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];i=0;while(1){if((i|0)==3)break;f[h+(i<<2)>>2]=0;i=i+1|0}FGc(g,j);i=f[l>>2]|0;if(i>>>0<(f[d+8>>2]|0)>>>0){HGc(i,g);f[l>>2]=(f[l>>2]|0)+24}else IGc(d,g);RFc(g);gGc(j);gGc(h);t=n}else t=a;u=e;return t|0}function lHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if((((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==90:0)?(k=a+2|0,(b[k>>0]|0)==102):0)?(l=SGc(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){CGc(j,c+-24|0);nGc(j,0,518058)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}FGc(g,h);GGc((f[k>>2]|0)+-24|0,g);RFc(g);gGc(h);gGc(i);gGc(j);m=l}else m=a;u=e;return m|0}function mHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;a:do if((c-a|0)>2?(b[a>>0]|0)==116:0){k=b[a+1>>0]|0;switch(k<<24>>24){case 101:case 105:break;default:{l=a;break a}}m=a+2|0;if(k<<24>>24==101)n=OGc(m,c,d)|0;else n=kGc(m,c,d)|0;if((n|0)!=(m|0)?(m=d+4|0,k=f[m>>2]|0,(f[d>>2]|0)!=(k|0)):0){CGc(j,k+-24|0);nGc(j,0,518050)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];k=0;while(1){if((k|0)==3)break;f[j+(k<<2)>>2]=0;k=k+1|0}oGc(i,517845)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];k=0;while(1){if((k|0)==3)break;f[i+(k<<2)>>2]=0;k=k+1|0}FGc(g,h);GGc((f[m>>2]|0)+-24|0,g);RFc(g);gGc(h);gGc(i);gGc(j);l=n}else l=a}else l=a;while(0);u=e;return l|0}function nHc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=5;etc(a,c,5)|0;b[e>>0]=0;_tc(a+5|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function oHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+12|0;if(((((c-a|0)>2?(b[a>>0]|0)==116:0)?(b[a+1>>0]|0)==119:0)?(j=a+2|0,k=OGc(j,c,d)|0,(k|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,(f[d>>2]|0)!=(c|0)):0){CGc(i,c+-24|0);nGc(i,0,518043)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}FGc(g,h);GGc((f[j>>2]|0)+-24|0,g);RFc(g);gGc(h);gGc(i);l=k}else l=a;u=e;return l|0}function pHc(a,b){a=a|0;b=b|0;qHc(a,b,Ztc(b)|0);return}function qHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=(f[a+8>>2]&2147483647)+-1|0;else k=10;do if(k>>>0>=d>>>0){if(j)l=f[a>>2]|0;else l=a;kEc(l,c,d)|0;b[g>>0]=0;_tc(l+d|0,g);if((b[h>>0]|0)<0){f[a+4>>2]=d;break}else{b[h>>0]=d;break}}else{if(j)m=f[a+4>>2]|0;else m=i&255;cGc(a,k,d-k|0,m,0,m,d,c)}while(0);u=e;return}function rHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e;a:do if((c-a|0)>1){h=b[a>>0]|0;i=h<<24>>24==111;switch(h<<24>>24){case 100:case 111:{if((b[a+1>>0]|0)==110){h=a+2|0;if(!i){i=MHc(h,c,d)|0;j=(i|0)==(h|0)?a:i;break a}i=yHc(h,c,d)|0;if((i|0)==(h|0)){j=a;break a}h=BGc(i,c,d)|0;if((h|0)==(i|0)){j=i;break a}i=d+4|0;k=f[i>>2]|0;if(((k-(f[d>>2]|0)|0)/24|0)>>>0<2){j=h;break a}CGc(g,k+-24|0);k=f[i>>2]|0;l=k+-24|0;m=k;while(1){if((m|0)==(l|0))break;n=m+-24|0;f[i>>2]=n;RFc(n);m=f[i>>2]|0}i=b[g+11>>0]|0;m=i<<24>>24<0;UFc(k+-48|0,m?f[g>>2]|0:g,m?f[g+4>>2]|0:i&255)|0;gGc(g);j=h;break a}break}default:{}}i=uHc(a,c,d)|0;if((i|0)==(a|0)){m=yHc(a,c,d)|0;if((m|0)!=(a|0)){l=BGc(m,c,d)|0;if((l|0)!=(m|0)){n=d+4|0;o=f[n>>2]|0;if(((o-(f[d>>2]|0)|0)/24|0)>>>0<2)j=l;else{CGc(g,o+-24|0);o=f[n>>2]|0;p=o+-24|0;q=o;while(1){if((q|0)==(p|0))break;r=q+-24|0;f[n>>2]=r;RFc(r);q=f[n>>2]|0}n=b[g+11>>0]|0;q=n<<24>>24<0;UFc(o+-48|0,q?f[g>>2]|0:g,q?f[g+4>>2]|0:n&255)|0;gGc(g);j=l}}else j=m}else j=a}else j=i}else j=a;while(0);u=e;return j|0}function sHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+8|0;h=e;a:do if((a|0)==(c|0))i=a;else{j=d+16|0;switch(b[a>>0]|0){case 84:{k=d+4|0;l=((f[k>>2]|0)-(f[d>>2]|0)|0)/24|0;m=AGc(a,c,d)|0;n=f[k>>2]|0;o=(n-(f[d>>2]|0)|0)/24|0;p=n;if((m|0)!=(a|0)&(o|0)==(l+1|0)){f[h>>2]=f[d+12>>2];tGc(g,p+-24|0,h);n=d+20|0;q=f[n>>2]|0;if(q>>>0<(f[d+24>>2]|0)>>>0){f[q>>2]=0;r=q+4|0;f[r>>2]=0;s=f[g+12>>2]|0;f[q+8>>2]=0;f[q+12>>2]=s;f[q>>2]=f[g>>2];s=g+4|0;f[r>>2]=f[s>>2];r=g+8|0;f[q+8>>2]=f[r>>2];f[r>>2]=0;f[s>>2]=0;f[g>>2]=0;f[n>>2]=(f[n>>2]|0)+16}else uGc(j,g);SFc(g);i=m;break a}else{t=o;v=p}while(1){if((t|0)==(l|0)){i=a;break a}p=v+-24|0;o=v;while(1){if((o|0)==(p|0))break;m=o+-24|0;f[k>>2]=m;RFc(m);o=f[k>>2]|0}t=t+-1|0;v=p}break}case 68:{k=LGc(a,c,d)|0;if((k|0)==(a|0)){i=a;break a}l=f[d+4>>2]|0;if((f[d>>2]|0)==(l|0)){i=a;break a}f[h>>2]=f[d+12>>2];tGc(g,l+-24|0,h);l=d+20|0;o=f[l>>2]|0;if(o>>>0<(f[d+24>>2]|0)>>>0){f[o>>2]=0;m=o+4|0;f[m>>2]=0;n=f[g+12>>2]|0;f[o+8>>2]=0;f[o+12>>2]=n;f[o>>2]=f[g>>2];n=g+4|0;f[m>>2]=f[n>>2];m=g+8|0;f[o+8>>2]=f[m>>2];f[m>>2]=0;f[n>>2]=0;f[g>>2]=0;f[l>>2]=(f[l>>2]|0)+16}else uGc(j,g);SFc(g);i=k;break a;break}case 83:{k=KGc(a,c,d)|0;if((k|0)!=(a|0)){i=k;break a}if((c-a|0)<=2){i=a;break a}if((b[a+1>>0]|0)!=116){i=a;break a}k=a+2|0;l=vHc(k,c,d)|0;if((l|0)==(k|0)){i=a;break a}k=d+4|0;n=f[k>>2]|0;if((f[d>>2]|0)==(n|0)){i=a;break a}nGc(n+-24|0,0,518141)|0;n=(f[k>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];tGc(g,n,h);n=d+20|0;k=f[n>>2]|0;if(k>>>0<(f[d+24>>2]|0)>>>0){f[k>>2]=0;m=k+4|0;f[m>>2]=0;o=f[g+12>>2]|0;f[k+8>>2]=0;f[k+12>>2]=o;f[k>>2]=f[g>>2];o=g+4|0;f[m>>2]=f[o>>2];m=g+8|0;f[k+8>>2]=f[m>>2];f[m>>2]=0;f[o>>2]=0;f[g>>2]=0;f[n>>2]=(f[n>>2]|0)+16}else uGc(j,g);SFc(g);i=l;break a;break}default:{i=a;break a}}}while(0);u=e;return i|0}function tHc(a,b,c){a=a|0;b=b|0;c=c|0;return uHc(a,b,c)|0}function uHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;if((a|0)!=(c|0)?(h=DGc(a,c,d)|0,(h|0)!=(a|0)):0){i=BGc(h,c,d)|0;if((i|0)!=(h|0)){c=d+4|0;j=f[c>>2]|0;if(((j-(f[d>>2]|0)|0)/24|0)>>>0<2)k=a;else{CGc(g,j+-24|0);j=f[c>>2]|0;d=j+-24|0;l=j;while(1){if((l|0)==(d|0))break;m=l+-24|0;f[c>>2]=m;RFc(m);l=f[c>>2]|0}c=b[g+11>>0]|0;l=c<<24>>24<0;UFc(j+-48|0,l?f[g>>2]|0:g,l?f[g+4>>2]|0:c&255)|0;gGc(g);k=i}}else k=h}else k=a;u=e;return k|0}function vHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;a:do if((a|0)==(c|0))e=a;else switch(b[a>>0]|0){case 68:case 67:{e=wHc(a,c,d)|0;break a;break}case 85:{e=xHc(a,c,d)|0;break a;break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{e=DGc(a,c,d)|0;break a;break}default:return yHc(a,c,d)|0}while(0);return e|0}function wHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+12|0;a:do if((c-a|0)>1?(k=d+4|0,l=f[k>>2]|0,(f[d>>2]|0)!=(l|0)):0){m=a+2|0;n=d+60|0;o=a+1|0;switch(b[a>>0]|0){case 67:{switch(b[o>>0]|0){case 53:case 51:case 50:case 49:break;default:{p=a;break a}}KHc(h,l+-24|0);FGc(g,h);q=f[k>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){HGc(q,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);gGc(h);b[n>>0]=1;p=m;break a;break}case 68:break;default:{p=a;break a}}switch(b[o>>0]|0){case 53:case 50:case 49:case 48:break;default:{p=a;break a}}KHc(j,l+-24|0);nGc(j,0,517917)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];l=0;while(1){if((l|0)==3)break;f[j+(l<<2)>>2]=0;l=l+1|0}FGc(g,i);l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){HGc(l,g);f[k>>2]=(f[k>>2]|0)+24}else IGc(d,g);RFc(g);gGc(i);gGc(j);b[n>>0]=1;p=m}else p=a;while(0);u=e;return p|0}function xHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+80|0;g=e+68|0;h=e+16|0;i=e+56|0;j=e+44|0;k=e;l=e+40|0;a:do if((c-a|0)>2?(b[a>>0]|0)==85:0){m=a+2|0;switch(b[a+1>>0]|0){case 116:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=Ztc(518648)|0;if(n>>>0>4294967279)dEc(i);if(n>>>0<11){b[i+11>>0]=n;o=i}else{p=n+16&-16;q=dGc(p)|0;f[i>>2]=q;f[i+8>>2]=p|-2147483648;f[i+4>>2]=n;o=q}etc(o,518648,n)|0;b[g>>0]=0;_tc(o+n|0,g);FGc(h,i);n=d+4|0;q=f[n>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){HGc(q,h);f[n>>2]=(f[n>>2]|0)+24}else IGc(d,h);RFc(h);gGc(i);if((m|0)==(c|0)){q=f[n>>2]|0;p=q+-24|0;r=q;while(1){if((r|0)==(p|0)){s=a;break a}q=r+-24|0;f[n>>2]=q;RFc(q);r=f[n>>2]|0}}if(((b[m>>0]|0)+-48|0)>>>0<10){r=a+3|0;while(1){if((r|0)==(c|0)){t=c;break}if(((b[r>>0]|0)+-48|0)>>>0>=10){t=r;break}r=r+1|0}GHc((f[n>>2]|0)+-24|0,m,t);v=t}else v=m;HHc((f[n>>2]|0)+-24|0,39);if((v|0)!=(c|0)?(b[v>>0]|0)==95:0){s=v+1|0;break a}r=f[n>>2]|0;p=r+-24|0;q=r;while(1){if((q|0)==(p|0)){s=a;break a}r=q+-24|0;f[n>>2]=r;RFc(r);q=f[n>>2]|0}break}case 108:break;default:{s=a;break a}}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;n=Ztc(518657)|0;if(n>>>0>4294967279)dEc(j);if(n>>>0<11){b[j+11>>0]=n;w=j}else{q=n+16&-16;p=dGc(q)|0;f[j>>2]=p;f[j+8>>2]=q|-2147483648;f[j+4>>2]=n;w=p}etc(w,518657,n)|0;b[g>>0]=0;_tc(w+n|0,g);FGc(h,j);n=d+4|0;p=f[n>>2]|0;if(p>>>0<(f[d+8>>2]|0)>>>0){HGc(p,h);f[n>>2]=(f[n>>2]|0)+24}else IGc(d,h);RFc(h);gGc(j);do if((b[m>>0]|0)!=118){p=kGc(m,c,d)|0;if((p|0)==(m|0)){q=f[n>>2]|0;r=q+-24|0;x=q;while(1){if((x|0)==(r|0)){s=a;break a}q=x+-24|0;f[n>>2]=q;RFc(q);x=f[n>>2]|0}}x=f[n>>2]|0;if(((x-(f[d>>2]|0)|0)/24|0)>>>0<2){s=a;break a}CGc(h,x+-24|0);x=f[n>>2]|0;r=x+-24|0;q=x;while(1){if((q|0)==(r|0))break;y=q+-24|0;f[n>>2]=y;RFc(y);q=f[n>>2]|0}q=h+11|0;r=b[q>>0]|0;y=r<<24>>24<0;z=h+4|0;UFc(x+-48|0,y?f[h>>2]|0:h,y?f[z>>2]|0:r&255)|0;r=p;while(1){y=kGc(r,c,d)|0;if((y|0)==(r|0)){A=60;break}B=f[n>>2]|0;if(((B-(f[d>>2]|0)|0)/24|0)>>>0<2){A=85;break}CGc(k,B+-24|0);if((b[q>>0]|0)<0){B=f[h>>2]|0;b[g>>0]=0;_tc(B,g);f[z>>2]=0}else{b[g>>0]=0;_tc(h,g);b[q>>0]=0}PGc(h);f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];B=0;while(1){if((B|0)==3)break;f[k+(B<<2)>>2]=0;B=B+1|0}gGc(k);B=f[n>>2]|0;C=B+-24|0;D=B;while(1){if((D|0)==(C|0))break;E=D+-24|0;f[n>>2]=E;RFc(E);D=f[n>>2]|0}D=b[q>>0]|0;if(!((D<<24>>24<0?f[z>>2]|0:D&255)|0)){r=y;continue}oGc(B+-48|0,518069)|0;D=b[q>>0]|0;C=D<<24>>24<0;UFc((f[n>>2]|0)+-24|0,C?f[h>>2]|0:h,C?f[z>>2]|0:D&255)|0;r=y}if((A|0)==60){oGc((f[n>>2]|0)+-24|0,517845)|0;gGc(h);F=r;break}else if((A|0)==85){gGc(h);s=a;break a}}else{HHc((f[n>>2]|0)+-24|0,41);F=a+3|0}while(0);if((F|0)!=(c|0)?(b[F>>0]|0)==69:0){m=F+1|0;if((m|0)==(c|0)){z=f[n>>2]|0;q=z+-24|0;p=z;while(1){if((p|0)==(q|0)){s=a;break a}z=p+-24|0;f[n>>2]=z;RFc(z);p=f[n>>2]|0}}if(((b[m>>0]|0)+-48|0)>>>0<10){p=F+2|0;while(1){if((p|0)==(c|0)){G=c;break}if(((b[p>>0]|0)+-48|0)>>>0>=10){G=p;break}p=p+1|0}p=(f[n>>2]|0)+-24|0;if((b[p+11>>0]|0)<0)H=f[p>>2]|0;else H=p;f[l>>2]=H+7;f[g>>2]=f[l>>2];IHc(p,g,m,G)|0;I=G}else I=m;if((I|0)!=(c|0)?(b[I>>0]|0)==95:0){s=I+1|0;break}p=f[n>>2]|0;q=p+-24|0;z=p;while(1){if((z|0)==(q|0)){s=a;break a}p=z+-24|0;f[n>>2]=p;RFc(p);z=f[n>>2]|0}}z=f[n>>2]|0;q=z+-24|0;m=z;while(1){if((m|0)==(q|0)){s=a;break a}z=m+-24|0;f[n>>2]=z;RFc(z);m=f[n>>2]|0}}else s=a;while(0);u=e;return s|0}function yHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;a:do if((c-a|0)>1){h=a+2|0;i=a+1|0;do switch(b[a>>0]|0){case 97:{switch(b[i>>0]|0){case 97:{zHc(g,518147);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 110:case 100:{AHc(g,518158);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 78:{zHc(g,518168);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 83:{AHc(g,518179);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 99:{switch(b[i>>0]|0){case 108:{zHc(g,518189);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 109:{AHc(g,518200);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 111:{AHc(g,518210);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[j>>2]=(f[j>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 118:{j=d+63|0;k=b[j>>0]|0;b[j>>0]=0;m=kGc(h,c,d)|0;b[j>>0]=k;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}nGc(k+-24|0,0,518220)|0;b[d+60>>0]=1;l=m;break a;break}default:{l=a;break a}}break}case 100:{switch(b[i>>0]|0){case 97:{BHc(g,518230);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 101:{AHc(g,518248);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 108:{CHc(g);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 118:{AHc(g,518258);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 86:{zHc(g,518268);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 101:{switch(b[i>>0]|0){case 111:{AHc(g,518279);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 79:{zHc(g,518289);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 113:{zHc(g,518300);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 103:{switch(b[i>>0]|0){case 101:{zHc(g,518311);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 116:{AHc(g,518322);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 105:{if((b[i>>0]|0)!=120){l=a;break a}zHc(g,518332);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 108:{switch(b[i>>0]|0){case 101:{zHc(g,518343);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 105:{m=DGc(h,c,d)|0;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}nGc(k+-24|0,0,518354)|0;l=m;break a;break}case 115:{zHc(g,518366);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 83:{DHc(g,518377);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 116:{AHc(g,518389);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 109:{switch(b[i>>0]|0){case 105:{AHc(g,518399);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 73:{zHc(g,518409);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 108:{AHc(g,518248);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 76:{zHc(g,518420);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 109:{zHc(g,518431);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 110:{switch(b[i>>0]|0){case 97:{EHc(g,518442);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 101:{zHc(g,518457);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 103:{AHc(g,518399);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 116:{AHc(g,518468);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 119:{FHc(g,518478);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 111:{switch(b[i>>0]|0){case 111:{zHc(g,518491);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 114:{AHc(g,518502);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 82:{zHc(g,518512);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 112:{switch(b[i>>0]|0){case 109:{DHc(g,518523);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 108:{AHc(g,518535);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 76:{zHc(g,518545);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 112:{zHc(g,518556);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 115:{AHc(g,518535);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 116:{zHc(g,518567);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 113:{if((b[i>>0]|0)!=117){l=a;break a}AHc(g,518578);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 114:{switch(b[i>>0]|0){case 109:{AHc(g,518588);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 77:{zHc(g,518598);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 115:{zHc(g,518609);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}case 83:{DHc(g,518620);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){HGc(k,g);f[m>>2]=(f[m>>2]|0)+24}else IGc(d,g);RFc(g);l=h;break a;break}default:{l=a;break a}}break}case 118:{if(((b[i>>0]|0)+-48|0)>>>0>=10){l=a;break a}m=DGc(h,c,d)|0;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}nGc(k+-24|0,0,518220)|0;l=m;break a;break}default:{l=a;break a}}while(0)}else l=a;while(0);u=e;return l|0}function zHc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=10;etc(a,c,10)|0;b[e>>0]=0;_tc(a+10|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function AHc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=9;etc(a,c,9)|0;b[e>>0]=0;_tc(a+9|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function BHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=dGc(32)|0;f[a>>2]=g;f[a+8>>2]=-2147483616;f[a+4>>2]=17;etc(g,c,17)|0;b[e>>0]=0;_tc(g+17|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function CHc(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=dGc(16)|0;f[a>>2]=e;f[a+8>>2]=-2147483632;f[a+4>>2]=15;etc(e,518632,15)|0;b[d>>0]=0;_tc(e+15|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function DHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=dGc(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=11;etc(g,c,11)|0;b[e>>0]=0;_tc(g+11|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function EHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=dGc(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=14;etc(g,c,14)|0;b[e>>0]=0;_tc(g+14|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function FHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=dGc(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=12;etc(g,c,12)|0;b[e>>0]=0;_tc(g+12|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function GHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=c;h=e+12|0;i=e;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=f[a+4>>2]|0;n=(f[a+8>>2]&2147483647)+-1|0}else{m=k&255;n=10}o=d-g|0;do if(o|0){if(l){p=f[a>>2]|0;q=p;r=f[a+4>>2]|0;s=p}else{q=a;r=k&255;s=a}if(xEc(c,s,q+r|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(o>>>0>4294967279)dEc(i);if(o>>>0<11){b[i+11>>0]=o;t=i}else{p=o+16&-16;v=dGc(p)|0;f[i>>2]=v;f[i+8>>2]=p|-2147483648;f[i+4>>2]=o;t=v}v=c;p=t;while(1){if((v|0)==(d|0))break;_tc(p,v);v=v+1|0;p=p+1|0}b[h>>0]=0;_tc(t+o|0,h);p=b[i+11>>0]|0;v=p<<24>>24<0;UFc(a,v?f[i>>2]|0:i,v?f[i+4>>2]|0:p&255)|0;gGc(i);break}p=m+o|0;if((n-m|0)>>>0<o>>>0)JHc(a,n,p-n|0,m,m,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;v=d+(m-g)|0;x=w+m|0;y=c;while(1){if((y|0)==(d|0))break;_tc(x,y);x=x+1|0;y=y+1|0}b[h>>0]=0;_tc(w+v|0,h);if((b[j>>0]|0)<0){f[a+4>>2]=p;break}else{b[j>>0]=p;break}}while(0);u=e;return}function HHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=d+1|0;b[e>>0]=c;c=a+11|0;h=b[c>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=10}if((j|0)==(k|0)){JHc(a,k,1,k,k,0);h=k+1|0;if((b[c>>0]|0)<0){l=h;m=8}else{n=h;m=7}}else{h=j+1|0;if(i){l=h;m=8}else{n=h;m=7}}if((m|0)==7){b[c>>0]=n;o=a}else if((m|0)==8){m=f[a>>2]|0;f[a+4>>2]=l;o=m}m=o+j|0;_tc(m,e);b[g>>0]=0;_tc(m+1|0,g);u=d;return}function IHc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+32|0;h=g+16|0;i=g;j=g+12|0;k=a+11|0;l=b[k>>0]|0;m=l<<24>>24<0;if(m)n=f[a>>2]|0;else n=a;o=f[c>>2]|0;c=o-n|0;n=e-d|0;do if(!n){p=l;q=35}else{if(m){r=f[a>>2]|0;s=r;t=f[a+4>>2]|0;v=r}else{s=a;t=l&255;v=a}if(xEc(d,v,s+t|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(n>>>0>4294967279)dEc(i);if(n>>>0<11){b[i+11>>0]=n;w=i}else{r=n+16&-16;x=dGc(r)|0;f[i>>2]=x;f[i+8>>2]=r|-2147483648;f[i+4>>2]=n;w=x}x=d;r=w;while(1){if((x|0)==(e|0))break;_tc(r,x);x=x+1|0;r=r+1|0}b[h>>0]=0;_tc(w+n|0,h);f[j>>2]=o;r=b[i+11>>0]|0;x=r<<24>>24<0;y=x?f[i>>2]|0:i;z=y+(x?f[i+4>>2]|0:r&255)|0;f[h>>2]=f[j>>2];r=IHc(a,h,y,z)|0;gGc(i);A=r;break}r=b[k>>0]|0;z=r<<24>>24<0;if(z){B=f[a+4>>2]|0;C=(f[a+8>>2]&2147483647)+-1|0}else{B=r&255;C=10}r=B+n|0;if((C-B|0)>>>0>=n>>>0){if(z)D=f[a>>2]|0;else D=a;z=B-c|0;if(!z)E=D;else{y=D+c|0;kEc(y+n|0,y,z)|0;E=D}}else{JHc(a,C,r-C|0,B,c,n);E=f[a>>2]|0}if((b[k>>0]|0)<0)f[a+4>>2]=r;else b[k>>0]=r;b[h>>0]=0;_tc(E+r|0,h);r=d;z=E+c|0;while(1){if((r|0)==(e|0))break;_tc(z,r);r=r+1|0;z=z+1|0}p=b[k>>0]|0;q=35}while(0);if((q|0)==35){if(p<<24>>24<0)F=f[a>>2]|0;else F=a;A=F+c|0}u=g;return A|0}function JHc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;if((-17-c|0)>>>0<d>>>0)dEc(a);if((b[a+11>>0]|0)<0)i=f[a>>2]|0;else i=a;if(c>>>0<2147483623){j=d+c|0;d=c<<1;k=j>>>0<d>>>0?d:j;l=k>>>0<11?11:k+16&-16}else l=-17;k=dGc(l)|0;if(g|0)etc(k,i,g)|0;j=e-g|0;if(j|0)etc(k+g+h|0,i+g|0,j)|0;if((c|0)!=10)eGc(i);f[a>>2]=k;f[a+8>>2]=l|-2147483648;return}function KHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+11|0;h=b[g>>0]|0;i=c+4|0;a:do if(!((h<<24>>24<0?f[i>>2]|0:h&255)|0))LHc(a,c);else{j=Ztc(518667)|0;k=b[g>>0]|0;if((j|0)==((k<<24>>24<0?f[i>>2]|0:k&255)|0)?(yGc(c,518667,j)|0)==0:0){pHc(c,518679);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=Ztc(518750)|0;if(j>>>0>4294967279)dEc(a);if(j>>>0<11){b[a+11>>0]=j;l=a}else{k=j+16&-16;m=dGc(k)|0;f[a>>2]=m;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;l=m}etc(l,518750,j)|0;b[e>>0]=0;_tc(l+j|0,e);break}j=Ztc(518763)|0;m=b[g>>0]|0;if((j|0)==((m<<24>>24<0?f[i>>2]|0:m&255)|0)?(yGc(c,518763,j)|0)==0:0){pHc(c,518776);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=Ztc(518826)|0;if(j>>>0>4294967279)dEc(a);if(j>>>0<11){b[a+11>>0]=j;n=a}else{m=j+16&-16;k=dGc(m)|0;f[a>>2]=k;f[a+8>>2]=m|-2147483648;f[a+4>>2]=j;n=k}etc(n,518826,j)|0;b[e>>0]=0;_tc(n+j|0,e);break}j=Ztc(518840)|0;k=b[g>>0]|0;if((j|0)==((k<<24>>24<0?f[i>>2]|0:k&255)|0)?(yGc(c,518840,j)|0)==0:0){pHc(c,518853);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=Ztc(518903)|0;if(j>>>0>4294967279)dEc(a);if(j>>>0<11){b[a+11>>0]=j;o=a}else{k=j+16&-16;m=dGc(k)|0;f[a>>2]=m;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;o=m}etc(o,518903,j)|0;b[e>>0]=0;_tc(o+j|0,e);break}j=Ztc(518917)|0;m=b[g>>0]|0;k=f[i>>2]|0;do if((j|0)==((m<<24>>24<0?k:m&255)|0)){if(yGc(c,518917,j)|0){p=f[i>>2]|0;q=b[g>>0]|0;break}pHc(c,518931);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=Ztc(518982)|0;if(r>>>0>4294967279)dEc(a);if(r>>>0<11){b[a+11>>0]=r;s=a}else{t=r+16&-16;v=dGc(t)|0;f[a>>2]=v;f[a+8>>2]=t|-2147483648;f[a+4>>2]=r;s=v}etc(s,518982,r)|0;b[e>>0]=0;_tc(s+r|0,e);break a}else{p=k;q=m}while(0);m=q<<24>>24<0;k=m?f[c>>2]|0:c;j=k+(m?p:q&255)|0;b:do if((b[j+-1>>0]|0)==62){m=1;r=j;c:while(1){v=r;d:while(1){w=v+-1|0;if((w|0)==(k|0))break c;x=v+-2|0;switch(b[x>>0]|0){case 60:{y=43;break d;break}case 62:{y=44;break d;break}default:v=w}}if((y|0)==43){y=0;v=m+-1|0;if(!v){z=x;break b}else{m=v;r=w;continue}}else if((y|0)==44){y=0;m=m+1|0;r=w;continue}}f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=0;while(1){if((r|0)==3)break a;f[a+(r<<2)>>2]=0;r=r+1|0}}else z=j;while(0);j=z;while(1){r=j+-1|0;if((r|0)==(k|0)){A=k;break}if((b[r>>0]|0)==58){A=j;break}else j=r}f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=z-A|0;if(j>>>0>4294967279)dEc(a);if(j>>>0<11){b[a+11>>0]=j;B=a}else{k=j+16&-16;r=dGc(k)|0;f[a>>2]=r;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;B=r}r=A;k=B;while(1){if((r|0)==(z|0))break;_tc(k,r);r=r+1|0;k=k+1|0}b[e>>0]=0;_tc(B+j|0,e)}while(0);u=d;return}function LHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if((b[c+11>>0]|0)<0){g=f[c>>2]|0;h=f[c+4>>2]|0;if(h>>>0>4294967279)dEc(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=dGc(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}etc(i,g,h)|0;b[e>>0]=0;_tc(i+h|0,e)}else{f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2]}u=d;return}function MHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((a|0)!=(b|0)){d=sHc(a,b,c)|0;if((d|0)==(a|0))e=uHc(a,b,c)|0;else e=d;if((e|0)!=(a|0)?(d=f[c+4>>2]|0,(f[c>>2]|0)!=(d|0)):0){nGc(d+-24|0,0,517917)|0;g=e}else g=a}else g=a;return g|0}function NHc(a){a=a|0;var b=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}b=a+12|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[b+(a<<2)>>2]=0;a=a+1|0}return}function OHc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+32|0;c=b;d=a+4|0;e=(((f[d>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;g=PHc(a)|0;if(g>>>0<e>>>0)mCc(a);else{h=f[a>>2]|0;i=((f[a+8>>2]|0)-h|0)/24|0;j=i<<1;QHc(c,i>>>0<g>>>1>>>0?(j>>>0<e>>>0?e:j):g,((f[d>>2]|0)-h|0)/24|0,a+12|0);h=c+8|0;d=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;NHc(d);f[h>>2]=d+24;RHc(a,c);SHc(c);u=b;return}}function PHc(a){a=a|0;return 178956970}function QHc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=THc(d,b)|0;f[a>>2]=e;d=e+(c*24|0)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b*24|0);return}function RHc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=g+-24|0;HGc((f[e>>2]|0)+-24|0,h);f[e>>2]=(f[e>>2]|0)+-24;g=h}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function SHc(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-24|0;f[c>>2]=e;RFc(e)}c=f[a>>2]|0;if(c|0)fGc(f[a+16>>2]|0,c,((f[a+12>>2]|0)-c|0)/24|0);return}function THc(a,b){a=a|0;b=b|0;return UHc(f[a>>2]|0,b*24|0)|0}function UHc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=aGc(b)|0;b=a+4096|0;d=f[b>>2]|0;if((a+4096-d|0)>>>0<c>>>0)e=ooc(c)|0;else{f[b>>2]=d+c;e=d}return e|0}function VHc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+12|0;k=NGc(a,c)|0;if(!((k|0)==(a|0)|(k|0)==(c|0))?(b[k>>0]|0)==69:0){c=d+11|0;l=b[c>>0]|0;m=d+4|0;do if((l<<24>>24<0?f[m>>2]|0:l&255)>>>0<=3){n=e+4|0;o=f[n>>2]|0;if(o>>>0<(f[e+8>>2]|0)>>>0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;NHc(o);f[n>>2]=(f[n>>2]|0)+24;break}else{OHc(e);break}}else{QGc(j,517847,d);oGc(j,517845)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];n=0;while(1){if((n|0)==3)break;f[j+(n<<2)>>2]=0;n=n+1|0}FGc(h,i);n=e+4|0;o=f[n>>2]|0;if(o>>>0<(f[e+8>>2]|0)>>>0){HGc(o,h);f[n>>2]=(f[n>>2]|0)+24}else IGc(e,h);RFc(h);gGc(i);gGc(j)}while(0);j=e+4|0;if((b[a>>0]|0)==110){HHc((f[j>>2]|0)+-24|0,45);p=a+1|0}else p=a;GHc((f[j>>2]|0)+-24|0,p,k);p=b[c>>0]|0;c=p<<24>>24<0;e=c?f[m>>2]|0:p&255;if(e>>>0<4)UFc((f[j>>2]|0)+-24|0,c?f[d>>2]|0:d,e)|0;q=k+1|0}else q=a;u=g;return q|0}function WHc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=4;etc(a,c,4)|0;b[e>>0]=0;_tc(a+4|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function XHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+80|0;g=e;h=e+44|0;i=e+48|0;j=e+8|0;k=e+32|0;a:do if((c-a|0)>>>0>8){l=0;m=h;while(1){o=b[a+l>>0]|0;q=o<<24>>24;r=a+(l|1)|0;if((l|0)==8){s=6;break}if(!(Zqc(q)|0))break;t=b[r>>0]|0;b[m>>0]=t+(((q+-48|0)>>>0<10?0:9)+q<<4)+((t+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((s|0)==6){if(o<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;t=h;while(1){q=l+-1|0;if(t>>>0>=q>>>0)break b;v=b[t>>0]|0;b[t>>0]=b[q>>0]|0;b[q>>0]=v;l=q;t=t+1|0}}while(0);t=i;l=t+24|0;do{b[t>>0]=0;t=t+1|0}while((t|0)<(l|0));p[g>>3]=+n[h>>2];t=gqc(i,24,519159,g)|0;if(t>>>0>23)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(t>>>0<11){b[k+11>>0]=t;w=k}else{l=t+16&-16;q=dGc(l)|0;f[k>>2]=q;f[k+8>>2]=l|-2147483648;f[k+4>>2]=t;w=q}etc(w,i,t)|0;b[g>>0]=0;_tc(w+t|0,g);FGc(j,k);t=d+4|0;q=f[t>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){HGc(q,j);f[t>>2]=(f[t>>2]|0)+24}else IGc(d,j);RFc(j);gGc(k);x=r}else x=a;y=x;break a}while(0);y=a}else y=a;while(0);u=e;return y|0}function YHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+96|0;g=e+8|0;h=e;i=e+56|0;j=e+16|0;k=e+40|0;a:do if((c-a|0)>>>0>16){l=0;m=h;while(1){n=b[a+l>>0]|0;o=n<<24>>24;q=a+(l|1)|0;if((l|0)==16){r=6;break}if(!(Zqc(o)|0))break;s=b[q>>0]|0;b[m>>0]=s+(((o+-48|0)>>>0<10?0:9)+o<<4)+((s+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((r|0)==6){if(n<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;s=h;while(1){o=l+-1|0;if(s>>>0>=o>>>0)break b;t=b[s>>0]|0;b[s>>0]=b[o>>0]|0;b[o>>0]=t;l=o;s=s+1|0}}while(0);s=i;l=s+32|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(l|0));p[g>>3]=+p[h>>3];s=gqc(i,32,519156,g)|0;if(s>>>0>31)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0<11){b[k+11>>0]=s;v=k}else{l=s+16&-16;o=dGc(l)|0;f[k>>2]=o;f[k+8>>2]=l|-2147483648;f[k+4>>2]=s;v=o}etc(v,i,s)|0;b[g>>0]=0;_tc(v+s|0,g);FGc(j,k);s=d+4|0;o=f[s>>2]|0;if(o>>>0<(f[d+8>>2]|0)>>>0){HGc(o,j);f[s>>2]=(f[s>>2]|0)+24}else IGc(d,j);RFc(j);gGc(k);w=q}else w=a;x=w;break a}while(0);x=a}else x=a;while(0);u=e;return x|0}function ZHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+96|0;g=e+8|0;h=e;i=e+56|0;j=e+16|0;k=e+40|0;a:do if((c-a|0)>>>0>20){l=0;m=h;while(1){n=b[a+l>>0]|0;o=n<<24>>24;q=a+(l|1)|0;if((l|0)==20){r=6;break}if(!(Zqc(o)|0))break;s=b[q>>0]|0;b[m>>0]=s+(((o+-48|0)>>>0<10?0:9)+o<<4)+((s+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((r|0)==6){if(n<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;s=h;while(1){o=l+-1|0;if(s>>>0>=o>>>0)break b;t=b[s>>0]|0;b[s>>0]=b[o>>0]|0;b[o>>0]=t;l=o;s=s+1|0}}while(0);s=i;l=s+40|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(l|0));p[g>>3]=+p[h>>3];s=gqc(i,40,519151,g)|0;if(s>>>0>39)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0<11){b[k+11>>0]=s;v=k}else{l=s+16&-16;o=dGc(l)|0;f[k>>2]=o;f[k+8>>2]=l|-2147483648;f[k+4>>2]=s;v=o}etc(v,i,s)|0;b[g>>0]=0;_tc(v+s|0,g);FGc(j,k);s=d+4|0;o=f[s>>2]|0;if(o>>>0<(f[d+8>>2]|0)>>>0){HGc(o,j);f[s>>2]=(f[s>>2]|0)+24}else IGc(d,j);RFc(j);gGc(k);w=q}else w=a;x=w;break a}while(0);x=a}else x=a;while(0);u=e;return x|0}function _Hc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=dGc(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=13;etc(g,c,13)|0;b[e>>0]=0;_tc(g+13|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function $Hc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+8|0;j=e;a:do if((a|0)!=(c|0)?(b[a>>0]|0)==78:0){k=lGc(a+1|0,c,g)|0;b:do if((k|0)!=(c|0)){l=d+52|0;f[l>>2]=0;m=k+1|0;switch(b[k>>0]|0){case 82:{n=1;o=6;break}case 79:{n=2;o=6;break}default:p=k}if((o|0)==6){f[l>>2]=n;p=m}m=d+4|0;l=f[m>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;NHc(l);f[m>>2]=(f[m>>2]|0)+24}else OHc(d);if(((c-p|0)>1?(b[p>>0]|0)==83:0)?(b[p+1>>0]|0)==116:0){pHc((f[m>>2]|0)+-24|0,519223);q=p+2|0}else q=p;if((q|0)==(c|0)){l=f[m>>2]|0;r=l+-24|0;s=l;while(1){if((s|0)==(r|0))break b;l=s+-24|0;f[m>>2]=l;RFc(l);s=f[m>>2]|0}}s=d+16|0;r=h+11|0;l=h+4|0;t=d+12|0;v=d+20|0;w=d+24|0;x=i+12|0;y=i+4|0;z=i+8|0;A=i+12|0;B=i+4|0;C=i+8|0;D=i+11|0;E=i+4|0;F=i+11|0;G=i+4|0;H=i+12|0;I=i+4|0;J=i+8|0;K=i+12|0;L=i+4|0;M=i+8|0;N=i+11|0;O=i+4|0;P=i+12|0;Q=i+4|0;R=i+8|0;S=i+11|0;T=i+4|0;U=0;V=q;c:while(1){W=V;d:while(1){X=b[W>>0]|0;Y=W+1|0;if(X<<24>>24==69)break c;switch(X<<24>>24|0){case 83:{o=21;break d;break}case 84:{o=37;break d;break}case 68:{o=51;break d;break}case 73:break;case 76:{if((Y|0)==(c|0))break b;else{W=Y;continue d}break}default:break d}X=BGc(W,c,d)|0;if((X|0)==(W|0)|(X|0)==(c|0))break b;CGc(h,(f[m>>2]|0)+-24|0);Z=f[m>>2]|0;_=Z+-24|0;$=Z;while(1){if(($|0)==(_|0))break;aa=$+-24|0;f[m>>2]=aa;RFc(aa);$=f[m>>2]|0}$=b[r>>0]|0;_=$<<24>>24<0;UFc(Z+-48|0,_?f[h>>2]|0:h,_?f[l>>2]|0:$&255)|0;$=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];tGc(i,$,j);$=f[v>>2]|0;if($>>>0<(f[w>>2]|0)>>>0){f[$>>2]=0;_=$+4|0;f[_>>2]=0;aa=f[x>>2]|0;f[$+8>>2]=0;f[$+12>>2]=aa;f[$>>2]=f[i>>2];f[_>>2]=f[y>>2];f[$+8>>2]=f[z>>2];f[z>>2]=0;f[y>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else uGc(s,i);SFc(i);gGc(h);W=X}e:do if((o|0)==21){o=0;if((Y|0)!=(c|0)?(b[Y>>0]|0)==116:0)break;$=KGc(W,c,d)|0;if(($|0)==(W|0)|($|0)==(c|0))break b;CGc(h,(f[m>>2]|0)+-24|0);_=f[m>>2]|0;aa=_+-24|0;ba=_;while(1){if((ba|0)==(aa|0))break;ca=ba+-24|0;f[m>>2]=ca;RFc(ca);ba=f[m>>2]|0}ba=_+-48|0;aa=b[ba+11>>0]|0;if(aa<<24>>24<0)da=f[_+-44>>2]|0;else da=aa&255;if(!da)dIc(ba,h);else{QGc(i,517919,h);ba=b[F>>0]|0;aa=ba<<24>>24<0;UFc((f[m>>2]|0)+-24|0,aa?f[i>>2]|0:i,aa?f[G>>2]|0:ba&255)|0;gGc(i);ba=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];tGc(i,ba,j);ba=f[v>>2]|0;if(ba>>>0<(f[w>>2]|0)>>>0){f[ba>>2]=0;aa=ba+4|0;f[aa>>2]=0;X=f[H>>2]|0;f[ba+8>>2]=0;f[ba+12>>2]=X;f[ba>>2]=f[i>>2];f[aa>>2]=f[I>>2];f[ba+8>>2]=f[J>>2];f[J>>2]=0;f[I>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else uGc(s,i);SFc(i)}gGc(h);U=1;V=$;continue c}else if((o|0)==37){o=0;ba=AGc(W,c,d)|0;if((ba|0)==(W|0)|(ba|0)==(c|0))break b;CGc(h,(f[m>>2]|0)+-24|0);aa=f[m>>2]|0;X=aa+-24|0;Z=aa;while(1){if((Z|0)==(X|0))break;ca=Z+-24|0;f[m>>2]=ca;RFc(ca);Z=f[m>>2]|0}Z=aa+-48|0;X=b[Z+11>>0]|0;if(X<<24>>24<0)ea=f[aa+-44>>2]|0;else ea=X&255;if(!ea)dIc(Z,h);else{QGc(i,517919,h);Z=b[N>>0]|0;X=Z<<24>>24<0;UFc((f[m>>2]|0)+-24|0,X?f[i>>2]|0:i,X?f[O>>2]|0:Z&255)|0;gGc(i)}Z=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];tGc(i,Z,j);Z=f[v>>2]|0;if(Z>>>0<(f[w>>2]|0)>>>0){f[Z>>2]=0;X=Z+4|0;f[X>>2]=0;$=f[K>>2]|0;f[Z+8>>2]=0;f[Z+12>>2]=$;f[Z>>2]=f[i>>2];f[X>>2]=f[L>>2];f[Z+8>>2]=f[M>>2];f[M>>2]=0;f[L>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else uGc(s,i);SFc(i);gGc(h);U=1;V=ba;continue c}else if((o|0)==51){o=0;if((Y|0)!=(c|0))switch(b[Y>>0]|0){case 84:case 116:break;default:break e}Z=LGc(W,c,d)|0;if((Z|0)==(W|0)|(Z|0)==(c|0))break b;CGc(h,(f[m>>2]|0)+-24|0);X=f[m>>2]|0;$=X+-24|0;_=X;while(1){if((_|0)==($|0))break;ca=_+-24|0;f[m>>2]=ca;RFc(ca);_=f[m>>2]|0}_=X+-48|0;$=b[_+11>>0]|0;if($<<24>>24<0)fa=f[X+-44>>2]|0;else fa=$&255;if(!fa)dIc(_,h);else{QGc(i,517919,h);_=b[S>>0]|0;$=_<<24>>24<0;UFc((f[m>>2]|0)+-24|0,$?f[i>>2]|0:i,$?f[T>>2]|0:_&255)|0;gGc(i)}_=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];tGc(i,_,j);_=f[v>>2]|0;if(_>>>0<(f[w>>2]|0)>>>0){f[_>>2]=0;$=_+4|0;f[$>>2]=0;ba=f[P>>2]|0;f[_+8>>2]=0;f[_+12>>2]=ba;f[_>>2]=f[i>>2];f[$>>2]=f[Q>>2];f[_+8>>2]=f[R>>2];f[R>>2]=0;f[Q>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else uGc(s,i);SFc(i);gGc(h);U=1;V=Z;continue c}while(0);_=vHc(W,c,d)|0;if((_|0)==(W|0)|(_|0)==(c|0))break b;CGc(h,(f[m>>2]|0)+-24|0);$=f[m>>2]|0;ba=$+-24|0;aa=$;while(1){if((aa|0)==(ba|0))break;ca=aa+-24|0;f[m>>2]=ca;RFc(ca);aa=f[m>>2]|0}aa=$+-48|0;ba=b[aa+11>>0]|0;if(ba<<24>>24<0)ga=f[$+-44>>2]|0;else ga=ba&255;if(!ga)dIc(aa,h);else{QGc(i,517919,h);aa=b[D>>0]|0;ba=aa<<24>>24<0;UFc((f[m>>2]|0)+-24|0,ba?f[i>>2]|0:i,ba?f[E>>2]|0:aa&255)|0;gGc(i)}aa=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];tGc(i,aa,j);aa=f[v>>2]|0;if(aa>>>0<(f[w>>2]|0)>>>0){f[aa>>2]=0;ba=aa+4|0;f[ba>>2]=0;W=f[A>>2]|0;f[aa+8>>2]=0;f[aa+12>>2]=W;f[aa>>2]=f[i>>2];f[ba>>2]=f[B>>2];f[aa+8>>2]=f[C>>2];f[C>>2]=0;f[B>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else uGc(s,i);SFc(i);gGc(h);U=1;V=_}f[d+48>>2]=f[g>>2];f:do if(U?(V=f[v>>2]|0,(f[s>>2]|0)!=(V|0)):0){B=V+-16|0;C=V;while(1){if((C|0)==(B|0))break f;V=C+-16|0;f[v>>2]=V;SFc(V);C=f[v>>2]|0}}while(0);ha=Y;break a}while(0);ha=a}else ha=a;while(0);u=e;return ha|0}function aIc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;a:do if(((((a|0)!=(c|0)?(b[a>>0]|0)==90:0)?(h=a+1|0,i=hGc(h,c,d)|0,!((i|0)==(h|0)|(i|0)==(c|0))):0)?(b[i>>0]|0)==69:0)?(h=i+1|0,(h|0)!=(c|0)):0){j=i+2|0;switch(b[h>>0]|0){case 115:{i=cIc(j,c)|0;k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=i;break a}oGc(k+-24|0,519206)|0;l=i;break a;break}case 100:{if((j|0)==(c|0)){l=a;break a}i=NGc(j,c)|0;if((i|0)==(c|0)){l=a;break a}if((b[i>>0]|0)!=95){l=a;break a}j=i+1|0;i=JGc(j,c,d)|0;k=d+4|0;if((i|0)==(j|0)){j=f[k>>2]|0;m=j+-24|0;n=j;while(1){if((n|0)==(m|0)){l=a;break a}j=n+-24|0;f[k>>2]=j;RFc(j);n=f[k>>2]|0}}n=f[k>>2]|0;if(((n-(f[d>>2]|0)|0)/24|0)>>>0<2){l=a;break a}CGc(g,n+-24|0);n=f[k>>2]|0;m=n+-24|0;j=n;while(1){if((j|0)==(m|0))break;o=j+-24|0;f[k>>2]=o;RFc(o);j=f[k>>2]|0}oGc(n+-48|0,517919)|0;j=b[g+11>>0]|0;m=j<<24>>24<0;UFc((f[k>>2]|0)+-24|0,m?f[g>>2]|0:g,m?f[g+4>>2]|0:j&255)|0;gGc(g);l=i;break a;break}default:{j=JGc(h,c,d)|0;if((j|0)==(h|0)){m=d+4|0;o=f[m>>2]|0;p=o+-24|0;q=o;while(1){if((q|0)==(p|0)){l=a;break a}o=q+-24|0;f[m>>2]=o;RFc(o);q=f[m>>2]|0}}m=cIc(j,c)|0;q=d+4|0;p=f[q>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0<2){l=m;break a}CGc(g,p+-24|0);p=f[q>>2]|0;h=p+-24|0;i=p;while(1){if((i|0)==(h|0))break;k=i+-24|0;f[q>>2]=k;RFc(k);i=f[q>>2]|0}oGc(p+-48|0,517919)|0;i=b[g+11>>0]|0;h=i<<24>>24<0;UFc((f[q>>2]|0)+-24|0,h?f[g>>2]|0:g,h?f[g+4>>2]|0:i&255)|0;gGc(g);l=m;break a}}}else l=a;while(0);u=e;return l|0}function bIc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;if((c-a|0)>1){if((b[a>>0]|0)==83?(b[a+1>>0]|0)==116:0){e=a+2|0;if((e|0)==(c|0)){g=0;h=c}else{g=0;h=(b[e>>0]|0)==76?a+3|0:e}}else{g=1;h=a}e=vHc(h,c,d)|0;c=(e|0)==(h|0);if(!(g|c)){g=f[d+4>>2]|0;if((f[d>>2]|0)==(g|0))i=a;else{nGc(g+-24|0,0,518141)|0;i=e}}else i=c?a:e}else i=a;return i|0}function cIc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:do if((a|0)!=(c|0)){d=b[a>>0]|0;e=a+1|0;if(d<<24>>24!=95){if(((d<<24>>24)+-48|0)>>>0<10)f=e;else{g=a;break}while(1){if((f|0)==(c|0)){g=c;break a}if(((b[f>>0]|0)+-48|0)>>>0>=10){g=f;break a}f=f+1|0}}if((e|0)!=(c|0)){d=b[e>>0]|0;h=a+2|0;if(((d<<24>>24)+-48|0)>>>0>=10)if(d<<24>>24==95){d=h;do{i=d;d=d+1|0;if((i|0)==(c|0)){g=a;break a}j=b[i>>0]|0}while(((j<<24>>24)+-48|0)>>>0<10);return (j<<24>>24==95?d:a)|0}else g=a;else g=h}else g=a}else g=a;while(0);return g|0}function dIc(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)!=(c|0)){d=b[c+11>>0]|0;e=d<<24>>24<0;qHc(a,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)}return}function eIc(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=dGc(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=21;etc(e,519238,21)|0;b[d>>0]=0;_tc(e+21|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function fIc(a,b){a=a|0;b=b|0;f[a>>2]=f[b>>2];return}function gIc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+20|0;e=c;g=a+4|0;h=((f[g>>2]|0)-(f[a>>2]|0)>>4)+1|0;i=iIc(a)|0;if(i>>>0<h>>>0)mCc(a);else{j=f[a>>2]|0;k=(f[a+8>>2]|0)-j|0;l=k>>3;jIc(e,k>>4>>>0<i>>>1>>>0?(l>>>0<h>>>0?h:l):i,(f[g>>2]|0)-j>>4,a+12|0);j=e+8|0;g=f[j>>2]|0;fIc(d,b);f[g>>2]=0;f[g+4>>2]=0;b=f[d>>2]|0;f[g+8>>2]=0;f[g+12>>2]=b;f[j>>2]=g+16;kIc(a,e);lIc(e);u=c;return}}function hIc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;a:do if((a|0)==(c|0))e=a;else{f=a+1|0;switch(b[a>>0]|0){case 88:{g=OGc(f,c,d)|0;if((g|0)==(f|0)|(g|0)==(c|0)){e=a;break a}e=(b[g>>0]|0)==69?g+1|0:a;break a;break}case 74:{if((f|0)==(c|0)){e=a;break a}else h=f;while(1){if((b[h>>0]|0)==69)break;g=hIc(h,c,d)|0;if((g|0)==(h|0)){e=a;break a}else h=g}e=h+1|0;break a;break}case 76:{if((f|0)!=(c|0)?(b[f>>0]|0)==90:0){g=a+2|0;i=hGc(g,c,d)|0;if((i|0)==(g|0)|(i|0)==(c|0)){e=a;break a}e=(b[i>>0]|0)==69?i+1|0:a;break a}e=RGc(a,c,d)|0;break a;break}default:{e=kGc(a,c,d)|0;break a}}}while(0);return e|0}function iIc(a){a=a|0;return 268435455}function jIc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=mIc(d,b)|0;f[a>>2]=e;d=e+(c<<4)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b<<4);return}function kIc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=f[e>>2]|0;i=h+-16|0;j=g+-16|0;f[i>>2]=0;k=h+-12|0;f[k>>2]=0;l=f[g+-4>>2]|0;f[h+-8>>2]=0;f[h+-4>>2]=l;f[i>>2]=f[j>>2];i=g+-12|0;f[k>>2]=f[i>>2];k=g+-8|0;f[h+-8>>2]=f[k>>2];f[k>>2]=0;f[i>>2]=0;f[j>>2]=0;f[e>>2]=(f[e>>2]|0)+-16;g=j}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function lIc(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;YFc(e)}c=f[a>>2]|0;if(c|0)bGc(f[a+16>>2]|0,c,(f[a+12>>2]|0)-c>>4);return}function mIc(a,b){a=a|0;b=b|0;return UHc(f[a>>2]|0,b<<4)|0}function nIc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=2;etc(a,519263,2)|0;b[d>>0]=0;_tc(a+2|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function oIc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+11|0;h=b[g>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=j>>>0<11?j:11;l=j;m=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=j>>>0<11?j:11;l=j;m=10}if((k-l+m|0)>>>0<c>>>0)cGc(a,m,l+c-k-m|0,l,0,k,c,519266);else{if(i)n=f[a>>2]|0;else n=a;do if((k|0)!=(c|0)){i=l-k|0;if(!i){o=k;p=0;q=519266;r=c;s=17}else{if(k>>>0>c>>>0){kEc(n,519266,c)|0;kEc(n+c|0,n+k|0,i)|0;t=k;v=c;break}do if(n>>>0<519266>>>0&(n+l|0)>>>0>519266>>>0)if((n+k|0)>>>0>519266>>>0){kEc(n,519266,k)|0;w=0;x=k;y=519266+c|0;z=c-k|0;break}else{w=k;x=0;y=519266+(c-k)|0;z=c;break}else{w=k;x=0;y=519266;z=c}while(0);m=n+x|0;kEc(m+z|0,m+w|0,i)|0;o=w;p=x;q=y;r=z;s=17}}else{o=c;p=0;q=519266;r=c;s=17}while(0);if((s|0)==17){kEc(n+p|0,q,r)|0;t=o;v=r}r=v-t+l|0;if((b[g>>0]|0)<0)f[a+4>>2]=r;else b[g>>0]=r;b[e>>0]=0;_tc(n+r|0,e)}u=d;return}function pIc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=f[a+4>>2]|0;else l=j&255;if(l>>>0<c>>>0)eEc(a);if(k)m=(f[a+8>>2]&2147483647)+-1|0;else m=10;j=l+e|0;if((m-l|0)>>>0>=e>>>0){if(e|0){if(k)n=f[a>>2]|0;else n=a;k=l-c|0;o=n+c|0;if(!k)p=d;else{kEc(o+e|0,o,k)|0;p=o>>>0<=d>>>0&(n+l|0)>>>0>d>>>0?d+e|0:d}kEc(o,p,e)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;b[h>>0]=0;_tc(n+j|0,h)}}else cGc(a,m,j-m|0,l,c,0,e,d);u=g;return a|0}function qIc(a){a=a|0;return 268435455}function rIc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=uIc(d,b)|0;f[a>>2]=e;d=e+(c<<4)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b<<4);return}function sIc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=f[e>>2]|0;i=h+-16|0;j=g+-16|0;f[i>>2]=0;k=h+-12|0;f[k>>2]=0;l=f[g+-4>>2]|0;f[h+-8>>2]=0;f[h+-4>>2]=l;f[i>>2]=f[j>>2];i=g+-12|0;f[k>>2]=f[i>>2];k=g+-8|0;f[h+-8>>2]=f[k>>2];f[k>>2]=0;f[i>>2]=0;f[j>>2]=0;f[e>>2]=(f[e>>2]|0)+-16;g=j}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function tIc(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;SFc(e)}c=f[a>>2]|0;if(c|0)ZFc(f[a+16>>2]|0,c,(f[a+12>>2]|0)-c>>4);return}function uIc(a,b){a=a|0;b=b|0;return UHc(f[a>>2]|0,b<<4)|0}function vIc(a){a=a|0;var b=0;if(!(PHc(a)|0))mCc(a);else{b=THc(a+12|0,1)|0;f[a+4>>2]=b;f[a>>2]=b;f[a+8>>2]=b+24;return}}function wIc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=a+11|0;g=b[e>>0]|0;if(g<<24>>24<0){h=f[a>>2]|0;i=f[a+4>>2]|0}else{h=a;i=g&255}j=(i|0)!=0&1;k=i-j|0;if(!k)l=g;else{kEc(h,h+j|0,k)|0;l=b[e>>0]|0}if(l<<24>>24<0)f[a+4>>2]=k;else b[e>>0]=k;b[d>>0]=0;_tc(h+k|0,d);u=c;return}function xIc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=7;etc(a,519039,7)|0;b[d>>0]=0;_tc(a+7|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function yIc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=3;etc(a,c,3)|0;b[e>>0]=0;_tc(a+3|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function zIc(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=dGc(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=18;etc(e,519459,18)|0;b[d>>0]=0;_tc(e+18|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function AIc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=8;etc(a,c,8)|0;b[e>>0]=0;_tc(a+8|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function BIc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=6;etc(a,519452,6)|0;b[d>>0]=0;_tc(a+6|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function CIc(a,b){a=a|0;b=b|0;f[a>>2]=b;f[a+4>>2]=f[b>>2];return}function DIc(a,c){a=a|0;c=c|0;f[a>>2]=c;b[a+4>>0]=b[c>>0]|0;return}function EIc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+64|0;g=e+60|0;h=e+48|0;i=e+36|0;j=e+24|0;k=e+12|0;l=e;a:do if((c-a|0)>2){m=a+2|0;n=a+1|0;switch(b[a>>0]|0){case 84:break;case 71:{switch(b[n>>0]|0){case 86:{o=JGc(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}nGc(r+-24|0,0,519677)|0;p=o;q=60;break a;break}case 82:{o=JGc(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}nGc(r+-24|0,0,519697)|0;p=o;q=60;break a;break}default:{p=a;q=60;break a}}break}default:{p=a;q=60;break a}}switch(b[n>>0]|0){case 86:{o=kGc(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}nGc(r+-24|0,0,519526)|0;p=o;q=60;break a;break}case 84:{o=kGc(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}nGc(r+-24|0,0,519538)|0;p=o;q=60;break a;break}case 73:{o=kGc(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}nGc(r+-24|0,0,519547)|0;p=o;q=60;break a;break}case 83:{o=kGc(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}nGc(r+-24|0,0,519561)|0;p=o;q=60;break a;break}case 99:{o=HIc(m,c)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=HIc(o,c)|0;if((r|0)==(o|0)){p=a;q=60;break a}o=hGc(r,c,d)|0;if((o|0)==(r|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}nGc(r+-24|0,0,519580)|0;p=o;q=60;break a;break}case 67:{o=kGc(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=NGc(o,c)|0;if((r|0)==(o|0)|(r|0)==(c|0)){p=a;q=60;break a}if((b[r>>0]|0)!=95){p=a;q=60;break a}o=r+1|0;r=kGc(o,c,d)|0;if((r|0)==(o|0)){p=a;q=60;break a}o=d+4|0;t=f[o>>2]|0;if(((t-(f[d>>2]|0)|0)/24|0)>>>0<2){s=a;break a}CGc(h,t+-24|0);t=f[o>>2]|0;v=t+-24|0;w=t;while(1){if((w|0)==(v|0))break;t=w+-24|0;f[o>>2]=t;RFc(t);w=f[o>>2]|0}nGc(h,0,519607)|0;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];w=0;while(1){if((w|0)==3)break;f[h+(w<<2)>>2]=0;w=w+1|0}oGc(k,519632)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];w=0;while(1){if((w|0)==3)break;f[k+(w<<2)>>2]=0;w=w+1|0}CGc(l,(f[o>>2]|0)+-24|0);w=b[l+11>>0]|0;v=w<<24>>24<0;UFc(j,v?f[l>>2]|0:l,v?f[l+4>>2]|0:w&255)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];w=0;while(1){if((w|0)==3)break;f[j+(w<<2)>>2]=0;w=w+1|0}w=f[o>>2]|0;v=w+-24|0;t=v+11|0;if((b[t>>0]|0)<0){x=f[v>>2]|0;b[g>>0]=0;_tc(x,g);f[w+-20>>2]=0}else{b[g>>0]=0;_tc(v,g);b[t>>0]=0}PGc(v);f[v>>2]=f[i>>2];f[v+4>>2]=f[i+4>>2];f[v+8>>2]=f[i+8>>2];v=0;while(1){if((v|0)==3)break;f[i+(v<<2)>>2]=0;v=v+1|0}gGc(i);gGc(l);gGc(j);gGc(k);gGc(h);p=r;q=60;break a;break}default:{v=HIc(n,c)|0;do if((v|0)!=(n|0)){o=hGc(v,c,d)|0;if((o|0)!=(v|0)){t=f[d+4>>2]|0;if((f[d>>2]|0)!=(t|0)){w=t+-24|0;if((b[m>>0]|0)==118){nGc(w,0,519637)|0;y=0;z=o;break}else{nGc(w,0,519655)|0;y=0;z=o;break}}else{y=1;z=a}}else{y=0;z=a}}else{y=3;z=a}while(0);switch(y&3){case 3:case 0:{p=z;q=60;break a;break}default:{}}if(!y){p=z;q=60;break a}else{s=a;break a}}}}else{p=a;q=60}while(0);if((q|0)==60)s=p;u=e;return s|0}function FIc(a){a=a|0;b[f[a>>2]>>0]=b[a+4>>0]|0;return}function GIc(a){a=a|0;f[f[a>>2]>>2]=f[a+4>>2];return}function HIc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;a:do if((a|0)!=(c|0)){d=a+1|0;switch(b[a>>0]|0){case 104:{e=NGc(d,c)|0;if((e|0)==(d|0)|(e|0)==(c|0)){f=a;break a}return ((b[e>>0]|0)==95?e+1|0:a)|0}case 118:break;default:{f=a;break a}}e=NGc(d,c)|0;if((!((e|0)==(d|0)|(e|0)==(c|0))?(b[e>>0]|0)==95:0)?(d=e+1|0,e=NGc(d,c)|0,!((e|0)==(d|0)|(e|0)==(c|0))):0)f=(b[e>>0]|0)==95?e+1|0:a;else f=a}else f=a;while(0);return f|0}function IIc(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function JIc(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b>>2]|0;f[a+8>>2]=0;f[a+12>>2]=c;return}function KIc(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function LIc(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b>>2]|0;f[a+8>>2]=0;f[a+12>>2]=c;return}function MIc(a){a=a|0;var c=0;if((b[a>>0]|0)==1)c=0;else{b[a>>0]=1;c=1}return c|0}function NIc(a){a=a|0;return}function OIc(a){a=a|0;return}function PIc(){var a=0;a=f[221791]|0;f[221791]=a+0;return a|0}function QIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=hj[f[(f[a>>2]|0)+16>>2]&511](a,b,e)|0;if(g)f[c>>2]=f[e>>2];u=d;return g&1|0}function RIc(a){a=a|0;var b=0;if(!a)b=0;else b=(bFc(a,23640,23760,0)|0)!=0;return b&1|0}function SIc(){}function TIc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return (J=e,a-c>>>0|0)|0}function UIc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return (J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function VIc(a){a=a|0;return 0}function WIc(a){a=a|0;return 0}function XIc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=a+d|0;c=c&255;if((d|0)>=67){while(a&3){b[a>>0]=c;a=a+1|0}g=e&-4|0;h=g-64|0;i=c|c<<8|c<<16|c<<24;while((a|0)<=(h|0)){f[a>>2]=i;f[a+4>>2]=i;f[a+8>>2]=i;f[a+12>>2]=i;f[a+16>>2]=i;f[a+20>>2]=i;f[a+24>>2]=i;f[a+28>>2]=i;f[a+32>>2]=i;f[a+36>>2]=i;f[a+40>>2]=i;f[a+44>>2]=i;f[a+48>>2]=i;f[a+52>>2]=i;f[a+56>>2]=i;f[a+60>>2]=i;a=a+64|0}while((a|0)<(g|0)){f[a>>2]=i;a=a+4|0}}while((a|0)<(e|0)){b[a>>0]=c;a=a+1|0}return e-d|0}function YIc(a){a=a|0;var c=0;c=b[w+(a&255)>>0]|0;if((c|0)<8)return c|0;c=b[w+(a>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=b[w+(a>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (b[w+(a>>>24)>>0]|0)+24|0}function ZIc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=a;h=b;i=h;j=c;k=d;l=k;if(!i){m=(e|0)!=0;if(!l){if(m){f[e>>2]=(g>>>0)%(j>>>0);f[e+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return (J=n,o)|0}else{if(!m){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=b&0;n=0;o=0;return (J=n,o)|0}}m=(l|0)==0;do if(j){if(!m){p=($(l|0)|0)-($(i|0)|0)|0;if(p>>>0<=31){q=p+1|0;r=31-p|0;s=p-31>>31;t=q;u=g>>>(q>>>0)&s|i<<r;v=i>>>(q>>>0)&s;w=0;x=g<<r;break}if(!e){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=h|b&0;n=0;o=0;return (J=n,o)|0}r=j-1|0;if(r&j|0){s=($(j|0)|0)+33-($(i|0)|0)|0;q=64-s|0;p=32-s|0;y=p>>31;z=s-32|0;A=z>>31;t=s;u=p-1>>31&i>>>(z>>>0)|(i<<p|g>>>(s>>>0))&A;v=A&i>>>(s>>>0);w=g<<q&y;x=(i<<q|g>>>(z>>>0))&y|g<<p&s-33>>31;break}if(e|0){f[e>>2]=r&g;f[e+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return (J=n,o)|0}else{r=YIc(j|0)|0;n=i>>>(r>>>0)|0;o=i<<32-r|g>>>(r>>>0)|0;return (J=n,o)|0}}else{if(m){if(e|0){f[e>>2]=(i>>>0)%(j>>>0);f[e+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return (J=n,o)|0}if(!g){if(e|0){f[e>>2]=0;f[e+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return (J=n,o)|0}r=l-1|0;if(!(r&l)){if(e|0){f[e>>2]=a|0;f[e+4>>2]=r&i|b&0}n=0;o=i>>>((YIc(l|0)|0)>>>0);return (J=n,o)|0}r=($(l|0)|0)-($(i|0)|0)|0;if(r>>>0<=30){s=r+1|0;p=31-r|0;t=s;u=i<<p|g>>>(s>>>0);v=i>>>(s>>>0);w=0;x=g<<p;break}if(!e){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=h|b&0;n=0;o=0;return (J=n,o)|0}while(0);if(!t){B=x;C=w;D=v;E=u;F=0;G=0}else{b=c|0|0;c=k|d&0;d=UIc(b|0,c|0,-1,-1)|0;k=J;h=x;x=w;w=v;v=u;u=t;t=0;do{a=h;h=x>>>31|h<<1;x=t|x<<1;g=v<<1|a>>>31|0;a=v>>>31|w<<1|0;TIc(d|0,k|0,g|0,a|0)|0;i=J;l=i>>31|((i|0)<0?-1:0)<<1;t=l&1;v=TIc(g|0,a|0,l&b|0,(((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1)&c|0)|0;w=J;u=u-1|0}while((u|0)!=0);B=h;C=x;D=w;E=v;F=0;G=t}t=C;C=0;if(e|0){f[e>>2]=E;f[e+4>>2]=D}n=(t|0)>>>31|(B|C)<<1|(C<<1|t>>>31)&0|F;o=(t<<1|0>>>31)&-2|G;return (J=n,o)|0}function _Ic(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e|0;h=b>>31|((b|0)<0?-1:0)<<1;i=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;j=d>>31|((d|0)<0?-1:0)<<1;k=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;l=TIc(h^a|0,i^b|0,h|0,i|0)|0;b=J;ZIc(l,b,TIc(j^c|0,k^d|0,j|0,k|0)|0,J,g)|0;k=TIc(f[g>>2]^h|0,f[g+4>>2]^i|0,h|0,i|0)|0;i=J;u=e;return (J=i,k)|0}function $Ic(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function aJc(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function bJc(a){a=a|0;return 0}function cJc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ZIc(a,b,c,d,0)|0}function dJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if((d|0)>=8192)return Sd(a|0,c|0,d|0)|0;e=a|0;g=a+d|0;if((a&3)==(c&3)){while(a&3){if(!d)return e|0;b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0;d=d-1|0}h=g&-4|0;d=h-64|0;while((a|0)<=(d|0)){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[a+36>>2]=f[c+36>>2];f[a+40>>2]=f[c+40>>2];f[a+44>>2]=f[c+44>>2];f[a+48>>2]=f[c+48>>2];f[a+52>>2]=f[c+52>>2];f[a+56>>2]=f[c+56>>2];f[a+60>>2]=f[c+60>>2];a=a+64|0;c=c+64|0}while((a|0)<(h|0)){f[a>>2]=f[c>>2];a=a+4|0;c=c+4|0}}else{h=g-4|0;while((a|0)<(h|0)){b[a>>0]=b[c>>0]|0;b[a+1>>0]=b[c+1>>0]|0;b[a+2>>0]=b[c+2>>0]|0;b[a+3>>0]=b[c+3>>0]|0;a=a+4|0;c=c+4|0}}while((a|0)<(g|0)){b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}return e|0}function eJc(a){a=a|0;var b=0,c=0;a=a+15&-16|0;b=f[r>>2]|0;c=b+a|0;if((a|0)>0&(c|0)<(b|0)|(c|0)<0){ea()|0;qe(12);return -1}f[r>>2]=c;if((c|0)>(da()|0)?(ca()|0)==0:0){f[r>>2]=b;qe(12);return -1}return b|0}function fJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;if((c|0)<(a|0)&(a|0)<(c+d|0)){e=a;c=c+d|0;a=a+d|0;while((d|0)>0){a=a-1|0;c=c-1|0;d=d-1|0;b[a>>0]=b[c>>0]|0}a=e}else dJc(a,c,d)|0;return a|0}function gJc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e|0;ZIc(a,b,c,d,g)|0;u=e;return (J=f[g+4>>2]|0,f[g>>2]|0)|0}function hJc(a){a=a|0;return (a&255)<<24|(a>>8&255)<<16|(a>>16&255)<<8|a>>>24|0}function iJc(a,b,c){a=a|0;b=b|0;c=c|0;c=$(b)|0;if((c|0)==32)c=c+($(a)|0)|0;J=0;return c|0}function jJc(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function kJc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=TIc(e^a|0,f^b|0,e|0,f|0)|0;b=J;a=g^e;e=h^f;return TIc((ZIc(i,b,TIc(g^c|0,h^d|0,g|0,h|0)|0,J,0)|0)^a|0,J^e|0,a|0,e|0)|0}function lJc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=Y(d,c)|0;f=a>>>16;a=(e>>>16)+(Y(d,f)|0)|0;d=b>>>16;b=Y(d,c)|0;return (J=(a>>>16)+(Y(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function mJc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=lJc(e,a)|0;f=J;return (J=(Y(b,a)|0)+(Y(d,e)|0)+f|f&0,c|0|0)|0}function nJc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return rg[a&3](b|0,c|0,d|0,e|0,f|0,+g)|0}function oJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;sg[a&1](b|0,c|0,d|0,e|0,+f,+g,+h)}function pJc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;tg[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)}function qJc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;ug[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)}function rJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;vg[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0)}function sJc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;wg[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i)}function tJc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xg[a&127](b|0,c|0,d|0,e|0,f|0,g|0)|0}function uJc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;yg[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0,l|0)}function vJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;zg[a&7](b|0,c|0,d|0,e|0,+f,+g,h|0)}function wJc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;Ag[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0)}function xJc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;Bg[a&3](b|0,c|0,+d,e|0,f|0,g|0)}function yJc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;Cg[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)}function zJc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;Dg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l)}function AJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;Eg[a&1](b|0,c|0,d|0,+e,+f,+g,+h)}function BJc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;return Fg[a&1](b|0,+c,d|0)|0}function CJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;Gg[a&3](b|0,c|0,+d,+e,f|0,+g,+h)}function DJc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;Hg[a&7](b|0,+c,d|0)}function EJc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;Ig[a&3](b|0,c|0,+d,+e,f|0,g|0)}function FJc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;Jg[a&3](b|0,c|0,+d,+e,f|0,+g)}function GJc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;return Kg[a&1](b|0,c|0,d|0,+e,f|0)|0}function HJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;Lg[a&15](b|0,c|0,d|0,e|0,f|0,+g,h|0)}function IJc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;Mg[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i,+j)}function JJc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;Ng[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,k|0)}function KJc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;Og[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j)}function LJc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=+k;Pg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,+k)}function MJc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;Qg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0)}function NJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Rg[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0)}function OJc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;return Sg[a&1](b|0,c|0,d|0,+e,+f)|0}function PJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;Tg[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h)}function QJc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;k=k|0;Ug[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j,k|0)}function RJc(a,b){a=a|0;b=b|0;return +Vg[a&31](b|0)}function SJc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;Wg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0)}function TJc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;return Xg[a&1](b|0,c|0,d|0,+e,+f,g|0)|0}function UJc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;Yg[a&3](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j,k|0)}function VJc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;Zg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,k|0,+l)}function WJc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;_g[a&3](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0)}function XJc(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;$g[a&1](+b,c|0,d|0)}function YJc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return +ah[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function ZJc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;k=k|0;return bh[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j,k|0)|0}function _Jc(a,b,c){a=a|0;b=b|0;c=c|0;return +ch[a&31](b|0,c|0)}function $Jc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;dh[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,j|0)}function aKc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;eh[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,+j)}function bKc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;fh[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j)}function cKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;return gh[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i)|0}function dKc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hh[a&127](b|0,c|0,d|0,e|0)|0}function eKc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;ih[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0,l|0)}function fKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;jh[a&1](b|0,c|0,d|0,+e,+f,+g,h|0)}function gKc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;kh[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k)}function hKc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return lh[a&7](b|0,c|0,d|0,+e)|0}function iKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;return mh[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0,+i)|0}function jKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return nh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function kKc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return oh[a&1](b|0,c|0,+d,+e,f|0)|0}function lKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;ph[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0)}function mKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=+h;qh[a&1](b|0,c|0,+d,+e,f|0,g|0,+h)}function nKc(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;k=+k;l=l|0;m=m|0;n=n|0;return rh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0,+k,l|0,m|0,n|0)|0}function oKc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;sh[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0)}function pKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;th[a&1](b|0,c|0,+d,e|0,f|0,g|0,+h)}function qKc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;uh[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0)}function rKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;vh[a&3](b|0,c|0,+d,e|0,f|0,g|0,h|0)}function sKc(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;wh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l,+m,n|0)}function tKc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;return +xh[a&1](b|0,c|0,d|0,+e,+f,g|0)}function uKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;i=i|0;yh[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0,i|0)}function vKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return +zh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function wKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=+i;Ah[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,+i)}function xKc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Bh[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0,j|0)}function yKc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return Ch[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function zKc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;Dh[a&15](b|0,c|0,d|0,e|0,f|0,+g)}function AKc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;k=k|0;Eh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0,k|0)}function BKc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b|0,c|0,d|0,e|0,f|0,g|0)}function CKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;Gh[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0)}function DKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;Hh[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0)}function EKc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;Ih[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0)}function FKc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;Jh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0)}function GKc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Kh[a&15](b|0,c|0,d|0,+e,+f)}function HKc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;Lh[a&7](b|0,c|0,d|0,+e,f|0)}function IKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;return Mh[a&3](b|0,c|0,+d,e|0,f|0,g|0,h|0)|0}function JKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;Nh[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i)}function KKc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Oh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function LKc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;return Ph[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j)|0}function MKc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +Qh[a&1](b|0,c|0,+d,+e,f|0)}function NKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;return Rh[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0)|0}function OKc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +Sh[a&31](b|0,c|0,d|0)}function PKc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;Th[a&3](b|0,c|0,d|0,+e,+f,+g)}function QKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Uh[a&3](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0)}function RKc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;return Vh[a&1](b|0,c|0,+d,+e,f|0,g|0)|0}function SKc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;Wh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i)}function TKc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;Xh[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0,+j,k|0)}function UKc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;Yh[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,j|0,+k)}function VKc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Zh[a&7](b|0,c|0,d|0,+e,+f,g|0)}function WKc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _h[a&127](b|0,c|0,d|0,e|0,f|0)|0}function XKc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[a&63](b|0,c|0,d|0,+e)}function YKc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;return ai[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0)|0}function ZKc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;bi[a&3](b|0,c|0,+d,e|0,f|0)}function _Kc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return ci[a&7](b|0,c|0,d|0,e|0,+f)|0}function $Kc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;di[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0)}function aLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b|0,c|0,d|0,e|0)}function bLc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;fi[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0,+i)}function cLc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b|0,c|0,d|0,e|0,f|0)}function dLc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;return hi[a&1](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)|0}function eLc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;ii[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function fLc(a,b,c){a=a|0;b=b|0;c=+c;ji[a&31](b|0,+c)}function gLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;return ki[a&3](b|0,c|0,+d,e|0)|0}function hLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return li[a&3](b|0,c|0,+d,+e)|0}function iLc(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b|0,c|0)}function jLc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ni[a&31](b|0,c|0,d|0,e|0,+f)}function kLc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;oi[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0)}function lLc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return pi[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function mLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;qi[a&7](b|0,c|0,+d,+e)}function nLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ri[a&15](b|0,c|0,+d,e|0)}function oLc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;si[a&1](b|0,c|0,d|0,+e,f|0,g|0,+h,+i,j|0)}function pLc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;return ti[a&1](b|0,c|0,d|0,+e,f|0,g|0)|0}function qLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +ui[a&1](b|0,c|0,d|0,+e)}function rLc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;vi[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0)}function sLc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wi[a&255](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function tLc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;xi[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0,k|0)}function uLc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;yi[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i)}function vLc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;zi[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i,j|0)}function wLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +Ai[a&15](b|0,c|0,d|0,e|0)}function xLc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;Bi[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k,l|0)}function yLc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;k=+k;Ci[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j,+k)}function zLc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;Di[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,+m)}function ALc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;Ei[a&7](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0)}function BLc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;Fi[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j)}function CLc(a,b,c){a=a|0;b=b|0;c=+c;return Gi[a&1](b|0,+c)|0}function DLc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;Hi[a&1](b|0,c|0,d|0,+e,+f,g|0,+h)}function ELc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ii[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function FLc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;Ji[a&1](b|0,c|0,+d,e|0,+f,+g,h|0)}function GLc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Ki[a&7](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function HLc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Li[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function ILc(a,b,c){a=a|0;b=b|0;c=c|0;return Mi[a&1023](b|0,c|0)|0}function JLc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;Ni[a&7](b|0,c|0,+d,+e,f|0)}function KLc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;Oi[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0)}function LLc(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;Pi[a&1](+b,c|0,d|0,e|0)}function MLc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;Qi[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0)}function NLc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;Ri[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j)}function OLc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;Si[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0)}function PLc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b|0,c|0,d|0)}function QLc(a){a=a|0;Ui[a&255]()}function RLc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;Vi[a&31](b|0,c|0,+d)}function SLc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=+h;return Wi[a&1](b|0,c|0,+d,+e,f|0,g|0,+h)|0}function TLc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;Xi[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0)}function ULc(a,b){a=a|0;b=b|0;Yi[a&2047](b|0)}function VLc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;Zi[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0,+k,l|0)}function WLc(a,b){a=a|0;b=b|0;return _i[a&1023](b|0)|0}function XLc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;$i[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j,k|0)}function YLc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;aj[a&1](b|0,+c,d|0,+e,+f,g|0)}function ZLc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;bj[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i)}function _Lc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;cj[a&7](b|0,+c,d|0,e|0)}function $Lc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;return dj[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0)|0}function aMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ej[a&15](b|0,c|0,d|0,e|0,+f,g|0)}function bMc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;fj[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0)}function cMc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;gj[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0)}function dMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[a&511](b|0,c|0,d|0)|0}function eMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;ij[a&1](b|0,c|0,+d,e|0,+f,g|0,h|0)}function fMc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;jj[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i)}function gMc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;kj[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0)}function hMc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;lj[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i)}function iMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;return mj[a&7](b|0,c|0,+d)|0}function jMc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;nj[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,+k,+l)}function kMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;oj[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0)}function lMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return +pj[a&7](b|0,c|0,d|0,e|0,f|0)}function mMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return +qj[a&1](b|0,c|0,d|0,e|0,+f)}function nMc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;return rj[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0)|0}function oMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;return sj[a&1](b|0,c|0,d|0,e|0,+f,+g)|0}function pMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;tj[a&7](b|0,c|0,d|0,+e,f|0,g|0)}function qMc(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;return uj[a&0](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)|0}function rMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return vj[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function sMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;return wj[a&3](b|0,c|0,+d,e|0,f|0,g|0)|0}function tMc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return xj[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0)|0}function uMc(a){a=a|0;return yj[a&63]()|0}function vMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;return zj[a&3](b|0,c|0,+d,e|0,f|0)|0}function wMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return +Aj[a&3](b|0,c|0,d|0,e|0,f|0,g|0)}function xMc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Bj[a&3](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0)|0}function yMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Cj[a&1](b|0,+c,d|0,+e,+f,g|0,h|0)}function zMc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;Dj[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0,m|0)}function AMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;return Ej[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0)|0}function BMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;return Fj[a&1](b|0,c|0,d|0,e|0,f|0,+g,+h)|0}function CMc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;Gj[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0)}function DMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;Hj[a&1](b|0,c|0,+d,e|0,+f,g|0)}function EMc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ij[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function FMc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;i=i|0;Jj[a&1](b|0,c|0,+d,e|0,+f,+g,h|0,i|0)}function GMc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;Kj[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j)}function HMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;Lj[a&7](b|0,c|0,d|0,e|0,+f,+g)}function IMc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;Mj[a&1](b|0,+c,d|0,e|0,f|0)}function JMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aa(0);return 0}function KMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;aa(1)}function LMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;aa(2)}function MMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;aa(3)}function NMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;aa(4)}function OMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;aa(5)}function PMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(6);return 0}function QMc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;aa(7)}function RMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;aa(8)}function SMc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;aa(9)}function TMc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;aa(10)}function UMc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aa(11)}function VMc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;aa(12)}function WMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;aa(13)}function XMc(a,b,c){a=a|0;b=+b;c=c|0;aa(14);return 0}function YMc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;aa(15)}function ZMc(a,b,c){a=a|0;b=+b;c=c|0;aa(16)}function _Mc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;aa(17)}function $Mc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;aa(18)}function aNc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;aa(19);return 0}function bNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;aa(20)}function cNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;i=+i;aa(21)}function dNc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(22)}function eNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;aa(23)}function fNc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;aa(24)}function gNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;aa(25)}function hNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;aa(26)}function iNc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;aa(27);return 0}function jNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;aa(28)}function kNc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;aa(29)}function lNc(a){a=a|0;aa(30);return 0.0}function mNc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;aa(31)}function nNc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(32);return 0}function oNc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;aa(33)}function pNc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;aa(34)}function qNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;aa(35)}function rNc(a,b,c){a=+a;b=b|0;c=c|0;aa(36)}function sNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(37);return 0.0}function tNc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;aa(38);return 0}function uNc(a,b){a=a|0;b=b|0;aa(39);return 0.0}function vNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;aa(40)}function wNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;aa(41)}function xNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;aa(42)}function yNc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;aa(43);return 0}function zNc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(44);return 0}function ANc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aa(45)}function BNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;aa(46)}function CNc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;aa(47)}function DNc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(48);return 0}function ENc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;h=+h;aa(49);return 0}function FNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(50);return 0}function GNc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(51);return 0}function HNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;aa(52)}function INc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;aa(53)}function JNc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=+j;k=k|0;l=l|0;m=m|0;aa(54);return 0}function KNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;aa(55)}function LNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=+g;aa(56)}function MNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;aa(57)}function NNc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;aa(58)}function ONc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;m=m|0;aa(59)}function PNc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(60);return 0.0}function QNc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;aa(61)}function RNc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(62);return 0.0}function SNc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;aa(63)}function TNc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;aa(64)}function UNc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(65);return 0}function VNc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aa(66)}function WNc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;aa(67)}function XNc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(68)}function YNc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;aa(69)}function ZNc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;aa(70)}function _Nc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;aa(71)}function $Nc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;aa(72)}function aOc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;aa(73)}function bOc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;aa(74)}function cOc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;aa(75);return 0}function dOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;aa(76)}function eOc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(77)}function fOc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;aa(78);return 0}function gOc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(79);return 0.0}function hOc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;aa(80);return 0}function iOc(a,b,c){a=a|0;b=b|0;c=c|0;aa(81);return 0.0}function jOc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;aa(82)}function kOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(83)}function lOc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;aa(84);return 0}function mOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;aa(85)}function nOc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;aa(86)}function oOc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;aa(87)}function pOc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(88)}function qOc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(89);return 0}function rOc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(90)}function sOc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;aa(91);return 0}function tOc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;aa(92)}function uOc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(93);return 0}function vOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;aa(94)}function wOc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(95)}function xOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;h=+h;aa(96)}function yOc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(97)}function zOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;aa(98);return 0}function AOc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(99)}function BOc(a,b){a=a|0;b=+b;aa(100)}function COc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;aa(101);return 0}function DOc(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;aa(102);return 0}function EOc(a,b){a=a|0;b=b|0;aa(103)}function FOc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(104)}function GOc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;aa(105)}function HOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;aa(106);return 0}function IOc(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;aa(107)}function JOc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;aa(108)}function KOc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=+g;h=+h;i=i|0;aa(109)}function LOc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;aa(110);return 0}function MOc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(111);return 0.0}function NOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;aa(112)}function OOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(113)}function POc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(114)}function QOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;aa(115)}function ROc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;aa(116)}function SOc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(117);return 0.0}function TOc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;aa(118)}function UOc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;aa(119)}function VOc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;aa(120)}function WOc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;aa(121)}function XOc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;aa(122)}function YOc(a,b){a=a|0;b=+b;aa(123);return 0}function ZOc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;aa(124)}function _Oc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(125)}function $Oc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;aa(126)}function aPc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;aa(127)}function bPc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(128)}function cPc(a,b){a=a|0;b=b|0;aa(129);return 0}function dPc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(130)}function ePc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;aa(131)}function fPc(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;aa(132)}function gPc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;aa(133)}function hPc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;aa(134)}function iPc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;aa(135)}function jPc(a,b,c){a=a|0;b=b|0;c=c|0;aa(136)}function kPc(){aa(137)}function lPc(){zf()}function mPc(a,b,c){a=a|0;b=b|0;c=+c;aa(138)}function nPc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;aa(139);return 0}function oPc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(140)}function pPc(a){a=a|0;aa(141)}function qPc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;aa(142)}function rPc(a){a=a|0;aa(143);return 0}function sPc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;aa(144)}function tPc(a,b,c,d,e,f){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;aa(145)}function uPc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;aa(146)}function vPc(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;aa(147)}function wPc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;aa(148);return 0}function xPc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;aa(149)}function yPc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;aa(150)}function zPc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(151)}function APc(a,b,c){a=a|0;b=b|0;c=c|0;aa(152);return 0}function BPc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;g=g|0;aa(153)}function CPc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;aa(154)}function DPc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;aa(155)}function EPc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;aa(156)}function FPc(a,b,c){a=a|0;b=b|0;c=+c;aa(157);return 0}function GPc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;aa(158)}function HPc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;aa(159)}function IPc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(160);return 0.0}function JPc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(161);return 0.0}function KPc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;aa(162);return 0}function LPc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;aa(163);return 0}function MPc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;aa(164)}function NPc(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;aa(165);return 0}function OPc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;aa(166);return 0}function PPc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;aa(167);return 0}function QPc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(168);return 0}function RPc(){aa(169);return 0}function SPc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;aa(170);return 0}function TPc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(171);return 0.0}function UPc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(172);return 0}function VPc(a,b,c,d,e,f,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;g=g|0;aa(173)}function WPc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;aa(174)}function XPc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;aa(175);return 0}function YPc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;aa(176);return 0}function ZPc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;aa(177)}function _Pc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;aa(178)}function $Pc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(179);return 0}function aQc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;aa(180)}function bQc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;aa(181)}function cQc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;aa(182)}function dQc(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;aa(183)}

// EMSCRIPTEN_END_FUNCS
var rg=[JMc,mAc,sAc,JMc];var sg=[KMc,eB];var tg=[LMc,fQb,Iq,xu,BJ,$u,LMc,LMc];var ug=[MMc,kB,sm,Lv];var vg=[NMc,gQb,Qs,Ku];var wg=[OMc,qs];var xg=[PMc,vP,wP,xP,yP,zP,AP,BP,CP,DP,EP,FP,GP,HP,IP,JP,KP,LP,MP,NP,OP,PP,G2,H2,I2,J2,K2,L2,M2,yqa,bbc,cbc,wvc,xvc,yvc,zvc,Avc,Bvc,Cvc,Dvc,Evc,Fvc,Gvc,qwc,rwc,swc,twc,uwc,vwc,wwc,xwc,ywc,zwc,Awc,Twc,Vwc,ixc,kxc,vxc,wxc,xxc,yxc,zxc,gyc,hyc,iyc,jyc,kyc,nAc,tAc,ly,yn,kC,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc,PMc];var yg=[QMc,UC];var zg=[RMc,YA,_A,nm,FB,wD,cu,RMc];var Ag=[SMc,bm];var Bg=[TMc,Nr,sv,TMc];var Cg=[UMc,VB,NC,UMc];var Dg=[VMc,gn];var Eg=[WMc,cm];var Fg=[XMc,cG];var Gg=[YMc,hm,km,YMc];var Hg=[ZMc,Thc,Uhc,Gq,Fs,ZMc,ZMc,ZMc];var Ig=[_Mc,Ul,xq,mt];var Jg=[$Mc,im,lm,$Mc];var Kg=[aNc,JG];var Lg=[bNc,sC,Vo,Xo,mE,pF,MH,lJ,Gu,bNc,bNc,bNc,bNc,bNc,bNc,bNc];var Mg=[cNc,fm];var Ng=[dNc,yD];var Og=[eNc,uB];var Pg=[fNc,tD];var Qg=[gNc,uE];var Rg=[hNc,VA,sp,gE];var Sg=[iNc,WK];var Tg=[jNc,lB,tm,Mv];var Ug=[kNc,$t];var Vg=[lNc,tya,qDa,sDa,uDa,wDa,yDa,ADa,CDa,IDa,jEa,yEa,IEa,KGb,aHb,DHb,FHb,LHb,tKb,Cn,Wn,sq,lNc,lNc,lNc,lNc,lNc,lNc,lNc,lNc,lNc,lNc];var Wg=[mNc,tJ];var Xg=[nNc,VK];var Yg=[oNc,hQb,os,oNc];var Zg=[pNc,xD];var _g=[qNc,uD,zD,qNc];var $g=[rNc,mo];var ah=[sNc,iD,Np,ND];var bh=[tNc,AI];var ch=[uNc,iNb,yNb,Rfc,bgc,dk,rz,zz,Hz,Pz,Xz,cA,kA,oA,wA,AA,Jm,Bn,mC,Lp,rq,vq,pr,wF,iG,OG,qH,cK,uNc,uNc,uNc,uNc];var dh=[vNc,wp];var eh=[wNc,qp];var fh=[xNc,ps];var gh=[yNc,CI];var hh=[zNc,TS,v_,U2,V2,W2,X2,Y2,wqa,xqa,Nnb,tob,t8b,bac,cac,nac,pac,qac,rac,sac,tac,wac,yac,zac,Aac,Mac,Xac,ebc,gbc,Bec,Mec,Oec,Xec,ifc,yfc,Kfc,Wfc,ggc,sgc,Egc,Qgc,ABc,XBc,YBc,ZBc,dCc,iy,jy,ny,zy,Py,Ry,Al,Uy,Dl,Xy,Gl,_y,Jl,bz,Ml,Pl,Ql,OA,gw,ax,ux,Kx,_x,vn,hC,An,SC,aD,rD,mr,CE,SE,VE,aF,GI,XI,NJ,hK,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc,zNc];var ih=[ANc,oOb,Cu,ANc];var jh=[BNc,Jo];var kh=[CNc,mF];var lh=[DNc,Hy,ww,Mw,KG,RK,DNc,DNc];var mh=[ENc,AH];var nh=[FNc,Tyc,Zyc,Wzc,Xzc,dAc,eAc,jC];var oh=[GNc,vH];var ph=[HNc,wq];var qh=[INc,lt];var rh=[JNc,fF];var sh=[KNc,Ho];var th=[LNc,Cm];var uh=[MNc,nOb,Hq,wu,AJ,MNc,MNc,MNc];var vh=[NNc,Mr,rv,NNc];var wh=[ONc,CN,zN,AN,BN,ONc,ONc,ONc];var xh=[PNc,EE];var yh=[QNc,nD];var zh=[RNc,MD];var Ah=[SNc,yB];var Bh=[TNc,am];var Ch=[UNc,wK];var Dh=[VNc,mB,um,an,Yo,qF,NH,mJ,Hu,VNc,VNc,VNc,VNc,VNc,VNc,VNc];var Eh=[WNc,bB];var Fh=[XNc,VN,WN,XN,YN,ZN,_N,$N,ON,PN,QN,RN,SN,TN,UN,UQ,VQ,WQ,XQ,O1,vda,wda,xda,yda,zda,Oia,Kia,Gia,Cia,yia,uia,qia,mia,iia,eia,Vma,Oma,Ima,Cma,wma,qma,kma,ema,_la,Ula,Ola,Ila,Gsa,Esa,Nsa,Lsa,Usa,Ssa,$sa,Zsa,hta,fta,ota,mta,vta,tta,Cta,Ata,Jta,Hta,Qta,Ota,Yta,Wta,$ta,hua,fua,kua,oua,GIa,Usc,zGb,VGb,aIb,GIb,kKb,VKb,eQb,jQb,Dac,Fac,Yhc,Zhc,ktc,zAc,EAc,WEc,dFc,EFc,sB,zm,zB,IB,Zm,OB,en,mn,_B,qn,cC,$n,wC,go,zC,qo,IC,KC,Do,YC,Qo,eD,$o,hD,zp,Qp,QD,TD,kq,Uq,_q,sE,hr,xE,FE,Dr,JE,Hr,gt,iH,Ft,VH,Ht,XH,_H,yJ,cO,bO,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc,XNc];var Gh=[YNc,mOb,Ju,YNc];var Hh=[ZNc,cD,fr,wJ];var Ih=[_Nc,uJ];var Jh=[$Nc,WC];var Kh=[aOc,Wj,XA,Yl,_l,em,Lm,up,cr,Kv,aOc,aOc,aOc,aOc,aOc,aOc];var Lh=[bOc,DB,io,nq,Ss,Bt,Pt,Mu];var Mh=[cOc,ME,zK,cOc];var Nh=[dOc,gm];var Oh=[eOc,FS,hn,WB,EC,xo,OC,eOc];var Ph=[fOc,BI];var Qh=[gOc,vr];var Rh=[hOc,DI];var Sh=[iOc,AO,BO,CO,DO,EO,FO,GO,X9b,Y9b,Gy,dz,hz,EB,un,ep,Kp,KD,qq,cE,uq,eE,Dq,or,iOc,iOc,iOc,iOc,iOc,iOc,iOc,iOc];var Th=[jOc,dm,gp,jOc];var Uh=[kOc,Lr,qv,kOc];var Vh=[lOc,uH];var Wh=[mOc,iB];var Xh=[nOc,fn];var Yh=[oOc,vp];var Zh=[pOc,WA,Xl,Zl,Km,tp,br,Jv];var _h=[qOc,RO,SO,TO,UO,VO,WO,XO,YO,ZO,_O,$O,aP,bP,cP,dP,eP,fP,gP,hP,iP,jP,E6,F6,G6,H6,I6,J6,K6,gFa,cGa,mpb,ypb,Npb,aqb,zqb,grb,urb,Hrb,Xrb,wsb,Lsb,$sb,ptb,Ftb,Vtb,jub,zub,Pub,hvb,wvb,Mvb,Vvb,awb,mwb,Bwb,Wwb,dxb,pxb,Kxb,Gyb,Syb,_yb,jzb,zzb,Rzb,Zzb,pAb,EAb,Bac,dbc,fbc,kvc,qvc,Rwc,Swc,Uwc,Ywc,gxc,hxc,jxc,nxc,JAc,MAc,$Ac,cBc,CBc,fCc,UAc,XAc,iBc,lBc,ky,Uj,Sy,Vy,Yy,$y,cz,gC,zn,lC,BE,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc,qOc];var $h=[rOc,kDa,hac,iac,Rac,Sac,Yj,ek,tw,Jw,$l,nC,jo,Ap,oq,dr,vs,Cs,Ts,Ct,Qt,Nu,Fv,iO,hO,kO,jO,mO,lO,oO,nO,qO,pO,sO,rO,uO,tO,wO,vO,yO,xO,Spa,Rpa,Qpa,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc,rOc];var ai=[sOc,eK];var bi=[tOc,Or,tv,tOc];var ci=[uOc,Wwc,Xwc,lxc,mxc,FI,gK,uOc];var di=[vOc,XC];var ei=[wOc,hX,IW,QW,RW,SW,TW,iX,$W,mX,_W,pX,sX,tX,uX,zX,AX,BX,LX,RX,XX,_X,LY,MY,NY,OY,QZ,RZ,SZ,TZ,P1,e3,f3,g3,h3,i3,j3,k3,uEa,VEa,WEa,_Fa,HIa,Vsc,Onb,Unb,eob,iob,pob,Gob,Kob,jpb,vpb,Kpb,Vpb,cqb,vqb,Bqb,Lqb,arb,rrb,Erb,Urb,esb,tsb,Esb,Usb,itb,ytb,Otb,cub,sub,Iub,avb,svb,Jvb,$vb,hwb,Awb,Cwb,Twb,axb,kxb,Hxb,Fyb,Oyb,Zyb,gzb,szb,Qzb,Wzb,mAb,zAb,YHb,ZHb,_Hb,$Hb,zHb,qIb,CLb,MLb,NLb,gTb,xWb,yWb,Q9b,_9b,dac,fac,jac,kac,lac,mac,oac,Nac,Pac,Tac,Uac,Vac,Wac,Yac,hbc,ibc,Dec,Gec,Hec,Zec,afc,bfc,kfc,nfc,ofc,Afc,Dfc,Efc,Mfc,Pfc,Qfc,Yfc,$fc,agc,igc,lgc,mgc,ugc,xgc,ygc,Ggc,Jgc,Kgc,Sgc,Vgc,Wgc,Rhc,Shc,Xhc,bjc,cjc,ltc,lvc,rvc,YEc,fFc,GFc,Jk,bk,_j,uy,Yk,yy,_k,Cy,cl,My,ll,nl,pl,rl,tl,vl,xl,uk,vk,dw,Zw,qx,Hx,Xx,qm,oB,xB,Em,Mm,GB,Qm,Sm,Vm,KB,$m,on,sn,tn,Gn,pC,Pn,Sn,Un,Xn,bo,fo,so,vo,MC,Lo,_C,So,Uo,_o,op,DD,Dp,Ip,ID,Sp,Xp,$p,XD,mq,Fq,Lq,oE,Oq,pE,Wq,Yq,ar,tr,Ar,Fr,Jr,Sr,Vr,us,JF,UF,jG,at,bH,ct,dH,et,ft,Jt,Mt,Nt,bI,lI,pI,rI,fu,lu,ou,Bu,FJ,Qu,dv,a8,h8,h9,m9,q8,v8,U4,$4,c5,f5,i5,m5,Uga,APb,FQb,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc,wOc];var fi=[xOc,st];var gi=[yOc,sN,mN,kR,lR,mR,nR,oR,pR,qR,rR,sR,tR,HW,y4,z4,A4,B4,C4,D4,E4,F4,G4,H4,I4,J4,$ha,Xha,Tha,Pha,Lha,Hha,Dha,zha,vha,rha,Cla,yla,ula,qla,mla,ila,ela,ala,Yka,Uka,sna,ona,kna,gna,cna,cpa,dpa,epa,fpa,gpa,hpa,ipa,zqa,Xqa,ara,fra,kra,pra,ura,zra,Era,Jra,Ora,Wra,Ura,csa,asa,aFa,Zpb,Pqb,DAb,R9b,eac,gac,xac,Cac,Eac,Iac,Jac,Kac,Lac,Oac,Qac,Lhc,XEc,eFc,FFc,xy,nB,vm,Am,Dm,AB,Um,JB,_m,PB,nn,$B,rn,dC,eC,oC,On,ao,xC,eo,ho,ro,JC,to,LC,Ko,ZC,Ro,Zo,fD,ap,FD,Hp,HD,Rp,RD,Wp,WD,lq,Eq,nE,Vq,Xq,$q,tE,ir,sr,zr,GE,Er,KE,Ir,rF,aH,cH,eH,fH,ht,Gt,It,YH,Lt,$H,aI,LI,nJ,Iu,fO,eO,Tfa,Sfa,Vfa,Ufa,Xfa,Wfa,Yfa,Zfa,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc,yOc];var hi=[zOc,XK];var ii=[AOc,ov];var ji=[BOc,sya,rDa,tDa,vDa,xDa,zDa,BDa,DDa,JDa,kEa,zEa,JEa,JGb,$Gb,CHb,EHb,KHb,sKb,Gs,Is,_s,tt,vt,wt,iv,Cv,BOc,BOc,BOc,BOc,BOc];var ki=[COc,PE,PF,CK];var li=[DOc,qD,wH,DOc];var mi=[EOc,yQ,JS,US,CS,y_,m0,n0,p0,q0,Ssc,m2,k2,i2,c6,t6,u9,v9,w9,Eaa,Caa,Laa,Jaa,Haa,bba,Zaa,iba,gba,eba,wba,Bba,Gba,Lba,Qba,_ba,eca,kca,qca,wca,Hca,Nca,Tca,Zca,dda,mda,oda,qda,sda,uda,Dda,Hda,Lda,Qda,Vda,Yda,oea,Bea,Oea,$ea,mfa,$fa,iha,jha,Cka,Eka,Gka,Kka,Mka,Oka,Lna,Jna,Wna,Rna,Ooa,npa,tpa,Mpa,vwa,twa,qwa,owa,Hwa,Fwa,Cwa,zwa,Axa,wxa,qxa,uxa,Hxa,uya,vya,Rya,Mya,Hya,Cya,Xya,Vya,fza,cza,aza,pza,mza,jza,Lza,Iza,Aza,xza,cAa,$za,Wza,Tza,yAa,wAa,uAa,AAa,DAa,LAa,JAa,HAa,SAa,QAa,OAa,UAa,WAa,YAa,_Aa,FBa,CBa,ABa,PBa,MBa,JBa,SBa,TBa,UBa,VBa,WBa,XBa,YBa,ZBa,hCa,iCa,jCa,kCa,qCa,tCa,uCa,vCa,wCa,xCa,yCa,zCa,ACa,BCa,CCa,DCa,ECa,iDa,jDa,lDa,nDa,pDa,FDa,HDa,QDa,WDa,bEa,cEa,eEa,fEa,gEa,iEa,xEa,BEa,DEa,FEa,HEa,LEa,EIa,_dc,bec,cec,DMa,HMa,IMa,JMa,LMa,ZOa,aPa,bPa,cPa,dPa,iOa,pOa,sOa,gec,vOa,kec,xOa,_Na,bOa,cOa,dOa,eOa,ZMa,_Ma,dNa,eNa,gNa,jNa,hec,wPa,zPa,APa,BPa,CPa,FQa,IQa,JQa,KQa,LQa,WPa,bQa,hQa,kQa,nQa,pQa,qRa,tRa,uRa,vRa,wRa,NRa,QRa,RRa,SRa,TRa,nSa,qSa,rSa,sSa,tSa,PSa,SSa,TSa,USa,VSa,uTa,xTa,yTa,zTa,ATa,cVa,fVa,gVa,hVa,iVa,tVa,wVa,xVa,yVa,zVa,MVa,PVa,QVa,RVa,SVa,bWa,eWa,fWa,gWa,hWa,tWa,wWa,xWa,yWa,zWa,LWa,OWa,PWa,QWa,RWa,bXa,eXa,fXa,gXa,hXa,sXa,vXa,wXa,xXa,yXa,KXa,NXa,OXa,PXa,QXa,dYa,gYa,hYa,iYa,jYa,hZa,kZa,lZa,mZa,nZa,xZa,AZa,BZa,CZa,DZa,NZa,QZa,RZa,SZa,TZa,b_a,e_a,f_a,g_a,h_a,r_a,u_a,v_a,w_a,x_a,H_a,K_a,L_a,M_a,N_a,X_a,__a,$_a,a$a,b$a,l$a,o$a,p$a,q$a,r$a,B$a,E$a,F$a,G$a,H$a,S$a,V$a,W$a,X$a,Y$a,g0a,j0a,k0a,l0a,m0a,w0a,z0a,A0a,B0a,C0a,S0a,V0a,W0a,X0a,Y0a,h1a,k1a,l1a,m1a,n1a,x1a,A1a,B1a,C1a,D1a,N1a,Q1a,R1a,S1a,T1a,b2a,e2a,f2a,g2a,h2a,r2a,u2a,v2a,w2a,x2a,H2a,K2a,L2a,M2a,N2a,Y2a,$2a,a3a,b3a,c3a,m3a,p3a,q3a,r3a,s3a,C3a,F3a,G3a,H3a,I3a,S3a,V3a,W3a,X3a,Y3a,g4a,j4a,k4a,l4a,m4a,x4a,A4a,B4a,C4a,D4a,N4a,Q4a,R4a,S4a,T4a,b5a,e5a,f5a,g5a,h5a,r5a,u5a,v5a,w5a,x5a,H5a,K5a,L5a,M5a,N5a,_5a,b6a,c6a,d6a,e6a,s6a,v6a,w6a,x6a,y6a,J6a,M6a,N6a,O6a,P6a,_6a,b7a,c7a,d7a,e7a,q7a,t7a,u7a,v7a,w7a,I7a,L7a,M7a,N7a,O7a,Z7a,a8a,b8a,c8a,d8a,p8a,s8a,t8a,u8a,v8a,I8a,L8a,M8a,N8a,O8a,_8a,b9a,c9a,d9a,e9a,p9a,s9a,t9a,u9a,v9a,G9a,J9a,K9a,L9a,M9a,X9a,_9a,$9a,aab,bab,nab,qab,rab,sab,tab,Eab,Hab,Iab,Jab,Kab,Xab,_ab,$ab,abb,bbb,mbb,pbb,qbb,rbb,sbb,Ebb,Hbb,Ibb,Jbb,Kbb,Wbb,Zbb,_bb,$bb,acb,lcb,ocb,pcb,qcb,rcb,Jcb,Mcb,Ncb,Ocb,Pcb,Zcb,adb,bdb,cdb,ddb,ndb,qdb,rdb,sdb,tdb,Ddb,Gdb,Hdb,Idb,Jdb,Wdb,Zdb,_db,$db,aeb,oeb,reb,seb,teb,ueb,Feb,Ieb,Jeb,Keb,Leb,Xeb,_eb,$eb,afb,bfb,tfb,wfb,xfb,yfb,zfb,Rfb,Ufb,Vfb,Wfb,Xfb,hgb,kgb,lgb,mgb,ngb,lhb,ohb,phb,qhb,rhb,Phb,Shb,Thb,Uhb,Vhb,fib,iib,jib,kib,lib,Dib,Gib,Hib,Iib,Jib,Tib,Wib,Xib,Yib,Zib,hjb,kjb,ljb,mjb,njb,zjb,Cjb,Djb,Ejb,Fjb,Rjb,Ujb,Vjb,Wjb,Xjb,kkb,nkb,okb,pkb,qkb,Ckb,Fkb,Gkb,Hkb,Ikb,blb,elb,flb,glb,hlb,Flb,Ilb,Jlb,Klb,Llb,Wlb,Zlb,_lb,$lb,amb,_ob,Bpb,jqb,Fqb,Dqb,Vqb,Psb,dtb,ttb,Jtb,Ztb,nub,Dub,Vub,mvb,Bvb,qwb,Dwb,Ewb,Fwb,txb,OAb,ABb,DBb,EBb,FBb,GBb,_Bb,bCb,cCb,dCb,eCb,sCb,vCb,wCb,xCb,yCb,ADb,DDb,EDb,FDb,GDb,RCb,YCb,cDb,fDb,iDb,kDb,mEb,pEb,qEb,rEb,sEb,MEb,PEb,QEb,REb,SEb,fFb,iFb,jFb,kFb,lFb,DFb,GFb,HFb,IFb,JFb,XFb,_Fb,$Fb,aGb,bGb,xGb,yGb,sGb,DGb,FGb,HGb,LGb,NGb,PGb,UHb,VHb,TGb,ZGb,bHb,dHb,fHb,hHb,jHb,lHb,nHb,uHb,AHb,GHb,IHb,hIb,rIb,tIb,vIb,FIb,zJb,xJb,EJb,GJb,bKb,_Jb,XJb,QJb,NJb,UJb,iKb,jKb,dKb,oKb,qKb,uKb,wKb,yKb,FKb,GKb,IKb,uLb,DLb,FLb,HLb,JLb,OLb,QLb,SLb,ULb,CMb,MMb,SMb,VMb,cNb,gNb,vNb,SNb,jOb,qOb,tOb,uOb,DOb,LPb,OPb,VPb,_Pb,dQb,pQb,xQb,hSb,nSb,sSb,xSb,QYb,TYb,UYb,VYb,WYb,KZb,NZb,OZb,PZb,QZb,d_b,g_b,h_b,i_b,j_b,x_b,A_b,B_b,C_b,D_b,S_b,V_b,W_b,X_b,Y_b,k$b,n$b,o$b,p$b,q$b,G$b,J$b,K$b,L$b,M$b,$$b,c0b,d0b,e0b,f0b,w0b,z0b,A0b,B0b,C0b,P0b,S0b,T0b,U0b,V0b,g1b,j1b,k1b,l1b,m1b,A1b,D1b,E1b,F1b,G1b,T1b,W1b,X1b,Y1b,Z1b,l2b,o2b,p2b,q2b,r2b,F2b,I2b,J2b,K2b,L2b,_2b,b3b,c3b,d3b,e3b,u3b,x3b,y3b,z3b,A3b,R3b,U3b,V3b,W3b,X3b,k4b,n4b,o4b,p4b,q4b,I4b,L4b,M4b,N4b,O4b,a5b,d5b,e5b,f5b,g5b,v5b,y5b,z5b,A5b,B5b,R5b,U5b,V5b,W5b,X5b,i6b,l6b,m6b,n6b,o6b,K6b,N6b,O6b,P6b,Q6b,d7b,g7b,h7b,i7b,j7b,B7b,E7b,F7b,G7b,H7b,fec,W8b,X8b,ucc,Mcc,Ncc,Scc,Tcc,Vcc,Ycc,Cec,Fec,Yec,$ec,jfc,mfc,zfc,Cfc,Lfc,Ofc,Xfc,_fc,hgc,kgc,tgc,wgc,Fgc,Igc,Rgc,Ugc,Gmc,itc,Juc,Quc,Xuc,cvc,fzc,gzc,hzc,izc,kzc,lzc,rzc,szc,tzc,uzc,wzc,xzc,Czc,Dzc,Ezc,Fzc,Hzc,Izc,Nzc,Ozc,Pzc,Qzc,Szc,Tzc,AAc,FAc,KBc,LBc,MBc,RBc,SBc,TBc,Kk,Lk,Mk,Nk,Ok,Pk,Qk,Rk,Sk,hk,fl,fk,kk,lk,Zj,nk,ok,pk,wk,xk,yk,tk,sk,Tv,hw,xw,Nw,bx,vx,Lx,Pm,Xm,Fn,In,Zn,Oo,Wo,fp,Cp,Gp,Tp,_p,cq,eq,hq,Bq,Nq,Qq,jr,zE,AE,qr,rr,wr,yr,Br,Kr,Rr,Ur,Zr,$r,bs,ds,es,gs,is,ks,ns,xs,As,Es,fG,Ls,Ns,Os,Ps,Vs,Xs,Ys,Zs,$s,it,jt,kt,qt,ut,Dt,SH,Kt,St,Ut,Wt,Zt,_t,hu,ju,ku,mu,nu,qu,su,tu,uu,Pu,Su,Uu,Vu,Wu,Xu,Yu,Zu,_u,fv,hv,jv,kv,lv,mv,nv,wv,yv,zv,Av,Bv,Dv,Ev,Hv,GR,HR,IR,JR,KR,LR,rS,qS,pS,oS,nS,mS,lS,kS,jS,iS,hS,gS,fS,eS,dS,cS,bS,aS,$R,_R,ZR,YR,XR,WR,VR,UR,TR,SR,RR,QR,PR,OR,NR,MR,ika,jka,fka,gka,hka,Bmb,Cmb,Dmb,Emb,Fmb,Gmb,Hmb,Imb,Jmb,Kmb,Lmb,Mmb,Nmb,Omb,Pmb,Qmb,Rmb,Smb,Tmb,Umb,Vmb,Wmb,Xmb,Ymb,Zmb,_mb,$mb,anb,bnb,cnb,dnb,enb,fnb,gnb,hnb,inb,jnb,knb,lnb,mnb,nnb,Pnc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc,EOc];var ni=[FOc,UW,WW,Gac,Hac,vy,aB,pm,Nn,BC,CD,ts,IF,TF,zt,QH,kI,eu,Au,EJ,cv,FOc,FOc,FOc,FOc,FOc,FOc,FOc,FOc,FOc,FOc,FOc];var oi=[GOc,cB];var pi=[HOc,dK];var qi=[IOc,Wl,Dn,np,zq,ot,IOc,IOc];var ri=[JOc,VW,vX,CX,MX,SX,$X,Im,iE,Pr,ys,uv,JOc,JOc,JOc,JOc];var si=[KOc,iQb];var ti=[LOc,IG];var ui=[MOc,Vp];var vi=[NOc,Io];var wi=[OOc,EL,FL,GL,HL,IL,JL,KL,LL,ML,NL,OL,PL,QL,RL,SL,TL,UL,VL,WL,XL,YL,ZL,_L,$L,aM,bM,cM,dM,eM,fM,gM,hM,iM,jM,kM,lM,mM,nM,oM,pM,qM,rM,sM,tM,uM,vM,wM,xM,yM,BM,CM,DM,EM,FM,GM,HM,DS,ES,xT,yT,zT,AT,BT,CT,DT,TY,UY,VY,WY,XY,YY,ZY,_Y,$Y,aZ,bZ,cZ,dZ,eZ,fZ,gZ,hZ,iZ,jZ,kZ,lZ,mZ,nZ,oZ,pZ,qZ,rZ,sZ,tZ,uZ,vZ,wZ,xZ,yZ,zZ,AZ,BZ,CZ,DZ,EZ,FZ,GZ,HZ,IZ,JZ,KZ,XZ,YZ,ZZ,_Z,$Z,a_,b_,c_,d_,e_,MB,RB,kn,YB,aC,Kn,rC,uC,oo,GC,Bo,QC,$C,AD,Ep,OD,iq,$D,qE,HE,TH,PZ,OZ,g_,bfa,afa,dfa,cfa,ffa,efa,hfa,gfa,jfa,ifa,Qea,Pea,Sea,Rea,Uea,Tea,Wea,Vea,Yea,Xea,Dea,Cea,Fea,Eea,Hea,Gea,Jea,Iea,Lea,Kea,qea,pea,sea,rea,uea,tea,wea,vea,yea,xea,dea,cea,fea,eea,hea,gea,jea,iea,lea,kea,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc,OOc];var xi=[POc,Go];var yi=[QOc,vB,vE,QOc];var zi=[ROc,pB,wm,ROc];var Ai=[SOc,uac,vac,ez,iz,fC,dp,lD,JD,bE,tq,hE,SOc,SOc,SOc,SOc];var Bi=[TOc,lF];var Ci=[UOc,gB];var Di=[VOc,UB];var Ei=[WOc,kQb,lE,oF,LH,kJ,Fu,WOc];var Fi=[XOc,hB];var Gi=[YOc,dG];var Hi=[ZOc,jB];var Ii=[_Oc,r4,s4,t4,u4,v4,w4,x4,gda,hda,ida,jda,kda,cja,hja,mja,rja,wja,Bja,Gja,Lja,Qja,Vja,Zoa,_oa,$oa,apa,bpa,Uoa,Voa,Woa,Xoa,Yoa,Poa,Qoa,Roa,Soa,Toa,ava,fva,kva,pva,uva,zva,Eva,Jva,Ova,Tva,Yva,bwa,gwa,aEa,Nsb,btb,rtb,Htb,Xtb,lub,Bub,Rub,jvb,Bzb,UPb,wB,Ym,NB,dn,SB,ln,ZB,pn,bC,Ln,_n,vC,yC,po,HC,Co,RC,No,Po,gD,yp,BD,Pp,PD,jq,aE,Tq,Zq,rE,wE,Cr,IE,Gr,hH,Et,UH,WH,Jfa,Ifa,Lfa,Kfa,Ofa,Nfa,Qfa,Rfa,Mfa,Pfa,Cmc,Bmc,Amc,zmc,ymc,xmc,wmc,Emc,Dmc,vmc,_Oc,_Oc,_Oc,_Oc,_Oc,_Oc,_Oc,_Oc];var Ji=[$Oc,CB];var Ki=[aPc,rB,ym,QB,dD,gr,xJ,aPc];var Li=[bPc,HV,IV,JV,KV,LV,MV,NV,AV,BV,CV,DV,EV,FV,GV,mV,nV,oV,pV,qV,rV,sV,tV,uV,vV,wV,xV,yV,zV,OV,PV,QV,RV,SV,TV,UV,eW,fW,gW,hW,jW,iW,kW,lW,mW,nW,oW,pW,qW,rW,zW,AW,BW,CW,DW,EW,FW,sW,tW,uW,vW,wW,xW,yW,ZV,_V,$V,aW,bW,cW,dW,wL,xL,yL,zL,AL,BL,CL,zca,Aca,Bca,Cca,Dca,Sba,Tba,Uba,Vba,Wba,oba,pba,qba,rba,sba,jn,XB,qC,no,FC,Ao,PC,GD,_D,XV,VV,WV,YV,GN,DN,EN,FN,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc,bPc];var Mi=[cPc,GS,gX,bX,lX,oX,rX,yX,KX,QX,WX,ZX,R1,S1,P2,Q2,R2,S2,T2,XEa,YEa,ZEa,cFa,dFa,$Fa,aGa,JIa,KIa,$sc,btc,wMa,BMa,GSb,UOa,BOa,kOa,qOa,TNa,YNa,VMa,XMa,pPa,uPa,yQa,DQa,NPa,PPa,dQa,iQa,jRa,oRa,GRa,LRa,gSa,lSa,ISa,NSa,oTa,sTa,ZUa,aVa,oVa,rVa,HVa,KVa,YVa,$Va,oWa,rWa,GWa,JWa,YWa,$Wa,nXa,qXa,FXa,IXa,_Xa,bYa,cZa,fZa,sZa,vZa,IZa,LZa,YZa,$Za,m_a,p_a,C_a,F_a,S_a,V_a,g$a,j$a,w$a,z$a,N$a,Q$a,b0a,e0a,r0a,u0a,N0a,Q0a,c1a,f1a,s1a,v1a,I1a,L1a,Y1a,$1a,m2a,p2a,C2a,F2a,T2a,W2a,h3a,k3a,x3a,A3a,N3a,Q3a,b4a,e4a,s4a,v4a,I4a,L4a,Y4a,$4a,m5a,p5a,C5a,F5a,V5a,Y5a,n6a,q6a,E6a,H6a,V6a,Y6a,l7a,o7a,D7a,G7a,U7a,X7a,k8a,n8a,D8a,G8a,V8a,Y8a,k9a,n9a,B9a,E9a,S9a,V9a,iab,lab,zab,Cab,Sab,Vab,hbb,kbb,zbb,Cbb,Rbb,Ubb,gcb,jcb,Ecb,Hcb,Ucb,Xcb,idb,ldb,ydb,Bdb,Rdb,Udb,jeb,meb,Aeb,Deb,Seb,Veb,ofb,rfb,Mfb,Pfb,cgb,fgb,ghb,jhb,Khb,Nhb,aib,dib,yib,Bib,Oib,Rib,cjb,fjb,ujb,xjb,Mjb,Pjb,fkb,ikb,xkb,Akb,Ykb,$kb,Alb,Dlb,Rlb,Ulb,kpb,wpb,Lpb,Wpb,_pb,$pb,wqb,Mqb,brb,srb,Frb,Vrb,fsb,hsb,usb,Fsb,Jsb,Vsb,Zsb,jtb,ntb,ztb,Dtb,Ptb,Ttb,dub,hub,tub,xub,Jub,Nub,bvb,fvb,tvb,Kvb,Tvb,iwb,lwb,rwb,swb,Uwb,bxb,lxb,oxb,Ixb,Pyb,hzb,tzb,xzb,Xzb,nAb,AAb,tBb,yBb,TBb,YBb,lCb,qCb,tDb,yDb,ICb,KCb,_Cb,dDb,fEb,kEb,FEb,KEb,_Eb,dFb,wFb,BFb,QFb,VFb,jNb,VNb,lOb,$Pb,iSb,ySb,JYb,OYb,DZb,IZb,YZb,b_b,q_b,v_b,L_b,Q_b,d$b,i$b,z$b,E$b,U$b,Z$b,p0b,u0b,I0b,N0b,$0b,e1b,t1b,y1b,M1b,R1b,e2b,j2b,y2b,D2b,T2b,Y2b,n3b,s3b,K3b,P3b,d4b,i4b,B4b,G4b,V4b,_4b,o5b,t5b,K5b,P5b,b6b,g6b,D6b,I6b,Y6b,b7b,u7b,z7b,o8b,T8b,dec,h9b,E9b,F9b,G9b,Zac,_ac,mec,vcc,BSb,Icc,Kcc,zec,Aec,Iec,Jec,Pec,Vec,Wec,cfc,gfc,hfc,pfc,wfc,xfc,Ffc,Ifc,Jfc,Ufc,Vfc,egc,fgc,ngc,qgc,rgc,zgc,Cgc,Dgc,Lgc,Ogc,Pgc,Xgc,phc,Bjc,Xnc,Ync,Znc,rtc,ttc,Muc,Tuc,_uc,fvc,vBc,xBc,zBc,_Bc,aCc,cCc,ey,fy,oy,qy,ry,sy,Dy,el,Fy,Jy,Ny,yl,Bl,El,Hl,Kl,Nl,Rl,lz,pz,vz,Dz,Lz,Tz,Vz,Zz,_z,$z,eA,gA,qA,uA,EA,GA,IA,JA,LA,NA,ew,uw,Kw,_w,rx,Ix,Yx,LB,xn,tC,Fo,mD,LD,VD,ZD,RE,UE,YE,ms,hF,sF,uF,yF,AF,RF,hG,tG,FG,GG,MG,PG,$G,gH,jH,oH,pH,yH,CH,RH,cI,oI,wI,xI,zI,II,UI,VI,WI,ZI,vu,rJ,zJ,KJ,LJ,MJ,PJ,aK,bK,jK,uK,EK,GK,QK,TK,b4,a4,$3,_3,Z3,i4,j4,k4,m4,l4,T4,W4,_4,b5,e5,h5,l5,Tga,hxa,ayb,Uxb,lyb,zPb,EQb,n9b,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc,cPc];var Ni=[dPc,Vl,jm,mm,yq,nt,dPc,dPc];var Oi=[ePc,oD];var Pi=[fPc,lo];var Qi=[gPc,vJ];var Ri=[hPc,au];var Si=[iPc,VC];var Ti=[jPc,eN,bN,QM,RM,SM,TM,UM,VM,uR,vR,wR,xR,yR,zR,AR,BR,CR,DR,tS,uS,vS,wS,xS,yS,zS,BS,JW,KW,LW,MW,NW,OW,PW,YW,ZW,aX,wX,EX,FX,TX,haa,caa,Z9,V9,Q9,t9,rya,TEa,UEa,_Ea,$Ea,bFa,eFa,ZFa,bGa,fNa,ipb,lpb,upb,xpb,Mpb,Upb,Xpb,Ypb,kqb,uqb,xqb,yqb,Nqb,Oqb,$qb,crb,drb,erb,frb,qrb,trb,Grb,Trb,Wrb,dsb,gsb,ssb,vsb,Gsb,Hsb,Isb,Ksb,Wsb,Xsb,Ysb,_sb,ktb,ltb,mtb,otb,Atb,Btb,Ctb,Etb,Qtb,Rtb,Stb,Utb,eub,fub,gub,iub,uub,vub,wub,yub,Kub,Lub,Mub,Oub,cvb,dvb,evb,gvb,uvb,vvb,Ivb,Lvb,Svb,Uvb,jwb,kwb,zwb,Swb,Vwb,cxb,mxb,nxb,Jxb,Qyb,Ryb,fzb,izb,uzb,vzb,wzb,yzb,Pzb,Yzb,lAb,oAb,yAb,BAb,CAb,GAb,HAb,UKb,kNb,zNb,WNb,aQb,cQb,J9b,L9b,N9b,P9b,S9b,Ucc,Eec,Nec,Qec,_ec,dfc,lfc,qfc,Bfc,Nfc,Zfc,jgc,vgc,Hgc,Tgc,Ohc,Phc,Qhc,Vhc,Whc,xic,Cjc,Ik,ck,ak,py,Xj,Xk,Zk,$k,By,ik,dl,hl,gk,il,jk,Ly,mk,kl,ml,ol,ql,sl,ul,wl,mz,qz,wz,Ez,Mz,Uz,Wz,fA,hA,rA,vA,FA,HA,rk,cw,Uv,Wv,iw,kw,yw,Aw,Yw,Ow,Qw,px,cx,ex,Gx,wx,yx,Wx,Mx,Ox,rm,Bm,Fm,Nm,Om,HB,Rm,Tm,Wm,Hn,Jn,Qn,Tn,Vn,Yn,co,ko,wo,Mo,To,hp,kp,mp,pp,Bp,ED,Fp,Jp,Up,Yp,Zp,aq,bq,dq,fq,gq,pq,Cq,Mq,Pq,Rq,Sq,er,yE,DE,ur,xr,Tr,Xr,Yr,_r,as,cs,fs,hs,js,kF,tF,vF,zF,BF,ws,KF,Ds,bG,Js,Ks,DG,EG,Us,bt,dt,rH,sH,ZH,Ot,Rt,mI,Tt,Vt,qI,Xt,yI,gu,KI,pu,$I,aJ,Ou,Ru,RJ,SJ,$J,ev,vK,Gv,f8,i8,k9,n9,t8,w8,T6,S6,V6,U6,zna,vna,wna,xna,yna,Fna,Bna,Cna,Dna,Ena,Upa,Tpa,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc,jPc];var Ui=[kPc,lPc,OEc,MMa,NMa,QMa,RMa,DPa,EPa,HPa,IPa,JPa,xRa,yRa,BRa,CRa,uSa,vSa,wSa,WSa,XSa,YSa,hTa,jTa,BTa,CTa,FTa,GTa,HTa,ITa,JTa,KTa,LTa,MTa,NTa,OTa,PTa,QTa,RTa,STa,TTa,UTa,VTa,WTa,XTa,YTa,ZTa,_Ta,$Ta,aUa,bUa,cUa,dUa,eUa,fUa,gUa,hUa,iUa,jUa,kUa,lUa,mUa,nUa,oUa,pUa,qUa,rUa,sUa,tUa,uUa,vUa,wUa,xUa,yUa,zUa,AUa,BUa,CUa,DUa,EUa,FUa,GUa,HUa,IUa,JUa,KUa,LUa,MUa,NUa,OUa,PUa,QUa,RUa,SUa,TUa,UUa,VUa,shb,thb,whb,xhb,yhb,zhb,Ahb,Bhb,Chb,Dhb,Ehb,Fhb,Ghb,HBb,IBb,LBb,MBb,NBb,OBb,PBb,tEb,uEb,xEb,yEb,zEb,AEb,BEb,PQb,QQb,cTb,hTb,jTb,RXb,YVb,aWb,qWb,eXb,SXb,XYb,YYb,$Yb,aZb,bZb,cZb,dZb,eZb,fZb,gZb,hZb,iZb,jZb,kZb,lZb,mZb,nZb,oZb,pZb,qZb,rZb,sZb,tZb,uZb,vZb,wZb,xZb,yZb,zZb,$bc,nec,oec,pec,qec,rec,sec,tec,uec,vec,wec,$gc,lhc,mhc,jjc,kjc,hFc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc,kPc];var Vi=[mPc,sz,Az,Iz,Qz,Yz,dA,lA,pA,xA,BA,sw,Iw,En,Aq,Qr,xF,zs,gG,QG,pt,BH,lK,vv,HK,g8,l9,u8,mPc,mPc,mPc,mPc];var Wi=[nPc,tH];var Xi=[oPc,jE,iJ,Du];var Yi=[pPc,KM,fN,cN,dN,MM,NM,OM,hN,tN,nN,oN,jN,kN,vQ,wQ,KS,LS,MS,AS,RS,GW,fX,kX,nX,qX,xX,JX,PX,VX,YX,t_,u_,x_,z_,A_,j0,k0,l0,K1,T1,U1,V1,W1,X1,ytc,ztc,Atc,Btc,M1,N1,Stc,Ttc,Utc,Vtc,Wtc,Xtc,x8,l2,j2,h2,Itc,Jtc,Ktc,Ltc,D3,E3,F3,G3,J3,K3,L3,M3,t5,u5,w5,x5,$5,a6,q6,r6,o9,gaa,eaa,faa,baa,$9,aaa,Y9,W9,X9,U9,S9,T9,P9,N9,O9,s9,q9,r9,z9,A9,K9,L9,M9,Daa,Baa,Kaa,Iaa,Gaa,aba,Yaa,hba,fba,dba,uba,vba,zba,Aba,Eba,Fba,Jba,Kba,Oba,Pba,Yba,Zba,cca,dca,ica,jca,oca,pca,uca,vca,Fca,Gca,Lca,Mca,Rca,Sca,Xca,Yca,bda,cda,lda,nda,pda,rda,tda,Bda,Cda,Fda,Gda,Jda,Kda,Oda,Pda,Tda,Uda,lba,Xda,nea,Aea,Nea,_ea,lfa,ufa,vfa,_fa,lha,kha,mqa,_ha,Yha,Zha,Wha,Uha,Vha,Sha,Qha,Rha,Oha,Mha,Nha,Kha,Iha,Jha,Gha,Eha,Fha,Cha,Aha,Bha,yha,wha,xha,uha,sha,tha,qha,oha,pha,oqa,Nia,qqa,Lia,Mia,Jia,Hia,Iia,Fia,Dia,Eia,Bia,zia,Aia,xia,via,wia,tia,ria,sia,pia,nia,oia,lia,jia,kia,hia,fia,gia,dia,bia,cia,Rja,Sja,Mja,Nja,Hja,Ija,Cja,Dja,xja,yja,sja,tja,nja,oja,ija,jja,dja,eja,_ia,$ia,aja,bja,tqa,fja,gja,kja,lja,pja,qja,uja,vja,zja,Aja,Eja,Fja,Jja,Kja,Oja,Pja,Tja,Uja,Xja,Yja,Aka,Bka,yka,Dka,wka,Fka,Ika,Jka,tka,Lka,rka,Nka,Bla,zla,Ala,xla,vla,wla,tla,rla,sla,pla,nla,ola,lla,jla,kla,hla,fla,gla,dla,bla,cla,$ka,Zka,_ka,Xka,Vka,Wka,Tka,Rka,Ska,Tma,Uma,Wma,Rma,Sma,Mma,Nma,Pma,Kma,Lma,Gma,Hma,Jma,Ema,Fma,Ama,Bma,Dma,yma,zma,uma,vma,xma,sma,tma,oma,pma,rma,mma,nma,ima,jma,lma,gma,hma,cma,dma,fma,ama,bma,Yla,Zla,$la,Wla,Xla,Sla,Tla,Vla,Qla,Rla,Mla,Nla,Pla,Kla,Lla,Gla,Hla,Jla,Ela,Fla,rna,pna,qna,nna,lna,mna,jna,hna,ina,fna,dna,ena,bna,$ma,ana,Kna,Ina,Una,Vna,Qna,Noa,lpa,mpa,rpa,spa,Lpa,nqa,pqa,rqa,sqa,uqa,vqa,Xra,Yra,Pra,Qra,Kra,Lra,Fra,Gra,Ara,Bra,vra,wra,qra,rra,lra,mra,gra,hra,bra,cra,Yqa,Zqa,Tqa,Uqa,Vqa,Wqa,_qa,$qa,dra,era,ira,jra,nra,ora,sra,tra,xra,yra,Cra,Dra,Hra,Ira,Mra,Nra,Sra,Vra,Tra,_ra,bsa,$ra,Fua,Gua,Dua,Eua,Bua,Cua,zua,Aua,xua,yua,vua,wua,tua,uua,rua,sua,pua,qua,lua,mua,aua,bua,Rta,Sta,Kta,Lta,Dta,Eta,wta,xta,pta,qta,ita,jta,ata,bta,Vsa,Wsa,Osa,Psa,Hsa,Isa,Asa,Bsa,Csa,Fsa,Dsa,Jsa,Msa,Ksa,Qsa,Tsa,Rsa,Xsa,_sa,Ysa,dta,gta,eta,kta,nta,lta,rta,uta,sta,yta,Bta,zta,Fta,Ita,Gta,Mta,Pta,Nta,Uta,Xta,Vta,_ta,dua,gua,eua,jua,nua,cwa,dwa,Zva,_va,Uva,Vva,Pva,Qva,Kva,Lva,Fva,Gva,Ava,Bva,vva,wva,qva,rva,lva,mva,gva,hva,bva,cva,Yua,Zua,_ua,$ua,dva,eva,iva,jva,nva,ova,sva,tva,xva,yva,Cva,Dva,Hva,Iva,Mva,Nva,Rva,Sva,Wva,Xva,$va,awa,ewa,fwa,uwa,swa,pwa,nwa,Gwa,Ewa,Bwa,ywa,zxa,vxa,pxa,txa,Fxa,Gxa,pya,qya,wya,nya,oya,Pya,Qya,Nya,Oya,Kya,Lya,Iya,Jya,Fya,Gya,Dya,Eya,Aya,Bya,yya,zya,Wya,Uya,eza,bza,$ya,oza,lza,iza,Kza,Hza,zza,wza,bAa,_za,Vza,Sza,xAa,vAa,tAa,zAa,CAa,KAa,IAa,GAa,RAa,PAa,NAa,TAa,VAa,XAa,ZAa,EBa,BBa,zBa,OBa,LBa,IBa,fCa,eCa,dCa,cCa,bCa,aCa,$Ba,_Ba,oCa,nCa,mCa,lCa,rCa,QCa,PCa,OCa,NCa,MCa,LCa,KCa,JCa,ICa,HCa,GCa,FCa,gDa,hDa,PDa,TDa,UDa,VDa,$Da,ZDa,_Da,tEa,vEa,rEa,sEa,REa,SEa,fFa,vFa,wFa,XFa,YFa,VFa,WFa,fHa,gHa,bHa,cHa,dHa,eHa,LIa,MIa,NIa,OIa,PIa,QIa,BIa,DIa,zKa,AKa,DKa,EKa,iLa,jLa,kLa,lLa,nLa,oLa,ZSb,ALa,BLa,tMa,uMa,zMa,iec,ROa,SOa,XOa,gOa,QOa,nOa,QNa,RNa,WNa,TMa,UMa,bNa,cNa,hOa,GOa,COa,DOa,mPa,nPa,sPa,vQa,wQa,BQa,LPa,MPa,SPa,TPa,$Pa,aQa,fQa,uQa,sQa,tQa,OQa,gRa,hRa,mRa,DRa,ERa,JRa,dSa,eSa,jSa,FSa,GSa,LSa,lTa,mTa,qTa,WUa,XUa,_Ua,lVa,mVa,pVa,EVa,FVa,IVa,VVa,WVa,ZVa,lWa,mWa,pWa,DWa,EWa,HWa,VWa,WWa,ZWa,kXa,lXa,oXa,CXa,DXa,GXa,XXa,YXa,$Xa,$Ya,aZa,dZa,pZa,qZa,tZa,FZa,GZa,JZa,VZa,WZa,ZZa,j_a,k_a,n_a,z_a,A_a,D_a,P_a,Q_a,T_a,d$a,e$a,h$a,t$a,u$a,x$a,K$a,L$a,O$a,_$a,$$a,c0a,o0a,p0a,s0a,K0a,L0a,O0a,$0a,a1a,d1a,p1a,q1a,t1a,F1a,G1a,J1a,V1a,W1a,Z1a,j2a,k2a,n2a,z2a,A2a,D2a,Q2a,R2a,U2a,e3a,f3a,i3a,u3a,v3a,y3a,K3a,L3a,O3a,_3a,$3a,c4a,p4a,q4a,t4a,F4a,G4a,J4a,V4a,W4a,Z4a,j5a,k5a,n5a,z5a,A5a,D5a,S5a,T5a,W5a,k6a,l6a,o6a,B6a,C6a,F6a,S6a,T6a,W6a,i7a,j7a,m7a,A7a,B7a,E7a,R7a,S7a,V7a,h8a,i8a,l8a,A8a,B8a,E8a,S8a,T8a,W8a,h9a,i9a,l9a,y9a,z9a,C9a,P9a,Q9a,T9a,fab,gab,jab,wab,xab,Aab,Pab,Qab,Tab,ebb,fbb,ibb,wbb,xbb,Abb,Obb,Pbb,Sbb,dcb,ecb,hcb,Bcb,Ccb,Fcb,Rcb,Scb,Vcb,fdb,gdb,jdb,vdb,wdb,zdb,Odb,Pdb,Sdb,geb,heb,keb,xeb,yeb,Beb,Peb,Qeb,Teb,lfb,mfb,pfb,Jfb,Kfb,Nfb,$fb,agb,dgb,dhb,ehb,hhb,Hhb,Ihb,Lhb,Zhb,_hb,bib,vib,wib,zib,Lib,Mib,Pib,$ib,ajb,djb,rjb,sjb,vjb,Jjb,Kjb,Njb,ckb,dkb,gkb,ukb,vkb,ykb,Vkb,Wkb,Zkb,xlb,ylb,Blb,Olb,Plb,Slb,Hob,Iob,Dob,Eob,Aob,Bob,xob,yob,uob,vob,qob,rob,mob,nob,job,kob,fob,gob,bob,cob,_nb,$nb,Rnb,Snb,Gnb,Hnb,Lnb,Qnb,Mnb,Tnb,aob,dob,hob,lob,oob,sob,wob,zob,Cob,Fob,Job,$ob,bpb,cpb,fpb,gpb,hpb,qpb,rpb,spb,tpb,Apb,Fpb,Gpb,Hpb,Jpb,Ipb,Spb,Tpb,Qpb,Rpb,hqb,iqb,mqb,nqb,oqb,sqb,tqb,qqb,rqb,Eqb,Cqb,Iqb,Jqb,Kqb,Uqb,Yqb,Zqb,_qb,lrb,mrb,orb,prb,Brb,Crb,Drb,Krb,Lrb,Prb,Srb,Qrb,$rb,asb,bsb,csb,lsb,msb,qsb,rsb,Dsb,Bsb,Csb,Osb,Tsb,Rsb,Ssb,ctb,htb,ftb,gtb,stb,xtb,vtb,wtb,Itb,Ntb,Ltb,Mtb,Ytb,bub,$tb,aub,mub,rub,pub,qub,Cub,Hub,Fub,Gub,Uub,Yub,Zub,_ub,$ub,lvb,pvb,qvb,rvb,zvb,Avb,Evb,Fvb,Gvb,Hvb,Rvb,Pvb,Qvb,Yvb,Zvb,_vb,dwb,ewb,fwb,gwb,pwb,vwb,wwb,xwb,ywb,Mwb,Nwb,Qwb,Rwb,Owb,Pwb,Zwb,_wb,$wb,gxb,hxb,ixb,jxb,sxb,xxb,yxb,Fxb,Gxb,Cyb,Dyb,Eyb,Lyb,Myb,Nyb,Wyb,Xyb,Yyb,bzb,czb,dzb,ezb,ozb,pzb,qzb,rzb,Lzb,Mzb,Nzb,Ozb,Vzb,Tzb,Uzb,bAb,cAb,jAb,kAb,tAb,uAb,vAb,xAb,wAb,MAb,NAb,qBb,rBb,wBb,QBb,RBb,WBb,iCb,jCb,oCb,qDb,rDb,wDb,GCb,HCb,NCb,OCb,WCb,XCb,aDb,pDb,nDb,oDb,JDb,cEb,dEb,iEb,CEb,DEb,IEb,XEb,YEb,bFb,tFb,uFb,zFb,NFb,OFb,TFb,THb,wGb,uGb,vGb,UGb,sHb,tHb,yHb,wHb,xHb,pIb,nIb,oIb,DIb,EIb,gJb,hJb,yJb,wJb,DJb,FJb,aKb,ZJb,WJb,PJb,LJb,MJb,JJb,TJb,hKb,fKb,gKb,CKb,DKb,EKb,JKb,SKb,dLb,eLb,BLb,zLb,ALb,KLb,LLb,kMb,lMb,BMb,LMb,RMb,UMb,$Mb,aNb,hNb,lNb,qNb,rNb,sNb,tNb,ANb,HNb,INb,NNb,ONb,LNb,MNb,PNb,QNb,XNb,$Nb,aOb,dOb,eOb,bOb,cOb,hOb,iOb,BOb,COb,QOb,ROb,oPb,pPb,QPb,RPb,KPb,JPb,NPb,SPb,TPb,YPb,ZPb,nQb,oQb,vQb,wQb,eSb,fSb,kSb,lSb,qSb,uSb,vSb,WSb,XSb,_Sb,$Sb,PXb,QXb,vWb,wWb,_hc,tWb,WWb,XWb,fYb,gYb,sYb,tYb,GYb,HYb,MYb,AZb,BZb,GZb,VZb,WZb,$Zb,n_b,o_b,t_b,I_b,J_b,O_b,a$b,b$b,g$b,w$b,x$b,C$b,R$b,S$b,X$b,m0b,n0b,s0b,F0b,G0b,L0b,Y0b,Z0b,c1b,q1b,r1b,w1b,J1b,K1b,P1b,b2b,c2b,h2b,v2b,w2b,B2b,Q2b,R2b,W2b,k3b,l3b,q3b,H3b,I3b,N3b,a4b,b4b,g4b,y4b,z4b,E4b,S4b,T4b,Y4b,l5b,m5b,r5b,H5b,I5b,N5b,_5b,$5b,e6b,A6b,B6b,G6b,V6b,W6b,$6b,r7b,s7b,x7b,p8b,q8b,Q8b,R8b,$dc,f9b,g9b,ekc,l9b,C9b,D9b,rcc,scc,xcc,ycc,Bcc,Ccc,Ecc,Fcc,Gcc,Hcc,Qcc,Rcc,xec,yec,Uec,ffc,vfc,Hfc,Tfc,dgc,pgc,Bgc,Ngc,nhc,ohc,Mhc,Nhc,vic,wic,ecc,ajc,HTb,zjc,fkc,Fmc,Msc,Osc,Qsc,Rsc,gtc,htc,Dtc,Etc,Ftc,Gtc,Ntc,Otc,Ptc,Qtc,Huc,Iuc,Ouc,Puc,Vuc,Wuc,avc,bvc,hvc,ivc,jvc,ovc,pvc,uvc,vvc,owc,pwc,Pwc,Qwc,exc,fxc,sxc,txc,dyc,eyc,Ryc,Syc,Xyc,Yyc,bzc,czc,nzc,ozc,yzc,zzc,Jzc,Kzc,Uzc,Vzc,bAc,cAc,kAc,lAc,qAc,rAc,wAc,xAc,BAc,CAc,nvc,RAc,GAc,eBc,fBc,qBc,rBc,tBc,uBc,GBc,HBc,NBc,OBc,UBc,VBc,gCc,hCc,iCc,REc,SEc,TEc,UEc,cFc,nFc,oFc,tFc,uFc,vFc,wFc,yFc,AFc,DFc,ay,kz,oz,uz,yz,Cz,Gz,Kz,Oz,Sz,bA,jA,nA,tA,zA,DA,Tl,zk,$v,pw,Fw,Vw,lx,Dx,Tx,kr,lr,$E,HQb,IQb,FF,MF,Bs,YF,_F,Hs,nG,pG,Ms,yG,AG,Ws,UG,WG,YG,lH,rt,GH,IH,gI,iI,tI,iu,PI,RI,ru,eJ,gJ,HJ,Tu,WJ,YJ,gv,pK,rK,xv,LK,NK,Iv,aL,qQ,c8,d8,i9,j9,r8,s8,F1,R4,V4,Y4,J0,W0,y0,k5,O5,I9,H9,G9,F9,E9,D9,C9,B9,Sga,sGa,PJa,FJa,YJa,UKa,hEc,ZVb,SLa,RLa,aMa,hMa,gMa,PMa,HNa,GNa,xNa,ONa,GPa,ARa,xSa,ZSa,iTa,ETa,J0a,H0a,Ffb,Dfb,wlb,vhb,tib,hmb,fmb,nlb,klb,Tkb,slb,Amb,SAb,KBb,wEb,yPb,DQb,FTb,vVb,SWb,bYb,jYb,_Yb,t9b,qdc,pdc,Zdc,kkc,zkc,Fkc,Lkc,Rkc,Xkc,blc,hlc,jlc,Cuc,Ovc,Qvc,Jxc,Lxc,Nxc,FEc,vyc,xyc,zyc,Yzc,poc,iFc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc,pPc];var Zi=[qPc,TB];var _i=[rPc,xQ,HS,IS,w_,o0,Wsc,Xsc,Q1,_sc,v5,b6,s6,J9,mDa,oDa,EDa,GDa,dEa,hEa,wEa,AEa,CEa,EEa,GEa,KEa,CIa,IIa,Zsc,vMa,xMa,yMa,AMa,CMa,EMa,GMa,jec,KMa,TOa,VOa,WOa,YOa,AOa,_Oa,jOa,lOa,mOa,oOa,rOa,tOa,wOa,EOa,FOa,SNa,UNa,VNa,XNa,ZNa,$Na,$Ma,aNa,hNa,iNa,yOa,zOa,oPa,qPa,rPa,tPa,vPa,xPa,xQa,zQa,AQa,CQa,EQa,GQa,QPa,RPa,UPa,VPa,cQa,eQa,gQa,jQa,lQa,oQa,qQa,rQa,PQa,QQa,iRa,kRa,lRa,nRa,pRa,rRa,FRa,HRa,IRa,KRa,MRa,ORa,fSa,hSa,iSa,kSa,mSa,oSa,HSa,JSa,KSa,MSa,OSa,QSa,nTa,pTa,rTa,tTa,vTa,YUa,$Ua,bVa,dVa,nVa,qVa,sVa,uVa,GVa,JVa,LVa,NVa,XVa,_Va,aWa,cWa,nWa,qWa,sWa,uWa,FWa,IWa,KWa,MWa,XWa,_Wa,aXa,cXa,mXa,pXa,rXa,tXa,EXa,HXa,JXa,LXa,ZXa,aYa,cYa,eYa,bZa,eZa,gZa,iZa,rZa,uZa,wZa,yZa,HZa,KZa,MZa,OZa,XZa,_Za,a_a,c_a,l_a,o_a,q_a,s_a,B_a,E_a,G_a,I_a,R_a,U_a,W_a,Y_a,f$a,i$a,k$a,m$a,v$a,y$a,A$a,C$a,M$a,P$a,R$a,T$a,a0a,d0a,f0a,h0a,q0a,t0a,v0a,x0a,M0a,P0a,R0a,T0a,b1a,e1a,g1a,i1a,r1a,u1a,w1a,y1a,H1a,K1a,M1a,O1a,X1a,_1a,a2a,c2a,l2a,o2a,q2a,s2a,B2a,E2a,G2a,I2a,S2a,V2a,X2a,Z2a,g3a,j3a,l3a,n3a,w3a,z3a,B3a,D3a,M3a,P3a,R3a,T3a,a4a,d4a,f4a,h4a,r4a,u4a,w4a,y4a,H4a,K4a,M4a,O4a,X4a,_4a,a5a,c5a,l5a,o5a,q5a,s5a,B5a,E5a,G5a,I5a,U5a,X5a,Z5a,$5a,m6a,p6a,r6a,t6a,D6a,G6a,I6a,K6a,U6a,X6a,Z6a,$6a,k7a,n7a,p7a,r7a,C7a,F7a,H7a,J7a,T7a,W7a,Y7a,_7a,j8a,m8a,o8a,q8a,C8a,F8a,H8a,J8a,U8a,X8a,Z8a,$8a,j9a,m9a,o9a,q9a,A9a,D9a,F9a,H9a,R9a,U9a,W9a,Y9a,hab,kab,mab,oab,yab,Bab,Dab,Fab,Rab,Uab,Wab,Yab,gbb,jbb,lbb,nbb,ybb,Bbb,Dbb,Fbb,Qbb,Tbb,Vbb,Xbb,fcb,icb,kcb,mcb,Dcb,Gcb,Icb,Kcb,Tcb,Wcb,Ycb,_cb,hdb,kdb,mdb,odb,xdb,Adb,Cdb,Edb,Qdb,Tdb,Vdb,Xdb,ieb,leb,neb,peb,zeb,Ceb,Eeb,Geb,Reb,Ueb,Web,Yeb,nfb,qfb,sfb,ufb,Lfb,Ofb,Qfb,Sfb,bgb,egb,ggb,igb,fhb,ihb,khb,mhb,Jhb,Mhb,Ohb,Qhb,$hb,cib,eib,gib,xib,Aib,Cib,Eib,Nib,Qib,Sib,Uib,bjb,ejb,gjb,ijb,tjb,wjb,yjb,Ajb,Ljb,Ojb,Qjb,Sjb,ekb,hkb,jkb,lkb,wkb,zkb,Bkb,Dkb,Xkb,_kb,alb,clb,zlb,Clb,Elb,Glb,Qlb,Tlb,Vlb,Xlb,Rob,apb,sBb,uBb,vBb,xBb,zBb,BBb,SBb,UBb,VBb,XBb,ZBb,$Bb,kCb,mCb,nCb,pCb,rCb,tCb,sDb,uDb,vDb,xDb,zDb,BDb,LCb,MCb,PCb,QCb,ZCb,$Cb,bDb,eDb,gDb,jDb,lDb,mDb,KDb,LDb,eEb,gEb,hEb,jEb,lEb,nEb,EEb,GEb,HEb,JEb,LEb,NEb,ZEb,$Eb,aFb,cFb,eFb,gFb,vFb,xFb,yFb,AFb,CFb,EFb,PFb,RFb,SFb,UFb,WFb,YFb,WHb,AGb,BGb,CGb,EGb,GGb,IGb,MGb,OGb,QGb,WGb,XGb,YGb,_Gb,cHb,eHb,gHb,iHb,kHb,mHb,oHb,bIb,cIb,dIb,BHb,HHb,JHb,sIb,uIb,wIb,HIb,IIb,JIb,lKb,mKb,nKb,pKb,rKb,vKb,xKb,zKb,HKb,TKb,ELb,GLb,ILb,PLb,RLb,TLb,VLb,dNb,wNb,TNb,kOb,pOb,rOb,sOb,jSb,oSb,pSb,tSb,zSb,YSb,IYb,KYb,LYb,NYb,PYb,RYb,CZb,EZb,FZb,HZb,JZb,LZb,XZb,ZZb,_Zb,a_b,c_b,e_b,p_b,r_b,s_b,u_b,w_b,y_b,K_b,M_b,N_b,P_b,R_b,T_b,c$b,e$b,f$b,h$b,j$b,l$b,y$b,A$b,B$b,D$b,F$b,H$b,T$b,V$b,W$b,Y$b,_$b,a0b,o0b,q0b,r0b,t0b,v0b,x0b,H0b,J0b,K0b,M0b,O0b,Q0b,_0b,a1b,b1b,d1b,f1b,h1b,s1b,u1b,v1b,x1b,z1b,B1b,L1b,N1b,O1b,Q1b,S1b,U1b,d2b,f2b,g2b,i2b,k2b,m2b,x2b,z2b,A2b,C2b,E2b,G2b,S2b,U2b,V2b,X2b,Z2b,$2b,m3b,o3b,p3b,r3b,t3b,v3b,J3b,L3b,M3b,O3b,Q3b,S3b,c4b,e4b,f4b,h4b,j4b,l4b,A4b,C4b,D4b,F4b,H4b,J4b,U4b,W4b,X4b,Z4b,$4b,b5b,n5b,p5b,q5b,s5b,u5b,w5b,J5b,L5b,M5b,O5b,Q5b,S5b,a6b,c6b,d6b,f6b,h6b,j6b,C6b,E6b,F6b,H6b,J6b,L6b,X6b,Z6b,_6b,a7b,c7b,e7b,t7b,v7b,w7b,y7b,A7b,C7b,S8b,U8b,aec,eec,V8b,$ac,abc,wcc,Dcc,Occ,Pcc,Wcc,Xcc,voc,mtc,ntc,ptc,qtc,Kuc,Ruc,Yuc,Zuc,dvc,evc,uxc,Bxc,Cxc,Dxc,Exc,Fxc,Gxc,Hxc,fyc,myc,nyc,oyc,pyc,qyc,ryc,syc,dzc,ezc,jzc,pzc,qzc,vzc,Azc,Bzc,Gzc,Lzc,Mzc,Rzc,KAc,LAc,NAc,aBc,bBc,dBc,IBc,JBc,PBc,QBc,VAc,WAc,YAc,jBc,kBc,mBc,pFc,xFc,$x,cy,dy,Tk,Uk,Vk,Wk,al,bl,gl,jl,MA,qk,PA,_v,bw,Vv,ow,rw,jw,Ew,Hw,zw,Uw,Xw,Pw,kx,ox,dx,Cx,Fx,xx,Sx,Vx,Nx,Rn,lp,Mp,_E,dF,gF,jF,EF,GF,HF,LF,NF,OF,SF,VF,XF,ZF,$F,aG,eG,kG,mG,oG,qG,rG,uG,vG,xG,zG,BG,CG,NG,RG,TG,VG,XG,ZG,_G,kH,mH,nH,zH,DH,FH,HH,JH,KH,dI,fI,hI,sI,uI,vI,JI,MI,OI,QI,SI,TI,_I,bJ,dJ,fJ,pJ,qJ,rPb,GJ,IJ,JJ,QJ,TJ,VJ,XJ,ZJ,_J,kK,mK,oK,qK,sK,tK,FK,IK,KK,MK,OK,PK,UK,ZK,$K,Q4,S4,X4,Z4,a5,K0,d5,_0,g5,z0,j5,D0,Rga,Vga,g6a,xPb,BPb,CQb,GQb,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc,rPc];var $i=[sPc,tB,KN,HN,IN,JN,sPc,sPc];var aj=[tPc,Hm];var bj=[uPc,qB,xm,uPc];var cj=[vPc,XW,DX,NX,DC,vPc,vPc,vPc];var dj=[wPc,HG];var ej=[xPc,lQb,Mn,AC,Kq,ss,yt,PH,jI,zu,DJ,bv,xPc,xPc,xPc,xPc];var fj=[yPc,rp,xp,fE];var gj=[zPc,pv];var hj=[APc,Tsc,Ysc,atc,hFa,FIa,FMa,$Oa,uOa,aOa,WMa,YMa,yPa,HQa,OPa,mQa,sRa,PRa,pSa,RSa,wTa,eVa,vVa,OVa,dWa,vWa,NWa,dXa,uXa,MXa,fYa,jZa,zZa,PZa,d_a,t_a,J_a,Z_a,n$a,D$a,U$a,i0a,y0a,U0a,j1a,z1a,P1a,d2a,t2a,J2a,_2a,o3a,E3a,U3a,i4a,z4a,P4a,d5a,t5a,J5a,a6a,u6a,L6a,a7a,s7a,K7a,$7a,r8a,K8a,a9a,r9a,I9a,Z9a,pab,Gab,Zab,obb,Gbb,Ybb,ncb,Lcb,$cb,pdb,Fdb,Ydb,qeb,Heb,Zeb,vfb,Tfb,jgb,nhb,Rhb,hib,Fib,Vib,jjb,Bjb,Tjb,mkb,Ekb,dlb,Hlb,Ylb,Sob,Tob,Uob,Vob,Wob,Xob,Yob,Zob,bqb,Aqb,Qqb,hrb,isb,Msb,atb,qtb,Gtb,Wtb,kub,Aub,Qub,ivb,nwb,qxb,Hyb,Tyb,kzb,Azb,qAb,FAb,CBb,aCb,uCb,CDb,JCb,hDb,oEb,OEb,hFb,FFb,ZFb,bNb,eNb,fNb,uNb,xNb,RNb,UNb,bQb,gSb,mSb,Plc,rSb,wSb,uWb,SYb,MZb,f_b,z_b,U_b,m$b,I$b,b0b,y0b,R0b,i1b,C1b,V1b,n2b,H2b,a3b,w3b,T3b,m4b,K4b,c5b,x5b,T5b,k6b,M6b,f7b,D7b,r8b,s8b,u8b,HSb,m9b,H9b,I9b,K9b,M9b,O9b,T9b,U9b,V9b,W9b,Z9b,$9b,aac,jbc,kbc,tcc,zcc,Jcc,Lcc,Kec,Lec,Rec,efc,rfc,Gfc,Sfc,cgc,ogc,Agc,Mgc,Ygc,Ajc,gkc,woc,xoc,Doc,Eoc,Ppc,jtc,otc,stc,Luc,Suc,mvc,svc,yAc,DAc,wBc,yBc,BBc,WBc,$Bc,bCc,eCc,VEc,zFc,BFc,gy,hy,my,wy,Ay,Ey,Iy,Ky,Oy,Qy,zl,Ty,Cl,Wy,Fl,Zy,Il,az,Ll,Ol,Sl,KA,fw,Xv,vw,lw,Lw,Bw,$w,Rw,sx,fx,Jx,zx,Zx,Px,wn,iC,Eo,TC,pD,sD,UD,YD,nr,TE,WE,XE,ZE,ls,bF,sG,LG,nI,HI,YI,hJ,OJ,iK,SK,o5,Onc,pqc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc,APc];var ij=[BPc,ip];var jj=[CPc,dB];var kj=[DPc,vD];var lj=[EPc,bu];var mj=[FPc,QE,QF,xH,DK,FPc,FPc,FPc];var nj=[GPc,Zda,_da,$da,aea,bea,GPc,GPc];var oj=[HPc,Jq,rs,xt,OH,yu,CJ,av];var pj=[IPc,fz,gz,cp,kD,dE,IPc,IPc];var qj=[JPc,SD];var rj=[KPc,eF];var sj=[LPc,EI];var tj=[MPc,WKb,Rs,At,Lu,MPc,MPc,MPc];var uj=[NPc];var vj=[OPc,fK];var wj=[PPc,NE,AK,PPc];var xj=[QPc,xK];var yj=[RPc,by,jz,nz,tz,xz,Bz,Fz,Jz,Nz,Rz,aA,iA,mA,sA,yA,CA,aw,qw,Gw,Ww,nx,Ex,Ux,cF,WF,lG,wG,SG,EH,eI,NI,cJ,oJ,UJ,nK,JK,_K,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc,RPc];var zj=[SPc,OE,BK,SPc];var Aj=[TPc,bp,jD,Op];var Bj=[UPc,LE,yK,UPc];var Cj=[VPc,Gm];var Dj=[WPc,sJ];var Ej=[XPc,bD];var Fj=[YPc,YK];var Gj=[ZPc,kE,jJ,Eu];var Hj=[_Pc,jp];var Ij=[$Pc,SS,Axc,lyc,HAc,IAc,ZAc,_Ac,SAc,TAc,gBc,hBc,$Pc,$Pc,$Pc,$Pc];var Jj=[aQc,BB];var Kj=[bQc,nF];var Lj=[cQc,ty,ZA,$A,fB,om,du,cQc];var Mj=[dQc,CC];return{dynCall_vididdi:YLc,dynCall_iiidii:vMc,dynCall_viiiidiidd:bKc,dynCall_viiiiiiiiidd:jMc,dynCall_viiiddiiid:aKc,dynCall_viiiiidi:HJc,dynCall_viiidiiiidi:TKc,_bitshift64Lshr:aJc,dynCall_viiiiddidd:NLc,__GLOBAL__sub_I_opencv_caffe_pb_cc:rgb,dynCall_viiiiidd:PJc,dynCall_viiididi:KLc,__GLOBAL__sub_I_versions_pb_cc:BSa,dynCall_viiidddii:rLc,dynCall_iiiddiiid:iKc,dynCall_viiiiiiiiiid:zJc,dynCall_diii:OKc,dynCall_viiiiiiiiiii:yJc,_bitshift64Ashr:$Ic,dynCall_viiiiidiiddi:xLc,_sbrk:eJc,__GLOBAL__sub_I_imgwarp_cpp:Koa,_memcpy:dJc,dynCall_viiiiddii:gMc,dynCall_iiiiiddiddi:ZJc,dynCall_vi:ULc,dynCall_iiiiiiiiiiiiiii:qMc,dynCall_iiid:iMc,__GLOBAL__sub_I_bind_cpp:loc,dynCall_viiiiddiiid:LJc,dynCall_viiidiiii:CKc,dynCall_viiiiiidd:ZLc,dynCall_viiiiddiiii:JJc,dynCall_vidiii:IMc,dynCall_viiidiiid:wKc,dynCall_iiii:dMc,dynCall_iiidd:hLc,__GLOBAL__I_000101:yuc,dynCall_viidiiiiiii:eLc,dynCall_viidiiid:pKc,_emscripten_get_global_libc:Foc,dynCall_iiidiiiii:xMc,dynCall_iiiiiiii:jKc,dynCall_viidiiii:rKc,dynCall_viiddidd:CJc,stackSave:Oj,dynCall_viiiii:cLc,___cxa_can_catch:QIc,_free:poc,runPostSets:SIc,dynCall_viiiiii:BKc,dynCall_viiiid:jLc,dynCall_viiiiid:zKc,dynCall_diiiddi:tKc,dynCall_iiiiiddi:NKc,dynCall_iiidiiii:IKc,dynCall_iiiiii:WKc,dynCall_viiiiddid:hMc,dynCall_viiiiiiidi:MJc,dynCall_viiiiddd:oJc,dynCall_diiiiiiii:vKc,dynCall_viiiidiiddi:UJc,dynCall_viiiiddi:vJc,__GLOBAL__sub_I_persistence_types_cpp:P4,__GLOBAL__sub_I_system_cpp:G5,dynCall_viiidddd:AJc,dynCall_iiiidd:OJc,dynCall_viiiddddi:wJc,dynCall_viiidddi:fKc,dynCall_iiiidi:GJc,dynCall_vidii:_Lc,dynCall_viiiddiii:bMc,setThrew:Rj,dynCall_viiiiiiiddi:XLc,dynCall_viiiiiddi:qJc,dynCall_viid:RLc,dynCall_viiiiddiddi:QJc,dynCall_viiddiiid:bLc,dynCall_viiiiidiiiii:eKc,dynCall_viiiddiiiid:UKc,dynCall_viiiddiiii:$Jc,dynCall_iiiii:dKc,dynCall_viiiddidddd:yLc,___cxa_is_pointer_type:RIc,_llvm_ctlz_i64:iJc,dynCall_iiiid:hKc,dynCall_viididdi:FLc,dynCall_viiiidddd:fMc,__GLOBAL__sub_I_status_cc:ETb,dynCall_iiidiii:sMc,dynCall_viiiiidiiii:TLc,dynCall_viiiiidiidd:gKc,dynCall_viiiiddddii:AKc,dynCall_viiiiiiidd:KJc,dynCall_viiiddd:PKc,stackAlloc:Nj,dynCall_iiiiidd:oMc,dynCall_viiiddi:VKc,dynCall_iiiiidi:rMc,dynCall_viiiiidiii:CMc,__GLOBAL__sub_I_color_lab_cpp:Zya,___divdi3:kJc,getTempRet0:Tj,dynCall_iiidiiiiiii:yKc,dynCall_viiiidddi:$Kc,dynCall_viididii:eMc,dynCall_diiii:wLc,dynCall_viiiidi:aMc,dynCall_viiid:XKc,dynCall_dii:_Jc,dynCall_vdii:XJc,__GLOBAL__sub_I_dnn_cpp:nFa,dynCall_viiii:aLc,dynCall_iiidiiiiii:tMc,_llvm_bswap_i32:hJc,__GLOBAL__sub_I_message_cc:_gc,dynCall_diiiiiii:YJc,dynCall_vididdii:yMc,establishStackSpace:Qj,dynCall_viiiidddiii:OLc,dynCall_viiidddiiii:tLc,dynCall_viiiidii:kMc,__GLOBAL__sub_I_haar_cpp:wPb,__GLOBAL__sub_I_kmeans_cpp:f2,___getTypeName:noc,dynCall_viiiiiiddi:vLc,dynCall_diiiid:mMc,__GLOBAL__sub_I_umatrix_cpp:pQ,dynCall_viiidiiddi:oLc,dynCall_i:uMc,dynCall_iiiidiii:$Lc,dynCall_viiiiiiiiii:KKc,dynCall_iiiiiii:tJc,__GLOBAL__sub_I_graph_pb_cc:cRa,dynCall_diiiiii:wMc,dynCall_vdiii:LLc,dynCall_iiiiiid:nJc,dynCall_viiididii:uKc,dynCall_viiddii:EJc,dynCall_diiiii:lMc,dynCall_iiiiiiiii:EMc,dynCall_iid:CLc,dynCall_iii:ILc,dynCall_viiiidddii:FKc,dynCall_viiddid:FJc,_memset:XIc,dynCall_diiddi:MKc,dynCall_viididi:DMc,__GLOBAL__sub_I_darknet_io_cpp:PAb,dynCall_viiidi:HKc,__GLOBAL__sub_I_prior_box_layer_cpp:_zb,dynCall_viiidd:GKc,dynCall_viiiiiidiiiii:zMc,dynCall_viiiiiii:ELc,_i64Subtract:TIc,dynCall_viiiiddiii:WJc,__GLOBAL__sub_I_init_cpp:xmb,setTempRet0:Sj,dynCall_viiiddiddd:BLc,dynCall_viiiiiid:GLc,dynCall_viiiiidiid:GMc,__GLOBAL__sub_I_op_def_pb_cc:pGb,dynCall_iiiiiddidd:LKc,___remdi3:_Ic,__GLOBAL__sub_I_iostream_cpp:zuc,dynCall_viiiddddii:xKc,dynCall_viiidddiii:oKc,_pthread_cond_broadcast:bJc,__GLOBAL__sub_I_descriptor_pb_cc:U7b,dynCall_viiiiiidiii:EKc,__GLOBAL__sub_I_tensor_shape_pb_cc:$Ra,dynCall_iiidi:gLc,dynCall_viiiiiidiiii:SJc,dynCall_iiiiidii:YKc,__GLOBAL__sub_I_hog_cpp:BQb,dynCall_iiiiidiii:lLc,dynCall_viiiiiidi:DKc,dynCall_vidi:DJc,dynCall_iidi:BJc,_malloc:ooc,__GLOBAL__sub_I_histogram_cpp:Qga,dynCall_viiddiii:lKc,_emscripten_replace_memory:qg,dynCall_viidiii:xJc,dynCall_viiiiddiiiid:VJc,dynCall_v:QLc,dynCall_viiddiid:mKc,__GLOBAL__sub_I_attr_value_pb_cc:hPa,dynCall_viidii:ZKc,dynCall_viiiiiiiiiiid:zLc,dynCall_iiiiiiiididiii:nKc,dynCall_viidi:nLc,dynCall_iiiiiiddi:dLc,___udivdi3:cJc,dynCall_vid:fLc,dynCall_di:RJc,dynCall_diiid:qLc,__GLOBAL__sub_I_tensor_pb_cc:dTa,__GLOBAL__sub_I_opencv_onnx_pb_cc:nmb,dynCall_viidiiiii:QKc,_bitshift64Shl:jJc,dynCall_viiiiiiiiiiddi:sKc,_fflush:aqc,dynCall_viiiiiiid:uLc,__GLOBAL__sub_I_types_pb_cc:gTa,dynCall_viidiiiiii:cMc,_pthread_mutex_lock:WIc,___cxa_demangle:LFc,__GLOBAL__sub_I_detection_output_layer_cpp:uxb,dynCall_iiiiiddid:cKc,___muldi3:mJc,dynCall_viiiidd:HMc,dynCall_vii:iLc,___uremdi3:gJc,dynCall_viiiiiiiii:HLc,dynCall_iiiiiidd:BMc,dynCall_viiiiiiii:sLc,dynCall_iiiddii:RKc,dynCall_viiiiddddi:kLc,_i64Add:UIc,dynCall_viiiiiidii:MLc,_pthread_mutex_unlock:VIc,dynCall_viiidii:pMc,dynCall_iiiiiidi:AMc,dynCall_viiiidiii:pJc,stackRestore:Pj,dynCall_viiddi:JLc,__GLOBAL__sub_I_function_pb_cc:XDb,dynCall_viiiddid:DLc,dynCall_viii:PLc,dynCall_iiiiiiiiiiiii:nMc,dynCall_viiiddii:NJc,dynCall_viiiidiid:sJc,___errno_location:zoc,dynCall_viididdii:FMc,dynCall_viidd:mLc,dynCall_ii:WLc,dynCall_iiiiid:_Kc,_memmove:fJc,dynCall_viiiiidii:ALc,dynCall_viiiddidd:SKc,__GLOBAL__sub_I_bindings_cpp:bL,dynCall_viiddiddd:JKc,dynCall_iiiddi:kKc,dynCall_iiiddiid:SLc,dynCall_viiiidiiiidi:VLc,dynCall_iiiiddi:TJc,dynCall_iiiidii:pLc,dynCall_viiiidiiii:qKc,dynCall_viiidiii:rJc,dynCall_viiiidddiiii:uJc,dynCall_viiddidddd:IJc}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var __GLOBAL__sub_I_attr_value_pb_cc=Module["__GLOBAL__sub_I_attr_value_pb_cc"]=asm["__GLOBAL__sub_I_attr_value_pb_cc"];var __GLOBAL__sub_I_op_def_pb_cc=Module["__GLOBAL__sub_I_op_def_pb_cc"]=asm["__GLOBAL__sub_I_op_def_pb_cc"];var __GLOBAL__sub_I_system_cpp=Module["__GLOBAL__sub_I_system_cpp"]=asm["__GLOBAL__sub_I_system_cpp"];var __GLOBAL__sub_I_umatrix_cpp=Module["__GLOBAL__sub_I_umatrix_cpp"]=asm["__GLOBAL__sub_I_umatrix_cpp"];var stackSave=Module["stackSave"]=asm["stackSave"];var getTempRet0=Module["getTempRet0"]=asm["getTempRet0"];var ___udivdi3=Module["___udivdi3"]=asm["___udivdi3"];var setThrew=Module["setThrew"]=asm["setThrew"];var __GLOBAL__sub_I_graph_pb_cc=Module["__GLOBAL__sub_I_graph_pb_cc"]=asm["__GLOBAL__sub_I_graph_pb_cc"];var __GLOBAL__sub_I_tensor_pb_cc=Module["__GLOBAL__sub_I_tensor_pb_cc"]=asm["__GLOBAL__sub_I_tensor_pb_cc"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var __GLOBAL__sub_I_opencv_onnx_pb_cc=Module["__GLOBAL__sub_I_opencv_onnx_pb_cc"]=asm["__GLOBAL__sub_I_opencv_onnx_pb_cc"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var _sbrk=Module["_sbrk"]=asm["_sbrk"];var _fflush=Module["_fflush"]=asm["_fflush"];var __GLOBAL__sub_I_types_pb_cc=Module["__GLOBAL__sub_I_types_pb_cc"]=asm["__GLOBAL__sub_I_types_pb_cc"];var ___cxa_is_pointer_type=Module["___cxa_is_pointer_type"]=asm["___cxa_is_pointer_type"];var _llvm_ctlz_i64=Module["_llvm_ctlz_i64"]=asm["_llvm_ctlz_i64"];var __GLOBAL__sub_I_haar_cpp=Module["__GLOBAL__sub_I_haar_cpp"]=asm["__GLOBAL__sub_I_haar_cpp"];var _bitshift64Ashr=Module["_bitshift64Ashr"]=asm["_bitshift64Ashr"];var _memset=Module["_memset"]=asm["_memset"];var __GLOBAL__sub_I_status_cc=Module["__GLOBAL__sub_I_status_cc"]=asm["__GLOBAL__sub_I_status_cc"];var ___cxa_demangle=Module["___cxa_demangle"]=asm["___cxa_demangle"];var __GLOBAL__sub_I_detection_output_layer_cpp=Module["__GLOBAL__sub_I_detection_output_layer_cpp"]=asm["__GLOBAL__sub_I_detection_output_layer_cpp"];var __GLOBAL__sub_I_imgwarp_cpp=Module["__GLOBAL__sub_I_imgwarp_cpp"]=asm["__GLOBAL__sub_I_imgwarp_cpp"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var __GLOBAL__sub_I_darknet_io_cpp=Module["__GLOBAL__sub_I_darknet_io_cpp"]=asm["__GLOBAL__sub_I_darknet_io_cpp"];var _llvm_bswap_i32=Module["_llvm_bswap_i32"]=asm["_llvm_bswap_i32"];var ___muldi3=Module["___muldi3"]=asm["___muldi3"];var __GLOBAL__sub_I_prior_box_layer_cpp=Module["__GLOBAL__sub_I_prior_box_layer_cpp"]=asm["__GLOBAL__sub_I_prior_box_layer_cpp"];var __GLOBAL__sub_I_versions_pb_cc=Module["__GLOBAL__sub_I_versions_pb_cc"]=asm["__GLOBAL__sub_I_versions_pb_cc"];var ___uremdi3=Module["___uremdi3"]=asm["___uremdi3"];var __GLOBAL__sub_I_color_lab_cpp=Module["__GLOBAL__sub_I_color_lab_cpp"]=asm["__GLOBAL__sub_I_color_lab_cpp"];var ___divdi3=Module["___divdi3"]=asm["___divdi3"];var stackAlloc=Module["stackAlloc"]=asm["stackAlloc"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var __GLOBAL__sub_I_bind_cpp=Module["__GLOBAL__sub_I_bind_cpp"]=asm["__GLOBAL__sub_I_bind_cpp"];var __GLOBAL__sub_I_init_cpp=Module["__GLOBAL__sub_I_init_cpp"]=asm["__GLOBAL__sub_I_init_cpp"];var setTempRet0=Module["setTempRet0"]=asm["setTempRet0"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var __GLOBAL__sub_I_function_pb_cc=Module["__GLOBAL__sub_I_function_pb_cc"]=asm["__GLOBAL__sub_I_function_pb_cc"];var _pthread_mutex_unlock=Module["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var __GLOBAL__I_000101=Module["__GLOBAL__I_000101"]=asm["__GLOBAL__I_000101"];var _emscripten_get_global_libc=Module["_emscripten_get_global_libc"]=asm["_emscripten_get_global_libc"];var ___getTypeName=Module["___getTypeName"]=asm["___getTypeName"];var __GLOBAL__sub_I_iostream_cpp=Module["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var __GLOBAL__sub_I_dnn_cpp=Module["__GLOBAL__sub_I_dnn_cpp"]=asm["__GLOBAL__sub_I_dnn_cpp"];var _pthread_cond_broadcast=Module["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var __GLOBAL__sub_I_descriptor_pb_cc=Module["__GLOBAL__sub_I_descriptor_pb_cc"]=asm["__GLOBAL__sub_I_descriptor_pb_cc"];var ___errno_location=Module["___errno_location"]=asm["___errno_location"];var __GLOBAL__sub_I_message_cc=Module["__GLOBAL__sub_I_message_cc"]=asm["__GLOBAL__sub_I_message_cc"];var __GLOBAL__sub_I_tensor_shape_pb_cc=Module["__GLOBAL__sub_I_tensor_shape_pb_cc"]=asm["__GLOBAL__sub_I_tensor_shape_pb_cc"];var ___cxa_can_catch=Module["___cxa_can_catch"]=asm["___cxa_can_catch"];var _free=Module["_free"]=asm["_free"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var __GLOBAL__sub_I_hog_cpp=Module["__GLOBAL__sub_I_hog_cpp"]=asm["__GLOBAL__sub_I_hog_cpp"];var establishStackSpace=Module["establishStackSpace"]=asm["establishStackSpace"];var _memmove=Module["_memmove"]=asm["_memmove"];var __GLOBAL__sub_I_bindings_cpp=Module["__GLOBAL__sub_I_bindings_cpp"]=asm["__GLOBAL__sub_I_bindings_cpp"];var stackRestore=Module["stackRestore"]=asm["stackRestore"];var _malloc=Module["_malloc"]=asm["_malloc"];var __GLOBAL__sub_I_histogram_cpp=Module["__GLOBAL__sub_I_histogram_cpp"]=asm["__GLOBAL__sub_I_histogram_cpp"];var _pthread_mutex_lock=Module["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var __GLOBAL__sub_I_kmeans_cpp=Module["__GLOBAL__sub_I_kmeans_cpp"]=asm["__GLOBAL__sub_I_kmeans_cpp"];var _emscripten_replace_memory=Module["_emscripten_replace_memory"]=asm["_emscripten_replace_memory"];var ___remdi3=Module["___remdi3"]=asm["___remdi3"];var __GLOBAL__sub_I_opencv_caffe_pb_cc=Module["__GLOBAL__sub_I_opencv_caffe_pb_cc"]=asm["__GLOBAL__sub_I_opencv_caffe_pb_cc"];var __GLOBAL__sub_I_persistence_types_cpp=Module["__GLOBAL__sub_I_persistence_types_cpp"]=asm["__GLOBAL__sub_I_persistence_types_cpp"];var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_viiiiddd=Module["dynCall_viiiiddd"]=asm["dynCall_viiiiddd"];var dynCall_viiiidiii=Module["dynCall_viiiidiii"]=asm["dynCall_viiiidiii"];var dynCall_viiiiiddi=Module["dynCall_viiiiiddi"]=asm["dynCall_viiiiiddi"];var dynCall_viiidiii=Module["dynCall_viiidiii"]=asm["dynCall_viiidiii"];var dynCall_viiiidiid=Module["dynCall_viiiidiid"]=asm["dynCall_viiiidiid"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_viiiidddiiii=Module["dynCall_viiiidddiiii"]=asm["dynCall_viiiidddiiii"];var dynCall_viiiiddi=Module["dynCall_viiiiddi"]=asm["dynCall_viiiiddi"];var dynCall_viiiddddi=Module["dynCall_viiiddddi"]=asm["dynCall_viiiddddi"];var dynCall_viidiii=Module["dynCall_viidiii"]=asm["dynCall_viidiii"];var dynCall_viiiiiiiiiii=Module["dynCall_viiiiiiiiiii"]=asm["dynCall_viiiiiiiiiii"];var dynCall_viiiiiiiiiid=Module["dynCall_viiiiiiiiiid"]=asm["dynCall_viiiiiiiiiid"];var dynCall_viiidddd=Module["dynCall_viiidddd"]=asm["dynCall_viiidddd"];var dynCall_iidi=Module["dynCall_iidi"]=asm["dynCall_iidi"];var dynCall_viiddidd=Module["dynCall_viiddidd"]=asm["dynCall_viiddidd"];var dynCall_vidi=Module["dynCall_vidi"]=asm["dynCall_vidi"];var dynCall_viiddii=Module["dynCall_viiddii"]=asm["dynCall_viiddii"];var dynCall_viiddid=Module["dynCall_viiddid"]=asm["dynCall_viiddid"];var dynCall_iiiidi=Module["dynCall_iiiidi"]=asm["dynCall_iiiidi"];var dynCall_viiiiidi=Module["dynCall_viiiiidi"]=asm["dynCall_viiiiidi"];var dynCall_viiddidddd=Module["dynCall_viiddidddd"]=asm["dynCall_viiddidddd"];var dynCall_viiiiddiiii=Module["dynCall_viiiiddiiii"]=asm["dynCall_viiiiddiiii"];var dynCall_viiiiiiidd=Module["dynCall_viiiiiiidd"]=asm["dynCall_viiiiiiidd"];var dynCall_viiiiddiiid=Module["dynCall_viiiiddiiid"]=asm["dynCall_viiiiddiiid"];var dynCall_viiiiiiidi=Module["dynCall_viiiiiiidi"]=asm["dynCall_viiiiiiidi"];var dynCall_viiiddii=Module["dynCall_viiiddii"]=asm["dynCall_viiiddii"];var dynCall_iiiidd=Module["dynCall_iiiidd"]=asm["dynCall_iiiidd"];var dynCall_viiiiidd=Module["dynCall_viiiiidd"]=asm["dynCall_viiiiidd"];var dynCall_viiiiddiddi=Module["dynCall_viiiiddiddi"]=asm["dynCall_viiiiddiddi"];var dynCall_di=Module["dynCall_di"]=asm["dynCall_di"];var dynCall_viiiiiidiiii=Module["dynCall_viiiiiidiiii"]=asm["dynCall_viiiiiidiiii"];var dynCall_iiiiddi=Module["dynCall_iiiiddi"]=asm["dynCall_iiiiddi"];var dynCall_viiiidiiddi=Module["dynCall_viiiidiiddi"]=asm["dynCall_viiiidiiddi"];var dynCall_viiiiddiiiid=Module["dynCall_viiiiddiiiid"]=asm["dynCall_viiiiddiiiid"];var dynCall_viiiiddiii=Module["dynCall_viiiiddiii"]=asm["dynCall_viiiiddiii"];var dynCall_vdii=Module["dynCall_vdii"]=asm["dynCall_vdii"];var dynCall_diiiiiii=Module["dynCall_diiiiiii"]=asm["dynCall_diiiiiii"];var dynCall_iiiiiddiddi=Module["dynCall_iiiiiddiddi"]=asm["dynCall_iiiiiddiddi"];var dynCall_dii=Module["dynCall_dii"]=asm["dynCall_dii"];var dynCall_viiiddiiii=Module["dynCall_viiiddiiii"]=asm["dynCall_viiiddiiii"];var dynCall_viiiddiiid=Module["dynCall_viiiddiiid"]=asm["dynCall_viiiddiiid"];var dynCall_viiiidiidd=Module["dynCall_viiiidiidd"]=asm["dynCall_viiiidiidd"];var dynCall_iiiiiddid=Module["dynCall_iiiiiddid"]=asm["dynCall_iiiiiddid"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viiiiidiiiii=Module["dynCall_viiiiidiiiii"]=asm["dynCall_viiiiidiiiii"];var dynCall_viiidddi=Module["dynCall_viiidddi"]=asm["dynCall_viiidddi"];var dynCall_viiiiidiidd=Module["dynCall_viiiiidiidd"]=asm["dynCall_viiiiidiidd"];var dynCall_iiiid=Module["dynCall_iiiid"]=asm["dynCall_iiiid"];var dynCall_iiiddiiid=Module["dynCall_iiiddiiid"]=asm["dynCall_iiiddiiid"];var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_iiiddi=Module["dynCall_iiiddi"]=asm["dynCall_iiiddi"];var dynCall_viiddiii=Module["dynCall_viiddiii"]=asm["dynCall_viiddiii"];var dynCall_viiddiid=Module["dynCall_viiddiid"]=asm["dynCall_viiddiid"];var dynCall_iiiiiiiididiii=Module["dynCall_iiiiiiiididiii"]=asm["dynCall_iiiiiiiididiii"];var dynCall_viiidddiii=Module["dynCall_viiidddiii"]=asm["dynCall_viiidddiii"];var dynCall_viidiiid=Module["dynCall_viidiiid"]=asm["dynCall_viidiiid"];var dynCall_viiiidiiii=Module["dynCall_viiiidiiii"]=asm["dynCall_viiiidiiii"];var dynCall_viidiiii=Module["dynCall_viidiiii"]=asm["dynCall_viidiiii"];var dynCall_viiiiiiiiiiddi=Module["dynCall_viiiiiiiiiiddi"]=asm["dynCall_viiiiiiiiiiddi"];var dynCall_diiiddi=Module["dynCall_diiiddi"]=asm["dynCall_diiiddi"];var dynCall_viiididii=Module["dynCall_viiididii"]=asm["dynCall_viiididii"];var dynCall_diiiiiiii=Module["dynCall_diiiiiiii"]=asm["dynCall_diiiiiiii"];var dynCall_viiidiiid=Module["dynCall_viiidiiid"]=asm["dynCall_viiidiiid"];var dynCall_viiiddddii=Module["dynCall_viiiddddii"]=asm["dynCall_viiiddddii"];var dynCall_iiidiiiiiii=Module["dynCall_iiidiiiiiii"]=asm["dynCall_iiidiiiiiii"];var dynCall_viiiiid=Module["dynCall_viiiiid"]=asm["dynCall_viiiiid"];var dynCall_viiiiddddii=Module["dynCall_viiiiddddii"]=asm["dynCall_viiiiddddii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_viiidiiii=Module["dynCall_viiidiiii"]=asm["dynCall_viiidiiii"];var dynCall_viiiiiidi=Module["dynCall_viiiiiidi"]=asm["dynCall_viiiiiidi"];var dynCall_viiiiiidiii=Module["dynCall_viiiiiidiii"]=asm["dynCall_viiiiiidiii"];var dynCall_viiiidddii=Module["dynCall_viiiidddii"]=asm["dynCall_viiiidddii"];var dynCall_viiidd=Module["dynCall_viiidd"]=asm["dynCall_viiidd"];var dynCall_viiidi=Module["dynCall_viiidi"]=asm["dynCall_viiidi"];var dynCall_iiidiiii=Module["dynCall_iiidiiii"]=asm["dynCall_iiidiiii"];var dynCall_viiddiddd=Module["dynCall_viiddiddd"]=asm["dynCall_viiddiddd"];var dynCall_viiiiiiiiii=Module["dynCall_viiiiiiiiii"]=asm["dynCall_viiiiiiiiii"];var dynCall_iiiiiddidd=Module["dynCall_iiiiiddidd"]=asm["dynCall_iiiiiddidd"];var dynCall_diiddi=Module["dynCall_diiddi"]=asm["dynCall_diiddi"];var dynCall_iiiiiddi=Module["dynCall_iiiiiddi"]=asm["dynCall_iiiiiddi"];var dynCall_diii=Module["dynCall_diii"]=asm["dynCall_diii"];var dynCall_viiiddd=Module["dynCall_viiiddd"]=asm["dynCall_viiiddd"];var dynCall_viidiiiii=Module["dynCall_viidiiiii"]=asm["dynCall_viidiiiii"];var dynCall_iiiddii=Module["dynCall_iiiddii"]=asm["dynCall_iiiddii"];var dynCall_viiiddidd=Module["dynCall_viiiddidd"]=asm["dynCall_viiiddidd"];var dynCall_viiidiiiidi=Module["dynCall_viiidiiiidi"]=asm["dynCall_viiidiiiidi"];var dynCall_viiiddiiiid=Module["dynCall_viiiddiiiid"]=asm["dynCall_viiiddiiiid"];var dynCall_viiiddi=Module["dynCall_viiiddi"]=asm["dynCall_viiiddi"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_viiid=Module["dynCall_viiid"]=asm["dynCall_viiid"];var dynCall_iiiiidii=Module["dynCall_iiiiidii"]=asm["dynCall_iiiiidii"];var dynCall_viidii=Module["dynCall_viidii"]=asm["dynCall_viidii"];var dynCall_iiiiid=Module["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_viiiidddi=Module["dynCall_viiiidddi"]=asm["dynCall_viiiidddi"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];var dynCall_viiddiiid=Module["dynCall_viiddiiid"]=asm["dynCall_viiddiiid"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_iiiiiiddi=Module["dynCall_iiiiiiddi"]=asm["dynCall_iiiiiiddi"];var dynCall_viidiiiiiii=Module["dynCall_viidiiiiiii"]=asm["dynCall_viidiiiiiii"];var dynCall_vid=Module["dynCall_vid"]=asm["dynCall_vid"];var dynCall_iiidi=Module["dynCall_iiidi"]=asm["dynCall_iiidi"];var dynCall_iiidd=Module["dynCall_iiidd"]=asm["dynCall_iiidd"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_viiiid=Module["dynCall_viiiid"]=asm["dynCall_viiiid"];var dynCall_viiiiddddi=Module["dynCall_viiiiddddi"]=asm["dynCall_viiiiddddi"];var dynCall_iiiiidiii=Module["dynCall_iiiiidiii"]=asm["dynCall_iiiiidiii"];var dynCall_viidd=Module["dynCall_viidd"]=asm["dynCall_viidd"];var dynCall_viidi=Module["dynCall_viidi"]=asm["dynCall_viidi"];var dynCall_viiidiiddi=Module["dynCall_viiidiiddi"]=asm["dynCall_viiidiiddi"];var dynCall_iiiidii=Module["dynCall_iiiidii"]=asm["dynCall_iiiidii"];var dynCall_diiid=Module["dynCall_diiid"]=asm["dynCall_diiid"];var dynCall_viiidddii=Module["dynCall_viiidddii"]=asm["dynCall_viiidddii"];var dynCall_viiiiiiii=Module["dynCall_viiiiiiii"]=asm["dynCall_viiiiiiii"];var dynCall_viiidddiiii=Module["dynCall_viiidddiiii"]=asm["dynCall_viiidddiiii"];var dynCall_viiiiiiid=Module["dynCall_viiiiiiid"]=asm["dynCall_viiiiiiid"];var dynCall_viiiiiiddi=Module["dynCall_viiiiiiddi"]=asm["dynCall_viiiiiiddi"];var dynCall_diiii=Module["dynCall_diiii"]=asm["dynCall_diiii"];var dynCall_viiiiidiiddi=Module["dynCall_viiiiidiiddi"]=asm["dynCall_viiiiidiiddi"];var dynCall_viiiddidddd=Module["dynCall_viiiddidddd"]=asm["dynCall_viiiddidddd"];var dynCall_viiiiiiiiiiid=Module["dynCall_viiiiiiiiiiid"]=asm["dynCall_viiiiiiiiiiid"];var dynCall_viiiiidii=Module["dynCall_viiiiidii"]=asm["dynCall_viiiiidii"];var dynCall_viiiddiddd=Module["dynCall_viiiddiddd"]=asm["dynCall_viiiddiddd"];var dynCall_iid=Module["dynCall_iid"]=asm["dynCall_iid"];var dynCall_viiiddid=Module["dynCall_viiiddid"]=asm["dynCall_viiiddid"];var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viididdi=Module["dynCall_viididdi"]=asm["dynCall_viididdi"];var dynCall_viiiiiid=Module["dynCall_viiiiiid"]=asm["dynCall_viiiiiid"];var dynCall_viiiiiiiii=Module["dynCall_viiiiiiiii"]=asm["dynCall_viiiiiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_viiddi=Module["dynCall_viiddi"]=asm["dynCall_viiddi"];var dynCall_viiididi=Module["dynCall_viiididi"]=asm["dynCall_viiididi"];var dynCall_vdiii=Module["dynCall_vdiii"]=asm["dynCall_vdiii"];var dynCall_viiiiiidii=Module["dynCall_viiiiiidii"]=asm["dynCall_viiiiiidii"];var dynCall_viiiiddidd=Module["dynCall_viiiiddidd"]=asm["dynCall_viiiiddidd"];var dynCall_viiiidddiii=Module["dynCall_viiiidddiii"]=asm["dynCall_viiiidddiii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_viid=Module["dynCall_viid"]=asm["dynCall_viid"];var dynCall_iiiddiid=Module["dynCall_iiiddiid"]=asm["dynCall_iiiddiid"];var dynCall_viiiiidiiii=Module["dynCall_viiiiidiiii"]=asm["dynCall_viiiiidiiii"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_viiiidiiiidi=Module["dynCall_viiiidiiiidi"]=asm["dynCall_viiiidiiiidi"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_viiiiiiiddi=Module["dynCall_viiiiiiiddi"]=asm["dynCall_viiiiiiiddi"];var dynCall_vididdi=Module["dynCall_vididdi"]=asm["dynCall_vididdi"];var dynCall_viiiiiidd=Module["dynCall_viiiiiidd"]=asm["dynCall_viiiiiidd"];var dynCall_vidii=Module["dynCall_vidii"]=asm["dynCall_vidii"];var dynCall_iiiidiii=Module["dynCall_iiiidiii"]=asm["dynCall_iiiidiii"];var dynCall_viiiidi=Module["dynCall_viiiidi"]=asm["dynCall_viiiidi"];var dynCall_viiiddiii=Module["dynCall_viiiddiii"]=asm["dynCall_viiiddiii"];var dynCall_viidiiiiii=Module["dynCall_viidiiiiii"]=asm["dynCall_viidiiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viididii=Module["dynCall_viididii"]=asm["dynCall_viididii"];var dynCall_viiiidddd=Module["dynCall_viiiidddd"]=asm["dynCall_viiiidddd"];var dynCall_viiiiddii=Module["dynCall_viiiiddii"]=asm["dynCall_viiiiddii"];var dynCall_viiiiddid=Module["dynCall_viiiiddid"]=asm["dynCall_viiiiddid"];var dynCall_iiid=Module["dynCall_iiid"]=asm["dynCall_iiid"];var dynCall_viiiiiiiiidd=Module["dynCall_viiiiiiiiidd"]=asm["dynCall_viiiiiiiiidd"];var dynCall_viiiidii=Module["dynCall_viiiidii"]=asm["dynCall_viiiidii"];var dynCall_diiiii=Module["dynCall_diiiii"]=asm["dynCall_diiiii"];var dynCall_diiiid=Module["dynCall_diiiid"]=asm["dynCall_diiiid"];var dynCall_iiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiiii"];var dynCall_iiiiidd=Module["dynCall_iiiiidd"]=asm["dynCall_iiiiidd"];var dynCall_viiidii=Module["dynCall_viiidii"]=asm["dynCall_viiidii"];var dynCall_iiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiiiiii"];var dynCall_iiiiidi=Module["dynCall_iiiiidi"]=asm["dynCall_iiiiidi"];var dynCall_iiidiii=Module["dynCall_iiidiii"]=asm["dynCall_iiidiii"];var dynCall_iiidiiiiii=Module["dynCall_iiidiiiiii"]=asm["dynCall_iiidiiiiii"];var dynCall_i=Module["dynCall_i"]=asm["dynCall_i"];var dynCall_iiidii=Module["dynCall_iiidii"]=asm["dynCall_iiidii"];var dynCall_diiiiii=Module["dynCall_diiiiii"]=asm["dynCall_diiiiii"];var dynCall_iiidiiiii=Module["dynCall_iiidiiiii"]=asm["dynCall_iiidiiiii"];var dynCall_vididdii=Module["dynCall_vididdii"]=asm["dynCall_vididdii"];var dynCall_viiiiiidiiiii=Module["dynCall_viiiiiidiiiii"]=asm["dynCall_viiiiiidiiiii"];var dynCall_iiiiiidi=Module["dynCall_iiiiiidi"]=asm["dynCall_iiiiiidi"];var dynCall_iiiiiidd=Module["dynCall_iiiiiidd"]=asm["dynCall_iiiiiidd"];var dynCall_viiiiidiii=Module["dynCall_viiiiidiii"]=asm["dynCall_viiiiidiii"];var dynCall_viididi=Module["dynCall_viididi"]=asm["dynCall_viididi"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_viididdii=Module["dynCall_viididdii"]=asm["dynCall_viididdii"];var dynCall_viiiiidiid=Module["dynCall_viiiiidiid"]=asm["dynCall_viiiiidiid"];var dynCall_viiiidd=Module["dynCall_viiiidd"]=asm["dynCall_viiiidd"];var dynCall_vidiii=Module["dynCall_vidiii"]=asm["dynCall_vidiii"];Runtime.stackAlloc=Module["stackAlloc"];Runtime.stackSave=Module["stackSave"];Runtime.stackRestore=Module["stackRestore"];Runtime.establishStackSpace=Module["establishStackSpace"];Runtime.setTempRet0=Module["setTempRet0"];Runtime.getTempRet0=Module["getTempRet0"];Module["asm"]=asm;Module["then"]=(function(func){if(Module["calledRun"]){func(Module)}else{var old=Module["onRuntimeInitialized"];Module["onRuntimeInitialized"]=(function(){if(old)old();func(Module)})}return Module});function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{var toLog=e;if(e&&typeof e==="object"&&e.stack){toLog=[e,e.stack]}Module.printErr("exception thrown: "+toLog);Module["quit"](1,e)}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}Module["quit"](status,new ExitStatus(status))}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(Module["onAbort"]){Module["onAbort"](what)}if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}run();Module["imread"]=(function(imageSource){var img=null;if(typeof imageSource==="string"){img=document.getElementById(imageSource)}else{img=imageSource}var canvas=null;var ctx=null;if(img instanceof HTMLImageElement){canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;ctx=canvas.getContext("2d");ctx.drawImage(img,0,0,img.width,img.height)}else if(img instanceof HTMLCanvasElement){canvas=img;ctx=canvas.getContext("2d")}else{throw new Error("Please input the valid canvas or img id.");return}var imgData=ctx.getImageData(0,0,canvas.width,canvas.height);return cv.matFromImageData(imgData)});Module["imshow"]=(function(canvasSource,mat){var canvas=null;if(typeof canvasSource==="string"){canvas=document.getElementById(canvasSource)}else{canvas=canvasSource}if(!(canvas instanceof HTMLCanvasElement)){throw new Error("Please input the valid canvas element or id.");return}if(!(mat instanceof cv.Mat)){throw new Error("Please input the valid cv.Mat instance.");return}var img=new cv.Mat;var depth=mat.type()%8;var scale=depth<=cv.CV_8S?1:depth<=cv.CV_32S?1/256:255;var shift=depth===cv.CV_8S||depth===cv.CV_16S?128:0;mat.convertTo(img,cv.CV_8U,scale,shift);switch(img.type()){case cv.CV_8UC1:cv.cvtColor(img,img,cv.COLOR_GRAY2RGBA);break;case cv.CV_8UC3:cv.cvtColor(img,img,cv.COLOR_RGB2RGBA);break;case cv.CV_8UC4:break;default:throw new Error("Bad number of channels (Source image must have 1, 3 or 4 channels)");return}var imgData=new ImageData(new Uint8ClampedArray(img.data),img.cols,img.rows);var ctx=canvas.getContext("2d");ctx.clearRect(0,0,canvas.width,canvas.height);canvas.width=imgData.width;canvas.height=imgData.height;ctx.putImageData(imgData,0,0);img.delete()});Module["VideoCapture"]=(function(videoSource){var video=null;if(typeof videoSource==="string"){video=document.getElementById(videoSource)}else{video=videoSource}if(!(video instanceof HTMLVideoElement)){throw new Error("Please input the valid video element or id.");return}var canvas=document.createElement("canvas");canvas.width=video.width;canvas.height=video.height;var ctx=canvas.getContext("2d");this.video=video;this.read=(function(frame){if(!(frame instanceof cv.Mat)){throw new Error("Please input the valid cv.Mat instance.");return}if(frame.type()!==cv.CV_8UC4){throw new Error("Bad type of input mat: the type should be cv.CV_8UC4.");return}if(frame.cols!==video.width||frame.rows!==video.height){throw new Error("Bad size of input mat: the size should be same as the video.");return}ctx.drawImage(video,0,0,video.width,video.height);frame.data.set(ctx.getImageData(0,0,video.width,video.height).data)})});function Range(start,end){this.start=typeof start==="undefined"?0:start;this.end=typeof end==="undefined"?0:end}Module["Range"]=Range;function Point(x,y){this.x=typeof x==="undefined"?0:x;this.y=typeof y==="undefined"?0:y}Module["Point"]=Point;function Size(width,height){this.width=typeof width==="undefined"?0:width;this.height=typeof height==="undefined"?0:height}Module["Size"]=Size;function Rect(){switch(arguments.length){case 0:{this.x=0;this.y=0;this.width=0;this.height=0;break};case 1:{var rect=arguments[0];this.x=rect.x;this.y=rect.y;this.width=rect.width;this.height=rect.height;break};case 2:{var point=arguments[0];var size=arguments[1];this.x=point.x;this.y=point.y;this.width=size.width;this.height=size.height;break};case 4:{this.x=arguments[0];this.y=arguments[1];this.width=arguments[2];this.height=arguments[3];break};default:{throw new Error("Invalid arguments")}}}Module["Rect"]=Rect;function RotatedRect(){switch(arguments.length){case 0:{this.center={x:0,y:0};this.size={width:0,height:0};this.angle=0;break};case 3:{this.center=arguments[0];this.size=arguments[1];this.angle=arguments[2];break};default:{throw new Error("Invalid arguments")}}}RotatedRect.points=(function(obj){return Module.rotatedRectPoints(obj)});RotatedRect.boundingRect=(function(obj){return Module.rotatedRectBoundingRect(obj)});RotatedRect.boundingRect2f=(function(obj){return Module.rotatedRectBoundingRect2f(obj)});Module["RotatedRect"]=RotatedRect;function Scalar(v0,v1,v2,v3){this.push(typeof v0==="undefined"?0:v0);this.push(typeof v1==="undefined"?0:v1);this.push(typeof v2==="undefined"?0:v2);this.push(typeof v3==="undefined"?0:v3)}Scalar.prototype=new Array;Scalar.all=(function(v){return new Scalar(v,v,v,v)});Module["Scalar"]=Scalar;function MinMaxLoc(){switch(arguments.length){case 0:{this.minVal=0;this.maxVal=0;this.minLoc=new Point;this.maxLoc=new Point;break};case 4:{this.minVal=arguments[0];this.maxVal=arguments[1];this.minLoc=arguments[2];this.maxLoc=arguments[3];break};default:{throw new Error("Invalid arguments")}}}Module["MinMaxLoc"]=MinMaxLoc;function Circle(){switch(arguments.length){case 0:{this.center=new Point;this.radius=0;break};case 2:{this.center=arguments[0];this.radius=arguments[1];break};default:{throw new Error("Invalid arguments")}}}Module["Circle"]=Circle;function TermCriteria(){switch(arguments.length){case 0:{this.type=0;this.maxCount=0;this.epsilon=0;break};case 3:{this.type=arguments[0];this.maxCount=arguments[1];this.epsilon=arguments[2];break};default:{throw new Error("Invalid arguments")}}}Module["TermCriteria"]=TermCriteria;Module["matFromArray"]=(function(rows,cols,type,array){var mat=new cv.Mat(rows,cols,type);switch(type){case cv.CV_8U:case cv.CV_8UC1:case cv.CV_8UC2:case cv.CV_8UC3:case cv.CV_8UC4:{mat.data.set(array);break};case cv.CV_8S:case cv.CV_8SC1:case cv.CV_8SC2:case cv.CV_8SC3:case cv.CV_8SC4:{mat.data8S.set(array);break};case cv.CV_16U:case cv.CV_16UC1:case cv.CV_16UC2:case cv.CV_16UC3:case cv.CV_16UC4:{mat.data16U.set(array);break};case cv.CV_16S:case cv.CV_16SC1:case cv.CV_16SC2:case cv.CV_16SC3:case cv.CV_16SC4:{mat.data16S.set(array);break};case cv.CV_32S:case cv.CV_32SC1:case cv.CV_32SC2:case cv.CV_32SC3:case cv.CV_32SC4:{mat.data32S.set(array);break};case cv.CV_32F:case cv.CV_32FC1:case cv.CV_32FC2:case cv.CV_32FC3:case cv.CV_32FC4:{mat.data32F.set(array);break};case cv.CV_64F:case cv.CV_64FC1:case cv.CV_64FC2:case cv.CV_64FC3:case cv.CV_64FC4:{mat.data64F.set(array);break};default:{throw new Error("Type is unsupported")}}return mat});Module["matFromImageData"]=(function(imageData){var mat=new cv.Mat(imageData.height,imageData.width,cv.CV_8UC4);mat.data.set(imageData.data);return mat})





  return cv;
};
if (typeof module === "object" && module.exports) {
  module['exports'] = cv;
};

  if (typeof Module === 'undefined')
    Module = {};
  return cv(Module);
}));
    